#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 19618
#define LARGE_STATE_COUNT 9476
#define SYMBOL_COUNT 243
#define ALIAS_COUNT 2
#define TOKEN_COUNT 120
#define EXTERNAL_TOKEN_COUNT 16
#define FIELD_COUNT 6
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 22

enum ts_symbol_identifiers {
  sym__word_identifier = 1,
  anon_sym_COMMA = 2,
  anon_sym_EQ = 3,
  anon_sym_begin = 4,
  anon_sym_module = 5,
  anon_sym_baremodule = 6,
  anon_sym_end = 7,
  anon_sym_abstract = 8,
  anon_sym_type = 9,
  anon_sym_primitive = 10,
  anon_sym_mutable = 11,
  anon_sym_struct = 12,
  anon_sym_function = 13,
  anon_sym_macro = 14,
  anon_sym_quote = 15,
  anon_sym_let = 16,
  anon_sym_if = 17,
  anon_sym_elseif = 18,
  anon_sym_else = 19,
  anon_sym_try = 20,
  anon_sym_catch = 21,
  anon_sym_finally = 22,
  anon_sym_for = 23,
  anon_sym_while = 24,
  sym_break_statement = 25,
  sym_continue_statement = 26,
  anon_sym_return = 27,
  anon_sym_const = 28,
  anon_sym_global = 29,
  anon_sym_local = 30,
  anon_sym_as = 31,
  aux_sym_import_path_token1 = 32,
  anon_sym_LPAREN = 33,
  anon_sym_RPAREN = 34,
  anon_sym_COLON = 35,
  anon_sym_export = 36,
  anon_sym_public = 37,
  anon_sym_import = 38,
  anon_sym_using = 39,
  anon_sym_LBRACK = 40,
  anon_sym_RBRACK = 41,
  anon_sym_outer = 42,
  anon_sym_in = 43,
  anon_sym_u2208 = 44,
  anon_sym_SEMI = 45,
  anon_sym_LBRACE = 46,
  anon_sym_RBRACE = 47,
  anon_sym_SQUOTE = 48,
  anon_sym_DOT = 49,
  anon_sym_do = 50,
  anon_sym_DOLLAR = 51,
  anon_sym_COLON2 = 52,
  anon_sym_COLON_COLON = 53,
  anon_sym_COLON_EQ = 54,
  anon_sym_DOT_EQ = 55,
  aux_sym_quote_expression_token1 = 56,
  anon_sym_isa = 57,
  anon_sym_DOT_DOT_DOT = 58,
  anon_sym_QMARK = 59,
  anon_sym_DASH_GT = 60,
  anon_sym_where = 61,
  anon_sym_AT = 62,
  anon_sym_true = 63,
  anon_sym_false = 64,
  aux_sym_integer_literal_token1 = 65,
  aux_sym_integer_literal_token2 = 66,
  aux_sym_integer_literal_token3 = 67,
  aux_sym_integer_literal_token4 = 68,
  aux_sym_float_literal_token1 = 69,
  aux_sym_float_literal_token2 = 70,
  aux_sym_float_literal_token3 = 71,
  aux_sym_float_literal_token4 = 72,
  sym_escape_sequence = 73,
  sym_character_literal = 74,
  anon_sym_DQUOTE = 75,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 76,
  anon_sym_BQUOTE = 77,
  anon_sym_BQUOTE_BQUOTE_BQUOTE = 78,
  anon_sym_DOLLAR_EQ = 79,
  aux_sym__assignment_operator_token1 = 80,
  sym__pair_operator = 81,
  sym__arrow_operator = 82,
  sym__lazy_or_operator = 83,
  sym__lazy_and_operator = 84,
  sym__comparison_operator = 85,
  sym__pipe_right_operator = 86,
  sym__pipe_left_operator = 87,
  sym__ellipsis_operator = 88,
  sym__plus_operator = 89,
  sym__times_operator = 90,
  sym__rational_operator = 91,
  sym__bitshift_operator = 92,
  sym__power_operator = 93,
  sym__tilde_operator = 94,
  sym__type_order_operator = 95,
  sym__unary_operator = 96,
  sym__unary_plus_operator = 97,
  anon_sym_DOT2 = 98,
  aux_sym__terminator_token1 = 99,
  aux_sym__terminator_token2 = 100,
  aux_sym_block_comment_token1 = 101,
  aux_sym_line_comment_token1 = 102,
  aux_sym_line_comment_token2 = 103,
  sym__block_comment_rest = 104,
  sym__immediate_paren = 105,
  sym__immediate_bracket = 106,
  sym__immediate_brace = 107,
  sym__immediate_string_start = 108,
  sym__immediate_command_start = 109,
  sym__content_cmd_1 = 110,
  sym__content_cmd_1_raw = 111,
  sym__content_cmd_3 = 112,
  sym__content_cmd_3_raw = 113,
  sym__content_str_1 = 114,
  sym__content_str_1_raw = 115,
  sym__content_str_3 = 116,
  sym__content_str_3_raw = 117,
  sym__end_cmd = 118,
  sym__end_str = 119,
  sym_source_file = 120,
  sym__block = 121,
  sym_open_tuple = 122,
  sym_assignment = 123,
  sym__closed_assignment = 124,
  sym__expression = 125,
  sym_module_definition = 126,
  sym_type_head = 127,
  sym_abstract_definition = 128,
  sym_primitive_definition = 129,
  sym_struct_definition = 130,
  sym_signature = 131,
  sym_function_definition = 132,
  sym_macro_definition = 133,
  sym_compound_statement = 134,
  sym_quote_statement = 135,
  sym_let_statement = 136,
  sym_if_statement = 137,
  sym_elseif_clause = 138,
  sym_else_clause = 139,
  sym_try_statement = 140,
  sym_catch_clause = 141,
  sym_finally_clause = 142,
  sym_for_statement = 143,
  sym_while_statement = 144,
  sym_return_statement = 145,
  sym_const_statement = 146,
  sym_global_statement = 147,
  sym_local_statement = 148,
  sym_import_alias = 149,
  sym_import_path = 150,
  sym__exportable = 151,
  sym__importable = 152,
  sym__import_list = 153,
  sym_selected_import = 154,
  sym_export_statement = 155,
  sym_public_statement = 156,
  sym_import_statement = 157,
  sym_using_statement = 158,
  sym__primary_expression = 159,
  sym__array = 160,
  sym_comprehension_expression = 161,
  sym__comprehension_clause = 162,
  sym_if_clause = 163,
  sym_for_clause = 164,
  sym_for_binding = 165,
  sym_matrix_expression = 166,
  sym_matrix_row = 167,
  sym_vector_expression = 168,
  sym_parenthesized_expression = 169,
  sym_tuple_expression = 170,
  sym_curly_expression = 171,
  sym_adjoint_expression = 172,
  sym_field_expression = 173,
  sym_index_expression = 174,
  sym_parametrized_type_expression = 175,
  sym_call_expression = 176,
  sym_broadcast_call_expression = 177,
  sym__closed_macrocall_expression = 178,
  sym_macrocall_expression = 179,
  sym_macro_argument_list = 180,
  sym_argument_list = 181,
  sym_do_clause = 182,
  sym__do_parameter_list = 183,
  sym_named_field = 184,
  sym_interpolation_expression = 185,
  sym_quote_expression = 186,
  sym_binary_expression = 187,
  sym_unary_expression = 188,
  sym_range_expression = 189,
  sym_splat_expression = 190,
  sym_ternary_expression = 191,
  sym_typed_expression = 192,
  sym_unary_typed_expression = 193,
  sym_arrow_function_expression = 194,
  sym_juxtaposition_expression = 195,
  sym_compound_assignment_expression = 196,
  sym_where_expression = 197,
  sym_macro_identifier = 198,
  sym_scoped_identifier = 199,
  sym_identifier = 200,
  sym_boolean_literal = 201,
  sym_integer_literal = 202,
  sym_float_literal = 203,
  sym__string = 204,
  sym__delimiter_str_1 = 205,
  sym__delimiter_str_3 = 206,
  sym__delimiter_cmd_1 = 207,
  sym__delimiter_cmd_3 = 208,
  sym_string_literal = 209,
  sym_command_literal = 210,
  sym_prefixed_string_literal = 211,
  sym_prefixed_command_literal = 212,
  sym_string_interpolation = 213,
  sym_operator = 214,
  sym__assignment_operator = 215,
  sym__syntactic_operator = 216,
  sym_block_comment = 217,
  sym_line_comment = 218,
  aux_sym__block_repeat1 = 219,
  aux_sym_open_tuple_repeat1 = 220,
  aux_sym_let_statement_repeat1 = 221,
  aux_sym_if_statement_repeat1 = 222,
  aux_sym_for_statement_repeat1 = 223,
  aux_sym__import_list_repeat1 = 224,
  aux_sym_export_statement_repeat1 = 225,
  aux_sym__comprehension_clause_repeat1 = 226,
  aux_sym_matrix_expression_repeat1 = 227,
  aux_sym_matrix_row_repeat1 = 228,
  aux_sym_vector_expression_repeat1 = 229,
  aux_sym_parenthesized_expression_repeat1 = 230,
  aux_sym_tuple_expression_repeat1 = 231,
  aux_sym_macro_argument_list_repeat1 = 232,
  aux_sym_argument_list_repeat1 = 233,
  aux_sym__do_parameter_list_repeat1 = 234,
  aux_sym_string_literal_repeat1 = 235,
  aux_sym_string_literal_repeat2 = 236,
  aux_sym_command_literal_repeat1 = 237,
  aux_sym_command_literal_repeat2 = 238,
  aux_sym_prefixed_string_literal_repeat1 = 239,
  aux_sym_prefixed_string_literal_repeat2 = 240,
  aux_sym_prefixed_command_literal_repeat1 = 241,
  aux_sym_prefixed_command_literal_repeat2 = 242,
  alias_sym_let_binding = 243,
  alias_sym_named_argument = 244,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__word_identifier] = "_word_identifier",
  [anon_sym_COMMA] = ",",
  [anon_sym_EQ] = "=",
  [anon_sym_begin] = "begin",
  [anon_sym_module] = "module",
  [anon_sym_baremodule] = "baremodule",
  [anon_sym_end] = "end",
  [anon_sym_abstract] = "abstract",
  [anon_sym_type] = "type",
  [anon_sym_primitive] = "primitive",
  [anon_sym_mutable] = "mutable",
  [anon_sym_struct] = "struct",
  [anon_sym_function] = "function",
  [anon_sym_macro] = "macro",
  [anon_sym_quote] = "quote",
  [anon_sym_let] = "let",
  [anon_sym_if] = "if",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_for] = "for",
  [anon_sym_while] = "while",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_return] = "return",
  [anon_sym_const] = "const",
  [anon_sym_global] = "global",
  [anon_sym_local] = "local",
  [anon_sym_as] = "as",
  [aux_sym_import_path_token1] = "import_path_token1",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COLON] = ":",
  [anon_sym_export] = "export",
  [anon_sym_public] = "public",
  [anon_sym_import] = "import",
  [anon_sym_using] = "using",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_outer] = "outer",
  [anon_sym_in] = "operator",
  [anon_sym_u2208] = "operator",
  [anon_sym_SEMI] = ";",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DOT] = ".",
  [anon_sym_do] = "do",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_COLON2] = ":",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_DOT_EQ] = ".=",
  [aux_sym_quote_expression_token1] = "identifier",
  [anon_sym_isa] = "operator",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_where] = "where",
  [anon_sym_AT] = "@",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [aux_sym_integer_literal_token1] = "integer_literal_token1",
  [aux_sym_integer_literal_token2] = "integer_literal_token2",
  [aux_sym_integer_literal_token3] = "integer_literal_token3",
  [aux_sym_integer_literal_token4] = "integer_literal_token4",
  [aux_sym_float_literal_token1] = "float_literal_token1",
  [aux_sym_float_literal_token2] = "float_literal_token2",
  [aux_sym_float_literal_token3] = "float_literal_token3",
  [aux_sym_float_literal_token4] = "float_literal_token4",
  [sym_escape_sequence] = "escape_sequence",
  [sym_character_literal] = "character_literal",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = "```",
  [anon_sym_DOLLAR_EQ] = "$=",
  [aux_sym__assignment_operator_token1] = "_assignment_operator_token1",
  [sym__pair_operator] = "_pair_operator",
  [sym__arrow_operator] = "_arrow_operator",
  [sym__lazy_or_operator] = "operator",
  [sym__lazy_and_operator] = "operator",
  [sym__comparison_operator] = "_comparison_operator",
  [sym__pipe_right_operator] = "_pipe_right_operator",
  [sym__pipe_left_operator] = "_pipe_left_operator",
  [sym__ellipsis_operator] = "_ellipsis_operator",
  [sym__plus_operator] = "_plus_operator",
  [sym__times_operator] = "_times_operator",
  [sym__rational_operator] = "_rational_operator",
  [sym__bitshift_operator] = "_bitshift_operator",
  [sym__power_operator] = "_power_operator",
  [sym__tilde_operator] = "_tilde_operator",
  [sym__type_order_operator] = "_type_order_operator",
  [sym__unary_operator] = "_unary_operator",
  [sym__unary_plus_operator] = "_unary_plus_operator",
  [anon_sym_DOT2] = ".",
  [aux_sym__terminator_token1] = "_terminator_token1",
  [aux_sym__terminator_token2] = "_terminator_token2",
  [aux_sym_block_comment_token1] = "block_comment_token1",
  [aux_sym_line_comment_token1] = "line_comment_token1",
  [aux_sym_line_comment_token2] = "line_comment_token2",
  [sym__block_comment_rest] = "_block_comment_rest",
  [sym__immediate_paren] = "_immediate_paren",
  [sym__immediate_bracket] = "_immediate_bracket",
  [sym__immediate_brace] = "_immediate_brace",
  [sym__immediate_string_start] = "_immediate_string_start",
  [sym__immediate_command_start] = "_immediate_command_start",
  [sym__content_cmd_1] = "content",
  [sym__content_cmd_1_raw] = "content",
  [sym__content_cmd_3] = "content",
  [sym__content_cmd_3_raw] = "content",
  [sym__content_str_1] = "content",
  [sym__content_str_1_raw] = "content",
  [sym__content_str_3] = "content",
  [sym__content_str_3_raw] = "content",
  [sym__end_cmd] = "_end_cmd",
  [sym__end_str] = "_end_str",
  [sym_source_file] = "source_file",
  [sym__block] = "_block",
  [sym_open_tuple] = "open_tuple",
  [sym_assignment] = "assignment",
  [sym__closed_assignment] = "assignment",
  [sym__expression] = "_expression",
  [sym_module_definition] = "module_definition",
  [sym_type_head] = "type_head",
  [sym_abstract_definition] = "abstract_definition",
  [sym_primitive_definition] = "primitive_definition",
  [sym_struct_definition] = "struct_definition",
  [sym_signature] = "signature",
  [sym_function_definition] = "function_definition",
  [sym_macro_definition] = "macro_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_quote_statement] = "quote_statement",
  [sym_let_statement] = "let_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_return_statement] = "return_statement",
  [sym_const_statement] = "const_statement",
  [sym_global_statement] = "global_statement",
  [sym_local_statement] = "local_statement",
  [sym_import_alias] = "import_alias",
  [sym_import_path] = "import_path",
  [sym__exportable] = "_exportable",
  [sym__importable] = "_importable",
  [sym__import_list] = "_import_list",
  [sym_selected_import] = "selected_import",
  [sym_export_statement] = "export_statement",
  [sym_public_statement] = "public_statement",
  [sym_import_statement] = "import_statement",
  [sym_using_statement] = "using_statement",
  [sym__primary_expression] = "_primary_expression",
  [sym__array] = "_array",
  [sym_comprehension_expression] = "comprehension_expression",
  [sym__comprehension_clause] = "_comprehension_clause",
  [sym_if_clause] = "if_clause",
  [sym_for_clause] = "for_clause",
  [sym_for_binding] = "for_binding",
  [sym_matrix_expression] = "matrix_expression",
  [sym_matrix_row] = "matrix_row",
  [sym_vector_expression] = "vector_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_curly_expression] = "curly_expression",
  [sym_adjoint_expression] = "adjoint_expression",
  [sym_field_expression] = "field_expression",
  [sym_index_expression] = "index_expression",
  [sym_parametrized_type_expression] = "parametrized_type_expression",
  [sym_call_expression] = "call_expression",
  [sym_broadcast_call_expression] = "broadcast_call_expression",
  [sym__closed_macrocall_expression] = "macrocall_expression",
  [sym_macrocall_expression] = "macrocall_expression",
  [sym_macro_argument_list] = "macro_argument_list",
  [sym_argument_list] = "argument_list",
  [sym_do_clause] = "do_clause",
  [sym__do_parameter_list] = "argument_list",
  [sym_named_field] = "named_field",
  [sym_interpolation_expression] = "interpolation_expression",
  [sym_quote_expression] = "quote_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_range_expression] = "range_expression",
  [sym_splat_expression] = "splat_expression",
  [sym_ternary_expression] = "ternary_expression",
  [sym_typed_expression] = "typed_expression",
  [sym_unary_typed_expression] = "unary_typed_expression",
  [sym_arrow_function_expression] = "arrow_function_expression",
  [sym_juxtaposition_expression] = "juxtaposition_expression",
  [sym_compound_assignment_expression] = "compound_assignment_expression",
  [sym_where_expression] = "where_expression",
  [sym_macro_identifier] = "macro_identifier",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_identifier] = "identifier",
  [sym_boolean_literal] = "boolean_literal",
  [sym_integer_literal] = "integer_literal",
  [sym_float_literal] = "float_literal",
  [sym__string] = "_string",
  [sym__delimiter_str_1] = "_delimiter_str_1",
  [sym__delimiter_str_3] = "_delimiter_str_3",
  [sym__delimiter_cmd_1] = "_delimiter_cmd_1",
  [sym__delimiter_cmd_3] = "_delimiter_cmd_3",
  [sym_string_literal] = "string_literal",
  [sym_command_literal] = "command_literal",
  [sym_prefixed_string_literal] = "prefixed_string_literal",
  [sym_prefixed_command_literal] = "prefixed_command_literal",
  [sym_string_interpolation] = "string_interpolation",
  [sym_operator] = "operator",
  [sym__assignment_operator] = "operator",
  [sym__syntactic_operator] = "operator",
  [sym_block_comment] = "block_comment",
  [sym_line_comment] = "line_comment",
  [aux_sym__block_repeat1] = "_block_repeat1",
  [aux_sym_open_tuple_repeat1] = "open_tuple_repeat1",
  [aux_sym_let_statement_repeat1] = "let_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym__comprehension_clause_repeat1] = "_comprehension_clause_repeat1",
  [aux_sym_matrix_expression_repeat1] = "matrix_expression_repeat1",
  [aux_sym_matrix_row_repeat1] = "matrix_row_repeat1",
  [aux_sym_vector_expression_repeat1] = "vector_expression_repeat1",
  [aux_sym_parenthesized_expression_repeat1] = "parenthesized_expression_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_macro_argument_list_repeat1] = "macro_argument_list_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym__do_parameter_list_repeat1] = "_do_parameter_list_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_string_literal_repeat2] = "string_literal_repeat2",
  [aux_sym_command_literal_repeat1] = "command_literal_repeat1",
  [aux_sym_command_literal_repeat2] = "command_literal_repeat2",
  [aux_sym_prefixed_string_literal_repeat1] = "prefixed_string_literal_repeat1",
  [aux_sym_prefixed_string_literal_repeat2] = "prefixed_string_literal_repeat2",
  [aux_sym_prefixed_command_literal_repeat1] = "prefixed_command_literal_repeat1",
  [aux_sym_prefixed_command_literal_repeat2] = "prefixed_command_literal_repeat2",
  [alias_sym_let_binding] = "let_binding",
  [alias_sym_named_argument] = "named_argument",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__word_identifier] = sym__word_identifier,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_begin] = anon_sym_begin,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_baremodule] = anon_sym_baremodule,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_primitive] = anon_sym_primitive,
  [anon_sym_mutable] = anon_sym_mutable,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_macro] = anon_sym_macro,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_while] = anon_sym_while,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_as] = anon_sym_as,
  [aux_sym_import_path_token1] = aux_sym_import_path_token1,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_outer] = anon_sym_outer,
  [anon_sym_in] = sym_operator,
  [anon_sym_u2208] = sym_operator,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_COLON2] = anon_sym_COLON,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_DOT_EQ] = anon_sym_DOT_EQ,
  [aux_sym_quote_expression_token1] = sym_identifier,
  [anon_sym_isa] = sym_operator,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [aux_sym_integer_literal_token1] = aux_sym_integer_literal_token1,
  [aux_sym_integer_literal_token2] = aux_sym_integer_literal_token2,
  [aux_sym_integer_literal_token3] = aux_sym_integer_literal_token3,
  [aux_sym_integer_literal_token4] = aux_sym_integer_literal_token4,
  [aux_sym_float_literal_token1] = aux_sym_float_literal_token1,
  [aux_sym_float_literal_token2] = aux_sym_float_literal_token2,
  [aux_sym_float_literal_token3] = aux_sym_float_literal_token3,
  [aux_sym_float_literal_token4] = aux_sym_float_literal_token4,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_character_literal] = sym_character_literal,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = anon_sym_BQUOTE_BQUOTE_BQUOTE,
  [anon_sym_DOLLAR_EQ] = anon_sym_DOLLAR_EQ,
  [aux_sym__assignment_operator_token1] = aux_sym__assignment_operator_token1,
  [sym__pair_operator] = sym__pair_operator,
  [sym__arrow_operator] = sym__arrow_operator,
  [sym__lazy_or_operator] = sym_operator,
  [sym__lazy_and_operator] = sym_operator,
  [sym__comparison_operator] = sym__comparison_operator,
  [sym__pipe_right_operator] = sym__pipe_right_operator,
  [sym__pipe_left_operator] = sym__pipe_left_operator,
  [sym__ellipsis_operator] = sym__ellipsis_operator,
  [sym__plus_operator] = sym__plus_operator,
  [sym__times_operator] = sym__times_operator,
  [sym__rational_operator] = sym__rational_operator,
  [sym__bitshift_operator] = sym__bitshift_operator,
  [sym__power_operator] = sym__power_operator,
  [sym__tilde_operator] = sym__tilde_operator,
  [sym__type_order_operator] = sym__type_order_operator,
  [sym__unary_operator] = sym__unary_operator,
  [sym__unary_plus_operator] = sym__unary_plus_operator,
  [anon_sym_DOT2] = anon_sym_DOT,
  [aux_sym__terminator_token1] = aux_sym__terminator_token1,
  [aux_sym__terminator_token2] = aux_sym__terminator_token2,
  [aux_sym_block_comment_token1] = aux_sym_block_comment_token1,
  [aux_sym_line_comment_token1] = aux_sym_line_comment_token1,
  [aux_sym_line_comment_token2] = aux_sym_line_comment_token2,
  [sym__block_comment_rest] = sym__block_comment_rest,
  [sym__immediate_paren] = sym__immediate_paren,
  [sym__immediate_bracket] = sym__immediate_bracket,
  [sym__immediate_brace] = sym__immediate_brace,
  [sym__immediate_string_start] = sym__immediate_string_start,
  [sym__immediate_command_start] = sym__immediate_command_start,
  [sym__content_cmd_1] = sym__content_cmd_1,
  [sym__content_cmd_1_raw] = sym__content_cmd_1,
  [sym__content_cmd_3] = sym__content_cmd_1,
  [sym__content_cmd_3_raw] = sym__content_cmd_1,
  [sym__content_str_1] = sym__content_cmd_1,
  [sym__content_str_1_raw] = sym__content_cmd_1,
  [sym__content_str_3] = sym__content_cmd_1,
  [sym__content_str_3_raw] = sym__content_cmd_1,
  [sym__end_cmd] = sym__end_cmd,
  [sym__end_str] = sym__end_str,
  [sym_source_file] = sym_source_file,
  [sym__block] = sym__block,
  [sym_open_tuple] = sym_open_tuple,
  [sym_assignment] = sym_assignment,
  [sym__closed_assignment] = sym_assignment,
  [sym__expression] = sym__expression,
  [sym_module_definition] = sym_module_definition,
  [sym_type_head] = sym_type_head,
  [sym_abstract_definition] = sym_abstract_definition,
  [sym_primitive_definition] = sym_primitive_definition,
  [sym_struct_definition] = sym_struct_definition,
  [sym_signature] = sym_signature,
  [sym_function_definition] = sym_function_definition,
  [sym_macro_definition] = sym_macro_definition,
  [sym_compound_statement] = sym_compound_statement,
  [sym_quote_statement] = sym_quote_statement,
  [sym_let_statement] = sym_let_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_const_statement] = sym_const_statement,
  [sym_global_statement] = sym_global_statement,
  [sym_local_statement] = sym_local_statement,
  [sym_import_alias] = sym_import_alias,
  [sym_import_path] = sym_import_path,
  [sym__exportable] = sym__exportable,
  [sym__importable] = sym__importable,
  [sym__import_list] = sym__import_list,
  [sym_selected_import] = sym_selected_import,
  [sym_export_statement] = sym_export_statement,
  [sym_public_statement] = sym_public_statement,
  [sym_import_statement] = sym_import_statement,
  [sym_using_statement] = sym_using_statement,
  [sym__primary_expression] = sym__primary_expression,
  [sym__array] = sym__array,
  [sym_comprehension_expression] = sym_comprehension_expression,
  [sym__comprehension_clause] = sym__comprehension_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_for_clause] = sym_for_clause,
  [sym_for_binding] = sym_for_binding,
  [sym_matrix_expression] = sym_matrix_expression,
  [sym_matrix_row] = sym_matrix_row,
  [sym_vector_expression] = sym_vector_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_curly_expression] = sym_curly_expression,
  [sym_adjoint_expression] = sym_adjoint_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_parametrized_type_expression] = sym_parametrized_type_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_broadcast_call_expression] = sym_broadcast_call_expression,
  [sym__closed_macrocall_expression] = sym_macrocall_expression,
  [sym_macrocall_expression] = sym_macrocall_expression,
  [sym_macro_argument_list] = sym_macro_argument_list,
  [sym_argument_list] = sym_argument_list,
  [sym_do_clause] = sym_do_clause,
  [sym__do_parameter_list] = sym_argument_list,
  [sym_named_field] = sym_named_field,
  [sym_interpolation_expression] = sym_interpolation_expression,
  [sym_quote_expression] = sym_quote_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_range_expression] = sym_range_expression,
  [sym_splat_expression] = sym_splat_expression,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_typed_expression] = sym_typed_expression,
  [sym_unary_typed_expression] = sym_unary_typed_expression,
  [sym_arrow_function_expression] = sym_arrow_function_expression,
  [sym_juxtaposition_expression] = sym_juxtaposition_expression,
  [sym_compound_assignment_expression] = sym_compound_assignment_expression,
  [sym_where_expression] = sym_where_expression,
  [sym_macro_identifier] = sym_macro_identifier,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_identifier] = sym_identifier,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_integer_literal] = sym_integer_literal,
  [sym_float_literal] = sym_float_literal,
  [sym__string] = sym__string,
  [sym__delimiter_str_1] = sym__delimiter_str_1,
  [sym__delimiter_str_3] = sym__delimiter_str_3,
  [sym__delimiter_cmd_1] = sym__delimiter_cmd_1,
  [sym__delimiter_cmd_3] = sym__delimiter_cmd_3,
  [sym_string_literal] = sym_string_literal,
  [sym_command_literal] = sym_command_literal,
  [sym_prefixed_string_literal] = sym_prefixed_string_literal,
  [sym_prefixed_command_literal] = sym_prefixed_command_literal,
  [sym_string_interpolation] = sym_string_interpolation,
  [sym_operator] = sym_operator,
  [sym__assignment_operator] = sym_operator,
  [sym__syntactic_operator] = sym_operator,
  [sym_block_comment] = sym_block_comment,
  [sym_line_comment] = sym_line_comment,
  [aux_sym__block_repeat1] = aux_sym__block_repeat1,
  [aux_sym_open_tuple_repeat1] = aux_sym_open_tuple_repeat1,
  [aux_sym_let_statement_repeat1] = aux_sym_let_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym__comprehension_clause_repeat1] = aux_sym__comprehension_clause_repeat1,
  [aux_sym_matrix_expression_repeat1] = aux_sym_matrix_expression_repeat1,
  [aux_sym_matrix_row_repeat1] = aux_sym_matrix_row_repeat1,
  [aux_sym_vector_expression_repeat1] = aux_sym_vector_expression_repeat1,
  [aux_sym_parenthesized_expression_repeat1] = aux_sym_parenthesized_expression_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_macro_argument_list_repeat1] = aux_sym_macro_argument_list_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym__do_parameter_list_repeat1] = aux_sym__do_parameter_list_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_string_literal_repeat2] = aux_sym_string_literal_repeat2,
  [aux_sym_command_literal_repeat1] = aux_sym_command_literal_repeat1,
  [aux_sym_command_literal_repeat2] = aux_sym_command_literal_repeat2,
  [aux_sym_prefixed_string_literal_repeat1] = aux_sym_prefixed_string_literal_repeat1,
  [aux_sym_prefixed_string_literal_repeat2] = aux_sym_prefixed_string_literal_repeat2,
  [aux_sym_prefixed_command_literal_repeat1] = aux_sym_prefixed_command_literal_repeat1,
  [aux_sym_prefixed_command_literal_repeat2] = aux_sym_prefixed_command_literal_repeat2,
  [alias_sym_let_binding] = alias_sym_let_binding,
  [alias_sym_named_argument] = alias_sym_named_argument,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__word_identifier] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_baremodule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_primitive] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mutable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_import_path_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_outer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_u2208] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quote_expression_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_isa] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_integer_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_integer_literal_token4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_float_literal_token4] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE_BQUOTE_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__assignment_operator_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__pair_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__lazy_or_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__lazy_and_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__comparison_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_right_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_left_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__ellipsis_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__plus_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__times_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__rational_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__bitshift_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__power_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__tilde_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__type_order_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_plus_operator] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DOT2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__terminator_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__terminator_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_line_comment_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__block_comment_rest] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_paren] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_bracket] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_brace] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_string_start] = {
    .visible = false,
    .named = true,
  },
  [sym__immediate_command_start] = {
    .visible = false,
    .named = true,
  },
  [sym__content_cmd_1] = {
    .visible = true,
    .named = true,
  },
  [sym__content_cmd_1_raw] = {
    .visible = true,
    .named = true,
  },
  [sym__content_cmd_3] = {
    .visible = true,
    .named = true,
  },
  [sym__content_cmd_3_raw] = {
    .visible = true,
    .named = true,
  },
  [sym__content_str_1] = {
    .visible = true,
    .named = true,
  },
  [sym__content_str_1_raw] = {
    .visible = true,
    .named = true,
  },
  [sym__content_str_3] = {
    .visible = true,
    .named = true,
  },
  [sym__content_str_3_raw] = {
    .visible = true,
    .named = true,
  },
  [sym__end_cmd] = {
    .visible = false,
    .named = true,
  },
  [sym__end_str] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = false,
    .named = true,
  },
  [sym_open_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__closed_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_module_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_type_head] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_quote_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_let_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_const_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_import_path] = {
    .visible = true,
    .named = true,
  },
  [sym__exportable] = {
    .visible = false,
    .named = true,
  },
  [sym__importable] = {
    .visible = false,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_selected_import] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_public_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__array] = {
    .visible = false,
    .named = true,
  },
  [sym_comprehension_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_matrix_row] = {
    .visible = true,
    .named = true,
  },
  [sym_vector_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_curly_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_adjoint_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parametrized_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_broadcast_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__closed_macrocall_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macrocall_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_do_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__do_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_named_field] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_quote_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_typed_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_juxtaposition_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_where_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string] = {
    .visible = false,
    .named = true,
  },
  [sym__delimiter_str_1] = {
    .visible = false,
    .named = true,
  },
  [sym__delimiter_str_3] = {
    .visible = false,
    .named = true,
  },
  [sym__delimiter_cmd_1] = {
    .visible = false,
    .named = true,
  },
  [sym__delimiter_cmd_3] = {
    .visible = false,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_command_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_prefixed_command_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__syntactic_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_open_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_let_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_matrix_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_matrix_row_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_vector_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__do_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefixed_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefixed_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefixed_command_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_prefixed_command_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_let_binding] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_named_argument] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_condition = 2,
  field_name = 3,
  field_prefix = 4,
  field_suffix = 5,
  field_value = 6,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_condition] = "condition",
  [field_name] = "name",
  [field_prefix] = "prefix",
  [field_suffix] = "suffix",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [3] = {.index = 0, .length = 1},
  [4] = {.index = 1, .length = 1},
  [7] = {.index = 2, .length = 1},
  [9] = {.index = 3, .length = 2},
  [11] = {.index = 5, .length = 1},
  [12] = {.index = 6, .length = 2},
  [13] = {.index = 8, .length = 3},
  [16] = {.index = 11, .length = 2},
  [17] = {.index = 13, .length = 2},
  [18] = {.index = 15, .length = 3},
  [19] = {.index = 18, .length = 2},
  [21] = {.index = 20, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_condition, 1},
  [2] =
    {field_value, 0},
  [3] =
    {field_alternative, 2},
    {field_condition, 1},
  [5] =
    {field_prefix, 0},
  [6] =
    {field_alternative, 3},
    {field_condition, 1},
  [8] =
    {field_alternative, 2},
    {field_alternative, 3},
    {field_condition, 1},
  [11] =
    {field_prefix, 0},
    {field_suffix, 4},
  [13] =
    {field_alternative, 4},
    {field_condition, 1},
  [15] =
    {field_alternative, 3},
    {field_alternative, 4},
    {field_condition, 1},
  [18] =
    {field_prefix, 0},
    {field_suffix, 5},
  [20] =
    {field_alternative, 4},
    {field_alternative, 5},
    {field_condition, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = sym_operator,
  },
  [5] = {
    [1] = alias_sym_named_argument,
  },
  [6] = {
    [1] = sym_operator,
  },
  [8] = {
    [1] = alias_sym_let_binding,
  },
  [10] = {
    [2] = alias_sym_named_argument,
  },
  [14] = {
    [2] = sym_operator,
  },
  [15] = {
    [3] = sym_operator,
  },
  [20] = {
    [3] = sym_assignment,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__closed_assignment, 3,
    sym_assignment,
    alias_sym_let_binding,
    alias_sym_named_argument,
  sym_named_field, 2,
    sym_named_field,
    sym_assignment,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 5,
  [6] = 4,
  [7] = 5,
  [8] = 4,
  [9] = 5,
  [10] = 4,
  [11] = 5,
  [12] = 4,
  [13] = 4,
  [14] = 4,
  [15] = 5,
  [16] = 5,
  [17] = 5,
  [18] = 5,
  [19] = 4,
  [20] = 4,
  [21] = 4,
  [22] = 5,
  [23] = 4,
  [24] = 5,
  [25] = 5,
  [26] = 4,
  [27] = 4,
  [28] = 5,
  [29] = 5,
  [30] = 5,
  [31] = 4,
  [32] = 5,
  [33] = 4,
  [34] = 4,
  [35] = 5,
  [36] = 4,
  [37] = 5,
  [38] = 4,
  [39] = 5,
  [40] = 4,
  [41] = 5,
  [42] = 5,
  [43] = 4,
  [44] = 5,
  [45] = 4,
  [46] = 5,
  [47] = 4,
  [48] = 5,
  [49] = 4,
  [50] = 5,
  [51] = 4,
  [52] = 4,
  [53] = 5,
  [54] = 5,
  [55] = 4,
  [56] = 5,
  [57] = 4,
  [58] = 58,
  [59] = 4,
  [60] = 60,
  [61] = 5,
  [62] = 5,
  [63] = 4,
  [64] = 4,
  [65] = 5,
  [66] = 60,
  [67] = 60,
  [68] = 4,
  [69] = 5,
  [70] = 4,
  [71] = 5,
  [72] = 58,
  [73] = 60,
  [74] = 5,
  [75] = 60,
  [76] = 60,
  [77] = 60,
  [78] = 4,
  [79] = 5,
  [80] = 60,
  [81] = 4,
  [82] = 5,
  [83] = 60,
  [84] = 60,
  [85] = 4,
  [86] = 60,
  [87] = 60,
  [88] = 4,
  [89] = 5,
  [90] = 4,
  [91] = 5,
  [92] = 5,
  [93] = 58,
  [94] = 4,
  [95] = 5,
  [96] = 4,
  [97] = 5,
  [98] = 58,
  [99] = 58,
  [100] = 4,
  [101] = 5,
  [102] = 58,
  [103] = 4,
  [104] = 5,
  [105] = 105,
  [106] = 106,
  [107] = 58,
  [108] = 58,
  [109] = 58,
  [110] = 4,
  [111] = 5,
  [112] = 4,
  [113] = 5,
  [114] = 4,
  [115] = 4,
  [116] = 5,
  [117] = 105,
  [118] = 105,
  [119] = 105,
  [120] = 58,
  [121] = 58,
  [122] = 106,
  [123] = 105,
  [124] = 106,
  [125] = 125,
  [126] = 126,
  [127] = 105,
  [128] = 106,
  [129] = 125,
  [130] = 105,
  [131] = 106,
  [132] = 125,
  [133] = 106,
  [134] = 126,
  [135] = 4,
  [136] = 5,
  [137] = 126,
  [138] = 105,
  [139] = 105,
  [140] = 126,
  [141] = 105,
  [142] = 105,
  [143] = 105,
  [144] = 125,
  [145] = 106,
  [146] = 58,
  [147] = 125,
  [148] = 106,
  [149] = 125,
  [150] = 58,
  [151] = 4,
  [152] = 105,
  [153] = 5,
  [154] = 125,
  [155] = 58,
  [156] = 105,
  [157] = 58,
  [158] = 125,
  [159] = 4,
  [160] = 5,
  [161] = 125,
  [162] = 4,
  [163] = 5,
  [164] = 125,
  [165] = 105,
  [166] = 125,
  [167] = 125,
  [168] = 125,
  [169] = 4,
  [170] = 5,
  [171] = 58,
  [172] = 125,
  [173] = 125,
  [174] = 125,
  [175] = 125,
  [176] = 125,
  [177] = 125,
  [178] = 125,
  [179] = 125,
  [180] = 125,
  [181] = 125,
  [182] = 125,
  [183] = 125,
  [184] = 125,
  [185] = 125,
  [186] = 125,
  [187] = 125,
  [188] = 125,
  [189] = 125,
  [190] = 125,
  [191] = 125,
  [192] = 125,
  [193] = 125,
  [194] = 125,
  [195] = 125,
  [196] = 125,
  [197] = 125,
  [198] = 125,
  [199] = 125,
  [200] = 125,
  [201] = 125,
  [202] = 125,
  [203] = 125,
  [204] = 125,
  [205] = 125,
  [206] = 125,
  [207] = 125,
  [208] = 125,
  [209] = 125,
  [210] = 125,
  [211] = 125,
  [212] = 125,
  [213] = 125,
  [214] = 125,
  [215] = 125,
  [216] = 125,
  [217] = 125,
  [218] = 125,
  [219] = 105,
  [220] = 220,
  [221] = 221,
  [222] = 105,
  [223] = 223,
  [224] = 106,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 105,
  [229] = 126,
  [230] = 106,
  [231] = 4,
  [232] = 5,
  [233] = 105,
  [234] = 234,
  [235] = 106,
  [236] = 106,
  [237] = 126,
  [238] = 238,
  [239] = 239,
  [240] = 126,
  [241] = 238,
  [242] = 58,
  [243] = 238,
  [244] = 105,
  [245] = 245,
  [246] = 105,
  [247] = 105,
  [248] = 4,
  [249] = 5,
  [250] = 126,
  [251] = 238,
  [252] = 252,
  [253] = 105,
  [254] = 126,
  [255] = 105,
  [256] = 105,
  [257] = 106,
  [258] = 258,
  [259] = 126,
  [260] = 126,
  [261] = 105,
  [262] = 126,
  [263] = 126,
  [264] = 126,
  [265] = 126,
  [266] = 106,
  [267] = 267,
  [268] = 58,
  [269] = 269,
  [270] = 270,
  [271] = 105,
  [272] = 105,
  [273] = 126,
  [274] = 126,
  [275] = 238,
  [276] = 126,
  [277] = 238,
  [278] = 105,
  [279] = 106,
  [280] = 106,
  [281] = 126,
  [282] = 238,
  [283] = 105,
  [284] = 126,
  [285] = 105,
  [286] = 126,
  [287] = 238,
  [288] = 126,
  [289] = 238,
  [290] = 4,
  [291] = 126,
  [292] = 105,
  [293] = 238,
  [294] = 105,
  [295] = 105,
  [296] = 126,
  [297] = 126,
  [298] = 5,
  [299] = 238,
  [300] = 126,
  [301] = 106,
  [302] = 238,
  [303] = 126,
  [304] = 105,
  [305] = 238,
  [306] = 238,
  [307] = 105,
  [308] = 105,
  [309] = 238,
  [310] = 238,
  [311] = 105,
  [312] = 312,
  [313] = 106,
  [314] = 126,
  [315] = 221,
  [316] = 126,
  [317] = 126,
  [318] = 312,
  [319] = 105,
  [320] = 126,
  [321] = 252,
  [322] = 126,
  [323] = 312,
  [324] = 312,
  [325] = 238,
  [326] = 258,
  [327] = 106,
  [328] = 238,
  [329] = 312,
  [330] = 238,
  [331] = 238,
  [332] = 238,
  [333] = 126,
  [334] = 220,
  [335] = 238,
  [336] = 269,
  [337] = 126,
  [338] = 245,
  [339] = 126,
  [340] = 223,
  [341] = 226,
  [342] = 238,
  [343] = 270,
  [344] = 239,
  [345] = 238,
  [346] = 126,
  [347] = 105,
  [348] = 227,
  [349] = 105,
  [350] = 126,
  [351] = 238,
  [352] = 312,
  [353] = 312,
  [354] = 312,
  [355] = 238,
  [356] = 105,
  [357] = 225,
  [358] = 238,
  [359] = 312,
  [360] = 312,
  [361] = 267,
  [362] = 105,
  [363] = 105,
  [364] = 105,
  [365] = 312,
  [366] = 238,
  [367] = 238,
  [368] = 312,
  [369] = 126,
  [370] = 126,
  [371] = 238,
  [372] = 126,
  [373] = 126,
  [374] = 238,
  [375] = 105,
  [376] = 126,
  [377] = 126,
  [378] = 105,
  [379] = 105,
  [380] = 126,
  [381] = 238,
  [382] = 126,
  [383] = 105,
  [384] = 238,
  [385] = 238,
  [386] = 106,
  [387] = 105,
  [388] = 238,
  [389] = 238,
  [390] = 238,
  [391] = 238,
  [392] = 238,
  [393] = 238,
  [394] = 238,
  [395] = 238,
  [396] = 238,
  [397] = 126,
  [398] = 126,
  [399] = 105,
  [400] = 238,
  [401] = 238,
  [402] = 105,
  [403] = 238,
  [404] = 126,
  [405] = 126,
  [406] = 238,
  [407] = 238,
  [408] = 238,
  [409] = 126,
  [410] = 238,
  [411] = 238,
  [412] = 238,
  [413] = 238,
  [414] = 238,
  [415] = 238,
  [416] = 238,
  [417] = 238,
  [418] = 126,
  [419] = 238,
  [420] = 126,
  [421] = 238,
  [422] = 238,
  [423] = 238,
  [424] = 238,
  [425] = 238,
  [426] = 238,
  [427] = 238,
  [428] = 238,
  [429] = 238,
  [430] = 238,
  [431] = 238,
  [432] = 238,
  [433] = 433,
  [434] = 433,
  [435] = 433,
  [436] = 433,
  [437] = 433,
  [438] = 438,
  [439] = 438,
  [440] = 438,
  [441] = 438,
  [442] = 438,
  [443] = 438,
  [444] = 438,
  [445] = 438,
  [446] = 438,
  [447] = 438,
  [448] = 433,
  [449] = 433,
  [450] = 433,
  [451] = 433,
  [452] = 433,
  [453] = 433,
  [454] = 433,
  [455] = 438,
  [456] = 438,
  [457] = 457,
  [458] = 458,
  [459] = 458,
  [460] = 457,
  [461] = 457,
  [462] = 457,
  [463] = 458,
  [464] = 457,
  [465] = 458,
  [466] = 458,
  [467] = 458,
  [468] = 457,
  [469] = 457,
  [470] = 458,
  [471] = 457,
  [472] = 457,
  [473] = 458,
  [474] = 458,
  [475] = 458,
  [476] = 457,
  [477] = 477,
  [478] = 457,
  [479] = 458,
  [480] = 457,
  [481] = 458,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 483,
  [486] = 483,
  [487] = 483,
  [488] = 483,
  [489] = 483,
  [490] = 483,
  [491] = 483,
  [492] = 483,
  [493] = 483,
  [494] = 483,
  [495] = 483,
  [496] = 496,
  [497] = 496,
  [498] = 496,
  [499] = 499,
  [500] = 500,
  [501] = 499,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 496,
  [507] = 502,
  [508] = 504,
  [509] = 496,
  [510] = 503,
  [511] = 503,
  [512] = 503,
  [513] = 505,
  [514] = 502,
  [515] = 504,
  [516] = 496,
  [517] = 517,
  [518] = 499,
  [519] = 499,
  [520] = 499,
  [521] = 502,
  [522] = 522,
  [523] = 505,
  [524] = 502,
  [525] = 504,
  [526] = 496,
  [527] = 505,
  [528] = 505,
  [529] = 482,
  [530] = 502,
  [531] = 504,
  [532] = 499,
  [533] = 496,
  [534] = 503,
  [535] = 505,
  [536] = 504,
  [537] = 504,
  [538] = 499,
  [539] = 496,
  [540] = 504,
  [541] = 484,
  [542] = 499,
  [543] = 503,
  [544] = 505,
  [545] = 503,
  [546] = 499,
  [547] = 499,
  [548] = 502,
  [549] = 503,
  [550] = 504,
  [551] = 505,
  [552] = 505,
  [553] = 503,
  [554] = 502,
  [555] = 504,
  [556] = 496,
  [557] = 505,
  [558] = 502,
  [559] = 503,
  [560] = 477,
  [561] = 499,
  [562] = 505,
  [563] = 502,
  [564] = 503,
  [565] = 504,
  [566] = 496,
  [567] = 503,
  [568] = 499,
  [569] = 505,
  [570] = 502,
  [571] = 504,
  [572] = 496,
  [573] = 502,
  [574] = 574,
  [575] = 574,
  [576] = 574,
  [577] = 577,
  [578] = 574,
  [579] = 574,
  [580] = 574,
  [581] = 581,
  [582] = 574,
  [583] = 574,
  [584] = 574,
  [585] = 585,
  [586] = 574,
  [587] = 574,
  [588] = 574,
  [589] = 574,
  [590] = 574,
  [591] = 574,
  [592] = 577,
  [593] = 574,
  [594] = 577,
  [595] = 574,
  [596] = 596,
  [597] = 574,
  [598] = 574,
  [599] = 574,
  [600] = 574,
  [601] = 574,
  [602] = 574,
  [603] = 574,
  [604] = 574,
  [605] = 574,
  [606] = 574,
  [607] = 574,
  [608] = 577,
  [609] = 574,
  [610] = 610,
  [611] = 574,
  [612] = 574,
  [613] = 574,
  [614] = 614,
  [615] = 574,
  [616] = 574,
  [617] = 574,
  [618] = 574,
  [619] = 574,
  [620] = 577,
  [621] = 574,
  [622] = 574,
  [623] = 577,
  [624] = 577,
  [625] = 574,
  [626] = 574,
  [627] = 627,
  [628] = 577,
  [629] = 574,
  [630] = 577,
  [631] = 577,
  [632] = 574,
  [633] = 574,
  [634] = 574,
  [635] = 574,
  [636] = 574,
  [637] = 574,
  [638] = 574,
  [639] = 574,
  [640] = 577,
  [641] = 574,
  [642] = 574,
  [643] = 574,
  [644] = 574,
  [645] = 614,
  [646] = 574,
  [647] = 574,
  [648] = 574,
  [649] = 577,
  [650] = 574,
  [651] = 574,
  [652] = 577,
  [653] = 574,
  [654] = 581,
  [655] = 574,
  [656] = 574,
  [657] = 577,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 662,
  [663] = 663,
  [664] = 664,
  [665] = 665,
  [666] = 664,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 662,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 659,
  [680] = 660,
  [681] = 661,
  [682] = 682,
  [683] = 663,
  [684] = 664,
  [685] = 667,
  [686] = 668,
  [687] = 671,
  [688] = 672,
  [689] = 676,
  [690] = 682,
  [691] = 658,
  [692] = 692,
  [693] = 658,
  [694] = 692,
  [695] = 667,
  [696] = 665,
  [697] = 668,
  [698] = 675,
  [699] = 669,
  [700] = 669,
  [701] = 670,
  [702] = 671,
  [703] = 672,
  [704] = 676,
  [705] = 673,
  [706] = 662,
  [707] = 675,
  [708] = 677,
  [709] = 677,
  [710] = 678,
  [711] = 659,
  [712] = 660,
  [713] = 661,
  [714] = 500,
  [715] = 663,
  [716] = 596,
  [717] = 664,
  [718] = 667,
  [719] = 668,
  [720] = 671,
  [721] = 672,
  [722] = 676,
  [723] = 682,
  [724] = 658,
  [725] = 692,
  [726] = 610,
  [727] = 614,
  [728] = 665,
  [729] = 665,
  [730] = 665,
  [731] = 678,
  [732] = 581,
  [733] = 682,
  [734] = 669,
  [735] = 670,
  [736] = 669,
  [737] = 670,
  [738] = 669,
  [739] = 673,
  [740] = 662,
  [741] = 675,
  [742] = 670,
  [743] = 677,
  [744] = 678,
  [745] = 659,
  [746] = 660,
  [747] = 661,
  [748] = 663,
  [749] = 665,
  [750] = 664,
  [751] = 667,
  [752] = 668,
  [753] = 671,
  [754] = 672,
  [755] = 676,
  [756] = 682,
  [757] = 658,
  [758] = 692,
  [759] = 673,
  [760] = 662,
  [761] = 675,
  [762] = 669,
  [763] = 670,
  [764] = 665,
  [765] = 658,
  [766] = 677,
  [767] = 678,
  [768] = 673,
  [769] = 669,
  [770] = 670,
  [771] = 662,
  [772] = 675,
  [773] = 659,
  [774] = 673,
  [775] = 662,
  [776] = 675,
  [777] = 677,
  [778] = 677,
  [779] = 678,
  [780] = 659,
  [781] = 660,
  [782] = 661,
  [783] = 678,
  [784] = 663,
  [785] = 659,
  [786] = 664,
  [787] = 667,
  [788] = 668,
  [789] = 671,
  [790] = 672,
  [791] = 676,
  [792] = 682,
  [793] = 658,
  [794] = 692,
  [795] = 660,
  [796] = 661,
  [797] = 660,
  [798] = 663,
  [799] = 661,
  [800] = 673,
  [801] = 662,
  [802] = 667,
  [803] = 668,
  [804] = 658,
  [805] = 692,
  [806] = 664,
  [807] = 667,
  [808] = 673,
  [809] = 662,
  [810] = 667,
  [811] = 668,
  [812] = 658,
  [813] = 692,
  [814] = 668,
  [815] = 671,
  [816] = 662,
  [817] = 667,
  [818] = 668,
  [819] = 658,
  [820] = 692,
  [821] = 672,
  [822] = 676,
  [823] = 662,
  [824] = 667,
  [825] = 668,
  [826] = 658,
  [827] = 692,
  [828] = 682,
  [829] = 662,
  [830] = 667,
  [831] = 668,
  [832] = 658,
  [833] = 692,
  [834] = 658,
  [835] = 662,
  [836] = 667,
  [837] = 668,
  [838] = 658,
  [839] = 692,
  [840] = 692,
  [841] = 517,
  [842] = 662,
  [843] = 667,
  [844] = 668,
  [845] = 658,
  [846] = 692,
  [847] = 663,
  [848] = 673,
  [849] = 662,
  [850] = 667,
  [851] = 668,
  [852] = 658,
  [853] = 692,
  [854] = 664,
  [855] = 662,
  [856] = 667,
  [857] = 668,
  [858] = 658,
  [859] = 692,
  [860] = 667,
  [861] = 668,
  [862] = 662,
  [863] = 667,
  [864] = 668,
  [865] = 658,
  [866] = 692,
  [867] = 662,
  [868] = 671,
  [869] = 662,
  [870] = 667,
  [871] = 668,
  [872] = 658,
  [873] = 692,
  [874] = 672,
  [875] = 662,
  [876] = 667,
  [877] = 668,
  [878] = 658,
  [879] = 692,
  [880] = 665,
  [881] = 676,
  [882] = 662,
  [883] = 667,
  [884] = 668,
  [885] = 658,
  [886] = 692,
  [887] = 682,
  [888] = 662,
  [889] = 667,
  [890] = 668,
  [891] = 658,
  [892] = 692,
  [893] = 658,
  [894] = 669,
  [895] = 662,
  [896] = 667,
  [897] = 668,
  [898] = 658,
  [899] = 692,
  [900] = 670,
  [901] = 662,
  [902] = 667,
  [903] = 668,
  [904] = 658,
  [905] = 692,
  [906] = 692,
  [907] = 662,
  [908] = 667,
  [909] = 668,
  [910] = 658,
  [911] = 692,
  [912] = 673,
  [913] = 662,
  [914] = 662,
  [915] = 667,
  [916] = 668,
  [917] = 658,
  [918] = 692,
  [919] = 675,
  [920] = 675,
  [921] = 662,
  [922] = 667,
  [923] = 668,
  [924] = 658,
  [925] = 692,
  [926] = 677,
  [927] = 678,
  [928] = 662,
  [929] = 667,
  [930] = 668,
  [931] = 658,
  [932] = 692,
  [933] = 659,
  [934] = 660,
  [935] = 662,
  [936] = 667,
  [937] = 668,
  [938] = 658,
  [939] = 692,
  [940] = 661,
  [941] = 614,
  [942] = 662,
  [943] = 667,
  [944] = 668,
  [945] = 658,
  [946] = 692,
  [947] = 663,
  [948] = 677,
  [949] = 662,
  [950] = 667,
  [951] = 668,
  [952] = 658,
  [953] = 692,
  [954] = 664,
  [955] = 662,
  [956] = 667,
  [957] = 668,
  [958] = 658,
  [959] = 692,
  [960] = 667,
  [961] = 668,
  [962] = 662,
  [963] = 667,
  [964] = 668,
  [965] = 658,
  [966] = 692,
  [967] = 671,
  [968] = 672,
  [969] = 662,
  [970] = 667,
  [971] = 658,
  [972] = 676,
  [973] = 682,
  [974] = 662,
  [975] = 667,
  [976] = 658,
  [977] = 658,
  [978] = 662,
  [979] = 667,
  [980] = 658,
  [981] = 692,
  [982] = 662,
  [983] = 667,
  [984] = 658,
  [985] = 678,
  [986] = 659,
  [987] = 662,
  [988] = 667,
  [989] = 658,
  [990] = 660,
  [991] = 661,
  [992] = 662,
  [993] = 667,
  [994] = 658,
  [995] = 663,
  [996] = 662,
  [997] = 667,
  [998] = 658,
  [999] = 581,
  [1000] = 664,
  [1001] = 662,
  [1002] = 667,
  [1003] = 658,
  [1004] = 662,
  [1005] = 667,
  [1006] = 658,
  [1007] = 665,
  [1008] = 667,
  [1009] = 662,
  [1010] = 667,
  [1011] = 658,
  [1012] = 668,
  [1013] = 659,
  [1014] = 662,
  [1015] = 667,
  [1016] = 658,
  [1017] = 669,
  [1018] = 662,
  [1019] = 667,
  [1020] = 658,
  [1021] = 670,
  [1022] = 671,
  [1023] = 662,
  [1024] = 667,
  [1025] = 658,
  [1026] = 672,
  [1027] = 676,
  [1028] = 662,
  [1029] = 667,
  [1030] = 673,
  [1031] = 662,
  [1032] = 675,
  [1033] = 662,
  [1034] = 667,
  [1035] = 658,
  [1036] = 682,
  [1037] = 677,
  [1038] = 662,
  [1039] = 667,
  [1040] = 658,
  [1041] = 678,
  [1042] = 659,
  [1043] = 662,
  [1044] = 667,
  [1045] = 658,
  [1046] = 660,
  [1047] = 661,
  [1048] = 662,
  [1049] = 667,
  [1050] = 658,
  [1051] = 663,
  [1052] = 662,
  [1053] = 667,
  [1054] = 658,
  [1055] = 658,
  [1056] = 664,
  [1057] = 662,
  [1058] = 667,
  [1059] = 658,
  [1060] = 667,
  [1061] = 662,
  [1062] = 667,
  [1063] = 658,
  [1064] = 668,
  [1065] = 671,
  [1066] = 662,
  [1067] = 667,
  [1068] = 658,
  [1069] = 672,
  [1070] = 662,
  [1071] = 667,
  [1072] = 658,
  [1073] = 676,
  [1074] = 662,
  [1075] = 667,
  [1076] = 658,
  [1077] = 682,
  [1078] = 662,
  [1079] = 667,
  [1080] = 658,
  [1081] = 658,
  [1082] = 692,
  [1083] = 692,
  [1084] = 614,
  [1085] = 692,
  [1086] = 660,
  [1087] = 665,
  [1088] = 581,
  [1089] = 661,
  [1090] = 665,
  [1091] = 670,
  [1092] = 669,
  [1093] = 670,
  [1094] = 669,
  [1095] = 670,
  [1096] = 673,
  [1097] = 665,
  [1098] = 673,
  [1099] = 662,
  [1100] = 675,
  [1101] = 673,
  [1102] = 677,
  [1103] = 678,
  [1104] = 659,
  [1105] = 660,
  [1106] = 661,
  [1107] = 662,
  [1108] = 663,
  [1109] = 675,
  [1110] = 664,
  [1111] = 667,
  [1112] = 668,
  [1113] = 671,
  [1114] = 672,
  [1115] = 676,
  [1116] = 682,
  [1117] = 658,
  [1118] = 692,
  [1119] = 663,
  [1120] = 677,
  [1121] = 678,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1122,
  [1126] = 1126,
  [1127] = 1123,
  [1128] = 1123,
  [1129] = 1122,
  [1130] = 1122,
  [1131] = 1122,
  [1132] = 1126,
  [1133] = 1126,
  [1134] = 1126,
  [1135] = 1135,
  [1136] = 1126,
  [1137] = 1122,
  [1138] = 1126,
  [1139] = 1122,
  [1140] = 1122,
  [1141] = 1122,
  [1142] = 1122,
  [1143] = 1122,
  [1144] = 1126,
  [1145] = 1126,
  [1146] = 1135,
  [1147] = 1123,
  [1148] = 1123,
  [1149] = 1126,
  [1150] = 1126,
  [1151] = 1122,
  [1152] = 1126,
  [1153] = 1126,
  [1154] = 1135,
  [1155] = 1126,
  [1156] = 1126,
  [1157] = 1122,
  [1158] = 1126,
  [1159] = 1122,
  [1160] = 1135,
  [1161] = 1122,
  [1162] = 1126,
  [1163] = 1135,
  [1164] = 1122,
  [1165] = 1126,
  [1166] = 1123,
  [1167] = 1126,
  [1168] = 1126,
  [1169] = 1135,
  [1170] = 1123,
  [1171] = 1135,
  [1172] = 1126,
  [1173] = 1122,
  [1174] = 1126,
  [1175] = 1122,
  [1176] = 1122,
  [1177] = 1126,
  [1178] = 1135,
  [1179] = 1126,
  [1180] = 1126,
  [1181] = 1122,
  [1182] = 1126,
  [1183] = 1126,
  [1184] = 614,
  [1185] = 1122,
  [1186] = 1126,
  [1187] = 1126,
  [1188] = 1126,
  [1189] = 1122,
  [1190] = 1190,
  [1191] = 1126,
  [1192] = 1123,
  [1193] = 1135,
  [1194] = 1126,
  [1195] = 1122,
  [1196] = 1126,
  [1197] = 1126,
  [1198] = 1126,
  [1199] = 1122,
  [1200] = 1126,
  [1201] = 1126,
  [1202] = 1126,
  [1203] = 1126,
  [1204] = 1123,
  [1205] = 1190,
  [1206] = 1123,
  [1207] = 1122,
  [1208] = 1208,
  [1209] = 1122,
  [1210] = 1122,
  [1211] = 1122,
  [1212] = 1122,
  [1213] = 1126,
  [1214] = 1135,
  [1215] = 1126,
  [1216] = 1126,
  [1217] = 1126,
  [1218] = 1126,
  [1219] = 1126,
  [1220] = 1126,
  [1221] = 1208,
  [1222] = 1190,
  [1223] = 1126,
  [1224] = 1126,
  [1225] = 1208,
  [1226] = 1190,
  [1227] = 1126,
  [1228] = 1126,
  [1229] = 1208,
  [1230] = 1190,
  [1231] = 1122,
  [1232] = 1123,
  [1233] = 1208,
  [1234] = 1190,
  [1235] = 1208,
  [1236] = 1135,
  [1237] = 1208,
  [1238] = 1190,
  [1239] = 1126,
  [1240] = 581,
  [1241] = 1208,
  [1242] = 1190,
  [1243] = 614,
  [1244] = 1126,
  [1245] = 1208,
  [1246] = 1190,
  [1247] = 1122,
  [1248] = 581,
  [1249] = 1208,
  [1250] = 1190,
  [1251] = 1122,
  [1252] = 1126,
  [1253] = 1208,
  [1254] = 1190,
  [1255] = 1126,
  [1256] = 1122,
  [1257] = 1208,
  [1258] = 1208,
  [1259] = 1208,
  [1260] = 1208,
  [1261] = 1208,
  [1262] = 1208,
  [1263] = 1208,
  [1264] = 1208,
  [1265] = 1208,
  [1266] = 1208,
  [1267] = 1208,
  [1268] = 1208,
  [1269] = 1208,
  [1270] = 1208,
  [1271] = 1208,
  [1272] = 1208,
  [1273] = 1208,
  [1274] = 1208,
  [1275] = 1208,
  [1276] = 1208,
  [1277] = 1208,
  [1278] = 1208,
  [1279] = 1208,
  [1280] = 1208,
  [1281] = 1208,
  [1282] = 1208,
  [1283] = 1126,
  [1284] = 1135,
  [1285] = 1126,
  [1286] = 1126,
  [1287] = 1126,
  [1288] = 1123,
  [1289] = 1135,
  [1290] = 1126,
  [1291] = 1126,
  [1292] = 1122,
  [1293] = 1126,
  [1294] = 1122,
  [1295] = 1123,
  [1296] = 1123,
  [1297] = 1122,
  [1298] = 1122,
  [1299] = 1135,
  [1300] = 1126,
  [1301] = 1126,
  [1302] = 1190,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1304,
  [1306] = 1306,
  [1307] = 1307,
  [1308] = 1308,
  [1309] = 1309,
  [1310] = 1310,
  [1311] = 1307,
  [1312] = 1307,
  [1313] = 1304,
  [1314] = 1307,
  [1315] = 1315,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1304,
  [1319] = 1315,
  [1320] = 1320,
  [1321] = 1304,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1307,
  [1325] = 1304,
  [1326] = 1304,
  [1327] = 1303,
  [1328] = 1307,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1334,
  [1335] = 1307,
  [1336] = 1336,
  [1337] = 1307,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1306,
  [1343] = 1343,
  [1344] = 1308,
  [1345] = 1306,
  [1346] = 1346,
  [1347] = 1309,
  [1348] = 1310,
  [1349] = 1346,
  [1350] = 1307,
  [1351] = 1304,
  [1352] = 1352,
  [1353] = 1320,
  [1354] = 1338,
  [1355] = 1316,
  [1356] = 1356,
  [1357] = 1317,
  [1358] = 1308,
  [1359] = 1315,
  [1360] = 1320,
  [1361] = 1307,
  [1362] = 1322,
  [1363] = 1323,
  [1364] = 1309,
  [1365] = 1339,
  [1366] = 1308,
  [1367] = 1309,
  [1368] = 1340,
  [1369] = 1304,
  [1370] = 1304,
  [1371] = 1303,
  [1372] = 1316,
  [1373] = 1316,
  [1374] = 1317,
  [1375] = 1317,
  [1376] = 1315,
  [1377] = 1320,
  [1378] = 1322,
  [1379] = 1323,
  [1380] = 1315,
  [1381] = 1320,
  [1382] = 1329,
  [1383] = 1322,
  [1384] = 1323,
  [1385] = 1303,
  [1386] = 1330,
  [1387] = 1329,
  [1388] = 1330,
  [1389] = 1331,
  [1390] = 1332,
  [1391] = 1333,
  [1392] = 1334,
  [1393] = 1331,
  [1394] = 1336,
  [1395] = 1332,
  [1396] = 1338,
  [1397] = 1339,
  [1398] = 1340,
  [1399] = 1341,
  [1400] = 1333,
  [1401] = 1343,
  [1402] = 1306,
  [1403] = 1303,
  [1404] = 1346,
  [1405] = 1336,
  [1406] = 1329,
  [1407] = 1330,
  [1408] = 1331,
  [1409] = 1332,
  [1410] = 1316,
  [1411] = 1333,
  [1412] = 1315,
  [1413] = 1320,
  [1414] = 1334,
  [1415] = 1322,
  [1416] = 1323,
  [1417] = 1307,
  [1418] = 1303,
  [1419] = 1336,
  [1420] = 1329,
  [1421] = 1330,
  [1422] = 1331,
  [1423] = 1332,
  [1424] = 1334,
  [1425] = 1336,
  [1426] = 1338,
  [1427] = 1338,
  [1428] = 1339,
  [1429] = 1340,
  [1430] = 1341,
  [1431] = 1339,
  [1432] = 1343,
  [1433] = 1340,
  [1434] = 1306,
  [1435] = 1346,
  [1436] = 1341,
  [1437] = 1338,
  [1438] = 1343,
  [1439] = 1339,
  [1440] = 1316,
  [1441] = 1340,
  [1442] = 1315,
  [1443] = 1320,
  [1444] = 1322,
  [1445] = 1323,
  [1446] = 1306,
  [1447] = 1303,
  [1448] = 1341,
  [1449] = 1329,
  [1450] = 1330,
  [1451] = 1331,
  [1452] = 1332,
  [1453] = 1334,
  [1454] = 1308,
  [1455] = 1336,
  [1456] = 1309,
  [1457] = 1338,
  [1458] = 1339,
  [1459] = 1340,
  [1460] = 1341,
  [1461] = 1343,
  [1462] = 1343,
  [1463] = 1306,
  [1464] = 1346,
  [1465] = 1307,
  [1466] = 1316,
  [1467] = 1315,
  [1468] = 1320,
  [1469] = 1308,
  [1470] = 1322,
  [1471] = 1323,
  [1472] = 1304,
  [1473] = 1303,
  [1474] = 1329,
  [1475] = 1330,
  [1476] = 1331,
  [1477] = 1332,
  [1478] = 1334,
  [1479] = 1309,
  [1480] = 1336,
  [1481] = 1307,
  [1482] = 1338,
  [1483] = 1339,
  [1484] = 1340,
  [1485] = 1341,
  [1486] = 1307,
  [1487] = 1343,
  [1488] = 1306,
  [1489] = 1346,
  [1490] = 1304,
  [1491] = 1304,
  [1492] = 1316,
  [1493] = 1315,
  [1494] = 1320,
  [1495] = 1307,
  [1496] = 1322,
  [1497] = 1323,
  [1498] = 1303,
  [1499] = 1329,
  [1500] = 1330,
  [1501] = 1331,
  [1502] = 1332,
  [1503] = 1334,
  [1504] = 1308,
  [1505] = 1336,
  [1506] = 1309,
  [1507] = 1338,
  [1508] = 1339,
  [1509] = 1340,
  [1510] = 1341,
  [1511] = 1343,
  [1512] = 1308,
  [1513] = 1306,
  [1514] = 1346,
  [1515] = 1307,
  [1516] = 1309,
  [1517] = 1316,
  [1518] = 1315,
  [1519] = 1320,
  [1520] = 1307,
  [1521] = 1322,
  [1522] = 1323,
  [1523] = 1306,
  [1524] = 1303,
  [1525] = 1329,
  [1526] = 1330,
  [1527] = 1331,
  [1528] = 1332,
  [1529] = 1334,
  [1530] = 1307,
  [1531] = 1336,
  [1532] = 1341,
  [1533] = 1338,
  [1534] = 1339,
  [1535] = 1340,
  [1536] = 1341,
  [1537] = 1308,
  [1538] = 1343,
  [1539] = 1309,
  [1540] = 1306,
  [1541] = 1346,
  [1542] = 1307,
  [1543] = 1307,
  [1544] = 1307,
  [1545] = 1316,
  [1546] = 1315,
  [1547] = 1320,
  [1548] = 1304,
  [1549] = 1322,
  [1550] = 1323,
  [1551] = 1303,
  [1552] = 1329,
  [1553] = 1330,
  [1554] = 1331,
  [1555] = 1332,
  [1556] = 1334,
  [1557] = 1346,
  [1558] = 1336,
  [1559] = 1304,
  [1560] = 1338,
  [1561] = 1339,
  [1562] = 1340,
  [1563] = 1341,
  [1564] = 1343,
  [1565] = 1306,
  [1566] = 1346,
  [1567] = 1306,
  [1568] = 1316,
  [1569] = 1315,
  [1570] = 1320,
  [1571] = 1307,
  [1572] = 1322,
  [1573] = 1323,
  [1574] = 1310,
  [1575] = 1303,
  [1576] = 1329,
  [1577] = 1330,
  [1578] = 1331,
  [1579] = 1332,
  [1580] = 1334,
  [1581] = 1308,
  [1582] = 1336,
  [1583] = 1309,
  [1584] = 1338,
  [1585] = 1339,
  [1586] = 1340,
  [1587] = 1341,
  [1588] = 1307,
  [1589] = 1343,
  [1590] = 1307,
  [1591] = 1306,
  [1592] = 1346,
  [1593] = 1304,
  [1594] = 1343,
  [1595] = 1316,
  [1596] = 1315,
  [1597] = 1320,
  [1598] = 1308,
  [1599] = 1322,
  [1600] = 1323,
  [1601] = 1309,
  [1602] = 1303,
  [1603] = 1329,
  [1604] = 1330,
  [1605] = 1331,
  [1606] = 1332,
  [1607] = 1334,
  [1608] = 1307,
  [1609] = 1336,
  [1610] = 1322,
  [1611] = 1338,
  [1612] = 1339,
  [1613] = 1340,
  [1614] = 1341,
  [1615] = 1308,
  [1616] = 1343,
  [1617] = 1309,
  [1618] = 1306,
  [1619] = 1346,
  [1620] = 1304,
  [1621] = 1304,
  [1622] = 1316,
  [1623] = 1315,
  [1624] = 1320,
  [1625] = 1322,
  [1626] = 1323,
  [1627] = 1308,
  [1628] = 1329,
  [1629] = 1330,
  [1630] = 1331,
  [1631] = 1332,
  [1632] = 1334,
  [1633] = 1316,
  [1634] = 1336,
  [1635] = 1317,
  [1636] = 1338,
  [1637] = 1339,
  [1638] = 1340,
  [1639] = 1341,
  [1640] = 1343,
  [1641] = 1315,
  [1642] = 1306,
  [1643] = 1346,
  [1644] = 1320,
  [1645] = 1307,
  [1646] = 1322,
  [1647] = 1316,
  [1648] = 1315,
  [1649] = 1320,
  [1650] = 1323,
  [1651] = 1322,
  [1652] = 1323,
  [1653] = 1307,
  [1654] = 1303,
  [1655] = 1329,
  [1656] = 1330,
  [1657] = 1331,
  [1658] = 1332,
  [1659] = 1334,
  [1660] = 1309,
  [1661] = 1336,
  [1662] = 1323,
  [1663] = 1338,
  [1664] = 1339,
  [1665] = 1340,
  [1666] = 1341,
  [1667] = 1308,
  [1668] = 1343,
  [1669] = 1309,
  [1670] = 1306,
  [1671] = 1346,
  [1672] = 1303,
  [1673] = 1308,
  [1674] = 1329,
  [1675] = 1316,
  [1676] = 1315,
  [1677] = 1320,
  [1678] = 1330,
  [1679] = 1322,
  [1680] = 1323,
  [1681] = 1331,
  [1682] = 1303,
  [1683] = 1329,
  [1684] = 1330,
  [1685] = 1331,
  [1686] = 1332,
  [1687] = 1334,
  [1688] = 1332,
  [1689] = 1336,
  [1690] = 1333,
  [1691] = 1338,
  [1692] = 1339,
  [1693] = 1340,
  [1694] = 1341,
  [1695] = 1334,
  [1696] = 1343,
  [1697] = 1309,
  [1698] = 1306,
  [1699] = 1346,
  [1700] = 1336,
  [1701] = 1304,
  [1702] = 1338,
  [1703] = 1316,
  [1704] = 1315,
  [1705] = 1320,
  [1706] = 1339,
  [1707] = 1322,
  [1708] = 1323,
  [1709] = 1340,
  [1710] = 1303,
  [1711] = 1329,
  [1712] = 1330,
  [1713] = 1331,
  [1714] = 1332,
  [1715] = 1334,
  [1716] = 1341,
  [1717] = 1336,
  [1718] = 1338,
  [1719] = 1339,
  [1720] = 1340,
  [1721] = 1341,
  [1722] = 1343,
  [1723] = 1343,
  [1724] = 1308,
  [1725] = 1306,
  [1726] = 1346,
  [1727] = 1306,
  [1728] = 1304,
  [1729] = 1308,
  [1730] = 1316,
  [1731] = 1315,
  [1732] = 1320,
  [1733] = 1309,
  [1734] = 1322,
  [1735] = 1323,
  [1736] = 1303,
  [1737] = 1329,
  [1738] = 1330,
  [1739] = 1331,
  [1740] = 1332,
  [1741] = 1334,
  [1742] = 1336,
  [1743] = 1310,
  [1744] = 1338,
  [1745] = 1339,
  [1746] = 1340,
  [1747] = 1341,
  [1748] = 1307,
  [1749] = 1343,
  [1750] = 1304,
  [1751] = 1306,
  [1752] = 1346,
  [1753] = 1307,
  [1754] = 1304,
  [1755] = 1316,
  [1756] = 1315,
  [1757] = 1320,
  [1758] = 1304,
  [1759] = 1322,
  [1760] = 1323,
  [1761] = 1308,
  [1762] = 1303,
  [1763] = 1329,
  [1764] = 1330,
  [1765] = 1331,
  [1766] = 1332,
  [1767] = 1334,
  [1768] = 1309,
  [1769] = 1336,
  [1770] = 1346,
  [1771] = 1338,
  [1772] = 1339,
  [1773] = 1340,
  [1774] = 1341,
  [1775] = 1343,
  [1776] = 1307,
  [1777] = 1306,
  [1778] = 1346,
  [1779] = 1304,
  [1780] = 1309,
  [1781] = 1316,
  [1782] = 1315,
  [1783] = 1320,
  [1784] = 1308,
  [1785] = 1322,
  [1786] = 1323,
  [1787] = 1309,
  [1788] = 1303,
  [1789] = 1329,
  [1790] = 1330,
  [1791] = 1331,
  [1792] = 1332,
  [1793] = 1334,
  [1794] = 1307,
  [1795] = 1336,
  [1796] = 1338,
  [1797] = 1339,
  [1798] = 1340,
  [1799] = 1341,
  [1800] = 1308,
  [1801] = 1343,
  [1802] = 1309,
  [1803] = 1306,
  [1804] = 1346,
  [1805] = 1304,
  [1806] = 1304,
  [1807] = 1316,
  [1808] = 1315,
  [1809] = 1320,
  [1810] = 1322,
  [1811] = 1323,
  [1812] = 1303,
  [1813] = 1329,
  [1814] = 1330,
  [1815] = 1331,
  [1816] = 1332,
  [1817] = 1334,
  [1818] = 1336,
  [1819] = 1307,
  [1820] = 1338,
  [1821] = 1339,
  [1822] = 1340,
  [1823] = 1341,
  [1824] = 1307,
  [1825] = 1343,
  [1826] = 1306,
  [1827] = 1346,
  [1828] = 1308,
  [1829] = 1309,
  [1830] = 1308,
  [1831] = 1316,
  [1832] = 1315,
  [1833] = 1320,
  [1834] = 1309,
  [1835] = 1322,
  [1836] = 1323,
  [1837] = 1304,
  [1838] = 1303,
  [1839] = 1329,
  [1840] = 1330,
  [1841] = 1331,
  [1842] = 1332,
  [1843] = 1334,
  [1844] = 1336,
  [1845] = 1316,
  [1846] = 1338,
  [1847] = 1339,
  [1848] = 1340,
  [1849] = 1341,
  [1850] = 1317,
  [1851] = 1343,
  [1852] = 1304,
  [1853] = 1306,
  [1854] = 1346,
  [1855] = 1315,
  [1856] = 1320,
  [1857] = 1304,
  [1858] = 1316,
  [1859] = 1315,
  [1860] = 1320,
  [1861] = 1322,
  [1862] = 1322,
  [1863] = 1323,
  [1864] = 1323,
  [1865] = 1303,
  [1866] = 1329,
  [1867] = 1330,
  [1868] = 1331,
  [1869] = 1332,
  [1870] = 1334,
  [1871] = 1336,
  [1872] = 1307,
  [1873] = 1338,
  [1874] = 1339,
  [1875] = 1340,
  [1876] = 1341,
  [1877] = 1343,
  [1878] = 1308,
  [1879] = 1306,
  [1880] = 1346,
  [1881] = 1309,
  [1882] = 1303,
  [1883] = 1316,
  [1884] = 1315,
  [1885] = 1320,
  [1886] = 1329,
  [1887] = 1322,
  [1888] = 1323,
  [1889] = 1330,
  [1890] = 1303,
  [1891] = 1329,
  [1892] = 1330,
  [1893] = 1331,
  [1894] = 1332,
  [1895] = 1334,
  [1896] = 1331,
  [1897] = 1336,
  [1898] = 1332,
  [1899] = 1338,
  [1900] = 1339,
  [1901] = 1340,
  [1902] = 1341,
  [1903] = 1333,
  [1904] = 1343,
  [1905] = 1334,
  [1906] = 1306,
  [1907] = 1346,
  [1908] = 1307,
  [1909] = 1336,
  [1910] = 1304,
  [1911] = 1316,
  [1912] = 1315,
  [1913] = 1320,
  [1914] = 1338,
  [1915] = 1322,
  [1916] = 1323,
  [1917] = 1339,
  [1918] = 1303,
  [1919] = 1329,
  [1920] = 1330,
  [1921] = 1331,
  [1922] = 1332,
  [1923] = 1334,
  [1924] = 1340,
  [1925] = 1336,
  [1926] = 1341,
  [1927] = 1338,
  [1928] = 1339,
  [1929] = 1340,
  [1930] = 1341,
  [1931] = 1343,
  [1932] = 1343,
  [1933] = 1306,
  [1934] = 1346,
  [1935] = 1935,
  [1936] = 1306,
  [1937] = 1308,
  [1938] = 1316,
  [1939] = 1315,
  [1940] = 1320,
  [1941] = 1308,
  [1942] = 1322,
  [1943] = 1323,
  [1944] = 1309,
  [1945] = 1303,
  [1946] = 1329,
  [1947] = 1330,
  [1948] = 1331,
  [1949] = 1332,
  [1950] = 1334,
  [1951] = 1309,
  [1952] = 1336,
  [1953] = 1338,
  [1954] = 1339,
  [1955] = 1340,
  [1956] = 1341,
  [1957] = 1307,
  [1958] = 1343,
  [1959] = 1307,
  [1960] = 1306,
  [1961] = 1346,
  [1962] = 1304,
  [1963] = 1310,
  [1964] = 1304,
  [1965] = 1316,
  [1966] = 1315,
  [1967] = 1320,
  [1968] = 1308,
  [1969] = 1322,
  [1970] = 1323,
  [1971] = 1309,
  [1972] = 1303,
  [1973] = 1329,
  [1974] = 1330,
  [1975] = 1331,
  [1976] = 1332,
  [1977] = 1334,
  [1978] = 1346,
  [1979] = 1336,
  [1980] = 1304,
  [1981] = 1338,
  [1982] = 1339,
  [1983] = 1340,
  [1984] = 1341,
  [1985] = 1304,
  [1986] = 1343,
  [1987] = 1306,
  [1988] = 1346,
  [1989] = 1307,
  [1990] = 1307,
  [1991] = 1316,
  [1992] = 1315,
  [1993] = 1320,
  [1994] = 1308,
  [1995] = 1322,
  [1996] = 1323,
  [1997] = 1309,
  [1998] = 1303,
  [1999] = 1329,
  [2000] = 1330,
  [2001] = 1331,
  [2002] = 1332,
  [2003] = 1334,
  [2004] = 1336,
  [2005] = 1304,
  [2006] = 1338,
  [2007] = 1339,
  [2008] = 1340,
  [2009] = 1341,
  [2010] = 1343,
  [2011] = 1307,
  [2012] = 1306,
  [2013] = 1346,
  [2014] = 1307,
  [2015] = 1304,
  [2016] = 1308,
  [2017] = 1316,
  [2018] = 1315,
  [2019] = 1320,
  [2020] = 1309,
  [2021] = 1322,
  [2022] = 1323,
  [2023] = 1308,
  [2024] = 1303,
  [2025] = 1329,
  [2026] = 1330,
  [2027] = 1331,
  [2028] = 1332,
  [2029] = 1334,
  [2030] = 1304,
  [2031] = 1336,
  [2032] = 1338,
  [2033] = 1339,
  [2034] = 1340,
  [2035] = 1341,
  [2036] = 1309,
  [2037] = 1343,
  [2038] = 1307,
  [2039] = 1306,
  [2040] = 1346,
  [2041] = 1308,
  [2042] = 1309,
  [2043] = 1316,
  [2044] = 1315,
  [2045] = 1320,
  [2046] = 1304,
  [2047] = 1322,
  [2048] = 1323,
  [2049] = 1304,
  [2050] = 1303,
  [2051] = 1329,
  [2052] = 1330,
  [2053] = 1331,
  [2054] = 1332,
  [2055] = 1334,
  [2056] = 1316,
  [2057] = 1336,
  [2058] = 1317,
  [2059] = 1338,
  [2060] = 1339,
  [2061] = 1340,
  [2062] = 1341,
  [2063] = 1343,
  [2064] = 1315,
  [2065] = 1306,
  [2066] = 1346,
  [2067] = 1320,
  [2068] = 1322,
  [2069] = 1316,
  [2070] = 1315,
  [2071] = 1320,
  [2072] = 1323,
  [2073] = 1322,
  [2074] = 1323,
  [2075] = 1303,
  [2076] = 1329,
  [2077] = 1330,
  [2078] = 1331,
  [2079] = 1332,
  [2080] = 1334,
  [2081] = 1307,
  [2082] = 1336,
  [2083] = 1338,
  [2084] = 1339,
  [2085] = 1340,
  [2086] = 1343,
  [2087] = 1308,
  [2088] = 1306,
  [2089] = 1346,
  [2090] = 1308,
  [2091] = 1309,
  [2092] = 1316,
  [2093] = 1315,
  [2094] = 1320,
  [2095] = 1303,
  [2096] = 1322,
  [2097] = 1323,
  [2098] = 1303,
  [2099] = 1329,
  [2100] = 1330,
  [2101] = 1331,
  [2102] = 1332,
  [2103] = 1334,
  [2104] = 1304,
  [2105] = 1336,
  [2106] = 1338,
  [2107] = 1339,
  [2108] = 1340,
  [2109] = 1343,
  [2110] = 1329,
  [2111] = 1306,
  [2112] = 1346,
  [2113] = 1330,
  [2114] = 1331,
  [2115] = 1332,
  [2116] = 1315,
  [2117] = 1320,
  [2118] = 1333,
  [2119] = 1322,
  [2120] = 1323,
  [2121] = 1329,
  [2122] = 1330,
  [2123] = 1334,
  [2124] = 1334,
  [2125] = 1336,
  [2126] = 1340,
  [2127] = 1306,
  [2128] = 1346,
  [2129] = 1336,
  [2130] = 1307,
  [2131] = 1338,
  [2132] = 1315,
  [2133] = 1320,
  [2134] = 1339,
  [2135] = 1322,
  [2136] = 1323,
  [2137] = 1329,
  [2138] = 1330,
  [2139] = 1334,
  [2140] = 1340,
  [2141] = 1336,
  [2142] = 1340,
  [2143] = 1341,
  [2144] = 1306,
  [2145] = 1346,
  [2146] = 1307,
  [2147] = 1343,
  [2148] = 1309,
  [2149] = 1315,
  [2150] = 1320,
  [2151] = 1306,
  [2152] = 1322,
  [2153] = 1323,
  [2154] = 1329,
  [2155] = 1330,
  [2156] = 1334,
  [2157] = 1308,
  [2158] = 1336,
  [2159] = 1340,
  [2160] = 1308,
  [2161] = 1306,
  [2162] = 1346,
  [2163] = 1309,
  [2164] = 1309,
  [2165] = 1308,
  [2166] = 1315,
  [2167] = 1320,
  [2168] = 1307,
  [2169] = 1322,
  [2170] = 1323,
  [2171] = 1329,
  [2172] = 1330,
  [2173] = 1334,
  [2174] = 1304,
  [2175] = 1336,
  [2176] = 1340,
  [2177] = 1304,
  [2178] = 1306,
  [2179] = 1346,
  [2180] = 1309,
  [2181] = 1346,
  [2182] = 1315,
  [2183] = 1320,
  [2184] = 1307,
  [2185] = 1322,
  [2186] = 1323,
  [2187] = 1329,
  [2188] = 1330,
  [2189] = 1334,
  [2190] = 1336,
  [2191] = 1340,
  [2192] = 1308,
  [2193] = 1306,
  [2194] = 1309,
  [2195] = 1304,
  [2196] = 1304,
  [2197] = 1315,
  [2198] = 1320,
  [2199] = 1322,
  [2200] = 1323,
  [2201] = 1329,
  [2202] = 1330,
  [2203] = 1334,
  [2204] = 1336,
  [2205] = 1340,
  [2206] = 1307,
  [2207] = 1306,
  [2208] = 1308,
  [2209] = 1309,
  [2210] = 1315,
  [2211] = 1320,
  [2212] = 1304,
  [2213] = 1322,
  [2214] = 1323,
  [2215] = 1329,
  [2216] = 1330,
  [2217] = 1334,
  [2218] = 1336,
  [2219] = 1340,
  [2220] = 1306,
  [2221] = 1307,
  [2222] = 1307,
  [2223] = 1308,
  [2224] = 1315,
  [2225] = 1320,
  [2226] = 1309,
  [2227] = 1322,
  [2228] = 1323,
  [2229] = 1329,
  [2230] = 1330,
  [2231] = 1334,
  [2232] = 1304,
  [2233] = 1336,
  [2234] = 1340,
  [2235] = 1304,
  [2236] = 1306,
  [2237] = 1308,
  [2238] = 1307,
  [2239] = 1315,
  [2240] = 1320,
  [2241] = 1309,
  [2242] = 1322,
  [2243] = 1323,
  [2244] = 1329,
  [2245] = 1330,
  [2246] = 1334,
  [2247] = 1308,
  [2248] = 1336,
  [2249] = 1340,
  [2250] = 1316,
  [2251] = 1306,
  [2252] = 1317,
  [2253] = 1309,
  [2254] = 1315,
  [2255] = 1315,
  [2256] = 1320,
  [2257] = 1320,
  [2258] = 1322,
  [2259] = 1323,
  [2260] = 1329,
  [2261] = 1330,
  [2262] = 1334,
  [2263] = 1336,
  [2264] = 1340,
  [2265] = 1322,
  [2266] = 1306,
  [2267] = 1323,
  [2268] = 1304,
  [2269] = 1315,
  [2270] = 1320,
  [2271] = 1304,
  [2272] = 1322,
  [2273] = 1323,
  [2274] = 1329,
  [2275] = 1330,
  [2276] = 1334,
  [2277] = 1307,
  [2278] = 1336,
  [2279] = 1340,
  [2280] = 1306,
  [2281] = 1303,
  [2282] = 1308,
  [2283] = 1329,
  [2284] = 1315,
  [2285] = 1320,
  [2286] = 1330,
  [2287] = 1322,
  [2288] = 1323,
  [2289] = 1329,
  [2290] = 1330,
  [2291] = 1334,
  [2292] = 1331,
  [2293] = 1336,
  [2294] = 1340,
  [2295] = 1332,
  [2296] = 1306,
  [2297] = 1333,
  [2298] = 1334,
  [2299] = 1309,
  [2300] = 1315,
  [2301] = 1320,
  [2302] = 1336,
  [2303] = 1322,
  [2304] = 1323,
  [2305] = 1329,
  [2306] = 1330,
  [2307] = 1334,
  [2308] = 1336,
  [2309] = 1340,
  [2310] = 1338,
  [2311] = 1306,
  [2312] = 1339,
  [2313] = 1340,
  [2314] = 1341,
  [2315] = 1315,
  [2316] = 1320,
  [2317] = 1304,
  [2318] = 1322,
  [2319] = 1323,
  [2320] = 1329,
  [2321] = 1330,
  [2322] = 1334,
  [2323] = 1343,
  [2324] = 1336,
  [2325] = 1340,
  [2326] = 1306,
  [2327] = 1306,
  [2328] = 1308,
  [2329] = 1315,
  [2330] = 1320,
  [2331] = 1309,
  [2332] = 1322,
  [2333] = 1323,
  [2334] = 1329,
  [2335] = 1330,
  [2336] = 1334,
  [2337] = 1307,
  [2338] = 1336,
  [2339] = 1340,
  [2340] = 1304,
  [2341] = 1306,
  [2342] = 1307,
  [2343] = 1307,
  [2344] = 1315,
  [2345] = 1320,
  [2346] = 1307,
  [2347] = 1322,
  [2348] = 1323,
  [2349] = 1329,
  [2350] = 1330,
  [2351] = 1334,
  [2352] = 1346,
  [2353] = 1336,
  [2354] = 1340,
  [2355] = 1306,
  [2356] = 1346,
  [2357] = 1307,
  [2358] = 1308,
  [2359] = 1315,
  [2360] = 1320,
  [2361] = 1322,
  [2362] = 1323,
  [2363] = 1329,
  [2364] = 1330,
  [2365] = 1334,
  [2366] = 1309,
  [2367] = 1336,
  [2368] = 1340,
  [2369] = 1307,
  [2370] = 1306,
  [2371] = 1304,
  [2372] = 1315,
  [2373] = 1320,
  [2374] = 1346,
  [2375] = 1322,
  [2376] = 1323,
  [2377] = 1329,
  [2378] = 1330,
  [2379] = 1334,
  [2380] = 1352,
  [2381] = 1336,
  [2382] = 1340,
  [2383] = 1306,
  [2384] = 1307,
  [2385] = 1308,
  [2386] = 1308,
  [2387] = 1315,
  [2388] = 1320,
  [2389] = 1309,
  [2390] = 1322,
  [2391] = 1323,
  [2392] = 1329,
  [2393] = 1330,
  [2394] = 1334,
  [2395] = 1309,
  [2396] = 1336,
  [2397] = 1340,
  [2398] = 1304,
  [2399] = 1306,
  [2400] = 1310,
  [2401] = 1315,
  [2402] = 1320,
  [2403] = 1307,
  [2404] = 1322,
  [2405] = 1323,
  [2406] = 1329,
  [2407] = 1330,
  [2408] = 1334,
  [2409] = 1307,
  [2410] = 1336,
  [2411] = 1340,
  [2412] = 1306,
  [2413] = 1308,
  [2414] = 1309,
  [2415] = 1316,
  [2416] = 1315,
  [2417] = 1320,
  [2418] = 1317,
  [2419] = 1322,
  [2420] = 1323,
  [2421] = 1329,
  [2422] = 1330,
  [2423] = 1334,
  [2424] = 2424,
  [2425] = 1336,
  [2426] = 1340,
  [2427] = 1306,
  [2428] = 1315,
  [2429] = 1320,
  [2430] = 1304,
  [2431] = 1315,
  [2432] = 1320,
  [2433] = 1322,
  [2434] = 1322,
  [2435] = 1323,
  [2436] = 1329,
  [2437] = 1330,
  [2438] = 1334,
  [2439] = 1323,
  [2440] = 1336,
  [2441] = 1340,
  [2442] = 1304,
  [2443] = 1316,
  [2444] = 1315,
  [2445] = 1320,
  [2446] = 1307,
  [2447] = 1322,
  [2448] = 1323,
  [2449] = 1329,
  [2450] = 1330,
  [2451] = 1334,
  [2452] = 1308,
  [2453] = 1336,
  [2454] = 1340,
  [2455] = 1329,
  [2456] = 1329,
  [2457] = 1329,
  [2458] = 1329,
  [2459] = 1329,
  [2460] = 1329,
  [2461] = 1329,
  [2462] = 1329,
  [2463] = 1329,
  [2464] = 1329,
  [2465] = 1329,
  [2466] = 1329,
  [2467] = 1329,
  [2468] = 1329,
  [2469] = 1329,
  [2470] = 1329,
  [2471] = 1329,
  [2472] = 1329,
  [2473] = 1329,
  [2474] = 1329,
  [2475] = 1329,
  [2476] = 1329,
  [2477] = 1329,
  [2478] = 1329,
  [2479] = 1329,
  [2480] = 1329,
  [2481] = 1329,
  [2482] = 1329,
  [2483] = 1329,
  [2484] = 1329,
  [2485] = 1329,
  [2486] = 1329,
  [2487] = 1329,
  [2488] = 1329,
  [2489] = 1329,
  [2490] = 1329,
  [2491] = 1329,
  [2492] = 1329,
  [2493] = 1329,
  [2494] = 1329,
  [2495] = 1329,
  [2496] = 1329,
  [2497] = 1329,
  [2498] = 1329,
  [2499] = 1329,
  [2500] = 1329,
  [2501] = 1329,
  [2502] = 1329,
  [2503] = 1329,
  [2504] = 1329,
  [2505] = 1329,
  [2506] = 1329,
  [2507] = 1329,
  [2508] = 1329,
  [2509] = 1329,
  [2510] = 1329,
  [2511] = 1329,
  [2512] = 1329,
  [2513] = 1329,
  [2514] = 1329,
  [2515] = 1329,
  [2516] = 1329,
  [2517] = 1303,
  [2518] = 1304,
  [2519] = 2424,
  [2520] = 1329,
  [2521] = 1935,
  [2522] = 1330,
  [2523] = 1331,
  [2524] = 1308,
  [2525] = 1309,
  [2526] = 1332,
  [2527] = 1333,
  [2528] = 1334,
  [2529] = 1336,
  [2530] = 1309,
  [2531] = 1346,
  [2532] = 1338,
  [2533] = 1308,
  [2534] = 1309,
  [2535] = 1339,
  [2536] = 1346,
  [2537] = 1346,
  [2538] = 1340,
  [2539] = 1341,
  [2540] = 2424,
  [2541] = 1352,
  [2542] = 1935,
  [2543] = 1343,
  [2544] = 1346,
  [2545] = 1307,
  [2546] = 1306,
  [2547] = 2424,
  [2548] = 1303,
  [2549] = 1935,
  [2550] = 1346,
  [2551] = 1307,
  [2552] = 1316,
  [2553] = 2424,
  [2554] = 1346,
  [2555] = 1935,
  [2556] = 1317,
  [2557] = 1346,
  [2558] = 1315,
  [2559] = 2424,
  [2560] = 1320,
  [2561] = 1935,
  [2562] = 1307,
  [2563] = 1346,
  [2564] = 1322,
  [2565] = 1323,
  [2566] = 2424,
  [2567] = 1304,
  [2568] = 1935,
  [2569] = 1356,
  [2570] = 1307,
  [2571] = 2424,
  [2572] = 1935,
  [2573] = 1329,
  [2574] = 1303,
  [2575] = 2424,
  [2576] = 1329,
  [2577] = 1935,
  [2578] = 1330,
  [2579] = 1331,
  [2580] = 1332,
  [2581] = 2424,
  [2582] = 1333,
  [2583] = 1935,
  [2584] = 1334,
  [2585] = 1330,
  [2586] = 1336,
  [2587] = 2424,
  [2588] = 1331,
  [2589] = 1935,
  [2590] = 1338,
  [2591] = 1339,
  [2592] = 1316,
  [2593] = 2424,
  [2594] = 1317,
  [2595] = 1935,
  [2596] = 1340,
  [2597] = 1935,
  [2598] = 1315,
  [2599] = 1935,
  [2600] = 1320,
  [2601] = 1935,
  [2602] = 1341,
  [2603] = 1935,
  [2604] = 1322,
  [2605] = 1935,
  [2606] = 1323,
  [2607] = 1935,
  [2608] = 1346,
  [2609] = 1935,
  [2610] = 1343,
  [2611] = 1935,
  [2612] = 1308,
  [2613] = 1935,
  [2614] = 1304,
  [2615] = 1935,
  [2616] = 1309,
  [2617] = 1935,
  [2618] = 1303,
  [2619] = 1935,
  [2620] = 1332,
  [2621] = 1935,
  [2622] = 1329,
  [2623] = 1935,
  [2624] = 1330,
  [2625] = 1935,
  [2626] = 1331,
  [2627] = 1935,
  [2628] = 1332,
  [2629] = 1935,
  [2630] = 1333,
  [2631] = 1935,
  [2632] = 1334,
  [2633] = 1935,
  [2634] = 1306,
  [2635] = 1935,
  [2636] = 1336,
  [2637] = 1935,
  [2638] = 1310,
  [2639] = 1935,
  [2640] = 1338,
  [2641] = 1935,
  [2642] = 1339,
  [2643] = 1935,
  [2644] = 1340,
  [2645] = 1935,
  [2646] = 1341,
  [2647] = 1935,
  [2648] = 1935,
  [2649] = 1935,
  [2650] = 1935,
  [2651] = 1935,
  [2652] = 1935,
  [2653] = 1935,
  [2654] = 1935,
  [2655] = 1935,
  [2656] = 1935,
  [2657] = 1935,
  [2658] = 1935,
  [2659] = 1935,
  [2660] = 1935,
  [2661] = 1935,
  [2662] = 1935,
  [2663] = 1935,
  [2664] = 1935,
  [2665] = 1935,
  [2666] = 1935,
  [2667] = 1935,
  [2668] = 1935,
  [2669] = 1935,
  [2670] = 1935,
  [2671] = 1935,
  [2672] = 1935,
  [2673] = 1935,
  [2674] = 1935,
  [2675] = 1935,
  [2676] = 1935,
  [2677] = 1935,
  [2678] = 1935,
  [2679] = 1346,
  [2680] = 1935,
  [2681] = 1308,
  [2682] = 1343,
  [2683] = 1309,
  [2684] = 1306,
  [2685] = 1307,
  [2686] = 1333,
  [2687] = 1307,
  [2688] = 1304,
  [2689] = 1346,
  [2690] = 1334,
  [2691] = 1307,
  [2692] = 1308,
  [2693] = 1304,
  [2694] = 1309,
  [2695] = 1307,
  [2696] = 1317,
  [2697] = 1336,
  [2698] = 1334,
  [2699] = 2699,
  [2700] = 2699,
  [2701] = 2701,
  [2702] = 2702,
  [2703] = 2703,
  [2704] = 2699,
  [2705] = 2705,
  [2706] = 2699,
  [2707] = 2707,
  [2708] = 2708,
  [2709] = 2699,
  [2710] = 2699,
  [2711] = 2711,
  [2712] = 2701,
  [2713] = 2702,
  [2714] = 2703,
  [2715] = 2715,
  [2716] = 2705,
  [2717] = 2708,
  [2718] = 2707,
  [2719] = 2708,
  [2720] = 2699,
  [2721] = 2699,
  [2722] = 2699,
  [2723] = 2701,
  [2724] = 2702,
  [2725] = 2703,
  [2726] = 2705,
  [2727] = 2699,
  [2728] = 2699,
  [2729] = 2707,
  [2730] = 2708,
  [2731] = 2731,
  [2732] = 2699,
  [2733] = 2699,
  [2734] = 2701,
  [2735] = 2702,
  [2736] = 2703,
  [2737] = 2699,
  [2738] = 2703,
  [2739] = 2699,
  [2740] = 2707,
  [2741] = 2708,
  [2742] = 2699,
  [2743] = 2699,
  [2744] = 2705,
  [2745] = 2699,
  [2746] = 2705,
  [2747] = 2707,
  [2748] = 2701,
  [2749] = 2702,
  [2750] = 2703,
  [2751] = 2705,
  [2752] = 2705,
  [2753] = 2699,
  [2754] = 2707,
  [2755] = 2708,
  [2756] = 2756,
  [2757] = 2699,
  [2758] = 2705,
  [2759] = 2756,
  [2760] = 2705,
  [2761] = 2705,
  [2762] = 2699,
  [2763] = 2699,
  [2764] = 2705,
  [2765] = 2705,
  [2766] = 2699,
  [2767] = 2705,
  [2768] = 2699,
  [2769] = 2705,
  [2770] = 2699,
  [2771] = 2699,
  [2772] = 2705,
  [2773] = 2699,
  [2774] = 2699,
  [2775] = 2705,
  [2776] = 2699,
  [2777] = 2701,
  [2778] = 2702,
  [2779] = 2703,
  [2780] = 2699,
  [2781] = 2699,
  [2782] = 2699,
  [2783] = 2707,
  [2784] = 2708,
  [2785] = 2699,
  [2786] = 2699,
  [2787] = 2699,
  [2788] = 2756,
  [2789] = 2731,
  [2790] = 2701,
  [2791] = 2702,
  [2792] = 2703,
  [2793] = 2705,
  [2794] = 2705,
  [2795] = 2705,
  [2796] = 2707,
  [2797] = 2708,
  [2798] = 2699,
  [2799] = 2699,
  [2800] = 2699,
  [2801] = 2756,
  [2802] = 2699,
  [2803] = 2701,
  [2804] = 2702,
  [2805] = 2703,
  [2806] = 2699,
  [2807] = 2702,
  [2808] = 2701,
  [2809] = 2707,
  [2810] = 2708,
  [2811] = 2699,
  [2812] = 2699,
  [2813] = 2699,
  [2814] = 2699,
  [2815] = 2701,
  [2816] = 2702,
  [2817] = 2703,
  [2818] = 2818,
  [2819] = 2819,
  [2820] = 2705,
  [2821] = 2707,
  [2822] = 2708,
  [2823] = 2699,
  [2824] = 2699,
  [2825] = 2699,
  [2826] = 2699,
  [2827] = 2701,
  [2828] = 2819,
  [2829] = 2702,
  [2830] = 2705,
  [2831] = 2705,
  [2832] = 2705,
  [2833] = 2819,
  [2834] = 2819,
  [2835] = 2819,
  [2836] = 2819,
  [2837] = 2819,
  [2838] = 2819,
  [2839] = 2819,
  [2840] = 2819,
  [2841] = 2819,
  [2842] = 2819,
  [2843] = 2703,
  [2844] = 2705,
  [2845] = 2699,
  [2846] = 2705,
  [2847] = 2699,
  [2848] = 2705,
  [2849] = 2699,
  [2850] = 2699,
  [2851] = 2699,
  [2852] = 2705,
  [2853] = 2699,
  [2854] = 2705,
  [2855] = 2699,
  [2856] = 2699,
  [2857] = 2699,
  [2858] = 2858,
  [2859] = 2699,
  [2860] = 2699,
  [2861] = 2705,
  [2862] = 2699,
  [2863] = 2699,
  [2864] = 2699,
  [2865] = 2699,
  [2866] = 2699,
  [2867] = 2705,
  [2868] = 2699,
  [2869] = 2705,
  [2870] = 2705,
  [2871] = 2707,
  [2872] = 2708,
  [2873] = 2699,
  [2874] = 2705,
  [2875] = 2699,
  [2876] = 2699,
  [2877] = 2699,
  [2878] = 2705,
  [2879] = 2701,
  [2880] = 2702,
  [2881] = 2703,
  [2882] = 2705,
  [2883] = 2705,
  [2884] = 2705,
  [2885] = 2705,
  [2886] = 2707,
  [2887] = 2708,
  [2888] = 2699,
  [2889] = 2889,
  [2890] = 2890,
  [2891] = 2891,
  [2892] = 2892,
  [2893] = 2893,
  [2894] = 2894,
  [2895] = 2895,
  [2896] = 2896,
  [2897] = 2897,
  [2898] = 2889,
  [2899] = 2899,
  [2900] = 2900,
  [2901] = 2901,
  [2902] = 2902,
  [2903] = 2903,
  [2904] = 2904,
  [2905] = 2905,
  [2906] = 2906,
  [2907] = 2891,
  [2908] = 2893,
  [2909] = 2906,
  [2910] = 2892,
  [2911] = 2894,
  [2912] = 2895,
  [2913] = 2896,
  [2914] = 2897,
  [2915] = 2889,
  [2916] = 2899,
  [2917] = 2900,
  [2918] = 2901,
  [2919] = 2902,
  [2920] = 2903,
  [2921] = 2904,
  [2922] = 2905,
  [2923] = 2890,
  [2924] = 2891,
  [2925] = 2892,
  [2926] = 2893,
  [2927] = 2894,
  [2928] = 2895,
  [2929] = 2890,
  [2930] = 2891,
  [2931] = 2892,
  [2932] = 2893,
  [2933] = 2894,
  [2934] = 2895,
  [2935] = 2896,
  [2936] = 2897,
  [2937] = 2889,
  [2938] = 2899,
  [2939] = 2900,
  [2940] = 2901,
  [2941] = 2902,
  [2942] = 2903,
  [2943] = 2904,
  [2944] = 2905,
  [2945] = 2906,
  [2946] = 2896,
  [2947] = 2897,
  [2948] = 2889,
  [2949] = 2899,
  [2950] = 2900,
  [2951] = 2901,
  [2952] = 2902,
  [2953] = 2903,
  [2954] = 2904,
  [2955] = 2890,
  [2956] = 2891,
  [2957] = 2892,
  [2958] = 2893,
  [2959] = 2894,
  [2960] = 2895,
  [2961] = 2896,
  [2962] = 2897,
  [2963] = 2889,
  [2964] = 2899,
  [2965] = 2900,
  [2966] = 2901,
  [2967] = 2902,
  [2968] = 2903,
  [2969] = 2904,
  [2970] = 2905,
  [2971] = 2906,
  [2972] = 2905,
  [2973] = 2906,
  [2974] = 2900,
  [2975] = 2890,
  [2976] = 2891,
  [2977] = 2892,
  [2978] = 2893,
  [2979] = 2894,
  [2980] = 2895,
  [2981] = 2896,
  [2982] = 2897,
  [2983] = 2889,
  [2984] = 2899,
  [2985] = 2900,
  [2986] = 2901,
  [2987] = 2902,
  [2988] = 2903,
  [2989] = 2904,
  [2990] = 2905,
  [2991] = 2906,
  [2992] = 2901,
  [2993] = 2890,
  [2994] = 2891,
  [2995] = 2892,
  [2996] = 2893,
  [2997] = 2894,
  [2998] = 2895,
  [2999] = 2890,
  [3000] = 2891,
  [3001] = 2892,
  [3002] = 2893,
  [3003] = 2894,
  [3004] = 2895,
  [3005] = 2896,
  [3006] = 2897,
  [3007] = 2889,
  [3008] = 2899,
  [3009] = 2900,
  [3010] = 2901,
  [3011] = 2902,
  [3012] = 2903,
  [3013] = 2904,
  [3014] = 2905,
  [3015] = 2906,
  [3016] = 2896,
  [3017] = 2897,
  [3018] = 2889,
  [3019] = 2899,
  [3020] = 2890,
  [3021] = 2891,
  [3022] = 2892,
  [3023] = 2893,
  [3024] = 2894,
  [3025] = 2895,
  [3026] = 2896,
  [3027] = 2897,
  [3028] = 2889,
  [3029] = 2899,
  [3030] = 2900,
  [3031] = 2901,
  [3032] = 2902,
  [3033] = 2903,
  [3034] = 2904,
  [3035] = 2905,
  [3036] = 2906,
  [3037] = 2900,
  [3038] = 2901,
  [3039] = 2890,
  [3040] = 2891,
  [3041] = 2892,
  [3042] = 2893,
  [3043] = 2894,
  [3044] = 2895,
  [3045] = 2896,
  [3046] = 2897,
  [3047] = 2889,
  [3048] = 2899,
  [3049] = 2900,
  [3050] = 2901,
  [3051] = 2902,
  [3052] = 2903,
  [3053] = 2904,
  [3054] = 2905,
  [3055] = 2906,
  [3056] = 2902,
  [3057] = 2903,
  [3058] = 2890,
  [3059] = 2891,
  [3060] = 2890,
  [3061] = 2891,
  [3062] = 2892,
  [3063] = 2893,
  [3064] = 2894,
  [3065] = 2895,
  [3066] = 2896,
  [3067] = 2897,
  [3068] = 2889,
  [3069] = 2899,
  [3070] = 2900,
  [3071] = 2901,
  [3072] = 2902,
  [3073] = 2903,
  [3074] = 2904,
  [3075] = 2905,
  [3076] = 2906,
  [3077] = 2892,
  [3078] = 2893,
  [3079] = 2894,
  [3080] = 2895,
  [3081] = 2896,
  [3082] = 2897,
  [3083] = 2889,
  [3084] = 2899,
  [3085] = 2900,
  [3086] = 2890,
  [3087] = 2891,
  [3088] = 2892,
  [3089] = 2893,
  [3090] = 2894,
  [3091] = 2895,
  [3092] = 2896,
  [3093] = 2897,
  [3094] = 2889,
  [3095] = 2899,
  [3096] = 2900,
  [3097] = 2901,
  [3098] = 2902,
  [3099] = 2903,
  [3100] = 2904,
  [3101] = 2905,
  [3102] = 2906,
  [3103] = 2901,
  [3104] = 2902,
  [3105] = 2903,
  [3106] = 2904,
  [3107] = 2905,
  [3108] = 2906,
  [3109] = 2904,
  [3110] = 2905,
  [3111] = 2890,
  [3112] = 2891,
  [3113] = 2892,
  [3114] = 2893,
  [3115] = 2894,
  [3116] = 2895,
  [3117] = 2896,
  [3118] = 2897,
  [3119] = 2889,
  [3120] = 2899,
  [3121] = 2900,
  [3122] = 2901,
  [3123] = 2902,
  [3124] = 2903,
  [3125] = 2904,
  [3126] = 2905,
  [3127] = 2906,
  [3128] = 2906,
  [3129] = 2902,
  [3130] = 2890,
  [3131] = 2891,
  [3132] = 2892,
  [3133] = 2893,
  [3134] = 2894,
  [3135] = 2895,
  [3136] = 2896,
  [3137] = 2897,
  [3138] = 2889,
  [3139] = 2899,
  [3140] = 2900,
  [3141] = 2901,
  [3142] = 2902,
  [3143] = 2903,
  [3144] = 2904,
  [3145] = 2905,
  [3146] = 2906,
  [3147] = 2903,
  [3148] = 2890,
  [3149] = 2891,
  [3150] = 2892,
  [3151] = 2893,
  [3152] = 2894,
  [3153] = 2895,
  [3154] = 2896,
  [3155] = 2897,
  [3156] = 2889,
  [3157] = 2899,
  [3158] = 2900,
  [3159] = 2901,
  [3160] = 2902,
  [3161] = 2903,
  [3162] = 2904,
  [3163] = 2905,
  [3164] = 2906,
  [3165] = 2890,
  [3166] = 2891,
  [3167] = 2892,
  [3168] = 2893,
  [3169] = 2894,
  [3170] = 2895,
  [3171] = 2896,
  [3172] = 2897,
  [3173] = 2889,
  [3174] = 2899,
  [3175] = 2900,
  [3176] = 2901,
  [3177] = 2902,
  [3178] = 2903,
  [3179] = 2904,
  [3180] = 2905,
  [3181] = 2906,
  [3182] = 2890,
  [3183] = 2891,
  [3184] = 2892,
  [3185] = 2893,
  [3186] = 2896,
  [3187] = 2897,
  [3188] = 2906,
  [3189] = 2904,
  [3190] = 2891,
  [3191] = 2892,
  [3192] = 2893,
  [3193] = 2894,
  [3194] = 2895,
  [3195] = 2896,
  [3196] = 2897,
  [3197] = 2889,
  [3198] = 2899,
  [3199] = 2900,
  [3200] = 2901,
  [3201] = 2902,
  [3202] = 2903,
  [3203] = 2904,
  [3204] = 2905,
  [3205] = 2906,
  [3206] = 2905,
  [3207] = 2906,
  [3208] = 3208,
  [3209] = 3209,
  [3210] = 3210,
  [3211] = 3211,
  [3212] = 3212,
  [3213] = 3213,
  [3214] = 2890,
  [3215] = 2891,
  [3216] = 2890,
  [3217] = 2891,
  [3218] = 2892,
  [3219] = 2893,
  [3220] = 2894,
  [3221] = 2895,
  [3222] = 2896,
  [3223] = 2897,
  [3224] = 2889,
  [3225] = 2899,
  [3226] = 2900,
  [3227] = 2901,
  [3228] = 2902,
  [3229] = 2903,
  [3230] = 2904,
  [3231] = 2905,
  [3232] = 2906,
  [3233] = 2891,
  [3234] = 2892,
  [3235] = 2893,
  [3236] = 2894,
  [3237] = 2895,
  [3238] = 2896,
  [3239] = 2897,
  [3240] = 2889,
  [3241] = 2899,
  [3242] = 2900,
  [3243] = 2901,
  [3244] = 2902,
  [3245] = 2903,
  [3246] = 2904,
  [3247] = 2905,
  [3248] = 2906,
  [3249] = 2892,
  [3250] = 2893,
  [3251] = 2891,
  [3252] = 2893,
  [3253] = 2906,
  [3254] = 3213,
  [3255] = 2894,
  [3256] = 2890,
  [3257] = 2891,
  [3258] = 2892,
  [3259] = 2894,
  [3260] = 2895,
  [3261] = 2896,
  [3262] = 2897,
  [3263] = 2889,
  [3264] = 2899,
  [3265] = 2900,
  [3266] = 2901,
  [3267] = 2902,
  [3268] = 2903,
  [3269] = 2904,
  [3270] = 2905,
  [3271] = 2906,
  [3272] = 3208,
  [3273] = 3273,
  [3274] = 2891,
  [3275] = 2892,
  [3276] = 2893,
  [3277] = 2894,
  [3278] = 2895,
  [3279] = 2896,
  [3280] = 2897,
  [3281] = 2889,
  [3282] = 2899,
  [3283] = 2900,
  [3284] = 2901,
  [3285] = 2902,
  [3286] = 2903,
  [3287] = 2904,
  [3288] = 2905,
  [3289] = 2906,
  [3290] = 2891,
  [3291] = 2892,
  [3292] = 2893,
  [3293] = 2894,
  [3294] = 2895,
  [3295] = 2896,
  [3296] = 2897,
  [3297] = 2889,
  [3298] = 2899,
  [3299] = 2900,
  [3300] = 2901,
  [3301] = 2902,
  [3302] = 2903,
  [3303] = 2904,
  [3304] = 2905,
  [3305] = 2906,
  [3306] = 2895,
  [3307] = 2891,
  [3308] = 2892,
  [3309] = 2893,
  [3310] = 2896,
  [3311] = 2897,
  [3312] = 2906,
  [3313] = 3208,
  [3314] = 2891,
  [3315] = 2892,
  [3316] = 2893,
  [3317] = 2896,
  [3318] = 2897,
  [3319] = 2906,
  [3320] = 2890,
  [3321] = 2891,
  [3322] = 2892,
  [3323] = 2893,
  [3324] = 2894,
  [3325] = 2895,
  [3326] = 2896,
  [3327] = 2897,
  [3328] = 2889,
  [3329] = 2899,
  [3330] = 2900,
  [3331] = 2891,
  [3332] = 2893,
  [3333] = 2894,
  [3334] = 2895,
  [3335] = 2889,
  [3336] = 2899,
  [3337] = 2900,
  [3338] = 2901,
  [3339] = 2902,
  [3340] = 2903,
  [3341] = 2904,
  [3342] = 2905,
  [3343] = 2906,
  [3344] = 2901,
  [3345] = 2902,
  [3346] = 2903,
  [3347] = 2904,
  [3348] = 2905,
  [3349] = 2906,
  [3350] = 3350,
  [3351] = 2896,
  [3352] = 2891,
  [3353] = 2892,
  [3354] = 2893,
  [3355] = 2894,
  [3356] = 2895,
  [3357] = 2896,
  [3358] = 2897,
  [3359] = 2889,
  [3360] = 2899,
  [3361] = 2900,
  [3362] = 2901,
  [3363] = 2902,
  [3364] = 2903,
  [3365] = 2904,
  [3366] = 2905,
  [3367] = 2906,
  [3368] = 2891,
  [3369] = 2892,
  [3370] = 2893,
  [3371] = 2894,
  [3372] = 2895,
  [3373] = 2896,
  [3374] = 2897,
  [3375] = 2889,
  [3376] = 2899,
  [3377] = 2900,
  [3378] = 2901,
  [3379] = 2902,
  [3380] = 2903,
  [3381] = 2904,
  [3382] = 2905,
  [3383] = 2906,
  [3384] = 3384,
  [3385] = 2891,
  [3386] = 2892,
  [3387] = 2893,
  [3388] = 2894,
  [3389] = 2895,
  [3390] = 2896,
  [3391] = 2897,
  [3392] = 2889,
  [3393] = 2899,
  [3394] = 2900,
  [3395] = 2901,
  [3396] = 2902,
  [3397] = 2903,
  [3398] = 2904,
  [3399] = 2905,
  [3400] = 2906,
  [3401] = 2891,
  [3402] = 2892,
  [3403] = 2893,
  [3404] = 2894,
  [3405] = 2895,
  [3406] = 2896,
  [3407] = 2897,
  [3408] = 2889,
  [3409] = 2899,
  [3410] = 2900,
  [3411] = 2901,
  [3412] = 2902,
  [3413] = 2903,
  [3414] = 2904,
  [3415] = 2905,
  [3416] = 2906,
  [3417] = 2897,
  [3418] = 2891,
  [3419] = 2892,
  [3420] = 2893,
  [3421] = 2894,
  [3422] = 2895,
  [3423] = 2896,
  [3424] = 2897,
  [3425] = 2889,
  [3426] = 2899,
  [3427] = 2900,
  [3428] = 2901,
  [3429] = 2902,
  [3430] = 2903,
  [3431] = 2904,
  [3432] = 2905,
  [3433] = 2906,
  [3434] = 2890,
  [3435] = 2891,
  [3436] = 2892,
  [3437] = 2893,
  [3438] = 2894,
  [3439] = 2895,
  [3440] = 2896,
  [3441] = 2897,
  [3442] = 2891,
  [3443] = 2892,
  [3444] = 2893,
  [3445] = 2894,
  [3446] = 2895,
  [3447] = 2896,
  [3448] = 2897,
  [3449] = 2889,
  [3450] = 2899,
  [3451] = 2900,
  [3452] = 2901,
  [3453] = 2902,
  [3454] = 2903,
  [3455] = 2904,
  [3456] = 2905,
  [3457] = 2906,
  [3458] = 2889,
  [3459] = 2899,
  [3460] = 2900,
  [3461] = 2901,
  [3462] = 2902,
  [3463] = 2903,
  [3464] = 2904,
  [3465] = 2905,
  [3466] = 2891,
  [3467] = 2892,
  [3468] = 2893,
  [3469] = 2894,
  [3470] = 2895,
  [3471] = 2896,
  [3472] = 2897,
  [3473] = 2889,
  [3474] = 2899,
  [3475] = 2900,
  [3476] = 2901,
  [3477] = 2902,
  [3478] = 2903,
  [3479] = 2904,
  [3480] = 2905,
  [3481] = 2906,
  [3482] = 2906,
  [3483] = 3213,
  [3484] = 2891,
  [3485] = 2892,
  [3486] = 2893,
  [3487] = 2894,
  [3488] = 2895,
  [3489] = 2896,
  [3490] = 2897,
  [3491] = 2889,
  [3492] = 2899,
  [3493] = 2900,
  [3494] = 2901,
  [3495] = 2902,
  [3496] = 2903,
  [3497] = 2904,
  [3498] = 2905,
  [3499] = 2906,
  [3500] = 3384,
  [3501] = 2892,
  [3502] = 2894,
  [3503] = 2895,
  [3504] = 2896,
  [3505] = 2897,
  [3506] = 2889,
  [3507] = 2899,
  [3508] = 2900,
  [3509] = 2901,
  [3510] = 2902,
  [3511] = 2903,
  [3512] = 2904,
  [3513] = 2905,
  [3514] = 2891,
  [3515] = 2893,
  [3516] = 2906,
  [3517] = 2891,
  [3518] = 2892,
  [3519] = 2893,
  [3520] = 2894,
  [3521] = 2895,
  [3522] = 2896,
  [3523] = 2897,
  [3524] = 2889,
  [3525] = 2899,
  [3526] = 2900,
  [3527] = 2901,
  [3528] = 2902,
  [3529] = 2903,
  [3530] = 2904,
  [3531] = 2905,
  [3532] = 2906,
  [3533] = 2889,
  [3534] = 2891,
  [3535] = 2892,
  [3536] = 2893,
  [3537] = 2894,
  [3538] = 2895,
  [3539] = 2896,
  [3540] = 2897,
  [3541] = 2889,
  [3542] = 2899,
  [3543] = 2900,
  [3544] = 2901,
  [3545] = 2902,
  [3546] = 2903,
  [3547] = 2893,
  [3548] = 2904,
  [3549] = 2905,
  [3550] = 3209,
  [3551] = 2906,
  [3552] = 3210,
  [3553] = 2894,
  [3554] = 2895,
  [3555] = 2889,
  [3556] = 2892,
  [3557] = 2894,
  [3558] = 2895,
  [3559] = 2896,
  [3560] = 2897,
  [3561] = 2889,
  [3562] = 2899,
  [3563] = 2900,
  [3564] = 2901,
  [3565] = 2902,
  [3566] = 2903,
  [3567] = 2904,
  [3568] = 2905,
  [3569] = 2899,
  [3570] = 2890,
  [3571] = 2893,
  [3572] = 2894,
  [3573] = 2895,
  [3574] = 2889,
  [3575] = 2899,
  [3576] = 2900,
  [3577] = 2901,
  [3578] = 2902,
  [3579] = 2903,
  [3580] = 2904,
  [3581] = 2905,
  [3582] = 2894,
  [3583] = 2895,
  [3584] = 2889,
  [3585] = 2899,
  [3586] = 2900,
  [3587] = 2901,
  [3588] = 2902,
  [3589] = 2903,
  [3590] = 2904,
  [3591] = 2905,
  [3592] = 2892,
  [3593] = 2896,
  [3594] = 2897,
  [3595] = 2900,
  [3596] = 2891,
  [3597] = 2893,
  [3598] = 2906,
  [3599] = 2892,
  [3600] = 2894,
  [3601] = 2895,
  [3602] = 2896,
  [3603] = 2897,
  [3604] = 2889,
  [3605] = 2899,
  [3606] = 2900,
  [3607] = 2901,
  [3608] = 2902,
  [3609] = 2903,
  [3610] = 2904,
  [3611] = 2905,
  [3612] = 2901,
  [3613] = 2891,
  [3614] = 2892,
  [3615] = 2893,
  [3616] = 2894,
  [3617] = 2895,
  [3618] = 2896,
  [3619] = 2897,
  [3620] = 2889,
  [3621] = 2899,
  [3622] = 2900,
  [3623] = 2901,
  [3624] = 2902,
  [3625] = 2903,
  [3626] = 2904,
  [3627] = 2905,
  [3628] = 2906,
  [3629] = 2902,
  [3630] = 2891,
  [3631] = 2892,
  [3632] = 2893,
  [3633] = 2896,
  [3634] = 2897,
  [3635] = 2906,
  [3636] = 2903,
  [3637] = 2904,
  [3638] = 2905,
  [3639] = 2891,
  [3640] = 2893,
  [3641] = 2906,
  [3642] = 2890,
  [3643] = 2892,
  [3644] = 2894,
  [3645] = 2895,
  [3646] = 2896,
  [3647] = 2897,
  [3648] = 2889,
  [3649] = 2899,
  [3650] = 2900,
  [3651] = 2901,
  [3652] = 2902,
  [3653] = 2903,
  [3654] = 2904,
  [3655] = 2905,
  [3656] = 2891,
  [3657] = 2894,
  [3658] = 2895,
  [3659] = 2889,
  [3660] = 2899,
  [3661] = 2900,
  [3662] = 2901,
  [3663] = 2902,
  [3664] = 2903,
  [3665] = 2904,
  [3666] = 2905,
  [3667] = 2891,
  [3668] = 2892,
  [3669] = 2893,
  [3670] = 2896,
  [3671] = 2897,
  [3672] = 3212,
  [3673] = 2906,
  [3674] = 2892,
  [3675] = 3209,
  [3676] = 2893,
  [3677] = 2894,
  [3678] = 2895,
  [3679] = 2896,
  [3680] = 2897,
  [3681] = 2889,
  [3682] = 2899,
  [3683] = 2900,
  [3684] = 2901,
  [3685] = 2902,
  [3686] = 2903,
  [3687] = 3212,
  [3688] = 2904,
  [3689] = 2905,
  [3690] = 3209,
  [3691] = 2906,
  [3692] = 3212,
  [3693] = 3209,
  [3694] = 3212,
  [3695] = 3209,
  [3696] = 3212,
  [3697] = 3209,
  [3698] = 3212,
  [3699] = 3209,
  [3700] = 3212,
  [3701] = 2890,
  [3702] = 2891,
  [3703] = 3209,
  [3704] = 2892,
  [3705] = 2893,
  [3706] = 2894,
  [3707] = 2895,
  [3708] = 2896,
  [3709] = 2897,
  [3710] = 2891,
  [3711] = 2893,
  [3712] = 2906,
  [3713] = 3212,
  [3714] = 2889,
  [3715] = 2899,
  [3716] = 3209,
  [3717] = 2900,
  [3718] = 2901,
  [3719] = 2902,
  [3720] = 2903,
  [3721] = 2892,
  [3722] = 2894,
  [3723] = 2895,
  [3724] = 2896,
  [3725] = 2897,
  [3726] = 3212,
  [3727] = 2889,
  [3728] = 2899,
  [3729] = 3209,
  [3730] = 2900,
  [3731] = 2901,
  [3732] = 2902,
  [3733] = 2903,
  [3734] = 2904,
  [3735] = 2905,
  [3736] = 2904,
  [3737] = 2905,
  [3738] = 2906,
  [3739] = 3212,
  [3740] = 3209,
  [3741] = 2894,
  [3742] = 2895,
  [3743] = 2889,
  [3744] = 2899,
  [3745] = 2900,
  [3746] = 2901,
  [3747] = 2902,
  [3748] = 2903,
  [3749] = 2904,
  [3750] = 2905,
  [3751] = 2890,
  [3752] = 2891,
  [3753] = 2892,
  [3754] = 2893,
  [3755] = 2894,
  [3756] = 2895,
  [3757] = 2896,
  [3758] = 2897,
  [3759] = 2889,
  [3760] = 2899,
  [3761] = 2900,
  [3762] = 2901,
  [3763] = 2902,
  [3764] = 2903,
  [3765] = 2904,
  [3766] = 2905,
  [3767] = 2906,
  [3768] = 2899,
  [3769] = 3210,
  [3770] = 2894,
  [3771] = 2894,
  [3772] = 2894,
  [3773] = 2894,
  [3774] = 3211,
  [3775] = 3211,
  [3776] = 3384,
  [3777] = 2894,
  [3778] = 2906,
  [3779] = 2892,
  [3780] = 2894,
  [3781] = 2895,
  [3782] = 2896,
  [3783] = 2897,
  [3784] = 2889,
  [3785] = 2899,
  [3786] = 2900,
  [3787] = 2901,
  [3788] = 2902,
  [3789] = 2903,
  [3790] = 2904,
  [3791] = 2905,
  [3792] = 2906,
  [3793] = 2891,
  [3794] = 2894,
  [3795] = 2906,
  [3796] = 2893,
  [3797] = 2894,
  [3798] = 2906,
  [3799] = 2906,
  [3800] = 2894,
  [3801] = 2906,
  [3802] = 2894,
  [3803] = 2906,
  [3804] = 2894,
  [3805] = 2906,
  [3806] = 2906,
  [3807] = 2892,
  [3808] = 2906,
  [3809] = 2894,
  [3810] = 2892,
  [3811] = 2894,
  [3812] = 2895,
  [3813] = 2896,
  [3814] = 2897,
  [3815] = 2895,
  [3816] = 2899,
  [3817] = 2900,
  [3818] = 2901,
  [3819] = 2902,
  [3820] = 2903,
  [3821] = 2904,
  [3822] = 2905,
  [3823] = 2906,
  [3824] = 2896,
  [3825] = 2894,
  [3826] = 2895,
  [3827] = 2889,
  [3828] = 2899,
  [3829] = 2900,
  [3830] = 2901,
  [3831] = 2902,
  [3832] = 2903,
  [3833] = 2904,
  [3834] = 2905,
  [3835] = 2906,
  [3836] = 2897,
  [3837] = 2889,
  [3838] = 2891,
  [3839] = 2892,
  [3840] = 2893,
  [3841] = 2896,
  [3842] = 2897,
  [3843] = 2906,
  [3844] = 2899,
  [3845] = 2906,
  [3846] = 2900,
  [3847] = 2906,
  [3848] = 2901,
  [3849] = 2902,
  [3850] = 2903,
  [3851] = 2894,
  [3852] = 2904,
  [3853] = 2906,
  [3854] = 2905,
  [3855] = 2892,
  [3856] = 2894,
  [3857] = 2895,
  [3858] = 2896,
  [3859] = 2897,
  [3860] = 2889,
  [3861] = 2899,
  [3862] = 2900,
  [3863] = 2901,
  [3864] = 2902,
  [3865] = 2903,
  [3866] = 2904,
  [3867] = 2905,
  [3868] = 2893,
  [3869] = 2895,
  [3870] = 2889,
  [3871] = 2899,
  [3872] = 2900,
  [3873] = 2901,
  [3874] = 2902,
  [3875] = 2903,
  [3876] = 2904,
  [3877] = 2905,
  [3878] = 2894,
  [3879] = 2895,
  [3880] = 2889,
  [3881] = 2899,
  [3882] = 2900,
  [3883] = 2901,
  [3884] = 2902,
  [3885] = 2903,
  [3886] = 2904,
  [3887] = 2905,
  [3888] = 2892,
  [3889] = 2896,
  [3890] = 2897,
  [3891] = 2891,
  [3892] = 2892,
  [3893] = 2893,
  [3894] = 2894,
  [3895] = 2895,
  [3896] = 2896,
  [3897] = 2897,
  [3898] = 2889,
  [3899] = 2899,
  [3900] = 2900,
  [3901] = 2901,
  [3902] = 2902,
  [3903] = 2903,
  [3904] = 2904,
  [3905] = 2905,
  [3906] = 2906,
  [3907] = 2891,
  [3908] = 2892,
  [3909] = 2893,
  [3910] = 2896,
  [3911] = 2897,
  [3912] = 2906,
  [3913] = 2906,
  [3914] = 2892,
  [3915] = 2894,
  [3916] = 2895,
  [3917] = 2896,
  [3918] = 2897,
  [3919] = 2889,
  [3920] = 2899,
  [3921] = 2900,
  [3922] = 2901,
  [3923] = 2902,
  [3924] = 2903,
  [3925] = 2904,
  [3926] = 2905,
  [3927] = 2895,
  [3928] = 2889,
  [3929] = 2899,
  [3930] = 2900,
  [3931] = 2901,
  [3932] = 2902,
  [3933] = 2903,
  [3934] = 2904,
  [3935] = 2905,
  [3936] = 2891,
  [3937] = 2892,
  [3938] = 2893,
  [3939] = 2895,
  [3940] = 2896,
  [3941] = 2897,
  [3942] = 2889,
  [3943] = 2899,
  [3944] = 2900,
  [3945] = 2901,
  [3946] = 2902,
  [3947] = 2903,
  [3948] = 2904,
  [3949] = 2905,
  [3950] = 2891,
  [3951] = 2893,
  [3952] = 2892,
  [3953] = 2893,
  [3954] = 2896,
  [3955] = 2897,
  [3956] = 2891,
  [3957] = 2895,
  [3958] = 2889,
  [3959] = 2899,
  [3960] = 2900,
  [3961] = 2901,
  [3962] = 2902,
  [3963] = 2903,
  [3964] = 2904,
  [3965] = 2905,
  [3966] = 2891,
  [3967] = 2892,
  [3968] = 2893,
  [3969] = 2895,
  [3970] = 2896,
  [3971] = 2897,
  [3972] = 2889,
  [3973] = 2899,
  [3974] = 2900,
  [3975] = 2901,
  [3976] = 2902,
  [3977] = 2903,
  [3978] = 2904,
  [3979] = 2905,
  [3980] = 2891,
  [3981] = 2892,
  [3982] = 2893,
  [3983] = 2895,
  [3984] = 2896,
  [3985] = 2897,
  [3986] = 2889,
  [3987] = 2899,
  [3988] = 2900,
  [3989] = 2901,
  [3990] = 2902,
  [3991] = 2903,
  [3992] = 2904,
  [3993] = 2905,
  [3994] = 2892,
  [3995] = 2896,
  [3996] = 2897,
  [3997] = 2895,
  [3998] = 2889,
  [3999] = 2899,
  [4000] = 2900,
  [4001] = 2901,
  [4002] = 2902,
  [4003] = 2903,
  [4004] = 2904,
  [4005] = 2905,
  [4006] = 2891,
  [4007] = 2893,
  [4008] = 2891,
  [4009] = 2892,
  [4010] = 2893,
  [4011] = 2895,
  [4012] = 2896,
  [4013] = 2897,
  [4014] = 2889,
  [4015] = 2899,
  [4016] = 2900,
  [4017] = 2901,
  [4018] = 2902,
  [4019] = 2903,
  [4020] = 2904,
  [4021] = 2905,
  [4022] = 2891,
  [4023] = 2892,
  [4024] = 2893,
  [4025] = 2896,
  [4026] = 2897,
  [4027] = 2891,
  [4028] = 2893,
  [4029] = 2891,
  [4030] = 2892,
  [4031] = 2893,
  [4032] = 2896,
  [4033] = 2897,
  [4034] = 2891,
  [4035] = 2891,
  [4036] = 2892,
  [4037] = 2893,
  [4038] = 2896,
  [4039] = 2897,
  [4040] = 2895,
  [4041] = 2889,
  [4042] = 2899,
  [4043] = 2900,
  [4044] = 2901,
  [4045] = 2902,
  [4046] = 2903,
  [4047] = 2904,
  [4048] = 2905,
  [4049] = 2891,
  [4050] = 2893,
  [4051] = 2892,
  [4052] = 2895,
  [4053] = 2896,
  [4054] = 2897,
  [4055] = 2889,
  [4056] = 2899,
  [4057] = 2900,
  [4058] = 2901,
  [4059] = 2902,
  [4060] = 2903,
  [4061] = 2904,
  [4062] = 2905,
  [4063] = 2895,
  [4064] = 2889,
  [4065] = 2899,
  [4066] = 2900,
  [4067] = 2901,
  [4068] = 2902,
  [4069] = 2903,
  [4070] = 2904,
  [4071] = 2905,
  [4072] = 2891,
  [4073] = 2893,
  [4074] = 2891,
  [4075] = 3212,
  [4076] = 4076,
  [4077] = 4076,
  [4078] = 4076,
  [4079] = 4076,
  [4080] = 4076,
  [4081] = 4076,
  [4082] = 4076,
  [4083] = 4076,
  [4084] = 4076,
  [4085] = 4076,
  [4086] = 4086,
  [4087] = 4086,
  [4088] = 4086,
  [4089] = 4086,
  [4090] = 4086,
  [4091] = 4086,
  [4092] = 4086,
  [4093] = 4086,
  [4094] = 4086,
  [4095] = 4095,
  [4096] = 4095,
  [4097] = 4095,
  [4098] = 4095,
  [4099] = 4095,
  [4100] = 4095,
  [4101] = 4095,
  [4102] = 4095,
  [4103] = 4095,
  [4104] = 4104,
  [4105] = 4105,
  [4106] = 4105,
  [4107] = 4104,
  [4108] = 4104,
  [4109] = 4104,
  [4110] = 4104,
  [4111] = 4105,
  [4112] = 4112,
  [4113] = 4104,
  [4114] = 4104,
  [4115] = 4104,
  [4116] = 4105,
  [4117] = 4105,
  [4118] = 4118,
  [4119] = 4104,
  [4120] = 4104,
  [4121] = 4104,
  [4122] = 4105,
  [4123] = 4123,
  [4124] = 4124,
  [4125] = 4125,
  [4126] = 4112,
  [4127] = 4125,
  [4128] = 4105,
  [4129] = 4129,
  [4130] = 4129,
  [4131] = 4131,
  [4132] = 4105,
  [4133] = 4123,
  [4134] = 4104,
  [4135] = 4104,
  [4136] = 4124,
  [4137] = 4104,
  [4138] = 4131,
  [4139] = 4105,
  [4140] = 4118,
  [4141] = 4131,
  [4142] = 4142,
  [4143] = 4112,
  [4144] = 4144,
  [4145] = 4145,
  [4146] = 4146,
  [4147] = 4147,
  [4148] = 4118,
  [4149] = 4125,
  [4150] = 4129,
  [4151] = 4151,
  [4152] = 4152,
  [4153] = 4153,
  [4154] = 4154,
  [4155] = 4123,
  [4156] = 4156,
  [4157] = 4112,
  [4158] = 4131,
  [4159] = 4159,
  [4160] = 4160,
  [4161] = 4161,
  [4162] = 4124,
  [4163] = 4118,
  [4164] = 4164,
  [4165] = 4165,
  [4166] = 4125,
  [4167] = 4129,
  [4168] = 4104,
  [4169] = 4123,
  [4170] = 4124,
  [4171] = 4171,
  [4172] = 4171,
  [4173] = 4173,
  [4174] = 4174,
  [4175] = 4175,
  [4176] = 4173,
  [4177] = 4174,
  [4178] = 4175,
  [4179] = 4179,
  [4180] = 4180,
  [4181] = 4181,
  [4182] = 4182,
  [4183] = 4183,
  [4184] = 4184,
  [4185] = 4179,
  [4186] = 4180,
  [4187] = 4181,
  [4188] = 4182,
  [4189] = 4183,
  [4190] = 4190,
  [4191] = 4184,
  [4192] = 4192,
  [4193] = 4153,
  [4194] = 4190,
  [4195] = 4131,
  [4196] = 4156,
  [4197] = 4112,
  [4198] = 4104,
  [4199] = 4192,
  [4200] = 4190,
  [4201] = 4118,
  [4202] = 4125,
  [4203] = 4129,
  [4204] = 4123,
  [4205] = 4124,
  [4206] = 4118,
  [4207] = 4125,
  [4208] = 4129,
  [4209] = 4123,
  [4210] = 4124,
  [4211] = 4190,
  [4212] = 4112,
  [4213] = 4104,
  [4214] = 4192,
  [4215] = 4146,
  [4216] = 4147,
  [4217] = 4154,
  [4218] = 4142,
  [4219] = 4112,
  [4220] = 4131,
  [4221] = 4105,
  [4222] = 4145,
  [4223] = 4118,
  [4224] = 4125,
  [4225] = 4129,
  [4226] = 4151,
  [4227] = 4192,
  [4228] = 4105,
  [4229] = 4123,
  [4230] = 4104,
  [4231] = 4159,
  [4232] = 4160,
  [4233] = 4164,
  [4234] = 4165,
  [4235] = 4144,
  [4236] = 4161,
  [4237] = 4131,
  [4238] = 4105,
  [4239] = 4105,
  [4240] = 4124,
  [4241] = 4105,
  [4242] = 4105,
  [4243] = 4152,
  [4244] = 4076,
  [4245] = 4245,
  [4246] = 4156,
  [4247] = 4142,
  [4248] = 4248,
  [4249] = 4249,
  [4250] = 4250,
  [4251] = 4144,
  [4252] = 4252,
  [4253] = 4145,
  [4254] = 4146,
  [4255] = 4125,
  [4256] = 4129,
  [4257] = 4190,
  [4258] = 4192,
  [4259] = 4173,
  [4260] = 4260,
  [4261] = 4171,
  [4262] = 4173,
  [4263] = 4156,
  [4264] = 4142,
  [4265] = 4265,
  [4266] = 4174,
  [4267] = 4175,
  [4268] = 4268,
  [4269] = 4179,
  [4270] = 4180,
  [4271] = 4181,
  [4272] = 4182,
  [4273] = 4183,
  [4274] = 4184,
  [4275] = 4275,
  [4276] = 4190,
  [4277] = 4147,
  [4278] = 4174,
  [4279] = 4151,
  [4280] = 4175,
  [4281] = 4161,
  [4282] = 4179,
  [4283] = 4161,
  [4284] = 4180,
  [4285] = 4181,
  [4286] = 4182,
  [4287] = 4183,
  [4288] = 4184,
  [4289] = 4289,
  [4290] = 4290,
  [4291] = 4291,
  [4292] = 4292,
  [4293] = 4293,
  [4294] = 4252,
  [4295] = 4295,
  [4296] = 4171,
  [4297] = 4145,
  [4298] = 4146,
  [4299] = 4147,
  [4300] = 4300,
  [4301] = 4301,
  [4302] = 4302,
  [4303] = 4173,
  [4304] = 4174,
  [4305] = 4151,
  [4306] = 4175,
  [4307] = 4154,
  [4308] = 4308,
  [4309] = 4309,
  [4310] = 4179,
  [4311] = 4161,
  [4312] = 4180,
  [4313] = 4181,
  [4314] = 4182,
  [4315] = 4183,
  [4316] = 4184,
  [4317] = 4291,
  [4318] = 4190,
  [4319] = 4293,
  [4320] = 4320,
  [4321] = 4321,
  [4322] = 4322,
  [4323] = 4156,
  [4324] = 4324,
  [4325] = 4325,
  [4326] = 4326,
  [4327] = 4327,
  [4328] = 4249,
  [4329] = 4250,
  [4330] = 4300,
  [4331] = 4301,
  [4332] = 4324,
  [4333] = 4142,
  [4334] = 4289,
  [4335] = 4153,
  [4336] = 4192,
  [4337] = 4104,
  [4338] = 4338,
  [4339] = 4339,
  [4340] = 4340,
  [4341] = 4341,
  [4342] = 4342,
  [4343] = 4338,
  [4344] = 4344,
  [4345] = 4345,
  [4346] = 4346,
  [4347] = 4347,
  [4348] = 4348,
  [4349] = 4245,
  [4350] = 4350,
  [4351] = 4351,
  [4352] = 4292,
  [4353] = 4353,
  [4354] = 4354,
  [4355] = 4355,
  [4356] = 4356,
  [4357] = 4144,
  [4358] = 4159,
  [4359] = 4359,
  [4360] = 4339,
  [4361] = 4156,
  [4362] = 4160,
  [4363] = 4164,
  [4364] = 4165,
  [4365] = 4105,
  [4366] = 4152,
  [4367] = 4260,
  [4368] = 4153,
  [4369] = 4369,
  [4370] = 4192,
  [4371] = 4192,
  [4372] = 4171,
  [4373] = 4173,
  [4374] = 4174,
  [4375] = 4175,
  [4376] = 4179,
  [4377] = 4180,
  [4378] = 4181,
  [4379] = 4123,
  [4380] = 4145,
  [4381] = 4146,
  [4382] = 4147,
  [4383] = 4268,
  [4384] = 4182,
  [4385] = 4183,
  [4386] = 4275,
  [4387] = 4156,
  [4388] = 4151,
  [4389] = 4154,
  [4390] = 4152,
  [4391] = 4184,
  [4392] = 4142,
  [4393] = 4192,
  [4394] = 4160,
  [4395] = 4161,
  [4396] = 4153,
  [4397] = 4152,
  [4398] = 4164,
  [4399] = 4165,
  [4400] = 4290,
  [4401] = 4153,
  [4402] = 4142,
  [4403] = 4359,
  [4404] = 4325,
  [4405] = 4322,
  [4406] = 4131,
  [4407] = 4124,
  [4408] = 4104,
  [4409] = 4145,
  [4410] = 4151,
  [4411] = 4154,
  [4412] = 4151,
  [4413] = 4104,
  [4414] = 4161,
  [4415] = 4190,
  [4416] = 4146,
  [4417] = 4171,
  [4418] = 4144,
  [4419] = 4190,
  [4420] = 4192,
  [4421] = 4145,
  [4422] = 4265,
  [4423] = 4326,
  [4424] = 4171,
  [4425] = 4425,
  [4426] = 4146,
  [4427] = 4147,
  [4428] = 4147,
  [4429] = 4118,
  [4430] = 4430,
  [4431] = 4190,
  [4432] = 4173,
  [4433] = 4190,
  [4434] = 4174,
  [4435] = 4435,
  [4436] = 4192,
  [4437] = 4175,
  [4438] = 4112,
  [4439] = 4302,
  [4440] = 4308,
  [4441] = 4309,
  [4442] = 4154,
  [4443] = 4154,
  [4444] = 4152,
  [4445] = 4192,
  [4446] = 4446,
  [4447] = 4447,
  [4448] = 4190,
  [4449] = 4104,
  [4450] = 4156,
  [4451] = 4179,
  [4452] = 4340,
  [4453] = 4453,
  [4454] = 4104,
  [4455] = 4327,
  [4456] = 4159,
  [4457] = 4160,
  [4458] = 4458,
  [4459] = 4459,
  [4460] = 4248,
  [4461] = 4159,
  [4462] = 4160,
  [4463] = 4164,
  [4464] = 4165,
  [4465] = 4465,
  [4466] = 4295,
  [4467] = 4467,
  [4468] = 4458,
  [4469] = 4144,
  [4470] = 4180,
  [4471] = 4164,
  [4472] = 4156,
  [4473] = 4181,
  [4474] = 4165,
  [4475] = 4104,
  [4476] = 4153,
  [4477] = 4144,
  [4478] = 4159,
  [4479] = 4160,
  [4480] = 4164,
  [4481] = 4152,
  [4482] = 4165,
  [4483] = 4483,
  [4484] = 4459,
  [4485] = 4182,
  [4486] = 4192,
  [4487] = 4341,
  [4488] = 4342,
  [4489] = 4192,
  [4490] = 4425,
  [4491] = 4183,
  [4492] = 4430,
  [4493] = 4344,
  [4494] = 4345,
  [4495] = 4346,
  [4496] = 4347,
  [4497] = 4348,
  [4498] = 4467,
  [4499] = 4435,
  [4500] = 4483,
  [4501] = 4446,
  [4502] = 4184,
  [4503] = 4447,
  [4504] = 4320,
  [4505] = 4321,
  [4506] = 4369,
  [4507] = 4350,
  [4508] = 4351,
  [4509] = 4353,
  [4510] = 4354,
  [4511] = 4453,
  [4512] = 4465,
  [4513] = 4355,
  [4514] = 4356,
  [4515] = 4159,
  [4516] = 4295,
  [4517] = 4265,
  [4518] = 4252,
  [4519] = 4345,
  [4520] = 4252,
  [4521] = 4151,
  [4522] = 4447,
  [4523] = 4350,
  [4524] = 4355,
  [4525] = 4351,
  [4526] = 4346,
  [4527] = 4320,
  [4528] = 4354,
  [4529] = 4302,
  [4530] = 4453,
  [4531] = 4154,
  [4532] = 4465,
  [4533] = 4355,
  [4534] = 4308,
  [4535] = 4309,
  [4536] = 4173,
  [4537] = 4356,
  [4538] = 4467,
  [4539] = 4260,
  [4540] = 4268,
  [4541] = 4275,
  [4542] = 4290,
  [4543] = 4145,
  [4544] = 4146,
  [4545] = 4147,
  [4546] = 4174,
  [4547] = 4112,
  [4548] = 4292,
  [4549] = 4289,
  [4550] = 4483,
  [4551] = 4292,
  [4552] = 4104,
  [4553] = 4347,
  [4554] = 4175,
  [4555] = 4356,
  [4556] = 4425,
  [4557] = 4260,
  [4558] = 4430,
  [4559] = 4156,
  [4560] = 4322,
  [4561] = 4435,
  [4562] = 4268,
  [4563] = 4446,
  [4564] = 4369,
  [4565] = 4275,
  [4566] = 4447,
  [4567] = 4453,
  [4568] = 4156,
  [4569] = 4465,
  [4570] = 4467,
  [4571] = 4300,
  [4572] = 4301,
  [4573] = 4190,
  [4574] = 4192,
  [4575] = 4265,
  [4576] = 4156,
  [4577] = 4483,
  [4578] = 4458,
  [4579] = 4459,
  [4580] = 4291,
  [4581] = 4295,
  [4582] = 4293,
  [4583] = 4321,
  [4584] = 4320,
  [4585] = 4321,
  [4586] = 4248,
  [4587] = 4338,
  [4588] = 4325,
  [4589] = 4326,
  [4590] = 4327,
  [4591] = 4249,
  [4592] = 4156,
  [4593] = 4250,
  [4594] = 4104,
  [4595] = 4156,
  [4596] = 4156,
  [4597] = 4300,
  [4598] = 4301,
  [4599] = 4324,
  [4600] = 4338,
  [4601] = 4339,
  [4602] = 4340,
  [4603] = 4341,
  [4604] = 4342,
  [4605] = 4344,
  [4606] = 4345,
  [4607] = 4346,
  [4608] = 4347,
  [4609] = 4348,
  [4610] = 4245,
  [4611] = 4350,
  [4612] = 4351,
  [4613] = 4353,
  [4614] = 4354,
  [4615] = 4355,
  [4616] = 4356,
  [4617] = 4289,
  [4618] = 4339,
  [4619] = 4292,
  [4620] = 4359,
  [4621] = 4260,
  [4622] = 4268,
  [4623] = 4275,
  [4624] = 4152,
  [4625] = 4340,
  [4626] = 4290,
  [4627] = 4290,
  [4628] = 4628,
  [4629] = 4425,
  [4630] = 4359,
  [4631] = 4430,
  [4632] = 4341,
  [4633] = 4446,
  [4634] = 4342,
  [4635] = 4447,
  [4636] = 4453,
  [4637] = 4465,
  [4638] = 4467,
  [4639] = 4348,
  [4640] = 4245,
  [4641] = 4300,
  [4642] = 4301,
  [4643] = 4159,
  [4644] = 4160,
  [4645] = 4359,
  [4646] = 4171,
  [4647] = 4338,
  [4648] = 4252,
  [4649] = 4260,
  [4650] = 4320,
  [4651] = 4268,
  [4652] = 4275,
  [4653] = 4161,
  [4654] = 4290,
  [4655] = 4324,
  [4656] = 4321,
  [4657] = 4425,
  [4658] = 4430,
  [4659] = 4435,
  [4660] = 4446,
  [4661] = 4447,
  [4662] = 4453,
  [4663] = 4465,
  [4664] = 4467,
  [4665] = 4291,
  [4666] = 4293,
  [4667] = 4131,
  [4668] = 4153,
  [4669] = 4369,
  [4670] = 4369,
  [4671] = 4320,
  [4672] = 4321,
  [4673] = 4483,
  [4674] = 4325,
  [4675] = 4252,
  [4676] = 4118,
  [4677] = 4125,
  [4678] = 4129,
  [4679] = 4123,
  [4680] = 4435,
  [4681] = 4124,
  [4682] = 4295,
  [4683] = 4326,
  [4684] = 4265,
  [4685] = 4483,
  [4686] = 4339,
  [4687] = 4325,
  [4688] = 4340,
  [4689] = 4326,
  [4690] = 4341,
  [4691] = 4342,
  [4692] = 4289,
  [4693] = 4327,
  [4694] = 4249,
  [4695] = 4250,
  [4696] = 4300,
  [4697] = 4301,
  [4698] = 4344,
  [4699] = 4338,
  [4700] = 4339,
  [4701] = 4340,
  [4702] = 4341,
  [4703] = 4342,
  [4704] = 4190,
  [4705] = 4346,
  [4706] = 4347,
  [4707] = 4348,
  [4708] = 4245,
  [4709] = 4350,
  [4710] = 4351,
  [4711] = 4354,
  [4712] = 4355,
  [4713] = 4356,
  [4714] = 4289,
  [4715] = 4425,
  [4716] = 4292,
  [4717] = 4104,
  [4718] = 4192,
  [4719] = 4353,
  [4720] = 4369,
  [4721] = 4293,
  [4722] = 4628,
  [4723] = 4156,
  [4724] = 4458,
  [4725] = 4430,
  [4726] = 4459,
  [4727] = 4458,
  [4728] = 4322,
  [4729] = 4292,
  [4730] = 4459,
  [4731] = 4248,
  [4732] = 4192,
  [4733] = 4192,
  [4734] = 4252,
  [4735] = 4248,
  [4736] = 4260,
  [4737] = 4268,
  [4738] = 4275,
  [4739] = 4164,
  [4740] = 4290,
  [4741] = 4291,
  [4742] = 4265,
  [4743] = 4369,
  [4744] = 4324,
  [4745] = 4192,
  [4746] = 4359,
  [4747] = 4190,
  [4748] = 4165,
  [4749] = 4425,
  [4750] = 4302,
  [4751] = 4302,
  [4752] = 4308,
  [4753] = 4309,
  [4754] = 4295,
  [4755] = 4483,
  [4756] = 4112,
  [4757] = 4291,
  [4758] = 4293,
  [4759] = 4320,
  [4760] = 4321,
  [4761] = 4325,
  [4762] = 4326,
  [4763] = 4327,
  [4764] = 4249,
  [4765] = 4250,
  [4766] = 4300,
  [4767] = 4301,
  [4768] = 4324,
  [4769] = 4338,
  [4770] = 4339,
  [4771] = 4340,
  [4772] = 4341,
  [4773] = 4342,
  [4774] = 4344,
  [4775] = 4345,
  [4776] = 4346,
  [4777] = 4347,
  [4778] = 4348,
  [4779] = 4430,
  [4780] = 4245,
  [4781] = 4350,
  [4782] = 4351,
  [4783] = 4353,
  [4784] = 4354,
  [4785] = 4355,
  [4786] = 4356,
  [4787] = 4322,
  [4788] = 4322,
  [4789] = 4354,
  [4790] = 4458,
  [4791] = 4293,
  [4792] = 4459,
  [4793] = 4325,
  [4794] = 4322,
  [4795] = 4345,
  [4796] = 4265,
  [4797] = 4248,
  [4798] = 4346,
  [4799] = 4347,
  [4800] = 4344,
  [4801] = 4348,
  [4802] = 4295,
  [4803] = 4302,
  [4804] = 4308,
  [4805] = 4309,
  [4806] = 4131,
  [4807] = 4245,
  [4808] = 4105,
  [4809] = 4350,
  [4810] = 4458,
  [4811] = 4459,
  [4812] = 4248,
  [4813] = 4435,
  [4814] = 4435,
  [4815] = 4326,
  [4816] = 4446,
  [4817] = 4446,
  [4818] = 4351,
  [4819] = 4124,
  [4820] = 4324,
  [4821] = 4105,
  [4822] = 4105,
  [4823] = 4308,
  [4824] = 4447,
  [4825] = 4309,
  [4826] = 4190,
  [4827] = 4327,
  [4828] = 4249,
  [4829] = 4144,
  [4830] = 4344,
  [4831] = 4179,
  [4832] = 4180,
  [4833] = 4327,
  [4834] = 4353,
  [4835] = 4181,
  [4836] = 4250,
  [4837] = 4453,
  [4838] = 4353,
  [4839] = 4249,
  [4840] = 4250,
  [4841] = 4465,
  [4842] = 4359,
  [4843] = 4302,
  [4844] = 4118,
  [4845] = 4125,
  [4846] = 4129,
  [4847] = 4467,
  [4848] = 4308,
  [4849] = 4309,
  [4850] = 4182,
  [4851] = 4183,
  [4852] = 4184,
  [4853] = 4123,
  [4854] = 4289,
  [4855] = 4291,
  [4856] = 4856,
  [4857] = 4142,
  [4858] = 4345,
  [4859] = 4190,
  [4860] = 4628,
  [4861] = 4112,
  [4862] = 4446,
  [4863] = 4339,
  [4864] = 4152,
  [4865] = 4153,
  [4866] = 4156,
  [4867] = 4192,
  [4868] = 4112,
  [4869] = 4118,
  [4870] = 4125,
  [4871] = 4129,
  [4872] = 4447,
  [4873] = 4173,
  [4874] = 4112,
  [4875] = 4174,
  [4876] = 4123,
  [4877] = 4124,
  [4878] = 4350,
  [4879] = 4340,
  [4880] = 4341,
  [4881] = 4118,
  [4882] = 4351,
  [4883] = 4125,
  [4884] = 4129,
  [4885] = 4353,
  [4886] = 4190,
  [4887] = 4342,
  [4888] = 4076,
  [4889] = 4124,
  [4890] = 4354,
  [4891] = 4123,
  [4892] = 4124,
  [4893] = 4453,
  [4894] = 4465,
  [4895] = 4355,
  [4896] = 4356,
  [4897] = 4467,
  [4898] = 4327,
  [4899] = 4175,
  [4900] = 4628,
  [4901] = 4292,
  [4902] = 4118,
  [4903] = 4302,
  [4904] = 4125,
  [4905] = 4293,
  [4906] = 4171,
  [4907] = 4173,
  [4908] = 4174,
  [4909] = 4175,
  [4910] = 4129,
  [4911] = 4179,
  [4912] = 4320,
  [4913] = 4180,
  [4914] = 4181,
  [4915] = 4192,
  [4916] = 4182,
  [4917] = 4183,
  [4918] = 4192,
  [4919] = 4628,
  [4920] = 4184,
  [4921] = 4249,
  [4922] = 4252,
  [4923] = 4156,
  [4924] = 4290,
  [4925] = 4118,
  [4926] = 4125,
  [4927] = 4129,
  [4928] = 4123,
  [4929] = 4289,
  [4930] = 4124,
  [4931] = 4338,
  [4932] = 4112,
  [4933] = 4250,
  [4934] = 4300,
  [4935] = 4131,
  [4936] = 4458,
  [4937] = 4131,
  [4938] = 4118,
  [4939] = 4125,
  [4940] = 4129,
  [4941] = 4112,
  [4942] = 4324,
  [4943] = 4179,
  [4944] = 4180,
  [4945] = 4181,
  [4946] = 4159,
  [4947] = 4160,
  [4948] = 4321,
  [4949] = 4112,
  [4950] = 4118,
  [4951] = 4125,
  [4952] = 4628,
  [4953] = 4129,
  [4954] = 4156,
  [4955] = 4164,
  [4956] = 4123,
  [4957] = 4165,
  [4958] = 4124,
  [4959] = 4131,
  [4960] = 4295,
  [4961] = 4628,
  [4962] = 4301,
  [4963] = 4144,
  [4964] = 4192,
  [4965] = 4322,
  [4966] = 4291,
  [4967] = 4118,
  [4968] = 4125,
  [4969] = 4129,
  [4970] = 4123,
  [4971] = 4131,
  [4972] = 4124,
  [4973] = 4131,
  [4974] = 4425,
  [4975] = 4131,
  [4976] = 4430,
  [4977] = 4182,
  [4978] = 4192,
  [4979] = 4156,
  [4980] = 4112,
  [4981] = 4131,
  [4982] = 4183,
  [4983] = 4171,
  [4984] = 4131,
  [4985] = 4123,
  [4986] = 4184,
  [4987] = 4260,
  [4988] = 4268,
  [4989] = 4156,
  [4990] = 4105,
  [4991] = 4105,
  [4992] = 4144,
  [4993] = 4359,
  [4994] = 4105,
  [4995] = 4628,
  [4996] = 4123,
  [4997] = 4344,
  [4998] = 4076,
  [4999] = 4105,
  [5000] = 4159,
  [5001] = 4160,
  [5002] = 4164,
  [5003] = 4165,
  [5004] = 4248,
  [5005] = 4105,
  [5006] = 4345,
  [5007] = 4192,
  [5008] = 4192,
  [5009] = 4105,
  [5010] = 4105,
  [5011] = 4275,
  [5012] = 4308,
  [5013] = 4309,
  [5014] = 4326,
  [5015] = 4628,
  [5016] = 4483,
  [5017] = 4369,
  [5018] = 4118,
  [5019] = 4125,
  [5020] = 4129,
  [5021] = 4459,
  [5022] = 4265,
  [5023] = 4346,
  [5024] = 4347,
  [5025] = 4348,
  [5026] = 4245,
  [5027] = 4123,
  [5028] = 4124,
  [5029] = 4435,
  [5030] = 4124,
  [5031] = 4105,
  [5032] = 4325,
  [5033] = 4076,
  [5034] = 4152,
  [5035] = 4153,
  [5036] = 4112,
  [5037] = 4156,
  [5038] = 4425,
  [5039] = 4152,
  [5040] = 4171,
  [5041] = 4174,
  [5042] = 4153,
  [5043] = 4160,
  [5044] = 5044,
  [5045] = 4192,
  [5046] = 4131,
  [5047] = 4430,
  [5048] = 4156,
  [5049] = 4179,
  [5050] = 4180,
  [5051] = 4628,
  [5052] = 4124,
  [5053] = 4164,
  [5054] = 4142,
  [5055] = 4165,
  [5056] = 4190,
  [5057] = 4112,
  [5058] = 4171,
  [5059] = 4147,
  [5060] = 4171,
  [5061] = 5044,
  [5062] = 4173,
  [5063] = 4174,
  [5064] = 4118,
  [5065] = 4175,
  [5066] = 4179,
  [5067] = 4180,
  [5068] = 4181,
  [5069] = 4182,
  [5070] = 4183,
  [5071] = 4184,
  [5072] = 4105,
  [5073] = 4181,
  [5074] = 4324,
  [5075] = 4173,
  [5076] = 4174,
  [5077] = 4076,
  [5078] = 4175,
  [5079] = 4180,
  [5080] = 4628,
  [5081] = 4369,
  [5082] = 4446,
  [5083] = 4359,
  [5084] = 4252,
  [5085] = 4435,
  [5086] = 4153,
  [5087] = 4465,
  [5088] = 4179,
  [5089] = 4180,
  [5090] = 4483,
  [5091] = 4112,
  [5092] = 4181,
  [5093] = 4447,
  [5094] = 4350,
  [5095] = 4173,
  [5096] = 4174,
  [5097] = 4182,
  [5098] = 4183,
  [5099] = 4351,
  [5100] = 4123,
  [5101] = 4184,
  [5102] = 4175,
  [5103] = 4118,
  [5104] = 4338,
  [5105] = 4182,
  [5106] = 4152,
  [5107] = 4144,
  [5108] = 4125,
  [5109] = 4183,
  [5110] = 4131,
  [5111] = 4145,
  [5112] = 4125,
  [5113] = 4129,
  [5114] = 4129,
  [5115] = 4353,
  [5116] = 4354,
  [5117] = 4173,
  [5118] = 4152,
  [5119] = 4153,
  [5120] = 4453,
  [5121] = 4174,
  [5122] = 4153,
  [5123] = 4355,
  [5124] = 4179,
  [5125] = 4131,
  [5126] = 4192,
  [5127] = 4112,
  [5128] = 4175,
  [5129] = 4295,
  [5130] = 4112,
  [5131] = 4356,
  [5132] = 4112,
  [5133] = 4156,
  [5134] = 4339,
  [5135] = 4249,
  [5136] = 4465,
  [5137] = 4458,
  [5138] = 4459,
  [5139] = 4248,
  [5140] = 4112,
  [5141] = 4184,
  [5142] = 4171,
  [5143] = 4131,
  [5144] = 4467,
  [5145] = 4302,
  [5146] = 4308,
  [5147] = 4309,
  [5148] = 4184,
  [5149] = 4147,
  [5150] = 4250,
  [5151] = 4124,
  [5152] = 4076,
  [5153] = 4347,
  [5154] = 4340,
  [5155] = 5155,
  [5156] = 4146,
  [5157] = 4190,
  [5158] = 4341,
  [5159] = 4152,
  [5160] = 4183,
  [5161] = 4342,
  [5162] = 4447,
  [5163] = 4291,
  [5164] = 4293,
  [5165] = 4320,
  [5166] = 4321,
  [5167] = 4123,
  [5168] = 4325,
  [5169] = 4326,
  [5170] = 4327,
  [5171] = 4249,
  [5172] = 4250,
  [5173] = 4161,
  [5174] = 4300,
  [5175] = 4301,
  [5176] = 4324,
  [5177] = 4338,
  [5178] = 4339,
  [5179] = 4340,
  [5180] = 4341,
  [5181] = 4153,
  [5182] = 4342,
  [5183] = 4344,
  [5184] = 4345,
  [5185] = 4346,
  [5186] = 4347,
  [5187] = 4348,
  [5188] = 4245,
  [5189] = 4350,
  [5190] = 4351,
  [5191] = 4353,
  [5192] = 4354,
  [5193] = 4355,
  [5194] = 4356,
  [5195] = 4124,
  [5196] = 4184,
  [5197] = 4179,
  [5198] = 4180,
  [5199] = 4483,
  [5200] = 4348,
  [5201] = 4105,
  [5202] = 4322,
  [5203] = 4181,
  [5204] = 4118,
  [5205] = 4129,
  [5206] = 4628,
  [5207] = 4265,
  [5208] = 4265,
  [5209] = 4245,
  [5210] = 4105,
  [5211] = 4184,
  [5212] = 4144,
  [5213] = 4125,
  [5214] = 4131,
  [5215] = 4144,
  [5216] = 4171,
  [5217] = 4628,
  [5218] = 4124,
  [5219] = 4152,
  [5220] = 4183,
  [5221] = 4327,
  [5222] = 4268,
  [5223] = 4182,
  [5224] = 4144,
  [5225] = 4159,
  [5226] = 4183,
  [5227] = 4160,
  [5228] = 4164,
  [5229] = 4165,
  [5230] = 4105,
  [5231] = 4152,
  [5232] = 4458,
  [5233] = 4459,
  [5234] = 4248,
  [5235] = 4131,
  [5236] = 4159,
  [5237] = 4160,
  [5238] = 4164,
  [5239] = 4165,
  [5240] = 4144,
  [5241] = 4295,
  [5242] = 4275,
  [5243] = 4118,
  [5244] = 4125,
  [5245] = 4144,
  [5246] = 4159,
  [5247] = 4160,
  [5248] = 4164,
  [5249] = 4165,
  [5250] = 4129,
  [5251] = 4325,
  [5252] = 4144,
  [5253] = 4142,
  [5254] = 4173,
  [5255] = 4123,
  [5256] = 5256,
  [5257] = 4289,
  [5258] = 4290,
  [5259] = 4173,
  [5260] = 4154,
  [5261] = 4105,
  [5262] = 4159,
  [5263] = 4160,
  [5264] = 4164,
  [5265] = 4165,
  [5266] = 4182,
  [5267] = 4159,
  [5268] = 4160,
  [5269] = 4164,
  [5270] = 4165,
  [5271] = 4174,
  [5272] = 4144,
  [5273] = 4628,
  [5274] = 4118,
  [5275] = 4125,
  [5276] = 4300,
  [5277] = 4175,
  [5278] = 4159,
  [5279] = 4160,
  [5280] = 4164,
  [5281] = 4165,
  [5282] = 4179,
  [5283] = 4124,
  [5284] = 4152,
  [5285] = 4180,
  [5286] = 4174,
  [5287] = 4105,
  [5288] = 4159,
  [5289] = 4179,
  [5290] = 4344,
  [5291] = 4467,
  [5292] = 4160,
  [5293] = 4164,
  [5294] = 4165,
  [5295] = 4076,
  [5296] = 4180,
  [5297] = 4123,
  [5298] = 4184,
  [5299] = 4181,
  [5300] = 4301,
  [5301] = 4153,
  [5302] = 4183,
  [5303] = 4129,
  [5304] = 4151,
  [5305] = 4289,
  [5306] = 4129,
  [5307] = 4154,
  [5308] = 4453,
  [5309] = 4145,
  [5310] = 4124,
  [5311] = 4181,
  [5312] = 4181,
  [5313] = 4345,
  [5314] = 4151,
  [5315] = 4346,
  [5316] = 4123,
  [5317] = 4359,
  [5318] = 4161,
  [5319] = 4302,
  [5320] = 4123,
  [5321] = 4173,
  [5322] = 4159,
  [5323] = 4175,
  [5324] = 4292,
  [5325] = 4308,
  [5326] = 4171,
  [5327] = 4309,
  [5328] = 4156,
  [5329] = 4146,
  [5330] = 4292,
  [5331] = 4252,
  [5332] = 4153,
  [5333] = 4260,
  [5334] = 4268,
  [5335] = 4275,
  [5336] = 4171,
  [5337] = 4173,
  [5338] = 4182,
  [5339] = 4290,
  [5340] = 4628,
  [5341] = 4322,
  [5342] = 4152,
  [5343] = 4174,
  [5344] = 4153,
  [5345] = 4175,
  [5346] = 4179,
  [5347] = 4180,
  [5348] = 4181,
  [5349] = 4291,
  [5350] = 4182,
  [5351] = 4293,
  [5352] = 4320,
  [5353] = 4183,
  [5354] = 4321,
  [5355] = 4184,
  [5356] = 4425,
  [5357] = 4118,
  [5358] = 4430,
  [5359] = 4435,
  [5360] = 4175,
  [5361] = 4369,
  [5362] = 4182,
  [5363] = 4125,
  [5364] = 4171,
  [5365] = 4446,
  [5366] = 4326,
  [5367] = 4260,
  [5368] = 4321,
  [5369] = 4265,
  [5370] = 4483,
  [5371] = 4322,
  [5372] = 4302,
  [5373] = 4308,
  [5374] = 4309,
  [5375] = 4144,
  [5376] = 4291,
  [5377] = 4293,
  [5378] = 4320,
  [5379] = 4359,
  [5380] = 4325,
  [5381] = 4326,
  [5382] = 4327,
  [5383] = 4249,
  [5384] = 4250,
  [5385] = 4300,
  [5386] = 4301,
  [5387] = 4324,
  [5388] = 4338,
  [5389] = 4339,
  [5390] = 4340,
  [5391] = 4341,
  [5392] = 4342,
  [5393] = 4344,
  [5394] = 4345,
  [5395] = 4346,
  [5396] = 4347,
  [5397] = 4348,
  [5398] = 4245,
  [5399] = 4350,
  [5400] = 4351,
  [5401] = 4308,
  [5402] = 4353,
  [5403] = 4354,
  [5404] = 4355,
  [5405] = 4356,
  [5406] = 4309,
  [5407] = 4144,
  [5408] = 4291,
  [5409] = 4293,
  [5410] = 4320,
  [5411] = 4321,
  [5412] = 4325,
  [5413] = 4326,
  [5414] = 4327,
  [5415] = 4249,
  [5416] = 4250,
  [5417] = 4300,
  [5418] = 4301,
  [5419] = 4324,
  [5420] = 4338,
  [5421] = 4339,
  [5422] = 4340,
  [5423] = 4341,
  [5424] = 4342,
  [5425] = 4344,
  [5426] = 4345,
  [5427] = 4346,
  [5428] = 4347,
  [5429] = 4348,
  [5430] = 4245,
  [5431] = 4350,
  [5432] = 4351,
  [5433] = 4353,
  [5434] = 4354,
  [5435] = 4355,
  [5436] = 4356,
  [5437] = 4322,
  [5438] = 4265,
  [5439] = 4302,
  [5440] = 4308,
  [5441] = 4309,
  [5442] = 4322,
  [5443] = 4265,
  [5444] = 4144,
  [5445] = 4291,
  [5446] = 4293,
  [5447] = 4320,
  [5448] = 4321,
  [5449] = 4369,
  [5450] = 4325,
  [5451] = 4326,
  [5452] = 4327,
  [5453] = 4249,
  [5454] = 4250,
  [5455] = 4252,
  [5456] = 4300,
  [5457] = 4301,
  [5458] = 4324,
  [5459] = 4338,
  [5460] = 4339,
  [5461] = 4340,
  [5462] = 4341,
  [5463] = 4342,
  [5464] = 4159,
  [5465] = 4160,
  [5466] = 4344,
  [5467] = 4345,
  [5468] = 4346,
  [5469] = 4347,
  [5470] = 4348,
  [5471] = 4245,
  [5472] = 4435,
  [5473] = 4350,
  [5474] = 4164,
  [5475] = 4351,
  [5476] = 4165,
  [5477] = 4353,
  [5478] = 4354,
  [5479] = 4355,
  [5480] = 4356,
  [5481] = 4458,
  [5482] = 4459,
  [5483] = 4322,
  [5484] = 4265,
  [5485] = 4483,
  [5486] = 4248,
  [5487] = 4302,
  [5488] = 4308,
  [5489] = 4309,
  [5490] = 4458,
  [5491] = 4289,
  [5492] = 4459,
  [5493] = 4295,
  [5494] = 4248,
  [5495] = 4105,
  [5496] = 4458,
  [5497] = 4459,
  [5498] = 4248,
  [5499] = 4291,
  [5500] = 4295,
  [5501] = 4293,
  [5502] = 4320,
  [5503] = 4321,
  [5504] = 4325,
  [5505] = 4326,
  [5506] = 4327,
  [5507] = 4249,
  [5508] = 4250,
  [5509] = 4302,
  [5510] = 4300,
  [5511] = 4301,
  [5512] = 4324,
  [5513] = 4338,
  [5514] = 4339,
  [5515] = 4340,
  [5516] = 4341,
  [5517] = 4342,
  [5518] = 4308,
  [5519] = 4309,
  [5520] = 4344,
  [5521] = 4345,
  [5522] = 4346,
  [5523] = 4347,
  [5524] = 4348,
  [5525] = 4245,
  [5526] = 4350,
  [5527] = 4351,
  [5528] = 4353,
  [5529] = 4354,
  [5530] = 4355,
  [5531] = 4356,
  [5532] = 4265,
  [5533] = 4292,
  [5534] = 4458,
  [5535] = 4459,
  [5536] = 4322,
  [5537] = 4248,
  [5538] = 4295,
  [5539] = 4458,
  [5540] = 4459,
  [5541] = 4248,
  [5542] = 4144,
  [5543] = 4458,
  [5544] = 4459,
  [5545] = 4248,
  [5546] = 4295,
  [5547] = 4295,
  [5548] = 4458,
  [5549] = 4295,
  [5550] = 4459,
  [5551] = 4248,
  [5552] = 4159,
  [5553] = 4160,
  [5554] = 4164,
  [5555] = 4165,
  [5556] = 4144,
  [5557] = 4369,
  [5558] = 4159,
  [5559] = 4160,
  [5560] = 4164,
  [5561] = 4165,
  [5562] = 4252,
  [5563] = 4260,
  [5564] = 4268,
  [5565] = 4275,
  [5566] = 4290,
  [5567] = 4425,
  [5568] = 4430,
  [5569] = 4435,
  [5570] = 4446,
  [5571] = 4447,
  [5572] = 4453,
  [5573] = 4465,
  [5574] = 4467,
  [5575] = 4291,
  [5576] = 4293,
  [5577] = 4320,
  [5578] = 4321,
  [5579] = 4483,
  [5580] = 4628,
  [5581] = 4325,
  [5582] = 4326,
  [5583] = 4327,
  [5584] = 4249,
  [5585] = 4250,
  [5586] = 5586,
  [5587] = 5044,
  [5588] = 4300,
  [5589] = 4301,
  [5590] = 4338,
  [5591] = 4339,
  [5592] = 4340,
  [5593] = 4341,
  [5594] = 4342,
  [5595] = 4345,
  [5596] = 4346,
  [5597] = 4347,
  [5598] = 4348,
  [5599] = 4245,
  [5600] = 4350,
  [5601] = 4351,
  [5602] = 4354,
  [5603] = 4355,
  [5604] = 4356,
  [5605] = 4076,
  [5606] = 4112,
  [5607] = 5044,
  [5608] = 4118,
  [5609] = 4125,
  [5610] = 4129,
  [5611] = 4324,
  [5612] = 4123,
  [5613] = 4344,
  [5614] = 4124,
  [5615] = 4353,
  [5616] = 4152,
  [5617] = 4153,
  [5618] = 4359,
  [5619] = 4171,
  [5620] = 4173,
  [5621] = 4174,
  [5622] = 4175,
  [5623] = 4179,
  [5624] = 4180,
  [5625] = 4181,
  [5626] = 4182,
  [5627] = 4183,
  [5628] = 4184,
  [5629] = 4322,
  [5630] = 5044,
  [5631] = 4152,
  [5632] = 4153,
  [5633] = 4435,
  [5634] = 4152,
  [5635] = 4153,
  [5636] = 4171,
  [5637] = 4173,
  [5638] = 4174,
  [5639] = 4175,
  [5640] = 4179,
  [5641] = 4180,
  [5642] = 4181,
  [5643] = 4182,
  [5644] = 4183,
  [5645] = 4184,
  [5646] = 4295,
  [5647] = 4265,
  [5648] = 4171,
  [5649] = 4173,
  [5650] = 4174,
  [5651] = 4175,
  [5652] = 4179,
  [5653] = 4180,
  [5654] = 4181,
  [5655] = 4182,
  [5656] = 4183,
  [5657] = 4184,
  [5658] = 4131,
  [5659] = 4076,
  [5660] = 5044,
  [5661] = 4152,
  [5662] = 5662,
  [5663] = 4153,
  [5664] = 4289,
  [5665] = 4292,
  [5666] = 4171,
  [5667] = 4260,
  [5668] = 4268,
  [5669] = 4275,
  [5670] = 4290,
  [5671] = 4173,
  [5672] = 4174,
  [5673] = 4175,
  [5674] = 4425,
  [5675] = 4430,
  [5676] = 4179,
  [5677] = 4180,
  [5678] = 4181,
  [5679] = 4446,
  [5680] = 4447,
  [5681] = 4182,
  [5682] = 4183,
  [5683] = 4453,
  [5684] = 4465,
  [5685] = 4184,
  [5686] = 4467,
  [5687] = 4289,
  [5688] = 4252,
  [5689] = 4369,
  [5690] = 4076,
  [5691] = 4252,
  [5692] = 4260,
  [5693] = 4268,
  [5694] = 4275,
  [5695] = 4290,
  [5696] = 4425,
  [5697] = 5697,
  [5698] = 4430,
  [5699] = 4435,
  [5700] = 4446,
  [5701] = 4447,
  [5702] = 4453,
  [5703] = 4465,
  [5704] = 4467,
  [5705] = 4105,
  [5706] = 4289,
  [5707] = 4292,
  [5708] = 4483,
  [5709] = 4260,
  [5710] = 4268,
  [5711] = 4275,
  [5712] = 4290,
  [5713] = 4425,
  [5714] = 4430,
  [5715] = 4446,
  [5716] = 4447,
  [5717] = 4453,
  [5718] = 4465,
  [5719] = 4467,
  [5720] = 4369,
  [5721] = 4252,
  [5722] = 4152,
  [5723] = 4435,
  [5724] = 4153,
  [5725] = 4483,
  [5726] = 4159,
  [5727] = 4160,
  [5728] = 4164,
  [5729] = 4165,
  [5730] = 4289,
  [5731] = 4458,
  [5732] = 4459,
  [5733] = 4292,
  [5734] = 4369,
  [5735] = 4248,
  [5736] = 4171,
  [5737] = 4252,
  [5738] = 4260,
  [5739] = 4268,
  [5740] = 4275,
  [5741] = 4290,
  [5742] = 4173,
  [5743] = 4174,
  [5744] = 4175,
  [5745] = 4425,
  [5746] = 4430,
  [5747] = 4179,
  [5748] = 4180,
  [5749] = 4181,
  [5750] = 4435,
  [5751] = 4446,
  [5752] = 4447,
  [5753] = 4182,
  [5754] = 4183,
  [5755] = 4453,
  [5756] = 4465,
  [5757] = 4184,
  [5758] = 4467,
  [5759] = 4289,
  [5760] = 4292,
  [5761] = 4483,
  [5762] = 4260,
  [5763] = 4268,
  [5764] = 4275,
  [5765] = 4290,
  [5766] = 4425,
  [5767] = 4430,
  [5768] = 4446,
  [5769] = 4447,
  [5770] = 4453,
  [5771] = 4465,
  [5772] = 4467,
  [5773] = 4289,
  [5774] = 4292,
  [5775] = 4369,
  [5776] = 4156,
  [5777] = 4359,
  [5778] = 4302,
  [5779] = 4252,
  [5780] = 4260,
  [5781] = 4268,
  [5782] = 4275,
  [5783] = 4265,
  [5784] = 4290,
  [5785] = 4308,
  [5786] = 4309,
  [5787] = 5662,
  [5788] = 4425,
  [5789] = 4430,
  [5790] = 4435,
  [5791] = 4446,
  [5792] = 4447,
  [5793] = 4453,
  [5794] = 4465,
  [5795] = 4467,
  [5796] = 4105,
  [5797] = 4295,
  [5798] = 4483,
  [5799] = 4359,
  [5800] = 4152,
  [5801] = 5697,
  [5802] = 4153,
  [5803] = 4291,
  [5804] = 4293,
  [5805] = 4320,
  [5806] = 4321,
  [5807] = 4359,
  [5808] = 4325,
  [5809] = 4326,
  [5810] = 4327,
  [5811] = 4249,
  [5812] = 4250,
  [5813] = 4300,
  [5814] = 4301,
  [5815] = 4324,
  [5816] = 4338,
  [5817] = 4339,
  [5818] = 4340,
  [5819] = 4341,
  [5820] = 4342,
  [5821] = 4344,
  [5822] = 4345,
  [5823] = 4346,
  [5824] = 4347,
  [5825] = 4348,
  [5826] = 4245,
  [5827] = 4350,
  [5828] = 4351,
  [5829] = 4353,
  [5830] = 4354,
  [5831] = 4355,
  [5832] = 4356,
  [5833] = 4289,
  [5834] = 4292,
  [5835] = 4171,
  [5836] = 4302,
  [5837] = 4260,
  [5838] = 4268,
  [5839] = 4275,
  [5840] = 4290,
  [5841] = 4173,
  [5842] = 4174,
  [5843] = 4175,
  [5844] = 4308,
  [5845] = 4309,
  [5846] = 4425,
  [5847] = 4430,
  [5848] = 4179,
  [5849] = 4180,
  [5850] = 4181,
  [5851] = 4446,
  [5852] = 4447,
  [5853] = 4182,
  [5854] = 4183,
  [5855] = 4453,
  [5856] = 4465,
  [5857] = 4184,
  [5858] = 4467,
  [5859] = 4369,
  [5860] = 4302,
  [5861] = 4252,
  [5862] = 4159,
  [5863] = 4160,
  [5864] = 4435,
  [5865] = 4164,
  [5866] = 4165,
  [5867] = 4291,
  [5868] = 4293,
  [5869] = 4320,
  [5870] = 4321,
  [5871] = 4483,
  [5872] = 4359,
  [5873] = 4325,
  [5874] = 4326,
  [5875] = 5044,
  [5876] = 4327,
  [5877] = 4249,
  [5878] = 4250,
  [5879] = 4302,
  [5880] = 4300,
  [5881] = 4301,
  [5882] = 4324,
  [5883] = 4338,
  [5884] = 4339,
  [5885] = 4340,
  [5886] = 4341,
  [5887] = 4342,
  [5888] = 4308,
  [5889] = 4309,
  [5890] = 4159,
  [5891] = 4160,
  [5892] = 4344,
  [5893] = 4345,
  [5894] = 4346,
  [5895] = 4347,
  [5896] = 4348,
  [5897] = 4245,
  [5898] = 4350,
  [5899] = 4164,
  [5900] = 4351,
  [5901] = 4165,
  [5902] = 4353,
  [5903] = 4354,
  [5904] = 4355,
  [5905] = 4356,
  [5906] = 4144,
  [5907] = 4291,
  [5908] = 4293,
  [5909] = 4320,
  [5910] = 4321,
  [5911] = 4322,
  [5912] = 4359,
  [5913] = 4325,
  [5914] = 4326,
  [5915] = 4327,
  [5916] = 4249,
  [5917] = 4250,
  [5918] = 4300,
  [5919] = 4301,
  [5920] = 4324,
  [5921] = 4338,
  [5922] = 4339,
  [5923] = 4340,
  [5924] = 4341,
  [5925] = 4342,
  [5926] = 4344,
  [5927] = 4345,
  [5928] = 4346,
  [5929] = 4347,
  [5930] = 4348,
  [5931] = 4245,
  [5932] = 4350,
  [5933] = 4351,
  [5934] = 4353,
  [5935] = 4354,
  [5936] = 4355,
  [5937] = 4356,
  [5938] = 4322,
  [5939] = 4265,
  [5940] = 4369,
  [5941] = 4359,
  [5942] = 4292,
  [5943] = 4275,
  [5944] = 4181,
  [5945] = 4182,
  [5946] = 4183,
  [5947] = 4184,
  [5948] = 5662,
  [5949] = 4131,
  [5950] = 5697,
  [5951] = 4248,
  [5952] = 4458,
  [5953] = 5953,
  [5954] = 4459,
  [5955] = 4369,
  [5956] = 4248,
  [5957] = 4289,
  [5958] = 4291,
  [5959] = 4292,
  [5960] = 4293,
  [5961] = 4320,
  [5962] = 4321,
  [5963] = 4359,
  [5964] = 4369,
  [5965] = 4325,
  [5966] = 4326,
  [5967] = 4327,
  [5968] = 4249,
  [5969] = 4250,
  [5970] = 4252,
  [5971] = 4458,
  [5972] = 4260,
  [5973] = 4268,
  [5974] = 4290,
  [5975] = 4300,
  [5976] = 4301,
  [5977] = 4324,
  [5978] = 4338,
  [5979] = 4339,
  [5980] = 4340,
  [5981] = 4341,
  [5982] = 4342,
  [5983] = 4295,
  [5984] = 4425,
  [5985] = 4430,
  [5986] = 4344,
  [5987] = 4345,
  [5988] = 4346,
  [5989] = 4347,
  [5990] = 4348,
  [5991] = 4245,
  [5992] = 4435,
  [5993] = 4252,
  [5994] = 4446,
  [5995] = 4447,
  [5996] = 4350,
  [5997] = 4351,
  [5998] = 4353,
  [5999] = 4354,
  [6000] = 4453,
  [6001] = 4465,
  [6002] = 4355,
  [6003] = 4356,
  [6004] = 4467,
  [6005] = 4289,
  [6006] = 4292,
  [6007] = 4483,
  [6008] = 4369,
  [6009] = 4252,
  [6010] = 4260,
  [6011] = 4268,
  [6012] = 4290,
  [6013] = 4425,
  [6014] = 4430,
  [6015] = 4435,
  [6016] = 4459,
  [6017] = 4446,
  [6018] = 4447,
  [6019] = 4453,
  [6020] = 4465,
  [6021] = 4467,
  [6022] = 4105,
  [6023] = 4483,
  [6024] = 4435,
  [6025] = 4458,
  [6026] = 4459,
  [6027] = 4302,
  [6028] = 4248,
  [6029] = 4295,
  [6030] = 4302,
  [6031] = 4322,
  [6032] = 4458,
  [6033] = 4308,
  [6034] = 4309,
  [6035] = 4459,
  [6036] = 4248,
  [6037] = 4291,
  [6038] = 4295,
  [6039] = 4293,
  [6040] = 4320,
  [6041] = 4321,
  [6042] = 4265,
  [6043] = 5662,
  [6044] = 4359,
  [6045] = 4325,
  [6046] = 4326,
  [6047] = 4327,
  [6048] = 4249,
  [6049] = 4250,
  [6050] = 4302,
  [6051] = 5697,
  [6052] = 4300,
  [6053] = 4301,
  [6054] = 4324,
  [6055] = 4338,
  [6056] = 4339,
  [6057] = 4340,
  [6058] = 4341,
  [6059] = 4342,
  [6060] = 4308,
  [6061] = 4309,
  [6062] = 4344,
  [6063] = 4345,
  [6064] = 4346,
  [6065] = 4347,
  [6066] = 4348,
  [6067] = 4245,
  [6068] = 4350,
  [6069] = 4351,
  [6070] = 4353,
  [6071] = 4354,
  [6072] = 4355,
  [6073] = 4356,
  [6074] = 4289,
  [6075] = 4291,
  [6076] = 4292,
  [6077] = 4293,
  [6078] = 4320,
  [6079] = 4321,
  [6080] = 4308,
  [6081] = 4369,
  [6082] = 4309,
  [6083] = 4325,
  [6084] = 4326,
  [6085] = 4327,
  [6086] = 4249,
  [6087] = 4250,
  [6088] = 4252,
  [6089] = 4260,
  [6090] = 4268,
  [6091] = 4275,
  [6092] = 4290,
  [6093] = 4300,
  [6094] = 4301,
  [6095] = 4324,
  [6096] = 4338,
  [6097] = 4339,
  [6098] = 4340,
  [6099] = 4341,
  [6100] = 4342,
  [6101] = 4425,
  [6102] = 4430,
  [6103] = 4344,
  [6104] = 4345,
  [6105] = 4346,
  [6106] = 4347,
  [6107] = 4348,
  [6108] = 4245,
  [6109] = 4435,
  [6110] = 4446,
  [6111] = 4447,
  [6112] = 4350,
  [6113] = 4351,
  [6114] = 4353,
  [6115] = 4354,
  [6116] = 4453,
  [6117] = 4465,
  [6118] = 4355,
  [6119] = 4356,
  [6120] = 4467,
  [6121] = 4483,
  [6122] = 4322,
  [6123] = 4359,
  [6124] = 4131,
  [6125] = 4159,
  [6126] = 4160,
  [6127] = 4164,
  [6128] = 4165,
  [6129] = 4628,
  [6130] = 4359,
  [6131] = 5662,
  [6132] = 5697,
  [6133] = 4302,
  [6134] = 4308,
  [6135] = 4309,
  [6136] = 4458,
  [6137] = 4459,
  [6138] = 4248,
  [6139] = 4289,
  [6140] = 4292,
  [6141] = 4260,
  [6142] = 4268,
  [6143] = 4275,
  [6144] = 4290,
  [6145] = 4265,
  [6146] = 4425,
  [6147] = 4430,
  [6148] = 5953,
  [6149] = 4446,
  [6150] = 4447,
  [6151] = 5044,
  [6152] = 4453,
  [6153] = 4465,
  [6154] = 4467,
  [6155] = 4105,
  [6156] = 4291,
  [6157] = 4293,
  [6158] = 4320,
  [6159] = 4321,
  [6160] = 4112,
  [6161] = 4325,
  [6162] = 4326,
  [6163] = 4327,
  [6164] = 4249,
  [6165] = 4250,
  [6166] = 4300,
  [6167] = 4301,
  [6168] = 4324,
  [6169] = 4338,
  [6170] = 4339,
  [6171] = 4340,
  [6172] = 4341,
  [6173] = 4342,
  [6174] = 4344,
  [6175] = 4345,
  [6176] = 4346,
  [6177] = 4347,
  [6178] = 4348,
  [6179] = 4245,
  [6180] = 4350,
  [6181] = 4351,
  [6182] = 4353,
  [6183] = 4354,
  [6184] = 4355,
  [6185] = 4356,
  [6186] = 4322,
  [6187] = 4291,
  [6188] = 4293,
  [6189] = 4320,
  [6190] = 4265,
  [6191] = 4321,
  [6192] = 4105,
  [6193] = 5662,
  [6194] = 4322,
  [6195] = 4369,
  [6196] = 4359,
  [6197] = 4252,
  [6198] = 4435,
  [6199] = 4105,
  [6200] = 4295,
  [6201] = 4265,
  [6202] = 4483,
  [6203] = 4105,
  [6204] = 5697,
  [6205] = 4289,
  [6206] = 4325,
  [6207] = 4292,
  [6208] = 4326,
  [6209] = 4327,
  [6210] = 4260,
  [6211] = 4268,
  [6212] = 4275,
  [6213] = 4290,
  [6214] = 4249,
  [6215] = 4425,
  [6216] = 4250,
  [6217] = 4430,
  [6218] = 4300,
  [6219] = 4446,
  [6220] = 4447,
  [6221] = 4453,
  [6222] = 4465,
  [6223] = 4467,
  [6224] = 4301,
  [6225] = 4324,
  [6226] = 4338,
  [6227] = 4339,
  [6228] = 4340,
  [6229] = 4341,
  [6230] = 4342,
  [6231] = 4344,
  [6232] = 4345,
  [6233] = 4346,
  [6234] = 4347,
  [6235] = 5662,
  [6236] = 4348,
  [6237] = 6237,
  [6238] = 5697,
  [6239] = 4245,
  [6240] = 4350,
  [6241] = 4351,
  [6242] = 4353,
  [6243] = 4354,
  [6244] = 4355,
  [6245] = 4356,
  [6246] = 4144,
  [6247] = 4295,
  [6248] = 4265,
  [6249] = 4359,
  [6250] = 4112,
  [6251] = 4105,
  [6252] = 4131,
  [6253] = 4105,
  [6254] = 6237,
  [6255] = 4322,
  [6256] = 4118,
  [6257] = 4125,
  [6258] = 4129,
  [6259] = 4123,
  [6260] = 4322,
  [6261] = 4124,
  [6262] = 4458,
  [6263] = 4459,
  [6264] = 4152,
  [6265] = 4248,
  [6266] = 4153,
  [6267] = 4112,
  [6268] = 4289,
  [6269] = 4295,
  [6270] = 4292,
  [6271] = 4369,
  [6272] = 5256,
  [6273] = 4252,
  [6274] = 4260,
  [6275] = 4268,
  [6276] = 4275,
  [6277] = 4290,
  [6278] = 4105,
  [6279] = 4425,
  [6280] = 4430,
  [6281] = 4435,
  [6282] = 4483,
  [6283] = 4446,
  [6284] = 4447,
  [6285] = 4453,
  [6286] = 4465,
  [6287] = 4467,
  [6288] = 4483,
  [6289] = 4171,
  [6290] = 4302,
  [6291] = 4173,
  [6292] = 4174,
  [6293] = 4175,
  [6294] = 4308,
  [6295] = 4309,
  [6296] = 4265,
  [6297] = 4179,
  [6298] = 4291,
  [6299] = 4293,
  [6300] = 4320,
  [6301] = 4321,
  [6302] = 4180,
  [6303] = 4325,
  [6304] = 4326,
  [6305] = 4327,
  [6306] = 4249,
  [6307] = 4250,
  [6308] = 4302,
  [6309] = 4300,
  [6310] = 4301,
  [6311] = 4324,
  [6312] = 4338,
  [6313] = 4339,
  [6314] = 4340,
  [6315] = 4341,
  [6316] = 4342,
  [6317] = 4308,
  [6318] = 4309,
  [6319] = 4344,
  [6320] = 4345,
  [6321] = 4346,
  [6322] = 4347,
  [6323] = 4348,
  [6324] = 4245,
  [6325] = 4350,
  [6326] = 4351,
  [6327] = 4353,
  [6328] = 4354,
  [6329] = 4355,
  [6330] = 4356,
  [6331] = 4275,
  [6332] = 4467,
  [6333] = 4245,
  [6334] = 4628,
  [6335] = 4105,
  [6336] = 5953,
  [6337] = 4112,
  [6338] = 4105,
  [6339] = 4144,
  [6340] = 4159,
  [6341] = 4160,
  [6342] = 4164,
  [6343] = 4165,
  [6344] = 4144,
  [6345] = 4105,
  [6346] = 4105,
  [6347] = 4105,
  [6348] = 4159,
  [6349] = 4160,
  [6350] = 4164,
  [6351] = 4165,
  [6352] = 4105,
  [6353] = 4353,
  [6354] = 4322,
  [6355] = 4112,
  [6356] = 6237,
  [6357] = 6237,
  [6358] = 4118,
  [6359] = 4125,
  [6360] = 4129,
  [6361] = 6361,
  [6362] = 5662,
  [6363] = 4123,
  [6364] = 6361,
  [6365] = 4124,
  [6366] = 4302,
  [6367] = 4354,
  [6368] = 5697,
  [6369] = 4105,
  [6370] = 4458,
  [6371] = 4459,
  [6372] = 4131,
  [6373] = 4248,
  [6374] = 4308,
  [6375] = 4309,
  [6376] = 5953,
  [6377] = 4131,
  [6378] = 4076,
  [6379] = 4112,
  [6380] = 4289,
  [6381] = 4292,
  [6382] = 4369,
  [6383] = 4355,
  [6384] = 4252,
  [6385] = 4152,
  [6386] = 4260,
  [6387] = 4268,
  [6388] = 4153,
  [6389] = 4112,
  [6390] = 4275,
  [6391] = 4290,
  [6392] = 4425,
  [6393] = 4112,
  [6394] = 4430,
  [6395] = 4435,
  [6396] = 4356,
  [6397] = 4446,
  [6398] = 4112,
  [6399] = 4447,
  [6400] = 5953,
  [6401] = 4453,
  [6402] = 4465,
  [6403] = 4346,
  [6404] = 4131,
  [6405] = 4483,
  [6406] = 6237,
  [6407] = 4350,
  [6408] = 5953,
  [6409] = 4291,
  [6410] = 4293,
  [6411] = 5953,
  [6412] = 4320,
  [6413] = 4112,
  [6414] = 4321,
  [6415] = 4131,
  [6416] = 4171,
  [6417] = 4325,
  [6418] = 4326,
  [6419] = 4327,
  [6420] = 4173,
  [6421] = 4174,
  [6422] = 4249,
  [6423] = 4175,
  [6424] = 4250,
  [6425] = 4300,
  [6426] = 4301,
  [6427] = 4112,
  [6428] = 4179,
  [6429] = 4180,
  [6430] = 4131,
  [6431] = 4324,
  [6432] = 4181,
  [6433] = 4338,
  [6434] = 4339,
  [6435] = 4340,
  [6436] = 4341,
  [6437] = 4342,
  [6438] = 4182,
  [6439] = 4183,
  [6440] = 4105,
  [6441] = 4184,
  [6442] = 4351,
  [6443] = 4344,
  [6444] = 6237,
  [6445] = 6237,
  [6446] = 4359,
  [6447] = 4131,
  [6448] = 4159,
  [6449] = 4160,
  [6450] = 4144,
  [6451] = 4347,
  [6452] = 4348,
  [6453] = 4164,
  [6454] = 4265,
  [6455] = 4165,
  [6456] = 4295,
  [6457] = 4131,
  [6458] = 4131,
  [6459] = 4345,
  [6460] = 4105,
  [6461] = 4322,
  [6462] = 4321,
  [6463] = 4458,
  [6464] = 4353,
  [6465] = 4354,
  [6466] = 4301,
  [6467] = 4324,
  [6468] = 6237,
  [6469] = 4302,
  [6470] = 4144,
  [6471] = 4355,
  [6472] = 4152,
  [6473] = 4159,
  [6474] = 4356,
  [6475] = 4160,
  [6476] = 4338,
  [6477] = 4339,
  [6478] = 4340,
  [6479] = 4341,
  [6480] = 4153,
  [6481] = 4164,
  [6482] = 4342,
  [6483] = 4265,
  [6484] = 4165,
  [6485] = 4308,
  [6486] = 4325,
  [6487] = 4326,
  [6488] = 4160,
  [6489] = 4327,
  [6490] = 4309,
  [6491] = 4144,
  [6492] = 4344,
  [6493] = 4131,
  [6494] = 4105,
  [6495] = 4345,
  [6496] = 5953,
  [6497] = 4346,
  [6498] = 4369,
  [6499] = 4347,
  [6500] = 4245,
  [6501] = 4252,
  [6502] = 4350,
  [6503] = 4435,
  [6504] = 4159,
  [6505] = 4351,
  [6506] = 4435,
  [6507] = 4160,
  [6508] = 4353,
  [6509] = 4354,
  [6510] = 4355,
  [6511] = 4356,
  [6512] = 4164,
  [6513] = 4483,
  [6514] = 4165,
  [6515] = 4144,
  [6516] = 6516,
  [6517] = 4348,
  [6518] = 4245,
  [6519] = 4308,
  [6520] = 4249,
  [6521] = 4144,
  [6522] = 4458,
  [6523] = 4350,
  [6524] = 4289,
  [6525] = 4292,
  [6526] = 4250,
  [6527] = 6361,
  [6528] = 4171,
  [6529] = 4164,
  [6530] = 4459,
  [6531] = 4351,
  [6532] = 4260,
  [6533] = 4268,
  [6534] = 4275,
  [6535] = 4353,
  [6536] = 4354,
  [6537] = 4290,
  [6538] = 4173,
  [6539] = 4174,
  [6540] = 4175,
  [6541] = 4165,
  [6542] = 4425,
  [6543] = 4355,
  [6544] = 4430,
  [6545] = 4356,
  [6546] = 4309,
  [6547] = 4179,
  [6548] = 4180,
  [6549] = 4181,
  [6550] = 4340,
  [6551] = 4320,
  [6552] = 4446,
  [6553] = 4159,
  [6554] = 4447,
  [6555] = 4160,
  [6556] = 4112,
  [6557] = 4182,
  [6558] = 4183,
  [6559] = 4453,
  [6560] = 4465,
  [6561] = 4184,
  [6562] = 4467,
  [6563] = 4325,
  [6564] = 4326,
  [6565] = 4248,
  [6566] = 4164,
  [6567] = 4302,
  [6568] = 4327,
  [6569] = 4291,
  [6570] = 4165,
  [6571] = 4159,
  [6572] = 4112,
  [6573] = 4144,
  [6574] = 4369,
  [6575] = 4144,
  [6576] = 4291,
  [6577] = 4321,
  [6578] = 4300,
  [6579] = 4301,
  [6580] = 4293,
  [6581] = 4345,
  [6582] = 4346,
  [6583] = 6583,
  [6584] = 6584,
  [6585] = 4160,
  [6586] = 4164,
  [6587] = 4165,
  [6588] = 6588,
  [6589] = 4105,
  [6590] = 4347,
  [6591] = 4265,
  [6592] = 6583,
  [6593] = 5044,
  [6594] = 4250,
  [6595] = 4300,
  [6596] = 6516,
  [6597] = 4105,
  [6598] = 4301,
  [6599] = 4112,
  [6600] = 6237,
  [6601] = 6601,
  [6602] = 4105,
  [6603] = 6584,
  [6604] = 4131,
  [6605] = 4105,
  [6606] = 6237,
  [6607] = 4144,
  [6608] = 4159,
  [6609] = 4159,
  [6610] = 4160,
  [6611] = 4164,
  [6612] = 4165,
  [6613] = 4159,
  [6614] = 4160,
  [6615] = 6588,
  [6616] = 4164,
  [6617] = 4252,
  [6618] = 4165,
  [6619] = 4293,
  [6620] = 4295,
  [6621] = 4295,
  [6622] = 4341,
  [6623] = 5953,
  [6624] = 4144,
  [6625] = 4105,
  [6626] = 4320,
  [6627] = 4483,
  [6628] = 4320,
  [6629] = 4324,
  [6630] = 4348,
  [6631] = 4159,
  [6632] = 4160,
  [6633] = 4321,
  [6634] = 4338,
  [6635] = 4339,
  [6636] = 4340,
  [6637] = 4112,
  [6638] = 4324,
  [6639] = 4341,
  [6640] = 4342,
  [6641] = 4322,
  [6642] = 4483,
  [6643] = 4164,
  [6644] = 4131,
  [6645] = 4165,
  [6646] = 4435,
  [6647] = 4325,
  [6648] = 4359,
  [6649] = 4131,
  [6650] = 4144,
  [6651] = 4326,
  [6652] = 4344,
  [6653] = 4338,
  [6654] = 6601,
  [6655] = 4265,
  [6656] = 4345,
  [6657] = 4291,
  [6658] = 4131,
  [6659] = 4327,
  [6660] = 5953,
  [6661] = 4346,
  [6662] = 4347,
  [6663] = 6361,
  [6664] = 4458,
  [6665] = 4144,
  [6666] = 4459,
  [6667] = 4348,
  [6668] = 4295,
  [6669] = 4322,
  [6670] = 6361,
  [6671] = 4245,
  [6672] = 4339,
  [6673] = 4369,
  [6674] = 4293,
  [6675] = 4248,
  [6676] = 4308,
  [6677] = 4249,
  [6678] = 4250,
  [6679] = 6361,
  [6680] = 4350,
  [6681] = 4459,
  [6682] = 4309,
  [6683] = 4252,
  [6684] = 4131,
  [6685] = 4112,
  [6686] = 4248,
  [6687] = 4351,
  [6688] = 4105,
  [6689] = 4112,
  [6690] = 4076,
  [6691] = 4302,
  [6692] = 4300,
  [6693] = 4342,
  [6694] = 6361,
  [6695] = 4105,
  [6696] = 4344,
  [6697] = 4249,
  [6698] = 5953,
  [6699] = 4295,
  [6700] = 4248,
  [6701] = 6583,
  [6702] = 6584,
  [6703] = 6588,
  [6704] = 6704,
  [6705] = 6705,
  [6706] = 6237,
  [6707] = 6707,
  [6708] = 6708,
  [6709] = 6709,
  [6710] = 6710,
  [6711] = 4144,
  [6712] = 4159,
  [6713] = 4160,
  [6714] = 4164,
  [6715] = 4165,
  [6716] = 4144,
  [6717] = 4105,
  [6718] = 4144,
  [6719] = 4291,
  [6720] = 4293,
  [6721] = 6516,
  [6722] = 4105,
  [6723] = 4458,
  [6724] = 4459,
  [6725] = 4320,
  [6726] = 4248,
  [6727] = 4321,
  [6728] = 4144,
  [6729] = 4291,
  [6730] = 4293,
  [6731] = 4369,
  [6732] = 4320,
  [6733] = 4458,
  [6734] = 4321,
  [6735] = 4459,
  [6736] = 4302,
  [6737] = 4325,
  [6738] = 4248,
  [6739] = 4326,
  [6740] = 4327,
  [6741] = 4249,
  [6742] = 4250,
  [6743] = 4252,
  [6744] = 4300,
  [6745] = 4301,
  [6746] = 4324,
  [6747] = 4338,
  [6748] = 4308,
  [6749] = 4309,
  [6750] = 4105,
  [6751] = 4339,
  [6752] = 6583,
  [6753] = 4144,
  [6754] = 4340,
  [6755] = 4341,
  [6756] = 4342,
  [6757] = 4344,
  [6758] = 4345,
  [6759] = 6584,
  [6760] = 6588,
  [6761] = 4105,
  [6762] = 4159,
  [6763] = 4160,
  [6764] = 4164,
  [6765] = 4165,
  [6766] = 4346,
  [6767] = 4347,
  [6768] = 4348,
  [6769] = 4245,
  [6770] = 6601,
  [6771] = 4291,
  [6772] = 4144,
  [6773] = 4293,
  [6774] = 6774,
  [6775] = 4320,
  [6776] = 4321,
  [6777] = 4322,
  [6778] = 4435,
  [6779] = 4350,
  [6780] = 6780,
  [6781] = 4325,
  [6782] = 4326,
  [6783] = 4327,
  [6784] = 4249,
  [6785] = 4250,
  [6786] = 4351,
  [6787] = 6787,
  [6788] = 4300,
  [6789] = 4301,
  [6790] = 4324,
  [6791] = 4338,
  [6792] = 4353,
  [6793] = 4339,
  [6794] = 4340,
  [6795] = 4341,
  [6796] = 4342,
  [6797] = 4354,
  [6798] = 4355,
  [6799] = 4344,
  [6800] = 4345,
  [6801] = 6801,
  [6802] = 4346,
  [6803] = 4347,
  [6804] = 4348,
  [6805] = 4245,
  [6806] = 4350,
  [6807] = 4351,
  [6808] = 4353,
  [6809] = 4354,
  [6810] = 4355,
  [6811] = 4356,
  [6812] = 4144,
  [6813] = 6237,
  [6814] = 6361,
  [6815] = 4356,
  [6816] = 6704,
  [6817] = 6817,
  [6818] = 4295,
  [6819] = 6237,
  [6820] = 4265,
  [6821] = 4322,
  [6822] = 4483,
  [6823] = 4105,
  [6824] = 4144,
  [6825] = 4159,
  [6826] = 4160,
  [6827] = 4164,
  [6828] = 4165,
  [6829] = 4369,
  [6830] = 6361,
  [6831] = 6831,
  [6832] = 4144,
  [6833] = 4359,
  [6834] = 4325,
  [6835] = 4326,
  [6836] = 4144,
  [6837] = 4327,
  [6838] = 4249,
  [6839] = 4250,
  [6840] = 4252,
  [6841] = 4300,
  [6842] = 4105,
  [6843] = 4301,
  [6844] = 4324,
  [6845] = 4338,
  [6846] = 4339,
  [6847] = 4159,
  [6848] = 4160,
  [6849] = 4164,
  [6850] = 4165,
  [6851] = 4340,
  [6852] = 4341,
  [6853] = 4342,
  [6854] = 6854,
  [6855] = 6855,
  [6856] = 4344,
  [6857] = 6704,
  [6858] = 4345,
  [6859] = 4346,
  [6860] = 6361,
  [6861] = 4347,
  [6862] = 4348,
  [6863] = 4245,
  [6864] = 4435,
  [6865] = 4350,
  [6866] = 6583,
  [6867] = 6584,
  [6868] = 6588,
  [6869] = 6516,
  [6870] = 4351,
  [6871] = 4291,
  [6872] = 4353,
  [6873] = 4293,
  [6874] = 4458,
  [6875] = 4144,
  [6876] = 4295,
  [6877] = 4459,
  [6878] = 4265,
  [6879] = 6237,
  [6880] = 6601,
  [6881] = 4320,
  [6882] = 4321,
  [6883] = 6883,
  [6884] = 4354,
  [6885] = 6885,
  [6886] = 6516,
  [6887] = 4265,
  [6888] = 4355,
  [6889] = 6889,
  [6890] = 6890,
  [6891] = 4325,
  [6892] = 6817,
  [6893] = 4326,
  [6894] = 4327,
  [6895] = 6601,
  [6896] = 6583,
  [6897] = 6584,
  [6898] = 6588,
  [6899] = 4249,
  [6900] = 4250,
  [6901] = 4300,
  [6902] = 4322,
  [6903] = 4301,
  [6904] = 4324,
  [6905] = 4338,
  [6906] = 4339,
  [6907] = 4340,
  [6908] = 4248,
  [6909] = 4341,
  [6910] = 4342,
  [6911] = 6516,
  [6912] = 5953,
  [6913] = 4344,
  [6914] = 4345,
  [6915] = 4346,
  [6916] = 4347,
  [6917] = 4348,
  [6918] = 4245,
  [6919] = 6601,
  [6920] = 5953,
  [6921] = 4350,
  [6922] = 6774,
  [6923] = 4351,
  [6924] = 6237,
  [6925] = 4353,
  [6926] = 4354,
  [6927] = 4355,
  [6928] = 4356,
  [6929] = 4356,
  [6930] = 5662,
  [6931] = 4248,
  [6932] = 4458,
  [6933] = 6780,
  [6934] = 5697,
  [6935] = 4458,
  [6936] = 4144,
  [6937] = 4459,
  [6938] = 6938,
  [6939] = 4291,
  [6940] = 4265,
  [6941] = 6787,
  [6942] = 4248,
  [6943] = 4293,
  [6944] = 4320,
  [6945] = 4321,
  [6946] = 4322,
  [6947] = 4265,
  [6948] = 5953,
  [6949] = 4369,
  [6950] = 4369,
  [6951] = 4325,
  [6952] = 4326,
  [6953] = 4295,
  [6954] = 4327,
  [6955] = 4249,
  [6956] = 4250,
  [6957] = 6237,
  [6958] = 4302,
  [6959] = 6774,
  [6960] = 6704,
  [6961] = 6801,
  [6962] = 6962,
  [6963] = 4308,
  [6964] = 4309,
  [6965] = 6707,
  [6966] = 6708,
  [6967] = 6709,
  [6968] = 4302,
  [6969] = 6710,
  [6970] = 4252,
  [6971] = 6774,
  [6972] = 4300,
  [6973] = 4301,
  [6974] = 4324,
  [6975] = 4338,
  [6976] = 4339,
  [6977] = 4340,
  [6978] = 4265,
  [6979] = 4342,
  [6980] = 4308,
  [6981] = 6962,
  [6982] = 4309,
  [6983] = 4159,
  [6984] = 4459,
  [6985] = 4160,
  [6986] = 4344,
  [6987] = 4345,
  [6988] = 4346,
  [6989] = 4291,
  [6990] = 4347,
  [6991] = 4348,
  [6992] = 4293,
  [6993] = 6817,
  [6994] = 4320,
  [6995] = 4321,
  [6996] = 4245,
  [6997] = 4435,
  [6998] = 4325,
  [6999] = 4326,
  [7000] = 4327,
  [7001] = 4249,
  [7002] = 4250,
  [7003] = 5953,
  [7004] = 4350,
  [7005] = 4164,
  [7006] = 4351,
  [7007] = 4300,
  [7008] = 4301,
  [7009] = 4324,
  [7010] = 4338,
  [7011] = 4339,
  [7012] = 4340,
  [7013] = 4341,
  [7014] = 4342,
  [7015] = 4165,
  [7016] = 4353,
  [7017] = 4354,
  [7018] = 4344,
  [7019] = 4345,
  [7020] = 4346,
  [7021] = 4347,
  [7022] = 4348,
  [7023] = 4245,
  [7024] = 4355,
  [7025] = 4356,
  [7026] = 4350,
  [7027] = 4351,
  [7028] = 4353,
  [7029] = 4354,
  [7030] = 4355,
  [7031] = 4356,
  [7032] = 4289,
  [7033] = 4295,
  [7034] = 4292,
  [7035] = 4295,
  [7036] = 4369,
  [7037] = 4322,
  [7038] = 4302,
  [7039] = 4252,
  [7040] = 4483,
  [7041] = 4260,
  [7042] = 4268,
  [7043] = 4275,
  [7044] = 4290,
  [7045] = 6583,
  [7046] = 6584,
  [7047] = 6588,
  [7048] = 4308,
  [7049] = 4309,
  [7050] = 4425,
  [7051] = 4430,
  [7052] = 4435,
  [7053] = 4446,
  [7054] = 4447,
  [7055] = 5953,
  [7056] = 4453,
  [7057] = 4465,
  [7058] = 4467,
  [7059] = 4322,
  [7060] = 4483,
  [7061] = 6831,
  [7062] = 4302,
  [7063] = 4252,
  [7064] = 4291,
  [7065] = 6854,
  [7066] = 4293,
  [7067] = 6883,
  [7068] = 4320,
  [7069] = 4321,
  [7070] = 4369,
  [7071] = 7071,
  [7072] = 7072,
  [7073] = 7073,
  [7074] = 7074,
  [7075] = 7075,
  [7076] = 7074,
  [7077] = 7071,
  [7078] = 7072,
  [7079] = 7073,
  [7080] = 7080,
  [7081] = 4459,
  [7082] = 7075,
  [7083] = 7080,
  [7084] = 7075,
  [7085] = 6885,
  [7086] = 6890,
  [7087] = 4483,
  [7088] = 4325,
  [7089] = 4326,
  [7090] = 4327,
  [7091] = 4105,
  [7092] = 4249,
  [7093] = 4458,
  [7094] = 4459,
  [7095] = 4291,
  [7096] = 4250,
  [7097] = 4293,
  [7098] = 6889,
  [7099] = 4320,
  [7100] = 4321,
  [7101] = 4302,
  [7102] = 6938,
  [7103] = 4248,
  [7104] = 4325,
  [7105] = 6817,
  [7106] = 6705,
  [7107] = 4326,
  [7108] = 4252,
  [7109] = 4327,
  [7110] = 4249,
  [7111] = 4250,
  [7112] = 4300,
  [7113] = 4301,
  [7114] = 4324,
  [7115] = 4338,
  [7116] = 4339,
  [7117] = 4340,
  [7118] = 4341,
  [7119] = 4342,
  [7120] = 4295,
  [7121] = 4300,
  [7122] = 4301,
  [7123] = 4308,
  [7124] = 4309,
  [7125] = 4324,
  [7126] = 4344,
  [7127] = 4338,
  [7128] = 4339,
  [7129] = 4340,
  [7130] = 4341,
  [7131] = 4342,
  [7132] = 6855,
  [7133] = 6705,
  [7134] = 4345,
  [7135] = 4346,
  [7136] = 4347,
  [7137] = 4348,
  [7138] = 4344,
  [7139] = 4345,
  [7140] = 4346,
  [7141] = 4347,
  [7142] = 4348,
  [7143] = 4245,
  [7144] = 6516,
  [7145] = 4245,
  [7146] = 4350,
  [7147] = 4435,
  [7148] = 4351,
  [7149] = 4350,
  [7150] = 4351,
  [7151] = 4353,
  [7152] = 4353,
  [7153] = 4354,
  [7154] = 4354,
  [7155] = 4355,
  [7156] = 4356,
  [7157] = 4355,
  [7158] = 4356,
  [7159] = 4144,
  [7160] = 4112,
  [7161] = 4458,
  [7162] = 4459,
  [7163] = 4265,
  [7164] = 4369,
  [7165] = 4483,
  [7166] = 4248,
  [7167] = 4252,
  [7168] = 4302,
  [7169] = 4308,
  [7170] = 4309,
  [7171] = 4435,
  [7172] = 4308,
  [7173] = 4309,
  [7174] = 4483,
  [7175] = 4435,
  [7176] = 6705,
  [7177] = 4295,
  [7178] = 4265,
  [7179] = 4302,
  [7180] = 4483,
  [7181] = 4369,
  [7182] = 4252,
  [7183] = 5953,
  [7184] = 4435,
  [7185] = 4295,
  [7186] = 4322,
  [7187] = 4308,
  [7188] = 6601,
  [7189] = 4309,
  [7190] = 4131,
  [7191] = 6237,
  [7192] = 4159,
  [7193] = 4483,
  [7194] = 4160,
  [7195] = 4164,
  [7196] = 4165,
  [7197] = 4105,
  [7198] = 4295,
  [7199] = 4076,
  [7200] = 4086,
  [7201] = 4105,
  [7202] = 4458,
  [7203] = 4322,
  [7204] = 4341,
  [7205] = 4347,
  [7206] = 4301,
  [7207] = 7207,
  [7208] = 6516,
  [7209] = 7209,
  [7210] = 7210,
  [7211] = 5953,
  [7212] = 4308,
  [7213] = 4309,
  [7214] = 7214,
  [7215] = 4159,
  [7216] = 4160,
  [7217] = 7214,
  [7218] = 4164,
  [7219] = 7219,
  [7220] = 4165,
  [7221] = 6962,
  [7222] = 7222,
  [7223] = 7223,
  [7224] = 7224,
  [7225] = 6361,
  [7226] = 7226,
  [7227] = 7214,
  [7228] = 6774,
  [7229] = 7229,
  [7230] = 6787,
  [7231] = 7223,
  [7232] = 4321,
  [7233] = 7214,
  [7234] = 4295,
  [7235] = 4265,
  [7236] = 7214,
  [7237] = 6817,
  [7238] = 4350,
  [7239] = 6361,
  [7240] = 4325,
  [7241] = 7214,
  [7242] = 6237,
  [7243] = 7243,
  [7244] = 7244,
  [7245] = 7214,
  [7246] = 4302,
  [7247] = 7214,
  [7248] = 6938,
  [7249] = 7249,
  [7250] = 7250,
  [7251] = 7224,
  [7252] = 7214,
  [7253] = 7250,
  [7254] = 4308,
  [7255] = 4309,
  [7256] = 7256,
  [7257] = 7257,
  [7258] = 6601,
  [7259] = 4324,
  [7260] = 4483,
  [7261] = 7261,
  [7262] = 4458,
  [7263] = 7071,
  [7264] = 7264,
  [7265] = 4144,
  [7266] = 7266,
  [7267] = 4459,
  [7268] = 4458,
  [7269] = 4144,
  [7270] = 4459,
  [7271] = 4291,
  [7272] = 7272,
  [7273] = 7273,
  [7274] = 4293,
  [7275] = 4320,
  [7276] = 4321,
  [7277] = 7072,
  [7278] = 7214,
  [7279] = 7214,
  [7280] = 4248,
  [7281] = 4325,
  [7282] = 4326,
  [7283] = 4327,
  [7284] = 4249,
  [7285] = 4250,
  [7286] = 7256,
  [7287] = 7226,
  [7288] = 4265,
  [7289] = 7289,
  [7290] = 7249,
  [7291] = 7291,
  [7292] = 4300,
  [7293] = 4301,
  [7294] = 7294,
  [7295] = 7295,
  [7296] = 4324,
  [7297] = 7297,
  [7298] = 6817,
  [7299] = 6705,
  [7300] = 4338,
  [7301] = 4339,
  [7302] = 4340,
  [7303] = 4341,
  [7304] = 4342,
  [7305] = 7305,
  [7306] = 7229,
  [7307] = 7272,
  [7308] = 7249,
  [7309] = 7309,
  [7310] = 7310,
  [7311] = 7261,
  [7312] = 7071,
  [7313] = 4344,
  [7314] = 4345,
  [7315] = 7266,
  [7316] = 4346,
  [7317] = 4347,
  [7318] = 4348,
  [7319] = 4245,
  [7320] = 7273,
  [7321] = 7321,
  [7322] = 7322,
  [7323] = 7072,
  [7324] = 7324,
  [7325] = 7325,
  [7326] = 7326,
  [7327] = 7327,
  [7328] = 7328,
  [7329] = 7321,
  [7330] = 7305,
  [7331] = 4350,
  [7332] = 4351,
  [7333] = 7073,
  [7334] = 4353,
  [7335] = 4354,
  [7336] = 7336,
  [7337] = 6890,
  [7338] = 4355,
  [7339] = 4356,
  [7340] = 7340,
  [7341] = 7341,
  [7342] = 4105,
  [7343] = 7073,
  [7344] = 4291,
  [7345] = 4351,
  [7346] = 5953,
  [7347] = 4293,
  [7348] = 7229,
  [7349] = 7272,
  [7350] = 7249,
  [7351] = 6890,
  [7352] = 4338,
  [7353] = 4320,
  [7354] = 4321,
  [7355] = 7355,
  [7356] = 6962,
  [7357] = 7214,
  [7358] = 6938,
  [7359] = 7359,
  [7360] = 7360,
  [7361] = 7361,
  [7362] = 6707,
  [7363] = 4325,
  [7364] = 4326,
  [7365] = 4327,
  [7366] = 4249,
  [7367] = 4250,
  [7368] = 6707,
  [7369] = 7369,
  [7370] = 4458,
  [7371] = 4144,
  [7372] = 4459,
  [7373] = 4105,
  [7374] = 7214,
  [7375] = 4300,
  [7376] = 4301,
  [7377] = 7377,
  [7378] = 4324,
  [7379] = 7379,
  [7380] = 4338,
  [7381] = 5953,
  [7382] = 4339,
  [7383] = 4340,
  [7384] = 4341,
  [7385] = 4342,
  [7386] = 4325,
  [7387] = 6705,
  [7388] = 6890,
  [7389] = 6708,
  [7390] = 7390,
  [7391] = 4339,
  [7392] = 6361,
  [7393] = 4248,
  [7394] = 4344,
  [7395] = 4345,
  [7396] = 7309,
  [7397] = 4346,
  [7398] = 6709,
  [7399] = 4348,
  [7400] = 4245,
  [7401] = 4340,
  [7402] = 7402,
  [7403] = 4248,
  [7404] = 7404,
  [7405] = 7075,
  [7406] = 4350,
  [7407] = 4351,
  [7408] = 7408,
  [7409] = 7409,
  [7410] = 4353,
  [7411] = 4354,
  [7412] = 7412,
  [7413] = 7214,
  [7414] = 4355,
  [7415] = 4356,
  [7416] = 7243,
  [7417] = 7417,
  [7418] = 7322,
  [7419] = 6710,
  [7420] = 7420,
  [7421] = 7421,
  [7422] = 4341,
  [7423] = 7355,
  [7424] = 7424,
  [7425] = 4342,
  [7426] = 7426,
  [7427] = 4355,
  [7428] = 7214,
  [7429] = 7210,
  [7430] = 7430,
  [7431] = 7431,
  [7432] = 7295,
  [7433] = 7433,
  [7434] = 4369,
  [7435] = 4356,
  [7436] = 7436,
  [7437] = 6938,
  [7438] = 4295,
  [7439] = 4105,
  [7440] = 7214,
  [7441] = 7226,
  [7442] = 4344,
  [7443] = 4302,
  [7444] = 4252,
  [7445] = 6705,
  [7446] = 4265,
  [7447] = 6801,
  [7448] = 6780,
  [7449] = 6237,
  [7450] = 4345,
  [7451] = 4144,
  [7452] = 6962,
  [7453] = 7214,
  [7454] = 6801,
  [7455] = 6780,
  [7456] = 4346,
  [7457] = 4308,
  [7458] = 4309,
  [7459] = 7359,
  [7460] = 7075,
  [7461] = 6787,
  [7462] = 4105,
  [7463] = 7321,
  [7464] = 7464,
  [7465] = 7214,
  [7466] = 7466,
  [7467] = 6707,
  [7468] = 6708,
  [7469] = 4435,
  [7470] = 6709,
  [7471] = 7214,
  [7472] = 4326,
  [7473] = 6710,
  [7474] = 4347,
  [7475] = 7475,
  [7476] = 6938,
  [7477] = 4348,
  [7478] = 6831,
  [7479] = 4327,
  [7480] = 6801,
  [7481] = 7340,
  [7482] = 6883,
  [7483] = 4291,
  [7484] = 6885,
  [7485] = 4458,
  [7486] = 4144,
  [7487] = 4459,
  [7488] = 4295,
  [7489] = 7074,
  [7490] = 6889,
  [7491] = 7214,
  [7492] = 6774,
  [7493] = 6817,
  [7494] = 7214,
  [7495] = 4293,
  [7496] = 4322,
  [7497] = 6817,
  [7498] = 7498,
  [7499] = 4483,
  [7500] = 7214,
  [7501] = 6962,
  [7502] = 4248,
  [7503] = 6705,
  [7504] = 6890,
  [7505] = 4320,
  [7506] = 7506,
  [7507] = 4321,
  [7508] = 7508,
  [7509] = 4249,
  [7510] = 6854,
  [7511] = 6855,
  [7512] = 7475,
  [7513] = 4245,
  [7514] = 4293,
  [7515] = 5953,
  [7516] = 6707,
  [7517] = 6708,
  [7518] = 6708,
  [7519] = 6709,
  [7520] = 6710,
  [7521] = 7521,
  [7522] = 7522,
  [7523] = 4350,
  [7524] = 7524,
  [7525] = 7498,
  [7526] = 4369,
  [7527] = 7214,
  [7528] = 4250,
  [7529] = 4322,
  [7530] = 6774,
  [7531] = 6704,
  [7532] = 4325,
  [7533] = 7506,
  [7534] = 4326,
  [7535] = 7521,
  [7536] = 7536,
  [7537] = 7537,
  [7538] = 4327,
  [7539] = 4249,
  [7540] = 7294,
  [7541] = 4250,
  [7542] = 4302,
  [7543] = 4252,
  [7544] = 4300,
  [7545] = 4351,
  [7546] = 4301,
  [7547] = 6831,
  [7548] = 4324,
  [7549] = 6704,
  [7550] = 4338,
  [7551] = 4339,
  [7552] = 7552,
  [7553] = 7553,
  [7554] = 6938,
  [7555] = 7522,
  [7556] = 7524,
  [7557] = 7536,
  [7558] = 4340,
  [7559] = 4341,
  [7560] = 7560,
  [7561] = 7537,
  [7562] = 4105,
  [7563] = 4342,
  [7564] = 4308,
  [7565] = 4309,
  [7566] = 4344,
  [7567] = 4291,
  [7568] = 4345,
  [7569] = 4346,
  [7570] = 4293,
  [7571] = 6774,
  [7572] = 7572,
  [7573] = 4320,
  [7574] = 4321,
  [7575] = 7552,
  [7576] = 4347,
  [7577] = 4348,
  [7578] = 7553,
  [7579] = 4245,
  [7580] = 4435,
  [7581] = 4325,
  [7582] = 4326,
  [7583] = 4350,
  [7584] = 4327,
  [7585] = 4249,
  [7586] = 4250,
  [7587] = 4351,
  [7588] = 4353,
  [7589] = 4354,
  [7590] = 4355,
  [7591] = 7214,
  [7592] = 7360,
  [7593] = 4356,
  [7594] = 4300,
  [7595] = 4301,
  [7596] = 7560,
  [7597] = 7214,
  [7598] = 4324,
  [7599] = 4302,
  [7600] = 4338,
  [7601] = 4339,
  [7602] = 4340,
  [7603] = 4341,
  [7604] = 4342,
  [7605] = 6854,
  [7606] = 7572,
  [7607] = 6855,
  [7608] = 7214,
  [7609] = 6705,
  [7610] = 5953,
  [7611] = 7611,
  [7612] = 4483,
  [7613] = 4344,
  [7614] = 4345,
  [7615] = 7615,
  [7616] = 4346,
  [7617] = 4291,
  [7618] = 7214,
  [7619] = 5953,
  [7620] = 6709,
  [7621] = 6710,
  [7622] = 7080,
  [7623] = 4295,
  [7624] = 7071,
  [7625] = 7072,
  [7626] = 7073,
  [7627] = 7074,
  [7628] = 7214,
  [7629] = 4347,
  [7630] = 7071,
  [7631] = 7072,
  [7632] = 7073,
  [7633] = 7074,
  [7634] = 7214,
  [7635] = 7436,
  [7636] = 6883,
  [7637] = 7074,
  [7638] = 4348,
  [7639] = 6885,
  [7640] = 7640,
  [7641] = 7071,
  [7642] = 7072,
  [7643] = 7073,
  [7644] = 7075,
  [7645] = 7071,
  [7646] = 7072,
  [7647] = 7073,
  [7648] = 7080,
  [7649] = 7649,
  [7650] = 7214,
  [7651] = 6889,
  [7652] = 7652,
  [7653] = 7080,
  [7654] = 7075,
  [7655] = 7080,
  [7656] = 7214,
  [7657] = 7075,
  [7658] = 7075,
  [7659] = 4245,
  [7660] = 4369,
  [7661] = 6962,
  [7662] = 6705,
  [7663] = 6237,
  [7664] = 4350,
  [7665] = 7652,
  [7666] = 7649,
  [7667] = 4351,
  [7668] = 7214,
  [7669] = 7214,
  [7670] = 4353,
  [7671] = 4354,
  [7672] = 6237,
  [7673] = 7508,
  [7674] = 4355,
  [7675] = 4356,
  [7676] = 4293,
  [7677] = 7214,
  [7678] = 4353,
  [7679] = 6583,
  [7680] = 4369,
  [7681] = 7214,
  [7682] = 6704,
  [7683] = 4295,
  [7684] = 4354,
  [7685] = 4322,
  [7686] = 6584,
  [7687] = 6817,
  [7688] = 7222,
  [7689] = 6774,
  [7690] = 6361,
  [7691] = 4265,
  [7692] = 7214,
  [7693] = 6588,
  [7694] = 6704,
  [7695] = 7695,
  [7696] = 6801,
  [7697] = 7214,
  [7698] = 7214,
  [7699] = 6705,
  [7700] = 5953,
  [7701] = 4355,
  [7702] = 6707,
  [7703] = 6890,
  [7704] = 7214,
  [7705] = 7705,
  [7706] = 6831,
  [7707] = 6854,
  [7708] = 6855,
  [7709] = 4356,
  [7710] = 7710,
  [7711] = 7711,
  [7712] = 7712,
  [7713] = 7713,
  [7714] = 7714,
  [7715] = 7214,
  [7716] = 7716,
  [7717] = 7717,
  [7718] = 6708,
  [7719] = 6709,
  [7720] = 6710,
  [7721] = 4326,
  [7722] = 7075,
  [7723] = 7214,
  [7724] = 7724,
  [7725] = 6704,
  [7726] = 7695,
  [7727] = 7264,
  [7728] = 4327,
  [7729] = 4320,
  [7730] = 4252,
  [7731] = 7229,
  [7732] = 7214,
  [7733] = 7733,
  [7734] = 4249,
  [7735] = 6361,
  [7736] = 4252,
  [7737] = 7214,
  [7738] = 7272,
  [7739] = 4321,
  [7740] = 6883,
  [7741] = 6885,
  [7742] = 6237,
  [7743] = 6889,
  [7744] = 7214,
  [7745] = 6780,
  [7746] = 6883,
  [7747] = 6885,
  [7748] = 7226,
  [7749] = 6889,
  [7750] = 7750,
  [7751] = 6883,
  [7752] = 7214,
  [7753] = 6787,
  [7754] = 7080,
  [7755] = 6885,
  [7756] = 4483,
  [7757] = 7710,
  [7758] = 6889,
  [7759] = 7080,
  [7760] = 7417,
  [7761] = 7761,
  [7762] = 7214,
  [7763] = 7214,
  [7764] = 7764,
  [7765] = 4295,
  [7766] = 6962,
  [7767] = 7767,
  [7768] = 4300,
  [7769] = 4301,
  [7770] = 7695,
  [7771] = 4324,
  [7772] = 6817,
  [7773] = 4338,
  [7774] = 4339,
  [7775] = 7264,
  [7776] = 7214,
  [7777] = 4112,
  [7778] = 7724,
  [7779] = 4308,
  [7780] = 4309,
  [7781] = 4340,
  [7782] = 4341,
  [7783] = 4295,
  [7784] = 7214,
  [7785] = 4342,
  [7786] = 7214,
  [7787] = 7321,
  [7788] = 7464,
  [7789] = 4344,
  [7790] = 4345,
  [7791] = 4346,
  [7792] = 4347,
  [7793] = 4348,
  [7794] = 7074,
  [7795] = 4105,
  [7796] = 4458,
  [7797] = 4459,
  [7798] = 4295,
  [7799] = 4435,
  [7800] = 4245,
  [7801] = 4250,
  [7802] = 7341,
  [7803] = 4369,
  [7804] = 4291,
  [7805] = 4248,
  [7806] = 7640,
  [7807] = 6774,
  [7808] = 7695,
  [7809] = 6817,
  [7810] = 7264,
  [7811] = 6890,
  [7812] = 7214,
  [7813] = 6704,
  [7814] = 6938,
  [7815] = 6817,
  [7816] = 7750,
  [7817] = 7214,
  [7818] = 6237,
  [7819] = 6962,
  [7820] = 6831,
  [7821] = 6854,
  [7822] = 6780,
  [7823] = 4252,
  [7824] = 7705,
  [7825] = 7711,
  [7826] = 7712,
  [7827] = 7713,
  [7828] = 7714,
  [7829] = 7716,
  [7830] = 6855,
  [7831] = 7717,
  [7832] = 7324,
  [7833] = 7325,
  [7834] = 7326,
  [7835] = 7327,
  [7836] = 7328,
  [7837] = 6787,
  [7838] = 7761,
  [7839] = 7764,
  [7840] = 4295,
  [7841] = 7214,
  [7842] = 7219,
  [7843] = 4131,
  [7844] = 6938,
  [7845] = 6705,
  [7846] = 7767,
  [7847] = 4369,
  [7848] = 7848,
  [7849] = 7849,
  [7850] = 4252,
  [7851] = 4435,
  [7852] = 4105,
  [7853] = 7310,
  [7854] = 4353,
  [7855] = 4435,
  [7856] = 4354,
  [7857] = 6831,
  [7858] = 6854,
  [7859] = 7214,
  [7860] = 6855,
  [7861] = 7214,
  [7862] = 7848,
  [7863] = 4322,
  [7864] = 6705,
  [7865] = 6704,
  [7866] = 7733,
  [7867] = 4483,
  [7868] = 7336,
  [7869] = 7244,
  [7870] = 6817,
  [7871] = 6361,
  [7872] = 4300,
  [7873] = 7214,
  [7874] = 7257,
  [7875] = 4265,
  [7876] = 7849,
  [7877] = 4322,
  [7878] = 7214,
  [7879] = 6361,
  [7880] = 7361,
  [7881] = 7369,
  [7882] = 7466,
  [7883] = 7214,
  [7884] = 7412,
  [7885] = 6817,
  [7886] = 7424,
  [7887] = 7214,
  [7888] = 4458,
  [7889] = 4144,
  [7890] = 4459,
  [7891] = 7433,
  [7892] = 7214,
  [7893] = 6704,
  [7894] = 6705,
  [7895] = 6890,
  [7896] = 4322,
  [7897] = 4435,
  [7898] = 7207,
  [7899] = 6774,
  [7900] = 6237,
  [7901] = 7209,
  [7902] = 7289,
  [7903] = 4248,
  [7904] = 4265,
  [7905] = 6704,
  [7906] = 7291,
  [7907] = 7214,
  [7908] = 4295,
  [7909] = 4302,
  [7910] = 4483,
  [7911] = 6774,
  [7912] = 4320,
  [7913] = 4144,
  [7914] = 4295,
  [7915] = 7297,
  [7916] = 6801,
  [7917] = 7377,
  [7918] = 7379,
  [7919] = 7390,
  [7920] = 7402,
  [7921] = 7404,
  [7922] = 4302,
  [7923] = 7214,
  [7924] = 7408,
  [7925] = 7409,
  [7926] = 7420,
  [7927] = 7421,
  [7928] = 7426,
  [7929] = 7430,
  [7930] = 4308,
  [7931] = 4309,
  [7932] = 7431,
  [7933] = 7074,
  [7934] = 7524,
  [7935] = 7560,
  [7936] = 7572,
  [7937] = 7219,
  [7938] = 6704,
  [7939] = 7289,
  [7940] = 6361,
  [7941] = 7377,
  [7942] = 7379,
  [7943] = 7390,
  [7944] = 7402,
  [7945] = 7404,
  [7946] = 7408,
  [7947] = 7409,
  [7948] = 7420,
  [7949] = 7421,
  [7950] = 7426,
  [7951] = 7430,
  [7952] = 7431,
  [7953] = 7295,
  [7954] = 7436,
  [7955] = 7724,
  [7956] = 7080,
  [7957] = 7710,
  [7958] = 7219,
  [7959] = 7289,
  [7960] = 7377,
  [7961] = 7379,
  [7962] = 7390,
  [7963] = 7402,
  [7964] = 7075,
  [7965] = 7404,
  [7966] = 7408,
  [7967] = 7409,
  [7968] = 7420,
  [7969] = 7421,
  [7970] = 7341,
  [7971] = 7294,
  [7972] = 7426,
  [7973] = 7360,
  [7974] = 7430,
  [7975] = 7431,
  [7976] = 7295,
  [7977] = 7436,
  [7978] = 7733,
  [7979] = 7244,
  [7980] = 7695,
  [7981] = 6890,
  [7982] = 4322,
  [7983] = 4295,
  [7984] = 6938,
  [7985] = 7074,
  [7986] = 7508,
  [7987] = 7750,
  [7988] = 7761,
  [7989] = 7764,
  [7990] = 7767,
  [7991] = 7848,
  [7992] = 7553,
  [7993] = 7207,
  [7994] = 7209,
  [7995] = 7210,
  [7996] = 7223,
  [7997] = 7294,
  [7998] = 7224,
  [7999] = 7250,
  [8000] = 7705,
  [8001] = 7711,
  [8002] = 7712,
  [8003] = 7713,
  [8004] = 7714,
  [8005] = 7716,
  [8006] = 7717,
  [8007] = 7324,
  [8008] = 7325,
  [8009] = 7326,
  [8010] = 7327,
  [8011] = 7328,
  [8012] = 7256,
  [8013] = 7360,
  [8014] = 7733,
  [8015] = 6938,
  [8016] = 5953,
  [8017] = 7640,
  [8018] = 4435,
  [8019] = 7244,
  [8020] = 7310,
  [8021] = 7291,
  [8022] = 7336,
  [8023] = 7361,
  [8024] = 7369,
  [8025] = 7412,
  [8026] = 7424,
  [8027] = 7433,
  [8028] = 7226,
  [8029] = 7508,
  [8030] = 6774,
  [8031] = 7695,
  [8032] = 7750,
  [8033] = 7761,
  [8034] = 7764,
  [8035] = 7767,
  [8036] = 7226,
  [8037] = 7466,
  [8038] = 7340,
  [8039] = 7848,
  [8040] = 7849,
  [8041] = 7207,
  [8042] = 7257,
  [8043] = 7209,
  [8044] = 7210,
  [8045] = 7223,
  [8046] = 7224,
  [8047] = 4458,
  [8048] = 4144,
  [8049] = 4459,
  [8050] = 7250,
  [8051] = 7256,
  [8052] = 6801,
  [8053] = 7080,
  [8054] = 7291,
  [8055] = 7297,
  [8056] = 7261,
  [8057] = 7266,
  [8058] = 7640,
  [8059] = 7075,
  [8060] = 7273,
  [8061] = 7305,
  [8062] = 6890,
  [8063] = 7310,
  [8064] = 7336,
  [8065] = 7361,
  [8066] = 7369,
  [8067] = 7412,
  [8068] = 7424,
  [8069] = 7355,
  [8070] = 7433,
  [8071] = 7359,
  [8072] = 4131,
  [8073] = 7466,
  [8074] = 7340,
  [8075] = 6361,
  [8076] = 4248,
  [8077] = 7257,
  [8078] = 6707,
  [8079] = 6708,
  [8080] = 7243,
  [8081] = 6709,
  [8082] = 6710,
  [8083] = 7226,
  [8084] = 7297,
  [8085] = 7291,
  [8086] = 7229,
  [8087] = 7272,
  [8088] = 7249,
  [8089] = 7297,
  [8090] = 7475,
  [8091] = 7695,
  [8092] = 6817,
  [8093] = 7229,
  [8094] = 7261,
  [8095] = 7071,
  [8096] = 7266,
  [8097] = 7272,
  [8098] = 7273,
  [8099] = 7072,
  [8100] = 7498,
  [8101] = 7506,
  [8102] = 7521,
  [8103] = 7522,
  [8104] = 7249,
  [8105] = 7305,
  [8106] = 7073,
  [8107] = 7536,
  [8108] = 7264,
  [8109] = 7537,
  [8110] = 7552,
  [8111] = 7553,
  [8112] = 7560,
  [8113] = 7572,
  [8114] = 7355,
  [8115] = 7359,
  [8116] = 7226,
  [8117] = 6774,
  [8118] = 7695,
  [8119] = 6817,
  [8120] = 7724,
  [8121] = 7219,
  [8122] = 7289,
  [8123] = 7377,
  [8124] = 7379,
  [8125] = 7390,
  [8126] = 7309,
  [8127] = 7402,
  [8128] = 7404,
  [8129] = 7243,
  [8130] = 7705,
  [8131] = 7710,
  [8132] = 7711,
  [8133] = 7712,
  [8134] = 7713,
  [8135] = 7714,
  [8136] = 7716,
  [8137] = 7717,
  [8138] = 7324,
  [8139] = 7325,
  [8140] = 7326,
  [8141] = 7327,
  [8142] = 7328,
  [8143] = 7408,
  [8144] = 7409,
  [8145] = 7420,
  [8146] = 7421,
  [8147] = 7426,
  [8148] = 6780,
  [8149] = 7430,
  [8150] = 7475,
  [8151] = 7431,
  [8152] = 7295,
  [8153] = 7436,
  [8154] = 4369,
  [8155] = 7498,
  [8156] = 7506,
  [8157] = 7521,
  [8158] = 7522,
  [8159] = 7524,
  [8160] = 7536,
  [8161] = 7075,
  [8162] = 7537,
  [8163] = 7552,
  [8164] = 7553,
  [8165] = 6938,
  [8166] = 7294,
  [8167] = 7560,
  [8168] = 7572,
  [8169] = 7360,
  [8170] = 7733,
  [8171] = 7244,
  [8172] = 4295,
  [8173] = 7226,
  [8174] = 7222,
  [8175] = 7695,
  [8176] = 6817,
  [8177] = 4265,
  [8178] = 6361,
  [8179] = 7508,
  [8180] = 7750,
  [8181] = 7761,
  [8182] = 7764,
  [8183] = 7767,
  [8184] = 7848,
  [8185] = 7849,
  [8186] = 7207,
  [8187] = 7209,
  [8188] = 7210,
  [8189] = 7223,
  [8190] = 7417,
  [8191] = 7224,
  [8192] = 7250,
  [8193] = 7256,
  [8194] = 7219,
  [8195] = 6787,
  [8196] = 6962,
  [8197] = 7289,
  [8198] = 7257,
  [8199] = 7377,
  [8200] = 7379,
  [8201] = 7390,
  [8202] = 7402,
  [8203] = 7404,
  [8204] = 7408,
  [8205] = 7640,
  [8206] = 7409,
  [8207] = 7420,
  [8208] = 7421,
  [8209] = 7426,
  [8210] = 7430,
  [8211] = 7310,
  [8212] = 7336,
  [8213] = 7361,
  [8214] = 7369,
  [8215] = 7412,
  [8216] = 7424,
  [8217] = 7433,
  [8218] = 7431,
  [8219] = 7295,
  [8220] = 7436,
  [8221] = 7466,
  [8222] = 7340,
  [8223] = 7294,
  [8224] = 7261,
  [8225] = 7360,
  [8226] = 7071,
  [8227] = 7266,
  [8228] = 7733,
  [8229] = 7244,
  [8230] = 7257,
  [8231] = 6817,
  [8232] = 6705,
  [8233] = 7273,
  [8234] = 7508,
  [8235] = 7750,
  [8236] = 7761,
  [8237] = 7764,
  [8238] = 7767,
  [8239] = 7848,
  [8240] = 7849,
  [8241] = 7207,
  [8242] = 7209,
  [8243] = 7210,
  [8244] = 7223,
  [8245] = 7224,
  [8246] = 7250,
  [8247] = 7256,
  [8248] = 7072,
  [8249] = 7695,
  [8250] = 7640,
  [8251] = 6883,
  [8252] = 6774,
  [8253] = 6704,
  [8254] = 7291,
  [8255] = 7310,
  [8256] = 7297,
  [8257] = 7336,
  [8258] = 7361,
  [8259] = 7229,
  [8260] = 7261,
  [8261] = 7071,
  [8262] = 7266,
  [8263] = 7272,
  [8264] = 7273,
  [8265] = 7072,
  [8266] = 7249,
  [8267] = 7369,
  [8268] = 7264,
  [8269] = 7412,
  [8270] = 7305,
  [8271] = 7424,
  [8272] = 7433,
  [8273] = 6885,
  [8274] = 7073,
  [8275] = 6889,
  [8276] = 6890,
  [8277] = 7222,
  [8278] = 7355,
  [8279] = 7359,
  [8280] = 7466,
  [8281] = 7340,
  [8282] = 7080,
  [8283] = 7309,
  [8284] = 7464,
  [8285] = 7243,
  [8286] = 7226,
  [8287] = 6361,
  [8288] = 7321,
  [8289] = 7464,
  [8290] = 7074,
  [8291] = 7475,
  [8292] = 7498,
  [8293] = 7506,
  [8294] = 7521,
  [8295] = 7522,
  [8296] = 7524,
  [8297] = 7536,
  [8298] = 7537,
  [8299] = 7552,
  [8300] = 7553,
  [8301] = 7560,
  [8302] = 7572,
  [8303] = 7229,
  [8304] = 7272,
  [8305] = 7249,
  [8306] = 7075,
  [8307] = 6890,
  [8308] = 7322,
  [8309] = 7264,
  [8310] = 7710,
  [8311] = 7219,
  [8312] = 7289,
  [8313] = 7226,
  [8314] = 7377,
  [8315] = 7379,
  [8316] = 7390,
  [8317] = 7402,
  [8318] = 7404,
  [8319] = 7408,
  [8320] = 7409,
  [8321] = 7420,
  [8322] = 7421,
  [8323] = 7426,
  [8324] = 7430,
  [8325] = 7431,
  [8326] = 7295,
  [8327] = 7436,
  [8328] = 7724,
  [8329] = 6938,
  [8330] = 7294,
  [8331] = 7360,
  [8332] = 7733,
  [8333] = 7305,
  [8334] = 7244,
  [8335] = 7705,
  [8336] = 7508,
  [8337] = 7711,
  [8338] = 7712,
  [8339] = 7713,
  [8340] = 7714,
  [8341] = 7716,
  [8342] = 7717,
  [8343] = 7324,
  [8344] = 7325,
  [8345] = 7326,
  [8346] = 7327,
  [8347] = 7328,
  [8348] = 7222,
  [8349] = 6361,
  [8350] = 7750,
  [8351] = 7761,
  [8352] = 4302,
  [8353] = 7264,
  [8354] = 7764,
  [8355] = 7767,
  [8356] = 7848,
  [8357] = 7849,
  [8358] = 7207,
  [8359] = 7209,
  [8360] = 7210,
  [8361] = 7223,
  [8362] = 7224,
  [8363] = 7250,
  [8364] = 4308,
  [8365] = 4309,
  [8366] = 7256,
  [8367] = 7640,
  [8368] = 7226,
  [8369] = 7310,
  [8370] = 6831,
  [8371] = 7336,
  [8372] = 6854,
  [8373] = 6855,
  [8374] = 7361,
  [8375] = 7724,
  [8376] = 7322,
  [8377] = 7369,
  [8378] = 7412,
  [8379] = 7424,
  [8380] = 7433,
  [8381] = 7341,
  [8382] = 4291,
  [8383] = 4293,
  [8384] = 4320,
  [8385] = 4321,
  [8386] = 4325,
  [8387] = 4326,
  [8388] = 4327,
  [8389] = 4249,
  [8390] = 4250,
  [8391] = 7222,
  [8392] = 7466,
  [8393] = 4300,
  [8394] = 4301,
  [8395] = 7340,
  [8396] = 4324,
  [8397] = 4338,
  [8398] = 4339,
  [8399] = 4340,
  [8400] = 4341,
  [8401] = 4342,
  [8402] = 6938,
  [8403] = 4344,
  [8404] = 4345,
  [8405] = 4346,
  [8406] = 4347,
  [8407] = 4348,
  [8408] = 4245,
  [8409] = 4350,
  [8410] = 4351,
  [8411] = 4353,
  [8412] = 4354,
  [8413] = 4355,
  [8414] = 4356,
  [8415] = 4105,
  [8416] = 7073,
  [8417] = 6890,
  [8418] = 6962,
  [8419] = 7264,
  [8420] = 7321,
  [8421] = 7695,
  [8422] = 6962,
  [8423] = 6705,
  [8424] = 7264,
  [8425] = 7321,
  [8426] = 6962,
  [8427] = 7229,
  [8428] = 7272,
  [8429] = 7249,
  [8430] = 7321,
  [8431] = 7309,
  [8432] = 7321,
  [8433] = 7229,
  [8434] = 7272,
  [8435] = 7249,
  [8436] = 6962,
  [8437] = 7229,
  [8438] = 7272,
  [8439] = 7249,
  [8440] = 7322,
  [8441] = 6962,
  [8442] = 6962,
  [8443] = 4112,
  [8444] = 7355,
  [8445] = 7695,
  [8446] = 7359,
  [8447] = 7341,
  [8448] = 7724,
  [8449] = 7080,
  [8450] = 7257,
  [8451] = 7341,
  [8452] = 7649,
  [8453] = 6780,
  [8454] = 7321,
  [8455] = 7464,
  [8456] = 7074,
  [8457] = 6774,
  [8458] = 6704,
  [8459] = 7291,
  [8460] = 7297,
  [8461] = 7695,
  [8462] = 6705,
  [8463] = 7229,
  [8464] = 4483,
  [8465] = 7309,
  [8466] = 7261,
  [8467] = 6237,
  [8468] = 6361,
  [8469] = 7071,
  [8470] = 7266,
  [8471] = 7272,
  [8472] = 7273,
  [8473] = 7072,
  [8474] = 7249,
  [8475] = 7305,
  [8476] = 7073,
  [8477] = 4252,
  [8478] = 7355,
  [8479] = 7359,
  [8480] = 7243,
  [8481] = 7417,
  [8482] = 7322,
  [8483] = 7710,
  [8484] = 4144,
  [8485] = 7074,
  [8486] = 7074,
  [8487] = 7071,
  [8488] = 7072,
  [8489] = 7073,
  [8490] = 7222,
  [8491] = 7652,
  [8492] = 7080,
  [8493] = 7711,
  [8494] = 7649,
  [8495] = 7071,
  [8496] = 7072,
  [8497] = 7073,
  [8498] = 7075,
  [8499] = 7080,
  [8500] = 7652,
  [8501] = 7075,
  [8502] = 7649,
  [8503] = 7075,
  [8504] = 7652,
  [8505] = 7649,
  [8506] = 7649,
  [8507] = 7652,
  [8508] = 7075,
  [8509] = 7309,
  [8510] = 7652,
  [8511] = 7222,
  [8512] = 7711,
  [8513] = 7695,
  [8514] = 7649,
  [8515] = 7652,
  [8516] = 7649,
  [8517] = 6361,
  [8518] = 7321,
  [8519] = 7243,
  [8520] = 6705,
  [8521] = 7321,
  [8522] = 6817,
  [8523] = 7417,
  [8524] = 7322,
  [8525] = 7705,
  [8526] = 7711,
  [8527] = 7712,
  [8528] = 7713,
  [8529] = 7714,
  [8530] = 7716,
  [8531] = 7717,
  [8532] = 7324,
  [8533] = 7325,
  [8534] = 7326,
  [8535] = 7327,
  [8536] = 7328,
  [8537] = 7464,
  [8538] = 7074,
  [8539] = 7475,
  [8540] = 7705,
  [8541] = 7498,
  [8542] = 7506,
  [8543] = 7521,
  [8544] = 7710,
  [8545] = 7711,
  [8546] = 7712,
  [8547] = 7522,
  [8548] = 7226,
  [8549] = 7524,
  [8550] = 7713,
  [8551] = 7714,
  [8552] = 7716,
  [8553] = 7536,
  [8554] = 6890,
  [8555] = 7717,
  [8556] = 7324,
  [8557] = 7325,
  [8558] = 7326,
  [8559] = 7537,
  [8560] = 7552,
  [8561] = 7553,
  [8562] = 7327,
  [8563] = 4159,
  [8564] = 4160,
  [8565] = 7560,
  [8566] = 7572,
  [8567] = 4164,
  [8568] = 7328,
  [8569] = 4165,
  [8570] = 7464,
  [8571] = 7264,
  [8572] = 7705,
  [8573] = 7710,
  [8574] = 7712,
  [8575] = 7713,
  [8576] = 7714,
  [8577] = 7716,
  [8578] = 7717,
  [8579] = 6787,
  [8580] = 7417,
  [8581] = 7264,
  [8582] = 4105,
  [8583] = 7222,
  [8584] = 7652,
  [8585] = 6938,
  [8586] = 7475,
  [8587] = 7705,
  [8588] = 7710,
  [8589] = 7712,
  [8590] = 7713,
  [8591] = 7714,
  [8592] = 7716,
  [8593] = 7717,
  [8594] = 7498,
  [8595] = 7506,
  [8596] = 7521,
  [8597] = 7522,
  [8598] = 7524,
  [8599] = 7536,
  [8600] = 7537,
  [8601] = 7341,
  [8602] = 7552,
  [8603] = 7309,
  [8604] = 7322,
  [8605] = 7324,
  [8606] = 7325,
  [8607] = 7326,
  [8608] = 7327,
  [8609] = 7328,
  [8610] = 7309,
  [8611] = 7322,
  [8612] = 7324,
  [8613] = 7325,
  [8614] = 7326,
  [8615] = 7327,
  [8616] = 7328,
  [8617] = 7849,
  [8618] = 7080,
  [8619] = 7710,
  [8620] = 7417,
  [8621] = 6817,
  [8622] = 7309,
  [8623] = 6787,
  [8624] = 4252,
  [8625] = 7309,
  [8626] = 7297,
  [8627] = 7264,
  [8628] = 7219,
  [8629] = 7229,
  [8630] = 7261,
  [8631] = 4369,
  [8632] = 7071,
  [8633] = 7355,
  [8634] = 7705,
  [8635] = 6705,
  [8636] = 7711,
  [8637] = 7710,
  [8638] = 7712,
  [8639] = 6601,
  [8640] = 7713,
  [8641] = 7714,
  [8642] = 7716,
  [8643] = 7717,
  [8644] = 7324,
  [8645] = 7325,
  [8646] = 7229,
  [8647] = 7321,
  [8648] = 7359,
  [8649] = 7508,
  [8650] = 7321,
  [8651] = 5953,
  [8652] = 7750,
  [8653] = 7074,
  [8654] = 7761,
  [8655] = 7764,
  [8656] = 7767,
  [8657] = 7695,
  [8658] = 7322,
  [8659] = 7321,
  [8660] = 7705,
  [8661] = 7711,
  [8662] = 7712,
  [8663] = 7713,
  [8664] = 7714,
  [8665] = 7716,
  [8666] = 7717,
  [8667] = 7324,
  [8668] = 7325,
  [8669] = 7326,
  [8670] = 7327,
  [8671] = 7328,
  [8672] = 7229,
  [8673] = 7272,
  [8674] = 7249,
  [8675] = 7309,
  [8676] = 7326,
  [8677] = 7075,
  [8678] = 7710,
  [8679] = 7327,
  [8680] = 7848,
  [8681] = 7229,
  [8682] = 7272,
  [8683] = 7249,
  [8684] = 7322,
  [8685] = 4459,
  [8686] = 7705,
  [8687] = 7711,
  [8688] = 7309,
  [8689] = 7849,
  [8690] = 7712,
  [8691] = 7322,
  [8692] = 6962,
  [8693] = 7713,
  [8694] = 7207,
  [8695] = 7209,
  [8696] = 7714,
  [8697] = 7324,
  [8698] = 7325,
  [8699] = 7326,
  [8700] = 7327,
  [8701] = 7328,
  [8702] = 7210,
  [8703] = 7309,
  [8704] = 7223,
  [8705] = 6817,
  [8706] = 7264,
  [8707] = 7224,
  [8708] = 7328,
  [8709] = 7716,
  [8710] = 7717,
  [8711] = 7309,
  [8712] = 7324,
  [8713] = 7325,
  [8714] = 7326,
  [8715] = 7327,
  [8716] = 7322,
  [8717] = 7250,
  [8718] = 7328,
  [8719] = 7256,
  [8720] = 7322,
  [8721] = 7322,
  [8722] = 4086,
  [8723] = 7222,
  [8724] = 6704,
  [8725] = 6938,
  [8726] = 7640,
  [8727] = 4086,
  [8728] = 6361,
  [8729] = 7310,
  [8730] = 7336,
  [8731] = 7361,
  [8732] = 7369,
  [8733] = 7412,
  [8734] = 7424,
  [8735] = 7433,
  [8736] = 7611,
  [8737] = 7615,
  [8738] = 4248,
  [8739] = 7466,
  [8740] = 7649,
  [8741] = 7340,
  [8742] = 7071,
  [8743] = 6237,
  [8744] = 7327,
  [8745] = 4144,
  [8746] = 7266,
  [8747] = 7226,
  [8748] = 7272,
  [8749] = 7075,
  [8750] = 6774,
  [8751] = 6705,
  [8752] = 7695,
  [8753] = 7222,
  [8754] = 7222,
  [8755] = 7652,
  [8756] = 7072,
  [8757] = 7222,
  [8758] = 7264,
  [8759] = 7724,
  [8760] = 7080,
  [8761] = 7321,
  [8762] = 7417,
  [8763] = 7249,
  [8764] = 7464,
  [8765] = 7075,
  [8766] = 4295,
  [8767] = 6890,
  [8768] = 4291,
  [8769] = 4293,
  [8770] = 4320,
  [8771] = 7222,
  [8772] = 7652,
  [8773] = 4321,
  [8774] = 7649,
  [8775] = 4325,
  [8776] = 4326,
  [8777] = 4327,
  [8778] = 4249,
  [8779] = 4250,
  [8780] = 7074,
  [8781] = 4302,
  [8782] = 7222,
  [8783] = 4300,
  [8784] = 7243,
  [8785] = 7341,
  [8786] = 4301,
  [8787] = 7309,
  [8788] = 6583,
  [8789] = 6584,
  [8790] = 7272,
  [8791] = 4324,
  [8792] = 4338,
  [8793] = 4339,
  [8794] = 6588,
  [8795] = 4144,
  [8796] = 7649,
  [8797] = 4340,
  [8798] = 7652,
  [8799] = 7289,
  [8800] = 7652,
  [8801] = 7327,
  [8802] = 7328,
  [8803] = 4341,
  [8804] = 4342,
  [8805] = 7073,
  [8806] = 7075,
  [8807] = 7273,
  [8808] = 7072,
  [8809] = 4483,
  [8810] = 7074,
  [8811] = 4308,
  [8812] = 7377,
  [8813] = 7652,
  [8814] = 7071,
  [8815] = 7072,
  [8816] = 7073,
  [8817] = 7710,
  [8818] = 6817,
  [8819] = 6705,
  [8820] = 4309,
  [8821] = 7475,
  [8822] = 7652,
  [8823] = 7649,
  [8824] = 4344,
  [8825] = 7264,
  [8826] = 7498,
  [8827] = 4345,
  [8828] = 7506,
  [8829] = 7291,
  [8830] = 4346,
  [8831] = 7695,
  [8832] = 7257,
  [8833] = 4347,
  [8834] = 6774,
  [8835] = 7328,
  [8836] = 7649,
  [8837] = 7695,
  [8838] = 7379,
  [8839] = 7390,
  [8840] = 7402,
  [8841] = 6817,
  [8842] = 7404,
  [8843] = 7408,
  [8844] = 7409,
  [8845] = 4348,
  [8846] = 7649,
  [8847] = 4245,
  [8848] = 4350,
  [8849] = 4351,
  [8850] = 7420,
  [8851] = 7421,
  [8852] = 4353,
  [8853] = 4354,
  [8854] = 7322,
  [8855] = 7426,
  [8856] = 6962,
  [8857] = 6962,
  [8858] = 7430,
  [8859] = 7431,
  [8860] = 7295,
  [8861] = 4435,
  [8862] = 7521,
  [8863] = 7522,
  [8864] = 7524,
  [8865] = 7536,
  [8866] = 4105,
  [8867] = 7537,
  [8868] = 7436,
  [8869] = 4159,
  [8870] = 6780,
  [8871] = 7249,
  [8872] = 7326,
  [8873] = 4160,
  [8874] = 4164,
  [8875] = 4165,
  [8876] = 4265,
  [8877] = 7305,
  [8878] = 4355,
  [8879] = 7705,
  [8880] = 7711,
  [8881] = 7712,
  [8882] = 7713,
  [8883] = 6817,
  [8884] = 6705,
  [8885] = 6962,
  [8886] = 7714,
  [8887] = 7716,
  [8888] = 7717,
  [8889] = 7324,
  [8890] = 7325,
  [8891] = 4356,
  [8892] = 7326,
  [8893] = 7327,
  [8894] = 7080,
  [8895] = 7328,
  [8896] = 4086,
  [8897] = 7705,
  [8898] = 7294,
  [8899] = 7710,
  [8900] = 7711,
  [8901] = 7360,
  [8902] = 7712,
  [8903] = 7705,
  [8904] = 6962,
  [8905] = 6516,
  [8906] = 7710,
  [8907] = 7711,
  [8908] = 7222,
  [8909] = 6817,
  [8910] = 6817,
  [8911] = 7713,
  [8912] = 7733,
  [8913] = 7712,
  [8914] = 7552,
  [8915] = 7553,
  [8916] = 7560,
  [8917] = 7572,
  [8918] = 7073,
  [8919] = 7714,
  [8920] = 7713,
  [8921] = 7652,
  [8922] = 7714,
  [8923] = 7716,
  [8924] = 7244,
  [8925] = 7226,
  [8926] = 7649,
  [8927] = 7075,
  [8928] = 7705,
  [8929] = 7716,
  [8930] = 7717,
  [8931] = 7710,
  [8932] = 7324,
  [8933] = 7711,
  [8934] = 7325,
  [8935] = 7226,
  [8936] = 7717,
  [8937] = 7712,
  [8938] = 7713,
  [8939] = 7714,
  [8940] = 7716,
  [8941] = 7717,
  [8942] = 7324,
  [8943] = 7325,
  [8944] = 7326,
  [8945] = 4458,
  [8946] = 4322,
  [8947] = 7649,
  [8948] = 6707,
  [8949] = 4327,
  [8950] = 7264,
  [8951] = 4249,
  [8952] = 4250,
  [8953] = 7080,
  [8954] = 6704,
  [8955] = 4302,
  [8956] = 4144,
  [8957] = 7710,
  [8958] = 6774,
  [8959] = 6855,
  [8960] = 4291,
  [8961] = 6705,
  [8962] = 4252,
  [8963] = 4356,
  [8964] = 4293,
  [8965] = 6705,
  [8966] = 7705,
  [8967] = 6962,
  [8968] = 7711,
  [8969] = 7712,
  [8970] = 7272,
  [8971] = 6361,
  [8972] = 6780,
  [8973] = 7713,
  [8974] = 7714,
  [8975] = 7321,
  [8976] = 7716,
  [8977] = 7321,
  [8978] = 6787,
  [8979] = 4320,
  [8980] = 7229,
  [8981] = 4483,
  [8982] = 6817,
  [8983] = 4300,
  [8984] = 7272,
  [8985] = 4248,
  [8986] = 7705,
  [8987] = 7712,
  [8988] = 7713,
  [8989] = 7714,
  [8990] = 7716,
  [8991] = 7717,
  [8992] = 7324,
  [8993] = 7325,
  [8994] = 7326,
  [8995] = 7327,
  [8996] = 7328,
  [8997] = 7309,
  [8998] = 7710,
  [8999] = 7322,
  [9000] = 6962,
  [9001] = 4105,
  [9002] = 7249,
  [9003] = 7075,
  [9004] = 4321,
  [9005] = 4295,
  [9006] = 6831,
  [9007] = 4301,
  [9008] = 7322,
  [9009] = 7074,
  [9010] = 6938,
  [9011] = 7711,
  [9012] = 6962,
  [9013] = 6801,
  [9014] = 6708,
  [9015] = 4324,
  [9016] = 6709,
  [9017] = 6710,
  [9018] = 4338,
  [9019] = 4339,
  [9020] = 4340,
  [9021] = 9021,
  [9022] = 7222,
  [9023] = 7322,
  [9024] = 6774,
  [9025] = 7717,
  [9026] = 7264,
  [9027] = 4341,
  [9028] = 4322,
  [9029] = 9029,
  [9030] = 7222,
  [9031] = 7695,
  [9032] = 7652,
  [9033] = 7324,
  [9034] = 4342,
  [9035] = 4086,
  [9036] = 4458,
  [9037] = 7649,
  [9038] = 4308,
  [9039] = 7711,
  [9040] = 7325,
  [9041] = 7705,
  [9042] = 7712,
  [9043] = 7713,
  [9044] = 7714,
  [9045] = 7716,
  [9046] = 7717,
  [9047] = 7324,
  [9048] = 7325,
  [9049] = 7326,
  [9050] = 7327,
  [9051] = 7328,
  [9052] = 7309,
  [9053] = 4459,
  [9054] = 7710,
  [9055] = 7695,
  [9056] = 7074,
  [9057] = 4309,
  [9058] = 6962,
  [9059] = 7071,
  [9060] = 7072,
  [9061] = 7073,
  [9062] = 7222,
  [9063] = 7326,
  [9064] = 6883,
  [9065] = 7327,
  [9066] = 7328,
  [9067] = 7322,
  [9068] = 7249,
  [9069] = 6885,
  [9070] = 7705,
  [9071] = 7652,
  [9072] = 7711,
  [9073] = 7712,
  [9074] = 7713,
  [9075] = 7714,
  [9076] = 7716,
  [9077] = 7717,
  [9078] = 7324,
  [9079] = 7322,
  [9080] = 7325,
  [9081] = 7326,
  [9082] = 7327,
  [9083] = 7328,
  [9084] = 7705,
  [9085] = 7710,
  [9086] = 7712,
  [9087] = 7713,
  [9088] = 7714,
  [9089] = 7716,
  [9090] = 7717,
  [9091] = 7324,
  [9092] = 7325,
  [9093] = 7326,
  [9094] = 7327,
  [9095] = 7328,
  [9096] = 4344,
  [9097] = 6889,
  [9098] = 7071,
  [9099] = 4345,
  [9100] = 7710,
  [9101] = 6854,
  [9102] = 6237,
  [9103] = 4369,
  [9104] = 4086,
  [9105] = 7229,
  [9106] = 7080,
  [9107] = 7075,
  [9108] = 7652,
  [9109] = 4346,
  [9110] = 6817,
  [9111] = 4347,
  [9112] = 4348,
  [9113] = 4245,
  [9114] = 7695,
  [9115] = 4435,
  [9116] = 7222,
  [9117] = 7222,
  [9118] = 7649,
  [9119] = 4265,
  [9120] = 7695,
  [9121] = 4325,
  [9122] = 4350,
  [9123] = 7711,
  [9124] = 6704,
  [9125] = 9125,
  [9126] = 7649,
  [9127] = 4295,
  [9128] = 7226,
  [9129] = 4351,
  [9130] = 4086,
  [9131] = 7649,
  [9132] = 4353,
  [9133] = 4354,
  [9134] = 7652,
  [9135] = 7309,
  [9136] = 7652,
  [9137] = 4355,
  [9138] = 7309,
  [9139] = 7309,
  [9140] = 7072,
  [9141] = 7417,
  [9142] = 6890,
  [9143] = 4326,
  [9144] = 7073,
  [9145] = 5953,
  [9146] = 7552,
  [9147] = 7297,
  [9148] = 7261,
  [9149] = 7071,
  [9150] = 7266,
  [9151] = 7273,
  [9152] = 7072,
  [9153] = 7305,
  [9154] = 7073,
  [9155] = 7705,
  [9156] = 7711,
  [9157] = 7712,
  [9158] = 7713,
  [9159] = 7714,
  [9160] = 7716,
  [9161] = 7717,
  [9162] = 7324,
  [9163] = 7325,
  [9164] = 7326,
  [9165] = 7327,
  [9166] = 7328,
  [9167] = 7649,
  [9168] = 7355,
  [9169] = 7359,
  [9170] = 6938,
  [9171] = 7309,
  [9172] = 7705,
  [9173] = 4086,
  [9174] = 7711,
  [9175] = 7226,
  [9176] = 7243,
  [9177] = 7341,
  [9178] = 7475,
  [9179] = 7712,
  [9180] = 7713,
  [9181] = 7714,
  [9182] = 7716,
  [9183] = 7498,
  [9184] = 7506,
  [9185] = 7521,
  [9186] = 7522,
  [9187] = 7524,
  [9188] = 7536,
  [9189] = 7537,
  [9190] = 7553,
  [9191] = 7560,
  [9192] = 7572,
  [9193] = 7322,
  [9194] = 7219,
  [9195] = 7289,
  [9196] = 7377,
  [9197] = 7717,
  [9198] = 7379,
  [9199] = 7324,
  [9200] = 7390,
  [9201] = 7402,
  [9202] = 7404,
  [9203] = 7408,
  [9204] = 7409,
  [9205] = 7420,
  [9206] = 7421,
  [9207] = 7426,
  [9208] = 7430,
  [9209] = 7431,
  [9210] = 7295,
  [9211] = 7222,
  [9212] = 7226,
  [9213] = 7652,
  [9214] = 6361,
  [9215] = 7436,
  [9216] = 7417,
  [9217] = 7325,
  [9218] = 7326,
  [9219] = 7294,
  [9220] = 7327,
  [9221] = 7328,
  [9222] = 7360,
  [9223] = 7733,
  [9224] = 7309,
  [9225] = 7244,
  [9226] = 7508,
  [9227] = 7750,
  [9228] = 7761,
  [9229] = 7764,
  [9230] = 7767,
  [9231] = 7848,
  [9232] = 7849,
  [9233] = 7207,
  [9234] = 7209,
  [9235] = 7210,
  [9236] = 7264,
  [9237] = 7223,
  [9238] = 7291,
  [9239] = 7250,
  [9240] = 7256,
  [9241] = 7222,
  [9242] = 7640,
  [9243] = 7310,
  [9244] = 7336,
  [9245] = 7361,
  [9246] = 7369,
  [9247] = 7412,
  [9248] = 7424,
  [9249] = 7433,
  [9250] = 9250,
  [9251] = 7321,
  [9252] = 7649,
  [9253] = 7466,
  [9254] = 7340,
  [9255] = 7229,
  [9256] = 7272,
  [9257] = 7249,
  [9258] = 6962,
  [9259] = 7229,
  [9260] = 7272,
  [9261] = 7249,
  [9262] = 7264,
  [9263] = 7080,
  [9264] = 4086,
  [9265] = 7309,
  [9266] = 9266,
  [9267] = 7322,
  [9268] = 7075,
  [9269] = 7695,
  [9270] = 7649,
  [9271] = 7222,
  [9272] = 9272,
  [9273] = 7649,
  [9274] = 7652,
  [9275] = 7711,
  [9276] = 7652,
  [9277] = 7222,
  [9278] = 7652,
  [9279] = 4086,
  [9280] = 7322,
  [9281] = 7324,
  [9282] = 7325,
  [9283] = 7326,
  [9284] = 7327,
  [9285] = 7328,
  [9286] = 7324,
  [9287] = 7325,
  [9288] = 7326,
  [9289] = 7327,
  [9290] = 7328,
  [9291] = 7309,
  [9292] = 7724,
  [9293] = 7257,
  [9294] = 7322,
  [9295] = 7710,
  [9296] = 7695,
  [9297] = 7710,
  [9298] = 7321,
  [9299] = 7464,
  [9300] = 7074,
  [9301] = 7705,
  [9302] = 7710,
  [9303] = 7712,
  [9304] = 7713,
  [9305] = 7714,
  [9306] = 7716,
  [9307] = 7717,
  [9308] = 6890,
  [9309] = 7705,
  [9310] = 7710,
  [9311] = 7711,
  [9312] = 7712,
  [9313] = 7713,
  [9314] = 7714,
  [9315] = 7716,
  [9316] = 7717,
  [9317] = 7224,
  [9318] = 7222,
  [9319] = 7328,
  [9320] = 7705,
  [9321] = 7710,
  [9322] = 7711,
  [9323] = 7712,
  [9324] = 7713,
  [9325] = 7714,
  [9326] = 7716,
  [9327] = 7717,
  [9328] = 7309,
  [9329] = 7322,
  [9330] = 7652,
  [9331] = 7325,
  [9332] = 7324,
  [9333] = 7649,
  [9334] = 7326,
  [9335] = 7327,
  [9336] = 4095,
  [9337] = 4095,
  [9338] = 4095,
  [9339] = 4086,
  [9340] = 4095,
  [9341] = 4095,
  [9342] = 4095,
  [9343] = 4095,
  [9344] = 4086,
  [9345] = 4095,
  [9346] = 9346,
  [9347] = 9346,
  [9348] = 9346,
  [9349] = 9346,
  [9350] = 9346,
  [9351] = 9346,
  [9352] = 9346,
  [9353] = 9346,
  [9354] = 9346,
  [9355] = 9346,
  [9356] = 9346,
  [9357] = 9346,
  [9358] = 9346,
  [9359] = 9346,
  [9360] = 9346,
  [9361] = 9346,
  [9362] = 9346,
  [9363] = 9346,
  [9364] = 9346,
  [9365] = 9346,
  [9366] = 9346,
  [9367] = 9346,
  [9368] = 9346,
  [9369] = 9346,
  [9370] = 9346,
  [9371] = 4095,
  [9372] = 9346,
  [9373] = 9346,
  [9374] = 9346,
  [9375] = 9346,
  [9376] = 9346,
  [9377] = 9346,
  [9378] = 9346,
  [9379] = 9346,
  [9380] = 9346,
  [9381] = 9346,
  [9382] = 9346,
  [9383] = 9346,
  [9384] = 9346,
  [9385] = 9346,
  [9386] = 9346,
  [9387] = 9346,
  [9388] = 9346,
  [9389] = 4095,
  [9390] = 9346,
  [9391] = 9346,
  [9392] = 9346,
  [9393] = 9346,
  [9394] = 9346,
  [9395] = 9346,
  [9396] = 9346,
  [9397] = 9346,
  [9398] = 9346,
  [9399] = 9346,
  [9400] = 9346,
  [9401] = 9346,
  [9402] = 9346,
  [9403] = 9346,
  [9404] = 9346,
  [9405] = 9346,
  [9406] = 9346,
  [9407] = 9346,
  [9408] = 9346,
  [9409] = 9346,
  [9410] = 4095,
  [9411] = 4105,
  [9412] = 4131,
  [9413] = 9413,
  [9414] = 4180,
  [9415] = 4183,
  [9416] = 4144,
  [9417] = 4165,
  [9418] = 4173,
  [9419] = 4174,
  [9420] = 4181,
  [9421] = 4175,
  [9422] = 4184,
  [9423] = 9423,
  [9424] = 4160,
  [9425] = 4164,
  [9426] = 4159,
  [9427] = 9427,
  [9428] = 7341,
  [9429] = 4171,
  [9430] = 4179,
  [9431] = 4182,
  [9432] = 4309,
  [9433] = 4326,
  [9434] = 4300,
  [9435] = 4320,
  [9436] = 4321,
  [9437] = 4346,
  [9438] = 4347,
  [9439] = 4341,
  [9440] = 4301,
  [9441] = 4344,
  [9442] = 4348,
  [9443] = 4353,
  [9444] = 4324,
  [9445] = 4322,
  [9446] = 4105,
  [9447] = 4459,
  [9448] = 4248,
  [9449] = 4245,
  [9450] = 4250,
  [9451] = 4345,
  [9452] = 4293,
  [9453] = 4302,
  [9454] = 4350,
  [9455] = 4354,
  [9456] = 4338,
  [9457] = 4342,
  [9458] = 4308,
  [9459] = 4351,
  [9460] = 4355,
  [9461] = 4327,
  [9462] = 4291,
  [9463] = 4249,
  [9464] = 9464,
  [9465] = 4458,
  [9466] = 4339,
  [9467] = 4325,
  [9468] = 4340,
  [9469] = 4356,
  [9470] = 4095,
  [9471] = 4095,
  [9472] = 9472,
  [9473] = 9473,
  [9474] = 4483,
  [9475] = 9475,
  [9476] = 9476,
  [9477] = 9476,
  [9478] = 9476,
  [9479] = 9476,
  [9480] = 9476,
  [9481] = 9476,
  [9482] = 9476,
  [9483] = 9476,
  [9484] = 9476,
  [9485] = 9476,
  [9486] = 9476,
  [9487] = 9476,
  [9488] = 9476,
  [9489] = 9476,
  [9490] = 9476,
  [9491] = 9476,
  [9492] = 9476,
  [9493] = 9476,
  [9494] = 9476,
  [9495] = 9476,
  [9496] = 9476,
  [9497] = 9476,
  [9498] = 9476,
  [9499] = 9476,
  [9500] = 9476,
  [9501] = 9476,
  [9502] = 9476,
  [9503] = 9476,
  [9504] = 9476,
  [9505] = 9476,
  [9506] = 9476,
  [9507] = 9476,
  [9508] = 9476,
  [9509] = 9476,
  [9510] = 9476,
  [9511] = 9476,
  [9512] = 9476,
  [9513] = 9476,
  [9514] = 9476,
  [9515] = 9476,
  [9516] = 9476,
  [9517] = 9476,
  [9518] = 9476,
  [9519] = 9476,
  [9520] = 9476,
  [9521] = 9476,
  [9522] = 9476,
  [9523] = 9476,
  [9524] = 9476,
  [9525] = 9476,
  [9526] = 9476,
  [9527] = 9476,
  [9528] = 9476,
  [9529] = 9476,
  [9530] = 9476,
  [9531] = 9476,
  [9532] = 9476,
  [9533] = 9476,
  [9534] = 9476,
  [9535] = 9476,
  [9536] = 4095,
  [9537] = 9537,
  [9538] = 9537,
  [9539] = 9539,
  [9540] = 9537,
  [9541] = 9539,
  [9542] = 4095,
  [9543] = 9543,
  [9544] = 9537,
  [9545] = 9537,
  [9546] = 9537,
  [9547] = 9537,
  [9548] = 9537,
  [9549] = 4095,
  [9550] = 9543,
  [9551] = 9537,
  [9552] = 9552,
  [9553] = 4095,
  [9554] = 9539,
  [9555] = 9539,
  [9556] = 4095,
  [9557] = 9537,
  [9558] = 9537,
  [9559] = 9539,
  [9560] = 9543,
  [9561] = 9537,
  [9562] = 4095,
  [9563] = 9537,
  [9564] = 9537,
  [9565] = 9537,
  [9566] = 9537,
  [9567] = 4095,
  [9568] = 9537,
  [9569] = 9543,
  [9570] = 9537,
  [9571] = 9537,
  [9572] = 4095,
  [9573] = 9537,
  [9574] = 9539,
  [9575] = 9537,
  [9576] = 9537,
  [9577] = 9537,
  [9578] = 9537,
  [9579] = 4095,
  [9580] = 4095,
  [9581] = 9537,
  [9582] = 9537,
  [9583] = 9537,
  [9584] = 4095,
  [9585] = 4095,
  [9586] = 9537,
  [9587] = 9537,
  [9588] = 9543,
  [9589] = 9539,
  [9590] = 9537,
  [9591] = 9537,
  [9592] = 9537,
  [9593] = 9537,
  [9594] = 9537,
  [9595] = 9537,
  [9596] = 9537,
  [9597] = 9537,
  [9598] = 4095,
  [9599] = 4095,
  [9600] = 9537,
  [9601] = 9537,
  [9602] = 9537,
  [9603] = 4095,
  [9604] = 4095,
  [9605] = 9543,
  [9606] = 9539,
  [9607] = 9537,
  [9608] = 9537,
  [9609] = 9537,
  [9610] = 4095,
  [9611] = 4095,
  [9612] = 9537,
  [9613] = 9537,
  [9614] = 9537,
  [9615] = 4095,
  [9616] = 4095,
  [9617] = 9543,
  [9618] = 9539,
  [9619] = 9537,
  [9620] = 9537,
  [9621] = 4095,
  [9622] = 9537,
  [9623] = 4095,
  [9624] = 9537,
  [9625] = 9537,
  [9626] = 4095,
  [9627] = 9537,
  [9628] = 4095,
  [9629] = 9543,
  [9630] = 9539,
  [9631] = 4095,
  [9632] = 9539,
  [9633] = 9537,
  [9634] = 4095,
  [9635] = 9537,
  [9636] = 4095,
  [9637] = 9537,
  [9638] = 9543,
  [9639] = 9537,
  [9640] = 9537,
  [9641] = 9539,
  [9642] = 9537,
  [9643] = 9537,
  [9644] = 9537,
  [9645] = 9552,
  [9646] = 9537,
  [9647] = 9537,
  [9648] = 4095,
  [9649] = 9543,
  [9650] = 9537,
  [9651] = 9537,
  [9652] = 9537,
  [9653] = 9543,
  [9654] = 9543,
  [9655] = 9539,
  [9656] = 9537,
  [9657] = 9537,
  [9658] = 9543,
  [9659] = 9539,
  [9660] = 9537,
  [9661] = 9537,
  [9662] = 9543,
  [9663] = 9539,
  [9664] = 9537,
  [9665] = 9537,
  [9666] = 9539,
  [9667] = 9537,
  [9668] = 9537,
  [9669] = 9537,
  [9670] = 9537,
  [9671] = 9537,
  [9672] = 9537,
  [9673] = 9537,
  [9674] = 9537,
  [9675] = 9537,
  [9676] = 9537,
  [9677] = 9539,
  [9678] = 9537,
  [9679] = 9537,
  [9680] = 9537,
  [9681] = 9537,
  [9682] = 9539,
  [9683] = 9537,
  [9684] = 9543,
  [9685] = 4095,
  [9686] = 9543,
  [9687] = 4095,
  [9688] = 9539,
  [9689] = 4095,
  [9690] = 9537,
  [9691] = 4095,
  [9692] = 4095,
  [9693] = 9537,
  [9694] = 9537,
  [9695] = 9537,
  [9696] = 9537,
  [9697] = 4095,
  [9698] = 9537,
  [9699] = 9537,
  [9700] = 4095,
  [9701] = 9543,
  [9702] = 9543,
  [9703] = 4095,
  [9704] = 9537,
  [9705] = 9539,
  [9706] = 9537,
  [9707] = 9537,
  [9708] = 4095,
  [9709] = 9543,
  [9710] = 9537,
  [9711] = 9543,
  [9712] = 4095,
  [9713] = 9537,
  [9714] = 9537,
  [9715] = 4095,
  [9716] = 9539,
  [9717] = 9537,
  [9718] = 4095,
  [9719] = 9537,
  [9720] = 9537,
  [9721] = 4095,
  [9722] = 9537,
  [9723] = 4359,
  [9724] = 4359,
  [9725] = 4359,
  [9726] = 4359,
  [9727] = 4359,
  [9728] = 4359,
  [9729] = 4359,
  [9730] = 4359,
  [9731] = 4359,
  [9732] = 4359,
  [9733] = 4144,
  [9734] = 4105,
  [9735] = 4459,
  [9736] = 4105,
  [9737] = 4124,
  [9738] = 4118,
  [9739] = 4129,
  [9740] = 4123,
  [9741] = 4248,
  [9742] = 4458,
  [9743] = 4153,
  [9744] = 4154,
  [9745] = 4183,
  [9746] = 4161,
  [9747] = 4144,
  [9748] = 4171,
  [9749] = 4181,
  [9750] = 4184,
  [9751] = 4146,
  [9752] = 4175,
  [9753] = 4179,
  [9754] = 4152,
  [9755] = 4173,
  [9756] = 4147,
  [9757] = 4174,
  [9758] = 4180,
  [9759] = 4151,
  [9760] = 4142,
  [9761] = 4145,
  [9762] = 4182,
  [9763] = 4321,
  [9764] = 4300,
  [9765] = 4290,
  [9766] = 4295,
  [9767] = 4301,
  [9768] = 4467,
  [9769] = 4458,
  [9770] = 4459,
  [9771] = 4268,
  [9772] = 4275,
  [9773] = 4324,
  [9774] = 4293,
  [9775] = 4483,
  [9776] = 4302,
  [9777] = 4347,
  [9778] = 4248,
  [9779] = 4430,
  [9780] = 4338,
  [9781] = 4446,
  [9782] = 4265,
  [9783] = 4322,
  [9784] = 4447,
  [9785] = 4346,
  [9786] = 4350,
  [9787] = 4345,
  [9788] = 4344,
  [9789] = 4354,
  [9790] = 4435,
  [9791] = 4245,
  [9792] = 4325,
  [9793] = 4326,
  [9794] = 4327,
  [9795] = 4351,
  [9796] = 4105,
  [9797] = 4353,
  [9798] = 4252,
  [9799] = 4292,
  [9800] = 4339,
  [9801] = 4340,
  [9802] = 4453,
  [9803] = 4369,
  [9804] = 4465,
  [9805] = 4355,
  [9806] = 4356,
  [9807] = 4289,
  [9808] = 4291,
  [9809] = 4249,
  [9810] = 4308,
  [9811] = 4341,
  [9812] = 4342,
  [9813] = 4144,
  [9814] = 4425,
  [9815] = 4144,
  [9816] = 4260,
  [9817] = 4309,
  [9818] = 4320,
  [9819] = 4250,
  [9820] = 4348,
  [9821] = 4105,
  [9822] = 4144,
  [9823] = 4131,
  [9824] = 4164,
  [9825] = 4165,
  [9826] = 4144,
  [9827] = 4144,
  [9828] = 4458,
  [9829] = 4248,
  [9830] = 4458,
  [9831] = 4248,
  [9832] = 4459,
  [9833] = 4160,
  [9834] = 4459,
  [9835] = 4159,
  [9836] = 4112,
  [9837] = 4125,
  [9838] = 4458,
  [9839] = 4459,
  [9840] = 4118,
  [9841] = 4129,
  [9842] = 4144,
  [9843] = 4105,
  [9844] = 4124,
  [9845] = 4123,
  [9846] = 4144,
  [9847] = 4459,
  [9848] = 4105,
  [9849] = 4458,
  [9850] = 4248,
  [9851] = 4123,
  [9852] = 4118,
  [9853] = 4144,
  [9854] = 4248,
  [9855] = 4459,
  [9856] = 4124,
  [9857] = 4248,
  [9858] = 4458,
  [9859] = 4129,
  [9860] = 4171,
  [9861] = 4173,
  [9862] = 4459,
  [9863] = 4129,
  [9864] = 4179,
  [9865] = 4174,
  [9866] = 4181,
  [9867] = 4458,
  [9868] = 4151,
  [9869] = 4180,
  [9870] = 4183,
  [9871] = 4153,
  [9872] = 4184,
  [9873] = 4180,
  [9874] = 4146,
  [9875] = 4174,
  [9876] = 4171,
  [9877] = 4175,
  [9878] = 4248,
  [9879] = 4175,
  [9880] = 4144,
  [9881] = 4182,
  [9882] = 4153,
  [9883] = 4147,
  [9884] = 4145,
  [9885] = 4183,
  [9886] = 4459,
  [9887] = 4161,
  [9888] = 4154,
  [9889] = 4248,
  [9890] = 4458,
  [9891] = 4173,
  [9892] = 4142,
  [9893] = 4152,
  [9894] = 4184,
  [9895] = 4105,
  [9896] = 4459,
  [9897] = 4124,
  [9898] = 4181,
  [9899] = 4152,
  [9900] = 4182,
  [9901] = 4118,
  [9902] = 4179,
  [9903] = 4248,
  [9904] = 4123,
  [9905] = 4458,
  [9906] = 4144,
  [9907] = 4467,
  [9908] = 4346,
  [9909] = 4347,
  [9910] = 4268,
  [9911] = 4249,
  [9912] = 4425,
  [9913] = 4430,
  [9914] = 4175,
  [9915] = 4308,
  [9916] = 4320,
  [9917] = 4248,
  [9918] = 4321,
  [9919] = 4354,
  [9920] = 4184,
  [9921] = 4291,
  [9922] = 4309,
  [9923] = 4320,
  [9924] = 4153,
  [9925] = 4105,
  [9926] = 4348,
  [9927] = 4245,
  [9928] = 4325,
  [9929] = 4290,
  [9930] = 4322,
  [9931] = 4104,
  [9932] = 4152,
  [9933] = 4252,
  [9934] = 4308,
  [9935] = 4309,
  [9936] = 4324,
  [9937] = 4338,
  [9938] = 4325,
  [9939] = 4459,
  [9940] = 4435,
  [9941] = 4326,
  [9942] = 4289,
  [9943] = 4179,
  [9944] = 4327,
  [9945] = 4249,
  [9946] = 4250,
  [9947] = 4180,
  [9948] = 4295,
  [9949] = 4292,
  [9950] = 4104,
  [9951] = 4174,
  [9952] = 4355,
  [9953] = 4483,
  [9954] = 4300,
  [9955] = 4321,
  [9956] = 4356,
  [9957] = 4301,
  [9958] = 4181,
  [9959] = 4327,
  [9960] = 4324,
  [9961] = 4338,
  [9962] = 4339,
  [9963] = 4340,
  [9964] = 4369,
  [9965] = 4341,
  [9966] = 4342,
  [9967] = 4275,
  [9968] = 4252,
  [9969] = 4265,
  [9970] = 4260,
  [9971] = 4268,
  [9972] = 4275,
  [9973] = 4290,
  [9974] = 4292,
  [9975] = 4295,
  [9976] = 4425,
  [9977] = 4430,
  [9978] = 4435,
  [9979] = 4369,
  [9980] = 4446,
  [9981] = 4447,
  [9982] = 4446,
  [9983] = 4453,
  [9984] = 4465,
  [9985] = 4467,
  [9986] = 4344,
  [9987] = 4345,
  [9988] = 4326,
  [9989] = 4260,
  [9990] = 4346,
  [9991] = 4347,
  [9992] = 4348,
  [9993] = 4245,
  [9994] = 4453,
  [9995] = 4302,
  [9996] = 4350,
  [9997] = 4351,
  [9998] = 4447,
  [9999] = 4483,
  [10000] = 4353,
  [10001] = 4354,
  [10002] = 4250,
  [10003] = 4355,
  [10004] = 4356,
  [10005] = 4350,
  [10006] = 4293,
  [10007] = 4351,
  [10008] = 4104,
  [10009] = 4339,
  [10010] = 4340,
  [10011] = 4359,
  [10012] = 4353,
  [10013] = 4300,
  [10014] = 4144,
  [10015] = 4341,
  [10016] = 4105,
  [10017] = 4105,
  [10018] = 4342,
  [10019] = 4458,
  [10020] = 4182,
  [10021] = 4322,
  [10022] = 4104,
  [10023] = 4291,
  [10024] = 4344,
  [10025] = 4183,
  [10026] = 4293,
  [10027] = 4265,
  [10028] = 4458,
  [10029] = 4144,
  [10030] = 4459,
  [10031] = 4289,
  [10032] = 4465,
  [10033] = 4248,
  [10034] = 4171,
  [10035] = 4302,
  [10036] = 4345,
  [10037] = 4301,
  [10038] = 4173,
  [10039] = 4369,
  [10040] = 4104,
  [10041] = 4348,
  [10042] = 4350,
  [10043] = 4104,
  [10044] = 4112,
  [10045] = 4165,
  [10046] = 4104,
  [10047] = 4104,
  [10048] = 4430,
  [10049] = 4338,
  [10050] = 4295,
  [10051] = 4346,
  [10052] = 4344,
  [10053] = 4292,
  [10054] = 4340,
  [10055] = 4159,
  [10056] = 4160,
  [10057] = 4159,
  [10058] = 4160,
  [10059] = 4118,
  [10060] = 4125,
  [10061] = 4129,
  [10062] = 4125,
  [10063] = 4164,
  [10064] = 4356,
  [10065] = 4435,
  [10066] = 4164,
  [10067] = 4123,
  [10068] = 4245,
  [10069] = 4341,
  [10070] = 4326,
  [10071] = 4131,
  [10072] = 4124,
  [10073] = 4104,
  [10074] = 4164,
  [10075] = 4112,
  [10076] = 4112,
  [10077] = 4165,
  [10078] = 4159,
  [10079] = 4125,
  [10080] = 4320,
  [10081] = 4321,
  [10082] = 4453,
  [10083] = 4293,
  [10084] = 4483,
  [10085] = 4165,
  [10086] = 4131,
  [10087] = 4425,
  [10088] = 4160,
  [10089] = 4268,
  [10090] = 4105,
  [10091] = 4159,
  [10092] = 4308,
  [10093] = 4465,
  [10094] = 4339,
  [10095] = 4104,
  [10096] = 4302,
  [10097] = 4628,
  [10098] = 4252,
  [10099] = 4265,
  [10100] = 4104,
  [10101] = 4104,
  [10102] = 4104,
  [10103] = 4355,
  [10104] = 4458,
  [10105] = 4324,
  [10106] = 4459,
  [10107] = 4458,
  [10108] = 4459,
  [10109] = 4112,
  [10110] = 4351,
  [10111] = 4322,
  [10112] = 4309,
  [10113] = 4160,
  [10114] = 4248,
  [10115] = 4104,
  [10116] = 4327,
  [10117] = 4131,
  [10118] = 4105,
  [10119] = 4249,
  [10120] = 4250,
  [10121] = 4354,
  [10122] = 4359,
  [10123] = 4342,
  [10124] = 4104,
  [10125] = 4291,
  [10126] = 4248,
  [10127] = 4353,
  [10128] = 4467,
  [10129] = 4289,
  [10130] = 4275,
  [10131] = 4131,
  [10132] = 4345,
  [10133] = 4104,
  [10134] = 4347,
  [10135] = 4446,
  [10136] = 4300,
  [10137] = 4290,
  [10138] = 4301,
  [10139] = 4325,
  [10140] = 4260,
  [10141] = 4125,
  [10142] = 4447,
  [10143] = 4164,
  [10144] = 4104,
  [10145] = 4165,
  [10146] = 4184,
  [10147] = 10147,
  [10148] = 4144,
  [10149] = 4125,
  [10150] = 4192,
  [10151] = 4159,
  [10152] = 4151,
  [10153] = 10147,
  [10154] = 10147,
  [10155] = 4160,
  [10156] = 4161,
  [10157] = 4190,
  [10158] = 10147,
  [10159] = 10159,
  [10160] = 4105,
  [10161] = 4146,
  [10162] = 4147,
  [10163] = 4104,
  [10164] = 4104,
  [10165] = 4628,
  [10166] = 4118,
  [10167] = 4104,
  [10168] = 4129,
  [10169] = 4190,
  [10170] = 4154,
  [10171] = 4192,
  [10172] = 4156,
  [10173] = 4152,
  [10174] = 4131,
  [10175] = 4164,
  [10176] = 4164,
  [10177] = 4104,
  [10178] = 4153,
  [10179] = 4142,
  [10180] = 4165,
  [10181] = 4165,
  [10182] = 4104,
  [10183] = 4131,
  [10184] = 4112,
  [10185] = 4123,
  [10186] = 4159,
  [10187] = 4160,
  [10188] = 4159,
  [10189] = 4160,
  [10190] = 4104,
  [10191] = 4192,
  [10192] = 4125,
  [10193] = 10147,
  [10194] = 4104,
  [10195] = 10147,
  [10196] = 10147,
  [10197] = 4159,
  [10198] = 4104,
  [10199] = 4112,
  [10200] = 10147,
  [10201] = 10159,
  [10202] = 4190,
  [10203] = 4104,
  [10204] = 4125,
  [10205] = 4131,
  [10206] = 4112,
  [10207] = 4190,
  [10208] = 4131,
  [10209] = 4112,
  [10210] = 10147,
  [10211] = 4192,
  [10212] = 4104,
  [10213] = 4160,
  [10214] = 4171,
  [10215] = 4104,
  [10216] = 4190,
  [10217] = 4173,
  [10218] = 4174,
  [10219] = 4124,
  [10220] = 4175,
  [10221] = 4179,
  [10222] = 4180,
  [10223] = 4181,
  [10224] = 4164,
  [10225] = 4104,
  [10226] = 10147,
  [10227] = 4165,
  [10228] = 4182,
  [10229] = 4183,
  [10230] = 4105,
  [10231] = 4165,
  [10232] = 4156,
  [10233] = 10147,
  [10234] = 4145,
  [10235] = 4164,
  [10236] = 4125,
  [10237] = 4104,
  [10238] = 4104,
  [10239] = 10147,
  [10240] = 4190,
  [10241] = 4131,
  [10242] = 4152,
  [10243] = 4467,
  [10244] = 4293,
  [10245] = 4320,
  [10246] = 4190,
  [10247] = 4190,
  [10248] = 4156,
  [10249] = 4104,
  [10250] = 4289,
  [10251] = 4112,
  [10252] = 4249,
  [10253] = 4192,
  [10254] = 4190,
  [10255] = 4250,
  [10256] = 4435,
  [10257] = 4123,
  [10258] = 4118,
  [10259] = 4325,
  [10260] = 4308,
  [10261] = 4302,
  [10262] = 4159,
  [10263] = 4300,
  [10264] = 4144,
  [10265] = 4353,
  [10266] = 4301,
  [10267] = 4160,
  [10268] = 4156,
  [10269] = 4160,
  [10270] = 10270,
  [10271] = 4324,
  [10272] = 4104,
  [10273] = 4164,
  [10274] = 4124,
  [10275] = 4338,
  [10276] = 4354,
  [10277] = 4192,
  [10278] = 4355,
  [10279] = 4184,
  [10280] = 4265,
  [10281] = 4165,
  [10282] = 4356,
  [10283] = 4369,
  [10284] = 4112,
  [10285] = 4252,
  [10286] = 4165,
  [10287] = 4260,
  [10288] = 4268,
  [10289] = 4190,
  [10290] = 4295,
  [10291] = 4275,
  [10292] = 4171,
  [10293] = 4190,
  [10294] = 4112,
  [10295] = 4156,
  [10296] = 4344,
  [10297] = 4290,
  [10298] = 4190,
  [10299] = 10159,
  [10300] = 4144,
  [10301] = 4131,
  [10302] = 4192,
  [10303] = 4248,
  [10304] = 4125,
  [10305] = 4104,
  [10306] = 4339,
  [10307] = 4192,
  [10308] = 4351,
  [10309] = 4190,
  [10310] = 4192,
  [10311] = 4125,
  [10312] = 4340,
  [10313] = 4309,
  [10314] = 4190,
  [10315] = 4245,
  [10316] = 4131,
  [10317] = 4165,
  [10318] = 4345,
  [10319] = 4326,
  [10320] = 4190,
  [10321] = 4327,
  [10322] = 4105,
  [10323] = 4425,
  [10324] = 4192,
  [10325] = 4430,
  [10326] = 10326,
  [10327] = 4173,
  [10328] = 4174,
  [10329] = 4105,
  [10330] = 4175,
  [10331] = 4458,
  [10332] = 4104,
  [10333] = 4350,
  [10334] = 4159,
  [10335] = 4104,
  [10336] = 4160,
  [10337] = 4156,
  [10338] = 4164,
  [10339] = 4156,
  [10340] = 4192,
  [10341] = 4459,
  [10342] = 4190,
  [10343] = 4125,
  [10344] = 4192,
  [10345] = 4192,
  [10346] = 4192,
  [10347] = 4348,
  [10348] = 4347,
  [10349] = 4446,
  [10350] = 4342,
  [10351] = 4447,
  [10352] = 4190,
  [10353] = 4192,
  [10354] = 4292,
  [10355] = 4164,
  [10356] = 4483,
  [10357] = 4129,
  [10358] = 4104,
  [10359] = 5044,
  [10360] = 4159,
  [10361] = 4179,
  [10362] = 4180,
  [10363] = 4156,
  [10364] = 4291,
  [10365] = 4321,
  [10366] = 4322,
  [10367] = 4181,
  [10368] = 4156,
  [10369] = 4192,
  [10370] = 4190,
  [10371] = 4156,
  [10372] = 4190,
  [10373] = 4341,
  [10374] = 4453,
  [10375] = 4190,
  [10376] = 4182,
  [10377] = 4183,
  [10378] = 4190,
  [10379] = 4465,
  [10380] = 4346,
  [10381] = 4153,
  [10382] = 4369,
  [10383] = 4156,
  [10384] = 4341,
  [10385] = 4342,
  [10386] = 4301,
  [10387] = 4190,
  [10388] = 4346,
  [10389] = 4190,
  [10390] = 4192,
  [10391] = 4347,
  [10392] = 4293,
  [10393] = 4348,
  [10394] = 4289,
  [10395] = 4453,
  [10396] = 4465,
  [10397] = 4308,
  [10398] = 4309,
  [10399] = 4322,
  [10400] = 4467,
  [10401] = 4245,
  [10402] = 4192,
  [10403] = 4265,
  [10404] = 4192,
  [10405] = 4156,
  [10406] = 4156,
  [10407] = 4190,
  [10408] = 4156,
  [10409] = 4105,
  [10410] = 4248,
  [10411] = 4291,
  [10412] = 4324,
  [10413] = 4153,
  [10414] = 4252,
  [10415] = 4324,
  [10416] = 4192,
  [10417] = 4350,
  [10418] = 4320,
  [10419] = 4156,
  [10420] = 4104,
  [10421] = 4322,
  [10422] = 4435,
  [10423] = 4321,
  [10424] = 4192,
  [10425] = 4192,
  [10426] = 4192,
  [10427] = 4338,
  [10428] = 4260,
  [10429] = 4181,
  [10430] = 4104,
  [10431] = 4268,
  [10432] = 4275,
  [10433] = 4338,
  [10434] = 4292,
  [10435] = 4190,
  [10436] = 4156,
  [10437] = 4192,
  [10438] = 4290,
  [10439] = 4325,
  [10440] = 4175,
  [10441] = 4293,
  [10442] = 4350,
  [10443] = 4192,
  [10444] = 4171,
  [10445] = 4190,
  [10446] = 4190,
  [10447] = 4351,
  [10448] = 4339,
  [10449] = 4340,
  [10450] = 4458,
  [10451] = 4351,
  [10452] = 4459,
  [10453] = 4341,
  [10454] = 4342,
  [10455] = 4326,
  [10456] = 4156,
  [10457] = 4156,
  [10458] = 4156,
  [10459] = 4156,
  [10460] = 4156,
  [10461] = 4192,
  [10462] = 4359,
  [10463] = 4425,
  [10464] = 4152,
  [10465] = 4179,
  [10466] = 4174,
  [10467] = 4430,
  [10468] = 4327,
  [10469] = 4190,
  [10470] = 4459,
  [10471] = 4353,
  [10472] = 4354,
  [10473] = 4249,
  [10474] = 4192,
  [10475] = 4144,
  [10476] = 4248,
  [10477] = 4265,
  [10478] = 4355,
  [10479] = 4369,
  [10480] = 4156,
  [10481] = 4353,
  [10482] = 4250,
  [10483] = 4356,
  [10484] = 4354,
  [10485] = 4300,
  [10486] = 4325,
  [10487] = 4326,
  [10488] = 4182,
  [10489] = 4302,
  [10490] = 4105,
  [10491] = 5697,
  [10492] = 4184,
  [10493] = 4344,
  [10494] = 4345,
  [10495] = 5953,
  [10496] = 4183,
  [10497] = 4291,
  [10498] = 4180,
  [10499] = 4190,
  [10500] = 4301,
  [10501] = 4355,
  [10502] = 4104,
  [10503] = 4356,
  [10504] = 4190,
  [10505] = 10159,
  [10506] = 4104,
  [10507] = 4192,
  [10508] = 4321,
  [10509] = 5662,
  [10510] = 4346,
  [10511] = 4483,
  [10512] = 4347,
  [10513] = 4173,
  [10514] = 4192,
  [10515] = 4192,
  [10516] = 4344,
  [10517] = 4308,
  [10518] = 4309,
  [10519] = 4320,
  [10520] = 4339,
  [10521] = 4300,
  [10522] = 4435,
  [10523] = 4340,
  [10524] = 4327,
  [10525] = 4249,
  [10526] = 4250,
  [10527] = 4446,
  [10528] = 4295,
  [10529] = 4447,
  [10530] = 4190,
  [10531] = 10531,
  [10532] = 4345,
  [10533] = 4192,
  [10534] = 4156,
  [10535] = 4348,
  [10536] = 4252,
  [10537] = 4245,
  [10538] = 4302,
  [10539] = 4295,
  [10540] = 4192,
  [10541] = 4458,
  [10542] = 4144,
  [10543] = 4483,
  [10544] = 10544,
  [10545] = 4156,
  [10546] = 4160,
  [10547] = 4350,
  [10548] = 4353,
  [10549] = 4131,
  [10550] = 4112,
  [10551] = 4125,
  [10552] = 4156,
  [10553] = 4290,
  [10554] = 4344,
  [10555] = 4131,
  [10556] = 4341,
  [10557] = 4112,
  [10558] = 4192,
  [10559] = 4351,
  [10560] = 4192,
  [10561] = 4300,
  [10562] = 4165,
  [10563] = 4295,
  [10564] = 4301,
  [10565] = 4293,
  [10566] = 4156,
  [10567] = 4295,
  [10568] = 4348,
  [10569] = 4159,
  [10570] = 6704,
  [10571] = 4192,
  [10572] = 10544,
  [10573] = 4425,
  [10574] = 4245,
  [10575] = 4430,
  [10576] = 4355,
  [10577] = 4325,
  [10578] = 4458,
  [10579] = 4342,
  [10580] = 6890,
  [10581] = 4250,
  [10582] = 4275,
  [10583] = 4309,
  [10584] = 6801,
  [10585] = 4459,
  [10586] = 4159,
  [10587] = 4338,
  [10588] = 10159,
  [10589] = 4160,
  [10590] = 4628,
  [10591] = 4164,
  [10592] = 4483,
  [10593] = 4628,
  [10594] = 4159,
  [10595] = 6361,
  [10596] = 4265,
  [10597] = 6705,
  [10598] = 4160,
  [10599] = 4446,
  [10600] = 4190,
  [10601] = 4164,
  [10602] = 6710,
  [10603] = 4192,
  [10604] = 4164,
  [10605] = 4327,
  [10606] = 4628,
  [10607] = 4112,
  [10608] = 4165,
  [10609] = 4125,
  [10610] = 4190,
  [10611] = 4105,
  [10612] = 4112,
  [10613] = 4125,
  [10614] = 4467,
  [10615] = 5155,
  [10616] = 4190,
  [10617] = 4326,
  [10618] = 4131,
  [10619] = 4131,
  [10620] = 4465,
  [10621] = 4346,
  [10622] = 4192,
  [10623] = 10623,
  [10624] = 10544,
  [10625] = 4292,
  [10626] = 4339,
  [10627] = 4435,
  [10628] = 4165,
  [10629] = 4289,
  [10630] = 4192,
  [10631] = 4118,
  [10632] = 4125,
  [10633] = 4156,
  [10634] = 4129,
  [10635] = 4159,
  [10636] = 4112,
  [10637] = 4159,
  [10638] = 10623,
  [10639] = 4105,
  [10640] = 4156,
  [10641] = 4156,
  [10642] = 4260,
  [10643] = 4123,
  [10644] = 4165,
  [10645] = 4156,
  [10646] = 4160,
  [10647] = 4160,
  [10648] = 4156,
  [10649] = 4164,
  [10650] = 4165,
  [10651] = 4156,
  [10652] = 4324,
  [10653] = 10623,
  [10654] = 4124,
  [10655] = 4356,
  [10656] = 4268,
  [10657] = 4320,
  [10658] = 4369,
  [10659] = 4248,
  [10660] = 4252,
  [10661] = 4131,
  [10662] = 4104,
  [10663] = 4347,
  [10664] = 6938,
  [10665] = 4190,
  [10666] = 4156,
  [10667] = 4308,
  [10668] = 4354,
  [10669] = 4340,
  [10670] = 4302,
  [10671] = 4321,
  [10672] = 4447,
  [10673] = 4192,
  [10674] = 4105,
  [10675] = 4249,
  [10676] = 4104,
  [10677] = 4359,
  [10678] = 4104,
  [10679] = 4291,
  [10680] = 4453,
  [10681] = 4345,
  [10682] = 4322,
  [10683] = 4164,
  [10684] = 4131,
  [10685] = 4628,
  [10686] = 4159,
  [10687] = 7466,
  [10688] = 4628,
  [10689] = 7355,
  [10690] = 4190,
  [10691] = 4164,
  [10692] = 4159,
  [10693] = 4105,
  [10694] = 4180,
  [10695] = 4112,
  [10696] = 4160,
  [10697] = 4175,
  [10698] = 4165,
  [10699] = 7522,
  [10700] = 4164,
  [10701] = 4156,
  [10702] = 7524,
  [10703] = 4190,
  [10704] = 4156,
  [10705] = 7433,
  [10706] = 4118,
  [10707] = 4171,
  [10708] = 4165,
  [10709] = 7506,
  [10710] = 4125,
  [10711] = 4129,
  [10712] = 7536,
  [10713] = 4628,
  [10714] = 4181,
  [10715] = 7537,
  [10716] = 4179,
  [10717] = 7426,
  [10718] = 4112,
  [10719] = 7430,
  [10720] = 7724,
  [10721] = 4125,
  [10722] = 4190,
  [10723] = 4159,
  [10724] = 7294,
  [10725] = 4165,
  [10726] = 4159,
  [10727] = 4160,
  [10728] = 7336,
  [10729] = 4105,
  [10730] = 4164,
  [10731] = 4112,
  [10732] = 7273,
  [10733] = 7379,
  [10734] = 4125,
  [10735] = 7431,
  [10736] = 7305,
  [10737] = 7310,
  [10738] = 4628,
  [10739] = 7390,
  [10740] = 4184,
  [10741] = 4105,
  [10742] = 4112,
  [10743] = 4165,
  [10744] = 4125,
  [10745] = 4125,
  [10746] = 4160,
  [10747] = 4112,
  [10748] = 4131,
  [10749] = 7369,
  [10750] = 4152,
  [10751] = 7424,
  [10752] = 4192,
  [10753] = 4628,
  [10754] = 4125,
  [10755] = 7640,
  [10756] = 10756,
  [10757] = 4156,
  [10758] = 4131,
  [10759] = 4104,
  [10760] = 7402,
  [10761] = 7340,
  [10762] = 4164,
  [10763] = 4165,
  [10764] = 4160,
  [10765] = 4131,
  [10766] = 4112,
  [10767] = 4153,
  [10768] = 7360,
  [10769] = 4131,
  [10770] = 4192,
  [10771] = 7226,
  [10772] = 4164,
  [10773] = 7508,
  [10774] = 4112,
  [10775] = 7475,
  [10776] = 4131,
  [10777] = 7498,
  [10778] = 4164,
  [10779] = 7359,
  [10780] = 4123,
  [10781] = 7521,
  [10782] = 4159,
  [10783] = 7750,
  [10784] = 7243,
  [10785] = 7295,
  [10786] = 7761,
  [10787] = 4190,
  [10788] = 4160,
  [10789] = 7404,
  [10790] = 7764,
  [10791] = 7767,
  [10792] = 7848,
  [10793] = 7849,
  [10794] = 4160,
  [10795] = 7207,
  [10796] = 7209,
  [10797] = 4164,
  [10798] = 7261,
  [10799] = 7408,
  [10800] = 4164,
  [10801] = 7436,
  [10802] = 7210,
  [10803] = 4192,
  [10804] = 7223,
  [10805] = 4159,
  [10806] = 7572,
  [10807] = 7224,
  [10808] = 4156,
  [10809] = 7250,
  [10810] = 4182,
  [10811] = 7256,
  [10812] = 4144,
  [10813] = 7361,
  [10814] = 4183,
  [10815] = 7552,
  [10816] = 7297,
  [10817] = 7695,
  [10818] = 7553,
  [10819] = 4159,
  [10820] = 7409,
  [10821] = 4173,
  [10822] = 4131,
  [10823] = 7420,
  [10824] = 7257,
  [10825] = 4190,
  [10826] = 7560,
  [10827] = 7421,
  [10828] = 4165,
  [10829] = 4628,
  [10830] = 4124,
  [10831] = 4156,
  [10832] = 7733,
  [10833] = 7341,
  [10834] = 7289,
  [10835] = 4165,
  [10836] = 7266,
  [10837] = 7412,
  [10838] = 7377,
  [10839] = 4192,
  [10840] = 10840,
  [10841] = 7291,
  [10842] = 4160,
  [10843] = 4131,
  [10844] = 4160,
  [10845] = 7244,
  [10846] = 4174,
  [10847] = 4159,
  [10848] = 4165,
  [10849] = 10849,
  [10850] = 4160,
  [10851] = 4289,
  [10852] = 4292,
  [10853] = 4164,
  [10854] = 4190,
  [10855] = 4260,
  [10856] = 4268,
  [10857] = 4275,
  [10858] = 4290,
  [10859] = 10849,
  [10860] = 4425,
  [10861] = 4430,
  [10862] = 4446,
  [10863] = 4447,
  [10864] = 4453,
  [10865] = 4465,
  [10866] = 4467,
  [10867] = 4190,
  [10868] = 4144,
  [10869] = 10849,
  [10870] = 4171,
  [10871] = 4173,
  [10872] = 4174,
  [10873] = 4175,
  [10874] = 4179,
  [10875] = 4180,
  [10876] = 4181,
  [10877] = 4190,
  [10878] = 4182,
  [10879] = 10849,
  [10880] = 4183,
  [10881] = 4105,
  [10882] = 4184,
  [10883] = 10849,
  [10884] = 10849,
  [10885] = 4190,
  [10886] = 10849,
  [10887] = 4190,
  [10888] = 10849,
  [10889] = 4190,
  [10890] = 10849,
  [10891] = 4190,
  [10892] = 10849,
  [10893] = 4190,
  [10894] = 10849,
  [10895] = 4190,
  [10896] = 10849,
  [10897] = 4190,
  [10898] = 10849,
  [10899] = 4190,
  [10900] = 10849,
  [10901] = 4190,
  [10902] = 10849,
  [10903] = 4190,
  [10904] = 10849,
  [10905] = 4159,
  [10906] = 4190,
  [10907] = 4160,
  [10908] = 4159,
  [10909] = 4160,
  [10910] = 10849,
  [10911] = 4144,
  [10912] = 4164,
  [10913] = 4165,
  [10914] = 4190,
  [10915] = 4164,
  [10916] = 4165,
  [10917] = 10849,
  [10918] = 4190,
  [10919] = 10849,
  [10920] = 4112,
  [10921] = 4190,
  [10922] = 10849,
  [10923] = 4359,
  [10924] = 4190,
  [10925] = 10849,
  [10926] = 4190,
  [10927] = 10849,
  [10928] = 5044,
  [10929] = 4159,
  [10930] = 4190,
  [10931] = 4160,
  [10932] = 10849,
  [10933] = 4125,
  [10934] = 4190,
  [10935] = 4190,
  [10936] = 4164,
  [10937] = 4165,
  [10938] = 10849,
  [10939] = 10939,
  [10940] = 4190,
  [10941] = 10849,
  [10942] = 4190,
  [10943] = 10849,
  [10944] = 4190,
  [10945] = 4190,
  [10946] = 10849,
  [10947] = 4190,
  [10948] = 4190,
  [10949] = 4190,
  [10950] = 10849,
  [10951] = 4190,
  [10952] = 10849,
  [10953] = 6583,
  [10954] = 6584,
  [10955] = 6588,
  [10956] = 4159,
  [10957] = 4160,
  [10958] = 4190,
  [10959] = 10849,
  [10960] = 4164,
  [10961] = 4165,
  [10962] = 4190,
  [10963] = 10849,
  [10964] = 4144,
  [10965] = 10849,
  [10966] = 10849,
  [10967] = 10849,
  [10968] = 4190,
  [10969] = 10849,
  [10970] = 10849,
  [10971] = 10849,
  [10972] = 10849,
  [10973] = 4142,
  [10974] = 10849,
  [10975] = 10849,
  [10976] = 10849,
  [10977] = 10849,
  [10978] = 10849,
  [10979] = 10849,
  [10980] = 4628,
  [10981] = 10849,
  [10982] = 6516,
  [10983] = 10849,
  [10984] = 10849,
  [10985] = 10849,
  [10986] = 10849,
  [10987] = 4190,
  [10988] = 10849,
  [10989] = 10849,
  [10990] = 10849,
  [10991] = 10849,
  [10992] = 4192,
  [10993] = 10849,
  [10994] = 4159,
  [10995] = 4160,
  [10996] = 10849,
  [10997] = 4164,
  [10998] = 4165,
  [10999] = 10849,
  [11000] = 10849,
  [11001] = 10849,
  [11002] = 10849,
  [11003] = 10849,
  [11004] = 10849,
  [11005] = 4190,
  [11006] = 10849,
  [11007] = 10849,
  [11008] = 10849,
  [11009] = 10849,
  [11010] = 10849,
  [11011] = 10849,
  [11012] = 10849,
  [11013] = 10849,
  [11014] = 10849,
  [11015] = 10849,
  [11016] = 10849,
  [11017] = 10849,
  [11018] = 10849,
  [11019] = 10849,
  [11020] = 10849,
  [11021] = 10849,
  [11022] = 10849,
  [11023] = 4190,
  [11024] = 4145,
  [11025] = 10849,
  [11026] = 4190,
  [11027] = 4190,
  [11028] = 4190,
  [11029] = 4190,
  [11030] = 4131,
  [11031] = 4151,
  [11032] = 4156,
  [11033] = 4190,
  [11034] = 4190,
  [11035] = 4190,
  [11036] = 4156,
  [11037] = 4190,
  [11038] = 6601,
  [11039] = 4190,
  [11040] = 4190,
  [11041] = 10849,
  [11042] = 4369,
  [11043] = 4252,
  [11044] = 10849,
  [11045] = 4435,
  [11046] = 4161,
  [11047] = 4628,
  [11048] = 4628,
  [11049] = 4265,
  [11050] = 4483,
  [11051] = 4112,
  [11052] = 4125,
  [11053] = 4112,
  [11054] = 4125,
  [11055] = 4131,
  [11056] = 4131,
  [11057] = 4190,
  [11058] = 10849,
  [11059] = 10849,
  [11060] = 10849,
  [11061] = 10849,
  [11062] = 10849,
  [11063] = 10849,
  [11064] = 10849,
  [11065] = 10849,
  [11066] = 10849,
  [11067] = 10849,
  [11068] = 10849,
  [11069] = 4190,
  [11070] = 4628,
  [11071] = 4112,
  [11072] = 4125,
  [11073] = 4131,
  [11074] = 10849,
  [11075] = 10849,
  [11076] = 10849,
  [11077] = 10849,
  [11078] = 10849,
  [11079] = 10849,
  [11080] = 10849,
  [11081] = 10849,
  [11082] = 10849,
  [11083] = 10849,
  [11084] = 10849,
  [11085] = 10849,
  [11086] = 10849,
  [11087] = 10849,
  [11088] = 10849,
  [11089] = 4628,
  [11090] = 4112,
  [11091] = 4125,
  [11092] = 4131,
  [11093] = 10849,
  [11094] = 10849,
  [11095] = 10849,
  [11096] = 10849,
  [11097] = 4628,
  [11098] = 4112,
  [11099] = 4125,
  [11100] = 4131,
  [11101] = 10849,
  [11102] = 10849,
  [11103] = 10849,
  [11104] = 10849,
  [11105] = 10849,
  [11106] = 10849,
  [11107] = 10849,
  [11108] = 10849,
  [11109] = 10849,
  [11110] = 4291,
  [11111] = 4293,
  [11112] = 4320,
  [11113] = 4321,
  [11114] = 4322,
  [11115] = 4325,
  [11116] = 4192,
  [11117] = 4156,
  [11118] = 4326,
  [11119] = 4156,
  [11120] = 4327,
  [11121] = 4249,
  [11122] = 10849,
  [11123] = 10849,
  [11124] = 4250,
  [11125] = 4302,
  [11126] = 4300,
  [11127] = 4301,
  [11128] = 4324,
  [11129] = 4338,
  [11130] = 4339,
  [11131] = 4340,
  [11132] = 4341,
  [11133] = 4342,
  [11134] = 4308,
  [11135] = 4309,
  [11136] = 4190,
  [11137] = 4344,
  [11138] = 4345,
  [11139] = 4346,
  [11140] = 4190,
  [11141] = 4347,
  [11142] = 4348,
  [11143] = 4245,
  [11144] = 4350,
  [11145] = 4351,
  [11146] = 10849,
  [11147] = 4353,
  [11148] = 4354,
  [11149] = 4355,
  [11150] = 4356,
  [11151] = 10849,
  [11152] = 10849,
  [11153] = 10849,
  [11154] = 10849,
  [11155] = 10849,
  [11156] = 10849,
  [11157] = 5044,
  [11158] = 5044,
  [11159] = 10849,
  [11160] = 10849,
  [11161] = 10849,
  [11162] = 10849,
  [11163] = 10849,
  [11164] = 10849,
  [11165] = 10849,
  [11166] = 10849,
  [11167] = 10849,
  [11168] = 10849,
  [11169] = 10849,
  [11170] = 10849,
  [11171] = 10849,
  [11172] = 10849,
  [11173] = 10849,
  [11174] = 4152,
  [11175] = 6237,
  [11176] = 4190,
  [11177] = 10849,
  [11178] = 4192,
  [11179] = 4165,
  [11180] = 4153,
  [11181] = 4192,
  [11182] = 4458,
  [11183] = 4459,
  [11184] = 4295,
  [11185] = 4248,
  [11186] = 4159,
  [11187] = 10849,
  [11188] = 4105,
  [11189] = 4309,
  [11190] = 4353,
  [11191] = 4291,
  [11192] = 4112,
  [11193] = 6237,
  [11194] = 4125,
  [11195] = 4112,
  [11196] = 4300,
  [11197] = 4125,
  [11198] = 4293,
  [11199] = 4320,
  [11200] = 4321,
  [11201] = 4131,
  [11202] = 4301,
  [11203] = 4131,
  [11204] = 4302,
  [11205] = 4325,
  [11206] = 4326,
  [11207] = 5662,
  [11208] = 4324,
  [11209] = 4327,
  [11210] = 4338,
  [11211] = 4249,
  [11212] = 4339,
  [11213] = 4250,
  [11214] = 4302,
  [11215] = 4300,
  [11216] = 4301,
  [11217] = 4324,
  [11218] = 4338,
  [11219] = 4339,
  [11220] = 4340,
  [11221] = 4341,
  [11222] = 4342,
  [11223] = 4308,
  [11224] = 4309,
  [11225] = 4344,
  [11226] = 4340,
  [11227] = 4341,
  [11228] = 4345,
  [11229] = 4346,
  [11230] = 4347,
  [11231] = 4300,
  [11232] = 4342,
  [11233] = 4628,
  [11234] = 4459,
  [11235] = 4348,
  [11236] = 4301,
  [11237] = 4344,
  [11238] = 4345,
  [11239] = 4346,
  [11240] = 4347,
  [11241] = 4348,
  [11242] = 4245,
  [11243] = 4245,
  [11244] = 4350,
  [11245] = 4164,
  [11246] = 4159,
  [11247] = 4351,
  [11248] = 4353,
  [11249] = 4354,
  [11250] = 4355,
  [11251] = 4356,
  [11252] = 4160,
  [11253] = 4350,
  [11254] = 4165,
  [11255] = 4289,
  [11256] = 4351,
  [11257] = 4353,
  [11258] = 4354,
  [11259] = 4355,
  [11260] = 4356,
  [11261] = 4164,
  [11262] = 4359,
  [11263] = 4322,
  [11264] = 4165,
  [11265] = 11265,
  [11266] = 4164,
  [11267] = 4165,
  [11268] = 4248,
  [11269] = 5697,
  [11270] = 4322,
  [11271] = 6883,
  [11272] = 4338,
  [11273] = 4112,
  [11274] = 6885,
  [11275] = 5662,
  [11276] = 4325,
  [11277] = 6889,
  [11278] = 4339,
  [11279] = 4340,
  [11280] = 4341,
  [11281] = 4342,
  [11282] = 4291,
  [11283] = 4326,
  [11284] = 4369,
  [11285] = 4308,
  [11286] = 4292,
  [11287] = 4131,
  [11288] = 4309,
  [11289] = 4293,
  [11290] = 4320,
  [11291] = 4321,
  [11292] = 4467,
  [11293] = 4308,
  [11294] = 4159,
  [11295] = 4346,
  [11296] = 4252,
  [11297] = 4265,
  [11298] = 11298,
  [11299] = 4458,
  [11300] = 4144,
  [11301] = 4459,
  [11302] = 4347,
  [11303] = 4348,
  [11304] = 11265,
  [11305] = 4245,
  [11306] = 4248,
  [11307] = 4160,
  [11308] = 4324,
  [11309] = 4350,
  [11310] = 5155,
  [11311] = 4291,
  [11312] = 4465,
  [11313] = 4351,
  [11314] = 4293,
  [11315] = 4320,
  [11316] = 4321,
  [11317] = 4354,
  [11318] = 4156,
  [11319] = 11298,
  [11320] = 11265,
  [11321] = 6707,
  [11322] = 6708,
  [11323] = 6709,
  [11324] = 5044,
  [11325] = 4435,
  [11326] = 4355,
  [11327] = 4125,
  [11328] = 4192,
  [11329] = 4302,
  [11330] = 5662,
  [11331] = 5697,
  [11332] = 4356,
  [11333] = 4105,
  [11334] = 4483,
  [11335] = 4295,
  [11336] = 4260,
  [11337] = 5044,
  [11338] = 4268,
  [11339] = 4369,
  [11340] = 4344,
  [11341] = 4252,
  [11342] = 5044,
  [11343] = 4327,
  [11344] = 6831,
  [11345] = 4325,
  [11346] = 6854,
  [11347] = 6855,
  [11348] = 4249,
  [11349] = 4326,
  [11350] = 4275,
  [11351] = 4322,
  [11352] = 4290,
  [11353] = 5953,
  [11354] = 4105,
  [11355] = 4435,
  [11356] = 4425,
  [11357] = 4327,
  [11358] = 4430,
  [11359] = 4250,
  [11360] = 4458,
  [11361] = 4156,
  [11362] = 4265,
  [11363] = 4483,
  [11364] = 4249,
  [11365] = 4459,
  [11366] = 4295,
  [11367] = 4248,
  [11368] = 4446,
  [11369] = 4250,
  [11370] = 4447,
  [11371] = 4458,
  [11372] = 4159,
  [11373] = 4160,
  [11374] = 4628,
  [11375] = 4453,
  [11376] = 11298,
  [11377] = 5697,
  [11378] = 4628,
  [11379] = 4345,
  [11380] = 6801,
  [11381] = 4164,
  [11382] = 4164,
  [11383] = 5044,
  [11384] = 4165,
  [11385] = 4160,
  [11386] = 4159,
  [11387] = 4160,
  [11388] = 4159,
  [11389] = 4160,
  [11390] = 4164,
  [11391] = 4165,
  [11392] = 4164,
  [11393] = 4165,
  [11394] = 6938,
  [11395] = 4131,
  [11396] = 4131,
  [11397] = 4131,
  [11398] = 4156,
  [11399] = 4112,
  [11400] = 4112,
  [11401] = 6710,
  [11402] = 6890,
  [11403] = 5044,
  [11404] = 4159,
  [11405] = 5044,
  [11406] = 4112,
  [11407] = 4125,
  [11408] = 4165,
  [11409] = 4131,
  [11410] = 6705,
  [11411] = 7219,
  [11412] = 6361,
  [11413] = 4105,
  [11414] = 4628,
  [11415] = 4160,
  [11416] = 5662,
  [11417] = 5697,
  [11418] = 5662,
  [11419] = 6704,
  [11420] = 5662,
  [11421] = 5697,
  [11422] = 5697,
  [11423] = 4112,
  [11424] = 4159,
  [11425] = 4164,
  [11426] = 11426,
  [11427] = 11427,
  [11428] = 7377,
  [11429] = 7379,
  [11430] = 7390,
  [11431] = 7402,
  [11432] = 4164,
  [11433] = 7273,
  [11434] = 4159,
  [11435] = 4160,
  [11436] = 7305,
  [11437] = 7404,
  [11438] = 7408,
  [11439] = 11426,
  [11440] = 11427,
  [11441] = 7409,
  [11442] = 11426,
  [11443] = 7420,
  [11444] = 7310,
  [11445] = 7336,
  [11446] = 7421,
  [11447] = 7361,
  [11448] = 7369,
  [11449] = 7297,
  [11450] = 7412,
  [11451] = 11427,
  [11452] = 7424,
  [11453] = 7433,
  [11454] = 7426,
  [11455] = 4164,
  [11456] = 7430,
  [11457] = 7431,
  [11458] = 4165,
  [11459] = 4131,
  [11460] = 4165,
  [11461] = 11426,
  [11462] = 11427,
  [11463] = 7257,
  [11464] = 7849,
  [11465] = 7295,
  [11466] = 7436,
  [11467] = 4159,
  [11468] = 4160,
  [11469] = 4164,
  [11470] = 5697,
  [11471] = 4165,
  [11472] = 7207,
  [11473] = 4105,
  [11474] = 7521,
  [11475] = 7508,
  [11476] = 7466,
  [11477] = 11426,
  [11478] = 7340,
  [11479] = 11427,
  [11480] = 4628,
  [11481] = 4131,
  [11482] = 7209,
  [11483] = 7553,
  [11484] = 7210,
  [11485] = 7341,
  [11486] = 7560,
  [11487] = 7223,
  [11488] = 7355,
  [11489] = 7498,
  [11490] = 7572,
  [11491] = 7359,
  [11492] = 4112,
  [11493] = 7224,
  [11494] = 7226,
  [11495] = 11426,
  [11496] = 11427,
  [11497] = 4628,
  [11498] = 7250,
  [11499] = 11426,
  [11500] = 11426,
  [11501] = 4112,
  [11502] = 7291,
  [11503] = 11427,
  [11504] = 4125,
  [11505] = 11427,
  [11506] = 7506,
  [11507] = 7256,
  [11508] = 4131,
  [11509] = 4112,
  [11510] = 11426,
  [11511] = 4159,
  [11512] = 4160,
  [11513] = 5662,
  [11514] = 7522,
  [11515] = 4164,
  [11516] = 4165,
  [11517] = 7848,
  [11518] = 4131,
  [11519] = 4160,
  [11520] = 7724,
  [11521] = 4164,
  [11522] = 4131,
  [11523] = 4112,
  [11524] = 4165,
  [11525] = 7524,
  [11526] = 4131,
  [11527] = 4112,
  [11528] = 4112,
  [11529] = 4131,
  [11530] = 4112,
  [11531] = 4131,
  [11532] = 11426,
  [11533] = 11427,
  [11534] = 5662,
  [11535] = 5697,
  [11536] = 4112,
  [11537] = 11426,
  [11538] = 11427,
  [11539] = 7695,
  [11540] = 7750,
  [11541] = 7761,
  [11542] = 7536,
  [11543] = 4118,
  [11544] = 7537,
  [11545] = 4159,
  [11546] = 4160,
  [11547] = 4125,
  [11548] = 4129,
  [11549] = 4164,
  [11550] = 11426,
  [11551] = 11427,
  [11552] = 4165,
  [11553] = 4123,
  [11554] = 11426,
  [11555] = 11427,
  [11556] = 4159,
  [11557] = 7294,
  [11558] = 11426,
  [11559] = 11427,
  [11560] = 7360,
  [11561] = 11426,
  [11562] = 11427,
  [11563] = 7289,
  [11564] = 11426,
  [11565] = 11426,
  [11566] = 11427,
  [11567] = 7261,
  [11568] = 11427,
  [11569] = 11426,
  [11570] = 11427,
  [11571] = 4124,
  [11572] = 4160,
  [11573] = 11426,
  [11574] = 11427,
  [11575] = 4295,
  [11576] = 7640,
  [11577] = 4159,
  [11578] = 5662,
  [11579] = 5697,
  [11580] = 4160,
  [11581] = 4164,
  [11582] = 4165,
  [11583] = 7733,
  [11584] = 7244,
  [11585] = 7475,
  [11586] = 4144,
  [11587] = 7266,
  [11588] = 11427,
  [11589] = 11426,
  [11590] = 11427,
  [11591] = 4159,
  [11592] = 4160,
  [11593] = 4165,
  [11594] = 7552,
  [11595] = 7764,
  [11596] = 7767,
  [11597] = 7243,
  [11598] = 4159,
  [11599] = 4164,
  [11600] = 4144,
  [11601] = 4112,
  [11602] = 4112,
  [11603] = 11603,
  [11604] = 11603,
  [11605] = 4435,
  [11606] = 11606,
  [11607] = 11606,
  [11608] = 11603,
  [11609] = 4159,
  [11610] = 4160,
  [11611] = 4265,
  [11612] = 4164,
  [11613] = 4165,
  [11614] = 4182,
  [11615] = 11606,
  [11616] = 4183,
  [11617] = 4291,
  [11618] = 6601,
  [11619] = 4144,
  [11620] = 4293,
  [11621] = 4320,
  [11622] = 4321,
  [11623] = 4483,
  [11624] = 4325,
  [11625] = 4131,
  [11626] = 4326,
  [11627] = 4327,
  [11628] = 4249,
  [11629] = 4131,
  [11630] = 4250,
  [11631] = 11603,
  [11632] = 4302,
  [11633] = 4300,
  [11634] = 11603,
  [11635] = 4171,
  [11636] = 6516,
  [11637] = 4301,
  [11638] = 4131,
  [11639] = 4324,
  [11640] = 11603,
  [11641] = 4338,
  [11642] = 4339,
  [11643] = 4340,
  [11644] = 4159,
  [11645] = 4112,
  [11646] = 4341,
  [11647] = 4131,
  [11648] = 4160,
  [11649] = 4112,
  [11650] = 4342,
  [11651] = 4131,
  [11652] = 4112,
  [11653] = 11603,
  [11654] = 4308,
  [11655] = 4309,
  [11656] = 11606,
  [11657] = 4173,
  [11658] = 4174,
  [11659] = 4344,
  [11660] = 4345,
  [11661] = 4346,
  [11662] = 4347,
  [11663] = 4348,
  [11664] = 4245,
  [11665] = 11606,
  [11666] = 4350,
  [11667] = 4351,
  [11668] = 4353,
  [11669] = 6237,
  [11670] = 4175,
  [11671] = 11606,
  [11672] = 4354,
  [11673] = 4355,
  [11674] = 4356,
  [11675] = 4184,
  [11676] = 6583,
  [11677] = 11606,
  [11678] = 11603,
  [11679] = 11606,
  [11680] = 11606,
  [11681] = 6588,
  [11682] = 4179,
  [11683] = 11606,
  [11684] = 4180,
  [11685] = 4152,
  [11686] = 4181,
  [11687] = 11603,
  [11688] = 4165,
  [11689] = 11606,
  [11690] = 5953,
  [11691] = 5044,
  [11692] = 11603,
  [11693] = 11606,
  [11694] = 4131,
  [11695] = 11606,
  [11696] = 6601,
  [11697] = 4153,
  [11698] = 11606,
  [11699] = 4322,
  [11700] = 11603,
  [11701] = 11603,
  [11702] = 11606,
  [11703] = 4164,
  [11704] = 4165,
  [11705] = 4164,
  [11706] = 4369,
  [11707] = 4159,
  [11708] = 11606,
  [11709] = 4159,
  [11710] = 4160,
  [11711] = 11606,
  [11712] = 11603,
  [11713] = 4159,
  [11714] = 4160,
  [11715] = 4458,
  [11716] = 4295,
  [11717] = 11606,
  [11718] = 4159,
  [11719] = 4160,
  [11720] = 4164,
  [11721] = 4165,
  [11722] = 4459,
  [11723] = 4248,
  [11724] = 4252,
  [11725] = 4164,
  [11726] = 4165,
  [11727] = 4165,
  [11728] = 11606,
  [11729] = 4160,
  [11730] = 11603,
  [11731] = 4112,
  [11732] = 6583,
  [11733] = 6583,
  [11734] = 6584,
  [11735] = 6588,
  [11736] = 6516,
  [11737] = 6601,
  [11738] = 4105,
  [11739] = 11606,
  [11740] = 6237,
  [11741] = 6584,
  [11742] = 6588,
  [11743] = 6516,
  [11744] = 6237,
  [11745] = 6584,
  [11746] = 4430,
  [11747] = 11747,
  [11748] = 11748,
  [11749] = 11749,
  [11750] = 6705,
  [11751] = 11748,
  [11752] = 4369,
  [11753] = 6705,
  [11754] = 7071,
  [11755] = 6885,
  [11756] = 11749,
  [11757] = 6831,
  [11758] = 7072,
  [11759] = 6854,
  [11760] = 6855,
  [11761] = 11747,
  [11762] = 11747,
  [11763] = 7073,
  [11764] = 11749,
  [11765] = 11748,
  [11766] = 4159,
  [11767] = 6705,
  [11768] = 4309,
  [11769] = 4355,
  [11770] = 11747,
  [11771] = 11748,
  [11772] = 5044,
  [11773] = 11748,
  [11774] = 11749,
  [11775] = 6361,
  [11776] = 11748,
  [11777] = 11749,
  [11778] = 11748,
  [11779] = 6801,
  [11780] = 4347,
  [11781] = 11747,
  [11782] = 4265,
  [11783] = 4458,
  [11784] = 11747,
  [11785] = 4459,
  [11786] = 4291,
  [11787] = 11748,
  [11788] = 4293,
  [11789] = 11747,
  [11790] = 11748,
  [11791] = 11748,
  [11792] = 4320,
  [11793] = 4321,
  [11794] = 6774,
  [11795] = 6237,
  [11796] = 4164,
  [11797] = 4252,
  [11798] = 11748,
  [11799] = 11748,
  [11800] = 4260,
  [11801] = 11748,
  [11802] = 4268,
  [11803] = 11748,
  [11804] = 11747,
  [11805] = 4325,
  [11806] = 11747,
  [11807] = 4275,
  [11808] = 4112,
  [11809] = 4326,
  [11810] = 11748,
  [11811] = 4290,
  [11812] = 6237,
  [11813] = 11748,
  [11814] = 6938,
  [11815] = 11748,
  [11816] = 11749,
  [11817] = 4348,
  [11818] = 4327,
  [11819] = 11748,
  [11820] = 4249,
  [11821] = 4159,
  [11822] = 4160,
  [11823] = 6787,
  [11824] = 4425,
  [11825] = 11748,
  [11826] = 4112,
  [11827] = 4345,
  [11828] = 4164,
  [11829] = 4160,
  [11830] = 4250,
  [11831] = 4165,
  [11832] = 4359,
  [11833] = 4245,
  [11834] = 11748,
  [11835] = 11748,
  [11836] = 11747,
  [11837] = 6817,
  [11838] = 4248,
  [11839] = 6601,
  [11840] = 5662,
  [11841] = 5697,
  [11842] = 6707,
  [11843] = 11748,
  [11844] = 4322,
  [11845] = 6780,
  [11846] = 11747,
  [11847] = 11748,
  [11848] = 11748,
  [11849] = 6704,
  [11850] = 11748,
  [11851] = 6780,
  [11852] = 11852,
  [11853] = 4346,
  [11854] = 6817,
  [11855] = 6883,
  [11856] = 6885,
  [11857] = 11747,
  [11858] = 6889,
  [11859] = 11748,
  [11860] = 6774,
  [11861] = 6831,
  [11862] = 6854,
  [11863] = 6855,
  [11864] = 11748,
  [11865] = 4435,
  [11866] = 6962,
  [11867] = 11748,
  [11868] = 11748,
  [11869] = 4350,
  [11870] = 11747,
  [11871] = 11749,
  [11872] = 6817,
  [11873] = 4289,
  [11874] = 4302,
  [11875] = 11748,
  [11876] = 4112,
  [11877] = 4446,
  [11878] = 11748,
  [11879] = 11747,
  [11880] = 11748,
  [11881] = 4164,
  [11882] = 6601,
  [11883] = 4447,
  [11884] = 4165,
  [11885] = 11748,
  [11886] = 4131,
  [11887] = 6708,
  [11888] = 4165,
  [11889] = 11747,
  [11890] = 7080,
  [11891] = 11748,
  [11892] = 6601,
  [11893] = 11748,
  [11894] = 4300,
  [11895] = 4453,
  [11896] = 4465,
  [11897] = 4301,
  [11898] = 11748,
  [11899] = 4324,
  [11900] = 11748,
  [11901] = 7071,
  [11902] = 7072,
  [11903] = 7073,
  [11904] = 4351,
  [11905] = 11749,
  [11906] = 11749,
  [11907] = 11748,
  [11908] = 4295,
  [11909] = 11747,
  [11910] = 11748,
  [11911] = 11748,
  [11912] = 6883,
  [11913] = 11748,
  [11914] = 7075,
  [11915] = 4467,
  [11916] = 4338,
  [11917] = 4339,
  [11918] = 11748,
  [11919] = 4340,
  [11920] = 11747,
  [11921] = 4341,
  [11922] = 4342,
  [11923] = 11748,
  [11924] = 11748,
  [11925] = 6817,
  [11926] = 4295,
  [11927] = 6889,
  [11928] = 11748,
  [11929] = 6774,
  [11930] = 11748,
  [11931] = 4159,
  [11932] = 11748,
  [11933] = 11748,
  [11934] = 11749,
  [11935] = 4353,
  [11936] = 4308,
  [11937] = 7075,
  [11938] = 11852,
  [11939] = 6774,
  [11940] = 4131,
  [11941] = 11748,
  [11942] = 6704,
  [11943] = 11748,
  [11944] = 11749,
  [11945] = 6774,
  [11946] = 11748,
  [11947] = 6704,
  [11948] = 11748,
  [11949] = 11748,
  [11950] = 11748,
  [11951] = 11747,
  [11952] = 4356,
  [11953] = 11749,
  [11954] = 6709,
  [11955] = 11748,
  [11956] = 11748,
  [11957] = 11748,
  [11958] = 11749,
  [11959] = 4483,
  [11960] = 11748,
  [11961] = 4105,
  [11962] = 6583,
  [11963] = 11747,
  [11964] = 11748,
  [11965] = 6707,
  [11966] = 6708,
  [11967] = 6709,
  [11968] = 6774,
  [11969] = 11748,
  [11970] = 4354,
  [11971] = 6707,
  [11972] = 6708,
  [11973] = 6709,
  [11974] = 4160,
  [11975] = 6710,
  [11976] = 6787,
  [11977] = 6883,
  [11978] = 6885,
  [11979] = 6704,
  [11980] = 6889,
  [11981] = 6831,
  [11982] = 6854,
  [11983] = 6855,
  [11984] = 11749,
  [11985] = 6583,
  [11986] = 6890,
  [11987] = 11748,
  [11988] = 6583,
  [11989] = 6704,
  [11990] = 6237,
  [11991] = 7080,
  [11992] = 4344,
  [11993] = 6584,
  [11994] = 6588,
  [11995] = 6516,
  [11996] = 6237,
  [11997] = 11748,
  [11998] = 11747,
  [11999] = 6962,
  [12000] = 6237,
  [12001] = 6584,
  [12002] = 6588,
  [12003] = 6516,
  [12004] = 4131,
  [12005] = 6584,
  [12006] = 6588,
  [12007] = 6516,
  [12008] = 6237,
  [12009] = 4292,
  [12010] = 6774,
  [12011] = 7075,
  [12012] = 7355,
  [12013] = 6962,
  [12014] = 6962,
  [12015] = 6583,
  [12016] = 6704,
  [12017] = 12017,
  [12018] = 7297,
  [12019] = 6774,
  [12020] = 12020,
  [12021] = 11852,
  [12022] = 7226,
  [12023] = 7750,
  [12024] = 7761,
  [12025] = 6584,
  [12026] = 6588,
  [12027] = 7764,
  [12028] = 7767,
  [12029] = 7848,
  [12030] = 7849,
  [12031] = 12017,
  [12032] = 12017,
  [12033] = 7207,
  [12034] = 12020,
  [12035] = 7209,
  [12036] = 7226,
  [12037] = 6774,
  [12038] = 12020,
  [12039] = 7210,
  [12040] = 6774,
  [12041] = 6817,
  [12042] = 6704,
  [12043] = 7223,
  [12044] = 7224,
  [12045] = 7264,
  [12046] = 7250,
  [12047] = 6817,
  [12048] = 7256,
  [12049] = 12017,
  [12050] = 7075,
  [12051] = 12017,
  [12052] = 12020,
  [12053] = 12017,
  [12054] = 12020,
  [12055] = 7695,
  [12056] = 7359,
  [12057] = 7080,
  [12058] = 7322,
  [12059] = 12020,
  [12060] = 7710,
  [12061] = 7649,
  [12062] = 7266,
  [12063] = 7652,
  [12064] = 7649,
  [12065] = 6817,
  [12066] = 7640,
  [12067] = 7652,
  [12068] = 7417,
  [12069] = 12017,
  [12070] = 6516,
  [12071] = 12020,
  [12072] = 7322,
  [12073] = 12017,
  [12074] = 7075,
  [12075] = 6705,
  [12076] = 6705,
  [12077] = 12020,
  [12078] = 7310,
  [12079] = 7336,
  [12080] = 6774,
  [12081] = 7361,
  [12082] = 7369,
  [12083] = 7412,
  [12084] = 7075,
  [12085] = 12017,
  [12086] = 7080,
  [12087] = 12020,
  [12088] = 7080,
  [12089] = 7424,
  [12090] = 6774,
  [12091] = 7075,
  [12092] = 7075,
  [12093] = 7075,
  [12094] = 7433,
  [12095] = 7075,
  [12096] = 7080,
  [12097] = 7705,
  [12098] = 7080,
  [12099] = 7080,
  [12100] = 7071,
  [12101] = 7072,
  [12102] = 7073,
  [12103] = 6780,
  [12104] = 7071,
  [12105] = 7072,
  [12106] = 7073,
  [12107] = 7071,
  [12108] = 7072,
  [12109] = 7073,
  [12110] = 7071,
  [12111] = 7072,
  [12112] = 7073,
  [12113] = 7071,
  [12114] = 7072,
  [12115] = 7073,
  [12116] = 6780,
  [12117] = 12017,
  [12118] = 12020,
  [12119] = 12017,
  [12120] = 7711,
  [12121] = 12020,
  [12122] = 12017,
  [12123] = 6817,
  [12124] = 12020,
  [12125] = 7466,
  [12126] = 7080,
  [12127] = 7712,
  [12128] = 6787,
  [12129] = 7340,
  [12130] = 7713,
  [12131] = 7273,
  [12132] = 6774,
  [12133] = 12017,
  [12134] = 7714,
  [12135] = 7716,
  [12136] = 6962,
  [12137] = 7717,
  [12138] = 12020,
  [12139] = 12017,
  [12140] = 6774,
  [12141] = 12020,
  [12142] = 7072,
  [12143] = 7324,
  [12144] = 6704,
  [12145] = 7325,
  [12146] = 7326,
  [12147] = 7327,
  [12148] = 7328,
  [12149] = 7219,
  [12150] = 11852,
  [12151] = 7305,
  [12152] = 7075,
  [12153] = 6774,
  [12154] = 7073,
  [12155] = 7291,
  [12156] = 7289,
  [12157] = 7475,
  [12158] = 6962,
  [12159] = 6704,
  [12160] = 12017,
  [12161] = 7071,
  [12162] = 7072,
  [12163] = 7073,
  [12164] = 7080,
  [12165] = 7075,
  [12166] = 7377,
  [12167] = 6817,
  [12168] = 12017,
  [12169] = 7075,
  [12170] = 12017,
  [12171] = 7379,
  [12172] = 12020,
  [12173] = 7390,
  [12174] = 12020,
  [12175] = 6774,
  [12176] = 7402,
  [12177] = 6780,
  [12178] = 7404,
  [12179] = 7408,
  [12180] = 6787,
  [12181] = 7695,
  [12182] = 7309,
  [12183] = 6817,
  [12184] = 4112,
  [12185] = 6962,
  [12186] = 12017,
  [12187] = 12020,
  [12188] = 12020,
  [12189] = 7417,
  [12190] = 7229,
  [12191] = 7272,
  [12192] = 7498,
  [12193] = 6817,
  [12194] = 7249,
  [12195] = 7226,
  [12196] = 7409,
  [12197] = 7420,
  [12198] = 7421,
  [12199] = 4131,
  [12200] = 6787,
  [12201] = 12017,
  [12202] = 12020,
  [12203] = 7506,
  [12204] = 7521,
  [12205] = 7426,
  [12206] = 7430,
  [12207] = 7431,
  [12208] = 11852,
  [12209] = 12017,
  [12210] = 6774,
  [12211] = 12020,
  [12212] = 7295,
  [12213] = 6704,
  [12214] = 6237,
  [12215] = 7436,
  [12216] = 12020,
  [12217] = 7522,
  [12218] = 6704,
  [12219] = 7264,
  [12220] = 6601,
  [12221] = 7524,
  [12222] = 6962,
  [12223] = 12017,
  [12224] = 6237,
  [12225] = 7536,
  [12226] = 7537,
  [12227] = 12017,
  [12228] = 12017,
  [12229] = 12020,
  [12230] = 12020,
  [12231] = 12017,
  [12232] = 7080,
  [12233] = 12020,
  [12234] = 6704,
  [12235] = 6780,
  [12236] = 6774,
  [12237] = 7243,
  [12238] = 7552,
  [12239] = 12017,
  [12240] = 12020,
  [12241] = 7553,
  [12242] = 6705,
  [12243] = 7724,
  [12244] = 7560,
  [12245] = 6817,
  [12246] = 6705,
  [12247] = 6817,
  [12248] = 6705,
  [12249] = 6817,
  [12250] = 12020,
  [12251] = 6817,
  [12252] = 12017,
  [12253] = 12017,
  [12254] = 12020,
  [12255] = 12020,
  [12256] = 7080,
  [12257] = 7294,
  [12258] = 7572,
  [12259] = 6780,
  [12260] = 6787,
  [12261] = 12017,
  [12262] = 7226,
  [12263] = 7360,
  [12264] = 12020,
  [12265] = 7695,
  [12266] = 6817,
  [12267] = 7261,
  [12268] = 6774,
  [12269] = 6704,
  [12270] = 7733,
  [12271] = 7222,
  [12272] = 12272,
  [12273] = 7229,
  [12274] = 7272,
  [12275] = 7249,
  [12276] = 7244,
  [12277] = 12017,
  [12278] = 12020,
  [12279] = 6883,
  [12280] = 6885,
  [12281] = 6889,
  [12282] = 4159,
  [12283] = 6831,
  [12284] = 6854,
  [12285] = 6855,
  [12286] = 7341,
  [12287] = 4160,
  [12288] = 4164,
  [12289] = 12017,
  [12290] = 12017,
  [12291] = 12020,
  [12292] = 6774,
  [12293] = 7071,
  [12294] = 6787,
  [12295] = 7219,
  [12296] = 12017,
  [12297] = 7219,
  [12298] = 7222,
  [12299] = 12020,
  [12300] = 6883,
  [12301] = 6885,
  [12302] = 6889,
  [12303] = 7229,
  [12304] = 6831,
  [12305] = 6854,
  [12306] = 6855,
  [12307] = 7071,
  [12308] = 7272,
  [12309] = 7072,
  [12310] = 7249,
  [12311] = 7073,
  [12312] = 7508,
  [12313] = 6883,
  [12314] = 6885,
  [12315] = 6889,
  [12316] = 4165,
  [12317] = 6831,
  [12318] = 6854,
  [12319] = 6855,
  [12320] = 7309,
  [12321] = 12020,
  [12322] = 6704,
  [12323] = 6583,
  [12324] = 12017,
  [12325] = 6583,
  [12326] = 6584,
  [12327] = 6588,
  [12328] = 6516,
  [12329] = 6601,
  [12330] = 6962,
  [12331] = 6780,
  [12332] = 6601,
  [12333] = 6787,
  [12334] = 6962,
  [12335] = 12272,
  [12336] = 7229,
  [12337] = 7272,
  [12338] = 7249,
  [12339] = 12017,
  [12340] = 7264,
  [12341] = 7264,
  [12342] = 12020,
  [12343] = 12017,
  [12344] = 7226,
  [12345] = 12020,
  [12346] = 12017,
  [12347] = 7257,
  [12348] = 6774,
  [12349] = 6707,
  [12350] = 6708,
  [12351] = 6709,
  [12352] = 6237,
  [12353] = 7705,
  [12354] = 12020,
  [12355] = 7710,
  [12356] = 7711,
  [12357] = 7712,
  [12358] = 6237,
  [12359] = 6707,
  [12360] = 6708,
  [12361] = 6709,
  [12362] = 6707,
  [12363] = 6708,
  [12364] = 6709,
  [12365] = 7713,
  [12366] = 7714,
  [12367] = 6584,
  [12368] = 6588,
  [12369] = 6516,
  [12370] = 7716,
  [12371] = 6237,
  [12372] = 7717,
  [12373] = 6705,
  [12374] = 7324,
  [12375] = 7325,
  [12376] = 7326,
  [12377] = 7327,
  [12378] = 7328,
  [12379] = 12020,
  [12380] = 6237,
  [12381] = 12017,
  [12382] = 7695,
  [12383] = 6855,
  [12384] = 6817,
  [12385] = 7229,
  [12386] = 7071,
  [12387] = 7272,
  [12388] = 7072,
  [12389] = 7080,
  [12390] = 7249,
  [12391] = 7073,
  [12392] = 6817,
  [12393] = 6787,
  [12394] = 6787,
  [12395] = 6237,
  [12396] = 7264,
  [12397] = 7272,
  [12398] = 6962,
  [12399] = 7309,
  [12400] = 6883,
  [12401] = 6774,
  [12402] = 7080,
  [12403] = 7264,
  [12404] = 7222,
  [12405] = 12272,
  [12406] = 6817,
  [12407] = 6705,
  [12408] = 7652,
  [12409] = 7071,
  [12410] = 7072,
  [12411] = 7322,
  [12412] = 7073,
  [12413] = 7226,
  [12414] = 7249,
  [12415] = 7417,
  [12416] = 7324,
  [12417] = 7075,
  [12418] = 6885,
  [12419] = 6780,
  [12420] = 12420,
  [12421] = 6774,
  [12422] = 7075,
  [12423] = 7080,
  [12424] = 6705,
  [12425] = 7080,
  [12426] = 6962,
  [12427] = 6962,
  [12428] = 7695,
  [12429] = 7325,
  [12430] = 6817,
  [12431] = 7705,
  [12432] = 7326,
  [12433] = 7652,
  [12434] = 7226,
  [12435] = 6889,
  [12436] = 7711,
  [12437] = 7695,
  [12438] = 7272,
  [12439] = 7222,
  [12440] = 7327,
  [12441] = 6962,
  [12442] = 6962,
  [12443] = 7712,
  [12444] = 7713,
  [12445] = 6962,
  [12446] = 7075,
  [12447] = 7695,
  [12448] = 7713,
  [12449] = 7714,
  [12450] = 7071,
  [12451] = 7072,
  [12452] = 7073,
  [12453] = 7716,
  [12454] = 7229,
  [12455] = 7717,
  [12456] = 7695,
  [12457] = 7324,
  [12458] = 7328,
  [12459] = 7325,
  [12460] = 7326,
  [12461] = 7652,
  [12462] = 6704,
  [12463] = 7652,
  [12464] = 6780,
  [12465] = 6704,
  [12466] = 7710,
  [12467] = 7075,
  [12468] = 7226,
  [12469] = 7071,
  [12470] = 7652,
  [12471] = 7072,
  [12472] = 7417,
  [12473] = 6774,
  [12474] = 7327,
  [12475] = 7652,
  [12476] = 7073,
  [12477] = 7328,
  [12478] = 6774,
  [12479] = 4159,
  [12480] = 7264,
  [12481] = 7226,
  [12482] = 7222,
  [12483] = 6707,
  [12484] = 7649,
  [12485] = 7714,
  [12486] = 12272,
  [12487] = 7649,
  [12488] = 4160,
  [12489] = 7075,
  [12490] = 6704,
  [12491] = 6780,
  [12492] = 7249,
  [12493] = 4164,
  [12494] = 7309,
  [12495] = 6962,
  [12496] = 6962,
  [12497] = 12497,
  [12498] = 6817,
  [12499] = 7229,
  [12500] = 7075,
  [12501] = 7322,
  [12502] = 4165,
  [12503] = 6774,
  [12504] = 7264,
  [12505] = 7222,
  [12506] = 7272,
  [12507] = 7229,
  [12508] = 6704,
  [12509] = 7710,
  [12510] = 7219,
  [12511] = 7272,
  [12512] = 6817,
  [12513] = 7649,
  [12514] = 6962,
  [12515] = 7226,
  [12516] = 7417,
  [12517] = 7249,
  [12518] = 6831,
  [12519] = 6962,
  [12520] = 7716,
  [12521] = 7249,
  [12522] = 7226,
  [12523] = 7075,
  [12524] = 7080,
  [12525] = 7229,
  [12526] = 7705,
  [12527] = 6962,
  [12528] = 7322,
  [12529] = 7071,
  [12530] = 7710,
  [12531] = 7417,
  [12532] = 7711,
  [12533] = 7712,
  [12534] = 7713,
  [12535] = 6774,
  [12536] = 6704,
  [12537] = 12537,
  [12538] = 7714,
  [12539] = 7716,
  [12540] = 7717,
  [12541] = 7324,
  [12542] = 7325,
  [12543] = 7326,
  [12544] = 7272,
  [12545] = 7072,
  [12546] = 7327,
  [12547] = 7328,
  [12548] = 6774,
  [12549] = 7249,
  [12550] = 7073,
  [12551] = 6704,
  [12552] = 7705,
  [12553] = 7710,
  [12554] = 6817,
  [12555] = 6705,
  [12556] = 7711,
  [12557] = 7652,
  [12558] = 7712,
  [12559] = 7712,
  [12560] = 7075,
  [12561] = 7713,
  [12562] = 7229,
  [12563] = 7219,
  [12564] = 7272,
  [12565] = 6962,
  [12566] = 7249,
  [12567] = 6962,
  [12568] = 7071,
  [12569] = 7072,
  [12570] = 6817,
  [12571] = 6705,
  [12572] = 7073,
  [12573] = 7714,
  [12574] = 7264,
  [12575] = 7080,
  [12576] = 7716,
  [12577] = 7071,
  [12578] = 7072,
  [12579] = 7717,
  [12580] = 7219,
  [12581] = 7073,
  [12582] = 6774,
  [12583] = 6774,
  [12584] = 6705,
  [12585] = 7324,
  [12586] = 6708,
  [12587] = 7325,
  [12588] = 7080,
  [12589] = 7326,
  [12590] = 12420,
  [12591] = 7075,
  [12592] = 7328,
  [12593] = 7080,
  [12594] = 6817,
  [12595] = 6707,
  [12596] = 6708,
  [12597] = 6709,
  [12598] = 7649,
  [12599] = 7417,
  [12600] = 11852,
  [12601] = 7080,
  [12602] = 6709,
  [12603] = 6707,
  [12604] = 6708,
  [12605] = 6709,
  [12606] = 7649,
  [12607] = 7229,
  [12608] = 7229,
  [12609] = 6883,
  [12610] = 6885,
  [12611] = 7080,
  [12612] = 6889,
  [12613] = 6831,
  [12614] = 6854,
  [12615] = 6855,
  [12616] = 7071,
  [12617] = 7649,
  [12618] = 7705,
  [12619] = 6854,
  [12620] = 7711,
  [12621] = 7705,
  [12622] = 6855,
  [12623] = 4131,
  [12624] = 7322,
  [12625] = 7309,
  [12626] = 7264,
  [12627] = 7649,
  [12628] = 7711,
  [12629] = 7322,
  [12630] = 7712,
  [12631] = 7272,
  [12632] = 7309,
  [12633] = 6817,
  [12634] = 6780,
  [12635] = 7264,
  [12636] = 7264,
  [12637] = 7264,
  [12638] = 7713,
  [12639] = 6787,
  [12640] = 7652,
  [12641] = 6705,
  [12642] = 7710,
  [12643] = 7229,
  [12644] = 7071,
  [12645] = 7272,
  [12646] = 7072,
  [12647] = 7249,
  [12648] = 7073,
  [12649] = 6817,
  [12650] = 7072,
  [12651] = 7264,
  [12652] = 6774,
  [12653] = 7705,
  [12654] = 7710,
  [12655] = 7711,
  [12656] = 7712,
  [12657] = 7713,
  [12658] = 7714,
  [12659] = 7716,
  [12660] = 7717,
  [12661] = 7324,
  [12662] = 7325,
  [12663] = 7326,
  [12664] = 7327,
  [12665] = 7328,
  [12666] = 7222,
  [12667] = 7705,
  [12668] = 7710,
  [12669] = 6817,
  [12670] = 6817,
  [12671] = 4112,
  [12672] = 7711,
  [12673] = 7712,
  [12674] = 7713,
  [12675] = 7714,
  [12676] = 7716,
  [12677] = 7717,
  [12678] = 7222,
  [12679] = 7264,
  [12680] = 7649,
  [12681] = 6705,
  [12682] = 7075,
  [12683] = 7249,
  [12684] = 7229,
  [12685] = 7272,
  [12686] = 7249,
  [12687] = 7710,
  [12688] = 7222,
  [12689] = 7075,
  [12690] = 7705,
  [12691] = 7711,
  [12692] = 7080,
  [12693] = 7712,
  [12694] = 7713,
  [12695] = 6237,
  [12696] = 7073,
  [12697] = 6817,
  [12698] = 7075,
  [12699] = 7714,
  [12700] = 7716,
  [12701] = 7717,
  [12702] = 6237,
  [12703] = 7272,
  [12704] = 7324,
  [12705] = 7325,
  [12706] = 7326,
  [12707] = 7327,
  [12708] = 7328,
  [12709] = 7714,
  [12710] = 7080,
  [12711] = 6787,
  [12712] = 6705,
  [12713] = 7716,
  [12714] = 7717,
  [12715] = 6817,
  [12716] = 7324,
  [12717] = 7325,
  [12718] = 7326,
  [12719] = 7327,
  [12720] = 7328,
  [12721] = 12272,
  [12722] = 7226,
  [12723] = 7309,
  [12724] = 7075,
  [12725] = 7249,
  [12726] = 7309,
  [12727] = 7322,
  [12728] = 7309,
  [12729] = 7322,
  [12730] = 7309,
  [12731] = 7717,
  [12732] = 7229,
  [12733] = 7229,
  [12734] = 7322,
  [12735] = 7417,
  [12736] = 7272,
  [12737] = 7249,
  [12738] = 7226,
  [12739] = 6817,
  [12740] = 7071,
  [12741] = 7072,
  [12742] = 7073,
  [12743] = 6705,
  [12744] = 7695,
  [12745] = 7075,
  [12746] = 7324,
  [12747] = 6883,
  [12748] = 6885,
  [12749] = 7226,
  [12750] = 6889,
  [12751] = 7325,
  [12752] = 11852,
  [12753] = 7326,
  [12754] = 7327,
  [12755] = 7328,
  [12756] = 7080,
  [12757] = 7264,
  [12758] = 6831,
  [12759] = 7222,
  [12760] = 6854,
  [12761] = 7327,
  [12762] = 6817,
  [12763] = 7695,
  [12764] = 6962,
  [12765] = 6780,
  [12766] = 7309,
  [12767] = 6787,
  [12768] = 7071,
  [12769] = 6774,
  [12770] = 6962,
  [12771] = 7075,
  [12772] = 7322,
  [12773] = 7272,
  [12774] = 7075,
  [12775] = 12775,
  [12776] = 7705,
  [12777] = 6774,
  [12778] = 7072,
  [12779] = 7710,
  [12780] = 7711,
  [12781] = 7712,
  [12782] = 7705,
  [12783] = 7710,
  [12784] = 7711,
  [12785] = 7712,
  [12786] = 7713,
  [12787] = 7714,
  [12788] = 7716,
  [12789] = 7717,
  [12790] = 7324,
  [12791] = 7325,
  [12792] = 7326,
  [12793] = 7327,
  [12794] = 7328,
  [12795] = 7713,
  [12796] = 7714,
  [12797] = 7716,
  [12798] = 7717,
  [12799] = 7324,
  [12800] = 7325,
  [12801] = 7326,
  [12802] = 7327,
  [12803] = 7328,
  [12804] = 7249,
  [12805] = 6704,
  [12806] = 7073,
  [12807] = 7222,
  [12808] = 7264,
  [12809] = 6962,
  [12810] = 7695,
  [12811] = 7649,
  [12812] = 7080,
  [12813] = 7222,
  [12814] = 7652,
  [12815] = 7710,
  [12816] = 7309,
  [12817] = 7075,
  [12818] = 7705,
  [12819] = 7711,
  [12820] = 7712,
  [12821] = 7713,
  [12822] = 7714,
  [12823] = 7716,
  [12824] = 7717,
  [12825] = 7324,
  [12826] = 7325,
  [12827] = 7326,
  [12828] = 7327,
  [12829] = 7328,
  [12830] = 9266,
  [12831] = 7226,
  [12832] = 6774,
  [12833] = 7229,
  [12834] = 6780,
  [12835] = 7071,
  [12836] = 7272,
  [12837] = 7072,
  [12838] = 7249,
  [12839] = 6787,
  [12840] = 7073,
  [12841] = 7264,
  [12842] = 7695,
  [12843] = 7710,
  [12844] = 7080,
  [12845] = 7705,
  [12846] = 7711,
  [12847] = 7712,
  [12848] = 7713,
  [12849] = 7714,
  [12850] = 7716,
  [12851] = 7717,
  [12852] = 7324,
  [12853] = 7325,
  [12854] = 7326,
  [12855] = 7327,
  [12856] = 7328,
  [12857] = 12272,
  [12858] = 7417,
  [12859] = 7322,
  [12860] = 7705,
  [12861] = 7710,
  [12862] = 7711,
  [12863] = 7229,
  [12864] = 7712,
  [12865] = 7226,
  [12866] = 7071,
  [12867] = 7713,
  [12868] = 7714,
  [12869] = 7272,
  [12870] = 7072,
  [12871] = 7716,
  [12872] = 7717,
  [12873] = 7249,
  [12874] = 7073,
  [12875] = 7324,
  [12876] = 7325,
  [12877] = 7326,
  [12878] = 7327,
  [12879] = 7695,
  [12880] = 7328,
  [12881] = 7219,
  [12882] = 7309,
  [12883] = 7309,
  [12884] = 7264,
  [12885] = 6962,
  [12886] = 7695,
  [12887] = 7222,
  [12888] = 7080,
  [12889] = 12272,
  [12890] = 7417,
  [12891] = 7322,
  [12892] = 7705,
  [12893] = 7710,
  [12894] = 7711,
  [12895] = 7712,
  [12896] = 7652,
  [12897] = 7713,
  [12898] = 7714,
  [12899] = 7716,
  [12900] = 7717,
  [12901] = 7324,
  [12902] = 7229,
  [12903] = 7272,
  [12904] = 7249,
  [12905] = 7325,
  [12906] = 7326,
  [12907] = 7327,
  [12908] = 7328,
  [12909] = 7226,
  [12910] = 7649,
  [12911] = 7226,
  [12912] = 7229,
  [12913] = 7272,
  [12914] = 7249,
  [12915] = 7226,
  [12916] = 7264,
  [12917] = 7229,
  [12918] = 7272,
  [12919] = 7249,
  [12920] = 7080,
  [12921] = 7695,
  [12922] = 6774,
  [12923] = 7264,
  [12924] = 7264,
  [12925] = 7264,
  [12926] = 7417,
  [12927] = 7075,
  [12928] = 7649,
  [12929] = 7229,
  [12930] = 7272,
  [12931] = 7249,
  [12932] = 9021,
  [12933] = 7417,
  [12934] = 6962,
  [12935] = 7322,
  [12936] = 7264,
  [12937] = 6817,
  [12938] = 7080,
  [12939] = 7652,
  [12940] = 7649,
  [12941] = 12941,
  [12942] = 7652,
  [12943] = 7649,
  [12944] = 7652,
  [12945] = 7222,
  [12946] = 7080,
  [12947] = 7080,
  [12948] = 7222,
  [12949] = 7652,
  [12950] = 7075,
  [12951] = 7711,
  [12952] = 7222,
  [12953] = 7652,
  [12954] = 7075,
  [12955] = 7222,
  [12956] = 7711,
  [12957] = 7071,
  [12958] = 7072,
  [12959] = 7073,
  [12960] = 7711,
  [12961] = 7071,
  [12962] = 7072,
  [12963] = 7073,
  [12964] = 7649,
  [12965] = 7649,
  [12966] = 7711,
  [12967] = 7222,
  [12968] = 7711,
  [12969] = 7222,
  [12970] = 7222,
  [12971] = 7711,
  [12972] = 7222,
  [12973] = 7322,
  [12974] = 7649,
  [12975] = 9125,
  [12976] = 6962,
  [12977] = 7652,
  [12978] = 6705,
  [12979] = 7652,
  [12980] = 7652,
  [12981] = 7649,
  [12982] = 7649,
  [12983] = 7649,
  [12984] = 7652,
  [12985] = 7649,
  [12986] = 7652,
  [12987] = 7649,
  [12988] = 7219,
  [12989] = 7219,
  [12990] = 7695,
  [12991] = 7705,
  [12992] = 7712,
  [12993] = 7713,
  [12994] = 7714,
  [12995] = 7716,
  [12996] = 7717,
  [12997] = 7324,
  [12998] = 7325,
  [12999] = 7326,
  [13000] = 7327,
  [13001] = 7328,
  [13002] = 7309,
  [13003] = 7322,
  [13004] = 7229,
  [13005] = 7071,
  [13006] = 7272,
  [13007] = 7072,
  [13008] = 7249,
  [13009] = 7073,
  [13010] = 6962,
  [13011] = 7226,
  [13012] = 6817,
  [13013] = 7705,
  [13014] = 7710,
  [13015] = 7712,
  [13016] = 7713,
  [13017] = 7714,
  [13018] = 7716,
  [13019] = 7717,
  [13020] = 7324,
  [13021] = 7325,
  [13022] = 7326,
  [13023] = 7327,
  [13024] = 7328,
  [13025] = 7075,
  [13026] = 7705,
  [13027] = 7710,
  [13028] = 7712,
  [13029] = 7713,
  [13030] = 7714,
  [13031] = 7716,
  [13032] = 7717,
  [13033] = 7309,
  [13034] = 7705,
  [13035] = 7712,
  [13036] = 7713,
  [13037] = 7714,
  [13038] = 7716,
  [13039] = 7717,
  [13040] = 7324,
  [13041] = 7325,
  [13042] = 7326,
  [13043] = 7327,
  [13044] = 7328,
  [13045] = 7324,
  [13046] = 7325,
  [13047] = 7326,
  [13048] = 7327,
  [13049] = 7328,
  [13050] = 7309,
  [13051] = 7322,
  [13052] = 7309,
  [13053] = 7322,
  [13054] = 7309,
  [13055] = 7322,
  [13056] = 6817,
  [13057] = 7080,
  [13058] = 6962,
  [13059] = 7222,
  [13060] = 6817,
  [13061] = 9021,
  [13062] = 7705,
  [13063] = 7710,
  [13064] = 7712,
  [13065] = 7713,
  [13066] = 7714,
  [13067] = 7716,
  [13068] = 7717,
  [13069] = 7324,
  [13070] = 7325,
  [13071] = 7326,
  [13072] = 7327,
  [13073] = 7328,
  [13074] = 7705,
  [13075] = 7710,
  [13076] = 7712,
  [13077] = 7713,
  [13078] = 7714,
  [13079] = 7716,
  [13080] = 7717,
  [13081] = 9125,
  [13082] = 6962,
  [13083] = 7710,
  [13084] = 7229,
  [13085] = 6962,
  [13086] = 7695,
  [13087] = 7309,
  [13088] = 7705,
  [13089] = 7712,
  [13090] = 7713,
  [13091] = 7714,
  [13092] = 7716,
  [13093] = 7717,
  [13094] = 7324,
  [13095] = 7325,
  [13096] = 7326,
  [13097] = 7327,
  [13098] = 7328,
  [13099] = 7324,
  [13100] = 7325,
  [13101] = 7326,
  [13102] = 7327,
  [13103] = 7328,
  [13104] = 6817,
  [13105] = 7710,
  [13106] = 7309,
  [13107] = 7322,
  [13108] = 7309,
  [13109] = 7322,
  [13110] = 6705,
  [13111] = 7710,
  [13112] = 7309,
  [13113] = 7322,
  [13114] = 6704,
  [13115] = 6583,
  [13116] = 6584,
  [13117] = 6588,
  [13118] = 6516,
  [13119] = 6601,
  [13120] = 6817,
  [13121] = 7222,
  [13122] = 7652,
  [13123] = 6237,
  [13124] = 7695,
  [13125] = 7322,
  [13126] = 7711,
  [13127] = 7714,
  [13128] = 7326,
  [13129] = 7327,
  [13130] = 7328,
  [13131] = 6787,
  [13132] = 13132,
  [13133] = 7652,
  [13134] = 6774,
  [13135] = 7080,
  [13136] = 7652,
  [13137] = 7264,
  [13138] = 13132,
  [13139] = 7222,
  [13140] = 7264,
  [13141] = 7080,
  [13142] = 7264,
  [13143] = 7652,
  [13144] = 13132,
  [13145] = 7075,
  [13146] = 7264,
  [13147] = 7075,
  [13148] = 13132,
  [13149] = 13132,
  [13150] = 7222,
  [13151] = 7417,
  [13152] = 6817,
  [13153] = 6780,
  [13154] = 7649,
  [13155] = 6787,
  [13156] = 7080,
  [13157] = 7071,
  [13158] = 7072,
  [13159] = 7073,
  [13160] = 7649,
  [13161] = 13132,
  [13162] = 13132,
  [13163] = 13132,
  [13164] = 13132,
  [13165] = 13132,
  [13166] = 7071,
  [13167] = 7072,
  [13168] = 7073,
  [13169] = 7075,
  [13170] = 7229,
  [13171] = 7417,
  [13172] = 7272,
  [13173] = 7249,
  [13174] = 13132,
  [13175] = 13175,
  [13176] = 13132,
  [13177] = 6962,
  [13178] = 7071,
  [13179] = 13132,
  [13180] = 13132,
  [13181] = 13132,
  [13182] = 7649,
  [13183] = 7072,
  [13184] = 13132,
  [13185] = 7695,
  [13186] = 6817,
  [13187] = 7073,
  [13188] = 7652,
  [13189] = 7309,
  [13190] = 7705,
  [13191] = 7710,
  [13192] = 13132,
  [13193] = 7711,
  [13194] = 7652,
  [13195] = 7309,
  [13196] = 7649,
  [13197] = 7322,
  [13198] = 7222,
  [13199] = 7080,
  [13200] = 7705,
  [13201] = 13132,
  [13202] = 7710,
  [13203] = 7711,
  [13204] = 7705,
  [13205] = 7712,
  [13206] = 7713,
  [13207] = 7714,
  [13208] = 7716,
  [13209] = 7717,
  [13210] = 7324,
  [13211] = 7325,
  [13212] = 7326,
  [13213] = 7327,
  [13214] = 7328,
  [13215] = 7712,
  [13216] = 7713,
  [13217] = 7714,
  [13218] = 7705,
  [13219] = 7711,
  [13220] = 7712,
  [13221] = 7713,
  [13222] = 7714,
  [13223] = 7716,
  [13224] = 7717,
  [13225] = 7324,
  [13226] = 7325,
  [13227] = 12941,
  [13228] = 6962,
  [13229] = 13132,
  [13230] = 6705,
  [13231] = 6817,
  [13232] = 13132,
  [13233] = 7326,
  [13234] = 7229,
  [13235] = 7272,
  [13236] = 7249,
  [13237] = 7229,
  [13238] = 7309,
  [13239] = 7649,
  [13240] = 7327,
  [13241] = 7322,
  [13242] = 7272,
  [13243] = 7249,
  [13244] = 7328,
  [13245] = 7716,
  [13246] = 7717,
  [13247] = 7712,
  [13248] = 13132,
  [13249] = 7324,
  [13250] = 7324,
  [13251] = 13132,
  [13252] = 7325,
  [13253] = 7326,
  [13254] = 7327,
  [13255] = 7328,
  [13256] = 7325,
  [13257] = 7326,
  [13258] = 7327,
  [13259] = 13132,
  [13260] = 7328,
  [13261] = 7652,
  [13262] = 7222,
  [13263] = 7652,
  [13264] = 7075,
  [13265] = 13132,
  [13266] = 7713,
  [13267] = 7714,
  [13268] = 7716,
  [13269] = 7309,
  [13270] = 7717,
  [13271] = 7324,
  [13272] = 7325,
  [13273] = 7326,
  [13274] = 7327,
  [13275] = 7328,
  [13276] = 6962,
  [13277] = 7649,
  [13278] = 7226,
  [13279] = 13279,
  [13280] = 13132,
  [13281] = 6704,
  [13282] = 6704,
  [13283] = 7649,
  [13284] = 13132,
  [13285] = 7075,
  [13286] = 7705,
  [13287] = 13132,
  [13288] = 6817,
  [13289] = 7710,
  [13290] = 7711,
  [13291] = 7710,
  [13292] = 7222,
  [13293] = 6774,
  [13294] = 7705,
  [13295] = 7325,
  [13296] = 7712,
  [13297] = 7713,
  [13298] = 7073,
  [13299] = 7309,
  [13300] = 13132,
  [13301] = 7716,
  [13302] = 7322,
  [13303] = 7705,
  [13304] = 7710,
  [13305] = 7711,
  [13306] = 7712,
  [13307] = 7713,
  [13308] = 7714,
  [13309] = 7717,
  [13310] = 13132,
  [13311] = 7716,
  [13312] = 7717,
  [13313] = 7309,
  [13314] = 7324,
  [13315] = 7322,
  [13316] = 7710,
  [13317] = 7325,
  [13318] = 7326,
  [13319] = 7327,
  [13320] = 7705,
  [13321] = 7710,
  [13322] = 7712,
  [13323] = 7713,
  [13324] = 7714,
  [13325] = 7716,
  [13326] = 7717,
  [13327] = 7324,
  [13328] = 7325,
  [13329] = 7326,
  [13330] = 7327,
  [13331] = 7328,
  [13332] = 7328,
  [13333] = 7322,
  [13334] = 7324,
  [13335] = 7309,
  [13336] = 7649,
  [13337] = 7325,
  [13338] = 7322,
  [13339] = 7649,
  [13340] = 7326,
  [13341] = 7327,
  [13342] = 7328,
  [13343] = 7712,
  [13344] = 6774,
  [13345] = 7713,
  [13346] = 7714,
  [13347] = 7229,
  [13348] = 7272,
  [13349] = 7249,
  [13350] = 7716,
  [13351] = 7222,
  [13352] = 7717,
  [13353] = 7309,
  [13354] = 7322,
  [13355] = 7710,
  [13356] = 6962,
  [13357] = 7324,
  [13358] = 7309,
  [13359] = 7322,
  [13360] = 13132,
  [13361] = 6704,
  [13362] = 6774,
  [13363] = 7309,
  [13364] = 7322,
  [13365] = 6774,
  [13366] = 7325,
  [13367] = 13132,
  [13368] = 7705,
  [13369] = 12941,
  [13370] = 7695,
  [13371] = 7710,
  [13372] = 7711,
  [13373] = 7712,
  [13374] = 7713,
  [13375] = 7714,
  [13376] = 7716,
  [13377] = 7717,
  [13378] = 13132,
  [13379] = 13132,
  [13380] = 7326,
  [13381] = 7649,
  [13382] = 7327,
  [13383] = 6705,
  [13384] = 7222,
  [13385] = 7652,
  [13386] = 7328,
  [13387] = 7222,
  [13388] = 13132,
  [13389] = 6780,
  [13390] = 7222,
  [13391] = 7222,
  [13392] = 13132,
  [13393] = 7652,
  [13394] = 7322,
  [13395] = 7075,
  [13396] = 7711,
  [13397] = 13132,
  [13398] = 7705,
  [13399] = 13132,
  [13400] = 7226,
  [13401] = 7710,
  [13402] = 6707,
  [13403] = 6708,
  [13404] = 6709,
  [13405] = 7711,
  [13406] = 7712,
  [13407] = 7711,
  [13408] = 6883,
  [13409] = 6885,
  [13410] = 7713,
  [13411] = 6889,
  [13412] = 6831,
  [13413] = 6854,
  [13414] = 6855,
  [13415] = 7652,
  [13416] = 6962,
  [13417] = 13132,
  [13418] = 13132,
  [13419] = 7714,
  [13420] = 13132,
  [13421] = 7716,
  [13422] = 7717,
  [13423] = 13132,
  [13424] = 6237,
  [13425] = 13132,
  [13426] = 7324,
  [13427] = 13132,
  [13428] = 13132,
  [13429] = 13132,
  [13430] = 13132,
  [13431] = 13132,
  [13432] = 7071,
  [13433] = 13132,
  [13434] = 7072,
  [13435] = 13132,
  [13436] = 13132,
  [13437] = 13132,
  [13438] = 7711,
  [13439] = 7717,
  [13440] = 13440,
  [13441] = 6704,
  [13442] = 13442,
  [13443] = 13443,
  [13444] = 13440,
  [13445] = 13442,
  [13446] = 13443,
  [13447] = 13443,
  [13448] = 13443,
  [13449] = 13442,
  [13450] = 6704,
  [13451] = 13440,
  [13452] = 13452,
  [13453] = 7710,
  [13454] = 7222,
  [13455] = 13442,
  [13456] = 13443,
  [13457] = 13457,
  [13458] = 13440,
  [13459] = 13440,
  [13460] = 13460,
  [13461] = 13442,
  [13462] = 13443,
  [13463] = 13443,
  [13464] = 13440,
  [13465] = 7229,
  [13466] = 6774,
  [13467] = 7272,
  [13468] = 7249,
  [13469] = 13442,
  [13470] = 13442,
  [13471] = 6704,
  [13472] = 13443,
  [13473] = 13440,
  [13474] = 13440,
  [13475] = 6704,
  [13476] = 7080,
  [13477] = 13442,
  [13478] = 13478,
  [13479] = 6704,
  [13480] = 7705,
  [13481] = 13443,
  [13482] = 7710,
  [13483] = 7711,
  [13484] = 7712,
  [13485] = 7713,
  [13486] = 7714,
  [13487] = 7716,
  [13488] = 13440,
  [13489] = 7717,
  [13490] = 7324,
  [13491] = 7325,
  [13492] = 7326,
  [13493] = 7327,
  [13494] = 7328,
  [13495] = 13495,
  [13496] = 13442,
  [13497] = 13478,
  [13498] = 7222,
  [13499] = 7652,
  [13500] = 13443,
  [13501] = 13440,
  [13502] = 13440,
  [13503] = 13442,
  [13504] = 13443,
  [13505] = 13443,
  [13506] = 13440,
  [13507] = 13442,
  [13508] = 13443,
  [13509] = 7264,
  [13510] = 13440,
  [13511] = 13442,
  [13512] = 13442,
  [13513] = 13495,
  [13514] = 13478,
  [13515] = 13443,
  [13516] = 13443,
  [13517] = 13440,
  [13518] = 13442,
  [13519] = 13443,
  [13520] = 6774,
  [13521] = 13440,
  [13522] = 13452,
  [13523] = 6704,
  [13524] = 13442,
  [13525] = 13457,
  [13526] = 13443,
  [13527] = 13440,
  [13528] = 13442,
  [13529] = 13443,
  [13530] = 13443,
  [13531] = 13440,
  [13532] = 13442,
  [13533] = 13443,
  [13534] = 13440,
  [13535] = 13442,
  [13536] = 13443,
  [13537] = 13440,
  [13538] = 13442,
  [13539] = 13443,
  [13540] = 13440,
  [13541] = 13452,
  [13542] = 13457,
  [13543] = 13442,
  [13544] = 13452,
  [13545] = 13443,
  [13546] = 13457,
  [13547] = 13440,
  [13548] = 13440,
  [13549] = 13442,
  [13550] = 13443,
  [13551] = 6774,
  [13552] = 13440,
  [13553] = 13442,
  [13554] = 13443,
  [13555] = 13440,
  [13556] = 6704,
  [13557] = 13440,
  [13558] = 13442,
  [13559] = 13443,
  [13560] = 13443,
  [13561] = 13440,
  [13562] = 13442,
  [13563] = 13443,
  [13564] = 13440,
  [13565] = 13440,
  [13566] = 6817,
  [13567] = 13442,
  [13568] = 13443,
  [13569] = 13440,
  [13570] = 7649,
  [13571] = 13442,
  [13572] = 13442,
  [13573] = 13443,
  [13574] = 13440,
  [13575] = 7710,
  [13576] = 13442,
  [13577] = 13443,
  [13578] = 13440,
  [13579] = 13440,
  [13580] = 13442,
  [13581] = 7226,
  [13582] = 13442,
  [13583] = 13443,
  [13584] = 6774,
  [13585] = 6774,
  [13586] = 6704,
  [13587] = 13440,
  [13588] = 13442,
  [13589] = 6774,
  [13590] = 13440,
  [13591] = 13440,
  [13592] = 13440,
  [13593] = 13440,
  [13594] = 13440,
  [13595] = 13440,
  [13596] = 6774,
  [13597] = 13440,
  [13598] = 7080,
  [13599] = 13495,
  [13600] = 13443,
  [13601] = 6704,
  [13602] = 6774,
  [13603] = 13495,
  [13604] = 13478,
  [13605] = 6962,
  [13606] = 13460,
  [13607] = 13443,
  [13608] = 13608,
  [13609] = 13440,
  [13610] = 13610,
  [13611] = 13440,
  [13612] = 6774,
  [13613] = 6704,
  [13614] = 7071,
  [13615] = 13440,
  [13616] = 7072,
  [13617] = 7264,
  [13618] = 7073,
  [13619] = 13442,
  [13620] = 6774,
  [13621] = 6704,
  [13622] = 13443,
  [13623] = 6774,
  [13624] = 6704,
  [13625] = 7417,
  [13626] = 7226,
  [13627] = 6774,
  [13628] = 13442,
  [13629] = 7075,
  [13630] = 6774,
  [13631] = 13452,
  [13632] = 6774,
  [13633] = 13457,
  [13634] = 6704,
  [13635] = 7705,
  [13636] = 7711,
  [13637] = 7712,
  [13638] = 7713,
  [13639] = 7714,
  [13640] = 7716,
  [13641] = 7705,
  [13642] = 7324,
  [13643] = 7325,
  [13644] = 7326,
  [13645] = 7327,
  [13646] = 7328,
  [13647] = 13440,
  [13648] = 13443,
  [13649] = 13610,
  [13650] = 7711,
  [13651] = 13443,
  [13652] = 7712,
  [13653] = 7713,
  [13654] = 7714,
  [13655] = 7716,
  [13656] = 7071,
  [13657] = 7717,
  [13658] = 7072,
  [13659] = 7324,
  [13660] = 7073,
  [13661] = 7309,
  [13662] = 13440,
  [13663] = 7264,
  [13664] = 13440,
  [13665] = 7649,
  [13666] = 13442,
  [13667] = 7325,
  [13668] = 7326,
  [13669] = 7327,
  [13670] = 7309,
  [13671] = 7322,
  [13672] = 7322,
  [13673] = 7328,
  [13674] = 7222,
  [13675] = 13608,
  [13676] = 7229,
  [13677] = 7272,
  [13678] = 7249,
  [13679] = 7309,
  [13680] = 7322,
  [13681] = 6774,
  [13682] = 6704,
  [13683] = 7264,
  [13684] = 7705,
  [13685] = 7711,
  [13686] = 7712,
  [13687] = 7713,
  [13688] = 7714,
  [13689] = 7716,
  [13690] = 13608,
  [13691] = 7717,
  [13692] = 7324,
  [13693] = 7325,
  [13694] = 7229,
  [13695] = 7272,
  [13696] = 7249,
  [13697] = 13442,
  [13698] = 7226,
  [13699] = 6774,
  [13700] = 7326,
  [13701] = 7327,
  [13702] = 7328,
  [13703] = 6962,
  [13704] = 6704,
  [13705] = 13608,
  [13706] = 13452,
  [13707] = 13442,
  [13708] = 6774,
  [13709] = 6704,
  [13710] = 6774,
  [13711] = 6774,
  [13712] = 6704,
  [13713] = 13457,
  [13714] = 13608,
  [13715] = 6774,
  [13716] = 6704,
  [13717] = 6774,
  [13718] = 13608,
  [13719] = 13443,
  [13720] = 6704,
  [13721] = 13495,
  [13722] = 13478,
  [13723] = 13443,
  [13724] = 13608,
  [13725] = 6774,
  [13726] = 13608,
  [13727] = 7417,
  [13728] = 7695,
  [13729] = 13608,
  [13730] = 13608,
  [13731] = 6704,
  [13732] = 13442,
  [13733] = 13608,
  [13734] = 13608,
  [13735] = 13608,
  [13736] = 13608,
  [13737] = 13608,
  [13738] = 13608,
  [13739] = 13608,
  [13740] = 13608,
  [13741] = 13608,
  [13742] = 13608,
  [13743] = 13743,
  [13744] = 13452,
  [13745] = 13457,
  [13746] = 13440,
  [13747] = 7649,
  [13748] = 13440,
  [13749] = 13440,
  [13750] = 7075,
  [13751] = 13440,
  [13752] = 13608,
  [13753] = 13442,
  [13754] = 7222,
  [13755] = 6774,
  [13756] = 6704,
  [13757] = 7229,
  [13758] = 7272,
  [13759] = 7249,
  [13760] = 13443,
  [13761] = 13442,
  [13762] = 13442,
  [13763] = 6774,
  [13764] = 6704,
  [13765] = 13443,
  [13766] = 13440,
  [13767] = 13440,
  [13768] = 13442,
  [13769] = 6774,
  [13770] = 7711,
  [13771] = 6704,
  [13772] = 6774,
  [13773] = 6704,
  [13774] = 13442,
  [13775] = 6774,
  [13776] = 13440,
  [13777] = 6774,
  [13778] = 6704,
  [13779] = 13452,
  [13780] = 13495,
  [13781] = 13478,
  [13782] = 6704,
  [13783] = 13443,
  [13784] = 7652,
  [13785] = 7649,
  [13786] = 6704,
  [13787] = 6774,
  [13788] = 13788,
  [13789] = 13495,
  [13790] = 13478,
  [13791] = 13442,
  [13792] = 7652,
  [13793] = 6774,
  [13794] = 6704,
  [13795] = 7652,
  [13796] = 7649,
  [13797] = 13443,
  [13798] = 13443,
  [13799] = 13440,
  [13800] = 13800,
  [13801] = 13440,
  [13802] = 13443,
  [13803] = 13442,
  [13804] = 6774,
  [13805] = 13442,
  [13806] = 6774,
  [13807] = 6704,
  [13808] = 13495,
  [13809] = 13478,
  [13810] = 6704,
  [13811] = 13452,
  [13812] = 13457,
  [13813] = 13443,
  [13814] = 13443,
  [13815] = 13452,
  [13816] = 13457,
  [13817] = 13440,
  [13818] = 13495,
  [13819] = 13478,
  [13820] = 13452,
  [13821] = 13457,
  [13822] = 13495,
  [13823] = 13440,
  [13824] = 13442,
  [13825] = 7705,
  [13826] = 7710,
  [13827] = 7712,
  [13828] = 7713,
  [13829] = 7714,
  [13830] = 7716,
  [13831] = 7717,
  [13832] = 7324,
  [13833] = 7325,
  [13834] = 7326,
  [13835] = 7327,
  [13836] = 7328,
  [13837] = 13440,
  [13838] = 6817,
  [13839] = 6705,
  [13840] = 7309,
  [13841] = 7322,
  [13842] = 6962,
  [13843] = 13478,
  [13844] = 7695,
  [13845] = 6962,
  [13846] = 13442,
  [13847] = 6774,
  [13848] = 6704,
  [13849] = 13443,
  [13850] = 13442,
  [13851] = 6774,
  [13852] = 7710,
  [13853] = 6774,
  [13854] = 6704,
  [13855] = 7309,
  [13856] = 6704,
  [13857] = 13442,
  [13858] = 6774,
  [13859] = 13442,
  [13860] = 13610,
  [13861] = 13495,
  [13862] = 13478,
  [13863] = 6774,
  [13864] = 6704,
  [13865] = 13443,
  [13866] = 7322,
  [13867] = 6705,
  [13868] = 6704,
  [13869] = 6704,
  [13870] = 13457,
  [13871] = 13440,
  [13872] = 13872,
  [13873] = 13443,
  [13874] = 13442,
  [13875] = 6774,
  [13876] = 6704,
  [13877] = 13443,
  [13878] = 13443,
  [13879] = 13443,
  [13880] = 13495,
  [13881] = 13478,
  [13882] = 13452,
  [13883] = 13457,
  [13884] = 7219,
  [13885] = 13495,
  [13886] = 13478,
  [13887] = 13452,
  [13888] = 13457,
  [13889] = 6774,
  [13890] = 13495,
  [13891] = 13478,
  [13892] = 6704,
  [13893] = 13452,
  [13894] = 13457,
  [13895] = 13440,
  [13896] = 13495,
  [13897] = 13478,
  [13898] = 13452,
  [13899] = 13457,
  [13900] = 13495,
  [13901] = 13478,
  [13902] = 13495,
  [13903] = 13478,
  [13904] = 13452,
  [13905] = 13442,
  [13906] = 7222,
  [13907] = 13457,
  [13908] = 7652,
  [13909] = 13495,
  [13910] = 13478,
  [13911] = 13452,
  [13912] = 13457,
  [13913] = 13442,
  [13914] = 13440,
  [13915] = 6774,
  [13916] = 6704,
  [13917] = 6774,
  [13918] = 13440,
  [13919] = 6774,
  [13920] = 6704,
  [13921] = 13443,
  [13922] = 13452,
  [13923] = 13457,
  [13924] = 13440,
  [13925] = 13442,
  [13926] = 13926,
  [13927] = 6774,
  [13928] = 6704,
  [13929] = 13442,
  [13930] = 13443,
  [13931] = 6774,
  [13932] = 13440,
  [13933] = 13442,
  [13934] = 6774,
  [13935] = 6704,
  [13936] = 13442,
  [13937] = 13495,
  [13938] = 13478,
  [13939] = 13440,
  [13940] = 7080,
  [13941] = 13460,
  [13942] = 13442,
  [13943] = 13440,
  [13944] = 6817,
  [13945] = 13442,
  [13946] = 6774,
  [13947] = 13452,
  [13948] = 6817,
  [13949] = 13443,
  [13950] = 13443,
  [13951] = 13457,
  [13952] = 13440,
  [13953] = 6774,
  [13954] = 13452,
  [13955] = 13440,
  [13956] = 13442,
  [13957] = 13457,
  [13958] = 6774,
  [13959] = 7075,
  [13960] = 13442,
  [13961] = 6774,
  [13962] = 6774,
  [13963] = 13443,
  [13964] = 7075,
  [13965] = 13440,
  [13966] = 13443,
  [13967] = 13443,
  [13968] = 13442,
  [13969] = 6774,
  [13970] = 13495,
  [13971] = 13478,
  [13972] = 6704,
  [13973] = 13443,
  [13974] = 13440,
  [13975] = 13443,
  [13976] = 7711,
  [13977] = 7649,
  [13978] = 13872,
  [13979] = 7652,
  [13980] = 7716,
  [13981] = 7649,
  [13982] = 13982,
  [13983] = 7226,
  [13984] = 7226,
  [13985] = 7226,
  [13986] = 7226,
  [13987] = 7705,
  [13988] = 7226,
  [13989] = 7226,
  [13990] = 7309,
  [13991] = 7322,
  [13992] = 7226,
  [13993] = 7226,
  [13994] = 7226,
  [13995] = 7711,
  [13996] = 6817,
  [13997] = 7226,
  [13998] = 7712,
  [13999] = 7226,
  [14000] = 7695,
  [14001] = 7717,
  [14002] = 7226,
  [14003] = 7226,
  [14004] = 7226,
  [14005] = 6705,
  [14006] = 7226,
  [14007] = 7226,
  [14008] = 7226,
  [14009] = 6962,
  [14010] = 7226,
  [14011] = 7226,
  [14012] = 7222,
  [14013] = 7226,
  [14014] = 7705,
  [14015] = 7712,
  [14016] = 7713,
  [14017] = 7714,
  [14018] = 7716,
  [14019] = 7717,
  [14020] = 7324,
  [14021] = 7325,
  [14022] = 7326,
  [14023] = 7327,
  [14024] = 7328,
  [14025] = 7695,
  [14026] = 7324,
  [14027] = 13800,
  [14028] = 7226,
  [14029] = 7226,
  [14030] = 7649,
  [14031] = 7309,
  [14032] = 7322,
  [14033] = 7226,
  [14034] = 7714,
  [14035] = 7713,
  [14036] = 7226,
  [14037] = 7226,
  [14038] = 7325,
  [14039] = 6962,
  [14040] = 7226,
  [14041] = 7326,
  [14042] = 7327,
  [14043] = 7226,
  [14044] = 7226,
  [14045] = 7226,
  [14046] = 7710,
  [14047] = 7226,
  [14048] = 7222,
  [14049] = 7652,
  [14050] = 7328,
  [14051] = 7226,
  [14052] = 7226,
  [14053] = 7705,
  [14054] = 7711,
  [14055] = 7712,
  [14056] = 7705,
  [14057] = 7712,
  [14058] = 7713,
  [14059] = 7714,
  [14060] = 7716,
  [14061] = 7717,
  [14062] = 7324,
  [14063] = 7325,
  [14064] = 7326,
  [14065] = 7327,
  [14066] = 7328,
  [14067] = 7713,
  [14068] = 7710,
  [14069] = 7226,
  [14070] = 7714,
  [14071] = 7716,
  [14072] = 7717,
  [14073] = 7324,
  [14074] = 7325,
  [14075] = 7326,
  [14076] = 7327,
  [14077] = 7328,
  [14078] = 7226,
  [14079] = 7222,
  [14080] = 7226,
  [14081] = 7226,
  [14082] = 7710,
  [14083] = 7309,
  [14084] = 7652,
  [14085] = 7226,
  [14086] = 7226,
  [14087] = 7309,
  [14088] = 7322,
  [14089] = 7226,
  [14090] = 7322,
  [14091] = 7649,
  [14092] = 7711,
  [14093] = 7652,
  [14094] = 7226,
  [14095] = 7710,
  [14096] = 7226,
  [14097] = 7226,
  [14098] = 7222,
  [14099] = 7226,
  [14100] = 7712,
  [14101] = 7695,
  [14102] = 14102,
  [14103] = 14103,
  [14104] = 14102,
  [14105] = 14103,
  [14106] = 14102,
  [14107] = 7714,
  [14108] = 7716,
  [14109] = 7717,
  [14110] = 14102,
  [14111] = 7324,
  [14112] = 7325,
  [14113] = 14103,
  [14114] = 14102,
  [14115] = 14102,
  [14116] = 14102,
  [14117] = 7327,
  [14118] = 14102,
  [14119] = 14102,
  [14120] = 14103,
  [14121] = 14102,
  [14122] = 7326,
  [14123] = 7327,
  [14124] = 14103,
  [14125] = 14125,
  [14126] = 14103,
  [14127] = 14103,
  [14128] = 13800,
  [14129] = 14103,
  [14130] = 14102,
  [14131] = 7328,
  [14132] = 14102,
  [14133] = 7710,
  [14134] = 14102,
  [14135] = 7326,
  [14136] = 14125,
  [14137] = 14102,
  [14138] = 14103,
  [14139] = 14102,
  [14140] = 14103,
  [14141] = 14103,
  [14142] = 14102,
  [14143] = 7328,
  [14144] = 7714,
  [14145] = 7717,
  [14146] = 14102,
  [14147] = 7309,
  [14148] = 14102,
  [14149] = 7649,
  [14150] = 14103,
  [14151] = 14102,
  [14152] = 14102,
  [14153] = 14103,
  [14154] = 14102,
  [14155] = 14103,
  [14156] = 14103,
  [14157] = 14102,
  [14158] = 14102,
  [14159] = 7716,
  [14160] = 7322,
  [14161] = 14102,
  [14162] = 14102,
  [14163] = 14103,
  [14164] = 14102,
  [14165] = 14103,
  [14166] = 14102,
  [14167] = 14125,
  [14168] = 14103,
  [14169] = 14103,
  [14170] = 7222,
  [14171] = 14103,
  [14172] = 14103,
  [14173] = 7649,
  [14174] = 14102,
  [14175] = 14103,
  [14176] = 7652,
  [14177] = 14103,
  [14178] = 14102,
  [14179] = 14102,
  [14180] = 14102,
  [14181] = 14103,
  [14182] = 14102,
  [14183] = 14103,
  [14184] = 14125,
  [14185] = 14103,
  [14186] = 7322,
  [14187] = 7705,
  [14188] = 14102,
  [14189] = 14102,
  [14190] = 7325,
  [14191] = 7222,
  [14192] = 14102,
  [14193] = 7711,
  [14194] = 14102,
  [14195] = 14103,
  [14196] = 14102,
  [14197] = 14103,
  [14198] = 14102,
  [14199] = 14103,
  [14200] = 14103,
  [14201] = 14102,
  [14202] = 14102,
  [14203] = 14103,
  [14204] = 14102,
  [14205] = 14102,
  [14206] = 7652,
  [14207] = 7710,
  [14208] = 14102,
  [14209] = 7705,
  [14210] = 7711,
  [14211] = 14102,
  [14212] = 14103,
  [14213] = 7712,
  [14214] = 7713,
  [14215] = 14103,
  [14216] = 14102,
  [14217] = 14102,
  [14218] = 7713,
  [14219] = 14102,
  [14220] = 14103,
  [14221] = 14102,
  [14222] = 14103,
  [14223] = 14103,
  [14224] = 14103,
  [14225] = 14102,
  [14226] = 14102,
  [14227] = 14102,
  [14228] = 7309,
  [14229] = 7324,
  [14230] = 14102,
  [14231] = 14103,
  [14232] = 14102,
  [14233] = 14103,
  [14234] = 14102,
  [14235] = 14103,
  [14236] = 14103,
  [14237] = 6801,
  [14238] = 14238,
  [14239] = 14238,
  [14240] = 14238,
  [14241] = 14238,
  [14242] = 14238,
  [14243] = 14238,
  [14244] = 14238,
  [14245] = 6787,
  [14246] = 14246,
  [14247] = 14246,
  [14248] = 14246,
  [14249] = 14246,
  [14250] = 14246,
  [14251] = 14246,
  [14252] = 14252,
  [14253] = 6787,
  [14254] = 14246,
  [14255] = 6780,
  [14256] = 14246,
  [14257] = 14246,
  [14258] = 14246,
  [14259] = 14246,
  [14260] = 14246,
  [14261] = 14261,
  [14262] = 14246,
  [14263] = 6780,
  [14264] = 14264,
  [14265] = 14265,
  [14266] = 14266,
  [14267] = 6787,
  [14268] = 14265,
  [14269] = 14261,
  [14270] = 14265,
  [14271] = 14264,
  [14272] = 6787,
  [14273] = 14261,
  [14274] = 14266,
  [14275] = 14264,
  [14276] = 6787,
  [14277] = 6780,
  [14278] = 6780,
  [14279] = 6780,
  [14280] = 14280,
  [14281] = 14281,
  [14282] = 14282,
  [14283] = 14283,
  [14284] = 14284,
  [14285] = 14285,
  [14286] = 14286,
  [14287] = 14280,
  [14288] = 14288,
  [14289] = 14289,
  [14290] = 14281,
  [14291] = 14291,
  [14292] = 14292,
  [14293] = 14293,
  [14294] = 14294,
  [14295] = 14291,
  [14296] = 14283,
  [14297] = 14282,
  [14298] = 14283,
  [14299] = 14282,
  [14300] = 14283,
  [14301] = 14284,
  [14302] = 14285,
  [14303] = 14280,
  [14304] = 14281,
  [14305] = 14283,
  [14306] = 14284,
  [14307] = 14284,
  [14308] = 14285,
  [14309] = 7264,
  [14310] = 14310,
  [14311] = 14285,
  [14312] = 14310,
  [14313] = 14280,
  [14314] = 14310,
  [14315] = 14281,
  [14316] = 14283,
  [14317] = 14283,
  [14318] = 14293,
  [14319] = 14319,
  [14320] = 14292,
  [14321] = 14293,
  [14322] = 14294,
  [14323] = 14291,
  [14324] = 14280,
  [14325] = 14282,
  [14326] = 14283,
  [14327] = 14284,
  [14328] = 14281,
  [14329] = 14285,
  [14330] = 14280,
  [14331] = 14281,
  [14332] = 14310,
  [14333] = 14310,
  [14334] = 14284,
  [14335] = 14335,
  [14336] = 14285,
  [14337] = 14337,
  [14338] = 14280,
  [14339] = 14289,
  [14340] = 14319,
  [14341] = 14292,
  [14342] = 14293,
  [14343] = 14294,
  [14344] = 14281,
  [14345] = 14282,
  [14346] = 14283,
  [14347] = 14284,
  [14348] = 14285,
  [14349] = 14280,
  [14350] = 14281,
  [14351] = 14284,
  [14352] = 14310,
  [14353] = 14310,
  [14354] = 14288,
  [14355] = 14285,
  [14356] = 14319,
  [14357] = 14292,
  [14358] = 14293,
  [14359] = 14280,
  [14360] = 14294,
  [14361] = 14282,
  [14362] = 14283,
  [14363] = 14281,
  [14364] = 14284,
  [14365] = 14282,
  [14366] = 14283,
  [14367] = 14284,
  [14368] = 14285,
  [14369] = 14280,
  [14370] = 14281,
  [14371] = 14285,
  [14372] = 14310,
  [14373] = 14282,
  [14374] = 14319,
  [14375] = 14292,
  [14376] = 14293,
  [14377] = 14294,
  [14378] = 14291,
  [14379] = 14335,
  [14380] = 14281,
  [14381] = 14281,
  [14382] = 14319,
  [14383] = 14292,
  [14384] = 14283,
  [14385] = 14293,
  [14386] = 14294,
  [14387] = 14282,
  [14388] = 14283,
  [14389] = 14284,
  [14390] = 14285,
  [14391] = 14291,
  [14392] = 14319,
  [14393] = 14292,
  [14394] = 14293,
  [14395] = 14294,
  [14396] = 14280,
  [14397] = 14281,
  [14398] = 14337,
  [14399] = 14310,
  [14400] = 14310,
  [14401] = 14284,
  [14402] = 14402,
  [14403] = 14285,
  [14404] = 14319,
  [14405] = 14280,
  [14406] = 14266,
  [14407] = 14319,
  [14408] = 14292,
  [14409] = 14293,
  [14410] = 14319,
  [14411] = 14292,
  [14412] = 14293,
  [14413] = 14294,
  [14414] = 14294,
  [14415] = 14292,
  [14416] = 14280,
  [14417] = 14282,
  [14418] = 14283,
  [14419] = 6780,
  [14420] = 14284,
  [14421] = 14285,
  [14422] = 14282,
  [14423] = 14283,
  [14424] = 14280,
  [14425] = 14281,
  [14426] = 14282,
  [14427] = 14283,
  [14428] = 14284,
  [14429] = 14285,
  [14430] = 14284,
  [14431] = 14281,
  [14432] = 14310,
  [14433] = 14285,
  [14434] = 14281,
  [14435] = 14293,
  [14436] = 14294,
  [14437] = 14337,
  [14438] = 14291,
  [14439] = 14291,
  [14440] = 14310,
  [14441] = 14441,
  [14442] = 14282,
  [14443] = 14283,
  [14444] = 14319,
  [14445] = 14284,
  [14446] = 14285,
  [14447] = 14292,
  [14448] = 14293,
  [14449] = 14294,
  [14450] = 14280,
  [14451] = 14280,
  [14452] = 14335,
  [14453] = 14337,
  [14454] = 14281,
  [14455] = 14310,
  [14456] = 14282,
  [14457] = 14281,
  [14458] = 14283,
  [14459] = 14284,
  [14460] = 14291,
  [14461] = 14291,
  [14462] = 14310,
  [14463] = 14285,
  [14464] = 14280,
  [14465] = 14281,
  [14466] = 14466,
  [14467] = 14286,
  [14468] = 14280,
  [14469] = 14281,
  [14470] = 14310,
  [14471] = 14291,
  [14472] = 14310,
  [14473] = 14282,
  [14474] = 14289,
  [14475] = 14310,
  [14476] = 14283,
  [14477] = 14310,
  [14478] = 14284,
  [14479] = 14285,
  [14480] = 14293,
  [14481] = 14285,
  [14482] = 14482,
  [14483] = 14280,
  [14484] = 14319,
  [14485] = 14288,
  [14486] = 14281,
  [14487] = 14319,
  [14488] = 14292,
  [14489] = 14293,
  [14490] = 14294,
  [14491] = 14288,
  [14492] = 14310,
  [14493] = 14319,
  [14494] = 14292,
  [14495] = 14281,
  [14496] = 14282,
  [14497] = 14293,
  [14498] = 14283,
  [14499] = 14294,
  [14500] = 14284,
  [14501] = 14285,
  [14502] = 14280,
  [14503] = 14281,
  [14504] = 14294,
  [14505] = 14282,
  [14506] = 14291,
  [14507] = 14283,
  [14508] = 14310,
  [14509] = 14291,
  [14510] = 14286,
  [14511] = 14289,
  [14512] = 14284,
  [14513] = 14284,
  [14514] = 14319,
  [14515] = 14292,
  [14516] = 14293,
  [14517] = 14294,
  [14518] = 14285,
  [14519] = 14280,
  [14520] = 14319,
  [14521] = 14292,
  [14522] = 14281,
  [14523] = 14293,
  [14524] = 14294,
  [14525] = 14291,
  [14526] = 14310,
  [14527] = 14310,
  [14528] = 14310,
  [14529] = 14282,
  [14530] = 14283,
  [14531] = 14531,
  [14532] = 14335,
  [14533] = 14284,
  [14534] = 14282,
  [14535] = 14283,
  [14536] = 14284,
  [14537] = 14285,
  [14538] = 14285,
  [14539] = 14280,
  [14540] = 14280,
  [14541] = 14281,
  [14542] = 14292,
  [14543] = 14281,
  [14544] = 14310,
  [14545] = 14319,
  [14546] = 14292,
  [14547] = 14291,
  [14548] = 14310,
  [14549] = 14293,
  [14550] = 14294,
  [14551] = 14293,
  [14552] = 14294,
  [14553] = 4112,
  [14554] = 14319,
  [14555] = 14292,
  [14556] = 14293,
  [14557] = 14294,
  [14558] = 14285,
  [14559] = 14310,
  [14560] = 14280,
  [14561] = 14282,
  [14562] = 14283,
  [14563] = 14284,
  [14564] = 14285,
  [14565] = 14280,
  [14566] = 14281,
  [14567] = 14310,
  [14568] = 14310,
  [14569] = 14281,
  [14570] = 14288,
  [14571] = 14281,
  [14572] = 14319,
  [14573] = 14292,
  [14574] = 14293,
  [14575] = 14319,
  [14576] = 14294,
  [14577] = 14286,
  [14578] = 14292,
  [14579] = 14289,
  [14580] = 14291,
  [14581] = 14282,
  [14582] = 14293,
  [14583] = 14294,
  [14584] = 14282,
  [14585] = 14283,
  [14586] = 14282,
  [14587] = 14283,
  [14588] = 14284,
  [14589] = 14284,
  [14590] = 14285,
  [14591] = 14280,
  [14592] = 14281,
  [14593] = 14285,
  [14594] = 14280,
  [14595] = 14281,
  [14596] = 14291,
  [14597] = 14319,
  [14598] = 14310,
  [14599] = 14292,
  [14600] = 14293,
  [14601] = 14294,
  [14602] = 14283,
  [14603] = 14282,
  [14604] = 4105,
  [14605] = 14266,
  [14606] = 4131,
  [14607] = 14319,
  [14608] = 14319,
  [14609] = 14292,
  [14610] = 14293,
  [14611] = 14294,
  [14612] = 14319,
  [14613] = 14292,
  [14614] = 14292,
  [14615] = 14293,
  [14616] = 14288,
  [14617] = 14294,
  [14618] = 14283,
  [14619] = 14284,
  [14620] = 14284,
  [14621] = 14293,
  [14622] = 14294,
  [14623] = 14285,
  [14624] = 14310,
  [14625] = 14282,
  [14626] = 14282,
  [14627] = 14283,
  [14628] = 14284,
  [14629] = 14629,
  [14630] = 14285,
  [14631] = 14283,
  [14632] = 14319,
  [14633] = 14292,
  [14634] = 14280,
  [14635] = 14281,
  [14636] = 14291,
  [14637] = 14284,
  [14638] = 14285,
  [14639] = 14280,
  [14640] = 14281,
  [14641] = 14293,
  [14642] = 14294,
  [14643] = 14280,
  [14644] = 14281,
  [14645] = 14285,
  [14646] = 14310,
  [14647] = 14291,
  [14648] = 14310,
  [14649] = 14282,
  [14650] = 14337,
  [14651] = 14283,
  [14652] = 14284,
  [14653] = 14285,
  [14654] = 14282,
  [14655] = 14280,
  [14656] = 14283,
  [14657] = 14284,
  [14658] = 14285,
  [14659] = 14659,
  [14660] = 14319,
  [14661] = 4159,
  [14662] = 14292,
  [14663] = 14293,
  [14664] = 14294,
  [14665] = 6787,
  [14666] = 14281,
  [14667] = 14280,
  [14668] = 14288,
  [14669] = 14282,
  [14670] = 4160,
  [14671] = 14283,
  [14672] = 14319,
  [14673] = 14292,
  [14674] = 14284,
  [14675] = 14293,
  [14676] = 14294,
  [14677] = 14285,
  [14678] = 14291,
  [14679] = 14280,
  [14680] = 14281,
  [14681] = 14281,
  [14682] = 14682,
  [14683] = 14335,
  [14684] = 14310,
  [14685] = 14337,
  [14686] = 14280,
  [14687] = 14319,
  [14688] = 14292,
  [14689] = 14293,
  [14690] = 14294,
  [14691] = 14282,
  [14692] = 14283,
  [14693] = 14284,
  [14694] = 14281,
  [14695] = 14282,
  [14696] = 14283,
  [14697] = 14310,
  [14698] = 14284,
  [14699] = 14291,
  [14700] = 14310,
  [14701] = 14319,
  [14702] = 14310,
  [14703] = 14286,
  [14704] = 14280,
  [14705] = 14285,
  [14706] = 14281,
  [14707] = 14289,
  [14708] = 14319,
  [14709] = 14291,
  [14710] = 14286,
  [14711] = 14289,
  [14712] = 14280,
  [14713] = 14281,
  [14714] = 14282,
  [14715] = 14291,
  [14716] = 14283,
  [14717] = 14310,
  [14718] = 14292,
  [14719] = 14293,
  [14720] = 14294,
  [14721] = 14286,
  [14722] = 14291,
  [14723] = 4164,
  [14724] = 14310,
  [14725] = 14282,
  [14726] = 14283,
  [14727] = 14284,
  [14728] = 14285,
  [14729] = 14280,
  [14730] = 14281,
  [14731] = 14310,
  [14732] = 14310,
  [14733] = 6780,
  [14734] = 14282,
  [14735] = 14283,
  [14736] = 14280,
  [14737] = 14291,
  [14738] = 14319,
  [14739] = 14292,
  [14740] = 14291,
  [14741] = 14293,
  [14742] = 14288,
  [14743] = 14294,
  [14744] = 14284,
  [14745] = 4165,
  [14746] = 14284,
  [14747] = 14285,
  [14748] = 14285,
  [14749] = 14282,
  [14750] = 14283,
  [14751] = 14284,
  [14752] = 14285,
  [14753] = 14280,
  [14754] = 14281,
  [14755] = 14319,
  [14756] = 14319,
  [14757] = 14319,
  [14758] = 14292,
  [14759] = 14292,
  [14760] = 14293,
  [14761] = 14310,
  [14762] = 14293,
  [14763] = 14294,
  [14764] = 14282,
  [14765] = 14292,
  [14766] = 14283,
  [14767] = 14293,
  [14768] = 14294,
  [14769] = 14319,
  [14770] = 14292,
  [14771] = 14282,
  [14772] = 14283,
  [14773] = 14282,
  [14774] = 14284,
  [14775] = 14285,
  [14776] = 14293,
  [14777] = 14280,
  [14778] = 14282,
  [14779] = 14319,
  [14780] = 14292,
  [14781] = 14293,
  [14782] = 14294,
  [14783] = 14281,
  [14784] = 14283,
  [14785] = 14284,
  [14786] = 14285,
  [14787] = 14310,
  [14788] = 14294,
  [14789] = 14310,
  [14790] = 14280,
  [14791] = 14319,
  [14792] = 14319,
  [14793] = 14292,
  [14794] = 14283,
  [14795] = 14284,
  [14796] = 14292,
  [14797] = 14293,
  [14798] = 14293,
  [14799] = 14285,
  [14800] = 14294,
  [14801] = 14294,
  [14802] = 14310,
  [14803] = 14280,
  [14804] = 14281,
  [14805] = 14291,
  [14806] = 14294,
  [14807] = 14310,
  [14808] = 14284,
  [14809] = 14335,
  [14810] = 14810,
  [14811] = 14282,
  [14812] = 14283,
  [14813] = 14284,
  [14814] = 14285,
  [14815] = 14337,
  [14816] = 14319,
  [14817] = 14319,
  [14818] = 14319,
  [14819] = 14292,
  [14820] = 14282,
  [14821] = 14319,
  [14822] = 14283,
  [14823] = 14284,
  [14824] = 14292,
  [14825] = 14293,
  [14826] = 14294,
  [14827] = 14285,
  [14828] = 14292,
  [14829] = 14319,
  [14830] = 14292,
  [14831] = 14293,
  [14832] = 14294,
  [14833] = 14282,
  [14834] = 14288,
  [14835] = 14282,
  [14836] = 14283,
  [14837] = 6787,
  [14838] = 14284,
  [14839] = 14285,
  [14840] = 14319,
  [14841] = 14280,
  [14842] = 14281,
  [14843] = 14283,
  [14844] = 14293,
  [14845] = 14282,
  [14846] = 14294,
  [14847] = 14283,
  [14848] = 14284,
  [14849] = 14285,
  [14850] = 14280,
  [14851] = 14291,
  [14852] = 14810,
  [14853] = 14280,
  [14854] = 14281,
  [14855] = 14319,
  [14856] = 14282,
  [14857] = 14292,
  [14858] = 14291,
  [14859] = 14291,
  [14860] = 14293,
  [14861] = 14482,
  [14862] = 14292,
  [14863] = 14863,
  [14864] = 14294,
  [14865] = 14284,
  [14866] = 14285,
  [14867] = 14310,
  [14868] = 14282,
  [14869] = 14319,
  [14870] = 14292,
  [14871] = 14293,
  [14872] = 14294,
  [14873] = 14310,
  [14874] = 14283,
  [14875] = 14283,
  [14876] = 14291,
  [14877] = 14310,
  [14878] = 14284,
  [14879] = 14285,
  [14880] = 14280,
  [14881] = 14281,
  [14882] = 14285,
  [14883] = 9413,
  [14884] = 14310,
  [14885] = 14280,
  [14886] = 14291,
  [14887] = 14286,
  [14888] = 14335,
  [14889] = 14284,
  [14890] = 14285,
  [14891] = 14282,
  [14892] = 14280,
  [14893] = 14281,
  [14894] = 14337,
  [14895] = 14291,
  [14896] = 14281,
  [14897] = 14288,
  [14898] = 14291,
  [14899] = 14292,
  [14900] = 14319,
  [14901] = 14291,
  [14902] = 14292,
  [14903] = 14293,
  [14904] = 14294,
  [14905] = 14310,
  [14906] = 14292,
  [14907] = 14282,
  [14908] = 14319,
  [14909] = 14292,
  [14910] = 14293,
  [14911] = 14294,
  [14912] = 14291,
  [14913] = 14288,
  [14914] = 14283,
  [14915] = 14284,
  [14916] = 14280,
  [14917] = 14281,
  [14918] = 14918,
  [14919] = 14282,
  [14920] = 14282,
  [14921] = 14283,
  [14922] = 14291,
  [14923] = 14284,
  [14924] = 14335,
  [14925] = 14285,
  [14926] = 14337,
  [14927] = 14310,
  [14928] = 14283,
  [14929] = 14284,
  [14930] = 14280,
  [14931] = 14286,
  [14932] = 14289,
  [14933] = 14281,
  [14934] = 14285,
  [14935] = 14291,
  [14936] = 14280,
  [14937] = 14281,
  [14938] = 14310,
  [14939] = 14294,
  [14940] = 14319,
  [14941] = 14292,
  [14942] = 14293,
  [14943] = 14294,
  [14944] = 14285,
  [14945] = 14282,
  [14946] = 14289,
  [14947] = 14288,
  [14948] = 14283,
  [14949] = 14284,
  [14950] = 14285,
  [14951] = 14293,
  [14952] = 14335,
  [14953] = 14337,
  [14954] = 14294,
  [14955] = 14335,
  [14956] = 14337,
  [14957] = 14282,
  [14958] = 14310,
  [14959] = 14319,
  [14960] = 14283,
  [14961] = 14280,
  [14962] = 14284,
  [14963] = 14319,
  [14964] = 14285,
  [14965] = 14292,
  [14966] = 14280,
  [14967] = 14280,
  [14968] = 14281,
  [14969] = 14281,
  [14970] = 14310,
  [14971] = 14293,
  [14972] = 14282,
  [14973] = 14294,
  [14974] = 14280,
  [14975] = 14281,
  [14976] = 14292,
  [14977] = 14281,
  [14978] = 14310,
  [14979] = 14293,
  [14980] = 14291,
  [14981] = 14291,
  [14982] = 14319,
  [14983] = 14293,
  [14984] = 14310,
  [14985] = 14319,
  [14986] = 14292,
  [14987] = 14292,
  [14988] = 14319,
  [14989] = 14292,
  [14990] = 14293,
  [14991] = 14319,
  [14992] = 14280,
  [14993] = 14293,
  [14994] = 14280,
  [14995] = 14289,
  [14996] = 14292,
  [14997] = 14293,
  [14998] = 14294,
  [14999] = 14293,
  [15000] = 14281,
  [15001] = 14294,
  [15002] = 14863,
  [15003] = 14319,
  [15004] = 14292,
  [15005] = 14319,
  [15006] = 14292,
  [15007] = 14293,
  [15008] = 14294,
  [15009] = 14293,
  [15010] = 14283,
  [15011] = 14294,
  [15012] = 14294,
  [15013] = 14294,
  [15014] = 14282,
  [15015] = 14283,
  [15016] = 14284,
  [15017] = 14285,
  [15018] = 14280,
  [15019] = 14310,
  [15020] = 14282,
  [15021] = 14283,
  [15022] = 14284,
  [15023] = 14285,
  [15024] = 14281,
  [15025] = 14280,
  [15026] = 14281,
  [15027] = 14291,
  [15028] = 14466,
  [15029] = 14282,
  [15030] = 14283,
  [15031] = 14284,
  [15032] = 14285,
  [15033] = 14310,
  [15034] = 14282,
  [15035] = 14281,
  [15036] = 14531,
  [15037] = 14294,
  [15038] = 14310,
  [15039] = 9427,
  [15040] = 14286,
  [15041] = 14266,
  [15042] = 14289,
  [15043] = 14319,
  [15044] = 14284,
  [15045] = 14292,
  [15046] = 14293,
  [15047] = 14294,
  [15048] = 14286,
  [15049] = 14319,
  [15050] = 14310,
  [15051] = 14292,
  [15052] = 9413,
  [15053] = 14293,
  [15054] = 14291,
  [15055] = 14294,
  [15056] = 7264,
  [15057] = 14282,
  [15058] = 14282,
  [15059] = 14283,
  [15060] = 14284,
  [15061] = 14285,
  [15062] = 14291,
  [15063] = 14280,
  [15064] = 14281,
  [15065] = 14310,
  [15066] = 14335,
  [15067] = 14286,
  [15068] = 14319,
  [15069] = 14319,
  [15070] = 14291,
  [15071] = 14292,
  [15072] = 14293,
  [15073] = 14294,
  [15074] = 14289,
  [15075] = 14282,
  [15076] = 14294,
  [15077] = 14291,
  [15078] = 14918,
  [15079] = 14282,
  [15080] = 14283,
  [15081] = 14284,
  [15082] = 14285,
  [15083] = 14291,
  [15084] = 14291,
  [15085] = 14291,
  [15086] = 14291,
  [15087] = 14291,
  [15088] = 14291,
  [15089] = 14282,
  [15090] = 14280,
  [15091] = 14335,
  [15092] = 14337,
  [15093] = 14283,
  [15094] = 14281,
  [15095] = 14284,
  [15096] = 14291,
  [15097] = 14319,
  [15098] = 14292,
  [15099] = 14293,
  [15100] = 14285,
  [15101] = 14294,
  [15102] = 14310,
  [15103] = 14292,
  [15104] = 14280,
  [15105] = 14293,
  [15106] = 14294,
  [15107] = 14319,
  [15108] = 14285,
  [15109] = 15109,
  [15110] = 15110,
  [15111] = 15110,
  [15112] = 15110,
  [15113] = 15113,
  [15114] = 15114,
  [15115] = 15115,
  [15116] = 15109,
  [15117] = 15110,
  [15118] = 15118,
  [15119] = 15118,
  [15120] = 15114,
  [15121] = 15109,
  [15122] = 15109,
  [15123] = 15113,
  [15124] = 15124,
  [15125] = 15110,
  [15126] = 15115,
  [15127] = 15109,
  [15128] = 15110,
  [15129] = 15129,
  [15130] = 15110,
  [15131] = 15118,
  [15132] = 15118,
  [15133] = 15118,
  [15134] = 14466,
  [15135] = 15124,
  [15136] = 15129,
  [15137] = 15114,
  [15138] = 15109,
  [15139] = 15118,
  [15140] = 15115,
  [15141] = 15118,
  [15142] = 15115,
  [15143] = 15109,
  [15144] = 15118,
  [15145] = 15110,
  [15146] = 15110,
  [15147] = 15129,
  [15148] = 15115,
  [15149] = 15113,
  [15150] = 15110,
  [15151] = 15124,
  [15152] = 15115,
  [15153] = 15114,
  [15154] = 15115,
  [15155] = 15118,
  [15156] = 15115,
  [15157] = 15118,
  [15158] = 15115,
  [15159] = 15114,
  [15160] = 15115,
  [15161] = 7264,
  [15162] = 15110,
  [15163] = 15110,
  [15164] = 15110,
  [15165] = 15110,
  [15166] = 15118,
  [15167] = 15109,
  [15168] = 15109,
  [15169] = 14810,
  [15170] = 15110,
  [15171] = 14252,
  [15172] = 15109,
  [15173] = 7264,
  [15174] = 15118,
  [15175] = 15109,
  [15176] = 14918,
  [15177] = 15118,
  [15178] = 15114,
  [15179] = 15118,
  [15180] = 15113,
  [15181] = 15118,
  [15182] = 15113,
  [15183] = 14810,
  [15184] = 14466,
  [15185] = 15118,
  [15186] = 15110,
  [15187] = 15110,
  [15188] = 15115,
  [15189] = 15109,
  [15190] = 15109,
  [15191] = 15115,
  [15192] = 15110,
  [15193] = 15110,
  [15194] = 15109,
  [15195] = 15113,
  [15196] = 15113,
  [15197] = 15110,
  [15198] = 15109,
  [15199] = 15118,
  [15200] = 15118,
  [15201] = 15118,
  [15202] = 15124,
  [15203] = 15118,
  [15204] = 15115,
  [15205] = 15115,
  [15206] = 15110,
  [15207] = 15118,
  [15208] = 15110,
  [15209] = 15114,
  [15210] = 15115,
  [15211] = 15110,
  [15212] = 15118,
  [15213] = 15118,
  [15214] = 15113,
  [15215] = 15118,
  [15216] = 15115,
  [15217] = 15124,
  [15218] = 15109,
  [15219] = 15110,
  [15220] = 15118,
  [15221] = 15129,
  [15222] = 15118,
  [15223] = 15114,
  [15224] = 15118,
  [15225] = 15118,
  [15226] = 15129,
  [15227] = 15118,
  [15228] = 15118,
  [15229] = 15115,
  [15230] = 15115,
  [15231] = 15109,
  [15232] = 15110,
  [15233] = 15124,
  [15234] = 15109,
  [15235] = 15124,
  [15236] = 15109,
  [15237] = 15115,
  [15238] = 15118,
  [15239] = 15129,
  [15240] = 15113,
  [15241] = 15118,
  [15242] = 15118,
  [15243] = 15110,
  [15244] = 15118,
  [15245] = 15110,
  [15246] = 15118,
  [15247] = 15113,
  [15248] = 7264,
  [15249] = 15118,
  [15250] = 15115,
  [15251] = 15109,
  [15252] = 15115,
  [15253] = 15253,
  [15254] = 15129,
  [15255] = 15109,
  [15256] = 15118,
  [15257] = 15114,
  [15258] = 14531,
  [15259] = 15118,
  [15260] = 15118,
  [15261] = 15124,
  [15262] = 15109,
  [15263] = 15109,
  [15264] = 15115,
  [15265] = 15110,
  [15266] = 15115,
  [15267] = 15109,
  [15268] = 15115,
  [15269] = 14810,
  [15270] = 15109,
  [15271] = 15109,
  [15272] = 15109,
  [15273] = 15115,
  [15274] = 15114,
  [15275] = 15118,
  [15276] = 15118,
  [15277] = 15118,
  [15278] = 15115,
  [15279] = 15118,
  [15280] = 15115,
  [15281] = 15110,
  [15282] = 14266,
  [15283] = 15118,
  [15284] = 15115,
  [15285] = 15109,
  [15286] = 4144,
  [15287] = 15115,
  [15288] = 14918,
  [15289] = 15129,
  [15290] = 15118,
  [15291] = 15110,
  [15292] = 15118,
  [15293] = 15115,
  [15294] = 15113,
  [15295] = 15129,
  [15296] = 14531,
  [15297] = 15118,
  [15298] = 15109,
  [15299] = 15129,
  [15300] = 15109,
  [15301] = 15115,
  [15302] = 15110,
  [15303] = 15118,
  [15304] = 15118,
  [15305] = 14918,
  [15306] = 15115,
  [15307] = 15110,
  [15308] = 15110,
  [15309] = 14531,
  [15310] = 15109,
  [15311] = 15124,
  [15312] = 15114,
  [15313] = 15110,
  [15314] = 15109,
  [15315] = 15124,
  [15316] = 15124,
  [15317] = 15118,
  [15318] = 15124,
  [15319] = 15115,
  [15320] = 15118,
  [15321] = 15110,
  [15322] = 15129,
  [15323] = 15109,
  [15324] = 14266,
  [15325] = 15129,
  [15326] = 15109,
  [15327] = 15109,
  [15328] = 15109,
  [15329] = 15114,
  [15330] = 15110,
  [15331] = 15118,
  [15332] = 14466,
  [15333] = 15118,
  [15334] = 15118,
  [15335] = 15113,
  [15336] = 15118,
  [15337] = 15109,
  [15338] = 15118,
  [15339] = 15115,
  [15340] = 15118,
  [15341] = 15115,
  [15342] = 15115,
  [15343] = 15115,
  [15344] = 15110,
  [15345] = 15118,
  [15346] = 15118,
  [15347] = 15118,
  [15348] = 15348,
  [15349] = 15349,
  [15350] = 15350,
  [15351] = 15351,
  [15352] = 15352,
  [15353] = 15353,
  [15354] = 15354,
  [15355] = 15355,
  [15356] = 15356,
  [15357] = 15357,
  [15358] = 15358,
  [15359] = 15359,
  [15360] = 15360,
  [15361] = 15360,
  [15362] = 15355,
  [15363] = 15348,
  [15364] = 15364,
  [15365] = 15365,
  [15366] = 15366,
  [15367] = 15367,
  [15368] = 15368,
  [15369] = 15348,
  [15370] = 15370,
  [15371] = 15368,
  [15372] = 4105,
  [15373] = 15350,
  [15374] = 15351,
  [15375] = 15352,
  [15376] = 15353,
  [15377] = 15350,
  [15378] = 15350,
  [15379] = 15356,
  [15380] = 15357,
  [15381] = 15358,
  [15382] = 15359,
  [15383] = 15351,
  [15384] = 15357,
  [15385] = 15352,
  [15386] = 15353,
  [15387] = 15358,
  [15388] = 15388,
  [15389] = 15389,
  [15390] = 15349,
  [15391] = 15366,
  [15392] = 15351,
  [15393] = 15368,
  [15394] = 15356,
  [15395] = 15350,
  [15396] = 15351,
  [15397] = 15352,
  [15398] = 15353,
  [15399] = 15357,
  [15400] = 15356,
  [15401] = 15357,
  [15402] = 15358,
  [15403] = 15359,
  [15404] = 15370,
  [15405] = 15366,
  [15406] = 15358,
  [15407] = 15356,
  [15408] = 15366,
  [15409] = 15357,
  [15410] = 15358,
  [15411] = 15359,
  [15412] = 15359,
  [15413] = 15354,
  [15414] = 15414,
  [15415] = 15368,
  [15416] = 15359,
  [15417] = 15364,
  [15418] = 15354,
  [15419] = 15350,
  [15420] = 15351,
  [15421] = 15352,
  [15422] = 15353,
  [15423] = 15423,
  [15424] = 6237,
  [15425] = 15356,
  [15426] = 15357,
  [15427] = 15358,
  [15428] = 15359,
  [15429] = 15366,
  [15430] = 15366,
  [15431] = 15364,
  [15432] = 15368,
  [15433] = 15360,
  [15434] = 15366,
  [15435] = 15350,
  [15436] = 15351,
  [15437] = 15352,
  [15438] = 15353,
  [15439] = 15351,
  [15440] = 15352,
  [15441] = 15353,
  [15442] = 15356,
  [15443] = 15357,
  [15444] = 15358,
  [15445] = 15359,
  [15446] = 15446,
  [15447] = 15366,
  [15448] = 15366,
  [15449] = 15368,
  [15450] = 15366,
  [15451] = 15350,
  [15452] = 15351,
  [15453] = 15352,
  [15454] = 15353,
  [15455] = 7264,
  [15456] = 15360,
  [15457] = 15356,
  [15458] = 15357,
  [15459] = 15358,
  [15460] = 15359,
  [15461] = 15360,
  [15462] = 15355,
  [15463] = 15355,
  [15464] = 15352,
  [15465] = 14531,
  [15466] = 15366,
  [15467] = 15348,
  [15468] = 4322,
  [15469] = 15368,
  [15470] = 15355,
  [15471] = 15367,
  [15472] = 15367,
  [15473] = 15368,
  [15474] = 15348,
  [15475] = 15360,
  [15476] = 15350,
  [15477] = 15351,
  [15478] = 15352,
  [15479] = 15353,
  [15480] = 15348,
  [15481] = 15356,
  [15482] = 15357,
  [15483] = 15358,
  [15484] = 15359,
  [15485] = 15350,
  [15486] = 15351,
  [15487] = 15352,
  [15488] = 15353,
  [15489] = 15388,
  [15490] = 15389,
  [15491] = 15368,
  [15492] = 15366,
  [15493] = 15349,
  [15494] = 15353,
  [15495] = 15368,
  [15496] = 15368,
  [15497] = 15355,
  [15498] = 15348,
  [15499] = 15350,
  [15500] = 15351,
  [15501] = 15352,
  [15502] = 15353,
  [15503] = 15370,
  [15504] = 15350,
  [15505] = 15356,
  [15506] = 15357,
  [15507] = 15358,
  [15508] = 15359,
  [15509] = 15351,
  [15510] = 15352,
  [15511] = 15353,
  [15512] = 15356,
  [15513] = 15357,
  [15514] = 15358,
  [15515] = 15366,
  [15516] = 15359,
  [15517] = 15354,
  [15518] = 4265,
  [15519] = 15364,
  [15520] = 15368,
  [15521] = 15350,
  [15522] = 15351,
  [15523] = 15352,
  [15524] = 15353,
  [15525] = 15368,
  [15526] = 15356,
  [15527] = 15357,
  [15528] = 15358,
  [15529] = 15359,
  [15530] = 15530,
  [15531] = 15388,
  [15532] = 15366,
  [15533] = 15368,
  [15534] = 4105,
  [15535] = 15366,
  [15536] = 15389,
  [15537] = 15349,
  [15538] = 15368,
  [15539] = 15350,
  [15540] = 15350,
  [15541] = 15351,
  [15542] = 15352,
  [15543] = 15353,
  [15544] = 15446,
  [15545] = 15366,
  [15546] = 15356,
  [15547] = 15357,
  [15548] = 15358,
  [15549] = 15359,
  [15550] = 4369,
  [15551] = 15351,
  [15552] = 15352,
  [15553] = 15353,
  [15554] = 15366,
  [15555] = 15368,
  [15556] = 15388,
  [15557] = 15389,
  [15558] = 15349,
  [15559] = 15370,
  [15560] = 15360,
  [15561] = 15368,
  [15562] = 15350,
  [15563] = 15351,
  [15564] = 15352,
  [15565] = 15353,
  [15566] = 15356,
  [15567] = 15357,
  [15568] = 15358,
  [15569] = 15359,
  [15570] = 15356,
  [15571] = 15357,
  [15572] = 15358,
  [15573] = 15359,
  [15574] = 15355,
  [15575] = 15348,
  [15576] = 15366,
  [15577] = 15368,
  [15578] = 15578,
  [15579] = 15354,
  [15580] = 15368,
  [15581] = 15350,
  [15582] = 15351,
  [15583] = 15352,
  [15584] = 15353,
  [15585] = 15350,
  [15586] = 15364,
  [15587] = 15351,
  [15588] = 15352,
  [15589] = 15356,
  [15590] = 15357,
  [15591] = 15358,
  [15592] = 15359,
  [15593] = 15353,
  [15594] = 15388,
  [15595] = 4252,
  [15596] = 15389,
  [15597] = 15349,
  [15598] = 15366,
  [15599] = 15366,
  [15600] = 15368,
  [15601] = 15370,
  [15602] = 15350,
  [15603] = 15370,
  [15604] = 15350,
  [15605] = 15351,
  [15606] = 15352,
  [15607] = 15353,
  [15608] = 15356,
  [15609] = 15357,
  [15610] = 15358,
  [15611] = 15359,
  [15612] = 15351,
  [15613] = 15356,
  [15614] = 15357,
  [15615] = 15358,
  [15616] = 15359,
  [15617] = 15352,
  [15618] = 15353,
  [15619] = 15354,
  [15620] = 15366,
  [15621] = 15364,
  [15622] = 15414,
  [15623] = 15366,
  [15624] = 15356,
  [15625] = 15357,
  [15626] = 15368,
  [15627] = 15358,
  [15628] = 15350,
  [15629] = 15351,
  [15630] = 15352,
  [15631] = 15353,
  [15632] = 15359,
  [15633] = 15350,
  [15634] = 15356,
  [15635] = 15357,
  [15636] = 15358,
  [15637] = 15359,
  [15638] = 15354,
  [15639] = 15366,
  [15640] = 15366,
  [15641] = 15364,
  [15642] = 15368,
  [15643] = 15350,
  [15644] = 15351,
  [15645] = 15352,
  [15646] = 15353,
  [15647] = 15356,
  [15648] = 15357,
  [15649] = 15358,
  [15650] = 15359,
  [15651] = 15360,
  [15652] = 15366,
  [15653] = 15355,
  [15654] = 15348,
  [15655] = 15352,
  [15656] = 15368,
  [15657] = 15368,
  [15658] = 15350,
  [15659] = 15351,
  [15660] = 15352,
  [15661] = 15353,
  [15662] = 15356,
  [15663] = 15357,
  [15664] = 15358,
  [15665] = 15359,
  [15666] = 15350,
  [15667] = 15350,
  [15668] = 15351,
  [15669] = 15352,
  [15670] = 15353,
  [15671] = 15351,
  [15672] = 15356,
  [15673] = 15357,
  [15674] = 15358,
  [15675] = 15359,
  [15676] = 15352,
  [15677] = 15350,
  [15678] = 15351,
  [15679] = 15352,
  [15680] = 15353,
  [15681] = 15356,
  [15682] = 15357,
  [15683] = 15358,
  [15684] = 15359,
  [15685] = 15388,
  [15686] = 15353,
  [15687] = 15350,
  [15688] = 15351,
  [15689] = 15352,
  [15690] = 15353,
  [15691] = 15356,
  [15692] = 15357,
  [15693] = 15358,
  [15694] = 15359,
  [15695] = 15360,
  [15696] = 15388,
  [15697] = 15350,
  [15698] = 15351,
  [15699] = 15352,
  [15700] = 15353,
  [15701] = 15389,
  [15702] = 15356,
  [15703] = 15357,
  [15704] = 15358,
  [15705] = 15359,
  [15706] = 15389,
  [15707] = 15350,
  [15708] = 15351,
  [15709] = 15352,
  [15710] = 15353,
  [15711] = 15356,
  [15712] = 15357,
  [15713] = 15358,
  [15714] = 15359,
  [15715] = 15349,
  [15716] = 15349,
  [15717] = 15350,
  [15718] = 15351,
  [15719] = 15352,
  [15720] = 15353,
  [15721] = 15356,
  [15722] = 15357,
  [15723] = 15358,
  [15724] = 15359,
  [15725] = 15350,
  [15726] = 15351,
  [15727] = 15352,
  [15728] = 15353,
  [15729] = 15356,
  [15730] = 15357,
  [15731] = 15358,
  [15732] = 15359,
  [15733] = 15350,
  [15734] = 15351,
  [15735] = 15352,
  [15736] = 15353,
  [15737] = 15356,
  [15738] = 15357,
  [15739] = 15358,
  [15740] = 15359,
  [15741] = 15350,
  [15742] = 15351,
  [15743] = 15352,
  [15744] = 15353,
  [15745] = 15356,
  [15746] = 15357,
  [15747] = 15358,
  [15748] = 15359,
  [15749] = 15350,
  [15750] = 15351,
  [15751] = 15352,
  [15752] = 15353,
  [15753] = 15356,
  [15754] = 15357,
  [15755] = 15358,
  [15756] = 15359,
  [15757] = 15350,
  [15758] = 15351,
  [15759] = 15352,
  [15760] = 15353,
  [15761] = 15356,
  [15762] = 15357,
  [15763] = 15358,
  [15764] = 15359,
  [15765] = 15765,
  [15766] = 15350,
  [15767] = 15351,
  [15768] = 15352,
  [15769] = 15353,
  [15770] = 15356,
  [15771] = 15357,
  [15772] = 15358,
  [15773] = 15359,
  [15774] = 15350,
  [15775] = 15351,
  [15776] = 15352,
  [15777] = 15353,
  [15778] = 15356,
  [15779] = 15357,
  [15780] = 15358,
  [15781] = 15359,
  [15782] = 15350,
  [15783] = 15351,
  [15784] = 15352,
  [15785] = 15353,
  [15786] = 15356,
  [15787] = 15357,
  [15788] = 15358,
  [15789] = 15359,
  [15790] = 15350,
  [15791] = 15351,
  [15792] = 15352,
  [15793] = 15353,
  [15794] = 15356,
  [15795] = 15357,
  [15796] = 15358,
  [15797] = 15359,
  [15798] = 15350,
  [15799] = 15351,
  [15800] = 15352,
  [15801] = 15353,
  [15802] = 15356,
  [15803] = 15357,
  [15804] = 15358,
  [15805] = 15359,
  [15806] = 15350,
  [15807] = 15351,
  [15808] = 15352,
  [15809] = 15353,
  [15810] = 15356,
  [15811] = 15357,
  [15812] = 15358,
  [15813] = 15359,
  [15814] = 15350,
  [15815] = 15351,
  [15816] = 15352,
  [15817] = 15353,
  [15818] = 15356,
  [15819] = 15357,
  [15820] = 15358,
  [15821] = 15359,
  [15822] = 15350,
  [15823] = 15351,
  [15824] = 15352,
  [15825] = 15353,
  [15826] = 15356,
  [15827] = 15357,
  [15828] = 15358,
  [15829] = 15359,
  [15830] = 15350,
  [15831] = 15351,
  [15832] = 15352,
  [15833] = 15353,
  [15834] = 15356,
  [15835] = 15357,
  [15836] = 15358,
  [15837] = 15359,
  [15838] = 15350,
  [15839] = 15351,
  [15840] = 15352,
  [15841] = 15353,
  [15842] = 15356,
  [15843] = 15357,
  [15844] = 15358,
  [15845] = 15359,
  [15846] = 15370,
  [15847] = 15350,
  [15848] = 15351,
  [15849] = 15352,
  [15850] = 15353,
  [15851] = 15356,
  [15852] = 15357,
  [15853] = 15358,
  [15854] = 15359,
  [15855] = 15350,
  [15856] = 15351,
  [15857] = 15352,
  [15858] = 15353,
  [15859] = 15356,
  [15860] = 15357,
  [15861] = 15358,
  [15862] = 15359,
  [15863] = 15350,
  [15864] = 15351,
  [15865] = 15352,
  [15866] = 15353,
  [15867] = 15356,
  [15868] = 15357,
  [15869] = 15358,
  [15870] = 15359,
  [15871] = 15350,
  [15872] = 15351,
  [15873] = 15352,
  [15874] = 15353,
  [15875] = 15356,
  [15876] = 15357,
  [15877] = 15358,
  [15878] = 15359,
  [15879] = 15350,
  [15880] = 15351,
  [15881] = 15352,
  [15882] = 15353,
  [15883] = 15356,
  [15884] = 15357,
  [15885] = 15358,
  [15886] = 15359,
  [15887] = 15350,
  [15888] = 15351,
  [15889] = 15352,
  [15890] = 15353,
  [15891] = 15356,
  [15892] = 15357,
  [15893] = 15358,
  [15894] = 15359,
  [15895] = 15350,
  [15896] = 15351,
  [15897] = 15352,
  [15898] = 15353,
  [15899] = 15356,
  [15900] = 15357,
  [15901] = 15358,
  [15902] = 15359,
  [15903] = 15350,
  [15904] = 15351,
  [15905] = 15352,
  [15906] = 15353,
  [15907] = 15356,
  [15908] = 15357,
  [15909] = 15358,
  [15910] = 15359,
  [15911] = 15350,
  [15912] = 15351,
  [15913] = 15352,
  [15914] = 15353,
  [15915] = 15370,
  [15916] = 15356,
  [15917] = 15357,
  [15918] = 15358,
  [15919] = 15359,
  [15920] = 15350,
  [15921] = 15351,
  [15922] = 15352,
  [15923] = 15353,
  [15924] = 15356,
  [15925] = 15357,
  [15926] = 15358,
  [15927] = 15359,
  [15928] = 15350,
  [15929] = 15351,
  [15930] = 15352,
  [15931] = 15353,
  [15932] = 15356,
  [15933] = 15357,
  [15934] = 15358,
  [15935] = 15359,
  [15936] = 15350,
  [15937] = 15351,
  [15938] = 15352,
  [15939] = 15353,
  [15940] = 15356,
  [15941] = 15357,
  [15942] = 15358,
  [15943] = 15359,
  [15944] = 15350,
  [15945] = 15351,
  [15946] = 15352,
  [15947] = 15353,
  [15948] = 15356,
  [15949] = 15357,
  [15950] = 15358,
  [15951] = 15359,
  [15952] = 15350,
  [15953] = 15351,
  [15954] = 15352,
  [15955] = 15353,
  [15956] = 15356,
  [15957] = 15357,
  [15958] = 15358,
  [15959] = 15359,
  [15960] = 15350,
  [15961] = 15351,
  [15962] = 15352,
  [15963] = 15353,
  [15964] = 15356,
  [15965] = 15357,
  [15966] = 15358,
  [15967] = 15359,
  [15968] = 15350,
  [15969] = 15351,
  [15970] = 15352,
  [15971] = 15353,
  [15972] = 15356,
  [15973] = 15357,
  [15974] = 15358,
  [15975] = 15359,
  [15976] = 15350,
  [15977] = 15351,
  [15978] = 15352,
  [15979] = 15353,
  [15980] = 15370,
  [15981] = 15356,
  [15982] = 15357,
  [15983] = 15358,
  [15984] = 15359,
  [15985] = 15350,
  [15986] = 15351,
  [15987] = 15352,
  [15988] = 15353,
  [15989] = 15356,
  [15990] = 15357,
  [15991] = 15358,
  [15992] = 15359,
  [15993] = 15350,
  [15994] = 15351,
  [15995] = 15352,
  [15996] = 15353,
  [15997] = 15356,
  [15998] = 15357,
  [15999] = 15358,
  [16000] = 15359,
  [16001] = 15350,
  [16002] = 15351,
  [16003] = 15352,
  [16004] = 15353,
  [16005] = 15356,
  [16006] = 15357,
  [16007] = 15358,
  [16008] = 15359,
  [16009] = 15350,
  [16010] = 15351,
  [16011] = 15352,
  [16012] = 15353,
  [16013] = 15356,
  [16014] = 15357,
  [16015] = 15358,
  [16016] = 15359,
  [16017] = 15350,
  [16018] = 15351,
  [16019] = 15352,
  [16020] = 15353,
  [16021] = 15356,
  [16022] = 15357,
  [16023] = 15358,
  [16024] = 15359,
  [16025] = 15350,
  [16026] = 15351,
  [16027] = 15352,
  [16028] = 15353,
  [16029] = 15356,
  [16030] = 15357,
  [16031] = 15358,
  [16032] = 15359,
  [16033] = 15356,
  [16034] = 4435,
  [16035] = 15357,
  [16036] = 15358,
  [16037] = 15359,
  [16038] = 15355,
  [16039] = 15356,
  [16040] = 15357,
  [16041] = 16041,
  [16042] = 15358,
  [16043] = 15353,
  [16044] = 15354,
  [16045] = 15446,
  [16046] = 15359,
  [16047] = 15366,
  [16048] = 15364,
  [16049] = 16049,
  [16050] = 16050,
  [16051] = 15348,
  [16052] = 4112,
  [16053] = 16053,
  [16054] = 16054,
  [16055] = 15765,
  [16056] = 16056,
  [16057] = 15578,
  [16058] = 15354,
  [16059] = 15388,
  [16060] = 15368,
  [16061] = 15366,
  [16062] = 15360,
  [16063] = 4159,
  [16064] = 16064,
  [16065] = 14810,
  [16066] = 15364,
  [16067] = 15355,
  [16068] = 15350,
  [16069] = 15351,
  [16070] = 15352,
  [16071] = 15353,
  [16072] = 15348,
  [16073] = 15360,
  [16074] = 15360,
  [16075] = 15366,
  [16076] = 15355,
  [16077] = 15348,
  [16078] = 15368,
  [16079] = 15368,
  [16080] = 14810,
  [16081] = 15350,
  [16082] = 15351,
  [16083] = 15352,
  [16084] = 15353,
  [16085] = 15388,
  [16086] = 15389,
  [16087] = 15349,
  [16088] = 4483,
  [16089] = 15360,
  [16090] = 15355,
  [16091] = 15367,
  [16092] = 16041,
  [16093] = 15370,
  [16094] = 15423,
  [16095] = 15350,
  [16096] = 16049,
  [16097] = 15368,
  [16098] = 15356,
  [16099] = 15357,
  [16100] = 15358,
  [16101] = 15359,
  [16102] = 15360,
  [16103] = 15354,
  [16104] = 15351,
  [16105] = 15364,
  [16106] = 15350,
  [16107] = 15350,
  [16108] = 15366,
  [16109] = 15350,
  [16110] = 15351,
  [16111] = 15352,
  [16112] = 15353,
  [16113] = 15351,
  [16114] = 15352,
  [16115] = 15353,
  [16116] = 15351,
  [16117] = 15388,
  [16118] = 15389,
  [16119] = 15388,
  [16120] = 15349,
  [16121] = 15389,
  [16122] = 15349,
  [16123] = 15366,
  [16124] = 15352,
  [16125] = 15353,
  [16126] = 15352,
  [16127] = 15353,
  [16128] = 15388,
  [16129] = 15370,
  [16130] = 15356,
  [16131] = 15357,
  [16132] = 15358,
  [16133] = 15359,
  [16134] = 15360,
  [16135] = 15360,
  [16136] = 15355,
  [16137] = 15389,
  [16138] = 15355,
  [16139] = 15348,
  [16140] = 15367,
  [16141] = 15348,
  [16142] = 15368,
  [16143] = 15370,
  [16144] = 15354,
  [16145] = 15360,
  [16146] = 15364,
  [16147] = 15368,
  [16148] = 15349,
  [16149] = 15350,
  [16150] = 15351,
  [16151] = 15352,
  [16152] = 15353,
  [16153] = 15366,
  [16154] = 15388,
  [16155] = 15389,
  [16156] = 15349,
  [16157] = 15350,
  [16158] = 15351,
  [16159] = 15352,
  [16160] = 15353,
  [16161] = 15360,
  [16162] = 15356,
  [16163] = 15388,
  [16164] = 15389,
  [16165] = 15349,
  [16166] = 4105,
  [16167] = 15357,
  [16168] = 15358,
  [16169] = 15359,
  [16170] = 15370,
  [16171] = 15355,
  [16172] = 16041,
  [16173] = 15370,
  [16174] = 15354,
  [16175] = 15356,
  [16176] = 15356,
  [16177] = 15357,
  [16178] = 16049,
  [16179] = 15358,
  [16180] = 4458,
  [16181] = 16050,
  [16182] = 15357,
  [16183] = 15359,
  [16184] = 16053,
  [16185] = 16054,
  [16186] = 15358,
  [16187] = 15765,
  [16188] = 16056,
  [16189] = 15578,
  [16190] = 4459,
  [16191] = 15367,
  [16192] = 15359,
  [16193] = 15354,
  [16194] = 15354,
  [16195] = 15355,
  [16196] = 15364,
  [16197] = 15364,
  [16198] = 15348,
  [16199] = 16041,
  [16200] = 15355,
  [16201] = 15388,
  [16202] = 15367,
  [16203] = 15348,
  [16204] = 16049,
  [16205] = 16050,
  [16206] = 15359,
  [16207] = 16053,
  [16208] = 16054,
  [16209] = 4160,
  [16210] = 15765,
  [16211] = 16056,
  [16212] = 15578,
  [16213] = 15366,
  [16214] = 15364,
  [16215] = 16041,
  [16216] = 4248,
  [16217] = 16217,
  [16218] = 16049,
  [16219] = 15355,
  [16220] = 16050,
  [16221] = 15389,
  [16222] = 16053,
  [16223] = 16054,
  [16224] = 15370,
  [16225] = 15765,
  [16226] = 16056,
  [16227] = 15578,
  [16228] = 15349,
  [16229] = 15360,
  [16230] = 15355,
  [16231] = 15355,
  [16232] = 15348,
  [16233] = 16041,
  [16234] = 15446,
  [16235] = 15367,
  [16236] = 15368,
  [16237] = 16049,
  [16238] = 16050,
  [16239] = 16053,
  [16240] = 16054,
  [16241] = 15765,
  [16242] = 16056,
  [16243] = 15578,
  [16244] = 16244,
  [16245] = 15366,
  [16246] = 15350,
  [16247] = 15351,
  [16248] = 15352,
  [16249] = 16041,
  [16250] = 15353,
  [16251] = 15388,
  [16252] = 15389,
  [16253] = 15349,
  [16254] = 16049,
  [16255] = 15348,
  [16256] = 16050,
  [16257] = 15368,
  [16258] = 16053,
  [16259] = 16054,
  [16260] = 15765,
  [16261] = 16056,
  [16262] = 15578,
  [16263] = 16041,
  [16264] = 15368,
  [16265] = 15366,
  [16266] = 15370,
  [16267] = 15356,
  [16268] = 16049,
  [16269] = 16050,
  [16270] = 15357,
  [16271] = 16053,
  [16272] = 16054,
  [16273] = 15765,
  [16274] = 16056,
  [16275] = 15578,
  [16276] = 15356,
  [16277] = 16041,
  [16278] = 15357,
  [16279] = 15358,
  [16280] = 15359,
  [16281] = 15358,
  [16282] = 15354,
  [16283] = 16049,
  [16284] = 16050,
  [16285] = 4295,
  [16286] = 16053,
  [16287] = 16054,
  [16288] = 15364,
  [16289] = 15765,
  [16290] = 16056,
  [16291] = 15578,
  [16292] = 15359,
  [16293] = 16041,
  [16294] = 15350,
  [16295] = 15351,
  [16296] = 15352,
  [16297] = 15353,
  [16298] = 16049,
  [16299] = 16050,
  [16300] = 16053,
  [16301] = 16054,
  [16302] = 15765,
  [16303] = 16056,
  [16304] = 15578,
  [16305] = 16041,
  [16306] = 6780,
  [16307] = 15354,
  [16308] = 16056,
  [16309] = 16049,
  [16310] = 15360,
  [16311] = 16050,
  [16312] = 16053,
  [16313] = 16054,
  [16314] = 15765,
  [16315] = 16056,
  [16316] = 15578,
  [16317] = 16041,
  [16318] = 15366,
  [16319] = 15366,
  [16320] = 15368,
  [16321] = 16049,
  [16322] = 16050,
  [16323] = 16053,
  [16324] = 16054,
  [16325] = 15765,
  [16326] = 16056,
  [16327] = 15578,
  [16328] = 16053,
  [16329] = 16054,
  [16330] = 16053,
  [16331] = 16054,
  [16332] = 15364,
  [16333] = 16053,
  [16334] = 16054,
  [16335] = 15355,
  [16336] = 15364,
  [16337] = 16053,
  [16338] = 16054,
  [16339] = 15348,
  [16340] = 16053,
  [16341] = 16054,
  [16342] = 15360,
  [16343] = 16053,
  [16344] = 16054,
  [16345] = 15356,
  [16346] = 16053,
  [16347] = 16054,
  [16348] = 16053,
  [16349] = 16054,
  [16350] = 15355,
  [16351] = 16053,
  [16352] = 16054,
  [16353] = 15355,
  [16354] = 16053,
  [16355] = 16054,
  [16356] = 16053,
  [16357] = 16054,
  [16358] = 16053,
  [16359] = 16054,
  [16360] = 16053,
  [16361] = 16054,
  [16362] = 15348,
  [16363] = 16053,
  [16364] = 16054,
  [16365] = 16053,
  [16366] = 16054,
  [16367] = 16053,
  [16368] = 16054,
  [16369] = 16053,
  [16370] = 16054,
  [16371] = 16053,
  [16372] = 16054,
  [16373] = 16053,
  [16374] = 16054,
  [16375] = 16053,
  [16376] = 16054,
  [16377] = 15360,
  [16378] = 15348,
  [16379] = 16053,
  [16380] = 16054,
  [16381] = 15388,
  [16382] = 16053,
  [16383] = 16054,
  [16384] = 16053,
  [16385] = 16054,
  [16386] = 15368,
  [16387] = 15355,
  [16388] = 16053,
  [16389] = 16054,
  [16390] = 15367,
  [16391] = 16053,
  [16392] = 16054,
  [16393] = 15348,
  [16394] = 16053,
  [16395] = 16054,
  [16396] = 15389,
  [16397] = 16053,
  [16398] = 16054,
  [16399] = 16053,
  [16400] = 16054,
  [16401] = 16053,
  [16402] = 16054,
  [16403] = 16053,
  [16404] = 16054,
  [16405] = 16053,
  [16406] = 16054,
  [16407] = 16407,
  [16408] = 16053,
  [16409] = 16054,
  [16410] = 16053,
  [16411] = 16054,
  [16412] = 5953,
  [16413] = 16053,
  [16414] = 16054,
  [16415] = 16053,
  [16416] = 16054,
  [16417] = 16053,
  [16418] = 16054,
  [16419] = 16053,
  [16420] = 16054,
  [16421] = 15368,
  [16422] = 16053,
  [16423] = 16054,
  [16424] = 15349,
  [16425] = 16053,
  [16426] = 16054,
  [16427] = 16053,
  [16428] = 16054,
  [16429] = 16053,
  [16430] = 16054,
  [16431] = 15368,
  [16432] = 16053,
  [16433] = 16054,
  [16434] = 16053,
  [16435] = 16054,
  [16436] = 16436,
  [16437] = 16053,
  [16438] = 16054,
  [16439] = 16053,
  [16440] = 16054,
  [16441] = 16053,
  [16442] = 16054,
  [16443] = 15350,
  [16444] = 16053,
  [16445] = 16054,
  [16446] = 16053,
  [16447] = 16054,
  [16448] = 16053,
  [16449] = 16054,
  [16450] = 15350,
  [16451] = 16053,
  [16452] = 16054,
  [16453] = 15351,
  [16454] = 16053,
  [16455] = 16054,
  [16456] = 15352,
  [16457] = 16053,
  [16458] = 16054,
  [16459] = 15353,
  [16460] = 16053,
  [16461] = 16054,
  [16462] = 16053,
  [16463] = 16054,
  [16464] = 16053,
  [16465] = 16054,
  [16466] = 16053,
  [16467] = 16054,
  [16468] = 16053,
  [16469] = 16054,
  [16470] = 16053,
  [16471] = 16054,
  [16472] = 16053,
  [16473] = 16054,
  [16474] = 16053,
  [16475] = 16054,
  [16476] = 16053,
  [16477] = 16054,
  [16478] = 16053,
  [16479] = 16054,
  [16480] = 16053,
  [16481] = 16054,
  [16482] = 16053,
  [16483] = 16054,
  [16484] = 16053,
  [16485] = 16054,
  [16486] = 16053,
  [16487] = 16054,
  [16488] = 16053,
  [16489] = 16054,
  [16490] = 16053,
  [16491] = 16054,
  [16492] = 16053,
  [16493] = 16054,
  [16494] = 16053,
  [16495] = 16054,
  [16496] = 16053,
  [16497] = 16054,
  [16498] = 16053,
  [16499] = 16054,
  [16500] = 16053,
  [16501] = 16054,
  [16502] = 16053,
  [16503] = 16054,
  [16504] = 16053,
  [16505] = 16054,
  [16506] = 16053,
  [16507] = 16054,
  [16508] = 16053,
  [16509] = 16054,
  [16510] = 16053,
  [16511] = 16054,
  [16512] = 16053,
  [16513] = 16054,
  [16514] = 16053,
  [16515] = 16054,
  [16516] = 16053,
  [16517] = 16054,
  [16518] = 16053,
  [16519] = 16054,
  [16520] = 16053,
  [16521] = 16054,
  [16522] = 16053,
  [16523] = 16054,
  [16524] = 16053,
  [16525] = 16054,
  [16526] = 16053,
  [16527] = 16054,
  [16528] = 16053,
  [16529] = 16054,
  [16530] = 16053,
  [16531] = 16054,
  [16532] = 16053,
  [16533] = 16054,
  [16534] = 16053,
  [16535] = 16054,
  [16536] = 16053,
  [16537] = 16054,
  [16538] = 16053,
  [16539] = 16054,
  [16540] = 16053,
  [16541] = 16054,
  [16542] = 16053,
  [16543] = 16054,
  [16544] = 15351,
  [16545] = 15368,
  [16546] = 15352,
  [16547] = 15353,
  [16548] = 15388,
  [16549] = 15389,
  [16550] = 14466,
  [16551] = 15349,
  [16552] = 15348,
  [16553] = 15357,
  [16554] = 15388,
  [16555] = 15389,
  [16556] = 15349,
  [16557] = 15350,
  [16558] = 15351,
  [16559] = 15352,
  [16560] = 15353,
  [16561] = 15388,
  [16562] = 15389,
  [16563] = 15370,
  [16564] = 15349,
  [16565] = 15370,
  [16566] = 15356,
  [16567] = 15357,
  [16568] = 15358,
  [16569] = 15359,
  [16570] = 15356,
  [16571] = 15357,
  [16572] = 15358,
  [16573] = 15359,
  [16574] = 15354,
  [16575] = 15354,
  [16576] = 15368,
  [16577] = 15364,
  [16578] = 15370,
  [16579] = 15364,
  [16580] = 4302,
  [16581] = 15356,
  [16582] = 15350,
  [16583] = 15357,
  [16584] = 15358,
  [16585] = 15351,
  [16586] = 15352,
  [16587] = 15359,
  [16588] = 15353,
  [16589] = 15354,
  [16590] = 16590,
  [16591] = 15364,
  [16592] = 16592,
  [16593] = 15388,
  [16594] = 15354,
  [16595] = 15389,
  [16596] = 15349,
  [16597] = 15350,
  [16598] = 15351,
  [16599] = 15352,
  [16600] = 15366,
  [16601] = 15358,
  [16602] = 15353,
  [16603] = 4105,
  [16604] = 15366,
  [16605] = 4164,
  [16606] = 15360,
  [16607] = 15355,
  [16608] = 15348,
  [16609] = 4308,
  [16610] = 4309,
  [16611] = 15360,
  [16612] = 15368,
  [16613] = 15355,
  [16614] = 15388,
  [16615] = 15348,
  [16616] = 4165,
  [16617] = 15389,
  [16618] = 15350,
  [16619] = 15351,
  [16620] = 15352,
  [16621] = 15353,
  [16622] = 15388,
  [16623] = 15389,
  [16624] = 15349,
  [16625] = 15368,
  [16626] = 15370,
  [16627] = 15414,
  [16628] = 15423,
  [16629] = 15349,
  [16630] = 15370,
  [16631] = 15350,
  [16632] = 15351,
  [16633] = 15370,
  [16634] = 15352,
  [16635] = 15353,
  [16636] = 15388,
  [16637] = 15389,
  [16638] = 15356,
  [16639] = 15349,
  [16640] = 15357,
  [16641] = 15358,
  [16642] = 15359,
  [16643] = 15354,
  [16644] = 15364,
  [16645] = 15356,
  [16646] = 15370,
  [16647] = 15357,
  [16648] = 7264,
  [16649] = 15358,
  [16650] = 15359,
  [16651] = 4291,
  [16652] = 4293,
  [16653] = 15354,
  [16654] = 15356,
  [16655] = 15357,
  [16656] = 15358,
  [16657] = 15359,
  [16658] = 15356,
  [16659] = 15354,
  [16660] = 4320,
  [16661] = 15357,
  [16662] = 15358,
  [16663] = 4321,
  [16664] = 15364,
  [16665] = 15366,
  [16666] = 15388,
  [16667] = 15359,
  [16668] = 15389,
  [16669] = 15368,
  [16670] = 15349,
  [16671] = 15364,
  [16672] = 15359,
  [16673] = 15360,
  [16674] = 15355,
  [16675] = 15348,
  [16676] = 15370,
  [16677] = 15366,
  [16678] = 15368,
  [16679] = 15350,
  [16680] = 15351,
  [16681] = 15352,
  [16682] = 15353,
  [16683] = 14531,
  [16684] = 15388,
  [16685] = 15389,
  [16686] = 15360,
  [16687] = 15349,
  [16688] = 4325,
  [16689] = 4326,
  [16690] = 15355,
  [16691] = 15348,
  [16692] = 4327,
  [16693] = 4249,
  [16694] = 4250,
  [16695] = 15368,
  [16696] = 15356,
  [16697] = 15366,
  [16698] = 4300,
  [16699] = 15356,
  [16700] = 15357,
  [16701] = 15358,
  [16702] = 15359,
  [16703] = 4301,
  [16704] = 4324,
  [16705] = 15354,
  [16706] = 4338,
  [16707] = 15350,
  [16708] = 4339,
  [16709] = 15351,
  [16710] = 15352,
  [16711] = 15353,
  [16712] = 4340,
  [16713] = 15388,
  [16714] = 4341,
  [16715] = 15389,
  [16716] = 4342,
  [16717] = 15357,
  [16718] = 15349,
  [16719] = 15358,
  [16720] = 15356,
  [16721] = 15370,
  [16722] = 15354,
  [16723] = 15354,
  [16724] = 15370,
  [16725] = 15356,
  [16726] = 15357,
  [16727] = 15358,
  [16728] = 15359,
  [16729] = 15356,
  [16730] = 15354,
  [16731] = 15357,
  [16732] = 15366,
  [16733] = 15358,
  [16734] = 15364,
  [16735] = 15359,
  [16736] = 4105,
  [16737] = 15360,
  [16738] = 15366,
  [16739] = 15366,
  [16740] = 15355,
  [16741] = 15348,
  [16742] = 15366,
  [16743] = 15368,
  [16744] = 15360,
  [16745] = 15355,
  [16746] = 15359,
  [16747] = 15350,
  [16748] = 15351,
  [16749] = 15352,
  [16750] = 15353,
  [16751] = 15388,
  [16752] = 15389,
  [16753] = 15349,
  [16754] = 15367,
  [16755] = 15348,
  [16756] = 4344,
  [16757] = 15368,
  [16758] = 16758,
  [16759] = 4345,
  [16760] = 15360,
  [16761] = 4346,
  [16762] = 4347,
  [16763] = 15350,
  [16764] = 15351,
  [16765] = 15352,
  [16766] = 15353,
  [16767] = 15354,
  [16768] = 4348,
  [16769] = 15356,
  [16770] = 15357,
  [16771] = 15355,
  [16772] = 15358,
  [16773] = 15359,
  [16774] = 15348,
  [16775] = 4245,
  [16776] = 15354,
  [16777] = 15364,
  [16778] = 15354,
  [16779] = 4350,
  [16780] = 4351,
  [16781] = 14466,
  [16782] = 4353,
  [16783] = 15388,
  [16784] = 15389,
  [16785] = 15349,
  [16786] = 16786,
  [16787] = 15368,
  [16788] = 4354,
  [16789] = 4355,
  [16790] = 15366,
  [16791] = 15360,
  [16792] = 4356,
  [16793] = 15370,
  [16794] = 15355,
  [16795] = 15356,
  [16796] = 15348,
  [16797] = 15357,
  [16798] = 15350,
  [16799] = 15358,
  [16800] = 15359,
  [16801] = 15351,
  [16802] = 15368,
  [16803] = 15350,
  [16804] = 15351,
  [16805] = 15352,
  [16806] = 15353,
  [16807] = 15388,
  [16808] = 15389,
  [16809] = 15349,
  [16810] = 15354,
  [16811] = 15364,
  [16812] = 15352,
  [16813] = 15350,
  [16814] = 15364,
  [16815] = 15351,
  [16816] = 15352,
  [16817] = 15353,
  [16818] = 15370,
  [16819] = 15356,
  [16820] = 15357,
  [16821] = 15358,
  [16822] = 15368,
  [16823] = 15359,
  [16824] = 15353,
  [16825] = 15354,
  [16826] = 15370,
  [16827] = 15356,
  [16828] = 15357,
  [16829] = 15358,
  [16830] = 15359,
  [16831] = 15364,
  [16832] = 15364,
  [16833] = 15360,
  [16834] = 15354,
  [16835] = 15388,
  [16836] = 15364,
  [16837] = 15350,
  [16838] = 15366,
  [16839] = 15351,
  [16840] = 15352,
  [16841] = 15353,
  [16842] = 15389,
  [16843] = 15388,
  [16844] = 15389,
  [16845] = 15349,
  [16846] = 16050,
  [16847] = 15368,
  [16848] = 15349,
  [16849] = 6787,
  [16850] = 15350,
  [16851] = 15351,
  [16852] = 15352,
  [16853] = 15353,
  [16854] = 15389,
  [16855] = 15355,
  [16856] = 15356,
  [16857] = 15357,
  [16858] = 15358,
  [16859] = 16859,
  [16860] = 15359,
  [16861] = 15366,
  [16862] = 15388,
  [16863] = 15370,
  [16864] = 15348,
  [16865] = 15356,
  [16866] = 15357,
  [16867] = 15358,
  [16868] = 15366,
  [16869] = 15359,
  [16870] = 15366,
  [16871] = 15354,
  [16872] = 15364,
  [16873] = 15368,
  [16874] = 15389,
  [16875] = 15368,
  [16876] = 15367,
  [16877] = 15388,
  [16878] = 15350,
  [16879] = 15351,
  [16880] = 15360,
  [16881] = 15352,
  [16882] = 15353,
  [16883] = 15355,
  [16884] = 15348,
  [16885] = 15368,
  [16886] = 15389,
  [16887] = 15349,
  [16888] = 15368,
  [16889] = 15356,
  [16890] = 15357,
  [16891] = 15358,
  [16892] = 15359,
  [16893] = 15350,
  [16894] = 15351,
  [16895] = 15352,
  [16896] = 15353,
  [16897] = 15370,
  [16898] = 15388,
  [16899] = 15389,
  [16900] = 15349,
  [16901] = 15360,
  [16902] = 4105,
  [16903] = 15366,
  [16904] = 15366,
  [16905] = 15370,
  [16906] = 15364,
  [16907] = 15356,
  [16908] = 15357,
  [16909] = 15358,
  [16910] = 15359,
  [16911] = 15357,
  [16912] = 15354,
  [16913] = 15350,
  [16914] = 15364,
  [16915] = 15351,
  [16916] = 15368,
  [16917] = 15352,
  [16918] = 15353,
  [16919] = 15360,
  [16920] = 15388,
  [16921] = 15350,
  [16922] = 15351,
  [16923] = 15352,
  [16924] = 15353,
  [16925] = 15360,
  [16926] = 15389,
  [16927] = 15360,
  [16928] = 15366,
  [16929] = 15355,
  [16930] = 15356,
  [16931] = 15357,
  [16932] = 15358,
  [16933] = 15355,
  [16934] = 15359,
  [16935] = 15367,
  [16936] = 15349,
  [16937] = 15348,
  [16938] = 15348,
  [16939] = 15370,
  [16940] = 15368,
  [16941] = 15360,
  [16942] = 15368,
  [16943] = 15350,
  [16944] = 15351,
  [16945] = 15352,
  [16946] = 15353,
  [16947] = 15355,
  [16948] = 15366,
  [16949] = 15348,
  [16950] = 15388,
  [16951] = 15389,
  [16952] = 15349,
  [16953] = 16053,
  [16954] = 16954,
  [16955] = 15350,
  [16956] = 15370,
  [16957] = 15351,
  [16958] = 15356,
  [16959] = 15357,
  [16960] = 15358,
  [16961] = 15359,
  [16962] = 16054,
  [16963] = 15368,
  [16964] = 15354,
  [16965] = 15352,
  [16966] = 15364,
  [16967] = 16967,
  [16968] = 15368,
  [16969] = 15353,
  [16970] = 15388,
  [16971] = 15389,
  [16972] = 15350,
  [16973] = 15351,
  [16974] = 15352,
  [16975] = 15414,
  [16976] = 15353,
  [16977] = 15349,
  [16978] = 15423,
  [16979] = 16979,
  [16980] = 15350,
  [16981] = 15351,
  [16982] = 15352,
  [16983] = 15353,
  [16984] = 15356,
  [16985] = 15357,
  [16986] = 15388,
  [16987] = 15358,
  [16988] = 15389,
  [16989] = 15359,
  [16990] = 15349,
  [16991] = 16991,
  [16992] = 15356,
  [16993] = 15357,
  [16994] = 16994,
  [16995] = 15358,
  [16996] = 16996,
  [16997] = 15366,
  [16998] = 15366,
  [16999] = 15359,
  [17000] = 15370,
  [17001] = 15355,
  [17002] = 17002,
  [17003] = 17003,
  [17004] = 15368,
  [17005] = 15370,
  [17006] = 15356,
  [17007] = 15357,
  [17008] = 15356,
  [17009] = 15358,
  [17010] = 15357,
  [17011] = 15358,
  [17012] = 15350,
  [17013] = 15359,
  [17014] = 17014,
  [17015] = 15351,
  [17016] = 15354,
  [17017] = 15350,
  [17018] = 15352,
  [17019] = 15353,
  [17020] = 15366,
  [17021] = 15364,
  [17022] = 15359,
  [17023] = 15356,
  [17024] = 15357,
  [17025] = 15358,
  [17026] = 15359,
  [17027] = 15354,
  [17028] = 15367,
  [17029] = 15364,
  [17030] = 14918,
  [17031] = 15366,
  [17032] = 15354,
  [17033] = 15370,
  [17034] = 15349,
  [17035] = 15348,
  [17036] = 15368,
  [17037] = 15364,
  [17038] = 15350,
  [17039] = 15351,
  [17040] = 15352,
  [17041] = 15353,
  [17042] = 15351,
  [17043] = 15348,
  [17044] = 14918,
  [17045] = 15366,
  [17046] = 15366,
  [17047] = 15356,
  [17048] = 15357,
  [17049] = 15358,
  [17050] = 15359,
  [17051] = 15356,
  [17052] = 15356,
  [17053] = 15360,
  [17054] = 15366,
  [17055] = 15366,
  [17056] = 15355,
  [17057] = 4131,
  [17058] = 15348,
  [17059] = 15358,
  [17060] = 15357,
  [17061] = 15368,
  [17062] = 15358,
  [17063] = 15359,
  [17064] = 15360,
  [17065] = 17065,
  [17066] = 17066,
  [17067] = 17067,
  [17068] = 17068,
  [17069] = 17069,
  [17070] = 17066,
  [17071] = 17071,
  [17072] = 17072,
  [17073] = 17073,
  [17074] = 17074,
  [17075] = 17073,
  [17076] = 17068,
  [17077] = 17069,
  [17078] = 17067,
  [17079] = 17073,
  [17080] = 17072,
  [17081] = 17066,
  [17082] = 17065,
  [17083] = 17068,
  [17084] = 17069,
  [17085] = 17072,
  [17086] = 17067,
  [17087] = 17067,
  [17088] = 17068,
  [17089] = 17066,
  [17090] = 17074,
  [17091] = 17069,
  [17092] = 17092,
  [17093] = 17073,
  [17094] = 17071,
  [17095] = 17072,
  [17096] = 17067,
  [17097] = 17073,
  [17098] = 17071,
  [17099] = 17099,
  [17100] = 17068,
  [17101] = 17067,
  [17102] = 17069,
  [17103] = 17074,
  [17104] = 17072,
  [17105] = 17074,
  [17106] = 17065,
  [17107] = 17073,
  [17108] = 17071,
  [17109] = 17071,
  [17110] = 17067,
  [17111] = 17111,
  [17112] = 17074,
  [17113] = 17068,
  [17114] = 17069,
  [17115] = 17072,
  [17116] = 17071,
  [17117] = 17067,
  [17118] = 17068,
  [17119] = 17066,
  [17120] = 17069,
  [17121] = 17072,
  [17122] = 17071,
  [17123] = 17123,
  [17124] = 17092,
  [17125] = 17071,
  [17126] = 17068,
  [17127] = 17069,
  [17128] = 17072,
  [17129] = 17074,
  [17130] = 17065,
  [17131] = 17131,
  [17132] = 17071,
  [17133] = 17068,
  [17134] = 17069,
  [17135] = 17067,
  [17136] = 17065,
  [17137] = 17137,
  [17138] = 17137,
  [17139] = 17073,
  [17140] = 17068,
  [17141] = 17066,
  [17142] = 17099,
  [17143] = 17068,
  [17144] = 17144,
  [17145] = 17065,
  [17146] = 17074,
  [17147] = 17065,
  [17148] = 17073,
  [17149] = 17068,
  [17150] = 17150,
  [17151] = 17065,
  [17152] = 17067,
  [17153] = 17068,
  [17154] = 17066,
  [17155] = 17065,
  [17156] = 4131,
  [17157] = 17067,
  [17158] = 17068,
  [17159] = 17065,
  [17160] = 17111,
  [17161] = 17066,
  [17162] = 17162,
  [17163] = 17068,
  [17164] = 17067,
  [17165] = 17165,
  [17166] = 17068,
  [17167] = 17073,
  [17168] = 17067,
  [17169] = 17073,
  [17170] = 17066,
  [17171] = 17068,
  [17172] = 17071,
  [17173] = 17066,
  [17174] = 17066,
  [17175] = 17073,
  [17176] = 17068,
  [17177] = 17067,
  [17178] = 17074,
  [17179] = 17068,
  [17180] = 17066,
  [17181] = 17071,
  [17182] = 17074,
  [17183] = 17073,
  [17184] = 17144,
  [17185] = 17137,
  [17186] = 17150,
  [17187] = 17099,
  [17188] = 17071,
  [17189] = 17065,
  [17190] = 17068,
  [17191] = 17074,
  [17192] = 17071,
  [17193] = 17073,
  [17194] = 17074,
  [17195] = 17074,
  [17196] = 17073,
  [17197] = 17065,
  [17198] = 17074,
  [17199] = 17068,
  [17200] = 17144,
  [17201] = 17073,
  [17202] = 17150,
  [17203] = 17067,
  [17204] = 17067,
  [17205] = 17071,
  [17206] = 17071,
  [17207] = 16996,
  [17208] = 17073,
  [17209] = 17068,
  [17210] = 17111,
  [17211] = 17002,
  [17212] = 17066,
  [17213] = 17068,
  [17214] = 17066,
  [17215] = 17065,
  [17216] = 17071,
  [17217] = 17068,
  [17218] = 17065,
  [17219] = 17065,
  [17220] = 17065,
  [17221] = 17067,
  [17222] = 17068,
  [17223] = 17003,
  [17224] = 17071,
  [17225] = 17068,
  [17226] = 17065,
  [17227] = 17071,
  [17228] = 17067,
  [17229] = 17229,
  [17230] = 17068,
  [17231] = 15365,
  [17232] = 4164,
  [17233] = 17137,
  [17234] = 17068,
  [17235] = 17067,
  [17236] = 17074,
  [17237] = 17068,
  [17238] = 17073,
  [17239] = 17065,
  [17240] = 17071,
  [17241] = 17068,
  [17242] = 17066,
  [17243] = 17111,
  [17244] = 17068,
  [17245] = 17099,
  [17246] = 17111,
  [17247] = 17073,
  [17248] = 17065,
  [17249] = 17067,
  [17250] = 17066,
  [17251] = 17065,
  [17252] = 17068,
  [17253] = 17066,
  [17254] = 17066,
  [17255] = 17071,
  [17256] = 17072,
  [17257] = 17068,
  [17258] = 17067,
  [17259] = 17071,
  [17260] = 17071,
  [17261] = 17074,
  [17262] = 17074,
  [17263] = 17068,
  [17264] = 17065,
  [17265] = 17073,
  [17266] = 17071,
  [17267] = 17066,
  [17268] = 17071,
  [17269] = 17071,
  [17270] = 17068,
  [17271] = 17067,
  [17272] = 4165,
  [17273] = 17068,
  [17274] = 17068,
  [17275] = 17067,
  [17276] = 17065,
  [17277] = 17069,
  [17278] = 17068,
  [17279] = 17137,
  [17280] = 17067,
  [17281] = 17067,
  [17282] = 17073,
  [17283] = 17065,
  [17284] = 17074,
  [17285] = 17068,
  [17286] = 17137,
  [17287] = 17065,
  [17288] = 17288,
  [17289] = 17066,
  [17290] = 17068,
  [17291] = 17067,
  [17292] = 17066,
  [17293] = 17073,
  [17294] = 17068,
  [17295] = 17067,
  [17296] = 17071,
  [17297] = 17068,
  [17298] = 17065,
  [17299] = 17074,
  [17300] = 17066,
  [17301] = 17068,
  [17302] = 17073,
  [17303] = 17073,
  [17304] = 17067,
  [17305] = 17068,
  [17306] = 17072,
  [17307] = 17071,
  [17308] = 17068,
  [17309] = 17137,
  [17310] = 17065,
  [17311] = 17068,
  [17312] = 17074,
  [17313] = 17131,
  [17314] = 17144,
  [17315] = 17067,
  [17316] = 17068,
  [17317] = 17074,
  [17318] = 17068,
  [17319] = 17071,
  [17320] = 17069,
  [17321] = 17065,
  [17322] = 17073,
  [17323] = 17074,
  [17324] = 17074,
  [17325] = 17073,
  [17326] = 17073,
  [17327] = 17066,
  [17328] = 17328,
  [17329] = 17067,
  [17330] = 17150,
  [17331] = 17071,
  [17332] = 17066,
  [17333] = 17071,
  [17334] = 17066,
  [17335] = 17335,
  [17336] = 17065,
  [17337] = 17066,
  [17338] = 17065,
  [17339] = 17065,
  [17340] = 17067,
  [17341] = 17072,
  [17342] = 17067,
  [17343] = 17067,
  [17344] = 17066,
  [17345] = 17066,
  [17346] = 17066,
  [17347] = 4159,
  [17348] = 17092,
  [17349] = 17065,
  [17350] = 17137,
  [17351] = 17068,
  [17352] = 17069,
  [17353] = 17066,
  [17354] = 17066,
  [17355] = 17131,
  [17356] = 17356,
  [17357] = 17074,
  [17358] = 17073,
  [17359] = 17071,
  [17360] = 17074,
  [17361] = 4144,
  [17362] = 17066,
  [17363] = 17073,
  [17364] = 17072,
  [17365] = 17099,
  [17366] = 17066,
  [17367] = 17065,
  [17368] = 17066,
  [17369] = 17074,
  [17370] = 17111,
  [17371] = 17073,
  [17372] = 17372,
  [17373] = 17066,
  [17374] = 17071,
  [17375] = 17074,
  [17376] = 17067,
  [17377] = 17073,
  [17378] = 17065,
  [17379] = 17137,
  [17380] = 17074,
  [17381] = 17066,
  [17382] = 17067,
  [17383] = 17066,
  [17384] = 17065,
  [17385] = 17072,
  [17386] = 4160,
  [17387] = 17068,
  [17388] = 16859,
  [17389] = 17071,
  [17390] = 17069,
  [17391] = 17092,
  [17392] = 17068,
  [17393] = 17066,
  [17394] = 17069,
  [17395] = 17065,
  [17396] = 17131,
  [17397] = 17065,
  [17398] = 17131,
  [17399] = 17144,
  [17400] = 17074,
  [17401] = 17067,
  [17402] = 17065,
  [17403] = 17074,
  [17404] = 17071,
  [17405] = 17067,
  [17406] = 17067,
  [17407] = 17067,
  [17408] = 17065,
  [17409] = 17073,
  [17410] = 17074,
  [17411] = 17066,
  [17412] = 17092,
  [17413] = 17413,
  [17414] = 17067,
  [17415] = 17066,
  [17416] = 17073,
  [17417] = 17071,
  [17418] = 17072,
  [17419] = 17074,
  [17420] = 17092,
  [17421] = 17074,
  [17422] = 17074,
  [17423] = 17066,
  [17424] = 17071,
  [17425] = 17073,
  [17426] = 17144,
  [17427] = 17074,
  [17428] = 17068,
  [17429] = 17073,
  [17430] = 17069,
  [17431] = 17074,
  [17432] = 17074,
  [17433] = 17071,
  [17434] = 17067,
  [17435] = 17073,
  [17436] = 17150,
  [17437] = 17065,
  [17438] = 17074,
  [17439] = 17131,
  [17440] = 17067,
  [17441] = 17144,
  [17442] = 17071,
  [17443] = 17092,
  [17444] = 17073,
  [17445] = 17150,
  [17446] = 17074,
  [17447] = 17071,
  [17448] = 17072,
  [17449] = 17065,
  [17450] = 17066,
  [17451] = 17071,
  [17452] = 17071,
  [17453] = 17073,
  [17454] = 17065,
  [17455] = 17071,
  [17456] = 17066,
  [17457] = 17065,
  [17458] = 17074,
  [17459] = 17068,
  [17460] = 17073,
  [17461] = 17067,
  [17462] = 17069,
  [17463] = 17065,
  [17464] = 17066,
  [17465] = 17067,
  [17466] = 17071,
  [17467] = 17067,
  [17468] = 17131,
  [17469] = 17288,
  [17470] = 17099,
  [17471] = 17071,
  [17472] = 17065,
  [17473] = 17111,
  [17474] = 17067,
  [17475] = 17068,
  [17476] = 17071,
  [17477] = 17065,
  [17478] = 17073,
  [17479] = 17067,
  [17480] = 17066,
  [17481] = 17067,
  [17482] = 17067,
  [17483] = 17065,
  [17484] = 17071,
  [17485] = 17131,
  [17486] = 17099,
  [17487] = 17111,
  [17488] = 17072,
  [17489] = 17065,
  [17490] = 17490,
  [17491] = 17288,
  [17492] = 17066,
  [17493] = 17065,
  [17494] = 17494,
  [17495] = 17074,
  [17496] = 17092,
  [17497] = 17150,
  [17498] = 17067,
  [17499] = 17066,
  [17500] = 17073,
  [17501] = 17071,
  [17502] = 17066,
  [17503] = 17065,
  [17504] = 17074,
  [17505] = 17066,
  [17506] = 17144,
  [17507] = 17068,
  [17508] = 17069,
  [17509] = 17144,
  [17510] = 17065,
  [17511] = 17137,
  [17512] = 17150,
  [17513] = 17073,
  [17514] = 17071,
  [17515] = 17066,
  [17516] = 17067,
  [17517] = 17517,
  [17518] = 17137,
  [17519] = 17074,
  [17520] = 17067,
  [17521] = 17067,
  [17522] = 17099,
  [17523] = 17072,
  [17524] = 17092,
  [17525] = 17073,
  [17526] = 17067,
  [17527] = 17099,
  [17528] = 17073,
  [17529] = 17071,
  [17530] = 17066,
  [17531] = 17066,
  [17532] = 17065,
  [17533] = 17111,
  [17534] = 17065,
  [17535] = 17068,
  [17536] = 17069,
  [17537] = 17150,
  [17538] = 17288,
  [17539] = 17067,
  [17540] = 17066,
  [17541] = 17074,
  [17542] = 17067,
  [17543] = 17111,
  [17544] = 17074,
  [17545] = 17065,
  [17546] = 17066,
  [17547] = 17099,
  [17548] = 17072,
  [17549] = 17131,
  [17550] = 17131,
  [17551] = 17066,
  [17552] = 17071,
  [17553] = 17074,
  [17554] = 6787,
  [17555] = 17073,
  [17556] = 17068,
  [17557] = 17074,
  [17558] = 17074,
  [17559] = 17073,
  [17560] = 17069,
  [17561] = 17071,
  [17562] = 17562,
  [17563] = 17131,
  [17564] = 17073,
  [17565] = 17071,
  [17566] = 17065,
  [17567] = 17073,
  [17568] = 17071,
  [17569] = 17074,
  [17570] = 17067,
  [17571] = 17074,
  [17572] = 17073,
  [17573] = 17074,
  [17574] = 17074,
  [17575] = 17071,
  [17576] = 17144,
  [17577] = 17073,
  [17578] = 17071,
  [17579] = 17092,
  [17580] = 17073,
  [17581] = 17073,
  [17582] = 17071,
  [17583] = 17065,
  [17584] = 17071,
  [17585] = 17072,
  [17586] = 17131,
  [17587] = 17071,
  [17588] = 17074,
  [17589] = 17074,
  [17590] = 17066,
  [17591] = 17073,
  [17592] = 17073,
  [17593] = 17067,
  [17594] = 17594,
  [17595] = 17092,
  [17596] = 17074,
  [17597] = 17074,
  [17598] = 17065,
  [17599] = 17065,
  [17600] = 17068,
  [17601] = 17069,
  [17602] = 17137,
  [17603] = 17066,
  [17604] = 17072,
  [17605] = 17073,
  [17606] = 17074,
  [17607] = 17069,
  [17608] = 17073,
  [17609] = 17092,
  [17610] = 17066,
  [17611] = 17066,
  [17612] = 17612,
  [17613] = 17071,
  [17614] = 17065,
  [17615] = 17150,
  [17616] = 17065,
  [17617] = 17068,
  [17618] = 17072,
  [17619] = 17067,
  [17620] = 17067,
  [17621] = 17069,
  [17622] = 17072,
  [17623] = 17131,
  [17624] = 17073,
  [17625] = 17067,
  [17626] = 17066,
  [17627] = 17068,
  [17628] = 17131,
  [17629] = 17144,
  [17630] = 17069,
  [17631] = 17099,
  [17632] = 17074,
  [17633] = 17072,
  [17634] = 17073,
  [17635] = 17131,
  [17636] = 17065,
  [17637] = 17111,
  [17638] = 17065,
  [17639] = 17068,
  [17640] = 17074,
  [17641] = 17069,
  [17642] = 17066,
  [17643] = 17074,
  [17644] = 17072,
  [17645] = 17073,
  [17646] = 17071,
  [17647] = 17066,
  [17648] = 17074,
  [17649] = 17144,
  [17650] = 17150,
  [17651] = 17071,
  [17652] = 6780,
  [17653] = 17073,
  [17654] = 17150,
  [17655] = 17068,
  [17656] = 17074,
  [17657] = 17099,
  [17658] = 17131,
  [17659] = 17073,
  [17660] = 17111,
  [17661] = 17069,
  [17662] = 17067,
  [17663] = 17071,
  [17664] = 17664,
  [17665] = 17074,
  [17666] = 17065,
  [17667] = 17072,
  [17668] = 17131,
  [17669] = 17131,
  [17670] = 17131,
  [17671] = 17131,
  [17672] = 17672,
  [17673] = 17673,
  [17674] = 17674,
  [17675] = 17675,
  [17676] = 17676,
  [17677] = 17675,
  [17678] = 4347,
  [17679] = 17675,
  [17680] = 17680,
  [17681] = 17676,
  [17682] = 4348,
  [17683] = 17675,
  [17684] = 17675,
  [17685] = 17685,
  [17686] = 17674,
  [17687] = 17675,
  [17688] = 17688,
  [17689] = 4245,
  [17690] = 17675,
  [17691] = 17691,
  [17692] = 17675,
  [17693] = 17675,
  [17694] = 17694,
  [17695] = 17676,
  [17696] = 17675,
  [17697] = 17675,
  [17698] = 4350,
  [17699] = 17680,
  [17700] = 17675,
  [17701] = 17675,
  [17702] = 17676,
  [17703] = 17685,
  [17704] = 17675,
  [17705] = 17675,
  [17706] = 17691,
  [17707] = 4351,
  [17708] = 17675,
  [17709] = 17674,
  [17710] = 17675,
  [17711] = 17676,
  [17712] = 17674,
  [17713] = 17675,
  [17714] = 17688,
  [17715] = 17673,
  [17716] = 17675,
  [17717] = 17675,
  [17718] = 17718,
  [17719] = 4353,
  [17720] = 17675,
  [17721] = 17680,
  [17722] = 17675,
  [17723] = 4354,
  [17724] = 17675,
  [17725] = 17725,
  [17726] = 17675,
  [17727] = 4355,
  [17728] = 4356,
  [17729] = 17675,
  [17730] = 17680,
  [17731] = 17680,
  [17732] = 17675,
  [17733] = 17688,
  [17734] = 17675,
  [17735] = 17691,
  [17736] = 17688,
  [17737] = 17675,
  [17738] = 17675,
  [17739] = 17674,
  [17740] = 17675,
  [17741] = 17675,
  [17742] = 17675,
  [17743] = 17676,
  [17744] = 17675,
  [17745] = 17675,
  [17746] = 17673,
  [17747] = 17718,
  [17748] = 17675,
  [17749] = 17725,
  [17750] = 17675,
  [17751] = 17675,
  [17752] = 4369,
  [17753] = 17675,
  [17754] = 17675,
  [17755] = 17675,
  [17756] = 17725,
  [17757] = 17674,
  [17758] = 17680,
  [17759] = 17675,
  [17760] = 17674,
  [17761] = 17673,
  [17762] = 17694,
  [17763] = 17685,
  [17764] = 17674,
  [17765] = 17718,
  [17766] = 17691,
  [17767] = 17674,
  [17768] = 17676,
  [17769] = 17725,
  [17770] = 17674,
  [17771] = 17673,
  [17772] = 17676,
  [17773] = 17694,
  [17774] = 17685,
  [17775] = 17673,
  [17776] = 17673,
  [17777] = 4144,
  [17778] = 17674,
  [17779] = 17718,
  [17780] = 4291,
  [17781] = 17674,
  [17782] = 4293,
  [17783] = 17673,
  [17784] = 17691,
  [17785] = 17673,
  [17786] = 17674,
  [17787] = 17676,
  [17788] = 17676,
  [17789] = 4320,
  [17790] = 4321,
  [17791] = 17691,
  [17792] = 17674,
  [17793] = 17694,
  [17794] = 17685,
  [17795] = 17673,
  [17796] = 17694,
  [17797] = 17685,
  [17798] = 17718,
  [17799] = 17691,
  [17800] = 17725,
  [17801] = 17725,
  [17802] = 17718,
  [17803] = 17694,
  [17804] = 17685,
  [17805] = 17691,
  [17806] = 17680,
  [17807] = 17691,
  [17808] = 17680,
  [17809] = 17688,
  [17810] = 17688,
  [17811] = 17691,
  [17812] = 17694,
  [17813] = 17725,
  [17814] = 17680,
  [17815] = 17725,
  [17816] = 17688,
  [17817] = 17674,
  [17818] = 17676,
  [17819] = 17725,
  [17820] = 17820,
  [17821] = 17725,
  [17822] = 17718,
  [17823] = 17676,
  [17824] = 17680,
  [17825] = 17694,
  [17826] = 17685,
  [17827] = 17674,
  [17828] = 17685,
  [17829] = 17673,
  [17830] = 17691,
  [17831] = 17694,
  [17832] = 17685,
  [17833] = 17718,
  [17834] = 17674,
  [17835] = 17688,
  [17836] = 17676,
  [17837] = 17673,
  [17838] = 17694,
  [17839] = 17685,
  [17840] = 17676,
  [17841] = 17718,
  [17842] = 17676,
  [17843] = 17676,
  [17844] = 17685,
  [17845] = 17725,
  [17846] = 17725,
  [17847] = 17725,
  [17848] = 17691,
  [17849] = 17718,
  [17850] = 17691,
  [17851] = 17691,
  [17852] = 17725,
  [17853] = 17680,
  [17854] = 17680,
  [17855] = 17725,
  [17856] = 17673,
  [17857] = 17680,
  [17858] = 17688,
  [17859] = 17691,
  [17860] = 17691,
  [17861] = 17674,
  [17862] = 17688,
  [17863] = 17688,
  [17864] = 17680,
  [17865] = 17673,
  [17866] = 17718,
  [17867] = 17688,
  [17868] = 17725,
  [17869] = 17691,
  [17870] = 17673,
  [17871] = 17691,
  [17872] = 17691,
  [17873] = 17674,
  [17874] = 17674,
  [17875] = 17673,
  [17876] = 17694,
  [17877] = 17685,
  [17878] = 17691,
  [17879] = 17676,
  [17880] = 17718,
  [17881] = 17680,
  [17882] = 17694,
  [17883] = 17674,
  [17884] = 17680,
  [17885] = 17680,
  [17886] = 17673,
  [17887] = 17685,
  [17888] = 17694,
  [17889] = 17685,
  [17890] = 17688,
  [17891] = 17718,
  [17892] = 17674,
  [17893] = 17718,
  [17894] = 17685,
  [17895] = 17718,
  [17896] = 17688,
  [17897] = 17676,
  [17898] = 17676,
  [17899] = 17691,
  [17900] = 17676,
  [17901] = 4325,
  [17902] = 17688,
  [17903] = 17725,
  [17904] = 17674,
  [17905] = 4483,
  [17906] = 17674,
  [17907] = 17673,
  [17908] = 17694,
  [17909] = 4326,
  [17910] = 17694,
  [17911] = 17694,
  [17912] = 17685,
  [17913] = 17718,
  [17914] = 17691,
  [17915] = 17680,
  [17916] = 17674,
  [17917] = 17676,
  [17918] = 17680,
  [17919] = 17680,
  [17920] = 17688,
  [17921] = 17725,
  [17922] = 17688,
  [17923] = 17691,
  [17924] = 17674,
  [17925] = 17688,
  [17926] = 17674,
  [17927] = 17725,
  [17928] = 17691,
  [17929] = 17676,
  [17930] = 17676,
  [17931] = 17691,
  [17932] = 17676,
  [17933] = 17674,
  [17934] = 17673,
  [17935] = 17694,
  [17936] = 17685,
  [17937] = 17676,
  [17938] = 17674,
  [17939] = 17673,
  [17940] = 17691,
  [17941] = 17691,
  [17942] = 17718,
  [17943] = 17694,
  [17944] = 17691,
  [17945] = 17676,
  [17946] = 17691,
  [17947] = 17694,
  [17948] = 17725,
  [17949] = 17680,
  [17950] = 17680,
  [17951] = 17676,
  [17952] = 17688,
  [17953] = 17688,
  [17954] = 17685,
  [17955] = 17676,
  [17956] = 17675,
  [17957] = 4327,
  [17958] = 17718,
  [17959] = 17674,
  [17960] = 17673,
  [17961] = 17718,
  [17962] = 17691,
  [17963] = 4249,
  [17964] = 17676,
  [17965] = 17674,
  [17966] = 17694,
  [17967] = 17676,
  [17968] = 17685,
  [17969] = 17691,
  [17970] = 17680,
  [17971] = 17691,
  [17972] = 17688,
  [17973] = 17676,
  [17974] = 17725,
  [17975] = 17718,
  [17976] = 17694,
  [17977] = 17676,
  [17978] = 4252,
  [17979] = 17725,
  [17980] = 17691,
  [17981] = 17685,
  [17982] = 17685,
  [17983] = 17675,
  [17984] = 7264,
  [17985] = 17675,
  [17986] = 17674,
  [17987] = 4250,
  [17988] = 17680,
  [17989] = 17691,
  [17990] = 17688,
  [17991] = 17691,
  [17992] = 17688,
  [17993] = 17676,
  [17994] = 17725,
  [17995] = 17674,
  [17996] = 17673,
  [17997] = 17725,
  [17998] = 4302,
  [17999] = 17999,
  [18000] = 17694,
  [18001] = 17685,
  [18002] = 17674,
  [18003] = 17718,
  [18004] = 17691,
  [18005] = 17676,
  [18006] = 17675,
  [18007] = 4105,
  [18008] = 17688,
  [18009] = 17691,
  [18010] = 17676,
  [18011] = 17691,
  [18012] = 17676,
  [18013] = 17680,
  [18014] = 4300,
  [18015] = 4459,
  [18016] = 17674,
  [18017] = 17691,
  [18018] = 17691,
  [18019] = 17680,
  [18020] = 17688,
  [18021] = 4248,
  [18022] = 17673,
  [18023] = 17694,
  [18024] = 4435,
  [18025] = 17685,
  [18026] = 17718,
  [18027] = 17691,
  [18028] = 4301,
  [18029] = 17674,
  [18030] = 17676,
  [18031] = 17691,
  [18032] = 17675,
  [18033] = 17674,
  [18034] = 17673,
  [18035] = 17688,
  [18036] = 17694,
  [18037] = 17685,
  [18038] = 17718,
  [18039] = 17676,
  [18040] = 17673,
  [18041] = 17718,
  [18042] = 4324,
  [18043] = 17676,
  [18044] = 17691,
  [18045] = 17725,
  [18046] = 4338,
  [18047] = 17725,
  [18048] = 18048,
  [18049] = 17674,
  [18050] = 17673,
  [18051] = 17691,
  [18052] = 17691,
  [18053] = 17675,
  [18054] = 4339,
  [18055] = 17676,
  [18056] = 17680,
  [18057] = 17688,
  [18058] = 17694,
  [18059] = 17685,
  [18060] = 17674,
  [18061] = 17725,
  [18062] = 17691,
  [18063] = 17725,
  [18064] = 17674,
  [18065] = 17673,
  [18066] = 17688,
  [18067] = 17674,
  [18068] = 17676,
  [18069] = 17718,
  [18070] = 17694,
  [18071] = 17685,
  [18072] = 4340,
  [18073] = 17718,
  [18074] = 17674,
  [18075] = 4295,
  [18076] = 17676,
  [18077] = 17680,
  [18078] = 17674,
  [18079] = 17675,
  [18080] = 17673,
  [18081] = 4341,
  [18082] = 17691,
  [18083] = 17674,
  [18084] = 17676,
  [18085] = 17688,
  [18086] = 17694,
  [18087] = 17680,
  [18088] = 17674,
  [18089] = 17673,
  [18090] = 17676,
  [18091] = 17694,
  [18092] = 17685,
  [18093] = 17676,
  [18094] = 17685,
  [18095] = 17688,
  [18096] = 4342,
  [18097] = 17674,
  [18098] = 17718,
  [18099] = 17718,
  [18100] = 17673,
  [18101] = 17676,
  [18102] = 4265,
  [18103] = 17680,
  [18104] = 17673,
  [18105] = 17718,
  [18106] = 17680,
  [18107] = 17674,
  [18108] = 17725,
  [18109] = 17675,
  [18110] = 17673,
  [18111] = 17676,
  [18112] = 4308,
  [18113] = 17691,
  [18114] = 17725,
  [18115] = 17691,
  [18116] = 17676,
  [18117] = 17694,
  [18118] = 17685,
  [18119] = 17675,
  [18120] = 17674,
  [18121] = 17691,
  [18122] = 17691,
  [18123] = 17676,
  [18124] = 17725,
  [18125] = 17673,
  [18126] = 17680,
  [18127] = 17688,
  [18128] = 17694,
  [18129] = 17718,
  [18130] = 17694,
  [18131] = 17675,
  [18132] = 17685,
  [18133] = 17685,
  [18134] = 17676,
  [18135] = 17688,
  [18136] = 17685,
  [18137] = 17718,
  [18138] = 4309,
  [18139] = 17691,
  [18140] = 17725,
  [18141] = 17725,
  [18142] = 17691,
  [18143] = 17675,
  [18144] = 17694,
  [18145] = 17691,
  [18146] = 17691,
  [18147] = 17691,
  [18148] = 17674,
  [18149] = 17674,
  [18150] = 18150,
  [18151] = 17680,
  [18152] = 17676,
  [18153] = 17676,
  [18154] = 17688,
  [18155] = 17674,
  [18156] = 17676,
  [18157] = 17680,
  [18158] = 17675,
  [18159] = 4458,
  [18160] = 17680,
  [18161] = 17688,
  [18162] = 17688,
  [18163] = 4344,
  [18164] = 17674,
  [18165] = 5953,
  [18166] = 17673,
  [18167] = 17675,
  [18168] = 17673,
  [18169] = 17676,
  [18170] = 4345,
  [18171] = 17694,
  [18172] = 17674,
  [18173] = 17691,
  [18174] = 17675,
  [18175] = 17673,
  [18176] = 17694,
  [18177] = 17685,
  [18178] = 17725,
  [18179] = 17694,
  [18180] = 17725,
  [18181] = 17685,
  [18182] = 6237,
  [18183] = 17718,
  [18184] = 17674,
  [18185] = 17685,
  [18186] = 17675,
  [18187] = 17718,
  [18188] = 4346,
  [18189] = 17674,
  [18190] = 17691,
  [18191] = 17691,
  [18192] = 17718,
  [18193] = 17675,
  [18194] = 17676,
  [18195] = 17676,
  [18196] = 17680,
  [18197] = 17680,
  [18198] = 17675,
  [18199] = 17688,
  [18200] = 17691,
  [18201] = 17676,
  [18202] = 17675,
  [18203] = 17718,
  [18204] = 17674,
  [18205] = 17725,
  [18206] = 17694,
  [18207] = 17685,
  [18208] = 17718,
  [18209] = 17688,
  [18210] = 17725,
  [18211] = 17675,
  [18212] = 17676,
  [18213] = 4322,
  [18214] = 17676,
  [18215] = 17718,
  [18216] = 17675,
  [18217] = 17676,
  [18218] = 17674,
  [18219] = 17676,
  [18220] = 17675,
  [18221] = 17676,
  [18222] = 17674,
  [18223] = 17673,
  [18224] = 17691,
  [18225] = 17674,
  [18226] = 17694,
  [18227] = 17674,
  [18228] = 17691,
  [18229] = 18229,
  [18230] = 18230,
  [18231] = 18231,
  [18232] = 18232,
  [18233] = 18233,
  [18234] = 7724,
  [18235] = 18235,
  [18236] = 18236,
  [18237] = 18237,
  [18238] = 18238,
  [18239] = 18239,
  [18240] = 18240,
  [18241] = 18241,
  [18242] = 18230,
  [18243] = 18229,
  [18244] = 18232,
  [18245] = 18245,
  [18246] = 18246,
  [18247] = 18229,
  [18248] = 18245,
  [18249] = 18249,
  [18250] = 18250,
  [18251] = 18230,
  [18252] = 18240,
  [18253] = 18253,
  [18254] = 18254,
  [18255] = 18241,
  [18256] = 18256,
  [18257] = 18257,
  [18258] = 18258,
  [18259] = 18246,
  [18260] = 18239,
  [18261] = 18232,
  [18262] = 18236,
  [18263] = 18238,
  [18264] = 18257,
  [18265] = 18265,
  [18266] = 18233,
  [18267] = 18231,
  [18268] = 18268,
  [18269] = 18236,
  [18270] = 18254,
  [18271] = 18241,
  [18272] = 18230,
  [18273] = 18273,
  [18274] = 18274,
  [18275] = 18275,
  [18276] = 18229,
  [18277] = 18230,
  [18278] = 18273,
  [18279] = 18279,
  [18280] = 18280,
  [18281] = 18281,
  [18282] = 18281,
  [18283] = 18229,
  [18284] = 18284,
  [18285] = 18245,
  [18286] = 18286,
  [18287] = 18257,
  [18288] = 18245,
  [18289] = 18241,
  [18290] = 18290,
  [18291] = 18250,
  [18292] = 18257,
  [18293] = 18250,
  [18294] = 18229,
  [18295] = 18245,
  [18296] = 18240,
  [18297] = 18290,
  [18298] = 18298,
  [18299] = 18280,
  [18300] = 18300,
  [18301] = 18250,
  [18302] = 18302,
  [18303] = 18303,
  [18304] = 18240,
  [18305] = 18279,
  [18306] = 18306,
  [18307] = 18307,
  [18308] = 18308,
  [18309] = 18257,
  [18310] = 18241,
  [18311] = 18280,
  [18312] = 18273,
  [18313] = 18230,
  [18314] = 18268,
  [18315] = 18315,
  [18316] = 18231,
  [18317] = 18250,
  [18318] = 18229,
  [18319] = 18307,
  [18320] = 18231,
  [18321] = 18321,
  [18322] = 18322,
  [18323] = 18250,
  [18324] = 18324,
  [18325] = 18298,
  [18326] = 18324,
  [18327] = 18230,
  [18328] = 18258,
  [18329] = 18329,
  [18330] = 18330,
  [18331] = 18303,
  [18332] = 18250,
  [18333] = 18258,
  [18334] = 18334,
  [18335] = 18230,
  [18336] = 18229,
  [18337] = 18245,
  [18338] = 18303,
  [18339] = 18237,
  [18340] = 18302,
  [18341] = 18237,
  [18342] = 18237,
  [18343] = 18240,
  [18344] = 18300,
  [18345] = 18250,
  [18346] = 18233,
  [18347] = 18274,
  [18348] = 18231,
  [18349] = 18281,
  [18350] = 18329,
  [18351] = 18306,
  [18352] = 18230,
  [18353] = 18322,
  [18354] = 18280,
  [18355] = 18250,
  [18356] = 18250,
  [18357] = 18330,
  [18358] = 18358,
  [18359] = 18280,
  [18360] = 18302,
  [18361] = 18274,
  [18362] = 18280,
  [18363] = 18240,
  [18364] = 18229,
  [18365] = 18257,
  [18366] = 18231,
  [18367] = 18324,
  [18368] = 18258,
  [18369] = 18369,
  [18370] = 18280,
  [18371] = 18229,
  [18372] = 18253,
  [18373] = 18245,
  [18374] = 18265,
  [18375] = 18334,
  [18376] = 18241,
  [18377] = 18377,
  [18378] = 18237,
  [18379] = 18233,
  [18380] = 18257,
  [18381] = 18279,
  [18382] = 4179,
  [18383] = 18231,
  [18384] = 18240,
  [18385] = 18385,
  [18386] = 18377,
  [18387] = 18268,
  [18388] = 18315,
  [18389] = 18258,
  [18390] = 18231,
  [18391] = 18302,
  [18392] = 18392,
  [18393] = 18274,
  [18394] = 18321,
  [18395] = 18231,
  [18396] = 18273,
  [18397] = 18280,
  [18398] = 18250,
  [18399] = 18290,
  [18400] = 18377,
  [18401] = 18240,
  [18402] = 18233,
  [18403] = 18246,
  [18404] = 18253,
  [18405] = 18306,
  [18406] = 18257,
  [18407] = 18300,
  [18408] = 18249,
  [18409] = 18306,
  [18410] = 18274,
  [18411] = 18258,
  [18412] = 18240,
  [18413] = 18413,
  [18414] = 18233,
  [18415] = 18233,
  [18416] = 18241,
  [18417] = 18230,
  [18418] = 18329,
  [18419] = 18245,
  [18420] = 18274,
  [18421] = 18258,
  [18422] = 18235,
  [18423] = 18324,
  [18424] = 18231,
  [18425] = 18229,
  [18426] = 18265,
  [18427] = 18258,
  [18428] = 18273,
  [18429] = 18324,
  [18430] = 18233,
  [18431] = 18229,
  [18432] = 18246,
  [18433] = 18245,
  [18434] = 18258,
  [18435] = 18258,
  [18436] = 18253,
  [18437] = 18250,
  [18438] = 18322,
  [18439] = 18330,
  [18440] = 18245,
  [18441] = 18239,
  [18442] = 18329,
  [18443] = 18237,
  [18444] = 18241,
  [18445] = 18250,
  [18446] = 18369,
  [18447] = 18257,
  [18448] = 18385,
  [18449] = 18257,
  [18450] = 18237,
  [18451] = 18237,
  [18452] = 18324,
  [18453] = 18369,
  [18454] = 18334,
  [18455] = 18240,
  [18456] = 18265,
  [18457] = 18385,
  [18458] = 18233,
  [18459] = 18268,
  [18460] = 18315,
  [18461] = 18281,
  [18462] = 18275,
  [18463] = 18233,
  [18464] = 18240,
  [18465] = 18250,
  [18466] = 18232,
  [18467] = 18307,
  [18468] = 18250,
  [18469] = 18231,
  [18470] = 18231,
  [18471] = 18274,
  [18472] = 18233,
  [18473] = 18298,
  [18474] = 18324,
  [18475] = 18246,
  [18476] = 18238,
  [18477] = 18392,
  [18478] = 18258,
  [18479] = 18281,
  [18480] = 18250,
  [18481] = 18258,
  [18482] = 18240,
  [18483] = 4182,
  [18484] = 18286,
  [18485] = 18241,
  [18486] = 18230,
  [18487] = 18487,
  [18488] = 18268,
  [18489] = 18315,
  [18490] = 18241,
  [18491] = 18290,
  [18492] = 18492,
  [18493] = 18330,
  [18494] = 18250,
  [18495] = 18280,
  [18496] = 18257,
  [18497] = 18246,
  [18498] = 18246,
  [18499] = 18229,
  [18500] = 18231,
  [18501] = 18245,
  [18502] = 18303,
  [18503] = 18315,
  [18504] = 18275,
  [18505] = 18240,
  [18506] = 18377,
  [18507] = 18413,
  [18508] = 18233,
  [18509] = 18241,
  [18510] = 18253,
  [18511] = 18511,
  [18512] = 18231,
  [18513] = 18257,
  [18514] = 18324,
  [18515] = 18308,
  [18516] = 18268,
  [18517] = 18315,
  [18518] = 18258,
  [18519] = 18280,
  [18520] = 18280,
  [18521] = 18241,
  [18522] = 18358,
  [18523] = 18307,
  [18524] = 18302,
  [18525] = 18237,
  [18526] = 18268,
  [18527] = 18315,
  [18528] = 18487,
  [18529] = 18231,
  [18530] = 18230,
  [18531] = 18240,
  [18532] = 18233,
  [18533] = 18280,
  [18534] = 18236,
  [18535] = 18250,
  [18536] = 18268,
  [18537] = 18315,
  [18538] = 18250,
  [18539] = 18238,
  [18540] = 18233,
  [18541] = 18239,
  [18542] = 18300,
  [18543] = 18268,
  [18544] = 18315,
  [18545] = 18286,
  [18546] = 18302,
  [18547] = 18306,
  [18548] = 18237,
  [18549] = 18268,
  [18550] = 18315,
  [18551] = 18322,
  [18552] = 18280,
  [18553] = 18237,
  [18554] = 18324,
  [18555] = 18268,
  [18556] = 18315,
  [18557] = 18557,
  [18558] = 18258,
  [18559] = 18330,
  [18560] = 18254,
  [18561] = 18561,
  [18562] = 18235,
  [18563] = 18250,
  [18564] = 18329,
  [18565] = 18240,
  [18566] = 18566,
  [18567] = 18256,
  [18568] = 18231,
  [18569] = 18324,
  [18570] = 18280,
  [18571] = 18258,
  [18572] = 18230,
  [18573] = 18274,
  [18574] = 18274,
  [18575] = 18330,
  [18576] = 18231,
  [18577] = 18324,
  [18578] = 18231,
  [18579] = 18258,
  [18580] = 18237,
  [18581] = 18284,
  [18582] = 18369,
  [18583] = 18240,
  [18584] = 18237,
  [18585] = 18265,
  [18586] = 18385,
  [18587] = 18302,
  [18588] = 18237,
  [18589] = 18237,
  [18590] = 18250,
  [18591] = 18237,
  [18592] = 4180,
  [18593] = 18233,
  [18594] = 18240,
  [18595] = 18284,
  [18596] = 18229,
  [18597] = 18557,
  [18598] = 18229,
  [18599] = 18231,
  [18600] = 18245,
  [18601] = 18566,
  [18602] = 18279,
  [18603] = 18231,
  [18604] = 18334,
  [18605] = 18324,
  [18606] = 18258,
  [18607] = 18307,
  [18608] = 18274,
  [18609] = 18324,
  [18610] = 18240,
  [18611] = 18275,
  [18612] = 18275,
  [18613] = 18274,
  [18614] = 18241,
  [18615] = 18237,
  [18616] = 18230,
  [18617] = 18290,
  [18618] = 18240,
  [18619] = 18258,
  [18620] = 18229,
  [18621] = 18298,
  [18622] = 18233,
  [18623] = 18229,
  [18624] = 18279,
  [18625] = 18245,
  [18626] = 18230,
  [18627] = 18240,
  [18628] = 18273,
  [18629] = 18241,
  [18630] = 18300,
  [18631] = 4173,
  [18632] = 18245,
  [18633] = 18265,
  [18634] = 18230,
  [18635] = 18302,
  [18636] = 18413,
  [18637] = 18306,
  [18638] = 18257,
  [18639] = 18229,
  [18640] = 18245,
  [18641] = 18233,
  [18642] = 18258,
  [18643] = 18238,
  [18644] = 18413,
  [18645] = 18274,
  [18646] = 18229,
  [18647] = 18241,
  [18648] = 18245,
  [18649] = 18257,
  [18650] = 18280,
  [18651] = 18324,
  [18652] = 18240,
  [18653] = 18241,
  [18654] = 18392,
  [18655] = 18240,
  [18656] = 18230,
  [18657] = 18237,
  [18658] = 18281,
  [18659] = 18302,
  [18660] = 18303,
  [18661] = 18230,
  [18662] = 18257,
  [18663] = 18257,
  [18664] = 18324,
  [18665] = 18246,
  [18666] = 18265,
  [18667] = 18241,
  [18668] = 18274,
  [18669] = 18230,
  [18670] = 18240,
  [18671] = 18280,
  [18672] = 18257,
  [18673] = 18253,
  [18674] = 18265,
  [18675] = 18239,
  [18676] = 18232,
  [18677] = 18236,
  [18678] = 18238,
  [18679] = 18245,
  [18680] = 18254,
  [18681] = 18557,
  [18682] = 18249,
  [18683] = 18273,
  [18684] = 18377,
  [18685] = 18281,
  [18686] = 18250,
  [18687] = 18245,
  [18688] = 18235,
  [18689] = 18290,
  [18690] = 18298,
  [18691] = 18233,
  [18692] = 18303,
  [18693] = 18233,
  [18694] = 18303,
  [18695] = 18253,
  [18696] = 18322,
  [18697] = 18413,
  [18698] = 18258,
  [18699] = 18250,
  [18700] = 18330,
  [18701] = 18280,
  [18702] = 18229,
  [18703] = 18566,
  [18704] = 18290,
  [18705] = 18230,
  [18706] = 18308,
  [18707] = 18258,
  [18708] = 18298,
  [18709] = 18233,
  [18710] = 18250,
  [18711] = 18230,
  [18712] = 18274,
  [18713] = 18358,
  [18714] = 18303,
  [18715] = 18377,
  [18716] = 18250,
  [18717] = 18229,
  [18718] = 18245,
  [18719] = 18274,
  [18720] = 18231,
  [18721] = 18258,
  [18722] = 18241,
  [18723] = 18308,
  [18724] = 18238,
  [18725] = 18250,
  [18726] = 18237,
  [18727] = 18237,
  [18728] = 18230,
  [18729] = 18250,
  [18730] = 18253,
  [18731] = 18240,
  [18732] = 18557,
  [18733] = 18256,
  [18734] = 18302,
  [18735] = 18235,
  [18736] = 18257,
  [18737] = 18280,
  [18738] = 18231,
  [18739] = 18240,
  [18740] = 18286,
  [18741] = 18274,
  [18742] = 18302,
  [18743] = 18280,
  [18744] = 18566,
  [18745] = 18258,
  [18746] = 18245,
  [18747] = 18240,
  [18748] = 18302,
  [18749] = 18246,
  [18750] = 18324,
  [18751] = 18273,
  [18752] = 18233,
  [18753] = 18274,
  [18754] = 18250,
  [18755] = 18280,
  [18756] = 18281,
  [18757] = 18300,
  [18758] = 4181,
  [18759] = 18358,
  [18760] = 18306,
  [18761] = 18322,
  [18762] = 18330,
  [18763] = 18233,
  [18764] = 18329,
  [18765] = 18233,
  [18766] = 18280,
  [18767] = 18253,
  [18768] = 18232,
  [18769] = 18280,
  [18770] = 18233,
  [18771] = 18369,
  [18772] = 18302,
  [18773] = 18329,
  [18774] = 18280,
  [18775] = 18385,
  [18776] = 18258,
  [18777] = 18237,
  [18778] = 18231,
  [18779] = 18245,
  [18780] = 18265,
  [18781] = 18258,
  [18782] = 18239,
  [18783] = 18280,
  [18784] = 18265,
  [18785] = 18240,
  [18786] = 18235,
  [18787] = 18230,
  [18788] = 18237,
  [18789] = 18237,
  [18790] = 18280,
  [18791] = 18250,
  [18792] = 18233,
  [18793] = 18511,
  [18794] = 18229,
  [18795] = 18280,
  [18796] = 18280,
  [18797] = 18280,
  [18798] = 18280,
  [18799] = 18280,
  [18800] = 18280,
  [18801] = 18280,
  [18802] = 18245,
  [18803] = 18280,
  [18804] = 18308,
  [18805] = 18280,
  [18806] = 18280,
  [18807] = 18280,
  [18808] = 18280,
  [18809] = 18358,
  [18810] = 18286,
  [18811] = 18241,
  [18812] = 18245,
  [18813] = 18230,
  [18814] = 18302,
  [18815] = 18308,
  [18816] = 18358,
  [18817] = 18257,
  [18818] = 18302,
  [18819] = 18236,
  [18820] = 18302,
  [18821] = 18240,
  [18822] = 18280,
  [18823] = 18256,
  [18824] = 18369,
  [18825] = 18230,
  [18826] = 18392,
  [18827] = 18240,
  [18828] = 18229,
  [18829] = 18229,
  [18830] = 18240,
  [18831] = 18245,
  [18832] = 18233,
  [18833] = 18487,
  [18834] = 18230,
  [18835] = 18231,
  [18836] = 18324,
  [18837] = 18258,
  [18838] = 18385,
  [18839] = 18241,
  [18840] = 18241,
  [18841] = 18566,
  [18842] = 18257,
  [18843] = 18275,
  [18844] = 18250,
  [18845] = 18334,
  [18846] = 18237,
  [18847] = 18229,
  [18848] = 18286,
  [18849] = 18237,
  [18850] = 18257,
  [18851] = 18250,
  [18852] = 18274,
  [18853] = 18257,
  [18854] = 18245,
  [18855] = 18302,
  [18856] = 18274,
  [18857] = 18250,
  [18858] = 18307,
  [18859] = 18274,
  [18860] = 18280,
  [18861] = 18308,
  [18862] = 18240,
  [18863] = 18265,
  [18864] = 18377,
  [18865] = 18233,
  [18866] = 18231,
  [18867] = 18258,
  [18868] = 18229,
  [18869] = 18280,
  [18870] = 18487,
  [18871] = 18324,
  [18872] = 18237,
  [18873] = 18240,
  [18874] = 18265,
  [18875] = 18308,
  [18876] = 18245,
  [18877] = 18280,
  [18878] = 18268,
  [18879] = 18315,
  [18880] = 18233,
  [18881] = 18232,
  [18882] = 18239,
  [18883] = 18236,
  [18884] = 18302,
  [18885] = 18238,
  [18886] = 18286,
  [18887] = 18241,
  [18888] = 18284,
  [18889] = 18230,
  [18890] = 18392,
  [18891] = 18254,
  [18892] = 18233,
  [18893] = 18280,
  [18894] = 18241,
  [18895] = 18358,
  [18896] = 18235,
  [18897] = 18257,
  [18898] = 18229,
  [18899] = 18249,
  [18900] = 18230,
  [18901] = 18231,
  [18902] = 18235,
  [18903] = 18229,
  [18904] = 18302,
  [18905] = 18240,
  [18906] = 18487,
  [18907] = 18324,
  [18908] = 18240,
  [18909] = 18258,
  [18910] = 18229,
  [18911] = 18229,
  [18912] = 18229,
  [18913] = 18230,
  [18914] = 18245,
  [18915] = 18273,
  [18916] = 18229,
  [18917] = 18245,
  [18918] = 18240,
  [18919] = 18240,
  [18920] = 18231,
  [18921] = 18274,
  [18922] = 18324,
  [18923] = 18231,
  [18924] = 18258,
  [18925] = 18358,
  [18926] = 18298,
  [18927] = 18241,
  [18928] = 18231,
  [18929] = 18257,
  [18930] = 18241,
  [18931] = 18557,
  [18932] = 18557,
  [18933] = 18324,
  [18934] = 18256,
  [18935] = 18321,
  [18936] = 18241,
  [18937] = 18236,
  [18938] = 18258,
  [18939] = 18250,
  [18940] = 18302,
  [18941] = 18250,
  [18942] = 18237,
  [18943] = 18230,
  [18944] = 18230,
  [18945] = 18257,
  [18946] = 18230,
  [18947] = 18256,
  [18948] = 18254,
  [18949] = 18240,
  [18950] = 18233,
  [18951] = 18245,
  [18952] = 18231,
  [18953] = 18280,
  [18954] = 18245,
  [18955] = 18233,
  [18956] = 18245,
  [18957] = 18229,
  [18958] = 18231,
  [18959] = 18258,
  [18960] = 18245,
  [18961] = 18273,
  [18962] = 18230,
  [18963] = 18566,
  [18964] = 18232,
  [18965] = 18257,
  [18966] = 18240,
  [18967] = 4184,
  [18968] = 18281,
  [18969] = 18237,
  [18970] = 18324,
  [18971] = 18307,
  [18972] = 18369,
  [18973] = 18286,
  [18974] = 18256,
  [18975] = 18239,
  [18976] = 18250,
  [18977] = 18249,
  [18978] = 18303,
  [18979] = 18241,
  [18980] = 18233,
  [18981] = 18290,
  [18982] = 18280,
  [18983] = 18229,
  [18984] = 18237,
  [18985] = 18245,
  [18986] = 18298,
  [18987] = 18302,
  [18988] = 4183,
  [18989] = 18275,
  [18990] = 18233,
  [18991] = 18377,
  [18992] = 18229,
  [18993] = 18993,
  [18994] = 18561,
  [18995] = 18258,
  [18996] = 18257,
  [18997] = 18235,
  [18998] = 18303,
  [18999] = 18229,
  [19000] = 18413,
  [19001] = 18245,
  [19002] = 18377,
  [19003] = 18232,
  [19004] = 18233,
  [19005] = 18321,
  [19006] = 18241,
  [19007] = 18233,
  [19008] = 18233,
  [19009] = 18240,
  [19010] = 18557,
  [19011] = 18240,
  [19012] = 18250,
  [19013] = 18274,
  [19014] = 18275,
  [19015] = 18245,
  [19016] = 18302,
  [19017] = 18487,
  [19018] = 18290,
  [19019] = 18240,
  [19020] = 18280,
  [19021] = 18487,
  [19022] = 18250,
  [19023] = 18241,
  [19024] = 18230,
  [19025] = 18237,
  [19026] = 18334,
  [19027] = 18230,
  [19028] = 18229,
  [19029] = 18265,
  [19030] = 18245,
  [19031] = 18257,
  [19032] = 18257,
  [19033] = 18237,
  [19034] = 18233,
  [19035] = 18413,
  [19036] = 18561,
  [19037] = 18241,
  [19038] = 18231,
  [19039] = 18257,
  [19040] = 18275,
  [19041] = 18324,
  [19042] = 18286,
  [19043] = 18240,
  [19044] = 18241,
  [19045] = 18249,
  [19046] = 18385,
  [19047] = 18233,
  [19048] = 18280,
  [19049] = 18250,
  [19050] = 18240,
  [19051] = 18258,
  [19052] = 18273,
  [19053] = 18258,
  [19054] = 18240,
  [19055] = 18232,
  [19056] = 18284,
  [19057] = 18241,
  [19058] = 18369,
  [19059] = 18237,
  [19060] = 18230,
  [19061] = 18322,
  [19062] = 18557,
  [19063] = 18566,
  [19064] = 18324,
  [19065] = 18307,
  [19066] = 18258,
  [19067] = 4175,
  [19068] = 18231,
  [19069] = 18324,
  [19070] = 18237,
  [19071] = 18230,
  [19072] = 18280,
  [19073] = 18324,
  [19074] = 18377,
  [19075] = 18229,
  [19076] = 18561,
  [19077] = 18258,
  [19078] = 18230,
  [19079] = 18240,
  [19080] = 18229,
  [19081] = 18245,
  [19082] = 18256,
  [19083] = 18231,
  [19084] = 18258,
  [19085] = 18257,
  [19086] = 18237,
  [19087] = 18241,
  [19088] = 18230,
  [19089] = 18237,
  [19090] = 18257,
  [19091] = 18235,
  [19092] = 18245,
  [19093] = 18237,
  [19094] = 18233,
  [19095] = 18413,
  [19096] = 18237,
  [19097] = 18257,
  [19098] = 18229,
  [19099] = 18241,
  [19100] = 18274,
  [19101] = 18240,
  [19102] = 18241,
  [19103] = 18561,
  [19104] = 18290,
  [19105] = 18257,
  [19106] = 18257,
  [19107] = 18487,
  [19108] = 18245,
  [19109] = 18392,
  [19110] = 18286,
  [19111] = 18265,
  [19112] = 18240,
  [19113] = 18250,
  [19114] = 18236,
  [19115] = 18230,
  [19116] = 18233,
  [19117] = 18392,
  [19118] = 18281,
  [19119] = 18487,
  [19120] = 18236,
  [19121] = 18302,
  [19122] = 18241,
  [19123] = 18233,
  [19124] = 18284,
  [19125] = 18241,
  [19126] = 18274,
  [19127] = 18284,
  [19128] = 18229,
  [19129] = 18561,
  [19130] = 18237,
  [19131] = 18557,
  [19132] = 18257,
  [19133] = 18306,
  [19134] = 18557,
  [19135] = 18561,
  [19136] = 18245,
  [19137] = 18279,
  [19138] = 18240,
  [19139] = 18274,
  [19140] = 18561,
  [19141] = 18566,
  [19142] = 18256,
  [19143] = 18561,
  [19144] = 18334,
  [19145] = 18274,
  [19146] = 18561,
  [19147] = 18238,
  [19148] = 18274,
  [19149] = 18561,
  [19150] = 18280,
  [19151] = 18229,
  [19152] = 18245,
  [19153] = 18280,
  [19154] = 18230,
  [19155] = 18300,
  [19156] = 18306,
  [19157] = 18229,
  [19158] = 18245,
  [19159] = 18235,
  [19160] = 18307,
  [19161] = 18274,
  [19162] = 18298,
  [19163] = 18231,
  [19164] = 18231,
  [19165] = 18324,
  [19166] = 18258,
  [19167] = 18322,
  [19168] = 18233,
  [19169] = 18254,
  [19170] = 18237,
  [19171] = 18230,
  [19172] = 18241,
  [19173] = 18284,
  [19174] = 18257,
  [19175] = 18257,
  [19176] = 18245,
  [19177] = 18330,
  [19178] = 18392,
  [19179] = 19179,
  [19180] = 18329,
  [19181] = 18557,
  [19182] = 18369,
  [19183] = 18280,
  [19184] = 18385,
  [19185] = 18280,
  [19186] = 18241,
  [19187] = 18240,
  [19188] = 18241,
  [19189] = 18250,
  [19190] = 18265,
  [19191] = 18250,
  [19192] = 18258,
  [19193] = 18240,
  [19194] = 18280,
  [19195] = 18257,
  [19196] = 18250,
  [19197] = 18233,
  [19198] = 18487,
  [19199] = 18230,
  [19200] = 18413,
  [19201] = 18280,
  [19202] = 18279,
  [19203] = 18274,
  [19204] = 18240,
  [19205] = 18392,
  [19206] = 18233,
  [19207] = 18511,
  [19208] = 18250,
  [19209] = 18240,
  [19210] = 18308,
  [19211] = 18566,
  [19212] = 18358,
  [19213] = 18302,
  [19214] = 18334,
  [19215] = 18334,
  [19216] = 18233,
  [19217] = 18246,
  [19218] = 18253,
  [19219] = 18302,
  [19220] = 18239,
  [19221] = 18232,
  [19222] = 18236,
  [19223] = 18238,
  [19224] = 18231,
  [19225] = 18254,
  [19226] = 18235,
  [19227] = 18258,
  [19228] = 18273,
  [19229] = 18324,
  [19230] = 18281,
  [19231] = 18237,
  [19232] = 18284,
  [19233] = 18257,
  [19234] = 18290,
  [19235] = 18298,
  [19236] = 18230,
  [19237] = 18303,
  [19238] = 18241,
  [19239] = 18280,
  [19240] = 18237,
  [19241] = 18229,
  [19242] = 18245,
  [19243] = 18302,
  [19244] = 18300,
  [19245] = 18230,
  [19246] = 18279,
  [19247] = 18229,
  [19248] = 18245,
  [19249] = 18302,
  [19250] = 18265,
  [19251] = 18229,
  [19252] = 18245,
  [19253] = 18257,
  [19254] = 18307,
  [19255] = 18274,
  [19256] = 18241,
  [19257] = 18258,
  [19258] = 18257,
  [19259] = 18249,
  [19260] = 18240,
  [19261] = 18298,
  [19262] = 18245,
  [19263] = 18257,
  [19264] = 18240,
  [19265] = 18239,
  [19266] = 18300,
  [19267] = 18256,
  [19268] = 18229,
  [19269] = 18249,
  [19270] = 18230,
  [19271] = 18233,
  [19272] = 18566,
  [19273] = 18241,
  [19274] = 18306,
  [19275] = 18250,
  [19276] = 18233,
  [19277] = 18230,
  [19278] = 18257,
  [19279] = 18240,
  [19280] = 18290,
  [19281] = 18250,
  [19282] = 18300,
  [19283] = 18306,
  [19284] = 18322,
  [19285] = 18330,
  [19286] = 18413,
  [19287] = 18329,
  [19288] = 18246,
  [19289] = 18369,
  [19290] = 18385,
  [19291] = 18298,
  [19292] = 18235,
  [19293] = 18240,
  [19294] = 18257,
  [19295] = 18250,
  [19296] = 18237,
  [19297] = 18253,
  [19298] = 18322,
  [19299] = 18250,
  [19300] = 18308,
  [19301] = 18358,
  [19302] = 18330,
  [19303] = 18307,
  [19304] = 18237,
  [19305] = 18280,
  [19306] = 18334,
  [19307] = 18230,
  [19308] = 18240,
  [19309] = 18280,
  [19310] = 18329,
  [19311] = 18245,
  [19312] = 18302,
  [19313] = 18230,
  [19314] = 18302,
  [19315] = 18231,
  [19316] = 18241,
  [19317] = 18250,
  [19318] = 18230,
  [19319] = 18240,
  [19320] = 18280,
  [19321] = 18280,
  [19322] = 18229,
  [19323] = 18245,
  [19324] = 18265,
  [19325] = 18231,
  [19326] = 18245,
  [19327] = 18274,
  [19328] = 18324,
  [19329] = 18286,
  [19330] = 18324,
  [19331] = 18280,
  [19332] = 18230,
  [19333] = 18241,
  [19334] = 18258,
  [19335] = 18257,
  [19336] = 18265,
  [19337] = 18241,
  [19338] = 18257,
  [19339] = 18274,
  [19340] = 4171,
  [19341] = 18235,
  [19342] = 18258,
  [19343] = 18369,
  [19344] = 18385,
  [19345] = 18239,
  [19346] = 18250,
  [19347] = 18231,
  [19348] = 18250,
  [19349] = 18237,
  [19350] = 18235,
  [19351] = 18281,
  [19352] = 18230,
  [19353] = 18229,
  [19354] = 18245,
  [19355] = 18392,
  [19356] = 18280,
  [19357] = 18233,
  [19358] = 18274,
  [19359] = 18258,
  [19360] = 18241,
  [19361] = 18231,
  [19362] = 18258,
  [19363] = 18324,
  [19364] = 18230,
  [19365] = 18231,
  [19366] = 18258,
  [19367] = 18237,
  [19368] = 18237,
  [19369] = 18229,
  [19370] = 18257,
  [19371] = 18237,
  [19372] = 18237,
  [19373] = 18229,
  [19374] = 18257,
  [19375] = 18257,
  [19376] = 18300,
  [19377] = 18245,
  [19378] = 18274,
  [19379] = 18306,
  [19380] = 18302,
  [19381] = 18245,
  [19382] = 18334,
  [19383] = 18240,
  [19384] = 18280,
  [19385] = 18233,
  [19386] = 18229,
  [19387] = 18241,
  [19388] = 18284,
  [19389] = 18257,
  [19390] = 18280,
  [19391] = 18566,
  [19392] = 18233,
  [19393] = 18237,
  [19394] = 18324,
  [19395] = 18229,
  [19396] = 18238,
  [19397] = 18256,
  [19398] = 18392,
  [19399] = 18231,
  [19400] = 18240,
  [19401] = 18235,
  [19402] = 18258,
  [19403] = 18230,
  [19404] = 18231,
  [19405] = 18324,
  [19406] = 18249,
  [19407] = 18241,
  [19408] = 18233,
  [19409] = 18240,
  [19410] = 18258,
  [19411] = 18279,
  [19412] = 18241,
  [19413] = 18240,
  [19414] = 18307,
  [19415] = 18250,
  [19416] = 18257,
  [19417] = 18229,
  [19418] = 18231,
  [19419] = 18233,
  [19420] = 18233,
  [19421] = 18324,
  [19422] = 18246,
  [19423] = 18245,
  [19424] = 18250,
  [19425] = 18235,
  [19426] = 18258,
  [19427] = 18561,
  [19428] = 18324,
  [19429] = 18258,
  [19430] = 18237,
  [19431] = 18329,
  [19432] = 18229,
  [19433] = 18249,
  [19434] = 18230,
  [19435] = 18240,
  [19436] = 18237,
  [19437] = 18324,
  [19438] = 18230,
  [19439] = 18245,
  [19440] = 4174,
  [19441] = 18229,
  [19442] = 18253,
  [19443] = 18245,
  [19444] = 18241,
  [19445] = 18258,
  [19446] = 18236,
  [19447] = 18322,
  [19448] = 18241,
  [19449] = 18233,
  [19450] = 18257,
  [19451] = 18235,
  [19452] = 18238,
  [19453] = 18229,
  [19454] = 18275,
  [19455] = 18330,
  [19456] = 18250,
  [19457] = 18245,
  [19458] = 18233,
  [19459] = 18230,
  [19460] = 18231,
  [19461] = 18231,
  [19462] = 18275,
  [19463] = 18241,
  [19464] = 18377,
  [19465] = 18324,
  [19466] = 18280,
  [19467] = 18250,
  [19468] = 18329,
  [19469] = 18250,
  [19470] = 18413,
  [19471] = 18274,
  [19472] = 18231,
  [19473] = 18258,
  [19474] = 18369,
  [19475] = 18274,
  [19476] = 18250,
  [19477] = 18237,
  [19478] = 18235,
  [19479] = 18385,
  [19480] = 18257,
  [19481] = 18487,
  [19482] = 18230,
  [19483] = 18286,
  [19484] = 18302,
  [19485] = 18557,
  [19486] = 18566,
  [19487] = 18256,
  [19488] = 18334,
  [19489] = 18302,
  [19490] = 18230,
  [19491] = 19491,
  [19492] = 18245,
  [19493] = 18392,
  [19494] = 18303,
  [19495] = 18279,
  [19496] = 18257,
  [19497] = 18240,
  [19498] = 18250,
  [19499] = 18254,
  [19500] = 18237,
  [19501] = 18229,
  [19502] = 18245,
  [19503] = 18250,
  [19504] = 18233,
  [19505] = 18235,
  [19506] = 18280,
  [19507] = 18240,
  [19508] = 18231,
  [19509] = 18511,
  [19510] = 18241,
  [19511] = 18302,
  [19512] = 18280,
  [19513] = 18240,
  [19514] = 18233,
  [19515] = 18308,
  [19516] = 18257,
  [19517] = 18257,
  [19518] = 18254,
  [19519] = 18229,
  [19520] = 18235,
  [19521] = 18274,
  [19522] = 18237,
  [19523] = 18230,
  [19524] = 18258,
  [19525] = 18280,
  [19526] = 18233,
  [19527] = 18229,
  [19528] = 18245,
  [19529] = 18300,
  [19530] = 18274,
  [19531] = 18231,
  [19532] = 18324,
  [19533] = 18258,
  [19534] = 18232,
  [19535] = 18249,
  [19536] = 18358,
  [19537] = 18237,
  [19538] = 18250,
  [19539] = 18241,
  [19540] = 18258,
  [19541] = 18241,
  [19542] = 18257,
  [19543] = 18233,
  [19544] = 18235,
  [19545] = 18233,
  [19546] = 18385,
  [19547] = 18275,
  [19548] = 18229,
  [19549] = 18245,
  [19550] = 18245,
  [19551] = 18302,
  [19552] = 18237,
  [19553] = 18250,
  [19554] = 18241,
  [19555] = 18231,
  [19556] = 18280,
  [19557] = 18258,
  [19558] = 18231,
  [19559] = 18324,
  [19560] = 18250,
  [19561] = 18280,
  [19562] = 18258,
  [19563] = 18274,
  [19564] = 18230,
  [19565] = 18308,
  [19566] = 18240,
  [19567] = 18258,
  [19568] = 18231,
  [19569] = 18258,
  [19570] = 18250,
  [19571] = 18235,
  [19572] = 18239,
  [19573] = 18265,
  [19574] = 18377,
  [19575] = 18237,
  [19576] = 18284,
  [19577] = 18280,
  [19578] = 18237,
  [19579] = 18237,
  [19580] = 18241,
  [19581] = 18279,
  [19582] = 18258,
  [19583] = 18413,
  [19584] = 18284,
  [19585] = 18257,
  [19586] = 18230,
  [19587] = 18265,
  [19588] = 18235,
  [19589] = 18322,
  [19590] = 18240,
  [19591] = 18233,
  [19592] = 18237,
  [19593] = 18358,
  [19594] = 18258,
  [19595] = 18237,
  [19596] = 18249,
  [19597] = 18302,
  [19598] = 18302,
  [19599] = 18257,
  [19600] = 18258,
  [19601] = 18254,
  [19602] = 18302,
  [19603] = 18279,
  [19604] = 18240,
  [19605] = 18254,
  [19606] = 18233,
  [19607] = 18235,
  [19608] = 18241,
  [19609] = 18487,
  [19610] = 18241,
  [19611] = 18280,
  [19612] = 18237,
  [19613] = 18240,
  [19614] = 18229,
  [19615] = 18265,
  [19616] = 19616,
  [19617] = 19617,
};

static TSCharacterRange sym__word_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xa9, 0xaa}, {0xae, 0xae}, {0xb0, 0xb0}, {0xb5, 0xb5}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5},
  {0x3f7, 0x481}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a},
  {0x66e, 0x66f}, {0x671, 0x6d3}, {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710},
  {0x712, 0x72f}, {0x74d, 0x7a5}, {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a},
  {0x824, 0x824}, {0x828, 0x828}, {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939},
  {0x93d, 0x93d}, {0x950, 0x950}, {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0},
  {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc},
  {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c},
  {0xa5e, 0xa5e}, {0xa72, 0xa74}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9},
  {0xabd, 0xabd}, {0xad0, 0xad0}, {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30},
  {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a},
  {0xb8e, 0xb90}, {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9},
  {0xbd0, 0xbd0}, {0xc05, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d},
  {0xc60, 0xc61}, {0xc80, 0xc80}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd},
  {0xcdd, 0xcde}, {0xce0, 0xce1}, {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e},
  {0xd54, 0xd56}, {0xd5f, 0xd61}, {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6},
  {0xe01, 0xe30}, {0xe32, 0xe32}, {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5},
  {0xea7, 0xeb0}, {0xeb2, 0xeb2}, {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47},
  {0xf49, 0xf6c}, {0xf88, 0xf8c}, {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066},
  {0x106e, 0x1070}, {0x1075, 0x1081}, {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248},
  {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5},
  {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f},
  {0x13a0, 0x13f5}, {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711},
  {0x171f, 0x1731}, {0x1740, 0x1751}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878},
  {0x1880, 0x18a8}, {0x18aa, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9},
  {0x1a00, 0x1a16}, {0x1a20, 0x1a54}, {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5},
  {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f}, {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3},
  {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa}, {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57},
  {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b}, {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4},
  {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3}, {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x203c, 0x203c}, {0x2049, 0x2049},
  {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d},
  {0x2122, 0x2122}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e},
  {0x2160, 0x2188}, {0x2194, 0x2199}, {0x21a9, 0x21aa}, {0x2200, 0x2207}, {0x220e, 0x2211}, {0x222b, 0x2233}, {0x231a, 0x231b}, {0x2328, 0x2328},
  {0x23cf, 0x23cf}, {0x23e9, 0x23f3}, {0x23f8, 0x23fa}, {0x24c2, 0x24c2}, {0x25aa, 0x25ab}, {0x25b6, 0x25b6}, {0x25c0, 0x25c0}, {0x25fb, 0x25fe},
  {0x2600, 0x2604}, {0x260e, 0x260e}, {0x2611, 0x2611}, {0x2614, 0x2615}, {0x2618, 0x2618}, {0x261d, 0x261d}, {0x2620, 0x2620}, {0x2622, 0x2623},
  {0x2626, 0x2626}, {0x262a, 0x262a}, {0x262e, 0x262f}, {0x2638, 0x263a}, {0x2640, 0x2640}, {0x2642, 0x2642}, {0x2648, 0x2653}, {0x265f, 0x2660},
  {0x2663, 0x2663}, {0x2665, 0x2666}, {0x2668, 0x2668}, {0x267b, 0x267b}, {0x267e, 0x267f}, {0x2692, 0x2697}, {0x2699, 0x2699}, {0x269b, 0x269c},
  {0x26a0, 0x26a1}, {0x26a7, 0x26a7}, {0x26aa, 0x26ab}, {0x26b0, 0x26b1}, {0x26bd, 0x26be}, {0x26c4, 0x26c5}, {0x26c8, 0x26c8}, {0x26ce, 0x26cf},
  {0x26d1, 0x26d1}, {0x26d3, 0x26d4}, {0x26e9, 0x26ea}, {0x26f0, 0x26f5}, {0x26f7, 0x26fa}, {0x26fd, 0x26fd}, {0x2702, 0x2702}, {0x2705, 0x2705},
  {0x2708, 0x270d}, {0x270f, 0x270f}, {0x2712, 0x2712}, {0x2714, 0x2714}, {0x2716, 0x2716}, {0x271d, 0x271d}, {0x2721, 0x2721}, {0x2728, 0x2728},
  {0x2733, 0x2734}, {0x2744, 0x2744}, {0x2747, 0x2747}, {0x274c, 0x274c}, {0x274e, 0x274e}, {0x2753, 0x2755}, {0x2757, 0x2757}, {0x2763, 0x2764},
  {0x2795, 0x2797}, {0x27a1, 0x27a1}, {0x27b0, 0x27b0}, {0x27bf, 0x27bf}, {0x2934, 0x2935}, {0x2b05, 0x2b07}, {0x2b1b, 0x2b1c}, {0x2b50, 0x2b50},
  {0x2b55, 0x2b55}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3030, 0x3035}, {0x3038, 0x303d}, {0x3041, 0x3096}, {0x309d, 0x309f},
  {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3297, 0x3297}, {0x3299, 0x3299},
  {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e}, {0xa67f, 0xa69d},
  {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa801},
  {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa8fe},
  {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef}, {0xa9fa, 0xa9fe},
  {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1}, {0xaab5, 0xaab6},
  {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06}, {0xab09, 0xab0e},
  {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6},
  {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28}, {0xfb2a, 0xfb36},
  {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f},
  {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b}, {0xfe7d, 0xfe7d},
  {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf}, {0xffd2, 0xffd7},
  {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d}, {0x10080, 0x100fa},
  {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d}, {0x103a0, 0x103c3},
  {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a},
  {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736},
  {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835},
  {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915},
  {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27}, {0x10f30, 0x10f45},
  {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af}, {0x110d0, 0x110e8},
  {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4}, {0x111da, 0x111da},
  {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d},
  {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339},
  {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af}, {0x114c4, 0x114c5},
  {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8}, {0x11700, 0x1171a},
  {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x1192f},
  {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00}, {0x11a0b, 0x11a32},
  {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e}, {0x11c40, 0x11c40},
  {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d89},
  {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e},
  {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a70, 0x16abe},
  {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a}, {0x16f50, 0x16f50},
  {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb},
  {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a},
  {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6},
  {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c},
  {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da},
  {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2},
  {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ad},
  {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4}, {0x1e900, 0x1e943},
  {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37},
  {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52},
  {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64},
  {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3},
  {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1f004, 0x1f004}, {0x1f0cf, 0x1f0cf}, {0x1f170, 0x1f171}, {0x1f17e, 0x1f17f}, {0x1f18e, 0x1f18e}, {0x1f191, 0x1f19a},
  {0x1f1e6, 0x1f1ff}, {0x1f201, 0x1f202}, {0x1f21a, 0x1f21a}, {0x1f22f, 0x1f22f}, {0x1f232, 0x1f23a}, {0x1f250, 0x1f251}, {0x1f300, 0x1f321}, {0x1f324, 0x1f393},
  {0x1f396, 0x1f397}, {0x1f399, 0x1f39b}, {0x1f39e, 0x1f3f0}, {0x1f3f3, 0x1f3f5}, {0x1f3f7, 0x1f4fd}, {0x1f4ff, 0x1f53d}, {0x1f549, 0x1f54e}, {0x1f550, 0x1f567},
  {0x1f56f, 0x1f570}, {0x1f573, 0x1f57a}, {0x1f587, 0x1f587}, {0x1f58a, 0x1f58d}, {0x1f590, 0x1f590}, {0x1f595, 0x1f596}, {0x1f5a4, 0x1f5a5}, {0x1f5a8, 0x1f5a8},
  {0x1f5b1, 0x1f5b2}, {0x1f5bc, 0x1f5bc}, {0x1f5c2, 0x1f5c4}, {0x1f5d1, 0x1f5d3}, {0x1f5dc, 0x1f5de}, {0x1f5e1, 0x1f5e1}, {0x1f5e3, 0x1f5e3}, {0x1f5e8, 0x1f5e8},
  {0x1f5ef, 0x1f5ef}, {0x1f5f3, 0x1f5f3}, {0x1f5fa, 0x1f64f}, {0x1f680, 0x1f6c5}, {0x1f6cb, 0x1f6d2}, {0x1f6d5, 0x1f6d7}, {0x1f6dc, 0x1f6e5}, {0x1f6e9, 0x1f6e9},
  {0x1f6eb, 0x1f6ec}, {0x1f6f0, 0x1f6f0}, {0x1f6f3, 0x1f6fc}, {0x1f7e0, 0x1f7eb}, {0x1f7f0, 0x1f7f0}, {0x1f90c, 0x1f93a}, {0x1f93c, 0x1f945}, {0x1f947, 0x1f9ff},
  {0x1fa70, 0x1fa7c}, {0x1fa80, 0x1fa88}, {0x1fa90, 0x1fabd}, {0x1fabf, 0x1fac5}, {0x1face, 0x1fadb}, {0x1fae0, 0x1fae8}, {0x1faf0, 0x1faf8}, {0x20000, 0x2a6df},
  {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym__word_identifier_character_set_2[] = {
  {0, 0x08}, {0x0e, 0x1f}, {'!', '!'}, {'0', '9'}, {'?', '?'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'},
  {0x7f, 0xa5}, {0xa7, 0xab}, {0xad, 0xb0}, {0xb2, 0xb6}, {0xb8, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2025}, {0x2027, 0x205c},
  {0x205e, 0x214a}, {0x214c, 0x218f}, {0x2195, 0x2199}, {0x219f, 0x219f}, {0x21a1, 0x21a1}, {0x21a5, 0x21a5}, {0x21a7, 0x21a8}, {0x21ad, 0x21ad},
  {0x21af, 0x21b5}, {0x21b8, 0x21b9}, {0x21be, 0x21bf}, {0x21c2, 0x21c3}, {0x21c5, 0x21c5}, {0x21c8, 0x21c8}, {0x21ca, 0x21ca}, {0x21d1, 0x21d1},
  {0x21d3, 0x21d3}, {0x21d5, 0x21d9}, {0x21de, 0x21df}, {0x21e1, 0x21e1}, {0x21e3, 0x21f3}, {0x2200, 0x2207}, {0x220e, 0x2211}, {0x2215, 0x2216},
  {0x221e, 0x2223}, {0x222b, 0x2236}, {0x2239, 0x2239}, {0x223c, 0x223c}, {0x223f, 0x223f}, {0x228c, 0x228c}, {0x229d, 0x229d}, {0x22a4, 0x22a8},
  {0x22aa, 0x22ab}, {0x22ad, 0x22ad}, {0x22af, 0x22af}, {0x22b8, 0x22ba}, {0x22be, 0x22c3}, {0x22c8, 0x22c8}, {0x22d4, 0x22d4}, {0x2300, 0x233e},
  {0x2340, 0x25b6}, {0x25b8, 0x27c1}, {0x27c3, 0x27c6}, {0x27ca, 0x27d0}, {0x27d3, 0x27d4}, {0x27d8, 0x27ef}, {0x27f2, 0x27f4}, {0x27f8, 0x27f8},
  {0x2800, 0x28ff}, {0x2919, 0x291c}, {0x2921, 0x2943}, {0x2971, 0x2976}, {0x2978, 0x2979}, {0x297b, 0x29b6}, {0x29b9, 0x29bb}, {0x29bd, 0x29bd},
  {0x29c2, 0x29e0}, {0x29e2, 0x29e2}, {0x29e6, 0x29f3}, {0x29f5, 0x29f5}, {0x29f8, 0x29f9}, {0x29fc, 0x2a06}, {0x2a09, 0x2a1c}, {0x2a1e, 0x2a1e},
  {0x2a20, 0x2a21}, {0x2a2f, 0x2a2f}, {0x2a3e, 0x2a3f}, {0x2a46, 0x2a49}, {0x2a59, 0x2a59}, {0x2a64, 0x2a65}, {0x2a68, 0x2a69}, {0x2ada, 0x2ada},
  {0x2adc, 0x2ae9}, {0x2aec, 0x2af6}, {0x2afb, 0x2b2f}, {0x2b45, 0x2b46}, {0x2b4d, 0xffe8}, {0xffed, 0x10ffff},
};

static TSCharacterRange sym__arrow_operator_character_set_2[] = {
  {'-', '-'}, {'<', '<'}, {0x2190, 0x2190}, {0x2192, 0x2192}, {0x2194, 0x2194}, {0x219a, 0x219e}, {0x21a0, 0x21a0}, {0x21a2, 0x21a4},
  {0x21a6, 0x21a6}, {0x21a9, 0x21ac}, {0x21ae, 0x21ae}, {0x21b6, 0x21b7}, {0x21ba, 0x21bd}, {0x21c0, 0x21c1}, {0x21c4, 0x21c4}, {0x21c6, 0x21c7},
  {0x21c9, 0x21c9}, {0x21cb, 0x21d0}, {0x21d2, 0x21d2}, {0x21d4, 0x21d4}, {0x21da, 0x21dd}, {0x21e0, 0x21e0}, {0x21e2, 0x21e2}, {0x21f4, 0x21f4},
  {0x21f6, 0x21ff}, {0x27f5, 0x27f7}, {0x27f9, 0x27ff}, {0x2900, 0x2907}, {0x290c, 0x2911}, {0x2914, 0x2918}, {0x291d, 0x2920}, {0x2944, 0x2948},
  {0x294a, 0x294b}, {0x294e, 0x294e}, {0x2950, 0x2950}, {0x2952, 0x2953}, {0x2956, 0x2957}, {0x295a, 0x295b}, {0x295e, 0x295f}, {0x2962, 0x2962},
  {0x2964, 0x2964}, {0x2966, 0x296d}, {0x2970, 0x2970}, {0x2977, 0x2977}, {0x297a, 0x297a}, {0x29f4, 0x29f4}, {0x2b30, 0x2b44}, {0x2b47, 0x2b4c},
  {0xffe9, 0xffe9}, {0xffeb, 0xffeb},
};

static TSCharacterRange sym__comparison_operator_character_set_2[] = {
  {'!', '!'}, {'<', '>'}, {0x2208, 0x220d}, {0x221d, 0x221d}, {0x2225, 0x2226}, {0x2237, 0x2237}, {0x223a, 0x223b}, {0x223d, 0x223e},
  {0x2241, 0x224e}, {0x2250, 0x2253}, {0x2256, 0x228b}, {0x228f, 0x2292}, {0x229c, 0x229c}, {0x22a2, 0x22a3}, {0x22a9, 0x22a9}, {0x22ac, 0x22ac},
  {0x22ae, 0x22ae}, {0x22b0, 0x22b7}, {0x22cd, 0x22cd}, {0x22d0, 0x22d1}, {0x22d5, 0x22ed}, {0x22f2, 0x22ff}, {0x27c2, 0x27c2}, {0x27c8, 0x27c9},
  {0x27d2, 0x27d2}, {0x29b7, 0x29b7}, {0x29c0, 0x29c1}, {0x29e1, 0x29e1}, {0x29e3, 0x29e5}, {0x2a66, 0x2a67}, {0x2a6a, 0x2a73}, {0x2a75, 0x2ad9},
  {0x2aea, 0x2aeb}, {0x2af7, 0x2afa},
};

static TSCharacterRange sym__plus_operator_character_set_2[] = {
  {'+', '+'}, {'|', '|'}, {0xa6, 0xa6}, {0xb1, 0xb1}, {0x2212, 0x2214}, {0x2228, 0x2228}, {0x222a, 0x222a}, {0x2238, 0x2238},
  {0x224f, 0x224f}, {0x228e, 0x228e}, {0x2294, 0x2296}, {0x229e, 0x229f}, {0x22bb, 0x22bb}, {0x22bd, 0x22bd}, {0x22ce, 0x22ce}, {0x22d3, 0x22d3},
  {0x27c7, 0x27c7}, {0x29fa, 0x29fb}, {0x2a08, 0x2a08}, {0x2a22, 0x2a2e}, {0x2a39, 0x2a3a}, {0x2a41, 0x2a42}, {0x2a45, 0x2a45}, {0x2a4a, 0x2a4a},
  {0x2a4c, 0x2a4c}, {0x2a4f, 0x2a50}, {0x2a52, 0x2a52}, {0x2a54, 0x2a54}, {0x2a56, 0x2a57}, {0x2a5b, 0x2a5b}, {0x2a5d, 0x2a5d}, {0x2a61, 0x2a63},
};

static TSCharacterRange sym__times_operator_character_set_2[] = {
  {'%', '&'}, {'*', '*'}, {'/', '/'}, {'\\', '\\'}, {0xb7, 0xb7}, {0xd7, 0xd7}, {0xf7, 0xf7}, {0x214b, 0x214b},
  {0x2217, 0x2219}, {0x2224, 0x2224}, {0x2227, 0x2227}, {0x2229, 0x2229}, {0x2240, 0x2240}, {0x228d, 0x228d}, {0x2293, 0x2293}, {0x2297, 0x229b},
  {0x22a0, 0x22a1}, {0x22bc, 0x22bc}, {0x22c4, 0x22c7}, {0x22c9, 0x22cc}, {0x22cf, 0x22cf}, {0x22d2, 0x22d2}, {0x233f, 0x233f}, {0x25b7, 0x25b7},
  {0x27d1, 0x27d1}, {0x27d5, 0x27d7}, {0x29b8, 0x29b8}, {0x29bc, 0x29bc}, {0x29be, 0x29bf}, {0x29f6, 0x29f7}, {0x2a07, 0x2a07}, {0x2a1d, 0x2a1d},
  {0x2a1f, 0x2a1f}, {0x2a30, 0x2a38}, {0x2a3b, 0x2a3d}, {0x2a40, 0x2a40}, {0x2a43, 0x2a44}, {0x2a4b, 0x2a4b}, {0x2a4d, 0x2a4e}, {0x2a51, 0x2a51},
  {0x2a53, 0x2a53}, {0x2a55, 0x2a55}, {0x2a58, 0x2a58}, {0x2a5a, 0x2a5a}, {0x2a5c, 0x2a5c}, {0x2a5e, 0x2a60}, {0x2adb, 0x2adb},
};

static TSCharacterRange sym__power_operator_character_set_2[] = {
  {'^', '^'}, {0x2191, 0x2191}, {0x2193, 0x2193}, {0x21f5, 0x21f5}, {0x27f0, 0x27f1}, {0x2908, 0x290b}, {0x2912, 0x2913}, {0x2949, 0x2949},
  {0x294c, 0x294d}, {0x294f, 0x294f}, {0x2951, 0x2951}, {0x2954, 0x2955}, {0x2958, 0x2959}, {0x295c, 0x295d}, {0x2960, 0x2961}, {0x2963, 0x2963},
  {0x2965, 0x2965}, {0x296e, 0x296f}, {0xffea, 0xffea}, {0xffec, 0xffec},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 602,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'a', 651,
        'b', 645,
        'c', 641,
        'd', 718,
        'e', 701,
        'f', 688,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(565);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '\n', 838,
        '\r', 1,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(1);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '\n', 839,
        '\r', 3,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(3);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\n', 839,
        '\r', 3,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(3);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '\n', 840,
        '\r', 6,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(6);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '\n', 840,
        '\r', 6,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(6);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '\n', 840,
        '\r', 6,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(6);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '\n', 840,
        '\r', 6,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(6);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '\n', 841,
        '\r', 10,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(10);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '\n', 841,
        '\r', 10,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(10);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '\n', 841,
        '\r', 10,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(10);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '\n', 841,
        '\r', 10,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(10);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '\n', 842,
        '\r', 14,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(14);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '\n', 842,
        '\r', 14,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(14);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '\n', 842,
        '\r', 14,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(14);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '\n', 842,
        '\r', 14,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(14);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '\n', 843,
        '\r', 16,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(16);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '\n', 844,
        '\r', 19,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(19);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '\n', 844,
        '\r', 19,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(19);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '\n', 844,
        '\r', 19,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(19);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '\n', 844,
        '\r', 19,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(19);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '\n', 845,
        '\r', 21,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(21);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '\n', 846,
        '\r', 22,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(22);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '\n', 846,
        '\r', 22,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(22);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '\n', 847,
        '\r', 24,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 602,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(24);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '\n', 847,
        '\r', 24,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 602,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(24);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '\n', 848,
        '\r', 26,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(26);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '\n', 849,
        '\r', 27,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(27);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '\n', 850,
        '\r', 28,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(28);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '\n', 851,
        '\r', 29,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(29);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '\n', 852,
        '\r', 30,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(30);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        '\n', 853,
        '\r', 31,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(31);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '\n', 854,
        '\r', 32,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(32);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '\n', 855,
        '\r', 35,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 34:
      ADVANCE_MAP(
        '\n', 855,
        '\r', 35,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '\n', 855,
        '\r', 35,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '\n', 856,
        '\r', 38,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '\n', 856,
        '\r', 38,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '\n', 856,
        '\r', 38,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '\n', 857,
        '\r', 40,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 641,
        'e', 706,
        'f', 694,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(40);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '\n', 857,
        '\r', 40,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(40);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '\n', 858,
        '\r', 42,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 641,
        'e', 707,
        'f', 688,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(42);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '\n', 858,
        '\r', 42,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(42);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '\n', 859,
        '\r', 43,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(43);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '\n', 860,
        '\r', 44,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(44);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '\n', 861,
        '\r', 46,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(46);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '\n', 861,
        '\r', 46,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(46);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '\n', 862,
        '\r', 48,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(48);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '\n', 862,
        '\r', 48,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(48);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '\n', 863,
        '\r', 50,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(50);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '\n', 863,
        '\r', 50,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(50);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '\n', 864,
        '\r', 52,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(52);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '\n', 864,
        '\r', 52,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(52);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '\n', 865,
        '\r', 53,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(53);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '\n', 866,
        '\r', 55,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(55);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '\n', 866,
        '\r', 55,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(55);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '\n', 867,
        '\r', 57,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(57);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '\n', 867,
        '\r', 57,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(57);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '\n', 868,
        '\r', 59,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'd', 718,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(59);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        '\n', 868,
        '\r', 59,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'd', 718,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(59);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 60:
      ADVANCE_MAP(
        '\n', 869,
        '\r', 61,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(61);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        '\n', 869,
        '\r', 61,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(61);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 62:
      ADVANCE_MAP(
        '\n', 870,
        '\r', 63,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(63);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 63:
      ADVANCE_MAP(
        '\n', 870,
        '\r', 63,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(63);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '\n', 871,
        '\r', 65,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(65);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '\n', 871,
        '\r', 65,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(65);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 66:
      ADVANCE_MAP(
        '\n', 872,
        '\r', 68,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(68);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '\n', 872,
        '\r', 68,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(68);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 68:
      ADVANCE_MAP(
        '\n', 872,
        '\r', 68,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(68);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '\n', 873,
        '\r', 70,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(70);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 70:
      ADVANCE_MAP(
        '\n', 873,
        '\r', 70,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(70);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '\n', 874,
        '\r', 73,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(73);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '\n', 874,
        '\r', 73,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(73);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 73:
      ADVANCE_MAP(
        '\n', 874,
        '\r', 73,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(73);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 74:
      ADVANCE_MAP(
        '\n', 875,
        '\r', 75,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(75);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '\n', 875,
        '\r', 75,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(75);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 76:
      ADVANCE_MAP(
        '\n', 876,
        '\r', 77,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(77);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 77:
      ADVANCE_MAP(
        '\n', 876,
        '\r', 77,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(77);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 78:
      ADVANCE_MAP(
        '\n', 877,
        '\r', 78,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(78);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 79:
      ADVANCE_MAP(
        '\n', 878,
        '\r', 80,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(80);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 80:
      ADVANCE_MAP(
        '\n', 878,
        '\r', 80,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(80);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 81:
      ADVANCE_MAP(
        '\n', 879,
        '\r', 82,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(82);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '\n', 879,
        '\r', 82,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(82);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 83:
      ADVANCE_MAP(
        '\n', 880,
        '\r', 84,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(84);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 84:
      ADVANCE_MAP(
        '\n', 880,
        '\r', 84,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(84);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 85:
      ADVANCE_MAP(
        '\n', 881,
        '\r', 86,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(86);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 86:
      ADVANCE_MAP(
        '\n', 881,
        '\r', 86,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(86);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 87:
      ADVANCE_MAP(
        '\n', 882,
        '\r', 87,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(87);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        '\n', 883,
        '\r', 88,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(88);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 89:
      ADVANCE_MAP(
        '\n', 884,
        '\r', 90,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(90);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 90:
      ADVANCE_MAP(
        '\n', 884,
        '\r', 90,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(90);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 91:
      ADVANCE_MAP(
        '\n', 885,
        '\r', 92,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(92);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 92:
      ADVANCE_MAP(
        '\n', 885,
        '\r', 92,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(92);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 93:
      ADVANCE_MAP(
        '\n', 886,
        '\r', 94,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(94);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 94:
      ADVANCE_MAP(
        '\n', 886,
        '\r', 94,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(94);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        '\n', 887,
        '\r', 96,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(96);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 96:
      ADVANCE_MAP(
        '\n', 887,
        '\r', 96,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'd', 718,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(96);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 97:
      ADVANCE_MAP(
        '\n', 888,
        '\r', 98,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(98);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 98:
      ADVANCE_MAP(
        '\n', 888,
        '\r', 98,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(98);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 99:
      ADVANCE_MAP(
        '\n', 889,
        '\r', 100,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(100);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 100:
      ADVANCE_MAP(
        '\n', 889,
        '\r', 100,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(100);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 101:
      ADVANCE_MAP(
        '\n', 890,
        '\r', 102,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(102);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 102:
      ADVANCE_MAP(
        '\n', 890,
        '\r', 102,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(102);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 103:
      ADVANCE_MAP(
        '\n', 891,
        '\r', 103,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(103);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 104:
      ADVANCE_MAP(
        '\n', 892,
        '\r', 105,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(105);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 105:
      ADVANCE_MAP(
        '\n', 892,
        '\r', 105,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(105);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 106:
      ADVANCE_MAP(
        '\n', 893,
        '\r', 107,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(107);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 107:
      ADVANCE_MAP(
        '\n', 893,
        '\r', 107,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(107);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        '\n', 894,
        '\r', 109,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(109);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 109:
      ADVANCE_MAP(
        '\n', 894,
        '\r', 109,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(109);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 110:
      ADVANCE_MAP(
        '\n', 894,
        '\r', 109,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(109);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 111:
      ADVANCE_MAP(
        '\n', 894,
        '\r', 109,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(109);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 112:
      ADVANCE_MAP(
        '\n', 895,
        '\r', 113,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(113);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 113:
      ADVANCE_MAP(
        '\n', 895,
        '\r', 113,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(113);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '\n', 895,
        '\r', 113,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(113);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 115:
      ADVANCE_MAP(
        '\n', 895,
        '\r', 113,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(113);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 116:
      ADVANCE_MAP(
        '\n', 896,
        '\r', 117,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 117:
      ADVANCE_MAP(
        '\n', 896,
        '\r', 117,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 118:
      ADVANCE_MAP(
        '\n', 896,
        '\r', 117,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 119:
      ADVANCE_MAP(
        '\n', 896,
        '\r', 117,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(117);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 120:
      ADVANCE_MAP(
        '\n', 897,
        '\r', 121,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(121);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 121:
      ADVANCE_MAP(
        '\n', 897,
        '\r', 121,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(121);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 122:
      ADVANCE_MAP(
        '\n', 897,
        '\r', 121,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(121);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 123:
      ADVANCE_MAP(
        '\n', 897,
        '\r', 121,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(121);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 124:
      ADVANCE_MAP(
        '\n', 898,
        '\r', 125,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(125);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 125:
      ADVANCE_MAP(
        '\n', 898,
        '\r', 125,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(125);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 126:
      ADVANCE_MAP(
        '\n', 898,
        '\r', 125,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(125);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 127:
      ADVANCE_MAP(
        '\n', 898,
        '\r', 125,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(125);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 128:
      ADVANCE_MAP(
        '\n', 899,
        '\r', 128,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(128);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 129:
      ADVANCE_MAP(
        '\n', 900,
        '\r', 130,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(130);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 130:
      ADVANCE_MAP(
        '\n', 900,
        '\r', 130,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(130);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 131:
      ADVANCE_MAP(
        '\n', 900,
        '\r', 130,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(130);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 132:
      ADVANCE_MAP(
        '\n', 900,
        '\r', 130,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(130);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 133:
      ADVANCE_MAP(
        '\n', 901,
        '\r', 134,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(134);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 134:
      ADVANCE_MAP(
        '\n', 901,
        '\r', 134,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(134);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 135:
      ADVANCE_MAP(
        '\n', 902,
        '\r', 136,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(136);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 136:
      ADVANCE_MAP(
        '\n', 902,
        '\r', 136,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(136);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 137:
      ADVANCE_MAP(
        '\n', 903,
        '\r', 138,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(138);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 138:
      ADVANCE_MAP(
        '\n', 903,
        '\r', 138,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(138);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 139:
      ADVANCE_MAP(
        '\n', 904,
        '\r', 140,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(140);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 140:
      ADVANCE_MAP(
        '\n', 904,
        '\r', 140,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(140);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 141:
      ADVANCE_MAP(
        '\n', 905,
        '\r', 142,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(142);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 142:
      ADVANCE_MAP(
        '\n', 905,
        '\r', 142,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(142);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 143:
      ADVANCE_MAP(
        '\n', 906,
        '\r', 143,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(143);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 144:
      ADVANCE_MAP(
        '\n', 907,
        '\r', 145,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(145);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 145:
      ADVANCE_MAP(
        '\n', 907,
        '\r', 145,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(145);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 146:
      ADVANCE_MAP(
        '\n', 908,
        '\r', 147,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 708,
        'f', 689,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(147);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 147:
      ADVANCE_MAP(
        '\n', 908,
        '\r', 147,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(147);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 148:
      ADVANCE_MAP(
        '\n', 909,
        '\r', 149,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 701,
        'f', 695,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(149);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 149:
      ADVANCE_MAP(
        '\n', 909,
        '\r', 149,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(149);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 150:
      ADVANCE_MAP(
        '\n', 910,
        '\r', 151,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 706,
        'f', 689,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(151);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 151:
      ADVANCE_MAP(
        '\n', 910,
        '\r', 151,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(151);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 152:
      ADVANCE_MAP(
        '\n', 911,
        '\r', 153,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 641,
        'e', 707,
        'f', 689,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(153);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 153:
      ADVANCE_MAP(
        '\n', 911,
        '\r', 153,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(153);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 154:
      ADVANCE_MAP(
        '\n', 912,
        '\r', 155,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 641,
        'e', 706,
        'f', 695,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(155);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 155:
      ADVANCE_MAP(
        '\n', 912,
        '\r', 155,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(155);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 156:
      ADVANCE_MAP(
        '\n', 913,
        '\r', 157,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 706,
        'f', 695,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(157);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 157:
      ADVANCE_MAP(
        '\n', 913,
        '\r', 157,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(157);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 158:
      ADVANCE_MAP(
        '\n', 914,
        '\r', 158,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(158);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 159:
      ADVANCE_MAP(
        '\n', 915,
        '\r', 159,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 835,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(159);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 160:
      ADVANCE_MAP(
        '\n', 916,
        '\r', 160,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(160);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 161:
      ADVANCE_MAP(
        '\n', 916,
        '\r', 160,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 770,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(160);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 162:
      ADVANCE_MAP(
        '\n', 917,
        '\r', 162,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(162);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 163:
      ADVANCE_MAP(
        '\n', 918,
        '\r', 163,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(163);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 164:
      ADVANCE_MAP(
        '\n', 919,
        '\r', 164,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(164);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 165:
      ADVANCE_MAP(
        '\n', 920,
        '\r', 166,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(166);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 166:
      ADVANCE_MAP(
        '\n', 920,
        '\r', 166,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(166);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 167:
      ADVANCE_MAP(
        '\n', 921,
        '\r', 168,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'd', 471,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(168);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 168:
      ADVANCE_MAP(
        '\n', 921,
        '\r', 168,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'd', 471,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(168);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 169:
      ADVANCE_MAP(
        '\n', 922,
        '\r', 170,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(170);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 170:
      ADVANCE_MAP(
        '\n', 922,
        '\r', 170,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(170);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 171:
      ADVANCE_MAP(
        '\n', 923,
        '\r', 172,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(172);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 172:
      ADVANCE_MAP(
        '\n', 923,
        '\r', 172,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(172);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 173:
      ADVANCE_MAP(
        '\n', 924,
        '\r', 174,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 613,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(174);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 174:
      ADVANCE_MAP(
        '\n', 924,
        '\r', 174,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(174);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 175:
      ADVANCE_MAP(
        '\n', 925,
        '\r', 176,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(176);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 176:
      ADVANCE_MAP(
        '\n', 925,
        '\r', 176,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(176);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 177:
      ADVANCE_MAP(
        '\n', 926,
        '\r', 177,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(177);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 178:
      ADVANCE_MAP(
        '\n', 927,
        '\r', 179,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(179);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 179:
      ADVANCE_MAP(
        '\n', 927,
        '\r', 179,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(179);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 180:
      ADVANCE_MAP(
        '\n', 928,
        '\r', 181,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(181);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 181:
      ADVANCE_MAP(
        '\n', 928,
        '\r', 181,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(181);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 182:
      ADVANCE_MAP(
        '\n', 929,
        '\r', 182,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(182);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 183:
      ADVANCE_MAP(
        '\n', 930,
        '\r', 183,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(183);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 184:
      ADVANCE_MAP(
        '\n', 931,
        '\r', 185,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(185);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 185:
      ADVANCE_MAP(
        '\n', 931,
        '\r', 185,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(185);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 186:
      ADVANCE_MAP(
        '\n', 932,
        '\r', 186,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(186);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 187:
      ADVANCE_MAP(
        '\n', 933,
        '\r', 187,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(187);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        '\n', 934,
        '\r', 189,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'd', 471,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(189);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 189:
      ADVANCE_MAP(
        '\n', 934,
        '\r', 189,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'd', 471,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(189);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 190:
      ADVANCE_MAP(
        '\n', 935,
        '\r', 191,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(191);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 191:
      ADVANCE_MAP(
        '\n', 935,
        '\r', 191,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(191);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 192:
      ADVANCE_MAP(
        '\n', 936,
        '\r', 193,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(193);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 193:
      ADVANCE_MAP(
        '\n', 936,
        '\r', 193,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(193);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 194:
      ADVANCE_MAP(
        '\n', 937,
        '\r', 195,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(195);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 195:
      ADVANCE_MAP(
        '\n', 937,
        '\r', 195,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(195);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 196:
      ADVANCE_MAP(
        '\n', 938,
        '\r', 197,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(197);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 197:
      ADVANCE_MAP(
        '\n', 938,
        '\r', 197,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(197);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 198:
      ADVANCE_MAP(
        '\n', 939,
        '\r', 199,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(199);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 199:
      ADVANCE_MAP(
        '\n', 939,
        '\r', 199,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(199);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 200:
      ADVANCE_MAP(
        '\n', 940,
        '\r', 201,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(201);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 201:
      ADVANCE_MAP(
        '\n', 940,
        '\r', 201,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(201);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 202:
      ADVANCE_MAP(
        '\n', 941,
        '\r', 203,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(203);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 203:
      ADVANCE_MAP(
        '\n', 941,
        '\r', 203,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(203);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 204:
      ADVANCE_MAP(
        '\n', 942,
        '\r', 205,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 615,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(205);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 205:
      ADVANCE_MAP(
        '\n', 942,
        '\r', 205,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(205);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 206:
      ADVANCE_MAP(
        '\n', 943,
        '\r', 207,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(207);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 207:
      ADVANCE_MAP(
        '\n', 943,
        '\r', 207,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(207);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 208:
      ADVANCE_MAP(
        '\n', 944,
        '\r', 209,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 615,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(209);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 209:
      ADVANCE_MAP(
        '\n', 944,
        '\r', 209,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(209);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 210:
      ADVANCE_MAP(
        '\n', 944,
        '\r', 209,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 771,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(209);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 211:
      ADVANCE_MAP(
        '\n', 945,
        '\r', 212,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(212);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 212:
      ADVANCE_MAP(
        '\n', 945,
        '\r', 212,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(212);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 213:
      ADVANCE_MAP(
        '\n', 946,
        '\r', 213,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(213);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 214:
      ADVANCE_MAP(
        '\n', 947,
        '\r', 215,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(215);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 215:
      ADVANCE_MAP(
        '\n', 947,
        '\r', 215,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(215);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 216:
      ADVANCE_MAP(
        '\n', 948,
        '\r', 217,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(217);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 217:
      ADVANCE_MAP(
        '\n', 948,
        '\r', 217,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(217);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 218:
      ADVANCE_MAP(
        '\n', 949,
        '\r', 219,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(219);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 219:
      ADVANCE_MAP(
        '\n', 949,
        '\r', 219,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(219);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 220:
      ADVANCE_MAP(
        '\n', 950,
        '\r', 220,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(220);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 221:
      ADVANCE_MAP(
        '\n', 951,
        '\r', 222,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(222);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 222:
      ADVANCE_MAP(
        '\n', 951,
        '\r', 222,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 701,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(222);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 223:
      ADVANCE_MAP(
        '\n', 952,
        '\r', 224,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(224);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 224:
      ADVANCE_MAP(
        '\n', 952,
        '\r', 224,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 705,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(224);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 225:
      ADVANCE_MAP(
        '\n', 953,
        '\r', 226,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(226);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 226:
      ADVANCE_MAP(
        '\n', 953,
        '\r', 226,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'c', 642,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(226);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 227:
      ADVANCE_MAP(
        '\n', 954,
        '\r', 228,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(228);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 228:
      ADVANCE_MAP(
        '\n', 954,
        '\r', 228,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 711,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(228);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 229:
      ADVANCE_MAP(
        '\n', 955,
        '\r', 230,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(230);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 230:
      ADVANCE_MAP(
        '\n', 955,
        '\r', 230,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'c', 642,
        'f', 690,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(230);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 231:
      ADVANCE_MAP(
        '\n', 956,
        '\r', 231,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(231);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 232:
      ADVANCE_MAP(
        '\n', 957,
        '\r', 233,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(233);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 233:
      ADVANCE_MAP(
        '\n', 957,
        '\r', 233,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(233);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 234:
      ADVANCE_MAP(
        '\n', 958,
        '\r', 234,
        '#', 980,
        ',', 568,
        ';', 977,
        '=', 569,
        'c', 448,
        'e', 466,
        'f', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(234);
      END_STATE();
    case 235:
      if (lookahead == '\n') ADVANCE(959);
      if (lookahead == '\r') ADVANCE(235);
      if (lookahead == '#') ADVANCE(980);
      if (lookahead == ',') ADVANCE(568);
      if (lookahead == ';') ADVANCE(977);
      if (lookahead == '=') ADVANCE(569);
      if (lookahead == 'e') ADVANCE(463);
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(235);
      END_STATE();
    case 236:
      ADVANCE_MAP(
        '\n', 960,
        '\r', 238,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(238);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 237:
      ADVANCE_MAP(
        '\n', 960,
        '\r', 238,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(238);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 238:
      ADVANCE_MAP(
        '\n', 960,
        '\r', 238,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(238);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 239:
      ADVANCE_MAP(
        '\n', 961,
        '\r', 241,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(241);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 240:
      ADVANCE_MAP(
        '\n', 961,
        '\r', 241,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(241);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 241:
      ADVANCE_MAP(
        '\n', 961,
        '\r', 241,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(241);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 242:
      ADVANCE_MAP(
        '\n', 961,
        '\r', 241,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(241);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 243:
      ADVANCE_MAP(
        '\n', 962,
        '\r', 245,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(245);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 244:
      ADVANCE_MAP(
        '\n', 962,
        '\r', 245,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(245);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 245:
      ADVANCE_MAP(
        '\n', 962,
        '\r', 245,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(245);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 246:
      ADVANCE_MAP(
        '\n', 963,
        '\r', 248,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(248);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 247:
      ADVANCE_MAP(
        '\n', 963,
        '\r', 248,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(248);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 248:
      ADVANCE_MAP(
        '\n', 963,
        '\r', 248,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(248);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 249:
      ADVANCE_MAP(
        '\n', 964,
        '\r', 251,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(251);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 250:
      ADVANCE_MAP(
        '\n', 964,
        '\r', 251,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(251);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 251:
      ADVANCE_MAP(
        '\n', 964,
        '\r', 251,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(251);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 252:
      ADVANCE_MAP(
        '\n', 965,
        '\r', 254,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(254);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 253:
      ADVANCE_MAP(
        '\n', 965,
        '\r', 254,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(254);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 254:
      ADVANCE_MAP(
        '\n', 965,
        '\r', 254,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(254);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 255:
      ADVANCE_MAP(
        '\n', 966,
        '\r', 257,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(257);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 256:
      ADVANCE_MAP(
        '\n', 966,
        '\r', 257,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(257);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 257:
      ADVANCE_MAP(
        '\n', 966,
        '\r', 257,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(257);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 258:
      ADVANCE_MAP(
        '\n', 967,
        '\r', 260,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(260);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 259:
      ADVANCE_MAP(
        '\n', 967,
        '\r', 260,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(260);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 260:
      ADVANCE_MAP(
        '\n', 967,
        '\r', 260,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(260);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 261:
      ADVANCE_MAP(
        '\n', 968,
        '\r', 262,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 708,
        'f', 688,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(262);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 262:
      ADVANCE_MAP(
        '\n', 968,
        '\r', 262,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(262);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 263:
      ADVANCE_MAP(
        '\n', 969,
        '\r', 265,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(265);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 264:
      ADVANCE_MAP(
        '\n', 969,
        '\r', 265,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(265);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 265:
      ADVANCE_MAP(
        '\n', 969,
        '\r', 265,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(265);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 266:
      ADVANCE_MAP(
        '\n', 970,
        '\r', 267,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 701,
        'f', 694,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(267);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 267:
      ADVANCE_MAP(
        '\n', 970,
        '\r', 267,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(267);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 268:
      ADVANCE_MAP(
        '\n', 971,
        '\r', 269,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(269);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 269:
      ADVANCE_MAP(
        '\n', 971,
        '\r', 269,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(269);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 270:
      ADVANCE_MAP(
        '\n', 971,
        '\r', 269,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(269);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 271:
      ADVANCE_MAP(
        '\n', 972,
        '\r', 272,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 706,
        'f', 688,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(272);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 272:
      ADVANCE_MAP(
        '\n', 972,
        '\r', 272,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(272);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 273:
      ADVANCE_MAP(
        '\n', 973,
        '\r', 274,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 706,
        'f', 694,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(274);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 274:
      ADVANCE_MAP(
        '\n', 973,
        '\r', 274,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(274);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 275:
      ADVANCE_MAP(
        '\n', 974,
        '\r', 276,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(276);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 276:
      ADVANCE_MAP(
        '\n', 974,
        '\r', 276,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(276);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 277:
      ADVANCE_MAP(
        '\n', 975,
        '\r', 278,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(278);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 278:
      ADVANCE_MAP(
        '\n', 975,
        '\r', 278,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(278);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 279:
      ADVANCE_MAP(
        '\n', 976,
        '\r', 279,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'd', 471,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(279);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 280:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(293);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 281:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(294);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 282:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(295);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 283:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(295);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 284:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        '0', 765,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(296);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 285:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(297);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 286:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(301);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 287:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(302);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 288:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 289:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 290:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(304);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 291:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 707,
        'f', 694,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(292);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 292:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(292);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 293:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(293);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 294:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(294);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 295:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(295);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 296:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        '0', 765,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(296);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 297:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(297);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 298:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(298);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 299:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 706,
        'f', 694,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(300);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 300:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(300);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 301:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(301);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 302:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(302);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 303:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(303);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 304:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(304);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 305:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 707,
        'f', 695,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(307);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 306:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 707,
        'f', 694,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(308);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 307:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(307);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 308:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(308);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 309:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 706,
        'f', 695,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(310);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 310:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(310);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 311:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 625,
        '<', 798,
        '=', 442,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 707,
        'f', 695,
        'g', 699,
        'i', 676,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 684,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(312);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 312:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 625,
        '<', 798,
        '=', 442,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(312);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 313:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(327);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 314:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(328);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 315:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(328);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 316:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(336);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 317:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(337);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 318:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(337);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 319:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(340);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 320:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 321:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 322:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(347);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 323:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(348);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 324:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(348);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 325:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(326);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 326:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(326);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 327:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(327);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 328:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(328);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 329:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(326);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 330:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(326);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 331:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(328);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 332:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(334);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 333:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'f', 722,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(335);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 334:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(334);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 335:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'f', 722,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(335);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 336:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(336);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 337:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(337);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 338:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(339);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 339:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(339);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 340:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(340);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 341:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 342:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(339);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 343:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'a', 735,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(339);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 344:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(341);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 345:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(346);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 346:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(346);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 347:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'd', 718,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(347);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 348:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(348);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 349:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 622,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(349);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 350:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'e', 711,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(350);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 351:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'c', 642,
        'f', 688,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(351);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 352:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 701,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(352);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 353:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 688,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(353);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 354:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(354);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 355:
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 674,
        '{', 603,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(355);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 356:
      ADVANCE_MAP(
        '!', 829,
        '#', 980,
        '$', 620,
        '(', 592,
        '+', 830,
        '-', 832,
        '.', 590,
        '/', 816,
        ':', 622,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(356);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 357:
      ADVANCE_MAP(
        '!', 829,
        '#', 980,
        '$', 620,
        '+', 830,
        '-', 835,
        '.', 837,
        '/', 816,
        ':', 622,
        '<', 799,
        '=', 442,
        '>', 801,
        '?', 634,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(357);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 358:
      ADVANCE_MAP(
        '!', 829,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 359:
      ADVANCE_MAP(
        '!', 829,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 360:
      ADVANCE_MAP(
        '!', 829,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 361:
      ADVANCE_MAP(
        '!', 829,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 362:
      ADVANCE_MAP(
        '!', 829,
        '+', 830,
        '-', 832,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == '.' ||
          lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 363:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 614,
        '/', 815,
        '0', 765,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 462,
        'i', 457,
        'w', 459,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(374);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 364:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        '0', 765,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'd', 471,
        'e', 466,
        'f', 462,
        'i', 457,
        'w', 459,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(375);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 365:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        '0', 765,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'i', 712,
        'w', 683,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(377);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 366:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'f', 722,
        'i', 673,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(378);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 367:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(379);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 368:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 613,
        '/', 815,
        '0', 765,
        ':', 595,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(376);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 369:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(380);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 370:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        '-', 834,
        '.', 614,
        '/', 815,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(381);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 371:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(382);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 372:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(383);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 373:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 613,
        '/', 815,
        ':', 595,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(383);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 374:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 421,
        '/', 815,
        '0', 765,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 462,
        'i', 457,
        'w', 459,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(374);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 375:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        '0', 765,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'd', 471,
        'e', 466,
        'f', 462,
        'i', 457,
        'w', 459,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(375);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 376:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        '0', 765,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(376);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 377:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        '0', 765,
        ':', 624,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'i', 712,
        'w', 683,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(377);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 378:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        ']', 597,
        '^', 825,
        'f', 722,
        'i', 673,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(378);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 379:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 601,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(379);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 380:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(380);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 381:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 834,
        '.', 421,
        '/', 815,
        ':', 440,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(381);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 382:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(382);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 383:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(383);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 384:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'a', 475,
        'd', 471,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(401);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 385:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'i', 712,
        'w', 683,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(404);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 386:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'f', 722,
        'i', 673,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(405);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 387:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(407);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 388:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 615,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'a', 475,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(402);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 389:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'd', 471,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(409);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 390:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'i', 712,
        'w', 683,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(411);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 391:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'f', 722,
        'i', 673,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(412);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 392:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(413);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 393:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 615,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(410);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 394:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(416);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 395:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(417);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 396:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'd', 471,
        'i', 468,
        'w', 459,
        '|', 811,
        0x2208, 600,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(418);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 397:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0x2208, 600,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(419);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 398:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        '-', 835,
        '.', 615,
        '/', 816,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 468,
        'w', 459,
        '|', 811,
        0x2208, 600,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(420);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 399:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'a', 735,
        'i', 712,
        'w', 683,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(403);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 400:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(406);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 401:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'a', 475,
        'd', 471,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(401);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 402:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'a', 475,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(402);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 403:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'a', 735,
        'i', 712,
        'w', 683,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(403);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 404:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'i', 712,
        'w', 683,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(404);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 405:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'f', 722,
        'i', 673,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(405);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 406:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(406);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 407:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(407);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 408:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 771,
        '/', 816,
        '0', 765,
        ':', 594,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'a', 475,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(402);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 409:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'd', 471,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(409);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 410:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'e', 467,
        'f', 470,
        'i', 457,
        'w', 459,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(410);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 411:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        '0', 765,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'i', 712,
        'w', 683,
        '|', 811,
        '}', 604,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(411);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(766);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 412:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        ']', 597,
        'f', 722,
        'i', 673,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(412);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 413:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 601,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'f', 722,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(413);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 414:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(415);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 415:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(415);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 416:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(416);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 417:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'e', 711,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(417);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 418:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'd', 471,
        'i', 468,
        'w', 459,
        '|', 811,
        0x2208, 600,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(418);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 419:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0x2208, 600,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(419);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 420:
      ADVANCE_MAP(
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 468,
        'w', 459,
        '|', 811,
        0x2208, 600,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(420);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 421:
      ADVANCE_MAP(
        '!', 441,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 422:
      ADVANCE_MAP(
        '!', 441,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 423:
      if (lookahead == '"') ADVANCE(787);
      END_STATE();
    case 424:
      ADVANCE_MAP(
        '#', 980,
        '$', 620,
        ')', 593,
        ',', 568,
        '.', 607,
        ':', 622,
        '=', 569,
        '\\', 480,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(425);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 425:
      if (lookahead == '#') ADVANCE(980);
      if (lookahead == '$') ADVANCE(620);
      if (lookahead == ')') ADVANCE(593);
      if (lookahead == ',') ADVANCE(568);
      if (lookahead == ':') ADVANCE(622);
      if (lookahead == '=') ADVANCE(569);
      if (lookahead == '\\') ADVANCE(480);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(425);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 426:
      if (lookahead == '#') ADVANCE(980);
      if (lookahead == ')') ADVANCE(593);
      if (lookahead == '.') ADVANCE(617);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(428);
      END_STATE();
    case 427:
      if (lookahead == '#') ADVANCE(980);
      if (lookahead == ')') ADVANCE(593);
      if (lookahead == '.') ADVANCE(773);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(428);
      END_STATE();
    case 428:
      if (lookahead == '#') ADVANCE(980);
      if (lookahead == ')') ADVANCE(593);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(428);
      END_STATE();
    case 429:
      if (lookahead == '\'') ADVANCE(785);
      END_STATE();
    case 430:
      if (lookahead == '\'') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(429);
      END_STATE();
    case 431:
      if (lookahead == '\'') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(430);
      END_STATE();
    case 432:
      if (lookahead == '\'') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(429);
      END_STATE();
    case 433:
      if (lookahead == '\'') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(432);
      END_STATE();
    case 434:
      if (lookahead == '\'') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(433);
      END_STATE();
    case 435:
      if (lookahead == '\'') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(434);
      END_STATE();
    case 436:
      if (lookahead == '\'') ADVANCE(785);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(435);
      END_STATE();
    case 437:
      if (lookahead == '-') ADVANCE(794);
      END_STATE();
    case 438:
      if (lookahead == '.') ADVANCE(499);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(761);
      END_STATE();
    case 439:
      if (lookahead == ':') ADVANCE(626);
      END_STATE();
    case 440:
      if (lookahead == ':') ADVANCE(626);
      if (lookahead == '=') ADVANCE(627);
      END_STATE();
    case 441:
      if (lookahead == '=') ADVANCE(802);
      END_STATE();
    case 442:
      if (lookahead == '=') ADVANCE(802);
      if (lookahead == '>') ADVANCE(792);
      END_STATE();
    case 443:
      if (lookahead == '=') ADVANCE(790);
      END_STATE();
    case 444:
      if (lookahead == '>') ADVANCE(793);
      END_STATE();
    case 445:
      if (lookahead == '\\') ADVANCE(479);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(429);
      END_STATE();
    case 446:
      if (lookahead == '_') ADVANCE(499);
      if (lookahead == 'p') ADVANCE(484);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(446);
      END_STATE();
    case 447:
      if (lookahead == '`') ADVANCE(789);
      END_STATE();
    case 448:
      if (lookahead == 'a') ADVANCE(478);
      END_STATE();
    case 449:
      if (lookahead == 'a') ADVANCE(631);
      END_STATE();
    case 450:
      if (lookahead == 'a') ADVANCE(465);
      END_STATE();
    case 451:
      if (lookahead == 'c') ADVANCE(460);
      END_STATE();
    case 452:
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 453:
      if (lookahead == 'e') ADVANCE(579);
      END_STATE();
    case 454:
      if (lookahead == 'e') ADVANCE(636);
      END_STATE();
    case 455:
      if (lookahead == 'e') ADVANCE(577);
      END_STATE();
    case 456:
      if (lookahead == 'e') ADVANCE(474);
      END_STATE();
    case 457:
      if (lookahead == 'f') ADVANCE(573);
      if (lookahead == 'n') ADVANCE(598);
      if (lookahead == 's') ADVANCE(449);
      END_STATE();
    case 458:
      if (lookahead == 'f') ADVANCE(575);
      END_STATE();
    case 459:
      if (lookahead == 'h') ADVANCE(456);
      END_STATE();
    case 460:
      if (lookahead == 'h') ADVANCE(582);
      END_STATE();
    case 461:
      if (lookahead == 'i') ADVANCE(469);
      END_STATE();
    case 462:
      if (lookahead == 'i') ADVANCE(469);
      if (lookahead == 'o') ADVANCE(473);
      END_STATE();
    case 463:
      if (lookahead == 'l') ADVANCE(476);
      if (lookahead == 'n') ADVANCE(452);
      END_STATE();
    case 464:
      if (lookahead == 'l') ADVANCE(481);
      END_STATE();
    case 465:
      if (lookahead == 'l') ADVANCE(464);
      END_STATE();
    case 466:
      if (lookahead == 'l') ADVANCE(477);
      if (lookahead == 'n') ADVANCE(452);
      END_STATE();
    case 467:
      if (lookahead == 'n') ADVANCE(452);
      END_STATE();
    case 468:
      if (lookahead == 'n') ADVANCE(598);
      if (lookahead == 's') ADVANCE(449);
      END_STATE();
    case 469:
      if (lookahead == 'n') ADVANCE(450);
      END_STATE();
    case 470:
      if (lookahead == 'o') ADVANCE(473);
      END_STATE();
    case 471:
      if (lookahead == 'o') ADVANCE(618);
      END_STATE();
    case 472:
      if (lookahead == 'p') ADVANCE(484);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(446);
      END_STATE();
    case 473:
      if (lookahead == 'r') ADVANCE(586);
      END_STATE();
    case 474:
      if (lookahead == 'r') ADVANCE(454);
      END_STATE();
    case 475:
      if (lookahead == 's') ADVANCE(588);
      END_STATE();
    case 476:
      if (lookahead == 's') ADVANCE(453);
      END_STATE();
    case 477:
      if (lookahead == 's') ADVANCE(455);
      END_STATE();
    case 478:
      if (lookahead == 't') ADVANCE(451);
      END_STATE();
    case 479:
      if (lookahead == 'x') ADVANCE(503);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(498);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(431);
      if (lookahead != 0) ADVANCE(429);
      END_STATE();
    case 480:
      if (lookahead == 'x') ADVANCE(504);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(502);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(779);
      if (lookahead != 0) ADVANCE(777);
      END_STATE();
    case 481:
      if (lookahead == 'y') ADVANCE(584);
      END_STATE();
    case 482:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(490);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(775);
      END_STATE();
    case 483:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(491);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(768);
      END_STATE();
    case 484:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(492);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(776);
      END_STATE();
    case 485:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(494);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(774);
      END_STATE();
    case 486:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(759);
      END_STATE();
    case 487:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(760);
      END_STATE();
    case 488:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(764);
      END_STATE();
    case 489:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      END_STATE();
    case 490:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(775);
      END_STATE();
    case 491:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(768);
      END_STATE();
    case 492:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(776);
      END_STATE();
    case 493:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      END_STATE();
    case 494:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(774);
      END_STATE();
    case 495:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 496:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(429);
      END_STATE();
    case 497:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(761);
      END_STATE();
    case 498:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(436);
      END_STATE();
    case 499:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(446);
      END_STATE();
    case 500:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(762);
      END_STATE();
    case 501:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(777);
      END_STATE();
    case 502:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(784);
      END_STATE();
    case 503:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(496);
      END_STATE();
    case 504:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(501);
      END_STATE();
    case 505:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 838,
        '\r', 1,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(506);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 506:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 838,
        '\r', 1,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'e', 705,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(506);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 507:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 843,
        '\r', 16,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(509);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 508:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 843,
        '\r', 16,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(509);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 509:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 843,
        '\r', 16,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(509);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 510:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 843,
        '\r', 16,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(509);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 511:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 845,
        '\r', 21,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(512);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 512:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 845,
        '\r', 21,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'e', 711,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(512);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 513:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 854,
        '\r', 32,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(515);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 514:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 854,
        '\r', 32,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 608,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(515);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 515:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 854,
        '\r', 32,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(515);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 516:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 859,
        '\r', 43,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 707,
        'f', 694,
        'g', 699,
        'i', 672,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(517);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 517:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 859,
        '\r', 43,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(517);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 518:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 860,
        '\r', 44,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(519);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 519:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 860,
        '\r', 44,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(519);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 520:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 865,
        '\r', 53,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 609,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(521);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 521:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 865,
        '\r', 53,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 358,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(521);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 522:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 877,
        '\r', 78,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(524);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 523:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 877,
        '\r', 78,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(524);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 524:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 877,
        '\r', 78,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(524);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 525:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 882,
        '\r', 87,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(526);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 526:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 882,
        '\r', 87,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(526);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 527:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 883,
        '\r', 88,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 606,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(528);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 528:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 883,
        '\r', 88,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'd', 718,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(528);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 529:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 891,
        '\r', 103,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 606,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 610,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(530);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 530:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 891,
        '\r', 103,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 359,
        '/', 815,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(530);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 531:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 899,
        '\r', 128,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 612,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(532);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 532:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 899,
        '\r', 128,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 360,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(532);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 533:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 899,
        '\r', 128,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 611,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(532);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 534:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 899,
        '\r', 128,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        '0', 763,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'a', 735,
        'f', 722,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(532);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 535:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 906,
        '\r', 143,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 769,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(536);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 536:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 906,
        '\r', 143,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '&', 813,
        '\'', 445,
        '(', 592,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 361,
        '/', 816,
        ':', 623,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        '@', 638,
        '[', 596,
        '`', 788,
        'i', 712,
        'w', 683,
        '{', 603,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(536);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 537:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 914,
        '\r', 158,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'a', 652,
        'b', 645,
        'c', 649,
        'e', 707,
        'f', 695,
        'g', 699,
        'i', 675,
        'l', 667,
        'm', 720,
        'p', 726,
        'q', 752,
        's', 746,
        't', 727,
        'u', 736,
        'w', 680,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(538);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 538:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 914,
        '\r', 158,
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        '`', 788,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(538);
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 539:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 917,
        '\r', 162,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(540);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 540:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 917,
        '\r', 162,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(540);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 541:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 918,
        '\r', 163,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(542);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 542:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 918,
        '\r', 163,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(542);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 543:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 919,
        '\r', 164,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 613,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(544);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 544:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 919,
        '\r', 164,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(544);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 545:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 926,
        '\r', 177,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(546);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 546:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 926,
        '\r', 177,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(546);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 547:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 929,
        '\r', 182,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(548);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 548:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 929,
        '\r', 182,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'd', 471,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(548);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 549:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 930,
        '\r', 183,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '\'', 605,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 614,
        '/', 815,
        ':', 595,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(550);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 550:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 930,
        '\r', 183,
        '!', 441,
        '#', 980,
        '$', 443,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 833,
        '.', 421,
        '/', 815,
        ':', 440,
        ';', 977,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '\\', 817,
        '^', 825,
        'i', 712,
        'w', 683,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(550);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 551:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 932,
        '\r', 186,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 615,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(552);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 552:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 932,
        '\r', 186,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(552);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 553:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 933,
        '\r', 187,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 615,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(554);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 554:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 933,
        '\r', 187,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(554);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 555:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 933,
        '\r', 187,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 771,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'e', 463,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(554);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 556:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 946,
        '\r', 213,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(557);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 557:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 946,
        '\r', 213,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 835,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(557);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 558:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 950,
        '\r', 220,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(559);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 559:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 950,
        '\r', 220,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(559);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 560:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 956,
        '\r', 231,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(561);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 561:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 956,
        '\r', 231,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 735,
        'i', 712,
        'w', 683,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(561);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 562:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 958,
        '\r', 234,
        '#', 980,
        ',', 568,
        ';', 977,
        '=', 569,
        'c', 448,
        'e', 466,
        'f', 461,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(562);
      END_STATE();
    case 563:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 976,
        '\r', 279,
        '!', 441,
        '#', 980,
        '&', 813,
        '\'', 605,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 616,
        '/', 816,
        ':', 594,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'd', 471,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(564);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 564:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '\n', 976,
        '\r', 279,
        '!', 441,
        '#', 980,
        '&', 813,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 422,
        '/', 816,
        ':', 439,
        ';', 977,
        '<', 799,
        '=', 570,
        '>', 801,
        '?', 634,
        'a', 475,
        'c', 448,
        'd', 471,
        'e', 466,
        'f', 461,
        'i', 468,
        'w', 459,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(564);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 565:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 621,
        '%', 817,
        '&', 814,
        '\'', 445,
        '(', 592,
        ')', 593,
        '*', 817,
        '+', 831,
        ',', 568,
        '-', 834,
        '.', 836,
        '/', 815,
        '0', 763,
        ':', 624,
        ';', 602,
        '<', 798,
        '=', 570,
        '>', 800,
        '?', 634,
        '@', 638,
        '[', 596,
        '\\', 817,
        ']', 597,
        '^', 825,
        '`', 788,
        'a', 735,
        'c', 642,
        'd', 718,
        'e', 701,
        'f', 688,
        'i', 673,
        'w', 683,
        '{', 603,
        '|', 809,
        '}', 604,
        '~', 826,
        0xf7, 817,
        0x2208, 600,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(565);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 566:
      if (eof) ADVANCE(567);
      ADVANCE_MAP(
        '!', 829,
        '"', 786,
        '#', 980,
        '$', 620,
        '\'', 445,
        '(', 592,
        ')', 593,
        '+', 830,
        ',', 568,
        '-', 832,
        '.', 362,
        '/', 816,
        '0', 763,
        ':', 623,
        ';', 601,
        '<', 799,
        '=', 442,
        '>', 801,
        '@', 638,
        '[', 596,
        ']', 597,
        '`', 788,
        'f', 722,
        'i', 674,
        '{', 603,
        '|', 810,
        '}', 604,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        0x2194, 758,
        0x21a9, 758,
        0x21aa, 758,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(566);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(764);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      if (set_contains(sym__word_identifier_character_set_1, 816, lookahead)) ADVANCE(758);
      END_STATE();
    case 567:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(802);
      if (lookahead == '>') ADVANCE(792);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 572:
      ACCEPT_TOKEN(anon_sym_end);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 574:
      ACCEPT_TOKEN(anon_sym_if);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 575:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 576:
      ACCEPT_TOKEN(anon_sym_elseif);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(678);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(458);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(677);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 581:
      ACCEPT_TOKEN(anon_sym_else);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 582:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_catch);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 584:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_finally);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_for);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 589:
      ACCEPT_TOKEN(anon_sym_as);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(aux_sym_import_path_token1);
      ADVANCE_MAP(
        '!', 829,
        '+', 830,
        '-', 832,
        '.', 591,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(aux_sym_import_path_token1);
      if (lookahead == '.') ADVANCE(591);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 593:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(626);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(626);
      if (lookahead == '=') ADVANCE(627);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 597:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 598:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 599:
      ACCEPT_TOKEN(anon_sym_in);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 600:
      ACCEPT_TOKEN(anon_sym_u2208);
      END_STATE();
    case 601:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 602:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';') ADVANCE(977);
      END_STATE();
    case 603:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 604:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 605:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 606:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\\') ADVANCE(479);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(429);
      END_STATE();
    case 607:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 608:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 829,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        'E', 485,
        'e', 485,
        'f', 485,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 609:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 829,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 610:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 829,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 611:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 829,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        'E', 485,
        'e', 485,
        'f', 485,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 612:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 829,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 613:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 441,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        'E', 485,
        'e', 485,
        'f', 485,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 614:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 441,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 615:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 441,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        'E', 485,
        'e', 485,
        'f', 485,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 616:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '!', 441,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 617:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      END_STATE();
    case 618:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 619:
      ACCEPT_TOKEN(anon_sym_do);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 620:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 621:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '=') ADVANCE(790);
      END_STATE();
    case 622:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 623:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(626);
      END_STATE();
    case 624:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':') ADVANCE(626);
      if (lookahead == '=') ADVANCE(627);
      END_STATE();
    case 625:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == '=') ADVANCE(627);
      END_STATE();
    case 626:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 627:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 628:
      ACCEPT_TOKEN(anon_sym_DOT_EQ);
      if (lookahead == '=') ADVANCE(802);
      if (lookahead == '>') ADVANCE(792);
      END_STATE();
    case 629:
      ACCEPT_TOKEN(aux_sym_quote_expression_token1);
      if (lookahead == 'i') ADVANCE(677);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 630:
      ACCEPT_TOKEN(aux_sym_quote_expression_token1);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 631:
      ACCEPT_TOKEN(anon_sym_isa);
      END_STATE();
    case 632:
      ACCEPT_TOKEN(anon_sym_isa);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 633:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 634:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 635:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 636:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 637:
      ACCEPT_TOKEN(anon_sym_where);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 638:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 639:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(632);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 640:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(696);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 641:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(744);
      if (lookahead == 'o') ADVANCE(713);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 642:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(744);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 643:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(650);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 644:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(702);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 645:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(730);
      if (lookahead == 'r') ADVANCE(668);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 646:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(654);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 647:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(698);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 648:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(704);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 649:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'a') ADVANCE(750);
      if (lookahead == 'o') ADVANCE(713);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 650:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(703);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 651:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(741);
      if (lookahead == 's') ADVANCE(589);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 652:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(741);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 653:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'b') ADVANCE(647);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 654:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(743);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 655:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(682);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 656:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(681);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 657:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'c') ADVANCE(647);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 658:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'd') ADVANCE(572);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 659:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'd') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 660:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'd') ADVANCE(751);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 661:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 662:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(578);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 663:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(637);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 664:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(581);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 665:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(629);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 666:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(710);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 667:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(743);
      if (lookahead == 'o') ADVANCE(657);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 668:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(640);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 669:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(733);
      if (lookahead == 'i') ADVANCE(703);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 670:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(733);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 671:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'e') ADVANCE(580);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 672:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(574);
      if (lookahead == 'm') ADVANCE(725);
      if (lookahead == 'n') ADVANCE(599);
      if (lookahead == 's') ADVANCE(639);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 673:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(574);
      if (lookahead == 'n') ADVANCE(599);
      if (lookahead == 's') ADVANCE(639);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 674:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(574);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 675:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(725);
      if (lookahead == 'n') ADVANCE(599);
      if (lookahead == 's') ADVANCE(639);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 676:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(630);
      if (lookahead == 'm') ADVANCE(725);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 677:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 678:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'f') ADVANCE(576);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 679:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'g') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 680:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(669);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 681:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 682:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(583);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 683:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(670);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 684:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'h') ADVANCE(687);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 685:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(709);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 686:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(755);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 687:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(703);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 688:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(716);
      if (lookahead == 'o') ADVANCE(728);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 689:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(716);
      if (lookahead == 'o') ADVANCE(729);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 690:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(716);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 691:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(714);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 692:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(715);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 693:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(745);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 694:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(717);
      if (lookahead == 'o') ADVANCE(728);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 695:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'i') ADVANCE(717);
      if (lookahead == 'o') ADVANCE(729);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 696:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'k') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 697:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(756);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 698:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 699:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(719);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 700:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(757);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 701:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(738);
      if (lookahead == 'n') ADVANCE(658);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 702:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(700);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 703:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(661);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 704:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(697);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 705:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(739);
      if (lookahead == 'n') ADVANCE(658);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 706:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(740);
      if (lookahead == 'n') ADVANCE(658);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 707:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(740);
      if (lookahead == 'n') ADVANCE(659);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 708:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'l') ADVANCE(742);
      if (lookahead == 'n') ADVANCE(658);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 709:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'm') ADVANCE(693);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 710:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'm') ADVANCE(721);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 711:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(658);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 712:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(599);
      if (lookahead == 's') ADVANCE(639);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 713:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(737);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 714:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(679);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 715:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(754);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 716:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(644);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 717:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'n') ADVANCE(648);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 718:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(619);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 719:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(653);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 720:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(660);
      if (lookahead == 'u') ADVANCE(748);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 721:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(660);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 722:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(728);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 723:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(747);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 724:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'o') ADVANCE(732);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 725:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'p') ADVANCE(724);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 726:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(685);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 727:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(756);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 728:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(587);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 729:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 730:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(666);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 731:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(753);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 732:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(743);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 733:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(663);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 734:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'r') ADVANCE(646);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 735:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(589);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 736:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(691);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 737:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(743);
      if (lookahead == 't') ADVANCE(692);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 738:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(662);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 739:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(664);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 740:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(665);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 741:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(749);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 742:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 's') ADVANCE(671);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 743:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 744:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(655);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 745:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(686);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 746:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(731);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 747:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(661);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 748:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(643);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 749:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(734);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 750:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 't') ADVANCE(656);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 751:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(703);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 752:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(723);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 753:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(654);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 754:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'u') ADVANCE(661);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 755:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'v') ADVANCE(661);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 756:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'y') ADVANCE(630);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 757:
      ACCEPT_TOKEN(sym__word_identifier);
      if (lookahead == 'y') ADVANCE(585);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 758:
      ACCEPT_TOKEN(sym__word_identifier);
      if ((!eof && set_contains(sym__word_identifier_character_set_2, 94, lookahead))) ADVANCE(758);
      END_STATE();
    case 759:
      ACCEPT_TOKEN(aux_sym_integer_literal_token1);
      if (lookahead == '_') ADVANCE(486);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(759);
      END_STATE();
    case 760:
      ACCEPT_TOKEN(aux_sym_integer_literal_token2);
      if (lookahead == '_') ADVANCE(487);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(760);
      END_STATE();
    case 761:
      ACCEPT_TOKEN(aux_sym_integer_literal_token3);
      if (lookahead == '.') ADVANCE(472);
      if (lookahead == '_') ADVANCE(497);
      if (lookahead == 'p') ADVANCE(484);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(761);
      END_STATE();
    case 762:
      ACCEPT_TOKEN(aux_sym_integer_literal_token3);
      if (lookahead == '_') ADVANCE(500);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(762);
      END_STATE();
    case 763:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(488);
      if (lookahead == 'b') ADVANCE(486);
      if (lookahead == 'o') ADVANCE(487);
      if (lookahead == 'x') ADVANCE(438);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(482);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(764);
      END_STATE();
    case 764:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(488);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(482);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(764);
      END_STATE();
    case 765:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(495);
      if (lookahead == 'b') ADVANCE(486);
      if (lookahead == 'o') ADVANCE(487);
      if (lookahead == 'x') ADVANCE(500);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 766:
      ACCEPT_TOKEN(aux_sym_integer_literal_token4);
      if (lookahead == '_') ADVANCE(495);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(766);
      END_STATE();
    case 767:
      ACCEPT_TOKEN(aux_sym_float_literal_token1);
      if (lookahead == '_') ADVANCE(489);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(483);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      END_STATE();
    case 768:
      ACCEPT_TOKEN(aux_sym_float_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(768);
      END_STATE();
    case 769:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      ADVANCE_MAP(
        '!', 829,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        'E', 485,
        'e', 485,
        'f', 485,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 770:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      ADVANCE_MAP(
        '!', 829,
        '+', 830,
        '-', 832,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
        'E', 485,
        'e', 485,
        'f', 485,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == '.' ||
          lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 771:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      ADVANCE_MAP(
        '!', 441,
        '&', 813,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 811,
        0xb1, 807,
        0x2213, 807,
        'E', 485,
        'e', 485,
        'f', 485,
      );
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 772:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (lookahead == '_') ADVANCE(493);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      END_STATE();
    case 773:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (lookahead == 'E' ||
          lookahead == 'e' ||
          lookahead == 'f') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(772);
      END_STATE();
    case 774:
      ACCEPT_TOKEN(aux_sym_float_literal_token2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(774);
      END_STATE();
    case 775:
      ACCEPT_TOKEN(aux_sym_float_literal_token3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(775);
      END_STATE();
    case 776:
      ACCEPT_TOKEN(aux_sym_float_literal_token4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(776);
      END_STATE();
    case 777:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 778:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(777);
      END_STATE();
    case 779:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(778);
      END_STATE();
    case 780:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(777);
      END_STATE();
    case 781:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(780);
      END_STATE();
    case 782:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(781);
      END_STATE();
    case 783:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(782);
      END_STATE();
    case 784:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(783);
      END_STATE();
    case 785:
      ACCEPT_TOKEN(sym_character_literal);
      END_STATE();
    case 786:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(423);
      END_STATE();
    case 787:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 788:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      if (lookahead == '`') ADVANCE(447);
      END_STATE();
    case 789:
      ACCEPT_TOKEN(anon_sym_BQUOTE_BQUOTE_BQUOTE);
      END_STATE();
    case 790:
      ACCEPT_TOKEN(anon_sym_DOLLAR_EQ);
      END_STATE();
    case 791:
      ACCEPT_TOKEN(aux_sym__assignment_operator_token1);
      END_STATE();
    case 792:
      ACCEPT_TOKEN(sym__pair_operator);
      END_STATE();
    case 793:
      ACCEPT_TOKEN(sym__arrow_operator);
      END_STATE();
    case 794:
      ACCEPT_TOKEN(sym__arrow_operator);
      if (lookahead == '>') ADVANCE(793);
      END_STATE();
    case 795:
      ACCEPT_TOKEN(sym__lazy_or_operator);
      END_STATE();
    case 796:
      ACCEPT_TOKEN(sym__lazy_and_operator);
      END_STATE();
    case 797:
      ACCEPT_TOKEN(sym__comparison_operator);
      END_STATE();
    case 798:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(437);
      if (lookahead == ':') ADVANCE(827);
      if (lookahead == '<') ADVANCE(821);
      if (lookahead == '=') ADVANCE(797);
      if (lookahead == '|') ADVANCE(804);
      END_STATE();
    case 799:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '-') ADVANCE(437);
      if (lookahead == ':') ADVANCE(827);
      if (lookahead == '<') ADVANCE(820);
      if (lookahead == '=') ADVANCE(797);
      if (lookahead == '|') ADVANCE(804);
      END_STATE();
    case 800:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':') ADVANCE(827);
      if (lookahead == '=') ADVANCE(797);
      if (lookahead == '>') ADVANCE(822);
      END_STATE();
    case 801:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == ':') ADVANCE(827);
      if (lookahead == '=') ADVANCE(797);
      if (lookahead == '>') ADVANCE(823);
      END_STATE();
    case 802:
      ACCEPT_TOKEN(sym__comparison_operator);
      if (lookahead == '=') ADVANCE(797);
      END_STATE();
    case 803:
      ACCEPT_TOKEN(sym__pipe_right_operator);
      END_STATE();
    case 804:
      ACCEPT_TOKEN(sym__pipe_left_operator);
      END_STATE();
    case 805:
      ACCEPT_TOKEN(sym__ellipsis_operator);
      END_STATE();
    case 806:
      ACCEPT_TOKEN(sym__ellipsis_operator);
      if (lookahead == '.') ADVANCE(633);
      END_STATE();
    case 807:
      ACCEPT_TOKEN(sym__plus_operator);
      END_STATE();
    case 808:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 809:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '=') ADVANCE(791);
      if (lookahead == '>') ADVANCE(803);
      if (lookahead == '|') ADVANCE(795);
      END_STATE();
    case 810:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '>') ADVANCE(803);
      END_STATE();
    case 811:
      ACCEPT_TOKEN(sym__plus_operator);
      if (lookahead == '>') ADVANCE(803);
      if (lookahead == '|') ADVANCE(795);
      END_STATE();
    case 812:
      ACCEPT_TOKEN(sym__times_operator);
      END_STATE();
    case 813:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '&') ADVANCE(796);
      END_STATE();
    case 814:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '&') ADVANCE(796);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 815:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '/') ADVANCE(819);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 816:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '/') ADVANCE(818);
      END_STATE();
    case 817:
      ACCEPT_TOKEN(sym__times_operator);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 818:
      ACCEPT_TOKEN(sym__rational_operator);
      END_STATE();
    case 819:
      ACCEPT_TOKEN(sym__rational_operator);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 820:
      ACCEPT_TOKEN(sym__bitshift_operator);
      END_STATE();
    case 821:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 822:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '=') ADVANCE(791);
      if (lookahead == '>') ADVANCE(821);
      END_STATE();
    case 823:
      ACCEPT_TOKEN(sym__bitshift_operator);
      if (lookahead == '>') ADVANCE(820);
      END_STATE();
    case 824:
      ACCEPT_TOKEN(sym__power_operator);
      END_STATE();
    case 825:
      ACCEPT_TOKEN(sym__power_operator);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 826:
      ACCEPT_TOKEN(sym__tilde_operator);
      END_STATE();
    case 827:
      ACCEPT_TOKEN(sym__type_order_operator);
      END_STATE();
    case 828:
      ACCEPT_TOKEN(sym__unary_operator);
      END_STATE();
    case 829:
      ACCEPT_TOKEN(sym__unary_operator);
      if (lookahead == '=') ADVANCE(802);
      END_STATE();
    case 830:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '+') ADVANCE(807);
      END_STATE();
    case 831:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '+') ADVANCE(807);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 832:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(444);
      END_STATE();
    case 833:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(444);
      if (lookahead == '=') ADVANCE(791);
      END_STATE();
    case 834:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(444);
      if (lookahead == '=') ADVANCE(791);
      if (lookahead == '>') ADVANCE(635);
      END_STATE();
    case 835:
      ACCEPT_TOKEN(sym__unary_plus_operator);
      if (lookahead == '-') ADVANCE(444);
      if (lookahead == '>') ADVANCE(635);
      END_STATE();
    case 836:
      ACCEPT_TOKEN(anon_sym_DOT2);
      ADVANCE_MAP(
        '!', 829,
        '%', 817,
        '&', 814,
        '*', 817,
        '+', 831,
        '-', 833,
        '.', 806,
        '/', 815,
        '<', 798,
        '=', 628,
        '>', 800,
        '\\', 817,
        '^', 825,
        '|', 809,
        '~', 826,
        0xf7, 817,
        0x2212, 808,
        0x22bb, 808,
        0xb1, 807,
        0x2213, 807,
        0x2254, 791,
        0x2255, 791,
        0x2a74, 791,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(767);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 837:
      ACCEPT_TOKEN(anon_sym_DOT2);
      ADVANCE_MAP(
        '!', 829,
        '+', 830,
        '-', 832,
        '.', 806,
        '/', 816,
        '<', 799,
        '=', 442,
        '>', 801,
        '|', 810,
        '~', 826,
        0xb1, 807,
        0x2213, 807,
      );
      if (lookahead == 0xac ||
          (0x221a <= lookahead && lookahead <= 0x221c)) ADVANCE(828);
      if (lookahead == 0x2026 ||
          lookahead == 0x205d ||
          (0x22ee <= lookahead && lookahead <= 0x22f1)) ADVANCE(805);
      if (set_contains(sym__power_operator_character_set_2, 20, lookahead)) ADVANCE(824);
      if (set_contains(sym__plus_operator_character_set_2, 32, lookahead)) ADVANCE(807);
      if (set_contains(sym__times_operator_character_set_2, 47, lookahead)) ADVANCE(812);
      if (set_contains(sym__arrow_operator_character_set_2, 50, lookahead)) ADVANCE(793);
      if (set_contains(sym__comparison_operator_character_set_2, 34, lookahead)) ADVANCE(797);
      END_STATE();
    case 838:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(838);
      if (lookahead == '\r') ADVANCE(1);
      END_STATE();
    case 839:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(839);
      if (lookahead == '\r') ADVANCE(3);
      END_STATE();
    case 840:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(840);
      if (lookahead == '\r') ADVANCE(6);
      END_STATE();
    case 841:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(841);
      if (lookahead == '\r') ADVANCE(10);
      END_STATE();
    case 842:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(842);
      if (lookahead == '\r') ADVANCE(14);
      END_STATE();
    case 843:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(843);
      if (lookahead == '\r') ADVANCE(16);
      END_STATE();
    case 844:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(844);
      if (lookahead == '\r') ADVANCE(19);
      END_STATE();
    case 845:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(845);
      if (lookahead == '\r') ADVANCE(21);
      END_STATE();
    case 846:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(846);
      if (lookahead == '\r') ADVANCE(22);
      END_STATE();
    case 847:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(847);
      if (lookahead == '\r') ADVANCE(24);
      END_STATE();
    case 848:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(848);
      if (lookahead == '\r') ADVANCE(26);
      END_STATE();
    case 849:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(849);
      if (lookahead == '\r') ADVANCE(27);
      END_STATE();
    case 850:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(850);
      if (lookahead == '\r') ADVANCE(28);
      END_STATE();
    case 851:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(851);
      if (lookahead == '\r') ADVANCE(29);
      END_STATE();
    case 852:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(852);
      if (lookahead == '\r') ADVANCE(30);
      END_STATE();
    case 853:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(853);
      if (lookahead == '\r') ADVANCE(31);
      END_STATE();
    case 854:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(854);
      if (lookahead == '\r') ADVANCE(32);
      END_STATE();
    case 855:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(855);
      if (lookahead == '\r') ADVANCE(35);
      END_STATE();
    case 856:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(856);
      if (lookahead == '\r') ADVANCE(38);
      END_STATE();
    case 857:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(857);
      if (lookahead == '\r') ADVANCE(40);
      END_STATE();
    case 858:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(858);
      if (lookahead == '\r') ADVANCE(42);
      END_STATE();
    case 859:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(859);
      if (lookahead == '\r') ADVANCE(43);
      END_STATE();
    case 860:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(860);
      if (lookahead == '\r') ADVANCE(44);
      END_STATE();
    case 861:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(861);
      if (lookahead == '\r') ADVANCE(46);
      END_STATE();
    case 862:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(862);
      if (lookahead == '\r') ADVANCE(48);
      END_STATE();
    case 863:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(863);
      if (lookahead == '\r') ADVANCE(50);
      END_STATE();
    case 864:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(864);
      if (lookahead == '\r') ADVANCE(52);
      END_STATE();
    case 865:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(865);
      if (lookahead == '\r') ADVANCE(53);
      END_STATE();
    case 866:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(866);
      if (lookahead == '\r') ADVANCE(55);
      END_STATE();
    case 867:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(867);
      if (lookahead == '\r') ADVANCE(57);
      END_STATE();
    case 868:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(868);
      if (lookahead == '\r') ADVANCE(59);
      END_STATE();
    case 869:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(869);
      if (lookahead == '\r') ADVANCE(61);
      END_STATE();
    case 870:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(870);
      if (lookahead == '\r') ADVANCE(63);
      END_STATE();
    case 871:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(871);
      if (lookahead == '\r') ADVANCE(65);
      END_STATE();
    case 872:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(872);
      if (lookahead == '\r') ADVANCE(68);
      END_STATE();
    case 873:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(873);
      if (lookahead == '\r') ADVANCE(70);
      END_STATE();
    case 874:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(874);
      if (lookahead == '\r') ADVANCE(73);
      END_STATE();
    case 875:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(875);
      if (lookahead == '\r') ADVANCE(75);
      END_STATE();
    case 876:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(876);
      if (lookahead == '\r') ADVANCE(77);
      END_STATE();
    case 877:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(877);
      if (lookahead == '\r') ADVANCE(78);
      END_STATE();
    case 878:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(878);
      if (lookahead == '\r') ADVANCE(80);
      END_STATE();
    case 879:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(879);
      if (lookahead == '\r') ADVANCE(82);
      END_STATE();
    case 880:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(880);
      if (lookahead == '\r') ADVANCE(84);
      END_STATE();
    case 881:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(881);
      if (lookahead == '\r') ADVANCE(86);
      END_STATE();
    case 882:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(882);
      if (lookahead == '\r') ADVANCE(87);
      END_STATE();
    case 883:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(883);
      if (lookahead == '\r') ADVANCE(88);
      END_STATE();
    case 884:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(884);
      if (lookahead == '\r') ADVANCE(90);
      END_STATE();
    case 885:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(885);
      if (lookahead == '\r') ADVANCE(92);
      END_STATE();
    case 886:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(886);
      if (lookahead == '\r') ADVANCE(94);
      END_STATE();
    case 887:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(887);
      if (lookahead == '\r') ADVANCE(96);
      END_STATE();
    case 888:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(888);
      if (lookahead == '\r') ADVANCE(98);
      END_STATE();
    case 889:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(889);
      if (lookahead == '\r') ADVANCE(100);
      END_STATE();
    case 890:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(890);
      if (lookahead == '\r') ADVANCE(102);
      END_STATE();
    case 891:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(891);
      if (lookahead == '\r') ADVANCE(103);
      END_STATE();
    case 892:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(892);
      if (lookahead == '\r') ADVANCE(105);
      END_STATE();
    case 893:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(893);
      if (lookahead == '\r') ADVANCE(107);
      END_STATE();
    case 894:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(894);
      if (lookahead == '\r') ADVANCE(109);
      END_STATE();
    case 895:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(895);
      if (lookahead == '\r') ADVANCE(113);
      END_STATE();
    case 896:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(896);
      if (lookahead == '\r') ADVANCE(117);
      END_STATE();
    case 897:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(897);
      if (lookahead == '\r') ADVANCE(121);
      END_STATE();
    case 898:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(898);
      if (lookahead == '\r') ADVANCE(125);
      END_STATE();
    case 899:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(899);
      if (lookahead == '\r') ADVANCE(128);
      END_STATE();
    case 900:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(900);
      if (lookahead == '\r') ADVANCE(130);
      END_STATE();
    case 901:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(901);
      if (lookahead == '\r') ADVANCE(134);
      END_STATE();
    case 902:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(902);
      if (lookahead == '\r') ADVANCE(136);
      END_STATE();
    case 903:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(903);
      if (lookahead == '\r') ADVANCE(138);
      END_STATE();
    case 904:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(904);
      if (lookahead == '\r') ADVANCE(140);
      END_STATE();
    case 905:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(905);
      if (lookahead == '\r') ADVANCE(142);
      END_STATE();
    case 906:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(906);
      if (lookahead == '\r') ADVANCE(143);
      END_STATE();
    case 907:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(907);
      if (lookahead == '\r') ADVANCE(145);
      END_STATE();
    case 908:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(908);
      if (lookahead == '\r') ADVANCE(147);
      END_STATE();
    case 909:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(909);
      if (lookahead == '\r') ADVANCE(149);
      END_STATE();
    case 910:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(910);
      if (lookahead == '\r') ADVANCE(151);
      END_STATE();
    case 911:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(911);
      if (lookahead == '\r') ADVANCE(153);
      END_STATE();
    case 912:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(912);
      if (lookahead == '\r') ADVANCE(155);
      END_STATE();
    case 913:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(913);
      if (lookahead == '\r') ADVANCE(157);
      END_STATE();
    case 914:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(914);
      if (lookahead == '\r') ADVANCE(158);
      END_STATE();
    case 915:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(915);
      if (lookahead == '\r') ADVANCE(159);
      END_STATE();
    case 916:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(916);
      if (lookahead == '\r') ADVANCE(160);
      END_STATE();
    case 917:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(917);
      if (lookahead == '\r') ADVANCE(162);
      END_STATE();
    case 918:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(918);
      if (lookahead == '\r') ADVANCE(163);
      END_STATE();
    case 919:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(919);
      if (lookahead == '\r') ADVANCE(164);
      END_STATE();
    case 920:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(920);
      if (lookahead == '\r') ADVANCE(166);
      END_STATE();
    case 921:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(921);
      if (lookahead == '\r') ADVANCE(168);
      END_STATE();
    case 922:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(922);
      if (lookahead == '\r') ADVANCE(170);
      END_STATE();
    case 923:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(923);
      if (lookahead == '\r') ADVANCE(172);
      END_STATE();
    case 924:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(924);
      if (lookahead == '\r') ADVANCE(174);
      END_STATE();
    case 925:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(925);
      if (lookahead == '\r') ADVANCE(176);
      END_STATE();
    case 926:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(926);
      if (lookahead == '\r') ADVANCE(177);
      END_STATE();
    case 927:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(927);
      if (lookahead == '\r') ADVANCE(179);
      END_STATE();
    case 928:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(928);
      if (lookahead == '\r') ADVANCE(181);
      END_STATE();
    case 929:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(929);
      if (lookahead == '\r') ADVANCE(182);
      END_STATE();
    case 930:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(930);
      if (lookahead == '\r') ADVANCE(183);
      END_STATE();
    case 931:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(931);
      if (lookahead == '\r') ADVANCE(185);
      END_STATE();
    case 932:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(932);
      if (lookahead == '\r') ADVANCE(186);
      END_STATE();
    case 933:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(933);
      if (lookahead == '\r') ADVANCE(187);
      END_STATE();
    case 934:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(934);
      if (lookahead == '\r') ADVANCE(189);
      END_STATE();
    case 935:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(935);
      if (lookahead == '\r') ADVANCE(191);
      END_STATE();
    case 936:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(936);
      if (lookahead == '\r') ADVANCE(193);
      END_STATE();
    case 937:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(937);
      if (lookahead == '\r') ADVANCE(195);
      END_STATE();
    case 938:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(938);
      if (lookahead == '\r') ADVANCE(197);
      END_STATE();
    case 939:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(939);
      if (lookahead == '\r') ADVANCE(199);
      END_STATE();
    case 940:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(940);
      if (lookahead == '\r') ADVANCE(201);
      END_STATE();
    case 941:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(941);
      if (lookahead == '\r') ADVANCE(203);
      END_STATE();
    case 942:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(942);
      if (lookahead == '\r') ADVANCE(205);
      END_STATE();
    case 943:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(943);
      if (lookahead == '\r') ADVANCE(207);
      END_STATE();
    case 944:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(944);
      if (lookahead == '\r') ADVANCE(209);
      END_STATE();
    case 945:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(945);
      if (lookahead == '\r') ADVANCE(212);
      END_STATE();
    case 946:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(946);
      if (lookahead == '\r') ADVANCE(213);
      END_STATE();
    case 947:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(947);
      if (lookahead == '\r') ADVANCE(215);
      END_STATE();
    case 948:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(948);
      if (lookahead == '\r') ADVANCE(217);
      END_STATE();
    case 949:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(949);
      if (lookahead == '\r') ADVANCE(219);
      END_STATE();
    case 950:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(950);
      if (lookahead == '\r') ADVANCE(220);
      END_STATE();
    case 951:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(951);
      if (lookahead == '\r') ADVANCE(222);
      END_STATE();
    case 952:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(952);
      if (lookahead == '\r') ADVANCE(224);
      END_STATE();
    case 953:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(953);
      if (lookahead == '\r') ADVANCE(226);
      END_STATE();
    case 954:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(954);
      if (lookahead == '\r') ADVANCE(228);
      END_STATE();
    case 955:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(955);
      if (lookahead == '\r') ADVANCE(230);
      END_STATE();
    case 956:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(956);
      if (lookahead == '\r') ADVANCE(231);
      END_STATE();
    case 957:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(957);
      if (lookahead == '\r') ADVANCE(233);
      END_STATE();
    case 958:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(958);
      if (lookahead == '\r') ADVANCE(234);
      END_STATE();
    case 959:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(959);
      if (lookahead == '\r') ADVANCE(235);
      END_STATE();
    case 960:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(960);
      if (lookahead == '\r') ADVANCE(238);
      END_STATE();
    case 961:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(961);
      if (lookahead == '\r') ADVANCE(241);
      END_STATE();
    case 962:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(962);
      if (lookahead == '\r') ADVANCE(245);
      END_STATE();
    case 963:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(963);
      if (lookahead == '\r') ADVANCE(248);
      END_STATE();
    case 964:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(964);
      if (lookahead == '\r') ADVANCE(251);
      END_STATE();
    case 965:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(965);
      if (lookahead == '\r') ADVANCE(254);
      END_STATE();
    case 966:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(966);
      if (lookahead == '\r') ADVANCE(257);
      END_STATE();
    case 967:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(967);
      if (lookahead == '\r') ADVANCE(260);
      END_STATE();
    case 968:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(968);
      if (lookahead == '\r') ADVANCE(262);
      END_STATE();
    case 969:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(969);
      if (lookahead == '\r') ADVANCE(265);
      END_STATE();
    case 970:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(970);
      if (lookahead == '\r') ADVANCE(267);
      END_STATE();
    case 971:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(971);
      if (lookahead == '\r') ADVANCE(269);
      END_STATE();
    case 972:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(972);
      if (lookahead == '\r') ADVANCE(272);
      END_STATE();
    case 973:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(973);
      if (lookahead == '\r') ADVANCE(274);
      END_STATE();
    case 974:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(974);
      if (lookahead == '\r') ADVANCE(276);
      END_STATE();
    case 975:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(975);
      if (lookahead == '\r') ADVANCE(278);
      END_STATE();
    case 976:
      ACCEPT_TOKEN(aux_sym__terminator_token1);
      if (lookahead == '\n') ADVANCE(976);
      if (lookahead == '\r') ADVANCE(279);
      END_STATE();
    case 977:
      ACCEPT_TOKEN(aux_sym__terminator_token2);
      if (lookahead == ';') ADVANCE(977);
      END_STATE();
    case 978:
      ACCEPT_TOKEN(aux_sym_block_comment_token1);
      END_STATE();
    case 979:
      ACCEPT_TOKEN(aux_sym_block_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(983);
      END_STATE();
    case 980:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == '=') ADVANCE(978);
      END_STATE();
    case 981:
      ACCEPT_TOKEN(aux_sym_line_comment_token1);
      if (lookahead == '=') ADVANCE(979);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(983);
      END_STATE();
    case 982:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead == '#') ADVANCE(981);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(982);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(983);
      END_STATE();
    case 983:
      ACCEPT_TOKEN(aux_sym_line_comment_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(983);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'e', 4,
        'f', 5,
        'g', 6,
        'i', 7,
        'l', 8,
        'm', 9,
        'o', 10,
        'p', 11,
        'q', 12,
        'r', 13,
        's', 14,
        't', 15,
        'u', 16,
        'w', 17,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b') ADVANCE(18);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(19);
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'r') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 4:
      if (lookahead == 'x') ADVANCE(23);
      END_STATE();
    case 5:
      if (lookahead == 'a') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(26);
      END_STATE();
    case 7:
      if (lookahead == 'm') ADVANCE(27);
      END_STATE();
    case 8:
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 10:
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(34);
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 12:
      if (lookahead == 'u') ADVANCE(36);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(37);
      END_STATE();
    case 14:
      if (lookahead == 't') ADVANCE(38);
      END_STATE();
    case 15:
      if (lookahead == 'r') ADVANCE(39);
      if (lookahead == 'y') ADVANCE(40);
      END_STATE();
    case 16:
      if (lookahead == 's') ADVANCE(41);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(42);
      END_STATE();
    case 18:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(44);
      END_STATE();
    case 20:
      if (lookahead == 'g') ADVANCE(45);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(46);
      END_STATE();
    case 22:
      if (lookahead == 'n') ADVANCE(47);
      END_STATE();
    case 23:
      if (lookahead == 'p') ADVANCE(48);
      END_STATE();
    case 24:
      if (lookahead == 'l') ADVANCE(49);
      END_STATE();
    case 25:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 26:
      if (lookahead == 'o') ADVANCE(51);
      END_STATE();
    case 27:
      if (lookahead == 'p') ADVANCE(52);
      END_STATE();
    case 28:
      if (lookahead == 't') ADVANCE(53);
      END_STATE();
    case 29:
      if (lookahead == 'c') ADVANCE(54);
      END_STATE();
    case 30:
      if (lookahead == 'c') ADVANCE(55);
      END_STATE();
    case 31:
      if (lookahead == 'd') ADVANCE(56);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(57);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(58);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(59);
      END_STATE();
    case 35:
      if (lookahead == 'b') ADVANCE(60);
      END_STATE();
    case 36:
      if (lookahead == 'o') ADVANCE(61);
      END_STATE();
    case 37:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == 'r') ADVANCE(63);
      END_STATE();
    case 39:
      if (lookahead == 'u') ADVANCE(64);
      if (lookahead == 'y') ADVANCE(65);
      END_STATE();
    case 40:
      if (lookahead == 'p') ADVANCE(66);
      END_STATE();
    case 41:
      if (lookahead == 'i') ADVANCE(67);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 45:
      if (lookahead == 'i') ADVANCE(71);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(72);
      END_STATE();
    case 47:
      if (lookahead == 's') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 49:
      if (lookahead == 's') ADVANCE(76);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(77);
      END_STATE();
    case 51:
      if (lookahead == 'b') ADVANCE(78);
      END_STATE();
    case 52:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(80);
      END_STATE();
    case 55:
      if (lookahead == 'r') ADVANCE(81);
      END_STATE();
    case 56:
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(84);
      END_STATE();
    case 59:
      if (lookahead == 'm') ADVANCE(85);
      END_STATE();
    case 60:
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 61:
      if (lookahead == 't') ADVANCE(87);
      END_STATE();
    case 62:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(89);
      END_STATE();
    case 64:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(91);
      END_STATE();
    case 67:
      if (lookahead == 'n') ADVANCE(92);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 69:
      if (lookahead == 'r') ADVANCE(94);
      END_STATE();
    case 70:
      if (lookahead == 'm') ADVANCE(95);
      END_STATE();
    case 71:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 72:
      if (lookahead == 'k') ADVANCE(97);
      END_STATE();
    case 73:
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 75:
      if (lookahead == 'r') ADVANCE(100);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(102);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(103);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(104);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(105);
      END_STATE();
    case 81:
      if (lookahead == 'o') ADVANCE(106);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(107);
      END_STATE();
    case 83:
      if (lookahead == 'b') ADVANCE(108);
      END_STATE();
    case 84:
      if (lookahead == 'r') ADVANCE(109);
      END_STATE();
    case 85:
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 86:
      if (lookahead == 'i') ADVANCE(111);
      END_STATE();
    case 87:
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(113);
      END_STATE();
    case 89:
      if (lookahead == 'c') ADVANCE(114);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 92:
      if (lookahead == 'g') ADVANCE(115);
      END_STATE();
    case 93:
      if (lookahead == 'e') ADVANCE(116);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(117);
      END_STATE();
    case 95:
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 99:
      if (lookahead == 'n') ADVANCE(119);
      END_STATE();
    case 100:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 102:
      if (lookahead == 'i') ADVANCE(121);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(122);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(123);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_macro);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(124);
      END_STATE();
    case 108:
      if (lookahead == 'l') ADVANCE(125);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_outer);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 111:
      if (lookahead == 'c') ADVANCE(127);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 117:
      if (lookahead == 'c') ADVANCE(130);
      END_STATE();
    case 118:
      if (lookahead == 'd') ADVANCE(131);
      END_STATE();
    case 119:
      if (lookahead == 'u') ADVANCE(132);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(133);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(134);
      END_STATE();
    case 126:
      if (lookahead == 'i') ADVANCE(135);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 130:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 131:
      if (lookahead == 'u') ADVANCE(137);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 133:
      if (lookahead == 'n') ADVANCE(139);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_mutable);
      END_STATE();
    case 135:
      if (lookahead == 'v') ADVANCE(140);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 137:
      if (lookahead == 'l') ADVANCE(141);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(142);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(143);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_primitive);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_baremodule);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 566},
  [2] = {.lex_state = 505, .external_lex_state = 2},
  [3] = {.lex_state = 2, .external_lex_state = 2},
  [4] = {.lex_state = 4, .external_lex_state = 3},
  [5] = {.lex_state = 4, .external_lex_state = 3},
  [6] = {.lex_state = 8, .external_lex_state = 3},
  [7] = {.lex_state = 8, .external_lex_state = 3},
  [8] = {.lex_state = 8, .external_lex_state = 3},
  [9] = {.lex_state = 8, .external_lex_state = 3},
  [10] = {.lex_state = 4, .external_lex_state = 3},
  [11] = {.lex_state = 4, .external_lex_state = 3},
  [12] = {.lex_state = 239, .external_lex_state = 3},
  [13] = {.lex_state = 4, .external_lex_state = 3},
  [14] = {.lex_state = 12, .external_lex_state = 3},
  [15] = {.lex_state = 12, .external_lex_state = 3},
  [16] = {.lex_state = 239, .external_lex_state = 3},
  [17] = {.lex_state = 239, .external_lex_state = 3},
  [18] = {.lex_state = 4, .external_lex_state = 3},
  [19] = {.lex_state = 8, .external_lex_state = 3},
  [20] = {.lex_state = 8, .external_lex_state = 3},
  [21] = {.lex_state = 4, .external_lex_state = 3},
  [22] = {.lex_state = 4, .external_lex_state = 3},
  [23] = {.lex_state = 507, .external_lex_state = 3},
  [24] = {.lex_state = 507, .external_lex_state = 3},
  [25] = {.lex_state = 8, .external_lex_state = 3},
  [26] = {.lex_state = 17, .external_lex_state = 3},
  [27] = {.lex_state = 17, .external_lex_state = 3},
  [28] = {.lex_state = 17, .external_lex_state = 3},
  [29] = {.lex_state = 17, .external_lex_state = 3},
  [30] = {.lex_state = 8, .external_lex_state = 3},
  [31] = {.lex_state = 12, .external_lex_state = 3},
  [32] = {.lex_state = 12, .external_lex_state = 3},
  [33] = {.lex_state = 239, .external_lex_state = 3},
  [34] = {.lex_state = 314, .external_lex_state = 3},
  [35] = {.lex_state = 314, .external_lex_state = 3},
  [36] = {.lex_state = 17, .external_lex_state = 3},
  [37] = {.lex_state = 17, .external_lex_state = 3},
  [38] = {.lex_state = 507, .external_lex_state = 3},
  [39] = {.lex_state = 507, .external_lex_state = 3},
  [40] = {.lex_state = 511, .external_lex_state = 3},
  [41] = {.lex_state = 511, .external_lex_state = 3},
  [42] = {.lex_state = 314, .external_lex_state = 3},
  [43] = {.lex_state = 17, .external_lex_state = 3},
  [44] = {.lex_state = 17, .external_lex_state = 3},
  [45] = {.lex_state = 12, .external_lex_state = 3},
  [46] = {.lex_state = 12, .external_lex_state = 3},
  [47] = {.lex_state = 12, .external_lex_state = 3},
  [48] = {.lex_state = 12, .external_lex_state = 3},
  [49] = {.lex_state = 239, .external_lex_state = 3},
  [50] = {.lex_state = 239, .external_lex_state = 3},
  [51] = {.lex_state = 239, .external_lex_state = 3},
  [52] = {.lex_state = 511, .external_lex_state = 3},
  [53] = {.lex_state = 511, .external_lex_state = 3},
  [54] = {.lex_state = 239, .external_lex_state = 3},
  [55] = {.lex_state = 507, .external_lex_state = 3},
  [56] = {.lex_state = 507, .external_lex_state = 3},
  [57] = {.lex_state = 314, .external_lex_state = 3},
  [58] = {.lex_state = 511},
  [59] = {.lex_state = 314, .external_lex_state = 3},
  [60] = {.lex_state = 8},
  [61] = {.lex_state = 511, .external_lex_state = 3},
  [62] = {.lex_state = 314, .external_lex_state = 3},
  [63] = {.lex_state = 511, .external_lex_state = 3},
  [64] = {.lex_state = 314, .external_lex_state = 3},
  [65] = {.lex_state = 314, .external_lex_state = 3},
  [66] = {.lex_state = 8},
  [67] = {.lex_state = 8},
  [68] = {.lex_state = 511, .external_lex_state = 3},
  [69] = {.lex_state = 511, .external_lex_state = 3},
  [70] = {.lex_state = 314, .external_lex_state = 3},
  [71] = {.lex_state = 314, .external_lex_state = 3},
  [72] = {.lex_state = 511},
  [73] = {.lex_state = 8},
  [74] = {.lex_state = 507, .external_lex_state = 3},
  [75] = {.lex_state = 8},
  [76] = {.lex_state = 8},
  [77] = {.lex_state = 8},
  [78] = {.lex_state = 314, .external_lex_state = 3},
  [79] = {.lex_state = 314, .external_lex_state = 3},
  [80] = {.lex_state = 8},
  [81] = {.lex_state = 314, .external_lex_state = 3},
  [82] = {.lex_state = 314, .external_lex_state = 3},
  [83] = {.lex_state = 8},
  [84] = {.lex_state = 8},
  [85] = {.lex_state = 507, .external_lex_state = 3},
  [86] = {.lex_state = 8},
  [87] = {.lex_state = 8},
  [88] = {.lex_state = 314, .external_lex_state = 3},
  [89] = {.lex_state = 314, .external_lex_state = 3},
  [90] = {.lex_state = 314, .external_lex_state = 3},
  [91] = {.lex_state = 314, .external_lex_state = 3},
  [92] = {.lex_state = 314, .external_lex_state = 3},
  [93] = {.lex_state = 23},
  [94] = {.lex_state = 320, .external_lex_state = 3},
  [95] = {.lex_state = 320, .external_lex_state = 3},
  [96] = {.lex_state = 320, .external_lex_state = 3},
  [97] = {.lex_state = 320, .external_lex_state = 3},
  [98] = {.lex_state = 511},
  [99] = {.lex_state = 25},
  [100] = {.lex_state = 314, .external_lex_state = 3},
  [101] = {.lex_state = 314, .external_lex_state = 3},
  [102] = {.lex_state = 8},
  [103] = {.lex_state = 314, .external_lex_state = 3},
  [104] = {.lex_state = 314, .external_lex_state = 3},
  [105] = {.lex_state = 8},
  [106] = {.lex_state = 4},
  [107] = {.lex_state = 8},
  [108] = {.lex_state = 4},
  [109] = {.lex_state = 23},
  [110] = {.lex_state = 314, .external_lex_state = 3},
  [111] = {.lex_state = 314, .external_lex_state = 3},
  [112] = {.lex_state = 314, .external_lex_state = 3},
  [113] = {.lex_state = 314, .external_lex_state = 3},
  [114] = {.lex_state = 314, .external_lex_state = 3},
  [115] = {.lex_state = 314, .external_lex_state = 3},
  [116] = {.lex_state = 314, .external_lex_state = 3},
  [117] = {.lex_state = 8},
  [118] = {.lex_state = 4},
  [119] = {.lex_state = 4},
  [120] = {.lex_state = 4},
  [121] = {.lex_state = 25},
  [122] = {.lex_state = 8},
  [123] = {.lex_state = 239},
  [124] = {.lex_state = 507},
  [125] = {.lex_state = 298},
  [126] = {.lex_state = 8},
  [127] = {.lex_state = 17},
  [128] = {.lex_state = 17},
  [129] = {.lex_state = 298},
  [130] = {.lex_state = 507},
  [131] = {.lex_state = 12},
  [132] = {.lex_state = 298},
  [133] = {.lex_state = 239},
  [134] = {.lex_state = 8},
  [135] = {.lex_state = 320, .external_lex_state = 3},
  [136] = {.lex_state = 320, .external_lex_state = 3},
  [137] = {.lex_state = 4},
  [138] = {.lex_state = 12},
  [139] = {.lex_state = 17},
  [140] = {.lex_state = 4},
  [141] = {.lex_state = 12},
  [142] = {.lex_state = 239},
  [143] = {.lex_state = 8},
  [144] = {.lex_state = 298},
  [145] = {.lex_state = 8},
  [146] = {.lex_state = 12},
  [147] = {.lex_state = 298},
  [148] = {.lex_state = 4},
  [149] = {.lex_state = 298},
  [150] = {.lex_state = 12},
  [151] = {.lex_state = 320, .external_lex_state = 3},
  [152] = {.lex_state = 8},
  [153] = {.lex_state = 320, .external_lex_state = 3},
  [154] = {.lex_state = 298},
  [155] = {.lex_state = 239},
  [156] = {.lex_state = 4},
  [157] = {.lex_state = 239},
  [158] = {.lex_state = 298},
  [159] = {.lex_state = 314, .external_lex_state = 3},
  [160] = {.lex_state = 314, .external_lex_state = 3},
  [161] = {.lex_state = 298},
  [162] = {.lex_state = 314, .external_lex_state = 3},
  [163] = {.lex_state = 314, .external_lex_state = 3},
  [164] = {.lex_state = 298},
  [165] = {.lex_state = 4},
  [166] = {.lex_state = 298},
  [167] = {.lex_state = 298},
  [168] = {.lex_state = 298},
  [169] = {.lex_state = 314, .external_lex_state = 3},
  [170] = {.lex_state = 314, .external_lex_state = 3},
  [171] = {.lex_state = 511},
  [172] = {.lex_state = 298},
  [173] = {.lex_state = 298},
  [174] = {.lex_state = 298},
  [175] = {.lex_state = 298},
  [176] = {.lex_state = 298},
  [177] = {.lex_state = 298},
  [178] = {.lex_state = 298},
  [179] = {.lex_state = 298},
  [180] = {.lex_state = 298},
  [181] = {.lex_state = 298},
  [182] = {.lex_state = 298},
  [183] = {.lex_state = 298},
  [184] = {.lex_state = 298},
  [185] = {.lex_state = 298},
  [186] = {.lex_state = 298},
  [187] = {.lex_state = 298},
  [188] = {.lex_state = 298},
  [189] = {.lex_state = 298},
  [190] = {.lex_state = 298},
  [191] = {.lex_state = 298},
  [192] = {.lex_state = 298},
  [193] = {.lex_state = 298},
  [194] = {.lex_state = 298},
  [195] = {.lex_state = 298},
  [196] = {.lex_state = 298},
  [197] = {.lex_state = 298},
  [198] = {.lex_state = 298},
  [199] = {.lex_state = 298},
  [200] = {.lex_state = 298},
  [201] = {.lex_state = 298},
  [202] = {.lex_state = 298},
  [203] = {.lex_state = 298},
  [204] = {.lex_state = 298},
  [205] = {.lex_state = 298},
  [206] = {.lex_state = 298},
  [207] = {.lex_state = 298},
  [208] = {.lex_state = 298},
  [209] = {.lex_state = 298},
  [210] = {.lex_state = 298},
  [211] = {.lex_state = 298},
  [212] = {.lex_state = 298},
  [213] = {.lex_state = 298},
  [214] = {.lex_state = 298},
  [215] = {.lex_state = 298},
  [216] = {.lex_state = 298},
  [217] = {.lex_state = 298},
  [218] = {.lex_state = 298},
  [219] = {.lex_state = 511},
  [220] = {.lex_state = 8, .external_lex_state = 4},
  [221] = {.lex_state = 8, .external_lex_state = 4},
  [222] = {.lex_state = 17},
  [223] = {.lex_state = 8, .external_lex_state = 4},
  [224] = {.lex_state = 17},
  [225] = {.lex_state = 8, .external_lex_state = 4},
  [226] = {.lex_state = 8, .external_lex_state = 4},
  [227] = {.lex_state = 8, .external_lex_state = 4},
  [228] = {.lex_state = 314},
  [229] = {.lex_state = 17},
  [230] = {.lex_state = 507},
  [231] = {.lex_state = 314, .external_lex_state = 3},
  [232] = {.lex_state = 314, .external_lex_state = 3},
  [233] = {.lex_state = 507},
  [234] = {.lex_state = 8},
  [235] = {.lex_state = 12},
  [236] = {.lex_state = 239},
  [237] = {.lex_state = 8},
  [238] = {.lex_state = 8, .external_lex_state = 4},
  [239] = {.lex_state = 8, .external_lex_state = 4},
  [240] = {.lex_state = 4},
  [241] = {.lex_state = 4, .external_lex_state = 4},
  [242] = {.lex_state = 511},
  [243] = {.lex_state = 8, .external_lex_state = 4},
  [244] = {.lex_state = 511},
  [245] = {.lex_state = 8, .external_lex_state = 4},
  [246] = {.lex_state = 12},
  [247] = {.lex_state = 17},
  [248] = {.lex_state = 314, .external_lex_state = 3},
  [249] = {.lex_state = 314, .external_lex_state = 3},
  [250] = {.lex_state = 4},
  [251] = {.lex_state = 4, .external_lex_state = 4},
  [252] = {.lex_state = 8, .external_lex_state = 4},
  [253] = {.lex_state = 12},
  [254] = {.lex_state = 507},
  [255] = {.lex_state = 239},
  [256] = {.lex_state = 239},
  [257] = {.lex_state = 511},
  [258] = {.lex_state = 8, .external_lex_state = 4},
  [259] = {.lex_state = 12},
  [260] = {.lex_state = 17},
  [261] = {.lex_state = 314},
  [262] = {.lex_state = 8},
  [263] = {.lex_state = 12},
  [264] = {.lex_state = 239},
  [265] = {.lex_state = 239},
  [266] = {.lex_state = 314},
  [267] = {.lex_state = 8, .external_lex_state = 4},
  [268] = {.lex_state = 511},
  [269] = {.lex_state = 8, .external_lex_state = 4},
  [270] = {.lex_state = 8, .external_lex_state = 4},
  [271] = {.lex_state = 507},
  [272] = {.lex_state = 314},
  [273] = {.lex_state = 507},
  [274] = {.lex_state = 511},
  [275] = {.lex_state = 17, .external_lex_state = 4},
  [276] = {.lex_state = 12},
  [277] = {.lex_state = 12, .external_lex_state = 4},
  [278] = {.lex_state = 511},
  [279] = {.lex_state = 314},
  [280] = {.lex_state = 511},
  [281] = {.lex_state = 17},
  [282] = {.lex_state = 17, .external_lex_state = 4},
  [283] = {.lex_state = 314},
  [284] = {.lex_state = 17},
  [285] = {.lex_state = 507},
  [286] = {.lex_state = 12},
  [287] = {.lex_state = 12, .external_lex_state = 4},
  [288] = {.lex_state = 239},
  [289] = {.lex_state = 239, .external_lex_state = 4},
  [290] = {.lex_state = 314, .external_lex_state = 3},
  [291] = {.lex_state = 239},
  [292] = {.lex_state = 314},
  [293] = {.lex_state = 239, .external_lex_state = 4},
  [294] = {.lex_state = 314},
  [295] = {.lex_state = 511},
  [296] = {.lex_state = 314},
  [297] = {.lex_state = 511},
  [298] = {.lex_state = 314, .external_lex_state = 3},
  [299] = {.lex_state = 8, .external_lex_state = 4},
  [300] = {.lex_state = 507},
  [301] = {.lex_state = 314},
  [302] = {.lex_state = 4, .external_lex_state = 4},
  [303] = {.lex_state = 314},
  [304] = {.lex_state = 314},
  [305] = {.lex_state = 4, .external_lex_state = 4},
  [306] = {.lex_state = 8, .external_lex_state = 4},
  [307] = {.lex_state = 314},
  [308] = {.lex_state = 314},
  [309] = {.lex_state = 8, .external_lex_state = 4},
  [310] = {.lex_state = 507, .external_lex_state = 4},
  [311] = {.lex_state = 314},
  [312] = {.lex_state = 511},
  [313] = {.lex_state = 314},
  [314] = {.lex_state = 314},
  [315] = {.lex_state = 511, .external_lex_state = 4},
  [316] = {.lex_state = 511},
  [317] = {.lex_state = 314},
  [318] = {.lex_state = 511},
  [319] = {.lex_state = 314},
  [320] = {.lex_state = 314},
  [321] = {.lex_state = 511, .external_lex_state = 4},
  [322] = {.lex_state = 507},
  [323] = {.lex_state = 511},
  [324] = {.lex_state = 511},
  [325] = {.lex_state = 314, .external_lex_state = 4},
  [326] = {.lex_state = 511, .external_lex_state = 4},
  [327] = {.lex_state = 320},
  [328] = {.lex_state = 511, .external_lex_state = 4},
  [329] = {.lex_state = 511},
  [330] = {.lex_state = 507, .external_lex_state = 4},
  [331] = {.lex_state = 17, .external_lex_state = 4},
  [332] = {.lex_state = 12, .external_lex_state = 4},
  [333] = {.lex_state = 314},
  [334] = {.lex_state = 511, .external_lex_state = 4},
  [335] = {.lex_state = 17, .external_lex_state = 4},
  [336] = {.lex_state = 511, .external_lex_state = 4},
  [337] = {.lex_state = 314},
  [338] = {.lex_state = 511, .external_lex_state = 4},
  [339] = {.lex_state = 314},
  [340] = {.lex_state = 511, .external_lex_state = 4},
  [341] = {.lex_state = 511, .external_lex_state = 4},
  [342] = {.lex_state = 12, .external_lex_state = 4},
  [343] = {.lex_state = 511, .external_lex_state = 4},
  [344] = {.lex_state = 511, .external_lex_state = 4},
  [345] = {.lex_state = 239, .external_lex_state = 4},
  [346] = {.lex_state = 511},
  [347] = {.lex_state = 314},
  [348] = {.lex_state = 511, .external_lex_state = 4},
  [349] = {.lex_state = 320},
  [350] = {.lex_state = 314},
  [351] = {.lex_state = 239, .external_lex_state = 4},
  [352] = {.lex_state = 511},
  [353] = {.lex_state = 511},
  [354] = {.lex_state = 511},
  [355] = {.lex_state = 507, .external_lex_state = 4},
  [356] = {.lex_state = 320},
  [357] = {.lex_state = 511, .external_lex_state = 4},
  [358] = {.lex_state = 8, .external_lex_state = 4},
  [359] = {.lex_state = 511},
  [360] = {.lex_state = 511},
  [361] = {.lex_state = 511, .external_lex_state = 4},
  [362] = {.lex_state = 314},
  [363] = {.lex_state = 314},
  [364] = {.lex_state = 314},
  [365] = {.lex_state = 511},
  [366] = {.lex_state = 511, .external_lex_state = 4},
  [367] = {.lex_state = 314, .external_lex_state = 4},
  [368] = {.lex_state = 511},
  [369] = {.lex_state = 314},
  [370] = {.lex_state = 314},
  [371] = {.lex_state = 314, .external_lex_state = 4},
  [372] = {.lex_state = 320},
  [373] = {.lex_state = 314},
  [374] = {.lex_state = 314, .external_lex_state = 4},
  [375] = {.lex_state = 314},
  [376] = {.lex_state = 320},
  [377] = {.lex_state = 314},
  [378] = {.lex_state = 314},
  [379] = {.lex_state = 320},
  [380] = {.lex_state = 314},
  [381] = {.lex_state = 314, .external_lex_state = 4},
  [382] = {.lex_state = 314},
  [383] = {.lex_state = 320},
  [384] = {.lex_state = 314, .external_lex_state = 4},
  [385] = {.lex_state = 507, .external_lex_state = 4},
  [386] = {.lex_state = 320},
  [387] = {.lex_state = 314},
  [388] = {.lex_state = 511, .external_lex_state = 4},
  [389] = {.lex_state = 314, .external_lex_state = 4},
  [390] = {.lex_state = 314, .external_lex_state = 4},
  [391] = {.lex_state = 314, .external_lex_state = 4},
  [392] = {.lex_state = 511, .external_lex_state = 4},
  [393] = {.lex_state = 507, .external_lex_state = 4},
  [394] = {.lex_state = 511, .external_lex_state = 4},
  [395] = {.lex_state = 314, .external_lex_state = 4},
  [396] = {.lex_state = 507, .external_lex_state = 4},
  [397] = {.lex_state = 320},
  [398] = {.lex_state = 320},
  [399] = {.lex_state = 314},
  [400] = {.lex_state = 320, .external_lex_state = 4},
  [401] = {.lex_state = 320, .external_lex_state = 4},
  [402] = {.lex_state = 314},
  [403] = {.lex_state = 314, .external_lex_state = 4},
  [404] = {.lex_state = 314},
  [405] = {.lex_state = 314},
  [406] = {.lex_state = 511, .external_lex_state = 4},
  [407] = {.lex_state = 314, .external_lex_state = 4},
  [408] = {.lex_state = 314, .external_lex_state = 4},
  [409] = {.lex_state = 314},
  [410] = {.lex_state = 314, .external_lex_state = 4},
  [411] = {.lex_state = 314, .external_lex_state = 4},
  [412] = {.lex_state = 314, .external_lex_state = 4},
  [413] = {.lex_state = 314, .external_lex_state = 4},
  [414] = {.lex_state = 314, .external_lex_state = 4},
  [415] = {.lex_state = 314, .external_lex_state = 4},
  [416] = {.lex_state = 314, .external_lex_state = 4},
  [417] = {.lex_state = 314, .external_lex_state = 4},
  [418] = {.lex_state = 314},
  [419] = {.lex_state = 314, .external_lex_state = 4},
  [420] = {.lex_state = 314},
  [421] = {.lex_state = 314, .external_lex_state = 4},
  [422] = {.lex_state = 314, .external_lex_state = 4},
  [423] = {.lex_state = 320, .external_lex_state = 4},
  [424] = {.lex_state = 314, .external_lex_state = 4},
  [425] = {.lex_state = 320, .external_lex_state = 4},
  [426] = {.lex_state = 320, .external_lex_state = 4},
  [427] = {.lex_state = 314, .external_lex_state = 4},
  [428] = {.lex_state = 320, .external_lex_state = 4},
  [429] = {.lex_state = 314, .external_lex_state = 4},
  [430] = {.lex_state = 314, .external_lex_state = 4},
  [431] = {.lex_state = 314, .external_lex_state = 4},
  [432] = {.lex_state = 314, .external_lex_state = 4},
  [433] = {.lex_state = 352},
  [434] = {.lex_state = 352},
  [435] = {.lex_state = 352},
  [436] = {.lex_state = 352},
  [437] = {.lex_state = 352},
  [438] = {.lex_state = 26},
  [439] = {.lex_state = 26},
  [440] = {.lex_state = 26},
  [441] = {.lex_state = 26},
  [442] = {.lex_state = 26},
  [443] = {.lex_state = 26},
  [444] = {.lex_state = 26},
  [445] = {.lex_state = 26},
  [446] = {.lex_state = 26},
  [447] = {.lex_state = 26},
  [448] = {.lex_state = 352},
  [449] = {.lex_state = 352},
  [450] = {.lex_state = 352},
  [451] = {.lex_state = 352},
  [452] = {.lex_state = 352},
  [453] = {.lex_state = 352},
  [454] = {.lex_state = 352},
  [455] = {.lex_state = 26},
  [456] = {.lex_state = 26},
  [457] = {.lex_state = 27},
  [458] = {.lex_state = 27},
  [459] = {.lex_state = 27},
  [460] = {.lex_state = 27},
  [461] = {.lex_state = 27},
  [462] = {.lex_state = 27},
  [463] = {.lex_state = 27},
  [464] = {.lex_state = 27},
  [465] = {.lex_state = 27},
  [466] = {.lex_state = 27},
  [467] = {.lex_state = 27},
  [468] = {.lex_state = 27},
  [469] = {.lex_state = 27},
  [470] = {.lex_state = 27},
  [471] = {.lex_state = 27},
  [472] = {.lex_state = 27},
  [473] = {.lex_state = 27},
  [474] = {.lex_state = 27},
  [475] = {.lex_state = 27},
  [476] = {.lex_state = 27},
  [477] = {.lex_state = 28},
  [478] = {.lex_state = 27},
  [479] = {.lex_state = 27},
  [480] = {.lex_state = 27},
  [481] = {.lex_state = 27},
  [482] = {.lex_state = 29},
  [483] = {.lex_state = 351},
  [484] = {.lex_state = 30},
  [485] = {.lex_state = 351},
  [486] = {.lex_state = 351},
  [487] = {.lex_state = 351},
  [488] = {.lex_state = 351},
  [489] = {.lex_state = 351},
  [490] = {.lex_state = 351},
  [491] = {.lex_state = 351},
  [492] = {.lex_state = 351},
  [493] = {.lex_state = 351},
  [494] = {.lex_state = 351},
  [495] = {.lex_state = 351},
  [496] = {.lex_state = 27},
  [497] = {.lex_state = 27},
  [498] = {.lex_state = 27},
  [499] = {.lex_state = 27},
  [500] = {.lex_state = 355},
  [501] = {.lex_state = 27},
  [502] = {.lex_state = 27},
  [503] = {.lex_state = 27},
  [504] = {.lex_state = 27},
  [505] = {.lex_state = 27},
  [506] = {.lex_state = 27},
  [507] = {.lex_state = 27},
  [508] = {.lex_state = 27},
  [509] = {.lex_state = 27},
  [510] = {.lex_state = 27},
  [511] = {.lex_state = 27},
  [512] = {.lex_state = 27},
  [513] = {.lex_state = 27},
  [514] = {.lex_state = 27},
  [515] = {.lex_state = 27},
  [516] = {.lex_state = 27},
  [517] = {.lex_state = 355},
  [518] = {.lex_state = 27},
  [519] = {.lex_state = 27},
  [520] = {.lex_state = 27},
  [521] = {.lex_state = 27},
  [522] = {.lex_state = 352},
  [523] = {.lex_state = 27},
  [524] = {.lex_state = 27},
  [525] = {.lex_state = 27},
  [526] = {.lex_state = 27},
  [527] = {.lex_state = 27},
  [528] = {.lex_state = 27},
  [529] = {.lex_state = 27},
  [530] = {.lex_state = 27},
  [531] = {.lex_state = 27},
  [532] = {.lex_state = 27},
  [533] = {.lex_state = 27},
  [534] = {.lex_state = 27},
  [535] = {.lex_state = 27},
  [536] = {.lex_state = 27},
  [537] = {.lex_state = 27},
  [538] = {.lex_state = 27},
  [539] = {.lex_state = 27},
  [540] = {.lex_state = 27},
  [541] = {.lex_state = 27},
  [542] = {.lex_state = 27},
  [543] = {.lex_state = 27},
  [544] = {.lex_state = 27},
  [545] = {.lex_state = 27},
  [546] = {.lex_state = 27},
  [547] = {.lex_state = 27},
  [548] = {.lex_state = 27},
  [549] = {.lex_state = 27},
  [550] = {.lex_state = 27},
  [551] = {.lex_state = 27},
  [552] = {.lex_state = 27},
  [553] = {.lex_state = 27},
  [554] = {.lex_state = 27},
  [555] = {.lex_state = 27},
  [556] = {.lex_state = 27},
  [557] = {.lex_state = 27},
  [558] = {.lex_state = 27},
  [559] = {.lex_state = 27},
  [560] = {.lex_state = 27},
  [561] = {.lex_state = 27},
  [562] = {.lex_state = 27},
  [563] = {.lex_state = 27},
  [564] = {.lex_state = 27},
  [565] = {.lex_state = 27},
  [566] = {.lex_state = 27},
  [567] = {.lex_state = 27},
  [568] = {.lex_state = 27},
  [569] = {.lex_state = 27},
  [570] = {.lex_state = 27},
  [571] = {.lex_state = 27},
  [572] = {.lex_state = 27},
  [573] = {.lex_state = 27},
  [574] = {.lex_state = 566},
  [575] = {.lex_state = 566},
  [576] = {.lex_state = 566},
  [577] = {.lex_state = 566},
  [578] = {.lex_state = 566},
  [579] = {.lex_state = 566},
  [580] = {.lex_state = 566},
  [581] = {.lex_state = 355},
  [582] = {.lex_state = 566},
  [583] = {.lex_state = 566},
  [584] = {.lex_state = 566},
  [585] = {.lex_state = 31},
  [586] = {.lex_state = 566},
  [587] = {.lex_state = 566},
  [588] = {.lex_state = 566},
  [589] = {.lex_state = 566},
  [590] = {.lex_state = 566},
  [591] = {.lex_state = 566},
  [592] = {.lex_state = 566},
  [593] = {.lex_state = 566},
  [594] = {.lex_state = 566},
  [595] = {.lex_state = 566},
  [596] = {.lex_state = 353},
  [597] = {.lex_state = 566},
  [598] = {.lex_state = 566},
  [599] = {.lex_state = 566},
  [600] = {.lex_state = 566},
  [601] = {.lex_state = 566},
  [602] = {.lex_state = 566},
  [603] = {.lex_state = 566},
  [604] = {.lex_state = 566},
  [605] = {.lex_state = 566},
  [606] = {.lex_state = 566},
  [607] = {.lex_state = 566},
  [608] = {.lex_state = 566},
  [609] = {.lex_state = 566},
  [610] = {.lex_state = 350},
  [611] = {.lex_state = 566},
  [612] = {.lex_state = 566},
  [613] = {.lex_state = 566},
  [614] = {.lex_state = 352},
  [615] = {.lex_state = 566},
  [616] = {.lex_state = 566},
  [617] = {.lex_state = 566},
  [618] = {.lex_state = 566},
  [619] = {.lex_state = 566},
  [620] = {.lex_state = 566},
  [621] = {.lex_state = 566},
  [622] = {.lex_state = 566},
  [623] = {.lex_state = 566},
  [624] = {.lex_state = 566},
  [625] = {.lex_state = 566},
  [626] = {.lex_state = 566},
  [627] = {.lex_state = 31},
  [628] = {.lex_state = 566},
  [629] = {.lex_state = 566},
  [630] = {.lex_state = 566},
  [631] = {.lex_state = 566},
  [632] = {.lex_state = 566},
  [633] = {.lex_state = 566},
  [634] = {.lex_state = 566},
  [635] = {.lex_state = 566},
  [636] = {.lex_state = 566},
  [637] = {.lex_state = 566},
  [638] = {.lex_state = 566},
  [639] = {.lex_state = 566},
  [640] = {.lex_state = 566},
  [641] = {.lex_state = 566},
  [642] = {.lex_state = 566},
  [643] = {.lex_state = 566},
  [644] = {.lex_state = 566},
  [645] = {.lex_state = 355},
  [646] = {.lex_state = 566},
  [647] = {.lex_state = 566},
  [648] = {.lex_state = 566},
  [649] = {.lex_state = 566},
  [650] = {.lex_state = 566},
  [651] = {.lex_state = 566},
  [652] = {.lex_state = 566},
  [653] = {.lex_state = 566},
  [654] = {.lex_state = 352},
  [655] = {.lex_state = 566},
  [656] = {.lex_state = 566},
  [657] = {.lex_state = 566},
  [658] = {.lex_state = 566},
  [659] = {.lex_state = 354},
  [660] = {.lex_state = 354},
  [661] = {.lex_state = 354},
  [662] = {.lex_state = 566},
  [663] = {.lex_state = 354},
  [664] = {.lex_state = 354},
  [665] = {.lex_state = 354},
  [666] = {.lex_state = 354},
  [667] = {.lex_state = 566},
  [668] = {.lex_state = 566},
  [669] = {.lex_state = 354},
  [670] = {.lex_state = 354},
  [671] = {.lex_state = 354},
  [672] = {.lex_state = 354},
  [673] = {.lex_state = 566},
  [674] = {.lex_state = 566},
  [675] = {.lex_state = 354},
  [676] = {.lex_state = 354},
  [677] = {.lex_state = 354},
  [678] = {.lex_state = 354},
  [679] = {.lex_state = 354},
  [680] = {.lex_state = 354},
  [681] = {.lex_state = 354},
  [682] = {.lex_state = 354},
  [683] = {.lex_state = 354},
  [684] = {.lex_state = 354},
  [685] = {.lex_state = 566},
  [686] = {.lex_state = 566},
  [687] = {.lex_state = 354},
  [688] = {.lex_state = 354},
  [689] = {.lex_state = 354},
  [690] = {.lex_state = 354},
  [691] = {.lex_state = 566},
  [692] = {.lex_state = 354},
  [693] = {.lex_state = 566},
  [694] = {.lex_state = 354},
  [695] = {.lex_state = 566},
  [696] = {.lex_state = 354},
  [697] = {.lex_state = 566},
  [698] = {.lex_state = 354},
  [699] = {.lex_state = 354},
  [700] = {.lex_state = 354},
  [701] = {.lex_state = 354},
  [702] = {.lex_state = 354},
  [703] = {.lex_state = 354},
  [704] = {.lex_state = 354},
  [705] = {.lex_state = 566},
  [706] = {.lex_state = 566},
  [707] = {.lex_state = 354},
  [708] = {.lex_state = 354},
  [709] = {.lex_state = 354},
  [710] = {.lex_state = 354},
  [711] = {.lex_state = 354},
  [712] = {.lex_state = 354},
  [713] = {.lex_state = 354},
  [714] = {.lex_state = 354},
  [715] = {.lex_state = 354},
  [716] = {.lex_state = 354},
  [717] = {.lex_state = 354},
  [718] = {.lex_state = 566},
  [719] = {.lex_state = 566},
  [720] = {.lex_state = 354},
  [721] = {.lex_state = 354},
  [722] = {.lex_state = 354},
  [723] = {.lex_state = 354},
  [724] = {.lex_state = 566},
  [725] = {.lex_state = 354},
  [726] = {.lex_state = 354},
  [727] = {.lex_state = 350},
  [728] = {.lex_state = 354},
  [729] = {.lex_state = 354},
  [730] = {.lex_state = 354},
  [731] = {.lex_state = 354},
  [732] = {.lex_state = 350},
  [733] = {.lex_state = 354},
  [734] = {.lex_state = 354},
  [735] = {.lex_state = 354},
  [736] = {.lex_state = 354},
  [737] = {.lex_state = 354},
  [738] = {.lex_state = 354},
  [739] = {.lex_state = 566},
  [740] = {.lex_state = 566},
  [741] = {.lex_state = 354},
  [742] = {.lex_state = 354},
  [743] = {.lex_state = 354},
  [744] = {.lex_state = 354},
  [745] = {.lex_state = 354},
  [746] = {.lex_state = 354},
  [747] = {.lex_state = 354},
  [748] = {.lex_state = 354},
  [749] = {.lex_state = 354},
  [750] = {.lex_state = 354},
  [751] = {.lex_state = 566},
  [752] = {.lex_state = 566},
  [753] = {.lex_state = 354},
  [754] = {.lex_state = 354},
  [755] = {.lex_state = 354},
  [756] = {.lex_state = 354},
  [757] = {.lex_state = 566},
  [758] = {.lex_state = 354},
  [759] = {.lex_state = 566},
  [760] = {.lex_state = 566},
  [761] = {.lex_state = 354},
  [762] = {.lex_state = 354},
  [763] = {.lex_state = 354},
  [764] = {.lex_state = 354},
  [765] = {.lex_state = 566},
  [766] = {.lex_state = 354},
  [767] = {.lex_state = 354},
  [768] = {.lex_state = 566},
  [769] = {.lex_state = 354},
  [770] = {.lex_state = 354},
  [771] = {.lex_state = 566},
  [772] = {.lex_state = 354},
  [773] = {.lex_state = 354},
  [774] = {.lex_state = 566},
  [775] = {.lex_state = 566},
  [776] = {.lex_state = 354},
  [777] = {.lex_state = 354},
  [778] = {.lex_state = 354},
  [779] = {.lex_state = 354},
  [780] = {.lex_state = 354},
  [781] = {.lex_state = 354},
  [782] = {.lex_state = 354},
  [783] = {.lex_state = 354},
  [784] = {.lex_state = 354},
  [785] = {.lex_state = 354},
  [786] = {.lex_state = 354},
  [787] = {.lex_state = 566},
  [788] = {.lex_state = 566},
  [789] = {.lex_state = 354},
  [790] = {.lex_state = 354},
  [791] = {.lex_state = 354},
  [792] = {.lex_state = 354},
  [793] = {.lex_state = 566},
  [794] = {.lex_state = 354},
  [795] = {.lex_state = 354},
  [796] = {.lex_state = 354},
  [797] = {.lex_state = 354},
  [798] = {.lex_state = 354},
  [799] = {.lex_state = 354},
  [800] = {.lex_state = 566},
  [801] = {.lex_state = 566},
  [802] = {.lex_state = 566},
  [803] = {.lex_state = 566},
  [804] = {.lex_state = 566},
  [805] = {.lex_state = 354},
  [806] = {.lex_state = 354},
  [807] = {.lex_state = 566},
  [808] = {.lex_state = 566},
  [809] = {.lex_state = 566},
  [810] = {.lex_state = 566},
  [811] = {.lex_state = 566},
  [812] = {.lex_state = 566},
  [813] = {.lex_state = 354},
  [814] = {.lex_state = 566},
  [815] = {.lex_state = 354},
  [816] = {.lex_state = 566},
  [817] = {.lex_state = 566},
  [818] = {.lex_state = 566},
  [819] = {.lex_state = 566},
  [820] = {.lex_state = 354},
  [821] = {.lex_state = 354},
  [822] = {.lex_state = 354},
  [823] = {.lex_state = 566},
  [824] = {.lex_state = 566},
  [825] = {.lex_state = 566},
  [826] = {.lex_state = 566},
  [827] = {.lex_state = 354},
  [828] = {.lex_state = 354},
  [829] = {.lex_state = 566},
  [830] = {.lex_state = 566},
  [831] = {.lex_state = 566},
  [832] = {.lex_state = 566},
  [833] = {.lex_state = 354},
  [834] = {.lex_state = 566},
  [835] = {.lex_state = 566},
  [836] = {.lex_state = 566},
  [837] = {.lex_state = 566},
  [838] = {.lex_state = 566},
  [839] = {.lex_state = 354},
  [840] = {.lex_state = 354},
  [841] = {.lex_state = 354},
  [842] = {.lex_state = 566},
  [843] = {.lex_state = 566},
  [844] = {.lex_state = 566},
  [845] = {.lex_state = 566},
  [846] = {.lex_state = 354},
  [847] = {.lex_state = 354},
  [848] = {.lex_state = 566},
  [849] = {.lex_state = 566},
  [850] = {.lex_state = 566},
  [851] = {.lex_state = 566},
  [852] = {.lex_state = 566},
  [853] = {.lex_state = 354},
  [854] = {.lex_state = 354},
  [855] = {.lex_state = 566},
  [856] = {.lex_state = 566},
  [857] = {.lex_state = 566},
  [858] = {.lex_state = 566},
  [859] = {.lex_state = 354},
  [860] = {.lex_state = 566},
  [861] = {.lex_state = 566},
  [862] = {.lex_state = 566},
  [863] = {.lex_state = 566},
  [864] = {.lex_state = 566},
  [865] = {.lex_state = 566},
  [866] = {.lex_state = 354},
  [867] = {.lex_state = 566},
  [868] = {.lex_state = 354},
  [869] = {.lex_state = 566},
  [870] = {.lex_state = 566},
  [871] = {.lex_state = 566},
  [872] = {.lex_state = 566},
  [873] = {.lex_state = 354},
  [874] = {.lex_state = 354},
  [875] = {.lex_state = 566},
  [876] = {.lex_state = 566},
  [877] = {.lex_state = 566},
  [878] = {.lex_state = 566},
  [879] = {.lex_state = 354},
  [880] = {.lex_state = 354},
  [881] = {.lex_state = 354},
  [882] = {.lex_state = 566},
  [883] = {.lex_state = 566},
  [884] = {.lex_state = 566},
  [885] = {.lex_state = 566},
  [886] = {.lex_state = 354},
  [887] = {.lex_state = 354},
  [888] = {.lex_state = 566},
  [889] = {.lex_state = 566},
  [890] = {.lex_state = 566},
  [891] = {.lex_state = 566},
  [892] = {.lex_state = 354},
  [893] = {.lex_state = 566},
  [894] = {.lex_state = 354},
  [895] = {.lex_state = 566},
  [896] = {.lex_state = 566},
  [897] = {.lex_state = 566},
  [898] = {.lex_state = 566},
  [899] = {.lex_state = 354},
  [900] = {.lex_state = 354},
  [901] = {.lex_state = 566},
  [902] = {.lex_state = 566},
  [903] = {.lex_state = 566},
  [904] = {.lex_state = 566},
  [905] = {.lex_state = 354},
  [906] = {.lex_state = 354},
  [907] = {.lex_state = 566},
  [908] = {.lex_state = 566},
  [909] = {.lex_state = 566},
  [910] = {.lex_state = 566},
  [911] = {.lex_state = 354},
  [912] = {.lex_state = 566},
  [913] = {.lex_state = 566},
  [914] = {.lex_state = 566},
  [915] = {.lex_state = 566},
  [916] = {.lex_state = 566},
  [917] = {.lex_state = 566},
  [918] = {.lex_state = 354},
  [919] = {.lex_state = 354},
  [920] = {.lex_state = 354},
  [921] = {.lex_state = 566},
  [922] = {.lex_state = 566},
  [923] = {.lex_state = 566},
  [924] = {.lex_state = 566},
  [925] = {.lex_state = 354},
  [926] = {.lex_state = 354},
  [927] = {.lex_state = 354},
  [928] = {.lex_state = 566},
  [929] = {.lex_state = 566},
  [930] = {.lex_state = 566},
  [931] = {.lex_state = 566},
  [932] = {.lex_state = 354},
  [933] = {.lex_state = 354},
  [934] = {.lex_state = 354},
  [935] = {.lex_state = 566},
  [936] = {.lex_state = 566},
  [937] = {.lex_state = 566},
  [938] = {.lex_state = 566},
  [939] = {.lex_state = 354},
  [940] = {.lex_state = 354},
  [941] = {.lex_state = 353},
  [942] = {.lex_state = 566},
  [943] = {.lex_state = 566},
  [944] = {.lex_state = 566},
  [945] = {.lex_state = 566},
  [946] = {.lex_state = 354},
  [947] = {.lex_state = 354},
  [948] = {.lex_state = 354},
  [949] = {.lex_state = 566},
  [950] = {.lex_state = 566},
  [951] = {.lex_state = 566},
  [952] = {.lex_state = 566},
  [953] = {.lex_state = 354},
  [954] = {.lex_state = 354},
  [955] = {.lex_state = 566},
  [956] = {.lex_state = 566},
  [957] = {.lex_state = 566},
  [958] = {.lex_state = 566},
  [959] = {.lex_state = 354},
  [960] = {.lex_state = 566},
  [961] = {.lex_state = 566},
  [962] = {.lex_state = 566},
  [963] = {.lex_state = 566},
  [964] = {.lex_state = 566},
  [965] = {.lex_state = 566},
  [966] = {.lex_state = 354},
  [967] = {.lex_state = 354},
  [968] = {.lex_state = 354},
  [969] = {.lex_state = 566},
  [970] = {.lex_state = 566},
  [971] = {.lex_state = 566},
  [972] = {.lex_state = 354},
  [973] = {.lex_state = 354},
  [974] = {.lex_state = 566},
  [975] = {.lex_state = 566},
  [976] = {.lex_state = 566},
  [977] = {.lex_state = 566},
  [978] = {.lex_state = 566},
  [979] = {.lex_state = 566},
  [980] = {.lex_state = 566},
  [981] = {.lex_state = 354},
  [982] = {.lex_state = 566},
  [983] = {.lex_state = 566},
  [984] = {.lex_state = 566},
  [985] = {.lex_state = 354},
  [986] = {.lex_state = 354},
  [987] = {.lex_state = 566},
  [988] = {.lex_state = 566},
  [989] = {.lex_state = 566},
  [990] = {.lex_state = 354},
  [991] = {.lex_state = 354},
  [992] = {.lex_state = 566},
  [993] = {.lex_state = 566},
  [994] = {.lex_state = 566},
  [995] = {.lex_state = 354},
  [996] = {.lex_state = 566},
  [997] = {.lex_state = 566},
  [998] = {.lex_state = 566},
  [999] = {.lex_state = 353},
  [1000] = {.lex_state = 354},
  [1001] = {.lex_state = 566},
  [1002] = {.lex_state = 566},
  [1003] = {.lex_state = 566},
  [1004] = {.lex_state = 566},
  [1005] = {.lex_state = 566},
  [1006] = {.lex_state = 566},
  [1007] = {.lex_state = 354},
  [1008] = {.lex_state = 566},
  [1009] = {.lex_state = 566},
  [1010] = {.lex_state = 566},
  [1011] = {.lex_state = 566},
  [1012] = {.lex_state = 566},
  [1013] = {.lex_state = 354},
  [1014] = {.lex_state = 566},
  [1015] = {.lex_state = 566},
  [1016] = {.lex_state = 566},
  [1017] = {.lex_state = 354},
  [1018] = {.lex_state = 566},
  [1019] = {.lex_state = 566},
  [1020] = {.lex_state = 566},
  [1021] = {.lex_state = 354},
  [1022] = {.lex_state = 354},
  [1023] = {.lex_state = 566},
  [1024] = {.lex_state = 566},
  [1025] = {.lex_state = 566},
  [1026] = {.lex_state = 354},
  [1027] = {.lex_state = 354},
  [1028] = {.lex_state = 566},
  [1029] = {.lex_state = 566},
  [1030] = {.lex_state = 566},
  [1031] = {.lex_state = 566},
  [1032] = {.lex_state = 354},
  [1033] = {.lex_state = 566},
  [1034] = {.lex_state = 566},
  [1035] = {.lex_state = 566},
  [1036] = {.lex_state = 354},
  [1037] = {.lex_state = 354},
  [1038] = {.lex_state = 566},
  [1039] = {.lex_state = 566},
  [1040] = {.lex_state = 566},
  [1041] = {.lex_state = 354},
  [1042] = {.lex_state = 354},
  [1043] = {.lex_state = 566},
  [1044] = {.lex_state = 566},
  [1045] = {.lex_state = 566},
  [1046] = {.lex_state = 354},
  [1047] = {.lex_state = 354},
  [1048] = {.lex_state = 566},
  [1049] = {.lex_state = 566},
  [1050] = {.lex_state = 566},
  [1051] = {.lex_state = 354},
  [1052] = {.lex_state = 566},
  [1053] = {.lex_state = 566},
  [1054] = {.lex_state = 566},
  [1055] = {.lex_state = 566},
  [1056] = {.lex_state = 354},
  [1057] = {.lex_state = 566},
  [1058] = {.lex_state = 566},
  [1059] = {.lex_state = 566},
  [1060] = {.lex_state = 566},
  [1061] = {.lex_state = 566},
  [1062] = {.lex_state = 566},
  [1063] = {.lex_state = 566},
  [1064] = {.lex_state = 566},
  [1065] = {.lex_state = 354},
  [1066] = {.lex_state = 566},
  [1067] = {.lex_state = 566},
  [1068] = {.lex_state = 566},
  [1069] = {.lex_state = 354},
  [1070] = {.lex_state = 566},
  [1071] = {.lex_state = 566},
  [1072] = {.lex_state = 566},
  [1073] = {.lex_state = 354},
  [1074] = {.lex_state = 566},
  [1075] = {.lex_state = 566},
  [1076] = {.lex_state = 566},
  [1077] = {.lex_state = 354},
  [1078] = {.lex_state = 566},
  [1079] = {.lex_state = 566},
  [1080] = {.lex_state = 566},
  [1081] = {.lex_state = 566},
  [1082] = {.lex_state = 354},
  [1083] = {.lex_state = 354},
  [1084] = {.lex_state = 351},
  [1085] = {.lex_state = 354},
  [1086] = {.lex_state = 354},
  [1087] = {.lex_state = 354},
  [1088] = {.lex_state = 351},
  [1089] = {.lex_state = 354},
  [1090] = {.lex_state = 354},
  [1091] = {.lex_state = 354},
  [1092] = {.lex_state = 354},
  [1093] = {.lex_state = 354},
  [1094] = {.lex_state = 354},
  [1095] = {.lex_state = 354},
  [1096] = {.lex_state = 566},
  [1097] = {.lex_state = 354},
  [1098] = {.lex_state = 566},
  [1099] = {.lex_state = 566},
  [1100] = {.lex_state = 354},
  [1101] = {.lex_state = 566},
  [1102] = {.lex_state = 354},
  [1103] = {.lex_state = 354},
  [1104] = {.lex_state = 354},
  [1105] = {.lex_state = 354},
  [1106] = {.lex_state = 354},
  [1107] = {.lex_state = 566},
  [1108] = {.lex_state = 354},
  [1109] = {.lex_state = 354},
  [1110] = {.lex_state = 354},
  [1111] = {.lex_state = 566},
  [1112] = {.lex_state = 566},
  [1113] = {.lex_state = 354},
  [1114] = {.lex_state = 354},
  [1115] = {.lex_state = 354},
  [1116] = {.lex_state = 354},
  [1117] = {.lex_state = 566},
  [1118] = {.lex_state = 354},
  [1119] = {.lex_state = 354},
  [1120] = {.lex_state = 354},
  [1121] = {.lex_state = 354},
  [1122] = {.lex_state = 566},
  [1123] = {.lex_state = 566},
  [1124] = {.lex_state = 566},
  [1125] = {.lex_state = 566},
  [1126] = {.lex_state = 566},
  [1127] = {.lex_state = 566},
  [1128] = {.lex_state = 566},
  [1129] = {.lex_state = 566},
  [1130] = {.lex_state = 566},
  [1131] = {.lex_state = 566},
  [1132] = {.lex_state = 566},
  [1133] = {.lex_state = 566},
  [1134] = {.lex_state = 566},
  [1135] = {.lex_state = 566},
  [1136] = {.lex_state = 566},
  [1137] = {.lex_state = 566},
  [1138] = {.lex_state = 566},
  [1139] = {.lex_state = 566},
  [1140] = {.lex_state = 566},
  [1141] = {.lex_state = 566},
  [1142] = {.lex_state = 566},
  [1143] = {.lex_state = 566},
  [1144] = {.lex_state = 566},
  [1145] = {.lex_state = 566},
  [1146] = {.lex_state = 566},
  [1147] = {.lex_state = 566},
  [1148] = {.lex_state = 566},
  [1149] = {.lex_state = 566},
  [1150] = {.lex_state = 566},
  [1151] = {.lex_state = 566},
  [1152] = {.lex_state = 566},
  [1153] = {.lex_state = 566},
  [1154] = {.lex_state = 566},
  [1155] = {.lex_state = 566},
  [1156] = {.lex_state = 566},
  [1157] = {.lex_state = 566},
  [1158] = {.lex_state = 566},
  [1159] = {.lex_state = 566},
  [1160] = {.lex_state = 566},
  [1161] = {.lex_state = 566},
  [1162] = {.lex_state = 566},
  [1163] = {.lex_state = 566},
  [1164] = {.lex_state = 566},
  [1165] = {.lex_state = 566},
  [1166] = {.lex_state = 566},
  [1167] = {.lex_state = 566},
  [1168] = {.lex_state = 566},
  [1169] = {.lex_state = 566},
  [1170] = {.lex_state = 566},
  [1171] = {.lex_state = 566},
  [1172] = {.lex_state = 566},
  [1173] = {.lex_state = 566},
  [1174] = {.lex_state = 566},
  [1175] = {.lex_state = 566},
  [1176] = {.lex_state = 566},
  [1177] = {.lex_state = 566},
  [1178] = {.lex_state = 566},
  [1179] = {.lex_state = 566},
  [1180] = {.lex_state = 566},
  [1181] = {.lex_state = 566},
  [1182] = {.lex_state = 566},
  [1183] = {.lex_state = 566},
  [1184] = {.lex_state = 566},
  [1185] = {.lex_state = 566},
  [1186] = {.lex_state = 566},
  [1187] = {.lex_state = 566},
  [1188] = {.lex_state = 566},
  [1189] = {.lex_state = 566},
  [1190] = {.lex_state = 31},
  [1191] = {.lex_state = 566},
  [1192] = {.lex_state = 566},
  [1193] = {.lex_state = 566},
  [1194] = {.lex_state = 566},
  [1195] = {.lex_state = 566},
  [1196] = {.lex_state = 566},
  [1197] = {.lex_state = 566},
  [1198] = {.lex_state = 566},
  [1199] = {.lex_state = 566},
  [1200] = {.lex_state = 566},
  [1201] = {.lex_state = 566},
  [1202] = {.lex_state = 566},
  [1203] = {.lex_state = 566},
  [1204] = {.lex_state = 566},
  [1205] = {.lex_state = 31},
  [1206] = {.lex_state = 566},
  [1207] = {.lex_state = 566},
  [1208] = {.lex_state = 31},
  [1209] = {.lex_state = 566},
  [1210] = {.lex_state = 566},
  [1211] = {.lex_state = 566},
  [1212] = {.lex_state = 566},
  [1213] = {.lex_state = 566},
  [1214] = {.lex_state = 566},
  [1215] = {.lex_state = 566},
  [1216] = {.lex_state = 566},
  [1217] = {.lex_state = 566},
  [1218] = {.lex_state = 566},
  [1219] = {.lex_state = 566},
  [1220] = {.lex_state = 566},
  [1221] = {.lex_state = 31},
  [1222] = {.lex_state = 31},
  [1223] = {.lex_state = 566},
  [1224] = {.lex_state = 566},
  [1225] = {.lex_state = 31},
  [1226] = {.lex_state = 31},
  [1227] = {.lex_state = 566},
  [1228] = {.lex_state = 566},
  [1229] = {.lex_state = 31},
  [1230] = {.lex_state = 31},
  [1231] = {.lex_state = 566},
  [1232] = {.lex_state = 566},
  [1233] = {.lex_state = 31},
  [1234] = {.lex_state = 31},
  [1235] = {.lex_state = 31},
  [1236] = {.lex_state = 566},
  [1237] = {.lex_state = 31},
  [1238] = {.lex_state = 31},
  [1239] = {.lex_state = 566},
  [1240] = {.lex_state = 354},
  [1241] = {.lex_state = 31},
  [1242] = {.lex_state = 31},
  [1243] = {.lex_state = 354},
  [1244] = {.lex_state = 566},
  [1245] = {.lex_state = 31},
  [1246] = {.lex_state = 31},
  [1247] = {.lex_state = 566},
  [1248] = {.lex_state = 566},
  [1249] = {.lex_state = 31},
  [1250] = {.lex_state = 31},
  [1251] = {.lex_state = 566},
  [1252] = {.lex_state = 566},
  [1253] = {.lex_state = 31},
  [1254] = {.lex_state = 31},
  [1255] = {.lex_state = 566},
  [1256] = {.lex_state = 566},
  [1257] = {.lex_state = 31},
  [1258] = {.lex_state = 31},
  [1259] = {.lex_state = 31},
  [1260] = {.lex_state = 31},
  [1261] = {.lex_state = 31},
  [1262] = {.lex_state = 31},
  [1263] = {.lex_state = 31},
  [1264] = {.lex_state = 31},
  [1265] = {.lex_state = 31},
  [1266] = {.lex_state = 31},
  [1267] = {.lex_state = 31},
  [1268] = {.lex_state = 31},
  [1269] = {.lex_state = 31},
  [1270] = {.lex_state = 31},
  [1271] = {.lex_state = 31},
  [1272] = {.lex_state = 31},
  [1273] = {.lex_state = 31},
  [1274] = {.lex_state = 31},
  [1275] = {.lex_state = 31},
  [1276] = {.lex_state = 31},
  [1277] = {.lex_state = 31},
  [1278] = {.lex_state = 31},
  [1279] = {.lex_state = 31},
  [1280] = {.lex_state = 31},
  [1281] = {.lex_state = 31},
  [1282] = {.lex_state = 31},
  [1283] = {.lex_state = 566},
  [1284] = {.lex_state = 566},
  [1285] = {.lex_state = 566},
  [1286] = {.lex_state = 566},
  [1287] = {.lex_state = 566},
  [1288] = {.lex_state = 566},
  [1289] = {.lex_state = 566},
  [1290] = {.lex_state = 566},
  [1291] = {.lex_state = 566},
  [1292] = {.lex_state = 566},
  [1293] = {.lex_state = 566},
  [1294] = {.lex_state = 566},
  [1295] = {.lex_state = 566},
  [1296] = {.lex_state = 566},
  [1297] = {.lex_state = 566},
  [1298] = {.lex_state = 566},
  [1299] = {.lex_state = 566},
  [1300] = {.lex_state = 566},
  [1301] = {.lex_state = 566},
  [1302] = {.lex_state = 31},
  [1303] = {.lex_state = 566},
  [1304] = {.lex_state = 566},
  [1305] = {.lex_state = 566},
  [1306] = {.lex_state = 566},
  [1307] = {.lex_state = 566},
  [1308] = {.lex_state = 566},
  [1309] = {.lex_state = 566},
  [1310] = {.lex_state = 566},
  [1311] = {.lex_state = 566},
  [1312] = {.lex_state = 566},
  [1313] = {.lex_state = 566},
  [1314] = {.lex_state = 566},
  [1315] = {.lex_state = 566},
  [1316] = {.lex_state = 566},
  [1317] = {.lex_state = 566},
  [1318] = {.lex_state = 566},
  [1319] = {.lex_state = 566},
  [1320] = {.lex_state = 566},
  [1321] = {.lex_state = 566},
  [1322] = {.lex_state = 566},
  [1323] = {.lex_state = 566},
  [1324] = {.lex_state = 566},
  [1325] = {.lex_state = 566},
  [1326] = {.lex_state = 566},
  [1327] = {.lex_state = 566},
  [1328] = {.lex_state = 566},
  [1329] = {.lex_state = 566},
  [1330] = {.lex_state = 566},
  [1331] = {.lex_state = 566},
  [1332] = {.lex_state = 566},
  [1333] = {.lex_state = 566},
  [1334] = {.lex_state = 566},
  [1335] = {.lex_state = 566},
  [1336] = {.lex_state = 566},
  [1337] = {.lex_state = 566},
  [1338] = {.lex_state = 566},
  [1339] = {.lex_state = 566},
  [1340] = {.lex_state = 566},
  [1341] = {.lex_state = 566},
  [1342] = {.lex_state = 566},
  [1343] = {.lex_state = 566},
  [1344] = {.lex_state = 566},
  [1345] = {.lex_state = 566},
  [1346] = {.lex_state = 566},
  [1347] = {.lex_state = 566},
  [1348] = {.lex_state = 566},
  [1349] = {.lex_state = 566},
  [1350] = {.lex_state = 566},
  [1351] = {.lex_state = 566},
  [1352] = {.lex_state = 566},
  [1353] = {.lex_state = 566},
  [1354] = {.lex_state = 566},
  [1355] = {.lex_state = 566},
  [1356] = {.lex_state = 566},
  [1357] = {.lex_state = 566},
  [1358] = {.lex_state = 566},
  [1359] = {.lex_state = 566},
  [1360] = {.lex_state = 566},
  [1361] = {.lex_state = 566},
  [1362] = {.lex_state = 566},
  [1363] = {.lex_state = 566},
  [1364] = {.lex_state = 566},
  [1365] = {.lex_state = 566},
  [1366] = {.lex_state = 566},
  [1367] = {.lex_state = 566},
  [1368] = {.lex_state = 566},
  [1369] = {.lex_state = 566},
  [1370] = {.lex_state = 566},
  [1371] = {.lex_state = 566},
  [1372] = {.lex_state = 566},
  [1373] = {.lex_state = 566},
  [1374] = {.lex_state = 566},
  [1375] = {.lex_state = 566},
  [1376] = {.lex_state = 566},
  [1377] = {.lex_state = 566},
  [1378] = {.lex_state = 566},
  [1379] = {.lex_state = 566},
  [1380] = {.lex_state = 566},
  [1381] = {.lex_state = 566},
  [1382] = {.lex_state = 566},
  [1383] = {.lex_state = 566},
  [1384] = {.lex_state = 566},
  [1385] = {.lex_state = 566},
  [1386] = {.lex_state = 566},
  [1387] = {.lex_state = 566},
  [1388] = {.lex_state = 566},
  [1389] = {.lex_state = 566},
  [1390] = {.lex_state = 566},
  [1391] = {.lex_state = 566},
  [1392] = {.lex_state = 566},
  [1393] = {.lex_state = 566},
  [1394] = {.lex_state = 566},
  [1395] = {.lex_state = 566},
  [1396] = {.lex_state = 566},
  [1397] = {.lex_state = 566},
  [1398] = {.lex_state = 566},
  [1399] = {.lex_state = 566},
  [1400] = {.lex_state = 566},
  [1401] = {.lex_state = 566},
  [1402] = {.lex_state = 566},
  [1403] = {.lex_state = 566},
  [1404] = {.lex_state = 566},
  [1405] = {.lex_state = 566},
  [1406] = {.lex_state = 566},
  [1407] = {.lex_state = 566},
  [1408] = {.lex_state = 566},
  [1409] = {.lex_state = 566},
  [1410] = {.lex_state = 566},
  [1411] = {.lex_state = 566},
  [1412] = {.lex_state = 566},
  [1413] = {.lex_state = 566},
  [1414] = {.lex_state = 566},
  [1415] = {.lex_state = 566},
  [1416] = {.lex_state = 566},
  [1417] = {.lex_state = 566},
  [1418] = {.lex_state = 566},
  [1419] = {.lex_state = 566},
  [1420] = {.lex_state = 566},
  [1421] = {.lex_state = 566},
  [1422] = {.lex_state = 566},
  [1423] = {.lex_state = 566},
  [1424] = {.lex_state = 566},
  [1425] = {.lex_state = 566},
  [1426] = {.lex_state = 566},
  [1427] = {.lex_state = 566},
  [1428] = {.lex_state = 566},
  [1429] = {.lex_state = 566},
  [1430] = {.lex_state = 566},
  [1431] = {.lex_state = 566},
  [1432] = {.lex_state = 566},
  [1433] = {.lex_state = 566},
  [1434] = {.lex_state = 566},
  [1435] = {.lex_state = 566},
  [1436] = {.lex_state = 566},
  [1437] = {.lex_state = 566},
  [1438] = {.lex_state = 566},
  [1439] = {.lex_state = 566},
  [1440] = {.lex_state = 566},
  [1441] = {.lex_state = 566},
  [1442] = {.lex_state = 566},
  [1443] = {.lex_state = 566},
  [1444] = {.lex_state = 566},
  [1445] = {.lex_state = 566},
  [1446] = {.lex_state = 566},
  [1447] = {.lex_state = 566},
  [1448] = {.lex_state = 566},
  [1449] = {.lex_state = 566},
  [1450] = {.lex_state = 566},
  [1451] = {.lex_state = 566},
  [1452] = {.lex_state = 566},
  [1453] = {.lex_state = 566},
  [1454] = {.lex_state = 566},
  [1455] = {.lex_state = 566},
  [1456] = {.lex_state = 566},
  [1457] = {.lex_state = 566},
  [1458] = {.lex_state = 566},
  [1459] = {.lex_state = 566},
  [1460] = {.lex_state = 566},
  [1461] = {.lex_state = 566},
  [1462] = {.lex_state = 566},
  [1463] = {.lex_state = 566},
  [1464] = {.lex_state = 566},
  [1465] = {.lex_state = 566},
  [1466] = {.lex_state = 566},
  [1467] = {.lex_state = 566},
  [1468] = {.lex_state = 566},
  [1469] = {.lex_state = 566},
  [1470] = {.lex_state = 566},
  [1471] = {.lex_state = 566},
  [1472] = {.lex_state = 566},
  [1473] = {.lex_state = 566},
  [1474] = {.lex_state = 566},
  [1475] = {.lex_state = 566},
  [1476] = {.lex_state = 566},
  [1477] = {.lex_state = 566},
  [1478] = {.lex_state = 566},
  [1479] = {.lex_state = 566},
  [1480] = {.lex_state = 566},
  [1481] = {.lex_state = 566},
  [1482] = {.lex_state = 566},
  [1483] = {.lex_state = 566},
  [1484] = {.lex_state = 566},
  [1485] = {.lex_state = 566},
  [1486] = {.lex_state = 566},
  [1487] = {.lex_state = 566},
  [1488] = {.lex_state = 566},
  [1489] = {.lex_state = 566},
  [1490] = {.lex_state = 566},
  [1491] = {.lex_state = 566},
  [1492] = {.lex_state = 566},
  [1493] = {.lex_state = 566},
  [1494] = {.lex_state = 566},
  [1495] = {.lex_state = 566},
  [1496] = {.lex_state = 566},
  [1497] = {.lex_state = 566},
  [1498] = {.lex_state = 566},
  [1499] = {.lex_state = 566},
  [1500] = {.lex_state = 566},
  [1501] = {.lex_state = 566},
  [1502] = {.lex_state = 566},
  [1503] = {.lex_state = 566},
  [1504] = {.lex_state = 566},
  [1505] = {.lex_state = 566},
  [1506] = {.lex_state = 566},
  [1507] = {.lex_state = 566},
  [1508] = {.lex_state = 566},
  [1509] = {.lex_state = 566},
  [1510] = {.lex_state = 566},
  [1511] = {.lex_state = 566},
  [1512] = {.lex_state = 566},
  [1513] = {.lex_state = 566},
  [1514] = {.lex_state = 566},
  [1515] = {.lex_state = 566},
  [1516] = {.lex_state = 566},
  [1517] = {.lex_state = 566},
  [1518] = {.lex_state = 566},
  [1519] = {.lex_state = 566},
  [1520] = {.lex_state = 566},
  [1521] = {.lex_state = 566},
  [1522] = {.lex_state = 566},
  [1523] = {.lex_state = 566},
  [1524] = {.lex_state = 566},
  [1525] = {.lex_state = 566},
  [1526] = {.lex_state = 566},
  [1527] = {.lex_state = 566},
  [1528] = {.lex_state = 566},
  [1529] = {.lex_state = 566},
  [1530] = {.lex_state = 566},
  [1531] = {.lex_state = 566},
  [1532] = {.lex_state = 566},
  [1533] = {.lex_state = 566},
  [1534] = {.lex_state = 566},
  [1535] = {.lex_state = 566},
  [1536] = {.lex_state = 566},
  [1537] = {.lex_state = 566},
  [1538] = {.lex_state = 566},
  [1539] = {.lex_state = 566},
  [1540] = {.lex_state = 566},
  [1541] = {.lex_state = 566},
  [1542] = {.lex_state = 566},
  [1543] = {.lex_state = 566},
  [1544] = {.lex_state = 566},
  [1545] = {.lex_state = 566},
  [1546] = {.lex_state = 566},
  [1547] = {.lex_state = 566},
  [1548] = {.lex_state = 566},
  [1549] = {.lex_state = 566},
  [1550] = {.lex_state = 566},
  [1551] = {.lex_state = 566},
  [1552] = {.lex_state = 566},
  [1553] = {.lex_state = 566},
  [1554] = {.lex_state = 566},
  [1555] = {.lex_state = 566},
  [1556] = {.lex_state = 566},
  [1557] = {.lex_state = 566},
  [1558] = {.lex_state = 566},
  [1559] = {.lex_state = 566},
  [1560] = {.lex_state = 566},
  [1561] = {.lex_state = 566},
  [1562] = {.lex_state = 566},
  [1563] = {.lex_state = 566},
  [1564] = {.lex_state = 566},
  [1565] = {.lex_state = 566},
  [1566] = {.lex_state = 566},
  [1567] = {.lex_state = 566},
  [1568] = {.lex_state = 566},
  [1569] = {.lex_state = 566},
  [1570] = {.lex_state = 566},
  [1571] = {.lex_state = 566},
  [1572] = {.lex_state = 566},
  [1573] = {.lex_state = 566},
  [1574] = {.lex_state = 566},
  [1575] = {.lex_state = 566},
  [1576] = {.lex_state = 566},
  [1577] = {.lex_state = 566},
  [1578] = {.lex_state = 566},
  [1579] = {.lex_state = 566},
  [1580] = {.lex_state = 566},
  [1581] = {.lex_state = 566},
  [1582] = {.lex_state = 566},
  [1583] = {.lex_state = 566},
  [1584] = {.lex_state = 566},
  [1585] = {.lex_state = 566},
  [1586] = {.lex_state = 566},
  [1587] = {.lex_state = 566},
  [1588] = {.lex_state = 566},
  [1589] = {.lex_state = 566},
  [1590] = {.lex_state = 566},
  [1591] = {.lex_state = 566},
  [1592] = {.lex_state = 566},
  [1593] = {.lex_state = 566},
  [1594] = {.lex_state = 566},
  [1595] = {.lex_state = 566},
  [1596] = {.lex_state = 566},
  [1597] = {.lex_state = 566},
  [1598] = {.lex_state = 566},
  [1599] = {.lex_state = 566},
  [1600] = {.lex_state = 566},
  [1601] = {.lex_state = 566},
  [1602] = {.lex_state = 566},
  [1603] = {.lex_state = 566},
  [1604] = {.lex_state = 566},
  [1605] = {.lex_state = 566},
  [1606] = {.lex_state = 566},
  [1607] = {.lex_state = 566},
  [1608] = {.lex_state = 566},
  [1609] = {.lex_state = 566},
  [1610] = {.lex_state = 566},
  [1611] = {.lex_state = 566},
  [1612] = {.lex_state = 566},
  [1613] = {.lex_state = 566},
  [1614] = {.lex_state = 566},
  [1615] = {.lex_state = 566},
  [1616] = {.lex_state = 566},
  [1617] = {.lex_state = 566},
  [1618] = {.lex_state = 566},
  [1619] = {.lex_state = 566},
  [1620] = {.lex_state = 566},
  [1621] = {.lex_state = 566},
  [1622] = {.lex_state = 566},
  [1623] = {.lex_state = 566},
  [1624] = {.lex_state = 566},
  [1625] = {.lex_state = 566},
  [1626] = {.lex_state = 566},
  [1627] = {.lex_state = 566},
  [1628] = {.lex_state = 566},
  [1629] = {.lex_state = 566},
  [1630] = {.lex_state = 566},
  [1631] = {.lex_state = 566},
  [1632] = {.lex_state = 566},
  [1633] = {.lex_state = 566},
  [1634] = {.lex_state = 566},
  [1635] = {.lex_state = 566},
  [1636] = {.lex_state = 566},
  [1637] = {.lex_state = 566},
  [1638] = {.lex_state = 566},
  [1639] = {.lex_state = 566},
  [1640] = {.lex_state = 566},
  [1641] = {.lex_state = 566},
  [1642] = {.lex_state = 566},
  [1643] = {.lex_state = 566},
  [1644] = {.lex_state = 566},
  [1645] = {.lex_state = 566},
  [1646] = {.lex_state = 566},
  [1647] = {.lex_state = 566},
  [1648] = {.lex_state = 566},
  [1649] = {.lex_state = 566},
  [1650] = {.lex_state = 566},
  [1651] = {.lex_state = 566},
  [1652] = {.lex_state = 566},
  [1653] = {.lex_state = 566},
  [1654] = {.lex_state = 566},
  [1655] = {.lex_state = 566},
  [1656] = {.lex_state = 566},
  [1657] = {.lex_state = 566},
  [1658] = {.lex_state = 566},
  [1659] = {.lex_state = 566},
  [1660] = {.lex_state = 566},
  [1661] = {.lex_state = 566},
  [1662] = {.lex_state = 566},
  [1663] = {.lex_state = 566},
  [1664] = {.lex_state = 566},
  [1665] = {.lex_state = 566},
  [1666] = {.lex_state = 566},
  [1667] = {.lex_state = 566},
  [1668] = {.lex_state = 566},
  [1669] = {.lex_state = 566},
  [1670] = {.lex_state = 566},
  [1671] = {.lex_state = 566},
  [1672] = {.lex_state = 566},
  [1673] = {.lex_state = 566},
  [1674] = {.lex_state = 566},
  [1675] = {.lex_state = 566},
  [1676] = {.lex_state = 566},
  [1677] = {.lex_state = 566},
  [1678] = {.lex_state = 566},
  [1679] = {.lex_state = 566},
  [1680] = {.lex_state = 566},
  [1681] = {.lex_state = 566},
  [1682] = {.lex_state = 566},
  [1683] = {.lex_state = 566},
  [1684] = {.lex_state = 566},
  [1685] = {.lex_state = 566},
  [1686] = {.lex_state = 566},
  [1687] = {.lex_state = 566},
  [1688] = {.lex_state = 566},
  [1689] = {.lex_state = 566},
  [1690] = {.lex_state = 566},
  [1691] = {.lex_state = 566},
  [1692] = {.lex_state = 566},
  [1693] = {.lex_state = 566},
  [1694] = {.lex_state = 566},
  [1695] = {.lex_state = 566},
  [1696] = {.lex_state = 566},
  [1697] = {.lex_state = 566},
  [1698] = {.lex_state = 566},
  [1699] = {.lex_state = 566},
  [1700] = {.lex_state = 566},
  [1701] = {.lex_state = 566},
  [1702] = {.lex_state = 566},
  [1703] = {.lex_state = 566},
  [1704] = {.lex_state = 566},
  [1705] = {.lex_state = 566},
  [1706] = {.lex_state = 566},
  [1707] = {.lex_state = 566},
  [1708] = {.lex_state = 566},
  [1709] = {.lex_state = 566},
  [1710] = {.lex_state = 566},
  [1711] = {.lex_state = 566},
  [1712] = {.lex_state = 566},
  [1713] = {.lex_state = 566},
  [1714] = {.lex_state = 566},
  [1715] = {.lex_state = 566},
  [1716] = {.lex_state = 566},
  [1717] = {.lex_state = 566},
  [1718] = {.lex_state = 566},
  [1719] = {.lex_state = 566},
  [1720] = {.lex_state = 566},
  [1721] = {.lex_state = 566},
  [1722] = {.lex_state = 566},
  [1723] = {.lex_state = 566},
  [1724] = {.lex_state = 566},
  [1725] = {.lex_state = 566},
  [1726] = {.lex_state = 566},
  [1727] = {.lex_state = 566},
  [1728] = {.lex_state = 566},
  [1729] = {.lex_state = 566},
  [1730] = {.lex_state = 566},
  [1731] = {.lex_state = 566},
  [1732] = {.lex_state = 566},
  [1733] = {.lex_state = 566},
  [1734] = {.lex_state = 566},
  [1735] = {.lex_state = 566},
  [1736] = {.lex_state = 566},
  [1737] = {.lex_state = 566},
  [1738] = {.lex_state = 566},
  [1739] = {.lex_state = 566},
  [1740] = {.lex_state = 566},
  [1741] = {.lex_state = 566},
  [1742] = {.lex_state = 566},
  [1743] = {.lex_state = 566},
  [1744] = {.lex_state = 566},
  [1745] = {.lex_state = 566},
  [1746] = {.lex_state = 566},
  [1747] = {.lex_state = 566},
  [1748] = {.lex_state = 566},
  [1749] = {.lex_state = 566},
  [1750] = {.lex_state = 566},
  [1751] = {.lex_state = 566},
  [1752] = {.lex_state = 566},
  [1753] = {.lex_state = 566},
  [1754] = {.lex_state = 566},
  [1755] = {.lex_state = 566},
  [1756] = {.lex_state = 566},
  [1757] = {.lex_state = 566},
  [1758] = {.lex_state = 566},
  [1759] = {.lex_state = 566},
  [1760] = {.lex_state = 566},
  [1761] = {.lex_state = 566},
  [1762] = {.lex_state = 566},
  [1763] = {.lex_state = 566},
  [1764] = {.lex_state = 566},
  [1765] = {.lex_state = 566},
  [1766] = {.lex_state = 566},
  [1767] = {.lex_state = 566},
  [1768] = {.lex_state = 566},
  [1769] = {.lex_state = 566},
  [1770] = {.lex_state = 566},
  [1771] = {.lex_state = 566},
  [1772] = {.lex_state = 566},
  [1773] = {.lex_state = 566},
  [1774] = {.lex_state = 566},
  [1775] = {.lex_state = 566},
  [1776] = {.lex_state = 566},
  [1777] = {.lex_state = 566},
  [1778] = {.lex_state = 566},
  [1779] = {.lex_state = 566},
  [1780] = {.lex_state = 566},
  [1781] = {.lex_state = 566},
  [1782] = {.lex_state = 566},
  [1783] = {.lex_state = 566},
  [1784] = {.lex_state = 566},
  [1785] = {.lex_state = 566},
  [1786] = {.lex_state = 566},
  [1787] = {.lex_state = 566},
  [1788] = {.lex_state = 566},
  [1789] = {.lex_state = 566},
  [1790] = {.lex_state = 566},
  [1791] = {.lex_state = 566},
  [1792] = {.lex_state = 566},
  [1793] = {.lex_state = 566},
  [1794] = {.lex_state = 566},
  [1795] = {.lex_state = 566},
  [1796] = {.lex_state = 566},
  [1797] = {.lex_state = 566},
  [1798] = {.lex_state = 566},
  [1799] = {.lex_state = 566},
  [1800] = {.lex_state = 566},
  [1801] = {.lex_state = 566},
  [1802] = {.lex_state = 566},
  [1803] = {.lex_state = 566},
  [1804] = {.lex_state = 566},
  [1805] = {.lex_state = 566},
  [1806] = {.lex_state = 566},
  [1807] = {.lex_state = 566},
  [1808] = {.lex_state = 566},
  [1809] = {.lex_state = 566},
  [1810] = {.lex_state = 566},
  [1811] = {.lex_state = 566},
  [1812] = {.lex_state = 566},
  [1813] = {.lex_state = 566},
  [1814] = {.lex_state = 566},
  [1815] = {.lex_state = 566},
  [1816] = {.lex_state = 566},
  [1817] = {.lex_state = 566},
  [1818] = {.lex_state = 566},
  [1819] = {.lex_state = 566},
  [1820] = {.lex_state = 566},
  [1821] = {.lex_state = 566},
  [1822] = {.lex_state = 566},
  [1823] = {.lex_state = 566},
  [1824] = {.lex_state = 566},
  [1825] = {.lex_state = 566},
  [1826] = {.lex_state = 566},
  [1827] = {.lex_state = 566},
  [1828] = {.lex_state = 566},
  [1829] = {.lex_state = 566},
  [1830] = {.lex_state = 566},
  [1831] = {.lex_state = 566},
  [1832] = {.lex_state = 566},
  [1833] = {.lex_state = 566},
  [1834] = {.lex_state = 566},
  [1835] = {.lex_state = 566},
  [1836] = {.lex_state = 566},
  [1837] = {.lex_state = 566},
  [1838] = {.lex_state = 566},
  [1839] = {.lex_state = 566},
  [1840] = {.lex_state = 566},
  [1841] = {.lex_state = 566},
  [1842] = {.lex_state = 566},
  [1843] = {.lex_state = 566},
  [1844] = {.lex_state = 566},
  [1845] = {.lex_state = 566},
  [1846] = {.lex_state = 566},
  [1847] = {.lex_state = 566},
  [1848] = {.lex_state = 566},
  [1849] = {.lex_state = 566},
  [1850] = {.lex_state = 566},
  [1851] = {.lex_state = 566},
  [1852] = {.lex_state = 566},
  [1853] = {.lex_state = 566},
  [1854] = {.lex_state = 566},
  [1855] = {.lex_state = 566},
  [1856] = {.lex_state = 566},
  [1857] = {.lex_state = 566},
  [1858] = {.lex_state = 566},
  [1859] = {.lex_state = 566},
  [1860] = {.lex_state = 566},
  [1861] = {.lex_state = 566},
  [1862] = {.lex_state = 566},
  [1863] = {.lex_state = 566},
  [1864] = {.lex_state = 566},
  [1865] = {.lex_state = 566},
  [1866] = {.lex_state = 566},
  [1867] = {.lex_state = 566},
  [1868] = {.lex_state = 566},
  [1869] = {.lex_state = 566},
  [1870] = {.lex_state = 566},
  [1871] = {.lex_state = 566},
  [1872] = {.lex_state = 566},
  [1873] = {.lex_state = 566},
  [1874] = {.lex_state = 566},
  [1875] = {.lex_state = 566},
  [1876] = {.lex_state = 566},
  [1877] = {.lex_state = 566},
  [1878] = {.lex_state = 566},
  [1879] = {.lex_state = 566},
  [1880] = {.lex_state = 566},
  [1881] = {.lex_state = 566},
  [1882] = {.lex_state = 566},
  [1883] = {.lex_state = 566},
  [1884] = {.lex_state = 566},
  [1885] = {.lex_state = 566},
  [1886] = {.lex_state = 566},
  [1887] = {.lex_state = 566},
  [1888] = {.lex_state = 566},
  [1889] = {.lex_state = 566},
  [1890] = {.lex_state = 566},
  [1891] = {.lex_state = 566},
  [1892] = {.lex_state = 566},
  [1893] = {.lex_state = 566},
  [1894] = {.lex_state = 566},
  [1895] = {.lex_state = 566},
  [1896] = {.lex_state = 566},
  [1897] = {.lex_state = 566},
  [1898] = {.lex_state = 566},
  [1899] = {.lex_state = 566},
  [1900] = {.lex_state = 566},
  [1901] = {.lex_state = 566},
  [1902] = {.lex_state = 566},
  [1903] = {.lex_state = 566},
  [1904] = {.lex_state = 566},
  [1905] = {.lex_state = 566},
  [1906] = {.lex_state = 566},
  [1907] = {.lex_state = 566},
  [1908] = {.lex_state = 566},
  [1909] = {.lex_state = 566},
  [1910] = {.lex_state = 566},
  [1911] = {.lex_state = 566},
  [1912] = {.lex_state = 566},
  [1913] = {.lex_state = 566},
  [1914] = {.lex_state = 566},
  [1915] = {.lex_state = 566},
  [1916] = {.lex_state = 566},
  [1917] = {.lex_state = 566},
  [1918] = {.lex_state = 566},
  [1919] = {.lex_state = 566},
  [1920] = {.lex_state = 566},
  [1921] = {.lex_state = 566},
  [1922] = {.lex_state = 566},
  [1923] = {.lex_state = 566},
  [1924] = {.lex_state = 566},
  [1925] = {.lex_state = 566},
  [1926] = {.lex_state = 566},
  [1927] = {.lex_state = 566},
  [1928] = {.lex_state = 566},
  [1929] = {.lex_state = 566},
  [1930] = {.lex_state = 566},
  [1931] = {.lex_state = 566},
  [1932] = {.lex_state = 566},
  [1933] = {.lex_state = 566},
  [1934] = {.lex_state = 566},
  [1935] = {.lex_state = 566},
  [1936] = {.lex_state = 566},
  [1937] = {.lex_state = 566},
  [1938] = {.lex_state = 566},
  [1939] = {.lex_state = 566},
  [1940] = {.lex_state = 566},
  [1941] = {.lex_state = 566},
  [1942] = {.lex_state = 566},
  [1943] = {.lex_state = 566},
  [1944] = {.lex_state = 566},
  [1945] = {.lex_state = 566},
  [1946] = {.lex_state = 566},
  [1947] = {.lex_state = 566},
  [1948] = {.lex_state = 566},
  [1949] = {.lex_state = 566},
  [1950] = {.lex_state = 566},
  [1951] = {.lex_state = 566},
  [1952] = {.lex_state = 566},
  [1953] = {.lex_state = 566},
  [1954] = {.lex_state = 566},
  [1955] = {.lex_state = 566},
  [1956] = {.lex_state = 566},
  [1957] = {.lex_state = 566},
  [1958] = {.lex_state = 566},
  [1959] = {.lex_state = 566},
  [1960] = {.lex_state = 566},
  [1961] = {.lex_state = 566},
  [1962] = {.lex_state = 566},
  [1963] = {.lex_state = 566},
  [1964] = {.lex_state = 566},
  [1965] = {.lex_state = 566},
  [1966] = {.lex_state = 566},
  [1967] = {.lex_state = 566},
  [1968] = {.lex_state = 566},
  [1969] = {.lex_state = 566},
  [1970] = {.lex_state = 566},
  [1971] = {.lex_state = 566},
  [1972] = {.lex_state = 566},
  [1973] = {.lex_state = 566},
  [1974] = {.lex_state = 566},
  [1975] = {.lex_state = 566},
  [1976] = {.lex_state = 566},
  [1977] = {.lex_state = 566},
  [1978] = {.lex_state = 566},
  [1979] = {.lex_state = 566},
  [1980] = {.lex_state = 566},
  [1981] = {.lex_state = 566},
  [1982] = {.lex_state = 566},
  [1983] = {.lex_state = 566},
  [1984] = {.lex_state = 566},
  [1985] = {.lex_state = 566},
  [1986] = {.lex_state = 566},
  [1987] = {.lex_state = 566},
  [1988] = {.lex_state = 566},
  [1989] = {.lex_state = 566},
  [1990] = {.lex_state = 566},
  [1991] = {.lex_state = 566},
  [1992] = {.lex_state = 566},
  [1993] = {.lex_state = 566},
  [1994] = {.lex_state = 566},
  [1995] = {.lex_state = 566},
  [1996] = {.lex_state = 566},
  [1997] = {.lex_state = 566},
  [1998] = {.lex_state = 566},
  [1999] = {.lex_state = 566},
  [2000] = {.lex_state = 566},
  [2001] = {.lex_state = 566},
  [2002] = {.lex_state = 566},
  [2003] = {.lex_state = 566},
  [2004] = {.lex_state = 566},
  [2005] = {.lex_state = 566},
  [2006] = {.lex_state = 566},
  [2007] = {.lex_state = 566},
  [2008] = {.lex_state = 566},
  [2009] = {.lex_state = 566},
  [2010] = {.lex_state = 566},
  [2011] = {.lex_state = 566},
  [2012] = {.lex_state = 566},
  [2013] = {.lex_state = 566},
  [2014] = {.lex_state = 566},
  [2015] = {.lex_state = 566},
  [2016] = {.lex_state = 566},
  [2017] = {.lex_state = 566},
  [2018] = {.lex_state = 566},
  [2019] = {.lex_state = 566},
  [2020] = {.lex_state = 566},
  [2021] = {.lex_state = 566},
  [2022] = {.lex_state = 566},
  [2023] = {.lex_state = 566},
  [2024] = {.lex_state = 566},
  [2025] = {.lex_state = 566},
  [2026] = {.lex_state = 566},
  [2027] = {.lex_state = 566},
  [2028] = {.lex_state = 566},
  [2029] = {.lex_state = 566},
  [2030] = {.lex_state = 566},
  [2031] = {.lex_state = 566},
  [2032] = {.lex_state = 566},
  [2033] = {.lex_state = 566},
  [2034] = {.lex_state = 566},
  [2035] = {.lex_state = 566},
  [2036] = {.lex_state = 566},
  [2037] = {.lex_state = 566},
  [2038] = {.lex_state = 566},
  [2039] = {.lex_state = 566},
  [2040] = {.lex_state = 566},
  [2041] = {.lex_state = 566},
  [2042] = {.lex_state = 566},
  [2043] = {.lex_state = 566},
  [2044] = {.lex_state = 566},
  [2045] = {.lex_state = 566},
  [2046] = {.lex_state = 566},
  [2047] = {.lex_state = 566},
  [2048] = {.lex_state = 566},
  [2049] = {.lex_state = 566},
  [2050] = {.lex_state = 566},
  [2051] = {.lex_state = 566},
  [2052] = {.lex_state = 566},
  [2053] = {.lex_state = 566},
  [2054] = {.lex_state = 566},
  [2055] = {.lex_state = 566},
  [2056] = {.lex_state = 566},
  [2057] = {.lex_state = 566},
  [2058] = {.lex_state = 566},
  [2059] = {.lex_state = 566},
  [2060] = {.lex_state = 566},
  [2061] = {.lex_state = 566},
  [2062] = {.lex_state = 566},
  [2063] = {.lex_state = 566},
  [2064] = {.lex_state = 566},
  [2065] = {.lex_state = 566},
  [2066] = {.lex_state = 566},
  [2067] = {.lex_state = 566},
  [2068] = {.lex_state = 566},
  [2069] = {.lex_state = 566},
  [2070] = {.lex_state = 566},
  [2071] = {.lex_state = 566},
  [2072] = {.lex_state = 566},
  [2073] = {.lex_state = 566},
  [2074] = {.lex_state = 566},
  [2075] = {.lex_state = 566},
  [2076] = {.lex_state = 566},
  [2077] = {.lex_state = 566},
  [2078] = {.lex_state = 566},
  [2079] = {.lex_state = 566},
  [2080] = {.lex_state = 566},
  [2081] = {.lex_state = 566},
  [2082] = {.lex_state = 566},
  [2083] = {.lex_state = 566},
  [2084] = {.lex_state = 566},
  [2085] = {.lex_state = 566},
  [2086] = {.lex_state = 566},
  [2087] = {.lex_state = 566},
  [2088] = {.lex_state = 566},
  [2089] = {.lex_state = 566},
  [2090] = {.lex_state = 566},
  [2091] = {.lex_state = 566},
  [2092] = {.lex_state = 566},
  [2093] = {.lex_state = 566},
  [2094] = {.lex_state = 566},
  [2095] = {.lex_state = 566},
  [2096] = {.lex_state = 566},
  [2097] = {.lex_state = 566},
  [2098] = {.lex_state = 566},
  [2099] = {.lex_state = 566},
  [2100] = {.lex_state = 566},
  [2101] = {.lex_state = 566},
  [2102] = {.lex_state = 566},
  [2103] = {.lex_state = 566},
  [2104] = {.lex_state = 566},
  [2105] = {.lex_state = 566},
  [2106] = {.lex_state = 566},
  [2107] = {.lex_state = 566},
  [2108] = {.lex_state = 566},
  [2109] = {.lex_state = 566},
  [2110] = {.lex_state = 566},
  [2111] = {.lex_state = 566},
  [2112] = {.lex_state = 566},
  [2113] = {.lex_state = 566},
  [2114] = {.lex_state = 566},
  [2115] = {.lex_state = 566},
  [2116] = {.lex_state = 566},
  [2117] = {.lex_state = 566},
  [2118] = {.lex_state = 566},
  [2119] = {.lex_state = 566},
  [2120] = {.lex_state = 566},
  [2121] = {.lex_state = 566},
  [2122] = {.lex_state = 566},
  [2123] = {.lex_state = 566},
  [2124] = {.lex_state = 566},
  [2125] = {.lex_state = 566},
  [2126] = {.lex_state = 566},
  [2127] = {.lex_state = 566},
  [2128] = {.lex_state = 566},
  [2129] = {.lex_state = 566},
  [2130] = {.lex_state = 566},
  [2131] = {.lex_state = 566},
  [2132] = {.lex_state = 566},
  [2133] = {.lex_state = 566},
  [2134] = {.lex_state = 566},
  [2135] = {.lex_state = 566},
  [2136] = {.lex_state = 566},
  [2137] = {.lex_state = 566},
  [2138] = {.lex_state = 566},
  [2139] = {.lex_state = 566},
  [2140] = {.lex_state = 566},
  [2141] = {.lex_state = 566},
  [2142] = {.lex_state = 566},
  [2143] = {.lex_state = 566},
  [2144] = {.lex_state = 566},
  [2145] = {.lex_state = 566},
  [2146] = {.lex_state = 566},
  [2147] = {.lex_state = 566},
  [2148] = {.lex_state = 566},
  [2149] = {.lex_state = 566},
  [2150] = {.lex_state = 566},
  [2151] = {.lex_state = 566},
  [2152] = {.lex_state = 566},
  [2153] = {.lex_state = 566},
  [2154] = {.lex_state = 566},
  [2155] = {.lex_state = 566},
  [2156] = {.lex_state = 566},
  [2157] = {.lex_state = 566},
  [2158] = {.lex_state = 566},
  [2159] = {.lex_state = 566},
  [2160] = {.lex_state = 566},
  [2161] = {.lex_state = 566},
  [2162] = {.lex_state = 566},
  [2163] = {.lex_state = 566},
  [2164] = {.lex_state = 566},
  [2165] = {.lex_state = 566},
  [2166] = {.lex_state = 566},
  [2167] = {.lex_state = 566},
  [2168] = {.lex_state = 566},
  [2169] = {.lex_state = 566},
  [2170] = {.lex_state = 566},
  [2171] = {.lex_state = 566},
  [2172] = {.lex_state = 566},
  [2173] = {.lex_state = 566},
  [2174] = {.lex_state = 566},
  [2175] = {.lex_state = 566},
  [2176] = {.lex_state = 566},
  [2177] = {.lex_state = 566},
  [2178] = {.lex_state = 566},
  [2179] = {.lex_state = 566},
  [2180] = {.lex_state = 566},
  [2181] = {.lex_state = 566},
  [2182] = {.lex_state = 566},
  [2183] = {.lex_state = 566},
  [2184] = {.lex_state = 566},
  [2185] = {.lex_state = 566},
  [2186] = {.lex_state = 566},
  [2187] = {.lex_state = 566},
  [2188] = {.lex_state = 566},
  [2189] = {.lex_state = 566},
  [2190] = {.lex_state = 566},
  [2191] = {.lex_state = 566},
  [2192] = {.lex_state = 566},
  [2193] = {.lex_state = 566},
  [2194] = {.lex_state = 566},
  [2195] = {.lex_state = 566},
  [2196] = {.lex_state = 566},
  [2197] = {.lex_state = 566},
  [2198] = {.lex_state = 566},
  [2199] = {.lex_state = 566},
  [2200] = {.lex_state = 566},
  [2201] = {.lex_state = 566},
  [2202] = {.lex_state = 566},
  [2203] = {.lex_state = 566},
  [2204] = {.lex_state = 566},
  [2205] = {.lex_state = 566},
  [2206] = {.lex_state = 566},
  [2207] = {.lex_state = 566},
  [2208] = {.lex_state = 566},
  [2209] = {.lex_state = 566},
  [2210] = {.lex_state = 566},
  [2211] = {.lex_state = 566},
  [2212] = {.lex_state = 566},
  [2213] = {.lex_state = 566},
  [2214] = {.lex_state = 566},
  [2215] = {.lex_state = 566},
  [2216] = {.lex_state = 566},
  [2217] = {.lex_state = 566},
  [2218] = {.lex_state = 566},
  [2219] = {.lex_state = 566},
  [2220] = {.lex_state = 566},
  [2221] = {.lex_state = 566},
  [2222] = {.lex_state = 566},
  [2223] = {.lex_state = 566},
  [2224] = {.lex_state = 566},
  [2225] = {.lex_state = 566},
  [2226] = {.lex_state = 566},
  [2227] = {.lex_state = 566},
  [2228] = {.lex_state = 566},
  [2229] = {.lex_state = 566},
  [2230] = {.lex_state = 566},
  [2231] = {.lex_state = 566},
  [2232] = {.lex_state = 566},
  [2233] = {.lex_state = 566},
  [2234] = {.lex_state = 566},
  [2235] = {.lex_state = 566},
  [2236] = {.lex_state = 566},
  [2237] = {.lex_state = 566},
  [2238] = {.lex_state = 566},
  [2239] = {.lex_state = 566},
  [2240] = {.lex_state = 566},
  [2241] = {.lex_state = 566},
  [2242] = {.lex_state = 566},
  [2243] = {.lex_state = 566},
  [2244] = {.lex_state = 566},
  [2245] = {.lex_state = 566},
  [2246] = {.lex_state = 566},
  [2247] = {.lex_state = 566},
  [2248] = {.lex_state = 566},
  [2249] = {.lex_state = 566},
  [2250] = {.lex_state = 566},
  [2251] = {.lex_state = 566},
  [2252] = {.lex_state = 566},
  [2253] = {.lex_state = 566},
  [2254] = {.lex_state = 566},
  [2255] = {.lex_state = 566},
  [2256] = {.lex_state = 566},
  [2257] = {.lex_state = 566},
  [2258] = {.lex_state = 566},
  [2259] = {.lex_state = 566},
  [2260] = {.lex_state = 566},
  [2261] = {.lex_state = 566},
  [2262] = {.lex_state = 566},
  [2263] = {.lex_state = 566},
  [2264] = {.lex_state = 566},
  [2265] = {.lex_state = 566},
  [2266] = {.lex_state = 566},
  [2267] = {.lex_state = 566},
  [2268] = {.lex_state = 566},
  [2269] = {.lex_state = 566},
  [2270] = {.lex_state = 566},
  [2271] = {.lex_state = 566},
  [2272] = {.lex_state = 566},
  [2273] = {.lex_state = 566},
  [2274] = {.lex_state = 566},
  [2275] = {.lex_state = 566},
  [2276] = {.lex_state = 566},
  [2277] = {.lex_state = 566},
  [2278] = {.lex_state = 566},
  [2279] = {.lex_state = 566},
  [2280] = {.lex_state = 566},
  [2281] = {.lex_state = 566},
  [2282] = {.lex_state = 566},
  [2283] = {.lex_state = 566},
  [2284] = {.lex_state = 566},
  [2285] = {.lex_state = 566},
  [2286] = {.lex_state = 566},
  [2287] = {.lex_state = 566},
  [2288] = {.lex_state = 566},
  [2289] = {.lex_state = 566},
  [2290] = {.lex_state = 566},
  [2291] = {.lex_state = 566},
  [2292] = {.lex_state = 566},
  [2293] = {.lex_state = 566},
  [2294] = {.lex_state = 566},
  [2295] = {.lex_state = 566},
  [2296] = {.lex_state = 566},
  [2297] = {.lex_state = 566},
  [2298] = {.lex_state = 566},
  [2299] = {.lex_state = 566},
  [2300] = {.lex_state = 566},
  [2301] = {.lex_state = 566},
  [2302] = {.lex_state = 566},
  [2303] = {.lex_state = 566},
  [2304] = {.lex_state = 566},
  [2305] = {.lex_state = 566},
  [2306] = {.lex_state = 566},
  [2307] = {.lex_state = 566},
  [2308] = {.lex_state = 566},
  [2309] = {.lex_state = 566},
  [2310] = {.lex_state = 566},
  [2311] = {.lex_state = 566},
  [2312] = {.lex_state = 566},
  [2313] = {.lex_state = 566},
  [2314] = {.lex_state = 566},
  [2315] = {.lex_state = 566},
  [2316] = {.lex_state = 566},
  [2317] = {.lex_state = 566},
  [2318] = {.lex_state = 566},
  [2319] = {.lex_state = 566},
  [2320] = {.lex_state = 566},
  [2321] = {.lex_state = 566},
  [2322] = {.lex_state = 566},
  [2323] = {.lex_state = 566},
  [2324] = {.lex_state = 566},
  [2325] = {.lex_state = 566},
  [2326] = {.lex_state = 566},
  [2327] = {.lex_state = 566},
  [2328] = {.lex_state = 566},
  [2329] = {.lex_state = 566},
  [2330] = {.lex_state = 566},
  [2331] = {.lex_state = 566},
  [2332] = {.lex_state = 566},
  [2333] = {.lex_state = 566},
  [2334] = {.lex_state = 566},
  [2335] = {.lex_state = 566},
  [2336] = {.lex_state = 566},
  [2337] = {.lex_state = 566},
  [2338] = {.lex_state = 566},
  [2339] = {.lex_state = 566},
  [2340] = {.lex_state = 566},
  [2341] = {.lex_state = 566},
  [2342] = {.lex_state = 566},
  [2343] = {.lex_state = 566},
  [2344] = {.lex_state = 566},
  [2345] = {.lex_state = 566},
  [2346] = {.lex_state = 566},
  [2347] = {.lex_state = 566},
  [2348] = {.lex_state = 566},
  [2349] = {.lex_state = 566},
  [2350] = {.lex_state = 566},
  [2351] = {.lex_state = 566},
  [2352] = {.lex_state = 566},
  [2353] = {.lex_state = 566},
  [2354] = {.lex_state = 566},
  [2355] = {.lex_state = 566},
  [2356] = {.lex_state = 566},
  [2357] = {.lex_state = 566},
  [2358] = {.lex_state = 566},
  [2359] = {.lex_state = 566},
  [2360] = {.lex_state = 566},
  [2361] = {.lex_state = 566},
  [2362] = {.lex_state = 566},
  [2363] = {.lex_state = 566},
  [2364] = {.lex_state = 566},
  [2365] = {.lex_state = 566},
  [2366] = {.lex_state = 566},
  [2367] = {.lex_state = 566},
  [2368] = {.lex_state = 566},
  [2369] = {.lex_state = 566},
  [2370] = {.lex_state = 566},
  [2371] = {.lex_state = 566},
  [2372] = {.lex_state = 566},
  [2373] = {.lex_state = 566},
  [2374] = {.lex_state = 566},
  [2375] = {.lex_state = 566},
  [2376] = {.lex_state = 566},
  [2377] = {.lex_state = 566},
  [2378] = {.lex_state = 566},
  [2379] = {.lex_state = 566},
  [2380] = {.lex_state = 566},
  [2381] = {.lex_state = 566},
  [2382] = {.lex_state = 566},
  [2383] = {.lex_state = 566},
  [2384] = {.lex_state = 566},
  [2385] = {.lex_state = 566},
  [2386] = {.lex_state = 566},
  [2387] = {.lex_state = 566},
  [2388] = {.lex_state = 566},
  [2389] = {.lex_state = 566},
  [2390] = {.lex_state = 566},
  [2391] = {.lex_state = 566},
  [2392] = {.lex_state = 566},
  [2393] = {.lex_state = 566},
  [2394] = {.lex_state = 566},
  [2395] = {.lex_state = 566},
  [2396] = {.lex_state = 566},
  [2397] = {.lex_state = 566},
  [2398] = {.lex_state = 566},
  [2399] = {.lex_state = 566},
  [2400] = {.lex_state = 566},
  [2401] = {.lex_state = 566},
  [2402] = {.lex_state = 566},
  [2403] = {.lex_state = 566},
  [2404] = {.lex_state = 566},
  [2405] = {.lex_state = 566},
  [2406] = {.lex_state = 566},
  [2407] = {.lex_state = 566},
  [2408] = {.lex_state = 566},
  [2409] = {.lex_state = 566},
  [2410] = {.lex_state = 566},
  [2411] = {.lex_state = 566},
  [2412] = {.lex_state = 566},
  [2413] = {.lex_state = 566},
  [2414] = {.lex_state = 566},
  [2415] = {.lex_state = 566},
  [2416] = {.lex_state = 566},
  [2417] = {.lex_state = 566},
  [2418] = {.lex_state = 566},
  [2419] = {.lex_state = 566},
  [2420] = {.lex_state = 566},
  [2421] = {.lex_state = 566},
  [2422] = {.lex_state = 566},
  [2423] = {.lex_state = 566},
  [2424] = {.lex_state = 566},
  [2425] = {.lex_state = 566},
  [2426] = {.lex_state = 566},
  [2427] = {.lex_state = 566},
  [2428] = {.lex_state = 566},
  [2429] = {.lex_state = 566},
  [2430] = {.lex_state = 566},
  [2431] = {.lex_state = 566},
  [2432] = {.lex_state = 566},
  [2433] = {.lex_state = 566},
  [2434] = {.lex_state = 566},
  [2435] = {.lex_state = 566},
  [2436] = {.lex_state = 566},
  [2437] = {.lex_state = 566},
  [2438] = {.lex_state = 566},
  [2439] = {.lex_state = 566},
  [2440] = {.lex_state = 566},
  [2441] = {.lex_state = 566},
  [2442] = {.lex_state = 566},
  [2443] = {.lex_state = 566},
  [2444] = {.lex_state = 566},
  [2445] = {.lex_state = 566},
  [2446] = {.lex_state = 566},
  [2447] = {.lex_state = 566},
  [2448] = {.lex_state = 566},
  [2449] = {.lex_state = 566},
  [2450] = {.lex_state = 566},
  [2451] = {.lex_state = 566},
  [2452] = {.lex_state = 566},
  [2453] = {.lex_state = 566},
  [2454] = {.lex_state = 566},
  [2455] = {.lex_state = 566},
  [2456] = {.lex_state = 566},
  [2457] = {.lex_state = 566},
  [2458] = {.lex_state = 566},
  [2459] = {.lex_state = 566},
  [2460] = {.lex_state = 566},
  [2461] = {.lex_state = 566},
  [2462] = {.lex_state = 566},
  [2463] = {.lex_state = 566},
  [2464] = {.lex_state = 566},
  [2465] = {.lex_state = 566},
  [2466] = {.lex_state = 566},
  [2467] = {.lex_state = 566},
  [2468] = {.lex_state = 566},
  [2469] = {.lex_state = 566},
  [2470] = {.lex_state = 566},
  [2471] = {.lex_state = 566},
  [2472] = {.lex_state = 566},
  [2473] = {.lex_state = 566},
  [2474] = {.lex_state = 566},
  [2475] = {.lex_state = 566},
  [2476] = {.lex_state = 566},
  [2477] = {.lex_state = 566},
  [2478] = {.lex_state = 566},
  [2479] = {.lex_state = 566},
  [2480] = {.lex_state = 566},
  [2481] = {.lex_state = 566},
  [2482] = {.lex_state = 566},
  [2483] = {.lex_state = 566},
  [2484] = {.lex_state = 566},
  [2485] = {.lex_state = 566},
  [2486] = {.lex_state = 566},
  [2487] = {.lex_state = 566},
  [2488] = {.lex_state = 566},
  [2489] = {.lex_state = 566},
  [2490] = {.lex_state = 566},
  [2491] = {.lex_state = 566},
  [2492] = {.lex_state = 566},
  [2493] = {.lex_state = 566},
  [2494] = {.lex_state = 566},
  [2495] = {.lex_state = 566},
  [2496] = {.lex_state = 566},
  [2497] = {.lex_state = 566},
  [2498] = {.lex_state = 566},
  [2499] = {.lex_state = 566},
  [2500] = {.lex_state = 566},
  [2501] = {.lex_state = 566},
  [2502] = {.lex_state = 566},
  [2503] = {.lex_state = 566},
  [2504] = {.lex_state = 566},
  [2505] = {.lex_state = 566},
  [2506] = {.lex_state = 566},
  [2507] = {.lex_state = 566},
  [2508] = {.lex_state = 566},
  [2509] = {.lex_state = 566},
  [2510] = {.lex_state = 566},
  [2511] = {.lex_state = 566},
  [2512] = {.lex_state = 566},
  [2513] = {.lex_state = 566},
  [2514] = {.lex_state = 566},
  [2515] = {.lex_state = 566},
  [2516] = {.lex_state = 566},
  [2517] = {.lex_state = 566},
  [2518] = {.lex_state = 566},
  [2519] = {.lex_state = 566},
  [2520] = {.lex_state = 566},
  [2521] = {.lex_state = 566},
  [2522] = {.lex_state = 566},
  [2523] = {.lex_state = 566},
  [2524] = {.lex_state = 566},
  [2525] = {.lex_state = 566},
  [2526] = {.lex_state = 566},
  [2527] = {.lex_state = 566},
  [2528] = {.lex_state = 566},
  [2529] = {.lex_state = 566},
  [2530] = {.lex_state = 566},
  [2531] = {.lex_state = 566},
  [2532] = {.lex_state = 566},
  [2533] = {.lex_state = 566},
  [2534] = {.lex_state = 566},
  [2535] = {.lex_state = 566},
  [2536] = {.lex_state = 566},
  [2537] = {.lex_state = 566},
  [2538] = {.lex_state = 566},
  [2539] = {.lex_state = 566},
  [2540] = {.lex_state = 566},
  [2541] = {.lex_state = 566},
  [2542] = {.lex_state = 566},
  [2543] = {.lex_state = 566},
  [2544] = {.lex_state = 566},
  [2545] = {.lex_state = 566},
  [2546] = {.lex_state = 566},
  [2547] = {.lex_state = 566},
  [2548] = {.lex_state = 566},
  [2549] = {.lex_state = 566},
  [2550] = {.lex_state = 566},
  [2551] = {.lex_state = 566},
  [2552] = {.lex_state = 566},
  [2553] = {.lex_state = 566},
  [2554] = {.lex_state = 566},
  [2555] = {.lex_state = 566},
  [2556] = {.lex_state = 566},
  [2557] = {.lex_state = 566},
  [2558] = {.lex_state = 566},
  [2559] = {.lex_state = 566},
  [2560] = {.lex_state = 566},
  [2561] = {.lex_state = 566},
  [2562] = {.lex_state = 566},
  [2563] = {.lex_state = 566},
  [2564] = {.lex_state = 566},
  [2565] = {.lex_state = 566},
  [2566] = {.lex_state = 566},
  [2567] = {.lex_state = 566},
  [2568] = {.lex_state = 566},
  [2569] = {.lex_state = 566},
  [2570] = {.lex_state = 566},
  [2571] = {.lex_state = 566},
  [2572] = {.lex_state = 566},
  [2573] = {.lex_state = 566},
  [2574] = {.lex_state = 566},
  [2575] = {.lex_state = 566},
  [2576] = {.lex_state = 566},
  [2577] = {.lex_state = 566},
  [2578] = {.lex_state = 566},
  [2579] = {.lex_state = 566},
  [2580] = {.lex_state = 566},
  [2581] = {.lex_state = 566},
  [2582] = {.lex_state = 566},
  [2583] = {.lex_state = 566},
  [2584] = {.lex_state = 566},
  [2585] = {.lex_state = 566},
  [2586] = {.lex_state = 566},
  [2587] = {.lex_state = 566},
  [2588] = {.lex_state = 566},
  [2589] = {.lex_state = 566},
  [2590] = {.lex_state = 566},
  [2591] = {.lex_state = 566},
  [2592] = {.lex_state = 566},
  [2593] = {.lex_state = 566},
  [2594] = {.lex_state = 566},
  [2595] = {.lex_state = 566},
  [2596] = {.lex_state = 566},
  [2597] = {.lex_state = 566},
  [2598] = {.lex_state = 566},
  [2599] = {.lex_state = 566},
  [2600] = {.lex_state = 566},
  [2601] = {.lex_state = 566},
  [2602] = {.lex_state = 566},
  [2603] = {.lex_state = 566},
  [2604] = {.lex_state = 566},
  [2605] = {.lex_state = 566},
  [2606] = {.lex_state = 566},
  [2607] = {.lex_state = 566},
  [2608] = {.lex_state = 566},
  [2609] = {.lex_state = 566},
  [2610] = {.lex_state = 566},
  [2611] = {.lex_state = 566},
  [2612] = {.lex_state = 566},
  [2613] = {.lex_state = 566},
  [2614] = {.lex_state = 566},
  [2615] = {.lex_state = 566},
  [2616] = {.lex_state = 566},
  [2617] = {.lex_state = 566},
  [2618] = {.lex_state = 566},
  [2619] = {.lex_state = 566},
  [2620] = {.lex_state = 566},
  [2621] = {.lex_state = 566},
  [2622] = {.lex_state = 566},
  [2623] = {.lex_state = 566},
  [2624] = {.lex_state = 566},
  [2625] = {.lex_state = 566},
  [2626] = {.lex_state = 566},
  [2627] = {.lex_state = 566},
  [2628] = {.lex_state = 566},
  [2629] = {.lex_state = 566},
  [2630] = {.lex_state = 566},
  [2631] = {.lex_state = 566},
  [2632] = {.lex_state = 566},
  [2633] = {.lex_state = 566},
  [2634] = {.lex_state = 566},
  [2635] = {.lex_state = 566},
  [2636] = {.lex_state = 566},
  [2637] = {.lex_state = 566},
  [2638] = {.lex_state = 566},
  [2639] = {.lex_state = 566},
  [2640] = {.lex_state = 566},
  [2641] = {.lex_state = 566},
  [2642] = {.lex_state = 566},
  [2643] = {.lex_state = 566},
  [2644] = {.lex_state = 566},
  [2645] = {.lex_state = 566},
  [2646] = {.lex_state = 566},
  [2647] = {.lex_state = 566},
  [2648] = {.lex_state = 566},
  [2649] = {.lex_state = 566},
  [2650] = {.lex_state = 566},
  [2651] = {.lex_state = 566},
  [2652] = {.lex_state = 566},
  [2653] = {.lex_state = 566},
  [2654] = {.lex_state = 566},
  [2655] = {.lex_state = 566},
  [2656] = {.lex_state = 566},
  [2657] = {.lex_state = 566},
  [2658] = {.lex_state = 566},
  [2659] = {.lex_state = 566},
  [2660] = {.lex_state = 566},
  [2661] = {.lex_state = 566},
  [2662] = {.lex_state = 566},
  [2663] = {.lex_state = 566},
  [2664] = {.lex_state = 566},
  [2665] = {.lex_state = 566},
  [2666] = {.lex_state = 566},
  [2667] = {.lex_state = 566},
  [2668] = {.lex_state = 566},
  [2669] = {.lex_state = 566},
  [2670] = {.lex_state = 566},
  [2671] = {.lex_state = 566},
  [2672] = {.lex_state = 566},
  [2673] = {.lex_state = 566},
  [2674] = {.lex_state = 566},
  [2675] = {.lex_state = 566},
  [2676] = {.lex_state = 566},
  [2677] = {.lex_state = 566},
  [2678] = {.lex_state = 566},
  [2679] = {.lex_state = 566},
  [2680] = {.lex_state = 566},
  [2681] = {.lex_state = 566},
  [2682] = {.lex_state = 566},
  [2683] = {.lex_state = 566},
  [2684] = {.lex_state = 566},
  [2685] = {.lex_state = 566},
  [2686] = {.lex_state = 566},
  [2687] = {.lex_state = 566},
  [2688] = {.lex_state = 566},
  [2689] = {.lex_state = 566},
  [2690] = {.lex_state = 566},
  [2691] = {.lex_state = 566},
  [2692] = {.lex_state = 566},
  [2693] = {.lex_state = 566},
  [2694] = {.lex_state = 566},
  [2695] = {.lex_state = 566},
  [2696] = {.lex_state = 566},
  [2697] = {.lex_state = 566},
  [2698] = {.lex_state = 566},
  [2699] = {.lex_state = 566},
  [2700] = {.lex_state = 566},
  [2701] = {.lex_state = 566},
  [2702] = {.lex_state = 566},
  [2703] = {.lex_state = 566},
  [2704] = {.lex_state = 566},
  [2705] = {.lex_state = 566},
  [2706] = {.lex_state = 566},
  [2707] = {.lex_state = 566},
  [2708] = {.lex_state = 566},
  [2709] = {.lex_state = 566},
  [2710] = {.lex_state = 566},
  [2711] = {.lex_state = 566},
  [2712] = {.lex_state = 566},
  [2713] = {.lex_state = 566},
  [2714] = {.lex_state = 566},
  [2715] = {.lex_state = 566},
  [2716] = {.lex_state = 566},
  [2717] = {.lex_state = 566},
  [2718] = {.lex_state = 566},
  [2719] = {.lex_state = 566},
  [2720] = {.lex_state = 566},
  [2721] = {.lex_state = 566},
  [2722] = {.lex_state = 566},
  [2723] = {.lex_state = 566},
  [2724] = {.lex_state = 566},
  [2725] = {.lex_state = 566},
  [2726] = {.lex_state = 566},
  [2727] = {.lex_state = 566},
  [2728] = {.lex_state = 566},
  [2729] = {.lex_state = 566},
  [2730] = {.lex_state = 566},
  [2731] = {.lex_state = 566},
  [2732] = {.lex_state = 566},
  [2733] = {.lex_state = 566},
  [2734] = {.lex_state = 566},
  [2735] = {.lex_state = 566},
  [2736] = {.lex_state = 566},
  [2737] = {.lex_state = 566},
  [2738] = {.lex_state = 566},
  [2739] = {.lex_state = 566},
  [2740] = {.lex_state = 566},
  [2741] = {.lex_state = 566},
  [2742] = {.lex_state = 566},
  [2743] = {.lex_state = 566},
  [2744] = {.lex_state = 566},
  [2745] = {.lex_state = 566},
  [2746] = {.lex_state = 566},
  [2747] = {.lex_state = 566},
  [2748] = {.lex_state = 566},
  [2749] = {.lex_state = 566},
  [2750] = {.lex_state = 566},
  [2751] = {.lex_state = 566},
  [2752] = {.lex_state = 566},
  [2753] = {.lex_state = 566},
  [2754] = {.lex_state = 566},
  [2755] = {.lex_state = 566},
  [2756] = {.lex_state = 566},
  [2757] = {.lex_state = 566},
  [2758] = {.lex_state = 566},
  [2759] = {.lex_state = 566},
  [2760] = {.lex_state = 566},
  [2761] = {.lex_state = 566},
  [2762] = {.lex_state = 566},
  [2763] = {.lex_state = 566},
  [2764] = {.lex_state = 566},
  [2765] = {.lex_state = 566},
  [2766] = {.lex_state = 566},
  [2767] = {.lex_state = 566},
  [2768] = {.lex_state = 566},
  [2769] = {.lex_state = 566},
  [2770] = {.lex_state = 566},
  [2771] = {.lex_state = 566},
  [2772] = {.lex_state = 566},
  [2773] = {.lex_state = 566},
  [2774] = {.lex_state = 566},
  [2775] = {.lex_state = 566},
  [2776] = {.lex_state = 566},
  [2777] = {.lex_state = 566},
  [2778] = {.lex_state = 566},
  [2779] = {.lex_state = 566},
  [2780] = {.lex_state = 566},
  [2781] = {.lex_state = 566},
  [2782] = {.lex_state = 566},
  [2783] = {.lex_state = 566},
  [2784] = {.lex_state = 566},
  [2785] = {.lex_state = 566},
  [2786] = {.lex_state = 566},
  [2787] = {.lex_state = 566},
  [2788] = {.lex_state = 566},
  [2789] = {.lex_state = 566},
  [2790] = {.lex_state = 566},
  [2791] = {.lex_state = 566},
  [2792] = {.lex_state = 566},
  [2793] = {.lex_state = 566},
  [2794] = {.lex_state = 566},
  [2795] = {.lex_state = 566},
  [2796] = {.lex_state = 566},
  [2797] = {.lex_state = 566},
  [2798] = {.lex_state = 566},
  [2799] = {.lex_state = 566},
  [2800] = {.lex_state = 566},
  [2801] = {.lex_state = 566},
  [2802] = {.lex_state = 566},
  [2803] = {.lex_state = 566},
  [2804] = {.lex_state = 566},
  [2805] = {.lex_state = 566},
  [2806] = {.lex_state = 566},
  [2807] = {.lex_state = 566},
  [2808] = {.lex_state = 566},
  [2809] = {.lex_state = 566},
  [2810] = {.lex_state = 566},
  [2811] = {.lex_state = 566},
  [2812] = {.lex_state = 566},
  [2813] = {.lex_state = 566},
  [2814] = {.lex_state = 566},
  [2815] = {.lex_state = 566},
  [2816] = {.lex_state = 566},
  [2817] = {.lex_state = 566},
  [2818] = {.lex_state = 566},
  [2819] = {.lex_state = 566},
  [2820] = {.lex_state = 566},
  [2821] = {.lex_state = 566},
  [2822] = {.lex_state = 566},
  [2823] = {.lex_state = 566},
  [2824] = {.lex_state = 566},
  [2825] = {.lex_state = 566},
  [2826] = {.lex_state = 566},
  [2827] = {.lex_state = 566},
  [2828] = {.lex_state = 566},
  [2829] = {.lex_state = 566},
  [2830] = {.lex_state = 566},
  [2831] = {.lex_state = 566},
  [2832] = {.lex_state = 566},
  [2833] = {.lex_state = 566},
  [2834] = {.lex_state = 566},
  [2835] = {.lex_state = 566},
  [2836] = {.lex_state = 566},
  [2837] = {.lex_state = 566},
  [2838] = {.lex_state = 566},
  [2839] = {.lex_state = 566},
  [2840] = {.lex_state = 566},
  [2841] = {.lex_state = 566},
  [2842] = {.lex_state = 566},
  [2843] = {.lex_state = 566},
  [2844] = {.lex_state = 566},
  [2845] = {.lex_state = 566},
  [2846] = {.lex_state = 566},
  [2847] = {.lex_state = 566},
  [2848] = {.lex_state = 566},
  [2849] = {.lex_state = 566},
  [2850] = {.lex_state = 566},
  [2851] = {.lex_state = 566},
  [2852] = {.lex_state = 566},
  [2853] = {.lex_state = 566},
  [2854] = {.lex_state = 566},
  [2855] = {.lex_state = 566},
  [2856] = {.lex_state = 566},
  [2857] = {.lex_state = 566},
  [2858] = {.lex_state = 566},
  [2859] = {.lex_state = 566},
  [2860] = {.lex_state = 566},
  [2861] = {.lex_state = 566},
  [2862] = {.lex_state = 566},
  [2863] = {.lex_state = 566},
  [2864] = {.lex_state = 566},
  [2865] = {.lex_state = 566},
  [2866] = {.lex_state = 566},
  [2867] = {.lex_state = 566},
  [2868] = {.lex_state = 566},
  [2869] = {.lex_state = 566},
  [2870] = {.lex_state = 566},
  [2871] = {.lex_state = 566},
  [2872] = {.lex_state = 566},
  [2873] = {.lex_state = 566},
  [2874] = {.lex_state = 566},
  [2875] = {.lex_state = 566},
  [2876] = {.lex_state = 566},
  [2877] = {.lex_state = 566},
  [2878] = {.lex_state = 566},
  [2879] = {.lex_state = 566},
  [2880] = {.lex_state = 566},
  [2881] = {.lex_state = 566},
  [2882] = {.lex_state = 566},
  [2883] = {.lex_state = 566},
  [2884] = {.lex_state = 566},
  [2885] = {.lex_state = 566},
  [2886] = {.lex_state = 566},
  [2887] = {.lex_state = 566},
  [2888] = {.lex_state = 566},
  [2889] = {.lex_state = 566},
  [2890] = {.lex_state = 566},
  [2891] = {.lex_state = 566},
  [2892] = {.lex_state = 566},
  [2893] = {.lex_state = 566},
  [2894] = {.lex_state = 566},
  [2895] = {.lex_state = 566},
  [2896] = {.lex_state = 566},
  [2897] = {.lex_state = 566},
  [2898] = {.lex_state = 566},
  [2899] = {.lex_state = 566},
  [2900] = {.lex_state = 566},
  [2901] = {.lex_state = 566},
  [2902] = {.lex_state = 566},
  [2903] = {.lex_state = 566},
  [2904] = {.lex_state = 566},
  [2905] = {.lex_state = 566},
  [2906] = {.lex_state = 566},
  [2907] = {.lex_state = 566},
  [2908] = {.lex_state = 566},
  [2909] = {.lex_state = 566},
  [2910] = {.lex_state = 566},
  [2911] = {.lex_state = 566},
  [2912] = {.lex_state = 566},
  [2913] = {.lex_state = 566},
  [2914] = {.lex_state = 566},
  [2915] = {.lex_state = 566},
  [2916] = {.lex_state = 566},
  [2917] = {.lex_state = 566},
  [2918] = {.lex_state = 566},
  [2919] = {.lex_state = 566},
  [2920] = {.lex_state = 566},
  [2921] = {.lex_state = 566},
  [2922] = {.lex_state = 566},
  [2923] = {.lex_state = 566},
  [2924] = {.lex_state = 566},
  [2925] = {.lex_state = 566},
  [2926] = {.lex_state = 566},
  [2927] = {.lex_state = 566},
  [2928] = {.lex_state = 566},
  [2929] = {.lex_state = 566},
  [2930] = {.lex_state = 566},
  [2931] = {.lex_state = 566},
  [2932] = {.lex_state = 566},
  [2933] = {.lex_state = 566},
  [2934] = {.lex_state = 566},
  [2935] = {.lex_state = 566},
  [2936] = {.lex_state = 566},
  [2937] = {.lex_state = 566},
  [2938] = {.lex_state = 566},
  [2939] = {.lex_state = 566},
  [2940] = {.lex_state = 566},
  [2941] = {.lex_state = 566},
  [2942] = {.lex_state = 566},
  [2943] = {.lex_state = 566},
  [2944] = {.lex_state = 566},
  [2945] = {.lex_state = 566},
  [2946] = {.lex_state = 566},
  [2947] = {.lex_state = 566},
  [2948] = {.lex_state = 566},
  [2949] = {.lex_state = 566},
  [2950] = {.lex_state = 566},
  [2951] = {.lex_state = 566},
  [2952] = {.lex_state = 566},
  [2953] = {.lex_state = 566},
  [2954] = {.lex_state = 566},
  [2955] = {.lex_state = 566},
  [2956] = {.lex_state = 566},
  [2957] = {.lex_state = 566},
  [2958] = {.lex_state = 566},
  [2959] = {.lex_state = 566},
  [2960] = {.lex_state = 566},
  [2961] = {.lex_state = 566},
  [2962] = {.lex_state = 566},
  [2963] = {.lex_state = 566},
  [2964] = {.lex_state = 566},
  [2965] = {.lex_state = 566},
  [2966] = {.lex_state = 566},
  [2967] = {.lex_state = 566},
  [2968] = {.lex_state = 566},
  [2969] = {.lex_state = 566},
  [2970] = {.lex_state = 566},
  [2971] = {.lex_state = 566},
  [2972] = {.lex_state = 566},
  [2973] = {.lex_state = 566},
  [2974] = {.lex_state = 566},
  [2975] = {.lex_state = 566},
  [2976] = {.lex_state = 566},
  [2977] = {.lex_state = 566},
  [2978] = {.lex_state = 566},
  [2979] = {.lex_state = 566},
  [2980] = {.lex_state = 566},
  [2981] = {.lex_state = 566},
  [2982] = {.lex_state = 566},
  [2983] = {.lex_state = 566},
  [2984] = {.lex_state = 566},
  [2985] = {.lex_state = 566},
  [2986] = {.lex_state = 566},
  [2987] = {.lex_state = 566},
  [2988] = {.lex_state = 566},
  [2989] = {.lex_state = 566},
  [2990] = {.lex_state = 566},
  [2991] = {.lex_state = 566},
  [2992] = {.lex_state = 566},
  [2993] = {.lex_state = 566},
  [2994] = {.lex_state = 566},
  [2995] = {.lex_state = 566},
  [2996] = {.lex_state = 566},
  [2997] = {.lex_state = 566},
  [2998] = {.lex_state = 566},
  [2999] = {.lex_state = 566},
  [3000] = {.lex_state = 566},
  [3001] = {.lex_state = 566},
  [3002] = {.lex_state = 566},
  [3003] = {.lex_state = 566},
  [3004] = {.lex_state = 566},
  [3005] = {.lex_state = 566},
  [3006] = {.lex_state = 566},
  [3007] = {.lex_state = 566},
  [3008] = {.lex_state = 566},
  [3009] = {.lex_state = 566},
  [3010] = {.lex_state = 566},
  [3011] = {.lex_state = 566},
  [3012] = {.lex_state = 566},
  [3013] = {.lex_state = 566},
  [3014] = {.lex_state = 566},
  [3015] = {.lex_state = 566},
  [3016] = {.lex_state = 566},
  [3017] = {.lex_state = 566},
  [3018] = {.lex_state = 566},
  [3019] = {.lex_state = 566},
  [3020] = {.lex_state = 566},
  [3021] = {.lex_state = 566},
  [3022] = {.lex_state = 566},
  [3023] = {.lex_state = 566},
  [3024] = {.lex_state = 566},
  [3025] = {.lex_state = 566},
  [3026] = {.lex_state = 566},
  [3027] = {.lex_state = 566},
  [3028] = {.lex_state = 566},
  [3029] = {.lex_state = 566},
  [3030] = {.lex_state = 566},
  [3031] = {.lex_state = 566},
  [3032] = {.lex_state = 566},
  [3033] = {.lex_state = 566},
  [3034] = {.lex_state = 566},
  [3035] = {.lex_state = 566},
  [3036] = {.lex_state = 566},
  [3037] = {.lex_state = 566},
  [3038] = {.lex_state = 566},
  [3039] = {.lex_state = 566},
  [3040] = {.lex_state = 566},
  [3041] = {.lex_state = 566},
  [3042] = {.lex_state = 566},
  [3043] = {.lex_state = 566},
  [3044] = {.lex_state = 566},
  [3045] = {.lex_state = 566},
  [3046] = {.lex_state = 566},
  [3047] = {.lex_state = 566},
  [3048] = {.lex_state = 566},
  [3049] = {.lex_state = 566},
  [3050] = {.lex_state = 566},
  [3051] = {.lex_state = 566},
  [3052] = {.lex_state = 566},
  [3053] = {.lex_state = 566},
  [3054] = {.lex_state = 566},
  [3055] = {.lex_state = 566},
  [3056] = {.lex_state = 566},
  [3057] = {.lex_state = 566},
  [3058] = {.lex_state = 566},
  [3059] = {.lex_state = 566},
  [3060] = {.lex_state = 566},
  [3061] = {.lex_state = 566},
  [3062] = {.lex_state = 566},
  [3063] = {.lex_state = 566},
  [3064] = {.lex_state = 566},
  [3065] = {.lex_state = 566},
  [3066] = {.lex_state = 566},
  [3067] = {.lex_state = 566},
  [3068] = {.lex_state = 566},
  [3069] = {.lex_state = 566},
  [3070] = {.lex_state = 566},
  [3071] = {.lex_state = 566},
  [3072] = {.lex_state = 566},
  [3073] = {.lex_state = 566},
  [3074] = {.lex_state = 566},
  [3075] = {.lex_state = 566},
  [3076] = {.lex_state = 566},
  [3077] = {.lex_state = 566},
  [3078] = {.lex_state = 566},
  [3079] = {.lex_state = 566},
  [3080] = {.lex_state = 566},
  [3081] = {.lex_state = 566},
  [3082] = {.lex_state = 566},
  [3083] = {.lex_state = 566},
  [3084] = {.lex_state = 566},
  [3085] = {.lex_state = 566},
  [3086] = {.lex_state = 566},
  [3087] = {.lex_state = 566},
  [3088] = {.lex_state = 566},
  [3089] = {.lex_state = 566},
  [3090] = {.lex_state = 566},
  [3091] = {.lex_state = 566},
  [3092] = {.lex_state = 566},
  [3093] = {.lex_state = 566},
  [3094] = {.lex_state = 566},
  [3095] = {.lex_state = 566},
  [3096] = {.lex_state = 566},
  [3097] = {.lex_state = 566},
  [3098] = {.lex_state = 566},
  [3099] = {.lex_state = 566},
  [3100] = {.lex_state = 566},
  [3101] = {.lex_state = 566},
  [3102] = {.lex_state = 566},
  [3103] = {.lex_state = 566},
  [3104] = {.lex_state = 566},
  [3105] = {.lex_state = 566},
  [3106] = {.lex_state = 566},
  [3107] = {.lex_state = 566},
  [3108] = {.lex_state = 566},
  [3109] = {.lex_state = 566},
  [3110] = {.lex_state = 566},
  [3111] = {.lex_state = 566},
  [3112] = {.lex_state = 566},
  [3113] = {.lex_state = 566},
  [3114] = {.lex_state = 566},
  [3115] = {.lex_state = 566},
  [3116] = {.lex_state = 566},
  [3117] = {.lex_state = 566},
  [3118] = {.lex_state = 566},
  [3119] = {.lex_state = 566},
  [3120] = {.lex_state = 566},
  [3121] = {.lex_state = 566},
  [3122] = {.lex_state = 566},
  [3123] = {.lex_state = 566},
  [3124] = {.lex_state = 566},
  [3125] = {.lex_state = 566},
  [3126] = {.lex_state = 566},
  [3127] = {.lex_state = 566},
  [3128] = {.lex_state = 566},
  [3129] = {.lex_state = 566},
  [3130] = {.lex_state = 566},
  [3131] = {.lex_state = 566},
  [3132] = {.lex_state = 566},
  [3133] = {.lex_state = 566},
  [3134] = {.lex_state = 566},
  [3135] = {.lex_state = 566},
  [3136] = {.lex_state = 566},
  [3137] = {.lex_state = 566},
  [3138] = {.lex_state = 566},
  [3139] = {.lex_state = 566},
  [3140] = {.lex_state = 566},
  [3141] = {.lex_state = 566},
  [3142] = {.lex_state = 566},
  [3143] = {.lex_state = 566},
  [3144] = {.lex_state = 566},
  [3145] = {.lex_state = 566},
  [3146] = {.lex_state = 566},
  [3147] = {.lex_state = 566},
  [3148] = {.lex_state = 566},
  [3149] = {.lex_state = 566},
  [3150] = {.lex_state = 566},
  [3151] = {.lex_state = 566},
  [3152] = {.lex_state = 566},
  [3153] = {.lex_state = 566},
  [3154] = {.lex_state = 566},
  [3155] = {.lex_state = 566},
  [3156] = {.lex_state = 566},
  [3157] = {.lex_state = 566},
  [3158] = {.lex_state = 566},
  [3159] = {.lex_state = 566},
  [3160] = {.lex_state = 566},
  [3161] = {.lex_state = 566},
  [3162] = {.lex_state = 566},
  [3163] = {.lex_state = 566},
  [3164] = {.lex_state = 566},
  [3165] = {.lex_state = 566},
  [3166] = {.lex_state = 566},
  [3167] = {.lex_state = 566},
  [3168] = {.lex_state = 566},
  [3169] = {.lex_state = 566},
  [3170] = {.lex_state = 566},
  [3171] = {.lex_state = 566},
  [3172] = {.lex_state = 566},
  [3173] = {.lex_state = 566},
  [3174] = {.lex_state = 566},
  [3175] = {.lex_state = 566},
  [3176] = {.lex_state = 566},
  [3177] = {.lex_state = 566},
  [3178] = {.lex_state = 566},
  [3179] = {.lex_state = 566},
  [3180] = {.lex_state = 566},
  [3181] = {.lex_state = 566},
  [3182] = {.lex_state = 566},
  [3183] = {.lex_state = 566},
  [3184] = {.lex_state = 566},
  [3185] = {.lex_state = 566},
  [3186] = {.lex_state = 566},
  [3187] = {.lex_state = 566},
  [3188] = {.lex_state = 566},
  [3189] = {.lex_state = 566},
  [3190] = {.lex_state = 566},
  [3191] = {.lex_state = 566},
  [3192] = {.lex_state = 566},
  [3193] = {.lex_state = 566},
  [3194] = {.lex_state = 566},
  [3195] = {.lex_state = 566},
  [3196] = {.lex_state = 566},
  [3197] = {.lex_state = 566},
  [3198] = {.lex_state = 566},
  [3199] = {.lex_state = 566},
  [3200] = {.lex_state = 566},
  [3201] = {.lex_state = 566},
  [3202] = {.lex_state = 566},
  [3203] = {.lex_state = 566},
  [3204] = {.lex_state = 566},
  [3205] = {.lex_state = 566},
  [3206] = {.lex_state = 566},
  [3207] = {.lex_state = 566},
  [3208] = {.lex_state = 566},
  [3209] = {.lex_state = 566},
  [3210] = {.lex_state = 566},
  [3211] = {.lex_state = 566},
  [3212] = {.lex_state = 566},
  [3213] = {.lex_state = 566},
  [3214] = {.lex_state = 566},
  [3215] = {.lex_state = 566},
  [3216] = {.lex_state = 566},
  [3217] = {.lex_state = 566},
  [3218] = {.lex_state = 566},
  [3219] = {.lex_state = 566},
  [3220] = {.lex_state = 566},
  [3221] = {.lex_state = 566},
  [3222] = {.lex_state = 566},
  [3223] = {.lex_state = 566},
  [3224] = {.lex_state = 566},
  [3225] = {.lex_state = 566},
  [3226] = {.lex_state = 566},
  [3227] = {.lex_state = 566},
  [3228] = {.lex_state = 566},
  [3229] = {.lex_state = 566},
  [3230] = {.lex_state = 566},
  [3231] = {.lex_state = 566},
  [3232] = {.lex_state = 566},
  [3233] = {.lex_state = 566},
  [3234] = {.lex_state = 566},
  [3235] = {.lex_state = 566},
  [3236] = {.lex_state = 566},
  [3237] = {.lex_state = 566},
  [3238] = {.lex_state = 566},
  [3239] = {.lex_state = 566},
  [3240] = {.lex_state = 566},
  [3241] = {.lex_state = 566},
  [3242] = {.lex_state = 566},
  [3243] = {.lex_state = 566},
  [3244] = {.lex_state = 566},
  [3245] = {.lex_state = 566},
  [3246] = {.lex_state = 566},
  [3247] = {.lex_state = 566},
  [3248] = {.lex_state = 566},
  [3249] = {.lex_state = 566},
  [3250] = {.lex_state = 566},
  [3251] = {.lex_state = 566},
  [3252] = {.lex_state = 566},
  [3253] = {.lex_state = 566},
  [3254] = {.lex_state = 566},
  [3255] = {.lex_state = 566},
  [3256] = {.lex_state = 566},
  [3257] = {.lex_state = 566},
  [3258] = {.lex_state = 566},
  [3259] = {.lex_state = 566},
  [3260] = {.lex_state = 566},
  [3261] = {.lex_state = 566},
  [3262] = {.lex_state = 566},
  [3263] = {.lex_state = 566},
  [3264] = {.lex_state = 566},
  [3265] = {.lex_state = 566},
  [3266] = {.lex_state = 566},
  [3267] = {.lex_state = 566},
  [3268] = {.lex_state = 566},
  [3269] = {.lex_state = 566},
  [3270] = {.lex_state = 566},
  [3271] = {.lex_state = 566},
  [3272] = {.lex_state = 566},
  [3273] = {.lex_state = 566},
  [3274] = {.lex_state = 566},
  [3275] = {.lex_state = 566},
  [3276] = {.lex_state = 566},
  [3277] = {.lex_state = 566},
  [3278] = {.lex_state = 566},
  [3279] = {.lex_state = 566},
  [3280] = {.lex_state = 566},
  [3281] = {.lex_state = 566},
  [3282] = {.lex_state = 566},
  [3283] = {.lex_state = 566},
  [3284] = {.lex_state = 566},
  [3285] = {.lex_state = 566},
  [3286] = {.lex_state = 566},
  [3287] = {.lex_state = 566},
  [3288] = {.lex_state = 566},
  [3289] = {.lex_state = 566},
  [3290] = {.lex_state = 566},
  [3291] = {.lex_state = 566},
  [3292] = {.lex_state = 566},
  [3293] = {.lex_state = 566},
  [3294] = {.lex_state = 566},
  [3295] = {.lex_state = 566},
  [3296] = {.lex_state = 566},
  [3297] = {.lex_state = 566},
  [3298] = {.lex_state = 566},
  [3299] = {.lex_state = 566},
  [3300] = {.lex_state = 566},
  [3301] = {.lex_state = 566},
  [3302] = {.lex_state = 566},
  [3303] = {.lex_state = 566},
  [3304] = {.lex_state = 566},
  [3305] = {.lex_state = 566},
  [3306] = {.lex_state = 566},
  [3307] = {.lex_state = 566},
  [3308] = {.lex_state = 566},
  [3309] = {.lex_state = 566},
  [3310] = {.lex_state = 566},
  [3311] = {.lex_state = 566},
  [3312] = {.lex_state = 566},
  [3313] = {.lex_state = 566},
  [3314] = {.lex_state = 566},
  [3315] = {.lex_state = 566},
  [3316] = {.lex_state = 566},
  [3317] = {.lex_state = 566},
  [3318] = {.lex_state = 566},
  [3319] = {.lex_state = 566},
  [3320] = {.lex_state = 566},
  [3321] = {.lex_state = 566},
  [3322] = {.lex_state = 566},
  [3323] = {.lex_state = 566},
  [3324] = {.lex_state = 566},
  [3325] = {.lex_state = 566},
  [3326] = {.lex_state = 566},
  [3327] = {.lex_state = 566},
  [3328] = {.lex_state = 566},
  [3329] = {.lex_state = 566},
  [3330] = {.lex_state = 566},
  [3331] = {.lex_state = 566},
  [3332] = {.lex_state = 566},
  [3333] = {.lex_state = 566},
  [3334] = {.lex_state = 566},
  [3335] = {.lex_state = 566},
  [3336] = {.lex_state = 566},
  [3337] = {.lex_state = 566},
  [3338] = {.lex_state = 566},
  [3339] = {.lex_state = 566},
  [3340] = {.lex_state = 566},
  [3341] = {.lex_state = 566},
  [3342] = {.lex_state = 566},
  [3343] = {.lex_state = 566},
  [3344] = {.lex_state = 566},
  [3345] = {.lex_state = 566},
  [3346] = {.lex_state = 566},
  [3347] = {.lex_state = 566},
  [3348] = {.lex_state = 566},
  [3349] = {.lex_state = 566},
  [3350] = {.lex_state = 566},
  [3351] = {.lex_state = 566},
  [3352] = {.lex_state = 566},
  [3353] = {.lex_state = 566},
  [3354] = {.lex_state = 566},
  [3355] = {.lex_state = 566},
  [3356] = {.lex_state = 566},
  [3357] = {.lex_state = 566},
  [3358] = {.lex_state = 566},
  [3359] = {.lex_state = 566},
  [3360] = {.lex_state = 566},
  [3361] = {.lex_state = 566},
  [3362] = {.lex_state = 566},
  [3363] = {.lex_state = 566},
  [3364] = {.lex_state = 566},
  [3365] = {.lex_state = 566},
  [3366] = {.lex_state = 566},
  [3367] = {.lex_state = 566},
  [3368] = {.lex_state = 566},
  [3369] = {.lex_state = 566},
  [3370] = {.lex_state = 566},
  [3371] = {.lex_state = 566},
  [3372] = {.lex_state = 566},
  [3373] = {.lex_state = 566},
  [3374] = {.lex_state = 566},
  [3375] = {.lex_state = 566},
  [3376] = {.lex_state = 566},
  [3377] = {.lex_state = 566},
  [3378] = {.lex_state = 566},
  [3379] = {.lex_state = 566},
  [3380] = {.lex_state = 566},
  [3381] = {.lex_state = 566},
  [3382] = {.lex_state = 566},
  [3383] = {.lex_state = 566},
  [3384] = {.lex_state = 566},
  [3385] = {.lex_state = 566},
  [3386] = {.lex_state = 566},
  [3387] = {.lex_state = 566},
  [3388] = {.lex_state = 566},
  [3389] = {.lex_state = 566},
  [3390] = {.lex_state = 566},
  [3391] = {.lex_state = 566},
  [3392] = {.lex_state = 566},
  [3393] = {.lex_state = 566},
  [3394] = {.lex_state = 566},
  [3395] = {.lex_state = 566},
  [3396] = {.lex_state = 566},
  [3397] = {.lex_state = 566},
  [3398] = {.lex_state = 566},
  [3399] = {.lex_state = 566},
  [3400] = {.lex_state = 566},
  [3401] = {.lex_state = 566},
  [3402] = {.lex_state = 566},
  [3403] = {.lex_state = 566},
  [3404] = {.lex_state = 566},
  [3405] = {.lex_state = 566},
  [3406] = {.lex_state = 566},
  [3407] = {.lex_state = 566},
  [3408] = {.lex_state = 566},
  [3409] = {.lex_state = 566},
  [3410] = {.lex_state = 566},
  [3411] = {.lex_state = 566},
  [3412] = {.lex_state = 566},
  [3413] = {.lex_state = 566},
  [3414] = {.lex_state = 566},
  [3415] = {.lex_state = 566},
  [3416] = {.lex_state = 566},
  [3417] = {.lex_state = 566},
  [3418] = {.lex_state = 566},
  [3419] = {.lex_state = 566},
  [3420] = {.lex_state = 566},
  [3421] = {.lex_state = 566},
  [3422] = {.lex_state = 566},
  [3423] = {.lex_state = 566},
  [3424] = {.lex_state = 566},
  [3425] = {.lex_state = 566},
  [3426] = {.lex_state = 566},
  [3427] = {.lex_state = 566},
  [3428] = {.lex_state = 566},
  [3429] = {.lex_state = 566},
  [3430] = {.lex_state = 566},
  [3431] = {.lex_state = 566},
  [3432] = {.lex_state = 566},
  [3433] = {.lex_state = 566},
  [3434] = {.lex_state = 566},
  [3435] = {.lex_state = 566},
  [3436] = {.lex_state = 566},
  [3437] = {.lex_state = 566},
  [3438] = {.lex_state = 566},
  [3439] = {.lex_state = 566},
  [3440] = {.lex_state = 566},
  [3441] = {.lex_state = 566},
  [3442] = {.lex_state = 566},
  [3443] = {.lex_state = 566},
  [3444] = {.lex_state = 566},
  [3445] = {.lex_state = 566},
  [3446] = {.lex_state = 566},
  [3447] = {.lex_state = 566},
  [3448] = {.lex_state = 566},
  [3449] = {.lex_state = 566},
  [3450] = {.lex_state = 566},
  [3451] = {.lex_state = 566},
  [3452] = {.lex_state = 566},
  [3453] = {.lex_state = 566},
  [3454] = {.lex_state = 566},
  [3455] = {.lex_state = 566},
  [3456] = {.lex_state = 566},
  [3457] = {.lex_state = 566},
  [3458] = {.lex_state = 566},
  [3459] = {.lex_state = 566},
  [3460] = {.lex_state = 566},
  [3461] = {.lex_state = 566},
  [3462] = {.lex_state = 566},
  [3463] = {.lex_state = 566},
  [3464] = {.lex_state = 566},
  [3465] = {.lex_state = 566},
  [3466] = {.lex_state = 566},
  [3467] = {.lex_state = 566},
  [3468] = {.lex_state = 566},
  [3469] = {.lex_state = 566},
  [3470] = {.lex_state = 566},
  [3471] = {.lex_state = 566},
  [3472] = {.lex_state = 566},
  [3473] = {.lex_state = 566},
  [3474] = {.lex_state = 566},
  [3475] = {.lex_state = 566},
  [3476] = {.lex_state = 566},
  [3477] = {.lex_state = 566},
  [3478] = {.lex_state = 566},
  [3479] = {.lex_state = 566},
  [3480] = {.lex_state = 566},
  [3481] = {.lex_state = 566},
  [3482] = {.lex_state = 566},
  [3483] = {.lex_state = 566},
  [3484] = {.lex_state = 566},
  [3485] = {.lex_state = 566},
  [3486] = {.lex_state = 566},
  [3487] = {.lex_state = 566},
  [3488] = {.lex_state = 566},
  [3489] = {.lex_state = 566},
  [3490] = {.lex_state = 566},
  [3491] = {.lex_state = 566},
  [3492] = {.lex_state = 566},
  [3493] = {.lex_state = 566},
  [3494] = {.lex_state = 566},
  [3495] = {.lex_state = 566},
  [3496] = {.lex_state = 566},
  [3497] = {.lex_state = 566},
  [3498] = {.lex_state = 566},
  [3499] = {.lex_state = 566},
  [3500] = {.lex_state = 566},
  [3501] = {.lex_state = 566},
  [3502] = {.lex_state = 566},
  [3503] = {.lex_state = 566},
  [3504] = {.lex_state = 566},
  [3505] = {.lex_state = 566},
  [3506] = {.lex_state = 566},
  [3507] = {.lex_state = 566},
  [3508] = {.lex_state = 566},
  [3509] = {.lex_state = 566},
  [3510] = {.lex_state = 566},
  [3511] = {.lex_state = 566},
  [3512] = {.lex_state = 566},
  [3513] = {.lex_state = 566},
  [3514] = {.lex_state = 566},
  [3515] = {.lex_state = 566},
  [3516] = {.lex_state = 566},
  [3517] = {.lex_state = 566},
  [3518] = {.lex_state = 566},
  [3519] = {.lex_state = 566},
  [3520] = {.lex_state = 566},
  [3521] = {.lex_state = 566},
  [3522] = {.lex_state = 566},
  [3523] = {.lex_state = 566},
  [3524] = {.lex_state = 566},
  [3525] = {.lex_state = 566},
  [3526] = {.lex_state = 566},
  [3527] = {.lex_state = 566},
  [3528] = {.lex_state = 566},
  [3529] = {.lex_state = 566},
  [3530] = {.lex_state = 566},
  [3531] = {.lex_state = 566},
  [3532] = {.lex_state = 566},
  [3533] = {.lex_state = 566},
  [3534] = {.lex_state = 566},
  [3535] = {.lex_state = 566},
  [3536] = {.lex_state = 566},
  [3537] = {.lex_state = 566},
  [3538] = {.lex_state = 566},
  [3539] = {.lex_state = 566},
  [3540] = {.lex_state = 566},
  [3541] = {.lex_state = 566},
  [3542] = {.lex_state = 566},
  [3543] = {.lex_state = 566},
  [3544] = {.lex_state = 566},
  [3545] = {.lex_state = 566},
  [3546] = {.lex_state = 566},
  [3547] = {.lex_state = 566},
  [3548] = {.lex_state = 566},
  [3549] = {.lex_state = 566},
  [3550] = {.lex_state = 566},
  [3551] = {.lex_state = 566},
  [3552] = {.lex_state = 566},
  [3553] = {.lex_state = 566},
  [3554] = {.lex_state = 566},
  [3555] = {.lex_state = 566},
  [3556] = {.lex_state = 566},
  [3557] = {.lex_state = 566},
  [3558] = {.lex_state = 566},
  [3559] = {.lex_state = 566},
  [3560] = {.lex_state = 566},
  [3561] = {.lex_state = 566},
  [3562] = {.lex_state = 566},
  [3563] = {.lex_state = 566},
  [3564] = {.lex_state = 566},
  [3565] = {.lex_state = 566},
  [3566] = {.lex_state = 566},
  [3567] = {.lex_state = 566},
  [3568] = {.lex_state = 566},
  [3569] = {.lex_state = 566},
  [3570] = {.lex_state = 566},
  [3571] = {.lex_state = 566},
  [3572] = {.lex_state = 566},
  [3573] = {.lex_state = 566},
  [3574] = {.lex_state = 566},
  [3575] = {.lex_state = 566},
  [3576] = {.lex_state = 566},
  [3577] = {.lex_state = 566},
  [3578] = {.lex_state = 566},
  [3579] = {.lex_state = 566},
  [3580] = {.lex_state = 566},
  [3581] = {.lex_state = 566},
  [3582] = {.lex_state = 566},
  [3583] = {.lex_state = 566},
  [3584] = {.lex_state = 566},
  [3585] = {.lex_state = 566},
  [3586] = {.lex_state = 566},
  [3587] = {.lex_state = 566},
  [3588] = {.lex_state = 566},
  [3589] = {.lex_state = 566},
  [3590] = {.lex_state = 566},
  [3591] = {.lex_state = 566},
  [3592] = {.lex_state = 566},
  [3593] = {.lex_state = 566},
  [3594] = {.lex_state = 566},
  [3595] = {.lex_state = 566},
  [3596] = {.lex_state = 566},
  [3597] = {.lex_state = 566},
  [3598] = {.lex_state = 566},
  [3599] = {.lex_state = 566},
  [3600] = {.lex_state = 566},
  [3601] = {.lex_state = 566},
  [3602] = {.lex_state = 566},
  [3603] = {.lex_state = 566},
  [3604] = {.lex_state = 566},
  [3605] = {.lex_state = 566},
  [3606] = {.lex_state = 566},
  [3607] = {.lex_state = 566},
  [3608] = {.lex_state = 566},
  [3609] = {.lex_state = 566},
  [3610] = {.lex_state = 566},
  [3611] = {.lex_state = 566},
  [3612] = {.lex_state = 566},
  [3613] = {.lex_state = 566},
  [3614] = {.lex_state = 566},
  [3615] = {.lex_state = 566},
  [3616] = {.lex_state = 566},
  [3617] = {.lex_state = 566},
  [3618] = {.lex_state = 566},
  [3619] = {.lex_state = 566},
  [3620] = {.lex_state = 566},
  [3621] = {.lex_state = 566},
  [3622] = {.lex_state = 566},
  [3623] = {.lex_state = 566},
  [3624] = {.lex_state = 566},
  [3625] = {.lex_state = 566},
  [3626] = {.lex_state = 566},
  [3627] = {.lex_state = 566},
  [3628] = {.lex_state = 566},
  [3629] = {.lex_state = 566},
  [3630] = {.lex_state = 566},
  [3631] = {.lex_state = 566},
  [3632] = {.lex_state = 566},
  [3633] = {.lex_state = 566},
  [3634] = {.lex_state = 566},
  [3635] = {.lex_state = 566},
  [3636] = {.lex_state = 566},
  [3637] = {.lex_state = 566},
  [3638] = {.lex_state = 566},
  [3639] = {.lex_state = 566},
  [3640] = {.lex_state = 566},
  [3641] = {.lex_state = 566},
  [3642] = {.lex_state = 566},
  [3643] = {.lex_state = 566},
  [3644] = {.lex_state = 566},
  [3645] = {.lex_state = 566},
  [3646] = {.lex_state = 566},
  [3647] = {.lex_state = 566},
  [3648] = {.lex_state = 566},
  [3649] = {.lex_state = 566},
  [3650] = {.lex_state = 566},
  [3651] = {.lex_state = 566},
  [3652] = {.lex_state = 566},
  [3653] = {.lex_state = 566},
  [3654] = {.lex_state = 566},
  [3655] = {.lex_state = 566},
  [3656] = {.lex_state = 566},
  [3657] = {.lex_state = 566},
  [3658] = {.lex_state = 566},
  [3659] = {.lex_state = 566},
  [3660] = {.lex_state = 566},
  [3661] = {.lex_state = 566},
  [3662] = {.lex_state = 566},
  [3663] = {.lex_state = 566},
  [3664] = {.lex_state = 566},
  [3665] = {.lex_state = 566},
  [3666] = {.lex_state = 566},
  [3667] = {.lex_state = 566},
  [3668] = {.lex_state = 566},
  [3669] = {.lex_state = 566},
  [3670] = {.lex_state = 566},
  [3671] = {.lex_state = 566},
  [3672] = {.lex_state = 566},
  [3673] = {.lex_state = 566},
  [3674] = {.lex_state = 566},
  [3675] = {.lex_state = 566},
  [3676] = {.lex_state = 566},
  [3677] = {.lex_state = 566},
  [3678] = {.lex_state = 566},
  [3679] = {.lex_state = 566},
  [3680] = {.lex_state = 566},
  [3681] = {.lex_state = 566},
  [3682] = {.lex_state = 566},
  [3683] = {.lex_state = 566},
  [3684] = {.lex_state = 566},
  [3685] = {.lex_state = 566},
  [3686] = {.lex_state = 566},
  [3687] = {.lex_state = 566},
  [3688] = {.lex_state = 566},
  [3689] = {.lex_state = 566},
  [3690] = {.lex_state = 566},
  [3691] = {.lex_state = 566},
  [3692] = {.lex_state = 566},
  [3693] = {.lex_state = 566},
  [3694] = {.lex_state = 566},
  [3695] = {.lex_state = 566},
  [3696] = {.lex_state = 566},
  [3697] = {.lex_state = 566},
  [3698] = {.lex_state = 566},
  [3699] = {.lex_state = 566},
  [3700] = {.lex_state = 566},
  [3701] = {.lex_state = 566},
  [3702] = {.lex_state = 566},
  [3703] = {.lex_state = 566},
  [3704] = {.lex_state = 566},
  [3705] = {.lex_state = 566},
  [3706] = {.lex_state = 566},
  [3707] = {.lex_state = 566},
  [3708] = {.lex_state = 566},
  [3709] = {.lex_state = 566},
  [3710] = {.lex_state = 566},
  [3711] = {.lex_state = 566},
  [3712] = {.lex_state = 566},
  [3713] = {.lex_state = 566},
  [3714] = {.lex_state = 566},
  [3715] = {.lex_state = 566},
  [3716] = {.lex_state = 566},
  [3717] = {.lex_state = 566},
  [3718] = {.lex_state = 566},
  [3719] = {.lex_state = 566},
  [3720] = {.lex_state = 566},
  [3721] = {.lex_state = 566},
  [3722] = {.lex_state = 566},
  [3723] = {.lex_state = 566},
  [3724] = {.lex_state = 566},
  [3725] = {.lex_state = 566},
  [3726] = {.lex_state = 566},
  [3727] = {.lex_state = 566},
  [3728] = {.lex_state = 566},
  [3729] = {.lex_state = 566},
  [3730] = {.lex_state = 566},
  [3731] = {.lex_state = 566},
  [3732] = {.lex_state = 566},
  [3733] = {.lex_state = 566},
  [3734] = {.lex_state = 566},
  [3735] = {.lex_state = 566},
  [3736] = {.lex_state = 566},
  [3737] = {.lex_state = 566},
  [3738] = {.lex_state = 566},
  [3739] = {.lex_state = 566},
  [3740] = {.lex_state = 566},
  [3741] = {.lex_state = 566},
  [3742] = {.lex_state = 566},
  [3743] = {.lex_state = 566},
  [3744] = {.lex_state = 566},
  [3745] = {.lex_state = 566},
  [3746] = {.lex_state = 566},
  [3747] = {.lex_state = 566},
  [3748] = {.lex_state = 566},
  [3749] = {.lex_state = 566},
  [3750] = {.lex_state = 566},
  [3751] = {.lex_state = 566},
  [3752] = {.lex_state = 566},
  [3753] = {.lex_state = 566},
  [3754] = {.lex_state = 566},
  [3755] = {.lex_state = 566},
  [3756] = {.lex_state = 566},
  [3757] = {.lex_state = 566},
  [3758] = {.lex_state = 566},
  [3759] = {.lex_state = 566},
  [3760] = {.lex_state = 566},
  [3761] = {.lex_state = 566},
  [3762] = {.lex_state = 566},
  [3763] = {.lex_state = 566},
  [3764] = {.lex_state = 566},
  [3765] = {.lex_state = 566},
  [3766] = {.lex_state = 566},
  [3767] = {.lex_state = 566},
  [3768] = {.lex_state = 566},
  [3769] = {.lex_state = 566},
  [3770] = {.lex_state = 566},
  [3771] = {.lex_state = 566},
  [3772] = {.lex_state = 566},
  [3773] = {.lex_state = 566},
  [3774] = {.lex_state = 566},
  [3775] = {.lex_state = 566},
  [3776] = {.lex_state = 566},
  [3777] = {.lex_state = 566},
  [3778] = {.lex_state = 566},
  [3779] = {.lex_state = 566},
  [3780] = {.lex_state = 566},
  [3781] = {.lex_state = 566},
  [3782] = {.lex_state = 566},
  [3783] = {.lex_state = 566},
  [3784] = {.lex_state = 566},
  [3785] = {.lex_state = 566},
  [3786] = {.lex_state = 566},
  [3787] = {.lex_state = 566},
  [3788] = {.lex_state = 566},
  [3789] = {.lex_state = 566},
  [3790] = {.lex_state = 566},
  [3791] = {.lex_state = 566},
  [3792] = {.lex_state = 566},
  [3793] = {.lex_state = 566},
  [3794] = {.lex_state = 566},
  [3795] = {.lex_state = 566},
  [3796] = {.lex_state = 566},
  [3797] = {.lex_state = 566},
  [3798] = {.lex_state = 566},
  [3799] = {.lex_state = 566},
  [3800] = {.lex_state = 566},
  [3801] = {.lex_state = 566},
  [3802] = {.lex_state = 566},
  [3803] = {.lex_state = 566},
  [3804] = {.lex_state = 566},
  [3805] = {.lex_state = 566},
  [3806] = {.lex_state = 566},
  [3807] = {.lex_state = 566},
  [3808] = {.lex_state = 566},
  [3809] = {.lex_state = 566},
  [3810] = {.lex_state = 566},
  [3811] = {.lex_state = 566},
  [3812] = {.lex_state = 566},
  [3813] = {.lex_state = 566},
  [3814] = {.lex_state = 566},
  [3815] = {.lex_state = 566},
  [3816] = {.lex_state = 566},
  [3817] = {.lex_state = 566},
  [3818] = {.lex_state = 566},
  [3819] = {.lex_state = 566},
  [3820] = {.lex_state = 566},
  [3821] = {.lex_state = 566},
  [3822] = {.lex_state = 566},
  [3823] = {.lex_state = 566},
  [3824] = {.lex_state = 566},
  [3825] = {.lex_state = 566},
  [3826] = {.lex_state = 566},
  [3827] = {.lex_state = 566},
  [3828] = {.lex_state = 566},
  [3829] = {.lex_state = 566},
  [3830] = {.lex_state = 566},
  [3831] = {.lex_state = 566},
  [3832] = {.lex_state = 566},
  [3833] = {.lex_state = 566},
  [3834] = {.lex_state = 566},
  [3835] = {.lex_state = 566},
  [3836] = {.lex_state = 566},
  [3837] = {.lex_state = 566},
  [3838] = {.lex_state = 566},
  [3839] = {.lex_state = 566},
  [3840] = {.lex_state = 566},
  [3841] = {.lex_state = 566},
  [3842] = {.lex_state = 566},
  [3843] = {.lex_state = 566},
  [3844] = {.lex_state = 566},
  [3845] = {.lex_state = 566},
  [3846] = {.lex_state = 566},
  [3847] = {.lex_state = 566},
  [3848] = {.lex_state = 566},
  [3849] = {.lex_state = 566},
  [3850] = {.lex_state = 566},
  [3851] = {.lex_state = 566},
  [3852] = {.lex_state = 566},
  [3853] = {.lex_state = 566},
  [3854] = {.lex_state = 566},
  [3855] = {.lex_state = 566},
  [3856] = {.lex_state = 566},
  [3857] = {.lex_state = 566},
  [3858] = {.lex_state = 566},
  [3859] = {.lex_state = 566},
  [3860] = {.lex_state = 566},
  [3861] = {.lex_state = 566},
  [3862] = {.lex_state = 566},
  [3863] = {.lex_state = 566},
  [3864] = {.lex_state = 566},
  [3865] = {.lex_state = 566},
  [3866] = {.lex_state = 566},
  [3867] = {.lex_state = 566},
  [3868] = {.lex_state = 566},
  [3869] = {.lex_state = 566},
  [3870] = {.lex_state = 566},
  [3871] = {.lex_state = 566},
  [3872] = {.lex_state = 566},
  [3873] = {.lex_state = 566},
  [3874] = {.lex_state = 566},
  [3875] = {.lex_state = 566},
  [3876] = {.lex_state = 566},
  [3877] = {.lex_state = 566},
  [3878] = {.lex_state = 566},
  [3879] = {.lex_state = 566},
  [3880] = {.lex_state = 566},
  [3881] = {.lex_state = 566},
  [3882] = {.lex_state = 566},
  [3883] = {.lex_state = 566},
  [3884] = {.lex_state = 566},
  [3885] = {.lex_state = 566},
  [3886] = {.lex_state = 566},
  [3887] = {.lex_state = 566},
  [3888] = {.lex_state = 566},
  [3889] = {.lex_state = 566},
  [3890] = {.lex_state = 566},
  [3891] = {.lex_state = 566},
  [3892] = {.lex_state = 566},
  [3893] = {.lex_state = 566},
  [3894] = {.lex_state = 566},
  [3895] = {.lex_state = 566},
  [3896] = {.lex_state = 566},
  [3897] = {.lex_state = 566},
  [3898] = {.lex_state = 566},
  [3899] = {.lex_state = 566},
  [3900] = {.lex_state = 566},
  [3901] = {.lex_state = 566},
  [3902] = {.lex_state = 566},
  [3903] = {.lex_state = 566},
  [3904] = {.lex_state = 566},
  [3905] = {.lex_state = 566},
  [3906] = {.lex_state = 566},
  [3907] = {.lex_state = 566},
  [3908] = {.lex_state = 566},
  [3909] = {.lex_state = 566},
  [3910] = {.lex_state = 566},
  [3911] = {.lex_state = 566},
  [3912] = {.lex_state = 566},
  [3913] = {.lex_state = 566},
  [3914] = {.lex_state = 566},
  [3915] = {.lex_state = 566},
  [3916] = {.lex_state = 566},
  [3917] = {.lex_state = 566},
  [3918] = {.lex_state = 566},
  [3919] = {.lex_state = 566},
  [3920] = {.lex_state = 566},
  [3921] = {.lex_state = 566},
  [3922] = {.lex_state = 566},
  [3923] = {.lex_state = 566},
  [3924] = {.lex_state = 566},
  [3925] = {.lex_state = 566},
  [3926] = {.lex_state = 566},
  [3927] = {.lex_state = 566},
  [3928] = {.lex_state = 566},
  [3929] = {.lex_state = 566},
  [3930] = {.lex_state = 566},
  [3931] = {.lex_state = 566},
  [3932] = {.lex_state = 566},
  [3933] = {.lex_state = 566},
  [3934] = {.lex_state = 566},
  [3935] = {.lex_state = 566},
  [3936] = {.lex_state = 566},
  [3937] = {.lex_state = 566},
  [3938] = {.lex_state = 566},
  [3939] = {.lex_state = 566},
  [3940] = {.lex_state = 566},
  [3941] = {.lex_state = 566},
  [3942] = {.lex_state = 566},
  [3943] = {.lex_state = 566},
  [3944] = {.lex_state = 566},
  [3945] = {.lex_state = 566},
  [3946] = {.lex_state = 566},
  [3947] = {.lex_state = 566},
  [3948] = {.lex_state = 566},
  [3949] = {.lex_state = 566},
  [3950] = {.lex_state = 566},
  [3951] = {.lex_state = 566},
  [3952] = {.lex_state = 566},
  [3953] = {.lex_state = 566},
  [3954] = {.lex_state = 566},
  [3955] = {.lex_state = 566},
  [3956] = {.lex_state = 566},
  [3957] = {.lex_state = 566},
  [3958] = {.lex_state = 566},
  [3959] = {.lex_state = 566},
  [3960] = {.lex_state = 566},
  [3961] = {.lex_state = 566},
  [3962] = {.lex_state = 566},
  [3963] = {.lex_state = 566},
  [3964] = {.lex_state = 566},
  [3965] = {.lex_state = 566},
  [3966] = {.lex_state = 566},
  [3967] = {.lex_state = 566},
  [3968] = {.lex_state = 566},
  [3969] = {.lex_state = 566},
  [3970] = {.lex_state = 566},
  [3971] = {.lex_state = 566},
  [3972] = {.lex_state = 566},
  [3973] = {.lex_state = 566},
  [3974] = {.lex_state = 566},
  [3975] = {.lex_state = 566},
  [3976] = {.lex_state = 566},
  [3977] = {.lex_state = 566},
  [3978] = {.lex_state = 566},
  [3979] = {.lex_state = 566},
  [3980] = {.lex_state = 566},
  [3981] = {.lex_state = 566},
  [3982] = {.lex_state = 566},
  [3983] = {.lex_state = 566},
  [3984] = {.lex_state = 566},
  [3985] = {.lex_state = 566},
  [3986] = {.lex_state = 566},
  [3987] = {.lex_state = 566},
  [3988] = {.lex_state = 566},
  [3989] = {.lex_state = 566},
  [3990] = {.lex_state = 566},
  [3991] = {.lex_state = 566},
  [3992] = {.lex_state = 566},
  [3993] = {.lex_state = 566},
  [3994] = {.lex_state = 566},
  [3995] = {.lex_state = 566},
  [3996] = {.lex_state = 566},
  [3997] = {.lex_state = 566},
  [3998] = {.lex_state = 566},
  [3999] = {.lex_state = 566},
  [4000] = {.lex_state = 566},
  [4001] = {.lex_state = 566},
  [4002] = {.lex_state = 566},
  [4003] = {.lex_state = 566},
  [4004] = {.lex_state = 566},
  [4005] = {.lex_state = 566},
  [4006] = {.lex_state = 566},
  [4007] = {.lex_state = 566},
  [4008] = {.lex_state = 566},
  [4009] = {.lex_state = 566},
  [4010] = {.lex_state = 566},
  [4011] = {.lex_state = 566},
  [4012] = {.lex_state = 566},
  [4013] = {.lex_state = 566},
  [4014] = {.lex_state = 566},
  [4015] = {.lex_state = 566},
  [4016] = {.lex_state = 566},
  [4017] = {.lex_state = 566},
  [4018] = {.lex_state = 566},
  [4019] = {.lex_state = 566},
  [4020] = {.lex_state = 566},
  [4021] = {.lex_state = 566},
  [4022] = {.lex_state = 566},
  [4023] = {.lex_state = 566},
  [4024] = {.lex_state = 566},
  [4025] = {.lex_state = 566},
  [4026] = {.lex_state = 566},
  [4027] = {.lex_state = 566},
  [4028] = {.lex_state = 566},
  [4029] = {.lex_state = 566},
  [4030] = {.lex_state = 566},
  [4031] = {.lex_state = 566},
  [4032] = {.lex_state = 566},
  [4033] = {.lex_state = 566},
  [4034] = {.lex_state = 566},
  [4035] = {.lex_state = 566},
  [4036] = {.lex_state = 566},
  [4037] = {.lex_state = 566},
  [4038] = {.lex_state = 566},
  [4039] = {.lex_state = 566},
  [4040] = {.lex_state = 566},
  [4041] = {.lex_state = 566},
  [4042] = {.lex_state = 566},
  [4043] = {.lex_state = 566},
  [4044] = {.lex_state = 566},
  [4045] = {.lex_state = 566},
  [4046] = {.lex_state = 566},
  [4047] = {.lex_state = 566},
  [4048] = {.lex_state = 566},
  [4049] = {.lex_state = 566},
  [4050] = {.lex_state = 566},
  [4051] = {.lex_state = 566},
  [4052] = {.lex_state = 566},
  [4053] = {.lex_state = 566},
  [4054] = {.lex_state = 566},
  [4055] = {.lex_state = 566},
  [4056] = {.lex_state = 566},
  [4057] = {.lex_state = 566},
  [4058] = {.lex_state = 566},
  [4059] = {.lex_state = 566},
  [4060] = {.lex_state = 566},
  [4061] = {.lex_state = 566},
  [4062] = {.lex_state = 566},
  [4063] = {.lex_state = 566},
  [4064] = {.lex_state = 566},
  [4065] = {.lex_state = 566},
  [4066] = {.lex_state = 566},
  [4067] = {.lex_state = 566},
  [4068] = {.lex_state = 566},
  [4069] = {.lex_state = 566},
  [4070] = {.lex_state = 566},
  [4071] = {.lex_state = 566},
  [4072] = {.lex_state = 566},
  [4073] = {.lex_state = 566},
  [4074] = {.lex_state = 566},
  [4075] = {.lex_state = 566},
  [4076] = {.lex_state = 236, .external_lex_state = 3},
  [4077] = {.lex_state = 243, .external_lex_state = 3},
  [4078] = {.lex_state = 249, .external_lex_state = 3},
  [4079] = {.lex_state = 513, .external_lex_state = 3},
  [4080] = {.lex_state = 282, .external_lex_state = 3},
  [4081] = {.lex_state = 33, .external_lex_state = 3},
  [4082] = {.lex_state = 36, .external_lex_state = 3},
  [4083] = {.lex_state = 255, .external_lex_state = 3},
  [4084] = {.lex_state = 255, .external_lex_state = 3},
  [4085] = {.lex_state = 288, .external_lex_state = 3},
  [4086] = {.lex_state = 4},
  [4087] = {.lex_state = 8},
  [4088] = {.lex_state = 239},
  [4089] = {.lex_state = 12},
  [4090] = {.lex_state = 17},
  [4091] = {.lex_state = 314},
  [4092] = {.lex_state = 507},
  [4093] = {.lex_state = 511},
  [4094] = {.lex_state = 320},
  [4095] = {.lex_state = 261, .external_lex_state = 3},
  [4096] = {.lex_state = 266, .external_lex_state = 3},
  [4097] = {.lex_state = 291, .external_lex_state = 3},
  [4098] = {.lex_state = 39, .external_lex_state = 3},
  [4099] = {.lex_state = 41, .external_lex_state = 3},
  [4100] = {.lex_state = 271, .external_lex_state = 3},
  [4101] = {.lex_state = 516, .external_lex_state = 3},
  [4102] = {.lex_state = 273, .external_lex_state = 3},
  [4103] = {.lex_state = 299, .external_lex_state = 3},
  [4104] = {.lex_state = 505, .external_lex_state = 2},
  [4105] = {.lex_state = 275, .external_lex_state = 2},
  [4106] = {.lex_state = 505, .external_lex_state = 2},
  [4107] = {.lex_state = 505, .external_lex_state = 2},
  [4108] = {.lex_state = 275, .external_lex_state = 2},
  [4109] = {.lex_state = 275, .external_lex_state = 2},
  [4110] = {.lex_state = 518, .external_lex_state = 2},
  [4111] = {.lex_state = 243, .external_lex_state = 2},
  [4112] = {.lex_state = 243, .external_lex_state = 2},
  [4113] = {.lex_state = 275, .external_lex_state = 2},
  [4114] = {.lex_state = 277, .external_lex_state = 2},
  [4115] = {.lex_state = 45, .external_lex_state = 2},
  [4116] = {.lex_state = 236, .external_lex_state = 2},
  [4117] = {.lex_state = 277, .external_lex_state = 2},
  [4118] = {.lex_state = 47, .external_lex_state = 3},
  [4119] = {.lex_state = 518, .external_lex_state = 2},
  [4120] = {.lex_state = 49, .external_lex_state = 2},
  [4121] = {.lex_state = 277, .external_lex_state = 2},
  [4122] = {.lex_state = 280, .external_lex_state = 2},
  [4123] = {.lex_state = 51, .external_lex_state = 3},
  [4124] = {.lex_state = 51, .external_lex_state = 3},
  [4125] = {.lex_state = 236, .external_lex_state = 2},
  [4126] = {.lex_state = 236, .external_lex_state = 2},
  [4127] = {.lex_state = 243, .external_lex_state = 2},
  [4128] = {.lex_state = 49, .external_lex_state = 2},
  [4129] = {.lex_state = 51, .external_lex_state = 3},
  [4130] = {.lex_state = 47, .external_lex_state = 3},
  [4131] = {.lex_state = 236, .external_lex_state = 2},
  [4132] = {.lex_state = 518, .external_lex_state = 2},
  [4133] = {.lex_state = 47, .external_lex_state = 3},
  [4134] = {.lex_state = 49, .external_lex_state = 2},
  [4135] = {.lex_state = 45, .external_lex_state = 2},
  [4136] = {.lex_state = 47, .external_lex_state = 3},
  [4137] = {.lex_state = 275, .external_lex_state = 2},
  [4138] = {.lex_state = 243, .external_lex_state = 2},
  [4139] = {.lex_state = 45, .external_lex_state = 2},
  [4140] = {.lex_state = 51, .external_lex_state = 3},
  [4141] = {.lex_state = 33, .external_lex_state = 2},
  [4142] = {.lex_state = 275, .external_lex_state = 3},
  [4143] = {.lex_state = 513, .external_lex_state = 2},
  [4144] = {.lex_state = 244, .external_lex_state = 3},
  [4145] = {.lex_state = 275, .external_lex_state = 3},
  [4146] = {.lex_state = 275, .external_lex_state = 3},
  [4147] = {.lex_state = 275, .external_lex_state = 3},
  [4148] = {.lex_state = 520, .external_lex_state = 3},
  [4149] = {.lex_state = 513, .external_lex_state = 2},
  [4150] = {.lex_state = 520, .external_lex_state = 3},
  [4151] = {.lex_state = 275, .external_lex_state = 3},
  [4152] = {.lex_state = 47, .external_lex_state = 3},
  [4153] = {.lex_state = 47, .external_lex_state = 3},
  [4154] = {.lex_state = 275, .external_lex_state = 3},
  [4155] = {.lex_state = 520, .external_lex_state = 3},
  [4156] = {.lex_state = 236, .external_lex_state = 3},
  [4157] = {.lex_state = 36, .external_lex_state = 2},
  [4158] = {.lex_state = 282, .external_lex_state = 2},
  [4159] = {.lex_state = 243, .external_lex_state = 3},
  [4160] = {.lex_state = 243, .external_lex_state = 3},
  [4161] = {.lex_state = 275, .external_lex_state = 3},
  [4162] = {.lex_state = 520, .external_lex_state = 3},
  [4163] = {.lex_state = 54, .external_lex_state = 3},
  [4164] = {.lex_state = 243, .external_lex_state = 3},
  [4165] = {.lex_state = 243, .external_lex_state = 3},
  [4166] = {.lex_state = 36, .external_lex_state = 2},
  [4167] = {.lex_state = 54, .external_lex_state = 3},
  [4168] = {.lex_state = 280, .external_lex_state = 2},
  [4169] = {.lex_state = 54, .external_lex_state = 3},
  [4170] = {.lex_state = 54, .external_lex_state = 3},
  [4171] = {.lex_state = 51, .external_lex_state = 3},
  [4172] = {.lex_state = 47, .external_lex_state = 3},
  [4173] = {.lex_state = 51, .external_lex_state = 3},
  [4174] = {.lex_state = 51, .external_lex_state = 3},
  [4175] = {.lex_state = 51, .external_lex_state = 3},
  [4176] = {.lex_state = 47, .external_lex_state = 3},
  [4177] = {.lex_state = 47, .external_lex_state = 3},
  [4178] = {.lex_state = 47, .external_lex_state = 3},
  [4179] = {.lex_state = 47, .external_lex_state = 3},
  [4180] = {.lex_state = 47, .external_lex_state = 3},
  [4181] = {.lex_state = 47, .external_lex_state = 3},
  [4182] = {.lex_state = 47, .external_lex_state = 3},
  [4183] = {.lex_state = 47, .external_lex_state = 3},
  [4184] = {.lex_state = 47, .external_lex_state = 3},
  [4185] = {.lex_state = 51, .external_lex_state = 3},
  [4186] = {.lex_state = 51, .external_lex_state = 3},
  [4187] = {.lex_state = 51, .external_lex_state = 3},
  [4188] = {.lex_state = 51, .external_lex_state = 3},
  [4189] = {.lex_state = 51, .external_lex_state = 3},
  [4190] = {.lex_state = 236, .external_lex_state = 3},
  [4191] = {.lex_state = 51, .external_lex_state = 3},
  [4192] = {.lex_state = 243, .external_lex_state = 3},
  [4193] = {.lex_state = 51, .external_lex_state = 3},
  [4194] = {.lex_state = 243, .external_lex_state = 3},
  [4195] = {.lex_state = 513, .external_lex_state = 2},
  [4196] = {.lex_state = 243, .external_lex_state = 3},
  [4197] = {.lex_state = 282, .external_lex_state = 2},
  [4198] = {.lex_state = 280, .external_lex_state = 2},
  [4199] = {.lex_state = 236, .external_lex_state = 3},
  [4200] = {.lex_state = 243, .external_lex_state = 3},
  [4201] = {.lex_state = 56, .external_lex_state = 3},
  [4202] = {.lex_state = 249, .external_lex_state = 2},
  [4203] = {.lex_state = 56, .external_lex_state = 3},
  [4204] = {.lex_state = 56, .external_lex_state = 3},
  [4205] = {.lex_state = 56, .external_lex_state = 3},
  [4206] = {.lex_state = 281, .external_lex_state = 3},
  [4207] = {.lex_state = 282, .external_lex_state = 2},
  [4208] = {.lex_state = 281, .external_lex_state = 3},
  [4209] = {.lex_state = 281, .external_lex_state = 3},
  [4210] = {.lex_state = 281, .external_lex_state = 3},
  [4211] = {.lex_state = 236, .external_lex_state = 3},
  [4212] = {.lex_state = 249, .external_lex_state = 2},
  [4213] = {.lex_state = 2, .external_lex_state = 2},
  [4214] = {.lex_state = 236, .external_lex_state = 3},
  [4215] = {.lex_state = 505, .external_lex_state = 3},
  [4216] = {.lex_state = 505, .external_lex_state = 3},
  [4217] = {.lex_state = 505, .external_lex_state = 3},
  [4218] = {.lex_state = 505, .external_lex_state = 3},
  [4219] = {.lex_state = 33, .external_lex_state = 2},
  [4220] = {.lex_state = 36, .external_lex_state = 2},
  [4221] = {.lex_state = 2, .external_lex_state = 2},
  [4222] = {.lex_state = 505, .external_lex_state = 3},
  [4223] = {.lex_state = 58, .external_lex_state = 3},
  [4224] = {.lex_state = 33, .external_lex_state = 2},
  [4225] = {.lex_state = 58, .external_lex_state = 3},
  [4226] = {.lex_state = 505, .external_lex_state = 3},
  [4227] = {.lex_state = 243, .external_lex_state = 3},
  [4228] = {.lex_state = 513, .external_lex_state = 2},
  [4229] = {.lex_state = 58, .external_lex_state = 3},
  [4230] = {.lex_state = 2, .external_lex_state = 2},
  [4231] = {.lex_state = 236, .external_lex_state = 3},
  [4232] = {.lex_state = 236, .external_lex_state = 3},
  [4233] = {.lex_state = 236, .external_lex_state = 3},
  [4234] = {.lex_state = 236, .external_lex_state = 3},
  [4235] = {.lex_state = 237, .external_lex_state = 3},
  [4236] = {.lex_state = 505, .external_lex_state = 3},
  [4237] = {.lex_state = 249, .external_lex_state = 2},
  [4238] = {.lex_state = 282, .external_lex_state = 2},
  [4239] = {.lex_state = 33, .external_lex_state = 2},
  [4240] = {.lex_state = 58, .external_lex_state = 3},
  [4241] = {.lex_state = 36, .external_lex_state = 2},
  [4242] = {.lex_state = 249, .external_lex_state = 2},
  [4243] = {.lex_state = 51, .external_lex_state = 3},
  [4244] = {.lex_state = 284, .external_lex_state = 3},
  [4245] = {.lex_state = 243, .external_lex_state = 3},
  [4246] = {.lex_state = 249, .external_lex_state = 3},
  [4247] = {.lex_state = 277, .external_lex_state = 3},
  [4248] = {.lex_state = 243, .external_lex_state = 3},
  [4249] = {.lex_state = 243, .external_lex_state = 3},
  [4250] = {.lex_state = 243, .external_lex_state = 3},
  [4251] = {.lex_state = 514, .external_lex_state = 3},
  [4252] = {.lex_state = 243, .external_lex_state = 3},
  [4253] = {.lex_state = 45, .external_lex_state = 3},
  [4254] = {.lex_state = 277, .external_lex_state = 3},
  [4255] = {.lex_state = 255, .external_lex_state = 2},
  [4256] = {.lex_state = 60, .external_lex_state = 3},
  [4257] = {.lex_state = 513, .external_lex_state = 3},
  [4258] = {.lex_state = 33, .external_lex_state = 3},
  [4259] = {.lex_state = 58, .external_lex_state = 3},
  [4260] = {.lex_state = 243, .external_lex_state = 3},
  [4261] = {.lex_state = 54, .external_lex_state = 3},
  [4262] = {.lex_state = 54, .external_lex_state = 3},
  [4263] = {.lex_state = 513, .external_lex_state = 3},
  [4264] = {.lex_state = 518, .external_lex_state = 3},
  [4265] = {.lex_state = 243, .external_lex_state = 3},
  [4266] = {.lex_state = 54, .external_lex_state = 3},
  [4267] = {.lex_state = 54, .external_lex_state = 3},
  [4268] = {.lex_state = 243, .external_lex_state = 3},
  [4269] = {.lex_state = 54, .external_lex_state = 3},
  [4270] = {.lex_state = 54, .external_lex_state = 3},
  [4271] = {.lex_state = 54, .external_lex_state = 3},
  [4272] = {.lex_state = 54, .external_lex_state = 3},
  [4273] = {.lex_state = 54, .external_lex_state = 3},
  [4274] = {.lex_state = 54, .external_lex_state = 3},
  [4275] = {.lex_state = 243, .external_lex_state = 3},
  [4276] = {.lex_state = 36, .external_lex_state = 3},
  [4277] = {.lex_state = 277, .external_lex_state = 3},
  [4278] = {.lex_state = 58, .external_lex_state = 3},
  [4279] = {.lex_state = 277, .external_lex_state = 3},
  [4280] = {.lex_state = 58, .external_lex_state = 3},
  [4281] = {.lex_state = 45, .external_lex_state = 3},
  [4282] = {.lex_state = 58, .external_lex_state = 3},
  [4283] = {.lex_state = 277, .external_lex_state = 3},
  [4284] = {.lex_state = 58, .external_lex_state = 3},
  [4285] = {.lex_state = 58, .external_lex_state = 3},
  [4286] = {.lex_state = 58, .external_lex_state = 3},
  [4287] = {.lex_state = 58, .external_lex_state = 3},
  [4288] = {.lex_state = 58, .external_lex_state = 3},
  [4289] = {.lex_state = 243, .external_lex_state = 3},
  [4290] = {.lex_state = 243, .external_lex_state = 3},
  [4291] = {.lex_state = 243, .external_lex_state = 3},
  [4292] = {.lex_state = 243, .external_lex_state = 3},
  [4293] = {.lex_state = 243, .external_lex_state = 3},
  [4294] = {.lex_state = 236, .external_lex_state = 3},
  [4295] = {.lex_state = 243, .external_lex_state = 3},
  [4296] = {.lex_state = 520, .external_lex_state = 3},
  [4297] = {.lex_state = 518, .external_lex_state = 3},
  [4298] = {.lex_state = 280, .external_lex_state = 3},
  [4299] = {.lex_state = 280, .external_lex_state = 3},
  [4300] = {.lex_state = 243, .external_lex_state = 3},
  [4301] = {.lex_state = 243, .external_lex_state = 3},
  [4302] = {.lex_state = 243, .external_lex_state = 3},
  [4303] = {.lex_state = 520, .external_lex_state = 3},
  [4304] = {.lex_state = 520, .external_lex_state = 3},
  [4305] = {.lex_state = 518, .external_lex_state = 3},
  [4306] = {.lex_state = 520, .external_lex_state = 3},
  [4307] = {.lex_state = 280, .external_lex_state = 3},
  [4308] = {.lex_state = 243, .external_lex_state = 3},
  [4309] = {.lex_state = 243, .external_lex_state = 3},
  [4310] = {.lex_state = 520, .external_lex_state = 3},
  [4311] = {.lex_state = 518, .external_lex_state = 3},
  [4312] = {.lex_state = 520, .external_lex_state = 3},
  [4313] = {.lex_state = 520, .external_lex_state = 3},
  [4314] = {.lex_state = 520, .external_lex_state = 3},
  [4315] = {.lex_state = 520, .external_lex_state = 3},
  [4316] = {.lex_state = 520, .external_lex_state = 3},
  [4317] = {.lex_state = 236, .external_lex_state = 3},
  [4318] = {.lex_state = 33, .external_lex_state = 3},
  [4319] = {.lex_state = 236, .external_lex_state = 3},
  [4320] = {.lex_state = 236, .external_lex_state = 3},
  [4321] = {.lex_state = 236, .external_lex_state = 3},
  [4322] = {.lex_state = 243, .external_lex_state = 3},
  [4323] = {.lex_state = 36, .external_lex_state = 3},
  [4324] = {.lex_state = 243, .external_lex_state = 3},
  [4325] = {.lex_state = 236, .external_lex_state = 3},
  [4326] = {.lex_state = 236, .external_lex_state = 3},
  [4327] = {.lex_state = 236, .external_lex_state = 3},
  [4328] = {.lex_state = 236, .external_lex_state = 3},
  [4329] = {.lex_state = 236, .external_lex_state = 3},
  [4330] = {.lex_state = 236, .external_lex_state = 3},
  [4331] = {.lex_state = 236, .external_lex_state = 3},
  [4332] = {.lex_state = 236, .external_lex_state = 3},
  [4333] = {.lex_state = 280, .external_lex_state = 3},
  [4334] = {.lex_state = 236, .external_lex_state = 3},
  [4335] = {.lex_state = 520, .external_lex_state = 3},
  [4336] = {.lex_state = 513, .external_lex_state = 3},
  [4337] = {.lex_state = 280, .external_lex_state = 2},
  [4338] = {.lex_state = 236, .external_lex_state = 3},
  [4339] = {.lex_state = 236, .external_lex_state = 3},
  [4340] = {.lex_state = 236, .external_lex_state = 3},
  [4341] = {.lex_state = 236, .external_lex_state = 3},
  [4342] = {.lex_state = 236, .external_lex_state = 3},
  [4343] = {.lex_state = 243, .external_lex_state = 3},
  [4344] = {.lex_state = 236, .external_lex_state = 3},
  [4345] = {.lex_state = 236, .external_lex_state = 3},
  [4346] = {.lex_state = 236, .external_lex_state = 3},
  [4347] = {.lex_state = 236, .external_lex_state = 3},
  [4348] = {.lex_state = 236, .external_lex_state = 3},
  [4349] = {.lex_state = 236, .external_lex_state = 3},
  [4350] = {.lex_state = 236, .external_lex_state = 3},
  [4351] = {.lex_state = 236, .external_lex_state = 3},
  [4352] = {.lex_state = 236, .external_lex_state = 3},
  [4353] = {.lex_state = 236, .external_lex_state = 3},
  [4354] = {.lex_state = 236, .external_lex_state = 3},
  [4355] = {.lex_state = 236, .external_lex_state = 3},
  [4356] = {.lex_state = 236, .external_lex_state = 3},
  [4357] = {.lex_state = 283, .external_lex_state = 3},
  [4358] = {.lex_state = 282, .external_lex_state = 3},
  [4359] = {.lex_state = 236, .external_lex_state = 3},
  [4360] = {.lex_state = 243, .external_lex_state = 3},
  [4361] = {.lex_state = 236, .external_lex_state = 3},
  [4362] = {.lex_state = 282, .external_lex_state = 3},
  [4363] = {.lex_state = 282, .external_lex_state = 3},
  [4364] = {.lex_state = 282, .external_lex_state = 3},
  [4365] = {.lex_state = 255, .external_lex_state = 2},
  [4366] = {.lex_state = 56, .external_lex_state = 3},
  [4367] = {.lex_state = 236, .external_lex_state = 3},
  [4368] = {.lex_state = 56, .external_lex_state = 3},
  [4369] = {.lex_state = 236, .external_lex_state = 3},
  [4370] = {.lex_state = 36, .external_lex_state = 3},
  [4371] = {.lex_state = 33, .external_lex_state = 3},
  [4372] = {.lex_state = 56, .external_lex_state = 3},
  [4373] = {.lex_state = 56, .external_lex_state = 3},
  [4374] = {.lex_state = 56, .external_lex_state = 3},
  [4375] = {.lex_state = 56, .external_lex_state = 3},
  [4376] = {.lex_state = 56, .external_lex_state = 3},
  [4377] = {.lex_state = 56, .external_lex_state = 3},
  [4378] = {.lex_state = 56, .external_lex_state = 3},
  [4379] = {.lex_state = 60, .external_lex_state = 3},
  [4380] = {.lex_state = 280, .external_lex_state = 3},
  [4381] = {.lex_state = 49, .external_lex_state = 3},
  [4382] = {.lex_state = 49, .external_lex_state = 3},
  [4383] = {.lex_state = 236, .external_lex_state = 3},
  [4384] = {.lex_state = 56, .external_lex_state = 3},
  [4385] = {.lex_state = 56, .external_lex_state = 3},
  [4386] = {.lex_state = 236, .external_lex_state = 3},
  [4387] = {.lex_state = 33, .external_lex_state = 3},
  [4388] = {.lex_state = 280, .external_lex_state = 3},
  [4389] = {.lex_state = 49, .external_lex_state = 3},
  [4390] = {.lex_state = 281, .external_lex_state = 3},
  [4391] = {.lex_state = 56, .external_lex_state = 3},
  [4392] = {.lex_state = 45, .external_lex_state = 3},
  [4393] = {.lex_state = 243, .external_lex_state = 3},
  [4394] = {.lex_state = 513, .external_lex_state = 3},
  [4395] = {.lex_state = 280, .external_lex_state = 3},
  [4396] = {.lex_state = 281, .external_lex_state = 3},
  [4397] = {.lex_state = 54, .external_lex_state = 3},
  [4398] = {.lex_state = 513, .external_lex_state = 3},
  [4399] = {.lex_state = 513, .external_lex_state = 3},
  [4400] = {.lex_state = 236, .external_lex_state = 3},
  [4401] = {.lex_state = 54, .external_lex_state = 3},
  [4402] = {.lex_state = 49, .external_lex_state = 3},
  [4403] = {.lex_state = 243, .external_lex_state = 3},
  [4404] = {.lex_state = 243, .external_lex_state = 3},
  [4405] = {.lex_state = 236, .external_lex_state = 3},
  [4406] = {.lex_state = 255, .external_lex_state = 2},
  [4407] = {.lex_state = 60, .external_lex_state = 3},
  [4408] = {.lex_state = 280, .external_lex_state = 2},
  [4409] = {.lex_state = 49, .external_lex_state = 3},
  [4410] = {.lex_state = 45, .external_lex_state = 3},
  [4411] = {.lex_state = 277, .external_lex_state = 3},
  [4412] = {.lex_state = 49, .external_lex_state = 3},
  [4413] = {.lex_state = 2, .external_lex_state = 2},
  [4414] = {.lex_state = 49, .external_lex_state = 3},
  [4415] = {.lex_state = 33, .external_lex_state = 3},
  [4416] = {.lex_state = 518, .external_lex_state = 3},
  [4417] = {.lex_state = 58, .external_lex_state = 3},
  [4418] = {.lex_state = 34, .external_lex_state = 3},
  [4419] = {.lex_state = 36, .external_lex_state = 3},
  [4420] = {.lex_state = 36, .external_lex_state = 3},
  [4421] = {.lex_state = 277, .external_lex_state = 3},
  [4422] = {.lex_state = 236, .external_lex_state = 3},
  [4423] = {.lex_state = 243, .external_lex_state = 3},
  [4424] = {.lex_state = 281, .external_lex_state = 3},
  [4425] = {.lex_state = 236, .external_lex_state = 3},
  [4426] = {.lex_state = 45, .external_lex_state = 3},
  [4427] = {.lex_state = 45, .external_lex_state = 3},
  [4428] = {.lex_state = 518, .external_lex_state = 3},
  [4429] = {.lex_state = 60, .external_lex_state = 3},
  [4430] = {.lex_state = 236, .external_lex_state = 3},
  [4431] = {.lex_state = 513, .external_lex_state = 3},
  [4432] = {.lex_state = 281, .external_lex_state = 3},
  [4433] = {.lex_state = 249, .external_lex_state = 3},
  [4434] = {.lex_state = 281, .external_lex_state = 3},
  [4435] = {.lex_state = 236, .external_lex_state = 3},
  [4436] = {.lex_state = 249, .external_lex_state = 3},
  [4437] = {.lex_state = 281, .external_lex_state = 3},
  [4438] = {.lex_state = 255, .external_lex_state = 2},
  [4439] = {.lex_state = 236, .external_lex_state = 3},
  [4440] = {.lex_state = 236, .external_lex_state = 3},
  [4441] = {.lex_state = 236, .external_lex_state = 3},
  [4442] = {.lex_state = 45, .external_lex_state = 3},
  [4443] = {.lex_state = 518, .external_lex_state = 3},
  [4444] = {.lex_state = 58, .external_lex_state = 3},
  [4445] = {.lex_state = 249, .external_lex_state = 3},
  [4446] = {.lex_state = 236, .external_lex_state = 3},
  [4447] = {.lex_state = 236, .external_lex_state = 3},
  [4448] = {.lex_state = 249, .external_lex_state = 3},
  [4449] = {.lex_state = 2, .external_lex_state = 2},
  [4450] = {.lex_state = 243, .external_lex_state = 3},
  [4451] = {.lex_state = 281, .external_lex_state = 3},
  [4452] = {.lex_state = 243, .external_lex_state = 3},
  [4453] = {.lex_state = 236, .external_lex_state = 3},
  [4454] = {.lex_state = 518, .external_lex_state = 2},
  [4455] = {.lex_state = 243, .external_lex_state = 3},
  [4456] = {.lex_state = 33, .external_lex_state = 3},
  [4457] = {.lex_state = 33, .external_lex_state = 3},
  [4458] = {.lex_state = 236, .external_lex_state = 3},
  [4459] = {.lex_state = 236, .external_lex_state = 3},
  [4460] = {.lex_state = 236, .external_lex_state = 3},
  [4461] = {.lex_state = 36, .external_lex_state = 3},
  [4462] = {.lex_state = 36, .external_lex_state = 3},
  [4463] = {.lex_state = 36, .external_lex_state = 3},
  [4464] = {.lex_state = 36, .external_lex_state = 3},
  [4465] = {.lex_state = 236, .external_lex_state = 3},
  [4466] = {.lex_state = 236, .external_lex_state = 3},
  [4467] = {.lex_state = 236, .external_lex_state = 3},
  [4468] = {.lex_state = 243, .external_lex_state = 3},
  [4469] = {.lex_state = 37, .external_lex_state = 3},
  [4470] = {.lex_state = 281, .external_lex_state = 3},
  [4471] = {.lex_state = 33, .external_lex_state = 3},
  [4472] = {.lex_state = 243, .external_lex_state = 3},
  [4473] = {.lex_state = 281, .external_lex_state = 3},
  [4474] = {.lex_state = 33, .external_lex_state = 3},
  [4475] = {.lex_state = 518, .external_lex_state = 2},
  [4476] = {.lex_state = 58, .external_lex_state = 3},
  [4477] = {.lex_state = 250, .external_lex_state = 3},
  [4478] = {.lex_state = 249, .external_lex_state = 3},
  [4479] = {.lex_state = 249, .external_lex_state = 3},
  [4480] = {.lex_state = 249, .external_lex_state = 3},
  [4481] = {.lex_state = 520, .external_lex_state = 3},
  [4482] = {.lex_state = 249, .external_lex_state = 3},
  [4483] = {.lex_state = 243, .external_lex_state = 3},
  [4484] = {.lex_state = 243, .external_lex_state = 3},
  [4485] = {.lex_state = 281, .external_lex_state = 3},
  [4486] = {.lex_state = 243, .external_lex_state = 3},
  [4487] = {.lex_state = 243, .external_lex_state = 3},
  [4488] = {.lex_state = 243, .external_lex_state = 3},
  [4489] = {.lex_state = 513, .external_lex_state = 3},
  [4490] = {.lex_state = 243, .external_lex_state = 3},
  [4491] = {.lex_state = 281, .external_lex_state = 3},
  [4492] = {.lex_state = 243, .external_lex_state = 3},
  [4493] = {.lex_state = 243, .external_lex_state = 3},
  [4494] = {.lex_state = 243, .external_lex_state = 3},
  [4495] = {.lex_state = 243, .external_lex_state = 3},
  [4496] = {.lex_state = 243, .external_lex_state = 3},
  [4497] = {.lex_state = 243, .external_lex_state = 3},
  [4498] = {.lex_state = 243, .external_lex_state = 3},
  [4499] = {.lex_state = 243, .external_lex_state = 3},
  [4500] = {.lex_state = 236, .external_lex_state = 3},
  [4501] = {.lex_state = 243, .external_lex_state = 3},
  [4502] = {.lex_state = 281, .external_lex_state = 3},
  [4503] = {.lex_state = 243, .external_lex_state = 3},
  [4504] = {.lex_state = 243, .external_lex_state = 3},
  [4505] = {.lex_state = 243, .external_lex_state = 3},
  [4506] = {.lex_state = 243, .external_lex_state = 3},
  [4507] = {.lex_state = 243, .external_lex_state = 3},
  [4508] = {.lex_state = 243, .external_lex_state = 3},
  [4509] = {.lex_state = 243, .external_lex_state = 3},
  [4510] = {.lex_state = 243, .external_lex_state = 3},
  [4511] = {.lex_state = 243, .external_lex_state = 3},
  [4512] = {.lex_state = 243, .external_lex_state = 3},
  [4513] = {.lex_state = 243, .external_lex_state = 3},
  [4514] = {.lex_state = 243, .external_lex_state = 3},
  [4515] = {.lex_state = 513, .external_lex_state = 3},
  [4516] = {.lex_state = 249, .external_lex_state = 3},
  [4517] = {.lex_state = 282, .external_lex_state = 3},
  [4518] = {.lex_state = 36, .external_lex_state = 3},
  [4519] = {.lex_state = 33, .external_lex_state = 3},
  [4520] = {.lex_state = 513, .external_lex_state = 3},
  [4521] = {.lex_state = 2, .external_lex_state = 3},
  [4522] = {.lex_state = 513, .external_lex_state = 3},
  [4523] = {.lex_state = 513, .external_lex_state = 3},
  [4524] = {.lex_state = 33, .external_lex_state = 3},
  [4525] = {.lex_state = 513, .external_lex_state = 3},
  [4526] = {.lex_state = 33, .external_lex_state = 3},
  [4527] = {.lex_state = 513, .external_lex_state = 3},
  [4528] = {.lex_state = 513, .external_lex_state = 3},
  [4529] = {.lex_state = 33, .external_lex_state = 3},
  [4530] = {.lex_state = 513, .external_lex_state = 3},
  [4531] = {.lex_state = 2, .external_lex_state = 3},
  [4532] = {.lex_state = 513, .external_lex_state = 3},
  [4533] = {.lex_state = 513, .external_lex_state = 3},
  [4534] = {.lex_state = 33, .external_lex_state = 3},
  [4535] = {.lex_state = 33, .external_lex_state = 3},
  [4536] = {.lex_state = 60, .external_lex_state = 3},
  [4537] = {.lex_state = 513, .external_lex_state = 3},
  [4538] = {.lex_state = 513, .external_lex_state = 3},
  [4539] = {.lex_state = 36, .external_lex_state = 3},
  [4540] = {.lex_state = 36, .external_lex_state = 3},
  [4541] = {.lex_state = 36, .external_lex_state = 3},
  [4542] = {.lex_state = 36, .external_lex_state = 3},
  [4543] = {.lex_state = 2, .external_lex_state = 3},
  [4544] = {.lex_state = 2, .external_lex_state = 3},
  [4545] = {.lex_state = 2, .external_lex_state = 3},
  [4546] = {.lex_state = 60, .external_lex_state = 3},
  [4547] = {.lex_state = 246, .external_lex_state = 2},
  [4548] = {.lex_state = 513, .external_lex_state = 3},
  [4549] = {.lex_state = 282, .external_lex_state = 3},
  [4550] = {.lex_state = 513, .external_lex_state = 3},
  [4551] = {.lex_state = 282, .external_lex_state = 3},
  [4552] = {.lex_state = 286, .external_lex_state = 2},
  [4553] = {.lex_state = 33, .external_lex_state = 3},
  [4554] = {.lex_state = 60, .external_lex_state = 3},
  [4555] = {.lex_state = 33, .external_lex_state = 3},
  [4556] = {.lex_state = 36, .external_lex_state = 3},
  [4557] = {.lex_state = 513, .external_lex_state = 3},
  [4558] = {.lex_state = 36, .external_lex_state = 3},
  [4559] = {.lex_state = 282, .external_lex_state = 3},
  [4560] = {.lex_state = 513, .external_lex_state = 3},
  [4561] = {.lex_state = 36, .external_lex_state = 3},
  [4562] = {.lex_state = 513, .external_lex_state = 3},
  [4563] = {.lex_state = 36, .external_lex_state = 3},
  [4564] = {.lex_state = 282, .external_lex_state = 3},
  [4565] = {.lex_state = 513, .external_lex_state = 3},
  [4566] = {.lex_state = 36, .external_lex_state = 3},
  [4567] = {.lex_state = 36, .external_lex_state = 3},
  [4568] = {.lex_state = 255, .external_lex_state = 3},
  [4569] = {.lex_state = 36, .external_lex_state = 3},
  [4570] = {.lex_state = 36, .external_lex_state = 3},
  [4571] = {.lex_state = 33, .external_lex_state = 3},
  [4572] = {.lex_state = 33, .external_lex_state = 3},
  [4573] = {.lex_state = 282, .external_lex_state = 3},
  [4574] = {.lex_state = 255, .external_lex_state = 3},
  [4575] = {.lex_state = 33, .external_lex_state = 3},
  [4576] = {.lex_state = 513, .external_lex_state = 3},
  [4577] = {.lex_state = 36, .external_lex_state = 3},
  [4578] = {.lex_state = 282, .external_lex_state = 3},
  [4579] = {.lex_state = 282, .external_lex_state = 3},
  [4580] = {.lex_state = 36, .external_lex_state = 3},
  [4581] = {.lex_state = 513, .external_lex_state = 3},
  [4582] = {.lex_state = 36, .external_lex_state = 3},
  [4583] = {.lex_state = 513, .external_lex_state = 3},
  [4584] = {.lex_state = 36, .external_lex_state = 3},
  [4585] = {.lex_state = 36, .external_lex_state = 3},
  [4586] = {.lex_state = 282, .external_lex_state = 3},
  [4587] = {.lex_state = 33, .external_lex_state = 3},
  [4588] = {.lex_state = 36, .external_lex_state = 3},
  [4589] = {.lex_state = 36, .external_lex_state = 3},
  [4590] = {.lex_state = 36, .external_lex_state = 3},
  [4591] = {.lex_state = 36, .external_lex_state = 3},
  [4592] = {.lex_state = 33, .external_lex_state = 3},
  [4593] = {.lex_state = 36, .external_lex_state = 3},
  [4594] = {.lex_state = 286, .external_lex_state = 2},
  [4595] = {.lex_state = 36, .external_lex_state = 3},
  [4596] = {.lex_state = 249, .external_lex_state = 3},
  [4597] = {.lex_state = 36, .external_lex_state = 3},
  [4598] = {.lex_state = 36, .external_lex_state = 3},
  [4599] = {.lex_state = 36, .external_lex_state = 3},
  [4600] = {.lex_state = 36, .external_lex_state = 3},
  [4601] = {.lex_state = 36, .external_lex_state = 3},
  [4602] = {.lex_state = 36, .external_lex_state = 3},
  [4603] = {.lex_state = 36, .external_lex_state = 3},
  [4604] = {.lex_state = 36, .external_lex_state = 3},
  [4605] = {.lex_state = 36, .external_lex_state = 3},
  [4606] = {.lex_state = 36, .external_lex_state = 3},
  [4607] = {.lex_state = 36, .external_lex_state = 3},
  [4608] = {.lex_state = 36, .external_lex_state = 3},
  [4609] = {.lex_state = 36, .external_lex_state = 3},
  [4610] = {.lex_state = 36, .external_lex_state = 3},
  [4611] = {.lex_state = 36, .external_lex_state = 3},
  [4612] = {.lex_state = 36, .external_lex_state = 3},
  [4613] = {.lex_state = 36, .external_lex_state = 3},
  [4614] = {.lex_state = 36, .external_lex_state = 3},
  [4615] = {.lex_state = 36, .external_lex_state = 3},
  [4616] = {.lex_state = 36, .external_lex_state = 3},
  [4617] = {.lex_state = 249, .external_lex_state = 3},
  [4618] = {.lex_state = 33, .external_lex_state = 3},
  [4619] = {.lex_state = 249, .external_lex_state = 3},
  [4620] = {.lex_state = 36, .external_lex_state = 3},
  [4621] = {.lex_state = 249, .external_lex_state = 3},
  [4622] = {.lex_state = 249, .external_lex_state = 3},
  [4623] = {.lex_state = 249, .external_lex_state = 3},
  [4624] = {.lex_state = 60, .external_lex_state = 3},
  [4625] = {.lex_state = 33, .external_lex_state = 3},
  [4626] = {.lex_state = 513, .external_lex_state = 3},
  [4627] = {.lex_state = 249, .external_lex_state = 3},
  [4628] = {.lex_state = 252, .external_lex_state = 2},
  [4629] = {.lex_state = 249, .external_lex_state = 3},
  [4630] = {.lex_state = 282, .external_lex_state = 3},
  [4631] = {.lex_state = 249, .external_lex_state = 3},
  [4632] = {.lex_state = 33, .external_lex_state = 3},
  [4633] = {.lex_state = 249, .external_lex_state = 3},
  [4634] = {.lex_state = 33, .external_lex_state = 3},
  [4635] = {.lex_state = 249, .external_lex_state = 3},
  [4636] = {.lex_state = 249, .external_lex_state = 3},
  [4637] = {.lex_state = 249, .external_lex_state = 3},
  [4638] = {.lex_state = 249, .external_lex_state = 3},
  [4639] = {.lex_state = 33, .external_lex_state = 3},
  [4640] = {.lex_state = 33, .external_lex_state = 3},
  [4641] = {.lex_state = 513, .external_lex_state = 3},
  [4642] = {.lex_state = 513, .external_lex_state = 3},
  [4643] = {.lex_state = 255, .external_lex_state = 3},
  [4644] = {.lex_state = 255, .external_lex_state = 3},
  [4645] = {.lex_state = 513, .external_lex_state = 3},
  [4646] = {.lex_state = 60, .external_lex_state = 3},
  [4647] = {.lex_state = 513, .external_lex_state = 3},
  [4648] = {.lex_state = 282, .external_lex_state = 3},
  [4649] = {.lex_state = 282, .external_lex_state = 3},
  [4650] = {.lex_state = 33, .external_lex_state = 3},
  [4651] = {.lex_state = 282, .external_lex_state = 3},
  [4652] = {.lex_state = 282, .external_lex_state = 3},
  [4653] = {.lex_state = 2, .external_lex_state = 3},
  [4654] = {.lex_state = 282, .external_lex_state = 3},
  [4655] = {.lex_state = 513, .external_lex_state = 3},
  [4656] = {.lex_state = 33, .external_lex_state = 3},
  [4657] = {.lex_state = 282, .external_lex_state = 3},
  [4658] = {.lex_state = 282, .external_lex_state = 3},
  [4659] = {.lex_state = 282, .external_lex_state = 3},
  [4660] = {.lex_state = 282, .external_lex_state = 3},
  [4661] = {.lex_state = 282, .external_lex_state = 3},
  [4662] = {.lex_state = 282, .external_lex_state = 3},
  [4663] = {.lex_state = 282, .external_lex_state = 3},
  [4664] = {.lex_state = 282, .external_lex_state = 3},
  [4665] = {.lex_state = 282, .external_lex_state = 3},
  [4666] = {.lex_state = 282, .external_lex_state = 3},
  [4667] = {.lex_state = 246, .external_lex_state = 2},
  [4668] = {.lex_state = 60, .external_lex_state = 3},
  [4669] = {.lex_state = 249, .external_lex_state = 3},
  [4670] = {.lex_state = 513, .external_lex_state = 3},
  [4671] = {.lex_state = 282, .external_lex_state = 3},
  [4672] = {.lex_state = 282, .external_lex_state = 3},
  [4673] = {.lex_state = 282, .external_lex_state = 3},
  [4674] = {.lex_state = 33, .external_lex_state = 3},
  [4675] = {.lex_state = 249, .external_lex_state = 3},
  [4676] = {.lex_state = 62, .external_lex_state = 3},
  [4677] = {.lex_state = 252, .external_lex_state = 2},
  [4678] = {.lex_state = 62, .external_lex_state = 3},
  [4679] = {.lex_state = 62, .external_lex_state = 3},
  [4680] = {.lex_state = 249, .external_lex_state = 3},
  [4681] = {.lex_state = 62, .external_lex_state = 3},
  [4682] = {.lex_state = 282, .external_lex_state = 3},
  [4683] = {.lex_state = 33, .external_lex_state = 3},
  [4684] = {.lex_state = 513, .external_lex_state = 3},
  [4685] = {.lex_state = 249, .external_lex_state = 3},
  [4686] = {.lex_state = 513, .external_lex_state = 3},
  [4687] = {.lex_state = 282, .external_lex_state = 3},
  [4688] = {.lex_state = 513, .external_lex_state = 3},
  [4689] = {.lex_state = 282, .external_lex_state = 3},
  [4690] = {.lex_state = 513, .external_lex_state = 3},
  [4691] = {.lex_state = 513, .external_lex_state = 3},
  [4692] = {.lex_state = 36, .external_lex_state = 3},
  [4693] = {.lex_state = 282, .external_lex_state = 3},
  [4694] = {.lex_state = 282, .external_lex_state = 3},
  [4695] = {.lex_state = 282, .external_lex_state = 3},
  [4696] = {.lex_state = 282, .external_lex_state = 3},
  [4697] = {.lex_state = 282, .external_lex_state = 3},
  [4698] = {.lex_state = 513, .external_lex_state = 3},
  [4699] = {.lex_state = 282, .external_lex_state = 3},
  [4700] = {.lex_state = 282, .external_lex_state = 3},
  [4701] = {.lex_state = 282, .external_lex_state = 3},
  [4702] = {.lex_state = 282, .external_lex_state = 3},
  [4703] = {.lex_state = 282, .external_lex_state = 3},
  [4704] = {.lex_state = 255, .external_lex_state = 3},
  [4705] = {.lex_state = 282, .external_lex_state = 3},
  [4706] = {.lex_state = 282, .external_lex_state = 3},
  [4707] = {.lex_state = 282, .external_lex_state = 3},
  [4708] = {.lex_state = 282, .external_lex_state = 3},
  [4709] = {.lex_state = 282, .external_lex_state = 3},
  [4710] = {.lex_state = 282, .external_lex_state = 3},
  [4711] = {.lex_state = 282, .external_lex_state = 3},
  [4712] = {.lex_state = 282, .external_lex_state = 3},
  [4713] = {.lex_state = 282, .external_lex_state = 3},
  [4714] = {.lex_state = 33, .external_lex_state = 3},
  [4715] = {.lex_state = 513, .external_lex_state = 3},
  [4716] = {.lex_state = 33, .external_lex_state = 3},
  [4717] = {.lex_state = 2, .external_lex_state = 2},
  [4718] = {.lex_state = 282, .external_lex_state = 3},
  [4719] = {.lex_state = 513, .external_lex_state = 3},
  [4720] = {.lex_state = 33, .external_lex_state = 3},
  [4721] = {.lex_state = 513, .external_lex_state = 3},
  [4722] = {.lex_state = 246, .external_lex_state = 2},
  [4723] = {.lex_state = 243, .external_lex_state = 3},
  [4724] = {.lex_state = 33, .external_lex_state = 3},
  [4725] = {.lex_state = 513, .external_lex_state = 3},
  [4726] = {.lex_state = 33, .external_lex_state = 3},
  [4727] = {.lex_state = 513, .external_lex_state = 3},
  [4728] = {.lex_state = 36, .external_lex_state = 3},
  [4729] = {.lex_state = 36, .external_lex_state = 3},
  [4730] = {.lex_state = 513, .external_lex_state = 3},
  [4731] = {.lex_state = 33, .external_lex_state = 3},
  [4732] = {.lex_state = 513, .external_lex_state = 3},
  [4733] = {.lex_state = 282, .external_lex_state = 3},
  [4734] = {.lex_state = 33, .external_lex_state = 3},
  [4735] = {.lex_state = 513, .external_lex_state = 3},
  [4736] = {.lex_state = 33, .external_lex_state = 3},
  [4737] = {.lex_state = 33, .external_lex_state = 3},
  [4738] = {.lex_state = 33, .external_lex_state = 3},
  [4739] = {.lex_state = 255, .external_lex_state = 3},
  [4740] = {.lex_state = 33, .external_lex_state = 3},
  [4741] = {.lex_state = 33, .external_lex_state = 3},
  [4742] = {.lex_state = 36, .external_lex_state = 3},
  [4743] = {.lex_state = 36, .external_lex_state = 3},
  [4744] = {.lex_state = 282, .external_lex_state = 3},
  [4745] = {.lex_state = 255, .external_lex_state = 3},
  [4746] = {.lex_state = 249, .external_lex_state = 3},
  [4747] = {.lex_state = 282, .external_lex_state = 3},
  [4748] = {.lex_state = 255, .external_lex_state = 3},
  [4749] = {.lex_state = 33, .external_lex_state = 3},
  [4750] = {.lex_state = 513, .external_lex_state = 3},
  [4751] = {.lex_state = 36, .external_lex_state = 3},
  [4752] = {.lex_state = 36, .external_lex_state = 3},
  [4753] = {.lex_state = 36, .external_lex_state = 3},
  [4754] = {.lex_state = 33, .external_lex_state = 3},
  [4755] = {.lex_state = 33, .external_lex_state = 3},
  [4756] = {.lex_state = 252, .external_lex_state = 2},
  [4757] = {.lex_state = 249, .external_lex_state = 3},
  [4758] = {.lex_state = 249, .external_lex_state = 3},
  [4759] = {.lex_state = 249, .external_lex_state = 3},
  [4760] = {.lex_state = 249, .external_lex_state = 3},
  [4761] = {.lex_state = 249, .external_lex_state = 3},
  [4762] = {.lex_state = 249, .external_lex_state = 3},
  [4763] = {.lex_state = 249, .external_lex_state = 3},
  [4764] = {.lex_state = 249, .external_lex_state = 3},
  [4765] = {.lex_state = 249, .external_lex_state = 3},
  [4766] = {.lex_state = 249, .external_lex_state = 3},
  [4767] = {.lex_state = 249, .external_lex_state = 3},
  [4768] = {.lex_state = 249, .external_lex_state = 3},
  [4769] = {.lex_state = 249, .external_lex_state = 3},
  [4770] = {.lex_state = 249, .external_lex_state = 3},
  [4771] = {.lex_state = 249, .external_lex_state = 3},
  [4772] = {.lex_state = 249, .external_lex_state = 3},
  [4773] = {.lex_state = 249, .external_lex_state = 3},
  [4774] = {.lex_state = 249, .external_lex_state = 3},
  [4775] = {.lex_state = 249, .external_lex_state = 3},
  [4776] = {.lex_state = 249, .external_lex_state = 3},
  [4777] = {.lex_state = 249, .external_lex_state = 3},
  [4778] = {.lex_state = 249, .external_lex_state = 3},
  [4779] = {.lex_state = 33, .external_lex_state = 3},
  [4780] = {.lex_state = 249, .external_lex_state = 3},
  [4781] = {.lex_state = 249, .external_lex_state = 3},
  [4782] = {.lex_state = 249, .external_lex_state = 3},
  [4783] = {.lex_state = 249, .external_lex_state = 3},
  [4784] = {.lex_state = 249, .external_lex_state = 3},
  [4785] = {.lex_state = 249, .external_lex_state = 3},
  [4786] = {.lex_state = 249, .external_lex_state = 3},
  [4787] = {.lex_state = 33, .external_lex_state = 3},
  [4788] = {.lex_state = 282, .external_lex_state = 3},
  [4789] = {.lex_state = 33, .external_lex_state = 3},
  [4790] = {.lex_state = 36, .external_lex_state = 3},
  [4791] = {.lex_state = 33, .external_lex_state = 3},
  [4792] = {.lex_state = 36, .external_lex_state = 3},
  [4793] = {.lex_state = 513, .external_lex_state = 3},
  [4794] = {.lex_state = 249, .external_lex_state = 3},
  [4795] = {.lex_state = 513, .external_lex_state = 3},
  [4796] = {.lex_state = 249, .external_lex_state = 3},
  [4797] = {.lex_state = 36, .external_lex_state = 3},
  [4798] = {.lex_state = 513, .external_lex_state = 3},
  [4799] = {.lex_state = 513, .external_lex_state = 3},
  [4800] = {.lex_state = 282, .external_lex_state = 3},
  [4801] = {.lex_state = 513, .external_lex_state = 3},
  [4802] = {.lex_state = 36, .external_lex_state = 3},
  [4803] = {.lex_state = 249, .external_lex_state = 3},
  [4804] = {.lex_state = 249, .external_lex_state = 3},
  [4805] = {.lex_state = 249, .external_lex_state = 3},
  [4806] = {.lex_state = 252, .external_lex_state = 2},
  [4807] = {.lex_state = 513, .external_lex_state = 3},
  [4808] = {.lex_state = 246, .external_lex_state = 2},
  [4809] = {.lex_state = 33, .external_lex_state = 3},
  [4810] = {.lex_state = 249, .external_lex_state = 3},
  [4811] = {.lex_state = 249, .external_lex_state = 3},
  [4812] = {.lex_state = 249, .external_lex_state = 3},
  [4813] = {.lex_state = 513, .external_lex_state = 3},
  [4814] = {.lex_state = 33, .external_lex_state = 3},
  [4815] = {.lex_state = 513, .external_lex_state = 3},
  [4816] = {.lex_state = 513, .external_lex_state = 3},
  [4817] = {.lex_state = 33, .external_lex_state = 3},
  [4818] = {.lex_state = 33, .external_lex_state = 3},
  [4819] = {.lex_state = 64, .external_lex_state = 3},
  [4820] = {.lex_state = 33, .external_lex_state = 3},
  [4821] = {.lex_state = 286, .external_lex_state = 2},
  [4822] = {.lex_state = 252, .external_lex_state = 2},
  [4823] = {.lex_state = 513, .external_lex_state = 3},
  [4824] = {.lex_state = 33, .external_lex_state = 3},
  [4825] = {.lex_state = 513, .external_lex_state = 3},
  [4826] = {.lex_state = 255, .external_lex_state = 3},
  [4827] = {.lex_state = 513, .external_lex_state = 3},
  [4828] = {.lex_state = 513, .external_lex_state = 3},
  [4829] = {.lex_state = 256, .external_lex_state = 3},
  [4830] = {.lex_state = 33, .external_lex_state = 3},
  [4831] = {.lex_state = 60, .external_lex_state = 3},
  [4832] = {.lex_state = 60, .external_lex_state = 3},
  [4833] = {.lex_state = 33, .external_lex_state = 3},
  [4834] = {.lex_state = 282, .external_lex_state = 3},
  [4835] = {.lex_state = 60, .external_lex_state = 3},
  [4836] = {.lex_state = 513, .external_lex_state = 3},
  [4837] = {.lex_state = 33, .external_lex_state = 3},
  [4838] = {.lex_state = 33, .external_lex_state = 3},
  [4839] = {.lex_state = 33, .external_lex_state = 3},
  [4840] = {.lex_state = 33, .external_lex_state = 3},
  [4841] = {.lex_state = 33, .external_lex_state = 3},
  [4842] = {.lex_state = 33, .external_lex_state = 3},
  [4843] = {.lex_state = 282, .external_lex_state = 3},
  [4844] = {.lex_state = 64, .external_lex_state = 3},
  [4845] = {.lex_state = 246, .external_lex_state = 2},
  [4846] = {.lex_state = 64, .external_lex_state = 3},
  [4847] = {.lex_state = 33, .external_lex_state = 3},
  [4848] = {.lex_state = 282, .external_lex_state = 3},
  [4849] = {.lex_state = 282, .external_lex_state = 3},
  [4850] = {.lex_state = 60, .external_lex_state = 3},
  [4851] = {.lex_state = 60, .external_lex_state = 3},
  [4852] = {.lex_state = 60, .external_lex_state = 3},
  [4853] = {.lex_state = 64, .external_lex_state = 3},
  [4854] = {.lex_state = 513, .external_lex_state = 3},
  [4855] = {.lex_state = 513, .external_lex_state = 3},
  [4856] = {.lex_state = 2, .external_lex_state = 2},
  [4857] = {.lex_state = 2, .external_lex_state = 3},
  [4858] = {.lex_state = 282, .external_lex_state = 3},
  [4859] = {.lex_state = 282, .external_lex_state = 3},
  [4860] = {.lex_state = 8, .external_lex_state = 2},
  [4861] = {.lex_state = 8, .external_lex_state = 2},
  [4862] = {.lex_state = 255, .external_lex_state = 3},
  [4863] = {.lex_state = 255, .external_lex_state = 3},
  [4864] = {.lex_state = 62, .external_lex_state = 3},
  [4865] = {.lex_state = 62, .external_lex_state = 3},
  [4866] = {.lex_state = 282, .external_lex_state = 3},
  [4867] = {.lex_state = 282, .external_lex_state = 3},
  [4868] = {.lex_state = 66, .external_lex_state = 2},
  [4869] = {.lex_state = 69, .external_lex_state = 3},
  [4870] = {.lex_state = 71, .external_lex_state = 2},
  [4871] = {.lex_state = 69, .external_lex_state = 3},
  [4872] = {.lex_state = 255, .external_lex_state = 3},
  [4873] = {.lex_state = 64, .external_lex_state = 3},
  [4874] = {.lex_state = 317, .external_lex_state = 2},
  [4875] = {.lex_state = 64, .external_lex_state = 3},
  [4876] = {.lex_state = 69, .external_lex_state = 3},
  [4877] = {.lex_state = 69, .external_lex_state = 3},
  [4878] = {.lex_state = 255, .external_lex_state = 3},
  [4879] = {.lex_state = 255, .external_lex_state = 3},
  [4880] = {.lex_state = 255, .external_lex_state = 3},
  [4881] = {.lex_state = 74, .external_lex_state = 3},
  [4882] = {.lex_state = 255, .external_lex_state = 3},
  [4883] = {.lex_state = 8, .external_lex_state = 2},
  [4884] = {.lex_state = 74, .external_lex_state = 3},
  [4885] = {.lex_state = 255, .external_lex_state = 3},
  [4886] = {.lex_state = 282, .external_lex_state = 3},
  [4887] = {.lex_state = 255, .external_lex_state = 3},
  [4888] = {.lex_state = 76, .external_lex_state = 3},
  [4889] = {.lex_state = 316, .external_lex_state = 3},
  [4890] = {.lex_state = 255, .external_lex_state = 3},
  [4891] = {.lex_state = 74, .external_lex_state = 3},
  [4892] = {.lex_state = 74, .external_lex_state = 3},
  [4893] = {.lex_state = 255, .external_lex_state = 3},
  [4894] = {.lex_state = 255, .external_lex_state = 3},
  [4895] = {.lex_state = 255, .external_lex_state = 3},
  [4896] = {.lex_state = 255, .external_lex_state = 3},
  [4897] = {.lex_state = 255, .external_lex_state = 3},
  [4898] = {.lex_state = 255, .external_lex_state = 3},
  [4899] = {.lex_state = 64, .external_lex_state = 3},
  [4900] = {.lex_state = 66, .external_lex_state = 2},
  [4901] = {.lex_state = 255, .external_lex_state = 3},
  [4902] = {.lex_state = 316, .external_lex_state = 3},
  [4903] = {.lex_state = 255, .external_lex_state = 3},
  [4904] = {.lex_state = 317, .external_lex_state = 2},
  [4905] = {.lex_state = 255, .external_lex_state = 3},
  [4906] = {.lex_state = 62, .external_lex_state = 3},
  [4907] = {.lex_state = 62, .external_lex_state = 3},
  [4908] = {.lex_state = 62, .external_lex_state = 3},
  [4909] = {.lex_state = 62, .external_lex_state = 3},
  [4910] = {.lex_state = 316, .external_lex_state = 3},
  [4911] = {.lex_state = 62, .external_lex_state = 3},
  [4912] = {.lex_state = 255, .external_lex_state = 3},
  [4913] = {.lex_state = 62, .external_lex_state = 3},
  [4914] = {.lex_state = 62, .external_lex_state = 3},
  [4915] = {.lex_state = 513, .external_lex_state = 3},
  [4916] = {.lex_state = 62, .external_lex_state = 3},
  [4917] = {.lex_state = 62, .external_lex_state = 3},
  [4918] = {.lex_state = 282, .external_lex_state = 3},
  [4919] = {.lex_state = 522, .external_lex_state = 2},
  [4920] = {.lex_state = 62, .external_lex_state = 3},
  [4921] = {.lex_state = 255, .external_lex_state = 3},
  [4922] = {.lex_state = 255, .external_lex_state = 3},
  [4923] = {.lex_state = 282, .external_lex_state = 3},
  [4924] = {.lex_state = 255, .external_lex_state = 3},
  [4925] = {.lex_state = 79, .external_lex_state = 3},
  [4926] = {.lex_state = 258, .external_lex_state = 2},
  [4927] = {.lex_state = 79, .external_lex_state = 3},
  [4928] = {.lex_state = 79, .external_lex_state = 3},
  [4929] = {.lex_state = 255, .external_lex_state = 3},
  [4930] = {.lex_state = 79, .external_lex_state = 3},
  [4931] = {.lex_state = 255, .external_lex_state = 3},
  [4932] = {.lex_state = 288, .external_lex_state = 2},
  [4933] = {.lex_state = 255, .external_lex_state = 3},
  [4934] = {.lex_state = 255, .external_lex_state = 3},
  [4935] = {.lex_state = 522, .external_lex_state = 2},
  [4936] = {.lex_state = 255, .external_lex_state = 3},
  [4937] = {.lex_state = 317, .external_lex_state = 2},
  [4938] = {.lex_state = 81, .external_lex_state = 3},
  [4939] = {.lex_state = 4, .external_lex_state = 2},
  [4940] = {.lex_state = 81, .external_lex_state = 3},
  [4941] = {.lex_state = 71, .external_lex_state = 2},
  [4942] = {.lex_state = 255, .external_lex_state = 3},
  [4943] = {.lex_state = 64, .external_lex_state = 3},
  [4944] = {.lex_state = 64, .external_lex_state = 3},
  [4945] = {.lex_state = 64, .external_lex_state = 3},
  [4946] = {.lex_state = 246, .external_lex_state = 3},
  [4947] = {.lex_state = 246, .external_lex_state = 3},
  [4948] = {.lex_state = 255, .external_lex_state = 3},
  [4949] = {.lex_state = 4, .external_lex_state = 2},
  [4950] = {.lex_state = 83, .external_lex_state = 3},
  [4951] = {.lex_state = 66, .external_lex_state = 2},
  [4952] = {.lex_state = 71, .external_lex_state = 2},
  [4953] = {.lex_state = 83, .external_lex_state = 3},
  [4954] = {.lex_state = 255, .external_lex_state = 3},
  [4955] = {.lex_state = 246, .external_lex_state = 3},
  [4956] = {.lex_state = 83, .external_lex_state = 3},
  [4957] = {.lex_state = 246, .external_lex_state = 3},
  [4958] = {.lex_state = 83, .external_lex_state = 3},
  [4959] = {.lex_state = 4, .external_lex_state = 2},
  [4960] = {.lex_state = 255, .external_lex_state = 3},
  [4961] = {.lex_state = 317, .external_lex_state = 2},
  [4962] = {.lex_state = 255, .external_lex_state = 3},
  [4963] = {.lex_state = 247, .external_lex_state = 3},
  [4964] = {.lex_state = 255, .external_lex_state = 3},
  [4965] = {.lex_state = 255, .external_lex_state = 3},
  [4966] = {.lex_state = 255, .external_lex_state = 3},
  [4967] = {.lex_state = 287, .external_lex_state = 3},
  [4968] = {.lex_state = 288, .external_lex_state = 2},
  [4969] = {.lex_state = 287, .external_lex_state = 3},
  [4970] = {.lex_state = 287, .external_lex_state = 3},
  [4971] = {.lex_state = 66, .external_lex_state = 2},
  [4972] = {.lex_state = 287, .external_lex_state = 3},
  [4973] = {.lex_state = 288, .external_lex_state = 2},
  [4974] = {.lex_state = 255, .external_lex_state = 3},
  [4975] = {.lex_state = 8, .external_lex_state = 2},
  [4976] = {.lex_state = 255, .external_lex_state = 3},
  [4977] = {.lex_state = 64, .external_lex_state = 3},
  [4978] = {.lex_state = 513, .external_lex_state = 3},
  [4979] = {.lex_state = 255, .external_lex_state = 3},
  [4980] = {.lex_state = 258, .external_lex_state = 2},
  [4981] = {.lex_state = 71, .external_lex_state = 2},
  [4982] = {.lex_state = 64, .external_lex_state = 3},
  [4983] = {.lex_state = 64, .external_lex_state = 3},
  [4984] = {.lex_state = 258, .external_lex_state = 2},
  [4985] = {.lex_state = 316, .external_lex_state = 3},
  [4986] = {.lex_state = 64, .external_lex_state = 3},
  [4987] = {.lex_state = 255, .external_lex_state = 3},
  [4988] = {.lex_state = 255, .external_lex_state = 3},
  [4989] = {.lex_state = 513, .external_lex_state = 3},
  [4990] = {.lex_state = 522, .external_lex_state = 2},
  [4991] = {.lex_state = 317, .external_lex_state = 2},
  [4992] = {.lex_state = 253, .external_lex_state = 3},
  [4993] = {.lex_state = 255, .external_lex_state = 3},
  [4994] = {.lex_state = 4, .external_lex_state = 2},
  [4995] = {.lex_state = 258, .external_lex_state = 2},
  [4996] = {.lex_state = 81, .external_lex_state = 3},
  [4997] = {.lex_state = 255, .external_lex_state = 3},
  [4998] = {.lex_state = 85, .external_lex_state = 3},
  [4999] = {.lex_state = 66, .external_lex_state = 2},
  [5000] = {.lex_state = 252, .external_lex_state = 3},
  [5001] = {.lex_state = 252, .external_lex_state = 3},
  [5002] = {.lex_state = 252, .external_lex_state = 3},
  [5003] = {.lex_state = 252, .external_lex_state = 3},
  [5004] = {.lex_state = 255, .external_lex_state = 3},
  [5005] = {.lex_state = 71, .external_lex_state = 2},
  [5006] = {.lex_state = 255, .external_lex_state = 3},
  [5007] = {.lex_state = 513, .external_lex_state = 3},
  [5008] = {.lex_state = 255, .external_lex_state = 3},
  [5009] = {.lex_state = 288, .external_lex_state = 2},
  [5010] = {.lex_state = 258, .external_lex_state = 2},
  [5011] = {.lex_state = 255, .external_lex_state = 3},
  [5012] = {.lex_state = 255, .external_lex_state = 3},
  [5013] = {.lex_state = 255, .external_lex_state = 3},
  [5014] = {.lex_state = 255, .external_lex_state = 3},
  [5015] = {.lex_state = 4, .external_lex_state = 2},
  [5016] = {.lex_state = 255, .external_lex_state = 3},
  [5017] = {.lex_state = 255, .external_lex_state = 3},
  [5018] = {.lex_state = 525, .external_lex_state = 3},
  [5019] = {.lex_state = 522, .external_lex_state = 2},
  [5020] = {.lex_state = 525, .external_lex_state = 3},
  [5021] = {.lex_state = 255, .external_lex_state = 3},
  [5022] = {.lex_state = 255, .external_lex_state = 3},
  [5023] = {.lex_state = 255, .external_lex_state = 3},
  [5024] = {.lex_state = 255, .external_lex_state = 3},
  [5025] = {.lex_state = 255, .external_lex_state = 3},
  [5026] = {.lex_state = 255, .external_lex_state = 3},
  [5027] = {.lex_state = 525, .external_lex_state = 3},
  [5028] = {.lex_state = 81, .external_lex_state = 3},
  [5029] = {.lex_state = 255, .external_lex_state = 3},
  [5030] = {.lex_state = 525, .external_lex_state = 3},
  [5031] = {.lex_state = 8, .external_lex_state = 2},
  [5032] = {.lex_state = 255, .external_lex_state = 3},
  [5033] = {.lex_state = 282, .external_lex_state = 3},
  [5034] = {.lex_state = 64, .external_lex_state = 3},
  [5035] = {.lex_state = 64, .external_lex_state = 3},
  [5036] = {.lex_state = 522, .external_lex_state = 2},
  [5037] = {.lex_state = 255, .external_lex_state = 3},
  [5038] = {.lex_state = 252, .external_lex_state = 3},
  [5039] = {.lex_state = 79, .external_lex_state = 3},
  [5040] = {.lex_state = 316, .external_lex_state = 3},
  [5041] = {.lex_state = 74, .external_lex_state = 3},
  [5042] = {.lex_state = 79, .external_lex_state = 3},
  [5043] = {.lex_state = 8, .external_lex_state = 3},
  [5044] = {.lex_state = 252, .external_lex_state = 3},
  [5045] = {.lex_state = 288, .external_lex_state = 3},
  [5046] = {.lex_state = 17, .external_lex_state = 2},
  [5047] = {.lex_state = 252, .external_lex_state = 3},
  [5048] = {.lex_state = 282, .external_lex_state = 3},
  [5049] = {.lex_state = 83, .external_lex_state = 3},
  [5050] = {.lex_state = 83, .external_lex_state = 3},
  [5051] = {.lex_state = 314, .external_lex_state = 2},
  [5052] = {.lex_state = 313, .external_lex_state = 3},
  [5053] = {.lex_state = 8, .external_lex_state = 3},
  [5054] = {.lex_state = 2, .external_lex_state = 3},
  [5055] = {.lex_state = 8, .external_lex_state = 3},
  [5056] = {.lex_state = 288, .external_lex_state = 3},
  [5057] = {.lex_state = 314, .external_lex_state = 2},
  [5058] = {.lex_state = 525, .external_lex_state = 3},
  [5059] = {.lex_state = 286, .external_lex_state = 3},
  [5060] = {.lex_state = 79, .external_lex_state = 3},
  [5061] = {.lex_state = 246, .external_lex_state = 3},
  [5062] = {.lex_state = 79, .external_lex_state = 3},
  [5063] = {.lex_state = 79, .external_lex_state = 3},
  [5064] = {.lex_state = 527, .external_lex_state = 3},
  [5065] = {.lex_state = 79, .external_lex_state = 3},
  [5066] = {.lex_state = 79, .external_lex_state = 3},
  [5067] = {.lex_state = 79, .external_lex_state = 3},
  [5068] = {.lex_state = 79, .external_lex_state = 3},
  [5069] = {.lex_state = 79, .external_lex_state = 3},
  [5070] = {.lex_state = 79, .external_lex_state = 3},
  [5071] = {.lex_state = 79, .external_lex_state = 3},
  [5072] = {.lex_state = 507, .external_lex_state = 2},
  [5073] = {.lex_state = 83, .external_lex_state = 3},
  [5074] = {.lex_state = 246, .external_lex_state = 3},
  [5075] = {.lex_state = 81, .external_lex_state = 3},
  [5076] = {.lex_state = 81, .external_lex_state = 3},
  [5077] = {.lex_state = 89, .external_lex_state = 3},
  [5078] = {.lex_state = 81, .external_lex_state = 3},
  [5079] = {.lex_state = 74, .external_lex_state = 3},
  [5080] = {.lex_state = 263, .external_lex_state = 2},
  [5081] = {.lex_state = 252, .external_lex_state = 3},
  [5082] = {.lex_state = 252, .external_lex_state = 3},
  [5083] = {.lex_state = 252, .external_lex_state = 3},
  [5084] = {.lex_state = 252, .external_lex_state = 3},
  [5085] = {.lex_state = 252, .external_lex_state = 3},
  [5086] = {.lex_state = 316, .external_lex_state = 3},
  [5087] = {.lex_state = 246, .external_lex_state = 3},
  [5088] = {.lex_state = 81, .external_lex_state = 3},
  [5089] = {.lex_state = 81, .external_lex_state = 3},
  [5090] = {.lex_state = 252, .external_lex_state = 3},
  [5091] = {.lex_state = 17, .external_lex_state = 2},
  [5092] = {.lex_state = 81, .external_lex_state = 3},
  [5093] = {.lex_state = 252, .external_lex_state = 3},
  [5094] = {.lex_state = 246, .external_lex_state = 3},
  [5095] = {.lex_state = 525, .external_lex_state = 3},
  [5096] = {.lex_state = 525, .external_lex_state = 3},
  [5097] = {.lex_state = 81, .external_lex_state = 3},
  [5098] = {.lex_state = 81, .external_lex_state = 3},
  [5099] = {.lex_state = 246, .external_lex_state = 3},
  [5100] = {.lex_state = 91, .external_lex_state = 3},
  [5101] = {.lex_state = 81, .external_lex_state = 3},
  [5102] = {.lex_state = 525, .external_lex_state = 3},
  [5103] = {.lex_state = 93, .external_lex_state = 3},
  [5104] = {.lex_state = 246, .external_lex_state = 3},
  [5105] = {.lex_state = 83, .external_lex_state = 3},
  [5106] = {.lex_state = 74, .external_lex_state = 3},
  [5107] = {.lex_state = 9, .external_lex_state = 3},
  [5108] = {.lex_state = 507, .external_lex_state = 2},
  [5109] = {.lex_state = 83, .external_lex_state = 3},
  [5110] = {.lex_state = 314, .external_lex_state = 2},
  [5111] = {.lex_state = 2, .external_lex_state = 3},
  [5112] = {.lex_state = 12, .external_lex_state = 2},
  [5113] = {.lex_state = 93, .external_lex_state = 3},
  [5114] = {.lex_state = 527, .external_lex_state = 3},
  [5115] = {.lex_state = 246, .external_lex_state = 3},
  [5116] = {.lex_state = 246, .external_lex_state = 3},
  [5117] = {.lex_state = 316, .external_lex_state = 3},
  [5118] = {.lex_state = 83, .external_lex_state = 3},
  [5119] = {.lex_state = 74, .external_lex_state = 3},
  [5120] = {.lex_state = 252, .external_lex_state = 3},
  [5121] = {.lex_state = 316, .external_lex_state = 3},
  [5122] = {.lex_state = 83, .external_lex_state = 3},
  [5123] = {.lex_state = 246, .external_lex_state = 3},
  [5124] = {.lex_state = 74, .external_lex_state = 3},
  [5125] = {.lex_state = 263, .external_lex_state = 2},
  [5126] = {.lex_state = 288, .external_lex_state = 3},
  [5127] = {.lex_state = 239, .external_lex_state = 2},
  [5128] = {.lex_state = 316, .external_lex_state = 3},
  [5129] = {.lex_state = 246, .external_lex_state = 3},
  [5130] = {.lex_state = 12, .external_lex_state = 2},
  [5131] = {.lex_state = 246, .external_lex_state = 3},
  [5132] = {.lex_state = 263, .external_lex_state = 2},
  [5133] = {.lex_state = 513, .external_lex_state = 3},
  [5134] = {.lex_state = 246, .external_lex_state = 3},
  [5135] = {.lex_state = 246, .external_lex_state = 3},
  [5136] = {.lex_state = 252, .external_lex_state = 3},
  [5137] = {.lex_state = 246, .external_lex_state = 3},
  [5138] = {.lex_state = 246, .external_lex_state = 3},
  [5139] = {.lex_state = 246, .external_lex_state = 3},
  [5140] = {.lex_state = 507, .external_lex_state = 2},
  [5141] = {.lex_state = 83, .external_lex_state = 3},
  [5142] = {.lex_state = 74, .external_lex_state = 3},
  [5143] = {.lex_state = 12, .external_lex_state = 2},
  [5144] = {.lex_state = 252, .external_lex_state = 3},
  [5145] = {.lex_state = 252, .external_lex_state = 3},
  [5146] = {.lex_state = 252, .external_lex_state = 3},
  [5147] = {.lex_state = 252, .external_lex_state = 3},
  [5148] = {.lex_state = 74, .external_lex_state = 3},
  [5149] = {.lex_state = 2, .external_lex_state = 3},
  [5150] = {.lex_state = 246, .external_lex_state = 3},
  [5151] = {.lex_state = 95, .external_lex_state = 3},
  [5152] = {.lex_state = 97, .external_lex_state = 3},
  [5153] = {.lex_state = 246, .external_lex_state = 3},
  [5154] = {.lex_state = 246, .external_lex_state = 3},
  [5155] = {.lex_state = 255, .external_lex_state = 3},
  [5156] = {.lex_state = 286, .external_lex_state = 3},
  [5157] = {.lex_state = 288, .external_lex_state = 3},
  [5158] = {.lex_state = 246, .external_lex_state = 3},
  [5159] = {.lex_state = 287, .external_lex_state = 3},
  [5160] = {.lex_state = 287, .external_lex_state = 3},
  [5161] = {.lex_state = 246, .external_lex_state = 3},
  [5162] = {.lex_state = 246, .external_lex_state = 3},
  [5163] = {.lex_state = 252, .external_lex_state = 3},
  [5164] = {.lex_state = 252, .external_lex_state = 3},
  [5165] = {.lex_state = 252, .external_lex_state = 3},
  [5166] = {.lex_state = 252, .external_lex_state = 3},
  [5167] = {.lex_state = 93, .external_lex_state = 3},
  [5168] = {.lex_state = 252, .external_lex_state = 3},
  [5169] = {.lex_state = 252, .external_lex_state = 3},
  [5170] = {.lex_state = 252, .external_lex_state = 3},
  [5171] = {.lex_state = 252, .external_lex_state = 3},
  [5172] = {.lex_state = 252, .external_lex_state = 3},
  [5173] = {.lex_state = 2, .external_lex_state = 3},
  [5174] = {.lex_state = 252, .external_lex_state = 3},
  [5175] = {.lex_state = 252, .external_lex_state = 3},
  [5176] = {.lex_state = 252, .external_lex_state = 3},
  [5177] = {.lex_state = 252, .external_lex_state = 3},
  [5178] = {.lex_state = 252, .external_lex_state = 3},
  [5179] = {.lex_state = 252, .external_lex_state = 3},
  [5180] = {.lex_state = 252, .external_lex_state = 3},
  [5181] = {.lex_state = 287, .external_lex_state = 3},
  [5182] = {.lex_state = 252, .external_lex_state = 3},
  [5183] = {.lex_state = 252, .external_lex_state = 3},
  [5184] = {.lex_state = 252, .external_lex_state = 3},
  [5185] = {.lex_state = 252, .external_lex_state = 3},
  [5186] = {.lex_state = 252, .external_lex_state = 3},
  [5187] = {.lex_state = 252, .external_lex_state = 3},
  [5188] = {.lex_state = 252, .external_lex_state = 3},
  [5189] = {.lex_state = 252, .external_lex_state = 3},
  [5190] = {.lex_state = 252, .external_lex_state = 3},
  [5191] = {.lex_state = 252, .external_lex_state = 3},
  [5192] = {.lex_state = 252, .external_lex_state = 3},
  [5193] = {.lex_state = 252, .external_lex_state = 3},
  [5194] = {.lex_state = 252, .external_lex_state = 3},
  [5195] = {.lex_state = 91, .external_lex_state = 3},
  [5196] = {.lex_state = 287, .external_lex_state = 3},
  [5197] = {.lex_state = 316, .external_lex_state = 3},
  [5198] = {.lex_state = 316, .external_lex_state = 3},
  [5199] = {.lex_state = 246, .external_lex_state = 3},
  [5200] = {.lex_state = 246, .external_lex_state = 3},
  [5201] = {.lex_state = 314, .external_lex_state = 2},
  [5202] = {.lex_state = 252, .external_lex_state = 3},
  [5203] = {.lex_state = 316, .external_lex_state = 3},
  [5204] = {.lex_state = 95, .external_lex_state = 3},
  [5205] = {.lex_state = 91, .external_lex_state = 3},
  [5206] = {.lex_state = 12, .external_lex_state = 2},
  [5207] = {.lex_state = 252, .external_lex_state = 3},
  [5208] = {.lex_state = 246, .external_lex_state = 3},
  [5209] = {.lex_state = 246, .external_lex_state = 3},
  [5210] = {.lex_state = 263, .external_lex_state = 2},
  [5211] = {.lex_state = 525, .external_lex_state = 3},
  [5212] = {.lex_state = 523, .external_lex_state = 3},
  [5213] = {.lex_state = 17, .external_lex_state = 2},
  [5214] = {.lex_state = 239, .external_lex_state = 2},
  [5215] = {.lex_state = 318, .external_lex_state = 3},
  [5216] = {.lex_state = 287, .external_lex_state = 3},
  [5217] = {.lex_state = 17, .external_lex_state = 2},
  [5218] = {.lex_state = 93, .external_lex_state = 3},
  [5219] = {.lex_state = 316, .external_lex_state = 3},
  [5220] = {.lex_state = 525, .external_lex_state = 3},
  [5221] = {.lex_state = 246, .external_lex_state = 3},
  [5222] = {.lex_state = 252, .external_lex_state = 3},
  [5223] = {.lex_state = 316, .external_lex_state = 3},
  [5224] = {.lex_state = 5, .external_lex_state = 3},
  [5225] = {.lex_state = 522, .external_lex_state = 3},
  [5226] = {.lex_state = 316, .external_lex_state = 3},
  [5227] = {.lex_state = 522, .external_lex_state = 3},
  [5228] = {.lex_state = 522, .external_lex_state = 3},
  [5229] = {.lex_state = 522, .external_lex_state = 3},
  [5230] = {.lex_state = 17, .external_lex_state = 2},
  [5231] = {.lex_state = 81, .external_lex_state = 3},
  [5232] = {.lex_state = 252, .external_lex_state = 3},
  [5233] = {.lex_state = 252, .external_lex_state = 3},
  [5234] = {.lex_state = 252, .external_lex_state = 3},
  [5235] = {.lex_state = 507, .external_lex_state = 2},
  [5236] = {.lex_state = 317, .external_lex_state = 3},
  [5237] = {.lex_state = 317, .external_lex_state = 3},
  [5238] = {.lex_state = 317, .external_lex_state = 3},
  [5239] = {.lex_state = 317, .external_lex_state = 3},
  [5240] = {.lex_state = 67, .external_lex_state = 3},
  [5241] = {.lex_state = 252, .external_lex_state = 3},
  [5242] = {.lex_state = 252, .external_lex_state = 3},
  [5243] = {.lex_state = 99, .external_lex_state = 3},
  [5244] = {.lex_state = 239, .external_lex_state = 2},
  [5245] = {.lex_state = 289, .external_lex_state = 3},
  [5246] = {.lex_state = 4, .external_lex_state = 3},
  [5247] = {.lex_state = 4, .external_lex_state = 3},
  [5248] = {.lex_state = 4, .external_lex_state = 3},
  [5249] = {.lex_state = 4, .external_lex_state = 3},
  [5250] = {.lex_state = 99, .external_lex_state = 3},
  [5251] = {.lex_state = 246, .external_lex_state = 3},
  [5252] = {.lex_state = 72, .external_lex_state = 3},
  [5253] = {.lex_state = 286, .external_lex_state = 3},
  [5254] = {.lex_state = 287, .external_lex_state = 3},
  [5255] = {.lex_state = 99, .external_lex_state = 3},
  [5256] = {.lex_state = 246, .external_lex_state = 3},
  [5257] = {.lex_state = 246, .external_lex_state = 3},
  [5258] = {.lex_state = 252, .external_lex_state = 3},
  [5259] = {.lex_state = 83, .external_lex_state = 3},
  [5260] = {.lex_state = 286, .external_lex_state = 3},
  [5261] = {.lex_state = 12, .external_lex_state = 2},
  [5262] = {.lex_state = 66, .external_lex_state = 3},
  [5263] = {.lex_state = 66, .external_lex_state = 3},
  [5264] = {.lex_state = 66, .external_lex_state = 3},
  [5265] = {.lex_state = 66, .external_lex_state = 3},
  [5266] = {.lex_state = 74, .external_lex_state = 3},
  [5267] = {.lex_state = 288, .external_lex_state = 3},
  [5268] = {.lex_state = 288, .external_lex_state = 3},
  [5269] = {.lex_state = 288, .external_lex_state = 3},
  [5270] = {.lex_state = 288, .external_lex_state = 3},
  [5271] = {.lex_state = 287, .external_lex_state = 3},
  [5272] = {.lex_state = 259, .external_lex_state = 3},
  [5273] = {.lex_state = 507, .external_lex_state = 2},
  [5274] = {.lex_state = 313, .external_lex_state = 3},
  [5275] = {.lex_state = 314, .external_lex_state = 2},
  [5276] = {.lex_state = 246, .external_lex_state = 3},
  [5277] = {.lex_state = 287, .external_lex_state = 3},
  [5278] = {.lex_state = 71, .external_lex_state = 3},
  [5279] = {.lex_state = 71, .external_lex_state = 3},
  [5280] = {.lex_state = 71, .external_lex_state = 3},
  [5281] = {.lex_state = 71, .external_lex_state = 3},
  [5282] = {.lex_state = 525, .external_lex_state = 3},
  [5283] = {.lex_state = 99, .external_lex_state = 3},
  [5284] = {.lex_state = 69, .external_lex_state = 3},
  [5285] = {.lex_state = 525, .external_lex_state = 3},
  [5286] = {.lex_state = 83, .external_lex_state = 3},
  [5287] = {.lex_state = 239, .external_lex_state = 2},
  [5288] = {.lex_state = 258, .external_lex_state = 3},
  [5289] = {.lex_state = 287, .external_lex_state = 3},
  [5290] = {.lex_state = 246, .external_lex_state = 3},
  [5291] = {.lex_state = 246, .external_lex_state = 3},
  [5292] = {.lex_state = 258, .external_lex_state = 3},
  [5293] = {.lex_state = 258, .external_lex_state = 3},
  [5294] = {.lex_state = 258, .external_lex_state = 3},
  [5295] = {.lex_state = 101, .external_lex_state = 3},
  [5296] = {.lex_state = 287, .external_lex_state = 3},
  [5297] = {.lex_state = 527, .external_lex_state = 3},
  [5298] = {.lex_state = 316, .external_lex_state = 3},
  [5299] = {.lex_state = 287, .external_lex_state = 3},
  [5300] = {.lex_state = 246, .external_lex_state = 3},
  [5301] = {.lex_state = 69, .external_lex_state = 3},
  [5302] = {.lex_state = 74, .external_lex_state = 3},
  [5303] = {.lex_state = 313, .external_lex_state = 3},
  [5304] = {.lex_state = 2, .external_lex_state = 3},
  [5305] = {.lex_state = 252, .external_lex_state = 3},
  [5306] = {.lex_state = 95, .external_lex_state = 3},
  [5307] = {.lex_state = 2, .external_lex_state = 3},
  [5308] = {.lex_state = 246, .external_lex_state = 3},
  [5309] = {.lex_state = 286, .external_lex_state = 3},
  [5310] = {.lex_state = 527, .external_lex_state = 3},
  [5311] = {.lex_state = 525, .external_lex_state = 3},
  [5312] = {.lex_state = 74, .external_lex_state = 3},
  [5313] = {.lex_state = 246, .external_lex_state = 3},
  [5314] = {.lex_state = 286, .external_lex_state = 3},
  [5315] = {.lex_state = 246, .external_lex_state = 3},
  [5316] = {.lex_state = 95, .external_lex_state = 3},
  [5317] = {.lex_state = 246, .external_lex_state = 3},
  [5318] = {.lex_state = 286, .external_lex_state = 3},
  [5319] = {.lex_state = 246, .external_lex_state = 3},
  [5320] = {.lex_state = 313, .external_lex_state = 3},
  [5321] = {.lex_state = 74, .external_lex_state = 3},
  [5322] = {.lex_state = 8, .external_lex_state = 3},
  [5323] = {.lex_state = 83, .external_lex_state = 3},
  [5324] = {.lex_state = 246, .external_lex_state = 3},
  [5325] = {.lex_state = 246, .external_lex_state = 3},
  [5326] = {.lex_state = 81, .external_lex_state = 3},
  [5327] = {.lex_state = 246, .external_lex_state = 3},
  [5328] = {.lex_state = 288, .external_lex_state = 3},
  [5329] = {.lex_state = 2, .external_lex_state = 3},
  [5330] = {.lex_state = 252, .external_lex_state = 3},
  [5331] = {.lex_state = 246, .external_lex_state = 3},
  [5332] = {.lex_state = 81, .external_lex_state = 3},
  [5333] = {.lex_state = 246, .external_lex_state = 3},
  [5334] = {.lex_state = 246, .external_lex_state = 3},
  [5335] = {.lex_state = 246, .external_lex_state = 3},
  [5336] = {.lex_state = 69, .external_lex_state = 3},
  [5337] = {.lex_state = 69, .external_lex_state = 3},
  [5338] = {.lex_state = 287, .external_lex_state = 3},
  [5339] = {.lex_state = 246, .external_lex_state = 3},
  [5340] = {.lex_state = 239, .external_lex_state = 2},
  [5341] = {.lex_state = 246, .external_lex_state = 3},
  [5342] = {.lex_state = 525, .external_lex_state = 3},
  [5343] = {.lex_state = 69, .external_lex_state = 3},
  [5344] = {.lex_state = 525, .external_lex_state = 3},
  [5345] = {.lex_state = 69, .external_lex_state = 3},
  [5346] = {.lex_state = 69, .external_lex_state = 3},
  [5347] = {.lex_state = 69, .external_lex_state = 3},
  [5348] = {.lex_state = 69, .external_lex_state = 3},
  [5349] = {.lex_state = 246, .external_lex_state = 3},
  [5350] = {.lex_state = 69, .external_lex_state = 3},
  [5351] = {.lex_state = 246, .external_lex_state = 3},
  [5352] = {.lex_state = 246, .external_lex_state = 3},
  [5353] = {.lex_state = 69, .external_lex_state = 3},
  [5354] = {.lex_state = 246, .external_lex_state = 3},
  [5355] = {.lex_state = 69, .external_lex_state = 3},
  [5356] = {.lex_state = 246, .external_lex_state = 3},
  [5357] = {.lex_state = 91, .external_lex_state = 3},
  [5358] = {.lex_state = 246, .external_lex_state = 3},
  [5359] = {.lex_state = 246, .external_lex_state = 3},
  [5360] = {.lex_state = 74, .external_lex_state = 3},
  [5361] = {.lex_state = 246, .external_lex_state = 3},
  [5362] = {.lex_state = 525, .external_lex_state = 3},
  [5363] = {.lex_state = 263, .external_lex_state = 2},
  [5364] = {.lex_state = 83, .external_lex_state = 3},
  [5365] = {.lex_state = 246, .external_lex_state = 3},
  [5366] = {.lex_state = 246, .external_lex_state = 3},
  [5367] = {.lex_state = 252, .external_lex_state = 3},
  [5368] = {.lex_state = 66, .external_lex_state = 3},
  [5369] = {.lex_state = 317, .external_lex_state = 3},
  [5370] = {.lex_state = 71, .external_lex_state = 3},
  [5371] = {.lex_state = 4, .external_lex_state = 3},
  [5372] = {.lex_state = 66, .external_lex_state = 3},
  [5373] = {.lex_state = 66, .external_lex_state = 3},
  [5374] = {.lex_state = 66, .external_lex_state = 3},
  [5375] = {.lex_state = 315, .external_lex_state = 3},
  [5376] = {.lex_state = 66, .external_lex_state = 3},
  [5377] = {.lex_state = 66, .external_lex_state = 3},
  [5378] = {.lex_state = 66, .external_lex_state = 3},
  [5379] = {.lex_state = 258, .external_lex_state = 3},
  [5380] = {.lex_state = 66, .external_lex_state = 3},
  [5381] = {.lex_state = 66, .external_lex_state = 3},
  [5382] = {.lex_state = 66, .external_lex_state = 3},
  [5383] = {.lex_state = 66, .external_lex_state = 3},
  [5384] = {.lex_state = 66, .external_lex_state = 3},
  [5385] = {.lex_state = 66, .external_lex_state = 3},
  [5386] = {.lex_state = 66, .external_lex_state = 3},
  [5387] = {.lex_state = 66, .external_lex_state = 3},
  [5388] = {.lex_state = 66, .external_lex_state = 3},
  [5389] = {.lex_state = 66, .external_lex_state = 3},
  [5390] = {.lex_state = 66, .external_lex_state = 3},
  [5391] = {.lex_state = 66, .external_lex_state = 3},
  [5392] = {.lex_state = 66, .external_lex_state = 3},
  [5393] = {.lex_state = 66, .external_lex_state = 3},
  [5394] = {.lex_state = 66, .external_lex_state = 3},
  [5395] = {.lex_state = 66, .external_lex_state = 3},
  [5396] = {.lex_state = 66, .external_lex_state = 3},
  [5397] = {.lex_state = 66, .external_lex_state = 3},
  [5398] = {.lex_state = 66, .external_lex_state = 3},
  [5399] = {.lex_state = 66, .external_lex_state = 3},
  [5400] = {.lex_state = 66, .external_lex_state = 3},
  [5401] = {.lex_state = 8, .external_lex_state = 3},
  [5402] = {.lex_state = 66, .external_lex_state = 3},
  [5403] = {.lex_state = 66, .external_lex_state = 3},
  [5404] = {.lex_state = 66, .external_lex_state = 3},
  [5405] = {.lex_state = 66, .external_lex_state = 3},
  [5406] = {.lex_state = 8, .external_lex_state = 3},
  [5407] = {.lex_state = 264, .external_lex_state = 3},
  [5408] = {.lex_state = 288, .external_lex_state = 3},
  [5409] = {.lex_state = 288, .external_lex_state = 3},
  [5410] = {.lex_state = 288, .external_lex_state = 3},
  [5411] = {.lex_state = 288, .external_lex_state = 3},
  [5412] = {.lex_state = 288, .external_lex_state = 3},
  [5413] = {.lex_state = 288, .external_lex_state = 3},
  [5414] = {.lex_state = 288, .external_lex_state = 3},
  [5415] = {.lex_state = 288, .external_lex_state = 3},
  [5416] = {.lex_state = 288, .external_lex_state = 3},
  [5417] = {.lex_state = 288, .external_lex_state = 3},
  [5418] = {.lex_state = 288, .external_lex_state = 3},
  [5419] = {.lex_state = 288, .external_lex_state = 3},
  [5420] = {.lex_state = 288, .external_lex_state = 3},
  [5421] = {.lex_state = 288, .external_lex_state = 3},
  [5422] = {.lex_state = 288, .external_lex_state = 3},
  [5423] = {.lex_state = 288, .external_lex_state = 3},
  [5424] = {.lex_state = 288, .external_lex_state = 3},
  [5425] = {.lex_state = 288, .external_lex_state = 3},
  [5426] = {.lex_state = 288, .external_lex_state = 3},
  [5427] = {.lex_state = 288, .external_lex_state = 3},
  [5428] = {.lex_state = 288, .external_lex_state = 3},
  [5429] = {.lex_state = 288, .external_lex_state = 3},
  [5430] = {.lex_state = 288, .external_lex_state = 3},
  [5431] = {.lex_state = 288, .external_lex_state = 3},
  [5432] = {.lex_state = 288, .external_lex_state = 3},
  [5433] = {.lex_state = 288, .external_lex_state = 3},
  [5434] = {.lex_state = 288, .external_lex_state = 3},
  [5435] = {.lex_state = 288, .external_lex_state = 3},
  [5436] = {.lex_state = 288, .external_lex_state = 3},
  [5437] = {.lex_state = 66, .external_lex_state = 3},
  [5438] = {.lex_state = 66, .external_lex_state = 3},
  [5439] = {.lex_state = 71, .external_lex_state = 3},
  [5440] = {.lex_state = 71, .external_lex_state = 3},
  [5441] = {.lex_state = 71, .external_lex_state = 3},
  [5442] = {.lex_state = 288, .external_lex_state = 3},
  [5443] = {.lex_state = 288, .external_lex_state = 3},
  [5444] = {.lex_state = 18, .external_lex_state = 3},
  [5445] = {.lex_state = 71, .external_lex_state = 3},
  [5446] = {.lex_state = 71, .external_lex_state = 3},
  [5447] = {.lex_state = 71, .external_lex_state = 3},
  [5448] = {.lex_state = 71, .external_lex_state = 3},
  [5449] = {.lex_state = 258, .external_lex_state = 3},
  [5450] = {.lex_state = 71, .external_lex_state = 3},
  [5451] = {.lex_state = 71, .external_lex_state = 3},
  [5452] = {.lex_state = 71, .external_lex_state = 3},
  [5453] = {.lex_state = 71, .external_lex_state = 3},
  [5454] = {.lex_state = 71, .external_lex_state = 3},
  [5455] = {.lex_state = 258, .external_lex_state = 3},
  [5456] = {.lex_state = 71, .external_lex_state = 3},
  [5457] = {.lex_state = 71, .external_lex_state = 3},
  [5458] = {.lex_state = 71, .external_lex_state = 3},
  [5459] = {.lex_state = 71, .external_lex_state = 3},
  [5460] = {.lex_state = 71, .external_lex_state = 3},
  [5461] = {.lex_state = 71, .external_lex_state = 3},
  [5462] = {.lex_state = 71, .external_lex_state = 3},
  [5463] = {.lex_state = 71, .external_lex_state = 3},
  [5464] = {.lex_state = 17, .external_lex_state = 3},
  [5465] = {.lex_state = 17, .external_lex_state = 3},
  [5466] = {.lex_state = 71, .external_lex_state = 3},
  [5467] = {.lex_state = 71, .external_lex_state = 3},
  [5468] = {.lex_state = 71, .external_lex_state = 3},
  [5469] = {.lex_state = 71, .external_lex_state = 3},
  [5470] = {.lex_state = 71, .external_lex_state = 3},
  [5471] = {.lex_state = 71, .external_lex_state = 3},
  [5472] = {.lex_state = 258, .external_lex_state = 3},
  [5473] = {.lex_state = 71, .external_lex_state = 3},
  [5474] = {.lex_state = 17, .external_lex_state = 3},
  [5475] = {.lex_state = 71, .external_lex_state = 3},
  [5476] = {.lex_state = 17, .external_lex_state = 3},
  [5477] = {.lex_state = 71, .external_lex_state = 3},
  [5478] = {.lex_state = 71, .external_lex_state = 3},
  [5479] = {.lex_state = 71, .external_lex_state = 3},
  [5480] = {.lex_state = 71, .external_lex_state = 3},
  [5481] = {.lex_state = 522, .external_lex_state = 3},
  [5482] = {.lex_state = 522, .external_lex_state = 3},
  [5483] = {.lex_state = 71, .external_lex_state = 3},
  [5484] = {.lex_state = 71, .external_lex_state = 3},
  [5485] = {.lex_state = 258, .external_lex_state = 3},
  [5486] = {.lex_state = 522, .external_lex_state = 3},
  [5487] = {.lex_state = 288, .external_lex_state = 3},
  [5488] = {.lex_state = 288, .external_lex_state = 3},
  [5489] = {.lex_state = 288, .external_lex_state = 3},
  [5490] = {.lex_state = 317, .external_lex_state = 3},
  [5491] = {.lex_state = 8, .external_lex_state = 3},
  [5492] = {.lex_state = 317, .external_lex_state = 3},
  [5493] = {.lex_state = 522, .external_lex_state = 3},
  [5494] = {.lex_state = 317, .external_lex_state = 3},
  [5495] = {.lex_state = 4, .external_lex_state = 3},
  [5496] = {.lex_state = 4, .external_lex_state = 3},
  [5497] = {.lex_state = 4, .external_lex_state = 3},
  [5498] = {.lex_state = 4, .external_lex_state = 3},
  [5499] = {.lex_state = 258, .external_lex_state = 3},
  [5500] = {.lex_state = 317, .external_lex_state = 3},
  [5501] = {.lex_state = 258, .external_lex_state = 3},
  [5502] = {.lex_state = 258, .external_lex_state = 3},
  [5503] = {.lex_state = 258, .external_lex_state = 3},
  [5504] = {.lex_state = 258, .external_lex_state = 3},
  [5505] = {.lex_state = 258, .external_lex_state = 3},
  [5506] = {.lex_state = 258, .external_lex_state = 3},
  [5507] = {.lex_state = 258, .external_lex_state = 3},
  [5508] = {.lex_state = 258, .external_lex_state = 3},
  [5509] = {.lex_state = 258, .external_lex_state = 3},
  [5510] = {.lex_state = 258, .external_lex_state = 3},
  [5511] = {.lex_state = 258, .external_lex_state = 3},
  [5512] = {.lex_state = 258, .external_lex_state = 3},
  [5513] = {.lex_state = 258, .external_lex_state = 3},
  [5514] = {.lex_state = 258, .external_lex_state = 3},
  [5515] = {.lex_state = 258, .external_lex_state = 3},
  [5516] = {.lex_state = 258, .external_lex_state = 3},
  [5517] = {.lex_state = 258, .external_lex_state = 3},
  [5518] = {.lex_state = 258, .external_lex_state = 3},
  [5519] = {.lex_state = 258, .external_lex_state = 3},
  [5520] = {.lex_state = 258, .external_lex_state = 3},
  [5521] = {.lex_state = 258, .external_lex_state = 3},
  [5522] = {.lex_state = 258, .external_lex_state = 3},
  [5523] = {.lex_state = 258, .external_lex_state = 3},
  [5524] = {.lex_state = 258, .external_lex_state = 3},
  [5525] = {.lex_state = 258, .external_lex_state = 3},
  [5526] = {.lex_state = 258, .external_lex_state = 3},
  [5527] = {.lex_state = 258, .external_lex_state = 3},
  [5528] = {.lex_state = 258, .external_lex_state = 3},
  [5529] = {.lex_state = 258, .external_lex_state = 3},
  [5530] = {.lex_state = 258, .external_lex_state = 3},
  [5531] = {.lex_state = 258, .external_lex_state = 3},
  [5532] = {.lex_state = 258, .external_lex_state = 3},
  [5533] = {.lex_state = 8, .external_lex_state = 3},
  [5534] = {.lex_state = 66, .external_lex_state = 3},
  [5535] = {.lex_state = 66, .external_lex_state = 3},
  [5536] = {.lex_state = 258, .external_lex_state = 3},
  [5537] = {.lex_state = 66, .external_lex_state = 3},
  [5538] = {.lex_state = 66, .external_lex_state = 3},
  [5539] = {.lex_state = 288, .external_lex_state = 3},
  [5540] = {.lex_state = 288, .external_lex_state = 3},
  [5541] = {.lex_state = 288, .external_lex_state = 3},
  [5542] = {.lex_state = 13, .external_lex_state = 3},
  [5543] = {.lex_state = 71, .external_lex_state = 3},
  [5544] = {.lex_state = 71, .external_lex_state = 3},
  [5545] = {.lex_state = 71, .external_lex_state = 3},
  [5546] = {.lex_state = 288, .external_lex_state = 3},
  [5547] = {.lex_state = 71, .external_lex_state = 3},
  [5548] = {.lex_state = 258, .external_lex_state = 3},
  [5549] = {.lex_state = 258, .external_lex_state = 3},
  [5550] = {.lex_state = 258, .external_lex_state = 3},
  [5551] = {.lex_state = 258, .external_lex_state = 3},
  [5552] = {.lex_state = 12, .external_lex_state = 3},
  [5553] = {.lex_state = 12, .external_lex_state = 3},
  [5554] = {.lex_state = 12, .external_lex_state = 3},
  [5555] = {.lex_state = 12, .external_lex_state = 3},
  [5556] = {.lex_state = 240, .external_lex_state = 3},
  [5557] = {.lex_state = 8, .external_lex_state = 3},
  [5558] = {.lex_state = 239, .external_lex_state = 3},
  [5559] = {.lex_state = 239, .external_lex_state = 3},
  [5560] = {.lex_state = 239, .external_lex_state = 3},
  [5561] = {.lex_state = 239, .external_lex_state = 3},
  [5562] = {.lex_state = 8, .external_lex_state = 3},
  [5563] = {.lex_state = 8, .external_lex_state = 3},
  [5564] = {.lex_state = 8, .external_lex_state = 3},
  [5565] = {.lex_state = 8, .external_lex_state = 3},
  [5566] = {.lex_state = 8, .external_lex_state = 3},
  [5567] = {.lex_state = 8, .external_lex_state = 3},
  [5568] = {.lex_state = 8, .external_lex_state = 3},
  [5569] = {.lex_state = 8, .external_lex_state = 3},
  [5570] = {.lex_state = 8, .external_lex_state = 3},
  [5571] = {.lex_state = 8, .external_lex_state = 3},
  [5572] = {.lex_state = 8, .external_lex_state = 3},
  [5573] = {.lex_state = 8, .external_lex_state = 3},
  [5574] = {.lex_state = 8, .external_lex_state = 3},
  [5575] = {.lex_state = 8, .external_lex_state = 3},
  [5576] = {.lex_state = 8, .external_lex_state = 3},
  [5577] = {.lex_state = 8, .external_lex_state = 3},
  [5578] = {.lex_state = 8, .external_lex_state = 3},
  [5579] = {.lex_state = 8, .external_lex_state = 3},
  [5580] = {.lex_state = 511, .external_lex_state = 2},
  [5581] = {.lex_state = 8, .external_lex_state = 3},
  [5582] = {.lex_state = 8, .external_lex_state = 3},
  [5583] = {.lex_state = 8, .external_lex_state = 3},
  [5584] = {.lex_state = 8, .external_lex_state = 3},
  [5585] = {.lex_state = 8, .external_lex_state = 3},
  [5586] = {.lex_state = 255, .external_lex_state = 3},
  [5587] = {.lex_state = 71, .external_lex_state = 3},
  [5588] = {.lex_state = 8, .external_lex_state = 3},
  [5589] = {.lex_state = 8, .external_lex_state = 3},
  [5590] = {.lex_state = 8, .external_lex_state = 3},
  [5591] = {.lex_state = 8, .external_lex_state = 3},
  [5592] = {.lex_state = 8, .external_lex_state = 3},
  [5593] = {.lex_state = 8, .external_lex_state = 3},
  [5594] = {.lex_state = 8, .external_lex_state = 3},
  [5595] = {.lex_state = 8, .external_lex_state = 3},
  [5596] = {.lex_state = 8, .external_lex_state = 3},
  [5597] = {.lex_state = 8, .external_lex_state = 3},
  [5598] = {.lex_state = 8, .external_lex_state = 3},
  [5599] = {.lex_state = 8, .external_lex_state = 3},
  [5600] = {.lex_state = 8, .external_lex_state = 3},
  [5601] = {.lex_state = 8, .external_lex_state = 3},
  [5602] = {.lex_state = 8, .external_lex_state = 3},
  [5603] = {.lex_state = 8, .external_lex_state = 3},
  [5604] = {.lex_state = 8, .external_lex_state = 3},
  [5605] = {.lex_state = 529, .external_lex_state = 3},
  [5606] = {.lex_state = 511, .external_lex_state = 2},
  [5607] = {.lex_state = 258, .external_lex_state = 3},
  [5608] = {.lex_state = 104, .external_lex_state = 3},
  [5609] = {.lex_state = 511, .external_lex_state = 2},
  [5610] = {.lex_state = 104, .external_lex_state = 3},
  [5611] = {.lex_state = 8, .external_lex_state = 3},
  [5612] = {.lex_state = 104, .external_lex_state = 3},
  [5613] = {.lex_state = 8, .external_lex_state = 3},
  [5614] = {.lex_state = 104, .external_lex_state = 3},
  [5615] = {.lex_state = 8, .external_lex_state = 3},
  [5616] = {.lex_state = 527, .external_lex_state = 3},
  [5617] = {.lex_state = 527, .external_lex_state = 3},
  [5618] = {.lex_state = 8, .external_lex_state = 3},
  [5619] = {.lex_state = 527, .external_lex_state = 3},
  [5620] = {.lex_state = 527, .external_lex_state = 3},
  [5621] = {.lex_state = 527, .external_lex_state = 3},
  [5622] = {.lex_state = 527, .external_lex_state = 3},
  [5623] = {.lex_state = 527, .external_lex_state = 3},
  [5624] = {.lex_state = 527, .external_lex_state = 3},
  [5625] = {.lex_state = 527, .external_lex_state = 3},
  [5626] = {.lex_state = 527, .external_lex_state = 3},
  [5627] = {.lex_state = 527, .external_lex_state = 3},
  [5628] = {.lex_state = 527, .external_lex_state = 3},
  [5629] = {.lex_state = 8, .external_lex_state = 3},
  [5630] = {.lex_state = 522, .external_lex_state = 3},
  [5631] = {.lex_state = 313, .external_lex_state = 3},
  [5632] = {.lex_state = 313, .external_lex_state = 3},
  [5633] = {.lex_state = 71, .external_lex_state = 3},
  [5634] = {.lex_state = 91, .external_lex_state = 3},
  [5635] = {.lex_state = 91, .external_lex_state = 3},
  [5636] = {.lex_state = 313, .external_lex_state = 3},
  [5637] = {.lex_state = 313, .external_lex_state = 3},
  [5638] = {.lex_state = 313, .external_lex_state = 3},
  [5639] = {.lex_state = 313, .external_lex_state = 3},
  [5640] = {.lex_state = 313, .external_lex_state = 3},
  [5641] = {.lex_state = 313, .external_lex_state = 3},
  [5642] = {.lex_state = 313, .external_lex_state = 3},
  [5643] = {.lex_state = 313, .external_lex_state = 3},
  [5644] = {.lex_state = 313, .external_lex_state = 3},
  [5645] = {.lex_state = 313, .external_lex_state = 3},
  [5646] = {.lex_state = 8, .external_lex_state = 3},
  [5647] = {.lex_state = 4, .external_lex_state = 3},
  [5648] = {.lex_state = 91, .external_lex_state = 3},
  [5649] = {.lex_state = 91, .external_lex_state = 3},
  [5650] = {.lex_state = 91, .external_lex_state = 3},
  [5651] = {.lex_state = 91, .external_lex_state = 3},
  [5652] = {.lex_state = 91, .external_lex_state = 3},
  [5653] = {.lex_state = 91, .external_lex_state = 3},
  [5654] = {.lex_state = 91, .external_lex_state = 3},
  [5655] = {.lex_state = 91, .external_lex_state = 3},
  [5656] = {.lex_state = 91, .external_lex_state = 3},
  [5657] = {.lex_state = 91, .external_lex_state = 3},
  [5658] = {.lex_state = 511, .external_lex_state = 2},
  [5659] = {.lex_state = 106, .external_lex_state = 3},
  [5660] = {.lex_state = 317, .external_lex_state = 3},
  [5661] = {.lex_state = 95, .external_lex_state = 3},
  [5662] = {.lex_state = 8, .external_lex_state = 3},
  [5663] = {.lex_state = 95, .external_lex_state = 3},
  [5664] = {.lex_state = 522, .external_lex_state = 3},
  [5665] = {.lex_state = 522, .external_lex_state = 3},
  [5666] = {.lex_state = 95, .external_lex_state = 3},
  [5667] = {.lex_state = 522, .external_lex_state = 3},
  [5668] = {.lex_state = 522, .external_lex_state = 3},
  [5669] = {.lex_state = 522, .external_lex_state = 3},
  [5670] = {.lex_state = 522, .external_lex_state = 3},
  [5671] = {.lex_state = 95, .external_lex_state = 3},
  [5672] = {.lex_state = 95, .external_lex_state = 3},
  [5673] = {.lex_state = 95, .external_lex_state = 3},
  [5674] = {.lex_state = 522, .external_lex_state = 3},
  [5675] = {.lex_state = 522, .external_lex_state = 3},
  [5676] = {.lex_state = 95, .external_lex_state = 3},
  [5677] = {.lex_state = 95, .external_lex_state = 3},
  [5678] = {.lex_state = 95, .external_lex_state = 3},
  [5679] = {.lex_state = 522, .external_lex_state = 3},
  [5680] = {.lex_state = 522, .external_lex_state = 3},
  [5681] = {.lex_state = 95, .external_lex_state = 3},
  [5682] = {.lex_state = 95, .external_lex_state = 3},
  [5683] = {.lex_state = 522, .external_lex_state = 3},
  [5684] = {.lex_state = 522, .external_lex_state = 3},
  [5685] = {.lex_state = 95, .external_lex_state = 3},
  [5686] = {.lex_state = 522, .external_lex_state = 3},
  [5687] = {.lex_state = 317, .external_lex_state = 3},
  [5688] = {.lex_state = 71, .external_lex_state = 3},
  [5689] = {.lex_state = 522, .external_lex_state = 3},
  [5690] = {.lex_state = 285, .external_lex_state = 3},
  [5691] = {.lex_state = 522, .external_lex_state = 3},
  [5692] = {.lex_state = 317, .external_lex_state = 3},
  [5693] = {.lex_state = 317, .external_lex_state = 3},
  [5694] = {.lex_state = 317, .external_lex_state = 3},
  [5695] = {.lex_state = 317, .external_lex_state = 3},
  [5696] = {.lex_state = 317, .external_lex_state = 3},
  [5697] = {.lex_state = 8, .external_lex_state = 3},
  [5698] = {.lex_state = 317, .external_lex_state = 3},
  [5699] = {.lex_state = 522, .external_lex_state = 3},
  [5700] = {.lex_state = 317, .external_lex_state = 3},
  [5701] = {.lex_state = 317, .external_lex_state = 3},
  [5702] = {.lex_state = 317, .external_lex_state = 3},
  [5703] = {.lex_state = 317, .external_lex_state = 3},
  [5704] = {.lex_state = 317, .external_lex_state = 3},
  [5705] = {.lex_state = 8, .external_lex_state = 3},
  [5706] = {.lex_state = 4, .external_lex_state = 3},
  [5707] = {.lex_state = 4, .external_lex_state = 3},
  [5708] = {.lex_state = 522, .external_lex_state = 3},
  [5709] = {.lex_state = 4, .external_lex_state = 3},
  [5710] = {.lex_state = 4, .external_lex_state = 3},
  [5711] = {.lex_state = 4, .external_lex_state = 3},
  [5712] = {.lex_state = 4, .external_lex_state = 3},
  [5713] = {.lex_state = 4, .external_lex_state = 3},
  [5714] = {.lex_state = 4, .external_lex_state = 3},
  [5715] = {.lex_state = 4, .external_lex_state = 3},
  [5716] = {.lex_state = 4, .external_lex_state = 3},
  [5717] = {.lex_state = 4, .external_lex_state = 3},
  [5718] = {.lex_state = 4, .external_lex_state = 3},
  [5719] = {.lex_state = 4, .external_lex_state = 3},
  [5720] = {.lex_state = 317, .external_lex_state = 3},
  [5721] = {.lex_state = 317, .external_lex_state = 3},
  [5722] = {.lex_state = 93, .external_lex_state = 3},
  [5723] = {.lex_state = 317, .external_lex_state = 3},
  [5724] = {.lex_state = 93, .external_lex_state = 3},
  [5725] = {.lex_state = 317, .external_lex_state = 3},
  [5726] = {.lex_state = 507, .external_lex_state = 3},
  [5727] = {.lex_state = 507, .external_lex_state = 3},
  [5728] = {.lex_state = 507, .external_lex_state = 3},
  [5729] = {.lex_state = 507, .external_lex_state = 3},
  [5730] = {.lex_state = 66, .external_lex_state = 3},
  [5731] = {.lex_state = 8, .external_lex_state = 3},
  [5732] = {.lex_state = 8, .external_lex_state = 3},
  [5733] = {.lex_state = 66, .external_lex_state = 3},
  [5734] = {.lex_state = 4, .external_lex_state = 3},
  [5735] = {.lex_state = 8, .external_lex_state = 3},
  [5736] = {.lex_state = 93, .external_lex_state = 3},
  [5737] = {.lex_state = 4, .external_lex_state = 3},
  [5738] = {.lex_state = 66, .external_lex_state = 3},
  [5739] = {.lex_state = 66, .external_lex_state = 3},
  [5740] = {.lex_state = 66, .external_lex_state = 3},
  [5741] = {.lex_state = 66, .external_lex_state = 3},
  [5742] = {.lex_state = 93, .external_lex_state = 3},
  [5743] = {.lex_state = 93, .external_lex_state = 3},
  [5744] = {.lex_state = 93, .external_lex_state = 3},
  [5745] = {.lex_state = 66, .external_lex_state = 3},
  [5746] = {.lex_state = 66, .external_lex_state = 3},
  [5747] = {.lex_state = 93, .external_lex_state = 3},
  [5748] = {.lex_state = 93, .external_lex_state = 3},
  [5749] = {.lex_state = 93, .external_lex_state = 3},
  [5750] = {.lex_state = 4, .external_lex_state = 3},
  [5751] = {.lex_state = 66, .external_lex_state = 3},
  [5752] = {.lex_state = 66, .external_lex_state = 3},
  [5753] = {.lex_state = 93, .external_lex_state = 3},
  [5754] = {.lex_state = 93, .external_lex_state = 3},
  [5755] = {.lex_state = 66, .external_lex_state = 3},
  [5756] = {.lex_state = 66, .external_lex_state = 3},
  [5757] = {.lex_state = 93, .external_lex_state = 3},
  [5758] = {.lex_state = 66, .external_lex_state = 3},
  [5759] = {.lex_state = 288, .external_lex_state = 3},
  [5760] = {.lex_state = 288, .external_lex_state = 3},
  [5761] = {.lex_state = 4, .external_lex_state = 3},
  [5762] = {.lex_state = 288, .external_lex_state = 3},
  [5763] = {.lex_state = 288, .external_lex_state = 3},
  [5764] = {.lex_state = 288, .external_lex_state = 3},
  [5765] = {.lex_state = 288, .external_lex_state = 3},
  [5766] = {.lex_state = 288, .external_lex_state = 3},
  [5767] = {.lex_state = 288, .external_lex_state = 3},
  [5768] = {.lex_state = 288, .external_lex_state = 3},
  [5769] = {.lex_state = 288, .external_lex_state = 3},
  [5770] = {.lex_state = 288, .external_lex_state = 3},
  [5771] = {.lex_state = 288, .external_lex_state = 3},
  [5772] = {.lex_state = 288, .external_lex_state = 3},
  [5773] = {.lex_state = 71, .external_lex_state = 3},
  [5774] = {.lex_state = 71, .external_lex_state = 3},
  [5775] = {.lex_state = 66, .external_lex_state = 3},
  [5776] = {.lex_state = 288, .external_lex_state = 3},
  [5777] = {.lex_state = 522, .external_lex_state = 3},
  [5778] = {.lex_state = 522, .external_lex_state = 3},
  [5779] = {.lex_state = 66, .external_lex_state = 3},
  [5780] = {.lex_state = 71, .external_lex_state = 3},
  [5781] = {.lex_state = 71, .external_lex_state = 3},
  [5782] = {.lex_state = 71, .external_lex_state = 3},
  [5783] = {.lex_state = 8, .external_lex_state = 3},
  [5784] = {.lex_state = 71, .external_lex_state = 3},
  [5785] = {.lex_state = 522, .external_lex_state = 3},
  [5786] = {.lex_state = 522, .external_lex_state = 3},
  [5787] = {.lex_state = 4, .external_lex_state = 3},
  [5788] = {.lex_state = 71, .external_lex_state = 3},
  [5789] = {.lex_state = 71, .external_lex_state = 3},
  [5790] = {.lex_state = 66, .external_lex_state = 3},
  [5791] = {.lex_state = 71, .external_lex_state = 3},
  [5792] = {.lex_state = 71, .external_lex_state = 3},
  [5793] = {.lex_state = 71, .external_lex_state = 3},
  [5794] = {.lex_state = 71, .external_lex_state = 3},
  [5795] = {.lex_state = 71, .external_lex_state = 3},
  [5796] = {.lex_state = 511, .external_lex_state = 2},
  [5797] = {.lex_state = 4, .external_lex_state = 3},
  [5798] = {.lex_state = 66, .external_lex_state = 3},
  [5799] = {.lex_state = 317, .external_lex_state = 3},
  [5800] = {.lex_state = 99, .external_lex_state = 3},
  [5801] = {.lex_state = 4, .external_lex_state = 3},
  [5802] = {.lex_state = 99, .external_lex_state = 3},
  [5803] = {.lex_state = 522, .external_lex_state = 3},
  [5804] = {.lex_state = 522, .external_lex_state = 3},
  [5805] = {.lex_state = 522, .external_lex_state = 3},
  [5806] = {.lex_state = 522, .external_lex_state = 3},
  [5807] = {.lex_state = 4, .external_lex_state = 3},
  [5808] = {.lex_state = 522, .external_lex_state = 3},
  [5809] = {.lex_state = 522, .external_lex_state = 3},
  [5810] = {.lex_state = 522, .external_lex_state = 3},
  [5811] = {.lex_state = 522, .external_lex_state = 3},
  [5812] = {.lex_state = 522, .external_lex_state = 3},
  [5813] = {.lex_state = 522, .external_lex_state = 3},
  [5814] = {.lex_state = 522, .external_lex_state = 3},
  [5815] = {.lex_state = 522, .external_lex_state = 3},
  [5816] = {.lex_state = 522, .external_lex_state = 3},
  [5817] = {.lex_state = 522, .external_lex_state = 3},
  [5818] = {.lex_state = 522, .external_lex_state = 3},
  [5819] = {.lex_state = 522, .external_lex_state = 3},
  [5820] = {.lex_state = 522, .external_lex_state = 3},
  [5821] = {.lex_state = 522, .external_lex_state = 3},
  [5822] = {.lex_state = 522, .external_lex_state = 3},
  [5823] = {.lex_state = 522, .external_lex_state = 3},
  [5824] = {.lex_state = 522, .external_lex_state = 3},
  [5825] = {.lex_state = 522, .external_lex_state = 3},
  [5826] = {.lex_state = 522, .external_lex_state = 3},
  [5827] = {.lex_state = 522, .external_lex_state = 3},
  [5828] = {.lex_state = 522, .external_lex_state = 3},
  [5829] = {.lex_state = 522, .external_lex_state = 3},
  [5830] = {.lex_state = 522, .external_lex_state = 3},
  [5831] = {.lex_state = 522, .external_lex_state = 3},
  [5832] = {.lex_state = 522, .external_lex_state = 3},
  [5833] = {.lex_state = 258, .external_lex_state = 3},
  [5834] = {.lex_state = 258, .external_lex_state = 3},
  [5835] = {.lex_state = 99, .external_lex_state = 3},
  [5836] = {.lex_state = 317, .external_lex_state = 3},
  [5837] = {.lex_state = 258, .external_lex_state = 3},
  [5838] = {.lex_state = 258, .external_lex_state = 3},
  [5839] = {.lex_state = 258, .external_lex_state = 3},
  [5840] = {.lex_state = 258, .external_lex_state = 3},
  [5841] = {.lex_state = 99, .external_lex_state = 3},
  [5842] = {.lex_state = 99, .external_lex_state = 3},
  [5843] = {.lex_state = 99, .external_lex_state = 3},
  [5844] = {.lex_state = 317, .external_lex_state = 3},
  [5845] = {.lex_state = 317, .external_lex_state = 3},
  [5846] = {.lex_state = 258, .external_lex_state = 3},
  [5847] = {.lex_state = 258, .external_lex_state = 3},
  [5848] = {.lex_state = 99, .external_lex_state = 3},
  [5849] = {.lex_state = 99, .external_lex_state = 3},
  [5850] = {.lex_state = 99, .external_lex_state = 3},
  [5851] = {.lex_state = 258, .external_lex_state = 3},
  [5852] = {.lex_state = 258, .external_lex_state = 3},
  [5853] = {.lex_state = 99, .external_lex_state = 3},
  [5854] = {.lex_state = 99, .external_lex_state = 3},
  [5855] = {.lex_state = 258, .external_lex_state = 3},
  [5856] = {.lex_state = 258, .external_lex_state = 3},
  [5857] = {.lex_state = 99, .external_lex_state = 3},
  [5858] = {.lex_state = 258, .external_lex_state = 3},
  [5859] = {.lex_state = 288, .external_lex_state = 3},
  [5860] = {.lex_state = 8, .external_lex_state = 3},
  [5861] = {.lex_state = 288, .external_lex_state = 3},
  [5862] = {.lex_state = 314, .external_lex_state = 3},
  [5863] = {.lex_state = 314, .external_lex_state = 3},
  [5864] = {.lex_state = 288, .external_lex_state = 3},
  [5865] = {.lex_state = 314, .external_lex_state = 3},
  [5866] = {.lex_state = 314, .external_lex_state = 3},
  [5867] = {.lex_state = 317, .external_lex_state = 3},
  [5868] = {.lex_state = 317, .external_lex_state = 3},
  [5869] = {.lex_state = 317, .external_lex_state = 3},
  [5870] = {.lex_state = 317, .external_lex_state = 3},
  [5871] = {.lex_state = 288, .external_lex_state = 3},
  [5872] = {.lex_state = 66, .external_lex_state = 3},
  [5873] = {.lex_state = 317, .external_lex_state = 3},
  [5874] = {.lex_state = 317, .external_lex_state = 3},
  [5875] = {.lex_state = 66, .external_lex_state = 3},
  [5876] = {.lex_state = 317, .external_lex_state = 3},
  [5877] = {.lex_state = 317, .external_lex_state = 3},
  [5878] = {.lex_state = 317, .external_lex_state = 3},
  [5879] = {.lex_state = 4, .external_lex_state = 3},
  [5880] = {.lex_state = 317, .external_lex_state = 3},
  [5881] = {.lex_state = 317, .external_lex_state = 3},
  [5882] = {.lex_state = 317, .external_lex_state = 3},
  [5883] = {.lex_state = 317, .external_lex_state = 3},
  [5884] = {.lex_state = 317, .external_lex_state = 3},
  [5885] = {.lex_state = 317, .external_lex_state = 3},
  [5886] = {.lex_state = 317, .external_lex_state = 3},
  [5887] = {.lex_state = 317, .external_lex_state = 3},
  [5888] = {.lex_state = 4, .external_lex_state = 3},
  [5889] = {.lex_state = 4, .external_lex_state = 3},
  [5890] = {.lex_state = 263, .external_lex_state = 3},
  [5891] = {.lex_state = 263, .external_lex_state = 3},
  [5892] = {.lex_state = 317, .external_lex_state = 3},
  [5893] = {.lex_state = 317, .external_lex_state = 3},
  [5894] = {.lex_state = 317, .external_lex_state = 3},
  [5895] = {.lex_state = 317, .external_lex_state = 3},
  [5896] = {.lex_state = 317, .external_lex_state = 3},
  [5897] = {.lex_state = 317, .external_lex_state = 3},
  [5898] = {.lex_state = 317, .external_lex_state = 3},
  [5899] = {.lex_state = 263, .external_lex_state = 3},
  [5900] = {.lex_state = 317, .external_lex_state = 3},
  [5901] = {.lex_state = 263, .external_lex_state = 3},
  [5902] = {.lex_state = 317, .external_lex_state = 3},
  [5903] = {.lex_state = 317, .external_lex_state = 3},
  [5904] = {.lex_state = 317, .external_lex_state = 3},
  [5905] = {.lex_state = 317, .external_lex_state = 3},
  [5906] = {.lex_state = 508, .external_lex_state = 3},
  [5907] = {.lex_state = 4, .external_lex_state = 3},
  [5908] = {.lex_state = 4, .external_lex_state = 3},
  [5909] = {.lex_state = 4, .external_lex_state = 3},
  [5910] = {.lex_state = 4, .external_lex_state = 3},
  [5911] = {.lex_state = 522, .external_lex_state = 3},
  [5912] = {.lex_state = 288, .external_lex_state = 3},
  [5913] = {.lex_state = 4, .external_lex_state = 3},
  [5914] = {.lex_state = 4, .external_lex_state = 3},
  [5915] = {.lex_state = 4, .external_lex_state = 3},
  [5916] = {.lex_state = 4, .external_lex_state = 3},
  [5917] = {.lex_state = 4, .external_lex_state = 3},
  [5918] = {.lex_state = 4, .external_lex_state = 3},
  [5919] = {.lex_state = 4, .external_lex_state = 3},
  [5920] = {.lex_state = 4, .external_lex_state = 3},
  [5921] = {.lex_state = 4, .external_lex_state = 3},
  [5922] = {.lex_state = 4, .external_lex_state = 3},
  [5923] = {.lex_state = 4, .external_lex_state = 3},
  [5924] = {.lex_state = 4, .external_lex_state = 3},
  [5925] = {.lex_state = 4, .external_lex_state = 3},
  [5926] = {.lex_state = 4, .external_lex_state = 3},
  [5927] = {.lex_state = 4, .external_lex_state = 3},
  [5928] = {.lex_state = 4, .external_lex_state = 3},
  [5929] = {.lex_state = 4, .external_lex_state = 3},
  [5930] = {.lex_state = 4, .external_lex_state = 3},
  [5931] = {.lex_state = 4, .external_lex_state = 3},
  [5932] = {.lex_state = 4, .external_lex_state = 3},
  [5933] = {.lex_state = 4, .external_lex_state = 3},
  [5934] = {.lex_state = 4, .external_lex_state = 3},
  [5935] = {.lex_state = 4, .external_lex_state = 3},
  [5936] = {.lex_state = 4, .external_lex_state = 3},
  [5937] = {.lex_state = 4, .external_lex_state = 3},
  [5938] = {.lex_state = 317, .external_lex_state = 3},
  [5939] = {.lex_state = 522, .external_lex_state = 3},
  [5940] = {.lex_state = 71, .external_lex_state = 3},
  [5941] = {.lex_state = 71, .external_lex_state = 3},
  [5942] = {.lex_state = 317, .external_lex_state = 3},
  [5943] = {.lex_state = 263, .external_lex_state = 3},
  [5944] = {.lex_state = 104, .external_lex_state = 3},
  [5945] = {.lex_state = 104, .external_lex_state = 3},
  [5946] = {.lex_state = 104, .external_lex_state = 3},
  [5947] = {.lex_state = 104, .external_lex_state = 3},
  [5948] = {.lex_state = 507, .external_lex_state = 3},
  [5949] = {.lex_state = 108, .external_lex_state = 5},
  [5950] = {.lex_state = 507, .external_lex_state = 3},
  [5951] = {.lex_state = 314, .external_lex_state = 3},
  [5952] = {.lex_state = 17, .external_lex_state = 3},
  [5953] = {.lex_state = 4, .external_lex_state = 3},
  [5954] = {.lex_state = 17, .external_lex_state = 3},
  [5955] = {.lex_state = 239, .external_lex_state = 3},
  [5956] = {.lex_state = 17, .external_lex_state = 3},
  [5957] = {.lex_state = 314, .external_lex_state = 3},
  [5958] = {.lex_state = 507, .external_lex_state = 3},
  [5959] = {.lex_state = 314, .external_lex_state = 3},
  [5960] = {.lex_state = 507, .external_lex_state = 3},
  [5961] = {.lex_state = 507, .external_lex_state = 3},
  [5962] = {.lex_state = 507, .external_lex_state = 3},
  [5963] = {.lex_state = 239, .external_lex_state = 3},
  [5964] = {.lex_state = 314, .external_lex_state = 3},
  [5965] = {.lex_state = 507, .external_lex_state = 3},
  [5966] = {.lex_state = 507, .external_lex_state = 3},
  [5967] = {.lex_state = 507, .external_lex_state = 3},
  [5968] = {.lex_state = 507, .external_lex_state = 3},
  [5969] = {.lex_state = 507, .external_lex_state = 3},
  [5970] = {.lex_state = 314, .external_lex_state = 3},
  [5971] = {.lex_state = 263, .external_lex_state = 3},
  [5972] = {.lex_state = 314, .external_lex_state = 3},
  [5973] = {.lex_state = 314, .external_lex_state = 3},
  [5974] = {.lex_state = 314, .external_lex_state = 3},
  [5975] = {.lex_state = 507, .external_lex_state = 3},
  [5976] = {.lex_state = 507, .external_lex_state = 3},
  [5977] = {.lex_state = 507, .external_lex_state = 3},
  [5978] = {.lex_state = 507, .external_lex_state = 3},
  [5979] = {.lex_state = 507, .external_lex_state = 3},
  [5980] = {.lex_state = 507, .external_lex_state = 3},
  [5981] = {.lex_state = 507, .external_lex_state = 3},
  [5982] = {.lex_state = 507, .external_lex_state = 3},
  [5983] = {.lex_state = 239, .external_lex_state = 3},
  [5984] = {.lex_state = 314, .external_lex_state = 3},
  [5985] = {.lex_state = 314, .external_lex_state = 3},
  [5986] = {.lex_state = 507, .external_lex_state = 3},
  [5987] = {.lex_state = 507, .external_lex_state = 3},
  [5988] = {.lex_state = 507, .external_lex_state = 3},
  [5989] = {.lex_state = 507, .external_lex_state = 3},
  [5990] = {.lex_state = 507, .external_lex_state = 3},
  [5991] = {.lex_state = 507, .external_lex_state = 3},
  [5992] = {.lex_state = 314, .external_lex_state = 3},
  [5993] = {.lex_state = 239, .external_lex_state = 3},
  [5994] = {.lex_state = 314, .external_lex_state = 3},
  [5995] = {.lex_state = 314, .external_lex_state = 3},
  [5996] = {.lex_state = 507, .external_lex_state = 3},
  [5997] = {.lex_state = 507, .external_lex_state = 3},
  [5998] = {.lex_state = 507, .external_lex_state = 3},
  [5999] = {.lex_state = 507, .external_lex_state = 3},
  [6000] = {.lex_state = 314, .external_lex_state = 3},
  [6001] = {.lex_state = 314, .external_lex_state = 3},
  [6002] = {.lex_state = 507, .external_lex_state = 3},
  [6003] = {.lex_state = 507, .external_lex_state = 3},
  [6004] = {.lex_state = 314, .external_lex_state = 3},
  [6005] = {.lex_state = 263, .external_lex_state = 3},
  [6006] = {.lex_state = 263, .external_lex_state = 3},
  [6007] = {.lex_state = 314, .external_lex_state = 3},
  [6008] = {.lex_state = 263, .external_lex_state = 3},
  [6009] = {.lex_state = 263, .external_lex_state = 3},
  [6010] = {.lex_state = 263, .external_lex_state = 3},
  [6011] = {.lex_state = 263, .external_lex_state = 3},
  [6012] = {.lex_state = 263, .external_lex_state = 3},
  [6013] = {.lex_state = 263, .external_lex_state = 3},
  [6014] = {.lex_state = 263, .external_lex_state = 3},
  [6015] = {.lex_state = 263, .external_lex_state = 3},
  [6016] = {.lex_state = 263, .external_lex_state = 3},
  [6017] = {.lex_state = 263, .external_lex_state = 3},
  [6018] = {.lex_state = 263, .external_lex_state = 3},
  [6019] = {.lex_state = 263, .external_lex_state = 3},
  [6020] = {.lex_state = 263, .external_lex_state = 3},
  [6021] = {.lex_state = 263, .external_lex_state = 3},
  [6022] = {.lex_state = 314, .external_lex_state = 3},
  [6023] = {.lex_state = 263, .external_lex_state = 3},
  [6024] = {.lex_state = 239, .external_lex_state = 3},
  [6025] = {.lex_state = 314, .external_lex_state = 3},
  [6026] = {.lex_state = 314, .external_lex_state = 3},
  [6027] = {.lex_state = 239, .external_lex_state = 3},
  [6028] = {.lex_state = 263, .external_lex_state = 3},
  [6029] = {.lex_state = 263, .external_lex_state = 3},
  [6030] = {.lex_state = 314, .external_lex_state = 3},
  [6031] = {.lex_state = 12, .external_lex_state = 3},
  [6032] = {.lex_state = 12, .external_lex_state = 3},
  [6033] = {.lex_state = 314, .external_lex_state = 3},
  [6034] = {.lex_state = 314, .external_lex_state = 3},
  [6035] = {.lex_state = 12, .external_lex_state = 3},
  [6036] = {.lex_state = 12, .external_lex_state = 3},
  [6037] = {.lex_state = 314, .external_lex_state = 3},
  [6038] = {.lex_state = 17, .external_lex_state = 3},
  [6039] = {.lex_state = 314, .external_lex_state = 3},
  [6040] = {.lex_state = 314, .external_lex_state = 3},
  [6041] = {.lex_state = 314, .external_lex_state = 3},
  [6042] = {.lex_state = 12, .external_lex_state = 3},
  [6043] = {.lex_state = 314, .external_lex_state = 3},
  [6044] = {.lex_state = 507, .external_lex_state = 3},
  [6045] = {.lex_state = 314, .external_lex_state = 3},
  [6046] = {.lex_state = 314, .external_lex_state = 3},
  [6047] = {.lex_state = 314, .external_lex_state = 3},
  [6048] = {.lex_state = 314, .external_lex_state = 3},
  [6049] = {.lex_state = 314, .external_lex_state = 3},
  [6050] = {.lex_state = 263, .external_lex_state = 3},
  [6051] = {.lex_state = 314, .external_lex_state = 3},
  [6052] = {.lex_state = 314, .external_lex_state = 3},
  [6053] = {.lex_state = 314, .external_lex_state = 3},
  [6054] = {.lex_state = 314, .external_lex_state = 3},
  [6055] = {.lex_state = 314, .external_lex_state = 3},
  [6056] = {.lex_state = 314, .external_lex_state = 3},
  [6057] = {.lex_state = 314, .external_lex_state = 3},
  [6058] = {.lex_state = 314, .external_lex_state = 3},
  [6059] = {.lex_state = 314, .external_lex_state = 3},
  [6060] = {.lex_state = 263, .external_lex_state = 3},
  [6061] = {.lex_state = 263, .external_lex_state = 3},
  [6062] = {.lex_state = 314, .external_lex_state = 3},
  [6063] = {.lex_state = 314, .external_lex_state = 3},
  [6064] = {.lex_state = 314, .external_lex_state = 3},
  [6065] = {.lex_state = 314, .external_lex_state = 3},
  [6066] = {.lex_state = 314, .external_lex_state = 3},
  [6067] = {.lex_state = 314, .external_lex_state = 3},
  [6068] = {.lex_state = 314, .external_lex_state = 3},
  [6069] = {.lex_state = 314, .external_lex_state = 3},
  [6070] = {.lex_state = 314, .external_lex_state = 3},
  [6071] = {.lex_state = 314, .external_lex_state = 3},
  [6072] = {.lex_state = 314, .external_lex_state = 3},
  [6073] = {.lex_state = 314, .external_lex_state = 3},
  [6074] = {.lex_state = 17, .external_lex_state = 3},
  [6075] = {.lex_state = 263, .external_lex_state = 3},
  [6076] = {.lex_state = 17, .external_lex_state = 3},
  [6077] = {.lex_state = 263, .external_lex_state = 3},
  [6078] = {.lex_state = 263, .external_lex_state = 3},
  [6079] = {.lex_state = 263, .external_lex_state = 3},
  [6080] = {.lex_state = 239, .external_lex_state = 3},
  [6081] = {.lex_state = 17, .external_lex_state = 3},
  [6082] = {.lex_state = 239, .external_lex_state = 3},
  [6083] = {.lex_state = 263, .external_lex_state = 3},
  [6084] = {.lex_state = 263, .external_lex_state = 3},
  [6085] = {.lex_state = 263, .external_lex_state = 3},
  [6086] = {.lex_state = 263, .external_lex_state = 3},
  [6087] = {.lex_state = 263, .external_lex_state = 3},
  [6088] = {.lex_state = 17, .external_lex_state = 3},
  [6089] = {.lex_state = 17, .external_lex_state = 3},
  [6090] = {.lex_state = 17, .external_lex_state = 3},
  [6091] = {.lex_state = 17, .external_lex_state = 3},
  [6092] = {.lex_state = 17, .external_lex_state = 3},
  [6093] = {.lex_state = 263, .external_lex_state = 3},
  [6094] = {.lex_state = 263, .external_lex_state = 3},
  [6095] = {.lex_state = 263, .external_lex_state = 3},
  [6096] = {.lex_state = 263, .external_lex_state = 3},
  [6097] = {.lex_state = 263, .external_lex_state = 3},
  [6098] = {.lex_state = 263, .external_lex_state = 3},
  [6099] = {.lex_state = 263, .external_lex_state = 3},
  [6100] = {.lex_state = 263, .external_lex_state = 3},
  [6101] = {.lex_state = 17, .external_lex_state = 3},
  [6102] = {.lex_state = 17, .external_lex_state = 3},
  [6103] = {.lex_state = 263, .external_lex_state = 3},
  [6104] = {.lex_state = 263, .external_lex_state = 3},
  [6105] = {.lex_state = 263, .external_lex_state = 3},
  [6106] = {.lex_state = 263, .external_lex_state = 3},
  [6107] = {.lex_state = 263, .external_lex_state = 3},
  [6108] = {.lex_state = 263, .external_lex_state = 3},
  [6109] = {.lex_state = 17, .external_lex_state = 3},
  [6110] = {.lex_state = 17, .external_lex_state = 3},
  [6111] = {.lex_state = 17, .external_lex_state = 3},
  [6112] = {.lex_state = 263, .external_lex_state = 3},
  [6113] = {.lex_state = 263, .external_lex_state = 3},
  [6114] = {.lex_state = 263, .external_lex_state = 3},
  [6115] = {.lex_state = 263, .external_lex_state = 3},
  [6116] = {.lex_state = 17, .external_lex_state = 3},
  [6117] = {.lex_state = 17, .external_lex_state = 3},
  [6118] = {.lex_state = 263, .external_lex_state = 3},
  [6119] = {.lex_state = 263, .external_lex_state = 3},
  [6120] = {.lex_state = 17, .external_lex_state = 3},
  [6121] = {.lex_state = 17, .external_lex_state = 3},
  [6122] = {.lex_state = 507, .external_lex_state = 3},
  [6123] = {.lex_state = 314, .external_lex_state = 3},
  [6124] = {.lex_state = 323, .external_lex_state = 2},
  [6125] = {.lex_state = 511, .external_lex_state = 3},
  [6126] = {.lex_state = 511, .external_lex_state = 3},
  [6127] = {.lex_state = 511, .external_lex_state = 3},
  [6128] = {.lex_state = 511, .external_lex_state = 3},
  [6129] = {.lex_state = 323, .external_lex_state = 2},
  [6130] = {.lex_state = 263, .external_lex_state = 3},
  [6131] = {.lex_state = 17, .external_lex_state = 3},
  [6132] = {.lex_state = 17, .external_lex_state = 3},
  [6133] = {.lex_state = 17, .external_lex_state = 3},
  [6134] = {.lex_state = 17, .external_lex_state = 3},
  [6135] = {.lex_state = 17, .external_lex_state = 3},
  [6136] = {.lex_state = 239, .external_lex_state = 3},
  [6137] = {.lex_state = 239, .external_lex_state = 3},
  [6138] = {.lex_state = 239, .external_lex_state = 3},
  [6139] = {.lex_state = 12, .external_lex_state = 3},
  [6140] = {.lex_state = 12, .external_lex_state = 3},
  [6141] = {.lex_state = 12, .external_lex_state = 3},
  [6142] = {.lex_state = 12, .external_lex_state = 3},
  [6143] = {.lex_state = 12, .external_lex_state = 3},
  [6144] = {.lex_state = 12, .external_lex_state = 3},
  [6145] = {.lex_state = 507, .external_lex_state = 3},
  [6146] = {.lex_state = 12, .external_lex_state = 3},
  [6147] = {.lex_state = 12, .external_lex_state = 3},
  [6148] = {.lex_state = 8, .external_lex_state = 3},
  [6149] = {.lex_state = 12, .external_lex_state = 3},
  [6150] = {.lex_state = 12, .external_lex_state = 3},
  [6151] = {.lex_state = 263, .external_lex_state = 3},
  [6152] = {.lex_state = 12, .external_lex_state = 3},
  [6153] = {.lex_state = 12, .external_lex_state = 3},
  [6154] = {.lex_state = 12, .external_lex_state = 3},
  [6155] = {.lex_state = 17, .external_lex_state = 3},
  [6156] = {.lex_state = 17, .external_lex_state = 3},
  [6157] = {.lex_state = 17, .external_lex_state = 3},
  [6158] = {.lex_state = 17, .external_lex_state = 3},
  [6159] = {.lex_state = 17, .external_lex_state = 3},
  [6160] = {.lex_state = 108, .external_lex_state = 5},
  [6161] = {.lex_state = 17, .external_lex_state = 3},
  [6162] = {.lex_state = 17, .external_lex_state = 3},
  [6163] = {.lex_state = 17, .external_lex_state = 3},
  [6164] = {.lex_state = 17, .external_lex_state = 3},
  [6165] = {.lex_state = 17, .external_lex_state = 3},
  [6166] = {.lex_state = 17, .external_lex_state = 3},
  [6167] = {.lex_state = 17, .external_lex_state = 3},
  [6168] = {.lex_state = 17, .external_lex_state = 3},
  [6169] = {.lex_state = 17, .external_lex_state = 3},
  [6170] = {.lex_state = 17, .external_lex_state = 3},
  [6171] = {.lex_state = 17, .external_lex_state = 3},
  [6172] = {.lex_state = 17, .external_lex_state = 3},
  [6173] = {.lex_state = 17, .external_lex_state = 3},
  [6174] = {.lex_state = 17, .external_lex_state = 3},
  [6175] = {.lex_state = 17, .external_lex_state = 3},
  [6176] = {.lex_state = 17, .external_lex_state = 3},
  [6177] = {.lex_state = 17, .external_lex_state = 3},
  [6178] = {.lex_state = 17, .external_lex_state = 3},
  [6179] = {.lex_state = 17, .external_lex_state = 3},
  [6180] = {.lex_state = 17, .external_lex_state = 3},
  [6181] = {.lex_state = 17, .external_lex_state = 3},
  [6182] = {.lex_state = 17, .external_lex_state = 3},
  [6183] = {.lex_state = 17, .external_lex_state = 3},
  [6184] = {.lex_state = 17, .external_lex_state = 3},
  [6185] = {.lex_state = 17, .external_lex_state = 3},
  [6186] = {.lex_state = 314, .external_lex_state = 3},
  [6187] = {.lex_state = 239, .external_lex_state = 3},
  [6188] = {.lex_state = 239, .external_lex_state = 3},
  [6189] = {.lex_state = 239, .external_lex_state = 3},
  [6190] = {.lex_state = 17, .external_lex_state = 3},
  [6191] = {.lex_state = 239, .external_lex_state = 3},
  [6192] = {.lex_state = 239, .external_lex_state = 3},
  [6193] = {.lex_state = 12, .external_lex_state = 3},
  [6194] = {.lex_state = 263, .external_lex_state = 3},
  [6195] = {.lex_state = 12, .external_lex_state = 3},
  [6196] = {.lex_state = 17, .external_lex_state = 3},
  [6197] = {.lex_state = 12, .external_lex_state = 3},
  [6198] = {.lex_state = 12, .external_lex_state = 3},
  [6199] = {.lex_state = 112, .external_lex_state = 5},
  [6200] = {.lex_state = 507, .external_lex_state = 3},
  [6201] = {.lex_state = 263, .external_lex_state = 3},
  [6202] = {.lex_state = 12, .external_lex_state = 3},
  [6203] = {.lex_state = 323, .external_lex_state = 2},
  [6204] = {.lex_state = 12, .external_lex_state = 3},
  [6205] = {.lex_state = 239, .external_lex_state = 3},
  [6206] = {.lex_state = 239, .external_lex_state = 3},
  [6207] = {.lex_state = 239, .external_lex_state = 3},
  [6208] = {.lex_state = 239, .external_lex_state = 3},
  [6209] = {.lex_state = 239, .external_lex_state = 3},
  [6210] = {.lex_state = 239, .external_lex_state = 3},
  [6211] = {.lex_state = 239, .external_lex_state = 3},
  [6212] = {.lex_state = 239, .external_lex_state = 3},
  [6213] = {.lex_state = 239, .external_lex_state = 3},
  [6214] = {.lex_state = 239, .external_lex_state = 3},
  [6215] = {.lex_state = 239, .external_lex_state = 3},
  [6216] = {.lex_state = 239, .external_lex_state = 3},
  [6217] = {.lex_state = 239, .external_lex_state = 3},
  [6218] = {.lex_state = 239, .external_lex_state = 3},
  [6219] = {.lex_state = 239, .external_lex_state = 3},
  [6220] = {.lex_state = 239, .external_lex_state = 3},
  [6221] = {.lex_state = 239, .external_lex_state = 3},
  [6222] = {.lex_state = 239, .external_lex_state = 3},
  [6223] = {.lex_state = 239, .external_lex_state = 3},
  [6224] = {.lex_state = 239, .external_lex_state = 3},
  [6225] = {.lex_state = 239, .external_lex_state = 3},
  [6226] = {.lex_state = 239, .external_lex_state = 3},
  [6227] = {.lex_state = 239, .external_lex_state = 3},
  [6228] = {.lex_state = 239, .external_lex_state = 3},
  [6229] = {.lex_state = 239, .external_lex_state = 3},
  [6230] = {.lex_state = 239, .external_lex_state = 3},
  [6231] = {.lex_state = 239, .external_lex_state = 3},
  [6232] = {.lex_state = 239, .external_lex_state = 3},
  [6233] = {.lex_state = 239, .external_lex_state = 3},
  [6234] = {.lex_state = 239, .external_lex_state = 3},
  [6235] = {.lex_state = 239, .external_lex_state = 3},
  [6236] = {.lex_state = 239, .external_lex_state = 3},
  [6237] = {.lex_state = 8, .external_lex_state = 3},
  [6238] = {.lex_state = 239, .external_lex_state = 3},
  [6239] = {.lex_state = 239, .external_lex_state = 3},
  [6240] = {.lex_state = 239, .external_lex_state = 3},
  [6241] = {.lex_state = 239, .external_lex_state = 3},
  [6242] = {.lex_state = 239, .external_lex_state = 3},
  [6243] = {.lex_state = 239, .external_lex_state = 3},
  [6244] = {.lex_state = 239, .external_lex_state = 3},
  [6245] = {.lex_state = 239, .external_lex_state = 3},
  [6246] = {.lex_state = 268, .external_lex_state = 3},
  [6247] = {.lex_state = 12, .external_lex_state = 3},
  [6248] = {.lex_state = 239, .external_lex_state = 3},
  [6249] = {.lex_state = 12, .external_lex_state = 3},
  [6250] = {.lex_state = 323, .external_lex_state = 2},
  [6251] = {.lex_state = 108, .external_lex_state = 5},
  [6252] = {.lex_state = 112, .external_lex_state = 5},
  [6253] = {.lex_state = 507, .external_lex_state = 3},
  [6254] = {.lex_state = 4, .external_lex_state = 3},
  [6255] = {.lex_state = 17, .external_lex_state = 3},
  [6256] = {.lex_state = 322, .external_lex_state = 3},
  [6257] = {.lex_state = 323, .external_lex_state = 2},
  [6258] = {.lex_state = 322, .external_lex_state = 3},
  [6259] = {.lex_state = 322, .external_lex_state = 3},
  [6260] = {.lex_state = 239, .external_lex_state = 3},
  [6261] = {.lex_state = 322, .external_lex_state = 3},
  [6262] = {.lex_state = 507, .external_lex_state = 3},
  [6263] = {.lex_state = 507, .external_lex_state = 3},
  [6264] = {.lex_state = 104, .external_lex_state = 3},
  [6265] = {.lex_state = 507, .external_lex_state = 3},
  [6266] = {.lex_state = 104, .external_lex_state = 3},
  [6267] = {.lex_state = 112, .external_lex_state = 5},
  [6268] = {.lex_state = 507, .external_lex_state = 3},
  [6269] = {.lex_state = 314, .external_lex_state = 3},
  [6270] = {.lex_state = 507, .external_lex_state = 3},
  [6271] = {.lex_state = 507, .external_lex_state = 3},
  [6272] = {.lex_state = 263, .external_lex_state = 3},
  [6273] = {.lex_state = 507, .external_lex_state = 3},
  [6274] = {.lex_state = 507, .external_lex_state = 3},
  [6275] = {.lex_state = 507, .external_lex_state = 3},
  [6276] = {.lex_state = 507, .external_lex_state = 3},
  [6277] = {.lex_state = 507, .external_lex_state = 3},
  [6278] = {.lex_state = 12, .external_lex_state = 3},
  [6279] = {.lex_state = 507, .external_lex_state = 3},
  [6280] = {.lex_state = 507, .external_lex_state = 3},
  [6281] = {.lex_state = 507, .external_lex_state = 3},
  [6282] = {.lex_state = 239, .external_lex_state = 3},
  [6283] = {.lex_state = 507, .external_lex_state = 3},
  [6284] = {.lex_state = 507, .external_lex_state = 3},
  [6285] = {.lex_state = 507, .external_lex_state = 3},
  [6286] = {.lex_state = 507, .external_lex_state = 3},
  [6287] = {.lex_state = 507, .external_lex_state = 3},
  [6288] = {.lex_state = 507, .external_lex_state = 3},
  [6289] = {.lex_state = 104, .external_lex_state = 3},
  [6290] = {.lex_state = 507, .external_lex_state = 3},
  [6291] = {.lex_state = 104, .external_lex_state = 3},
  [6292] = {.lex_state = 104, .external_lex_state = 3},
  [6293] = {.lex_state = 104, .external_lex_state = 3},
  [6294] = {.lex_state = 507, .external_lex_state = 3},
  [6295] = {.lex_state = 507, .external_lex_state = 3},
  [6296] = {.lex_state = 314, .external_lex_state = 3},
  [6297] = {.lex_state = 104, .external_lex_state = 3},
  [6298] = {.lex_state = 12, .external_lex_state = 3},
  [6299] = {.lex_state = 12, .external_lex_state = 3},
  [6300] = {.lex_state = 12, .external_lex_state = 3},
  [6301] = {.lex_state = 12, .external_lex_state = 3},
  [6302] = {.lex_state = 104, .external_lex_state = 3},
  [6303] = {.lex_state = 12, .external_lex_state = 3},
  [6304] = {.lex_state = 12, .external_lex_state = 3},
  [6305] = {.lex_state = 12, .external_lex_state = 3},
  [6306] = {.lex_state = 12, .external_lex_state = 3},
  [6307] = {.lex_state = 12, .external_lex_state = 3},
  [6308] = {.lex_state = 12, .external_lex_state = 3},
  [6309] = {.lex_state = 12, .external_lex_state = 3},
  [6310] = {.lex_state = 12, .external_lex_state = 3},
  [6311] = {.lex_state = 12, .external_lex_state = 3},
  [6312] = {.lex_state = 12, .external_lex_state = 3},
  [6313] = {.lex_state = 12, .external_lex_state = 3},
  [6314] = {.lex_state = 12, .external_lex_state = 3},
  [6315] = {.lex_state = 12, .external_lex_state = 3},
  [6316] = {.lex_state = 12, .external_lex_state = 3},
  [6317] = {.lex_state = 12, .external_lex_state = 3},
  [6318] = {.lex_state = 12, .external_lex_state = 3},
  [6319] = {.lex_state = 12, .external_lex_state = 3},
  [6320] = {.lex_state = 12, .external_lex_state = 3},
  [6321] = {.lex_state = 12, .external_lex_state = 3},
  [6322] = {.lex_state = 12, .external_lex_state = 3},
  [6323] = {.lex_state = 12, .external_lex_state = 3},
  [6324] = {.lex_state = 12, .external_lex_state = 3},
  [6325] = {.lex_state = 12, .external_lex_state = 3},
  [6326] = {.lex_state = 12, .external_lex_state = 3},
  [6327] = {.lex_state = 12, .external_lex_state = 3},
  [6328] = {.lex_state = 12, .external_lex_state = 3},
  [6329] = {.lex_state = 12, .external_lex_state = 3},
  [6330] = {.lex_state = 12, .external_lex_state = 3},
  [6331] = {.lex_state = 314, .external_lex_state = 3},
  [6332] = {.lex_state = 511, .external_lex_state = 3},
  [6333] = {.lex_state = 511, .external_lex_state = 3},
  [6334] = {.lex_state = 320, .external_lex_state = 2},
  [6335] = {.lex_state = 325, .external_lex_state = 5},
  [6336] = {.lex_state = 12, .external_lex_state = 3},
  [6337] = {.lex_state = 116, .external_lex_state = 5},
  [6338] = {.lex_state = 116, .external_lex_state = 5},
  [6339] = {.lex_state = 114},
  [6340] = {.lex_state = 112},
  [6341] = {.lex_state = 112},
  [6342] = {.lex_state = 112},
  [6343] = {.lex_state = 112},
  [6344] = {.lex_state = 324, .external_lex_state = 3},
  [6345] = {.lex_state = 4, .external_lex_state = 5},
  [6346] = {.lex_state = 120, .external_lex_state = 5},
  [6347] = {.lex_state = 320, .external_lex_state = 2},
  [6348] = {.lex_state = 323, .external_lex_state = 3},
  [6349] = {.lex_state = 323, .external_lex_state = 3},
  [6350] = {.lex_state = 323, .external_lex_state = 3},
  [6351] = {.lex_state = 323, .external_lex_state = 3},
  [6352] = {.lex_state = 124, .external_lex_state = 5},
  [6353] = {.lex_state = 511, .external_lex_state = 3},
  [6354] = {.lex_state = 511, .external_lex_state = 3},
  [6355] = {.lex_state = 531, .external_lex_state = 5},
  [6356] = {.lex_state = 239, .external_lex_state = 3},
  [6357] = {.lex_state = 507, .external_lex_state = 3},
  [6358] = {.lex_state = 319, .external_lex_state = 3},
  [6359] = {.lex_state = 320, .external_lex_state = 2},
  [6360] = {.lex_state = 319, .external_lex_state = 3},
  [6361] = {.lex_state = 4, .external_lex_state = 3},
  [6362] = {.lex_state = 511, .external_lex_state = 3},
  [6363] = {.lex_state = 319, .external_lex_state = 3},
  [6364] = {.lex_state = 8, .external_lex_state = 3},
  [6365] = {.lex_state = 319, .external_lex_state = 3},
  [6366] = {.lex_state = 511, .external_lex_state = 3},
  [6367] = {.lex_state = 511, .external_lex_state = 3},
  [6368] = {.lex_state = 511, .external_lex_state = 3},
  [6369] = {.lex_state = 8, .external_lex_state = 5},
  [6370] = {.lex_state = 511, .external_lex_state = 3},
  [6371] = {.lex_state = 511, .external_lex_state = 3},
  [6372] = {.lex_state = 116, .external_lex_state = 5},
  [6373] = {.lex_state = 511, .external_lex_state = 3},
  [6374] = {.lex_state = 511, .external_lex_state = 3},
  [6375] = {.lex_state = 511, .external_lex_state = 3},
  [6376] = {.lex_state = 239, .external_lex_state = 3},
  [6377] = {.lex_state = 124, .external_lex_state = 5},
  [6378] = {.lex_state = 290, .external_lex_state = 3},
  [6379] = {.lex_state = 4, .external_lex_state = 5},
  [6380] = {.lex_state = 511, .external_lex_state = 3},
  [6381] = {.lex_state = 511, .external_lex_state = 3},
  [6382] = {.lex_state = 511, .external_lex_state = 3},
  [6383] = {.lex_state = 511, .external_lex_state = 3},
  [6384] = {.lex_state = 511, .external_lex_state = 3},
  [6385] = {.lex_state = 322, .external_lex_state = 3},
  [6386] = {.lex_state = 511, .external_lex_state = 3},
  [6387] = {.lex_state = 511, .external_lex_state = 3},
  [6388] = {.lex_state = 322, .external_lex_state = 3},
  [6389] = {.lex_state = 320, .external_lex_state = 2},
  [6390] = {.lex_state = 511, .external_lex_state = 3},
  [6391] = {.lex_state = 511, .external_lex_state = 3},
  [6392] = {.lex_state = 511, .external_lex_state = 3},
  [6393] = {.lex_state = 325, .external_lex_state = 5},
  [6394] = {.lex_state = 511, .external_lex_state = 3},
  [6395] = {.lex_state = 511, .external_lex_state = 3},
  [6396] = {.lex_state = 511, .external_lex_state = 3},
  [6397] = {.lex_state = 511, .external_lex_state = 3},
  [6398] = {.lex_state = 124, .external_lex_state = 5},
  [6399] = {.lex_state = 511, .external_lex_state = 3},
  [6400] = {.lex_state = 314, .external_lex_state = 3},
  [6401] = {.lex_state = 511, .external_lex_state = 3},
  [6402] = {.lex_state = 511, .external_lex_state = 3},
  [6403] = {.lex_state = 511, .external_lex_state = 3},
  [6404] = {.lex_state = 531, .external_lex_state = 5},
  [6405] = {.lex_state = 511, .external_lex_state = 3},
  [6406] = {.lex_state = 12, .external_lex_state = 3},
  [6407] = {.lex_state = 511, .external_lex_state = 3},
  [6408] = {.lex_state = 17, .external_lex_state = 3},
  [6409] = {.lex_state = 511, .external_lex_state = 3},
  [6410] = {.lex_state = 511, .external_lex_state = 3},
  [6411] = {.lex_state = 507, .external_lex_state = 3},
  [6412] = {.lex_state = 511, .external_lex_state = 3},
  [6413] = {.lex_state = 8, .external_lex_state = 5},
  [6414] = {.lex_state = 511, .external_lex_state = 3},
  [6415] = {.lex_state = 8, .external_lex_state = 5},
  [6416] = {.lex_state = 322, .external_lex_state = 3},
  [6417] = {.lex_state = 511, .external_lex_state = 3},
  [6418] = {.lex_state = 511, .external_lex_state = 3},
  [6419] = {.lex_state = 511, .external_lex_state = 3},
  [6420] = {.lex_state = 322, .external_lex_state = 3},
  [6421] = {.lex_state = 322, .external_lex_state = 3},
  [6422] = {.lex_state = 511, .external_lex_state = 3},
  [6423] = {.lex_state = 322, .external_lex_state = 3},
  [6424] = {.lex_state = 511, .external_lex_state = 3},
  [6425] = {.lex_state = 511, .external_lex_state = 3},
  [6426] = {.lex_state = 511, .external_lex_state = 3},
  [6427] = {.lex_state = 120, .external_lex_state = 5},
  [6428] = {.lex_state = 322, .external_lex_state = 3},
  [6429] = {.lex_state = 322, .external_lex_state = 3},
  [6430] = {.lex_state = 120, .external_lex_state = 5},
  [6431] = {.lex_state = 511, .external_lex_state = 3},
  [6432] = {.lex_state = 322, .external_lex_state = 3},
  [6433] = {.lex_state = 511, .external_lex_state = 3},
  [6434] = {.lex_state = 511, .external_lex_state = 3},
  [6435] = {.lex_state = 511, .external_lex_state = 3},
  [6436] = {.lex_state = 511, .external_lex_state = 3},
  [6437] = {.lex_state = 511, .external_lex_state = 3},
  [6438] = {.lex_state = 322, .external_lex_state = 3},
  [6439] = {.lex_state = 322, .external_lex_state = 3},
  [6440] = {.lex_state = 531, .external_lex_state = 5},
  [6441] = {.lex_state = 322, .external_lex_state = 3},
  [6442] = {.lex_state = 511, .external_lex_state = 3},
  [6443] = {.lex_state = 511, .external_lex_state = 3},
  [6444] = {.lex_state = 17, .external_lex_state = 3},
  [6445] = {.lex_state = 314, .external_lex_state = 3},
  [6446] = {.lex_state = 511, .external_lex_state = 3},
  [6447] = {.lex_state = 325, .external_lex_state = 5},
  [6448] = {.lex_state = 108},
  [6449] = {.lex_state = 108},
  [6450] = {.lex_state = 110},
  [6451] = {.lex_state = 511, .external_lex_state = 3},
  [6452] = {.lex_state = 511, .external_lex_state = 3},
  [6453] = {.lex_state = 108},
  [6454] = {.lex_state = 511, .external_lex_state = 3},
  [6455] = {.lex_state = 108},
  [6456] = {.lex_state = 511, .external_lex_state = 3},
  [6457] = {.lex_state = 320, .external_lex_state = 2},
  [6458] = {.lex_state = 4, .external_lex_state = 5},
  [6459] = {.lex_state = 511, .external_lex_state = 3},
  [6460] = {.lex_state = 511, .external_lex_state = 3},
  [6461] = {.lex_state = 108},
  [6462] = {.lex_state = 108},
  [6463] = {.lex_state = 323, .external_lex_state = 3},
  [6464] = {.lex_state = 108},
  [6465] = {.lex_state = 108},
  [6466] = {.lex_state = 323, .external_lex_state = 3},
  [6467] = {.lex_state = 323, .external_lex_state = 3},
  [6468] = {.lex_state = 108},
  [6469] = {.lex_state = 108},
  [6470] = {.lex_state = 118},
  [6471] = {.lex_state = 108},
  [6472] = {.lex_state = 319, .external_lex_state = 3},
  [6473] = {.lex_state = 116},
  [6474] = {.lex_state = 108},
  [6475] = {.lex_state = 116},
  [6476] = {.lex_state = 323, .external_lex_state = 3},
  [6477] = {.lex_state = 323, .external_lex_state = 3},
  [6478] = {.lex_state = 323, .external_lex_state = 3},
  [6479] = {.lex_state = 323, .external_lex_state = 3},
  [6480] = {.lex_state = 319, .external_lex_state = 3},
  [6481] = {.lex_state = 116},
  [6482] = {.lex_state = 323, .external_lex_state = 3},
  [6483] = {.lex_state = 323, .external_lex_state = 3},
  [6484] = {.lex_state = 116},
  [6485] = {.lex_state = 323, .external_lex_state = 3},
  [6486] = {.lex_state = 108},
  [6487] = {.lex_state = 108},
  [6488] = {.lex_state = 531},
  [6489] = {.lex_state = 108},
  [6490] = {.lex_state = 323, .external_lex_state = 3},
  [6491] = {.lex_state = 321, .external_lex_state = 3},
  [6492] = {.lex_state = 323, .external_lex_state = 3},
  [6493] = {.lex_state = 239, .external_lex_state = 5},
  [6494] = {.lex_state = 17, .external_lex_state = 5},
  [6495] = {.lex_state = 323, .external_lex_state = 3},
  [6496] = {.lex_state = 112},
  [6497] = {.lex_state = 323, .external_lex_state = 3},
  [6498] = {.lex_state = 323, .external_lex_state = 3},
  [6499] = {.lex_state = 323, .external_lex_state = 3},
  [6500] = {.lex_state = 112},
  [6501] = {.lex_state = 323, .external_lex_state = 3},
  [6502] = {.lex_state = 112},
  [6503] = {.lex_state = 108},
  [6504] = {.lex_state = 4},
  [6505] = {.lex_state = 112},
  [6506] = {.lex_state = 323, .external_lex_state = 3},
  [6507] = {.lex_state = 4},
  [6508] = {.lex_state = 112},
  [6509] = {.lex_state = 112},
  [6510] = {.lex_state = 112},
  [6511] = {.lex_state = 112},
  [6512] = {.lex_state = 4},
  [6513] = {.lex_state = 323, .external_lex_state = 3},
  [6514] = {.lex_state = 4},
  [6515] = {.lex_state = 122},
  [6516] = {.lex_state = 112},
  [6517] = {.lex_state = 323, .external_lex_state = 3},
  [6518] = {.lex_state = 323, .external_lex_state = 3},
  [6519] = {.lex_state = 108},
  [6520] = {.lex_state = 108},
  [6521] = {.lex_state = 329},
  [6522] = {.lex_state = 112},
  [6523] = {.lex_state = 323, .external_lex_state = 3},
  [6524] = {.lex_state = 323, .external_lex_state = 3},
  [6525] = {.lex_state = 323, .external_lex_state = 3},
  [6526] = {.lex_state = 108},
  [6527] = {.lex_state = 12, .external_lex_state = 3},
  [6528] = {.lex_state = 319, .external_lex_state = 3},
  [6529] = {.lex_state = 531},
  [6530] = {.lex_state = 112},
  [6531] = {.lex_state = 323, .external_lex_state = 3},
  [6532] = {.lex_state = 323, .external_lex_state = 3},
  [6533] = {.lex_state = 323, .external_lex_state = 3},
  [6534] = {.lex_state = 323, .external_lex_state = 3},
  [6535] = {.lex_state = 323, .external_lex_state = 3},
  [6536] = {.lex_state = 323, .external_lex_state = 3},
  [6537] = {.lex_state = 323, .external_lex_state = 3},
  [6538] = {.lex_state = 319, .external_lex_state = 3},
  [6539] = {.lex_state = 319, .external_lex_state = 3},
  [6540] = {.lex_state = 319, .external_lex_state = 3},
  [6541] = {.lex_state = 531},
  [6542] = {.lex_state = 323, .external_lex_state = 3},
  [6543] = {.lex_state = 323, .external_lex_state = 3},
  [6544] = {.lex_state = 323, .external_lex_state = 3},
  [6545] = {.lex_state = 323, .external_lex_state = 3},
  [6546] = {.lex_state = 108},
  [6547] = {.lex_state = 319, .external_lex_state = 3},
  [6548] = {.lex_state = 319, .external_lex_state = 3},
  [6549] = {.lex_state = 319, .external_lex_state = 3},
  [6550] = {.lex_state = 112},
  [6551] = {.lex_state = 112},
  [6552] = {.lex_state = 323, .external_lex_state = 3},
  [6553] = {.lex_state = 120},
  [6554] = {.lex_state = 323, .external_lex_state = 3},
  [6555] = {.lex_state = 120},
  [6556] = {.lex_state = 12, .external_lex_state = 5},
  [6557] = {.lex_state = 319, .external_lex_state = 3},
  [6558] = {.lex_state = 319, .external_lex_state = 3},
  [6559] = {.lex_state = 323, .external_lex_state = 3},
  [6560] = {.lex_state = 323, .external_lex_state = 3},
  [6561] = {.lex_state = 319, .external_lex_state = 3},
  [6562] = {.lex_state = 323, .external_lex_state = 3},
  [6563] = {.lex_state = 112},
  [6564] = {.lex_state = 112},
  [6565] = {.lex_state = 112},
  [6566] = {.lex_state = 120},
  [6567] = {.lex_state = 112},
  [6568] = {.lex_state = 112},
  [6569] = {.lex_state = 323, .external_lex_state = 3},
  [6570] = {.lex_state = 120},
  [6571] = {.lex_state = 325},
  [6572] = {.lex_state = 314, .external_lex_state = 5},
  [6573] = {.lex_state = 5},
  [6574] = {.lex_state = 112},
  [6575] = {.lex_state = 126},
  [6576] = {.lex_state = 108},
  [6577] = {.lex_state = 112},
  [6578] = {.lex_state = 108},
  [6579] = {.lex_state = 108},
  [6580] = {.lex_state = 323, .external_lex_state = 3},
  [6581] = {.lex_state = 112},
  [6582] = {.lex_state = 112},
  [6583] = {.lex_state = 112},
  [6584] = {.lex_state = 112},
  [6585] = {.lex_state = 325},
  [6586] = {.lex_state = 325},
  [6587] = {.lex_state = 325},
  [6588] = {.lex_state = 112},
  [6589] = {.lex_state = 314, .external_lex_state = 5},
  [6590] = {.lex_state = 112},
  [6591] = {.lex_state = 108},
  [6592] = {.lex_state = 108},
  [6593] = {.lex_state = 323, .external_lex_state = 3},
  [6594] = {.lex_state = 112},
  [6595] = {.lex_state = 112},
  [6596] = {.lex_state = 108},
  [6597] = {.lex_state = 129, .external_lex_state = 5},
  [6598] = {.lex_state = 112},
  [6599] = {.lex_state = 17, .external_lex_state = 5},
  [6600] = {.lex_state = 511, .external_lex_state = 3},
  [6601] = {.lex_state = 112},
  [6602] = {.lex_state = 12, .external_lex_state = 5},
  [6603] = {.lex_state = 108},
  [6604] = {.lex_state = 314, .external_lex_state = 5},
  [6605] = {.lex_state = 507, .external_lex_state = 5},
  [6606] = {.lex_state = 112},
  [6607] = {.lex_state = 533},
  [6608] = {.lex_state = 531},
  [6609] = {.lex_state = 320, .external_lex_state = 3},
  [6610] = {.lex_state = 320, .external_lex_state = 3},
  [6611] = {.lex_state = 320, .external_lex_state = 3},
  [6612] = {.lex_state = 320, .external_lex_state = 3},
  [6613] = {.lex_state = 124},
  [6614] = {.lex_state = 124},
  [6615] = {.lex_state = 108},
  [6616] = {.lex_state = 124},
  [6617] = {.lex_state = 112},
  [6618] = {.lex_state = 124},
  [6619] = {.lex_state = 108},
  [6620] = {.lex_state = 108},
  [6621] = {.lex_state = 323, .external_lex_state = 3},
  [6622] = {.lex_state = 112},
  [6623] = {.lex_state = 108},
  [6624] = {.lex_state = 9},
  [6625] = {.lex_state = 239, .external_lex_state = 5},
  [6626] = {.lex_state = 108},
  [6627] = {.lex_state = 112},
  [6628] = {.lex_state = 323, .external_lex_state = 3},
  [6629] = {.lex_state = 108},
  [6630] = {.lex_state = 112},
  [6631] = {.lex_state = 8},
  [6632] = {.lex_state = 8},
  [6633] = {.lex_state = 323, .external_lex_state = 3},
  [6634] = {.lex_state = 108},
  [6635] = {.lex_state = 108},
  [6636] = {.lex_state = 108},
  [6637] = {.lex_state = 129, .external_lex_state = 5},
  [6638] = {.lex_state = 112},
  [6639] = {.lex_state = 108},
  [6640] = {.lex_state = 108},
  [6641] = {.lex_state = 323, .external_lex_state = 3},
  [6642] = {.lex_state = 108},
  [6643] = {.lex_state = 8},
  [6644] = {.lex_state = 507, .external_lex_state = 5},
  [6645] = {.lex_state = 8},
  [6646] = {.lex_state = 112},
  [6647] = {.lex_state = 323, .external_lex_state = 3},
  [6648] = {.lex_state = 323, .external_lex_state = 3},
  [6649] = {.lex_state = 12, .external_lex_state = 5},
  [6650] = {.lex_state = 115},
  [6651] = {.lex_state = 323, .external_lex_state = 3},
  [6652] = {.lex_state = 108},
  [6653] = {.lex_state = 112},
  [6654] = {.lex_state = 108},
  [6655] = {.lex_state = 112},
  [6656] = {.lex_state = 108},
  [6657] = {.lex_state = 112},
  [6658] = {.lex_state = 129, .external_lex_state = 5},
  [6659] = {.lex_state = 323, .external_lex_state = 3},
  [6660] = {.lex_state = 511, .external_lex_state = 3},
  [6661] = {.lex_state = 108},
  [6662] = {.lex_state = 108},
  [6663] = {.lex_state = 239, .external_lex_state = 3},
  [6664] = {.lex_state = 108},
  [6665] = {.lex_state = 111},
  [6666] = {.lex_state = 108},
  [6667] = {.lex_state = 108},
  [6668] = {.lex_state = 112},
  [6669] = {.lex_state = 112},
  [6670] = {.lex_state = 17, .external_lex_state = 3},
  [6671] = {.lex_state = 108},
  [6672] = {.lex_state = 112},
  [6673] = {.lex_state = 108},
  [6674] = {.lex_state = 112},
  [6675] = {.lex_state = 108},
  [6676] = {.lex_state = 112},
  [6677] = {.lex_state = 323, .external_lex_state = 3},
  [6678] = {.lex_state = 323, .external_lex_state = 3},
  [6679] = {.lex_state = 314, .external_lex_state = 3},
  [6680] = {.lex_state = 108},
  [6681] = {.lex_state = 323, .external_lex_state = 3},
  [6682] = {.lex_state = 112},
  [6683] = {.lex_state = 108},
  [6684] = {.lex_state = 17, .external_lex_state = 5},
  [6685] = {.lex_state = 507, .external_lex_state = 5},
  [6686] = {.lex_state = 323, .external_lex_state = 3},
  [6687] = {.lex_state = 108},
  [6688] = {.lex_state = 112},
  [6689] = {.lex_state = 239, .external_lex_state = 5},
  [6690] = {.lex_state = 284, .external_lex_state = 3},
  [6691] = {.lex_state = 323, .external_lex_state = 3},
  [6692] = {.lex_state = 323, .external_lex_state = 3},
  [6693] = {.lex_state = 112},
  [6694] = {.lex_state = 507, .external_lex_state = 3},
  [6695] = {.lex_state = 108},
  [6696] = {.lex_state = 112},
  [6697] = {.lex_state = 112},
  [6698] = {.lex_state = 120},
  [6699] = {.lex_state = 120},
  [6700] = {.lex_state = 116},
  [6701] = {.lex_state = 325},
  [6702] = {.lex_state = 325},
  [6703] = {.lex_state = 325},
  [6704] = {.lex_state = 4, .external_lex_state = 4},
  [6705] = {.lex_state = 4, .external_lex_state = 4},
  [6706] = {.lex_state = 325},
  [6707] = {.lex_state = 8},
  [6708] = {.lex_state = 8},
  [6709] = {.lex_state = 8},
  [6710] = {.lex_state = 108},
  [6711] = {.lex_state = 123},
  [6712] = {.lex_state = 314},
  [6713] = {.lex_state = 314},
  [6714] = {.lex_state = 314},
  [6715] = {.lex_state = 314},
  [6716] = {.lex_state = 330},
  [6717] = {.lex_state = 511, .external_lex_state = 5},
  [6718] = {.lex_state = 119},
  [6719] = {.lex_state = 120},
  [6720] = {.lex_state = 120},
  [6721] = {.lex_state = 325},
  [6722] = {.lex_state = 8},
  [6723] = {.lex_state = 124},
  [6724] = {.lex_state = 124},
  [6725] = {.lex_state = 120},
  [6726] = {.lex_state = 124},
  [6727] = {.lex_state = 120},
  [6728] = {.lex_state = 131},
  [6729] = {.lex_state = 116},
  [6730] = {.lex_state = 116},
  [6731] = {.lex_state = 120},
  [6732] = {.lex_state = 116},
  [6733] = {.lex_state = 320, .external_lex_state = 3},
  [6734] = {.lex_state = 116},
  [6735] = {.lex_state = 320, .external_lex_state = 3},
  [6736] = {.lex_state = 8},
  [6737] = {.lex_state = 120},
  [6738] = {.lex_state = 320, .external_lex_state = 3},
  [6739] = {.lex_state = 120},
  [6740] = {.lex_state = 120},
  [6741] = {.lex_state = 120},
  [6742] = {.lex_state = 120},
  [6743] = {.lex_state = 120},
  [6744] = {.lex_state = 120},
  [6745] = {.lex_state = 120},
  [6746] = {.lex_state = 120},
  [6747] = {.lex_state = 120},
  [6748] = {.lex_state = 8},
  [6749] = {.lex_state = 8},
  [6750] = {.lex_state = 4},
  [6751] = {.lex_state = 120},
  [6752] = {.lex_state = 120},
  [6753] = {.lex_state = 127},
  [6754] = {.lex_state = 120},
  [6755] = {.lex_state = 120},
  [6756] = {.lex_state = 120},
  [6757] = {.lex_state = 120},
  [6758] = {.lex_state = 120},
  [6759] = {.lex_state = 120},
  [6760] = {.lex_state = 120},
  [6761] = {.lex_state = 120},
  [6762] = {.lex_state = 17},
  [6763] = {.lex_state = 17},
  [6764] = {.lex_state = 17},
  [6765] = {.lex_state = 17},
  [6766] = {.lex_state = 120},
  [6767] = {.lex_state = 120},
  [6768] = {.lex_state = 120},
  [6769] = {.lex_state = 120},
  [6770] = {.lex_state = 325},
  [6771] = {.lex_state = 8},
  [6772] = {.lex_state = 508},
  [6773] = {.lex_state = 8},
  [6774] = {.lex_state = 252},
  [6775] = {.lex_state = 8},
  [6776] = {.lex_state = 8},
  [6777] = {.lex_state = 531},
  [6778] = {.lex_state = 120},
  [6779] = {.lex_state = 120},
  [6780] = {.lex_state = 4},
  [6781] = {.lex_state = 8},
  [6782] = {.lex_state = 8},
  [6783] = {.lex_state = 8},
  [6784] = {.lex_state = 8},
  [6785] = {.lex_state = 8},
  [6786] = {.lex_state = 120},
  [6787] = {.lex_state = 4},
  [6788] = {.lex_state = 8},
  [6789] = {.lex_state = 8},
  [6790] = {.lex_state = 8},
  [6791] = {.lex_state = 8},
  [6792] = {.lex_state = 120},
  [6793] = {.lex_state = 8},
  [6794] = {.lex_state = 8},
  [6795] = {.lex_state = 8},
  [6796] = {.lex_state = 8},
  [6797] = {.lex_state = 120},
  [6798] = {.lex_state = 120},
  [6799] = {.lex_state = 8},
  [6800] = {.lex_state = 8},
  [6801] = {.lex_state = 8, .external_lex_state = 4},
  [6802] = {.lex_state = 8},
  [6803] = {.lex_state = 8},
  [6804] = {.lex_state = 8},
  [6805] = {.lex_state = 8},
  [6806] = {.lex_state = 8},
  [6807] = {.lex_state = 8},
  [6808] = {.lex_state = 8},
  [6809] = {.lex_state = 8},
  [6810] = {.lex_state = 8},
  [6811] = {.lex_state = 8},
  [6812] = {.lex_state = 315},
  [6813] = {.lex_state = 8},
  [6814] = {.lex_state = 108},
  [6815] = {.lex_state = 120},
  [6816] = {.lex_state = 8, .external_lex_state = 4},
  [6817] = {.lex_state = 246},
  [6818] = {.lex_state = 4},
  [6819] = {.lex_state = 116},
  [6820] = {.lex_state = 4},
  [6821] = {.lex_state = 120},
  [6822] = {.lex_state = 120},
  [6823] = {.lex_state = 320, .external_lex_state = 3},
  [6824] = {.lex_state = 18},
  [6825] = {.lex_state = 12},
  [6826] = {.lex_state = 12},
  [6827] = {.lex_state = 12},
  [6828] = {.lex_state = 12},
  [6829] = {.lex_state = 116},
  [6830] = {.lex_state = 511, .external_lex_state = 3},
  [6831] = {.lex_state = 4},
  [6832] = {.lex_state = 13},
  [6833] = {.lex_state = 320, .external_lex_state = 3},
  [6834] = {.lex_state = 116},
  [6835] = {.lex_state = 116},
  [6836] = {.lex_state = 240},
  [6837] = {.lex_state = 116},
  [6838] = {.lex_state = 116},
  [6839] = {.lex_state = 116},
  [6840] = {.lex_state = 116},
  [6841] = {.lex_state = 116},
  [6842] = {.lex_state = 124},
  [6843] = {.lex_state = 116},
  [6844] = {.lex_state = 116},
  [6845] = {.lex_state = 116},
  [6846] = {.lex_state = 116},
  [6847] = {.lex_state = 239},
  [6848] = {.lex_state = 239},
  [6849] = {.lex_state = 239},
  [6850] = {.lex_state = 239},
  [6851] = {.lex_state = 116},
  [6852] = {.lex_state = 116},
  [6853] = {.lex_state = 116},
  [6854] = {.lex_state = 112},
  [6855] = {.lex_state = 4},
  [6856] = {.lex_state = 116},
  [6857] = {.lex_state = 4, .external_lex_state = 4},
  [6858] = {.lex_state = 116},
  [6859] = {.lex_state = 116},
  [6860] = {.lex_state = 112},
  [6861] = {.lex_state = 116},
  [6862] = {.lex_state = 116},
  [6863] = {.lex_state = 116},
  [6864] = {.lex_state = 116},
  [6865] = {.lex_state = 116},
  [6866] = {.lex_state = 116},
  [6867] = {.lex_state = 116},
  [6868] = {.lex_state = 116},
  [6869] = {.lex_state = 120},
  [6870] = {.lex_state = 116},
  [6871] = {.lex_state = 4},
  [6872] = {.lex_state = 116},
  [6873] = {.lex_state = 4},
  [6874] = {.lex_state = 8},
  [6875] = {.lex_state = 11},
  [6876] = {.lex_state = 531},
  [6877] = {.lex_state = 8},
  [6878] = {.lex_state = 531},
  [6879] = {.lex_state = 4},
  [6880] = {.lex_state = 120},
  [6881] = {.lex_state = 4},
  [6882] = {.lex_state = 4},
  [6883] = {.lex_state = 8},
  [6884] = {.lex_state = 116},
  [6885] = {.lex_state = 8},
  [6886] = {.lex_state = 116},
  [6887] = {.lex_state = 120},
  [6888] = {.lex_state = 116},
  [6889] = {.lex_state = 8},
  [6890] = {.lex_state = 108},
  [6891] = {.lex_state = 4},
  [6892] = {.lex_state = 252},
  [6893] = {.lex_state = 4},
  [6894] = {.lex_state = 4},
  [6895] = {.lex_state = 116},
  [6896] = {.lex_state = 124},
  [6897] = {.lex_state = 124},
  [6898] = {.lex_state = 124},
  [6899] = {.lex_state = 4},
  [6900] = {.lex_state = 4},
  [6901] = {.lex_state = 4},
  [6902] = {.lex_state = 325},
  [6903] = {.lex_state = 4},
  [6904] = {.lex_state = 4},
  [6905] = {.lex_state = 4},
  [6906] = {.lex_state = 4},
  [6907] = {.lex_state = 4},
  [6908] = {.lex_state = 8},
  [6909] = {.lex_state = 4},
  [6910] = {.lex_state = 4},
  [6911] = {.lex_state = 124},
  [6912] = {.lex_state = 4},
  [6913] = {.lex_state = 4},
  [6914] = {.lex_state = 4},
  [6915] = {.lex_state = 4},
  [6916] = {.lex_state = 4},
  [6917] = {.lex_state = 4},
  [6918] = {.lex_state = 4},
  [6919] = {.lex_state = 124},
  [6920] = {.lex_state = 531},
  [6921] = {.lex_state = 4},
  [6922] = {.lex_state = 246},
  [6923] = {.lex_state = 4},
  [6924] = {.lex_state = 120},
  [6925] = {.lex_state = 4},
  [6926] = {.lex_state = 4},
  [6927] = {.lex_state = 4},
  [6928] = {.lex_state = 4},
  [6929] = {.lex_state = 116},
  [6930] = {.lex_state = 320, .external_lex_state = 3},
  [6931] = {.lex_state = 325},
  [6932] = {.lex_state = 325},
  [6933] = {.lex_state = 8},
  [6934] = {.lex_state = 320, .external_lex_state = 3},
  [6935] = {.lex_state = 4},
  [6936] = {.lex_state = 7},
  [6937] = {.lex_state = 4},
  [6938] = {.lex_state = 108},
  [6939] = {.lex_state = 320, .external_lex_state = 3},
  [6940] = {.lex_state = 325},
  [6941] = {.lex_state = 8},
  [6942] = {.lex_state = 4},
  [6943] = {.lex_state = 320, .external_lex_state = 3},
  [6944] = {.lex_state = 320, .external_lex_state = 3},
  [6945] = {.lex_state = 320, .external_lex_state = 3},
  [6946] = {.lex_state = 124},
  [6947] = {.lex_state = 124},
  [6948] = {.lex_state = 124},
  [6949] = {.lex_state = 4},
  [6950] = {.lex_state = 320, .external_lex_state = 3},
  [6951] = {.lex_state = 320, .external_lex_state = 3},
  [6952] = {.lex_state = 320, .external_lex_state = 3},
  [6953] = {.lex_state = 325},
  [6954] = {.lex_state = 320, .external_lex_state = 3},
  [6955] = {.lex_state = 320, .external_lex_state = 3},
  [6956] = {.lex_state = 320, .external_lex_state = 3},
  [6957] = {.lex_state = 124},
  [6958] = {.lex_state = 531},
  [6959] = {.lex_state = 246},
  [6960] = {.lex_state = 8, .external_lex_state = 4},
  [6961] = {.lex_state = 4, .external_lex_state = 4},
  [6962] = {.lex_state = 246},
  [6963] = {.lex_state = 531},
  [6964] = {.lex_state = 531},
  [6965] = {.lex_state = 4},
  [6966] = {.lex_state = 4},
  [6967] = {.lex_state = 4},
  [6968] = {.lex_state = 320, .external_lex_state = 3},
  [6969] = {.lex_state = 112},
  [6970] = {.lex_state = 4},
  [6971] = {.lex_state = 252},
  [6972] = {.lex_state = 320, .external_lex_state = 3},
  [6973] = {.lex_state = 320, .external_lex_state = 3},
  [6974] = {.lex_state = 320, .external_lex_state = 3},
  [6975] = {.lex_state = 320, .external_lex_state = 3},
  [6976] = {.lex_state = 320, .external_lex_state = 3},
  [6977] = {.lex_state = 320, .external_lex_state = 3},
  [6978] = {.lex_state = 320, .external_lex_state = 3},
  [6979] = {.lex_state = 320, .external_lex_state = 3},
  [6980] = {.lex_state = 320, .external_lex_state = 3},
  [6981] = {.lex_state = 252},
  [6982] = {.lex_state = 320, .external_lex_state = 3},
  [6983] = {.lex_state = 129},
  [6984] = {.lex_state = 116},
  [6985] = {.lex_state = 129},
  [6986] = {.lex_state = 320, .external_lex_state = 3},
  [6987] = {.lex_state = 320, .external_lex_state = 3},
  [6988] = {.lex_state = 320, .external_lex_state = 3},
  [6989] = {.lex_state = 531},
  [6990] = {.lex_state = 320, .external_lex_state = 3},
  [6991] = {.lex_state = 320, .external_lex_state = 3},
  [6992] = {.lex_state = 531},
  [6993] = {.lex_state = 252},
  [6994] = {.lex_state = 531},
  [6995] = {.lex_state = 531},
  [6996] = {.lex_state = 320, .external_lex_state = 3},
  [6997] = {.lex_state = 4},
  [6998] = {.lex_state = 531},
  [6999] = {.lex_state = 531},
  [7000] = {.lex_state = 531},
  [7001] = {.lex_state = 531},
  [7002] = {.lex_state = 531},
  [7003] = {.lex_state = 325},
  [7004] = {.lex_state = 320, .external_lex_state = 3},
  [7005] = {.lex_state = 129},
  [7006] = {.lex_state = 320, .external_lex_state = 3},
  [7007] = {.lex_state = 531},
  [7008] = {.lex_state = 531},
  [7009] = {.lex_state = 531},
  [7010] = {.lex_state = 531},
  [7011] = {.lex_state = 531},
  [7012] = {.lex_state = 531},
  [7013] = {.lex_state = 531},
  [7014] = {.lex_state = 531},
  [7015] = {.lex_state = 129},
  [7016] = {.lex_state = 320, .external_lex_state = 3},
  [7017] = {.lex_state = 320, .external_lex_state = 3},
  [7018] = {.lex_state = 531},
  [7019] = {.lex_state = 531},
  [7020] = {.lex_state = 531},
  [7021] = {.lex_state = 531},
  [7022] = {.lex_state = 531},
  [7023] = {.lex_state = 531},
  [7024] = {.lex_state = 320, .external_lex_state = 3},
  [7025] = {.lex_state = 320, .external_lex_state = 3},
  [7026] = {.lex_state = 531},
  [7027] = {.lex_state = 531},
  [7028] = {.lex_state = 531},
  [7029] = {.lex_state = 531},
  [7030] = {.lex_state = 531},
  [7031] = {.lex_state = 531},
  [7032] = {.lex_state = 320, .external_lex_state = 3},
  [7033] = {.lex_state = 4, .external_lex_state = 4},
  [7034] = {.lex_state = 320, .external_lex_state = 3},
  [7035] = {.lex_state = 320, .external_lex_state = 3},
  [7036] = {.lex_state = 531},
  [7037] = {.lex_state = 8},
  [7038] = {.lex_state = 325},
  [7039] = {.lex_state = 531},
  [7040] = {.lex_state = 4},
  [7041] = {.lex_state = 320, .external_lex_state = 3},
  [7042] = {.lex_state = 320, .external_lex_state = 3},
  [7043] = {.lex_state = 320, .external_lex_state = 3},
  [7044] = {.lex_state = 320, .external_lex_state = 3},
  [7045] = {.lex_state = 531},
  [7046] = {.lex_state = 531},
  [7047] = {.lex_state = 531},
  [7048] = {.lex_state = 325},
  [7049] = {.lex_state = 325},
  [7050] = {.lex_state = 320, .external_lex_state = 3},
  [7051] = {.lex_state = 320, .external_lex_state = 3},
  [7052] = {.lex_state = 531},
  [7053] = {.lex_state = 320, .external_lex_state = 3},
  [7054] = {.lex_state = 320, .external_lex_state = 3},
  [7055] = {.lex_state = 8},
  [7056] = {.lex_state = 320, .external_lex_state = 3},
  [7057] = {.lex_state = 320, .external_lex_state = 3},
  [7058] = {.lex_state = 320, .external_lex_state = 3},
  [7059] = {.lex_state = 116},
  [7060] = {.lex_state = 531},
  [7061] = {.lex_state = 8},
  [7062] = {.lex_state = 116},
  [7063] = {.lex_state = 320, .external_lex_state = 3},
  [7064] = {.lex_state = 124},
  [7065] = {.lex_state = 108},
  [7066] = {.lex_state = 124},
  [7067] = {.lex_state = 4},
  [7068] = {.lex_state = 124},
  [7069] = {.lex_state = 124},
  [7070] = {.lex_state = 124},
  [7071] = {.lex_state = 8},
  [7072] = {.lex_state = 8},
  [7073] = {.lex_state = 8},
  [7074] = {.lex_state = 8},
  [7075] = {.lex_state = 8},
  [7076] = {.lex_state = 4},
  [7077] = {.lex_state = 4},
  [7078] = {.lex_state = 4},
  [7079] = {.lex_state = 4},
  [7080] = {.lex_state = 8},
  [7081] = {.lex_state = 325},
  [7082] = {.lex_state = 8},
  [7083] = {.lex_state = 4},
  [7084] = {.lex_state = 4},
  [7085] = {.lex_state = 4},
  [7086] = {.lex_state = 112},
  [7087] = {.lex_state = 116},
  [7088] = {.lex_state = 124},
  [7089] = {.lex_state = 124},
  [7090] = {.lex_state = 124},
  [7091] = {.lex_state = 531},
  [7092] = {.lex_state = 124},
  [7093] = {.lex_state = 531},
  [7094] = {.lex_state = 531},
  [7095] = {.lex_state = 325},
  [7096] = {.lex_state = 124},
  [7097] = {.lex_state = 325},
  [7098] = {.lex_state = 4},
  [7099] = {.lex_state = 325},
  [7100] = {.lex_state = 325},
  [7101] = {.lex_state = 124},
  [7102] = {.lex_state = 112},
  [7103] = {.lex_state = 531},
  [7104] = {.lex_state = 325},
  [7105] = {.lex_state = 246},
  [7106] = {.lex_state = 8, .external_lex_state = 4},
  [7107] = {.lex_state = 325},
  [7108] = {.lex_state = 124},
  [7109] = {.lex_state = 325},
  [7110] = {.lex_state = 325},
  [7111] = {.lex_state = 325},
  [7112] = {.lex_state = 124},
  [7113] = {.lex_state = 124},
  [7114] = {.lex_state = 124},
  [7115] = {.lex_state = 124},
  [7116] = {.lex_state = 124},
  [7117] = {.lex_state = 124},
  [7118] = {.lex_state = 124},
  [7119] = {.lex_state = 124},
  [7120] = {.lex_state = 8},
  [7121] = {.lex_state = 325},
  [7122] = {.lex_state = 325},
  [7123] = {.lex_state = 124},
  [7124] = {.lex_state = 124},
  [7125] = {.lex_state = 325},
  [7126] = {.lex_state = 124},
  [7127] = {.lex_state = 325},
  [7128] = {.lex_state = 325},
  [7129] = {.lex_state = 325},
  [7130] = {.lex_state = 325},
  [7131] = {.lex_state = 325},
  [7132] = {.lex_state = 8},
  [7133] = {.lex_state = 8, .external_lex_state = 4},
  [7134] = {.lex_state = 124},
  [7135] = {.lex_state = 124},
  [7136] = {.lex_state = 124},
  [7137] = {.lex_state = 124},
  [7138] = {.lex_state = 325},
  [7139] = {.lex_state = 325},
  [7140] = {.lex_state = 325},
  [7141] = {.lex_state = 325},
  [7142] = {.lex_state = 325},
  [7143] = {.lex_state = 325},
  [7144] = {.lex_state = 531},
  [7145] = {.lex_state = 124},
  [7146] = {.lex_state = 325},
  [7147] = {.lex_state = 124},
  [7148] = {.lex_state = 325},
  [7149] = {.lex_state = 124},
  [7150] = {.lex_state = 124},
  [7151] = {.lex_state = 124},
  [7152] = {.lex_state = 325},
  [7153] = {.lex_state = 325},
  [7154] = {.lex_state = 124},
  [7155] = {.lex_state = 325},
  [7156] = {.lex_state = 325},
  [7157] = {.lex_state = 124},
  [7158] = {.lex_state = 124},
  [7159] = {.lex_state = 534},
  [7160] = {.lex_state = 511, .external_lex_state = 5},
  [7161] = {.lex_state = 120},
  [7162] = {.lex_state = 120},
  [7163] = {.lex_state = 116},
  [7164] = {.lex_state = 325},
  [7165] = {.lex_state = 124},
  [7166] = {.lex_state = 120},
  [7167] = {.lex_state = 325},
  [7168] = {.lex_state = 4},
  [7169] = {.lex_state = 116},
  [7170] = {.lex_state = 116},
  [7171] = {.lex_state = 320, .external_lex_state = 3},
  [7172] = {.lex_state = 4},
  [7173] = {.lex_state = 4},
  [7174] = {.lex_state = 320, .external_lex_state = 3},
  [7175] = {.lex_state = 325},
  [7176] = {.lex_state = 4, .external_lex_state = 4},
  [7177] = {.lex_state = 116},
  [7178] = {.lex_state = 8},
  [7179] = {.lex_state = 120},
  [7180] = {.lex_state = 325},
  [7181] = {.lex_state = 8},
  [7182] = {.lex_state = 8},
  [7183] = {.lex_state = 116},
  [7184] = {.lex_state = 8},
  [7185] = {.lex_state = 124},
  [7186] = {.lex_state = 320, .external_lex_state = 3},
  [7187] = {.lex_state = 120},
  [7188] = {.lex_state = 531},
  [7189] = {.lex_state = 120},
  [7190] = {.lex_state = 511, .external_lex_state = 5},
  [7191] = {.lex_state = 531},
  [7192] = {.lex_state = 507},
  [7193] = {.lex_state = 8},
  [7194] = {.lex_state = 507},
  [7195] = {.lex_state = 507},
  [7196] = {.lex_state = 507},
  [7197] = {.lex_state = 116},
  [7198] = {.lex_state = 8, .external_lex_state = 4},
  [7199] = {.lex_state = 290, .external_lex_state = 3},
  [7200] = {.lex_state = 332},
  [7201] = {.lex_state = 325},
  [7202] = {.lex_state = 116},
  [7203] = {.lex_state = 4},
  [7204] = {.lex_state = 320, .external_lex_state = 3},
  [7205] = {.lex_state = 507},
  [7206] = {.lex_state = 12},
  [7207] = {.lex_state = 4},
  [7208] = {.lex_state = 129},
  [7209] = {.lex_state = 4},
  [7210] = {.lex_state = 4},
  [7211] = {.lex_state = 12},
  [7212] = {.lex_state = 129},
  [7213] = {.lex_state = 129},
  [7214] = {.lex_state = 507},
  [7215] = {.lex_state = 511},
  [7216] = {.lex_state = 511},
  [7217] = {.lex_state = 507},
  [7218] = {.lex_state = 511},
  [7219] = {.lex_state = 8},
  [7220] = {.lex_state = 511},
  [7221] = {.lex_state = 66},
  [7222] = {.lex_state = 4},
  [7223] = {.lex_state = 4},
  [7224] = {.lex_state = 4},
  [7225] = {.lex_state = 116},
  [7226] = {.lex_state = 8},
  [7227] = {.lex_state = 507},
  [7228] = {.lex_state = 71},
  [7229] = {.lex_state = 8},
  [7230] = {.lex_state = 507},
  [7231] = {.lex_state = 8},
  [7232] = {.lex_state = 17},
  [7233] = {.lex_state = 507},
  [7234] = {.lex_state = 314},
  [7235] = {.lex_state = 129},
  [7236] = {.lex_state = 507},
  [7237] = {.lex_state = 66},
  [7238] = {.lex_state = 17},
  [7239] = {.lex_state = 4},
  [7240] = {.lex_state = 17},
  [7241] = {.lex_state = 507},
  [7242] = {.lex_state = 239},
  [7243] = {.lex_state = 8},
  [7244] = {.lex_state = 4},
  [7245] = {.lex_state = 507},
  [7246] = {.lex_state = 507},
  [7247] = {.lex_state = 507},
  [7248] = {.lex_state = 531},
  [7249] = {.lex_state = 4},
  [7250] = {.lex_state = 4},
  [7251] = {.lex_state = 8},
  [7252] = {.lex_state = 507},
  [7253] = {.lex_state = 8},
  [7254] = {.lex_state = 507},
  [7255] = {.lex_state = 507},
  [7256] = {.lex_state = 4},
  [7257] = {.lex_state = 4},
  [7258] = {.lex_state = 129},
  [7259] = {.lex_state = 12},
  [7260] = {.lex_state = 507},
  [7261] = {.lex_state = 8},
  [7262] = {.lex_state = 507},
  [7263] = {.lex_state = 8},
  [7264] = {.lex_state = 4},
  [7265] = {.lex_state = 510},
  [7266] = {.lex_state = 8},
  [7267] = {.lex_state = 507},
  [7268] = {.lex_state = 12},
  [7269] = {.lex_state = 15},
  [7270] = {.lex_state = 12},
  [7271] = {.lex_state = 129},
  [7272] = {.lex_state = 8},
  [7273] = {.lex_state = 8},
  [7274] = {.lex_state = 129},
  [7275] = {.lex_state = 129},
  [7276] = {.lex_state = 129},
  [7277] = {.lex_state = 8},
  [7278] = {.lex_state = 507},
  [7279] = {.lex_state = 507},
  [7280] = {.lex_state = 12},
  [7281] = {.lex_state = 129},
  [7282] = {.lex_state = 129},
  [7283] = {.lex_state = 129},
  [7284] = {.lex_state = 129},
  [7285] = {.lex_state = 129},
  [7286] = {.lex_state = 8},
  [7287] = {.lex_state = 8},
  [7288] = {.lex_state = 12},
  [7289] = {.lex_state = 8},
  [7290] = {.lex_state = 8},
  [7291] = {.lex_state = 4},
  [7292] = {.lex_state = 129},
  [7293] = {.lex_state = 129},
  [7294] = {.lex_state = 4},
  [7295] = {.lex_state = 4},
  [7296] = {.lex_state = 129},
  [7297] = {.lex_state = 4},
  [7298] = {.lex_state = 522},
  [7299] = {.lex_state = 507, .external_lex_state = 4},
  [7300] = {.lex_state = 129},
  [7301] = {.lex_state = 129},
  [7302] = {.lex_state = 129},
  [7303] = {.lex_state = 129},
  [7304] = {.lex_state = 129},
  [7305] = {.lex_state = 8},
  [7306] = {.lex_state = 8},
  [7307] = {.lex_state = 8},
  [7308] = {.lex_state = 8},
  [7309] = {.lex_state = 8},
  [7310] = {.lex_state = 8},
  [7311] = {.lex_state = 4},
  [7312] = {.lex_state = 4},
  [7313] = {.lex_state = 129},
  [7314] = {.lex_state = 129},
  [7315] = {.lex_state = 4},
  [7316] = {.lex_state = 129},
  [7317] = {.lex_state = 129},
  [7318] = {.lex_state = 129},
  [7319] = {.lex_state = 129},
  [7320] = {.lex_state = 4},
  [7321] = {.lex_state = 8},
  [7322] = {.lex_state = 8},
  [7323] = {.lex_state = 4},
  [7324] = {.lex_state = 8},
  [7325] = {.lex_state = 8},
  [7326] = {.lex_state = 8},
  [7327] = {.lex_state = 8},
  [7328] = {.lex_state = 8},
  [7329] = {.lex_state = 4},
  [7330] = {.lex_state = 4},
  [7331] = {.lex_state = 129},
  [7332] = {.lex_state = 129},
  [7333] = {.lex_state = 4},
  [7334] = {.lex_state = 129},
  [7335] = {.lex_state = 129},
  [7336] = {.lex_state = 8},
  [7337] = {.lex_state = 531},
  [7338] = {.lex_state = 129},
  [7339] = {.lex_state = 129},
  [7340] = {.lex_state = 4},
  [7341] = {.lex_state = 8},
  [7342] = {.lex_state = 129},
  [7343] = {.lex_state = 8},
  [7344] = {.lex_state = 507},
  [7345] = {.lex_state = 17},
  [7346] = {.lex_state = 314},
  [7347] = {.lex_state = 507},
  [7348] = {.lex_state = 4},
  [7349] = {.lex_state = 4},
  [7350] = {.lex_state = 4},
  [7351] = {.lex_state = 8},
  [7352] = {.lex_state = 12},
  [7353] = {.lex_state = 507},
  [7354] = {.lex_state = 507},
  [7355] = {.lex_state = 4},
  [7356] = {.lex_state = 252},
  [7357] = {.lex_state = 507},
  [7358] = {.lex_state = 124},
  [7359] = {.lex_state = 4},
  [7360] = {.lex_state = 4},
  [7361] = {.lex_state = 8},
  [7362] = {.lex_state = 12},
  [7363] = {.lex_state = 507},
  [7364] = {.lex_state = 507},
  [7365] = {.lex_state = 507},
  [7366] = {.lex_state = 507},
  [7367] = {.lex_state = 507},
  [7368] = {.lex_state = 314},
  [7369] = {.lex_state = 8},
  [7370] = {.lex_state = 314},
  [7371] = {.lex_state = 331},
  [7372] = {.lex_state = 314},
  [7373] = {.lex_state = 239},
  [7374] = {.lex_state = 507},
  [7375] = {.lex_state = 507},
  [7376] = {.lex_state = 507},
  [7377] = {.lex_state = 8},
  [7378] = {.lex_state = 507},
  [7379] = {.lex_state = 8},
  [7380] = {.lex_state = 507},
  [7381] = {.lex_state = 239},
  [7382] = {.lex_state = 507},
  [7383] = {.lex_state = 507},
  [7384] = {.lex_state = 507},
  [7385] = {.lex_state = 507},
  [7386] = {.lex_state = 12},
  [7387] = {.lex_state = 507, .external_lex_state = 4},
  [7388] = {.lex_state = 116},
  [7389] = {.lex_state = 12},
  [7390] = {.lex_state = 8},
  [7391] = {.lex_state = 12},
  [7392] = {.lex_state = 8},
  [7393] = {.lex_state = 507},
  [7394] = {.lex_state = 507},
  [7395] = {.lex_state = 507},
  [7396] = {.lex_state = 4},
  [7397] = {.lex_state = 507},
  [7398] = {.lex_state = 12},
  [7399] = {.lex_state = 507},
  [7400] = {.lex_state = 507},
  [7401] = {.lex_state = 12},
  [7402] = {.lex_state = 8},
  [7403] = {.lex_state = 314},
  [7404] = {.lex_state = 8},
  [7405] = {.lex_state = 8},
  [7406] = {.lex_state = 507},
  [7407] = {.lex_state = 507},
  [7408] = {.lex_state = 8},
  [7409] = {.lex_state = 8},
  [7410] = {.lex_state = 507},
  [7411] = {.lex_state = 507},
  [7412] = {.lex_state = 8},
  [7413] = {.lex_state = 507},
  [7414] = {.lex_state = 507},
  [7415] = {.lex_state = 507},
  [7416] = {.lex_state = 4},
  [7417] = {.lex_state = 4},
  [7418] = {.lex_state = 4},
  [7419] = {.lex_state = 120},
  [7420] = {.lex_state = 8},
  [7421] = {.lex_state = 8},
  [7422] = {.lex_state = 12},
  [7423] = {.lex_state = 8},
  [7424] = {.lex_state = 8},
  [7425] = {.lex_state = 12},
  [7426] = {.lex_state = 8},
  [7427] = {.lex_state = 17},
  [7428] = {.lex_state = 507},
  [7429] = {.lex_state = 8},
  [7430] = {.lex_state = 8},
  [7431] = {.lex_state = 8},
  [7432] = {.lex_state = 8},
  [7433] = {.lex_state = 8},
  [7434] = {.lex_state = 129},
  [7435] = {.lex_state = 17},
  [7436] = {.lex_state = 8},
  [7437] = {.lex_state = 116},
  [7438] = {.lex_state = 507},
  [7439] = {.lex_state = 12},
  [7440] = {.lex_state = 507},
  [7441] = {.lex_state = 4},
  [7442] = {.lex_state = 12},
  [7443] = {.lex_state = 314},
  [7444] = {.lex_state = 129},
  [7445] = {.lex_state = 239, .external_lex_state = 4},
  [7446] = {.lex_state = 507},
  [7447] = {.lex_state = 12, .external_lex_state = 4},
  [7448] = {.lex_state = 507},
  [7449] = {.lex_state = 320, .external_lex_state = 3},
  [7450] = {.lex_state = 12},
  [7451] = {.lex_state = 268},
  [7452] = {.lex_state = 522},
  [7453] = {.lex_state = 507},
  [7454] = {.lex_state = 17, .external_lex_state = 4},
  [7455] = {.lex_state = 12},
  [7456] = {.lex_state = 12},
  [7457] = {.lex_state = 314},
  [7458] = {.lex_state = 314},
  [7459] = {.lex_state = 8},
  [7460] = {.lex_state = 8},
  [7461] = {.lex_state = 12},
  [7462] = {.lex_state = 338, .external_lex_state = 5},
  [7463] = {.lex_state = 4},
  [7464] = {.lex_state = 4},
  [7465] = {.lex_state = 507},
  [7466] = {.lex_state = 8},
  [7467] = {.lex_state = 17},
  [7468] = {.lex_state = 17},
  [7469] = {.lex_state = 129},
  [7470] = {.lex_state = 17},
  [7471] = {.lex_state = 507},
  [7472] = {.lex_state = 17},
  [7473] = {.lex_state = 116},
  [7474] = {.lex_state = 12},
  [7475] = {.lex_state = 4},
  [7476] = {.lex_state = 8},
  [7477] = {.lex_state = 12},
  [7478] = {.lex_state = 314},
  [7479] = {.lex_state = 17},
  [7480] = {.lex_state = 507, .external_lex_state = 4},
  [7481] = {.lex_state = 8},
  [7482] = {.lex_state = 12},
  [7483] = {.lex_state = 239},
  [7484] = {.lex_state = 12},
  [7485] = {.lex_state = 129},
  [7486] = {.lex_state = 132},
  [7487] = {.lex_state = 129},
  [7488] = {.lex_state = 314, .external_lex_state = 4},
  [7489] = {.lex_state = 4},
  [7490] = {.lex_state = 12},
  [7491] = {.lex_state = 507},
  [7492] = {.lex_state = 71},
  [7493] = {.lex_state = 71},
  [7494] = {.lex_state = 507},
  [7495] = {.lex_state = 239},
  [7496] = {.lex_state = 17},
  [7497] = {.lex_state = 246},
  [7498] = {.lex_state = 4},
  [7499] = {.lex_state = 129},
  [7500] = {.lex_state = 507},
  [7501] = {.lex_state = 71},
  [7502] = {.lex_state = 129},
  [7503] = {.lex_state = 8, .external_lex_state = 4},
  [7504] = {.lex_state = 4},
  [7505] = {.lex_state = 239},
  [7506] = {.lex_state = 4},
  [7507] = {.lex_state = 239},
  [7508] = {.lex_state = 4},
  [7509] = {.lex_state = 17},
  [7510] = {.lex_state = 325},
  [7511] = {.lex_state = 314},
  [7512] = {.lex_state = 8},
  [7513] = {.lex_state = 12},
  [7514] = {.lex_state = 17},
  [7515] = {.lex_state = 507},
  [7516] = {.lex_state = 507},
  [7517] = {.lex_state = 507},
  [7518] = {.lex_state = 314},
  [7519] = {.lex_state = 507},
  [7520] = {.lex_state = 531},
  [7521] = {.lex_state = 4},
  [7522] = {.lex_state = 4},
  [7523] = {.lex_state = 12},
  [7524] = {.lex_state = 4},
  [7525] = {.lex_state = 8},
  [7526] = {.lex_state = 12},
  [7527] = {.lex_state = 507},
  [7528] = {.lex_state = 17},
  [7529] = {.lex_state = 12},
  [7530] = {.lex_state = 66},
  [7531] = {.lex_state = 12, .external_lex_state = 4},
  [7532] = {.lex_state = 239},
  [7533] = {.lex_state = 8},
  [7534] = {.lex_state = 239},
  [7535] = {.lex_state = 8},
  [7536] = {.lex_state = 4},
  [7537] = {.lex_state = 4},
  [7538] = {.lex_state = 239},
  [7539] = {.lex_state = 239},
  [7540] = {.lex_state = 8},
  [7541] = {.lex_state = 239},
  [7542] = {.lex_state = 239},
  [7543] = {.lex_state = 12},
  [7544] = {.lex_state = 239},
  [7545] = {.lex_state = 12},
  [7546] = {.lex_state = 239},
  [7547] = {.lex_state = 12},
  [7548] = {.lex_state = 239},
  [7549] = {.lex_state = 17, .external_lex_state = 4},
  [7550] = {.lex_state = 239},
  [7551] = {.lex_state = 239},
  [7552] = {.lex_state = 4},
  [7553] = {.lex_state = 4},
  [7554] = {.lex_state = 4},
  [7555] = {.lex_state = 8},
  [7556] = {.lex_state = 8},
  [7557] = {.lex_state = 8},
  [7558] = {.lex_state = 239},
  [7559] = {.lex_state = 239},
  [7560] = {.lex_state = 4},
  [7561] = {.lex_state = 8},
  [7562] = {.lex_state = 507},
  [7563] = {.lex_state = 239},
  [7564] = {.lex_state = 239},
  [7565] = {.lex_state = 239},
  [7566] = {.lex_state = 239},
  [7567] = {.lex_state = 314},
  [7568] = {.lex_state = 239},
  [7569] = {.lex_state = 239},
  [7570] = {.lex_state = 314},
  [7571] = {.lex_state = 258},
  [7572] = {.lex_state = 4},
  [7573] = {.lex_state = 314},
  [7574] = {.lex_state = 314},
  [7575] = {.lex_state = 8},
  [7576] = {.lex_state = 239},
  [7577] = {.lex_state = 239},
  [7578] = {.lex_state = 8},
  [7579] = {.lex_state = 239},
  [7580] = {.lex_state = 12},
  [7581] = {.lex_state = 314},
  [7582] = {.lex_state = 314},
  [7583] = {.lex_state = 239},
  [7584] = {.lex_state = 314},
  [7585] = {.lex_state = 314},
  [7586] = {.lex_state = 314},
  [7587] = {.lex_state = 239},
  [7588] = {.lex_state = 239},
  [7589] = {.lex_state = 239},
  [7590] = {.lex_state = 239},
  [7591] = {.lex_state = 507},
  [7592] = {.lex_state = 8},
  [7593] = {.lex_state = 239},
  [7594] = {.lex_state = 314},
  [7595] = {.lex_state = 314},
  [7596] = {.lex_state = 8},
  [7597] = {.lex_state = 507},
  [7598] = {.lex_state = 314},
  [7599] = {.lex_state = 12},
  [7600] = {.lex_state = 314},
  [7601] = {.lex_state = 314},
  [7602] = {.lex_state = 314},
  [7603] = {.lex_state = 314},
  [7604] = {.lex_state = 314},
  [7605] = {.lex_state = 120},
  [7606] = {.lex_state = 8},
  [7607] = {.lex_state = 12},
  [7608] = {.lex_state = 507},
  [7609] = {.lex_state = 239, .external_lex_state = 4},
  [7610] = {.lex_state = 129},
  [7611] = {.lex_state = 8},
  [7612] = {.lex_state = 12},
  [7613] = {.lex_state = 314},
  [7614] = {.lex_state = 314},
  [7615] = {.lex_state = 8},
  [7616] = {.lex_state = 314},
  [7617] = {.lex_state = 12},
  [7618] = {.lex_state = 507},
  [7619] = {.lex_state = 17},
  [7620] = {.lex_state = 314},
  [7621] = {.lex_state = 325},
  [7622] = {.lex_state = 507},
  [7623] = {.lex_state = 239, .external_lex_state = 4},
  [7624] = {.lex_state = 507},
  [7625] = {.lex_state = 507},
  [7626] = {.lex_state = 507},
  [7627] = {.lex_state = 17},
  [7628] = {.lex_state = 507},
  [7629] = {.lex_state = 314},
  [7630] = {.lex_state = 17},
  [7631] = {.lex_state = 17},
  [7632] = {.lex_state = 17},
  [7633] = {.lex_state = 12},
  [7634] = {.lex_state = 507},
  [7635] = {.lex_state = 4},
  [7636] = {.lex_state = 17},
  [7637] = {.lex_state = 239},
  [7638] = {.lex_state = 314},
  [7639] = {.lex_state = 17},
  [7640] = {.lex_state = 8},
  [7641] = {.lex_state = 12},
  [7642] = {.lex_state = 12},
  [7643] = {.lex_state = 12},
  [7644] = {.lex_state = 507},
  [7645] = {.lex_state = 239},
  [7646] = {.lex_state = 239},
  [7647] = {.lex_state = 239},
  [7648] = {.lex_state = 17},
  [7649] = {.lex_state = 4},
  [7650] = {.lex_state = 507},
  [7651] = {.lex_state = 17},
  [7652] = {.lex_state = 4},
  [7653] = {.lex_state = 12},
  [7654] = {.lex_state = 17},
  [7655] = {.lex_state = 239},
  [7656] = {.lex_state = 507},
  [7657] = {.lex_state = 12},
  [7658] = {.lex_state = 239},
  [7659] = {.lex_state = 314},
  [7660] = {.lex_state = 507},
  [7661] = {.lex_state = 258},
  [7662] = {.lex_state = 314, .external_lex_state = 4},
  [7663] = {.lex_state = 17},
  [7664] = {.lex_state = 314},
  [7665] = {.lex_state = 8},
  [7666] = {.lex_state = 8},
  [7667] = {.lex_state = 314},
  [7668] = {.lex_state = 507},
  [7669] = {.lex_state = 507},
  [7670] = {.lex_state = 314},
  [7671] = {.lex_state = 314},
  [7672] = {.lex_state = 129},
  [7673] = {.lex_state = 8},
  [7674] = {.lex_state = 314},
  [7675] = {.lex_state = 314},
  [7676] = {.lex_state = 12},
  [7677] = {.lex_state = 507},
  [7678] = {.lex_state = 12},
  [7679] = {.lex_state = 129},
  [7680] = {.lex_state = 17},
  [7681] = {.lex_state = 507},
  [7682] = {.lex_state = 239, .external_lex_state = 4},
  [7683] = {.lex_state = 12, .external_lex_state = 4},
  [7684] = {.lex_state = 12},
  [7685] = {.lex_state = 314},
  [7686] = {.lex_state = 129},
  [7687] = {.lex_state = 258},
  [7688] = {.lex_state = 8},
  [7689] = {.lex_state = 66},
  [7690] = {.lex_state = 120},
  [7691] = {.lex_state = 17},
  [7692] = {.lex_state = 507},
  [7693] = {.lex_state = 129},
  [7694] = {.lex_state = 17, .external_lex_state = 4},
  [7695] = {.lex_state = 8},
  [7696] = {.lex_state = 239, .external_lex_state = 4},
  [7697] = {.lex_state = 507},
  [7698] = {.lex_state = 507},
  [7699] = {.lex_state = 17, .external_lex_state = 4},
  [7700] = {.lex_state = 320, .external_lex_state = 3},
  [7701] = {.lex_state = 12},
  [7702] = {.lex_state = 239},
  [7703] = {.lex_state = 325},
  [7704] = {.lex_state = 507},
  [7705] = {.lex_state = 8},
  [7706] = {.lex_state = 17},
  [7707] = {.lex_state = 116},
  [7708] = {.lex_state = 17},
  [7709] = {.lex_state = 12},
  [7710] = {.lex_state = 8},
  [7711] = {.lex_state = 8},
  [7712] = {.lex_state = 8},
  [7713] = {.lex_state = 8},
  [7714] = {.lex_state = 8},
  [7715] = {.lex_state = 507},
  [7716] = {.lex_state = 8},
  [7717] = {.lex_state = 8},
  [7718] = {.lex_state = 239},
  [7719] = {.lex_state = 239},
  [7720] = {.lex_state = 124},
  [7721] = {.lex_state = 12},
  [7722] = {.lex_state = 4},
  [7723] = {.lex_state = 507},
  [7724] = {.lex_state = 8},
  [7725] = {.lex_state = 507, .external_lex_state = 4},
  [7726] = {.lex_state = 8},
  [7727] = {.lex_state = 4},
  [7728] = {.lex_state = 12},
  [7729] = {.lex_state = 12},
  [7730] = {.lex_state = 507},
  [7731] = {.lex_state = 4},
  [7732] = {.lex_state = 507},
  [7733] = {.lex_state = 4},
  [7734] = {.lex_state = 12},
  [7735] = {.lex_state = 531},
  [7736] = {.lex_state = 17},
  [7737] = {.lex_state = 507},
  [7738] = {.lex_state = 4},
  [7739] = {.lex_state = 12},
  [7740] = {.lex_state = 507},
  [7741] = {.lex_state = 507},
  [7742] = {.lex_state = 12},
  [7743] = {.lex_state = 507},
  [7744] = {.lex_state = 507},
  [7745] = {.lex_state = 239},
  [7746] = {.lex_state = 314},
  [7747] = {.lex_state = 314},
  [7748] = {.lex_state = 4},
  [7749] = {.lex_state = 314},
  [7750] = {.lex_state = 4},
  [7751] = {.lex_state = 239},
  [7752] = {.lex_state = 507},
  [7753] = {.lex_state = 239},
  [7754] = {.lex_state = 4},
  [7755] = {.lex_state = 239},
  [7756] = {.lex_state = 314},
  [7757] = {.lex_state = 4},
  [7758] = {.lex_state = 239},
  [7759] = {.lex_state = 8},
  [7760] = {.lex_state = 8},
  [7761] = {.lex_state = 4},
  [7762] = {.lex_state = 507},
  [7763] = {.lex_state = 507},
  [7764] = {.lex_state = 4},
  [7765] = {.lex_state = 17},
  [7766] = {.lex_state = 246},
  [7767] = {.lex_state = 4},
  [7768] = {.lex_state = 17},
  [7769] = {.lex_state = 17},
  [7770] = {.lex_state = 4},
  [7771] = {.lex_state = 17},
  [7772] = {.lex_state = 522},
  [7773] = {.lex_state = 17},
  [7774] = {.lex_state = 17},
  [7775] = {.lex_state = 8},
  [7776] = {.lex_state = 507},
  [7777] = {.lex_state = 338, .external_lex_state = 5},
  [7778] = {.lex_state = 4},
  [7779] = {.lex_state = 12},
  [7780] = {.lex_state = 12},
  [7781] = {.lex_state = 17},
  [7782] = {.lex_state = 17},
  [7783] = {.lex_state = 17, .external_lex_state = 4},
  [7784] = {.lex_state = 507},
  [7785] = {.lex_state = 17},
  [7786] = {.lex_state = 507},
  [7787] = {.lex_state = 8},
  [7788] = {.lex_state = 8},
  [7789] = {.lex_state = 17},
  [7790] = {.lex_state = 17},
  [7791] = {.lex_state = 17},
  [7792] = {.lex_state = 17},
  [7793] = {.lex_state = 17},
  [7794] = {.lex_state = 8},
  [7795] = {.lex_state = 314},
  [7796] = {.lex_state = 239},
  [7797] = {.lex_state = 239},
  [7798] = {.lex_state = 12},
  [7799] = {.lex_state = 17},
  [7800] = {.lex_state = 17},
  [7801] = {.lex_state = 12},
  [7802] = {.lex_state = 4},
  [7803] = {.lex_state = 314},
  [7804] = {.lex_state = 17},
  [7805] = {.lex_state = 239},
  [7806] = {.lex_state = 4},
  [7807] = {.lex_state = 522},
  [7808] = {.lex_state = 4},
  [7809] = {.lex_state = 66},
  [7810] = {.lex_state = 8},
  [7811] = {.lex_state = 120},
  [7812] = {.lex_state = 507},
  [7813] = {.lex_state = 12, .external_lex_state = 4},
  [7814] = {.lex_state = 325},
  [7815] = {.lex_state = 258},
  [7816] = {.lex_state = 8},
  [7817] = {.lex_state = 507},
  [7818] = {.lex_state = 507},
  [7819] = {.lex_state = 246},
  [7820] = {.lex_state = 239},
  [7821] = {.lex_state = 124},
  [7822] = {.lex_state = 17},
  [7823] = {.lex_state = 314},
  [7824] = {.lex_state = 4},
  [7825] = {.lex_state = 4},
  [7826] = {.lex_state = 4},
  [7827] = {.lex_state = 4},
  [7828] = {.lex_state = 4},
  [7829] = {.lex_state = 4},
  [7830] = {.lex_state = 239},
  [7831] = {.lex_state = 4},
  [7832] = {.lex_state = 4},
  [7833] = {.lex_state = 4},
  [7834] = {.lex_state = 4},
  [7835] = {.lex_state = 4},
  [7836] = {.lex_state = 4},
  [7837] = {.lex_state = 17},
  [7838] = {.lex_state = 8},
  [7839] = {.lex_state = 8},
  [7840] = {.lex_state = 239},
  [7841] = {.lex_state = 507},
  [7842] = {.lex_state = 4},
  [7843] = {.lex_state = 338, .external_lex_state = 5},
  [7844] = {.lex_state = 120},
  [7845] = {.lex_state = 12, .external_lex_state = 4},
  [7846] = {.lex_state = 8},
  [7847] = {.lex_state = 239},
  [7848] = {.lex_state = 8},
  [7849] = {.lex_state = 8},
  [7850] = {.lex_state = 239},
  [7851] = {.lex_state = 239},
  [7852] = {.lex_state = 17},
  [7853] = {.lex_state = 4},
  [7854] = {.lex_state = 17},
  [7855] = {.lex_state = 507},
  [7856] = {.lex_state = 17},
  [7857] = {.lex_state = 507},
  [7858] = {.lex_state = 531},
  [7859] = {.lex_state = 507},
  [7860] = {.lex_state = 507},
  [7861] = {.lex_state = 507},
  [7862] = {.lex_state = 4},
  [7863] = {.lex_state = 507},
  [7864] = {.lex_state = 12, .external_lex_state = 4},
  [7865] = {.lex_state = 239, .external_lex_state = 4},
  [7866] = {.lex_state = 8},
  [7867] = {.lex_state = 239},
  [7868] = {.lex_state = 4},
  [7869] = {.lex_state = 8},
  [7870] = {.lex_state = 71},
  [7871] = {.lex_state = 325},
  [7872] = {.lex_state = 12},
  [7873] = {.lex_state = 507},
  [7874] = {.lex_state = 8},
  [7875] = {.lex_state = 314},
  [7876] = {.lex_state = 4},
  [7877] = {.lex_state = 239},
  [7878] = {.lex_state = 507},
  [7879] = {.lex_state = 124},
  [7880] = {.lex_state = 4},
  [7881] = {.lex_state = 4},
  [7882] = {.lex_state = 4},
  [7883] = {.lex_state = 507},
  [7884] = {.lex_state = 4},
  [7885] = {.lex_state = 246},
  [7886] = {.lex_state = 4},
  [7887] = {.lex_state = 507},
  [7888] = {.lex_state = 17},
  [7889] = {.lex_state = 20},
  [7890] = {.lex_state = 17},
  [7891] = {.lex_state = 4},
  [7892] = {.lex_state = 507},
  [7893] = {.lex_state = 314, .external_lex_state = 4},
  [7894] = {.lex_state = 17, .external_lex_state = 4},
  [7895] = {.lex_state = 124},
  [7896] = {.lex_state = 129},
  [7897] = {.lex_state = 314},
  [7898] = {.lex_state = 8},
  [7899] = {.lex_state = 522},
  [7900] = {.lex_state = 314},
  [7901] = {.lex_state = 8},
  [7902] = {.lex_state = 4},
  [7903] = {.lex_state = 17},
  [7904] = {.lex_state = 239},
  [7905] = {.lex_state = 507, .external_lex_state = 4},
  [7906] = {.lex_state = 8},
  [7907] = {.lex_state = 507},
  [7908] = {.lex_state = 507, .external_lex_state = 4},
  [7909] = {.lex_state = 129},
  [7910] = {.lex_state = 17},
  [7911] = {.lex_state = 258},
  [7912] = {.lex_state = 17},
  [7913] = {.lex_state = 242},
  [7914] = {.lex_state = 129},
  [7915] = {.lex_state = 8},
  [7916] = {.lex_state = 314, .external_lex_state = 4},
  [7917] = {.lex_state = 4},
  [7918] = {.lex_state = 4},
  [7919] = {.lex_state = 4},
  [7920] = {.lex_state = 4},
  [7921] = {.lex_state = 4},
  [7922] = {.lex_state = 17},
  [7923] = {.lex_state = 507},
  [7924] = {.lex_state = 4},
  [7925] = {.lex_state = 4},
  [7926] = {.lex_state = 4},
  [7927] = {.lex_state = 4},
  [7928] = {.lex_state = 4},
  [7929] = {.lex_state = 4},
  [7930] = {.lex_state = 17},
  [7931] = {.lex_state = 17},
  [7932] = {.lex_state = 4},
  [7933] = {.lex_state = 507},
  [7934] = {.lex_state = 314},
  [7935] = {.lex_state = 12},
  [7936] = {.lex_state = 12},
  [7937] = {.lex_state = 507},
  [7938] = {.lex_state = 511, .external_lex_state = 4},
  [7939] = {.lex_state = 507},
  [7940] = {.lex_state = 314},
  [7941] = {.lex_state = 507},
  [7942] = {.lex_state = 507},
  [7943] = {.lex_state = 507},
  [7944] = {.lex_state = 507},
  [7945] = {.lex_state = 507},
  [7946] = {.lex_state = 507},
  [7947] = {.lex_state = 507},
  [7948] = {.lex_state = 507},
  [7949] = {.lex_state = 507},
  [7950] = {.lex_state = 507},
  [7951] = {.lex_state = 507},
  [7952] = {.lex_state = 507},
  [7953] = {.lex_state = 507},
  [7954] = {.lex_state = 507},
  [7955] = {.lex_state = 17},
  [7956] = {.lex_state = 12},
  [7957] = {.lex_state = 12},
  [7958] = {.lex_state = 12},
  [7959] = {.lex_state = 12},
  [7960] = {.lex_state = 12},
  [7961] = {.lex_state = 12},
  [7962] = {.lex_state = 12},
  [7963] = {.lex_state = 12},
  [7964] = {.lex_state = 17},
  [7965] = {.lex_state = 12},
  [7966] = {.lex_state = 12},
  [7967] = {.lex_state = 12},
  [7968] = {.lex_state = 12},
  [7969] = {.lex_state = 12},
  [7970] = {.lex_state = 17},
  [7971] = {.lex_state = 507},
  [7972] = {.lex_state = 12},
  [7973] = {.lex_state = 507},
  [7974] = {.lex_state = 12},
  [7975] = {.lex_state = 12},
  [7976] = {.lex_state = 12},
  [7977] = {.lex_state = 12},
  [7978] = {.lex_state = 507},
  [7979] = {.lex_state = 507},
  [7980] = {.lex_state = 12},
  [7981] = {.lex_state = 239},
  [7982] = {.lex_state = 511},
  [7983] = {.lex_state = 511, .external_lex_state = 4},
  [7984] = {.lex_state = 314},
  [7985] = {.lex_state = 507},
  [7986] = {.lex_state = 507},
  [7987] = {.lex_state = 507},
  [7988] = {.lex_state = 507},
  [7989] = {.lex_state = 507},
  [7990] = {.lex_state = 507},
  [7991] = {.lex_state = 507},
  [7992] = {.lex_state = 12},
  [7993] = {.lex_state = 507},
  [7994] = {.lex_state = 507},
  [7995] = {.lex_state = 507},
  [7996] = {.lex_state = 507},
  [7997] = {.lex_state = 12},
  [7998] = {.lex_state = 507},
  [7999] = {.lex_state = 507},
  [8000] = {.lex_state = 12},
  [8001] = {.lex_state = 12},
  [8002] = {.lex_state = 12},
  [8003] = {.lex_state = 12},
  [8004] = {.lex_state = 12},
  [8005] = {.lex_state = 12},
  [8006] = {.lex_state = 12},
  [8007] = {.lex_state = 12},
  [8008] = {.lex_state = 12},
  [8009] = {.lex_state = 12},
  [8010] = {.lex_state = 12},
  [8011] = {.lex_state = 12},
  [8012] = {.lex_state = 507},
  [8013] = {.lex_state = 12},
  [8014] = {.lex_state = 12},
  [8015] = {.lex_state = 239},
  [8016] = {.lex_state = 511},
  [8017] = {.lex_state = 507},
  [8018] = {.lex_state = 511},
  [8019] = {.lex_state = 12},
  [8020] = {.lex_state = 507},
  [8021] = {.lex_state = 12},
  [8022] = {.lex_state = 507},
  [8023] = {.lex_state = 507},
  [8024] = {.lex_state = 507},
  [8025] = {.lex_state = 507},
  [8026] = {.lex_state = 507},
  [8027] = {.lex_state = 507},
  [8028] = {.lex_state = 314},
  [8029] = {.lex_state = 12},
  [8030] = {.lex_state = 263},
  [8031] = {.lex_state = 17},
  [8032] = {.lex_state = 12},
  [8033] = {.lex_state = 12},
  [8034] = {.lex_state = 12},
  [8035] = {.lex_state = 12},
  [8036] = {.lex_state = 507},
  [8037] = {.lex_state = 507},
  [8038] = {.lex_state = 507},
  [8039] = {.lex_state = 12},
  [8040] = {.lex_state = 12},
  [8041] = {.lex_state = 12},
  [8042] = {.lex_state = 314},
  [8043] = {.lex_state = 12},
  [8044] = {.lex_state = 12},
  [8045] = {.lex_state = 12},
  [8046] = {.lex_state = 12},
  [8047] = {.lex_state = 511},
  [8048] = {.lex_state = 270},
  [8049] = {.lex_state = 511},
  [8050] = {.lex_state = 12},
  [8051] = {.lex_state = 12},
  [8052] = {.lex_state = 511, .external_lex_state = 4},
  [8053] = {.lex_state = 239},
  [8054] = {.lex_state = 314},
  [8055] = {.lex_state = 314},
  [8056] = {.lex_state = 314},
  [8057] = {.lex_state = 314},
  [8058] = {.lex_state = 12},
  [8059] = {.lex_state = 507},
  [8060] = {.lex_state = 314},
  [8061] = {.lex_state = 314},
  [8062] = {.lex_state = 129},
  [8063] = {.lex_state = 12},
  [8064] = {.lex_state = 12},
  [8065] = {.lex_state = 12},
  [8066] = {.lex_state = 12},
  [8067] = {.lex_state = 12},
  [8068] = {.lex_state = 12},
  [8069] = {.lex_state = 314},
  [8070] = {.lex_state = 12},
  [8071] = {.lex_state = 314},
  [8072] = {.lex_state = 320, .external_lex_state = 5},
  [8073] = {.lex_state = 12},
  [8074] = {.lex_state = 12},
  [8075] = {.lex_state = 17},
  [8076] = {.lex_state = 511},
  [8077] = {.lex_state = 239},
  [8078] = {.lex_state = 511},
  [8079] = {.lex_state = 511},
  [8080] = {.lex_state = 314},
  [8081] = {.lex_state = 511},
  [8082] = {.lex_state = 129},
  [8083] = {.lex_state = 17},
  [8084] = {.lex_state = 12},
  [8085] = {.lex_state = 239},
  [8086] = {.lex_state = 507},
  [8087] = {.lex_state = 507},
  [8088] = {.lex_state = 507},
  [8089] = {.lex_state = 239},
  [8090] = {.lex_state = 314},
  [8091] = {.lex_state = 17},
  [8092] = {.lex_state = 317},
  [8093] = {.lex_state = 12},
  [8094] = {.lex_state = 239},
  [8095] = {.lex_state = 239},
  [8096] = {.lex_state = 239},
  [8097] = {.lex_state = 12},
  [8098] = {.lex_state = 239},
  [8099] = {.lex_state = 239},
  [8100] = {.lex_state = 314},
  [8101] = {.lex_state = 314},
  [8102] = {.lex_state = 314},
  [8103] = {.lex_state = 314},
  [8104] = {.lex_state = 12},
  [8105] = {.lex_state = 239},
  [8106] = {.lex_state = 239},
  [8107] = {.lex_state = 314},
  [8108] = {.lex_state = 507},
  [8109] = {.lex_state = 314},
  [8110] = {.lex_state = 314},
  [8111] = {.lex_state = 314},
  [8112] = {.lex_state = 314},
  [8113] = {.lex_state = 314},
  [8114] = {.lex_state = 239},
  [8115] = {.lex_state = 239},
  [8116] = {.lex_state = 12},
  [8117] = {.lex_state = 317},
  [8118] = {.lex_state = 12},
  [8119] = {.lex_state = 263},
  [8120] = {.lex_state = 507},
  [8121] = {.lex_state = 314},
  [8122] = {.lex_state = 314},
  [8123] = {.lex_state = 314},
  [8124] = {.lex_state = 314},
  [8125] = {.lex_state = 314},
  [8126] = {.lex_state = 239},
  [8127] = {.lex_state = 314},
  [8128] = {.lex_state = 314},
  [8129] = {.lex_state = 239},
  [8130] = {.lex_state = 239},
  [8131] = {.lex_state = 239},
  [8132] = {.lex_state = 239},
  [8133] = {.lex_state = 239},
  [8134] = {.lex_state = 239},
  [8135] = {.lex_state = 239},
  [8136] = {.lex_state = 239},
  [8137] = {.lex_state = 239},
  [8138] = {.lex_state = 239},
  [8139] = {.lex_state = 239},
  [8140] = {.lex_state = 239},
  [8141] = {.lex_state = 239},
  [8142] = {.lex_state = 239},
  [8143] = {.lex_state = 314},
  [8144] = {.lex_state = 314},
  [8145] = {.lex_state = 314},
  [8146] = {.lex_state = 314},
  [8147] = {.lex_state = 314},
  [8148] = {.lex_state = 314},
  [8149] = {.lex_state = 314},
  [8150] = {.lex_state = 239},
  [8151] = {.lex_state = 314},
  [8152] = {.lex_state = 314},
  [8153] = {.lex_state = 314},
  [8154] = {.lex_state = 511},
  [8155] = {.lex_state = 239},
  [8156] = {.lex_state = 239},
  [8157] = {.lex_state = 239},
  [8158] = {.lex_state = 239},
  [8159] = {.lex_state = 239},
  [8160] = {.lex_state = 239},
  [8161] = {.lex_state = 12},
  [8162] = {.lex_state = 239},
  [8163] = {.lex_state = 239},
  [8164] = {.lex_state = 239},
  [8165] = {.lex_state = 129},
  [8166] = {.lex_state = 314},
  [8167] = {.lex_state = 239},
  [8168] = {.lex_state = 239},
  [8169] = {.lex_state = 314},
  [8170] = {.lex_state = 314},
  [8171] = {.lex_state = 314},
  [8172] = {.lex_state = 511},
  [8173] = {.lex_state = 17},
  [8174] = {.lex_state = 507},
  [8175] = {.lex_state = 239},
  [8176] = {.lex_state = 317},
  [8177] = {.lex_state = 511},
  [8178] = {.lex_state = 320, .external_lex_state = 3},
  [8179] = {.lex_state = 314},
  [8180] = {.lex_state = 314},
  [8181] = {.lex_state = 314},
  [8182] = {.lex_state = 314},
  [8183] = {.lex_state = 314},
  [8184] = {.lex_state = 314},
  [8185] = {.lex_state = 314},
  [8186] = {.lex_state = 314},
  [8187] = {.lex_state = 314},
  [8188] = {.lex_state = 314},
  [8189] = {.lex_state = 314},
  [8190] = {.lex_state = 17},
  [8191] = {.lex_state = 314},
  [8192] = {.lex_state = 314},
  [8193] = {.lex_state = 314},
  [8194] = {.lex_state = 239},
  [8195] = {.lex_state = 314},
  [8196] = {.lex_state = 246},
  [8197] = {.lex_state = 239},
  [8198] = {.lex_state = 12},
  [8199] = {.lex_state = 239},
  [8200] = {.lex_state = 239},
  [8201] = {.lex_state = 239},
  [8202] = {.lex_state = 239},
  [8203] = {.lex_state = 239},
  [8204] = {.lex_state = 239},
  [8205] = {.lex_state = 314},
  [8206] = {.lex_state = 239},
  [8207] = {.lex_state = 239},
  [8208] = {.lex_state = 239},
  [8209] = {.lex_state = 239},
  [8210] = {.lex_state = 239},
  [8211] = {.lex_state = 314},
  [8212] = {.lex_state = 314},
  [8213] = {.lex_state = 314},
  [8214] = {.lex_state = 314},
  [8215] = {.lex_state = 314},
  [8216] = {.lex_state = 314},
  [8217] = {.lex_state = 314},
  [8218] = {.lex_state = 239},
  [8219] = {.lex_state = 239},
  [8220] = {.lex_state = 239},
  [8221] = {.lex_state = 314},
  [8222] = {.lex_state = 314},
  [8223] = {.lex_state = 239},
  [8224] = {.lex_state = 12},
  [8225] = {.lex_state = 239},
  [8226] = {.lex_state = 12},
  [8227] = {.lex_state = 12},
  [8228] = {.lex_state = 239},
  [8229] = {.lex_state = 239},
  [8230] = {.lex_state = 17},
  [8231] = {.lex_state = 522},
  [8232] = {.lex_state = 507, .external_lex_state = 4},
  [8233] = {.lex_state = 12},
  [8234] = {.lex_state = 239},
  [8235] = {.lex_state = 239},
  [8236] = {.lex_state = 239},
  [8237] = {.lex_state = 239},
  [8238] = {.lex_state = 239},
  [8239] = {.lex_state = 239},
  [8240] = {.lex_state = 239},
  [8241] = {.lex_state = 239},
  [8242] = {.lex_state = 239},
  [8243] = {.lex_state = 239},
  [8244] = {.lex_state = 239},
  [8245] = {.lex_state = 239},
  [8246] = {.lex_state = 239},
  [8247] = {.lex_state = 239},
  [8248] = {.lex_state = 12},
  [8249] = {.lex_state = 239},
  [8250] = {.lex_state = 239},
  [8251] = {.lex_state = 511},
  [8252] = {.lex_state = 317},
  [8253] = {.lex_state = 314, .external_lex_state = 4},
  [8254] = {.lex_state = 17},
  [8255] = {.lex_state = 239},
  [8256] = {.lex_state = 17},
  [8257] = {.lex_state = 239},
  [8258] = {.lex_state = 239},
  [8259] = {.lex_state = 17},
  [8260] = {.lex_state = 17},
  [8261] = {.lex_state = 17},
  [8262] = {.lex_state = 17},
  [8263] = {.lex_state = 17},
  [8264] = {.lex_state = 17},
  [8265] = {.lex_state = 17},
  [8266] = {.lex_state = 17},
  [8267] = {.lex_state = 239},
  [8268] = {.lex_state = 12},
  [8269] = {.lex_state = 239},
  [8270] = {.lex_state = 17},
  [8271] = {.lex_state = 239},
  [8272] = {.lex_state = 239},
  [8273] = {.lex_state = 511},
  [8274] = {.lex_state = 17},
  [8275] = {.lex_state = 511},
  [8276] = {.lex_state = 507},
  [8277] = {.lex_state = 17},
  [8278] = {.lex_state = 17},
  [8279] = {.lex_state = 17},
  [8280] = {.lex_state = 239},
  [8281] = {.lex_state = 239},
  [8282] = {.lex_state = 507},
  [8283] = {.lex_state = 17},
  [8284] = {.lex_state = 314},
  [8285] = {.lex_state = 17},
  [8286] = {.lex_state = 12},
  [8287] = {.lex_state = 12},
  [8288] = {.lex_state = 12},
  [8289] = {.lex_state = 12},
  [8290] = {.lex_state = 12},
  [8291] = {.lex_state = 17},
  [8292] = {.lex_state = 17},
  [8293] = {.lex_state = 17},
  [8294] = {.lex_state = 17},
  [8295] = {.lex_state = 17},
  [8296] = {.lex_state = 17},
  [8297] = {.lex_state = 17},
  [8298] = {.lex_state = 17},
  [8299] = {.lex_state = 17},
  [8300] = {.lex_state = 17},
  [8301] = {.lex_state = 17},
  [8302] = {.lex_state = 17},
  [8303] = {.lex_state = 239},
  [8304] = {.lex_state = 239},
  [8305] = {.lex_state = 239},
  [8306] = {.lex_state = 239},
  [8307] = {.lex_state = 17},
  [8308] = {.lex_state = 507},
  [8309] = {.lex_state = 17},
  [8310] = {.lex_state = 4},
  [8311] = {.lex_state = 17},
  [8312] = {.lex_state = 17},
  [8313] = {.lex_state = 239},
  [8314] = {.lex_state = 17},
  [8315] = {.lex_state = 17},
  [8316] = {.lex_state = 17},
  [8317] = {.lex_state = 17},
  [8318] = {.lex_state = 17},
  [8319] = {.lex_state = 17},
  [8320] = {.lex_state = 17},
  [8321] = {.lex_state = 17},
  [8322] = {.lex_state = 17},
  [8323] = {.lex_state = 17},
  [8324] = {.lex_state = 17},
  [8325] = {.lex_state = 17},
  [8326] = {.lex_state = 17},
  [8327] = {.lex_state = 17},
  [8328] = {.lex_state = 314},
  [8329] = {.lex_state = 507},
  [8330] = {.lex_state = 17},
  [8331] = {.lex_state = 17},
  [8332] = {.lex_state = 17},
  [8333] = {.lex_state = 12},
  [8334] = {.lex_state = 17},
  [8335] = {.lex_state = 4},
  [8336] = {.lex_state = 17},
  [8337] = {.lex_state = 4},
  [8338] = {.lex_state = 4},
  [8339] = {.lex_state = 4},
  [8340] = {.lex_state = 4},
  [8341] = {.lex_state = 4},
  [8342] = {.lex_state = 4},
  [8343] = {.lex_state = 4},
  [8344] = {.lex_state = 4},
  [8345] = {.lex_state = 4},
  [8346] = {.lex_state = 4},
  [8347] = {.lex_state = 4},
  [8348] = {.lex_state = 12},
  [8349] = {.lex_state = 239},
  [8350] = {.lex_state = 17},
  [8351] = {.lex_state = 17},
  [8352] = {.lex_state = 511},
  [8353] = {.lex_state = 239},
  [8354] = {.lex_state = 17},
  [8355] = {.lex_state = 17},
  [8356] = {.lex_state = 17},
  [8357] = {.lex_state = 17},
  [8358] = {.lex_state = 17},
  [8359] = {.lex_state = 17},
  [8360] = {.lex_state = 17},
  [8361] = {.lex_state = 17},
  [8362] = {.lex_state = 17},
  [8363] = {.lex_state = 17},
  [8364] = {.lex_state = 511},
  [8365] = {.lex_state = 511},
  [8366] = {.lex_state = 17},
  [8367] = {.lex_state = 17},
  [8368] = {.lex_state = 239},
  [8369] = {.lex_state = 17},
  [8370] = {.lex_state = 511},
  [8371] = {.lex_state = 17},
  [8372] = {.lex_state = 129},
  [8373] = {.lex_state = 511},
  [8374] = {.lex_state = 17},
  [8375] = {.lex_state = 12},
  [8376] = {.lex_state = 17},
  [8377] = {.lex_state = 17},
  [8378] = {.lex_state = 17},
  [8379] = {.lex_state = 17},
  [8380] = {.lex_state = 17},
  [8381] = {.lex_state = 12},
  [8382] = {.lex_state = 511},
  [8383] = {.lex_state = 511},
  [8384] = {.lex_state = 511},
  [8385] = {.lex_state = 511},
  [8386] = {.lex_state = 511},
  [8387] = {.lex_state = 511},
  [8388] = {.lex_state = 511},
  [8389] = {.lex_state = 511},
  [8390] = {.lex_state = 511},
  [8391] = {.lex_state = 239},
  [8392] = {.lex_state = 17},
  [8393] = {.lex_state = 511},
  [8394] = {.lex_state = 511},
  [8395] = {.lex_state = 17},
  [8396] = {.lex_state = 511},
  [8397] = {.lex_state = 511},
  [8398] = {.lex_state = 511},
  [8399] = {.lex_state = 511},
  [8400] = {.lex_state = 511},
  [8401] = {.lex_state = 511},
  [8402] = {.lex_state = 17},
  [8403] = {.lex_state = 511},
  [8404] = {.lex_state = 511},
  [8405] = {.lex_state = 511},
  [8406] = {.lex_state = 511},
  [8407] = {.lex_state = 511},
  [8408] = {.lex_state = 511},
  [8409] = {.lex_state = 511},
  [8410] = {.lex_state = 511},
  [8411] = {.lex_state = 511},
  [8412] = {.lex_state = 511},
  [8413] = {.lex_state = 511},
  [8414] = {.lex_state = 511},
  [8415] = {.lex_state = 511},
  [8416] = {.lex_state = 12},
  [8417] = {.lex_state = 314},
  [8418] = {.lex_state = 317},
  [8419] = {.lex_state = 12},
  [8420] = {.lex_state = 507},
  [8421] = {.lex_state = 507},
  [8422] = {.lex_state = 263},
  [8423] = {.lex_state = 314, .external_lex_state = 4},
  [8424] = {.lex_state = 239},
  [8425] = {.lex_state = 17},
  [8426] = {.lex_state = 522},
  [8427] = {.lex_state = 17},
  [8428] = {.lex_state = 17},
  [8429] = {.lex_state = 17},
  [8430] = {.lex_state = 12},
  [8431] = {.lex_state = 4},
  [8432] = {.lex_state = 239},
  [8433] = {.lex_state = 12},
  [8434] = {.lex_state = 12},
  [8435] = {.lex_state = 12},
  [8436] = {.lex_state = 66},
  [8437] = {.lex_state = 239},
  [8438] = {.lex_state = 239},
  [8439] = {.lex_state = 239},
  [8440] = {.lex_state = 4},
  [8441] = {.lex_state = 71},
  [8442] = {.lex_state = 258},
  [8443] = {.lex_state = 320, .external_lex_state = 5},
  [8444] = {.lex_state = 12},
  [8445] = {.lex_state = 507},
  [8446] = {.lex_state = 12},
  [8447] = {.lex_state = 314},
  [8448] = {.lex_state = 239},
  [8449] = {.lex_state = 17},
  [8450] = {.lex_state = 507},
  [8451] = {.lex_state = 239},
  [8452] = {.lex_state = 4},
  [8453] = {.lex_state = 511},
  [8454] = {.lex_state = 239},
  [8455] = {.lex_state = 239},
  [8456] = {.lex_state = 239},
  [8457] = {.lex_state = 263},
  [8458] = {.lex_state = 511, .external_lex_state = 4},
  [8459] = {.lex_state = 507},
  [8460] = {.lex_state = 507},
  [8461] = {.lex_state = 8},
  [8462] = {.lex_state = 511, .external_lex_state = 4},
  [8463] = {.lex_state = 507},
  [8464] = {.lex_state = 511},
  [8465] = {.lex_state = 12},
  [8466] = {.lex_state = 507},
  [8467] = {.lex_state = 511},
  [8468] = {.lex_state = 129},
  [8469] = {.lex_state = 507},
  [8470] = {.lex_state = 507},
  [8471] = {.lex_state = 507},
  [8472] = {.lex_state = 507},
  [8473] = {.lex_state = 507},
  [8474] = {.lex_state = 507},
  [8475] = {.lex_state = 507},
  [8476] = {.lex_state = 507},
  [8477] = {.lex_state = 511},
  [8478] = {.lex_state = 507},
  [8479] = {.lex_state = 507},
  [8480] = {.lex_state = 12},
  [8481] = {.lex_state = 12},
  [8482] = {.lex_state = 12},
  [8483] = {.lex_state = 17},
  [8484] = {.lex_state = 342},
  [8485] = {.lex_state = 511},
  [8486] = {.lex_state = 314},
  [8487] = {.lex_state = 511},
  [8488] = {.lex_state = 511},
  [8489] = {.lex_state = 511},
  [8490] = {.lex_state = 8},
  [8491] = {.lex_state = 8},
  [8492] = {.lex_state = 511},
  [8493] = {.lex_state = 8},
  [8494] = {.lex_state = 8},
  [8495] = {.lex_state = 314},
  [8496] = {.lex_state = 314},
  [8497] = {.lex_state = 314},
  [8498] = {.lex_state = 511},
  [8499] = {.lex_state = 314},
  [8500] = {.lex_state = 507},
  [8501] = {.lex_state = 511},
  [8502] = {.lex_state = 17},
  [8503] = {.lex_state = 314},
  [8504] = {.lex_state = 17},
  [8505] = {.lex_state = 12},
  [8506] = {.lex_state = 239},
  [8507] = {.lex_state = 12},
  [8508] = {.lex_state = 507},
  [8509] = {.lex_state = 507},
  [8510] = {.lex_state = 239},
  [8511] = {.lex_state = 8},
  [8512] = {.lex_state = 8},
  [8513] = {.lex_state = 314},
  [8514] = {.lex_state = 507},
  [8515] = {.lex_state = 8},
  [8516] = {.lex_state = 8},
  [8517] = {.lex_state = 507},
  [8518] = {.lex_state = 507},
  [8519] = {.lex_state = 507},
  [8520] = {.lex_state = 511, .external_lex_state = 4},
  [8521] = {.lex_state = 17},
  [8522] = {.lex_state = 263},
  [8523] = {.lex_state = 239},
  [8524] = {.lex_state = 239},
  [8525] = {.lex_state = 17},
  [8526] = {.lex_state = 17},
  [8527] = {.lex_state = 17},
  [8528] = {.lex_state = 17},
  [8529] = {.lex_state = 17},
  [8530] = {.lex_state = 17},
  [8531] = {.lex_state = 17},
  [8532] = {.lex_state = 17},
  [8533] = {.lex_state = 17},
  [8534] = {.lex_state = 17},
  [8535] = {.lex_state = 17},
  [8536] = {.lex_state = 17},
  [8537] = {.lex_state = 17},
  [8538] = {.lex_state = 17},
  [8539] = {.lex_state = 507},
  [8540] = {.lex_state = 507},
  [8541] = {.lex_state = 507},
  [8542] = {.lex_state = 507},
  [8543] = {.lex_state = 507},
  [8544] = {.lex_state = 507},
  [8545] = {.lex_state = 507},
  [8546] = {.lex_state = 507},
  [8547] = {.lex_state = 507},
  [8548] = {.lex_state = 507},
  [8549] = {.lex_state = 507},
  [8550] = {.lex_state = 507},
  [8551] = {.lex_state = 507},
  [8552] = {.lex_state = 507},
  [8553] = {.lex_state = 507},
  [8554] = {.lex_state = 12},
  [8555] = {.lex_state = 507},
  [8556] = {.lex_state = 507},
  [8557] = {.lex_state = 507},
  [8558] = {.lex_state = 507},
  [8559] = {.lex_state = 507},
  [8560] = {.lex_state = 507},
  [8561] = {.lex_state = 507},
  [8562] = {.lex_state = 507},
  [8563] = {.lex_state = 338},
  [8564] = {.lex_state = 338},
  [8565] = {.lex_state = 507},
  [8566] = {.lex_state = 507},
  [8567] = {.lex_state = 338},
  [8568] = {.lex_state = 507},
  [8569] = {.lex_state = 338},
  [8570] = {.lex_state = 507},
  [8571] = {.lex_state = 507},
  [8572] = {.lex_state = 8},
  [8573] = {.lex_state = 8},
  [8574] = {.lex_state = 8},
  [8575] = {.lex_state = 8},
  [8576] = {.lex_state = 8},
  [8577] = {.lex_state = 8},
  [8578] = {.lex_state = 8},
  [8579] = {.lex_state = 511},
  [8580] = {.lex_state = 507},
  [8581] = {.lex_state = 17},
  [8582] = {.lex_state = 320, .external_lex_state = 5},
  [8583] = {.lex_state = 4},
  [8584] = {.lex_state = 4},
  [8585] = {.lex_state = 12},
  [8586] = {.lex_state = 12},
  [8587] = {.lex_state = 8},
  [8588] = {.lex_state = 8},
  [8589] = {.lex_state = 8},
  [8590] = {.lex_state = 8},
  [8591] = {.lex_state = 8},
  [8592] = {.lex_state = 8},
  [8593] = {.lex_state = 8},
  [8594] = {.lex_state = 12},
  [8595] = {.lex_state = 12},
  [8596] = {.lex_state = 12},
  [8597] = {.lex_state = 12},
  [8598] = {.lex_state = 12},
  [8599] = {.lex_state = 12},
  [8600] = {.lex_state = 12},
  [8601] = {.lex_state = 507},
  [8602] = {.lex_state = 12},
  [8603] = {.lex_state = 8},
  [8604] = {.lex_state = 8},
  [8605] = {.lex_state = 8},
  [8606] = {.lex_state = 8},
  [8607] = {.lex_state = 8},
  [8608] = {.lex_state = 8},
  [8609] = {.lex_state = 8},
  [8610] = {.lex_state = 8},
  [8611] = {.lex_state = 8},
  [8612] = {.lex_state = 8},
  [8613] = {.lex_state = 8},
  [8614] = {.lex_state = 8},
  [8615] = {.lex_state = 8},
  [8616] = {.lex_state = 8},
  [8617] = {.lex_state = 507},
  [8618] = {.lex_state = 314},
  [8619] = {.lex_state = 314},
  [8620] = {.lex_state = 511},
  [8621] = {.lex_state = 263},
  [8622] = {.lex_state = 8},
  [8623] = {.lex_state = 314},
  [8624] = {.lex_state = 338},
  [8625] = {.lex_state = 314},
  [8626] = {.lex_state = 511},
  [8627] = {.lex_state = 314},
  [8628] = {.lex_state = 511},
  [8629] = {.lex_state = 511},
  [8630] = {.lex_state = 511},
  [8631] = {.lex_state = 338},
  [8632] = {.lex_state = 511},
  [8633] = {.lex_state = 511},
  [8634] = {.lex_state = 314},
  [8635] = {.lex_state = 511, .external_lex_state = 4},
  [8636] = {.lex_state = 314},
  [8637] = {.lex_state = 17},
  [8638] = {.lex_state = 314},
  [8639] = {.lex_state = 338},
  [8640] = {.lex_state = 314},
  [8641] = {.lex_state = 314},
  [8642] = {.lex_state = 314},
  [8643] = {.lex_state = 314},
  [8644] = {.lex_state = 314},
  [8645] = {.lex_state = 314},
  [8646] = {.lex_state = 314},
  [8647] = {.lex_state = 314},
  [8648] = {.lex_state = 511},
  [8649] = {.lex_state = 511},
  [8650] = {.lex_state = 511},
  [8651] = {.lex_state = 338},
  [8652] = {.lex_state = 511},
  [8653] = {.lex_state = 314},
  [8654] = {.lex_state = 511},
  [8655] = {.lex_state = 511},
  [8656] = {.lex_state = 511},
  [8657] = {.lex_state = 314},
  [8658] = {.lex_state = 8},
  [8659] = {.lex_state = 314},
  [8660] = {.lex_state = 511},
  [8661] = {.lex_state = 511},
  [8662] = {.lex_state = 511},
  [8663] = {.lex_state = 511},
  [8664] = {.lex_state = 511},
  [8665] = {.lex_state = 511},
  [8666] = {.lex_state = 511},
  [8667] = {.lex_state = 511},
  [8668] = {.lex_state = 511},
  [8669] = {.lex_state = 511},
  [8670] = {.lex_state = 511},
  [8671] = {.lex_state = 511},
  [8672] = {.lex_state = 511},
  [8673] = {.lex_state = 511},
  [8674] = {.lex_state = 511},
  [8675] = {.lex_state = 511},
  [8676] = {.lex_state = 314},
  [8677] = {.lex_state = 314},
  [8678] = {.lex_state = 511},
  [8679] = {.lex_state = 314},
  [8680] = {.lex_state = 511},
  [8681] = {.lex_state = 314},
  [8682] = {.lex_state = 314},
  [8683] = {.lex_state = 314},
  [8684] = {.lex_state = 511},
  [8685] = {.lex_state = 338},
  [8686] = {.lex_state = 17},
  [8687] = {.lex_state = 17},
  [8688] = {.lex_state = 17},
  [8689] = {.lex_state = 511},
  [8690] = {.lex_state = 17},
  [8691] = {.lex_state = 507},
  [8692] = {.lex_state = 317},
  [8693] = {.lex_state = 17},
  [8694] = {.lex_state = 511},
  [8695] = {.lex_state = 511},
  [8696] = {.lex_state = 17},
  [8697] = {.lex_state = 507},
  [8698] = {.lex_state = 507},
  [8699] = {.lex_state = 507},
  [8700] = {.lex_state = 507},
  [8701] = {.lex_state = 507},
  [8702] = {.lex_state = 511},
  [8703] = {.lex_state = 12},
  [8704] = {.lex_state = 511},
  [8705] = {.lex_state = 317},
  [8706] = {.lex_state = 314},
  [8707] = {.lex_state = 511},
  [8708] = {.lex_state = 314},
  [8709] = {.lex_state = 17},
  [8710] = {.lex_state = 17},
  [8711] = {.lex_state = 239},
  [8712] = {.lex_state = 17},
  [8713] = {.lex_state = 17},
  [8714] = {.lex_state = 17},
  [8715] = {.lex_state = 17},
  [8716] = {.lex_state = 17},
  [8717] = {.lex_state = 511},
  [8718] = {.lex_state = 17},
  [8719] = {.lex_state = 511},
  [8720] = {.lex_state = 12},
  [8721] = {.lex_state = 239},
  [8722] = {.lex_state = 133},
  [8723] = {.lex_state = 314},
  [8724] = {.lex_state = 314, .external_lex_state = 4},
  [8725] = {.lex_state = 511},
  [8726] = {.lex_state = 511},
  [8727] = {.lex_state = 135},
  [8728] = {.lex_state = 511},
  [8729] = {.lex_state = 511},
  [8730] = {.lex_state = 511},
  [8731] = {.lex_state = 511},
  [8732] = {.lex_state = 511},
  [8733] = {.lex_state = 511},
  [8734] = {.lex_state = 511},
  [8735] = {.lex_state = 511},
  [8736] = {.lex_state = 511},
  [8737] = {.lex_state = 511},
  [8738] = {.lex_state = 338},
  [8739] = {.lex_state = 511},
  [8740] = {.lex_state = 507},
  [8741] = {.lex_state = 511},
  [8742] = {.lex_state = 314},
  [8743] = {.lex_state = 338},
  [8744] = {.lex_state = 8},
  [8745] = {.lex_state = 343},
  [8746] = {.lex_state = 511},
  [8747] = {.lex_state = 511},
  [8748] = {.lex_state = 314},
  [8749] = {.lex_state = 507},
  [8750] = {.lex_state = 317},
  [8751] = {.lex_state = 314, .external_lex_state = 4},
  [8752] = {.lex_state = 511},
  [8753] = {.lex_state = 511},
  [8754] = {.lex_state = 239},
  [8755] = {.lex_state = 239},
  [8756] = {.lex_state = 314},
  [8757] = {.lex_state = 8},
  [8758] = {.lex_state = 511},
  [8759] = {.lex_state = 511},
  [8760] = {.lex_state = 314},
  [8761] = {.lex_state = 511},
  [8762] = {.lex_state = 314},
  [8763] = {.lex_state = 314},
  [8764] = {.lex_state = 511},
  [8765] = {.lex_state = 511},
  [8766] = {.lex_state = 338},
  [8767] = {.lex_state = 511},
  [8768] = {.lex_state = 338},
  [8769] = {.lex_state = 338},
  [8770] = {.lex_state = 338},
  [8771] = {.lex_state = 17},
  [8772] = {.lex_state = 17},
  [8773] = {.lex_state = 338},
  [8774] = {.lex_state = 12},
  [8775] = {.lex_state = 338},
  [8776] = {.lex_state = 338},
  [8777] = {.lex_state = 338},
  [8778] = {.lex_state = 338},
  [8779] = {.lex_state = 338},
  [8780] = {.lex_state = 511},
  [8781] = {.lex_state = 338},
  [8782] = {.lex_state = 12},
  [8783] = {.lex_state = 338},
  [8784] = {.lex_state = 511},
  [8785] = {.lex_state = 511},
  [8786] = {.lex_state = 338},
  [8787] = {.lex_state = 507},
  [8788] = {.lex_state = 338},
  [8789] = {.lex_state = 338},
  [8790] = {.lex_state = 511},
  [8791] = {.lex_state = 338},
  [8792] = {.lex_state = 338},
  [8793] = {.lex_state = 338},
  [8794] = {.lex_state = 338},
  [8795] = {.lex_state = 321},
  [8796] = {.lex_state = 314},
  [8797] = {.lex_state = 338},
  [8798] = {.lex_state = 314},
  [8799] = {.lex_state = 511},
  [8800] = {.lex_state = 8},
  [8801] = {.lex_state = 239},
  [8802] = {.lex_state = 239},
  [8803] = {.lex_state = 338},
  [8804] = {.lex_state = 338},
  [8805] = {.lex_state = 314},
  [8806] = {.lex_state = 314},
  [8807] = {.lex_state = 511},
  [8808] = {.lex_state = 511},
  [8809] = {.lex_state = 338},
  [8810] = {.lex_state = 314},
  [8811] = {.lex_state = 338},
  [8812] = {.lex_state = 511},
  [8813] = {.lex_state = 12},
  [8814] = {.lex_state = 314},
  [8815] = {.lex_state = 314},
  [8816] = {.lex_state = 314},
  [8817] = {.lex_state = 12},
  [8818] = {.lex_state = 522},
  [8819] = {.lex_state = 507, .external_lex_state = 4},
  [8820] = {.lex_state = 338},
  [8821] = {.lex_state = 511},
  [8822] = {.lex_state = 511},
  [8823] = {.lex_state = 511},
  [8824] = {.lex_state = 338},
  [8825] = {.lex_state = 511},
  [8826] = {.lex_state = 511},
  [8827] = {.lex_state = 338},
  [8828] = {.lex_state = 511},
  [8829] = {.lex_state = 511},
  [8830] = {.lex_state = 338},
  [8831] = {.lex_state = 511},
  [8832] = {.lex_state = 511},
  [8833] = {.lex_state = 338},
  [8834] = {.lex_state = 317},
  [8835] = {.lex_state = 8},
  [8836] = {.lex_state = 8},
  [8837] = {.lex_state = 507},
  [8838] = {.lex_state = 511},
  [8839] = {.lex_state = 511},
  [8840] = {.lex_state = 511},
  [8841] = {.lex_state = 317},
  [8842] = {.lex_state = 511},
  [8843] = {.lex_state = 511},
  [8844] = {.lex_state = 511},
  [8845] = {.lex_state = 338},
  [8846] = {.lex_state = 239},
  [8847] = {.lex_state = 338},
  [8848] = {.lex_state = 338},
  [8849] = {.lex_state = 338},
  [8850] = {.lex_state = 511},
  [8851] = {.lex_state = 511},
  [8852] = {.lex_state = 338},
  [8853] = {.lex_state = 338},
  [8854] = {.lex_state = 314},
  [8855] = {.lex_state = 511},
  [8856] = {.lex_state = 263},
  [8857] = {.lex_state = 317},
  [8858] = {.lex_state = 511},
  [8859] = {.lex_state = 511},
  [8860] = {.lex_state = 511},
  [8861] = {.lex_state = 338},
  [8862] = {.lex_state = 511},
  [8863] = {.lex_state = 511},
  [8864] = {.lex_state = 511},
  [8865] = {.lex_state = 511},
  [8866] = {.lex_state = 338},
  [8867] = {.lex_state = 511},
  [8868] = {.lex_state = 511},
  [8869] = {.lex_state = 320},
  [8870] = {.lex_state = 314},
  [8871] = {.lex_state = 511},
  [8872] = {.lex_state = 8},
  [8873] = {.lex_state = 320},
  [8874] = {.lex_state = 320},
  [8875] = {.lex_state = 320},
  [8876] = {.lex_state = 338},
  [8877] = {.lex_state = 511},
  [8878] = {.lex_state = 338},
  [8879] = {.lex_state = 12},
  [8880] = {.lex_state = 12},
  [8881] = {.lex_state = 12},
  [8882] = {.lex_state = 12},
  [8883] = {.lex_state = 522},
  [8884] = {.lex_state = 507, .external_lex_state = 4},
  [8885] = {.lex_state = 263},
  [8886] = {.lex_state = 12},
  [8887] = {.lex_state = 12},
  [8888] = {.lex_state = 12},
  [8889] = {.lex_state = 12},
  [8890] = {.lex_state = 12},
  [8891] = {.lex_state = 338},
  [8892] = {.lex_state = 12},
  [8893] = {.lex_state = 12},
  [8894] = {.lex_state = 511},
  [8895] = {.lex_state = 12},
  [8896] = {.lex_state = 314},
  [8897] = {.lex_state = 507},
  [8898] = {.lex_state = 511},
  [8899] = {.lex_state = 507},
  [8900] = {.lex_state = 507},
  [8901] = {.lex_state = 511},
  [8902] = {.lex_state = 507},
  [8903] = {.lex_state = 8},
  [8904] = {.lex_state = 522},
  [8905] = {.lex_state = 338},
  [8906] = {.lex_state = 8},
  [8907] = {.lex_state = 8},
  [8908] = {.lex_state = 507},
  [8909] = {.lex_state = 522},
  [8910] = {.lex_state = 263},
  [8911] = {.lex_state = 507},
  [8912] = {.lex_state = 511},
  [8913] = {.lex_state = 8},
  [8914] = {.lex_state = 511},
  [8915] = {.lex_state = 511},
  [8916] = {.lex_state = 511},
  [8917] = {.lex_state = 511},
  [8918] = {.lex_state = 511},
  [8919] = {.lex_state = 507},
  [8920] = {.lex_state = 8},
  [8921] = {.lex_state = 507},
  [8922] = {.lex_state = 8},
  [8923] = {.lex_state = 8},
  [8924] = {.lex_state = 511},
  [8925] = {.lex_state = 511},
  [8926] = {.lex_state = 17},
  [8927] = {.lex_state = 511},
  [8928] = {.lex_state = 239},
  [8929] = {.lex_state = 507},
  [8930] = {.lex_state = 8},
  [8931] = {.lex_state = 239},
  [8932] = {.lex_state = 8},
  [8933] = {.lex_state = 239},
  [8934] = {.lex_state = 8},
  [8935] = {.lex_state = 314},
  [8936] = {.lex_state = 507},
  [8937] = {.lex_state = 239},
  [8938] = {.lex_state = 239},
  [8939] = {.lex_state = 239},
  [8940] = {.lex_state = 239},
  [8941] = {.lex_state = 239},
  [8942] = {.lex_state = 239},
  [8943] = {.lex_state = 239},
  [8944] = {.lex_state = 239},
  [8945] = {.lex_state = 338},
  [8946] = {.lex_state = 338},
  [8947] = {.lex_state = 511},
  [8948] = {.lex_state = 320},
  [8949] = {.lex_state = 320},
  [8950] = {.lex_state = 314},
  [8951] = {.lex_state = 320},
  [8952] = {.lex_state = 320},
  [8953] = {.lex_state = 314},
  [8954] = {.lex_state = 320, .external_lex_state = 4},
  [8955] = {.lex_state = 320},
  [8956] = {.lex_state = 344},
  [8957] = {.lex_state = 314},
  [8958] = {.lex_state = 323},
  [8959] = {.lex_state = 320},
  [8960] = {.lex_state = 320},
  [8961] = {.lex_state = 320, .external_lex_state = 4},
  [8962] = {.lex_state = 320},
  [8963] = {.lex_state = 320},
  [8964] = {.lex_state = 320},
  [8965] = {.lex_state = 320, .external_lex_state = 4},
  [8966] = {.lex_state = 314},
  [8967] = {.lex_state = 263},
  [8968] = {.lex_state = 314},
  [8969] = {.lex_state = 314},
  [8970] = {.lex_state = 314},
  [8971] = {.lex_state = 338},
  [8972] = {.lex_state = 320},
  [8973] = {.lex_state = 314},
  [8974] = {.lex_state = 314},
  [8975] = {.lex_state = 314},
  [8976] = {.lex_state = 314},
  [8977] = {.lex_state = 314},
  [8978] = {.lex_state = 320},
  [8979] = {.lex_state = 320},
  [8980] = {.lex_state = 314},
  [8981] = {.lex_state = 320},
  [8982] = {.lex_state = 323},
  [8983] = {.lex_state = 320},
  [8984] = {.lex_state = 314},
  [8985] = {.lex_state = 320},
  [8986] = {.lex_state = 511},
  [8987] = {.lex_state = 511},
  [8988] = {.lex_state = 511},
  [8989] = {.lex_state = 511},
  [8990] = {.lex_state = 511},
  [8991] = {.lex_state = 511},
  [8992] = {.lex_state = 511},
  [8993] = {.lex_state = 511},
  [8994] = {.lex_state = 511},
  [8995] = {.lex_state = 511},
  [8996] = {.lex_state = 511},
  [8997] = {.lex_state = 511},
  [8998] = {.lex_state = 511},
  [8999] = {.lex_state = 511},
  [9000] = {.lex_state = 522},
  [9001] = {.lex_state = 320},
  [9002] = {.lex_state = 314},
  [9003] = {.lex_state = 314},
  [9004] = {.lex_state = 320},
  [9005] = {.lex_state = 320, .external_lex_state = 4},
  [9006] = {.lex_state = 320},
  [9007] = {.lex_state = 320},
  [9008] = {.lex_state = 314},
  [9009] = {.lex_state = 314},
  [9010] = {.lex_state = 338},
  [9011] = {.lex_state = 511},
  [9012] = {.lex_state = 323},
  [9013] = {.lex_state = 320, .external_lex_state = 4},
  [9014] = {.lex_state = 320},
  [9015] = {.lex_state = 320},
  [9016] = {.lex_state = 320},
  [9017] = {.lex_state = 338},
  [9018] = {.lex_state = 320},
  [9019] = {.lex_state = 320},
  [9020] = {.lex_state = 320},
  [9021] = {.lex_state = 511},
  [9022] = {.lex_state = 314},
  [9023] = {.lex_state = 314},
  [9024] = {.lex_state = 323},
  [9025] = {.lex_state = 314},
  [9026] = {.lex_state = 314},
  [9027] = {.lex_state = 320},
  [9028] = {.lex_state = 320},
  [9029] = {.lex_state = 263},
  [9030] = {.lex_state = 511},
  [9031] = {.lex_state = 507},
  [9032] = {.lex_state = 511},
  [9033] = {.lex_state = 314},
  [9034] = {.lex_state = 320},
  [9035] = {.lex_state = 137},
  [9036] = {.lex_state = 320},
  [9037] = {.lex_state = 511},
  [9038] = {.lex_state = 320},
  [9039] = {.lex_state = 507},
  [9040] = {.lex_state = 314},
  [9041] = {.lex_state = 511},
  [9042] = {.lex_state = 511},
  [9043] = {.lex_state = 511},
  [9044] = {.lex_state = 511},
  [9045] = {.lex_state = 511},
  [9046] = {.lex_state = 511},
  [9047] = {.lex_state = 511},
  [9048] = {.lex_state = 511},
  [9049] = {.lex_state = 511},
  [9050] = {.lex_state = 511},
  [9051] = {.lex_state = 511},
  [9052] = {.lex_state = 511},
  [9053] = {.lex_state = 320},
  [9054] = {.lex_state = 511},
  [9055] = {.lex_state = 511},
  [9056] = {.lex_state = 320},
  [9057] = {.lex_state = 320},
  [9058] = {.lex_state = 317},
  [9059] = {.lex_state = 320},
  [9060] = {.lex_state = 320},
  [9061] = {.lex_state = 320},
  [9062] = {.lex_state = 314},
  [9063] = {.lex_state = 314},
  [9064] = {.lex_state = 320},
  [9065] = {.lex_state = 314},
  [9066] = {.lex_state = 314},
  [9067] = {.lex_state = 511},
  [9068] = {.lex_state = 314},
  [9069] = {.lex_state = 320},
  [9070] = {.lex_state = 314},
  [9071] = {.lex_state = 314},
  [9072] = {.lex_state = 314},
  [9073] = {.lex_state = 314},
  [9074] = {.lex_state = 314},
  [9075] = {.lex_state = 314},
  [9076] = {.lex_state = 314},
  [9077] = {.lex_state = 314},
  [9078] = {.lex_state = 314},
  [9079] = {.lex_state = 507},
  [9080] = {.lex_state = 314},
  [9081] = {.lex_state = 314},
  [9082] = {.lex_state = 314},
  [9083] = {.lex_state = 314},
  [9084] = {.lex_state = 507},
  [9085] = {.lex_state = 507},
  [9086] = {.lex_state = 507},
  [9087] = {.lex_state = 507},
  [9088] = {.lex_state = 507},
  [9089] = {.lex_state = 507},
  [9090] = {.lex_state = 507},
  [9091] = {.lex_state = 507},
  [9092] = {.lex_state = 507},
  [9093] = {.lex_state = 507},
  [9094] = {.lex_state = 507},
  [9095] = {.lex_state = 507},
  [9096] = {.lex_state = 320},
  [9097] = {.lex_state = 320},
  [9098] = {.lex_state = 314},
  [9099] = {.lex_state = 320},
  [9100] = {.lex_state = 314},
  [9101] = {.lex_state = 338},
  [9102] = {.lex_state = 320},
  [9103] = {.lex_state = 320},
  [9104] = {.lex_state = 139},
  [9105] = {.lex_state = 314},
  [9106] = {.lex_state = 320},
  [9107] = {.lex_state = 320},
  [9108] = {.lex_state = 314},
  [9109] = {.lex_state = 320},
  [9110] = {.lex_state = 323},
  [9111] = {.lex_state = 320},
  [9112] = {.lex_state = 320},
  [9113] = {.lex_state = 320},
  [9114] = {.lex_state = 314},
  [9115] = {.lex_state = 320},
  [9116] = {.lex_state = 511},
  [9117] = {.lex_state = 507},
  [9118] = {.lex_state = 314},
  [9119] = {.lex_state = 320},
  [9120] = {.lex_state = 507},
  [9121] = {.lex_state = 320},
  [9122] = {.lex_state = 320},
  [9123] = {.lex_state = 511},
  [9124] = {.lex_state = 320, .external_lex_state = 4},
  [9125] = {.lex_state = 511},
  [9126] = {.lex_state = 314},
  [9127] = {.lex_state = 320},
  [9128] = {.lex_state = 314},
  [9129] = {.lex_state = 320},
  [9130] = {.lex_state = 141},
  [9131] = {.lex_state = 507},
  [9132] = {.lex_state = 320},
  [9133] = {.lex_state = 320},
  [9134] = {.lex_state = 511},
  [9135] = {.lex_state = 314},
  [9136] = {.lex_state = 507},
  [9137] = {.lex_state = 320},
  [9138] = {.lex_state = 314},
  [9139] = {.lex_state = 507},
  [9140] = {.lex_state = 314},
  [9141] = {.lex_state = 314},
  [9142] = {.lex_state = 338},
  [9143] = {.lex_state = 320},
  [9144] = {.lex_state = 314},
  [9145] = {.lex_state = 320},
  [9146] = {.lex_state = 320},
  [9147] = {.lex_state = 320},
  [9148] = {.lex_state = 320},
  [9149] = {.lex_state = 320},
  [9150] = {.lex_state = 320},
  [9151] = {.lex_state = 320},
  [9152] = {.lex_state = 320},
  [9153] = {.lex_state = 320},
  [9154] = {.lex_state = 320},
  [9155] = {.lex_state = 314},
  [9156] = {.lex_state = 314},
  [9157] = {.lex_state = 314},
  [9158] = {.lex_state = 314},
  [9159] = {.lex_state = 314},
  [9160] = {.lex_state = 314},
  [9161] = {.lex_state = 314},
  [9162] = {.lex_state = 314},
  [9163] = {.lex_state = 314},
  [9164] = {.lex_state = 314},
  [9165] = {.lex_state = 314},
  [9166] = {.lex_state = 314},
  [9167] = {.lex_state = 511},
  [9168] = {.lex_state = 320},
  [9169] = {.lex_state = 320},
  [9170] = {.lex_state = 320},
  [9171] = {.lex_state = 320},
  [9172] = {.lex_state = 511},
  [9173] = {.lex_state = 535},
  [9174] = {.lex_state = 511},
  [9175] = {.lex_state = 320},
  [9176] = {.lex_state = 320},
  [9177] = {.lex_state = 320},
  [9178] = {.lex_state = 320},
  [9179] = {.lex_state = 511},
  [9180] = {.lex_state = 511},
  [9181] = {.lex_state = 511},
  [9182] = {.lex_state = 511},
  [9183] = {.lex_state = 320},
  [9184] = {.lex_state = 320},
  [9185] = {.lex_state = 320},
  [9186] = {.lex_state = 320},
  [9187] = {.lex_state = 320},
  [9188] = {.lex_state = 320},
  [9189] = {.lex_state = 320},
  [9190] = {.lex_state = 320},
  [9191] = {.lex_state = 320},
  [9192] = {.lex_state = 320},
  [9193] = {.lex_state = 511},
  [9194] = {.lex_state = 320},
  [9195] = {.lex_state = 320},
  [9196] = {.lex_state = 320},
  [9197] = {.lex_state = 511},
  [9198] = {.lex_state = 320},
  [9199] = {.lex_state = 511},
  [9200] = {.lex_state = 320},
  [9201] = {.lex_state = 320},
  [9202] = {.lex_state = 320},
  [9203] = {.lex_state = 320},
  [9204] = {.lex_state = 320},
  [9205] = {.lex_state = 320},
  [9206] = {.lex_state = 320},
  [9207] = {.lex_state = 320},
  [9208] = {.lex_state = 320},
  [9209] = {.lex_state = 320},
  [9210] = {.lex_state = 320},
  [9211] = {.lex_state = 511},
  [9212] = {.lex_state = 320},
  [9213] = {.lex_state = 511},
  [9214] = {.lex_state = 320},
  [9215] = {.lex_state = 320},
  [9216] = {.lex_state = 320},
  [9217] = {.lex_state = 511},
  [9218] = {.lex_state = 511},
  [9219] = {.lex_state = 320},
  [9220] = {.lex_state = 511},
  [9221] = {.lex_state = 511},
  [9222] = {.lex_state = 320},
  [9223] = {.lex_state = 320},
  [9224] = {.lex_state = 511},
  [9225] = {.lex_state = 320},
  [9226] = {.lex_state = 320},
  [9227] = {.lex_state = 320},
  [9228] = {.lex_state = 320},
  [9229] = {.lex_state = 320},
  [9230] = {.lex_state = 320},
  [9231] = {.lex_state = 320},
  [9232] = {.lex_state = 320},
  [9233] = {.lex_state = 320},
  [9234] = {.lex_state = 320},
  [9235] = {.lex_state = 320},
  [9236] = {.lex_state = 320},
  [9237] = {.lex_state = 320},
  [9238] = {.lex_state = 320},
  [9239] = {.lex_state = 320},
  [9240] = {.lex_state = 320},
  [9241] = {.lex_state = 320},
  [9242] = {.lex_state = 320},
  [9243] = {.lex_state = 320},
  [9244] = {.lex_state = 320},
  [9245] = {.lex_state = 320},
  [9246] = {.lex_state = 320},
  [9247] = {.lex_state = 320},
  [9248] = {.lex_state = 320},
  [9249] = {.lex_state = 320},
  [9250] = {.lex_state = 507},
  [9251] = {.lex_state = 320},
  [9252] = {.lex_state = 314},
  [9253] = {.lex_state = 320},
  [9254] = {.lex_state = 320},
  [9255] = {.lex_state = 320},
  [9256] = {.lex_state = 320},
  [9257] = {.lex_state = 320},
  [9258] = {.lex_state = 323},
  [9259] = {.lex_state = 320},
  [9260] = {.lex_state = 320},
  [9261] = {.lex_state = 320},
  [9262] = {.lex_state = 320},
  [9263] = {.lex_state = 320},
  [9264] = {.lex_state = 144},
  [9265] = {.lex_state = 314},
  [9266] = {.lex_state = 511},
  [9267] = {.lex_state = 314},
  [9268] = {.lex_state = 320},
  [9269] = {.lex_state = 320},
  [9270] = {.lex_state = 507},
  [9271] = {.lex_state = 507},
  [9272] = {.lex_state = 511},
  [9273] = {.lex_state = 320},
  [9274] = {.lex_state = 320},
  [9275] = {.lex_state = 507},
  [9276] = {.lex_state = 507},
  [9277] = {.lex_state = 314},
  [9278] = {.lex_state = 314},
  [9279] = {.lex_state = 333},
  [9280] = {.lex_state = 507},
  [9281] = {.lex_state = 507},
  [9282] = {.lex_state = 507},
  [9283] = {.lex_state = 507},
  [9284] = {.lex_state = 507},
  [9285] = {.lex_state = 507},
  [9286] = {.lex_state = 320},
  [9287] = {.lex_state = 320},
  [9288] = {.lex_state = 320},
  [9289] = {.lex_state = 320},
  [9290] = {.lex_state = 320},
  [9291] = {.lex_state = 507},
  [9292] = {.lex_state = 320},
  [9293] = {.lex_state = 320},
  [9294] = {.lex_state = 320},
  [9295] = {.lex_state = 511},
  [9296] = {.lex_state = 320},
  [9297] = {.lex_state = 314},
  [9298] = {.lex_state = 320},
  [9299] = {.lex_state = 320},
  [9300] = {.lex_state = 320},
  [9301] = {.lex_state = 507},
  [9302] = {.lex_state = 507},
  [9303] = {.lex_state = 507},
  [9304] = {.lex_state = 507},
  [9305] = {.lex_state = 507},
  [9306] = {.lex_state = 507},
  [9307] = {.lex_state = 507},
  [9308] = {.lex_state = 320},
  [9309] = {.lex_state = 320},
  [9310] = {.lex_state = 320},
  [9311] = {.lex_state = 320},
  [9312] = {.lex_state = 320},
  [9313] = {.lex_state = 320},
  [9314] = {.lex_state = 320},
  [9315] = {.lex_state = 320},
  [9316] = {.lex_state = 320},
  [9317] = {.lex_state = 320},
  [9318] = {.lex_state = 320},
  [9319] = {.lex_state = 320},
  [9320] = {.lex_state = 320},
  [9321] = {.lex_state = 320},
  [9322] = {.lex_state = 320},
  [9323] = {.lex_state = 320},
  [9324] = {.lex_state = 320},
  [9325] = {.lex_state = 320},
  [9326] = {.lex_state = 320},
  [9327] = {.lex_state = 320},
  [9328] = {.lex_state = 320},
  [9329] = {.lex_state = 320},
  [9330] = {.lex_state = 320},
  [9331] = {.lex_state = 320},
  [9332] = {.lex_state = 320},
  [9333] = {.lex_state = 320},
  [9334] = {.lex_state = 320},
  [9335] = {.lex_state = 320},
  [9336] = {.lex_state = 146, .external_lex_state = 3},
  [9337] = {.lex_state = 291, .external_lex_state = 3},
  [9338] = {.lex_state = 148, .external_lex_state = 3},
  [9339] = {.lex_state = 345},
  [9340] = {.lex_state = 305, .external_lex_state = 3},
  [9341] = {.lex_state = 150, .external_lex_state = 3},
  [9342] = {.lex_state = 152, .external_lex_state = 3},
  [9343] = {.lex_state = 154, .external_lex_state = 3},
  [9344] = {.lex_state = 332},
  [9345] = {.lex_state = 156, .external_lex_state = 3},
  [9346] = {.lex_state = 31},
  [9347] = {.lex_state = 31},
  [9348] = {.lex_state = 31},
  [9349] = {.lex_state = 31},
  [9350] = {.lex_state = 31},
  [9351] = {.lex_state = 31},
  [9352] = {.lex_state = 31},
  [9353] = {.lex_state = 31},
  [9354] = {.lex_state = 31},
  [9355] = {.lex_state = 31},
  [9356] = {.lex_state = 31},
  [9357] = {.lex_state = 31},
  [9358] = {.lex_state = 31},
  [9359] = {.lex_state = 31},
  [9360] = {.lex_state = 31},
  [9361] = {.lex_state = 31},
  [9362] = {.lex_state = 31},
  [9363] = {.lex_state = 31},
  [9364] = {.lex_state = 31},
  [9365] = {.lex_state = 31},
  [9366] = {.lex_state = 31},
  [9367] = {.lex_state = 31},
  [9368] = {.lex_state = 31},
  [9369] = {.lex_state = 31},
  [9370] = {.lex_state = 31},
  [9371] = {.lex_state = 537, .external_lex_state = 3},
  [9372] = {.lex_state = 31},
  [9373] = {.lex_state = 31},
  [9374] = {.lex_state = 31},
  [9375] = {.lex_state = 31},
  [9376] = {.lex_state = 31},
  [9377] = {.lex_state = 31},
  [9378] = {.lex_state = 31},
  [9379] = {.lex_state = 31},
  [9380] = {.lex_state = 31},
  [9381] = {.lex_state = 31},
  [9382] = {.lex_state = 31},
  [9383] = {.lex_state = 31},
  [9384] = {.lex_state = 31},
  [9385] = {.lex_state = 31},
  [9386] = {.lex_state = 31},
  [9387] = {.lex_state = 31},
  [9388] = {.lex_state = 31},
  [9389] = {.lex_state = 306, .external_lex_state = 3},
  [9390] = {.lex_state = 31},
  [9391] = {.lex_state = 31},
  [9392] = {.lex_state = 31},
  [9393] = {.lex_state = 31},
  [9394] = {.lex_state = 31},
  [9395] = {.lex_state = 31},
  [9396] = {.lex_state = 31},
  [9397] = {.lex_state = 31},
  [9398] = {.lex_state = 31},
  [9399] = {.lex_state = 31},
  [9400] = {.lex_state = 31},
  [9401] = {.lex_state = 31},
  [9402] = {.lex_state = 31},
  [9403] = {.lex_state = 31},
  [9404] = {.lex_state = 31},
  [9405] = {.lex_state = 31},
  [9406] = {.lex_state = 31},
  [9407] = {.lex_state = 31},
  [9408] = {.lex_state = 31},
  [9409] = {.lex_state = 31},
  [9410] = {.lex_state = 309, .external_lex_state = 3},
  [9411] = {.lex_state = 27, .external_lex_state = 5},
  [9412] = {.lex_state = 27, .external_lex_state = 5},
  [9413] = {.lex_state = 27},
  [9414] = {.lex_state = 159},
  [9415] = {.lex_state = 159},
  [9416] = {.lex_state = 161},
  [9417] = {.lex_state = 27},
  [9418] = {.lex_state = 159},
  [9419] = {.lex_state = 159},
  [9420] = {.lex_state = 159},
  [9421] = {.lex_state = 159},
  [9422] = {.lex_state = 159},
  [9423] = {.lex_state = 159},
  [9424] = {.lex_state = 27},
  [9425] = {.lex_state = 27},
  [9426] = {.lex_state = 27},
  [9427] = {.lex_state = 27},
  [9428] = {.lex_state = 31},
  [9429] = {.lex_state = 159},
  [9430] = {.lex_state = 159},
  [9431] = {.lex_state = 159},
  [9432] = {.lex_state = 27},
  [9433] = {.lex_state = 27},
  [9434] = {.lex_state = 27},
  [9435] = {.lex_state = 27},
  [9436] = {.lex_state = 27},
  [9437] = {.lex_state = 27},
  [9438] = {.lex_state = 27},
  [9439] = {.lex_state = 27},
  [9440] = {.lex_state = 27},
  [9441] = {.lex_state = 27},
  [9442] = {.lex_state = 27},
  [9443] = {.lex_state = 27},
  [9444] = {.lex_state = 27},
  [9445] = {.lex_state = 27},
  [9446] = {.lex_state = 27},
  [9447] = {.lex_state = 27},
  [9448] = {.lex_state = 27},
  [9449] = {.lex_state = 27},
  [9450] = {.lex_state = 27},
  [9451] = {.lex_state = 27},
  [9452] = {.lex_state = 27},
  [9453] = {.lex_state = 27},
  [9454] = {.lex_state = 27},
  [9455] = {.lex_state = 27},
  [9456] = {.lex_state = 27},
  [9457] = {.lex_state = 27},
  [9458] = {.lex_state = 27},
  [9459] = {.lex_state = 27},
  [9460] = {.lex_state = 27},
  [9461] = {.lex_state = 27},
  [9462] = {.lex_state = 27},
  [9463] = {.lex_state = 27},
  [9464] = {.lex_state = 31},
  [9465] = {.lex_state = 27},
  [9466] = {.lex_state = 27},
  [9467] = {.lex_state = 27},
  [9468] = {.lex_state = 27},
  [9469] = {.lex_state = 27},
  [9470] = {.lex_state = 305, .external_lex_state = 3},
  [9471] = {.lex_state = 305, .external_lex_state = 3},
  [9472] = {.lex_state = 354},
  [9473] = {.lex_state = 354},
  [9474] = {.lex_state = 566},
  [9475] = {.lex_state = 354},
  [9476] = {.lex_state = 349},
  [9477] = {.lex_state = 349},
  [9478] = {.lex_state = 349},
  [9479] = {.lex_state = 349},
  [9480] = {.lex_state = 349},
  [9481] = {.lex_state = 349},
  [9482] = {.lex_state = 349},
  [9483] = {.lex_state = 349},
  [9484] = {.lex_state = 349},
  [9485] = {.lex_state = 349},
  [9486] = {.lex_state = 349},
  [9487] = {.lex_state = 349},
  [9488] = {.lex_state = 349},
  [9489] = {.lex_state = 349},
  [9490] = {.lex_state = 349},
  [9491] = {.lex_state = 349},
  [9492] = {.lex_state = 349},
  [9493] = {.lex_state = 349},
  [9494] = {.lex_state = 349},
  [9495] = {.lex_state = 349},
  [9496] = {.lex_state = 349},
  [9497] = {.lex_state = 349},
  [9498] = {.lex_state = 349},
  [9499] = {.lex_state = 349},
  [9500] = {.lex_state = 349},
  [9501] = {.lex_state = 349},
  [9502] = {.lex_state = 349},
  [9503] = {.lex_state = 349},
  [9504] = {.lex_state = 349},
  [9505] = {.lex_state = 349},
  [9506] = {.lex_state = 349},
  [9507] = {.lex_state = 349},
  [9508] = {.lex_state = 349},
  [9509] = {.lex_state = 349},
  [9510] = {.lex_state = 349},
  [9511] = {.lex_state = 349},
  [9512] = {.lex_state = 349},
  [9513] = {.lex_state = 349},
  [9514] = {.lex_state = 349},
  [9515] = {.lex_state = 349},
  [9516] = {.lex_state = 349},
  [9517] = {.lex_state = 349},
  [9518] = {.lex_state = 349},
  [9519] = {.lex_state = 349},
  [9520] = {.lex_state = 349},
  [9521] = {.lex_state = 349},
  [9522] = {.lex_state = 349},
  [9523] = {.lex_state = 349},
  [9524] = {.lex_state = 349},
  [9525] = {.lex_state = 349},
  [9526] = {.lex_state = 349},
  [9527] = {.lex_state = 349},
  [9528] = {.lex_state = 349},
  [9529] = {.lex_state = 349},
  [9530] = {.lex_state = 349},
  [9531] = {.lex_state = 349},
  [9532] = {.lex_state = 349},
  [9533] = {.lex_state = 349},
  [9534] = {.lex_state = 349},
  [9535] = {.lex_state = 349},
  [9536] = {.lex_state = 311, .external_lex_state = 3},
  [9537] = {.lex_state = 311, .external_lex_state = 3},
  [9538] = {.lex_state = 311, .external_lex_state = 3},
  [9539] = {.lex_state = 349},
  [9540] = {.lex_state = 311, .external_lex_state = 3},
  [9541] = {.lex_state = 349},
  [9542] = {.lex_state = 311, .external_lex_state = 3},
  [9543] = {.lex_state = 349},
  [9544] = {.lex_state = 311, .external_lex_state = 3},
  [9545] = {.lex_state = 311, .external_lex_state = 3},
  [9546] = {.lex_state = 311, .external_lex_state = 3},
  [9547] = {.lex_state = 311, .external_lex_state = 3},
  [9548] = {.lex_state = 311, .external_lex_state = 3},
  [9549] = {.lex_state = 311, .external_lex_state = 3},
  [9550] = {.lex_state = 349},
  [9551] = {.lex_state = 311, .external_lex_state = 3},
  [9552] = {.lex_state = 349},
  [9553] = {.lex_state = 311, .external_lex_state = 3},
  [9554] = {.lex_state = 349},
  [9555] = {.lex_state = 349},
  [9556] = {.lex_state = 311, .external_lex_state = 3},
  [9557] = {.lex_state = 311, .external_lex_state = 3},
  [9558] = {.lex_state = 311, .external_lex_state = 3},
  [9559] = {.lex_state = 349},
  [9560] = {.lex_state = 349},
  [9561] = {.lex_state = 311, .external_lex_state = 3},
  [9562] = {.lex_state = 311, .external_lex_state = 3},
  [9563] = {.lex_state = 311, .external_lex_state = 3},
  [9564] = {.lex_state = 311, .external_lex_state = 3},
  [9565] = {.lex_state = 311, .external_lex_state = 3},
  [9566] = {.lex_state = 311, .external_lex_state = 3},
  [9567] = {.lex_state = 311, .external_lex_state = 3},
  [9568] = {.lex_state = 311, .external_lex_state = 3},
  [9569] = {.lex_state = 349},
  [9570] = {.lex_state = 311, .external_lex_state = 3},
  [9571] = {.lex_state = 311, .external_lex_state = 3},
  [9572] = {.lex_state = 311, .external_lex_state = 3},
  [9573] = {.lex_state = 311, .external_lex_state = 3},
  [9574] = {.lex_state = 349},
  [9575] = {.lex_state = 311, .external_lex_state = 3},
  [9576] = {.lex_state = 311, .external_lex_state = 3},
  [9577] = {.lex_state = 311, .external_lex_state = 3},
  [9578] = {.lex_state = 311, .external_lex_state = 3},
  [9579] = {.lex_state = 311, .external_lex_state = 3},
  [9580] = {.lex_state = 311, .external_lex_state = 3},
  [9581] = {.lex_state = 311, .external_lex_state = 3},
  [9582] = {.lex_state = 311, .external_lex_state = 3},
  [9583] = {.lex_state = 311, .external_lex_state = 3},
  [9584] = {.lex_state = 311, .external_lex_state = 3},
  [9585] = {.lex_state = 311, .external_lex_state = 3},
  [9586] = {.lex_state = 311, .external_lex_state = 3},
  [9587] = {.lex_state = 311, .external_lex_state = 3},
  [9588] = {.lex_state = 349},
  [9589] = {.lex_state = 349},
  [9590] = {.lex_state = 311, .external_lex_state = 3},
  [9591] = {.lex_state = 311, .external_lex_state = 3},
  [9592] = {.lex_state = 311, .external_lex_state = 3},
  [9593] = {.lex_state = 311, .external_lex_state = 3},
  [9594] = {.lex_state = 311, .external_lex_state = 3},
  [9595] = {.lex_state = 311, .external_lex_state = 3},
  [9596] = {.lex_state = 311, .external_lex_state = 3},
  [9597] = {.lex_state = 311, .external_lex_state = 3},
  [9598] = {.lex_state = 311, .external_lex_state = 3},
  [9599] = {.lex_state = 311, .external_lex_state = 3},
  [9600] = {.lex_state = 311, .external_lex_state = 3},
  [9601] = {.lex_state = 311, .external_lex_state = 3},
  [9602] = {.lex_state = 311, .external_lex_state = 3},
  [9603] = {.lex_state = 311, .external_lex_state = 3},
  [9604] = {.lex_state = 311, .external_lex_state = 3},
  [9605] = {.lex_state = 349},
  [9606] = {.lex_state = 349},
  [9607] = {.lex_state = 311, .external_lex_state = 3},
  [9608] = {.lex_state = 311, .external_lex_state = 3},
  [9609] = {.lex_state = 311, .external_lex_state = 3},
  [9610] = {.lex_state = 311, .external_lex_state = 3},
  [9611] = {.lex_state = 311, .external_lex_state = 3},
  [9612] = {.lex_state = 311, .external_lex_state = 3},
  [9613] = {.lex_state = 311, .external_lex_state = 3},
  [9614] = {.lex_state = 311, .external_lex_state = 3},
  [9615] = {.lex_state = 311, .external_lex_state = 3},
  [9616] = {.lex_state = 311, .external_lex_state = 3},
  [9617] = {.lex_state = 349},
  [9618] = {.lex_state = 349},
  [9619] = {.lex_state = 311, .external_lex_state = 3},
  [9620] = {.lex_state = 311, .external_lex_state = 3},
  [9621] = {.lex_state = 311, .external_lex_state = 3},
  [9622] = {.lex_state = 311, .external_lex_state = 3},
  [9623] = {.lex_state = 311, .external_lex_state = 3},
  [9624] = {.lex_state = 311, .external_lex_state = 3},
  [9625] = {.lex_state = 311, .external_lex_state = 3},
  [9626] = {.lex_state = 311, .external_lex_state = 3},
  [9627] = {.lex_state = 311, .external_lex_state = 3},
  [9628] = {.lex_state = 311, .external_lex_state = 3},
  [9629] = {.lex_state = 349},
  [9630] = {.lex_state = 349},
  [9631] = {.lex_state = 311, .external_lex_state = 3},
  [9632] = {.lex_state = 349},
  [9633] = {.lex_state = 311, .external_lex_state = 3},
  [9634] = {.lex_state = 311, .external_lex_state = 3},
  [9635] = {.lex_state = 311, .external_lex_state = 3},
  [9636] = {.lex_state = 311, .external_lex_state = 3},
  [9637] = {.lex_state = 311, .external_lex_state = 3},
  [9638] = {.lex_state = 349},
  [9639] = {.lex_state = 311, .external_lex_state = 3},
  [9640] = {.lex_state = 311, .external_lex_state = 3},
  [9641] = {.lex_state = 349},
  [9642] = {.lex_state = 311, .external_lex_state = 3},
  [9643] = {.lex_state = 311, .external_lex_state = 3},
  [9644] = {.lex_state = 311, .external_lex_state = 3},
  [9645] = {.lex_state = 349},
  [9646] = {.lex_state = 311, .external_lex_state = 3},
  [9647] = {.lex_state = 311, .external_lex_state = 3},
  [9648] = {.lex_state = 311, .external_lex_state = 3},
  [9649] = {.lex_state = 349},
  [9650] = {.lex_state = 311, .external_lex_state = 3},
  [9651] = {.lex_state = 311, .external_lex_state = 3},
  [9652] = {.lex_state = 311, .external_lex_state = 3},
  [9653] = {.lex_state = 349},
  [9654] = {.lex_state = 349},
  [9655] = {.lex_state = 349},
  [9656] = {.lex_state = 311, .external_lex_state = 3},
  [9657] = {.lex_state = 311, .external_lex_state = 3},
  [9658] = {.lex_state = 349},
  [9659] = {.lex_state = 349},
  [9660] = {.lex_state = 311, .external_lex_state = 3},
  [9661] = {.lex_state = 311, .external_lex_state = 3},
  [9662] = {.lex_state = 349},
  [9663] = {.lex_state = 349},
  [9664] = {.lex_state = 311, .external_lex_state = 3},
  [9665] = {.lex_state = 311, .external_lex_state = 3},
  [9666] = {.lex_state = 349},
  [9667] = {.lex_state = 311, .external_lex_state = 3},
  [9668] = {.lex_state = 311, .external_lex_state = 3},
  [9669] = {.lex_state = 311, .external_lex_state = 3},
  [9670] = {.lex_state = 311, .external_lex_state = 3},
  [9671] = {.lex_state = 311, .external_lex_state = 3},
  [9672] = {.lex_state = 311, .external_lex_state = 3},
  [9673] = {.lex_state = 311, .external_lex_state = 3},
  [9674] = {.lex_state = 311, .external_lex_state = 3},
  [9675] = {.lex_state = 311, .external_lex_state = 3},
  [9676] = {.lex_state = 311, .external_lex_state = 3},
  [9677] = {.lex_state = 349},
  [9678] = {.lex_state = 311, .external_lex_state = 3},
  [9679] = {.lex_state = 311, .external_lex_state = 3},
  [9680] = {.lex_state = 311, .external_lex_state = 3},
  [9681] = {.lex_state = 311, .external_lex_state = 3},
  [9682] = {.lex_state = 349},
  [9683] = {.lex_state = 311, .external_lex_state = 3},
  [9684] = {.lex_state = 349},
  [9685] = {.lex_state = 311, .external_lex_state = 3},
  [9686] = {.lex_state = 349},
  [9687] = {.lex_state = 311, .external_lex_state = 3},
  [9688] = {.lex_state = 349},
  [9689] = {.lex_state = 311, .external_lex_state = 3},
  [9690] = {.lex_state = 311, .external_lex_state = 3},
  [9691] = {.lex_state = 311, .external_lex_state = 3},
  [9692] = {.lex_state = 311, .external_lex_state = 3},
  [9693] = {.lex_state = 311, .external_lex_state = 3},
  [9694] = {.lex_state = 311, .external_lex_state = 3},
  [9695] = {.lex_state = 311, .external_lex_state = 3},
  [9696] = {.lex_state = 311, .external_lex_state = 3},
  [9697] = {.lex_state = 311, .external_lex_state = 3},
  [9698] = {.lex_state = 311, .external_lex_state = 3},
  [9699] = {.lex_state = 311, .external_lex_state = 3},
  [9700] = {.lex_state = 311, .external_lex_state = 3},
  [9701] = {.lex_state = 349},
  [9702] = {.lex_state = 349},
  [9703] = {.lex_state = 311, .external_lex_state = 3},
  [9704] = {.lex_state = 311, .external_lex_state = 3},
  [9705] = {.lex_state = 349},
  [9706] = {.lex_state = 311, .external_lex_state = 3},
  [9707] = {.lex_state = 311, .external_lex_state = 3},
  [9708] = {.lex_state = 311, .external_lex_state = 3},
  [9709] = {.lex_state = 349},
  [9710] = {.lex_state = 311, .external_lex_state = 3},
  [9711] = {.lex_state = 349},
  [9712] = {.lex_state = 311, .external_lex_state = 3},
  [9713] = {.lex_state = 311, .external_lex_state = 3},
  [9714] = {.lex_state = 311, .external_lex_state = 3},
  [9715] = {.lex_state = 311, .external_lex_state = 3},
  [9716] = {.lex_state = 349},
  [9717] = {.lex_state = 311, .external_lex_state = 3},
  [9718] = {.lex_state = 311, .external_lex_state = 3},
  [9719] = {.lex_state = 311, .external_lex_state = 3},
  [9720] = {.lex_state = 311, .external_lex_state = 3},
  [9721] = {.lex_state = 311, .external_lex_state = 3},
  [9722] = {.lex_state = 311, .external_lex_state = 3},
  [9723] = {.lex_state = 284, .external_lex_state = 3},
  [9724] = {.lex_state = 76, .external_lex_state = 3},
  [9725] = {.lex_state = 85, .external_lex_state = 3},
  [9726] = {.lex_state = 97, .external_lex_state = 3},
  [9727] = {.lex_state = 101, .external_lex_state = 3},
  [9728] = {.lex_state = 89, .external_lex_state = 3},
  [9729] = {.lex_state = 106, .external_lex_state = 3},
  [9730] = {.lex_state = 529, .external_lex_state = 3},
  [9731] = {.lex_state = 285, .external_lex_state = 3},
  [9732] = {.lex_state = 290, .external_lex_state = 3},
  [9733] = {.lex_state = 332},
  [9734] = {.lex_state = 363, .external_lex_state = 2},
  [9735] = {.lex_state = 332},
  [9736] = {.lex_state = 364, .external_lex_state = 2},
  [9737] = {.lex_state = 364, .external_lex_state = 3},
  [9738] = {.lex_state = 364, .external_lex_state = 3},
  [9739] = {.lex_state = 364, .external_lex_state = 3},
  [9740] = {.lex_state = 364, .external_lex_state = 3},
  [9741] = {.lex_state = 332},
  [9742] = {.lex_state = 332},
  [9743] = {.lex_state = 364, .external_lex_state = 3},
  [9744] = {.lex_state = 363, .external_lex_state = 3},
  [9745] = {.lex_state = 364, .external_lex_state = 3},
  [9746] = {.lex_state = 363, .external_lex_state = 3},
  [9747] = {.lex_state = 368, .external_lex_state = 3},
  [9748] = {.lex_state = 364, .external_lex_state = 3},
  [9749] = {.lex_state = 364, .external_lex_state = 3},
  [9750] = {.lex_state = 364, .external_lex_state = 3},
  [9751] = {.lex_state = 363, .external_lex_state = 3},
  [9752] = {.lex_state = 364, .external_lex_state = 3},
  [9753] = {.lex_state = 364, .external_lex_state = 3},
  [9754] = {.lex_state = 364, .external_lex_state = 3},
  [9755] = {.lex_state = 364, .external_lex_state = 3},
  [9756] = {.lex_state = 363, .external_lex_state = 3},
  [9757] = {.lex_state = 364, .external_lex_state = 3},
  [9758] = {.lex_state = 364, .external_lex_state = 3},
  [9759] = {.lex_state = 363, .external_lex_state = 3},
  [9760] = {.lex_state = 363, .external_lex_state = 3},
  [9761] = {.lex_state = 363, .external_lex_state = 3},
  [9762] = {.lex_state = 364, .external_lex_state = 3},
  [9763] = {.lex_state = 364, .external_lex_state = 3},
  [9764] = {.lex_state = 364, .external_lex_state = 3},
  [9765] = {.lex_state = 364, .external_lex_state = 3},
  [9766] = {.lex_state = 364, .external_lex_state = 3},
  [9767] = {.lex_state = 364, .external_lex_state = 3},
  [9768] = {.lex_state = 364, .external_lex_state = 3},
  [9769] = {.lex_state = 364, .external_lex_state = 3},
  [9770] = {.lex_state = 364, .external_lex_state = 3},
  [9771] = {.lex_state = 364, .external_lex_state = 3},
  [9772] = {.lex_state = 364, .external_lex_state = 3},
  [9773] = {.lex_state = 364, .external_lex_state = 3},
  [9774] = {.lex_state = 364, .external_lex_state = 3},
  [9775] = {.lex_state = 364, .external_lex_state = 3},
  [9776] = {.lex_state = 364, .external_lex_state = 3},
  [9777] = {.lex_state = 364, .external_lex_state = 3},
  [9778] = {.lex_state = 364, .external_lex_state = 3},
  [9779] = {.lex_state = 364, .external_lex_state = 3},
  [9780] = {.lex_state = 364, .external_lex_state = 3},
  [9781] = {.lex_state = 364, .external_lex_state = 3},
  [9782] = {.lex_state = 364, .external_lex_state = 3},
  [9783] = {.lex_state = 364, .external_lex_state = 3},
  [9784] = {.lex_state = 364, .external_lex_state = 3},
  [9785] = {.lex_state = 364, .external_lex_state = 3},
  [9786] = {.lex_state = 364, .external_lex_state = 3},
  [9787] = {.lex_state = 364, .external_lex_state = 3},
  [9788] = {.lex_state = 364, .external_lex_state = 3},
  [9789] = {.lex_state = 364, .external_lex_state = 3},
  [9790] = {.lex_state = 364, .external_lex_state = 3},
  [9791] = {.lex_state = 364, .external_lex_state = 3},
  [9792] = {.lex_state = 364, .external_lex_state = 3},
  [9793] = {.lex_state = 364, .external_lex_state = 3},
  [9794] = {.lex_state = 364, .external_lex_state = 3},
  [9795] = {.lex_state = 364, .external_lex_state = 3},
  [9796] = {.lex_state = 364, .external_lex_state = 3},
  [9797] = {.lex_state = 364, .external_lex_state = 3},
  [9798] = {.lex_state = 364, .external_lex_state = 3},
  [9799] = {.lex_state = 364, .external_lex_state = 3},
  [9800] = {.lex_state = 364, .external_lex_state = 3},
  [9801] = {.lex_state = 364, .external_lex_state = 3},
  [9802] = {.lex_state = 364, .external_lex_state = 3},
  [9803] = {.lex_state = 364, .external_lex_state = 3},
  [9804] = {.lex_state = 364, .external_lex_state = 3},
  [9805] = {.lex_state = 364, .external_lex_state = 3},
  [9806] = {.lex_state = 364, .external_lex_state = 3},
  [9807] = {.lex_state = 364, .external_lex_state = 3},
  [9808] = {.lex_state = 364, .external_lex_state = 3},
  [9809] = {.lex_state = 364, .external_lex_state = 3},
  [9810] = {.lex_state = 364, .external_lex_state = 3},
  [9811] = {.lex_state = 364, .external_lex_state = 3},
  [9812] = {.lex_state = 364, .external_lex_state = 3},
  [9813] = {.lex_state = 133},
  [9814] = {.lex_state = 364, .external_lex_state = 3},
  [9815] = {.lex_state = 135},
  [9816] = {.lex_state = 364, .external_lex_state = 3},
  [9817] = {.lex_state = 364, .external_lex_state = 3},
  [9818] = {.lex_state = 364, .external_lex_state = 3},
  [9819] = {.lex_state = 364, .external_lex_state = 3},
  [9820] = {.lex_state = 364, .external_lex_state = 3},
  [9821] = {.lex_state = 539, .external_lex_state = 2},
  [9822] = {.lex_state = 141},
  [9823] = {.lex_state = 364, .external_lex_state = 2},
  [9824] = {.lex_state = 365, .external_lex_state = 3},
  [9825] = {.lex_state = 365, .external_lex_state = 3},
  [9826] = {.lex_state = 137},
  [9827] = {.lex_state = 139},
  [9828] = {.lex_state = 135},
  [9829] = {.lex_state = 133},
  [9830] = {.lex_state = 133},
  [9831] = {.lex_state = 135},
  [9832] = {.lex_state = 133},
  [9833] = {.lex_state = 365, .external_lex_state = 3},
  [9834] = {.lex_state = 135},
  [9835] = {.lex_state = 365, .external_lex_state = 3},
  [9836] = {.lex_state = 364, .external_lex_state = 2},
  [9837] = {.lex_state = 364, .external_lex_state = 2},
  [9838] = {.lex_state = 141},
  [9839] = {.lex_state = 139},
  [9840] = {.lex_state = 389, .external_lex_state = 3},
  [9841] = {.lex_state = 541, .external_lex_state = 3},
  [9842] = {.lex_state = 535},
  [9843] = {.lex_state = 389, .external_lex_state = 2},
  [9844] = {.lex_state = 389, .external_lex_state = 3},
  [9845] = {.lex_state = 541, .external_lex_state = 3},
  [9846] = {.lex_state = 144},
  [9847] = {.lex_state = 141},
  [9848] = {.lex_state = 541, .external_lex_state = 2},
  [9849] = {.lex_state = 137},
  [9850] = {.lex_state = 139},
  [9851] = {.lex_state = 389, .external_lex_state = 3},
  [9852] = {.lex_state = 541, .external_lex_state = 3},
  [9853] = {.lex_state = 333},
  [9854] = {.lex_state = 141},
  [9855] = {.lex_state = 137},
  [9856] = {.lex_state = 541, .external_lex_state = 3},
  [9857] = {.lex_state = 137},
  [9858] = {.lex_state = 139},
  [9859] = {.lex_state = 389, .external_lex_state = 3},
  [9860] = {.lex_state = 541, .external_lex_state = 3},
  [9861] = {.lex_state = 541, .external_lex_state = 3},
  [9862] = {.lex_state = 144},
  [9863] = {.lex_state = 384, .external_lex_state = 3},
  [9864] = {.lex_state = 389, .external_lex_state = 3},
  [9865] = {.lex_state = 541, .external_lex_state = 3},
  [9866] = {.lex_state = 541, .external_lex_state = 3},
  [9867] = {.lex_state = 535},
  [9868] = {.lex_state = 539, .external_lex_state = 3},
  [9869] = {.lex_state = 389, .external_lex_state = 3},
  [9870] = {.lex_state = 541, .external_lex_state = 3},
  [9871] = {.lex_state = 389, .external_lex_state = 3},
  [9872] = {.lex_state = 541, .external_lex_state = 3},
  [9873] = {.lex_state = 541, .external_lex_state = 3},
  [9874] = {.lex_state = 539, .external_lex_state = 3},
  [9875] = {.lex_state = 389, .external_lex_state = 3},
  [9876] = {.lex_state = 389, .external_lex_state = 3},
  [9877] = {.lex_state = 389, .external_lex_state = 3},
  [9878] = {.lex_state = 535},
  [9879] = {.lex_state = 541, .external_lex_state = 3},
  [9880] = {.lex_state = 393, .external_lex_state = 3},
  [9881] = {.lex_state = 389, .external_lex_state = 3},
  [9882] = {.lex_state = 541, .external_lex_state = 3},
  [9883] = {.lex_state = 539, .external_lex_state = 3},
  [9884] = {.lex_state = 539, .external_lex_state = 3},
  [9885] = {.lex_state = 389, .external_lex_state = 3},
  [9886] = {.lex_state = 333},
  [9887] = {.lex_state = 539, .external_lex_state = 3},
  [9888] = {.lex_state = 539, .external_lex_state = 3},
  [9889] = {.lex_state = 144},
  [9890] = {.lex_state = 333},
  [9891] = {.lex_state = 389, .external_lex_state = 3},
  [9892] = {.lex_state = 539, .external_lex_state = 3},
  [9893] = {.lex_state = 541, .external_lex_state = 3},
  [9894] = {.lex_state = 389, .external_lex_state = 3},
  [9895] = {.lex_state = 384, .external_lex_state = 2},
  [9896] = {.lex_state = 535},
  [9897] = {.lex_state = 384, .external_lex_state = 3},
  [9898] = {.lex_state = 389, .external_lex_state = 3},
  [9899] = {.lex_state = 389, .external_lex_state = 3},
  [9900] = {.lex_state = 541, .external_lex_state = 3},
  [9901] = {.lex_state = 384, .external_lex_state = 3},
  [9902] = {.lex_state = 541, .external_lex_state = 3},
  [9903] = {.lex_state = 333},
  [9904] = {.lex_state = 384, .external_lex_state = 3},
  [9905] = {.lex_state = 144},
  [9906] = {.lex_state = 543, .external_lex_state = 3},
  [9907] = {.lex_state = 541, .external_lex_state = 3},
  [9908] = {.lex_state = 541, .external_lex_state = 3},
  [9909] = {.lex_state = 541, .external_lex_state = 3},
  [9910] = {.lex_state = 541, .external_lex_state = 3},
  [9911] = {.lex_state = 541, .external_lex_state = 3},
  [9912] = {.lex_state = 541, .external_lex_state = 3},
  [9913] = {.lex_state = 541, .external_lex_state = 3},
  [9914] = {.lex_state = 384, .external_lex_state = 3},
  [9915] = {.lex_state = 541, .external_lex_state = 3},
  [9916] = {.lex_state = 389, .external_lex_state = 3},
  [9917] = {.lex_state = 541, .external_lex_state = 3},
  [9918] = {.lex_state = 389, .external_lex_state = 3},
  [9919] = {.lex_state = 541, .external_lex_state = 3},
  [9920] = {.lex_state = 384, .external_lex_state = 3},
  [9921] = {.lex_state = 541, .external_lex_state = 3},
  [9922] = {.lex_state = 541, .external_lex_state = 3},
  [9923] = {.lex_state = 541, .external_lex_state = 3},
  [9924] = {.lex_state = 384, .external_lex_state = 3},
  [9925] = {.lex_state = 541, .external_lex_state = 3},
  [9926] = {.lex_state = 541, .external_lex_state = 3},
  [9927] = {.lex_state = 541, .external_lex_state = 3},
  [9928] = {.lex_state = 541, .external_lex_state = 3},
  [9929] = {.lex_state = 541, .external_lex_state = 3},
  [9930] = {.lex_state = 541, .external_lex_state = 3},
  [9931] = {.lex_state = 539, .external_lex_state = 2},
  [9932] = {.lex_state = 384, .external_lex_state = 3},
  [9933] = {.lex_state = 541, .external_lex_state = 3},
  [9934] = {.lex_state = 389, .external_lex_state = 3},
  [9935] = {.lex_state = 389, .external_lex_state = 3},
  [9936] = {.lex_state = 541, .external_lex_state = 3},
  [9937] = {.lex_state = 541, .external_lex_state = 3},
  [9938] = {.lex_state = 389, .external_lex_state = 3},
  [9939] = {.lex_state = 541, .external_lex_state = 3},
  [9940] = {.lex_state = 541, .external_lex_state = 3},
  [9941] = {.lex_state = 389, .external_lex_state = 3},
  [9942] = {.lex_state = 389, .external_lex_state = 3},
  [9943] = {.lex_state = 384, .external_lex_state = 3},
  [9944] = {.lex_state = 389, .external_lex_state = 3},
  [9945] = {.lex_state = 389, .external_lex_state = 3},
  [9946] = {.lex_state = 389, .external_lex_state = 3},
  [9947] = {.lex_state = 384, .external_lex_state = 3},
  [9948] = {.lex_state = 389, .external_lex_state = 3},
  [9949] = {.lex_state = 389, .external_lex_state = 3},
  [9950] = {.lex_state = 165, .external_lex_state = 2},
  [9951] = {.lex_state = 384, .external_lex_state = 3},
  [9952] = {.lex_state = 541, .external_lex_state = 3},
  [9953] = {.lex_state = 541, .external_lex_state = 3},
  [9954] = {.lex_state = 389, .external_lex_state = 3},
  [9955] = {.lex_state = 541, .external_lex_state = 3},
  [9956] = {.lex_state = 541, .external_lex_state = 3},
  [9957] = {.lex_state = 389, .external_lex_state = 3},
  [9958] = {.lex_state = 384, .external_lex_state = 3},
  [9959] = {.lex_state = 541, .external_lex_state = 3},
  [9960] = {.lex_state = 389, .external_lex_state = 3},
  [9961] = {.lex_state = 389, .external_lex_state = 3},
  [9962] = {.lex_state = 389, .external_lex_state = 3},
  [9963] = {.lex_state = 389, .external_lex_state = 3},
  [9964] = {.lex_state = 389, .external_lex_state = 3},
  [9965] = {.lex_state = 389, .external_lex_state = 3},
  [9966] = {.lex_state = 389, .external_lex_state = 3},
  [9967] = {.lex_state = 541, .external_lex_state = 3},
  [9968] = {.lex_state = 389, .external_lex_state = 3},
  [9969] = {.lex_state = 389, .external_lex_state = 3},
  [9970] = {.lex_state = 389, .external_lex_state = 3},
  [9971] = {.lex_state = 389, .external_lex_state = 3},
  [9972] = {.lex_state = 389, .external_lex_state = 3},
  [9973] = {.lex_state = 389, .external_lex_state = 3},
  [9974] = {.lex_state = 541, .external_lex_state = 3},
  [9975] = {.lex_state = 541, .external_lex_state = 3},
  [9976] = {.lex_state = 389, .external_lex_state = 3},
  [9977] = {.lex_state = 389, .external_lex_state = 3},
  [9978] = {.lex_state = 389, .external_lex_state = 3},
  [9979] = {.lex_state = 541, .external_lex_state = 3},
  [9980] = {.lex_state = 389, .external_lex_state = 3},
  [9981] = {.lex_state = 389, .external_lex_state = 3},
  [9982] = {.lex_state = 541, .external_lex_state = 3},
  [9983] = {.lex_state = 389, .external_lex_state = 3},
  [9984] = {.lex_state = 389, .external_lex_state = 3},
  [9985] = {.lex_state = 389, .external_lex_state = 3},
  [9986] = {.lex_state = 389, .external_lex_state = 3},
  [9987] = {.lex_state = 389, .external_lex_state = 3},
  [9988] = {.lex_state = 541, .external_lex_state = 3},
  [9989] = {.lex_state = 541, .external_lex_state = 3},
  [9990] = {.lex_state = 389, .external_lex_state = 3},
  [9991] = {.lex_state = 389, .external_lex_state = 3},
  [9992] = {.lex_state = 389, .external_lex_state = 3},
  [9993] = {.lex_state = 389, .external_lex_state = 3},
  [9994] = {.lex_state = 541, .external_lex_state = 3},
  [9995] = {.lex_state = 541, .external_lex_state = 3},
  [9996] = {.lex_state = 389, .external_lex_state = 3},
  [9997] = {.lex_state = 389, .external_lex_state = 3},
  [9998] = {.lex_state = 541, .external_lex_state = 3},
  [9999] = {.lex_state = 389, .external_lex_state = 3},
  [10000] = {.lex_state = 389, .external_lex_state = 3},
  [10001] = {.lex_state = 389, .external_lex_state = 3},
  [10002] = {.lex_state = 541, .external_lex_state = 3},
  [10003] = {.lex_state = 389, .external_lex_state = 3},
  [10004] = {.lex_state = 389, .external_lex_state = 3},
  [10005] = {.lex_state = 541, .external_lex_state = 3},
  [10006] = {.lex_state = 541, .external_lex_state = 3},
  [10007] = {.lex_state = 541, .external_lex_state = 3},
  [10008] = {.lex_state = 165, .external_lex_state = 2},
  [10009] = {.lex_state = 541, .external_lex_state = 3},
  [10010] = {.lex_state = 541, .external_lex_state = 3},
  [10011] = {.lex_state = 389, .external_lex_state = 3},
  [10012] = {.lex_state = 541, .external_lex_state = 3},
  [10013] = {.lex_state = 541, .external_lex_state = 3},
  [10014] = {.lex_state = 388, .external_lex_state = 3},
  [10015] = {.lex_state = 541, .external_lex_state = 3},
  [10016] = {.lex_state = 389, .external_lex_state = 3},
  [10017] = {.lex_state = 165, .external_lex_state = 2},
  [10018] = {.lex_state = 541, .external_lex_state = 3},
  [10019] = {.lex_state = 541, .external_lex_state = 3},
  [10020] = {.lex_state = 384, .external_lex_state = 3},
  [10021] = {.lex_state = 389, .external_lex_state = 3},
  [10022] = {.lex_state = 539, .external_lex_state = 2},
  [10023] = {.lex_state = 389, .external_lex_state = 3},
  [10024] = {.lex_state = 541, .external_lex_state = 3},
  [10025] = {.lex_state = 384, .external_lex_state = 3},
  [10026] = {.lex_state = 389, .external_lex_state = 3},
  [10027] = {.lex_state = 541, .external_lex_state = 3},
  [10028] = {.lex_state = 389, .external_lex_state = 3},
  [10029] = {.lex_state = 345},
  [10030] = {.lex_state = 389, .external_lex_state = 3},
  [10031] = {.lex_state = 541, .external_lex_state = 3},
  [10032] = {.lex_state = 541, .external_lex_state = 3},
  [10033] = {.lex_state = 389, .external_lex_state = 3},
  [10034] = {.lex_state = 384, .external_lex_state = 3},
  [10035] = {.lex_state = 389, .external_lex_state = 3},
  [10036] = {.lex_state = 541, .external_lex_state = 3},
  [10037] = {.lex_state = 541, .external_lex_state = 3},
  [10038] = {.lex_state = 384, .external_lex_state = 3},
  [10039] = {.lex_state = 384, .external_lex_state = 3},
  [10040] = {.lex_state = 363, .external_lex_state = 2},
  [10041] = {.lex_state = 384, .external_lex_state = 3},
  [10042] = {.lex_state = 384, .external_lex_state = 3},
  [10043] = {.lex_state = 363, .external_lex_state = 2},
  [10044] = {.lex_state = 167, .external_lex_state = 2},
  [10045] = {.lex_state = 366, .external_lex_state = 3},
  [10046] = {.lex_state = 363, .external_lex_state = 2},
  [10047] = {.lex_state = 363, .external_lex_state = 2},
  [10048] = {.lex_state = 384, .external_lex_state = 3},
  [10049] = {.lex_state = 384, .external_lex_state = 3},
  [10050] = {.lex_state = 384, .external_lex_state = 3},
  [10051] = {.lex_state = 384, .external_lex_state = 3},
  [10052] = {.lex_state = 384, .external_lex_state = 3},
  [10053] = {.lex_state = 384, .external_lex_state = 3},
  [10054] = {.lex_state = 384, .external_lex_state = 3},
  [10055] = {.lex_state = 169, .external_lex_state = 3},
  [10056] = {.lex_state = 169, .external_lex_state = 3},
  [10057] = {.lex_state = 390, .external_lex_state = 3},
  [10058] = {.lex_state = 390, .external_lex_state = 3},
  [10059] = {.lex_state = 167, .external_lex_state = 3},
  [10060] = {.lex_state = 167, .external_lex_state = 2},
  [10061] = {.lex_state = 167, .external_lex_state = 3},
  [10062] = {.lex_state = 541, .external_lex_state = 2},
  [10063] = {.lex_state = 390, .external_lex_state = 3},
  [10064] = {.lex_state = 384, .external_lex_state = 3},
  [10065] = {.lex_state = 384, .external_lex_state = 3},
  [10066] = {.lex_state = 171, .external_lex_state = 3},
  [10067] = {.lex_state = 167, .external_lex_state = 3},
  [10068] = {.lex_state = 384, .external_lex_state = 3},
  [10069] = {.lex_state = 384, .external_lex_state = 3},
  [10070] = {.lex_state = 384, .external_lex_state = 3},
  [10071] = {.lex_state = 541, .external_lex_state = 2},
  [10072] = {.lex_state = 167, .external_lex_state = 3},
  [10073] = {.lex_state = 539, .external_lex_state = 2},
  [10074] = {.lex_state = 169, .external_lex_state = 3},
  [10075] = {.lex_state = 541, .external_lex_state = 2},
  [10076] = {.lex_state = 364, .external_lex_state = 2},
  [10077] = {.lex_state = 171, .external_lex_state = 3},
  [10078] = {.lex_state = 171, .external_lex_state = 3},
  [10079] = {.lex_state = 364, .external_lex_state = 2},
  [10080] = {.lex_state = 384, .external_lex_state = 3},
  [10081] = {.lex_state = 384, .external_lex_state = 3},
  [10082] = {.lex_state = 384, .external_lex_state = 3},
  [10083] = {.lex_state = 384, .external_lex_state = 3},
  [10084] = {.lex_state = 384, .external_lex_state = 3},
  [10085] = {.lex_state = 169, .external_lex_state = 3},
  [10086] = {.lex_state = 364, .external_lex_state = 2},
  [10087] = {.lex_state = 384, .external_lex_state = 3},
  [10088] = {.lex_state = 171, .external_lex_state = 3},
  [10089] = {.lex_state = 384, .external_lex_state = 3},
  [10090] = {.lex_state = 384, .external_lex_state = 3},
  [10091] = {.lex_state = 366, .external_lex_state = 3},
  [10092] = {.lex_state = 384, .external_lex_state = 3},
  [10093] = {.lex_state = 384, .external_lex_state = 3},
  [10094] = {.lex_state = 384, .external_lex_state = 3},
  [10095] = {.lex_state = 363, .external_lex_state = 2},
  [10096] = {.lex_state = 384, .external_lex_state = 3},
  [10097] = {.lex_state = 389, .external_lex_state = 2},
  [10098] = {.lex_state = 384, .external_lex_state = 3},
  [10099] = {.lex_state = 384, .external_lex_state = 3},
  [10100] = {.lex_state = 539, .external_lex_state = 2},
  [10101] = {.lex_state = 539, .external_lex_state = 2},
  [10102] = {.lex_state = 363, .external_lex_state = 2},
  [10103] = {.lex_state = 384, .external_lex_state = 3},
  [10104] = {.lex_state = 384, .external_lex_state = 3},
  [10105] = {.lex_state = 384, .external_lex_state = 3},
  [10106] = {.lex_state = 384, .external_lex_state = 3},
  [10107] = {.lex_state = 345},
  [10108] = {.lex_state = 345},
  [10109] = {.lex_state = 389, .external_lex_state = 2},
  [10110] = {.lex_state = 384, .external_lex_state = 3},
  [10111] = {.lex_state = 384, .external_lex_state = 3},
  [10112] = {.lex_state = 384, .external_lex_state = 3},
  [10113] = {.lex_state = 366, .external_lex_state = 3},
  [10114] = {.lex_state = 345},
  [10115] = {.lex_state = 363, .external_lex_state = 2},
  [10116] = {.lex_state = 384, .external_lex_state = 3},
  [10117] = {.lex_state = 389, .external_lex_state = 2},
  [10118] = {.lex_state = 167, .external_lex_state = 2},
  [10119] = {.lex_state = 384, .external_lex_state = 3},
  [10120] = {.lex_state = 384, .external_lex_state = 3},
  [10121] = {.lex_state = 384, .external_lex_state = 3},
  [10122] = {.lex_state = 384, .external_lex_state = 3},
  [10123] = {.lex_state = 384, .external_lex_state = 3},
  [10124] = {.lex_state = 539, .external_lex_state = 2},
  [10125] = {.lex_state = 384, .external_lex_state = 3},
  [10126] = {.lex_state = 384, .external_lex_state = 3},
  [10127] = {.lex_state = 384, .external_lex_state = 3},
  [10128] = {.lex_state = 384, .external_lex_state = 3},
  [10129] = {.lex_state = 384, .external_lex_state = 3},
  [10130] = {.lex_state = 384, .external_lex_state = 3},
  [10131] = {.lex_state = 167, .external_lex_state = 2},
  [10132] = {.lex_state = 384, .external_lex_state = 3},
  [10133] = {.lex_state = 539, .external_lex_state = 2},
  [10134] = {.lex_state = 384, .external_lex_state = 3},
  [10135] = {.lex_state = 384, .external_lex_state = 3},
  [10136] = {.lex_state = 384, .external_lex_state = 3},
  [10137] = {.lex_state = 384, .external_lex_state = 3},
  [10138] = {.lex_state = 384, .external_lex_state = 3},
  [10139] = {.lex_state = 384, .external_lex_state = 3},
  [10140] = {.lex_state = 384, .external_lex_state = 3},
  [10141] = {.lex_state = 389, .external_lex_state = 2},
  [10142] = {.lex_state = 384, .external_lex_state = 3},
  [10143] = {.lex_state = 366, .external_lex_state = 3},
  [10144] = {.lex_state = 539, .external_lex_state = 2},
  [10145] = {.lex_state = 390, .external_lex_state = 3},
  [10146] = {.lex_state = 167, .external_lex_state = 3},
  [10147] = {.lex_state = 539, .external_lex_state = 2},
  [10148] = {.lex_state = 173, .external_lex_state = 3},
  [10149] = {.lex_state = 384, .external_lex_state = 2},
  [10150] = {.lex_state = 541, .external_lex_state = 3},
  [10151] = {.lex_state = 175, .external_lex_state = 3},
  [10152] = {.lex_state = 165, .external_lex_state = 3},
  [10153] = {.lex_state = 539, .external_lex_state = 2},
  [10154] = {.lex_state = 539, .external_lex_state = 2},
  [10155] = {.lex_state = 175, .external_lex_state = 3},
  [10156] = {.lex_state = 165, .external_lex_state = 3},
  [10157] = {.lex_state = 167, .external_lex_state = 3},
  [10158] = {.lex_state = 539, .external_lex_state = 2},
  [10159] = {.lex_state = 363, .external_lex_state = 2},
  [10160] = {.lex_state = 384, .external_lex_state = 5},
  [10161] = {.lex_state = 165, .external_lex_state = 3},
  [10162] = {.lex_state = 165, .external_lex_state = 3},
  [10163] = {.lex_state = 363, .external_lex_state = 2},
  [10164] = {.lex_state = 363, .external_lex_state = 2},
  [10165] = {.lex_state = 384, .external_lex_state = 2},
  [10166] = {.lex_state = 545, .external_lex_state = 3},
  [10167] = {.lex_state = 363, .external_lex_state = 2},
  [10168] = {.lex_state = 545, .external_lex_state = 3},
  [10169] = {.lex_state = 167, .external_lex_state = 3},
  [10170] = {.lex_state = 165, .external_lex_state = 3},
  [10171] = {.lex_state = 167, .external_lex_state = 3},
  [10172] = {.lex_state = 167, .external_lex_state = 3},
  [10173] = {.lex_state = 167, .external_lex_state = 3},
  [10174] = {.lex_state = 384, .external_lex_state = 2},
  [10175] = {.lex_state = 178, .external_lex_state = 3},
  [10176] = {.lex_state = 175, .external_lex_state = 3},
  [10177] = {.lex_state = 539, .external_lex_state = 2},
  [10178] = {.lex_state = 167, .external_lex_state = 3},
  [10179] = {.lex_state = 165, .external_lex_state = 3},
  [10180] = {.lex_state = 178, .external_lex_state = 3},
  [10181] = {.lex_state = 175, .external_lex_state = 3},
  [10182] = {.lex_state = 363, .external_lex_state = 2},
  [10183] = {.lex_state = 541, .external_lex_state = 2},
  [10184] = {.lex_state = 541, .external_lex_state = 2},
  [10185] = {.lex_state = 545, .external_lex_state = 3},
  [10186] = {.lex_state = 385, .external_lex_state = 3},
  [10187] = {.lex_state = 385, .external_lex_state = 3},
  [10188] = {.lex_state = 178, .external_lex_state = 3},
  [10189] = {.lex_state = 178, .external_lex_state = 3},
  [10190] = {.lex_state = 363, .external_lex_state = 2},
  [10191] = {.lex_state = 541, .external_lex_state = 3},
  [10192] = {.lex_state = 541, .external_lex_state = 2},
  [10193] = {.lex_state = 539, .external_lex_state = 2},
  [10194] = {.lex_state = 363, .external_lex_state = 2},
  [10195] = {.lex_state = 539, .external_lex_state = 2},
  [10196] = {.lex_state = 539, .external_lex_state = 2},
  [10197] = {.lex_state = 180, .external_lex_state = 3},
  [10198] = {.lex_state = 539, .external_lex_state = 2},
  [10199] = {.lex_state = 384, .external_lex_state = 2},
  [10200] = {.lex_state = 539, .external_lex_state = 2},
  [10201] = {.lex_state = 363, .external_lex_state = 2},
  [10202] = {.lex_state = 541, .external_lex_state = 3},
  [10203] = {.lex_state = 539, .external_lex_state = 2},
  [10204] = {.lex_state = 541, .external_lex_state = 2},
  [10205] = {.lex_state = 541, .external_lex_state = 2},
  [10206] = {.lex_state = 541, .external_lex_state = 2},
  [10207] = {.lex_state = 541, .external_lex_state = 3},
  [10208] = {.lex_state = 541, .external_lex_state = 2},
  [10209] = {.lex_state = 541, .external_lex_state = 2},
  [10210] = {.lex_state = 539, .external_lex_state = 2},
  [10211] = {.lex_state = 167, .external_lex_state = 3},
  [10212] = {.lex_state = 363, .external_lex_state = 2},
  [10213] = {.lex_state = 180, .external_lex_state = 3},
  [10214] = {.lex_state = 167, .external_lex_state = 3},
  [10215] = {.lex_state = 363, .external_lex_state = 2},
  [10216] = {.lex_state = 541, .external_lex_state = 3},
  [10217] = {.lex_state = 167, .external_lex_state = 3},
  [10218] = {.lex_state = 167, .external_lex_state = 3},
  [10219] = {.lex_state = 545, .external_lex_state = 3},
  [10220] = {.lex_state = 167, .external_lex_state = 3},
  [10221] = {.lex_state = 167, .external_lex_state = 3},
  [10222] = {.lex_state = 167, .external_lex_state = 3},
  [10223] = {.lex_state = 167, .external_lex_state = 3},
  [10224] = {.lex_state = 385, .external_lex_state = 3},
  [10225] = {.lex_state = 363, .external_lex_state = 2},
  [10226] = {.lex_state = 539, .external_lex_state = 2},
  [10227] = {.lex_state = 385, .external_lex_state = 3},
  [10228] = {.lex_state = 167, .external_lex_state = 3},
  [10229] = {.lex_state = 167, .external_lex_state = 3},
  [10230] = {.lex_state = 545, .external_lex_state = 2},
  [10231] = {.lex_state = 180, .external_lex_state = 3},
  [10232] = {.lex_state = 541, .external_lex_state = 3},
  [10233] = {.lex_state = 539, .external_lex_state = 2},
  [10234] = {.lex_state = 165, .external_lex_state = 3},
  [10235] = {.lex_state = 180, .external_lex_state = 3},
  [10236] = {.lex_state = 541, .external_lex_state = 2},
  [10237] = {.lex_state = 363, .external_lex_state = 2},
  [10238] = {.lex_state = 539, .external_lex_state = 2},
  [10239] = {.lex_state = 539, .external_lex_state = 2},
  [10240] = {.lex_state = 167, .external_lex_state = 3},
  [10241] = {.lex_state = 541, .external_lex_state = 2},
  [10242] = {.lex_state = 545, .external_lex_state = 3},
  [10243] = {.lex_state = 167, .external_lex_state = 3},
  [10244] = {.lex_state = 167, .external_lex_state = 3},
  [10245] = {.lex_state = 167, .external_lex_state = 3},
  [10246] = {.lex_state = 541, .external_lex_state = 3},
  [10247] = {.lex_state = 364, .external_lex_state = 3},
  [10248] = {.lex_state = 541, .external_lex_state = 3},
  [10249] = {.lex_state = 363, .external_lex_state = 2},
  [10250] = {.lex_state = 167, .external_lex_state = 3},
  [10251] = {.lex_state = 541, .external_lex_state = 2},
  [10252] = {.lex_state = 167, .external_lex_state = 3},
  [10253] = {.lex_state = 364, .external_lex_state = 3},
  [10254] = {.lex_state = 364, .external_lex_state = 3},
  [10255] = {.lex_state = 167, .external_lex_state = 3},
  [10256] = {.lex_state = 167, .external_lex_state = 3},
  [10257] = {.lex_state = 547, .external_lex_state = 3},
  [10258] = {.lex_state = 547, .external_lex_state = 3},
  [10259] = {.lex_state = 167, .external_lex_state = 3},
  [10260] = {.lex_state = 167, .external_lex_state = 3},
  [10261] = {.lex_state = 167, .external_lex_state = 3},
  [10262] = {.lex_state = 367, .external_lex_state = 3},
  [10263] = {.lex_state = 167, .external_lex_state = 3},
  [10264] = {.lex_state = 388},
  [10265] = {.lex_state = 167, .external_lex_state = 3},
  [10266] = {.lex_state = 167, .external_lex_state = 3},
  [10267] = {.lex_state = 367, .external_lex_state = 3},
  [10268] = {.lex_state = 167, .external_lex_state = 3},
  [10269] = {.lex_state = 549, .external_lex_state = 3},
  [10270] = {.lex_state = 539, .external_lex_state = 2},
  [10271] = {.lex_state = 167, .external_lex_state = 3},
  [10272] = {.lex_state = 363, .external_lex_state = 2},
  [10273] = {.lex_state = 549, .external_lex_state = 3},
  [10274] = {.lex_state = 547, .external_lex_state = 3},
  [10275] = {.lex_state = 167, .external_lex_state = 3},
  [10276] = {.lex_state = 167, .external_lex_state = 3},
  [10277] = {.lex_state = 364, .external_lex_state = 3},
  [10278] = {.lex_state = 167, .external_lex_state = 3},
  [10279] = {.lex_state = 545, .external_lex_state = 3},
  [10280] = {.lex_state = 167, .external_lex_state = 3},
  [10281] = {.lex_state = 549, .external_lex_state = 3},
  [10282] = {.lex_state = 167, .external_lex_state = 3},
  [10283] = {.lex_state = 167, .external_lex_state = 3},
  [10284] = {.lex_state = 541, .external_lex_state = 2},
  [10285] = {.lex_state = 167, .external_lex_state = 3},
  [10286] = {.lex_state = 184, .external_lex_state = 3},
  [10287] = {.lex_state = 167, .external_lex_state = 3},
  [10288] = {.lex_state = 167, .external_lex_state = 3},
  [10289] = {.lex_state = 541, .external_lex_state = 3},
  [10290] = {.lex_state = 167, .external_lex_state = 3},
  [10291] = {.lex_state = 167, .external_lex_state = 3},
  [10292] = {.lex_state = 545, .external_lex_state = 3},
  [10293] = {.lex_state = 364, .external_lex_state = 3},
  [10294] = {.lex_state = 364, .external_lex_state = 2},
  [10295] = {.lex_state = 541, .external_lex_state = 3},
  [10296] = {.lex_state = 167, .external_lex_state = 3},
  [10297] = {.lex_state = 167, .external_lex_state = 3},
  [10298] = {.lex_state = 541, .external_lex_state = 3},
  [10299] = {.lex_state = 363, .external_lex_state = 2},
  [10300] = {.lex_state = 551, .external_lex_state = 3},
  [10301] = {.lex_state = 541, .external_lex_state = 2},
  [10302] = {.lex_state = 364, .external_lex_state = 3},
  [10303] = {.lex_state = 167, .external_lex_state = 3},
  [10304] = {.lex_state = 364, .external_lex_state = 2},
  [10305] = {.lex_state = 363, .external_lex_state = 2},
  [10306] = {.lex_state = 167, .external_lex_state = 3},
  [10307] = {.lex_state = 541, .external_lex_state = 3},
  [10308] = {.lex_state = 167, .external_lex_state = 3},
  [10309] = {.lex_state = 541, .external_lex_state = 3},
  [10310] = {.lex_state = 541, .external_lex_state = 3},
  [10311] = {.lex_state = 541, .external_lex_state = 2},
  [10312] = {.lex_state = 167, .external_lex_state = 3},
  [10313] = {.lex_state = 167, .external_lex_state = 3},
  [10314] = {.lex_state = 364, .external_lex_state = 3},
  [10315] = {.lex_state = 167, .external_lex_state = 3},
  [10316] = {.lex_state = 364, .external_lex_state = 2},
  [10317] = {.lex_state = 367, .external_lex_state = 3},
  [10318] = {.lex_state = 167, .external_lex_state = 3},
  [10319] = {.lex_state = 167, .external_lex_state = 3},
  [10320] = {.lex_state = 541, .external_lex_state = 3},
  [10321] = {.lex_state = 167, .external_lex_state = 3},
  [10322] = {.lex_state = 547, .external_lex_state = 2},
  [10323] = {.lex_state = 167, .external_lex_state = 3},
  [10324] = {.lex_state = 541, .external_lex_state = 3},
  [10325] = {.lex_state = 167, .external_lex_state = 3},
  [10326] = {.lex_state = 539, .external_lex_state = 2},
  [10327] = {.lex_state = 545, .external_lex_state = 3},
  [10328] = {.lex_state = 545, .external_lex_state = 3},
  [10329] = {.lex_state = 167, .external_lex_state = 3},
  [10330] = {.lex_state = 545, .external_lex_state = 3},
  [10331] = {.lex_state = 167, .external_lex_state = 3},
  [10332] = {.lex_state = 363, .external_lex_state = 2},
  [10333] = {.lex_state = 167, .external_lex_state = 3},
  [10334] = {.lex_state = 184, .external_lex_state = 3},
  [10335] = {.lex_state = 363, .external_lex_state = 2},
  [10336] = {.lex_state = 184, .external_lex_state = 3},
  [10337] = {.lex_state = 364, .external_lex_state = 3},
  [10338] = {.lex_state = 184, .external_lex_state = 3},
  [10339] = {.lex_state = 364, .external_lex_state = 3},
  [10340] = {.lex_state = 364, .external_lex_state = 3},
  [10341] = {.lex_state = 167, .external_lex_state = 3},
  [10342] = {.lex_state = 364, .external_lex_state = 3},
  [10343] = {.lex_state = 541, .external_lex_state = 2},
  [10344] = {.lex_state = 364, .external_lex_state = 3},
  [10345] = {.lex_state = 541, .external_lex_state = 3},
  [10346] = {.lex_state = 364, .external_lex_state = 3},
  [10347] = {.lex_state = 167, .external_lex_state = 3},
  [10348] = {.lex_state = 167, .external_lex_state = 3},
  [10349] = {.lex_state = 167, .external_lex_state = 3},
  [10350] = {.lex_state = 167, .external_lex_state = 3},
  [10351] = {.lex_state = 167, .external_lex_state = 3},
  [10352] = {.lex_state = 541, .external_lex_state = 3},
  [10353] = {.lex_state = 541, .external_lex_state = 3},
  [10354] = {.lex_state = 167, .external_lex_state = 3},
  [10355] = {.lex_state = 367, .external_lex_state = 3},
  [10356] = {.lex_state = 167, .external_lex_state = 3},
  [10357] = {.lex_state = 547, .external_lex_state = 3},
  [10358] = {.lex_state = 363, .external_lex_state = 2},
  [10359] = {.lex_state = 389, .external_lex_state = 3},
  [10360] = {.lex_state = 549, .external_lex_state = 3},
  [10361] = {.lex_state = 545, .external_lex_state = 3},
  [10362] = {.lex_state = 545, .external_lex_state = 3},
  [10363] = {.lex_state = 541, .external_lex_state = 3},
  [10364] = {.lex_state = 167, .external_lex_state = 3},
  [10365] = {.lex_state = 167, .external_lex_state = 3},
  [10366] = {.lex_state = 167, .external_lex_state = 3},
  [10367] = {.lex_state = 545, .external_lex_state = 3},
  [10368] = {.lex_state = 541, .external_lex_state = 3},
  [10369] = {.lex_state = 541, .external_lex_state = 3},
  [10370] = {.lex_state = 364, .external_lex_state = 3},
  [10371] = {.lex_state = 364, .external_lex_state = 3},
  [10372] = {.lex_state = 541, .external_lex_state = 3},
  [10373] = {.lex_state = 167, .external_lex_state = 3},
  [10374] = {.lex_state = 167, .external_lex_state = 3},
  [10375] = {.lex_state = 541, .external_lex_state = 3},
  [10376] = {.lex_state = 545, .external_lex_state = 3},
  [10377] = {.lex_state = 545, .external_lex_state = 3},
  [10378] = {.lex_state = 541, .external_lex_state = 3},
  [10379] = {.lex_state = 167, .external_lex_state = 3},
  [10380] = {.lex_state = 167, .external_lex_state = 3},
  [10381] = {.lex_state = 545, .external_lex_state = 3},
  [10382] = {.lex_state = 384},
  [10383] = {.lex_state = 541, .external_lex_state = 3},
  [10384] = {.lex_state = 545, .external_lex_state = 3},
  [10385] = {.lex_state = 545, .external_lex_state = 3},
  [10386] = {.lex_state = 545, .external_lex_state = 3},
  [10387] = {.lex_state = 364, .external_lex_state = 3},
  [10388] = {.lex_state = 545, .external_lex_state = 3},
  [10389] = {.lex_state = 541, .external_lex_state = 3},
  [10390] = {.lex_state = 364, .external_lex_state = 3},
  [10391] = {.lex_state = 545, .external_lex_state = 3},
  [10392] = {.lex_state = 545, .external_lex_state = 3},
  [10393] = {.lex_state = 545, .external_lex_state = 3},
  [10394] = {.lex_state = 545, .external_lex_state = 3},
  [10395] = {.lex_state = 545, .external_lex_state = 3},
  [10396] = {.lex_state = 545, .external_lex_state = 3},
  [10397] = {.lex_state = 545, .external_lex_state = 3},
  [10398] = {.lex_state = 545, .external_lex_state = 3},
  [10399] = {.lex_state = 545, .external_lex_state = 3},
  [10400] = {.lex_state = 545, .external_lex_state = 3},
  [10401] = {.lex_state = 545, .external_lex_state = 3},
  [10402] = {.lex_state = 364, .external_lex_state = 3},
  [10403] = {.lex_state = 545, .external_lex_state = 3},
  [10404] = {.lex_state = 364, .external_lex_state = 3},
  [10405] = {.lex_state = 364, .external_lex_state = 3},
  [10406] = {.lex_state = 364, .external_lex_state = 3},
  [10407] = {.lex_state = 541, .external_lex_state = 3},
  [10408] = {.lex_state = 541, .external_lex_state = 3},
  [10409] = {.lex_state = 384},
  [10410] = {.lex_state = 384},
  [10411] = {.lex_state = 545, .external_lex_state = 3},
  [10412] = {.lex_state = 384},
  [10413] = {.lex_state = 547, .external_lex_state = 3},
  [10414] = {.lex_state = 545, .external_lex_state = 3},
  [10415] = {.lex_state = 545, .external_lex_state = 3},
  [10416] = {.lex_state = 364, .external_lex_state = 3},
  [10417] = {.lex_state = 384},
  [10418] = {.lex_state = 545, .external_lex_state = 3},
  [10419] = {.lex_state = 541, .external_lex_state = 3},
  [10420] = {.lex_state = 363, .external_lex_state = 2},
  [10421] = {.lex_state = 384},
  [10422] = {.lex_state = 384},
  [10423] = {.lex_state = 545, .external_lex_state = 3},
  [10424] = {.lex_state = 364, .external_lex_state = 3},
  [10425] = {.lex_state = 541, .external_lex_state = 3},
  [10426] = {.lex_state = 541, .external_lex_state = 3},
  [10427] = {.lex_state = 384},
  [10428] = {.lex_state = 545, .external_lex_state = 3},
  [10429] = {.lex_state = 547, .external_lex_state = 3},
  [10430] = {.lex_state = 363, .external_lex_state = 2},
  [10431] = {.lex_state = 545, .external_lex_state = 3},
  [10432] = {.lex_state = 545, .external_lex_state = 3},
  [10433] = {.lex_state = 545, .external_lex_state = 3},
  [10434] = {.lex_state = 545, .external_lex_state = 3},
  [10435] = {.lex_state = 541, .external_lex_state = 3},
  [10436] = {.lex_state = 541, .external_lex_state = 3},
  [10437] = {.lex_state = 541, .external_lex_state = 3},
  [10438] = {.lex_state = 545, .external_lex_state = 3},
  [10439] = {.lex_state = 384},
  [10440] = {.lex_state = 547, .external_lex_state = 3},
  [10441] = {.lex_state = 384},
  [10442] = {.lex_state = 545, .external_lex_state = 3},
  [10443] = {.lex_state = 364, .external_lex_state = 3},
  [10444] = {.lex_state = 547, .external_lex_state = 3},
  [10445] = {.lex_state = 541, .external_lex_state = 3},
  [10446] = {.lex_state = 364, .external_lex_state = 3},
  [10447] = {.lex_state = 384},
  [10448] = {.lex_state = 384},
  [10449] = {.lex_state = 384},
  [10450] = {.lex_state = 545, .external_lex_state = 3},
  [10451] = {.lex_state = 545, .external_lex_state = 3},
  [10452] = {.lex_state = 545, .external_lex_state = 3},
  [10453] = {.lex_state = 384},
  [10454] = {.lex_state = 384},
  [10455] = {.lex_state = 384},
  [10456] = {.lex_state = 364, .external_lex_state = 3},
  [10457] = {.lex_state = 364, .external_lex_state = 3},
  [10458] = {.lex_state = 364, .external_lex_state = 3},
  [10459] = {.lex_state = 364, .external_lex_state = 3},
  [10460] = {.lex_state = 364, .external_lex_state = 3},
  [10461] = {.lex_state = 364, .external_lex_state = 3},
  [10462] = {.lex_state = 545, .external_lex_state = 3},
  [10463] = {.lex_state = 545, .external_lex_state = 3},
  [10464] = {.lex_state = 547, .external_lex_state = 3},
  [10465] = {.lex_state = 547, .external_lex_state = 3},
  [10466] = {.lex_state = 547, .external_lex_state = 3},
  [10467] = {.lex_state = 545, .external_lex_state = 3},
  [10468] = {.lex_state = 384},
  [10469] = {.lex_state = 364, .external_lex_state = 3},
  [10470] = {.lex_state = 384},
  [10471] = {.lex_state = 384},
  [10472] = {.lex_state = 384},
  [10473] = {.lex_state = 384},
  [10474] = {.lex_state = 541, .external_lex_state = 3},
  [10475] = {.lex_state = 553, .external_lex_state = 3},
  [10476] = {.lex_state = 545, .external_lex_state = 3},
  [10477] = {.lex_state = 384},
  [10478] = {.lex_state = 384},
  [10479] = {.lex_state = 545, .external_lex_state = 3},
  [10480] = {.lex_state = 541, .external_lex_state = 3},
  [10481] = {.lex_state = 545, .external_lex_state = 3},
  [10482] = {.lex_state = 384},
  [10483] = {.lex_state = 384},
  [10484] = {.lex_state = 545, .external_lex_state = 3},
  [10485] = {.lex_state = 384},
  [10486] = {.lex_state = 545, .external_lex_state = 3},
  [10487] = {.lex_state = 545, .external_lex_state = 3},
  [10488] = {.lex_state = 547, .external_lex_state = 3},
  [10489] = {.lex_state = 384},
  [10490] = {.lex_state = 545, .external_lex_state = 3},
  [10491] = {.lex_state = 384, .external_lex_state = 3},
  [10492] = {.lex_state = 547, .external_lex_state = 3},
  [10493] = {.lex_state = 384},
  [10494] = {.lex_state = 384},
  [10495] = {.lex_state = 384},
  [10496] = {.lex_state = 547, .external_lex_state = 3},
  [10497] = {.lex_state = 384},
  [10498] = {.lex_state = 547, .external_lex_state = 3},
  [10499] = {.lex_state = 541, .external_lex_state = 3},
  [10500] = {.lex_state = 384},
  [10501] = {.lex_state = 545, .external_lex_state = 3},
  [10502] = {.lex_state = 363, .external_lex_state = 2},
  [10503] = {.lex_state = 545, .external_lex_state = 3},
  [10504] = {.lex_state = 364, .external_lex_state = 3},
  [10505] = {.lex_state = 363, .external_lex_state = 2},
  [10506] = {.lex_state = 363, .external_lex_state = 2},
  [10507] = {.lex_state = 364, .external_lex_state = 3},
  [10508] = {.lex_state = 384},
  [10509] = {.lex_state = 384, .external_lex_state = 3},
  [10510] = {.lex_state = 384},
  [10511] = {.lex_state = 545, .external_lex_state = 3},
  [10512] = {.lex_state = 384},
  [10513] = {.lex_state = 547, .external_lex_state = 3},
  [10514] = {.lex_state = 364, .external_lex_state = 3},
  [10515] = {.lex_state = 364, .external_lex_state = 3},
  [10516] = {.lex_state = 545, .external_lex_state = 3},
  [10517] = {.lex_state = 384},
  [10518] = {.lex_state = 384},
  [10519] = {.lex_state = 384},
  [10520] = {.lex_state = 545, .external_lex_state = 3},
  [10521] = {.lex_state = 545, .external_lex_state = 3},
  [10522] = {.lex_state = 545, .external_lex_state = 3},
  [10523] = {.lex_state = 545, .external_lex_state = 3},
  [10524] = {.lex_state = 545, .external_lex_state = 3},
  [10525] = {.lex_state = 545, .external_lex_state = 3},
  [10526] = {.lex_state = 545, .external_lex_state = 3},
  [10527] = {.lex_state = 545, .external_lex_state = 3},
  [10528] = {.lex_state = 545, .external_lex_state = 3},
  [10529] = {.lex_state = 545, .external_lex_state = 3},
  [10530] = {.lex_state = 541, .external_lex_state = 3},
  [10531] = {.lex_state = 539, .external_lex_state = 2},
  [10532] = {.lex_state = 545, .external_lex_state = 3},
  [10533] = {.lex_state = 364, .external_lex_state = 3},
  [10534] = {.lex_state = 364, .external_lex_state = 3},
  [10535] = {.lex_state = 384},
  [10536] = {.lex_state = 384},
  [10537] = {.lex_state = 384},
  [10538] = {.lex_state = 545, .external_lex_state = 3},
  [10539] = {.lex_state = 384},
  [10540] = {.lex_state = 364, .external_lex_state = 3},
  [10541] = {.lex_state = 384},
  [10542] = {.lex_state = 408},
  [10543] = {.lex_state = 384},
  [10544] = {.lex_state = 370, .external_lex_state = 2},
  [10545] = {.lex_state = 364, .external_lex_state = 3},
  [10546] = {.lex_state = 369, .external_lex_state = 3},
  [10547] = {.lex_state = 547, .external_lex_state = 3},
  [10548] = {.lex_state = 547, .external_lex_state = 3},
  [10549] = {.lex_state = 384, .external_lex_state = 5},
  [10550] = {.lex_state = 364, .external_lex_state = 2},
  [10551] = {.lex_state = 364, .external_lex_state = 2},
  [10552] = {.lex_state = 364, .external_lex_state = 3},
  [10553] = {.lex_state = 547, .external_lex_state = 3},
  [10554] = {.lex_state = 547, .external_lex_state = 3},
  [10555] = {.lex_state = 364, .external_lex_state = 2},
  [10556] = {.lex_state = 547, .external_lex_state = 3},
  [10557] = {.lex_state = 188, .external_lex_state = 2},
  [10558] = {.lex_state = 364, .external_lex_state = 3},
  [10559] = {.lex_state = 547, .external_lex_state = 3},
  [10560] = {.lex_state = 364, .external_lex_state = 3},
  [10561] = {.lex_state = 547, .external_lex_state = 3},
  [10562] = {.lex_state = 369, .external_lex_state = 3},
  [10563] = {.lex_state = 547, .external_lex_state = 3},
  [10564] = {.lex_state = 547, .external_lex_state = 3},
  [10565] = {.lex_state = 547, .external_lex_state = 3},
  [10566] = {.lex_state = 364, .external_lex_state = 3},
  [10567] = {.lex_state = 384, .external_lex_state = 4},
  [10568] = {.lex_state = 547, .external_lex_state = 3},
  [10569] = {.lex_state = 369, .external_lex_state = 3},
  [10570] = {.lex_state = 384, .external_lex_state = 4},
  [10571] = {.lex_state = 364, .external_lex_state = 3},
  [10572] = {.lex_state = 370, .external_lex_state = 2},
  [10573] = {.lex_state = 547, .external_lex_state = 3},
  [10574] = {.lex_state = 547, .external_lex_state = 3},
  [10575] = {.lex_state = 547, .external_lex_state = 3},
  [10576] = {.lex_state = 547, .external_lex_state = 3},
  [10577] = {.lex_state = 547, .external_lex_state = 3},
  [10578] = {.lex_state = 547, .external_lex_state = 3},
  [10579] = {.lex_state = 547, .external_lex_state = 3},
  [10580] = {.lex_state = 384},
  [10581] = {.lex_state = 547, .external_lex_state = 3},
  [10582] = {.lex_state = 547, .external_lex_state = 3},
  [10583] = {.lex_state = 547, .external_lex_state = 3},
  [10584] = {.lex_state = 384, .external_lex_state = 4},
  [10585] = {.lex_state = 547, .external_lex_state = 3},
  [10586] = {.lex_state = 190, .external_lex_state = 3},
  [10587] = {.lex_state = 547, .external_lex_state = 3},
  [10588] = {.lex_state = 363, .external_lex_state = 2},
  [10589] = {.lex_state = 190, .external_lex_state = 3},
  [10590] = {.lex_state = 545, .external_lex_state = 2},
  [10591] = {.lex_state = 190, .external_lex_state = 3},
  [10592] = {.lex_state = 547, .external_lex_state = 3},
  [10593] = {.lex_state = 389, .external_lex_state = 2},
  [10594] = {.lex_state = 192, .external_lex_state = 3},
  [10595] = {.lex_state = 384},
  [10596] = {.lex_state = 547, .external_lex_state = 3},
  [10597] = {.lex_state = 384, .external_lex_state = 4},
  [10598] = {.lex_state = 192, .external_lex_state = 3},
  [10599] = {.lex_state = 547, .external_lex_state = 3},
  [10600] = {.lex_state = 364, .external_lex_state = 3},
  [10601] = {.lex_state = 369, .external_lex_state = 3},
  [10602] = {.lex_state = 384},
  [10603] = {.lex_state = 541, .external_lex_state = 3},
  [10604] = {.lex_state = 192, .external_lex_state = 3},
  [10605] = {.lex_state = 547, .external_lex_state = 3},
  [10606] = {.lex_state = 188, .external_lex_state = 2},
  [10607] = {.lex_state = 545, .external_lex_state = 2},
  [10608] = {.lex_state = 190, .external_lex_state = 3},
  [10609] = {.lex_state = 545, .external_lex_state = 2},
  [10610] = {.lex_state = 364, .external_lex_state = 3},
  [10611] = {.lex_state = 547, .external_lex_state = 3},
  [10612] = {.lex_state = 389, .external_lex_state = 2},
  [10613] = {.lex_state = 389, .external_lex_state = 2},
  [10614] = {.lex_state = 547, .external_lex_state = 3},
  [10615] = {.lex_state = 364, .external_lex_state = 3},
  [10616] = {.lex_state = 364, .external_lex_state = 3},
  [10617] = {.lex_state = 547, .external_lex_state = 3},
  [10618] = {.lex_state = 545, .external_lex_state = 2},
  [10619] = {.lex_state = 389, .external_lex_state = 2},
  [10620] = {.lex_state = 547, .external_lex_state = 3},
  [10621] = {.lex_state = 547, .external_lex_state = 3},
  [10622] = {.lex_state = 364, .external_lex_state = 3},
  [10623] = {.lex_state = 370, .external_lex_state = 2},
  [10624] = {.lex_state = 370, .external_lex_state = 2},
  [10625] = {.lex_state = 547, .external_lex_state = 3},
  [10626] = {.lex_state = 547, .external_lex_state = 3},
  [10627] = {.lex_state = 547, .external_lex_state = 3},
  [10628] = {.lex_state = 192, .external_lex_state = 3},
  [10629] = {.lex_state = 547, .external_lex_state = 3},
  [10630] = {.lex_state = 364, .external_lex_state = 3},
  [10631] = {.lex_state = 188, .external_lex_state = 3},
  [10632] = {.lex_state = 188, .external_lex_state = 2},
  [10633] = {.lex_state = 541, .external_lex_state = 3},
  [10634] = {.lex_state = 188, .external_lex_state = 3},
  [10635] = {.lex_state = 391, .external_lex_state = 3},
  [10636] = {.lex_state = 384, .external_lex_state = 5},
  [10637] = {.lex_state = 399},
  [10638] = {.lex_state = 370, .external_lex_state = 2},
  [10639] = {.lex_state = 188, .external_lex_state = 2},
  [10640] = {.lex_state = 541, .external_lex_state = 3},
  [10641] = {.lex_state = 364, .external_lex_state = 3},
  [10642] = {.lex_state = 547, .external_lex_state = 3},
  [10643] = {.lex_state = 188, .external_lex_state = 3},
  [10644] = {.lex_state = 399},
  [10645] = {.lex_state = 364, .external_lex_state = 3},
  [10646] = {.lex_state = 399},
  [10647] = {.lex_state = 391, .external_lex_state = 3},
  [10648] = {.lex_state = 364, .external_lex_state = 3},
  [10649] = {.lex_state = 391, .external_lex_state = 3},
  [10650] = {.lex_state = 391, .external_lex_state = 3},
  [10651] = {.lex_state = 364, .external_lex_state = 3},
  [10652] = {.lex_state = 547, .external_lex_state = 3},
  [10653] = {.lex_state = 370, .external_lex_state = 2},
  [10654] = {.lex_state = 188, .external_lex_state = 3},
  [10655] = {.lex_state = 547, .external_lex_state = 3},
  [10656] = {.lex_state = 547, .external_lex_state = 3},
  [10657] = {.lex_state = 547, .external_lex_state = 3},
  [10658] = {.lex_state = 547, .external_lex_state = 3},
  [10659] = {.lex_state = 547, .external_lex_state = 3},
  [10660] = {.lex_state = 547, .external_lex_state = 3},
  [10661] = {.lex_state = 188, .external_lex_state = 2},
  [10662] = {.lex_state = 363, .external_lex_state = 2},
  [10663] = {.lex_state = 547, .external_lex_state = 3},
  [10664] = {.lex_state = 384},
  [10665] = {.lex_state = 364, .external_lex_state = 3},
  [10666] = {.lex_state = 364, .external_lex_state = 3},
  [10667] = {.lex_state = 547, .external_lex_state = 3},
  [10668] = {.lex_state = 547, .external_lex_state = 3},
  [10669] = {.lex_state = 547, .external_lex_state = 3},
  [10670] = {.lex_state = 547, .external_lex_state = 3},
  [10671] = {.lex_state = 547, .external_lex_state = 3},
  [10672] = {.lex_state = 547, .external_lex_state = 3},
  [10673] = {.lex_state = 364, .external_lex_state = 3},
  [10674] = {.lex_state = 370, .external_lex_state = 2},
  [10675] = {.lex_state = 547, .external_lex_state = 3},
  [10676] = {.lex_state = 363, .external_lex_state = 2},
  [10677] = {.lex_state = 547, .external_lex_state = 3},
  [10678] = {.lex_state = 363, .external_lex_state = 2},
  [10679] = {.lex_state = 547, .external_lex_state = 3},
  [10680] = {.lex_state = 547, .external_lex_state = 3},
  [10681] = {.lex_state = 547, .external_lex_state = 3},
  [10682] = {.lex_state = 547, .external_lex_state = 3},
  [10683] = {.lex_state = 399},
  [10684] = {.lex_state = 545, .external_lex_state = 2},
  [10685] = {.lex_state = 547, .external_lex_state = 2},
  [10686] = {.lex_state = 386, .external_lex_state = 3},
  [10687] = {.lex_state = 384},
  [10688] = {.lex_state = 384, .external_lex_state = 2},
  [10689] = {.lex_state = 384},
  [10690] = {.lex_state = 364, .external_lex_state = 3},
  [10691] = {.lex_state = 371, .external_lex_state = 3},
  [10692] = {.lex_state = 194, .external_lex_state = 3},
  [10693] = {.lex_state = 547, .external_lex_state = 5},
  [10694] = {.lex_state = 188, .external_lex_state = 3},
  [10695] = {.lex_state = 545, .external_lex_state = 2},
  [10696] = {.lex_state = 386, .external_lex_state = 3},
  [10697] = {.lex_state = 188, .external_lex_state = 3},
  [10698] = {.lex_state = 196, .external_lex_state = 3},
  [10699] = {.lex_state = 384},
  [10700] = {.lex_state = 386, .external_lex_state = 3},
  [10701] = {.lex_state = 364, .external_lex_state = 3},
  [10702] = {.lex_state = 384},
  [10703] = {.lex_state = 364, .external_lex_state = 3},
  [10704] = {.lex_state = 364, .external_lex_state = 3},
  [10705] = {.lex_state = 384},
  [10706] = {.lex_state = 563, .external_lex_state = 3},
  [10707] = {.lex_state = 188, .external_lex_state = 3},
  [10708] = {.lex_state = 198, .external_lex_state = 3},
  [10709] = {.lex_state = 384},
  [10710] = {.lex_state = 563, .external_lex_state = 2},
  [10711] = {.lex_state = 563, .external_lex_state = 3},
  [10712] = {.lex_state = 384},
  [10713] = {.lex_state = 545, .external_lex_state = 2},
  [10714] = {.lex_state = 188, .external_lex_state = 3},
  [10715] = {.lex_state = 384},
  [10716] = {.lex_state = 188, .external_lex_state = 3},
  [10717] = {.lex_state = 384},
  [10718] = {.lex_state = 545, .external_lex_state = 2},
  [10719] = {.lex_state = 384},
  [10720] = {.lex_state = 384},
  [10721] = {.lex_state = 545, .external_lex_state = 2},
  [10722] = {.lex_state = 364, .external_lex_state = 3},
  [10723] = {.lex_state = 385},
  [10724] = {.lex_state = 384},
  [10725] = {.lex_state = 386, .external_lex_state = 3},
  [10726] = {.lex_state = 200, .external_lex_state = 3},
  [10727] = {.lex_state = 385},
  [10728] = {.lex_state = 384},
  [10729] = {.lex_state = 372, .external_lex_state = 2},
  [10730] = {.lex_state = 198, .external_lex_state = 3},
  [10731] = {.lex_state = 547, .external_lex_state = 2},
  [10732] = {.lex_state = 384},
  [10733] = {.lex_state = 384},
  [10734] = {.lex_state = 545, .external_lex_state = 2},
  [10735] = {.lex_state = 384},
  [10736] = {.lex_state = 384},
  [10737] = {.lex_state = 384},
  [10738] = {.lex_state = 545, .external_lex_state = 2},
  [10739] = {.lex_state = 384},
  [10740] = {.lex_state = 188, .external_lex_state = 3},
  [10741] = {.lex_state = 563, .external_lex_state = 2},
  [10742] = {.lex_state = 545, .external_lex_state = 2},
  [10743] = {.lex_state = 385},
  [10744] = {.lex_state = 545, .external_lex_state = 2},
  [10745] = {.lex_state = 547, .external_lex_state = 2},
  [10746] = {.lex_state = 200, .external_lex_state = 3},
  [10747] = {.lex_state = 384, .external_lex_state = 2},
  [10748] = {.lex_state = 545, .external_lex_state = 2},
  [10749] = {.lex_state = 384},
  [10750] = {.lex_state = 188, .external_lex_state = 3},
  [10751] = {.lex_state = 384},
  [10752] = {.lex_state = 364, .external_lex_state = 3},
  [10753] = {.lex_state = 563, .external_lex_state = 2},
  [10754] = {.lex_state = 384, .external_lex_state = 2},
  [10755] = {.lex_state = 384},
  [10756] = {.lex_state = 541, .external_lex_state = 3},
  [10757] = {.lex_state = 364, .external_lex_state = 3},
  [10758] = {.lex_state = 563, .external_lex_state = 2},
  [10759] = {.lex_state = 363, .external_lex_state = 2},
  [10760] = {.lex_state = 384},
  [10761] = {.lex_state = 384},
  [10762] = {.lex_state = 200, .external_lex_state = 3},
  [10763] = {.lex_state = 200, .external_lex_state = 3},
  [10764] = {.lex_state = 194, .external_lex_state = 3},
  [10765] = {.lex_state = 547, .external_lex_state = 2},
  [10766] = {.lex_state = 563, .external_lex_state = 2},
  [10767] = {.lex_state = 188, .external_lex_state = 3},
  [10768] = {.lex_state = 384},
  [10769] = {.lex_state = 545, .external_lex_state = 2},
  [10770] = {.lex_state = 364, .external_lex_state = 3},
  [10771] = {.lex_state = 384},
  [10772] = {.lex_state = 202, .external_lex_state = 3},
  [10773] = {.lex_state = 384},
  [10774] = {.lex_state = 384, .external_lex_state = 5},
  [10775] = {.lex_state = 384},
  [10776] = {.lex_state = 384, .external_lex_state = 2},
  [10777] = {.lex_state = 384},
  [10778] = {.lex_state = 196, .external_lex_state = 3},
  [10779] = {.lex_state = 384},
  [10780] = {.lex_state = 563, .external_lex_state = 3},
  [10781] = {.lex_state = 384},
  [10782] = {.lex_state = 198, .external_lex_state = 3},
  [10783] = {.lex_state = 384},
  [10784] = {.lex_state = 384},
  [10785] = {.lex_state = 384},
  [10786] = {.lex_state = 384},
  [10787] = {.lex_state = 364, .external_lex_state = 3},
  [10788] = {.lex_state = 371, .external_lex_state = 3},
  [10789] = {.lex_state = 384},
  [10790] = {.lex_state = 384},
  [10791] = {.lex_state = 384},
  [10792] = {.lex_state = 384},
  [10793] = {.lex_state = 384},
  [10794] = {.lex_state = 196, .external_lex_state = 3},
  [10795] = {.lex_state = 384},
  [10796] = {.lex_state = 384},
  [10797] = {.lex_state = 385},
  [10798] = {.lex_state = 384},
  [10799] = {.lex_state = 384},
  [10800] = {.lex_state = 194, .external_lex_state = 3},
  [10801] = {.lex_state = 384},
  [10802] = {.lex_state = 384},
  [10803] = {.lex_state = 364, .external_lex_state = 3},
  [10804] = {.lex_state = 384},
  [10805] = {.lex_state = 196, .external_lex_state = 3},
  [10806] = {.lex_state = 384},
  [10807] = {.lex_state = 384},
  [10808] = {.lex_state = 364, .external_lex_state = 3},
  [10809] = {.lex_state = 384},
  [10810] = {.lex_state = 188, .external_lex_state = 3},
  [10811] = {.lex_state = 384},
  [10812] = {.lex_state = 204, .external_lex_state = 3},
  [10813] = {.lex_state = 384},
  [10814] = {.lex_state = 188, .external_lex_state = 3},
  [10815] = {.lex_state = 384},
  [10816] = {.lex_state = 384},
  [10817] = {.lex_state = 384},
  [10818] = {.lex_state = 384},
  [10819] = {.lex_state = 202, .external_lex_state = 3},
  [10820] = {.lex_state = 384},
  [10821] = {.lex_state = 188, .external_lex_state = 3},
  [10822] = {.lex_state = 384, .external_lex_state = 5},
  [10823] = {.lex_state = 384},
  [10824] = {.lex_state = 384},
  [10825] = {.lex_state = 364, .external_lex_state = 3},
  [10826] = {.lex_state = 384},
  [10827] = {.lex_state = 384},
  [10828] = {.lex_state = 371, .external_lex_state = 3},
  [10829] = {.lex_state = 545, .external_lex_state = 2},
  [10830] = {.lex_state = 563, .external_lex_state = 3},
  [10831] = {.lex_state = 364, .external_lex_state = 3},
  [10832] = {.lex_state = 384},
  [10833] = {.lex_state = 384},
  [10834] = {.lex_state = 384},
  [10835] = {.lex_state = 194, .external_lex_state = 3},
  [10836] = {.lex_state = 384},
  [10837] = {.lex_state = 384},
  [10838] = {.lex_state = 384},
  [10839] = {.lex_state = 364, .external_lex_state = 3},
  [10840] = {.lex_state = 349},
  [10841] = {.lex_state = 384},
  [10842] = {.lex_state = 202, .external_lex_state = 3},
  [10843] = {.lex_state = 372, .external_lex_state = 2},
  [10844] = {.lex_state = 198, .external_lex_state = 3},
  [10845] = {.lex_state = 384},
  [10846] = {.lex_state = 188, .external_lex_state = 3},
  [10847] = {.lex_state = 371, .external_lex_state = 3},
  [10848] = {.lex_state = 202, .external_lex_state = 3},
  [10849] = {.lex_state = 349},
  [10850] = {.lex_state = 206, .external_lex_state = 3},
  [10851] = {.lex_state = 188, .external_lex_state = 3},
  [10852] = {.lex_state = 188, .external_lex_state = 3},
  [10853] = {.lex_state = 206, .external_lex_state = 3},
  [10854] = {.lex_state = 364, .external_lex_state = 3},
  [10855] = {.lex_state = 188, .external_lex_state = 3},
  [10856] = {.lex_state = 188, .external_lex_state = 3},
  [10857] = {.lex_state = 188, .external_lex_state = 3},
  [10858] = {.lex_state = 188, .external_lex_state = 3},
  [10859] = {.lex_state = 349},
  [10860] = {.lex_state = 188, .external_lex_state = 3},
  [10861] = {.lex_state = 188, .external_lex_state = 3},
  [10862] = {.lex_state = 188, .external_lex_state = 3},
  [10863] = {.lex_state = 188, .external_lex_state = 3},
  [10864] = {.lex_state = 188, .external_lex_state = 3},
  [10865] = {.lex_state = 188, .external_lex_state = 3},
  [10866] = {.lex_state = 188, .external_lex_state = 3},
  [10867] = {.lex_state = 364, .external_lex_state = 3},
  [10868] = {.lex_state = 208, .external_lex_state = 3},
  [10869] = {.lex_state = 349},
  [10870] = {.lex_state = 563, .external_lex_state = 3},
  [10871] = {.lex_state = 563, .external_lex_state = 3},
  [10872] = {.lex_state = 563, .external_lex_state = 3},
  [10873] = {.lex_state = 563, .external_lex_state = 3},
  [10874] = {.lex_state = 563, .external_lex_state = 3},
  [10875] = {.lex_state = 563, .external_lex_state = 3},
  [10876] = {.lex_state = 563, .external_lex_state = 3},
  [10877] = {.lex_state = 364, .external_lex_state = 3},
  [10878] = {.lex_state = 563, .external_lex_state = 3},
  [10879] = {.lex_state = 349},
  [10880] = {.lex_state = 563, .external_lex_state = 3},
  [10881] = {.lex_state = 188, .external_lex_state = 3},
  [10882] = {.lex_state = 563, .external_lex_state = 3},
  [10883] = {.lex_state = 349},
  [10884] = {.lex_state = 349},
  [10885] = {.lex_state = 364, .external_lex_state = 3},
  [10886] = {.lex_state = 349},
  [10887] = {.lex_state = 364, .external_lex_state = 3},
  [10888] = {.lex_state = 349},
  [10889] = {.lex_state = 364, .external_lex_state = 3},
  [10890] = {.lex_state = 349},
  [10891] = {.lex_state = 364, .external_lex_state = 3},
  [10892] = {.lex_state = 349},
  [10893] = {.lex_state = 364, .external_lex_state = 3},
  [10894] = {.lex_state = 349},
  [10895] = {.lex_state = 364, .external_lex_state = 3},
  [10896] = {.lex_state = 349},
  [10897] = {.lex_state = 364, .external_lex_state = 3},
  [10898] = {.lex_state = 349},
  [10899] = {.lex_state = 364, .external_lex_state = 3},
  [10900] = {.lex_state = 349},
  [10901] = {.lex_state = 364, .external_lex_state = 3},
  [10902] = {.lex_state = 349},
  [10903] = {.lex_state = 364, .external_lex_state = 3},
  [10904] = {.lex_state = 349},
  [10905] = {.lex_state = 211, .external_lex_state = 3},
  [10906] = {.lex_state = 364, .external_lex_state = 3},
  [10907] = {.lex_state = 211, .external_lex_state = 3},
  [10908] = {.lex_state = 556, .external_lex_state = 3},
  [10909] = {.lex_state = 556, .external_lex_state = 3},
  [10910] = {.lex_state = 349},
  [10911] = {.lex_state = 373, .external_lex_state = 3},
  [10912] = {.lex_state = 211, .external_lex_state = 3},
  [10913] = {.lex_state = 211, .external_lex_state = 3},
  [10914] = {.lex_state = 364, .external_lex_state = 3},
  [10915] = {.lex_state = 556, .external_lex_state = 3},
  [10916] = {.lex_state = 556, .external_lex_state = 3},
  [10917] = {.lex_state = 349},
  [10918] = {.lex_state = 364, .external_lex_state = 3},
  [10919] = {.lex_state = 349},
  [10920] = {.lex_state = 545, .external_lex_state = 2},
  [10921] = {.lex_state = 364, .external_lex_state = 3},
  [10922] = {.lex_state = 349},
  [10923] = {.lex_state = 188, .external_lex_state = 3},
  [10924] = {.lex_state = 364, .external_lex_state = 3},
  [10925] = {.lex_state = 349},
  [10926] = {.lex_state = 364, .external_lex_state = 3},
  [10927] = {.lex_state = 349},
  [10928] = {.lex_state = 188, .external_lex_state = 3},
  [10929] = {.lex_state = 214, .external_lex_state = 3},
  [10930] = {.lex_state = 364, .external_lex_state = 3},
  [10931] = {.lex_state = 214, .external_lex_state = 3},
  [10932] = {.lex_state = 349},
  [10933] = {.lex_state = 545, .external_lex_state = 2},
  [10934] = {.lex_state = 364, .external_lex_state = 3},
  [10935] = {.lex_state = 364, .external_lex_state = 3},
  [10936] = {.lex_state = 214, .external_lex_state = 3},
  [10937] = {.lex_state = 214, .external_lex_state = 3},
  [10938] = {.lex_state = 349},
  [10939] = {.lex_state = 541, .external_lex_state = 3},
  [10940] = {.lex_state = 364, .external_lex_state = 3},
  [10941] = {.lex_state = 349},
  [10942] = {.lex_state = 364, .external_lex_state = 3},
  [10943] = {.lex_state = 349},
  [10944] = {.lex_state = 364, .external_lex_state = 3},
  [10945] = {.lex_state = 364, .external_lex_state = 3},
  [10946] = {.lex_state = 349},
  [10947] = {.lex_state = 364, .external_lex_state = 3},
  [10948] = {.lex_state = 364, .external_lex_state = 3},
  [10949] = {.lex_state = 364, .external_lex_state = 3},
  [10950] = {.lex_state = 349},
  [10951] = {.lex_state = 364, .external_lex_state = 3},
  [10952] = {.lex_state = 349},
  [10953] = {.lex_state = 384},
  [10954] = {.lex_state = 384},
  [10955] = {.lex_state = 384},
  [10956] = {.lex_state = 216, .external_lex_state = 3},
  [10957] = {.lex_state = 216, .external_lex_state = 3},
  [10958] = {.lex_state = 364, .external_lex_state = 3},
  [10959] = {.lex_state = 349},
  [10960] = {.lex_state = 216, .external_lex_state = 3},
  [10961] = {.lex_state = 216, .external_lex_state = 3},
  [10962] = {.lex_state = 364, .external_lex_state = 3},
  [10963] = {.lex_state = 349},
  [10964] = {.lex_state = 553},
  [10965] = {.lex_state = 349},
  [10966] = {.lex_state = 349},
  [10967] = {.lex_state = 349},
  [10968] = {.lex_state = 364, .external_lex_state = 3},
  [10969] = {.lex_state = 349},
  [10970] = {.lex_state = 349},
  [10971] = {.lex_state = 349},
  [10972] = {.lex_state = 349},
  [10973] = {.lex_state = 370, .external_lex_state = 3},
  [10974] = {.lex_state = 349},
  [10975] = {.lex_state = 349},
  [10976] = {.lex_state = 349},
  [10977] = {.lex_state = 349},
  [10978] = {.lex_state = 349},
  [10979] = {.lex_state = 349},
  [10980] = {.lex_state = 545, .external_lex_state = 2},
  [10981] = {.lex_state = 349},
  [10982] = {.lex_state = 384},
  [10983] = {.lex_state = 349},
  [10984] = {.lex_state = 349},
  [10985] = {.lex_state = 349},
  [10986] = {.lex_state = 349},
  [10987] = {.lex_state = 364, .external_lex_state = 3},
  [10988] = {.lex_state = 349},
  [10989] = {.lex_state = 349},
  [10990] = {.lex_state = 349},
  [10991] = {.lex_state = 349},
  [10992] = {.lex_state = 364, .external_lex_state = 3},
  [10993] = {.lex_state = 349},
  [10994] = {.lex_state = 392, .external_lex_state = 3},
  [10995] = {.lex_state = 392, .external_lex_state = 3},
  [10996] = {.lex_state = 349},
  [10997] = {.lex_state = 392, .external_lex_state = 3},
  [10998] = {.lex_state = 392, .external_lex_state = 3},
  [10999] = {.lex_state = 349},
  [11000] = {.lex_state = 349},
  [11001] = {.lex_state = 349},
  [11002] = {.lex_state = 349},
  [11003] = {.lex_state = 349},
  [11004] = {.lex_state = 349},
  [11005] = {.lex_state = 364, .external_lex_state = 3},
  [11006] = {.lex_state = 349},
  [11007] = {.lex_state = 349},
  [11008] = {.lex_state = 349},
  [11009] = {.lex_state = 349},
  [11010] = {.lex_state = 349},
  [11011] = {.lex_state = 349},
  [11012] = {.lex_state = 349},
  [11013] = {.lex_state = 349},
  [11014] = {.lex_state = 349},
  [11015] = {.lex_state = 349},
  [11016] = {.lex_state = 349},
  [11017] = {.lex_state = 349},
  [11018] = {.lex_state = 349},
  [11019] = {.lex_state = 349},
  [11020] = {.lex_state = 349},
  [11021] = {.lex_state = 349},
  [11022] = {.lex_state = 349},
  [11023] = {.lex_state = 364, .external_lex_state = 3},
  [11024] = {.lex_state = 370, .external_lex_state = 3},
  [11025] = {.lex_state = 349},
  [11026] = {.lex_state = 364, .external_lex_state = 3},
  [11027] = {.lex_state = 364, .external_lex_state = 3},
  [11028] = {.lex_state = 364, .external_lex_state = 3},
  [11029] = {.lex_state = 364, .external_lex_state = 3},
  [11030] = {.lex_state = 545, .external_lex_state = 2},
  [11031] = {.lex_state = 370, .external_lex_state = 3},
  [11032] = {.lex_state = 364, .external_lex_state = 3},
  [11033] = {.lex_state = 364, .external_lex_state = 3},
  [11034] = {.lex_state = 364, .external_lex_state = 3},
  [11035] = {.lex_state = 364, .external_lex_state = 3},
  [11036] = {.lex_state = 364, .external_lex_state = 3},
  [11037] = {.lex_state = 364, .external_lex_state = 3},
  [11038] = {.lex_state = 384},
  [11039] = {.lex_state = 364, .external_lex_state = 3},
  [11040] = {.lex_state = 364, .external_lex_state = 3},
  [11041] = {.lex_state = 349},
  [11042] = {.lex_state = 188, .external_lex_state = 3},
  [11043] = {.lex_state = 188, .external_lex_state = 3},
  [11044] = {.lex_state = 349},
  [11045] = {.lex_state = 188, .external_lex_state = 3},
  [11046] = {.lex_state = 370, .external_lex_state = 3},
  [11047] = {.lex_state = 545, .external_lex_state = 2},
  [11048] = {.lex_state = 389, .external_lex_state = 2},
  [11049] = {.lex_state = 188, .external_lex_state = 3},
  [11050] = {.lex_state = 188, .external_lex_state = 3},
  [11051] = {.lex_state = 545, .external_lex_state = 2},
  [11052] = {.lex_state = 545, .external_lex_state = 2},
  [11053] = {.lex_state = 389, .external_lex_state = 2},
  [11054] = {.lex_state = 389, .external_lex_state = 2},
  [11055] = {.lex_state = 545, .external_lex_state = 2},
  [11056] = {.lex_state = 389, .external_lex_state = 2},
  [11057] = {.lex_state = 364, .external_lex_state = 3},
  [11058] = {.lex_state = 349},
  [11059] = {.lex_state = 349},
  [11060] = {.lex_state = 349},
  [11061] = {.lex_state = 349},
  [11062] = {.lex_state = 349},
  [11063] = {.lex_state = 349},
  [11064] = {.lex_state = 349},
  [11065] = {.lex_state = 349},
  [11066] = {.lex_state = 349},
  [11067] = {.lex_state = 349},
  [11068] = {.lex_state = 349},
  [11069] = {.lex_state = 364, .external_lex_state = 3},
  [11070] = {.lex_state = 547, .external_lex_state = 2},
  [11071] = {.lex_state = 547, .external_lex_state = 2},
  [11072] = {.lex_state = 547, .external_lex_state = 2},
  [11073] = {.lex_state = 547, .external_lex_state = 2},
  [11074] = {.lex_state = 349},
  [11075] = {.lex_state = 349},
  [11076] = {.lex_state = 349},
  [11077] = {.lex_state = 349},
  [11078] = {.lex_state = 349},
  [11079] = {.lex_state = 349},
  [11080] = {.lex_state = 349},
  [11081] = {.lex_state = 349},
  [11082] = {.lex_state = 349},
  [11083] = {.lex_state = 349},
  [11084] = {.lex_state = 349},
  [11085] = {.lex_state = 349},
  [11086] = {.lex_state = 349},
  [11087] = {.lex_state = 349},
  [11088] = {.lex_state = 349},
  [11089] = {.lex_state = 547, .external_lex_state = 2},
  [11090] = {.lex_state = 547, .external_lex_state = 2},
  [11091] = {.lex_state = 547, .external_lex_state = 2},
  [11092] = {.lex_state = 547, .external_lex_state = 2},
  [11093] = {.lex_state = 349},
  [11094] = {.lex_state = 349},
  [11095] = {.lex_state = 349},
  [11096] = {.lex_state = 349},
  [11097] = {.lex_state = 547, .external_lex_state = 2},
  [11098] = {.lex_state = 547, .external_lex_state = 2},
  [11099] = {.lex_state = 547, .external_lex_state = 2},
  [11100] = {.lex_state = 547, .external_lex_state = 2},
  [11101] = {.lex_state = 349},
  [11102] = {.lex_state = 349},
  [11103] = {.lex_state = 349},
  [11104] = {.lex_state = 349},
  [11105] = {.lex_state = 349},
  [11106] = {.lex_state = 349},
  [11107] = {.lex_state = 349},
  [11108] = {.lex_state = 349},
  [11109] = {.lex_state = 349},
  [11110] = {.lex_state = 188, .external_lex_state = 3},
  [11111] = {.lex_state = 188, .external_lex_state = 3},
  [11112] = {.lex_state = 188, .external_lex_state = 3},
  [11113] = {.lex_state = 188, .external_lex_state = 3},
  [11114] = {.lex_state = 188, .external_lex_state = 3},
  [11115] = {.lex_state = 188, .external_lex_state = 3},
  [11116] = {.lex_state = 364, .external_lex_state = 3},
  [11117] = {.lex_state = 364, .external_lex_state = 3},
  [11118] = {.lex_state = 188, .external_lex_state = 3},
  [11119] = {.lex_state = 364, .external_lex_state = 3},
  [11120] = {.lex_state = 188, .external_lex_state = 3},
  [11121] = {.lex_state = 188, .external_lex_state = 3},
  [11122] = {.lex_state = 349},
  [11123] = {.lex_state = 349},
  [11124] = {.lex_state = 188, .external_lex_state = 3},
  [11125] = {.lex_state = 188, .external_lex_state = 3},
  [11126] = {.lex_state = 188, .external_lex_state = 3},
  [11127] = {.lex_state = 188, .external_lex_state = 3},
  [11128] = {.lex_state = 188, .external_lex_state = 3},
  [11129] = {.lex_state = 188, .external_lex_state = 3},
  [11130] = {.lex_state = 188, .external_lex_state = 3},
  [11131] = {.lex_state = 188, .external_lex_state = 3},
  [11132] = {.lex_state = 188, .external_lex_state = 3},
  [11133] = {.lex_state = 188, .external_lex_state = 3},
  [11134] = {.lex_state = 188, .external_lex_state = 3},
  [11135] = {.lex_state = 188, .external_lex_state = 3},
  [11136] = {.lex_state = 364, .external_lex_state = 3},
  [11137] = {.lex_state = 188, .external_lex_state = 3},
  [11138] = {.lex_state = 188, .external_lex_state = 3},
  [11139] = {.lex_state = 188, .external_lex_state = 3},
  [11140] = {.lex_state = 364, .external_lex_state = 3},
  [11141] = {.lex_state = 188, .external_lex_state = 3},
  [11142] = {.lex_state = 188, .external_lex_state = 3},
  [11143] = {.lex_state = 188, .external_lex_state = 3},
  [11144] = {.lex_state = 188, .external_lex_state = 3},
  [11145] = {.lex_state = 188, .external_lex_state = 3},
  [11146] = {.lex_state = 349},
  [11147] = {.lex_state = 188, .external_lex_state = 3},
  [11148] = {.lex_state = 188, .external_lex_state = 3},
  [11149] = {.lex_state = 188, .external_lex_state = 3},
  [11150] = {.lex_state = 188, .external_lex_state = 3},
  [11151] = {.lex_state = 349},
  [11152] = {.lex_state = 349},
  [11153] = {.lex_state = 349},
  [11154] = {.lex_state = 349},
  [11155] = {.lex_state = 349},
  [11156] = {.lex_state = 349},
  [11157] = {.lex_state = 545, .external_lex_state = 3},
  [11158] = {.lex_state = 389, .external_lex_state = 3},
  [11159] = {.lex_state = 349},
  [11160] = {.lex_state = 349},
  [11161] = {.lex_state = 349},
  [11162] = {.lex_state = 349},
  [11163] = {.lex_state = 349},
  [11164] = {.lex_state = 349},
  [11165] = {.lex_state = 349},
  [11166] = {.lex_state = 349},
  [11167] = {.lex_state = 349},
  [11168] = {.lex_state = 349},
  [11169] = {.lex_state = 349},
  [11170] = {.lex_state = 349},
  [11171] = {.lex_state = 349},
  [11172] = {.lex_state = 349},
  [11173] = {.lex_state = 349},
  [11174] = {.lex_state = 563, .external_lex_state = 3},
  [11175] = {.lex_state = 384},
  [11176] = {.lex_state = 364, .external_lex_state = 3},
  [11177] = {.lex_state = 349},
  [11178] = {.lex_state = 364, .external_lex_state = 3},
  [11179] = {.lex_state = 206, .external_lex_state = 3},
  [11180] = {.lex_state = 563, .external_lex_state = 3},
  [11181] = {.lex_state = 364, .external_lex_state = 3},
  [11182] = {.lex_state = 188, .external_lex_state = 3},
  [11183] = {.lex_state = 188, .external_lex_state = 3},
  [11184] = {.lex_state = 188, .external_lex_state = 3},
  [11185] = {.lex_state = 188, .external_lex_state = 3},
  [11186] = {.lex_state = 206, .external_lex_state = 3},
  [11187] = {.lex_state = 349},
  [11188] = {.lex_state = 372, .external_lex_state = 3},
  [11189] = {.lex_state = 547},
  [11190] = {.lex_state = 372, .external_lex_state = 3},
  [11191] = {.lex_state = 563, .external_lex_state = 3},
  [11192] = {.lex_state = 547, .external_lex_state = 2},
  [11193] = {.lex_state = 384},
  [11194] = {.lex_state = 547, .external_lex_state = 2},
  [11195] = {.lex_state = 384, .external_lex_state = 2},
  [11196] = {.lex_state = 547},
  [11197] = {.lex_state = 384, .external_lex_state = 2},
  [11198] = {.lex_state = 563, .external_lex_state = 3},
  [11199] = {.lex_state = 563, .external_lex_state = 3},
  [11200] = {.lex_state = 563, .external_lex_state = 3},
  [11201] = {.lex_state = 547, .external_lex_state = 2},
  [11202] = {.lex_state = 547},
  [11203] = {.lex_state = 384, .external_lex_state = 2},
  [11204] = {.lex_state = 372, .external_lex_state = 3},
  [11205] = {.lex_state = 563, .external_lex_state = 3},
  [11206] = {.lex_state = 563, .external_lex_state = 3},
  [11207] = {.lex_state = 563, .external_lex_state = 3},
  [11208] = {.lex_state = 547},
  [11209] = {.lex_state = 563, .external_lex_state = 3},
  [11210] = {.lex_state = 547},
  [11211] = {.lex_state = 563, .external_lex_state = 3},
  [11212] = {.lex_state = 547},
  [11213] = {.lex_state = 563, .external_lex_state = 3},
  [11214] = {.lex_state = 563, .external_lex_state = 3},
  [11215] = {.lex_state = 563, .external_lex_state = 3},
  [11216] = {.lex_state = 563, .external_lex_state = 3},
  [11217] = {.lex_state = 563, .external_lex_state = 3},
  [11218] = {.lex_state = 563, .external_lex_state = 3},
  [11219] = {.lex_state = 563, .external_lex_state = 3},
  [11220] = {.lex_state = 563, .external_lex_state = 3},
  [11221] = {.lex_state = 563, .external_lex_state = 3},
  [11222] = {.lex_state = 563, .external_lex_state = 3},
  [11223] = {.lex_state = 563, .external_lex_state = 3},
  [11224] = {.lex_state = 563, .external_lex_state = 3},
  [11225] = {.lex_state = 563, .external_lex_state = 3},
  [11226] = {.lex_state = 547},
  [11227] = {.lex_state = 547},
  [11228] = {.lex_state = 563, .external_lex_state = 3},
  [11229] = {.lex_state = 563, .external_lex_state = 3},
  [11230] = {.lex_state = 563, .external_lex_state = 3},
  [11231] = {.lex_state = 372, .external_lex_state = 3},
  [11232] = {.lex_state = 547},
  [11233] = {.lex_state = 547, .external_lex_state = 2},
  [11234] = {.lex_state = 372, .external_lex_state = 3},
  [11235] = {.lex_state = 563, .external_lex_state = 3},
  [11236] = {.lex_state = 372, .external_lex_state = 3},
  [11237] = {.lex_state = 547},
  [11238] = {.lex_state = 547},
  [11239] = {.lex_state = 547},
  [11240] = {.lex_state = 547},
  [11241] = {.lex_state = 547},
  [11242] = {.lex_state = 547},
  [11243] = {.lex_state = 563, .external_lex_state = 3},
  [11244] = {.lex_state = 563, .external_lex_state = 3},
  [11245] = {.lex_state = 387, .external_lex_state = 3},
  [11246] = {.lex_state = 218, .external_lex_state = 3},
  [11247] = {.lex_state = 563, .external_lex_state = 3},
  [11248] = {.lex_state = 563, .external_lex_state = 3},
  [11249] = {.lex_state = 563, .external_lex_state = 3},
  [11250] = {.lex_state = 563, .external_lex_state = 3},
  [11251] = {.lex_state = 563, .external_lex_state = 3},
  [11252] = {.lex_state = 218, .external_lex_state = 3},
  [11253] = {.lex_state = 547},
  [11254] = {.lex_state = 387, .external_lex_state = 3},
  [11255] = {.lex_state = 563, .external_lex_state = 3},
  [11256] = {.lex_state = 547},
  [11257] = {.lex_state = 547},
  [11258] = {.lex_state = 547},
  [11259] = {.lex_state = 547},
  [11260] = {.lex_state = 547},
  [11261] = {.lex_state = 558, .external_lex_state = 3},
  [11262] = {.lex_state = 563, .external_lex_state = 3},
  [11263] = {.lex_state = 563, .external_lex_state = 3},
  [11264] = {.lex_state = 558, .external_lex_state = 3},
  [11265] = {.lex_state = 372, .external_lex_state = 3},
  [11266] = {.lex_state = 218, .external_lex_state = 3},
  [11267] = {.lex_state = 218, .external_lex_state = 3},
  [11268] = {.lex_state = 372, .external_lex_state = 3},
  [11269] = {.lex_state = 563, .external_lex_state = 3},
  [11270] = {.lex_state = 372, .external_lex_state = 3},
  [11271] = {.lex_state = 384},
  [11272] = {.lex_state = 372, .external_lex_state = 3},
  [11273] = {.lex_state = 547, .external_lex_state = 2},
  [11274] = {.lex_state = 384},
  [11275] = {.lex_state = 547, .external_lex_state = 3},
  [11276] = {.lex_state = 372, .external_lex_state = 3},
  [11277] = {.lex_state = 384},
  [11278] = {.lex_state = 372, .external_lex_state = 3},
  [11279] = {.lex_state = 372, .external_lex_state = 3},
  [11280] = {.lex_state = 372, .external_lex_state = 3},
  [11281] = {.lex_state = 372, .external_lex_state = 3},
  [11282] = {.lex_state = 372, .external_lex_state = 3},
  [11283] = {.lex_state = 372, .external_lex_state = 3},
  [11284] = {.lex_state = 547},
  [11285] = {.lex_state = 372, .external_lex_state = 3},
  [11286] = {.lex_state = 563, .external_lex_state = 3},
  [11287] = {.lex_state = 547, .external_lex_state = 2},
  [11288] = {.lex_state = 372, .external_lex_state = 3},
  [11289] = {.lex_state = 372, .external_lex_state = 3},
  [11290] = {.lex_state = 372, .external_lex_state = 3},
  [11291] = {.lex_state = 372, .external_lex_state = 3},
  [11292] = {.lex_state = 563, .external_lex_state = 3},
  [11293] = {.lex_state = 547},
  [11294] = {.lex_state = 558, .external_lex_state = 3},
  [11295] = {.lex_state = 372, .external_lex_state = 3},
  [11296] = {.lex_state = 547},
  [11297] = {.lex_state = 547},
  [11298] = {.lex_state = 372, .external_lex_state = 3},
  [11299] = {.lex_state = 547},
  [11300] = {.lex_state = 555},
  [11301] = {.lex_state = 547},
  [11302] = {.lex_state = 372, .external_lex_state = 3},
  [11303] = {.lex_state = 372, .external_lex_state = 3},
  [11304] = {.lex_state = 372, .external_lex_state = 3},
  [11305] = {.lex_state = 372, .external_lex_state = 3},
  [11306] = {.lex_state = 547},
  [11307] = {.lex_state = 558, .external_lex_state = 3},
  [11308] = {.lex_state = 372, .external_lex_state = 3},
  [11309] = {.lex_state = 372, .external_lex_state = 3},
  [11310] = {.lex_state = 364, .external_lex_state = 3},
  [11311] = {.lex_state = 547},
  [11312] = {.lex_state = 563, .external_lex_state = 3},
  [11313] = {.lex_state = 372, .external_lex_state = 3},
  [11314] = {.lex_state = 547},
  [11315] = {.lex_state = 547},
  [11316] = {.lex_state = 547},
  [11317] = {.lex_state = 372, .external_lex_state = 3},
  [11318] = {.lex_state = 364, .external_lex_state = 3},
  [11319] = {.lex_state = 372, .external_lex_state = 3},
  [11320] = {.lex_state = 372, .external_lex_state = 3},
  [11321] = {.lex_state = 384},
  [11322] = {.lex_state = 384},
  [11323] = {.lex_state = 384},
  [11324] = {.lex_state = 545, .external_lex_state = 3},
  [11325] = {.lex_state = 547},
  [11326] = {.lex_state = 372, .external_lex_state = 3},
  [11327] = {.lex_state = 547, .external_lex_state = 2},
  [11328] = {.lex_state = 364, .external_lex_state = 3},
  [11329] = {.lex_state = 547},
  [11330] = {.lex_state = 384, .external_lex_state = 3},
  [11331] = {.lex_state = 384, .external_lex_state = 3},
  [11332] = {.lex_state = 372, .external_lex_state = 3},
  [11333] = {.lex_state = 563, .external_lex_state = 3},
  [11334] = {.lex_state = 547},
  [11335] = {.lex_state = 547},
  [11336] = {.lex_state = 563, .external_lex_state = 3},
  [11337] = {.lex_state = 545, .external_lex_state = 3},
  [11338] = {.lex_state = 563, .external_lex_state = 3},
  [11339] = {.lex_state = 563, .external_lex_state = 3},
  [11340] = {.lex_state = 372, .external_lex_state = 3},
  [11341] = {.lex_state = 563, .external_lex_state = 3},
  [11342] = {.lex_state = 545, .external_lex_state = 3},
  [11343] = {.lex_state = 372, .external_lex_state = 3},
  [11344] = {.lex_state = 384},
  [11345] = {.lex_state = 547},
  [11346] = {.lex_state = 384},
  [11347] = {.lex_state = 384},
  [11348] = {.lex_state = 372, .external_lex_state = 3},
  [11349] = {.lex_state = 547},
  [11350] = {.lex_state = 563, .external_lex_state = 3},
  [11351] = {.lex_state = 547},
  [11352] = {.lex_state = 563, .external_lex_state = 3},
  [11353] = {.lex_state = 547},
  [11354] = {.lex_state = 547},
  [11355] = {.lex_state = 563, .external_lex_state = 3},
  [11356] = {.lex_state = 563, .external_lex_state = 3},
  [11357] = {.lex_state = 547},
  [11358] = {.lex_state = 563, .external_lex_state = 3},
  [11359] = {.lex_state = 372, .external_lex_state = 3},
  [11360] = {.lex_state = 563, .external_lex_state = 3},
  [11361] = {.lex_state = 364, .external_lex_state = 3},
  [11362] = {.lex_state = 563, .external_lex_state = 3},
  [11363] = {.lex_state = 563, .external_lex_state = 3},
  [11364] = {.lex_state = 547},
  [11365] = {.lex_state = 563, .external_lex_state = 3},
  [11366] = {.lex_state = 563, .external_lex_state = 3},
  [11367] = {.lex_state = 563, .external_lex_state = 3},
  [11368] = {.lex_state = 563, .external_lex_state = 3},
  [11369] = {.lex_state = 547},
  [11370] = {.lex_state = 563, .external_lex_state = 3},
  [11371] = {.lex_state = 372, .external_lex_state = 3},
  [11372] = {.lex_state = 387, .external_lex_state = 3},
  [11373] = {.lex_state = 387, .external_lex_state = 3},
  [11374] = {.lex_state = 547, .external_lex_state = 2},
  [11375] = {.lex_state = 563, .external_lex_state = 3},
  [11376] = {.lex_state = 372, .external_lex_state = 3},
  [11377] = {.lex_state = 547, .external_lex_state = 3},
  [11378] = {.lex_state = 384, .external_lex_state = 2},
  [11379] = {.lex_state = 372, .external_lex_state = 3},
  [11380] = {.lex_state = 547, .external_lex_state = 4},
  [11381] = {.lex_state = 325},
  [11382] = {.lex_state = 395, .external_lex_state = 3},
  [11383] = {.lex_state = 545, .external_lex_state = 3},
  [11384] = {.lex_state = 325},
  [11385] = {.lex_state = 325},
  [11386] = {.lex_state = 221},
  [11387] = {.lex_state = 221},
  [11388] = {.lex_state = 223},
  [11389] = {.lex_state = 223},
  [11390] = {.lex_state = 223},
  [11391] = {.lex_state = 223},
  [11392] = {.lex_state = 221},
  [11393] = {.lex_state = 221},
  [11394] = {.lex_state = 547},
  [11395] = {.lex_state = 547, .external_lex_state = 5},
  [11396] = {.lex_state = 563, .external_lex_state = 5},
  [11397] = {.lex_state = 384, .external_lex_state = 5},
  [11398] = {.lex_state = 364, .external_lex_state = 3},
  [11399] = {.lex_state = 547, .external_lex_state = 5},
  [11400] = {.lex_state = 384, .external_lex_state = 5},
  [11401] = {.lex_state = 547},
  [11402] = {.lex_state = 547},
  [11403] = {.lex_state = 545, .external_lex_state = 3},
  [11404] = {.lex_state = 395, .external_lex_state = 3},
  [11405] = {.lex_state = 389, .external_lex_state = 3},
  [11406] = {.lex_state = 389, .external_lex_state = 2},
  [11407] = {.lex_state = 389, .external_lex_state = 2},
  [11408] = {.lex_state = 395, .external_lex_state = 3},
  [11409] = {.lex_state = 389, .external_lex_state = 2},
  [11410] = {.lex_state = 547, .external_lex_state = 4},
  [11411] = {.lex_state = 384},
  [11412] = {.lex_state = 547},
  [11413] = {.lex_state = 563, .external_lex_state = 5},
  [11414] = {.lex_state = 389, .external_lex_state = 2},
  [11415] = {.lex_state = 395, .external_lex_state = 3},
  [11416] = {.lex_state = 547, .external_lex_state = 3},
  [11417] = {.lex_state = 547, .external_lex_state = 3},
  [11418] = {.lex_state = 547, .external_lex_state = 3},
  [11419] = {.lex_state = 547, .external_lex_state = 4},
  [11420] = {.lex_state = 547, .external_lex_state = 3},
  [11421] = {.lex_state = 547, .external_lex_state = 3},
  [11422] = {.lex_state = 547, .external_lex_state = 3},
  [11423] = {.lex_state = 563, .external_lex_state = 5},
  [11424] = {.lex_state = 325},
  [11425] = {.lex_state = 225},
  [11426] = {.lex_state = 356},
  [11427] = {.lex_state = 356},
  [11428] = {.lex_state = 547},
  [11429] = {.lex_state = 547},
  [11430] = {.lex_state = 547},
  [11431] = {.lex_state = 547},
  [11432] = {.lex_state = 394, .external_lex_state = 3},
  [11433] = {.lex_state = 547},
  [11434] = {.lex_state = 227},
  [11435] = {.lex_state = 227},
  [11436] = {.lex_state = 547},
  [11437] = {.lex_state = 547},
  [11438] = {.lex_state = 547},
  [11439] = {.lex_state = 356},
  [11440] = {.lex_state = 356},
  [11441] = {.lex_state = 547},
  [11442] = {.lex_state = 356},
  [11443] = {.lex_state = 547},
  [11444] = {.lex_state = 547},
  [11445] = {.lex_state = 547},
  [11446] = {.lex_state = 547},
  [11447] = {.lex_state = 547},
  [11448] = {.lex_state = 547},
  [11449] = {.lex_state = 547},
  [11450] = {.lex_state = 547},
  [11451] = {.lex_state = 356},
  [11452] = {.lex_state = 547},
  [11453] = {.lex_state = 547},
  [11454] = {.lex_state = 547},
  [11455] = {.lex_state = 227},
  [11456] = {.lex_state = 547},
  [11457] = {.lex_state = 547},
  [11458] = {.lex_state = 227},
  [11459] = {.lex_state = 396, .external_lex_state = 2},
  [11460] = {.lex_state = 394, .external_lex_state = 3},
  [11461] = {.lex_state = 356},
  [11462] = {.lex_state = 356},
  [11463] = {.lex_state = 547},
  [11464] = {.lex_state = 547},
  [11465] = {.lex_state = 547},
  [11466] = {.lex_state = 547},
  [11467] = {.lex_state = 229},
  [11468] = {.lex_state = 229},
  [11469] = {.lex_state = 229},
  [11470] = {.lex_state = 547, .external_lex_state = 3},
  [11471] = {.lex_state = 229},
  [11472] = {.lex_state = 547},
  [11473] = {.lex_state = 396, .external_lex_state = 2},
  [11474] = {.lex_state = 547},
  [11475] = {.lex_state = 547},
  [11476] = {.lex_state = 547},
  [11477] = {.lex_state = 356},
  [11478] = {.lex_state = 547},
  [11479] = {.lex_state = 356},
  [11480] = {.lex_state = 396, .external_lex_state = 2},
  [11481] = {.lex_state = 563, .external_lex_state = 5},
  [11482] = {.lex_state = 547},
  [11483] = {.lex_state = 547},
  [11484] = {.lex_state = 547},
  [11485] = {.lex_state = 547},
  [11486] = {.lex_state = 547},
  [11487] = {.lex_state = 547},
  [11488] = {.lex_state = 547},
  [11489] = {.lex_state = 547},
  [11490] = {.lex_state = 547},
  [11491] = {.lex_state = 547},
  [11492] = {.lex_state = 563, .external_lex_state = 5},
  [11493] = {.lex_state = 547},
  [11494] = {.lex_state = 547},
  [11495] = {.lex_state = 356},
  [11496] = {.lex_state = 356},
  [11497] = {.lex_state = 384, .external_lex_state = 2},
  [11498] = {.lex_state = 547},
  [11499] = {.lex_state = 356},
  [11500] = {.lex_state = 356},
  [11501] = {.lex_state = 384, .external_lex_state = 2},
  [11502] = {.lex_state = 547},
  [11503] = {.lex_state = 356},
  [11504] = {.lex_state = 384, .external_lex_state = 2},
  [11505] = {.lex_state = 356},
  [11506] = {.lex_state = 547},
  [11507] = {.lex_state = 547},
  [11508] = {.lex_state = 384, .external_lex_state = 2},
  [11509] = {.lex_state = 547, .external_lex_state = 5},
  [11510] = {.lex_state = 356},
  [11511] = {.lex_state = 397, .external_lex_state = 3},
  [11512] = {.lex_state = 397, .external_lex_state = 3},
  [11513] = {.lex_state = 547, .external_lex_state = 3},
  [11514] = {.lex_state = 547},
  [11515] = {.lex_state = 397, .external_lex_state = 3},
  [11516] = {.lex_state = 397, .external_lex_state = 3},
  [11517] = {.lex_state = 547},
  [11518] = {.lex_state = 547, .external_lex_state = 5},
  [11519] = {.lex_state = 314},
  [11520] = {.lex_state = 547},
  [11521] = {.lex_state = 314},
  [11522] = {.lex_state = 547, .external_lex_state = 5},
  [11523] = {.lex_state = 547, .external_lex_state = 5},
  [11524] = {.lex_state = 314},
  [11525] = {.lex_state = 547},
  [11526] = {.lex_state = 384, .external_lex_state = 5},
  [11527] = {.lex_state = 384, .external_lex_state = 5},
  [11528] = {.lex_state = 547, .external_lex_state = 5},
  [11529] = {.lex_state = 547, .external_lex_state = 5},
  [11530] = {.lex_state = 547, .external_lex_state = 5},
  [11531] = {.lex_state = 547, .external_lex_state = 5},
  [11532] = {.lex_state = 356},
  [11533] = {.lex_state = 356},
  [11534] = {.lex_state = 384, .external_lex_state = 3},
  [11535] = {.lex_state = 384, .external_lex_state = 3},
  [11536] = {.lex_state = 396, .external_lex_state = 2},
  [11537] = {.lex_state = 356},
  [11538] = {.lex_state = 356},
  [11539] = {.lex_state = 547},
  [11540] = {.lex_state = 547},
  [11541] = {.lex_state = 547},
  [11542] = {.lex_state = 547},
  [11543] = {.lex_state = 396, .external_lex_state = 3},
  [11544] = {.lex_state = 547},
  [11545] = {.lex_state = 196},
  [11546] = {.lex_state = 196},
  [11547] = {.lex_state = 396, .external_lex_state = 2},
  [11548] = {.lex_state = 396, .external_lex_state = 3},
  [11549] = {.lex_state = 196},
  [11550] = {.lex_state = 356},
  [11551] = {.lex_state = 356},
  [11552] = {.lex_state = 196},
  [11553] = {.lex_state = 396, .external_lex_state = 3},
  [11554] = {.lex_state = 356},
  [11555] = {.lex_state = 356},
  [11556] = {.lex_state = 394, .external_lex_state = 3},
  [11557] = {.lex_state = 547},
  [11558] = {.lex_state = 356},
  [11559] = {.lex_state = 356},
  [11560] = {.lex_state = 547},
  [11561] = {.lex_state = 356},
  [11562] = {.lex_state = 356},
  [11563] = {.lex_state = 547},
  [11564] = {.lex_state = 356},
  [11565] = {.lex_state = 356},
  [11566] = {.lex_state = 356},
  [11567] = {.lex_state = 547},
  [11568] = {.lex_state = 356},
  [11569] = {.lex_state = 356},
  [11570] = {.lex_state = 356},
  [11571] = {.lex_state = 396, .external_lex_state = 3},
  [11572] = {.lex_state = 394, .external_lex_state = 3},
  [11573] = {.lex_state = 356},
  [11574] = {.lex_state = 356},
  [11575] = {.lex_state = 563, .external_lex_state = 4},
  [11576] = {.lex_state = 547},
  [11577] = {.lex_state = 202},
  [11578] = {.lex_state = 547, .external_lex_state = 3},
  [11579] = {.lex_state = 547, .external_lex_state = 3},
  [11580] = {.lex_state = 202},
  [11581] = {.lex_state = 202},
  [11582] = {.lex_state = 202},
  [11583] = {.lex_state = 547},
  [11584] = {.lex_state = 547},
  [11585] = {.lex_state = 547},
  [11586] = {.lex_state = 208},
  [11587] = {.lex_state = 547},
  [11588] = {.lex_state = 356},
  [11589] = {.lex_state = 356},
  [11590] = {.lex_state = 356},
  [11591] = {.lex_state = 225},
  [11592] = {.lex_state = 225},
  [11593] = {.lex_state = 225},
  [11594] = {.lex_state = 547},
  [11595] = {.lex_state = 547},
  [11596] = {.lex_state = 547},
  [11597] = {.lex_state = 547},
  [11598] = {.lex_state = 314},
  [11599] = {.lex_state = 400},
  [11600] = {.lex_state = 210},
  [11601] = {.lex_state = 547, .external_lex_state = 5},
  [11602] = {.lex_state = 384, .external_lex_state = 5},
  [11603] = {.lex_state = 384},
  [11604] = {.lex_state = 384},
  [11605] = {.lex_state = 563},
  [11606] = {.lex_state = 356},
  [11607] = {.lex_state = 356},
  [11608] = {.lex_state = 384},
  [11609] = {.lex_state = 214},
  [11610] = {.lex_state = 214},
  [11611] = {.lex_state = 563},
  [11612] = {.lex_state = 214},
  [11613] = {.lex_state = 214},
  [11614] = {.lex_state = 396, .external_lex_state = 3},
  [11615] = {.lex_state = 356},
  [11616] = {.lex_state = 396, .external_lex_state = 3},
  [11617] = {.lex_state = 563},
  [11618] = {.lex_state = 563},
  [11619] = {.lex_state = 398, .external_lex_state = 3},
  [11620] = {.lex_state = 563},
  [11621] = {.lex_state = 563},
  [11622] = {.lex_state = 563},
  [11623] = {.lex_state = 563},
  [11624] = {.lex_state = 563},
  [11625] = {.lex_state = 547, .external_lex_state = 5},
  [11626] = {.lex_state = 563},
  [11627] = {.lex_state = 563},
  [11628] = {.lex_state = 563},
  [11629] = {.lex_state = 384, .external_lex_state = 5},
  [11630] = {.lex_state = 563},
  [11631] = {.lex_state = 384},
  [11632] = {.lex_state = 563},
  [11633] = {.lex_state = 563},
  [11634] = {.lex_state = 384},
  [11635] = {.lex_state = 396, .external_lex_state = 3},
  [11636] = {.lex_state = 563},
  [11637] = {.lex_state = 563},
  [11638] = {.lex_state = 547, .external_lex_state = 5},
  [11639] = {.lex_state = 563},
  [11640] = {.lex_state = 384},
  [11641] = {.lex_state = 563},
  [11642] = {.lex_state = 563},
  [11643] = {.lex_state = 563},
  [11644] = {.lex_state = 560},
  [11645] = {.lex_state = 547, .external_lex_state = 5},
  [11646] = {.lex_state = 563},
  [11647] = {.lex_state = 547, .external_lex_state = 5},
  [11648] = {.lex_state = 560},
  [11649] = {.lex_state = 547, .external_lex_state = 5},
  [11650] = {.lex_state = 563},
  [11651] = {.lex_state = 547, .external_lex_state = 5},
  [11652] = {.lex_state = 547, .external_lex_state = 5},
  [11653] = {.lex_state = 384},
  [11654] = {.lex_state = 563},
  [11655] = {.lex_state = 563},
  [11656] = {.lex_state = 356},
  [11657] = {.lex_state = 396, .external_lex_state = 3},
  [11658] = {.lex_state = 396, .external_lex_state = 3},
  [11659] = {.lex_state = 563},
  [11660] = {.lex_state = 563},
  [11661] = {.lex_state = 563},
  [11662] = {.lex_state = 563},
  [11663] = {.lex_state = 563},
  [11664] = {.lex_state = 563},
  [11665] = {.lex_state = 356},
  [11666] = {.lex_state = 563},
  [11667] = {.lex_state = 563},
  [11668] = {.lex_state = 563},
  [11669] = {.lex_state = 563},
  [11670] = {.lex_state = 396, .external_lex_state = 3},
  [11671] = {.lex_state = 356},
  [11672] = {.lex_state = 563},
  [11673] = {.lex_state = 563},
  [11674] = {.lex_state = 563},
  [11675] = {.lex_state = 396, .external_lex_state = 3},
  [11676] = {.lex_state = 563},
  [11677] = {.lex_state = 356},
  [11678] = {.lex_state = 384},
  [11679] = {.lex_state = 356},
  [11680] = {.lex_state = 356},
  [11681] = {.lex_state = 563},
  [11682] = {.lex_state = 396, .external_lex_state = 3},
  [11683] = {.lex_state = 356},
  [11684] = {.lex_state = 396, .external_lex_state = 3},
  [11685] = {.lex_state = 396, .external_lex_state = 3},
  [11686] = {.lex_state = 396, .external_lex_state = 3},
  [11687] = {.lex_state = 384},
  [11688] = {.lex_state = 206},
  [11689] = {.lex_state = 356},
  [11690] = {.lex_state = 563},
  [11691] = {.lex_state = 389, .external_lex_state = 3},
  [11692] = {.lex_state = 384},
  [11693] = {.lex_state = 356},
  [11694] = {.lex_state = 547, .external_lex_state = 5},
  [11695] = {.lex_state = 356},
  [11696] = {.lex_state = 547},
  [11697] = {.lex_state = 396, .external_lex_state = 3},
  [11698] = {.lex_state = 356},
  [11699] = {.lex_state = 563},
  [11700] = {.lex_state = 384},
  [11701] = {.lex_state = 384},
  [11702] = {.lex_state = 356},
  [11703] = {.lex_state = 560},
  [11704] = {.lex_state = 560},
  [11705] = {.lex_state = 206},
  [11706] = {.lex_state = 563},
  [11707] = {.lex_state = 206},
  [11708] = {.lex_state = 356},
  [11709] = {.lex_state = 232},
  [11710] = {.lex_state = 232},
  [11711] = {.lex_state = 356},
  [11712] = {.lex_state = 384},
  [11713] = {.lex_state = 400},
  [11714] = {.lex_state = 400},
  [11715] = {.lex_state = 563},
  [11716] = {.lex_state = 563},
  [11717] = {.lex_state = 356},
  [11718] = {.lex_state = 211},
  [11719] = {.lex_state = 211},
  [11720] = {.lex_state = 211},
  [11721] = {.lex_state = 211},
  [11722] = {.lex_state = 563},
  [11723] = {.lex_state = 563},
  [11724] = {.lex_state = 563},
  [11725] = {.lex_state = 232},
  [11726] = {.lex_state = 400},
  [11727] = {.lex_state = 232},
  [11728] = {.lex_state = 356},
  [11729] = {.lex_state = 206},
  [11730] = {.lex_state = 384},
  [11731] = {.lex_state = 547, .external_lex_state = 5},
  [11732] = {.lex_state = 547},
  [11733] = {.lex_state = 384},
  [11734] = {.lex_state = 384},
  [11735] = {.lex_state = 384},
  [11736] = {.lex_state = 384},
  [11737] = {.lex_state = 384},
  [11738] = {.lex_state = 563},
  [11739] = {.lex_state = 356},
  [11740] = {.lex_state = 384},
  [11741] = {.lex_state = 547},
  [11742] = {.lex_state = 547},
  [11743] = {.lex_state = 547},
  [11744] = {.lex_state = 547},
  [11745] = {.lex_state = 563},
  [11746] = {.lex_state = 396, .external_lex_state = 3},
  [11747] = {.lex_state = 356},
  [11748] = {.lex_state = 384},
  [11749] = {.lex_state = 384},
  [11750] = {.lex_state = 547, .external_lex_state = 4},
  [11751] = {.lex_state = 384},
  [11752] = {.lex_state = 396, .external_lex_state = 3},
  [11753] = {.lex_state = 563, .external_lex_state = 4},
  [11754] = {.lex_state = 547},
  [11755] = {.lex_state = 563},
  [11756] = {.lex_state = 384},
  [11757] = {.lex_state = 563},
  [11758] = {.lex_state = 547},
  [11759] = {.lex_state = 563},
  [11760] = {.lex_state = 563},
  [11761] = {.lex_state = 356},
  [11762] = {.lex_state = 356},
  [11763] = {.lex_state = 547},
  [11764] = {.lex_state = 384},
  [11765] = {.lex_state = 384},
  [11766] = {.lex_state = 558},
  [11767] = {.lex_state = 563, .external_lex_state = 4},
  [11768] = {.lex_state = 396, .external_lex_state = 3},
  [11769] = {.lex_state = 396, .external_lex_state = 3},
  [11770] = {.lex_state = 356},
  [11771] = {.lex_state = 384},
  [11772] = {.lex_state = 396, .external_lex_state = 3},
  [11773] = {.lex_state = 384},
  [11774] = {.lex_state = 384},
  [11775] = {.lex_state = 563},
  [11776] = {.lex_state = 384},
  [11777] = {.lex_state = 384},
  [11778] = {.lex_state = 384},
  [11779] = {.lex_state = 563, .external_lex_state = 4},
  [11780] = {.lex_state = 396, .external_lex_state = 3},
  [11781] = {.lex_state = 356},
  [11782] = {.lex_state = 396, .external_lex_state = 3},
  [11783] = {.lex_state = 396, .external_lex_state = 3},
  [11784] = {.lex_state = 356},
  [11785] = {.lex_state = 396, .external_lex_state = 3},
  [11786] = {.lex_state = 396, .external_lex_state = 3},
  [11787] = {.lex_state = 384},
  [11788] = {.lex_state = 396, .external_lex_state = 3},
  [11789] = {.lex_state = 356},
  [11790] = {.lex_state = 384},
  [11791] = {.lex_state = 384},
  [11792] = {.lex_state = 396, .external_lex_state = 3},
  [11793] = {.lex_state = 396, .external_lex_state = 3},
  [11794] = {.lex_state = 188},
  [11795] = {.lex_state = 547},
  [11796] = {.lex_state = 558},
  [11797] = {.lex_state = 396, .external_lex_state = 3},
  [11798] = {.lex_state = 384},
  [11799] = {.lex_state = 384},
  [11800] = {.lex_state = 396, .external_lex_state = 3},
  [11801] = {.lex_state = 384},
  [11802] = {.lex_state = 396, .external_lex_state = 3},
  [11803] = {.lex_state = 384},
  [11804] = {.lex_state = 356},
  [11805] = {.lex_state = 396, .external_lex_state = 3},
  [11806] = {.lex_state = 356},
  [11807] = {.lex_state = 396, .external_lex_state = 3},
  [11808] = {.lex_state = 547, .external_lex_state = 5},
  [11809] = {.lex_state = 396, .external_lex_state = 3},
  [11810] = {.lex_state = 384},
  [11811] = {.lex_state = 396, .external_lex_state = 3},
  [11812] = {.lex_state = 563},
  [11813] = {.lex_state = 384},
  [11814] = {.lex_state = 563},
  [11815] = {.lex_state = 384},
  [11816] = {.lex_state = 384},
  [11817] = {.lex_state = 396, .external_lex_state = 3},
  [11818] = {.lex_state = 396, .external_lex_state = 3},
  [11819] = {.lex_state = 384},
  [11820] = {.lex_state = 396, .external_lex_state = 3},
  [11821] = {.lex_state = 387},
  [11822] = {.lex_state = 387},
  [11823] = {.lex_state = 563},
  [11824] = {.lex_state = 396, .external_lex_state = 3},
  [11825] = {.lex_state = 384},
  [11826] = {.lex_state = 384, .external_lex_state = 5},
  [11827] = {.lex_state = 396, .external_lex_state = 3},
  [11828] = {.lex_state = 387},
  [11829] = {.lex_state = 558},
  [11830] = {.lex_state = 396, .external_lex_state = 3},
  [11831] = {.lex_state = 387},
  [11832] = {.lex_state = 396, .external_lex_state = 3},
  [11833] = {.lex_state = 396, .external_lex_state = 3},
  [11834] = {.lex_state = 384},
  [11835] = {.lex_state = 384},
  [11836] = {.lex_state = 356},
  [11837] = {.lex_state = 545},
  [11838] = {.lex_state = 396, .external_lex_state = 3},
  [11839] = {.lex_state = 547},
  [11840] = {.lex_state = 384, .external_lex_state = 3},
  [11841] = {.lex_state = 384, .external_lex_state = 3},
  [11842] = {.lex_state = 563},
  [11843] = {.lex_state = 384},
  [11844] = {.lex_state = 396, .external_lex_state = 3},
  [11845] = {.lex_state = 547},
  [11846] = {.lex_state = 356},
  [11847] = {.lex_state = 384},
  [11848] = {.lex_state = 384},
  [11849] = {.lex_state = 563, .external_lex_state = 4},
  [11850] = {.lex_state = 384},
  [11851] = {.lex_state = 563},
  [11852] = {.lex_state = 547},
  [11853] = {.lex_state = 396, .external_lex_state = 3},
  [11854] = {.lex_state = 188},
  [11855] = {.lex_state = 547},
  [11856] = {.lex_state = 547},
  [11857] = {.lex_state = 356},
  [11858] = {.lex_state = 547},
  [11859] = {.lex_state = 384},
  [11860] = {.lex_state = 188},
  [11861] = {.lex_state = 547},
  [11862] = {.lex_state = 547},
  [11863] = {.lex_state = 547},
  [11864] = {.lex_state = 384},
  [11865] = {.lex_state = 396, .external_lex_state = 3},
  [11866] = {.lex_state = 188},
  [11867] = {.lex_state = 384},
  [11868] = {.lex_state = 384},
  [11869] = {.lex_state = 396, .external_lex_state = 3},
  [11870] = {.lex_state = 356},
  [11871] = {.lex_state = 384},
  [11872] = {.lex_state = 545},
  [11873] = {.lex_state = 396, .external_lex_state = 3},
  [11874] = {.lex_state = 396, .external_lex_state = 3},
  [11875] = {.lex_state = 384},
  [11876] = {.lex_state = 547, .external_lex_state = 5},
  [11877] = {.lex_state = 396, .external_lex_state = 3},
  [11878] = {.lex_state = 384},
  [11879] = {.lex_state = 356},
  [11880] = {.lex_state = 384},
  [11881] = {.lex_state = 218},
  [11882] = {.lex_state = 547},
  [11883] = {.lex_state = 396, .external_lex_state = 3},
  [11884] = {.lex_state = 558},
  [11885] = {.lex_state = 384},
  [11886] = {.lex_state = 547, .external_lex_state = 5},
  [11887] = {.lex_state = 563},
  [11888] = {.lex_state = 218},
  [11889] = {.lex_state = 356},
  [11890] = {.lex_state = 563},
  [11891] = {.lex_state = 384},
  [11892] = {.lex_state = 547},
  [11893] = {.lex_state = 384},
  [11894] = {.lex_state = 396, .external_lex_state = 3},
  [11895] = {.lex_state = 396, .external_lex_state = 3},
  [11896] = {.lex_state = 396, .external_lex_state = 3},
  [11897] = {.lex_state = 396, .external_lex_state = 3},
  [11898] = {.lex_state = 384},
  [11899] = {.lex_state = 396, .external_lex_state = 3},
  [11900] = {.lex_state = 384},
  [11901] = {.lex_state = 563},
  [11902] = {.lex_state = 563},
  [11903] = {.lex_state = 563},
  [11904] = {.lex_state = 396, .external_lex_state = 3},
  [11905] = {.lex_state = 384},
  [11906] = {.lex_state = 384},
  [11907] = {.lex_state = 384},
  [11908] = {.lex_state = 396, .external_lex_state = 3},
  [11909] = {.lex_state = 356},
  [11910] = {.lex_state = 384},
  [11911] = {.lex_state = 384},
  [11912] = {.lex_state = 563},
  [11913] = {.lex_state = 384},
  [11914] = {.lex_state = 547},
  [11915] = {.lex_state = 396, .external_lex_state = 3},
  [11916] = {.lex_state = 396, .external_lex_state = 3},
  [11917] = {.lex_state = 396, .external_lex_state = 3},
  [11918] = {.lex_state = 384},
  [11919] = {.lex_state = 396, .external_lex_state = 3},
  [11920] = {.lex_state = 356},
  [11921] = {.lex_state = 396, .external_lex_state = 3},
  [11922] = {.lex_state = 396, .external_lex_state = 3},
  [11923] = {.lex_state = 384},
  [11924] = {.lex_state = 384},
  [11925] = {.lex_state = 188},
  [11926] = {.lex_state = 547, .external_lex_state = 4},
  [11927] = {.lex_state = 563},
  [11928] = {.lex_state = 384},
  [11929] = {.lex_state = 545},
  [11930] = {.lex_state = 384},
  [11931] = {.lex_state = 218},
  [11932] = {.lex_state = 384},
  [11933] = {.lex_state = 384},
  [11934] = {.lex_state = 384},
  [11935] = {.lex_state = 396, .external_lex_state = 3},
  [11936] = {.lex_state = 396, .external_lex_state = 3},
  [11937] = {.lex_state = 563},
  [11938] = {.lex_state = 563},
  [11939] = {.lex_state = 545},
  [11940] = {.lex_state = 547, .external_lex_state = 5},
  [11941] = {.lex_state = 384},
  [11942] = {.lex_state = 547, .external_lex_state = 4},
  [11943] = {.lex_state = 384},
  [11944] = {.lex_state = 384},
  [11945] = {.lex_state = 545},
  [11946] = {.lex_state = 384},
  [11947] = {.lex_state = 547, .external_lex_state = 4},
  [11948] = {.lex_state = 384},
  [11949] = {.lex_state = 384},
  [11950] = {.lex_state = 384},
  [11951] = {.lex_state = 356},
  [11952] = {.lex_state = 396, .external_lex_state = 3},
  [11953] = {.lex_state = 384},
  [11954] = {.lex_state = 563},
  [11955] = {.lex_state = 384},
  [11956] = {.lex_state = 384},
  [11957] = {.lex_state = 384},
  [11958] = {.lex_state = 384},
  [11959] = {.lex_state = 396, .external_lex_state = 3},
  [11960] = {.lex_state = 384},
  [11961] = {.lex_state = 396, .external_lex_state = 3},
  [11962] = {.lex_state = 547},
  [11963] = {.lex_state = 356},
  [11964] = {.lex_state = 384},
  [11965] = {.lex_state = 547},
  [11966] = {.lex_state = 547},
  [11967] = {.lex_state = 547},
  [11968] = {.lex_state = 188},
  [11969] = {.lex_state = 384},
  [11970] = {.lex_state = 396, .external_lex_state = 3},
  [11971] = {.lex_state = 384},
  [11972] = {.lex_state = 384},
  [11973] = {.lex_state = 384},
  [11974] = {.lex_state = 218},
  [11975] = {.lex_state = 563},
  [11976] = {.lex_state = 547},
  [11977] = {.lex_state = 384},
  [11978] = {.lex_state = 384},
  [11979] = {.lex_state = 563, .external_lex_state = 4},
  [11980] = {.lex_state = 384},
  [11981] = {.lex_state = 384},
  [11982] = {.lex_state = 384},
  [11983] = {.lex_state = 384},
  [11984] = {.lex_state = 384},
  [11985] = {.lex_state = 547},
  [11986] = {.lex_state = 563},
  [11987] = {.lex_state = 384},
  [11988] = {.lex_state = 547},
  [11989] = {.lex_state = 563, .external_lex_state = 4},
  [11990] = {.lex_state = 384},
  [11991] = {.lex_state = 547},
  [11992] = {.lex_state = 396, .external_lex_state = 3},
  [11993] = {.lex_state = 547},
  [11994] = {.lex_state = 547},
  [11995] = {.lex_state = 547},
  [11996] = {.lex_state = 547},
  [11997] = {.lex_state = 384},
  [11998] = {.lex_state = 356},
  [11999] = {.lex_state = 545},
  [12000] = {.lex_state = 547},
  [12001] = {.lex_state = 547},
  [12002] = {.lex_state = 547},
  [12003] = {.lex_state = 547},
  [12004] = {.lex_state = 384, .external_lex_state = 5},
  [12005] = {.lex_state = 547},
  [12006] = {.lex_state = 547},
  [12007] = {.lex_state = 547},
  [12008] = {.lex_state = 547},
  [12009] = {.lex_state = 396, .external_lex_state = 3},
  [12010] = {.lex_state = 545},
  [12011] = {.lex_state = 547},
  [12012] = {.lex_state = 563},
  [12013] = {.lex_state = 545},
  [12014] = {.lex_state = 389},
  [12015] = {.lex_state = 547},
  [12016] = {.lex_state = 384, .external_lex_state = 4},
  [12017] = {.lex_state = 384},
  [12018] = {.lex_state = 563},
  [12019] = {.lex_state = 389},
  [12020] = {.lex_state = 384},
  [12021] = {.lex_state = 547},
  [12022] = {.lex_state = 547},
  [12023] = {.lex_state = 563},
  [12024] = {.lex_state = 563},
  [12025] = {.lex_state = 547},
  [12026] = {.lex_state = 547},
  [12027] = {.lex_state = 563},
  [12028] = {.lex_state = 563},
  [12029] = {.lex_state = 563},
  [12030] = {.lex_state = 563},
  [12031] = {.lex_state = 384},
  [12032] = {.lex_state = 384},
  [12033] = {.lex_state = 563},
  [12034] = {.lex_state = 384},
  [12035] = {.lex_state = 563},
  [12036] = {.lex_state = 563},
  [12037] = {.lex_state = 389},
  [12038] = {.lex_state = 384},
  [12039] = {.lex_state = 563},
  [12040] = {.lex_state = 545},
  [12041] = {.lex_state = 389},
  [12042] = {.lex_state = 547, .external_lex_state = 4},
  [12043] = {.lex_state = 563},
  [12044] = {.lex_state = 563},
  [12045] = {.lex_state = 563},
  [12046] = {.lex_state = 563},
  [12047] = {.lex_state = 545},
  [12048] = {.lex_state = 563},
  [12049] = {.lex_state = 384},
  [12050] = {.lex_state = 547},
  [12051] = {.lex_state = 384},
  [12052] = {.lex_state = 384},
  [12053] = {.lex_state = 384},
  [12054] = {.lex_state = 384},
  [12055] = {.lex_state = 563},
  [12056] = {.lex_state = 563},
  [12057] = {.lex_state = 563},
  [12058] = {.lex_state = 563},
  [12059] = {.lex_state = 384},
  [12060] = {.lex_state = 547},
  [12061] = {.lex_state = 547},
  [12062] = {.lex_state = 563},
  [12063] = {.lex_state = 547},
  [12064] = {.lex_state = 563},
  [12065] = {.lex_state = 389},
  [12066] = {.lex_state = 563},
  [12067] = {.lex_state = 563},
  [12068] = {.lex_state = 547},
  [12069] = {.lex_state = 384},
  [12070] = {.lex_state = 547},
  [12071] = {.lex_state = 384},
  [12072] = {.lex_state = 547},
  [12073] = {.lex_state = 384},
  [12074] = {.lex_state = 547},
  [12075] = {.lex_state = 547, .external_lex_state = 4},
  [12076] = {.lex_state = 547, .external_lex_state = 4},
  [12077] = {.lex_state = 384},
  [12078] = {.lex_state = 563},
  [12079] = {.lex_state = 563},
  [12080] = {.lex_state = 389},
  [12081] = {.lex_state = 563},
  [12082] = {.lex_state = 563},
  [12083] = {.lex_state = 563},
  [12084] = {.lex_state = 547},
  [12085] = {.lex_state = 384},
  [12086] = {.lex_state = 384},
  [12087] = {.lex_state = 384},
  [12088] = {.lex_state = 384},
  [12089] = {.lex_state = 563},
  [12090] = {.lex_state = 545},
  [12091] = {.lex_state = 384},
  [12092] = {.lex_state = 384},
  [12093] = {.lex_state = 384},
  [12094] = {.lex_state = 563},
  [12095] = {.lex_state = 384},
  [12096] = {.lex_state = 547},
  [12097] = {.lex_state = 563},
  [12098] = {.lex_state = 547},
  [12099] = {.lex_state = 547},
  [12100] = {.lex_state = 547},
  [12101] = {.lex_state = 547},
  [12102] = {.lex_state = 547},
  [12103] = {.lex_state = 547},
  [12104] = {.lex_state = 547},
  [12105] = {.lex_state = 547},
  [12106] = {.lex_state = 547},
  [12107] = {.lex_state = 547},
  [12108] = {.lex_state = 547},
  [12109] = {.lex_state = 547},
  [12110] = {.lex_state = 384},
  [12111] = {.lex_state = 384},
  [12112] = {.lex_state = 384},
  [12113] = {.lex_state = 384},
  [12114] = {.lex_state = 384},
  [12115] = {.lex_state = 384},
  [12116] = {.lex_state = 384},
  [12117] = {.lex_state = 384},
  [12118] = {.lex_state = 384},
  [12119] = {.lex_state = 384},
  [12120] = {.lex_state = 563},
  [12121] = {.lex_state = 384},
  [12122] = {.lex_state = 384},
  [12123] = {.lex_state = 389},
  [12124] = {.lex_state = 384},
  [12125] = {.lex_state = 563},
  [12126] = {.lex_state = 384},
  [12127] = {.lex_state = 563},
  [12128] = {.lex_state = 384},
  [12129] = {.lex_state = 563},
  [12130] = {.lex_state = 563},
  [12131] = {.lex_state = 563},
  [12132] = {.lex_state = 545},
  [12133] = {.lex_state = 384},
  [12134] = {.lex_state = 563},
  [12135] = {.lex_state = 563},
  [12136] = {.lex_state = 389},
  [12137] = {.lex_state = 563},
  [12138] = {.lex_state = 384},
  [12139] = {.lex_state = 384},
  [12140] = {.lex_state = 545},
  [12141] = {.lex_state = 384},
  [12142] = {.lex_state = 563},
  [12143] = {.lex_state = 563},
  [12144] = {.lex_state = 547, .external_lex_state = 4},
  [12145] = {.lex_state = 563},
  [12146] = {.lex_state = 563},
  [12147] = {.lex_state = 563},
  [12148] = {.lex_state = 563},
  [12149] = {.lex_state = 563},
  [12150] = {.lex_state = 547},
  [12151] = {.lex_state = 563},
  [12152] = {.lex_state = 563},
  [12153] = {.lex_state = 545},
  [12154] = {.lex_state = 563},
  [12155] = {.lex_state = 563},
  [12156] = {.lex_state = 563},
  [12157] = {.lex_state = 563},
  [12158] = {.lex_state = 545},
  [12159] = {.lex_state = 547, .external_lex_state = 4},
  [12160] = {.lex_state = 384},
  [12161] = {.lex_state = 384},
  [12162] = {.lex_state = 384},
  [12163] = {.lex_state = 384},
  [12164] = {.lex_state = 547},
  [12165] = {.lex_state = 384},
  [12166] = {.lex_state = 563},
  [12167] = {.lex_state = 545},
  [12168] = {.lex_state = 384},
  [12169] = {.lex_state = 384},
  [12170] = {.lex_state = 384},
  [12171] = {.lex_state = 563},
  [12172] = {.lex_state = 384},
  [12173] = {.lex_state = 563},
  [12174] = {.lex_state = 384},
  [12175] = {.lex_state = 389},
  [12176] = {.lex_state = 563},
  [12177] = {.lex_state = 384},
  [12178] = {.lex_state = 563},
  [12179] = {.lex_state = 563},
  [12180] = {.lex_state = 384},
  [12181] = {.lex_state = 563},
  [12182] = {.lex_state = 563},
  [12183] = {.lex_state = 545},
  [12184] = {.lex_state = 384, .external_lex_state = 5},
  [12185] = {.lex_state = 389},
  [12186] = {.lex_state = 384},
  [12187] = {.lex_state = 384},
  [12188] = {.lex_state = 384},
  [12189] = {.lex_state = 563},
  [12190] = {.lex_state = 563},
  [12191] = {.lex_state = 563},
  [12192] = {.lex_state = 563},
  [12193] = {.lex_state = 545},
  [12194] = {.lex_state = 563},
  [12195] = {.lex_state = 563},
  [12196] = {.lex_state = 563},
  [12197] = {.lex_state = 563},
  [12198] = {.lex_state = 563},
  [12199] = {.lex_state = 384, .external_lex_state = 5},
  [12200] = {.lex_state = 547},
  [12201] = {.lex_state = 384},
  [12202] = {.lex_state = 384},
  [12203] = {.lex_state = 563},
  [12204] = {.lex_state = 563},
  [12205] = {.lex_state = 563},
  [12206] = {.lex_state = 563},
  [12207] = {.lex_state = 563},
  [12208] = {.lex_state = 547},
  [12209] = {.lex_state = 384},
  [12210] = {.lex_state = 545},
  [12211] = {.lex_state = 384},
  [12212] = {.lex_state = 563},
  [12213] = {.lex_state = 547, .external_lex_state = 4},
  [12214] = {.lex_state = 547},
  [12215] = {.lex_state = 563},
  [12216] = {.lex_state = 384},
  [12217] = {.lex_state = 563},
  [12218] = {.lex_state = 384, .external_lex_state = 4},
  [12219] = {.lex_state = 547},
  [12220] = {.lex_state = 547},
  [12221] = {.lex_state = 563},
  [12222] = {.lex_state = 545},
  [12223] = {.lex_state = 384},
  [12224] = {.lex_state = 547},
  [12225] = {.lex_state = 563},
  [12226] = {.lex_state = 563},
  [12227] = {.lex_state = 384},
  [12228] = {.lex_state = 384},
  [12229] = {.lex_state = 384},
  [12230] = {.lex_state = 384},
  [12231] = {.lex_state = 384},
  [12232] = {.lex_state = 547},
  [12233] = {.lex_state = 384},
  [12234] = {.lex_state = 384, .external_lex_state = 4},
  [12235] = {.lex_state = 547},
  [12236] = {.lex_state = 389},
  [12237] = {.lex_state = 563},
  [12238] = {.lex_state = 563},
  [12239] = {.lex_state = 384},
  [12240] = {.lex_state = 384},
  [12241] = {.lex_state = 563},
  [12242] = {.lex_state = 384, .external_lex_state = 4},
  [12243] = {.lex_state = 563},
  [12244] = {.lex_state = 563},
  [12245] = {.lex_state = 389},
  [12246] = {.lex_state = 384, .external_lex_state = 4},
  [12247] = {.lex_state = 389},
  [12248] = {.lex_state = 384, .external_lex_state = 4},
  [12249] = {.lex_state = 389},
  [12250] = {.lex_state = 384},
  [12251] = {.lex_state = 545},
  [12252] = {.lex_state = 384},
  [12253] = {.lex_state = 384},
  [12254] = {.lex_state = 384},
  [12255] = {.lex_state = 384},
  [12256] = {.lex_state = 563},
  [12257] = {.lex_state = 563},
  [12258] = {.lex_state = 563},
  [12259] = {.lex_state = 547},
  [12260] = {.lex_state = 547},
  [12261] = {.lex_state = 384},
  [12262] = {.lex_state = 563},
  [12263] = {.lex_state = 563},
  [12264] = {.lex_state = 384},
  [12265] = {.lex_state = 547},
  [12266] = {.lex_state = 545},
  [12267] = {.lex_state = 563},
  [12268] = {.lex_state = 545},
  [12269] = {.lex_state = 547, .external_lex_state = 4},
  [12270] = {.lex_state = 563},
  [12271] = {.lex_state = 547},
  [12272] = {.lex_state = 563},
  [12273] = {.lex_state = 547},
  [12274] = {.lex_state = 547},
  [12275] = {.lex_state = 547},
  [12276] = {.lex_state = 563},
  [12277] = {.lex_state = 384},
  [12278] = {.lex_state = 384},
  [12279] = {.lex_state = 547},
  [12280] = {.lex_state = 547},
  [12281] = {.lex_state = 547},
  [12282] = {.lex_state = 414},
  [12283] = {.lex_state = 547},
  [12284] = {.lex_state = 547},
  [12285] = {.lex_state = 547},
  [12286] = {.lex_state = 563},
  [12287] = {.lex_state = 414},
  [12288] = {.lex_state = 414},
  [12289] = {.lex_state = 384},
  [12290] = {.lex_state = 384},
  [12291] = {.lex_state = 384},
  [12292] = {.lex_state = 389},
  [12293] = {.lex_state = 563},
  [12294] = {.lex_state = 547},
  [12295] = {.lex_state = 547},
  [12296] = {.lex_state = 384},
  [12297] = {.lex_state = 384},
  [12298] = {.lex_state = 563},
  [12299] = {.lex_state = 384},
  [12300] = {.lex_state = 547},
  [12301] = {.lex_state = 547},
  [12302] = {.lex_state = 547},
  [12303] = {.lex_state = 547},
  [12304] = {.lex_state = 547},
  [12305] = {.lex_state = 547},
  [12306] = {.lex_state = 547},
  [12307] = {.lex_state = 547},
  [12308] = {.lex_state = 547},
  [12309] = {.lex_state = 547},
  [12310] = {.lex_state = 547},
  [12311] = {.lex_state = 547},
  [12312] = {.lex_state = 563},
  [12313] = {.lex_state = 547},
  [12314] = {.lex_state = 547},
  [12315] = {.lex_state = 547},
  [12316] = {.lex_state = 414},
  [12317] = {.lex_state = 547},
  [12318] = {.lex_state = 547},
  [12319] = {.lex_state = 547},
  [12320] = {.lex_state = 547},
  [12321] = {.lex_state = 384},
  [12322] = {.lex_state = 547, .external_lex_state = 4},
  [12323] = {.lex_state = 547},
  [12324] = {.lex_state = 384},
  [12325] = {.lex_state = 384},
  [12326] = {.lex_state = 384},
  [12327] = {.lex_state = 384},
  [12328] = {.lex_state = 384},
  [12329] = {.lex_state = 384},
  [12330] = {.lex_state = 545},
  [12331] = {.lex_state = 384},
  [12332] = {.lex_state = 547},
  [12333] = {.lex_state = 384},
  [12334] = {.lex_state = 188},
  [12335] = {.lex_state = 547},
  [12336] = {.lex_state = 563},
  [12337] = {.lex_state = 563},
  [12338] = {.lex_state = 563},
  [12339] = {.lex_state = 384},
  [12340] = {.lex_state = 547},
  [12341] = {.lex_state = 563},
  [12342] = {.lex_state = 384},
  [12343] = {.lex_state = 384},
  [12344] = {.lex_state = 547},
  [12345] = {.lex_state = 384},
  [12346] = {.lex_state = 384},
  [12347] = {.lex_state = 563},
  [12348] = {.lex_state = 545},
  [12349] = {.lex_state = 547},
  [12350] = {.lex_state = 547},
  [12351] = {.lex_state = 547},
  [12352] = {.lex_state = 547},
  [12353] = {.lex_state = 547},
  [12354] = {.lex_state = 384},
  [12355] = {.lex_state = 563},
  [12356] = {.lex_state = 547},
  [12357] = {.lex_state = 547},
  [12358] = {.lex_state = 384},
  [12359] = {.lex_state = 547},
  [12360] = {.lex_state = 547},
  [12361] = {.lex_state = 547},
  [12362] = {.lex_state = 547},
  [12363] = {.lex_state = 547},
  [12364] = {.lex_state = 547},
  [12365] = {.lex_state = 547},
  [12366] = {.lex_state = 547},
  [12367] = {.lex_state = 547},
  [12368] = {.lex_state = 547},
  [12369] = {.lex_state = 547},
  [12370] = {.lex_state = 547},
  [12371] = {.lex_state = 547},
  [12372] = {.lex_state = 547},
  [12373] = {.lex_state = 547, .external_lex_state = 4},
  [12374] = {.lex_state = 547},
  [12375] = {.lex_state = 547},
  [12376] = {.lex_state = 547},
  [12377] = {.lex_state = 547},
  [12378] = {.lex_state = 547},
  [12379] = {.lex_state = 384},
  [12380] = {.lex_state = 547},
  [12381] = {.lex_state = 384},
  [12382] = {.lex_state = 384},
  [12383] = {.lex_state = 547},
  [12384] = {.lex_state = 545},
  [12385] = {.lex_state = 547},
  [12386] = {.lex_state = 547},
  [12387] = {.lex_state = 547},
  [12388] = {.lex_state = 547},
  [12389] = {.lex_state = 547},
  [12390] = {.lex_state = 547},
  [12391] = {.lex_state = 547},
  [12392] = {.lex_state = 389},
  [12393] = {.lex_state = 384},
  [12394] = {.lex_state = 384},
  [12395] = {.lex_state = 547},
  [12396] = {.lex_state = 384},
  [12397] = {.lex_state = 547},
  [12398] = {.lex_state = 545},
  [12399] = {.lex_state = 547},
  [12400] = {.lex_state = 547},
  [12401] = {.lex_state = 545},
  [12402] = {.lex_state = 547},
  [12403] = {.lex_state = 384},
  [12404] = {.lex_state = 547},
  [12405] = {.lex_state = 547},
  [12406] = {.lex_state = 389},
  [12407] = {.lex_state = 384, .external_lex_state = 4},
  [12408] = {.lex_state = 547},
  [12409] = {.lex_state = 384},
  [12410] = {.lex_state = 384},
  [12411] = {.lex_state = 547},
  [12412] = {.lex_state = 384},
  [12413] = {.lex_state = 384},
  [12414] = {.lex_state = 547},
  [12415] = {.lex_state = 547},
  [12416] = {.lex_state = 547},
  [12417] = {.lex_state = 384},
  [12418] = {.lex_state = 547},
  [12419] = {.lex_state = 547},
  [12420] = {.lex_state = 384},
  [12421] = {.lex_state = 389},
  [12422] = {.lex_state = 384},
  [12423] = {.lex_state = 384},
  [12424] = {.lex_state = 547, .external_lex_state = 4},
  [12425] = {.lex_state = 384},
  [12426] = {.lex_state = 389},
  [12427] = {.lex_state = 389},
  [12428] = {.lex_state = 384},
  [12429] = {.lex_state = 547},
  [12430] = {.lex_state = 545},
  [12431] = {.lex_state = 547},
  [12432] = {.lex_state = 547},
  [12433] = {.lex_state = 563},
  [12434] = {.lex_state = 547},
  [12435] = {.lex_state = 547},
  [12436] = {.lex_state = 547},
  [12437] = {.lex_state = 384},
  [12438] = {.lex_state = 384},
  [12439] = {.lex_state = 547},
  [12440] = {.lex_state = 547},
  [12441] = {.lex_state = 389},
  [12442] = {.lex_state = 389},
  [12443] = {.lex_state = 547},
  [12444] = {.lex_state = 547},
  [12445] = {.lex_state = 389},
  [12446] = {.lex_state = 384},
  [12447] = {.lex_state = 547},
  [12448] = {.lex_state = 547},
  [12449] = {.lex_state = 547},
  [12450] = {.lex_state = 384},
  [12451] = {.lex_state = 384},
  [12452] = {.lex_state = 384},
  [12453] = {.lex_state = 547},
  [12454] = {.lex_state = 384},
  [12455] = {.lex_state = 547},
  [12456] = {.lex_state = 547},
  [12457] = {.lex_state = 547},
  [12458] = {.lex_state = 547},
  [12459] = {.lex_state = 547},
  [12460] = {.lex_state = 547},
  [12461] = {.lex_state = 547},
  [12462] = {.lex_state = 547, .external_lex_state = 4},
  [12463] = {.lex_state = 547},
  [12464] = {.lex_state = 547},
  [12465] = {.lex_state = 547, .external_lex_state = 4},
  [12466] = {.lex_state = 547},
  [12467] = {.lex_state = 547},
  [12468] = {.lex_state = 547},
  [12469] = {.lex_state = 384},
  [12470] = {.lex_state = 384},
  [12471] = {.lex_state = 384},
  [12472] = {.lex_state = 547},
  [12473] = {.lex_state = 389},
  [12474] = {.lex_state = 547},
  [12475] = {.lex_state = 384},
  [12476] = {.lex_state = 384},
  [12477] = {.lex_state = 547},
  [12478] = {.lex_state = 389},
  [12479] = {.lex_state = 394},
  [12480] = {.lex_state = 547},
  [12481] = {.lex_state = 547},
  [12482] = {.lex_state = 547},
  [12483] = {.lex_state = 547},
  [12484] = {.lex_state = 384},
  [12485] = {.lex_state = 547},
  [12486] = {.lex_state = 547},
  [12487] = {.lex_state = 384},
  [12488] = {.lex_state = 394},
  [12489] = {.lex_state = 547},
  [12490] = {.lex_state = 384, .external_lex_state = 4},
  [12491] = {.lex_state = 384},
  [12492] = {.lex_state = 384},
  [12493] = {.lex_state = 394},
  [12494] = {.lex_state = 547},
  [12495] = {.lex_state = 389},
  [12496] = {.lex_state = 389},
  [12497] = {.lex_state = 384},
  [12498] = {.lex_state = 389},
  [12499] = {.lex_state = 547},
  [12500] = {.lex_state = 547},
  [12501] = {.lex_state = 547},
  [12502] = {.lex_state = 394},
  [12503] = {.lex_state = 545},
  [12504] = {.lex_state = 547},
  [12505] = {.lex_state = 547},
  [12506] = {.lex_state = 547},
  [12507] = {.lex_state = 384},
  [12508] = {.lex_state = 384, .external_lex_state = 4},
  [12509] = {.lex_state = 547},
  [12510] = {.lex_state = 547},
  [12511] = {.lex_state = 384},
  [12512] = {.lex_state = 389},
  [12513] = {.lex_state = 563},
  [12514] = {.lex_state = 545},
  [12515] = {.lex_state = 547},
  [12516] = {.lex_state = 384},
  [12517] = {.lex_state = 384},
  [12518] = {.lex_state = 547},
  [12519] = {.lex_state = 545},
  [12520] = {.lex_state = 547},
  [12521] = {.lex_state = 547},
  [12522] = {.lex_state = 547},
  [12523] = {.lex_state = 384},
  [12524] = {.lex_state = 547},
  [12525] = {.lex_state = 547},
  [12526] = {.lex_state = 547},
  [12527] = {.lex_state = 545},
  [12528] = {.lex_state = 547},
  [12529] = {.lex_state = 547},
  [12530] = {.lex_state = 563},
  [12531] = {.lex_state = 384},
  [12532] = {.lex_state = 547},
  [12533] = {.lex_state = 547},
  [12534] = {.lex_state = 547},
  [12535] = {.lex_state = 545},
  [12536] = {.lex_state = 547, .external_lex_state = 4},
  [12537] = {.lex_state = 384},
  [12538] = {.lex_state = 547},
  [12539] = {.lex_state = 547},
  [12540] = {.lex_state = 547},
  [12541] = {.lex_state = 547},
  [12542] = {.lex_state = 547},
  [12543] = {.lex_state = 547},
  [12544] = {.lex_state = 547},
  [12545] = {.lex_state = 547},
  [12546] = {.lex_state = 547},
  [12547] = {.lex_state = 547},
  [12548] = {.lex_state = 545},
  [12549] = {.lex_state = 547},
  [12550] = {.lex_state = 547},
  [12551] = {.lex_state = 547, .external_lex_state = 4},
  [12552] = {.lex_state = 547},
  [12553] = {.lex_state = 547},
  [12554] = {.lex_state = 389},
  [12555] = {.lex_state = 384, .external_lex_state = 4},
  [12556] = {.lex_state = 547},
  [12557] = {.lex_state = 547},
  [12558] = {.lex_state = 547},
  [12559] = {.lex_state = 547},
  [12560] = {.lex_state = 384},
  [12561] = {.lex_state = 547},
  [12562] = {.lex_state = 384},
  [12563] = {.lex_state = 547},
  [12564] = {.lex_state = 384},
  [12565] = {.lex_state = 389},
  [12566] = {.lex_state = 384},
  [12567] = {.lex_state = 545},
  [12568] = {.lex_state = 547},
  [12569] = {.lex_state = 547},
  [12570] = {.lex_state = 545},
  [12571] = {.lex_state = 547, .external_lex_state = 4},
  [12572] = {.lex_state = 547},
  [12573] = {.lex_state = 547},
  [12574] = {.lex_state = 384},
  [12575] = {.lex_state = 547},
  [12576] = {.lex_state = 547},
  [12577] = {.lex_state = 384},
  [12578] = {.lex_state = 384},
  [12579] = {.lex_state = 547},
  [12580] = {.lex_state = 547},
  [12581] = {.lex_state = 384},
  [12582] = {.lex_state = 389},
  [12583] = {.lex_state = 545},
  [12584] = {.lex_state = 384, .external_lex_state = 4},
  [12585] = {.lex_state = 547},
  [12586] = {.lex_state = 547},
  [12587] = {.lex_state = 547},
  [12588] = {.lex_state = 384},
  [12589] = {.lex_state = 547},
  [12590] = {.lex_state = 384},
  [12591] = {.lex_state = 547},
  [12592] = {.lex_state = 547},
  [12593] = {.lex_state = 547},
  [12594] = {.lex_state = 389},
  [12595] = {.lex_state = 547},
  [12596] = {.lex_state = 547},
  [12597] = {.lex_state = 547},
  [12598] = {.lex_state = 547},
  [12599] = {.lex_state = 384},
  [12600] = {.lex_state = 547},
  [12601] = {.lex_state = 547},
  [12602] = {.lex_state = 547},
  [12603] = {.lex_state = 384},
  [12604] = {.lex_state = 384},
  [12605] = {.lex_state = 384},
  [12606] = {.lex_state = 547},
  [12607] = {.lex_state = 384},
  [12608] = {.lex_state = 547},
  [12609] = {.lex_state = 384},
  [12610] = {.lex_state = 384},
  [12611] = {.lex_state = 384},
  [12612] = {.lex_state = 384},
  [12613] = {.lex_state = 384},
  [12614] = {.lex_state = 384},
  [12615] = {.lex_state = 384},
  [12616] = {.lex_state = 547},
  [12617] = {.lex_state = 547},
  [12618] = {.lex_state = 547},
  [12619] = {.lex_state = 547},
  [12620] = {.lex_state = 547},
  [12621] = {.lex_state = 563},
  [12622] = {.lex_state = 547},
  [12623] = {.lex_state = 384, .external_lex_state = 5},
  [12624] = {.lex_state = 547},
  [12625] = {.lex_state = 547},
  [12626] = {.lex_state = 547},
  [12627] = {.lex_state = 547},
  [12628] = {.lex_state = 563},
  [12629] = {.lex_state = 563},
  [12630] = {.lex_state = 563},
  [12631] = {.lex_state = 547},
  [12632] = {.lex_state = 563},
  [12633] = {.lex_state = 389},
  [12634] = {.lex_state = 384},
  [12635] = {.lex_state = 384},
  [12636] = {.lex_state = 384},
  [12637] = {.lex_state = 547},
  [12638] = {.lex_state = 563},
  [12639] = {.lex_state = 547},
  [12640] = {.lex_state = 384},
  [12641] = {.lex_state = 384, .external_lex_state = 4},
  [12642] = {.lex_state = 547},
  [12643] = {.lex_state = 384},
  [12644] = {.lex_state = 384},
  [12645] = {.lex_state = 384},
  [12646] = {.lex_state = 384},
  [12647] = {.lex_state = 384},
  [12648] = {.lex_state = 384},
  [12649] = {.lex_state = 389},
  [12650] = {.lex_state = 547},
  [12651] = {.lex_state = 547},
  [12652] = {.lex_state = 545},
  [12653] = {.lex_state = 384},
  [12654] = {.lex_state = 384},
  [12655] = {.lex_state = 384},
  [12656] = {.lex_state = 384},
  [12657] = {.lex_state = 384},
  [12658] = {.lex_state = 384},
  [12659] = {.lex_state = 384},
  [12660] = {.lex_state = 384},
  [12661] = {.lex_state = 384},
  [12662] = {.lex_state = 384},
  [12663] = {.lex_state = 384},
  [12664] = {.lex_state = 384},
  [12665] = {.lex_state = 384},
  [12666] = {.lex_state = 384},
  [12667] = {.lex_state = 384},
  [12668] = {.lex_state = 384},
  [12669] = {.lex_state = 389},
  [12670] = {.lex_state = 389},
  [12671] = {.lex_state = 384, .external_lex_state = 5},
  [12672] = {.lex_state = 384},
  [12673] = {.lex_state = 384},
  [12674] = {.lex_state = 384},
  [12675] = {.lex_state = 384},
  [12676] = {.lex_state = 384},
  [12677] = {.lex_state = 384},
  [12678] = {.lex_state = 384},
  [12679] = {.lex_state = 547},
  [12680] = {.lex_state = 384},
  [12681] = {.lex_state = 384, .external_lex_state = 4},
  [12682] = {.lex_state = 547},
  [12683] = {.lex_state = 547},
  [12684] = {.lex_state = 547},
  [12685] = {.lex_state = 547},
  [12686] = {.lex_state = 547},
  [12687] = {.lex_state = 384},
  [12688] = {.lex_state = 384},
  [12689] = {.lex_state = 384},
  [12690] = {.lex_state = 384},
  [12691] = {.lex_state = 384},
  [12692] = {.lex_state = 384},
  [12693] = {.lex_state = 384},
  [12694] = {.lex_state = 384},
  [12695] = {.lex_state = 547},
  [12696] = {.lex_state = 547},
  [12697] = {.lex_state = 389},
  [12698] = {.lex_state = 384},
  [12699] = {.lex_state = 384},
  [12700] = {.lex_state = 384},
  [12701] = {.lex_state = 384},
  [12702] = {.lex_state = 384},
  [12703] = {.lex_state = 384},
  [12704] = {.lex_state = 384},
  [12705] = {.lex_state = 384},
  [12706] = {.lex_state = 384},
  [12707] = {.lex_state = 384},
  [12708] = {.lex_state = 384},
  [12709] = {.lex_state = 563},
  [12710] = {.lex_state = 547},
  [12711] = {.lex_state = 547},
  [12712] = {.lex_state = 384, .external_lex_state = 4},
  [12713] = {.lex_state = 563},
  [12714] = {.lex_state = 563},
  [12715] = {.lex_state = 545},
  [12716] = {.lex_state = 384},
  [12717] = {.lex_state = 384},
  [12718] = {.lex_state = 384},
  [12719] = {.lex_state = 384},
  [12720] = {.lex_state = 384},
  [12721] = {.lex_state = 547},
  [12722] = {.lex_state = 547},
  [12723] = {.lex_state = 547},
  [12724] = {.lex_state = 384},
  [12725] = {.lex_state = 384},
  [12726] = {.lex_state = 384},
  [12727] = {.lex_state = 384},
  [12728] = {.lex_state = 384},
  [12729] = {.lex_state = 384},
  [12730] = {.lex_state = 384},
  [12731] = {.lex_state = 547},
  [12732] = {.lex_state = 547},
  [12733] = {.lex_state = 384},
  [12734] = {.lex_state = 384},
  [12735] = {.lex_state = 547},
  [12736] = {.lex_state = 384},
  [12737] = {.lex_state = 384},
  [12738] = {.lex_state = 384},
  [12739] = {.lex_state = 389},
  [12740] = {.lex_state = 547},
  [12741] = {.lex_state = 547},
  [12742] = {.lex_state = 547},
  [12743] = {.lex_state = 384, .external_lex_state = 4},
  [12744] = {.lex_state = 547},
  [12745] = {.lex_state = 384},
  [12746] = {.lex_state = 563},
  [12747] = {.lex_state = 547},
  [12748] = {.lex_state = 547},
  [12749] = {.lex_state = 384},
  [12750] = {.lex_state = 547},
  [12751] = {.lex_state = 563},
  [12752] = {.lex_state = 547},
  [12753] = {.lex_state = 563},
  [12754] = {.lex_state = 563},
  [12755] = {.lex_state = 563},
  [12756] = {.lex_state = 547},
  [12757] = {.lex_state = 384},
  [12758] = {.lex_state = 547},
  [12759] = {.lex_state = 563},
  [12760] = {.lex_state = 547},
  [12761] = {.lex_state = 547},
  [12762] = {.lex_state = 389},
  [12763] = {.lex_state = 547},
  [12764] = {.lex_state = 545},
  [12765] = {.lex_state = 384},
  [12766] = {.lex_state = 547},
  [12767] = {.lex_state = 384},
  [12768] = {.lex_state = 547},
  [12769] = {.lex_state = 389},
  [12770] = {.lex_state = 545},
  [12771] = {.lex_state = 547},
  [12772] = {.lex_state = 547},
  [12773] = {.lex_state = 547},
  [12774] = {.lex_state = 384},
  [12775] = {.lex_state = 545},
  [12776] = {.lex_state = 384},
  [12777] = {.lex_state = 389},
  [12778] = {.lex_state = 547},
  [12779] = {.lex_state = 384},
  [12780] = {.lex_state = 384},
  [12781] = {.lex_state = 384},
  [12782] = {.lex_state = 547},
  [12783] = {.lex_state = 547},
  [12784] = {.lex_state = 547},
  [12785] = {.lex_state = 547},
  [12786] = {.lex_state = 547},
  [12787] = {.lex_state = 547},
  [12788] = {.lex_state = 547},
  [12789] = {.lex_state = 547},
  [12790] = {.lex_state = 547},
  [12791] = {.lex_state = 547},
  [12792] = {.lex_state = 547},
  [12793] = {.lex_state = 547},
  [12794] = {.lex_state = 547},
  [12795] = {.lex_state = 384},
  [12796] = {.lex_state = 384},
  [12797] = {.lex_state = 384},
  [12798] = {.lex_state = 384},
  [12799] = {.lex_state = 384},
  [12800] = {.lex_state = 384},
  [12801] = {.lex_state = 384},
  [12802] = {.lex_state = 384},
  [12803] = {.lex_state = 384},
  [12804] = {.lex_state = 547},
  [12805] = {.lex_state = 384, .external_lex_state = 4},
  [12806] = {.lex_state = 547},
  [12807] = {.lex_state = 384},
  [12808] = {.lex_state = 384},
  [12809] = {.lex_state = 389},
  [12810] = {.lex_state = 384},
  [12811] = {.lex_state = 547},
  [12812] = {.lex_state = 384},
  [12813] = {.lex_state = 547},
  [12814] = {.lex_state = 547},
  [12815] = {.lex_state = 547},
  [12816] = {.lex_state = 547},
  [12817] = {.lex_state = 384},
  [12818] = {.lex_state = 547},
  [12819] = {.lex_state = 547},
  [12820] = {.lex_state = 547},
  [12821] = {.lex_state = 547},
  [12822] = {.lex_state = 547},
  [12823] = {.lex_state = 547},
  [12824] = {.lex_state = 547},
  [12825] = {.lex_state = 547},
  [12826] = {.lex_state = 547},
  [12827] = {.lex_state = 547},
  [12828] = {.lex_state = 547},
  [12829] = {.lex_state = 547},
  [12830] = {.lex_state = 384},
  [12831] = {.lex_state = 547},
  [12832] = {.lex_state = 389},
  [12833] = {.lex_state = 384},
  [12834] = {.lex_state = 384},
  [12835] = {.lex_state = 384},
  [12836] = {.lex_state = 384},
  [12837] = {.lex_state = 384},
  [12838] = {.lex_state = 384},
  [12839] = {.lex_state = 384},
  [12840] = {.lex_state = 384},
  [12841] = {.lex_state = 384},
  [12842] = {.lex_state = 384},
  [12843] = {.lex_state = 547},
  [12844] = {.lex_state = 547},
  [12845] = {.lex_state = 547},
  [12846] = {.lex_state = 547},
  [12847] = {.lex_state = 547},
  [12848] = {.lex_state = 547},
  [12849] = {.lex_state = 547},
  [12850] = {.lex_state = 547},
  [12851] = {.lex_state = 547},
  [12852] = {.lex_state = 547},
  [12853] = {.lex_state = 547},
  [12854] = {.lex_state = 547},
  [12855] = {.lex_state = 547},
  [12856] = {.lex_state = 547},
  [12857] = {.lex_state = 547},
  [12858] = {.lex_state = 547},
  [12859] = {.lex_state = 547},
  [12860] = {.lex_state = 547},
  [12861] = {.lex_state = 547},
  [12862] = {.lex_state = 547},
  [12863] = {.lex_state = 547},
  [12864] = {.lex_state = 547},
  [12865] = {.lex_state = 384},
  [12866] = {.lex_state = 547},
  [12867] = {.lex_state = 547},
  [12868] = {.lex_state = 547},
  [12869] = {.lex_state = 547},
  [12870] = {.lex_state = 547},
  [12871] = {.lex_state = 547},
  [12872] = {.lex_state = 547},
  [12873] = {.lex_state = 547},
  [12874] = {.lex_state = 547},
  [12875] = {.lex_state = 547},
  [12876] = {.lex_state = 547},
  [12877] = {.lex_state = 547},
  [12878] = {.lex_state = 547},
  [12879] = {.lex_state = 547},
  [12880] = {.lex_state = 547},
  [12881] = {.lex_state = 547},
  [12882] = {.lex_state = 547},
  [12883] = {.lex_state = 547},
  [12884] = {.lex_state = 384},
  [12885] = {.lex_state = 389},
  [12886] = {.lex_state = 384},
  [12887] = {.lex_state = 547},
  [12888] = {.lex_state = 547},
  [12889] = {.lex_state = 547},
  [12890] = {.lex_state = 547},
  [12891] = {.lex_state = 547},
  [12892] = {.lex_state = 547},
  [12893] = {.lex_state = 547},
  [12894] = {.lex_state = 547},
  [12895] = {.lex_state = 547},
  [12896] = {.lex_state = 547},
  [12897] = {.lex_state = 547},
  [12898] = {.lex_state = 547},
  [12899] = {.lex_state = 547},
  [12900] = {.lex_state = 547},
  [12901] = {.lex_state = 547},
  [12902] = {.lex_state = 384},
  [12903] = {.lex_state = 384},
  [12904] = {.lex_state = 384},
  [12905] = {.lex_state = 547},
  [12906] = {.lex_state = 547},
  [12907] = {.lex_state = 547},
  [12908] = {.lex_state = 547},
  [12909] = {.lex_state = 384},
  [12910] = {.lex_state = 547},
  [12911] = {.lex_state = 547},
  [12912] = {.lex_state = 547},
  [12913] = {.lex_state = 547},
  [12914] = {.lex_state = 547},
  [12915] = {.lex_state = 547},
  [12916] = {.lex_state = 547},
  [12917] = {.lex_state = 384},
  [12918] = {.lex_state = 384},
  [12919] = {.lex_state = 384},
  [12920] = {.lex_state = 384},
  [12921] = {.lex_state = 384},
  [12922] = {.lex_state = 389},
  [12923] = {.lex_state = 547},
  [12924] = {.lex_state = 547},
  [12925] = {.lex_state = 547},
  [12926] = {.lex_state = 384},
  [12927] = {.lex_state = 384},
  [12928] = {.lex_state = 547},
  [12929] = {.lex_state = 547},
  [12930] = {.lex_state = 547},
  [12931] = {.lex_state = 547},
  [12932] = {.lex_state = 384},
  [12933] = {.lex_state = 384},
  [12934] = {.lex_state = 389},
  [12935] = {.lex_state = 547},
  [12936] = {.lex_state = 384},
  [12937] = {.lex_state = 389},
  [12938] = {.lex_state = 547},
  [12939] = {.lex_state = 547},
  [12940] = {.lex_state = 547},
  [12941] = {.lex_state = 384},
  [12942] = {.lex_state = 547},
  [12943] = {.lex_state = 547},
  [12944] = {.lex_state = 384},
  [12945] = {.lex_state = 547},
  [12946] = {.lex_state = 384},
  [12947] = {.lex_state = 384},
  [12948] = {.lex_state = 384},
  [12949] = {.lex_state = 384},
  [12950] = {.lex_state = 384},
  [12951] = {.lex_state = 384},
  [12952] = {.lex_state = 384},
  [12953] = {.lex_state = 384},
  [12954] = {.lex_state = 384},
  [12955] = {.lex_state = 384},
  [12956] = {.lex_state = 384},
  [12957] = {.lex_state = 384},
  [12958] = {.lex_state = 384},
  [12959] = {.lex_state = 384},
  [12960] = {.lex_state = 384},
  [12961] = {.lex_state = 384},
  [12962] = {.lex_state = 384},
  [12963] = {.lex_state = 384},
  [12964] = {.lex_state = 384},
  [12965] = {.lex_state = 384},
  [12966] = {.lex_state = 384},
  [12967] = {.lex_state = 384},
  [12968] = {.lex_state = 384},
  [12969] = {.lex_state = 384},
  [12970] = {.lex_state = 384},
  [12971] = {.lex_state = 384},
  [12972] = {.lex_state = 384},
  [12973] = {.lex_state = 547},
  [12974] = {.lex_state = 384},
  [12975] = {.lex_state = 384},
  [12976] = {.lex_state = 389},
  [12977] = {.lex_state = 384},
  [12978] = {.lex_state = 384, .external_lex_state = 4},
  [12979] = {.lex_state = 384},
  [12980] = {.lex_state = 384},
  [12981] = {.lex_state = 384},
  [12982] = {.lex_state = 384},
  [12983] = {.lex_state = 384},
  [12984] = {.lex_state = 384},
  [12985] = {.lex_state = 384},
  [12986] = {.lex_state = 384},
  [12987] = {.lex_state = 384},
  [12988] = {.lex_state = 547},
  [12989] = {.lex_state = 384},
  [12990] = {.lex_state = 384},
  [12991] = {.lex_state = 384},
  [12992] = {.lex_state = 384},
  [12993] = {.lex_state = 384},
  [12994] = {.lex_state = 384},
  [12995] = {.lex_state = 384},
  [12996] = {.lex_state = 384},
  [12997] = {.lex_state = 384},
  [12998] = {.lex_state = 384},
  [12999] = {.lex_state = 384},
  [13000] = {.lex_state = 384},
  [13001] = {.lex_state = 384},
  [13002] = {.lex_state = 384},
  [13003] = {.lex_state = 384},
  [13004] = {.lex_state = 384},
  [13005] = {.lex_state = 384},
  [13006] = {.lex_state = 384},
  [13007] = {.lex_state = 384},
  [13008] = {.lex_state = 384},
  [13009] = {.lex_state = 384},
  [13010] = {.lex_state = 389},
  [13011] = {.lex_state = 547},
  [13012] = {.lex_state = 389},
  [13013] = {.lex_state = 384},
  [13014] = {.lex_state = 384},
  [13015] = {.lex_state = 384},
  [13016] = {.lex_state = 384},
  [13017] = {.lex_state = 384},
  [13018] = {.lex_state = 384},
  [13019] = {.lex_state = 384},
  [13020] = {.lex_state = 384},
  [13021] = {.lex_state = 384},
  [13022] = {.lex_state = 384},
  [13023] = {.lex_state = 384},
  [13024] = {.lex_state = 384},
  [13025] = {.lex_state = 547},
  [13026] = {.lex_state = 384},
  [13027] = {.lex_state = 384},
  [13028] = {.lex_state = 384},
  [13029] = {.lex_state = 384},
  [13030] = {.lex_state = 384},
  [13031] = {.lex_state = 384},
  [13032] = {.lex_state = 384},
  [13033] = {.lex_state = 384},
  [13034] = {.lex_state = 384},
  [13035] = {.lex_state = 384},
  [13036] = {.lex_state = 384},
  [13037] = {.lex_state = 384},
  [13038] = {.lex_state = 384},
  [13039] = {.lex_state = 384},
  [13040] = {.lex_state = 384},
  [13041] = {.lex_state = 384},
  [13042] = {.lex_state = 384},
  [13043] = {.lex_state = 384},
  [13044] = {.lex_state = 384},
  [13045] = {.lex_state = 384},
  [13046] = {.lex_state = 384},
  [13047] = {.lex_state = 384},
  [13048] = {.lex_state = 384},
  [13049] = {.lex_state = 384},
  [13050] = {.lex_state = 384},
  [13051] = {.lex_state = 384},
  [13052] = {.lex_state = 384},
  [13053] = {.lex_state = 384},
  [13054] = {.lex_state = 384},
  [13055] = {.lex_state = 384},
  [13056] = {.lex_state = 389},
  [13057] = {.lex_state = 547},
  [13058] = {.lex_state = 389},
  [13059] = {.lex_state = 547},
  [13060] = {.lex_state = 389},
  [13061] = {.lex_state = 384},
  [13062] = {.lex_state = 384},
  [13063] = {.lex_state = 384},
  [13064] = {.lex_state = 384},
  [13065] = {.lex_state = 384},
  [13066] = {.lex_state = 384},
  [13067] = {.lex_state = 384},
  [13068] = {.lex_state = 384},
  [13069] = {.lex_state = 384},
  [13070] = {.lex_state = 384},
  [13071] = {.lex_state = 384},
  [13072] = {.lex_state = 384},
  [13073] = {.lex_state = 384},
  [13074] = {.lex_state = 384},
  [13075] = {.lex_state = 384},
  [13076] = {.lex_state = 384},
  [13077] = {.lex_state = 384},
  [13078] = {.lex_state = 384},
  [13079] = {.lex_state = 384},
  [13080] = {.lex_state = 384},
  [13081] = {.lex_state = 384},
  [13082] = {.lex_state = 389},
  [13083] = {.lex_state = 384},
  [13084] = {.lex_state = 547},
  [13085] = {.lex_state = 389},
  [13086] = {.lex_state = 384},
  [13087] = {.lex_state = 547},
  [13088] = {.lex_state = 384},
  [13089] = {.lex_state = 384},
  [13090] = {.lex_state = 384},
  [13091] = {.lex_state = 384},
  [13092] = {.lex_state = 384},
  [13093] = {.lex_state = 384},
  [13094] = {.lex_state = 384},
  [13095] = {.lex_state = 384},
  [13096] = {.lex_state = 384},
  [13097] = {.lex_state = 384},
  [13098] = {.lex_state = 384},
  [13099] = {.lex_state = 384},
  [13100] = {.lex_state = 384},
  [13101] = {.lex_state = 384},
  [13102] = {.lex_state = 384},
  [13103] = {.lex_state = 384},
  [13104] = {.lex_state = 545},
  [13105] = {.lex_state = 384},
  [13106] = {.lex_state = 384},
  [13107] = {.lex_state = 384},
  [13108] = {.lex_state = 384},
  [13109] = {.lex_state = 384},
  [13110] = {.lex_state = 547, .external_lex_state = 4},
  [13111] = {.lex_state = 384},
  [13112] = {.lex_state = 384},
  [13113] = {.lex_state = 384},
  [13114] = {.lex_state = 384, .external_lex_state = 4},
  [13115] = {.lex_state = 384},
  [13116] = {.lex_state = 384},
  [13117] = {.lex_state = 384},
  [13118] = {.lex_state = 384},
  [13119] = {.lex_state = 384},
  [13120] = {.lex_state = 389},
  [13121] = {.lex_state = 547},
  [13122] = {.lex_state = 547},
  [13123] = {.lex_state = 384},
  [13124] = {.lex_state = 384},
  [13125] = {.lex_state = 384},
  [13126] = {.lex_state = 384},
  [13127] = {.lex_state = 384},
  [13128] = {.lex_state = 547},
  [13129] = {.lex_state = 547},
  [13130] = {.lex_state = 547},
  [13131] = {.lex_state = 384},
  [13132] = {.lex_state = 357},
  [13133] = {.lex_state = 384},
  [13134] = {.lex_state = 389},
  [13135] = {.lex_state = 384},
  [13136] = {.lex_state = 384},
  [13137] = {.lex_state = 384},
  [13138] = {.lex_state = 357},
  [13139] = {.lex_state = 547},
  [13140] = {.lex_state = 384},
  [13141] = {.lex_state = 384},
  [13142] = {.lex_state = 384},
  [13143] = {.lex_state = 547},
  [13144] = {.lex_state = 357},
  [13145] = {.lex_state = 384},
  [13146] = {.lex_state = 384},
  [13147] = {.lex_state = 384},
  [13148] = {.lex_state = 357},
  [13149] = {.lex_state = 357},
  [13150] = {.lex_state = 384},
  [13151] = {.lex_state = 384},
  [13152] = {.lex_state = 389},
  [13153] = {.lex_state = 384},
  [13154] = {.lex_state = 384},
  [13155] = {.lex_state = 384},
  [13156] = {.lex_state = 384},
  [13157] = {.lex_state = 384},
  [13158] = {.lex_state = 384},
  [13159] = {.lex_state = 384},
  [13160] = {.lex_state = 384},
  [13161] = {.lex_state = 357},
  [13162] = {.lex_state = 357},
  [13163] = {.lex_state = 357},
  [13164] = {.lex_state = 357},
  [13165] = {.lex_state = 357},
  [13166] = {.lex_state = 384},
  [13167] = {.lex_state = 384},
  [13168] = {.lex_state = 384},
  [13169] = {.lex_state = 384},
  [13170] = {.lex_state = 384},
  [13171] = {.lex_state = 384},
  [13172] = {.lex_state = 384},
  [13173] = {.lex_state = 384},
  [13174] = {.lex_state = 357},
  [13175] = {.lex_state = 545},
  [13176] = {.lex_state = 357},
  [13177] = {.lex_state = 389},
  [13178] = {.lex_state = 384},
  [13179] = {.lex_state = 357},
  [13180] = {.lex_state = 357},
  [13181] = {.lex_state = 357},
  [13182] = {.lex_state = 384},
  [13183] = {.lex_state = 384},
  [13184] = {.lex_state = 357},
  [13185] = {.lex_state = 384},
  [13186] = {.lex_state = 389},
  [13187] = {.lex_state = 384},
  [13188] = {.lex_state = 384},
  [13189] = {.lex_state = 384},
  [13190] = {.lex_state = 384},
  [13191] = {.lex_state = 384},
  [13192] = {.lex_state = 357},
  [13193] = {.lex_state = 384},
  [13194] = {.lex_state = 384},
  [13195] = {.lex_state = 547},
  [13196] = {.lex_state = 384},
  [13197] = {.lex_state = 384},
  [13198] = {.lex_state = 547},
  [13199] = {.lex_state = 384},
  [13200] = {.lex_state = 384},
  [13201] = {.lex_state = 357},
  [13202] = {.lex_state = 384},
  [13203] = {.lex_state = 384},
  [13204] = {.lex_state = 384},
  [13205] = {.lex_state = 384},
  [13206] = {.lex_state = 384},
  [13207] = {.lex_state = 384},
  [13208] = {.lex_state = 384},
  [13209] = {.lex_state = 384},
  [13210] = {.lex_state = 384},
  [13211] = {.lex_state = 384},
  [13212] = {.lex_state = 384},
  [13213] = {.lex_state = 384},
  [13214] = {.lex_state = 384},
  [13215] = {.lex_state = 384},
  [13216] = {.lex_state = 384},
  [13217] = {.lex_state = 384},
  [13218] = {.lex_state = 384},
  [13219] = {.lex_state = 384},
  [13220] = {.lex_state = 384},
  [13221] = {.lex_state = 384},
  [13222] = {.lex_state = 384},
  [13223] = {.lex_state = 384},
  [13224] = {.lex_state = 384},
  [13225] = {.lex_state = 384},
  [13226] = {.lex_state = 384},
  [13227] = {.lex_state = 384},
  [13228] = {.lex_state = 389},
  [13229] = {.lex_state = 357},
  [13230] = {.lex_state = 384, .external_lex_state = 4},
  [13231] = {.lex_state = 389},
  [13232] = {.lex_state = 357},
  [13233] = {.lex_state = 384},
  [13234] = {.lex_state = 384},
  [13235] = {.lex_state = 384},
  [13236] = {.lex_state = 384},
  [13237] = {.lex_state = 384},
  [13238] = {.lex_state = 384},
  [13239] = {.lex_state = 384},
  [13240] = {.lex_state = 384},
  [13241] = {.lex_state = 384},
  [13242] = {.lex_state = 384},
  [13243] = {.lex_state = 384},
  [13244] = {.lex_state = 384},
  [13245] = {.lex_state = 384},
  [13246] = {.lex_state = 384},
  [13247] = {.lex_state = 384},
  [13248] = {.lex_state = 357},
  [13249] = {.lex_state = 384},
  [13250] = {.lex_state = 384},
  [13251] = {.lex_state = 357},
  [13252] = {.lex_state = 384},
  [13253] = {.lex_state = 384},
  [13254] = {.lex_state = 384},
  [13255] = {.lex_state = 384},
  [13256] = {.lex_state = 384},
  [13257] = {.lex_state = 384},
  [13258] = {.lex_state = 384},
  [13259] = {.lex_state = 357},
  [13260] = {.lex_state = 384},
  [13261] = {.lex_state = 547},
  [13262] = {.lex_state = 384},
  [13263] = {.lex_state = 384},
  [13264] = {.lex_state = 384},
  [13265] = {.lex_state = 357},
  [13266] = {.lex_state = 384},
  [13267] = {.lex_state = 384},
  [13268] = {.lex_state = 384},
  [13269] = {.lex_state = 547},
  [13270] = {.lex_state = 384},
  [13271] = {.lex_state = 384},
  [13272] = {.lex_state = 384},
  [13273] = {.lex_state = 384},
  [13274] = {.lex_state = 384},
  [13275] = {.lex_state = 384},
  [13276] = {.lex_state = 389},
  [13277] = {.lex_state = 547},
  [13278] = {.lex_state = 384},
  [13279] = {.lex_state = 547},
  [13280] = {.lex_state = 357},
  [13281] = {.lex_state = 384, .external_lex_state = 4},
  [13282] = {.lex_state = 384, .external_lex_state = 4},
  [13283] = {.lex_state = 384},
  [13284] = {.lex_state = 357},
  [13285] = {.lex_state = 384},
  [13286] = {.lex_state = 384},
  [13287] = {.lex_state = 357},
  [13288] = {.lex_state = 389},
  [13289] = {.lex_state = 384},
  [13290] = {.lex_state = 384},
  [13291] = {.lex_state = 384},
  [13292] = {.lex_state = 384},
  [13293] = {.lex_state = 389},
  [13294] = {.lex_state = 384},
  [13295] = {.lex_state = 547},
  [13296] = {.lex_state = 384},
  [13297] = {.lex_state = 384},
  [13298] = {.lex_state = 384},
  [13299] = {.lex_state = 384},
  [13300] = {.lex_state = 357},
  [13301] = {.lex_state = 384},
  [13302] = {.lex_state = 547},
  [13303] = {.lex_state = 547},
  [13304] = {.lex_state = 547},
  [13305] = {.lex_state = 547},
  [13306] = {.lex_state = 547},
  [13307] = {.lex_state = 547},
  [13308] = {.lex_state = 547},
  [13309] = {.lex_state = 384},
  [13310] = {.lex_state = 357},
  [13311] = {.lex_state = 547},
  [13312] = {.lex_state = 547},
  [13313] = {.lex_state = 384},
  [13314] = {.lex_state = 547},
  [13315] = {.lex_state = 384},
  [13316] = {.lex_state = 384},
  [13317] = {.lex_state = 547},
  [13318] = {.lex_state = 547},
  [13319] = {.lex_state = 547},
  [13320] = {.lex_state = 384},
  [13321] = {.lex_state = 384},
  [13322] = {.lex_state = 384},
  [13323] = {.lex_state = 384},
  [13324] = {.lex_state = 384},
  [13325] = {.lex_state = 384},
  [13326] = {.lex_state = 384},
  [13327] = {.lex_state = 384},
  [13328] = {.lex_state = 384},
  [13329] = {.lex_state = 384},
  [13330] = {.lex_state = 384},
  [13331] = {.lex_state = 384},
  [13332] = {.lex_state = 547},
  [13333] = {.lex_state = 384},
  [13334] = {.lex_state = 384},
  [13335] = {.lex_state = 384},
  [13336] = {.lex_state = 384},
  [13337] = {.lex_state = 384},
  [13338] = {.lex_state = 384},
  [13339] = {.lex_state = 384},
  [13340] = {.lex_state = 384},
  [13341] = {.lex_state = 384},
  [13342] = {.lex_state = 384},
  [13343] = {.lex_state = 384},
  [13344] = {.lex_state = 389},
  [13345] = {.lex_state = 384},
  [13346] = {.lex_state = 384},
  [13347] = {.lex_state = 384},
  [13348] = {.lex_state = 384},
  [13349] = {.lex_state = 384},
  [13350] = {.lex_state = 384},
  [13351] = {.lex_state = 384},
  [13352] = {.lex_state = 384},
  [13353] = {.lex_state = 384},
  [13354] = {.lex_state = 384},
  [13355] = {.lex_state = 384},
  [13356] = {.lex_state = 389},
  [13357] = {.lex_state = 384},
  [13358] = {.lex_state = 384},
  [13359] = {.lex_state = 384},
  [13360] = {.lex_state = 357},
  [13361] = {.lex_state = 384, .external_lex_state = 4},
  [13362] = {.lex_state = 389},
  [13363] = {.lex_state = 384},
  [13364] = {.lex_state = 384},
  [13365] = {.lex_state = 389},
  [13366] = {.lex_state = 384},
  [13367] = {.lex_state = 357},
  [13368] = {.lex_state = 384},
  [13369] = {.lex_state = 384},
  [13370] = {.lex_state = 547},
  [13371] = {.lex_state = 384},
  [13372] = {.lex_state = 384},
  [13373] = {.lex_state = 384},
  [13374] = {.lex_state = 384},
  [13375] = {.lex_state = 384},
  [13376] = {.lex_state = 384},
  [13377] = {.lex_state = 384},
  [13378] = {.lex_state = 357},
  [13379] = {.lex_state = 357},
  [13380] = {.lex_state = 384},
  [13381] = {.lex_state = 547},
  [13382] = {.lex_state = 384},
  [13383] = {.lex_state = 384, .external_lex_state = 4},
  [13384] = {.lex_state = 384},
  [13385] = {.lex_state = 384},
  [13386] = {.lex_state = 384},
  [13387] = {.lex_state = 384},
  [13388] = {.lex_state = 357},
  [13389] = {.lex_state = 384},
  [13390] = {.lex_state = 384},
  [13391] = {.lex_state = 384},
  [13392] = {.lex_state = 357},
  [13393] = {.lex_state = 384},
  [13394] = {.lex_state = 547},
  [13395] = {.lex_state = 384},
  [13396] = {.lex_state = 384},
  [13397] = {.lex_state = 357},
  [13398] = {.lex_state = 547},
  [13399] = {.lex_state = 357},
  [13400] = {.lex_state = 384},
  [13401] = {.lex_state = 547},
  [13402] = {.lex_state = 384},
  [13403] = {.lex_state = 384},
  [13404] = {.lex_state = 384},
  [13405] = {.lex_state = 547},
  [13406] = {.lex_state = 547},
  [13407] = {.lex_state = 384},
  [13408] = {.lex_state = 384},
  [13409] = {.lex_state = 384},
  [13410] = {.lex_state = 547},
  [13411] = {.lex_state = 384},
  [13412] = {.lex_state = 384},
  [13413] = {.lex_state = 384},
  [13414] = {.lex_state = 384},
  [13415] = {.lex_state = 384},
  [13416] = {.lex_state = 389},
  [13417] = {.lex_state = 357},
  [13418] = {.lex_state = 357},
  [13419] = {.lex_state = 547},
  [13420] = {.lex_state = 357},
  [13421] = {.lex_state = 547},
  [13422] = {.lex_state = 547},
  [13423] = {.lex_state = 357},
  [13424] = {.lex_state = 384},
  [13425] = {.lex_state = 357},
  [13426] = {.lex_state = 547},
  [13427] = {.lex_state = 357},
  [13428] = {.lex_state = 357},
  [13429] = {.lex_state = 357},
  [13430] = {.lex_state = 357},
  [13431] = {.lex_state = 357},
  [13432] = {.lex_state = 384},
  [13433] = {.lex_state = 357},
  [13434] = {.lex_state = 384},
  [13435] = {.lex_state = 357},
  [13436] = {.lex_state = 357},
  [13437] = {.lex_state = 357},
  [13438] = {.lex_state = 384},
  [13439] = {.lex_state = 384},
  [13440] = {.lex_state = 384},
  [13441] = {.lex_state = 384, .external_lex_state = 4},
  [13442] = {.lex_state = 384},
  [13443] = {.lex_state = 384},
  [13444] = {.lex_state = 384},
  [13445] = {.lex_state = 384},
  [13446] = {.lex_state = 384},
  [13447] = {.lex_state = 384},
  [13448] = {.lex_state = 384},
  [13449] = {.lex_state = 384},
  [13450] = {.lex_state = 384, .external_lex_state = 4},
  [13451] = {.lex_state = 384},
  [13452] = {.lex_state = 349},
  [13453] = {.lex_state = 384},
  [13454] = {.lex_state = 384},
  [13455] = {.lex_state = 384},
  [13456] = {.lex_state = 384},
  [13457] = {.lex_state = 349},
  [13458] = {.lex_state = 384},
  [13459] = {.lex_state = 384},
  [13460] = {.lex_state = 396},
  [13461] = {.lex_state = 384},
  [13462] = {.lex_state = 384},
  [13463] = {.lex_state = 384},
  [13464] = {.lex_state = 384},
  [13465] = {.lex_state = 384},
  [13466] = {.lex_state = 389},
  [13467] = {.lex_state = 384},
  [13468] = {.lex_state = 384},
  [13469] = {.lex_state = 384},
  [13470] = {.lex_state = 384},
  [13471] = {.lex_state = 384, .external_lex_state = 4},
  [13472] = {.lex_state = 384},
  [13473] = {.lex_state = 384},
  [13474] = {.lex_state = 384},
  [13475] = {.lex_state = 384, .external_lex_state = 4},
  [13476] = {.lex_state = 384},
  [13477] = {.lex_state = 384},
  [13478] = {.lex_state = 349},
  [13479] = {.lex_state = 384, .external_lex_state = 4},
  [13480] = {.lex_state = 384},
  [13481] = {.lex_state = 384},
  [13482] = {.lex_state = 384},
  [13483] = {.lex_state = 384},
  [13484] = {.lex_state = 384},
  [13485] = {.lex_state = 384},
  [13486] = {.lex_state = 384},
  [13487] = {.lex_state = 384},
  [13488] = {.lex_state = 384},
  [13489] = {.lex_state = 384},
  [13490] = {.lex_state = 384},
  [13491] = {.lex_state = 384},
  [13492] = {.lex_state = 384},
  [13493] = {.lex_state = 384},
  [13494] = {.lex_state = 384},
  [13495] = {.lex_state = 349},
  [13496] = {.lex_state = 384},
  [13497] = {.lex_state = 349},
  [13498] = {.lex_state = 384},
  [13499] = {.lex_state = 384},
  [13500] = {.lex_state = 384},
  [13501] = {.lex_state = 384},
  [13502] = {.lex_state = 384},
  [13503] = {.lex_state = 384},
  [13504] = {.lex_state = 384},
  [13505] = {.lex_state = 384},
  [13506] = {.lex_state = 384},
  [13507] = {.lex_state = 384},
  [13508] = {.lex_state = 384},
  [13509] = {.lex_state = 384},
  [13510] = {.lex_state = 384},
  [13511] = {.lex_state = 384},
  [13512] = {.lex_state = 384},
  [13513] = {.lex_state = 349},
  [13514] = {.lex_state = 349},
  [13515] = {.lex_state = 384},
  [13516] = {.lex_state = 384},
  [13517] = {.lex_state = 384},
  [13518] = {.lex_state = 384},
  [13519] = {.lex_state = 384},
  [13520] = {.lex_state = 389},
  [13521] = {.lex_state = 384},
  [13522] = {.lex_state = 349},
  [13523] = {.lex_state = 384, .external_lex_state = 4},
  [13524] = {.lex_state = 384},
  [13525] = {.lex_state = 349},
  [13526] = {.lex_state = 384},
  [13527] = {.lex_state = 384},
  [13528] = {.lex_state = 384},
  [13529] = {.lex_state = 384},
  [13530] = {.lex_state = 384},
  [13531] = {.lex_state = 384},
  [13532] = {.lex_state = 384},
  [13533] = {.lex_state = 384},
  [13534] = {.lex_state = 384},
  [13535] = {.lex_state = 384},
  [13536] = {.lex_state = 384},
  [13537] = {.lex_state = 384},
  [13538] = {.lex_state = 384},
  [13539] = {.lex_state = 384},
  [13540] = {.lex_state = 384},
  [13541] = {.lex_state = 349},
  [13542] = {.lex_state = 349},
  [13543] = {.lex_state = 384},
  [13544] = {.lex_state = 349},
  [13545] = {.lex_state = 384},
  [13546] = {.lex_state = 349},
  [13547] = {.lex_state = 384},
  [13548] = {.lex_state = 384},
  [13549] = {.lex_state = 384},
  [13550] = {.lex_state = 384},
  [13551] = {.lex_state = 389},
  [13552] = {.lex_state = 384},
  [13553] = {.lex_state = 384},
  [13554] = {.lex_state = 384},
  [13555] = {.lex_state = 384},
  [13556] = {.lex_state = 384, .external_lex_state = 4},
  [13557] = {.lex_state = 384},
  [13558] = {.lex_state = 384},
  [13559] = {.lex_state = 384},
  [13560] = {.lex_state = 384},
  [13561] = {.lex_state = 384},
  [13562] = {.lex_state = 384},
  [13563] = {.lex_state = 384},
  [13564] = {.lex_state = 384},
  [13565] = {.lex_state = 384},
  [13566] = {.lex_state = 389},
  [13567] = {.lex_state = 384},
  [13568] = {.lex_state = 384},
  [13569] = {.lex_state = 384},
  [13570] = {.lex_state = 384},
  [13571] = {.lex_state = 384},
  [13572] = {.lex_state = 384},
  [13573] = {.lex_state = 384},
  [13574] = {.lex_state = 384},
  [13575] = {.lex_state = 384},
  [13576] = {.lex_state = 384},
  [13577] = {.lex_state = 384},
  [13578] = {.lex_state = 384},
  [13579] = {.lex_state = 384},
  [13580] = {.lex_state = 384},
  [13581] = {.lex_state = 384},
  [13582] = {.lex_state = 384},
  [13583] = {.lex_state = 384},
  [13584] = {.lex_state = 389},
  [13585] = {.lex_state = 389},
  [13586] = {.lex_state = 384, .external_lex_state = 4},
  [13587] = {.lex_state = 384},
  [13588] = {.lex_state = 384},
  [13589] = {.lex_state = 389},
  [13590] = {.lex_state = 384},
  [13591] = {.lex_state = 384},
  [13592] = {.lex_state = 384},
  [13593] = {.lex_state = 384},
  [13594] = {.lex_state = 384},
  [13595] = {.lex_state = 384},
  [13596] = {.lex_state = 389},
  [13597] = {.lex_state = 384},
  [13598] = {.lex_state = 384},
  [13599] = {.lex_state = 349},
  [13600] = {.lex_state = 384},
  [13601] = {.lex_state = 384, .external_lex_state = 4},
  [13602] = {.lex_state = 389},
  [13603] = {.lex_state = 349},
  [13604] = {.lex_state = 349},
  [13605] = {.lex_state = 389},
  [13606] = {.lex_state = 396},
  [13607] = {.lex_state = 384},
  [13608] = {.lex_state = 349},
  [13609] = {.lex_state = 384},
  [13610] = {.lex_state = 396},
  [13611] = {.lex_state = 384},
  [13612] = {.lex_state = 389},
  [13613] = {.lex_state = 384, .external_lex_state = 4},
  [13614] = {.lex_state = 384},
  [13615] = {.lex_state = 384},
  [13616] = {.lex_state = 384},
  [13617] = {.lex_state = 384},
  [13618] = {.lex_state = 384},
  [13619] = {.lex_state = 384},
  [13620] = {.lex_state = 389},
  [13621] = {.lex_state = 384, .external_lex_state = 4},
  [13622] = {.lex_state = 384},
  [13623] = {.lex_state = 389},
  [13624] = {.lex_state = 384, .external_lex_state = 4},
  [13625] = {.lex_state = 384},
  [13626] = {.lex_state = 384},
  [13627] = {.lex_state = 389},
  [13628] = {.lex_state = 384},
  [13629] = {.lex_state = 384},
  [13630] = {.lex_state = 389},
  [13631] = {.lex_state = 349},
  [13632] = {.lex_state = 389},
  [13633] = {.lex_state = 349},
  [13634] = {.lex_state = 384, .external_lex_state = 4},
  [13635] = {.lex_state = 384},
  [13636] = {.lex_state = 384},
  [13637] = {.lex_state = 384},
  [13638] = {.lex_state = 384},
  [13639] = {.lex_state = 384},
  [13640] = {.lex_state = 384},
  [13641] = {.lex_state = 384},
  [13642] = {.lex_state = 384},
  [13643] = {.lex_state = 384},
  [13644] = {.lex_state = 384},
  [13645] = {.lex_state = 384},
  [13646] = {.lex_state = 384},
  [13647] = {.lex_state = 384},
  [13648] = {.lex_state = 384},
  [13649] = {.lex_state = 396},
  [13650] = {.lex_state = 384},
  [13651] = {.lex_state = 384},
  [13652] = {.lex_state = 384},
  [13653] = {.lex_state = 384},
  [13654] = {.lex_state = 384},
  [13655] = {.lex_state = 384},
  [13656] = {.lex_state = 384},
  [13657] = {.lex_state = 384},
  [13658] = {.lex_state = 384},
  [13659] = {.lex_state = 384},
  [13660] = {.lex_state = 384},
  [13661] = {.lex_state = 384},
  [13662] = {.lex_state = 384},
  [13663] = {.lex_state = 384},
  [13664] = {.lex_state = 384},
  [13665] = {.lex_state = 384},
  [13666] = {.lex_state = 384},
  [13667] = {.lex_state = 384},
  [13668] = {.lex_state = 384},
  [13669] = {.lex_state = 384},
  [13670] = {.lex_state = 384},
  [13671] = {.lex_state = 384},
  [13672] = {.lex_state = 384},
  [13673] = {.lex_state = 384},
  [13674] = {.lex_state = 384},
  [13675] = {.lex_state = 349},
  [13676] = {.lex_state = 384},
  [13677] = {.lex_state = 384},
  [13678] = {.lex_state = 384},
  [13679] = {.lex_state = 384},
  [13680] = {.lex_state = 384},
  [13681] = {.lex_state = 389},
  [13682] = {.lex_state = 384, .external_lex_state = 4},
  [13683] = {.lex_state = 384},
  [13684] = {.lex_state = 384},
  [13685] = {.lex_state = 384},
  [13686] = {.lex_state = 384},
  [13687] = {.lex_state = 384},
  [13688] = {.lex_state = 384},
  [13689] = {.lex_state = 384},
  [13690] = {.lex_state = 349},
  [13691] = {.lex_state = 384},
  [13692] = {.lex_state = 384},
  [13693] = {.lex_state = 384},
  [13694] = {.lex_state = 384},
  [13695] = {.lex_state = 384},
  [13696] = {.lex_state = 384},
  [13697] = {.lex_state = 384},
  [13698] = {.lex_state = 384},
  [13699] = {.lex_state = 389},
  [13700] = {.lex_state = 384},
  [13701] = {.lex_state = 384},
  [13702] = {.lex_state = 384},
  [13703] = {.lex_state = 389},
  [13704] = {.lex_state = 384, .external_lex_state = 4},
  [13705] = {.lex_state = 349},
  [13706] = {.lex_state = 349},
  [13707] = {.lex_state = 384},
  [13708] = {.lex_state = 389},
  [13709] = {.lex_state = 384, .external_lex_state = 4},
  [13710] = {.lex_state = 389},
  [13711] = {.lex_state = 389},
  [13712] = {.lex_state = 384, .external_lex_state = 4},
  [13713] = {.lex_state = 349},
  [13714] = {.lex_state = 349},
  [13715] = {.lex_state = 389},
  [13716] = {.lex_state = 384, .external_lex_state = 4},
  [13717] = {.lex_state = 389},
  [13718] = {.lex_state = 349},
  [13719] = {.lex_state = 384},
  [13720] = {.lex_state = 384, .external_lex_state = 4},
  [13721] = {.lex_state = 349},
  [13722] = {.lex_state = 349},
  [13723] = {.lex_state = 384},
  [13724] = {.lex_state = 349},
  [13725] = {.lex_state = 389},
  [13726] = {.lex_state = 349},
  [13727] = {.lex_state = 384},
  [13728] = {.lex_state = 384},
  [13729] = {.lex_state = 349},
  [13730] = {.lex_state = 349},
  [13731] = {.lex_state = 384, .external_lex_state = 4},
  [13732] = {.lex_state = 384},
  [13733] = {.lex_state = 349},
  [13734] = {.lex_state = 349},
  [13735] = {.lex_state = 349},
  [13736] = {.lex_state = 349},
  [13737] = {.lex_state = 349},
  [13738] = {.lex_state = 349},
  [13739] = {.lex_state = 349},
  [13740] = {.lex_state = 349},
  [13741] = {.lex_state = 349},
  [13742] = {.lex_state = 349},
  [13743] = {.lex_state = 384},
  [13744] = {.lex_state = 349},
  [13745] = {.lex_state = 349},
  [13746] = {.lex_state = 384},
  [13747] = {.lex_state = 384},
  [13748] = {.lex_state = 384},
  [13749] = {.lex_state = 384},
  [13750] = {.lex_state = 384},
  [13751] = {.lex_state = 384},
  [13752] = {.lex_state = 349},
  [13753] = {.lex_state = 384},
  [13754] = {.lex_state = 384},
  [13755] = {.lex_state = 389},
  [13756] = {.lex_state = 384, .external_lex_state = 4},
  [13757] = {.lex_state = 384},
  [13758] = {.lex_state = 384},
  [13759] = {.lex_state = 384},
  [13760] = {.lex_state = 384},
  [13761] = {.lex_state = 384},
  [13762] = {.lex_state = 384},
  [13763] = {.lex_state = 389},
  [13764] = {.lex_state = 384, .external_lex_state = 4},
  [13765] = {.lex_state = 384},
  [13766] = {.lex_state = 384},
  [13767] = {.lex_state = 384},
  [13768] = {.lex_state = 384},
  [13769] = {.lex_state = 389},
  [13770] = {.lex_state = 384},
  [13771] = {.lex_state = 384, .external_lex_state = 4},
  [13772] = {.lex_state = 389},
  [13773] = {.lex_state = 384, .external_lex_state = 4},
  [13774] = {.lex_state = 384},
  [13775] = {.lex_state = 389},
  [13776] = {.lex_state = 384},
  [13777] = {.lex_state = 389},
  [13778] = {.lex_state = 384, .external_lex_state = 4},
  [13779] = {.lex_state = 349},
  [13780] = {.lex_state = 349},
  [13781] = {.lex_state = 349},
  [13782] = {.lex_state = 384, .external_lex_state = 4},
  [13783] = {.lex_state = 384},
  [13784] = {.lex_state = 384},
  [13785] = {.lex_state = 384},
  [13786] = {.lex_state = 384, .external_lex_state = 4},
  [13787] = {.lex_state = 389},
  [13788] = {.lex_state = 547},
  [13789] = {.lex_state = 349},
  [13790] = {.lex_state = 349},
  [13791] = {.lex_state = 384},
  [13792] = {.lex_state = 384},
  [13793] = {.lex_state = 389},
  [13794] = {.lex_state = 384, .external_lex_state = 4},
  [13795] = {.lex_state = 384},
  [13796] = {.lex_state = 384},
  [13797] = {.lex_state = 384},
  [13798] = {.lex_state = 384},
  [13799] = {.lex_state = 384},
  [13800] = {.lex_state = 384},
  [13801] = {.lex_state = 384},
  [13802] = {.lex_state = 384},
  [13803] = {.lex_state = 384},
  [13804] = {.lex_state = 389},
  [13805] = {.lex_state = 384},
  [13806] = {.lex_state = 389},
  [13807] = {.lex_state = 384, .external_lex_state = 4},
  [13808] = {.lex_state = 349},
  [13809] = {.lex_state = 349},
  [13810] = {.lex_state = 384, .external_lex_state = 4},
  [13811] = {.lex_state = 349},
  [13812] = {.lex_state = 349},
  [13813] = {.lex_state = 384},
  [13814] = {.lex_state = 384},
  [13815] = {.lex_state = 349},
  [13816] = {.lex_state = 349},
  [13817] = {.lex_state = 384},
  [13818] = {.lex_state = 349},
  [13819] = {.lex_state = 349},
  [13820] = {.lex_state = 349},
  [13821] = {.lex_state = 349},
  [13822] = {.lex_state = 349},
  [13823] = {.lex_state = 384},
  [13824] = {.lex_state = 384},
  [13825] = {.lex_state = 384},
  [13826] = {.lex_state = 384},
  [13827] = {.lex_state = 384},
  [13828] = {.lex_state = 384},
  [13829] = {.lex_state = 384},
  [13830] = {.lex_state = 384},
  [13831] = {.lex_state = 384},
  [13832] = {.lex_state = 384},
  [13833] = {.lex_state = 384},
  [13834] = {.lex_state = 384},
  [13835] = {.lex_state = 384},
  [13836] = {.lex_state = 384},
  [13837] = {.lex_state = 384},
  [13838] = {.lex_state = 389},
  [13839] = {.lex_state = 384, .external_lex_state = 4},
  [13840] = {.lex_state = 384},
  [13841] = {.lex_state = 384},
  [13842] = {.lex_state = 389},
  [13843] = {.lex_state = 349},
  [13844] = {.lex_state = 384},
  [13845] = {.lex_state = 389},
  [13846] = {.lex_state = 384},
  [13847] = {.lex_state = 389},
  [13848] = {.lex_state = 384, .external_lex_state = 4},
  [13849] = {.lex_state = 384},
  [13850] = {.lex_state = 384},
  [13851] = {.lex_state = 389},
  [13852] = {.lex_state = 384},
  [13853] = {.lex_state = 389},
  [13854] = {.lex_state = 384, .external_lex_state = 4},
  [13855] = {.lex_state = 384},
  [13856] = {.lex_state = 384, .external_lex_state = 4},
  [13857] = {.lex_state = 384},
  [13858] = {.lex_state = 389},
  [13859] = {.lex_state = 384},
  [13860] = {.lex_state = 396},
  [13861] = {.lex_state = 349},
  [13862] = {.lex_state = 349},
  [13863] = {.lex_state = 389},
  [13864] = {.lex_state = 384, .external_lex_state = 4},
  [13865] = {.lex_state = 384},
  [13866] = {.lex_state = 384},
  [13867] = {.lex_state = 384, .external_lex_state = 4},
  [13868] = {.lex_state = 384, .external_lex_state = 4},
  [13869] = {.lex_state = 384, .external_lex_state = 4},
  [13870] = {.lex_state = 349},
  [13871] = {.lex_state = 384},
  [13872] = {.lex_state = 384},
  [13873] = {.lex_state = 384},
  [13874] = {.lex_state = 384},
  [13875] = {.lex_state = 389},
  [13876] = {.lex_state = 384, .external_lex_state = 4},
  [13877] = {.lex_state = 384},
  [13878] = {.lex_state = 384},
  [13879] = {.lex_state = 384},
  [13880] = {.lex_state = 349},
  [13881] = {.lex_state = 349},
  [13882] = {.lex_state = 349},
  [13883] = {.lex_state = 349},
  [13884] = {.lex_state = 384},
  [13885] = {.lex_state = 349},
  [13886] = {.lex_state = 349},
  [13887] = {.lex_state = 349},
  [13888] = {.lex_state = 349},
  [13889] = {.lex_state = 389},
  [13890] = {.lex_state = 349},
  [13891] = {.lex_state = 349},
  [13892] = {.lex_state = 384, .external_lex_state = 4},
  [13893] = {.lex_state = 349},
  [13894] = {.lex_state = 349},
  [13895] = {.lex_state = 384},
  [13896] = {.lex_state = 349},
  [13897] = {.lex_state = 349},
  [13898] = {.lex_state = 349},
  [13899] = {.lex_state = 349},
  [13900] = {.lex_state = 349},
  [13901] = {.lex_state = 349},
  [13902] = {.lex_state = 349},
  [13903] = {.lex_state = 349},
  [13904] = {.lex_state = 349},
  [13905] = {.lex_state = 384},
  [13906] = {.lex_state = 384},
  [13907] = {.lex_state = 349},
  [13908] = {.lex_state = 384},
  [13909] = {.lex_state = 349},
  [13910] = {.lex_state = 349},
  [13911] = {.lex_state = 349},
  [13912] = {.lex_state = 349},
  [13913] = {.lex_state = 384},
  [13914] = {.lex_state = 384},
  [13915] = {.lex_state = 389},
  [13916] = {.lex_state = 384, .external_lex_state = 4},
  [13917] = {.lex_state = 389},
  [13918] = {.lex_state = 384},
  [13919] = {.lex_state = 389},
  [13920] = {.lex_state = 384, .external_lex_state = 4},
  [13921] = {.lex_state = 384},
  [13922] = {.lex_state = 349},
  [13923] = {.lex_state = 349},
  [13924] = {.lex_state = 384},
  [13925] = {.lex_state = 384},
  [13926] = {.lex_state = 384},
  [13927] = {.lex_state = 389},
  [13928] = {.lex_state = 384, .external_lex_state = 4},
  [13929] = {.lex_state = 384},
  [13930] = {.lex_state = 384},
  [13931] = {.lex_state = 389},
  [13932] = {.lex_state = 384},
  [13933] = {.lex_state = 384},
  [13934] = {.lex_state = 389},
  [13935] = {.lex_state = 384, .external_lex_state = 4},
  [13936] = {.lex_state = 384},
  [13937] = {.lex_state = 349},
  [13938] = {.lex_state = 349},
  [13939] = {.lex_state = 384},
  [13940] = {.lex_state = 384},
  [13941] = {.lex_state = 396},
  [13942] = {.lex_state = 384},
  [13943] = {.lex_state = 384},
  [13944] = {.lex_state = 389},
  [13945] = {.lex_state = 384},
  [13946] = {.lex_state = 389},
  [13947] = {.lex_state = 349},
  [13948] = {.lex_state = 389},
  [13949] = {.lex_state = 384},
  [13950] = {.lex_state = 384},
  [13951] = {.lex_state = 349},
  [13952] = {.lex_state = 384},
  [13953] = {.lex_state = 389},
  [13954] = {.lex_state = 349},
  [13955] = {.lex_state = 384},
  [13956] = {.lex_state = 384},
  [13957] = {.lex_state = 349},
  [13958] = {.lex_state = 389},
  [13959] = {.lex_state = 384},
  [13960] = {.lex_state = 384},
  [13961] = {.lex_state = 389},
  [13962] = {.lex_state = 389},
  [13963] = {.lex_state = 384},
  [13964] = {.lex_state = 384},
  [13965] = {.lex_state = 384},
  [13966] = {.lex_state = 384},
  [13967] = {.lex_state = 384},
  [13968] = {.lex_state = 384},
  [13969] = {.lex_state = 389},
  [13970] = {.lex_state = 349},
  [13971] = {.lex_state = 349},
  [13972] = {.lex_state = 384, .external_lex_state = 4},
  [13973] = {.lex_state = 384},
  [13974] = {.lex_state = 384},
  [13975] = {.lex_state = 384},
  [13976] = {.lex_state = 384},
  [13977] = {.lex_state = 384},
  [13978] = {.lex_state = 384},
  [13979] = {.lex_state = 384},
  [13980] = {.lex_state = 384},
  [13981] = {.lex_state = 384},
  [13982] = {.lex_state = 384},
  [13983] = {.lex_state = 384},
  [13984] = {.lex_state = 384},
  [13985] = {.lex_state = 384},
  [13986] = {.lex_state = 384},
  [13987] = {.lex_state = 384},
  [13988] = {.lex_state = 384},
  [13989] = {.lex_state = 384},
  [13990] = {.lex_state = 384},
  [13991] = {.lex_state = 384},
  [13992] = {.lex_state = 384},
  [13993] = {.lex_state = 384},
  [13994] = {.lex_state = 384},
  [13995] = {.lex_state = 384},
  [13996] = {.lex_state = 389},
  [13997] = {.lex_state = 384},
  [13998] = {.lex_state = 384},
  [13999] = {.lex_state = 384},
  [14000] = {.lex_state = 384},
  [14001] = {.lex_state = 384},
  [14002] = {.lex_state = 384},
  [14003] = {.lex_state = 384},
  [14004] = {.lex_state = 384},
  [14005] = {.lex_state = 384, .external_lex_state = 4},
  [14006] = {.lex_state = 384},
  [14007] = {.lex_state = 384},
  [14008] = {.lex_state = 384},
  [14009] = {.lex_state = 389},
  [14010] = {.lex_state = 384},
  [14011] = {.lex_state = 384},
  [14012] = {.lex_state = 384},
  [14013] = {.lex_state = 384},
  [14014] = {.lex_state = 384},
  [14015] = {.lex_state = 384},
  [14016] = {.lex_state = 384},
  [14017] = {.lex_state = 384},
  [14018] = {.lex_state = 384},
  [14019] = {.lex_state = 384},
  [14020] = {.lex_state = 384},
  [14021] = {.lex_state = 384},
  [14022] = {.lex_state = 384},
  [14023] = {.lex_state = 384},
  [14024] = {.lex_state = 384},
  [14025] = {.lex_state = 384},
  [14026] = {.lex_state = 384},
  [14027] = {.lex_state = 384},
  [14028] = {.lex_state = 384},
  [14029] = {.lex_state = 384},
  [14030] = {.lex_state = 384},
  [14031] = {.lex_state = 384},
  [14032] = {.lex_state = 384},
  [14033] = {.lex_state = 384},
  [14034] = {.lex_state = 384},
  [14035] = {.lex_state = 384},
  [14036] = {.lex_state = 384},
  [14037] = {.lex_state = 384},
  [14038] = {.lex_state = 384},
  [14039] = {.lex_state = 389},
  [14040] = {.lex_state = 384},
  [14041] = {.lex_state = 384},
  [14042] = {.lex_state = 384},
  [14043] = {.lex_state = 384},
  [14044] = {.lex_state = 384},
  [14045] = {.lex_state = 384},
  [14046] = {.lex_state = 384},
  [14047] = {.lex_state = 384},
  [14048] = {.lex_state = 384},
  [14049] = {.lex_state = 384},
  [14050] = {.lex_state = 384},
  [14051] = {.lex_state = 384},
  [14052] = {.lex_state = 384},
  [14053] = {.lex_state = 384},
  [14054] = {.lex_state = 384},
  [14055] = {.lex_state = 384},
  [14056] = {.lex_state = 384},
  [14057] = {.lex_state = 384},
  [14058] = {.lex_state = 384},
  [14059] = {.lex_state = 384},
  [14060] = {.lex_state = 384},
  [14061] = {.lex_state = 384},
  [14062] = {.lex_state = 384},
  [14063] = {.lex_state = 384},
  [14064] = {.lex_state = 384},
  [14065] = {.lex_state = 384},
  [14066] = {.lex_state = 384},
  [14067] = {.lex_state = 384},
  [14068] = {.lex_state = 384},
  [14069] = {.lex_state = 384},
  [14070] = {.lex_state = 384},
  [14071] = {.lex_state = 384},
  [14072] = {.lex_state = 384},
  [14073] = {.lex_state = 384},
  [14074] = {.lex_state = 384},
  [14075] = {.lex_state = 384},
  [14076] = {.lex_state = 384},
  [14077] = {.lex_state = 384},
  [14078] = {.lex_state = 384},
  [14079] = {.lex_state = 384},
  [14080] = {.lex_state = 384},
  [14081] = {.lex_state = 384},
  [14082] = {.lex_state = 384},
  [14083] = {.lex_state = 384},
  [14084] = {.lex_state = 384},
  [14085] = {.lex_state = 384},
  [14086] = {.lex_state = 384},
  [14087] = {.lex_state = 384},
  [14088] = {.lex_state = 384},
  [14089] = {.lex_state = 384},
  [14090] = {.lex_state = 384},
  [14091] = {.lex_state = 384},
  [14092] = {.lex_state = 384},
  [14093] = {.lex_state = 384},
  [14094] = {.lex_state = 384},
  [14095] = {.lex_state = 384},
  [14096] = {.lex_state = 384},
  [14097] = {.lex_state = 384},
  [14098] = {.lex_state = 384},
  [14099] = {.lex_state = 384},
  [14100] = {.lex_state = 384},
  [14101] = {.lex_state = 384},
  [14102] = {.lex_state = 349, .external_lex_state = 4},
  [14103] = {.lex_state = 349, .external_lex_state = 4},
  [14104] = {.lex_state = 349, .external_lex_state = 4},
  [14105] = {.lex_state = 349, .external_lex_state = 4},
  [14106] = {.lex_state = 349, .external_lex_state = 4},
  [14107] = {.lex_state = 384},
  [14108] = {.lex_state = 384},
  [14109] = {.lex_state = 384},
  [14110] = {.lex_state = 349, .external_lex_state = 4},
  [14111] = {.lex_state = 384},
  [14112] = {.lex_state = 384},
  [14113] = {.lex_state = 349, .external_lex_state = 4},
  [14114] = {.lex_state = 349, .external_lex_state = 4},
  [14115] = {.lex_state = 349, .external_lex_state = 4},
  [14116] = {.lex_state = 349, .external_lex_state = 4},
  [14117] = {.lex_state = 384},
  [14118] = {.lex_state = 349, .external_lex_state = 4},
  [14119] = {.lex_state = 349, .external_lex_state = 4},
  [14120] = {.lex_state = 349, .external_lex_state = 4},
  [14121] = {.lex_state = 349, .external_lex_state = 4},
  [14122] = {.lex_state = 384},
  [14123] = {.lex_state = 384},
  [14124] = {.lex_state = 349, .external_lex_state = 4},
  [14125] = {.lex_state = 384},
  [14126] = {.lex_state = 349, .external_lex_state = 4},
  [14127] = {.lex_state = 349, .external_lex_state = 4},
  [14128] = {.lex_state = 384},
  [14129] = {.lex_state = 349, .external_lex_state = 4},
  [14130] = {.lex_state = 349, .external_lex_state = 4},
  [14131] = {.lex_state = 384},
  [14132] = {.lex_state = 349, .external_lex_state = 4},
  [14133] = {.lex_state = 384},
  [14134] = {.lex_state = 349, .external_lex_state = 4},
  [14135] = {.lex_state = 384},
  [14136] = {.lex_state = 384},
  [14137] = {.lex_state = 349, .external_lex_state = 4},
  [14138] = {.lex_state = 349, .external_lex_state = 4},
  [14139] = {.lex_state = 349, .external_lex_state = 4},
  [14140] = {.lex_state = 349, .external_lex_state = 4},
  [14141] = {.lex_state = 349, .external_lex_state = 4},
  [14142] = {.lex_state = 349, .external_lex_state = 4},
  [14143] = {.lex_state = 384},
  [14144] = {.lex_state = 384},
  [14145] = {.lex_state = 384},
  [14146] = {.lex_state = 349, .external_lex_state = 4},
  [14147] = {.lex_state = 384},
  [14148] = {.lex_state = 349, .external_lex_state = 4},
  [14149] = {.lex_state = 384},
  [14150] = {.lex_state = 349, .external_lex_state = 4},
  [14151] = {.lex_state = 349, .external_lex_state = 4},
  [14152] = {.lex_state = 349, .external_lex_state = 4},
  [14153] = {.lex_state = 349, .external_lex_state = 4},
  [14154] = {.lex_state = 349, .external_lex_state = 4},
  [14155] = {.lex_state = 349, .external_lex_state = 4},
  [14156] = {.lex_state = 349, .external_lex_state = 4},
  [14157] = {.lex_state = 349, .external_lex_state = 4},
  [14158] = {.lex_state = 349, .external_lex_state = 4},
  [14159] = {.lex_state = 384},
  [14160] = {.lex_state = 384},
  [14161] = {.lex_state = 349, .external_lex_state = 4},
  [14162] = {.lex_state = 349, .external_lex_state = 4},
  [14163] = {.lex_state = 349, .external_lex_state = 4},
  [14164] = {.lex_state = 349, .external_lex_state = 4},
  [14165] = {.lex_state = 349, .external_lex_state = 4},
  [14166] = {.lex_state = 349, .external_lex_state = 4},
  [14167] = {.lex_state = 384},
  [14168] = {.lex_state = 349, .external_lex_state = 4},
  [14169] = {.lex_state = 349, .external_lex_state = 4},
  [14170] = {.lex_state = 384},
  [14171] = {.lex_state = 349, .external_lex_state = 4},
  [14172] = {.lex_state = 349, .external_lex_state = 4},
  [14173] = {.lex_state = 384},
  [14174] = {.lex_state = 349, .external_lex_state = 4},
  [14175] = {.lex_state = 349, .external_lex_state = 4},
  [14176] = {.lex_state = 384},
  [14177] = {.lex_state = 349, .external_lex_state = 4},
  [14178] = {.lex_state = 349, .external_lex_state = 4},
  [14179] = {.lex_state = 349, .external_lex_state = 4},
  [14180] = {.lex_state = 349, .external_lex_state = 4},
  [14181] = {.lex_state = 349, .external_lex_state = 4},
  [14182] = {.lex_state = 349, .external_lex_state = 4},
  [14183] = {.lex_state = 349, .external_lex_state = 4},
  [14184] = {.lex_state = 384},
  [14185] = {.lex_state = 349, .external_lex_state = 4},
  [14186] = {.lex_state = 384},
  [14187] = {.lex_state = 384},
  [14188] = {.lex_state = 349, .external_lex_state = 4},
  [14189] = {.lex_state = 349, .external_lex_state = 4},
  [14190] = {.lex_state = 384},
  [14191] = {.lex_state = 384},
  [14192] = {.lex_state = 349, .external_lex_state = 4},
  [14193] = {.lex_state = 384},
  [14194] = {.lex_state = 349, .external_lex_state = 4},
  [14195] = {.lex_state = 349, .external_lex_state = 4},
  [14196] = {.lex_state = 349, .external_lex_state = 4},
  [14197] = {.lex_state = 349, .external_lex_state = 4},
  [14198] = {.lex_state = 349, .external_lex_state = 4},
  [14199] = {.lex_state = 349, .external_lex_state = 4},
  [14200] = {.lex_state = 349, .external_lex_state = 4},
  [14201] = {.lex_state = 349, .external_lex_state = 4},
  [14202] = {.lex_state = 349, .external_lex_state = 4},
  [14203] = {.lex_state = 349, .external_lex_state = 4},
  [14204] = {.lex_state = 349, .external_lex_state = 4},
  [14205] = {.lex_state = 349, .external_lex_state = 4},
  [14206] = {.lex_state = 384},
  [14207] = {.lex_state = 384},
  [14208] = {.lex_state = 349, .external_lex_state = 4},
  [14209] = {.lex_state = 384},
  [14210] = {.lex_state = 384},
  [14211] = {.lex_state = 349, .external_lex_state = 4},
  [14212] = {.lex_state = 349, .external_lex_state = 4},
  [14213] = {.lex_state = 384},
  [14214] = {.lex_state = 384},
  [14215] = {.lex_state = 349, .external_lex_state = 4},
  [14216] = {.lex_state = 349, .external_lex_state = 4},
  [14217] = {.lex_state = 349, .external_lex_state = 4},
  [14218] = {.lex_state = 384},
  [14219] = {.lex_state = 349, .external_lex_state = 4},
  [14220] = {.lex_state = 349, .external_lex_state = 4},
  [14221] = {.lex_state = 349, .external_lex_state = 4},
  [14222] = {.lex_state = 349, .external_lex_state = 4},
  [14223] = {.lex_state = 349, .external_lex_state = 4},
  [14224] = {.lex_state = 349, .external_lex_state = 4},
  [14225] = {.lex_state = 349, .external_lex_state = 4},
  [14226] = {.lex_state = 349, .external_lex_state = 4},
  [14227] = {.lex_state = 349, .external_lex_state = 4},
  [14228] = {.lex_state = 384},
  [14229] = {.lex_state = 384},
  [14230] = {.lex_state = 349, .external_lex_state = 4},
  [14231] = {.lex_state = 349, .external_lex_state = 4},
  [14232] = {.lex_state = 349, .external_lex_state = 4},
  [14233] = {.lex_state = 349, .external_lex_state = 4},
  [14234] = {.lex_state = 349, .external_lex_state = 4},
  [14235] = {.lex_state = 349, .external_lex_state = 4},
  [14236] = {.lex_state = 349, .external_lex_state = 4},
  [14237] = {.lex_state = 384, .external_lex_state = 4},
  [14238] = {.lex_state = 384},
  [14239] = {.lex_state = 384},
  [14240] = {.lex_state = 384},
  [14241] = {.lex_state = 384},
  [14242] = {.lex_state = 384},
  [14243] = {.lex_state = 384},
  [14244] = {.lex_state = 384},
  [14245] = {.lex_state = 562},
  [14246] = {.lex_state = 363},
  [14247] = {.lex_state = 363},
  [14248] = {.lex_state = 363},
  [14249] = {.lex_state = 363},
  [14250] = {.lex_state = 363},
  [14251] = {.lex_state = 363},
  [14252] = {.lex_state = 539},
  [14253] = {.lex_state = 235},
  [14254] = {.lex_state = 363},
  [14255] = {.lex_state = 562},
  [14256] = {.lex_state = 363},
  [14257] = {.lex_state = 363},
  [14258] = {.lex_state = 363},
  [14259] = {.lex_state = 363},
  [14260] = {.lex_state = 363},
  [14261] = {.lex_state = 363},
  [14262] = {.lex_state = 363},
  [14263] = {.lex_state = 235},
  [14264] = {.lex_state = 363},
  [14265] = {.lex_state = 363},
  [14266] = {.lex_state = 235},
  [14267] = {.lex_state = 562},
  [14268] = {.lex_state = 363},
  [14269] = {.lex_state = 363},
  [14270] = {.lex_state = 363},
  [14271] = {.lex_state = 363},
  [14272] = {.lex_state = 562},
  [14273] = {.lex_state = 363},
  [14274] = {.lex_state = 562},
  [14275] = {.lex_state = 363},
  [14276] = {.lex_state = 562},
  [14277] = {.lex_state = 562},
  [14278] = {.lex_state = 562},
  [14279] = {.lex_state = 562},
  [14280] = {.lex_state = 363},
  [14281] = {.lex_state = 363},
  [14282] = {.lex_state = 424, .external_lex_state = 6},
  [14283] = {.lex_state = 424, .external_lex_state = 7},
  [14284] = {.lex_state = 424, .external_lex_state = 8},
  [14285] = {.lex_state = 424, .external_lex_state = 9},
  [14286] = {.lex_state = 363},
  [14287] = {.lex_state = 363},
  [14288] = {.lex_state = 363},
  [14289] = {.lex_state = 363},
  [14290] = {.lex_state = 363},
  [14291] = {.lex_state = 349},
  [14292] = {.lex_state = 424, .external_lex_state = 7},
  [14293] = {.lex_state = 424, .external_lex_state = 8},
  [14294] = {.lex_state = 424, .external_lex_state = 9},
  [14295] = {.lex_state = 349},
  [14296] = {.lex_state = 424, .external_lex_state = 7},
  [14297] = {.lex_state = 424, .external_lex_state = 6},
  [14298] = {.lex_state = 424, .external_lex_state = 7},
  [14299] = {.lex_state = 424, .external_lex_state = 6},
  [14300] = {.lex_state = 424, .external_lex_state = 7},
  [14301] = {.lex_state = 424, .external_lex_state = 8},
  [14302] = {.lex_state = 424, .external_lex_state = 9},
  [14303] = {.lex_state = 363},
  [14304] = {.lex_state = 363},
  [14305] = {.lex_state = 424, .external_lex_state = 7},
  [14306] = {.lex_state = 424, .external_lex_state = 8},
  [14307] = {.lex_state = 424, .external_lex_state = 8},
  [14308] = {.lex_state = 424, .external_lex_state = 9},
  [14309] = {.lex_state = 235},
  [14310] = {.lex_state = 363},
  [14311] = {.lex_state = 424, .external_lex_state = 9},
  [14312] = {.lex_state = 363},
  [14313] = {.lex_state = 363},
  [14314] = {.lex_state = 363},
  [14315] = {.lex_state = 363},
  [14316] = {.lex_state = 424, .external_lex_state = 7},
  [14317] = {.lex_state = 424, .external_lex_state = 7},
  [14318] = {.lex_state = 424, .external_lex_state = 8},
  [14319] = {.lex_state = 424, .external_lex_state = 6},
  [14320] = {.lex_state = 424, .external_lex_state = 7},
  [14321] = {.lex_state = 424, .external_lex_state = 8},
  [14322] = {.lex_state = 424, .external_lex_state = 9},
  [14323] = {.lex_state = 349},
  [14324] = {.lex_state = 363},
  [14325] = {.lex_state = 424, .external_lex_state = 6},
  [14326] = {.lex_state = 424, .external_lex_state = 7},
  [14327] = {.lex_state = 424, .external_lex_state = 8},
  [14328] = {.lex_state = 363},
  [14329] = {.lex_state = 424, .external_lex_state = 9},
  [14330] = {.lex_state = 363},
  [14331] = {.lex_state = 363},
  [14332] = {.lex_state = 363},
  [14333] = {.lex_state = 363},
  [14334] = {.lex_state = 424, .external_lex_state = 8},
  [14335] = {.lex_state = 363},
  [14336] = {.lex_state = 424, .external_lex_state = 9},
  [14337] = {.lex_state = 363},
  [14338] = {.lex_state = 363},
  [14339] = {.lex_state = 363},
  [14340] = {.lex_state = 424, .external_lex_state = 6},
  [14341] = {.lex_state = 424, .external_lex_state = 7},
  [14342] = {.lex_state = 424, .external_lex_state = 8},
  [14343] = {.lex_state = 424, .external_lex_state = 9},
  [14344] = {.lex_state = 363},
  [14345] = {.lex_state = 424, .external_lex_state = 6},
  [14346] = {.lex_state = 424, .external_lex_state = 7},
  [14347] = {.lex_state = 424, .external_lex_state = 8},
  [14348] = {.lex_state = 424, .external_lex_state = 9},
  [14349] = {.lex_state = 363},
  [14350] = {.lex_state = 363},
  [14351] = {.lex_state = 424, .external_lex_state = 8},
  [14352] = {.lex_state = 363},
  [14353] = {.lex_state = 363},
  [14354] = {.lex_state = 363},
  [14355] = {.lex_state = 424, .external_lex_state = 9},
  [14356] = {.lex_state = 424, .external_lex_state = 6},
  [14357] = {.lex_state = 424, .external_lex_state = 7},
  [14358] = {.lex_state = 424, .external_lex_state = 8},
  [14359] = {.lex_state = 363},
  [14360] = {.lex_state = 424, .external_lex_state = 9},
  [14361] = {.lex_state = 424, .external_lex_state = 6},
  [14362] = {.lex_state = 424, .external_lex_state = 7},
  [14363] = {.lex_state = 363},
  [14364] = {.lex_state = 424, .external_lex_state = 8},
  [14365] = {.lex_state = 424, .external_lex_state = 6},
  [14366] = {.lex_state = 424, .external_lex_state = 7},
  [14367] = {.lex_state = 424, .external_lex_state = 8},
  [14368] = {.lex_state = 424, .external_lex_state = 9},
  [14369] = {.lex_state = 363},
  [14370] = {.lex_state = 363},
  [14371] = {.lex_state = 424, .external_lex_state = 9},
  [14372] = {.lex_state = 363},
  [14373] = {.lex_state = 424, .external_lex_state = 6},
  [14374] = {.lex_state = 424, .external_lex_state = 6},
  [14375] = {.lex_state = 424, .external_lex_state = 7},
  [14376] = {.lex_state = 424, .external_lex_state = 8},
  [14377] = {.lex_state = 424, .external_lex_state = 9},
  [14378] = {.lex_state = 349},
  [14379] = {.lex_state = 363},
  [14380] = {.lex_state = 363},
  [14381] = {.lex_state = 363},
  [14382] = {.lex_state = 424, .external_lex_state = 6},
  [14383] = {.lex_state = 424, .external_lex_state = 7},
  [14384] = {.lex_state = 424, .external_lex_state = 7},
  [14385] = {.lex_state = 424, .external_lex_state = 8},
  [14386] = {.lex_state = 424, .external_lex_state = 9},
  [14387] = {.lex_state = 424, .external_lex_state = 6},
  [14388] = {.lex_state = 424, .external_lex_state = 7},
  [14389] = {.lex_state = 424, .external_lex_state = 8},
  [14390] = {.lex_state = 424, .external_lex_state = 9},
  [14391] = {.lex_state = 349},
  [14392] = {.lex_state = 424, .external_lex_state = 6},
  [14393] = {.lex_state = 424, .external_lex_state = 7},
  [14394] = {.lex_state = 424, .external_lex_state = 8},
  [14395] = {.lex_state = 424, .external_lex_state = 9},
  [14396] = {.lex_state = 363},
  [14397] = {.lex_state = 363},
  [14398] = {.lex_state = 363},
  [14399] = {.lex_state = 363},
  [14400] = {.lex_state = 363},
  [14401] = {.lex_state = 424, .external_lex_state = 8},
  [14402] = {.lex_state = 424, .external_lex_state = 6},
  [14403] = {.lex_state = 424, .external_lex_state = 9},
  [14404] = {.lex_state = 424, .external_lex_state = 6},
  [14405] = {.lex_state = 363},
  [14406] = {.lex_state = 562},
  [14407] = {.lex_state = 424, .external_lex_state = 6},
  [14408] = {.lex_state = 424, .external_lex_state = 7},
  [14409] = {.lex_state = 424, .external_lex_state = 8},
  [14410] = {.lex_state = 424, .external_lex_state = 6},
  [14411] = {.lex_state = 424, .external_lex_state = 7},
  [14412] = {.lex_state = 424, .external_lex_state = 8},
  [14413] = {.lex_state = 424, .external_lex_state = 9},
  [14414] = {.lex_state = 424, .external_lex_state = 9},
  [14415] = {.lex_state = 424, .external_lex_state = 7},
  [14416] = {.lex_state = 363},
  [14417] = {.lex_state = 424, .external_lex_state = 6},
  [14418] = {.lex_state = 424, .external_lex_state = 7},
  [14419] = {.lex_state = 562},
  [14420] = {.lex_state = 424, .external_lex_state = 8},
  [14421] = {.lex_state = 424, .external_lex_state = 9},
  [14422] = {.lex_state = 424, .external_lex_state = 6},
  [14423] = {.lex_state = 424, .external_lex_state = 7},
  [14424] = {.lex_state = 363},
  [14425] = {.lex_state = 363},
  [14426] = {.lex_state = 424, .external_lex_state = 6},
  [14427] = {.lex_state = 424, .external_lex_state = 7},
  [14428] = {.lex_state = 424, .external_lex_state = 8},
  [14429] = {.lex_state = 424, .external_lex_state = 9},
  [14430] = {.lex_state = 424, .external_lex_state = 8},
  [14431] = {.lex_state = 363},
  [14432] = {.lex_state = 363},
  [14433] = {.lex_state = 424, .external_lex_state = 9},
  [14434] = {.lex_state = 363},
  [14435] = {.lex_state = 424, .external_lex_state = 8},
  [14436] = {.lex_state = 424, .external_lex_state = 9},
  [14437] = {.lex_state = 363},
  [14438] = {.lex_state = 349},
  [14439] = {.lex_state = 349},
  [14440] = {.lex_state = 363},
  [14441] = {.lex_state = 424, .external_lex_state = 7},
  [14442] = {.lex_state = 424, .external_lex_state = 6},
  [14443] = {.lex_state = 424, .external_lex_state = 7},
  [14444] = {.lex_state = 424, .external_lex_state = 6},
  [14445] = {.lex_state = 424, .external_lex_state = 8},
  [14446] = {.lex_state = 424, .external_lex_state = 9},
  [14447] = {.lex_state = 424, .external_lex_state = 7},
  [14448] = {.lex_state = 424, .external_lex_state = 8},
  [14449] = {.lex_state = 424, .external_lex_state = 9},
  [14450] = {.lex_state = 363},
  [14451] = {.lex_state = 363},
  [14452] = {.lex_state = 363},
  [14453] = {.lex_state = 363},
  [14454] = {.lex_state = 363},
  [14455] = {.lex_state = 363},
  [14456] = {.lex_state = 424, .external_lex_state = 6},
  [14457] = {.lex_state = 363},
  [14458] = {.lex_state = 424, .external_lex_state = 7},
  [14459] = {.lex_state = 424, .external_lex_state = 8},
  [14460] = {.lex_state = 349},
  [14461] = {.lex_state = 349},
  [14462] = {.lex_state = 363},
  [14463] = {.lex_state = 424, .external_lex_state = 9},
  [14464] = {.lex_state = 363},
  [14465] = {.lex_state = 363},
  [14466] = {.lex_state = 165},
  [14467] = {.lex_state = 363},
  [14468] = {.lex_state = 363},
  [14469] = {.lex_state = 363},
  [14470] = {.lex_state = 363},
  [14471] = {.lex_state = 349},
  [14472] = {.lex_state = 363},
  [14473] = {.lex_state = 424, .external_lex_state = 6},
  [14474] = {.lex_state = 363},
  [14475] = {.lex_state = 363},
  [14476] = {.lex_state = 424, .external_lex_state = 7},
  [14477] = {.lex_state = 363},
  [14478] = {.lex_state = 424, .external_lex_state = 8},
  [14479] = {.lex_state = 424, .external_lex_state = 9},
  [14480] = {.lex_state = 424, .external_lex_state = 8},
  [14481] = {.lex_state = 424, .external_lex_state = 9},
  [14482] = {.lex_state = 363},
  [14483] = {.lex_state = 363},
  [14484] = {.lex_state = 424, .external_lex_state = 6},
  [14485] = {.lex_state = 363},
  [14486] = {.lex_state = 363},
  [14487] = {.lex_state = 424, .external_lex_state = 6},
  [14488] = {.lex_state = 424, .external_lex_state = 7},
  [14489] = {.lex_state = 424, .external_lex_state = 8},
  [14490] = {.lex_state = 424, .external_lex_state = 9},
  [14491] = {.lex_state = 363},
  [14492] = {.lex_state = 363},
  [14493] = {.lex_state = 424, .external_lex_state = 6},
  [14494] = {.lex_state = 424, .external_lex_state = 7},
  [14495] = {.lex_state = 363},
  [14496] = {.lex_state = 424, .external_lex_state = 6},
  [14497] = {.lex_state = 424, .external_lex_state = 8},
  [14498] = {.lex_state = 424, .external_lex_state = 7},
  [14499] = {.lex_state = 424, .external_lex_state = 9},
  [14500] = {.lex_state = 424, .external_lex_state = 8},
  [14501] = {.lex_state = 424, .external_lex_state = 9},
  [14502] = {.lex_state = 363},
  [14503] = {.lex_state = 363},
  [14504] = {.lex_state = 424, .external_lex_state = 9},
  [14505] = {.lex_state = 424, .external_lex_state = 6},
  [14506] = {.lex_state = 349},
  [14507] = {.lex_state = 424, .external_lex_state = 7},
  [14508] = {.lex_state = 363},
  [14509] = {.lex_state = 349},
  [14510] = {.lex_state = 363},
  [14511] = {.lex_state = 363},
  [14512] = {.lex_state = 424, .external_lex_state = 8},
  [14513] = {.lex_state = 424, .external_lex_state = 8},
  [14514] = {.lex_state = 424, .external_lex_state = 6},
  [14515] = {.lex_state = 424, .external_lex_state = 7},
  [14516] = {.lex_state = 424, .external_lex_state = 8},
  [14517] = {.lex_state = 424, .external_lex_state = 9},
  [14518] = {.lex_state = 424, .external_lex_state = 9},
  [14519] = {.lex_state = 363},
  [14520] = {.lex_state = 424, .external_lex_state = 6},
  [14521] = {.lex_state = 424, .external_lex_state = 7},
  [14522] = {.lex_state = 363},
  [14523] = {.lex_state = 424, .external_lex_state = 8},
  [14524] = {.lex_state = 424, .external_lex_state = 9},
  [14525] = {.lex_state = 349},
  [14526] = {.lex_state = 363},
  [14527] = {.lex_state = 363},
  [14528] = {.lex_state = 363},
  [14529] = {.lex_state = 424, .external_lex_state = 6},
  [14530] = {.lex_state = 424, .external_lex_state = 7},
  [14531] = {.lex_state = 562},
  [14532] = {.lex_state = 363},
  [14533] = {.lex_state = 424, .external_lex_state = 8},
  [14534] = {.lex_state = 424, .external_lex_state = 6},
  [14535] = {.lex_state = 424, .external_lex_state = 7},
  [14536] = {.lex_state = 424, .external_lex_state = 8},
  [14537] = {.lex_state = 424, .external_lex_state = 9},
  [14538] = {.lex_state = 424, .external_lex_state = 9},
  [14539] = {.lex_state = 363},
  [14540] = {.lex_state = 363},
  [14541] = {.lex_state = 363},
  [14542] = {.lex_state = 424, .external_lex_state = 7},
  [14543] = {.lex_state = 363},
  [14544] = {.lex_state = 363},
  [14545] = {.lex_state = 424, .external_lex_state = 6},
  [14546] = {.lex_state = 424, .external_lex_state = 7},
  [14547] = {.lex_state = 349},
  [14548] = {.lex_state = 363},
  [14549] = {.lex_state = 424, .external_lex_state = 8},
  [14550] = {.lex_state = 424, .external_lex_state = 9},
  [14551] = {.lex_state = 424, .external_lex_state = 8},
  [14552] = {.lex_state = 424, .external_lex_state = 9},
  [14553] = {.lex_state = 424, .external_lex_state = 2},
  [14554] = {.lex_state = 424, .external_lex_state = 6},
  [14555] = {.lex_state = 424, .external_lex_state = 7},
  [14556] = {.lex_state = 424, .external_lex_state = 8},
  [14557] = {.lex_state = 424, .external_lex_state = 9},
  [14558] = {.lex_state = 424, .external_lex_state = 9},
  [14559] = {.lex_state = 363},
  [14560] = {.lex_state = 363},
  [14561] = {.lex_state = 424, .external_lex_state = 6},
  [14562] = {.lex_state = 424, .external_lex_state = 7},
  [14563] = {.lex_state = 424, .external_lex_state = 8},
  [14564] = {.lex_state = 424, .external_lex_state = 9},
  [14565] = {.lex_state = 363},
  [14566] = {.lex_state = 363},
  [14567] = {.lex_state = 363},
  [14568] = {.lex_state = 363},
  [14569] = {.lex_state = 363},
  [14570] = {.lex_state = 363},
  [14571] = {.lex_state = 363},
  [14572] = {.lex_state = 424, .external_lex_state = 6},
  [14573] = {.lex_state = 424, .external_lex_state = 7},
  [14574] = {.lex_state = 424, .external_lex_state = 8},
  [14575] = {.lex_state = 424, .external_lex_state = 6},
  [14576] = {.lex_state = 424, .external_lex_state = 9},
  [14577] = {.lex_state = 363},
  [14578] = {.lex_state = 424, .external_lex_state = 7},
  [14579] = {.lex_state = 363},
  [14580] = {.lex_state = 349},
  [14581] = {.lex_state = 424, .external_lex_state = 6},
  [14582] = {.lex_state = 424, .external_lex_state = 8},
  [14583] = {.lex_state = 424, .external_lex_state = 9},
  [14584] = {.lex_state = 424, .external_lex_state = 6},
  [14585] = {.lex_state = 424, .external_lex_state = 7},
  [14586] = {.lex_state = 424, .external_lex_state = 6},
  [14587] = {.lex_state = 424, .external_lex_state = 7},
  [14588] = {.lex_state = 424, .external_lex_state = 8},
  [14589] = {.lex_state = 424, .external_lex_state = 8},
  [14590] = {.lex_state = 424, .external_lex_state = 9},
  [14591] = {.lex_state = 363},
  [14592] = {.lex_state = 363},
  [14593] = {.lex_state = 424, .external_lex_state = 9},
  [14594] = {.lex_state = 363},
  [14595] = {.lex_state = 363},
  [14596] = {.lex_state = 349},
  [14597] = {.lex_state = 424, .external_lex_state = 6},
  [14598] = {.lex_state = 363},
  [14599] = {.lex_state = 424, .external_lex_state = 7},
  [14600] = {.lex_state = 424, .external_lex_state = 8},
  [14601] = {.lex_state = 424, .external_lex_state = 9},
  [14602] = {.lex_state = 424, .external_lex_state = 7},
  [14603] = {.lex_state = 424, .external_lex_state = 6},
  [14604] = {.lex_state = 424, .external_lex_state = 2},
  [14605] = {.lex_state = 562},
  [14606] = {.lex_state = 424, .external_lex_state = 2},
  [14607] = {.lex_state = 424, .external_lex_state = 6},
  [14608] = {.lex_state = 424, .external_lex_state = 6},
  [14609] = {.lex_state = 424, .external_lex_state = 7},
  [14610] = {.lex_state = 424, .external_lex_state = 8},
  [14611] = {.lex_state = 424, .external_lex_state = 9},
  [14612] = {.lex_state = 424, .external_lex_state = 6},
  [14613] = {.lex_state = 424, .external_lex_state = 7},
  [14614] = {.lex_state = 424, .external_lex_state = 7},
  [14615] = {.lex_state = 424, .external_lex_state = 8},
  [14616] = {.lex_state = 363},
  [14617] = {.lex_state = 424, .external_lex_state = 9},
  [14618] = {.lex_state = 424, .external_lex_state = 7},
  [14619] = {.lex_state = 424, .external_lex_state = 8},
  [14620] = {.lex_state = 424, .external_lex_state = 8},
  [14621] = {.lex_state = 424, .external_lex_state = 8},
  [14622] = {.lex_state = 424, .external_lex_state = 9},
  [14623] = {.lex_state = 424, .external_lex_state = 9},
  [14624] = {.lex_state = 363},
  [14625] = {.lex_state = 424, .external_lex_state = 6},
  [14626] = {.lex_state = 424, .external_lex_state = 6},
  [14627] = {.lex_state = 424, .external_lex_state = 7},
  [14628] = {.lex_state = 424, .external_lex_state = 8},
  [14629] = {.lex_state = 363},
  [14630] = {.lex_state = 424, .external_lex_state = 9},
  [14631] = {.lex_state = 424, .external_lex_state = 7},
  [14632] = {.lex_state = 424, .external_lex_state = 6},
  [14633] = {.lex_state = 424, .external_lex_state = 7},
  [14634] = {.lex_state = 363},
  [14635] = {.lex_state = 363},
  [14636] = {.lex_state = 349},
  [14637] = {.lex_state = 424, .external_lex_state = 8},
  [14638] = {.lex_state = 424, .external_lex_state = 9},
  [14639] = {.lex_state = 363},
  [14640] = {.lex_state = 363},
  [14641] = {.lex_state = 424, .external_lex_state = 8},
  [14642] = {.lex_state = 424, .external_lex_state = 9},
  [14643] = {.lex_state = 363},
  [14644] = {.lex_state = 363},
  [14645] = {.lex_state = 424, .external_lex_state = 9},
  [14646] = {.lex_state = 363},
  [14647] = {.lex_state = 349},
  [14648] = {.lex_state = 363},
  [14649] = {.lex_state = 424, .external_lex_state = 6},
  [14650] = {.lex_state = 363},
  [14651] = {.lex_state = 424, .external_lex_state = 7},
  [14652] = {.lex_state = 424, .external_lex_state = 8},
  [14653] = {.lex_state = 424, .external_lex_state = 9},
  [14654] = {.lex_state = 424, .external_lex_state = 6},
  [14655] = {.lex_state = 363},
  [14656] = {.lex_state = 424, .external_lex_state = 7},
  [14657] = {.lex_state = 424, .external_lex_state = 8},
  [14658] = {.lex_state = 424, .external_lex_state = 9},
  [14659] = {.lex_state = 424, .external_lex_state = 8},
  [14660] = {.lex_state = 424, .external_lex_state = 6},
  [14661] = {.lex_state = 424, .external_lex_state = 3},
  [14662] = {.lex_state = 424, .external_lex_state = 7},
  [14663] = {.lex_state = 424, .external_lex_state = 8},
  [14664] = {.lex_state = 424, .external_lex_state = 9},
  [14665] = {.lex_state = 562},
  [14666] = {.lex_state = 363},
  [14667] = {.lex_state = 363},
  [14668] = {.lex_state = 363},
  [14669] = {.lex_state = 424, .external_lex_state = 6},
  [14670] = {.lex_state = 424, .external_lex_state = 3},
  [14671] = {.lex_state = 424, .external_lex_state = 7},
  [14672] = {.lex_state = 424, .external_lex_state = 6},
  [14673] = {.lex_state = 424, .external_lex_state = 7},
  [14674] = {.lex_state = 424, .external_lex_state = 8},
  [14675] = {.lex_state = 424, .external_lex_state = 8},
  [14676] = {.lex_state = 424, .external_lex_state = 9},
  [14677] = {.lex_state = 424, .external_lex_state = 9},
  [14678] = {.lex_state = 349},
  [14679] = {.lex_state = 363},
  [14680] = {.lex_state = 363},
  [14681] = {.lex_state = 363},
  [14682] = {.lex_state = 424, .external_lex_state = 9},
  [14683] = {.lex_state = 363},
  [14684] = {.lex_state = 363},
  [14685] = {.lex_state = 363},
  [14686] = {.lex_state = 363},
  [14687] = {.lex_state = 424, .external_lex_state = 6},
  [14688] = {.lex_state = 424, .external_lex_state = 7},
  [14689] = {.lex_state = 424, .external_lex_state = 8},
  [14690] = {.lex_state = 424, .external_lex_state = 9},
  [14691] = {.lex_state = 424, .external_lex_state = 6},
  [14692] = {.lex_state = 424, .external_lex_state = 7},
  [14693] = {.lex_state = 424, .external_lex_state = 8},
  [14694] = {.lex_state = 363},
  [14695] = {.lex_state = 424, .external_lex_state = 6},
  [14696] = {.lex_state = 424, .external_lex_state = 7},
  [14697] = {.lex_state = 363},
  [14698] = {.lex_state = 424, .external_lex_state = 8},
  [14699] = {.lex_state = 349},
  [14700] = {.lex_state = 363},
  [14701] = {.lex_state = 424, .external_lex_state = 6},
  [14702] = {.lex_state = 363},
  [14703] = {.lex_state = 363},
  [14704] = {.lex_state = 363},
  [14705] = {.lex_state = 424, .external_lex_state = 9},
  [14706] = {.lex_state = 363},
  [14707] = {.lex_state = 363},
  [14708] = {.lex_state = 424, .external_lex_state = 6},
  [14709] = {.lex_state = 349},
  [14710] = {.lex_state = 363},
  [14711] = {.lex_state = 363},
  [14712] = {.lex_state = 363},
  [14713] = {.lex_state = 363},
  [14714] = {.lex_state = 424, .external_lex_state = 6},
  [14715] = {.lex_state = 349},
  [14716] = {.lex_state = 424, .external_lex_state = 7},
  [14717] = {.lex_state = 363},
  [14718] = {.lex_state = 424, .external_lex_state = 7},
  [14719] = {.lex_state = 424, .external_lex_state = 8},
  [14720] = {.lex_state = 424, .external_lex_state = 9},
  [14721] = {.lex_state = 363},
  [14722] = {.lex_state = 349},
  [14723] = {.lex_state = 424, .external_lex_state = 3},
  [14724] = {.lex_state = 363},
  [14725] = {.lex_state = 424, .external_lex_state = 6},
  [14726] = {.lex_state = 424, .external_lex_state = 7},
  [14727] = {.lex_state = 424, .external_lex_state = 8},
  [14728] = {.lex_state = 424, .external_lex_state = 9},
  [14729] = {.lex_state = 363},
  [14730] = {.lex_state = 363},
  [14731] = {.lex_state = 363},
  [14732] = {.lex_state = 363},
  [14733] = {.lex_state = 562},
  [14734] = {.lex_state = 424, .external_lex_state = 6},
  [14735] = {.lex_state = 424, .external_lex_state = 7},
  [14736] = {.lex_state = 363},
  [14737] = {.lex_state = 349},
  [14738] = {.lex_state = 424, .external_lex_state = 6},
  [14739] = {.lex_state = 424, .external_lex_state = 7},
  [14740] = {.lex_state = 349},
  [14741] = {.lex_state = 424, .external_lex_state = 8},
  [14742] = {.lex_state = 363},
  [14743] = {.lex_state = 424, .external_lex_state = 9},
  [14744] = {.lex_state = 424, .external_lex_state = 8},
  [14745] = {.lex_state = 424, .external_lex_state = 3},
  [14746] = {.lex_state = 424, .external_lex_state = 8},
  [14747] = {.lex_state = 424, .external_lex_state = 9},
  [14748] = {.lex_state = 424, .external_lex_state = 9},
  [14749] = {.lex_state = 424, .external_lex_state = 6},
  [14750] = {.lex_state = 424, .external_lex_state = 7},
  [14751] = {.lex_state = 424, .external_lex_state = 8},
  [14752] = {.lex_state = 424, .external_lex_state = 9},
  [14753] = {.lex_state = 363},
  [14754] = {.lex_state = 363},
  [14755] = {.lex_state = 424, .external_lex_state = 6},
  [14756] = {.lex_state = 424, .external_lex_state = 6},
  [14757] = {.lex_state = 424, .external_lex_state = 6},
  [14758] = {.lex_state = 424, .external_lex_state = 7},
  [14759] = {.lex_state = 424, .external_lex_state = 7},
  [14760] = {.lex_state = 424, .external_lex_state = 8},
  [14761] = {.lex_state = 363},
  [14762] = {.lex_state = 424, .external_lex_state = 8},
  [14763] = {.lex_state = 424, .external_lex_state = 9},
  [14764] = {.lex_state = 424, .external_lex_state = 6},
  [14765] = {.lex_state = 424, .external_lex_state = 7},
  [14766] = {.lex_state = 424, .external_lex_state = 7},
  [14767] = {.lex_state = 424, .external_lex_state = 8},
  [14768] = {.lex_state = 424, .external_lex_state = 9},
  [14769] = {.lex_state = 424, .external_lex_state = 6},
  [14770] = {.lex_state = 424, .external_lex_state = 7},
  [14771] = {.lex_state = 424, .external_lex_state = 6},
  [14772] = {.lex_state = 424, .external_lex_state = 7},
  [14773] = {.lex_state = 424, .external_lex_state = 6},
  [14774] = {.lex_state = 424, .external_lex_state = 8},
  [14775] = {.lex_state = 424, .external_lex_state = 9},
  [14776] = {.lex_state = 424, .external_lex_state = 8},
  [14777] = {.lex_state = 363},
  [14778] = {.lex_state = 424, .external_lex_state = 6},
  [14779] = {.lex_state = 424, .external_lex_state = 6},
  [14780] = {.lex_state = 424, .external_lex_state = 7},
  [14781] = {.lex_state = 424, .external_lex_state = 8},
  [14782] = {.lex_state = 424, .external_lex_state = 9},
  [14783] = {.lex_state = 363},
  [14784] = {.lex_state = 424, .external_lex_state = 7},
  [14785] = {.lex_state = 424, .external_lex_state = 8},
  [14786] = {.lex_state = 424, .external_lex_state = 9},
  [14787] = {.lex_state = 363},
  [14788] = {.lex_state = 424, .external_lex_state = 9},
  [14789] = {.lex_state = 363},
  [14790] = {.lex_state = 363},
  [14791] = {.lex_state = 424, .external_lex_state = 6},
  [14792] = {.lex_state = 424, .external_lex_state = 6},
  [14793] = {.lex_state = 424, .external_lex_state = 7},
  [14794] = {.lex_state = 424, .external_lex_state = 7},
  [14795] = {.lex_state = 424, .external_lex_state = 8},
  [14796] = {.lex_state = 424, .external_lex_state = 7},
  [14797] = {.lex_state = 424, .external_lex_state = 8},
  [14798] = {.lex_state = 424, .external_lex_state = 8},
  [14799] = {.lex_state = 424, .external_lex_state = 9},
  [14800] = {.lex_state = 424, .external_lex_state = 9},
  [14801] = {.lex_state = 424, .external_lex_state = 9},
  [14802] = {.lex_state = 363},
  [14803] = {.lex_state = 363},
  [14804] = {.lex_state = 363},
  [14805] = {.lex_state = 349},
  [14806] = {.lex_state = 424, .external_lex_state = 9},
  [14807] = {.lex_state = 363},
  [14808] = {.lex_state = 424, .external_lex_state = 8},
  [14809] = {.lex_state = 363},
  [14810] = {.lex_state = 165},
  [14811] = {.lex_state = 424, .external_lex_state = 6},
  [14812] = {.lex_state = 424, .external_lex_state = 7},
  [14813] = {.lex_state = 424, .external_lex_state = 8},
  [14814] = {.lex_state = 424, .external_lex_state = 9},
  [14815] = {.lex_state = 363},
  [14816] = {.lex_state = 424, .external_lex_state = 6},
  [14817] = {.lex_state = 424, .external_lex_state = 6},
  [14818] = {.lex_state = 424, .external_lex_state = 6},
  [14819] = {.lex_state = 424, .external_lex_state = 7},
  [14820] = {.lex_state = 424, .external_lex_state = 6},
  [14821] = {.lex_state = 424, .external_lex_state = 6},
  [14822] = {.lex_state = 424, .external_lex_state = 7},
  [14823] = {.lex_state = 424, .external_lex_state = 8},
  [14824] = {.lex_state = 424, .external_lex_state = 7},
  [14825] = {.lex_state = 424, .external_lex_state = 8},
  [14826] = {.lex_state = 424, .external_lex_state = 9},
  [14827] = {.lex_state = 424, .external_lex_state = 9},
  [14828] = {.lex_state = 424, .external_lex_state = 7},
  [14829] = {.lex_state = 424, .external_lex_state = 6},
  [14830] = {.lex_state = 424, .external_lex_state = 7},
  [14831] = {.lex_state = 424, .external_lex_state = 8},
  [14832] = {.lex_state = 424, .external_lex_state = 9},
  [14833] = {.lex_state = 424, .external_lex_state = 6},
  [14834] = {.lex_state = 363},
  [14835] = {.lex_state = 424, .external_lex_state = 6},
  [14836] = {.lex_state = 424, .external_lex_state = 7},
  [14837] = {.lex_state = 562},
  [14838] = {.lex_state = 424, .external_lex_state = 8},
  [14839] = {.lex_state = 424, .external_lex_state = 9},
  [14840] = {.lex_state = 424, .external_lex_state = 6},
  [14841] = {.lex_state = 363},
  [14842] = {.lex_state = 363},
  [14843] = {.lex_state = 424, .external_lex_state = 7},
  [14844] = {.lex_state = 424, .external_lex_state = 8},
  [14845] = {.lex_state = 424, .external_lex_state = 6},
  [14846] = {.lex_state = 424, .external_lex_state = 9},
  [14847] = {.lex_state = 424, .external_lex_state = 7},
  [14848] = {.lex_state = 424, .external_lex_state = 8},
  [14849] = {.lex_state = 424, .external_lex_state = 9},
  [14850] = {.lex_state = 363},
  [14851] = {.lex_state = 349},
  [14852] = {.lex_state = 539},
  [14853] = {.lex_state = 363},
  [14854] = {.lex_state = 363},
  [14855] = {.lex_state = 424, .external_lex_state = 6},
  [14856] = {.lex_state = 424, .external_lex_state = 6},
  [14857] = {.lex_state = 424, .external_lex_state = 7},
  [14858] = {.lex_state = 349},
  [14859] = {.lex_state = 349},
  [14860] = {.lex_state = 424, .external_lex_state = 8},
  [14861] = {.lex_state = 363},
  [14862] = {.lex_state = 424, .external_lex_state = 7},
  [14863] = {.lex_state = 363},
  [14864] = {.lex_state = 424, .external_lex_state = 9},
  [14865] = {.lex_state = 424, .external_lex_state = 8},
  [14866] = {.lex_state = 424, .external_lex_state = 9},
  [14867] = {.lex_state = 363},
  [14868] = {.lex_state = 424, .external_lex_state = 6},
  [14869] = {.lex_state = 424, .external_lex_state = 6},
  [14870] = {.lex_state = 424, .external_lex_state = 7},
  [14871] = {.lex_state = 424, .external_lex_state = 8},
  [14872] = {.lex_state = 424, .external_lex_state = 9},
  [14873] = {.lex_state = 363},
  [14874] = {.lex_state = 424, .external_lex_state = 7},
  [14875] = {.lex_state = 424, .external_lex_state = 7},
  [14876] = {.lex_state = 349},
  [14877] = {.lex_state = 363},
  [14878] = {.lex_state = 424, .external_lex_state = 8},
  [14879] = {.lex_state = 424, .external_lex_state = 9},
  [14880] = {.lex_state = 363},
  [14881] = {.lex_state = 363},
  [14882] = {.lex_state = 424, .external_lex_state = 9},
  [14883] = {.lex_state = 363},
  [14884] = {.lex_state = 363},
  [14885] = {.lex_state = 363},
  [14886] = {.lex_state = 349},
  [14887] = {.lex_state = 363},
  [14888] = {.lex_state = 363},
  [14889] = {.lex_state = 424, .external_lex_state = 8},
  [14890] = {.lex_state = 424, .external_lex_state = 9},
  [14891] = {.lex_state = 424, .external_lex_state = 6},
  [14892] = {.lex_state = 363},
  [14893] = {.lex_state = 363},
  [14894] = {.lex_state = 363},
  [14895] = {.lex_state = 349},
  [14896] = {.lex_state = 363},
  [14897] = {.lex_state = 363},
  [14898] = {.lex_state = 349},
  [14899] = {.lex_state = 424, .external_lex_state = 7},
  [14900] = {.lex_state = 424, .external_lex_state = 6},
  [14901] = {.lex_state = 349},
  [14902] = {.lex_state = 424, .external_lex_state = 7},
  [14903] = {.lex_state = 424, .external_lex_state = 8},
  [14904] = {.lex_state = 424, .external_lex_state = 9},
  [14905] = {.lex_state = 363},
  [14906] = {.lex_state = 424, .external_lex_state = 7},
  [14907] = {.lex_state = 424, .external_lex_state = 6},
  [14908] = {.lex_state = 424, .external_lex_state = 6},
  [14909] = {.lex_state = 424, .external_lex_state = 7},
  [14910] = {.lex_state = 424, .external_lex_state = 8},
  [14911] = {.lex_state = 424, .external_lex_state = 9},
  [14912] = {.lex_state = 349},
  [14913] = {.lex_state = 363},
  [14914] = {.lex_state = 424, .external_lex_state = 7},
  [14915] = {.lex_state = 424, .external_lex_state = 8},
  [14916] = {.lex_state = 363},
  [14917] = {.lex_state = 363},
  [14918] = {.lex_state = 539},
  [14919] = {.lex_state = 424, .external_lex_state = 6},
  [14920] = {.lex_state = 424, .external_lex_state = 6},
  [14921] = {.lex_state = 424, .external_lex_state = 7},
  [14922] = {.lex_state = 349},
  [14923] = {.lex_state = 424, .external_lex_state = 8},
  [14924] = {.lex_state = 363},
  [14925] = {.lex_state = 424, .external_lex_state = 9},
  [14926] = {.lex_state = 363},
  [14927] = {.lex_state = 363},
  [14928] = {.lex_state = 424, .external_lex_state = 7},
  [14929] = {.lex_state = 424, .external_lex_state = 8},
  [14930] = {.lex_state = 363},
  [14931] = {.lex_state = 363},
  [14932] = {.lex_state = 363},
  [14933] = {.lex_state = 363},
  [14934] = {.lex_state = 424, .external_lex_state = 9},
  [14935] = {.lex_state = 349},
  [14936] = {.lex_state = 363},
  [14937] = {.lex_state = 363},
  [14938] = {.lex_state = 363},
  [14939] = {.lex_state = 424, .external_lex_state = 9},
  [14940] = {.lex_state = 424, .external_lex_state = 6},
  [14941] = {.lex_state = 424, .external_lex_state = 7},
  [14942] = {.lex_state = 424, .external_lex_state = 8},
  [14943] = {.lex_state = 424, .external_lex_state = 9},
  [14944] = {.lex_state = 424, .external_lex_state = 9},
  [14945] = {.lex_state = 424, .external_lex_state = 6},
  [14946] = {.lex_state = 363},
  [14947] = {.lex_state = 363},
  [14948] = {.lex_state = 424, .external_lex_state = 7},
  [14949] = {.lex_state = 424, .external_lex_state = 8},
  [14950] = {.lex_state = 424, .external_lex_state = 9},
  [14951] = {.lex_state = 424, .external_lex_state = 8},
  [14952] = {.lex_state = 363},
  [14953] = {.lex_state = 363},
  [14954] = {.lex_state = 424, .external_lex_state = 9},
  [14955] = {.lex_state = 363},
  [14956] = {.lex_state = 363},
  [14957] = {.lex_state = 424, .external_lex_state = 6},
  [14958] = {.lex_state = 363},
  [14959] = {.lex_state = 424, .external_lex_state = 6},
  [14960] = {.lex_state = 424, .external_lex_state = 7},
  [14961] = {.lex_state = 363},
  [14962] = {.lex_state = 424, .external_lex_state = 8},
  [14963] = {.lex_state = 424, .external_lex_state = 6},
  [14964] = {.lex_state = 424, .external_lex_state = 9},
  [14965] = {.lex_state = 424, .external_lex_state = 7},
  [14966] = {.lex_state = 363},
  [14967] = {.lex_state = 363},
  [14968] = {.lex_state = 363},
  [14969] = {.lex_state = 363},
  [14970] = {.lex_state = 363},
  [14971] = {.lex_state = 424, .external_lex_state = 8},
  [14972] = {.lex_state = 424, .external_lex_state = 6},
  [14973] = {.lex_state = 424, .external_lex_state = 9},
  [14974] = {.lex_state = 363},
  [14975] = {.lex_state = 363},
  [14976] = {.lex_state = 424, .external_lex_state = 7},
  [14977] = {.lex_state = 363},
  [14978] = {.lex_state = 363},
  [14979] = {.lex_state = 424, .external_lex_state = 8},
  [14980] = {.lex_state = 349},
  [14981] = {.lex_state = 349},
  [14982] = {.lex_state = 424, .external_lex_state = 6},
  [14983] = {.lex_state = 424, .external_lex_state = 8},
  [14984] = {.lex_state = 363},
  [14985] = {.lex_state = 424, .external_lex_state = 6},
  [14986] = {.lex_state = 424, .external_lex_state = 7},
  [14987] = {.lex_state = 424, .external_lex_state = 7},
  [14988] = {.lex_state = 424, .external_lex_state = 6},
  [14989] = {.lex_state = 424, .external_lex_state = 7},
  [14990] = {.lex_state = 424, .external_lex_state = 8},
  [14991] = {.lex_state = 424, .external_lex_state = 6},
  [14992] = {.lex_state = 363},
  [14993] = {.lex_state = 424, .external_lex_state = 8},
  [14994] = {.lex_state = 363},
  [14995] = {.lex_state = 363},
  [14996] = {.lex_state = 424, .external_lex_state = 7},
  [14997] = {.lex_state = 424, .external_lex_state = 8},
  [14998] = {.lex_state = 424, .external_lex_state = 9},
  [14999] = {.lex_state = 424, .external_lex_state = 8},
  [15000] = {.lex_state = 363},
  [15001] = {.lex_state = 424, .external_lex_state = 9},
  [15002] = {.lex_state = 363},
  [15003] = {.lex_state = 424, .external_lex_state = 6},
  [15004] = {.lex_state = 424, .external_lex_state = 7},
  [15005] = {.lex_state = 424, .external_lex_state = 6},
  [15006] = {.lex_state = 424, .external_lex_state = 7},
  [15007] = {.lex_state = 424, .external_lex_state = 8},
  [15008] = {.lex_state = 424, .external_lex_state = 9},
  [15009] = {.lex_state = 424, .external_lex_state = 8},
  [15010] = {.lex_state = 424, .external_lex_state = 7},
  [15011] = {.lex_state = 424, .external_lex_state = 9},
  [15012] = {.lex_state = 424, .external_lex_state = 9},
  [15013] = {.lex_state = 424, .external_lex_state = 9},
  [15014] = {.lex_state = 424, .external_lex_state = 6},
  [15015] = {.lex_state = 424, .external_lex_state = 7},
  [15016] = {.lex_state = 424, .external_lex_state = 8},
  [15017] = {.lex_state = 424, .external_lex_state = 9},
  [15018] = {.lex_state = 363},
  [15019] = {.lex_state = 363},
  [15020] = {.lex_state = 424, .external_lex_state = 6},
  [15021] = {.lex_state = 424, .external_lex_state = 7},
  [15022] = {.lex_state = 424, .external_lex_state = 8},
  [15023] = {.lex_state = 424, .external_lex_state = 9},
  [15024] = {.lex_state = 363},
  [15025] = {.lex_state = 363},
  [15026] = {.lex_state = 363},
  [15027] = {.lex_state = 349},
  [15028] = {.lex_state = 539},
  [15029] = {.lex_state = 424, .external_lex_state = 6},
  [15030] = {.lex_state = 424, .external_lex_state = 7},
  [15031] = {.lex_state = 424, .external_lex_state = 8},
  [15032] = {.lex_state = 424, .external_lex_state = 9},
  [15033] = {.lex_state = 363},
  [15034] = {.lex_state = 424, .external_lex_state = 6},
  [15035] = {.lex_state = 363},
  [15036] = {.lex_state = 235},
  [15037] = {.lex_state = 424, .external_lex_state = 9},
  [15038] = {.lex_state = 363},
  [15039] = {.lex_state = 363},
  [15040] = {.lex_state = 363},
  [15041] = {.lex_state = 562},
  [15042] = {.lex_state = 363},
  [15043] = {.lex_state = 424, .external_lex_state = 6},
  [15044] = {.lex_state = 424, .external_lex_state = 8},
  [15045] = {.lex_state = 424, .external_lex_state = 7},
  [15046] = {.lex_state = 424, .external_lex_state = 8},
  [15047] = {.lex_state = 424, .external_lex_state = 9},
  [15048] = {.lex_state = 363},
  [15049] = {.lex_state = 424, .external_lex_state = 6},
  [15050] = {.lex_state = 363},
  [15051] = {.lex_state = 424, .external_lex_state = 7},
  [15052] = {.lex_state = 363},
  [15053] = {.lex_state = 424, .external_lex_state = 8},
  [15054] = {.lex_state = 349},
  [15055] = {.lex_state = 424, .external_lex_state = 9},
  [15056] = {.lex_state = 562},
  [15057] = {.lex_state = 424, .external_lex_state = 6},
  [15058] = {.lex_state = 424, .external_lex_state = 6},
  [15059] = {.lex_state = 424, .external_lex_state = 7},
  [15060] = {.lex_state = 424, .external_lex_state = 8},
  [15061] = {.lex_state = 424, .external_lex_state = 9},
  [15062] = {.lex_state = 349},
  [15063] = {.lex_state = 363},
  [15064] = {.lex_state = 363},
  [15065] = {.lex_state = 363},
  [15066] = {.lex_state = 363},
  [15067] = {.lex_state = 363},
  [15068] = {.lex_state = 424, .external_lex_state = 6},
  [15069] = {.lex_state = 424, .external_lex_state = 6},
  [15070] = {.lex_state = 349},
  [15071] = {.lex_state = 424, .external_lex_state = 7},
  [15072] = {.lex_state = 424, .external_lex_state = 8},
  [15073] = {.lex_state = 424, .external_lex_state = 9},
  [15074] = {.lex_state = 363},
  [15075] = {.lex_state = 424, .external_lex_state = 6},
  [15076] = {.lex_state = 424, .external_lex_state = 9},
  [15077] = {.lex_state = 349},
  [15078] = {.lex_state = 165},
  [15079] = {.lex_state = 424, .external_lex_state = 6},
  [15080] = {.lex_state = 424, .external_lex_state = 7},
  [15081] = {.lex_state = 424, .external_lex_state = 8},
  [15082] = {.lex_state = 424, .external_lex_state = 9},
  [15083] = {.lex_state = 349},
  [15084] = {.lex_state = 349},
  [15085] = {.lex_state = 349},
  [15086] = {.lex_state = 349},
  [15087] = {.lex_state = 349},
  [15088] = {.lex_state = 349},
  [15089] = {.lex_state = 424, .external_lex_state = 6},
  [15090] = {.lex_state = 363},
  [15091] = {.lex_state = 363},
  [15092] = {.lex_state = 363},
  [15093] = {.lex_state = 424, .external_lex_state = 7},
  [15094] = {.lex_state = 363},
  [15095] = {.lex_state = 424, .external_lex_state = 8},
  [15096] = {.lex_state = 349},
  [15097] = {.lex_state = 424, .external_lex_state = 6},
  [15098] = {.lex_state = 424, .external_lex_state = 7},
  [15099] = {.lex_state = 424, .external_lex_state = 8},
  [15100] = {.lex_state = 424, .external_lex_state = 9},
  [15101] = {.lex_state = 424, .external_lex_state = 9},
  [15102] = {.lex_state = 363},
  [15103] = {.lex_state = 424, .external_lex_state = 7},
  [15104] = {.lex_state = 363},
  [15105] = {.lex_state = 424, .external_lex_state = 8},
  [15106] = {.lex_state = 424, .external_lex_state = 9},
  [15107] = {.lex_state = 424, .external_lex_state = 6},
  [15108] = {.lex_state = 424, .external_lex_state = 9},
  [15109] = {.lex_state = 0},
  [15110] = {.lex_state = 0},
  [15111] = {.lex_state = 0},
  [15112] = {.lex_state = 0},
  [15113] = {.lex_state = 284},
  [15114] = {.lex_state = 364},
  [15115] = {.lex_state = 0},
  [15116] = {.lex_state = 0},
  [15117] = {.lex_state = 0},
  [15118] = {.lex_state = 0},
  [15119] = {.lex_state = 0},
  [15120] = {.lex_state = 364},
  [15121] = {.lex_state = 0},
  [15122] = {.lex_state = 0},
  [15123] = {.lex_state = 284},
  [15124] = {.lex_state = 364},
  [15125] = {.lex_state = 0},
  [15126] = {.lex_state = 0},
  [15127] = {.lex_state = 0},
  [15128] = {.lex_state = 0},
  [15129] = {.lex_state = 364},
  [15130] = {.lex_state = 0},
  [15131] = {.lex_state = 0},
  [15132] = {.lex_state = 0},
  [15133] = {.lex_state = 0},
  [15134] = {.lex_state = 539},
  [15135] = {.lex_state = 364},
  [15136] = {.lex_state = 364},
  [15137] = {.lex_state = 364},
  [15138] = {.lex_state = 0},
  [15139] = {.lex_state = 0},
  [15140] = {.lex_state = 0},
  [15141] = {.lex_state = 0},
  [15142] = {.lex_state = 0},
  [15143] = {.lex_state = 0},
  [15144] = {.lex_state = 0},
  [15145] = {.lex_state = 0},
  [15146] = {.lex_state = 0},
  [15147] = {.lex_state = 364},
  [15148] = {.lex_state = 0},
  [15149] = {.lex_state = 284},
  [15150] = {.lex_state = 0},
  [15151] = {.lex_state = 364},
  [15152] = {.lex_state = 0},
  [15153] = {.lex_state = 364},
  [15154] = {.lex_state = 0},
  [15155] = {.lex_state = 0},
  [15156] = {.lex_state = 0},
  [15157] = {.lex_state = 0},
  [15158] = {.lex_state = 0},
  [15159] = {.lex_state = 364},
  [15160] = {.lex_state = 0},
  [15161] = {.lex_state = 562},
  [15162] = {.lex_state = 0},
  [15163] = {.lex_state = 0},
  [15164] = {.lex_state = 0},
  [15165] = {.lex_state = 0},
  [15166] = {.lex_state = 0},
  [15167] = {.lex_state = 0},
  [15168] = {.lex_state = 0},
  [15169] = {.lex_state = 539},
  [15170] = {.lex_state = 0},
  [15171] = {.lex_state = 165},
  [15172] = {.lex_state = 0},
  [15173] = {.lex_state = 562},
  [15174] = {.lex_state = 0},
  [15175] = {.lex_state = 0},
  [15176] = {.lex_state = 539},
  [15177] = {.lex_state = 0},
  [15178] = {.lex_state = 364},
  [15179] = {.lex_state = 0},
  [15180] = {.lex_state = 284},
  [15181] = {.lex_state = 0},
  [15182] = {.lex_state = 284},
  [15183] = {.lex_state = 539},
  [15184] = {.lex_state = 539},
  [15185] = {.lex_state = 0},
  [15186] = {.lex_state = 0},
  [15187] = {.lex_state = 0},
  [15188] = {.lex_state = 0},
  [15189] = {.lex_state = 0},
  [15190] = {.lex_state = 0},
  [15191] = {.lex_state = 0},
  [15192] = {.lex_state = 0},
  [15193] = {.lex_state = 0},
  [15194] = {.lex_state = 0},
  [15195] = {.lex_state = 284},
  [15196] = {.lex_state = 284},
  [15197] = {.lex_state = 0},
  [15198] = {.lex_state = 0},
  [15199] = {.lex_state = 0},
  [15200] = {.lex_state = 0},
  [15201] = {.lex_state = 0},
  [15202] = {.lex_state = 364},
  [15203] = {.lex_state = 0},
  [15204] = {.lex_state = 0},
  [15205] = {.lex_state = 0},
  [15206] = {.lex_state = 0},
  [15207] = {.lex_state = 0},
  [15208] = {.lex_state = 0},
  [15209] = {.lex_state = 364},
  [15210] = {.lex_state = 0},
  [15211] = {.lex_state = 0},
  [15212] = {.lex_state = 0},
  [15213] = {.lex_state = 0},
  [15214] = {.lex_state = 284},
  [15215] = {.lex_state = 0},
  [15216] = {.lex_state = 0},
  [15217] = {.lex_state = 364},
  [15218] = {.lex_state = 0},
  [15219] = {.lex_state = 0},
  [15220] = {.lex_state = 0},
  [15221] = {.lex_state = 364},
  [15222] = {.lex_state = 0},
  [15223] = {.lex_state = 364},
  [15224] = {.lex_state = 0},
  [15225] = {.lex_state = 0},
  [15226] = {.lex_state = 364},
  [15227] = {.lex_state = 0},
  [15228] = {.lex_state = 0},
  [15229] = {.lex_state = 0},
  [15230] = {.lex_state = 0},
  [15231] = {.lex_state = 0},
  [15232] = {.lex_state = 0},
  [15233] = {.lex_state = 364},
  [15234] = {.lex_state = 0},
  [15235] = {.lex_state = 364},
  [15236] = {.lex_state = 0},
  [15237] = {.lex_state = 0},
  [15238] = {.lex_state = 0},
  [15239] = {.lex_state = 364},
  [15240] = {.lex_state = 284},
  [15241] = {.lex_state = 0},
  [15242] = {.lex_state = 0},
  [15243] = {.lex_state = 0},
  [15244] = {.lex_state = 0},
  [15245] = {.lex_state = 0},
  [15246] = {.lex_state = 0},
  [15247] = {.lex_state = 284},
  [15248] = {.lex_state = 562},
  [15249] = {.lex_state = 0},
  [15250] = {.lex_state = 0},
  [15251] = {.lex_state = 0},
  [15252] = {.lex_state = 0},
  [15253] = {.lex_state = 363},
  [15254] = {.lex_state = 364},
  [15255] = {.lex_state = 0},
  [15256] = {.lex_state = 0},
  [15257] = {.lex_state = 364},
  [15258] = {.lex_state = 562},
  [15259] = {.lex_state = 0},
  [15260] = {.lex_state = 0},
  [15261] = {.lex_state = 364},
  [15262] = {.lex_state = 0},
  [15263] = {.lex_state = 0},
  [15264] = {.lex_state = 0},
  [15265] = {.lex_state = 0},
  [15266] = {.lex_state = 0},
  [15267] = {.lex_state = 0},
  [15268] = {.lex_state = 0},
  [15269] = {.lex_state = 539},
  [15270] = {.lex_state = 0},
  [15271] = {.lex_state = 0},
  [15272] = {.lex_state = 0},
  [15273] = {.lex_state = 0},
  [15274] = {.lex_state = 364},
  [15275] = {.lex_state = 0},
  [15276] = {.lex_state = 0},
  [15277] = {.lex_state = 0},
  [15278] = {.lex_state = 0},
  [15279] = {.lex_state = 0},
  [15280] = {.lex_state = 0},
  [15281] = {.lex_state = 0},
  [15282] = {.lex_state = 562},
  [15283] = {.lex_state = 0},
  [15284] = {.lex_state = 0},
  [15285] = {.lex_state = 0},
  [15286] = {.lex_state = 426, .external_lex_state = 3},
  [15287] = {.lex_state = 0},
  [15288] = {.lex_state = 539},
  [15289] = {.lex_state = 364},
  [15290] = {.lex_state = 0},
  [15291] = {.lex_state = 0},
  [15292] = {.lex_state = 0},
  [15293] = {.lex_state = 0},
  [15294] = {.lex_state = 284},
  [15295] = {.lex_state = 364},
  [15296] = {.lex_state = 562},
  [15297] = {.lex_state = 0},
  [15298] = {.lex_state = 0},
  [15299] = {.lex_state = 364},
  [15300] = {.lex_state = 0},
  [15301] = {.lex_state = 0},
  [15302] = {.lex_state = 0},
  [15303] = {.lex_state = 0},
  [15304] = {.lex_state = 0},
  [15305] = {.lex_state = 539},
  [15306] = {.lex_state = 0},
  [15307] = {.lex_state = 0},
  [15308] = {.lex_state = 0},
  [15309] = {.lex_state = 562},
  [15310] = {.lex_state = 0},
  [15311] = {.lex_state = 364},
  [15312] = {.lex_state = 364},
  [15313] = {.lex_state = 0},
  [15314] = {.lex_state = 0},
  [15315] = {.lex_state = 364},
  [15316] = {.lex_state = 364},
  [15317] = {.lex_state = 0},
  [15318] = {.lex_state = 364},
  [15319] = {.lex_state = 0},
  [15320] = {.lex_state = 0},
  [15321] = {.lex_state = 0},
  [15322] = {.lex_state = 364},
  [15323] = {.lex_state = 0},
  [15324] = {.lex_state = 562},
  [15325] = {.lex_state = 364},
  [15326] = {.lex_state = 0},
  [15327] = {.lex_state = 0},
  [15328] = {.lex_state = 0},
  [15329] = {.lex_state = 364},
  [15330] = {.lex_state = 0},
  [15331] = {.lex_state = 0},
  [15332] = {.lex_state = 539},
  [15333] = {.lex_state = 0},
  [15334] = {.lex_state = 0},
  [15335] = {.lex_state = 284},
  [15336] = {.lex_state = 0},
  [15337] = {.lex_state = 0},
  [15338] = {.lex_state = 0},
  [15339] = {.lex_state = 0},
  [15340] = {.lex_state = 0},
  [15341] = {.lex_state = 0},
  [15342] = {.lex_state = 0},
  [15343] = {.lex_state = 0},
  [15344] = {.lex_state = 0},
  [15345] = {.lex_state = 0},
  [15346] = {.lex_state = 0},
  [15347] = {.lex_state = 0},
  [15348] = {.lex_state = 0},
  [15349] = {.lex_state = 0},
  [15350] = {.lex_state = 424, .external_lex_state = 10},
  [15351] = {.lex_state = 424, .external_lex_state = 11},
  [15352] = {.lex_state = 424, .external_lex_state = 12},
  [15353] = {.lex_state = 424, .external_lex_state = 13},
  [15354] = {.lex_state = 0},
  [15355] = {.lex_state = 0},
  [15356] = {.lex_state = 424, .external_lex_state = 10},
  [15357] = {.lex_state = 424, .external_lex_state = 11},
  [15358] = {.lex_state = 424, .external_lex_state = 12},
  [15359] = {.lex_state = 424, .external_lex_state = 13},
  [15360] = {.lex_state = 0},
  [15361] = {.lex_state = 0},
  [15362] = {.lex_state = 0},
  [15363] = {.lex_state = 0},
  [15364] = {.lex_state = 0},
  [15365] = {.lex_state = 424, .external_lex_state = 9},
  [15366] = {.lex_state = 505},
  [15367] = {.lex_state = 0},
  [15368] = {.lex_state = 505},
  [15369] = {.lex_state = 0},
  [15370] = {.lex_state = 0},
  [15371] = {.lex_state = 505},
  [15372] = {.lex_state = 424, .external_lex_state = 5},
  [15373] = {.lex_state = 424, .external_lex_state = 10},
  [15374] = {.lex_state = 424, .external_lex_state = 11},
  [15375] = {.lex_state = 424, .external_lex_state = 12},
  [15376] = {.lex_state = 424, .external_lex_state = 13},
  [15377] = {.lex_state = 424, .external_lex_state = 10},
  [15378] = {.lex_state = 424, .external_lex_state = 10},
  [15379] = {.lex_state = 424, .external_lex_state = 10},
  [15380] = {.lex_state = 424, .external_lex_state = 11},
  [15381] = {.lex_state = 424, .external_lex_state = 12},
  [15382] = {.lex_state = 424, .external_lex_state = 13},
  [15383] = {.lex_state = 424, .external_lex_state = 11},
  [15384] = {.lex_state = 424, .external_lex_state = 11},
  [15385] = {.lex_state = 424, .external_lex_state = 12},
  [15386] = {.lex_state = 424, .external_lex_state = 13},
  [15387] = {.lex_state = 424, .external_lex_state = 12},
  [15388] = {.lex_state = 0},
  [15389] = {.lex_state = 0},
  [15390] = {.lex_state = 0},
  [15391] = {.lex_state = 505},
  [15392] = {.lex_state = 424, .external_lex_state = 11},
  [15393] = {.lex_state = 505},
  [15394] = {.lex_state = 424, .external_lex_state = 10},
  [15395] = {.lex_state = 424, .external_lex_state = 10},
  [15396] = {.lex_state = 424, .external_lex_state = 11},
  [15397] = {.lex_state = 424, .external_lex_state = 12},
  [15398] = {.lex_state = 424, .external_lex_state = 13},
  [15399] = {.lex_state = 424, .external_lex_state = 11},
  [15400] = {.lex_state = 424, .external_lex_state = 10},
  [15401] = {.lex_state = 424, .external_lex_state = 11},
  [15402] = {.lex_state = 424, .external_lex_state = 12},
  [15403] = {.lex_state = 424, .external_lex_state = 13},
  [15404] = {.lex_state = 0},
  [15405] = {.lex_state = 505},
  [15406] = {.lex_state = 424, .external_lex_state = 12},
  [15407] = {.lex_state = 424, .external_lex_state = 10},
  [15408] = {.lex_state = 505},
  [15409] = {.lex_state = 424, .external_lex_state = 11},
  [15410] = {.lex_state = 424, .external_lex_state = 12},
  [15411] = {.lex_state = 424, .external_lex_state = 13},
  [15412] = {.lex_state = 424, .external_lex_state = 13},
  [15413] = {.lex_state = 0},
  [15414] = {.lex_state = 424, .external_lex_state = 6},
  [15415] = {.lex_state = 505},
  [15416] = {.lex_state = 424, .external_lex_state = 13},
  [15417] = {.lex_state = 0},
  [15418] = {.lex_state = 0},
  [15419] = {.lex_state = 424, .external_lex_state = 10},
  [15420] = {.lex_state = 424, .external_lex_state = 11},
  [15421] = {.lex_state = 424, .external_lex_state = 12},
  [15422] = {.lex_state = 424, .external_lex_state = 13},
  [15423] = {.lex_state = 424, .external_lex_state = 6},
  [15424] = {.lex_state = 424, .external_lex_state = 3},
  [15425] = {.lex_state = 424, .external_lex_state = 10},
  [15426] = {.lex_state = 424, .external_lex_state = 11},
  [15427] = {.lex_state = 424, .external_lex_state = 12},
  [15428] = {.lex_state = 424, .external_lex_state = 13},
  [15429] = {.lex_state = 505},
  [15430] = {.lex_state = 505},
  [15431] = {.lex_state = 0},
  [15432] = {.lex_state = 505},
  [15433] = {.lex_state = 0},
  [15434] = {.lex_state = 505},
  [15435] = {.lex_state = 424, .external_lex_state = 10},
  [15436] = {.lex_state = 424, .external_lex_state = 11},
  [15437] = {.lex_state = 424, .external_lex_state = 12},
  [15438] = {.lex_state = 424, .external_lex_state = 13},
  [15439] = {.lex_state = 424, .external_lex_state = 11},
  [15440] = {.lex_state = 424, .external_lex_state = 12},
  [15441] = {.lex_state = 424, .external_lex_state = 13},
  [15442] = {.lex_state = 424, .external_lex_state = 10},
  [15443] = {.lex_state = 424, .external_lex_state = 11},
  [15444] = {.lex_state = 424, .external_lex_state = 12},
  [15445] = {.lex_state = 424, .external_lex_state = 13},
  [15446] = {.lex_state = 424, .external_lex_state = 6},
  [15447] = {.lex_state = 505},
  [15448] = {.lex_state = 505},
  [15449] = {.lex_state = 505},
  [15450] = {.lex_state = 505},
  [15451] = {.lex_state = 424, .external_lex_state = 10},
  [15452] = {.lex_state = 424, .external_lex_state = 11},
  [15453] = {.lex_state = 424, .external_lex_state = 12},
  [15454] = {.lex_state = 424, .external_lex_state = 13},
  [15455] = {.lex_state = 562},
  [15456] = {.lex_state = 0},
  [15457] = {.lex_state = 424, .external_lex_state = 10},
  [15458] = {.lex_state = 424, .external_lex_state = 11},
  [15459] = {.lex_state = 424, .external_lex_state = 12},
  [15460] = {.lex_state = 424, .external_lex_state = 13},
  [15461] = {.lex_state = 0},
  [15462] = {.lex_state = 0},
  [15463] = {.lex_state = 0},
  [15464] = {.lex_state = 424, .external_lex_state = 12},
  [15465] = {.lex_state = 562},
  [15466] = {.lex_state = 505},
  [15467] = {.lex_state = 0},
  [15468] = {.lex_state = 424, .external_lex_state = 3},
  [15469] = {.lex_state = 505},
  [15470] = {.lex_state = 0},
  [15471] = {.lex_state = 0},
  [15472] = {.lex_state = 0},
  [15473] = {.lex_state = 505},
  [15474] = {.lex_state = 0},
  [15475] = {.lex_state = 0},
  [15476] = {.lex_state = 424, .external_lex_state = 10},
  [15477] = {.lex_state = 424, .external_lex_state = 11},
  [15478] = {.lex_state = 424, .external_lex_state = 12},
  [15479] = {.lex_state = 424, .external_lex_state = 13},
  [15480] = {.lex_state = 0},
  [15481] = {.lex_state = 424, .external_lex_state = 10},
  [15482] = {.lex_state = 424, .external_lex_state = 11},
  [15483] = {.lex_state = 424, .external_lex_state = 12},
  [15484] = {.lex_state = 424, .external_lex_state = 13},
  [15485] = {.lex_state = 424, .external_lex_state = 10},
  [15486] = {.lex_state = 424, .external_lex_state = 11},
  [15487] = {.lex_state = 424, .external_lex_state = 12},
  [15488] = {.lex_state = 424, .external_lex_state = 13},
  [15489] = {.lex_state = 0},
  [15490] = {.lex_state = 0},
  [15491] = {.lex_state = 505},
  [15492] = {.lex_state = 505},
  [15493] = {.lex_state = 0},
  [15494] = {.lex_state = 424, .external_lex_state = 13},
  [15495] = {.lex_state = 505},
  [15496] = {.lex_state = 505},
  [15497] = {.lex_state = 0},
  [15498] = {.lex_state = 0},
  [15499] = {.lex_state = 424, .external_lex_state = 10},
  [15500] = {.lex_state = 424, .external_lex_state = 11},
  [15501] = {.lex_state = 424, .external_lex_state = 12},
  [15502] = {.lex_state = 424, .external_lex_state = 13},
  [15503] = {.lex_state = 0},
  [15504] = {.lex_state = 424, .external_lex_state = 10},
  [15505] = {.lex_state = 424, .external_lex_state = 10},
  [15506] = {.lex_state = 424, .external_lex_state = 11},
  [15507] = {.lex_state = 424, .external_lex_state = 12},
  [15508] = {.lex_state = 424, .external_lex_state = 13},
  [15509] = {.lex_state = 424, .external_lex_state = 11},
  [15510] = {.lex_state = 424, .external_lex_state = 12},
  [15511] = {.lex_state = 424, .external_lex_state = 13},
  [15512] = {.lex_state = 424, .external_lex_state = 10},
  [15513] = {.lex_state = 424, .external_lex_state = 11},
  [15514] = {.lex_state = 424, .external_lex_state = 12},
  [15515] = {.lex_state = 505},
  [15516] = {.lex_state = 424, .external_lex_state = 13},
  [15517] = {.lex_state = 0},
  [15518] = {.lex_state = 424, .external_lex_state = 3},
  [15519] = {.lex_state = 0},
  [15520] = {.lex_state = 505},
  [15521] = {.lex_state = 424, .external_lex_state = 10},
  [15522] = {.lex_state = 424, .external_lex_state = 11},
  [15523] = {.lex_state = 424, .external_lex_state = 12},
  [15524] = {.lex_state = 424, .external_lex_state = 13},
  [15525] = {.lex_state = 505},
  [15526] = {.lex_state = 424, .external_lex_state = 10},
  [15527] = {.lex_state = 424, .external_lex_state = 11},
  [15528] = {.lex_state = 424, .external_lex_state = 12},
  [15529] = {.lex_state = 424, .external_lex_state = 13},
  [15530] = {.lex_state = 505},
  [15531] = {.lex_state = 0},
  [15532] = {.lex_state = 505},
  [15533] = {.lex_state = 505},
  [15534] = {.lex_state = 424, .external_lex_state = 6},
  [15535] = {.lex_state = 505},
  [15536] = {.lex_state = 0},
  [15537] = {.lex_state = 0},
  [15538] = {.lex_state = 505},
  [15539] = {.lex_state = 424, .external_lex_state = 10},
  [15540] = {.lex_state = 424, .external_lex_state = 10},
  [15541] = {.lex_state = 424, .external_lex_state = 11},
  [15542] = {.lex_state = 424, .external_lex_state = 12},
  [15543] = {.lex_state = 424, .external_lex_state = 13},
  [15544] = {.lex_state = 424, .external_lex_state = 8},
  [15545] = {.lex_state = 505},
  [15546] = {.lex_state = 424, .external_lex_state = 10},
  [15547] = {.lex_state = 424, .external_lex_state = 11},
  [15548] = {.lex_state = 424, .external_lex_state = 12},
  [15549] = {.lex_state = 424, .external_lex_state = 13},
  [15550] = {.lex_state = 424, .external_lex_state = 3},
  [15551] = {.lex_state = 424, .external_lex_state = 11},
  [15552] = {.lex_state = 424, .external_lex_state = 12},
  [15553] = {.lex_state = 424, .external_lex_state = 13},
  [15554] = {.lex_state = 505},
  [15555] = {.lex_state = 505},
  [15556] = {.lex_state = 0},
  [15557] = {.lex_state = 0},
  [15558] = {.lex_state = 0},
  [15559] = {.lex_state = 0},
  [15560] = {.lex_state = 0},
  [15561] = {.lex_state = 505},
  [15562] = {.lex_state = 424, .external_lex_state = 10},
  [15563] = {.lex_state = 424, .external_lex_state = 11},
  [15564] = {.lex_state = 424, .external_lex_state = 12},
  [15565] = {.lex_state = 424, .external_lex_state = 13},
  [15566] = {.lex_state = 424, .external_lex_state = 10},
  [15567] = {.lex_state = 424, .external_lex_state = 11},
  [15568] = {.lex_state = 424, .external_lex_state = 12},
  [15569] = {.lex_state = 424, .external_lex_state = 13},
  [15570] = {.lex_state = 424, .external_lex_state = 10},
  [15571] = {.lex_state = 424, .external_lex_state = 11},
  [15572] = {.lex_state = 424, .external_lex_state = 12},
  [15573] = {.lex_state = 424, .external_lex_state = 13},
  [15574] = {.lex_state = 0},
  [15575] = {.lex_state = 0},
  [15576] = {.lex_state = 505},
  [15577] = {.lex_state = 505},
  [15578] = {.lex_state = 363},
  [15579] = {.lex_state = 0},
  [15580] = {.lex_state = 505},
  [15581] = {.lex_state = 424, .external_lex_state = 10},
  [15582] = {.lex_state = 424, .external_lex_state = 11},
  [15583] = {.lex_state = 424, .external_lex_state = 12},
  [15584] = {.lex_state = 424, .external_lex_state = 13},
  [15585] = {.lex_state = 424, .external_lex_state = 10},
  [15586] = {.lex_state = 0},
  [15587] = {.lex_state = 424, .external_lex_state = 11},
  [15588] = {.lex_state = 424, .external_lex_state = 12},
  [15589] = {.lex_state = 424, .external_lex_state = 10},
  [15590] = {.lex_state = 424, .external_lex_state = 11},
  [15591] = {.lex_state = 424, .external_lex_state = 12},
  [15592] = {.lex_state = 424, .external_lex_state = 13},
  [15593] = {.lex_state = 424, .external_lex_state = 13},
  [15594] = {.lex_state = 0},
  [15595] = {.lex_state = 424, .external_lex_state = 3},
  [15596] = {.lex_state = 0},
  [15597] = {.lex_state = 0},
  [15598] = {.lex_state = 505},
  [15599] = {.lex_state = 505},
  [15600] = {.lex_state = 505},
  [15601] = {.lex_state = 0},
  [15602] = {.lex_state = 424, .external_lex_state = 10},
  [15603] = {.lex_state = 0},
  [15604] = {.lex_state = 424, .external_lex_state = 10},
  [15605] = {.lex_state = 424, .external_lex_state = 11},
  [15606] = {.lex_state = 424, .external_lex_state = 12},
  [15607] = {.lex_state = 424, .external_lex_state = 13},
  [15608] = {.lex_state = 424, .external_lex_state = 10},
  [15609] = {.lex_state = 424, .external_lex_state = 11},
  [15610] = {.lex_state = 424, .external_lex_state = 12},
  [15611] = {.lex_state = 424, .external_lex_state = 13},
  [15612] = {.lex_state = 424, .external_lex_state = 11},
  [15613] = {.lex_state = 424, .external_lex_state = 10},
  [15614] = {.lex_state = 424, .external_lex_state = 11},
  [15615] = {.lex_state = 424, .external_lex_state = 12},
  [15616] = {.lex_state = 424, .external_lex_state = 13},
  [15617] = {.lex_state = 424, .external_lex_state = 12},
  [15618] = {.lex_state = 424, .external_lex_state = 13},
  [15619] = {.lex_state = 0},
  [15620] = {.lex_state = 505},
  [15621] = {.lex_state = 0},
  [15622] = {.lex_state = 424, .external_lex_state = 9},
  [15623] = {.lex_state = 505},
  [15624] = {.lex_state = 424, .external_lex_state = 10},
  [15625] = {.lex_state = 424, .external_lex_state = 11},
  [15626] = {.lex_state = 505},
  [15627] = {.lex_state = 424, .external_lex_state = 12},
  [15628] = {.lex_state = 424, .external_lex_state = 10},
  [15629] = {.lex_state = 424, .external_lex_state = 11},
  [15630] = {.lex_state = 424, .external_lex_state = 12},
  [15631] = {.lex_state = 424, .external_lex_state = 13},
  [15632] = {.lex_state = 424, .external_lex_state = 13},
  [15633] = {.lex_state = 424, .external_lex_state = 10},
  [15634] = {.lex_state = 424, .external_lex_state = 10},
  [15635] = {.lex_state = 424, .external_lex_state = 11},
  [15636] = {.lex_state = 424, .external_lex_state = 12},
  [15637] = {.lex_state = 424, .external_lex_state = 13},
  [15638] = {.lex_state = 0},
  [15639] = {.lex_state = 505},
  [15640] = {.lex_state = 505},
  [15641] = {.lex_state = 0},
  [15642] = {.lex_state = 505},
  [15643] = {.lex_state = 424, .external_lex_state = 10},
  [15644] = {.lex_state = 424, .external_lex_state = 11},
  [15645] = {.lex_state = 424, .external_lex_state = 12},
  [15646] = {.lex_state = 424, .external_lex_state = 13},
  [15647] = {.lex_state = 424, .external_lex_state = 10},
  [15648] = {.lex_state = 424, .external_lex_state = 11},
  [15649] = {.lex_state = 424, .external_lex_state = 12},
  [15650] = {.lex_state = 424, .external_lex_state = 13},
  [15651] = {.lex_state = 0},
  [15652] = {.lex_state = 505},
  [15653] = {.lex_state = 0},
  [15654] = {.lex_state = 0},
  [15655] = {.lex_state = 424, .external_lex_state = 12},
  [15656] = {.lex_state = 505},
  [15657] = {.lex_state = 505},
  [15658] = {.lex_state = 424, .external_lex_state = 10},
  [15659] = {.lex_state = 424, .external_lex_state = 11},
  [15660] = {.lex_state = 424, .external_lex_state = 12},
  [15661] = {.lex_state = 424, .external_lex_state = 13},
  [15662] = {.lex_state = 424, .external_lex_state = 10},
  [15663] = {.lex_state = 424, .external_lex_state = 11},
  [15664] = {.lex_state = 424, .external_lex_state = 12},
  [15665] = {.lex_state = 424, .external_lex_state = 13},
  [15666] = {.lex_state = 424, .external_lex_state = 10},
  [15667] = {.lex_state = 424, .external_lex_state = 10},
  [15668] = {.lex_state = 424, .external_lex_state = 11},
  [15669] = {.lex_state = 424, .external_lex_state = 12},
  [15670] = {.lex_state = 424, .external_lex_state = 13},
  [15671] = {.lex_state = 424, .external_lex_state = 11},
  [15672] = {.lex_state = 424, .external_lex_state = 10},
  [15673] = {.lex_state = 424, .external_lex_state = 11},
  [15674] = {.lex_state = 424, .external_lex_state = 12},
  [15675] = {.lex_state = 424, .external_lex_state = 13},
  [15676] = {.lex_state = 424, .external_lex_state = 12},
  [15677] = {.lex_state = 424, .external_lex_state = 10},
  [15678] = {.lex_state = 424, .external_lex_state = 11},
  [15679] = {.lex_state = 424, .external_lex_state = 12},
  [15680] = {.lex_state = 424, .external_lex_state = 13},
  [15681] = {.lex_state = 424, .external_lex_state = 10},
  [15682] = {.lex_state = 424, .external_lex_state = 11},
  [15683] = {.lex_state = 424, .external_lex_state = 12},
  [15684] = {.lex_state = 424, .external_lex_state = 13},
  [15685] = {.lex_state = 0},
  [15686] = {.lex_state = 424, .external_lex_state = 13},
  [15687] = {.lex_state = 424, .external_lex_state = 10},
  [15688] = {.lex_state = 424, .external_lex_state = 11},
  [15689] = {.lex_state = 424, .external_lex_state = 12},
  [15690] = {.lex_state = 424, .external_lex_state = 13},
  [15691] = {.lex_state = 424, .external_lex_state = 10},
  [15692] = {.lex_state = 424, .external_lex_state = 11},
  [15693] = {.lex_state = 424, .external_lex_state = 12},
  [15694] = {.lex_state = 424, .external_lex_state = 13},
  [15695] = {.lex_state = 0},
  [15696] = {.lex_state = 0},
  [15697] = {.lex_state = 424, .external_lex_state = 10},
  [15698] = {.lex_state = 424, .external_lex_state = 11},
  [15699] = {.lex_state = 424, .external_lex_state = 12},
  [15700] = {.lex_state = 424, .external_lex_state = 13},
  [15701] = {.lex_state = 0},
  [15702] = {.lex_state = 424, .external_lex_state = 10},
  [15703] = {.lex_state = 424, .external_lex_state = 11},
  [15704] = {.lex_state = 424, .external_lex_state = 12},
  [15705] = {.lex_state = 424, .external_lex_state = 13},
  [15706] = {.lex_state = 0},
  [15707] = {.lex_state = 424, .external_lex_state = 10},
  [15708] = {.lex_state = 424, .external_lex_state = 11},
  [15709] = {.lex_state = 424, .external_lex_state = 12},
  [15710] = {.lex_state = 424, .external_lex_state = 13},
  [15711] = {.lex_state = 424, .external_lex_state = 10},
  [15712] = {.lex_state = 424, .external_lex_state = 11},
  [15713] = {.lex_state = 424, .external_lex_state = 12},
  [15714] = {.lex_state = 424, .external_lex_state = 13},
  [15715] = {.lex_state = 0},
  [15716] = {.lex_state = 0},
  [15717] = {.lex_state = 424, .external_lex_state = 10},
  [15718] = {.lex_state = 424, .external_lex_state = 11},
  [15719] = {.lex_state = 424, .external_lex_state = 12},
  [15720] = {.lex_state = 424, .external_lex_state = 13},
  [15721] = {.lex_state = 424, .external_lex_state = 10},
  [15722] = {.lex_state = 424, .external_lex_state = 11},
  [15723] = {.lex_state = 424, .external_lex_state = 12},
  [15724] = {.lex_state = 424, .external_lex_state = 13},
  [15725] = {.lex_state = 424, .external_lex_state = 10},
  [15726] = {.lex_state = 424, .external_lex_state = 11},
  [15727] = {.lex_state = 424, .external_lex_state = 12},
  [15728] = {.lex_state = 424, .external_lex_state = 13},
  [15729] = {.lex_state = 424, .external_lex_state = 10},
  [15730] = {.lex_state = 424, .external_lex_state = 11},
  [15731] = {.lex_state = 424, .external_lex_state = 12},
  [15732] = {.lex_state = 424, .external_lex_state = 13},
  [15733] = {.lex_state = 424, .external_lex_state = 10},
  [15734] = {.lex_state = 424, .external_lex_state = 11},
  [15735] = {.lex_state = 424, .external_lex_state = 12},
  [15736] = {.lex_state = 424, .external_lex_state = 13},
  [15737] = {.lex_state = 424, .external_lex_state = 10},
  [15738] = {.lex_state = 424, .external_lex_state = 11},
  [15739] = {.lex_state = 424, .external_lex_state = 12},
  [15740] = {.lex_state = 424, .external_lex_state = 13},
  [15741] = {.lex_state = 424, .external_lex_state = 10},
  [15742] = {.lex_state = 424, .external_lex_state = 11},
  [15743] = {.lex_state = 424, .external_lex_state = 12},
  [15744] = {.lex_state = 424, .external_lex_state = 13},
  [15745] = {.lex_state = 424, .external_lex_state = 10},
  [15746] = {.lex_state = 424, .external_lex_state = 11},
  [15747] = {.lex_state = 424, .external_lex_state = 12},
  [15748] = {.lex_state = 424, .external_lex_state = 13},
  [15749] = {.lex_state = 424, .external_lex_state = 10},
  [15750] = {.lex_state = 424, .external_lex_state = 11},
  [15751] = {.lex_state = 424, .external_lex_state = 12},
  [15752] = {.lex_state = 424, .external_lex_state = 13},
  [15753] = {.lex_state = 424, .external_lex_state = 10},
  [15754] = {.lex_state = 424, .external_lex_state = 11},
  [15755] = {.lex_state = 424, .external_lex_state = 12},
  [15756] = {.lex_state = 424, .external_lex_state = 13},
  [15757] = {.lex_state = 424, .external_lex_state = 10},
  [15758] = {.lex_state = 424, .external_lex_state = 11},
  [15759] = {.lex_state = 424, .external_lex_state = 12},
  [15760] = {.lex_state = 424, .external_lex_state = 13},
  [15761] = {.lex_state = 424, .external_lex_state = 10},
  [15762] = {.lex_state = 424, .external_lex_state = 11},
  [15763] = {.lex_state = 424, .external_lex_state = 12},
  [15764] = {.lex_state = 424, .external_lex_state = 13},
  [15765] = {.lex_state = 505},
  [15766] = {.lex_state = 424, .external_lex_state = 10},
  [15767] = {.lex_state = 424, .external_lex_state = 11},
  [15768] = {.lex_state = 424, .external_lex_state = 12},
  [15769] = {.lex_state = 424, .external_lex_state = 13},
  [15770] = {.lex_state = 424, .external_lex_state = 10},
  [15771] = {.lex_state = 424, .external_lex_state = 11},
  [15772] = {.lex_state = 424, .external_lex_state = 12},
  [15773] = {.lex_state = 424, .external_lex_state = 13},
  [15774] = {.lex_state = 424, .external_lex_state = 10},
  [15775] = {.lex_state = 424, .external_lex_state = 11},
  [15776] = {.lex_state = 424, .external_lex_state = 12},
  [15777] = {.lex_state = 424, .external_lex_state = 13},
  [15778] = {.lex_state = 424, .external_lex_state = 10},
  [15779] = {.lex_state = 424, .external_lex_state = 11},
  [15780] = {.lex_state = 424, .external_lex_state = 12},
  [15781] = {.lex_state = 424, .external_lex_state = 13},
  [15782] = {.lex_state = 424, .external_lex_state = 10},
  [15783] = {.lex_state = 424, .external_lex_state = 11},
  [15784] = {.lex_state = 424, .external_lex_state = 12},
  [15785] = {.lex_state = 424, .external_lex_state = 13},
  [15786] = {.lex_state = 424, .external_lex_state = 10},
  [15787] = {.lex_state = 424, .external_lex_state = 11},
  [15788] = {.lex_state = 424, .external_lex_state = 12},
  [15789] = {.lex_state = 424, .external_lex_state = 13},
  [15790] = {.lex_state = 424, .external_lex_state = 10},
  [15791] = {.lex_state = 424, .external_lex_state = 11},
  [15792] = {.lex_state = 424, .external_lex_state = 12},
  [15793] = {.lex_state = 424, .external_lex_state = 13},
  [15794] = {.lex_state = 424, .external_lex_state = 10},
  [15795] = {.lex_state = 424, .external_lex_state = 11},
  [15796] = {.lex_state = 424, .external_lex_state = 12},
  [15797] = {.lex_state = 424, .external_lex_state = 13},
  [15798] = {.lex_state = 424, .external_lex_state = 10},
  [15799] = {.lex_state = 424, .external_lex_state = 11},
  [15800] = {.lex_state = 424, .external_lex_state = 12},
  [15801] = {.lex_state = 424, .external_lex_state = 13},
  [15802] = {.lex_state = 424, .external_lex_state = 10},
  [15803] = {.lex_state = 424, .external_lex_state = 11},
  [15804] = {.lex_state = 424, .external_lex_state = 12},
  [15805] = {.lex_state = 424, .external_lex_state = 13},
  [15806] = {.lex_state = 424, .external_lex_state = 10},
  [15807] = {.lex_state = 424, .external_lex_state = 11},
  [15808] = {.lex_state = 424, .external_lex_state = 12},
  [15809] = {.lex_state = 424, .external_lex_state = 13},
  [15810] = {.lex_state = 424, .external_lex_state = 10},
  [15811] = {.lex_state = 424, .external_lex_state = 11},
  [15812] = {.lex_state = 424, .external_lex_state = 12},
  [15813] = {.lex_state = 424, .external_lex_state = 13},
  [15814] = {.lex_state = 424, .external_lex_state = 10},
  [15815] = {.lex_state = 424, .external_lex_state = 11},
  [15816] = {.lex_state = 424, .external_lex_state = 12},
  [15817] = {.lex_state = 424, .external_lex_state = 13},
  [15818] = {.lex_state = 424, .external_lex_state = 10},
  [15819] = {.lex_state = 424, .external_lex_state = 11},
  [15820] = {.lex_state = 424, .external_lex_state = 12},
  [15821] = {.lex_state = 424, .external_lex_state = 13},
  [15822] = {.lex_state = 424, .external_lex_state = 10},
  [15823] = {.lex_state = 424, .external_lex_state = 11},
  [15824] = {.lex_state = 424, .external_lex_state = 12},
  [15825] = {.lex_state = 424, .external_lex_state = 13},
  [15826] = {.lex_state = 424, .external_lex_state = 10},
  [15827] = {.lex_state = 424, .external_lex_state = 11},
  [15828] = {.lex_state = 424, .external_lex_state = 12},
  [15829] = {.lex_state = 424, .external_lex_state = 13},
  [15830] = {.lex_state = 424, .external_lex_state = 10},
  [15831] = {.lex_state = 424, .external_lex_state = 11},
  [15832] = {.lex_state = 424, .external_lex_state = 12},
  [15833] = {.lex_state = 424, .external_lex_state = 13},
  [15834] = {.lex_state = 424, .external_lex_state = 10},
  [15835] = {.lex_state = 424, .external_lex_state = 11},
  [15836] = {.lex_state = 424, .external_lex_state = 12},
  [15837] = {.lex_state = 424, .external_lex_state = 13},
  [15838] = {.lex_state = 424, .external_lex_state = 10},
  [15839] = {.lex_state = 424, .external_lex_state = 11},
  [15840] = {.lex_state = 424, .external_lex_state = 12},
  [15841] = {.lex_state = 424, .external_lex_state = 13},
  [15842] = {.lex_state = 424, .external_lex_state = 10},
  [15843] = {.lex_state = 424, .external_lex_state = 11},
  [15844] = {.lex_state = 424, .external_lex_state = 12},
  [15845] = {.lex_state = 424, .external_lex_state = 13},
  [15846] = {.lex_state = 0},
  [15847] = {.lex_state = 424, .external_lex_state = 10},
  [15848] = {.lex_state = 424, .external_lex_state = 11},
  [15849] = {.lex_state = 424, .external_lex_state = 12},
  [15850] = {.lex_state = 424, .external_lex_state = 13},
  [15851] = {.lex_state = 424, .external_lex_state = 10},
  [15852] = {.lex_state = 424, .external_lex_state = 11},
  [15853] = {.lex_state = 424, .external_lex_state = 12},
  [15854] = {.lex_state = 424, .external_lex_state = 13},
  [15855] = {.lex_state = 424, .external_lex_state = 10},
  [15856] = {.lex_state = 424, .external_lex_state = 11},
  [15857] = {.lex_state = 424, .external_lex_state = 12},
  [15858] = {.lex_state = 424, .external_lex_state = 13},
  [15859] = {.lex_state = 424, .external_lex_state = 10},
  [15860] = {.lex_state = 424, .external_lex_state = 11},
  [15861] = {.lex_state = 424, .external_lex_state = 12},
  [15862] = {.lex_state = 424, .external_lex_state = 13},
  [15863] = {.lex_state = 424, .external_lex_state = 10},
  [15864] = {.lex_state = 424, .external_lex_state = 11},
  [15865] = {.lex_state = 424, .external_lex_state = 12},
  [15866] = {.lex_state = 424, .external_lex_state = 13},
  [15867] = {.lex_state = 424, .external_lex_state = 10},
  [15868] = {.lex_state = 424, .external_lex_state = 11},
  [15869] = {.lex_state = 424, .external_lex_state = 12},
  [15870] = {.lex_state = 424, .external_lex_state = 13},
  [15871] = {.lex_state = 424, .external_lex_state = 10},
  [15872] = {.lex_state = 424, .external_lex_state = 11},
  [15873] = {.lex_state = 424, .external_lex_state = 12},
  [15874] = {.lex_state = 424, .external_lex_state = 13},
  [15875] = {.lex_state = 424, .external_lex_state = 10},
  [15876] = {.lex_state = 424, .external_lex_state = 11},
  [15877] = {.lex_state = 424, .external_lex_state = 12},
  [15878] = {.lex_state = 424, .external_lex_state = 13},
  [15879] = {.lex_state = 424, .external_lex_state = 10},
  [15880] = {.lex_state = 424, .external_lex_state = 11},
  [15881] = {.lex_state = 424, .external_lex_state = 12},
  [15882] = {.lex_state = 424, .external_lex_state = 13},
  [15883] = {.lex_state = 424, .external_lex_state = 10},
  [15884] = {.lex_state = 424, .external_lex_state = 11},
  [15885] = {.lex_state = 424, .external_lex_state = 12},
  [15886] = {.lex_state = 424, .external_lex_state = 13},
  [15887] = {.lex_state = 424, .external_lex_state = 10},
  [15888] = {.lex_state = 424, .external_lex_state = 11},
  [15889] = {.lex_state = 424, .external_lex_state = 12},
  [15890] = {.lex_state = 424, .external_lex_state = 13},
  [15891] = {.lex_state = 424, .external_lex_state = 10},
  [15892] = {.lex_state = 424, .external_lex_state = 11},
  [15893] = {.lex_state = 424, .external_lex_state = 12},
  [15894] = {.lex_state = 424, .external_lex_state = 13},
  [15895] = {.lex_state = 424, .external_lex_state = 10},
  [15896] = {.lex_state = 424, .external_lex_state = 11},
  [15897] = {.lex_state = 424, .external_lex_state = 12},
  [15898] = {.lex_state = 424, .external_lex_state = 13},
  [15899] = {.lex_state = 424, .external_lex_state = 10},
  [15900] = {.lex_state = 424, .external_lex_state = 11},
  [15901] = {.lex_state = 424, .external_lex_state = 12},
  [15902] = {.lex_state = 424, .external_lex_state = 13},
  [15903] = {.lex_state = 424, .external_lex_state = 10},
  [15904] = {.lex_state = 424, .external_lex_state = 11},
  [15905] = {.lex_state = 424, .external_lex_state = 12},
  [15906] = {.lex_state = 424, .external_lex_state = 13},
  [15907] = {.lex_state = 424, .external_lex_state = 10},
  [15908] = {.lex_state = 424, .external_lex_state = 11},
  [15909] = {.lex_state = 424, .external_lex_state = 12},
  [15910] = {.lex_state = 424, .external_lex_state = 13},
  [15911] = {.lex_state = 424, .external_lex_state = 10},
  [15912] = {.lex_state = 424, .external_lex_state = 11},
  [15913] = {.lex_state = 424, .external_lex_state = 12},
  [15914] = {.lex_state = 424, .external_lex_state = 13},
  [15915] = {.lex_state = 0},
  [15916] = {.lex_state = 424, .external_lex_state = 10},
  [15917] = {.lex_state = 424, .external_lex_state = 11},
  [15918] = {.lex_state = 424, .external_lex_state = 12},
  [15919] = {.lex_state = 424, .external_lex_state = 13},
  [15920] = {.lex_state = 424, .external_lex_state = 10},
  [15921] = {.lex_state = 424, .external_lex_state = 11},
  [15922] = {.lex_state = 424, .external_lex_state = 12},
  [15923] = {.lex_state = 424, .external_lex_state = 13},
  [15924] = {.lex_state = 424, .external_lex_state = 10},
  [15925] = {.lex_state = 424, .external_lex_state = 11},
  [15926] = {.lex_state = 424, .external_lex_state = 12},
  [15927] = {.lex_state = 424, .external_lex_state = 13},
  [15928] = {.lex_state = 424, .external_lex_state = 10},
  [15929] = {.lex_state = 424, .external_lex_state = 11},
  [15930] = {.lex_state = 424, .external_lex_state = 12},
  [15931] = {.lex_state = 424, .external_lex_state = 13},
  [15932] = {.lex_state = 424, .external_lex_state = 10},
  [15933] = {.lex_state = 424, .external_lex_state = 11},
  [15934] = {.lex_state = 424, .external_lex_state = 12},
  [15935] = {.lex_state = 424, .external_lex_state = 13},
  [15936] = {.lex_state = 424, .external_lex_state = 10},
  [15937] = {.lex_state = 424, .external_lex_state = 11},
  [15938] = {.lex_state = 424, .external_lex_state = 12},
  [15939] = {.lex_state = 424, .external_lex_state = 13},
  [15940] = {.lex_state = 424, .external_lex_state = 10},
  [15941] = {.lex_state = 424, .external_lex_state = 11},
  [15942] = {.lex_state = 424, .external_lex_state = 12},
  [15943] = {.lex_state = 424, .external_lex_state = 13},
  [15944] = {.lex_state = 424, .external_lex_state = 10},
  [15945] = {.lex_state = 424, .external_lex_state = 11},
  [15946] = {.lex_state = 424, .external_lex_state = 12},
  [15947] = {.lex_state = 424, .external_lex_state = 13},
  [15948] = {.lex_state = 424, .external_lex_state = 10},
  [15949] = {.lex_state = 424, .external_lex_state = 11},
  [15950] = {.lex_state = 424, .external_lex_state = 12},
  [15951] = {.lex_state = 424, .external_lex_state = 13},
  [15952] = {.lex_state = 424, .external_lex_state = 10},
  [15953] = {.lex_state = 424, .external_lex_state = 11},
  [15954] = {.lex_state = 424, .external_lex_state = 12},
  [15955] = {.lex_state = 424, .external_lex_state = 13},
  [15956] = {.lex_state = 424, .external_lex_state = 10},
  [15957] = {.lex_state = 424, .external_lex_state = 11},
  [15958] = {.lex_state = 424, .external_lex_state = 12},
  [15959] = {.lex_state = 424, .external_lex_state = 13},
  [15960] = {.lex_state = 424, .external_lex_state = 10},
  [15961] = {.lex_state = 424, .external_lex_state = 11},
  [15962] = {.lex_state = 424, .external_lex_state = 12},
  [15963] = {.lex_state = 424, .external_lex_state = 13},
  [15964] = {.lex_state = 424, .external_lex_state = 10},
  [15965] = {.lex_state = 424, .external_lex_state = 11},
  [15966] = {.lex_state = 424, .external_lex_state = 12},
  [15967] = {.lex_state = 424, .external_lex_state = 13},
  [15968] = {.lex_state = 424, .external_lex_state = 10},
  [15969] = {.lex_state = 424, .external_lex_state = 11},
  [15970] = {.lex_state = 424, .external_lex_state = 12},
  [15971] = {.lex_state = 424, .external_lex_state = 13},
  [15972] = {.lex_state = 424, .external_lex_state = 10},
  [15973] = {.lex_state = 424, .external_lex_state = 11},
  [15974] = {.lex_state = 424, .external_lex_state = 12},
  [15975] = {.lex_state = 424, .external_lex_state = 13},
  [15976] = {.lex_state = 424, .external_lex_state = 10},
  [15977] = {.lex_state = 424, .external_lex_state = 11},
  [15978] = {.lex_state = 424, .external_lex_state = 12},
  [15979] = {.lex_state = 424, .external_lex_state = 13},
  [15980] = {.lex_state = 0},
  [15981] = {.lex_state = 424, .external_lex_state = 10},
  [15982] = {.lex_state = 424, .external_lex_state = 11},
  [15983] = {.lex_state = 424, .external_lex_state = 12},
  [15984] = {.lex_state = 424, .external_lex_state = 13},
  [15985] = {.lex_state = 424, .external_lex_state = 10},
  [15986] = {.lex_state = 424, .external_lex_state = 11},
  [15987] = {.lex_state = 424, .external_lex_state = 12},
  [15988] = {.lex_state = 424, .external_lex_state = 13},
  [15989] = {.lex_state = 424, .external_lex_state = 10},
  [15990] = {.lex_state = 424, .external_lex_state = 11},
  [15991] = {.lex_state = 424, .external_lex_state = 12},
  [15992] = {.lex_state = 424, .external_lex_state = 13},
  [15993] = {.lex_state = 424, .external_lex_state = 10},
  [15994] = {.lex_state = 424, .external_lex_state = 11},
  [15995] = {.lex_state = 424, .external_lex_state = 12},
  [15996] = {.lex_state = 424, .external_lex_state = 13},
  [15997] = {.lex_state = 424, .external_lex_state = 10},
  [15998] = {.lex_state = 424, .external_lex_state = 11},
  [15999] = {.lex_state = 424, .external_lex_state = 12},
  [16000] = {.lex_state = 424, .external_lex_state = 13},
  [16001] = {.lex_state = 424, .external_lex_state = 10},
  [16002] = {.lex_state = 424, .external_lex_state = 11},
  [16003] = {.lex_state = 424, .external_lex_state = 12},
  [16004] = {.lex_state = 424, .external_lex_state = 13},
  [16005] = {.lex_state = 424, .external_lex_state = 10},
  [16006] = {.lex_state = 424, .external_lex_state = 11},
  [16007] = {.lex_state = 424, .external_lex_state = 12},
  [16008] = {.lex_state = 424, .external_lex_state = 13},
  [16009] = {.lex_state = 424, .external_lex_state = 10},
  [16010] = {.lex_state = 424, .external_lex_state = 11},
  [16011] = {.lex_state = 424, .external_lex_state = 12},
  [16012] = {.lex_state = 424, .external_lex_state = 13},
  [16013] = {.lex_state = 424, .external_lex_state = 10},
  [16014] = {.lex_state = 424, .external_lex_state = 11},
  [16015] = {.lex_state = 424, .external_lex_state = 12},
  [16016] = {.lex_state = 424, .external_lex_state = 13},
  [16017] = {.lex_state = 424, .external_lex_state = 10},
  [16018] = {.lex_state = 424, .external_lex_state = 11},
  [16019] = {.lex_state = 424, .external_lex_state = 12},
  [16020] = {.lex_state = 424, .external_lex_state = 13},
  [16021] = {.lex_state = 424, .external_lex_state = 10},
  [16022] = {.lex_state = 424, .external_lex_state = 11},
  [16023] = {.lex_state = 424, .external_lex_state = 12},
  [16024] = {.lex_state = 424, .external_lex_state = 13},
  [16025] = {.lex_state = 424, .external_lex_state = 10},
  [16026] = {.lex_state = 424, .external_lex_state = 11},
  [16027] = {.lex_state = 424, .external_lex_state = 12},
  [16028] = {.lex_state = 424, .external_lex_state = 13},
  [16029] = {.lex_state = 424, .external_lex_state = 10},
  [16030] = {.lex_state = 424, .external_lex_state = 11},
  [16031] = {.lex_state = 424, .external_lex_state = 12},
  [16032] = {.lex_state = 424, .external_lex_state = 13},
  [16033] = {.lex_state = 424, .external_lex_state = 10},
  [16034] = {.lex_state = 424, .external_lex_state = 3},
  [16035] = {.lex_state = 424, .external_lex_state = 11},
  [16036] = {.lex_state = 424, .external_lex_state = 12},
  [16037] = {.lex_state = 424, .external_lex_state = 13},
  [16038] = {.lex_state = 0},
  [16039] = {.lex_state = 424, .external_lex_state = 10},
  [16040] = {.lex_state = 424, .external_lex_state = 11},
  [16041] = {.lex_state = 349},
  [16042] = {.lex_state = 424, .external_lex_state = 12},
  [16043] = {.lex_state = 424, .external_lex_state = 13},
  [16044] = {.lex_state = 0},
  [16045] = {.lex_state = 424, .external_lex_state = 7},
  [16046] = {.lex_state = 424, .external_lex_state = 13},
  [16047] = {.lex_state = 505},
  [16048] = {.lex_state = 0},
  [16049] = {.lex_state = 505},
  [16050] = {.lex_state = 363},
  [16051] = {.lex_state = 0},
  [16052] = {.lex_state = 424, .external_lex_state = 5},
  [16053] = {.lex_state = 0},
  [16054] = {.lex_state = 0},
  [16055] = {.lex_state = 505},
  [16056] = {.lex_state = 505},
  [16057] = {.lex_state = 363},
  [16058] = {.lex_state = 0},
  [16059] = {.lex_state = 0},
  [16060] = {.lex_state = 505},
  [16061] = {.lex_state = 505},
  [16062] = {.lex_state = 0},
  [16063] = {.lex_state = 424},
  [16064] = {.lex_state = 505},
  [16065] = {.lex_state = 505},
  [16066] = {.lex_state = 0},
  [16067] = {.lex_state = 0},
  [16068] = {.lex_state = 424, .external_lex_state = 10},
  [16069] = {.lex_state = 424, .external_lex_state = 11},
  [16070] = {.lex_state = 424, .external_lex_state = 12},
  [16071] = {.lex_state = 424, .external_lex_state = 13},
  [16072] = {.lex_state = 0},
  [16073] = {.lex_state = 0},
  [16074] = {.lex_state = 0},
  [16075] = {.lex_state = 505},
  [16076] = {.lex_state = 0},
  [16077] = {.lex_state = 0},
  [16078] = {.lex_state = 505},
  [16079] = {.lex_state = 505},
  [16080] = {.lex_state = 539},
  [16081] = {.lex_state = 424, .external_lex_state = 10},
  [16082] = {.lex_state = 424, .external_lex_state = 11},
  [16083] = {.lex_state = 424, .external_lex_state = 12},
  [16084] = {.lex_state = 424, .external_lex_state = 13},
  [16085] = {.lex_state = 0},
  [16086] = {.lex_state = 0},
  [16087] = {.lex_state = 0},
  [16088] = {.lex_state = 424, .external_lex_state = 3},
  [16089] = {.lex_state = 0},
  [16090] = {.lex_state = 0},
  [16091] = {.lex_state = 0},
  [16092] = {.lex_state = 349},
  [16093] = {.lex_state = 0},
  [16094] = {.lex_state = 424, .external_lex_state = 9},
  [16095] = {.lex_state = 424, .external_lex_state = 10},
  [16096] = {.lex_state = 505},
  [16097] = {.lex_state = 505},
  [16098] = {.lex_state = 424, .external_lex_state = 10},
  [16099] = {.lex_state = 424, .external_lex_state = 11},
  [16100] = {.lex_state = 424, .external_lex_state = 12},
  [16101] = {.lex_state = 424, .external_lex_state = 13},
  [16102] = {.lex_state = 0},
  [16103] = {.lex_state = 0},
  [16104] = {.lex_state = 424, .external_lex_state = 11},
  [16105] = {.lex_state = 0},
  [16106] = {.lex_state = 424, .external_lex_state = 10},
  [16107] = {.lex_state = 424, .external_lex_state = 10},
  [16108] = {.lex_state = 505},
  [16109] = {.lex_state = 424, .external_lex_state = 10},
  [16110] = {.lex_state = 424, .external_lex_state = 11},
  [16111] = {.lex_state = 424, .external_lex_state = 12},
  [16112] = {.lex_state = 424, .external_lex_state = 13},
  [16113] = {.lex_state = 424, .external_lex_state = 11},
  [16114] = {.lex_state = 424, .external_lex_state = 12},
  [16115] = {.lex_state = 424, .external_lex_state = 13},
  [16116] = {.lex_state = 424, .external_lex_state = 11},
  [16117] = {.lex_state = 0},
  [16118] = {.lex_state = 0},
  [16119] = {.lex_state = 0},
  [16120] = {.lex_state = 0},
  [16121] = {.lex_state = 0},
  [16122] = {.lex_state = 0},
  [16123] = {.lex_state = 505},
  [16124] = {.lex_state = 424, .external_lex_state = 12},
  [16125] = {.lex_state = 424, .external_lex_state = 13},
  [16126] = {.lex_state = 424, .external_lex_state = 12},
  [16127] = {.lex_state = 424, .external_lex_state = 13},
  [16128] = {.lex_state = 0},
  [16129] = {.lex_state = 0},
  [16130] = {.lex_state = 424, .external_lex_state = 10},
  [16131] = {.lex_state = 424, .external_lex_state = 11},
  [16132] = {.lex_state = 424, .external_lex_state = 12},
  [16133] = {.lex_state = 424, .external_lex_state = 13},
  [16134] = {.lex_state = 0},
  [16135] = {.lex_state = 0},
  [16136] = {.lex_state = 0},
  [16137] = {.lex_state = 0},
  [16138] = {.lex_state = 0},
  [16139] = {.lex_state = 0},
  [16140] = {.lex_state = 0},
  [16141] = {.lex_state = 0},
  [16142] = {.lex_state = 505},
  [16143] = {.lex_state = 0},
  [16144] = {.lex_state = 0},
  [16145] = {.lex_state = 0},
  [16146] = {.lex_state = 0},
  [16147] = {.lex_state = 505},
  [16148] = {.lex_state = 0},
  [16149] = {.lex_state = 424, .external_lex_state = 10},
  [16150] = {.lex_state = 424, .external_lex_state = 11},
  [16151] = {.lex_state = 424, .external_lex_state = 12},
  [16152] = {.lex_state = 424, .external_lex_state = 13},
  [16153] = {.lex_state = 505},
  [16154] = {.lex_state = 0},
  [16155] = {.lex_state = 0},
  [16156] = {.lex_state = 0},
  [16157] = {.lex_state = 424, .external_lex_state = 10},
  [16158] = {.lex_state = 424, .external_lex_state = 11},
  [16159] = {.lex_state = 424, .external_lex_state = 12},
  [16160] = {.lex_state = 424, .external_lex_state = 13},
  [16161] = {.lex_state = 0},
  [16162] = {.lex_state = 424, .external_lex_state = 10},
  [16163] = {.lex_state = 0},
  [16164] = {.lex_state = 0},
  [16165] = {.lex_state = 0},
  [16166] = {.lex_state = 424, .external_lex_state = 7},
  [16167] = {.lex_state = 424, .external_lex_state = 11},
  [16168] = {.lex_state = 424, .external_lex_state = 12},
  [16169] = {.lex_state = 424, .external_lex_state = 13},
  [16170] = {.lex_state = 0},
  [16171] = {.lex_state = 0},
  [16172] = {.lex_state = 349},
  [16173] = {.lex_state = 0},
  [16174] = {.lex_state = 0},
  [16175] = {.lex_state = 424, .external_lex_state = 10},
  [16176] = {.lex_state = 424, .external_lex_state = 10},
  [16177] = {.lex_state = 424, .external_lex_state = 11},
  [16178] = {.lex_state = 505},
  [16179] = {.lex_state = 424, .external_lex_state = 12},
  [16180] = {.lex_state = 424, .external_lex_state = 3},
  [16181] = {.lex_state = 363},
  [16182] = {.lex_state = 424, .external_lex_state = 11},
  [16183] = {.lex_state = 424, .external_lex_state = 13},
  [16184] = {.lex_state = 0},
  [16185] = {.lex_state = 0},
  [16186] = {.lex_state = 424, .external_lex_state = 12},
  [16187] = {.lex_state = 505},
  [16188] = {.lex_state = 505},
  [16189] = {.lex_state = 363},
  [16190] = {.lex_state = 424, .external_lex_state = 3},
  [16191] = {.lex_state = 0},
  [16192] = {.lex_state = 424, .external_lex_state = 13},
  [16193] = {.lex_state = 0},
  [16194] = {.lex_state = 0},
  [16195] = {.lex_state = 0},
  [16196] = {.lex_state = 0},
  [16197] = {.lex_state = 0},
  [16198] = {.lex_state = 0},
  [16199] = {.lex_state = 349},
  [16200] = {.lex_state = 0},
  [16201] = {.lex_state = 0},
  [16202] = {.lex_state = 0},
  [16203] = {.lex_state = 0},
  [16204] = {.lex_state = 505},
  [16205] = {.lex_state = 363},
  [16206] = {.lex_state = 424, .external_lex_state = 13},
  [16207] = {.lex_state = 0},
  [16208] = {.lex_state = 0},
  [16209] = {.lex_state = 424},
  [16210] = {.lex_state = 505},
  [16211] = {.lex_state = 505},
  [16212] = {.lex_state = 363},
  [16213] = {.lex_state = 505},
  [16214] = {.lex_state = 0},
  [16215] = {.lex_state = 349},
  [16216] = {.lex_state = 424, .external_lex_state = 3},
  [16217] = {.lex_state = 424, .external_lex_state = 10},
  [16218] = {.lex_state = 505},
  [16219] = {.lex_state = 0},
  [16220] = {.lex_state = 363},
  [16221] = {.lex_state = 0},
  [16222] = {.lex_state = 0},
  [16223] = {.lex_state = 0},
  [16224] = {.lex_state = 0},
  [16225] = {.lex_state = 505},
  [16226] = {.lex_state = 505},
  [16227] = {.lex_state = 363},
  [16228] = {.lex_state = 0},
  [16229] = {.lex_state = 0},
  [16230] = {.lex_state = 0},
  [16231] = {.lex_state = 0},
  [16232] = {.lex_state = 0},
  [16233] = {.lex_state = 349},
  [16234] = {.lex_state = 424, .external_lex_state = 9},
  [16235] = {.lex_state = 0},
  [16236] = {.lex_state = 505},
  [16237] = {.lex_state = 505},
  [16238] = {.lex_state = 363},
  [16239] = {.lex_state = 0},
  [16240] = {.lex_state = 0},
  [16241] = {.lex_state = 505},
  [16242] = {.lex_state = 505},
  [16243] = {.lex_state = 363},
  [16244] = {.lex_state = 424, .external_lex_state = 11},
  [16245] = {.lex_state = 505},
  [16246] = {.lex_state = 424, .external_lex_state = 10},
  [16247] = {.lex_state = 424, .external_lex_state = 11},
  [16248] = {.lex_state = 424, .external_lex_state = 12},
  [16249] = {.lex_state = 349},
  [16250] = {.lex_state = 424, .external_lex_state = 13},
  [16251] = {.lex_state = 0},
  [16252] = {.lex_state = 0},
  [16253] = {.lex_state = 0},
  [16254] = {.lex_state = 505},
  [16255] = {.lex_state = 0},
  [16256] = {.lex_state = 363},
  [16257] = {.lex_state = 505},
  [16258] = {.lex_state = 0},
  [16259] = {.lex_state = 0},
  [16260] = {.lex_state = 505},
  [16261] = {.lex_state = 505},
  [16262] = {.lex_state = 363},
  [16263] = {.lex_state = 349},
  [16264] = {.lex_state = 505},
  [16265] = {.lex_state = 505},
  [16266] = {.lex_state = 0},
  [16267] = {.lex_state = 424, .external_lex_state = 10},
  [16268] = {.lex_state = 505},
  [16269] = {.lex_state = 363},
  [16270] = {.lex_state = 424, .external_lex_state = 11},
  [16271] = {.lex_state = 0},
  [16272] = {.lex_state = 0},
  [16273] = {.lex_state = 505},
  [16274] = {.lex_state = 505},
  [16275] = {.lex_state = 363},
  [16276] = {.lex_state = 424, .external_lex_state = 10},
  [16277] = {.lex_state = 349},
  [16278] = {.lex_state = 424, .external_lex_state = 11},
  [16279] = {.lex_state = 424, .external_lex_state = 12},
  [16280] = {.lex_state = 424, .external_lex_state = 13},
  [16281] = {.lex_state = 424, .external_lex_state = 12},
  [16282] = {.lex_state = 0},
  [16283] = {.lex_state = 505},
  [16284] = {.lex_state = 363},
  [16285] = {.lex_state = 424, .external_lex_state = 3},
  [16286] = {.lex_state = 0},
  [16287] = {.lex_state = 0},
  [16288] = {.lex_state = 0},
  [16289] = {.lex_state = 505},
  [16290] = {.lex_state = 505},
  [16291] = {.lex_state = 363},
  [16292] = {.lex_state = 424, .external_lex_state = 13},
  [16293] = {.lex_state = 349},
  [16294] = {.lex_state = 424, .external_lex_state = 10},
  [16295] = {.lex_state = 424, .external_lex_state = 11},
  [16296] = {.lex_state = 424, .external_lex_state = 12},
  [16297] = {.lex_state = 424, .external_lex_state = 13},
  [16298] = {.lex_state = 505},
  [16299] = {.lex_state = 363},
  [16300] = {.lex_state = 0},
  [16301] = {.lex_state = 0},
  [16302] = {.lex_state = 505},
  [16303] = {.lex_state = 505},
  [16304] = {.lex_state = 363},
  [16305] = {.lex_state = 349},
  [16306] = {.lex_state = 424},
  [16307] = {.lex_state = 0},
  [16308] = {.lex_state = 505},
  [16309] = {.lex_state = 505},
  [16310] = {.lex_state = 0},
  [16311] = {.lex_state = 363},
  [16312] = {.lex_state = 0},
  [16313] = {.lex_state = 0},
  [16314] = {.lex_state = 505},
  [16315] = {.lex_state = 505},
  [16316] = {.lex_state = 363},
  [16317] = {.lex_state = 349},
  [16318] = {.lex_state = 505},
  [16319] = {.lex_state = 505},
  [16320] = {.lex_state = 505},
  [16321] = {.lex_state = 505},
  [16322] = {.lex_state = 363},
  [16323] = {.lex_state = 0},
  [16324] = {.lex_state = 0},
  [16325] = {.lex_state = 505},
  [16326] = {.lex_state = 505},
  [16327] = {.lex_state = 363},
  [16328] = {.lex_state = 0},
  [16329] = {.lex_state = 0},
  [16330] = {.lex_state = 0},
  [16331] = {.lex_state = 0},
  [16332] = {.lex_state = 0},
  [16333] = {.lex_state = 0},
  [16334] = {.lex_state = 0},
  [16335] = {.lex_state = 0},
  [16336] = {.lex_state = 0},
  [16337] = {.lex_state = 0},
  [16338] = {.lex_state = 0},
  [16339] = {.lex_state = 0},
  [16340] = {.lex_state = 0},
  [16341] = {.lex_state = 0},
  [16342] = {.lex_state = 0},
  [16343] = {.lex_state = 0},
  [16344] = {.lex_state = 0},
  [16345] = {.lex_state = 424, .external_lex_state = 10},
  [16346] = {.lex_state = 0},
  [16347] = {.lex_state = 0},
  [16348] = {.lex_state = 0},
  [16349] = {.lex_state = 0},
  [16350] = {.lex_state = 0},
  [16351] = {.lex_state = 0},
  [16352] = {.lex_state = 0},
  [16353] = {.lex_state = 0},
  [16354] = {.lex_state = 0},
  [16355] = {.lex_state = 0},
  [16356] = {.lex_state = 0},
  [16357] = {.lex_state = 0},
  [16358] = {.lex_state = 0},
  [16359] = {.lex_state = 0},
  [16360] = {.lex_state = 0},
  [16361] = {.lex_state = 0},
  [16362] = {.lex_state = 0},
  [16363] = {.lex_state = 0},
  [16364] = {.lex_state = 0},
  [16365] = {.lex_state = 0},
  [16366] = {.lex_state = 0},
  [16367] = {.lex_state = 0},
  [16368] = {.lex_state = 0},
  [16369] = {.lex_state = 0},
  [16370] = {.lex_state = 0},
  [16371] = {.lex_state = 0},
  [16372] = {.lex_state = 0},
  [16373] = {.lex_state = 0},
  [16374] = {.lex_state = 0},
  [16375] = {.lex_state = 0},
  [16376] = {.lex_state = 0},
  [16377] = {.lex_state = 0},
  [16378] = {.lex_state = 0},
  [16379] = {.lex_state = 0},
  [16380] = {.lex_state = 0},
  [16381] = {.lex_state = 0},
  [16382] = {.lex_state = 0},
  [16383] = {.lex_state = 0},
  [16384] = {.lex_state = 0},
  [16385] = {.lex_state = 0},
  [16386] = {.lex_state = 505},
  [16387] = {.lex_state = 0},
  [16388] = {.lex_state = 0},
  [16389] = {.lex_state = 0},
  [16390] = {.lex_state = 0},
  [16391] = {.lex_state = 0},
  [16392] = {.lex_state = 0},
  [16393] = {.lex_state = 0},
  [16394] = {.lex_state = 0},
  [16395] = {.lex_state = 0},
  [16396] = {.lex_state = 0},
  [16397] = {.lex_state = 0},
  [16398] = {.lex_state = 0},
  [16399] = {.lex_state = 0},
  [16400] = {.lex_state = 0},
  [16401] = {.lex_state = 0},
  [16402] = {.lex_state = 0},
  [16403] = {.lex_state = 0},
  [16404] = {.lex_state = 0},
  [16405] = {.lex_state = 0},
  [16406] = {.lex_state = 0},
  [16407] = {.lex_state = 424, .external_lex_state = 12},
  [16408] = {.lex_state = 0},
  [16409] = {.lex_state = 0},
  [16410] = {.lex_state = 0},
  [16411] = {.lex_state = 0},
  [16412] = {.lex_state = 424, .external_lex_state = 3},
  [16413] = {.lex_state = 0},
  [16414] = {.lex_state = 0},
  [16415] = {.lex_state = 0},
  [16416] = {.lex_state = 0},
  [16417] = {.lex_state = 0},
  [16418] = {.lex_state = 0},
  [16419] = {.lex_state = 0},
  [16420] = {.lex_state = 0},
  [16421] = {.lex_state = 505},
  [16422] = {.lex_state = 0},
  [16423] = {.lex_state = 0},
  [16424] = {.lex_state = 0},
  [16425] = {.lex_state = 0},
  [16426] = {.lex_state = 0},
  [16427] = {.lex_state = 0},
  [16428] = {.lex_state = 0},
  [16429] = {.lex_state = 0},
  [16430] = {.lex_state = 0},
  [16431] = {.lex_state = 505},
  [16432] = {.lex_state = 0},
  [16433] = {.lex_state = 0},
  [16434] = {.lex_state = 0},
  [16435] = {.lex_state = 0},
  [16436] = {.lex_state = 424, .external_lex_state = 13},
  [16437] = {.lex_state = 0},
  [16438] = {.lex_state = 0},
  [16439] = {.lex_state = 0},
  [16440] = {.lex_state = 0},
  [16441] = {.lex_state = 0},
  [16442] = {.lex_state = 0},
  [16443] = {.lex_state = 424, .external_lex_state = 10},
  [16444] = {.lex_state = 0},
  [16445] = {.lex_state = 0},
  [16446] = {.lex_state = 0},
  [16447] = {.lex_state = 0},
  [16448] = {.lex_state = 0},
  [16449] = {.lex_state = 0},
  [16450] = {.lex_state = 424, .external_lex_state = 10},
  [16451] = {.lex_state = 0},
  [16452] = {.lex_state = 0},
  [16453] = {.lex_state = 424, .external_lex_state = 11},
  [16454] = {.lex_state = 0},
  [16455] = {.lex_state = 0},
  [16456] = {.lex_state = 424, .external_lex_state = 12},
  [16457] = {.lex_state = 0},
  [16458] = {.lex_state = 0},
  [16459] = {.lex_state = 424, .external_lex_state = 13},
  [16460] = {.lex_state = 0},
  [16461] = {.lex_state = 0},
  [16462] = {.lex_state = 0},
  [16463] = {.lex_state = 0},
  [16464] = {.lex_state = 0},
  [16465] = {.lex_state = 0},
  [16466] = {.lex_state = 0},
  [16467] = {.lex_state = 0},
  [16468] = {.lex_state = 0},
  [16469] = {.lex_state = 0},
  [16470] = {.lex_state = 0},
  [16471] = {.lex_state = 0},
  [16472] = {.lex_state = 0},
  [16473] = {.lex_state = 0},
  [16474] = {.lex_state = 0},
  [16475] = {.lex_state = 0},
  [16476] = {.lex_state = 0},
  [16477] = {.lex_state = 0},
  [16478] = {.lex_state = 0},
  [16479] = {.lex_state = 0},
  [16480] = {.lex_state = 0},
  [16481] = {.lex_state = 0},
  [16482] = {.lex_state = 0},
  [16483] = {.lex_state = 0},
  [16484] = {.lex_state = 0},
  [16485] = {.lex_state = 0},
  [16486] = {.lex_state = 0},
  [16487] = {.lex_state = 0},
  [16488] = {.lex_state = 0},
  [16489] = {.lex_state = 0},
  [16490] = {.lex_state = 0},
  [16491] = {.lex_state = 0},
  [16492] = {.lex_state = 0},
  [16493] = {.lex_state = 0},
  [16494] = {.lex_state = 0},
  [16495] = {.lex_state = 0},
  [16496] = {.lex_state = 0},
  [16497] = {.lex_state = 0},
  [16498] = {.lex_state = 0},
  [16499] = {.lex_state = 0},
  [16500] = {.lex_state = 0},
  [16501] = {.lex_state = 0},
  [16502] = {.lex_state = 0},
  [16503] = {.lex_state = 0},
  [16504] = {.lex_state = 0},
  [16505] = {.lex_state = 0},
  [16506] = {.lex_state = 0},
  [16507] = {.lex_state = 0},
  [16508] = {.lex_state = 0},
  [16509] = {.lex_state = 0},
  [16510] = {.lex_state = 0},
  [16511] = {.lex_state = 0},
  [16512] = {.lex_state = 0},
  [16513] = {.lex_state = 0},
  [16514] = {.lex_state = 0},
  [16515] = {.lex_state = 0},
  [16516] = {.lex_state = 0},
  [16517] = {.lex_state = 0},
  [16518] = {.lex_state = 0},
  [16519] = {.lex_state = 0},
  [16520] = {.lex_state = 0},
  [16521] = {.lex_state = 0},
  [16522] = {.lex_state = 0},
  [16523] = {.lex_state = 0},
  [16524] = {.lex_state = 0},
  [16525] = {.lex_state = 0},
  [16526] = {.lex_state = 0},
  [16527] = {.lex_state = 0},
  [16528] = {.lex_state = 0},
  [16529] = {.lex_state = 0},
  [16530] = {.lex_state = 0},
  [16531] = {.lex_state = 0},
  [16532] = {.lex_state = 0},
  [16533] = {.lex_state = 0},
  [16534] = {.lex_state = 0},
  [16535] = {.lex_state = 0},
  [16536] = {.lex_state = 0},
  [16537] = {.lex_state = 0},
  [16538] = {.lex_state = 0},
  [16539] = {.lex_state = 0},
  [16540] = {.lex_state = 0},
  [16541] = {.lex_state = 0},
  [16542] = {.lex_state = 0},
  [16543] = {.lex_state = 0},
  [16544] = {.lex_state = 424, .external_lex_state = 11},
  [16545] = {.lex_state = 505},
  [16546] = {.lex_state = 424, .external_lex_state = 12},
  [16547] = {.lex_state = 424, .external_lex_state = 13},
  [16548] = {.lex_state = 0},
  [16549] = {.lex_state = 0},
  [16550] = {.lex_state = 539},
  [16551] = {.lex_state = 0},
  [16552] = {.lex_state = 0},
  [16553] = {.lex_state = 424, .external_lex_state = 11},
  [16554] = {.lex_state = 0},
  [16555] = {.lex_state = 0},
  [16556] = {.lex_state = 0},
  [16557] = {.lex_state = 424, .external_lex_state = 10},
  [16558] = {.lex_state = 424, .external_lex_state = 11},
  [16559] = {.lex_state = 424, .external_lex_state = 12},
  [16560] = {.lex_state = 424, .external_lex_state = 13},
  [16561] = {.lex_state = 0},
  [16562] = {.lex_state = 0},
  [16563] = {.lex_state = 0},
  [16564] = {.lex_state = 0},
  [16565] = {.lex_state = 0},
  [16566] = {.lex_state = 424, .external_lex_state = 10},
  [16567] = {.lex_state = 424, .external_lex_state = 11},
  [16568] = {.lex_state = 424, .external_lex_state = 12},
  [16569] = {.lex_state = 424, .external_lex_state = 13},
  [16570] = {.lex_state = 424, .external_lex_state = 10},
  [16571] = {.lex_state = 424, .external_lex_state = 11},
  [16572] = {.lex_state = 424, .external_lex_state = 12},
  [16573] = {.lex_state = 424, .external_lex_state = 13},
  [16574] = {.lex_state = 0},
  [16575] = {.lex_state = 0},
  [16576] = {.lex_state = 505},
  [16577] = {.lex_state = 0},
  [16578] = {.lex_state = 0},
  [16579] = {.lex_state = 0},
  [16580] = {.lex_state = 424, .external_lex_state = 3},
  [16581] = {.lex_state = 424, .external_lex_state = 10},
  [16582] = {.lex_state = 424, .external_lex_state = 10},
  [16583] = {.lex_state = 424, .external_lex_state = 11},
  [16584] = {.lex_state = 424, .external_lex_state = 12},
  [16585] = {.lex_state = 424, .external_lex_state = 11},
  [16586] = {.lex_state = 424, .external_lex_state = 12},
  [16587] = {.lex_state = 424, .external_lex_state = 13},
  [16588] = {.lex_state = 424, .external_lex_state = 13},
  [16589] = {.lex_state = 0},
  [16590] = {.lex_state = 363},
  [16591] = {.lex_state = 0},
  [16592] = {.lex_state = 424, .external_lex_state = 9},
  [16593] = {.lex_state = 0},
  [16594] = {.lex_state = 0},
  [16595] = {.lex_state = 0},
  [16596] = {.lex_state = 0},
  [16597] = {.lex_state = 424, .external_lex_state = 10},
  [16598] = {.lex_state = 424, .external_lex_state = 11},
  [16599] = {.lex_state = 424, .external_lex_state = 12},
  [16600] = {.lex_state = 505},
  [16601] = {.lex_state = 424, .external_lex_state = 12},
  [16602] = {.lex_state = 424, .external_lex_state = 13},
  [16603] = {.lex_state = 424, .external_lex_state = 9},
  [16604] = {.lex_state = 505},
  [16605] = {.lex_state = 424},
  [16606] = {.lex_state = 0},
  [16607] = {.lex_state = 0},
  [16608] = {.lex_state = 0},
  [16609] = {.lex_state = 424, .external_lex_state = 3},
  [16610] = {.lex_state = 424, .external_lex_state = 3},
  [16611] = {.lex_state = 0},
  [16612] = {.lex_state = 505},
  [16613] = {.lex_state = 0},
  [16614] = {.lex_state = 0},
  [16615] = {.lex_state = 0},
  [16616] = {.lex_state = 424},
  [16617] = {.lex_state = 0},
  [16618] = {.lex_state = 424, .external_lex_state = 10},
  [16619] = {.lex_state = 424, .external_lex_state = 11},
  [16620] = {.lex_state = 424, .external_lex_state = 12},
  [16621] = {.lex_state = 424, .external_lex_state = 13},
  [16622] = {.lex_state = 0},
  [16623] = {.lex_state = 0},
  [16624] = {.lex_state = 0},
  [16625] = {.lex_state = 505},
  [16626] = {.lex_state = 0},
  [16627] = {.lex_state = 424, .external_lex_state = 8},
  [16628] = {.lex_state = 424, .external_lex_state = 8},
  [16629] = {.lex_state = 0},
  [16630] = {.lex_state = 0},
  [16631] = {.lex_state = 424, .external_lex_state = 10},
  [16632] = {.lex_state = 424, .external_lex_state = 11},
  [16633] = {.lex_state = 0},
  [16634] = {.lex_state = 424, .external_lex_state = 12},
  [16635] = {.lex_state = 424, .external_lex_state = 13},
  [16636] = {.lex_state = 0},
  [16637] = {.lex_state = 0},
  [16638] = {.lex_state = 424, .external_lex_state = 10},
  [16639] = {.lex_state = 0},
  [16640] = {.lex_state = 424, .external_lex_state = 11},
  [16641] = {.lex_state = 424, .external_lex_state = 12},
  [16642] = {.lex_state = 424, .external_lex_state = 13},
  [16643] = {.lex_state = 0},
  [16644] = {.lex_state = 0},
  [16645] = {.lex_state = 424, .external_lex_state = 10},
  [16646] = {.lex_state = 0},
  [16647] = {.lex_state = 424, .external_lex_state = 11},
  [16648] = {.lex_state = 562},
  [16649] = {.lex_state = 424, .external_lex_state = 12},
  [16650] = {.lex_state = 424, .external_lex_state = 13},
  [16651] = {.lex_state = 424, .external_lex_state = 3},
  [16652] = {.lex_state = 424, .external_lex_state = 3},
  [16653] = {.lex_state = 0},
  [16654] = {.lex_state = 424, .external_lex_state = 10},
  [16655] = {.lex_state = 424, .external_lex_state = 11},
  [16656] = {.lex_state = 424, .external_lex_state = 12},
  [16657] = {.lex_state = 424, .external_lex_state = 13},
  [16658] = {.lex_state = 424, .external_lex_state = 10},
  [16659] = {.lex_state = 0},
  [16660] = {.lex_state = 424, .external_lex_state = 3},
  [16661] = {.lex_state = 424, .external_lex_state = 11},
  [16662] = {.lex_state = 424, .external_lex_state = 12},
  [16663] = {.lex_state = 424, .external_lex_state = 3},
  [16664] = {.lex_state = 0},
  [16665] = {.lex_state = 505},
  [16666] = {.lex_state = 0},
  [16667] = {.lex_state = 424, .external_lex_state = 13},
  [16668] = {.lex_state = 0},
  [16669] = {.lex_state = 505},
  [16670] = {.lex_state = 0},
  [16671] = {.lex_state = 0},
  [16672] = {.lex_state = 424, .external_lex_state = 13},
  [16673] = {.lex_state = 0},
  [16674] = {.lex_state = 0},
  [16675] = {.lex_state = 0},
  [16676] = {.lex_state = 0},
  [16677] = {.lex_state = 505},
  [16678] = {.lex_state = 505},
  [16679] = {.lex_state = 424, .external_lex_state = 10},
  [16680] = {.lex_state = 424, .external_lex_state = 11},
  [16681] = {.lex_state = 424, .external_lex_state = 12},
  [16682] = {.lex_state = 424, .external_lex_state = 13},
  [16683] = {.lex_state = 562},
  [16684] = {.lex_state = 0},
  [16685] = {.lex_state = 0},
  [16686] = {.lex_state = 0},
  [16687] = {.lex_state = 0},
  [16688] = {.lex_state = 424, .external_lex_state = 3},
  [16689] = {.lex_state = 424, .external_lex_state = 3},
  [16690] = {.lex_state = 0},
  [16691] = {.lex_state = 0},
  [16692] = {.lex_state = 424, .external_lex_state = 3},
  [16693] = {.lex_state = 424, .external_lex_state = 3},
  [16694] = {.lex_state = 424, .external_lex_state = 3},
  [16695] = {.lex_state = 505},
  [16696] = {.lex_state = 424, .external_lex_state = 10},
  [16697] = {.lex_state = 505},
  [16698] = {.lex_state = 424, .external_lex_state = 3},
  [16699] = {.lex_state = 424, .external_lex_state = 10},
  [16700] = {.lex_state = 424, .external_lex_state = 11},
  [16701] = {.lex_state = 424, .external_lex_state = 12},
  [16702] = {.lex_state = 424, .external_lex_state = 13},
  [16703] = {.lex_state = 424, .external_lex_state = 3},
  [16704] = {.lex_state = 424, .external_lex_state = 3},
  [16705] = {.lex_state = 0},
  [16706] = {.lex_state = 424, .external_lex_state = 3},
  [16707] = {.lex_state = 424, .external_lex_state = 10},
  [16708] = {.lex_state = 424, .external_lex_state = 3},
  [16709] = {.lex_state = 424, .external_lex_state = 11},
  [16710] = {.lex_state = 424, .external_lex_state = 12},
  [16711] = {.lex_state = 424, .external_lex_state = 13},
  [16712] = {.lex_state = 424, .external_lex_state = 3},
  [16713] = {.lex_state = 0},
  [16714] = {.lex_state = 424, .external_lex_state = 3},
  [16715] = {.lex_state = 0},
  [16716] = {.lex_state = 424, .external_lex_state = 3},
  [16717] = {.lex_state = 424, .external_lex_state = 11},
  [16718] = {.lex_state = 0},
  [16719] = {.lex_state = 424, .external_lex_state = 12},
  [16720] = {.lex_state = 424, .external_lex_state = 10},
  [16721] = {.lex_state = 0},
  [16722] = {.lex_state = 0},
  [16723] = {.lex_state = 0},
  [16724] = {.lex_state = 0},
  [16725] = {.lex_state = 424, .external_lex_state = 10},
  [16726] = {.lex_state = 424, .external_lex_state = 11},
  [16727] = {.lex_state = 424, .external_lex_state = 12},
  [16728] = {.lex_state = 424, .external_lex_state = 13},
  [16729] = {.lex_state = 424, .external_lex_state = 10},
  [16730] = {.lex_state = 0},
  [16731] = {.lex_state = 424, .external_lex_state = 11},
  [16732] = {.lex_state = 505},
  [16733] = {.lex_state = 424, .external_lex_state = 12},
  [16734] = {.lex_state = 0},
  [16735] = {.lex_state = 424, .external_lex_state = 13},
  [16736] = {.lex_state = 424, .external_lex_state = 3},
  [16737] = {.lex_state = 0},
  [16738] = {.lex_state = 505},
  [16739] = {.lex_state = 505},
  [16740] = {.lex_state = 0},
  [16741] = {.lex_state = 0},
  [16742] = {.lex_state = 505},
  [16743] = {.lex_state = 505},
  [16744] = {.lex_state = 0},
  [16745] = {.lex_state = 0},
  [16746] = {.lex_state = 424, .external_lex_state = 13},
  [16747] = {.lex_state = 424, .external_lex_state = 10},
  [16748] = {.lex_state = 424, .external_lex_state = 11},
  [16749] = {.lex_state = 424, .external_lex_state = 12},
  [16750] = {.lex_state = 424, .external_lex_state = 13},
  [16751] = {.lex_state = 0},
  [16752] = {.lex_state = 0},
  [16753] = {.lex_state = 0},
  [16754] = {.lex_state = 0},
  [16755] = {.lex_state = 0},
  [16756] = {.lex_state = 424, .external_lex_state = 3},
  [16757] = {.lex_state = 505},
  [16758] = {.lex_state = 363},
  [16759] = {.lex_state = 424, .external_lex_state = 3},
  [16760] = {.lex_state = 0},
  [16761] = {.lex_state = 424, .external_lex_state = 3},
  [16762] = {.lex_state = 424, .external_lex_state = 3},
  [16763] = {.lex_state = 424, .external_lex_state = 10},
  [16764] = {.lex_state = 424, .external_lex_state = 11},
  [16765] = {.lex_state = 424, .external_lex_state = 12},
  [16766] = {.lex_state = 424, .external_lex_state = 13},
  [16767] = {.lex_state = 0},
  [16768] = {.lex_state = 424, .external_lex_state = 3},
  [16769] = {.lex_state = 424, .external_lex_state = 10},
  [16770] = {.lex_state = 424, .external_lex_state = 11},
  [16771] = {.lex_state = 0},
  [16772] = {.lex_state = 424, .external_lex_state = 12},
  [16773] = {.lex_state = 424, .external_lex_state = 13},
  [16774] = {.lex_state = 0},
  [16775] = {.lex_state = 424, .external_lex_state = 3},
  [16776] = {.lex_state = 0},
  [16777] = {.lex_state = 0},
  [16778] = {.lex_state = 0},
  [16779] = {.lex_state = 424, .external_lex_state = 3},
  [16780] = {.lex_state = 424, .external_lex_state = 3},
  [16781] = {.lex_state = 505},
  [16782] = {.lex_state = 424, .external_lex_state = 3},
  [16783] = {.lex_state = 0},
  [16784] = {.lex_state = 0},
  [16785] = {.lex_state = 0},
  [16786] = {.lex_state = 0},
  [16787] = {.lex_state = 505},
  [16788] = {.lex_state = 424, .external_lex_state = 3},
  [16789] = {.lex_state = 424, .external_lex_state = 3},
  [16790] = {.lex_state = 505},
  [16791] = {.lex_state = 0},
  [16792] = {.lex_state = 424, .external_lex_state = 3},
  [16793] = {.lex_state = 0},
  [16794] = {.lex_state = 0},
  [16795] = {.lex_state = 424, .external_lex_state = 10},
  [16796] = {.lex_state = 0},
  [16797] = {.lex_state = 424, .external_lex_state = 11},
  [16798] = {.lex_state = 424, .external_lex_state = 10},
  [16799] = {.lex_state = 424, .external_lex_state = 12},
  [16800] = {.lex_state = 424, .external_lex_state = 13},
  [16801] = {.lex_state = 424, .external_lex_state = 11},
  [16802] = {.lex_state = 505},
  [16803] = {.lex_state = 424, .external_lex_state = 10},
  [16804] = {.lex_state = 424, .external_lex_state = 11},
  [16805] = {.lex_state = 424, .external_lex_state = 12},
  [16806] = {.lex_state = 424, .external_lex_state = 13},
  [16807] = {.lex_state = 0},
  [16808] = {.lex_state = 0},
  [16809] = {.lex_state = 0},
  [16810] = {.lex_state = 0},
  [16811] = {.lex_state = 0},
  [16812] = {.lex_state = 424, .external_lex_state = 12},
  [16813] = {.lex_state = 424, .external_lex_state = 10},
  [16814] = {.lex_state = 0},
  [16815] = {.lex_state = 424, .external_lex_state = 11},
  [16816] = {.lex_state = 424, .external_lex_state = 12},
  [16817] = {.lex_state = 424, .external_lex_state = 13},
  [16818] = {.lex_state = 0},
  [16819] = {.lex_state = 424, .external_lex_state = 10},
  [16820] = {.lex_state = 424, .external_lex_state = 11},
  [16821] = {.lex_state = 424, .external_lex_state = 12},
  [16822] = {.lex_state = 505},
  [16823] = {.lex_state = 424, .external_lex_state = 13},
  [16824] = {.lex_state = 424, .external_lex_state = 13},
  [16825] = {.lex_state = 0},
  [16826] = {.lex_state = 0},
  [16827] = {.lex_state = 424, .external_lex_state = 10},
  [16828] = {.lex_state = 424, .external_lex_state = 11},
  [16829] = {.lex_state = 424, .external_lex_state = 12},
  [16830] = {.lex_state = 424, .external_lex_state = 13},
  [16831] = {.lex_state = 0},
  [16832] = {.lex_state = 0},
  [16833] = {.lex_state = 0},
  [16834] = {.lex_state = 0},
  [16835] = {.lex_state = 0},
  [16836] = {.lex_state = 0},
  [16837] = {.lex_state = 424, .external_lex_state = 10},
  [16838] = {.lex_state = 505},
  [16839] = {.lex_state = 424, .external_lex_state = 11},
  [16840] = {.lex_state = 424, .external_lex_state = 12},
  [16841] = {.lex_state = 424, .external_lex_state = 13},
  [16842] = {.lex_state = 0},
  [16843] = {.lex_state = 0},
  [16844] = {.lex_state = 0},
  [16845] = {.lex_state = 0},
  [16846] = {.lex_state = 363},
  [16847] = {.lex_state = 505},
  [16848] = {.lex_state = 0},
  [16849] = {.lex_state = 424},
  [16850] = {.lex_state = 424, .external_lex_state = 10},
  [16851] = {.lex_state = 424, .external_lex_state = 11},
  [16852] = {.lex_state = 424, .external_lex_state = 12},
  [16853] = {.lex_state = 424, .external_lex_state = 13},
  [16854] = {.lex_state = 0},
  [16855] = {.lex_state = 0},
  [16856] = {.lex_state = 424, .external_lex_state = 10},
  [16857] = {.lex_state = 424, .external_lex_state = 11},
  [16858] = {.lex_state = 424, .external_lex_state = 12},
  [16859] = {.lex_state = 363},
  [16860] = {.lex_state = 424, .external_lex_state = 13},
  [16861] = {.lex_state = 505},
  [16862] = {.lex_state = 0},
  [16863] = {.lex_state = 0},
  [16864] = {.lex_state = 0},
  [16865] = {.lex_state = 424, .external_lex_state = 10},
  [16866] = {.lex_state = 424, .external_lex_state = 11},
  [16867] = {.lex_state = 424, .external_lex_state = 12},
  [16868] = {.lex_state = 505},
  [16869] = {.lex_state = 424, .external_lex_state = 13},
  [16870] = {.lex_state = 505},
  [16871] = {.lex_state = 0},
  [16872] = {.lex_state = 0},
  [16873] = {.lex_state = 505},
  [16874] = {.lex_state = 0},
  [16875] = {.lex_state = 505},
  [16876] = {.lex_state = 0},
  [16877] = {.lex_state = 0},
  [16878] = {.lex_state = 424, .external_lex_state = 10},
  [16879] = {.lex_state = 424, .external_lex_state = 11},
  [16880] = {.lex_state = 0},
  [16881] = {.lex_state = 424, .external_lex_state = 12},
  [16882] = {.lex_state = 424, .external_lex_state = 13},
  [16883] = {.lex_state = 0},
  [16884] = {.lex_state = 0},
  [16885] = {.lex_state = 505},
  [16886] = {.lex_state = 0},
  [16887] = {.lex_state = 0},
  [16888] = {.lex_state = 505},
  [16889] = {.lex_state = 424, .external_lex_state = 10},
  [16890] = {.lex_state = 424, .external_lex_state = 11},
  [16891] = {.lex_state = 424, .external_lex_state = 12},
  [16892] = {.lex_state = 424, .external_lex_state = 13},
  [16893] = {.lex_state = 424, .external_lex_state = 10},
  [16894] = {.lex_state = 424, .external_lex_state = 11},
  [16895] = {.lex_state = 424, .external_lex_state = 12},
  [16896] = {.lex_state = 424, .external_lex_state = 13},
  [16897] = {.lex_state = 0},
  [16898] = {.lex_state = 0},
  [16899] = {.lex_state = 0},
  [16900] = {.lex_state = 0},
  [16901] = {.lex_state = 0},
  [16902] = {.lex_state = 424, .external_lex_state = 8},
  [16903] = {.lex_state = 505},
  [16904] = {.lex_state = 505},
  [16905] = {.lex_state = 0},
  [16906] = {.lex_state = 0},
  [16907] = {.lex_state = 424, .external_lex_state = 10},
  [16908] = {.lex_state = 424, .external_lex_state = 11},
  [16909] = {.lex_state = 424, .external_lex_state = 12},
  [16910] = {.lex_state = 424, .external_lex_state = 13},
  [16911] = {.lex_state = 424, .external_lex_state = 11},
  [16912] = {.lex_state = 0},
  [16913] = {.lex_state = 424, .external_lex_state = 10},
  [16914] = {.lex_state = 0},
  [16915] = {.lex_state = 424, .external_lex_state = 11},
  [16916] = {.lex_state = 505},
  [16917] = {.lex_state = 424, .external_lex_state = 12},
  [16918] = {.lex_state = 424, .external_lex_state = 13},
  [16919] = {.lex_state = 0},
  [16920] = {.lex_state = 0},
  [16921] = {.lex_state = 424, .external_lex_state = 10},
  [16922] = {.lex_state = 424, .external_lex_state = 11},
  [16923] = {.lex_state = 424, .external_lex_state = 12},
  [16924] = {.lex_state = 424, .external_lex_state = 13},
  [16925] = {.lex_state = 0},
  [16926] = {.lex_state = 0},
  [16927] = {.lex_state = 0},
  [16928] = {.lex_state = 505},
  [16929] = {.lex_state = 0},
  [16930] = {.lex_state = 424, .external_lex_state = 10},
  [16931] = {.lex_state = 424, .external_lex_state = 11},
  [16932] = {.lex_state = 424, .external_lex_state = 12},
  [16933] = {.lex_state = 0},
  [16934] = {.lex_state = 424, .external_lex_state = 13},
  [16935] = {.lex_state = 0},
  [16936] = {.lex_state = 0},
  [16937] = {.lex_state = 0},
  [16938] = {.lex_state = 0},
  [16939] = {.lex_state = 0},
  [16940] = {.lex_state = 505},
  [16941] = {.lex_state = 0},
  [16942] = {.lex_state = 505},
  [16943] = {.lex_state = 424, .external_lex_state = 10},
  [16944] = {.lex_state = 424, .external_lex_state = 11},
  [16945] = {.lex_state = 424, .external_lex_state = 12},
  [16946] = {.lex_state = 424, .external_lex_state = 13},
  [16947] = {.lex_state = 0},
  [16948] = {.lex_state = 505},
  [16949] = {.lex_state = 0},
  [16950] = {.lex_state = 0},
  [16951] = {.lex_state = 0},
  [16952] = {.lex_state = 0},
  [16953] = {.lex_state = 0},
  [16954] = {.lex_state = 0},
  [16955] = {.lex_state = 424, .external_lex_state = 10},
  [16956] = {.lex_state = 0},
  [16957] = {.lex_state = 424, .external_lex_state = 11},
  [16958] = {.lex_state = 424, .external_lex_state = 10},
  [16959] = {.lex_state = 424, .external_lex_state = 11},
  [16960] = {.lex_state = 424, .external_lex_state = 12},
  [16961] = {.lex_state = 424, .external_lex_state = 13},
  [16962] = {.lex_state = 0},
  [16963] = {.lex_state = 505},
  [16964] = {.lex_state = 0},
  [16965] = {.lex_state = 424, .external_lex_state = 12},
  [16966] = {.lex_state = 0},
  [16967] = {.lex_state = 424, .external_lex_state = 6},
  [16968] = {.lex_state = 505},
  [16969] = {.lex_state = 424, .external_lex_state = 13},
  [16970] = {.lex_state = 0},
  [16971] = {.lex_state = 0},
  [16972] = {.lex_state = 424, .external_lex_state = 10},
  [16973] = {.lex_state = 424, .external_lex_state = 11},
  [16974] = {.lex_state = 424, .external_lex_state = 12},
  [16975] = {.lex_state = 424, .external_lex_state = 7},
  [16976] = {.lex_state = 424, .external_lex_state = 13},
  [16977] = {.lex_state = 0},
  [16978] = {.lex_state = 424, .external_lex_state = 7},
  [16979] = {.lex_state = 505},
  [16980] = {.lex_state = 424, .external_lex_state = 10},
  [16981] = {.lex_state = 424, .external_lex_state = 11},
  [16982] = {.lex_state = 424, .external_lex_state = 12},
  [16983] = {.lex_state = 424, .external_lex_state = 13},
  [16984] = {.lex_state = 424, .external_lex_state = 10},
  [16985] = {.lex_state = 424, .external_lex_state = 11},
  [16986] = {.lex_state = 0},
  [16987] = {.lex_state = 424, .external_lex_state = 12},
  [16988] = {.lex_state = 0},
  [16989] = {.lex_state = 424, .external_lex_state = 13},
  [16990] = {.lex_state = 0},
  [16991] = {.lex_state = 424, .external_lex_state = 7},
  [16992] = {.lex_state = 424, .external_lex_state = 10},
  [16993] = {.lex_state = 424, .external_lex_state = 11},
  [16994] = {.lex_state = 505},
  [16995] = {.lex_state = 424, .external_lex_state = 12},
  [16996] = {.lex_state = 424, .external_lex_state = 6},
  [16997] = {.lex_state = 505},
  [16998] = {.lex_state = 505},
  [16999] = {.lex_state = 424, .external_lex_state = 13},
  [17000] = {.lex_state = 0},
  [17001] = {.lex_state = 0},
  [17002] = {.lex_state = 424, .external_lex_state = 7},
  [17003] = {.lex_state = 424, .external_lex_state = 8},
  [17004] = {.lex_state = 505},
  [17005] = {.lex_state = 0},
  [17006] = {.lex_state = 424, .external_lex_state = 10},
  [17007] = {.lex_state = 424, .external_lex_state = 11},
  [17008] = {.lex_state = 424, .external_lex_state = 10},
  [17009] = {.lex_state = 424, .external_lex_state = 12},
  [17010] = {.lex_state = 424, .external_lex_state = 11},
  [17011] = {.lex_state = 424, .external_lex_state = 12},
  [17012] = {.lex_state = 424, .external_lex_state = 10},
  [17013] = {.lex_state = 424, .external_lex_state = 13},
  [17014] = {.lex_state = 424, .external_lex_state = 8},
  [17015] = {.lex_state = 424, .external_lex_state = 11},
  [17016] = {.lex_state = 0},
  [17017] = {.lex_state = 424, .external_lex_state = 10},
  [17018] = {.lex_state = 424, .external_lex_state = 12},
  [17019] = {.lex_state = 424, .external_lex_state = 13},
  [17020] = {.lex_state = 505},
  [17021] = {.lex_state = 0},
  [17022] = {.lex_state = 424, .external_lex_state = 13},
  [17023] = {.lex_state = 424, .external_lex_state = 10},
  [17024] = {.lex_state = 424, .external_lex_state = 11},
  [17025] = {.lex_state = 424, .external_lex_state = 12},
  [17026] = {.lex_state = 424, .external_lex_state = 13},
  [17027] = {.lex_state = 0},
  [17028] = {.lex_state = 0},
  [17029] = {.lex_state = 0},
  [17030] = {.lex_state = 505},
  [17031] = {.lex_state = 505},
  [17032] = {.lex_state = 0},
  [17033] = {.lex_state = 0},
  [17034] = {.lex_state = 0},
  [17035] = {.lex_state = 0},
  [17036] = {.lex_state = 505},
  [17037] = {.lex_state = 0},
  [17038] = {.lex_state = 424, .external_lex_state = 10},
  [17039] = {.lex_state = 424, .external_lex_state = 11},
  [17040] = {.lex_state = 424, .external_lex_state = 12},
  [17041] = {.lex_state = 424, .external_lex_state = 13},
  [17042] = {.lex_state = 424, .external_lex_state = 11},
  [17043] = {.lex_state = 0},
  [17044] = {.lex_state = 539},
  [17045] = {.lex_state = 505},
  [17046] = {.lex_state = 505},
  [17047] = {.lex_state = 424, .external_lex_state = 10},
  [17048] = {.lex_state = 424, .external_lex_state = 11},
  [17049] = {.lex_state = 424, .external_lex_state = 12},
  [17050] = {.lex_state = 424, .external_lex_state = 13},
  [17051] = {.lex_state = 424, .external_lex_state = 10},
  [17052] = {.lex_state = 424, .external_lex_state = 10},
  [17053] = {.lex_state = 0},
  [17054] = {.lex_state = 505},
  [17055] = {.lex_state = 505},
  [17056] = {.lex_state = 0},
  [17057] = {.lex_state = 424, .external_lex_state = 5},
  [17058] = {.lex_state = 0},
  [17059] = {.lex_state = 424, .external_lex_state = 12},
  [17060] = {.lex_state = 424, .external_lex_state = 11},
  [17061] = {.lex_state = 505},
  [17062] = {.lex_state = 424, .external_lex_state = 12},
  [17063] = {.lex_state = 424, .external_lex_state = 13},
  [17064] = {.lex_state = 0},
  [17065] = {.lex_state = 0},
  [17066] = {.lex_state = 0},
  [17067] = {.lex_state = 0},
  [17068] = {.lex_state = 363},
  [17069] = {.lex_state = 0, .external_lex_state = 3},
  [17070] = {.lex_state = 0},
  [17071] = {.lex_state = 0},
  [17072] = {.lex_state = 0, .external_lex_state = 3},
  [17073] = {.lex_state = 0},
  [17074] = {.lex_state = 0},
  [17075] = {.lex_state = 0},
  [17076] = {.lex_state = 363},
  [17077] = {.lex_state = 0, .external_lex_state = 3},
  [17078] = {.lex_state = 0},
  [17079] = {.lex_state = 0},
  [17080] = {.lex_state = 0, .external_lex_state = 3},
  [17081] = {.lex_state = 0},
  [17082] = {.lex_state = 0},
  [17083] = {.lex_state = 363},
  [17084] = {.lex_state = 0, .external_lex_state = 3},
  [17085] = {.lex_state = 0, .external_lex_state = 3},
  [17086] = {.lex_state = 0},
  [17087] = {.lex_state = 0},
  [17088] = {.lex_state = 363},
  [17089] = {.lex_state = 0},
  [17090] = {.lex_state = 0},
  [17091] = {.lex_state = 0, .external_lex_state = 3},
  [17092] = {.lex_state = 363},
  [17093] = {.lex_state = 0},
  [17094] = {.lex_state = 0},
  [17095] = {.lex_state = 0, .external_lex_state = 3},
  [17096] = {.lex_state = 0},
  [17097] = {.lex_state = 0},
  [17098] = {.lex_state = 0},
  [17099] = {.lex_state = 363},
  [17100] = {.lex_state = 363},
  [17101] = {.lex_state = 0},
  [17102] = {.lex_state = 0, .external_lex_state = 3},
  [17103] = {.lex_state = 0},
  [17104] = {.lex_state = 0, .external_lex_state = 3},
  [17105] = {.lex_state = 0},
  [17106] = {.lex_state = 0},
  [17107] = {.lex_state = 0},
  [17108] = {.lex_state = 0},
  [17109] = {.lex_state = 0},
  [17110] = {.lex_state = 0},
  [17111] = {.lex_state = 363},
  [17112] = {.lex_state = 0},
  [17113] = {.lex_state = 363},
  [17114] = {.lex_state = 0, .external_lex_state = 3},
  [17115] = {.lex_state = 0, .external_lex_state = 3},
  [17116] = {.lex_state = 0},
  [17117] = {.lex_state = 0},
  [17118] = {.lex_state = 363},
  [17119] = {.lex_state = 0},
  [17120] = {.lex_state = 0, .external_lex_state = 3},
  [17121] = {.lex_state = 0, .external_lex_state = 3},
  [17122] = {.lex_state = 0},
  [17123] = {.lex_state = 363},
  [17124] = {.lex_state = 363},
  [17125] = {.lex_state = 0},
  [17126] = {.lex_state = 363},
  [17127] = {.lex_state = 0, .external_lex_state = 3},
  [17128] = {.lex_state = 0, .external_lex_state = 3},
  [17129] = {.lex_state = 0},
  [17130] = {.lex_state = 0},
  [17131] = {.lex_state = 349},
  [17132] = {.lex_state = 0},
  [17133] = {.lex_state = 363},
  [17134] = {.lex_state = 0, .external_lex_state = 3},
  [17135] = {.lex_state = 0},
  [17136] = {.lex_state = 0},
  [17137] = {.lex_state = 363},
  [17138] = {.lex_state = 363},
  [17139] = {.lex_state = 0},
  [17140] = {.lex_state = 363},
  [17141] = {.lex_state = 0},
  [17142] = {.lex_state = 363},
  [17143] = {.lex_state = 363},
  [17144] = {.lex_state = 363},
  [17145] = {.lex_state = 0},
  [17146] = {.lex_state = 0},
  [17147] = {.lex_state = 0},
  [17148] = {.lex_state = 0},
  [17149] = {.lex_state = 363},
  [17150] = {.lex_state = 363},
  [17151] = {.lex_state = 0},
  [17152] = {.lex_state = 0},
  [17153] = {.lex_state = 363},
  [17154] = {.lex_state = 0},
  [17155] = {.lex_state = 0},
  [17156] = {.lex_state = 0, .external_lex_state = 5},
  [17157] = {.lex_state = 0},
  [17158] = {.lex_state = 363},
  [17159] = {.lex_state = 0},
  [17160] = {.lex_state = 363},
  [17161] = {.lex_state = 0},
  [17162] = {.lex_state = 364},
  [17163] = {.lex_state = 363},
  [17164] = {.lex_state = 0},
  [17165] = {.lex_state = 364},
  [17166] = {.lex_state = 363},
  [17167] = {.lex_state = 0},
  [17168] = {.lex_state = 0},
  [17169] = {.lex_state = 0},
  [17170] = {.lex_state = 0},
  [17171] = {.lex_state = 363},
  [17172] = {.lex_state = 0},
  [17173] = {.lex_state = 0},
  [17174] = {.lex_state = 0},
  [17175] = {.lex_state = 0},
  [17176] = {.lex_state = 363},
  [17177] = {.lex_state = 0},
  [17178] = {.lex_state = 0},
  [17179] = {.lex_state = 363},
  [17180] = {.lex_state = 0},
  [17181] = {.lex_state = 0},
  [17182] = {.lex_state = 0},
  [17183] = {.lex_state = 0},
  [17184] = {.lex_state = 363},
  [17185] = {.lex_state = 363},
  [17186] = {.lex_state = 363},
  [17187] = {.lex_state = 363},
  [17188] = {.lex_state = 0},
  [17189] = {.lex_state = 0},
  [17190] = {.lex_state = 363},
  [17191] = {.lex_state = 0},
  [17192] = {.lex_state = 0},
  [17193] = {.lex_state = 0},
  [17194] = {.lex_state = 0},
  [17195] = {.lex_state = 0},
  [17196] = {.lex_state = 0},
  [17197] = {.lex_state = 0},
  [17198] = {.lex_state = 0},
  [17199] = {.lex_state = 363},
  [17200] = {.lex_state = 363},
  [17201] = {.lex_state = 0},
  [17202] = {.lex_state = 363},
  [17203] = {.lex_state = 0},
  [17204] = {.lex_state = 0},
  [17205] = {.lex_state = 0},
  [17206] = {.lex_state = 0},
  [17207] = {.lex_state = 424, .external_lex_state = 10},
  [17208] = {.lex_state = 0},
  [17209] = {.lex_state = 363},
  [17210] = {.lex_state = 363},
  [17211] = {.lex_state = 424, .external_lex_state = 11},
  [17212] = {.lex_state = 0},
  [17213] = {.lex_state = 363},
  [17214] = {.lex_state = 0},
  [17215] = {.lex_state = 0},
  [17216] = {.lex_state = 0},
  [17217] = {.lex_state = 363},
  [17218] = {.lex_state = 0},
  [17219] = {.lex_state = 0},
  [17220] = {.lex_state = 0},
  [17221] = {.lex_state = 0},
  [17222] = {.lex_state = 363},
  [17223] = {.lex_state = 424, .external_lex_state = 12},
  [17224] = {.lex_state = 0},
  [17225] = {.lex_state = 363},
  [17226] = {.lex_state = 0},
  [17227] = {.lex_state = 0},
  [17228] = {.lex_state = 0},
  [17229] = {.lex_state = 363},
  [17230] = {.lex_state = 363},
  [17231] = {.lex_state = 424, .external_lex_state = 13},
  [17232] = {.lex_state = 349},
  [17233] = {.lex_state = 363},
  [17234] = {.lex_state = 363},
  [17235] = {.lex_state = 0},
  [17236] = {.lex_state = 0},
  [17237] = {.lex_state = 363},
  [17238] = {.lex_state = 0},
  [17239] = {.lex_state = 0},
  [17240] = {.lex_state = 0},
  [17241] = {.lex_state = 363},
  [17242] = {.lex_state = 0},
  [17243] = {.lex_state = 363},
  [17244] = {.lex_state = 363},
  [17245] = {.lex_state = 363},
  [17246] = {.lex_state = 363},
  [17247] = {.lex_state = 0},
  [17248] = {.lex_state = 0},
  [17249] = {.lex_state = 0},
  [17250] = {.lex_state = 0},
  [17251] = {.lex_state = 0},
  [17252] = {.lex_state = 363},
  [17253] = {.lex_state = 0},
  [17254] = {.lex_state = 0},
  [17255] = {.lex_state = 0},
  [17256] = {.lex_state = 0, .external_lex_state = 3},
  [17257] = {.lex_state = 363},
  [17258] = {.lex_state = 0},
  [17259] = {.lex_state = 0},
  [17260] = {.lex_state = 0},
  [17261] = {.lex_state = 0},
  [17262] = {.lex_state = 0},
  [17263] = {.lex_state = 363},
  [17264] = {.lex_state = 0},
  [17265] = {.lex_state = 0},
  [17266] = {.lex_state = 0},
  [17267] = {.lex_state = 0},
  [17268] = {.lex_state = 0},
  [17269] = {.lex_state = 0},
  [17270] = {.lex_state = 363},
  [17271] = {.lex_state = 0},
  [17272] = {.lex_state = 349},
  [17273] = {.lex_state = 363},
  [17274] = {.lex_state = 363},
  [17275] = {.lex_state = 0},
  [17276] = {.lex_state = 0},
  [17277] = {.lex_state = 0, .external_lex_state = 3},
  [17278] = {.lex_state = 363},
  [17279] = {.lex_state = 363},
  [17280] = {.lex_state = 0},
  [17281] = {.lex_state = 0},
  [17282] = {.lex_state = 0},
  [17283] = {.lex_state = 0},
  [17284] = {.lex_state = 0},
  [17285] = {.lex_state = 363},
  [17286] = {.lex_state = 363},
  [17287] = {.lex_state = 0},
  [17288] = {.lex_state = 349, .external_lex_state = 4},
  [17289] = {.lex_state = 0},
  [17290] = {.lex_state = 363},
  [17291] = {.lex_state = 0},
  [17292] = {.lex_state = 0},
  [17293] = {.lex_state = 0},
  [17294] = {.lex_state = 363},
  [17295] = {.lex_state = 0},
  [17296] = {.lex_state = 0},
  [17297] = {.lex_state = 363},
  [17298] = {.lex_state = 0},
  [17299] = {.lex_state = 0},
  [17300] = {.lex_state = 0},
  [17301] = {.lex_state = 363},
  [17302] = {.lex_state = 0},
  [17303] = {.lex_state = 0},
  [17304] = {.lex_state = 0},
  [17305] = {.lex_state = 363},
  [17306] = {.lex_state = 0, .external_lex_state = 3},
  [17307] = {.lex_state = 0},
  [17308] = {.lex_state = 363},
  [17309] = {.lex_state = 363},
  [17310] = {.lex_state = 0},
  [17311] = {.lex_state = 363},
  [17312] = {.lex_state = 0},
  [17313] = {.lex_state = 349},
  [17314] = {.lex_state = 363},
  [17315] = {.lex_state = 0},
  [17316] = {.lex_state = 363},
  [17317] = {.lex_state = 0},
  [17318] = {.lex_state = 363},
  [17319] = {.lex_state = 0},
  [17320] = {.lex_state = 0, .external_lex_state = 3},
  [17321] = {.lex_state = 0},
  [17322] = {.lex_state = 0},
  [17323] = {.lex_state = 0},
  [17324] = {.lex_state = 0},
  [17325] = {.lex_state = 0},
  [17326] = {.lex_state = 0},
  [17327] = {.lex_state = 0},
  [17328] = {.lex_state = 364},
  [17329] = {.lex_state = 0},
  [17330] = {.lex_state = 363},
  [17331] = {.lex_state = 0},
  [17332] = {.lex_state = 0},
  [17333] = {.lex_state = 0},
  [17334] = {.lex_state = 0},
  [17335] = {.lex_state = 363},
  [17336] = {.lex_state = 0},
  [17337] = {.lex_state = 0},
  [17338] = {.lex_state = 0},
  [17339] = {.lex_state = 0},
  [17340] = {.lex_state = 0},
  [17341] = {.lex_state = 0, .external_lex_state = 3},
  [17342] = {.lex_state = 0},
  [17343] = {.lex_state = 0},
  [17344] = {.lex_state = 0},
  [17345] = {.lex_state = 0},
  [17346] = {.lex_state = 0},
  [17347] = {.lex_state = 349},
  [17348] = {.lex_state = 363},
  [17349] = {.lex_state = 0},
  [17350] = {.lex_state = 363},
  [17351] = {.lex_state = 363},
  [17352] = {.lex_state = 0, .external_lex_state = 3},
  [17353] = {.lex_state = 0},
  [17354] = {.lex_state = 0},
  [17355] = {.lex_state = 349},
  [17356] = {.lex_state = 505},
  [17357] = {.lex_state = 0},
  [17358] = {.lex_state = 0},
  [17359] = {.lex_state = 0},
  [17360] = {.lex_state = 0},
  [17361] = {.lex_state = 426},
  [17362] = {.lex_state = 0},
  [17363] = {.lex_state = 0},
  [17364] = {.lex_state = 0, .external_lex_state = 3},
  [17365] = {.lex_state = 363},
  [17366] = {.lex_state = 0},
  [17367] = {.lex_state = 0},
  [17368] = {.lex_state = 0},
  [17369] = {.lex_state = 0},
  [17370] = {.lex_state = 363},
  [17371] = {.lex_state = 0},
  [17372] = {.lex_state = 424, .external_lex_state = 10},
  [17373] = {.lex_state = 0},
  [17374] = {.lex_state = 0},
  [17375] = {.lex_state = 0},
  [17376] = {.lex_state = 0},
  [17377] = {.lex_state = 0},
  [17378] = {.lex_state = 0},
  [17379] = {.lex_state = 363},
  [17380] = {.lex_state = 0},
  [17381] = {.lex_state = 0},
  [17382] = {.lex_state = 0},
  [17383] = {.lex_state = 0},
  [17384] = {.lex_state = 0},
  [17385] = {.lex_state = 0, .external_lex_state = 3},
  [17386] = {.lex_state = 349},
  [17387] = {.lex_state = 363},
  [17388] = {.lex_state = 0},
  [17389] = {.lex_state = 0},
  [17390] = {.lex_state = 0, .external_lex_state = 3},
  [17391] = {.lex_state = 363},
  [17392] = {.lex_state = 363},
  [17393] = {.lex_state = 0},
  [17394] = {.lex_state = 0, .external_lex_state = 3},
  [17395] = {.lex_state = 0},
  [17396] = {.lex_state = 349},
  [17397] = {.lex_state = 0},
  [17398] = {.lex_state = 349},
  [17399] = {.lex_state = 363},
  [17400] = {.lex_state = 0},
  [17401] = {.lex_state = 0},
  [17402] = {.lex_state = 0},
  [17403] = {.lex_state = 0},
  [17404] = {.lex_state = 0},
  [17405] = {.lex_state = 0},
  [17406] = {.lex_state = 0},
  [17407] = {.lex_state = 0},
  [17408] = {.lex_state = 0},
  [17409] = {.lex_state = 0},
  [17410] = {.lex_state = 0},
  [17411] = {.lex_state = 0},
  [17412] = {.lex_state = 363},
  [17413] = {.lex_state = 424, .external_lex_state = 13},
  [17414] = {.lex_state = 0},
  [17415] = {.lex_state = 0},
  [17416] = {.lex_state = 0},
  [17417] = {.lex_state = 0},
  [17418] = {.lex_state = 0, .external_lex_state = 3},
  [17419] = {.lex_state = 0},
  [17420] = {.lex_state = 363},
  [17421] = {.lex_state = 0},
  [17422] = {.lex_state = 0},
  [17423] = {.lex_state = 0},
  [17424] = {.lex_state = 0},
  [17425] = {.lex_state = 0},
  [17426] = {.lex_state = 363},
  [17427] = {.lex_state = 0},
  [17428] = {.lex_state = 363},
  [17429] = {.lex_state = 0},
  [17430] = {.lex_state = 0, .external_lex_state = 3},
  [17431] = {.lex_state = 0},
  [17432] = {.lex_state = 0},
  [17433] = {.lex_state = 0},
  [17434] = {.lex_state = 0},
  [17435] = {.lex_state = 0},
  [17436] = {.lex_state = 363},
  [17437] = {.lex_state = 0},
  [17438] = {.lex_state = 0},
  [17439] = {.lex_state = 349},
  [17440] = {.lex_state = 0},
  [17441] = {.lex_state = 363},
  [17442] = {.lex_state = 0},
  [17443] = {.lex_state = 363},
  [17444] = {.lex_state = 0},
  [17445] = {.lex_state = 363},
  [17446] = {.lex_state = 0},
  [17447] = {.lex_state = 0},
  [17448] = {.lex_state = 0, .external_lex_state = 3},
  [17449] = {.lex_state = 0},
  [17450] = {.lex_state = 0},
  [17451] = {.lex_state = 0},
  [17452] = {.lex_state = 0},
  [17453] = {.lex_state = 0},
  [17454] = {.lex_state = 0},
  [17455] = {.lex_state = 0},
  [17456] = {.lex_state = 0},
  [17457] = {.lex_state = 0},
  [17458] = {.lex_state = 0},
  [17459] = {.lex_state = 363},
  [17460] = {.lex_state = 0},
  [17461] = {.lex_state = 0},
  [17462] = {.lex_state = 0, .external_lex_state = 3},
  [17463] = {.lex_state = 0},
  [17464] = {.lex_state = 0},
  [17465] = {.lex_state = 0},
  [17466] = {.lex_state = 0},
  [17467] = {.lex_state = 0},
  [17468] = {.lex_state = 349},
  [17469] = {.lex_state = 349, .external_lex_state = 4},
  [17470] = {.lex_state = 363},
  [17471] = {.lex_state = 0},
  [17472] = {.lex_state = 0},
  [17473] = {.lex_state = 363},
  [17474] = {.lex_state = 0},
  [17475] = {.lex_state = 363},
  [17476] = {.lex_state = 0},
  [17477] = {.lex_state = 0},
  [17478] = {.lex_state = 0},
  [17479] = {.lex_state = 0},
  [17480] = {.lex_state = 0},
  [17481] = {.lex_state = 0},
  [17482] = {.lex_state = 0},
  [17483] = {.lex_state = 0},
  [17484] = {.lex_state = 0},
  [17485] = {.lex_state = 349},
  [17486] = {.lex_state = 363},
  [17487] = {.lex_state = 363},
  [17488] = {.lex_state = 0, .external_lex_state = 3},
  [17489] = {.lex_state = 0},
  [17490] = {.lex_state = 0},
  [17491] = {.lex_state = 349, .external_lex_state = 4},
  [17492] = {.lex_state = 0},
  [17493] = {.lex_state = 0},
  [17494] = {.lex_state = 0},
  [17495] = {.lex_state = 0},
  [17496] = {.lex_state = 363},
  [17497] = {.lex_state = 363},
  [17498] = {.lex_state = 0},
  [17499] = {.lex_state = 0},
  [17500] = {.lex_state = 0},
  [17501] = {.lex_state = 0},
  [17502] = {.lex_state = 0},
  [17503] = {.lex_state = 0},
  [17504] = {.lex_state = 0},
  [17505] = {.lex_state = 0},
  [17506] = {.lex_state = 363},
  [17507] = {.lex_state = 363},
  [17508] = {.lex_state = 0, .external_lex_state = 3},
  [17509] = {.lex_state = 363},
  [17510] = {.lex_state = 0},
  [17511] = {.lex_state = 363},
  [17512] = {.lex_state = 363},
  [17513] = {.lex_state = 0},
  [17514] = {.lex_state = 0},
  [17515] = {.lex_state = 0},
  [17516] = {.lex_state = 0},
  [17517] = {.lex_state = 505},
  [17518] = {.lex_state = 363},
  [17519] = {.lex_state = 0},
  [17520] = {.lex_state = 0},
  [17521] = {.lex_state = 0},
  [17522] = {.lex_state = 363},
  [17523] = {.lex_state = 0, .external_lex_state = 3},
  [17524] = {.lex_state = 363},
  [17525] = {.lex_state = 0},
  [17526] = {.lex_state = 0},
  [17527] = {.lex_state = 363},
  [17528] = {.lex_state = 0},
  [17529] = {.lex_state = 0},
  [17530] = {.lex_state = 0},
  [17531] = {.lex_state = 0},
  [17532] = {.lex_state = 0},
  [17533] = {.lex_state = 363},
  [17534] = {.lex_state = 0},
  [17535] = {.lex_state = 363},
  [17536] = {.lex_state = 0, .external_lex_state = 3},
  [17537] = {.lex_state = 363},
  [17538] = {.lex_state = 349, .external_lex_state = 4},
  [17539] = {.lex_state = 0},
  [17540] = {.lex_state = 0},
  [17541] = {.lex_state = 0},
  [17542] = {.lex_state = 0},
  [17543] = {.lex_state = 363},
  [17544] = {.lex_state = 0},
  [17545] = {.lex_state = 0},
  [17546] = {.lex_state = 0},
  [17547] = {.lex_state = 363},
  [17548] = {.lex_state = 0, .external_lex_state = 3},
  [17549] = {.lex_state = 349},
  [17550] = {.lex_state = 349},
  [17551] = {.lex_state = 0},
  [17552] = {.lex_state = 0},
  [17553] = {.lex_state = 0},
  [17554] = {.lex_state = 424},
  [17555] = {.lex_state = 0},
  [17556] = {.lex_state = 363},
  [17557] = {.lex_state = 0},
  [17558] = {.lex_state = 0},
  [17559] = {.lex_state = 0},
  [17560] = {.lex_state = 0, .external_lex_state = 3},
  [17561] = {.lex_state = 0},
  [17562] = {.lex_state = 0},
  [17563] = {.lex_state = 349},
  [17564] = {.lex_state = 0},
  [17565] = {.lex_state = 0},
  [17566] = {.lex_state = 0},
  [17567] = {.lex_state = 0},
  [17568] = {.lex_state = 0},
  [17569] = {.lex_state = 0},
  [17570] = {.lex_state = 0},
  [17571] = {.lex_state = 0},
  [17572] = {.lex_state = 0},
  [17573] = {.lex_state = 0},
  [17574] = {.lex_state = 0},
  [17575] = {.lex_state = 0},
  [17576] = {.lex_state = 363},
  [17577] = {.lex_state = 0},
  [17578] = {.lex_state = 0},
  [17579] = {.lex_state = 363},
  [17580] = {.lex_state = 0},
  [17581] = {.lex_state = 0},
  [17582] = {.lex_state = 0},
  [17583] = {.lex_state = 0},
  [17584] = {.lex_state = 0},
  [17585] = {.lex_state = 0, .external_lex_state = 3},
  [17586] = {.lex_state = 349},
  [17587] = {.lex_state = 0},
  [17588] = {.lex_state = 0},
  [17589] = {.lex_state = 0},
  [17590] = {.lex_state = 0},
  [17591] = {.lex_state = 0},
  [17592] = {.lex_state = 0},
  [17593] = {.lex_state = 0},
  [17594] = {.lex_state = 363},
  [17595] = {.lex_state = 363},
  [17596] = {.lex_state = 0},
  [17597] = {.lex_state = 0},
  [17598] = {.lex_state = 0},
  [17599] = {.lex_state = 0},
  [17600] = {.lex_state = 363},
  [17601] = {.lex_state = 0, .external_lex_state = 3},
  [17602] = {.lex_state = 363},
  [17603] = {.lex_state = 0},
  [17604] = {.lex_state = 0, .external_lex_state = 3},
  [17605] = {.lex_state = 0},
  [17606] = {.lex_state = 0},
  [17607] = {.lex_state = 0, .external_lex_state = 3},
  [17608] = {.lex_state = 0},
  [17609] = {.lex_state = 363},
  [17610] = {.lex_state = 0},
  [17611] = {.lex_state = 0},
  [17612] = {.lex_state = 424, .external_lex_state = 12},
  [17613] = {.lex_state = 0},
  [17614] = {.lex_state = 0},
  [17615] = {.lex_state = 363},
  [17616] = {.lex_state = 0},
  [17617] = {.lex_state = 363},
  [17618] = {.lex_state = 0, .external_lex_state = 3},
  [17619] = {.lex_state = 0},
  [17620] = {.lex_state = 0},
  [17621] = {.lex_state = 0, .external_lex_state = 3},
  [17622] = {.lex_state = 0, .external_lex_state = 3},
  [17623] = {.lex_state = 349},
  [17624] = {.lex_state = 0},
  [17625] = {.lex_state = 0},
  [17626] = {.lex_state = 0},
  [17627] = {.lex_state = 363},
  [17628] = {.lex_state = 349},
  [17629] = {.lex_state = 363},
  [17630] = {.lex_state = 0, .external_lex_state = 3},
  [17631] = {.lex_state = 363},
  [17632] = {.lex_state = 0},
  [17633] = {.lex_state = 0, .external_lex_state = 3},
  [17634] = {.lex_state = 0},
  [17635] = {.lex_state = 349},
  [17636] = {.lex_state = 0},
  [17637] = {.lex_state = 363},
  [17638] = {.lex_state = 0},
  [17639] = {.lex_state = 363},
  [17640] = {.lex_state = 0},
  [17641] = {.lex_state = 0, .external_lex_state = 3},
  [17642] = {.lex_state = 0},
  [17643] = {.lex_state = 0},
  [17644] = {.lex_state = 0, .external_lex_state = 3},
  [17645] = {.lex_state = 0},
  [17646] = {.lex_state = 0},
  [17647] = {.lex_state = 0},
  [17648] = {.lex_state = 0},
  [17649] = {.lex_state = 363},
  [17650] = {.lex_state = 363},
  [17651] = {.lex_state = 0},
  [17652] = {.lex_state = 424},
  [17653] = {.lex_state = 0},
  [17654] = {.lex_state = 363},
  [17655] = {.lex_state = 363},
  [17656] = {.lex_state = 0},
  [17657] = {.lex_state = 363},
  [17658] = {.lex_state = 349},
  [17659] = {.lex_state = 0},
  [17660] = {.lex_state = 363},
  [17661] = {.lex_state = 0, .external_lex_state = 3},
  [17662] = {.lex_state = 0},
  [17663] = {.lex_state = 0},
  [17664] = {.lex_state = 363},
  [17665] = {.lex_state = 0},
  [17666] = {.lex_state = 0},
  [17667] = {.lex_state = 0, .external_lex_state = 3},
  [17668] = {.lex_state = 349},
  [17669] = {.lex_state = 349},
  [17670] = {.lex_state = 349},
  [17671] = {.lex_state = 349},
  [17672] = {.lex_state = 424, .external_lex_state = 11},
  [17673] = {.lex_state = 0},
  [17674] = {.lex_state = 0},
  [17675] = {.lex_state = 0},
  [17676] = {.lex_state = 0},
  [17677] = {.lex_state = 0},
  [17678] = {.lex_state = 424},
  [17679] = {.lex_state = 0},
  [17680] = {.lex_state = 0},
  [17681] = {.lex_state = 0},
  [17682] = {.lex_state = 424},
  [17683] = {.lex_state = 0},
  [17684] = {.lex_state = 0},
  [17685] = {.lex_state = 0},
  [17686] = {.lex_state = 0},
  [17687] = {.lex_state = 0},
  [17688] = {.lex_state = 0},
  [17689] = {.lex_state = 424},
  [17690] = {.lex_state = 0},
  [17691] = {.lex_state = 0},
  [17692] = {.lex_state = 0},
  [17693] = {.lex_state = 0},
  [17694] = {.lex_state = 0},
  [17695] = {.lex_state = 0},
  [17696] = {.lex_state = 0},
  [17697] = {.lex_state = 0},
  [17698] = {.lex_state = 424},
  [17699] = {.lex_state = 0},
  [17700] = {.lex_state = 0},
  [17701] = {.lex_state = 0},
  [17702] = {.lex_state = 0},
  [17703] = {.lex_state = 0},
  [17704] = {.lex_state = 0},
  [17705] = {.lex_state = 0},
  [17706] = {.lex_state = 0},
  [17707] = {.lex_state = 424},
  [17708] = {.lex_state = 0},
  [17709] = {.lex_state = 0},
  [17710] = {.lex_state = 0},
  [17711] = {.lex_state = 0},
  [17712] = {.lex_state = 0},
  [17713] = {.lex_state = 0},
  [17714] = {.lex_state = 0},
  [17715] = {.lex_state = 0},
  [17716] = {.lex_state = 0},
  [17717] = {.lex_state = 0},
  [17718] = {.lex_state = 0},
  [17719] = {.lex_state = 424},
  [17720] = {.lex_state = 0},
  [17721] = {.lex_state = 0},
  [17722] = {.lex_state = 0},
  [17723] = {.lex_state = 424},
  [17724] = {.lex_state = 0},
  [17725] = {.lex_state = 0},
  [17726] = {.lex_state = 0},
  [17727] = {.lex_state = 424},
  [17728] = {.lex_state = 424},
  [17729] = {.lex_state = 0},
  [17730] = {.lex_state = 0},
  [17731] = {.lex_state = 0},
  [17732] = {.lex_state = 0},
  [17733] = {.lex_state = 0},
  [17734] = {.lex_state = 0},
  [17735] = {.lex_state = 0},
  [17736] = {.lex_state = 0},
  [17737] = {.lex_state = 0},
  [17738] = {.lex_state = 0},
  [17739] = {.lex_state = 0},
  [17740] = {.lex_state = 0},
  [17741] = {.lex_state = 0},
  [17742] = {.lex_state = 0},
  [17743] = {.lex_state = 0},
  [17744] = {.lex_state = 0},
  [17745] = {.lex_state = 0},
  [17746] = {.lex_state = 0},
  [17747] = {.lex_state = 0},
  [17748] = {.lex_state = 0},
  [17749] = {.lex_state = 0},
  [17750] = {.lex_state = 0},
  [17751] = {.lex_state = 0},
  [17752] = {.lex_state = 424},
  [17753] = {.lex_state = 0},
  [17754] = {.lex_state = 0},
  [17755] = {.lex_state = 0},
  [17756] = {.lex_state = 0},
  [17757] = {.lex_state = 0},
  [17758] = {.lex_state = 0},
  [17759] = {.lex_state = 0},
  [17760] = {.lex_state = 0},
  [17761] = {.lex_state = 0},
  [17762] = {.lex_state = 0},
  [17763] = {.lex_state = 0},
  [17764] = {.lex_state = 0},
  [17765] = {.lex_state = 0},
  [17766] = {.lex_state = 0},
  [17767] = {.lex_state = 0},
  [17768] = {.lex_state = 0},
  [17769] = {.lex_state = 0},
  [17770] = {.lex_state = 0},
  [17771] = {.lex_state = 0},
  [17772] = {.lex_state = 0},
  [17773] = {.lex_state = 0},
  [17774] = {.lex_state = 0},
  [17775] = {.lex_state = 0},
  [17776] = {.lex_state = 0},
  [17777] = {.lex_state = 427},
  [17778] = {.lex_state = 0},
  [17779] = {.lex_state = 0},
  [17780] = {.lex_state = 424},
  [17781] = {.lex_state = 0},
  [17782] = {.lex_state = 424},
  [17783] = {.lex_state = 0},
  [17784] = {.lex_state = 0},
  [17785] = {.lex_state = 0},
  [17786] = {.lex_state = 0},
  [17787] = {.lex_state = 0},
  [17788] = {.lex_state = 0},
  [17789] = {.lex_state = 424},
  [17790] = {.lex_state = 424},
  [17791] = {.lex_state = 0},
  [17792] = {.lex_state = 0},
  [17793] = {.lex_state = 0},
  [17794] = {.lex_state = 0},
  [17795] = {.lex_state = 0},
  [17796] = {.lex_state = 0},
  [17797] = {.lex_state = 0},
  [17798] = {.lex_state = 0},
  [17799] = {.lex_state = 0},
  [17800] = {.lex_state = 0},
  [17801] = {.lex_state = 0},
  [17802] = {.lex_state = 0},
  [17803] = {.lex_state = 0},
  [17804] = {.lex_state = 0},
  [17805] = {.lex_state = 0},
  [17806] = {.lex_state = 0},
  [17807] = {.lex_state = 0},
  [17808] = {.lex_state = 0},
  [17809] = {.lex_state = 0},
  [17810] = {.lex_state = 0},
  [17811] = {.lex_state = 0},
  [17812] = {.lex_state = 0},
  [17813] = {.lex_state = 0},
  [17814] = {.lex_state = 0},
  [17815] = {.lex_state = 0},
  [17816] = {.lex_state = 0},
  [17817] = {.lex_state = 0},
  [17818] = {.lex_state = 0},
  [17819] = {.lex_state = 0},
  [17820] = {.lex_state = 363},
  [17821] = {.lex_state = 0},
  [17822] = {.lex_state = 0},
  [17823] = {.lex_state = 0},
  [17824] = {.lex_state = 0},
  [17825] = {.lex_state = 0},
  [17826] = {.lex_state = 0},
  [17827] = {.lex_state = 0},
  [17828] = {.lex_state = 0},
  [17829] = {.lex_state = 0},
  [17830] = {.lex_state = 0},
  [17831] = {.lex_state = 0},
  [17832] = {.lex_state = 0},
  [17833] = {.lex_state = 0},
  [17834] = {.lex_state = 0},
  [17835] = {.lex_state = 0},
  [17836] = {.lex_state = 0},
  [17837] = {.lex_state = 0},
  [17838] = {.lex_state = 0},
  [17839] = {.lex_state = 0},
  [17840] = {.lex_state = 0},
  [17841] = {.lex_state = 0},
  [17842] = {.lex_state = 0},
  [17843] = {.lex_state = 0},
  [17844] = {.lex_state = 0},
  [17845] = {.lex_state = 0},
  [17846] = {.lex_state = 0},
  [17847] = {.lex_state = 0},
  [17848] = {.lex_state = 0},
  [17849] = {.lex_state = 0},
  [17850] = {.lex_state = 0},
  [17851] = {.lex_state = 0},
  [17852] = {.lex_state = 0},
  [17853] = {.lex_state = 0},
  [17854] = {.lex_state = 0},
  [17855] = {.lex_state = 0},
  [17856] = {.lex_state = 0},
  [17857] = {.lex_state = 0},
  [17858] = {.lex_state = 0},
  [17859] = {.lex_state = 0},
  [17860] = {.lex_state = 0},
  [17861] = {.lex_state = 0},
  [17862] = {.lex_state = 0},
  [17863] = {.lex_state = 0},
  [17864] = {.lex_state = 0},
  [17865] = {.lex_state = 0},
  [17866] = {.lex_state = 0},
  [17867] = {.lex_state = 0},
  [17868] = {.lex_state = 0},
  [17869] = {.lex_state = 0},
  [17870] = {.lex_state = 0},
  [17871] = {.lex_state = 0},
  [17872] = {.lex_state = 0},
  [17873] = {.lex_state = 0},
  [17874] = {.lex_state = 0},
  [17875] = {.lex_state = 0},
  [17876] = {.lex_state = 0},
  [17877] = {.lex_state = 0},
  [17878] = {.lex_state = 0},
  [17879] = {.lex_state = 0},
  [17880] = {.lex_state = 0},
  [17881] = {.lex_state = 0},
  [17882] = {.lex_state = 0},
  [17883] = {.lex_state = 0},
  [17884] = {.lex_state = 0},
  [17885] = {.lex_state = 0},
  [17886] = {.lex_state = 0},
  [17887] = {.lex_state = 0},
  [17888] = {.lex_state = 0},
  [17889] = {.lex_state = 0},
  [17890] = {.lex_state = 0},
  [17891] = {.lex_state = 0},
  [17892] = {.lex_state = 0},
  [17893] = {.lex_state = 0},
  [17894] = {.lex_state = 0},
  [17895] = {.lex_state = 0},
  [17896] = {.lex_state = 0},
  [17897] = {.lex_state = 0},
  [17898] = {.lex_state = 0},
  [17899] = {.lex_state = 0},
  [17900] = {.lex_state = 0},
  [17901] = {.lex_state = 424},
  [17902] = {.lex_state = 0},
  [17903] = {.lex_state = 0},
  [17904] = {.lex_state = 0},
  [17905] = {.lex_state = 424},
  [17906] = {.lex_state = 0},
  [17907] = {.lex_state = 0},
  [17908] = {.lex_state = 0},
  [17909] = {.lex_state = 424},
  [17910] = {.lex_state = 0},
  [17911] = {.lex_state = 0},
  [17912] = {.lex_state = 0},
  [17913] = {.lex_state = 0},
  [17914] = {.lex_state = 0},
  [17915] = {.lex_state = 0},
  [17916] = {.lex_state = 0},
  [17917] = {.lex_state = 0},
  [17918] = {.lex_state = 0},
  [17919] = {.lex_state = 0},
  [17920] = {.lex_state = 0},
  [17921] = {.lex_state = 0},
  [17922] = {.lex_state = 0},
  [17923] = {.lex_state = 0},
  [17924] = {.lex_state = 0},
  [17925] = {.lex_state = 0},
  [17926] = {.lex_state = 0},
  [17927] = {.lex_state = 0},
  [17928] = {.lex_state = 0},
  [17929] = {.lex_state = 0},
  [17930] = {.lex_state = 0},
  [17931] = {.lex_state = 0},
  [17932] = {.lex_state = 0},
  [17933] = {.lex_state = 0},
  [17934] = {.lex_state = 0},
  [17935] = {.lex_state = 0},
  [17936] = {.lex_state = 0},
  [17937] = {.lex_state = 0},
  [17938] = {.lex_state = 0},
  [17939] = {.lex_state = 0},
  [17940] = {.lex_state = 0},
  [17941] = {.lex_state = 0},
  [17942] = {.lex_state = 0},
  [17943] = {.lex_state = 0},
  [17944] = {.lex_state = 0},
  [17945] = {.lex_state = 0},
  [17946] = {.lex_state = 0},
  [17947] = {.lex_state = 0},
  [17948] = {.lex_state = 0},
  [17949] = {.lex_state = 0},
  [17950] = {.lex_state = 0},
  [17951] = {.lex_state = 0},
  [17952] = {.lex_state = 0},
  [17953] = {.lex_state = 0},
  [17954] = {.lex_state = 0},
  [17955] = {.lex_state = 0},
  [17956] = {.lex_state = 0},
  [17957] = {.lex_state = 424},
  [17958] = {.lex_state = 0},
  [17959] = {.lex_state = 0},
  [17960] = {.lex_state = 0},
  [17961] = {.lex_state = 0},
  [17962] = {.lex_state = 0},
  [17963] = {.lex_state = 424},
  [17964] = {.lex_state = 0},
  [17965] = {.lex_state = 0},
  [17966] = {.lex_state = 0},
  [17967] = {.lex_state = 0},
  [17968] = {.lex_state = 0},
  [17969] = {.lex_state = 0},
  [17970] = {.lex_state = 0},
  [17971] = {.lex_state = 0},
  [17972] = {.lex_state = 0},
  [17973] = {.lex_state = 0},
  [17974] = {.lex_state = 0},
  [17975] = {.lex_state = 0},
  [17976] = {.lex_state = 0},
  [17977] = {.lex_state = 0},
  [17978] = {.lex_state = 424},
  [17979] = {.lex_state = 0},
  [17980] = {.lex_state = 0},
  [17981] = {.lex_state = 0},
  [17982] = {.lex_state = 0},
  [17983] = {.lex_state = 0},
  [17984] = {.lex_state = 424},
  [17985] = {.lex_state = 0},
  [17986] = {.lex_state = 0},
  [17987] = {.lex_state = 424},
  [17988] = {.lex_state = 0},
  [17989] = {.lex_state = 0},
  [17990] = {.lex_state = 0},
  [17991] = {.lex_state = 0},
  [17992] = {.lex_state = 0},
  [17993] = {.lex_state = 0},
  [17994] = {.lex_state = 0},
  [17995] = {.lex_state = 0},
  [17996] = {.lex_state = 0},
  [17997] = {.lex_state = 0},
  [17998] = {.lex_state = 424},
  [17999] = {.lex_state = 363},
  [18000] = {.lex_state = 0},
  [18001] = {.lex_state = 0},
  [18002] = {.lex_state = 0},
  [18003] = {.lex_state = 0},
  [18004] = {.lex_state = 0},
  [18005] = {.lex_state = 0},
  [18006] = {.lex_state = 0},
  [18007] = {.lex_state = 424},
  [18008] = {.lex_state = 0},
  [18009] = {.lex_state = 0},
  [18010] = {.lex_state = 0},
  [18011] = {.lex_state = 0},
  [18012] = {.lex_state = 0},
  [18013] = {.lex_state = 0},
  [18014] = {.lex_state = 424},
  [18015] = {.lex_state = 424},
  [18016] = {.lex_state = 0},
  [18017] = {.lex_state = 0},
  [18018] = {.lex_state = 0},
  [18019] = {.lex_state = 0},
  [18020] = {.lex_state = 0},
  [18021] = {.lex_state = 424},
  [18022] = {.lex_state = 0},
  [18023] = {.lex_state = 0},
  [18024] = {.lex_state = 424},
  [18025] = {.lex_state = 0},
  [18026] = {.lex_state = 0},
  [18027] = {.lex_state = 0},
  [18028] = {.lex_state = 424},
  [18029] = {.lex_state = 0},
  [18030] = {.lex_state = 0},
  [18031] = {.lex_state = 0},
  [18032] = {.lex_state = 0},
  [18033] = {.lex_state = 0},
  [18034] = {.lex_state = 0},
  [18035] = {.lex_state = 0},
  [18036] = {.lex_state = 0},
  [18037] = {.lex_state = 0},
  [18038] = {.lex_state = 0},
  [18039] = {.lex_state = 0},
  [18040] = {.lex_state = 0},
  [18041] = {.lex_state = 0},
  [18042] = {.lex_state = 424},
  [18043] = {.lex_state = 0},
  [18044] = {.lex_state = 0},
  [18045] = {.lex_state = 0},
  [18046] = {.lex_state = 424},
  [18047] = {.lex_state = 0},
  [18048] = {.lex_state = 363},
  [18049] = {.lex_state = 0},
  [18050] = {.lex_state = 0},
  [18051] = {.lex_state = 0},
  [18052] = {.lex_state = 0},
  [18053] = {.lex_state = 0},
  [18054] = {.lex_state = 424},
  [18055] = {.lex_state = 0},
  [18056] = {.lex_state = 0},
  [18057] = {.lex_state = 0},
  [18058] = {.lex_state = 0},
  [18059] = {.lex_state = 0},
  [18060] = {.lex_state = 0},
  [18061] = {.lex_state = 0},
  [18062] = {.lex_state = 0},
  [18063] = {.lex_state = 0},
  [18064] = {.lex_state = 0},
  [18065] = {.lex_state = 0},
  [18066] = {.lex_state = 0},
  [18067] = {.lex_state = 0},
  [18068] = {.lex_state = 0},
  [18069] = {.lex_state = 0},
  [18070] = {.lex_state = 0},
  [18071] = {.lex_state = 0},
  [18072] = {.lex_state = 424},
  [18073] = {.lex_state = 0},
  [18074] = {.lex_state = 0},
  [18075] = {.lex_state = 424},
  [18076] = {.lex_state = 0},
  [18077] = {.lex_state = 0},
  [18078] = {.lex_state = 0},
  [18079] = {.lex_state = 0},
  [18080] = {.lex_state = 0},
  [18081] = {.lex_state = 424},
  [18082] = {.lex_state = 0},
  [18083] = {.lex_state = 0},
  [18084] = {.lex_state = 0},
  [18085] = {.lex_state = 0},
  [18086] = {.lex_state = 0},
  [18087] = {.lex_state = 0},
  [18088] = {.lex_state = 0},
  [18089] = {.lex_state = 0},
  [18090] = {.lex_state = 0},
  [18091] = {.lex_state = 0},
  [18092] = {.lex_state = 0},
  [18093] = {.lex_state = 0},
  [18094] = {.lex_state = 0},
  [18095] = {.lex_state = 0},
  [18096] = {.lex_state = 424},
  [18097] = {.lex_state = 0},
  [18098] = {.lex_state = 0},
  [18099] = {.lex_state = 0},
  [18100] = {.lex_state = 0},
  [18101] = {.lex_state = 0},
  [18102] = {.lex_state = 424},
  [18103] = {.lex_state = 0},
  [18104] = {.lex_state = 0},
  [18105] = {.lex_state = 0},
  [18106] = {.lex_state = 0},
  [18107] = {.lex_state = 0},
  [18108] = {.lex_state = 0},
  [18109] = {.lex_state = 0},
  [18110] = {.lex_state = 0},
  [18111] = {.lex_state = 0},
  [18112] = {.lex_state = 424},
  [18113] = {.lex_state = 0},
  [18114] = {.lex_state = 0},
  [18115] = {.lex_state = 0},
  [18116] = {.lex_state = 0},
  [18117] = {.lex_state = 0},
  [18118] = {.lex_state = 0},
  [18119] = {.lex_state = 0},
  [18120] = {.lex_state = 0},
  [18121] = {.lex_state = 0},
  [18122] = {.lex_state = 0},
  [18123] = {.lex_state = 0},
  [18124] = {.lex_state = 0},
  [18125] = {.lex_state = 0},
  [18126] = {.lex_state = 0},
  [18127] = {.lex_state = 0},
  [18128] = {.lex_state = 0},
  [18129] = {.lex_state = 0},
  [18130] = {.lex_state = 0},
  [18131] = {.lex_state = 0},
  [18132] = {.lex_state = 0},
  [18133] = {.lex_state = 0},
  [18134] = {.lex_state = 0},
  [18135] = {.lex_state = 0},
  [18136] = {.lex_state = 0},
  [18137] = {.lex_state = 0},
  [18138] = {.lex_state = 424},
  [18139] = {.lex_state = 0},
  [18140] = {.lex_state = 0},
  [18141] = {.lex_state = 0},
  [18142] = {.lex_state = 0},
  [18143] = {.lex_state = 0},
  [18144] = {.lex_state = 0},
  [18145] = {.lex_state = 0},
  [18146] = {.lex_state = 0},
  [18147] = {.lex_state = 0},
  [18148] = {.lex_state = 0},
  [18149] = {.lex_state = 0},
  [18150] = {.lex_state = 363},
  [18151] = {.lex_state = 0},
  [18152] = {.lex_state = 0},
  [18153] = {.lex_state = 0},
  [18154] = {.lex_state = 0},
  [18155] = {.lex_state = 0},
  [18156] = {.lex_state = 0},
  [18157] = {.lex_state = 0},
  [18158] = {.lex_state = 0},
  [18159] = {.lex_state = 424},
  [18160] = {.lex_state = 0},
  [18161] = {.lex_state = 0},
  [18162] = {.lex_state = 0},
  [18163] = {.lex_state = 424},
  [18164] = {.lex_state = 0},
  [18165] = {.lex_state = 424},
  [18166] = {.lex_state = 0},
  [18167] = {.lex_state = 0},
  [18168] = {.lex_state = 0},
  [18169] = {.lex_state = 0},
  [18170] = {.lex_state = 424},
  [18171] = {.lex_state = 0},
  [18172] = {.lex_state = 0},
  [18173] = {.lex_state = 0},
  [18174] = {.lex_state = 0},
  [18175] = {.lex_state = 0},
  [18176] = {.lex_state = 0},
  [18177] = {.lex_state = 0},
  [18178] = {.lex_state = 0},
  [18179] = {.lex_state = 0},
  [18180] = {.lex_state = 0},
  [18181] = {.lex_state = 0},
  [18182] = {.lex_state = 424},
  [18183] = {.lex_state = 0},
  [18184] = {.lex_state = 0},
  [18185] = {.lex_state = 0},
  [18186] = {.lex_state = 0},
  [18187] = {.lex_state = 0},
  [18188] = {.lex_state = 424},
  [18189] = {.lex_state = 0},
  [18190] = {.lex_state = 0},
  [18191] = {.lex_state = 0},
  [18192] = {.lex_state = 0},
  [18193] = {.lex_state = 0},
  [18194] = {.lex_state = 0},
  [18195] = {.lex_state = 0},
  [18196] = {.lex_state = 0},
  [18197] = {.lex_state = 0},
  [18198] = {.lex_state = 0},
  [18199] = {.lex_state = 0},
  [18200] = {.lex_state = 0},
  [18201] = {.lex_state = 0},
  [18202] = {.lex_state = 0},
  [18203] = {.lex_state = 0},
  [18204] = {.lex_state = 0},
  [18205] = {.lex_state = 0},
  [18206] = {.lex_state = 0},
  [18207] = {.lex_state = 0},
  [18208] = {.lex_state = 0},
  [18209] = {.lex_state = 0},
  [18210] = {.lex_state = 0},
  [18211] = {.lex_state = 0},
  [18212] = {.lex_state = 0},
  [18213] = {.lex_state = 424},
  [18214] = {.lex_state = 0},
  [18215] = {.lex_state = 0},
  [18216] = {.lex_state = 0},
  [18217] = {.lex_state = 0},
  [18218] = {.lex_state = 0},
  [18219] = {.lex_state = 0},
  [18220] = {.lex_state = 0},
  [18221] = {.lex_state = 0},
  [18222] = {.lex_state = 0},
  [18223] = {.lex_state = 0},
  [18224] = {.lex_state = 0},
  [18225] = {.lex_state = 0},
  [18226] = {.lex_state = 0},
  [18227] = {.lex_state = 0},
  [18228] = {.lex_state = 0},
  [18229] = {.lex_state = 0},
  [18230] = {.lex_state = 0},
  [18231] = {.lex_state = 424},
  [18232] = {.lex_state = 363},
  [18233] = {.lex_state = 0},
  [18234] = {.lex_state = 349},
  [18235] = {.lex_state = 0, .external_lex_state = 4},
  [18236] = {.lex_state = 363},
  [18237] = {.lex_state = 0},
  [18238] = {.lex_state = 363},
  [18239] = {.lex_state = 363},
  [18240] = {.lex_state = 349},
  [18241] = {.lex_state = 0},
  [18242] = {.lex_state = 0},
  [18243] = {.lex_state = 0},
  [18244] = {.lex_state = 363},
  [18245] = {.lex_state = 0},
  [18246] = {.lex_state = 363},
  [18247] = {.lex_state = 0},
  [18248] = {.lex_state = 0},
  [18249] = {.lex_state = 363},
  [18250] = {.lex_state = 0},
  [18251] = {.lex_state = 0},
  [18252] = {.lex_state = 349},
  [18253] = {.lex_state = 363},
  [18254] = {.lex_state = 363},
  [18255] = {.lex_state = 0},
  [18256] = {.lex_state = 363},
  [18257] = {.lex_state = 0},
  [18258] = {.lex_state = 0},
  [18259] = {.lex_state = 363},
  [18260] = {.lex_state = 363},
  [18261] = {.lex_state = 363},
  [18262] = {.lex_state = 363},
  [18263] = {.lex_state = 363},
  [18264] = {.lex_state = 0},
  [18265] = {.lex_state = 0},
  [18266] = {.lex_state = 0},
  [18267] = {.lex_state = 424},
  [18268] = {.lex_state = 349},
  [18269] = {.lex_state = 363},
  [18270] = {.lex_state = 363},
  [18271] = {.lex_state = 0},
  [18272] = {.lex_state = 0},
  [18273] = {.lex_state = 363},
  [18274] = {.lex_state = 0},
  [18275] = {.lex_state = 363},
  [18276] = {.lex_state = 0},
  [18277] = {.lex_state = 0},
  [18278] = {.lex_state = 363},
  [18279] = {.lex_state = 363},
  [18280] = {.lex_state = 0},
  [18281] = {.lex_state = 363},
  [18282] = {.lex_state = 363},
  [18283] = {.lex_state = 0},
  [18284] = {.lex_state = 363},
  [18285] = {.lex_state = 0},
  [18286] = {.lex_state = 363},
  [18287] = {.lex_state = 0},
  [18288] = {.lex_state = 0},
  [18289] = {.lex_state = 0},
  [18290] = {.lex_state = 363},
  [18291] = {.lex_state = 0},
  [18292] = {.lex_state = 0},
  [18293] = {.lex_state = 0},
  [18294] = {.lex_state = 0},
  [18295] = {.lex_state = 0},
  [18296] = {.lex_state = 349},
  [18297] = {.lex_state = 363},
  [18298] = {.lex_state = 363},
  [18299] = {.lex_state = 0},
  [18300] = {.lex_state = 363},
  [18301] = {.lex_state = 0},
  [18302] = {.lex_state = 363},
  [18303] = {.lex_state = 363},
  [18304] = {.lex_state = 349},
  [18305] = {.lex_state = 363},
  [18306] = {.lex_state = 363},
  [18307] = {.lex_state = 363},
  [18308] = {.lex_state = 363},
  [18309] = {.lex_state = 0},
  [18310] = {.lex_state = 0},
  [18311] = {.lex_state = 0},
  [18312] = {.lex_state = 363},
  [18313] = {.lex_state = 0},
  [18314] = {.lex_state = 349},
  [18315] = {.lex_state = 349},
  [18316] = {.lex_state = 424},
  [18317] = {.lex_state = 0},
  [18318] = {.lex_state = 0},
  [18319] = {.lex_state = 363},
  [18320] = {.lex_state = 424},
  [18321] = {.lex_state = 0},
  [18322] = {.lex_state = 363},
  [18323] = {.lex_state = 0},
  [18324] = {.lex_state = 0},
  [18325] = {.lex_state = 363},
  [18326] = {.lex_state = 0},
  [18327] = {.lex_state = 0},
  [18328] = {.lex_state = 0},
  [18329] = {.lex_state = 363},
  [18330] = {.lex_state = 363},
  [18331] = {.lex_state = 363},
  [18332] = {.lex_state = 0},
  [18333] = {.lex_state = 0},
  [18334] = {.lex_state = 363},
  [18335] = {.lex_state = 0},
  [18336] = {.lex_state = 0},
  [18337] = {.lex_state = 0},
  [18338] = {.lex_state = 363},
  [18339] = {.lex_state = 0},
  [18340] = {.lex_state = 363},
  [18341] = {.lex_state = 0},
  [18342] = {.lex_state = 0},
  [18343] = {.lex_state = 349},
  [18344] = {.lex_state = 363},
  [18345] = {.lex_state = 0},
  [18346] = {.lex_state = 0},
  [18347] = {.lex_state = 0},
  [18348] = {.lex_state = 424},
  [18349] = {.lex_state = 363},
  [18350] = {.lex_state = 363},
  [18351] = {.lex_state = 363},
  [18352] = {.lex_state = 0},
  [18353] = {.lex_state = 363},
  [18354] = {.lex_state = 0},
  [18355] = {.lex_state = 0},
  [18356] = {.lex_state = 0},
  [18357] = {.lex_state = 363},
  [18358] = {.lex_state = 363},
  [18359] = {.lex_state = 0},
  [18360] = {.lex_state = 363},
  [18361] = {.lex_state = 0},
  [18362] = {.lex_state = 0},
  [18363] = {.lex_state = 349},
  [18364] = {.lex_state = 0},
  [18365] = {.lex_state = 0},
  [18366] = {.lex_state = 424},
  [18367] = {.lex_state = 0},
  [18368] = {.lex_state = 0},
  [18369] = {.lex_state = 363},
  [18370] = {.lex_state = 0},
  [18371] = {.lex_state = 0},
  [18372] = {.lex_state = 363},
  [18373] = {.lex_state = 0},
  [18374] = {.lex_state = 0},
  [18375] = {.lex_state = 363},
  [18376] = {.lex_state = 0},
  [18377] = {.lex_state = 363},
  [18378] = {.lex_state = 0},
  [18379] = {.lex_state = 0},
  [18380] = {.lex_state = 0},
  [18381] = {.lex_state = 363},
  [18382] = {.lex_state = 0},
  [18383] = {.lex_state = 424},
  [18384] = {.lex_state = 349},
  [18385] = {.lex_state = 363},
  [18386] = {.lex_state = 363},
  [18387] = {.lex_state = 349},
  [18388] = {.lex_state = 349},
  [18389] = {.lex_state = 0},
  [18390] = {.lex_state = 424},
  [18391] = {.lex_state = 363},
  [18392] = {.lex_state = 363},
  [18393] = {.lex_state = 0},
  [18394] = {.lex_state = 0},
  [18395] = {.lex_state = 424},
  [18396] = {.lex_state = 363},
  [18397] = {.lex_state = 0},
  [18398] = {.lex_state = 0},
  [18399] = {.lex_state = 363},
  [18400] = {.lex_state = 363},
  [18401] = {.lex_state = 349},
  [18402] = {.lex_state = 0},
  [18403] = {.lex_state = 363},
  [18404] = {.lex_state = 363},
  [18405] = {.lex_state = 363},
  [18406] = {.lex_state = 0},
  [18407] = {.lex_state = 363},
  [18408] = {.lex_state = 363},
  [18409] = {.lex_state = 363},
  [18410] = {.lex_state = 0},
  [18411] = {.lex_state = 0},
  [18412] = {.lex_state = 349},
  [18413] = {.lex_state = 363},
  [18414] = {.lex_state = 0},
  [18415] = {.lex_state = 0},
  [18416] = {.lex_state = 0},
  [18417] = {.lex_state = 0},
  [18418] = {.lex_state = 363},
  [18419] = {.lex_state = 0},
  [18420] = {.lex_state = 0},
  [18421] = {.lex_state = 0},
  [18422] = {.lex_state = 0, .external_lex_state = 4},
  [18423] = {.lex_state = 0},
  [18424] = {.lex_state = 424},
  [18425] = {.lex_state = 0},
  [18426] = {.lex_state = 0},
  [18427] = {.lex_state = 0},
  [18428] = {.lex_state = 363},
  [18429] = {.lex_state = 0},
  [18430] = {.lex_state = 0},
  [18431] = {.lex_state = 0},
  [18432] = {.lex_state = 363},
  [18433] = {.lex_state = 0},
  [18434] = {.lex_state = 0},
  [18435] = {.lex_state = 0},
  [18436] = {.lex_state = 363},
  [18437] = {.lex_state = 0},
  [18438] = {.lex_state = 363},
  [18439] = {.lex_state = 363},
  [18440] = {.lex_state = 0},
  [18441] = {.lex_state = 363},
  [18442] = {.lex_state = 363},
  [18443] = {.lex_state = 0},
  [18444] = {.lex_state = 0},
  [18445] = {.lex_state = 0},
  [18446] = {.lex_state = 363},
  [18447] = {.lex_state = 0},
  [18448] = {.lex_state = 363},
  [18449] = {.lex_state = 0},
  [18450] = {.lex_state = 0},
  [18451] = {.lex_state = 0},
  [18452] = {.lex_state = 0},
  [18453] = {.lex_state = 363},
  [18454] = {.lex_state = 363},
  [18455] = {.lex_state = 349},
  [18456] = {.lex_state = 0},
  [18457] = {.lex_state = 363},
  [18458] = {.lex_state = 0},
  [18459] = {.lex_state = 349},
  [18460] = {.lex_state = 349},
  [18461] = {.lex_state = 363},
  [18462] = {.lex_state = 363},
  [18463] = {.lex_state = 0},
  [18464] = {.lex_state = 349},
  [18465] = {.lex_state = 0},
  [18466] = {.lex_state = 363},
  [18467] = {.lex_state = 363},
  [18468] = {.lex_state = 0},
  [18469] = {.lex_state = 424},
  [18470] = {.lex_state = 424},
  [18471] = {.lex_state = 0},
  [18472] = {.lex_state = 0},
  [18473] = {.lex_state = 363},
  [18474] = {.lex_state = 0},
  [18475] = {.lex_state = 363},
  [18476] = {.lex_state = 363},
  [18477] = {.lex_state = 363},
  [18478] = {.lex_state = 0},
  [18479] = {.lex_state = 363},
  [18480] = {.lex_state = 0},
  [18481] = {.lex_state = 0},
  [18482] = {.lex_state = 349},
  [18483] = {.lex_state = 0},
  [18484] = {.lex_state = 363},
  [18485] = {.lex_state = 0},
  [18486] = {.lex_state = 0},
  [18487] = {.lex_state = 363},
  [18488] = {.lex_state = 349},
  [18489] = {.lex_state = 349},
  [18490] = {.lex_state = 0},
  [18491] = {.lex_state = 363},
  [18492] = {.lex_state = 0},
  [18493] = {.lex_state = 363},
  [18494] = {.lex_state = 0},
  [18495] = {.lex_state = 0},
  [18496] = {.lex_state = 0},
  [18497] = {.lex_state = 363},
  [18498] = {.lex_state = 363},
  [18499] = {.lex_state = 0},
  [18500] = {.lex_state = 424},
  [18501] = {.lex_state = 0},
  [18502] = {.lex_state = 363},
  [18503] = {.lex_state = 349},
  [18504] = {.lex_state = 363},
  [18505] = {.lex_state = 349},
  [18506] = {.lex_state = 363},
  [18507] = {.lex_state = 363},
  [18508] = {.lex_state = 0},
  [18509] = {.lex_state = 0},
  [18510] = {.lex_state = 363},
  [18511] = {.lex_state = 0},
  [18512] = {.lex_state = 424},
  [18513] = {.lex_state = 0},
  [18514] = {.lex_state = 0},
  [18515] = {.lex_state = 363},
  [18516] = {.lex_state = 349},
  [18517] = {.lex_state = 349},
  [18518] = {.lex_state = 0},
  [18519] = {.lex_state = 0},
  [18520] = {.lex_state = 0},
  [18521] = {.lex_state = 0},
  [18522] = {.lex_state = 363},
  [18523] = {.lex_state = 363},
  [18524] = {.lex_state = 363},
  [18525] = {.lex_state = 0},
  [18526] = {.lex_state = 349},
  [18527] = {.lex_state = 349},
  [18528] = {.lex_state = 363},
  [18529] = {.lex_state = 424},
  [18530] = {.lex_state = 0},
  [18531] = {.lex_state = 349},
  [18532] = {.lex_state = 0},
  [18533] = {.lex_state = 0},
  [18534] = {.lex_state = 363},
  [18535] = {.lex_state = 0},
  [18536] = {.lex_state = 349},
  [18537] = {.lex_state = 349},
  [18538] = {.lex_state = 0},
  [18539] = {.lex_state = 363},
  [18540] = {.lex_state = 0},
  [18541] = {.lex_state = 363},
  [18542] = {.lex_state = 363},
  [18543] = {.lex_state = 349},
  [18544] = {.lex_state = 349},
  [18545] = {.lex_state = 363},
  [18546] = {.lex_state = 363},
  [18547] = {.lex_state = 363},
  [18548] = {.lex_state = 0},
  [18549] = {.lex_state = 349},
  [18550] = {.lex_state = 349},
  [18551] = {.lex_state = 363},
  [18552] = {.lex_state = 0},
  [18553] = {.lex_state = 0},
  [18554] = {.lex_state = 0},
  [18555] = {.lex_state = 349},
  [18556] = {.lex_state = 349},
  [18557] = {.lex_state = 363},
  [18558] = {.lex_state = 0},
  [18559] = {.lex_state = 363},
  [18560] = {.lex_state = 363},
  [18561] = {.lex_state = 349},
  [18562] = {.lex_state = 0, .external_lex_state = 4},
  [18563] = {.lex_state = 0},
  [18564] = {.lex_state = 363},
  [18565] = {.lex_state = 349},
  [18566] = {.lex_state = 363},
  [18567] = {.lex_state = 363},
  [18568] = {.lex_state = 424},
  [18569] = {.lex_state = 0},
  [18570] = {.lex_state = 0},
  [18571] = {.lex_state = 0},
  [18572] = {.lex_state = 0},
  [18573] = {.lex_state = 0},
  [18574] = {.lex_state = 0},
  [18575] = {.lex_state = 363},
  [18576] = {.lex_state = 424},
  [18577] = {.lex_state = 0},
  [18578] = {.lex_state = 424},
  [18579] = {.lex_state = 0},
  [18580] = {.lex_state = 0},
  [18581] = {.lex_state = 363},
  [18582] = {.lex_state = 363},
  [18583] = {.lex_state = 349},
  [18584] = {.lex_state = 0},
  [18585] = {.lex_state = 0},
  [18586] = {.lex_state = 363},
  [18587] = {.lex_state = 363},
  [18588] = {.lex_state = 0},
  [18589] = {.lex_state = 0},
  [18590] = {.lex_state = 0},
  [18591] = {.lex_state = 0},
  [18592] = {.lex_state = 0},
  [18593] = {.lex_state = 0},
  [18594] = {.lex_state = 349},
  [18595] = {.lex_state = 363},
  [18596] = {.lex_state = 0},
  [18597] = {.lex_state = 363},
  [18598] = {.lex_state = 0},
  [18599] = {.lex_state = 424},
  [18600] = {.lex_state = 0},
  [18601] = {.lex_state = 363},
  [18602] = {.lex_state = 363},
  [18603] = {.lex_state = 424},
  [18604] = {.lex_state = 363},
  [18605] = {.lex_state = 0},
  [18606] = {.lex_state = 0},
  [18607] = {.lex_state = 363},
  [18608] = {.lex_state = 0},
  [18609] = {.lex_state = 0},
  [18610] = {.lex_state = 349},
  [18611] = {.lex_state = 363},
  [18612] = {.lex_state = 363},
  [18613] = {.lex_state = 0},
  [18614] = {.lex_state = 0},
  [18615] = {.lex_state = 0},
  [18616] = {.lex_state = 0},
  [18617] = {.lex_state = 363},
  [18618] = {.lex_state = 349},
  [18619] = {.lex_state = 0},
  [18620] = {.lex_state = 0},
  [18621] = {.lex_state = 363},
  [18622] = {.lex_state = 0},
  [18623] = {.lex_state = 0},
  [18624] = {.lex_state = 363},
  [18625] = {.lex_state = 0},
  [18626] = {.lex_state = 0},
  [18627] = {.lex_state = 349},
  [18628] = {.lex_state = 363},
  [18629] = {.lex_state = 0},
  [18630] = {.lex_state = 363},
  [18631] = {.lex_state = 0},
  [18632] = {.lex_state = 0},
  [18633] = {.lex_state = 0},
  [18634] = {.lex_state = 0},
  [18635] = {.lex_state = 363},
  [18636] = {.lex_state = 363},
  [18637] = {.lex_state = 363},
  [18638] = {.lex_state = 0},
  [18639] = {.lex_state = 0},
  [18640] = {.lex_state = 0},
  [18641] = {.lex_state = 0},
  [18642] = {.lex_state = 0},
  [18643] = {.lex_state = 363},
  [18644] = {.lex_state = 363},
  [18645] = {.lex_state = 0},
  [18646] = {.lex_state = 0},
  [18647] = {.lex_state = 0},
  [18648] = {.lex_state = 0},
  [18649] = {.lex_state = 0},
  [18650] = {.lex_state = 0},
  [18651] = {.lex_state = 0},
  [18652] = {.lex_state = 349},
  [18653] = {.lex_state = 0},
  [18654] = {.lex_state = 363},
  [18655] = {.lex_state = 349},
  [18656] = {.lex_state = 0},
  [18657] = {.lex_state = 0},
  [18658] = {.lex_state = 363},
  [18659] = {.lex_state = 363},
  [18660] = {.lex_state = 363},
  [18661] = {.lex_state = 0},
  [18662] = {.lex_state = 0},
  [18663] = {.lex_state = 0},
  [18664] = {.lex_state = 0},
  [18665] = {.lex_state = 363},
  [18666] = {.lex_state = 0},
  [18667] = {.lex_state = 0},
  [18668] = {.lex_state = 0},
  [18669] = {.lex_state = 0},
  [18670] = {.lex_state = 349},
  [18671] = {.lex_state = 0},
  [18672] = {.lex_state = 0},
  [18673] = {.lex_state = 363},
  [18674] = {.lex_state = 0},
  [18675] = {.lex_state = 363},
  [18676] = {.lex_state = 363},
  [18677] = {.lex_state = 363},
  [18678] = {.lex_state = 363},
  [18679] = {.lex_state = 0},
  [18680] = {.lex_state = 363},
  [18681] = {.lex_state = 363},
  [18682] = {.lex_state = 363},
  [18683] = {.lex_state = 363},
  [18684] = {.lex_state = 363},
  [18685] = {.lex_state = 363},
  [18686] = {.lex_state = 0},
  [18687] = {.lex_state = 0},
  [18688] = {.lex_state = 0, .external_lex_state = 4},
  [18689] = {.lex_state = 363},
  [18690] = {.lex_state = 363},
  [18691] = {.lex_state = 0},
  [18692] = {.lex_state = 363},
  [18693] = {.lex_state = 0},
  [18694] = {.lex_state = 363},
  [18695] = {.lex_state = 363},
  [18696] = {.lex_state = 363},
  [18697] = {.lex_state = 363},
  [18698] = {.lex_state = 0},
  [18699] = {.lex_state = 0},
  [18700] = {.lex_state = 363},
  [18701] = {.lex_state = 0},
  [18702] = {.lex_state = 0},
  [18703] = {.lex_state = 363},
  [18704] = {.lex_state = 363},
  [18705] = {.lex_state = 0},
  [18706] = {.lex_state = 363},
  [18707] = {.lex_state = 0},
  [18708] = {.lex_state = 363},
  [18709] = {.lex_state = 0},
  [18710] = {.lex_state = 0},
  [18711] = {.lex_state = 0},
  [18712] = {.lex_state = 0},
  [18713] = {.lex_state = 363},
  [18714] = {.lex_state = 363},
  [18715] = {.lex_state = 363},
  [18716] = {.lex_state = 0},
  [18717] = {.lex_state = 0},
  [18718] = {.lex_state = 0},
  [18719] = {.lex_state = 0},
  [18720] = {.lex_state = 424},
  [18721] = {.lex_state = 0},
  [18722] = {.lex_state = 0},
  [18723] = {.lex_state = 363},
  [18724] = {.lex_state = 363},
  [18725] = {.lex_state = 0},
  [18726] = {.lex_state = 0},
  [18727] = {.lex_state = 0},
  [18728] = {.lex_state = 0},
  [18729] = {.lex_state = 0},
  [18730] = {.lex_state = 363},
  [18731] = {.lex_state = 349},
  [18732] = {.lex_state = 363},
  [18733] = {.lex_state = 363},
  [18734] = {.lex_state = 363},
  [18735] = {.lex_state = 0, .external_lex_state = 4},
  [18736] = {.lex_state = 0},
  [18737] = {.lex_state = 0},
  [18738] = {.lex_state = 424},
  [18739] = {.lex_state = 349},
  [18740] = {.lex_state = 363},
  [18741] = {.lex_state = 0},
  [18742] = {.lex_state = 363},
  [18743] = {.lex_state = 0},
  [18744] = {.lex_state = 363},
  [18745] = {.lex_state = 0},
  [18746] = {.lex_state = 0},
  [18747] = {.lex_state = 349},
  [18748] = {.lex_state = 363},
  [18749] = {.lex_state = 363},
  [18750] = {.lex_state = 0},
  [18751] = {.lex_state = 363},
  [18752] = {.lex_state = 0},
  [18753] = {.lex_state = 0},
  [18754] = {.lex_state = 0},
  [18755] = {.lex_state = 0},
  [18756] = {.lex_state = 363},
  [18757] = {.lex_state = 363},
  [18758] = {.lex_state = 0},
  [18759] = {.lex_state = 363},
  [18760] = {.lex_state = 363},
  [18761] = {.lex_state = 363},
  [18762] = {.lex_state = 363},
  [18763] = {.lex_state = 0},
  [18764] = {.lex_state = 363},
  [18765] = {.lex_state = 0},
  [18766] = {.lex_state = 0},
  [18767] = {.lex_state = 363},
  [18768] = {.lex_state = 363},
  [18769] = {.lex_state = 0},
  [18770] = {.lex_state = 0},
  [18771] = {.lex_state = 363},
  [18772] = {.lex_state = 363},
  [18773] = {.lex_state = 363},
  [18774] = {.lex_state = 0},
  [18775] = {.lex_state = 363},
  [18776] = {.lex_state = 0},
  [18777] = {.lex_state = 0},
  [18778] = {.lex_state = 424},
  [18779] = {.lex_state = 0},
  [18780] = {.lex_state = 0},
  [18781] = {.lex_state = 0},
  [18782] = {.lex_state = 363},
  [18783] = {.lex_state = 0},
  [18784] = {.lex_state = 0},
  [18785] = {.lex_state = 349},
  [18786] = {.lex_state = 0, .external_lex_state = 4},
  [18787] = {.lex_state = 0},
  [18788] = {.lex_state = 0},
  [18789] = {.lex_state = 0},
  [18790] = {.lex_state = 0},
  [18791] = {.lex_state = 0},
  [18792] = {.lex_state = 0},
  [18793] = {.lex_state = 0},
  [18794] = {.lex_state = 0},
  [18795] = {.lex_state = 0},
  [18796] = {.lex_state = 0},
  [18797] = {.lex_state = 0},
  [18798] = {.lex_state = 0},
  [18799] = {.lex_state = 0},
  [18800] = {.lex_state = 0},
  [18801] = {.lex_state = 0},
  [18802] = {.lex_state = 0},
  [18803] = {.lex_state = 0},
  [18804] = {.lex_state = 363},
  [18805] = {.lex_state = 0},
  [18806] = {.lex_state = 0},
  [18807] = {.lex_state = 0},
  [18808] = {.lex_state = 0},
  [18809] = {.lex_state = 363},
  [18810] = {.lex_state = 363},
  [18811] = {.lex_state = 0},
  [18812] = {.lex_state = 0},
  [18813] = {.lex_state = 0},
  [18814] = {.lex_state = 363},
  [18815] = {.lex_state = 363},
  [18816] = {.lex_state = 363},
  [18817] = {.lex_state = 0},
  [18818] = {.lex_state = 363},
  [18819] = {.lex_state = 363},
  [18820] = {.lex_state = 363},
  [18821] = {.lex_state = 349},
  [18822] = {.lex_state = 0},
  [18823] = {.lex_state = 363},
  [18824] = {.lex_state = 363},
  [18825] = {.lex_state = 0},
  [18826] = {.lex_state = 363},
  [18827] = {.lex_state = 349},
  [18828] = {.lex_state = 0},
  [18829] = {.lex_state = 0},
  [18830] = {.lex_state = 349},
  [18831] = {.lex_state = 0},
  [18832] = {.lex_state = 0},
  [18833] = {.lex_state = 363},
  [18834] = {.lex_state = 0},
  [18835] = {.lex_state = 424},
  [18836] = {.lex_state = 0},
  [18837] = {.lex_state = 0},
  [18838] = {.lex_state = 363},
  [18839] = {.lex_state = 0},
  [18840] = {.lex_state = 0},
  [18841] = {.lex_state = 363},
  [18842] = {.lex_state = 0},
  [18843] = {.lex_state = 363},
  [18844] = {.lex_state = 0},
  [18845] = {.lex_state = 363},
  [18846] = {.lex_state = 0},
  [18847] = {.lex_state = 0},
  [18848] = {.lex_state = 363},
  [18849] = {.lex_state = 0},
  [18850] = {.lex_state = 0},
  [18851] = {.lex_state = 0},
  [18852] = {.lex_state = 0},
  [18853] = {.lex_state = 0},
  [18854] = {.lex_state = 0},
  [18855] = {.lex_state = 363},
  [18856] = {.lex_state = 0},
  [18857] = {.lex_state = 0},
  [18858] = {.lex_state = 363},
  [18859] = {.lex_state = 0},
  [18860] = {.lex_state = 0},
  [18861] = {.lex_state = 363},
  [18862] = {.lex_state = 349},
  [18863] = {.lex_state = 0},
  [18864] = {.lex_state = 363},
  [18865] = {.lex_state = 0},
  [18866] = {.lex_state = 424},
  [18867] = {.lex_state = 0},
  [18868] = {.lex_state = 0},
  [18869] = {.lex_state = 0},
  [18870] = {.lex_state = 363},
  [18871] = {.lex_state = 0},
  [18872] = {.lex_state = 0},
  [18873] = {.lex_state = 349},
  [18874] = {.lex_state = 0},
  [18875] = {.lex_state = 363},
  [18876] = {.lex_state = 0},
  [18877] = {.lex_state = 0},
  [18878] = {.lex_state = 349},
  [18879] = {.lex_state = 349},
  [18880] = {.lex_state = 0},
  [18881] = {.lex_state = 363},
  [18882] = {.lex_state = 363},
  [18883] = {.lex_state = 363},
  [18884] = {.lex_state = 363},
  [18885] = {.lex_state = 363},
  [18886] = {.lex_state = 363},
  [18887] = {.lex_state = 0},
  [18888] = {.lex_state = 363},
  [18889] = {.lex_state = 0},
  [18890] = {.lex_state = 363},
  [18891] = {.lex_state = 363},
  [18892] = {.lex_state = 0},
  [18893] = {.lex_state = 0},
  [18894] = {.lex_state = 0},
  [18895] = {.lex_state = 363},
  [18896] = {.lex_state = 0, .external_lex_state = 4},
  [18897] = {.lex_state = 0},
  [18898] = {.lex_state = 0},
  [18899] = {.lex_state = 363},
  [18900] = {.lex_state = 0},
  [18901] = {.lex_state = 424},
  [18902] = {.lex_state = 0, .external_lex_state = 4},
  [18903] = {.lex_state = 0},
  [18904] = {.lex_state = 363},
  [18905] = {.lex_state = 349},
  [18906] = {.lex_state = 363},
  [18907] = {.lex_state = 0},
  [18908] = {.lex_state = 349},
  [18909] = {.lex_state = 0},
  [18910] = {.lex_state = 0},
  [18911] = {.lex_state = 0},
  [18912] = {.lex_state = 0},
  [18913] = {.lex_state = 0},
  [18914] = {.lex_state = 0},
  [18915] = {.lex_state = 363},
  [18916] = {.lex_state = 0},
  [18917] = {.lex_state = 0},
  [18918] = {.lex_state = 349},
  [18919] = {.lex_state = 349},
  [18920] = {.lex_state = 424},
  [18921] = {.lex_state = 0},
  [18922] = {.lex_state = 0},
  [18923] = {.lex_state = 424},
  [18924] = {.lex_state = 0},
  [18925] = {.lex_state = 363},
  [18926] = {.lex_state = 363},
  [18927] = {.lex_state = 0},
  [18928] = {.lex_state = 424},
  [18929] = {.lex_state = 0},
  [18930] = {.lex_state = 0},
  [18931] = {.lex_state = 363},
  [18932] = {.lex_state = 363},
  [18933] = {.lex_state = 0},
  [18934] = {.lex_state = 363},
  [18935] = {.lex_state = 0},
  [18936] = {.lex_state = 0},
  [18937] = {.lex_state = 363},
  [18938] = {.lex_state = 0},
  [18939] = {.lex_state = 0},
  [18940] = {.lex_state = 363},
  [18941] = {.lex_state = 0},
  [18942] = {.lex_state = 0},
  [18943] = {.lex_state = 0},
  [18944] = {.lex_state = 0},
  [18945] = {.lex_state = 0},
  [18946] = {.lex_state = 0},
  [18947] = {.lex_state = 363},
  [18948] = {.lex_state = 363},
  [18949] = {.lex_state = 349},
  [18950] = {.lex_state = 0},
  [18951] = {.lex_state = 0},
  [18952] = {.lex_state = 424},
  [18953] = {.lex_state = 0},
  [18954] = {.lex_state = 0},
  [18955] = {.lex_state = 0},
  [18956] = {.lex_state = 0},
  [18957] = {.lex_state = 0},
  [18958] = {.lex_state = 424},
  [18959] = {.lex_state = 0},
  [18960] = {.lex_state = 0},
  [18961] = {.lex_state = 363},
  [18962] = {.lex_state = 0},
  [18963] = {.lex_state = 363},
  [18964] = {.lex_state = 363},
  [18965] = {.lex_state = 0},
  [18966] = {.lex_state = 349},
  [18967] = {.lex_state = 0},
  [18968] = {.lex_state = 363},
  [18969] = {.lex_state = 0},
  [18970] = {.lex_state = 0},
  [18971] = {.lex_state = 363},
  [18972] = {.lex_state = 363},
  [18973] = {.lex_state = 363},
  [18974] = {.lex_state = 363},
  [18975] = {.lex_state = 363},
  [18976] = {.lex_state = 0},
  [18977] = {.lex_state = 363},
  [18978] = {.lex_state = 363},
  [18979] = {.lex_state = 0},
  [18980] = {.lex_state = 0},
  [18981] = {.lex_state = 363},
  [18982] = {.lex_state = 0},
  [18983] = {.lex_state = 0},
  [18984] = {.lex_state = 0},
  [18985] = {.lex_state = 0},
  [18986] = {.lex_state = 363},
  [18987] = {.lex_state = 363},
  [18988] = {.lex_state = 0},
  [18989] = {.lex_state = 363},
  [18990] = {.lex_state = 0},
  [18991] = {.lex_state = 363},
  [18992] = {.lex_state = 0},
  [18993] = {.lex_state = 982},
  [18994] = {.lex_state = 349},
  [18995] = {.lex_state = 0},
  [18996] = {.lex_state = 0},
  [18997] = {.lex_state = 0, .external_lex_state = 4},
  [18998] = {.lex_state = 363},
  [18999] = {.lex_state = 0},
  [19000] = {.lex_state = 363},
  [19001] = {.lex_state = 0},
  [19002] = {.lex_state = 363},
  [19003] = {.lex_state = 363},
  [19004] = {.lex_state = 0},
  [19005] = {.lex_state = 0},
  [19006] = {.lex_state = 0},
  [19007] = {.lex_state = 0},
  [19008] = {.lex_state = 0},
  [19009] = {.lex_state = 349},
  [19010] = {.lex_state = 363},
  [19011] = {.lex_state = 349},
  [19012] = {.lex_state = 0},
  [19013] = {.lex_state = 0},
  [19014] = {.lex_state = 363},
  [19015] = {.lex_state = 0},
  [19016] = {.lex_state = 363},
  [19017] = {.lex_state = 363},
  [19018] = {.lex_state = 363},
  [19019] = {.lex_state = 349},
  [19020] = {.lex_state = 0},
  [19021] = {.lex_state = 363},
  [19022] = {.lex_state = 0},
  [19023] = {.lex_state = 0},
  [19024] = {.lex_state = 0},
  [19025] = {.lex_state = 0},
  [19026] = {.lex_state = 363},
  [19027] = {.lex_state = 0},
  [19028] = {.lex_state = 0},
  [19029] = {.lex_state = 0},
  [19030] = {.lex_state = 0},
  [19031] = {.lex_state = 0},
  [19032] = {.lex_state = 0},
  [19033] = {.lex_state = 0},
  [19034] = {.lex_state = 0},
  [19035] = {.lex_state = 363},
  [19036] = {.lex_state = 349},
  [19037] = {.lex_state = 0},
  [19038] = {.lex_state = 424},
  [19039] = {.lex_state = 0},
  [19040] = {.lex_state = 363},
  [19041] = {.lex_state = 0},
  [19042] = {.lex_state = 363},
  [19043] = {.lex_state = 349},
  [19044] = {.lex_state = 0},
  [19045] = {.lex_state = 363},
  [19046] = {.lex_state = 363},
  [19047] = {.lex_state = 0},
  [19048] = {.lex_state = 0},
  [19049] = {.lex_state = 0},
  [19050] = {.lex_state = 349},
  [19051] = {.lex_state = 0},
  [19052] = {.lex_state = 363},
  [19053] = {.lex_state = 0},
  [19054] = {.lex_state = 349},
  [19055] = {.lex_state = 363},
  [19056] = {.lex_state = 363},
  [19057] = {.lex_state = 0},
  [19058] = {.lex_state = 363},
  [19059] = {.lex_state = 0},
  [19060] = {.lex_state = 0},
  [19061] = {.lex_state = 363},
  [19062] = {.lex_state = 363},
  [19063] = {.lex_state = 363},
  [19064] = {.lex_state = 0},
  [19065] = {.lex_state = 363},
  [19066] = {.lex_state = 0},
  [19067] = {.lex_state = 0},
  [19068] = {.lex_state = 424},
  [19069] = {.lex_state = 0},
  [19070] = {.lex_state = 0},
  [19071] = {.lex_state = 0},
  [19072] = {.lex_state = 0},
  [19073] = {.lex_state = 0},
  [19074] = {.lex_state = 363},
  [19075] = {.lex_state = 0},
  [19076] = {.lex_state = 349},
  [19077] = {.lex_state = 0},
  [19078] = {.lex_state = 0},
  [19079] = {.lex_state = 349},
  [19080] = {.lex_state = 0},
  [19081] = {.lex_state = 0},
  [19082] = {.lex_state = 363},
  [19083] = {.lex_state = 424},
  [19084] = {.lex_state = 0},
  [19085] = {.lex_state = 0},
  [19086] = {.lex_state = 0},
  [19087] = {.lex_state = 0},
  [19088] = {.lex_state = 0},
  [19089] = {.lex_state = 0},
  [19090] = {.lex_state = 0},
  [19091] = {.lex_state = 0, .external_lex_state = 4},
  [19092] = {.lex_state = 0},
  [19093] = {.lex_state = 0},
  [19094] = {.lex_state = 0},
  [19095] = {.lex_state = 363},
  [19096] = {.lex_state = 0},
  [19097] = {.lex_state = 0},
  [19098] = {.lex_state = 0},
  [19099] = {.lex_state = 0},
  [19100] = {.lex_state = 0},
  [19101] = {.lex_state = 349},
  [19102] = {.lex_state = 0},
  [19103] = {.lex_state = 349},
  [19104] = {.lex_state = 363},
  [19105] = {.lex_state = 0},
  [19106] = {.lex_state = 0},
  [19107] = {.lex_state = 363},
  [19108] = {.lex_state = 0},
  [19109] = {.lex_state = 363},
  [19110] = {.lex_state = 363},
  [19111] = {.lex_state = 0},
  [19112] = {.lex_state = 349},
  [19113] = {.lex_state = 0},
  [19114] = {.lex_state = 363},
  [19115] = {.lex_state = 0},
  [19116] = {.lex_state = 0},
  [19117] = {.lex_state = 363},
  [19118] = {.lex_state = 363},
  [19119] = {.lex_state = 363},
  [19120] = {.lex_state = 363},
  [19121] = {.lex_state = 363},
  [19122] = {.lex_state = 0},
  [19123] = {.lex_state = 0},
  [19124] = {.lex_state = 363},
  [19125] = {.lex_state = 0},
  [19126] = {.lex_state = 0},
  [19127] = {.lex_state = 363},
  [19128] = {.lex_state = 0},
  [19129] = {.lex_state = 349},
  [19130] = {.lex_state = 0},
  [19131] = {.lex_state = 363},
  [19132] = {.lex_state = 0},
  [19133] = {.lex_state = 363},
  [19134] = {.lex_state = 363},
  [19135] = {.lex_state = 349},
  [19136] = {.lex_state = 0},
  [19137] = {.lex_state = 363},
  [19138] = {.lex_state = 349},
  [19139] = {.lex_state = 0},
  [19140] = {.lex_state = 349},
  [19141] = {.lex_state = 363},
  [19142] = {.lex_state = 363},
  [19143] = {.lex_state = 349},
  [19144] = {.lex_state = 363},
  [19145] = {.lex_state = 0},
  [19146] = {.lex_state = 349},
  [19147] = {.lex_state = 363},
  [19148] = {.lex_state = 0},
  [19149] = {.lex_state = 349},
  [19150] = {.lex_state = 0},
  [19151] = {.lex_state = 0},
  [19152] = {.lex_state = 0},
  [19153] = {.lex_state = 0},
  [19154] = {.lex_state = 0},
  [19155] = {.lex_state = 363},
  [19156] = {.lex_state = 363},
  [19157] = {.lex_state = 0},
  [19158] = {.lex_state = 0},
  [19159] = {.lex_state = 0, .external_lex_state = 4},
  [19160] = {.lex_state = 363},
  [19161] = {.lex_state = 0},
  [19162] = {.lex_state = 363},
  [19163] = {.lex_state = 424},
  [19164] = {.lex_state = 424},
  [19165] = {.lex_state = 0},
  [19166] = {.lex_state = 0},
  [19167] = {.lex_state = 363},
  [19168] = {.lex_state = 0},
  [19169] = {.lex_state = 363},
  [19170] = {.lex_state = 0},
  [19171] = {.lex_state = 0},
  [19172] = {.lex_state = 0},
  [19173] = {.lex_state = 363},
  [19174] = {.lex_state = 0},
  [19175] = {.lex_state = 0},
  [19176] = {.lex_state = 0},
  [19177] = {.lex_state = 363},
  [19178] = {.lex_state = 363},
  [19179] = {.lex_state = 0, .external_lex_state = 14},
  [19180] = {.lex_state = 363},
  [19181] = {.lex_state = 363},
  [19182] = {.lex_state = 363},
  [19183] = {.lex_state = 0},
  [19184] = {.lex_state = 363},
  [19185] = {.lex_state = 0},
  [19186] = {.lex_state = 0},
  [19187] = {.lex_state = 349},
  [19188] = {.lex_state = 0},
  [19189] = {.lex_state = 0},
  [19190] = {.lex_state = 0},
  [19191] = {.lex_state = 0},
  [19192] = {.lex_state = 0},
  [19193] = {.lex_state = 349},
  [19194] = {.lex_state = 0},
  [19195] = {.lex_state = 0},
  [19196] = {.lex_state = 0},
  [19197] = {.lex_state = 0},
  [19198] = {.lex_state = 363},
  [19199] = {.lex_state = 0},
  [19200] = {.lex_state = 363},
  [19201] = {.lex_state = 0},
  [19202] = {.lex_state = 363},
  [19203] = {.lex_state = 0},
  [19204] = {.lex_state = 349},
  [19205] = {.lex_state = 363},
  [19206] = {.lex_state = 0},
  [19207] = {.lex_state = 0},
  [19208] = {.lex_state = 0},
  [19209] = {.lex_state = 349},
  [19210] = {.lex_state = 363},
  [19211] = {.lex_state = 363},
  [19212] = {.lex_state = 363},
  [19213] = {.lex_state = 363},
  [19214] = {.lex_state = 363},
  [19215] = {.lex_state = 363},
  [19216] = {.lex_state = 0},
  [19217] = {.lex_state = 363},
  [19218] = {.lex_state = 363},
  [19219] = {.lex_state = 363},
  [19220] = {.lex_state = 363},
  [19221] = {.lex_state = 363},
  [19222] = {.lex_state = 363},
  [19223] = {.lex_state = 363},
  [19224] = {.lex_state = 424},
  [19225] = {.lex_state = 363},
  [19226] = {.lex_state = 0, .external_lex_state = 4},
  [19227] = {.lex_state = 0},
  [19228] = {.lex_state = 363},
  [19229] = {.lex_state = 0},
  [19230] = {.lex_state = 363},
  [19231] = {.lex_state = 0},
  [19232] = {.lex_state = 363},
  [19233] = {.lex_state = 0},
  [19234] = {.lex_state = 363},
  [19235] = {.lex_state = 363},
  [19236] = {.lex_state = 0},
  [19237] = {.lex_state = 363},
  [19238] = {.lex_state = 0},
  [19239] = {.lex_state = 0},
  [19240] = {.lex_state = 0},
  [19241] = {.lex_state = 0},
  [19242] = {.lex_state = 0},
  [19243] = {.lex_state = 363},
  [19244] = {.lex_state = 363},
  [19245] = {.lex_state = 0},
  [19246] = {.lex_state = 363},
  [19247] = {.lex_state = 0},
  [19248] = {.lex_state = 0},
  [19249] = {.lex_state = 363},
  [19250] = {.lex_state = 0},
  [19251] = {.lex_state = 0},
  [19252] = {.lex_state = 0},
  [19253] = {.lex_state = 0},
  [19254] = {.lex_state = 363},
  [19255] = {.lex_state = 0},
  [19256] = {.lex_state = 0},
  [19257] = {.lex_state = 0},
  [19258] = {.lex_state = 0},
  [19259] = {.lex_state = 363},
  [19260] = {.lex_state = 349},
  [19261] = {.lex_state = 363},
  [19262] = {.lex_state = 0},
  [19263] = {.lex_state = 0},
  [19264] = {.lex_state = 349},
  [19265] = {.lex_state = 363},
  [19266] = {.lex_state = 363},
  [19267] = {.lex_state = 363},
  [19268] = {.lex_state = 0},
  [19269] = {.lex_state = 363},
  [19270] = {.lex_state = 0},
  [19271] = {.lex_state = 0},
  [19272] = {.lex_state = 363},
  [19273] = {.lex_state = 0},
  [19274] = {.lex_state = 363},
  [19275] = {.lex_state = 0},
  [19276] = {.lex_state = 0},
  [19277] = {.lex_state = 0},
  [19278] = {.lex_state = 0},
  [19279] = {.lex_state = 349},
  [19280] = {.lex_state = 363},
  [19281] = {.lex_state = 0},
  [19282] = {.lex_state = 363},
  [19283] = {.lex_state = 363},
  [19284] = {.lex_state = 363},
  [19285] = {.lex_state = 363},
  [19286] = {.lex_state = 363},
  [19287] = {.lex_state = 363},
  [19288] = {.lex_state = 363},
  [19289] = {.lex_state = 363},
  [19290] = {.lex_state = 363},
  [19291] = {.lex_state = 363},
  [19292] = {.lex_state = 0, .external_lex_state = 4},
  [19293] = {.lex_state = 349},
  [19294] = {.lex_state = 0},
  [19295] = {.lex_state = 0},
  [19296] = {.lex_state = 0},
  [19297] = {.lex_state = 363},
  [19298] = {.lex_state = 363},
  [19299] = {.lex_state = 0},
  [19300] = {.lex_state = 363},
  [19301] = {.lex_state = 363},
  [19302] = {.lex_state = 363},
  [19303] = {.lex_state = 363},
  [19304] = {.lex_state = 0},
  [19305] = {.lex_state = 0},
  [19306] = {.lex_state = 363},
  [19307] = {.lex_state = 0},
  [19308] = {.lex_state = 349},
  [19309] = {.lex_state = 0},
  [19310] = {.lex_state = 363},
  [19311] = {.lex_state = 0},
  [19312] = {.lex_state = 363},
  [19313] = {.lex_state = 0},
  [19314] = {.lex_state = 363},
  [19315] = {.lex_state = 424},
  [19316] = {.lex_state = 0},
  [19317] = {.lex_state = 0},
  [19318] = {.lex_state = 0},
  [19319] = {.lex_state = 349},
  [19320] = {.lex_state = 0},
  [19321] = {.lex_state = 0},
  [19322] = {.lex_state = 0},
  [19323] = {.lex_state = 0},
  [19324] = {.lex_state = 0},
  [19325] = {.lex_state = 424},
  [19326] = {.lex_state = 0},
  [19327] = {.lex_state = 0},
  [19328] = {.lex_state = 0},
  [19329] = {.lex_state = 363},
  [19330] = {.lex_state = 0},
  [19331] = {.lex_state = 0},
  [19332] = {.lex_state = 0},
  [19333] = {.lex_state = 0},
  [19334] = {.lex_state = 0},
  [19335] = {.lex_state = 0},
  [19336] = {.lex_state = 0},
  [19337] = {.lex_state = 0},
  [19338] = {.lex_state = 0},
  [19339] = {.lex_state = 0},
  [19340] = {.lex_state = 0},
  [19341] = {.lex_state = 0, .external_lex_state = 4},
  [19342] = {.lex_state = 0},
  [19343] = {.lex_state = 363},
  [19344] = {.lex_state = 363},
  [19345] = {.lex_state = 363},
  [19346] = {.lex_state = 0},
  [19347] = {.lex_state = 424},
  [19348] = {.lex_state = 0},
  [19349] = {.lex_state = 0},
  [19350] = {.lex_state = 0, .external_lex_state = 4},
  [19351] = {.lex_state = 363},
  [19352] = {.lex_state = 0},
  [19353] = {.lex_state = 0},
  [19354] = {.lex_state = 0},
  [19355] = {.lex_state = 363},
  [19356] = {.lex_state = 0},
  [19357] = {.lex_state = 0},
  [19358] = {.lex_state = 0},
  [19359] = {.lex_state = 0},
  [19360] = {.lex_state = 0},
  [19361] = {.lex_state = 424},
  [19362] = {.lex_state = 0},
  [19363] = {.lex_state = 0},
  [19364] = {.lex_state = 0},
  [19365] = {.lex_state = 424},
  [19366] = {.lex_state = 0},
  [19367] = {.lex_state = 0},
  [19368] = {.lex_state = 0},
  [19369] = {.lex_state = 0},
  [19370] = {.lex_state = 0},
  [19371] = {.lex_state = 0},
  [19372] = {.lex_state = 0},
  [19373] = {.lex_state = 0},
  [19374] = {.lex_state = 0},
  [19375] = {.lex_state = 0},
  [19376] = {.lex_state = 363},
  [19377] = {.lex_state = 0},
  [19378] = {.lex_state = 0},
  [19379] = {.lex_state = 363},
  [19380] = {.lex_state = 363},
  [19381] = {.lex_state = 0},
  [19382] = {.lex_state = 363},
  [19383] = {.lex_state = 349},
  [19384] = {.lex_state = 0},
  [19385] = {.lex_state = 0},
  [19386] = {.lex_state = 0},
  [19387] = {.lex_state = 0},
  [19388] = {.lex_state = 363},
  [19389] = {.lex_state = 0},
  [19390] = {.lex_state = 0},
  [19391] = {.lex_state = 363},
  [19392] = {.lex_state = 0},
  [19393] = {.lex_state = 0},
  [19394] = {.lex_state = 0},
  [19395] = {.lex_state = 0},
  [19396] = {.lex_state = 363},
  [19397] = {.lex_state = 363},
  [19398] = {.lex_state = 363},
  [19399] = {.lex_state = 424},
  [19400] = {.lex_state = 349},
  [19401] = {.lex_state = 0, .external_lex_state = 4},
  [19402] = {.lex_state = 0},
  [19403] = {.lex_state = 0},
  [19404] = {.lex_state = 424},
  [19405] = {.lex_state = 0},
  [19406] = {.lex_state = 363},
  [19407] = {.lex_state = 0},
  [19408] = {.lex_state = 0},
  [19409] = {.lex_state = 349},
  [19410] = {.lex_state = 0},
  [19411] = {.lex_state = 363},
  [19412] = {.lex_state = 0},
  [19413] = {.lex_state = 349},
  [19414] = {.lex_state = 363},
  [19415] = {.lex_state = 0},
  [19416] = {.lex_state = 0},
  [19417] = {.lex_state = 0},
  [19418] = {.lex_state = 424},
  [19419] = {.lex_state = 0},
  [19420] = {.lex_state = 0},
  [19421] = {.lex_state = 0},
  [19422] = {.lex_state = 363},
  [19423] = {.lex_state = 0},
  [19424] = {.lex_state = 0},
  [19425] = {.lex_state = 0, .external_lex_state = 4},
  [19426] = {.lex_state = 0},
  [19427] = {.lex_state = 349},
  [19428] = {.lex_state = 0},
  [19429] = {.lex_state = 0},
  [19430] = {.lex_state = 0},
  [19431] = {.lex_state = 363},
  [19432] = {.lex_state = 0},
  [19433] = {.lex_state = 363},
  [19434] = {.lex_state = 0},
  [19435] = {.lex_state = 349},
  [19436] = {.lex_state = 0},
  [19437] = {.lex_state = 0},
  [19438] = {.lex_state = 0},
  [19439] = {.lex_state = 0},
  [19440] = {.lex_state = 0},
  [19441] = {.lex_state = 0},
  [19442] = {.lex_state = 363},
  [19443] = {.lex_state = 0},
  [19444] = {.lex_state = 0},
  [19445] = {.lex_state = 0},
  [19446] = {.lex_state = 363},
  [19447] = {.lex_state = 363},
  [19448] = {.lex_state = 0},
  [19449] = {.lex_state = 0},
  [19450] = {.lex_state = 0},
  [19451] = {.lex_state = 0, .external_lex_state = 4},
  [19452] = {.lex_state = 363},
  [19453] = {.lex_state = 0},
  [19454] = {.lex_state = 363},
  [19455] = {.lex_state = 363},
  [19456] = {.lex_state = 0},
  [19457] = {.lex_state = 0},
  [19458] = {.lex_state = 0},
  [19459] = {.lex_state = 0},
  [19460] = {.lex_state = 424},
  [19461] = {.lex_state = 424},
  [19462] = {.lex_state = 363},
  [19463] = {.lex_state = 0},
  [19464] = {.lex_state = 363},
  [19465] = {.lex_state = 0},
  [19466] = {.lex_state = 0},
  [19467] = {.lex_state = 0},
  [19468] = {.lex_state = 363},
  [19469] = {.lex_state = 0},
  [19470] = {.lex_state = 363},
  [19471] = {.lex_state = 0},
  [19472] = {.lex_state = 424},
  [19473] = {.lex_state = 0},
  [19474] = {.lex_state = 363},
  [19475] = {.lex_state = 0},
  [19476] = {.lex_state = 0},
  [19477] = {.lex_state = 0},
  [19478] = {.lex_state = 0, .external_lex_state = 4},
  [19479] = {.lex_state = 363},
  [19480] = {.lex_state = 0},
  [19481] = {.lex_state = 363},
  [19482] = {.lex_state = 0},
  [19483] = {.lex_state = 363},
  [19484] = {.lex_state = 363},
  [19485] = {.lex_state = 363},
  [19486] = {.lex_state = 363},
  [19487] = {.lex_state = 363},
  [19488] = {.lex_state = 363},
  [19489] = {.lex_state = 363},
  [19490] = {.lex_state = 0},
  [19491] = {.lex_state = 0},
  [19492] = {.lex_state = 0},
  [19493] = {.lex_state = 363},
  [19494] = {.lex_state = 363},
  [19495] = {.lex_state = 363},
  [19496] = {.lex_state = 0},
  [19497] = {.lex_state = 349},
  [19498] = {.lex_state = 0},
  [19499] = {.lex_state = 363},
  [19500] = {.lex_state = 0},
  [19501] = {.lex_state = 0},
  [19502] = {.lex_state = 0},
  [19503] = {.lex_state = 0},
  [19504] = {.lex_state = 0},
  [19505] = {.lex_state = 0, .external_lex_state = 4},
  [19506] = {.lex_state = 0},
  [19507] = {.lex_state = 349},
  [19508] = {.lex_state = 424},
  [19509] = {.lex_state = 0},
  [19510] = {.lex_state = 0},
  [19511] = {.lex_state = 363},
  [19512] = {.lex_state = 0},
  [19513] = {.lex_state = 349},
  [19514] = {.lex_state = 0},
  [19515] = {.lex_state = 363},
  [19516] = {.lex_state = 0},
  [19517] = {.lex_state = 0},
  [19518] = {.lex_state = 363},
  [19519] = {.lex_state = 0},
  [19520] = {.lex_state = 0, .external_lex_state = 4},
  [19521] = {.lex_state = 0},
  [19522] = {.lex_state = 0},
  [19523] = {.lex_state = 0},
  [19524] = {.lex_state = 0},
  [19525] = {.lex_state = 0},
  [19526] = {.lex_state = 0},
  [19527] = {.lex_state = 0},
  [19528] = {.lex_state = 0},
  [19529] = {.lex_state = 363},
  [19530] = {.lex_state = 0},
  [19531] = {.lex_state = 424},
  [19532] = {.lex_state = 0},
  [19533] = {.lex_state = 0},
  [19534] = {.lex_state = 363},
  [19535] = {.lex_state = 363},
  [19536] = {.lex_state = 363},
  [19537] = {.lex_state = 0},
  [19538] = {.lex_state = 0},
  [19539] = {.lex_state = 0},
  [19540] = {.lex_state = 0},
  [19541] = {.lex_state = 0},
  [19542] = {.lex_state = 0},
  [19543] = {.lex_state = 0},
  [19544] = {.lex_state = 0, .external_lex_state = 4},
  [19545] = {.lex_state = 0},
  [19546] = {.lex_state = 363},
  [19547] = {.lex_state = 363},
  [19548] = {.lex_state = 0},
  [19549] = {.lex_state = 0},
  [19550] = {.lex_state = 0},
  [19551] = {.lex_state = 363},
  [19552] = {.lex_state = 0},
  [19553] = {.lex_state = 0},
  [19554] = {.lex_state = 0},
  [19555] = {.lex_state = 424},
  [19556] = {.lex_state = 0},
  [19557] = {.lex_state = 0},
  [19558] = {.lex_state = 424},
  [19559] = {.lex_state = 0},
  [19560] = {.lex_state = 0},
  [19561] = {.lex_state = 0},
  [19562] = {.lex_state = 0},
  [19563] = {.lex_state = 0},
  [19564] = {.lex_state = 0},
  [19565] = {.lex_state = 363},
  [19566] = {.lex_state = 349},
  [19567] = {.lex_state = 0},
  [19568] = {.lex_state = 424},
  [19569] = {.lex_state = 0},
  [19570] = {.lex_state = 0},
  [19571] = {.lex_state = 0, .external_lex_state = 4},
  [19572] = {.lex_state = 363},
  [19573] = {.lex_state = 0},
  [19574] = {.lex_state = 363},
  [19575] = {.lex_state = 0},
  [19576] = {.lex_state = 363},
  [19577] = {.lex_state = 0},
  [19578] = {.lex_state = 0},
  [19579] = {.lex_state = 0},
  [19580] = {.lex_state = 0},
  [19581] = {.lex_state = 363},
  [19582] = {.lex_state = 0},
  [19583] = {.lex_state = 363},
  [19584] = {.lex_state = 363},
  [19585] = {.lex_state = 0},
  [19586] = {.lex_state = 0},
  [19587] = {.lex_state = 0},
  [19588] = {.lex_state = 0, .external_lex_state = 4},
  [19589] = {.lex_state = 363},
  [19590] = {.lex_state = 349},
  [19591] = {.lex_state = 0},
  [19592] = {.lex_state = 0},
  [19593] = {.lex_state = 363},
  [19594] = {.lex_state = 0},
  [19595] = {.lex_state = 0},
  [19596] = {.lex_state = 363},
  [19597] = {.lex_state = 363},
  [19598] = {.lex_state = 363},
  [19599] = {.lex_state = 0},
  [19600] = {.lex_state = 0},
  [19601] = {.lex_state = 363},
  [19602] = {.lex_state = 363},
  [19603] = {.lex_state = 363},
  [19604] = {.lex_state = 349},
  [19605] = {.lex_state = 363},
  [19606] = {.lex_state = 0},
  [19607] = {.lex_state = 0, .external_lex_state = 4},
  [19608] = {.lex_state = 0},
  [19609] = {.lex_state = 363},
  [19610] = {.lex_state = 0},
  [19611] = {.lex_state = 0},
  [19612] = {.lex_state = 0},
  [19613] = {.lex_state = 349},
  [19614] = {.lex_state = 0},
  [19615] = {.lex_state = 0},
  [19616] = {(TSStateId)(-1)},
  [19617] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_block_comment] = STATE(0),
    [sym_line_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__word_identifier] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_begin] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_baremodule] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_primitive] = ACTIONS(1),
    [anon_sym_mutable] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_macro] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [sym_continue_statement] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_outer] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_u2208] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_COLON2] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_DOT_EQ] = ACTIONS(1),
    [aux_sym_quote_expression_token1] = ACTIONS(1),
    [anon_sym_isa] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [aux_sym_integer_literal_token1] = ACTIONS(1),
    [aux_sym_integer_literal_token2] = ACTIONS(1),
    [aux_sym_integer_literal_token3] = ACTIONS(1),
    [aux_sym_integer_literal_token4] = ACTIONS(1),
    [aux_sym_float_literal_token1] = ACTIONS(1),
    [aux_sym_float_literal_token3] = ACTIONS(1),
    [aux_sym_float_literal_token4] = ACTIONS(1),
    [sym_character_literal] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1),
    [aux_sym__assignment_operator_token1] = ACTIONS(1),
    [sym__pair_operator] = ACTIONS(1),
    [sym__arrow_operator] = ACTIONS(1),
    [sym__lazy_or_operator] = ACTIONS(1),
    [sym__lazy_and_operator] = ACTIONS(1),
    [sym__comparison_operator] = ACTIONS(1),
    [sym__pipe_right_operator] = ACTIONS(1),
    [sym__pipe_left_operator] = ACTIONS(1),
    [sym__ellipsis_operator] = ACTIONS(1),
    [sym__plus_operator] = ACTIONS(1),
    [sym__times_operator] = ACTIONS(1),
    [sym__rational_operator] = ACTIONS(1),
    [sym__bitshift_operator] = ACTIONS(1),
    [sym__power_operator] = ACTIONS(1),
    [sym__tilde_operator] = ACTIONS(1),
    [sym__type_order_operator] = ACTIONS(1),
    [sym__unary_operator] = ACTIONS(1),
    [sym__unary_plus_operator] = ACTIONS(1),
    [anon_sym_DOT2] = ACTIONS(1),
    [aux_sym__terminator_token2] = ACTIONS(1),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__block_comment_rest] = ACTIONS(1),
    [sym__immediate_paren] = ACTIONS(1),
    [sym__immediate_bracket] = ACTIONS(1),
    [sym__immediate_brace] = ACTIONS(1),
    [sym__immediate_string_start] = ACTIONS(1),
    [sym__immediate_command_start] = ACTIONS(1),
    [sym__content_cmd_1] = ACTIONS(1),
    [sym__content_cmd_1_raw] = ACTIONS(1),
    [sym__content_cmd_3] = ACTIONS(1),
    [sym__content_cmd_3_raw] = ACTIONS(1),
    [sym__content_str_1] = ACTIONS(1),
    [sym__content_str_1_raw] = ACTIONS(1),
    [sym__content_str_3] = ACTIONS(1),
    [sym__content_str_3_raw] = ACTIONS(1),
    [sym__end_cmd] = ACTIONS(1),
    [sym__end_str] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(19491),
    [sym__block] = STATE(18492),
    [sym_open_tuple] = STATE(15282),
    [sym_assignment] = STATE(16065),
    [sym__expression] = STATE(12600),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10407),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(13011),
    [sym_unary_expression] = STATE(13011),
    [sym_range_expression] = STATE(13011),
    [sym_splat_expression] = STATE(13011),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12652),
    [sym_unary_typed_expression] = STATE(13011),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(13011),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12465),
    [sym_block_comment] = STATE(1),
    [sym_line_comment] = STATE(1),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2] = {
    [sym__block] = STATE(17328),
    [sym_open_tuple] = STATE(14274),
    [sym_assignment] = STATE(14810),
    [sym__expression] = STATE(11938),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(2),
    [sym_line_comment] = STATE(2),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(107),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(163),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(169),
    [aux_sym_integer_literal_token2] = ACTIONS(169),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(173),
    [aux_sym_float_literal_token3] = ACTIONS(173),
    [aux_sym_float_literal_token4] = ACTIONS(173),
    [sym_character_literal] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(181),
    [sym__type_order_operator] = ACTIONS(181),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym__terminator_token1] = ACTIONS(183),
    [aux_sym__terminator_token2] = ACTIONS(185),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(191),
    [sym__immediate_command_start] = ACTIONS(193),
  },
  [3] = {
    [sym__block] = STATE(17328),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(3),
    [sym_line_comment] = STATE(3),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(107),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(223),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(237),
    [aux_sym__terminator_token2] = ACTIONS(239),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(241),
    [sym__immediate_command_start] = ACTIONS(243),
  },
  [4] = {
    [sym_open_tuple] = STATE(7329),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7076),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(12157),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(4),
    [sym_line_comment] = STATE(4),
    [aux_sym_macro_argument_list_repeat1] = STATE(118),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(323),
    [sym__immediate_bracket] = ACTIONS(325),
    [sym__immediate_brace] = ACTIONS(327),
  },
  [5] = {
    [sym_open_tuple] = STATE(7329),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7076),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(12312),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(5),
    [sym_line_comment] = STATE(5),
    [aux_sym_macro_argument_list_repeat1] = STATE(118),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(333),
    [sym__immediate_bracket] = ACTIONS(335),
    [sym__immediate_brace] = ACTIONS(337),
  },
  [6] = {
    [sym_open_tuple] = STATE(7321),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7074),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(7512),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(6),
    [sym_line_comment] = STATE(6),
    [aux_sym_macro_argument_list_repeat1] = STATE(105),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(247),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(415),
    [sym__immediate_bracket] = ACTIONS(417),
    [sym__immediate_brace] = ACTIONS(419),
  },
  [7] = {
    [sym_open_tuple] = STATE(7321),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7074),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(7673),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(7),
    [sym_line_comment] = STATE(7),
    [aux_sym_macro_argument_list_repeat1] = STATE(105),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(421),
    [sym__immediate_bracket] = ACTIONS(423),
    [sym__immediate_brace] = ACTIONS(425),
  },
  [8] = {
    [sym_open_tuple] = STATE(7321),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7074),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(8),
    [sym_line_comment] = STATE(8),
    [aux_sym_macro_argument_list_repeat1] = STATE(117),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(247),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [9] = {
    [sym_open_tuple] = STATE(7321),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7074),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(9),
    [sym_line_comment] = STATE(9),
    [aux_sym_macro_argument_list_repeat1] = STATE(117),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [10] = {
    [sym_open_tuple] = STATE(7329),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7076),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(7475),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(10),
    [sym_line_comment] = STATE(10),
    [aux_sym_macro_argument_list_repeat1] = STATE(119),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(439),
    [sym__immediate_bracket] = ACTIONS(441),
    [sym__immediate_brace] = ACTIONS(443),
  },
  [11] = {
    [sym_open_tuple] = STATE(7329),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7076),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(7508),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(11),
    [sym_line_comment] = STATE(11),
    [aux_sym_macro_argument_list_repeat1] = STATE(119),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(445),
    [sym__immediate_bracket] = ACTIONS(447),
    [sym__immediate_brace] = ACTIONS(449),
  },
  [12] = {
    [sym_open_tuple] = STATE(8432),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(12),
    [sym_line_comment] = STATE(12),
    [aux_sym_macro_argument_list_repeat1] = STATE(123),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [13] = {
    [sym_open_tuple] = STATE(7463),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7489),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(12157),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(13),
    [sym_line_comment] = STATE(13),
    [aux_sym_macro_argument_list_repeat1] = STATE(156),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(323),
    [sym__immediate_bracket] = ACTIONS(325),
    [sym__immediate_brace] = ACTIONS(327),
  },
  [14] = {
    [sym_open_tuple] = STATE(8430),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(7633),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(14),
    [sym_line_comment] = STATE(14),
    [aux_sym_macro_argument_list_repeat1] = STATE(138),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [15] = {
    [sym_open_tuple] = STATE(8430),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(7633),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(15),
    [sym_line_comment] = STATE(15),
    [aux_sym_macro_argument_list_repeat1] = STATE(138),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [16] = {
    [sym_open_tuple] = STATE(8432),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(8234),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(16),
    [sym_line_comment] = STATE(16),
    [aux_sym_macro_argument_list_repeat1] = STATE(142),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(611),
    [sym__immediate_bracket] = ACTIONS(613),
    [sym__immediate_brace] = ACTIONS(615),
  },
  [17] = {
    [sym_open_tuple] = STATE(8432),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(17),
    [sym_line_comment] = STATE(17),
    [aux_sym_macro_argument_list_repeat1] = STATE(123),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [18] = {
    [sym_open_tuple] = STATE(7463),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7489),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(12312),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(18),
    [sym_line_comment] = STATE(18),
    [aux_sym_macro_argument_list_repeat1] = STATE(156),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(333),
    [sym__immediate_bracket] = ACTIONS(335),
    [sym__immediate_brace] = ACTIONS(337),
  },
  [19] = {
    [sym_open_tuple] = STATE(7787),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(7512),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(19),
    [sym_line_comment] = STATE(19),
    [aux_sym_macro_argument_list_repeat1] = STATE(143),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(247),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(415),
    [sym__immediate_bracket] = ACTIONS(417),
    [sym__immediate_brace] = ACTIONS(419),
  },
  [20] = {
    [sym_open_tuple] = STATE(7787),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(20),
    [sym_line_comment] = STATE(20),
    [aux_sym_macro_argument_list_repeat1] = STATE(152),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(247),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [21] = {
    [sym_open_tuple] = STATE(7463),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7489),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(7475),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(21),
    [sym_line_comment] = STATE(21),
    [aux_sym_macro_argument_list_repeat1] = STATE(165),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(247),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(439),
    [sym__immediate_bracket] = ACTIONS(441),
    [sym__immediate_brace] = ACTIONS(443),
  },
  [22] = {
    [sym_open_tuple] = STATE(7463),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7489),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_macro_argument_list] = STATE(7508),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(22),
    [sym_line_comment] = STATE(22),
    [aux_sym_macro_argument_list_repeat1] = STATE(165),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(445),
    [sym__immediate_bracket] = ACTIONS(447),
    [sym__immediate_brace] = ACTIONS(449),
  },
  [23] = {
    [sym_open_tuple] = STATE(8420),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(8539),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(23),
    [sym_line_comment] = STATE(23),
    [aux_sym_macro_argument_list_repeat1] = STATE(130),
    [ts_builtin_sym_end] = ACTIONS(321),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(247),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(701),
    [sym__immediate_bracket] = ACTIONS(703),
    [sym__immediate_brace] = ACTIONS(705),
  },
  [24] = {
    [sym_open_tuple] = STATE(8420),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(7986),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(24),
    [sym_line_comment] = STATE(24),
    [aux_sym_macro_argument_list_repeat1] = STATE(130),
    [ts_builtin_sym_end] = ACTIONS(331),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(329),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(707),
    [sym__immediate_bracket] = ACTIONS(709),
    [sym__immediate_brace] = ACTIONS(711),
  },
  [25] = {
    [sym_open_tuple] = STATE(7787),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(25),
    [sym_line_comment] = STATE(25),
    [aux_sym_macro_argument_list_repeat1] = STATE(152),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [26] = {
    [sym_open_tuple] = STATE(8425),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(7627),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(26),
    [sym_line_comment] = STATE(26),
    [aux_sym_macro_argument_list_repeat1] = STATE(127),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [27] = {
    [sym_open_tuple] = STATE(8425),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(7627),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(8291),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(27),
    [sym_line_comment] = STATE(27),
    [aux_sym_macro_argument_list_repeat1] = STATE(139),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(789),
    [sym__immediate_bracket] = ACTIONS(791),
    [sym__immediate_brace] = ACTIONS(793),
  },
  [28] = {
    [sym_open_tuple] = STATE(8425),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(7627),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(8336),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(28),
    [sym_line_comment] = STATE(28),
    [aux_sym_macro_argument_list_repeat1] = STATE(139),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(795),
    [sym__immediate_bracket] = ACTIONS(797),
    [sym__immediate_brace] = ACTIONS(799),
  },
  [29] = {
    [sym_open_tuple] = STATE(8425),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(7627),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(29),
    [sym_line_comment] = STATE(29),
    [aux_sym_macro_argument_list_repeat1] = STATE(127),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [30] = {
    [sym_open_tuple] = STATE(7787),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_macro_argument_list] = STATE(7673),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(30),
    [sym_line_comment] = STATE(30),
    [aux_sym_macro_argument_list_repeat1] = STATE(143),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(329),
    [anon_sym_else] = ACTIONS(329),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(421),
    [sym__immediate_bracket] = ACTIONS(423),
    [sym__immediate_brace] = ACTIONS(425),
  },
  [31] = {
    [sym_open_tuple] = STATE(8430),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(7633),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(8586),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(31),
    [sym_line_comment] = STATE(31),
    [aux_sym_macro_argument_list_repeat1] = STATE(141),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(801),
    [sym__immediate_bracket] = ACTIONS(803),
    [sym__immediate_brace] = ACTIONS(805),
  },
  [32] = {
    [sym_open_tuple] = STATE(8430),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(7633),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(8029),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(32),
    [sym_line_comment] = STATE(32),
    [aux_sym_macro_argument_list_repeat1] = STATE(141),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(807),
    [sym__immediate_bracket] = ACTIONS(809),
    [sym__immediate_brace] = ACTIONS(811),
  },
  [33] = {
    [sym_open_tuple] = STATE(8432),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(8150),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(33),
    [sym_line_comment] = STATE(33),
    [aux_sym_macro_argument_list_repeat1] = STATE(142),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(813),
    [sym__immediate_bracket] = ACTIONS(815),
    [sym__immediate_brace] = ACTIONS(817),
  },
  [34] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(34),
    [sym_line_comment] = STATE(34),
    [aux_sym_macro_argument_list_repeat1] = STATE(261),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [35] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8179),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(35),
    [sym_line_comment] = STATE(35),
    [aux_sym_macro_argument_list_repeat1] = STATE(228),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(907),
    [sym__immediate_bracket] = ACTIONS(909),
    [sym__immediate_brace] = ACTIONS(911),
  },
  [36] = {
    [sym_open_tuple] = STATE(8521),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(8538),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(36),
    [sym_line_comment] = STATE(36),
    [aux_sym_macro_argument_list_repeat1] = STATE(222),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [37] = {
    [sym_open_tuple] = STATE(8521),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(8538),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(37),
    [sym_line_comment] = STATE(37),
    [aux_sym_macro_argument_list_repeat1] = STATE(222),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [38] = {
    [sym_open_tuple] = STATE(8420),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(38),
    [sym_line_comment] = STATE(38),
    [aux_sym_macro_argument_list_repeat1] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(321),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [39] = {
    [sym_open_tuple] = STATE(8420),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(39),
    [sym_line_comment] = STATE(39),
    [aux_sym_macro_argument_list_repeat1] = STATE(271),
    [ts_builtin_sym_end] = ACTIONS(331),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [40] = {
    [sym_open_tuple] = STATE(8650),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8485),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(40),
    [sym_line_comment] = STATE(40),
    [aux_sym_macro_argument_list_repeat1] = STATE(219),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [41] = {
    [sym_open_tuple] = STATE(8650),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8485),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(41),
    [sym_line_comment] = STATE(41),
    [aux_sym_macro_argument_list_repeat1] = STATE(219),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [42] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(42),
    [sym_line_comment] = STATE(42),
    [aux_sym_macro_argument_list_repeat1] = STATE(261),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [43] = {
    [sym_open_tuple] = STATE(8521),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(8538),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(8291),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(43),
    [sym_line_comment] = STATE(43),
    [aux_sym_macro_argument_list_repeat1] = STATE(247),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(789),
    [sym__immediate_bracket] = ACTIONS(791),
    [sym__immediate_brace] = ACTIONS(793),
  },
  [44] = {
    [sym_open_tuple] = STATE(8521),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(8538),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_macro_argument_list] = STATE(8336),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(44),
    [sym_line_comment] = STATE(44),
    [aux_sym_macro_argument_list_repeat1] = STATE(247),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(795),
    [sym__immediate_bracket] = ACTIONS(797),
    [sym__immediate_brace] = ACTIONS(799),
  },
  [45] = {
    [sym_open_tuple] = STATE(8288),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(45),
    [sym_line_comment] = STATE(45),
    [aux_sym_macro_argument_list_repeat1] = STATE(246),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [46] = {
    [sym_open_tuple] = STATE(8288),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(46),
    [sym_line_comment] = STATE(46),
    [aux_sym_macro_argument_list_repeat1] = STATE(246),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [47] = {
    [sym_open_tuple] = STATE(8288),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(8586),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(47),
    [sym_line_comment] = STATE(47),
    [aux_sym_macro_argument_list_repeat1] = STATE(253),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(801),
    [sym__immediate_bracket] = ACTIONS(803),
    [sym__immediate_brace] = ACTIONS(805),
  },
  [48] = {
    [sym_open_tuple] = STATE(8288),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_macro_argument_list] = STATE(8029),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(48),
    [sym_line_comment] = STATE(48),
    [aux_sym_macro_argument_list_repeat1] = STATE(253),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(807),
    [sym__immediate_bracket] = ACTIONS(809),
    [sym__immediate_brace] = ACTIONS(811),
  },
  [49] = {
    [sym_open_tuple] = STATE(8454),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(8456),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(8150),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(49),
    [sym_line_comment] = STATE(49),
    [aux_sym_macro_argument_list_repeat1] = STATE(256),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(813),
    [sym__immediate_bracket] = ACTIONS(815),
    [sym__immediate_brace] = ACTIONS(817),
  },
  [50] = {
    [sym_open_tuple] = STATE(8454),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(8456),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(8234),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(50),
    [sym_line_comment] = STATE(50),
    [aux_sym_macro_argument_list_repeat1] = STATE(256),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(611),
    [sym__immediate_bracket] = ACTIONS(613),
    [sym__immediate_brace] = ACTIONS(615),
  },
  [51] = {
    [sym_open_tuple] = STATE(8454),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(8456),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(51),
    [sym_line_comment] = STATE(51),
    [aux_sym_macro_argument_list_repeat1] = STATE(255),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(247),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [52] = {
    [sym_open_tuple] = STATE(8650),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8485),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(8821),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(52),
    [sym_line_comment] = STATE(52),
    [aux_sym_macro_argument_list_repeat1] = STATE(244),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1017),
    [sym__immediate_bracket] = ACTIONS(1019),
    [sym__immediate_brace] = ACTIONS(1021),
  },
  [53] = {
    [sym_open_tuple] = STATE(8650),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8485),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(8649),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(53),
    [sym_line_comment] = STATE(53),
    [aux_sym_macro_argument_list_repeat1] = STATE(244),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1023),
    [sym__immediate_bracket] = ACTIONS(1025),
    [sym__immediate_brace] = ACTIONS(1027),
  },
  [54] = {
    [sym_open_tuple] = STATE(8454),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(8456),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(54),
    [sym_line_comment] = STATE(54),
    [aux_sym_macro_argument_list_repeat1] = STATE(255),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(329),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [55] = {
    [sym_open_tuple] = STATE(8518),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7985),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(8539),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(55),
    [sym_line_comment] = STATE(55),
    [aux_sym_macro_argument_list_repeat1] = STATE(233),
    [ts_builtin_sym_end] = ACTIONS(321),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(247),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(701),
    [sym__immediate_bracket] = ACTIONS(703),
    [sym__immediate_brace] = ACTIONS(705),
  },
  [56] = {
    [sym_open_tuple] = STATE(8518),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7985),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(7986),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(56),
    [sym_line_comment] = STATE(56),
    [aux_sym_macro_argument_list_repeat1] = STATE(233),
    [ts_builtin_sym_end] = ACTIONS(331),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(329),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(707),
    [sym__immediate_bracket] = ACTIONS(709),
    [sym__immediate_brace] = ACTIONS(711),
  },
  [57] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8090),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(57),
    [sym_line_comment] = STATE(57),
    [aux_sym_macro_argument_list_repeat1] = STATE(228),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1037),
    [sym__immediate_bracket] = ACTIONS(1039),
    [sym__immediate_brace] = ACTIONS(1041),
  },
  [58] = {
    [sym__block] = STATE(19117),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(58),
    [sym_line_comment] = STATE(58),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1045),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1047),
    [aux_sym__terminator_token2] = ACTIONS(1049),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [59] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(59),
    [sym_line_comment] = STATE(59),
    [aux_sym_macro_argument_list_repeat1] = STATE(283),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [60] = {
    [sym__block] = STATE(14379),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19127),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(60),
    [sym_line_comment] = STATE(60),
    [aux_sym_if_statement_repeat1] = STATE(14398),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1067),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1143),
    [aux_sym__terminator_token2] = ACTIONS(1145),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [61] = {
    [sym_open_tuple] = STATE(8761),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(61),
    [sym_line_comment] = STATE(61),
    [aux_sym_macro_argument_list_repeat1] = STATE(295),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [62] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(62),
    [sym_line_comment] = STATE(62),
    [aux_sym_macro_argument_list_repeat1] = STATE(292),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [63] = {
    [sym_open_tuple] = STATE(8761),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(63),
    [sym_line_comment] = STATE(63),
    [aux_sym_macro_argument_list_repeat1] = STATE(295),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [64] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8090),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(64),
    [sym_line_comment] = STATE(64),
    [aux_sym_macro_argument_list_repeat1] = STATE(304),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1037),
    [sym__immediate_bracket] = ACTIONS(1039),
    [sym__immediate_brace] = ACTIONS(1041),
  },
  [65] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8179),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(65),
    [sym_line_comment] = STATE(65),
    [aux_sym_macro_argument_list_repeat1] = STATE(304),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(907),
    [sym__immediate_bracket] = ACTIONS(909),
    [sym__immediate_brace] = ACTIONS(911),
  },
  [66] = {
    [sym__block] = STATE(14952),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19056),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(66),
    [sym_line_comment] = STATE(66),
    [aux_sym_if_statement_repeat1] = STATE(14953),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1163),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1165),
    [aux_sym__terminator_token2] = ACTIONS(1167),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [67] = {
    [sym__block] = STATE(14955),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19173),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(67),
    [sym_line_comment] = STATE(67),
    [aux_sym_if_statement_repeat1] = STATE(14956),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1169),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1171),
    [aux_sym__terminator_token2] = ACTIONS(1173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [68] = {
    [sym_open_tuple] = STATE(8761),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(8821),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(68),
    [sym_line_comment] = STATE(68),
    [aux_sym_macro_argument_list_repeat1] = STATE(278),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1017),
    [sym__immediate_bracket] = ACTIONS(1019),
    [sym__immediate_brace] = ACTIONS(1021),
  },
  [69] = {
    [sym_open_tuple] = STATE(8761),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_macro_argument_list] = STATE(8649),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(69),
    [sym_line_comment] = STATE(69),
    [aux_sym_macro_argument_list_repeat1] = STATE(278),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1023),
    [sym__immediate_bracket] = ACTIONS(1025),
    [sym__immediate_brace] = ACTIONS(1027),
  },
  [70] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8090),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(70),
    [sym_line_comment] = STATE(70),
    [aux_sym_macro_argument_list_repeat1] = STATE(294),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1037),
    [sym__immediate_bracket] = ACTIONS(1039),
    [sym__immediate_brace] = ACTIONS(1041),
  },
  [71] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8179),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(71),
    [sym_line_comment] = STATE(71),
    [aux_sym_macro_argument_list_repeat1] = STATE(294),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(331),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(907),
    [sym__immediate_bracket] = ACTIONS(909),
    [sym__immediate_brace] = ACTIONS(911),
  },
  [72] = {
    [sym__block] = STATE(18392),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(72),
    [sym_line_comment] = STATE(72),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1175),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1177),
    [aux_sym__terminator_token2] = ACTIONS(1179),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [73] = {
    [sym__block] = STATE(14452),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18888),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(73),
    [sym_line_comment] = STATE(73),
    [aux_sym_if_statement_repeat1] = STATE(14453),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1181),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1183),
    [aux_sym__terminator_token2] = ACTIONS(1185),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [74] = {
    [sym_open_tuple] = STATE(8518),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7985),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(11475),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(74),
    [sym_line_comment] = STATE(74),
    [aux_sym_macro_argument_list_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(331),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(329),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(329),
    [sym__lazy_and_operator] = ACTIONS(329),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(331),
    [aux_sym__terminator_token2] = ACTIONS(329),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(433),
    [sym__immediate_bracket] = ACTIONS(435),
    [sym__immediate_brace] = ACTIONS(437),
  },
  [75] = {
    [sym__block] = STATE(14532),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18581),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(75),
    [sym_line_comment] = STATE(75),
    [aux_sym_if_statement_repeat1] = STATE(14650),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1187),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1189),
    [aux_sym__terminator_token2] = ACTIONS(1191),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [76] = {
    [sym__block] = STATE(14683),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18595),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(76),
    [sym_line_comment] = STATE(76),
    [aux_sym_if_statement_repeat1] = STATE(14685),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1193),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1195),
    [aux_sym__terminator_token2] = ACTIONS(1197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [77] = {
    [sym__block] = STATE(14888),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19124),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(77),
    [sym_line_comment] = STATE(77),
    [aux_sym_if_statement_repeat1] = STATE(14894),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1199),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1201),
    [aux_sym__terminator_token2] = ACTIONS(1203),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [78] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(78),
    [sym_line_comment] = STATE(78),
    [aux_sym_macro_argument_list_repeat1] = STATE(272),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [79] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(79),
    [sym_line_comment] = STATE(79),
    [aux_sym_macro_argument_list_repeat1] = STATE(272),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [80] = {
    [sym__block] = STATE(15091),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19576),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(80),
    [sym_line_comment] = STATE(80),
    [aux_sym_if_statement_repeat1] = STATE(15092),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1205),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1207),
    [aux_sym__terminator_token2] = ACTIONS(1209),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [81] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(81),
    [sym_line_comment] = STATE(81),
    [aux_sym_macro_argument_list_repeat1] = STATE(307),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [82] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(82),
    [sym_line_comment] = STATE(82),
    [aux_sym_macro_argument_list_repeat1] = STATE(307),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [83] = {
    [sym__block] = STATE(15066),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19388),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(83),
    [sym_line_comment] = STATE(83),
    [aux_sym_if_statement_repeat1] = STATE(14437),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1211),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1213),
    [aux_sym__terminator_token2] = ACTIONS(1215),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [84] = {
    [sym__block] = STATE(14809),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18284),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(84),
    [sym_line_comment] = STATE(84),
    [aux_sym_if_statement_repeat1] = STATE(14815),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1217),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1219),
    [aux_sym__terminator_token2] = ACTIONS(1221),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [85] = {
    [sym_open_tuple] = STATE(8518),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7985),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_macro_argument_list] = STATE(11585),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(85),
    [sym_line_comment] = STATE(85),
    [aux_sym_macro_argument_list_repeat1] = STATE(285),
    [ts_builtin_sym_end] = ACTIONS(321),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(247),
    [anon_sym_QMARK] = ACTIONS(247),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(247),
    [sym__lazy_and_operator] = ACTIONS(247),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(321),
    [aux_sym__terminator_token2] = ACTIONS(247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(427),
    [sym__immediate_bracket] = ACTIONS(429),
    [sym__immediate_brace] = ACTIONS(431),
  },
  [86] = {
    [sym__block] = STATE(14924),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19584),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(86),
    [sym_line_comment] = STATE(86),
    [aux_sym_if_statement_repeat1] = STATE(14926),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1223),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1225),
    [aux_sym__terminator_token2] = ACTIONS(1227),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [87] = {
    [sym__block] = STATE(14335),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19232),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(87),
    [sym_line_comment] = STATE(87),
    [aux_sym_if_statement_repeat1] = STATE(14337),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1229),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(1231),
    [aux_sym__terminator_token2] = ACTIONS(1233),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [88] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(88),
    [sym_line_comment] = STATE(88),
    [aux_sym_macro_argument_list_repeat1] = STATE(308),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [89] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(89),
    [sym_line_comment] = STATE(89),
    [aux_sym_macro_argument_list_repeat1] = STATE(308),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [90] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(90),
    [sym_line_comment] = STATE(90),
    [aux_sym_macro_argument_list_repeat1] = STATE(292),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(321),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [91] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(91),
    [sym_line_comment] = STATE(91),
    [aux_sym_macro_argument_list_repeat1] = STATE(283),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [92] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(92),
    [sym_line_comment] = STATE(92),
    [aux_sym_macro_argument_list_repeat1] = STATE(347),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [93] = {
    [sym__block] = STATE(19178),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(93),
    [sym_line_comment] = STATE(93),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1043),
    [anon_sym_finally] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1237),
    [aux_sym__terminator_token2] = ACTIONS(1239),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [94] = {
    [sym_open_tuple] = STATE(9251),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(9178),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(94),
    [sym_line_comment] = STATE(94),
    [aux_sym_macro_argument_list_repeat1] = STATE(356),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1323),
    [sym__immediate_bracket] = ACTIONS(1325),
    [sym__immediate_brace] = ACTIONS(1327),
  },
  [95] = {
    [sym_open_tuple] = STATE(9251),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(9226),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(95),
    [sym_line_comment] = STATE(95),
    [aux_sym_macro_argument_list_repeat1] = STATE(356),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1329),
    [sym__immediate_bracket] = ACTIONS(1331),
    [sym__immediate_brace] = ACTIONS(1333),
  },
  [96] = {
    [sym_open_tuple] = STATE(9251),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(96),
    [sym_line_comment] = STATE(96),
    [aux_sym_macro_argument_list_repeat1] = STATE(349),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [97] = {
    [sym_open_tuple] = STATE(9251),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(97),
    [sym_line_comment] = STATE(97),
    [aux_sym_macro_argument_list_repeat1] = STATE(349),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [98] = {
    [sym__block] = STATE(19205),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(98),
    [sym_line_comment] = STATE(98),
    [ts_builtin_sym_end] = ACTIONS(1335),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1337),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(1043),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1339),
    [aux_sym__terminator_token2] = ACTIONS(1341),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [99] = {
    [sym__block] = STATE(18392),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(99),
    [sym_line_comment] = STATE(99),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1175),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_SEMI] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1177),
    [aux_sym__terminator_token2] = ACTIONS(1179),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [100] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(100),
    [sym_line_comment] = STATE(100),
    [aux_sym_macro_argument_list_repeat1] = STATE(362),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [101] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(101),
    [sym_line_comment] = STATE(101),
    [aux_sym_macro_argument_list_repeat1] = STATE(362),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [102] = {
    [sym__block] = STATE(19178),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(102),
    [sym_line_comment] = STATE(102),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1237),
    [aux_sym__terminator_token2] = ACTIONS(1239),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [103] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(103),
    [sym_line_comment] = STATE(103),
    [aux_sym_macro_argument_list_repeat1] = STATE(363),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [104] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(104),
    [sym_line_comment] = STATE(104),
    [aux_sym_macro_argument_list_repeat1] = STATE(363),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [105] = {
    [sym_open_tuple] = STATE(7321),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7074),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(105),
    [sym_line_comment] = STATE(105),
    [aux_sym_macro_argument_list_repeat1] = STATE(122),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_elseif] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [106] = {
    [sym_open_tuple] = STATE(7329),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7076),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(106),
    [sym_line_comment] = STATE(106),
    [aux_sym_macro_argument_list_repeat1] = STATE(106),
    [sym__word_identifier] = ACTIONS(1355),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1363),
    [anon_sym_baremodule] = ACTIONS(1363),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_primitive] = ACTIONS(1369),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1375),
    [anon_sym_function] = ACTIONS(1378),
    [anon_sym_macro] = ACTIONS(1381),
    [anon_sym_quote] = ACTIONS(1384),
    [anon_sym_let] = ACTIONS(1387),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(1393),
    [anon_sym_finally] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_while] = ACTIONS(1399),
    [sym_break_statement] = ACTIONS(1402),
    [sym_continue_statement] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(1405),
    [anon_sym_const] = ACTIONS(1408),
    [anon_sym_global] = ACTIONS(1411),
    [anon_sym_local] = ACTIONS(1414),
    [anon_sym_LPAREN] = ACTIONS(1417),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1423),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_using] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_DOLLAR] = ACTIONS(1438),
    [anon_sym_COLON2] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(1444),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1450),
    [anon_sym_false] = ACTIONS(1450),
    [aux_sym_integer_literal_token1] = ACTIONS(1453),
    [aux_sym_integer_literal_token2] = ACTIONS(1453),
    [aux_sym_integer_literal_token3] = ACTIONS(1453),
    [aux_sym_integer_literal_token4] = ACTIONS(1456),
    [aux_sym_float_literal_token1] = ACTIONS(1459),
    [aux_sym_float_literal_token3] = ACTIONS(1459),
    [aux_sym_float_literal_token4] = ACTIONS(1459),
    [sym_character_literal] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1477),
    [sym__arrow_operator] = ACTIONS(1477),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1477),
    [sym__pipe_right_operator] = ACTIONS(1477),
    [sym__pipe_left_operator] = ACTIONS(1477),
    [sym__ellipsis_operator] = ACTIONS(1477),
    [sym__plus_operator] = ACTIONS(1477),
    [sym__times_operator] = ACTIONS(1477),
    [sym__rational_operator] = ACTIONS(1477),
    [sym__bitshift_operator] = ACTIONS(1477),
    [sym__power_operator] = ACTIONS(1477),
    [sym__tilde_operator] = ACTIONS(1480),
    [sym__type_order_operator] = ACTIONS(1480),
    [sym__unary_operator] = ACTIONS(1480),
    [sym__unary_plus_operator] = ACTIONS(1480),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [107] = {
    [sym__block] = STATE(18826),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(107),
    [sym_line_comment] = STATE(107),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1485),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1043),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1487),
    [aux_sym__terminator_token2] = ACTIONS(1489),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [108] = {
    [sym__block] = STATE(18890),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(108),
    [sym_line_comment] = STATE(108),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1491),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1493),
    [aux_sym__terminator_token2] = ACTIONS(1495),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [109] = {
    [sym__block] = STATE(19398),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(109),
    [sym_line_comment] = STATE(109),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1497),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1043),
    [anon_sym_finally] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1499),
    [aux_sym__terminator_token2] = ACTIONS(1501),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [110] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(110),
    [sym_line_comment] = STATE(110),
    [aux_sym_macro_argument_list_repeat1] = STATE(311),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [111] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(111),
    [sym_line_comment] = STATE(111),
    [aux_sym_macro_argument_list_repeat1] = STATE(311),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [112] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(112),
    [sym_line_comment] = STATE(112),
    [aux_sym_macro_argument_list_repeat1] = STATE(364),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [113] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(113),
    [sym_line_comment] = STATE(113),
    [aux_sym_macro_argument_list_repeat1] = STATE(364),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(331),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [114] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8090),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(114),
    [sym_line_comment] = STATE(114),
    [aux_sym_macro_argument_list_repeat1] = STATE(319),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1037),
    [sym__immediate_bracket] = ACTIONS(1039),
    [sym__immediate_brace] = ACTIONS(1041),
  },
  [115] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(115),
    [sym_line_comment] = STATE(115),
    [aux_sym_macro_argument_list_repeat1] = STATE(347),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [116] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(8179),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(116),
    [sym_line_comment] = STATE(116),
    [aux_sym_macro_argument_list_repeat1] = STATE(319),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_SEMI] = ACTIONS(331),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(907),
    [sym__immediate_bracket] = ACTIONS(909),
    [sym__immediate_brace] = ACTIONS(911),
  },
  [117] = {
    [sym_open_tuple] = STATE(7321),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7074),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(117),
    [sym_line_comment] = STATE(117),
    [aux_sym_macro_argument_list_repeat1] = STATE(122),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [118] = {
    [sym_open_tuple] = STATE(7329),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7076),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(118),
    [sym_line_comment] = STATE(118),
    [aux_sym_macro_argument_list_repeat1] = STATE(106),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [119] = {
    [sym_open_tuple] = STATE(7329),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7076),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(119),
    [sym_line_comment] = STATE(119),
    [aux_sym_macro_argument_list_repeat1] = STATE(106),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [120] = {
    [sym__block] = STATE(19109),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(120),
    [sym_line_comment] = STATE(120),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1503),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_else] = ACTIONS(1043),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1505),
    [aux_sym__terminator_token2] = ACTIONS(1507),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [121] = {
    [sym__block] = STATE(19117),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(121),
    [sym_line_comment] = STATE(121),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1045),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_SEMI] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1047),
    [aux_sym__terminator_token2] = ACTIONS(1049),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [122] = {
    [sym_open_tuple] = STATE(7321),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7074),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(122),
    [sym_line_comment] = STATE(122),
    [aux_sym_macro_argument_list_repeat1] = STATE(122),
    [sym__word_identifier] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1512),
    [anon_sym_module] = ACTIONS(1515),
    [anon_sym_baremodule] = ACTIONS(1515),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(1518),
    [anon_sym_primitive] = ACTIONS(1521),
    [anon_sym_mutable] = ACTIONS(1524),
    [anon_sym_struct] = ACTIONS(1527),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_macro] = ACTIONS(1533),
    [anon_sym_quote] = ACTIONS(1536),
    [anon_sym_let] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1542),
    [anon_sym_elseif] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_while] = ACTIONS(1551),
    [sym_break_statement] = ACTIONS(1554),
    [sym_continue_statement] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(1557),
    [anon_sym_const] = ACTIONS(1560),
    [anon_sym_global] = ACTIONS(1563),
    [anon_sym_local] = ACTIONS(1566),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1572),
    [anon_sym_public] = ACTIONS(1575),
    [anon_sym_import] = ACTIONS(1578),
    [anon_sym_using] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_COLON2] = ACTIONS(1593),
    [anon_sym_COLON_COLON] = ACTIONS(1596),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1599),
    [anon_sym_true] = ACTIONS(1602),
    [anon_sym_false] = ACTIONS(1602),
    [aux_sym_integer_literal_token1] = ACTIONS(1605),
    [aux_sym_integer_literal_token2] = ACTIONS(1605),
    [aux_sym_integer_literal_token3] = ACTIONS(1605),
    [aux_sym_integer_literal_token4] = ACTIONS(1608),
    [aux_sym_float_literal_token1] = ACTIONS(1611),
    [aux_sym_float_literal_token3] = ACTIONS(1611),
    [aux_sym_float_literal_token4] = ACTIONS(1611),
    [sym_character_literal] = ACTIONS(1614),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1617),
    [sym__arrow_operator] = ACTIONS(1617),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1617),
    [sym__pipe_right_operator] = ACTIONS(1617),
    [sym__pipe_left_operator] = ACTIONS(1617),
    [sym__ellipsis_operator] = ACTIONS(1617),
    [sym__plus_operator] = ACTIONS(1617),
    [sym__times_operator] = ACTIONS(1617),
    [sym__rational_operator] = ACTIONS(1617),
    [sym__bitshift_operator] = ACTIONS(1617),
    [sym__power_operator] = ACTIONS(1617),
    [sym__tilde_operator] = ACTIONS(1620),
    [sym__type_order_operator] = ACTIONS(1620),
    [sym__unary_operator] = ACTIONS(1620),
    [sym__unary_plus_operator] = ACTIONS(1620),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [123] = {
    [sym_open_tuple] = STATE(8432),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(123),
    [sym_line_comment] = STATE(123),
    [aux_sym_macro_argument_list_repeat1] = STATE(133),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [124] = {
    [sym_open_tuple] = STATE(8420),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(124),
    [sym_line_comment] = STATE(124),
    [aux_sym_macro_argument_list_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(1483),
    [sym__word_identifier] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1626),
    [anon_sym_module] = ACTIONS(1629),
    [anon_sym_baremodule] = ACTIONS(1629),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_primitive] = ACTIONS(1635),
    [anon_sym_mutable] = ACTIONS(1638),
    [anon_sym_struct] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(1644),
    [anon_sym_macro] = ACTIONS(1647),
    [anon_sym_quote] = ACTIONS(1650),
    [anon_sym_let] = ACTIONS(1653),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_try] = ACTIONS(1659),
    [anon_sym_for] = ACTIONS(1662),
    [anon_sym_while] = ACTIONS(1665),
    [sym_break_statement] = ACTIONS(1668),
    [sym_continue_statement] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(1671),
    [anon_sym_const] = ACTIONS(1674),
    [anon_sym_global] = ACTIONS(1677),
    [anon_sym_local] = ACTIONS(1680),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1686),
    [anon_sym_public] = ACTIONS(1689),
    [anon_sym_import] = ACTIONS(1692),
    [anon_sym_using] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1713),
    [anon_sym_true] = ACTIONS(1716),
    [anon_sym_false] = ACTIONS(1716),
    [aux_sym_integer_literal_token1] = ACTIONS(1719),
    [aux_sym_integer_literal_token2] = ACTIONS(1719),
    [aux_sym_integer_literal_token3] = ACTIONS(1719),
    [aux_sym_integer_literal_token4] = ACTIONS(1722),
    [aux_sym_float_literal_token1] = ACTIONS(1725),
    [aux_sym_float_literal_token3] = ACTIONS(1725),
    [aux_sym_float_literal_token4] = ACTIONS(1725),
    [sym_character_literal] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1731),
    [sym__arrow_operator] = ACTIONS(1731),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1731),
    [sym__pipe_right_operator] = ACTIONS(1731),
    [sym__pipe_left_operator] = ACTIONS(1731),
    [sym__ellipsis_operator] = ACTIONS(1731),
    [sym__plus_operator] = ACTIONS(1731),
    [sym__times_operator] = ACTIONS(1731),
    [sym__rational_operator] = ACTIONS(1731),
    [sym__bitshift_operator] = ACTIONS(1731),
    [sym__power_operator] = ACTIONS(1731),
    [sym__tilde_operator] = ACTIONS(1734),
    [sym__type_order_operator] = ACTIONS(1734),
    [sym__unary_operator] = ACTIONS(1734),
    [sym__unary_plus_operator] = ACTIONS(1734),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [125] = {
    [sym__closed_assignment] = STATE(14700),
    [sym__expression] = STATE(11765),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17956),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19044),
    [sym__syntactic_operator] = STATE(19044),
    [sym_block_comment] = STATE(125),
    [sym_line_comment] = STATE(125),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(1739),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(1801),
    [anon_sym_COLON_EQ] = ACTIONS(1803),
    [anon_sym_DOT_EQ] = ACTIONS(1805),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1827),
    [sym__lazy_and_operator] = ACTIONS(1827),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [126] = {
    [sym_open_tuple] = STATE(7306),
    [sym_assignment] = STATE(7261),
    [sym__expression] = STATE(7071),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(126),
    [sym_line_comment] = STATE(126),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(1835),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [127] = {
    [sym_open_tuple] = STATE(8425),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(7627),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(127),
    [sym_line_comment] = STATE(127),
    [aux_sym_macro_argument_list_repeat1] = STATE(128),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [128] = {
    [sym_open_tuple] = STATE(8425),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(7627),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(128),
    [sym_line_comment] = STATE(128),
    [aux_sym_macro_argument_list_repeat1] = STATE(128),
    [sym__word_identifier] = ACTIONS(1839),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1842),
    [anon_sym_module] = ACTIONS(1845),
    [anon_sym_baremodule] = ACTIONS(1845),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_primitive] = ACTIONS(1851),
    [anon_sym_mutable] = ACTIONS(1854),
    [anon_sym_struct] = ACTIONS(1857),
    [anon_sym_function] = ACTIONS(1860),
    [anon_sym_macro] = ACTIONS(1863),
    [anon_sym_quote] = ACTIONS(1866),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_if] = ACTIONS(1872),
    [anon_sym_try] = ACTIONS(1875),
    [anon_sym_catch] = ACTIONS(1358),
    [anon_sym_finally] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1878),
    [anon_sym_while] = ACTIONS(1881),
    [sym_break_statement] = ACTIONS(1884),
    [sym_continue_statement] = ACTIONS(1884),
    [anon_sym_return] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1890),
    [anon_sym_global] = ACTIONS(1893),
    [anon_sym_local] = ACTIONS(1896),
    [anon_sym_LPAREN] = ACTIONS(1899),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1902),
    [anon_sym_public] = ACTIONS(1905),
    [anon_sym_import] = ACTIONS(1908),
    [anon_sym_using] = ACTIONS(1911),
    [anon_sym_LBRACK] = ACTIONS(1914),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1917),
    [anon_sym_DOLLAR] = ACTIONS(1920),
    [anon_sym_COLON2] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1929),
    [anon_sym_true] = ACTIONS(1932),
    [anon_sym_false] = ACTIONS(1932),
    [aux_sym_integer_literal_token1] = ACTIONS(1935),
    [aux_sym_integer_literal_token2] = ACTIONS(1935),
    [aux_sym_integer_literal_token3] = ACTIONS(1935),
    [aux_sym_integer_literal_token4] = ACTIONS(1938),
    [aux_sym_float_literal_token1] = ACTIONS(1941),
    [aux_sym_float_literal_token3] = ACTIONS(1941),
    [aux_sym_float_literal_token4] = ACTIONS(1941),
    [sym_character_literal] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1947),
    [sym__arrow_operator] = ACTIONS(1947),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1947),
    [sym__pipe_right_operator] = ACTIONS(1947),
    [sym__pipe_left_operator] = ACTIONS(1947),
    [sym__ellipsis_operator] = ACTIONS(1947),
    [sym__plus_operator] = ACTIONS(1947),
    [sym__times_operator] = ACTIONS(1947),
    [sym__rational_operator] = ACTIONS(1947),
    [sym__bitshift_operator] = ACTIONS(1947),
    [sym__power_operator] = ACTIONS(1947),
    [sym__tilde_operator] = ACTIONS(1950),
    [sym__type_order_operator] = ACTIONS(1950),
    [sym__unary_operator] = ACTIONS(1950),
    [sym__unary_plus_operator] = ACTIONS(1950),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [129] = {
    [sym__closed_assignment] = STATE(15019),
    [sym__expression] = STATE(11956),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17754),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18485),
    [sym__syntactic_operator] = STATE(18485),
    [sym_block_comment] = STATE(129),
    [sym_line_comment] = STATE(129),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(1959),
    [anon_sym_COLON_EQ] = ACTIONS(1961),
    [anon_sym_DOT_EQ] = ACTIONS(1963),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1965),
    [sym__lazy_and_operator] = ACTIONS(1965),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [130] = {
    [sym_open_tuple] = STATE(8420),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(130),
    [sym_line_comment] = STATE(130),
    [aux_sym_macro_argument_list_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [131] = {
    [sym_open_tuple] = STATE(8430),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(7633),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(131),
    [sym_line_comment] = STATE(131),
    [aux_sym_macro_argument_list_repeat1] = STATE(131),
    [sym__word_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1970),
    [anon_sym_module] = ACTIONS(1973),
    [anon_sym_baremodule] = ACTIONS(1973),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(1976),
    [anon_sym_primitive] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1982),
    [anon_sym_struct] = ACTIONS(1985),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_macro] = ACTIONS(1991),
    [anon_sym_quote] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2003),
    [anon_sym_catch] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(2006),
    [anon_sym_while] = ACTIONS(2009),
    [sym_break_statement] = ACTIONS(2012),
    [sym_continue_statement] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(2015),
    [anon_sym_const] = ACTIONS(2018),
    [anon_sym_global] = ACTIONS(2021),
    [anon_sym_local] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2033),
    [anon_sym_import] = ACTIONS(2036),
    [anon_sym_using] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_DOLLAR] = ACTIONS(2048),
    [anon_sym_COLON2] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_true] = ACTIONS(2060),
    [anon_sym_false] = ACTIONS(2060),
    [aux_sym_integer_literal_token1] = ACTIONS(2063),
    [aux_sym_integer_literal_token2] = ACTIONS(2063),
    [aux_sym_integer_literal_token3] = ACTIONS(2063),
    [aux_sym_integer_literal_token4] = ACTIONS(2066),
    [aux_sym_float_literal_token1] = ACTIONS(2069),
    [aux_sym_float_literal_token3] = ACTIONS(2069),
    [aux_sym_float_literal_token4] = ACTIONS(2069),
    [sym_character_literal] = ACTIONS(2072),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(2075),
    [sym__arrow_operator] = ACTIONS(2075),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(2075),
    [sym__pipe_right_operator] = ACTIONS(2075),
    [sym__pipe_left_operator] = ACTIONS(2075),
    [sym__ellipsis_operator] = ACTIONS(2075),
    [sym__plus_operator] = ACTIONS(2075),
    [sym__times_operator] = ACTIONS(2075),
    [sym__rational_operator] = ACTIONS(2075),
    [sym__bitshift_operator] = ACTIONS(2075),
    [sym__power_operator] = ACTIONS(2075),
    [sym__tilde_operator] = ACTIONS(2078),
    [sym__type_order_operator] = ACTIONS(2078),
    [sym__unary_operator] = ACTIONS(2078),
    [sym__unary_plus_operator] = ACTIONS(2078),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [132] = {
    [sym__closed_assignment] = STATE(14455),
    [sym__expression] = STATE(11885),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18053),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18722),
    [sym__syntactic_operator] = STATE(18722),
    [sym_block_comment] = STATE(132),
    [sym_line_comment] = STATE(132),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2081),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2087),
    [anon_sym_COLON_EQ] = ACTIONS(2089),
    [anon_sym_DOT_EQ] = ACTIONS(2091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2093),
    [sym__lazy_and_operator] = ACTIONS(2093),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [133] = {
    [sym_open_tuple] = STATE(8432),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(133),
    [sym_line_comment] = STATE(133),
    [aux_sym_macro_argument_list_repeat1] = STATE(133),
    [sym__word_identifier] = ACTIONS(2095),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_baremodule] = ACTIONS(2101),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(2104),
    [anon_sym_primitive] = ACTIONS(2107),
    [anon_sym_mutable] = ACTIONS(2110),
    [anon_sym_struct] = ACTIONS(2113),
    [anon_sym_function] = ACTIONS(2116),
    [anon_sym_macro] = ACTIONS(2119),
    [anon_sym_quote] = ACTIONS(2122),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2131),
    [anon_sym_finally] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(2134),
    [anon_sym_while] = ACTIONS(2137),
    [sym_break_statement] = ACTIONS(2140),
    [sym_continue_statement] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(2143),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_global] = ACTIONS(2149),
    [anon_sym_local] = ACTIONS(2152),
    [anon_sym_LPAREN] = ACTIONS(2155),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(2158),
    [anon_sym_public] = ACTIONS(2161),
    [anon_sym_import] = ACTIONS(2164),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_DOLLAR] = ACTIONS(2176),
    [anon_sym_COLON2] = ACTIONS(2179),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(2185),
    [anon_sym_true] = ACTIONS(2188),
    [anon_sym_false] = ACTIONS(2188),
    [aux_sym_integer_literal_token1] = ACTIONS(2191),
    [aux_sym_integer_literal_token2] = ACTIONS(2191),
    [aux_sym_integer_literal_token3] = ACTIONS(2191),
    [aux_sym_integer_literal_token4] = ACTIONS(2194),
    [aux_sym_float_literal_token1] = ACTIONS(2197),
    [aux_sym_float_literal_token3] = ACTIONS(2197),
    [aux_sym_float_literal_token4] = ACTIONS(2197),
    [sym_character_literal] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(2203),
    [sym__arrow_operator] = ACTIONS(2203),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(2203),
    [sym__pipe_right_operator] = ACTIONS(2203),
    [sym__pipe_left_operator] = ACTIONS(2203),
    [sym__ellipsis_operator] = ACTIONS(2203),
    [sym__plus_operator] = ACTIONS(2203),
    [sym__times_operator] = ACTIONS(2203),
    [sym__rational_operator] = ACTIONS(2203),
    [sym__bitshift_operator] = ACTIONS(2203),
    [sym__power_operator] = ACTIONS(2203),
    [sym__tilde_operator] = ACTIONS(2206),
    [sym__type_order_operator] = ACTIONS(2206),
    [sym__unary_operator] = ACTIONS(2206),
    [sym__unary_plus_operator] = ACTIONS(2206),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [134] = {
    [sym_open_tuple] = STATE(12273),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(11754),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10207),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11929),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(134),
    [sym_line_comment] = STATE(134),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1835),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(2219),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(2219),
    [sym__pipe_left_operator] = ACTIONS(2219),
    [sym__ellipsis_operator] = ACTIONS(2219),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(2219),
    [sym__bitshift_operator] = ACTIONS(2219),
    [sym__power_operator] = ACTIONS(2219),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1137),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [135] = {
    [sym_open_tuple] = STATE(9298),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(9178),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(135),
    [sym_line_comment] = STATE(135),
    [aux_sym_macro_argument_list_repeat1] = STATE(383),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1323),
    [sym__immediate_bracket] = ACTIONS(1325),
    [sym__immediate_brace] = ACTIONS(1327),
  },
  [136] = {
    [sym_open_tuple] = STATE(9298),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(9226),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(136),
    [sym_line_comment] = STATE(136),
    [aux_sym_macro_argument_list_repeat1] = STATE(383),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1329),
    [sym__immediate_bracket] = ACTIONS(1331),
    [sym__immediate_brace] = ACTIONS(1333),
  },
  [137] = {
    [sym_open_tuple] = STATE(12336),
    [sym_assignment] = STATE(12267),
    [sym__expression] = STATE(11901),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10169),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12036),
    [sym_unary_expression] = STATE(12036),
    [sym_range_expression] = STATE(12036),
    [sym_splat_expression] = STATE(12036),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11968),
    [sym_unary_typed_expression] = STATE(12036),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12036),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11979),
    [sym_block_comment] = STATE(137),
    [sym_line_comment] = STATE(137),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(169),
    [aux_sym_integer_literal_token2] = ACTIONS(169),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(173),
    [aux_sym_float_literal_token3] = ACTIONS(173),
    [aux_sym_float_literal_token4] = ACTIONS(173),
    [sym_character_literal] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(181),
    [sym__type_order_operator] = ACTIONS(181),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [138] = {
    [sym_open_tuple] = STATE(8430),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(7633),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(138),
    [sym_line_comment] = STATE(138),
    [aux_sym_macro_argument_list_repeat1] = STATE(131),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [139] = {
    [sym_open_tuple] = STATE(8425),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(7627),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(139),
    [sym_line_comment] = STATE(139),
    [aux_sym_macro_argument_list_repeat1] = STATE(128),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [140] = {
    [sym_open_tuple] = STATE(7348),
    [sym_assignment] = STATE(7311),
    [sym__expression] = STATE(7077),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(140),
    [sym_line_comment] = STATE(140),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [141] = {
    [sym_open_tuple] = STATE(8430),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(7633),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(141),
    [sym_line_comment] = STATE(141),
    [aux_sym_macro_argument_list_repeat1] = STATE(131),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [142] = {
    [sym_open_tuple] = STATE(8432),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(7637),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(142),
    [sym_line_comment] = STATE(142),
    [aux_sym_macro_argument_list_repeat1] = STATE(133),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [143] = {
    [sym_open_tuple] = STATE(7787),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(143),
    [sym_line_comment] = STATE(143),
    [aux_sym_macro_argument_list_repeat1] = STATE(145),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_elseif] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [144] = {
    [sym__closed_assignment] = STATE(14927),
    [sym__expression] = STATE(11913),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17983),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18376),
    [sym__syntactic_operator] = STATE(18376),
    [sym_block_comment] = STATE(144),
    [sym_line_comment] = STATE(144),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2237),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2239),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2243),
    [anon_sym_COLON_EQ] = ACTIONS(2245),
    [anon_sym_DOT_EQ] = ACTIONS(2247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2249),
    [sym__lazy_and_operator] = ACTIONS(2249),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [145] = {
    [sym_open_tuple] = STATE(7787),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(145),
    [sym_line_comment] = STATE(145),
    [aux_sym_macro_argument_list_repeat1] = STATE(145),
    [sym__word_identifier] = ACTIONS(1509),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1512),
    [anon_sym_module] = ACTIONS(1515),
    [anon_sym_baremodule] = ACTIONS(1515),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(1518),
    [anon_sym_primitive] = ACTIONS(1521),
    [anon_sym_mutable] = ACTIONS(1524),
    [anon_sym_struct] = ACTIONS(1527),
    [anon_sym_function] = ACTIONS(1530),
    [anon_sym_macro] = ACTIONS(1533),
    [anon_sym_quote] = ACTIONS(1536),
    [anon_sym_let] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1542),
    [anon_sym_elseif] = ACTIONS(1358),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(1545),
    [anon_sym_for] = ACTIONS(1548),
    [anon_sym_while] = ACTIONS(1551),
    [sym_break_statement] = ACTIONS(1554),
    [sym_continue_statement] = ACTIONS(1554),
    [anon_sym_return] = ACTIONS(2251),
    [anon_sym_const] = ACTIONS(2254),
    [anon_sym_global] = ACTIONS(2257),
    [anon_sym_local] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1572),
    [anon_sym_public] = ACTIONS(1575),
    [anon_sym_import] = ACTIONS(1578),
    [anon_sym_using] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(1584),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1587),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_COLON2] = ACTIONS(1593),
    [anon_sym_COLON_COLON] = ACTIONS(1596),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1599),
    [anon_sym_true] = ACTIONS(1602),
    [anon_sym_false] = ACTIONS(1602),
    [aux_sym_integer_literal_token1] = ACTIONS(1605),
    [aux_sym_integer_literal_token2] = ACTIONS(1605),
    [aux_sym_integer_literal_token3] = ACTIONS(1605),
    [aux_sym_integer_literal_token4] = ACTIONS(1608),
    [aux_sym_float_literal_token1] = ACTIONS(1611),
    [aux_sym_float_literal_token3] = ACTIONS(1611),
    [aux_sym_float_literal_token4] = ACTIONS(1611),
    [sym_character_literal] = ACTIONS(1614),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1617),
    [sym__arrow_operator] = ACTIONS(1617),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1617),
    [sym__pipe_right_operator] = ACTIONS(1617),
    [sym__pipe_left_operator] = ACTIONS(1617),
    [sym__ellipsis_operator] = ACTIONS(1617),
    [sym__plus_operator] = ACTIONS(1617),
    [sym__times_operator] = ACTIONS(1617),
    [sym__rational_operator] = ACTIONS(1617),
    [sym__bitshift_operator] = ACTIONS(1617),
    [sym__power_operator] = ACTIONS(1617),
    [sym__tilde_operator] = ACTIONS(1620),
    [sym__type_order_operator] = ACTIONS(1620),
    [sym__unary_operator] = ACTIONS(1620),
    [sym__unary_plus_operator] = ACTIONS(1620),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [146] = {
    [sym__block] = STATE(19178),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(146),
    [sym_line_comment] = STATE(146),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1237),
    [aux_sym__terminator_token2] = ACTIONS(1239),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [147] = {
    [sym__closed_assignment] = STATE(14440),
    [sym__expression] = STATE(11864),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18119),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19407),
    [sym__syntactic_operator] = STATE(19407),
    [sym_block_comment] = STATE(147),
    [sym_line_comment] = STATE(147),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2263),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2269),
    [anon_sym_COLON_EQ] = ACTIONS(2271),
    [anon_sym_DOT_EQ] = ACTIONS(2273),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2275),
    [sym__lazy_and_operator] = ACTIONS(2275),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [148] = {
    [sym_open_tuple] = STATE(7463),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7489),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(148),
    [sym_line_comment] = STATE(148),
    [aux_sym_macro_argument_list_repeat1] = STATE(148),
    [sym__word_identifier] = ACTIONS(1355),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1360),
    [anon_sym_module] = ACTIONS(1363),
    [anon_sym_baremodule] = ACTIONS(1363),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(1366),
    [anon_sym_primitive] = ACTIONS(1369),
    [anon_sym_mutable] = ACTIONS(1372),
    [anon_sym_struct] = ACTIONS(1375),
    [anon_sym_function] = ACTIONS(1378),
    [anon_sym_macro] = ACTIONS(1381),
    [anon_sym_quote] = ACTIONS(1384),
    [anon_sym_let] = ACTIONS(1387),
    [anon_sym_if] = ACTIONS(1390),
    [anon_sym_else] = ACTIONS(1358),
    [anon_sym_try] = ACTIONS(1393),
    [anon_sym_finally] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1396),
    [anon_sym_while] = ACTIONS(1399),
    [sym_break_statement] = ACTIONS(1402),
    [sym_continue_statement] = ACTIONS(1402),
    [anon_sym_return] = ACTIONS(2277),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_global] = ACTIONS(2283),
    [anon_sym_local] = ACTIONS(2286),
    [anon_sym_LPAREN] = ACTIONS(1417),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1420),
    [anon_sym_public] = ACTIONS(1423),
    [anon_sym_import] = ACTIONS(1426),
    [anon_sym_using] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1432),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1435),
    [anon_sym_DOLLAR] = ACTIONS(1438),
    [anon_sym_COLON2] = ACTIONS(1441),
    [anon_sym_COLON_COLON] = ACTIONS(1444),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1450),
    [anon_sym_false] = ACTIONS(1450),
    [aux_sym_integer_literal_token1] = ACTIONS(1453),
    [aux_sym_integer_literal_token2] = ACTIONS(1453),
    [aux_sym_integer_literal_token3] = ACTIONS(1453),
    [aux_sym_integer_literal_token4] = ACTIONS(1456),
    [aux_sym_float_literal_token1] = ACTIONS(1459),
    [aux_sym_float_literal_token3] = ACTIONS(1459),
    [aux_sym_float_literal_token4] = ACTIONS(1459),
    [sym_character_literal] = ACTIONS(1462),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1477),
    [sym__arrow_operator] = ACTIONS(1477),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1477),
    [sym__pipe_right_operator] = ACTIONS(1477),
    [sym__pipe_left_operator] = ACTIONS(1477),
    [sym__ellipsis_operator] = ACTIONS(1477),
    [sym__plus_operator] = ACTIONS(1477),
    [sym__times_operator] = ACTIONS(1477),
    [sym__rational_operator] = ACTIONS(1477),
    [sym__bitshift_operator] = ACTIONS(1477),
    [sym__power_operator] = ACTIONS(1477),
    [sym__tilde_operator] = ACTIONS(1480),
    [sym__type_order_operator] = ACTIONS(1480),
    [sym__unary_operator] = ACTIONS(1480),
    [sym__unary_plus_operator] = ACTIONS(1480),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [149] = {
    [sym__closed_assignment] = STATE(14567),
    [sym__expression] = STATE(11946),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18032),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19099),
    [sym__syntactic_operator] = STATE(19099),
    [sym_block_comment] = STATE(149),
    [sym_line_comment] = STATE(149),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2289),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2291),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2295),
    [anon_sym_COLON_EQ] = ACTIONS(2297),
    [anon_sym_DOT_EQ] = ACTIONS(2299),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2301),
    [sym__lazy_and_operator] = ACTIONS(2301),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [150] = {
    [sym__block] = STATE(19493),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(150),
    [sym_line_comment] = STATE(150),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2303),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(2305),
    [aux_sym__terminator_token2] = ACTIONS(2307),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [151] = {
    [sym_open_tuple] = STATE(9298),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(151),
    [sym_line_comment] = STATE(151),
    [aux_sym_macro_argument_list_repeat1] = STATE(379),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(247),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [152] = {
    [sym_open_tuple] = STATE(7787),
    [sym_assignment] = STATE(7788),
    [sym__expression] = STATE(7794),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(152),
    [sym_line_comment] = STATE(152),
    [aux_sym_macro_argument_list_repeat1] = STATE(145),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [153] = {
    [sym_open_tuple] = STATE(9298),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(153),
    [sym_line_comment] = STATE(153),
    [aux_sym_macro_argument_list_repeat1] = STATE(379),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(329),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [154] = {
    [sym__closed_assignment] = STATE(14462),
    [sym__expression] = STATE(11799),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18109),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19256),
    [sym__syntactic_operator] = STATE(19256),
    [sym_block_comment] = STATE(154),
    [sym_line_comment] = STATE(154),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2315),
    [anon_sym_COLON_EQ] = ACTIONS(2317),
    [anon_sym_DOT_EQ] = ACTIONS(2319),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2321),
    [sym__lazy_and_operator] = ACTIONS(2321),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [155] = {
    [sym__block] = STATE(19178),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(155),
    [sym_line_comment] = STATE(155),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1237),
    [aux_sym__terminator_token2] = ACTIONS(1239),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [156] = {
    [sym_open_tuple] = STATE(7463),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7489),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(156),
    [sym_line_comment] = STATE(156),
    [aux_sym_macro_argument_list_repeat1] = STATE(148),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [157] = {
    [sym__block] = STATE(18477),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(157),
    [sym_line_comment] = STATE(157),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(2323),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1043),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(2325),
    [aux_sym__terminator_token2] = ACTIONS(2327),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [158] = {
    [sym__closed_assignment] = STATE(14724),
    [sym__expression] = STATE(11911),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18131),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18521),
    [sym__syntactic_operator] = STATE(18521),
    [sym_block_comment] = STATE(158),
    [sym_line_comment] = STATE(158),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2329),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2331),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2335),
    [anon_sym_COLON_EQ] = ACTIONS(2337),
    [anon_sym_DOT_EQ] = ACTIONS(2339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2341),
    [sym__lazy_and_operator] = ACTIONS(2341),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [159] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(159),
    [sym_line_comment] = STATE(159),
    [aux_sym_macro_argument_list_repeat1] = STATE(378),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [160] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(160),
    [sym_line_comment] = STATE(160),
    [aux_sym_macro_argument_list_repeat1] = STATE(378),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(331),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [161] = {
    [sym__closed_assignment] = STATE(14877),
    [sym__expression] = STATE(11949),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18143),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19316),
    [sym__syntactic_operator] = STATE(19316),
    [sym_block_comment] = STATE(161),
    [sym_line_comment] = STATE(161),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2349),
    [anon_sym_COLON_EQ] = ACTIONS(2351),
    [anon_sym_DOT_EQ] = ACTIONS(2353),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2355),
    [sym__lazy_and_operator] = ACTIONS(2355),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [162] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(162),
    [sym_line_comment] = STATE(162),
    [aux_sym_macro_argument_list_repeat1] = STATE(387),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [163] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(163),
    [sym_line_comment] = STATE(163),
    [aux_sym_macro_argument_list_repeat1] = STATE(387),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [164] = {
    [sym__closed_assignment] = STATE(14984),
    [sym__expression] = STATE(11815),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18158),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19023),
    [sym__syntactic_operator] = STATE(19023),
    [sym_block_comment] = STATE(164),
    [sym_line_comment] = STATE(164),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2357),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2359),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2363),
    [anon_sym_COLON_EQ] = ACTIONS(2365),
    [anon_sym_DOT_EQ] = ACTIONS(2367),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2369),
    [sym__lazy_and_operator] = ACTIONS(2369),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [165] = {
    [sym_open_tuple] = STATE(7463),
    [sym_assignment] = STATE(7464),
    [sym__expression] = STATE(7489),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(165),
    [sym_line_comment] = STATE(165),
    [aux_sym_macro_argument_list_repeat1] = STATE(148),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_else] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [166] = {
    [sym__closed_assignment] = STATE(14697),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18167),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18310),
    [sym__syntactic_operator] = STATE(18310),
    [sym_block_comment] = STATE(166),
    [sym_line_comment] = STATE(166),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2371),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2377),
    [anon_sym_COLON_EQ] = ACTIONS(2379),
    [anon_sym_DOT_EQ] = ACTIONS(2381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2383),
    [sym__lazy_and_operator] = ACTIONS(2383),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [167] = {
    [sym__closed_assignment] = STATE(14400),
    [sym__expression] = STATE(11791),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18174),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19102),
    [sym__syntactic_operator] = STATE(19102),
    [sym_block_comment] = STATE(167),
    [sym_line_comment] = STATE(167),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2385),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2389),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2391),
    [anon_sym_COLON_EQ] = ACTIONS(2393),
    [anon_sym_DOT_EQ] = ACTIONS(2395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2397),
    [sym__lazy_and_operator] = ACTIONS(2397),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [168] = {
    [sym__closed_assignment] = STATE(14310),
    [sym__expression] = STATE(11771),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18193),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18647),
    [sym__syntactic_operator] = STATE(18647),
    [sym_block_comment] = STATE(168),
    [sym_line_comment] = STATE(168),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2399),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2401),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2405),
    [anon_sym_COLON_EQ] = ACTIONS(2407),
    [anon_sym_DOT_EQ] = ACTIONS(2409),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2411),
    [sym__lazy_and_operator] = ACTIONS(2411),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [169] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(169),
    [sym_line_comment] = STATE(169),
    [aux_sym_macro_argument_list_repeat1] = STATE(375),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_EQ] = ACTIONS(247),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [170] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(170),
    [sym_line_comment] = STATE(170),
    [aux_sym_macro_argument_list_repeat1] = STATE(375),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [171] = {
    [sym__block] = STATE(19178),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(171),
    [sym_line_comment] = STATE(171),
    [ts_builtin_sym_end] = ACTIONS(1335),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1235),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1237),
    [aux_sym__terminator_token2] = ACTIONS(1239),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [172] = {
    [sym__closed_assignment] = STATE(14646),
    [sym__expression] = STATE(11835),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18211),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18289),
    [sym__syntactic_operator] = STATE(18289),
    [sym_block_comment] = STATE(172),
    [sym_line_comment] = STATE(172),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2413),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2415),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2417),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2419),
    [anon_sym_COLON_EQ] = ACTIONS(2421),
    [anon_sym_DOT_EQ] = ACTIONS(2423),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2425),
    [sym__lazy_and_operator] = ACTIONS(2425),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [173] = {
    [sym__closed_assignment] = STATE(14867),
    [sym__expression] = STATE(11948),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18216),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18509),
    [sym__syntactic_operator] = STATE(18509),
    [sym_block_comment] = STATE(173),
    [sym_line_comment] = STATE(173),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2427),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2429),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2433),
    [anon_sym_COLON_EQ] = ACTIONS(2435),
    [anon_sym_DOT_EQ] = ACTIONS(2437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2439),
    [sym__lazy_and_operator] = ACTIONS(2439),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [174] = {
    [sym__closed_assignment] = STATE(14958),
    [sym__expression] = STATE(11997),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18220),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18811),
    [sym__syntactic_operator] = STATE(18811),
    [sym_block_comment] = STATE(174),
    [sym_line_comment] = STATE(174),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2441),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2443),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2447),
    [anon_sym_COLON_EQ] = ACTIONS(2449),
    [anon_sym_DOT_EQ] = ACTIONS(2451),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2453),
    [sym__lazy_and_operator] = ACTIONS(2453),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [175] = {
    [sym__closed_assignment] = STATE(14526),
    [sym__expression] = STATE(11898),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17677),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19087),
    [sym__syntactic_operator] = STATE(19087),
    [sym_block_comment] = STATE(175),
    [sym_line_comment] = STATE(175),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2455),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2461),
    [anon_sym_COLON_EQ] = ACTIONS(2463),
    [anon_sym_DOT_EQ] = ACTIONS(2465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2467),
    [sym__lazy_and_operator] = ACTIONS(2467),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [176] = {
    [sym__closed_assignment] = STATE(14548),
    [sym__expression] = STATE(11748),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17679),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19387),
    [sym__syntactic_operator] = STATE(19387),
    [sym_block_comment] = STATE(176),
    [sym_line_comment] = STATE(176),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2469),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2471),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2475),
    [anon_sym_COLON_EQ] = ACTIONS(2477),
    [anon_sym_DOT_EQ] = ACTIONS(2479),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2481),
    [sym__lazy_and_operator] = ACTIONS(2481),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [177] = {
    [sym__closed_assignment] = STATE(14353),
    [sym__expression] = STATE(11930),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17683),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19580),
    [sym__syntactic_operator] = STATE(19580),
    [sym_block_comment] = STATE(177),
    [sym_line_comment] = STATE(177),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2483),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2489),
    [anon_sym_COLON_EQ] = ACTIONS(2491),
    [anon_sym_DOT_EQ] = ACTIONS(2493),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2495),
    [sym__lazy_and_operator] = ACTIONS(2495),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [178] = {
    [sym__closed_assignment] = STATE(14938),
    [sym__expression] = STATE(11776),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17684),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18614),
    [sym__syntactic_operator] = STATE(18614),
    [sym_block_comment] = STATE(178),
    [sym_line_comment] = STATE(178),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2497),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2499),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2503),
    [anon_sym_COLON_EQ] = ACTIONS(2505),
    [anon_sym_DOT_EQ] = ACTIONS(2507),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2509),
    [sym__lazy_and_operator] = ACTIONS(2509),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [179] = {
    [sym__closed_assignment] = STATE(14873),
    [sym__expression] = STATE(11843),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17687),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18840),
    [sym__syntactic_operator] = STATE(18840),
    [sym_block_comment] = STATE(179),
    [sym_line_comment] = STATE(179),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2511),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2517),
    [anon_sym_COLON_EQ] = ACTIONS(2519),
    [anon_sym_DOT_EQ] = ACTIONS(2521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2523),
    [sym__lazy_and_operator] = ACTIONS(2523),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [180] = {
    [sym__closed_assignment] = STATE(14314),
    [sym__expression] = STATE(11875),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17690),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19463),
    [sym__syntactic_operator] = STATE(19463),
    [sym_block_comment] = STATE(180),
    [sym_line_comment] = STATE(180),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2525),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2527),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2531),
    [anon_sym_COLON_EQ] = ACTIONS(2533),
    [anon_sym_DOT_EQ] = ACTIONS(2535),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2537),
    [sym__lazy_and_operator] = ACTIONS(2537),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [181] = {
    [sym__closed_assignment] = STATE(15038),
    [sym__expression] = STATE(11810),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18186),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19610),
    [sym__syntactic_operator] = STATE(19610),
    [sym_block_comment] = STATE(181),
    [sym_line_comment] = STATE(181),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2545),
    [anon_sym_COLON_EQ] = ACTIONS(2547),
    [anon_sym_DOT_EQ] = ACTIONS(2549),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2551),
    [sym__lazy_and_operator] = ACTIONS(2551),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [182] = {
    [sym__closed_assignment] = STATE(14807),
    [sym__expression] = STATE(11928),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17700),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18416),
    [sym__syntactic_operator] = STATE(18416),
    [sym_block_comment] = STATE(182),
    [sym_line_comment] = STATE(182),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2553),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2555),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2559),
    [anon_sym_COLON_EQ] = ACTIONS(2561),
    [anon_sym_DOT_EQ] = ACTIONS(2563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2565),
    [sym__lazy_and_operator] = ACTIONS(2565),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [183] = {
    [sym__closed_assignment] = STATE(14559),
    [sym__expression] = STATE(11751),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18202),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19554),
    [sym__syntactic_operator] = STATE(19554),
    [sym_block_comment] = STATE(183),
    [sym_line_comment] = STATE(183),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2567),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2569),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2573),
    [anon_sym_COLON_EQ] = ACTIONS(2575),
    [anon_sym_DOT_EQ] = ACTIONS(2577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2579),
    [sym__lazy_and_operator] = ACTIONS(2579),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [184] = {
    [sym__closed_assignment] = STATE(15033),
    [sym__expression] = STATE(11910),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17705),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18936),
    [sym__syntactic_operator] = STATE(18936),
    [sym_block_comment] = STATE(184),
    [sym_line_comment] = STATE(184),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2581),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2587),
    [anon_sym_COLON_EQ] = ACTIONS(2589),
    [anon_sym_DOT_EQ] = ACTIONS(2591),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2593),
    [sym__lazy_and_operator] = ACTIONS(2593),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [185] = {
    [sym__closed_assignment] = STATE(14789),
    [sym__expression] = STATE(11848),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17675),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19360),
    [sym__syntactic_operator] = STATE(19360),
    [sym_block_comment] = STATE(185),
    [sym_line_comment] = STATE(185),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2595),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2601),
    [anon_sym_COLON_EQ] = ACTIONS(2603),
    [anon_sym_DOT_EQ] = ACTIONS(2605),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2607),
    [sym__lazy_and_operator] = ACTIONS(2607),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [186] = {
    [sym__closed_assignment] = STATE(14492),
    [sym__expression] = STATE(11859),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17710),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18930),
    [sym__syntactic_operator] = STATE(18930),
    [sym_block_comment] = STATE(186),
    [sym_line_comment] = STATE(186),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2609),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2615),
    [anon_sym_COLON_EQ] = ACTIONS(2617),
    [anon_sym_DOT_EQ] = ACTIONS(2619),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2621),
    [sym__lazy_and_operator] = ACTIONS(2621),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [187] = {
    [sym__closed_assignment] = STATE(14731),
    [sym__expression] = STATE(11964),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17713),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19444),
    [sym__syntactic_operator] = STATE(19444),
    [sym_block_comment] = STATE(187),
    [sym_line_comment] = STATE(187),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2623),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2625),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2629),
    [anon_sym_COLON_EQ] = ACTIONS(2631),
    [anon_sym_DOT_EQ] = ACTIONS(2633),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2635),
    [sym__lazy_and_operator] = ACTIONS(2635),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [188] = {
    [sym__closed_assignment] = STATE(14332),
    [sym__expression] = STATE(11790),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17716),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19125),
    [sym__syntactic_operator] = STATE(19125),
    [sym_block_comment] = STATE(188),
    [sym_line_comment] = STATE(188),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2637),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2639),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2643),
    [anon_sym_COLON_EQ] = ACTIONS(2645),
    [anon_sym_DOT_EQ] = ACTIONS(2647),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2649),
    [sym__lazy_and_operator] = ACTIONS(2649),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [189] = {
    [sym__closed_assignment] = STATE(14372),
    [sym__expression] = STATE(11924),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17717),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19541),
    [sym__syntactic_operator] = STATE(19541),
    [sym_block_comment] = STATE(189),
    [sym_line_comment] = STATE(189),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2657),
    [anon_sym_COLON_EQ] = ACTIONS(2659),
    [anon_sym_DOT_EQ] = ACTIONS(2661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2663),
    [sym__lazy_and_operator] = ACTIONS(2663),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [190] = {
    [sym__closed_assignment] = STATE(14802),
    [sym__expression] = STATE(11813),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17724),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19337),
    [sym__syntactic_operator] = STATE(19337),
    [sym_block_comment] = STATE(190),
    [sym_line_comment] = STATE(190),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2665),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2671),
    [anon_sym_COLON_EQ] = ACTIONS(2673),
    [anon_sym_DOT_EQ] = ACTIONS(2675),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2677),
    [sym__lazy_and_operator] = ACTIONS(2677),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [191] = {
    [sym__closed_assignment] = STATE(14528),
    [sym__expression] = STATE(11801),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17693),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18629),
    [sym__syntactic_operator] = STATE(18629),
    [sym_block_comment] = STATE(191),
    [sym_line_comment] = STATE(191),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2679),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2685),
    [anon_sym_COLON_EQ] = ACTIONS(2687),
    [anon_sym_DOT_EQ] = ACTIONS(2689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2691),
    [sym__lazy_and_operator] = ACTIONS(2691),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [192] = {
    [sym__closed_assignment] = STATE(14717),
    [sym__expression] = STATE(11891),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17697),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19122),
    [sym__syntactic_operator] = STATE(19122),
    [sym_block_comment] = STATE(192),
    [sym_line_comment] = STATE(192),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2693),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2699),
    [anon_sym_COLON_EQ] = ACTIONS(2701),
    [anon_sym_DOT_EQ] = ACTIONS(2703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2705),
    [sym__lazy_and_operator] = ACTIONS(2705),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [193] = {
    [sym__closed_assignment] = STATE(14432),
    [sym__expression] = STATE(11950),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17742),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19057),
    [sym__syntactic_operator] = STATE(19057),
    [sym_block_comment] = STATE(193),
    [sym_line_comment] = STATE(193),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2707),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2709),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2713),
    [anon_sym_COLON_EQ] = ACTIONS(2715),
    [anon_sym_DOT_EQ] = ACTIONS(2717),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2719),
    [sym__lazy_and_operator] = ACTIONS(2719),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [194] = {
    [sym__closed_assignment] = STATE(14475),
    [sym__expression] = STATE(11957),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17726),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18255),
    [sym__syntactic_operator] = STATE(18255),
    [sym_block_comment] = STATE(194),
    [sym_line_comment] = STATE(194),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2721),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2723),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2727),
    [anon_sym_COLON_EQ] = ACTIONS(2729),
    [anon_sym_DOT_EQ] = ACTIONS(2731),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2733),
    [sym__lazy_and_operator] = ACTIONS(2733),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [195] = {
    [sym__closed_assignment] = STATE(14978),
    [sym__expression] = STATE(11778),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17704),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18444),
    [sym__syntactic_operator] = STATE(18444),
    [sym_block_comment] = STATE(195),
    [sym_line_comment] = STATE(195),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2735),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2741),
    [anon_sym_COLON_EQ] = ACTIONS(2743),
    [anon_sym_DOT_EQ] = ACTIONS(2745),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2747),
    [sym__lazy_and_operator] = ACTIONS(2747),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [196] = {
    [sym__closed_assignment] = STATE(15102),
    [sym__expression] = STATE(11787),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17985),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18653),
    [sym__syntactic_operator] = STATE(18653),
    [sym_block_comment] = STATE(196),
    [sym_line_comment] = STATE(196),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2749),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2751),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2755),
    [anon_sym_COLON_EQ] = ACTIONS(2757),
    [anon_sym_DOT_EQ] = ACTIONS(2759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2761),
    [sym__lazy_and_operator] = ACTIONS(2761),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [197] = {
    [sym__closed_assignment] = STATE(15065),
    [sym__expression] = STATE(11773),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17708),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18839),
    [sym__syntactic_operator] = STATE(18839),
    [sym_block_comment] = STATE(197),
    [sym_line_comment] = STATE(197),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2763),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2765),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2769),
    [anon_sym_COLON_EQ] = ACTIONS(2771),
    [anon_sym_DOT_EQ] = ACTIONS(2773),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2775),
    [sym__lazy_and_operator] = ACTIONS(2775),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [198] = {
    [sym__closed_assignment] = STATE(15050),
    [sym__expression] = STATE(11878),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17734),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18927),
    [sym__syntactic_operator] = STATE(18927),
    [sym_block_comment] = STATE(198),
    [sym_line_comment] = STATE(198),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2783),
    [anon_sym_COLON_EQ] = ACTIONS(2785),
    [anon_sym_DOT_EQ] = ACTIONS(2787),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2789),
    [sym__lazy_and_operator] = ACTIONS(2789),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [199] = {
    [sym__closed_assignment] = STATE(14352),
    [sym__expression] = STATE(11918),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17740),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19037),
    [sym__syntactic_operator] = STATE(19037),
    [sym_block_comment] = STATE(199),
    [sym_line_comment] = STATE(199),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2791),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2793),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2797),
    [anon_sym_COLON_EQ] = ACTIONS(2799),
    [anon_sym_DOT_EQ] = ACTIONS(2801),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2803),
    [sym__lazy_and_operator] = ACTIONS(2803),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [200] = {
    [sym__closed_assignment] = STATE(14399),
    [sym__expression] = STATE(11941),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17741),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19172),
    [sym__syntactic_operator] = STATE(19172),
    [sym_block_comment] = STATE(200),
    [sym_line_comment] = STATE(200),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2805),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2811),
    [anon_sym_COLON_EQ] = ACTIONS(2813),
    [anon_sym_DOT_EQ] = ACTIONS(2815),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2817),
    [sym__lazy_and_operator] = ACTIONS(2817),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [201] = {
    [sym__closed_assignment] = STATE(14702),
    [sym__expression] = STATE(11803),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17722),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19333),
    [sym__syntactic_operator] = STATE(19333),
    [sym_block_comment] = STATE(201),
    [sym_line_comment] = STATE(201),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2819),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2821),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2825),
    [anon_sym_COLON_EQ] = ACTIONS(2827),
    [anon_sym_DOT_EQ] = ACTIONS(2829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2831),
    [sym__lazy_and_operator] = ACTIONS(2831),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [202] = {
    [sym__closed_assignment] = STATE(14477),
    [sym__expression] = STATE(11907),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17692),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19448),
    [sym__syntactic_operator] = STATE(19448),
    [sym_block_comment] = STATE(202),
    [sym_line_comment] = STATE(202),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2839),
    [anon_sym_COLON_EQ] = ACTIONS(2841),
    [anon_sym_DOT_EQ] = ACTIONS(2843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2845),
    [sym__lazy_and_operator] = ACTIONS(2845),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [203] = {
    [sym__closed_assignment] = STATE(14648),
    [sym__expression] = STATE(11933),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17751),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19539),
    [sym__syntactic_operator] = STATE(19539),
    [sym_block_comment] = STATE(203),
    [sym_line_comment] = STATE(203),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2847),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2849),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2853),
    [anon_sym_COLON_EQ] = ACTIONS(2855),
    [anon_sym_DOT_EQ] = ACTIONS(2857),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2859),
    [sym__lazy_and_operator] = ACTIONS(2859),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [204] = {
    [sym__closed_assignment] = STATE(14624),
    [sym__expression] = STATE(11868),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17696),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19186),
    [sym__syntactic_operator] = STATE(19186),
    [sym_block_comment] = STATE(204),
    [sym_line_comment] = STATE(204),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2861),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2867),
    [anon_sym_COLON_EQ] = ACTIONS(2869),
    [anon_sym_DOT_EQ] = ACTIONS(2871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2873),
    [sym__lazy_and_operator] = ACTIONS(2873),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [205] = {
    [sym__closed_assignment] = STATE(14508),
    [sym__expression] = STATE(11960),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17744),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18490),
    [sym__syntactic_operator] = STATE(18490),
    [sym_block_comment] = STATE(205),
    [sym_line_comment] = STATE(205),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2875),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2881),
    [anon_sym_COLON_EQ] = ACTIONS(2883),
    [anon_sym_DOT_EQ] = ACTIONS(2885),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2887),
    [sym__lazy_and_operator] = ACTIONS(2887),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [206] = {
    [sym__closed_assignment] = STATE(14905),
    [sym__expression] = STATE(11847),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19238),
    [sym__syntactic_operator] = STATE(19238),
    [sym_block_comment] = STATE(206),
    [sym_line_comment] = STATE(206),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2889),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2895),
    [anon_sym_COLON_EQ] = ACTIONS(2897),
    [anon_sym_DOT_EQ] = ACTIONS(2899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2901),
    [sym__lazy_and_operator] = ACTIONS(2901),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [207] = {
    [sym__closed_assignment] = STATE(14970),
    [sym__expression] = STATE(11850),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17732),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19006),
    [sym__syntactic_operator] = STATE(19006),
    [sym_block_comment] = STATE(207),
    [sym_line_comment] = STATE(207),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2909),
    [anon_sym_COLON_EQ] = ACTIONS(2911),
    [anon_sym_DOT_EQ] = ACTIONS(2913),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2915),
    [sym__lazy_and_operator] = ACTIONS(2915),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [208] = {
    [sym__closed_assignment] = STATE(14333),
    [sym__expression] = STATE(11900),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17738),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18887),
    [sym__syntactic_operator] = STATE(18887),
    [sym_block_comment] = STATE(208),
    [sym_line_comment] = STATE(208),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2917),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2919),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2923),
    [anon_sym_COLON_EQ] = ACTIONS(2925),
    [anon_sym_DOT_EQ] = ACTIONS(2927),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2929),
    [sym__lazy_and_operator] = ACTIONS(2929),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [209] = {
    [sym__closed_assignment] = STATE(14598),
    [sym__expression] = STATE(11943),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17750),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19412),
    [sym__syntactic_operator] = STATE(19412),
    [sym_block_comment] = STATE(209),
    [sym_line_comment] = STATE(209),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2931),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2937),
    [anon_sym_COLON_EQ] = ACTIONS(2939),
    [anon_sym_DOT_EQ] = ACTIONS(2941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2943),
    [sym__lazy_and_operator] = ACTIONS(2943),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [210] = {
    [sym__closed_assignment] = STATE(14527),
    [sym__expression] = STATE(11798),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17720),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18894),
    [sym__syntactic_operator] = STATE(18894),
    [sym_block_comment] = STATE(210),
    [sym_line_comment] = STATE(210),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2951),
    [anon_sym_COLON_EQ] = ACTIONS(2953),
    [anon_sym_DOT_EQ] = ACTIONS(2955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2957),
    [sym__lazy_and_operator] = ACTIONS(2957),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [211] = {
    [sym__closed_assignment] = STATE(14761),
    [sym__expression] = STATE(11834),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17759),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18271),
    [sym__syntactic_operator] = STATE(18271),
    [sym_block_comment] = STATE(211),
    [sym_line_comment] = STATE(211),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2959),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2965),
    [anon_sym_COLON_EQ] = ACTIONS(2967),
    [anon_sym_DOT_EQ] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2971),
    [sym__lazy_and_operator] = ACTIONS(2971),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [212] = {
    [sym__closed_assignment] = STATE(14884),
    [sym__expression] = STATE(11825),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17729),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18667),
    [sym__syntactic_operator] = STATE(18667),
    [sym_block_comment] = STATE(212),
    [sym_line_comment] = STATE(212),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2973),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2979),
    [anon_sym_COLON_EQ] = ACTIONS(2981),
    [anon_sym_DOT_EQ] = ACTIONS(2983),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2985),
    [sym__lazy_and_operator] = ACTIONS(2985),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [213] = {
    [sym__closed_assignment] = STATE(14312),
    [sym__expression] = STATE(11893),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18979),
    [sym__syntactic_operator] = STATE(18979),
    [sym_block_comment] = STATE(213),
    [sym_line_comment] = STATE(213),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(2987),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(2993),
    [anon_sym_COLON_EQ] = ACTIONS(2995),
    [anon_sym_DOT_EQ] = ACTIONS(2997),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(2999),
    [sym__lazy_and_operator] = ACTIONS(2999),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [214] = {
    [sym__closed_assignment] = STATE(14568),
    [sym__expression] = STATE(11987),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17748),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19273),
    [sym__syntactic_operator] = STATE(19273),
    [sym_block_comment] = STATE(214),
    [sym_line_comment] = STATE(214),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3001),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3007),
    [anon_sym_COLON_EQ] = ACTIONS(3009),
    [anon_sym_DOT_EQ] = ACTIONS(3011),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3013),
    [sym__lazy_and_operator] = ACTIONS(3013),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [215] = {
    [sym__closed_assignment] = STATE(14732),
    [sym__expression] = STATE(11819),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17755),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19510),
    [sym__syntactic_operator] = STATE(19510),
    [sym_block_comment] = STATE(215),
    [sym_line_comment] = STATE(215),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3015),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3021),
    [anon_sym_COLON_EQ] = ACTIONS(3023),
    [anon_sym_DOT_EQ] = ACTIONS(3025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3027),
    [sym__lazy_and_operator] = ACTIONS(3027),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [216] = {
    [sym__closed_assignment] = STATE(14544),
    [sym__expression] = STATE(11969),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17745),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19608),
    [sym__syntactic_operator] = STATE(19608),
    [sym_block_comment] = STATE(216),
    [sym_line_comment] = STATE(216),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3031),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3035),
    [anon_sym_COLON_EQ] = ACTIONS(3037),
    [anon_sym_DOT_EQ] = ACTIONS(3039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3041),
    [sym__lazy_and_operator] = ACTIONS(3041),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [217] = {
    [sym__closed_assignment] = STATE(14684),
    [sym__expression] = STATE(11867),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17753),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(18241),
    [sym__syntactic_operator] = STATE(18241),
    [sym_block_comment] = STATE(217),
    [sym_line_comment] = STATE(217),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3043),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3045),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3049),
    [anon_sym_COLON_EQ] = ACTIONS(3051),
    [anon_sym_DOT_EQ] = ACTIONS(3053),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3055),
    [sym__lazy_and_operator] = ACTIONS(3055),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [218] = {
    [sym__closed_assignment] = STATE(14472),
    [sym__expression] = STATE(11923),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18198),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym__assignment_operator] = STATE(19188),
    [sym__syntactic_operator] = STATE(19188),
    [sym_block_comment] = STATE(218),
    [sym_line_comment] = STATE(218),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1797),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [anon_sym_COLON_EQ] = ACTIONS(3065),
    [anon_sym_DOT_EQ] = ACTIONS(3067),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1807),
    [anon_sym_QMARK] = ACTIONS(1807),
    [anon_sym_DASH_GT] = ACTIONS(1807),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3069),
    [sym__lazy_and_operator] = ACTIONS(3069),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [anon_sym_DOT2] = ACTIONS(1833),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [219] = {
    [sym_open_tuple] = STATE(8650),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8485),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(219),
    [sym_line_comment] = STATE(219),
    [aux_sym_macro_argument_list_repeat1] = STATE(257),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [220] = {
    [sym__expression] = STATE(8872),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(220),
    [sym_line_comment] = STATE(220),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [221] = {
    [sym__expression] = STATE(8744),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(221),
    [sym_line_comment] = STATE(221),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [222] = {
    [sym_open_tuple] = STATE(8521),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(8538),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(222),
    [sym_line_comment] = STATE(222),
    [aux_sym_macro_argument_list_repeat1] = STATE(224),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [223] = {
    [sym__expression] = STATE(8835),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(223),
    [sym_line_comment] = STATE(223),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [224] = {
    [sym_open_tuple] = STATE(8521),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(8538),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(224),
    [sym_line_comment] = STATE(224),
    [aux_sym_macro_argument_list_repeat1] = STATE(224),
    [sym__word_identifier] = ACTIONS(1839),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1842),
    [anon_sym_module] = ACTIONS(1845),
    [anon_sym_baremodule] = ACTIONS(1845),
    [anon_sym_abstract] = ACTIONS(1848),
    [anon_sym_primitive] = ACTIONS(1851),
    [anon_sym_mutable] = ACTIONS(1854),
    [anon_sym_struct] = ACTIONS(1857),
    [anon_sym_function] = ACTIONS(1860),
    [anon_sym_macro] = ACTIONS(1863),
    [anon_sym_quote] = ACTIONS(1866),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_if] = ACTIONS(1872),
    [anon_sym_try] = ACTIONS(1875),
    [anon_sym_catch] = ACTIONS(1358),
    [anon_sym_finally] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(1878),
    [anon_sym_while] = ACTIONS(1881),
    [sym_break_statement] = ACTIONS(1884),
    [sym_continue_statement] = ACTIONS(1884),
    [anon_sym_return] = ACTIONS(3077),
    [anon_sym_const] = ACTIONS(3080),
    [anon_sym_global] = ACTIONS(3083),
    [anon_sym_local] = ACTIONS(3086),
    [anon_sym_LPAREN] = ACTIONS(1899),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1902),
    [anon_sym_public] = ACTIONS(1905),
    [anon_sym_import] = ACTIONS(1908),
    [anon_sym_using] = ACTIONS(1911),
    [anon_sym_LBRACK] = ACTIONS(1914),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1917),
    [anon_sym_DOLLAR] = ACTIONS(1920),
    [anon_sym_COLON2] = ACTIONS(1923),
    [anon_sym_COLON_COLON] = ACTIONS(1926),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1929),
    [anon_sym_true] = ACTIONS(1932),
    [anon_sym_false] = ACTIONS(1932),
    [aux_sym_integer_literal_token1] = ACTIONS(1935),
    [aux_sym_integer_literal_token2] = ACTIONS(1935),
    [aux_sym_integer_literal_token3] = ACTIONS(1935),
    [aux_sym_integer_literal_token4] = ACTIONS(1938),
    [aux_sym_float_literal_token1] = ACTIONS(1941),
    [aux_sym_float_literal_token3] = ACTIONS(1941),
    [aux_sym_float_literal_token4] = ACTIONS(1941),
    [sym_character_literal] = ACTIONS(1944),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1947),
    [sym__arrow_operator] = ACTIONS(1947),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1947),
    [sym__pipe_right_operator] = ACTIONS(1947),
    [sym__pipe_left_operator] = ACTIONS(1947),
    [sym__ellipsis_operator] = ACTIONS(1947),
    [sym__plus_operator] = ACTIONS(1947),
    [sym__times_operator] = ACTIONS(1947),
    [sym__rational_operator] = ACTIONS(1947),
    [sym__bitshift_operator] = ACTIONS(1947),
    [sym__power_operator] = ACTIONS(1947),
    [sym__tilde_operator] = ACTIONS(1950),
    [sym__type_order_operator] = ACTIONS(1950),
    [sym__unary_operator] = ACTIONS(1950),
    [sym__unary_plus_operator] = ACTIONS(1950),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [225] = {
    [sym__expression] = STATE(7219),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(225),
    [sym_line_comment] = STATE(225),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [226] = {
    [sym__expression] = STATE(7611),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(226),
    [sym_line_comment] = STATE(226),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [227] = {
    [sym__expression] = STATE(7615),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(227),
    [sym_line_comment] = STATE(227),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [228] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(228),
    [sym_line_comment] = STATE(228),
    [aux_sym_macro_argument_list_repeat1] = STATE(266),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1353),
    [aux_sym_float_literal_token3] = ACTIONS(1353),
    [aux_sym_float_literal_token4] = ACTIONS(1353),
    [sym_character_literal] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1353),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1353),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1353),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [229] = {
    [sym_open_tuple] = STATE(12525),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12100),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10372),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12348),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(229),
    [sym_line_comment] = STATE(229),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [230] = {
    [sym_open_tuple] = STATE(8518),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7985),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(230),
    [sym_line_comment] = STATE(230),
    [aux_sym_macro_argument_list_repeat1] = STATE(230),
    [ts_builtin_sym_end] = ACTIONS(1483),
    [sym__word_identifier] = ACTIONS(1623),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1626),
    [anon_sym_module] = ACTIONS(1629),
    [anon_sym_baremodule] = ACTIONS(1629),
    [anon_sym_abstract] = ACTIONS(1632),
    [anon_sym_primitive] = ACTIONS(1635),
    [anon_sym_mutable] = ACTIONS(1638),
    [anon_sym_struct] = ACTIONS(1641),
    [anon_sym_function] = ACTIONS(1644),
    [anon_sym_macro] = ACTIONS(1647),
    [anon_sym_quote] = ACTIONS(1650),
    [anon_sym_let] = ACTIONS(1653),
    [anon_sym_if] = ACTIONS(1656),
    [anon_sym_try] = ACTIONS(1659),
    [anon_sym_for] = ACTIONS(1662),
    [anon_sym_while] = ACTIONS(1665),
    [sym_break_statement] = ACTIONS(1668),
    [sym_continue_statement] = ACTIONS(1668),
    [anon_sym_return] = ACTIONS(3121),
    [anon_sym_const] = ACTIONS(3124),
    [anon_sym_global] = ACTIONS(3127),
    [anon_sym_local] = ACTIONS(3130),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(1686),
    [anon_sym_public] = ACTIONS(1689),
    [anon_sym_import] = ACTIONS(1692),
    [anon_sym_using] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1698),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(1701),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_COLON_COLON] = ACTIONS(1710),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(1713),
    [anon_sym_true] = ACTIONS(1716),
    [anon_sym_false] = ACTIONS(1716),
    [aux_sym_integer_literal_token1] = ACTIONS(1719),
    [aux_sym_integer_literal_token2] = ACTIONS(1719),
    [aux_sym_integer_literal_token3] = ACTIONS(1719),
    [aux_sym_integer_literal_token4] = ACTIONS(1722),
    [aux_sym_float_literal_token1] = ACTIONS(1725),
    [aux_sym_float_literal_token3] = ACTIONS(1725),
    [aux_sym_float_literal_token4] = ACTIONS(1725),
    [sym_character_literal] = ACTIONS(1728),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(1731),
    [sym__arrow_operator] = ACTIONS(1731),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(1731),
    [sym__pipe_right_operator] = ACTIONS(1731),
    [sym__pipe_left_operator] = ACTIONS(1731),
    [sym__ellipsis_operator] = ACTIONS(1731),
    [sym__plus_operator] = ACTIONS(1731),
    [sym__times_operator] = ACTIONS(1731),
    [sym__rational_operator] = ACTIONS(1731),
    [sym__bitshift_operator] = ACTIONS(1731),
    [sym__power_operator] = ACTIONS(1731),
    [sym__tilde_operator] = ACTIONS(1734),
    [sym__type_order_operator] = ACTIONS(1734),
    [sym__unary_operator] = ACTIONS(1734),
    [sym__unary_plus_operator] = ACTIONS(1734),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [231] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(231),
    [sym_line_comment] = STATE(231),
    [aux_sym_macro_argument_list_repeat1] = STATE(402),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [232] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(232),
    [sym_line_comment] = STATE(232),
    [aux_sym_macro_argument_list_repeat1] = STATE(402),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [233] = {
    [sym_open_tuple] = STATE(8518),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7985),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(233),
    [sym_line_comment] = STATE(233),
    [aux_sym_macro_argument_list_repeat1] = STATE(230),
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_RBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [234] = {
    [sym__block] = STATE(17229),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(234),
    [sym_line_comment] = STATE(234),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3133),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(3133),
    [anon_sym_else] = ACTIONS(3133),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1097),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1111),
    [sym__arrow_operator] = ACTIONS(1113),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1119),
    [sym__pipe_right_operator] = ACTIONS(1121),
    [sym__pipe_left_operator] = ACTIONS(1123),
    [sym__ellipsis_operator] = ACTIONS(1125),
    [sym__plus_operator] = ACTIONS(1127),
    [sym__times_operator] = ACTIONS(1129),
    [sym__rational_operator] = ACTIONS(1131),
    [sym__bitshift_operator] = ACTIONS(1133),
    [sym__power_operator] = ACTIONS(1135),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1139),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1141),
    [aux_sym__terminator_token1] = ACTIONS(3135),
    [aux_sym__terminator_token2] = ACTIONS(3137),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [235] = {
    [sym_open_tuple] = STATE(8288),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(235),
    [sym_line_comment] = STATE(235),
    [aux_sym_macro_argument_list_repeat1] = STATE(235),
    [sym__word_identifier] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(1970),
    [anon_sym_module] = ACTIONS(1973),
    [anon_sym_baremodule] = ACTIONS(1973),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(1976),
    [anon_sym_primitive] = ACTIONS(1979),
    [anon_sym_mutable] = ACTIONS(1982),
    [anon_sym_struct] = ACTIONS(1985),
    [anon_sym_function] = ACTIONS(1988),
    [anon_sym_macro] = ACTIONS(1991),
    [anon_sym_quote] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1997),
    [anon_sym_if] = ACTIONS(2000),
    [anon_sym_try] = ACTIONS(2003),
    [anon_sym_catch] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(2006),
    [anon_sym_while] = ACTIONS(2009),
    [sym_break_statement] = ACTIONS(2012),
    [sym_continue_statement] = ACTIONS(2012),
    [anon_sym_return] = ACTIONS(3139),
    [anon_sym_const] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3145),
    [anon_sym_local] = ACTIONS(3148),
    [anon_sym_LPAREN] = ACTIONS(2027),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(2030),
    [anon_sym_public] = ACTIONS(2033),
    [anon_sym_import] = ACTIONS(2036),
    [anon_sym_using] = ACTIONS(2039),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(2045),
    [anon_sym_DOLLAR] = ACTIONS(2048),
    [anon_sym_COLON2] = ACTIONS(2051),
    [anon_sym_COLON_COLON] = ACTIONS(2054),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(2057),
    [anon_sym_true] = ACTIONS(2060),
    [anon_sym_false] = ACTIONS(2060),
    [aux_sym_integer_literal_token1] = ACTIONS(2063),
    [aux_sym_integer_literal_token2] = ACTIONS(2063),
    [aux_sym_integer_literal_token3] = ACTIONS(2063),
    [aux_sym_integer_literal_token4] = ACTIONS(2066),
    [aux_sym_float_literal_token1] = ACTIONS(2069),
    [aux_sym_float_literal_token3] = ACTIONS(2069),
    [aux_sym_float_literal_token4] = ACTIONS(2069),
    [sym_character_literal] = ACTIONS(2072),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(2075),
    [sym__arrow_operator] = ACTIONS(2075),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(2075),
    [sym__pipe_right_operator] = ACTIONS(2075),
    [sym__pipe_left_operator] = ACTIONS(2075),
    [sym__ellipsis_operator] = ACTIONS(2075),
    [sym__plus_operator] = ACTIONS(2075),
    [sym__times_operator] = ACTIONS(2075),
    [sym__rational_operator] = ACTIONS(2075),
    [sym__bitshift_operator] = ACTIONS(2075),
    [sym__power_operator] = ACTIONS(2075),
    [sym__tilde_operator] = ACTIONS(2078),
    [sym__type_order_operator] = ACTIONS(2078),
    [sym__unary_operator] = ACTIONS(2078),
    [sym__unary_plus_operator] = ACTIONS(2078),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [236] = {
    [sym_open_tuple] = STATE(8454),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(8456),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(236),
    [sym_line_comment] = STATE(236),
    [aux_sym_macro_argument_list_repeat1] = STATE(236),
    [sym__word_identifier] = ACTIONS(2095),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(2098),
    [anon_sym_module] = ACTIONS(2101),
    [anon_sym_baremodule] = ACTIONS(2101),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(2104),
    [anon_sym_primitive] = ACTIONS(2107),
    [anon_sym_mutable] = ACTIONS(2110),
    [anon_sym_struct] = ACTIONS(2113),
    [anon_sym_function] = ACTIONS(2116),
    [anon_sym_macro] = ACTIONS(2119),
    [anon_sym_quote] = ACTIONS(2122),
    [anon_sym_let] = ACTIONS(2125),
    [anon_sym_if] = ACTIONS(2128),
    [anon_sym_try] = ACTIONS(2131),
    [anon_sym_finally] = ACTIONS(1358),
    [anon_sym_for] = ACTIONS(2134),
    [anon_sym_while] = ACTIONS(2137),
    [sym_break_statement] = ACTIONS(2140),
    [sym_continue_statement] = ACTIONS(2140),
    [anon_sym_return] = ACTIONS(3151),
    [anon_sym_const] = ACTIONS(3154),
    [anon_sym_global] = ACTIONS(3157),
    [anon_sym_local] = ACTIONS(3160),
    [anon_sym_LPAREN] = ACTIONS(2155),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(2158),
    [anon_sym_public] = ACTIONS(2161),
    [anon_sym_import] = ACTIONS(2164),
    [anon_sym_using] = ACTIONS(2167),
    [anon_sym_LBRACK] = ACTIONS(2170),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(2173),
    [anon_sym_DOLLAR] = ACTIONS(2176),
    [anon_sym_COLON2] = ACTIONS(2179),
    [anon_sym_COLON_COLON] = ACTIONS(2182),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(2185),
    [anon_sym_true] = ACTIONS(2188),
    [anon_sym_false] = ACTIONS(2188),
    [aux_sym_integer_literal_token1] = ACTIONS(2191),
    [aux_sym_integer_literal_token2] = ACTIONS(2191),
    [aux_sym_integer_literal_token3] = ACTIONS(2191),
    [aux_sym_integer_literal_token4] = ACTIONS(2194),
    [aux_sym_float_literal_token1] = ACTIONS(2197),
    [aux_sym_float_literal_token3] = ACTIONS(2197),
    [aux_sym_float_literal_token4] = ACTIONS(2197),
    [sym_character_literal] = ACTIONS(2200),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(2203),
    [sym__arrow_operator] = ACTIONS(2203),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(2203),
    [sym__pipe_right_operator] = ACTIONS(2203),
    [sym__pipe_left_operator] = ACTIONS(2203),
    [sym__ellipsis_operator] = ACTIONS(2203),
    [sym__plus_operator] = ACTIONS(2203),
    [sym__times_operator] = ACTIONS(2203),
    [sym__rational_operator] = ACTIONS(2203),
    [sym__bitshift_operator] = ACTIONS(2203),
    [sym__power_operator] = ACTIONS(2203),
    [sym__tilde_operator] = ACTIONS(2206),
    [sym__type_order_operator] = ACTIONS(2206),
    [sym__unary_operator] = ACTIONS(2206),
    [sym__unary_plus_operator] = ACTIONS(2206),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [237] = {
    [sym_open_tuple] = STATE(12303),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12307),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10216),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12344),
    [sym_unary_expression] = STATE(12344),
    [sym_range_expression] = STATE(12344),
    [sym_splat_expression] = STATE(12344),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11945),
    [sym_unary_typed_expression] = STATE(12344),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12344),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11947),
    [sym_block_comment] = STATE(237),
    [sym_line_comment] = STATE(237),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1835),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(2219),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(2219),
    [sym__pipe_left_operator] = ACTIONS(2219),
    [sym__ellipsis_operator] = ACTIONS(2219),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(2219),
    [sym__bitshift_operator] = ACTIONS(2219),
    [sym__power_operator] = ACTIONS(2219),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1137),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [238] = {
    [sym__expression] = STATE(12320),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(238),
    [sym_line_comment] = STATE(238),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(2219),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(2219),
    [sym__pipe_left_operator] = ACTIONS(2219),
    [sym__ellipsis_operator] = ACTIONS(2219),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(2219),
    [sym__bitshift_operator] = ACTIONS(2219),
    [sym__power_operator] = ACTIONS(2219),
    [sym__tilde_operator] = ACTIONS(1137),
    [sym__type_order_operator] = ACTIONS(1137),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [239] = {
    [sym__expression] = STATE(8913),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(239),
    [sym_line_comment] = STATE(239),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [240] = {
    [sym_open_tuple] = STATE(12190),
    [sym_assignment] = STATE(12267),
    [sym__expression] = STATE(12293),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10240),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12195),
    [sym_unary_expression] = STATE(12195),
    [sym_range_expression] = STATE(12195),
    [sym_splat_expression] = STATE(12195),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11860),
    [sym_unary_typed_expression] = STATE(12195),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12195),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11849),
    [sym_block_comment] = STATE(240),
    [sym_line_comment] = STATE(240),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(169),
    [aux_sym_integer_literal_token2] = ACTIONS(169),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(173),
    [aux_sym_float_literal_token3] = ACTIONS(173),
    [aux_sym_float_literal_token4] = ACTIONS(173),
    [sym_character_literal] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(181),
    [sym__type_order_operator] = ACTIONS(181),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [241] = {
    [sym__expression] = STATE(12182),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(241),
    [sym_line_comment] = STATE(241),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(169),
    [aux_sym_integer_literal_token2] = ACTIONS(169),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(173),
    [aux_sym_float_literal_token3] = ACTIONS(173),
    [aux_sym_float_literal_token4] = ACTIONS(173),
    [sym_character_literal] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(181),
    [sym__type_order_operator] = ACTIONS(181),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [242] = {
    [sym__block] = STATE(19355),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(242),
    [sym_line_comment] = STATE(242),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3163),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(3165),
    [aux_sym__terminator_token2] = ACTIONS(3167),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [243] = {
    [sym__expression] = STATE(7309),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(243),
    [sym_line_comment] = STATE(243),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [244] = {
    [sym_open_tuple] = STATE(8650),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8485),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(244),
    [sym_line_comment] = STATE(244),
    [aux_sym_macro_argument_list_repeat1] = STATE(257),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [245] = {
    [sym__expression] = STATE(8903),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(245),
    [sym_line_comment] = STATE(245),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [246] = {
    [sym_open_tuple] = STATE(8288),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(246),
    [sym_line_comment] = STATE(246),
    [aux_sym_macro_argument_list_repeat1] = STATE(235),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [247] = {
    [sym_open_tuple] = STATE(8521),
    [sym_assignment] = STATE(8537),
    [sym__expression] = STATE(8538),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(247),
    [sym_line_comment] = STATE(247),
    [aux_sym_macro_argument_list_repeat1] = STATE(224),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [248] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(248),
    [sym_line_comment] = STATE(248),
    [aux_sym_macro_argument_list_repeat1] = STATE(399),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(901),
    [sym__immediate_bracket] = ACTIONS(903),
    [sym__immediate_brace] = ACTIONS(905),
  },
  [249] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(249),
    [sym_line_comment] = STATE(249),
    [aux_sym_macro_argument_list_repeat1] = STATE(399),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(331),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(995),
    [sym__immediate_bracket] = ACTIONS(997),
    [sym__immediate_brace] = ACTIONS(999),
  },
  [250] = {
    [sym_open_tuple] = STATE(7731),
    [sym_assignment] = STATE(7311),
    [sym__expression] = STATE(7312),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(250),
    [sym_line_comment] = STATE(250),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [251] = {
    [sym__expression] = STATE(7396),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(251),
    [sym_line_comment] = STATE(251),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(319),
    [sym__type_order_operator] = ACTIONS(319),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [252] = {
    [sym__expression] = STATE(8923),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(252),
    [sym_line_comment] = STATE(252),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [253] = {
    [sym_open_tuple] = STATE(8288),
    [sym_assignment] = STATE(8289),
    [sym__expression] = STATE(8290),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(253),
    [sym_line_comment] = STATE(253),
    [aux_sym_macro_argument_list_repeat1] = STATE(235),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_catch] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [254] = {
    [sym_open_tuple] = STATE(8086),
    [sym_assignment] = STATE(8466),
    [sym__expression] = STATE(7624),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(254),
    [sym_line_comment] = STATE(254),
    [ts_builtin_sym_end] = ACTIONS(1837),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [255] = {
    [sym_open_tuple] = STATE(8454),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(8456),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(255),
    [sym_line_comment] = STATE(255),
    [aux_sym_macro_argument_list_repeat1] = STATE(236),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [256] = {
    [sym_open_tuple] = STATE(8454),
    [sym_assignment] = STATE(8455),
    [sym__expression] = STATE(8456),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(256),
    [sym_line_comment] = STATE(256),
    [aux_sym_macro_argument_list_repeat1] = STATE(236),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_finally] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [257] = {
    [sym_open_tuple] = STATE(8650),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8485),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(257),
    [sym_line_comment] = STATE(257),
    [aux_sym_macro_argument_list_repeat1] = STATE(257),
    [sym__word_identifier] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3175),
    [anon_sym_baremodule] = ACTIONS(3175),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(3178),
    [anon_sym_primitive] = ACTIONS(3181),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3190),
    [anon_sym_macro] = ACTIONS(3193),
    [anon_sym_quote] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3205),
    [anon_sym_for] = ACTIONS(3208),
    [anon_sym_while] = ACTIONS(3211),
    [sym_break_statement] = ACTIONS(3214),
    [sym_continue_statement] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3217),
    [anon_sym_const] = ACTIONS(3220),
    [anon_sym_global] = ACTIONS(3223),
    [anon_sym_local] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3232),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_import] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_DOLLAR] = ACTIONS(3250),
    [anon_sym_COLON2] = ACTIONS(3253),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3259),
    [anon_sym_true] = ACTIONS(3262),
    [anon_sym_false] = ACTIONS(3262),
    [aux_sym_integer_literal_token1] = ACTIONS(3265),
    [aux_sym_integer_literal_token2] = ACTIONS(3265),
    [aux_sym_integer_literal_token3] = ACTIONS(3265),
    [aux_sym_integer_literal_token4] = ACTIONS(3268),
    [aux_sym_float_literal_token1] = ACTIONS(3271),
    [aux_sym_float_literal_token3] = ACTIONS(3271),
    [aux_sym_float_literal_token4] = ACTIONS(3271),
    [sym_character_literal] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(3277),
    [sym__arrow_operator] = ACTIONS(3277),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(3277),
    [sym__pipe_right_operator] = ACTIONS(3277),
    [sym__pipe_left_operator] = ACTIONS(3277),
    [sym__ellipsis_operator] = ACTIONS(3277),
    [sym__plus_operator] = ACTIONS(3277),
    [sym__times_operator] = ACTIONS(3277),
    [sym__rational_operator] = ACTIONS(3277),
    [sym__bitshift_operator] = ACTIONS(3277),
    [sym__power_operator] = ACTIONS(3277),
    [sym__tilde_operator] = ACTIONS(3280),
    [sym__type_order_operator] = ACTIONS(3280),
    [sym__unary_operator] = ACTIONS(3280),
    [sym__unary_plus_operator] = ACTIONS(3280),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [258] = {
    [sym__expression] = STATE(8930),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(258),
    [sym_line_comment] = STATE(258),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [259] = {
    [sym_open_tuple] = STATE(12684),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12104),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10309),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12090),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(259),
    [sym_line_comment] = STATE(259),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3301),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(3305),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3307),
    [aux_sym_integer_literal_token2] = ACTIONS(3307),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(3311),
    [aux_sym_float_literal_token3] = ACTIONS(3311),
    [aux_sym_float_literal_token4] = ACTIONS(3311),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3313),
    [sym__type_order_operator] = ACTIONS(3313),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [260] = {
    [sym_open_tuple] = STATE(8427),
    [sym_assignment] = STATE(8260),
    [sym__expression] = STATE(7630),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(260),
    [sym_line_comment] = STATE(260),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [261] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(261),
    [sym_line_comment] = STATE(261),
    [aux_sym_macro_argument_list_repeat1] = STATE(266),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [262] = {
    [sym_open_tuple] = STATE(7229),
    [sym_assignment] = STATE(7261),
    [sym__expression] = STATE(7263),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(262),
    [sym_line_comment] = STATE(262),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(1835),
    [anon_sym_else] = ACTIONS(1835),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(413),
    [sym__type_order_operator] = ACTIONS(413),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [263] = {
    [sym_open_tuple] = STATE(8433),
    [sym_assignment] = STATE(8224),
    [sym__expression] = STATE(7641),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(263),
    [sym_line_comment] = STATE(263),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [264] = {
    [sym_open_tuple] = STATE(12732),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12107),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10246),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12132),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(264),
    [sym_line_comment] = STATE(264),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(3337),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3339),
    [aux_sym_integer_literal_token2] = ACTIONS(3339),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(3343),
    [aux_sym_float_literal_token3] = ACTIONS(3343),
    [aux_sym_float_literal_token4] = ACTIONS(3343),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3345),
    [sym__type_order_operator] = ACTIONS(3345),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [265] = {
    [sym_open_tuple] = STATE(8437),
    [sym_assignment] = STATE(8094),
    [sym__expression] = STATE(7645),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(265),
    [sym_line_comment] = STATE(265),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [266] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(266),
    [sym_line_comment] = STATE(266),
    [aux_sym_macro_argument_list_repeat1] = STATE(266),
    [sym__word_identifier] = ACTIONS(3347),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(3350),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_baremodule] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_primitive] = ACTIONS(3359),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_macro] = ACTIONS(3371),
    [anon_sym_quote] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3380),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3386),
    [anon_sym_while] = ACTIONS(3389),
    [sym_break_statement] = ACTIONS(3392),
    [sym_continue_statement] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3395),
    [anon_sym_const] = ACTIONS(3398),
    [anon_sym_global] = ACTIONS(3401),
    [anon_sym_local] = ACTIONS(3404),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3416),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(1483),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR] = ACTIONS(3428),
    [anon_sym_COLON2] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3440),
    [anon_sym_false] = ACTIONS(3440),
    [aux_sym_integer_literal_token1] = ACTIONS(3443),
    [aux_sym_integer_literal_token2] = ACTIONS(3443),
    [aux_sym_integer_literal_token3] = ACTIONS(3446),
    [aux_sym_integer_literal_token4] = ACTIONS(3449),
    [aux_sym_float_literal_token1] = ACTIONS(3452),
    [aux_sym_float_literal_token3] = ACTIONS(3452),
    [aux_sym_float_literal_token4] = ACTIONS(3452),
    [sym_character_literal] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3458),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3461),
    [sym__pair_operator] = ACTIONS(3464),
    [sym__arrow_operator] = ACTIONS(3467),
    [sym__lazy_or_operator] = ACTIONS(1483),
    [sym__lazy_and_operator] = ACTIONS(1483),
    [sym__comparison_operator] = ACTIONS(3467),
    [sym__pipe_right_operator] = ACTIONS(3464),
    [sym__pipe_left_operator] = ACTIONS(3464),
    [sym__ellipsis_operator] = ACTIONS(3467),
    [sym__plus_operator] = ACTIONS(3467),
    [sym__times_operator] = ACTIONS(3467),
    [sym__rational_operator] = ACTIONS(3464),
    [sym__bitshift_operator] = ACTIONS(3464),
    [sym__power_operator] = ACTIONS(3464),
    [sym__tilde_operator] = ACTIONS(3470),
    [sym__type_order_operator] = ACTIONS(3470),
    [sym__unary_operator] = ACTIONS(3473),
    [sym__unary_plus_operator] = ACTIONS(3473),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [267] = {
    [sym__expression] = STATE(8907),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(267),
    [sym_line_comment] = STATE(267),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [268] = {
    [sym__block] = STATE(18654),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(268),
    [sym_line_comment] = STATE(268),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1043),
    [anon_sym_EQ] = ACTIONS(1043),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3476),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1043),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1043),
    [anon_sym_QMARK] = ACTIONS(1043),
    [anon_sym_where] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1043),
    [sym__lazy_and_operator] = ACTIONS(1043),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(3478),
    [aux_sym__terminator_token2] = ACTIONS(3480),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [269] = {
    [sym__expression] = STATE(8932),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(269),
    [sym_line_comment] = STATE(269),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [270] = {
    [sym__expression] = STATE(8934),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(270),
    [sym_line_comment] = STATE(270),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [271] = {
    [sym_open_tuple] = STATE(8420),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7933),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(271),
    [sym_line_comment] = STATE(271),
    [aux_sym_macro_argument_list_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [272] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(272),
    [sym_line_comment] = STATE(272),
    [aux_sym_macro_argument_list_repeat1] = STATE(279),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [273] = {
    [sym_open_tuple] = STATE(8463),
    [sym_assignment] = STATE(8466),
    [sym__expression] = STATE(8469),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(273),
    [sym_line_comment] = STATE(273),
    [ts_builtin_sym_end] = ACTIONS(1837),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(1835),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [274] = {
    [sym_open_tuple] = STATE(8672),
    [sym_assignment] = STATE(8630),
    [sym__expression] = STATE(8487),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(274),
    [sym_line_comment] = STATE(274),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [275] = {
    [sym__expression] = STATE(12399),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(275),
    [sym_line_comment] = STATE(275),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [276] = {
    [sym_open_tuple] = STATE(12608),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12616),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10375),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12434),
    [sym_unary_expression] = STATE(12434),
    [sym_range_expression] = STATE(12434),
    [sym_splat_expression] = STATE(12434),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12140),
    [sym_unary_typed_expression] = STATE(12434),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12434),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12144),
    [sym_block_comment] = STATE(276),
    [sym_line_comment] = STATE(276),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3301),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(3305),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3307),
    [aux_sym_integer_literal_token2] = ACTIONS(3307),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(3311),
    [aux_sym_float_literal_token3] = ACTIONS(3311),
    [aux_sym_float_literal_token4] = ACTIONS(3311),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3313),
    [sym__type_order_operator] = ACTIONS(3313),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [277] = {
    [sym__expression] = STATE(12723),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(277),
    [sym_line_comment] = STATE(277),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3301),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(3305),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3307),
    [aux_sym_integer_literal_token2] = ACTIONS(3307),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(3311),
    [aux_sym_float_literal_token3] = ACTIONS(3311),
    [aux_sym_float_literal_token4] = ACTIONS(3311),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3313),
    [sym__type_order_operator] = ACTIONS(3313),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [278] = {
    [sym_open_tuple] = STATE(8761),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(278),
    [sym_line_comment] = STATE(278),
    [aux_sym_macro_argument_list_repeat1] = STATE(280),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1351),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1351),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1351),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1351),
    [aux_sym_integer_literal_token2] = ACTIONS(1351),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1351),
    [aux_sym_float_literal_token3] = ACTIONS(1351),
    [aux_sym_float_literal_token4] = ACTIONS(1351),
    [sym_character_literal] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1351),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(1351),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [279] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(279),
    [sym_line_comment] = STATE(279),
    [aux_sym_macro_argument_list_repeat1] = STATE(279),
    [sym__word_identifier] = ACTIONS(3347),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(3490),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_baremodule] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_primitive] = ACTIONS(3359),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_macro] = ACTIONS(3371),
    [anon_sym_quote] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3380),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3386),
    [anon_sym_while] = ACTIONS(3389),
    [sym_break_statement] = ACTIONS(3392),
    [sym_continue_statement] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3493),
    [anon_sym_const] = ACTIONS(3496),
    [anon_sym_global] = ACTIONS(3499),
    [anon_sym_local] = ACTIONS(3502),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3416),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3428),
    [anon_sym_COLON2] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3440),
    [anon_sym_false] = ACTIONS(3440),
    [aux_sym_integer_literal_token1] = ACTIONS(3443),
    [aux_sym_integer_literal_token2] = ACTIONS(3443),
    [aux_sym_integer_literal_token3] = ACTIONS(3446),
    [aux_sym_integer_literal_token4] = ACTIONS(3449),
    [aux_sym_float_literal_token1] = ACTIONS(3452),
    [aux_sym_float_literal_token3] = ACTIONS(3452),
    [aux_sym_float_literal_token4] = ACTIONS(3452),
    [sym_character_literal] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3458),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3461),
    [sym__pair_operator] = ACTIONS(3464),
    [sym__arrow_operator] = ACTIONS(3467),
    [sym__lazy_or_operator] = ACTIONS(1483),
    [sym__lazy_and_operator] = ACTIONS(1483),
    [sym__comparison_operator] = ACTIONS(3467),
    [sym__pipe_right_operator] = ACTIONS(3464),
    [sym__pipe_left_operator] = ACTIONS(3464),
    [sym__ellipsis_operator] = ACTIONS(3467),
    [sym__plus_operator] = ACTIONS(3467),
    [sym__times_operator] = ACTIONS(3467),
    [sym__rational_operator] = ACTIONS(3464),
    [sym__bitshift_operator] = ACTIONS(3464),
    [sym__power_operator] = ACTIONS(3464),
    [sym__tilde_operator] = ACTIONS(3505),
    [sym__type_order_operator] = ACTIONS(3505),
    [sym__unary_operator] = ACTIONS(3508),
    [sym__unary_plus_operator] = ACTIONS(3508),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [280] = {
    [sym_open_tuple] = STATE(8761),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(280),
    [sym_line_comment] = STATE(280),
    [aux_sym_macro_argument_list_repeat1] = STATE(280),
    [sym__word_identifier] = ACTIONS(3169),
    [anon_sym_COMMA] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(3172),
    [anon_sym_module] = ACTIONS(3175),
    [anon_sym_baremodule] = ACTIONS(3175),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(3178),
    [anon_sym_primitive] = ACTIONS(3181),
    [anon_sym_mutable] = ACTIONS(3184),
    [anon_sym_struct] = ACTIONS(3187),
    [anon_sym_function] = ACTIONS(3190),
    [anon_sym_macro] = ACTIONS(3193),
    [anon_sym_quote] = ACTIONS(3196),
    [anon_sym_let] = ACTIONS(3199),
    [anon_sym_if] = ACTIONS(3202),
    [anon_sym_try] = ACTIONS(3205),
    [anon_sym_for] = ACTIONS(3208),
    [anon_sym_while] = ACTIONS(3211),
    [sym_break_statement] = ACTIONS(3214),
    [sym_continue_statement] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3511),
    [anon_sym_const] = ACTIONS(3514),
    [anon_sym_global] = ACTIONS(3517),
    [anon_sym_local] = ACTIONS(3520),
    [anon_sym_LPAREN] = ACTIONS(3229),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3232),
    [anon_sym_public] = ACTIONS(3235),
    [anon_sym_import] = ACTIONS(3238),
    [anon_sym_using] = ACTIONS(3241),
    [anon_sym_LBRACK] = ACTIONS(3244),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(3247),
    [anon_sym_DOLLAR] = ACTIONS(3250),
    [anon_sym_COLON2] = ACTIONS(3253),
    [anon_sym_COLON_COLON] = ACTIONS(3256),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1358),
    [anon_sym_QMARK] = ACTIONS(1358),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3259),
    [anon_sym_true] = ACTIONS(3262),
    [anon_sym_false] = ACTIONS(3262),
    [aux_sym_integer_literal_token1] = ACTIONS(3265),
    [aux_sym_integer_literal_token2] = ACTIONS(3265),
    [aux_sym_integer_literal_token3] = ACTIONS(3265),
    [aux_sym_integer_literal_token4] = ACTIONS(3268),
    [aux_sym_float_literal_token1] = ACTIONS(3271),
    [aux_sym_float_literal_token3] = ACTIONS(3271),
    [aux_sym_float_literal_token4] = ACTIONS(3271),
    [sym_character_literal] = ACTIONS(3274),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1468),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1474),
    [sym__pair_operator] = ACTIONS(3277),
    [sym__arrow_operator] = ACTIONS(3277),
    [sym__lazy_or_operator] = ACTIONS(1358),
    [sym__lazy_and_operator] = ACTIONS(1358),
    [sym__comparison_operator] = ACTIONS(3277),
    [sym__pipe_right_operator] = ACTIONS(3277),
    [sym__pipe_left_operator] = ACTIONS(3277),
    [sym__ellipsis_operator] = ACTIONS(3277),
    [sym__plus_operator] = ACTIONS(3277),
    [sym__times_operator] = ACTIONS(3277),
    [sym__rational_operator] = ACTIONS(3277),
    [sym__bitshift_operator] = ACTIONS(3277),
    [sym__power_operator] = ACTIONS(3277),
    [sym__tilde_operator] = ACTIONS(3280),
    [sym__type_order_operator] = ACTIONS(3280),
    [sym__unary_operator] = ACTIONS(3280),
    [sym__unary_plus_operator] = ACTIONS(3280),
    [aux_sym__terminator_token1] = ACTIONS(1483),
    [aux_sym__terminator_token2] = ACTIONS(1358),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [281] = {
    [sym_open_tuple] = STATE(8259),
    [sym_assignment] = STATE(8260),
    [sym__expression] = STATE(8261),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(281),
    [sym_line_comment] = STATE(281),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [282] = {
    [sym__expression] = STATE(8283),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(282),
    [sym_line_comment] = STATE(282),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(787),
    [sym__type_order_operator] = ACTIONS(787),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [283] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(283),
    [sym_line_comment] = STATE(283),
    [aux_sym_macro_argument_list_repeat1] = STATE(279),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [284] = {
    [sym_open_tuple] = STATE(12385),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12386),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10352),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12481),
    [sym_unary_expression] = STATE(12481),
    [sym_range_expression] = STATE(12481),
    [sym_splat_expression] = STATE(12481),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12268),
    [sym_unary_typed_expression] = STATE(12481),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12481),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12269),
    [sym_block_comment] = STATE(284),
    [sym_line_comment] = STATE(284),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [285] = {
    [sym_open_tuple] = STATE(8518),
    [sym_assignment] = STATE(8570),
    [sym__expression] = STATE(7985),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(285),
    [sym_line_comment] = STATE(285),
    [aux_sym_macro_argument_list_repeat1] = STATE(230),
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [286] = {
    [sym_open_tuple] = STATE(8093),
    [sym_assignment] = STATE(8224),
    [sym__expression] = STATE(8226),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(286),
    [sym_line_comment] = STATE(286),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [287] = {
    [sym__expression] = STATE(8465),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(287),
    [sym_line_comment] = STATE(287),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(609),
    [sym__type_order_operator] = ACTIONS(609),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [288] = {
    [sym_open_tuple] = STATE(12499),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12529),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10320),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12522),
    [sym_unary_expression] = STATE(12522),
    [sym_range_expression] = STATE(12522),
    [sym_splat_expression] = STATE(12522),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12010),
    [sym_unary_typed_expression] = STATE(12522),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12522),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12322),
    [sym_block_comment] = STATE(288),
    [sym_line_comment] = STATE(288),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(3337),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3339),
    [aux_sym_integer_literal_token2] = ACTIONS(3339),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(3343),
    [aux_sym_float_literal_token3] = ACTIONS(3343),
    [aux_sym_float_literal_token4] = ACTIONS(3343),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3345),
    [sym__type_order_operator] = ACTIONS(3345),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [289] = {
    [sym__expression] = STATE(12494),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(289),
    [sym_line_comment] = STATE(289),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(3337),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3339),
    [aux_sym_integer_literal_token2] = ACTIONS(3339),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(3343),
    [aux_sym_float_literal_token3] = ACTIONS(3343),
    [aux_sym_float_literal_token4] = ACTIONS(3343),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3345),
    [sym__type_order_operator] = ACTIONS(3345),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [290] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10775),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(290),
    [sym_line_comment] = STATE(290),
    [aux_sym_macro_argument_list_repeat1] = STATE(292),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(247),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(247),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_where] = ACTIONS(247),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(321),
    [sym__lazy_and_operator] = ACTIONS(321),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1017),
    [sym__immediate_bracket] = ACTIONS(1019),
    [sym__immediate_brace] = ACTIONS(1021),
  },
  [291] = {
    [sym_open_tuple] = STATE(8303),
    [sym_assignment] = STATE(8094),
    [sym__expression] = STATE(8095),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(291),
    [sym_line_comment] = STATE(291),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(1835),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [292] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(292),
    [sym_line_comment] = STATE(292),
    [aux_sym_macro_argument_list_repeat1] = STATE(301),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [293] = {
    [sym__expression] = STATE(8126),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(293),
    [sym_line_comment] = STATE(293),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(525),
    [sym__type_order_operator] = ACTIONS(525),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [294] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(294),
    [sym_line_comment] = STATE(294),
    [aux_sym_macro_argument_list_repeat1] = STATE(301),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1353),
    [aux_sym_float_literal_token3] = ACTIONS(1353),
    [aux_sym_float_literal_token4] = ACTIONS(1353),
    [sym_character_literal] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1353),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1353),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1353),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [295] = {
    [sym_open_tuple] = STATE(8761),
    [sym_assignment] = STATE(8764),
    [sym__expression] = STATE(8780),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(295),
    [sym_line_comment] = STATE(295),
    [aux_sym_macro_argument_list_repeat1] = STATE(280),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(1351),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1351),
    [anon_sym_QMARK] = ACTIONS(1351),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1351),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1351),
    [sym__lazy_and_operator] = ACTIONS(1351),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1351),
    [sym__pipe_left_operator] = ACTIONS(1351),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1351),
    [sym__bitshift_operator] = ACTIONS(1351),
    [sym__power_operator] = ACTIONS(1351),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(1351),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym__terminator_token1] = ACTIONS(1353),
    [aux_sym__terminator_token2] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [296] = {
    [sym_open_tuple] = STATE(8681),
    [sym_assignment] = STATE(8056),
    [sym__expression] = STATE(8495),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(296),
    [sym_line_comment] = STATE(296),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1837),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(1837),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [297] = {
    [sym_open_tuple] = STATE(12929),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12568),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10389),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12503),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(297),
    [sym_line_comment] = STATE(297),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [298] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_macro_argument_list] = STATE(10773),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(298),
    [sym_line_comment] = STATE(298),
    [aux_sym_macro_argument_list_repeat1] = STATE(292),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(329),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(329),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(331),
    [anon_sym_QMARK] = ACTIONS(331),
    [anon_sym_where] = ACTIONS(329),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(331),
    [sym__lazy_and_operator] = ACTIONS(331),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(1023),
    [sym__immediate_bracket] = ACTIONS(1025),
    [sym__immediate_brace] = ACTIONS(1027),
  },
  [299] = {
    [sym__expression] = STATE(12625),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(299),
    [sym_line_comment] = STATE(299),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(1093),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(2217),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(1105),
    [aux_sym_integer_literal_token2] = ACTIONS(1105),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(1109),
    [aux_sym_float_literal_token3] = ACTIONS(1109),
    [aux_sym_float_literal_token4] = ACTIONS(1109),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(2219),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(2219),
    [sym__pipe_left_operator] = ACTIONS(2219),
    [sym__ellipsis_operator] = ACTIONS(2219),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(2219),
    [sym__bitshift_operator] = ACTIONS(2219),
    [sym__power_operator] = ACTIONS(2219),
    [sym__tilde_operator] = ACTIONS(3547),
    [sym__type_order_operator] = ACTIONS(3547),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [300] = {
    [sym_open_tuple] = STATE(12912),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12740),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10435),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12583),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(300),
    [sym_line_comment] = STATE(300),
    [ts_builtin_sym_end] = ACTIONS(1837),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3557),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(3559),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(75),
    [aux_sym_integer_literal_token2] = ACTIONS(75),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(3561),
    [aux_sym_float_literal_token3] = ACTIONS(3561),
    [aux_sym_float_literal_token4] = ACTIONS(3561),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(97),
    [sym__type_order_operator] = ACTIONS(97),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [301] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(301),
    [sym_line_comment] = STATE(301),
    [aux_sym_macro_argument_list_repeat1] = STATE(301),
    [sym__word_identifier] = ACTIONS(3347),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(3350),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_baremodule] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_primitive] = ACTIONS(3359),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_macro] = ACTIONS(3371),
    [anon_sym_quote] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3380),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3386),
    [anon_sym_while] = ACTIONS(3389),
    [sym_break_statement] = ACTIONS(3392),
    [sym_continue_statement] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3563),
    [anon_sym_const] = ACTIONS(3566),
    [anon_sym_global] = ACTIONS(3569),
    [anon_sym_local] = ACTIONS(3572),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3416),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(1483),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(1483),
    [anon_sym_DOLLAR] = ACTIONS(3428),
    [anon_sym_COLON2] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3440),
    [anon_sym_false] = ACTIONS(3440),
    [aux_sym_integer_literal_token1] = ACTIONS(3443),
    [aux_sym_integer_literal_token2] = ACTIONS(3443),
    [aux_sym_integer_literal_token3] = ACTIONS(3446),
    [aux_sym_integer_literal_token4] = ACTIONS(3449),
    [aux_sym_float_literal_token1] = ACTIONS(3452),
    [aux_sym_float_literal_token3] = ACTIONS(3452),
    [aux_sym_float_literal_token4] = ACTIONS(3452),
    [sym_character_literal] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3458),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3461),
    [sym__pair_operator] = ACTIONS(3464),
    [sym__arrow_operator] = ACTIONS(3467),
    [sym__lazy_or_operator] = ACTIONS(1483),
    [sym__lazy_and_operator] = ACTIONS(1483),
    [sym__comparison_operator] = ACTIONS(3467),
    [sym__pipe_right_operator] = ACTIONS(3464),
    [sym__pipe_left_operator] = ACTIONS(3464),
    [sym__ellipsis_operator] = ACTIONS(3467),
    [sym__plus_operator] = ACTIONS(3467),
    [sym__times_operator] = ACTIONS(3467),
    [sym__rational_operator] = ACTIONS(3464),
    [sym__bitshift_operator] = ACTIONS(3464),
    [sym__power_operator] = ACTIONS(3464),
    [sym__tilde_operator] = ACTIONS(3470),
    [sym__type_order_operator] = ACTIONS(3470),
    [sym__unary_operator] = ACTIONS(3473),
    [sym__unary_plus_operator] = ACTIONS(3473),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [302] = {
    [sym__expression] = STATE(12632),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(302),
    [sym_line_comment] = STATE(302),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(169),
    [aux_sym_integer_literal_token2] = ACTIONS(169),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(173),
    [aux_sym_float_literal_token3] = ACTIONS(173),
    [aux_sym_float_literal_token4] = ACTIONS(173),
    [sym_character_literal] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3575),
    [sym__type_order_operator] = ACTIONS(3575),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [303] = {
    [sym_open_tuple] = STATE(12917),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12469),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10504),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12582),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(303),
    [sym_line_comment] = STATE(303),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1837),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(1837),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [304] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(304),
    [sym_line_comment] = STATE(304),
    [aux_sym_macro_argument_list_repeat1] = STATE(279),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1353),
    [aux_sym_float_literal_token3] = ACTIONS(1353),
    [aux_sym_float_literal_token4] = ACTIONS(1353),
    [sym_character_literal] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1353),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1353),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1353),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [305] = {
    [sym__expression] = STATE(8431),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(305),
    [sym_line_comment] = STATE(305),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(287),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(301),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(305),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(309),
    [aux_sym_integer_literal_token2] = ACTIONS(309),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(313),
    [aux_sym_float_literal_token3] = ACTIONS(313),
    [aux_sym_float_literal_token4] = ACTIONS(313),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(317),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(317),
    [sym__pipe_left_operator] = ACTIONS(317),
    [sym__ellipsis_operator] = ACTIONS(317),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(317),
    [sym__bitshift_operator] = ACTIONS(317),
    [sym__power_operator] = ACTIONS(317),
    [sym__tilde_operator] = ACTIONS(3613),
    [sym__type_order_operator] = ACTIONS(3613),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [306] = {
    [sym__expression] = STATE(8603),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(306),
    [sym_line_comment] = STATE(306),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3615),
    [sym__type_order_operator] = ACTIONS(3615),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [307] = {
    [sym_open_tuple] = STATE(8977),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8810),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(307),
    [sym_line_comment] = STATE(307),
    [aux_sym_macro_argument_list_repeat1] = STATE(279),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [308] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(308),
    [sym_line_comment] = STATE(308),
    [aux_sym_macro_argument_list_repeat1] = STATE(266),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [309] = {
    [sym__expression] = STATE(8610),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(309),
    [sym_line_comment] = STATE(309),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3617),
    [sym__type_order_operator] = ACTIONS(3617),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [310] = {
    [sym__expression] = STATE(8509),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(310),
    [sym_line_comment] = STATE(310),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(699),
    [sym__type_order_operator] = ACTIONS(699),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [311] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(311),
    [sym_line_comment] = STATE(311),
    [aux_sym_macro_argument_list_repeat1] = STATE(313),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [312] = {
    [sym__block] = STATE(18319),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(312),
    [sym_line_comment] = STATE(312),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3619),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3663),
    [aux_sym__terminator_token2] = ACTIONS(3665),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [313] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(313),
    [sym_line_comment] = STATE(313),
    [aux_sym_macro_argument_list_repeat1] = STATE(313),
    [sym__word_identifier] = ACTIONS(3347),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(3490),
    [anon_sym_module] = ACTIONS(3353),
    [anon_sym_baremodule] = ACTIONS(3353),
    [anon_sym_abstract] = ACTIONS(3356),
    [anon_sym_primitive] = ACTIONS(3359),
    [anon_sym_mutable] = ACTIONS(3362),
    [anon_sym_struct] = ACTIONS(3365),
    [anon_sym_function] = ACTIONS(3368),
    [anon_sym_macro] = ACTIONS(3371),
    [anon_sym_quote] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_if] = ACTIONS(3380),
    [anon_sym_try] = ACTIONS(3383),
    [anon_sym_for] = ACTIONS(3386),
    [anon_sym_while] = ACTIONS(3389),
    [sym_break_statement] = ACTIONS(3392),
    [sym_continue_statement] = ACTIONS(3392),
    [anon_sym_return] = ACTIONS(3667),
    [anon_sym_const] = ACTIONS(3670),
    [anon_sym_global] = ACTIONS(3673),
    [anon_sym_local] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3407),
    [anon_sym_RPAREN] = ACTIONS(1483),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3410),
    [anon_sym_public] = ACTIONS(3413),
    [anon_sym_import] = ACTIONS(3416),
    [anon_sym_using] = ACTIONS(3419),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(3428),
    [anon_sym_COLON2] = ACTIONS(3431),
    [anon_sym_COLON_COLON] = ACTIONS(3434),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3437),
    [anon_sym_true] = ACTIONS(3440),
    [anon_sym_false] = ACTIONS(3440),
    [aux_sym_integer_literal_token1] = ACTIONS(3443),
    [aux_sym_integer_literal_token2] = ACTIONS(3443),
    [aux_sym_integer_literal_token3] = ACTIONS(3446),
    [aux_sym_integer_literal_token4] = ACTIONS(3449),
    [aux_sym_float_literal_token1] = ACTIONS(3452),
    [aux_sym_float_literal_token3] = ACTIONS(3452),
    [aux_sym_float_literal_token4] = ACTIONS(3452),
    [sym_character_literal] = ACTIONS(3455),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3458),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3461),
    [sym__pair_operator] = ACTIONS(3464),
    [sym__arrow_operator] = ACTIONS(3467),
    [sym__lazy_or_operator] = ACTIONS(1483),
    [sym__lazy_and_operator] = ACTIONS(1483),
    [sym__comparison_operator] = ACTIONS(3467),
    [sym__pipe_right_operator] = ACTIONS(3464),
    [sym__pipe_left_operator] = ACTIONS(3464),
    [sym__ellipsis_operator] = ACTIONS(3467),
    [sym__plus_operator] = ACTIONS(3467),
    [sym__times_operator] = ACTIONS(3467),
    [sym__rational_operator] = ACTIONS(3464),
    [sym__bitshift_operator] = ACTIONS(3464),
    [sym__power_operator] = ACTIONS(3464),
    [sym__tilde_operator] = ACTIONS(3505),
    [sym__type_order_operator] = ACTIONS(3505),
    [sym__unary_operator] = ACTIONS(3508),
    [sym__unary_plus_operator] = ACTIONS(3508),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [314] = {
    [sym_open_tuple] = STATE(12902),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12577),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10446),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12473),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(314),
    [sym_line_comment] = STATE(314),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [315] = {
    [sym__expression] = STATE(9220),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(315),
    [sym_line_comment] = STATE(315),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [316] = {
    [sym_open_tuple] = STATE(8629),
    [sym_assignment] = STATE(8630),
    [sym__expression] = STATE(8632),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(316),
    [sym_line_comment] = STATE(316),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [317] = {
    [sym_open_tuple] = STATE(8646),
    [sym_assignment] = STATE(8056),
    [sym__expression] = STATE(8742),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(317),
    [sym_line_comment] = STATE(317),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1837),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(1837),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [318] = {
    [sym__block] = STATE(18858),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(318),
    [sym_line_comment] = STATE(318),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3693),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3695),
    [aux_sym__terminator_token2] = ACTIONS(3697),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [319] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(319),
    [sym_line_comment] = STATE(319),
    [aux_sym_macro_argument_list_repeat1] = STATE(313),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1353),
    [aux_sym_float_literal_token3] = ACTIONS(1353),
    [aux_sym_float_literal_token4] = ACTIONS(1353),
    [sym_character_literal] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1353),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1353),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1353),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [320] = {
    [sym_open_tuple] = STATE(12833),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12835),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10387),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12865),
    [sym_unary_expression] = STATE(12865),
    [sym_range_expression] = STATE(12865),
    [sym_splat_expression] = STATE(12865),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12478),
    [sym_unary_typed_expression] = STATE(12865),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12865),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12490),
    [sym_block_comment] = STATE(320),
    [sym_line_comment] = STATE(320),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1837),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(1837),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [321] = {
    [sym__expression] = STATE(9182),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(321),
    [sym_line_comment] = STATE(321),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [322] = {
    [sym_open_tuple] = STATE(13084),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12768),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10445),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12911),
    [sym_unary_expression] = STATE(12911),
    [sym_range_expression] = STATE(12911),
    [sym_splat_expression] = STATE(12911),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12535),
    [sym_unary_typed_expression] = STATE(12911),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12911),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12536),
    [sym_block_comment] = STATE(322),
    [sym_line_comment] = STATE(322),
    [ts_builtin_sym_end] = ACTIONS(1837),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3557),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(3559),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(75),
    [aux_sym_integer_literal_token2] = ACTIONS(75),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(3561),
    [aux_sym_float_literal_token3] = ACTIONS(3561),
    [aux_sym_float_literal_token4] = ACTIONS(3561),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(97),
    [sym__type_order_operator] = ACTIONS(97),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [323] = {
    [sym__block] = STATE(18607),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(323),
    [sym_line_comment] = STATE(323),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3707),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3709),
    [aux_sym__terminator_token2] = ACTIONS(3711),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [324] = {
    [sym__block] = STATE(19160),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(324),
    [sym_line_comment] = STATE(324),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3713),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3715),
    [aux_sym__terminator_token2] = ACTIONS(3717),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [325] = {
    [sym__expression] = STATE(8625),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(325),
    [sym_line_comment] = STATE(325),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [326] = {
    [sym__expression] = STATE(9197),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(326),
    [sym_line_comment] = STATE(326),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [327] = {
    [sym_open_tuple] = STATE(9251),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(327),
    [sym_line_comment] = STATE(327),
    [aux_sym_macro_argument_list_repeat1] = STATE(327),
    [sym__word_identifier] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_EQ] = ACTIONS(1358),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_module] = ACTIONS(3725),
    [anon_sym_baremodule] = ACTIONS(3725),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_primitive] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3734),
    [anon_sym_struct] = ACTIONS(3737),
    [anon_sym_function] = ACTIONS(3740),
    [anon_sym_macro] = ACTIONS(3743),
    [anon_sym_quote] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3749),
    [anon_sym_if] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3758),
    [anon_sym_while] = ACTIONS(3761),
    [sym_break_statement] = ACTIONS(3764),
    [sym_continue_statement] = ACTIONS(3764),
    [anon_sym_return] = ACTIONS(3767),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_global] = ACTIONS(3773),
    [anon_sym_local] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3779),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3782),
    [anon_sym_public] = ACTIONS(3785),
    [anon_sym_import] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_COLON2] = ACTIONS(3803),
    [anon_sym_COLON_COLON] = ACTIONS(3806),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3809),
    [anon_sym_true] = ACTIONS(3812),
    [anon_sym_false] = ACTIONS(3812),
    [aux_sym_integer_literal_token1] = ACTIONS(3815),
    [aux_sym_integer_literal_token2] = ACTIONS(3815),
    [aux_sym_integer_literal_token3] = ACTIONS(3818),
    [aux_sym_integer_literal_token4] = ACTIONS(3821),
    [aux_sym_float_literal_token1] = ACTIONS(3824),
    [aux_sym_float_literal_token3] = ACTIONS(3824),
    [aux_sym_float_literal_token4] = ACTIONS(3824),
    [sym_character_literal] = ACTIONS(3827),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3458),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3461),
    [sym__pair_operator] = ACTIONS(3830),
    [sym__arrow_operator] = ACTIONS(3833),
    [sym__lazy_or_operator] = ACTIONS(1483),
    [sym__lazy_and_operator] = ACTIONS(1483),
    [sym__comparison_operator] = ACTIONS(3833),
    [sym__pipe_right_operator] = ACTIONS(3830),
    [sym__pipe_left_operator] = ACTIONS(3830),
    [sym__ellipsis_operator] = ACTIONS(3833),
    [sym__plus_operator] = ACTIONS(3833),
    [sym__times_operator] = ACTIONS(3833),
    [sym__rational_operator] = ACTIONS(3830),
    [sym__bitshift_operator] = ACTIONS(3830),
    [sym__power_operator] = ACTIONS(3830),
    [sym__tilde_operator] = ACTIONS(3836),
    [sym__type_order_operator] = ACTIONS(3836),
    [sym__unary_operator] = ACTIONS(3839),
    [sym__unary_plus_operator] = ACTIONS(3839),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [328] = {
    [sym__expression] = STATE(12883),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(328),
    [sym_line_comment] = STATE(328),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [329] = {
    [sym__block] = STATE(19065),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(329),
    [sym_line_comment] = STATE(329),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3842),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3844),
    [aux_sym__terminator_token2] = ACTIONS(3846),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [330] = {
    [sym__expression] = STATE(12882),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(330),
    [sym_line_comment] = STATE(330),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3557),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(3559),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(75),
    [aux_sym_integer_literal_token2] = ACTIONS(75),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(3561),
    [aux_sym_float_literal_token3] = ACTIONS(3561),
    [aux_sym_float_literal_token4] = ACTIONS(3561),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(97),
    [sym__type_order_operator] = ACTIONS(97),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [331] = {
    [sym__expression] = STATE(13087),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(331),
    [sym_line_comment] = STATE(331),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3848),
    [sym__type_order_operator] = ACTIONS(3848),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [332] = {
    [sym__expression] = STATE(12766),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(332),
    [sym_line_comment] = STATE(332),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3301),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(3305),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3307),
    [aux_sym_integer_literal_token2] = ACTIONS(3307),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(3311),
    [aux_sym_float_literal_token3] = ACTIONS(3311),
    [aux_sym_float_literal_token4] = ACTIONS(3311),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3850),
    [sym__type_order_operator] = ACTIONS(3850),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [333] = {
    [sym_open_tuple] = STATE(12562),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12110),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10342),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12292),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(333),
    [sym_line_comment] = STATE(333),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [334] = {
    [sym__expression] = STATE(9218),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(334),
    [sym_line_comment] = STATE(334),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [335] = {
    [sym__expression] = STATE(8688),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(335),
    [sym_line_comment] = STATE(335),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(753),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(763),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(765),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(771),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(777),
    [aux_sym_integer_literal_token2] = ACTIONS(777),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(781),
    [aux_sym_float_literal_token3] = ACTIONS(781),
    [aux_sym_float_literal_token4] = ACTIONS(781),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(785),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(785),
    [sym__pipe_left_operator] = ACTIONS(785),
    [sym__ellipsis_operator] = ACTIONS(785),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(785),
    [sym__bitshift_operator] = ACTIONS(785),
    [sym__power_operator] = ACTIONS(785),
    [sym__tilde_operator] = ACTIONS(3878),
    [sym__type_order_operator] = ACTIONS(3878),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [336] = {
    [sym__expression] = STATE(9199),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(336),
    [sym_line_comment] = STATE(336),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [337] = {
    [sym_open_tuple] = STATE(8980),
    [sym_assignment] = STATE(8056),
    [sym__expression] = STATE(8814),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(337),
    [sym_line_comment] = STATE(337),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [338] = {
    [sym__expression] = STATE(9172),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(338),
    [sym_line_comment] = STATE(338),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [339] = {
    [sym_open_tuple] = STATE(12733),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12113),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10314),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12019),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(339),
    [sym_line_comment] = STATE(339),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1837),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [340] = {
    [sym__expression] = STATE(9221),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(340),
    [sym_line_comment] = STATE(340),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [341] = {
    [sym__expression] = STATE(8736),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(341),
    [sym_line_comment] = STATE(341),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [342] = {
    [sym__expression] = STATE(8703),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(342),
    [sym_line_comment] = STATE(342),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(575),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(585),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(587),
    [anon_sym_DOLLAR] = ACTIONS(589),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(593),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(599),
    [aux_sym_integer_literal_token2] = ACTIONS(599),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(603),
    [aux_sym_float_literal_token3] = ACTIONS(603),
    [aux_sym_float_literal_token4] = ACTIONS(603),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(607),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(607),
    [sym__pipe_left_operator] = ACTIONS(607),
    [sym__ellipsis_operator] = ACTIONS(607),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(607),
    [sym__bitshift_operator] = ACTIONS(607),
    [sym__power_operator] = ACTIONS(607),
    [sym__tilde_operator] = ACTIONS(3892),
    [sym__type_order_operator] = ACTIONS(3892),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [343] = {
    [sym__expression] = STATE(9217),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(343),
    [sym_line_comment] = STATE(343),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [344] = {
    [sym__expression] = STATE(9179),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(344),
    [sym_line_comment] = STATE(344),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [345] = {
    [sym__expression] = STATE(12816),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(345),
    [sym_line_comment] = STATE(345),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(3337),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3339),
    [aux_sym_integer_literal_token2] = ACTIONS(3339),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(3343),
    [aux_sym_float_literal_token3] = ACTIONS(3343),
    [aux_sym_float_literal_token4] = ACTIONS(3343),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3894),
    [sym__type_order_operator] = ACTIONS(3894),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [346] = {
    [sym_open_tuple] = STATE(12863),
    [sym_assignment] = STATE(11567),
    [sym__expression] = STATE(12866),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10499),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12915),
    [sym_unary_expression] = STATE(12915),
    [sym_range_expression] = STATE(12915),
    [sym_splat_expression] = STATE(12915),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12548),
    [sym_unary_typed_expression] = STATE(12915),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12915),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12551),
    [sym_block_comment] = STATE(346),
    [sym_line_comment] = STATE(346),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1835),
    [anon_sym_QMARK] = ACTIONS(1835),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(1835),
    [sym__lazy_and_operator] = ACTIONS(1835),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(1837),
    [aux_sym__terminator_token2] = ACTIONS(1835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [347] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(347),
    [sym_line_comment] = STATE(347),
    [aux_sym_macro_argument_list_repeat1] = STATE(266),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [348] = {
    [sym__expression] = STATE(8737),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(348),
    [sym_line_comment] = STATE(348),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [349] = {
    [sym_open_tuple] = STATE(9251),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(349),
    [sym_line_comment] = STATE(349),
    [aux_sym_macro_argument_list_repeat1] = STATE(327),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [350] = {
    [sym_open_tuple] = STATE(13237),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12961),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10600),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12769),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(350),
    [sym_line_comment] = STATE(350),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [351] = {
    [sym__expression] = STATE(8711),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(351),
    [sym_line_comment] = STATE(351),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(503),
    [anon_sym_DOLLAR] = ACTIONS(505),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(509),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(515),
    [aux_sym_integer_literal_token2] = ACTIONS(515),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(519),
    [aux_sym_float_literal_token3] = ACTIONS(519),
    [aux_sym_float_literal_token4] = ACTIONS(519),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(523),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(523),
    [sym__pipe_left_operator] = ACTIONS(523),
    [sym__ellipsis_operator] = ACTIONS(523),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(523),
    [sym__bitshift_operator] = ACTIONS(523),
    [sym__power_operator] = ACTIONS(523),
    [sym__tilde_operator] = ACTIONS(3908),
    [sym__type_order_operator] = ACTIONS(3908),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [352] = {
    [sym__block] = STATE(18307),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(352),
    [sym_line_comment] = STATE(352),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3910),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3912),
    [aux_sym__terminator_token2] = ACTIONS(3914),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [353] = {
    [sym__block] = STATE(18523),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(353),
    [sym_line_comment] = STATE(353),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3916),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3918),
    [aux_sym__terminator_token2] = ACTIONS(3920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [354] = {
    [sym__block] = STATE(18467),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(354),
    [sym_line_comment] = STATE(354),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3922),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3924),
    [aux_sym__terminator_token2] = ACTIONS(3926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [355] = {
    [sym__expression] = STATE(8787),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(355),
    [sym_line_comment] = STATE(355),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(3928),
    [sym__type_order_operator] = ACTIONS(3928),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [356] = {
    [sym_open_tuple] = STATE(9251),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9056),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(356),
    [sym_line_comment] = STATE(356),
    [aux_sym_macro_argument_list_repeat1] = STATE(327),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1353),
    [aux_sym_float_literal_token3] = ACTIONS(1353),
    [aux_sym_float_literal_token4] = ACTIONS(1353),
    [sym_character_literal] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1353),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1353),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1353),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [357] = {
    [sym__expression] = STATE(8628),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(357),
    [sym_line_comment] = STATE(357),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [358] = {
    [sym__expression] = STATE(8622),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(358),
    [sym_line_comment] = STATE(358),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_DOLLAR] = ACTIONS(393),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(397),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(403),
    [aux_sym_integer_literal_token2] = ACTIONS(403),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(407),
    [aux_sym_float_literal_token3] = ACTIONS(407),
    [aux_sym_float_literal_token4] = ACTIONS(407),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(411),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(411),
    [sym__pipe_left_operator] = ACTIONS(411),
    [sym__ellipsis_operator] = ACTIONS(411),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(411),
    [sym__bitshift_operator] = ACTIONS(411),
    [sym__power_operator] = ACTIONS(411),
    [sym__tilde_operator] = ACTIONS(3073),
    [sym__type_order_operator] = ACTIONS(3073),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [359] = {
    [sym__block] = STATE(19303),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(359),
    [sym_line_comment] = STATE(359),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3930),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3932),
    [aux_sym__terminator_token2] = ACTIONS(3934),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [360] = {
    [sym__block] = STATE(19414),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(360),
    [sym_line_comment] = STATE(360),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3936),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3938),
    [aux_sym__terminator_token2] = ACTIONS(3940),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [361] = {
    [sym__expression] = STATE(9174),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(361),
    [sym_line_comment] = STATE(361),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [362] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(362),
    [sym_line_comment] = STATE(362),
    [aux_sym_macro_argument_list_repeat1] = STATE(313),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [363] = {
    [sym_open_tuple] = STATE(8975),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(9009),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(363),
    [sym_line_comment] = STATE(363),
    [aux_sym_macro_argument_list_repeat1] = STATE(313),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [364] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(364),
    [sym_line_comment] = STATE(364),
    [aux_sym_macro_argument_list_repeat1] = STATE(301),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [365] = {
    [sym__block] = STATE(19254),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(365),
    [sym_line_comment] = STATE(365),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3942),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3944),
    [aux_sym__terminator_token2] = ACTIONS(3946),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [366] = {
    [sym__expression] = STATE(8675),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(366),
    [sym_line_comment] = STATE(366),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(993),
    [sym__type_order_operator] = ACTIONS(993),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [367] = {
    [sym__expression] = STATE(13002),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(367),
    [sym_line_comment] = STATE(367),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [368] = {
    [sym__block] = STATE(18971),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(368),
    [sym_line_comment] = STATE(368),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3948),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(3625),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(3633),
    [sym__arrow_operator] = ACTIONS(3635),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3641),
    [sym__pipe_right_operator] = ACTIONS(3643),
    [sym__pipe_left_operator] = ACTIONS(3645),
    [sym__ellipsis_operator] = ACTIONS(3647),
    [sym__plus_operator] = ACTIONS(3649),
    [sym__times_operator] = ACTIONS(3651),
    [sym__rational_operator] = ACTIONS(3653),
    [sym__bitshift_operator] = ACTIONS(3655),
    [sym__power_operator] = ACTIONS(3657),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(3659),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(3661),
    [aux_sym__terminator_token1] = ACTIONS(3950),
    [aux_sym__terminator_token2] = ACTIONS(3952),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [369] = {
    [sym_open_tuple] = STATE(12454),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12644),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10293),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12413),
    [sym_unary_expression] = STATE(12413),
    [sym_range_expression] = STATE(12413),
    [sym_splat_expression] = STATE(12413),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12037),
    [sym_unary_typed_expression] = STATE(12413),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12413),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12234),
    [sym_block_comment] = STATE(369),
    [sym_line_comment] = STATE(369),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1837),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [370] = {
    [sym_open_tuple] = STATE(13004),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(13005),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10469),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12909),
    [sym_unary_expression] = STATE(12909),
    [sym_range_expression] = STATE(12909),
    [sym_splat_expression] = STATE(12909),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(12909),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12909),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12508),
    [sym_block_comment] = STATE(370),
    [sym_line_comment] = STATE(370),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [371] = {
    [sym__expression] = STATE(13033),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(371),
    [sym_line_comment] = STATE(371),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [372] = {
    [sym_open_tuple] = STATE(13465),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(13157),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10690),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13134),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(372),
    [sym_line_comment] = STATE(372),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [373] = {
    [sym_open_tuple] = STATE(9105),
    [sym_assignment] = STATE(8056),
    [sym__expression] = STATE(9098),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(373),
    [sym_line_comment] = STATE(373),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [374] = {
    [sym__expression] = STATE(9135),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(374),
    [sym_line_comment] = STATE(374),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [375] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(375),
    [sym_line_comment] = STATE(375),
    [aux_sym_macro_argument_list_repeat1] = STATE(266),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [376] = {
    [sym_open_tuple] = STATE(9255),
    [sym_assignment] = STATE(9148),
    [sym__expression] = STATE(9059),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(376),
    [sym_line_comment] = STATE(376),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [377] = {
    [sym_open_tuple] = STATE(13170),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12957),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10610),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12777),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(377),
    [sym_line_comment] = STATE(377),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [378] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(378),
    [sym_line_comment] = STATE(378),
    [aux_sym_macro_argument_list_repeat1] = STATE(301),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [379] = {
    [sym_open_tuple] = STATE(9298),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(379),
    [sym_line_comment] = STATE(379),
    [aux_sym_macro_argument_list_repeat1] = STATE(386),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [380] = {
    [sym_open_tuple] = STATE(13234),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(13432),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10665),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13278),
    [sym_unary_expression] = STATE(13278),
    [sym_range_expression] = STATE(13278),
    [sym_splat_expression] = STATE(13278),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12832),
    [sym_unary_typed_expression] = STATE(13278),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13278),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12805),
    [sym_block_comment] = STATE(380),
    [sym_line_comment] = STATE(380),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [381] = {
    [sym__expression] = STATE(13238),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(381),
    [sym_line_comment] = STATE(381),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [382] = {
    [sym_open_tuple] = STATE(12643),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12450),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10370),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12749),
    [sym_unary_expression] = STATE(12749),
    [sym_range_expression] = STATE(12749),
    [sym_splat_expression] = STATE(12749),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12236),
    [sym_unary_typed_expression] = STATE(12749),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12749),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12218),
    [sym_block_comment] = STATE(382),
    [sym_line_comment] = STATE(382),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_SEMI] = ACTIONS(1837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [383] = {
    [sym_open_tuple] = STATE(9298),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(383),
    [sym_line_comment] = STATE(383),
    [aux_sym_macro_argument_list_repeat1] = STATE(386),
    [sym__word_identifier] = ACTIONS(1351),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(1351),
    [anon_sym_module] = ACTIONS(1351),
    [anon_sym_baremodule] = ACTIONS(1351),
    [anon_sym_end] = ACTIONS(1351),
    [anon_sym_abstract] = ACTIONS(1351),
    [anon_sym_primitive] = ACTIONS(1351),
    [anon_sym_mutable] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_function] = ACTIONS(1351),
    [anon_sym_macro] = ACTIONS(1351),
    [anon_sym_quote] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_try] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [sym_break_statement] = ACTIONS(1351),
    [sym_continue_statement] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_global] = ACTIONS(1351),
    [anon_sym_local] = ACTIONS(1351),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(1351),
    [anon_sym_public] = ACTIONS(1351),
    [anon_sym_import] = ACTIONS(1351),
    [anon_sym_using] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_DOLLAR] = ACTIONS(1353),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(1353),
    [aux_sym_float_literal_token3] = ACTIONS(1353),
    [aux_sym_float_literal_token4] = ACTIONS(1353),
    [sym_character_literal] = ACTIONS(1353),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1353),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(1353),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(1353),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(1351),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [384] = {
    [sym__expression] = STATE(9138),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(384),
    [sym_line_comment] = STATE(384),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [385] = {
    [sym__expression] = STATE(13269),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(385),
    [sym_line_comment] = STATE(385),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3557),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(3559),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(75),
    [aux_sym_integer_literal_token2] = ACTIONS(75),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(3561),
    [aux_sym_float_literal_token3] = ACTIONS(3561),
    [aux_sym_float_literal_token4] = ACTIONS(3561),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(4028),
    [sym__type_order_operator] = ACTIONS(4028),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [386] = {
    [sym_open_tuple] = STATE(9298),
    [sym_assignment] = STATE(9299),
    [sym__expression] = STATE(9300),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(386),
    [sym_line_comment] = STATE(386),
    [aux_sym_macro_argument_list_repeat1] = STATE(386),
    [sym__word_identifier] = ACTIONS(3719),
    [anon_sym_COMMA] = ACTIONS(1483),
    [anon_sym_begin] = ACTIONS(3722),
    [anon_sym_module] = ACTIONS(3725),
    [anon_sym_baremodule] = ACTIONS(3725),
    [anon_sym_end] = ACTIONS(1358),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_primitive] = ACTIONS(3731),
    [anon_sym_mutable] = ACTIONS(3734),
    [anon_sym_struct] = ACTIONS(3737),
    [anon_sym_function] = ACTIONS(3740),
    [anon_sym_macro] = ACTIONS(3743),
    [anon_sym_quote] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3749),
    [anon_sym_if] = ACTIONS(3752),
    [anon_sym_try] = ACTIONS(3755),
    [anon_sym_for] = ACTIONS(3758),
    [anon_sym_while] = ACTIONS(3761),
    [sym_break_statement] = ACTIONS(3764),
    [sym_continue_statement] = ACTIONS(3764),
    [anon_sym_return] = ACTIONS(4030),
    [anon_sym_const] = ACTIONS(4033),
    [anon_sym_global] = ACTIONS(4036),
    [anon_sym_local] = ACTIONS(4039),
    [anon_sym_LPAREN] = ACTIONS(3779),
    [anon_sym_COLON] = ACTIONS(1358),
    [anon_sym_export] = ACTIONS(3782),
    [anon_sym_public] = ACTIONS(3785),
    [anon_sym_import] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3791),
    [anon_sym_LBRACK] = ACTIONS(3794),
    [anon_sym_in] = ACTIONS(1358),
    [anon_sym_LBRACE] = ACTIONS(3797),
    [anon_sym_DOLLAR] = ACTIONS(3800),
    [anon_sym_COLON2] = ACTIONS(3803),
    [anon_sym_COLON_COLON] = ACTIONS(3806),
    [anon_sym_isa] = ACTIONS(1358),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1483),
    [anon_sym_QMARK] = ACTIONS(1483),
    [anon_sym_where] = ACTIONS(1358),
    [anon_sym_AT] = ACTIONS(3809),
    [anon_sym_true] = ACTIONS(3812),
    [anon_sym_false] = ACTIONS(3812),
    [aux_sym_integer_literal_token1] = ACTIONS(3815),
    [aux_sym_integer_literal_token2] = ACTIONS(3815),
    [aux_sym_integer_literal_token3] = ACTIONS(3818),
    [aux_sym_integer_literal_token4] = ACTIONS(3821),
    [aux_sym_float_literal_token1] = ACTIONS(3824),
    [aux_sym_float_literal_token3] = ACTIONS(3824),
    [aux_sym_float_literal_token4] = ACTIONS(3824),
    [sym_character_literal] = ACTIONS(3827),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3458),
    [anon_sym_BQUOTE] = ACTIONS(1471),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3461),
    [sym__pair_operator] = ACTIONS(3830),
    [sym__arrow_operator] = ACTIONS(3833),
    [sym__lazy_or_operator] = ACTIONS(1483),
    [sym__lazy_and_operator] = ACTIONS(1483),
    [sym__comparison_operator] = ACTIONS(3833),
    [sym__pipe_right_operator] = ACTIONS(3830),
    [sym__pipe_left_operator] = ACTIONS(3830),
    [sym__ellipsis_operator] = ACTIONS(3833),
    [sym__plus_operator] = ACTIONS(3833),
    [sym__times_operator] = ACTIONS(3833),
    [sym__rational_operator] = ACTIONS(3830),
    [sym__bitshift_operator] = ACTIONS(3830),
    [sym__power_operator] = ACTIONS(3830),
    [sym__tilde_operator] = ACTIONS(3836),
    [sym__type_order_operator] = ACTIONS(3836),
    [sym__unary_operator] = ACTIONS(3839),
    [sym__unary_plus_operator] = ACTIONS(3839),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [387] = {
    [sym_open_tuple] = STATE(8659),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8486),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(387),
    [sym_line_comment] = STATE(387),
    [aux_sym_macro_argument_list_repeat1] = STATE(266),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_EQ] = ACTIONS(1351),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [388] = {
    [sym__expression] = STATE(13195),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(388),
    [sym_line_comment] = STATE(388),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(4042),
    [sym__type_order_operator] = ACTIONS(4042),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [389] = {
    [sym__expression] = STATE(12728),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(389),
    [sym_line_comment] = STATE(389),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [390] = {
    [sym__expression] = STATE(12730),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(390),
    [sym_line_comment] = STATE(390),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [391] = {
    [sym__expression] = STATE(13313),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(391),
    [sym_line_comment] = STATE(391),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [392] = {
    [sym__expression] = STATE(9052),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(392),
    [sym_line_comment] = STATE(392),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(4048),
    [sym__type_order_operator] = ACTIONS(4048),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [393] = {
    [sym__expression] = STATE(9139),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(393),
    [sym_line_comment] = STATE(393),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(4050),
    [sym__type_order_operator] = ACTIONS(4050),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [394] = {
    [sym__expression] = STATE(8997),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(394),
    [sym_line_comment] = STATE(394),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(4052),
    [sym__type_order_operator] = ACTIONS(4052),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [395] = {
    [sym__expression] = STATE(13052),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(395),
    [sym_line_comment] = STATE(395),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [396] = {
    [sym__expression] = STATE(9291),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(396),
    [sym_line_comment] = STATE(396),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(4058),
    [sym__type_order_operator] = ACTIONS(4058),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [397] = {
    [sym_open_tuple] = STATE(13757),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(13656),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10787),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13581),
    [sym_unary_expression] = STATE(13581),
    [sym_range_expression] = STATE(13581),
    [sym_splat_expression] = STATE(13581),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13365),
    [sym_unary_typed_expression] = STATE(13581),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13581),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13282),
    [sym_block_comment] = STATE(397),
    [sym_line_comment] = STATE(397),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [398] = {
    [sym_open_tuple] = STATE(9259),
    [sym_assignment] = STATE(9148),
    [sym__expression] = STATE(9149),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(398),
    [sym_line_comment] = STATE(398),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(1835),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [399] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(399),
    [sym_line_comment] = STATE(399),
    [aux_sym_macro_argument_list_repeat1] = STATE(301),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(1353),
    [aux_sym_integer_literal_token2] = ACTIONS(1353),
    [aux_sym_integer_literal_token3] = ACTIONS(1351),
    [aux_sym_integer_literal_token4] = ACTIONS(1351),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [400] = {
    [sym__expression] = STATE(9171),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(400),
    [sym_line_comment] = STATE(400),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [401] = {
    [sym__expression] = STATE(13670),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(401),
    [sym_line_comment] = STATE(401),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [402] = {
    [sym_open_tuple] = STATE(8647),
    [sym_assignment] = STATE(8284),
    [sym__expression] = STATE(8653),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(402),
    [sym_line_comment] = STATE(402),
    [aux_sym_macro_argument_list_repeat1] = STATE(301),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(1353),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_COLON] = ACTIONS(1351),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(1351),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_isa] = ACTIONS(1351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1353),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_where] = ACTIONS(1351),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1353),
    [sym__arrow_operator] = ACTIONS(1351),
    [sym__lazy_or_operator] = ACTIONS(1353),
    [sym__lazy_and_operator] = ACTIONS(1353),
    [sym__comparison_operator] = ACTIONS(1351),
    [sym__pipe_right_operator] = ACTIONS(1353),
    [sym__pipe_left_operator] = ACTIONS(1353),
    [sym__ellipsis_operator] = ACTIONS(1351),
    [sym__plus_operator] = ACTIONS(1351),
    [sym__times_operator] = ACTIONS(1351),
    [sym__rational_operator] = ACTIONS(1353),
    [sym__bitshift_operator] = ACTIONS(1353),
    [sym__power_operator] = ACTIONS(1353),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(1353),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(1351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [403] = {
    [sym__expression] = STATE(13189),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(403),
    [sym_line_comment] = STATE(403),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [404] = {
    [sym_open_tuple] = STATE(13347),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(13178),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10616),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13400),
    [sym_unary_expression] = STATE(13400),
    [sym_range_expression] = STATE(13400),
    [sym_splat_expression] = STATE(13400),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12922),
    [sym_unary_typed_expression] = STATE(13400),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13400),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13114),
    [sym_block_comment] = STATE(404),
    [sym_line_comment] = STATE(404),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1837),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [405] = {
    [sym_open_tuple] = STATE(13694),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(13166),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10722),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13293),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(405),
    [sym_line_comment] = STATE(405),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [406] = {
    [sym__expression] = STATE(9224),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(406),
    [sym_line_comment] = STATE(406),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(961),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(971),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_DOLLAR] = ACTIONS(975),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(979),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(983),
    [aux_sym_integer_literal_token2] = ACTIONS(983),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(987),
    [aux_sym_float_literal_token3] = ACTIONS(987),
    [aux_sym_float_literal_token4] = ACTIONS(987),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(991),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(991),
    [sym__pipe_left_operator] = ACTIONS(991),
    [sym__ellipsis_operator] = ACTIONS(991),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(991),
    [sym__bitshift_operator] = ACTIONS(991),
    [sym__power_operator] = ACTIONS(991),
    [sym__tilde_operator] = ACTIONS(3691),
    [sym__type_order_operator] = ACTIONS(3691),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [407] = {
    [sym__expression] = STATE(9265),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(407),
    [sym_line_comment] = STATE(407),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(895),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [408] = {
    [sym__expression] = STATE(13050),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(408),
    [sym_line_comment] = STATE(408),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [409] = {
    [sym_open_tuple] = STATE(12607),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12161),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10247),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12080),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(409),
    [sym_line_comment] = STATE(409),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [410] = {
    [sym__expression] = STATE(13855),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(410),
    [sym_line_comment] = STATE(410),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [411] = {
    [sym__expression] = STATE(13353),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(411),
    [sym_line_comment] = STATE(411),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [412] = {
    [sym__expression] = STATE(13363),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(412),
    [sym_line_comment] = STATE(412),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [413] = {
    [sym__expression] = STATE(13106),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(413),
    [sym_line_comment] = STATE(413),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [414] = {
    [sym__expression] = STATE(13108),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(414),
    [sym_line_comment] = STATE(414),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [415] = {
    [sym__expression] = STATE(13661),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(415),
    [sym_line_comment] = STATE(415),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [416] = {
    [sym__expression] = STATE(13335),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(416),
    [sym_line_comment] = STATE(416),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [417] = {
    [sym__expression] = STATE(13299),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(417),
    [sym_line_comment] = STATE(417),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [418] = {
    [sym_open_tuple] = STATE(13676),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(13614),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10703),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13698),
    [sym_unary_expression] = STATE(13698),
    [sym_range_expression] = STATE(13698),
    [sym_splat_expression] = STATE(13698),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13344),
    [sym_unary_typed_expression] = STATE(13698),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13698),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13361),
    [sym_block_comment] = STATE(418),
    [sym_line_comment] = STATE(418),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [419] = {
    [sym__expression] = STATE(13679),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(419),
    [sym_line_comment] = STATE(419),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [420] = {
    [sym_open_tuple] = STATE(12507),
    [sym_assignment] = STATE(10798),
    [sym__expression] = STATE(12409),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10254),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12738),
    [sym_unary_expression] = STATE(12738),
    [sym_range_expression] = STATE(12738),
    [sym_splat_expression] = STATE(12738),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12175),
    [sym_unary_typed_expression] = STATE(12738),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12738),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12016),
    [sym_block_comment] = STATE(420),
    [sym_line_comment] = STATE(420),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1837),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(1835),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(1835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1837),
    [anon_sym_QMARK] = ACTIONS(1837),
    [anon_sym_where] = ACTIONS(1835),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(1837),
    [sym__lazy_and_operator] = ACTIONS(1837),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [421] = {
    [sym__expression] = STATE(12726),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(421),
    [sym_line_comment] = STATE(421),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [422] = {
    [sym__expression] = STATE(14083),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(422),
    [sym_line_comment] = STATE(422),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [423] = {
    [sym__expression] = STATE(14031),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(423),
    [sym_line_comment] = STATE(423),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [424] = {
    [sym__expression] = STATE(13840),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(424),
    [sym_line_comment] = STATE(424),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [425] = {
    [sym__expression] = STATE(14087),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(425),
    [sym_line_comment] = STATE(425),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [426] = {
    [sym__expression] = STATE(9328),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(426),
    [sym_line_comment] = STATE(426),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1317),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [427] = {
    [sym__expression] = STATE(14228),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(427),
    [sym_line_comment] = STATE(427),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [428] = {
    [sym__expression] = STATE(14147),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(428),
    [sym_line_comment] = STATE(428),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [429] = {
    [sym__expression] = STATE(13990),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(429),
    [sym_line_comment] = STATE(429),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [430] = {
    [sym__expression] = STATE(13054),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(430),
    [sym_line_comment] = STATE(430),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [431] = {
    [sym__expression] = STATE(13112),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(431),
    [sym_line_comment] = STATE(431),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [432] = {
    [sym__expression] = STATE(13358),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(432),
    [sym_line_comment] = STATE(432),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [433] = {
    [sym__block] = STATE(14710),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18683),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(433),
    [sym_line_comment] = STATE(433),
    [aux_sym_if_statement_repeat1] = STATE(14711),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4200),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [434] = {
    [sym__block] = STATE(15040),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18273),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(434),
    [sym_line_comment] = STATE(434),
    [aux_sym_if_statement_repeat1] = STATE(15042),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4216),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [435] = {
    [sym__block] = STATE(14931),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19228),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(435),
    [sym_line_comment] = STATE(435),
    [aux_sym_if_statement_repeat1] = STATE(14932),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4218),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [436] = {
    [sym__block] = STATE(14286),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18428),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(436),
    [sym_line_comment] = STATE(436),
    [aux_sym_if_statement_repeat1] = STATE(14289),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4220),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [437] = {
    [sym__block] = STATE(14510),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18628),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(437),
    [sym_line_comment] = STATE(437),
    [aux_sym_if_statement_repeat1] = STATE(14511),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4222),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [438] = {
    [sym__block] = STATE(16181),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15254),
    [sym_finally_clause] = STATE(17391),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(438),
    [sym_line_comment] = STATE(438),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4228),
    [aux_sym__terminator_token2] = ACTIONS(4230),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [439] = {
    [sym__block] = STATE(16205),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15289),
    [sym_finally_clause] = STATE(17420),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(439),
    [sym_line_comment] = STATE(439),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4232),
    [aux_sym__terminator_token2] = ACTIONS(4234),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [440] = {
    [sym__block] = STATE(16220),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15322),
    [sym_finally_clause] = STATE(17524),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(440),
    [sym_line_comment] = STATE(440),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4236),
    [aux_sym__terminator_token2] = ACTIONS(4238),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [441] = {
    [sym__block] = STATE(16238),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15239),
    [sym_finally_clause] = STATE(17124),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(441),
    [sym_line_comment] = STATE(441),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4240),
    [aux_sym__terminator_token2] = ACTIONS(4242),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [442] = {
    [sym__block] = STATE(16256),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15147),
    [sym_finally_clause] = STATE(17348),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(442),
    [sym_line_comment] = STATE(442),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4244),
    [aux_sym__terminator_token2] = ACTIONS(4246),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [443] = {
    [sym__block] = STATE(16269),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15221),
    [sym_finally_clause] = STATE(17579),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(443),
    [sym_line_comment] = STATE(443),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4248),
    [aux_sym__terminator_token2] = ACTIONS(4250),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [444] = {
    [sym__block] = STATE(16284),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15129),
    [sym_finally_clause] = STATE(17609),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(444),
    [sym_line_comment] = STATE(444),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4252),
    [aux_sym__terminator_token2] = ACTIONS(4254),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [445] = {
    [sym__block] = STATE(16322),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15295),
    [sym_finally_clause] = STATE(17595),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(445),
    [sym_line_comment] = STATE(445),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4256),
    [aux_sym__terminator_token2] = ACTIONS(4258),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [446] = {
    [sym__block] = STATE(16299),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15325),
    [sym_finally_clause] = STATE(17412),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(446),
    [sym_line_comment] = STATE(446),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4260),
    [aux_sym__terminator_token2] = ACTIONS(4262),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [447] = {
    [sym__block] = STATE(16311),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15226),
    [sym_finally_clause] = STATE(17443),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(447),
    [sym_line_comment] = STATE(447),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4264),
    [aux_sym__terminator_token2] = ACTIONS(4266),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [448] = {
    [sym__block] = STATE(14703),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18396),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(448),
    [sym_line_comment] = STATE(448),
    [aux_sym_if_statement_repeat1] = STATE(14707),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4268),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [449] = {
    [sym__block] = STATE(14721),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(19052),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(449),
    [sym_line_comment] = STATE(449),
    [aux_sym_if_statement_repeat1] = STATE(14995),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4270),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [450] = {
    [sym__block] = STATE(15048),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18751),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(450),
    [sym_line_comment] = STATE(450),
    [aux_sym_if_statement_repeat1] = STATE(14339),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4272),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [451] = {
    [sym__block] = STATE(14577),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18278),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(451),
    [sym_line_comment] = STATE(451),
    [aux_sym_if_statement_repeat1] = STATE(14579),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4274),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [452] = {
    [sym__block] = STATE(14887),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18312),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(452),
    [sym_line_comment] = STATE(452),
    [aux_sym_if_statement_repeat1] = STATE(14946),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4276),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [453] = {
    [sym__block] = STATE(15067),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18961),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(453),
    [sym_line_comment] = STATE(453),
    [aux_sym_if_statement_repeat1] = STATE(15074),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4278),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [454] = {
    [sym__block] = STATE(14467),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_elseif_clause] = STATE(17123),
    [sym_else_clause] = STATE(18915),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(454),
    [sym_line_comment] = STATE(454),
    [aux_sym_if_statement_repeat1] = STATE(14474),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4280),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(1069),
    [anon_sym_else] = ACTIONS(1071),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [455] = {
    [sym__block] = STATE(16050),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15299),
    [sym_finally_clause] = STATE(17092),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(455),
    [sym_line_comment] = STATE(455),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4282),
    [aux_sym__terminator_token2] = ACTIONS(4284),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [456] = {
    [sym__block] = STATE(16846),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15136),
    [sym_finally_clause] = STATE(17496),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(456),
    [sym_line_comment] = STATE(456),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3107),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(3111),
    [anon_sym_AT] = ACTIONS(773),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3113),
    [aux_sym_integer_literal_token2] = ACTIONS(3113),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(3117),
    [aux_sym_float_literal_token3] = ACTIONS(3117),
    [aux_sym_float_literal_token4] = ACTIONS(3117),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3119),
    [sym__type_order_operator] = ACTIONS(3119),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym__terminator_token1] = ACTIONS(4286),
    [aux_sym__terminator_token2] = ACTIONS(4288),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [457] = {
    [sym__block] = STATE(18454),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(457),
    [sym_line_comment] = STATE(457),
    [aux_sym_for_statement_repeat1] = STATE(466),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4292),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4294),
    [aux_sym__terminator_token2] = ACTIONS(4296),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [458] = {
    [sym__block] = STATE(18298),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(458),
    [sym_line_comment] = STATE(458),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4298),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4300),
    [aux_sym__terminator_token2] = ACTIONS(4302),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [459] = {
    [sym__block] = STATE(18473),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(459),
    [sym_line_comment] = STATE(459),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4304),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4306),
    [aux_sym__terminator_token2] = ACTIONS(4308),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [460] = {
    [sym__block] = STATE(18375),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(460),
    [sym_line_comment] = STATE(460),
    [aux_sym_for_statement_repeat1] = STATE(481),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4310),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4312),
    [aux_sym__terminator_token2] = ACTIONS(4314),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [461] = {
    [sym__block] = STATE(19214),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(461),
    [sym_line_comment] = STATE(461),
    [aux_sym_for_statement_repeat1] = STATE(465),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4316),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4318),
    [aux_sym__terminator_token2] = ACTIONS(4320),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [462] = {
    [sym__block] = STATE(19306),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(462),
    [sym_line_comment] = STATE(462),
    [aux_sym_for_statement_repeat1] = STATE(474),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4322),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4324),
    [aux_sym__terminator_token2] = ACTIONS(4326),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [463] = {
    [sym__block] = STATE(19162),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(463),
    [sym_line_comment] = STATE(463),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4328),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4330),
    [aux_sym__terminator_token2] = ACTIONS(4332),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [464] = {
    [sym__block] = STATE(19382),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(464),
    [sym_line_comment] = STATE(464),
    [aux_sym_for_statement_repeat1] = STATE(467),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4334),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4336),
    [aux_sym__terminator_token2] = ACTIONS(4338),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [465] = {
    [sym__block] = STATE(19261),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(465),
    [sym_line_comment] = STATE(465),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4340),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4342),
    [aux_sym__terminator_token2] = ACTIONS(4344),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [466] = {
    [sym__block] = STATE(18325),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(466),
    [sym_line_comment] = STATE(466),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4348),
    [aux_sym__terminator_token2] = ACTIONS(4350),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [467] = {
    [sym__block] = STATE(18708),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(467),
    [sym_line_comment] = STATE(467),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4352),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4354),
    [aux_sym__terminator_token2] = ACTIONS(4356),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [468] = {
    [sym__block] = STATE(18845),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(468),
    [sym_line_comment] = STATE(468),
    [aux_sym_for_statement_repeat1] = STATE(463),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4358),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4360),
    [aux_sym__terminator_token2] = ACTIONS(4362),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [469] = {
    [sym__block] = STATE(18604),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(469),
    [sym_line_comment] = STATE(469),
    [aux_sym_for_statement_repeat1] = STATE(479),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4364),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4366),
    [aux_sym__terminator_token2] = ACTIONS(4368),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [470] = {
    [sym__block] = STATE(18986),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(470),
    [sym_line_comment] = STATE(470),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4370),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4372),
    [aux_sym__terminator_token2] = ACTIONS(4374),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [471] = {
    [sym__block] = STATE(18334),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(471),
    [sym_line_comment] = STATE(471),
    [aux_sym_for_statement_repeat1] = STATE(475),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4376),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4378),
    [aux_sym__terminator_token2] = ACTIONS(4380),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [472] = {
    [sym__block] = STATE(19026),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(472),
    [sym_line_comment] = STATE(472),
    [aux_sym_for_statement_repeat1] = STATE(459),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4382),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4384),
    [aux_sym__terminator_token2] = ACTIONS(4386),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [473] = {
    [sym__block] = STATE(19235),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(473),
    [sym_line_comment] = STATE(473),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4388),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4390),
    [aux_sym__terminator_token2] = ACTIONS(4392),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [474] = {
    [sym__block] = STATE(18926),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(474),
    [sym_line_comment] = STATE(474),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4394),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4396),
    [aux_sym__terminator_token2] = ACTIONS(4398),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [475] = {
    [sym__block] = STATE(19291),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(475),
    [sym_line_comment] = STATE(475),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4400),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4402),
    [aux_sym__terminator_token2] = ACTIONS(4404),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [476] = {
    [sym__block] = STATE(19488),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(476),
    [sym_line_comment] = STATE(476),
    [aux_sym_for_statement_repeat1] = STATE(470),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4406),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4408),
    [aux_sym__terminator_token2] = ACTIONS(4410),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [477] = {
    [sym__block] = STATE(17165),
    [sym_open_tuple] = STATE(14274),
    [sym_assignment] = STATE(14810),
    [sym__expression] = STATE(11938),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(2),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(477),
    [sym_line_comment] = STATE(477),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(4412),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(4412),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(4412),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(143),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(155),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(161),
    [anon_sym_AT] = ACTIONS(165),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(169),
    [aux_sym_integer_literal_token2] = ACTIONS(169),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(173),
    [aux_sym_float_literal_token3] = ACTIONS(173),
    [aux_sym_float_literal_token4] = ACTIONS(173),
    [sym_character_literal] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(181),
    [sym__type_order_operator] = ACTIONS(181),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym__terminator_token1] = ACTIONS(4414),
    [aux_sym__terminator_token2] = ACTIONS(4416),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [478] = {
    [sym__block] = STATE(19144),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(478),
    [sym_line_comment] = STATE(478),
    [aux_sym_for_statement_repeat1] = STATE(473),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4418),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4420),
    [aux_sym__terminator_token2] = ACTIONS(4422),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [479] = {
    [sym__block] = STATE(18690),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(479),
    [sym_line_comment] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4424),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4426),
    [aux_sym__terminator_token2] = ACTIONS(4428),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [480] = {
    [sym__block] = STATE(19215),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(480),
    [sym_line_comment] = STATE(480),
    [aux_sym_for_statement_repeat1] = STATE(458),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4430),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4432),
    [aux_sym__terminator_token2] = ACTIONS(4434),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [481] = {
    [sym__block] = STATE(18621),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(481),
    [sym_line_comment] = STATE(481),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_COMMA] = ACTIONS(4290),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4436),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4438),
    [aux_sym__terminator_token2] = ACTIONS(4440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [482] = {
    [sym__block] = STATE(17820),
    [sym_open_tuple] = STATE(14605),
    [sym_assignment] = STATE(15169),
    [sym__expression] = STATE(12150),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10289),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12515),
    [sym_unary_expression] = STATE(12515),
    [sym_range_expression] = STATE(12515),
    [sym_splat_expression] = STATE(12515),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12040),
    [sym_unary_typed_expression] = STATE(12515),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12515),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12042),
    [sym_block_comment] = STATE(482),
    [sym_line_comment] = STATE(482),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4442),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(4442),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3333),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(3337),
    [anon_sym_AT] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3339),
    [aux_sym_integer_literal_token2] = ACTIONS(3339),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(3343),
    [aux_sym_float_literal_token3] = ACTIONS(3343),
    [aux_sym_float_literal_token4] = ACTIONS(3343),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3345),
    [sym__type_order_operator] = ACTIONS(3345),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym__terminator_token1] = ACTIONS(4444),
    [aux_sym__terminator_token2] = ACTIONS(4446),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [483] = {
    [sym__block] = STATE(16327),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15209),
    [sym_finally_clause] = STATE(17399),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(483),
    [sym_line_comment] = STATE(483),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [484] = {
    [sym__block] = STATE(18150),
    [sym_open_tuple] = STATE(14406),
    [sym_assignment] = STATE(15183),
    [sym__expression] = STATE(12021),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10378),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12468),
    [sym_unary_expression] = STATE(12468),
    [sym_range_expression] = STATE(12468),
    [sym_splat_expression] = STATE(12468),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12153),
    [sym_unary_typed_expression] = STATE(12468),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12468),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12159),
    [sym_block_comment] = STATE(484),
    [sym_line_comment] = STATE(484),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4460),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4460),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(3301),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(3305),
    [anon_sym_AT] = ACTIONS(595),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(3307),
    [aux_sym_integer_literal_token2] = ACTIONS(3307),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(3311),
    [aux_sym_float_literal_token3] = ACTIONS(3311),
    [aux_sym_float_literal_token4] = ACTIONS(3311),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(3313),
    [sym__type_order_operator] = ACTIONS(3313),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym__terminator_token1] = ACTIONS(4462),
    [aux_sym__terminator_token2] = ACTIONS(4464),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [485] = {
    [sym__block] = STATE(15578),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15223),
    [sym_finally_clause] = STATE(17426),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(485),
    [sym_line_comment] = STATE(485),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [486] = {
    [sym__block] = STATE(16057),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15153),
    [sym_finally_clause] = STATE(17506),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(486),
    [sym_line_comment] = STATE(486),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [487] = {
    [sym__block] = STATE(16189),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15114),
    [sym_finally_clause] = STATE(17314),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(487),
    [sym_line_comment] = STATE(487),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [488] = {
    [sym__block] = STATE(16212),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15159),
    [sym_finally_clause] = STATE(17509),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(488),
    [sym_line_comment] = STATE(488),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [489] = {
    [sym__block] = STATE(16227),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15257),
    [sym_finally_clause] = STATE(17144),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(489),
    [sym_line_comment] = STATE(489),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [490] = {
    [sym__block] = STATE(16243),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15137),
    [sym_finally_clause] = STATE(17200),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(490),
    [sym_line_comment] = STATE(490),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [491] = {
    [sym__block] = STATE(16262),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15312),
    [sym_finally_clause] = STATE(17441),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(491),
    [sym_line_comment] = STATE(491),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [492] = {
    [sym__block] = STATE(16275),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15329),
    [sym_finally_clause] = STATE(17649),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(492),
    [sym_line_comment] = STATE(492),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [493] = {
    [sym__block] = STATE(16291),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15274),
    [sym_finally_clause] = STATE(17629),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(493),
    [sym_line_comment] = STATE(493),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [494] = {
    [sym__block] = STATE(16304),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15178),
    [sym_finally_clause] = STATE(17184),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(494),
    [sym_line_comment] = STATE(494),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [495] = {
    [sym__block] = STATE(16316),
    [sym_open_tuple] = STATE(15041),
    [sym_assignment] = STATE(15269),
    [sym__expression] = STATE(12208),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_catch_clause] = STATE(15120),
    [sym_finally_clause] = STATE(17576),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(495),
    [sym_line_comment] = STATE(495),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4224),
    [anon_sym_finally] = ACTIONS(4226),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [496] = {
    [sym__block] = STATE(18557),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(496),
    [sym_line_comment] = STATE(496),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4466),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4468),
    [aux_sym__terminator_token2] = ACTIONS(4470),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [497] = {
    [sym__block] = STATE(18732),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(497),
    [sym_line_comment] = STATE(497),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4472),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4474),
    [aux_sym__terminator_token2] = ACTIONS(4476),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [498] = {
    [sym__block] = STATE(19010),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(498),
    [sym_line_comment] = STATE(498),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4478),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4480),
    [aux_sym__terminator_token2] = ACTIONS(4482),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [499] = {
    [sym__block] = STATE(18541),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(499),
    [sym_line_comment] = STATE(499),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4484),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4486),
    [aux_sym__terminator_token2] = ACTIONS(4488),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [500] = {
    [sym__block] = STATE(17328),
    [sym_open_tuple] = STATE(14274),
    [sym_assignment] = STATE(14810),
    [sym__expression] = STATE(11938),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(500),
    [sym_line_comment] = STATE(500),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(107),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(107),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(107),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [501] = {
    [sym__block] = STATE(18975),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(501),
    [sym_line_comment] = STATE(501),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4510),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4512),
    [aux_sym__terminator_token2] = ACTIONS(4514),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [502] = {
    [sym__block] = STATE(18487),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(502),
    [sym_line_comment] = STATE(502),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4516),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4518),
    [aux_sym__terminator_token2] = ACTIONS(4520),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [503] = {
    [sym__block] = STATE(19406),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(503),
    [sym_line_comment] = STATE(503),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4522),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4524),
    [aux_sym__terminator_token2] = ACTIONS(4526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [504] = {
    [sym__block] = STATE(18810),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(504),
    [sym_line_comment] = STATE(504),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4528),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4530),
    [aux_sym__terminator_token2] = ACTIONS(4532),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [505] = {
    [sym__block] = STATE(19464),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(505),
    [sym_line_comment] = STATE(505),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4534),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4536),
    [aux_sym__terminator_token2] = ACTIONS(4538),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [506] = {
    [sym__block] = STATE(19131),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(506),
    [sym_line_comment] = STATE(506),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4540),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4542),
    [aux_sym__terminator_token2] = ACTIONS(4544),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [507] = {
    [sym__block] = STATE(19481),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(507),
    [sym_line_comment] = STATE(507),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4546),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4548),
    [aux_sym__terminator_token2] = ACTIONS(4550),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [508] = {
    [sym__block] = STATE(19483),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(508),
    [sym_line_comment] = STATE(508),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4552),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4554),
    [aux_sym__terminator_token2] = ACTIONS(4556),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [509] = {
    [sym__block] = STATE(19485),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(509),
    [sym_line_comment] = STATE(509),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4558),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4560),
    [aux_sym__terminator_token2] = ACTIONS(4562),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [510] = {
    [sym__block] = STATE(19596),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(510),
    [sym_line_comment] = STATE(510),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4564),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4566),
    [aux_sym__terminator_token2] = ACTIONS(4568),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [511] = {
    [sym__block] = STATE(18682),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(511),
    [sym_line_comment] = STATE(511),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4570),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4572),
    [aux_sym__terminator_token2] = ACTIONS(4574),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [512] = {
    [sym__block] = STATE(18249),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(512),
    [sym_line_comment] = STATE(512),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4576),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4578),
    [aux_sym__terminator_token2] = ACTIONS(4580),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [513] = {
    [sym__block] = STATE(19074),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(513),
    [sym_line_comment] = STATE(513),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4582),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4584),
    [aux_sym__terminator_token2] = ACTIONS(4586),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [514] = {
    [sym__block] = STATE(19107),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(514),
    [sym_line_comment] = STATE(514),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4588),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4590),
    [aux_sym__terminator_token2] = ACTIONS(4592),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [515] = {
    [sym__block] = STATE(19110),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(515),
    [sym_line_comment] = STATE(515),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4594),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4596),
    [aux_sym__terminator_token2] = ACTIONS(4598),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [516] = {
    [sym__block] = STATE(19134),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(516),
    [sym_line_comment] = STATE(516),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4600),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4602),
    [aux_sym__terminator_token2] = ACTIONS(4604),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [517] = {
    [sym__block] = STATE(17162),
    [sym_open_tuple] = STATE(14274),
    [sym_assignment] = STATE(14810),
    [sym__expression] = STATE(11938),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(517),
    [sym_line_comment] = STATE(517),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(4606),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(4606),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(4606),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [518] = {
    [sym__block] = STATE(18260),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(518),
    [sym_line_comment] = STATE(518),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4608),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4610),
    [aux_sym__terminator_token2] = ACTIONS(4612),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [519] = {
    [sym__block] = STATE(19265),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(519),
    [sym_line_comment] = STATE(519),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4614),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4616),
    [aux_sym__terminator_token2] = ACTIONS(4618),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [520] = {
    [sym__block] = STATE(18675),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(520),
    [sym_line_comment] = STATE(520),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4620),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4622),
    [aux_sym__terminator_token2] = ACTIONS(4624),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [521] = {
    [sym__block] = STATE(19609),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(521),
    [sym_line_comment] = STATE(521),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4626),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4628),
    [aux_sym__terminator_token2] = ACTIONS(4630),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [522] = {
    [sym__block] = STATE(17594),
    [sym_open_tuple] = STATE(14266),
    [sym_assignment] = STATE(14852),
    [sym__expression] = STATE(11852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(522),
    [sym_line_comment] = STATE(522),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4632),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(4632),
    [anon_sym_else] = ACTIONS(4632),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [523] = {
    [sym__block] = STATE(19002),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(523),
    [sym_line_comment] = STATE(523),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4634),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4636),
    [aux_sym__terminator_token2] = ACTIONS(4638),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [524] = {
    [sym__block] = STATE(19198),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(524),
    [sym_line_comment] = STATE(524),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4640),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4642),
    [aux_sym__terminator_token2] = ACTIONS(4644),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [525] = {
    [sym__block] = STATE(18484),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(525),
    [sym_line_comment] = STATE(525),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4646),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4648),
    [aux_sym__terminator_token2] = ACTIONS(4650),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [526] = {
    [sym__block] = STATE(18681),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(526),
    [sym_line_comment] = STATE(526),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4652),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4654),
    [aux_sym__terminator_token2] = ACTIONS(4656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [527] = {
    [sym__block] = STATE(18506),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(527),
    [sym_line_comment] = STATE(527),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4658),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4660),
    [aux_sym__terminator_token2] = ACTIONS(4662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [528] = {
    [sym__block] = STATE(18684),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(528),
    [sym_line_comment] = STATE(528),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4664),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4666),
    [aux_sym__terminator_token2] = ACTIONS(4668),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [529] = {
    [sym__block] = STATE(17820),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(529),
    [sym_line_comment] = STATE(529),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4442),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4670),
    [aux_sym__terminator_token2] = ACTIONS(4672),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [530] = {
    [sym__block] = STATE(18870),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(530),
    [sym_line_comment] = STATE(530),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4674),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4676),
    [aux_sym__terminator_token2] = ACTIONS(4678),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [531] = {
    [sym__block] = STATE(18886),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(531),
    [sym_line_comment] = STATE(531),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4680),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4682),
    [aux_sym__terminator_token2] = ACTIONS(4684),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [532] = {
    [sym__block] = STATE(19572),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(532),
    [sym_line_comment] = STATE(532),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4686),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4688),
    [aux_sym__terminator_token2] = ACTIONS(4690),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [533] = {
    [sym__block] = STATE(18931),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(533),
    [sym_line_comment] = STATE(533),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4692),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4694),
    [aux_sym__terminator_token2] = ACTIONS(4696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [534] = {
    [sym__block] = STATE(18977),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(534),
    [sym_line_comment] = STATE(534),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4698),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4700),
    [aux_sym__terminator_token2] = ACTIONS(4702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [535] = {
    [sym__block] = STATE(18715),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(535),
    [sym_line_comment] = STATE(535),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4704),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4706),
    [aux_sym__terminator_token2] = ACTIONS(4708),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [536] = {
    [sym__block] = STATE(19329),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(536),
    [sym_line_comment] = STATE(536),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4710),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4712),
    [aux_sym__terminator_token2] = ACTIONS(4714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [537] = {
    [sym__block] = STATE(18286),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(537),
    [sym_line_comment] = STATE(537),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4716),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4718),
    [aux_sym__terminator_token2] = ACTIONS(4720),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [538] = {
    [sym__block] = STATE(19345),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(538),
    [sym_line_comment] = STATE(538),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4722),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4724),
    [aux_sym__terminator_token2] = ACTIONS(4726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [539] = {
    [sym__block] = STATE(18597),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(539),
    [sym_line_comment] = STATE(539),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4728),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4730),
    [aux_sym__terminator_token2] = ACTIONS(4732),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [540] = {
    [sym__block] = STATE(18740),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(540),
    [sym_line_comment] = STATE(540),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4734),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4736),
    [aux_sym__terminator_token2] = ACTIONS(4738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [541] = {
    [sym__block] = STATE(18150),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(541),
    [sym_line_comment] = STATE(541),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4460),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4740),
    [aux_sym__terminator_token2] = ACTIONS(4742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [542] = {
    [sym__block] = STATE(18782),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(542),
    [sym_line_comment] = STATE(542),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4744),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4746),
    [aux_sym__terminator_token2] = ACTIONS(4748),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [543] = {
    [sym__block] = STATE(19269),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(543),
    [sym_line_comment] = STATE(543),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4750),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4752),
    [aux_sym__terminator_token2] = ACTIONS(4754),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [544] = {
    [sym__block] = STATE(18864),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(544),
    [sym_line_comment] = STATE(544),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4756),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4758),
    [aux_sym__terminator_token2] = ACTIONS(4760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [545] = {
    [sym__block] = STATE(18408),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(545),
    [sym_line_comment] = STATE(545),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4762),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4764),
    [aux_sym__terminator_token2] = ACTIONS(4766),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [546] = {
    [sym__block] = STATE(18441),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(546),
    [sym_line_comment] = STATE(546),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4768),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4770),
    [aux_sym__terminator_token2] = ACTIONS(4772),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [547] = {
    [sym__block] = STATE(19220),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(547),
    [sym_line_comment] = STATE(547),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4774),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4776),
    [aux_sym__terminator_token2] = ACTIONS(4778),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [548] = {
    [sym__block] = STATE(18528),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(548),
    [sym_line_comment] = STATE(548),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4780),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4782),
    [aux_sym__terminator_token2] = ACTIONS(4784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [549] = {
    [sym__block] = STATE(19535),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(549),
    [sym_line_comment] = STATE(549),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4786),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4788),
    [aux_sym__terminator_token2] = ACTIONS(4790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [550] = {
    [sym__block] = STATE(18545),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(550),
    [sym_line_comment] = STATE(550),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4792),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4794),
    [aux_sym__terminator_token2] = ACTIONS(4796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [551] = {
    [sym__block] = STATE(19574),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(551),
    [sym_line_comment] = STATE(551),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4798),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4800),
    [aux_sym__terminator_token2] = ACTIONS(4802),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [552] = {
    [sym__block] = STATE(18377),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(552),
    [sym_line_comment] = STATE(552),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4804),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4806),
    [aux_sym__terminator_token2] = ACTIONS(4808),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [553] = {
    [sym__block] = STATE(19433),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(553),
    [sym_line_comment] = STATE(553),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4810),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4812),
    [aux_sym__terminator_token2] = ACTIONS(4814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [554] = {
    [sym__block] = STATE(18833),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(554),
    [sym_line_comment] = STATE(554),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4816),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4818),
    [aux_sym__terminator_token2] = ACTIONS(4820),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [555] = {
    [sym__block] = STATE(18848),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(555),
    [sym_line_comment] = STATE(555),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4822),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4824),
    [aux_sym__terminator_token2] = ACTIONS(4826),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [556] = {
    [sym__block] = STATE(18932),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(556),
    [sym_line_comment] = STATE(556),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4830),
    [aux_sym__terminator_token2] = ACTIONS(4832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [557] = {
    [sym__block] = STATE(18400),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(557),
    [sym_line_comment] = STATE(557),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4834),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4836),
    [aux_sym__terminator_token2] = ACTIONS(4838),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [558] = {
    [sym__block] = STATE(19119),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(558),
    [sym_line_comment] = STATE(558),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4840),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4842),
    [aux_sym__terminator_token2] = ACTIONS(4844),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [559] = {
    [sym__block] = STATE(18899),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(559),
    [sym_line_comment] = STATE(559),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4846),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4848),
    [aux_sym__terminator_token2] = ACTIONS(4850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [560] = {
    [sym__block] = STATE(17165),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(3),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(560),
    [sym_line_comment] = STATE(560),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4412),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4852),
    [aux_sym__terminator_token2] = ACTIONS(4854),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [561] = {
    [sym__block] = STATE(18882),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(561),
    [sym_line_comment] = STATE(561),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4856),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4858),
    [aux_sym__terminator_token2] = ACTIONS(4860),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [562] = {
    [sym__block] = STATE(18991),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(562),
    [sym_line_comment] = STATE(562),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4862),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4864),
    [aux_sym__terminator_token2] = ACTIONS(4866),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [563] = {
    [sym__block] = STATE(19021),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(563),
    [sym_line_comment] = STATE(563),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4868),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4870),
    [aux_sym__terminator_token2] = ACTIONS(4872),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [564] = {
    [sym__block] = STATE(19259),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(564),
    [sym_line_comment] = STATE(564),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4874),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4876),
    [aux_sym__terminator_token2] = ACTIONS(4878),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [565] = {
    [sym__block] = STATE(19042),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(565),
    [sym_line_comment] = STATE(565),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4880),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4882),
    [aux_sym__terminator_token2] = ACTIONS(4884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [566] = {
    [sym__block] = STATE(19062),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(566),
    [sym_line_comment] = STATE(566),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4886),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4888),
    [aux_sym__terminator_token2] = ACTIONS(4890),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [567] = {
    [sym__block] = STATE(19045),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(567),
    [sym_line_comment] = STATE(567),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4892),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4894),
    [aux_sym__terminator_token2] = ACTIONS(4896),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [568] = {
    [sym__block] = STATE(18239),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(568),
    [sym_line_comment] = STATE(568),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4898),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4900),
    [aux_sym__terminator_token2] = ACTIONS(4902),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [569] = {
    [sym__block] = STATE(18386),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(569),
    [sym_line_comment] = STATE(569),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4904),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4906),
    [aux_sym__terminator_token2] = ACTIONS(4908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [570] = {
    [sym__block] = STATE(18906),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(570),
    [sym_line_comment] = STATE(570),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4910),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4912),
    [aux_sym__terminator_token2] = ACTIONS(4914),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [571] = {
    [sym__block] = STATE(18973),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(571),
    [sym_line_comment] = STATE(571),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4916),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4918),
    [aux_sym__terminator_token2] = ACTIONS(4920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [572] = {
    [sym__block] = STATE(19181),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(572),
    [sym_line_comment] = STATE(572),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4922),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4924),
    [aux_sym__terminator_token2] = ACTIONS(4926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [573] = {
    [sym__block] = STATE(19017),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(573),
    [sym_line_comment] = STATE(573),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4928),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_DOLLAR] = ACTIONS(217),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(221),
    [anon_sym_AT] = ACTIONS(225),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(227),
    [aux_sym_integer_literal_token2] = ACTIONS(227),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(231),
    [aux_sym_float_literal_token3] = ACTIONS(231),
    [aux_sym_float_literal_token4] = ACTIONS(231),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(93),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(93),
    [sym__pipe_left_operator] = ACTIONS(93),
    [sym__ellipsis_operator] = ACTIONS(93),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(93),
    [sym__bitshift_operator] = ACTIONS(93),
    [sym__power_operator] = ACTIONS(93),
    [sym__tilde_operator] = ACTIONS(235),
    [sym__type_order_operator] = ACTIONS(235),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym__terminator_token1] = ACTIONS(4930),
    [aux_sym__terminator_token2] = ACTIONS(4932),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [574] = {
    [sym__closed_assignment] = STATE(9403),
    [sym__expression] = STATE(7861),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15623),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(574),
    [sym_line_comment] = STATE(574),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4934),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4940),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [575] = {
    [sym__closed_assignment] = STATE(9353),
    [sym__expression] = STATE(7634),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15535),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(575),
    [sym_line_comment] = STATE(575),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4958),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4960),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [576] = {
    [sym__closed_assignment] = STATE(9387),
    [sym__expression] = STATE(7692),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17031),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(576),
    [sym_line_comment] = STATE(576),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4962),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4964),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [577] = {
    [sym__closed_assignment] = STATE(14249),
    [sym__expression] = STATE(11608),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17726),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(577),
    [sym_line_comment] = STATE(577),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(4968),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(4970),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [578] = {
    [sym__closed_assignment] = STATE(9402),
    [sym__expression] = STATE(7698),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17055),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(578),
    [sym_line_comment] = STATE(578),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4972),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4974),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [579] = {
    [sym__closed_assignment] = STATE(9370),
    [sym__expression] = STATE(7744),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15599),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(579),
    [sym_line_comment] = STATE(579),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4976),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4978),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [580] = {
    [sym__closed_assignment] = STATE(9406),
    [sym__expression] = STATE(7704),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15366),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(580),
    [sym_line_comment] = STATE(580),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4980),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4982),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [581] = {
    [sym_open_tuple] = STATE(14531),
    [sym_assignment] = STATE(15171),
    [sym__expression] = STATE(12272),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(581),
    [sym_line_comment] = STATE(581),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(4984),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(4984),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(4984),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [582] = {
    [sym__closed_assignment] = STATE(9346),
    [sym__expression] = STATE(7715),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15391),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(582),
    [sym_line_comment] = STATE(582),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4986),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4988),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [583] = {
    [sym__closed_assignment] = STATE(9373),
    [sym__expression] = STATE(7878),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16738),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(583),
    [sym_line_comment] = STATE(583),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4990),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4992),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [584] = {
    [sym__closed_assignment] = STATE(9355),
    [sym__expression] = STATE(7723),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15408),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(584),
    [sym_line_comment] = STATE(584),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(4994),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(4996),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [585] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(585),
    [sym_line_comment] = STATE(585),
    [aux_sym_matrix_row_repeat1] = STATE(627),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(665),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(675),
    [anon_sym_RBRACK] = ACTIONS(4998),
    [anon_sym_LBRACE] = ACTIONS(677),
    [anon_sym_DOLLAR] = ACTIONS(679),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(685),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(689),
    [aux_sym_integer_literal_token2] = ACTIONS(689),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(693),
    [aux_sym_float_literal_token3] = ACTIONS(693),
    [aux_sym_float_literal_token4] = ACTIONS(693),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(697),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(697),
    [sym__pipe_left_operator] = ACTIONS(697),
    [sym__ellipsis_operator] = ACTIONS(697),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(697),
    [sym__bitshift_operator] = ACTIONS(697),
    [sym__power_operator] = ACTIONS(697),
    [sym__tilde_operator] = ACTIONS(4050),
    [sym__type_order_operator] = ACTIONS(4050),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym__terminator_token1] = ACTIONS(5000),
    [aux_sym__terminator_token2] = ACTIONS(4998),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [586] = {
    [sym__closed_assignment] = STATE(9358),
    [sym__expression] = STATE(7737),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15429),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(586),
    [sym_line_comment] = STATE(586),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5002),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5004),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [587] = {
    [sym__closed_assignment] = STATE(9372),
    [sym__expression] = STATE(7233),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15430),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(587),
    [sym_line_comment] = STATE(587),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5006),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5008),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [588] = {
    [sym__closed_assignment] = STATE(9359),
    [sym__expression] = STATE(7892),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16265),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(588),
    [sym_line_comment] = STATE(588),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5010),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5012),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [589] = {
    [sym__closed_assignment] = STATE(9361),
    [sym__expression] = STATE(7752),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15448),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(589),
    [sym_line_comment] = STATE(589),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5014),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5016),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [590] = {
    [sym__closed_assignment] = STATE(9391),
    [sym__expression] = STATE(7278),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16047),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(590),
    [sym_line_comment] = STATE(590),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5018),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5020),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [591] = {
    [sym__closed_assignment] = STATE(9384),
    [sym__expression] = STATE(7763),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15466),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(591),
    [sym_line_comment] = STATE(591),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5022),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5024),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [592] = {
    [sym__closed_assignment] = STATE(14256),
    [sym__expression] = STATE(11701),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17956),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(592),
    [sym_line_comment] = STATE(592),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5026),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5028),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [593] = {
    [sym__closed_assignment] = STATE(9390),
    [sym__expression] = STATE(7786),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15492),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(593),
    [sym_line_comment] = STATE(593),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5030),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5032),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [594] = {
    [sym__closed_assignment] = STATE(14262),
    [sym__expression] = STATE(11678),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18158),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(594),
    [sym_line_comment] = STATE(594),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5034),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5036),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [595] = {
    [sym__closed_assignment] = STATE(9400),
    [sym__expression] = STATE(7817),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15515),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(595),
    [sym_line_comment] = STATE(595),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5038),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5040),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [596] = {
    [sym__block] = STATE(18048),
    [sym_open_tuple] = STATE(14605),
    [sym_assignment] = STATE(15169),
    [sym__expression] = STATE(12150),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10289),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12515),
    [sym_unary_expression] = STATE(12515),
    [sym_range_expression] = STATE(12515),
    [sym_splat_expression] = STATE(12515),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12040),
    [sym_unary_typed_expression] = STATE(12515),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12515),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12042),
    [sym_block_comment] = STATE(596),
    [sym_line_comment] = STATE(596),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5042),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(5042),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [597] = {
    [sym__closed_assignment] = STATE(9405),
    [sym__expression] = STATE(7859),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15532),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(597),
    [sym_line_comment] = STATE(597),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5056),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5058),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [598] = {
    [sym__closed_assignment] = STATE(9388),
    [sym__expression] = STATE(7812),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15434),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(598),
    [sym_line_comment] = STATE(598),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5060),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5062),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [599] = {
    [sym__closed_assignment] = STATE(9398),
    [sym__expression] = STATE(7887),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15554),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(599),
    [sym_line_comment] = STATE(599),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5064),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5066),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [600] = {
    [sym__closed_assignment] = STATE(9354),
    [sym__expression] = STATE(7413),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16245),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(600),
    [sym_line_comment] = STATE(600),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5068),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5070),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [601] = {
    [sym__closed_assignment] = STATE(9408),
    [sym__expression] = STATE(7214),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15576),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(601),
    [sym_line_comment] = STATE(601),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5072),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [602] = {
    [sym__closed_assignment] = STATE(9363),
    [sym__expression] = STATE(7491),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16075),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(602),
    [sym_line_comment] = STATE(602),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5076),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [603] = {
    [sym__closed_assignment] = STATE(9352),
    [sym__expression] = STATE(7227),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15598),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(603),
    [sym_line_comment] = STATE(603),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5080),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5082),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [604] = {
    [sym__closed_assignment] = STATE(9366),
    [sym__expression] = STATE(7236),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15620),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(604),
    [sym_line_comment] = STATE(604),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5084),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [605] = {
    [sym__closed_assignment] = STATE(9375),
    [sym__expression] = STATE(7245),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15639),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(605),
    [sym_line_comment] = STATE(605),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5088),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5090),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [606] = {
    [sym__closed_assignment] = STATE(9381),
    [sym__expression] = STATE(7252),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15652),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(606),
    [sym_line_comment] = STATE(606),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5092),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5094),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [607] = {
    [sym__closed_assignment] = STATE(9380),
    [sym__expression] = STATE(7494),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16739),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(607),
    [sym_line_comment] = STATE(607),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5096),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5098),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [608] = {
    [sym__closed_assignment] = STATE(14251),
    [sym__expression] = STATE(11730),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18131),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(608),
    [sym_line_comment] = STATE(608),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5100),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5102),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [609] = {
    [sym__closed_assignment] = STATE(9350),
    [sym__expression] = STATE(7656),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16903),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(609),
    [sym_line_comment] = STATE(609),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5106),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [610] = {
    [sym__block] = STATE(17999),
    [sym_open_tuple] = STATE(14406),
    [sym_assignment] = STATE(15183),
    [sym__expression] = STATE(12021),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10378),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12468),
    [sym_unary_expression] = STATE(12468),
    [sym_range_expression] = STATE(12468),
    [sym_splat_expression] = STATE(12468),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12153),
    [sym_unary_typed_expression] = STATE(12468),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12468),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12159),
    [sym_block_comment] = STATE(610),
    [sym_line_comment] = STATE(610),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5108),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(5108),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [611] = {
    [sym__closed_assignment] = STATE(9367),
    [sym__expression] = STATE(7907),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16604),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(611),
    [sym_line_comment] = STATE(611),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5122),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5124),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [612] = {
    [sym__closed_assignment] = STATE(9409),
    [sym__expression] = STATE(7668),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16153),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(612),
    [sym_line_comment] = STATE(612),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5126),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5128),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [613] = {
    [sym__closed_assignment] = STATE(9356),
    [sym__expression] = STATE(7697),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17054),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(613),
    [sym_line_comment] = STATE(613),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5130),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5132),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [614] = {
    [sym_open_tuple] = STATE(15036),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12335),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(614),
    [sym_line_comment] = STATE(614),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5134),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(5134),
    [anon_sym_else] = ACTIONS(5134),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [615] = {
    [sym__closed_assignment] = STATE(9362),
    [sym__expression] = STATE(7762),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15447),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(615),
    [sym_line_comment] = STATE(615),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5136),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5138),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [616] = {
    [sym__closed_assignment] = STATE(9376),
    [sym__expression] = STATE(7923),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16677),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(616),
    [sym_line_comment] = STATE(616),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5140),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [617] = {
    [sym__closed_assignment] = STATE(9365),
    [sym__expression] = STATE(7217),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15545),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(617),
    [sym_line_comment] = STATE(617),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5144),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5146),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [618] = {
    [sym__closed_assignment] = STATE(9349),
    [sym__expression] = STATE(7681),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16998),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(618),
    [sym_line_comment] = STATE(618),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5148),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5150),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [619] = {
    [sym__closed_assignment] = STATE(9368),
    [sym__expression] = STATE(7241),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15640),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(619),
    [sym_line_comment] = STATE(619),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5152),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5154),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [620] = {
    [sym__closed_assignment] = STATE(14256),
    [sym__expression] = STATE(11631),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18006),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(620),
    [sym_line_comment] = STATE(620),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5156),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5158),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [621] = {
    [sym__closed_assignment] = STATE(9382),
    [sym__expression] = STATE(7784),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16742),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(621),
    [sym_line_comment] = STATE(621),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5160),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5162),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [622] = {
    [sym__closed_assignment] = STATE(9374),
    [sym__expression] = STATE(7279),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16061),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(622),
    [sym_line_comment] = STATE(622),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5164),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5166),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [623] = {
    [sym__closed_assignment] = STATE(14258),
    [sym__expression] = STATE(11712),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17956),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(623),
    [sym_line_comment] = STATE(623),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5168),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5170),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5172),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [624] = {
    [sym__closed_assignment] = STATE(14250),
    [sym__expression] = STATE(11634),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18167),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(624),
    [sym_line_comment] = STATE(624),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5174),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5176),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [625] = {
    [sym__closed_assignment] = STATE(9377),
    [sym__expression] = STATE(7374),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16123),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(625),
    [sym_line_comment] = STATE(625),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5178),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5180),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [626] = {
    [sym__closed_assignment] = STATE(9364),
    [sym__expression] = STATE(7841),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15450),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(626),
    [sym_line_comment] = STATE(626),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5182),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [627] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(627),
    [sym_line_comment] = STATE(627),
    [aux_sym_matrix_row_repeat1] = STATE(627),
    [sym__word_identifier] = ACTIONS(5186),
    [anon_sym_begin] = ACTIONS(5189),
    [anon_sym_module] = ACTIONS(5192),
    [anon_sym_baremodule] = ACTIONS(5192),
    [anon_sym_abstract] = ACTIONS(5195),
    [anon_sym_primitive] = ACTIONS(5198),
    [anon_sym_mutable] = ACTIONS(5201),
    [anon_sym_struct] = ACTIONS(5204),
    [anon_sym_function] = ACTIONS(5207),
    [anon_sym_macro] = ACTIONS(5210),
    [anon_sym_quote] = ACTIONS(5213),
    [anon_sym_let] = ACTIONS(5216),
    [anon_sym_if] = ACTIONS(5219),
    [anon_sym_try] = ACTIONS(5222),
    [anon_sym_for] = ACTIONS(5225),
    [anon_sym_while] = ACTIONS(5228),
    [sym_break_statement] = ACTIONS(5231),
    [sym_continue_statement] = ACTIONS(5231),
    [anon_sym_return] = ACTIONS(5234),
    [anon_sym_const] = ACTIONS(5237),
    [anon_sym_global] = ACTIONS(5240),
    [anon_sym_local] = ACTIONS(5243),
    [anon_sym_LPAREN] = ACTIONS(5246),
    [anon_sym_export] = ACTIONS(5249),
    [anon_sym_public] = ACTIONS(5252),
    [anon_sym_import] = ACTIONS(5255),
    [anon_sym_using] = ACTIONS(5258),
    [anon_sym_LBRACK] = ACTIONS(5261),
    [anon_sym_RBRACK] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(5266),
    [anon_sym_DOLLAR] = ACTIONS(5269),
    [anon_sym_COLON2] = ACTIONS(5272),
    [anon_sym_COLON_COLON] = ACTIONS(5275),
    [anon_sym_AT] = ACTIONS(5278),
    [anon_sym_true] = ACTIONS(5281),
    [anon_sym_false] = ACTIONS(5281),
    [aux_sym_integer_literal_token1] = ACTIONS(5284),
    [aux_sym_integer_literal_token2] = ACTIONS(5284),
    [aux_sym_integer_literal_token3] = ACTIONS(5284),
    [aux_sym_integer_literal_token4] = ACTIONS(5287),
    [aux_sym_float_literal_token1] = ACTIONS(5290),
    [aux_sym_float_literal_token3] = ACTIONS(5290),
    [aux_sym_float_literal_token4] = ACTIONS(5290),
    [sym_character_literal] = ACTIONS(5293),
    [anon_sym_DQUOTE] = ACTIONS(5296),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(5299),
    [anon_sym_BQUOTE] = ACTIONS(5302),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(5305),
    [sym__pair_operator] = ACTIONS(5308),
    [sym__arrow_operator] = ACTIONS(5308),
    [sym__comparison_operator] = ACTIONS(5308),
    [sym__pipe_right_operator] = ACTIONS(5308),
    [sym__pipe_left_operator] = ACTIONS(5308),
    [sym__ellipsis_operator] = ACTIONS(5308),
    [sym__plus_operator] = ACTIONS(5308),
    [sym__times_operator] = ACTIONS(5308),
    [sym__rational_operator] = ACTIONS(5308),
    [sym__bitshift_operator] = ACTIONS(5308),
    [sym__power_operator] = ACTIONS(5308),
    [sym__tilde_operator] = ACTIONS(5311),
    [sym__type_order_operator] = ACTIONS(5311),
    [sym__unary_operator] = ACTIONS(5311),
    [sym__unary_plus_operator] = ACTIONS(5311),
    [aux_sym__terminator_token1] = ACTIONS(5314),
    [aux_sym__terminator_token2] = ACTIONS(5264),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [628] = {
    [sym__closed_assignment] = STATE(14259),
    [sym__expression] = STATE(11692),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17754),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(628),
    [sym_line_comment] = STATE(628),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5316),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5318),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [629] = {
    [sym__closed_assignment] = STATE(9378),
    [sym__expression] = STATE(7440),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16213),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(629),
    [sym_line_comment] = STATE(629),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5320),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5322),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [630] = {
    [sym__closed_assignment] = STATE(14257),
    [sym__expression] = STATE(11640),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18119),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(630),
    [sym_line_comment] = STATE(630),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5324),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5326),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [631] = {
    [sym__closed_assignment] = STATE(14254),
    [sym__expression] = STATE(11700),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17684),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(631),
    [sym_line_comment] = STATE(631),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5328),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5330),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [632] = {
    [sym__closed_assignment] = STATE(9383),
    [sym__expression] = STATE(7453),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16318),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(632),
    [sym_line_comment] = STATE(632),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5332),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5334),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [633] = {
    [sym__closed_assignment] = STATE(9385),
    [sym__expression] = STATE(7873),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17046),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(633),
    [sym_line_comment] = STATE(633),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5336),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5338),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [634] = {
    [sym__closed_assignment] = STATE(9396),
    [sym__expression] = STATE(7628),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16868),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(634),
    [sym_line_comment] = STATE(634),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5340),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5342),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [635] = {
    [sym__closed_assignment] = STATE(9393),
    [sym__expression] = STATE(7465),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16600),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(635),
    [sym_line_comment] = STATE(635),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5344),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5346),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [636] = {
    [sym__closed_assignment] = STATE(9379),
    [sym__expression] = STATE(7677),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16697),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(636),
    [sym_line_comment] = STATE(636),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5348),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5350),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [637] = {
    [sym__closed_assignment] = STATE(9348),
    [sym__expression] = STATE(7883),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16108),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(637),
    [sym_line_comment] = STATE(637),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5352),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5354),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [638] = {
    [sym__closed_assignment] = STATE(9395),
    [sym__expression] = STATE(7500),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16665),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(638),
    [sym_line_comment] = STATE(638),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5356),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5358),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [639] = {
    [sym__closed_assignment] = STATE(9360),
    [sym__expression] = STATE(7471),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16997),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(639),
    [sym_line_comment] = STATE(639),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5360),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5362),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [640] = {
    [sym__closed_assignment] = STATE(14247),
    [sym__expression] = STATE(11687),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18032),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(640),
    [sym_line_comment] = STATE(640),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5364),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5366),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [641] = {
    [sym__closed_assignment] = STATE(9397),
    [sym__expression] = STATE(7527),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16732),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(641),
    [sym_line_comment] = STATE(641),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5368),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5370),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [642] = {
    [sym__closed_assignment] = STATE(9392),
    [sym__expression] = STATE(7732),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16861),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(642),
    [sym_line_comment] = STATE(642),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5372),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5374),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [643] = {
    [sym__closed_assignment] = STATE(9357),
    [sym__expression] = STATE(7247),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16928),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(643),
    [sym_line_comment] = STATE(643),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5376),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [644] = {
    [sym__closed_assignment] = STATE(9404),
    [sym__expression] = STATE(7591),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16790),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(644),
    [sym_line_comment] = STATE(644),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5380),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5382),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [645] = {
    [sym_open_tuple] = STATE(14531),
    [sym_assignment] = STATE(15171),
    [sym__expression] = STATE(12272),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(645),
    [sym_line_comment] = STATE(645),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_end] = ACTIONS(5134),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_else] = ACTIONS(5134),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_finally] = ACTIONS(5134),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [646] = {
    [sym__closed_assignment] = STATE(9407),
    [sym__expression] = STATE(7608),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16838),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(646),
    [sym_line_comment] = STATE(646),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5384),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5386),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [647] = {
    [sym__closed_assignment] = STATE(9394),
    [sym__expression] = STATE(7428),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17045),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(647),
    [sym_line_comment] = STATE(647),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5388),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5390),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [648] = {
    [sym__closed_assignment] = STATE(9351),
    [sym__expression] = STATE(7618),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16870),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(648),
    [sym_line_comment] = STATE(648),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5392),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5394),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [649] = {
    [sym__closed_assignment] = STATE(14248),
    [sym__expression] = STATE(11604),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17683),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(649),
    [sym_line_comment] = STATE(649),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5396),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5398),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [650] = {
    [sym__closed_assignment] = STATE(9347),
    [sym__expression] = STATE(7357),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(15405),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(650),
    [sym_line_comment] = STATE(650),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5400),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5402),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [651] = {
    [sym__closed_assignment] = STATE(9401),
    [sym__expression] = STATE(7650),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16904),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(651),
    [sym_line_comment] = STATE(651),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5404),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5406),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [652] = {
    [sym__closed_assignment] = STATE(14246),
    [sym__expression] = STATE(11653),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17983),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(652),
    [sym_line_comment] = STATE(652),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5408),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [653] = {
    [sym__closed_assignment] = STATE(9369),
    [sym__expression] = STATE(7597),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16319),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(653),
    [sym_line_comment] = STATE(653),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5412),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5414),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [654] = {
    [sym_open_tuple] = STATE(15036),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12335),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(654),
    [sym_line_comment] = STATE(654),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4984),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_elseif] = ACTIONS(4984),
    [anon_sym_else] = ACTIONS(4984),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [655] = {
    [sym__closed_assignment] = STATE(9386),
    [sym__expression] = STATE(7669),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(16948),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(655),
    [sym_line_comment] = STATE(655),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5416),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [656] = {
    [sym__closed_assignment] = STATE(9399),
    [sym__expression] = STATE(7776),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17020),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(656),
    [sym_line_comment] = STATE(656),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_COMMA] = ACTIONS(5420),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5422),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [657] = {
    [sym__closed_assignment] = STATE(14260),
    [sym__expression] = STATE(11603),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17717),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(657),
    [sym_line_comment] = STATE(657),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(4966),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5424),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5426),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [658] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(658),
    [sym_line_comment] = STATE(658),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5428),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [659] = {
    [sym__block] = STATE(18262),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(659),
    [sym_line_comment] = STATE(659),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5432),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [660] = {
    [sym__block] = STATE(18263),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(660),
    [sym_line_comment] = STATE(660),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5446),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [661] = {
    [sym__block] = STATE(18270),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(661),
    [sym_line_comment] = STATE(661),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5448),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [662] = {
    [sym__closed_assignment] = STATE(14440),
    [sym__expression] = STATE(11864),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18119),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(662),
    [sym_line_comment] = STATE(662),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2265),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2267),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [663] = {
    [sym__block] = STATE(18298),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(663),
    [sym_line_comment] = STATE(663),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4298),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [664] = {
    [sym__block] = STATE(18694),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(664),
    [sym_line_comment] = STATE(664),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5450),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [665] = {
    [sym__block] = STATE(18462),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(665),
    [sym_line_comment] = STATE(665),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5452),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [666] = {
    [sym__block] = STATE(18303),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(666),
    [sym_line_comment] = STATE(666),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5454),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [667] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(667),
    [sym_line_comment] = STATE(667),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5456),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [668] = {
    [sym__closed_assignment] = STATE(16129),
    [sym__expression] = STATE(12343),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(668),
    [sym_line_comment] = STATE(668),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5458),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5460),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5462),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [669] = {
    [sym__block] = STATE(18841),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(669),
    [sym_line_comment] = STATE(669),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5464),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [670] = {
    [sym__block] = STATE(18947),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(670),
    [sym_line_comment] = STATE(670),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5466),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [671] = {
    [sym__block] = STATE(18407),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(671),
    [sym_line_comment] = STATE(671),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5468),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [672] = {
    [sym__block] = STATE(18409),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(672),
    [sym_line_comment] = STATE(672),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5470),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [673] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11958),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17259),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(673),
    [sym_line_comment] = STATE(673),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5474),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [674] = {
    [sym__closed_assignment] = STATE(14787),
    [sym__expression] = STATE(11880),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18006),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(674),
    [sym_line_comment] = STATE(674),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5476),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5478),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [675] = {
    [sym__block] = STATE(18749),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(675),
    [sym_line_comment] = STATE(675),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5480),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [676] = {
    [sym__block] = STATE(18438),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(676),
    [sym_line_comment] = STATE(676),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5482),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [677] = {
    [sym__block] = STATE(18782),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(677),
    [sym_line_comment] = STATE(677),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4744),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [678] = {
    [sym__block] = STATE(18964),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(678),
    [sym_line_comment] = STATE(678),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5484),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [679] = {
    [sym__block] = STATE(19114),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(679),
    [sym_line_comment] = STATE(679),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5486),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [680] = {
    [sym__block] = STATE(19396),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(680),
    [sym_line_comment] = STATE(680),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5488),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [681] = {
    [sym__block] = STATE(19605),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(681),
    [sym_line_comment] = STATE(681),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5490),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [682] = {
    [sym__block] = STATE(18448),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(682),
    [sym_line_comment] = STATE(682),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5492),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [683] = {
    [sym__block] = STATE(18621),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(683),
    [sym_line_comment] = STATE(683),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4436),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [684] = {
    [sym__block] = STATE(18660),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(684),
    [sym_line_comment] = STATE(684),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5494),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [685] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(685),
    [sym_line_comment] = STATE(685),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5496),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [686] = {
    [sym__closed_assignment] = STATE(16626),
    [sym__expression] = STATE(12227),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(686),
    [sym_line_comment] = STATE(686),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5500),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5502),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [687] = {
    [sym__block] = STATE(18344),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(687),
    [sym_line_comment] = STATE(687),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [688] = {
    [sym__block] = STATE(18351),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(688),
    [sym_line_comment] = STATE(688),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5506),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [689] = {
    [sym__block] = STATE(18353),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(689),
    [sym_line_comment] = STATE(689),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5508),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [690] = {
    [sym__block] = STATE(18457),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(690),
    [sym_line_comment] = STATE(690),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5510),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [691] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(691),
    [sym_line_comment] = STATE(691),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5512),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [692] = {
    [sym__block] = STATE(18820),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(692),
    [sym_line_comment] = STATE(692),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5514),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [693] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(693),
    [sym_line_comment] = STATE(693),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5516),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [694] = {
    [sym__block] = STATE(18524),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(694),
    [sym_line_comment] = STATE(694),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5518),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [695] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(695),
    [sym_line_comment] = STATE(695),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5520),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [696] = {
    [sym__block] = STATE(18612),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(696),
    [sym_line_comment] = STATE(696),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5522),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [697] = {
    [sym__closed_assignment] = STATE(16897),
    [sym__expression] = STATE(12160),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(697),
    [sym_line_comment] = STATE(697),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5524),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5526),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5528),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [698] = {
    [sym__block] = STATE(18259),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(698),
    [sym_line_comment] = STATE(698),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5530),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [699] = {
    [sym__block] = STATE(18601),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(699),
    [sym_line_comment] = STATE(699),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5532),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [700] = {
    [sym__block] = STATE(19272),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(700),
    [sym_line_comment] = STATE(700),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5534),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [701] = {
    [sym__block] = STATE(19397),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(701),
    [sym_line_comment] = STATE(701),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5536),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [702] = {
    [sym__block] = STATE(19244),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(702),
    [sym_line_comment] = STATE(702),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5538),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [703] = {
    [sym__block] = STATE(19133),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(703),
    [sym_line_comment] = STATE(703),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5540),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [704] = {
    [sym__block] = STATE(19589),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(704),
    [sym_line_comment] = STATE(704),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5542),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [705] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11749),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17125),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(705),
    [sym_line_comment] = STATE(705),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5544),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [706] = {
    [sym__closed_assignment] = STATE(14400),
    [sym__expression] = STATE(11791),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18174),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(706),
    [sym_line_comment] = STATE(706),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2387),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2389),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [707] = {
    [sym__block] = STATE(18475),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(707),
    [sym_line_comment] = STATE(707),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5546),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [708] = {
    [sym__block] = STATE(18239),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(708),
    [sym_line_comment] = STATE(708),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4898),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [709] = {
    [sym__block] = STATE(18882),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(709),
    [sym_line_comment] = STATE(709),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4856),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [710] = {
    [sym__block] = STATE(19003),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(710),
    [sym_line_comment] = STATE(710),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5548),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [711] = {
    [sym__block] = STATE(19446),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(711),
    [sym_line_comment] = STATE(711),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5550),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [712] = {
    [sym__block] = STATE(19452),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(712),
    [sym_line_comment] = STATE(712),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5552),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [713] = {
    [sym__block] = STATE(19499),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(713),
    [sym_line_comment] = STATE(713),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5554),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [714] = {
    [sym__block] = STATE(17328),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(714),
    [sym_line_comment] = STATE(714),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(107),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [715] = {
    [sym__block] = STATE(18473),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(715),
    [sym_line_comment] = STATE(715),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4304),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [716] = {
    [sym__block] = STATE(18048),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(716),
    [sym_line_comment] = STATE(716),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5042),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [717] = {
    [sym__block] = STATE(18502),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(717),
    [sym_line_comment] = STATE(717),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5556),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [718] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(718),
    [sym_line_comment] = STATE(718),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5558),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [719] = {
    [sym__closed_assignment] = STATE(16939),
    [sym__expression] = STATE(12223),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(719),
    [sym_line_comment] = STATE(719),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5560),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5562),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5564),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [720] = {
    [sym__block] = STATE(19376),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(720),
    [sym_line_comment] = STATE(720),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5566),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [721] = {
    [sym__block] = STATE(19379),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(721),
    [sym_line_comment] = STATE(721),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5568),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [722] = {
    [sym__block] = STATE(19447),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(722),
    [sym_line_comment] = STATE(722),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5570),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [723] = {
    [sym__block] = STATE(19479),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(723),
    [sym_line_comment] = STATE(723),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5572),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [724] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(724),
    [sym_line_comment] = STATE(724),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5574),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [725] = {
    [sym__block] = STATE(19380),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(725),
    [sym_line_comment] = STATE(725),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5576),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [726] = {
    [sym__block] = STATE(17999),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(726),
    [sym_line_comment] = STATE(726),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5108),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [727] = {
    [sym_open_tuple] = STATE(15296),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12721),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10378),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12468),
    [sym_unary_expression] = STATE(12468),
    [sym_range_expression] = STATE(12468),
    [sym_splat_expression] = STATE(12468),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12153),
    [sym_unary_typed_expression] = STATE(12468),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12468),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12159),
    [sym_block_comment] = STATE(727),
    [sym_line_comment] = STATE(727),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5134),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(5134),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [728] = {
    [sym__block] = STATE(18843),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(728),
    [sym_line_comment] = STATE(728),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5578),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [729] = {
    [sym__block] = STATE(18611),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(729),
    [sym_line_comment] = STATE(729),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5580),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [730] = {
    [sym__block] = STATE(18275),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(730),
    [sym_line_comment] = STATE(730),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5582),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [731] = {
    [sym__block] = STATE(18244),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(731),
    [sym_line_comment] = STATE(731),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5584),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [732] = {
    [sym_open_tuple] = STATE(15296),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12721),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10378),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12468),
    [sym_unary_expression] = STATE(12468),
    [sym_range_expression] = STATE(12468),
    [sym_splat_expression] = STATE(12468),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12153),
    [sym_unary_typed_expression] = STATE(12468),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12468),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12159),
    [sym_block_comment] = STATE(732),
    [sym_line_comment] = STATE(732),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4984),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4984),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [733] = {
    [sym__block] = STATE(19546),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(733),
    [sym_line_comment] = STATE(733),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5586),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [734] = {
    [sym__block] = STATE(19211),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(734),
    [sym_line_comment] = STATE(734),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5588),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [735] = {
    [sym__block] = STATE(19267),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(735),
    [sym_line_comment] = STATE(735),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5590),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [736] = {
    [sym__block] = STATE(18963),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(736),
    [sym_line_comment] = STATE(736),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5592),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [737] = {
    [sym__block] = STATE(18974),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(737),
    [sym_line_comment] = STATE(737),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5594),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [738] = {
    [sym__block] = STATE(18703),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(738),
    [sym_line_comment] = STATE(738),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5596),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [739] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11984),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17578),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(739),
    [sym_line_comment] = STATE(739),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5598),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [740] = {
    [sym__closed_assignment] = STATE(15038),
    [sym__expression] = STATE(11810),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18186),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(740),
    [sym_line_comment] = STATE(740),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2541),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2543),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [741] = {
    [sym__block] = STATE(19288),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(741),
    [sym_line_comment] = STATE(741),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5600),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [742] = {
    [sym__block] = STATE(18733),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(742),
    [sym_line_comment] = STATE(742),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5602),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [743] = {
    [sym__block] = STATE(19345),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(743),
    [sym_line_comment] = STATE(743),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4722),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [744] = {
    [sym__block] = STATE(18768),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(744),
    [sym_line_comment] = STATE(744),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5604),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [745] = {
    [sym__block] = STATE(18937),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(745),
    [sym_line_comment] = STATE(745),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5606),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [746] = {
    [sym__block] = STATE(18476),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(746),
    [sym_line_comment] = STATE(746),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5608),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [747] = {
    [sym__block] = STATE(18948),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(747),
    [sym_line_comment] = STATE(747),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5610),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [748] = {
    [sym__block] = STATE(19291),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(748),
    [sym_line_comment] = STATE(748),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4400),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [749] = {
    [sym__block] = STATE(19547),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(749),
    [sym_line_comment] = STATE(749),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5612),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [750] = {
    [sym__block] = STATE(19494),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(750),
    [sym_line_comment] = STATE(750),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5614),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [751] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(751),
    [sym_line_comment] = STATE(751),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5616),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [752] = {
    [sym__closed_assignment] = STATE(16676),
    [sym__expression] = STATE(12122),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(752),
    [sym_line_comment] = STATE(752),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5618),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5620),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5622),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [753] = {
    [sym__block] = STATE(18630),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(753),
    [sym_line_comment] = STATE(753),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5624),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [754] = {
    [sym__block] = STATE(18637),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(754),
    [sym_line_comment] = STATE(754),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5626),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [755] = {
    [sym__block] = STATE(18696),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(755),
    [sym_line_comment] = STATE(755),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5628),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [756] = {
    [sym__block] = STATE(18838),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(756),
    [sym_line_comment] = STATE(756),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5630),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [757] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(757),
    [sym_line_comment] = STATE(757),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5632),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [758] = {
    [sym__block] = STATE(18904),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(758),
    [sym_line_comment] = STATE(758),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5634),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [759] = {
    [sym__closed_assignment] = STATE(16161),
    [sym__expression] = STATE(11944),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(759),
    [sym_line_comment] = STATE(759),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5636),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5638),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [760] = {
    [sym__closed_assignment] = STATE(14470),
    [sym__expression] = STATE(11955),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18079),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(760),
    [sym_line_comment] = STATE(760),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5640),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5642),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [761] = {
    [sym__block] = STATE(18403),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(761),
    [sym_line_comment] = STATE(761),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5644),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [762] = {
    [sym__block] = STATE(19391),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(762),
    [sym_line_comment] = STATE(762),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5646),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [763] = {
    [sym__block] = STATE(18256),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(763),
    [sym_line_comment] = STATE(763),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5648),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [764] = {
    [sym__block] = STATE(19040),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(764),
    [sym_line_comment] = STATE(764),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5650),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [765] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(765),
    [sym_line_comment] = STATE(765),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5652),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [766] = {
    [sym__block] = STATE(18441),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(766),
    [sym_line_comment] = STATE(766),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4768),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [767] = {
    [sym__block] = STATE(18466),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(767),
    [sym_line_comment] = STATE(767),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5654),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [768] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11777),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17514),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(768),
    [sym_line_comment] = STATE(768),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5656),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [769] = {
    [sym__block] = STATE(18744),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(769),
    [sym_line_comment] = STATE(769),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5658),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [770] = {
    [sym__block] = STATE(18823),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(770),
    [sym_line_comment] = STATE(770),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5660),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [771] = {
    [sym__closed_assignment] = STATE(14462),
    [sym__expression] = STATE(11799),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18109),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(771),
    [sym_line_comment] = STATE(771),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [772] = {
    [sym__block] = STATE(18498),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(772),
    [sym_line_comment] = STATE(772),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5662),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [773] = {
    [sym__block] = STATE(18534),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(773),
    [sym_line_comment] = STATE(773),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5664),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [774] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11906),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17266),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(774),
    [sym_line_comment] = STATE(774),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5666),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [775] = {
    [sym__closed_assignment] = STATE(14567),
    [sym__expression] = STATE(11946),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18032),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(775),
    [sym_line_comment] = STATE(775),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2291),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [776] = {
    [sym__block] = STATE(18432),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(776),
    [sym_line_comment] = STATE(776),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5668),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [777] = {
    [sym__block] = STATE(18541),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(777),
    [sym_line_comment] = STATE(777),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4484),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [778] = {
    [sym__block] = STATE(18975),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(778),
    [sym_line_comment] = STATE(778),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4510),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [779] = {
    [sym__block] = STATE(19055),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(779),
    [sym_line_comment] = STATE(779),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5670),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [780] = {
    [sym__block] = STATE(19120),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(780),
    [sym_line_comment] = STATE(780),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5672),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [781] = {
    [sym__block] = STATE(19147),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(781),
    [sym_line_comment] = STATE(781),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5674),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [782] = {
    [sym__block] = STATE(19601),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(782),
    [sym_line_comment] = STATE(782),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5676),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [783] = {
    [sym__block] = STATE(18881),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(783),
    [sym_line_comment] = STATE(783),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5678),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [784] = {
    [sym__block] = STATE(19261),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(784),
    [sym_line_comment] = STATE(784),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4340),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [785] = {
    [sym__block] = STATE(18883),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(785),
    [sym_line_comment] = STATE(785),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5680),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [786] = {
    [sym__block] = STATE(18338),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(786),
    [sym_line_comment] = STATE(786),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5682),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [787] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(787),
    [sym_line_comment] = STATE(787),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5684),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [788] = {
    [sym__closed_assignment] = STATE(15846),
    [sym__expression] = STATE(12168),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(788),
    [sym_line_comment] = STATE(788),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5686),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5688),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5690),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [789] = {
    [sym__block] = STATE(18300),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(789),
    [sym_line_comment] = STATE(789),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5692),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [790] = {
    [sym__block] = STATE(18306),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(790),
    [sym_line_comment] = STATE(790),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [791] = {
    [sym__block] = STATE(18322),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(791),
    [sym_line_comment] = STATE(791),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5696),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [792] = {
    [sym__block] = STATE(18385),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(792),
    [sym_line_comment] = STATE(792),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5698),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [793] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(793),
    [sym_line_comment] = STATE(793),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [794] = {
    [sym__block] = STATE(18734),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(794),
    [sym_line_comment] = STATE(794),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5702),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [795] = {
    [sym__block] = STATE(18885),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(795),
    [sym_line_comment] = STATE(795),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5704),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [796] = {
    [sym__block] = STATE(18891),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(796),
    [sym_line_comment] = STATE(796),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5706),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [797] = {
    [sym__block] = STATE(18539),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(797),
    [sym_line_comment] = STATE(797),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5708),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [798] = {
    [sym__block] = STATE(18986),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(798),
    [sym_line_comment] = STATE(798),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4370),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [799] = {
    [sym__block] = STATE(18560),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(799),
    [sym_line_comment] = STATE(799),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5710),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [800] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11764),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17374),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(800),
    [sym_line_comment] = STATE(800),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5712),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [801] = {
    [sym__closed_assignment] = STATE(14310),
    [sym__expression] = STATE(11771),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18193),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(801),
    [sym_line_comment] = STATE(801),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2401),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2403),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [802] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(802),
    [sym_line_comment] = STATE(802),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5714),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [803] = {
    [sym__closed_assignment] = STATE(16173),
    [sym__expression] = STATE(12209),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(803),
    [sym_line_comment] = STATE(803),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5716),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5718),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5720),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [804] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(804),
    [sym_line_comment] = STATE(804),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5722),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [805] = {
    [sym__block] = STATE(18884),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(805),
    [sym_line_comment] = STATE(805),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5724),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [806] = {
    [sym__block] = STATE(18998),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(806),
    [sym_line_comment] = STATE(806),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5726),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [807] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(807),
    [sym_line_comment] = STATE(807),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5728),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [808] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11871),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17613),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(808),
    [sym_line_comment] = STATE(808),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5730),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [809] = {
    [sym__closed_assignment] = STATE(14472),
    [sym__expression] = STATE(11923),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18198),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(809),
    [sym_line_comment] = STATE(809),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [810] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(810),
    [sym_line_comment] = STATE(810),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5732),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [811] = {
    [sym__closed_assignment] = STATE(16578),
    [sym__expression] = STATE(12231),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(811),
    [sym_line_comment] = STATE(811),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5734),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5736),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [812] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(812),
    [sym_line_comment] = STATE(812),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5740),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [813] = {
    [sym__block] = STATE(19312),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(813),
    [sym_line_comment] = STATE(813),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5742),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [814] = {
    [sym__closed_assignment] = STATE(16563),
    [sym__expression] = STATE(12053),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(814),
    [sym_line_comment] = STATE(814),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5744),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5748),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [815] = {
    [sym__block] = STATE(19155),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(815),
    [sym_line_comment] = STATE(815),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5750),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [816] = {
    [sym__closed_assignment] = STATE(14559),
    [sym__expression] = STATE(11751),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18202),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(816),
    [sym_line_comment] = STATE(816),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2569),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [817] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(817),
    [sym_line_comment] = STATE(817),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5752),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [818] = {
    [sym__closed_assignment] = STATE(16646),
    [sym__expression] = STATE(12261),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(818),
    [sym_line_comment] = STATE(818),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5754),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5756),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5758),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [819] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(819),
    [sym_line_comment] = STATE(819),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5760),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [820] = {
    [sym__block] = STATE(18340),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(820),
    [sym_line_comment] = STATE(820),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5762),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [821] = {
    [sym__block] = STATE(19156),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(821),
    [sym_line_comment] = STATE(821),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5764),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [822] = {
    [sym__block] = STATE(19167),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(822),
    [sym_line_comment] = STATE(822),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5766),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [823] = {
    [sym__closed_assignment] = STATE(14646),
    [sym__expression] = STATE(11835),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18211),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(823),
    [sym_line_comment] = STATE(823),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2415),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2417),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [824] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(824),
    [sym_line_comment] = STATE(824),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5768),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [825] = {
    [sym__closed_assignment] = STATE(16724),
    [sym__expression] = STATE(12290),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(825),
    [sym_line_comment] = STATE(825),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5770),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5772),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5774),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [826] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(826),
    [sym_line_comment] = STATE(826),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5776),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [827] = {
    [sym__block] = STATE(18546),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(827),
    [sym_line_comment] = STATE(827),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5778),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [828] = {
    [sym__block] = STATE(19184),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(828),
    [sym_line_comment] = STATE(828),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5780),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [829] = {
    [sym__closed_assignment] = STATE(14724),
    [sym__expression] = STATE(11911),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18131),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(829),
    [sym_line_comment] = STATE(829),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2331),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2333),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [830] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(830),
    [sym_line_comment] = STATE(830),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5782),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [831] = {
    [sym__closed_assignment] = STATE(16818),
    [sym__expression] = STATE(12324),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(831),
    [sym_line_comment] = STATE(831),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5784),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5788),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [832] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(832),
    [sym_line_comment] = STATE(832),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5790),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [833] = {
    [sym__block] = STATE(18855),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(833),
    [sym_line_comment] = STATE(833),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5792),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [834] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(834),
    [sym_line_comment] = STATE(834),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5794),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [835] = {
    [sym__closed_assignment] = STATE(14867),
    [sym__expression] = STATE(11948),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18216),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(835),
    [sym_line_comment] = STATE(835),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2429),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2431),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [836] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(836),
    [sym_line_comment] = STATE(836),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [837] = {
    [sym__closed_assignment] = STATE(16905),
    [sym__expression] = STATE(12031),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(837),
    [sym_line_comment] = STATE(837),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5800),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5802),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [838] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(838),
    [sym_line_comment] = STATE(838),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5804),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [839] = {
    [sym__block] = STATE(19121),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(839),
    [sym_line_comment] = STATE(839),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5806),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [840] = {
    [sym__block] = STATE(19219),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(840),
    [sym_line_comment] = STATE(840),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5808),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [841] = {
    [sym__block] = STATE(17162),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(841),
    [sym_line_comment] = STATE(841),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4606),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [842] = {
    [sym__closed_assignment] = STATE(14958),
    [sym__expression] = STATE(11997),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18220),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(842),
    [sym_line_comment] = STATE(842),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2443),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2445),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [843] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(843),
    [sym_line_comment] = STATE(843),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5810),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [844] = {
    [sym__closed_assignment] = STATE(17005),
    [sym__expression] = STATE(12049),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(844),
    [sym_line_comment] = STATE(844),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5812),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5814),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5816),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [845] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(845),
    [sym_line_comment] = STATE(845),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5818),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [846] = {
    [sym__block] = STATE(19489),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(846),
    [sym_line_comment] = STATE(846),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5820),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [847] = {
    [sym__block] = STATE(18708),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(847),
    [sym_line_comment] = STATE(847),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4352),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [848] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11774),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17216),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(848),
    [sym_line_comment] = STATE(848),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [849] = {
    [sym__closed_assignment] = STATE(15102),
    [sym__expression] = STATE(11787),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17985),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(849),
    [sym_line_comment] = STATE(849),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2751),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [850] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(850),
    [sym_line_comment] = STATE(850),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5824),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [851] = {
    [sym__closed_assignment] = STATE(15915),
    [sym__expression] = STATE(12073),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(851),
    [sym_line_comment] = STATE(851),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5826),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5828),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5830),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [852] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(852),
    [sym_line_comment] = STATE(852),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5832),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [853] = {
    [sym__block] = STATE(19511),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(853),
    [sym_line_comment] = STATE(853),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [854] = {
    [sym__block] = STATE(18714),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(854),
    [sym_line_comment] = STATE(854),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5836),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [855] = {
    [sym__closed_assignment] = STATE(14789),
    [sym__expression] = STATE(11848),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17675),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(855),
    [sym_line_comment] = STATE(855),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2597),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2599),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [856] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(856),
    [sym_line_comment] = STATE(856),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5838),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [857] = {
    [sym__closed_assignment] = STATE(15370),
    [sym__expression] = STATE(12117),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(857),
    [sym_line_comment] = STATE(857),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5840),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5842),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [858] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(858),
    [sym_line_comment] = STATE(858),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5846),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [859] = {
    [sym__block] = STATE(19213),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(859),
    [sym_line_comment] = STATE(859),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5848),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [860] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(860),
    [sym_line_comment] = STATE(860),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5850),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [861] = {
    [sym__closed_assignment] = STATE(15559),
    [sym__expression] = STATE(12253),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(861),
    [sym_line_comment] = STATE(861),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5854),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [862] = {
    [sym__closed_assignment] = STATE(14526),
    [sym__expression] = STATE(11898),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17677),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(862),
    [sym_line_comment] = STATE(862),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2459),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [863] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(863),
    [sym_line_comment] = STATE(863),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5858),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [864] = {
    [sym__closed_assignment] = STATE(16224),
    [sym__expression] = STATE(12139),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(864),
    [sym_line_comment] = STATE(864),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5862),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5864),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [865] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(865),
    [sym_line_comment] = STATE(865),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5866),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [866] = {
    [sym__block] = STATE(19597),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(866),
    [sym_line_comment] = STATE(866),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5868),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [867] = {
    [sym__closed_assignment] = STATE(14455),
    [sym__expression] = STATE(11885),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18053),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(867),
    [sym_line_comment] = STATE(867),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2085),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [868] = {
    [sym__block] = STATE(19266),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(868),
    [sym_line_comment] = STATE(868),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5870),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [869] = {
    [sym__closed_assignment] = STATE(14984),
    [sym__expression] = STATE(11815),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18158),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(869),
    [sym_line_comment] = STATE(869),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2359),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2361),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [870] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(870),
    [sym_line_comment] = STATE(870),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [871] = {
    [sym__closed_assignment] = STATE(17033),
    [sym__expression] = STATE(12170),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(871),
    [sym_line_comment] = STATE(871),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5874),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5876),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5878),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [872] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(872),
    [sym_line_comment] = STATE(872),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5880),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [873] = {
    [sym__block] = STATE(19598),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(873),
    [sym_line_comment] = STATE(873),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5882),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [874] = {
    [sym__block] = STATE(19274),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(874),
    [sym_line_comment] = STATE(874),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5884),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [875] = {
    [sym__closed_assignment] = STATE(14548),
    [sym__expression] = STATE(11748),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17679),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(875),
    [sym_line_comment] = STATE(875),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2471),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2473),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [876] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(876),
    [sym_line_comment] = STATE(876),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5886),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [877] = {
    [sym__closed_assignment] = STATE(15603),
    [sym__expression] = STATE(12186),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(877),
    [sym_line_comment] = STATE(877),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5888),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5890),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5892),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [878] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(878),
    [sym_line_comment] = STATE(878),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5894),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [879] = {
    [sym__block] = STATE(18940),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(879),
    [sym_line_comment] = STATE(879),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5896),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [880] = {
    [sym__block] = STATE(18504),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(880),
    [sym_line_comment] = STATE(880),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5898),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [881] = {
    [sym__block] = STATE(19298),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(881),
    [sym_line_comment] = STATE(881),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5900),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [882] = {
    [sym__closed_assignment] = STATE(14697),
    [sym__expression] = STATE(11932),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18167),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(882),
    [sym_line_comment] = STATE(882),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2373),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2375),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [883] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(883),
    [sym_line_comment] = STATE(883),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5902),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [884] = {
    [sym__closed_assignment] = STATE(16143),
    [sym__expression] = STATE(12201),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(884),
    [sym_line_comment] = STATE(884),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5904),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5906),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5908),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [885] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(885),
    [sym_line_comment] = STATE(885),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5910),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [886] = {
    [sym__block] = STATE(18772),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(886),
    [sym_line_comment] = STATE(886),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5912),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [887] = {
    [sym__block] = STATE(19344),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(887),
    [sym_line_comment] = STATE(887),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5914),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [888] = {
    [sym__closed_assignment] = STATE(14873),
    [sym__expression] = STATE(11843),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17687),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(888),
    [sym_line_comment] = STATE(888),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2513),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2515),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [889] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(889),
    [sym_line_comment] = STATE(889),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5916),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [890] = {
    [sym__closed_assignment] = STATE(16630),
    [sym__expression] = STATE(12381),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(890),
    [sym_line_comment] = STATE(890),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5918),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5920),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5922),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [891] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(891),
    [sym_line_comment] = STATE(891),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5924),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [892] = {
    [sym__block] = STATE(18360),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(892),
    [sym_line_comment] = STATE(892),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5926),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [893] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(893),
    [sym_line_comment] = STATE(893),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5928),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [894] = {
    [sym__block] = STATE(18566),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(894),
    [sym_line_comment] = STATE(894),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5930),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [895] = {
    [sym__closed_assignment] = STATE(14314),
    [sym__expression] = STATE(11875),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17690),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(895),
    [sym_line_comment] = STATE(895),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2527),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2529),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [896] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(896),
    [sym_line_comment] = STATE(896),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5932),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [897] = {
    [sym__closed_assignment] = STATE(16863),
    [sym__expression] = STATE(12228),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(897),
    [sym_line_comment] = STATE(897),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5934),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5936),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5938),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [898] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(898),
    [sym_line_comment] = STATE(898),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5940),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [899] = {
    [sym__block] = STATE(18987),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(899),
    [sym_line_comment] = STATE(899),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5942),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [900] = {
    [sym__block] = STATE(18567),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(900),
    [sym_line_comment] = STATE(900),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5944),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [901] = {
    [sym__closed_assignment] = STATE(14477),
    [sym__expression] = STATE(11907),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17692),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(901),
    [sym_line_comment] = STATE(901),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2837),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [902] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(902),
    [sym_line_comment] = STATE(902),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5946),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [903] = {
    [sym__closed_assignment] = STATE(17000),
    [sym__expression] = STATE(12252),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(903),
    [sym_line_comment] = STATE(903),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5948),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5950),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5952),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [904] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(904),
    [sym_line_comment] = STATE(904),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5954),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [905] = {
    [sym__block] = STATE(19484),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(905),
    [sym_line_comment] = STATE(905),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5956),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [906] = {
    [sym__block] = STATE(19551),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(906),
    [sym_line_comment] = STATE(906),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5958),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [907] = {
    [sym__closed_assignment] = STATE(14528),
    [sym__expression] = STATE(11801),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17693),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(907),
    [sym_line_comment] = STATE(907),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2681),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [908] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(908),
    [sym_line_comment] = STATE(908),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5960),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [909] = {
    [sym__closed_assignment] = STATE(15404),
    [sym__expression] = STATE(12277),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(909),
    [sym_line_comment] = STATE(909),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5962),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5964),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [910] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(910),
    [sym_line_comment] = STATE(910),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5968),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [911] = {
    [sym__block] = STATE(18635),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(911),
    [sym_line_comment] = STATE(911),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5970),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [912] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11756),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17172),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(912),
    [sym_line_comment] = STATE(912),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5972),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [913] = {
    [sym__closed_assignment] = STATE(14700),
    [sym__expression] = STATE(11765),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17956),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(913),
    [sym_line_comment] = STATE(913),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [914] = {
    [sym__closed_assignment] = STATE(14624),
    [sym__expression] = STATE(11868),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17696),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(914),
    [sym_line_comment] = STATE(914),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2863),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2865),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [915] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(915),
    [sym_line_comment] = STATE(915),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [916] = {
    [sym__closed_assignment] = STATE(15503),
    [sym__expression] = STATE(12296),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(916),
    [sym_line_comment] = STATE(916),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5980),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [917] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(917),
    [sym_line_comment] = STATE(917),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5982),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [918] = {
    [sym__block] = STATE(18587),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(918),
    [sym_line_comment] = STATE(918),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5984),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [919] = {
    [sym__block] = STATE(18665),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(919),
    [sym_line_comment] = STATE(919),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5986),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [920] = {
    [sym__block] = STATE(19422),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(920),
    [sym_line_comment] = STATE(920),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5988),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [921] = {
    [sym__closed_assignment] = STATE(14717),
    [sym__expression] = STATE(11891),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17697),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(921),
    [sym_line_comment] = STATE(921),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2695),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2697),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [922] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(922),
    [sym_line_comment] = STATE(922),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5990),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [923] = {
    [sym__closed_assignment] = STATE(15601),
    [sym__expression] = STATE(12346),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(923),
    [sym_line_comment] = STATE(923),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(5994),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(5996),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [924] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(924),
    [sym_line_comment] = STATE(924),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(5998),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [925] = {
    [sym__block] = STATE(18742),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(925),
    [sym_line_comment] = STATE(925),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6000),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [926] = {
    [sym__block] = STATE(18675),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(926),
    [sym_line_comment] = STATE(926),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4620),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [927] = {
    [sym__block] = STATE(18676),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(927),
    [sym_line_comment] = STATE(927),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6002),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [928] = {
    [sym__closed_assignment] = STATE(14807),
    [sym__expression] = STATE(11928),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17700),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(928),
    [sym_line_comment] = STATE(928),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2555),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2557),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [929] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(929),
    [sym_line_comment] = STATE(929),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6004),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [930] = {
    [sym__closed_assignment] = STATE(15980),
    [sym__expression] = STATE(12017),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(930),
    [sym_line_comment] = STATE(930),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6006),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6008),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6010),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [931] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(931),
    [sym_line_comment] = STATE(931),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6012),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [932] = {
    [sym__block] = STATE(18391),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(932),
    [sym_line_comment] = STATE(932),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6014),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [933] = {
    [sym__block] = STATE(18677),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(933),
    [sym_line_comment] = STATE(933),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6016),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [934] = {
    [sym__block] = STATE(18678),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(934),
    [sym_line_comment] = STATE(934),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6018),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [935] = {
    [sym__closed_assignment] = STATE(14905),
    [sym__expression] = STATE(11847),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(935),
    [sym_line_comment] = STATE(935),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2893),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [936] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(936),
    [sym_line_comment] = STATE(936),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6020),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [937] = {
    [sym__closed_assignment] = STATE(16093),
    [sym__expression] = STATE(12032),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(937),
    [sym_line_comment] = STATE(937),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6022),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6024),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6026),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [938] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(938),
    [sym_line_comment] = STATE(938),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6028),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [939] = {
    [sym__block] = STATE(19602),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(939),
    [sym_line_comment] = STATE(939),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6030),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [940] = {
    [sym__block] = STATE(18680),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(940),
    [sym_line_comment] = STATE(940),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6032),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [941] = {
    [sym_open_tuple] = STATE(15258),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12486),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10289),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12515),
    [sym_unary_expression] = STATE(12515),
    [sym_range_expression] = STATE(12515),
    [sym_splat_expression] = STATE(12515),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12040),
    [sym_unary_typed_expression] = STATE(12515),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12515),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12042),
    [sym_block_comment] = STATE(941),
    [sym_line_comment] = STATE(941),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5134),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(5134),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [942] = {
    [sym__closed_assignment] = STATE(14978),
    [sym__expression] = STATE(11778),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17704),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(942),
    [sym_line_comment] = STATE(942),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2737),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2739),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [943] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(943),
    [sym_line_comment] = STATE(943),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6034),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [944] = {
    [sym__closed_assignment] = STATE(16170),
    [sym__expression] = STATE(12051),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(944),
    [sym_line_comment] = STATE(944),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6036),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6038),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6040),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [945] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(945),
    [sym_line_comment] = STATE(945),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6042),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [946] = {
    [sym__block] = STATE(18748),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(946),
    [sym_line_comment] = STATE(946),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6044),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [947] = {
    [sym__block] = STATE(18690),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(947),
    [sym_line_comment] = STATE(947),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4424),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [948] = {
    [sym__block] = STATE(19572),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(948),
    [sym_line_comment] = STATE(948),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4686),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [949] = {
    [sym__closed_assignment] = STATE(15033),
    [sym__expression] = STATE(11910),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17705),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(949),
    [sym_line_comment] = STATE(949),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2583),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [950] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(950),
    [sym_line_comment] = STATE(950),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6046),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [951] = {
    [sym__closed_assignment] = STATE(16266),
    [sym__expression] = STATE(12069),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(951),
    [sym_line_comment] = STATE(951),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6048),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6050),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6052),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [952] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(952),
    [sym_line_comment] = STATE(952),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6054),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [953] = {
    [sym__block] = STATE(19249),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(953),
    [sym_line_comment] = STATE(953),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6056),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [954] = {
    [sym__block] = STATE(18692),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(954),
    [sym_line_comment] = STATE(954),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6058),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [955] = {
    [sym__closed_assignment] = STATE(15065),
    [sym__expression] = STATE(11773),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17708),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(955),
    [sym_line_comment] = STATE(955),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2765),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2767),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [956] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(956),
    [sym_line_comment] = STATE(956),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6060),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [957] = {
    [sym__closed_assignment] = STATE(16565),
    [sym__expression] = STATE(12085),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(957),
    [sym_line_comment] = STATE(957),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6062),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6064),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6066),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [958] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(958),
    [sym_line_comment] = STATE(958),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6068),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [959] = {
    [sym__block] = STATE(19243),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(959),
    [sym_line_comment] = STATE(959),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6070),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [960] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(960),
    [sym_line_comment] = STATE(960),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6072),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [961] = {
    [sym__closed_assignment] = STATE(16793),
    [sym__expression] = STATE(12239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(961),
    [sym_line_comment] = STATE(961),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6074),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6076),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6078),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [962] = {
    [sym__closed_assignment] = STATE(14492),
    [sym__expression] = STATE(11859),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17710),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(962),
    [sym_line_comment] = STATE(962),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2611),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2613),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [963] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(963),
    [sym_line_comment] = STATE(963),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6080),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [964] = {
    [sym__closed_assignment] = STATE(16633),
    [sym__expression] = STATE(12119),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(964),
    [sym_line_comment] = STATE(964),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6082),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6084),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6086),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [965] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(965),
    [sym_line_comment] = STATE(965),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6088),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [966] = {
    [sym__block] = STATE(18302),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(966),
    [sym_line_comment] = STATE(966),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6090),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [967] = {
    [sym__block] = STATE(18757),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(967),
    [sym_line_comment] = STATE(967),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6092),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [968] = {
    [sym__block] = STATE(18760),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(968),
    [sym_line_comment] = STATE(968),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6094),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [969] = {
    [sym__closed_assignment] = STATE(14353),
    [sym__expression] = STATE(11930),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17683),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(969),
    [sym_line_comment] = STATE(969),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2485),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [970] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(970),
    [sym_line_comment] = STATE(970),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6096),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [971] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(971),
    [sym_line_comment] = STATE(971),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6098),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [972] = {
    [sym__block] = STATE(18761),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(972),
    [sym_line_comment] = STATE(972),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6100),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [973] = {
    [sym__block] = STATE(18775),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(973),
    [sym_line_comment] = STATE(973),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6102),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [974] = {
    [sym__closed_assignment] = STATE(14731),
    [sym__expression] = STATE(11964),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17713),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(974),
    [sym_line_comment] = STATE(974),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2625),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2627),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [975] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(975),
    [sym_line_comment] = STATE(975),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6104),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [976] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(976),
    [sym_line_comment] = STATE(976),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6106),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [977] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(977),
    [sym_line_comment] = STATE(977),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6108),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [978] = {
    [sym__closed_assignment] = STATE(14938),
    [sym__expression] = STATE(11776),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17684),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(978),
    [sym_line_comment] = STATE(978),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2499),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2501),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [979] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(979),
    [sym_line_comment] = STATE(979),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6110),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [980] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(980),
    [sym_line_comment] = STATE(980),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6112),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [981] = {
    [sym__block] = STATE(18818),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(981),
    [sym_line_comment] = STATE(981),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6114),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [982] = {
    [sym__closed_assignment] = STATE(14332),
    [sym__expression] = STATE(11790),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17716),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(982),
    [sym_line_comment] = STATE(982),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2639),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2641),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [983] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(983),
    [sym_line_comment] = STATE(983),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6116),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [984] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(984),
    [sym_line_comment] = STATE(984),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6118),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [985] = {
    [sym__block] = STATE(18232),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(985),
    [sym_line_comment] = STATE(985),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6120),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [986] = {
    [sym__block] = STATE(18236),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(986),
    [sym_line_comment] = STATE(986),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6122),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [987] = {
    [sym__closed_assignment] = STATE(14527),
    [sym__expression] = STATE(11798),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17720),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(987),
    [sym_line_comment] = STATE(987),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [988] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(988),
    [sym_line_comment] = STATE(988),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6124),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [989] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(989),
    [sym_line_comment] = STATE(989),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6126),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [990] = {
    [sym__block] = STATE(18238),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(990),
    [sym_line_comment] = STATE(990),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6128),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [991] = {
    [sym__block] = STATE(18254),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(991),
    [sym_line_comment] = STATE(991),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6130),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [992] = {
    [sym__closed_assignment] = STATE(14702),
    [sym__expression] = STATE(11803),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17722),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(992),
    [sym_line_comment] = STATE(992),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2821),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [993] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(993),
    [sym_line_comment] = STATE(993),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6132),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [994] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(994),
    [sym_line_comment] = STATE(994),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6134),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [995] = {
    [sym__block] = STATE(18325),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(995),
    [sym_line_comment] = STATE(995),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [996] = {
    [sym__closed_assignment] = STATE(14802),
    [sym__expression] = STATE(11813),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17724),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(996),
    [sym_line_comment] = STATE(996),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2667),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [997] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(997),
    [sym_line_comment] = STATE(997),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6136),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [998] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(998),
    [sym_line_comment] = STATE(998),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6138),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [999] = {
    [sym_open_tuple] = STATE(15258),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12486),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10289),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12515),
    [sym_unary_expression] = STATE(12515),
    [sym_range_expression] = STATE(12515),
    [sym_splat_expression] = STATE(12515),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12040),
    [sym_unary_typed_expression] = STATE(12515),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12515),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12042),
    [sym_block_comment] = STATE(999),
    [sym_line_comment] = STATE(999),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4984),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_finally] = ACTIONS(4984),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1000] = {
    [sym__block] = STATE(18331),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1000),
    [sym_line_comment] = STATE(1000),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6140),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1001] = {
    [sym__closed_assignment] = STATE(14884),
    [sym__expression] = STATE(11825),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17729),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1001),
    [sym_line_comment] = STATE(1001),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2975),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2977),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1002] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1002),
    [sym_line_comment] = STATE(1002),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1003] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1003),
    [sym_line_comment] = STATE(1003),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6144),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1004] = {
    [sym__closed_assignment] = STATE(14970),
    [sym__expression] = STATE(11850),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17732),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1004),
    [sym_line_comment] = STATE(1004),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2907),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1005] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1005),
    [sym_line_comment] = STATE(1005),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6146),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1006] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1006),
    [sym_line_comment] = STATE(1006),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6148),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1007] = {
    [sym__block] = STATE(18989),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1007),
    [sym_line_comment] = STATE(1007),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6150),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1008] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1008),
    [sym_line_comment] = STATE(1008),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6152),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1009] = {
    [sym__closed_assignment] = STATE(15050),
    [sym__expression] = STATE(11878),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17734),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1009),
    [sym_line_comment] = STATE(1009),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2781),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1010] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1010),
    [sym_line_comment] = STATE(1010),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6154),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1011] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1011),
    [sym_line_comment] = STATE(1011),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6156),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1012] = {
    [sym__closed_assignment] = STATE(16721),
    [sym__expression] = STATE(12289),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1012),
    [sym_line_comment] = STATE(1012),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6158),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6160),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6162),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1013] = {
    [sym__block] = STATE(18269),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1013),
    [sym_line_comment] = STATE(1013),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6164),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1014] = {
    [sym__closed_assignment] = STATE(14312),
    [sym__expression] = STATE(11893),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1014),
    [sym_line_comment] = STATE(1014),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2989),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1015] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1015),
    [sym_line_comment] = STATE(1015),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6166),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1016] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1016),
    [sym_line_comment] = STATE(1016),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6168),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1017] = {
    [sym__block] = STATE(19063),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1017),
    [sym_line_comment] = STATE(1017),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6170),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1018] = {
    [sym__closed_assignment] = STATE(14333),
    [sym__expression] = STATE(11900),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17738),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1018),
    [sym_line_comment] = STATE(1018),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2919),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2921),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1019] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1019),
    [sym_line_comment] = STATE(1019),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6172),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1020] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1020),
    [sym_line_comment] = STATE(1020),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6174),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1021] = {
    [sym__block] = STATE(19082),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1021),
    [sym_line_comment] = STATE(1021),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6176),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1022] = {
    [sym__block] = STATE(18542),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1022),
    [sym_line_comment] = STATE(1022),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6178),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1023] = {
    [sym__closed_assignment] = STATE(14352),
    [sym__expression] = STATE(11918),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17740),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1023),
    [sym_line_comment] = STATE(1023),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2793),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1024] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1024),
    [sym_line_comment] = STATE(1024),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6180),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1025] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1025),
    [sym_line_comment] = STATE(1025),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6182),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1026] = {
    [sym__block] = STATE(18547),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1026),
    [sym_line_comment] = STATE(1026),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6184),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1027] = {
    [sym__block] = STATE(18551),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1027),
    [sym_line_comment] = STATE(1027),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6186),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1028] = {
    [sym__closed_assignment] = STATE(14372),
    [sym__expression] = STATE(11924),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17717),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1028),
    [sym_line_comment] = STATE(1028),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1029] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1029),
    [sym_line_comment] = STATE(1029),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6188),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1030] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11905),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17205),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1030),
    [sym_line_comment] = STATE(1030),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6190),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1031] = {
    [sym__closed_assignment] = STATE(14927),
    [sym__expression] = STATE(11913),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17983),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1031),
    [sym_line_comment] = STATE(1031),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2239),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2241),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1032] = {
    [sym__block] = STATE(19217),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1032),
    [sym_line_comment] = STATE(1032),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6192),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1033] = {
    [sym__closed_assignment] = STATE(14399),
    [sym__expression] = STATE(11941),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17741),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1033),
    [sym_line_comment] = STATE(1033),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1034] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1034),
    [sym_line_comment] = STATE(1034),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6194),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1035] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1035),
    [sym_line_comment] = STATE(1035),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1036] = {
    [sym__block] = STATE(18586),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1036),
    [sym_line_comment] = STATE(1036),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6198),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1037] = {
    [sym__block] = STATE(19220),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1037),
    [sym_line_comment] = STATE(1037),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4774),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1038] = {
    [sym__closed_assignment] = STATE(14432),
    [sym__expression] = STATE(11950),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17742),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1038),
    [sym_line_comment] = STATE(1038),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2709),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2711),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1039] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1039),
    [sym_line_comment] = STATE(1039),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6200),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1040] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1040),
    [sym_line_comment] = STATE(1040),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6202),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1041] = {
    [sym__block] = STATE(19221),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1041),
    [sym_line_comment] = STATE(1041),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6204),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1042] = {
    [sym__block] = STATE(19222),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1042),
    [sym_line_comment] = STATE(1042),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6206),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1043] = {
    [sym__closed_assignment] = STATE(14475),
    [sym__expression] = STATE(11957),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17726),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1043),
    [sym_line_comment] = STATE(1043),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2723),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1044] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1044),
    [sym_line_comment] = STATE(1044),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6208),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1045] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1045),
    [sym_line_comment] = STATE(1045),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6210),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1046] = {
    [sym__block] = STATE(19223),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1046),
    [sym_line_comment] = STATE(1046),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6212),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1047] = {
    [sym__block] = STATE(19225),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1047),
    [sym_line_comment] = STATE(1047),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6214),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1048] = {
    [sym__closed_assignment] = STATE(14508),
    [sym__expression] = STATE(11960),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17744),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1048),
    [sym_line_comment] = STATE(1048),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2879),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1049] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1049),
    [sym_line_comment] = STATE(1049),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6216),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1050] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1050),
    [sym_line_comment] = STATE(1050),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6218),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1051] = {
    [sym__block] = STATE(19235),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1051),
    [sym_line_comment] = STATE(1051),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4388),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1052] = {
    [sym__closed_assignment] = STATE(14544),
    [sym__expression] = STATE(11969),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17745),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1052),
    [sym_line_comment] = STATE(1052),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3031),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3033),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1053] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1053),
    [sym_line_comment] = STATE(1053),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6220),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1054] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1054),
    [sym_line_comment] = STATE(1054),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6222),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1055] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1055),
    [sym_line_comment] = STATE(1055),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6224),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1056] = {
    [sym__block] = STATE(19237),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1056),
    [sym_line_comment] = STATE(1056),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6226),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1057] = {
    [sym__closed_assignment] = STATE(14568),
    [sym__expression] = STATE(11987),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17748),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1057),
    [sym_line_comment] = STATE(1057),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3003),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3005),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1058] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1058),
    [sym_line_comment] = STATE(1058),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6228),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1059] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1059),
    [sym_line_comment] = STATE(1059),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6230),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1060] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1060),
    [sym_line_comment] = STATE(1060),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6232),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1061] = {
    [sym__closed_assignment] = STATE(14598),
    [sym__expression] = STATE(11943),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17750),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1061),
    [sym_line_comment] = STATE(1061),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1062] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1062),
    [sym_line_comment] = STATE(1062),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6234),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1063] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1063),
    [sym_line_comment] = STATE(1063),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1064] = {
    [sym__closed_assignment] = STATE(16956),
    [sym__expression] = STATE(12339),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1064),
    [sym_line_comment] = STATE(1064),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6238),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6240),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6242),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1065] = {
    [sym__block] = STATE(19282),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1065),
    [sym_line_comment] = STATE(1065),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6244),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1066] = {
    [sym__closed_assignment] = STATE(14648),
    [sym__expression] = STATE(11933),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17751),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1066),
    [sym_line_comment] = STATE(1066),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2849),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1067] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1067),
    [sym_line_comment] = STATE(1067),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6246),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1068] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1068),
    [sym_line_comment] = STATE(1068),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6248),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1069] = {
    [sym__block] = STATE(19283),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1069),
    [sym_line_comment] = STATE(1069),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1070] = {
    [sym__closed_assignment] = STATE(14684),
    [sym__expression] = STATE(11867),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17753),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1070),
    [sym_line_comment] = STATE(1070),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3045),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3047),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1071] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1071),
    [sym_line_comment] = STATE(1071),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1072] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1072),
    [sym_line_comment] = STATE(1072),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6254),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1073] = {
    [sym__block] = STATE(19284),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1073),
    [sym_line_comment] = STATE(1073),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6256),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1074] = {
    [sym__closed_assignment] = STATE(14732),
    [sym__expression] = STATE(11819),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17755),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1074),
    [sym_line_comment] = STATE(1074),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(3017),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(3019),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1075] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1075),
    [sym_line_comment] = STATE(1075),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6258),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1076] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1076),
    [sym_line_comment] = STATE(1076),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6260),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1077] = {
    [sym__block] = STATE(19290),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1077),
    [sym_line_comment] = STATE(1077),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6262),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1078] = {
    [sym__closed_assignment] = STATE(14761),
    [sym__expression] = STATE(11834),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17759),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1078),
    [sym_line_comment] = STATE(1078),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2961),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1079] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1079),
    [sym_line_comment] = STATE(1079),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6264),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1080] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1080),
    [sym_line_comment] = STATE(1080),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6266),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1081] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1081),
    [sym_line_comment] = STATE(1081),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6268),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1082] = {
    [sym__block] = STATE(19314),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1082),
    [sym_line_comment] = STATE(1082),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6270),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1083] = {
    [sym__block] = STATE(18814),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1083),
    [sym_line_comment] = STATE(1083),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6272),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1084] = {
    [sym_open_tuple] = STATE(15309),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12405),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(1084),
    [sym_line_comment] = STATE(1084),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(5134),
    [anon_sym_finally] = ACTIONS(5134),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1085] = {
    [sym__block] = STATE(18659),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1085),
    [sym_line_comment] = STATE(1085),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6274),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1086] = {
    [sym__block] = STATE(18643),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1086),
    [sym_line_comment] = STATE(1086),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6276),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1087] = {
    [sym__block] = STATE(19014),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1087),
    [sym_line_comment] = STATE(1087),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6278),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1088] = {
    [sym_open_tuple] = STATE(15309),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12405),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(1088),
    [sym_line_comment] = STATE(1088),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_catch] = ACTIONS(4984),
    [anon_sym_finally] = ACTIONS(4984),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1089] = {
    [sym__block] = STATE(19169),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1089),
    [sym_line_comment] = STATE(1089),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6280),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1090] = {
    [sym__block] = STATE(19462),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1090),
    [sym_line_comment] = STATE(1090),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6282),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1091] = {
    [sym__block] = STATE(18934),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1091),
    [sym_line_comment] = STATE(1091),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6284),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1092] = {
    [sym__block] = STATE(19141),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1092),
    [sym_line_comment] = STATE(1092),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6286),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1093] = {
    [sym__block] = STATE(19142),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1093),
    [sym_line_comment] = STATE(1093),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6288),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1094] = {
    [sym__block] = STATE(19486),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1094),
    [sym_line_comment] = STATE(1094),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6290),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1095] = {
    [sym__block] = STATE(19487),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1095),
    [sym_line_comment] = STATE(1095),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6292),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1096] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11934),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17565),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1096),
    [sym_line_comment] = STATE(1096),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6294),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1097] = {
    [sym__block] = STATE(19454),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1097),
    [sym_line_comment] = STATE(1097),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6296),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1098] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11816),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17484),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1098),
    [sym_line_comment] = STATE(1098),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6298),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1099] = {
    [sym__closed_assignment] = STATE(14877),
    [sym__expression] = STATE(11949),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(18143),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1099),
    [sym_line_comment] = STATE(1099),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(2345),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(2347),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1100] = {
    [sym__block] = STATE(18497),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1100),
    [sym_line_comment] = STATE(1100),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6300),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1101] = {
    [sym__closed_assignment] = STATE(16102),
    [sym__expression] = STATE(11953),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1101),
    [sym_line_comment] = STATE(1101),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(5472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6302),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1102] = {
    [sym__block] = STATE(19265),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1102),
    [sym_line_comment] = STATE(1102),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4614),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1103] = {
    [sym__block] = STATE(19534),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1103),
    [sym_line_comment] = STATE(1103),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6304),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1104] = {
    [sym__block] = STATE(18819),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1104),
    [sym_line_comment] = STATE(1104),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6306),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1105] = {
    [sym__block] = STATE(18724),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1105),
    [sym_line_comment] = STATE(1105),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6308),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1106] = {
    [sym__block] = STATE(19518),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1106),
    [sym_line_comment] = STATE(1106),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6310),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1107] = {
    [sym__closed_assignment] = STATE(15019),
    [sym__expression] = STATE(11956),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10390),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17754),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12406),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1107),
    [sym_line_comment] = STATE(1107),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(1955),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1108] = {
    [sym__block] = STATE(18926),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1108),
    [sym_line_comment] = STATE(1108),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4394),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1109] = {
    [sym__block] = STATE(18246),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1109),
    [sym_line_comment] = STATE(1109),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6312),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1110] = {
    [sym__block] = STATE(18978),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1110),
    [sym_line_comment] = STATE(1110),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6314),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1111] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1111),
    [sym_line_comment] = STATE(1111),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6316),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1112] = {
    [sym__closed_assignment] = STATE(16826),
    [sym__expression] = STATE(12133),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1112),
    [sym_line_comment] = STATE(1112),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6318),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6320),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(6322),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1113] = {
    [sym__block] = STATE(19529),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1113),
    [sym_line_comment] = STATE(1113),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6324),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1114] = {
    [sym__block] = STATE(18405),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1114),
    [sym_line_comment] = STATE(1114),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6326),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1115] = {
    [sym__block] = STATE(19061),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1115),
    [sym_line_comment] = STATE(1115),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6328),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1116] = {
    [sym__block] = STATE(19046),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1116),
    [sym_line_comment] = STATE(1116),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6330),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1117] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1117),
    [sym_line_comment] = STATE(1117),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_RBRACK] = ACTIONS(6332),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1118] = {
    [sym__block] = STATE(19016),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1118),
    [sym_line_comment] = STATE(1118),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6334),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1119] = {
    [sym__block] = STATE(19162),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1119),
    [sym_line_comment] = STATE(1119),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4328),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1120] = {
    [sym__block] = STATE(18260),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1120),
    [sym_line_comment] = STATE(1120),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4608),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1121] = {
    [sym__block] = STATE(18261),
    [sym_open_tuple] = STATE(15324),
    [sym_assignment] = STATE(16080),
    [sym__expression] = STATE(12752),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1121),
    [sym_line_comment] = STATE(1121),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(6336),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1122] = {
    [sym__closed_assignment] = STATE(16310),
    [sym__expression] = STATE(12174),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1122),
    [sym_line_comment] = STATE(1122),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6338),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6340),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1123] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1123),
    [sym_line_comment] = STATE(1123),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6342),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1124] = {
    [sym__closed_assignment] = STATE(9464),
    [sym__expression] = STATE(9250),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_matrix_row] = STATE(17517),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(1124),
    [sym_line_comment] = STATE(1124),
    [aux_sym_matrix_row_repeat1] = STATE(585),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1125] = {
    [sym__closed_assignment] = STATE(16941),
    [sym__expression] = STATE(12379),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1125),
    [sym_line_comment] = STATE(1125),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6344),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6346),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1126] = {
    [sym__closed_assignment] = STATE(17403),
    [sym__expression] = STATE(13526),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1126),
    [sym_line_comment] = STATE(1126),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6348),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6350),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1127] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1127),
    [sym_line_comment] = STATE(1127),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6352),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1128] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1128),
    [sym_line_comment] = STATE(1128),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6354),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1129] = {
    [sym__closed_assignment] = STATE(16229),
    [sym__expression] = STATE(12034),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1129),
    [sym_line_comment] = STATE(1129),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6356),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6358),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1130] = {
    [sym__closed_assignment] = STATE(17064),
    [sym__expression] = STATE(12187),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1130),
    [sym_line_comment] = STATE(1130),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6360),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6362),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1131] = {
    [sym__closed_assignment] = STATE(16927),
    [sym__expression] = STATE(12059),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1131),
    [sym_line_comment] = STATE(1131),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6364),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6366),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1132] = {
    [sym__closed_assignment] = STATE(17103),
    [sym__expression] = STATE(13529),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1132),
    [sym_line_comment] = STATE(1132),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6368),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6370),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1133] = {
    [sym__closed_assignment] = STATE(17375),
    [sym__expression] = STATE(13879),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1133),
    [sym_line_comment] = STATE(1133),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6372),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6374),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1134] = {
    [sym__closed_assignment] = STATE(17074),
    [sym__expression] = STATE(13930),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1134),
    [sym_line_comment] = STATE(1134),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6376),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6378),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1135] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1135),
    [sym_line_comment] = STATE(1135),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6380),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1136] = {
    [sym__closed_assignment] = STATE(17360),
    [sym__expression] = STATE(13559),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1136),
    [sym_line_comment] = STATE(1136),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6382),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6384),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1137] = {
    [sym__closed_assignment] = STATE(16611),
    [sym__expression] = STATE(12211),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1137),
    [sym_line_comment] = STATE(1137),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6386),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6388),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1138] = {
    [sym__closed_assignment] = STATE(17504),
    [sym__expression] = STATE(13533),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1138),
    [sym_line_comment] = STATE(1138),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6390),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6392),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1139] = {
    [sym__closed_assignment] = STATE(16135),
    [sym__expression] = STATE(12124),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1139),
    [sym_line_comment] = STATE(1139),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6394),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6396),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1140] = {
    [sym__closed_assignment] = STATE(16342),
    [sym__expression] = STATE(12052),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1140),
    [sym_line_comment] = STATE(1140),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6398),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6400),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1141] = {
    [sym__closed_assignment] = STATE(15433),
    [sym__expression] = STATE(12229),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1141),
    [sym_line_comment] = STATE(1141),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6402),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6404),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1142] = {
    [sym__closed_assignment] = STATE(17053),
    [sym__expression] = STATE(12038),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1142),
    [sym_line_comment] = STATE(1142),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6406),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6408),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1143] = {
    [sym__closed_assignment] = STATE(16791),
    [sym__expression] = STATE(12202),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1143),
    [sym_line_comment] = STATE(1143),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6410),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6412),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1144] = {
    [sym__closed_assignment] = STATE(17299),
    [sym__expression] = STATE(13536),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1144),
    [sym_line_comment] = STATE(1144),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6414),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6416),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1145] = {
    [sym__closed_assignment] = STATE(17324),
    [sym__expression] = STATE(13949),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1145),
    [sym_line_comment] = STATE(1145),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6418),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6420),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1146] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1146),
    [sym_line_comment] = STATE(1146),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6422),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1147] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1147),
    [sym_line_comment] = STATE(1147),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6424),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1148] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1148),
    [sym_line_comment] = STATE(1148),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6426),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1149] = {
    [sym__closed_assignment] = STATE(17431),
    [sym__expression] = STATE(13600),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1149),
    [sym_line_comment] = STATE(1149),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6428),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6430),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1150] = {
    [sym__closed_assignment] = STATE(17519),
    [sym__expression] = STATE(13539),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1150),
    [sym_line_comment] = STATE(1150),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6432),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6434),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1151] = {
    [sym__closed_assignment] = STATE(16606),
    [sym__expression] = STATE(12071),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1151),
    [sym_line_comment] = STATE(1151),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6436),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6438),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1152] = {
    [sym__closed_assignment] = STATE(17438),
    [sym__expression] = STATE(13723),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1152),
    [sym_line_comment] = STATE(1152),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6440),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6442),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1153] = {
    [sym__closed_assignment] = STATE(17458),
    [sym__expression] = STATE(13921),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1153),
    [sym_line_comment] = STATE(1153),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6444),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6446),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1154] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1154),
    [sym_line_comment] = STATE(1154),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6448),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1155] = {
    [sym__closed_assignment] = STATE(17574),
    [sym__expression] = STATE(13963),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1155),
    [sym_line_comment] = STATE(1155),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6450),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6452),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1156] = {
    [sym__closed_assignment] = STATE(17284),
    [sym__expression] = STATE(13545),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1156),
    [sym_line_comment] = STATE(1156),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6454),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6456),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1157] = {
    [sym__closed_assignment] = STATE(16744),
    [sym__expression] = STATE(12345),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1157),
    [sym_line_comment] = STATE(1157),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6458),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6460),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1158] = {
    [sym__closed_assignment] = STATE(17569),
    [sym__expression] = STATE(13505),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1158),
    [sym_line_comment] = STATE(1158),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6462),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6464),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1159] = {
    [sym__closed_assignment] = STATE(16925),
    [sym__expression] = STATE(12216),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1159),
    [sym_line_comment] = STATE(1159),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6466),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6468),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1160] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1160),
    [sym_line_comment] = STATE(1160),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6470),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1161] = {
    [sym__closed_assignment] = STATE(16673),
    [sym__expression] = STATE(12087),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1161),
    [sym_line_comment] = STATE(1161),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6472),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6474),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1162] = {
    [sym__closed_assignment] = STATE(17410),
    [sym__expression] = STATE(13550),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1162),
    [sym_line_comment] = STATE(1162),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6476),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6478),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1163] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1163),
    [sym_line_comment] = STATE(1163),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6480),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1164] = {
    [sym__closed_assignment] = STATE(16073),
    [sym__expression] = STATE(12054),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1164),
    [sym_line_comment] = STATE(1164),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6482),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6484),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1165] = {
    [sym__closed_assignment] = STATE(17195),
    [sym__expression] = STATE(13651),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1165),
    [sym_line_comment] = STATE(1165),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6486),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6488),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1166] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1166),
    [sym_line_comment] = STATE(1166),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6490),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1167] = {
    [sym__closed_assignment] = STATE(17558),
    [sym__expression] = STATE(13973),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1167),
    [sym_line_comment] = STATE(1167),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6492),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6494),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1168] = {
    [sym__closed_assignment] = STATE(17596),
    [sym__expression] = STATE(13554),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1168),
    [sym_line_comment] = STATE(1168),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6496),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6498),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1169] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1169),
    [sym_line_comment] = STATE(1169),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6500),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1170] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1170),
    [sym_line_comment] = STATE(1170),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6502),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1171] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1171),
    [sym_line_comment] = STATE(1171),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6504),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1172] = {
    [sym__closed_assignment] = STATE(17632),
    [sym__expression] = STATE(13967),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1172),
    [sym_line_comment] = STATE(1172),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6506),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6508),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1173] = {
    [sym__closed_assignment] = STATE(16737),
    [sym__expression] = STATE(12121),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1173),
    [sym_line_comment] = STATE(1173),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6510),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6512),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1174] = {
    [sym__closed_assignment] = STATE(17236),
    [sym__expression] = STATE(13560),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1174),
    [sym_line_comment] = STATE(1174),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6514),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6516),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1175] = {
    [sym__closed_assignment] = STATE(15360),
    [sym__expression] = STATE(12230),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1175),
    [sym_line_comment] = STATE(1175),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6518),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6520),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1176] = {
    [sym__closed_assignment] = STATE(16686),
    [sym__expression] = STATE(12233),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1176),
    [sym_line_comment] = STATE(1176),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6522),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6524),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1177] = {
    [sym__closed_assignment] = STATE(17665),
    [sym__expression] = STATE(13530),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1177),
    [sym_line_comment] = STATE(1177),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6526),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6528),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1178] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1178),
    [sym_line_comment] = STATE(1178),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6530),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1179] = {
    [sym__closed_assignment] = STATE(17090),
    [sym__expression] = STATE(13443),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1179),
    [sym_line_comment] = STATE(1179),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6532),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6534),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1180] = {
    [sym__closed_assignment] = STATE(17317),
    [sym__expression] = STATE(13563),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1180),
    [sym_line_comment] = STATE(1180),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6536),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6538),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1181] = {
    [sym__closed_assignment] = STATE(16377),
    [sym__expression] = STATE(12255),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1181),
    [sym_line_comment] = STATE(1181),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6540),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1182] = {
    [sym__closed_assignment] = STATE(17422),
    [sym__expression] = STATE(13719),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1182),
    [sym_line_comment] = STATE(1182),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6544),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1183] = {
    [sym__closed_assignment] = STATE(17640),
    [sym__expression] = STATE(13515),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1183),
    [sym_line_comment] = STATE(1183),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6548),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6550),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1184] = {
    [sym_open_tuple] = STATE(16683),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12857),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10407),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(13011),
    [sym_unary_expression] = STATE(13011),
    [sym_range_expression] = STATE(13011),
    [sym_splat_expression] = STATE(13011),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12652),
    [sym_unary_typed_expression] = STATE(13011),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(13011),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12465),
    [sym_block_comment] = STATE(1184),
    [sym_line_comment] = STATE(1184),
    [ts_builtin_sym_end] = ACTIONS(6552),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1185] = {
    [sym__closed_assignment] = STATE(15695),
    [sym__expression] = STATE(12077),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1185),
    [sym_line_comment] = STATE(1185),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6556),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1186] = {
    [sym__closed_assignment] = STATE(17432),
    [sym__expression] = STATE(13568),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1186),
    [sym_line_comment] = STATE(1186),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6558),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6560),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1187] = {
    [sym__closed_assignment] = STATE(17182),
    [sym__expression] = STATE(13448),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1187),
    [sym_line_comment] = STATE(1187),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6562),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6564),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1188] = {
    [sym__closed_assignment] = STATE(17571),
    [sym__expression] = STATE(13765),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1188),
    [sym_line_comment] = STATE(1188),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6566),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6568),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1189] = {
    [sym__closed_assignment] = STATE(15456),
    [sym__expression] = STATE(12254),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1189),
    [sym_line_comment] = STATE(1189),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6570),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6572),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1190] = {
    [sym__closed_assignment] = STATE(16096),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10210),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1190),
    [sym_line_comment] = STATE(1190),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6590),
    [aux_sym__terminator_token2] = ACTIONS(6592),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1191] = {
    [sym__closed_assignment] = STATE(17553),
    [sym__expression] = STATE(13573),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1191),
    [sym_line_comment] = STATE(1191),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6594),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6596),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1192] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1192),
    [sym_line_comment] = STATE(1192),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6598),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1193] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1193),
    [sym_line_comment] = STATE(1193),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6600),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1194] = {
    [sym__closed_assignment] = STATE(17262),
    [sym__expression] = STATE(13456),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1194),
    [sym_line_comment] = STATE(1194),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6602),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6604),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1195] = {
    [sym__closed_assignment] = STATE(15461),
    [sym__expression] = STATE(12138),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1195),
    [sym_line_comment] = STATE(1195),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6606),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6608),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1196] = {
    [sym__closed_assignment] = STATE(17112),
    [sym__expression] = STATE(13577),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1196),
    [sym_line_comment] = STATE(1196),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6610),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6612),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1197] = {
    [sym__closed_assignment] = STATE(17656),
    [sym__expression] = STATE(13760),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1197),
    [sym_line_comment] = STATE(1197),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6614),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6616),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1198] = {
    [sym__closed_assignment] = STATE(17312),
    [sym__expression] = STATE(13446),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1198),
    [sym_line_comment] = STATE(1198),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6618),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6620),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1199] = {
    [sym__closed_assignment] = STATE(15361),
    [sym__expression] = STATE(12250),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1199),
    [sym_line_comment] = STATE(1199),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6622),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6624),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1200] = {
    [sym__closed_assignment] = STATE(17588),
    [sym__expression] = STATE(13849),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1200),
    [sym_line_comment] = STATE(1200),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6626),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6628),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1201] = {
    [sym__closed_assignment] = STATE(17191),
    [sym__expression] = STATE(13583),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1201),
    [sym_line_comment] = STATE(1201),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6630),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6632),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1202] = {
    [sym__closed_assignment] = STATE(17323),
    [sym__expression] = STATE(13462),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1202),
    [sym_line_comment] = STATE(1202),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6634),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6636),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1203] = {
    [sym__closed_assignment] = STATE(17573),
    [sym__expression] = STATE(13975),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1203),
    [sym_line_comment] = STATE(1203),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6638),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6640),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1204] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1204),
    [sym_line_comment] = STATE(1204),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6642),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1205] = {
    [sym__closed_assignment] = STATE(16049),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10196),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1205),
    [sym_line_comment] = STATE(1205),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6644),
    [aux_sym__terminator_token2] = ACTIONS(6646),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1206] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1206),
    [sym_line_comment] = STATE(1206),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6648),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1207] = {
    [sym__closed_assignment] = STATE(15560),
    [sym__expression] = STATE(12278),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1207),
    [sym_line_comment] = STATE(1207),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6650),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6652),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1208] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(1083),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1208),
    [sym_line_comment] = STATE(1208),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1209] = {
    [sym__closed_assignment] = STATE(16901),
    [sym__expression] = STATE(12342),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1209),
    [sym_line_comment] = STATE(1209),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6658),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6660),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1210] = {
    [sym__closed_assignment] = STATE(16760),
    [sym__expression] = STATE(12264),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1210),
    [sym_line_comment] = STATE(1210),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6662),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6664),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1211] = {
    [sym__closed_assignment] = STATE(16089),
    [sym__expression] = STATE(12321),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1211),
    [sym_line_comment] = STATE(1211),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6666),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6668),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1212] = {
    [sym__closed_assignment] = STATE(16833),
    [sym__expression] = STATE(12118),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1212),
    [sym_line_comment] = STATE(1212),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6670),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6672),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1213] = {
    [sym__closed_assignment] = STATE(17369),
    [sym__expression] = STATE(13472),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1213),
    [sym_line_comment] = STATE(1213),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6674),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6676),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1214] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1214),
    [sym_line_comment] = STATE(1214),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6678),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1215] = {
    [sym__closed_assignment] = STATE(17446),
    [sym__expression] = STATE(13622),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1215),
    [sym_line_comment] = STATE(1215),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6680),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6682),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1216] = {
    [sym__closed_assignment] = STATE(17261),
    [sym__expression] = STATE(13783),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1216),
    [sym_line_comment] = STATE(1216),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6684),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6686),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1217] = {
    [sym__closed_assignment] = STATE(17541),
    [sym__expression] = STATE(13463),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1217),
    [sym_line_comment] = STATE(1217),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6688),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6690),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1218] = {
    [sym__closed_assignment] = STATE(17400),
    [sym__expression] = STATE(13878),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1218),
    [sym_line_comment] = STATE(1218),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6692),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6694),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1219] = {
    [sym__closed_assignment] = STATE(17643),
    [sym__expression] = STATE(13447),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1219),
    [sym_line_comment] = STATE(1219),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6696),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6698),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1220] = {
    [sym__closed_assignment] = STATE(17544),
    [sym__expression] = STATE(13607),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1220),
    [sym_line_comment] = STATE(1220),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6700),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6702),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1221] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(906),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1221),
    [sym_line_comment] = STATE(1221),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1222] = {
    [sym__closed_assignment] = STATE(16204),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10239),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1222),
    [sym_line_comment] = STATE(1222),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6704),
    [aux_sym__terminator_token2] = ACTIONS(6706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1223] = {
    [sym__closed_assignment] = STATE(17589),
    [sym__expression] = STATE(13950),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1223),
    [sym_line_comment] = STATE(1223),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6708),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6710),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1224] = {
    [sym__closed_assignment] = STATE(17421),
    [sym__expression] = STATE(13481),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1224),
    [sym_line_comment] = STATE(1224),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6712),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6714),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1225] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(694),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1225),
    [sym_line_comment] = STATE(1225),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1226] = {
    [sym__closed_assignment] = STATE(16218),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10153),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1226),
    [sym_line_comment] = STATE(1226),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6716),
    [aux_sym__terminator_token2] = ACTIONS(6718),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1227] = {
    [sym__closed_assignment] = STATE(17105),
    [sym__expression] = STATE(13797),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1227),
    [sym_line_comment] = STATE(1227),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6720),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6722),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1228] = {
    [sym__closed_assignment] = STATE(17419),
    [sym__expression] = STATE(13966),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1228),
    [sym_line_comment] = STATE(1228),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6724),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6726),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1229] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(840),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1229),
    [sym_line_comment] = STATE(1229),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1230] = {
    [sym__closed_assignment] = STATE(16237),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10154),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1230),
    [sym_line_comment] = STATE(1230),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6728),
    [aux_sym__terminator_token2] = ACTIONS(6730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1231] = {
    [sym__closed_assignment] = STATE(15651),
    [sym__expression] = STATE(12299),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1231),
    [sym_line_comment] = STATE(1231),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6732),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6734),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1232] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1232),
    [sym_line_comment] = STATE(1232),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6736),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1233] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(981),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1233),
    [sym_line_comment] = STATE(1233),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1234] = {
    [sym__closed_assignment] = STATE(16254),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10200),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1234),
    [sym_line_comment] = STATE(1234),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6738),
    [aux_sym__terminator_token2] = ACTIONS(6740),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1235] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(1085),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1235),
    [sym_line_comment] = STATE(1235),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1236] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1236),
    [sym_line_comment] = STATE(1236),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6742),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1237] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(1082),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1237),
    [sym_line_comment] = STATE(1237),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1238] = {
    [sym__closed_assignment] = STATE(16268),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10193),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1238),
    [sym_line_comment] = STATE(1238),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6744),
    [aux_sym__terminator_token2] = ACTIONS(6746),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1239] = {
    [sym__closed_assignment] = STATE(17495),
    [sym__expression] = STATE(13500),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1239),
    [sym_line_comment] = STATE(1239),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6748),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6750),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1240] = {
    [sym_open_tuple] = STATE(15465),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12889),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1240),
    [sym_line_comment] = STATE(1240),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(4984),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1241] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(1118),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1241),
    [sym_line_comment] = STATE(1241),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1242] = {
    [sym__closed_assignment] = STATE(16283),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10147),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1242),
    [sym_line_comment] = STATE(1242),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6752),
    [aux_sym__terminator_token2] = ACTIONS(6754),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1243] = {
    [sym_open_tuple] = STATE(15465),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12889),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1243),
    [sym_line_comment] = STATE(1243),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(5134),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1244] = {
    [sym__closed_assignment] = STATE(17178),
    [sym__expression] = STATE(13814),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1244),
    [sym_line_comment] = STATE(1244),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6756),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6758),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1245] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(692),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1245),
    [sym_line_comment] = STATE(1245),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1246] = {
    [sym__closed_assignment] = STATE(16298),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10158),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1246),
    [sym_line_comment] = STATE(1246),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6760),
    [aux_sym__terminator_token2] = ACTIONS(6762),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1247] = {
    [sym__closed_assignment] = STATE(15475),
    [sym__expression] = STATE(12141),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1247),
    [sym_line_comment] = STATE(1247),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6764),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6766),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1248] = {
    [sym_open_tuple] = STATE(16683),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12857),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10407),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(13011),
    [sym_unary_expression] = STATE(13011),
    [sym_range_expression] = STATE(13011),
    [sym_splat_expression] = STATE(13011),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12652),
    [sym_unary_typed_expression] = STATE(13011),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(13011),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12465),
    [sym_block_comment] = STATE(1248),
    [sym_line_comment] = STATE(1248),
    [ts_builtin_sym_end] = ACTIONS(6768),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1249] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(725),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1249),
    [sym_line_comment] = STATE(1249),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1250] = {
    [sym__closed_assignment] = STATE(16309),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10195),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1250),
    [sym_line_comment] = STATE(1250),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6770),
    [aux_sym__terminator_token2] = ACTIONS(6772),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1251] = {
    [sym__closed_assignment] = STATE(16880),
    [sym__expression] = STATE(12291),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1251),
    [sym_line_comment] = STATE(1251),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6774),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6776),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1252] = {
    [sym__closed_assignment] = STATE(17557),
    [sym__expression] = STATE(13504),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1252),
    [sym_line_comment] = STATE(1252),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6778),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6780),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1253] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(758),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1253),
    [sym_line_comment] = STATE(1253),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1254] = {
    [sym__closed_assignment] = STATE(16321),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10226),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1254),
    [sym_line_comment] = STATE(1254),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6782),
    [aux_sym__terminator_token2] = ACTIONS(6784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1255] = {
    [sym__closed_assignment] = STATE(17427),
    [sym__expression] = STATE(13798),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1255),
    [sym_line_comment] = STATE(1255),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6786),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6788),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1256] = {
    [sym__closed_assignment] = STATE(16074),
    [sym__expression] = STATE(12354),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1256),
    [sym_line_comment] = STATE(1256),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6790),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6792),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1257] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(794),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1257),
    [sym_line_comment] = STATE(1257),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1258] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1258),
    [sym_line_comment] = STATE(1258),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1259] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(813),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1259),
    [sym_line_comment] = STATE(1259),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1260] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(820),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1260),
    [sym_line_comment] = STATE(1260),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1261] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(827),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1261),
    [sym_line_comment] = STATE(1261),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1262] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(833),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1262),
    [sym_line_comment] = STATE(1262),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1263] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(839),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1263),
    [sym_line_comment] = STATE(1263),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1264] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(846),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1264),
    [sym_line_comment] = STATE(1264),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1265] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(853),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1265),
    [sym_line_comment] = STATE(1265),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1266] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(859),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1266),
    [sym_line_comment] = STATE(1266),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1267] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(866),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1267),
    [sym_line_comment] = STATE(1267),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1268] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(873),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1268),
    [sym_line_comment] = STATE(1268),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1269] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(879),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1269),
    [sym_line_comment] = STATE(1269),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1270] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(886),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1270),
    [sym_line_comment] = STATE(1270),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1271] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(892),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1271),
    [sym_line_comment] = STATE(1271),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1272] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(899),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1272),
    [sym_line_comment] = STATE(1272),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1273] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(905),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1273),
    [sym_line_comment] = STATE(1273),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1274] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(911),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1274),
    [sym_line_comment] = STATE(1274),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1275] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(918),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1275),
    [sym_line_comment] = STATE(1275),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1276] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(925),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1276),
    [sym_line_comment] = STATE(1276),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1277] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(932),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1277),
    [sym_line_comment] = STATE(1277),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1278] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(939),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1278),
    [sym_line_comment] = STATE(1278),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1279] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(946),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1279),
    [sym_line_comment] = STATE(1279),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1280] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1280),
    [sym_line_comment] = STATE(1280),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1281] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(959),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1281),
    [sym_line_comment] = STATE(1281),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1282] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10756),
    [sym_tuple_expression] = STATE(10756),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym__do_parameter_list] = STATE(966),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13279),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12775),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10326),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1282),
    [sym_line_comment] = STATE(1282),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(203),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4178),
    [sym__type_order_operator] = ACTIONS(4178),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym__terminator_token1] = ACTIONS(6654),
    [aux_sym__terminator_token2] = ACTIONS(6656),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1283] = {
    [sym__closed_assignment] = STATE(17198),
    [sym__expression] = STATE(13877),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1283),
    [sym_line_comment] = STATE(1283),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6794),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6796),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1284] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1284),
    [sym_line_comment] = STATE(1284),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6798),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1285] = {
    [sym__closed_assignment] = STATE(17357),
    [sym__expression] = STATE(13873),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1285),
    [sym_line_comment] = STATE(1285),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6800),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6802),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1286] = {
    [sym__closed_assignment] = STATE(17606),
    [sym__expression] = STATE(13508),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1286),
    [sym_line_comment] = STATE(1286),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6804),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6806),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1287] = {
    [sym__closed_assignment] = STATE(17597),
    [sym__expression] = STATE(13648),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1287),
    [sym_line_comment] = STATE(1287),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6808),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6810),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1288] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1288),
    [sym_line_comment] = STATE(1288),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6812),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1289] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1289),
    [sym_line_comment] = STATE(1289),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6814),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1290] = {
    [sym__closed_assignment] = STATE(17129),
    [sym__expression] = STATE(13865),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1290),
    [sym_line_comment] = STATE(1290),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6816),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6818),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1291] = {
    [sym__closed_assignment] = STATE(17194),
    [sym__expression] = STATE(13813),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1291),
    [sym_line_comment] = STATE(1291),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6820),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6822),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1292] = {
    [sym__closed_assignment] = STATE(16145),
    [sym__expression] = STATE(12240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1292),
    [sym_line_comment] = STATE(1292),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6824),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6826),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1293] = {
    [sym__closed_assignment] = STATE(17648),
    [sym__expression] = STATE(13516),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1293),
    [sym_line_comment] = STATE(1293),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6828),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6830),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1294] = {
    [sym__closed_assignment] = STATE(16062),
    [sym__expression] = STATE(12172),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1294),
    [sym_line_comment] = STATE(1294),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6832),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6834),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1295] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1295),
    [sym_line_comment] = STATE(1295),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6836),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1296] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10159),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1296),
    [sym_line_comment] = STATE(1296),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6838),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1297] = {
    [sym__closed_assignment] = STATE(16134),
    [sym__expression] = STATE(12020),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1297),
    [sym_line_comment] = STATE(1297),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6840),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6842),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1298] = {
    [sym__closed_assignment] = STATE(16919),
    [sym__expression] = STATE(12188),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1298),
    [sym_line_comment] = STATE(1298),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6844),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6846),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1299] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12420),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10201),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1299),
    [sym_line_comment] = STATE(1299),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6848),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1300] = {
    [sym__closed_assignment] = STATE(17146),
    [sym__expression] = STATE(13802),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1300),
    [sym_line_comment] = STATE(1300),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6850),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6852),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1301] = {
    [sym__closed_assignment] = STATE(17380),
    [sym__expression] = STATE(13519),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1301),
    [sym_line_comment] = STATE(1301),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(6854),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6856),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1302] = {
    [sym__closed_assignment] = STATE(16178),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10233),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(1302),
    [sym_line_comment] = STATE(1302),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6576),
    [anon_sym_LBRACE] = ACTIONS(6578),
    [anon_sym_DOLLAR] = ACTIONS(6580),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(6582),
    [anon_sym_AT] = ACTIONS(6584),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3603),
    [aux_sym_integer_literal_token2] = ACTIONS(3603),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(6586),
    [aux_sym_float_literal_token3] = ACTIONS(6586),
    [aux_sym_float_literal_token4] = ACTIONS(6586),
    [sym_character_literal] = ACTIONS(6588),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(1825),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1825),
    [sym__pipe_left_operator] = ACTIONS(1825),
    [sym__ellipsis_operator] = ACTIONS(1825),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1825),
    [sym__bitshift_operator] = ACTIONS(1825),
    [sym__power_operator] = ACTIONS(1825),
    [sym__tilde_operator] = ACTIONS(4158),
    [sym__type_order_operator] = ACTIONS(4158),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym__terminator_token1] = ACTIONS(6858),
    [aux_sym__terminator_token2] = ACTIONS(6860),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1303] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1303),
    [sym_line_comment] = STATE(1303),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6862),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1304] = {
    [sym_open_tuple] = STATE(7775),
    [sym_assignment] = STATE(7724),
    [sym__expression] = STATE(7759),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(1304),
    [sym_line_comment] = STATE(1304),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1305] = {
    [sym_open_tuple] = STATE(12808),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12611),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10504),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12582),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1305),
    [sym_line_comment] = STATE(1305),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1306] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1306),
    [sym_line_comment] = STATE(1306),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6884),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1307] = {
    [sym_open_tuple] = STATE(18231),
    [sym_assignment] = STATE(8726),
    [sym__expression] = STATE(8501),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(1307),
    [sym_line_comment] = STATE(1307),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1308] = {
    [sym_open_tuple] = STATE(12645),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12451),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10370),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12749),
    [sym_unary_expression] = STATE(12749),
    [sym_range_expression] = STATE(12749),
    [sym_splat_expression] = STATE(12749),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12236),
    [sym_unary_typed_expression] = STATE(12749),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12749),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12218),
    [sym_block_comment] = STATE(1308),
    [sym_line_comment] = STATE(1308),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1309] = {
    [sym_open_tuple] = STATE(12647),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12452),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10370),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12749),
    [sym_unary_expression] = STATE(12749),
    [sym_range_expression] = STATE(12749),
    [sym_splat_expression] = STATE(12749),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12236),
    [sym_unary_typed_expression] = STATE(12749),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12749),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12218),
    [sym_block_comment] = STATE(1309),
    [sym_line_comment] = STATE(1309),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1310] = {
    [sym_open_tuple] = STATE(16683),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12857),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10407),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(13011),
    [sym_unary_expression] = STATE(13011),
    [sym_range_expression] = STATE(13011),
    [sym_splat_expression] = STATE(13011),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12652),
    [sym_unary_typed_expression] = STATE(13011),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(13011),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12465),
    [sym_block_comment] = STATE(1310),
    [sym_line_comment] = STATE(1310),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1311] = {
    [sym_open_tuple] = STATE(18923),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12774),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10469),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12909),
    [sym_unary_expression] = STATE(12909),
    [sym_range_expression] = STATE(12909),
    [sym_splat_expression] = STATE(12909),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(12909),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12909),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12508),
    [sym_block_comment] = STATE(1311),
    [sym_line_comment] = STATE(1311),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1312] = {
    [sym_open_tuple] = STATE(19164),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12771),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10445),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12911),
    [sym_unary_expression] = STATE(12911),
    [sym_range_expression] = STATE(12911),
    [sym_splat_expression] = STATE(12911),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12535),
    [sym_unary_typed_expression] = STATE(12911),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12911),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12536),
    [sym_block_comment] = STATE(1312),
    [sym_line_comment] = STATE(1312),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1313] = {
    [sym_open_tuple] = STATE(12340),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(11991),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10207),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11929),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1313),
    [sym_line_comment] = STATE(1313),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1314] = {
    [sym_open_tuple] = STATE(19418),
    [sym_assignment] = STATE(8017),
    [sym__expression] = STATE(8749),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(1314),
    [sym_line_comment] = STATE(1314),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1315] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1315),
    [sym_line_comment] = STATE(1315),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6906),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1316] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1316),
    [sym_line_comment] = STATE(1316),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6908),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1317] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(1317),
    [sym_line_comment] = STATE(1317),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6910),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1318] = {
    [sym_open_tuple] = STATE(12341),
    [sym_assignment] = STATE(12243),
    [sym__expression] = STATE(11890),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10169),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12036),
    [sym_unary_expression] = STATE(12036),
    [sym_range_expression] = STATE(12036),
    [sym_splat_expression] = STATE(12036),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11968),
    [sym_unary_typed_expression] = STATE(12036),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12036),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11979),
    [sym_block_comment] = STATE(1318),
    [sym_line_comment] = STATE(1318),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1319] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1319),
    [sym_line_comment] = STATE(1319),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6912),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1320] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1320),
    [sym_line_comment] = STATE(1320),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(6914),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1321] = {
    [sym_open_tuple] = STATE(12925),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12938),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10445),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12911),
    [sym_unary_expression] = STATE(12911),
    [sym_range_expression] = STATE(12911),
    [sym_splat_expression] = STATE(12911),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12535),
    [sym_unary_typed_expression] = STATE(12911),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12911),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12536),
    [sym_block_comment] = STATE(1321),
    [sym_line_comment] = STATE(1321),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1322] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1322),
    [sym_line_comment] = STATE(1322),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6916),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1323] = {
    [sym__expression] = STATE(13857),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17582),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1323),
    [sym_line_comment] = STATE(1323),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6918),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1324] = {
    [sym_open_tuple] = STATE(18923),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12927),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10469),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12909),
    [sym_unary_expression] = STATE(12909),
    [sym_range_expression] = STATE(12909),
    [sym_splat_expression] = STATE(12909),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(12909),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12909),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12508),
    [sym_block_comment] = STATE(1324),
    [sym_line_comment] = STATE(1324),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1325] = {
    [sym_open_tuple] = STATE(12651),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12098),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10309),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12090),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1325),
    [sym_line_comment] = STATE(1325),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1326] = {
    [sym_open_tuple] = STATE(12679),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12099),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10246),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12132),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1326),
    [sym_line_comment] = STATE(1326),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1327] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1327),
    [sym_line_comment] = STATE(1327),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6920),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1328] = {
    [sym_open_tuple] = STATE(19568),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13147),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10690),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13134),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1328),
    [sym_line_comment] = STATE(1328),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1329] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1329),
    [sym_line_comment] = STATE(1329),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6922),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1330] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1330),
    [sym_line_comment] = STATE(1330),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6924),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1331] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1331),
    [sym_line_comment] = STATE(1331),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6926),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1332] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1332),
    [sym_line_comment] = STATE(1332),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6928),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1333] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1333),
    [sym_line_comment] = STATE(1333),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6930),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1334] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1334),
    [sym_line_comment] = STATE(1334),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(6932),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1335] = {
    [sym_open_tuple] = STATE(19555),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12092),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10342),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12292),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1335),
    [sym_line_comment] = STATE(1335),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1336] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1336),
    [sym_line_comment] = STATE(1336),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6934),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1337] = {
    [sym_open_tuple] = STATE(18383),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12095),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10314),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12019),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1337),
    [sym_line_comment] = STATE(1337),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1338] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1338),
    [sym_line_comment] = STATE(1338),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6936),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1339] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1339),
    [sym_line_comment] = STATE(1339),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6938),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1340] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1340),
    [sym_line_comment] = STATE(1340),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6940),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1341] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1341),
    [sym_line_comment] = STATE(1341),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6942),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1342] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1342),
    [sym_line_comment] = STATE(1342),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6944),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1343] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1343),
    [sym_line_comment] = STATE(1343),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6946),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1344] = {
    [sym_open_tuple] = STATE(8471),
    [sym_assignment] = STATE(8472),
    [sym__expression] = STATE(8473),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(1344),
    [sym_line_comment] = STATE(1344),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1345] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1345),
    [sym_line_comment] = STATE(1345),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6948),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1346] = {
    [sym_open_tuple] = STATE(18738),
    [sym_assignment] = STATE(7266),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10914),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14085),
    [sym_unary_expression] = STATE(14085),
    [sym_range_expression] = STATE(14085),
    [sym_splat_expression] = STATE(14085),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13953),
    [sym_unary_typed_expression] = STATE(14085),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14085),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13441),
    [sym_block_comment] = STATE(1346),
    [sym_line_comment] = STATE(1346),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1347] = {
    [sym_open_tuple] = STATE(8474),
    [sym_assignment] = STATE(8475),
    [sym__expression] = STATE(8476),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(1347),
    [sym_line_comment] = STATE(1347),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1348] = {
    [sym_open_tuple] = STATE(15465),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12889),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(1348),
    [sym_line_comment] = STATE(1348),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1349] = {
    [sym_open_tuple] = STATE(19038),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11176),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14008),
    [sym_unary_expression] = STATE(14008),
    [sym_range_expression] = STATE(14008),
    [sym_splat_expression] = STATE(14008),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13934),
    [sym_unary_typed_expression] = STATE(14008),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14008),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13854),
    [sym_block_comment] = STATE(1349),
    [sym_line_comment] = STATE(1349),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1350] = {
    [sym_open_tuple] = STATE(18928),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(13025),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10499),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12915),
    [sym_unary_expression] = STATE(12915),
    [sym_range_expression] = STATE(12915),
    [sym_splat_expression] = STATE(12915),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12548),
    [sym_unary_typed_expression] = STATE(12915),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12915),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12551),
    [sym_block_comment] = STATE(1350),
    [sym_line_comment] = STATE(1350),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1351] = {
    [sym_open_tuple] = STATE(14309),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12164),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(1351),
    [sym_line_comment] = STATE(1351),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1352] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(15039),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11376),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11376),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13460),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10544),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1352),
    [sym_line_comment] = STATE(1352),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(6954),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1353] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1353),
    [sym_line_comment] = STATE(1353),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(6958),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1354] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1354),
    [sym_line_comment] = STATE(1354),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6960),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1355] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1355),
    [sym_line_comment] = STATE(1355),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6962),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1356] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(14861),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11319),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11319),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13606),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10624),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1356),
    [sym_line_comment] = STATE(1356),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(6964),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1357] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(1357),
    [sym_line_comment] = STATE(1357),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6966),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1358] = {
    [sym_open_tuple] = STATE(12836),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12837),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10387),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12865),
    [sym_unary_expression] = STATE(12865),
    [sym_range_expression] = STATE(12865),
    [sym_splat_expression] = STATE(12865),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12478),
    [sym_unary_typed_expression] = STATE(12865),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12865),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12490),
    [sym_block_comment] = STATE(1358),
    [sym_line_comment] = STATE(1358),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1359] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1359),
    [sym_line_comment] = STATE(1359),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6968),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1360] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1360),
    [sym_line_comment] = STATE(1360),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(6970),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1361] = {
    [sym_open_tuple] = STATE(19418),
    [sym_assignment] = STATE(8017),
    [sym__expression] = STATE(8059),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(1361),
    [sym_line_comment] = STATE(1361),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1362] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1362),
    [sym_line_comment] = STATE(1362),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6972),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1363] = {
    [sym__expression] = STATE(13732),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17455),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1363),
    [sym_line_comment] = STATE(1363),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6974),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1364] = {
    [sym_open_tuple] = STATE(12838),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12840),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10387),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12865),
    [sym_unary_expression] = STATE(12865),
    [sym_range_expression] = STATE(12865),
    [sym_splat_expression] = STATE(12865),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12478),
    [sym_unary_typed_expression] = STATE(12865),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12865),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12490),
    [sym_block_comment] = STATE(1364),
    [sym_line_comment] = STATE(1364),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1365] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1365),
    [sym_line_comment] = STATE(1365),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6976),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1366] = {
    [sym_open_tuple] = STATE(8748),
    [sym_assignment] = STATE(8060),
    [sym__expression] = STATE(8756),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(1366),
    [sym_line_comment] = STATE(1366),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1367] = {
    [sym_open_tuple] = STATE(8763),
    [sym_assignment] = STATE(8061),
    [sym__expression] = STATE(8805),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(1367),
    [sym_line_comment] = STATE(1367),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1368] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1368),
    [sym_line_comment] = STATE(1368),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6978),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1369] = {
    [sym_open_tuple] = STATE(15161),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12402),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(1369),
    [sym_line_comment] = STATE(1369),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1370] = {
    [sym_open_tuple] = STATE(15056),
    [sym_assignment] = STATE(12243),
    [sym__expression] = STATE(12057),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(1370),
    [sym_line_comment] = STATE(1370),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1371] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1371),
    [sym_line_comment] = STATE(1371),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6980),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1372] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1372),
    [sym_line_comment] = STATE(1372),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6982),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1373] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1373),
    [sym_line_comment] = STATE(1373),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6984),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1374] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(1374),
    [sym_line_comment] = STATE(1374),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1375] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(1375),
    [sym_line_comment] = STATE(1375),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6988),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1376] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1376),
    [sym_line_comment] = STATE(1376),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6990),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1377] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1377),
    [sym_line_comment] = STATE(1377),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(6992),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1378] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1378),
    [sym_line_comment] = STATE(1378),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(6994),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1379] = {
    [sym__expression] = STATE(13768),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17205),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1379),
    [sym_line_comment] = STATE(1379),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6996),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1380] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1380),
    [sym_line_comment] = STATE(1380),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6998),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1381] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1381),
    [sym_line_comment] = STATE(1381),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7000),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1382] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1382),
    [sym_line_comment] = STATE(1382),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7002),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1383] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1383),
    [sym_line_comment] = STATE(1383),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7004),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1384] = {
    [sym__expression] = STATE(13929),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17216),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1384),
    [sym_line_comment] = STATE(1384),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7006),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1385] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1385),
    [sym_line_comment] = STATE(1385),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7008),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1386] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1386),
    [sym_line_comment] = STATE(1386),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7010),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1387] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1387),
    [sym_line_comment] = STATE(1387),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6922),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1388] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1388),
    [sym_line_comment] = STATE(1388),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7012),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1389] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1389),
    [sym_line_comment] = STATE(1389),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7014),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1390] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1390),
    [sym_line_comment] = STATE(1390),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7016),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1391] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1391),
    [sym_line_comment] = STATE(1391),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7018),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1392] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1392),
    [sym_line_comment] = STATE(1392),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7020),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1393] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1393),
    [sym_line_comment] = STATE(1393),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7022),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1394] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1394),
    [sym_line_comment] = STATE(1394),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7024),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1395] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1395),
    [sym_line_comment] = STATE(1395),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7026),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1396] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1396),
    [sym_line_comment] = STATE(1396),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7028),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1397] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1397),
    [sym_line_comment] = STATE(1397),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7030),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1398] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1398),
    [sym_line_comment] = STATE(1398),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7032),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1399] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1399),
    [sym_line_comment] = STATE(1399),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7034),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1400] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1400),
    [sym_line_comment] = STATE(1400),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7010),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1401] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1401),
    [sym_line_comment] = STATE(1401),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7036),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1402] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1402),
    [sym_line_comment] = STATE(1402),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7038),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1403] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1403),
    [sym_line_comment] = STATE(1403),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7040),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1404] = {
    [sym_open_tuple] = STATE(18366),
    [sym_assignment] = STATE(8262),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10854),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14069),
    [sym_unary_expression] = STATE(14069),
    [sym_range_expression] = STATE(14069),
    [sym_splat_expression] = STATE(14069),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13961),
    [sym_unary_typed_expression] = STATE(14069),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14069),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13935),
    [sym_block_comment] = STATE(1404),
    [sym_line_comment] = STATE(1404),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1405] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1405),
    [sym_line_comment] = STATE(1405),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7042),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1406] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1406),
    [sym_line_comment] = STATE(1406),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1407] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1407),
    [sym_line_comment] = STATE(1407),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1408] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1408),
    [sym_line_comment] = STATE(1408),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7048),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1409] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1409),
    [sym_line_comment] = STATE(1409),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7050),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1410] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1410),
    [sym_line_comment] = STATE(1410),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7052),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1411] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1411),
    [sym_line_comment] = STATE(1411),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7046),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1412] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1412),
    [sym_line_comment] = STATE(1412),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7054),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1413] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1413),
    [sym_line_comment] = STATE(1413),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7056),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1414] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1414),
    [sym_line_comment] = STATE(1414),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7058),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1415] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1415),
    [sym_line_comment] = STATE(1415),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7060),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1416] = {
    [sym__expression] = STATE(13469),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17122),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1416),
    [sym_line_comment] = STATE(1416),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7062),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1417] = {
    [sym_open_tuple] = STATE(18395),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12467),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10435),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12583),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1417),
    [sym_line_comment] = STATE(1417),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1418] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1418),
    [sym_line_comment] = STATE(1418),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7064),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1419] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1419),
    [sym_line_comment] = STATE(1419),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7066),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1420] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1420),
    [sym_line_comment] = STATE(1420),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7068),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1421] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1421),
    [sym_line_comment] = STATE(1421),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7070),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1422] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1422),
    [sym_line_comment] = STATE(1422),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7072),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1423] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1423),
    [sym_line_comment] = STATE(1423),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7074),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1424] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1424),
    [sym_line_comment] = STATE(1424),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7076),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1425] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1425),
    [sym_line_comment] = STATE(1425),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7078),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1426] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1426),
    [sym_line_comment] = STATE(1426),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7080),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1427] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1427),
    [sym_line_comment] = STATE(1427),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7082),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1428] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1428),
    [sym_line_comment] = STATE(1428),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7084),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1429] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1429),
    [sym_line_comment] = STATE(1429),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7086),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1430] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1430),
    [sym_line_comment] = STATE(1430),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7088),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1431] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1431),
    [sym_line_comment] = STATE(1431),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7090),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1432] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1432),
    [sym_line_comment] = STATE(1432),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7092),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1433] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1433),
    [sym_line_comment] = STATE(1433),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7094),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1434] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1434),
    [sym_line_comment] = STATE(1434),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7096),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1435] = {
    [sym_open_tuple] = STATE(18576),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10867),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14081),
    [sym_unary_expression] = STATE(14081),
    [sym_range_expression] = STATE(14081),
    [sym_splat_expression] = STATE(14081),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13889),
    [sym_unary_typed_expression] = STATE(14081),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14081),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13972),
    [sym_block_comment] = STATE(1435),
    [sym_line_comment] = STATE(1435),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1436] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1436),
    [sym_line_comment] = STATE(1436),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1437] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1437),
    [sym_line_comment] = STATE(1437),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7100),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1438] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1438),
    [sym_line_comment] = STATE(1438),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7102),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1439] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1439),
    [sym_line_comment] = STATE(1439),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7104),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1440] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1440),
    [sym_line_comment] = STATE(1440),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7106),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1441] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1441),
    [sym_line_comment] = STATE(1441),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7108),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1442] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1442),
    [sym_line_comment] = STATE(1442),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7110),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1443] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1443),
    [sym_line_comment] = STATE(1443),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7112),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1444] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1444),
    [sym_line_comment] = STATE(1444),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7114),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1445] = {
    [sym__expression] = STATE(13619),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17227),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1445),
    [sym_line_comment] = STATE(1445),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7116),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1446] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1446),
    [sym_line_comment] = STATE(1446),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7118),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1447] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1447),
    [sym_line_comment] = STATE(1447),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7120),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1448] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1448),
    [sym_line_comment] = STATE(1448),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7122),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1449] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1449),
    [sym_line_comment] = STATE(1449),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7068),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1450] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1450),
    [sym_line_comment] = STATE(1450),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7124),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1451] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1451),
    [sym_line_comment] = STATE(1451),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7126),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1452] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1452),
    [sym_line_comment] = STATE(1452),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7128),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1453] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1453),
    [sym_line_comment] = STATE(1453),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7130),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1454] = {
    [sym_open_tuple] = STATE(13348),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(13183),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10616),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13400),
    [sym_unary_expression] = STATE(13400),
    [sym_range_expression] = STATE(13400),
    [sym_splat_expression] = STATE(13400),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12922),
    [sym_unary_typed_expression] = STATE(13400),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13400),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13114),
    [sym_block_comment] = STATE(1454),
    [sym_line_comment] = STATE(1454),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1455] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1455),
    [sym_line_comment] = STATE(1455),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7132),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1456] = {
    [sym_open_tuple] = STATE(13349),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(13187),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10616),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13400),
    [sym_unary_expression] = STATE(13400),
    [sym_range_expression] = STATE(13400),
    [sym_splat_expression] = STATE(13400),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12922),
    [sym_unary_typed_expression] = STATE(13400),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13400),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13114),
    [sym_block_comment] = STATE(1456),
    [sym_line_comment] = STATE(1456),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1457] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1457),
    [sym_line_comment] = STATE(1457),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7134),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1458] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1458),
    [sym_line_comment] = STATE(1458),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7136),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1459] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1459),
    [sym_line_comment] = STATE(1459),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7138),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1460] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1460),
    [sym_line_comment] = STATE(1460),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7140),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1461] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1461),
    [sym_line_comment] = STATE(1461),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7142),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1462] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1462),
    [sym_line_comment] = STATE(1462),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7144),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1463] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1463),
    [sym_line_comment] = STATE(1463),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7146),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1464] = {
    [sym_open_tuple] = STATE(18920),
    [sym_assignment] = STATE(8057),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10877),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14033),
    [sym_unary_expression] = STATE(14033),
    [sym_range_expression] = STATE(14033),
    [sym_splat_expression] = STATE(14033),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13772),
    [sym_unary_typed_expression] = STATE(14033),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14033),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13892),
    [sym_block_comment] = STATE(1464),
    [sym_line_comment] = STATE(1464),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1465] = {
    [sym_open_tuple] = STATE(18390),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12689),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10504),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12582),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1465),
    [sym_line_comment] = STATE(1465),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1466] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1466),
    [sym_line_comment] = STATE(1466),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7148),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1467] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1467),
    [sym_line_comment] = STATE(1467),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7150),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1468] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1468),
    [sym_line_comment] = STATE(1468),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7152),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1469] = {
    [sym_open_tuple] = STATE(12930),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12569),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10389),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12503),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1469),
    [sym_line_comment] = STATE(1469),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1470] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1470),
    [sym_line_comment] = STATE(1470),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7154),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1471] = {
    [sym__expression] = STATE(13707),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17389),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1471),
    [sym_line_comment] = STATE(1471),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7156),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1472] = {
    [sym_open_tuple] = STATE(8706),
    [sym_assignment] = STATE(8328),
    [sym__expression] = STATE(8499),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(1472),
    [sym_line_comment] = STATE(1472),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1473] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1473),
    [sym_line_comment] = STATE(1473),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7158),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1474] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1474),
    [sym_line_comment] = STATE(1474),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7160),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1475] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1475),
    [sym_line_comment] = STATE(1475),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7162),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1476] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1476),
    [sym_line_comment] = STATE(1476),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7164),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1477] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1477),
    [sym_line_comment] = STATE(1477),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7166),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1478] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1478),
    [sym_line_comment] = STATE(1478),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7168),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1479] = {
    [sym_open_tuple] = STATE(12931),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12572),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10389),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12503),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1479),
    [sym_line_comment] = STATE(1479),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1480] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1480),
    [sym_line_comment] = STATE(1480),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7170),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1481] = {
    [sym_open_tuple] = STATE(18529),
    [sym_assignment] = STATE(7640),
    [sym__expression] = STATE(7075),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(1481),
    [sym_line_comment] = STATE(1481),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1482] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1482),
    [sym_line_comment] = STATE(1482),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7172),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1483] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1483),
    [sym_line_comment] = STATE(1483),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7174),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1484] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1484),
    [sym_line_comment] = STATE(1484),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7176),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1485] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1485),
    [sym_line_comment] = STATE(1485),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7178),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1486] = {
    [sym_open_tuple] = STATE(18500),
    [sym_assignment] = STATE(8205),
    [sym__expression] = STATE(8677),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(1486),
    [sym_line_comment] = STATE(1486),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1487] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1487),
    [sym_line_comment] = STATE(1487),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7180),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1488] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1488),
    [sym_line_comment] = STATE(1488),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1489] = {
    [sym_open_tuple] = STATE(19163),
    [sym_assignment] = STATE(8470),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11023),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14028),
    [sym_unary_expression] = STATE(14028),
    [sym_range_expression] = STATE(14028),
    [sym_splat_expression] = STATE(14028),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13602),
    [sym_unary_typed_expression] = STATE(14028),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14028),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13601),
    [sym_block_comment] = STATE(1489),
    [sym_line_comment] = STATE(1489),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1490] = {
    [sym_open_tuple] = STATE(12916),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(13057),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10499),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12915),
    [sym_unary_expression] = STATE(12915),
    [sym_range_expression] = STATE(12915),
    [sym_splat_expression] = STATE(12915),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12548),
    [sym_unary_typed_expression] = STATE(12915),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12915),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12551),
    [sym_block_comment] = STATE(1490),
    [sym_line_comment] = STATE(1490),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1491] = {
    [sym_open_tuple] = STATE(13663),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(13598),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10703),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13698),
    [sym_unary_expression] = STATE(13698),
    [sym_range_expression] = STATE(13698),
    [sym_splat_expression] = STATE(13698),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13344),
    [sym_unary_typed_expression] = STATE(13698),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13698),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13361),
    [sym_block_comment] = STATE(1491),
    [sym_line_comment] = STATE(1491),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1492] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1492),
    [sym_line_comment] = STATE(1492),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7184),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1493] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1493),
    [sym_line_comment] = STATE(1493),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7186),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1494] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1494),
    [sym_line_comment] = STATE(1494),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7188),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1495] = {
    [sym_open_tuple] = STATE(18231),
    [sym_assignment] = STATE(8726),
    [sym__expression] = STATE(8498),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(1495),
    [sym_line_comment] = STATE(1495),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1496] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1496),
    [sym_line_comment] = STATE(1496),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7190),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1497] = {
    [sym__expression] = STATE(13762),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17476),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1497),
    [sym_line_comment] = STATE(1497),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7192),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1498] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1498),
    [sym_line_comment] = STATE(1498),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7194),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1499] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1499),
    [sym_line_comment] = STATE(1499),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7160),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1500] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1500),
    [sym_line_comment] = STATE(1500),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7196),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1501] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1501),
    [sym_line_comment] = STATE(1501),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7198),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1502] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1502),
    [sym_line_comment] = STATE(1502),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7200),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1503] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1503),
    [sym_line_comment] = STATE(1503),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7202),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1504] = {
    [sym_open_tuple] = STATE(12564),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12111),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10342),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12292),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1504),
    [sym_line_comment] = STATE(1504),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1505] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1505),
    [sym_line_comment] = STATE(1505),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7204),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1506] = {
    [sym_open_tuple] = STATE(12566),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12112),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10342),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12292),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1506),
    [sym_line_comment] = STATE(1506),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1507] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1507),
    [sym_line_comment] = STATE(1507),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7206),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1508] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1508),
    [sym_line_comment] = STATE(1508),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7208),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1509] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1509),
    [sym_line_comment] = STATE(1509),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7210),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1510] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1510),
    [sym_line_comment] = STATE(1510),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7212),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1511] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1511),
    [sym_line_comment] = STATE(1511),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7214),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1512] = {
    [sym_open_tuple] = STATE(12308),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12309),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10216),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12344),
    [sym_unary_expression] = STATE(12344),
    [sym_range_expression] = STATE(12344),
    [sym_splat_expression] = STATE(12344),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11945),
    [sym_unary_typed_expression] = STATE(12344),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12344),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11947),
    [sym_block_comment] = STATE(1512),
    [sym_line_comment] = STATE(1512),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1513] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1513),
    [sym_line_comment] = STATE(1513),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7216),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1514] = {
    [sym_open_tuple] = STATE(18231),
    [sym_assignment] = STATE(8746),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10934),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14051),
    [sym_unary_expression] = STATE(14051),
    [sym_range_expression] = STATE(14051),
    [sym_splat_expression] = STATE(14051),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13769),
    [sym_unary_typed_expression] = STATE(14051),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14051),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13771),
    [sym_block_comment] = STATE(1514),
    [sym_line_comment] = STATE(1514),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1515] = {
    [sym_open_tuple] = STATE(18576),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12523),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10446),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12473),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1515),
    [sym_line_comment] = STATE(1515),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1516] = {
    [sym_open_tuple] = STATE(12310),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12311),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10216),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12344),
    [sym_unary_expression] = STATE(12344),
    [sym_range_expression] = STATE(12344),
    [sym_splat_expression] = STATE(12344),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11945),
    [sym_unary_typed_expression] = STATE(12344),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12344),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11947),
    [sym_block_comment] = STATE(1516),
    [sym_line_comment] = STATE(1516),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1517] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1517),
    [sym_line_comment] = STATE(1517),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7218),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1518] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1518),
    [sym_line_comment] = STATE(1518),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7220),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1519] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1519),
    [sym_line_comment] = STATE(1519),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7222),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1520] = {
    [sym_open_tuple] = STATE(19163),
    [sym_assignment] = STATE(8017),
    [sym__expression] = STATE(8508),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(1520),
    [sym_line_comment] = STATE(1520),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1521] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1521),
    [sym_line_comment] = STATE(1521),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7224),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1522] = {
    [sym__expression] = STATE(13791),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17484),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1522),
    [sym_line_comment] = STATE(1522),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7226),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1523] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1523),
    [sym_line_comment] = STATE(1523),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7228),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1524] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1524),
    [sym_line_comment] = STATE(1524),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7230),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1525] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1525),
    [sym_line_comment] = STATE(1525),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7232),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1526] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1526),
    [sym_line_comment] = STATE(1526),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7234),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1527] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1527),
    [sym_line_comment] = STATE(1527),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7236),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1528] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1528),
    [sym_line_comment] = STATE(1528),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7238),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1529] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1529),
    [sym_line_comment] = STATE(1529),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1530] = {
    [sym_open_tuple] = STATE(18470),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12489),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10389),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12503),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1530),
    [sym_line_comment] = STATE(1530),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1531] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1531),
    [sym_line_comment] = STATE(1531),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7242),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1532] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1532),
    [sym_line_comment] = STATE(1532),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7244),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1533] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1533),
    [sym_line_comment] = STATE(1533),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7246),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1534] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1534),
    [sym_line_comment] = STATE(1534),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7248),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1535] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1535),
    [sym_line_comment] = STATE(1535),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7250),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1536] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1536),
    [sym_line_comment] = STATE(1536),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7252),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1537] = {
    [sym_open_tuple] = STATE(12918),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12471),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10504),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12582),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1537),
    [sym_line_comment] = STATE(1537),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1538] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1538),
    [sym_line_comment] = STATE(1538),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7254),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1539] = {
    [sym_open_tuple] = STATE(12919),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12476),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10504),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12582),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1539),
    [sym_line_comment] = STATE(1539),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1540] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1540),
    [sym_line_comment] = STATE(1540),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7256),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1541] = {
    [sym_open_tuple] = STATE(19365),
    [sym_assignment] = STATE(8057),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11039),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13997),
    [sym_unary_expression] = STATE(13997),
    [sym_range_expression] = STATE(13997),
    [sym_splat_expression] = STATE(13997),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13717),
    [sym_unary_typed_expression] = STATE(13997),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13997),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13716),
    [sym_block_comment] = STATE(1541),
    [sym_line_comment] = STATE(1541),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1542] = {
    [sym_open_tuple] = STATE(19568),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13145),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10690),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13134),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1542),
    [sym_line_comment] = STATE(1542),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1543] = {
    [sym_open_tuple] = STATE(19555),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12091),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10342),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12292),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1543),
    [sym_line_comment] = STATE(1543),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1544] = {
    [sym_open_tuple] = STATE(18383),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12093),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10314),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12019),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1544),
    [sym_line_comment] = STATE(1544),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1545] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1545),
    [sym_line_comment] = STATE(1545),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1546] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1546),
    [sym_line_comment] = STATE(1546),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7260),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1547] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1547),
    [sym_line_comment] = STATE(1547),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7262),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1548] = {
    [sym_open_tuple] = STATE(15173),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12710),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10378),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12468),
    [sym_unary_expression] = STATE(12468),
    [sym_range_expression] = STATE(12468),
    [sym_splat_expression] = STATE(12468),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12153),
    [sym_unary_typed_expression] = STATE(12468),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12468),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12159),
    [sym_block_comment] = STATE(1548),
    [sym_line_comment] = STATE(1548),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1549] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1549),
    [sym_line_comment] = STATE(1549),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7264),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1550] = {
    [sym__expression] = STATE(13805),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17646),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1550),
    [sym_line_comment] = STATE(1550),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7266),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1551] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1551),
    [sym_line_comment] = STATE(1551),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7268),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1552] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1552),
    [sym_line_comment] = STATE(1552),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7232),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1553] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1553),
    [sym_line_comment] = STATE(1553),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7270),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1554] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1554),
    [sym_line_comment] = STATE(1554),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7272),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1555] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1555),
    [sym_line_comment] = STATE(1555),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1556] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1556),
    [sym_line_comment] = STATE(1556),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7276),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1557] = {
    [sym_open_tuple] = STATE(19315),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11040),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14006),
    [sym_unary_expression] = STATE(14006),
    [sym_range_expression] = STATE(14006),
    [sym_splat_expression] = STATE(14006),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13725),
    [sym_unary_typed_expression] = STATE(14006),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14006),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13731),
    [sym_block_comment] = STATE(1557),
    [sym_line_comment] = STATE(1557),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1558] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1558),
    [sym_line_comment] = STATE(1558),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7278),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1559] = {
    [sym_open_tuple] = STATE(12504),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12389),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10352),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12481),
    [sym_unary_expression] = STATE(12481),
    [sym_range_expression] = STATE(12481),
    [sym_splat_expression] = STATE(12481),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12268),
    [sym_unary_typed_expression] = STATE(12481),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12481),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12269),
    [sym_block_comment] = STATE(1559),
    [sym_line_comment] = STATE(1559),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1560] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1560),
    [sym_line_comment] = STATE(1560),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7280),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1561] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1561),
    [sym_line_comment] = STATE(1561),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7282),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1562] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1562),
    [sym_line_comment] = STATE(1562),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7284),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1563] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1563),
    [sym_line_comment] = STATE(1563),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7286),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1564] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1564),
    [sym_line_comment] = STATE(1564),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7288),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1565] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1565),
    [sym_line_comment] = STATE(1565),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7290),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1566] = {
    [sym_open_tuple] = STATE(18529),
    [sym_assignment] = STATE(7266),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10885),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14080),
    [sym_unary_expression] = STATE(14080),
    [sym_range_expression] = STATE(14080),
    [sym_splat_expression] = STATE(14080),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13623),
    [sym_unary_typed_expression] = STATE(14080),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14080),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13773),
    [sym_block_comment] = STATE(1566),
    [sym_line_comment] = STATE(1566),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1567] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1567),
    [sym_line_comment] = STATE(1567),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6966),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1568] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1568),
    [sym_line_comment] = STATE(1568),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7292),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1569] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1569),
    [sym_line_comment] = STATE(1569),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7294),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1570] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1570),
    [sym_line_comment] = STATE(1570),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7296),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1571] = {
    [sym_open_tuple] = STATE(18778),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12817),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10387),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12865),
    [sym_unary_expression] = STATE(12865),
    [sym_range_expression] = STATE(12865),
    [sym_splat_expression] = STATE(12865),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12478),
    [sym_unary_typed_expression] = STATE(12865),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12865),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12490),
    [sym_block_comment] = STATE(1571),
    [sym_line_comment] = STATE(1571),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1572] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1572),
    [sym_line_comment] = STATE(1572),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7298),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1573] = {
    [sym__expression] = STATE(13859),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17447),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1573),
    [sym_line_comment] = STATE(1573),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7300),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1574] = {
    [sym_open_tuple] = STATE(15309),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12405),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10298),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12722),
    [sym_unary_expression] = STATE(12722),
    [sym_range_expression] = STATE(12722),
    [sym_splat_expression] = STATE(12722),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12210),
    [sym_unary_typed_expression] = STATE(12722),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12722),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12213),
    [sym_block_comment] = STATE(1574),
    [sym_line_comment] = STATE(1574),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1575] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1575),
    [sym_line_comment] = STATE(1575),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7302),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1576] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1576),
    [sym_line_comment] = STATE(1576),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7304),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1577] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1577),
    [sym_line_comment] = STATE(1577),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7306),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1578] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1578),
    [sym_line_comment] = STATE(1578),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7308),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1579] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1579),
    [sym_line_comment] = STATE(1579),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7310),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1580] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1580),
    [sym_line_comment] = STATE(1580),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7312),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1581] = {
    [sym_open_tuple] = STATE(7307),
    [sym_assignment] = STATE(7273),
    [sym__expression] = STATE(7072),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(1581),
    [sym_line_comment] = STATE(1581),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1582] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1582),
    [sym_line_comment] = STATE(1582),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7314),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1583] = {
    [sym_open_tuple] = STATE(7308),
    [sym_assignment] = STATE(7305),
    [sym__expression] = STATE(7073),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(1583),
    [sym_line_comment] = STATE(1583),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1584] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1584),
    [sym_line_comment] = STATE(1584),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7316),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1585] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1585),
    [sym_line_comment] = STATE(1585),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7318),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1586] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1586),
    [sym_line_comment] = STATE(1586),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7320),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1587] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1587),
    [sym_line_comment] = STATE(1587),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7322),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1588] = {
    [sym_open_tuple] = STATE(19461),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12011),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10216),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12344),
    [sym_unary_expression] = STATE(12344),
    [sym_range_expression] = STATE(12344),
    [sym_splat_expression] = STATE(12344),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11945),
    [sym_unary_typed_expression] = STATE(12344),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12344),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11947),
    [sym_block_comment] = STATE(1588),
    [sym_line_comment] = STATE(1588),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1589] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1589),
    [sym_line_comment] = STATE(1589),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7324),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1590] = {
    [sym_open_tuple] = STATE(18778),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13964),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10387),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12865),
    [sym_unary_expression] = STATE(12865),
    [sym_range_expression] = STATE(12865),
    [sym_splat_expression] = STATE(12865),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12478),
    [sym_unary_typed_expression] = STATE(12865),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12865),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12490),
    [sym_block_comment] = STATE(1590),
    [sym_line_comment] = STATE(1590),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1591] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1591),
    [sym_line_comment] = STATE(1591),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7326),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1592] = {
    [sym_open_tuple] = STATE(18348),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10887),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14099),
    [sym_unary_expression] = STATE(14099),
    [sym_range_expression] = STATE(14099),
    [sym_splat_expression] = STATE(14099),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13711),
    [sym_unary_typed_expression] = STATE(14099),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14099),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13479),
    [sym_block_comment] = STATE(1592),
    [sym_line_comment] = STATE(1592),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1593] = {
    [sym_open_tuple] = STATE(8627),
    [sym_assignment] = STATE(8328),
    [sym__expression] = STATE(8760),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4747),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8935),
    [sym_unary_expression] = STATE(8935),
    [sym_range_expression] = STATE(8935),
    [sym_splat_expression] = STATE(8935),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8252),
    [sym_unary_typed_expression] = STATE(8935),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8935),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8253),
    [sym_block_comment] = STATE(1593),
    [sym_line_comment] = STATE(1593),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1594] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1594),
    [sym_line_comment] = STATE(1594),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7328),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1595] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1595),
    [sym_line_comment] = STATE(1595),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7330),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1596] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1596),
    [sym_line_comment] = STATE(1596),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7332),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1597] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1597),
    [sym_line_comment] = STATE(1597),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7334),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1598] = {
    [sym_open_tuple] = STATE(12191),
    [sym_assignment] = STATE(12131),
    [sym__expression] = STATE(12142),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10240),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12195),
    [sym_unary_expression] = STATE(12195),
    [sym_range_expression] = STATE(12195),
    [sym_splat_expression] = STATE(12195),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11860),
    [sym_unary_typed_expression] = STATE(12195),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12195),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11849),
    [sym_block_comment] = STATE(1598),
    [sym_line_comment] = STATE(1598),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1599] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1599),
    [sym_line_comment] = STATE(1599),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7336),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1600] = {
    [sym__expression] = STATE(13913),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17529),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1600),
    [sym_line_comment] = STATE(1600),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7338),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1601] = {
    [sym_open_tuple] = STATE(12194),
    [sym_assignment] = STATE(12151),
    [sym__expression] = STATE(12154),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10240),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12195),
    [sym_unary_expression] = STATE(12195),
    [sym_range_expression] = STATE(12195),
    [sym_splat_expression] = STATE(12195),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11860),
    [sym_unary_typed_expression] = STATE(12195),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12195),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11849),
    [sym_block_comment] = STATE(1601),
    [sym_line_comment] = STATE(1601),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1602] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1602),
    [sym_line_comment] = STATE(1602),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7340),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1603] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1603),
    [sym_line_comment] = STATE(1603),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7304),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1604] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1604),
    [sym_line_comment] = STATE(1604),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7342),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1605] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1605),
    [sym_line_comment] = STATE(1605),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7344),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1606] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1606),
    [sym_line_comment] = STATE(1606),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7346),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1607] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1607),
    [sym_line_comment] = STATE(1607),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7348),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1608] = {
    [sym_open_tuple] = STATE(18738),
    [sym_assignment] = STATE(7640),
    [sym__expression] = STATE(7460),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(1608),
    [sym_line_comment] = STATE(1608),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1609] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1609),
    [sym_line_comment] = STATE(1609),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7350),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1610] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1610),
    [sym_line_comment] = STATE(1610),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7352),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1611] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1611),
    [sym_line_comment] = STATE(1611),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7354),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1612] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1612),
    [sym_line_comment] = STATE(1612),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7356),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1613] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1613),
    [sym_line_comment] = STATE(1613),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7358),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1614] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1614),
    [sym_line_comment] = STATE(1614),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7360),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1615] = {
    [sym_open_tuple] = STATE(12544),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12101),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10372),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12348),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1615),
    [sym_line_comment] = STATE(1615),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1616] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1616),
    [sym_line_comment] = STATE(1616),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7362),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1617] = {
    [sym_open_tuple] = STATE(12549),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12102),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10372),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12348),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1617),
    [sym_line_comment] = STATE(1617),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1618] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1618),
    [sym_line_comment] = STATE(1618),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7364),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1619] = {
    [sym_open_tuple] = STATE(18267),
    [sym_assignment] = STATE(12062),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10889),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14096),
    [sym_unary_expression] = STATE(14096),
    [sym_range_expression] = STATE(14096),
    [sym_splat_expression] = STATE(14096),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13763),
    [sym_unary_typed_expression] = STATE(14096),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14096),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13624),
    [sym_block_comment] = STATE(1619),
    [sym_line_comment] = STATE(1619),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1620] = {
    [sym_open_tuple] = STATE(8581),
    [sym_assignment] = STATE(7955),
    [sym__expression] = STATE(8449),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(1620),
    [sym_line_comment] = STATE(1620),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1621] = {
    [sym_open_tuple] = STATE(8825),
    [sym_assignment] = STATE(8759),
    [sym__expression] = STATE(8492),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(1621),
    [sym_line_comment] = STATE(1621),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1622] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1622),
    [sym_line_comment] = STATE(1622),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7386),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1623] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1623),
    [sym_line_comment] = STATE(1623),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7388),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1624] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1624),
    [sym_line_comment] = STATE(1624),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7390),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1625] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1625),
    [sym_line_comment] = STATE(1625),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7392),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1626] = {
    [sym__expression] = STATE(13960),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17319),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1626),
    [sym_line_comment] = STATE(1626),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7394),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1627] = {
    [sym_open_tuple] = STATE(7272),
    [sym_assignment] = STATE(7273),
    [sym__expression] = STATE(7277),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(1627),
    [sym_line_comment] = STATE(1627),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1628] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1628),
    [sym_line_comment] = STATE(1628),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7396),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1629] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1629),
    [sym_line_comment] = STATE(1629),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7398),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1630] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1630),
    [sym_line_comment] = STATE(1630),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7400),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1631] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1631),
    [sym_line_comment] = STATE(1631),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7402),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1632] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1632),
    [sym_line_comment] = STATE(1632),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7404),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1633] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1633),
    [sym_line_comment] = STATE(1633),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7406),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1634] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1634),
    [sym_line_comment] = STATE(1634),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7408),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1635] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(1635),
    [sym_line_comment] = STATE(1635),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7410),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1636] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1636),
    [sym_line_comment] = STATE(1636),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7412),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1637] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1637),
    [sym_line_comment] = STATE(1637),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7414),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1638] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1638),
    [sym_line_comment] = STATE(1638),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7416),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1639] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1639),
    [sym_line_comment] = STATE(1639),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7418),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1640] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1640),
    [sym_line_comment] = STATE(1640),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7420),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1641] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1641),
    [sym_line_comment] = STATE(1641),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7422),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1642] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1642),
    [sym_line_comment] = STATE(1642),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7424),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1643] = {
    [sym_open_tuple] = STATE(18952),
    [sym_assignment] = STATE(7315),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10891),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13994),
    [sym_unary_expression] = STATE(13994),
    [sym_range_expression] = STATE(13994),
    [sym_splat_expression] = STATE(13994),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13793),
    [sym_unary_typed_expression] = STATE(13994),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13994),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13712),
    [sym_block_comment] = STATE(1643),
    [sym_line_comment] = STATE(1643),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1644] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1644),
    [sym_line_comment] = STATE(1644),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7426),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1645] = {
    [sym_open_tuple] = STATE(19399),
    [sym_assignment] = STATE(12066),
    [sym__expression] = STATE(12152),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10240),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12195),
    [sym_unary_expression] = STATE(12195),
    [sym_range_expression] = STATE(12195),
    [sym_splat_expression] = STATE(12195),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11860),
    [sym_unary_typed_expression] = STATE(12195),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12195),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11849),
    [sym_block_comment] = STATE(1645),
    [sym_line_comment] = STATE(1645),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1646] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1646),
    [sym_line_comment] = STATE(1646),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7428),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1647] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1647),
    [sym_line_comment] = STATE(1647),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7430),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1648] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1648),
    [sym_line_comment] = STATE(1648),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7432),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1649] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1649),
    [sym_line_comment] = STATE(1649),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7434),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1650] = {
    [sym__expression] = STATE(13571),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17471),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1650),
    [sym_line_comment] = STATE(1650),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7436),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1651] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1651),
    [sym_line_comment] = STATE(1651),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7438),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1652] = {
    [sym__expression] = STATE(13580),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17109),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1652),
    [sym_line_comment] = STATE(1652),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7440),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1653] = {
    [sym_open_tuple] = STATE(19404),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12050),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10372),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12348),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1653),
    [sym_line_comment] = STATE(1653),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1654] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1654),
    [sym_line_comment] = STATE(1654),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7442),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1655] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1655),
    [sym_line_comment] = STATE(1655),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7396),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1656] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1656),
    [sym_line_comment] = STATE(1656),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7444),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1657] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1657),
    [sym_line_comment] = STATE(1657),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7446),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1658] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1658),
    [sym_line_comment] = STATE(1658),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7448),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1659] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1659),
    [sym_line_comment] = STATE(1659),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7450),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1660] = {
    [sym_open_tuple] = STATE(7290),
    [sym_assignment] = STATE(7305),
    [sym__expression] = STATE(7343),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(1660),
    [sym_line_comment] = STATE(1660),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1661] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1661),
    [sym_line_comment] = STATE(1661),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7452),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1662] = {
    [sym__expression] = STATE(13936),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17565),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1662),
    [sym_line_comment] = STATE(1662),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7454),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1663] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1663),
    [sym_line_comment] = STATE(1663),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7456),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1664] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1664),
    [sym_line_comment] = STATE(1664),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7458),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1665] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1665),
    [sym_line_comment] = STATE(1665),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7460),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1666] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1666),
    [sym_line_comment] = STATE(1666),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7462),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1667] = {
    [sym_open_tuple] = STATE(8673),
    [sym_assignment] = STATE(8807),
    [sym__expression] = STATE(8488),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(1667),
    [sym_line_comment] = STATE(1667),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1668] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1668),
    [sym_line_comment] = STATE(1668),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7464),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1669] = {
    [sym_open_tuple] = STATE(8674),
    [sym_assignment] = STATE(8877),
    [sym__expression] = STATE(8489),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4826),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8925),
    [sym_unary_expression] = STATE(8925),
    [sym_range_expression] = STATE(8925),
    [sym_splat_expression] = STATE(8925),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8030),
    [sym_unary_typed_expression] = STATE(8925),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8925),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(7938),
    [sym_block_comment] = STATE(1669),
    [sym_line_comment] = STATE(1669),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1670] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1670),
    [sym_line_comment] = STATE(1670),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7466),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1671] = {
    [sym_open_tuple] = STATE(18568),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10893),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14044),
    [sym_unary_expression] = STATE(14044),
    [sym_range_expression] = STATE(14044),
    [sym_splat_expression] = STATE(14044),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13806),
    [sym_unary_typed_expression] = STATE(14044),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14044),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13764),
    [sym_block_comment] = STATE(1671),
    [sym_line_comment] = STATE(1671),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1672] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1672),
    [sym_line_comment] = STATE(1672),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7468),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1673] = {
    [sym_open_tuple] = STATE(12631),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12650),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10375),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12434),
    [sym_unary_expression] = STATE(12434),
    [sym_range_expression] = STATE(12434),
    [sym_splat_expression] = STATE(12434),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12140),
    [sym_unary_typed_expression] = STATE(12434),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12434),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12144),
    [sym_block_comment] = STATE(1673),
    [sym_line_comment] = STATE(1673),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1674] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1674),
    [sym_line_comment] = STATE(1674),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7470),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1675] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1675),
    [sym_line_comment] = STATE(1675),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7472),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1676] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1676),
    [sym_line_comment] = STATE(1676),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7474),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1677] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1677),
    [sym_line_comment] = STATE(1677),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7476),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1678] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1678),
    [sym_line_comment] = STATE(1678),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7478),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1679] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1679),
    [sym_line_comment] = STATE(1679),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7480),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1680] = {
    [sym__expression] = STATE(13582),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17259),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1680),
    [sym_line_comment] = STATE(1680),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7482),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1681] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1681),
    [sym_line_comment] = STATE(1681),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7484),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1682] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1682),
    [sym_line_comment] = STATE(1682),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7486),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1683] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1683),
    [sym_line_comment] = STATE(1683),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7488),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1684] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1684),
    [sym_line_comment] = STATE(1684),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7490),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1685] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1685),
    [sym_line_comment] = STATE(1685),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7492),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1686] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1686),
    [sym_line_comment] = STATE(1686),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7494),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1687] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1687),
    [sym_line_comment] = STATE(1687),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7496),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1688] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1688),
    [sym_line_comment] = STATE(1688),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7498),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1689] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1689),
    [sym_line_comment] = STATE(1689),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7500),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1690] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1690),
    [sym_line_comment] = STATE(1690),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7478),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1691] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1691),
    [sym_line_comment] = STATE(1691),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7502),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1692] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1692),
    [sym_line_comment] = STATE(1692),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7504),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1693] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1693),
    [sym_line_comment] = STATE(1693),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7506),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1694] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1694),
    [sym_line_comment] = STATE(1694),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7508),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1695] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1695),
    [sym_line_comment] = STATE(1695),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7510),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1696] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1696),
    [sym_line_comment] = STATE(1696),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7512),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1697] = {
    [sym_open_tuple] = STATE(12683),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12696),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10375),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12434),
    [sym_unary_expression] = STATE(12434),
    [sym_range_expression] = STATE(12434),
    [sym_splat_expression] = STATE(12434),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12140),
    [sym_unary_typed_expression] = STATE(12434),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12434),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12144),
    [sym_block_comment] = STATE(1697),
    [sym_line_comment] = STATE(1697),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1698] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1698),
    [sym_line_comment] = STATE(1698),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7514),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1699] = {
    [sym_open_tuple] = STATE(19068),
    [sym_assignment] = STATE(8227),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10895),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14040),
    [sym_unary_expression] = STATE(14040),
    [sym_range_expression] = STATE(14040),
    [sym_splat_expression] = STATE(14040),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13863),
    [sym_unary_typed_expression] = STATE(14040),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14040),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13794),
    [sym_block_comment] = STATE(1699),
    [sym_line_comment] = STATE(1699),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1700] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1700),
    [sym_line_comment] = STATE(1700),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7516),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1701] = {
    [sym_open_tuple] = STATE(17984),
    [sym_assignment] = STATE(18234),
    [sym__expression] = STATE(13476),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(1701),
    [sym_line_comment] = STATE(1701),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1702] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1702),
    [sym_line_comment] = STATE(1702),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7518),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1703] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1703),
    [sym_line_comment] = STATE(1703),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7520),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1704] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1704),
    [sym_line_comment] = STATE(1704),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7522),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1705] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1705),
    [sym_line_comment] = STATE(1705),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7524),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1706] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1706),
    [sym_line_comment] = STATE(1706),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7526),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1707] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1707),
    [sym_line_comment] = STATE(1707),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7528),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1708] = {
    [sym__expression] = STATE(13824),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17404),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1708),
    [sym_line_comment] = STATE(1708),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7530),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1709] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1709),
    [sym_line_comment] = STATE(1709),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7532),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1710] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1710),
    [sym_line_comment] = STATE(1710),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7534),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1711] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1711),
    [sym_line_comment] = STATE(1711),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7488),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1712] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1712),
    [sym_line_comment] = STATE(1712),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7536),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1713] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1713),
    [sym_line_comment] = STATE(1713),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7538),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1714] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1714),
    [sym_line_comment] = STATE(1714),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7540),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1715] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1715),
    [sym_line_comment] = STATE(1715),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7542),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1716] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1716),
    [sym_line_comment] = STATE(1716),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7544),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1717] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1717),
    [sym_line_comment] = STATE(1717),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7546),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1718] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1718),
    [sym_line_comment] = STATE(1718),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7548),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1719] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1719),
    [sym_line_comment] = STATE(1719),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7550),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1720] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1720),
    [sym_line_comment] = STATE(1720),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7552),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1721] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1721),
    [sym_line_comment] = STATE(1721),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7554),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1722] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1722),
    [sym_line_comment] = STATE(1722),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7556),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1723] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1723),
    [sym_line_comment] = STATE(1723),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7558),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1724] = {
    [sym_open_tuple] = STATE(12869),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12870),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10499),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12915),
    [sym_unary_expression] = STATE(12915),
    [sym_range_expression] = STATE(12915),
    [sym_splat_expression] = STATE(12915),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12548),
    [sym_unary_typed_expression] = STATE(12915),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12915),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12551),
    [sym_block_comment] = STATE(1724),
    [sym_line_comment] = STATE(1724),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1725] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1725),
    [sym_line_comment] = STATE(1725),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7560),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1726] = {
    [sym_open_tuple] = STATE(19558),
    [sym_assignment] = STATE(8262),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10897),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13984),
    [sym_unary_expression] = STATE(13984),
    [sym_range_expression] = STATE(13984),
    [sym_splat_expression] = STATE(13984),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13915),
    [sym_unary_typed_expression] = STATE(13984),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13984),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13807),
    [sym_block_comment] = STATE(1726),
    [sym_line_comment] = STATE(1726),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1727] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1727),
    [sym_line_comment] = STATE(1727),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6988),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1728] = {
    [sym_open_tuple] = STATE(12936),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12812),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10469),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12909),
    [sym_unary_expression] = STATE(12909),
    [sym_range_expression] = STATE(12909),
    [sym_splat_expression] = STATE(12909),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(12909),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12909),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12508),
    [sym_block_comment] = STATE(1728),
    [sym_line_comment] = STATE(1728),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1729] = {
    [sym_open_tuple] = STATE(13695),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(13167),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10722),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13293),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1729),
    [sym_line_comment] = STATE(1729),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1730] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1730),
    [sym_line_comment] = STATE(1730),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7562),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1731] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1731),
    [sym_line_comment] = STATE(1731),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7564),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1732] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1732),
    [sym_line_comment] = STATE(1732),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7566),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1733] = {
    [sym_open_tuple] = STATE(13696),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(13168),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10722),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13293),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1733),
    [sym_line_comment] = STATE(1733),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1734] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1734),
    [sym_line_comment] = STATE(1734),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7568),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1735] = {
    [sym__expression] = STATE(13449),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17125),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1735),
    [sym_line_comment] = STATE(1735),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7570),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1736] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1736),
    [sym_line_comment] = STATE(1736),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7572),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1737] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1737),
    [sym_line_comment] = STATE(1737),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7574),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1738] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1738),
    [sym_line_comment] = STATE(1738),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7576),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1739] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1739),
    [sym_line_comment] = STATE(1739),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7578),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1740] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1740),
    [sym_line_comment] = STATE(1740),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7580),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1741] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1741),
    [sym_line_comment] = STATE(1741),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7582),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1742] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1742),
    [sym_line_comment] = STATE(1742),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7584),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1743] = {
    [sym_open_tuple] = STATE(15258),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12486),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10289),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12515),
    [sym_unary_expression] = STATE(12515),
    [sym_range_expression] = STATE(12515),
    [sym_splat_expression] = STATE(12515),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12040),
    [sym_unary_typed_expression] = STATE(12515),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12515),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12042),
    [sym_block_comment] = STATE(1743),
    [sym_line_comment] = STATE(1743),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1744] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1744),
    [sym_line_comment] = STATE(1744),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7586),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1745] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1745),
    [sym_line_comment] = STATE(1745),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7588),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1746] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1746),
    [sym_line_comment] = STATE(1746),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7590),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1747] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1747),
    [sym_line_comment] = STATE(1747),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7592),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1748] = {
    [sym_open_tuple] = STATE(19531),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13629),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10703),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13698),
    [sym_unary_expression] = STATE(13698),
    [sym_range_expression] = STATE(13698),
    [sym_splat_expression] = STATE(13698),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13344),
    [sym_unary_typed_expression] = STATE(13698),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13698),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13361),
    [sym_block_comment] = STATE(1748),
    [sym_line_comment] = STATE(1748),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1749] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1749),
    [sym_line_comment] = STATE(1749),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7594),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1750] = {
    [sym_open_tuple] = STATE(9236),
    [sym_assignment] = STATE(9292),
    [sym__expression] = STATE(9263),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(1750),
    [sym_line_comment] = STATE(1750),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1751] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1751),
    [sym_line_comment] = STATE(1751),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7596),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1752] = {
    [sym_open_tuple] = STATE(18603),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10899),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14011),
    [sym_unary_expression] = STATE(14011),
    [sym_range_expression] = STATE(14011),
    [sym_splat_expression] = STATE(14011),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13962),
    [sym_unary_typed_expression] = STATE(14011),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14011),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13864),
    [sym_block_comment] = STATE(1752),
    [sym_line_comment] = STATE(1752),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1753] = {
    [sym_open_tuple] = STATE(18424),
    [sym_assignment] = STATE(8726),
    [sym__expression] = STATE(8927),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(1753),
    [sym_line_comment] = STATE(1753),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1754] = {
    [sym_open_tuple] = STATE(13683),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(13156),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10722),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13293),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1754),
    [sym_line_comment] = STATE(1754),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1755] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1755),
    [sym_line_comment] = STATE(1755),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7598),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1756] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1756),
    [sym_line_comment] = STATE(1756),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7600),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1757] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1757),
    [sym_line_comment] = STATE(1757),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7602),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1758] = {
    [sym_open_tuple] = STATE(8571),
    [sym_assignment] = STATE(8120),
    [sym__expression] = STATE(8282),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4431),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8036),
    [sym_unary_expression] = STATE(8036),
    [sym_range_expression] = STATE(8036),
    [sym_splat_expression] = STATE(8036),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7899),
    [sym_unary_typed_expression] = STATE(8036),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8036),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7905),
    [sym_block_comment] = STATE(1758),
    [sym_line_comment] = STATE(1758),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1759] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1759),
    [sym_line_comment] = STATE(1759),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7604),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1760] = {
    [sym__expression] = STATE(13511),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17452),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1760),
    [sym_line_comment] = STATE(1760),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7606),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1761] = {
    [sym_open_tuple] = STATE(12903),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12578),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10446),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12473),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1761),
    [sym_line_comment] = STATE(1761),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1762] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1762),
    [sym_line_comment] = STATE(1762),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7608),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1763] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1763),
    [sym_line_comment] = STATE(1763),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7574),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1764] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1764),
    [sym_line_comment] = STATE(1764),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7610),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1765] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1765),
    [sym_line_comment] = STATE(1765),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7612),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1766] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1766),
    [sym_line_comment] = STATE(1766),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7614),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1767] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1767),
    [sym_line_comment] = STATE(1767),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7616),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1768] = {
    [sym_open_tuple] = STATE(12904),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12581),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10446),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12473),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1768),
    [sym_line_comment] = STATE(1768),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1769] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1769),
    [sym_line_comment] = STATE(1769),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7618),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1770] = {
    [sym_open_tuple] = STATE(18424),
    [sym_assignment] = STATE(8746),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10987),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13985),
    [sym_unary_expression] = STATE(13985),
    [sym_range_expression] = STATE(13985),
    [sym_splat_expression] = STATE(13985),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13551),
    [sym_unary_typed_expression] = STATE(13985),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13985),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13556),
    [sym_block_comment] = STATE(1770),
    [sym_line_comment] = STATE(1770),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1771] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1771),
    [sym_line_comment] = STATE(1771),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7620),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1772] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1772),
    [sym_line_comment] = STATE(1772),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7622),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1773] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1773),
    [sym_line_comment] = STATE(1773),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7624),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1774] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1774),
    [sym_line_comment] = STATE(1774),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7626),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1775] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1775),
    [sym_line_comment] = STATE(1775),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7628),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1776] = {
    [sym_open_tuple] = STATE(19038),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12591),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10375),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12434),
    [sym_unary_expression] = STATE(12434),
    [sym_range_expression] = STATE(12434),
    [sym_splat_expression] = STATE(12434),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12140),
    [sym_unary_typed_expression] = STATE(12434),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12434),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12144),
    [sym_block_comment] = STATE(1776),
    [sym_line_comment] = STATE(1776),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1777] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1777),
    [sym_line_comment] = STATE(1777),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7630),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1778] = {
    [sym_open_tuple] = STATE(18901),
    [sym_assignment] = STATE(8057),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10901),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14045),
    [sym_unary_expression] = STATE(14045),
    [sym_range_expression] = STATE(14045),
    [sym_splat_expression] = STATE(14045),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13584),
    [sym_unary_typed_expression] = STATE(14045),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14045),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13916),
    [sym_block_comment] = STATE(1778),
    [sym_line_comment] = STATE(1778),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1779] = {
    [sym_open_tuple] = STATE(7810),
    [sym_assignment] = STATE(7724),
    [sym__expression] = STATE(7080),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(1779),
    [sym_line_comment] = STATE(1779),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1780] = {
    [sym_open_tuple] = STATE(12873),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12874),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10499),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12915),
    [sym_unary_expression] = STATE(12915),
    [sym_range_expression] = STATE(12915),
    [sym_splat_expression] = STATE(12915),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12548),
    [sym_unary_typed_expression] = STATE(12915),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12915),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12551),
    [sym_block_comment] = STATE(1780),
    [sym_line_comment] = STATE(1780),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1781] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1781),
    [sym_line_comment] = STATE(1781),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7632),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1782] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1782),
    [sym_line_comment] = STATE(1782),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7634),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1783] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1783),
    [sym_line_comment] = STATE(1783),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7636),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1784] = {
    [sym_open_tuple] = STATE(8263),
    [sym_assignment] = STATE(8264),
    [sym__expression] = STATE(8265),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(1784),
    [sym_line_comment] = STATE(1784),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1785] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1785),
    [sym_line_comment] = STATE(1785),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7638),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1786] = {
    [sym__expression] = STATE(13588),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17240),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1786),
    [sym_line_comment] = STATE(1786),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7640),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1787] = {
    [sym_open_tuple] = STATE(8266),
    [sym_assignment] = STATE(8270),
    [sym__expression] = STATE(8274),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(1787),
    [sym_line_comment] = STATE(1787),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1788] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1788),
    [sym_line_comment] = STATE(1788),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7642),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1789] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1789),
    [sym_line_comment] = STATE(1789),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7644),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1790] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1790),
    [sym_line_comment] = STATE(1790),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1791] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1791),
    [sym_line_comment] = STATE(1791),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7648),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1792] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1792),
    [sym_line_comment] = STATE(1792),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7650),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1793] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1793),
    [sym_line_comment] = STATE(1793),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7652),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1794] = {
    [sym_open_tuple] = STATE(18576),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12698),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10446),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12473),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1794),
    [sym_line_comment] = STATE(1794),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1795] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1795),
    [sym_line_comment] = STATE(1795),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7654),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1796] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1796),
    [sym_line_comment] = STATE(1796),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7656),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1797] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1797),
    [sym_line_comment] = STATE(1797),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7658),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1798] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1798),
    [sym_line_comment] = STATE(1798),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7660),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1799] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1799),
    [sym_line_comment] = STATE(1799),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7662),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1800] = {
    [sym_open_tuple] = STATE(8087),
    [sym_assignment] = STATE(8472),
    [sym__expression] = STATE(7625),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(1800),
    [sym_line_comment] = STATE(1800),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1801] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1801),
    [sym_line_comment] = STATE(1801),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7664),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1802] = {
    [sym_open_tuple] = STATE(8088),
    [sym_assignment] = STATE(8475),
    [sym__expression] = STATE(7626),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(1802),
    [sym_line_comment] = STATE(1802),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1803] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1803),
    [sym_line_comment] = STATE(1803),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7666),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1804] = {
    [sym_open_tuple] = STATE(18469),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10903),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13400),
    [sym_unary_expression] = STATE(13400),
    [sym_range_expression] = STATE(13400),
    [sym_splat_expression] = STATE(13400),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13585),
    [sym_unary_typed_expression] = STATE(13400),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13400),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13114),
    [sym_block_comment] = STATE(1804),
    [sym_line_comment] = STATE(1804),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1805] = {
    [sym_open_tuple] = STATE(8950),
    [sym_assignment] = STATE(8328),
    [sym__expression] = STATE(8953),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(1805),
    [sym_line_comment] = STATE(1805),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1806] = {
    [sym_open_tuple] = STATE(12219),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12232),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10216),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12344),
    [sym_unary_expression] = STATE(12344),
    [sym_range_expression] = STATE(12344),
    [sym_splat_expression] = STATE(12344),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11945),
    [sym_unary_typed_expression] = STATE(12344),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12344),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11947),
    [sym_block_comment] = STATE(1806),
    [sym_line_comment] = STATE(1806),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1807] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1807),
    [sym_line_comment] = STATE(1807),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7668),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1808] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1808),
    [sym_line_comment] = STATE(1808),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7670),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1809] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1809),
    [sym_line_comment] = STATE(1809),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7672),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1810] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1810),
    [sym_line_comment] = STATE(1810),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7674),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1811] = {
    [sym__expression] = STATE(13628),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17417),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1811),
    [sym_line_comment] = STATE(1811),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7676),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1812] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1812),
    [sym_line_comment] = STATE(1812),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7678),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1813] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1813),
    [sym_line_comment] = STATE(1813),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7644),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1814] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1814),
    [sym_line_comment] = STATE(1814),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7680),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1815] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1815),
    [sym_line_comment] = STATE(1815),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7682),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1816] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1816),
    [sym_line_comment] = STATE(1816),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7684),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1817] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1817),
    [sym_line_comment] = STATE(1817),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7686),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1818] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1818),
    [sym_line_comment] = STATE(1818),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7688),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1819] = {
    [sym_open_tuple] = STATE(18366),
    [sym_assignment] = STATE(8367),
    [sym__expression] = STATE(7964),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4415),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8083),
    [sym_unary_expression] = STATE(8083),
    [sym_range_expression] = STATE(8083),
    [sym_splat_expression] = STATE(8083),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7689),
    [sym_unary_typed_expression] = STATE(8083),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8083),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7694),
    [sym_block_comment] = STATE(1819),
    [sym_line_comment] = STATE(1819),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1820] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1820),
    [sym_line_comment] = STATE(1820),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7690),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1821] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1821),
    [sym_line_comment] = STATE(1821),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7692),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1822] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1822),
    [sym_line_comment] = STATE(1822),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7694),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1823] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1823),
    [sym_line_comment] = STATE(1823),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7696),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1824] = {
    [sym_open_tuple] = STATE(19163),
    [sym_assignment] = STATE(8017),
    [sym__expression] = STATE(7644),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(1824),
    [sym_line_comment] = STATE(1824),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1825] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1825),
    [sym_line_comment] = STATE(1825),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7698),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1826] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1826),
    [sym_line_comment] = STATE(1826),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7700),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1827] = {
    [sym_open_tuple] = STATE(18316),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10906),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13581),
    [sym_unary_expression] = STATE(13581),
    [sym_range_expression] = STATE(13581),
    [sym_splat_expression] = STATE(13581),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13851),
    [sym_unary_typed_expression] = STATE(13581),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13581),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13282),
    [sym_block_comment] = STATE(1827),
    [sym_line_comment] = STATE(1827),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1828] = {
    [sym_open_tuple] = STATE(8682),
    [sym_assignment] = STATE(8060),
    [sym__expression] = STATE(8496),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(1828),
    [sym_line_comment] = STATE(1828),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1829] = {
    [sym_open_tuple] = STATE(8683),
    [sym_assignment] = STATE(8061),
    [sym__expression] = STATE(8497),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(1829),
    [sym_line_comment] = STATE(1829),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1830] = {
    [sym_open_tuple] = STATE(8970),
    [sym_assignment] = STATE(8060),
    [sym__expression] = STATE(9140),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(1830),
    [sym_line_comment] = STATE(1830),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1831] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1831),
    [sym_line_comment] = STATE(1831),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7702),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1832] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1832),
    [sym_line_comment] = STATE(1832),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7704),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1833] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1833),
    [sym_line_comment] = STATE(1833),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7706),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1834] = {
    [sym_open_tuple] = STATE(9068),
    [sym_assignment] = STATE(8061),
    [sym__expression] = STATE(9144),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(1834),
    [sym_line_comment] = STATE(1834),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1835] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1835),
    [sym_line_comment] = STATE(1835),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7708),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1836] = {
    [sym__expression] = STATE(13697),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17268),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1836),
    [sym_line_comment] = STATE(1836),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7710),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1837] = {
    [sym_open_tuple] = STATE(12045),
    [sym_assignment] = STATE(12243),
    [sym__expression] = STATE(12256),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10240),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12195),
    [sym_unary_expression] = STATE(12195),
    [sym_range_expression] = STATE(12195),
    [sym_splat_expression] = STATE(12195),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11860),
    [sym_unary_typed_expression] = STATE(12195),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12195),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11849),
    [sym_block_comment] = STATE(1837),
    [sym_line_comment] = STATE(1837),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1838] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1838),
    [sym_line_comment] = STATE(1838),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7712),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1839] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1839),
    [sym_line_comment] = STATE(1839),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7714),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1840] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1840),
    [sym_line_comment] = STATE(1840),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7716),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1841] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1841),
    [sym_line_comment] = STATE(1841),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7718),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1842] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1842),
    [sym_line_comment] = STATE(1842),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7720),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1843] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1843),
    [sym_line_comment] = STATE(1843),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7722),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1844] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1844),
    [sym_line_comment] = STATE(1844),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7724),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1845] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1845),
    [sym_line_comment] = STATE(1845),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7726),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1846] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1846),
    [sym_line_comment] = STATE(1846),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7728),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1847] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1847),
    [sym_line_comment] = STATE(1847),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1848] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1848),
    [sym_line_comment] = STATE(1848),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7732),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1849] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1849),
    [sym_line_comment] = STATE(1849),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7734),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1850] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(1850),
    [sym_line_comment] = STATE(1850),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7182),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1851] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1851),
    [sym_line_comment] = STATE(1851),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7736),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1852] = {
    [sym_open_tuple] = STATE(16648),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12844),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10407),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(13011),
    [sym_unary_expression] = STATE(13011),
    [sym_range_expression] = STATE(13011),
    [sym_splat_expression] = STATE(13011),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12652),
    [sym_unary_typed_expression] = STATE(13011),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(13011),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12465),
    [sym_block_comment] = STATE(1852),
    [sym_line_comment] = STATE(1852),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1853] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1853),
    [sym_line_comment] = STATE(1853),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7738),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1854] = {
    [sym_open_tuple] = STATE(19325),
    [sym_assignment] = STATE(7315),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10918),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13993),
    [sym_unary_expression] = STATE(13993),
    [sym_range_expression] = STATE(13993),
    [sym_splat_expression] = STATE(13993),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13520),
    [sym_unary_typed_expression] = STATE(13993),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13993),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13586),
    [sym_block_comment] = STATE(1854),
    [sym_line_comment] = STATE(1854),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1855] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1855),
    [sym_line_comment] = STATE(1855),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7740),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1856] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1856),
    [sym_line_comment] = STATE(1856),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7742),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1857] = {
    [sym_open_tuple] = STATE(7727),
    [sym_assignment] = STATE(7778),
    [sym__expression] = STATE(7754),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(1857),
    [sym_line_comment] = STATE(1857),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1858] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1858),
    [sym_line_comment] = STATE(1858),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7764),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1859] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1859),
    [sym_line_comment] = STATE(1859),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7766),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1860] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1860),
    [sym_line_comment] = STATE(1860),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7768),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1861] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1861),
    [sym_line_comment] = STATE(1861),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7770),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1862] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1862),
    [sym_line_comment] = STATE(1862),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7772),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1863] = {
    [sym__expression] = STATE(13753),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17181),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1863),
    [sym_line_comment] = STATE(1863),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7774),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1864] = {
    [sym__expression] = STATE(13666),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1864),
    [sym_line_comment] = STATE(1864),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7776),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1865] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1865),
    [sym_line_comment] = STATE(1865),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7778),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1866] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1866),
    [sym_line_comment] = STATE(1866),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7714),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1867] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1867),
    [sym_line_comment] = STATE(1867),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7780),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1868] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1868),
    [sym_line_comment] = STATE(1868),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7782),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1869] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1869),
    [sym_line_comment] = STATE(1869),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7784),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1870] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1870),
    [sym_line_comment] = STATE(1870),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7786),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1871] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1871),
    [sym_line_comment] = STATE(1871),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1872] = {
    [sym_open_tuple] = STATE(19365),
    [sym_assignment] = STATE(8205),
    [sym__expression] = STATE(8503),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4573),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8117),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(1872),
    [sym_line_comment] = STATE(1872),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1873] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1873),
    [sym_line_comment] = STATE(1873),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7790),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1874] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1874),
    [sym_line_comment] = STATE(1874),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7792),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1875] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1875),
    [sym_line_comment] = STATE(1875),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7794),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1876] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1876),
    [sym_line_comment] = STATE(1876),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7796),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1877] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1877),
    [sym_line_comment] = STATE(1877),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7798),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1878] = {
    [sym_open_tuple] = STATE(12274),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(11758),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10207),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11929),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1878),
    [sym_line_comment] = STATE(1878),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1879] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1879),
    [sym_line_comment] = STATE(1879),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7800),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1880] = {
    [sym_open_tuple] = STATE(19347),
    [sym_assignment] = STATE(8227),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10921),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13999),
    [sym_unary_expression] = STATE(13999),
    [sym_range_expression] = STATE(13999),
    [sym_splat_expression] = STATE(13999),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13589),
    [sym_unary_typed_expression] = STATE(13999),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13999),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13869),
    [sym_block_comment] = STATE(1880),
    [sym_line_comment] = STATE(1880),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1881] = {
    [sym_open_tuple] = STATE(12275),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(11763),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10207),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11929),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1881),
    [sym_line_comment] = STATE(1881),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1882] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1882),
    [sym_line_comment] = STATE(1882),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7802),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1883] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1883),
    [sym_line_comment] = STATE(1883),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7804),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1884] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1884),
    [sym_line_comment] = STATE(1884),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7806),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1885] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1885),
    [sym_line_comment] = STATE(1885),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7808),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1886] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1886),
    [sym_line_comment] = STATE(1886),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7470),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1887] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1887),
    [sym_line_comment] = STATE(1887),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7810),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1888] = {
    [sym__expression] = STATE(13774),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17442),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1888),
    [sym_line_comment] = STATE(1888),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7812),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1889] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1889),
    [sym_line_comment] = STATE(1889),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7814),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1890] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1890),
    [sym_line_comment] = STATE(1890),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7816),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1891] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1891),
    [sym_line_comment] = STATE(1891),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1892] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1892),
    [sym_line_comment] = STATE(1892),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7820),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1893] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1893),
    [sym_line_comment] = STATE(1893),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7822),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1894] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1894),
    [sym_line_comment] = STATE(1894),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7824),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1895] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1895),
    [sym_line_comment] = STATE(1895),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7826),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1896] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1896),
    [sym_line_comment] = STATE(1896),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7828),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1897] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1897),
    [sym_line_comment] = STATE(1897),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7830),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1898] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1898),
    [sym_line_comment] = STATE(1898),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7832),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1899] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1899),
    [sym_line_comment] = STATE(1899),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7834),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1900] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1900),
    [sym_line_comment] = STATE(1900),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7836),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1901] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1901),
    [sym_line_comment] = STATE(1901),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7838),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1902] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1902),
    [sym_line_comment] = STATE(1902),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7840),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1903] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1903),
    [sym_line_comment] = STATE(1903),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7842),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1904] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1904),
    [sym_line_comment] = STATE(1904),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7844),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1905] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1905),
    [sym_line_comment] = STATE(1905),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7846),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1906] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1906),
    [sym_line_comment] = STATE(1906),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7848),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1907] = {
    [sym_open_tuple] = STATE(18320),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10924),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14003),
    [sym_unary_expression] = STATE(14003),
    [sym_range_expression] = STATE(14003),
    [sym_splat_expression] = STATE(14003),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13630),
    [sym_unary_typed_expression] = STATE(14003),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14003),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13450),
    [sym_block_comment] = STATE(1907),
    [sym_line_comment] = STATE(1907),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1908] = {
    [sym_open_tuple] = STATE(18920),
    [sym_assignment] = STATE(8205),
    [sym__expression] = STATE(9003),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4859),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9128),
    [sym_unary_expression] = STATE(9128),
    [sym_range_expression] = STATE(9128),
    [sym_splat_expression] = STATE(9128),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8750),
    [sym_unary_typed_expression] = STATE(9128),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9128),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8724),
    [sym_block_comment] = STATE(1908),
    [sym_line_comment] = STATE(1908),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1909] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1909),
    [sym_line_comment] = STATE(1909),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1910] = {
    [sym_open_tuple] = STATE(12480),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12524),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10375),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12434),
    [sym_unary_expression] = STATE(12434),
    [sym_range_expression] = STATE(12434),
    [sym_splat_expression] = STATE(12434),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12140),
    [sym_unary_typed_expression] = STATE(12434),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12434),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12144),
    [sym_block_comment] = STATE(1910),
    [sym_line_comment] = STATE(1910),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1911] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1911),
    [sym_line_comment] = STATE(1911),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7852),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1912] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1912),
    [sym_line_comment] = STATE(1912),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7854),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1913] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1913),
    [sym_line_comment] = STATE(1913),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7856),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1914] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1914),
    [sym_line_comment] = STATE(1914),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7858),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1915] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1915),
    [sym_line_comment] = STATE(1915),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7860),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1916] = {
    [sym__expression] = STATE(13803),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17116),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1916),
    [sym_line_comment] = STATE(1916),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7862),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1917] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1917),
    [sym_line_comment] = STATE(1917),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7864),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1918] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1918),
    [sym_line_comment] = STATE(1918),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7866),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1919] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1919),
    [sym_line_comment] = STATE(1919),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7818),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1920] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1920),
    [sym_line_comment] = STATE(1920),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7868),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1921] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1921),
    [sym_line_comment] = STATE(1921),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7870),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1922] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1922),
    [sym_line_comment] = STATE(1922),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7872),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1923] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1923),
    [sym_line_comment] = STATE(1923),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7874),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1924] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1924),
    [sym_line_comment] = STATE(1924),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7876),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1925] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1925),
    [sym_line_comment] = STATE(1925),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7878),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1926] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1926),
    [sym_line_comment] = STATE(1926),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7880),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1927] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1927),
    [sym_line_comment] = STATE(1927),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7882),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1928] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1928),
    [sym_line_comment] = STATE(1928),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7884),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1929] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1929),
    [sym_line_comment] = STATE(1929),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1930] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1930),
    [sym_line_comment] = STATE(1930),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1931] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1931),
    [sym_line_comment] = STATE(1931),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7890),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1932] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1932),
    [sym_line_comment] = STATE(1932),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7892),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1933] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1933),
    [sym_line_comment] = STATE(1933),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7894),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1934] = {
    [sym_open_tuple] = STATE(18512),
    [sym_assignment] = STATE(8096),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10926),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14036),
    [sym_unary_expression] = STATE(14036),
    [sym_range_expression] = STATE(14036),
    [sym_splat_expression] = STATE(14036),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13710),
    [sym_unary_typed_expression] = STATE(14036),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14036),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13523),
    [sym_block_comment] = STATE(1934),
    [sym_line_comment] = STATE(1934),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1935] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18827),
    [sym__expression] = STATE(13459),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(1935),
    [sym_line_comment] = STATE(1935),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1936] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1936),
    [sym_line_comment] = STATE(1936),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7896),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1937] = {
    [sym_open_tuple] = STATE(7738),
    [sym_assignment] = STATE(7320),
    [sym__expression] = STATE(7323),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(1937),
    [sym_line_comment] = STATE(1937),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1938] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1938),
    [sym_line_comment] = STATE(1938),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7898),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1939] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1939),
    [sym_line_comment] = STATE(1939),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7900),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1940] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1940),
    [sym_line_comment] = STATE(1940),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7902),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1941] = {
    [sym_open_tuple] = STATE(12438),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12646),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10293),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12413),
    [sym_unary_expression] = STATE(12413),
    [sym_range_expression] = STATE(12413),
    [sym_splat_expression] = STATE(12413),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12037),
    [sym_unary_typed_expression] = STATE(12413),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12413),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12234),
    [sym_block_comment] = STATE(1941),
    [sym_line_comment] = STATE(1941),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1942] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1942),
    [sym_line_comment] = STATE(1942),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7904),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1943] = {
    [sym__expression] = STATE(13846),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17359),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1943),
    [sym_line_comment] = STATE(1943),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7906),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1944] = {
    [sym_open_tuple] = STATE(12492),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12648),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10293),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12413),
    [sym_unary_expression] = STATE(12413),
    [sym_range_expression] = STATE(12413),
    [sym_splat_expression] = STATE(12413),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12037),
    [sym_unary_typed_expression] = STATE(12413),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12413),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12234),
    [sym_block_comment] = STATE(1944),
    [sym_line_comment] = STATE(1944),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1945] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1945),
    [sym_line_comment] = STATE(1945),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7908),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1946] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1946),
    [sym_line_comment] = STATE(1946),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7910),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1947] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1947),
    [sym_line_comment] = STATE(1947),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7912),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1948] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1948),
    [sym_line_comment] = STATE(1948),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7914),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1949] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1949),
    [sym_line_comment] = STATE(1949),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7916),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1950] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1950),
    [sym_line_comment] = STATE(1950),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7918),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1951] = {
    [sym_open_tuple] = STATE(7249),
    [sym_assignment] = STATE(7330),
    [sym__expression] = STATE(7333),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(1951),
    [sym_line_comment] = STATE(1951),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1952] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1952),
    [sym_line_comment] = STATE(1952),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7920),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1953] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1953),
    [sym_line_comment] = STATE(1953),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7922),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1954] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1954),
    [sym_line_comment] = STATE(1954),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7924),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1955] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1955),
    [sym_line_comment] = STATE(1955),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7926),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1956] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1956),
    [sym_line_comment] = STATE(1956),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7928),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1957] = {
    [sym_open_tuple] = STATE(18348),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(11914),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10207),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11929),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1957),
    [sym_line_comment] = STATE(1957),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1958] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1958),
    [sym_line_comment] = STATE(1958),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7930),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1959] = {
    [sym_open_tuple] = STATE(18599),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13169),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10722),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13293),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(1959),
    [sym_line_comment] = STATE(1959),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1960] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1960),
    [sym_line_comment] = STATE(1960),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7932),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1961] = {
    [sym_open_tuple] = STATE(18720),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10930),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13278),
    [sym_unary_expression] = STATE(13278),
    [sym_range_expression] = STATE(13278),
    [sym_splat_expression] = STATE(13278),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13755),
    [sym_unary_typed_expression] = STATE(13278),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13278),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12805),
    [sym_block_comment] = STATE(1961),
    [sym_line_comment] = STATE(1961),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1962] = {
    [sym_open_tuple] = STATE(9262),
    [sym_assignment] = STATE(9292),
    [sym__expression] = STATE(9106),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(1962),
    [sym_line_comment] = STATE(1962),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1963] = {
    [sym_open_tuple] = STATE(15036),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12335),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10202),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12022),
    [sym_unary_expression] = STATE(12022),
    [sym_range_expression] = STATE(12022),
    [sym_splat_expression] = STATE(12022),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11939),
    [sym_unary_typed_expression] = STATE(12022),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12022),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11942),
    [sym_block_comment] = STATE(1963),
    [sym_line_comment] = STATE(1963),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1964] = {
    [sym_open_tuple] = STATE(12757),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12588),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10254),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12738),
    [sym_unary_expression] = STATE(12738),
    [sym_range_expression] = STATE(12738),
    [sym_splat_expression] = STATE(12738),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12175),
    [sym_unary_typed_expression] = STATE(12738),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12738),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12016),
    [sym_block_comment] = STATE(1964),
    [sym_line_comment] = STATE(1964),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1965] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1965),
    [sym_line_comment] = STATE(1965),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7934),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1966] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1966),
    [sym_line_comment] = STATE(1966),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7936),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1967] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1967),
    [sym_line_comment] = STATE(1967),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7938),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1968] = {
    [sym_open_tuple] = STATE(12337),
    [sym_assignment] = STATE(12131),
    [sym__expression] = STATE(11902),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10169),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12036),
    [sym_unary_expression] = STATE(12036),
    [sym_range_expression] = STATE(12036),
    [sym_splat_expression] = STATE(12036),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11968),
    [sym_unary_typed_expression] = STATE(12036),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12036),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11979),
    [sym_block_comment] = STATE(1968),
    [sym_line_comment] = STATE(1968),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1969] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1969),
    [sym_line_comment] = STATE(1969),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7940),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1970] = {
    [sym__expression] = STATE(13874),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17071),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1970),
    [sym_line_comment] = STATE(1970),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7942),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1971] = {
    [sym_open_tuple] = STATE(12338),
    [sym_assignment] = STATE(12151),
    [sym__expression] = STATE(11903),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10169),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12036),
    [sym_unary_expression] = STATE(12036),
    [sym_range_expression] = STATE(12036),
    [sym_splat_expression] = STATE(12036),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11968),
    [sym_unary_typed_expression] = STATE(12036),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12036),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11979),
    [sym_block_comment] = STATE(1971),
    [sym_line_comment] = STATE(1971),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1972] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1972),
    [sym_line_comment] = STATE(1972),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7944),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1973] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1973),
    [sym_line_comment] = STATE(1973),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7910),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1974] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1974),
    [sym_line_comment] = STATE(1974),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7946),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1975] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1975),
    [sym_line_comment] = STATE(1975),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7948),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1976] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1976),
    [sym_line_comment] = STATE(1976),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7950),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1977] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1977),
    [sym_line_comment] = STATE(1977),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7952),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1978] = {
    [sym_open_tuple] = STATE(18923),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11005),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12909),
    [sym_unary_expression] = STATE(12909),
    [sym_range_expression] = STATE(12909),
    [sym_splat_expression] = STATE(12909),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13596),
    [sym_unary_typed_expression] = STATE(12909),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12909),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12508),
    [sym_block_comment] = STATE(1978),
    [sym_line_comment] = STATE(1978),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1979] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1979),
    [sym_line_comment] = STATE(1979),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7954),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1980] = {
    [sym_open_tuple] = STATE(8268),
    [sym_assignment] = STATE(8375),
    [sym__expression] = STATE(7956),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(1980),
    [sym_line_comment] = STATE(1980),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1981] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1981),
    [sym_line_comment] = STATE(1981),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7976),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1982] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1982),
    [sym_line_comment] = STATE(1982),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7978),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1983] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1983),
    [sym_line_comment] = STATE(1983),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7980),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1984] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1984),
    [sym_line_comment] = STATE(1984),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7982),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1985] = {
    [sym_open_tuple] = STATE(8309),
    [sym_assignment] = STATE(7955),
    [sym__expression] = STATE(7648),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(1985),
    [sym_line_comment] = STATE(1985),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1986] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1986),
    [sym_line_comment] = STATE(1986),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7984),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1987] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(1987),
    [sym_line_comment] = STATE(1987),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7986),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1988] = {
    [sym_open_tuple] = STATE(18866),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10935),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12749),
    [sym_unary_expression] = STATE(12749),
    [sym_range_expression] = STATE(12749),
    [sym_splat_expression] = STATE(12749),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13777),
    [sym_unary_typed_expression] = STATE(12749),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12749),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12218),
    [sym_block_comment] = STATE(1988),
    [sym_line_comment] = STATE(1988),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1989] = {
    [sym_open_tuple] = STATE(18267),
    [sym_assignment] = STATE(12066),
    [sym__expression] = STATE(11937),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10169),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12036),
    [sym_unary_expression] = STATE(12036),
    [sym_range_expression] = STATE(12036),
    [sym_splat_expression] = STATE(12036),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11968),
    [sym_unary_typed_expression] = STATE(12036),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12036),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11979),
    [sym_block_comment] = STATE(1989),
    [sym_line_comment] = STATE(1989),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1990] = {
    [sym_open_tuple] = STATE(18738),
    [sym_assignment] = STATE(7640),
    [sym__expression] = STATE(7405),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4194),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7287),
    [sym_unary_expression] = STATE(7287),
    [sym_range_expression] = STATE(7287),
    [sym_splat_expression] = STATE(7287),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6959),
    [sym_unary_typed_expression] = STATE(7287),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7287),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6960),
    [sym_block_comment] = STATE(1990),
    [sym_line_comment] = STATE(1990),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1991] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1991),
    [sym_line_comment] = STATE(1991),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7988),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1992] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1992),
    [sym_line_comment] = STATE(1992),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7990),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1993] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1993),
    [sym_line_comment] = STATE(1993),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(7992),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1994] = {
    [sym_open_tuple] = STATE(12685),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12105),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10309),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12090),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1994),
    [sym_line_comment] = STATE(1994),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1995] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(1995),
    [sym_line_comment] = STATE(1995),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(7994),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1996] = {
    [sym__expression] = STATE(13925),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17575),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1996),
    [sym_line_comment] = STATE(1996),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7996),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1997] = {
    [sym_open_tuple] = STATE(12686),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12106),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10309),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12090),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(1997),
    [sym_line_comment] = STATE(1997),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1998] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(1998),
    [sym_line_comment] = STATE(1998),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7998),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [1999] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(1999),
    [sym_line_comment] = STATE(1999),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8000),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2000] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2000),
    [sym_line_comment] = STATE(2000),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8002),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2001] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2001),
    [sym_line_comment] = STATE(2001),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8004),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2002] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2002),
    [sym_line_comment] = STATE(2002),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8006),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2003] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2003),
    [sym_line_comment] = STATE(2003),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8008),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2004] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2004),
    [sym_line_comment] = STATE(2004),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8010),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2005] = {
    [sym_open_tuple] = STATE(12841),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12423),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10446),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12473),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2005),
    [sym_line_comment] = STATE(2005),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2006] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2006),
    [sym_line_comment] = STATE(2006),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8012),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2007] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2007),
    [sym_line_comment] = STATE(2007),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8014),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2008] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2008),
    [sym_line_comment] = STATE(2008),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8016),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2009] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2009),
    [sym_line_comment] = STATE(2009),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8018),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2010] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2010),
    [sym_line_comment] = STATE(2010),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8020),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2011] = {
    [sym_open_tuple] = STATE(18952),
    [sym_assignment] = STATE(7806),
    [sym__expression] = STATE(7722),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4190),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7748),
    [sym_unary_expression] = STATE(7748),
    [sym_range_expression] = STATE(7748),
    [sym_splat_expression] = STATE(7748),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6774),
    [sym_unary_typed_expression] = STATE(7748),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7748),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6704),
    [sym_block_comment] = STATE(2011),
    [sym_line_comment] = STATE(2011),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2012] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2012),
    [sym_line_comment] = STATE(2012),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8022),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2013] = {
    [sym_open_tuple] = STATE(18958),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10940),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12413),
    [sym_unary_expression] = STATE(12413),
    [sym_range_expression] = STATE(12413),
    [sym_splat_expression] = STATE(12413),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13804),
    [sym_unary_typed_expression] = STATE(12413),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12413),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12234),
    [sym_block_comment] = STATE(2013),
    [sym_line_comment] = STATE(2013),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2014] = {
    [sym_open_tuple] = STATE(18568),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12074),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10309),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12090),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2014),
    [sym_line_comment] = STATE(2014),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2015] = {
    [sym_open_tuple] = STATE(15455),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12888),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10530),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12831),
    [sym_unary_expression] = STATE(12831),
    [sym_range_expression] = STATE(12831),
    [sym_splat_expression] = STATE(12831),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12401),
    [sym_unary_typed_expression] = STATE(12831),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12831),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12462),
    [sym_block_comment] = STATE(2015),
    [sym_line_comment] = STATE(2015),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2016] = {
    [sym_open_tuple] = STATE(8428),
    [sym_assignment] = STATE(8264),
    [sym__expression] = STATE(7631),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(2016),
    [sym_line_comment] = STATE(2016),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2017] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2017),
    [sym_line_comment] = STATE(2017),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8024),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2018] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2018),
    [sym_line_comment] = STATE(2018),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8026),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2019] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2019),
    [sym_line_comment] = STATE(2019),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8028),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2020] = {
    [sym_open_tuple] = STATE(8429),
    [sym_assignment] = STATE(8270),
    [sym__expression] = STATE(7632),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(2020),
    [sym_line_comment] = STATE(2020),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2021] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2021),
    [sym_line_comment] = STATE(2021),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8030),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2022] = {
    [sym__expression] = STATE(13945),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17098),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2022),
    [sym_line_comment] = STATE(2022),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8032),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2023] = {
    [sym_open_tuple] = STATE(8097),
    [sym_assignment] = STATE(8233),
    [sym__expression] = STATE(8248),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(2023),
    [sym_line_comment] = STATE(2023),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2024] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2024),
    [sym_line_comment] = STATE(2024),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8034),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2025] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2025),
    [sym_line_comment] = STATE(2025),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8000),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2026] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2026),
    [sym_line_comment] = STATE(2026),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8036),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2027] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2027),
    [sym_line_comment] = STATE(2027),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8038),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2028] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2028),
    [sym_line_comment] = STATE(2028),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8040),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2029] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2029),
    [sym_line_comment] = STATE(2029),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8042),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2030] = {
    [sym_open_tuple] = STATE(9026),
    [sym_assignment] = STATE(8328),
    [sym__expression] = STATE(8618),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(2030),
    [sym_line_comment] = STATE(2030),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2031] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2031),
    [sym_line_comment] = STATE(2031),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8044),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2032] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2032),
    [sym_line_comment] = STATE(2032),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8046),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2033] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2033),
    [sym_line_comment] = STATE(2033),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8048),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2034] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2034),
    [sym_line_comment] = STATE(2034),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8050),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2035] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2035),
    [sym_line_comment] = STATE(2035),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8052),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2036] = {
    [sym_open_tuple] = STATE(8104),
    [sym_assignment] = STATE(8333),
    [sym__expression] = STATE(8416),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(2036),
    [sym_line_comment] = STATE(2036),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2037] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2037),
    [sym_line_comment] = STATE(2037),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8054),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2038] = {
    [sym_open_tuple] = STATE(19558),
    [sym_assignment] = STATE(8367),
    [sym__expression] = STATE(7654),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4318),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8173),
    [sym_unary_expression] = STATE(8173),
    [sym_range_expression] = STATE(8173),
    [sym_splat_expression] = STATE(8173),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7530),
    [sym_unary_typed_expression] = STATE(8173),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8173),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7549),
    [sym_block_comment] = STATE(2038),
    [sym_line_comment] = STATE(2038),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2039] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2039),
    [sym_line_comment] = STATE(2039),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8056),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2040] = {
    [sym_open_tuple] = STATE(19083),
    [sym_assignment] = STATE(9150),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11069),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14094),
    [sym_unary_expression] = STATE(14094),
    [sym_range_expression] = STATE(14094),
    [sym_splat_expression] = STATE(14094),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13787),
    [sym_unary_typed_expression] = STATE(14094),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14094),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13786),
    [sym_block_comment] = STATE(2040),
    [sym_line_comment] = STATE(2040),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2041] = {
    [sym_open_tuple] = STATE(8984),
    [sym_assignment] = STATE(8060),
    [sym__expression] = STATE(8815),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(2041),
    [sym_line_comment] = STATE(2041),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2042] = {
    [sym_open_tuple] = STATE(9002),
    [sym_assignment] = STATE(8061),
    [sym__expression] = STATE(8816),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(2042),
    [sym_line_comment] = STATE(2042),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2043] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2043),
    [sym_line_comment] = STATE(2043),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8058),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2044] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2044),
    [sym_line_comment] = STATE(2044),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8060),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2045] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2045),
    [sym_line_comment] = STATE(2045),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2046] = {
    [sym_open_tuple] = STATE(15248),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12601),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10289),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12515),
    [sym_unary_expression] = STATE(12515),
    [sym_range_expression] = STATE(12515),
    [sym_splat_expression] = STATE(12515),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12040),
    [sym_unary_typed_expression] = STATE(12515),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12515),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12042),
    [sym_block_comment] = STATE(2046),
    [sym_line_comment] = STATE(2046),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2047] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2047),
    [sym_line_comment] = STATE(2047),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8064),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2048] = {
    [sym__expression] = STATE(13956),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17188),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2048),
    [sym_line_comment] = STATE(2048),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8066),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2049] = {
    [sym_open_tuple] = STATE(7264),
    [sym_assignment] = STATE(7778),
    [sym__expression] = STATE(7083),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(2049),
    [sym_line_comment] = STATE(2049),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2050] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2050),
    [sym_line_comment] = STATE(2050),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8068),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2051] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2051),
    [sym_line_comment] = STATE(2051),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8070),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2052] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2052),
    [sym_line_comment] = STATE(2052),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8072),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2053] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2053),
    [sym_line_comment] = STATE(2053),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8074),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2054] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2054),
    [sym_line_comment] = STATE(2054),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8076),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2055] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2055),
    [sym_line_comment] = STATE(2055),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8078),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2056] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2056),
    [sym_line_comment] = STATE(2056),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8080),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2057] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2057),
    [sym_line_comment] = STATE(2057),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8082),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2058] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2058),
    [sym_line_comment] = STATE(2058),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7424),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2059] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2059),
    [sym_line_comment] = STATE(2059),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8084),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2060] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2060),
    [sym_line_comment] = STATE(2060),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8086),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2061] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2061),
    [sym_line_comment] = STATE(2061),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8088),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2062] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2062),
    [sym_line_comment] = STATE(2062),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8090),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2063] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2063),
    [sym_line_comment] = STATE(2063),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8092),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2064] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2064),
    [sym_line_comment] = STATE(2064),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8094),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2065] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2065),
    [sym_line_comment] = STATE(2065),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8096),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2066] = {
    [sym_open_tuple] = STATE(19224),
    [sym_assignment] = STATE(8096),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10942),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14037),
    [sym_unary_expression] = STATE(14037),
    [sym_range_expression] = STATE(14037),
    [sym_splat_expression] = STATE(14037),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13847),
    [sym_unary_typed_expression] = STATE(14037),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14037),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13756),
    [sym_block_comment] = STATE(2066),
    [sym_line_comment] = STATE(2066),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2067] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2067),
    [sym_line_comment] = STATE(2067),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2068] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2068),
    [sym_line_comment] = STATE(2068),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8100),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2069] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2069),
    [sym_line_comment] = STATE(2069),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8102),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2070] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2070),
    [sym_line_comment] = STATE(2070),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8104),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2071] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2071),
    [sym_line_comment] = STATE(2071),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8106),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2072] = {
    [sym__expression] = STATE(13761),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17514),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2072),
    [sym_line_comment] = STATE(2072),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8108),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2073] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2073),
    [sym_line_comment] = STATE(2073),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8110),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2074] = {
    [sym__expression] = STATE(13968),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17578),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2074),
    [sym_line_comment] = STATE(2074),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8112),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2075] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2075),
    [sym_line_comment] = STATE(2075),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8114),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2076] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2076),
    [sym_line_comment] = STATE(2076),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8070),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2077] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2077),
    [sym_line_comment] = STATE(2077),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8116),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2078] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2078),
    [sym_line_comment] = STATE(2078),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8118),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2079] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2079),
    [sym_line_comment] = STATE(2079),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8120),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2080] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2080),
    [sym_line_comment] = STATE(2080),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8122),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2081] = {
    [sym_open_tuple] = STATE(18901),
    [sym_assignment] = STATE(8205),
    [sym__expression] = STATE(8806),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4886),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8028),
    [sym_unary_expression] = STATE(8028),
    [sym_range_expression] = STATE(8028),
    [sym_splat_expression] = STATE(8028),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8834),
    [sym_unary_typed_expression] = STATE(8028),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8028),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7893),
    [sym_block_comment] = STATE(2081),
    [sym_line_comment] = STATE(2081),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2082] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2082),
    [sym_line_comment] = STATE(2082),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8124),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2083] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2083),
    [sym_line_comment] = STATE(2083),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8126),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2084] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2084),
    [sym_line_comment] = STATE(2084),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8128),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2085] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2085),
    [sym_line_comment] = STATE(2085),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8130),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2086] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2086),
    [sym_line_comment] = STATE(2086),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8132),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2087] = {
    [sym_open_tuple] = STATE(12387),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12388),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10352),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12481),
    [sym_unary_expression] = STATE(12481),
    [sym_range_expression] = STATE(12481),
    [sym_splat_expression] = STATE(12481),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12268),
    [sym_unary_typed_expression] = STATE(12481),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12481),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12269),
    [sym_block_comment] = STATE(2087),
    [sym_line_comment] = STATE(2087),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2088] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2088),
    [sym_line_comment] = STATE(2088),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8134),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2089] = {
    [sym_open_tuple] = STATE(19361),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10945),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14086),
    [sym_unary_expression] = STATE(14086),
    [sym_range_expression] = STATE(14086),
    [sym_splat_expression] = STATE(14086),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13875),
    [sym_unary_typed_expression] = STATE(14086),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14086),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13778),
    [sym_block_comment] = STATE(2089),
    [sym_line_comment] = STATE(2089),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2090] = {
    [sym_open_tuple] = STATE(7349),
    [sym_assignment] = STATE(7320),
    [sym__expression] = STATE(7078),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(2090),
    [sym_line_comment] = STATE(2090),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2091] = {
    [sym_open_tuple] = STATE(7350),
    [sym_assignment] = STATE(7330),
    [sym__expression] = STATE(7079),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(2091),
    [sym_line_comment] = STATE(2091),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2092] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2092),
    [sym_line_comment] = STATE(2092),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8136),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2093] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2093),
    [sym_line_comment] = STATE(2093),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8138),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2094] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2094),
    [sym_line_comment] = STATE(2094),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8140),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2095] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2095),
    [sym_line_comment] = STATE(2095),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8142),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2096] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2096),
    [sym_line_comment] = STATE(2096),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8144),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2097] = {
    [sym__expression] = STATE(13442),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17269),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2097),
    [sym_line_comment] = STATE(2097),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8146),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2098] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2098),
    [sym_line_comment] = STATE(2098),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8148),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2099] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2099),
    [sym_line_comment] = STATE(2099),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8150),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2100] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2100),
    [sym_line_comment] = STATE(2100),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8152),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2101] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2101),
    [sym_line_comment] = STATE(2101),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8154),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2102] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2102),
    [sym_line_comment] = STATE(2102),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8156),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2103] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2103),
    [sym_line_comment] = STATE(2103),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8158),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2104] = {
    [sym_open_tuple] = STATE(8419),
    [sym_assignment] = STATE(8375),
    [sym__expression] = STATE(7653),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(2104),
    [sym_line_comment] = STATE(2104),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2105] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2105),
    [sym_line_comment] = STATE(2105),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8160),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2106] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2106),
    [sym_line_comment] = STATE(2106),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8162),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2107] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2107),
    [sym_line_comment] = STATE(2107),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8164),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2108] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2108),
    [sym_line_comment] = STATE(2108),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8166),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2109] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2109),
    [sym_line_comment] = STATE(2109),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8168),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2110] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2110),
    [sym_line_comment] = STATE(2110),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8170),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2111] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2111),
    [sym_line_comment] = STATE(2111),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8172),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2112] = {
    [sym_open_tuple] = STATE(19472),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10948),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13983),
    [sym_unary_expression] = STATE(13983),
    [sym_range_expression] = STATE(13983),
    [sym_splat_expression] = STATE(13983),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13927),
    [sym_unary_typed_expression] = STATE(13983),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13983),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13810),
    [sym_block_comment] = STATE(2112),
    [sym_line_comment] = STATE(2112),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2113] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2113),
    [sym_line_comment] = STATE(2113),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8174),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2114] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2114),
    [sym_line_comment] = STATE(2114),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2115] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2115),
    [sym_line_comment] = STATE(2115),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8178),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2116] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2116),
    [sym_line_comment] = STATE(2116),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8180),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2117] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2117),
    [sym_line_comment] = STATE(2117),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8182),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2118] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2118),
    [sym_line_comment] = STATE(2118),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6924),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2119] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2119),
    [sym_line_comment] = STATE(2119),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8184),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2120] = {
    [sym__expression] = STATE(13445),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17266),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2120),
    [sym_line_comment] = STATE(2120),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8186),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2121] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2121),
    [sym_line_comment] = STATE(2121),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8150),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2122] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2122),
    [sym_line_comment] = STATE(2122),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8188),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2123] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2123),
    [sym_line_comment] = STATE(2123),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8190),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2124] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2124),
    [sym_line_comment] = STATE(2124),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8192),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2125] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2125),
    [sym_line_comment] = STATE(2125),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8194),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2126] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2126),
    [sym_line_comment] = STATE(2126),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8196),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2127] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2127),
    [sym_line_comment] = STATE(2127),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8198),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2128] = {
    [sym_open_tuple] = STATE(19568),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10951),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14004),
    [sym_unary_expression] = STATE(14004),
    [sym_range_expression] = STATE(14004),
    [sym_splat_expression] = STATE(14004),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13946),
    [sym_unary_typed_expression] = STATE(14004),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14004),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13848),
    [sym_block_comment] = STATE(2128),
    [sym_line_comment] = STATE(2128),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2129] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2129),
    [sym_line_comment] = STATE(2129),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8200),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2130] = {
    [sym_open_tuple] = STATE(19068),
    [sym_assignment] = STATE(8058),
    [sym__expression] = STATE(8161),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4276),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8116),
    [sym_unary_expression] = STATE(8116),
    [sym_range_expression] = STATE(8116),
    [sym_splat_expression] = STATE(8116),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7228),
    [sym_unary_typed_expression] = STATE(8116),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8116),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7813),
    [sym_block_comment] = STATE(2130),
    [sym_line_comment] = STATE(2130),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2131] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2131),
    [sym_line_comment] = STATE(2131),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8202),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2132] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2132),
    [sym_line_comment] = STATE(2132),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8204),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2133] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2133),
    [sym_line_comment] = STATE(2133),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8206),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2134] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2134),
    [sym_line_comment] = STATE(2134),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8208),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2135] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2135),
    [sym_line_comment] = STATE(2135),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8210),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2136] = {
    [sym__expression] = STATE(13455),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2136),
    [sym_line_comment] = STATE(2136),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8212),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2137] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2137),
    [sym_line_comment] = STATE(2137),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8214),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2138] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2138),
    [sym_line_comment] = STATE(2138),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8216),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2139] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2139),
    [sym_line_comment] = STATE(2139),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8218),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2140] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2140),
    [sym_line_comment] = STATE(2140),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8220),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2141] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2141),
    [sym_line_comment] = STATE(2141),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8222),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2142] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2142),
    [sym_line_comment] = STATE(2142),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8224),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2143] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2143),
    [sym_line_comment] = STATE(2143),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8226),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2144] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2144),
    [sym_line_comment] = STATE(2144),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8228),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2145] = {
    [sym_open_tuple] = STATE(19460),
    [sym_assignment] = STATE(9150),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11140),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14010),
    [sym_unary_expression] = STATE(14010),
    [sym_range_expression] = STATE(14010),
    [sym_splat_expression] = STATE(14010),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13858),
    [sym_unary_typed_expression] = STATE(14010),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14010),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13856),
    [sym_block_comment] = STATE(2145),
    [sym_line_comment] = STATE(2145),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2146] = {
    [sym_open_tuple] = STATE(19325),
    [sym_assignment] = STATE(7806),
    [sym__expression] = STATE(7084),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4211),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7441),
    [sym_unary_expression] = STATE(7441),
    [sym_range_expression] = STATE(7441),
    [sym_splat_expression] = STATE(7441),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6971),
    [sym_unary_typed_expression] = STATE(7441),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7441),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6857),
    [sym_block_comment] = STATE(2146),
    [sym_line_comment] = STATE(2146),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2147] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2147),
    [sym_line_comment] = STATE(2147),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8230),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2148] = {
    [sym_open_tuple] = STATE(12390),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12391),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10352),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12481),
    [sym_unary_expression] = STATE(12481),
    [sym_range_expression] = STATE(12481),
    [sym_splat_expression] = STATE(12481),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12268),
    [sym_unary_typed_expression] = STATE(12481),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12481),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12269),
    [sym_block_comment] = STATE(2148),
    [sym_line_comment] = STATE(2148),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2149] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2149),
    [sym_line_comment] = STATE(2149),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8232),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2150] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2150),
    [sym_line_comment] = STATE(2150),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8234),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2151] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2151),
    [sym_line_comment] = STATE(2151),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8236),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2152] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2152),
    [sym_line_comment] = STATE(2152),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8238),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2153] = {
    [sym__expression] = STATE(13461),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17433),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2153),
    [sym_line_comment] = STATE(2153),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8240),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2154] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2154),
    [sym_line_comment] = STATE(2154),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8214),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2155] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2155),
    [sym_line_comment] = STATE(2155),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6930),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2156] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2156),
    [sym_line_comment] = STATE(2156),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8242),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2157] = {
    [sym_open_tuple] = STATE(8434),
    [sym_assignment] = STATE(8233),
    [sym__expression] = STATE(7642),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(2157),
    [sym_line_comment] = STATE(2157),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2158] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2158),
    [sym_line_comment] = STATE(2158),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8244),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2159] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2159),
    [sym_line_comment] = STATE(2159),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8246),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2160] = {
    [sym_open_tuple] = STATE(13172),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12958),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10610),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12777),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2160),
    [sym_line_comment] = STATE(2160),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2161] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2161),
    [sym_line_comment] = STATE(2161),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8248),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2162] = {
    [sym_open_tuple] = STATE(19555),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10958),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14029),
    [sym_unary_expression] = STATE(14029),
    [sym_range_expression] = STATE(14029),
    [sym_splat_expression] = STATE(14029),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13958),
    [sym_unary_typed_expression] = STATE(14029),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14029),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13876),
    [sym_block_comment] = STATE(2162),
    [sym_line_comment] = STATE(2162),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2163] = {
    [sym_open_tuple] = STATE(13173),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12959),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10610),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12777),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2163),
    [sym_line_comment] = STATE(2163),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2164] = {
    [sym_open_tuple] = STATE(8435),
    [sym_assignment] = STATE(8333),
    [sym__expression] = STATE(7643),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(2164),
    [sym_line_comment] = STATE(2164),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2165] = {
    [sym_open_tuple] = STATE(12506),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12545),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10320),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12522),
    [sym_unary_expression] = STATE(12522),
    [sym_range_expression] = STATE(12522),
    [sym_splat_expression] = STATE(12522),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12010),
    [sym_unary_typed_expression] = STATE(12522),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12522),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12322),
    [sym_block_comment] = STATE(2165),
    [sym_line_comment] = STATE(2165),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2166] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2166),
    [sym_line_comment] = STATE(2166),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8250),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2167] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2167),
    [sym_line_comment] = STATE(2167),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8252),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2168] = {
    [sym_open_tuple] = STATE(18835),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12422),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10254),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12738),
    [sym_unary_expression] = STATE(12738),
    [sym_range_expression] = STATE(12738),
    [sym_splat_expression] = STATE(12738),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12175),
    [sym_unary_typed_expression] = STATE(12738),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12738),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12016),
    [sym_block_comment] = STATE(2168),
    [sym_line_comment] = STATE(2168),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2169] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2169),
    [sym_line_comment] = STATE(2169),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8254),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2170] = {
    [sym__expression] = STATE(13470),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17501),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2170),
    [sym_line_comment] = STATE(2170),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8256),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2171] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2171),
    [sym_line_comment] = STATE(2171),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2172] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2172),
    [sym_line_comment] = STATE(2172),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8260),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2173] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2173),
    [sym_line_comment] = STATE(2173),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2174] = {
    [sym_open_tuple] = STATE(12626),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12756),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10320),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12522),
    [sym_unary_expression] = STATE(12522),
    [sym_range_expression] = STATE(12522),
    [sym_splat_expression] = STATE(12522),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12010),
    [sym_unary_typed_expression] = STATE(12522),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12522),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12322),
    [sym_block_comment] = STATE(2174),
    [sym_line_comment] = STATE(2174),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2175] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2175),
    [sym_line_comment] = STATE(2175),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8264),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2176] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2176),
    [sym_line_comment] = STATE(2176),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8266),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2177] = {
    [sym_open_tuple] = STATE(12396),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12126),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10247),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12080),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2177),
    [sym_line_comment] = STATE(2177),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2178] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2178),
    [sym_line_comment] = STATE(2178),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8268),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2179] = {
    [sym_open_tuple] = STATE(18383),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10962),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14052),
    [sym_unary_expression] = STATE(14052),
    [sym_range_expression] = STATE(14052),
    [sym_splat_expression] = STATE(14052),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13969),
    [sym_unary_typed_expression] = STATE(14052),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14052),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13928),
    [sym_block_comment] = STATE(2179),
    [sym_line_comment] = STATE(2179),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2180] = {
    [sym_open_tuple] = STATE(12521),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12550),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10320),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12522),
    [sym_unary_expression] = STATE(12522),
    [sym_range_expression] = STATE(12522),
    [sym_splat_expression] = STATE(12522),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12010),
    [sym_unary_typed_expression] = STATE(12522),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12522),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12322),
    [sym_block_comment] = STATE(2180),
    [sym_line_comment] = STATE(2180),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2181] = {
    [sym_open_tuple] = STATE(19418),
    [sym_assignment] = STATE(8470),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10949),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13989),
    [sym_unary_expression] = STATE(13989),
    [sym_range_expression] = STATE(13989),
    [sym_splat_expression] = STATE(13989),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13931),
    [sym_unary_typed_expression] = STATE(13989),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13989),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13475),
    [sym_block_comment] = STATE(2181),
    [sym_line_comment] = STATE(2181),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2182] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2182),
    [sym_line_comment] = STATE(2182),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8270),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2183] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2183),
    [sym_line_comment] = STATE(2183),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8272),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2184] = {
    [sym_open_tuple] = STATE(19347),
    [sym_assignment] = STATE(8058),
    [sym__expression] = STATE(7657),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4419),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8286),
    [sym_unary_expression] = STATE(8286),
    [sym_range_expression] = STATE(8286),
    [sym_splat_expression] = STATE(8286),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7492),
    [sym_unary_typed_expression] = STATE(8286),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8286),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7531),
    [sym_block_comment] = STATE(2184),
    [sym_line_comment] = STATE(2184),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2185] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2185),
    [sym_line_comment] = STATE(2185),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8274),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2186] = {
    [sym__expression] = STATE(13477),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2186),
    [sym_line_comment] = STATE(2186),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8276),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2187] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2187),
    [sym_line_comment] = STATE(2187),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8258),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2188] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2188),
    [sym_line_comment] = STATE(2188),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8278),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2189] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2189),
    [sym_line_comment] = STATE(2189),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8280),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2190] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2190),
    [sym_line_comment] = STATE(2190),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8282),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2191] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2191),
    [sym_line_comment] = STATE(2191),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8284),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2192] = {
    [sym_open_tuple] = STATE(12397),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12108),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10246),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12132),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2192),
    [sym_line_comment] = STATE(2192),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2193] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2193),
    [sym_line_comment] = STATE(2193),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8286),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2194] = {
    [sym_open_tuple] = STATE(12414),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12109),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10246),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12132),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2194),
    [sym_line_comment] = STATE(2194),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2195] = {
    [sym_open_tuple] = STATE(8353),
    [sym_assignment] = STATE(8448),
    [sym__expression] = STATE(8053),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(2195),
    [sym_line_comment] = STATE(2195),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2196] = {
    [sym_open_tuple] = STATE(8424),
    [sym_assignment] = STATE(8448),
    [sym__expression] = STATE(7655),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(2196),
    [sym_line_comment] = STATE(2196),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2197] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2197),
    [sym_line_comment] = STATE(2197),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8308),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2198] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2198),
    [sym_line_comment] = STATE(2198),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8310),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2199] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2199),
    [sym_line_comment] = STATE(2199),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8312),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2200] = {
    [sym__expression] = STATE(13496),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17663),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2200),
    [sym_line_comment] = STATE(2200),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8314),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2201] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2201),
    [sym_line_comment] = STATE(2201),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8316),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2202] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2202),
    [sym_line_comment] = STATE(2202),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8318),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2203] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2203),
    [sym_line_comment] = STATE(2203),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8320),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2204] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2204),
    [sym_line_comment] = STATE(2204),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8322),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2205] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2205),
    [sym_line_comment] = STATE(2205),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8324),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2206] = {
    [sym_open_tuple] = STATE(18320),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12084),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10246),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12132),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2206),
    [sym_line_comment] = STATE(2206),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2207] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2207),
    [sym_line_comment] = STATE(2207),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8326),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2208] = {
    [sym_open_tuple] = STATE(13467),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(13158),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10690),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13134),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2208),
    [sym_line_comment] = STATE(2208),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2209] = {
    [sym_open_tuple] = STATE(13468),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(13159),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10690),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13134),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2209),
    [sym_line_comment] = STATE(2209),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2210] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2210),
    [sym_line_comment] = STATE(2210),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8328),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2211] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2211),
    [sym_line_comment] = STATE(2211),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8330),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2212] = {
    [sym_open_tuple] = STATE(13140),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12946),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10610),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12777),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2212),
    [sym_line_comment] = STATE(2212),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2213] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2213),
    [sym_line_comment] = STATE(2213),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8332),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2214] = {
    [sym__expression] = STATE(13503),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17260),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2214),
    [sym_line_comment] = STATE(2214),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8334),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2215] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2215),
    [sym_line_comment] = STATE(2215),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8316),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2216] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2216),
    [sym_line_comment] = STATE(2216),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7018),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2217] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2217),
    [sym_line_comment] = STATE(2217),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8336),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2218] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2218),
    [sym_line_comment] = STATE(2218),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8338),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2219] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2219),
    [sym_line_comment] = STATE(2219),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8340),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2220] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2220),
    [sym_line_comment] = STATE(2220),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8342),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2221] = {
    [sym_open_tuple] = STATE(19472),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12950),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10610),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12777),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2221),
    [sym_line_comment] = STATE(2221),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2222] = {
    [sym_open_tuple] = STATE(18603),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12682),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10320),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12522),
    [sym_unary_expression] = STATE(12522),
    [sym_range_expression] = STATE(12522),
    [sym_splat_expression] = STATE(12522),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12010),
    [sym_unary_typed_expression] = STATE(12522),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12522),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12322),
    [sym_block_comment] = STATE(2222),
    [sym_line_comment] = STATE(2222),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2223] = {
    [sym_open_tuple] = STATE(8438),
    [sym_assignment] = STATE(8098),
    [sym__expression] = STATE(7646),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(2223),
    [sym_line_comment] = STATE(2223),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2224] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2224),
    [sym_line_comment] = STATE(2224),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8344),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2225] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2225),
    [sym_line_comment] = STATE(2225),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8346),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2226] = {
    [sym_open_tuple] = STATE(8439),
    [sym_assignment] = STATE(8105),
    [sym__expression] = STATE(7647),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(2226),
    [sym_line_comment] = STATE(2226),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2227] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2227),
    [sym_line_comment] = STATE(2227),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8348),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2228] = {
    [sym__expression] = STATE(13507),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17094),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2228),
    [sym_line_comment] = STATE(2228),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8350),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2229] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2229),
    [sym_line_comment] = STATE(2229),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2230] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2230),
    [sym_line_comment] = STATE(2230),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8354),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2231] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2231),
    [sym_line_comment] = STATE(2231),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8356),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2232] = {
    [sym_open_tuple] = STATE(8758),
    [sym_assignment] = STATE(8759),
    [sym__expression] = STATE(8894),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(2232),
    [sym_line_comment] = STATE(2232),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2233] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2233),
    [sym_line_comment] = STATE(2233),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8358),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2234] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2234),
    [sym_line_comment] = STATE(2234),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8360),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2235] = {
    [sym_open_tuple] = STATE(13509),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(13135),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10690),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13134),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2235),
    [sym_line_comment] = STATE(2235),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2236] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2236),
    [sym_line_comment] = STATE(2236),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8362),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2237] = {
    [sym_open_tuple] = STATE(13758),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(13658),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10787),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13581),
    [sym_unary_expression] = STATE(13581),
    [sym_range_expression] = STATE(13581),
    [sym_splat_expression] = STATE(13581),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13365),
    [sym_unary_typed_expression] = STATE(13581),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13581),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13282),
    [sym_block_comment] = STATE(2237),
    [sym_line_comment] = STATE(2237),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2238] = {
    [sym_open_tuple] = STATE(18316),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13959),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10787),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13581),
    [sym_unary_expression] = STATE(13581),
    [sym_range_expression] = STATE(13581),
    [sym_splat_expression] = STATE(13581),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13365),
    [sym_unary_typed_expression] = STATE(13581),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13581),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13282),
    [sym_block_comment] = STATE(2238),
    [sym_line_comment] = STATE(2238),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2239] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2239),
    [sym_line_comment] = STATE(2239),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8364),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2240] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2240),
    [sym_line_comment] = STATE(2240),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8366),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2241] = {
    [sym_open_tuple] = STATE(13759),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(13660),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10787),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13581),
    [sym_unary_expression] = STATE(13581),
    [sym_range_expression] = STATE(13581),
    [sym_splat_expression] = STATE(13581),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13365),
    [sym_unary_typed_expression] = STATE(13581),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13581),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13282),
    [sym_block_comment] = STATE(2241),
    [sym_line_comment] = STATE(2241),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2242] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2242),
    [sym_line_comment] = STATE(2242),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8368),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2243] = {
    [sym__expression] = STATE(13512),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17192),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2243),
    [sym_line_comment] = STATE(2243),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8370),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2244] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2244),
    [sym_line_comment] = STATE(2244),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2245] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2245),
    [sym_line_comment] = STATE(2245),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8372),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2246] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2246),
    [sym_line_comment] = STATE(2246),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8374),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2247] = {
    [sym_open_tuple] = STATE(13242),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12962),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10600),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12769),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2247),
    [sym_line_comment] = STATE(2247),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2248] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2248),
    [sym_line_comment] = STATE(2248),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8376),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2249] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2249),
    [sym_line_comment] = STATE(2249),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8378),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2250] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2250),
    [sym_line_comment] = STATE(2250),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8380),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2251] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2251),
    [sym_line_comment] = STATE(2251),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8382),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2252] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2252),
    [sym_line_comment] = STATE(2252),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7514),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2253] = {
    [sym_open_tuple] = STATE(13243),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12963),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10600),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12769),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2253),
    [sym_line_comment] = STATE(2253),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2254] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2254),
    [sym_line_comment] = STATE(2254),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8384),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2255] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2255),
    [sym_line_comment] = STATE(2255),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8386),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2256] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2256),
    [sym_line_comment] = STATE(2256),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8388),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2257] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2257),
    [sym_line_comment] = STATE(2257),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8390),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2258] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2258),
    [sym_line_comment] = STATE(2258),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8392),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2259] = {
    [sym__expression] = STATE(13518),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17568),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2259),
    [sym_line_comment] = STATE(2259),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8394),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2260] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2260),
    [sym_line_comment] = STATE(2260),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8396),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2261] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2261),
    [sym_line_comment] = STATE(2261),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8398),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2262] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2262),
    [sym_line_comment] = STATE(2262),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8400),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2263] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2263),
    [sym_line_comment] = STATE(2263),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8402),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2264] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2264),
    [sym_line_comment] = STATE(2264),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8404),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2265] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2265),
    [sym_line_comment] = STATE(2265),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8406),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2266] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2266),
    [sym_line_comment] = STATE(2266),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6910),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2267] = {
    [sym__expression] = STATE(13850),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17224),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2267),
    [sym_line_comment] = STATE(2267),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8408),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2268] = {
    [sym_open_tuple] = STATE(13142),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12947),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10600),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12769),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2268),
    [sym_line_comment] = STATE(2268),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2269] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2269),
    [sym_line_comment] = STATE(2269),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8410),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2270] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2270),
    [sym_line_comment] = STATE(2270),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8412),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2271] = {
    [sym_open_tuple] = STATE(13137),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(13141),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10616),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13400),
    [sym_unary_expression] = STATE(13400),
    [sym_range_expression] = STATE(13400),
    [sym_splat_expression] = STATE(13400),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12922),
    [sym_unary_typed_expression] = STATE(13400),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13400),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13114),
    [sym_block_comment] = STATE(2271),
    [sym_line_comment] = STATE(2271),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2272] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2272),
    [sym_line_comment] = STATE(2272),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8414),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2273] = {
    [sym__expression] = STATE(13524),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17307),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2273),
    [sym_line_comment] = STATE(2273),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8416),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2274] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2274),
    [sym_line_comment] = STATE(2274),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8396),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2275] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2275),
    [sym_line_comment] = STATE(2275),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8418),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2276] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2276),
    [sym_line_comment] = STATE(2276),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8420),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2277] = {
    [sym_open_tuple] = STATE(19224),
    [sym_assignment] = STATE(8250),
    [sym__expression] = STATE(7658),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4448),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8368),
    [sym_unary_expression] = STATE(8368),
    [sym_range_expression] = STATE(8368),
    [sym_splat_expression] = STATE(8368),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7911),
    [sym_unary_typed_expression] = STATE(8368),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8368),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7865),
    [sym_block_comment] = STATE(2277),
    [sym_line_comment] = STATE(2277),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2278] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2278),
    [sym_line_comment] = STATE(2278),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8422),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2279] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2279),
    [sym_line_comment] = STATE(2279),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8424),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2280] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2280),
    [sym_line_comment] = STATE(2280),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8426),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2281] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2281),
    [sym_line_comment] = STATE(2281),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8428),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2282] = {
    [sym_open_tuple] = STATE(9256),
    [sym_assignment] = STATE(9151),
    [sym__expression] = STATE(9060),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(2282),
    [sym_line_comment] = STATE(2282),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2283] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2283),
    [sym_line_comment] = STATE(2283),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8170),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2284] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2284),
    [sym_line_comment] = STATE(2284),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8430),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2285] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2285),
    [sym_line_comment] = STATE(2285),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2286] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2286),
    [sym_line_comment] = STATE(2286),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8434),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2287] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2287),
    [sym_line_comment] = STATE(2287),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8436),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2288] = {
    [sym__expression] = STATE(13528),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17374),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2288),
    [sym_line_comment] = STATE(2288),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8438),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2289] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2289),
    [sym_line_comment] = STATE(2289),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8440),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2290] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2290),
    [sym_line_comment] = STATE(2290),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8442),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2291] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2291),
    [sym_line_comment] = STATE(2291),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8444),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2292] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2292),
    [sym_line_comment] = STATE(2292),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8446),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2293] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2293),
    [sym_line_comment] = STATE(2293),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8448),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2294] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2294),
    [sym_line_comment] = STATE(2294),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8450),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2295] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2295),
    [sym_line_comment] = STATE(2295),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8452),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2296] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2296),
    [sym_line_comment] = STATE(2296),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8454),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2297] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2297),
    [sym_line_comment] = STATE(2297),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7012),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2298] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2298),
    [sym_line_comment] = STATE(2298),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8456),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2299] = {
    [sym_open_tuple] = STATE(9257),
    [sym_assignment] = STATE(9153),
    [sym__expression] = STATE(9061),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(2299),
    [sym_line_comment] = STATE(2299),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2300] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2300),
    [sym_line_comment] = STATE(2300),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8458),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2301] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2301),
    [sym_line_comment] = STATE(2301),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8460),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2302] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2302),
    [sym_line_comment] = STATE(2302),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8462),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2303] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2303),
    [sym_line_comment] = STATE(2303),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8464),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2304] = {
    [sym__expression] = STATE(13532),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17552),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2304),
    [sym_line_comment] = STATE(2304),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8466),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2305] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2305),
    [sym_line_comment] = STATE(2305),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8440),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2306] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2306),
    [sym_line_comment] = STATE(2306),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8468),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2307] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2307),
    [sym_line_comment] = STATE(2307),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8470),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2308] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2308),
    [sym_line_comment] = STATE(2308),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8472),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2309] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2309),
    [sym_line_comment] = STATE(2309),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8474),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2310] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2310),
    [sym_line_comment] = STATE(2310),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8476),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2311] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2311),
    [sym_line_comment] = STATE(2311),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6986),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2312] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2312),
    [sym_line_comment] = STATE(2312),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8478),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2313] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2313),
    [sym_line_comment] = STATE(2313),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8480),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2314] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2314),
    [sym_line_comment] = STATE(2314),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8482),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2315] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2315),
    [sym_line_comment] = STATE(2315),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8484),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2316] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2316),
    [sym_line_comment] = STATE(2316),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8486),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2317] = {
    [sym_open_tuple] = STATE(12635),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12086),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10342),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12292),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2317),
    [sym_line_comment] = STATE(2317),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2318] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2318),
    [sym_line_comment] = STATE(2318),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8488),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2319] = {
    [sym__expression] = STATE(13535),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17296),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2319),
    [sym_line_comment] = STATE(2319),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8490),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2320] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2320),
    [sym_line_comment] = STATE(2320),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8492),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2321] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2321),
    [sym_line_comment] = STATE(2321),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8494),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2322] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2322),
    [sym_line_comment] = STATE(2322),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8496),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2323] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2323),
    [sym_line_comment] = STATE(2323),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8498),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2324] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2324),
    [sym_line_comment] = STATE(2324),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8500),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2325] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2325),
    [sym_line_comment] = STATE(2325),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8502),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2326] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2326),
    [sym_line_comment] = STATE(2326),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8504),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2327] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2327),
    [sym_line_comment] = STATE(2327),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8506),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2328] = {
    [sym_open_tuple] = STATE(12736),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12114),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10314),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12019),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2328),
    [sym_line_comment] = STATE(2328),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2329] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2329),
    [sym_line_comment] = STATE(2329),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8508),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2330] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2330),
    [sym_line_comment] = STATE(2330),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8510),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2331] = {
    [sym_open_tuple] = STATE(12737),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12115),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10314),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12019),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2331),
    [sym_line_comment] = STATE(2331),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2332] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2332),
    [sym_line_comment] = STATE(2332),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8512),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2333] = {
    [sym__expression] = STATE(13538),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17613),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2333),
    [sym_line_comment] = STATE(2333),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8514),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2334] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2334),
    [sym_line_comment] = STATE(2334),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8492),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2335] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2335),
    [sym_line_comment] = STATE(2335),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8516),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2336] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2336),
    [sym_line_comment] = STATE(2336),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8518),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2337] = {
    [sym_open_tuple] = STATE(19361),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12954),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10600),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12769),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2337),
    [sym_line_comment] = STATE(2337),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2338] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2338),
    [sym_line_comment] = STATE(2338),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8520),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2339] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2339),
    [sym_line_comment] = STATE(2339),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8522),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2340] = {
    [sym_open_tuple] = STATE(12636),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12088),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10314),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12019),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2340),
    [sym_line_comment] = STATE(2340),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2341] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2341),
    [sym_line_comment] = STATE(2341),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8524),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2342] = {
    [sym_open_tuple] = STATE(18835),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12446),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10254),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12738),
    [sym_unary_expression] = STATE(12738),
    [sym_range_expression] = STATE(12738),
    [sym_splat_expression] = STATE(12738),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12175),
    [sym_unary_typed_expression] = STATE(12738),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12738),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12016),
    [sym_block_comment] = STATE(2342),
    [sym_line_comment] = STATE(2342),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2343] = {
    [sym_open_tuple] = STATE(18469),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13285),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10616),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13400),
    [sym_unary_expression] = STATE(13400),
    [sym_range_expression] = STATE(13400),
    [sym_splat_expression] = STATE(13400),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12922),
    [sym_unary_typed_expression] = STATE(13400),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13400),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13114),
    [sym_block_comment] = STATE(2343),
    [sym_line_comment] = STATE(2343),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2344] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2344),
    [sym_line_comment] = STATE(2344),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8526),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2345] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2345),
    [sym_line_comment] = STATE(2345),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8528),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2346] = {
    [sym_open_tuple] = STATE(18866),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12417),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10370),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12749),
    [sym_unary_expression] = STATE(12749),
    [sym_range_expression] = STATE(12749),
    [sym_splat_expression] = STATE(12749),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12236),
    [sym_unary_typed_expression] = STATE(12749),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12749),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12218),
    [sym_block_comment] = STATE(2346),
    [sym_line_comment] = STATE(2346),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2347] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2347),
    [sym_line_comment] = STATE(2347),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8530),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2348] = {
    [sym__expression] = STATE(13543),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17424),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2348),
    [sym_line_comment] = STATE(2348),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8532),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2349] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2349),
    [sym_line_comment] = STATE(2349),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8534),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2350] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2350),
    [sym_line_comment] = STATE(2350),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8536),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2351] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2351),
    [sym_line_comment] = STATE(2351),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8538),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2352] = {
    [sym_open_tuple] = STATE(18500),
    [sym_assignment] = STATE(8057),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10947),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14013),
    [sym_unary_expression] = STATE(14013),
    [sym_range_expression] = STATE(14013),
    [sym_splat_expression] = STATE(14013),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13919),
    [sym_unary_typed_expression] = STATE(14013),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14013),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13868),
    [sym_block_comment] = STATE(2352),
    [sym_line_comment] = STATE(2352),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2353] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2353),
    [sym_line_comment] = STATE(2353),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8540),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2354] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2354),
    [sym_line_comment] = STATE(2354),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8542),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2355] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2355),
    [sym_line_comment] = STATE(2355),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8544),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2356] = {
    [sym_open_tuple] = STATE(19164),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10944),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14047),
    [sym_unary_expression] = STATE(14047),
    [sym_range_expression] = STATE(14047),
    [sym_splat_expression] = STATE(14047),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13917),
    [sym_unary_typed_expression] = STATE(14047),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14047),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13920),
    [sym_block_comment] = STATE(2356),
    [sym_line_comment] = STATE(2356),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2357] = {
    [sym_open_tuple] = STATE(18958),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12745),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10293),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12413),
    [sym_unary_expression] = STATE(12413),
    [sym_range_expression] = STATE(12413),
    [sym_splat_expression] = STATE(12413),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12037),
    [sym_unary_typed_expression] = STATE(12413),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12413),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12234),
    [sym_block_comment] = STATE(2357),
    [sym_line_comment] = STATE(2357),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2358] = {
    [sym_open_tuple] = STATE(8304),
    [sym_assignment] = STATE(8098),
    [sym__expression] = STATE(8099),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(2358),
    [sym_line_comment] = STATE(2358),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2359] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2359),
    [sym_line_comment] = STATE(2359),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8546),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2360] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2360),
    [sym_line_comment] = STATE(2360),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8548),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2361] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2361),
    [sym_line_comment] = STATE(2361),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8550),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2362] = {
    [sym__expression] = STATE(13549),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17651),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2362),
    [sym_line_comment] = STATE(2362),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8552),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2363] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2363),
    [sym_line_comment] = STATE(2363),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8534),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2364] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2364),
    [sym_line_comment] = STATE(2364),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8554),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2365] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2365),
    [sym_line_comment] = STATE(2365),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8556),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2366] = {
    [sym_open_tuple] = STATE(8305),
    [sym_assignment] = STATE(8105),
    [sym__expression] = STATE(8106),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(2366),
    [sym_line_comment] = STATE(2366),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2367] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2367),
    [sym_line_comment] = STATE(2367),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8558),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2368] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2368),
    [sym_line_comment] = STATE(2368),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8560),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2369] = {
    [sym_open_tuple] = STATE(19460),
    [sym_assignment] = STATE(9242),
    [sym__expression] = STATE(9107),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5157),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9212),
    [sym_unary_expression] = STATE(9212),
    [sym_range_expression] = STATE(9212),
    [sym_splat_expression] = STATE(9212),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8958),
    [sym_unary_typed_expression] = STATE(9212),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9212),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9124),
    [sym_block_comment] = STATE(2369),
    [sym_line_comment] = STATE(2369),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2370] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2370),
    [sym_line_comment] = STATE(2370),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8562),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2371] = {
    [sym_open_tuple] = STATE(13617),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(13940),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10787),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13581),
    [sym_unary_expression] = STATE(13581),
    [sym_range_expression] = STATE(13581),
    [sym_splat_expression] = STATE(13581),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13365),
    [sym_unary_typed_expression] = STATE(13581),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13581),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13282),
    [sym_block_comment] = STATE(2371),
    [sym_line_comment] = STATE(2371),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2372] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2372),
    [sym_line_comment] = STATE(2372),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8564),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2373] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2373),
    [sym_line_comment] = STATE(2373),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8566),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2374] = {
    [sym_open_tuple] = STATE(18778),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10387),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12865),
    [sym_unary_expression] = STATE(12865),
    [sym_range_expression] = STATE(12865),
    [sym_splat_expression] = STATE(12865),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12478),
    [sym_unary_typed_expression] = STATE(12865),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12865),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12490),
    [sym_block_comment] = STATE(2374),
    [sym_line_comment] = STATE(2374),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2375] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2375),
    [sym_line_comment] = STATE(2375),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8568),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2376] = {
    [sym__expression] = STATE(13553),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17255),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2376),
    [sym_line_comment] = STATE(2376),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8570),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2377] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2377),
    [sym_line_comment] = STATE(2377),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8572),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2378] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2378),
    [sym_line_comment] = STATE(2378),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8574),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2379] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2379),
    [sym_line_comment] = STATE(2379),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8576),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2380] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(9427),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2380),
    [sym_line_comment] = STATE(2380),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2381] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2381),
    [sym_line_comment] = STATE(2381),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8580),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2382] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2382),
    [sym_line_comment] = STATE(2382),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8582),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2383] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2383),
    [sym_line_comment] = STATE(2383),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8584),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2384] = {
    [sym_open_tuple] = STATE(18316),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13750),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10787),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13581),
    [sym_unary_expression] = STATE(13581),
    [sym_range_expression] = STATE(13581),
    [sym_splat_expression] = STATE(13581),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13365),
    [sym_unary_typed_expression] = STATE(13581),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13581),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13282),
    [sym_block_comment] = STATE(2384),
    [sym_line_comment] = STATE(2384),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2385] = {
    [sym_open_tuple] = STATE(12773),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12778),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10445),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12911),
    [sym_unary_expression] = STATE(12911),
    [sym_range_expression] = STATE(12911),
    [sym_splat_expression] = STATE(12911),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12535),
    [sym_unary_typed_expression] = STATE(12911),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12911),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12536),
    [sym_block_comment] = STATE(2385),
    [sym_line_comment] = STATE(2385),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2386] = {
    [sym_open_tuple] = STATE(13235),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(13434),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10665),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13278),
    [sym_unary_expression] = STATE(13278),
    [sym_range_expression] = STATE(13278),
    [sym_splat_expression] = STATE(13278),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12832),
    [sym_unary_typed_expression] = STATE(13278),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13278),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12805),
    [sym_block_comment] = STATE(2386),
    [sym_line_comment] = STATE(2386),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2387] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2387),
    [sym_line_comment] = STATE(2387),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8586),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2388] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2388),
    [sym_line_comment] = STATE(2388),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8588),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2389] = {
    [sym_open_tuple] = STATE(13236),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(13298),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10665),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13278),
    [sym_unary_expression] = STATE(13278),
    [sym_range_expression] = STATE(13278),
    [sym_splat_expression] = STATE(13278),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12832),
    [sym_unary_typed_expression] = STATE(13278),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13278),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12805),
    [sym_block_comment] = STATE(2389),
    [sym_line_comment] = STATE(2389),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2390] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2390),
    [sym_line_comment] = STATE(2390),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8590),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2391] = {
    [sym__expression] = STATE(13558),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17333),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2391),
    [sym_line_comment] = STATE(2391),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8592),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2392] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2392),
    [sym_line_comment] = STATE(2392),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8572),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2393] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2393),
    [sym_line_comment] = STATE(2393),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8594),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2394] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2394),
    [sym_line_comment] = STATE(2394),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8596),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2395] = {
    [sym_open_tuple] = STATE(12804),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12806),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10445),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12911),
    [sym_unary_expression] = STATE(12911),
    [sym_range_expression] = STATE(12911),
    [sym_splat_expression] = STATE(12911),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12535),
    [sym_unary_typed_expression] = STATE(12911),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12911),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12536),
    [sym_block_comment] = STATE(2395),
    [sym_line_comment] = STATE(2395),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2396] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2396),
    [sym_line_comment] = STATE(2396),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8598),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2397] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2397),
    [sym_line_comment] = STATE(2397),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8600),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2398] = {
    [sym_open_tuple] = STATE(13146),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(13199),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10665),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13278),
    [sym_unary_expression] = STATE(13278),
    [sym_range_expression] = STATE(13278),
    [sym_splat_expression] = STATE(13278),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12832),
    [sym_unary_typed_expression] = STATE(13278),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13278),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12805),
    [sym_block_comment] = STATE(2398),
    [sym_line_comment] = STATE(2398),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2399] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2399),
    [sym_line_comment] = STATE(2399),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8602),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2400] = {
    [sym_open_tuple] = STATE(14531),
    [sym_assignment] = STATE(15171),
    [sym__expression] = STATE(12272),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10157),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12262),
    [sym_unary_expression] = STATE(12262),
    [sym_range_expression] = STATE(12262),
    [sym_splat_expression] = STATE(12262),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11794),
    [sym_unary_typed_expression] = STATE(12262),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12262),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11989),
    [sym_block_comment] = STATE(2400),
    [sym_line_comment] = STATE(2400),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2401] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2401),
    [sym_line_comment] = STATE(2401),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8604),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2402] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2402),
    [sym_line_comment] = STATE(2402),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8606),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2403] = {
    [sym_open_tuple] = STATE(18512),
    [sym_assignment] = STATE(8250),
    [sym__expression] = STATE(8306),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4433),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8313),
    [sym_unary_expression] = STATE(8313),
    [sym_range_expression] = STATE(8313),
    [sym_splat_expression] = STATE(8313),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7571),
    [sym_unary_typed_expression] = STATE(8313),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8313),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7682),
    [sym_block_comment] = STATE(2403),
    [sym_line_comment] = STATE(2403),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2404] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2404),
    [sym_line_comment] = STATE(2404),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8608),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2405] = {
    [sym__expression] = STATE(13562),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17451),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2405),
    [sym_line_comment] = STATE(2405),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8610),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2406] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2406),
    [sym_line_comment] = STATE(2406),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8612),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2407] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2407),
    [sym_line_comment] = STATE(2407),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8614),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2408] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2408),
    [sym_line_comment] = STATE(2408),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8616),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2409] = {
    [sym_open_tuple] = STATE(19315),
    [sym_assignment] = STATE(11576),
    [sym__expression] = STATE(12500),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10352),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12481),
    [sym_unary_expression] = STATE(12481),
    [sym_range_expression] = STATE(12481),
    [sym_splat_expression] = STATE(12481),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12268),
    [sym_unary_typed_expression] = STATE(12481),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12481),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12269),
    [sym_block_comment] = STATE(2409),
    [sym_line_comment] = STATE(2409),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2410] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2410),
    [sym_line_comment] = STATE(2410),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8618),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2411] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2411),
    [sym_line_comment] = STATE(2411),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8620),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2412] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2412),
    [sym_line_comment] = STATE(2412),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8622),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2413] = {
    [sym_open_tuple] = STATE(9260),
    [sym_assignment] = STATE(9151),
    [sym__expression] = STATE(9152),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(2413),
    [sym_line_comment] = STATE(2413),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2414] = {
    [sym_open_tuple] = STATE(9261),
    [sym_assignment] = STATE(9153),
    [sym__expression] = STATE(9154),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(2414),
    [sym_line_comment] = STATE(2414),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2415] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2415),
    [sym_line_comment] = STATE(2415),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8624),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2416] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2416),
    [sym_line_comment] = STATE(2416),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8626),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2417] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2417),
    [sym_line_comment] = STATE(2417),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8628),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2418] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2418),
    [sym_line_comment] = STATE(2418),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8056),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2419] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2419),
    [sym_line_comment] = STATE(2419),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8630),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2420] = {
    [sym__expression] = STATE(13567),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17584),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2420),
    [sym_line_comment] = STATE(2420),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8632),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2421] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2421),
    [sym_line_comment] = STATE(2421),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8612),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2422] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2422),
    [sym_line_comment] = STATE(2422),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8634),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2423] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2423),
    [sym_line_comment] = STATE(2423),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8636),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2424] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(468),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2424),
    [sym_line_comment] = STATE(2424),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2425] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2425),
    [sym_line_comment] = STATE(2425),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8638),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2426] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2426),
    [sym_line_comment] = STATE(2426),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8640),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2427] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2427),
    [sym_line_comment] = STATE(2427),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8642),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2428] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2428),
    [sym_line_comment] = STATE(2428),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8644),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2429] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2429),
    [sym_line_comment] = STATE(2429),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8646),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2430] = {
    [sym_open_tuple] = STATE(12923),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12575),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10435),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12583),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2430),
    [sym_line_comment] = STATE(2430),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2431] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2431),
    [sym_line_comment] = STATE(2431),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8648),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2432] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2432),
    [sym_line_comment] = STATE(2432),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8650),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2433] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2433),
    [sym_line_comment] = STATE(2433),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8652),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2434] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2434),
    [sym_line_comment] = STATE(2434),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8654),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2435] = {
    [sym__expression] = STATE(13572),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17132),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2435),
    [sym_line_comment] = STATE(2435),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8656),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2436] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2436),
    [sym_line_comment] = STATE(2436),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8658),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2437] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2437),
    [sym_line_comment] = STATE(2437),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8660),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2438] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2438),
    [sym_line_comment] = STATE(2438),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8662),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2439] = {
    [sym__expression] = STATE(13933),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17172),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2439),
    [sym_line_comment] = STATE(2439),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8664),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2440] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2440),
    [sym_line_comment] = STATE(2440),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8666),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2441] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2441),
    [sym_line_comment] = STATE(2441),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8668),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2442] = {
    [sym_open_tuple] = STATE(12403),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12425),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10370),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12749),
    [sym_unary_expression] = STATE(12749),
    [sym_range_expression] = STATE(12749),
    [sym_splat_expression] = STATE(12749),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12236),
    [sym_unary_typed_expression] = STATE(12749),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12749),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12218),
    [sym_block_comment] = STATE(2442),
    [sym_line_comment] = STATE(2442),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2443] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2443),
    [sym_line_comment] = STATE(2443),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8670),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2444] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2444),
    [sym_line_comment] = STATE(2444),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8672),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2445] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2445),
    [sym_line_comment] = STATE(2445),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8674),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2446] = {
    [sym_open_tuple] = STATE(18720),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13264),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10665),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13278),
    [sym_unary_expression] = STATE(13278),
    [sym_range_expression] = STATE(13278),
    [sym_splat_expression] = STATE(13278),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12832),
    [sym_unary_typed_expression] = STATE(13278),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13278),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12805),
    [sym_block_comment] = STATE(2446),
    [sym_line_comment] = STATE(2446),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2447] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2447),
    [sym_line_comment] = STATE(2447),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8676),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2448] = {
    [sym__expression] = STATE(13576),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17206),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2448),
    [sym_line_comment] = STATE(2448),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8678),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2449] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2449),
    [sym_line_comment] = STATE(2449),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8658),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2450] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2450),
    [sym_line_comment] = STATE(2450),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8680),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2451] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2451),
    [sym_line_comment] = STATE(2451),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8682),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2452] = {
    [sym_open_tuple] = STATE(8790),
    [sym_assignment] = STATE(8807),
    [sym__expression] = STATE(8808),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(2452),
    [sym_line_comment] = STATE(2452),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2453] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2453),
    [sym_line_comment] = STATE(2453),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8684),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2454] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2454),
    [sym_line_comment] = STATE(2454),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8686),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2455] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2455),
    [sym_line_comment] = STATE(2455),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8688),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2456] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2456),
    [sym_line_comment] = STATE(2456),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8688),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2457] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2457),
    [sym_line_comment] = STATE(2457),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8690),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2458] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2458),
    [sym_line_comment] = STATE(2458),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8690),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2459] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2459),
    [sym_line_comment] = STATE(2459),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8692),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2460] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2460),
    [sym_line_comment] = STATE(2460),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8692),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2461] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2461),
    [sym_line_comment] = STATE(2461),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8694),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2462] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2462),
    [sym_line_comment] = STATE(2462),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8694),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2463] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2463),
    [sym_line_comment] = STATE(2463),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2464] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2464),
    [sym_line_comment] = STATE(2464),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2465] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2465),
    [sym_line_comment] = STATE(2465),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8698),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2466] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2466),
    [sym_line_comment] = STATE(2466),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8698),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2467] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2467),
    [sym_line_comment] = STATE(2467),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8700),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2468] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2468),
    [sym_line_comment] = STATE(2468),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8700),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2469] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2469),
    [sym_line_comment] = STATE(2469),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8702),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2470] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2470),
    [sym_line_comment] = STATE(2470),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8702),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2471] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2471),
    [sym_line_comment] = STATE(2471),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8704),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2472] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2472),
    [sym_line_comment] = STATE(2472),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8704),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2473] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2473),
    [sym_line_comment] = STATE(2473),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8706),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2474] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2474),
    [sym_line_comment] = STATE(2474),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8706),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2475] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2475),
    [sym_line_comment] = STATE(2475),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8708),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2476] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2476),
    [sym_line_comment] = STATE(2476),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8708),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2477] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2477),
    [sym_line_comment] = STATE(2477),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8710),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2478] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2478),
    [sym_line_comment] = STATE(2478),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8710),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2479] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2479),
    [sym_line_comment] = STATE(2479),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8712),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2480] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2480),
    [sym_line_comment] = STATE(2480),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8712),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2481] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2481),
    [sym_line_comment] = STATE(2481),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8714),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2482] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2482),
    [sym_line_comment] = STATE(2482),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8714),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2483] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2483),
    [sym_line_comment] = STATE(2483),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8716),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2484] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2484),
    [sym_line_comment] = STATE(2484),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8716),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2485] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2485),
    [sym_line_comment] = STATE(2485),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2486] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2486),
    [sym_line_comment] = STATE(2486),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8718),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2487] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2487),
    [sym_line_comment] = STATE(2487),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8720),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2488] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2488),
    [sym_line_comment] = STATE(2488),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8720),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2489] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2489),
    [sym_line_comment] = STATE(2489),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8722),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2490] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2490),
    [sym_line_comment] = STATE(2490),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8722),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2491] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2491),
    [sym_line_comment] = STATE(2491),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8724),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2492] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2492),
    [sym_line_comment] = STATE(2492),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8724),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2493] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2493),
    [sym_line_comment] = STATE(2493),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8726),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2494] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2494),
    [sym_line_comment] = STATE(2494),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8726),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2495] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2495),
    [sym_line_comment] = STATE(2495),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8728),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2496] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2496),
    [sym_line_comment] = STATE(2496),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8728),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2497] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2497),
    [sym_line_comment] = STATE(2497),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8730),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2498] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2498),
    [sym_line_comment] = STATE(2498),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8730),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2499] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2499),
    [sym_line_comment] = STATE(2499),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8732),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2500] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2500),
    [sym_line_comment] = STATE(2500),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8732),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2501] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2501),
    [sym_line_comment] = STATE(2501),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8734),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2502] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2502),
    [sym_line_comment] = STATE(2502),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8734),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2503] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2503),
    [sym_line_comment] = STATE(2503),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8736),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2504] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2504),
    [sym_line_comment] = STATE(2504),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8736),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2505] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2505),
    [sym_line_comment] = STATE(2505),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8738),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2506] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2506),
    [sym_line_comment] = STATE(2506),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8738),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2507] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2507),
    [sym_line_comment] = STATE(2507),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2508] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2508),
    [sym_line_comment] = STATE(2508),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8740),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2509] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2509),
    [sym_line_comment] = STATE(2509),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8742),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2510] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2510),
    [sym_line_comment] = STATE(2510),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8742),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2511] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2511),
    [sym_line_comment] = STATE(2511),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8744),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2512] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2512),
    [sym_line_comment] = STATE(2512),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8744),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2513] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2513),
    [sym_line_comment] = STATE(2513),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8746),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2514] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2514),
    [sym_line_comment] = STATE(2514),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8746),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2515] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2515),
    [sym_line_comment] = STATE(2515),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8748),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2516] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2516),
    [sym_line_comment] = STATE(2516),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8748),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2517] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2517),
    [sym_line_comment] = STATE(2517),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8750),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2518] = {
    [sym_open_tuple] = STATE(12574),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12692),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10293),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12413),
    [sym_unary_expression] = STATE(12413),
    [sym_range_expression] = STATE(12413),
    [sym_splat_expression] = STATE(12413),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12037),
    [sym_unary_typed_expression] = STATE(12413),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12413),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12234),
    [sym_block_comment] = STATE(2518),
    [sym_line_comment] = STATE(2518),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2519] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(457),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2519),
    [sym_line_comment] = STATE(2519),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2520] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2520),
    [sym_line_comment] = STATE(2520),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8752),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2521] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19101),
    [sym__expression] = STATE(13751),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2521),
    [sym_line_comment] = STATE(2521),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2522] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2522),
    [sym_line_comment] = STATE(2522),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7842),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2523] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2523),
    [sym_line_comment] = STATE(2523),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8754),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2524] = {
    [sym_open_tuple] = STATE(12511),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12410),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10254),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12738),
    [sym_unary_expression] = STATE(12738),
    [sym_range_expression] = STATE(12738),
    [sym_splat_expression] = STATE(12738),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12175),
    [sym_unary_typed_expression] = STATE(12738),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12738),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12016),
    [sym_block_comment] = STATE(2524),
    [sym_line_comment] = STATE(2524),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2525] = {
    [sym_open_tuple] = STATE(12517),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12412),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10254),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12738),
    [sym_unary_expression] = STATE(12738),
    [sym_range_expression] = STATE(12738),
    [sym_splat_expression] = STATE(12738),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12175),
    [sym_unary_typed_expression] = STATE(12738),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12738),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12016),
    [sym_block_comment] = STATE(2525),
    [sym_line_comment] = STATE(2525),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2526] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2526),
    [sym_line_comment] = STATE(2526),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8756),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2527] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2527),
    [sym_line_comment] = STATE(2527),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7610),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2528] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2528),
    [sym_line_comment] = STATE(2528),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8758),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2529] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2529),
    [sym_line_comment] = STATE(2529),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8760),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2530] = {
    [sym_open_tuple] = STATE(8871),
    [sym_assignment] = STATE(8877),
    [sym__expression] = STATE(8918),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(2530),
    [sym_line_comment] = STATE(2530),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2531] = {
    [sym_open_tuple] = STATE(18470),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11027),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14097),
    [sym_unary_expression] = STATE(14097),
    [sym_range_expression] = STATE(14097),
    [sym_splat_expression] = STATE(14097),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13620),
    [sym_unary_typed_expression] = STATE(14097),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14097),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13621),
    [sym_block_comment] = STATE(2531),
    [sym_line_comment] = STATE(2531),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2532] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2532),
    [sym_line_comment] = STATE(2532),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8762),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2533] = {
    [sym_open_tuple] = STATE(12703),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(12162),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10247),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12080),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2533),
    [sym_line_comment] = STATE(2533),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2534] = {
    [sym_open_tuple] = STATE(12725),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(12163),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10247),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12080),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2534),
    [sym_line_comment] = STATE(2534),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2535] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2535),
    [sym_line_comment] = STATE(2535),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8764),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2536] = {
    [sym_open_tuple] = STATE(18390),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11028),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14089),
    [sym_unary_expression] = STATE(14089),
    [sym_range_expression] = STATE(14089),
    [sym_splat_expression] = STATE(14089),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13627),
    [sym_unary_typed_expression] = STATE(14089),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14089),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13682),
    [sym_block_comment] = STATE(2536),
    [sym_line_comment] = STATE(2536),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2537] = {
    [sym_open_tuple] = STATE(19404),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11029),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13988),
    [sym_unary_expression] = STATE(13988),
    [sym_range_expression] = STATE(13988),
    [sym_splat_expression] = STATE(13988),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13632),
    [sym_unary_typed_expression] = STATE(13988),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13988),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13634),
    [sym_block_comment] = STATE(2537),
    [sym_line_comment] = STATE(2537),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2538] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2538),
    [sym_line_comment] = STATE(2538),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8766),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2539] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2539),
    [sym_line_comment] = STATE(2539),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8768),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2540] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(464),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2540),
    [sym_line_comment] = STATE(2540),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2541] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(15039),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11319),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11319),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13606),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10624),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2541),
    [sym_line_comment] = STATE(2541),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(6964),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2542] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19613),
    [sym__expression] = STATE(13548),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2542),
    [sym_line_comment] = STATE(2542),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2543] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2543),
    [sym_line_comment] = STATE(2543),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8770),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2544] = {
    [sym_open_tuple] = STATE(19531),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11033),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13698),
    [sym_unary_expression] = STATE(13698),
    [sym_range_expression] = STATE(13698),
    [sym_splat_expression] = STATE(13698),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13681),
    [sym_unary_typed_expression] = STATE(13698),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13698),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13361),
    [sym_block_comment] = STATE(2544),
    [sym_line_comment] = STATE(2544),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2545] = {
    [sym_open_tuple] = STATE(18866),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12724),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10370),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12749),
    [sym_unary_expression] = STATE(12749),
    [sym_range_expression] = STATE(12749),
    [sym_splat_expression] = STATE(12749),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12236),
    [sym_unary_typed_expression] = STATE(12749),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12749),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12218),
    [sym_block_comment] = STATE(2545),
    [sym_line_comment] = STATE(2545),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2546] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2546),
    [sym_line_comment] = STATE(2546),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8772),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2547] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(480),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2547),
    [sym_line_comment] = STATE(2547),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2548] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2548),
    [sym_line_comment] = STATE(2548),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8774),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2549] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19011),
    [sym__expression] = STATE(13647),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2549),
    [sym_line_comment] = STATE(2549),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2550] = {
    [sym_open_tuple] = STATE(18599),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11034),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13992),
    [sym_unary_expression] = STATE(13992),
    [sym_range_expression] = STATE(13992),
    [sym_splat_expression] = STATE(13992),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13699),
    [sym_unary_typed_expression] = STATE(13992),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13992),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13709),
    [sym_block_comment] = STATE(2550),
    [sym_line_comment] = STATE(2550),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2551] = {
    [sym_open_tuple] = STATE(18578),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12169),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10247),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12080),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2551),
    [sym_line_comment] = STATE(2551),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2552] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2552),
    [sym_line_comment] = STATE(2552),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8776),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2553] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(476),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2553),
    [sym_line_comment] = STATE(2553),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2554] = {
    [sym_open_tuple] = STATE(19461),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11057),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13986),
    [sym_unary_expression] = STATE(13986),
    [sym_range_expression] = STATE(13986),
    [sym_splat_expression] = STATE(13986),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13775),
    [sym_unary_typed_expression] = STATE(13986),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13986),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13704),
    [sym_block_comment] = STATE(2554),
    [sym_line_comment] = STATE(2554),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2555] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18384),
    [sym__expression] = STATE(13746),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2555),
    [sym_line_comment] = STATE(2555),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2556] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2556),
    [sym_line_comment] = STATE(2556),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7118),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2557] = {
    [sym_open_tuple] = STATE(18835),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11035),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12738),
    [sym_unary_expression] = STATE(12738),
    [sym_range_expression] = STATE(12738),
    [sym_splat_expression] = STATE(12738),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13708),
    [sym_unary_typed_expression] = STATE(12738),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12738),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12016),
    [sym_block_comment] = STATE(2557),
    [sym_line_comment] = STATE(2557),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2558] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2558),
    [sym_line_comment] = STATE(2558),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8778),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2559] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(469),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2559),
    [sym_line_comment] = STATE(2559),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2560] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2560),
    [sym_line_comment] = STATE(2560),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8780),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2561] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18652),
    [sym__expression] = STATE(13817),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2561),
    [sym_line_comment] = STATE(2561),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2562] = {
    [sym_open_tuple] = STATE(18958),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12560),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10293),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12413),
    [sym_unary_expression] = STATE(12413),
    [sym_range_expression] = STATE(12413),
    [sym_splat_expression] = STATE(12413),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12037),
    [sym_unary_typed_expression] = STATE(12413),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12413),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12234),
    [sym_block_comment] = STATE(2562),
    [sym_line_comment] = STATE(2562),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2563] = {
    [sym_open_tuple] = STATE(18578),
    [sym_assignment] = STATE(10836),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11037),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14002),
    [sym_unary_expression] = STATE(14002),
    [sym_range_expression] = STATE(14002),
    [sym_splat_expression] = STATE(14002),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13715),
    [sym_unary_typed_expression] = STATE(14002),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14002),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13720),
    [sym_block_comment] = STATE(2563),
    [sym_line_comment] = STATE(2563),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2564] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2564),
    [sym_line_comment] = STATE(2564),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8782),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2565] = {
    [sym__expression] = STATE(13942),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17108),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2565),
    [sym_line_comment] = STATE(2565),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8784),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2566] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(478),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2566),
    [sym_line_comment] = STATE(2566),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2567] = {
    [sym_open_tuple] = STATE(12884),
    [sym_assignment] = STATE(10720),
    [sym__expression] = STATE(12920),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10387),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12865),
    [sym_unary_expression] = STATE(12865),
    [sym_range_expression] = STATE(12865),
    [sym_splat_expression] = STATE(12865),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12478),
    [sym_unary_typed_expression] = STATE(12865),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12865),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12490),
    [sym_block_comment] = STATE(2567),
    [sym_line_comment] = STATE(2567),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2568] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19209),
    [sym__expression] = STATE(13924),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2568),
    [sym_line_comment] = STATE(2568),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2569] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(14482),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11376),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11376),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13460),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10544),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2569),
    [sym_line_comment] = STATE(2569),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(6954),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2570] = {
    [sym_open_tuple] = STATE(19083),
    [sym_assignment] = STATE(9242),
    [sym__expression] = STATE(9268),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5056),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9175),
    [sym_unary_expression] = STATE(9175),
    [sym_range_expression] = STATE(9175),
    [sym_splat_expression] = STATE(9175),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9024),
    [sym_unary_typed_expression] = STATE(9175),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9175),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8954),
    [sym_block_comment] = STATE(2570),
    [sym_line_comment] = STATE(2570),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2571] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(462),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2571),
    [sym_line_comment] = STATE(2571),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2572] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19112),
    [sym__expression] = STATE(13914),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2572),
    [sym_line_comment] = STATE(2572),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2573] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2573),
    [sym_line_comment] = STATE(2573),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7002),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2574] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2574),
    [sym_line_comment] = STATE(2574),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8786),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2575] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(460),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2575),
    [sym_line_comment] = STATE(2575),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2576] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2576),
    [sym_line_comment] = STATE(2576),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7044),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2577] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19383),
    [sym__expression] = STATE(13609),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2577),
    [sym_line_comment] = STATE(2577),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2578] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2578),
    [sym_line_comment] = STATE(2578),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8788),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2579] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2579),
    [sym_line_comment] = STATE(2579),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8790),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2580] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2580),
    [sym_line_comment] = STATE(2580),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8792),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2581] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(472),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2581),
    [sym_line_comment] = STATE(2581),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2582] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2582),
    [sym_line_comment] = STATE(2582),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8788),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2583] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18304),
    [sym__expression] = STATE(13557),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2583),
    [sym_line_comment] = STATE(2583),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2584] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2584),
    [sym_line_comment] = STATE(2584),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8794),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2585] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2585),
    [sym_line_comment] = STATE(2585),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8796),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2586] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2586),
    [sym_line_comment] = STATE(2586),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8798),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2587] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(471),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2587),
    [sym_line_comment] = STATE(2587),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2588] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2588),
    [sym_line_comment] = STATE(2588),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8800),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2589] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19204),
    [sym__expression] = STATE(13955),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2589),
    [sym_line_comment] = STATE(2589),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2590] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2590),
    [sym_line_comment] = STATE(2590),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8802),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2591] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2591),
    [sym_line_comment] = STATE(2591),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8804),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2592] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2592),
    [sym_line_comment] = STATE(2592),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8806),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2593] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_for_binding] = STATE(461),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11298),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11298),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13941),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10572),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2593),
    [sym_line_comment] = STATE(2593),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_outer] = ACTIONS(8578),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2594] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2594),
    [sym_line_comment] = STATE(2594),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8134),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2595] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19400),
    [sym__expression] = STATE(13564),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2595),
    [sym_line_comment] = STATE(2595),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2596] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2596),
    [sym_line_comment] = STATE(2596),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8808),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2597] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18565),
    [sym__expression] = STATE(13662),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2597),
    [sym_line_comment] = STATE(2597),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2598] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2598),
    [sym_line_comment] = STATE(2598),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8810),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2599] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18966),
    [sym__expression] = STATE(13748),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2599),
    [sym_line_comment] = STATE(2599),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2600] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2600),
    [sym_line_comment] = STATE(2600),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8812),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2601] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18252),
    [sym__expression] = STATE(13776),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2601),
    [sym_line_comment] = STATE(2601),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2602] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2602),
    [sym_line_comment] = STATE(2602),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8814),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2603] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18455),
    [sym__expression] = STATE(13801),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2603),
    [sym_line_comment] = STATE(2603),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2604] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2604),
    [sym_line_comment] = STATE(2604),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8816),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2605] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18739),
    [sym__expression] = STATE(13837),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2605),
    [sym_line_comment] = STATE(2605),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2606] = {
    [sym__expression] = STATE(13905),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17587),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2606),
    [sym_line_comment] = STATE(2606),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8818),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2607] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19050),
    [sym__expression] = STATE(13895),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2607),
    [sym_line_comment] = STATE(2607),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2608] = {
    [sym_open_tuple] = STATE(18928),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10968),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14007),
    [sym_unary_expression] = STATE(14007),
    [sym_range_expression] = STATE(14007),
    [sym_splat_expression] = STATE(14007),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13466),
    [sym_unary_typed_expression] = STATE(14007),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14007),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13471),
    [sym_block_comment] = STATE(2608),
    [sym_line_comment] = STATE(2608),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2609] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19319),
    [sym__expression] = STATE(13932),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2609),
    [sym_line_comment] = STATE(2609),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2610] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2610),
    [sym_line_comment] = STATE(2610),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8820),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2611] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19604),
    [sym__expression] = STATE(13974),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2611),
    [sym_line_comment] = STATE(2611),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2612] = {
    [sym_open_tuple] = STATE(12913),
    [sym_assignment] = STATE(11433),
    [sym__expression] = STATE(12741),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10435),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12583),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2612),
    [sym_line_comment] = STATE(2612),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2613] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18610),
    [sym__expression] = STATE(13502),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2613),
    [sym_line_comment] = STATE(2613),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2614] = {
    [sym_open_tuple] = STATE(12924),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12593),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10389),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12503),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2614),
    [sym_line_comment] = STATE(2614),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2615] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18873),
    [sym__expression] = STATE(13766),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2615),
    [sym_line_comment] = STATE(2615),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2616] = {
    [sym_open_tuple] = STATE(12914),
    [sym_assignment] = STATE(11436),
    [sym__expression] = STATE(12742),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10435),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12583),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2616),
    [sym_line_comment] = STATE(2616),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2617] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19079),
    [sym__expression] = STATE(13943),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2617),
    [sym_line_comment] = STATE(2617),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2618] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2618),
    [sym_line_comment] = STATE(2618),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8822),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2619] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18821),
    [sym__expression] = STATE(13474),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2619),
    [sym_line_comment] = STATE(2619),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2620] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2620),
    [sym_line_comment] = STATE(2620),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8824),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2621] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19566),
    [sym__expression] = STATE(13578),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2621),
    [sym_line_comment] = STATE(2621),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2622] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2622),
    [sym_line_comment] = STATE(2622),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8752),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2623] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19054),
    [sym__expression] = STATE(13615),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2623),
    [sym_line_comment] = STATE(2623),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2624] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2624),
    [sym_line_comment] = STATE(2624),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8826),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2625] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18862),
    [sym__expression] = STATE(13664),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2625),
    [sym_line_comment] = STATE(2625),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2626] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2626),
    [sym_line_comment] = STATE(2626),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8828),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2627] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19264),
    [sym__expression] = STATE(13749),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2627),
    [sym_line_comment] = STATE(2627),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2628] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2628),
    [sym_line_comment] = STATE(2628),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8830),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2629] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18918),
    [sym__expression] = STATE(13767),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2629),
    [sym_line_comment] = STATE(2629),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2630] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2630),
    [sym_line_comment] = STATE(2630),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7646),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2631] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18655),
    [sym__expression] = STATE(13799),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2631),
    [sym_line_comment] = STATE(2631),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2632] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2632),
    [sym_line_comment] = STATE(2632),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8832),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2633] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19413),
    [sym__expression] = STATE(13823),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2633),
    [sym_line_comment] = STATE(2633),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2634] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2634),
    [sym_line_comment] = STATE(2634),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8834),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2635] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18296),
    [sym__expression] = STATE(13871),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2635),
    [sym_line_comment] = STATE(2635),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2636] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2636),
    [sym_line_comment] = STATE(2636),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8836),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2637] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18949),
    [sym__expression] = STATE(13918),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2637),
    [sym_line_comment] = STATE(2637),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2638] = {
    [sym_open_tuple] = STATE(15296),
    [sym_assignment] = STATE(14252),
    [sym__expression] = STATE(12721),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10378),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12468),
    [sym_unary_expression] = STATE(12468),
    [sym_range_expression] = STATE(12468),
    [sym_splat_expression] = STATE(12468),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12153),
    [sym_unary_typed_expression] = STATE(12468),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12468),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12159),
    [sym_block_comment] = STATE(2638),
    [sym_line_comment] = STATE(2638),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2639] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18482),
    [sym__expression] = STATE(13939),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2639),
    [sym_line_comment] = STATE(2639),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2640] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2640),
    [sym_line_comment] = STATE(2640),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8838),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2641] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19019),
    [sym__expression] = STATE(13952),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2641),
    [sym_line_comment] = STATE(2641),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2642] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2642),
    [sym_line_comment] = STATE(2642),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8840),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2643] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19260),
    [sym__expression] = STATE(13965),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2643),
    [sym_line_comment] = STATE(2643),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2644] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2644),
    [sym_line_comment] = STATE(2644),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8842),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2645] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19590),
    [sym__expression] = STATE(13440),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2645),
    [sym_line_comment] = STATE(2645),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2646] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2646),
    [sym_line_comment] = STATE(2646),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8844),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2647] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18401),
    [sym__expression] = STATE(13444),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2647),
    [sym_line_comment] = STATE(2647),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2648] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18618),
    [sym__expression] = STATE(13451),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2648),
    [sym_line_comment] = STATE(2648),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2649] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18785),
    [sym__expression] = STATE(13458),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2649),
    [sym_line_comment] = STATE(2649),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2650] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18905),
    [sym__expression] = STATE(13464),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2650),
    [sym_line_comment] = STATE(2650),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2651] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19009),
    [sym__expression] = STATE(13473),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2651),
    [sym_line_comment] = STATE(2651),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2652] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19138),
    [sym__expression] = STATE(13488),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2652),
    [sym_line_comment] = STATE(2652),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2653] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19308),
    [sym__expression] = STATE(13501),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2653),
    [sym_line_comment] = STATE(2653),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2654] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19409),
    [sym__expression] = STATE(13506),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2654),
    [sym_line_comment] = STATE(2654),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2655] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19513),
    [sym__expression] = STATE(13510),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2655),
    [sym_line_comment] = STATE(2655),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2656] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19497),
    [sym__expression] = STATE(13517),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2656),
    [sym_line_comment] = STATE(2656),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2657] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19043),
    [sym__expression] = STATE(13521),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2657),
    [sym_line_comment] = STATE(2657),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2658] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18919),
    [sym__expression] = STATE(13527),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2658),
    [sym_line_comment] = STATE(2658),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2659] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19279),
    [sym__expression] = STATE(13531),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2659),
    [sym_line_comment] = STATE(2659),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2660] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18731),
    [sym__expression] = STATE(13534),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2660),
    [sym_line_comment] = STATE(2660),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2661] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19293),
    [sym__expression] = STATE(13537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2661),
    [sym_line_comment] = STATE(2661),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2662] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18363),
    [sym__expression] = STATE(13540),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2662),
    [sym_line_comment] = STATE(2662),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2663] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19507),
    [sym__expression] = STATE(13547),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2663),
    [sym_line_comment] = STATE(2663),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2664] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18594),
    [sym__expression] = STATE(13552),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2664),
    [sym_line_comment] = STATE(2664),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2665] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18908),
    [sym__expression] = STATE(13555),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2665),
    [sym_line_comment] = STATE(2665),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2666] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19193),
    [sym__expression] = STATE(13561),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2666),
    [sym_line_comment] = STATE(2666),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2667] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19435),
    [sym__expression] = STATE(13565),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2667),
    [sym_line_comment] = STATE(2667),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2668] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18830),
    [sym__expression] = STATE(13569),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2668),
    [sym_line_comment] = STATE(2668),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2669] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(19187),
    [sym__expression] = STATE(13574),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2669),
    [sym_line_comment] = STATE(2669),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2670] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18747),
    [sym__expression] = STATE(13579),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2670),
    [sym_line_comment] = STATE(2670),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2671] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18240),
    [sym__expression] = STATE(13587),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2671),
    [sym_line_comment] = STATE(2671),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2672] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18343),
    [sym__expression] = STATE(13590),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2672),
    [sym_line_comment] = STATE(2672),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2673] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18412),
    [sym__expression] = STATE(13591),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2673),
    [sym_line_comment] = STATE(2673),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2674] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18464),
    [sym__expression] = STATE(13592),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2674),
    [sym_line_comment] = STATE(2674),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2675] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18531),
    [sym__expression] = STATE(13593),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2675),
    [sym_line_comment] = STATE(2675),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2676] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18583),
    [sym__expression] = STATE(13594),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2676),
    [sym_line_comment] = STATE(2676),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2677] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18627),
    [sym__expression] = STATE(13595),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2677),
    [sym_line_comment] = STATE(2677),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2678] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18670),
    [sym__expression] = STATE(13597),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2678),
    [sym_line_comment] = STATE(2678),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2679] = {
    [sym_open_tuple] = STATE(18395),
    [sym_assignment] = STATE(11587),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11026),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14043),
    [sym_unary_expression] = STATE(14043),
    [sym_range_expression] = STATE(14043),
    [sym_splat_expression] = STATE(14043),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13612),
    [sym_unary_typed_expression] = STATE(14043),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14043),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13613),
    [sym_block_comment] = STATE(2679),
    [sym_line_comment] = STATE(2679),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2680] = {
    [sym_open_tuple] = STATE(19508),
    [sym_assignment] = STATE(18505),
    [sym__expression] = STATE(13611),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10825),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13626),
    [sym_unary_expression] = STATE(13626),
    [sym_range_expression] = STATE(13626),
    [sym_splat_expression] = STATE(13626),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13362),
    [sym_unary_typed_expression] = STATE(13626),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13626),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13281),
    [sym_block_comment] = STATE(2680),
    [sym_line_comment] = STATE(2680),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2681] = {
    [sym_open_tuple] = STATE(13677),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(13616),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10703),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13698),
    [sym_unary_expression] = STATE(13698),
    [sym_range_expression] = STATE(13698),
    [sym_splat_expression] = STATE(13698),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13344),
    [sym_unary_typed_expression] = STATE(13698),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13698),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13361),
    [sym_block_comment] = STATE(2681),
    [sym_line_comment] = STATE(2681),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2682] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2682),
    [sym_line_comment] = STATE(2682),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8846),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2683] = {
    [sym_open_tuple] = STATE(13678),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(13618),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10703),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13698),
    [sym_unary_expression] = STATE(13698),
    [sym_range_expression] = STATE(13698),
    [sym_splat_expression] = STATE(13698),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13344),
    [sym_unary_typed_expression] = STATE(13698),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13698),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13361),
    [sym_block_comment] = STATE(2683),
    [sym_line_comment] = STATE(2683),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2684] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2684),
    [sym_line_comment] = STATE(2684),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(7410),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2685] = {
    [sym_open_tuple] = STATE(18424),
    [sym_assignment] = STATE(8726),
    [sym__expression] = STATE(8765),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4704),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8747),
    [sym_unary_expression] = STATE(8747),
    [sym_range_expression] = STATE(8747),
    [sym_splat_expression] = STATE(8747),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8457),
    [sym_unary_typed_expression] = STATE(8747),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8747),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8458),
    [sym_block_comment] = STATE(2685),
    [sym_line_comment] = STATE(2685),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2686] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2686),
    [sym_line_comment] = STATE(2686),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(8796),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2687] = {
    [sym_open_tuple] = STATE(18578),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(12165),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10247),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12080),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2687),
    [sym_line_comment] = STATE(2687),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2688] = {
    [sym_open_tuple] = STATE(12637),
    [sym_assignment] = STATE(11520),
    [sym__expression] = STATE(12096),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10372),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11494),
    [sym_unary_expression] = STATE(11494),
    [sym_range_expression] = STATE(11494),
    [sym_splat_expression] = STATE(11494),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12348),
    [sym_unary_typed_expression] = STATE(11494),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11494),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11419),
    [sym_block_comment] = STATE(2688),
    [sym_line_comment] = STATE(2688),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2689] = {
    [sym_open_tuple] = STATE(19399),
    [sym_assignment] = STATE(12062),
    [sym__expression] = STATE(13982),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11136),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14078),
    [sym_unary_expression] = STATE(14078),
    [sym_range_expression] = STATE(14078),
    [sym_splat_expression] = STATE(14078),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13853),
    [sym_unary_typed_expression] = STATE(14078),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14078),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13782),
    [sym_block_comment] = STATE(2689),
    [sym_line_comment] = STATE(2689),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2690] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2690),
    [sym_line_comment] = STATE(2690),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8848),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2691] = {
    [sym_open_tuple] = STATE(18390),
    [sym_assignment] = STATE(10755),
    [sym__expression] = STATE(13395),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10504),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10771),
    [sym_unary_expression] = STATE(10771),
    [sym_range_expression] = STATE(10771),
    [sym_splat_expression] = STATE(10771),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12582),
    [sym_unary_typed_expression] = STATE(10771),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10771),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10570),
    [sym_block_comment] = STATE(2691),
    [sym_line_comment] = STATE(2691),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2692] = {
    [sym_open_tuple] = STATE(13006),
    [sym_assignment] = STATE(10732),
    [sym__expression] = STATE(13007),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10469),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12909),
    [sym_unary_expression] = STATE(12909),
    [sym_range_expression] = STATE(12909),
    [sym_splat_expression] = STATE(12909),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(12909),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12909),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12508),
    [sym_block_comment] = STATE(2692),
    [sym_line_comment] = STATE(2692),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2693] = {
    [sym_open_tuple] = STATE(8108),
    [sym_assignment] = STATE(8120),
    [sym__expression] = STATE(7622),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4257),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8548),
    [sym_unary_expression] = STATE(8548),
    [sym_range_expression] = STATE(8548),
    [sym_splat_expression] = STATE(8548),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7807),
    [sym_unary_typed_expression] = STATE(8548),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8548),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7725),
    [sym_block_comment] = STATE(2693),
    [sym_line_comment] = STATE(2693),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2694] = {
    [sym_open_tuple] = STATE(13008),
    [sym_assignment] = STATE(10736),
    [sym__expression] = STATE(13009),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10469),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12909),
    [sym_unary_expression] = STATE(12909),
    [sym_range_expression] = STATE(12909),
    [sym_splat_expression] = STATE(12909),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12421),
    [sym_unary_typed_expression] = STATE(12909),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12909),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12508),
    [sym_block_comment] = STATE(2694),
    [sym_line_comment] = STATE(2694),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2695] = {
    [sym_open_tuple] = STATE(18529),
    [sym_assignment] = STATE(7640),
    [sym__expression] = STATE(7082),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4200),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7226),
    [sym_unary_expression] = STATE(7226),
    [sym_range_expression] = STATE(7226),
    [sym_splat_expression] = STATE(7226),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6922),
    [sym_unary_typed_expression] = STATE(7226),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7226),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6816),
    [sym_block_comment] = STATE(2695),
    [sym_line_comment] = STATE(2695),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2696] = {
    [sym__closed_assignment] = STATE(16590),
    [sym__expression] = STATE(12497),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2696),
    [sym_line_comment] = STATE(2696),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_RPAREN] = ACTIONS(6884),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2697] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2697),
    [sym_line_comment] = STATE(2697),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(8850),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2698] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2698),
    [sym_line_comment] = STATE(2698),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(8852),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2699] = {
    [sym__closed_assignment] = STATE(7959),
    [sym__expression] = STATE(8813),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4370),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7980),
    [sym_unary_expression] = STATE(7980),
    [sym_range_expression] = STATE(7980),
    [sym_splat_expression] = STATE(7980),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7870),
    [sym_unary_typed_expression] = STATE(7980),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(7980),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7864),
    [sym_block_comment] = STATE(2699),
    [sym_line_comment] = STATE(2699),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2700] = {
    [sym__closed_assignment] = STATE(8122),
    [sym__expression] = STATE(9108),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4718),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8657),
    [sym_unary_expression] = STATE(8657),
    [sym_range_expression] = STATE(8657),
    [sym_splat_expression] = STATE(8657),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8092),
    [sym_unary_typed_expression] = STATE(8657),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8657),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8423),
    [sym_block_comment] = STATE(2700),
    [sym_line_comment] = STATE(2700),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2701] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(573),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2701),
    [sym_line_comment] = STATE(2701),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2702] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(537),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2702),
    [sym_line_comment] = STATE(2702),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2703] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(539),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2703),
    [sym_line_comment] = STATE(2703),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2704] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13784),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10770),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13288),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2704),
    [sym_line_comment] = STATE(2704),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2705] = {
    [sym__closed_assignment] = STATE(7341),
    [sym__expression] = STATE(8836),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4393),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(8461),
    [sym_unary_expression] = STATE(8461),
    [sym_range_expression] = STATE(8461),
    [sym_splat_expression] = STATE(8461),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7497),
    [sym_unary_typed_expression] = STATE(8461),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(8461),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(7503),
    [sym_block_comment] = STATE(2705),
    [sym_line_comment] = STATE(2705),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2706] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(13122),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10307),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12456),
    [sym_unary_expression] = STATE(12456),
    [sym_range_expression] = STATE(12456),
    [sym_splat_expression] = STATE(12456),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12266),
    [sym_unary_typed_expression] = STATE(12456),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12456),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12076),
    [sym_block_comment] = STATE(2706),
    [sym_line_comment] = STATE(2706),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2707] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(19200),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2707),
    [sym_line_comment] = STATE(2707),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2708] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(542),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2708),
    [sym_line_comment] = STATE(2708),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2709] = {
    [sym__closed_assignment] = STATE(8312),
    [sym__expression] = STATE(8504),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4371),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8031),
    [sym_unary_expression] = STATE(8031),
    [sym_range_expression] = STATE(8031),
    [sym_splat_expression] = STATE(8031),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7237),
    [sym_unary_typed_expression] = STATE(8031),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8031),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7894),
    [sym_block_comment] = STATE(2709),
    [sym_line_comment] = STATE(2709),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2710] = {
    [sym__closed_assignment] = STATE(8197),
    [sym__expression] = STATE(8510),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4445),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8249),
    [sym_unary_expression] = STATE(8249),
    [sym_range_expression] = STATE(8249),
    [sym_splat_expression] = STATE(8249),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7815),
    [sym_unary_typed_expression] = STATE(8249),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8249),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7445),
    [sym_block_comment] = STATE(2710),
    [sym_line_comment] = STATE(2710),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2711] = {
    [sym__closed_assignment] = STATE(17356),
    [sym__expression] = STATE(14239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11328),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14101),
    [sym_unary_expression] = STATE(14101),
    [sym_range_expression] = STATE(14101),
    [sym_splat_expression] = STATE(14101),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13996),
    [sym_unary_typed_expression] = STATE(14101),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14101),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10270),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14005),
    [sym_block_comment] = STATE(2711),
    [sym_line_comment] = STATE(2711),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2712] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(554),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2712),
    [sym_line_comment] = STATE(2712),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2713] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(555),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2713),
    [sym_line_comment] = STATE(2713),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2714] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(556),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2714),
    [sym_line_comment] = STATE(2714),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2715] = {
    [sym__closed_assignment] = STATE(17494),
    [sym__expression] = STATE(13926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2715),
    [sym_line_comment] = STATE(2715),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2716] = {
    [sym__closed_assignment] = STATE(11485),
    [sym__expression] = STATE(12811),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10310),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12744),
    [sym_unary_expression] = STATE(12744),
    [sym_range_expression] = STATE(12744),
    [sym_splat_expression] = STATE(12744),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12047),
    [sym_unary_typed_expression] = STATE(12744),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12744),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12373),
    [sym_block_comment] = STATE(2716),
    [sym_line_comment] = STATE(2716),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2717] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(568),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2717),
    [sym_line_comment] = STATE(2717),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2718] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(18644),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2718),
    [sym_line_comment] = STATE(2718),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2719] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(561),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2719),
    [sym_line_comment] = STATE(2719),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2720] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12470),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10253),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12041),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2720),
    [sym_line_comment] = STATE(2720),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2721] = {
    [sym__closed_assignment] = STATE(8122),
    [sym__expression] = STATE(8798),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4733),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8513),
    [sym_unary_expression] = STATE(8513),
    [sym_range_expression] = STATE(8513),
    [sym_splat_expression] = STATE(8513),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8176),
    [sym_unary_typed_expression] = STATE(8513),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8513),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7662),
    [sym_block_comment] = STATE(2721),
    [sym_line_comment] = STATE(2721),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2722] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12896),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10310),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12744),
    [sym_unary_expression] = STATE(12744),
    [sym_range_expression] = STATE(12744),
    [sym_splat_expression] = STATE(12744),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12047),
    [sym_unary_typed_expression] = STATE(12744),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12744),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12373),
    [sym_block_comment] = STATE(2722),
    [sym_line_comment] = STATE(2722),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2723] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(570),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2723),
    [sym_line_comment] = STATE(2723),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2724] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(571),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2724),
    [sym_line_comment] = STATE(2724),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2725] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(572),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2725),
    [sym_line_comment] = STATE(2725),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2726] = {
    [sym__closed_assignment] = STATE(11485),
    [sym__expression] = STATE(12910),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10307),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12456),
    [sym_unary_expression] = STATE(12456),
    [sym_range_expression] = STATE(12456),
    [sym_splat_expression] = STATE(12456),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12266),
    [sym_unary_typed_expression] = STATE(12456),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12456),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12076),
    [sym_block_comment] = STATE(2726),
    [sym_line_comment] = STATE(2726),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2727] = {
    [sym__closed_assignment] = STATE(12156),
    [sym__expression] = STATE(12067),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10211),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12181),
    [sym_unary_expression] = STATE(12181),
    [sym_range_expression] = STATE(12181),
    [sym_splat_expression] = STATE(12181),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11854),
    [sym_unary_typed_expression] = STATE(12181),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12181),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11753),
    [sym_block_comment] = STATE(2727),
    [sym_line_comment] = STATE(2727),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2728] = {
    [sym__closed_assignment] = STATE(8312),
    [sym__expression] = STATE(8772),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4258),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8091),
    [sym_unary_expression] = STATE(8091),
    [sym_range_expression] = STATE(8091),
    [sym_splat_expression] = STATE(8091),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7809),
    [sym_unary_typed_expression] = STATE(8091),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8091),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7699),
    [sym_block_comment] = STATE(2728),
    [sym_line_comment] = STATE(2728),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2729] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(18413),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2729),
    [sym_line_comment] = STATE(2729),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2730] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(538),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2730),
    [sym_line_comment] = STATE(2730),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2731] = {
    [sym__expression] = STATE(13872),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10299),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2731),
    [sym_line_comment] = STATE(2731),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2732] = {
    [sym__closed_assignment] = STATE(7902),
    [sym__expression] = STATE(8584),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4199),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7808),
    [sym_unary_expression] = STATE(7808),
    [sym_range_expression] = STATE(7808),
    [sym_splat_expression] = STATE(7808),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6892),
    [sym_unary_typed_expression] = STATE(7808),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7808),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(7176),
    [sym_block_comment] = STATE(2732),
    [sym_line_comment] = STATE(2732),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2733] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13908),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10558),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13185),
    [sym_unary_expression] = STATE(13185),
    [sym_range_expression] = STATE(13185),
    [sym_splat_expression] = STATE(13185),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13012),
    [sym_unary_typed_expression] = STATE(13185),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13185),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12978),
    [sym_block_comment] = STATE(2733),
    [sym_line_comment] = STATE(2733),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2734] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(558),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2734),
    [sym_line_comment] = STATE(2734),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2735] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(536),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2735),
    [sym_line_comment] = STATE(2735),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2736] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(497),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2736),
    [sym_line_comment] = STATE(2736),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2737] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(13143),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10426),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12763),
    [sym_unary_expression] = STATE(12763),
    [sym_range_expression] = STATE(12763),
    [sym_splat_expression] = STATE(12763),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12715),
    [sym_unary_typed_expression] = STATE(12763),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12763),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12424),
    [sym_block_comment] = STATE(2737),
    [sym_line_comment] = STATE(2737),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2738] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(506),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2738),
    [sym_line_comment] = STATE(2738),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2739] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(14084),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10992),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13566),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2739),
    [sym_line_comment] = STATE(2739),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2740] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(18636),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2740),
    [sym_line_comment] = STATE(2740),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2741] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(501),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2741),
    [sym_line_comment] = STATE(2741),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2742] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13133),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10622),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13120),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2742),
    [sym_line_comment] = STATE(2742),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2743] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12475),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10277),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12123),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2743),
    [sym_line_comment] = STATE(2743),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2744] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13239),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10443),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12810),
    [sym_unary_expression] = STATE(12810),
    [sym_range_expression] = STATE(12810),
    [sym_splat_expression] = STATE(12810),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12810),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12810),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12584),
    [sym_block_comment] = STATE(2744),
    [sym_line_comment] = STATE(2744),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2745] = {
    [sym__closed_assignment] = STATE(7939),
    [sym__expression] = STATE(8500),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4489),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8445),
    [sym_unary_expression] = STATE(8445),
    [sym_range_expression] = STATE(8445),
    [sym_splat_expression] = STATE(8445),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7772),
    [sym_unary_typed_expression] = STATE(8445),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8445),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7387),
    [sym_block_comment] = STATE(2745),
    [sym_line_comment] = STATE(2745),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2746] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13665),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10558),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13185),
    [sym_unary_expression] = STATE(13185),
    [sym_range_expression] = STATE(13185),
    [sym_splat_expression] = STATE(13185),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13012),
    [sym_unary_typed_expression] = STATE(13185),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13185),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12978),
    [sym_block_comment] = STATE(2746),
    [sym_line_comment] = STATE(2746),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2747] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(19286),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2747),
    [sym_line_comment] = STATE(2747),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2748] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(524),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2748),
    [sym_line_comment] = STATE(2748),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2749] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(525),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2749),
    [sym_line_comment] = STATE(2749),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2750] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(526),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2750),
    [sym_line_comment] = STATE(2750),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2751] = {
    [sym__closed_assignment] = STATE(7970),
    [sym__expression] = STATE(8926),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4258),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8091),
    [sym_unary_expression] = STATE(8091),
    [sym_range_expression] = STATE(8091),
    [sym_splat_expression] = STATE(8091),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7809),
    [sym_unary_typed_expression] = STATE(8091),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8091),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7699),
    [sym_block_comment] = STATE(2751),
    [sym_line_comment] = STATE(2751),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2752] = {
    [sym__closed_assignment] = STATE(9428),
    [sym__expression] = STATE(13277),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10603),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(13370),
    [sym_unary_expression] = STATE(13370),
    [sym_range_expression] = STATE(13370),
    [sym_splat_expression] = STATE(13370),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(13104),
    [sym_unary_typed_expression] = STATE(13370),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(13370),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(13110),
    [sym_block_comment] = STATE(2752),
    [sym_line_comment] = STATE(2752),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2753] = {
    [sym__closed_assignment] = STATE(9195),
    [sym__expression] = STATE(9274),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5126),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9296),
    [sym_unary_expression] = STATE(9296),
    [sym_range_expression] = STATE(9296),
    [sym_splat_expression] = STATE(9296),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9110),
    [sym_unary_typed_expression] = STATE(9296),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9296),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8961),
    [sym_block_comment] = STATE(2753),
    [sym_line_comment] = STATE(2753),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2754] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(19035),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2754),
    [sym_line_comment] = STATE(2754),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2755] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(532),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2755),
    [sym_line_comment] = STATE(2755),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2756] = {
    [sym__expression] = STATE(14167),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_named_field] = STATE(19207),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10588),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2756),
    [sym_line_comment] = STATE(2756),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2757] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13194),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10424),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13086),
    [sym_unary_expression] = STATE(13086),
    [sym_range_expression] = STATE(13086),
    [sym_splat_expression] = STATE(13086),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12512),
    [sym_unary_typed_expression] = STATE(13086),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13086),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12681),
    [sym_block_comment] = STATE(2757),
    [sym_line_comment] = STATE(2757),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2758] = {
    [sym__closed_assignment] = STATE(11485),
    [sym__expression] = STATE(13277),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10426),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12763),
    [sym_unary_expression] = STATE(12763),
    [sym_range_expression] = STATE(12763),
    [sym_splat_expression] = STATE(12763),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12715),
    [sym_unary_typed_expression] = STATE(12763),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12763),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12424),
    [sym_block_comment] = STATE(2758),
    [sym_line_comment] = STATE(2758),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2759] = {
    [sym__expression] = STATE(14184),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_named_field] = STATE(18793),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10588),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2759),
    [sym_line_comment] = STATE(2759),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2760] = {
    [sym__closed_assignment] = STATE(8601),
    [sym__expression] = STATE(8740),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4336),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8421),
    [sym_unary_expression] = STATE(8421),
    [sym_range_expression] = STATE(8421),
    [sym_splat_expression] = STATE(8421),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7298),
    [sym_unary_typed_expression] = STATE(8421),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8421),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7299),
    [sym_block_comment] = STATE(2760),
    [sym_line_comment] = STATE(2760),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2761] = {
    [sym__closed_assignment] = STATE(12286),
    [sym__expression] = STATE(12513),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10171),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12055),
    [sym_unary_expression] = STATE(12055),
    [sym_range_expression] = STATE(12055),
    [sym_splat_expression] = STATE(12055),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11925),
    [sym_unary_typed_expression] = STATE(12055),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12055),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11767),
    [sym_block_comment] = STATE(2761),
    [sym_line_comment] = STATE(2761),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2762] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13499),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10673),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12937),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2762),
    [sym_line_comment] = STATE(2762),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2763] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12944),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10416),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12392),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2763),
    [sym_line_comment] = STATE(2763),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2764] = {
    [sym__closed_assignment] = STATE(9177),
    [sym__expression] = STATE(9333),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5045),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9269),
    [sym_unary_expression] = STATE(9269),
    [sym_range_expression] = STATE(9269),
    [sym_splat_expression] = STATE(9269),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8982),
    [sym_unary_typed_expression] = STATE(9269),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9269),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8965),
    [sym_block_comment] = STATE(2764),
    [sym_line_comment] = STATE(2764),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2765] = {
    [sym__closed_assignment] = STATE(8447),
    [sym__expression] = STATE(9252),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4867),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9114),
    [sym_unary_expression] = STATE(9114),
    [sym_range_expression] = STATE(9114),
    [sym_splat_expression] = STATE(9114),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8841),
    [sym_unary_typed_expression] = STATE(9114),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9114),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8751),
    [sym_block_comment] = STATE(2765),
    [sym_line_comment] = STATE(2765),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2766] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13263),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10443),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12810),
    [sym_unary_expression] = STATE(12810),
    [sym_range_expression] = STATE(12810),
    [sym_splat_expression] = STATE(12810),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12697),
    [sym_unary_typed_expression] = STATE(12810),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12810),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12584),
    [sym_block_comment] = STATE(2766),
    [sym_line_comment] = STATE(2766),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2767] = {
    [sym__closed_assignment] = STATE(8381),
    [sym__expression] = STATE(8774),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4370),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(7980),
    [sym_unary_expression] = STATE(7980),
    [sym_range_expression] = STATE(7980),
    [sym_splat_expression] = STATE(7980),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7870),
    [sym_unary_typed_expression] = STATE(7980),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(7980),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7864),
    [sym_block_comment] = STATE(2767),
    [sym_line_comment] = STATE(2767),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2768] = {
    [sym__closed_assignment] = STATE(12156),
    [sym__expression] = STATE(12433),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10171),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12055),
    [sym_unary_expression] = STATE(12055),
    [sym_range_expression] = STATE(12055),
    [sym_splat_expression] = STATE(12055),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11925),
    [sym_unary_typed_expression] = STATE(12055),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12055),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11767),
    [sym_block_comment] = STATE(2768),
    [sym_line_comment] = STATE(2768),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2769] = {
    [sym__closed_assignment] = STATE(11485),
    [sym__expression] = STATE(13381),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10474),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12879),
    [sym_unary_expression] = STATE(12879),
    [sym_range_expression] = STATE(12879),
    [sym_splat_expression] = STATE(12879),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12570),
    [sym_unary_typed_expression] = STATE(12879),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12879),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12571),
    [sym_block_comment] = STATE(2769),
    [sym_line_comment] = STATE(2769),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2770] = {
    [sym__closed_assignment] = STATE(7289),
    [sym__expression] = STATE(7665),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4192),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7726),
    [sym_unary_expression] = STATE(7726),
    [sym_range_expression] = STATE(7726),
    [sym_splat_expression] = STATE(7726),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6817),
    [sym_unary_typed_expression] = STATE(7726),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7726),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(7133),
    [sym_block_comment] = STATE(2770),
    [sym_line_comment] = STATE(2770),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2771] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(14176),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11181),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14025),
    [sym_unary_expression] = STATE(14025),
    [sym_range_expression] = STATE(14025),
    [sym_splat_expression] = STATE(14025),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13948),
    [sym_unary_typed_expression] = STATE(14025),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14025),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13867),
    [sym_block_comment] = STATE(2771),
    [sym_line_comment] = STATE(2771),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2772] = {
    [sym__closed_assignment] = STATE(11485),
    [sym__expression] = STATE(12928),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10324),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12447),
    [sym_unary_expression] = STATE(12447),
    [sym_range_expression] = STATE(12447),
    [sym_splat_expression] = STATE(12447),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12167),
    [sym_unary_typed_expression] = STATE(12447),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12447),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12075),
    [sym_block_comment] = STATE(2772),
    [sym_line_comment] = STATE(2772),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2773] = {
    [sym__closed_assignment] = STATE(7939),
    [sym__expression] = STATE(8921),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4336),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8421),
    [sym_unary_expression] = STATE(8421),
    [sym_range_expression] = STATE(8421),
    [sym_splat_expression] = STATE(8421),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7298),
    [sym_unary_typed_expression] = STATE(8421),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8421),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7299),
    [sym_block_comment] = STATE(2773),
    [sym_line_comment] = STATE(2773),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2774] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12640),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10302),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12065),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2774),
    [sym_line_comment] = STATE(2774),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2775] = {
    [sym__closed_assignment] = STATE(9428),
    [sym__expression] = STATE(8740),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4732),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8837),
    [sym_unary_expression] = STATE(8837),
    [sym_range_expression] = STATE(8837),
    [sym_splat_expression] = STATE(8837),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8231),
    [sym_unary_typed_expression] = STATE(8837),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8837),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8232),
    [sym_block_comment] = STATE(2775),
    [sym_line_comment] = STATE(2775),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2776] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13795),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10803),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13152),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2776),
    [sym_line_comment] = STATE(2776),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2777] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(530),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2777),
    [sym_line_comment] = STATE(2777),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2778] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(531),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2778),
    [sym_line_comment] = STATE(2778),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2779] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(533),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2779),
    [sym_line_comment] = STATE(2779),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2780] = {
    [sym__closed_assignment] = STATE(8799),
    [sym__expression] = STATE(8822),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4574),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8752),
    [sym_unary_expression] = STATE(8752),
    [sym_range_expression] = STATE(8752),
    [sym_splat_expression] = STATE(8752),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8119),
    [sym_unary_typed_expression] = STATE(8752),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8752),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8462),
    [sym_block_comment] = STATE(2780),
    [sym_line_comment] = STATE(2780),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2781] = {
    [sym__closed_assignment] = STATE(8122),
    [sym__expression] = STATE(9071),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4918),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8513),
    [sym_unary_expression] = STATE(8513),
    [sym_range_expression] = STATE(8513),
    [sym_splat_expression] = STATE(8513),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8705),
    [sym_unary_typed_expression] = STATE(8513),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8513),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7662),
    [sym_block_comment] = STATE(2781),
    [sym_line_comment] = STATE(2781),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2782] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12408),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10353),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11539),
    [sym_unary_expression] = STATE(11539),
    [sym_range_expression] = STATE(11539),
    [sym_splat_expression] = STATE(11539),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12183),
    [sym_unary_typed_expression] = STATE(11539),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11539),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11410),
    [sym_block_comment] = STATE(2782),
    [sym_line_comment] = STATE(2782),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2783] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(18697),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2783),
    [sym_line_comment] = STATE(2783),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2784] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(546),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2784),
    [sym_line_comment] = STATE(2784),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2785] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12814),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10324),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12447),
    [sym_unary_expression] = STATE(12447),
    [sym_range_expression] = STATE(12447),
    [sym_splat_expression] = STATE(12447),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12167),
    [sym_unary_typed_expression] = STATE(12447),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12447),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12075),
    [sym_block_comment] = STATE(2785),
    [sym_line_comment] = STATE(2785),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2786] = {
    [sym__closed_assignment] = STATE(7959),
    [sym__expression] = STATE(8507),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4420),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8118),
    [sym_unary_expression] = STATE(8118),
    [sym_range_expression] = STATE(8118),
    [sym_splat_expression] = STATE(8118),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7493),
    [sym_unary_typed_expression] = STATE(8118),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8118),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7845),
    [sym_block_comment] = STATE(2786),
    [sym_line_comment] = STATE(2786),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2787] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12557),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10345),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11539),
    [sym_unary_expression] = STATE(11539),
    [sym_range_expression] = STATE(11539),
    [sym_splat_expression] = STATE(11539),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12193),
    [sym_unary_typed_expression] = STATE(11539),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11539),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11410),
    [sym_block_comment] = STATE(2787),
    [sym_line_comment] = STATE(2787),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2788] = {
    [sym__expression] = STATE(14136),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_named_field] = STATE(19509),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10588),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2788),
    [sym_line_comment] = STATE(2788),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2789] = {
    [sym__expression] = STATE(13978),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_named_field] = STATE(17335),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10505),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2789),
    [sym_line_comment] = STATE(2789),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2790] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(514),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2790),
    [sym_line_comment] = STATE(2790),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2791] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(515),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2791),
    [sym_line_comment] = STATE(2791),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2792] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(516),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2792),
    [sym_line_comment] = STATE(2792),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2793] = {
    [sym__closed_assignment] = STATE(8451),
    [sym__expression] = STATE(8846),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4436),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8175),
    [sym_unary_expression] = STATE(8175),
    [sym_range_expression] = STATE(8175),
    [sym_splat_expression] = STATE(8175),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7687),
    [sym_unary_typed_expression] = STATE(8175),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8175),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7609),
    [sym_block_comment] = STATE(2793),
    [sym_line_comment] = STATE(2793),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2794] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13339),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2794),
    [sym_line_comment] = STATE(2794),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2795] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13196),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10424),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13086),
    [sym_unary_expression] = STATE(13086),
    [sym_range_expression] = STATE(13086),
    [sym_splat_expression] = STATE(13086),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12512),
    [sym_unary_typed_expression] = STATE(13086),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13086),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12681),
    [sym_block_comment] = STATE(2795),
    [sym_line_comment] = STATE(2795),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2796] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(19095),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2796),
    [sym_line_comment] = STATE(2796),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2797] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(518),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2797),
    [sym_line_comment] = STATE(2797),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2798] = {
    [sym__closed_assignment] = STATE(8799),
    [sym__expression] = STATE(9213),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4964),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9055),
    [sym_unary_expression] = STATE(9055),
    [sym_range_expression] = STATE(9055),
    [sym_splat_expression] = STATE(9055),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8621),
    [sym_unary_typed_expression] = STATE(9055),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(9055),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8635),
    [sym_block_comment] = STATE(2798),
    [sym_line_comment] = STATE(2798),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2799] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12063),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10150),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11539),
    [sym_unary_expression] = STATE(11539),
    [sym_range_expression] = STATE(11539),
    [sym_splat_expression] = STATE(11539),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11837),
    [sym_unary_typed_expression] = STATE(11539),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11539),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11410),
    [sym_block_comment] = STATE(2799),
    [sym_line_comment] = STATE(2799),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2800] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13385),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10404),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13124),
    [sym_unary_expression] = STATE(13124),
    [sym_range_expression] = STATE(13124),
    [sym_splat_expression] = STATE(13124),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12594),
    [sym_unary_typed_expression] = STATE(13124),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13124),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12712),
    [sym_block_comment] = STATE(2800),
    [sym_line_comment] = STATE(2800),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2801] = {
    [sym__expression] = STATE(14125),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_named_field] = STATE(18511),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10588),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2801),
    [sym_line_comment] = STATE(2801),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2802] = {
    [sym__closed_assignment] = STATE(7902),
    [sym__expression] = STATE(7652),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4214),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7770),
    [sym_unary_expression] = STATE(7770),
    [sym_range_expression] = STATE(7770),
    [sym_splat_expression] = STATE(7770),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6993),
    [sym_unary_typed_expression] = STATE(7770),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7770),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6705),
    [sym_block_comment] = STATE(2802),
    [sym_line_comment] = STATE(2802),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2803] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(521),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2803),
    [sym_line_comment] = STATE(2803),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2804] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(540),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2804),
    [sym_line_comment] = STATE(2804),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2805] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(498),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2805),
    [sym_line_comment] = STATE(2805),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2806] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12939),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10425),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11539),
    [sym_unary_expression] = STATE(11539),
    [sym_range_expression] = STATE(11539),
    [sym_splat_expression] = STATE(11539),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12430),
    [sym_unary_typed_expression] = STATE(11539),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11539),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11410),
    [sym_block_comment] = STATE(2806),
    [sym_line_comment] = STATE(2806),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2807] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(504),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2807),
    [sym_line_comment] = STATE(2807),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2808] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(502),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2808),
    [sym_line_comment] = STATE(2808),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2809] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(19583),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2809),
    [sym_line_comment] = STATE(2809),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2810] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(499),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2810),
    [sym_line_comment] = STATE(2810),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2811] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(13261),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10474),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12879),
    [sym_unary_expression] = STATE(12879),
    [sym_range_expression] = STATE(12879),
    [sym_splat_expression] = STATE(12879),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12570),
    [sym_unary_typed_expression] = STATE(12879),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12879),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(12571),
    [sym_block_comment] = STATE(2811),
    [sym_line_comment] = STATE(2811),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2812] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12463),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10191),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12265),
    [sym_unary_expression] = STATE(12265),
    [sym_range_expression] = STATE(12265),
    [sym_splat_expression] = STATE(12265),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11872),
    [sym_unary_typed_expression] = STATE(12265),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12265),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11750),
    [sym_block_comment] = STATE(2812),
    [sym_line_comment] = STATE(2812),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2813] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13415),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2813),
    [sym_line_comment] = STATE(2813),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2814] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12942),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10437),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11539),
    [sym_unary_expression] = STATE(11539),
    [sym_range_expression] = STATE(11539),
    [sym_splat_expression] = STATE(11539),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12384),
    [sym_unary_typed_expression] = STATE(11539),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11539),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11410),
    [sym_block_comment] = STATE(2814),
    [sym_line_comment] = STATE(2814),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2815] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(548),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2815),
    [sym_line_comment] = STATE(2815),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2816] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(550),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2816),
    [sym_line_comment] = STATE(2816),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2817] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(496),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2817),
    [sym_line_comment] = STATE(2817),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2818] = {
    [sym__closed_assignment] = STATE(17490),
    [sym__expression] = STATE(12537),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10402),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12554),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2818),
    [sym_line_comment] = STATE(2818),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2819] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15294),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2819),
    [sym_line_comment] = STATE(2819),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2820] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13570),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10673),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12921),
    [sym_unary_expression] = STATE(12921),
    [sym_range_expression] = STATE(12921),
    [sym_splat_expression] = STATE(12921),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12937),
    [sym_unary_typed_expression] = STATE(12921),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12921),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12555),
    [sym_block_comment] = STATE(2820),
    [sym_line_comment] = STATE(2820),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2821] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(18507),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2821),
    [sym_line_comment] = STATE(2821),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2822] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(520),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2822),
    [sym_line_comment] = STATE(2822),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2823] = {
    [sym__closed_assignment] = STATE(7289),
    [sym__expression] = STATE(8800),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4393),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(8461),
    [sym_unary_expression] = STATE(8461),
    [sym_range_expression] = STATE(8461),
    [sym_splat_expression] = STATE(8461),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7497),
    [sym_unary_typed_expression] = STATE(8461),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(8461),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(7503),
    [sym_block_comment] = STATE(2823),
    [sym_line_comment] = STATE(2823),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2824] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13136),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10560),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12762),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2824),
    [sym_line_comment] = STATE(2824),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2825] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(14206),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11116),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14000),
    [sym_unary_expression] = STATE(14000),
    [sym_range_expression] = STATE(14000),
    [sym_splat_expression] = STATE(14000),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13838),
    [sym_unary_typed_expression] = STATE(14000),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14000),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13839),
    [sym_block_comment] = STATE(2825),
    [sym_line_comment] = STATE(2825),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2826] = {
    [sym__closed_assignment] = STATE(8197),
    [sym__expression] = STATE(8755),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4436),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8175),
    [sym_unary_expression] = STATE(8175),
    [sym_range_expression] = STATE(8175),
    [sym_splat_expression] = STATE(8175),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7687),
    [sym_unary_typed_expression] = STATE(8175),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8175),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7609),
    [sym_block_comment] = STATE(2826),
    [sym_line_comment] = STATE(2826),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2827] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(563),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2827),
    [sym_line_comment] = STATE(2827),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2828] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15240),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2828),
    [sym_line_comment] = STATE(2828),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2829] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(565),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2829),
    [sym_line_comment] = STATE(2829),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2830] = {
    [sym__closed_assignment] = STATE(7341),
    [sym__expression] = STATE(8494),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4227),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7695),
    [sym_unary_expression] = STATE(7695),
    [sym_range_expression] = STATE(7695),
    [sym_splat_expression] = STATE(7695),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7105),
    [sym_unary_typed_expression] = STATE(7695),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7695),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(7106),
    [sym_block_comment] = STATE(2830),
    [sym_line_comment] = STATE(2830),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2831] = {
    [sym__closed_assignment] = STATE(8785),
    [sym__expression] = STATE(9037),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4745),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8831),
    [sym_unary_expression] = STATE(8831),
    [sym_range_expression] = STATE(8831),
    [sym_splat_expression] = STATE(8831),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8522),
    [sym_unary_typed_expression] = STATE(8831),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8831),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8520),
    [sym_block_comment] = STATE(2831),
    [sym_line_comment] = STATE(2831),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2832] = {
    [sym__closed_assignment] = STATE(8601),
    [sym__expression] = STATE(9270),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4915),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9120),
    [sym_unary_expression] = STATE(9120),
    [sym_range_expression] = STATE(9120),
    [sym_splat_expression] = STATE(9120),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8818),
    [sym_unary_typed_expression] = STATE(9120),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9120),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8819),
    [sym_block_comment] = STATE(2832),
    [sym_line_comment] = STATE(2832),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2833] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15149),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2833),
    [sym_line_comment] = STATE(2833),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2834] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15196),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2834),
    [sym_line_comment] = STATE(2834),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2835] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15214),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2835),
    [sym_line_comment] = STATE(2835),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2836] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15180),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2836),
    [sym_line_comment] = STATE(2836),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2837] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15113),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2837),
    [sym_line_comment] = STATE(2837),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2838] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15195),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2838),
    [sym_line_comment] = STATE(2838),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2839] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15247),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2839),
    [sym_line_comment] = STATE(2839),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2840] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15335),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2840),
    [sym_line_comment] = STATE(2840),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2841] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15123),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2841),
    [sym_line_comment] = STATE(2841),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2842] = {
    [sym__expression] = STATE(14242),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(15182),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10615),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2842),
    [sym_line_comment] = STATE(2842),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2843] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(566),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2843),
    [sym_line_comment] = STATE(2843),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2844] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13747),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2844),
    [sym_line_comment] = STATE(2844),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2845] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13393),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10533),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12886),
    [sym_unary_expression] = STATE(12886),
    [sym_range_expression] = STATE(12886),
    [sym_splat_expression] = STATE(12886),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12739),
    [sym_unary_typed_expression] = STATE(12886),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12886),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12743),
    [sym_block_comment] = STATE(2845),
    [sym_line_comment] = STATE(2845),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2846] = {
    [sym__closed_assignment] = STATE(9428),
    [sym__expression] = STATE(9270),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4978),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9031),
    [sym_unary_expression] = STATE(9031),
    [sym_range_expression] = STATE(9031),
    [sym_splat_expression] = STATE(9031),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8883),
    [sym_unary_typed_expression] = STATE(9031),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9031),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8884),
    [sym_block_comment] = STATE(2846),
    [sym_line_comment] = STATE(2846),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2847] = {
    [sym__closed_assignment] = STATE(7289),
    [sym__expression] = STATE(8491),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4227),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7695),
    [sym_unary_expression] = STATE(7695),
    [sym_range_expression] = STATE(7695),
    [sym_splat_expression] = STATE(7695),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7105),
    [sym_unary_typed_expression] = STATE(7695),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7695),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(7106),
    [sym_block_comment] = STATE(2847),
    [sym_line_comment] = STATE(2847),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2848] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(14173),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11116),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14000),
    [sym_unary_expression] = STATE(14000),
    [sym_range_expression] = STATE(14000),
    [sym_splat_expression] = STATE(14000),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13838),
    [sym_unary_typed_expression] = STATE(14000),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14000),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13839),
    [sym_block_comment] = STATE(2848),
    [sym_line_comment] = STATE(2848),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2849] = {
    [sym__closed_assignment] = STATE(8799),
    [sym__expression] = STATE(9032),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4745),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8831),
    [sym_unary_expression] = STATE(8831),
    [sym_range_expression] = STATE(8831),
    [sym_splat_expression] = STATE(8831),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8522),
    [sym_unary_typed_expression] = STATE(8831),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8831),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8520),
    [sym_block_comment] = STATE(2849),
    [sym_line_comment] = STATE(2849),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2850] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13792),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2850),
    [sym_line_comment] = STATE(2850),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2851] = {
    [sym__closed_assignment] = STATE(7939),
    [sym__expression] = STATE(9276),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4915),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(9120),
    [sym_unary_expression] = STATE(9120),
    [sym_range_expression] = STATE(9120),
    [sym_splat_expression] = STATE(9120),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8818),
    [sym_unary_typed_expression] = STATE(9120),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(9120),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(8819),
    [sym_block_comment] = STATE(2851),
    [sym_line_comment] = STATE(2851),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2852] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(14091),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10752),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13844),
    [sym_unary_expression] = STATE(13844),
    [sym_range_expression] = STATE(13844),
    [sym_splat_expression] = STATE(13844),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13231),
    [sym_unary_typed_expression] = STATE(13844),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13844),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13230),
    [sym_block_comment] = STATE(2852),
    [sym_line_comment] = STATE(2852),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2853] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(14049),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10752),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13844),
    [sym_unary_expression] = STATE(13844),
    [sym_range_expression] = STATE(13844),
    [sym_splat_expression] = STATE(13844),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13231),
    [sym_unary_typed_expression] = STATE(13844),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13844),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13230),
    [sym_block_comment] = STATE(2853),
    [sym_line_comment] = STATE(2853),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2854] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(12965),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10346),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12437),
    [sym_unary_expression] = STATE(12437),
    [sym_range_expression] = STATE(12437),
    [sym_splat_expression] = STATE(12437),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12249),
    [sym_unary_typed_expression] = STATE(12437),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12437),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12248),
    [sym_block_comment] = STATE(2854),
    [sym_line_comment] = STATE(2854),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2855] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12949),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10344),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12382),
    [sym_unary_expression] = STATE(12382),
    [sym_range_expression] = STATE(12382),
    [sym_splat_expression] = STATE(12382),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12247),
    [sym_unary_typed_expression] = STATE(12382),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12382),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12246),
    [sym_block_comment] = STATE(2855),
    [sym_line_comment] = STATE(2855),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2856] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12953),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10346),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12437),
    [sym_unary_expression] = STATE(12437),
    [sym_range_expression] = STATE(12437),
    [sym_splat_expression] = STATE(12437),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12249),
    [sym_unary_typed_expression] = STATE(12437),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12437),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12248),
    [sym_block_comment] = STATE(2856),
    [sym_line_comment] = STATE(2856),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2857] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12977),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10507),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12649),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2857),
    [sym_line_comment] = STATE(2857),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2858] = {
    [sym__closed_assignment] = STATE(17664),
    [sym__expression] = STATE(13743),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10571),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12990),
    [sym_unary_expression] = STATE(12990),
    [sym_range_expression] = STATE(12990),
    [sym_splat_expression] = STATE(12990),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13056),
    [sym_unary_typed_expression] = STATE(12990),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12990),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12407),
    [sym_block_comment] = STATE(2858),
    [sym_line_comment] = STATE(2858),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2859] = {
    [sym__closed_assignment] = STATE(7289),
    [sym__expression] = STATE(8515),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4486),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7726),
    [sym_unary_expression] = STATE(7726),
    [sym_range_expression] = STATE(7726),
    [sym_splat_expression] = STATE(7726),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7885),
    [sym_unary_typed_expression] = STATE(7726),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7726),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(7133),
    [sym_block_comment] = STATE(2859),
    [sym_line_comment] = STATE(2859),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2860] = {
    [sym__closed_assignment] = STATE(8799),
    [sym__expression] = STATE(9134),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5008),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8752),
    [sym_unary_expression] = STATE(8752),
    [sym_range_expression] = STATE(8752),
    [sym_splat_expression] = STATE(8752),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8910),
    [sym_unary_typed_expression] = STATE(8752),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8752),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8462),
    [sym_block_comment] = STATE(2860),
    [sym_line_comment] = STATE(2860),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2861] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13336),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10404),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13124),
    [sym_unary_expression] = STATE(13124),
    [sym_range_expression] = STATE(13124),
    [sym_splat_expression] = STATE(13124),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12594),
    [sym_unary_typed_expression] = STATE(13124),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13124),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12712),
    [sym_block_comment] = STATE(2861),
    [sym_line_comment] = STATE(2861),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2862] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13188),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10630),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13060),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2862),
    [sym_line_comment] = STATE(2862),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2863] = {
    [sym__closed_assignment] = STATE(7939),
    [sym__expression] = STATE(9136),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5007),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8445),
    [sym_unary_expression] = STATE(8445),
    [sym_range_expression] = STATE(8445),
    [sym_splat_expression] = STATE(8445),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8909),
    [sym_unary_typed_expression] = STATE(8445),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8445),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7387),
    [sym_block_comment] = STATE(2863),
    [sym_line_comment] = STATE(2863),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2864] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(13979),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11178),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13944),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2864),
    [sym_line_comment] = STATE(2864),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2865] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12979),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10514),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12669),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2865),
    [sym_line_comment] = STATE(2865),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2866] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12980),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10515),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12670),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2866),
    [sym_line_comment] = STATE(2866),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2867] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(12964),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10344),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12382),
    [sym_unary_expression] = STATE(12382),
    [sym_range_expression] = STATE(12382),
    [sym_splat_expression] = STATE(12382),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12247),
    [sym_unary_typed_expression] = STATE(12382),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12382),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12246),
    [sym_block_comment] = STATE(2867),
    [sym_line_comment] = STATE(2867),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2868] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12984),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10340),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12428),
    [sym_unary_expression] = STATE(12428),
    [sym_range_expression] = STATE(12428),
    [sym_splat_expression] = STATE(12428),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12245),
    [sym_unary_typed_expression] = STATE(12428),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12428),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12242),
    [sym_block_comment] = STATE(2868),
    [sym_line_comment] = STATE(2868),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2869] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(12985),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10340),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12428),
    [sym_unary_expression] = STATE(12428),
    [sym_range_expression] = STATE(12428),
    [sym_splat_expression] = STATE(12428),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12245),
    [sym_unary_typed_expression] = STATE(12428),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12428),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12242),
    [sym_block_comment] = STATE(2869),
    [sym_line_comment] = STATE(2869),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2870] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(14149),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11181),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(14025),
    [sym_unary_expression] = STATE(14025),
    [sym_range_expression] = STATE(14025),
    [sym_splat_expression] = STATE(14025),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13948),
    [sym_unary_typed_expression] = STATE(14025),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(14025),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13867),
    [sym_block_comment] = STATE(2870),
    [sym_line_comment] = STATE(2870),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2871] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(19000),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2871),
    [sym_line_comment] = STATE(2871),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2872] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(547),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2872),
    [sym_line_comment] = STATE(2872),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2873] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(12986),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10461),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10817),
    [sym_unary_expression] = STATE(10817),
    [sym_range_expression] = STATE(10817),
    [sym_splat_expression] = STATE(10817),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12498),
    [sym_unary_typed_expression] = STATE(10817),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10817),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10597),
    [sym_block_comment] = STATE(2873),
    [sym_line_comment] = STATE(2873),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2874] = {
    [sym__closed_assignment] = STATE(11485),
    [sym__expression] = STATE(12598),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10191),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(12265),
    [sym_unary_expression] = STATE(12265),
    [sym_range_expression] = STATE(12265),
    [sym_splat_expression] = STATE(12265),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11872),
    [sym_unary_typed_expression] = STATE(12265),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(12265),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11750),
    [sym_block_comment] = STATE(2874),
    [sym_line_comment] = STATE(2874),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2875] = {
    [sym__closed_assignment] = STATE(11563),
    [sym__expression] = STATE(12461),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10369),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11539),
    [sym_unary_expression] = STATE(11539),
    [sym_range_expression] = STATE(11539),
    [sym_splat_expression] = STATE(11539),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12251),
    [sym_unary_typed_expression] = STATE(11539),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11539),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11410),
    [sym_block_comment] = STATE(2875),
    [sym_line_comment] = STATE(2875),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2876] = {
    [sym__closed_assignment] = STATE(9195),
    [sym__expression] = STATE(9330),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5045),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9269),
    [sym_unary_expression] = STATE(9269),
    [sym_range_expression] = STATE(9269),
    [sym_splat_expression] = STATE(9269),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(8982),
    [sym_unary_typed_expression] = STATE(9269),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9269),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(8965),
    [sym_block_comment] = STATE(2876),
    [sym_line_comment] = STATE(2876),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2877] = {
    [sym__closed_assignment] = STATE(10834),
    [sym__expression] = STATE(14093),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10839),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13728),
    [sym_unary_expression] = STATE(13728),
    [sym_range_expression] = STATE(13728),
    [sym_splat_expression] = STATE(13728),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13186),
    [sym_unary_typed_expression] = STATE(13728),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13728),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13383),
    [sym_block_comment] = STATE(2877),
    [sym_line_comment] = STATE(2877),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2878] = {
    [sym__closed_assignment] = STATE(8447),
    [sym__expression] = STATE(9126),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4718),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8657),
    [sym_unary_expression] = STATE(8657),
    [sym_range_expression] = STATE(8657),
    [sym_splat_expression] = STATE(8657),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8092),
    [sym_unary_typed_expression] = STATE(8657),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8657),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8423),
    [sym_block_comment] = STATE(2878),
    [sym_line_comment] = STATE(2878),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2879] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(507),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2879),
    [sym_line_comment] = STATE(2879),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2880] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(508),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2880),
    [sym_line_comment] = STATE(2880),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2881] = {
    [sym__expression] = STATE(14241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_signature] = STATE(509),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11398),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(5586),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(9423),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(9029),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(9272),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(4856),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2881),
    [sym_line_comment] = STATE(2881),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(8856),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2882] = {
    [sym__closed_assignment] = STATE(8785),
    [sym__expression] = STATE(9167),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4964),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9055),
    [sym_unary_expression] = STATE(9055),
    [sym_range_expression] = STATE(9055),
    [sym_splat_expression] = STATE(9055),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8621),
    [sym_unary_typed_expression] = STATE(9055),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(9055),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8635),
    [sym_block_comment] = STATE(2882),
    [sym_line_comment] = STATE(2882),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2883] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(14030),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10839),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(13728),
    [sym_unary_expression] = STATE(13728),
    [sym_range_expression] = STATE(13728),
    [sym_splat_expression] = STATE(13728),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13186),
    [sym_unary_typed_expression] = STATE(13728),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(13728),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(13383),
    [sym_block_comment] = STATE(2883),
    [sym_line_comment] = STATE(2883),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2884] = {
    [sym__closed_assignment] = STATE(10833),
    [sym__expression] = STATE(13283),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10540),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12842),
    [sym_unary_expression] = STATE(12842),
    [sym_range_expression] = STATE(12842),
    [sym_splat_expression] = STATE(12842),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12633),
    [sym_unary_typed_expression] = STATE(12842),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(12842),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(12641),
    [sym_block_comment] = STATE(2884),
    [sym_line_comment] = STATE(2884),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2885] = {
    [sym__closed_assignment] = STATE(7802),
    [sym__expression] = STATE(8452),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4199),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7808),
    [sym_unary_expression] = STATE(7808),
    [sym_range_expression] = STATE(7808),
    [sym_splat_expression] = STATE(7808),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6892),
    [sym_unary_typed_expression] = STATE(7808),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7808),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(7176),
    [sym_block_comment] = STATE(2885),
    [sym_line_comment] = STATE(2885),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2886] = {
    [sym__expression] = STATE(14243),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(19470),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11310),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(7199),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(12830),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10759),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2886),
    [sym_line_comment] = STATE(2886),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(8860),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2887] = {
    [sym__expression] = STATE(14238),
    [sym_module_definition] = STATE(10824),
    [sym_type_head] = STATE(519),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(5155),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4084),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(9266),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(290),
    [sym_identifier] = STATE(4717),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(14237),
    [sym_block_comment] = STATE(2887),
    [sym_line_comment] = STATE(2887),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(8854),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2888] = {
    [sym__closed_assignment] = STATE(8122),
    [sym__expression] = STATE(9278),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4867),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(9114),
    [sym_unary_expression] = STATE(9114),
    [sym_range_expression] = STATE(9114),
    [sym_splat_expression] = STATE(9114),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8841),
    [sym_unary_typed_expression] = STATE(9114),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(9114),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(8751),
    [sym_block_comment] = STATE(2888),
    [sym_line_comment] = STATE(2888),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2889] = {
    [sym__expression] = STATE(12995),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2889),
    [sym_line_comment] = STATE(2889),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2890] = {
    [sym__expression] = STATE(12472),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2890),
    [sym_line_comment] = STATE(2890),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2891] = {
    [sym__expression] = STATE(12058),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2891),
    [sym_line_comment] = STATE(2891),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2892] = {
    [sym__expression] = STATE(12353),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2892),
    [sym_line_comment] = STATE(2892),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2893] = {
    [sym__expression] = STATE(12355),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2893),
    [sym_line_comment] = STATE(2893),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2894] = {
    [sym__expression] = STATE(12356),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2894),
    [sym_line_comment] = STATE(2894),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2895] = {
    [sym__expression] = STATE(12357),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2895),
    [sym_line_comment] = STATE(2895),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2896] = {
    [sym__expression] = STATE(12365),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2896),
    [sym_line_comment] = STATE(2896),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2897] = {
    [sym__expression] = STATE(12366),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2897),
    [sym_line_comment] = STATE(2897),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2898] = {
    [sym__expression] = STATE(12370),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2898),
    [sym_line_comment] = STATE(2898),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2899] = {
    [sym__expression] = STATE(12372),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2899),
    [sym_line_comment] = STATE(2899),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2900] = {
    [sym__expression] = STATE(12374),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2900),
    [sym_line_comment] = STATE(2900),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2901] = {
    [sym__expression] = STATE(12375),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2901),
    [sym_line_comment] = STATE(2901),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2902] = {
    [sym__expression] = STATE(12376),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2902),
    [sym_line_comment] = STATE(2902),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2903] = {
    [sym__expression] = STATE(12377),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2903),
    [sym_line_comment] = STATE(2903),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2904] = {
    [sym__expression] = STATE(12378),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2904),
    [sym_line_comment] = STATE(2904),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2905] = {
    [sym__expression] = STATE(12295),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2905),
    [sym_line_comment] = STATE(2905),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2906] = {
    [sym__expression] = STATE(12759),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2906),
    [sym_line_comment] = STATE(2906),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2907] = {
    [sym__expression] = STATE(13991),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2907),
    [sym_line_comment] = STATE(2907),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2908] = {
    [sym__expression] = STATE(14046),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2908),
    [sym_line_comment] = STATE(2908),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2909] = {
    [sym__expression] = STATE(13351),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2909),
    [sym_line_comment] = STATE(2909),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2910] = {
    [sym__expression] = STATE(14053),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2910),
    [sym_line_comment] = STATE(2910),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2911] = {
    [sym__expression] = STATE(14054),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2911),
    [sym_line_comment] = STATE(2911),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2912] = {
    [sym__expression] = STATE(14055),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2912),
    [sym_line_comment] = STATE(2912),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2913] = {
    [sym__expression] = STATE(14067),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2913),
    [sym_line_comment] = STATE(2913),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2914] = {
    [sym__expression] = STATE(14070),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2914),
    [sym_line_comment] = STATE(2914),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2915] = {
    [sym__expression] = STATE(14071),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2915),
    [sym_line_comment] = STATE(2915),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2916] = {
    [sym__expression] = STATE(14072),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2916),
    [sym_line_comment] = STATE(2916),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2917] = {
    [sym__expression] = STATE(14073),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2917),
    [sym_line_comment] = STATE(2917),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2918] = {
    [sym__expression] = STATE(14074),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2918),
    [sym_line_comment] = STATE(2918),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2919] = {
    [sym__expression] = STATE(14075),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2919),
    [sym_line_comment] = STATE(2919),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2920] = {
    [sym__expression] = STATE(14076),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2920),
    [sym_line_comment] = STATE(2920),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2921] = {
    [sym__expression] = STATE(14077),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2921),
    [sym_line_comment] = STATE(2921),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2922] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2922),
    [sym_line_comment] = STATE(2922),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2923] = {
    [sym__expression] = STATE(12415),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2923),
    [sym_line_comment] = STATE(2923),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2924] = {
    [sym__expression] = STATE(14186),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2924),
    [sym_line_comment] = STATE(2924),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2925] = {
    [sym__expression] = STATE(9172),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2925),
    [sym_line_comment] = STATE(2925),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2926] = {
    [sym__expression] = STATE(14133),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2926),
    [sym_line_comment] = STATE(2926),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2927] = {
    [sym__expression] = STATE(9174),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2927),
    [sym_line_comment] = STATE(2927),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2928] = {
    [sym__expression] = STATE(9179),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2928),
    [sym_line_comment] = STATE(2928),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2929] = {
    [sym__expression] = STATE(8190),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2929),
    [sym_line_comment] = STATE(2929),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2930] = {
    [sym__expression] = STATE(12411),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2930),
    [sym_line_comment] = STATE(2930),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2931] = {
    [sym__expression] = STATE(12097),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2931),
    [sym_line_comment] = STATE(2931),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2932] = {
    [sym__expression] = STATE(12642),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2932),
    [sym_line_comment] = STATE(2932),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2933] = {
    [sym__expression] = STATE(12120),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2933),
    [sym_line_comment] = STATE(2933),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2934] = {
    [sym__expression] = STATE(12127),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2934),
    [sym_line_comment] = STATE(2934),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2935] = {
    [sym__expression] = STATE(12130),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2935),
    [sym_line_comment] = STATE(2935),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2936] = {
    [sym__expression] = STATE(12134),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2936),
    [sym_line_comment] = STATE(2936),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2937] = {
    [sym__expression] = STATE(12135),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2937),
    [sym_line_comment] = STATE(2937),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2938] = {
    [sym__expression] = STATE(12137),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2938),
    [sym_line_comment] = STATE(2938),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2939] = {
    [sym__expression] = STATE(12143),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2939),
    [sym_line_comment] = STATE(2939),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2940] = {
    [sym__expression] = STATE(12145),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2940),
    [sym_line_comment] = STATE(2940),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2941] = {
    [sym__expression] = STATE(12146),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2941),
    [sym_line_comment] = STATE(2941),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2942] = {
    [sym__expression] = STATE(12147),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2942),
    [sym_line_comment] = STATE(2942),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2943] = {
    [sym__expression] = STATE(12148),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2943),
    [sym_line_comment] = STATE(2943),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2944] = {
    [sym__expression] = STATE(12149),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(2944),
    [sym_line_comment] = STATE(2944),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2945] = {
    [sym__expression] = STATE(12887),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2945),
    [sym_line_comment] = STATE(2945),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2946] = {
    [sym__expression] = STATE(9180),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2946),
    [sym_line_comment] = STATE(2946),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2947] = {
    [sym__expression] = STATE(9181),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2947),
    [sym_line_comment] = STATE(2947),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2948] = {
    [sym__expression] = STATE(9182),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2948),
    [sym_line_comment] = STATE(2948),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2949] = {
    [sym__expression] = STATE(9197),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2949),
    [sym_line_comment] = STATE(2949),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2950] = {
    [sym__expression] = STATE(9199),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2950),
    [sym_line_comment] = STATE(2950),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2951] = {
    [sym__expression] = STATE(9217),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2951),
    [sym_line_comment] = STATE(2951),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2952] = {
    [sym__expression] = STATE(9218),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2952),
    [sym_line_comment] = STATE(2952),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2953] = {
    [sym__expression] = STATE(9220),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2953),
    [sym_line_comment] = STATE(2953),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2954] = {
    [sym__expression] = STATE(9221),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2954),
    [sym_line_comment] = STATE(2954),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2955] = {
    [sym__expression] = STATE(12933),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2955),
    [sym_line_comment] = STATE(2955),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2956] = {
    [sym__expression] = STATE(8376),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2956),
    [sym_line_comment] = STATE(2956),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2957] = {
    [sym__expression] = STATE(12431),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2957),
    [sym_line_comment] = STATE(2957),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2958] = {
    [sym__expression] = STATE(8483),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2958),
    [sym_line_comment] = STATE(2958),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2959] = {
    [sym__expression] = STATE(12436),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2959),
    [sym_line_comment] = STATE(2959),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2960] = {
    [sym__expression] = STATE(12443),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2960),
    [sym_line_comment] = STATE(2960),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2961] = {
    [sym__expression] = STATE(12444),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2961),
    [sym_line_comment] = STATE(2961),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2962] = {
    [sym__expression] = STATE(12449),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2962),
    [sym_line_comment] = STATE(2962),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2963] = {
    [sym__expression] = STATE(12453),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2963),
    [sym_line_comment] = STATE(2963),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2964] = {
    [sym__expression] = STATE(12455),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2964),
    [sym_line_comment] = STATE(2964),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2965] = {
    [sym__expression] = STATE(12457),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2965),
    [sym_line_comment] = STATE(2965),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2966] = {
    [sym__expression] = STATE(12459),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2966),
    [sym_line_comment] = STATE(2966),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2967] = {
    [sym__expression] = STATE(12460),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2967),
    [sym_line_comment] = STATE(2967),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2968] = {
    [sym__expression] = STATE(12474),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2968),
    [sym_line_comment] = STATE(2968),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2969] = {
    [sym__expression] = STATE(12477),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2969),
    [sym_line_comment] = STATE(2969),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2970] = {
    [sym__expression] = STATE(12563),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2970),
    [sym_line_comment] = STATE(2970),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2971] = {
    [sym__expression] = STATE(8771),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2971),
    [sym_line_comment] = STATE(2971),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2972] = {
    [sym__expression] = STATE(8628),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(2972),
    [sym_line_comment] = STATE(2972),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2973] = {
    [sym__expression] = STATE(14191),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(2973),
    [sym_line_comment] = STATE(2973),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2974] = {
    [sym__expression] = STATE(12875),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2974),
    [sym_line_comment] = STATE(2974),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2975] = {
    [sym__expression] = STATE(9141),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(2975),
    [sym_line_comment] = STATE(2975),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2976] = {
    [sym__expression] = STATE(9023),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(2976),
    [sym_line_comment] = STATE(2976),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2977] = {
    [sym__expression] = STATE(8525),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2977),
    [sym_line_comment] = STATE(2977),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2978] = {
    [sym__expression] = STATE(8957),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(2978),
    [sym_line_comment] = STATE(2978),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2979] = {
    [sym__expression] = STATE(8526),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2979),
    [sym_line_comment] = STATE(2979),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2980] = {
    [sym__expression] = STATE(8527),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2980),
    [sym_line_comment] = STATE(2980),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2981] = {
    [sym__expression] = STATE(8528),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2981),
    [sym_line_comment] = STATE(2981),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2982] = {
    [sym__expression] = STATE(8529),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2982),
    [sym_line_comment] = STATE(2982),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2983] = {
    [sym__expression] = STATE(8530),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2983),
    [sym_line_comment] = STATE(2983),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2984] = {
    [sym__expression] = STATE(8531),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2984),
    [sym_line_comment] = STATE(2984),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2985] = {
    [sym__expression] = STATE(8532),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2985),
    [sym_line_comment] = STATE(2985),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2986] = {
    [sym__expression] = STATE(8533),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2986),
    [sym_line_comment] = STATE(2986),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2987] = {
    [sym__expression] = STATE(8534),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2987),
    [sym_line_comment] = STATE(2987),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2988] = {
    [sym__expression] = STATE(8535),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2988),
    [sym_line_comment] = STATE(2988),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2989] = {
    [sym__expression] = STATE(8536),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2989),
    [sym_line_comment] = STATE(2989),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2990] = {
    [sym__expression] = STATE(8311),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(2990),
    [sym_line_comment] = STATE(2990),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2991] = {
    [sym__expression] = STATE(9277),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(2991),
    [sym_line_comment] = STATE(2991),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2992] = {
    [sym__expression] = STATE(12876),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2992),
    [sym_line_comment] = STATE(2992),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2993] = {
    [sym__expression] = STATE(12890),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2993),
    [sym_line_comment] = STATE(2993),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2994] = {
    [sym__expression] = STATE(12891),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2994),
    [sym_line_comment] = STATE(2994),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2995] = {
    [sym__expression] = STATE(12892),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2995),
    [sym_line_comment] = STATE(2995),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2996] = {
    [sym__expression] = STATE(12893),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2996),
    [sym_line_comment] = STATE(2996),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2997] = {
    [sym__expression] = STATE(12894),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2997),
    [sym_line_comment] = STATE(2997),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2998] = {
    [sym__expression] = STATE(12895),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(2998),
    [sym_line_comment] = STATE(2998),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [2999] = {
    [sym__expression] = STATE(7417),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(2999),
    [sym_line_comment] = STATE(2999),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3000] = {
    [sym__expression] = STATE(7418),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3000),
    [sym_line_comment] = STATE(3000),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3001] = {
    [sym__expression] = STATE(9070),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3001),
    [sym_line_comment] = STATE(3001),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3002] = {
    [sym__expression] = STATE(7757),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3002),
    [sym_line_comment] = STATE(3002),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3003] = {
    [sym__expression] = STATE(9072),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3003),
    [sym_line_comment] = STATE(3003),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3004] = {
    [sym__expression] = STATE(9073),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3004),
    [sym_line_comment] = STATE(3004),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3005] = {
    [sym__expression] = STATE(9074),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3005),
    [sym_line_comment] = STATE(3005),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3006] = {
    [sym__expression] = STATE(9075),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3006),
    [sym_line_comment] = STATE(3006),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3007] = {
    [sym__expression] = STATE(9076),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3007),
    [sym_line_comment] = STATE(3007),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3008] = {
    [sym__expression] = STATE(9077),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3008),
    [sym_line_comment] = STATE(3008),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3009] = {
    [sym__expression] = STATE(9078),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3009),
    [sym_line_comment] = STATE(3009),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3010] = {
    [sym__expression] = STATE(9080),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3010),
    [sym_line_comment] = STATE(3010),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3011] = {
    [sym__expression] = STATE(9081),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3011),
    [sym_line_comment] = STATE(3011),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3012] = {
    [sym__expression] = STATE(9082),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3012),
    [sym_line_comment] = STATE(3012),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3013] = {
    [sym__expression] = STATE(9083),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3013),
    [sym_line_comment] = STATE(3013),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3014] = {
    [sym__expression] = STATE(8121),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3014),
    [sym_line_comment] = STATE(3014),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3015] = {
    [sym__expression] = STATE(8583),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3015),
    [sym_line_comment] = STATE(3015),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3016] = {
    [sym__expression] = STATE(12897),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3016),
    [sym_line_comment] = STATE(3016),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3017] = {
    [sym__expression] = STATE(12898),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3017),
    [sym_line_comment] = STATE(3017),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3018] = {
    [sym__expression] = STATE(12899),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3018),
    [sym_line_comment] = STATE(3018),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3019] = {
    [sym__expression] = STATE(12900),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3019),
    [sym_line_comment] = STATE(3019),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3020] = {
    [sym__expression] = STATE(8481),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3020),
    [sym_line_comment] = STATE(3020),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3021] = {
    [sym__expression] = STATE(8482),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3021),
    [sym_line_comment] = STATE(3021),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3022] = {
    [sym__expression] = STATE(7824),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3022),
    [sym_line_comment] = STATE(3022),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3023] = {
    [sym__expression] = STATE(7957),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3023),
    [sym_line_comment] = STATE(3023),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3024] = {
    [sym__expression] = STATE(7825),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3024),
    [sym_line_comment] = STATE(3024),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3025] = {
    [sym__expression] = STATE(7826),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3025),
    [sym_line_comment] = STATE(3025),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3026] = {
    [sym__expression] = STATE(7827),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3026),
    [sym_line_comment] = STATE(3026),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3027] = {
    [sym__expression] = STATE(7828),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3027),
    [sym_line_comment] = STATE(3027),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3028] = {
    [sym__expression] = STATE(7829),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3028),
    [sym_line_comment] = STATE(3028),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3029] = {
    [sym__expression] = STATE(7831),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3029),
    [sym_line_comment] = STATE(3029),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3030] = {
    [sym__expression] = STATE(7832),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3030),
    [sym_line_comment] = STATE(3030),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3031] = {
    [sym__expression] = STATE(7833),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3031),
    [sym_line_comment] = STATE(3031),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3032] = {
    [sym__expression] = STATE(7834),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3032),
    [sym_line_comment] = STATE(3032),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3033] = {
    [sym__expression] = STATE(7835),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3033),
    [sym_line_comment] = STATE(3033),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3034] = {
    [sym__expression] = STATE(7836),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3034),
    [sym_line_comment] = STATE(3034),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3035] = {
    [sym__expression] = STATE(7842),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3035),
    [sym_line_comment] = STATE(3035),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3036] = {
    [sym__expression] = STATE(8782),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3036),
    [sym_line_comment] = STATE(3036),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3037] = {
    [sym__expression] = STATE(12901),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3037),
    [sym_line_comment] = STATE(3037),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3038] = {
    [sym__expression] = STATE(12905),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3038),
    [sym_line_comment] = STATE(3038),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3039] = {
    [sym__expression] = STATE(12735),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3039),
    [sym_line_comment] = STATE(3039),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3040] = {
    [sym__expression] = STATE(12528),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3040),
    [sym_line_comment] = STATE(3040),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3041] = {
    [sym__expression] = STATE(8000),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3041),
    [sym_line_comment] = STATE(3041),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3042] = {
    [sym__expression] = STATE(12509),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3042),
    [sym_line_comment] = STATE(3042),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3043] = {
    [sym__expression] = STATE(8001),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3043),
    [sym_line_comment] = STATE(3043),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3044] = {
    [sym__expression] = STATE(8002),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3044),
    [sym_line_comment] = STATE(3044),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3045] = {
    [sym__expression] = STATE(8003),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3045),
    [sym_line_comment] = STATE(3045),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3046] = {
    [sym__expression] = STATE(8004),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3046),
    [sym_line_comment] = STATE(3046),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3047] = {
    [sym__expression] = STATE(8005),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3047),
    [sym_line_comment] = STATE(3047),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3048] = {
    [sym__expression] = STATE(8006),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3048),
    [sym_line_comment] = STATE(3048),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3049] = {
    [sym__expression] = STATE(8007),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3049),
    [sym_line_comment] = STATE(3049),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3050] = {
    [sym__expression] = STATE(8008),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3050),
    [sym_line_comment] = STATE(3050),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3051] = {
    [sym__expression] = STATE(8009),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3051),
    [sym_line_comment] = STATE(3051),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3052] = {
    [sym__expression] = STATE(8010),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3052),
    [sym_line_comment] = STATE(3052),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3053] = {
    [sym__expression] = STATE(8011),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3053),
    [sym_line_comment] = STATE(3053),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3054] = {
    [sym__expression] = STATE(7958),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3054),
    [sym_line_comment] = STATE(3054),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3055] = {
    [sym__expression] = STATE(13121),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3055),
    [sym_line_comment] = STATE(3055),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3056] = {
    [sym__expression] = STATE(12906),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3056),
    [sym_line_comment] = STATE(3056),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3057] = {
    [sym__expression] = STATE(12907),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3057),
    [sym_line_comment] = STATE(3057),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3058] = {
    [sym__expression] = STATE(12926),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3058),
    [sym_line_comment] = STATE(3058),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3059] = {
    [sym__expression] = STATE(8658),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3059),
    [sym_line_comment] = STATE(3059),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3060] = {
    [sym__expression] = STATE(8523),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3060),
    [sym_line_comment] = STATE(3060),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3061] = {
    [sym__expression] = STATE(13672),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3061),
    [sym_line_comment] = STATE(3061),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3062] = {
    [sym__expression] = STATE(12618),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3062),
    [sym_line_comment] = STATE(3062),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3063] = {
    [sym__expression] = STATE(13852),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3063),
    [sym_line_comment] = STATE(3063),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3064] = {
    [sym__expression] = STATE(12620),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3064),
    [sym_line_comment] = STATE(3064),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3065] = {
    [sym__expression] = STATE(12558),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3065),
    [sym_line_comment] = STATE(3065),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3066] = {
    [sym__expression] = STATE(12448),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3066),
    [sym_line_comment] = STATE(3066),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3067] = {
    [sym__expression] = STATE(12485),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3067),
    [sym_line_comment] = STATE(3067),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3068] = {
    [sym__expression] = STATE(12520),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3068),
    [sym_line_comment] = STATE(3068),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3069] = {
    [sym__expression] = STATE(12731),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3069),
    [sym_line_comment] = STATE(3069),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3070] = {
    [sym__expression] = STATE(12416),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3070),
    [sym_line_comment] = STATE(3070),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3071] = {
    [sym__expression] = STATE(12429),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3071),
    [sym_line_comment] = STATE(3071),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3072] = {
    [sym__expression] = STATE(12432),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3072),
    [sym_line_comment] = STATE(3072),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3073] = {
    [sym__expression] = STATE(12440),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3073),
    [sym_line_comment] = STATE(3073),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3074] = {
    [sym__expression] = STATE(12458),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3074),
    [sym_line_comment] = STATE(3074),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3075] = {
    [sym__expression] = STATE(12580),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3075),
    [sym_line_comment] = STATE(3075),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3076] = {
    [sym__expression] = STATE(13906),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3076),
    [sym_line_comment] = STATE(3076),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3077] = {
    [sym__expression] = STATE(14209),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3077),
    [sym_line_comment] = STATE(3077),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3078] = {
    [sym__expression] = STATE(9295),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3078),
    [sym_line_comment] = STATE(3078),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3079] = {
    [sym__expression] = STATE(14210),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3079),
    [sym_line_comment] = STATE(3079),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3080] = {
    [sym__expression] = STATE(14213),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3080),
    [sym_line_comment] = STATE(3080),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3081] = {
    [sym__expression] = STATE(14218),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3081),
    [sym_line_comment] = STATE(3081),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3082] = {
    [sym__expression] = STATE(14107),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3082),
    [sym_line_comment] = STATE(3082),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3083] = {
    [sym__expression] = STATE(14108),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3083),
    [sym_line_comment] = STATE(3083),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3084] = {
    [sym__expression] = STATE(14109),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3084),
    [sym_line_comment] = STATE(3084),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3085] = {
    [sym__expression] = STATE(14111),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3085),
    [sym_line_comment] = STATE(3085),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3086] = {
    [sym__expression] = STATE(13171),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3086),
    [sym_line_comment] = STATE(3086),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3087] = {
    [sym__expression] = STATE(14160),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3087),
    [sym_line_comment] = STATE(3087),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3088] = {
    [sym__expression] = STATE(13641),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3088),
    [sym_line_comment] = STATE(3088),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3089] = {
    [sym__expression] = STATE(14207),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3089),
    [sym_line_comment] = STATE(3089),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3090] = {
    [sym__expression] = STATE(13650),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3090),
    [sym_line_comment] = STATE(3090),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3091] = {
    [sym__expression] = STATE(13652),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3091),
    [sym_line_comment] = STATE(3091),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3092] = {
    [sym__expression] = STATE(13653),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3092),
    [sym_line_comment] = STATE(3092),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3093] = {
    [sym__expression] = STATE(13654),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3093),
    [sym_line_comment] = STATE(3093),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3094] = {
    [sym__expression] = STATE(13655),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3094),
    [sym_line_comment] = STATE(3094),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3095] = {
    [sym__expression] = STATE(13657),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3095),
    [sym_line_comment] = STATE(3095),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3096] = {
    [sym__expression] = STATE(13659),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3096),
    [sym_line_comment] = STATE(3096),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3097] = {
    [sym__expression] = STATE(13667),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3097),
    [sym_line_comment] = STATE(3097),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3098] = {
    [sym__expression] = STATE(13668),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3098),
    [sym_line_comment] = STATE(3098),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3099] = {
    [sym__expression] = STATE(13669),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3099),
    [sym_line_comment] = STATE(3099),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3100] = {
    [sym__expression] = STATE(13673),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3100),
    [sym_line_comment] = STATE(3100),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3101] = {
    [sym__expression] = STATE(12989),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3101),
    [sym_line_comment] = STATE(3101),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3102] = {
    [sym__expression] = STATE(14170),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3102),
    [sym_line_comment] = STATE(3102),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3103] = {
    [sym__expression] = STATE(14112),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3103),
    [sym_line_comment] = STATE(3103),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3104] = {
    [sym__expression] = STATE(14122),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3104),
    [sym_line_comment] = STATE(3104),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3105] = {
    [sym__expression] = STATE(14123),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3105),
    [sym_line_comment] = STATE(3105),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3106] = {
    [sym__expression] = STATE(14131),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3106),
    [sym_line_comment] = STATE(3106),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3107] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3107),
    [sym_line_comment] = STATE(3107),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3108] = {
    [sym__expression] = STATE(8757),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3108),
    [sym_line_comment] = STATE(3108),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3109] = {
    [sym__expression] = STATE(12908),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3109),
    [sym_line_comment] = STATE(3109),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3110] = {
    [sym__expression] = STATE(12988),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3110),
    [sym_line_comment] = STATE(3110),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3111] = {
    [sym__expression] = STATE(13727),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3111),
    [sym_line_comment] = STATE(3111),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3112] = {
    [sym__expression] = STATE(8524),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3112),
    [sym_line_comment] = STATE(3112),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3113] = {
    [sym__expression] = STATE(8130),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3113),
    [sym_line_comment] = STATE(3113),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3114] = {
    [sym__expression] = STATE(8131),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3114),
    [sym_line_comment] = STATE(3114),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3115] = {
    [sym__expression] = STATE(8132),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3115),
    [sym_line_comment] = STATE(3115),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3116] = {
    [sym__expression] = STATE(8133),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3116),
    [sym_line_comment] = STATE(3116),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3117] = {
    [sym__expression] = STATE(8134),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3117),
    [sym_line_comment] = STATE(3117),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3118] = {
    [sym__expression] = STATE(8135),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3118),
    [sym_line_comment] = STATE(3118),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3119] = {
    [sym__expression] = STATE(8136),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3119),
    [sym_line_comment] = STATE(3119),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3120] = {
    [sym__expression] = STATE(8137),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3120),
    [sym_line_comment] = STATE(3120),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3121] = {
    [sym__expression] = STATE(8138),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3121),
    [sym_line_comment] = STATE(3121),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3122] = {
    [sym__expression] = STATE(8139),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3122),
    [sym_line_comment] = STATE(3122),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3123] = {
    [sym__expression] = STATE(8140),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3123),
    [sym_line_comment] = STATE(3123),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3124] = {
    [sym__expression] = STATE(8141),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3124),
    [sym_line_comment] = STATE(3124),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3125] = {
    [sym__expression] = STATE(8142),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3125),
    [sym_line_comment] = STATE(3125),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3126] = {
    [sym__expression] = STATE(8194),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3126),
    [sym_line_comment] = STATE(3126),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3127] = {
    [sym__expression] = STATE(8754),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3127),
    [sym_line_comment] = STATE(3127),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3128] = {
    [sym__expression] = STATE(13198),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3128),
    [sym_line_comment] = STATE(3128),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3129] = {
    [sym__expression] = STATE(12877),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3129),
    [sym_line_comment] = STATE(3129),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3130] = {
    [sym__expression] = STATE(9216),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3130),
    [sym_line_comment] = STATE(3130),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3131] = {
    [sym__expression] = STATE(13241),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3131),
    [sym_line_comment] = STATE(3131),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3132] = {
    [sym__expression] = STATE(13286),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3132),
    [sym_line_comment] = STATE(3132),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3133] = {
    [sym__expression] = STATE(13289),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3133),
    [sym_line_comment] = STATE(3133),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3134] = {
    [sym__expression] = STATE(13290),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3134),
    [sym_line_comment] = STATE(3134),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3135] = {
    [sym__expression] = STATE(13343),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3135),
    [sym_line_comment] = STATE(3135),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3136] = {
    [sym__expression] = STATE(13345),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3136),
    [sym_line_comment] = STATE(3136),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3137] = {
    [sym__expression] = STATE(13346),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3137),
    [sym_line_comment] = STATE(3137),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3138] = {
    [sym__expression] = STATE(13350),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3138),
    [sym_line_comment] = STATE(3138),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3139] = {
    [sym__expression] = STATE(13352),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3139),
    [sym_line_comment] = STATE(3139),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3140] = {
    [sym__expression] = STATE(13357),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3140),
    [sym_line_comment] = STATE(3140),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3141] = {
    [sym__expression] = STATE(13366),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3141),
    [sym_line_comment] = STATE(3141),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3142] = {
    [sym__expression] = STATE(13380),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3142),
    [sym_line_comment] = STATE(3142),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3143] = {
    [sym__expression] = STATE(13382),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3143),
    [sym_line_comment] = STATE(3143),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3144] = {
    [sym__expression] = STATE(13386),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3144),
    [sym_line_comment] = STATE(3144),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3145] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3145),
    [sym_line_comment] = STATE(3145),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3146] = {
    [sym__expression] = STATE(13498),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3146),
    [sym_line_comment] = STATE(3146),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3147] = {
    [sym__expression] = STATE(12878),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3147),
    [sym_line_comment] = STATE(3147),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3148] = {
    [sym__expression] = STATE(13151),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3148),
    [sym_line_comment] = STATE(3148),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3149] = {
    [sym__expression] = STATE(13338),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3149),
    [sym_line_comment] = STATE(3149),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3150] = {
    [sym__expression] = STATE(13200),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3150),
    [sym_line_comment] = STATE(3150),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3151] = {
    [sym__expression] = STATE(13202),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3151),
    [sym_line_comment] = STATE(3151),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3152] = {
    [sym__expression] = STATE(13372),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3152),
    [sym_line_comment] = STATE(3152),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3153] = {
    [sym__expression] = STATE(13373),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3153),
    [sym_line_comment] = STATE(3153),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3154] = {
    [sym__expression] = STATE(13216),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3154),
    [sym_line_comment] = STATE(3154),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3155] = {
    [sym__expression] = STATE(13217),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3155),
    [sym_line_comment] = STATE(3155),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3156] = {
    [sym__expression] = STATE(13376),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3156),
    [sym_line_comment] = STATE(3156),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3157] = {
    [sym__expression] = STATE(13377),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3157),
    [sym_line_comment] = STATE(3157),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3158] = {
    [sym__expression] = STATE(13249),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3158),
    [sym_line_comment] = STATE(3158),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3159] = {
    [sym__expression] = STATE(13256),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3159),
    [sym_line_comment] = STATE(3159),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3160] = {
    [sym__expression] = STATE(13257),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3160),
    [sym_line_comment] = STATE(3160),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3161] = {
    [sym__expression] = STATE(13258),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3161),
    [sym_line_comment] = STATE(3161),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3162] = {
    [sym__expression] = STATE(13260),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3162),
    [sym_line_comment] = STATE(3162),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3163] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3163),
    [sym_line_comment] = STATE(3163),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3164] = {
    [sym__expression] = STATE(13262),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3164),
    [sym_line_comment] = STATE(3164),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3165] = {
    [sym__expression] = STATE(12599),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3165),
    [sym_line_comment] = STATE(3165),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3166] = {
    [sym__expression] = STATE(13333),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3166),
    [sym_line_comment] = STATE(3166),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3167] = {
    [sym__expression] = STATE(13368),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3167),
    [sym_line_comment] = STATE(3167),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3168] = {
    [sym__expression] = STATE(13371),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3168),
    [sym_line_comment] = STATE(3168),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3169] = {
    [sym__expression] = STATE(9311),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3169),
    [sym_line_comment] = STATE(3169),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3170] = {
    [sym__expression] = STATE(9312),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3170),
    [sym_line_comment] = STATE(3170),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3171] = {
    [sym__expression] = STATE(13374),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3171),
    [sym_line_comment] = STATE(3171),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3172] = {
    [sym__expression] = STATE(13375),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3172),
    [sym_line_comment] = STATE(3172),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3173] = {
    [sym__expression] = STATE(9315),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3173),
    [sym_line_comment] = STATE(3173),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3174] = {
    [sym__expression] = STATE(9316),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3174),
    [sym_line_comment] = STATE(3174),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3175] = {
    [sym__expression] = STATE(9286),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3175),
    [sym_line_comment] = STATE(3175),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3176] = {
    [sym__expression] = STATE(9287),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3176),
    [sym_line_comment] = STATE(3176),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3177] = {
    [sym__expression] = STATE(9288),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3177),
    [sym_line_comment] = STATE(3177),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3178] = {
    [sym__expression] = STATE(9289),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3178),
    [sym_line_comment] = STATE(3178),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3179] = {
    [sym__expression] = STATE(9290),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3179),
    [sym_line_comment] = STATE(3179),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3180] = {
    [sym__expression] = STATE(9194),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3180),
    [sym_line_comment] = STATE(3180),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3181] = {
    [sym__expression] = STATE(13384),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3181),
    [sym_line_comment] = STATE(3181),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3182] = {
    [sym__expression] = STATE(12531),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3182),
    [sym_line_comment] = STATE(3182),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3183] = {
    [sym__expression] = STATE(9294),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3183),
    [sym_line_comment] = STATE(3183),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3184] = {
    [sym__expression] = STATE(9309),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3184),
    [sym_line_comment] = STATE(3184),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3185] = {
    [sym__expression] = STATE(9310),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3185),
    [sym_line_comment] = STATE(3185),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3186] = {
    [sym__expression] = STATE(9313),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3186),
    [sym_line_comment] = STATE(3186),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3187] = {
    [sym__expression] = STATE(9314),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3187),
    [sym_line_comment] = STATE(3187),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3188] = {
    [sym__expression] = STATE(9318),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3188),
    [sym_line_comment] = STATE(3188),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3189] = {
    [sym__expression] = STATE(12880),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3189),
    [sym_line_comment] = STATE(3189),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3190] = {
    [sym__expression] = STATE(13394),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3190),
    [sym_line_comment] = STATE(3190),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3191] = {
    [sym__expression] = STATE(13398),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3191),
    [sym_line_comment] = STATE(3191),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3192] = {
    [sym__expression] = STATE(13401),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3192),
    [sym_line_comment] = STATE(3192),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3193] = {
    [sym__expression] = STATE(13405),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3193),
    [sym_line_comment] = STATE(3193),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3194] = {
    [sym__expression] = STATE(13406),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3194),
    [sym_line_comment] = STATE(3194),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3195] = {
    [sym__expression] = STATE(13410),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3195),
    [sym_line_comment] = STATE(3195),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3196] = {
    [sym__expression] = STATE(13419),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3196),
    [sym_line_comment] = STATE(3196),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3197] = {
    [sym__expression] = STATE(13421),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3197),
    [sym_line_comment] = STATE(3197),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3198] = {
    [sym__expression] = STATE(13422),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3198),
    [sym_line_comment] = STATE(3198),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3199] = {
    [sym__expression] = STATE(13426),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3199),
    [sym_line_comment] = STATE(3199),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3200] = {
    [sym__expression] = STATE(13295),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3200),
    [sym_line_comment] = STATE(3200),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3201] = {
    [sym__expression] = STATE(13128),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3201),
    [sym_line_comment] = STATE(3201),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3202] = {
    [sym__expression] = STATE(13129),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3202),
    [sym_line_comment] = STATE(3202),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3203] = {
    [sym__expression] = STATE(13130),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3203),
    [sym_line_comment] = STATE(3203),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3204] = {
    [sym__expression] = STATE(12881),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3204),
    [sym_line_comment] = STATE(3204),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3205] = {
    [sym__expression] = STATE(12945),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3205),
    [sym_line_comment] = STATE(3205),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3206] = {
    [sym__expression] = STATE(12881),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3206),
    [sym_line_comment] = STATE(3206),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3207] = {
    [sym__expression] = STATE(13139),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10633),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19185),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12764),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(85),
    [sym_identifier] = STATE(10198),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3207),
    [sym_line_comment] = STATE(3207),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(41),
    [anon_sym_const] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_local] = ACTIONS(47),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8884),
    [sym__type_order_operator] = ACTIONS(8884),
    [sym__unary_operator] = ACTIONS(4028),
    [sym__unary_plus_operator] = ACTIONS(4028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3208] = {
    [sym__expression] = STATE(13061),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3208),
    [sym_line_comment] = STATE(3208),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3209] = {
    [sym__expression] = STATE(359),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3209),
    [sym_line_comment] = STATE(3209),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3210] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11304),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11304),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13860),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10623),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3210),
    [sym_line_comment] = STATE(3210),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3211] = {
    [sym__expression] = STATE(13800),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10704),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18370),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13276),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(159),
    [sym_identifier] = STATE(10272),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3211),
    [sym_line_comment] = STATE(3211),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4072),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_global] = ACTIONS(4076),
    [anon_sym_local] = ACTIONS(4078),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4128),
    [sym__type_order_operator] = ACTIONS(4128),
    [sym__unary_operator] = ACTIONS(4130),
    [sym__unary_plus_operator] = ACTIONS(4130),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3212] = {
    [sym__expression] = STATE(75),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3212),
    [sym_line_comment] = STATE(3212),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3213] = {
    [sym__expression] = STATE(13081),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3213),
    [sym_line_comment] = STATE(3213),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3214] = {
    [sym__expression] = STATE(12858),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3214),
    [sym_line_comment] = STATE(3214),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3215] = {
    [sym__expression] = STATE(12859),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3215),
    [sym_line_comment] = STATE(3215),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3216] = {
    [sym__expression] = STATE(8580),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3216),
    [sym_line_comment] = STATE(3216),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3217] = {
    [sym__expression] = STATE(12501),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3217),
    [sym_line_comment] = STATE(3217),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3218] = {
    [sym__expression] = STATE(8903),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3218),
    [sym_line_comment] = STATE(3218),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3219] = {
    [sym__expression] = STATE(8906),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3219),
    [sym_line_comment] = STATE(3219),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3220] = {
    [sym__expression] = STATE(12556),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3220),
    [sym_line_comment] = STATE(3220),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3221] = {
    [sym__expression] = STATE(12559),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3221),
    [sym_line_comment] = STATE(3221),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3222] = {
    [sym__expression] = STATE(8920),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3222),
    [sym_line_comment] = STATE(3222),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3223] = {
    [sym__expression] = STATE(8922),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3223),
    [sym_line_comment] = STATE(3223),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3224] = {
    [sym__expression] = STATE(12576),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3224),
    [sym_line_comment] = STATE(3224),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3225] = {
    [sym__expression] = STATE(12579),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3225),
    [sym_line_comment] = STATE(3225),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3226] = {
    [sym__expression] = STATE(12585),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3226),
    [sym_line_comment] = STATE(3226),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3227] = {
    [sym__expression] = STATE(12587),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3227),
    [sym_line_comment] = STATE(3227),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3228] = {
    [sym__expression] = STATE(12589),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3228),
    [sym_line_comment] = STATE(3228),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3229] = {
    [sym__expression] = STATE(12761),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3229),
    [sym_line_comment] = STATE(3229),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3230] = {
    [sym__expression] = STATE(12592),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3230),
    [sym_line_comment] = STATE(3230),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3231] = {
    [sym__expression] = STATE(12510),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3231),
    [sym_line_comment] = STATE(3231),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3232] = {
    [sym__expression] = STATE(12813),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3232),
    [sym_line_comment] = STATE(3232),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3233] = {
    [sym__expression] = STATE(13302),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3233),
    [sym_line_comment] = STATE(3233),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3234] = {
    [sym__expression] = STATE(13303),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3234),
    [sym_line_comment] = STATE(3234),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3235] = {
    [sym__expression] = STATE(13304),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3235),
    [sym_line_comment] = STATE(3235),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3236] = {
    [sym__expression] = STATE(13305),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3236),
    [sym_line_comment] = STATE(3236),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3237] = {
    [sym__expression] = STATE(13306),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3237),
    [sym_line_comment] = STATE(3237),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3238] = {
    [sym__expression] = STATE(13307),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3238),
    [sym_line_comment] = STATE(3238),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3239] = {
    [sym__expression] = STATE(13308),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3239),
    [sym_line_comment] = STATE(3239),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3240] = {
    [sym__expression] = STATE(13311),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3240),
    [sym_line_comment] = STATE(3240),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3241] = {
    [sym__expression] = STATE(13312),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3241),
    [sym_line_comment] = STATE(3241),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3242] = {
    [sym__expression] = STATE(13314),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3242),
    [sym_line_comment] = STATE(3242),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3243] = {
    [sym__expression] = STATE(13317),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3243),
    [sym_line_comment] = STATE(3243),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3244] = {
    [sym__expression] = STATE(13318),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3244),
    [sym_line_comment] = STATE(3244),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3245] = {
    [sym__expression] = STATE(13319),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3245),
    [sym_line_comment] = STATE(3245),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3246] = {
    [sym__expression] = STATE(13332),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3246),
    [sym_line_comment] = STATE(3246),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3247] = {
    [sym__expression] = STATE(12988),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10640),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19556),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12770),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(63),
    [sym_identifier] = STATE(10238),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3247),
    [sym_line_comment] = STATE(3247),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(195),
    [anon_sym_const] = ACTIONS(197),
    [anon_sym_global] = ACTIONS(199),
    [anon_sym_local] = ACTIONS(201),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8882),
    [sym__type_order_operator] = ACTIONS(8882),
    [sym__unary_operator] = ACTIONS(4042),
    [sym__unary_plus_operator] = ACTIONS(4042),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3248] = {
    [sym__expression] = STATE(13059),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10408),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5659),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19194),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12567),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(40),
    [sym_identifier] = STATE(10203),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9264),
    [sym_float_literal] = STATE(9264),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3248),
    [sym_line_comment] = STATE(3248),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3539),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_global] = ACTIONS(3543),
    [anon_sym_local] = ACTIONS(3545),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(205),
    [anon_sym_public] = ACTIONS(207),
    [anon_sym_import] = ACTIONS(209),
    [anon_sym_using] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5434),
    [anon_sym_COLON2] = ACTIONS(219),
    [anon_sym_COLON_COLON] = ACTIONS(5436),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5440),
    [aux_sym_integer_literal_token2] = ACTIONS(5440),
    [aux_sym_integer_literal_token3] = ACTIONS(227),
    [aux_sym_integer_literal_token4] = ACTIONS(229),
    [aux_sym_float_literal_token1] = ACTIONS(5442),
    [aux_sym_float_literal_token3] = ACTIONS(5442),
    [aux_sym_float_literal_token4] = ACTIONS(5442),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5444),
    [sym__type_order_operator] = ACTIONS(5444),
    [sym__unary_operator] = ACTIONS(235),
    [sym__unary_plus_operator] = ACTIONS(235),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3249] = {
    [sym__expression] = STATE(12860),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3249),
    [sym_line_comment] = STATE(3249),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3250] = {
    [sym__expression] = STATE(12861),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3250),
    [sym_line_comment] = STATE(3250),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3251] = {
    [sym__expression] = STATE(14090),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3251),
    [sym_line_comment] = STATE(3251),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3252] = {
    [sym__expression] = STATE(14095),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3252),
    [sym_line_comment] = STATE(3252),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3253] = {
    [sym__expression] = STATE(14012),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3253),
    [sym_line_comment] = STATE(3253),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3254] = {
    [sym__expression] = STATE(9125),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3254),
    [sym_line_comment] = STATE(3254),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3255] = {
    [sym__expression] = STATE(12862),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3255),
    [sym_line_comment] = STATE(3255),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3256] = {
    [sym__expression] = STATE(13625),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3256),
    [sym_line_comment] = STATE(3256),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3257] = {
    [sym__expression] = STATE(7322),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3257),
    [sym_line_comment] = STATE(3257),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3258] = {
    [sym__expression] = STATE(13987),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3258),
    [sym_line_comment] = STATE(3258),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3259] = {
    [sym__expression] = STATE(13995),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3259),
    [sym_line_comment] = STATE(3259),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3260] = {
    [sym__expression] = STATE(13998),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3260),
    [sym_line_comment] = STATE(3260),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3261] = {
    [sym__expression] = STATE(14035),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3261),
    [sym_line_comment] = STATE(3261),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3262] = {
    [sym__expression] = STATE(14034),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3262),
    [sym_line_comment] = STATE(3262),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3263] = {
    [sym__expression] = STATE(13980),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3263),
    [sym_line_comment] = STATE(3263),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3264] = {
    [sym__expression] = STATE(14001),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3264),
    [sym_line_comment] = STATE(3264),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3265] = {
    [sym__expression] = STATE(14026),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3265),
    [sym_line_comment] = STATE(3265),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3266] = {
    [sym__expression] = STATE(14038),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3266),
    [sym_line_comment] = STATE(3266),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3267] = {
    [sym__expression] = STATE(14041),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3267),
    [sym_line_comment] = STATE(3267),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3268] = {
    [sym__expression] = STATE(14042),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3268),
    [sym_line_comment] = STATE(3268),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3269] = {
    [sym__expression] = STATE(14050),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3269),
    [sym_line_comment] = STATE(3269),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3270] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11032),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18737),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13605),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10676),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3270),
    [sym_line_comment] = STATE(3270),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4156),
    [sym__type_order_operator] = ACTIONS(4156),
    [sym__unary_operator] = ACTIONS(4158),
    [sym__unary_plus_operator] = ACTIONS(4158),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3271] = {
    [sym__expression] = STATE(7688),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3271),
    [sym_line_comment] = STATE(3271),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3272] = {
    [sym__expression] = STATE(9021),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3272),
    [sym_line_comment] = STATE(3272),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3273] = {
    [sym__expression] = STATE(14244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(10939),
    [sym_tuple_expression] = STATE(10939),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(13788),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13175),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10531),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3273),
    [sym_line_comment] = STATE(3273),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3274] = {
    [sym__expression] = STATE(12772),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3274),
    [sym_line_comment] = STATE(3274),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3275] = {
    [sym__expression] = STATE(7705),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3275),
    [sym_line_comment] = STATE(3275),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3276] = {
    [sym__expression] = STATE(7710),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3276),
    [sym_line_comment] = STATE(3276),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3277] = {
    [sym__expression] = STATE(12784),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3277),
    [sym_line_comment] = STATE(3277),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3278] = {
    [sym__expression] = STATE(12785),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3278),
    [sym_line_comment] = STATE(3278),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3279] = {
    [sym__expression] = STATE(7713),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3279),
    [sym_line_comment] = STATE(3279),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3280] = {
    [sym__expression] = STATE(7714),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3280),
    [sym_line_comment] = STATE(3280),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3281] = {
    [sym__expression] = STATE(12788),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3281),
    [sym_line_comment] = STATE(3281),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3282] = {
    [sym__expression] = STATE(12789),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3282),
    [sym_line_comment] = STATE(3282),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3283] = {
    [sym__expression] = STATE(12790),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3283),
    [sym_line_comment] = STATE(3283),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3284] = {
    [sym__expression] = STATE(12791),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3284),
    [sym_line_comment] = STATE(3284),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3285] = {
    [sym__expression] = STATE(12792),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3285),
    [sym_line_comment] = STATE(3285),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3286] = {
    [sym__expression] = STATE(12793),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3286),
    [sym_line_comment] = STATE(3286),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3287] = {
    [sym__expression] = STATE(12794),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3287),
    [sym_line_comment] = STATE(3287),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3288] = {
    [sym__expression] = STATE(12510),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3288),
    [sym_line_comment] = STATE(3288),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3289] = {
    [sym__expression] = STATE(12482),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3289),
    [sym_line_comment] = STATE(3289),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3290] = {
    [sym__expression] = STATE(8684),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3290),
    [sym_line_comment] = STATE(3290),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3291] = {
    [sym__expression] = STATE(12782),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3291),
    [sym_line_comment] = STATE(3291),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3292] = {
    [sym__expression] = STATE(12783),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3292),
    [sym_line_comment] = STATE(3292),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3293] = {
    [sym__expression] = STATE(13193),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3293),
    [sym_line_comment] = STATE(3293),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3294] = {
    [sym__expression] = STATE(13247),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3294),
    [sym_line_comment] = STATE(3294),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3295] = {
    [sym__expression] = STATE(12786),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3295),
    [sym_line_comment] = STATE(3295),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3296] = {
    [sym__expression] = STATE(12787),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10480),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19183),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12519),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(36),
    [sym_identifier] = STATE(10101),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3296),
    [sym_line_comment] = STATE(3296),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3523),
    [anon_sym_const] = ACTIONS(3525),
    [anon_sym_global] = ACTIONS(3527),
    [anon_sym_local] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8886),
    [sym__type_order_operator] = ACTIONS(8886),
    [sym__unary_operator] = ACTIONS(3848),
    [sym__unary_plus_operator] = ACTIONS(3848),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3297] = {
    [sym__expression] = STATE(13268),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3297),
    [sym_line_comment] = STATE(3297),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3298] = {
    [sym__expression] = STATE(13270),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3298),
    [sym_line_comment] = STATE(3298),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3299] = {
    [sym__expression] = STATE(13271),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3299),
    [sym_line_comment] = STATE(3299),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3300] = {
    [sym__expression] = STATE(13272),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3300),
    [sym_line_comment] = STATE(3300),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3301] = {
    [sym__expression] = STATE(13273),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3301),
    [sym_line_comment] = STATE(3301),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3302] = {
    [sym__expression] = STATE(13274),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3302),
    [sym_line_comment] = STATE(3302),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3303] = {
    [sym__expression] = STATE(13275),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3303),
    [sym_line_comment] = STATE(3303),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3304] = {
    [sym__expression] = STATE(12989),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3304),
    [sym_line_comment] = STATE(3304),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3305] = {
    [sym__expression] = STATE(8753),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3305),
    [sym_line_comment] = STATE(3305),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3306] = {
    [sym__expression] = STATE(12864),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3306),
    [sym_line_comment] = STATE(3306),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3307] = {
    [sym__expression] = STATE(13197),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3307),
    [sym_line_comment] = STATE(3307),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3308] = {
    [sym__expression] = STATE(13190),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3308),
    [sym_line_comment] = STATE(3308),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3309] = {
    [sym__expression] = STATE(13191),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3309),
    [sym_line_comment] = STATE(3309),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3310] = {
    [sym__expression] = STATE(13266),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3310),
    [sym_line_comment] = STATE(3310),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3311] = {
    [sym__expression] = STATE(13267),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3311),
    [sym_line_comment] = STATE(3311),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3312] = {
    [sym__expression] = STATE(12807),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3312),
    [sym_line_comment] = STATE(3312),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3313] = {
    [sym__expression] = STATE(12932),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3313),
    [sym_line_comment] = STATE(3313),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3314] = {
    [sym__expression] = STATE(8691),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3314),
    [sym_line_comment] = STATE(3314),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3315] = {
    [sym__expression] = STATE(8897),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3315),
    [sym_line_comment] = STATE(3315),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3316] = {
    [sym__expression] = STATE(8899),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3316),
    [sym_line_comment] = STATE(3316),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3317] = {
    [sym__expression] = STATE(8911),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3317),
    [sym_line_comment] = STATE(3317),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3318] = {
    [sym__expression] = STATE(8919),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3318),
    [sym_line_comment] = STATE(3318),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3319] = {
    [sym__expression] = STATE(8174),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3319),
    [sym_line_comment] = STATE(3319),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3320] = {
    [sym__expression] = STATE(8620),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3320),
    [sym_line_comment] = STATE(3320),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3321] = {
    [sym__expression] = STATE(9193),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3321),
    [sym_line_comment] = STATE(3321),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3322] = {
    [sym__expression] = STATE(12552),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3322),
    [sym_line_comment] = STATE(3322),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3323] = {
    [sym__expression] = STATE(12553),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3323),
    [sym_line_comment] = STATE(3323),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3324] = {
    [sym__expression] = STATE(12780),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3324),
    [sym_line_comment] = STATE(3324),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3325] = {
    [sym__expression] = STATE(12781),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3325),
    [sym_line_comment] = STATE(3325),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3326] = {
    [sym__expression] = STATE(12561),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3326),
    [sym_line_comment] = STATE(3326),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3327] = {
    [sym__expression] = STATE(12573),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10295),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5152),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19390),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12158),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(26),
    [sym_identifier] = STATE(10073),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9104),
    [sym_float_literal] = STATE(9104),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3327),
    [sym_line_comment] = STATE(3327),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3089),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3091),
    [anon_sym_const] = ACTIONS(3093),
    [anon_sym_global] = ACTIONS(3095),
    [anon_sym_local] = ACTIONS(3097),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3099),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3103),
    [anon_sym_using] = ACTIONS(3105),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4448),
    [anon_sym_COLON2] = ACTIONS(3109),
    [anon_sym_COLON_COLON] = ACTIONS(4450),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4454),
    [aux_sym_integer_literal_token2] = ACTIONS(4454),
    [aux_sym_integer_literal_token3] = ACTIONS(3113),
    [aux_sym_integer_literal_token4] = ACTIONS(3115),
    [aux_sym_float_literal_token1] = ACTIONS(4456),
    [aux_sym_float_literal_token3] = ACTIONS(4456),
    [aux_sym_float_literal_token4] = ACTIONS(4456),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4458),
    [sym__type_order_operator] = ACTIONS(4458),
    [sym__unary_operator] = ACTIONS(3119),
    [sym__unary_plus_operator] = ACTIONS(3119),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3328] = {
    [sym__expression] = STATE(12797),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3328),
    [sym_line_comment] = STATE(3328),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3329] = {
    [sym__expression] = STATE(12798),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3329),
    [sym_line_comment] = STATE(3329),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3330] = {
    [sym__expression] = STATE(12799),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3330),
    [sym_line_comment] = STATE(3330),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3331] = {
    [sym__expression] = STATE(9008),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3331),
    [sym_line_comment] = STATE(3331),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3332] = {
    [sym__expression] = STATE(9100),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3332),
    [sym_line_comment] = STATE(3332),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3333] = {
    [sym__expression] = STATE(8968),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3333),
    [sym_line_comment] = STATE(3333),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3334] = {
    [sym__expression] = STATE(8969),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3334),
    [sym_line_comment] = STATE(3334),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3335] = {
    [sym__expression] = STATE(8976),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3335),
    [sym_line_comment] = STATE(3335),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3336] = {
    [sym__expression] = STATE(9025),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3336),
    [sym_line_comment] = STATE(3336),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3337] = {
    [sym__expression] = STATE(9033),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3337),
    [sym_line_comment] = STATE(3337),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3338] = {
    [sym__expression] = STATE(9040),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3338),
    [sym_line_comment] = STATE(3338),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3339] = {
    [sym__expression] = STATE(9063),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3339),
    [sym_line_comment] = STATE(3339),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3340] = {
    [sym__expression] = STATE(9065),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3340),
    [sym_line_comment] = STATE(3340),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3341] = {
    [sym__expression] = STATE(9066),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3341),
    [sym_line_comment] = STATE(3341),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3342] = {
    [sym__expression] = STATE(8121),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3342),
    [sym_line_comment] = STATE(3342),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3343] = {
    [sym__expression] = STATE(8723),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3343),
    [sym_line_comment] = STATE(3343),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3344] = {
    [sym__expression] = STATE(12800),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3344),
    [sym_line_comment] = STATE(3344),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3345] = {
    [sym__expression] = STATE(12801),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3345),
    [sym_line_comment] = STATE(3345),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3346] = {
    [sym__expression] = STATE(12802),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3346),
    [sym_line_comment] = STATE(3346),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3347] = {
    [sym__expression] = STATE(12803),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3347),
    [sym_line_comment] = STATE(3347),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3348] = {
    [sym__expression] = STATE(12989),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3348),
    [sym_line_comment] = STATE(3348),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3349] = {
    [sym__expression] = STATE(9211),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3349),
    [sym_line_comment] = STATE(3349),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3350] = {
    [sym__expression] = STATE(234),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3350),
    [sym_line_comment] = STATE(3350),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3351] = {
    [sym__expression] = STATE(12867),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3351),
    [sym_line_comment] = STATE(3351),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3352] = {
    [sym__expression] = STATE(12624),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3352),
    [sym_line_comment] = STATE(3352),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3353] = {
    [sym__expression] = STATE(8966),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3353),
    [sym_line_comment] = STATE(3353),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3354] = {
    [sym__expression] = STATE(12466),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3354),
    [sym_line_comment] = STATE(3354),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3355] = {
    [sym__expression] = STATE(8907),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3355),
    [sym_line_comment] = STATE(3355),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3356] = {
    [sym__expression] = STATE(8913),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3356),
    [sym_line_comment] = STATE(3356),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3357] = {
    [sym__expression] = STATE(8973),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3357),
    [sym_line_comment] = STATE(3357),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3358] = {
    [sym__expression] = STATE(8974),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3358),
    [sym_line_comment] = STATE(3358),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3359] = {
    [sym__expression] = STATE(8923),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3359),
    [sym_line_comment] = STATE(3359),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3360] = {
    [sym__expression] = STATE(8930),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3360),
    [sym_line_comment] = STATE(3360),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3361] = {
    [sym__expression] = STATE(8932),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3361),
    [sym_line_comment] = STATE(3361),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3362] = {
    [sym__expression] = STATE(8934),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3362),
    [sym_line_comment] = STATE(3362),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3363] = {
    [sym__expression] = STATE(8872),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3363),
    [sym_line_comment] = STATE(3363),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3364] = {
    [sym__expression] = STATE(8744),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3364),
    [sym_line_comment] = STATE(3364),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3365] = {
    [sym__expression] = STATE(8835),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3365),
    [sym_line_comment] = STATE(3365),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3366] = {
    [sym__expression] = STATE(7219),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3366),
    [sym_line_comment] = STATE(3366),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3367] = {
    [sym__expression] = STATE(12271),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3367),
    [sym_line_comment] = STATE(3367),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3368] = {
    [sym__expression] = STATE(12629),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3368),
    [sym_line_comment] = STATE(3368),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3369] = {
    [sym__expression] = STATE(12526),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3369),
    [sym_line_comment] = STATE(3369),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3370] = {
    [sym__expression] = STATE(12530),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3370),
    [sym_line_comment] = STATE(3370),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3371] = {
    [sym__expression] = STATE(12532),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3371),
    [sym_line_comment] = STATE(3371),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3372] = {
    [sym__expression] = STATE(12533),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3372),
    [sym_line_comment] = STATE(3372),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3373] = {
    [sym__expression] = STATE(12534),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3373),
    [sym_line_comment] = STATE(3373),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3374] = {
    [sym__expression] = STATE(12538),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3374),
    [sym_line_comment] = STATE(3374),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3375] = {
    [sym__expression] = STATE(12539),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3375),
    [sym_line_comment] = STATE(3375),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3376] = {
    [sym__expression] = STATE(12540),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3376),
    [sym_line_comment] = STATE(3376),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3377] = {
    [sym__expression] = STATE(12541),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3377),
    [sym_line_comment] = STATE(3377),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3378] = {
    [sym__expression] = STATE(12542),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3378),
    [sym_line_comment] = STATE(3378),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3379] = {
    [sym__expression] = STATE(12543),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3379),
    [sym_line_comment] = STATE(3379),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3380] = {
    [sym__expression] = STATE(12546),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3380),
    [sym_line_comment] = STATE(3380),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3381] = {
    [sym__expression] = STATE(12547),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3381),
    [sym_line_comment] = STATE(3381),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3382] = {
    [sym__expression] = STATE(12295),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3382),
    [sym_line_comment] = STATE(3382),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3383] = {
    [sym__expression] = STATE(12298),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3383),
    [sym_line_comment] = STATE(3383),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3384] = {
    [sym__expression] = STATE(13369),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3384),
    [sym_line_comment] = STATE(3384),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3385] = {
    [sym__expression] = STATE(12935),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3385),
    [sym_line_comment] = STATE(3385),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3386] = {
    [sym__expression] = STATE(12621),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3386),
    [sym_line_comment] = STATE(3386),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3387] = {
    [sym__expression] = STATE(12815),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3387),
    [sym_line_comment] = STATE(3387),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3388] = {
    [sym__expression] = STATE(12628),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3388),
    [sym_line_comment] = STATE(3388),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3389] = {
    [sym__expression] = STATE(12630),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3389),
    [sym_line_comment] = STATE(3389),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3390] = {
    [sym__expression] = STATE(12638),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3390),
    [sym_line_comment] = STATE(3390),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3391] = {
    [sym__expression] = STATE(12709),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3391),
    [sym_line_comment] = STATE(3391),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3392] = {
    [sym__expression] = STATE(12713),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3392),
    [sym_line_comment] = STATE(3392),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3393] = {
    [sym__expression] = STATE(12714),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3393),
    [sym_line_comment] = STATE(3393),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3394] = {
    [sym__expression] = STATE(12746),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3394),
    [sym_line_comment] = STATE(3394),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3395] = {
    [sym__expression] = STATE(12751),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3395),
    [sym_line_comment] = STATE(3395),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3396] = {
    [sym__expression] = STATE(12753),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3396),
    [sym_line_comment] = STATE(3396),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3397] = {
    [sym__expression] = STATE(12754),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3397),
    [sym_line_comment] = STATE(3397),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3398] = {
    [sym__expression] = STATE(12755),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3398),
    [sym_line_comment] = STATE(3398),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3399] = {
    [sym__expression] = STATE(12149),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10268),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(19239),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(12334),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(13),
    [sym_identifier] = STATE(9950),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3399),
    [sym_line_comment] = STATE(3399),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(135),
    [anon_sym_const] = ACTIONS(137),
    [anon_sym_global] = ACTIONS(139),
    [anon_sym_local] = ACTIONS(141),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8864),
    [sym__type_order_operator] = ACTIONS(8864),
    [sym__unary_operator] = ACTIONS(3575),
    [sym__unary_plus_operator] = ACTIONS(3575),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3400] = {
    [sym__expression] = STATE(12505),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10363),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18520),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12222),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(14),
    [sym_identifier] = STATE(10144),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3400),
    [sym_line_comment] = STATE(3400),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3285),
    [anon_sym_const] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3289),
    [anon_sym_local] = ACTIONS(3291),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5120),
    [sym__type_order_operator] = ACTIONS(5120),
    [sym__unary_operator] = ACTIONS(3313),
    [sym__unary_plus_operator] = ACTIONS(3313),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3401] = {
    [sym__expression] = STATE(8716),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3401),
    [sym_line_comment] = STATE(3401),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3402] = {
    [sym__expression] = STATE(12818),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3402),
    [sym_line_comment] = STATE(3402),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3403] = {
    [sym__expression] = STATE(8637),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3403),
    [sym_line_comment] = STATE(3403),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3404] = {
    [sym__expression] = STATE(12819),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3404),
    [sym_line_comment] = STATE(3404),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3405] = {
    [sym__expression] = STATE(12820),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3405),
    [sym_line_comment] = STATE(3405),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3406] = {
    [sym__expression] = STATE(12821),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3406),
    [sym_line_comment] = STATE(3406),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3407] = {
    [sym__expression] = STATE(12822),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3407),
    [sym_line_comment] = STATE(3407),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3408] = {
    [sym__expression] = STATE(12823),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3408),
    [sym_line_comment] = STATE(3408),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3409] = {
    [sym__expression] = STATE(12824),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3409),
    [sym_line_comment] = STATE(3409),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3410] = {
    [sym__expression] = STATE(12825),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3410),
    [sym_line_comment] = STATE(3410),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3411] = {
    [sym__expression] = STATE(12826),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3411),
    [sym_line_comment] = STATE(3411),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3412] = {
    [sym__expression] = STATE(12827),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3412),
    [sym_line_comment] = STATE(3412),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3413] = {
    [sym__expression] = STATE(12828),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3413),
    [sym_line_comment] = STATE(3413),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3414] = {
    [sym__expression] = STATE(12829),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3414),
    [sym_line_comment] = STATE(3414),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3415] = {
    [sym__expression] = STATE(12563),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10436),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5295),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19020),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12527),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(45),
    [sym_identifier] = STATE(10133),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9130),
    [sym_float_literal] = STATE(9130),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3415),
    [sym_line_comment] = STATE(3415),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3283),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3484),
    [anon_sym_global] = ACTIONS(3486),
    [anon_sym_local] = ACTIONS(3488),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3293),
    [anon_sym_public] = ACTIONS(3295),
    [anon_sym_import] = ACTIONS(3297),
    [anon_sym_using] = ACTIONS(3299),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5110),
    [anon_sym_COLON2] = ACTIONS(3303),
    [anon_sym_COLON_COLON] = ACTIONS(5112),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5116),
    [aux_sym_integer_literal_token2] = ACTIONS(5116),
    [aux_sym_integer_literal_token3] = ACTIONS(3307),
    [aux_sym_integer_literal_token4] = ACTIONS(3309),
    [aux_sym_float_literal_token1] = ACTIONS(5118),
    [aux_sym_float_literal_token3] = ACTIONS(5118),
    [aux_sym_float_literal_token4] = ACTIONS(5118),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8868),
    [sym__type_order_operator] = ACTIONS(8868),
    [sym__unary_operator] = ACTIONS(3850),
    [sym__unary_plus_operator] = ACTIONS(3850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3416] = {
    [sym__expression] = STATE(8277),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4387),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(19512),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(7221),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(27),
    [sym_identifier] = STATE(4120),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3416),
    [sym_line_comment] = STATE(3416),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(745),
    [anon_sym_const] = ACTIONS(747),
    [anon_sym_global] = ACTIONS(749),
    [anon_sym_local] = ACTIONS(751),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(7384),
    [sym__type_order_operator] = ACTIONS(7384),
    [sym__unary_operator] = ACTIONS(787),
    [sym__unary_plus_operator] = ACTIONS(787),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3417] = {
    [sym__expression] = STATE(12868),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3417),
    [sym_line_comment] = STATE(3417),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3418] = {
    [sym__expression] = STATE(9267),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3418),
    [sym_line_comment] = STATE(3418),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3419] = {
    [sym__expression] = STATE(8686),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3419),
    [sym_line_comment] = STATE(3419),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3420] = {
    [sym__expression] = STATE(9297),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3420),
    [sym_line_comment] = STATE(3420),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3421] = {
    [sym__expression] = STATE(8687),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3421),
    [sym_line_comment] = STATE(3421),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3422] = {
    [sym__expression] = STATE(8690),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3422),
    [sym_line_comment] = STATE(3422),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3423] = {
    [sym__expression] = STATE(8693),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3423),
    [sym_line_comment] = STATE(3423),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3424] = {
    [sym__expression] = STATE(8696),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3424),
    [sym_line_comment] = STATE(3424),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3425] = {
    [sym__expression] = STATE(8709),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3425),
    [sym_line_comment] = STATE(3425),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3426] = {
    [sym__expression] = STATE(8710),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3426),
    [sym_line_comment] = STATE(3426),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3427] = {
    [sym__expression] = STATE(8712),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3427),
    [sym_line_comment] = STATE(3427),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3428] = {
    [sym__expression] = STATE(8713),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3428),
    [sym_line_comment] = STATE(3428),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3429] = {
    [sym__expression] = STATE(8714),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3429),
    [sym_line_comment] = STATE(3429),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3430] = {
    [sym__expression] = STATE(8715),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3430),
    [sym_line_comment] = STATE(3430),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3431] = {
    [sym__expression] = STATE(8718),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3431),
    [sym_line_comment] = STATE(3431),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3432] = {
    [sym__expression] = STATE(8311),
    [sym_module_definition] = STATE(8230),
    [sym_abstract_definition] = STATE(8230),
    [sym_primitive_definition] = STATE(8230),
    [sym_struct_definition] = STATE(8230),
    [sym_function_definition] = STATE(8230),
    [sym_macro_definition] = STATE(8230),
    [sym_compound_statement] = STATE(8230),
    [sym_quote_statement] = STATE(8230),
    [sym_let_statement] = STATE(8230),
    [sym_if_statement] = STATE(8230),
    [sym_try_statement] = STATE(8230),
    [sym_for_statement] = STATE(8230),
    [sym_while_statement] = STATE(8230),
    [sym_return_statement] = STATE(8230),
    [sym_const_statement] = STATE(8230),
    [sym_global_statement] = STATE(8230),
    [sym_local_statement] = STATE(8230),
    [sym_export_statement] = STATE(8230),
    [sym_public_statement] = STATE(8230),
    [sym_import_statement] = STATE(8230),
    [sym_using_statement] = STATE(8230),
    [sym__primary_expression] = STATE(4592),
    [sym__array] = STATE(4716),
    [sym_comprehension_expression] = STATE(4791),
    [sym_matrix_expression] = STATE(4791),
    [sym_vector_expression] = STATE(4791),
    [sym_parenthesized_expression] = STATE(4716),
    [sym_tuple_expression] = STATE(4716),
    [sym_curly_expression] = STATE(4716),
    [sym_adjoint_expression] = STATE(4081),
    [sym_field_expression] = STATE(4716),
    [sym_index_expression] = STATE(4716),
    [sym_parametrized_type_expression] = STATE(4716),
    [sym_call_expression] = STATE(4716),
    [sym_broadcast_call_expression] = STATE(4716),
    [sym__closed_macrocall_expression] = STATE(4716),
    [sym_macrocall_expression] = STATE(8230),
    [sym_argument_list] = STATE(18359),
    [sym_interpolation_expression] = STATE(4716),
    [sym_quote_expression] = STATE(4716),
    [sym_binary_expression] = STATE(8230),
    [sym_unary_expression] = STATE(8230),
    [sym_range_expression] = STATE(8230),
    [sym_splat_expression] = STATE(8230),
    [sym_ternary_expression] = STATE(8230),
    [sym_typed_expression] = STATE(8436),
    [sym_unary_typed_expression] = STATE(8230),
    [sym_arrow_function_expression] = STATE(8230),
    [sym_juxtaposition_expression] = STATE(8230),
    [sym_compound_assignment_expression] = STATE(8230),
    [sym_where_expression] = STATE(8230),
    [sym_macro_identifier] = STATE(43),
    [sym_identifier] = STATE(4134),
    [sym_boolean_literal] = STATE(4716),
    [sym_integer_literal] = STATE(4090),
    [sym_float_literal] = STATE(4090),
    [sym__string] = STATE(4716),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(7454),
    [sym_block_comment] = STATE(3432),
    [sym_line_comment] = STATE(3432),
    [sym__word_identifier] = ACTIONS(713),
    [anon_sym_begin] = ACTIONS(715),
    [anon_sym_module] = ACTIONS(717),
    [anon_sym_baremodule] = ACTIONS(717),
    [anon_sym_abstract] = ACTIONS(719),
    [anon_sym_primitive] = ACTIONS(721),
    [anon_sym_mutable] = ACTIONS(723),
    [anon_sym_struct] = ACTIONS(725),
    [anon_sym_function] = ACTIONS(727),
    [anon_sym_macro] = ACTIONS(729),
    [anon_sym_quote] = ACTIONS(731),
    [anon_sym_let] = ACTIONS(733),
    [anon_sym_if] = ACTIONS(735),
    [anon_sym_try] = ACTIONS(737),
    [anon_sym_for] = ACTIONS(739),
    [anon_sym_while] = ACTIONS(741),
    [sym_break_statement] = ACTIONS(743),
    [sym_continue_statement] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(913),
    [anon_sym_const] = ACTIONS(915),
    [anon_sym_global] = ACTIONS(917),
    [anon_sym_local] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(7366),
    [anon_sym_export] = ACTIONS(755),
    [anon_sym_public] = ACTIONS(757),
    [anon_sym_import] = ACTIONS(759),
    [anon_sym_using] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(7368),
    [anon_sym_LBRACE] = ACTIONS(7370),
    [anon_sym_DOLLAR] = ACTIONS(7372),
    [anon_sym_COLON2] = ACTIONS(769),
    [anon_sym_COLON_COLON] = ACTIONS(7374),
    [anon_sym_AT] = ACTIONS(4452),
    [anon_sym_true] = ACTIONS(775),
    [anon_sym_false] = ACTIONS(775),
    [aux_sym_integer_literal_token1] = ACTIONS(7376),
    [aux_sym_integer_literal_token2] = ACTIONS(7376),
    [aux_sym_integer_literal_token3] = ACTIONS(777),
    [aux_sym_integer_literal_token4] = ACTIONS(779),
    [aux_sym_float_literal_token1] = ACTIONS(7378),
    [aux_sym_float_literal_token3] = ACTIONS(7378),
    [aux_sym_float_literal_token4] = ACTIONS(7378),
    [sym_character_literal] = ACTIONS(7380),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7382),
    [sym__arrow_operator] = ACTIONS(785),
    [sym__comparison_operator] = ACTIONS(785),
    [sym__pipe_right_operator] = ACTIONS(7382),
    [sym__pipe_left_operator] = ACTIONS(7382),
    [sym__ellipsis_operator] = ACTIONS(7382),
    [sym__plus_operator] = ACTIONS(785),
    [sym__times_operator] = ACTIONS(785),
    [sym__rational_operator] = ACTIONS(7382),
    [sym__bitshift_operator] = ACTIONS(7382),
    [sym__power_operator] = ACTIONS(7382),
    [sym__tilde_operator] = ACTIONS(8870),
    [sym__type_order_operator] = ACTIONS(8870),
    [sym__unary_operator] = ACTIONS(3878),
    [sym__unary_plus_operator] = ACTIONS(3878),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3433] = {
    [sym__expression] = STATE(9022),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4923),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18822),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8857),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(64),
    [sym_identifier] = STATE(4408),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3433),
    [sym_line_comment] = STATE(3433),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1053),
    [anon_sym_const] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1057),
    [anon_sym_local] = ACTIONS(1059),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(1061),
    [sym__type_order_operator] = ACTIONS(1061),
    [sym__unary_operator] = ACTIONS(1063),
    [sym__unary_plus_operator] = ACTIONS(1063),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3434] = {
    [sym__expression] = STATE(8762),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3434),
    [sym_line_comment] = STATE(3434),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3435] = {
    [sym__expression] = STATE(13125),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3435),
    [sym_line_comment] = STATE(3435),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3436] = {
    [sym__expression] = STATE(12776),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3436),
    [sym_line_comment] = STATE(3436),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3437] = {
    [sym__expression] = STATE(12779),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3437),
    [sym_line_comment] = STATE(3437),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3438] = {
    [sym__expression] = STATE(8545),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3438),
    [sym_line_comment] = STATE(3438),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3439] = {
    [sym__expression] = STATE(8546),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3439),
    [sym_line_comment] = STATE(3439),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3440] = {
    [sym__expression] = STATE(12795),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3440),
    [sym_line_comment] = STATE(3440),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3441] = {
    [sym__expression] = STATE(12796),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10534),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18570),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12565),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10190),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3441),
    [sym_line_comment] = STATE(3441),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(1829),
    [sym__type_order_operator] = ACTIONS(1829),
    [sym__unary_operator] = ACTIONS(1831),
    [sym__unary_plus_operator] = ACTIONS(1831),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3442] = {
    [sym__expression] = STATE(8440),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3442),
    [sym_line_comment] = STATE(3442),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3443] = {
    [sym__expression] = STATE(9155),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3443),
    [sym_line_comment] = STATE(3443),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3444] = {
    [sym__expression] = STATE(8310),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3444),
    [sym_line_comment] = STATE(3444),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3445] = {
    [sym__expression] = STATE(9156),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3445),
    [sym_line_comment] = STATE(3445),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3446] = {
    [sym__expression] = STATE(9157),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3446),
    [sym_line_comment] = STATE(3446),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3447] = {
    [sym__expression] = STATE(9158),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3447),
    [sym_line_comment] = STATE(3447),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3448] = {
    [sym__expression] = STATE(9159),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3448),
    [sym_line_comment] = STATE(3448),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3449] = {
    [sym__expression] = STATE(9160),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3449),
    [sym_line_comment] = STATE(3449),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3450] = {
    [sym__expression] = STATE(9161),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3450),
    [sym_line_comment] = STATE(3450),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3451] = {
    [sym__expression] = STATE(9162),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3451),
    [sym_line_comment] = STATE(3451),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3452] = {
    [sym__expression] = STATE(9163),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3452),
    [sym_line_comment] = STATE(3452),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3453] = {
    [sym__expression] = STATE(9164),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3453),
    [sym_line_comment] = STATE(3453),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3454] = {
    [sym__expression] = STATE(9165),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3454),
    [sym_line_comment] = STATE(3454),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3455] = {
    [sym__expression] = STATE(9166),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3455),
    [sym_line_comment] = STATE(3455),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3456] = {
    [sym__expression] = STATE(8121),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(5048),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18877),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(9058),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(114),
    [sym_identifier] = STATE(4337),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3456),
    [sym_line_comment] = STATE(3456),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(1051),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1345),
    [anon_sym_global] = ACTIONS(1347),
    [anon_sym_local] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4092),
    [sym__type_order_operator] = ACTIONS(4092),
    [sym__unary_operator] = ACTIONS(4094),
    [sym__unary_plus_operator] = ACTIONS(4094),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3457] = {
    [sym__expression] = STATE(7222),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4156),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(19309),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(6981),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(10),
    [sym_identifier] = STATE(4107),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3457),
    [sym_line_comment] = STATE(3457),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(279),
    [anon_sym_const] = ACTIONS(281),
    [anon_sym_global] = ACTIONS(283),
    [anon_sym_local] = ACTIONS(285),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(7762),
    [sym__type_order_operator] = ACTIONS(7762),
    [sym__unary_operator] = ACTIONS(319),
    [sym__unary_plus_operator] = ACTIONS(319),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3458] = {
    [sym__expression] = STATE(8552),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3458),
    [sym_line_comment] = STATE(3458),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3459] = {
    [sym__expression] = STATE(8555),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3459),
    [sym_line_comment] = STATE(3459),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3460] = {
    [sym__expression] = STATE(8556),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3460),
    [sym_line_comment] = STATE(3460),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3461] = {
    [sym__expression] = STATE(8557),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3461),
    [sym_line_comment] = STATE(3461),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3462] = {
    [sym__expression] = STATE(8558),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3462),
    [sym_line_comment] = STATE(3462),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3463] = {
    [sym__expression] = STATE(8562),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3463),
    [sym_line_comment] = STATE(3463),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3464] = {
    [sym__expression] = STATE(8568),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3464),
    [sym_line_comment] = STATE(3464),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3465] = {
    [sym__expression] = STATE(7937),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3465),
    [sym_line_comment] = STATE(3465),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3466] = {
    [sym__expression] = STATE(8720),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3466),
    [sym_line_comment] = STATE(3466),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3467] = {
    [sym__expression] = STATE(8335),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3467),
    [sym_line_comment] = STATE(3467),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3468] = {
    [sym__expression] = STATE(8817),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3468),
    [sym_line_comment] = STATE(3468),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3469] = {
    [sym__expression] = STATE(8337),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3469),
    [sym_line_comment] = STATE(3469),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3470] = {
    [sym__expression] = STATE(8338),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3470),
    [sym_line_comment] = STATE(3470),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3471] = {
    [sym__expression] = STATE(8339),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3471),
    [sym_line_comment] = STATE(3471),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3472] = {
    [sym__expression] = STATE(8340),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3472),
    [sym_line_comment] = STATE(3472),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3473] = {
    [sym__expression] = STATE(8341),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3473),
    [sym_line_comment] = STATE(3473),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3474] = {
    [sym__expression] = STATE(8342),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3474),
    [sym_line_comment] = STATE(3474),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3475] = {
    [sym__expression] = STATE(8343),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3475),
    [sym_line_comment] = STATE(3475),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3476] = {
    [sym__expression] = STATE(8344),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3476),
    [sym_line_comment] = STATE(3476),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3477] = {
    [sym__expression] = STATE(8345),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3477),
    [sym_line_comment] = STATE(3477),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3478] = {
    [sym__expression] = STATE(8346),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3478),
    [sym_line_comment] = STATE(3478),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3479] = {
    [sym__expression] = STATE(8347),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3479),
    [sym_line_comment] = STATE(3479),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3480] = {
    [sym__expression] = STATE(7842),
    [sym_module_definition] = STATE(7257),
    [sym_abstract_definition] = STATE(7257),
    [sym_primitive_definition] = STATE(7257),
    [sym_struct_definition] = STATE(7257),
    [sym_function_definition] = STATE(7257),
    [sym_macro_definition] = STATE(7257),
    [sym_compound_statement] = STATE(7257),
    [sym_quote_statement] = STATE(7257),
    [sym_let_statement] = STATE(7257),
    [sym_if_statement] = STATE(7257),
    [sym_try_statement] = STATE(7257),
    [sym_for_statement] = STATE(7257),
    [sym_while_statement] = STATE(7257),
    [sym_return_statement] = STATE(7257),
    [sym_const_statement] = STATE(7257),
    [sym_global_statement] = STATE(7257),
    [sym_local_statement] = STATE(7257),
    [sym_export_statement] = STATE(7257),
    [sym_public_statement] = STATE(7257),
    [sym_import_statement] = STATE(7257),
    [sym_using_statement] = STATE(7257),
    [sym__primary_expression] = STATE(4361),
    [sym__array] = STATE(4352),
    [sym_comprehension_expression] = STATE(4319),
    [sym_matrix_expression] = STATE(4319),
    [sym_vector_expression] = STATE(4319),
    [sym_parenthesized_expression] = STATE(4352),
    [sym_tuple_expression] = STATE(4352),
    [sym_curly_expression] = STATE(4352),
    [sym_adjoint_expression] = STATE(4076),
    [sym_field_expression] = STATE(4352),
    [sym_index_expression] = STATE(4352),
    [sym_parametrized_type_expression] = STATE(4352),
    [sym_call_expression] = STATE(4352),
    [sym_broadcast_call_expression] = STATE(4352),
    [sym__closed_macrocall_expression] = STATE(4352),
    [sym_macrocall_expression] = STATE(7257),
    [sym_argument_list] = STATE(18893),
    [sym_interpolation_expression] = STATE(4352),
    [sym_quote_expression] = STATE(4352),
    [sym_binary_expression] = STATE(7257),
    [sym_unary_expression] = STATE(7257),
    [sym_range_expression] = STATE(7257),
    [sym_splat_expression] = STATE(7257),
    [sym_ternary_expression] = STATE(7257),
    [sym_typed_expression] = STATE(7356),
    [sym_unary_typed_expression] = STATE(7257),
    [sym_arrow_function_expression] = STATE(7257),
    [sym_juxtaposition_expression] = STATE(7257),
    [sym_compound_assignment_expression] = STATE(7257),
    [sym_where_expression] = STATE(7257),
    [sym_macro_identifier] = STATE(21),
    [sym_identifier] = STATE(4104),
    [sym_boolean_literal] = STATE(4352),
    [sym_integer_literal] = STATE(4086),
    [sym_float_literal] = STATE(4086),
    [sym__string] = STATE(4352),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(6961),
    [sym_block_comment] = STATE(3480),
    [sym_line_comment] = STATE(3480),
    [sym__word_identifier] = ACTIONS(245),
    [anon_sym_begin] = ACTIONS(249),
    [anon_sym_module] = ACTIONS(251),
    [anon_sym_baremodule] = ACTIONS(251),
    [anon_sym_abstract] = ACTIONS(253),
    [anon_sym_primitive] = ACTIONS(255),
    [anon_sym_mutable] = ACTIONS(257),
    [anon_sym_struct] = ACTIONS(259),
    [anon_sym_function] = ACTIONS(261),
    [anon_sym_macro] = ACTIONS(263),
    [anon_sym_quote] = ACTIONS(265),
    [anon_sym_let] = ACTIONS(267),
    [anon_sym_if] = ACTIONS(269),
    [anon_sym_try] = ACTIONS(271),
    [anon_sym_for] = ACTIONS(273),
    [anon_sym_while] = ACTIONS(275),
    [sym_break_statement] = ACTIONS(277),
    [sym_continue_statement] = ACTIONS(277),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_global] = ACTIONS(531),
    [anon_sym_local] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(7744),
    [anon_sym_export] = ACTIONS(289),
    [anon_sym_public] = ACTIONS(291),
    [anon_sym_import] = ACTIONS(293),
    [anon_sym_using] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(7746),
    [anon_sym_LBRACE] = ACTIONS(7748),
    [anon_sym_DOLLAR] = ACTIONS(7750),
    [anon_sym_COLON2] = ACTIONS(303),
    [anon_sym_COLON_COLON] = ACTIONS(7752),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(307),
    [anon_sym_false] = ACTIONS(307),
    [aux_sym_integer_literal_token1] = ACTIONS(7754),
    [aux_sym_integer_literal_token2] = ACTIONS(7754),
    [aux_sym_integer_literal_token3] = ACTIONS(309),
    [aux_sym_integer_literal_token4] = ACTIONS(311),
    [aux_sym_float_literal_token1] = ACTIONS(7756),
    [aux_sym_float_literal_token3] = ACTIONS(7756),
    [aux_sym_float_literal_token4] = ACTIONS(7756),
    [sym_character_literal] = ACTIONS(7758),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7760),
    [sym__arrow_operator] = ACTIONS(317),
    [sym__comparison_operator] = ACTIONS(317),
    [sym__pipe_right_operator] = ACTIONS(7760),
    [sym__pipe_left_operator] = ACTIONS(7760),
    [sym__ellipsis_operator] = ACTIONS(7760),
    [sym__plus_operator] = ACTIONS(317),
    [sym__times_operator] = ACTIONS(317),
    [sym__rational_operator] = ACTIONS(7760),
    [sym__bitshift_operator] = ACTIONS(7760),
    [sym__power_operator] = ACTIONS(7760),
    [sym__tilde_operator] = ACTIONS(8872),
    [sym__type_order_operator] = ACTIONS(8872),
    [sym__unary_operator] = ACTIONS(3613),
    [sym__unary_plus_operator] = ACTIONS(3613),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3481] = {
    [sym__expression] = STATE(8348),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4323),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19321),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(7501),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(31),
    [sym_identifier] = STATE(4115),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3481),
    [sym_line_comment] = STATE(3481),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(567),
    [anon_sym_const] = ACTIONS(569),
    [anon_sym_global] = ACTIONS(571),
    [anon_sym_local] = ACTIONS(573),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(7974),
    [sym__type_order_operator] = ACTIONS(7974),
    [sym__unary_operator] = ACTIONS(609),
    [sym__unary_plus_operator] = ACTIONS(609),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3482] = {
    [sym__expression] = STATE(13390),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10666),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18869),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12885),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10167),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3482),
    [sym_line_comment] = STATE(3482),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4068),
    [sym__type_order_operator] = ACTIONS(4068),
    [sym__unary_operator] = ACTIONS(4070),
    [sym__unary_plus_operator] = ACTIONS(4070),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3483] = {
    [sym__expression] = STATE(12975),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3483),
    [sym_line_comment] = STATE(3483),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3484] = {
    [sym__expression] = STATE(12973),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3484),
    [sym_line_comment] = STATE(3484),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3485] = {
    [sym__expression] = STATE(8879),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3485),
    [sym_line_comment] = STATE(3485),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3486] = {
    [sym__expression] = STATE(12843),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3486),
    [sym_line_comment] = STATE(3486),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3487] = {
    [sym__expression] = STATE(8880),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3487),
    [sym_line_comment] = STATE(3487),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3488] = {
    [sym__expression] = STATE(8881),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3488),
    [sym_line_comment] = STATE(3488),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3489] = {
    [sym__expression] = STATE(8882),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3489),
    [sym_line_comment] = STATE(3489),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3490] = {
    [sym__expression] = STATE(8886),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3490),
    [sym_line_comment] = STATE(3490),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3491] = {
    [sym__expression] = STATE(8887),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3491),
    [sym_line_comment] = STATE(3491),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3492] = {
    [sym__expression] = STATE(8888),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3492),
    [sym_line_comment] = STATE(3492),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3493] = {
    [sym__expression] = STATE(8889),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3493),
    [sym_line_comment] = STATE(3493),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3494] = {
    [sym__expression] = STATE(8890),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3494),
    [sym_line_comment] = STATE(3494),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3495] = {
    [sym__expression] = STATE(8892),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3495),
    [sym_line_comment] = STATE(3495),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3496] = {
    [sym__expression] = STATE(8893),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3496),
    [sym_line_comment] = STATE(3496),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3497] = {
    [sym__expression] = STATE(8895),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3497),
    [sym_line_comment] = STATE(3497),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3498] = {
    [sym__expression] = STATE(7958),
    [sym_module_definition] = STATE(8198),
    [sym_abstract_definition] = STATE(8198),
    [sym_primitive_definition] = STATE(8198),
    [sym_struct_definition] = STATE(8198),
    [sym_function_definition] = STATE(8198),
    [sym_macro_definition] = STATE(8198),
    [sym_compound_statement] = STATE(8198),
    [sym_quote_statement] = STATE(8198),
    [sym_let_statement] = STATE(8198),
    [sym_if_statement] = STATE(8198),
    [sym_try_statement] = STATE(8198),
    [sym_for_statement] = STATE(8198),
    [sym_while_statement] = STATE(8198),
    [sym_return_statement] = STATE(8198),
    [sym_const_statement] = STATE(8198),
    [sym_global_statement] = STATE(8198),
    [sym_local_statement] = STATE(8198),
    [sym_export_statement] = STATE(8198),
    [sym_public_statement] = STATE(8198),
    [sym_import_statement] = STATE(8198),
    [sym_using_statement] = STATE(8198),
    [sym__primary_expression] = STATE(4595),
    [sym__array] = STATE(4729),
    [sym_comprehension_expression] = STATE(4582),
    [sym_matrix_expression] = STATE(4582),
    [sym_vector_expression] = STATE(4582),
    [sym_parenthesized_expression] = STATE(4729),
    [sym_tuple_expression] = STATE(4729),
    [sym_curly_expression] = STATE(4729),
    [sym_adjoint_expression] = STATE(4082),
    [sym_field_expression] = STATE(4729),
    [sym_index_expression] = STATE(4729),
    [sym_parametrized_type_expression] = STATE(4729),
    [sym_call_expression] = STATE(4729),
    [sym_broadcast_call_expression] = STATE(4729),
    [sym__closed_macrocall_expression] = STATE(4729),
    [sym_macrocall_expression] = STATE(8198),
    [sym_argument_list] = STATE(19048),
    [sym_interpolation_expression] = STATE(4729),
    [sym_quote_expression] = STATE(4729),
    [sym_binary_expression] = STATE(8198),
    [sym_unary_expression] = STATE(8198),
    [sym_range_expression] = STATE(8198),
    [sym_splat_expression] = STATE(8198),
    [sym_ternary_expression] = STATE(8198),
    [sym_typed_expression] = STATE(8441),
    [sym_unary_typed_expression] = STATE(8198),
    [sym_arrow_function_expression] = STATE(8198),
    [sym_juxtaposition_expression] = STATE(8198),
    [sym_compound_assignment_expression] = STATE(8198),
    [sym_where_expression] = STATE(8198),
    [sym_macro_identifier] = STATE(47),
    [sym_identifier] = STATE(4135),
    [sym_boolean_literal] = STATE(4729),
    [sym_integer_literal] = STATE(4089),
    [sym_float_literal] = STATE(4089),
    [sym__string] = STATE(4729),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(7447),
    [sym_block_comment] = STATE(3498),
    [sym_line_comment] = STATE(3498),
    [sym__word_identifier] = ACTIONS(535),
    [anon_sym_begin] = ACTIONS(537),
    [anon_sym_module] = ACTIONS(539),
    [anon_sym_baremodule] = ACTIONS(539),
    [anon_sym_abstract] = ACTIONS(541),
    [anon_sym_primitive] = ACTIONS(543),
    [anon_sym_mutable] = ACTIONS(545),
    [anon_sym_struct] = ACTIONS(547),
    [anon_sym_function] = ACTIONS(549),
    [anon_sym_macro] = ACTIONS(551),
    [anon_sym_quote] = ACTIONS(553),
    [anon_sym_let] = ACTIONS(555),
    [anon_sym_if] = ACTIONS(557),
    [anon_sym_try] = ACTIONS(559),
    [anon_sym_for] = ACTIONS(561),
    [anon_sym_while] = ACTIONS(563),
    [sym_break_statement] = ACTIONS(565),
    [sym_continue_statement] = ACTIONS(565),
    [anon_sym_return] = ACTIONS(1001),
    [anon_sym_const] = ACTIONS(1003),
    [anon_sym_global] = ACTIONS(1005),
    [anon_sym_local] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(7956),
    [anon_sym_export] = ACTIONS(577),
    [anon_sym_public] = ACTIONS(579),
    [anon_sym_import] = ACTIONS(581),
    [anon_sym_using] = ACTIONS(583),
    [anon_sym_LBRACK] = ACTIONS(7958),
    [anon_sym_LBRACE] = ACTIONS(7960),
    [anon_sym_DOLLAR] = ACTIONS(7962),
    [anon_sym_COLON2] = ACTIONS(591),
    [anon_sym_COLON_COLON] = ACTIONS(7964),
    [anon_sym_AT] = ACTIONS(5114),
    [anon_sym_true] = ACTIONS(597),
    [anon_sym_false] = ACTIONS(597),
    [aux_sym_integer_literal_token1] = ACTIONS(7966),
    [aux_sym_integer_literal_token2] = ACTIONS(7966),
    [aux_sym_integer_literal_token3] = ACTIONS(599),
    [aux_sym_integer_literal_token4] = ACTIONS(601),
    [aux_sym_float_literal_token1] = ACTIONS(7968),
    [aux_sym_float_literal_token3] = ACTIONS(7968),
    [aux_sym_float_literal_token4] = ACTIONS(7968),
    [sym_character_literal] = ACTIONS(7970),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(7972),
    [sym__arrow_operator] = ACTIONS(607),
    [sym__comparison_operator] = ACTIONS(607),
    [sym__pipe_right_operator] = ACTIONS(7972),
    [sym__pipe_left_operator] = ACTIONS(7972),
    [sym__ellipsis_operator] = ACTIONS(7972),
    [sym__plus_operator] = ACTIONS(607),
    [sym__times_operator] = ACTIONS(607),
    [sym__rational_operator] = ACTIONS(7972),
    [sym__bitshift_operator] = ACTIONS(7972),
    [sym__power_operator] = ACTIONS(7972),
    [sym__tilde_operator] = ACTIONS(8874),
    [sym__type_order_operator] = ACTIONS(8874),
    [sym__unary_operator] = ACTIONS(3892),
    [sym__unary_plus_operator] = ACTIONS(3892),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3499] = {
    [sym__expression] = STATE(12404),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10248),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18311),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12013),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(12),
    [sym_identifier] = STATE(10124),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3499),
    [sym_line_comment] = STATE(3499),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3317),
    [anon_sym_const] = ACTIONS(3319),
    [anon_sym_global] = ACTIONS(3321),
    [anon_sym_local] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(5054),
    [sym__type_order_operator] = ACTIONS(5054),
    [sym__unary_operator] = ACTIONS(3345),
    [sym__unary_plus_operator] = ACTIONS(3345),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3500] = {
    [sym__expression] = STATE(13227),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10552),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18953),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13010),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10237),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3500),
    [sym_line_comment] = STATE(3500),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4136),
    [sym__type_order_operator] = ACTIONS(4136),
    [sym__unary_operator] = ACTIONS(4138),
    [sym__unary_plus_operator] = ACTIONS(4138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3501] = {
    [sym__expression] = STATE(12845),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3501),
    [sym_line_comment] = STATE(3501),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3502] = {
    [sym__expression] = STATE(12846),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3502),
    [sym_line_comment] = STATE(3502),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3503] = {
    [sym__expression] = STATE(12847),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3503),
    [sym_line_comment] = STATE(3503),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3504] = {
    [sym__expression] = STATE(12848),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3504),
    [sym_line_comment] = STATE(3504),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3505] = {
    [sym__expression] = STATE(12849),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3505),
    [sym_line_comment] = STATE(3505),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3506] = {
    [sym__expression] = STATE(12850),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3506),
    [sym_line_comment] = STATE(3506),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3507] = {
    [sym__expression] = STATE(12851),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3507),
    [sym_line_comment] = STATE(3507),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3508] = {
    [sym__expression] = STATE(12852),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3508),
    [sym_line_comment] = STATE(3508),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3509] = {
    [sym__expression] = STATE(12853),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3509),
    [sym_line_comment] = STATE(3509),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3510] = {
    [sym__expression] = STATE(12854),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3510),
    [sym_line_comment] = STATE(3510),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3511] = {
    [sym__expression] = STATE(12855),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3511),
    [sym_line_comment] = STATE(3511),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3512] = {
    [sym__expression] = STATE(12856),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3512),
    [sym_line_comment] = STATE(3512),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3513] = {
    [sym__expression] = STATE(12580),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10383),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5077),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18552),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12398),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(51),
    [sym_identifier] = STATE(10100),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9035),
    [sym_float_literal] = STATE(9035),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3513),
    [sym_line_comment] = STATE(3513),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(3315),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3531),
    [anon_sym_const] = ACTIONS(3533),
    [anon_sym_global] = ACTIONS(3535),
    [anon_sym_local] = ACTIONS(3537),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(3325),
    [anon_sym_public] = ACTIONS(3327),
    [anon_sym_import] = ACTIONS(3329),
    [anon_sym_using] = ACTIONS(3331),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(5044),
    [anon_sym_COLON2] = ACTIONS(3335),
    [anon_sym_COLON_COLON] = ACTIONS(5046),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(5050),
    [aux_sym_integer_literal_token2] = ACTIONS(5050),
    [aux_sym_integer_literal_token3] = ACTIONS(3339),
    [aux_sym_integer_literal_token4] = ACTIONS(3341),
    [aux_sym_float_literal_token1] = ACTIONS(5052),
    [aux_sym_float_literal_token3] = ACTIONS(5052),
    [aux_sym_float_literal_token4] = ACTIONS(5052),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(8876),
    [sym__type_order_operator] = ACTIONS(8876),
    [sym__unary_operator] = ACTIONS(3894),
    [sym__unary_plus_operator] = ACTIONS(3894),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3514] = {
    [sym__expression] = STATE(13671),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3514),
    [sym_line_comment] = STATE(3514),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3515] = {
    [sym__expression] = STATE(13453),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3515),
    [sym_line_comment] = STATE(3515),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3516] = {
    [sym__expression] = STATE(13454),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3516),
    [sym_line_comment] = STATE(3516),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3517] = {
    [sym__expression] = STATE(8721),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3517),
    [sym_line_comment] = STATE(3517),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3518] = {
    [sym__expression] = STATE(8928),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3518),
    [sym_line_comment] = STATE(3518),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3519] = {
    [sym__expression] = STATE(8931),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3519),
    [sym_line_comment] = STATE(3519),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3520] = {
    [sym__expression] = STATE(8933),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3520),
    [sym_line_comment] = STATE(3520),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3521] = {
    [sym__expression] = STATE(8937),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3521),
    [sym_line_comment] = STATE(3521),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3522] = {
    [sym__expression] = STATE(8938),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3522),
    [sym_line_comment] = STATE(3522),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3523] = {
    [sym__expression] = STATE(8939),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3523),
    [sym_line_comment] = STATE(3523),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3524] = {
    [sym__expression] = STATE(8940),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3524),
    [sym_line_comment] = STATE(3524),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3525] = {
    [sym__expression] = STATE(8941),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3525),
    [sym_line_comment] = STATE(3525),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3526] = {
    [sym__expression] = STATE(8942),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3526),
    [sym_line_comment] = STATE(3526),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3527] = {
    [sym__expression] = STATE(8943),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3527),
    [sym_line_comment] = STATE(3527),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3528] = {
    [sym__expression] = STATE(8944),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3528),
    [sym_line_comment] = STATE(3528),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3529] = {
    [sym__expression] = STATE(8801),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3529),
    [sym_line_comment] = STATE(3529),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3530] = {
    [sym__expression] = STATE(8802),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3530),
    [sym_line_comment] = STATE(3530),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3531] = {
    [sym__expression] = STATE(8194),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4596),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(18495),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(8442),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(49),
    [sym_identifier] = STATE(4114),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3531),
    [sym_line_comment] = STATE(3531),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(1009),
    [anon_sym_const] = ACTIONS(1011),
    [anon_sym_global] = ACTIONS(1013),
    [anon_sym_local] = ACTIONS(1015),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8880),
    [sym__type_order_operator] = ACTIONS(8880),
    [sym__unary_operator] = ACTIONS(3908),
    [sym__unary_plus_operator] = ACTIONS(3908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3532] = {
    [sym__expression] = STATE(8391),
    [sym_module_definition] = STATE(8077),
    [sym_abstract_definition] = STATE(8077),
    [sym_primitive_definition] = STATE(8077),
    [sym_struct_definition] = STATE(8077),
    [sym_function_definition] = STATE(8077),
    [sym_macro_definition] = STATE(8077),
    [sym_compound_statement] = STATE(8077),
    [sym_quote_statement] = STATE(8077),
    [sym_let_statement] = STATE(8077),
    [sym_if_statement] = STATE(8077),
    [sym_try_statement] = STATE(8077),
    [sym_for_statement] = STATE(8077),
    [sym_while_statement] = STATE(8077),
    [sym_return_statement] = STATE(8077),
    [sym_const_statement] = STATE(8077),
    [sym_global_statement] = STATE(8077),
    [sym_local_statement] = STATE(8077),
    [sym_export_statement] = STATE(8077),
    [sym_public_statement] = STATE(8077),
    [sym_import_statement] = STATE(8077),
    [sym_using_statement] = STATE(8077),
    [sym__primary_expression] = STATE(4246),
    [sym__array] = STATE(4619),
    [sym_comprehension_expression] = STATE(4758),
    [sym_matrix_expression] = STATE(4758),
    [sym_vector_expression] = STATE(4758),
    [sym_parenthesized_expression] = STATE(4619),
    [sym_tuple_expression] = STATE(4619),
    [sym_curly_expression] = STATE(4619),
    [sym_adjoint_expression] = STATE(4078),
    [sym_field_expression] = STATE(4619),
    [sym_index_expression] = STATE(4619),
    [sym_parametrized_type_expression] = STATE(4619),
    [sym_call_expression] = STATE(4619),
    [sym_broadcast_call_expression] = STATE(4619),
    [sym__closed_macrocall_expression] = STATE(4619),
    [sym_macrocall_expression] = STATE(8077),
    [sym_argument_list] = STATE(19201),
    [sym_interpolation_expression] = STATE(4619),
    [sym_quote_expression] = STATE(4619),
    [sym_binary_expression] = STATE(8077),
    [sym_unary_expression] = STATE(8077),
    [sym_range_expression] = STATE(8077),
    [sym_splat_expression] = STATE(8077),
    [sym_ternary_expression] = STATE(8077),
    [sym_typed_expression] = STATE(7661),
    [sym_unary_typed_expression] = STATE(8077),
    [sym_arrow_function_expression] = STATE(8077),
    [sym_juxtaposition_expression] = STATE(8077),
    [sym_compound_assignment_expression] = STATE(8077),
    [sym_where_expression] = STATE(8077),
    [sym_macro_identifier] = STATE(33),
    [sym_identifier] = STATE(4121),
    [sym_boolean_literal] = STATE(4619),
    [sym_integer_literal] = STATE(4088),
    [sym_float_literal] = STATE(4088),
    [sym__string] = STATE(4619),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(7696),
    [sym_block_comment] = STATE(3532),
    [sym_line_comment] = STATE(3532),
    [sym__word_identifier] = ACTIONS(451),
    [anon_sym_begin] = ACTIONS(453),
    [anon_sym_module] = ACTIONS(455),
    [anon_sym_baremodule] = ACTIONS(455),
    [anon_sym_abstract] = ACTIONS(457),
    [anon_sym_primitive] = ACTIONS(459),
    [anon_sym_mutable] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(463),
    [anon_sym_function] = ACTIONS(465),
    [anon_sym_macro] = ACTIONS(467),
    [anon_sym_quote] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(471),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_try] = ACTIONS(475),
    [anon_sym_for] = ACTIONS(477),
    [anon_sym_while] = ACTIONS(479),
    [sym_break_statement] = ACTIONS(481),
    [sym_continue_statement] = ACTIONS(481),
    [anon_sym_return] = ACTIONS(483),
    [anon_sym_const] = ACTIONS(485),
    [anon_sym_global] = ACTIONS(487),
    [anon_sym_local] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(8288),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_public] = ACTIONS(495),
    [anon_sym_import] = ACTIONS(497),
    [anon_sym_using] = ACTIONS(499),
    [anon_sym_LBRACK] = ACTIONS(8290),
    [anon_sym_LBRACE] = ACTIONS(8292),
    [anon_sym_DOLLAR] = ACTIONS(8294),
    [anon_sym_COLON2] = ACTIONS(507),
    [anon_sym_COLON_COLON] = ACTIONS(8296),
    [anon_sym_AT] = ACTIONS(5048),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [aux_sym_integer_literal_token1] = ACTIONS(8298),
    [aux_sym_integer_literal_token2] = ACTIONS(8298),
    [aux_sym_integer_literal_token3] = ACTIONS(515),
    [aux_sym_integer_literal_token4] = ACTIONS(517),
    [aux_sym_float_literal_token1] = ACTIONS(8300),
    [aux_sym_float_literal_token3] = ACTIONS(8300),
    [aux_sym_float_literal_token4] = ACTIONS(8300),
    [sym_character_literal] = ACTIONS(8302),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(8304),
    [sym__arrow_operator] = ACTIONS(523),
    [sym__comparison_operator] = ACTIONS(523),
    [sym__pipe_right_operator] = ACTIONS(8304),
    [sym__pipe_left_operator] = ACTIONS(8304),
    [sym__ellipsis_operator] = ACTIONS(8304),
    [sym__plus_operator] = ACTIONS(523),
    [sym__times_operator] = ACTIONS(523),
    [sym__rational_operator] = ACTIONS(8304),
    [sym__bitshift_operator] = ACTIONS(8304),
    [sym__power_operator] = ACTIONS(8304),
    [sym__tilde_operator] = ACTIONS(8306),
    [sym__type_order_operator] = ACTIONS(8306),
    [sym__unary_operator] = ACTIONS(525),
    [sym__unary_plus_operator] = ACTIONS(525),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3533] = {
    [sym__expression] = STATE(12871),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3533),
    [sym_line_comment] = STATE(3533),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3534] = {
    [sym__expression] = STATE(13866),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3534),
    [sym_line_comment] = STATE(3534),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3535] = {
    [sym__expression] = STATE(13480),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3535),
    [sym_line_comment] = STATE(3535),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3536] = {
    [sym__expression] = STATE(13482),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3536),
    [sym_line_comment] = STATE(3536),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3537] = {
    [sym__expression] = STATE(13483),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3537),
    [sym_line_comment] = STATE(3537),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3538] = {
    [sym__expression] = STATE(13484),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3538),
    [sym_line_comment] = STATE(3538),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3539] = {
    [sym__expression] = STATE(13485),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3539),
    [sym_line_comment] = STATE(3539),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3540] = {
    [sym__expression] = STATE(13486),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3540),
    [sym_line_comment] = STATE(3540),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3541] = {
    [sym__expression] = STATE(13487),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3541),
    [sym_line_comment] = STATE(3541),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3542] = {
    [sym__expression] = STATE(13489),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3542),
    [sym_line_comment] = STATE(3542),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3543] = {
    [sym__expression] = STATE(13490),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3543),
    [sym_line_comment] = STATE(3543),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3544] = {
    [sym__expression] = STATE(13491),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3544),
    [sym_line_comment] = STATE(3544),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3545] = {
    [sym__expression] = STATE(13492),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3545),
    [sym_line_comment] = STATE(3545),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3546] = {
    [sym__expression] = STATE(13493),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3546),
    [sym_line_comment] = STATE(3546),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3547] = {
    [sym__expression] = STATE(13111),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3547),
    [sym_line_comment] = STATE(3547),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3548] = {
    [sym__expression] = STATE(13494),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3548),
    [sym_line_comment] = STATE(3548),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3549] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10757),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18701),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13177),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(100),
    [sym_identifier] = STATE(10249),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3549),
    [sym_line_comment] = STATE(3549),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4012),
    [anon_sym_local] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4112),
    [sym__type_order_operator] = ACTIONS(4112),
    [sym__unary_operator] = ACTIONS(4114),
    [sym__unary_plus_operator] = ACTIONS(4114),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3550] = {
    [sym__expression] = STATE(353),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3550),
    [sym_line_comment] = STATE(3550),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3551] = {
    [sym__expression] = STATE(13387),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10641),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19356),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13085),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(78),
    [sym_identifier] = STATE(10332),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3551),
    [sym_line_comment] = STATE(3551),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3900),
    [anon_sym_local] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3904),
    [sym__type_order_operator] = ACTIONS(3904),
    [sym__unary_operator] = ACTIONS(3906),
    [sym__unary_plus_operator] = ACTIONS(3906),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3552] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11265),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11265),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13649),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10653),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3552),
    [sym_line_comment] = STATE(3552),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3553] = {
    [sym__expression] = STATE(9322),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3553),
    [sym_line_comment] = STATE(3553),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3554] = {
    [sym__expression] = STATE(9323),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3554),
    [sym_line_comment] = STATE(3554),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3555] = {
    [sym__expression] = STATE(9326),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3555),
    [sym_line_comment] = STATE(3555),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3556] = {
    [sym__expression] = STATE(8660),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3556),
    [sym_line_comment] = STATE(3556),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3557] = {
    [sym__expression] = STATE(8661),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3557),
    [sym_line_comment] = STATE(3557),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3558] = {
    [sym__expression] = STATE(8662),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3558),
    [sym_line_comment] = STATE(3558),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3559] = {
    [sym__expression] = STATE(8663),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3559),
    [sym_line_comment] = STATE(3559),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3560] = {
    [sym__expression] = STATE(8664),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3560),
    [sym_line_comment] = STATE(3560),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3561] = {
    [sym__expression] = STATE(8665),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3561),
    [sym_line_comment] = STATE(3561),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3562] = {
    [sym__expression] = STATE(8666),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3562),
    [sym_line_comment] = STATE(3562),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3563] = {
    [sym__expression] = STATE(8667),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3563),
    [sym_line_comment] = STATE(3563),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3564] = {
    [sym__expression] = STATE(8668),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3564),
    [sym_line_comment] = STATE(3564),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3565] = {
    [sym__expression] = STATE(8669),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3565),
    [sym_line_comment] = STATE(3565),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3566] = {
    [sym__expression] = STATE(8670),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3566),
    [sym_line_comment] = STATE(3566),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3567] = {
    [sym__expression] = STATE(8671),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3567),
    [sym_line_comment] = STATE(3567),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3568] = {
    [sym__expression] = STATE(8628),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3568),
    [sym_line_comment] = STATE(3568),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3569] = {
    [sym__expression] = STATE(9327),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3569),
    [sym_line_comment] = STATE(3569),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3570] = {
    [sym__expression] = STATE(12516),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3570),
    [sym_line_comment] = STATE(3570),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3571] = {
    [sym__expression] = STATE(8678),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4568),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(19611),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8422),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4213),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3571),
    [sym_line_comment] = STATE(3571),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(6904),
    [sym__type_order_operator] = ACTIONS(6904),
    [sym__unary_operator] = ACTIONS(993),
    [sym__unary_plus_operator] = ACTIONS(993),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3572] = {
    [sym__expression] = STATE(8900),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3572),
    [sym_line_comment] = STATE(3572),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3573] = {
    [sym__expression] = STATE(8902),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3573),
    [sym_line_comment] = STATE(3573),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3574] = {
    [sym__expression] = STATE(8929),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3574),
    [sym_line_comment] = STATE(3574),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3575] = {
    [sym__expression] = STATE(8936),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3575),
    [sym_line_comment] = STATE(3575),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3576] = {
    [sym__expression] = STATE(8697),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3576),
    [sym_line_comment] = STATE(3576),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3577] = {
    [sym__expression] = STATE(8698),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3577),
    [sym_line_comment] = STATE(3577),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3578] = {
    [sym__expression] = STATE(8699),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3578),
    [sym_line_comment] = STATE(3578),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3579] = {
    [sym__expression] = STATE(8700),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3579),
    [sym_line_comment] = STATE(3579),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3580] = {
    [sym__expression] = STATE(8701),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3580),
    [sym_line_comment] = STATE(3580),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3581] = {
    [sym__expression] = STATE(7937),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3581),
    [sym_line_comment] = STATE(3581),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3582] = {
    [sym__expression] = STATE(13636),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3582),
    [sym_line_comment] = STATE(3582),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3583] = {
    [sym__expression] = STATE(13637),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3583),
    [sym_line_comment] = STATE(3583),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3584] = {
    [sym__expression] = STATE(13640),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3584),
    [sym_line_comment] = STATE(3584),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3585] = {
    [sym__expression] = STATE(13439),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3585),
    [sym_line_comment] = STATE(3585),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3586] = {
    [sym__expression] = STATE(13642),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3586),
    [sym_line_comment] = STATE(3586),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3587] = {
    [sym__expression] = STATE(13643),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3587),
    [sym_line_comment] = STATE(3587),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3588] = {
    [sym__expression] = STATE(13644),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3588),
    [sym_line_comment] = STATE(3588),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3589] = {
    [sym__expression] = STATE(13645),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3589),
    [sym_line_comment] = STATE(3589),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3590] = {
    [sym__expression] = STATE(13646),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3590),
    [sym_line_comment] = STATE(3590),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3591] = {
    [sym__expression] = STATE(13884),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3591),
    [sym_line_comment] = STATE(3591),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3592] = {
    [sym__expression] = STATE(13635),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3592),
    [sym_line_comment] = STATE(3592),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3593] = {
    [sym__expression] = STATE(13638),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3593),
    [sym_line_comment] = STATE(3593),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3594] = {
    [sym__expression] = STATE(13639),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10701),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19561),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13416),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10430),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3594),
    [sym_line_comment] = STATE(3594),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3992),
    [sym__type_order_operator] = ACTIONS(3992),
    [sym__unary_operator] = ACTIONS(3994),
    [sym__unary_plus_operator] = ACTIONS(3994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3595] = {
    [sym__expression] = STATE(9332),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3595),
    [sym_line_comment] = STATE(3595),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3596] = {
    [sym__expression] = STATE(13354),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3596),
    [sym_line_comment] = STATE(3596),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3597] = {
    [sym__expression] = STATE(13291),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3597),
    [sym_line_comment] = STATE(3597),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3598] = {
    [sym__expression] = STATE(13292),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3598),
    [sym_line_comment] = STATE(3598),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3599] = {
    [sym__expression] = STATE(13294),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3599),
    [sym_line_comment] = STATE(3599),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3600] = {
    [sym__expression] = STATE(13438),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3600),
    [sym_line_comment] = STATE(3600),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3601] = {
    [sym__expression] = STATE(13296),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3601),
    [sym_line_comment] = STATE(3601),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3602] = {
    [sym__expression] = STATE(13297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3602),
    [sym_line_comment] = STATE(3602),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3603] = {
    [sym__expression] = STATE(13127),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3603),
    [sym_line_comment] = STATE(3603),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3604] = {
    [sym__expression] = STATE(13301),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3604),
    [sym_line_comment] = STATE(3604),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3605] = {
    [sym__expression] = STATE(13309),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3605),
    [sym_line_comment] = STATE(3605),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3606] = {
    [sym__expression] = STATE(13334),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3606),
    [sym_line_comment] = STATE(3606),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3607] = {
    [sym__expression] = STATE(13337),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3607),
    [sym_line_comment] = STATE(3607),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3608] = {
    [sym__expression] = STATE(13340),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3608),
    [sym_line_comment] = STATE(3608),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3609] = {
    [sym__expression] = STATE(13341),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3609),
    [sym_line_comment] = STATE(3609),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3610] = {
    [sym__expression] = STATE(13342),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3610),
    [sym_line_comment] = STATE(3610),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3611] = {
    [sym__expression] = STATE(12989),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10648),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19466),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12809),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(115),
    [sym_identifier] = STATE(10305),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3611),
    [sym_line_comment] = STATE(3611),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(4000),
    [anon_sym_local] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4004),
    [sym__type_order_operator] = ACTIONS(4004),
    [sym__unary_operator] = ACTIONS(4006),
    [sym__unary_plus_operator] = ACTIONS(4006),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3612] = {
    [sym__expression] = STATE(9331),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3612),
    [sym_line_comment] = STATE(3612),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3613] = {
    [sym__expression] = STATE(12729),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3613),
    [sym_line_comment] = STATE(3613),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3614] = {
    [sym__expression] = STATE(12653),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3614),
    [sym_line_comment] = STATE(3614),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3615] = {
    [sym__expression] = STATE(12654),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3615),
    [sym_line_comment] = STATE(3615),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3616] = {
    [sym__expression] = STATE(12672),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3616),
    [sym_line_comment] = STATE(3616),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3617] = {
    [sym__expression] = STATE(12673),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3617),
    [sym_line_comment] = STATE(3617),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3618] = {
    [sym__expression] = STATE(12657),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3618),
    [sym_line_comment] = STATE(3618),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3619] = {
    [sym__expression] = STATE(12658),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3619),
    [sym_line_comment] = STATE(3619),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3620] = {
    [sym__expression] = STATE(12676),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3620),
    [sym_line_comment] = STATE(3620),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3621] = {
    [sym__expression] = STATE(12677),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3621),
    [sym_line_comment] = STATE(3621),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3622] = {
    [sym__expression] = STATE(12661),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3622),
    [sym_line_comment] = STATE(3622),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3623] = {
    [sym__expression] = STATE(12662),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3623),
    [sym_line_comment] = STATE(3623),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3624] = {
    [sym__expression] = STATE(12663),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3624),
    [sym_line_comment] = STATE(3624),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3625] = {
    [sym__expression] = STATE(12664),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3625),
    [sym_line_comment] = STATE(3625),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3626] = {
    [sym__expression] = STATE(12665),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3626),
    [sym_line_comment] = STATE(3626),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3627] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3627),
    [sym_line_comment] = STATE(3627),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3628] = {
    [sym__expression] = STATE(12666),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3628),
    [sym_line_comment] = STATE(3628),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3629] = {
    [sym__expression] = STATE(9334),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3629),
    [sym_line_comment] = STATE(3629),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3630] = {
    [sym__expression] = STATE(12734),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3630),
    [sym_line_comment] = STATE(3630),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3631] = {
    [sym__expression] = STATE(12667),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3631),
    [sym_line_comment] = STATE(3631),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3632] = {
    [sym__expression] = STATE(12668),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3632),
    [sym_line_comment] = STATE(3632),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3633] = {
    [sym__expression] = STATE(12674),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3633),
    [sym_line_comment] = STATE(3633),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3634] = {
    [sym__expression] = STATE(12675),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3634),
    [sym_line_comment] = STATE(3634),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3635] = {
    [sym__expression] = STATE(12678),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10339),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19506),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12185),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10040),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3635),
    [sym_line_comment] = STATE(3635),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3888),
    [sym__type_order_operator] = ACTIONS(3888),
    [sym__unary_operator] = ACTIONS(3890),
    [sym__unary_plus_operator] = ACTIONS(3890),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3636] = {
    [sym__expression] = STATE(9335),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3636),
    [sym_line_comment] = STATE(3636),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3637] = {
    [sym__expression] = STATE(9319),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3637),
    [sym_line_comment] = STATE(3637),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3638] = {
    [sym__expression] = STATE(9194),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3638),
    [sym_line_comment] = STATE(3638),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3639] = {
    [sym__expression] = STATE(12727),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3639),
    [sym_line_comment] = STATE(3639),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3640] = {
    [sym__expression] = STATE(12687),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3640),
    [sym_line_comment] = STATE(3640),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3641] = {
    [sym__expression] = STATE(12688),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3641),
    [sym_line_comment] = STATE(3641),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3642] = {
    [sym__expression] = STATE(7760),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3642),
    [sym_line_comment] = STATE(3642),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3643] = {
    [sym__expression] = STATE(12690),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3643),
    [sym_line_comment] = STATE(3643),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3644] = {
    [sym__expression] = STATE(12691),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3644),
    [sym_line_comment] = STATE(3644),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3645] = {
    [sym__expression] = STATE(12693),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3645),
    [sym_line_comment] = STATE(3645),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3646] = {
    [sym__expression] = STATE(12694),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3646),
    [sym_line_comment] = STATE(3646),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3647] = {
    [sym__expression] = STATE(12699),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3647),
    [sym_line_comment] = STATE(3647),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3648] = {
    [sym__expression] = STATE(12700),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3648),
    [sym_line_comment] = STATE(3648),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3649] = {
    [sym__expression] = STATE(12701),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3649),
    [sym_line_comment] = STATE(3649),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3650] = {
    [sym__expression] = STATE(12704),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3650),
    [sym_line_comment] = STATE(3650),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3651] = {
    [sym__expression] = STATE(12705),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3651),
    [sym_line_comment] = STATE(3651),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3652] = {
    [sym__expression] = STATE(12706),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3652),
    [sym_line_comment] = STATE(3652),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3653] = {
    [sym__expression] = STATE(12707),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3653),
    [sym_line_comment] = STATE(3653),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3654] = {
    [sym__expression] = STATE(12708),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3654),
    [sym_line_comment] = STATE(3654),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3655] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10371),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18650),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12014),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10102),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3655),
    [sym_line_comment] = STATE(3655),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4108),
    [sym__type_order_operator] = ACTIONS(4108),
    [sym__unary_operator] = ACTIONS(4110),
    [sym__unary_plus_operator] = ACTIONS(4110),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3656] = {
    [sym__expression] = STATE(8308),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3656),
    [sym_line_comment] = STATE(3656),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3657] = {
    [sym__expression] = STATE(12655),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3657),
    [sym_line_comment] = STATE(3657),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3658] = {
    [sym__expression] = STATE(12656),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3658),
    [sym_line_comment] = STATE(3658),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3659] = {
    [sym__expression] = STATE(12659),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3659),
    [sym_line_comment] = STATE(3659),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3660] = {
    [sym__expression] = STATE(12660),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3660),
    [sym_line_comment] = STATE(3660),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3661] = {
    [sym__expression] = STATE(12716),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3661),
    [sym_line_comment] = STATE(3661),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3662] = {
    [sym__expression] = STATE(12717),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3662),
    [sym_line_comment] = STATE(3662),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3663] = {
    [sym__expression] = STATE(12718),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3663),
    [sym_line_comment] = STATE(3663),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3664] = {
    [sym__expression] = STATE(12719),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3664),
    [sym_line_comment] = STATE(3664),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3665] = {
    [sym__expression] = STATE(12720),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3665),
    [sym_line_comment] = STATE(3665),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3666] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10337),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19577),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12136),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10095),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3666),
    [sym_line_comment] = STATE(3666),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3874),
    [sym__type_order_operator] = ACTIONS(3874),
    [sym__unary_operator] = ACTIONS(3876),
    [sym__unary_plus_operator] = ACTIONS(3876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3667] = {
    [sym__expression] = STATE(9329),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3667),
    [sym_line_comment] = STATE(3667),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3668] = {
    [sym__expression] = STATE(9320),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3668),
    [sym_line_comment] = STATE(3668),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3669] = {
    [sym__expression] = STATE(9321),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3669),
    [sym_line_comment] = STATE(3669),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3670] = {
    [sym__expression] = STATE(9324),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3670),
    [sym_line_comment] = STATE(3670),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3671] = {
    [sym__expression] = STATE(9325),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5776),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19072),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9258),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(135),
    [sym_identifier] = STATE(4552),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3671),
    [sym_line_comment] = STATE(3671),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(2221),
    [anon_sym_const] = ACTIONS(2223),
    [anon_sym_global] = ACTIONS(2225),
    [anon_sym_local] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(4172),
    [sym__type_order_operator] = ACTIONS(4172),
    [sym__unary_operator] = ACTIONS(4174),
    [sym__unary_plus_operator] = ACTIONS(4174),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3672] = {
    [sym__expression] = STATE(60),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3672),
    [sym_line_comment] = STATE(3672),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3673] = {
    [sym__expression] = STATE(9241),
    [sym_module_definition] = STATE(9293),
    [sym_abstract_definition] = STATE(9293),
    [sym_primitive_definition] = STATE(9293),
    [sym_struct_definition] = STATE(9293),
    [sym_function_definition] = STATE(9293),
    [sym_macro_definition] = STATE(9293),
    [sym_compound_statement] = STATE(9293),
    [sym_quote_statement] = STATE(9293),
    [sym_let_statement] = STATE(9293),
    [sym_if_statement] = STATE(9293),
    [sym_try_statement] = STATE(9293),
    [sym_for_statement] = STATE(9293),
    [sym_while_statement] = STATE(9293),
    [sym_return_statement] = STATE(9293),
    [sym_const_statement] = STATE(9293),
    [sym_global_statement] = STATE(9293),
    [sym_local_statement] = STATE(9293),
    [sym_export_statement] = STATE(9293),
    [sym_public_statement] = STATE(9293),
    [sym_import_statement] = STATE(9293),
    [sym_using_statement] = STATE(9293),
    [sym__primary_expression] = STATE(5328),
    [sym__array] = STATE(5760),
    [sym_comprehension_expression] = STATE(5409),
    [sym_matrix_expression] = STATE(5409),
    [sym_vector_expression] = STATE(5409),
    [sym_parenthesized_expression] = STATE(5760),
    [sym_tuple_expression] = STATE(5760),
    [sym_curly_expression] = STATE(5760),
    [sym_adjoint_expression] = STATE(4085),
    [sym_field_expression] = STATE(5760),
    [sym_index_expression] = STATE(5760),
    [sym_parametrized_type_expression] = STATE(5760),
    [sym_call_expression] = STATE(5760),
    [sym_broadcast_call_expression] = STATE(5760),
    [sym__closed_macrocall_expression] = STATE(5760),
    [sym_macrocall_expression] = STATE(9293),
    [sym_argument_list] = STATE(19305),
    [sym_interpolation_expression] = STATE(5760),
    [sym_quote_expression] = STATE(5760),
    [sym_binary_expression] = STATE(9293),
    [sym_unary_expression] = STATE(9293),
    [sym_range_expression] = STATE(9293),
    [sym_splat_expression] = STATE(9293),
    [sym_ternary_expression] = STATE(9293),
    [sym_typed_expression] = STATE(9012),
    [sym_unary_typed_expression] = STATE(9293),
    [sym_arrow_function_expression] = STATE(9293),
    [sym_juxtaposition_expression] = STATE(9293),
    [sym_compound_assignment_expression] = STATE(9293),
    [sym_where_expression] = STATE(9293),
    [sym_macro_identifier] = STATE(94),
    [sym_identifier] = STATE(4594),
    [sym_boolean_literal] = STATE(5760),
    [sym_integer_literal] = STATE(4094),
    [sym_float_literal] = STATE(4094),
    [sym__string] = STATE(5760),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(9013),
    [sym_block_comment] = STATE(3673),
    [sym_line_comment] = STATE(3673),
    [sym__word_identifier] = ACTIONS(1241),
    [anon_sym_begin] = ACTIONS(1243),
    [anon_sym_module] = ACTIONS(1245),
    [anon_sym_baremodule] = ACTIONS(1245),
    [anon_sym_abstract] = ACTIONS(1247),
    [anon_sym_primitive] = ACTIONS(1249),
    [anon_sym_mutable] = ACTIONS(1251),
    [anon_sym_struct] = ACTIONS(1253),
    [anon_sym_function] = ACTIONS(1255),
    [anon_sym_macro] = ACTIONS(1257),
    [anon_sym_quote] = ACTIONS(1259),
    [anon_sym_let] = ACTIONS(1261),
    [anon_sym_if] = ACTIONS(1263),
    [anon_sym_try] = ACTIONS(1265),
    [anon_sym_for] = ACTIONS(1267),
    [anon_sym_while] = ACTIONS(1269),
    [sym_break_statement] = ACTIONS(1271),
    [sym_continue_statement] = ACTIONS(1271),
    [anon_sym_return] = ACTIONS(1273),
    [anon_sym_const] = ACTIONS(1275),
    [anon_sym_global] = ACTIONS(1277),
    [anon_sym_local] = ACTIONS(1279),
    [anon_sym_LPAREN] = ACTIONS(1281),
    [anon_sym_export] = ACTIONS(1283),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1287),
    [anon_sym_using] = ACTIONS(1289),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_DOLLAR] = ACTIONS(1295),
    [anon_sym_COLON2] = ACTIONS(1297),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1303),
    [anon_sym_false] = ACTIONS(1303),
    [aux_sym_integer_literal_token1] = ACTIONS(1305),
    [aux_sym_integer_literal_token2] = ACTIONS(1305),
    [aux_sym_integer_literal_token3] = ACTIONS(1307),
    [aux_sym_integer_literal_token4] = ACTIONS(1309),
    [aux_sym_float_literal_token1] = ACTIONS(1311),
    [aux_sym_float_literal_token3] = ACTIONS(1311),
    [aux_sym_float_literal_token4] = ACTIONS(1311),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1315),
    [sym__arrow_operator] = ACTIONS(1317),
    [sym__comparison_operator] = ACTIONS(1317),
    [sym__pipe_right_operator] = ACTIONS(1315),
    [sym__pipe_left_operator] = ACTIONS(1315),
    [sym__ellipsis_operator] = ACTIONS(1315),
    [sym__plus_operator] = ACTIONS(1317),
    [sym__times_operator] = ACTIONS(1317),
    [sym__rational_operator] = ACTIONS(1315),
    [sym__bitshift_operator] = ACTIONS(1315),
    [sym__power_operator] = ACTIONS(1315),
    [sym__tilde_operator] = ACTIONS(1319),
    [sym__type_order_operator] = ACTIONS(1319),
    [sym__unary_operator] = ACTIONS(1321),
    [sym__unary_plus_operator] = ACTIONS(1321),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3674] = {
    [sym__expression] = STATE(8540),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3674),
    [sym_line_comment] = STATE(3674),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3675] = {
    [sym__expression] = STATE(360),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3675),
    [sym_line_comment] = STATE(3675),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3676] = {
    [sym__expression] = STATE(8544),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3676),
    [sym_line_comment] = STATE(3676),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3677] = {
    [sym__expression] = STATE(14193),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3677),
    [sym_line_comment] = STATE(3677),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3678] = {
    [sym__expression] = STATE(14100),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3678),
    [sym_line_comment] = STATE(3678),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3679] = {
    [sym__expression] = STATE(8550),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3679),
    [sym_line_comment] = STATE(3679),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3680] = {
    [sym__expression] = STATE(8551),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4263),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19153),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(7452),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4119),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3680),
    [sym_line_comment] = STATE(3680),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(4956),
    [sym__type_order_operator] = ACTIONS(4956),
    [sym__unary_operator] = ACTIONS(699),
    [sym__unary_plus_operator] = ACTIONS(699),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3681] = {
    [sym__expression] = STATE(14159),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3681),
    [sym_line_comment] = STATE(3681),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3682] = {
    [sym__expression] = STATE(14145),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3682),
    [sym_line_comment] = STATE(3682),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3683] = {
    [sym__expression] = STATE(14229),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3683),
    [sym_line_comment] = STATE(3683),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3684] = {
    [sym__expression] = STATE(14190),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3684),
    [sym_line_comment] = STATE(3684),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3685] = {
    [sym__expression] = STATE(14135),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3685),
    [sym_line_comment] = STATE(3685),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3686] = {
    [sym__expression] = STATE(14117),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3686),
    [sym_line_comment] = STATE(3686),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3687] = {
    [sym__expression] = STATE(67),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3687),
    [sym_line_comment] = STATE(3687),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3688] = {
    [sym__expression] = STATE(14143),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3688),
    [sym_line_comment] = STATE(3688),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3689] = {
    [sym__expression] = STATE(13884),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3689),
    [sym_line_comment] = STATE(3689),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3690] = {
    [sym__expression] = STATE(365),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3690),
    [sym_line_comment] = STATE(3690),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3691] = {
    [sym__expression] = STATE(8908),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4576),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(19384),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8426),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4110),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3691),
    [sym_line_comment] = STATE(3691),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8890),
    [sym__type_order_operator] = ACTIONS(8890),
    [sym__unary_operator] = ACTIONS(3928),
    [sym__unary_plus_operator] = ACTIONS(3928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3692] = {
    [sym__expression] = STATE(73),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3692),
    [sym_line_comment] = STATE(3692),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3693] = {
    [sym__expression] = STATE(352),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3693),
    [sym_line_comment] = STATE(3693),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3694] = {
    [sym__expression] = STATE(76),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3694),
    [sym_line_comment] = STATE(3694),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3695] = {
    [sym__expression] = STATE(323),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3695),
    [sym_line_comment] = STATE(3695),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3696] = {
    [sym__expression] = STATE(77),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3696),
    [sym_line_comment] = STATE(3696),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3697] = {
    [sym__expression] = STATE(324),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3697),
    [sym_line_comment] = STATE(3697),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3698] = {
    [sym__expression] = STATE(80),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3698),
    [sym_line_comment] = STATE(3698),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3699] = {
    [sym__expression] = STATE(368),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3699),
    [sym_line_comment] = STATE(3699),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3700] = {
    [sym__expression] = STATE(83),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3700),
    [sym_line_comment] = STATE(3700),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3701] = {
    [sym__expression] = STATE(12068),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3701),
    [sym_line_comment] = STATE(3701),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3702] = {
    [sym__expression] = STATE(8854),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3702),
    [sym_line_comment] = STATE(3702),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3703] = {
    [sym__expression] = STATE(318),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3703),
    [sym_line_comment] = STATE(3703),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3704] = {
    [sym__expression] = STATE(14187),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3704),
    [sym_line_comment] = STATE(3704),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3705] = {
    [sym__expression] = STATE(8619),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3705),
    [sym_line_comment] = STATE(3705),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3706] = {
    [sym__expression] = STATE(8636),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3706),
    [sym_line_comment] = STATE(3706),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3707] = {
    [sym__expression] = STATE(8638),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3707),
    [sym_line_comment] = STATE(3707),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3708] = {
    [sym__expression] = STATE(14214),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3708),
    [sym_line_comment] = STATE(3708),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3709] = {
    [sym__expression] = STATE(14144),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11361),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18299),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14009),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10678),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3709),
    [sym_line_comment] = STATE(3709),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4180),
    [sym__type_order_operator] = ACTIONS(4180),
    [sym__unary_operator] = ACTIONS(4182),
    [sym__unary_plus_operator] = ACTIONS(4182),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3710] = {
    [sym__expression] = STATE(13680),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3710),
    [sym_line_comment] = STATE(3710),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3711] = {
    [sym__expression] = STATE(13575),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3711),
    [sym_line_comment] = STATE(3711),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3712] = {
    [sym__expression] = STATE(14098),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11036),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19525),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13703),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(231),
    [sym_identifier] = STATE(10502),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3712),
    [sym_line_comment] = STATE(3712),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4142),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_local] = ACTIONS(4146),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4184),
    [sym__type_order_operator] = ACTIONS(4184),
    [sym__unary_operator] = ACTIONS(4186),
    [sym__unary_plus_operator] = ACTIONS(4186),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3713] = {
    [sym__expression] = STATE(84),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3713),
    [sym_line_comment] = STATE(3713),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3714] = {
    [sym__expression] = STATE(8642),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3714),
    [sym_line_comment] = STATE(3714),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3715] = {
    [sym__expression] = STATE(8643),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3715),
    [sym_line_comment] = STATE(3715),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3716] = {
    [sym__expression] = STATE(329),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3716),
    [sym_line_comment] = STATE(3716),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3717] = {
    [sym__expression] = STATE(8644),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3717),
    [sym_line_comment] = STATE(3717),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3718] = {
    [sym__expression] = STATE(8645),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3718),
    [sym_line_comment] = STATE(3718),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3719] = {
    [sym__expression] = STATE(8676),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3719),
    [sym_line_comment] = STATE(3719),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3720] = {
    [sym__expression] = STATE(8679),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3720),
    [sym_line_comment] = STATE(3720),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3721] = {
    [sym__expression] = STATE(13218),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3721),
    [sym_line_comment] = STATE(3721),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3722] = {
    [sym__expression] = STATE(13219),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3722),
    [sym_line_comment] = STATE(3722),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3723] = {
    [sym__expression] = STATE(13220),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3723),
    [sym_line_comment] = STATE(3723),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3724] = {
    [sym__expression] = STATE(13221),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3724),
    [sym_line_comment] = STATE(3724),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3725] = {
    [sym__expression] = STATE(13222),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3725),
    [sym_line_comment] = STATE(3725),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3726] = {
    [sym__expression] = STATE(86),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3726),
    [sym_line_comment] = STATE(3726),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3727] = {
    [sym__expression] = STATE(13223),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3727),
    [sym_line_comment] = STATE(3727),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3728] = {
    [sym__expression] = STATE(13224),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3728),
    [sym_line_comment] = STATE(3728),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3729] = {
    [sym__expression] = STATE(354),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3729),
    [sym_line_comment] = STATE(3729),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3730] = {
    [sym__expression] = STATE(13225),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3730),
    [sym_line_comment] = STATE(3730),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3731] = {
    [sym__expression] = STATE(13226),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3731),
    [sym_line_comment] = STATE(3731),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3732] = {
    [sym__expression] = STATE(13233),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3732),
    [sym_line_comment] = STATE(3732),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3733] = {
    [sym__expression] = STATE(13240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3733),
    [sym_line_comment] = STATE(3733),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3734] = {
    [sym__expression] = STATE(13244),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3734),
    [sym_line_comment] = STATE(3734),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3735] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3735),
    [sym_line_comment] = STATE(3735),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3736] = {
    [sym__expression] = STATE(8708),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3736),
    [sym_line_comment] = STATE(3736),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3737] = {
    [sym__expression] = STATE(8121),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3737),
    [sym_line_comment] = STATE(3737),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3738] = {
    [sym__expression] = STATE(9062),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4866),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(19150),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8692),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(70),
    [sym_identifier] = STATE(4168),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3738),
    [sym_line_comment] = STATE(3738),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(1155),
    [anon_sym_const] = ACTIONS(1157),
    [anon_sym_global] = ACTIONS(1159),
    [anon_sym_local] = ACTIONS(1161),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(4024),
    [sym__type_order_operator] = ACTIONS(4024),
    [sym__unary_operator] = ACTIONS(4026),
    [sym__unary_plus_operator] = ACTIONS(4026),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3739] = {
    [sym__expression] = STATE(87),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3739),
    [sym_line_comment] = STATE(3739),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3740] = {
    [sym__expression] = STATE(312),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(5037),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18362),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8967),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4413),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3740),
    [sym_line_comment] = STATE(3740),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8866),
    [sym__type_order_operator] = ACTIONS(8866),
    [sym__unary_operator] = ACTIONS(3691),
    [sym__unary_plus_operator] = ACTIONS(3691),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3741] = {
    [sym__expression] = STATE(13203),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3741),
    [sym_line_comment] = STATE(3741),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3742] = {
    [sym__expression] = STATE(13215),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3742),
    [sym_line_comment] = STATE(3742),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3743] = {
    [sym__expression] = STATE(13245),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3743),
    [sym_line_comment] = STATE(3743),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3744] = {
    [sym__expression] = STATE(13246),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3744),
    [sym_line_comment] = STATE(3744),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3745] = {
    [sym__expression] = STATE(13250),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3745),
    [sym_line_comment] = STATE(3745),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3746] = {
    [sym__expression] = STATE(13252),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3746),
    [sym_line_comment] = STATE(3746),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3747] = {
    [sym__expression] = STATE(13253),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3747),
    [sym_line_comment] = STATE(3747),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3748] = {
    [sym__expression] = STATE(13254),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3748),
    [sym_line_comment] = STATE(3748),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3749] = {
    [sym__expression] = STATE(13255),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3749),
    [sym_line_comment] = STATE(3749),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3750] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10545),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18860),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12976),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10215),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3750),
    [sym_line_comment] = STATE(3750),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4132),
    [sym__type_order_operator] = ACTIONS(4132),
    [sym__unary_operator] = ACTIONS(4134),
    [sym__unary_plus_operator] = ACTIONS(4134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3751] = {
    [sym__expression] = STATE(12189),
    [sym_module_definition] = STATE(12347),
    [sym_abstract_definition] = STATE(12347),
    [sym_primitive_definition] = STATE(12347),
    [sym_struct_definition] = STATE(12347),
    [sym_function_definition] = STATE(12347),
    [sym_macro_definition] = STATE(12347),
    [sym_compound_statement] = STATE(12347),
    [sym_quote_statement] = STATE(12347),
    [sym_let_statement] = STATE(12347),
    [sym_if_statement] = STATE(12347),
    [sym_try_statement] = STATE(12347),
    [sym_for_statement] = STATE(12347),
    [sym_while_statement] = STATE(12347),
    [sym_return_statement] = STATE(12347),
    [sym_const_statement] = STATE(12347),
    [sym_global_statement] = STATE(12347),
    [sym_local_statement] = STATE(12347),
    [sym_export_statement] = STATE(12347),
    [sym_public_statement] = STATE(12347),
    [sym_import_statement] = STATE(12347),
    [sym_using_statement] = STATE(12347),
    [sym__primary_expression] = STATE(10172),
    [sym__array] = STATE(10354),
    [sym_comprehension_expression] = STATE(10244),
    [sym_matrix_expression] = STATE(10244),
    [sym_vector_expression] = STATE(10244),
    [sym_parenthesized_expression] = STATE(10354),
    [sym_tuple_expression] = STATE(10354),
    [sym_curly_expression] = STATE(10354),
    [sym_adjoint_expression] = STATE(4888),
    [sym_field_expression] = STATE(10354),
    [sym_index_expression] = STATE(10354),
    [sym_parametrized_type_expression] = STATE(10354),
    [sym_call_expression] = STATE(10354),
    [sym_broadcast_call_expression] = STATE(10354),
    [sym__closed_macrocall_expression] = STATE(10354),
    [sym_macrocall_expression] = STATE(12347),
    [sym_argument_list] = STATE(18671),
    [sym_interpolation_expression] = STATE(10354),
    [sym_quote_expression] = STATE(10354),
    [sym_binary_expression] = STATE(12347),
    [sym_unary_expression] = STATE(12347),
    [sym_range_expression] = STATE(12347),
    [sym_splat_expression] = STATE(12347),
    [sym_ternary_expression] = STATE(12347),
    [sym_typed_expression] = STATE(11866),
    [sym_unary_typed_expression] = STATE(12347),
    [sym_arrow_function_expression] = STATE(12347),
    [sym_juxtaposition_expression] = STATE(12347),
    [sym_compound_assignment_expression] = STATE(12347),
    [sym_where_expression] = STATE(12347),
    [sym_macro_identifier] = STATE(4),
    [sym_identifier] = STATE(10008),
    [sym_boolean_literal] = STATE(10354),
    [sym_integer_literal] = STATE(8727),
    [sym_float_literal] = STATE(8727),
    [sym__string] = STATE(10354),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(11779),
    [sym_block_comment] = STATE(3751),
    [sym_line_comment] = STATE(3751),
    [sym__word_identifier] = ACTIONS(99),
    [anon_sym_begin] = ACTIONS(103),
    [anon_sym_module] = ACTIONS(105),
    [anon_sym_baremodule] = ACTIONS(105),
    [anon_sym_abstract] = ACTIONS(109),
    [anon_sym_primitive] = ACTIONS(111),
    [anon_sym_mutable] = ACTIONS(113),
    [anon_sym_struct] = ACTIONS(115),
    [anon_sym_function] = ACTIONS(117),
    [anon_sym_macro] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_let] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(125),
    [anon_sym_try] = ACTIONS(127),
    [anon_sym_for] = ACTIONS(129),
    [anon_sym_while] = ACTIONS(131),
    [sym_break_statement] = ACTIONS(133),
    [sym_continue_statement] = ACTIONS(133),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2231),
    [anon_sym_global] = ACTIONS(2233),
    [anon_sym_local] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_export] = ACTIONS(145),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(149),
    [anon_sym_using] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(4492),
    [anon_sym_LBRACE] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(4496),
    [anon_sym_COLON2] = ACTIONS(159),
    [anon_sym_COLON_COLON] = ACTIONS(4498),
    [anon_sym_AT] = ACTIONS(4500),
    [anon_sym_true] = ACTIONS(167),
    [anon_sym_false] = ACTIONS(167),
    [aux_sym_integer_literal_token1] = ACTIONS(4502),
    [aux_sym_integer_literal_token2] = ACTIONS(4502),
    [aux_sym_integer_literal_token3] = ACTIONS(169),
    [aux_sym_integer_literal_token4] = ACTIONS(171),
    [aux_sym_float_literal_token1] = ACTIONS(4504),
    [aux_sym_float_literal_token3] = ACTIONS(4504),
    [aux_sym_float_literal_token4] = ACTIONS(4504),
    [sym_character_literal] = ACTIONS(4506),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(4508),
    [sym__type_order_operator] = ACTIONS(4508),
    [sym__unary_operator] = ACTIONS(181),
    [sym__unary_plus_operator] = ACTIONS(181),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3752] = {
    [sym__expression] = STATE(12072),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3752),
    [sym_line_comment] = STATE(3752),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3753] = {
    [sym__expression] = STATE(8634),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3753),
    [sym_line_comment] = STATE(3753),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3754] = {
    [sym__expression] = STATE(12060),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10232),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18354),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(11999),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(8),
    [sym_identifier] = STATE(10022),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3754),
    [sym_line_comment] = STATE(3754),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(2209),
    [anon_sym_const] = ACTIONS(2211),
    [anon_sym_global] = ACTIONS(2213),
    [anon_sym_local] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(4214),
    [sym__type_order_operator] = ACTIONS(4214),
    [sym__unary_operator] = ACTIONS(1137),
    [sym__unary_plus_operator] = ACTIONS(1137),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3755] = {
    [sym__expression] = STATE(7711),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3755),
    [sym_line_comment] = STATE(3755),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3756] = {
    [sym__expression] = STATE(7712),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3756),
    [sym_line_comment] = STATE(3756),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3757] = {
    [sym__expression] = STATE(8640),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3757),
    [sym_line_comment] = STATE(3757),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3758] = {
    [sym__expression] = STATE(8641),
    [sym_module_definition] = STATE(8042),
    [sym_abstract_definition] = STATE(8042),
    [sym_primitive_definition] = STATE(8042),
    [sym_struct_definition] = STATE(8042),
    [sym_function_definition] = STATE(8042),
    [sym_macro_definition] = STATE(8042),
    [sym_compound_statement] = STATE(8042),
    [sym_quote_statement] = STATE(8042),
    [sym_let_statement] = STATE(8042),
    [sym_if_statement] = STATE(8042),
    [sym_try_statement] = STATE(8042),
    [sym_for_statement] = STATE(8042),
    [sym_while_statement] = STATE(8042),
    [sym_return_statement] = STATE(8042),
    [sym_const_statement] = STATE(8042),
    [sym_global_statement] = STATE(8042),
    [sym_local_statement] = STATE(8042),
    [sym_export_statement] = STATE(8042),
    [sym_public_statement] = STATE(8042),
    [sym_import_statement] = STATE(8042),
    [sym_using_statement] = STATE(8042),
    [sym__primary_expression] = STATE(4559),
    [sym__array] = STATE(4551),
    [sym_comprehension_expression] = STATE(4666),
    [sym_matrix_expression] = STATE(4666),
    [sym_vector_expression] = STATE(4666),
    [sym_parenthesized_expression] = STATE(4551),
    [sym_tuple_expression] = STATE(4551),
    [sym_curly_expression] = STATE(4551),
    [sym_adjoint_expression] = STATE(4080),
    [sym_field_expression] = STATE(4551),
    [sym_index_expression] = STATE(4551),
    [sym_parametrized_type_expression] = STATE(4551),
    [sym_call_expression] = STATE(4551),
    [sym_broadcast_call_expression] = STATE(4551),
    [sym__closed_macrocall_expression] = STATE(4551),
    [sym_macrocall_expression] = STATE(8042),
    [sym_argument_list] = STATE(18797),
    [sym_interpolation_expression] = STATE(4551),
    [sym_quote_expression] = STATE(4551),
    [sym_binary_expression] = STATE(8042),
    [sym_unary_expression] = STATE(8042),
    [sym_range_expression] = STATE(8042),
    [sym_splat_expression] = STATE(8042),
    [sym_ternary_expression] = STATE(8042),
    [sym_typed_expression] = STATE(8418),
    [sym_unary_typed_expression] = STATE(8042),
    [sym_arrow_function_expression] = STATE(8042),
    [sym_juxtaposition_expression] = STATE(8042),
    [sym_compound_assignment_expression] = STATE(8042),
    [sym_where_expression] = STATE(8042),
    [sym_macro_identifier] = STATE(57),
    [sym_identifier] = STATE(4198),
    [sym_boolean_literal] = STATE(4551),
    [sym_integer_literal] = STATE(4091),
    [sym_float_literal] = STATE(4091),
    [sym__string] = STATE(4551),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(7916),
    [sym_block_comment] = STATE(3758),
    [sym_line_comment] = STATE(3758),
    [sym__word_identifier] = ACTIONS(819),
    [anon_sym_begin] = ACTIONS(821),
    [anon_sym_module] = ACTIONS(823),
    [anon_sym_baremodule] = ACTIONS(823),
    [anon_sym_abstract] = ACTIONS(825),
    [anon_sym_primitive] = ACTIONS(827),
    [anon_sym_mutable] = ACTIONS(829),
    [anon_sym_struct] = ACTIONS(831),
    [anon_sym_function] = ACTIONS(833),
    [anon_sym_macro] = ACTIONS(835),
    [anon_sym_quote] = ACTIONS(837),
    [anon_sym_let] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_try] = ACTIONS(843),
    [anon_sym_for] = ACTIONS(845),
    [anon_sym_while] = ACTIONS(847),
    [sym_break_statement] = ACTIONS(849),
    [sym_continue_statement] = ACTIONS(849),
    [anon_sym_return] = ACTIONS(851),
    [anon_sym_const] = ACTIONS(853),
    [anon_sym_global] = ACTIONS(855),
    [anon_sym_local] = ACTIONS(857),
    [anon_sym_LPAREN] = ACTIONS(859),
    [anon_sym_export] = ACTIONS(861),
    [anon_sym_public] = ACTIONS(863),
    [anon_sym_import] = ACTIONS(865),
    [anon_sym_using] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(869),
    [anon_sym_LBRACE] = ACTIONS(871),
    [anon_sym_DOLLAR] = ACTIONS(873),
    [anon_sym_COLON2] = ACTIONS(875),
    [anon_sym_COLON_COLON] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(881),
    [anon_sym_false] = ACTIONS(881),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(893),
    [sym__arrow_operator] = ACTIONS(895),
    [sym__comparison_operator] = ACTIONS(895),
    [sym__pipe_right_operator] = ACTIONS(893),
    [sym__pipe_left_operator] = ACTIONS(893),
    [sym__ellipsis_operator] = ACTIONS(893),
    [sym__plus_operator] = ACTIONS(895),
    [sym__times_operator] = ACTIONS(895),
    [sym__rational_operator] = ACTIONS(893),
    [sym__bitshift_operator] = ACTIONS(893),
    [sym__power_operator] = ACTIONS(893),
    [sym__tilde_operator] = ACTIONS(897),
    [sym__type_order_operator] = ACTIONS(897),
    [sym__unary_operator] = ACTIONS(899),
    [sym__unary_plus_operator] = ACTIONS(899),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3759] = {
    [sym__expression] = STATE(7716),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3759),
    [sym_line_comment] = STATE(3759),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3760] = {
    [sym__expression] = STATE(7717),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3760),
    [sym_line_comment] = STATE(3760),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3761] = {
    [sym__expression] = STATE(7324),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3761),
    [sym_line_comment] = STATE(3761),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3762] = {
    [sym__expression] = STATE(7325),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3762),
    [sym_line_comment] = STATE(3762),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3763] = {
    [sym__expression] = STATE(7326),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3763),
    [sym_line_comment] = STATE(3763),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3764] = {
    [sym__expression] = STATE(7327),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3764),
    [sym_line_comment] = STATE(3764),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3765] = {
    [sym__expression] = STATE(7328),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3765),
    [sym_line_comment] = STATE(3765),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3766] = {
    [sym__expression] = STATE(7219),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4196),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18397),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(6962),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4109),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3766),
    [sym_line_comment] = STATE(3766),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(6882),
    [sym__type_order_operator] = ACTIONS(6882),
    [sym__unary_operator] = ACTIONS(413),
    [sym__unary_plus_operator] = ACTIONS(413),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3767] = {
    [sym__expression] = STATE(12439),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10368),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(4998),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(19320),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12330),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(20),
    [sym_identifier] = STATE(9931),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(8722),
    [sym_float_literal] = STATE(8722),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3767),
    [sym_line_comment] = STATE(3767),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(1065),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(1073),
    [anon_sym_const] = ACTIONS(1075),
    [anon_sym_global] = ACTIONS(1077),
    [anon_sym_local] = ACTIONS(1079),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(1083),
    [anon_sym_public] = ACTIONS(1085),
    [anon_sym_import] = ACTIONS(1087),
    [anon_sym_using] = ACTIONS(1089),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(4202),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(4204),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(4208),
    [aux_sym_integer_literal_token2] = ACTIONS(4208),
    [aux_sym_integer_literal_token3] = ACTIONS(1105),
    [aux_sym_integer_literal_token4] = ACTIONS(1107),
    [aux_sym_float_literal_token1] = ACTIONS(4210),
    [aux_sym_float_literal_token3] = ACTIONS(4210),
    [aux_sym_float_literal_token4] = ACTIONS(4210),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4212),
    [sym__arrow_operator] = ACTIONS(2219),
    [sym__comparison_operator] = ACTIONS(2219),
    [sym__pipe_right_operator] = ACTIONS(4212),
    [sym__pipe_left_operator] = ACTIONS(4212),
    [sym__ellipsis_operator] = ACTIONS(4212),
    [sym__plus_operator] = ACTIONS(2219),
    [sym__times_operator] = ACTIONS(2219),
    [sym__rational_operator] = ACTIONS(4212),
    [sym__bitshift_operator] = ACTIONS(4212),
    [sym__power_operator] = ACTIONS(4212),
    [sym__tilde_operator] = ACTIONS(8892),
    [sym__type_order_operator] = ACTIONS(8892),
    [sym__unary_operator] = ACTIONS(3547),
    [sym__unary_plus_operator] = ACTIONS(3547),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3768] = {
    [sym__expression] = STATE(12872),
    [sym_module_definition] = STATE(11463),
    [sym_abstract_definition] = STATE(11463),
    [sym_primitive_definition] = STATE(11463),
    [sym_struct_definition] = STATE(11463),
    [sym_function_definition] = STATE(11463),
    [sym_macro_definition] = STATE(11463),
    [sym_compound_statement] = STATE(11463),
    [sym_quote_statement] = STATE(11463),
    [sym_let_statement] = STATE(11463),
    [sym_if_statement] = STATE(11463),
    [sym_try_statement] = STATE(11463),
    [sym_for_statement] = STATE(11463),
    [sym_while_statement] = STATE(11463),
    [sym_return_statement] = STATE(11463),
    [sym_const_statement] = STATE(11463),
    [sym_global_statement] = STATE(11463),
    [sym_local_statement] = STATE(11463),
    [sym_export_statement] = STATE(11463),
    [sym_public_statement] = STATE(11463),
    [sym_import_statement] = STATE(11463),
    [sym_using_statement] = STATE(11463),
    [sym__primary_expression] = STATE(10419),
    [sym__array] = STATE(9974),
    [sym_comprehension_expression] = STATE(10006),
    [sym_matrix_expression] = STATE(10006),
    [sym_vector_expression] = STATE(10006),
    [sym_parenthesized_expression] = STATE(9974),
    [sym_tuple_expression] = STATE(9974),
    [sym_curly_expression] = STATE(9974),
    [sym_adjoint_expression] = STATE(5605),
    [sym_field_expression] = STATE(9974),
    [sym_index_expression] = STATE(9974),
    [sym_parametrized_type_expression] = STATE(9974),
    [sym_call_expression] = STATE(9974),
    [sym_broadcast_call_expression] = STATE(9974),
    [sym__closed_macrocall_expression] = STATE(9974),
    [sym_macrocall_expression] = STATE(11463),
    [sym_argument_list] = STATE(18280),
    [sym_interpolation_expression] = STATE(9974),
    [sym_quote_expression] = STATE(9974),
    [sym_binary_expression] = STATE(11463),
    [sym_unary_expression] = STATE(11463),
    [sym_range_expression] = STATE(11463),
    [sym_splat_expression] = STATE(11463),
    [sym_ternary_expression] = STATE(11463),
    [sym_typed_expression] = STATE(12514),
    [sym_unary_typed_expression] = STATE(11463),
    [sym_arrow_function_expression] = STATE(11463),
    [sym_juxtaposition_expression] = STATE(11463),
    [sym_compound_assignment_expression] = STATE(11463),
    [sym_where_expression] = STATE(11463),
    [sym_macro_identifier] = STATE(38),
    [sym_identifier] = STATE(10177),
    [sym_boolean_literal] = STATE(9974),
    [sym_integer_literal] = STATE(9173),
    [sym_float_literal] = STATE(9173),
    [sym__string] = STATE(9974),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(11380),
    [sym_block_comment] = STATE(3768),
    [sym_line_comment] = STATE(3768),
    [sym__word_identifier] = ACTIONS(9),
    [anon_sym_begin] = ACTIONS(11),
    [anon_sym_module] = ACTIONS(13),
    [anon_sym_baremodule] = ACTIONS(13),
    [anon_sym_abstract] = ACTIONS(15),
    [anon_sym_primitive] = ACTIONS(17),
    [anon_sym_mutable] = ACTIONS(19),
    [anon_sym_struct] = ACTIONS(21),
    [anon_sym_function] = ACTIONS(23),
    [anon_sym_macro] = ACTIONS(25),
    [anon_sym_quote] = ACTIONS(27),
    [anon_sym_let] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_try] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [sym_break_statement] = ACTIONS(39),
    [sym_continue_statement] = ACTIONS(39),
    [anon_sym_return] = ACTIONS(3549),
    [anon_sym_const] = ACTIONS(3551),
    [anon_sym_global] = ACTIONS(3553),
    [anon_sym_local] = ACTIONS(3555),
    [anon_sym_LPAREN] = ACTIONS(49),
    [anon_sym_export] = ACTIONS(51),
    [anon_sym_public] = ACTIONS(53),
    [anon_sym_import] = ACTIONS(55),
    [anon_sym_using] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_LBRACE] = ACTIONS(61),
    [anon_sym_DOLLAR] = ACTIONS(63),
    [anon_sym_COLON2] = ACTIONS(65),
    [anon_sym_COLON_COLON] = ACTIONS(67),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(71),
    [anon_sym_false] = ACTIONS(71),
    [aux_sym_integer_literal_token1] = ACTIONS(73),
    [aux_sym_integer_literal_token2] = ACTIONS(73),
    [aux_sym_integer_literal_token3] = ACTIONS(75),
    [aux_sym_integer_literal_token4] = ACTIONS(77),
    [aux_sym_float_literal_token1] = ACTIONS(79),
    [aux_sym_float_literal_token3] = ACTIONS(79),
    [aux_sym_float_literal_token4] = ACTIONS(79),
    [sym_character_literal] = ACTIONS(81),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(91),
    [sym__arrow_operator] = ACTIONS(93),
    [sym__comparison_operator] = ACTIONS(93),
    [sym__pipe_right_operator] = ACTIONS(91),
    [sym__pipe_left_operator] = ACTIONS(91),
    [sym__ellipsis_operator] = ACTIONS(91),
    [sym__plus_operator] = ACTIONS(93),
    [sym__times_operator] = ACTIONS(93),
    [sym__rational_operator] = ACTIONS(91),
    [sym__bitshift_operator] = ACTIONS(91),
    [sym__power_operator] = ACTIONS(91),
    [sym__tilde_operator] = ACTIONS(95),
    [sym__type_order_operator] = ACTIONS(95),
    [sym__unary_operator] = ACTIONS(97),
    [sym__unary_plus_operator] = ACTIONS(97),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3769] = {
    [sym__expression] = STATE(14240),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(11320),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(11320),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13610),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10638),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3769),
    [sym_line_comment] = STATE(3769),
    [sym__word_identifier] = ACTIONS(6950),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(6952),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(6956),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3770] = {
    [sym__expression] = STATE(8493),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3770),
    [sym_line_comment] = STATE(3770),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3771] = {
    [sym__expression] = STATE(13126),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3771),
    [sym_line_comment] = STATE(3771),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3772] = {
    [sym__expression] = STATE(9275),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3772),
    [sym_line_comment] = STATE(3772),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3773] = {
    [sym__expression] = STATE(12966),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3773),
    [sym_line_comment] = STATE(3773),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3774] = {
    [sym__expression] = STATE(14027),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3774),
    [sym_line_comment] = STATE(3774),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3775] = {
    [sym__expression] = STATE(14128),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11318),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(19331),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(14039),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10115),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3775),
    [sym_line_comment] = STATE(3775),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4176),
    [sym__type_order_operator] = ACTIONS(4176),
    [sym__unary_operator] = ACTIONS(4178),
    [sym__unary_plus_operator] = ACTIONS(4178),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3776] = {
    [sym__expression] = STATE(12941),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3776),
    [sym_line_comment] = STATE(3776),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3777] = {
    [sym__expression] = STATE(9011),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3777),
    [sym_line_comment] = STATE(3777),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3778] = {
    [sym__expression] = STATE(13391),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3778),
    [sym_line_comment] = STATE(3778),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3779] = {
    [sym__expression] = STATE(13204),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3779),
    [sym_line_comment] = STATE(3779),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3780] = {
    [sym__expression] = STATE(13396),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3780),
    [sym_line_comment] = STATE(3780),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3781] = {
    [sym__expression] = STATE(13205),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3781),
    [sym_line_comment] = STATE(3781),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3782] = {
    [sym__expression] = STATE(13206),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3782),
    [sym_line_comment] = STATE(3782),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3783] = {
    [sym__expression] = STATE(13207),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3783),
    [sym_line_comment] = STATE(3783),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3784] = {
    [sym__expression] = STATE(13208),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3784),
    [sym_line_comment] = STATE(3784),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3785] = {
    [sym__expression] = STATE(13209),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3785),
    [sym_line_comment] = STATE(3785),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3786] = {
    [sym__expression] = STATE(13210),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3786),
    [sym_line_comment] = STATE(3786),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3787] = {
    [sym__expression] = STATE(13211),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3787),
    [sym_line_comment] = STATE(3787),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3788] = {
    [sym__expression] = STATE(13212),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3788),
    [sym_line_comment] = STATE(3788),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3789] = {
    [sym__expression] = STATE(13213),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3789),
    [sym_line_comment] = STATE(3789),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3790] = {
    [sym__expression] = STATE(13214),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3790),
    [sym_line_comment] = STATE(3790),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3791] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3791),
    [sym_line_comment] = STATE(3791),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3792] = {
    [sym__expression] = STATE(8490),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3792),
    [sym_line_comment] = STATE(3792),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3793] = {
    [sym__expression] = STATE(13359),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3793),
    [sym_line_comment] = STATE(3793),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3794] = {
    [sym__expression] = STATE(13407),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3794),
    [sym_line_comment] = STATE(3794),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3795] = {
    [sym__expression] = STATE(9030),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3795),
    [sym_line_comment] = STATE(3795),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3796] = {
    [sym__expression] = STATE(13355),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10645),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18783),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12934),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10225),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3796),
    [sym_line_comment] = STATE(3796),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4196),
    [sym__type_order_operator] = ACTIONS(4196),
    [sym__unary_operator] = ACTIONS(4198),
    [sym__unary_plus_operator] = ACTIONS(4198),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3797] = {
    [sym__expression] = STATE(9039),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3797),
    [sym_line_comment] = STATE(3797),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3798] = {
    [sym__expression] = STATE(13754),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3798),
    [sym_line_comment] = STATE(3798),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3799] = {
    [sym__expression] = STATE(13674),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3799),
    [sym_line_comment] = STATE(3799),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3800] = {
    [sym__expression] = STATE(13976),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3800),
    [sym_line_comment] = STATE(3800),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3801] = {
    [sym__expression] = STATE(9271),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3801),
    [sym_line_comment] = STATE(3801),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3802] = {
    [sym__expression] = STATE(8512),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3802),
    [sym_line_comment] = STATE(3802),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3803] = {
    [sym__expression] = STATE(14048),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3803),
    [sym_line_comment] = STATE(3803),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3804] = {
    [sym__expression] = STATE(12951),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3804),
    [sym_line_comment] = STATE(3804),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3805] = {
    [sym__expression] = STATE(12948),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3805),
    [sym_line_comment] = STATE(3805),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3806] = {
    [sym__expression] = STATE(12952),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3806),
    [sym_line_comment] = STATE(3806),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3807] = {
    [sym__expression] = STATE(13684),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3807),
    [sym_line_comment] = STATE(3807),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3808] = {
    [sym__expression] = STATE(12955),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3808),
    [sym_line_comment] = STATE(3808),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3809] = {
    [sym__expression] = STATE(13685),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3809),
    [sym_line_comment] = STATE(3809),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3810] = {
    [sym__expression] = STATE(12991),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3810),
    [sym_line_comment] = STATE(3810),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3811] = {
    [sym__expression] = STATE(12956),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3811),
    [sym_line_comment] = STATE(3811),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3812] = {
    [sym__expression] = STATE(12992),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3812),
    [sym_line_comment] = STATE(3812),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3813] = {
    [sym__expression] = STATE(12993),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3813),
    [sym_line_comment] = STATE(3813),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3814] = {
    [sym__expression] = STATE(12994),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3814),
    [sym_line_comment] = STATE(3814),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3815] = {
    [sym__expression] = STATE(13686),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3815),
    [sym_line_comment] = STATE(3815),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3816] = {
    [sym__expression] = STATE(12996),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3816),
    [sym_line_comment] = STATE(3816),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3817] = {
    [sym__expression] = STATE(12997),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3817),
    [sym_line_comment] = STATE(3817),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3818] = {
    [sym__expression] = STATE(12998),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3818),
    [sym_line_comment] = STATE(3818),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3819] = {
    [sym__expression] = STATE(12999),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3819),
    [sym_line_comment] = STATE(3819),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3820] = {
    [sym__expression] = STATE(13000),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3820),
    [sym_line_comment] = STATE(3820),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3821] = {
    [sym__expression] = STATE(13001),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3821),
    [sym_line_comment] = STATE(3821),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3822] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3822),
    [sym_line_comment] = STATE(3822),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3823] = {
    [sym__expression] = STATE(8511),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3823),
    [sym_line_comment] = STATE(3823),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3824] = {
    [sym__expression] = STATE(13687),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3824),
    [sym_line_comment] = STATE(3824),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3825] = {
    [sym__expression] = STATE(13770),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3825),
    [sym_line_comment] = STATE(3825),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3826] = {
    [sym__expression] = STATE(13827),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3826),
    [sym_line_comment] = STATE(3826),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3827] = {
    [sym__expression] = STATE(13830),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3827),
    [sym_line_comment] = STATE(3827),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3828] = {
    [sym__expression] = STATE(13831),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3828),
    [sym_line_comment] = STATE(3828),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3829] = {
    [sym__expression] = STATE(13832),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3829),
    [sym_line_comment] = STATE(3829),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3830] = {
    [sym__expression] = STATE(13833),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3830),
    [sym_line_comment] = STATE(3830),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3831] = {
    [sym__expression] = STATE(13834),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3831),
    [sym_line_comment] = STATE(3831),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3832] = {
    [sym__expression] = STATE(13835),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3832),
    [sym_line_comment] = STATE(3832),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3833] = {
    [sym__expression] = STATE(13836),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3833),
    [sym_line_comment] = STATE(3833),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3834] = {
    [sym__expression] = STATE(12989),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3834),
    [sym_line_comment] = STATE(3834),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3835] = {
    [sym__expression] = STATE(9116),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3835),
    [sym_line_comment] = STATE(3835),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3836] = {
    [sym__expression] = STATE(13688),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3836),
    [sym_line_comment] = STATE(3836),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3837] = {
    [sym__expression] = STATE(13689),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3837),
    [sym_line_comment] = STATE(3837),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3838] = {
    [sym__expression] = STATE(13841),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3838),
    [sym_line_comment] = STATE(3838),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3839] = {
    [sym__expression] = STATE(13825),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3839),
    [sym_line_comment] = STATE(3839),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3840] = {
    [sym__expression] = STATE(13826),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3840),
    [sym_line_comment] = STATE(3840),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3841] = {
    [sym__expression] = STATE(13828),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3841),
    [sym_line_comment] = STATE(3841),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3842] = {
    [sym__expression] = STATE(13829),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10808),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18769),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13228),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(110),
    [sym_identifier] = STATE(10358),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3842),
    [sym_line_comment] = STATE(3842),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1771),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_global] = ACTIONS(1775),
    [anon_sym_local] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4164),
    [sym__type_order_operator] = ACTIONS(4164),
    [sym__unary_operator] = ACTIONS(4166),
    [sym__unary_plus_operator] = ACTIONS(4166),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3843] = {
    [sym__expression] = STATE(13150),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3843),
    [sym_line_comment] = STATE(3843),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3844] = {
    [sym__expression] = STATE(13691),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3844),
    [sym_line_comment] = STATE(3844),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3845] = {
    [sym__expression] = STATE(9117),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3845),
    [sym_line_comment] = STATE(3845),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3846] = {
    [sym__expression] = STATE(13692),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3846),
    [sym_line_comment] = STATE(3846),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3847] = {
    [sym__expression] = STATE(14079),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3847),
    [sym_line_comment] = STATE(3847),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3848] = {
    [sym__expression] = STATE(13693),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3848),
    [sym_line_comment] = STATE(3848),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3849] = {
    [sym__expression] = STATE(13700),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3849),
    [sym_line_comment] = STATE(3849),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3850] = {
    [sym__expression] = STATE(13701),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3850),
    [sym_line_comment] = STATE(3850),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3851] = {
    [sym__expression] = STATE(12960),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3851),
    [sym_line_comment] = STATE(3851),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3852] = {
    [sym__expression] = STATE(13702),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3852),
    [sym_line_comment] = STATE(3852),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3853] = {
    [sym__expression] = STATE(12972),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3853),
    [sym_line_comment] = STATE(3853),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3854] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10831),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18533),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13356),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(162),
    [sym_identifier] = STATE(10420),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9344),
    [sym_float_literal] = STATE(9344),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3854),
    [sym_line_comment] = STATE(3854),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_local] = ACTIONS(4086),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4088),
    [sym__type_order_operator] = ACTIONS(4088),
    [sym__unary_operator] = ACTIONS(4090),
    [sym__unary_plus_operator] = ACTIONS(4090),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3855] = {
    [sym__expression] = STATE(8986),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3855),
    [sym_line_comment] = STATE(3855),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3856] = {
    [sym__expression] = STATE(9123),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3856),
    [sym_line_comment] = STATE(3856),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3857] = {
    [sym__expression] = STATE(8987),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3857),
    [sym_line_comment] = STATE(3857),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3858] = {
    [sym__expression] = STATE(8988),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3858),
    [sym_line_comment] = STATE(3858),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3859] = {
    [sym__expression] = STATE(8989),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3859),
    [sym_line_comment] = STATE(3859),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3860] = {
    [sym__expression] = STATE(8990),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3860),
    [sym_line_comment] = STATE(3860),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3861] = {
    [sym__expression] = STATE(8991),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3861),
    [sym_line_comment] = STATE(3861),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3862] = {
    [sym__expression] = STATE(8992),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3862),
    [sym_line_comment] = STATE(3862),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3863] = {
    [sym__expression] = STATE(8993),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3863),
    [sym_line_comment] = STATE(3863),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3864] = {
    [sym__expression] = STATE(8994),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3864),
    [sym_line_comment] = STATE(3864),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3865] = {
    [sym__expression] = STATE(8995),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3865),
    [sym_line_comment] = STATE(3865),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3866] = {
    [sym__expression] = STATE(8996),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3866),
    [sym_line_comment] = STATE(3866),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3867] = {
    [sym__expression] = STATE(8628),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3867),
    [sym_line_comment] = STATE(3867),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3868] = {
    [sym__expression] = STATE(8998),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3868),
    [sym_line_comment] = STATE(3868),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3869] = {
    [sym__expression] = STATE(9303),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3869),
    [sym_line_comment] = STATE(3869),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3870] = {
    [sym__expression] = STATE(9306),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3870),
    [sym_line_comment] = STATE(3870),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3871] = {
    [sym__expression] = STATE(9307),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3871),
    [sym_line_comment] = STATE(3871),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3872] = {
    [sym__expression] = STATE(9281),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3872),
    [sym_line_comment] = STATE(3872),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3873] = {
    [sym__expression] = STATE(9282),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3873),
    [sym_line_comment] = STATE(3873),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3874] = {
    [sym__expression] = STATE(9283),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3874),
    [sym_line_comment] = STATE(3874),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3875] = {
    [sym__expression] = STATE(9284),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3875),
    [sym_line_comment] = STATE(3875),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3876] = {
    [sym__expression] = STATE(9285),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3876),
    [sym_line_comment] = STATE(3876),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3877] = {
    [sym__expression] = STATE(7937),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3877),
    [sym_line_comment] = STATE(3877),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3878] = {
    [sym__expression] = STATE(14092),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3878),
    [sym_line_comment] = STATE(3878),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3879] = {
    [sym__expression] = STATE(14015),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3879),
    [sym_line_comment] = STATE(3879),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3880] = {
    [sym__expression] = STATE(14018),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3880),
    [sym_line_comment] = STATE(3880),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3881] = {
    [sym__expression] = STATE(14019),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3881),
    [sym_line_comment] = STATE(3881),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3882] = {
    [sym__expression] = STATE(14020),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3882),
    [sym_line_comment] = STATE(3882),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3883] = {
    [sym__expression] = STATE(14021),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3883),
    [sym_line_comment] = STATE(3883),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3884] = {
    [sym__expression] = STATE(14022),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3884),
    [sym_line_comment] = STATE(3884),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3885] = {
    [sym__expression] = STATE(14023),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3885),
    [sym_line_comment] = STATE(3885),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3886] = {
    [sym__expression] = STATE(14024),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3886),
    [sym_line_comment] = STATE(3886),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3887] = {
    [sym__expression] = STATE(13884),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3887),
    [sym_line_comment] = STATE(3887),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3888] = {
    [sym__expression] = STATE(14014),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3888),
    [sym_line_comment] = STATE(3888),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3889] = {
    [sym__expression] = STATE(14016),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3889),
    [sym_line_comment] = STATE(3889),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3890] = {
    [sym__expression] = STATE(14017),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3890),
    [sym_line_comment] = STATE(3890),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3891] = {
    [sym__expression] = STATE(13051),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3891),
    [sym_line_comment] = STATE(3891),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3892] = {
    [sym__expression] = STATE(13013),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3892),
    [sym_line_comment] = STATE(3892),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3893] = {
    [sym__expression] = STATE(13014),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3893),
    [sym_line_comment] = STATE(3893),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3894] = {
    [sym__expression] = STATE(12968),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3894),
    [sym_line_comment] = STATE(3894),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3895] = {
    [sym__expression] = STATE(13028),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3895),
    [sym_line_comment] = STATE(3895),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3896] = {
    [sym__expression] = STATE(13016),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3896),
    [sym_line_comment] = STATE(3896),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3897] = {
    [sym__expression] = STATE(13017),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3897),
    [sym_line_comment] = STATE(3897),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3898] = {
    [sym__expression] = STATE(13031),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3898),
    [sym_line_comment] = STATE(3898),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3899] = {
    [sym__expression] = STATE(13032),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3899),
    [sym_line_comment] = STATE(3899),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3900] = {
    [sym__expression] = STATE(13020),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3900),
    [sym_line_comment] = STATE(3900),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3901] = {
    [sym__expression] = STATE(13021),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3901),
    [sym_line_comment] = STATE(3901),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3902] = {
    [sym__expression] = STATE(13022),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3902),
    [sym_line_comment] = STATE(3902),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3903] = {
    [sym__expression] = STATE(13023),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3903),
    [sym_line_comment] = STATE(3903),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3904] = {
    [sym__expression] = STATE(13024),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3904),
    [sym_line_comment] = STATE(3904),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3905] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3905),
    [sym_line_comment] = STATE(3905),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3906] = {
    [sym__expression] = STATE(12967),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3906),
    [sym_line_comment] = STATE(3906),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3907] = {
    [sym__expression] = STATE(13053),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3907),
    [sym_line_comment] = STATE(3907),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3908] = {
    [sym__expression] = STATE(13026),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3908),
    [sym_line_comment] = STATE(3908),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3909] = {
    [sym__expression] = STATE(13027),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3909),
    [sym_line_comment] = STATE(3909),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3910] = {
    [sym__expression] = STATE(13029),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3910),
    [sym_line_comment] = STATE(3910),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3911] = {
    [sym__expression] = STATE(13030),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3911),
    [sym_line_comment] = STATE(3911),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3912] = {
    [sym__expression] = STATE(12969),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10457),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18808),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12442),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(88),
    [sym_identifier] = STATE(10164),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3912),
    [sym_line_comment] = STATE(3912),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_local] = ACTIONS(3886),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4054),
    [sym__type_order_operator] = ACTIONS(4054),
    [sym__unary_operator] = ACTIONS(4056),
    [sym__unary_plus_operator] = ACTIONS(4056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3913] = {
    [sym__expression] = STATE(12970),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3913),
    [sym_line_comment] = STATE(3913),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3914] = {
    [sym__expression] = STATE(13034),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3914),
    [sym_line_comment] = STATE(3914),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3915] = {
    [sym__expression] = STATE(12971),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3915),
    [sym_line_comment] = STATE(3915),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3916] = {
    [sym__expression] = STATE(13035),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3916),
    [sym_line_comment] = STATE(3916),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3917] = {
    [sym__expression] = STATE(13036),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3917),
    [sym_line_comment] = STATE(3917),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3918] = {
    [sym__expression] = STATE(13037),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3918),
    [sym_line_comment] = STATE(3918),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3919] = {
    [sym__expression] = STATE(13038),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3919),
    [sym_line_comment] = STATE(3919),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3920] = {
    [sym__expression] = STATE(13039),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3920),
    [sym_line_comment] = STATE(3920),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3921] = {
    [sym__expression] = STATE(13040),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3921),
    [sym_line_comment] = STATE(3921),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3922] = {
    [sym__expression] = STATE(13041),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3922),
    [sym_line_comment] = STATE(3922),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3923] = {
    [sym__expression] = STATE(13042),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3923),
    [sym_line_comment] = STATE(3923),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3924] = {
    [sym__expression] = STATE(13043),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3924),
    [sym_line_comment] = STATE(3924),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3925] = {
    [sym__expression] = STATE(13044),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3925),
    [sym_line_comment] = STATE(3925),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3926] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3926),
    [sym_line_comment] = STATE(3926),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3927] = {
    [sym__expression] = STATE(13015),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3927),
    [sym_line_comment] = STATE(3927),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3928] = {
    [sym__expression] = STATE(13018),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3928),
    [sym_line_comment] = STATE(3928),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3929] = {
    [sym__expression] = STATE(13019),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3929),
    [sym_line_comment] = STATE(3929),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3930] = {
    [sym__expression] = STATE(13045),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3930),
    [sym_line_comment] = STATE(3930),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3931] = {
    [sym__expression] = STATE(13046),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3931),
    [sym_line_comment] = STATE(3931),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3932] = {
    [sym__expression] = STATE(13047),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3932),
    [sym_line_comment] = STATE(3932),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3933] = {
    [sym__expression] = STATE(13048),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3933),
    [sym_line_comment] = STATE(3933),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3934] = {
    [sym__expression] = STATE(13049),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3934),
    [sym_line_comment] = STATE(3934),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3935] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10456),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18807),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12441),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(81),
    [sym_identifier] = STATE(10163),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3935),
    [sym_line_comment] = STATE(3935),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3852),
    [anon_sym_const] = ACTIONS(3854),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_local] = ACTIONS(3858),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4096),
    [sym__type_order_operator] = ACTIONS(4096),
    [sym__unary_operator] = ACTIONS(4098),
    [sym__unary_plus_operator] = ACTIONS(4098),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3936] = {
    [sym__expression] = STATE(13315),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3936),
    [sym_line_comment] = STATE(3936),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3937] = {
    [sym__expression] = STATE(9041),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3937),
    [sym_line_comment] = STATE(3937),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3938] = {
    [sym__expression] = STATE(13316),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10566),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18743),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13058),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(90),
    [sym_identifier] = STATE(10212),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3938),
    [sym_line_comment] = STATE(3938),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3699),
    [anon_sym_const] = ACTIONS(3701),
    [anon_sym_global] = ACTIONS(3703),
    [anon_sym_local] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4044),
    [sym__type_order_operator] = ACTIONS(4044),
    [sym__unary_operator] = ACTIONS(4046),
    [sym__unary_plus_operator] = ACTIONS(4046),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3939] = {
    [sym__expression] = STATE(9042),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3939),
    [sym_line_comment] = STATE(3939),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3940] = {
    [sym__expression] = STATE(9043),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3940),
    [sym_line_comment] = STATE(3940),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3941] = {
    [sym__expression] = STATE(9044),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3941),
    [sym_line_comment] = STATE(3941),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3942] = {
    [sym__expression] = STATE(9045),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3942),
    [sym_line_comment] = STATE(3942),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3943] = {
    [sym__expression] = STATE(9046),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3943),
    [sym_line_comment] = STATE(3943),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3944] = {
    [sym__expression] = STATE(9047),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3944),
    [sym_line_comment] = STATE(3944),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3945] = {
    [sym__expression] = STATE(9048),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3945),
    [sym_line_comment] = STATE(3945),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3946] = {
    [sym__expression] = STATE(9049),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3946),
    [sym_line_comment] = STATE(3946),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3947] = {
    [sym__expression] = STATE(9050),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3947),
    [sym_line_comment] = STATE(3947),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3948] = {
    [sym__expression] = STATE(9051),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3948),
    [sym_line_comment] = STATE(3948),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3949] = {
    [sym__expression] = STATE(8628),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3949),
    [sym_line_comment] = STATE(3949),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3950] = {
    [sym__expression] = STATE(8611),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3950),
    [sym_line_comment] = STATE(3950),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3951] = {
    [sym__expression] = STATE(9054),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3951),
    [sym_line_comment] = STATE(3951),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3952] = {
    [sym__expression] = STATE(8572),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3952),
    [sym_line_comment] = STATE(3952),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3953] = {
    [sym__expression] = STATE(8573),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3953),
    [sym_line_comment] = STATE(3953),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3954] = {
    [sym__expression] = STATE(8575),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3954),
    [sym_line_comment] = STATE(3954),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3955] = {
    [sym__expression] = STATE(8576),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3955),
    [sym_line_comment] = STATE(3955),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3956] = {
    [sym__expression] = STATE(9067),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4979),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18766),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8885),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(68),
    [sym_identifier] = STATE(4230),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(3956),
    [sym_line_comment] = STATE(3956),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(1147),
    [anon_sym_const] = ACTIONS(1149),
    [anon_sym_global] = ACTIONS(1151),
    [anon_sym_local] = ACTIONS(1153),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8888),
    [sym__type_order_operator] = ACTIONS(8888),
    [sym__unary_operator] = ACTIONS(4048),
    [sym__unary_plus_operator] = ACTIONS(4048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3957] = {
    [sym__expression] = STATE(13322),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3957),
    [sym_line_comment] = STATE(3957),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3958] = {
    [sym__expression] = STATE(13325),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3958),
    [sym_line_comment] = STATE(3958),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3959] = {
    [sym__expression] = STATE(13326),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3959),
    [sym_line_comment] = STATE(3959),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3960] = {
    [sym__expression] = STATE(13327),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3960),
    [sym_line_comment] = STATE(3960),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3961] = {
    [sym__expression] = STATE(13328),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3961),
    [sym_line_comment] = STATE(3961),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3962] = {
    [sym__expression] = STATE(13329),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3962),
    [sym_line_comment] = STATE(3962),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3963] = {
    [sym__expression] = STATE(13330),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3963),
    [sym_line_comment] = STATE(3963),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3964] = {
    [sym__expression] = STATE(13331),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3964),
    [sym_line_comment] = STATE(3964),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3965] = {
    [sym__expression] = STATE(12989),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3965),
    [sym_line_comment] = STATE(3965),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3966] = {
    [sym__expression] = STATE(13364),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3966),
    [sym_line_comment] = STATE(3966),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3967] = {
    [sym__expression] = STATE(13320),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3967),
    [sym_line_comment] = STATE(3967),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3968] = {
    [sym__expression] = STATE(13321),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3968),
    [sym_line_comment] = STATE(3968),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3969] = {
    [sym__expression] = STATE(9086),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3969),
    [sym_line_comment] = STATE(3969),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3970] = {
    [sym__expression] = STATE(13323),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3970),
    [sym_line_comment] = STATE(3970),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3971] = {
    [sym__expression] = STATE(13324),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10651),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5690),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18795),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13082),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(59),
    [sym_identifier] = STATE(10335),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9279),
    [sym_float_literal] = STATE(9279),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3971),
    [sym_line_comment] = STATE(3971),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3679),
    [anon_sym_const] = ACTIONS(3681),
    [anon_sym_global] = ACTIONS(3683),
    [anon_sym_local] = ACTIONS(3685),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1785),
    [anon_sym_import] = ACTIONS(1787),
    [anon_sym_using] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_COLON2] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(3689),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(1811),
    [aux_sym_integer_literal_token2] = ACTIONS(1811),
    [aux_sym_integer_literal_token3] = ACTIONS(1813),
    [aux_sym_integer_literal_token4] = ACTIONS(1815),
    [aux_sym_float_literal_token1] = ACTIONS(1817),
    [aux_sym_float_literal_token3] = ACTIONS(1817),
    [aux_sym_float_literal_token4] = ACTIONS(1817),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4116),
    [sym__type_order_operator] = ACTIONS(4116),
    [sym__unary_operator] = ACTIONS(4118),
    [sym__unary_plus_operator] = ACTIONS(4118),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3972] = {
    [sym__expression] = STATE(9089),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3972),
    [sym_line_comment] = STATE(3972),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3973] = {
    [sym__expression] = STATE(9090),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3973),
    [sym_line_comment] = STATE(3973),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3974] = {
    [sym__expression] = STATE(9091),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3974),
    [sym_line_comment] = STATE(3974),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3975] = {
    [sym__expression] = STATE(9092),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3975),
    [sym_line_comment] = STATE(3975),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3976] = {
    [sym__expression] = STATE(9093),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3976),
    [sym_line_comment] = STATE(3976),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3977] = {
    [sym__expression] = STATE(9094),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3977),
    [sym_line_comment] = STATE(3977),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3978] = {
    [sym__expression] = STATE(9095),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3978),
    [sym_line_comment] = STATE(3978),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3979] = {
    [sym__expression] = STATE(7937),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3979),
    [sym_line_comment] = STATE(3979),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3980] = {
    [sym__expression] = STATE(9079),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3980),
    [sym_line_comment] = STATE(3980),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3981] = {
    [sym__expression] = STATE(9084),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3981),
    [sym_line_comment] = STATE(3981),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3982] = {
    [sym__expression] = STATE(9085),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3982),
    [sym_line_comment] = STATE(3982),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3983] = {
    [sym__expression] = STATE(14057),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3983),
    [sym_line_comment] = STATE(3983),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3984] = {
    [sym__expression] = STATE(9087),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3984),
    [sym_line_comment] = STATE(3984),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3985] = {
    [sym__expression] = STATE(9088),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(4989),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18796),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(8904),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(23),
    [sym_identifier] = STATE(4454),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(3985),
    [sym_line_comment] = STATE(3985),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(657),
    [anon_sym_const] = ACTIONS(659),
    [anon_sym_global] = ACTIONS(661),
    [anon_sym_local] = ACTIONS(663),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(5430),
    [sym__type_order_operator] = ACTIONS(5430),
    [sym__unary_operator] = ACTIONS(4050),
    [sym__unary_plus_operator] = ACTIONS(4050),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3986] = {
    [sym__expression] = STATE(14060),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3986),
    [sym_line_comment] = STATE(3986),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3987] = {
    [sym__expression] = STATE(14061),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3987),
    [sym_line_comment] = STATE(3987),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3988] = {
    [sym__expression] = STATE(14062),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3988),
    [sym_line_comment] = STATE(3988),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3989] = {
    [sym__expression] = STATE(14063),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3989),
    [sym_line_comment] = STATE(3989),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3990] = {
    [sym__expression] = STATE(14064),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3990),
    [sym_line_comment] = STATE(3990),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3991] = {
    [sym__expression] = STATE(14065),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3991),
    [sym_line_comment] = STATE(3991),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3992] = {
    [sym__expression] = STATE(14066),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3992),
    [sym_line_comment] = STATE(3992),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3993] = {
    [sym__expression] = STATE(13884),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3993),
    [sym_line_comment] = STATE(3993),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3994] = {
    [sym__expression] = STATE(14056),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3994),
    [sym_line_comment] = STATE(3994),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3995] = {
    [sym__expression] = STATE(14058),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3995),
    [sym_line_comment] = STATE(3995),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3996] = {
    [sym__expression] = STATE(14059),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(3996),
    [sym_line_comment] = STATE(3996),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3997] = {
    [sym__expression] = STATE(8589),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3997),
    [sym_line_comment] = STATE(3997),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3998] = {
    [sym__expression] = STATE(8592),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3998),
    [sym_line_comment] = STATE(3998),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [3999] = {
    [sym__expression] = STATE(8593),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(3999),
    [sym_line_comment] = STATE(3999),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4000] = {
    [sym__expression] = STATE(8605),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4000),
    [sym_line_comment] = STATE(4000),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4001] = {
    [sym__expression] = STATE(8606),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4001),
    [sym_line_comment] = STATE(4001),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4002] = {
    [sym__expression] = STATE(8607),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4002),
    [sym_line_comment] = STATE(4002),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4003] = {
    [sym__expression] = STATE(8608),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4003),
    [sym_line_comment] = STATE(4003),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4004] = {
    [sym__expression] = STATE(8609),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4004),
    [sym_line_comment] = STATE(4004),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4005] = {
    [sym__expression] = STATE(7219),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4005),
    [sym_line_comment] = STATE(4005),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4006] = {
    [sym__expression] = STATE(14088),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4006),
    [sym_line_comment] = STATE(4006),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4007] = {
    [sym__expression] = STATE(14068),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11117),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18800),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13842),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(151),
    [sym_identifier] = STATE(10506),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4007),
    [sym_line_comment] = STATE(4007),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4060),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_global] = ACTIONS(4064),
    [anon_sym_local] = ACTIONS(4066),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4168),
    [sym__type_order_operator] = ACTIONS(4168),
    [sym__unary_operator] = ACTIONS(4170),
    [sym__unary_plus_operator] = ACTIONS(4170),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4008] = {
    [sym__expression] = STATE(13107),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4008),
    [sym_line_comment] = STATE(4008),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4009] = {
    [sym__expression] = STATE(13062),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4009),
    [sym_line_comment] = STATE(4009),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4010] = {
    [sym__expression] = STATE(13063),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4010),
    [sym_line_comment] = STATE(4010),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4011] = {
    [sym__expression] = STATE(13076),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4011),
    [sym_line_comment] = STATE(4011),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4012] = {
    [sym__expression] = STATE(13065),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4012),
    [sym_line_comment] = STATE(4012),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4013] = {
    [sym__expression] = STATE(13066),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4013),
    [sym_line_comment] = STATE(4013),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4014] = {
    [sym__expression] = STATE(13079),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4014),
    [sym_line_comment] = STATE(4014),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4015] = {
    [sym__expression] = STATE(13080),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4015),
    [sym_line_comment] = STATE(4015),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4016] = {
    [sym__expression] = STATE(13069),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4016),
    [sym_line_comment] = STATE(4016),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4017] = {
    [sym__expression] = STATE(13070),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4017),
    [sym_line_comment] = STATE(4017),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4018] = {
    [sym__expression] = STATE(13071),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4018),
    [sym_line_comment] = STATE(4018),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4019] = {
    [sym__expression] = STATE(13072),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4019),
    [sym_line_comment] = STATE(4019),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4020] = {
    [sym__expression] = STATE(13073),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4020),
    [sym_line_comment] = STATE(4020),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4021] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4021),
    [sym_line_comment] = STATE(4021),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4022] = {
    [sym__expression] = STATE(13109),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4022),
    [sym_line_comment] = STATE(4022),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4023] = {
    [sym__expression] = STATE(13074),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4023),
    [sym_line_comment] = STATE(4023),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4024] = {
    [sym__expression] = STATE(13075),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4024),
    [sym_line_comment] = STATE(4024),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4025] = {
    [sym__expression] = STATE(13077),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4025),
    [sym_line_comment] = STATE(4025),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4026] = {
    [sym__expression] = STATE(13078),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10406),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18805),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12427),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(112),
    [sym_identifier] = STATE(10047),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4026),
    [sym_line_comment] = STATE(4026),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3958),
    [anon_sym_local] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4124),
    [sym__type_order_operator] = ACTIONS(4124),
    [sym__unary_operator] = ACTIONS(4126),
    [sym__unary_plus_operator] = ACTIONS(4126),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4027] = {
    [sym__expression] = STATE(13003),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4027),
    [sym_line_comment] = STATE(4027),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4028] = {
    [sym__expression] = STATE(13083),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10458),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18790),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12445),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(34),
    [sym_identifier] = STATE(10194),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4028),
    [sym_line_comment] = STATE(4028),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3579),
    [anon_sym_const] = ACTIONS(3581),
    [anon_sym_global] = ACTIONS(3583),
    [anon_sym_local] = ACTIONS(3585),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(3609),
    [sym__type_order_operator] = ACTIONS(3609),
    [sym__unary_operator] = ACTIONS(3611),
    [sym__unary_plus_operator] = ACTIONS(3611),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4029] = {
    [sym__expression] = STATE(8604),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4029),
    [sym_line_comment] = STATE(4029),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4030] = {
    [sym__expression] = STATE(8587),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4030),
    [sym_line_comment] = STATE(4030),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4031] = {
    [sym__expression] = STATE(8588),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4031),
    [sym_line_comment] = STATE(4031),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4032] = {
    [sym__expression] = STATE(8590),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4032),
    [sym_line_comment] = STATE(4032),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4033] = {
    [sym__expression] = STATE(8591),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4450),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18799),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7766),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(6),
    [sym_identifier] = STATE(4113),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4033),
    [sym_line_comment] = STATE(4033),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(371),
    [anon_sym_const] = ACTIONS(373),
    [anon_sym_global] = ACTIONS(375),
    [anon_sym_local] = ACTIONS(377),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8858),
    [sym__type_order_operator] = ACTIONS(8858),
    [sym__unary_operator] = ACTIONS(3615),
    [sym__unary_plus_operator] = ACTIONS(3615),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4034] = {
    [sym__expression] = STATE(8999),
    [sym_module_definition] = STATE(8832),
    [sym_abstract_definition] = STATE(8832),
    [sym_primitive_definition] = STATE(8832),
    [sym_struct_definition] = STATE(8832),
    [sym_function_definition] = STATE(8832),
    [sym_macro_definition] = STATE(8832),
    [sym_compound_statement] = STATE(8832),
    [sym_quote_statement] = STATE(8832),
    [sym_let_statement] = STATE(8832),
    [sym_if_statement] = STATE(8832),
    [sym_try_statement] = STATE(8832),
    [sym_for_statement] = STATE(8832),
    [sym_while_statement] = STATE(8832),
    [sym_return_statement] = STATE(8832),
    [sym_const_statement] = STATE(8832),
    [sym_global_statement] = STATE(8832),
    [sym_local_statement] = STATE(8832),
    [sym_export_statement] = STATE(8832),
    [sym_public_statement] = STATE(8832),
    [sym_import_statement] = STATE(8832),
    [sym_using_statement] = STATE(8832),
    [sym__primary_expression] = STATE(4954),
    [sym__array] = STATE(4901),
    [sym_comprehension_expression] = STATE(4905),
    [sym_matrix_expression] = STATE(4905),
    [sym_vector_expression] = STATE(4905),
    [sym_parenthesized_expression] = STATE(4901),
    [sym_tuple_expression] = STATE(4901),
    [sym_curly_expression] = STATE(4901),
    [sym_adjoint_expression] = STATE(4083),
    [sym_field_expression] = STATE(4901),
    [sym_index_expression] = STATE(4901),
    [sym_parametrized_type_expression] = STATE(4901),
    [sym_call_expression] = STATE(4901),
    [sym_broadcast_call_expression] = STATE(4901),
    [sym__closed_macrocall_expression] = STATE(4901),
    [sym_macrocall_expression] = STATE(8832),
    [sym_argument_list] = STATE(18798),
    [sym_interpolation_expression] = STATE(4901),
    [sym_quote_expression] = STATE(4901),
    [sym_binary_expression] = STATE(8832),
    [sym_unary_expression] = STATE(8832),
    [sym_range_expression] = STATE(8832),
    [sym_splat_expression] = STATE(8832),
    [sym_ternary_expression] = STATE(8832),
    [sym_typed_expression] = STATE(8856),
    [sym_unary_typed_expression] = STATE(8832),
    [sym_arrow_function_expression] = STATE(8832),
    [sym_juxtaposition_expression] = STATE(8832),
    [sym_compound_assignment_expression] = STATE(8832),
    [sym_where_expression] = STATE(8832),
    [sym_macro_identifier] = STATE(52),
    [sym_identifier] = STATE(4449),
    [sym_boolean_literal] = STATE(4901),
    [sym_integer_literal] = STATE(4093),
    [sym_float_literal] = STATE(4093),
    [sym__string] = STATE(4901),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(8052),
    [sym_block_comment] = STATE(4034),
    [sym_line_comment] = STATE(4034),
    [sym__word_identifier] = ACTIONS(921),
    [anon_sym_begin] = ACTIONS(923),
    [anon_sym_module] = ACTIONS(925),
    [anon_sym_baremodule] = ACTIONS(925),
    [anon_sym_abstract] = ACTIONS(927),
    [anon_sym_primitive] = ACTIONS(929),
    [anon_sym_mutable] = ACTIONS(931),
    [anon_sym_struct] = ACTIONS(933),
    [anon_sym_function] = ACTIONS(935),
    [anon_sym_macro] = ACTIONS(937),
    [anon_sym_quote] = ACTIONS(939),
    [anon_sym_let] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(943),
    [anon_sym_try] = ACTIONS(945),
    [anon_sym_for] = ACTIONS(947),
    [anon_sym_while] = ACTIONS(949),
    [sym_break_statement] = ACTIONS(951),
    [sym_continue_statement] = ACTIONS(951),
    [anon_sym_return] = ACTIONS(953),
    [anon_sym_const] = ACTIONS(955),
    [anon_sym_global] = ACTIONS(957),
    [anon_sym_local] = ACTIONS(959),
    [anon_sym_LPAREN] = ACTIONS(6886),
    [anon_sym_export] = ACTIONS(963),
    [anon_sym_public] = ACTIONS(965),
    [anon_sym_import] = ACTIONS(967),
    [anon_sym_using] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(6888),
    [anon_sym_LBRACE] = ACTIONS(6890),
    [anon_sym_DOLLAR] = ACTIONS(6892),
    [anon_sym_COLON2] = ACTIONS(977),
    [anon_sym_COLON_COLON] = ACTIONS(6894),
    [anon_sym_AT] = ACTIONS(5438),
    [anon_sym_true] = ACTIONS(981),
    [anon_sym_false] = ACTIONS(981),
    [aux_sym_integer_literal_token1] = ACTIONS(6896),
    [aux_sym_integer_literal_token2] = ACTIONS(6896),
    [aux_sym_integer_literal_token3] = ACTIONS(983),
    [aux_sym_integer_literal_token4] = ACTIONS(985),
    [aux_sym_float_literal_token1] = ACTIONS(6898),
    [aux_sym_float_literal_token3] = ACTIONS(6898),
    [aux_sym_float_literal_token4] = ACTIONS(6898),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6902),
    [sym__arrow_operator] = ACTIONS(991),
    [sym__comparison_operator] = ACTIONS(991),
    [sym__pipe_right_operator] = ACTIONS(6902),
    [sym__pipe_left_operator] = ACTIONS(6902),
    [sym__ellipsis_operator] = ACTIONS(6902),
    [sym__plus_operator] = ACTIONS(991),
    [sym__times_operator] = ACTIONS(991),
    [sym__rational_operator] = ACTIONS(6902),
    [sym__bitshift_operator] = ACTIONS(6902),
    [sym__power_operator] = ACTIONS(6902),
    [sym__tilde_operator] = ACTIONS(8862),
    [sym__type_order_operator] = ACTIONS(8862),
    [sym__unary_operator] = ACTIONS(4052),
    [sym__unary_plus_operator] = ACTIONS(4052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4035] = {
    [sym__expression] = STATE(9280),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(4035),
    [sym_line_comment] = STATE(4035),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4036] = {
    [sym__expression] = STATE(9301),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(4036),
    [sym_line_comment] = STATE(4036),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4037] = {
    [sym__expression] = STATE(9302),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(4037),
    [sym_line_comment] = STATE(4037),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4038] = {
    [sym__expression] = STATE(9304),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(4038),
    [sym_line_comment] = STATE(4038),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4039] = {
    [sym__expression] = STATE(9305),
    [sym_module_definition] = STATE(8450),
    [sym_abstract_definition] = STATE(8450),
    [sym_primitive_definition] = STATE(8450),
    [sym_struct_definition] = STATE(8450),
    [sym_function_definition] = STATE(8450),
    [sym_macro_definition] = STATE(8450),
    [sym_compound_statement] = STATE(8450),
    [sym_quote_statement] = STATE(8450),
    [sym_let_statement] = STATE(8450),
    [sym_if_statement] = STATE(8450),
    [sym_try_statement] = STATE(8450),
    [sym_for_statement] = STATE(8450),
    [sym_while_statement] = STATE(8450),
    [sym_return_statement] = STATE(8450),
    [sym_const_statement] = STATE(8450),
    [sym_global_statement] = STATE(8450),
    [sym_local_statement] = STATE(8450),
    [sym_export_statement] = STATE(8450),
    [sym_public_statement] = STATE(8450),
    [sym_import_statement] = STATE(8450),
    [sym_using_statement] = STATE(8450),
    [sym__primary_expression] = STATE(5133),
    [sym__array] = STATE(4548),
    [sym_comprehension_expression] = STATE(4721),
    [sym_matrix_expression] = STATE(4721),
    [sym_vector_expression] = STATE(4721),
    [sym_parenthesized_expression] = STATE(4548),
    [sym_tuple_expression] = STATE(4548),
    [sym_curly_expression] = STATE(4548),
    [sym_adjoint_expression] = STATE(4079),
    [sym_field_expression] = STATE(4548),
    [sym_index_expression] = STATE(4548),
    [sym_parametrized_type_expression] = STATE(4548),
    [sym_call_expression] = STATE(4548),
    [sym_broadcast_call_expression] = STATE(4548),
    [sym__closed_macrocall_expression] = STATE(4548),
    [sym_macrocall_expression] = STATE(8450),
    [sym_argument_list] = STATE(18774),
    [sym_interpolation_expression] = STATE(4548),
    [sym_quote_expression] = STATE(4548),
    [sym_binary_expression] = STATE(8450),
    [sym_unary_expression] = STATE(8450),
    [sym_range_expression] = STATE(8450),
    [sym_splat_expression] = STATE(8450),
    [sym_ternary_expression] = STATE(8450),
    [sym_typed_expression] = STATE(9000),
    [sym_unary_typed_expression] = STATE(8450),
    [sym_arrow_function_expression] = STATE(8450),
    [sym_juxtaposition_expression] = STATE(8450),
    [sym_compound_assignment_expression] = STATE(8450),
    [sym_where_expression] = STATE(8450),
    [sym_macro_identifier] = STATE(55),
    [sym_identifier] = STATE(4475),
    [sym_boolean_literal] = STATE(4548),
    [sym_integer_literal] = STATE(4092),
    [sym_float_literal] = STATE(4092),
    [sym__string] = STATE(4548),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(7480),
    [sym_block_comment] = STATE(4039),
    [sym_line_comment] = STATE(4039),
    [sym__word_identifier] = ACTIONS(625),
    [anon_sym_begin] = ACTIONS(627),
    [anon_sym_module] = ACTIONS(629),
    [anon_sym_baremodule] = ACTIONS(629),
    [anon_sym_abstract] = ACTIONS(631),
    [anon_sym_primitive] = ACTIONS(633),
    [anon_sym_mutable] = ACTIONS(635),
    [anon_sym_struct] = ACTIONS(637),
    [anon_sym_function] = ACTIONS(639),
    [anon_sym_macro] = ACTIONS(641),
    [anon_sym_quote] = ACTIONS(643),
    [anon_sym_let] = ACTIONS(645),
    [anon_sym_if] = ACTIONS(647),
    [anon_sym_try] = ACTIONS(649),
    [anon_sym_for] = ACTIONS(651),
    [anon_sym_while] = ACTIONS(653),
    [sym_break_statement] = ACTIONS(655),
    [sym_continue_statement] = ACTIONS(655),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1031),
    [anon_sym_global] = ACTIONS(1033),
    [anon_sym_local] = ACTIONS(1035),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_export] = ACTIONS(667),
    [anon_sym_public] = ACTIONS(669),
    [anon_sym_import] = ACTIONS(671),
    [anon_sym_using] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(4938),
    [anon_sym_LBRACE] = ACTIONS(4942),
    [anon_sym_DOLLAR] = ACTIONS(4944),
    [anon_sym_COLON2] = ACTIONS(681),
    [anon_sym_COLON_COLON] = ACTIONS(4946),
    [anon_sym_AT] = ACTIONS(69),
    [anon_sym_true] = ACTIONS(687),
    [anon_sym_false] = ACTIONS(687),
    [aux_sym_integer_literal_token1] = ACTIONS(4948),
    [aux_sym_integer_literal_token2] = ACTIONS(4948),
    [aux_sym_integer_literal_token3] = ACTIONS(689),
    [aux_sym_integer_literal_token4] = ACTIONS(691),
    [aux_sym_float_literal_token1] = ACTIONS(4950),
    [aux_sym_float_literal_token3] = ACTIONS(4950),
    [aux_sym_float_literal_token4] = ACTIONS(4950),
    [sym_character_literal] = ACTIONS(4952),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(4954),
    [sym__arrow_operator] = ACTIONS(697),
    [sym__comparison_operator] = ACTIONS(697),
    [sym__pipe_right_operator] = ACTIONS(4954),
    [sym__pipe_left_operator] = ACTIONS(4954),
    [sym__ellipsis_operator] = ACTIONS(4954),
    [sym__plus_operator] = ACTIONS(697),
    [sym__times_operator] = ACTIONS(697),
    [sym__rational_operator] = ACTIONS(4954),
    [sym__bitshift_operator] = ACTIONS(4954),
    [sym__power_operator] = ACTIONS(4954),
    [sym__tilde_operator] = ACTIONS(8896),
    [sym__type_order_operator] = ACTIONS(8896),
    [sym__unary_operator] = ACTIONS(4058),
    [sym__unary_plus_operator] = ACTIONS(4058),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4040] = {
    [sym__expression] = STATE(8574),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4040),
    [sym_line_comment] = STATE(4040),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4041] = {
    [sym__expression] = STATE(8577),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4041),
    [sym_line_comment] = STATE(4041),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4042] = {
    [sym__expression] = STATE(8578),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4042),
    [sym_line_comment] = STATE(4042),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4043] = {
    [sym__expression] = STATE(8612),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4043),
    [sym_line_comment] = STATE(4043),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4044] = {
    [sym__expression] = STATE(8613),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4044),
    [sym_line_comment] = STATE(4044),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4045] = {
    [sym__expression] = STATE(8614),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4045),
    [sym_line_comment] = STATE(4045),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4046] = {
    [sym__expression] = STATE(8615),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4046),
    [sym_line_comment] = STATE(4046),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4047] = {
    [sym__expression] = STATE(8616),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4047),
    [sym_line_comment] = STATE(4047),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4048] = {
    [sym__expression] = STATE(7219),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4472),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18755),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(7819),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4108),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4048),
    [sym_line_comment] = STATE(4048),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8894),
    [sym__type_order_operator] = ACTIONS(8894),
    [sym__unary_operator] = ACTIONS(3617),
    [sym__unary_plus_operator] = ACTIONS(3617),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4049] = {
    [sym__expression] = STATE(14032),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4049),
    [sym_line_comment] = STATE(4049),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4050] = {
    [sym__expression] = STATE(14082),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(11119),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(6378),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18806),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(13845),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(96),
    [sym_identifier] = STATE(10662),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(9339),
    [sym_float_literal] = STATE(9339),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4050),
    [sym_line_comment] = STATE(4050),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(3962),
    [anon_sym_const] = ACTIONS(3964),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_local] = ACTIONS(3968),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3970),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_import] = ACTIONS(3974),
    [anon_sym_using] = ACTIONS(3976),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3978),
    [anon_sym_COLON2] = ACTIONS(3980),
    [anon_sym_COLON_COLON] = ACTIONS(3982),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3984),
    [aux_sym_integer_literal_token2] = ACTIONS(3984),
    [aux_sym_integer_literal_token3] = ACTIONS(3986),
    [aux_sym_integer_literal_token4] = ACTIONS(3988),
    [aux_sym_float_literal_token1] = ACTIONS(3990),
    [aux_sym_float_literal_token3] = ACTIONS(3990),
    [aux_sym_float_literal_token4] = ACTIONS(3990),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4160),
    [sym__type_order_operator] = ACTIONS(4160),
    [sym__unary_operator] = ACTIONS(4162),
    [sym__unary_plus_operator] = ACTIONS(4162),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4051] = {
    [sym__expression] = STATE(13088),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4051),
    [sym_line_comment] = STATE(4051),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4052] = {
    [sym__expression] = STATE(13089),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4052),
    [sym_line_comment] = STATE(4052),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4053] = {
    [sym__expression] = STATE(13090),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4053),
    [sym_line_comment] = STATE(4053),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4054] = {
    [sym__expression] = STATE(13091),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4054),
    [sym_line_comment] = STATE(4054),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4055] = {
    [sym__expression] = STATE(13092),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4055),
    [sym_line_comment] = STATE(4055),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4056] = {
    [sym__expression] = STATE(13093),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4056),
    [sym_line_comment] = STATE(4056),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4057] = {
    [sym__expression] = STATE(13094),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4057),
    [sym_line_comment] = STATE(4057),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4058] = {
    [sym__expression] = STATE(13095),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4058),
    [sym_line_comment] = STATE(4058),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4059] = {
    [sym__expression] = STATE(13096),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4059),
    [sym_line_comment] = STATE(4059),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4060] = {
    [sym__expression] = STATE(13097),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4060),
    [sym_line_comment] = STATE(4060),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4061] = {
    [sym__expression] = STATE(13098),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4061),
    [sym_line_comment] = STATE(4061),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4062] = {
    [sym__expression] = STATE(11411),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4062),
    [sym_line_comment] = STATE(4062),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4063] = {
    [sym__expression] = STATE(13064),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4063),
    [sym_line_comment] = STATE(4063),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4064] = {
    [sym__expression] = STATE(13067),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4064),
    [sym_line_comment] = STATE(4064),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4065] = {
    [sym__expression] = STATE(13068),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4065),
    [sym_line_comment] = STATE(4065),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4066] = {
    [sym__expression] = STATE(13099),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4066),
    [sym_line_comment] = STATE(4066),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4067] = {
    [sym__expression] = STATE(13100),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4067),
    [sym_line_comment] = STATE(4067),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4068] = {
    [sym__expression] = STATE(13101),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4068),
    [sym_line_comment] = STATE(4068),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4069] = {
    [sym__expression] = STATE(13102),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4069),
    [sym_line_comment] = STATE(4069),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4070] = {
    [sym__expression] = STATE(13103),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4070),
    [sym_line_comment] = STATE(4070),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4071] = {
    [sym__expression] = STATE(12297),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10405),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(5033),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18803),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12426),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(103),
    [sym_identifier] = STATE(10043),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(8896),
    [sym_float_literal] = STATE(8896),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4071),
    [sym_line_comment] = STATE(4071),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(1741),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4016),
    [anon_sym_const] = ACTIONS(4018),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_local] = ACTIONS(4022),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3860),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_import] = ACTIONS(3864),
    [anon_sym_using] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3868),
    [anon_sym_COLON2] = ACTIONS(3870),
    [anon_sym_COLON_COLON] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(883),
    [aux_sym_integer_literal_token2] = ACTIONS(883),
    [aux_sym_integer_literal_token3] = ACTIONS(885),
    [aux_sym_integer_literal_token4] = ACTIONS(887),
    [aux_sym_float_literal_token1] = ACTIONS(889),
    [aux_sym_float_literal_token3] = ACTIONS(889),
    [aux_sym_float_literal_token4] = ACTIONS(889),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4120),
    [sym__type_order_operator] = ACTIONS(4120),
    [sym__unary_operator] = ACTIONS(4122),
    [sym__unary_plus_operator] = ACTIONS(4122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4072] = {
    [sym__expression] = STATE(13113),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4072),
    [sym_line_comment] = STATE(4072),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4073] = {
    [sym__expression] = STATE(13105),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10459),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18801),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12495),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(248),
    [sym_identifier] = STATE(10046),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4073),
    [sym_line_comment] = STATE(4073),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4150),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_local] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4192),
    [sym__type_order_operator] = ACTIONS(4192),
    [sym__unary_operator] = ACTIONS(4194),
    [sym__unary_plus_operator] = ACTIONS(4194),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4074] = {
    [sym__expression] = STATE(13055),
    [sym_module_definition] = STATE(10824),
    [sym_abstract_definition] = STATE(10824),
    [sym_primitive_definition] = STATE(10824),
    [sym_struct_definition] = STATE(10824),
    [sym_function_definition] = STATE(10824),
    [sym_macro_definition] = STATE(10824),
    [sym_compound_statement] = STATE(10824),
    [sym_quote_statement] = STATE(10824),
    [sym_let_statement] = STATE(10824),
    [sym_if_statement] = STATE(10824),
    [sym_try_statement] = STATE(10824),
    [sym_for_statement] = STATE(10824),
    [sym_while_statement] = STATE(10824),
    [sym_return_statement] = STATE(10824),
    [sym_const_statement] = STATE(10824),
    [sym_global_statement] = STATE(10824),
    [sym_local_statement] = STATE(10824),
    [sym_export_statement] = STATE(10824),
    [sym_public_statement] = STATE(10824),
    [sym_import_statement] = STATE(10824),
    [sym_using_statement] = STATE(10824),
    [sym__primary_expression] = STATE(10460),
    [sym__array] = STATE(9799),
    [sym_comprehension_expression] = STATE(9774),
    [sym_matrix_expression] = STATE(9774),
    [sym_vector_expression] = STATE(9774),
    [sym_parenthesized_expression] = STATE(9799),
    [sym_tuple_expression] = STATE(9799),
    [sym_curly_expression] = STATE(9799),
    [sym_adjoint_expression] = STATE(4244),
    [sym_field_expression] = STATE(9799),
    [sym_index_expression] = STATE(9799),
    [sym_parametrized_type_expression] = STATE(9799),
    [sym_call_expression] = STATE(9799),
    [sym_broadcast_call_expression] = STATE(9799),
    [sym__closed_macrocall_expression] = STATE(9799),
    [sym_macrocall_expression] = STATE(10824),
    [sym_argument_list] = STATE(18982),
    [sym_interpolation_expression] = STATE(9799),
    [sym_quote_expression] = STATE(9799),
    [sym_binary_expression] = STATE(10824),
    [sym_unary_expression] = STATE(10824),
    [sym_range_expression] = STATE(10824),
    [sym_splat_expression] = STATE(10824),
    [sym_ternary_expression] = STATE(10824),
    [sym_typed_expression] = STATE(12496),
    [sym_unary_typed_expression] = STATE(10824),
    [sym_arrow_function_expression] = STATE(10824),
    [sym_juxtaposition_expression] = STATE(10824),
    [sym_compound_assignment_expression] = STATE(10824),
    [sym_where_expression] = STATE(10824),
    [sym_macro_identifier] = STATE(169),
    [sym_identifier] = STATE(10182),
    [sym_boolean_literal] = STATE(9799),
    [sym_integer_literal] = STATE(7200),
    [sym_float_literal] = STATE(7200),
    [sym__string] = STATE(9799),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(10584),
    [sym_block_comment] = STATE(4074),
    [sym_line_comment] = STATE(4074),
    [sym__word_identifier] = ACTIONS(1737),
    [anon_sym_begin] = ACTIONS(3577),
    [anon_sym_module] = ACTIONS(1743),
    [anon_sym_baremodule] = ACTIONS(1743),
    [anon_sym_abstract] = ACTIONS(1745),
    [anon_sym_primitive] = ACTIONS(1747),
    [anon_sym_mutable] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1751),
    [anon_sym_function] = ACTIONS(1753),
    [anon_sym_macro] = ACTIONS(1755),
    [anon_sym_quote] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1759),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1767),
    [sym_break_statement] = ACTIONS(1769),
    [sym_continue_statement] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4102),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_local] = ACTIONS(4106),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(3587),
    [anon_sym_public] = ACTIONS(3589),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_using] = ACTIONS(3593),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(3595),
    [anon_sym_COLON2] = ACTIONS(3597),
    [anon_sym_COLON_COLON] = ACTIONS(3599),
    [anon_sym_AT] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [aux_sym_integer_literal_token1] = ACTIONS(3601),
    [aux_sym_integer_literal_token2] = ACTIONS(3601),
    [aux_sym_integer_literal_token3] = ACTIONS(3603),
    [aux_sym_integer_literal_token4] = ACTIONS(3605),
    [aux_sym_float_literal_token1] = ACTIONS(3607),
    [aux_sym_float_literal_token3] = ACTIONS(3607),
    [aux_sym_float_literal_token4] = ACTIONS(3607),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(1823),
    [sym__arrow_operator] = ACTIONS(1825),
    [sym__comparison_operator] = ACTIONS(1825),
    [sym__pipe_right_operator] = ACTIONS(1823),
    [sym__pipe_left_operator] = ACTIONS(1823),
    [sym__ellipsis_operator] = ACTIONS(1823),
    [sym__plus_operator] = ACTIONS(1825),
    [sym__times_operator] = ACTIONS(1825),
    [sym__rational_operator] = ACTIONS(1823),
    [sym__bitshift_operator] = ACTIONS(1823),
    [sym__power_operator] = ACTIONS(1823),
    [sym__tilde_operator] = ACTIONS(4188),
    [sym__type_order_operator] = ACTIONS(4188),
    [sym__unary_operator] = ACTIONS(4190),
    [sym__unary_plus_operator] = ACTIONS(4190),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4075] = {
    [sym__expression] = STATE(66),
    [sym_module_definition] = STATE(7874),
    [sym_abstract_definition] = STATE(7874),
    [sym_primitive_definition] = STATE(7874),
    [sym_struct_definition] = STATE(7874),
    [sym_function_definition] = STATE(7874),
    [sym_macro_definition] = STATE(7874),
    [sym_compound_statement] = STATE(7874),
    [sym_quote_statement] = STATE(7874),
    [sym_let_statement] = STATE(7874),
    [sym_if_statement] = STATE(7874),
    [sym_try_statement] = STATE(7874),
    [sym_for_statement] = STATE(7874),
    [sym_while_statement] = STATE(7874),
    [sym_return_statement] = STATE(7874),
    [sym_const_statement] = STATE(7874),
    [sym_global_statement] = STATE(7874),
    [sym_local_statement] = STATE(7874),
    [sym_export_statement] = STATE(7874),
    [sym_public_statement] = STATE(7874),
    [sym_import_statement] = STATE(7874),
    [sym_using_statement] = STATE(7874),
    [sym__primary_expression] = STATE(4723),
    [sym__array] = STATE(4292),
    [sym_comprehension_expression] = STATE(4293),
    [sym_matrix_expression] = STATE(4293),
    [sym_vector_expression] = STATE(4293),
    [sym_parenthesized_expression] = STATE(4292),
    [sym_tuple_expression] = STATE(4292),
    [sym_curly_expression] = STATE(4292),
    [sym_adjoint_expression] = STATE(4077),
    [sym_field_expression] = STATE(4292),
    [sym_index_expression] = STATE(4292),
    [sym_parametrized_type_expression] = STATE(4292),
    [sym_call_expression] = STATE(4292),
    [sym_broadcast_call_expression] = STATE(4292),
    [sym__closed_macrocall_expression] = STATE(4292),
    [sym_macrocall_expression] = STATE(7874),
    [sym_argument_list] = STATE(18519),
    [sym_interpolation_expression] = STATE(4292),
    [sym_quote_expression] = STATE(4292),
    [sym_binary_expression] = STATE(7874),
    [sym_unary_expression] = STATE(7874),
    [sym_range_expression] = STATE(7874),
    [sym_splat_expression] = STATE(7874),
    [sym_ternary_expression] = STATE(7874),
    [sym_typed_expression] = STATE(8196),
    [sym_unary_typed_expression] = STATE(7874),
    [sym_arrow_function_expression] = STATE(7874),
    [sym_juxtaposition_expression] = STATE(7874),
    [sym_compound_assignment_expression] = STATE(7874),
    [sym_where_expression] = STATE(7874),
    [sym_macro_identifier] = STATE(19),
    [sym_identifier] = STATE(4137),
    [sym_boolean_literal] = STATE(4292),
    [sym_integer_literal] = STATE(4087),
    [sym_float_literal] = STATE(4087),
    [sym__string] = STATE(4292),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(6801),
    [sym_block_comment] = STATE(4075),
    [sym_line_comment] = STATE(4075),
    [sym__word_identifier] = ACTIONS(339),
    [anon_sym_begin] = ACTIONS(341),
    [anon_sym_module] = ACTIONS(343),
    [anon_sym_baremodule] = ACTIONS(343),
    [anon_sym_abstract] = ACTIONS(345),
    [anon_sym_primitive] = ACTIONS(347),
    [anon_sym_mutable] = ACTIONS(349),
    [anon_sym_struct] = ACTIONS(351),
    [anon_sym_function] = ACTIONS(353),
    [anon_sym_macro] = ACTIONS(355),
    [anon_sym_quote] = ACTIONS(357),
    [anon_sym_let] = ACTIONS(359),
    [anon_sym_if] = ACTIONS(361),
    [anon_sym_try] = ACTIONS(363),
    [anon_sym_for] = ACTIONS(365),
    [anon_sym_while] = ACTIONS(367),
    [sym_break_statement] = ACTIONS(369),
    [sym_continue_statement] = ACTIONS(369),
    [anon_sym_return] = ACTIONS(617),
    [anon_sym_const] = ACTIONS(619),
    [anon_sym_global] = ACTIONS(621),
    [anon_sym_local] = ACTIONS(623),
    [anon_sym_LPAREN] = ACTIONS(6864),
    [anon_sym_export] = ACTIONS(381),
    [anon_sym_public] = ACTIONS(383),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_using] = ACTIONS(387),
    [anon_sym_LBRACK] = ACTIONS(6866),
    [anon_sym_LBRACE] = ACTIONS(6868),
    [anon_sym_DOLLAR] = ACTIONS(6870),
    [anon_sym_COLON2] = ACTIONS(395),
    [anon_sym_COLON_COLON] = ACTIONS(6872),
    [anon_sym_AT] = ACTIONS(4206),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [aux_sym_integer_literal_token1] = ACTIONS(6874),
    [aux_sym_integer_literal_token2] = ACTIONS(6874),
    [aux_sym_integer_literal_token3] = ACTIONS(403),
    [aux_sym_integer_literal_token4] = ACTIONS(405),
    [aux_sym_float_literal_token1] = ACTIONS(6876),
    [aux_sym_float_literal_token3] = ACTIONS(6876),
    [aux_sym_float_literal_token4] = ACTIONS(6876),
    [sym_character_literal] = ACTIONS(6878),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(6880),
    [sym__arrow_operator] = ACTIONS(411),
    [sym__comparison_operator] = ACTIONS(411),
    [sym__pipe_right_operator] = ACTIONS(6880),
    [sym__pipe_left_operator] = ACTIONS(6880),
    [sym__ellipsis_operator] = ACTIONS(6880),
    [sym__plus_operator] = ACTIONS(411),
    [sym__times_operator] = ACTIONS(411),
    [sym__rational_operator] = ACTIONS(6880),
    [sym__bitshift_operator] = ACTIONS(6880),
    [sym__power_operator] = ACTIONS(6880),
    [sym__tilde_operator] = ACTIONS(8878),
    [sym__type_order_operator] = ACTIONS(8878),
    [sym__unary_operator] = ACTIONS(3073),
    [sym__unary_plus_operator] = ACTIONS(3073),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4076] = {
    [sym__primary_expression] = STATE(5801),
    [sym__array] = STATE(5707),
    [sym_comprehension_expression] = STATE(5908),
    [sym_matrix_expression] = STATE(5908),
    [sym_vector_expression] = STATE(5908),
    [sym_parenthesized_expression] = STATE(5707),
    [sym_tuple_expression] = STATE(5707),
    [sym_curly_expression] = STATE(5707),
    [sym_adjoint_expression] = STATE(5707),
    [sym_field_expression] = STATE(5707),
    [sym_index_expression] = STATE(5707),
    [sym_parametrized_type_expression] = STATE(5707),
    [sym_call_expression] = STATE(5707),
    [sym_broadcast_call_expression] = STATE(5707),
    [sym__closed_macrocall_expression] = STATE(5707),
    [sym_interpolation_expression] = STATE(5707),
    [sym_quote_expression] = STATE(5707),
    [sym_macro_identifier] = STATE(17667),
    [sym_identifier] = STATE(5015),
    [sym_boolean_literal] = STATE(5707),
    [sym__string] = STATE(5707),
    [sym__delimiter_str_1] = STATE(14755),
    [sym__delimiter_str_3] = STATE(14765),
    [sym__delimiter_cmd_1] = STATE(14767),
    [sym__delimiter_cmd_3] = STATE(14806),
    [sym_string_literal] = STATE(5907),
    [sym_command_literal] = STATE(5907),
    [sym_prefixed_string_literal] = STATE(5907),
    [sym_prefixed_command_literal] = STATE(5907),
    [sym_operator] = STATE(19520),
    [sym_block_comment] = STATE(4076),
    [sym_line_comment] = STATE(4076),
    [sym__word_identifier] = ACTIONS(8898),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(8901),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(8904),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(8907),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(8910),
    [anon_sym_COLON2] = ACTIONS(8913),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(8919),
    [anon_sym_false] = ACTIONS(8919),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(8922),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4077] = {
    [sym__primary_expression] = STATE(5697),
    [sym__array] = STATE(5533),
    [sym_comprehension_expression] = STATE(5576),
    [sym_matrix_expression] = STATE(5576),
    [sym_vector_expression] = STATE(5576),
    [sym_parenthesized_expression] = STATE(5533),
    [sym_tuple_expression] = STATE(5533),
    [sym_curly_expression] = STATE(5533),
    [sym_adjoint_expression] = STATE(5533),
    [sym_field_expression] = STATE(5533),
    [sym_index_expression] = STATE(5533),
    [sym_parametrized_type_expression] = STATE(5533),
    [sym_call_expression] = STATE(5533),
    [sym_broadcast_call_expression] = STATE(5533),
    [sym__closed_macrocall_expression] = STATE(5533),
    [sym_interpolation_expression] = STATE(5533),
    [sym_quote_expression] = STATE(5533),
    [sym_macro_identifier] = STATE(17256),
    [sym_identifier] = STATE(4860),
    [sym_boolean_literal] = STATE(5533),
    [sym__string] = STATE(5533),
    [sym__delimiter_str_1] = STATE(14988),
    [sym__delimiter_str_3] = STATE(14989),
    [sym__delimiter_cmd_1] = STATE(14999),
    [sym__delimiter_cmd_3] = STATE(15012),
    [sym_string_literal] = STATE(5575),
    [sym_command_literal] = STATE(5575),
    [sym_prefixed_string_literal] = STATE(5575),
    [sym_prefixed_command_literal] = STATE(5575),
    [sym_operator] = STATE(18688),
    [sym_block_comment] = STATE(4077),
    [sym_line_comment] = STATE(4077),
    [sym__word_identifier] = ACTIONS(8940),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(8943),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(8946),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(8949),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(8952),
    [anon_sym_COLON2] = ACTIONS(8955),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(8958),
    [anon_sym_false] = ACTIONS(8958),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(8961),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4078] = {
    [sym__primary_expression] = STATE(6238),
    [sym__array] = STATE(6207),
    [sym_comprehension_expression] = STATE(6188),
    [sym_matrix_expression] = STATE(6188),
    [sym_vector_expression] = STATE(6188),
    [sym_parenthesized_expression] = STATE(6207),
    [sym_tuple_expression] = STATE(6207),
    [sym_curly_expression] = STATE(6207),
    [sym_adjoint_expression] = STATE(6207),
    [sym_field_expression] = STATE(6207),
    [sym_index_expression] = STATE(6207),
    [sym_parametrized_type_expression] = STATE(6207),
    [sym_call_expression] = STATE(6207),
    [sym_broadcast_call_expression] = STATE(6207),
    [sym__closed_macrocall_expression] = STATE(6207),
    [sym_interpolation_expression] = STATE(6207),
    [sym_quote_expression] = STATE(6207),
    [sym_macro_identifier] = STATE(17104),
    [sym_identifier] = STATE(5340),
    [sym_boolean_literal] = STATE(6207),
    [sym__string] = STATE(6207),
    [sym__delimiter_str_1] = STATE(14407),
    [sym__delimiter_str_3] = STATE(14408),
    [sym__delimiter_cmd_1] = STATE(14409),
    [sym__delimiter_cmd_3] = STATE(14414),
    [sym_string_literal] = STATE(6187),
    [sym_command_literal] = STATE(6187),
    [sym_prefixed_string_literal] = STATE(6187),
    [sym_prefixed_command_literal] = STATE(6187),
    [sym_operator] = STATE(18735),
    [sym_block_comment] = STATE(4078),
    [sym_line_comment] = STATE(4078),
    [sym__word_identifier] = ACTIONS(8964),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(8967),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(8970),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(8973),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(8976),
    [anon_sym_COLON2] = ACTIONS(8979),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(8982),
    [anon_sym_false] = ACTIONS(8982),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(8985),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4079] = {
    [sym__primary_expression] = STATE(5950),
    [sym__array] = STATE(6270),
    [sym_comprehension_expression] = STATE(5960),
    [sym_matrix_expression] = STATE(5960),
    [sym_vector_expression] = STATE(5960),
    [sym_parenthesized_expression] = STATE(6270),
    [sym_tuple_expression] = STATE(6270),
    [sym_curly_expression] = STATE(6270),
    [sym_adjoint_expression] = STATE(6270),
    [sym_field_expression] = STATE(6270),
    [sym_index_expression] = STATE(6270),
    [sym_parametrized_type_expression] = STATE(6270),
    [sym_call_expression] = STATE(6270),
    [sym_broadcast_call_expression] = STATE(6270),
    [sym__closed_macrocall_expression] = STATE(6270),
    [sym_interpolation_expression] = STATE(6270),
    [sym_quote_expression] = STATE(6270),
    [sym_macro_identifier] = STATE(17341),
    [sym_identifier] = STATE(5273),
    [sym_boolean_literal] = STATE(6270),
    [sym__string] = STATE(6270),
    [sym__delimiter_str_1] = STATE(14607),
    [sym__delimiter_str_3] = STATE(14609),
    [sym__delimiter_cmd_1] = STATE(14610),
    [sym__delimiter_cmd_3] = STATE(14611),
    [sym_string_literal] = STATE(5958),
    [sym_command_literal] = STATE(5958),
    [sym_prefixed_string_literal] = STATE(5958),
    [sym_prefixed_command_literal] = STATE(5958),
    [sym_operator] = STATE(18896),
    [sym_block_comment] = STATE(4079),
    [sym_line_comment] = STATE(4079),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(8988),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(8991),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(8994),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(8997),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9000),
    [anon_sym_COLON2] = ACTIONS(9003),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(9006),
    [anon_sym_false] = ACTIONS(9006),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(9009),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4080] = {
    [sym__primary_expression] = STATE(6051),
    [sym__array] = STATE(5959),
    [sym_comprehension_expression] = STATE(6039),
    [sym_matrix_expression] = STATE(6039),
    [sym_vector_expression] = STATE(6039),
    [sym_parenthesized_expression] = STATE(5959),
    [sym_tuple_expression] = STATE(5959),
    [sym_curly_expression] = STATE(5959),
    [sym_adjoint_expression] = STATE(5959),
    [sym_field_expression] = STATE(5959),
    [sym_index_expression] = STATE(5959),
    [sym_parametrized_type_expression] = STATE(5959),
    [sym_call_expression] = STATE(5959),
    [sym_broadcast_call_expression] = STATE(5959),
    [sym__closed_macrocall_expression] = STATE(5959),
    [sym_interpolation_expression] = STATE(5959),
    [sym_quote_expression] = STATE(5959),
    [sym_macro_identifier] = STATE(17448),
    [sym_identifier] = STATE(5051),
    [sym_boolean_literal] = STATE(5959),
    [sym__string] = STATE(5959),
    [sym__delimiter_str_1] = STATE(15069),
    [sym__delimiter_str_3] = STATE(15071),
    [sym__delimiter_cmd_1] = STATE(15072),
    [sym__delimiter_cmd_3] = STATE(15073),
    [sym_string_literal] = STATE(6037),
    [sym_command_literal] = STATE(6037),
    [sym_prefixed_string_literal] = STATE(6037),
    [sym_prefixed_command_literal] = STATE(6037),
    [sym_operator] = STATE(19159),
    [sym_block_comment] = STATE(4080),
    [sym_line_comment] = STATE(4080),
    [sym__word_identifier] = ACTIONS(9012),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9015),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9018),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(9021),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9024),
    [anon_sym_COLON2] = ACTIONS(9027),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9030),
    [anon_sym_true] = ACTIONS(9033),
    [anon_sym_false] = ACTIONS(9033),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(9036),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9039),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9042),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4081] = {
    [sym__primary_expression] = STATE(6132),
    [sym__array] = STATE(6076),
    [sym_comprehension_expression] = STATE(6157),
    [sym_matrix_expression] = STATE(6157),
    [sym_vector_expression] = STATE(6157),
    [sym_parenthesized_expression] = STATE(6076),
    [sym_tuple_expression] = STATE(6076),
    [sym_curly_expression] = STATE(6076),
    [sym_adjoint_expression] = STATE(6076),
    [sym_field_expression] = STATE(6076),
    [sym_index_expression] = STATE(6076),
    [sym_parametrized_type_expression] = STATE(6076),
    [sym_call_expression] = STATE(6076),
    [sym_broadcast_call_expression] = STATE(6076),
    [sym__closed_macrocall_expression] = STATE(6076),
    [sym_interpolation_expression] = STATE(6076),
    [sym_quote_expression] = STATE(6076),
    [sym_macro_identifier] = STATE(17585),
    [sym_identifier] = STATE(5217),
    [sym_boolean_literal] = STATE(6076),
    [sym__string] = STATE(6076),
    [sym__delimiter_str_1] = STATE(14392),
    [sym__delimiter_str_3] = STATE(14393),
    [sym__delimiter_cmd_1] = STATE(14394),
    [sym__delimiter_cmd_3] = STATE(14395),
    [sym_string_literal] = STATE(6156),
    [sym_command_literal] = STATE(6156),
    [sym_prefixed_string_literal] = STATE(6156),
    [sym_prefixed_command_literal] = STATE(6156),
    [sym_operator] = STATE(19401),
    [sym_block_comment] = STATE(4081),
    [sym_line_comment] = STATE(4081),
    [sym__word_identifier] = ACTIONS(9048),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9051),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9054),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9057),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9060),
    [anon_sym_COLON2] = ACTIONS(9063),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(9066),
    [anon_sym_false] = ACTIONS(9066),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(9069),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4082] = {
    [sym__primary_expression] = STATE(6204),
    [sym__array] = STATE(6140),
    [sym_comprehension_expression] = STATE(6299),
    [sym_matrix_expression] = STATE(6299),
    [sym_vector_expression] = STATE(6299),
    [sym_parenthesized_expression] = STATE(6140),
    [sym_tuple_expression] = STATE(6140),
    [sym_curly_expression] = STATE(6140),
    [sym_adjoint_expression] = STATE(6140),
    [sym_field_expression] = STATE(6140),
    [sym_index_expression] = STATE(6140),
    [sym_parametrized_type_expression] = STATE(6140),
    [sym_call_expression] = STATE(6140),
    [sym_broadcast_call_expression] = STATE(6140),
    [sym__closed_macrocall_expression] = STATE(6140),
    [sym_interpolation_expression] = STATE(6140),
    [sym_quote_expression] = STATE(6140),
    [sym_macro_identifier] = STATE(17072),
    [sym_identifier] = STATE(5206),
    [sym_boolean_literal] = STATE(6140),
    [sym__string] = STATE(6140),
    [sym__delimiter_str_1] = STATE(14982),
    [sym__delimiter_str_3] = STATE(14987),
    [sym__delimiter_cmd_1] = STATE(14990),
    [sym__delimiter_cmd_3] = STATE(15013),
    [sym_string_literal] = STATE(6298),
    [sym_command_literal] = STATE(6298),
    [sym_prefixed_string_literal] = STATE(6298),
    [sym_prefixed_command_literal] = STATE(6298),
    [sym_operator] = STATE(19544),
    [sym_block_comment] = STATE(4082),
    [sym_line_comment] = STATE(4082),
    [sym__word_identifier] = ACTIONS(9072),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9075),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9078),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9081),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9084),
    [anon_sym_COLON2] = ACTIONS(9087),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(9090),
    [anon_sym_false] = ACTIONS(9090),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(9093),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4083] = {
    [sym__primary_expression] = STATE(6368),
    [sym__array] = STATE(6381),
    [sym_comprehension_expression] = STATE(6410),
    [sym_matrix_expression] = STATE(6410),
    [sym_vector_expression] = STATE(6410),
    [sym_parenthesized_expression] = STATE(6381),
    [sym_tuple_expression] = STATE(6381),
    [sym_curly_expression] = STATE(6381),
    [sym_adjoint_expression] = STATE(6381),
    [sym_field_expression] = STATE(6381),
    [sym_index_expression] = STATE(6381),
    [sym_parametrized_type_expression] = STATE(6381),
    [sym_call_expression] = STATE(6381),
    [sym_broadcast_call_expression] = STATE(6381),
    [sym__closed_macrocall_expression] = STATE(6381),
    [sym_interpolation_expression] = STATE(6381),
    [sym_quote_expression] = STATE(6381),
    [sym_macro_identifier] = STATE(17306),
    [sym_identifier] = STATE(5580),
    [sym_boolean_literal] = STATE(6381),
    [sym__string] = STATE(6381),
    [sym__delimiter_str_1] = STATE(14382),
    [sym__delimiter_str_3] = STATE(14383),
    [sym__delimiter_cmd_1] = STATE(14385),
    [sym__delimiter_cmd_3] = STATE(14386),
    [sym_string_literal] = STATE(6409),
    [sym_command_literal] = STATE(6409),
    [sym_prefixed_string_literal] = STATE(6409),
    [sym_prefixed_command_literal] = STATE(6409),
    [sym_operator] = STATE(18786),
    [sym_block_comment] = STATE(4083),
    [sym_line_comment] = STATE(4083),
    [sym__word_identifier] = ACTIONS(9096),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9099),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9102),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9105),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9108),
    [anon_sym_COLON2] = ACTIONS(9111),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(9114),
    [anon_sym_false] = ACTIONS(9114),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(9117),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4084] = {
    [sym__primary_expression] = STATE(10491),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10165),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(4084),
    [sym_line_comment] = STATE(4084),
    [sym__word_identifier] = ACTIONS(9120),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9123),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9126),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9129),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9132),
    [anon_sym_COLON2] = ACTIONS(9135),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(8916),
    [anon_sym_true] = ACTIONS(9138),
    [anon_sym_false] = ACTIONS(9138),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(9141),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(8928),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(8934),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4085] = {
    [sym__primary_expression] = STATE(6934),
    [sym__array] = STATE(7034),
    [sym_comprehension_expression] = STATE(6943),
    [sym_matrix_expression] = STATE(6943),
    [sym_vector_expression] = STATE(6943),
    [sym_parenthesized_expression] = STATE(7034),
    [sym_tuple_expression] = STATE(7034),
    [sym_curly_expression] = STATE(7034),
    [sym_adjoint_expression] = STATE(7034),
    [sym_field_expression] = STATE(7034),
    [sym_index_expression] = STATE(7034),
    [sym_parametrized_type_expression] = STATE(7034),
    [sym_call_expression] = STATE(7034),
    [sym_broadcast_call_expression] = STATE(7034),
    [sym__closed_macrocall_expression] = STATE(7034),
    [sym_interpolation_expression] = STATE(7034),
    [sym_quote_expression] = STATE(7034),
    [sym_macro_identifier] = STATE(17115),
    [sym_identifier] = STATE(6334),
    [sym_boolean_literal] = STATE(7034),
    [sym__string] = STATE(7034),
    [sym__delimiter_str_1] = STATE(14487),
    [sym__delimiter_str_3] = STATE(14488),
    [sym__delimiter_cmd_1] = STATE(14489),
    [sym__delimiter_cmd_3] = STATE(14490),
    [sym_string_literal] = STATE(6939),
    [sym_command_literal] = STATE(6939),
    [sym_prefixed_string_literal] = STATE(6939),
    [sym_prefixed_command_literal] = STATE(6939),
    [sym_operator] = STATE(18902),
    [sym_block_comment] = STATE(4085),
    [sym_line_comment] = STATE(4085),
    [sym__word_identifier] = ACTIONS(9144),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9147),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9150),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9153),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9156),
    [anon_sym_COLON2] = ACTIONS(9159),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9030),
    [anon_sym_true] = ACTIONS(9162),
    [anon_sym_false] = ACTIONS(9162),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(9165),
    [anon_sym_DQUOTE] = ACTIONS(8925),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9039),
    [anon_sym_BQUOTE] = ACTIONS(8931),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9042),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(8937),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4086] = {
    [sym__primary_expression] = STATE(5801),
    [sym__array] = STATE(5707),
    [sym_comprehension_expression] = STATE(5908),
    [sym_matrix_expression] = STATE(5908),
    [sym_vector_expression] = STATE(5908),
    [sym_parenthesized_expression] = STATE(5707),
    [sym_tuple_expression] = STATE(5707),
    [sym_curly_expression] = STATE(5707),
    [sym_adjoint_expression] = STATE(5707),
    [sym_field_expression] = STATE(5707),
    [sym_index_expression] = STATE(5707),
    [sym_parametrized_type_expression] = STATE(5707),
    [sym_call_expression] = STATE(5707),
    [sym_broadcast_call_expression] = STATE(5707),
    [sym__closed_macrocall_expression] = STATE(5707),
    [sym_interpolation_expression] = STATE(5707),
    [sym_quote_expression] = STATE(5707),
    [sym_macro_identifier] = STATE(17667),
    [sym_identifier] = STATE(5015),
    [sym_boolean_literal] = STATE(5707),
    [sym__string] = STATE(5707),
    [sym__delimiter_str_1] = STATE(14755),
    [sym__delimiter_str_3] = STATE(14765),
    [sym__delimiter_cmd_1] = STATE(14767),
    [sym__delimiter_cmd_3] = STATE(14806),
    [sym_string_literal] = STATE(5907),
    [sym_command_literal] = STATE(5907),
    [sym_prefixed_string_literal] = STATE(5907),
    [sym_prefixed_command_literal] = STATE(5907),
    [sym_operator] = STATE(19520),
    [sym_block_comment] = STATE(4086),
    [sym_line_comment] = STATE(4086),
    [sym__word_identifier] = ACTIONS(9168),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9173),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9176),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9179),
    [anon_sym_DOLLAR] = ACTIONS(9182),
    [anon_sym_COLON2] = ACTIONS(9185),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9188),
    [anon_sym_true] = ACTIONS(9191),
    [anon_sym_false] = ACTIONS(9191),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9194),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9206),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(9209),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4087] = {
    [sym__primary_expression] = STATE(5697),
    [sym__array] = STATE(5533),
    [sym_comprehension_expression] = STATE(5576),
    [sym_matrix_expression] = STATE(5576),
    [sym_vector_expression] = STATE(5576),
    [sym_parenthesized_expression] = STATE(5533),
    [sym_tuple_expression] = STATE(5533),
    [sym_curly_expression] = STATE(5533),
    [sym_adjoint_expression] = STATE(5533),
    [sym_field_expression] = STATE(5533),
    [sym_index_expression] = STATE(5533),
    [sym_parametrized_type_expression] = STATE(5533),
    [sym_call_expression] = STATE(5533),
    [sym_broadcast_call_expression] = STATE(5533),
    [sym__closed_macrocall_expression] = STATE(5533),
    [sym_interpolation_expression] = STATE(5533),
    [sym_quote_expression] = STATE(5533),
    [sym_macro_identifier] = STATE(17256),
    [sym_identifier] = STATE(4860),
    [sym_boolean_literal] = STATE(5533),
    [sym__string] = STATE(5533),
    [sym__delimiter_str_1] = STATE(14988),
    [sym__delimiter_str_3] = STATE(14989),
    [sym__delimiter_cmd_1] = STATE(14999),
    [sym__delimiter_cmd_3] = STATE(15012),
    [sym_string_literal] = STATE(5575),
    [sym_command_literal] = STATE(5575),
    [sym_prefixed_string_literal] = STATE(5575),
    [sym_prefixed_command_literal] = STATE(5575),
    [sym_operator] = STATE(18688),
    [sym_block_comment] = STATE(4087),
    [sym_line_comment] = STATE(4087),
    [sym__word_identifier] = ACTIONS(9214),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9217),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9220),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9223),
    [anon_sym_DOLLAR] = ACTIONS(9226),
    [anon_sym_COLON2] = ACTIONS(9229),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9188),
    [anon_sym_true] = ACTIONS(9232),
    [anon_sym_false] = ACTIONS(9232),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9235),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9206),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(9209),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4088] = {
    [sym__primary_expression] = STATE(6238),
    [sym__array] = STATE(6207),
    [sym_comprehension_expression] = STATE(6188),
    [sym_matrix_expression] = STATE(6188),
    [sym_vector_expression] = STATE(6188),
    [sym_parenthesized_expression] = STATE(6207),
    [sym_tuple_expression] = STATE(6207),
    [sym_curly_expression] = STATE(6207),
    [sym_adjoint_expression] = STATE(6207),
    [sym_field_expression] = STATE(6207),
    [sym_index_expression] = STATE(6207),
    [sym_parametrized_type_expression] = STATE(6207),
    [sym_call_expression] = STATE(6207),
    [sym_broadcast_call_expression] = STATE(6207),
    [sym__closed_macrocall_expression] = STATE(6207),
    [sym_interpolation_expression] = STATE(6207),
    [sym_quote_expression] = STATE(6207),
    [sym_macro_identifier] = STATE(17104),
    [sym_identifier] = STATE(5340),
    [sym_boolean_literal] = STATE(6207),
    [sym__string] = STATE(6207),
    [sym__delimiter_str_1] = STATE(14407),
    [sym__delimiter_str_3] = STATE(14408),
    [sym__delimiter_cmd_1] = STATE(14409),
    [sym__delimiter_cmd_3] = STATE(14414),
    [sym_string_literal] = STATE(6187),
    [sym_command_literal] = STATE(6187),
    [sym_prefixed_string_literal] = STATE(6187),
    [sym_prefixed_command_literal] = STATE(6187),
    [sym_operator] = STATE(18735),
    [sym_block_comment] = STATE(4088),
    [sym_line_comment] = STATE(4088),
    [sym__word_identifier] = ACTIONS(9238),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9241),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9244),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9247),
    [anon_sym_DOLLAR] = ACTIONS(9250),
    [anon_sym_COLON2] = ACTIONS(9253),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9188),
    [anon_sym_true] = ACTIONS(9256),
    [anon_sym_false] = ACTIONS(9256),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9259),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9206),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(9209),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4089] = {
    [sym__primary_expression] = STATE(6204),
    [sym__array] = STATE(6140),
    [sym_comprehension_expression] = STATE(6299),
    [sym_matrix_expression] = STATE(6299),
    [sym_vector_expression] = STATE(6299),
    [sym_parenthesized_expression] = STATE(6140),
    [sym_tuple_expression] = STATE(6140),
    [sym_curly_expression] = STATE(6140),
    [sym_adjoint_expression] = STATE(6140),
    [sym_field_expression] = STATE(6140),
    [sym_index_expression] = STATE(6140),
    [sym_parametrized_type_expression] = STATE(6140),
    [sym_call_expression] = STATE(6140),
    [sym_broadcast_call_expression] = STATE(6140),
    [sym__closed_macrocall_expression] = STATE(6140),
    [sym_interpolation_expression] = STATE(6140),
    [sym_quote_expression] = STATE(6140),
    [sym_macro_identifier] = STATE(17072),
    [sym_identifier] = STATE(5206),
    [sym_boolean_literal] = STATE(6140),
    [sym__string] = STATE(6140),
    [sym__delimiter_str_1] = STATE(14982),
    [sym__delimiter_str_3] = STATE(14987),
    [sym__delimiter_cmd_1] = STATE(14990),
    [sym__delimiter_cmd_3] = STATE(15013),
    [sym_string_literal] = STATE(6298),
    [sym_command_literal] = STATE(6298),
    [sym_prefixed_string_literal] = STATE(6298),
    [sym_prefixed_command_literal] = STATE(6298),
    [sym_operator] = STATE(19544),
    [sym_block_comment] = STATE(4089),
    [sym_line_comment] = STATE(4089),
    [sym__word_identifier] = ACTIONS(9262),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9265),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9268),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9271),
    [anon_sym_DOLLAR] = ACTIONS(9274),
    [anon_sym_COLON2] = ACTIONS(9277),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9188),
    [anon_sym_true] = ACTIONS(9280),
    [anon_sym_false] = ACTIONS(9280),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9283),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9206),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(9209),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4090] = {
    [sym__primary_expression] = STATE(6132),
    [sym__array] = STATE(6076),
    [sym_comprehension_expression] = STATE(6157),
    [sym_matrix_expression] = STATE(6157),
    [sym_vector_expression] = STATE(6157),
    [sym_parenthesized_expression] = STATE(6076),
    [sym_tuple_expression] = STATE(6076),
    [sym_curly_expression] = STATE(6076),
    [sym_adjoint_expression] = STATE(6076),
    [sym_field_expression] = STATE(6076),
    [sym_index_expression] = STATE(6076),
    [sym_parametrized_type_expression] = STATE(6076),
    [sym_call_expression] = STATE(6076),
    [sym_broadcast_call_expression] = STATE(6076),
    [sym__closed_macrocall_expression] = STATE(6076),
    [sym_interpolation_expression] = STATE(6076),
    [sym_quote_expression] = STATE(6076),
    [sym_macro_identifier] = STATE(17585),
    [sym_identifier] = STATE(5217),
    [sym_boolean_literal] = STATE(6076),
    [sym__string] = STATE(6076),
    [sym__delimiter_str_1] = STATE(14392),
    [sym__delimiter_str_3] = STATE(14393),
    [sym__delimiter_cmd_1] = STATE(14394),
    [sym__delimiter_cmd_3] = STATE(14395),
    [sym_string_literal] = STATE(6156),
    [sym_command_literal] = STATE(6156),
    [sym_prefixed_string_literal] = STATE(6156),
    [sym_prefixed_command_literal] = STATE(6156),
    [sym_operator] = STATE(19401),
    [sym_block_comment] = STATE(4090),
    [sym_line_comment] = STATE(4090),
    [sym__word_identifier] = ACTIONS(9286),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9289),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9292),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9295),
    [anon_sym_DOLLAR] = ACTIONS(9298),
    [anon_sym_COLON2] = ACTIONS(9301),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9188),
    [anon_sym_true] = ACTIONS(9304),
    [anon_sym_false] = ACTIONS(9304),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9307),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9206),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(9209),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4091] = {
    [sym__primary_expression] = STATE(6051),
    [sym__array] = STATE(5959),
    [sym_comprehension_expression] = STATE(6039),
    [sym_matrix_expression] = STATE(6039),
    [sym_vector_expression] = STATE(6039),
    [sym_parenthesized_expression] = STATE(5959),
    [sym_tuple_expression] = STATE(5959),
    [sym_curly_expression] = STATE(5959),
    [sym_adjoint_expression] = STATE(5959),
    [sym_field_expression] = STATE(5959),
    [sym_index_expression] = STATE(5959),
    [sym_parametrized_type_expression] = STATE(5959),
    [sym_call_expression] = STATE(5959),
    [sym_broadcast_call_expression] = STATE(5959),
    [sym__closed_macrocall_expression] = STATE(5959),
    [sym_interpolation_expression] = STATE(5959),
    [sym_quote_expression] = STATE(5959),
    [sym_macro_identifier] = STATE(17448),
    [sym_identifier] = STATE(5051),
    [sym_boolean_literal] = STATE(5959),
    [sym__string] = STATE(5959),
    [sym__delimiter_str_1] = STATE(15069),
    [sym__delimiter_str_3] = STATE(15071),
    [sym__delimiter_cmd_1] = STATE(15072),
    [sym__delimiter_cmd_3] = STATE(15073),
    [sym_string_literal] = STATE(6037),
    [sym_command_literal] = STATE(6037),
    [sym_prefixed_string_literal] = STATE(6037),
    [sym_prefixed_command_literal] = STATE(6037),
    [sym_operator] = STATE(19159),
    [sym_block_comment] = STATE(4091),
    [sym_line_comment] = STATE(4091),
    [sym__word_identifier] = ACTIONS(9310),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9313),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9316),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9319),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9322),
    [anon_sym_COLON2] = ACTIONS(9325),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9328),
    [anon_sym_true] = ACTIONS(9331),
    [anon_sym_false] = ACTIONS(9331),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9334),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9337),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9340),
    [sym__pair_operator] = ACTIONS(9343),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9343),
    [sym__pipe_left_operator] = ACTIONS(9343),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9343),
    [sym__bitshift_operator] = ACTIONS(9343),
    [sym__power_operator] = ACTIONS(9343),
    [sym__tilde_operator] = ACTIONS(9343),
    [sym__type_order_operator] = ACTIONS(9343),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4092] = {
    [sym__primary_expression] = STATE(5950),
    [sym__array] = STATE(6270),
    [sym_comprehension_expression] = STATE(5960),
    [sym_matrix_expression] = STATE(5960),
    [sym_vector_expression] = STATE(5960),
    [sym_parenthesized_expression] = STATE(6270),
    [sym_tuple_expression] = STATE(6270),
    [sym_curly_expression] = STATE(6270),
    [sym_adjoint_expression] = STATE(6270),
    [sym_field_expression] = STATE(6270),
    [sym_index_expression] = STATE(6270),
    [sym_parametrized_type_expression] = STATE(6270),
    [sym_call_expression] = STATE(6270),
    [sym_broadcast_call_expression] = STATE(6270),
    [sym__closed_macrocall_expression] = STATE(6270),
    [sym_interpolation_expression] = STATE(6270),
    [sym_quote_expression] = STATE(6270),
    [sym_macro_identifier] = STATE(17341),
    [sym_identifier] = STATE(5273),
    [sym_boolean_literal] = STATE(6270),
    [sym__string] = STATE(6270),
    [sym__delimiter_str_1] = STATE(14607),
    [sym__delimiter_str_3] = STATE(14609),
    [sym__delimiter_cmd_1] = STATE(14610),
    [sym__delimiter_cmd_3] = STATE(14611),
    [sym_string_literal] = STATE(5958),
    [sym_command_literal] = STATE(5958),
    [sym_prefixed_string_literal] = STATE(5958),
    [sym_prefixed_command_literal] = STATE(5958),
    [sym_operator] = STATE(18896),
    [sym_block_comment] = STATE(4092),
    [sym_line_comment] = STATE(4092),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9346),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9349),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9352),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9355),
    [anon_sym_DOLLAR] = ACTIONS(9358),
    [anon_sym_COLON2] = ACTIONS(9361),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9188),
    [anon_sym_true] = ACTIONS(9364),
    [anon_sym_false] = ACTIONS(9364),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9367),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9206),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(9209),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4093] = {
    [sym__primary_expression] = STATE(6368),
    [sym__array] = STATE(6381),
    [sym_comprehension_expression] = STATE(6410),
    [sym_matrix_expression] = STATE(6410),
    [sym_vector_expression] = STATE(6410),
    [sym_parenthesized_expression] = STATE(6381),
    [sym_tuple_expression] = STATE(6381),
    [sym_curly_expression] = STATE(6381),
    [sym_adjoint_expression] = STATE(6381),
    [sym_field_expression] = STATE(6381),
    [sym_index_expression] = STATE(6381),
    [sym_parametrized_type_expression] = STATE(6381),
    [sym_call_expression] = STATE(6381),
    [sym_broadcast_call_expression] = STATE(6381),
    [sym__closed_macrocall_expression] = STATE(6381),
    [sym_interpolation_expression] = STATE(6381),
    [sym_quote_expression] = STATE(6381),
    [sym_macro_identifier] = STATE(17306),
    [sym_identifier] = STATE(5580),
    [sym_boolean_literal] = STATE(6381),
    [sym__string] = STATE(6381),
    [sym__delimiter_str_1] = STATE(14382),
    [sym__delimiter_str_3] = STATE(14383),
    [sym__delimiter_cmd_1] = STATE(14385),
    [sym__delimiter_cmd_3] = STATE(14386),
    [sym_string_literal] = STATE(6409),
    [sym_command_literal] = STATE(6409),
    [sym_prefixed_string_literal] = STATE(6409),
    [sym_prefixed_command_literal] = STATE(6409),
    [sym_operator] = STATE(18786),
    [sym_block_comment] = STATE(4093),
    [sym_line_comment] = STATE(4093),
    [sym__word_identifier] = ACTIONS(9370),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9373),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9376),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9379),
    [anon_sym_DOLLAR] = ACTIONS(9382),
    [anon_sym_COLON2] = ACTIONS(9385),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9188),
    [anon_sym_true] = ACTIONS(9388),
    [anon_sym_false] = ACTIONS(9388),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9391),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9206),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(9209),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4094] = {
    [sym__primary_expression] = STATE(6934),
    [sym__array] = STATE(7034),
    [sym_comprehension_expression] = STATE(6943),
    [sym_matrix_expression] = STATE(6943),
    [sym_vector_expression] = STATE(6943),
    [sym_parenthesized_expression] = STATE(7034),
    [sym_tuple_expression] = STATE(7034),
    [sym_curly_expression] = STATE(7034),
    [sym_adjoint_expression] = STATE(7034),
    [sym_field_expression] = STATE(7034),
    [sym_index_expression] = STATE(7034),
    [sym_parametrized_type_expression] = STATE(7034),
    [sym_call_expression] = STATE(7034),
    [sym_broadcast_call_expression] = STATE(7034),
    [sym__closed_macrocall_expression] = STATE(7034),
    [sym_interpolation_expression] = STATE(7034),
    [sym_quote_expression] = STATE(7034),
    [sym_macro_identifier] = STATE(17115),
    [sym_identifier] = STATE(6334),
    [sym_boolean_literal] = STATE(7034),
    [sym__string] = STATE(7034),
    [sym__delimiter_str_1] = STATE(14487),
    [sym__delimiter_str_3] = STATE(14488),
    [sym__delimiter_cmd_1] = STATE(14489),
    [sym__delimiter_cmd_3] = STATE(14490),
    [sym_string_literal] = STATE(6939),
    [sym_command_literal] = STATE(6939),
    [sym_prefixed_string_literal] = STATE(6939),
    [sym_prefixed_command_literal] = STATE(6939),
    [sym_operator] = STATE(18902),
    [sym_block_comment] = STATE(4094),
    [sym_line_comment] = STATE(4094),
    [sym__word_identifier] = ACTIONS(9394),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9397),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9400),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9403),
    [anon_sym_DOLLAR] = ACTIONS(9406),
    [anon_sym_COLON2] = ACTIONS(9409),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9328),
    [anon_sym_true] = ACTIONS(9412),
    [anon_sym_false] = ACTIONS(9412),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9415),
    [anon_sym_DQUOTE] = ACTIONS(9197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9337),
    [anon_sym_BQUOTE] = ACTIONS(9203),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9340),
    [sym__pair_operator] = ACTIONS(9343),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9343),
    [sym__pipe_left_operator] = ACTIONS(9343),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9343),
    [sym__bitshift_operator] = ACTIONS(9343),
    [sym__power_operator] = ACTIONS(9343),
    [sym__tilde_operator] = ACTIONS(9343),
    [sym__type_order_operator] = ACTIONS(9343),
    [sym__unary_operator] = ACTIONS(9209),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [4095] = {
    [sym_identifier] = STATE(4126),
    [sym_integer_literal] = STATE(4369),
    [sym_float_literal] = STATE(4369),
    [sym__string] = STATE(4369),
    [sym__delimiter_str_1] = STATE(14791),
    [sym__delimiter_str_3] = STATE(14793),
    [sym__delimiter_cmd_1] = STATE(14798),
    [sym__delimiter_cmd_3] = STATE(14800),
    [sym_string_literal] = STATE(4317),
    [sym_command_literal] = STATE(4317),
    [sym_prefixed_string_literal] = STATE(4317),
    [sym_prefixed_command_literal] = STATE(4317),
    [sym_operator] = STATE(4369),
    [sym__assignment_operator] = STATE(4369),
    [sym__syntactic_operator] = STATE(4369),
    [sym_block_comment] = STATE(4095),
    [sym_line_comment] = STATE(4095),
    [sym__word_identifier] = ACTIONS(9418),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9420),
    [anon_sym_COLON2] = ACTIONS(9422),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(9424),
    [anon_sym_DOT_EQ] = ACTIONS(9424),
    [aux_sym_quote_expression_token1] = ACTIONS(9426),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9420),
    [anon_sym_QMARK] = ACTIONS(9420),
    [anon_sym_DASH_GT] = ACTIONS(9420),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9428),
    [aux_sym_integer_literal_token2] = ACTIONS(9428),
    [aux_sym_integer_literal_token3] = ACTIONS(9428),
    [aux_sym_integer_literal_token4] = ACTIONS(9430),
    [aux_sym_float_literal_token1] = ACTIONS(9432),
    [aux_sym_float_literal_token3] = ACTIONS(9432),
    [aux_sym_float_literal_token4] = ACTIONS(9432),
    [sym_character_literal] = ACTIONS(315),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9424),
    [aux_sym__assignment_operator_token1] = ACTIONS(9424),
    [sym__pair_operator] = ACTIONS(9422),
    [sym__arrow_operator] = ACTIONS(9422),
    [sym__lazy_or_operator] = ACTIONS(9426),
    [sym__lazy_and_operator] = ACTIONS(9426),
    [sym__comparison_operator] = ACTIONS(9422),
    [sym__pipe_right_operator] = ACTIONS(9422),
    [sym__pipe_left_operator] = ACTIONS(9422),
    [sym__ellipsis_operator] = ACTIONS(9422),
    [sym__plus_operator] = ACTIONS(9422),
    [sym__times_operator] = ACTIONS(9422),
    [sym__rational_operator] = ACTIONS(9422),
    [sym__bitshift_operator] = ACTIONS(9422),
    [sym__power_operator] = ACTIONS(9422),
    [sym__tilde_operator] = ACTIONS(9422),
    [sym__type_order_operator] = ACTIONS(9422),
    [sym__unary_operator] = ACTIONS(9422),
    [sym__unary_plus_operator] = ACTIONS(9422),
    [anon_sym_DOT2] = ACTIONS(9420),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9434),
    [sym__immediate_bracket] = ACTIONS(9436),
    [sym__immediate_brace] = ACTIONS(9438),
  },
  [4096] = {
    [sym_identifier] = STATE(4112),
    [sym_integer_literal] = STATE(4506),
    [sym_float_literal] = STATE(4506),
    [sym__string] = STATE(4506),
    [sym__delimiter_str_1] = STATE(14869),
    [sym__delimiter_str_3] = STATE(14870),
    [sym__delimiter_cmd_1] = STATE(14871),
    [sym__delimiter_cmd_3] = STATE(14872),
    [sym_string_literal] = STATE(4291),
    [sym_command_literal] = STATE(4291),
    [sym_prefixed_string_literal] = STATE(4291),
    [sym_prefixed_command_literal] = STATE(4291),
    [sym_operator] = STATE(4506),
    [sym__assignment_operator] = STATE(4506),
    [sym__syntactic_operator] = STATE(4506),
    [sym_block_comment] = STATE(4096),
    [sym_line_comment] = STATE(4096),
    [sym__word_identifier] = ACTIONS(9440),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9442),
    [anon_sym_COLON2] = ACTIONS(9444),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(9446),
    [anon_sym_DOT_EQ] = ACTIONS(9446),
    [aux_sym_quote_expression_token1] = ACTIONS(9448),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9442),
    [anon_sym_QMARK] = ACTIONS(9442),
    [anon_sym_DASH_GT] = ACTIONS(9442),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9450),
    [aux_sym_integer_literal_token2] = ACTIONS(9450),
    [aux_sym_integer_literal_token3] = ACTIONS(9450),
    [aux_sym_integer_literal_token4] = ACTIONS(9452),
    [aux_sym_float_literal_token1] = ACTIONS(9454),
    [aux_sym_float_literal_token3] = ACTIONS(9454),
    [aux_sym_float_literal_token4] = ACTIONS(9454),
    [sym_character_literal] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9446),
    [aux_sym__assignment_operator_token1] = ACTIONS(9446),
    [sym__pair_operator] = ACTIONS(9444),
    [sym__arrow_operator] = ACTIONS(9444),
    [sym__lazy_or_operator] = ACTIONS(9448),
    [sym__lazy_and_operator] = ACTIONS(9448),
    [sym__comparison_operator] = ACTIONS(9444),
    [sym__pipe_right_operator] = ACTIONS(9444),
    [sym__pipe_left_operator] = ACTIONS(9444),
    [sym__ellipsis_operator] = ACTIONS(9444),
    [sym__plus_operator] = ACTIONS(9444),
    [sym__times_operator] = ACTIONS(9444),
    [sym__rational_operator] = ACTIONS(9444),
    [sym__bitshift_operator] = ACTIONS(9444),
    [sym__power_operator] = ACTIONS(9444),
    [sym__tilde_operator] = ACTIONS(9444),
    [sym__type_order_operator] = ACTIONS(9444),
    [sym__unary_operator] = ACTIONS(9444),
    [sym__unary_plus_operator] = ACTIONS(9444),
    [anon_sym_DOT2] = ACTIONS(9442),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9456),
    [sym__immediate_bracket] = ACTIONS(9458),
    [sym__immediate_brace] = ACTIONS(9460),
  },
  [4097] = {
    [sym_identifier] = STATE(4197),
    [sym_integer_literal] = STATE(4564),
    [sym_float_literal] = STATE(4564),
    [sym__string] = STATE(4564),
    [sym__delimiter_str_1] = STATE(14701),
    [sym__delimiter_str_3] = STATE(14899),
    [sym__delimiter_cmd_1] = STATE(14318),
    [sym__delimiter_cmd_3] = STATE(14504),
    [sym_string_literal] = STATE(4665),
    [sym_command_literal] = STATE(4665),
    [sym_prefixed_string_literal] = STATE(4665),
    [sym_prefixed_command_literal] = STATE(4665),
    [sym_operator] = STATE(4564),
    [sym__assignment_operator] = STATE(4564),
    [sym__syntactic_operator] = STATE(4564),
    [sym_block_comment] = STATE(4097),
    [sym_line_comment] = STATE(4097),
    [sym__word_identifier] = ACTIONS(9462),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(9464),
    [anon_sym_COLON2] = ACTIONS(9466),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(9468),
    [anon_sym_DOT_EQ] = ACTIONS(9470),
    [aux_sym_quote_expression_token1] = ACTIONS(9472),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9474),
    [anon_sym_QMARK] = ACTIONS(9474),
    [anon_sym_DASH_GT] = ACTIONS(9474),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9476),
    [aux_sym_integer_literal_token2] = ACTIONS(9476),
    [aux_sym_integer_literal_token3] = ACTIONS(9478),
    [aux_sym_integer_literal_token4] = ACTIONS(9480),
    [aux_sym_float_literal_token1] = ACTIONS(9482),
    [aux_sym_float_literal_token3] = ACTIONS(9482),
    [aux_sym_float_literal_token4] = ACTIONS(9482),
    [sym_character_literal] = ACTIONS(891),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9468),
    [aux_sym__assignment_operator_token1] = ACTIONS(9468),
    [sym__pair_operator] = ACTIONS(9484),
    [sym__arrow_operator] = ACTIONS(9466),
    [sym__lazy_or_operator] = ACTIONS(9486),
    [sym__lazy_and_operator] = ACTIONS(9486),
    [sym__comparison_operator] = ACTIONS(9466),
    [sym__pipe_right_operator] = ACTIONS(9484),
    [sym__pipe_left_operator] = ACTIONS(9484),
    [sym__ellipsis_operator] = ACTIONS(9466),
    [sym__plus_operator] = ACTIONS(9466),
    [sym__times_operator] = ACTIONS(9466),
    [sym__rational_operator] = ACTIONS(9466),
    [sym__bitshift_operator] = ACTIONS(9466),
    [sym__power_operator] = ACTIONS(9466),
    [sym__tilde_operator] = ACTIONS(9484),
    [sym__type_order_operator] = ACTIONS(9484),
    [sym__unary_operator] = ACTIONS(9466),
    [sym__unary_plus_operator] = ACTIONS(9466),
    [anon_sym_DOT2] = ACTIONS(9464),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9488),
    [sym__immediate_bracket] = ACTIONS(9490),
    [sym__immediate_brace] = ACTIONS(9492),
  },
  [4098] = {
    [sym_identifier] = STATE(4157),
    [sym_integer_literal] = STATE(4743),
    [sym_float_literal] = STATE(4743),
    [sym__string] = STATE(4743),
    [sym__delimiter_str_1] = STATE(15043),
    [sym__delimiter_str_3] = STATE(15045),
    [sym__delimiter_cmd_1] = STATE(15046),
    [sym__delimiter_cmd_3] = STATE(15047),
    [sym_string_literal] = STATE(4580),
    [sym_command_literal] = STATE(4580),
    [sym_prefixed_string_literal] = STATE(4580),
    [sym_prefixed_command_literal] = STATE(4580),
    [sym_operator] = STATE(4743),
    [sym__assignment_operator] = STATE(4743),
    [sym__syntactic_operator] = STATE(4743),
    [sym_block_comment] = STATE(4098),
    [sym_line_comment] = STATE(4098),
    [sym__word_identifier] = ACTIONS(9494),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9496),
    [anon_sym_COLON2] = ACTIONS(9498),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(9500),
    [anon_sym_DOT_EQ] = ACTIONS(9500),
    [aux_sym_quote_expression_token1] = ACTIONS(9502),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9496),
    [anon_sym_QMARK] = ACTIONS(9496),
    [anon_sym_DASH_GT] = ACTIONS(9496),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9504),
    [aux_sym_integer_literal_token2] = ACTIONS(9504),
    [aux_sym_integer_literal_token3] = ACTIONS(9504),
    [aux_sym_integer_literal_token4] = ACTIONS(9506),
    [aux_sym_float_literal_token1] = ACTIONS(9508),
    [aux_sym_float_literal_token3] = ACTIONS(9508),
    [aux_sym_float_literal_token4] = ACTIONS(9508),
    [sym_character_literal] = ACTIONS(605),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9500),
    [aux_sym__assignment_operator_token1] = ACTIONS(9500),
    [sym__pair_operator] = ACTIONS(9498),
    [sym__arrow_operator] = ACTIONS(9498),
    [sym__lazy_or_operator] = ACTIONS(9502),
    [sym__lazy_and_operator] = ACTIONS(9502),
    [sym__comparison_operator] = ACTIONS(9498),
    [sym__pipe_right_operator] = ACTIONS(9498),
    [sym__pipe_left_operator] = ACTIONS(9498),
    [sym__ellipsis_operator] = ACTIONS(9498),
    [sym__plus_operator] = ACTIONS(9498),
    [sym__times_operator] = ACTIONS(9498),
    [sym__rational_operator] = ACTIONS(9498),
    [sym__bitshift_operator] = ACTIONS(9498),
    [sym__power_operator] = ACTIONS(9498),
    [sym__tilde_operator] = ACTIONS(9498),
    [sym__type_order_operator] = ACTIONS(9498),
    [sym__unary_operator] = ACTIONS(9498),
    [sym__unary_plus_operator] = ACTIONS(9498),
    [anon_sym_DOT2] = ACTIONS(9496),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9510),
    [sym__immediate_bracket] = ACTIONS(9512),
    [sym__immediate_brace] = ACTIONS(9514),
  },
  [4099] = {
    [sym_identifier] = STATE(4219),
    [sym_integer_literal] = STATE(4720),
    [sym_float_literal] = STATE(4720),
    [sym__string] = STATE(4720),
    [sym__delimiter_str_1] = STATE(14818),
    [sym__delimiter_str_3] = STATE(14828),
    [sym__delimiter_cmd_1] = STATE(14844),
    [sym__delimiter_cmd_3] = STATE(14846),
    [sym_string_literal] = STATE(4741),
    [sym_command_literal] = STATE(4741),
    [sym_prefixed_string_literal] = STATE(4741),
    [sym_prefixed_command_literal] = STATE(4741),
    [sym_operator] = STATE(4720),
    [sym__assignment_operator] = STATE(4720),
    [sym__syntactic_operator] = STATE(4720),
    [sym_block_comment] = STATE(4099),
    [sym_line_comment] = STATE(4099),
    [sym__word_identifier] = ACTIONS(9516),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9518),
    [anon_sym_COLON2] = ACTIONS(9520),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(9522),
    [anon_sym_DOT_EQ] = ACTIONS(9522),
    [aux_sym_quote_expression_token1] = ACTIONS(9524),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9518),
    [anon_sym_QMARK] = ACTIONS(9518),
    [anon_sym_DASH_GT] = ACTIONS(9518),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9526),
    [aux_sym_integer_literal_token2] = ACTIONS(9526),
    [aux_sym_integer_literal_token3] = ACTIONS(9526),
    [aux_sym_integer_literal_token4] = ACTIONS(9528),
    [aux_sym_float_literal_token1] = ACTIONS(9530),
    [aux_sym_float_literal_token3] = ACTIONS(9530),
    [aux_sym_float_literal_token4] = ACTIONS(9530),
    [sym_character_literal] = ACTIONS(783),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9522),
    [aux_sym__assignment_operator_token1] = ACTIONS(9522),
    [sym__pair_operator] = ACTIONS(9520),
    [sym__arrow_operator] = ACTIONS(9520),
    [sym__lazy_or_operator] = ACTIONS(9524),
    [sym__lazy_and_operator] = ACTIONS(9524),
    [sym__comparison_operator] = ACTIONS(9520),
    [sym__pipe_right_operator] = ACTIONS(9520),
    [sym__pipe_left_operator] = ACTIONS(9520),
    [sym__ellipsis_operator] = ACTIONS(9520),
    [sym__plus_operator] = ACTIONS(9520),
    [sym__times_operator] = ACTIONS(9520),
    [sym__rational_operator] = ACTIONS(9520),
    [sym__bitshift_operator] = ACTIONS(9520),
    [sym__power_operator] = ACTIONS(9520),
    [sym__tilde_operator] = ACTIONS(9520),
    [sym__type_order_operator] = ACTIONS(9520),
    [sym__unary_operator] = ACTIONS(9520),
    [sym__unary_plus_operator] = ACTIONS(9520),
    [anon_sym_DOT2] = ACTIONS(9518),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9532),
    [sym__immediate_bracket] = ACTIONS(9534),
    [sym__immediate_brace] = ACTIONS(9536),
  },
  [4100] = {
    [sym_identifier] = STATE(4212),
    [sym_integer_literal] = STATE(4669),
    [sym_float_literal] = STATE(4669),
    [sym__string] = STATE(4669),
    [sym__delimiter_str_1] = STATE(14404),
    [sym__delimiter_str_3] = STATE(14415),
    [sym__delimiter_cmd_1] = STATE(14435),
    [sym__delimiter_cmd_3] = STATE(14436),
    [sym_string_literal] = STATE(4757),
    [sym_command_literal] = STATE(4757),
    [sym_prefixed_string_literal] = STATE(4757),
    [sym_prefixed_command_literal] = STATE(4757),
    [sym_operator] = STATE(4669),
    [sym__assignment_operator] = STATE(4669),
    [sym__syntactic_operator] = STATE(4669),
    [sym_block_comment] = STATE(4100),
    [sym_line_comment] = STATE(4100),
    [sym__word_identifier] = ACTIONS(9538),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9540),
    [anon_sym_COLON2] = ACTIONS(9542),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(9544),
    [anon_sym_DOT_EQ] = ACTIONS(9544),
    [aux_sym_quote_expression_token1] = ACTIONS(9546),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9540),
    [anon_sym_QMARK] = ACTIONS(9540),
    [anon_sym_DASH_GT] = ACTIONS(9540),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9548),
    [aux_sym_integer_literal_token2] = ACTIONS(9548),
    [aux_sym_integer_literal_token3] = ACTIONS(9548),
    [aux_sym_integer_literal_token4] = ACTIONS(9550),
    [aux_sym_float_literal_token1] = ACTIONS(9552),
    [aux_sym_float_literal_token3] = ACTIONS(9552),
    [aux_sym_float_literal_token4] = ACTIONS(9552),
    [sym_character_literal] = ACTIONS(521),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9544),
    [aux_sym__assignment_operator_token1] = ACTIONS(9544),
    [sym__pair_operator] = ACTIONS(9542),
    [sym__arrow_operator] = ACTIONS(9542),
    [sym__lazy_or_operator] = ACTIONS(9546),
    [sym__lazy_and_operator] = ACTIONS(9546),
    [sym__comparison_operator] = ACTIONS(9542),
    [sym__pipe_right_operator] = ACTIONS(9542),
    [sym__pipe_left_operator] = ACTIONS(9542),
    [sym__ellipsis_operator] = ACTIONS(9542),
    [sym__plus_operator] = ACTIONS(9542),
    [sym__times_operator] = ACTIONS(9542),
    [sym__rational_operator] = ACTIONS(9542),
    [sym__bitshift_operator] = ACTIONS(9542),
    [sym__power_operator] = ACTIONS(9542),
    [sym__tilde_operator] = ACTIONS(9542),
    [sym__type_order_operator] = ACTIONS(9542),
    [sym__unary_operator] = ACTIONS(9542),
    [sym__unary_plus_operator] = ACTIONS(9542),
    [anon_sym_DOT2] = ACTIONS(9540),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9554),
    [sym__immediate_bracket] = ACTIONS(9556),
    [sym__immediate_brace] = ACTIONS(9558),
  },
  [4101] = {
    [sym_identifier] = STATE(4143),
    [sym_integer_literal] = STATE(4670),
    [sym_float_literal] = STATE(4670),
    [sym__string] = STATE(4670),
    [sym__delimiter_str_1] = STATE(14410),
    [sym__delimiter_str_3] = STATE(14411),
    [sym__delimiter_cmd_1] = STATE(14412),
    [sym__delimiter_cmd_3] = STATE(14413),
    [sym_string_literal] = STATE(4855),
    [sym_command_literal] = STATE(4855),
    [sym_prefixed_string_literal] = STATE(4855),
    [sym_prefixed_command_literal] = STATE(4855),
    [sym_operator] = STATE(4670),
    [sym__assignment_operator] = STATE(4670),
    [sym__syntactic_operator] = STATE(4670),
    [sym_block_comment] = STATE(4101),
    [sym_line_comment] = STATE(4101),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(9560),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9562),
    [anon_sym_COLON2] = ACTIONS(9564),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(9566),
    [anon_sym_DOT_EQ] = ACTIONS(9566),
    [aux_sym_quote_expression_token1] = ACTIONS(9568),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9562),
    [anon_sym_QMARK] = ACTIONS(9562),
    [anon_sym_DASH_GT] = ACTIONS(9562),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9570),
    [aux_sym_integer_literal_token2] = ACTIONS(9570),
    [aux_sym_integer_literal_token3] = ACTIONS(9570),
    [aux_sym_integer_literal_token4] = ACTIONS(9572),
    [aux_sym_float_literal_token1] = ACTIONS(9574),
    [aux_sym_float_literal_token3] = ACTIONS(9574),
    [aux_sym_float_literal_token4] = ACTIONS(9574),
    [sym_character_literal] = ACTIONS(695),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9566),
    [aux_sym__assignment_operator_token1] = ACTIONS(9566),
    [sym__pair_operator] = ACTIONS(9564),
    [sym__arrow_operator] = ACTIONS(9564),
    [sym__lazy_or_operator] = ACTIONS(9568),
    [sym__lazy_and_operator] = ACTIONS(9568),
    [sym__comparison_operator] = ACTIONS(9564),
    [sym__pipe_right_operator] = ACTIONS(9564),
    [sym__pipe_left_operator] = ACTIONS(9564),
    [sym__ellipsis_operator] = ACTIONS(9564),
    [sym__plus_operator] = ACTIONS(9564),
    [sym__times_operator] = ACTIONS(9564),
    [sym__rational_operator] = ACTIONS(9564),
    [sym__bitshift_operator] = ACTIONS(9564),
    [sym__power_operator] = ACTIONS(9564),
    [sym__tilde_operator] = ACTIONS(9564),
    [sym__type_order_operator] = ACTIONS(9564),
    [sym__unary_operator] = ACTIONS(9564),
    [sym__unary_plus_operator] = ACTIONS(9564),
    [anon_sym_DOT2] = ACTIONS(9562),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9576),
    [sym__immediate_bracket] = ACTIONS(9578),
    [sym__immediate_brace] = ACTIONS(9580),
  },
  [4102] = {
    [sym_identifier] = STATE(4438),
    [sym_integer_literal] = STATE(5017),
    [sym_float_literal] = STATE(5017),
    [sym__string] = STATE(5017),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(5017),
    [sym__assignment_operator] = STATE(5017),
    [sym__syntactic_operator] = STATE(5017),
    [sym_block_comment] = STATE(4102),
    [sym_line_comment] = STATE(4102),
    [sym__word_identifier] = ACTIONS(9582),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9584),
    [anon_sym_COLON2] = ACTIONS(9586),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(9588),
    [anon_sym_DOT_EQ] = ACTIONS(9588),
    [aux_sym_quote_expression_token1] = ACTIONS(9590),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9584),
    [anon_sym_QMARK] = ACTIONS(9584),
    [anon_sym_DASH_GT] = ACTIONS(9584),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9592),
    [aux_sym_integer_literal_token2] = ACTIONS(9592),
    [aux_sym_integer_literal_token3] = ACTIONS(9592),
    [aux_sym_integer_literal_token4] = ACTIONS(9594),
    [aux_sym_float_literal_token1] = ACTIONS(9596),
    [aux_sym_float_literal_token3] = ACTIONS(9596),
    [aux_sym_float_literal_token4] = ACTIONS(9596),
    [sym_character_literal] = ACTIONS(989),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9588),
    [aux_sym__assignment_operator_token1] = ACTIONS(9588),
    [sym__pair_operator] = ACTIONS(9586),
    [sym__arrow_operator] = ACTIONS(9586),
    [sym__lazy_or_operator] = ACTIONS(9590),
    [sym__lazy_and_operator] = ACTIONS(9590),
    [sym__comparison_operator] = ACTIONS(9586),
    [sym__pipe_right_operator] = ACTIONS(9586),
    [sym__pipe_left_operator] = ACTIONS(9586),
    [sym__ellipsis_operator] = ACTIONS(9586),
    [sym__plus_operator] = ACTIONS(9586),
    [sym__times_operator] = ACTIONS(9586),
    [sym__rational_operator] = ACTIONS(9586),
    [sym__bitshift_operator] = ACTIONS(9586),
    [sym__power_operator] = ACTIONS(9586),
    [sym__tilde_operator] = ACTIONS(9586),
    [sym__type_order_operator] = ACTIONS(9586),
    [sym__unary_operator] = ACTIONS(9586),
    [sym__unary_plus_operator] = ACTIONS(9586),
    [anon_sym_DOT2] = ACTIONS(9584),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9598),
    [sym__immediate_bracket] = ACTIONS(9600),
    [sym__immediate_brace] = ACTIONS(9602),
  },
  [4103] = {
    [sym_identifier] = STATE(4932),
    [sym_integer_literal] = STATE(5859),
    [sym_float_literal] = STATE(5859),
    [sym__string] = STATE(5859),
    [sym__delimiter_str_1] = STATE(14900),
    [sym__delimiter_str_3] = STATE(14902),
    [sym__delimiter_cmd_1] = STATE(14903),
    [sym__delimiter_cmd_3] = STATE(14904),
    [sym_string_literal] = STATE(5408),
    [sym_command_literal] = STATE(5408),
    [sym_prefixed_string_literal] = STATE(5408),
    [sym_prefixed_command_literal] = STATE(5408),
    [sym_operator] = STATE(5859),
    [sym__assignment_operator] = STATE(5859),
    [sym__syntactic_operator] = STATE(5859),
    [sym_block_comment] = STATE(4103),
    [sym_line_comment] = STATE(4103),
    [sym__word_identifier] = ACTIONS(9604),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(9606),
    [anon_sym_COLON2] = ACTIONS(9608),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(9610),
    [anon_sym_DOT_EQ] = ACTIONS(9612),
    [aux_sym_quote_expression_token1] = ACTIONS(9614),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9616),
    [anon_sym_QMARK] = ACTIONS(9616),
    [anon_sym_DASH_GT] = ACTIONS(9616),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(9618),
    [aux_sym_integer_literal_token2] = ACTIONS(9618),
    [aux_sym_integer_literal_token3] = ACTIONS(9620),
    [aux_sym_integer_literal_token4] = ACTIONS(9622),
    [aux_sym_float_literal_token1] = ACTIONS(9624),
    [aux_sym_float_literal_token3] = ACTIONS(9624),
    [aux_sym_float_literal_token4] = ACTIONS(9624),
    [sym_character_literal] = ACTIONS(1313),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9610),
    [aux_sym__assignment_operator_token1] = ACTIONS(9610),
    [sym__pair_operator] = ACTIONS(9626),
    [sym__arrow_operator] = ACTIONS(9608),
    [sym__lazy_or_operator] = ACTIONS(9628),
    [sym__lazy_and_operator] = ACTIONS(9628),
    [sym__comparison_operator] = ACTIONS(9608),
    [sym__pipe_right_operator] = ACTIONS(9626),
    [sym__pipe_left_operator] = ACTIONS(9626),
    [sym__ellipsis_operator] = ACTIONS(9608),
    [sym__plus_operator] = ACTIONS(9608),
    [sym__times_operator] = ACTIONS(9608),
    [sym__rational_operator] = ACTIONS(9608),
    [sym__bitshift_operator] = ACTIONS(9608),
    [sym__power_operator] = ACTIONS(9608),
    [sym__tilde_operator] = ACTIONS(9626),
    [sym__type_order_operator] = ACTIONS(9626),
    [sym__unary_operator] = ACTIONS(9608),
    [sym__unary_plus_operator] = ACTIONS(9608),
    [anon_sym_DOT2] = ACTIONS(9606),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9630),
    [sym__immediate_bracket] = ACTIONS(9632),
    [sym__immediate_brace] = ACTIONS(9634),
  },
  [4104] = {
    [sym_block_comment] = STATE(4104),
    [sym_line_comment] = STATE(4104),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9636),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9638),
    [sym__immediate_command_start] = ACTIONS(9640),
  },
  [4105] = {
    [sym_block_comment] = STATE(4105),
    [sym_line_comment] = STATE(4105),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4106] = {
    [sym_block_comment] = STATE(4106),
    [sym_line_comment] = STATE(4106),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4107] = {
    [sym_block_comment] = STATE(4107),
    [sym_line_comment] = STATE(4107),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9646),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9638),
    [sym__immediate_command_start] = ACTIONS(9640),
  },
  [4108] = {
    [sym_block_comment] = STATE(4108),
    [sym_line_comment] = STATE(4108),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9648),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9650),
    [sym__immediate_command_start] = ACTIONS(9652),
  },
  [4109] = {
    [sym_block_comment] = STATE(4109),
    [sym_line_comment] = STATE(4109),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9654),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9650),
    [sym__immediate_command_start] = ACTIONS(9652),
  },
  [4110] = {
    [sym_block_comment] = STATE(4110),
    [sym_line_comment] = STATE(4110),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9656),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9658),
    [sym__immediate_command_start] = ACTIONS(9660),
  },
  [4111] = {
    [sym_block_comment] = STATE(4111),
    [sym_line_comment] = STATE(4111),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4112] = {
    [sym_block_comment] = STATE(4112),
    [sym_line_comment] = STATE(4112),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9650),
    [sym__immediate_command_start] = ACTIONS(9652),
  },
  [4113] = {
    [sym_block_comment] = STATE(4113),
    [sym_line_comment] = STATE(4113),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9666),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9650),
    [sym__immediate_command_start] = ACTIONS(9652),
  },
  [4114] = {
    [sym_block_comment] = STATE(4114),
    [sym_line_comment] = STATE(4114),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9668),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9670),
    [sym__immediate_command_start] = ACTIONS(9672),
  },
  [4115] = {
    [sym_block_comment] = STATE(4115),
    [sym_line_comment] = STATE(4115),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9674),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9676),
    [sym__immediate_command_start] = ACTIONS(9678),
  },
  [4116] = {
    [sym_block_comment] = STATE(4116),
    [sym_line_comment] = STATE(4116),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4117] = {
    [sym_block_comment] = STATE(4117),
    [sym_line_comment] = STATE(4117),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4118] = {
    [sym_do_clause] = STATE(4425),
    [sym_block_comment] = STATE(4118),
    [sym_line_comment] = STATE(4118),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_else] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9682),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_COLON_EQ] = ACTIONS(9680),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9680),
    [aux_sym__assignment_operator_token1] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4119] = {
    [sym_block_comment] = STATE(4119),
    [sym_line_comment] = STATE(4119),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9686),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9658),
    [sym__immediate_command_start] = ACTIONS(9660),
  },
  [4120] = {
    [sym_block_comment] = STATE(4120),
    [sym_line_comment] = STATE(4120),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9688),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9690),
    [sym__immediate_command_start] = ACTIONS(9692),
  },
  [4121] = {
    [sym_block_comment] = STATE(4121),
    [sym_line_comment] = STATE(4121),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9694),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9670),
    [sym__immediate_command_start] = ACTIONS(9672),
  },
  [4122] = {
    [sym_block_comment] = STATE(4122),
    [sym_line_comment] = STATE(4122),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_COLON_EQ] = ACTIONS(9644),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_DASH_GT] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9644),
    [aux_sym__assignment_operator_token1] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4123] = {
    [sym_do_clause] = STATE(4501),
    [sym_block_comment] = STATE(4123),
    [sym_line_comment] = STATE(4123),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_elseif] = ACTIONS(9696),
    [anon_sym_else] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9698),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_COLON_EQ] = ACTIONS(9696),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9696),
    [aux_sym__assignment_operator_token1] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4124] = {
    [sym_do_clause] = STATE(4512),
    [sym_block_comment] = STATE(4124),
    [sym_line_comment] = STATE(4124),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_elseif] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9698),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4125] = {
    [sym_block_comment] = STATE(4125),
    [sym_line_comment] = STATE(4125),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9638),
    [sym__immediate_command_start] = ACTIONS(9640),
  },
  [4126] = {
    [sym_block_comment] = STATE(4126),
    [sym_line_comment] = STATE(4126),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9638),
    [sym__immediate_command_start] = ACTIONS(9640),
  },
  [4127] = {
    [sym_block_comment] = STATE(4127),
    [sym_line_comment] = STATE(4127),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_elseif] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9650),
    [sym__immediate_command_start] = ACTIONS(9652),
  },
  [4128] = {
    [sym_block_comment] = STATE(4128),
    [sym_line_comment] = STATE(4128),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4129] = {
    [sym_do_clause] = STATE(4492),
    [sym_block_comment] = STATE(4129),
    [sym_line_comment] = STATE(4129),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_elseif] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9698),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4130] = {
    [sym_do_clause] = STATE(4430),
    [sym_block_comment] = STATE(4130),
    [sym_line_comment] = STATE(4130),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9682),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4131] = {
    [sym_block_comment] = STATE(4131),
    [sym_line_comment] = STATE(4131),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9638),
    [sym__immediate_command_start] = ACTIONS(9640),
  },
  [4132] = {
    [sym_block_comment] = STATE(4132),
    [sym_line_comment] = STATE(4132),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4133] = {
    [sym_do_clause] = STATE(4446),
    [sym_block_comment] = STATE(4133),
    [sym_line_comment] = STATE(4133),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_else] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9682),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_COLON_EQ] = ACTIONS(9696),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9696),
    [aux_sym__assignment_operator_token1] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4134] = {
    [sym_block_comment] = STATE(4134),
    [sym_line_comment] = STATE(4134),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9718),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9690),
    [sym__immediate_command_start] = ACTIONS(9692),
  },
  [4135] = {
    [sym_block_comment] = STATE(4135),
    [sym_line_comment] = STATE(4135),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9720),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9676),
    [sym__immediate_command_start] = ACTIONS(9678),
  },
  [4136] = {
    [sym_do_clause] = STATE(4465),
    [sym_block_comment] = STATE(4136),
    [sym_line_comment] = STATE(4136),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9682),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4137] = {
    [sym_block_comment] = STATE(4137),
    [sym_line_comment] = STATE(4137),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9722),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9650),
    [sym__immediate_command_start] = ACTIONS(9652),
  },
  [4138] = {
    [sym_block_comment] = STATE(4138),
    [sym_line_comment] = STATE(4138),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9650),
    [sym__immediate_command_start] = ACTIONS(9652),
  },
  [4139] = {
    [sym_block_comment] = STATE(4139),
    [sym_line_comment] = STATE(4139),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4140] = {
    [sym_do_clause] = STATE(4490),
    [sym_block_comment] = STATE(4140),
    [sym_line_comment] = STATE(4140),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_elseif] = ACTIONS(9680),
    [anon_sym_else] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9698),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_COLON_EQ] = ACTIONS(9680),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9680),
    [aux_sym__assignment_operator_token1] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4141] = {
    [sym_block_comment] = STATE(4141),
    [sym_line_comment] = STATE(4141),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9690),
    [sym__immediate_command_start] = ACTIONS(9692),
  },
  [4142] = {
    [sym_block_comment] = STATE(4142),
    [sym_line_comment] = STATE(4142),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_elseif] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4143] = {
    [sym_block_comment] = STATE(4143),
    [sym_line_comment] = STATE(4143),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9658),
    [sym__immediate_command_start] = ACTIONS(9660),
  },
  [4144] = {
    [sym_block_comment] = STATE(4144),
    [sym_line_comment] = STATE(4144),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(9732),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4145] = {
    [sym_block_comment] = STATE(4145),
    [sym_line_comment] = STATE(4145),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_elseif] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4146] = {
    [sym_block_comment] = STATE(4146),
    [sym_line_comment] = STATE(4146),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_elseif] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4147] = {
    [sym_block_comment] = STATE(4147),
    [sym_line_comment] = STATE(4147),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_elseif] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4148] = {
    [sym_do_clause] = STATE(4715),
    [sym_block_comment] = STATE(4148),
    [sym_line_comment] = STATE(4148),
    [ts_builtin_sym_end] = ACTIONS(9684),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_RBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9748),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_COLON_EQ] = ACTIONS(9680),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9680),
    [aux_sym__assignment_operator_token1] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4149] = {
    [sym_block_comment] = STATE(4149),
    [sym_line_comment] = STATE(4149),
    [ts_builtin_sym_end] = ACTIONS(9708),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_RBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9658),
    [sym__immediate_command_start] = ACTIONS(9660),
  },
  [4150] = {
    [sym_do_clause] = STATE(4725),
    [sym_block_comment] = STATE(4150),
    [sym_line_comment] = STATE(4150),
    [ts_builtin_sym_end] = ACTIONS(9712),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_RBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9748),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4151] = {
    [sym_block_comment] = STATE(4151),
    [sym_line_comment] = STATE(4151),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_elseif] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4152] = {
    [sym_block_comment] = STATE(4152),
    [sym_line_comment] = STATE(4152),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_else] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_COLON_EQ] = ACTIONS(9726),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9726),
    [aux_sym__assignment_operator_token1] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4153] = {
    [sym_block_comment] = STATE(4153),
    [sym_line_comment] = STATE(4153),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_else] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_COLON_EQ] = ACTIONS(9744),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9744),
    [aux_sym__assignment_operator_token1] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4154] = {
    [sym_block_comment] = STATE(4154),
    [sym_line_comment] = STATE(4154),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_elseif] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4155] = {
    [sym_do_clause] = STATE(4816),
    [sym_block_comment] = STATE(4155),
    [sym_line_comment] = STATE(4155),
    [ts_builtin_sym_end] = ACTIONS(9700),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_RBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9748),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_COLON_EQ] = ACTIONS(9696),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9696),
    [aux_sym__assignment_operator_token1] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4156] = {
    [sym__assignment_operator] = STATE(3457),
    [sym_block_comment] = STATE(4156),
    [sym_line_comment] = STATE(4156),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9764),
    [anon_sym_DOT] = ACTIONS(9766),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
    [sym__immediate_bracket] = ACTIONS(9772),
    [sym__immediate_brace] = ACTIONS(9774),
  },
  [4157] = {
    [sym_block_comment] = STATE(4157),
    [sym_line_comment] = STATE(4157),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9676),
    [sym__immediate_command_start] = ACTIONS(9678),
  },
  [4158] = {
    [sym_block_comment] = STATE(4158),
    [sym_line_comment] = STATE(4158),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_COLON_EQ] = ACTIONS(9716),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9716),
    [aux_sym__assignment_operator_token1] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9776),
    [sym__immediate_command_start] = ACTIONS(9778),
  },
  [4159] = {
    [sym_identifier] = STATE(4507),
    [sym_block_comment] = STATE(4159),
    [sym_line_comment] = STATE(4159),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_elseif] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_COLON_EQ] = ACTIONS(9780),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9780),
    [aux_sym__assignment_operator_token1] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4160] = {
    [sym_identifier] = STATE(4508),
    [sym_block_comment] = STATE(4160),
    [sym_line_comment] = STATE(4160),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_elseif] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_COLON_EQ] = ACTIONS(9784),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9784),
    [aux_sym__assignment_operator_token1] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4161] = {
    [sym_block_comment] = STATE(4161),
    [sym_line_comment] = STATE(4161),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_elseif] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4162] = {
    [sym_do_clause] = STATE(4532),
    [sym_block_comment] = STATE(4162),
    [sym_line_comment] = STATE(4162),
    [ts_builtin_sym_end] = ACTIONS(9704),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_RBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9748),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4163] = {
    [sym_do_clause] = STATE(4556),
    [sym_block_comment] = STATE(4163),
    [sym_line_comment] = STATE(4163),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_catch] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9794),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_COLON_EQ] = ACTIONS(9680),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9680),
    [aux_sym__assignment_operator_token1] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4164] = {
    [sym_identifier] = STATE(4513),
    [sym_block_comment] = STATE(4164),
    [sym_line_comment] = STATE(4164),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_elseif] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_COLON_EQ] = ACTIONS(9796),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9796),
    [aux_sym__assignment_operator_token1] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4165] = {
    [sym_identifier] = STATE(4514),
    [sym_block_comment] = STATE(4165),
    [sym_line_comment] = STATE(4165),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_elseif] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_COLON_EQ] = ACTIONS(9800),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9800),
    [aux_sym__assignment_operator_token1] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4166] = {
    [sym_block_comment] = STATE(4166),
    [sym_line_comment] = STATE(4166),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9676),
    [sym__immediate_command_start] = ACTIONS(9678),
  },
  [4167] = {
    [sym_do_clause] = STATE(4558),
    [sym_block_comment] = STATE(4167),
    [sym_line_comment] = STATE(4167),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9794),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4168] = {
    [sym_block_comment] = STATE(4168),
    [sym_line_comment] = STATE(4168),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(9804),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9776),
    [sym__immediate_command_start] = ACTIONS(9778),
  },
  [4169] = {
    [sym_do_clause] = STATE(4563),
    [sym_block_comment] = STATE(4169),
    [sym_line_comment] = STATE(4169),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_catch] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9794),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_COLON_EQ] = ACTIONS(9696),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9696),
    [aux_sym__assignment_operator_token1] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4170] = {
    [sym_do_clause] = STATE(4569),
    [sym_block_comment] = STATE(4170),
    [sym_line_comment] = STATE(4170),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9794),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4171] = {
    [sym_block_comment] = STATE(4171),
    [sym_line_comment] = STATE(4171),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_elseif] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_COLON_EQ] = ACTIONS(9738),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9738),
    [aux_sym__assignment_operator_token1] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4172] = {
    [sym_block_comment] = STATE(4172),
    [sym_line_comment] = STATE(4172),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_COLON_EQ] = ACTIONS(9738),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9738),
    [aux_sym__assignment_operator_token1] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4173] = {
    [sym_block_comment] = STATE(4173),
    [sym_line_comment] = STATE(4173),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_elseif] = ACTIONS(9752),
    [anon_sym_else] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_COLON_EQ] = ACTIONS(9752),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9752),
    [aux_sym__assignment_operator_token1] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4174] = {
    [sym_block_comment] = STATE(4174),
    [sym_line_comment] = STATE(4174),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_elseif] = ACTIONS(9810),
    [anon_sym_else] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_COLON_EQ] = ACTIONS(9810),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9810),
    [aux_sym__assignment_operator_token1] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4175] = {
    [sym_block_comment] = STATE(4175),
    [sym_line_comment] = STATE(4175),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_elseif] = ACTIONS(9814),
    [anon_sym_else] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_COLON_EQ] = ACTIONS(9814),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9814),
    [aux_sym__assignment_operator_token1] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4176] = {
    [sym_block_comment] = STATE(4176),
    [sym_line_comment] = STATE(4176),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_else] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_COLON_EQ] = ACTIONS(9752),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9752),
    [aux_sym__assignment_operator_token1] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4177] = {
    [sym_block_comment] = STATE(4177),
    [sym_line_comment] = STATE(4177),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_else] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_COLON_EQ] = ACTIONS(9810),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9810),
    [aux_sym__assignment_operator_token1] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4178] = {
    [sym_block_comment] = STATE(4178),
    [sym_line_comment] = STATE(4178),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_else] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_COLON_EQ] = ACTIONS(9814),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9814),
    [aux_sym__assignment_operator_token1] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4179] = {
    [sym_block_comment] = STATE(4179),
    [sym_line_comment] = STATE(4179),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_else] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_COLON_EQ] = ACTIONS(9818),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9818),
    [aux_sym__assignment_operator_token1] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4180] = {
    [sym_block_comment] = STATE(4180),
    [sym_line_comment] = STATE(4180),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_else] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_COLON_EQ] = ACTIONS(9790),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9790),
    [aux_sym__assignment_operator_token1] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4181] = {
    [sym_block_comment] = STATE(4181),
    [sym_line_comment] = STATE(4181),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_else] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_COLON_EQ] = ACTIONS(9824),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9824),
    [aux_sym__assignment_operator_token1] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4182] = {
    [sym_block_comment] = STATE(4182),
    [sym_line_comment] = STATE(4182),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_else] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_COLON_EQ] = ACTIONS(9828),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9828),
    [aux_sym__assignment_operator_token1] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4183] = {
    [sym_block_comment] = STATE(4183),
    [sym_line_comment] = STATE(4183),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_else] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_COLON_EQ] = ACTIONS(9832),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9832),
    [aux_sym__assignment_operator_token1] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4184] = {
    [sym_block_comment] = STATE(4184),
    [sym_line_comment] = STATE(4184),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_else] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_COLON_EQ] = ACTIONS(9836),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9836),
    [aux_sym__assignment_operator_token1] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4185] = {
    [sym_block_comment] = STATE(4185),
    [sym_line_comment] = STATE(4185),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_elseif] = ACTIONS(9818),
    [anon_sym_else] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_COLON_EQ] = ACTIONS(9818),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9818),
    [aux_sym__assignment_operator_token1] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4186] = {
    [sym_block_comment] = STATE(4186),
    [sym_line_comment] = STATE(4186),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_elseif] = ACTIONS(9790),
    [anon_sym_else] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_COLON_EQ] = ACTIONS(9790),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9790),
    [aux_sym__assignment_operator_token1] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4187] = {
    [sym_block_comment] = STATE(4187),
    [sym_line_comment] = STATE(4187),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_elseif] = ACTIONS(9824),
    [anon_sym_else] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_COLON_EQ] = ACTIONS(9824),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9824),
    [aux_sym__assignment_operator_token1] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4188] = {
    [sym_block_comment] = STATE(4188),
    [sym_line_comment] = STATE(4188),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_elseif] = ACTIONS(9828),
    [anon_sym_else] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_COLON_EQ] = ACTIONS(9828),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9828),
    [aux_sym__assignment_operator_token1] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4189] = {
    [sym_block_comment] = STATE(4189),
    [sym_line_comment] = STATE(4189),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_elseif] = ACTIONS(9832),
    [anon_sym_else] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_COLON_EQ] = ACTIONS(9832),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9832),
    [aux_sym__assignment_operator_token1] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4190] = {
    [sym__assignment_operator] = STATE(3015),
    [sym_block_comment] = STATE(4190),
    [sym_line_comment] = STATE(4190),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9764),
    [anon_sym_DOT] = ACTIONS(9842),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
    [sym__immediate_bracket] = ACTIONS(9772),
    [sym__immediate_brace] = ACTIONS(9774),
  },
  [4191] = {
    [sym_block_comment] = STATE(4191),
    [sym_line_comment] = STATE(4191),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_elseif] = ACTIONS(9836),
    [anon_sym_else] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_COLON_EQ] = ACTIONS(9836),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9836),
    [aux_sym__assignment_operator_token1] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4192] = {
    [sym__assignment_operator] = STATE(3271),
    [sym_block_comment] = STATE(4192),
    [sym_line_comment] = STATE(4192),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9846),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4193] = {
    [sym_block_comment] = STATE(4193),
    [sym_line_comment] = STATE(4193),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_elseif] = ACTIONS(9744),
    [anon_sym_else] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_COLON_EQ] = ACTIONS(9744),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9744),
    [aux_sym__assignment_operator_token1] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4194] = {
    [sym__assignment_operator] = STATE(3792),
    [sym_block_comment] = STATE(4194),
    [sym_line_comment] = STATE(4194),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9856),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4195] = {
    [sym_block_comment] = STATE(4195),
    [sym_line_comment] = STATE(4195),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9658),
    [sym__immediate_command_start] = ACTIONS(9660),
  },
  [4196] = {
    [sym__assignment_operator] = STATE(3271),
    [sym_block_comment] = STATE(4196),
    [sym_line_comment] = STATE(4196),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9846),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4197] = {
    [sym_block_comment] = STATE(4197),
    [sym_line_comment] = STATE(4197),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_COLON_EQ] = ACTIONS(9664),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9664),
    [aux_sym__assignment_operator_token1] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9776),
    [sym__immediate_command_start] = ACTIONS(9778),
  },
  [4198] = {
    [sym_block_comment] = STATE(4198),
    [sym_line_comment] = STATE(4198),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(9858),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9776),
    [sym__immediate_command_start] = ACTIONS(9778),
  },
  [4199] = {
    [sym__assignment_operator] = STATE(3015),
    [sym_block_comment] = STATE(4199),
    [sym_line_comment] = STATE(4199),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9860),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9764),
    [anon_sym_DOT] = ACTIONS(9842),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
    [sym__immediate_bracket] = ACTIONS(9772),
    [sym__immediate_brace] = ACTIONS(9774),
  },
  [4200] = {
    [sym__assignment_operator] = STATE(3271),
    [sym_block_comment] = STATE(4200),
    [sym_line_comment] = STATE(4200),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9846),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4201] = {
    [sym_do_clause] = STATE(4629),
    [sym_block_comment] = STATE(4201),
    [sym_line_comment] = STATE(4201),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9862),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_COLON_EQ] = ACTIONS(9680),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9680),
    [aux_sym__assignment_operator_token1] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4202] = {
    [sym_block_comment] = STATE(4202),
    [sym_line_comment] = STATE(4202),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9670),
    [sym__immediate_command_start] = ACTIONS(9672),
  },
  [4203] = {
    [sym_do_clause] = STATE(4631),
    [sym_block_comment] = STATE(4203),
    [sym_line_comment] = STATE(4203),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9862),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4204] = {
    [sym_do_clause] = STATE(4633),
    [sym_block_comment] = STATE(4204),
    [sym_line_comment] = STATE(4204),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9862),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_COLON_EQ] = ACTIONS(9696),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9696),
    [aux_sym__assignment_operator_token1] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4205] = {
    [sym_do_clause] = STATE(4637),
    [sym_block_comment] = STATE(4205),
    [sym_line_comment] = STATE(4205),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9862),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4206] = {
    [sym_do_clause] = STATE(4657),
    [sym_block_comment] = STATE(4206),
    [sym_line_comment] = STATE(4206),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9684),
    [anon_sym_RPAREN] = ACTIONS(9684),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9684),
    [anon_sym_RBRACK] = ACTIONS(9684),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_SEMI] = ACTIONS(9684),
    [anon_sym_LBRACE] = ACTIONS(9684),
    [anon_sym_RBRACE] = ACTIONS(9684),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9864),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9684),
    [anon_sym_COLON_EQ] = ACTIONS(9684),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9684),
    [anon_sym_QMARK] = ACTIONS(9684),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9684),
    [aux_sym_integer_literal_token2] = ACTIONS(9684),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9684),
    [aux_sym_float_literal_token3] = ACTIONS(9684),
    [aux_sym_float_literal_token4] = ACTIONS(9684),
    [sym_character_literal] = ACTIONS(9684),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9684),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9684),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9684),
    [aux_sym__assignment_operator_token1] = ACTIONS(9684),
    [sym__pair_operator] = ACTIONS(9684),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9684),
    [sym__lazy_and_operator] = ACTIONS(9684),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9684),
    [sym__pipe_left_operator] = ACTIONS(9684),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9684),
    [sym__type_order_operator] = ACTIONS(9684),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4207] = {
    [sym_block_comment] = STATE(4207),
    [sym_line_comment] = STATE(4207),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_RBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_SEMI] = ACTIONS(9708),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_COLON_EQ] = ACTIONS(9708),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9708),
    [aux_sym__assignment_operator_token1] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9776),
    [sym__immediate_command_start] = ACTIONS(9778),
  },
  [4208] = {
    [sym_do_clause] = STATE(4658),
    [sym_block_comment] = STATE(4208),
    [sym_line_comment] = STATE(4208),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_RBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_SEMI] = ACTIONS(9712),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9864),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_COLON_EQ] = ACTIONS(9712),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9712),
    [aux_sym__assignment_operator_token1] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4209] = {
    [sym_do_clause] = STATE(4660),
    [sym_block_comment] = STATE(4209),
    [sym_line_comment] = STATE(4209),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9700),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9700),
    [anon_sym_RPAREN] = ACTIONS(9700),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9700),
    [anon_sym_RBRACK] = ACTIONS(9700),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_SEMI] = ACTIONS(9700),
    [anon_sym_LBRACE] = ACTIONS(9700),
    [anon_sym_RBRACE] = ACTIONS(9700),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9864),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9700),
    [anon_sym_COLON_EQ] = ACTIONS(9700),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9700),
    [anon_sym_QMARK] = ACTIONS(9700),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9700),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9700),
    [aux_sym_integer_literal_token2] = ACTIONS(9700),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9700),
    [aux_sym_float_literal_token3] = ACTIONS(9700),
    [aux_sym_float_literal_token4] = ACTIONS(9700),
    [sym_character_literal] = ACTIONS(9700),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9700),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9700),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9700),
    [aux_sym__assignment_operator_token1] = ACTIONS(9700),
    [sym__pair_operator] = ACTIONS(9700),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9700),
    [sym__lazy_and_operator] = ACTIONS(9700),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9700),
    [sym__pipe_left_operator] = ACTIONS(9700),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9700),
    [sym__type_order_operator] = ACTIONS(9700),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4210] = {
    [sym_do_clause] = STATE(4663),
    [sym_block_comment] = STATE(4210),
    [sym_line_comment] = STATE(4210),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_RBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_SEMI] = ACTIONS(9704),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_RBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9864),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_COLON_EQ] = ACTIONS(9704),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9704),
    [aux_sym__assignment_operator_token1] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4211] = {
    [sym__assignment_operator] = STATE(3457),
    [sym_block_comment] = STATE(4211),
    [sym_line_comment] = STATE(4211),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9764),
    [anon_sym_DOT] = ACTIONS(9766),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
    [sym__immediate_bracket] = ACTIONS(9772),
    [sym__immediate_brace] = ACTIONS(9774),
  },
  [4212] = {
    [sym_block_comment] = STATE(4212),
    [sym_line_comment] = STATE(4212),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9670),
    [sym__immediate_command_start] = ACTIONS(9672),
  },
  [4213] = {
    [sym_block_comment] = STATE(4213),
    [sym_line_comment] = STATE(4213),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9866),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4214] = {
    [sym__assignment_operator] = STATE(3457),
    [sym_block_comment] = STATE(4214),
    [sym_line_comment] = STATE(4214),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9764),
    [anon_sym_DOT] = ACTIONS(9766),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
    [sym__immediate_bracket] = ACTIONS(9772),
    [sym__immediate_brace] = ACTIONS(9774),
  },
  [4215] = {
    [sym_block_comment] = STATE(4215),
    [sym_line_comment] = STATE(4215),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4216] = {
    [sym_block_comment] = STATE(4216),
    [sym_line_comment] = STATE(4216),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4217] = {
    [sym_block_comment] = STATE(4217),
    [sym_line_comment] = STATE(4217),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4218] = {
    [sym_block_comment] = STATE(4218),
    [sym_line_comment] = STATE(4218),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4219] = {
    [sym_block_comment] = STATE(4219),
    [sym_line_comment] = STATE(4219),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9690),
    [sym__immediate_command_start] = ACTIONS(9692),
  },
  [4220] = {
    [sym_block_comment] = STATE(4220),
    [sym_line_comment] = STATE(4220),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9676),
    [sym__immediate_command_start] = ACTIONS(9678),
  },
  [4221] = {
    [sym_block_comment] = STATE(4221),
    [sym_line_comment] = STATE(4221),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4222] = {
    [sym_block_comment] = STATE(4222),
    [sym_line_comment] = STATE(4222),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4223] = {
    [sym_do_clause] = STATE(4749),
    [sym_block_comment] = STATE(4223),
    [sym_line_comment] = STATE(4223),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_catch] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9872),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_COLON_EQ] = ACTIONS(9680),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9680),
    [aux_sym__assignment_operator_token1] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4224] = {
    [sym_block_comment] = STATE(4224),
    [sym_line_comment] = STATE(4224),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9690),
    [sym__immediate_command_start] = ACTIONS(9692),
  },
  [4225] = {
    [sym_do_clause] = STATE(4779),
    [sym_block_comment] = STATE(4225),
    [sym_line_comment] = STATE(4225),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9872),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4226] = {
    [sym_block_comment] = STATE(4226),
    [sym_line_comment] = STATE(4226),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4227] = {
    [sym__assignment_operator] = STATE(3792),
    [sym_block_comment] = STATE(4227),
    [sym_line_comment] = STATE(4227),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9874),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9856),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4228] = {
    [sym_block_comment] = STATE(4228),
    [sym_line_comment] = STATE(4228),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4229] = {
    [sym_do_clause] = STATE(4817),
    [sym_block_comment] = STATE(4229),
    [sym_line_comment] = STATE(4229),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_catch] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9872),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_COLON_EQ] = ACTIONS(9696),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9696),
    [aux_sym__assignment_operator_token1] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4230] = {
    [sym_block_comment] = STATE(4230),
    [sym_line_comment] = STATE(4230),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(9876),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4231] = {
    [sym_identifier] = STATE(4350),
    [sym_block_comment] = STATE(4231),
    [sym_line_comment] = STATE(4231),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_COLON_EQ] = ACTIONS(9780),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9780),
    [aux_sym__assignment_operator_token1] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4232] = {
    [sym_identifier] = STATE(4351),
    [sym_block_comment] = STATE(4232),
    [sym_line_comment] = STATE(4232),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_COLON_EQ] = ACTIONS(9784),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9784),
    [aux_sym__assignment_operator_token1] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4233] = {
    [sym_identifier] = STATE(4355),
    [sym_block_comment] = STATE(4233),
    [sym_line_comment] = STATE(4233),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_COLON_EQ] = ACTIONS(9796),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9796),
    [aux_sym__assignment_operator_token1] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4234] = {
    [sym_identifier] = STATE(4356),
    [sym_block_comment] = STATE(4234),
    [sym_line_comment] = STATE(4234),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_COLON_EQ] = ACTIONS(9800),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9800),
    [aux_sym__assignment_operator_token1] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4235] = {
    [sym_block_comment] = STATE(4235),
    [sym_line_comment] = STATE(4235),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(9878),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4236] = {
    [sym_block_comment] = STATE(4236),
    [sym_line_comment] = STATE(4236),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4237] = {
    [sym_block_comment] = STATE(4237),
    [sym_line_comment] = STATE(4237),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9670),
    [sym__immediate_command_start] = ACTIONS(9672),
  },
  [4238] = {
    [sym_block_comment] = STATE(4238),
    [sym_line_comment] = STATE(4238),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_COLON_EQ] = ACTIONS(9644),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9644),
    [aux_sym__assignment_operator_token1] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4239] = {
    [sym_block_comment] = STATE(4239),
    [sym_line_comment] = STATE(4239),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4240] = {
    [sym_do_clause] = STATE(4841),
    [sym_block_comment] = STATE(4240),
    [sym_line_comment] = STATE(4240),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9872),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4241] = {
    [sym_block_comment] = STATE(4241),
    [sym_line_comment] = STATE(4241),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4242] = {
    [sym_block_comment] = STATE(4242),
    [sym_line_comment] = STATE(4242),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4243] = {
    [sym_block_comment] = STATE(4243),
    [sym_line_comment] = STATE(4243),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_elseif] = ACTIONS(9726),
    [anon_sym_else] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_COLON_EQ] = ACTIONS(9726),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9726),
    [aux_sym__assignment_operator_token1] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4244] = {
    [sym__primary_expression] = STATE(10491),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10165),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(4244),
    [sym_line_comment] = STATE(4244),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9888),
    [anon_sym_COLON2] = ACTIONS(9890),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(189),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4245] = {
    [sym_block_comment] = STATE(4245),
    [sym_line_comment] = STATE(4245),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_elseif] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_COLON_EQ] = ACTIONS(9898),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9898),
    [aux_sym__assignment_operator_token1] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [4246] = {
    [sym__assignment_operator] = STATE(3532),
    [sym_block_comment] = STATE(4246),
    [sym_line_comment] = STATE(4246),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9902),
    [anon_sym_DOT] = ACTIONS(9904),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
    [sym__immediate_bracket] = ACTIONS(9908),
    [sym__immediate_brace] = ACTIONS(9910),
  },
  [4247] = {
    [sym_block_comment] = STATE(4247),
    [sym_line_comment] = STATE(4247),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4248] = {
    [sym_block_comment] = STATE(4248),
    [sym_line_comment] = STATE(4248),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_elseif] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_COLON_EQ] = ACTIONS(9912),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9912),
    [aux_sym__assignment_operator_token1] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [4249] = {
    [sym_block_comment] = STATE(4249),
    [sym_line_comment] = STATE(4249),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_elseif] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_COLON_EQ] = ACTIONS(9916),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9916),
    [aux_sym__assignment_operator_token1] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4250] = {
    [sym_block_comment] = STATE(4250),
    [sym_line_comment] = STATE(4250),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_elseif] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_COLON_EQ] = ACTIONS(9920),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9920),
    [aux_sym__assignment_operator_token1] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4251] = {
    [sym_block_comment] = STATE(4251),
    [sym_line_comment] = STATE(4251),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(9924),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4252] = {
    [sym_block_comment] = STATE(4252),
    [sym_line_comment] = STATE(4252),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_elseif] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_COLON_EQ] = ACTIONS(9926),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9926),
    [aux_sym__assignment_operator_token1] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4253] = {
    [sym_block_comment] = STATE(4253),
    [sym_line_comment] = STATE(4253),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4254] = {
    [sym_block_comment] = STATE(4254),
    [sym_line_comment] = STATE(4254),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4255] = {
    [sym_block_comment] = STATE(4255),
    [sym_line_comment] = STATE(4255),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4256] = {
    [sym_do_clause] = STATE(4976),
    [sym_block_comment] = STATE(4256),
    [sym_line_comment] = STATE(4256),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(9930),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4257] = {
    [sym__assignment_operator] = STATE(3319),
    [sym_block_comment] = STATE(4257),
    [sym_line_comment] = STATE(4257),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(9934),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4258] = {
    [sym__assignment_operator] = STATE(2971),
    [sym_block_comment] = STATE(4258),
    [sym_line_comment] = STATE(4258),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9942),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9944),
    [anon_sym_DOT] = ACTIONS(9946),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
    [sym__immediate_bracket] = ACTIONS(9950),
    [sym__immediate_brace] = ACTIONS(9952),
  },
  [4259] = {
    [sym_block_comment] = STATE(4259),
    [sym_line_comment] = STATE(4259),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_catch] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_COLON_EQ] = ACTIONS(9752),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9752),
    [aux_sym__assignment_operator_token1] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4260] = {
    [sym_block_comment] = STATE(4260),
    [sym_line_comment] = STATE(4260),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_elseif] = ACTIONS(9954),
    [anon_sym_else] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_COLON_EQ] = ACTIONS(9954),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9954),
    [aux_sym__assignment_operator_token1] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4261] = {
    [sym_block_comment] = STATE(4261),
    [sym_line_comment] = STATE(4261),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_catch] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_COLON_EQ] = ACTIONS(9738),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9738),
    [aux_sym__assignment_operator_token1] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4262] = {
    [sym_block_comment] = STATE(4262),
    [sym_line_comment] = STATE(4262),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_catch] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_COLON_EQ] = ACTIONS(9752),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9752),
    [aux_sym__assignment_operator_token1] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4263] = {
    [sym__assignment_operator] = STATE(3319),
    [sym_block_comment] = STATE(4263),
    [sym_line_comment] = STATE(4263),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(9934),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4264] = {
    [sym_block_comment] = STATE(4264),
    [sym_line_comment] = STATE(4264),
    [ts_builtin_sym_end] = ACTIONS(9728),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_RBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4265] = {
    [sym_block_comment] = STATE(4265),
    [sym_line_comment] = STATE(4265),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_elseif] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_COLON_EQ] = ACTIONS(9958),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9958),
    [aux_sym__assignment_operator_token1] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [4266] = {
    [sym_block_comment] = STATE(4266),
    [sym_line_comment] = STATE(4266),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_catch] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_COLON_EQ] = ACTIONS(9810),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9810),
    [aux_sym__assignment_operator_token1] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4267] = {
    [sym_block_comment] = STATE(4267),
    [sym_line_comment] = STATE(4267),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_catch] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_COLON_EQ] = ACTIONS(9814),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9814),
    [aux_sym__assignment_operator_token1] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4268] = {
    [sym_block_comment] = STATE(4268),
    [sym_line_comment] = STATE(4268),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_elseif] = ACTIONS(9962),
    [anon_sym_else] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_COLON_EQ] = ACTIONS(9962),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9962),
    [aux_sym__assignment_operator_token1] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4269] = {
    [sym_block_comment] = STATE(4269),
    [sym_line_comment] = STATE(4269),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_catch] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_COLON_EQ] = ACTIONS(9818),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9818),
    [aux_sym__assignment_operator_token1] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4270] = {
    [sym_block_comment] = STATE(4270),
    [sym_line_comment] = STATE(4270),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_catch] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_COLON_EQ] = ACTIONS(9790),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9790),
    [aux_sym__assignment_operator_token1] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4271] = {
    [sym_block_comment] = STATE(4271),
    [sym_line_comment] = STATE(4271),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_catch] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_COLON_EQ] = ACTIONS(9824),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9824),
    [aux_sym__assignment_operator_token1] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4272] = {
    [sym_block_comment] = STATE(4272),
    [sym_line_comment] = STATE(4272),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_catch] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_COLON_EQ] = ACTIONS(9828),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9828),
    [aux_sym__assignment_operator_token1] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4273] = {
    [sym_block_comment] = STATE(4273),
    [sym_line_comment] = STATE(4273),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_catch] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_COLON_EQ] = ACTIONS(9832),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9832),
    [aux_sym__assignment_operator_token1] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4274] = {
    [sym_block_comment] = STATE(4274),
    [sym_line_comment] = STATE(4274),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_catch] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_COLON_EQ] = ACTIONS(9836),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9836),
    [aux_sym__assignment_operator_token1] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4275] = {
    [sym_block_comment] = STATE(4275),
    [sym_line_comment] = STATE(4275),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_elseif] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [4276] = {
    [sym__assignment_operator] = STATE(3036),
    [sym_block_comment] = STATE(4276),
    [sym_line_comment] = STATE(4276),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9968),
    [anon_sym_DOT] = ACTIONS(9970),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
    [sym__immediate_bracket] = ACTIONS(9974),
    [sym__immediate_brace] = ACTIONS(9976),
  },
  [4277] = {
    [sym_block_comment] = STATE(4277),
    [sym_line_comment] = STATE(4277),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4278] = {
    [sym_block_comment] = STATE(4278),
    [sym_line_comment] = STATE(4278),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_catch] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_COLON_EQ] = ACTIONS(9810),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9810),
    [aux_sym__assignment_operator_token1] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4279] = {
    [sym_block_comment] = STATE(4279),
    [sym_line_comment] = STATE(4279),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4280] = {
    [sym_block_comment] = STATE(4280),
    [sym_line_comment] = STATE(4280),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_catch] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_COLON_EQ] = ACTIONS(9814),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9814),
    [aux_sym__assignment_operator_token1] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4281] = {
    [sym_block_comment] = STATE(4281),
    [sym_line_comment] = STATE(4281),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4282] = {
    [sym_block_comment] = STATE(4282),
    [sym_line_comment] = STATE(4282),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_catch] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_COLON_EQ] = ACTIONS(9818),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9818),
    [aux_sym__assignment_operator_token1] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4283] = {
    [sym_block_comment] = STATE(4283),
    [sym_line_comment] = STATE(4283),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4284] = {
    [sym_block_comment] = STATE(4284),
    [sym_line_comment] = STATE(4284),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_catch] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_COLON_EQ] = ACTIONS(9790),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9790),
    [aux_sym__assignment_operator_token1] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4285] = {
    [sym_block_comment] = STATE(4285),
    [sym_line_comment] = STATE(4285),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_catch] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_COLON_EQ] = ACTIONS(9824),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9824),
    [aux_sym__assignment_operator_token1] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4286] = {
    [sym_block_comment] = STATE(4286),
    [sym_line_comment] = STATE(4286),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_catch] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_COLON_EQ] = ACTIONS(9828),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9828),
    [aux_sym__assignment_operator_token1] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4287] = {
    [sym_block_comment] = STATE(4287),
    [sym_line_comment] = STATE(4287),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_catch] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_COLON_EQ] = ACTIONS(9832),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9832),
    [aux_sym__assignment_operator_token1] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4288] = {
    [sym_block_comment] = STATE(4288),
    [sym_line_comment] = STATE(4288),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_catch] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_COLON_EQ] = ACTIONS(9836),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9836),
    [aux_sym__assignment_operator_token1] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4289] = {
    [sym_block_comment] = STATE(4289),
    [sym_line_comment] = STATE(4289),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_elseif] = ACTIONS(9978),
    [anon_sym_else] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_COLON_EQ] = ACTIONS(9978),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9978),
    [aux_sym__assignment_operator_token1] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4290] = {
    [sym_block_comment] = STATE(4290),
    [sym_line_comment] = STATE(4290),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_elseif] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4291] = {
    [sym_block_comment] = STATE(4291),
    [sym_line_comment] = STATE(4291),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_elseif] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_COLON_EQ] = ACTIONS(9982),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9982),
    [aux_sym__assignment_operator_token1] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4292] = {
    [sym_block_comment] = STATE(4292),
    [sym_line_comment] = STATE(4292),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4293] = {
    [sym_block_comment] = STATE(4293),
    [sym_line_comment] = STATE(4293),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_elseif] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_COLON_EQ] = ACTIONS(9986),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9986),
    [aux_sym__assignment_operator_token1] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4294] = {
    [sym_block_comment] = STATE(4294),
    [sym_line_comment] = STATE(4294),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_COLON_EQ] = ACTIONS(9926),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9926),
    [aux_sym__assignment_operator_token1] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4295] = {
    [sym_block_comment] = STATE(4295),
    [sym_line_comment] = STATE(4295),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3071),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3071),
    [aux_sym__assignment_operator_token1] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4296] = {
    [sym_block_comment] = STATE(4296),
    [sym_line_comment] = STATE(4296),
    [ts_builtin_sym_end] = ACTIONS(9806),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_COLON_EQ] = ACTIONS(9738),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9738),
    [aux_sym__assignment_operator_token1] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4297] = {
    [sym_block_comment] = STATE(4297),
    [sym_line_comment] = STATE(4297),
    [ts_builtin_sym_end] = ACTIONS(9740),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4298] = {
    [sym_block_comment] = STATE(4298),
    [sym_line_comment] = STATE(4298),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_RPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_RBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_SEMI] = ACTIONS(9746),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_RBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_COLON_EQ] = ACTIONS(9746),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_DASH_GT] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9746),
    [aux_sym__assignment_operator_token1] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4299] = {
    [sym_block_comment] = STATE(4299),
    [sym_line_comment] = STATE(4299),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_RPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_RBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_SEMI] = ACTIONS(9746),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_RBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_COLON_EQ] = ACTIONS(9746),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_DASH_GT] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9746),
    [aux_sym__assignment_operator_token1] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4300] = {
    [sym_block_comment] = STATE(4300),
    [sym_line_comment] = STATE(4300),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_elseif] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_COLON_EQ] = ACTIONS(9990),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9990),
    [aux_sym__assignment_operator_token1] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4301] = {
    [sym_block_comment] = STATE(4301),
    [sym_line_comment] = STATE(4301),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_elseif] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_COLON_EQ] = ACTIONS(9994),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9994),
    [aux_sym__assignment_operator_token1] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4302] = {
    [sym_block_comment] = STATE(4302),
    [sym_line_comment] = STATE(4302),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_elseif] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4303] = {
    [sym_block_comment] = STATE(4303),
    [sym_line_comment] = STATE(4303),
    [ts_builtin_sym_end] = ACTIONS(9808),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_RBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_COLON_EQ] = ACTIONS(9752),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9752),
    [aux_sym__assignment_operator_token1] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4304] = {
    [sym_block_comment] = STATE(4304),
    [sym_line_comment] = STATE(4304),
    [ts_builtin_sym_end] = ACTIONS(9812),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_RBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_COLON_EQ] = ACTIONS(9810),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9810),
    [aux_sym__assignment_operator_token1] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4305] = {
    [sym_block_comment] = STATE(4305),
    [sym_line_comment] = STATE(4305),
    [ts_builtin_sym_end] = ACTIONS(9754),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_RBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4306] = {
    [sym_block_comment] = STATE(4306),
    [sym_line_comment] = STATE(4306),
    [ts_builtin_sym_end] = ACTIONS(9816),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_RBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_COLON_EQ] = ACTIONS(9814),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9814),
    [aux_sym__assignment_operator_token1] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4307] = {
    [sym_block_comment] = STATE(4307),
    [sym_line_comment] = STATE(4307),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_RBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9762),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_COLON_EQ] = ACTIONS(9762),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_DASH_GT] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9762),
    [aux_sym__assignment_operator_token1] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4308] = {
    [sym_block_comment] = STATE(4308),
    [sym_line_comment] = STATE(4308),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_elseif] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4309] = {
    [sym_block_comment] = STATE(4309),
    [sym_line_comment] = STATE(4309),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_elseif] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4310] = {
    [sym_block_comment] = STATE(4310),
    [sym_line_comment] = STATE(4310),
    [ts_builtin_sym_end] = ACTIONS(9820),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_RBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_COLON_EQ] = ACTIONS(9818),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9818),
    [aux_sym__assignment_operator_token1] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4311] = {
    [sym_block_comment] = STATE(4311),
    [sym_line_comment] = STATE(4311),
    [ts_builtin_sym_end] = ACTIONS(9792),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_RBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4312] = {
    [sym_block_comment] = STATE(4312),
    [sym_line_comment] = STATE(4312),
    [ts_builtin_sym_end] = ACTIONS(9822),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_RBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_COLON_EQ] = ACTIONS(9790),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9790),
    [aux_sym__assignment_operator_token1] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4313] = {
    [sym_block_comment] = STATE(4313),
    [sym_line_comment] = STATE(4313),
    [ts_builtin_sym_end] = ACTIONS(9826),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_RBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_COLON_EQ] = ACTIONS(9824),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9824),
    [aux_sym__assignment_operator_token1] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4314] = {
    [sym_block_comment] = STATE(4314),
    [sym_line_comment] = STATE(4314),
    [ts_builtin_sym_end] = ACTIONS(9830),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_RBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_COLON_EQ] = ACTIONS(9828),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9828),
    [aux_sym__assignment_operator_token1] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4315] = {
    [sym_block_comment] = STATE(4315),
    [sym_line_comment] = STATE(4315),
    [ts_builtin_sym_end] = ACTIONS(9834),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_RBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_COLON_EQ] = ACTIONS(9832),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9832),
    [aux_sym__assignment_operator_token1] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4316] = {
    [sym_block_comment] = STATE(4316),
    [sym_line_comment] = STATE(4316),
    [ts_builtin_sym_end] = ACTIONS(9838),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_RBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_COLON_EQ] = ACTIONS(9836),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9836),
    [aux_sym__assignment_operator_token1] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4317] = {
    [sym_block_comment] = STATE(4317),
    [sym_line_comment] = STATE(4317),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_COLON_EQ] = ACTIONS(9982),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9982),
    [aux_sym__assignment_operator_token1] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4318] = {
    [sym__assignment_operator] = STATE(3416),
    [sym_block_comment] = STATE(4318),
    [sym_line_comment] = STATE(4318),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9944),
    [anon_sym_DOT] = ACTIONS(9998),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
    [sym__immediate_bracket] = ACTIONS(9950),
    [sym__immediate_brace] = ACTIONS(9952),
  },
  [4319] = {
    [sym_block_comment] = STATE(4319),
    [sym_line_comment] = STATE(4319),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_COLON_EQ] = ACTIONS(9986),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9986),
    [aux_sym__assignment_operator_token1] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4320] = {
    [sym_block_comment] = STATE(4320),
    [sym_line_comment] = STATE(4320),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_COLON_EQ] = ACTIONS(10000),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10000),
    [aux_sym__assignment_operator_token1] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4321] = {
    [sym_block_comment] = STATE(4321),
    [sym_line_comment] = STATE(4321),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_COLON_EQ] = ACTIONS(10004),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10004),
    [aux_sym__assignment_operator_token1] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4322] = {
    [sym_block_comment] = STATE(4322),
    [sym_line_comment] = STATE(4322),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4323] = {
    [sym__assignment_operator] = STATE(3481),
    [sym_block_comment] = STATE(4323),
    [sym_line_comment] = STATE(4323),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9968),
    [anon_sym_DOT] = ACTIONS(10008),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
    [sym__immediate_bracket] = ACTIONS(9974),
    [sym__immediate_brace] = ACTIONS(9976),
  },
  [4324] = {
    [sym_block_comment] = STATE(4324),
    [sym_line_comment] = STATE(4324),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_elseif] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4325] = {
    [sym_block_comment] = STATE(4325),
    [sym_line_comment] = STATE(4325),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_COLON_EQ] = ACTIONS(10010),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10010),
    [aux_sym__assignment_operator_token1] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [4326] = {
    [sym_block_comment] = STATE(4326),
    [sym_line_comment] = STATE(4326),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_COLON_EQ] = ACTIONS(10014),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10014),
    [aux_sym__assignment_operator_token1] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [4327] = {
    [sym_block_comment] = STATE(4327),
    [sym_line_comment] = STATE(4327),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_COLON_EQ] = ACTIONS(10018),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10018),
    [aux_sym__assignment_operator_token1] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4328] = {
    [sym_block_comment] = STATE(4328),
    [sym_line_comment] = STATE(4328),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_COLON_EQ] = ACTIONS(9916),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9916),
    [aux_sym__assignment_operator_token1] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4329] = {
    [sym_block_comment] = STATE(4329),
    [sym_line_comment] = STATE(4329),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_COLON_EQ] = ACTIONS(9920),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9920),
    [aux_sym__assignment_operator_token1] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4330] = {
    [sym_block_comment] = STATE(4330),
    [sym_line_comment] = STATE(4330),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_COLON_EQ] = ACTIONS(9990),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9990),
    [aux_sym__assignment_operator_token1] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4331] = {
    [sym_block_comment] = STATE(4331),
    [sym_line_comment] = STATE(4331),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_COLON_EQ] = ACTIONS(9994),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9994),
    [aux_sym__assignment_operator_token1] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4332] = {
    [sym_block_comment] = STATE(4332),
    [sym_line_comment] = STATE(4332),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4333] = {
    [sym_block_comment] = STATE(4333),
    [sym_line_comment] = STATE(4333),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_RPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_RBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_SEMI] = ACTIONS(9728),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_COLON_EQ] = ACTIONS(9728),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_DASH_GT] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9728),
    [aux_sym__assignment_operator_token1] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4334] = {
    [sym_block_comment] = STATE(4334),
    [sym_line_comment] = STATE(4334),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_else] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_COLON_EQ] = ACTIONS(9978),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9978),
    [aux_sym__assignment_operator_token1] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4335] = {
    [sym_block_comment] = STATE(4335),
    [sym_line_comment] = STATE(4335),
    [ts_builtin_sym_end] = ACTIONS(9758),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_RBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_COLON_EQ] = ACTIONS(9744),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9744),
    [aux_sym__assignment_operator_token1] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4336] = {
    [sym__assignment_operator] = STATE(3691),
    [sym_block_comment] = STATE(4336),
    [sym_line_comment] = STATE(4336),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10022),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(10024),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4337] = {
    [sym_block_comment] = STATE(4337),
    [sym_line_comment] = STATE(4337),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(10026),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9776),
    [sym__immediate_command_start] = ACTIONS(9778),
  },
  [4338] = {
    [sym_block_comment] = STATE(4338),
    [sym_line_comment] = STATE(4338),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4339] = {
    [sym_block_comment] = STATE(4339),
    [sym_line_comment] = STATE(4339),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_COLON_EQ] = ACTIONS(10028),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10028),
    [aux_sym__assignment_operator_token1] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4340] = {
    [sym_block_comment] = STATE(4340),
    [sym_line_comment] = STATE(4340),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_COLON_EQ] = ACTIONS(10032),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10032),
    [aux_sym__assignment_operator_token1] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4341] = {
    [sym_block_comment] = STATE(4341),
    [sym_line_comment] = STATE(4341),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_COLON_EQ] = ACTIONS(10036),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10036),
    [aux_sym__assignment_operator_token1] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4342] = {
    [sym_block_comment] = STATE(4342),
    [sym_line_comment] = STATE(4342),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_COLON_EQ] = ACTIONS(10040),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10040),
    [aux_sym__assignment_operator_token1] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4343] = {
    [sym_block_comment] = STATE(4343),
    [sym_line_comment] = STATE(4343),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_elseif] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4344] = {
    [sym_block_comment] = STATE(4344),
    [sym_line_comment] = STATE(4344),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4345] = {
    [sym_block_comment] = STATE(4345),
    [sym_line_comment] = STATE(4345),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_COLON_EQ] = ACTIONS(10044),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10044),
    [aux_sym__assignment_operator_token1] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [4346] = {
    [sym_block_comment] = STATE(4346),
    [sym_line_comment] = STATE(4346),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_COLON_EQ] = ACTIONS(10048),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10048),
    [aux_sym__assignment_operator_token1] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [4347] = {
    [sym_block_comment] = STATE(4347),
    [sym_line_comment] = STATE(4347),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_COLON_EQ] = ACTIONS(10052),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10052),
    [aux_sym__assignment_operator_token1] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [4348] = {
    [sym_block_comment] = STATE(4348),
    [sym_line_comment] = STATE(4348),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_COLON_EQ] = ACTIONS(10056),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10056),
    [aux_sym__assignment_operator_token1] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [4349] = {
    [sym_block_comment] = STATE(4349),
    [sym_line_comment] = STATE(4349),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_COLON_EQ] = ACTIONS(9898),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9898),
    [aux_sym__assignment_operator_token1] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [4350] = {
    [sym_block_comment] = STATE(4350),
    [sym_line_comment] = STATE(4350),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_COLON_EQ] = ACTIONS(10060),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10060),
    [aux_sym__assignment_operator_token1] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4351] = {
    [sym_block_comment] = STATE(4351),
    [sym_line_comment] = STATE(4351),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_COLON_EQ] = ACTIONS(10064),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10064),
    [aux_sym__assignment_operator_token1] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4352] = {
    [sym_block_comment] = STATE(4352),
    [sym_line_comment] = STATE(4352),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4353] = {
    [sym_block_comment] = STATE(4353),
    [sym_line_comment] = STATE(4353),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_COLON_EQ] = ACTIONS(10068),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10068),
    [aux_sym__assignment_operator_token1] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4354] = {
    [sym_block_comment] = STATE(4354),
    [sym_line_comment] = STATE(4354),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_COLON_EQ] = ACTIONS(10072),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10072),
    [aux_sym__assignment_operator_token1] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4355] = {
    [sym_block_comment] = STATE(4355),
    [sym_line_comment] = STATE(4355),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_COLON_EQ] = ACTIONS(10076),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10076),
    [aux_sym__assignment_operator_token1] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4356] = {
    [sym_block_comment] = STATE(4356),
    [sym_line_comment] = STATE(4356),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_COLON_EQ] = ACTIONS(10080),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10080),
    [aux_sym__assignment_operator_token1] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4357] = {
    [sym_block_comment] = STATE(4357),
    [sym_line_comment] = STATE(4357),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_COLON_EQ] = ACTIONS(9734),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10084),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9734),
    [aux_sym__assignment_operator_token1] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4358] = {
    [sym_identifier] = STATE(4709),
    [sym_block_comment] = STATE(4358),
    [sym_line_comment] = STATE(4358),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_RPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_RBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_SEMI] = ACTIONS(9782),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_RBRACE] = ACTIONS(9782),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_COLON_EQ] = ACTIONS(9782),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9782),
    [aux_sym__assignment_operator_token1] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4359] = {
    [sym_block_comment] = STATE(4359),
    [sym_line_comment] = STATE(4359),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_else] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_COLON_EQ] = ACTIONS(10086),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10086),
    [aux_sym__assignment_operator_token1] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4360] = {
    [sym_block_comment] = STATE(4360),
    [sym_line_comment] = STATE(4360),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_elseif] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_COLON_EQ] = ACTIONS(10028),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10028),
    [aux_sym__assignment_operator_token1] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4361] = {
    [sym__assignment_operator] = STATE(3015),
    [sym_block_comment] = STATE(4361),
    [sym_line_comment] = STATE(4361),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9764),
    [anon_sym_DOT] = ACTIONS(9842),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
    [sym__immediate_bracket] = ACTIONS(9772),
    [sym__immediate_brace] = ACTIONS(9774),
  },
  [4362] = {
    [sym_identifier] = STATE(4710),
    [sym_block_comment] = STATE(4362),
    [sym_line_comment] = STATE(4362),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_RPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_RBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_SEMI] = ACTIONS(9786),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_COLON_EQ] = ACTIONS(9786),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9786),
    [aux_sym__assignment_operator_token1] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4363] = {
    [sym_identifier] = STATE(4712),
    [sym_block_comment] = STATE(4363),
    [sym_line_comment] = STATE(4363),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_RPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_RBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_SEMI] = ACTIONS(9798),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_RBRACE] = ACTIONS(9798),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_COLON_EQ] = ACTIONS(9798),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9798),
    [aux_sym__assignment_operator_token1] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4364] = {
    [sym_identifier] = STATE(4713),
    [sym_block_comment] = STATE(4364),
    [sym_line_comment] = STATE(4364),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_RPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_RBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_SEMI] = ACTIONS(9802),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_RBRACE] = ACTIONS(9802),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_COLON_EQ] = ACTIONS(9802),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9802),
    [aux_sym__assignment_operator_token1] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4365] = {
    [sym_block_comment] = STATE(4365),
    [sym_line_comment] = STATE(4365),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_COLON_EQ] = ACTIONS(9642),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9642),
    [aux_sym__assignment_operator_token1] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4366] = {
    [sym_block_comment] = STATE(4366),
    [sym_line_comment] = STATE(4366),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_COLON_EQ] = ACTIONS(9726),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9726),
    [aux_sym__assignment_operator_token1] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4367] = {
    [sym_block_comment] = STATE(4367),
    [sym_line_comment] = STATE(4367),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_else] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_COLON_EQ] = ACTIONS(9954),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9954),
    [aux_sym__assignment_operator_token1] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4368] = {
    [sym_block_comment] = STATE(4368),
    [sym_line_comment] = STATE(4368),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_COLON_EQ] = ACTIONS(9744),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9744),
    [aux_sym__assignment_operator_token1] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4369] = {
    [sym_block_comment] = STATE(4369),
    [sym_line_comment] = STATE(4369),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [4370] = {
    [sym__assignment_operator] = STATE(3036),
    [sym_block_comment] = STATE(4370),
    [sym_line_comment] = STATE(4370),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10090),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9968),
    [anon_sym_DOT] = ACTIONS(9970),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
    [sym__immediate_bracket] = ACTIONS(9974),
    [sym__immediate_brace] = ACTIONS(9976),
  },
  [4371] = {
    [sym__assignment_operator] = STATE(3416),
    [sym_block_comment] = STATE(4371),
    [sym_line_comment] = STATE(4371),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9944),
    [anon_sym_DOT] = ACTIONS(9998),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
    [sym__immediate_bracket] = ACTIONS(9950),
    [sym__immediate_brace] = ACTIONS(9952),
  },
  [4372] = {
    [sym_block_comment] = STATE(4372),
    [sym_line_comment] = STATE(4372),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_COLON_EQ] = ACTIONS(9738),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9738),
    [aux_sym__assignment_operator_token1] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4373] = {
    [sym_block_comment] = STATE(4373),
    [sym_line_comment] = STATE(4373),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_COLON_EQ] = ACTIONS(9752),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9752),
    [aux_sym__assignment_operator_token1] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4374] = {
    [sym_block_comment] = STATE(4374),
    [sym_line_comment] = STATE(4374),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_COLON_EQ] = ACTIONS(9810),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9810),
    [aux_sym__assignment_operator_token1] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4375] = {
    [sym_block_comment] = STATE(4375),
    [sym_line_comment] = STATE(4375),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_COLON_EQ] = ACTIONS(9814),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9814),
    [aux_sym__assignment_operator_token1] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4376] = {
    [sym_block_comment] = STATE(4376),
    [sym_line_comment] = STATE(4376),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_COLON_EQ] = ACTIONS(9818),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9818),
    [aux_sym__assignment_operator_token1] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4377] = {
    [sym_block_comment] = STATE(4377),
    [sym_line_comment] = STATE(4377),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_COLON_EQ] = ACTIONS(9790),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9790),
    [aux_sym__assignment_operator_token1] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4378] = {
    [sym_block_comment] = STATE(4378),
    [sym_line_comment] = STATE(4378),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_COLON_EQ] = ACTIONS(9824),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9824),
    [aux_sym__assignment_operator_token1] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4379] = {
    [sym_do_clause] = STATE(4862),
    [sym_block_comment] = STATE(4379),
    [sym_line_comment] = STATE(4379),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(9930),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_COLON_EQ] = ACTIONS(9696),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9696),
    [aux_sym__assignment_operator_token1] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4380] = {
    [sym_block_comment] = STATE(4380),
    [sym_line_comment] = STATE(4380),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_RPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_RBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9740),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_RBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_COLON_EQ] = ACTIONS(9740),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_DASH_GT] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9740),
    [aux_sym__assignment_operator_token1] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4381] = {
    [sym_block_comment] = STATE(4381),
    [sym_line_comment] = STATE(4381),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4382] = {
    [sym_block_comment] = STATE(4382),
    [sym_line_comment] = STATE(4382),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4383] = {
    [sym_block_comment] = STATE(4383),
    [sym_line_comment] = STATE(4383),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_else] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_COLON_EQ] = ACTIONS(9962),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9962),
    [aux_sym__assignment_operator_token1] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4384] = {
    [sym_block_comment] = STATE(4384),
    [sym_line_comment] = STATE(4384),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_COLON_EQ] = ACTIONS(9828),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9828),
    [aux_sym__assignment_operator_token1] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4385] = {
    [sym_block_comment] = STATE(4385),
    [sym_line_comment] = STATE(4385),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_COLON_EQ] = ACTIONS(9832),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9832),
    [aux_sym__assignment_operator_token1] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4386] = {
    [sym_block_comment] = STATE(4386),
    [sym_line_comment] = STATE(4386),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [4387] = {
    [sym__assignment_operator] = STATE(3416),
    [sym_block_comment] = STATE(4387),
    [sym_line_comment] = STATE(4387),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9944),
    [anon_sym_DOT] = ACTIONS(9998),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
    [sym__immediate_bracket] = ACTIONS(9950),
    [sym__immediate_brace] = ACTIONS(9952),
  },
  [4388] = {
    [sym_block_comment] = STATE(4388),
    [sym_line_comment] = STATE(4388),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_RPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_RBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_SEMI] = ACTIONS(9754),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_RBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_COLON_EQ] = ACTIONS(9754),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_DASH_GT] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9754),
    [aux_sym__assignment_operator_token1] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4389] = {
    [sym_block_comment] = STATE(4389),
    [sym_line_comment] = STATE(4389),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4390] = {
    [sym_block_comment] = STATE(4390),
    [sym_line_comment] = STATE(4390),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9756),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9756),
    [anon_sym_RPAREN] = ACTIONS(9756),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9756),
    [anon_sym_RBRACK] = ACTIONS(9756),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_SEMI] = ACTIONS(9756),
    [anon_sym_LBRACE] = ACTIONS(9756),
    [anon_sym_RBRACE] = ACTIONS(9756),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9756),
    [anon_sym_COLON_EQ] = ACTIONS(9756),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9756),
    [anon_sym_QMARK] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9756),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9756),
    [aux_sym_integer_literal_token2] = ACTIONS(9756),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9756),
    [aux_sym_float_literal_token3] = ACTIONS(9756),
    [aux_sym_float_literal_token4] = ACTIONS(9756),
    [sym_character_literal] = ACTIONS(9756),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9756),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9756),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9756),
    [aux_sym__assignment_operator_token1] = ACTIONS(9756),
    [sym__pair_operator] = ACTIONS(9756),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9756),
    [sym__lazy_and_operator] = ACTIONS(9756),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9756),
    [sym__pipe_left_operator] = ACTIONS(9756),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9756),
    [sym__type_order_operator] = ACTIONS(9756),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4391] = {
    [sym_block_comment] = STATE(4391),
    [sym_line_comment] = STATE(4391),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_COLON_EQ] = ACTIONS(9836),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9836),
    [aux_sym__assignment_operator_token1] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4392] = {
    [sym_block_comment] = STATE(4392),
    [sym_line_comment] = STATE(4392),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4393] = {
    [sym__assignment_operator] = STATE(3108),
    [sym_block_comment] = STATE(4393),
    [sym_line_comment] = STATE(4393),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10092),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9856),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4394] = {
    [sym_identifier] = STATE(4525),
    [sym_block_comment] = STATE(4394),
    [sym_line_comment] = STATE(4394),
    [ts_builtin_sym_end] = ACTIONS(9786),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_RBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_COLON_EQ] = ACTIONS(9784),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9784),
    [aux_sym__assignment_operator_token1] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4395] = {
    [sym_block_comment] = STATE(4395),
    [sym_line_comment] = STATE(4395),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_RPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_RBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_SEMI] = ACTIONS(9792),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_COLON_EQ] = ACTIONS(9792),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_DASH_GT] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9792),
    [aux_sym__assignment_operator_token1] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4396] = {
    [sym_block_comment] = STATE(4396),
    [sym_line_comment] = STATE(4396),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_RBRACK] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9758),
    [anon_sym_COLON_EQ] = ACTIONS(9758),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9758),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9758),
    [aux_sym_integer_literal_token2] = ACTIONS(9758),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9758),
    [aux_sym_float_literal_token3] = ACTIONS(9758),
    [aux_sym_float_literal_token4] = ACTIONS(9758),
    [sym_character_literal] = ACTIONS(9758),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9758),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9758),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9758),
    [aux_sym__assignment_operator_token1] = ACTIONS(9758),
    [sym__pair_operator] = ACTIONS(9758),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9758),
    [sym__lazy_and_operator] = ACTIONS(9758),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9758),
    [sym__pipe_left_operator] = ACTIONS(9758),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9758),
    [sym__type_order_operator] = ACTIONS(9758),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4397] = {
    [sym_block_comment] = STATE(4397),
    [sym_line_comment] = STATE(4397),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_catch] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_COLON_EQ] = ACTIONS(9726),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9726),
    [aux_sym__assignment_operator_token1] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4398] = {
    [sym_identifier] = STATE(4533),
    [sym_block_comment] = STATE(4398),
    [sym_line_comment] = STATE(4398),
    [ts_builtin_sym_end] = ACTIONS(9798),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_RBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_COLON_EQ] = ACTIONS(9796),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9796),
    [aux_sym__assignment_operator_token1] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4399] = {
    [sym_identifier] = STATE(4537),
    [sym_block_comment] = STATE(4399),
    [sym_line_comment] = STATE(4399),
    [ts_builtin_sym_end] = ACTIONS(9802),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_RBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_COLON_EQ] = ACTIONS(9800),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9800),
    [aux_sym__assignment_operator_token1] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4400] = {
    [sym_block_comment] = STATE(4400),
    [sym_line_comment] = STATE(4400),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4401] = {
    [sym_block_comment] = STATE(4401),
    [sym_line_comment] = STATE(4401),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_catch] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_COLON_EQ] = ACTIONS(9744),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9744),
    [aux_sym__assignment_operator_token1] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4402] = {
    [sym_block_comment] = STATE(4402),
    [sym_line_comment] = STATE(4402),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4403] = {
    [sym_block_comment] = STATE(4403),
    [sym_line_comment] = STATE(4403),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_elseif] = ACTIONS(10086),
    [anon_sym_else] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_COLON_EQ] = ACTIONS(10086),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10086),
    [aux_sym__assignment_operator_token1] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4404] = {
    [sym_block_comment] = STATE(4404),
    [sym_line_comment] = STATE(4404),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_elseif] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_COLON_EQ] = ACTIONS(10010),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10010),
    [aux_sym__assignment_operator_token1] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [4405] = {
    [sym_block_comment] = STATE(4405),
    [sym_line_comment] = STATE(4405),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4406] = {
    [sym_block_comment] = STATE(4406),
    [sym_line_comment] = STATE(4406),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4407] = {
    [sym_do_clause] = STATE(4894),
    [sym_block_comment] = STATE(4407),
    [sym_line_comment] = STATE(4407),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(9930),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4408] = {
    [sym_block_comment] = STATE(4408),
    [sym_line_comment] = STATE(4408),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(10094),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9776),
    [sym__immediate_command_start] = ACTIONS(9778),
  },
  [4409] = {
    [sym_block_comment] = STATE(4409),
    [sym_line_comment] = STATE(4409),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4410] = {
    [sym_block_comment] = STATE(4410),
    [sym_line_comment] = STATE(4410),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4411] = {
    [sym_block_comment] = STATE(4411),
    [sym_line_comment] = STATE(4411),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4412] = {
    [sym_block_comment] = STATE(4412),
    [sym_line_comment] = STATE(4412),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4413] = {
    [sym_block_comment] = STATE(4413),
    [sym_line_comment] = STATE(4413),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(10096),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4414] = {
    [sym_block_comment] = STATE(4414),
    [sym_line_comment] = STATE(4414),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4415] = {
    [sym__assignment_operator] = STATE(2971),
    [sym_block_comment] = STATE(4415),
    [sym_line_comment] = STATE(4415),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9944),
    [anon_sym_DOT] = ACTIONS(9946),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
    [sym__immediate_bracket] = ACTIONS(9950),
    [sym__immediate_brace] = ACTIONS(9952),
  },
  [4416] = {
    [sym_block_comment] = STATE(4416),
    [sym_line_comment] = STATE(4416),
    [ts_builtin_sym_end] = ACTIONS(9746),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_RBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4417] = {
    [sym_block_comment] = STATE(4417),
    [sym_line_comment] = STATE(4417),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_catch] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_COLON_EQ] = ACTIONS(9738),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9738),
    [aux_sym__assignment_operator_token1] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4418] = {
    [sym_block_comment] = STATE(4418),
    [sym_line_comment] = STATE(4418),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10100),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4419] = {
    [sym__assignment_operator] = STATE(3481),
    [sym_block_comment] = STATE(4419),
    [sym_line_comment] = STATE(4419),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9968),
    [anon_sym_DOT] = ACTIONS(10008),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
    [sym__immediate_bracket] = ACTIONS(9974),
    [sym__immediate_brace] = ACTIONS(9976),
  },
  [4420] = {
    [sym__assignment_operator] = STATE(3481),
    [sym_block_comment] = STATE(4420),
    [sym_line_comment] = STATE(4420),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9968),
    [anon_sym_DOT] = ACTIONS(10008),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
    [sym__immediate_bracket] = ACTIONS(9974),
    [sym__immediate_brace] = ACTIONS(9976),
  },
  [4421] = {
    [sym_block_comment] = STATE(4421),
    [sym_line_comment] = STATE(4421),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4422] = {
    [sym_block_comment] = STATE(4422),
    [sym_line_comment] = STATE(4422),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_COLON_EQ] = ACTIONS(9958),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9958),
    [aux_sym__assignment_operator_token1] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [4423] = {
    [sym_block_comment] = STATE(4423),
    [sym_line_comment] = STATE(4423),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_elseif] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_COLON_EQ] = ACTIONS(10014),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10014),
    [aux_sym__assignment_operator_token1] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [4424] = {
    [sym_block_comment] = STATE(4424),
    [sym_line_comment] = STATE(4424),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9806),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9806),
    [anon_sym_RPAREN] = ACTIONS(9806),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9806),
    [anon_sym_RBRACK] = ACTIONS(9806),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9806),
    [anon_sym_LBRACE] = ACTIONS(9806),
    [anon_sym_RBRACE] = ACTIONS(9806),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9806),
    [anon_sym_COLON_EQ] = ACTIONS(9806),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9806),
    [anon_sym_QMARK] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9806),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9806),
    [aux_sym_integer_literal_token2] = ACTIONS(9806),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9806),
    [aux_sym_float_literal_token3] = ACTIONS(9806),
    [aux_sym_float_literal_token4] = ACTIONS(9806),
    [sym_character_literal] = ACTIONS(9806),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9806),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9806),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9806),
    [aux_sym__assignment_operator_token1] = ACTIONS(9806),
    [sym__pair_operator] = ACTIONS(9806),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9806),
    [sym__lazy_and_operator] = ACTIONS(9806),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9806),
    [sym__pipe_left_operator] = ACTIONS(9806),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9806),
    [sym__type_order_operator] = ACTIONS(9806),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4425] = {
    [sym_block_comment] = STATE(4425),
    [sym_line_comment] = STATE(4425),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_else] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_COLON_EQ] = ACTIONS(10102),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10102),
    [aux_sym__assignment_operator_token1] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4426] = {
    [sym_block_comment] = STATE(4426),
    [sym_line_comment] = STATE(4426),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4427] = {
    [sym_block_comment] = STATE(4427),
    [sym_line_comment] = STATE(4427),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4428] = {
    [sym_block_comment] = STATE(4428),
    [sym_line_comment] = STATE(4428),
    [ts_builtin_sym_end] = ACTIONS(9746),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_RBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4429] = {
    [sym_do_clause] = STATE(4974),
    [sym_block_comment] = STATE(4429),
    [sym_line_comment] = STATE(4429),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(9930),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_COLON_EQ] = ACTIONS(9680),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9680),
    [aux_sym__assignment_operator_token1] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4430] = {
    [sym_block_comment] = STATE(4430),
    [sym_line_comment] = STATE(4430),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_else] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_COLON_EQ] = ACTIONS(10106),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10106),
    [aux_sym__assignment_operator_token1] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4431] = {
    [sym__assignment_operator] = STATE(3691),
    [sym_block_comment] = STATE(4431),
    [sym_line_comment] = STATE(4431),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(10024),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4432] = {
    [sym_block_comment] = STATE(4432),
    [sym_line_comment] = STATE(4432),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9808),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9808),
    [anon_sym_RPAREN] = ACTIONS(9808),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9808),
    [anon_sym_RBRACK] = ACTIONS(9808),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_SEMI] = ACTIONS(9808),
    [anon_sym_LBRACE] = ACTIONS(9808),
    [anon_sym_RBRACE] = ACTIONS(9808),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9808),
    [anon_sym_COLON_EQ] = ACTIONS(9808),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9808),
    [anon_sym_QMARK] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9808),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9808),
    [aux_sym_integer_literal_token2] = ACTIONS(9808),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9808),
    [aux_sym_float_literal_token3] = ACTIONS(9808),
    [aux_sym_float_literal_token4] = ACTIONS(9808),
    [sym_character_literal] = ACTIONS(9808),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9808),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9808),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9808),
    [aux_sym__assignment_operator_token1] = ACTIONS(9808),
    [sym__pair_operator] = ACTIONS(9808),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9808),
    [sym__lazy_and_operator] = ACTIONS(9808),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9808),
    [sym__pipe_left_operator] = ACTIONS(9808),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9808),
    [sym__type_order_operator] = ACTIONS(9808),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4433] = {
    [sym__assignment_operator] = STATE(3127),
    [sym_block_comment] = STATE(4433),
    [sym_line_comment] = STATE(4433),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9902),
    [anon_sym_DOT] = ACTIONS(10114),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
    [sym__immediate_bracket] = ACTIONS(9908),
    [sym__immediate_brace] = ACTIONS(9910),
  },
  [4434] = {
    [sym_block_comment] = STATE(4434),
    [sym_line_comment] = STATE(4434),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9812),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9812),
    [anon_sym_RPAREN] = ACTIONS(9812),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9812),
    [anon_sym_RBRACK] = ACTIONS(9812),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_SEMI] = ACTIONS(9812),
    [anon_sym_LBRACE] = ACTIONS(9812),
    [anon_sym_RBRACE] = ACTIONS(9812),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9812),
    [anon_sym_COLON_EQ] = ACTIONS(9812),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9812),
    [anon_sym_QMARK] = ACTIONS(9812),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9812),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9812),
    [aux_sym_integer_literal_token2] = ACTIONS(9812),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9812),
    [aux_sym_float_literal_token3] = ACTIONS(9812),
    [aux_sym_float_literal_token4] = ACTIONS(9812),
    [sym_character_literal] = ACTIONS(9812),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9812),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9812),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9812),
    [aux_sym__assignment_operator_token1] = ACTIONS(9812),
    [sym__pair_operator] = ACTIONS(9812),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9812),
    [sym__lazy_and_operator] = ACTIONS(9812),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9812),
    [sym__pipe_left_operator] = ACTIONS(9812),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9812),
    [sym__type_order_operator] = ACTIONS(9812),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4435] = {
    [sym_block_comment] = STATE(4435),
    [sym_line_comment] = STATE(4435),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_COLON_EQ] = ACTIONS(10116),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10116),
    [aux_sym__assignment_operator_token1] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [4436] = {
    [sym__assignment_operator] = STATE(3127),
    [sym_block_comment] = STATE(4436),
    [sym_line_comment] = STATE(4436),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10120),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9902),
    [anon_sym_DOT] = ACTIONS(10114),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
    [sym__immediate_bracket] = ACTIONS(9908),
    [sym__immediate_brace] = ACTIONS(9910),
  },
  [4437] = {
    [sym_block_comment] = STATE(4437),
    [sym_line_comment] = STATE(4437),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9816),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9816),
    [anon_sym_RPAREN] = ACTIONS(9816),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9816),
    [anon_sym_RBRACK] = ACTIONS(9816),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_SEMI] = ACTIONS(9816),
    [anon_sym_LBRACE] = ACTIONS(9816),
    [anon_sym_RBRACE] = ACTIONS(9816),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9816),
    [anon_sym_COLON_EQ] = ACTIONS(9816),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9816),
    [anon_sym_QMARK] = ACTIONS(9816),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9816),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9816),
    [aux_sym_integer_literal_token2] = ACTIONS(9816),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9816),
    [aux_sym_float_literal_token3] = ACTIONS(9816),
    [aux_sym_float_literal_token4] = ACTIONS(9816),
    [sym_character_literal] = ACTIONS(9816),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9816),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9816),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9816),
    [aux_sym__assignment_operator_token1] = ACTIONS(9816),
    [sym__pair_operator] = ACTIONS(9816),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9816),
    [sym__lazy_and_operator] = ACTIONS(9816),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9816),
    [sym__pipe_left_operator] = ACTIONS(9816),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9816),
    [sym__type_order_operator] = ACTIONS(9816),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4438] = {
    [sym_block_comment] = STATE(4438),
    [sym_line_comment] = STATE(4438),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4439] = {
    [sym_block_comment] = STATE(4439),
    [sym_line_comment] = STATE(4439),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4440] = {
    [sym_block_comment] = STATE(4440),
    [sym_line_comment] = STATE(4440),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4441] = {
    [sym_block_comment] = STATE(4441),
    [sym_line_comment] = STATE(4441),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4442] = {
    [sym_block_comment] = STATE(4442),
    [sym_line_comment] = STATE(4442),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4443] = {
    [sym_block_comment] = STATE(4443),
    [sym_line_comment] = STATE(4443),
    [ts_builtin_sym_end] = ACTIONS(9762),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_RBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4444] = {
    [sym_block_comment] = STATE(4444),
    [sym_line_comment] = STATE(4444),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_catch] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_COLON_EQ] = ACTIONS(9726),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9726),
    [aux_sym__assignment_operator_token1] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4445] = {
    [sym__assignment_operator] = STATE(3532),
    [sym_block_comment] = STATE(4445),
    [sym_line_comment] = STATE(4445),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9902),
    [anon_sym_DOT] = ACTIONS(9904),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
    [sym__immediate_bracket] = ACTIONS(9908),
    [sym__immediate_brace] = ACTIONS(9910),
  },
  [4446] = {
    [sym_block_comment] = STATE(4446),
    [sym_line_comment] = STATE(4446),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_else] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_COLON_EQ] = ACTIONS(10122),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10122),
    [aux_sym__assignment_operator_token1] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4447] = {
    [sym_block_comment] = STATE(4447),
    [sym_line_comment] = STATE(4447),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4448] = {
    [sym__assignment_operator] = STATE(3532),
    [sym_block_comment] = STATE(4448),
    [sym_line_comment] = STATE(4448),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9902),
    [anon_sym_DOT] = ACTIONS(9904),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
    [sym__immediate_bracket] = ACTIONS(9908),
    [sym__immediate_brace] = ACTIONS(9910),
  },
  [4449] = {
    [sym_block_comment] = STATE(4449),
    [sym_line_comment] = STATE(4449),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(10126),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4450] = {
    [sym__assignment_operator] = STATE(3823),
    [sym_block_comment] = STATE(4450),
    [sym_line_comment] = STATE(4450),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9846),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4451] = {
    [sym_block_comment] = STATE(4451),
    [sym_line_comment] = STATE(4451),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9820),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9820),
    [anon_sym_RPAREN] = ACTIONS(9820),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9820),
    [anon_sym_RBRACK] = ACTIONS(9820),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_SEMI] = ACTIONS(9820),
    [anon_sym_LBRACE] = ACTIONS(9820),
    [anon_sym_RBRACE] = ACTIONS(9820),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9820),
    [anon_sym_COLON_EQ] = ACTIONS(9820),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9820),
    [anon_sym_QMARK] = ACTIONS(9820),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9820),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9820),
    [aux_sym_integer_literal_token2] = ACTIONS(9820),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9820),
    [aux_sym_float_literal_token3] = ACTIONS(9820),
    [aux_sym_float_literal_token4] = ACTIONS(9820),
    [sym_character_literal] = ACTIONS(9820),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9820),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9820),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9820),
    [aux_sym__assignment_operator_token1] = ACTIONS(9820),
    [sym__pair_operator] = ACTIONS(9820),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9820),
    [sym__lazy_and_operator] = ACTIONS(9820),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9820),
    [sym__pipe_left_operator] = ACTIONS(9820),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9820),
    [sym__type_order_operator] = ACTIONS(9820),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4452] = {
    [sym_block_comment] = STATE(4452),
    [sym_line_comment] = STATE(4452),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_elseif] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_COLON_EQ] = ACTIONS(10032),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10032),
    [aux_sym__assignment_operator_token1] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4453] = {
    [sym_block_comment] = STATE(4453),
    [sym_line_comment] = STATE(4453),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_else] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_COLON_EQ] = ACTIONS(10128),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10128),
    [aux_sym__assignment_operator_token1] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4454] = {
    [sym_block_comment] = STATE(4454),
    [sym_line_comment] = STATE(4454),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(10132),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9658),
    [sym__immediate_command_start] = ACTIONS(9660),
  },
  [4455] = {
    [sym_block_comment] = STATE(4455),
    [sym_line_comment] = STATE(4455),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_elseif] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_COLON_EQ] = ACTIONS(10018),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10018),
    [aux_sym__assignment_operator_token1] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4456] = {
    [sym_identifier] = STATE(4809),
    [sym_block_comment] = STATE(4456),
    [sym_line_comment] = STATE(4456),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_COLON_EQ] = ACTIONS(9780),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9780),
    [aux_sym__assignment_operator_token1] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4457] = {
    [sym_identifier] = STATE(4818),
    [sym_block_comment] = STATE(4457),
    [sym_line_comment] = STATE(4457),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_COLON_EQ] = ACTIONS(9784),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9784),
    [aux_sym__assignment_operator_token1] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4458] = {
    [sym_block_comment] = STATE(4458),
    [sym_line_comment] = STATE(4458),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4459] = {
    [sym_block_comment] = STATE(4459),
    [sym_line_comment] = STATE(4459),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_COLON_EQ] = ACTIONS(10134),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10134),
    [aux_sym__assignment_operator_token1] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [4460] = {
    [sym_block_comment] = STATE(4460),
    [sym_line_comment] = STATE(4460),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_COLON_EQ] = ACTIONS(9912),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9912),
    [aux_sym__assignment_operator_token1] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [4461] = {
    [sym_identifier] = STATE(4611),
    [sym_block_comment] = STATE(4461),
    [sym_line_comment] = STATE(4461),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_COLON_EQ] = ACTIONS(9780),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9780),
    [aux_sym__assignment_operator_token1] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4462] = {
    [sym_identifier] = STATE(4612),
    [sym_block_comment] = STATE(4462),
    [sym_line_comment] = STATE(4462),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_COLON_EQ] = ACTIONS(9784),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9784),
    [aux_sym__assignment_operator_token1] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4463] = {
    [sym_identifier] = STATE(4615),
    [sym_block_comment] = STATE(4463),
    [sym_line_comment] = STATE(4463),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_COLON_EQ] = ACTIONS(9796),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9796),
    [aux_sym__assignment_operator_token1] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4464] = {
    [sym_identifier] = STATE(4616),
    [sym_block_comment] = STATE(4464),
    [sym_line_comment] = STATE(4464),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_COLON_EQ] = ACTIONS(9800),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9800),
    [aux_sym__assignment_operator_token1] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4465] = {
    [sym_block_comment] = STATE(4465),
    [sym_line_comment] = STATE(4465),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_else] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_COLON_EQ] = ACTIONS(10138),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10138),
    [aux_sym__assignment_operator_token1] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4466] = {
    [sym_block_comment] = STATE(4466),
    [sym_line_comment] = STATE(4466),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3071),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3071),
    [aux_sym__assignment_operator_token1] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4467] = {
    [sym_block_comment] = STATE(4467),
    [sym_line_comment] = STATE(4467),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_else] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_COLON_EQ] = ACTIONS(10142),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10142),
    [aux_sym__assignment_operator_token1] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4468] = {
    [sym_block_comment] = STATE(4468),
    [sym_line_comment] = STATE(4468),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4469] = {
    [sym_block_comment] = STATE(4469),
    [sym_line_comment] = STATE(4469),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10146),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4470] = {
    [sym_block_comment] = STATE(4470),
    [sym_line_comment] = STATE(4470),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9822),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9822),
    [anon_sym_RPAREN] = ACTIONS(9822),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9822),
    [anon_sym_RBRACK] = ACTIONS(9822),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_SEMI] = ACTIONS(9822),
    [anon_sym_LBRACE] = ACTIONS(9822),
    [anon_sym_RBRACE] = ACTIONS(9822),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9822),
    [anon_sym_COLON_EQ] = ACTIONS(9822),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9822),
    [anon_sym_QMARK] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9822),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9822),
    [aux_sym_integer_literal_token2] = ACTIONS(9822),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9822),
    [aux_sym_float_literal_token3] = ACTIONS(9822),
    [aux_sym_float_literal_token4] = ACTIONS(9822),
    [sym_character_literal] = ACTIONS(9822),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9822),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9822),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9822),
    [aux_sym__assignment_operator_token1] = ACTIONS(9822),
    [sym__pair_operator] = ACTIONS(9822),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9822),
    [sym__lazy_and_operator] = ACTIONS(9822),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9822),
    [sym__pipe_left_operator] = ACTIONS(9822),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9822),
    [sym__type_order_operator] = ACTIONS(9822),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4471] = {
    [sym_identifier] = STATE(4524),
    [sym_block_comment] = STATE(4471),
    [sym_line_comment] = STATE(4471),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_COLON_EQ] = ACTIONS(9796),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9796),
    [aux_sym__assignment_operator_token1] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4472] = {
    [sym__assignment_operator] = STATE(3792),
    [sym_block_comment] = STATE(4472),
    [sym_line_comment] = STATE(4472),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9856),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4473] = {
    [sym_block_comment] = STATE(4473),
    [sym_line_comment] = STATE(4473),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9826),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9826),
    [anon_sym_RPAREN] = ACTIONS(9826),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9826),
    [anon_sym_RBRACK] = ACTIONS(9826),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_SEMI] = ACTIONS(9826),
    [anon_sym_LBRACE] = ACTIONS(9826),
    [anon_sym_RBRACE] = ACTIONS(9826),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9826),
    [anon_sym_COLON_EQ] = ACTIONS(9826),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9826),
    [anon_sym_QMARK] = ACTIONS(9826),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9826),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9826),
    [aux_sym_integer_literal_token2] = ACTIONS(9826),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9826),
    [aux_sym_float_literal_token3] = ACTIONS(9826),
    [aux_sym_float_literal_token4] = ACTIONS(9826),
    [sym_character_literal] = ACTIONS(9826),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9826),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9826),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9826),
    [aux_sym__assignment_operator_token1] = ACTIONS(9826),
    [sym__pair_operator] = ACTIONS(9826),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9826),
    [sym__lazy_and_operator] = ACTIONS(9826),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9826),
    [sym__pipe_left_operator] = ACTIONS(9826),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9826),
    [sym__type_order_operator] = ACTIONS(9826),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4474] = {
    [sym_identifier] = STATE(4555),
    [sym_block_comment] = STATE(4474),
    [sym_line_comment] = STATE(4474),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_COLON_EQ] = ACTIONS(9800),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9800),
    [aux_sym__assignment_operator_token1] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4475] = {
    [sym_block_comment] = STATE(4475),
    [sym_line_comment] = STATE(4475),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(10148),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9658),
    [sym__immediate_command_start] = ACTIONS(9660),
  },
  [4476] = {
    [sym_block_comment] = STATE(4476),
    [sym_line_comment] = STATE(4476),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_catch] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_COLON_EQ] = ACTIONS(9744),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9744),
    [aux_sym__assignment_operator_token1] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4477] = {
    [sym_block_comment] = STATE(4477),
    [sym_line_comment] = STATE(4477),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10150),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4478] = {
    [sym_identifier] = STATE(4781),
    [sym_block_comment] = STATE(4478),
    [sym_line_comment] = STATE(4478),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_COLON_EQ] = ACTIONS(9780),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9780),
    [aux_sym__assignment_operator_token1] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4479] = {
    [sym_identifier] = STATE(4782),
    [sym_block_comment] = STATE(4479),
    [sym_line_comment] = STATE(4479),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_COLON_EQ] = ACTIONS(9784),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9784),
    [aux_sym__assignment_operator_token1] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4480] = {
    [sym_identifier] = STATE(4785),
    [sym_block_comment] = STATE(4480),
    [sym_line_comment] = STATE(4480),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_COLON_EQ] = ACTIONS(9796),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9796),
    [aux_sym__assignment_operator_token1] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4481] = {
    [sym_block_comment] = STATE(4481),
    [sym_line_comment] = STATE(4481),
    [ts_builtin_sym_end] = ACTIONS(9756),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_RBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_COLON_EQ] = ACTIONS(9726),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9726),
    [aux_sym__assignment_operator_token1] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4482] = {
    [sym_identifier] = STATE(4786),
    [sym_block_comment] = STATE(4482),
    [sym_line_comment] = STATE(4482),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_COLON_EQ] = ACTIONS(9800),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9800),
    [aux_sym__assignment_operator_token1] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4483] = {
    [sym_block_comment] = STATE(4483),
    [sym_line_comment] = STATE(4483),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_elseif] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_COLON_EQ] = ACTIONS(10152),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10152),
    [aux_sym__assignment_operator_token1] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [4484] = {
    [sym_block_comment] = STATE(4484),
    [sym_line_comment] = STATE(4484),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_elseif] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_COLON_EQ] = ACTIONS(10134),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10134),
    [aux_sym__assignment_operator_token1] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [4485] = {
    [sym_block_comment] = STATE(4485),
    [sym_line_comment] = STATE(4485),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9830),
    [anon_sym_RPAREN] = ACTIONS(9830),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9830),
    [anon_sym_RBRACK] = ACTIONS(9830),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_SEMI] = ACTIONS(9830),
    [anon_sym_LBRACE] = ACTIONS(9830),
    [anon_sym_RBRACE] = ACTIONS(9830),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9830),
    [anon_sym_COLON_EQ] = ACTIONS(9830),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9830),
    [anon_sym_QMARK] = ACTIONS(9830),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9830),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9830),
    [aux_sym_integer_literal_token2] = ACTIONS(9830),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9830),
    [aux_sym_float_literal_token3] = ACTIONS(9830),
    [aux_sym_float_literal_token4] = ACTIONS(9830),
    [sym_character_literal] = ACTIONS(9830),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9830),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9830),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9830),
    [aux_sym__assignment_operator_token1] = ACTIONS(9830),
    [sym__pair_operator] = ACTIONS(9830),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9830),
    [sym__lazy_and_operator] = ACTIONS(9830),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9830),
    [sym__pipe_left_operator] = ACTIONS(9830),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9830),
    [sym__type_order_operator] = ACTIONS(9830),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4486] = {
    [sym__assignment_operator] = STATE(3823),
    [sym_block_comment] = STATE(4486),
    [sym_line_comment] = STATE(4486),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9846),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4487] = {
    [sym_block_comment] = STATE(4487),
    [sym_line_comment] = STATE(4487),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_elseif] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_COLON_EQ] = ACTIONS(10036),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10036),
    [aux_sym__assignment_operator_token1] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4488] = {
    [sym_block_comment] = STATE(4488),
    [sym_line_comment] = STATE(4488),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_elseif] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_COLON_EQ] = ACTIONS(10040),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10040),
    [aux_sym__assignment_operator_token1] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4489] = {
    [sym__assignment_operator] = STATE(3319),
    [sym_block_comment] = STATE(4489),
    [sym_line_comment] = STATE(4489),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(9934),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4490] = {
    [sym_block_comment] = STATE(4490),
    [sym_line_comment] = STATE(4490),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_elseif] = ACTIONS(10102),
    [anon_sym_else] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_COLON_EQ] = ACTIONS(10102),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10102),
    [aux_sym__assignment_operator_token1] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4491] = {
    [sym_block_comment] = STATE(4491),
    [sym_line_comment] = STATE(4491),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9834),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9834),
    [anon_sym_RPAREN] = ACTIONS(9834),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9834),
    [anon_sym_RBRACK] = ACTIONS(9834),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_SEMI] = ACTIONS(9834),
    [anon_sym_LBRACE] = ACTIONS(9834),
    [anon_sym_RBRACE] = ACTIONS(9834),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9834),
    [anon_sym_COLON_EQ] = ACTIONS(9834),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9834),
    [anon_sym_QMARK] = ACTIONS(9834),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9834),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9834),
    [aux_sym_integer_literal_token2] = ACTIONS(9834),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9834),
    [aux_sym_float_literal_token3] = ACTIONS(9834),
    [aux_sym_float_literal_token4] = ACTIONS(9834),
    [sym_character_literal] = ACTIONS(9834),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9834),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9834),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9834),
    [aux_sym__assignment_operator_token1] = ACTIONS(9834),
    [sym__pair_operator] = ACTIONS(9834),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9834),
    [sym__lazy_and_operator] = ACTIONS(9834),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9834),
    [sym__pipe_left_operator] = ACTIONS(9834),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9834),
    [sym__type_order_operator] = ACTIONS(9834),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4492] = {
    [sym_block_comment] = STATE(4492),
    [sym_line_comment] = STATE(4492),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_elseif] = ACTIONS(10106),
    [anon_sym_else] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_COLON_EQ] = ACTIONS(10106),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10106),
    [aux_sym__assignment_operator_token1] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4493] = {
    [sym_block_comment] = STATE(4493),
    [sym_line_comment] = STATE(4493),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_elseif] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4494] = {
    [sym_block_comment] = STATE(4494),
    [sym_line_comment] = STATE(4494),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_elseif] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_COLON_EQ] = ACTIONS(10044),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10044),
    [aux_sym__assignment_operator_token1] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [4495] = {
    [sym_block_comment] = STATE(4495),
    [sym_line_comment] = STATE(4495),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_elseif] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_COLON_EQ] = ACTIONS(10048),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10048),
    [aux_sym__assignment_operator_token1] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [4496] = {
    [sym_block_comment] = STATE(4496),
    [sym_line_comment] = STATE(4496),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_elseif] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_COLON_EQ] = ACTIONS(10052),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10052),
    [aux_sym__assignment_operator_token1] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [4497] = {
    [sym_block_comment] = STATE(4497),
    [sym_line_comment] = STATE(4497),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_elseif] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_COLON_EQ] = ACTIONS(10056),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10056),
    [aux_sym__assignment_operator_token1] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [4498] = {
    [sym_block_comment] = STATE(4498),
    [sym_line_comment] = STATE(4498),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_elseif] = ACTIONS(10142),
    [anon_sym_else] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_COLON_EQ] = ACTIONS(10142),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10142),
    [aux_sym__assignment_operator_token1] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4499] = {
    [sym_block_comment] = STATE(4499),
    [sym_line_comment] = STATE(4499),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_elseif] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_COLON_EQ] = ACTIONS(10116),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10116),
    [aux_sym__assignment_operator_token1] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [4500] = {
    [sym_block_comment] = STATE(4500),
    [sym_line_comment] = STATE(4500),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_COLON_EQ] = ACTIONS(10152),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10152),
    [aux_sym__assignment_operator_token1] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [4501] = {
    [sym_block_comment] = STATE(4501),
    [sym_line_comment] = STATE(4501),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_elseif] = ACTIONS(10122),
    [anon_sym_else] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_COLON_EQ] = ACTIONS(10122),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10122),
    [aux_sym__assignment_operator_token1] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4502] = {
    [sym_block_comment] = STATE(4502),
    [sym_line_comment] = STATE(4502),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9838),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9838),
    [anon_sym_RPAREN] = ACTIONS(9838),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9838),
    [anon_sym_RBRACK] = ACTIONS(9838),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_SEMI] = ACTIONS(9838),
    [anon_sym_LBRACE] = ACTIONS(9838),
    [anon_sym_RBRACE] = ACTIONS(9838),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9838),
    [anon_sym_COLON_EQ] = ACTIONS(9838),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9838),
    [anon_sym_QMARK] = ACTIONS(9838),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9838),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9838),
    [aux_sym_integer_literal_token2] = ACTIONS(9838),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9838),
    [aux_sym_float_literal_token3] = ACTIONS(9838),
    [aux_sym_float_literal_token4] = ACTIONS(9838),
    [sym_character_literal] = ACTIONS(9838),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9838),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9838),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9838),
    [aux_sym__assignment_operator_token1] = ACTIONS(9838),
    [sym__pair_operator] = ACTIONS(9838),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9838),
    [sym__lazy_and_operator] = ACTIONS(9838),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9838),
    [sym__pipe_left_operator] = ACTIONS(9838),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9838),
    [sym__type_order_operator] = ACTIONS(9838),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4503] = {
    [sym_block_comment] = STATE(4503),
    [sym_line_comment] = STATE(4503),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_elseif] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4504] = {
    [sym_block_comment] = STATE(4504),
    [sym_line_comment] = STATE(4504),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_elseif] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_COLON_EQ] = ACTIONS(10000),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10000),
    [aux_sym__assignment_operator_token1] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4505] = {
    [sym_block_comment] = STATE(4505),
    [sym_line_comment] = STATE(4505),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_elseif] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_COLON_EQ] = ACTIONS(10004),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10004),
    [aux_sym__assignment_operator_token1] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4506] = {
    [sym_block_comment] = STATE(4506),
    [sym_line_comment] = STATE(4506),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [4507] = {
    [sym_block_comment] = STATE(4507),
    [sym_line_comment] = STATE(4507),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_elseif] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_COLON_EQ] = ACTIONS(10060),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10060),
    [aux_sym__assignment_operator_token1] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4508] = {
    [sym_block_comment] = STATE(4508),
    [sym_line_comment] = STATE(4508),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_elseif] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_COLON_EQ] = ACTIONS(10064),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10064),
    [aux_sym__assignment_operator_token1] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4509] = {
    [sym_block_comment] = STATE(4509),
    [sym_line_comment] = STATE(4509),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_elseif] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_COLON_EQ] = ACTIONS(10068),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10068),
    [aux_sym__assignment_operator_token1] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4510] = {
    [sym_block_comment] = STATE(4510),
    [sym_line_comment] = STATE(4510),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_elseif] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_COLON_EQ] = ACTIONS(10072),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10072),
    [aux_sym__assignment_operator_token1] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4511] = {
    [sym_block_comment] = STATE(4511),
    [sym_line_comment] = STATE(4511),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_elseif] = ACTIONS(10128),
    [anon_sym_else] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_COLON_EQ] = ACTIONS(10128),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10128),
    [aux_sym__assignment_operator_token1] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4512] = {
    [sym_block_comment] = STATE(4512),
    [sym_line_comment] = STATE(4512),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_elseif] = ACTIONS(10138),
    [anon_sym_else] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_COLON_EQ] = ACTIONS(10138),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10138),
    [aux_sym__assignment_operator_token1] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4513] = {
    [sym_block_comment] = STATE(4513),
    [sym_line_comment] = STATE(4513),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_elseif] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_COLON_EQ] = ACTIONS(10076),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10076),
    [aux_sym__assignment_operator_token1] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4514] = {
    [sym_block_comment] = STATE(4514),
    [sym_line_comment] = STATE(4514),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_elseif] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_COLON_EQ] = ACTIONS(10080),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10080),
    [aux_sym__assignment_operator_token1] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4515] = {
    [sym_identifier] = STATE(4523),
    [sym_block_comment] = STATE(4515),
    [sym_line_comment] = STATE(4515),
    [ts_builtin_sym_end] = ACTIONS(9782),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_RBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_COLON_EQ] = ACTIONS(9780),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9780),
    [aux_sym__assignment_operator_token1] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4516] = {
    [sym_block_comment] = STATE(4516),
    [sym_line_comment] = STATE(4516),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3071),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3071),
    [aux_sym__assignment_operator_token1] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4517] = {
    [sym_block_comment] = STATE(4517),
    [sym_line_comment] = STATE(4517),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_RPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_RBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_SEMI] = ACTIONS(9960),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_RBRACE] = ACTIONS(9960),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_COLON_EQ] = ACTIONS(9960),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9960),
    [aux_sym__assignment_operator_token1] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [4518] = {
    [sym_block_comment] = STATE(4518),
    [sym_line_comment] = STATE(4518),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_COLON_EQ] = ACTIONS(9926),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9926),
    [aux_sym__assignment_operator_token1] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4519] = {
    [sym_block_comment] = STATE(4519),
    [sym_line_comment] = STATE(4519),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_COLON_EQ] = ACTIONS(10044),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10044),
    [aux_sym__assignment_operator_token1] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [4520] = {
    [sym_block_comment] = STATE(4520),
    [sym_line_comment] = STATE(4520),
    [ts_builtin_sym_end] = ACTIONS(9928),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_RBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_COLON_EQ] = ACTIONS(9926),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9926),
    [aux_sym__assignment_operator_token1] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4521] = {
    [sym_block_comment] = STATE(4521),
    [sym_line_comment] = STATE(4521),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4522] = {
    [sym_block_comment] = STATE(4522),
    [sym_line_comment] = STATE(4522),
    [ts_builtin_sym_end] = ACTIONS(9704),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_RBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4523] = {
    [sym_block_comment] = STATE(4523),
    [sym_line_comment] = STATE(4523),
    [ts_builtin_sym_end] = ACTIONS(10062),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_RBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_COLON_EQ] = ACTIONS(10060),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10060),
    [aux_sym__assignment_operator_token1] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4524] = {
    [sym_block_comment] = STATE(4524),
    [sym_line_comment] = STATE(4524),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_COLON_EQ] = ACTIONS(10076),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10076),
    [aux_sym__assignment_operator_token1] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4525] = {
    [sym_block_comment] = STATE(4525),
    [sym_line_comment] = STATE(4525),
    [ts_builtin_sym_end] = ACTIONS(10066),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_RBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_COLON_EQ] = ACTIONS(10064),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10064),
    [aux_sym__assignment_operator_token1] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4526] = {
    [sym_block_comment] = STATE(4526),
    [sym_line_comment] = STATE(4526),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_COLON_EQ] = ACTIONS(10048),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10048),
    [aux_sym__assignment_operator_token1] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [4527] = {
    [sym_block_comment] = STATE(4527),
    [sym_line_comment] = STATE(4527),
    [ts_builtin_sym_end] = ACTIONS(10002),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_RBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_COLON_EQ] = ACTIONS(10000),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10000),
    [aux_sym__assignment_operator_token1] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4528] = {
    [sym_block_comment] = STATE(4528),
    [sym_line_comment] = STATE(4528),
    [ts_builtin_sym_end] = ACTIONS(10074),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_RBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_COLON_EQ] = ACTIONS(10072),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10072),
    [aux_sym__assignment_operator_token1] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4529] = {
    [sym_block_comment] = STATE(4529),
    [sym_line_comment] = STATE(4529),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4530] = {
    [sym_block_comment] = STATE(4530),
    [sym_line_comment] = STATE(4530),
    [ts_builtin_sym_end] = ACTIONS(10130),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_RBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_COLON_EQ] = ACTIONS(10128),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10128),
    [aux_sym__assignment_operator_token1] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4531] = {
    [sym_block_comment] = STATE(4531),
    [sym_line_comment] = STATE(4531),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4532] = {
    [sym_block_comment] = STATE(4532),
    [sym_line_comment] = STATE(4532),
    [ts_builtin_sym_end] = ACTIONS(10140),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_RBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_COLON_EQ] = ACTIONS(10138),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10138),
    [aux_sym__assignment_operator_token1] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4533] = {
    [sym_block_comment] = STATE(4533),
    [sym_line_comment] = STATE(4533),
    [ts_builtin_sym_end] = ACTIONS(10078),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_RBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_COLON_EQ] = ACTIONS(10076),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10076),
    [aux_sym__assignment_operator_token1] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4534] = {
    [sym_block_comment] = STATE(4534),
    [sym_line_comment] = STATE(4534),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4535] = {
    [sym_block_comment] = STATE(4535),
    [sym_line_comment] = STATE(4535),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4536] = {
    [sym_block_comment] = STATE(4536),
    [sym_line_comment] = STATE(4536),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_COLON_EQ] = ACTIONS(9752),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9752),
    [aux_sym__assignment_operator_token1] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4537] = {
    [sym_block_comment] = STATE(4537),
    [sym_line_comment] = STATE(4537),
    [ts_builtin_sym_end] = ACTIONS(10082),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_RBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_COLON_EQ] = ACTIONS(10080),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10080),
    [aux_sym__assignment_operator_token1] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4538] = {
    [sym_block_comment] = STATE(4538),
    [sym_line_comment] = STATE(4538),
    [ts_builtin_sym_end] = ACTIONS(10144),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_RBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_COLON_EQ] = ACTIONS(10142),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10142),
    [aux_sym__assignment_operator_token1] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4539] = {
    [sym_block_comment] = STATE(4539),
    [sym_line_comment] = STATE(4539),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_catch] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_COLON_EQ] = ACTIONS(9954),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9954),
    [aux_sym__assignment_operator_token1] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4540] = {
    [sym_block_comment] = STATE(4540),
    [sym_line_comment] = STATE(4540),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_catch] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_COLON_EQ] = ACTIONS(9962),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9962),
    [aux_sym__assignment_operator_token1] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4541] = {
    [sym_block_comment] = STATE(4541),
    [sym_line_comment] = STATE(4541),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [4542] = {
    [sym_block_comment] = STATE(4542),
    [sym_line_comment] = STATE(4542),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4543] = {
    [sym_block_comment] = STATE(4543),
    [sym_line_comment] = STATE(4543),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4544] = {
    [sym_block_comment] = STATE(4544),
    [sym_line_comment] = STATE(4544),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4545] = {
    [sym_block_comment] = STATE(4545),
    [sym_line_comment] = STATE(4545),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4546] = {
    [sym_block_comment] = STATE(4546),
    [sym_line_comment] = STATE(4546),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_COLON_EQ] = ACTIONS(9810),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9810),
    [aux_sym__assignment_operator_token1] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4547] = {
    [sym_block_comment] = STATE(4547),
    [sym_line_comment] = STATE(4547),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10156),
    [sym__immediate_command_start] = ACTIONS(10158),
  },
  [4548] = {
    [sym_block_comment] = STATE(4548),
    [sym_line_comment] = STATE(4548),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4549] = {
    [sym_block_comment] = STATE(4549),
    [sym_line_comment] = STATE(4549),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9980),
    [anon_sym_RPAREN] = ACTIONS(9980),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9980),
    [anon_sym_RBRACK] = ACTIONS(9980),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_SEMI] = ACTIONS(9980),
    [anon_sym_LBRACE] = ACTIONS(9980),
    [anon_sym_RBRACE] = ACTIONS(9980),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9980),
    [anon_sym_COLON_EQ] = ACTIONS(9980),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9980),
    [anon_sym_QMARK] = ACTIONS(9980),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9980),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9980),
    [aux_sym_integer_literal_token2] = ACTIONS(9980),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9980),
    [aux_sym_float_literal_token3] = ACTIONS(9980),
    [aux_sym_float_literal_token4] = ACTIONS(9980),
    [sym_character_literal] = ACTIONS(9980),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9980),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9980),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9980),
    [aux_sym__assignment_operator_token1] = ACTIONS(9980),
    [sym__pair_operator] = ACTIONS(9980),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9980),
    [sym__lazy_and_operator] = ACTIONS(9980),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9980),
    [sym__pipe_left_operator] = ACTIONS(9980),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9980),
    [sym__type_order_operator] = ACTIONS(9980),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4550] = {
    [sym_block_comment] = STATE(4550),
    [sym_line_comment] = STATE(4550),
    [ts_builtin_sym_end] = ACTIONS(10154),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_RBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_COLON_EQ] = ACTIONS(10152),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10152),
    [aux_sym__assignment_operator_token1] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [4551] = {
    [sym_block_comment] = STATE(4551),
    [sym_line_comment] = STATE(4551),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4552] = {
    [sym_block_comment] = STATE(4552),
    [sym_line_comment] = STATE(4552),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(10160),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10162),
    [sym__immediate_command_start] = ACTIONS(10164),
  },
  [4553] = {
    [sym_block_comment] = STATE(4553),
    [sym_line_comment] = STATE(4553),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_COLON_EQ] = ACTIONS(10052),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10052),
    [aux_sym__assignment_operator_token1] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [4554] = {
    [sym_block_comment] = STATE(4554),
    [sym_line_comment] = STATE(4554),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_COLON_EQ] = ACTIONS(9814),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9814),
    [aux_sym__assignment_operator_token1] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4555] = {
    [sym_block_comment] = STATE(4555),
    [sym_line_comment] = STATE(4555),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_COLON_EQ] = ACTIONS(10080),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10080),
    [aux_sym__assignment_operator_token1] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4556] = {
    [sym_block_comment] = STATE(4556),
    [sym_line_comment] = STATE(4556),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_catch] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_COLON_EQ] = ACTIONS(10102),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10102),
    [aux_sym__assignment_operator_token1] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4557] = {
    [sym_block_comment] = STATE(4557),
    [sym_line_comment] = STATE(4557),
    [ts_builtin_sym_end] = ACTIONS(9956),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_RBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_COLON_EQ] = ACTIONS(9954),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9954),
    [aux_sym__assignment_operator_token1] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4558] = {
    [sym_block_comment] = STATE(4558),
    [sym_line_comment] = STATE(4558),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_catch] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_COLON_EQ] = ACTIONS(10106),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10106),
    [aux_sym__assignment_operator_token1] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4559] = {
    [sym__assignment_operator] = STATE(3343),
    [sym_block_comment] = STATE(4559),
    [sym_line_comment] = STATE(4559),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10168),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4560] = {
    [sym_block_comment] = STATE(4560),
    [sym_line_comment] = STATE(4560),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4561] = {
    [sym_block_comment] = STATE(4561),
    [sym_line_comment] = STATE(4561),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_COLON_EQ] = ACTIONS(10116),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10116),
    [aux_sym__assignment_operator_token1] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [4562] = {
    [sym_block_comment] = STATE(4562),
    [sym_line_comment] = STATE(4562),
    [ts_builtin_sym_end] = ACTIONS(9964),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_RBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_COLON_EQ] = ACTIONS(9962),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9962),
    [aux_sym__assignment_operator_token1] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4563] = {
    [sym_block_comment] = STATE(4563),
    [sym_line_comment] = STATE(4563),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_catch] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_COLON_EQ] = ACTIONS(10122),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10122),
    [aux_sym__assignment_operator_token1] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4564] = {
    [sym_block_comment] = STATE(4564),
    [sym_line_comment] = STATE(4564),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_COLON_EQ] = ACTIONS(9664),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9664),
    [aux_sym__assignment_operator_token1] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [4565] = {
    [sym_block_comment] = STATE(4565),
    [sym_line_comment] = STATE(4565),
    [ts_builtin_sym_end] = ACTIONS(9708),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_RBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [4566] = {
    [sym_block_comment] = STATE(4566),
    [sym_line_comment] = STATE(4566),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4567] = {
    [sym_block_comment] = STATE(4567),
    [sym_line_comment] = STATE(4567),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_catch] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_COLON_EQ] = ACTIONS(10128),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10128),
    [aux_sym__assignment_operator_token1] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4568] = {
    [sym__assignment_operator] = STATE(3305),
    [sym_block_comment] = STATE(4568),
    [sym_line_comment] = STATE(4568),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10178),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4569] = {
    [sym_block_comment] = STATE(4569),
    [sym_line_comment] = STATE(4569),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_catch] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_COLON_EQ] = ACTIONS(10138),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10138),
    [aux_sym__assignment_operator_token1] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4570] = {
    [sym_block_comment] = STATE(4570),
    [sym_line_comment] = STATE(4570),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_catch] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_COLON_EQ] = ACTIONS(10142),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10142),
    [aux_sym__assignment_operator_token1] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4571] = {
    [sym_block_comment] = STATE(4571),
    [sym_line_comment] = STATE(4571),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_COLON_EQ] = ACTIONS(9990),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9990),
    [aux_sym__assignment_operator_token1] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4572] = {
    [sym_block_comment] = STATE(4572),
    [sym_line_comment] = STATE(4572),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_COLON_EQ] = ACTIONS(9994),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9994),
    [aux_sym__assignment_operator_token1] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4573] = {
    [sym__assignment_operator] = STATE(3343),
    [sym_block_comment] = STATE(4573),
    [sym_line_comment] = STATE(4573),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10168),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4574] = {
    [sym__assignment_operator] = STATE(3305),
    [sym_block_comment] = STATE(4574),
    [sym_line_comment] = STATE(4574),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10178),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4575] = {
    [sym_block_comment] = STATE(4575),
    [sym_line_comment] = STATE(4575),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_COLON_EQ] = ACTIONS(9958),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9958),
    [aux_sym__assignment_operator_token1] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [4576] = {
    [sym__assignment_operator] = STATE(3691),
    [sym_block_comment] = STATE(4576),
    [sym_line_comment] = STATE(4576),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(10024),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4577] = {
    [sym_block_comment] = STATE(4577),
    [sym_line_comment] = STATE(4577),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_COLON_EQ] = ACTIONS(10152),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10152),
    [aux_sym__assignment_operator_token1] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [4578] = {
    [sym_block_comment] = STATE(4578),
    [sym_line_comment] = STATE(4578),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_COLON_EQ] = ACTIONS(9734),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9734),
    [aux_sym__assignment_operator_token1] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4579] = {
    [sym_block_comment] = STATE(4579),
    [sym_line_comment] = STATE(4579),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_RPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_RBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_SEMI] = ACTIONS(10136),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_RBRACE] = ACTIONS(10136),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_COLON_EQ] = ACTIONS(10136),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10136),
    [aux_sym__assignment_operator_token1] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [4580] = {
    [sym_block_comment] = STATE(4580),
    [sym_line_comment] = STATE(4580),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_COLON_EQ] = ACTIONS(9982),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9982),
    [aux_sym__assignment_operator_token1] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4581] = {
    [sym_block_comment] = STATE(4581),
    [sym_line_comment] = STATE(4581),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3071),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3071),
    [aux_sym__assignment_operator_token1] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4582] = {
    [sym_block_comment] = STATE(4582),
    [sym_line_comment] = STATE(4582),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_COLON_EQ] = ACTIONS(9986),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9986),
    [aux_sym__assignment_operator_token1] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4583] = {
    [sym_block_comment] = STATE(4583),
    [sym_line_comment] = STATE(4583),
    [ts_builtin_sym_end] = ACTIONS(10006),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_RBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_COLON_EQ] = ACTIONS(10004),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10004),
    [aux_sym__assignment_operator_token1] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4584] = {
    [sym_block_comment] = STATE(4584),
    [sym_line_comment] = STATE(4584),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_COLON_EQ] = ACTIONS(10000),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10000),
    [aux_sym__assignment_operator_token1] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4585] = {
    [sym_block_comment] = STATE(4585),
    [sym_line_comment] = STATE(4585),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_COLON_EQ] = ACTIONS(10004),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10004),
    [aux_sym__assignment_operator_token1] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4586] = {
    [sym_block_comment] = STATE(4586),
    [sym_line_comment] = STATE(4586),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_RPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_RBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_SEMI] = ACTIONS(9914),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_RBRACE] = ACTIONS(9914),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_COLON_EQ] = ACTIONS(9914),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9914),
    [aux_sym__assignment_operator_token1] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [4587] = {
    [sym_block_comment] = STATE(4587),
    [sym_line_comment] = STATE(4587),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4588] = {
    [sym_block_comment] = STATE(4588),
    [sym_line_comment] = STATE(4588),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_COLON_EQ] = ACTIONS(10010),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10010),
    [aux_sym__assignment_operator_token1] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [4589] = {
    [sym_block_comment] = STATE(4589),
    [sym_line_comment] = STATE(4589),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_COLON_EQ] = ACTIONS(10014),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10014),
    [aux_sym__assignment_operator_token1] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [4590] = {
    [sym_block_comment] = STATE(4590),
    [sym_line_comment] = STATE(4590),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_COLON_EQ] = ACTIONS(10018),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10018),
    [aux_sym__assignment_operator_token1] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4591] = {
    [sym_block_comment] = STATE(4591),
    [sym_line_comment] = STATE(4591),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_COLON_EQ] = ACTIONS(9916),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9916),
    [aux_sym__assignment_operator_token1] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4592] = {
    [sym__assignment_operator] = STATE(2971),
    [sym_block_comment] = STATE(4592),
    [sym_line_comment] = STATE(4592),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9944),
    [anon_sym_DOT] = ACTIONS(9946),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
    [sym__immediate_bracket] = ACTIONS(9950),
    [sym__immediate_brace] = ACTIONS(9952),
  },
  [4593] = {
    [sym_block_comment] = STATE(4593),
    [sym_line_comment] = STATE(4593),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_COLON_EQ] = ACTIONS(9920),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9920),
    [aux_sym__assignment_operator_token1] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4594] = {
    [sym_block_comment] = STATE(4594),
    [sym_line_comment] = STATE(4594),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(10186),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10162),
    [sym__immediate_command_start] = ACTIONS(10164),
  },
  [4595] = {
    [sym__assignment_operator] = STATE(3036),
    [sym_block_comment] = STATE(4595),
    [sym_line_comment] = STATE(4595),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9968),
    [anon_sym_DOT] = ACTIONS(9970),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
    [sym__immediate_bracket] = ACTIONS(9974),
    [sym__immediate_brace] = ACTIONS(9976),
  },
  [4596] = {
    [sym__assignment_operator] = STATE(3127),
    [sym_block_comment] = STATE(4596),
    [sym_line_comment] = STATE(4596),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9902),
    [anon_sym_DOT] = ACTIONS(10114),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
    [sym__immediate_bracket] = ACTIONS(9908),
    [sym__immediate_brace] = ACTIONS(9910),
  },
  [4597] = {
    [sym_block_comment] = STATE(4597),
    [sym_line_comment] = STATE(4597),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_COLON_EQ] = ACTIONS(9990),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9990),
    [aux_sym__assignment_operator_token1] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4598] = {
    [sym_block_comment] = STATE(4598),
    [sym_line_comment] = STATE(4598),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_COLON_EQ] = ACTIONS(9994),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9994),
    [aux_sym__assignment_operator_token1] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4599] = {
    [sym_block_comment] = STATE(4599),
    [sym_line_comment] = STATE(4599),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4600] = {
    [sym_block_comment] = STATE(4600),
    [sym_line_comment] = STATE(4600),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4601] = {
    [sym_block_comment] = STATE(4601),
    [sym_line_comment] = STATE(4601),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_COLON_EQ] = ACTIONS(10028),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10028),
    [aux_sym__assignment_operator_token1] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4602] = {
    [sym_block_comment] = STATE(4602),
    [sym_line_comment] = STATE(4602),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_COLON_EQ] = ACTIONS(10032),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10032),
    [aux_sym__assignment_operator_token1] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4603] = {
    [sym_block_comment] = STATE(4603),
    [sym_line_comment] = STATE(4603),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_COLON_EQ] = ACTIONS(10036),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10036),
    [aux_sym__assignment_operator_token1] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4604] = {
    [sym_block_comment] = STATE(4604),
    [sym_line_comment] = STATE(4604),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_COLON_EQ] = ACTIONS(10040),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10040),
    [aux_sym__assignment_operator_token1] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4605] = {
    [sym_block_comment] = STATE(4605),
    [sym_line_comment] = STATE(4605),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4606] = {
    [sym_block_comment] = STATE(4606),
    [sym_line_comment] = STATE(4606),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_COLON_EQ] = ACTIONS(10044),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10044),
    [aux_sym__assignment_operator_token1] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [4607] = {
    [sym_block_comment] = STATE(4607),
    [sym_line_comment] = STATE(4607),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_COLON_EQ] = ACTIONS(10048),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10048),
    [aux_sym__assignment_operator_token1] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [4608] = {
    [sym_block_comment] = STATE(4608),
    [sym_line_comment] = STATE(4608),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_COLON_EQ] = ACTIONS(10052),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10052),
    [aux_sym__assignment_operator_token1] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [4609] = {
    [sym_block_comment] = STATE(4609),
    [sym_line_comment] = STATE(4609),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_COLON_EQ] = ACTIONS(10056),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10056),
    [aux_sym__assignment_operator_token1] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [4610] = {
    [sym_block_comment] = STATE(4610),
    [sym_line_comment] = STATE(4610),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_COLON_EQ] = ACTIONS(9898),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9898),
    [aux_sym__assignment_operator_token1] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [4611] = {
    [sym_block_comment] = STATE(4611),
    [sym_line_comment] = STATE(4611),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_COLON_EQ] = ACTIONS(10060),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10060),
    [aux_sym__assignment_operator_token1] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4612] = {
    [sym_block_comment] = STATE(4612),
    [sym_line_comment] = STATE(4612),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_COLON_EQ] = ACTIONS(10064),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10064),
    [aux_sym__assignment_operator_token1] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4613] = {
    [sym_block_comment] = STATE(4613),
    [sym_line_comment] = STATE(4613),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_COLON_EQ] = ACTIONS(10068),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10068),
    [aux_sym__assignment_operator_token1] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4614] = {
    [sym_block_comment] = STATE(4614),
    [sym_line_comment] = STATE(4614),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_COLON_EQ] = ACTIONS(10072),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10072),
    [aux_sym__assignment_operator_token1] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4615] = {
    [sym_block_comment] = STATE(4615),
    [sym_line_comment] = STATE(4615),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_COLON_EQ] = ACTIONS(10076),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10076),
    [aux_sym__assignment_operator_token1] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4616] = {
    [sym_block_comment] = STATE(4616),
    [sym_line_comment] = STATE(4616),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_COLON_EQ] = ACTIONS(10080),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10080),
    [aux_sym__assignment_operator_token1] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4617] = {
    [sym_block_comment] = STATE(4617),
    [sym_line_comment] = STATE(4617),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_COLON_EQ] = ACTIONS(9978),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9978),
    [aux_sym__assignment_operator_token1] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4618] = {
    [sym_block_comment] = STATE(4618),
    [sym_line_comment] = STATE(4618),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_COLON_EQ] = ACTIONS(10028),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10028),
    [aux_sym__assignment_operator_token1] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4619] = {
    [sym_block_comment] = STATE(4619),
    [sym_line_comment] = STATE(4619),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4620] = {
    [sym_block_comment] = STATE(4620),
    [sym_line_comment] = STATE(4620),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_catch] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_COLON_EQ] = ACTIONS(10086),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10086),
    [aux_sym__assignment_operator_token1] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4621] = {
    [sym_block_comment] = STATE(4621),
    [sym_line_comment] = STATE(4621),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_COLON_EQ] = ACTIONS(9954),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9954),
    [aux_sym__assignment_operator_token1] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4622] = {
    [sym_block_comment] = STATE(4622),
    [sym_line_comment] = STATE(4622),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_COLON_EQ] = ACTIONS(9962),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9962),
    [aux_sym__assignment_operator_token1] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4623] = {
    [sym_block_comment] = STATE(4623),
    [sym_line_comment] = STATE(4623),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [4624] = {
    [sym_block_comment] = STATE(4624),
    [sym_line_comment] = STATE(4624),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_COLON_EQ] = ACTIONS(9726),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9726),
    [aux_sym__assignment_operator_token1] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4625] = {
    [sym_block_comment] = STATE(4625),
    [sym_line_comment] = STATE(4625),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_COLON_EQ] = ACTIONS(10032),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10032),
    [aux_sym__assignment_operator_token1] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4626] = {
    [sym_block_comment] = STATE(4626),
    [sym_line_comment] = STATE(4626),
    [ts_builtin_sym_end] = ACTIONS(9712),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_RBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4627] = {
    [sym_block_comment] = STATE(4627),
    [sym_line_comment] = STATE(4627),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4628] = {
    [sym_block_comment] = STATE(4628),
    [sym_line_comment] = STATE(4628),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10188),
    [sym__immediate_command_start] = ACTIONS(10190),
  },
  [4629] = {
    [sym_block_comment] = STATE(4629),
    [sym_line_comment] = STATE(4629),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_COLON_EQ] = ACTIONS(10102),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10102),
    [aux_sym__assignment_operator_token1] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4630] = {
    [sym_block_comment] = STATE(4630),
    [sym_line_comment] = STATE(4630),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10088),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10088),
    [anon_sym_RPAREN] = ACTIONS(10088),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10088),
    [anon_sym_RBRACK] = ACTIONS(10088),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_SEMI] = ACTIONS(10088),
    [anon_sym_LBRACE] = ACTIONS(10088),
    [anon_sym_RBRACE] = ACTIONS(10088),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10088),
    [anon_sym_COLON_EQ] = ACTIONS(10088),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10088),
    [anon_sym_QMARK] = ACTIONS(10088),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10088),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10088),
    [aux_sym_integer_literal_token2] = ACTIONS(10088),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10088),
    [aux_sym_float_literal_token3] = ACTIONS(10088),
    [aux_sym_float_literal_token4] = ACTIONS(10088),
    [sym_character_literal] = ACTIONS(10088),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10088),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10088),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10088),
    [aux_sym__assignment_operator_token1] = ACTIONS(10088),
    [sym__pair_operator] = ACTIONS(10088),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10088),
    [sym__lazy_and_operator] = ACTIONS(10088),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10088),
    [sym__pipe_left_operator] = ACTIONS(10088),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10088),
    [sym__type_order_operator] = ACTIONS(10088),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4631] = {
    [sym_block_comment] = STATE(4631),
    [sym_line_comment] = STATE(4631),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_COLON_EQ] = ACTIONS(10106),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10106),
    [aux_sym__assignment_operator_token1] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4632] = {
    [sym_block_comment] = STATE(4632),
    [sym_line_comment] = STATE(4632),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_COLON_EQ] = ACTIONS(10036),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10036),
    [aux_sym__assignment_operator_token1] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4633] = {
    [sym_block_comment] = STATE(4633),
    [sym_line_comment] = STATE(4633),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_COLON_EQ] = ACTIONS(10122),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10122),
    [aux_sym__assignment_operator_token1] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4634] = {
    [sym_block_comment] = STATE(4634),
    [sym_line_comment] = STATE(4634),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_COLON_EQ] = ACTIONS(10040),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10040),
    [aux_sym__assignment_operator_token1] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4635] = {
    [sym_block_comment] = STATE(4635),
    [sym_line_comment] = STATE(4635),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4636] = {
    [sym_block_comment] = STATE(4636),
    [sym_line_comment] = STATE(4636),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_COLON_EQ] = ACTIONS(10128),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10128),
    [aux_sym__assignment_operator_token1] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4637] = {
    [sym_block_comment] = STATE(4637),
    [sym_line_comment] = STATE(4637),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_COLON_EQ] = ACTIONS(10138),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10138),
    [aux_sym__assignment_operator_token1] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4638] = {
    [sym_block_comment] = STATE(4638),
    [sym_line_comment] = STATE(4638),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_COLON_EQ] = ACTIONS(10142),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10142),
    [aux_sym__assignment_operator_token1] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4639] = {
    [sym_block_comment] = STATE(4639),
    [sym_line_comment] = STATE(4639),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_COLON_EQ] = ACTIONS(10056),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10056),
    [aux_sym__assignment_operator_token1] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [4640] = {
    [sym_block_comment] = STATE(4640),
    [sym_line_comment] = STATE(4640),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_COLON_EQ] = ACTIONS(9898),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9898),
    [aux_sym__assignment_operator_token1] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [4641] = {
    [sym_block_comment] = STATE(4641),
    [sym_line_comment] = STATE(4641),
    [ts_builtin_sym_end] = ACTIONS(9992),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_RBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_COLON_EQ] = ACTIONS(9990),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9990),
    [aux_sym__assignment_operator_token1] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4642] = {
    [sym_block_comment] = STATE(4642),
    [sym_line_comment] = STATE(4642),
    [ts_builtin_sym_end] = ACTIONS(9996),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_RBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_COLON_EQ] = ACTIONS(9994),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9994),
    [aux_sym__assignment_operator_token1] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4643] = {
    [sym_identifier] = STATE(4878),
    [sym_block_comment] = STATE(4643),
    [sym_line_comment] = STATE(4643),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_COLON_EQ] = ACTIONS(9780),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9780),
    [aux_sym__assignment_operator_token1] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4644] = {
    [sym_identifier] = STATE(4882),
    [sym_block_comment] = STATE(4644),
    [sym_line_comment] = STATE(4644),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_COLON_EQ] = ACTIONS(9784),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9784),
    [aux_sym__assignment_operator_token1] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4645] = {
    [sym_block_comment] = STATE(4645),
    [sym_line_comment] = STATE(4645),
    [ts_builtin_sym_end] = ACTIONS(10088),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_RBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_COLON_EQ] = ACTIONS(10086),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10086),
    [aux_sym__assignment_operator_token1] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4646] = {
    [sym_block_comment] = STATE(4646),
    [sym_line_comment] = STATE(4646),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_COLON_EQ] = ACTIONS(9738),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9738),
    [aux_sym__assignment_operator_token1] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4647] = {
    [sym_block_comment] = STATE(4647),
    [sym_line_comment] = STATE(4647),
    [ts_builtin_sym_end] = ACTIONS(9762),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_RBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4648] = {
    [sym_block_comment] = STATE(4648),
    [sym_line_comment] = STATE(4648),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_RPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_RBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_SEMI] = ACTIONS(9928),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_RBRACE] = ACTIONS(9928),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_COLON_EQ] = ACTIONS(9928),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9928),
    [aux_sym__assignment_operator_token1] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4649] = {
    [sym_block_comment] = STATE(4649),
    [sym_line_comment] = STATE(4649),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9956),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9956),
    [anon_sym_RPAREN] = ACTIONS(9956),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9956),
    [anon_sym_RBRACK] = ACTIONS(9956),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_SEMI] = ACTIONS(9956),
    [anon_sym_LBRACE] = ACTIONS(9956),
    [anon_sym_RBRACE] = ACTIONS(9956),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9956),
    [anon_sym_COLON_EQ] = ACTIONS(9956),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9956),
    [anon_sym_QMARK] = ACTIONS(9956),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9956),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9956),
    [aux_sym_integer_literal_token2] = ACTIONS(9956),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9956),
    [aux_sym_float_literal_token3] = ACTIONS(9956),
    [aux_sym_float_literal_token4] = ACTIONS(9956),
    [sym_character_literal] = ACTIONS(9956),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9956),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9956),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9956),
    [aux_sym__assignment_operator_token1] = ACTIONS(9956),
    [sym__pair_operator] = ACTIONS(9956),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9956),
    [sym__lazy_and_operator] = ACTIONS(9956),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9956),
    [sym__pipe_left_operator] = ACTIONS(9956),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9956),
    [sym__type_order_operator] = ACTIONS(9956),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4650] = {
    [sym_block_comment] = STATE(4650),
    [sym_line_comment] = STATE(4650),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_COLON_EQ] = ACTIONS(10000),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10000),
    [aux_sym__assignment_operator_token1] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4651] = {
    [sym_block_comment] = STATE(4651),
    [sym_line_comment] = STATE(4651),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9964),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9964),
    [anon_sym_RPAREN] = ACTIONS(9964),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9964),
    [anon_sym_RBRACK] = ACTIONS(9964),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_SEMI] = ACTIONS(9964),
    [anon_sym_LBRACE] = ACTIONS(9964),
    [anon_sym_RBRACE] = ACTIONS(9964),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9964),
    [anon_sym_COLON_EQ] = ACTIONS(9964),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9964),
    [anon_sym_QMARK] = ACTIONS(9964),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9964),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9964),
    [aux_sym_integer_literal_token2] = ACTIONS(9964),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9964),
    [aux_sym_float_literal_token3] = ACTIONS(9964),
    [aux_sym_float_literal_token4] = ACTIONS(9964),
    [sym_character_literal] = ACTIONS(9964),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9964),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9964),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9964),
    [aux_sym__assignment_operator_token1] = ACTIONS(9964),
    [sym__pair_operator] = ACTIONS(9964),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9964),
    [sym__lazy_and_operator] = ACTIONS(9964),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9964),
    [sym__pipe_left_operator] = ACTIONS(9964),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9964),
    [sym__type_order_operator] = ACTIONS(9964),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4652] = {
    [sym_block_comment] = STATE(4652),
    [sym_line_comment] = STATE(4652),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_RBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_SEMI] = ACTIONS(9708),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_COLON_EQ] = ACTIONS(9708),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9708),
    [aux_sym__assignment_operator_token1] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [4653] = {
    [sym_block_comment] = STATE(4653),
    [sym_line_comment] = STATE(4653),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4654] = {
    [sym_block_comment] = STATE(4654),
    [sym_line_comment] = STATE(4654),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_RBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_SEMI] = ACTIONS(9712),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_COLON_EQ] = ACTIONS(9712),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9712),
    [aux_sym__assignment_operator_token1] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4655] = {
    [sym_block_comment] = STATE(4655),
    [sym_line_comment] = STATE(4655),
    [ts_builtin_sym_end] = ACTIONS(9754),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_RBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4656] = {
    [sym_block_comment] = STATE(4656),
    [sym_line_comment] = STATE(4656),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_COLON_EQ] = ACTIONS(10004),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10004),
    [aux_sym__assignment_operator_token1] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4657] = {
    [sym_block_comment] = STATE(4657),
    [sym_line_comment] = STATE(4657),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10104),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10104),
    [anon_sym_RPAREN] = ACTIONS(10104),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10104),
    [anon_sym_RBRACK] = ACTIONS(10104),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_SEMI] = ACTIONS(10104),
    [anon_sym_LBRACE] = ACTIONS(10104),
    [anon_sym_RBRACE] = ACTIONS(10104),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10104),
    [anon_sym_COLON_EQ] = ACTIONS(10104),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10104),
    [anon_sym_QMARK] = ACTIONS(10104),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10104),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10104),
    [aux_sym_integer_literal_token2] = ACTIONS(10104),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10104),
    [aux_sym_float_literal_token3] = ACTIONS(10104),
    [aux_sym_float_literal_token4] = ACTIONS(10104),
    [sym_character_literal] = ACTIONS(10104),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10104),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10104),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10104),
    [aux_sym__assignment_operator_token1] = ACTIONS(10104),
    [sym__pair_operator] = ACTIONS(10104),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10104),
    [sym__lazy_and_operator] = ACTIONS(10104),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10104),
    [sym__pipe_left_operator] = ACTIONS(10104),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10104),
    [sym__type_order_operator] = ACTIONS(10104),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4658] = {
    [sym_block_comment] = STATE(4658),
    [sym_line_comment] = STATE(4658),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10108),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10108),
    [anon_sym_RPAREN] = ACTIONS(10108),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10108),
    [anon_sym_RBRACK] = ACTIONS(10108),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_SEMI] = ACTIONS(10108),
    [anon_sym_LBRACE] = ACTIONS(10108),
    [anon_sym_RBRACE] = ACTIONS(10108),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10108),
    [anon_sym_COLON_EQ] = ACTIONS(10108),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10108),
    [anon_sym_QMARK] = ACTIONS(10108),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10108),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10108),
    [aux_sym_integer_literal_token2] = ACTIONS(10108),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10108),
    [aux_sym_float_literal_token3] = ACTIONS(10108),
    [aux_sym_float_literal_token4] = ACTIONS(10108),
    [sym_character_literal] = ACTIONS(10108),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10108),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10108),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10108),
    [aux_sym__assignment_operator_token1] = ACTIONS(10108),
    [sym__pair_operator] = ACTIONS(10108),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10108),
    [sym__lazy_and_operator] = ACTIONS(10108),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10108),
    [sym__pipe_left_operator] = ACTIONS(10108),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10108),
    [sym__type_order_operator] = ACTIONS(10108),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4659] = {
    [sym_block_comment] = STATE(4659),
    [sym_line_comment] = STATE(4659),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_RPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_RBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_SEMI] = ACTIONS(10118),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_RBRACE] = ACTIONS(10118),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_COLON_EQ] = ACTIONS(10118),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10118),
    [aux_sym__assignment_operator_token1] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [4660] = {
    [sym_block_comment] = STATE(4660),
    [sym_line_comment] = STATE(4660),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10124),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10124),
    [anon_sym_RPAREN] = ACTIONS(10124),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10124),
    [anon_sym_RBRACK] = ACTIONS(10124),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_SEMI] = ACTIONS(10124),
    [anon_sym_LBRACE] = ACTIONS(10124),
    [anon_sym_RBRACE] = ACTIONS(10124),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10124),
    [anon_sym_COLON_EQ] = ACTIONS(10124),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10124),
    [anon_sym_QMARK] = ACTIONS(10124),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10124),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10124),
    [aux_sym_integer_literal_token2] = ACTIONS(10124),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10124),
    [aux_sym_float_literal_token3] = ACTIONS(10124),
    [aux_sym_float_literal_token4] = ACTIONS(10124),
    [sym_character_literal] = ACTIONS(10124),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10124),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10124),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10124),
    [aux_sym__assignment_operator_token1] = ACTIONS(10124),
    [sym__pair_operator] = ACTIONS(10124),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10124),
    [sym__lazy_and_operator] = ACTIONS(10124),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10124),
    [sym__pipe_left_operator] = ACTIONS(10124),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10124),
    [sym__type_order_operator] = ACTIONS(10124),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4661] = {
    [sym_block_comment] = STATE(4661),
    [sym_line_comment] = STATE(4661),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_RBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_SEMI] = ACTIONS(9704),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_RBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_COLON_EQ] = ACTIONS(9704),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9704),
    [aux_sym__assignment_operator_token1] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4662] = {
    [sym_block_comment] = STATE(4662),
    [sym_line_comment] = STATE(4662),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10130),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10130),
    [anon_sym_RPAREN] = ACTIONS(10130),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10130),
    [anon_sym_RBRACK] = ACTIONS(10130),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_SEMI] = ACTIONS(10130),
    [anon_sym_LBRACE] = ACTIONS(10130),
    [anon_sym_RBRACE] = ACTIONS(10130),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10130),
    [anon_sym_COLON_EQ] = ACTIONS(10130),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10130),
    [anon_sym_QMARK] = ACTIONS(10130),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10130),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10130),
    [aux_sym_integer_literal_token2] = ACTIONS(10130),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10130),
    [aux_sym_float_literal_token3] = ACTIONS(10130),
    [aux_sym_float_literal_token4] = ACTIONS(10130),
    [sym_character_literal] = ACTIONS(10130),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10130),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10130),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10130),
    [aux_sym__assignment_operator_token1] = ACTIONS(10130),
    [sym__pair_operator] = ACTIONS(10130),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10130),
    [sym__lazy_and_operator] = ACTIONS(10130),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10130),
    [sym__pipe_left_operator] = ACTIONS(10130),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10130),
    [sym__type_order_operator] = ACTIONS(10130),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4663] = {
    [sym_block_comment] = STATE(4663),
    [sym_line_comment] = STATE(4663),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10140),
    [anon_sym_RPAREN] = ACTIONS(10140),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10140),
    [anon_sym_RBRACK] = ACTIONS(10140),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_SEMI] = ACTIONS(10140),
    [anon_sym_LBRACE] = ACTIONS(10140),
    [anon_sym_RBRACE] = ACTIONS(10140),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10140),
    [anon_sym_COLON_EQ] = ACTIONS(10140),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_QMARK] = ACTIONS(10140),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10140),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10140),
    [aux_sym_integer_literal_token2] = ACTIONS(10140),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10140),
    [aux_sym_float_literal_token3] = ACTIONS(10140),
    [aux_sym_float_literal_token4] = ACTIONS(10140),
    [sym_character_literal] = ACTIONS(10140),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10140),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10140),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10140),
    [aux_sym__assignment_operator_token1] = ACTIONS(10140),
    [sym__pair_operator] = ACTIONS(10140),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10140),
    [sym__lazy_and_operator] = ACTIONS(10140),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10140),
    [sym__pipe_left_operator] = ACTIONS(10140),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10140),
    [sym__type_order_operator] = ACTIONS(10140),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4664] = {
    [sym_block_comment] = STATE(4664),
    [sym_line_comment] = STATE(4664),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10144),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10144),
    [anon_sym_RPAREN] = ACTIONS(10144),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10144),
    [anon_sym_RBRACK] = ACTIONS(10144),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_SEMI] = ACTIONS(10144),
    [anon_sym_LBRACE] = ACTIONS(10144),
    [anon_sym_RBRACE] = ACTIONS(10144),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10144),
    [anon_sym_COLON_EQ] = ACTIONS(10144),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10144),
    [anon_sym_QMARK] = ACTIONS(10144),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10144),
    [aux_sym_integer_literal_token2] = ACTIONS(10144),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10144),
    [aux_sym_float_literal_token3] = ACTIONS(10144),
    [aux_sym_float_literal_token4] = ACTIONS(10144),
    [sym_character_literal] = ACTIONS(10144),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10144),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10144),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10144),
    [aux_sym__assignment_operator_token1] = ACTIONS(10144),
    [sym__pair_operator] = ACTIONS(10144),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10144),
    [sym__lazy_and_operator] = ACTIONS(10144),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10144),
    [sym__pipe_left_operator] = ACTIONS(10144),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10144),
    [sym__type_order_operator] = ACTIONS(10144),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4665] = {
    [sym_block_comment] = STATE(4665),
    [sym_line_comment] = STATE(4665),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_RPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_RBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_SEMI] = ACTIONS(9984),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_RBRACE] = ACTIONS(9984),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_COLON_EQ] = ACTIONS(9984),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9984),
    [aux_sym__assignment_operator_token1] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4666] = {
    [sym_block_comment] = STATE(4666),
    [sym_line_comment] = STATE(4666),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_RPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_RBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_SEMI] = ACTIONS(9988),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_RBRACE] = ACTIONS(9988),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_COLON_EQ] = ACTIONS(9988),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9988),
    [aux_sym__assignment_operator_token1] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4667] = {
    [sym_block_comment] = STATE(4667),
    [sym_line_comment] = STATE(4667),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10156),
    [sym__immediate_command_start] = ACTIONS(10158),
  },
  [4668] = {
    [sym_block_comment] = STATE(4668),
    [sym_line_comment] = STATE(4668),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_COLON_EQ] = ACTIONS(9744),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9744),
    [aux_sym__assignment_operator_token1] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4669] = {
    [sym_block_comment] = STATE(4669),
    [sym_line_comment] = STATE(4669),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [4670] = {
    [sym_block_comment] = STATE(4670),
    [sym_line_comment] = STATE(4670),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [4671] = {
    [sym_block_comment] = STATE(4671),
    [sym_line_comment] = STATE(4671),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_RPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_RBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_SEMI] = ACTIONS(10002),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_RBRACE] = ACTIONS(10002),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_COLON_EQ] = ACTIONS(10002),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10002),
    [aux_sym__assignment_operator_token1] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4672] = {
    [sym_block_comment] = STATE(4672),
    [sym_line_comment] = STATE(4672),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_RPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_RBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_SEMI] = ACTIONS(10006),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_RBRACE] = ACTIONS(10006),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_COLON_EQ] = ACTIONS(10006),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10006),
    [aux_sym__assignment_operator_token1] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4673] = {
    [sym_block_comment] = STATE(4673),
    [sym_line_comment] = STATE(4673),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_RPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_RBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_SEMI] = ACTIONS(10154),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_RBRACE] = ACTIONS(10154),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_COLON_EQ] = ACTIONS(10154),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10154),
    [aux_sym__assignment_operator_token1] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [4674] = {
    [sym_block_comment] = STATE(4674),
    [sym_line_comment] = STATE(4674),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_COLON_EQ] = ACTIONS(10010),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10010),
    [aux_sym__assignment_operator_token1] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [4675] = {
    [sym_block_comment] = STATE(4675),
    [sym_line_comment] = STATE(4675),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_COLON_EQ] = ACTIONS(9926),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9926),
    [aux_sym__assignment_operator_token1] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4676] = {
    [sym_do_clause] = STATE(5038),
    [sym_block_comment] = STATE(4676),
    [sym_line_comment] = STATE(4676),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_else] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10192),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_DASH_GT] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4677] = {
    [sym_block_comment] = STATE(4677),
    [sym_line_comment] = STATE(4677),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10188),
    [sym__immediate_command_start] = ACTIONS(10190),
  },
  [4678] = {
    [sym_do_clause] = STATE(5047),
    [sym_block_comment] = STATE(4678),
    [sym_line_comment] = STATE(4678),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10192),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4679] = {
    [sym_do_clause] = STATE(5082),
    [sym_block_comment] = STATE(4679),
    [sym_line_comment] = STATE(4679),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_else] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10192),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_DASH_GT] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4680] = {
    [sym_block_comment] = STATE(4680),
    [sym_line_comment] = STATE(4680),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_COLON_EQ] = ACTIONS(10116),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10116),
    [aux_sym__assignment_operator_token1] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [4681] = {
    [sym_do_clause] = STATE(5136),
    [sym_block_comment] = STATE(4681),
    [sym_line_comment] = STATE(4681),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10192),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4682] = {
    [sym_block_comment] = STATE(4682),
    [sym_line_comment] = STATE(4682),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3075),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3075),
    [aux_sym__assignment_operator_token1] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4683] = {
    [sym_block_comment] = STATE(4683),
    [sym_line_comment] = STATE(4683),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_COLON_EQ] = ACTIONS(10014),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10014),
    [aux_sym__assignment_operator_token1] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [4684] = {
    [sym_block_comment] = STATE(4684),
    [sym_line_comment] = STATE(4684),
    [ts_builtin_sym_end] = ACTIONS(9960),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_RBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_COLON_EQ] = ACTIONS(9958),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9958),
    [aux_sym__assignment_operator_token1] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [4685] = {
    [sym_block_comment] = STATE(4685),
    [sym_line_comment] = STATE(4685),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_COLON_EQ] = ACTIONS(10152),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10152),
    [aux_sym__assignment_operator_token1] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [4686] = {
    [sym_block_comment] = STATE(4686),
    [sym_line_comment] = STATE(4686),
    [ts_builtin_sym_end] = ACTIONS(10030),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_RBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_COLON_EQ] = ACTIONS(10028),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10028),
    [aux_sym__assignment_operator_token1] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4687] = {
    [sym_block_comment] = STATE(4687),
    [sym_line_comment] = STATE(4687),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_RPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_RBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_SEMI] = ACTIONS(10012),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_RBRACE] = ACTIONS(10012),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_COLON_EQ] = ACTIONS(10012),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10012),
    [aux_sym__assignment_operator_token1] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [4688] = {
    [sym_block_comment] = STATE(4688),
    [sym_line_comment] = STATE(4688),
    [ts_builtin_sym_end] = ACTIONS(10034),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_RBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_COLON_EQ] = ACTIONS(10032),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10032),
    [aux_sym__assignment_operator_token1] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4689] = {
    [sym_block_comment] = STATE(4689),
    [sym_line_comment] = STATE(4689),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_RPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_RBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_SEMI] = ACTIONS(10016),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_RBRACE] = ACTIONS(10016),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_COLON_EQ] = ACTIONS(10016),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10016),
    [aux_sym__assignment_operator_token1] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [4690] = {
    [sym_block_comment] = STATE(4690),
    [sym_line_comment] = STATE(4690),
    [ts_builtin_sym_end] = ACTIONS(10038),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_RBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_COLON_EQ] = ACTIONS(10036),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10036),
    [aux_sym__assignment_operator_token1] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4691] = {
    [sym_block_comment] = STATE(4691),
    [sym_line_comment] = STATE(4691),
    [ts_builtin_sym_end] = ACTIONS(10042),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_RBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_COLON_EQ] = ACTIONS(10040),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10040),
    [aux_sym__assignment_operator_token1] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4692] = {
    [sym_block_comment] = STATE(4692),
    [sym_line_comment] = STATE(4692),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_catch] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_COLON_EQ] = ACTIONS(9978),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9978),
    [aux_sym__assignment_operator_token1] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4693] = {
    [sym_block_comment] = STATE(4693),
    [sym_line_comment] = STATE(4693),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_RPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_RBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_SEMI] = ACTIONS(10020),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_RBRACE] = ACTIONS(10020),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_COLON_EQ] = ACTIONS(10020),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10020),
    [aux_sym__assignment_operator_token1] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4694] = {
    [sym_block_comment] = STATE(4694),
    [sym_line_comment] = STATE(4694),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_RPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_RBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_SEMI] = ACTIONS(9918),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_COLON_EQ] = ACTIONS(9918),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9918),
    [aux_sym__assignment_operator_token1] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4695] = {
    [sym_block_comment] = STATE(4695),
    [sym_line_comment] = STATE(4695),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_RPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_RBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_SEMI] = ACTIONS(9922),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_RBRACE] = ACTIONS(9922),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_COLON_EQ] = ACTIONS(9922),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9922),
    [aux_sym__assignment_operator_token1] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4696] = {
    [sym_block_comment] = STATE(4696),
    [sym_line_comment] = STATE(4696),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_RPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_RBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_SEMI] = ACTIONS(9992),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_RBRACE] = ACTIONS(9992),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_COLON_EQ] = ACTIONS(9992),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9992),
    [aux_sym__assignment_operator_token1] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4697] = {
    [sym_block_comment] = STATE(4697),
    [sym_line_comment] = STATE(4697),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_RPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_RBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_SEMI] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_RBRACE] = ACTIONS(9996),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_COLON_EQ] = ACTIONS(9996),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9996),
    [aux_sym__assignment_operator_token1] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4698] = {
    [sym_block_comment] = STATE(4698),
    [sym_line_comment] = STATE(4698),
    [ts_builtin_sym_end] = ACTIONS(9792),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_RBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4699] = {
    [sym_block_comment] = STATE(4699),
    [sym_line_comment] = STATE(4699),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_RBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9762),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_COLON_EQ] = ACTIONS(9762),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9762),
    [aux_sym__assignment_operator_token1] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4700] = {
    [sym_block_comment] = STATE(4700),
    [sym_line_comment] = STATE(4700),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_RPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_RBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_SEMI] = ACTIONS(10030),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_RBRACE] = ACTIONS(10030),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_COLON_EQ] = ACTIONS(10030),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10030),
    [aux_sym__assignment_operator_token1] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4701] = {
    [sym_block_comment] = STATE(4701),
    [sym_line_comment] = STATE(4701),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_RPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_RBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_SEMI] = ACTIONS(10034),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_RBRACE] = ACTIONS(10034),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_COLON_EQ] = ACTIONS(10034),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10034),
    [aux_sym__assignment_operator_token1] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4702] = {
    [sym_block_comment] = STATE(4702),
    [sym_line_comment] = STATE(4702),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_RPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_RBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_SEMI] = ACTIONS(10038),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_RBRACE] = ACTIONS(10038),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_COLON_EQ] = ACTIONS(10038),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10038),
    [aux_sym__assignment_operator_token1] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4703] = {
    [sym_block_comment] = STATE(4703),
    [sym_line_comment] = STATE(4703),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_RPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_RBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_SEMI] = ACTIONS(10042),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_COLON_EQ] = ACTIONS(10042),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10042),
    [aux_sym__assignment_operator_token1] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4704] = {
    [sym__assignment_operator] = STATE(3795),
    [sym_block_comment] = STATE(4704),
    [sym_line_comment] = STATE(4704),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10196),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4705] = {
    [sym_block_comment] = STATE(4705),
    [sym_line_comment] = STATE(4705),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_RPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_RBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_SEMI] = ACTIONS(10050),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_RBRACE] = ACTIONS(10050),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_COLON_EQ] = ACTIONS(10050),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10050),
    [aux_sym__assignment_operator_token1] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [4706] = {
    [sym_block_comment] = STATE(4706),
    [sym_line_comment] = STATE(4706),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_RBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_SEMI] = ACTIONS(10054),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_RBRACE] = ACTIONS(10054),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_COLON_EQ] = ACTIONS(10054),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10054),
    [aux_sym__assignment_operator_token1] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [4707] = {
    [sym_block_comment] = STATE(4707),
    [sym_line_comment] = STATE(4707),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_RPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_RBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_SEMI] = ACTIONS(10058),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_RBRACE] = ACTIONS(10058),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_COLON_EQ] = ACTIONS(10058),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10058),
    [aux_sym__assignment_operator_token1] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [4708] = {
    [sym_block_comment] = STATE(4708),
    [sym_line_comment] = STATE(4708),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_RPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_RBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_SEMI] = ACTIONS(9900),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_RBRACE] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_COLON_EQ] = ACTIONS(9900),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9900),
    [aux_sym__assignment_operator_token1] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [4709] = {
    [sym_block_comment] = STATE(4709),
    [sym_line_comment] = STATE(4709),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_RPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_RBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_SEMI] = ACTIONS(10062),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_RBRACE] = ACTIONS(10062),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_COLON_EQ] = ACTIONS(10062),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10062),
    [aux_sym__assignment_operator_token1] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4710] = {
    [sym_block_comment] = STATE(4710),
    [sym_line_comment] = STATE(4710),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_RPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_RBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_SEMI] = ACTIONS(10066),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_RBRACE] = ACTIONS(10066),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_COLON_EQ] = ACTIONS(10066),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10066),
    [aux_sym__assignment_operator_token1] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4711] = {
    [sym_block_comment] = STATE(4711),
    [sym_line_comment] = STATE(4711),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_RPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_RBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_SEMI] = ACTIONS(10074),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_RBRACE] = ACTIONS(10074),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_COLON_EQ] = ACTIONS(10074),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10074),
    [aux_sym__assignment_operator_token1] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4712] = {
    [sym_block_comment] = STATE(4712),
    [sym_line_comment] = STATE(4712),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_RPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_RBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_SEMI] = ACTIONS(10078),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_RBRACE] = ACTIONS(10078),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_COLON_EQ] = ACTIONS(10078),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10078),
    [aux_sym__assignment_operator_token1] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4713] = {
    [sym_block_comment] = STATE(4713),
    [sym_line_comment] = STATE(4713),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_RPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_RBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_SEMI] = ACTIONS(10082),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_RBRACE] = ACTIONS(10082),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_COLON_EQ] = ACTIONS(10082),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10082),
    [aux_sym__assignment_operator_token1] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4714] = {
    [sym_block_comment] = STATE(4714),
    [sym_line_comment] = STATE(4714),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_catch] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_COLON_EQ] = ACTIONS(9978),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9978),
    [aux_sym__assignment_operator_token1] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4715] = {
    [sym_block_comment] = STATE(4715),
    [sym_line_comment] = STATE(4715),
    [ts_builtin_sym_end] = ACTIONS(10104),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_RBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_COLON_EQ] = ACTIONS(10102),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10102),
    [aux_sym__assignment_operator_token1] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4716] = {
    [sym_block_comment] = STATE(4716),
    [sym_line_comment] = STATE(4716),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4717] = {
    [sym_block_comment] = STATE(4717),
    [sym_line_comment] = STATE(4717),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(10198),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(9868),
    [sym__immediate_command_start] = ACTIONS(9870),
  },
  [4718] = {
    [sym__assignment_operator] = STATE(3738),
    [sym_block_comment] = STATE(4718),
    [sym_line_comment] = STATE(4718),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10200),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10202),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4719] = {
    [sym_block_comment] = STATE(4719),
    [sym_line_comment] = STATE(4719),
    [ts_builtin_sym_end] = ACTIONS(10070),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_RBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_COLON_EQ] = ACTIONS(10068),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10068),
    [aux_sym__assignment_operator_token1] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4720] = {
    [sym_block_comment] = STATE(4720),
    [sym_line_comment] = STATE(4720),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [4721] = {
    [sym_block_comment] = STATE(4721),
    [sym_line_comment] = STATE(4721),
    [ts_builtin_sym_end] = ACTIONS(9988),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_RBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_COLON_EQ] = ACTIONS(9986),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9986),
    [aux_sym__assignment_operator_token1] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4722] = {
    [sym_block_comment] = STATE(4722),
    [sym_line_comment] = STATE(4722),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10156),
    [sym__immediate_command_start] = ACTIONS(10158),
  },
  [4723] = {
    [sym__assignment_operator] = STATE(3108),
    [sym_block_comment] = STATE(4723),
    [sym_line_comment] = STATE(4723),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9844),
    [anon_sym_DOT] = ACTIONS(9856),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
    [sym__immediate_bracket] = ACTIONS(9850),
    [sym__immediate_brace] = ACTIONS(9852),
  },
  [4724] = {
    [sym_block_comment] = STATE(4724),
    [sym_line_comment] = STATE(4724),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4725] = {
    [sym_block_comment] = STATE(4725),
    [sym_line_comment] = STATE(4725),
    [ts_builtin_sym_end] = ACTIONS(10108),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_RBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_COLON_EQ] = ACTIONS(10106),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10106),
    [aux_sym__assignment_operator_token1] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4726] = {
    [sym_block_comment] = STATE(4726),
    [sym_line_comment] = STATE(4726),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_COLON_EQ] = ACTIONS(10134),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10134),
    [aux_sym__assignment_operator_token1] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [4727] = {
    [sym_block_comment] = STATE(4727),
    [sym_line_comment] = STATE(4727),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4728] = {
    [sym_block_comment] = STATE(4728),
    [sym_line_comment] = STATE(4728),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4729] = {
    [sym_block_comment] = STATE(4729),
    [sym_line_comment] = STATE(4729),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4730] = {
    [sym_block_comment] = STATE(4730),
    [sym_line_comment] = STATE(4730),
    [ts_builtin_sym_end] = ACTIONS(10136),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_RBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_COLON_EQ] = ACTIONS(10134),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10134),
    [aux_sym__assignment_operator_token1] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [4731] = {
    [sym_block_comment] = STATE(4731),
    [sym_line_comment] = STATE(4731),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_COLON_EQ] = ACTIONS(9912),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9912),
    [aux_sym__assignment_operator_token1] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [4732] = {
    [sym__assignment_operator] = STATE(3691),
    [sym_block_comment] = STATE(4732),
    [sym_line_comment] = STATE(4732),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10204),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(10024),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4733] = {
    [sym__assignment_operator] = STATE(3343),
    [sym_block_comment] = STATE(4733),
    [sym_line_comment] = STATE(4733),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10168),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4734] = {
    [sym_block_comment] = STATE(4734),
    [sym_line_comment] = STATE(4734),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_COLON_EQ] = ACTIONS(9926),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9926),
    [aux_sym__assignment_operator_token1] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4735] = {
    [sym_block_comment] = STATE(4735),
    [sym_line_comment] = STATE(4735),
    [ts_builtin_sym_end] = ACTIONS(9914),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_RBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_COLON_EQ] = ACTIONS(9912),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9912),
    [aux_sym__assignment_operator_token1] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [4736] = {
    [sym_block_comment] = STATE(4736),
    [sym_line_comment] = STATE(4736),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_catch] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_COLON_EQ] = ACTIONS(9954),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9954),
    [aux_sym__assignment_operator_token1] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4737] = {
    [sym_block_comment] = STATE(4737),
    [sym_line_comment] = STATE(4737),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_catch] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_COLON_EQ] = ACTIONS(9962),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9962),
    [aux_sym__assignment_operator_token1] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4738] = {
    [sym_block_comment] = STATE(4738),
    [sym_line_comment] = STATE(4738),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [4739] = {
    [sym_identifier] = STATE(4895),
    [sym_block_comment] = STATE(4739),
    [sym_line_comment] = STATE(4739),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_COLON_EQ] = ACTIONS(9796),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9796),
    [aux_sym__assignment_operator_token1] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4740] = {
    [sym_block_comment] = STATE(4740),
    [sym_line_comment] = STATE(4740),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4741] = {
    [sym_block_comment] = STATE(4741),
    [sym_line_comment] = STATE(4741),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_COLON_EQ] = ACTIONS(9982),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9982),
    [aux_sym__assignment_operator_token1] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4742] = {
    [sym_block_comment] = STATE(4742),
    [sym_line_comment] = STATE(4742),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_COLON_EQ] = ACTIONS(9958),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9958),
    [aux_sym__assignment_operator_token1] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [4743] = {
    [sym_block_comment] = STATE(4743),
    [sym_line_comment] = STATE(4743),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [4744] = {
    [sym_block_comment] = STATE(4744),
    [sym_line_comment] = STATE(4744),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_RPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_RBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_SEMI] = ACTIONS(9754),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_RBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_COLON_EQ] = ACTIONS(9754),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9754),
    [aux_sym__assignment_operator_token1] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4745] = {
    [sym__assignment_operator] = STATE(3795),
    [sym_block_comment] = STATE(4745),
    [sym_line_comment] = STATE(4745),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10196),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4746] = {
    [sym_block_comment] = STATE(4746),
    [sym_line_comment] = STATE(4746),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_COLON_EQ] = ACTIONS(10086),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10086),
    [aux_sym__assignment_operator_token1] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4747] = {
    [sym__assignment_operator] = STATE(3738),
    [sym_block_comment] = STATE(4747),
    [sym_line_comment] = STATE(4747),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10202),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4748] = {
    [sym_identifier] = STATE(4896),
    [sym_block_comment] = STATE(4748),
    [sym_line_comment] = STATE(4748),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_COLON_EQ] = ACTIONS(9800),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9800),
    [aux_sym__assignment_operator_token1] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4749] = {
    [sym_block_comment] = STATE(4749),
    [sym_line_comment] = STATE(4749),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_catch] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_COLON_EQ] = ACTIONS(10102),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10102),
    [aux_sym__assignment_operator_token1] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4750] = {
    [sym_block_comment] = STATE(4750),
    [sym_line_comment] = STATE(4750),
    [ts_builtin_sym_end] = ACTIONS(9728),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_RBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4751] = {
    [sym_block_comment] = STATE(4751),
    [sym_line_comment] = STATE(4751),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4752] = {
    [sym_block_comment] = STATE(4752),
    [sym_line_comment] = STATE(4752),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4753] = {
    [sym_block_comment] = STATE(4753),
    [sym_line_comment] = STATE(4753),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4754] = {
    [sym_block_comment] = STATE(4754),
    [sym_line_comment] = STATE(4754),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3071),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3071),
    [aux_sym__assignment_operator_token1] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4755] = {
    [sym_block_comment] = STATE(4755),
    [sym_line_comment] = STATE(4755),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_COLON_EQ] = ACTIONS(10152),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10152),
    [aux_sym__assignment_operator_token1] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [4756] = {
    [sym_block_comment] = STATE(4756),
    [sym_line_comment] = STATE(4756),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10188),
    [sym__immediate_command_start] = ACTIONS(10190),
  },
  [4757] = {
    [sym_block_comment] = STATE(4757),
    [sym_line_comment] = STATE(4757),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_COLON_EQ] = ACTIONS(9982),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9982),
    [aux_sym__assignment_operator_token1] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4758] = {
    [sym_block_comment] = STATE(4758),
    [sym_line_comment] = STATE(4758),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_COLON_EQ] = ACTIONS(9986),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9986),
    [aux_sym__assignment_operator_token1] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4759] = {
    [sym_block_comment] = STATE(4759),
    [sym_line_comment] = STATE(4759),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_COLON_EQ] = ACTIONS(10000),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10000),
    [aux_sym__assignment_operator_token1] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4760] = {
    [sym_block_comment] = STATE(4760),
    [sym_line_comment] = STATE(4760),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_COLON_EQ] = ACTIONS(10004),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10004),
    [aux_sym__assignment_operator_token1] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4761] = {
    [sym_block_comment] = STATE(4761),
    [sym_line_comment] = STATE(4761),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_COLON_EQ] = ACTIONS(10010),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10010),
    [aux_sym__assignment_operator_token1] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [4762] = {
    [sym_block_comment] = STATE(4762),
    [sym_line_comment] = STATE(4762),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_COLON_EQ] = ACTIONS(10014),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10014),
    [aux_sym__assignment_operator_token1] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [4763] = {
    [sym_block_comment] = STATE(4763),
    [sym_line_comment] = STATE(4763),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_COLON_EQ] = ACTIONS(10018),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10018),
    [aux_sym__assignment_operator_token1] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4764] = {
    [sym_block_comment] = STATE(4764),
    [sym_line_comment] = STATE(4764),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_COLON_EQ] = ACTIONS(9916),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9916),
    [aux_sym__assignment_operator_token1] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4765] = {
    [sym_block_comment] = STATE(4765),
    [sym_line_comment] = STATE(4765),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_COLON_EQ] = ACTIONS(9920),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9920),
    [aux_sym__assignment_operator_token1] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4766] = {
    [sym_block_comment] = STATE(4766),
    [sym_line_comment] = STATE(4766),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_COLON_EQ] = ACTIONS(9990),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9990),
    [aux_sym__assignment_operator_token1] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4767] = {
    [sym_block_comment] = STATE(4767),
    [sym_line_comment] = STATE(4767),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_COLON_EQ] = ACTIONS(9994),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9994),
    [aux_sym__assignment_operator_token1] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4768] = {
    [sym_block_comment] = STATE(4768),
    [sym_line_comment] = STATE(4768),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4769] = {
    [sym_block_comment] = STATE(4769),
    [sym_line_comment] = STATE(4769),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4770] = {
    [sym_block_comment] = STATE(4770),
    [sym_line_comment] = STATE(4770),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_COLON_EQ] = ACTIONS(10028),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10028),
    [aux_sym__assignment_operator_token1] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4771] = {
    [sym_block_comment] = STATE(4771),
    [sym_line_comment] = STATE(4771),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_COLON_EQ] = ACTIONS(10032),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10032),
    [aux_sym__assignment_operator_token1] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4772] = {
    [sym_block_comment] = STATE(4772),
    [sym_line_comment] = STATE(4772),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_COLON_EQ] = ACTIONS(10036),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10036),
    [aux_sym__assignment_operator_token1] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4773] = {
    [sym_block_comment] = STATE(4773),
    [sym_line_comment] = STATE(4773),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_COLON_EQ] = ACTIONS(10040),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10040),
    [aux_sym__assignment_operator_token1] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4774] = {
    [sym_block_comment] = STATE(4774),
    [sym_line_comment] = STATE(4774),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4775] = {
    [sym_block_comment] = STATE(4775),
    [sym_line_comment] = STATE(4775),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_COLON_EQ] = ACTIONS(10044),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10044),
    [aux_sym__assignment_operator_token1] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [4776] = {
    [sym_block_comment] = STATE(4776),
    [sym_line_comment] = STATE(4776),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_COLON_EQ] = ACTIONS(10048),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10048),
    [aux_sym__assignment_operator_token1] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [4777] = {
    [sym_block_comment] = STATE(4777),
    [sym_line_comment] = STATE(4777),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_COLON_EQ] = ACTIONS(10052),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10052),
    [aux_sym__assignment_operator_token1] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [4778] = {
    [sym_block_comment] = STATE(4778),
    [sym_line_comment] = STATE(4778),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_COLON_EQ] = ACTIONS(10056),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10056),
    [aux_sym__assignment_operator_token1] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [4779] = {
    [sym_block_comment] = STATE(4779),
    [sym_line_comment] = STATE(4779),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_catch] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_COLON_EQ] = ACTIONS(10106),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10106),
    [aux_sym__assignment_operator_token1] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4780] = {
    [sym_block_comment] = STATE(4780),
    [sym_line_comment] = STATE(4780),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_COLON_EQ] = ACTIONS(9898),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9898),
    [aux_sym__assignment_operator_token1] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [4781] = {
    [sym_block_comment] = STATE(4781),
    [sym_line_comment] = STATE(4781),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_COLON_EQ] = ACTIONS(10060),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10060),
    [aux_sym__assignment_operator_token1] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4782] = {
    [sym_block_comment] = STATE(4782),
    [sym_line_comment] = STATE(4782),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_COLON_EQ] = ACTIONS(10064),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10064),
    [aux_sym__assignment_operator_token1] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4783] = {
    [sym_block_comment] = STATE(4783),
    [sym_line_comment] = STATE(4783),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_COLON_EQ] = ACTIONS(10068),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10068),
    [aux_sym__assignment_operator_token1] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4784] = {
    [sym_block_comment] = STATE(4784),
    [sym_line_comment] = STATE(4784),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_COLON_EQ] = ACTIONS(10072),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10072),
    [aux_sym__assignment_operator_token1] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4785] = {
    [sym_block_comment] = STATE(4785),
    [sym_line_comment] = STATE(4785),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_COLON_EQ] = ACTIONS(10076),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10076),
    [aux_sym__assignment_operator_token1] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4786] = {
    [sym_block_comment] = STATE(4786),
    [sym_line_comment] = STATE(4786),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_COLON_EQ] = ACTIONS(10080),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10080),
    [aux_sym__assignment_operator_token1] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4787] = {
    [sym_block_comment] = STATE(4787),
    [sym_line_comment] = STATE(4787),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4788] = {
    [sym_block_comment] = STATE(4788),
    [sym_line_comment] = STATE(4788),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_COLON_EQ] = ACTIONS(9716),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9716),
    [aux_sym__assignment_operator_token1] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4789] = {
    [sym_block_comment] = STATE(4789),
    [sym_line_comment] = STATE(4789),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_COLON_EQ] = ACTIONS(10072),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10072),
    [aux_sym__assignment_operator_token1] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4790] = {
    [sym_block_comment] = STATE(4790),
    [sym_line_comment] = STATE(4790),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4791] = {
    [sym_block_comment] = STATE(4791),
    [sym_line_comment] = STATE(4791),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_COLON_EQ] = ACTIONS(9986),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9986),
    [aux_sym__assignment_operator_token1] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4792] = {
    [sym_block_comment] = STATE(4792),
    [sym_line_comment] = STATE(4792),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_COLON_EQ] = ACTIONS(10134),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10134),
    [aux_sym__assignment_operator_token1] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [4793] = {
    [sym_block_comment] = STATE(4793),
    [sym_line_comment] = STATE(4793),
    [ts_builtin_sym_end] = ACTIONS(10012),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_RBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_COLON_EQ] = ACTIONS(10010),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10010),
    [aux_sym__assignment_operator_token1] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [4794] = {
    [sym_block_comment] = STATE(4794),
    [sym_line_comment] = STATE(4794),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4795] = {
    [sym_block_comment] = STATE(4795),
    [sym_line_comment] = STATE(4795),
    [ts_builtin_sym_end] = ACTIONS(10046),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_RBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_COLON_EQ] = ACTIONS(10044),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10044),
    [aux_sym__assignment_operator_token1] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [4796] = {
    [sym_block_comment] = STATE(4796),
    [sym_line_comment] = STATE(4796),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_COLON_EQ] = ACTIONS(9958),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9958),
    [aux_sym__assignment_operator_token1] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [4797] = {
    [sym_block_comment] = STATE(4797),
    [sym_line_comment] = STATE(4797),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_COLON_EQ] = ACTIONS(9912),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9912),
    [aux_sym__assignment_operator_token1] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [4798] = {
    [sym_block_comment] = STATE(4798),
    [sym_line_comment] = STATE(4798),
    [ts_builtin_sym_end] = ACTIONS(10050),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_RBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_COLON_EQ] = ACTIONS(10048),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10048),
    [aux_sym__assignment_operator_token1] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [4799] = {
    [sym_block_comment] = STATE(4799),
    [sym_line_comment] = STATE(4799),
    [ts_builtin_sym_end] = ACTIONS(10054),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_RBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_COLON_EQ] = ACTIONS(10052),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10052),
    [aux_sym__assignment_operator_token1] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [4800] = {
    [sym_block_comment] = STATE(4800),
    [sym_line_comment] = STATE(4800),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_RPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_RBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_SEMI] = ACTIONS(9792),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_COLON_EQ] = ACTIONS(9792),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9792),
    [aux_sym__assignment_operator_token1] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4801] = {
    [sym_block_comment] = STATE(4801),
    [sym_line_comment] = STATE(4801),
    [ts_builtin_sym_end] = ACTIONS(10058),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_RBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_COLON_EQ] = ACTIONS(10056),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10056),
    [aux_sym__assignment_operator_token1] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [4802] = {
    [sym_block_comment] = STATE(4802),
    [sym_line_comment] = STATE(4802),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3071),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3071),
    [aux_sym__assignment_operator_token1] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4803] = {
    [sym_block_comment] = STATE(4803),
    [sym_line_comment] = STATE(4803),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4804] = {
    [sym_block_comment] = STATE(4804),
    [sym_line_comment] = STATE(4804),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4805] = {
    [sym_block_comment] = STATE(4805),
    [sym_line_comment] = STATE(4805),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4806] = {
    [sym_block_comment] = STATE(4806),
    [sym_line_comment] = STATE(4806),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10188),
    [sym__immediate_command_start] = ACTIONS(10190),
  },
  [4807] = {
    [sym_block_comment] = STATE(4807),
    [sym_line_comment] = STATE(4807),
    [ts_builtin_sym_end] = ACTIONS(9900),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_RBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_COLON_EQ] = ACTIONS(9898),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9898),
    [aux_sym__assignment_operator_token1] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [4808] = {
    [sym_block_comment] = STATE(4808),
    [sym_line_comment] = STATE(4808),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4809] = {
    [sym_block_comment] = STATE(4809),
    [sym_line_comment] = STATE(4809),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_COLON_EQ] = ACTIONS(10060),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10060),
    [aux_sym__assignment_operator_token1] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4810] = {
    [sym_block_comment] = STATE(4810),
    [sym_line_comment] = STATE(4810),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4811] = {
    [sym_block_comment] = STATE(4811),
    [sym_line_comment] = STATE(4811),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_COLON_EQ] = ACTIONS(10134),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10134),
    [aux_sym__assignment_operator_token1] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [4812] = {
    [sym_block_comment] = STATE(4812),
    [sym_line_comment] = STATE(4812),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_COLON_EQ] = ACTIONS(9912),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9912),
    [aux_sym__assignment_operator_token1] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [4813] = {
    [sym_block_comment] = STATE(4813),
    [sym_line_comment] = STATE(4813),
    [ts_builtin_sym_end] = ACTIONS(10118),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_RBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_COLON_EQ] = ACTIONS(10116),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10116),
    [aux_sym__assignment_operator_token1] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [4814] = {
    [sym_block_comment] = STATE(4814),
    [sym_line_comment] = STATE(4814),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_COLON_EQ] = ACTIONS(10116),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10116),
    [aux_sym__assignment_operator_token1] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [4815] = {
    [sym_block_comment] = STATE(4815),
    [sym_line_comment] = STATE(4815),
    [ts_builtin_sym_end] = ACTIONS(10016),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_RBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_COLON_EQ] = ACTIONS(10014),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10014),
    [aux_sym__assignment_operator_token1] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [4816] = {
    [sym_block_comment] = STATE(4816),
    [sym_line_comment] = STATE(4816),
    [ts_builtin_sym_end] = ACTIONS(10124),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_RBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_COLON_EQ] = ACTIONS(10122),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10122),
    [aux_sym__assignment_operator_token1] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4817] = {
    [sym_block_comment] = STATE(4817),
    [sym_line_comment] = STATE(4817),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_catch] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_COLON_EQ] = ACTIONS(10122),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10122),
    [aux_sym__assignment_operator_token1] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4818] = {
    [sym_block_comment] = STATE(4818),
    [sym_line_comment] = STATE(4818),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_COLON_EQ] = ACTIONS(10064),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10064),
    [aux_sym__assignment_operator_token1] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4819] = {
    [sym_do_clause] = STATE(5087),
    [sym_block_comment] = STATE(4819),
    [sym_line_comment] = STATE(4819),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_elseif] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10210),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4820] = {
    [sym_block_comment] = STATE(4820),
    [sym_line_comment] = STATE(4820),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4821] = {
    [sym_block_comment] = STATE(4821),
    [sym_line_comment] = STATE(4821),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_COLON_EQ] = ACTIONS(9644),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_DASH_GT] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9644),
    [aux_sym__assignment_operator_token1] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4822] = {
    [sym_block_comment] = STATE(4822),
    [sym_line_comment] = STATE(4822),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4823] = {
    [sym_block_comment] = STATE(4823),
    [sym_line_comment] = STATE(4823),
    [ts_builtin_sym_end] = ACTIONS(9740),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4824] = {
    [sym_block_comment] = STATE(4824),
    [sym_line_comment] = STATE(4824),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4825] = {
    [sym_block_comment] = STATE(4825),
    [sym_line_comment] = STATE(4825),
    [ts_builtin_sym_end] = ACTIONS(9746),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_RBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4826] = {
    [sym__assignment_operator] = STATE(3305),
    [sym_block_comment] = STATE(4826),
    [sym_line_comment] = STATE(4826),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10178),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4827] = {
    [sym_block_comment] = STATE(4827),
    [sym_line_comment] = STATE(4827),
    [ts_builtin_sym_end] = ACTIONS(10020),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_RBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_COLON_EQ] = ACTIONS(10018),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10018),
    [aux_sym__assignment_operator_token1] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4828] = {
    [sym_block_comment] = STATE(4828),
    [sym_line_comment] = STATE(4828),
    [ts_builtin_sym_end] = ACTIONS(9918),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_RBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_COLON_EQ] = ACTIONS(9916),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9916),
    [aux_sym__assignment_operator_token1] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4829] = {
    [sym_block_comment] = STATE(4829),
    [sym_line_comment] = STATE(4829),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10212),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4830] = {
    [sym_block_comment] = STATE(4830),
    [sym_line_comment] = STATE(4830),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4831] = {
    [sym_block_comment] = STATE(4831),
    [sym_line_comment] = STATE(4831),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_COLON_EQ] = ACTIONS(9818),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9818),
    [aux_sym__assignment_operator_token1] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4832] = {
    [sym_block_comment] = STATE(4832),
    [sym_line_comment] = STATE(4832),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_COLON_EQ] = ACTIONS(9790),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9790),
    [aux_sym__assignment_operator_token1] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4833] = {
    [sym_block_comment] = STATE(4833),
    [sym_line_comment] = STATE(4833),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_COLON_EQ] = ACTIONS(10018),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10018),
    [aux_sym__assignment_operator_token1] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4834] = {
    [sym_block_comment] = STATE(4834),
    [sym_line_comment] = STATE(4834),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_RPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_RBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_SEMI] = ACTIONS(10070),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_COLON_EQ] = ACTIONS(10070),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10070),
    [aux_sym__assignment_operator_token1] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4835] = {
    [sym_block_comment] = STATE(4835),
    [sym_line_comment] = STATE(4835),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_COLON_EQ] = ACTIONS(9824),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9824),
    [aux_sym__assignment_operator_token1] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4836] = {
    [sym_block_comment] = STATE(4836),
    [sym_line_comment] = STATE(4836),
    [ts_builtin_sym_end] = ACTIONS(9922),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_RBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_COLON_EQ] = ACTIONS(9920),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9920),
    [aux_sym__assignment_operator_token1] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4837] = {
    [sym_block_comment] = STATE(4837),
    [sym_line_comment] = STATE(4837),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_catch] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_COLON_EQ] = ACTIONS(10128),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10128),
    [aux_sym__assignment_operator_token1] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4838] = {
    [sym_block_comment] = STATE(4838),
    [sym_line_comment] = STATE(4838),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_COLON_EQ] = ACTIONS(10068),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10068),
    [aux_sym__assignment_operator_token1] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4839] = {
    [sym_block_comment] = STATE(4839),
    [sym_line_comment] = STATE(4839),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_COLON_EQ] = ACTIONS(9916),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9916),
    [aux_sym__assignment_operator_token1] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4840] = {
    [sym_block_comment] = STATE(4840),
    [sym_line_comment] = STATE(4840),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_COLON_EQ] = ACTIONS(9920),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9920),
    [aux_sym__assignment_operator_token1] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4841] = {
    [sym_block_comment] = STATE(4841),
    [sym_line_comment] = STATE(4841),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_catch] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_COLON_EQ] = ACTIONS(10138),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10138),
    [aux_sym__assignment_operator_token1] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4842] = {
    [sym_block_comment] = STATE(4842),
    [sym_line_comment] = STATE(4842),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_catch] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_COLON_EQ] = ACTIONS(10086),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10086),
    [aux_sym__assignment_operator_token1] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4843] = {
    [sym_block_comment] = STATE(4843),
    [sym_line_comment] = STATE(4843),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_RPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_RBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_SEMI] = ACTIONS(9728),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_COLON_EQ] = ACTIONS(9728),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9728),
    [aux_sym__assignment_operator_token1] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4844] = {
    [sym_do_clause] = STATE(5356),
    [sym_block_comment] = STATE(4844),
    [sym_line_comment] = STATE(4844),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_elseif] = ACTIONS(9680),
    [anon_sym_else] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10210),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_DASH_GT] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4845] = {
    [sym_block_comment] = STATE(4845),
    [sym_line_comment] = STATE(4845),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_elseif] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10156),
    [sym__immediate_command_start] = ACTIONS(10158),
  },
  [4846] = {
    [sym_do_clause] = STATE(5358),
    [sym_block_comment] = STATE(4846),
    [sym_line_comment] = STATE(4846),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_elseif] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10210),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4847] = {
    [sym_block_comment] = STATE(4847),
    [sym_line_comment] = STATE(4847),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_catch] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_COLON_EQ] = ACTIONS(10142),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10142),
    [aux_sym__assignment_operator_token1] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4848] = {
    [sym_block_comment] = STATE(4848),
    [sym_line_comment] = STATE(4848),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_RPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_RBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9740),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_RBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_COLON_EQ] = ACTIONS(9740),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9740),
    [aux_sym__assignment_operator_token1] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [4849] = {
    [sym_block_comment] = STATE(4849),
    [sym_line_comment] = STATE(4849),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_RPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_RBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_SEMI] = ACTIONS(9746),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_RBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_COLON_EQ] = ACTIONS(9746),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9746),
    [aux_sym__assignment_operator_token1] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [4850] = {
    [sym_block_comment] = STATE(4850),
    [sym_line_comment] = STATE(4850),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_COLON_EQ] = ACTIONS(9828),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9828),
    [aux_sym__assignment_operator_token1] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4851] = {
    [sym_block_comment] = STATE(4851),
    [sym_line_comment] = STATE(4851),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_COLON_EQ] = ACTIONS(9832),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9832),
    [aux_sym__assignment_operator_token1] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4852] = {
    [sym_block_comment] = STATE(4852),
    [sym_line_comment] = STATE(4852),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_COLON_EQ] = ACTIONS(9836),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9836),
    [aux_sym__assignment_operator_token1] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4853] = {
    [sym_do_clause] = STATE(5365),
    [sym_block_comment] = STATE(4853),
    [sym_line_comment] = STATE(4853),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_elseif] = ACTIONS(9696),
    [anon_sym_else] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10210),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_DASH_GT] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4854] = {
    [sym_block_comment] = STATE(4854),
    [sym_line_comment] = STATE(4854),
    [ts_builtin_sym_end] = ACTIONS(9980),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_RBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_COLON_EQ] = ACTIONS(9978),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9978),
    [aux_sym__assignment_operator_token1] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4855] = {
    [sym_block_comment] = STATE(4855),
    [sym_line_comment] = STATE(4855),
    [ts_builtin_sym_end] = ACTIONS(9984),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_RBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_COLON_EQ] = ACTIONS(9982),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9982),
    [aux_sym__assignment_operator_token1] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4856] = {
    [sym_block_comment] = STATE(4856),
    [sym_line_comment] = STATE(4856),
    [sym__word_identifier] = ACTIONS(10214),
    [anon_sym_begin] = ACTIONS(10214),
    [anon_sym_module] = ACTIONS(10214),
    [anon_sym_baremodule] = ACTIONS(10214),
    [anon_sym_end] = ACTIONS(10214),
    [anon_sym_abstract] = ACTIONS(10214),
    [anon_sym_primitive] = ACTIONS(10214),
    [anon_sym_mutable] = ACTIONS(10214),
    [anon_sym_struct] = ACTIONS(10214),
    [anon_sym_function] = ACTIONS(10214),
    [anon_sym_macro] = ACTIONS(10214),
    [anon_sym_quote] = ACTIONS(10214),
    [anon_sym_let] = ACTIONS(10214),
    [anon_sym_if] = ACTIONS(10214),
    [anon_sym_try] = ACTIONS(10214),
    [anon_sym_for] = ACTIONS(10214),
    [anon_sym_while] = ACTIONS(10214),
    [sym_break_statement] = ACTIONS(10214),
    [sym_continue_statement] = ACTIONS(10214),
    [anon_sym_return] = ACTIONS(10214),
    [anon_sym_const] = ACTIONS(10214),
    [anon_sym_global] = ACTIONS(10214),
    [anon_sym_local] = ACTIONS(10214),
    [anon_sym_LPAREN] = ACTIONS(10214),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(10214),
    [anon_sym_public] = ACTIONS(10214),
    [anon_sym_import] = ACTIONS(10214),
    [anon_sym_using] = ACTIONS(10214),
    [anon_sym_LBRACK] = ACTIONS(10214),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10214),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10214),
    [anon_sym_COLON2] = ACTIONS(10214),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(10198),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10214),
    [anon_sym_true] = ACTIONS(10214),
    [anon_sym_false] = ACTIONS(10214),
    [aux_sym_integer_literal_token1] = ACTIONS(10214),
    [aux_sym_integer_literal_token2] = ACTIONS(10214),
    [aux_sym_integer_literal_token3] = ACTIONS(10214),
    [aux_sym_integer_literal_token4] = ACTIONS(10214),
    [aux_sym_float_literal_token1] = ACTIONS(10214),
    [aux_sym_float_literal_token3] = ACTIONS(10214),
    [aux_sym_float_literal_token4] = ACTIONS(10214),
    [sym_character_literal] = ACTIONS(10214),
    [anon_sym_DQUOTE] = ACTIONS(10214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10214),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(10214),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(10216),
    [aux_sym__terminator_token2] = ACTIONS(10214),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10218),
    [sym__immediate_command_start] = ACTIONS(10220),
  },
  [4857] = {
    [sym_block_comment] = STATE(4857),
    [sym_line_comment] = STATE(4857),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4858] = {
    [sym_block_comment] = STATE(4858),
    [sym_line_comment] = STATE(4858),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_RPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_RBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_SEMI] = ACTIONS(10046),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_RBRACE] = ACTIONS(10046),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_COLON_EQ] = ACTIONS(10046),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10046),
    [aux_sym__assignment_operator_token1] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [4859] = {
    [sym__assignment_operator] = STATE(2991),
    [sym_block_comment] = STATE(4859),
    [sym_line_comment] = STATE(4859),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10224),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4860] = {
    [sym_block_comment] = STATE(4860),
    [sym_line_comment] = STATE(4860),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10226),
    [sym__immediate_command_start] = ACTIONS(10228),
  },
  [4861] = {
    [sym_block_comment] = STATE(4861),
    [sym_line_comment] = STATE(4861),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10226),
    [sym__immediate_command_start] = ACTIONS(10228),
  },
  [4862] = {
    [sym_block_comment] = STATE(4862),
    [sym_line_comment] = STATE(4862),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_COLON_EQ] = ACTIONS(10122),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10122),
    [aux_sym__assignment_operator_token1] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [4863] = {
    [sym_block_comment] = STATE(4863),
    [sym_line_comment] = STATE(4863),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_COLON_EQ] = ACTIONS(10028),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10028),
    [aux_sym__assignment_operator_token1] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [4864] = {
    [sym_block_comment] = STATE(4864),
    [sym_line_comment] = STATE(4864),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_else] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [4865] = {
    [sym_block_comment] = STATE(4865),
    [sym_line_comment] = STATE(4865),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_else] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [4866] = {
    [sym__assignment_operator] = STATE(3738),
    [sym_block_comment] = STATE(4866),
    [sym_line_comment] = STATE(4866),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10202),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4867] = {
    [sym__assignment_operator] = STATE(2991),
    [sym_block_comment] = STATE(4867),
    [sym_line_comment] = STATE(4867),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10230),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10224),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4868] = {
    [sym_block_comment] = STATE(4868),
    [sym_line_comment] = STATE(4868),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10232),
    [sym__immediate_command_start] = ACTIONS(10234),
  },
  [4869] = {
    [sym_do_clause] = STATE(5788),
    [sym_block_comment] = STATE(4869),
    [sym_line_comment] = STATE(4869),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_catch] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10236),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_DASH_GT] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4870] = {
    [sym_block_comment] = STATE(4870),
    [sym_line_comment] = STATE(4870),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10238),
    [sym__immediate_command_start] = ACTIONS(10240),
  },
  [4871] = {
    [sym_do_clause] = STATE(5789),
    [sym_block_comment] = STATE(4871),
    [sym_line_comment] = STATE(4871),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10236),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4872] = {
    [sym_block_comment] = STATE(4872),
    [sym_line_comment] = STATE(4872),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_COLON_EQ] = ACTIONS(9702),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9702),
    [aux_sym__assignment_operator_token1] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4873] = {
    [sym_block_comment] = STATE(4873),
    [sym_line_comment] = STATE(4873),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_elseif] = ACTIONS(9752),
    [anon_sym_else] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4874] = {
    [sym_block_comment] = STATE(4874),
    [sym_line_comment] = STATE(4874),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_DASH_GT] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10242),
    [sym__immediate_command_start] = ACTIONS(10244),
  },
  [4875] = {
    [sym_block_comment] = STATE(4875),
    [sym_line_comment] = STATE(4875),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_elseif] = ACTIONS(9810),
    [anon_sym_else] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4876] = {
    [sym_do_clause] = STATE(5791),
    [sym_block_comment] = STATE(4876),
    [sym_line_comment] = STATE(4876),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_catch] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10236),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_DASH_GT] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4877] = {
    [sym_do_clause] = STATE(5794),
    [sym_block_comment] = STATE(4877),
    [sym_line_comment] = STATE(4877),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10236),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4878] = {
    [sym_block_comment] = STATE(4878),
    [sym_line_comment] = STATE(4878),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_COLON_EQ] = ACTIONS(10060),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10060),
    [aux_sym__assignment_operator_token1] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [4879] = {
    [sym_block_comment] = STATE(4879),
    [sym_line_comment] = STATE(4879),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_COLON_EQ] = ACTIONS(10032),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10032),
    [aux_sym__assignment_operator_token1] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [4880] = {
    [sym_block_comment] = STATE(4880),
    [sym_line_comment] = STATE(4880),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_COLON_EQ] = ACTIONS(10036),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10036),
    [aux_sym__assignment_operator_token1] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [4881] = {
    [sym_do_clause] = STATE(5567),
    [sym_block_comment] = STATE(4881),
    [sym_line_comment] = STATE(4881),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_elseif] = ACTIONS(9680),
    [anon_sym_else] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10246),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4882] = {
    [sym_block_comment] = STATE(4882),
    [sym_line_comment] = STATE(4882),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_COLON_EQ] = ACTIONS(10064),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10064),
    [aux_sym__assignment_operator_token1] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [4883] = {
    [sym_block_comment] = STATE(4883),
    [sym_line_comment] = STATE(4883),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_elseif] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10226),
    [sym__immediate_command_start] = ACTIONS(10228),
  },
  [4884] = {
    [sym_do_clause] = STATE(5568),
    [sym_block_comment] = STATE(4884),
    [sym_line_comment] = STATE(4884),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_elseif] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10246),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4885] = {
    [sym_block_comment] = STATE(4885),
    [sym_line_comment] = STATE(4885),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_COLON_EQ] = ACTIONS(10068),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10068),
    [aux_sym__assignment_operator_token1] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [4886] = {
    [sym__assignment_operator] = STATE(3433),
    [sym_block_comment] = STATE(4886),
    [sym_line_comment] = STATE(4886),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10248),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4887] = {
    [sym_block_comment] = STATE(4887),
    [sym_line_comment] = STATE(4887),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_COLON_EQ] = ACTIONS(10040),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10040),
    [aux_sym__assignment_operator_token1] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [4888] = {
    [sym__primary_expression] = STATE(11269),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(11286),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_macro_identifier] = STATE(17548),
    [sym_identifier] = STATE(10753),
    [sym_boolean_literal] = STATE(11286),
    [sym__string] = STATE(11286),
    [sym__delimiter_str_1] = STATE(14484),
    [sym__delimiter_str_3] = STATE(14542),
    [sym__delimiter_cmd_1] = STATE(14549),
    [sym__delimiter_cmd_3] = STATE(14550),
    [sym_string_literal] = STATE(11191),
    [sym_command_literal] = STATE(11191),
    [sym_prefixed_string_literal] = STATE(11191),
    [sym_prefixed_command_literal] = STATE(11191),
    [sym_operator] = STATE(19341),
    [sym_block_comment] = STATE(4888),
    [sym_line_comment] = STATE(4888),
    [sym__word_identifier] = ACTIONS(10250),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(10252),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(10254),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10256),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10258),
    [anon_sym_COLON2] = ACTIONS(10260),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10264),
    [anon_sym_false] = ACTIONS(10264),
    [sym_character_literal] = ACTIONS(10266),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4889] = {
    [sym_do_clause] = STATE(5703),
    [sym_block_comment] = STATE(4889),
    [sym_line_comment] = STATE(4889),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_RBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_SEMI] = ACTIONS(9704),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_RBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10268),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_DASH_GT] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4890] = {
    [sym_block_comment] = STATE(4890),
    [sym_line_comment] = STATE(4890),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_COLON_EQ] = ACTIONS(10072),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10072),
    [aux_sym__assignment_operator_token1] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [4891] = {
    [sym_do_clause] = STATE(5570),
    [sym_block_comment] = STATE(4891),
    [sym_line_comment] = STATE(4891),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_elseif] = ACTIONS(9696),
    [anon_sym_else] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10246),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4892] = {
    [sym_do_clause] = STATE(5573),
    [sym_block_comment] = STATE(4892),
    [sym_line_comment] = STATE(4892),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_elseif] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10246),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4893] = {
    [sym_block_comment] = STATE(4893),
    [sym_line_comment] = STATE(4893),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_COLON_EQ] = ACTIONS(10128),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10128),
    [aux_sym__assignment_operator_token1] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [4894] = {
    [sym_block_comment] = STATE(4894),
    [sym_line_comment] = STATE(4894),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_COLON_EQ] = ACTIONS(10138),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10138),
    [aux_sym__assignment_operator_token1] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [4895] = {
    [sym_block_comment] = STATE(4895),
    [sym_line_comment] = STATE(4895),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_COLON_EQ] = ACTIONS(10076),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10076),
    [aux_sym__assignment_operator_token1] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [4896] = {
    [sym_block_comment] = STATE(4896),
    [sym_line_comment] = STATE(4896),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_COLON_EQ] = ACTIONS(10080),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10080),
    [aux_sym__assignment_operator_token1] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [4897] = {
    [sym_block_comment] = STATE(4897),
    [sym_line_comment] = STATE(4897),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_COLON_EQ] = ACTIONS(10142),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10142),
    [aux_sym__assignment_operator_token1] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [4898] = {
    [sym_block_comment] = STATE(4898),
    [sym_line_comment] = STATE(4898),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_COLON_EQ] = ACTIONS(10018),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10018),
    [aux_sym__assignment_operator_token1] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [4899] = {
    [sym_block_comment] = STATE(4899),
    [sym_line_comment] = STATE(4899),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_elseif] = ACTIONS(9814),
    [anon_sym_else] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4900] = {
    [sym_block_comment] = STATE(4900),
    [sym_line_comment] = STATE(4900),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10232),
    [sym__immediate_command_start] = ACTIONS(10234),
  },
  [4901] = {
    [sym_block_comment] = STATE(4901),
    [sym_line_comment] = STATE(4901),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4902] = {
    [sym_do_clause] = STATE(5696),
    [sym_block_comment] = STATE(4902),
    [sym_line_comment] = STATE(4902),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9684),
    [anon_sym_RPAREN] = ACTIONS(9684),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9684),
    [anon_sym_RBRACK] = ACTIONS(9684),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_SEMI] = ACTIONS(9684),
    [anon_sym_LBRACE] = ACTIONS(9684),
    [anon_sym_RBRACE] = ACTIONS(9684),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10268),
    [anon_sym_DOLLAR] = ACTIONS(9684),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9684),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9684),
    [anon_sym_QMARK] = ACTIONS(9684),
    [anon_sym_DASH_GT] = ACTIONS(9684),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9684),
    [aux_sym_integer_literal_token2] = ACTIONS(9684),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9684),
    [aux_sym_float_literal_token3] = ACTIONS(9684),
    [aux_sym_float_literal_token4] = ACTIONS(9684),
    [sym_character_literal] = ACTIONS(9684),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9684),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9684),
    [sym__pair_operator] = ACTIONS(9684),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9684),
    [sym__lazy_and_operator] = ACTIONS(9684),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9684),
    [sym__pipe_left_operator] = ACTIONS(9684),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9684),
    [sym__bitshift_operator] = ACTIONS(9684),
    [sym__power_operator] = ACTIONS(9684),
    [sym__tilde_operator] = ACTIONS(9684),
    [sym__type_order_operator] = ACTIONS(9684),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4903] = {
    [sym_block_comment] = STATE(4903),
    [sym_line_comment] = STATE(4903),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [4904] = {
    [sym_block_comment] = STATE(4904),
    [sym_line_comment] = STATE(4904),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_RBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_SEMI] = ACTIONS(9708),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_DASH_GT] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10242),
    [sym__immediate_command_start] = ACTIONS(10244),
  },
  [4905] = {
    [sym_block_comment] = STATE(4905),
    [sym_line_comment] = STATE(4905),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_COLON_EQ] = ACTIONS(9986),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9986),
    [aux_sym__assignment_operator_token1] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [4906] = {
    [sym_block_comment] = STATE(4906),
    [sym_line_comment] = STATE(4906),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4907] = {
    [sym_block_comment] = STATE(4907),
    [sym_line_comment] = STATE(4907),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_else] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [4908] = {
    [sym_block_comment] = STATE(4908),
    [sym_line_comment] = STATE(4908),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_else] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [4909] = {
    [sym_block_comment] = STATE(4909),
    [sym_line_comment] = STATE(4909),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_else] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [4910] = {
    [sym_do_clause] = STATE(5698),
    [sym_block_comment] = STATE(4910),
    [sym_line_comment] = STATE(4910),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_RBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_SEMI] = ACTIONS(9712),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10268),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_DASH_GT] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4911] = {
    [sym_block_comment] = STATE(4911),
    [sym_line_comment] = STATE(4911),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_else] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4912] = {
    [sym_block_comment] = STATE(4912),
    [sym_line_comment] = STATE(4912),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_COLON_EQ] = ACTIONS(10000),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10000),
    [aux_sym__assignment_operator_token1] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [4913] = {
    [sym_block_comment] = STATE(4913),
    [sym_line_comment] = STATE(4913),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_else] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4914] = {
    [sym_block_comment] = STATE(4914),
    [sym_line_comment] = STATE(4914),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_else] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4915] = {
    [sym__assignment_operator] = STATE(3801),
    [sym_block_comment] = STATE(4915),
    [sym_line_comment] = STATE(4915),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10270),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(10024),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4916] = {
    [sym_block_comment] = STATE(4916),
    [sym_line_comment] = STATE(4916),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_else] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4917] = {
    [sym_block_comment] = STATE(4917),
    [sym_line_comment] = STATE(4917),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_else] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4918] = {
    [sym__assignment_operator] = STATE(3433),
    [sym_block_comment] = STATE(4918),
    [sym_line_comment] = STATE(4918),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10248),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4919] = {
    [sym_block_comment] = STATE(4919),
    [sym_line_comment] = STATE(4919),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10272),
    [sym__immediate_command_start] = ACTIONS(10274),
  },
  [4920] = {
    [sym_block_comment] = STATE(4920),
    [sym_line_comment] = STATE(4920),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_else] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4921] = {
    [sym_block_comment] = STATE(4921),
    [sym_line_comment] = STATE(4921),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_COLON_EQ] = ACTIONS(9916),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9916),
    [aux_sym__assignment_operator_token1] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [4922] = {
    [sym_block_comment] = STATE(4922),
    [sym_line_comment] = STATE(4922),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_COLON_EQ] = ACTIONS(9926),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9926),
    [aux_sym__assignment_operator_token1] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [4923] = {
    [sym__assignment_operator] = STATE(3433),
    [sym_block_comment] = STATE(4923),
    [sym_line_comment] = STATE(4923),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10248),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [4924] = {
    [sym_block_comment] = STATE(4924),
    [sym_line_comment] = STATE(4924),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_COLON_EQ] = ACTIONS(9710),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9710),
    [aux_sym__assignment_operator_token1] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4925] = {
    [sym_do_clause] = STATE(5846),
    [sym_block_comment] = STATE(4925),
    [sym_line_comment] = STATE(4925),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10276),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_DASH_GT] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4926] = {
    [sym_block_comment] = STATE(4926),
    [sym_line_comment] = STATE(4926),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10278),
    [sym__immediate_command_start] = ACTIONS(10280),
  },
  [4927] = {
    [sym_do_clause] = STATE(5847),
    [sym_block_comment] = STATE(4927),
    [sym_line_comment] = STATE(4927),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10276),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4928] = {
    [sym_do_clause] = STATE(5851),
    [sym_block_comment] = STATE(4928),
    [sym_line_comment] = STATE(4928),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10276),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_DASH_GT] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4929] = {
    [sym_block_comment] = STATE(4929),
    [sym_line_comment] = STATE(4929),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_COLON_EQ] = ACTIONS(9978),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9978),
    [aux_sym__assignment_operator_token1] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [4930] = {
    [sym_do_clause] = STATE(5856),
    [sym_block_comment] = STATE(4930),
    [sym_line_comment] = STATE(4930),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10276),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4931] = {
    [sym_block_comment] = STATE(4931),
    [sym_line_comment] = STATE(4931),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [4932] = {
    [sym_block_comment] = STATE(4932),
    [sym_line_comment] = STATE(4932),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_COLON_EQ] = ACTIONS(9664),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9664),
    [aux_sym__assignment_operator_token1] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10162),
    [sym__immediate_command_start] = ACTIONS(10164),
  },
  [4933] = {
    [sym_block_comment] = STATE(4933),
    [sym_line_comment] = STATE(4933),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_COLON_EQ] = ACTIONS(9920),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9920),
    [aux_sym__assignment_operator_token1] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [4934] = {
    [sym_block_comment] = STATE(4934),
    [sym_line_comment] = STATE(4934),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_COLON_EQ] = ACTIONS(9990),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9990),
    [aux_sym__assignment_operator_token1] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [4935] = {
    [sym_block_comment] = STATE(4935),
    [sym_line_comment] = STATE(4935),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10272),
    [sym__immediate_command_start] = ACTIONS(10274),
  },
  [4936] = {
    [sym_block_comment] = STATE(4936),
    [sym_line_comment] = STATE(4936),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_COLON_EQ] = ACTIONS(9730),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9730),
    [aux_sym__assignment_operator_token1] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4937] = {
    [sym_block_comment] = STATE(4937),
    [sym_line_comment] = STATE(4937),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_DASH_GT] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10242),
    [sym__immediate_command_start] = ACTIONS(10244),
  },
  [4938] = {
    [sym_do_clause] = STATE(5713),
    [sym_block_comment] = STATE(4938),
    [sym_line_comment] = STATE(4938),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_else] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10282),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4939] = {
    [sym_block_comment] = STATE(4939),
    [sym_line_comment] = STATE(4939),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10284),
    [sym__immediate_command_start] = ACTIONS(10286),
  },
  [4940] = {
    [sym_do_clause] = STATE(5714),
    [sym_block_comment] = STATE(4940),
    [sym_line_comment] = STATE(4940),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10282),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4941] = {
    [sym_block_comment] = STATE(4941),
    [sym_line_comment] = STATE(4941),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10238),
    [sym__immediate_command_start] = ACTIONS(10240),
  },
  [4942] = {
    [sym_block_comment] = STATE(4942),
    [sym_line_comment] = STATE(4942),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [4943] = {
    [sym_block_comment] = STATE(4943),
    [sym_line_comment] = STATE(4943),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_elseif] = ACTIONS(9818),
    [anon_sym_else] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [4944] = {
    [sym_block_comment] = STATE(4944),
    [sym_line_comment] = STATE(4944),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_elseif] = ACTIONS(9790),
    [anon_sym_else] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [4945] = {
    [sym_block_comment] = STATE(4945),
    [sym_line_comment] = STATE(4945),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_elseif] = ACTIONS(9824),
    [anon_sym_else] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [4946] = {
    [sym_identifier] = STATE(5094),
    [sym_block_comment] = STATE(4946),
    [sym_line_comment] = STATE(4946),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_elseif] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_DASH_GT] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [4947] = {
    [sym_identifier] = STATE(5099),
    [sym_block_comment] = STATE(4947),
    [sym_line_comment] = STATE(4947),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_elseif] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_DASH_GT] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [4948] = {
    [sym_block_comment] = STATE(4948),
    [sym_line_comment] = STATE(4948),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_COLON_EQ] = ACTIONS(10004),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10004),
    [aux_sym__assignment_operator_token1] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [4949] = {
    [sym_block_comment] = STATE(4949),
    [sym_line_comment] = STATE(4949),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10284),
    [sym__immediate_command_start] = ACTIONS(10286),
  },
  [4950] = {
    [sym_do_clause] = STATE(5745),
    [sym_block_comment] = STATE(4950),
    [sym_line_comment] = STATE(4950),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_catch] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10288),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_DASH_GT] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4951] = {
    [sym_block_comment] = STATE(4951),
    [sym_line_comment] = STATE(4951),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10232),
    [sym__immediate_command_start] = ACTIONS(10234),
  },
  [4952] = {
    [sym_block_comment] = STATE(4952),
    [sym_line_comment] = STATE(4952),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10238),
    [sym__immediate_command_start] = ACTIONS(10240),
  },
  [4953] = {
    [sym_do_clause] = STATE(5746),
    [sym_block_comment] = STATE(4953),
    [sym_line_comment] = STATE(4953),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10288),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4954] = {
    [sym__assignment_operator] = STATE(3835),
    [sym_block_comment] = STATE(4954),
    [sym_line_comment] = STATE(4954),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10178),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4955] = {
    [sym_identifier] = STATE(5123),
    [sym_block_comment] = STATE(4955),
    [sym_line_comment] = STATE(4955),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_elseif] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_DASH_GT] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [4956] = {
    [sym_do_clause] = STATE(5751),
    [sym_block_comment] = STATE(4956),
    [sym_line_comment] = STATE(4956),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_catch] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10288),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_DASH_GT] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4957] = {
    [sym_identifier] = STATE(5131),
    [sym_block_comment] = STATE(4957),
    [sym_line_comment] = STATE(4957),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_elseif] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_DASH_GT] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [4958] = {
    [sym_do_clause] = STATE(5756),
    [sym_block_comment] = STATE(4958),
    [sym_line_comment] = STATE(4958),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10288),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4959] = {
    [sym_block_comment] = STATE(4959),
    [sym_line_comment] = STATE(4959),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10284),
    [sym__immediate_command_start] = ACTIONS(10286),
  },
  [4960] = {
    [sym_block_comment] = STATE(4960),
    [sym_line_comment] = STATE(4960),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(3071),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3071),
    [aux_sym__assignment_operator_token1] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [4961] = {
    [sym_block_comment] = STATE(4961),
    [sym_line_comment] = STATE(4961),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10242),
    [sym__immediate_command_start] = ACTIONS(10244),
  },
  [4962] = {
    [sym_block_comment] = STATE(4962),
    [sym_line_comment] = STATE(4962),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_COLON_EQ] = ACTIONS(9994),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9994),
    [aux_sym__assignment_operator_token1] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [4963] = {
    [sym_block_comment] = STATE(4963),
    [sym_line_comment] = STATE(4963),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10290),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4964] = {
    [sym__assignment_operator] = STATE(3349),
    [sym_block_comment] = STATE(4964),
    [sym_line_comment] = STATE(4964),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10292),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10196),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4965] = {
    [sym_block_comment] = STATE(4965),
    [sym_line_comment] = STATE(4965),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_COLON_EQ] = ACTIONS(9714),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9714),
    [aux_sym__assignment_operator_token1] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [4966] = {
    [sym_block_comment] = STATE(4966),
    [sym_line_comment] = STATE(4966),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_COLON_EQ] = ACTIONS(9982),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9982),
    [aux_sym__assignment_operator_token1] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [4967] = {
    [sym_do_clause] = STATE(5766),
    [sym_block_comment] = STATE(4967),
    [sym_line_comment] = STATE(4967),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9684),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9684),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9684),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10294),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9684),
    [anon_sym_COLON_EQ] = ACTIONS(9684),
    [anon_sym_DOT_EQ] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9684),
    [anon_sym_QMARK] = ACTIONS(9684),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9684),
    [aux_sym_integer_literal_token2] = ACTIONS(9684),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9684),
    [aux_sym_float_literal_token3] = ACTIONS(9684),
    [aux_sym_float_literal_token4] = ACTIONS(9684),
    [sym_character_literal] = ACTIONS(9684),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9684),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9684),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9684),
    [aux_sym__assignment_operator_token1] = ACTIONS(9684),
    [sym__pair_operator] = ACTIONS(9684),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9684),
    [sym__lazy_and_operator] = ACTIONS(9684),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9684),
    [sym__pipe_left_operator] = ACTIONS(9684),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9684),
    [sym__type_order_operator] = ACTIONS(9684),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [4968] = {
    [sym_block_comment] = STATE(4968),
    [sym_line_comment] = STATE(4968),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_COLON_EQ] = ACTIONS(9708),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9708),
    [aux_sym__assignment_operator_token1] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10162),
    [sym__immediate_command_start] = ACTIONS(10164),
  },
  [4969] = {
    [sym_do_clause] = STATE(5767),
    [sym_block_comment] = STATE(4969),
    [sym_line_comment] = STATE(4969),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10294),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_COLON_EQ] = ACTIONS(9712),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9712),
    [aux_sym__assignment_operator_token1] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [4970] = {
    [sym_do_clause] = STATE(5768),
    [sym_block_comment] = STATE(4970),
    [sym_line_comment] = STATE(4970),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9700),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9700),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9700),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9700),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10294),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9700),
    [anon_sym_COLON_EQ] = ACTIONS(9700),
    [anon_sym_DOT_EQ] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9700),
    [anon_sym_QMARK] = ACTIONS(9700),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9700),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9700),
    [aux_sym_integer_literal_token2] = ACTIONS(9700),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9700),
    [aux_sym_float_literal_token3] = ACTIONS(9700),
    [aux_sym_float_literal_token4] = ACTIONS(9700),
    [sym_character_literal] = ACTIONS(9700),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9700),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9700),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9700),
    [aux_sym__assignment_operator_token1] = ACTIONS(9700),
    [sym__pair_operator] = ACTIONS(9700),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9700),
    [sym__lazy_and_operator] = ACTIONS(9700),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9700),
    [sym__pipe_left_operator] = ACTIONS(9700),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9700),
    [sym__type_order_operator] = ACTIONS(9700),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4971] = {
    [sym_block_comment] = STATE(4971),
    [sym_line_comment] = STATE(4971),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10232),
    [sym__immediate_command_start] = ACTIONS(10234),
  },
  [4972] = {
    [sym_do_clause] = STATE(5771),
    [sym_block_comment] = STATE(4972),
    [sym_line_comment] = STATE(4972),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10294),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_COLON_EQ] = ACTIONS(9704),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9704),
    [aux_sym__assignment_operator_token1] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [4973] = {
    [sym_block_comment] = STATE(4973),
    [sym_line_comment] = STATE(4973),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_COLON_EQ] = ACTIONS(9716),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9716),
    [aux_sym__assignment_operator_token1] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10162),
    [sym__immediate_command_start] = ACTIONS(10164),
  },
  [4974] = {
    [sym_block_comment] = STATE(4974),
    [sym_line_comment] = STATE(4974),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_COLON_EQ] = ACTIONS(10102),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10102),
    [aux_sym__assignment_operator_token1] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [4975] = {
    [sym_block_comment] = STATE(4975),
    [sym_line_comment] = STATE(4975),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10226),
    [sym__immediate_command_start] = ACTIONS(10228),
  },
  [4976] = {
    [sym_block_comment] = STATE(4976),
    [sym_line_comment] = STATE(4976),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_COLON_EQ] = ACTIONS(10106),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10106),
    [aux_sym__assignment_operator_token1] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [4977] = {
    [sym_block_comment] = STATE(4977),
    [sym_line_comment] = STATE(4977),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_elseif] = ACTIONS(9828),
    [anon_sym_else] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [4978] = {
    [sym__assignment_operator] = STATE(3801),
    [sym_block_comment] = STATE(4978),
    [sym_line_comment] = STATE(4978),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10296),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(10024),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4979] = {
    [sym__assignment_operator] = STATE(3795),
    [sym_block_comment] = STATE(4979),
    [sym_line_comment] = STATE(4979),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10196),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [4980] = {
    [sym_block_comment] = STATE(4980),
    [sym_line_comment] = STATE(4980),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10278),
    [sym__immediate_command_start] = ACTIONS(10280),
  },
  [4981] = {
    [sym_block_comment] = STATE(4981),
    [sym_line_comment] = STATE(4981),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10238),
    [sym__immediate_command_start] = ACTIONS(10240),
  },
  [4982] = {
    [sym_block_comment] = STATE(4982),
    [sym_line_comment] = STATE(4982),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_elseif] = ACTIONS(9832),
    [anon_sym_else] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [4983] = {
    [sym_block_comment] = STATE(4983),
    [sym_line_comment] = STATE(4983),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_elseif] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [4984] = {
    [sym_block_comment] = STATE(4984),
    [sym_line_comment] = STATE(4984),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10278),
    [sym__immediate_command_start] = ACTIONS(10280),
  },
  [4985] = {
    [sym_do_clause] = STATE(5700),
    [sym_block_comment] = STATE(4985),
    [sym_line_comment] = STATE(4985),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9700),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9700),
    [anon_sym_RPAREN] = ACTIONS(9700),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9700),
    [anon_sym_RBRACK] = ACTIONS(9700),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_SEMI] = ACTIONS(9700),
    [anon_sym_LBRACE] = ACTIONS(9700),
    [anon_sym_RBRACE] = ACTIONS(9700),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10268),
    [anon_sym_DOLLAR] = ACTIONS(9700),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9700),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9700),
    [anon_sym_QMARK] = ACTIONS(9700),
    [anon_sym_DASH_GT] = ACTIONS(9700),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9700),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9700),
    [aux_sym_integer_literal_token2] = ACTIONS(9700),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9700),
    [aux_sym_float_literal_token3] = ACTIONS(9700),
    [aux_sym_float_literal_token4] = ACTIONS(9700),
    [sym_character_literal] = ACTIONS(9700),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9700),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9700),
    [sym__pair_operator] = ACTIONS(9700),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9700),
    [sym__lazy_and_operator] = ACTIONS(9700),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9700),
    [sym__pipe_left_operator] = ACTIONS(9700),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9700),
    [sym__bitshift_operator] = ACTIONS(9700),
    [sym__power_operator] = ACTIONS(9700),
    [sym__tilde_operator] = ACTIONS(9700),
    [sym__type_order_operator] = ACTIONS(9700),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4986] = {
    [sym_block_comment] = STATE(4986),
    [sym_line_comment] = STATE(4986),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_elseif] = ACTIONS(9836),
    [anon_sym_else] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [4987] = {
    [sym_block_comment] = STATE(4987),
    [sym_line_comment] = STATE(4987),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_COLON_EQ] = ACTIONS(9954),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9954),
    [aux_sym__assignment_operator_token1] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [4988] = {
    [sym_block_comment] = STATE(4988),
    [sym_line_comment] = STATE(4988),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_COLON_EQ] = ACTIONS(9962),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9962),
    [aux_sym__assignment_operator_token1] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [4989] = {
    [sym__assignment_operator] = STATE(3845),
    [sym_block_comment] = STATE(4989),
    [sym_line_comment] = STATE(4989),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(9934),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [4990] = {
    [sym_block_comment] = STATE(4990),
    [sym_line_comment] = STATE(4990),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4991] = {
    [sym_block_comment] = STATE(4991),
    [sym_line_comment] = STATE(4991),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_DASH_GT] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4992] = {
    [sym_block_comment] = STATE(4992),
    [sym_line_comment] = STATE(4992),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10298),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [4993] = {
    [sym_block_comment] = STATE(4993),
    [sym_line_comment] = STATE(4993),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_COLON_EQ] = ACTIONS(10086),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10086),
    [aux_sym__assignment_operator_token1] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [4994] = {
    [sym_block_comment] = STATE(4994),
    [sym_line_comment] = STATE(4994),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [4995] = {
    [sym_block_comment] = STATE(4995),
    [sym_line_comment] = STATE(4995),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10278),
    [sym__immediate_command_start] = ACTIONS(10280),
  },
  [4996] = {
    [sym_do_clause] = STATE(5715),
    [sym_block_comment] = STATE(4996),
    [sym_line_comment] = STATE(4996),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_else] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10282),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [4997] = {
    [sym_block_comment] = STATE(4997),
    [sym_line_comment] = STATE(4997),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [4998] = {
    [sym__primary_expression] = STATE(11377),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(10685),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(4998),
    [sym_line_comment] = STATE(4998),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10308),
    [anon_sym_COLON2] = ACTIONS(10310),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [4999] = {
    [sym_block_comment] = STATE(4999),
    [sym_line_comment] = STATE(4999),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5000] = {
    [sym_identifier] = STATE(5189),
    [sym_block_comment] = STATE(5000),
    [sym_line_comment] = STATE(5000),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_DASH_GT] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5001] = {
    [sym_identifier] = STATE(5190),
    [sym_block_comment] = STATE(5001),
    [sym_line_comment] = STATE(5001),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_DASH_GT] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5002] = {
    [sym_identifier] = STATE(5193),
    [sym_block_comment] = STATE(5002),
    [sym_line_comment] = STATE(5002),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_DASH_GT] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5003] = {
    [sym_identifier] = STATE(5194),
    [sym_block_comment] = STATE(5003),
    [sym_line_comment] = STATE(5003),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_DASH_GT] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5004] = {
    [sym_block_comment] = STATE(5004),
    [sym_line_comment] = STATE(5004),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_COLON_EQ] = ACTIONS(9912),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9912),
    [aux_sym__assignment_operator_token1] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5005] = {
    [sym_block_comment] = STATE(5005),
    [sym_line_comment] = STATE(5005),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5006] = {
    [sym_block_comment] = STATE(5006),
    [sym_line_comment] = STATE(5006),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_COLON_EQ] = ACTIONS(10044),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10044),
    [aux_sym__assignment_operator_token1] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5007] = {
    [sym__assignment_operator] = STATE(3845),
    [sym_block_comment] = STATE(5007),
    [sym_line_comment] = STATE(5007),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(9934),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [5008] = {
    [sym__assignment_operator] = STATE(3835),
    [sym_block_comment] = STATE(5008),
    [sym_line_comment] = STATE(5008),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10178),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [5009] = {
    [sym_block_comment] = STATE(5009),
    [sym_line_comment] = STATE(5009),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_COLON_EQ] = ACTIONS(9644),
    [anon_sym_DOT_EQ] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9644),
    [aux_sym__assignment_operator_token1] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5010] = {
    [sym_block_comment] = STATE(5010),
    [sym_line_comment] = STATE(5010),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5011] = {
    [sym_block_comment] = STATE(5011),
    [sym_line_comment] = STATE(5011),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_COLON_EQ] = ACTIONS(9706),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9706),
    [aux_sym__assignment_operator_token1] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5012] = {
    [sym_block_comment] = STATE(5012),
    [sym_line_comment] = STATE(5012),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5013] = {
    [sym_block_comment] = STATE(5013),
    [sym_line_comment] = STATE(5013),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5014] = {
    [sym_block_comment] = STATE(5014),
    [sym_line_comment] = STATE(5014),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_COLON_EQ] = ACTIONS(10014),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10014),
    [aux_sym__assignment_operator_token1] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5015] = {
    [sym_block_comment] = STATE(5015),
    [sym_line_comment] = STATE(5015),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10284),
    [sym__immediate_command_start] = ACTIONS(10286),
  },
  [5016] = {
    [sym_block_comment] = STATE(5016),
    [sym_line_comment] = STATE(5016),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_COLON_EQ] = ACTIONS(10152),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10152),
    [aux_sym__assignment_operator_token1] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5017] = {
    [sym_block_comment] = STATE(5017),
    [sym_line_comment] = STATE(5017),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_COLON_EQ] = ACTIONS(9662),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9662),
    [aux_sym__assignment_operator_token1] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5018] = {
    [sym_do_clause] = STATE(5674),
    [sym_block_comment] = STATE(5018),
    [sym_line_comment] = STATE(5018),
    [ts_builtin_sym_end] = ACTIONS(9684),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_RBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10316),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_DASH_GT] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5019] = {
    [sym_block_comment] = STATE(5019),
    [sym_line_comment] = STATE(5019),
    [ts_builtin_sym_end] = ACTIONS(9708),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_RBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10272),
    [sym__immediate_command_start] = ACTIONS(10274),
  },
  [5020] = {
    [sym_do_clause] = STATE(5675),
    [sym_block_comment] = STATE(5020),
    [sym_line_comment] = STATE(5020),
    [ts_builtin_sym_end] = ACTIONS(9712),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_RBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10316),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5021] = {
    [sym_block_comment] = STATE(5021),
    [sym_line_comment] = STATE(5021),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_COLON_EQ] = ACTIONS(10134),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10134),
    [aux_sym__assignment_operator_token1] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5022] = {
    [sym_block_comment] = STATE(5022),
    [sym_line_comment] = STATE(5022),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_COLON_EQ] = ACTIONS(9958),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9958),
    [aux_sym__assignment_operator_token1] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5023] = {
    [sym_block_comment] = STATE(5023),
    [sym_line_comment] = STATE(5023),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_COLON_EQ] = ACTIONS(10048),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10048),
    [aux_sym__assignment_operator_token1] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5024] = {
    [sym_block_comment] = STATE(5024),
    [sym_line_comment] = STATE(5024),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_COLON_EQ] = ACTIONS(10052),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10052),
    [aux_sym__assignment_operator_token1] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5025] = {
    [sym_block_comment] = STATE(5025),
    [sym_line_comment] = STATE(5025),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_COLON_EQ] = ACTIONS(10056),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10056),
    [aux_sym__assignment_operator_token1] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5026] = {
    [sym_block_comment] = STATE(5026),
    [sym_line_comment] = STATE(5026),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_COLON_EQ] = ACTIONS(9898),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9898),
    [aux_sym__assignment_operator_token1] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5027] = {
    [sym_do_clause] = STATE(5679),
    [sym_block_comment] = STATE(5027),
    [sym_line_comment] = STATE(5027),
    [ts_builtin_sym_end] = ACTIONS(9700),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_RBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10316),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_DASH_GT] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5028] = {
    [sym_do_clause] = STATE(5718),
    [sym_block_comment] = STATE(5028),
    [sym_line_comment] = STATE(5028),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10282),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5029] = {
    [sym_block_comment] = STATE(5029),
    [sym_line_comment] = STATE(5029),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_COLON_EQ] = ACTIONS(10116),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10116),
    [aux_sym__assignment_operator_token1] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5030] = {
    [sym_do_clause] = STATE(5684),
    [sym_block_comment] = STATE(5030),
    [sym_line_comment] = STATE(5030),
    [ts_builtin_sym_end] = ACTIONS(9704),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_RBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10316),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5031] = {
    [sym_block_comment] = STATE(5031),
    [sym_line_comment] = STATE(5031),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5032] = {
    [sym_block_comment] = STATE(5032),
    [sym_line_comment] = STATE(5032),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_COLON_EQ] = ACTIONS(10010),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10010),
    [aux_sym__assignment_operator_token1] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5033] = {
    [sym__primary_expression] = STATE(11331),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10688),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(5033),
    [sym_line_comment] = STATE(5033),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10318),
    [anon_sym_COLON2] = ACTIONS(10320),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5034] = {
    [sym_block_comment] = STATE(5034),
    [sym_line_comment] = STATE(5034),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_elseif] = ACTIONS(9726),
    [anon_sym_else] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5035] = {
    [sym_block_comment] = STATE(5035),
    [sym_line_comment] = STATE(5035),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_elseif] = ACTIONS(9744),
    [anon_sym_else] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5036] = {
    [sym_block_comment] = STATE(5036),
    [sym_line_comment] = STATE(5036),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10272),
    [sym__immediate_command_start] = ACTIONS(10274),
  },
  [5037] = {
    [sym__assignment_operator] = STATE(3349),
    [sym_block_comment] = STATE(5037),
    [sym_line_comment] = STATE(5037),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10196),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [5038] = {
    [sym_block_comment] = STATE(5038),
    [sym_line_comment] = STATE(5038),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_else] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_DASH_GT] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5039] = {
    [sym_block_comment] = STATE(5039),
    [sym_line_comment] = STATE(5039),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5040] = {
    [sym_block_comment] = STATE(5040),
    [sym_line_comment] = STATE(5040),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9806),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9806),
    [anon_sym_RPAREN] = ACTIONS(9806),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9806),
    [anon_sym_RBRACK] = ACTIONS(9806),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9806),
    [anon_sym_LBRACE] = ACTIONS(9806),
    [anon_sym_RBRACE] = ACTIONS(9806),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9806),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9806),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9806),
    [anon_sym_QMARK] = ACTIONS(9806),
    [anon_sym_DASH_GT] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9806),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9806),
    [aux_sym_integer_literal_token2] = ACTIONS(9806),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9806),
    [aux_sym_float_literal_token3] = ACTIONS(9806),
    [aux_sym_float_literal_token4] = ACTIONS(9806),
    [sym_character_literal] = ACTIONS(9806),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9806),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9806),
    [sym__pair_operator] = ACTIONS(9806),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9806),
    [sym__lazy_and_operator] = ACTIONS(9806),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9806),
    [sym__pipe_left_operator] = ACTIONS(9806),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9806),
    [sym__bitshift_operator] = ACTIONS(9806),
    [sym__power_operator] = ACTIONS(9806),
    [sym__tilde_operator] = ACTIONS(9806),
    [sym__type_order_operator] = ACTIONS(9806),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5041] = {
    [sym_block_comment] = STATE(5041),
    [sym_line_comment] = STATE(5041),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_elseif] = ACTIONS(9810),
    [anon_sym_else] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5042] = {
    [sym_block_comment] = STATE(5042),
    [sym_line_comment] = STATE(5042),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5043] = {
    [sym_identifier] = STATE(5601),
    [sym_block_comment] = STATE(5043),
    [sym_line_comment] = STATE(5043),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_elseif] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5044] = {
    [sym_block_comment] = STATE(5044),
    [sym_line_comment] = STATE(5044),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10322),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_else] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_finally] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10324),
    [anon_sym_DOT] = ACTIONS(10326),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10330),
    [sym__immediate_bracket] = ACTIONS(10332),
    [sym__immediate_brace] = ACTIONS(10334),
  },
  [5045] = {
    [sym__assignment_operator] = STATE(3188),
    [sym_block_comment] = STATE(5045),
    [sym_line_comment] = STATE(5045),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10336),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10338),
    [anon_sym_DOT] = ACTIONS(10340),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
    [sym__immediate_bracket] = ACTIONS(10344),
    [sym__immediate_brace] = ACTIONS(10346),
  },
  [5046] = {
    [sym_block_comment] = STATE(5046),
    [sym_line_comment] = STATE(5046),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10348),
    [sym__immediate_command_start] = ACTIONS(10350),
  },
  [5047] = {
    [sym_block_comment] = STATE(5047),
    [sym_line_comment] = STATE(5047),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_else] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_DASH_GT] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5048] = {
    [sym__assignment_operator] = STATE(2991),
    [sym_block_comment] = STATE(5048),
    [sym_line_comment] = STATE(5048),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10166),
    [anon_sym_DOT] = ACTIONS(10224),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
    [sym__immediate_bracket] = ACTIONS(10172),
    [sym__immediate_brace] = ACTIONS(10174),
  },
  [5049] = {
    [sym_block_comment] = STATE(5049),
    [sym_line_comment] = STATE(5049),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_catch] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5050] = {
    [sym_block_comment] = STATE(5050),
    [sym_line_comment] = STATE(5050),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_catch] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5051] = {
    [sym_block_comment] = STATE(5051),
    [sym_line_comment] = STATE(5051),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10352),
    [sym__immediate_command_start] = ACTIONS(10354),
  },
  [5052] = {
    [sym_do_clause] = STATE(6001),
    [sym_block_comment] = STATE(5052),
    [sym_line_comment] = STATE(5052),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_RBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_SEMI] = ACTIONS(9704),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_RBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10356),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5053] = {
    [sym_identifier] = STATE(5603),
    [sym_block_comment] = STATE(5053),
    [sym_line_comment] = STATE(5053),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_elseif] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5054] = {
    [sym_block_comment] = STATE(5054),
    [sym_line_comment] = STATE(5054),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(10358),
    [anon_sym_COLON_EQ] = ACTIONS(9724),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9724),
    [aux_sym__assignment_operator_token1] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(10358),
    [sym__arrow_operator] = ACTIONS(10358),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(10358),
    [sym__pipe_right_operator] = ACTIONS(10358),
    [sym__pipe_left_operator] = ACTIONS(10358),
    [sym__ellipsis_operator] = ACTIONS(10358),
    [sym__plus_operator] = ACTIONS(10358),
    [sym__times_operator] = ACTIONS(10358),
    [sym__rational_operator] = ACTIONS(10358),
    [sym__bitshift_operator] = ACTIONS(10358),
    [sym__power_operator] = ACTIONS(10358),
    [sym__tilde_operator] = ACTIONS(10358),
    [sym__type_order_operator] = ACTIONS(10358),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(10358),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5055] = {
    [sym_identifier] = STATE(5604),
    [sym_block_comment] = STATE(5055),
    [sym_line_comment] = STATE(5055),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_elseif] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5056] = {
    [sym__assignment_operator] = STATE(3188),
    [sym_block_comment] = STATE(5056),
    [sym_line_comment] = STATE(5056),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10338),
    [anon_sym_DOT] = ACTIONS(10340),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
    [sym__immediate_bracket] = ACTIONS(10344),
    [sym__immediate_brace] = ACTIONS(10346),
  },
  [5057] = {
    [sym_block_comment] = STATE(5057),
    [sym_line_comment] = STATE(5057),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10352),
    [sym__immediate_command_start] = ACTIONS(10354),
  },
  [5058] = {
    [sym_block_comment] = STATE(5058),
    [sym_line_comment] = STATE(5058),
    [ts_builtin_sym_end] = ACTIONS(9806),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5059] = {
    [sym_block_comment] = STATE(5059),
    [sym_line_comment] = STATE(5059),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_COLON_EQ] = ACTIONS(9746),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_DASH_GT] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9746),
    [aux_sym__assignment_operator_token1] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5060] = {
    [sym_block_comment] = STATE(5060),
    [sym_line_comment] = STATE(5060),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5061] = {
    [sym_block_comment] = STATE(5061),
    [sym_line_comment] = STATE(5061),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10322),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_elseif] = ACTIONS(10322),
    [anon_sym_else] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10363),
    [anon_sym_DOT] = ACTIONS(10365),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10367),
    [sym__immediate_bracket] = ACTIONS(10369),
    [sym__immediate_brace] = ACTIONS(10371),
  },
  [5062] = {
    [sym_block_comment] = STATE(5062),
    [sym_line_comment] = STATE(5062),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5063] = {
    [sym_block_comment] = STATE(5063),
    [sym_line_comment] = STATE(5063),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5064] = {
    [sym_do_clause] = STATE(6279),
    [sym_block_comment] = STATE(5064),
    [sym_line_comment] = STATE(5064),
    [ts_builtin_sym_end] = ACTIONS(9684),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_RBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10373),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5065] = {
    [sym_block_comment] = STATE(5065),
    [sym_line_comment] = STATE(5065),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5066] = {
    [sym_block_comment] = STATE(5066),
    [sym_line_comment] = STATE(5066),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5067] = {
    [sym_block_comment] = STATE(5067),
    [sym_line_comment] = STATE(5067),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5068] = {
    [sym_block_comment] = STATE(5068),
    [sym_line_comment] = STATE(5068),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5069] = {
    [sym_block_comment] = STATE(5069),
    [sym_line_comment] = STATE(5069),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5070] = {
    [sym_block_comment] = STATE(5070),
    [sym_line_comment] = STATE(5070),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5071] = {
    [sym_block_comment] = STATE(5071),
    [sym_line_comment] = STATE(5071),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5072] = {
    [sym_block_comment] = STATE(5072),
    [sym_line_comment] = STATE(5072),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5073] = {
    [sym_block_comment] = STATE(5073),
    [sym_line_comment] = STATE(5073),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_catch] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5074] = {
    [sym_block_comment] = STATE(5074),
    [sym_line_comment] = STATE(5074),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_elseif] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5075] = {
    [sym_block_comment] = STATE(5075),
    [sym_line_comment] = STATE(5075),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_else] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5076] = {
    [sym_block_comment] = STATE(5076),
    [sym_line_comment] = STATE(5076),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_else] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5077] = {
    [sym__primary_expression] = STATE(11422),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11097),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(5077),
    [sym_line_comment] = STATE(5077),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10375),
    [anon_sym_COLON2] = ACTIONS(10377),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5078] = {
    [sym_block_comment] = STATE(5078),
    [sym_line_comment] = STATE(5078),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_else] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5079] = {
    [sym_block_comment] = STATE(5079),
    [sym_line_comment] = STATE(5079),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_elseif] = ACTIONS(9790),
    [anon_sym_else] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5080] = {
    [sym_block_comment] = STATE(5080),
    [sym_line_comment] = STATE(5080),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10379),
    [sym__immediate_command_start] = ACTIONS(10381),
  },
  [5081] = {
    [sym_block_comment] = STATE(5081),
    [sym_line_comment] = STATE(5081),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5082] = {
    [sym_block_comment] = STATE(5082),
    [sym_line_comment] = STATE(5082),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_else] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_DASH_GT] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5083] = {
    [sym_block_comment] = STATE(5083),
    [sym_line_comment] = STATE(5083),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_else] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_DASH_GT] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5084] = {
    [sym_block_comment] = STATE(5084),
    [sym_line_comment] = STATE(5084),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_DASH_GT] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5085] = {
    [sym_block_comment] = STATE(5085),
    [sym_line_comment] = STATE(5085),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_DASH_GT] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5086] = {
    [sym_block_comment] = STATE(5086),
    [sym_line_comment] = STATE(5086),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_RBRACK] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9758),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9758),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_DASH_GT] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9758),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9758),
    [aux_sym_integer_literal_token2] = ACTIONS(9758),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9758),
    [aux_sym_float_literal_token3] = ACTIONS(9758),
    [aux_sym_float_literal_token4] = ACTIONS(9758),
    [sym_character_literal] = ACTIONS(9758),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9758),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9758),
    [sym__pair_operator] = ACTIONS(9758),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9758),
    [sym__lazy_and_operator] = ACTIONS(9758),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9758),
    [sym__pipe_left_operator] = ACTIONS(9758),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9758),
    [sym__bitshift_operator] = ACTIONS(9758),
    [sym__power_operator] = ACTIONS(9758),
    [sym__tilde_operator] = ACTIONS(9758),
    [sym__type_order_operator] = ACTIONS(9758),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5087] = {
    [sym_block_comment] = STATE(5087),
    [sym_line_comment] = STATE(5087),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_elseif] = ACTIONS(10138),
    [anon_sym_else] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_DASH_GT] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5088] = {
    [sym_block_comment] = STATE(5088),
    [sym_line_comment] = STATE(5088),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_else] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5089] = {
    [sym_block_comment] = STATE(5089),
    [sym_line_comment] = STATE(5089),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_else] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5090] = {
    [sym_block_comment] = STATE(5090),
    [sym_line_comment] = STATE(5090),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_DASH_GT] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5091] = {
    [sym_block_comment] = STATE(5091),
    [sym_line_comment] = STATE(5091),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10348),
    [sym__immediate_command_start] = ACTIONS(10350),
  },
  [5092] = {
    [sym_block_comment] = STATE(5092),
    [sym_line_comment] = STATE(5092),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_else] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5093] = {
    [sym_block_comment] = STATE(5093),
    [sym_line_comment] = STATE(5093),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5094] = {
    [sym_block_comment] = STATE(5094),
    [sym_line_comment] = STATE(5094),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_elseif] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_DASH_GT] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5095] = {
    [sym_block_comment] = STATE(5095),
    [sym_line_comment] = STATE(5095),
    [ts_builtin_sym_end] = ACTIONS(9808),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_RBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5096] = {
    [sym_block_comment] = STATE(5096),
    [sym_line_comment] = STATE(5096),
    [ts_builtin_sym_end] = ACTIONS(9812),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_RBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5097] = {
    [sym_block_comment] = STATE(5097),
    [sym_line_comment] = STATE(5097),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_else] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5098] = {
    [sym_block_comment] = STATE(5098),
    [sym_line_comment] = STATE(5098),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_else] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5099] = {
    [sym_block_comment] = STATE(5099),
    [sym_line_comment] = STATE(5099),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_elseif] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_DASH_GT] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5100] = {
    [sym_do_clause] = STATE(6017),
    [sym_block_comment] = STATE(5100),
    [sym_line_comment] = STATE(5100),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10383),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_DASH_GT] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5101] = {
    [sym_block_comment] = STATE(5101),
    [sym_line_comment] = STATE(5101),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_else] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5102] = {
    [sym_block_comment] = STATE(5102),
    [sym_line_comment] = STATE(5102),
    [ts_builtin_sym_end] = ACTIONS(9816),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_RBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5103] = {
    [sym_do_clause] = STATE(6146),
    [sym_block_comment] = STATE(5103),
    [sym_line_comment] = STATE(5103),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_catch] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10385),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5104] = {
    [sym_block_comment] = STATE(5104),
    [sym_line_comment] = STATE(5104),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_elseif] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5105] = {
    [sym_block_comment] = STATE(5105),
    [sym_line_comment] = STATE(5105),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_catch] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5106] = {
    [sym_block_comment] = STATE(5106),
    [sym_line_comment] = STATE(5106),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_elseif] = ACTIONS(9726),
    [anon_sym_else] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5107] = {
    [sym_block_comment] = STATE(5107),
    [sym_line_comment] = STATE(5107),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10387),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5108] = {
    [sym_block_comment] = STATE(5108),
    [sym_line_comment] = STATE(5108),
    [ts_builtin_sym_end] = ACTIONS(9708),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_RBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10389),
    [sym__immediate_command_start] = ACTIONS(10391),
  },
  [5109] = {
    [sym_block_comment] = STATE(5109),
    [sym_line_comment] = STATE(5109),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_catch] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5110] = {
    [sym_block_comment] = STATE(5110),
    [sym_line_comment] = STATE(5110),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10352),
    [sym__immediate_command_start] = ACTIONS(10354),
  },
  [5111] = {
    [sym_block_comment] = STATE(5111),
    [sym_line_comment] = STATE(5111),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(10393),
    [anon_sym_COLON_EQ] = ACTIONS(9736),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9736),
    [aux_sym__assignment_operator_token1] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(10393),
    [sym__arrow_operator] = ACTIONS(10393),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(10393),
    [sym__pipe_right_operator] = ACTIONS(10393),
    [sym__pipe_left_operator] = ACTIONS(10393),
    [sym__ellipsis_operator] = ACTIONS(10393),
    [sym__plus_operator] = ACTIONS(10393),
    [sym__times_operator] = ACTIONS(10393),
    [sym__rational_operator] = ACTIONS(10393),
    [sym__bitshift_operator] = ACTIONS(10393),
    [sym__power_operator] = ACTIONS(10393),
    [sym__tilde_operator] = ACTIONS(10393),
    [sym__type_order_operator] = ACTIONS(10393),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(10393),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5112] = {
    [sym_block_comment] = STATE(5112),
    [sym_line_comment] = STATE(5112),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10396),
    [sym__immediate_command_start] = ACTIONS(10398),
  },
  [5113] = {
    [sym_do_clause] = STATE(6147),
    [sym_block_comment] = STATE(5113),
    [sym_line_comment] = STATE(5113),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10385),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5114] = {
    [sym_do_clause] = STATE(6280),
    [sym_block_comment] = STATE(5114),
    [sym_line_comment] = STATE(5114),
    [ts_builtin_sym_end] = ACTIONS(9712),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_RBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10373),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5115] = {
    [sym_block_comment] = STATE(5115),
    [sym_line_comment] = STATE(5115),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_elseif] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_DASH_GT] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5116] = {
    [sym_block_comment] = STATE(5116),
    [sym_line_comment] = STATE(5116),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_elseif] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_DASH_GT] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5117] = {
    [sym_block_comment] = STATE(5117),
    [sym_line_comment] = STATE(5117),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9808),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9808),
    [anon_sym_RPAREN] = ACTIONS(9808),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9808),
    [anon_sym_RBRACK] = ACTIONS(9808),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_SEMI] = ACTIONS(9808),
    [anon_sym_LBRACE] = ACTIONS(9808),
    [anon_sym_RBRACE] = ACTIONS(9808),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9808),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9808),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9808),
    [anon_sym_QMARK] = ACTIONS(9808),
    [anon_sym_DASH_GT] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9808),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9808),
    [aux_sym_integer_literal_token2] = ACTIONS(9808),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9808),
    [aux_sym_float_literal_token3] = ACTIONS(9808),
    [aux_sym_float_literal_token4] = ACTIONS(9808),
    [sym_character_literal] = ACTIONS(9808),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9808),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9808),
    [sym__pair_operator] = ACTIONS(9808),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9808),
    [sym__lazy_and_operator] = ACTIONS(9808),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9808),
    [sym__pipe_left_operator] = ACTIONS(9808),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9808),
    [sym__bitshift_operator] = ACTIONS(9808),
    [sym__power_operator] = ACTIONS(9808),
    [sym__tilde_operator] = ACTIONS(9808),
    [sym__type_order_operator] = ACTIONS(9808),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5118] = {
    [sym_block_comment] = STATE(5118),
    [sym_line_comment] = STATE(5118),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_catch] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5119] = {
    [sym_block_comment] = STATE(5119),
    [sym_line_comment] = STATE(5119),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_elseif] = ACTIONS(9744),
    [anon_sym_else] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5120] = {
    [sym_block_comment] = STATE(5120),
    [sym_line_comment] = STATE(5120),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_else] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_DASH_GT] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5121] = {
    [sym_block_comment] = STATE(5121),
    [sym_line_comment] = STATE(5121),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9812),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9812),
    [anon_sym_RPAREN] = ACTIONS(9812),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9812),
    [anon_sym_RBRACK] = ACTIONS(9812),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_SEMI] = ACTIONS(9812),
    [anon_sym_LBRACE] = ACTIONS(9812),
    [anon_sym_RBRACE] = ACTIONS(9812),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9812),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9812),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9812),
    [anon_sym_QMARK] = ACTIONS(9812),
    [anon_sym_DASH_GT] = ACTIONS(9812),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9812),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9812),
    [aux_sym_integer_literal_token2] = ACTIONS(9812),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9812),
    [aux_sym_float_literal_token3] = ACTIONS(9812),
    [aux_sym_float_literal_token4] = ACTIONS(9812),
    [sym_character_literal] = ACTIONS(9812),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9812),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9812),
    [sym__pair_operator] = ACTIONS(9812),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9812),
    [sym__lazy_and_operator] = ACTIONS(9812),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9812),
    [sym__pipe_left_operator] = ACTIONS(9812),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9812),
    [sym__bitshift_operator] = ACTIONS(9812),
    [sym__power_operator] = ACTIONS(9812),
    [sym__tilde_operator] = ACTIONS(9812),
    [sym__type_order_operator] = ACTIONS(9812),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5122] = {
    [sym_block_comment] = STATE(5122),
    [sym_line_comment] = STATE(5122),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_catch] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5123] = {
    [sym_block_comment] = STATE(5123),
    [sym_line_comment] = STATE(5123),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_elseif] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_DASH_GT] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5124] = {
    [sym_block_comment] = STATE(5124),
    [sym_line_comment] = STATE(5124),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_elseif] = ACTIONS(9818),
    [anon_sym_else] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5125] = {
    [sym_block_comment] = STATE(5125),
    [sym_line_comment] = STATE(5125),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10379),
    [sym__immediate_command_start] = ACTIONS(10381),
  },
  [5126] = {
    [sym__assignment_operator] = STATE(3673),
    [sym_block_comment] = STATE(5126),
    [sym_line_comment] = STATE(5126),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10338),
    [anon_sym_DOT] = ACTIONS(10400),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
    [sym__immediate_bracket] = ACTIONS(10344),
    [sym__immediate_brace] = ACTIONS(10346),
  },
  [5127] = {
    [sym_block_comment] = STATE(5127),
    [sym_line_comment] = STATE(5127),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10402),
    [sym__immediate_command_start] = ACTIONS(10404),
  },
  [5128] = {
    [sym_block_comment] = STATE(5128),
    [sym_line_comment] = STATE(5128),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9816),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9816),
    [anon_sym_RPAREN] = ACTIONS(9816),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9816),
    [anon_sym_RBRACK] = ACTIONS(9816),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_SEMI] = ACTIONS(9816),
    [anon_sym_LBRACE] = ACTIONS(9816),
    [anon_sym_RBRACE] = ACTIONS(9816),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9816),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9816),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9816),
    [anon_sym_QMARK] = ACTIONS(9816),
    [anon_sym_DASH_GT] = ACTIONS(9816),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9816),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9816),
    [aux_sym_integer_literal_token2] = ACTIONS(9816),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9816),
    [aux_sym_float_literal_token3] = ACTIONS(9816),
    [aux_sym_float_literal_token4] = ACTIONS(9816),
    [sym_character_literal] = ACTIONS(9816),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9816),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9816),
    [sym__pair_operator] = ACTIONS(9816),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9816),
    [sym__lazy_and_operator] = ACTIONS(9816),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9816),
    [sym__pipe_left_operator] = ACTIONS(9816),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9816),
    [sym__bitshift_operator] = ACTIONS(9816),
    [sym__power_operator] = ACTIONS(9816),
    [sym__tilde_operator] = ACTIONS(9816),
    [sym__type_order_operator] = ACTIONS(9816),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5129] = {
    [sym_block_comment] = STATE(5129),
    [sym_line_comment] = STATE(5129),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5130] = {
    [sym_block_comment] = STATE(5130),
    [sym_line_comment] = STATE(5130),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10396),
    [sym__immediate_command_start] = ACTIONS(10398),
  },
  [5131] = {
    [sym_block_comment] = STATE(5131),
    [sym_line_comment] = STATE(5131),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_elseif] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_DASH_GT] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5132] = {
    [sym_block_comment] = STATE(5132),
    [sym_line_comment] = STATE(5132),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10379),
    [sym__immediate_command_start] = ACTIONS(10381),
  },
  [5133] = {
    [sym__assignment_operator] = STATE(3801),
    [sym_block_comment] = STATE(5133),
    [sym_line_comment] = STATE(5133),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_SQUOTE] = ACTIONS(9932),
    [anon_sym_DOT] = ACTIONS(10024),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
    [sym__immediate_bracket] = ACTIONS(9938),
    [sym__immediate_brace] = ACTIONS(9940),
  },
  [5134] = {
    [sym_block_comment] = STATE(5134),
    [sym_line_comment] = STATE(5134),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_elseif] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_DASH_GT] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5135] = {
    [sym_block_comment] = STATE(5135),
    [sym_line_comment] = STATE(5135),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_elseif] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_DASH_GT] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5136] = {
    [sym_block_comment] = STATE(5136),
    [sym_line_comment] = STATE(5136),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_else] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_DASH_GT] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5137] = {
    [sym_block_comment] = STATE(5137),
    [sym_line_comment] = STATE(5137),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5138] = {
    [sym_block_comment] = STATE(5138),
    [sym_line_comment] = STATE(5138),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_elseif] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_DASH_GT] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5139] = {
    [sym_block_comment] = STATE(5139),
    [sym_line_comment] = STATE(5139),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_elseif] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_DASH_GT] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5140] = {
    [sym_block_comment] = STATE(5140),
    [sym_line_comment] = STATE(5140),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10389),
    [sym__immediate_command_start] = ACTIONS(10391),
  },
  [5141] = {
    [sym_block_comment] = STATE(5141),
    [sym_line_comment] = STATE(5141),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_catch] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5142] = {
    [sym_block_comment] = STATE(5142),
    [sym_line_comment] = STATE(5142),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_elseif] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5143] = {
    [sym_block_comment] = STATE(5143),
    [sym_line_comment] = STATE(5143),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10396),
    [sym__immediate_command_start] = ACTIONS(10398),
  },
  [5144] = {
    [sym_block_comment] = STATE(5144),
    [sym_line_comment] = STATE(5144),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_else] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_DASH_GT] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5145] = {
    [sym_block_comment] = STATE(5145),
    [sym_line_comment] = STATE(5145),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5146] = {
    [sym_block_comment] = STATE(5146),
    [sym_line_comment] = STATE(5146),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5147] = {
    [sym_block_comment] = STATE(5147),
    [sym_line_comment] = STATE(5147),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5148] = {
    [sym_block_comment] = STATE(5148),
    [sym_line_comment] = STATE(5148),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_elseif] = ACTIONS(9836),
    [anon_sym_else] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5149] = {
    [sym_block_comment] = STATE(5149),
    [sym_line_comment] = STATE(5149),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(10406),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(10406),
    [sym__arrow_operator] = ACTIONS(10406),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(10406),
    [sym__pipe_right_operator] = ACTIONS(10406),
    [sym__pipe_left_operator] = ACTIONS(10406),
    [sym__ellipsis_operator] = ACTIONS(10406),
    [sym__plus_operator] = ACTIONS(10406),
    [sym__times_operator] = ACTIONS(10406),
    [sym__rational_operator] = ACTIONS(10406),
    [sym__bitshift_operator] = ACTIONS(10406),
    [sym__power_operator] = ACTIONS(10406),
    [sym__tilde_operator] = ACTIONS(10406),
    [sym__type_order_operator] = ACTIONS(10406),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(10406),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5150] = {
    [sym_block_comment] = STATE(5150),
    [sym_line_comment] = STATE(5150),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_elseif] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_DASH_GT] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5151] = {
    [sym_do_clause] = STATE(6117),
    [sym_block_comment] = STATE(5151),
    [sym_line_comment] = STATE(5151),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10409),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5152] = {
    [sym__primary_expression] = STATE(11417),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11070),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(5152),
    [sym_line_comment] = STATE(5152),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10411),
    [anon_sym_COLON2] = ACTIONS(10413),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5153] = {
    [sym_block_comment] = STATE(5153),
    [sym_line_comment] = STATE(5153),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_elseif] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_DASH_GT] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5154] = {
    [sym_block_comment] = STATE(5154),
    [sym_line_comment] = STATE(5154),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_elseif] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_DASH_GT] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5155] = {
    [sym__assignment_operator] = STATE(2973),
    [sym_block_comment] = STATE(5155),
    [sym_line_comment] = STATE(5155),
    [sym__word_identifier] = ACTIONS(10415),
    [anon_sym_begin] = ACTIONS(10415),
    [anon_sym_module] = ACTIONS(10415),
    [anon_sym_baremodule] = ACTIONS(10415),
    [anon_sym_end] = ACTIONS(10415),
    [anon_sym_abstract] = ACTIONS(10415),
    [anon_sym_primitive] = ACTIONS(10415),
    [anon_sym_mutable] = ACTIONS(10415),
    [anon_sym_struct] = ACTIONS(10415),
    [anon_sym_function] = ACTIONS(10415),
    [anon_sym_macro] = ACTIONS(10415),
    [anon_sym_quote] = ACTIONS(10415),
    [anon_sym_let] = ACTIONS(10415),
    [anon_sym_if] = ACTIONS(10415),
    [anon_sym_try] = ACTIONS(10415),
    [anon_sym_for] = ACTIONS(10415),
    [anon_sym_while] = ACTIONS(10415),
    [sym_break_statement] = ACTIONS(10415),
    [sym_continue_statement] = ACTIONS(10415),
    [anon_sym_return] = ACTIONS(10415),
    [anon_sym_const] = ACTIONS(10415),
    [anon_sym_global] = ACTIONS(10415),
    [anon_sym_local] = ACTIONS(10415),
    [anon_sym_LPAREN] = ACTIONS(10415),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(10415),
    [anon_sym_public] = ACTIONS(10415),
    [anon_sym_import] = ACTIONS(10415),
    [anon_sym_using] = ACTIONS(10415),
    [anon_sym_LBRACK] = ACTIONS(10415),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10415),
    [anon_sym_SQUOTE] = ACTIONS(10176),
    [anon_sym_DOT] = ACTIONS(10417),
    [anon_sym_DOLLAR] = ACTIONS(10415),
    [anon_sym_COLON2] = ACTIONS(10415),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_COLON_EQ] = ACTIONS(9768),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10415),
    [anon_sym_true] = ACTIONS(10415),
    [anon_sym_false] = ACTIONS(10415),
    [aux_sym_integer_literal_token1] = ACTIONS(10415),
    [aux_sym_integer_literal_token2] = ACTIONS(10415),
    [aux_sym_integer_literal_token3] = ACTIONS(10415),
    [aux_sym_integer_literal_token4] = ACTIONS(10415),
    [aux_sym_float_literal_token1] = ACTIONS(10415),
    [aux_sym_float_literal_token3] = ACTIONS(10415),
    [aux_sym_float_literal_token4] = ACTIONS(10415),
    [sym_character_literal] = ACTIONS(10415),
    [anon_sym_DQUOTE] = ACTIONS(10415),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10415),
    [anon_sym_BQUOTE] = ACTIONS(10415),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10415),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9768),
    [aux_sym__assignment_operator_token1] = ACTIONS(9768),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(10419),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(10415),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(10421),
    [aux_sym__terminator_token2] = ACTIONS(10415),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
    [sym__immediate_bracket] = ACTIONS(10182),
    [sym__immediate_brace] = ACTIONS(10184),
  },
  [5156] = {
    [sym_block_comment] = STATE(5156),
    [sym_line_comment] = STATE(5156),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_COLON_EQ] = ACTIONS(9746),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_DASH_GT] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9746),
    [aux_sym__assignment_operator_token1] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5157] = {
    [sym__assignment_operator] = STATE(3673),
    [sym_block_comment] = STATE(5157),
    [sym_line_comment] = STATE(5157),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10338),
    [anon_sym_DOT] = ACTIONS(10400),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
    [sym__immediate_bracket] = ACTIONS(10344),
    [sym__immediate_brace] = ACTIONS(10346),
  },
  [5158] = {
    [sym_block_comment] = STATE(5158),
    [sym_line_comment] = STATE(5158),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_elseif] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_DASH_GT] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5159] = {
    [sym_block_comment] = STATE(5159),
    [sym_line_comment] = STATE(5159),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9756),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9756),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9756),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9756),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9756),
    [anon_sym_COLON_EQ] = ACTIONS(9756),
    [anon_sym_DOT_EQ] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9756),
    [anon_sym_QMARK] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9756),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9756),
    [aux_sym_integer_literal_token2] = ACTIONS(9756),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9756),
    [aux_sym_float_literal_token3] = ACTIONS(9756),
    [aux_sym_float_literal_token4] = ACTIONS(9756),
    [sym_character_literal] = ACTIONS(9756),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9756),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9756),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9756),
    [aux_sym__assignment_operator_token1] = ACTIONS(9756),
    [sym__pair_operator] = ACTIONS(9756),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9756),
    [sym__lazy_and_operator] = ACTIONS(9756),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9756),
    [sym__pipe_left_operator] = ACTIONS(9756),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9756),
    [sym__type_order_operator] = ACTIONS(9756),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5160] = {
    [sym_block_comment] = STATE(5160),
    [sym_line_comment] = STATE(5160),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9834),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9834),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9834),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9834),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9834),
    [anon_sym_COLON_EQ] = ACTIONS(9834),
    [anon_sym_DOT_EQ] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9834),
    [anon_sym_QMARK] = ACTIONS(9834),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9834),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9834),
    [aux_sym_integer_literal_token2] = ACTIONS(9834),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9834),
    [aux_sym_float_literal_token3] = ACTIONS(9834),
    [aux_sym_float_literal_token4] = ACTIONS(9834),
    [sym_character_literal] = ACTIONS(9834),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9834),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9834),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9834),
    [aux_sym__assignment_operator_token1] = ACTIONS(9834),
    [sym__pair_operator] = ACTIONS(9834),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9834),
    [sym__lazy_and_operator] = ACTIONS(9834),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9834),
    [sym__pipe_left_operator] = ACTIONS(9834),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9834),
    [sym__type_order_operator] = ACTIONS(9834),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5161] = {
    [sym_block_comment] = STATE(5161),
    [sym_line_comment] = STATE(5161),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_elseif] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_DASH_GT] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5162] = {
    [sym_block_comment] = STATE(5162),
    [sym_line_comment] = STATE(5162),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_elseif] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5163] = {
    [sym_block_comment] = STATE(5163),
    [sym_line_comment] = STATE(5163),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_DASH_GT] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5164] = {
    [sym_block_comment] = STATE(5164),
    [sym_line_comment] = STATE(5164),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_DASH_GT] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5165] = {
    [sym_block_comment] = STATE(5165),
    [sym_line_comment] = STATE(5165),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_DASH_GT] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5166] = {
    [sym_block_comment] = STATE(5166),
    [sym_line_comment] = STATE(5166),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_DASH_GT] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5167] = {
    [sym_do_clause] = STATE(6149),
    [sym_block_comment] = STATE(5167),
    [sym_line_comment] = STATE(5167),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_catch] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10385),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5168] = {
    [sym_block_comment] = STATE(5168),
    [sym_line_comment] = STATE(5168),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_DASH_GT] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5169] = {
    [sym_block_comment] = STATE(5169),
    [sym_line_comment] = STATE(5169),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_DASH_GT] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5170] = {
    [sym_block_comment] = STATE(5170),
    [sym_line_comment] = STATE(5170),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_DASH_GT] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5171] = {
    [sym_block_comment] = STATE(5171),
    [sym_line_comment] = STATE(5171),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_DASH_GT] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5172] = {
    [sym_block_comment] = STATE(5172),
    [sym_line_comment] = STATE(5172),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_DASH_GT] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5173] = {
    [sym_block_comment] = STATE(5173),
    [sym_line_comment] = STATE(5173),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(10423),
    [anon_sym_COLON_EQ] = ACTIONS(9788),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9788),
    [aux_sym__assignment_operator_token1] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(10423),
    [sym__arrow_operator] = ACTIONS(10423),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(10423),
    [sym__pipe_right_operator] = ACTIONS(10423),
    [sym__pipe_left_operator] = ACTIONS(10423),
    [sym__ellipsis_operator] = ACTIONS(10423),
    [sym__plus_operator] = ACTIONS(10423),
    [sym__times_operator] = ACTIONS(10423),
    [sym__rational_operator] = ACTIONS(10423),
    [sym__bitshift_operator] = ACTIONS(10423),
    [sym__power_operator] = ACTIONS(10423),
    [sym__tilde_operator] = ACTIONS(10423),
    [sym__type_order_operator] = ACTIONS(10423),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(10423),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5174] = {
    [sym_block_comment] = STATE(5174),
    [sym_line_comment] = STATE(5174),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_DASH_GT] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5175] = {
    [sym_block_comment] = STATE(5175),
    [sym_line_comment] = STATE(5175),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_DASH_GT] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5176] = {
    [sym_block_comment] = STATE(5176),
    [sym_line_comment] = STATE(5176),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5177] = {
    [sym_block_comment] = STATE(5177),
    [sym_line_comment] = STATE(5177),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5178] = {
    [sym_block_comment] = STATE(5178),
    [sym_line_comment] = STATE(5178),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_DASH_GT] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5179] = {
    [sym_block_comment] = STATE(5179),
    [sym_line_comment] = STATE(5179),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_DASH_GT] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5180] = {
    [sym_block_comment] = STATE(5180),
    [sym_line_comment] = STATE(5180),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_DASH_GT] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5181] = {
    [sym_block_comment] = STATE(5181),
    [sym_line_comment] = STATE(5181),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9758),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9758),
    [anon_sym_COLON_EQ] = ACTIONS(9758),
    [anon_sym_DOT_EQ] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9758),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9758),
    [aux_sym_integer_literal_token2] = ACTIONS(9758),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9758),
    [aux_sym_float_literal_token3] = ACTIONS(9758),
    [aux_sym_float_literal_token4] = ACTIONS(9758),
    [sym_character_literal] = ACTIONS(9758),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9758),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9758),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9758),
    [aux_sym__assignment_operator_token1] = ACTIONS(9758),
    [sym__pair_operator] = ACTIONS(9758),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9758),
    [sym__lazy_and_operator] = ACTIONS(9758),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9758),
    [sym__pipe_left_operator] = ACTIONS(9758),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9758),
    [sym__type_order_operator] = ACTIONS(9758),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5182] = {
    [sym_block_comment] = STATE(5182),
    [sym_line_comment] = STATE(5182),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_DASH_GT] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5183] = {
    [sym_block_comment] = STATE(5183),
    [sym_line_comment] = STATE(5183),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5184] = {
    [sym_block_comment] = STATE(5184),
    [sym_line_comment] = STATE(5184),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_DASH_GT] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5185] = {
    [sym_block_comment] = STATE(5185),
    [sym_line_comment] = STATE(5185),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_DASH_GT] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5186] = {
    [sym_block_comment] = STATE(5186),
    [sym_line_comment] = STATE(5186),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_DASH_GT] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5187] = {
    [sym_block_comment] = STATE(5187),
    [sym_line_comment] = STATE(5187),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_DASH_GT] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5188] = {
    [sym_block_comment] = STATE(5188),
    [sym_line_comment] = STATE(5188),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DASH_GT] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5189] = {
    [sym_block_comment] = STATE(5189),
    [sym_line_comment] = STATE(5189),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_DASH_GT] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5190] = {
    [sym_block_comment] = STATE(5190),
    [sym_line_comment] = STATE(5190),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_DASH_GT] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5191] = {
    [sym_block_comment] = STATE(5191),
    [sym_line_comment] = STATE(5191),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_DASH_GT] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5192] = {
    [sym_block_comment] = STATE(5192),
    [sym_line_comment] = STATE(5192),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_DASH_GT] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5193] = {
    [sym_block_comment] = STATE(5193),
    [sym_line_comment] = STATE(5193),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_DASH_GT] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5194] = {
    [sym_block_comment] = STATE(5194),
    [sym_line_comment] = STATE(5194),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_DASH_GT] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5195] = {
    [sym_do_clause] = STATE(6020),
    [sym_block_comment] = STATE(5195),
    [sym_line_comment] = STATE(5195),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10383),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5196] = {
    [sym_block_comment] = STATE(5196),
    [sym_line_comment] = STATE(5196),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9838),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9838),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9838),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9838),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9838),
    [anon_sym_COLON_EQ] = ACTIONS(9838),
    [anon_sym_DOT_EQ] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9838),
    [anon_sym_QMARK] = ACTIONS(9838),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9838),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9838),
    [aux_sym_integer_literal_token2] = ACTIONS(9838),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9838),
    [aux_sym_float_literal_token3] = ACTIONS(9838),
    [aux_sym_float_literal_token4] = ACTIONS(9838),
    [sym_character_literal] = ACTIONS(9838),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9838),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9838),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9838),
    [aux_sym__assignment_operator_token1] = ACTIONS(9838),
    [sym__pair_operator] = ACTIONS(9838),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9838),
    [sym__lazy_and_operator] = ACTIONS(9838),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9838),
    [sym__pipe_left_operator] = ACTIONS(9838),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9838),
    [sym__type_order_operator] = ACTIONS(9838),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5197] = {
    [sym_block_comment] = STATE(5197),
    [sym_line_comment] = STATE(5197),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9820),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9820),
    [anon_sym_RPAREN] = ACTIONS(9820),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9820),
    [anon_sym_RBRACK] = ACTIONS(9820),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_SEMI] = ACTIONS(9820),
    [anon_sym_LBRACE] = ACTIONS(9820),
    [anon_sym_RBRACE] = ACTIONS(9820),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9820),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9820),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9820),
    [anon_sym_QMARK] = ACTIONS(9820),
    [anon_sym_DASH_GT] = ACTIONS(9820),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9820),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9820),
    [aux_sym_integer_literal_token2] = ACTIONS(9820),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9820),
    [aux_sym_float_literal_token3] = ACTIONS(9820),
    [aux_sym_float_literal_token4] = ACTIONS(9820),
    [sym_character_literal] = ACTIONS(9820),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9820),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9820),
    [sym__pair_operator] = ACTIONS(9820),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9820),
    [sym__lazy_and_operator] = ACTIONS(9820),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9820),
    [sym__pipe_left_operator] = ACTIONS(9820),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9820),
    [sym__bitshift_operator] = ACTIONS(9820),
    [sym__power_operator] = ACTIONS(9820),
    [sym__tilde_operator] = ACTIONS(9820),
    [sym__type_order_operator] = ACTIONS(9820),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5198] = {
    [sym_block_comment] = STATE(5198),
    [sym_line_comment] = STATE(5198),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9822),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9822),
    [anon_sym_RPAREN] = ACTIONS(9822),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9822),
    [anon_sym_RBRACK] = ACTIONS(9822),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_SEMI] = ACTIONS(9822),
    [anon_sym_LBRACE] = ACTIONS(9822),
    [anon_sym_RBRACE] = ACTIONS(9822),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9822),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9822),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9822),
    [anon_sym_QMARK] = ACTIONS(9822),
    [anon_sym_DASH_GT] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9822),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9822),
    [aux_sym_integer_literal_token2] = ACTIONS(9822),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9822),
    [aux_sym_float_literal_token3] = ACTIONS(9822),
    [aux_sym_float_literal_token4] = ACTIONS(9822),
    [sym_character_literal] = ACTIONS(9822),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9822),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9822),
    [sym__pair_operator] = ACTIONS(9822),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9822),
    [sym__lazy_and_operator] = ACTIONS(9822),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9822),
    [sym__pipe_left_operator] = ACTIONS(9822),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9822),
    [sym__bitshift_operator] = ACTIONS(9822),
    [sym__power_operator] = ACTIONS(9822),
    [sym__tilde_operator] = ACTIONS(9822),
    [sym__type_order_operator] = ACTIONS(9822),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5199] = {
    [sym_block_comment] = STATE(5199),
    [sym_line_comment] = STATE(5199),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_elseif] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_DASH_GT] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5200] = {
    [sym_block_comment] = STATE(5200),
    [sym_line_comment] = STATE(5200),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_elseif] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_DASH_GT] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5201] = {
    [sym_block_comment] = STATE(5201),
    [sym_line_comment] = STATE(5201),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5202] = {
    [sym_block_comment] = STATE(5202),
    [sym_line_comment] = STATE(5202),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5203] = {
    [sym_block_comment] = STATE(5203),
    [sym_line_comment] = STATE(5203),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9826),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9826),
    [anon_sym_RPAREN] = ACTIONS(9826),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9826),
    [anon_sym_RBRACK] = ACTIONS(9826),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_SEMI] = ACTIONS(9826),
    [anon_sym_LBRACE] = ACTIONS(9826),
    [anon_sym_RBRACE] = ACTIONS(9826),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9826),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9826),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9826),
    [anon_sym_QMARK] = ACTIONS(9826),
    [anon_sym_DASH_GT] = ACTIONS(9826),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9826),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9826),
    [aux_sym_integer_literal_token2] = ACTIONS(9826),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9826),
    [aux_sym_float_literal_token3] = ACTIONS(9826),
    [aux_sym_float_literal_token4] = ACTIONS(9826),
    [sym_character_literal] = ACTIONS(9826),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9826),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9826),
    [sym__pair_operator] = ACTIONS(9826),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9826),
    [sym__lazy_and_operator] = ACTIONS(9826),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9826),
    [sym__pipe_left_operator] = ACTIONS(9826),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9826),
    [sym__bitshift_operator] = ACTIONS(9826),
    [sym__power_operator] = ACTIONS(9826),
    [sym__tilde_operator] = ACTIONS(9826),
    [sym__type_order_operator] = ACTIONS(9826),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5204] = {
    [sym_do_clause] = STATE(6101),
    [sym_block_comment] = STATE(5204),
    [sym_line_comment] = STATE(5204),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_catch] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10409),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5205] = {
    [sym_do_clause] = STATE(6014),
    [sym_block_comment] = STATE(5205),
    [sym_line_comment] = STATE(5205),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10383),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5206] = {
    [sym_block_comment] = STATE(5206),
    [sym_line_comment] = STATE(5206),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10396),
    [sym__immediate_command_start] = ACTIONS(10398),
  },
  [5207] = {
    [sym_block_comment] = STATE(5207),
    [sym_line_comment] = STATE(5207),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_DASH_GT] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5208] = {
    [sym_block_comment] = STATE(5208),
    [sym_line_comment] = STATE(5208),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_elseif] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_DASH_GT] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5209] = {
    [sym_block_comment] = STATE(5209),
    [sym_line_comment] = STATE(5209),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_elseif] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DASH_GT] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5210] = {
    [sym_block_comment] = STATE(5210),
    [sym_line_comment] = STATE(5210),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_DASH_GT] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5211] = {
    [sym_block_comment] = STATE(5211),
    [sym_line_comment] = STATE(5211),
    [ts_builtin_sym_end] = ACTIONS(9838),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_RBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5212] = {
    [sym_block_comment] = STATE(5212),
    [sym_line_comment] = STATE(5212),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10426),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5213] = {
    [sym_block_comment] = STATE(5213),
    [sym_line_comment] = STATE(5213),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10348),
    [sym__immediate_command_start] = ACTIONS(10350),
  },
  [5214] = {
    [sym_block_comment] = STATE(5214),
    [sym_line_comment] = STATE(5214),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10402),
    [sym__immediate_command_start] = ACTIONS(10404),
  },
  [5215] = {
    [sym_block_comment] = STATE(5215),
    [sym_line_comment] = STATE(5215),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_DASH_GT] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10428),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5216] = {
    [sym_block_comment] = STATE(5216),
    [sym_line_comment] = STATE(5216),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9806),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9806),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9806),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9806),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9806),
    [anon_sym_COLON_EQ] = ACTIONS(9806),
    [anon_sym_DOT_EQ] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9806),
    [anon_sym_QMARK] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9806),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9806),
    [aux_sym_integer_literal_token2] = ACTIONS(9806),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9806),
    [aux_sym_float_literal_token3] = ACTIONS(9806),
    [aux_sym_float_literal_token4] = ACTIONS(9806),
    [sym_character_literal] = ACTIONS(9806),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9806),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9806),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9806),
    [aux_sym__assignment_operator_token1] = ACTIONS(9806),
    [sym__pair_operator] = ACTIONS(9806),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9806),
    [sym__lazy_and_operator] = ACTIONS(9806),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9806),
    [sym__pipe_left_operator] = ACTIONS(9806),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9806),
    [sym__type_order_operator] = ACTIONS(9806),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5217] = {
    [sym_block_comment] = STATE(5217),
    [sym_line_comment] = STATE(5217),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10348),
    [sym__immediate_command_start] = ACTIONS(10350),
  },
  [5218] = {
    [sym_do_clause] = STATE(6153),
    [sym_block_comment] = STATE(5218),
    [sym_line_comment] = STATE(5218),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10385),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5219] = {
    [sym_block_comment] = STATE(5219),
    [sym_line_comment] = STATE(5219),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9756),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9756),
    [anon_sym_RPAREN] = ACTIONS(9756),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9756),
    [anon_sym_RBRACK] = ACTIONS(9756),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_SEMI] = ACTIONS(9756),
    [anon_sym_LBRACE] = ACTIONS(9756),
    [anon_sym_RBRACE] = ACTIONS(9756),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9756),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9756),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9756),
    [anon_sym_QMARK] = ACTIONS(9756),
    [anon_sym_DASH_GT] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9756),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9756),
    [aux_sym_integer_literal_token2] = ACTIONS(9756),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9756),
    [aux_sym_float_literal_token3] = ACTIONS(9756),
    [aux_sym_float_literal_token4] = ACTIONS(9756),
    [sym_character_literal] = ACTIONS(9756),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9756),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9756),
    [sym__pair_operator] = ACTIONS(9756),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9756),
    [sym__lazy_and_operator] = ACTIONS(9756),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9756),
    [sym__pipe_left_operator] = ACTIONS(9756),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9756),
    [sym__bitshift_operator] = ACTIONS(9756),
    [sym__power_operator] = ACTIONS(9756),
    [sym__tilde_operator] = ACTIONS(9756),
    [sym__type_order_operator] = ACTIONS(9756),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5220] = {
    [sym_block_comment] = STATE(5220),
    [sym_line_comment] = STATE(5220),
    [ts_builtin_sym_end] = ACTIONS(9834),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_RBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5221] = {
    [sym_block_comment] = STATE(5221),
    [sym_line_comment] = STATE(5221),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_elseif] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_DASH_GT] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5222] = {
    [sym_block_comment] = STATE(5222),
    [sym_line_comment] = STATE(5222),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_else] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_DASH_GT] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5223] = {
    [sym_block_comment] = STATE(5223),
    [sym_line_comment] = STATE(5223),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9830),
    [anon_sym_RPAREN] = ACTIONS(9830),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9830),
    [anon_sym_RBRACK] = ACTIONS(9830),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_SEMI] = ACTIONS(9830),
    [anon_sym_LBRACE] = ACTIONS(9830),
    [anon_sym_RBRACE] = ACTIONS(9830),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9830),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9830),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9830),
    [anon_sym_QMARK] = ACTIONS(9830),
    [anon_sym_DASH_GT] = ACTIONS(9830),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9830),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9830),
    [aux_sym_integer_literal_token2] = ACTIONS(9830),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9830),
    [aux_sym_float_literal_token3] = ACTIONS(9830),
    [aux_sym_float_literal_token4] = ACTIONS(9830),
    [sym_character_literal] = ACTIONS(9830),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9830),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9830),
    [sym__pair_operator] = ACTIONS(9830),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9830),
    [sym__lazy_and_operator] = ACTIONS(9830),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9830),
    [sym__pipe_left_operator] = ACTIONS(9830),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9830),
    [sym__bitshift_operator] = ACTIONS(9830),
    [sym__power_operator] = ACTIONS(9830),
    [sym__tilde_operator] = ACTIONS(9830),
    [sym__type_order_operator] = ACTIONS(9830),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5224] = {
    [sym_block_comment] = STATE(5224),
    [sym_line_comment] = STATE(5224),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10430),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5225] = {
    [sym_identifier] = STATE(5827),
    [sym_block_comment] = STATE(5225),
    [sym_line_comment] = STATE(5225),
    [ts_builtin_sym_end] = ACTIONS(9782),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_RBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_DASH_GT] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5226] = {
    [sym_block_comment] = STATE(5226),
    [sym_line_comment] = STATE(5226),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9834),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9834),
    [anon_sym_RPAREN] = ACTIONS(9834),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9834),
    [anon_sym_RBRACK] = ACTIONS(9834),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_SEMI] = ACTIONS(9834),
    [anon_sym_LBRACE] = ACTIONS(9834),
    [anon_sym_RBRACE] = ACTIONS(9834),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9834),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9834),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9834),
    [anon_sym_QMARK] = ACTIONS(9834),
    [anon_sym_DASH_GT] = ACTIONS(9834),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9834),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9834),
    [aux_sym_integer_literal_token2] = ACTIONS(9834),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9834),
    [aux_sym_float_literal_token3] = ACTIONS(9834),
    [aux_sym_float_literal_token4] = ACTIONS(9834),
    [sym_character_literal] = ACTIONS(9834),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9834),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9834),
    [sym__pair_operator] = ACTIONS(9834),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9834),
    [sym__lazy_and_operator] = ACTIONS(9834),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9834),
    [sym__pipe_left_operator] = ACTIONS(9834),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9834),
    [sym__bitshift_operator] = ACTIONS(9834),
    [sym__power_operator] = ACTIONS(9834),
    [sym__tilde_operator] = ACTIONS(9834),
    [sym__type_order_operator] = ACTIONS(9834),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5227] = {
    [sym_identifier] = STATE(5828),
    [sym_block_comment] = STATE(5227),
    [sym_line_comment] = STATE(5227),
    [ts_builtin_sym_end] = ACTIONS(9786),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_RBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_DASH_GT] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5228] = {
    [sym_identifier] = STATE(5831),
    [sym_block_comment] = STATE(5228),
    [sym_line_comment] = STATE(5228),
    [ts_builtin_sym_end] = ACTIONS(9798),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_RBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_DASH_GT] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5229] = {
    [sym_identifier] = STATE(5832),
    [sym_block_comment] = STATE(5229),
    [sym_line_comment] = STATE(5229),
    [ts_builtin_sym_end] = ACTIONS(9802),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_RBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_DASH_GT] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5230] = {
    [sym_block_comment] = STATE(5230),
    [sym_line_comment] = STATE(5230),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5231] = {
    [sym_block_comment] = STATE(5231),
    [sym_line_comment] = STATE(5231),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_else] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5232] = {
    [sym_block_comment] = STATE(5232),
    [sym_line_comment] = STATE(5232),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5233] = {
    [sym_block_comment] = STATE(5233),
    [sym_line_comment] = STATE(5233),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_DASH_GT] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5234] = {
    [sym_block_comment] = STATE(5234),
    [sym_line_comment] = STATE(5234),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_DASH_GT] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5235] = {
    [sym_block_comment] = STATE(5235),
    [sym_line_comment] = STATE(5235),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10389),
    [sym__immediate_command_start] = ACTIONS(10391),
  },
  [5236] = {
    [sym_identifier] = STATE(5898),
    [sym_block_comment] = STATE(5236),
    [sym_line_comment] = STATE(5236),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_RPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_RBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_SEMI] = ACTIONS(9782),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_RBRACE] = ACTIONS(9782),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_DASH_GT] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5237] = {
    [sym_identifier] = STATE(5900),
    [sym_block_comment] = STATE(5237),
    [sym_line_comment] = STATE(5237),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_RPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_RBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_SEMI] = ACTIONS(9786),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_DASH_GT] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5238] = {
    [sym_identifier] = STATE(5904),
    [sym_block_comment] = STATE(5238),
    [sym_line_comment] = STATE(5238),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_RPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_RBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_SEMI] = ACTIONS(9798),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_RBRACE] = ACTIONS(9798),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_DASH_GT] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5239] = {
    [sym_identifier] = STATE(5905),
    [sym_block_comment] = STATE(5239),
    [sym_line_comment] = STATE(5239),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_RPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_RBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_SEMI] = ACTIONS(9802),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_RBRACE] = ACTIONS(9802),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_DASH_GT] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5240] = {
    [sym_block_comment] = STATE(5240),
    [sym_line_comment] = STATE(5240),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10432),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5241] = {
    [sym_block_comment] = STATE(5241),
    [sym_line_comment] = STATE(5241),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5242] = {
    [sym_block_comment] = STATE(5242),
    [sym_line_comment] = STATE(5242),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5243] = {
    [sym_do_clause] = STATE(6215),
    [sym_block_comment] = STATE(5243),
    [sym_line_comment] = STATE(5243),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_finally] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10434),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5244] = {
    [sym_block_comment] = STATE(5244),
    [sym_line_comment] = STATE(5244),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10402),
    [sym__immediate_command_start] = ACTIONS(10404),
  },
  [5245] = {
    [sym_block_comment] = STATE(5245),
    [sym_line_comment] = STATE(5245),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_COLON_EQ] = ACTIONS(9734),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10436),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9734),
    [aux_sym__assignment_operator_token1] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5246] = {
    [sym_identifier] = STATE(5932),
    [sym_block_comment] = STATE(5246),
    [sym_line_comment] = STATE(5246),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5247] = {
    [sym_identifier] = STATE(5933),
    [sym_block_comment] = STATE(5247),
    [sym_line_comment] = STATE(5247),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5248] = {
    [sym_identifier] = STATE(5936),
    [sym_block_comment] = STATE(5248),
    [sym_line_comment] = STATE(5248),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5249] = {
    [sym_identifier] = STATE(5937),
    [sym_block_comment] = STATE(5249),
    [sym_line_comment] = STATE(5249),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5250] = {
    [sym_do_clause] = STATE(6217),
    [sym_block_comment] = STATE(5250),
    [sym_line_comment] = STATE(5250),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10434),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5251] = {
    [sym_block_comment] = STATE(5251),
    [sym_line_comment] = STATE(5251),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_elseif] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_DASH_GT] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5252] = {
    [sym_block_comment] = STATE(5252),
    [sym_line_comment] = STATE(5252),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10438),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5253] = {
    [sym_block_comment] = STATE(5253),
    [sym_line_comment] = STATE(5253),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_COLON_EQ] = ACTIONS(9728),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_DASH_GT] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9728),
    [aux_sym__assignment_operator_token1] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5254] = {
    [sym_block_comment] = STATE(5254),
    [sym_line_comment] = STATE(5254),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9808),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9808),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9808),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9808),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9808),
    [anon_sym_COLON_EQ] = ACTIONS(9808),
    [anon_sym_DOT_EQ] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9808),
    [anon_sym_QMARK] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9808),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9808),
    [aux_sym_integer_literal_token2] = ACTIONS(9808),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9808),
    [aux_sym_float_literal_token3] = ACTIONS(9808),
    [aux_sym_float_literal_token4] = ACTIONS(9808),
    [sym_character_literal] = ACTIONS(9808),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9808),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9808),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9808),
    [aux_sym__assignment_operator_token1] = ACTIONS(9808),
    [sym__pair_operator] = ACTIONS(9808),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9808),
    [sym__lazy_and_operator] = ACTIONS(9808),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9808),
    [sym__pipe_left_operator] = ACTIONS(9808),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9808),
    [sym__type_order_operator] = ACTIONS(9808),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5255] = {
    [sym_do_clause] = STATE(6219),
    [sym_block_comment] = STATE(5255),
    [sym_line_comment] = STATE(5255),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10434),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5256] = {
    [sym_block_comment] = STATE(5256),
    [sym_line_comment] = STATE(5256),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_elseif] = ACTIONS(10322),
    [anon_sym_else] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10363),
    [anon_sym_DOT] = ACTIONS(10365),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10367),
    [sym__immediate_bracket] = ACTIONS(10369),
    [sym__immediate_brace] = ACTIONS(10371),
  },
  [5257] = {
    [sym_block_comment] = STATE(5257),
    [sym_line_comment] = STATE(5257),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_elseif] = ACTIONS(9978),
    [anon_sym_else] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_DASH_GT] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5258] = {
    [sym_block_comment] = STATE(5258),
    [sym_line_comment] = STATE(5258),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5259] = {
    [sym_block_comment] = STATE(5259),
    [sym_line_comment] = STATE(5259),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_catch] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5260] = {
    [sym_block_comment] = STATE(5260),
    [sym_line_comment] = STATE(5260),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_COLON_EQ] = ACTIONS(9762),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_DASH_GT] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9762),
    [aux_sym__assignment_operator_token1] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5261] = {
    [sym_block_comment] = STATE(5261),
    [sym_line_comment] = STATE(5261),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5262] = {
    [sym_identifier] = STATE(5399),
    [sym_block_comment] = STATE(5262),
    [sym_line_comment] = STATE(5262),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_DASH_GT] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5263] = {
    [sym_identifier] = STATE(5400),
    [sym_block_comment] = STATE(5263),
    [sym_line_comment] = STATE(5263),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_DASH_GT] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5264] = {
    [sym_identifier] = STATE(5404),
    [sym_block_comment] = STATE(5264),
    [sym_line_comment] = STATE(5264),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_DASH_GT] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5265] = {
    [sym_identifier] = STATE(5405),
    [sym_block_comment] = STATE(5265),
    [sym_line_comment] = STATE(5265),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_DASH_GT] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5266] = {
    [sym_block_comment] = STATE(5266),
    [sym_line_comment] = STATE(5266),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_elseif] = ACTIONS(9828),
    [anon_sym_else] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5267] = {
    [sym_identifier] = STATE(5431),
    [sym_block_comment] = STATE(5267),
    [sym_line_comment] = STATE(5267),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_COLON_EQ] = ACTIONS(9782),
    [anon_sym_DOT_EQ] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9782),
    [aux_sym__assignment_operator_token1] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5268] = {
    [sym_identifier] = STATE(5432),
    [sym_block_comment] = STATE(5268),
    [sym_line_comment] = STATE(5268),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_COLON_EQ] = ACTIONS(9786),
    [anon_sym_DOT_EQ] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9786),
    [aux_sym__assignment_operator_token1] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5269] = {
    [sym_identifier] = STATE(5435),
    [sym_block_comment] = STATE(5269),
    [sym_line_comment] = STATE(5269),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_COLON_EQ] = ACTIONS(9798),
    [anon_sym_DOT_EQ] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9798),
    [aux_sym__assignment_operator_token1] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5270] = {
    [sym_identifier] = STATE(5436),
    [sym_block_comment] = STATE(5270),
    [sym_line_comment] = STATE(5270),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_COLON_EQ] = ACTIONS(9802),
    [anon_sym_DOT_EQ] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9802),
    [aux_sym__assignment_operator_token1] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5271] = {
    [sym_block_comment] = STATE(5271),
    [sym_line_comment] = STATE(5271),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9812),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9812),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9812),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9812),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9812),
    [anon_sym_COLON_EQ] = ACTIONS(9812),
    [anon_sym_DOT_EQ] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9812),
    [anon_sym_QMARK] = ACTIONS(9812),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9812),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9812),
    [aux_sym_integer_literal_token2] = ACTIONS(9812),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9812),
    [aux_sym_float_literal_token3] = ACTIONS(9812),
    [aux_sym_float_literal_token4] = ACTIONS(9812),
    [sym_character_literal] = ACTIONS(9812),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9812),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9812),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9812),
    [aux_sym__assignment_operator_token1] = ACTIONS(9812),
    [sym__pair_operator] = ACTIONS(9812),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9812),
    [sym__lazy_and_operator] = ACTIONS(9812),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9812),
    [sym__pipe_left_operator] = ACTIONS(9812),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9812),
    [sym__type_order_operator] = ACTIONS(9812),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5272] = {
    [sym_block_comment] = STATE(5272),
    [sym_line_comment] = STATE(5272),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10442),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5273] = {
    [sym_block_comment] = STATE(5273),
    [sym_line_comment] = STATE(5273),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10389),
    [sym__immediate_command_start] = ACTIONS(10391),
  },
  [5274] = {
    [sym_do_clause] = STATE(5984),
    [sym_block_comment] = STATE(5274),
    [sym_line_comment] = STATE(5274),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9684),
    [anon_sym_RPAREN] = ACTIONS(9684),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9684),
    [anon_sym_RBRACK] = ACTIONS(9684),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_SEMI] = ACTIONS(9684),
    [anon_sym_LBRACE] = ACTIONS(9684),
    [anon_sym_RBRACE] = ACTIONS(9684),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10356),
    [anon_sym_DOLLAR] = ACTIONS(9684),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9684),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9684),
    [anon_sym_QMARK] = ACTIONS(9684),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9684),
    [aux_sym_integer_literal_token2] = ACTIONS(9684),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9684),
    [aux_sym_float_literal_token3] = ACTIONS(9684),
    [aux_sym_float_literal_token4] = ACTIONS(9684),
    [sym_character_literal] = ACTIONS(9684),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9684),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9684),
    [sym__pair_operator] = ACTIONS(9684),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9684),
    [sym__lazy_and_operator] = ACTIONS(9684),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9684),
    [sym__pipe_left_operator] = ACTIONS(9684),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9684),
    [sym__bitshift_operator] = ACTIONS(9684),
    [sym__power_operator] = ACTIONS(9684),
    [sym__tilde_operator] = ACTIONS(9684),
    [sym__type_order_operator] = ACTIONS(9684),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5275] = {
    [sym_block_comment] = STATE(5275),
    [sym_line_comment] = STATE(5275),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_RBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_SEMI] = ACTIONS(9708),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10352),
    [sym__immediate_command_start] = ACTIONS(10354),
  },
  [5276] = {
    [sym_block_comment] = STATE(5276),
    [sym_line_comment] = STATE(5276),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_elseif] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_DASH_GT] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5277] = {
    [sym_block_comment] = STATE(5277),
    [sym_line_comment] = STATE(5277),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9816),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9816),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9816),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9816),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9816),
    [anon_sym_COLON_EQ] = ACTIONS(9816),
    [anon_sym_DOT_EQ] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9816),
    [anon_sym_QMARK] = ACTIONS(9816),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9816),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9816),
    [aux_sym_integer_literal_token2] = ACTIONS(9816),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9816),
    [aux_sym_float_literal_token3] = ACTIONS(9816),
    [aux_sym_float_literal_token4] = ACTIONS(9816),
    [sym_character_literal] = ACTIONS(9816),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9816),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9816),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9816),
    [aux_sym__assignment_operator_token1] = ACTIONS(9816),
    [sym__pair_operator] = ACTIONS(9816),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9816),
    [sym__lazy_and_operator] = ACTIONS(9816),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9816),
    [sym__pipe_left_operator] = ACTIONS(9816),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9816),
    [sym__type_order_operator] = ACTIONS(9816),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5278] = {
    [sym_identifier] = STATE(5473),
    [sym_block_comment] = STATE(5278),
    [sym_line_comment] = STATE(5278),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_DASH_GT] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5279] = {
    [sym_identifier] = STATE(5475),
    [sym_block_comment] = STATE(5279),
    [sym_line_comment] = STATE(5279),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_DASH_GT] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5280] = {
    [sym_identifier] = STATE(5479),
    [sym_block_comment] = STATE(5280),
    [sym_line_comment] = STATE(5280),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_DASH_GT] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5281] = {
    [sym_identifier] = STATE(5480),
    [sym_block_comment] = STATE(5281),
    [sym_line_comment] = STATE(5281),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_DASH_GT] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5282] = {
    [sym_block_comment] = STATE(5282),
    [sym_line_comment] = STATE(5282),
    [ts_builtin_sym_end] = ACTIONS(9820),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_RBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5283] = {
    [sym_do_clause] = STATE(6222),
    [sym_block_comment] = STATE(5283),
    [sym_line_comment] = STATE(5283),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10434),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5284] = {
    [sym_block_comment] = STATE(5284),
    [sym_line_comment] = STATE(5284),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_catch] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5285] = {
    [sym_block_comment] = STATE(5285),
    [sym_line_comment] = STATE(5285),
    [ts_builtin_sym_end] = ACTIONS(9822),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_RBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5286] = {
    [sym_block_comment] = STATE(5286),
    [sym_line_comment] = STATE(5286),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_catch] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5287] = {
    [sym_block_comment] = STATE(5287),
    [sym_line_comment] = STATE(5287),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5288] = {
    [sym_identifier] = STATE(5526),
    [sym_block_comment] = STATE(5288),
    [sym_line_comment] = STATE(5288),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_DASH_GT] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5289] = {
    [sym_block_comment] = STATE(5289),
    [sym_line_comment] = STATE(5289),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9820),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9820),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9820),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9820),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9820),
    [anon_sym_COLON_EQ] = ACTIONS(9820),
    [anon_sym_DOT_EQ] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9820),
    [anon_sym_QMARK] = ACTIONS(9820),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9820),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9820),
    [aux_sym_integer_literal_token2] = ACTIONS(9820),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9820),
    [aux_sym_float_literal_token3] = ACTIONS(9820),
    [aux_sym_float_literal_token4] = ACTIONS(9820),
    [sym_character_literal] = ACTIONS(9820),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9820),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9820),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9820),
    [aux_sym__assignment_operator_token1] = ACTIONS(9820),
    [sym__pair_operator] = ACTIONS(9820),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9820),
    [sym__lazy_and_operator] = ACTIONS(9820),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9820),
    [sym__pipe_left_operator] = ACTIONS(9820),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9820),
    [sym__type_order_operator] = ACTIONS(9820),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5290] = {
    [sym_block_comment] = STATE(5290),
    [sym_line_comment] = STATE(5290),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_elseif] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5291] = {
    [sym_block_comment] = STATE(5291),
    [sym_line_comment] = STATE(5291),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_elseif] = ACTIONS(10142),
    [anon_sym_else] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_DASH_GT] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5292] = {
    [sym_identifier] = STATE(5527),
    [sym_block_comment] = STATE(5292),
    [sym_line_comment] = STATE(5292),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_DASH_GT] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5293] = {
    [sym_identifier] = STATE(5530),
    [sym_block_comment] = STATE(5293),
    [sym_line_comment] = STATE(5293),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_DASH_GT] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5294] = {
    [sym_identifier] = STATE(5531),
    [sym_block_comment] = STATE(5294),
    [sym_line_comment] = STATE(5294),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_DASH_GT] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5295] = {
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11089),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(5295),
    [sym_line_comment] = STATE(5295),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10444),
    [anon_sym_COLON2] = ACTIONS(10446),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5296] = {
    [sym_block_comment] = STATE(5296),
    [sym_line_comment] = STATE(5296),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9822),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9822),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9822),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9822),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9822),
    [anon_sym_COLON_EQ] = ACTIONS(9822),
    [anon_sym_DOT_EQ] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9822),
    [anon_sym_QMARK] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9822),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9822),
    [aux_sym_integer_literal_token2] = ACTIONS(9822),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9822),
    [aux_sym_float_literal_token3] = ACTIONS(9822),
    [aux_sym_float_literal_token4] = ACTIONS(9822),
    [sym_character_literal] = ACTIONS(9822),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9822),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9822),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9822),
    [aux_sym__assignment_operator_token1] = ACTIONS(9822),
    [sym__pair_operator] = ACTIONS(9822),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9822),
    [sym__lazy_and_operator] = ACTIONS(9822),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9822),
    [sym__pipe_left_operator] = ACTIONS(9822),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9822),
    [sym__type_order_operator] = ACTIONS(9822),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5297] = {
    [sym_do_clause] = STATE(6283),
    [sym_block_comment] = STATE(5297),
    [sym_line_comment] = STATE(5297),
    [ts_builtin_sym_end] = ACTIONS(9700),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_RBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10373),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5298] = {
    [sym_block_comment] = STATE(5298),
    [sym_line_comment] = STATE(5298),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9838),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9838),
    [anon_sym_RPAREN] = ACTIONS(9838),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9838),
    [anon_sym_RBRACK] = ACTIONS(9838),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_SEMI] = ACTIONS(9838),
    [anon_sym_LBRACE] = ACTIONS(9838),
    [anon_sym_RBRACE] = ACTIONS(9838),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9838),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9838),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9838),
    [anon_sym_QMARK] = ACTIONS(9838),
    [anon_sym_DASH_GT] = ACTIONS(9838),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9838),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9838),
    [aux_sym_integer_literal_token2] = ACTIONS(9838),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9838),
    [aux_sym_float_literal_token3] = ACTIONS(9838),
    [aux_sym_float_literal_token4] = ACTIONS(9838),
    [sym_character_literal] = ACTIONS(9838),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9838),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9838),
    [sym__pair_operator] = ACTIONS(9838),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9838),
    [sym__lazy_and_operator] = ACTIONS(9838),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9838),
    [sym__pipe_left_operator] = ACTIONS(9838),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9838),
    [sym__bitshift_operator] = ACTIONS(9838),
    [sym__power_operator] = ACTIONS(9838),
    [sym__tilde_operator] = ACTIONS(9838),
    [sym__type_order_operator] = ACTIONS(9838),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5299] = {
    [sym_block_comment] = STATE(5299),
    [sym_line_comment] = STATE(5299),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9826),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9826),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9826),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9826),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9826),
    [anon_sym_COLON_EQ] = ACTIONS(9826),
    [anon_sym_DOT_EQ] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9826),
    [anon_sym_QMARK] = ACTIONS(9826),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9826),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9826),
    [aux_sym_integer_literal_token2] = ACTIONS(9826),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9826),
    [aux_sym_float_literal_token3] = ACTIONS(9826),
    [aux_sym_float_literal_token4] = ACTIONS(9826),
    [sym_character_literal] = ACTIONS(9826),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9826),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9826),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9826),
    [aux_sym__assignment_operator_token1] = ACTIONS(9826),
    [sym__pair_operator] = ACTIONS(9826),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9826),
    [sym__lazy_and_operator] = ACTIONS(9826),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9826),
    [sym__pipe_left_operator] = ACTIONS(9826),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9826),
    [sym__type_order_operator] = ACTIONS(9826),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5300] = {
    [sym_block_comment] = STATE(5300),
    [sym_line_comment] = STATE(5300),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_elseif] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_DASH_GT] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5301] = {
    [sym_block_comment] = STATE(5301),
    [sym_line_comment] = STATE(5301),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_catch] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5302] = {
    [sym_block_comment] = STATE(5302),
    [sym_line_comment] = STATE(5302),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_elseif] = ACTIONS(9832),
    [anon_sym_else] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5303] = {
    [sym_do_clause] = STATE(5985),
    [sym_block_comment] = STATE(5303),
    [sym_line_comment] = STATE(5303),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_RBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_SEMI] = ACTIONS(9712),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10356),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5304] = {
    [sym_block_comment] = STATE(5304),
    [sym_line_comment] = STATE(5304),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(10448),
    [anon_sym_COLON_EQ] = ACTIONS(9750),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9750),
    [aux_sym__assignment_operator_token1] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(10448),
    [sym__arrow_operator] = ACTIONS(10448),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(10448),
    [sym__pipe_right_operator] = ACTIONS(10448),
    [sym__pipe_left_operator] = ACTIONS(10448),
    [sym__ellipsis_operator] = ACTIONS(10448),
    [sym__plus_operator] = ACTIONS(10448),
    [sym__times_operator] = ACTIONS(10448),
    [sym__rational_operator] = ACTIONS(10448),
    [sym__bitshift_operator] = ACTIONS(10448),
    [sym__power_operator] = ACTIONS(10448),
    [sym__tilde_operator] = ACTIONS(10448),
    [sym__type_order_operator] = ACTIONS(10448),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(10448),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5305] = {
    [sym_block_comment] = STATE(5305),
    [sym_line_comment] = STATE(5305),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_else] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_DASH_GT] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5306] = {
    [sym_do_clause] = STATE(6102),
    [sym_block_comment] = STATE(5306),
    [sym_line_comment] = STATE(5306),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10409),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5307] = {
    [sym_block_comment] = STATE(5307),
    [sym_line_comment] = STATE(5307),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(10451),
    [anon_sym_COLON_EQ] = ACTIONS(9760),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9760),
    [aux_sym__assignment_operator_token1] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(10451),
    [sym__arrow_operator] = ACTIONS(10451),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(10451),
    [sym__pipe_right_operator] = ACTIONS(10451),
    [sym__pipe_left_operator] = ACTIONS(10451),
    [sym__ellipsis_operator] = ACTIONS(10451),
    [sym__plus_operator] = ACTIONS(10451),
    [sym__times_operator] = ACTIONS(10451),
    [sym__rational_operator] = ACTIONS(10451),
    [sym__bitshift_operator] = ACTIONS(10451),
    [sym__power_operator] = ACTIONS(10451),
    [sym__tilde_operator] = ACTIONS(10451),
    [sym__type_order_operator] = ACTIONS(10451),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(10451),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5308] = {
    [sym_block_comment] = STATE(5308),
    [sym_line_comment] = STATE(5308),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_elseif] = ACTIONS(10128),
    [anon_sym_else] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_DASH_GT] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5309] = {
    [sym_block_comment] = STATE(5309),
    [sym_line_comment] = STATE(5309),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_COLON_EQ] = ACTIONS(9740),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_DASH_GT] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9740),
    [aux_sym__assignment_operator_token1] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5310] = {
    [sym_do_clause] = STATE(6286),
    [sym_block_comment] = STATE(5310),
    [sym_line_comment] = STATE(5310),
    [ts_builtin_sym_end] = ACTIONS(9704),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_RBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10373),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5311] = {
    [sym_block_comment] = STATE(5311),
    [sym_line_comment] = STATE(5311),
    [ts_builtin_sym_end] = ACTIONS(9826),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_RBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5312] = {
    [sym_block_comment] = STATE(5312),
    [sym_line_comment] = STATE(5312),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_elseif] = ACTIONS(9824),
    [anon_sym_else] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5313] = {
    [sym_block_comment] = STATE(5313),
    [sym_line_comment] = STATE(5313),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_elseif] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_DASH_GT] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5314] = {
    [sym_block_comment] = STATE(5314),
    [sym_line_comment] = STATE(5314),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_COLON_EQ] = ACTIONS(9754),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_DASH_GT] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9754),
    [aux_sym__assignment_operator_token1] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5315] = {
    [sym_block_comment] = STATE(5315),
    [sym_line_comment] = STATE(5315),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_elseif] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_DASH_GT] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5316] = {
    [sym_do_clause] = STATE(6110),
    [sym_block_comment] = STATE(5316),
    [sym_line_comment] = STATE(5316),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_catch] = ACTIONS(9696),
    [anon_sym_finally] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10409),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5317] = {
    [sym_block_comment] = STATE(5317),
    [sym_line_comment] = STATE(5317),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_elseif] = ACTIONS(10086),
    [anon_sym_else] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_DASH_GT] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5318] = {
    [sym_block_comment] = STATE(5318),
    [sym_line_comment] = STATE(5318),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_COLON_EQ] = ACTIONS(9792),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_DASH_GT] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9792),
    [aux_sym__assignment_operator_token1] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5319] = {
    [sym_block_comment] = STATE(5319),
    [sym_line_comment] = STATE(5319),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_elseif] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5320] = {
    [sym_do_clause] = STATE(5994),
    [sym_block_comment] = STATE(5320),
    [sym_line_comment] = STATE(5320),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9700),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9700),
    [anon_sym_RPAREN] = ACTIONS(9700),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9700),
    [anon_sym_RBRACK] = ACTIONS(9700),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_SEMI] = ACTIONS(9700),
    [anon_sym_LBRACE] = ACTIONS(9700),
    [anon_sym_RBRACE] = ACTIONS(9700),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10356),
    [anon_sym_DOLLAR] = ACTIONS(9700),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9700),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9700),
    [anon_sym_QMARK] = ACTIONS(9700),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9700),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9700),
    [aux_sym_integer_literal_token2] = ACTIONS(9700),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9700),
    [aux_sym_float_literal_token3] = ACTIONS(9700),
    [aux_sym_float_literal_token4] = ACTIONS(9700),
    [sym_character_literal] = ACTIONS(9700),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9700),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9700),
    [sym__pair_operator] = ACTIONS(9700),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9700),
    [sym__lazy_and_operator] = ACTIONS(9700),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9700),
    [sym__pipe_left_operator] = ACTIONS(9700),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9700),
    [sym__bitshift_operator] = ACTIONS(9700),
    [sym__power_operator] = ACTIONS(9700),
    [sym__tilde_operator] = ACTIONS(9700),
    [sym__type_order_operator] = ACTIONS(9700),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5321] = {
    [sym_block_comment] = STATE(5321),
    [sym_line_comment] = STATE(5321),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_elseif] = ACTIONS(9752),
    [anon_sym_else] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5322] = {
    [sym_identifier] = STATE(5600),
    [sym_block_comment] = STATE(5322),
    [sym_line_comment] = STATE(5322),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_elseif] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5323] = {
    [sym_block_comment] = STATE(5323),
    [sym_line_comment] = STATE(5323),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_catch] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5324] = {
    [sym_block_comment] = STATE(5324),
    [sym_line_comment] = STATE(5324),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5325] = {
    [sym_block_comment] = STATE(5325),
    [sym_line_comment] = STATE(5325),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_elseif] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5326] = {
    [sym_block_comment] = STATE(5326),
    [sym_line_comment] = STATE(5326),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_else] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5327] = {
    [sym_block_comment] = STATE(5327),
    [sym_line_comment] = STATE(5327),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_elseif] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5328] = {
    [sym__assignment_operator] = STATE(3673),
    [sym_block_comment] = STATE(5328),
    [sym_line_comment] = STATE(5328),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10338),
    [anon_sym_DOT] = ACTIONS(10400),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
    [sym__immediate_bracket] = ACTIONS(10344),
    [sym__immediate_brace] = ACTIONS(10346),
  },
  [5329] = {
    [sym_block_comment] = STATE(5329),
    [sym_line_comment] = STATE(5329),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(10454),
    [anon_sym_COLON_EQ] = ACTIONS(9742),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9742),
    [aux_sym__assignment_operator_token1] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(10454),
    [sym__arrow_operator] = ACTIONS(10454),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(10454),
    [sym__pipe_right_operator] = ACTIONS(10454),
    [sym__pipe_left_operator] = ACTIONS(10454),
    [sym__ellipsis_operator] = ACTIONS(10454),
    [sym__plus_operator] = ACTIONS(10454),
    [sym__times_operator] = ACTIONS(10454),
    [sym__rational_operator] = ACTIONS(10454),
    [sym__bitshift_operator] = ACTIONS(10454),
    [sym__power_operator] = ACTIONS(10454),
    [sym__tilde_operator] = ACTIONS(10454),
    [sym__type_order_operator] = ACTIONS(10454),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(10454),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5330] = {
    [sym_block_comment] = STATE(5330),
    [sym_line_comment] = STATE(5330),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5331] = {
    [sym_block_comment] = STATE(5331),
    [sym_line_comment] = STATE(5331),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_elseif] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_DASH_GT] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5332] = {
    [sym_block_comment] = STATE(5332),
    [sym_line_comment] = STATE(5332),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_else] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5333] = {
    [sym_block_comment] = STATE(5333),
    [sym_line_comment] = STATE(5333),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_elseif] = ACTIONS(9954),
    [anon_sym_else] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_DASH_GT] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5334] = {
    [sym_block_comment] = STATE(5334),
    [sym_line_comment] = STATE(5334),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_elseif] = ACTIONS(9962),
    [anon_sym_else] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_DASH_GT] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5335] = {
    [sym_block_comment] = STATE(5335),
    [sym_line_comment] = STATE(5335),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_elseif] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5336] = {
    [sym_block_comment] = STATE(5336),
    [sym_line_comment] = STATE(5336),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_catch] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5337] = {
    [sym_block_comment] = STATE(5337),
    [sym_line_comment] = STATE(5337),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_catch] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5338] = {
    [sym_block_comment] = STATE(5338),
    [sym_line_comment] = STATE(5338),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9830),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9830),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9830),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9830),
    [anon_sym_COLON_EQ] = ACTIONS(9830),
    [anon_sym_DOT_EQ] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9830),
    [anon_sym_QMARK] = ACTIONS(9830),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9830),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9830),
    [aux_sym_integer_literal_token2] = ACTIONS(9830),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9830),
    [aux_sym_float_literal_token3] = ACTIONS(9830),
    [aux_sym_float_literal_token4] = ACTIONS(9830),
    [sym_character_literal] = ACTIONS(9830),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9830),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9830),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9830),
    [aux_sym__assignment_operator_token1] = ACTIONS(9830),
    [sym__pair_operator] = ACTIONS(9830),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9830),
    [sym__lazy_and_operator] = ACTIONS(9830),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9830),
    [sym__pipe_left_operator] = ACTIONS(9830),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9830),
    [sym__type_order_operator] = ACTIONS(9830),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5339] = {
    [sym_block_comment] = STATE(5339),
    [sym_line_comment] = STATE(5339),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_elseif] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5340] = {
    [sym_block_comment] = STATE(5340),
    [sym_line_comment] = STATE(5340),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10402),
    [sym__immediate_command_start] = ACTIONS(10404),
  },
  [5341] = {
    [sym_block_comment] = STATE(5341),
    [sym_line_comment] = STATE(5341),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5342] = {
    [sym_block_comment] = STATE(5342),
    [sym_line_comment] = STATE(5342),
    [ts_builtin_sym_end] = ACTIONS(9756),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_RBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5343] = {
    [sym_block_comment] = STATE(5343),
    [sym_line_comment] = STATE(5343),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_catch] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5344] = {
    [sym_block_comment] = STATE(5344),
    [sym_line_comment] = STATE(5344),
    [ts_builtin_sym_end] = ACTIONS(9758),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_RBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5345] = {
    [sym_block_comment] = STATE(5345),
    [sym_line_comment] = STATE(5345),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_catch] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5346] = {
    [sym_block_comment] = STATE(5346),
    [sym_line_comment] = STATE(5346),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_catch] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5347] = {
    [sym_block_comment] = STATE(5347),
    [sym_line_comment] = STATE(5347),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_catch] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5348] = {
    [sym_block_comment] = STATE(5348),
    [sym_line_comment] = STATE(5348),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_catch] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5349] = {
    [sym_block_comment] = STATE(5349),
    [sym_line_comment] = STATE(5349),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_elseif] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_DASH_GT] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5350] = {
    [sym_block_comment] = STATE(5350),
    [sym_line_comment] = STATE(5350),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_catch] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5351] = {
    [sym_block_comment] = STATE(5351),
    [sym_line_comment] = STATE(5351),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_elseif] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_DASH_GT] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5352] = {
    [sym_block_comment] = STATE(5352),
    [sym_line_comment] = STATE(5352),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_elseif] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_DASH_GT] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5353] = {
    [sym_block_comment] = STATE(5353),
    [sym_line_comment] = STATE(5353),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_catch] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5354] = {
    [sym_block_comment] = STATE(5354),
    [sym_line_comment] = STATE(5354),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_elseif] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_DASH_GT] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5355] = {
    [sym_block_comment] = STATE(5355),
    [sym_line_comment] = STATE(5355),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_catch] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5356] = {
    [sym_block_comment] = STATE(5356),
    [sym_line_comment] = STATE(5356),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_elseif] = ACTIONS(10102),
    [anon_sym_else] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_DASH_GT] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5357] = {
    [sym_do_clause] = STATE(6013),
    [sym_block_comment] = STATE(5357),
    [sym_line_comment] = STATE(5357),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10383),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_DASH_GT] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5358] = {
    [sym_block_comment] = STATE(5358),
    [sym_line_comment] = STATE(5358),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_elseif] = ACTIONS(10106),
    [anon_sym_else] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_DASH_GT] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5359] = {
    [sym_block_comment] = STATE(5359),
    [sym_line_comment] = STATE(5359),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_elseif] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_DASH_GT] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5360] = {
    [sym_block_comment] = STATE(5360),
    [sym_line_comment] = STATE(5360),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_elseif] = ACTIONS(9814),
    [anon_sym_else] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5361] = {
    [sym_block_comment] = STATE(5361),
    [sym_line_comment] = STATE(5361),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5362] = {
    [sym_block_comment] = STATE(5362),
    [sym_line_comment] = STATE(5362),
    [ts_builtin_sym_end] = ACTIONS(9830),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_RBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5363] = {
    [sym_block_comment] = STATE(5363),
    [sym_line_comment] = STATE(5363),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10379),
    [sym__immediate_command_start] = ACTIONS(10381),
  },
  [5364] = {
    [sym_block_comment] = STATE(5364),
    [sym_line_comment] = STATE(5364),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_catch] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5365] = {
    [sym_block_comment] = STATE(5365),
    [sym_line_comment] = STATE(5365),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_elseif] = ACTIONS(10122),
    [anon_sym_else] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_DASH_GT] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5366] = {
    [sym_block_comment] = STATE(5366),
    [sym_line_comment] = STATE(5366),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_elseif] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_DASH_GT] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5367] = {
    [sym_block_comment] = STATE(5367),
    [sym_line_comment] = STATE(5367),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_else] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_DASH_GT] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5368] = {
    [sym_block_comment] = STATE(5368),
    [sym_line_comment] = STATE(5368),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_DASH_GT] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5369] = {
    [sym_block_comment] = STATE(5369),
    [sym_line_comment] = STATE(5369),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_RPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_RBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_SEMI] = ACTIONS(9960),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_RBRACE] = ACTIONS(9960),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_DASH_GT] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5370] = {
    [sym_block_comment] = STATE(5370),
    [sym_line_comment] = STATE(5370),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_DASH_GT] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5371] = {
    [sym_block_comment] = STATE(5371),
    [sym_line_comment] = STATE(5371),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5372] = {
    [sym_block_comment] = STATE(5372),
    [sym_line_comment] = STATE(5372),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5373] = {
    [sym_block_comment] = STATE(5373),
    [sym_line_comment] = STATE(5373),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5374] = {
    [sym_block_comment] = STATE(5374),
    [sym_line_comment] = STATE(5374),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5375] = {
    [sym_block_comment] = STATE(5375),
    [sym_line_comment] = STATE(5375),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10457),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5376] = {
    [sym_block_comment] = STATE(5376),
    [sym_line_comment] = STATE(5376),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_DASH_GT] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5377] = {
    [sym_block_comment] = STATE(5377),
    [sym_line_comment] = STATE(5377),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_DASH_GT] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5378] = {
    [sym_block_comment] = STATE(5378),
    [sym_line_comment] = STATE(5378),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_DASH_GT] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5379] = {
    [sym_block_comment] = STATE(5379),
    [sym_line_comment] = STATE(5379),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_DASH_GT] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5380] = {
    [sym_block_comment] = STATE(5380),
    [sym_line_comment] = STATE(5380),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_DASH_GT] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5381] = {
    [sym_block_comment] = STATE(5381),
    [sym_line_comment] = STATE(5381),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_DASH_GT] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5382] = {
    [sym_block_comment] = STATE(5382),
    [sym_line_comment] = STATE(5382),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_DASH_GT] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5383] = {
    [sym_block_comment] = STATE(5383),
    [sym_line_comment] = STATE(5383),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_DASH_GT] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5384] = {
    [sym_block_comment] = STATE(5384),
    [sym_line_comment] = STATE(5384),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_DASH_GT] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5385] = {
    [sym_block_comment] = STATE(5385),
    [sym_line_comment] = STATE(5385),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_DASH_GT] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5386] = {
    [sym_block_comment] = STATE(5386),
    [sym_line_comment] = STATE(5386),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_DASH_GT] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5387] = {
    [sym_block_comment] = STATE(5387),
    [sym_line_comment] = STATE(5387),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5388] = {
    [sym_block_comment] = STATE(5388),
    [sym_line_comment] = STATE(5388),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5389] = {
    [sym_block_comment] = STATE(5389),
    [sym_line_comment] = STATE(5389),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_DASH_GT] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5390] = {
    [sym_block_comment] = STATE(5390),
    [sym_line_comment] = STATE(5390),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_DASH_GT] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5391] = {
    [sym_block_comment] = STATE(5391),
    [sym_line_comment] = STATE(5391),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_DASH_GT] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5392] = {
    [sym_block_comment] = STATE(5392),
    [sym_line_comment] = STATE(5392),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_DASH_GT] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5393] = {
    [sym_block_comment] = STATE(5393),
    [sym_line_comment] = STATE(5393),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5394] = {
    [sym_block_comment] = STATE(5394),
    [sym_line_comment] = STATE(5394),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_DASH_GT] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5395] = {
    [sym_block_comment] = STATE(5395),
    [sym_line_comment] = STATE(5395),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_DASH_GT] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5396] = {
    [sym_block_comment] = STATE(5396),
    [sym_line_comment] = STATE(5396),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_DASH_GT] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5397] = {
    [sym_block_comment] = STATE(5397),
    [sym_line_comment] = STATE(5397),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_DASH_GT] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5398] = {
    [sym_block_comment] = STATE(5398),
    [sym_line_comment] = STATE(5398),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DASH_GT] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5399] = {
    [sym_block_comment] = STATE(5399),
    [sym_line_comment] = STATE(5399),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_DASH_GT] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5400] = {
    [sym_block_comment] = STATE(5400),
    [sym_line_comment] = STATE(5400),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_DASH_GT] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5401] = {
    [sym_block_comment] = STATE(5401),
    [sym_line_comment] = STATE(5401),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_elseif] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5402] = {
    [sym_block_comment] = STATE(5402),
    [sym_line_comment] = STATE(5402),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_DASH_GT] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5403] = {
    [sym_block_comment] = STATE(5403),
    [sym_line_comment] = STATE(5403),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_DASH_GT] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5404] = {
    [sym_block_comment] = STATE(5404),
    [sym_line_comment] = STATE(5404),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_DASH_GT] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5405] = {
    [sym_block_comment] = STATE(5405),
    [sym_line_comment] = STATE(5405),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_DASH_GT] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5406] = {
    [sym_block_comment] = STATE(5406),
    [sym_line_comment] = STATE(5406),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_elseif] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5407] = {
    [sym_block_comment] = STATE(5407),
    [sym_line_comment] = STATE(5407),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10459),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5408] = {
    [sym_block_comment] = STATE(5408),
    [sym_line_comment] = STATE(5408),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_COLON_EQ] = ACTIONS(9984),
    [anon_sym_DOT_EQ] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9984),
    [aux_sym__assignment_operator_token1] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5409] = {
    [sym_block_comment] = STATE(5409),
    [sym_line_comment] = STATE(5409),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_COLON_EQ] = ACTIONS(9988),
    [anon_sym_DOT_EQ] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9988),
    [aux_sym__assignment_operator_token1] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5410] = {
    [sym_block_comment] = STATE(5410),
    [sym_line_comment] = STATE(5410),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_COLON_EQ] = ACTIONS(10002),
    [anon_sym_DOT_EQ] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10002),
    [aux_sym__assignment_operator_token1] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5411] = {
    [sym_block_comment] = STATE(5411),
    [sym_line_comment] = STATE(5411),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_COLON_EQ] = ACTIONS(10006),
    [anon_sym_DOT_EQ] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10006),
    [aux_sym__assignment_operator_token1] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5412] = {
    [sym_block_comment] = STATE(5412),
    [sym_line_comment] = STATE(5412),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_COLON_EQ] = ACTIONS(10012),
    [anon_sym_DOT_EQ] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10012),
    [aux_sym__assignment_operator_token1] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5413] = {
    [sym_block_comment] = STATE(5413),
    [sym_line_comment] = STATE(5413),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_COLON_EQ] = ACTIONS(10016),
    [anon_sym_DOT_EQ] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10016),
    [aux_sym__assignment_operator_token1] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5414] = {
    [sym_block_comment] = STATE(5414),
    [sym_line_comment] = STATE(5414),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_COLON_EQ] = ACTIONS(10020),
    [anon_sym_DOT_EQ] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10020),
    [aux_sym__assignment_operator_token1] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5415] = {
    [sym_block_comment] = STATE(5415),
    [sym_line_comment] = STATE(5415),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_COLON_EQ] = ACTIONS(9918),
    [anon_sym_DOT_EQ] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9918),
    [aux_sym__assignment_operator_token1] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5416] = {
    [sym_block_comment] = STATE(5416),
    [sym_line_comment] = STATE(5416),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_COLON_EQ] = ACTIONS(9922),
    [anon_sym_DOT_EQ] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9922),
    [aux_sym__assignment_operator_token1] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5417] = {
    [sym_block_comment] = STATE(5417),
    [sym_line_comment] = STATE(5417),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_COLON_EQ] = ACTIONS(9992),
    [anon_sym_DOT_EQ] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9992),
    [aux_sym__assignment_operator_token1] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5418] = {
    [sym_block_comment] = STATE(5418),
    [sym_line_comment] = STATE(5418),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_COLON_EQ] = ACTIONS(9996),
    [anon_sym_DOT_EQ] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9996),
    [aux_sym__assignment_operator_token1] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5419] = {
    [sym_block_comment] = STATE(5419),
    [sym_line_comment] = STATE(5419),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_COLON_EQ] = ACTIONS(9754),
    [anon_sym_DOT_EQ] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9754),
    [aux_sym__assignment_operator_token1] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5420] = {
    [sym_block_comment] = STATE(5420),
    [sym_line_comment] = STATE(5420),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_COLON_EQ] = ACTIONS(9762),
    [anon_sym_DOT_EQ] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9762),
    [aux_sym__assignment_operator_token1] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5421] = {
    [sym_block_comment] = STATE(5421),
    [sym_line_comment] = STATE(5421),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_COLON_EQ] = ACTIONS(10030),
    [anon_sym_DOT_EQ] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10030),
    [aux_sym__assignment_operator_token1] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5422] = {
    [sym_block_comment] = STATE(5422),
    [sym_line_comment] = STATE(5422),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_COLON_EQ] = ACTIONS(10034),
    [anon_sym_DOT_EQ] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10034),
    [aux_sym__assignment_operator_token1] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5423] = {
    [sym_block_comment] = STATE(5423),
    [sym_line_comment] = STATE(5423),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_COLON_EQ] = ACTIONS(10038),
    [anon_sym_DOT_EQ] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10038),
    [aux_sym__assignment_operator_token1] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5424] = {
    [sym_block_comment] = STATE(5424),
    [sym_line_comment] = STATE(5424),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_COLON_EQ] = ACTIONS(10042),
    [anon_sym_DOT_EQ] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10042),
    [aux_sym__assignment_operator_token1] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5425] = {
    [sym_block_comment] = STATE(5425),
    [sym_line_comment] = STATE(5425),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_COLON_EQ] = ACTIONS(9792),
    [anon_sym_DOT_EQ] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9792),
    [aux_sym__assignment_operator_token1] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5426] = {
    [sym_block_comment] = STATE(5426),
    [sym_line_comment] = STATE(5426),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_COLON_EQ] = ACTIONS(10046),
    [anon_sym_DOT_EQ] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10046),
    [aux_sym__assignment_operator_token1] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5427] = {
    [sym_block_comment] = STATE(5427),
    [sym_line_comment] = STATE(5427),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_COLON_EQ] = ACTIONS(10050),
    [anon_sym_DOT_EQ] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10050),
    [aux_sym__assignment_operator_token1] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5428] = {
    [sym_block_comment] = STATE(5428),
    [sym_line_comment] = STATE(5428),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_COLON_EQ] = ACTIONS(10054),
    [anon_sym_DOT_EQ] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10054),
    [aux_sym__assignment_operator_token1] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5429] = {
    [sym_block_comment] = STATE(5429),
    [sym_line_comment] = STATE(5429),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_COLON_EQ] = ACTIONS(10058),
    [anon_sym_DOT_EQ] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10058),
    [aux_sym__assignment_operator_token1] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5430] = {
    [sym_block_comment] = STATE(5430),
    [sym_line_comment] = STATE(5430),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_COLON_EQ] = ACTIONS(9900),
    [anon_sym_DOT_EQ] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9900),
    [aux_sym__assignment_operator_token1] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5431] = {
    [sym_block_comment] = STATE(5431),
    [sym_line_comment] = STATE(5431),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_COLON_EQ] = ACTIONS(10062),
    [anon_sym_DOT_EQ] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10062),
    [aux_sym__assignment_operator_token1] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5432] = {
    [sym_block_comment] = STATE(5432),
    [sym_line_comment] = STATE(5432),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_COLON_EQ] = ACTIONS(10066),
    [anon_sym_DOT_EQ] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10066),
    [aux_sym__assignment_operator_token1] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5433] = {
    [sym_block_comment] = STATE(5433),
    [sym_line_comment] = STATE(5433),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_COLON_EQ] = ACTIONS(10070),
    [anon_sym_DOT_EQ] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10070),
    [aux_sym__assignment_operator_token1] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5434] = {
    [sym_block_comment] = STATE(5434),
    [sym_line_comment] = STATE(5434),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_COLON_EQ] = ACTIONS(10074),
    [anon_sym_DOT_EQ] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10074),
    [aux_sym__assignment_operator_token1] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5435] = {
    [sym_block_comment] = STATE(5435),
    [sym_line_comment] = STATE(5435),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_COLON_EQ] = ACTIONS(10078),
    [anon_sym_DOT_EQ] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10078),
    [aux_sym__assignment_operator_token1] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5436] = {
    [sym_block_comment] = STATE(5436),
    [sym_line_comment] = STATE(5436),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_COLON_EQ] = ACTIONS(10082),
    [anon_sym_DOT_EQ] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10082),
    [aux_sym__assignment_operator_token1] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5437] = {
    [sym_block_comment] = STATE(5437),
    [sym_line_comment] = STATE(5437),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5438] = {
    [sym_block_comment] = STATE(5438),
    [sym_line_comment] = STATE(5438),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_DASH_GT] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5439] = {
    [sym_block_comment] = STATE(5439),
    [sym_line_comment] = STATE(5439),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5440] = {
    [sym_block_comment] = STATE(5440),
    [sym_line_comment] = STATE(5440),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5441] = {
    [sym_block_comment] = STATE(5441),
    [sym_line_comment] = STATE(5441),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5442] = {
    [sym_block_comment] = STATE(5442),
    [sym_line_comment] = STATE(5442),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_COLON_EQ] = ACTIONS(9716),
    [anon_sym_DOT_EQ] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9716),
    [aux_sym__assignment_operator_token1] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5443] = {
    [sym_block_comment] = STATE(5443),
    [sym_line_comment] = STATE(5443),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_COLON_EQ] = ACTIONS(9960),
    [anon_sym_DOT_EQ] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9960),
    [aux_sym__assignment_operator_token1] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5444] = {
    [sym_block_comment] = STATE(5444),
    [sym_line_comment] = STATE(5444),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10461),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5445] = {
    [sym_block_comment] = STATE(5445),
    [sym_line_comment] = STATE(5445),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_DASH_GT] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5446] = {
    [sym_block_comment] = STATE(5446),
    [sym_line_comment] = STATE(5446),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_DASH_GT] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5447] = {
    [sym_block_comment] = STATE(5447),
    [sym_line_comment] = STATE(5447),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_DASH_GT] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5448] = {
    [sym_block_comment] = STATE(5448),
    [sym_line_comment] = STATE(5448),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_DASH_GT] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5449] = {
    [sym_block_comment] = STATE(5449),
    [sym_line_comment] = STATE(5449),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5450] = {
    [sym_block_comment] = STATE(5450),
    [sym_line_comment] = STATE(5450),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_DASH_GT] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5451] = {
    [sym_block_comment] = STATE(5451),
    [sym_line_comment] = STATE(5451),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_DASH_GT] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5452] = {
    [sym_block_comment] = STATE(5452),
    [sym_line_comment] = STATE(5452),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_DASH_GT] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5453] = {
    [sym_block_comment] = STATE(5453),
    [sym_line_comment] = STATE(5453),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_DASH_GT] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5454] = {
    [sym_block_comment] = STATE(5454),
    [sym_line_comment] = STATE(5454),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_DASH_GT] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5455] = {
    [sym_block_comment] = STATE(5455),
    [sym_line_comment] = STATE(5455),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_DASH_GT] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5456] = {
    [sym_block_comment] = STATE(5456),
    [sym_line_comment] = STATE(5456),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_DASH_GT] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5457] = {
    [sym_block_comment] = STATE(5457),
    [sym_line_comment] = STATE(5457),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_DASH_GT] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5458] = {
    [sym_block_comment] = STATE(5458),
    [sym_line_comment] = STATE(5458),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5459] = {
    [sym_block_comment] = STATE(5459),
    [sym_line_comment] = STATE(5459),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5460] = {
    [sym_block_comment] = STATE(5460),
    [sym_line_comment] = STATE(5460),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_DASH_GT] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5461] = {
    [sym_block_comment] = STATE(5461),
    [sym_line_comment] = STATE(5461),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_DASH_GT] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5462] = {
    [sym_block_comment] = STATE(5462),
    [sym_line_comment] = STATE(5462),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_DASH_GT] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5463] = {
    [sym_block_comment] = STATE(5463),
    [sym_line_comment] = STATE(5463),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_DASH_GT] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5464] = {
    [sym_identifier] = STATE(6180),
    [sym_block_comment] = STATE(5464),
    [sym_line_comment] = STATE(5464),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5465] = {
    [sym_identifier] = STATE(6181),
    [sym_block_comment] = STATE(5465),
    [sym_line_comment] = STATE(5465),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5466] = {
    [sym_block_comment] = STATE(5466),
    [sym_line_comment] = STATE(5466),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5467] = {
    [sym_block_comment] = STATE(5467),
    [sym_line_comment] = STATE(5467),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_DASH_GT] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5468] = {
    [sym_block_comment] = STATE(5468),
    [sym_line_comment] = STATE(5468),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_DASH_GT] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5469] = {
    [sym_block_comment] = STATE(5469),
    [sym_line_comment] = STATE(5469),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_DASH_GT] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5470] = {
    [sym_block_comment] = STATE(5470),
    [sym_line_comment] = STATE(5470),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_DASH_GT] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5471] = {
    [sym_block_comment] = STATE(5471),
    [sym_line_comment] = STATE(5471),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DASH_GT] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5472] = {
    [sym_block_comment] = STATE(5472),
    [sym_line_comment] = STATE(5472),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_DASH_GT] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5473] = {
    [sym_block_comment] = STATE(5473),
    [sym_line_comment] = STATE(5473),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_DASH_GT] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5474] = {
    [sym_identifier] = STATE(6184),
    [sym_block_comment] = STATE(5474),
    [sym_line_comment] = STATE(5474),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5475] = {
    [sym_block_comment] = STATE(5475),
    [sym_line_comment] = STATE(5475),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_DASH_GT] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5476] = {
    [sym_identifier] = STATE(6185),
    [sym_block_comment] = STATE(5476),
    [sym_line_comment] = STATE(5476),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5477] = {
    [sym_block_comment] = STATE(5477),
    [sym_line_comment] = STATE(5477),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_DASH_GT] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5478] = {
    [sym_block_comment] = STATE(5478),
    [sym_line_comment] = STATE(5478),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_DASH_GT] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5479] = {
    [sym_block_comment] = STATE(5479),
    [sym_line_comment] = STATE(5479),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_DASH_GT] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5480] = {
    [sym_block_comment] = STATE(5480),
    [sym_line_comment] = STATE(5480),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_DASH_GT] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5481] = {
    [sym_block_comment] = STATE(5481),
    [sym_line_comment] = STATE(5481),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5482] = {
    [sym_block_comment] = STATE(5482),
    [sym_line_comment] = STATE(5482),
    [ts_builtin_sym_end] = ACTIONS(10136),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_RBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_DASH_GT] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5483] = {
    [sym_block_comment] = STATE(5483),
    [sym_line_comment] = STATE(5483),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5484] = {
    [sym_block_comment] = STATE(5484),
    [sym_line_comment] = STATE(5484),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_DASH_GT] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5485] = {
    [sym_block_comment] = STATE(5485),
    [sym_line_comment] = STATE(5485),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_DASH_GT] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5486] = {
    [sym_block_comment] = STATE(5486),
    [sym_line_comment] = STATE(5486),
    [ts_builtin_sym_end] = ACTIONS(9914),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_RBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_DASH_GT] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5487] = {
    [sym_block_comment] = STATE(5487),
    [sym_line_comment] = STATE(5487),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_COLON_EQ] = ACTIONS(9728),
    [anon_sym_DOT_EQ] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9728),
    [aux_sym__assignment_operator_token1] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5488] = {
    [sym_block_comment] = STATE(5488),
    [sym_line_comment] = STATE(5488),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_COLON_EQ] = ACTIONS(9740),
    [anon_sym_DOT_EQ] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9740),
    [aux_sym__assignment_operator_token1] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5489] = {
    [sym_block_comment] = STATE(5489),
    [sym_line_comment] = STATE(5489),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_COLON_EQ] = ACTIONS(9746),
    [anon_sym_DOT_EQ] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9746),
    [aux_sym__assignment_operator_token1] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5490] = {
    [sym_block_comment] = STATE(5490),
    [sym_line_comment] = STATE(5490),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_DASH_GT] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5491] = {
    [sym_block_comment] = STATE(5491),
    [sym_line_comment] = STATE(5491),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_elseif] = ACTIONS(9978),
    [anon_sym_else] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5492] = {
    [sym_block_comment] = STATE(5492),
    [sym_line_comment] = STATE(5492),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_RPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_RBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_SEMI] = ACTIONS(10136),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_RBRACE] = ACTIONS(10136),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_DASH_GT] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5493] = {
    [sym_block_comment] = STATE(5493),
    [sym_line_comment] = STATE(5493),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5494] = {
    [sym_block_comment] = STATE(5494),
    [sym_line_comment] = STATE(5494),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_RPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_RBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_SEMI] = ACTIONS(9914),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_RBRACE] = ACTIONS(9914),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_DASH_GT] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5495] = {
    [sym_block_comment] = STATE(5495),
    [sym_line_comment] = STATE(5495),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [5496] = {
    [sym_block_comment] = STATE(5496),
    [sym_line_comment] = STATE(5496),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5497] = {
    [sym_block_comment] = STATE(5497),
    [sym_line_comment] = STATE(5497),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5498] = {
    [sym_block_comment] = STATE(5498),
    [sym_line_comment] = STATE(5498),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5499] = {
    [sym_block_comment] = STATE(5499),
    [sym_line_comment] = STATE(5499),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_DASH_GT] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5500] = {
    [sym_block_comment] = STATE(5500),
    [sym_line_comment] = STATE(5500),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_DASH_GT] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5501] = {
    [sym_block_comment] = STATE(5501),
    [sym_line_comment] = STATE(5501),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_DASH_GT] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5502] = {
    [sym_block_comment] = STATE(5502),
    [sym_line_comment] = STATE(5502),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_DASH_GT] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5503] = {
    [sym_block_comment] = STATE(5503),
    [sym_line_comment] = STATE(5503),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_DASH_GT] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5504] = {
    [sym_block_comment] = STATE(5504),
    [sym_line_comment] = STATE(5504),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_DASH_GT] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5505] = {
    [sym_block_comment] = STATE(5505),
    [sym_line_comment] = STATE(5505),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_DASH_GT] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5506] = {
    [sym_block_comment] = STATE(5506),
    [sym_line_comment] = STATE(5506),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_DASH_GT] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5507] = {
    [sym_block_comment] = STATE(5507),
    [sym_line_comment] = STATE(5507),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_DASH_GT] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5508] = {
    [sym_block_comment] = STATE(5508),
    [sym_line_comment] = STATE(5508),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_DASH_GT] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5509] = {
    [sym_block_comment] = STATE(5509),
    [sym_line_comment] = STATE(5509),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5510] = {
    [sym_block_comment] = STATE(5510),
    [sym_line_comment] = STATE(5510),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_DASH_GT] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5511] = {
    [sym_block_comment] = STATE(5511),
    [sym_line_comment] = STATE(5511),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_DASH_GT] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5512] = {
    [sym_block_comment] = STATE(5512),
    [sym_line_comment] = STATE(5512),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5513] = {
    [sym_block_comment] = STATE(5513),
    [sym_line_comment] = STATE(5513),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5514] = {
    [sym_block_comment] = STATE(5514),
    [sym_line_comment] = STATE(5514),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_DASH_GT] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5515] = {
    [sym_block_comment] = STATE(5515),
    [sym_line_comment] = STATE(5515),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_DASH_GT] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5516] = {
    [sym_block_comment] = STATE(5516),
    [sym_line_comment] = STATE(5516),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_DASH_GT] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5517] = {
    [sym_block_comment] = STATE(5517),
    [sym_line_comment] = STATE(5517),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_DASH_GT] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5518] = {
    [sym_block_comment] = STATE(5518),
    [sym_line_comment] = STATE(5518),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5519] = {
    [sym_block_comment] = STATE(5519),
    [sym_line_comment] = STATE(5519),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5520] = {
    [sym_block_comment] = STATE(5520),
    [sym_line_comment] = STATE(5520),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5521] = {
    [sym_block_comment] = STATE(5521),
    [sym_line_comment] = STATE(5521),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_DASH_GT] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5522] = {
    [sym_block_comment] = STATE(5522),
    [sym_line_comment] = STATE(5522),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_DASH_GT] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5523] = {
    [sym_block_comment] = STATE(5523),
    [sym_line_comment] = STATE(5523),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_DASH_GT] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5524] = {
    [sym_block_comment] = STATE(5524),
    [sym_line_comment] = STATE(5524),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_DASH_GT] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5525] = {
    [sym_block_comment] = STATE(5525),
    [sym_line_comment] = STATE(5525),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DASH_GT] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5526] = {
    [sym_block_comment] = STATE(5526),
    [sym_line_comment] = STATE(5526),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_DASH_GT] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5527] = {
    [sym_block_comment] = STATE(5527),
    [sym_line_comment] = STATE(5527),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_DASH_GT] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5528] = {
    [sym_block_comment] = STATE(5528),
    [sym_line_comment] = STATE(5528),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_DASH_GT] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5529] = {
    [sym_block_comment] = STATE(5529),
    [sym_line_comment] = STATE(5529),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_DASH_GT] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5530] = {
    [sym_block_comment] = STATE(5530),
    [sym_line_comment] = STATE(5530),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_DASH_GT] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5531] = {
    [sym_block_comment] = STATE(5531),
    [sym_line_comment] = STATE(5531),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_DASH_GT] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5532] = {
    [sym_block_comment] = STATE(5532),
    [sym_line_comment] = STATE(5532),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_DASH_GT] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5533] = {
    [sym_block_comment] = STATE(5533),
    [sym_line_comment] = STATE(5533),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_elseif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5534] = {
    [sym_block_comment] = STATE(5534),
    [sym_line_comment] = STATE(5534),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5535] = {
    [sym_block_comment] = STATE(5535),
    [sym_line_comment] = STATE(5535),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_DASH_GT] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5536] = {
    [sym_block_comment] = STATE(5536),
    [sym_line_comment] = STATE(5536),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5537] = {
    [sym_block_comment] = STATE(5537),
    [sym_line_comment] = STATE(5537),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_DASH_GT] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5538] = {
    [sym_block_comment] = STATE(5538),
    [sym_line_comment] = STATE(5538),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5539] = {
    [sym_block_comment] = STATE(5539),
    [sym_line_comment] = STATE(5539),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_COLON_EQ] = ACTIONS(9734),
    [anon_sym_DOT_EQ] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9734),
    [aux_sym__assignment_operator_token1] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5540] = {
    [sym_block_comment] = STATE(5540),
    [sym_line_comment] = STATE(5540),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_COLON_EQ] = ACTIONS(10136),
    [anon_sym_DOT_EQ] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10136),
    [aux_sym__assignment_operator_token1] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5541] = {
    [sym_block_comment] = STATE(5541),
    [sym_line_comment] = STATE(5541),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_COLON_EQ] = ACTIONS(9914),
    [anon_sym_DOT_EQ] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9914),
    [aux_sym__assignment_operator_token1] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5542] = {
    [sym_block_comment] = STATE(5542),
    [sym_line_comment] = STATE(5542),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10463),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5543] = {
    [sym_block_comment] = STATE(5543),
    [sym_line_comment] = STATE(5543),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5544] = {
    [sym_block_comment] = STATE(5544),
    [sym_line_comment] = STATE(5544),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_DASH_GT] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5545] = {
    [sym_block_comment] = STATE(5545),
    [sym_line_comment] = STATE(5545),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_DASH_GT] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5546] = {
    [sym_block_comment] = STATE(5546),
    [sym_line_comment] = STATE(5546),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(3075),
    [anon_sym_DOT_EQ] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [anon_sym_DOLLAR_EQ] = ACTIONS(3075),
    [aux_sym__assignment_operator_token1] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5547] = {
    [sym_block_comment] = STATE(5547),
    [sym_line_comment] = STATE(5547),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5548] = {
    [sym_block_comment] = STATE(5548),
    [sym_line_comment] = STATE(5548),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5549] = {
    [sym_block_comment] = STATE(5549),
    [sym_line_comment] = STATE(5549),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5550] = {
    [sym_block_comment] = STATE(5550),
    [sym_line_comment] = STATE(5550),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_DASH_GT] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5551] = {
    [sym_block_comment] = STATE(5551),
    [sym_line_comment] = STATE(5551),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_DASH_GT] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5552] = {
    [sym_identifier] = STATE(6325),
    [sym_block_comment] = STATE(5552),
    [sym_line_comment] = STATE(5552),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5553] = {
    [sym_identifier] = STATE(6326),
    [sym_block_comment] = STATE(5553),
    [sym_line_comment] = STATE(5553),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5554] = {
    [sym_identifier] = STATE(6329),
    [sym_block_comment] = STATE(5554),
    [sym_line_comment] = STATE(5554),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5555] = {
    [sym_identifier] = STATE(6330),
    [sym_block_comment] = STATE(5555),
    [sym_line_comment] = STATE(5555),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5556] = {
    [sym_block_comment] = STATE(5556),
    [sym_line_comment] = STATE(5556),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10465),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5557] = {
    [sym_block_comment] = STATE(5557),
    [sym_line_comment] = STATE(5557),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5558] = {
    [sym_identifier] = STATE(6240),
    [sym_block_comment] = STATE(5558),
    [sym_line_comment] = STATE(5558),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5559] = {
    [sym_identifier] = STATE(6241),
    [sym_block_comment] = STATE(5559),
    [sym_line_comment] = STATE(5559),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5560] = {
    [sym_identifier] = STATE(6244),
    [sym_block_comment] = STATE(5560),
    [sym_line_comment] = STATE(5560),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5561] = {
    [sym_identifier] = STATE(6245),
    [sym_block_comment] = STATE(5561),
    [sym_line_comment] = STATE(5561),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5562] = {
    [sym_block_comment] = STATE(5562),
    [sym_line_comment] = STATE(5562),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_elseif] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5563] = {
    [sym_block_comment] = STATE(5563),
    [sym_line_comment] = STATE(5563),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_elseif] = ACTIONS(9954),
    [anon_sym_else] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5564] = {
    [sym_block_comment] = STATE(5564),
    [sym_line_comment] = STATE(5564),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_elseif] = ACTIONS(9962),
    [anon_sym_else] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5565] = {
    [sym_block_comment] = STATE(5565),
    [sym_line_comment] = STATE(5565),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_elseif] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5566] = {
    [sym_block_comment] = STATE(5566),
    [sym_line_comment] = STATE(5566),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_elseif] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5567] = {
    [sym_block_comment] = STATE(5567),
    [sym_line_comment] = STATE(5567),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_elseif] = ACTIONS(10102),
    [anon_sym_else] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5568] = {
    [sym_block_comment] = STATE(5568),
    [sym_line_comment] = STATE(5568),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_elseif] = ACTIONS(10106),
    [anon_sym_else] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5569] = {
    [sym_block_comment] = STATE(5569),
    [sym_line_comment] = STATE(5569),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_elseif] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5570] = {
    [sym_block_comment] = STATE(5570),
    [sym_line_comment] = STATE(5570),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_elseif] = ACTIONS(10122),
    [anon_sym_else] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5571] = {
    [sym_block_comment] = STATE(5571),
    [sym_line_comment] = STATE(5571),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_elseif] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5572] = {
    [sym_block_comment] = STATE(5572),
    [sym_line_comment] = STATE(5572),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_elseif] = ACTIONS(10128),
    [anon_sym_else] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5573] = {
    [sym_block_comment] = STATE(5573),
    [sym_line_comment] = STATE(5573),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_elseif] = ACTIONS(10138),
    [anon_sym_else] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5574] = {
    [sym_block_comment] = STATE(5574),
    [sym_line_comment] = STATE(5574),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_elseif] = ACTIONS(10142),
    [anon_sym_else] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5575] = {
    [sym_block_comment] = STATE(5575),
    [sym_line_comment] = STATE(5575),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_elseif] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5576] = {
    [sym_block_comment] = STATE(5576),
    [sym_line_comment] = STATE(5576),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_elseif] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5577] = {
    [sym_block_comment] = STATE(5577),
    [sym_line_comment] = STATE(5577),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_elseif] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5578] = {
    [sym_block_comment] = STATE(5578),
    [sym_line_comment] = STATE(5578),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_elseif] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5579] = {
    [sym_block_comment] = STATE(5579),
    [sym_line_comment] = STATE(5579),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_elseif] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5580] = {
    [sym_block_comment] = STATE(5580),
    [sym_line_comment] = STATE(5580),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10467),
    [sym__immediate_command_start] = ACTIONS(10469),
  },
  [5581] = {
    [sym_block_comment] = STATE(5581),
    [sym_line_comment] = STATE(5581),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_elseif] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5582] = {
    [sym_block_comment] = STATE(5582),
    [sym_line_comment] = STATE(5582),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_elseif] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5583] = {
    [sym_block_comment] = STATE(5583),
    [sym_line_comment] = STATE(5583),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_elseif] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5584] = {
    [sym_block_comment] = STATE(5584),
    [sym_line_comment] = STATE(5584),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_elseif] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5585] = {
    [sym_block_comment] = STATE(5585),
    [sym_line_comment] = STATE(5585),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_elseif] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5586] = {
    [sym_block_comment] = STATE(5586),
    [sym_line_comment] = STATE(5586),
    [sym__word_identifier] = ACTIONS(10214),
    [anon_sym_begin] = ACTIONS(10214),
    [anon_sym_module] = ACTIONS(10214),
    [anon_sym_baremodule] = ACTIONS(10214),
    [anon_sym_end] = ACTIONS(10214),
    [anon_sym_abstract] = ACTIONS(10214),
    [anon_sym_primitive] = ACTIONS(10214),
    [anon_sym_mutable] = ACTIONS(10214),
    [anon_sym_struct] = ACTIONS(10214),
    [anon_sym_function] = ACTIONS(10214),
    [anon_sym_macro] = ACTIONS(10214),
    [anon_sym_quote] = ACTIONS(10214),
    [anon_sym_let] = ACTIONS(10214),
    [anon_sym_if] = ACTIONS(10214),
    [anon_sym_try] = ACTIONS(10214),
    [anon_sym_for] = ACTIONS(10214),
    [anon_sym_while] = ACTIONS(10214),
    [sym_break_statement] = ACTIONS(10214),
    [sym_continue_statement] = ACTIONS(10214),
    [anon_sym_return] = ACTIONS(10214),
    [anon_sym_const] = ACTIONS(10214),
    [anon_sym_global] = ACTIONS(10214),
    [anon_sym_local] = ACTIONS(10214),
    [anon_sym_LPAREN] = ACTIONS(10214),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(10214),
    [anon_sym_public] = ACTIONS(10214),
    [anon_sym_import] = ACTIONS(10214),
    [anon_sym_using] = ACTIONS(10214),
    [anon_sym_LBRACK] = ACTIONS(10214),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10214),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10214),
    [anon_sym_COLON2] = ACTIONS(10214),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10214),
    [anon_sym_true] = ACTIONS(10214),
    [anon_sym_false] = ACTIONS(10214),
    [aux_sym_integer_literal_token1] = ACTIONS(10214),
    [aux_sym_integer_literal_token2] = ACTIONS(10214),
    [aux_sym_integer_literal_token3] = ACTIONS(10214),
    [aux_sym_integer_literal_token4] = ACTIONS(10214),
    [aux_sym_float_literal_token1] = ACTIONS(10214),
    [aux_sym_float_literal_token3] = ACTIONS(10214),
    [aux_sym_float_literal_token4] = ACTIONS(10214),
    [sym_character_literal] = ACTIONS(10214),
    [anon_sym_DQUOTE] = ACTIONS(10214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10214),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(10214),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(10216),
    [aux_sym__terminator_token2] = ACTIONS(10214),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5587] = {
    [sym_block_comment] = STATE(5587),
    [sym_line_comment] = STATE(5587),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10322),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_catch] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10471),
    [anon_sym_DOT] = ACTIONS(10473),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10475),
    [sym__immediate_bracket] = ACTIONS(10477),
    [sym__immediate_brace] = ACTIONS(10479),
  },
  [5588] = {
    [sym_block_comment] = STATE(5588),
    [sym_line_comment] = STATE(5588),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_elseif] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5589] = {
    [sym_block_comment] = STATE(5589),
    [sym_line_comment] = STATE(5589),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_elseif] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5590] = {
    [sym_block_comment] = STATE(5590),
    [sym_line_comment] = STATE(5590),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_elseif] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5591] = {
    [sym_block_comment] = STATE(5591),
    [sym_line_comment] = STATE(5591),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_elseif] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5592] = {
    [sym_block_comment] = STATE(5592),
    [sym_line_comment] = STATE(5592),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_elseif] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5593] = {
    [sym_block_comment] = STATE(5593),
    [sym_line_comment] = STATE(5593),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_elseif] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5594] = {
    [sym_block_comment] = STATE(5594),
    [sym_line_comment] = STATE(5594),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_elseif] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5595] = {
    [sym_block_comment] = STATE(5595),
    [sym_line_comment] = STATE(5595),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_elseif] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5596] = {
    [sym_block_comment] = STATE(5596),
    [sym_line_comment] = STATE(5596),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_elseif] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5597] = {
    [sym_block_comment] = STATE(5597),
    [sym_line_comment] = STATE(5597),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_elseif] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5598] = {
    [sym_block_comment] = STATE(5598),
    [sym_line_comment] = STATE(5598),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_elseif] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5599] = {
    [sym_block_comment] = STATE(5599),
    [sym_line_comment] = STATE(5599),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_elseif] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5600] = {
    [sym_block_comment] = STATE(5600),
    [sym_line_comment] = STATE(5600),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_elseif] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5601] = {
    [sym_block_comment] = STATE(5601),
    [sym_line_comment] = STATE(5601),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_elseif] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5602] = {
    [sym_block_comment] = STATE(5602),
    [sym_line_comment] = STATE(5602),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_elseif] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5603] = {
    [sym_block_comment] = STATE(5603),
    [sym_line_comment] = STATE(5603),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_elseif] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5604] = {
    [sym_block_comment] = STATE(5604),
    [sym_line_comment] = STATE(5604),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_elseif] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5605] = {
    [sym__primary_expression] = STATE(11470),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11233),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(5605),
    [sym_line_comment] = STATE(5605),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10481),
    [anon_sym_COLON2] = ACTIONS(10483),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5606] = {
    [sym_block_comment] = STATE(5606),
    [sym_line_comment] = STATE(5606),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10467),
    [sym__immediate_command_start] = ACTIONS(10469),
  },
  [5607] = {
    [sym_block_comment] = STATE(5607),
    [sym_line_comment] = STATE(5607),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10322),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_finally] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10485),
    [anon_sym_DOT] = ACTIONS(10487),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10489),
    [sym__immediate_bracket] = ACTIONS(10491),
    [sym__immediate_brace] = ACTIONS(10493),
  },
  [5608] = {
    [sym_do_clause] = STATE(6392),
    [sym_block_comment] = STATE(5608),
    [sym_line_comment] = STATE(5608),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9680),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9680),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9680),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9680),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10495),
    [anon_sym_DOLLAR] = ACTIONS(9680),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9680),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9680),
    [anon_sym_QMARK] = ACTIONS(9680),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9680),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9680),
    [aux_sym_integer_literal_token2] = ACTIONS(9680),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9680),
    [aux_sym_float_literal_token3] = ACTIONS(9680),
    [aux_sym_float_literal_token4] = ACTIONS(9680),
    [sym_character_literal] = ACTIONS(9680),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9680),
    [sym__pair_operator] = ACTIONS(9680),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9680),
    [sym__lazy_and_operator] = ACTIONS(9680),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9680),
    [sym__pipe_left_operator] = ACTIONS(9680),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9680),
    [sym__bitshift_operator] = ACTIONS(9680),
    [sym__power_operator] = ACTIONS(9680),
    [sym__tilde_operator] = ACTIONS(9680),
    [sym__type_order_operator] = ACTIONS(9680),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym__terminator_token1] = ACTIONS(9684),
    [aux_sym__terminator_token2] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [5609] = {
    [sym_block_comment] = STATE(5609),
    [sym_line_comment] = STATE(5609),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10467),
    [sym__immediate_command_start] = ACTIONS(10469),
  },
  [5610] = {
    [sym_do_clause] = STATE(6394),
    [sym_block_comment] = STATE(5610),
    [sym_line_comment] = STATE(5610),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10495),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5611] = {
    [sym_block_comment] = STATE(5611),
    [sym_line_comment] = STATE(5611),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_elseif] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5612] = {
    [sym_do_clause] = STATE(6397),
    [sym_block_comment] = STATE(5612),
    [sym_line_comment] = STATE(5612),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9696),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9696),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9696),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9696),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10495),
    [anon_sym_DOLLAR] = ACTIONS(9696),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9696),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9696),
    [anon_sym_QMARK] = ACTIONS(9696),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9696),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9696),
    [aux_sym_integer_literal_token2] = ACTIONS(9696),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9696),
    [aux_sym_float_literal_token3] = ACTIONS(9696),
    [aux_sym_float_literal_token4] = ACTIONS(9696),
    [sym_character_literal] = ACTIONS(9696),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9696),
    [sym__pair_operator] = ACTIONS(9696),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9696),
    [sym__lazy_and_operator] = ACTIONS(9696),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9696),
    [sym__pipe_left_operator] = ACTIONS(9696),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9696),
    [sym__bitshift_operator] = ACTIONS(9696),
    [sym__power_operator] = ACTIONS(9696),
    [sym__tilde_operator] = ACTIONS(9696),
    [sym__type_order_operator] = ACTIONS(9696),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym__terminator_token1] = ACTIONS(9700),
    [aux_sym__terminator_token2] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [5613] = {
    [sym_block_comment] = STATE(5613),
    [sym_line_comment] = STATE(5613),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_elseif] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5614] = {
    [sym_do_clause] = STATE(6402),
    [sym_block_comment] = STATE(5614),
    [sym_line_comment] = STATE(5614),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10495),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5615] = {
    [sym_block_comment] = STATE(5615),
    [sym_line_comment] = STATE(5615),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_elseif] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5616] = {
    [sym_block_comment] = STATE(5616),
    [sym_line_comment] = STATE(5616),
    [ts_builtin_sym_end] = ACTIONS(9756),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_RBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5617] = {
    [sym_block_comment] = STATE(5617),
    [sym_line_comment] = STATE(5617),
    [ts_builtin_sym_end] = ACTIONS(9758),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_RBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5618] = {
    [sym_block_comment] = STATE(5618),
    [sym_line_comment] = STATE(5618),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_elseif] = ACTIONS(10086),
    [anon_sym_else] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5619] = {
    [sym_block_comment] = STATE(5619),
    [sym_line_comment] = STATE(5619),
    [ts_builtin_sym_end] = ACTIONS(9806),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_RBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5620] = {
    [sym_block_comment] = STATE(5620),
    [sym_line_comment] = STATE(5620),
    [ts_builtin_sym_end] = ACTIONS(9808),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_RBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5621] = {
    [sym_block_comment] = STATE(5621),
    [sym_line_comment] = STATE(5621),
    [ts_builtin_sym_end] = ACTIONS(9812),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_RBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5622] = {
    [sym_block_comment] = STATE(5622),
    [sym_line_comment] = STATE(5622),
    [ts_builtin_sym_end] = ACTIONS(9816),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_RBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5623] = {
    [sym_block_comment] = STATE(5623),
    [sym_line_comment] = STATE(5623),
    [ts_builtin_sym_end] = ACTIONS(9820),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_RBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5624] = {
    [sym_block_comment] = STATE(5624),
    [sym_line_comment] = STATE(5624),
    [ts_builtin_sym_end] = ACTIONS(9822),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_RBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5625] = {
    [sym_block_comment] = STATE(5625),
    [sym_line_comment] = STATE(5625),
    [ts_builtin_sym_end] = ACTIONS(9826),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_RBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5626] = {
    [sym_block_comment] = STATE(5626),
    [sym_line_comment] = STATE(5626),
    [ts_builtin_sym_end] = ACTIONS(9830),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_RBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5627] = {
    [sym_block_comment] = STATE(5627),
    [sym_line_comment] = STATE(5627),
    [ts_builtin_sym_end] = ACTIONS(9834),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_RBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5628] = {
    [sym_block_comment] = STATE(5628),
    [sym_line_comment] = STATE(5628),
    [ts_builtin_sym_end] = ACTIONS(9838),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_RBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5629] = {
    [sym_block_comment] = STATE(5629),
    [sym_line_comment] = STATE(5629),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5630] = {
    [sym_block_comment] = STATE(5630),
    [sym_line_comment] = STATE(5630),
    [ts_builtin_sym_end] = ACTIONS(10328),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10322),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_RBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10497),
    [anon_sym_DOT] = ACTIONS(10499),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10501),
    [sym__immediate_bracket] = ACTIONS(10503),
    [sym__immediate_brace] = ACTIONS(10505),
  },
  [5631] = {
    [sym_block_comment] = STATE(5631),
    [sym_line_comment] = STATE(5631),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9756),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9756),
    [anon_sym_RPAREN] = ACTIONS(9756),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9756),
    [anon_sym_RBRACK] = ACTIONS(9756),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_SEMI] = ACTIONS(9756),
    [anon_sym_LBRACE] = ACTIONS(9756),
    [anon_sym_RBRACE] = ACTIONS(9756),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9756),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9756),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9756),
    [anon_sym_QMARK] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9756),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9756),
    [aux_sym_integer_literal_token2] = ACTIONS(9756),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9756),
    [aux_sym_float_literal_token3] = ACTIONS(9756),
    [aux_sym_float_literal_token4] = ACTIONS(9756),
    [sym_character_literal] = ACTIONS(9756),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9756),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9756),
    [sym__pair_operator] = ACTIONS(9756),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9756),
    [sym__lazy_and_operator] = ACTIONS(9756),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9756),
    [sym__pipe_left_operator] = ACTIONS(9756),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9756),
    [sym__bitshift_operator] = ACTIONS(9756),
    [sym__power_operator] = ACTIONS(9756),
    [sym__tilde_operator] = ACTIONS(9756),
    [sym__type_order_operator] = ACTIONS(9756),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5632] = {
    [sym_block_comment] = STATE(5632),
    [sym_line_comment] = STATE(5632),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_RBRACK] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9758),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9758),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9758),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9758),
    [aux_sym_integer_literal_token2] = ACTIONS(9758),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9758),
    [aux_sym_float_literal_token3] = ACTIONS(9758),
    [aux_sym_float_literal_token4] = ACTIONS(9758),
    [sym_character_literal] = ACTIONS(9758),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9758),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9758),
    [sym__pair_operator] = ACTIONS(9758),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9758),
    [sym__lazy_and_operator] = ACTIONS(9758),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9758),
    [sym__pipe_left_operator] = ACTIONS(9758),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9758),
    [sym__bitshift_operator] = ACTIONS(9758),
    [sym__power_operator] = ACTIONS(9758),
    [sym__tilde_operator] = ACTIONS(9758),
    [sym__type_order_operator] = ACTIONS(9758),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5633] = {
    [sym_block_comment] = STATE(5633),
    [sym_line_comment] = STATE(5633),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_DASH_GT] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5634] = {
    [sym_block_comment] = STATE(5634),
    [sym_line_comment] = STATE(5634),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_DASH_GT] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5635] = {
    [sym_block_comment] = STATE(5635),
    [sym_line_comment] = STATE(5635),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_DASH_GT] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5636] = {
    [sym_block_comment] = STATE(5636),
    [sym_line_comment] = STATE(5636),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9806),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9806),
    [anon_sym_RPAREN] = ACTIONS(9806),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9806),
    [anon_sym_RBRACK] = ACTIONS(9806),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_SEMI] = ACTIONS(9806),
    [anon_sym_LBRACE] = ACTIONS(9806),
    [anon_sym_RBRACE] = ACTIONS(9806),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9806),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9806),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9806),
    [anon_sym_QMARK] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9806),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9806),
    [aux_sym_integer_literal_token2] = ACTIONS(9806),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9806),
    [aux_sym_float_literal_token3] = ACTIONS(9806),
    [aux_sym_float_literal_token4] = ACTIONS(9806),
    [sym_character_literal] = ACTIONS(9806),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9806),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9806),
    [sym__pair_operator] = ACTIONS(9806),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9806),
    [sym__lazy_and_operator] = ACTIONS(9806),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9806),
    [sym__pipe_left_operator] = ACTIONS(9806),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9806),
    [sym__bitshift_operator] = ACTIONS(9806),
    [sym__power_operator] = ACTIONS(9806),
    [sym__tilde_operator] = ACTIONS(9806),
    [sym__type_order_operator] = ACTIONS(9806),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5637] = {
    [sym_block_comment] = STATE(5637),
    [sym_line_comment] = STATE(5637),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9808),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9808),
    [anon_sym_RPAREN] = ACTIONS(9808),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9808),
    [anon_sym_RBRACK] = ACTIONS(9808),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_SEMI] = ACTIONS(9808),
    [anon_sym_LBRACE] = ACTIONS(9808),
    [anon_sym_RBRACE] = ACTIONS(9808),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9808),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9808),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9808),
    [anon_sym_QMARK] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9808),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9808),
    [aux_sym_integer_literal_token2] = ACTIONS(9808),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9808),
    [aux_sym_float_literal_token3] = ACTIONS(9808),
    [aux_sym_float_literal_token4] = ACTIONS(9808),
    [sym_character_literal] = ACTIONS(9808),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9808),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9808),
    [sym__pair_operator] = ACTIONS(9808),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9808),
    [sym__lazy_and_operator] = ACTIONS(9808),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9808),
    [sym__pipe_left_operator] = ACTIONS(9808),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9808),
    [sym__bitshift_operator] = ACTIONS(9808),
    [sym__power_operator] = ACTIONS(9808),
    [sym__tilde_operator] = ACTIONS(9808),
    [sym__type_order_operator] = ACTIONS(9808),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5638] = {
    [sym_block_comment] = STATE(5638),
    [sym_line_comment] = STATE(5638),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9812),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9812),
    [anon_sym_RPAREN] = ACTIONS(9812),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9812),
    [anon_sym_RBRACK] = ACTIONS(9812),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_SEMI] = ACTIONS(9812),
    [anon_sym_LBRACE] = ACTIONS(9812),
    [anon_sym_RBRACE] = ACTIONS(9812),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9812),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9812),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9812),
    [anon_sym_QMARK] = ACTIONS(9812),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9812),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9812),
    [aux_sym_integer_literal_token2] = ACTIONS(9812),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9812),
    [aux_sym_float_literal_token3] = ACTIONS(9812),
    [aux_sym_float_literal_token4] = ACTIONS(9812),
    [sym_character_literal] = ACTIONS(9812),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9812),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9812),
    [sym__pair_operator] = ACTIONS(9812),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9812),
    [sym__lazy_and_operator] = ACTIONS(9812),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9812),
    [sym__pipe_left_operator] = ACTIONS(9812),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9812),
    [sym__bitshift_operator] = ACTIONS(9812),
    [sym__power_operator] = ACTIONS(9812),
    [sym__tilde_operator] = ACTIONS(9812),
    [sym__type_order_operator] = ACTIONS(9812),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5639] = {
    [sym_block_comment] = STATE(5639),
    [sym_line_comment] = STATE(5639),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9816),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9816),
    [anon_sym_RPAREN] = ACTIONS(9816),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9816),
    [anon_sym_RBRACK] = ACTIONS(9816),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_SEMI] = ACTIONS(9816),
    [anon_sym_LBRACE] = ACTIONS(9816),
    [anon_sym_RBRACE] = ACTIONS(9816),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9816),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9816),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9816),
    [anon_sym_QMARK] = ACTIONS(9816),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9816),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9816),
    [aux_sym_integer_literal_token2] = ACTIONS(9816),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9816),
    [aux_sym_float_literal_token3] = ACTIONS(9816),
    [aux_sym_float_literal_token4] = ACTIONS(9816),
    [sym_character_literal] = ACTIONS(9816),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9816),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9816),
    [sym__pair_operator] = ACTIONS(9816),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9816),
    [sym__lazy_and_operator] = ACTIONS(9816),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9816),
    [sym__pipe_left_operator] = ACTIONS(9816),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9816),
    [sym__bitshift_operator] = ACTIONS(9816),
    [sym__power_operator] = ACTIONS(9816),
    [sym__tilde_operator] = ACTIONS(9816),
    [sym__type_order_operator] = ACTIONS(9816),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5640] = {
    [sym_block_comment] = STATE(5640),
    [sym_line_comment] = STATE(5640),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9820),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9820),
    [anon_sym_RPAREN] = ACTIONS(9820),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9820),
    [anon_sym_RBRACK] = ACTIONS(9820),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_SEMI] = ACTIONS(9820),
    [anon_sym_LBRACE] = ACTIONS(9820),
    [anon_sym_RBRACE] = ACTIONS(9820),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9820),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9820),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9820),
    [anon_sym_QMARK] = ACTIONS(9820),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9820),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9820),
    [aux_sym_integer_literal_token2] = ACTIONS(9820),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9820),
    [aux_sym_float_literal_token3] = ACTIONS(9820),
    [aux_sym_float_literal_token4] = ACTIONS(9820),
    [sym_character_literal] = ACTIONS(9820),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9820),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9820),
    [sym__pair_operator] = ACTIONS(9820),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9820),
    [sym__lazy_and_operator] = ACTIONS(9820),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9820),
    [sym__pipe_left_operator] = ACTIONS(9820),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9820),
    [sym__bitshift_operator] = ACTIONS(9820),
    [sym__power_operator] = ACTIONS(9820),
    [sym__tilde_operator] = ACTIONS(9820),
    [sym__type_order_operator] = ACTIONS(9820),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5641] = {
    [sym_block_comment] = STATE(5641),
    [sym_line_comment] = STATE(5641),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9822),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9822),
    [anon_sym_RPAREN] = ACTIONS(9822),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9822),
    [anon_sym_RBRACK] = ACTIONS(9822),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_SEMI] = ACTIONS(9822),
    [anon_sym_LBRACE] = ACTIONS(9822),
    [anon_sym_RBRACE] = ACTIONS(9822),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9822),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9822),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9822),
    [anon_sym_QMARK] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9822),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9822),
    [aux_sym_integer_literal_token2] = ACTIONS(9822),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9822),
    [aux_sym_float_literal_token3] = ACTIONS(9822),
    [aux_sym_float_literal_token4] = ACTIONS(9822),
    [sym_character_literal] = ACTIONS(9822),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9822),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9822),
    [sym__pair_operator] = ACTIONS(9822),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9822),
    [sym__lazy_and_operator] = ACTIONS(9822),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9822),
    [sym__pipe_left_operator] = ACTIONS(9822),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9822),
    [sym__bitshift_operator] = ACTIONS(9822),
    [sym__power_operator] = ACTIONS(9822),
    [sym__tilde_operator] = ACTIONS(9822),
    [sym__type_order_operator] = ACTIONS(9822),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5642] = {
    [sym_block_comment] = STATE(5642),
    [sym_line_comment] = STATE(5642),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9826),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9826),
    [anon_sym_RPAREN] = ACTIONS(9826),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9826),
    [anon_sym_RBRACK] = ACTIONS(9826),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_SEMI] = ACTIONS(9826),
    [anon_sym_LBRACE] = ACTIONS(9826),
    [anon_sym_RBRACE] = ACTIONS(9826),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9826),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9826),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9826),
    [anon_sym_QMARK] = ACTIONS(9826),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9826),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9826),
    [aux_sym_integer_literal_token2] = ACTIONS(9826),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9826),
    [aux_sym_float_literal_token3] = ACTIONS(9826),
    [aux_sym_float_literal_token4] = ACTIONS(9826),
    [sym_character_literal] = ACTIONS(9826),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9826),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9826),
    [sym__pair_operator] = ACTIONS(9826),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9826),
    [sym__lazy_and_operator] = ACTIONS(9826),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9826),
    [sym__pipe_left_operator] = ACTIONS(9826),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9826),
    [sym__bitshift_operator] = ACTIONS(9826),
    [sym__power_operator] = ACTIONS(9826),
    [sym__tilde_operator] = ACTIONS(9826),
    [sym__type_order_operator] = ACTIONS(9826),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5643] = {
    [sym_block_comment] = STATE(5643),
    [sym_line_comment] = STATE(5643),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9830),
    [anon_sym_RPAREN] = ACTIONS(9830),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9830),
    [anon_sym_RBRACK] = ACTIONS(9830),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_SEMI] = ACTIONS(9830),
    [anon_sym_LBRACE] = ACTIONS(9830),
    [anon_sym_RBRACE] = ACTIONS(9830),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9830),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9830),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9830),
    [anon_sym_QMARK] = ACTIONS(9830),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9830),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9830),
    [aux_sym_integer_literal_token2] = ACTIONS(9830),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9830),
    [aux_sym_float_literal_token3] = ACTIONS(9830),
    [aux_sym_float_literal_token4] = ACTIONS(9830),
    [sym_character_literal] = ACTIONS(9830),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9830),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9830),
    [sym__pair_operator] = ACTIONS(9830),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9830),
    [sym__lazy_and_operator] = ACTIONS(9830),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9830),
    [sym__pipe_left_operator] = ACTIONS(9830),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9830),
    [sym__bitshift_operator] = ACTIONS(9830),
    [sym__power_operator] = ACTIONS(9830),
    [sym__tilde_operator] = ACTIONS(9830),
    [sym__type_order_operator] = ACTIONS(9830),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5644] = {
    [sym_block_comment] = STATE(5644),
    [sym_line_comment] = STATE(5644),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9834),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9834),
    [anon_sym_RPAREN] = ACTIONS(9834),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9834),
    [anon_sym_RBRACK] = ACTIONS(9834),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_SEMI] = ACTIONS(9834),
    [anon_sym_LBRACE] = ACTIONS(9834),
    [anon_sym_RBRACE] = ACTIONS(9834),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9834),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9834),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9834),
    [anon_sym_QMARK] = ACTIONS(9834),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9834),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9834),
    [aux_sym_integer_literal_token2] = ACTIONS(9834),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9834),
    [aux_sym_float_literal_token3] = ACTIONS(9834),
    [aux_sym_float_literal_token4] = ACTIONS(9834),
    [sym_character_literal] = ACTIONS(9834),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9834),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9834),
    [sym__pair_operator] = ACTIONS(9834),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9834),
    [sym__lazy_and_operator] = ACTIONS(9834),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9834),
    [sym__pipe_left_operator] = ACTIONS(9834),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9834),
    [sym__bitshift_operator] = ACTIONS(9834),
    [sym__power_operator] = ACTIONS(9834),
    [sym__tilde_operator] = ACTIONS(9834),
    [sym__type_order_operator] = ACTIONS(9834),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5645] = {
    [sym_block_comment] = STATE(5645),
    [sym_line_comment] = STATE(5645),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9838),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9838),
    [anon_sym_RPAREN] = ACTIONS(9838),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9838),
    [anon_sym_RBRACK] = ACTIONS(9838),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_SEMI] = ACTIONS(9838),
    [anon_sym_LBRACE] = ACTIONS(9838),
    [anon_sym_RBRACE] = ACTIONS(9838),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9838),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9838),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9838),
    [anon_sym_QMARK] = ACTIONS(9838),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9838),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9838),
    [aux_sym_integer_literal_token2] = ACTIONS(9838),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9838),
    [aux_sym_float_literal_token3] = ACTIONS(9838),
    [aux_sym_float_literal_token4] = ACTIONS(9838),
    [sym_character_literal] = ACTIONS(9838),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9838),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9838),
    [sym__pair_operator] = ACTIONS(9838),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9838),
    [sym__lazy_and_operator] = ACTIONS(9838),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9838),
    [sym__pipe_left_operator] = ACTIONS(9838),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9838),
    [sym__bitshift_operator] = ACTIONS(9838),
    [sym__power_operator] = ACTIONS(9838),
    [sym__tilde_operator] = ACTIONS(9838),
    [sym__type_order_operator] = ACTIONS(9838),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5646] = {
    [sym_block_comment] = STATE(5646),
    [sym_line_comment] = STATE(5646),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5647] = {
    [sym_block_comment] = STATE(5647),
    [sym_line_comment] = STATE(5647),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5648] = {
    [sym_block_comment] = STATE(5648),
    [sym_line_comment] = STATE(5648),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5649] = {
    [sym_block_comment] = STATE(5649),
    [sym_line_comment] = STATE(5649),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5650] = {
    [sym_block_comment] = STATE(5650),
    [sym_line_comment] = STATE(5650),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5651] = {
    [sym_block_comment] = STATE(5651),
    [sym_line_comment] = STATE(5651),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5652] = {
    [sym_block_comment] = STATE(5652),
    [sym_line_comment] = STATE(5652),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5653] = {
    [sym_block_comment] = STATE(5653),
    [sym_line_comment] = STATE(5653),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5654] = {
    [sym_block_comment] = STATE(5654),
    [sym_line_comment] = STATE(5654),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5655] = {
    [sym_block_comment] = STATE(5655),
    [sym_line_comment] = STATE(5655),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5656] = {
    [sym_block_comment] = STATE(5656),
    [sym_line_comment] = STATE(5656),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5657] = {
    [sym_block_comment] = STATE(5657),
    [sym_line_comment] = STATE(5657),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5658] = {
    [sym_block_comment] = STATE(5658),
    [sym_line_comment] = STATE(5658),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10467),
    [sym__immediate_command_start] = ACTIONS(10469),
  },
  [5659] = {
    [sym__primary_expression] = STATE(11579),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11374),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(5659),
    [sym_line_comment] = STATE(5659),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10507),
    [anon_sym_COLON2] = ACTIONS(10509),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_COLON_EQ] = ACTIONS(101),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(101),
    [aux_sym__assignment_operator_token1] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(8937),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(8937),
    [sym__pipe_left_operator] = ACTIONS(8937),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(8937),
    [sym__type_order_operator] = ACTIONS(8937),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5660] = {
    [sym_block_comment] = STATE(5660),
    [sym_line_comment] = STATE(5660),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10328),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10328),
    [anon_sym_RPAREN] = ACTIONS(10328),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10328),
    [anon_sym_RBRACK] = ACTIONS(10328),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_SEMI] = ACTIONS(10328),
    [anon_sym_LBRACE] = ACTIONS(10328),
    [anon_sym_RBRACE] = ACTIONS(10328),
    [anon_sym_SQUOTE] = ACTIONS(10511),
    [anon_sym_DOT] = ACTIONS(10513),
    [anon_sym_DOLLAR] = ACTIONS(10328),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10328),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10328),
    [anon_sym_QMARK] = ACTIONS(10328),
    [anon_sym_DASH_GT] = ACTIONS(10328),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10328),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10328),
    [aux_sym_integer_literal_token2] = ACTIONS(10328),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10328),
    [aux_sym_float_literal_token3] = ACTIONS(10328),
    [aux_sym_float_literal_token4] = ACTIONS(10328),
    [sym_character_literal] = ACTIONS(10328),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10328),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10328),
    [sym__pair_operator] = ACTIONS(10328),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10328),
    [sym__lazy_and_operator] = ACTIONS(10328),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10328),
    [sym__pipe_left_operator] = ACTIONS(10328),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10328),
    [sym__bitshift_operator] = ACTIONS(10328),
    [sym__power_operator] = ACTIONS(10328),
    [sym__tilde_operator] = ACTIONS(10328),
    [sym__type_order_operator] = ACTIONS(10328),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10515),
    [sym__immediate_bracket] = ACTIONS(10517),
    [sym__immediate_brace] = ACTIONS(10519),
  },
  [5661] = {
    [sym_block_comment] = STATE(5661),
    [sym_line_comment] = STATE(5661),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_catch] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5662] = {
    [sym_block_comment] = STATE(5662),
    [sym_line_comment] = STATE(5662),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_end] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_elseif] = ACTIONS(10440),
    [anon_sym_else] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10440),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10440),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10440),
    [anon_sym_SQUOTE] = ACTIONS(10521),
    [anon_sym_DOT] = ACTIONS(10523),
    [anon_sym_DOLLAR] = ACTIONS(10440),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10440),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10440),
    [anon_sym_QMARK] = ACTIONS(10440),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10440),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10440),
    [aux_sym_integer_literal_token2] = ACTIONS(10440),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10440),
    [aux_sym_float_literal_token3] = ACTIONS(10440),
    [aux_sym_float_literal_token4] = ACTIONS(10440),
    [sym_character_literal] = ACTIONS(10440),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10440),
    [sym__pair_operator] = ACTIONS(10440),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10440),
    [sym__lazy_and_operator] = ACTIONS(10440),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10440),
    [sym__pipe_left_operator] = ACTIONS(10440),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10440),
    [sym__bitshift_operator] = ACTIONS(10440),
    [sym__power_operator] = ACTIONS(10440),
    [sym__tilde_operator] = ACTIONS(10440),
    [sym__type_order_operator] = ACTIONS(10440),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym__terminator_token1] = ACTIONS(10525),
    [aux_sym__terminator_token2] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10527),
    [sym__immediate_bracket] = ACTIONS(10529),
    [sym__immediate_brace] = ACTIONS(10531),
  },
  [5663] = {
    [sym_block_comment] = STATE(5663),
    [sym_line_comment] = STATE(5663),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_catch] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5664] = {
    [sym_block_comment] = STATE(5664),
    [sym_line_comment] = STATE(5664),
    [ts_builtin_sym_end] = ACTIONS(9980),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_RBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_DASH_GT] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5665] = {
    [sym_block_comment] = STATE(5665),
    [sym_line_comment] = STATE(5665),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5666] = {
    [sym_block_comment] = STATE(5666),
    [sym_line_comment] = STATE(5666),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_catch] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5667] = {
    [sym_block_comment] = STATE(5667),
    [sym_line_comment] = STATE(5667),
    [ts_builtin_sym_end] = ACTIONS(9956),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_RBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_DASH_GT] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5668] = {
    [sym_block_comment] = STATE(5668),
    [sym_line_comment] = STATE(5668),
    [ts_builtin_sym_end] = ACTIONS(9964),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_RBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_DASH_GT] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5669] = {
    [sym_block_comment] = STATE(5669),
    [sym_line_comment] = STATE(5669),
    [ts_builtin_sym_end] = ACTIONS(9708),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_RBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5670] = {
    [sym_block_comment] = STATE(5670),
    [sym_line_comment] = STATE(5670),
    [ts_builtin_sym_end] = ACTIONS(9712),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_RBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5671] = {
    [sym_block_comment] = STATE(5671),
    [sym_line_comment] = STATE(5671),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_catch] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5672] = {
    [sym_block_comment] = STATE(5672),
    [sym_line_comment] = STATE(5672),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_catch] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5673] = {
    [sym_block_comment] = STATE(5673),
    [sym_line_comment] = STATE(5673),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_catch] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5674] = {
    [sym_block_comment] = STATE(5674),
    [sym_line_comment] = STATE(5674),
    [ts_builtin_sym_end] = ACTIONS(10104),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_RBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_DASH_GT] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5675] = {
    [sym_block_comment] = STATE(5675),
    [sym_line_comment] = STATE(5675),
    [ts_builtin_sym_end] = ACTIONS(10108),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_RBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_DASH_GT] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5676] = {
    [sym_block_comment] = STATE(5676),
    [sym_line_comment] = STATE(5676),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_catch] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5677] = {
    [sym_block_comment] = STATE(5677),
    [sym_line_comment] = STATE(5677),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_catch] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5678] = {
    [sym_block_comment] = STATE(5678),
    [sym_line_comment] = STATE(5678),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_catch] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5679] = {
    [sym_block_comment] = STATE(5679),
    [sym_line_comment] = STATE(5679),
    [ts_builtin_sym_end] = ACTIONS(10124),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_RBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_DASH_GT] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5680] = {
    [sym_block_comment] = STATE(5680),
    [sym_line_comment] = STATE(5680),
    [ts_builtin_sym_end] = ACTIONS(9704),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_RBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5681] = {
    [sym_block_comment] = STATE(5681),
    [sym_line_comment] = STATE(5681),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_catch] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5682] = {
    [sym_block_comment] = STATE(5682),
    [sym_line_comment] = STATE(5682),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_catch] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5683] = {
    [sym_block_comment] = STATE(5683),
    [sym_line_comment] = STATE(5683),
    [ts_builtin_sym_end] = ACTIONS(10130),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_RBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_DASH_GT] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5684] = {
    [sym_block_comment] = STATE(5684),
    [sym_line_comment] = STATE(5684),
    [ts_builtin_sym_end] = ACTIONS(10140),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_RBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_DASH_GT] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5685] = {
    [sym_block_comment] = STATE(5685),
    [sym_line_comment] = STATE(5685),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_catch] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5686] = {
    [sym_block_comment] = STATE(5686),
    [sym_line_comment] = STATE(5686),
    [ts_builtin_sym_end] = ACTIONS(10144),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_RBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_DASH_GT] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5687] = {
    [sym_block_comment] = STATE(5687),
    [sym_line_comment] = STATE(5687),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9980),
    [anon_sym_RPAREN] = ACTIONS(9980),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9980),
    [anon_sym_RBRACK] = ACTIONS(9980),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_SEMI] = ACTIONS(9980),
    [anon_sym_LBRACE] = ACTIONS(9980),
    [anon_sym_RBRACE] = ACTIONS(9980),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9980),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9980),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9980),
    [anon_sym_QMARK] = ACTIONS(9980),
    [anon_sym_DASH_GT] = ACTIONS(9980),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9980),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9980),
    [aux_sym_integer_literal_token2] = ACTIONS(9980),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9980),
    [aux_sym_float_literal_token3] = ACTIONS(9980),
    [aux_sym_float_literal_token4] = ACTIONS(9980),
    [sym_character_literal] = ACTIONS(9980),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9980),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9980),
    [sym__pair_operator] = ACTIONS(9980),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9980),
    [sym__lazy_and_operator] = ACTIONS(9980),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9980),
    [sym__pipe_left_operator] = ACTIONS(9980),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9980),
    [sym__bitshift_operator] = ACTIONS(9980),
    [sym__power_operator] = ACTIONS(9980),
    [sym__tilde_operator] = ACTIONS(9980),
    [sym__type_order_operator] = ACTIONS(9980),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5688] = {
    [sym_block_comment] = STATE(5688),
    [sym_line_comment] = STATE(5688),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_DASH_GT] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5689] = {
    [sym_block_comment] = STATE(5689),
    [sym_line_comment] = STATE(5689),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5690] = {
    [sym__primary_expression] = STATE(11535),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(11378),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(5690),
    [sym_line_comment] = STATE(5690),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10533),
    [anon_sym_COLON2] = ACTIONS(10535),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5691] = {
    [sym_block_comment] = STATE(5691),
    [sym_line_comment] = STATE(5691),
    [ts_builtin_sym_end] = ACTIONS(9928),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_RBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_DASH_GT] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5692] = {
    [sym_block_comment] = STATE(5692),
    [sym_line_comment] = STATE(5692),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9956),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9956),
    [anon_sym_RPAREN] = ACTIONS(9956),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9956),
    [anon_sym_RBRACK] = ACTIONS(9956),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_SEMI] = ACTIONS(9956),
    [anon_sym_LBRACE] = ACTIONS(9956),
    [anon_sym_RBRACE] = ACTIONS(9956),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9956),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9956),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9956),
    [anon_sym_QMARK] = ACTIONS(9956),
    [anon_sym_DASH_GT] = ACTIONS(9956),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9956),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9956),
    [aux_sym_integer_literal_token2] = ACTIONS(9956),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9956),
    [aux_sym_float_literal_token3] = ACTIONS(9956),
    [aux_sym_float_literal_token4] = ACTIONS(9956),
    [sym_character_literal] = ACTIONS(9956),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9956),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9956),
    [sym__pair_operator] = ACTIONS(9956),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9956),
    [sym__lazy_and_operator] = ACTIONS(9956),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9956),
    [sym__pipe_left_operator] = ACTIONS(9956),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9956),
    [sym__bitshift_operator] = ACTIONS(9956),
    [sym__power_operator] = ACTIONS(9956),
    [sym__tilde_operator] = ACTIONS(9956),
    [sym__type_order_operator] = ACTIONS(9956),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5693] = {
    [sym_block_comment] = STATE(5693),
    [sym_line_comment] = STATE(5693),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9964),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9964),
    [anon_sym_RPAREN] = ACTIONS(9964),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9964),
    [anon_sym_RBRACK] = ACTIONS(9964),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_SEMI] = ACTIONS(9964),
    [anon_sym_LBRACE] = ACTIONS(9964),
    [anon_sym_RBRACE] = ACTIONS(9964),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9964),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9964),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9964),
    [anon_sym_QMARK] = ACTIONS(9964),
    [anon_sym_DASH_GT] = ACTIONS(9964),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9964),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9964),
    [aux_sym_integer_literal_token2] = ACTIONS(9964),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9964),
    [aux_sym_float_literal_token3] = ACTIONS(9964),
    [aux_sym_float_literal_token4] = ACTIONS(9964),
    [sym_character_literal] = ACTIONS(9964),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9964),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9964),
    [sym__pair_operator] = ACTIONS(9964),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9964),
    [sym__lazy_and_operator] = ACTIONS(9964),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9964),
    [sym__pipe_left_operator] = ACTIONS(9964),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9964),
    [sym__bitshift_operator] = ACTIONS(9964),
    [sym__power_operator] = ACTIONS(9964),
    [sym__tilde_operator] = ACTIONS(9964),
    [sym__type_order_operator] = ACTIONS(9964),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5694] = {
    [sym_block_comment] = STATE(5694),
    [sym_line_comment] = STATE(5694),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_RBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_SEMI] = ACTIONS(9708),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_DASH_GT] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5695] = {
    [sym_block_comment] = STATE(5695),
    [sym_line_comment] = STATE(5695),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_RBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_SEMI] = ACTIONS(9712),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_DASH_GT] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5696] = {
    [sym_block_comment] = STATE(5696),
    [sym_line_comment] = STATE(5696),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10104),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10104),
    [anon_sym_RPAREN] = ACTIONS(10104),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10104),
    [anon_sym_RBRACK] = ACTIONS(10104),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_SEMI] = ACTIONS(10104),
    [anon_sym_LBRACE] = ACTIONS(10104),
    [anon_sym_RBRACE] = ACTIONS(10104),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10104),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10104),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10104),
    [anon_sym_QMARK] = ACTIONS(10104),
    [anon_sym_DASH_GT] = ACTIONS(10104),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10104),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10104),
    [aux_sym_integer_literal_token2] = ACTIONS(10104),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10104),
    [aux_sym_float_literal_token3] = ACTIONS(10104),
    [aux_sym_float_literal_token4] = ACTIONS(10104),
    [sym_character_literal] = ACTIONS(10104),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10104),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10104),
    [sym__pair_operator] = ACTIONS(10104),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10104),
    [sym__lazy_and_operator] = ACTIONS(10104),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10104),
    [sym__pipe_left_operator] = ACTIONS(10104),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10104),
    [sym__bitshift_operator] = ACTIONS(10104),
    [sym__power_operator] = ACTIONS(10104),
    [sym__tilde_operator] = ACTIONS(10104),
    [sym__type_order_operator] = ACTIONS(10104),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5697] = {
    [sym_block_comment] = STATE(5697),
    [sym_line_comment] = STATE(5697),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10537),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_end] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_elseif] = ACTIONS(10537),
    [anon_sym_else] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10537),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10537),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10537),
    [anon_sym_SQUOTE] = ACTIONS(10521),
    [anon_sym_DOT] = ACTIONS(10523),
    [anon_sym_DOLLAR] = ACTIONS(10537),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10537),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10537),
    [anon_sym_QMARK] = ACTIONS(10537),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10537),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10537),
    [aux_sym_integer_literal_token2] = ACTIONS(10537),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10537),
    [aux_sym_float_literal_token3] = ACTIONS(10537),
    [aux_sym_float_literal_token4] = ACTIONS(10537),
    [sym_character_literal] = ACTIONS(10537),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10537),
    [sym__pair_operator] = ACTIONS(10537),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10537),
    [sym__lazy_and_operator] = ACTIONS(10537),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10537),
    [sym__pipe_left_operator] = ACTIONS(10537),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10537),
    [sym__bitshift_operator] = ACTIONS(10537),
    [sym__power_operator] = ACTIONS(10537),
    [sym__tilde_operator] = ACTIONS(10537),
    [sym__type_order_operator] = ACTIONS(10537),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym__terminator_token1] = ACTIONS(10539),
    [aux_sym__terminator_token2] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10527),
    [sym__immediate_bracket] = ACTIONS(10529),
    [sym__immediate_brace] = ACTIONS(10531),
  },
  [5698] = {
    [sym_block_comment] = STATE(5698),
    [sym_line_comment] = STATE(5698),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10108),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10108),
    [anon_sym_RPAREN] = ACTIONS(10108),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10108),
    [anon_sym_RBRACK] = ACTIONS(10108),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_SEMI] = ACTIONS(10108),
    [anon_sym_LBRACE] = ACTIONS(10108),
    [anon_sym_RBRACE] = ACTIONS(10108),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10108),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10108),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10108),
    [anon_sym_QMARK] = ACTIONS(10108),
    [anon_sym_DASH_GT] = ACTIONS(10108),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10108),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10108),
    [aux_sym_integer_literal_token2] = ACTIONS(10108),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10108),
    [aux_sym_float_literal_token3] = ACTIONS(10108),
    [aux_sym_float_literal_token4] = ACTIONS(10108),
    [sym_character_literal] = ACTIONS(10108),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10108),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10108),
    [sym__pair_operator] = ACTIONS(10108),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10108),
    [sym__lazy_and_operator] = ACTIONS(10108),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10108),
    [sym__pipe_left_operator] = ACTIONS(10108),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10108),
    [sym__bitshift_operator] = ACTIONS(10108),
    [sym__power_operator] = ACTIONS(10108),
    [sym__tilde_operator] = ACTIONS(10108),
    [sym__type_order_operator] = ACTIONS(10108),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5699] = {
    [sym_block_comment] = STATE(5699),
    [sym_line_comment] = STATE(5699),
    [ts_builtin_sym_end] = ACTIONS(10118),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_RBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_DASH_GT] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5700] = {
    [sym_block_comment] = STATE(5700),
    [sym_line_comment] = STATE(5700),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10124),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10124),
    [anon_sym_RPAREN] = ACTIONS(10124),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10124),
    [anon_sym_RBRACK] = ACTIONS(10124),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_SEMI] = ACTIONS(10124),
    [anon_sym_LBRACE] = ACTIONS(10124),
    [anon_sym_RBRACE] = ACTIONS(10124),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10124),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10124),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10124),
    [anon_sym_QMARK] = ACTIONS(10124),
    [anon_sym_DASH_GT] = ACTIONS(10124),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10124),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10124),
    [aux_sym_integer_literal_token2] = ACTIONS(10124),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10124),
    [aux_sym_float_literal_token3] = ACTIONS(10124),
    [aux_sym_float_literal_token4] = ACTIONS(10124),
    [sym_character_literal] = ACTIONS(10124),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10124),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10124),
    [sym__pair_operator] = ACTIONS(10124),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10124),
    [sym__lazy_and_operator] = ACTIONS(10124),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10124),
    [sym__pipe_left_operator] = ACTIONS(10124),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10124),
    [sym__bitshift_operator] = ACTIONS(10124),
    [sym__power_operator] = ACTIONS(10124),
    [sym__tilde_operator] = ACTIONS(10124),
    [sym__type_order_operator] = ACTIONS(10124),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5701] = {
    [sym_block_comment] = STATE(5701),
    [sym_line_comment] = STATE(5701),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_RBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_SEMI] = ACTIONS(9704),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_RBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_DASH_GT] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5702] = {
    [sym_block_comment] = STATE(5702),
    [sym_line_comment] = STATE(5702),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10130),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10130),
    [anon_sym_RPAREN] = ACTIONS(10130),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10130),
    [anon_sym_RBRACK] = ACTIONS(10130),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_SEMI] = ACTIONS(10130),
    [anon_sym_LBRACE] = ACTIONS(10130),
    [anon_sym_RBRACE] = ACTIONS(10130),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10130),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10130),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10130),
    [anon_sym_QMARK] = ACTIONS(10130),
    [anon_sym_DASH_GT] = ACTIONS(10130),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10130),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10130),
    [aux_sym_integer_literal_token2] = ACTIONS(10130),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10130),
    [aux_sym_float_literal_token3] = ACTIONS(10130),
    [aux_sym_float_literal_token4] = ACTIONS(10130),
    [sym_character_literal] = ACTIONS(10130),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10130),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10130),
    [sym__pair_operator] = ACTIONS(10130),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10130),
    [sym__lazy_and_operator] = ACTIONS(10130),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10130),
    [sym__pipe_left_operator] = ACTIONS(10130),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10130),
    [sym__bitshift_operator] = ACTIONS(10130),
    [sym__power_operator] = ACTIONS(10130),
    [sym__tilde_operator] = ACTIONS(10130),
    [sym__type_order_operator] = ACTIONS(10130),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5703] = {
    [sym_block_comment] = STATE(5703),
    [sym_line_comment] = STATE(5703),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10140),
    [anon_sym_RPAREN] = ACTIONS(10140),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10140),
    [anon_sym_RBRACK] = ACTIONS(10140),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_SEMI] = ACTIONS(10140),
    [anon_sym_LBRACE] = ACTIONS(10140),
    [anon_sym_RBRACE] = ACTIONS(10140),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10140),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10140),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_QMARK] = ACTIONS(10140),
    [anon_sym_DASH_GT] = ACTIONS(10140),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10140),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10140),
    [aux_sym_integer_literal_token2] = ACTIONS(10140),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10140),
    [aux_sym_float_literal_token3] = ACTIONS(10140),
    [aux_sym_float_literal_token4] = ACTIONS(10140),
    [sym_character_literal] = ACTIONS(10140),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10140),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10140),
    [sym__pair_operator] = ACTIONS(10140),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10140),
    [sym__lazy_and_operator] = ACTIONS(10140),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10140),
    [sym__pipe_left_operator] = ACTIONS(10140),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10140),
    [sym__bitshift_operator] = ACTIONS(10140),
    [sym__power_operator] = ACTIONS(10140),
    [sym__tilde_operator] = ACTIONS(10140),
    [sym__type_order_operator] = ACTIONS(10140),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5704] = {
    [sym_block_comment] = STATE(5704),
    [sym_line_comment] = STATE(5704),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10144),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10144),
    [anon_sym_RPAREN] = ACTIONS(10144),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10144),
    [anon_sym_RBRACK] = ACTIONS(10144),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_SEMI] = ACTIONS(10144),
    [anon_sym_LBRACE] = ACTIONS(10144),
    [anon_sym_RBRACE] = ACTIONS(10144),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10144),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10144),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10144),
    [anon_sym_QMARK] = ACTIONS(10144),
    [anon_sym_DASH_GT] = ACTIONS(10144),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10144),
    [aux_sym_integer_literal_token2] = ACTIONS(10144),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10144),
    [aux_sym_float_literal_token3] = ACTIONS(10144),
    [aux_sym_float_literal_token4] = ACTIONS(10144),
    [sym_character_literal] = ACTIONS(10144),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10144),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10144),
    [sym__pair_operator] = ACTIONS(10144),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10144),
    [sym__lazy_and_operator] = ACTIONS(10144),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10144),
    [sym__pipe_left_operator] = ACTIONS(10144),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10144),
    [sym__bitshift_operator] = ACTIONS(10144),
    [sym__power_operator] = ACTIONS(10144),
    [sym__tilde_operator] = ACTIONS(10144),
    [sym__type_order_operator] = ACTIONS(10144),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5705] = {
    [sym_block_comment] = STATE(5705),
    [sym_line_comment] = STATE(5705),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [5706] = {
    [sym_block_comment] = STATE(5706),
    [sym_line_comment] = STATE(5706),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_else] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5707] = {
    [sym_block_comment] = STATE(5707),
    [sym_line_comment] = STATE(5707),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5708] = {
    [sym_block_comment] = STATE(5708),
    [sym_line_comment] = STATE(5708),
    [ts_builtin_sym_end] = ACTIONS(10154),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_RBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_DASH_GT] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5709] = {
    [sym_block_comment] = STATE(5709),
    [sym_line_comment] = STATE(5709),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_else] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5710] = {
    [sym_block_comment] = STATE(5710),
    [sym_line_comment] = STATE(5710),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_else] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5711] = {
    [sym_block_comment] = STATE(5711),
    [sym_line_comment] = STATE(5711),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_else] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5712] = {
    [sym_block_comment] = STATE(5712),
    [sym_line_comment] = STATE(5712),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_else] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5713] = {
    [sym_block_comment] = STATE(5713),
    [sym_line_comment] = STATE(5713),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_else] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5714] = {
    [sym_block_comment] = STATE(5714),
    [sym_line_comment] = STATE(5714),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_else] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5715] = {
    [sym_block_comment] = STATE(5715),
    [sym_line_comment] = STATE(5715),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_else] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5716] = {
    [sym_block_comment] = STATE(5716),
    [sym_line_comment] = STATE(5716),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_else] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5717] = {
    [sym_block_comment] = STATE(5717),
    [sym_line_comment] = STATE(5717),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_else] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5718] = {
    [sym_block_comment] = STATE(5718),
    [sym_line_comment] = STATE(5718),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_else] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5719] = {
    [sym_block_comment] = STATE(5719),
    [sym_line_comment] = STATE(5719),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_else] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5720] = {
    [sym_block_comment] = STATE(5720),
    [sym_line_comment] = STATE(5720),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_DASH_GT] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5721] = {
    [sym_block_comment] = STATE(5721),
    [sym_line_comment] = STATE(5721),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_RPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_RBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_SEMI] = ACTIONS(9928),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_RBRACE] = ACTIONS(9928),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_DASH_GT] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5722] = {
    [sym_block_comment] = STATE(5722),
    [sym_line_comment] = STATE(5722),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_catch] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5723] = {
    [sym_block_comment] = STATE(5723),
    [sym_line_comment] = STATE(5723),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_RPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_RBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_SEMI] = ACTIONS(10118),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_RBRACE] = ACTIONS(10118),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_DASH_GT] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5724] = {
    [sym_block_comment] = STATE(5724),
    [sym_line_comment] = STATE(5724),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_catch] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5725] = {
    [sym_block_comment] = STATE(5725),
    [sym_line_comment] = STATE(5725),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_RPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_RBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_SEMI] = ACTIONS(10154),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_RBRACE] = ACTIONS(10154),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_DASH_GT] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5726] = {
    [sym_identifier] = STATE(5996),
    [sym_block_comment] = STATE(5726),
    [sym_line_comment] = STATE(5726),
    [ts_builtin_sym_end] = ACTIONS(9782),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_RBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5727] = {
    [sym_identifier] = STATE(5997),
    [sym_block_comment] = STATE(5727),
    [sym_line_comment] = STATE(5727),
    [ts_builtin_sym_end] = ACTIONS(9786),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_RBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5728] = {
    [sym_identifier] = STATE(6002),
    [sym_block_comment] = STATE(5728),
    [sym_line_comment] = STATE(5728),
    [ts_builtin_sym_end] = ACTIONS(9798),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_RBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5729] = {
    [sym_identifier] = STATE(6003),
    [sym_block_comment] = STATE(5729),
    [sym_line_comment] = STATE(5729),
    [ts_builtin_sym_end] = ACTIONS(9802),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_RBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5730] = {
    [sym_block_comment] = STATE(5730),
    [sym_line_comment] = STATE(5730),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_catch] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_DASH_GT] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5731] = {
    [sym_block_comment] = STATE(5731),
    [sym_line_comment] = STATE(5731),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5732] = {
    [sym_block_comment] = STATE(5732),
    [sym_line_comment] = STATE(5732),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_elseif] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5733] = {
    [sym_block_comment] = STATE(5733),
    [sym_line_comment] = STATE(5733),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5734] = {
    [sym_block_comment] = STATE(5734),
    [sym_line_comment] = STATE(5734),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5735] = {
    [sym_block_comment] = STATE(5735),
    [sym_line_comment] = STATE(5735),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_elseif] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5736] = {
    [sym_block_comment] = STATE(5736),
    [sym_line_comment] = STATE(5736),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_catch] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5737] = {
    [sym_block_comment] = STATE(5737),
    [sym_line_comment] = STATE(5737),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5738] = {
    [sym_block_comment] = STATE(5738),
    [sym_line_comment] = STATE(5738),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_catch] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_DASH_GT] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5739] = {
    [sym_block_comment] = STATE(5739),
    [sym_line_comment] = STATE(5739),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_catch] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_DASH_GT] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5740] = {
    [sym_block_comment] = STATE(5740),
    [sym_line_comment] = STATE(5740),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5741] = {
    [sym_block_comment] = STATE(5741),
    [sym_line_comment] = STATE(5741),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5742] = {
    [sym_block_comment] = STATE(5742),
    [sym_line_comment] = STATE(5742),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_catch] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5743] = {
    [sym_block_comment] = STATE(5743),
    [sym_line_comment] = STATE(5743),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_catch] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5744] = {
    [sym_block_comment] = STATE(5744),
    [sym_line_comment] = STATE(5744),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_catch] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5745] = {
    [sym_block_comment] = STATE(5745),
    [sym_line_comment] = STATE(5745),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_catch] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_DASH_GT] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5746] = {
    [sym_block_comment] = STATE(5746),
    [sym_line_comment] = STATE(5746),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_catch] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_DASH_GT] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5747] = {
    [sym_block_comment] = STATE(5747),
    [sym_line_comment] = STATE(5747),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_catch] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5748] = {
    [sym_block_comment] = STATE(5748),
    [sym_line_comment] = STATE(5748),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_catch] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5749] = {
    [sym_block_comment] = STATE(5749),
    [sym_line_comment] = STATE(5749),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_catch] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5750] = {
    [sym_block_comment] = STATE(5750),
    [sym_line_comment] = STATE(5750),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5751] = {
    [sym_block_comment] = STATE(5751),
    [sym_line_comment] = STATE(5751),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_catch] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_DASH_GT] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5752] = {
    [sym_block_comment] = STATE(5752),
    [sym_line_comment] = STATE(5752),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5753] = {
    [sym_block_comment] = STATE(5753),
    [sym_line_comment] = STATE(5753),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_catch] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5754] = {
    [sym_block_comment] = STATE(5754),
    [sym_line_comment] = STATE(5754),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_catch] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5755] = {
    [sym_block_comment] = STATE(5755),
    [sym_line_comment] = STATE(5755),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_catch] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_DASH_GT] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5756] = {
    [sym_block_comment] = STATE(5756),
    [sym_line_comment] = STATE(5756),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_catch] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_DASH_GT] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5757] = {
    [sym_block_comment] = STATE(5757),
    [sym_line_comment] = STATE(5757),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_catch] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5758] = {
    [sym_block_comment] = STATE(5758),
    [sym_line_comment] = STATE(5758),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_catch] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_DASH_GT] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5759] = {
    [sym_block_comment] = STATE(5759),
    [sym_line_comment] = STATE(5759),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9980),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9980),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9980),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9980),
    [anon_sym_COLON_EQ] = ACTIONS(9980),
    [anon_sym_DOT_EQ] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9980),
    [anon_sym_QMARK] = ACTIONS(9980),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9980),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9980),
    [aux_sym_integer_literal_token2] = ACTIONS(9980),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9980),
    [aux_sym_float_literal_token3] = ACTIONS(9980),
    [aux_sym_float_literal_token4] = ACTIONS(9980),
    [sym_character_literal] = ACTIONS(9980),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9980),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9980),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9980),
    [aux_sym__assignment_operator_token1] = ACTIONS(9980),
    [sym__pair_operator] = ACTIONS(9980),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9980),
    [sym__lazy_and_operator] = ACTIONS(9980),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9980),
    [sym__pipe_left_operator] = ACTIONS(9980),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9980),
    [sym__type_order_operator] = ACTIONS(9980),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5760] = {
    [sym_block_comment] = STATE(5760),
    [sym_line_comment] = STATE(5760),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5761] = {
    [sym_block_comment] = STATE(5761),
    [sym_line_comment] = STATE(5761),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5762] = {
    [sym_block_comment] = STATE(5762),
    [sym_line_comment] = STATE(5762),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9956),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9956),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9956),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9956),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9956),
    [anon_sym_COLON_EQ] = ACTIONS(9956),
    [anon_sym_DOT_EQ] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9956),
    [anon_sym_QMARK] = ACTIONS(9956),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9956),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9956),
    [aux_sym_integer_literal_token2] = ACTIONS(9956),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9956),
    [aux_sym_float_literal_token3] = ACTIONS(9956),
    [aux_sym_float_literal_token4] = ACTIONS(9956),
    [sym_character_literal] = ACTIONS(9956),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9956),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9956),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9956),
    [aux_sym__assignment_operator_token1] = ACTIONS(9956),
    [sym__pair_operator] = ACTIONS(9956),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9956),
    [sym__lazy_and_operator] = ACTIONS(9956),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9956),
    [sym__pipe_left_operator] = ACTIONS(9956),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9956),
    [sym__type_order_operator] = ACTIONS(9956),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5763] = {
    [sym_block_comment] = STATE(5763),
    [sym_line_comment] = STATE(5763),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9964),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9964),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9964),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9964),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9964),
    [anon_sym_COLON_EQ] = ACTIONS(9964),
    [anon_sym_DOT_EQ] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9964),
    [anon_sym_QMARK] = ACTIONS(9964),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9964),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9964),
    [aux_sym_integer_literal_token2] = ACTIONS(9964),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9964),
    [aux_sym_float_literal_token3] = ACTIONS(9964),
    [aux_sym_float_literal_token4] = ACTIONS(9964),
    [sym_character_literal] = ACTIONS(9964),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9964),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9964),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9964),
    [aux_sym__assignment_operator_token1] = ACTIONS(9964),
    [sym__pair_operator] = ACTIONS(9964),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9964),
    [sym__lazy_and_operator] = ACTIONS(9964),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9964),
    [sym__pipe_left_operator] = ACTIONS(9964),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9964),
    [sym__type_order_operator] = ACTIONS(9964),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5764] = {
    [sym_block_comment] = STATE(5764),
    [sym_line_comment] = STATE(5764),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_COLON_EQ] = ACTIONS(9708),
    [anon_sym_DOT_EQ] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9708),
    [aux_sym__assignment_operator_token1] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5765] = {
    [sym_block_comment] = STATE(5765),
    [sym_line_comment] = STATE(5765),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_COLON_EQ] = ACTIONS(9712),
    [anon_sym_DOT_EQ] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9712),
    [aux_sym__assignment_operator_token1] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5766] = {
    [sym_block_comment] = STATE(5766),
    [sym_line_comment] = STATE(5766),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10104),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10104),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10104),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10104),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10104),
    [anon_sym_COLON_EQ] = ACTIONS(10104),
    [anon_sym_DOT_EQ] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10104),
    [anon_sym_QMARK] = ACTIONS(10104),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10104),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10104),
    [aux_sym_integer_literal_token2] = ACTIONS(10104),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10104),
    [aux_sym_float_literal_token3] = ACTIONS(10104),
    [aux_sym_float_literal_token4] = ACTIONS(10104),
    [sym_character_literal] = ACTIONS(10104),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10104),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10104),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10104),
    [aux_sym__assignment_operator_token1] = ACTIONS(10104),
    [sym__pair_operator] = ACTIONS(10104),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10104),
    [sym__lazy_and_operator] = ACTIONS(10104),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10104),
    [sym__pipe_left_operator] = ACTIONS(10104),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10104),
    [sym__type_order_operator] = ACTIONS(10104),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5767] = {
    [sym_block_comment] = STATE(5767),
    [sym_line_comment] = STATE(5767),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10108),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10108),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10108),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10108),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10108),
    [anon_sym_COLON_EQ] = ACTIONS(10108),
    [anon_sym_DOT_EQ] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10108),
    [anon_sym_QMARK] = ACTIONS(10108),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10108),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10108),
    [aux_sym_integer_literal_token2] = ACTIONS(10108),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10108),
    [aux_sym_float_literal_token3] = ACTIONS(10108),
    [aux_sym_float_literal_token4] = ACTIONS(10108),
    [sym_character_literal] = ACTIONS(10108),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10108),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10108),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10108),
    [aux_sym__assignment_operator_token1] = ACTIONS(10108),
    [sym__pair_operator] = ACTIONS(10108),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10108),
    [sym__lazy_and_operator] = ACTIONS(10108),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10108),
    [sym__pipe_left_operator] = ACTIONS(10108),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10108),
    [sym__type_order_operator] = ACTIONS(10108),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5768] = {
    [sym_block_comment] = STATE(5768),
    [sym_line_comment] = STATE(5768),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10124),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10124),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10124),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10124),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10124),
    [anon_sym_COLON_EQ] = ACTIONS(10124),
    [anon_sym_DOT_EQ] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10124),
    [anon_sym_QMARK] = ACTIONS(10124),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10124),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10124),
    [aux_sym_integer_literal_token2] = ACTIONS(10124),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10124),
    [aux_sym_float_literal_token3] = ACTIONS(10124),
    [aux_sym_float_literal_token4] = ACTIONS(10124),
    [sym_character_literal] = ACTIONS(10124),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10124),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10124),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10124),
    [aux_sym__assignment_operator_token1] = ACTIONS(10124),
    [sym__pair_operator] = ACTIONS(10124),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10124),
    [sym__lazy_and_operator] = ACTIONS(10124),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10124),
    [sym__pipe_left_operator] = ACTIONS(10124),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10124),
    [sym__type_order_operator] = ACTIONS(10124),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5769] = {
    [sym_block_comment] = STATE(5769),
    [sym_line_comment] = STATE(5769),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_COLON_EQ] = ACTIONS(9704),
    [anon_sym_DOT_EQ] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9704),
    [aux_sym__assignment_operator_token1] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5770] = {
    [sym_block_comment] = STATE(5770),
    [sym_line_comment] = STATE(5770),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10130),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10130),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10130),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10130),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10130),
    [anon_sym_COLON_EQ] = ACTIONS(10130),
    [anon_sym_DOT_EQ] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10130),
    [anon_sym_QMARK] = ACTIONS(10130),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10130),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10130),
    [aux_sym_integer_literal_token2] = ACTIONS(10130),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10130),
    [aux_sym_float_literal_token3] = ACTIONS(10130),
    [aux_sym_float_literal_token4] = ACTIONS(10130),
    [sym_character_literal] = ACTIONS(10130),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10130),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10130),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10130),
    [aux_sym__assignment_operator_token1] = ACTIONS(10130),
    [sym__pair_operator] = ACTIONS(10130),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10130),
    [sym__lazy_and_operator] = ACTIONS(10130),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10130),
    [sym__pipe_left_operator] = ACTIONS(10130),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10130),
    [sym__type_order_operator] = ACTIONS(10130),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5771] = {
    [sym_block_comment] = STATE(5771),
    [sym_line_comment] = STATE(5771),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10140),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10140),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10140),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10140),
    [anon_sym_COLON_EQ] = ACTIONS(10140),
    [anon_sym_DOT_EQ] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_QMARK] = ACTIONS(10140),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10140),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10140),
    [aux_sym_integer_literal_token2] = ACTIONS(10140),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10140),
    [aux_sym_float_literal_token3] = ACTIONS(10140),
    [aux_sym_float_literal_token4] = ACTIONS(10140),
    [sym_character_literal] = ACTIONS(10140),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10140),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10140),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10140),
    [aux_sym__assignment_operator_token1] = ACTIONS(10140),
    [sym__pair_operator] = ACTIONS(10140),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10140),
    [sym__lazy_and_operator] = ACTIONS(10140),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10140),
    [sym__pipe_left_operator] = ACTIONS(10140),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10140),
    [sym__type_order_operator] = ACTIONS(10140),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5772] = {
    [sym_block_comment] = STATE(5772),
    [sym_line_comment] = STATE(5772),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10144),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10144),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10144),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10144),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10144),
    [anon_sym_COLON_EQ] = ACTIONS(10144),
    [anon_sym_DOT_EQ] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10144),
    [anon_sym_QMARK] = ACTIONS(10144),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10144),
    [aux_sym_integer_literal_token2] = ACTIONS(10144),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10144),
    [aux_sym_float_literal_token3] = ACTIONS(10144),
    [aux_sym_float_literal_token4] = ACTIONS(10144),
    [sym_character_literal] = ACTIONS(10144),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10144),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10144),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10144),
    [aux_sym__assignment_operator_token1] = ACTIONS(10144),
    [sym__pair_operator] = ACTIONS(10144),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10144),
    [sym__lazy_and_operator] = ACTIONS(10144),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10144),
    [sym__pipe_left_operator] = ACTIONS(10144),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10144),
    [sym__type_order_operator] = ACTIONS(10144),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5773] = {
    [sym_block_comment] = STATE(5773),
    [sym_line_comment] = STATE(5773),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_catch] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_DASH_GT] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5774] = {
    [sym_block_comment] = STATE(5774),
    [sym_line_comment] = STATE(5774),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5775] = {
    [sym_block_comment] = STATE(5775),
    [sym_line_comment] = STATE(5775),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5776] = {
    [sym__assignment_operator] = STATE(3188),
    [sym_block_comment] = STATE(5776),
    [sym_line_comment] = STATE(5776),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_SQUOTE] = ACTIONS(10338),
    [anon_sym_DOT] = ACTIONS(10340),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_COLON_EQ] = ACTIONS(1821),
    [anon_sym_DOT_EQ] = ACTIONS(9768),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [anon_sym_DOLLAR_EQ] = ACTIONS(1821),
    [aux_sym__assignment_operator_token1] = ACTIONS(1821),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
    [sym__immediate_bracket] = ACTIONS(10344),
    [sym__immediate_brace] = ACTIONS(10346),
  },
  [5777] = {
    [sym_block_comment] = STATE(5777),
    [sym_line_comment] = STATE(5777),
    [ts_builtin_sym_end] = ACTIONS(10088),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_RBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_DASH_GT] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5778] = {
    [sym_block_comment] = STATE(5778),
    [sym_line_comment] = STATE(5778),
    [ts_builtin_sym_end] = ACTIONS(9728),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_RBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5779] = {
    [sym_block_comment] = STATE(5779),
    [sym_line_comment] = STATE(5779),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_DASH_GT] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5780] = {
    [sym_block_comment] = STATE(5780),
    [sym_line_comment] = STATE(5780),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_catch] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_DASH_GT] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5781] = {
    [sym_block_comment] = STATE(5781),
    [sym_line_comment] = STATE(5781),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_catch] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_DASH_GT] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5782] = {
    [sym_block_comment] = STATE(5782),
    [sym_line_comment] = STATE(5782),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5783] = {
    [sym_block_comment] = STATE(5783),
    [sym_line_comment] = STATE(5783),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_elseif] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5784] = {
    [sym_block_comment] = STATE(5784),
    [sym_line_comment] = STATE(5784),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5785] = {
    [sym_block_comment] = STATE(5785),
    [sym_line_comment] = STATE(5785),
    [ts_builtin_sym_end] = ACTIONS(9740),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5786] = {
    [sym_block_comment] = STATE(5786),
    [sym_line_comment] = STATE(5786),
    [ts_builtin_sym_end] = ACTIONS(9746),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_RBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5787] = {
    [sym_block_comment] = STATE(5787),
    [sym_line_comment] = STATE(5787),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_end] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_else] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_finally] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10440),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10440),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10440),
    [anon_sym_SQUOTE] = ACTIONS(10541),
    [anon_sym_DOT] = ACTIONS(10543),
    [anon_sym_DOLLAR] = ACTIONS(10440),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10440),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10440),
    [anon_sym_QMARK] = ACTIONS(10440),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10440),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10440),
    [aux_sym_integer_literal_token2] = ACTIONS(10440),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10440),
    [aux_sym_float_literal_token3] = ACTIONS(10440),
    [aux_sym_float_literal_token4] = ACTIONS(10440),
    [sym_character_literal] = ACTIONS(10440),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10440),
    [sym__pair_operator] = ACTIONS(10440),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10440),
    [sym__lazy_and_operator] = ACTIONS(10440),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10440),
    [sym__pipe_left_operator] = ACTIONS(10440),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10440),
    [sym__bitshift_operator] = ACTIONS(10440),
    [sym__power_operator] = ACTIONS(10440),
    [sym__tilde_operator] = ACTIONS(10440),
    [sym__type_order_operator] = ACTIONS(10440),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym__terminator_token1] = ACTIONS(10525),
    [aux_sym__terminator_token2] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10545),
    [sym__immediate_bracket] = ACTIONS(10547),
    [sym__immediate_brace] = ACTIONS(10549),
  },
  [5788] = {
    [sym_block_comment] = STATE(5788),
    [sym_line_comment] = STATE(5788),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_catch] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_DASH_GT] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5789] = {
    [sym_block_comment] = STATE(5789),
    [sym_line_comment] = STATE(5789),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_catch] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_DASH_GT] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5790] = {
    [sym_block_comment] = STATE(5790),
    [sym_line_comment] = STATE(5790),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_DASH_GT] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5791] = {
    [sym_block_comment] = STATE(5791),
    [sym_line_comment] = STATE(5791),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_catch] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_DASH_GT] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5792] = {
    [sym_block_comment] = STATE(5792),
    [sym_line_comment] = STATE(5792),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5793] = {
    [sym_block_comment] = STATE(5793),
    [sym_line_comment] = STATE(5793),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_catch] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_DASH_GT] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5794] = {
    [sym_block_comment] = STATE(5794),
    [sym_line_comment] = STATE(5794),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_catch] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_DASH_GT] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5795] = {
    [sym_block_comment] = STATE(5795),
    [sym_line_comment] = STATE(5795),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_catch] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_DASH_GT] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5796] = {
    [sym_block_comment] = STATE(5796),
    [sym_line_comment] = STATE(5796),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [5797] = {
    [sym_block_comment] = STATE(5797),
    [sym_line_comment] = STATE(5797),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5798] = {
    [sym_block_comment] = STATE(5798),
    [sym_line_comment] = STATE(5798),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_DASH_GT] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5799] = {
    [sym_block_comment] = STATE(5799),
    [sym_line_comment] = STATE(5799),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10088),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10088),
    [anon_sym_RPAREN] = ACTIONS(10088),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10088),
    [anon_sym_RBRACK] = ACTIONS(10088),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_SEMI] = ACTIONS(10088),
    [anon_sym_LBRACE] = ACTIONS(10088),
    [anon_sym_RBRACE] = ACTIONS(10088),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10088),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10088),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10088),
    [anon_sym_QMARK] = ACTIONS(10088),
    [anon_sym_DASH_GT] = ACTIONS(10088),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10088),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10088),
    [aux_sym_integer_literal_token2] = ACTIONS(10088),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10088),
    [aux_sym_float_literal_token3] = ACTIONS(10088),
    [aux_sym_float_literal_token4] = ACTIONS(10088),
    [sym_character_literal] = ACTIONS(10088),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10088),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10088),
    [sym__pair_operator] = ACTIONS(10088),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10088),
    [sym__lazy_and_operator] = ACTIONS(10088),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10088),
    [sym__pipe_left_operator] = ACTIONS(10088),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10088),
    [sym__bitshift_operator] = ACTIONS(10088),
    [sym__power_operator] = ACTIONS(10088),
    [sym__tilde_operator] = ACTIONS(10088),
    [sym__type_order_operator] = ACTIONS(10088),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5800] = {
    [sym_block_comment] = STATE(5800),
    [sym_line_comment] = STATE(5800),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_finally] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [5801] = {
    [sym_block_comment] = STATE(5801),
    [sym_line_comment] = STATE(5801),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10537),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_end] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_else] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_finally] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10537),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10537),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10537),
    [anon_sym_SQUOTE] = ACTIONS(10541),
    [anon_sym_DOT] = ACTIONS(10543),
    [anon_sym_DOLLAR] = ACTIONS(10537),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10537),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10537),
    [anon_sym_QMARK] = ACTIONS(10537),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10537),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10537),
    [aux_sym_integer_literal_token2] = ACTIONS(10537),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10537),
    [aux_sym_float_literal_token3] = ACTIONS(10537),
    [aux_sym_float_literal_token4] = ACTIONS(10537),
    [sym_character_literal] = ACTIONS(10537),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10537),
    [sym__pair_operator] = ACTIONS(10537),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10537),
    [sym__lazy_and_operator] = ACTIONS(10537),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10537),
    [sym__pipe_left_operator] = ACTIONS(10537),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10537),
    [sym__bitshift_operator] = ACTIONS(10537),
    [sym__power_operator] = ACTIONS(10537),
    [sym__tilde_operator] = ACTIONS(10537),
    [sym__type_order_operator] = ACTIONS(10537),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym__terminator_token1] = ACTIONS(10539),
    [aux_sym__terminator_token2] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10545),
    [sym__immediate_bracket] = ACTIONS(10547),
    [sym__immediate_brace] = ACTIONS(10549),
  },
  [5802] = {
    [sym_block_comment] = STATE(5802),
    [sym_line_comment] = STATE(5802),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_finally] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [5803] = {
    [sym_block_comment] = STATE(5803),
    [sym_line_comment] = STATE(5803),
    [ts_builtin_sym_end] = ACTIONS(9984),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_RBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_DASH_GT] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5804] = {
    [sym_block_comment] = STATE(5804),
    [sym_line_comment] = STATE(5804),
    [ts_builtin_sym_end] = ACTIONS(9988),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_RBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_DASH_GT] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5805] = {
    [sym_block_comment] = STATE(5805),
    [sym_line_comment] = STATE(5805),
    [ts_builtin_sym_end] = ACTIONS(10002),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_RBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_DASH_GT] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5806] = {
    [sym_block_comment] = STATE(5806),
    [sym_line_comment] = STATE(5806),
    [ts_builtin_sym_end] = ACTIONS(10006),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_RBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_DASH_GT] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5807] = {
    [sym_block_comment] = STATE(5807),
    [sym_line_comment] = STATE(5807),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_else] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5808] = {
    [sym_block_comment] = STATE(5808),
    [sym_line_comment] = STATE(5808),
    [ts_builtin_sym_end] = ACTIONS(10012),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_RBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_DASH_GT] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5809] = {
    [sym_block_comment] = STATE(5809),
    [sym_line_comment] = STATE(5809),
    [ts_builtin_sym_end] = ACTIONS(10016),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_RBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_DASH_GT] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5810] = {
    [sym_block_comment] = STATE(5810),
    [sym_line_comment] = STATE(5810),
    [ts_builtin_sym_end] = ACTIONS(10020),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_RBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_DASH_GT] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5811] = {
    [sym_block_comment] = STATE(5811),
    [sym_line_comment] = STATE(5811),
    [ts_builtin_sym_end] = ACTIONS(9918),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_RBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_DASH_GT] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5812] = {
    [sym_block_comment] = STATE(5812),
    [sym_line_comment] = STATE(5812),
    [ts_builtin_sym_end] = ACTIONS(9922),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_RBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_DASH_GT] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5813] = {
    [sym_block_comment] = STATE(5813),
    [sym_line_comment] = STATE(5813),
    [ts_builtin_sym_end] = ACTIONS(9992),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_RBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_DASH_GT] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5814] = {
    [sym_block_comment] = STATE(5814),
    [sym_line_comment] = STATE(5814),
    [ts_builtin_sym_end] = ACTIONS(9996),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_RBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_DASH_GT] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5815] = {
    [sym_block_comment] = STATE(5815),
    [sym_line_comment] = STATE(5815),
    [ts_builtin_sym_end] = ACTIONS(9754),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_RBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5816] = {
    [sym_block_comment] = STATE(5816),
    [sym_line_comment] = STATE(5816),
    [ts_builtin_sym_end] = ACTIONS(9762),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_RBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5817] = {
    [sym_block_comment] = STATE(5817),
    [sym_line_comment] = STATE(5817),
    [ts_builtin_sym_end] = ACTIONS(10030),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_RBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_DASH_GT] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5818] = {
    [sym_block_comment] = STATE(5818),
    [sym_line_comment] = STATE(5818),
    [ts_builtin_sym_end] = ACTIONS(10034),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_RBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_DASH_GT] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5819] = {
    [sym_block_comment] = STATE(5819),
    [sym_line_comment] = STATE(5819),
    [ts_builtin_sym_end] = ACTIONS(10038),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_RBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_DASH_GT] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5820] = {
    [sym_block_comment] = STATE(5820),
    [sym_line_comment] = STATE(5820),
    [ts_builtin_sym_end] = ACTIONS(10042),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_RBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_DASH_GT] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5821] = {
    [sym_block_comment] = STATE(5821),
    [sym_line_comment] = STATE(5821),
    [ts_builtin_sym_end] = ACTIONS(9792),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_RBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5822] = {
    [sym_block_comment] = STATE(5822),
    [sym_line_comment] = STATE(5822),
    [ts_builtin_sym_end] = ACTIONS(10046),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_RBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_DASH_GT] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5823] = {
    [sym_block_comment] = STATE(5823),
    [sym_line_comment] = STATE(5823),
    [ts_builtin_sym_end] = ACTIONS(10050),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_RBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_DASH_GT] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5824] = {
    [sym_block_comment] = STATE(5824),
    [sym_line_comment] = STATE(5824),
    [ts_builtin_sym_end] = ACTIONS(10054),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_RBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_DASH_GT] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5825] = {
    [sym_block_comment] = STATE(5825),
    [sym_line_comment] = STATE(5825),
    [ts_builtin_sym_end] = ACTIONS(10058),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_RBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_DASH_GT] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5826] = {
    [sym_block_comment] = STATE(5826),
    [sym_line_comment] = STATE(5826),
    [ts_builtin_sym_end] = ACTIONS(9900),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_RBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DASH_GT] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5827] = {
    [sym_block_comment] = STATE(5827),
    [sym_line_comment] = STATE(5827),
    [ts_builtin_sym_end] = ACTIONS(10062),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_RBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_DASH_GT] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5828] = {
    [sym_block_comment] = STATE(5828),
    [sym_line_comment] = STATE(5828),
    [ts_builtin_sym_end] = ACTIONS(10066),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_RBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_DASH_GT] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5829] = {
    [sym_block_comment] = STATE(5829),
    [sym_line_comment] = STATE(5829),
    [ts_builtin_sym_end] = ACTIONS(10070),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_RBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_DASH_GT] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5830] = {
    [sym_block_comment] = STATE(5830),
    [sym_line_comment] = STATE(5830),
    [ts_builtin_sym_end] = ACTIONS(10074),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_RBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_DASH_GT] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5831] = {
    [sym_block_comment] = STATE(5831),
    [sym_line_comment] = STATE(5831),
    [ts_builtin_sym_end] = ACTIONS(10078),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_RBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_DASH_GT] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5832] = {
    [sym_block_comment] = STATE(5832),
    [sym_line_comment] = STATE(5832),
    [ts_builtin_sym_end] = ACTIONS(10082),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_RBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_DASH_GT] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5833] = {
    [sym_block_comment] = STATE(5833),
    [sym_line_comment] = STATE(5833),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_DASH_GT] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5834] = {
    [sym_block_comment] = STATE(5834),
    [sym_line_comment] = STATE(5834),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5835] = {
    [sym_block_comment] = STATE(5835),
    [sym_line_comment] = STATE(5835),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_finally] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [5836] = {
    [sym_block_comment] = STATE(5836),
    [sym_line_comment] = STATE(5836),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_RPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_RBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_SEMI] = ACTIONS(9728),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_DASH_GT] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5837] = {
    [sym_block_comment] = STATE(5837),
    [sym_line_comment] = STATE(5837),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_DASH_GT] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5838] = {
    [sym_block_comment] = STATE(5838),
    [sym_line_comment] = STATE(5838),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_DASH_GT] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5839] = {
    [sym_block_comment] = STATE(5839),
    [sym_line_comment] = STATE(5839),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5840] = {
    [sym_block_comment] = STATE(5840),
    [sym_line_comment] = STATE(5840),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5841] = {
    [sym_block_comment] = STATE(5841),
    [sym_line_comment] = STATE(5841),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_finally] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [5842] = {
    [sym_block_comment] = STATE(5842),
    [sym_line_comment] = STATE(5842),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_finally] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [5843] = {
    [sym_block_comment] = STATE(5843),
    [sym_line_comment] = STATE(5843),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_finally] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [5844] = {
    [sym_block_comment] = STATE(5844),
    [sym_line_comment] = STATE(5844),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_RPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_RBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9740),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_RBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_DASH_GT] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5845] = {
    [sym_block_comment] = STATE(5845),
    [sym_line_comment] = STATE(5845),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_RPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_RBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_SEMI] = ACTIONS(9746),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_RBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_DASH_GT] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5846] = {
    [sym_block_comment] = STATE(5846),
    [sym_line_comment] = STATE(5846),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_DASH_GT] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5847] = {
    [sym_block_comment] = STATE(5847),
    [sym_line_comment] = STATE(5847),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_DASH_GT] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5848] = {
    [sym_block_comment] = STATE(5848),
    [sym_line_comment] = STATE(5848),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_finally] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [5849] = {
    [sym_block_comment] = STATE(5849),
    [sym_line_comment] = STATE(5849),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_finally] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [5850] = {
    [sym_block_comment] = STATE(5850),
    [sym_line_comment] = STATE(5850),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_finally] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5851] = {
    [sym_block_comment] = STATE(5851),
    [sym_line_comment] = STATE(5851),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_DASH_GT] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5852] = {
    [sym_block_comment] = STATE(5852),
    [sym_line_comment] = STATE(5852),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5853] = {
    [sym_block_comment] = STATE(5853),
    [sym_line_comment] = STATE(5853),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_finally] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5854] = {
    [sym_block_comment] = STATE(5854),
    [sym_line_comment] = STATE(5854),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_finally] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5855] = {
    [sym_block_comment] = STATE(5855),
    [sym_line_comment] = STATE(5855),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_DASH_GT] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [5856] = {
    [sym_block_comment] = STATE(5856),
    [sym_line_comment] = STATE(5856),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_DASH_GT] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [5857] = {
    [sym_block_comment] = STATE(5857),
    [sym_line_comment] = STATE(5857),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_finally] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5858] = {
    [sym_block_comment] = STATE(5858),
    [sym_line_comment] = STATE(5858),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_DASH_GT] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [5859] = {
    [sym_block_comment] = STATE(5859),
    [sym_line_comment] = STATE(5859),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_COLON_EQ] = ACTIONS(9664),
    [anon_sym_DOT_EQ] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9664),
    [aux_sym__assignment_operator_token1] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5860] = {
    [sym_block_comment] = STATE(5860),
    [sym_line_comment] = STATE(5860),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_elseif] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5861] = {
    [sym_block_comment] = STATE(5861),
    [sym_line_comment] = STATE(5861),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_COLON_EQ] = ACTIONS(9928),
    [anon_sym_DOT_EQ] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [anon_sym_DOLLAR_EQ] = ACTIONS(9928),
    [aux_sym__assignment_operator_token1] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5862] = {
    [sym_identifier] = STATE(6068),
    [sym_block_comment] = STATE(5862),
    [sym_line_comment] = STATE(5862),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_RPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_RBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_SEMI] = ACTIONS(9782),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_RBRACE] = ACTIONS(9782),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5863] = {
    [sym_identifier] = STATE(6069),
    [sym_block_comment] = STATE(5863),
    [sym_line_comment] = STATE(5863),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_RPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_RBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_SEMI] = ACTIONS(9786),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5864] = {
    [sym_block_comment] = STATE(5864),
    [sym_line_comment] = STATE(5864),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_COLON_EQ] = ACTIONS(10118),
    [anon_sym_DOT_EQ] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10118),
    [aux_sym__assignment_operator_token1] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5865] = {
    [sym_identifier] = STATE(6072),
    [sym_block_comment] = STATE(5865),
    [sym_line_comment] = STATE(5865),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_RPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_RBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_SEMI] = ACTIONS(9798),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_RBRACE] = ACTIONS(9798),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5866] = {
    [sym_identifier] = STATE(6073),
    [sym_block_comment] = STATE(5866),
    [sym_line_comment] = STATE(5866),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_RPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_RBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_SEMI] = ACTIONS(9802),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_RBRACE] = ACTIONS(9802),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5867] = {
    [sym_block_comment] = STATE(5867),
    [sym_line_comment] = STATE(5867),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_RPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_RBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_SEMI] = ACTIONS(9984),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_RBRACE] = ACTIONS(9984),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_DASH_GT] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5868] = {
    [sym_block_comment] = STATE(5868),
    [sym_line_comment] = STATE(5868),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_RPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_RBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_SEMI] = ACTIONS(9988),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_RBRACE] = ACTIONS(9988),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_DASH_GT] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5869] = {
    [sym_block_comment] = STATE(5869),
    [sym_line_comment] = STATE(5869),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_RPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_RBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_SEMI] = ACTIONS(10002),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_RBRACE] = ACTIONS(10002),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_DASH_GT] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5870] = {
    [sym_block_comment] = STATE(5870),
    [sym_line_comment] = STATE(5870),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_RPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_RBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_SEMI] = ACTIONS(10006),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_RBRACE] = ACTIONS(10006),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DASH_GT] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5871] = {
    [sym_block_comment] = STATE(5871),
    [sym_line_comment] = STATE(5871),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_COLON_EQ] = ACTIONS(10154),
    [anon_sym_DOT_EQ] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10154),
    [aux_sym__assignment_operator_token1] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [5872] = {
    [sym_block_comment] = STATE(5872),
    [sym_line_comment] = STATE(5872),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_catch] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_DASH_GT] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5873] = {
    [sym_block_comment] = STATE(5873),
    [sym_line_comment] = STATE(5873),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_RPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_RBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_SEMI] = ACTIONS(10012),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_RBRACE] = ACTIONS(10012),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_DASH_GT] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5874] = {
    [sym_block_comment] = STATE(5874),
    [sym_line_comment] = STATE(5874),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_RPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_RBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_SEMI] = ACTIONS(10016),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_RBRACE] = ACTIONS(10016),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_DASH_GT] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5875] = {
    [sym_block_comment] = STATE(5875),
    [sym_line_comment] = STATE(5875),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10322),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_catch] = ACTIONS(10322),
    [anon_sym_finally] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10551),
    [anon_sym_DOT] = ACTIONS(10553),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10555),
    [sym__immediate_bracket] = ACTIONS(10557),
    [sym__immediate_brace] = ACTIONS(10559),
  },
  [5876] = {
    [sym_block_comment] = STATE(5876),
    [sym_line_comment] = STATE(5876),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_RPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_RBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_SEMI] = ACTIONS(10020),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_RBRACE] = ACTIONS(10020),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_DASH_GT] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5877] = {
    [sym_block_comment] = STATE(5877),
    [sym_line_comment] = STATE(5877),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_RPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_RBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_SEMI] = ACTIONS(9918),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_DASH_GT] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5878] = {
    [sym_block_comment] = STATE(5878),
    [sym_line_comment] = STATE(5878),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_RPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_RBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_SEMI] = ACTIONS(9922),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_RBRACE] = ACTIONS(9922),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_DASH_GT] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5879] = {
    [sym_block_comment] = STATE(5879),
    [sym_line_comment] = STATE(5879),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [5880] = {
    [sym_block_comment] = STATE(5880),
    [sym_line_comment] = STATE(5880),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_RPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_RBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_SEMI] = ACTIONS(9992),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_RBRACE] = ACTIONS(9992),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_DASH_GT] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5881] = {
    [sym_block_comment] = STATE(5881),
    [sym_line_comment] = STATE(5881),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_RPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_RBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_SEMI] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_RBRACE] = ACTIONS(9996),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_DASH_GT] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5882] = {
    [sym_block_comment] = STATE(5882),
    [sym_line_comment] = STATE(5882),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_RPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_RBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_SEMI] = ACTIONS(9754),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_RBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_DASH_GT] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5883] = {
    [sym_block_comment] = STATE(5883),
    [sym_line_comment] = STATE(5883),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_RBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9762),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_DASH_GT] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5884] = {
    [sym_block_comment] = STATE(5884),
    [sym_line_comment] = STATE(5884),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_RPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_RBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_SEMI] = ACTIONS(10030),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_RBRACE] = ACTIONS(10030),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_DASH_GT] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5885] = {
    [sym_block_comment] = STATE(5885),
    [sym_line_comment] = STATE(5885),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_RPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_RBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_SEMI] = ACTIONS(10034),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_RBRACE] = ACTIONS(10034),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_DASH_GT] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5886] = {
    [sym_block_comment] = STATE(5886),
    [sym_line_comment] = STATE(5886),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_RPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_RBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_SEMI] = ACTIONS(10038),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_RBRACE] = ACTIONS(10038),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_DASH_GT] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5887] = {
    [sym_block_comment] = STATE(5887),
    [sym_line_comment] = STATE(5887),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_RPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_RBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_SEMI] = ACTIONS(10042),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_DASH_GT] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5888] = {
    [sym_block_comment] = STATE(5888),
    [sym_line_comment] = STATE(5888),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [5889] = {
    [sym_block_comment] = STATE(5889),
    [sym_line_comment] = STATE(5889),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [5890] = {
    [sym_identifier] = STATE(6112),
    [sym_block_comment] = STATE(5890),
    [sym_line_comment] = STATE(5890),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_DASH_GT] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [5891] = {
    [sym_identifier] = STATE(6113),
    [sym_block_comment] = STATE(5891),
    [sym_line_comment] = STATE(5891),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_DASH_GT] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [5892] = {
    [sym_block_comment] = STATE(5892),
    [sym_line_comment] = STATE(5892),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_RPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_RBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_SEMI] = ACTIONS(9792),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_DASH_GT] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5893] = {
    [sym_block_comment] = STATE(5893),
    [sym_line_comment] = STATE(5893),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_RPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_RBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_SEMI] = ACTIONS(10046),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_RBRACE] = ACTIONS(10046),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_DASH_GT] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5894] = {
    [sym_block_comment] = STATE(5894),
    [sym_line_comment] = STATE(5894),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_RPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_RBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_SEMI] = ACTIONS(10050),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_RBRACE] = ACTIONS(10050),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_DASH_GT] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5895] = {
    [sym_block_comment] = STATE(5895),
    [sym_line_comment] = STATE(5895),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_RBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_SEMI] = ACTIONS(10054),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_RBRACE] = ACTIONS(10054),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_DASH_GT] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5896] = {
    [sym_block_comment] = STATE(5896),
    [sym_line_comment] = STATE(5896),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_RPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_RBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_SEMI] = ACTIONS(10058),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_RBRACE] = ACTIONS(10058),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_DASH_GT] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5897] = {
    [sym_block_comment] = STATE(5897),
    [sym_line_comment] = STATE(5897),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_RPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_RBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_SEMI] = ACTIONS(9900),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_RBRACE] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_DASH_GT] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5898] = {
    [sym_block_comment] = STATE(5898),
    [sym_line_comment] = STATE(5898),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_RPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_RBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_SEMI] = ACTIONS(10062),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_RBRACE] = ACTIONS(10062),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_DASH_GT] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5899] = {
    [sym_identifier] = STATE(6118),
    [sym_block_comment] = STATE(5899),
    [sym_line_comment] = STATE(5899),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_DASH_GT] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [5900] = {
    [sym_block_comment] = STATE(5900),
    [sym_line_comment] = STATE(5900),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_RPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_RBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_SEMI] = ACTIONS(10066),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_RBRACE] = ACTIONS(10066),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_DASH_GT] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5901] = {
    [sym_identifier] = STATE(6119),
    [sym_block_comment] = STATE(5901),
    [sym_line_comment] = STATE(5901),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_DASH_GT] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [5902] = {
    [sym_block_comment] = STATE(5902),
    [sym_line_comment] = STATE(5902),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_RPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_RBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_SEMI] = ACTIONS(10070),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_DASH_GT] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5903] = {
    [sym_block_comment] = STATE(5903),
    [sym_line_comment] = STATE(5903),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_RPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_RBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_SEMI] = ACTIONS(10074),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_RBRACE] = ACTIONS(10074),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_DASH_GT] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5904] = {
    [sym_block_comment] = STATE(5904),
    [sym_line_comment] = STATE(5904),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_RPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_RBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_SEMI] = ACTIONS(10078),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_RBRACE] = ACTIONS(10078),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_DASH_GT] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5905] = {
    [sym_block_comment] = STATE(5905),
    [sym_line_comment] = STATE(5905),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_RPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_RBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_SEMI] = ACTIONS(10082),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_RBRACE] = ACTIONS(10082),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_DASH_GT] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5906] = {
    [sym_block_comment] = STATE(5906),
    [sym_line_comment] = STATE(5906),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10561),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5907] = {
    [sym_block_comment] = STATE(5907),
    [sym_line_comment] = STATE(5907),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5908] = {
    [sym_block_comment] = STATE(5908),
    [sym_line_comment] = STATE(5908),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5909] = {
    [sym_block_comment] = STATE(5909),
    [sym_line_comment] = STATE(5909),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5910] = {
    [sym_block_comment] = STATE(5910),
    [sym_line_comment] = STATE(5910),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5911] = {
    [sym_block_comment] = STATE(5911),
    [sym_line_comment] = STATE(5911),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5912] = {
    [sym_block_comment] = STATE(5912),
    [sym_line_comment] = STATE(5912),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10088),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10088),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10088),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10088),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10088),
    [anon_sym_COLON_EQ] = ACTIONS(10088),
    [anon_sym_DOT_EQ] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10088),
    [anon_sym_QMARK] = ACTIONS(10088),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10088),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10088),
    [aux_sym_integer_literal_token2] = ACTIONS(10088),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10088),
    [aux_sym_float_literal_token3] = ACTIONS(10088),
    [aux_sym_float_literal_token4] = ACTIONS(10088),
    [sym_character_literal] = ACTIONS(10088),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10088),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10088),
    [anon_sym_DOLLAR_EQ] = ACTIONS(10088),
    [aux_sym__assignment_operator_token1] = ACTIONS(10088),
    [sym__pair_operator] = ACTIONS(10088),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10088),
    [sym__lazy_and_operator] = ACTIONS(10088),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10088),
    [sym__pipe_left_operator] = ACTIONS(10088),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10088),
    [sym__type_order_operator] = ACTIONS(10088),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5913] = {
    [sym_block_comment] = STATE(5913),
    [sym_line_comment] = STATE(5913),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5914] = {
    [sym_block_comment] = STATE(5914),
    [sym_line_comment] = STATE(5914),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5915] = {
    [sym_block_comment] = STATE(5915),
    [sym_line_comment] = STATE(5915),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5916] = {
    [sym_block_comment] = STATE(5916),
    [sym_line_comment] = STATE(5916),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5917] = {
    [sym_block_comment] = STATE(5917),
    [sym_line_comment] = STATE(5917),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5918] = {
    [sym_block_comment] = STATE(5918),
    [sym_line_comment] = STATE(5918),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5919] = {
    [sym_block_comment] = STATE(5919),
    [sym_line_comment] = STATE(5919),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5920] = {
    [sym_block_comment] = STATE(5920),
    [sym_line_comment] = STATE(5920),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5921] = {
    [sym_block_comment] = STATE(5921),
    [sym_line_comment] = STATE(5921),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5922] = {
    [sym_block_comment] = STATE(5922),
    [sym_line_comment] = STATE(5922),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5923] = {
    [sym_block_comment] = STATE(5923),
    [sym_line_comment] = STATE(5923),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5924] = {
    [sym_block_comment] = STATE(5924),
    [sym_line_comment] = STATE(5924),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5925] = {
    [sym_block_comment] = STATE(5925),
    [sym_line_comment] = STATE(5925),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5926] = {
    [sym_block_comment] = STATE(5926),
    [sym_line_comment] = STATE(5926),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5927] = {
    [sym_block_comment] = STATE(5927),
    [sym_line_comment] = STATE(5927),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5928] = {
    [sym_block_comment] = STATE(5928),
    [sym_line_comment] = STATE(5928),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5929] = {
    [sym_block_comment] = STATE(5929),
    [sym_line_comment] = STATE(5929),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5930] = {
    [sym_block_comment] = STATE(5930),
    [sym_line_comment] = STATE(5930),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5931] = {
    [sym_block_comment] = STATE(5931),
    [sym_line_comment] = STATE(5931),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5932] = {
    [sym_block_comment] = STATE(5932),
    [sym_line_comment] = STATE(5932),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5933] = {
    [sym_block_comment] = STATE(5933),
    [sym_line_comment] = STATE(5933),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5934] = {
    [sym_block_comment] = STATE(5934),
    [sym_line_comment] = STATE(5934),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5935] = {
    [sym_block_comment] = STATE(5935),
    [sym_line_comment] = STATE(5935),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [5936] = {
    [sym_block_comment] = STATE(5936),
    [sym_line_comment] = STATE(5936),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [5937] = {
    [sym_block_comment] = STATE(5937),
    [sym_line_comment] = STATE(5937),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [5938] = {
    [sym_block_comment] = STATE(5938),
    [sym_line_comment] = STATE(5938),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_DASH_GT] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [5939] = {
    [sym_block_comment] = STATE(5939),
    [sym_line_comment] = STATE(5939),
    [ts_builtin_sym_end] = ACTIONS(9960),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_RBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_DASH_GT] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [5940] = {
    [sym_block_comment] = STATE(5940),
    [sym_line_comment] = STATE(5940),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5941] = {
    [sym_block_comment] = STATE(5941),
    [sym_line_comment] = STATE(5941),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_catch] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_DASH_GT] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5942] = {
    [sym_block_comment] = STATE(5942),
    [sym_line_comment] = STATE(5942),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5943] = {
    [sym_block_comment] = STATE(5943),
    [sym_line_comment] = STATE(5943),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_DASH_GT] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [5944] = {
    [sym_block_comment] = STATE(5944),
    [sym_line_comment] = STATE(5944),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9824),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9824),
    [anon_sym_QMARK] = ACTIONS(9824),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9824),
    [sym__lazy_and_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [5945] = {
    [sym_block_comment] = STATE(5945),
    [sym_line_comment] = STATE(5945),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9828),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(9828),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9828),
    [sym__lazy_and_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [5946] = {
    [sym_block_comment] = STATE(5946),
    [sym_line_comment] = STATE(5946),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9832),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9832),
    [anon_sym_QMARK] = ACTIONS(9832),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9832),
    [sym__lazy_and_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [5947] = {
    [sym_block_comment] = STATE(5947),
    [sym_line_comment] = STATE(5947),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9836),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9836),
    [anon_sym_QMARK] = ACTIONS(9836),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9836),
    [sym__lazy_and_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [5948] = {
    [sym_block_comment] = STATE(5948),
    [sym_line_comment] = STATE(5948),
    [ts_builtin_sym_end] = ACTIONS(10525),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10440),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10440),
    [anon_sym_RBRACK] = ACTIONS(10440),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10440),
    [anon_sym_SQUOTE] = ACTIONS(10563),
    [anon_sym_DOT] = ACTIONS(10565),
    [anon_sym_DOLLAR] = ACTIONS(10440),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10440),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10440),
    [anon_sym_QMARK] = ACTIONS(10440),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10440),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10440),
    [aux_sym_integer_literal_token2] = ACTIONS(10440),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10440),
    [aux_sym_float_literal_token3] = ACTIONS(10440),
    [aux_sym_float_literal_token4] = ACTIONS(10440),
    [sym_character_literal] = ACTIONS(10440),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10440),
    [sym__pair_operator] = ACTIONS(10440),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10440),
    [sym__lazy_and_operator] = ACTIONS(10440),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10440),
    [sym__pipe_left_operator] = ACTIONS(10440),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10440),
    [sym__bitshift_operator] = ACTIONS(10440),
    [sym__power_operator] = ACTIONS(10440),
    [sym__tilde_operator] = ACTIONS(10440),
    [sym__type_order_operator] = ACTIONS(10440),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym__terminator_token1] = ACTIONS(10525),
    [aux_sym__terminator_token2] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10567),
    [sym__immediate_bracket] = ACTIONS(10569),
    [sym__immediate_brace] = ACTIONS(10571),
  },
  [5949] = {
    [sym_block_comment] = STATE(5949),
    [sym_line_comment] = STATE(5949),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10573),
    [sym__immediate_command_start] = ACTIONS(10575),
  },
  [5950] = {
    [sym_block_comment] = STATE(5950),
    [sym_line_comment] = STATE(5950),
    [ts_builtin_sym_end] = ACTIONS(10539),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10537),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10537),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10537),
    [anon_sym_RBRACK] = ACTIONS(10537),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10537),
    [anon_sym_SQUOTE] = ACTIONS(10563),
    [anon_sym_DOT] = ACTIONS(10565),
    [anon_sym_DOLLAR] = ACTIONS(10537),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10537),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10537),
    [anon_sym_QMARK] = ACTIONS(10537),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10537),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10537),
    [aux_sym_integer_literal_token2] = ACTIONS(10537),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10537),
    [aux_sym_float_literal_token3] = ACTIONS(10537),
    [aux_sym_float_literal_token4] = ACTIONS(10537),
    [sym_character_literal] = ACTIONS(10537),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10537),
    [sym__pair_operator] = ACTIONS(10537),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10537),
    [sym__lazy_and_operator] = ACTIONS(10537),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10537),
    [sym__pipe_left_operator] = ACTIONS(10537),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10537),
    [sym__bitshift_operator] = ACTIONS(10537),
    [sym__power_operator] = ACTIONS(10537),
    [sym__tilde_operator] = ACTIONS(10537),
    [sym__type_order_operator] = ACTIONS(10537),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym__terminator_token1] = ACTIONS(10539),
    [aux_sym__terminator_token2] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10567),
    [sym__immediate_bracket] = ACTIONS(10569),
    [sym__immediate_brace] = ACTIONS(10571),
  },
  [5951] = {
    [sym_block_comment] = STATE(5951),
    [sym_line_comment] = STATE(5951),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_RPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_RBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_SEMI] = ACTIONS(9914),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_RBRACE] = ACTIONS(9914),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5952] = {
    [sym_block_comment] = STATE(5952),
    [sym_line_comment] = STATE(5952),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5953] = {
    [sym_block_comment] = STATE(5953),
    [sym_line_comment] = STATE(5953),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_else] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [5954] = {
    [sym_block_comment] = STATE(5954),
    [sym_line_comment] = STATE(5954),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [5955] = {
    [sym_block_comment] = STATE(5955),
    [sym_line_comment] = STATE(5955),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5956] = {
    [sym_block_comment] = STATE(5956),
    [sym_line_comment] = STATE(5956),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [5957] = {
    [sym_block_comment] = STATE(5957),
    [sym_line_comment] = STATE(5957),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9980),
    [anon_sym_RPAREN] = ACTIONS(9980),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9980),
    [anon_sym_RBRACK] = ACTIONS(9980),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_SEMI] = ACTIONS(9980),
    [anon_sym_LBRACE] = ACTIONS(9980),
    [anon_sym_RBRACE] = ACTIONS(9980),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9980),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9980),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9980),
    [anon_sym_QMARK] = ACTIONS(9980),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9980),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9980),
    [aux_sym_integer_literal_token2] = ACTIONS(9980),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9980),
    [aux_sym_float_literal_token3] = ACTIONS(9980),
    [aux_sym_float_literal_token4] = ACTIONS(9980),
    [sym_character_literal] = ACTIONS(9980),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9980),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9980),
    [sym__pair_operator] = ACTIONS(9980),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9980),
    [sym__lazy_and_operator] = ACTIONS(9980),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9980),
    [sym__pipe_left_operator] = ACTIONS(9980),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9980),
    [sym__bitshift_operator] = ACTIONS(9980),
    [sym__power_operator] = ACTIONS(9980),
    [sym__tilde_operator] = ACTIONS(9980),
    [sym__type_order_operator] = ACTIONS(9980),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [5958] = {
    [sym_block_comment] = STATE(5958),
    [sym_line_comment] = STATE(5958),
    [ts_builtin_sym_end] = ACTIONS(9984),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_RBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [5959] = {
    [sym_block_comment] = STATE(5959),
    [sym_line_comment] = STATE(5959),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_RBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_RBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [5960] = {
    [sym_block_comment] = STATE(5960),
    [sym_line_comment] = STATE(5960),
    [ts_builtin_sym_end] = ACTIONS(9988),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_RBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [5961] = {
    [sym_block_comment] = STATE(5961),
    [sym_line_comment] = STATE(5961),
    [ts_builtin_sym_end] = ACTIONS(10002),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_RBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [5962] = {
    [sym_block_comment] = STATE(5962),
    [sym_line_comment] = STATE(5962),
    [ts_builtin_sym_end] = ACTIONS(10006),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_RBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [5963] = {
    [sym_block_comment] = STATE(5963),
    [sym_line_comment] = STATE(5963),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [5964] = {
    [sym_block_comment] = STATE(5964),
    [sym_line_comment] = STATE(5964),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [5965] = {
    [sym_block_comment] = STATE(5965),
    [sym_line_comment] = STATE(5965),
    [ts_builtin_sym_end] = ACTIONS(10012),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_RBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [5966] = {
    [sym_block_comment] = STATE(5966),
    [sym_line_comment] = STATE(5966),
    [ts_builtin_sym_end] = ACTIONS(10016),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_RBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [5967] = {
    [sym_block_comment] = STATE(5967),
    [sym_line_comment] = STATE(5967),
    [ts_builtin_sym_end] = ACTIONS(10020),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_RBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [5968] = {
    [sym_block_comment] = STATE(5968),
    [sym_line_comment] = STATE(5968),
    [ts_builtin_sym_end] = ACTIONS(9918),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_RBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [5969] = {
    [sym_block_comment] = STATE(5969),
    [sym_line_comment] = STATE(5969),
    [ts_builtin_sym_end] = ACTIONS(9922),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_RBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [5970] = {
    [sym_block_comment] = STATE(5970),
    [sym_line_comment] = STATE(5970),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_RPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_RBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_SEMI] = ACTIONS(9928),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_RBRACE] = ACTIONS(9928),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5971] = {
    [sym_block_comment] = STATE(5971),
    [sym_line_comment] = STATE(5971),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_DASH_GT] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [5972] = {
    [sym_block_comment] = STATE(5972),
    [sym_line_comment] = STATE(5972),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9956),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9956),
    [anon_sym_RPAREN] = ACTIONS(9956),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9956),
    [anon_sym_RBRACK] = ACTIONS(9956),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_SEMI] = ACTIONS(9956),
    [anon_sym_LBRACE] = ACTIONS(9956),
    [anon_sym_RBRACE] = ACTIONS(9956),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9956),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9956),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9956),
    [anon_sym_QMARK] = ACTIONS(9956),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9956),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9956),
    [aux_sym_integer_literal_token2] = ACTIONS(9956),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9956),
    [aux_sym_float_literal_token3] = ACTIONS(9956),
    [aux_sym_float_literal_token4] = ACTIONS(9956),
    [sym_character_literal] = ACTIONS(9956),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9956),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9956),
    [sym__pair_operator] = ACTIONS(9956),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9956),
    [sym__lazy_and_operator] = ACTIONS(9956),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9956),
    [sym__pipe_left_operator] = ACTIONS(9956),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9956),
    [sym__bitshift_operator] = ACTIONS(9956),
    [sym__power_operator] = ACTIONS(9956),
    [sym__tilde_operator] = ACTIONS(9956),
    [sym__type_order_operator] = ACTIONS(9956),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [5973] = {
    [sym_block_comment] = STATE(5973),
    [sym_line_comment] = STATE(5973),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9964),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9964),
    [anon_sym_RPAREN] = ACTIONS(9964),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9964),
    [anon_sym_RBRACK] = ACTIONS(9964),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_SEMI] = ACTIONS(9964),
    [anon_sym_LBRACE] = ACTIONS(9964),
    [anon_sym_RBRACE] = ACTIONS(9964),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9964),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9964),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9964),
    [anon_sym_QMARK] = ACTIONS(9964),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9964),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9964),
    [aux_sym_integer_literal_token2] = ACTIONS(9964),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9964),
    [aux_sym_float_literal_token3] = ACTIONS(9964),
    [aux_sym_float_literal_token4] = ACTIONS(9964),
    [sym_character_literal] = ACTIONS(9964),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9964),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9964),
    [sym__pair_operator] = ACTIONS(9964),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9964),
    [sym__lazy_and_operator] = ACTIONS(9964),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9964),
    [sym__pipe_left_operator] = ACTIONS(9964),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9964),
    [sym__bitshift_operator] = ACTIONS(9964),
    [sym__power_operator] = ACTIONS(9964),
    [sym__tilde_operator] = ACTIONS(9964),
    [sym__type_order_operator] = ACTIONS(9964),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [5974] = {
    [sym_block_comment] = STATE(5974),
    [sym_line_comment] = STATE(5974),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_RPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_RBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_SEMI] = ACTIONS(9712),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_RBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [5975] = {
    [sym_block_comment] = STATE(5975),
    [sym_line_comment] = STATE(5975),
    [ts_builtin_sym_end] = ACTIONS(9992),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_RBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [5976] = {
    [sym_block_comment] = STATE(5976),
    [sym_line_comment] = STATE(5976),
    [ts_builtin_sym_end] = ACTIONS(9996),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_RBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [5977] = {
    [sym_block_comment] = STATE(5977),
    [sym_line_comment] = STATE(5977),
    [ts_builtin_sym_end] = ACTIONS(9754),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_RBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [5978] = {
    [sym_block_comment] = STATE(5978),
    [sym_line_comment] = STATE(5978),
    [ts_builtin_sym_end] = ACTIONS(9762),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_RBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [5979] = {
    [sym_block_comment] = STATE(5979),
    [sym_line_comment] = STATE(5979),
    [ts_builtin_sym_end] = ACTIONS(10030),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_RBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [5980] = {
    [sym_block_comment] = STATE(5980),
    [sym_line_comment] = STATE(5980),
    [ts_builtin_sym_end] = ACTIONS(10034),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_RBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [5981] = {
    [sym_block_comment] = STATE(5981),
    [sym_line_comment] = STATE(5981),
    [ts_builtin_sym_end] = ACTIONS(10038),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_RBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [5982] = {
    [sym_block_comment] = STATE(5982),
    [sym_line_comment] = STATE(5982),
    [ts_builtin_sym_end] = ACTIONS(10042),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_RBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [5983] = {
    [sym_block_comment] = STATE(5983),
    [sym_line_comment] = STATE(5983),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [5984] = {
    [sym_block_comment] = STATE(5984),
    [sym_line_comment] = STATE(5984),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10104),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10104),
    [anon_sym_RPAREN] = ACTIONS(10104),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10104),
    [anon_sym_RBRACK] = ACTIONS(10104),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_SEMI] = ACTIONS(10104),
    [anon_sym_LBRACE] = ACTIONS(10104),
    [anon_sym_RBRACE] = ACTIONS(10104),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10104),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10104),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10104),
    [anon_sym_QMARK] = ACTIONS(10104),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10104),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10104),
    [aux_sym_integer_literal_token2] = ACTIONS(10104),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10104),
    [aux_sym_float_literal_token3] = ACTIONS(10104),
    [aux_sym_float_literal_token4] = ACTIONS(10104),
    [sym_character_literal] = ACTIONS(10104),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10104),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10104),
    [sym__pair_operator] = ACTIONS(10104),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10104),
    [sym__lazy_and_operator] = ACTIONS(10104),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10104),
    [sym__pipe_left_operator] = ACTIONS(10104),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10104),
    [sym__bitshift_operator] = ACTIONS(10104),
    [sym__power_operator] = ACTIONS(10104),
    [sym__tilde_operator] = ACTIONS(10104),
    [sym__type_order_operator] = ACTIONS(10104),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [5985] = {
    [sym_block_comment] = STATE(5985),
    [sym_line_comment] = STATE(5985),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10108),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10108),
    [anon_sym_RPAREN] = ACTIONS(10108),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10108),
    [anon_sym_RBRACK] = ACTIONS(10108),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_SEMI] = ACTIONS(10108),
    [anon_sym_LBRACE] = ACTIONS(10108),
    [anon_sym_RBRACE] = ACTIONS(10108),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10108),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10108),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10108),
    [anon_sym_QMARK] = ACTIONS(10108),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10108),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10108),
    [aux_sym_integer_literal_token2] = ACTIONS(10108),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10108),
    [aux_sym_float_literal_token3] = ACTIONS(10108),
    [aux_sym_float_literal_token4] = ACTIONS(10108),
    [sym_character_literal] = ACTIONS(10108),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10108),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10108),
    [sym__pair_operator] = ACTIONS(10108),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10108),
    [sym__lazy_and_operator] = ACTIONS(10108),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10108),
    [sym__pipe_left_operator] = ACTIONS(10108),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10108),
    [sym__bitshift_operator] = ACTIONS(10108),
    [sym__power_operator] = ACTIONS(10108),
    [sym__tilde_operator] = ACTIONS(10108),
    [sym__type_order_operator] = ACTIONS(10108),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [5986] = {
    [sym_block_comment] = STATE(5986),
    [sym_line_comment] = STATE(5986),
    [ts_builtin_sym_end] = ACTIONS(9792),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_RBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [5987] = {
    [sym_block_comment] = STATE(5987),
    [sym_line_comment] = STATE(5987),
    [ts_builtin_sym_end] = ACTIONS(10046),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_RBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [5988] = {
    [sym_block_comment] = STATE(5988),
    [sym_line_comment] = STATE(5988),
    [ts_builtin_sym_end] = ACTIONS(10050),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_RBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [5989] = {
    [sym_block_comment] = STATE(5989),
    [sym_line_comment] = STATE(5989),
    [ts_builtin_sym_end] = ACTIONS(10054),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_RBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [5990] = {
    [sym_block_comment] = STATE(5990),
    [sym_line_comment] = STATE(5990),
    [ts_builtin_sym_end] = ACTIONS(10058),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_RBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [5991] = {
    [sym_block_comment] = STATE(5991),
    [sym_line_comment] = STATE(5991),
    [ts_builtin_sym_end] = ACTIONS(9900),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_RBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [5992] = {
    [sym_block_comment] = STATE(5992),
    [sym_line_comment] = STATE(5992),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_RPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_RBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_SEMI] = ACTIONS(10118),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_RBRACE] = ACTIONS(10118),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [5993] = {
    [sym_block_comment] = STATE(5993),
    [sym_line_comment] = STATE(5993),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [5994] = {
    [sym_block_comment] = STATE(5994),
    [sym_line_comment] = STATE(5994),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10124),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10124),
    [anon_sym_RPAREN] = ACTIONS(10124),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10124),
    [anon_sym_RBRACK] = ACTIONS(10124),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_SEMI] = ACTIONS(10124),
    [anon_sym_LBRACE] = ACTIONS(10124),
    [anon_sym_RBRACE] = ACTIONS(10124),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10124),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10124),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10124),
    [anon_sym_QMARK] = ACTIONS(10124),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10124),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10124),
    [aux_sym_integer_literal_token2] = ACTIONS(10124),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10124),
    [aux_sym_float_literal_token3] = ACTIONS(10124),
    [aux_sym_float_literal_token4] = ACTIONS(10124),
    [sym_character_literal] = ACTIONS(10124),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10124),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10124),
    [sym__pair_operator] = ACTIONS(10124),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10124),
    [sym__lazy_and_operator] = ACTIONS(10124),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10124),
    [sym__pipe_left_operator] = ACTIONS(10124),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10124),
    [sym__bitshift_operator] = ACTIONS(10124),
    [sym__power_operator] = ACTIONS(10124),
    [sym__tilde_operator] = ACTIONS(10124),
    [sym__type_order_operator] = ACTIONS(10124),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [5995] = {
    [sym_block_comment] = STATE(5995),
    [sym_line_comment] = STATE(5995),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_RPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_RBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_SEMI] = ACTIONS(9704),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_RBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [5996] = {
    [sym_block_comment] = STATE(5996),
    [sym_line_comment] = STATE(5996),
    [ts_builtin_sym_end] = ACTIONS(10062),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_RBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [5997] = {
    [sym_block_comment] = STATE(5997),
    [sym_line_comment] = STATE(5997),
    [ts_builtin_sym_end] = ACTIONS(10066),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_RBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [5998] = {
    [sym_block_comment] = STATE(5998),
    [sym_line_comment] = STATE(5998),
    [ts_builtin_sym_end] = ACTIONS(10070),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_RBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [5999] = {
    [sym_block_comment] = STATE(5999),
    [sym_line_comment] = STATE(5999),
    [ts_builtin_sym_end] = ACTIONS(10074),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_RBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6000] = {
    [sym_block_comment] = STATE(6000),
    [sym_line_comment] = STATE(6000),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10130),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10130),
    [anon_sym_RPAREN] = ACTIONS(10130),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10130),
    [anon_sym_RBRACK] = ACTIONS(10130),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_SEMI] = ACTIONS(10130),
    [anon_sym_LBRACE] = ACTIONS(10130),
    [anon_sym_RBRACE] = ACTIONS(10130),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10130),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10130),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10130),
    [anon_sym_QMARK] = ACTIONS(10130),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10130),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10130),
    [aux_sym_integer_literal_token2] = ACTIONS(10130),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10130),
    [aux_sym_float_literal_token3] = ACTIONS(10130),
    [aux_sym_float_literal_token4] = ACTIONS(10130),
    [sym_character_literal] = ACTIONS(10130),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10130),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10130),
    [sym__pair_operator] = ACTIONS(10130),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10130),
    [sym__lazy_and_operator] = ACTIONS(10130),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10130),
    [sym__pipe_left_operator] = ACTIONS(10130),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10130),
    [sym__bitshift_operator] = ACTIONS(10130),
    [sym__power_operator] = ACTIONS(10130),
    [sym__tilde_operator] = ACTIONS(10130),
    [sym__type_order_operator] = ACTIONS(10130),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6001] = {
    [sym_block_comment] = STATE(6001),
    [sym_line_comment] = STATE(6001),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10140),
    [anon_sym_RPAREN] = ACTIONS(10140),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10140),
    [anon_sym_RBRACK] = ACTIONS(10140),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_SEMI] = ACTIONS(10140),
    [anon_sym_LBRACE] = ACTIONS(10140),
    [anon_sym_RBRACE] = ACTIONS(10140),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10140),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10140),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_QMARK] = ACTIONS(10140),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10140),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10140),
    [aux_sym_integer_literal_token2] = ACTIONS(10140),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10140),
    [aux_sym_float_literal_token3] = ACTIONS(10140),
    [aux_sym_float_literal_token4] = ACTIONS(10140),
    [sym_character_literal] = ACTIONS(10140),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10140),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10140),
    [sym__pair_operator] = ACTIONS(10140),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10140),
    [sym__lazy_and_operator] = ACTIONS(10140),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10140),
    [sym__pipe_left_operator] = ACTIONS(10140),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10140),
    [sym__bitshift_operator] = ACTIONS(10140),
    [sym__power_operator] = ACTIONS(10140),
    [sym__tilde_operator] = ACTIONS(10140),
    [sym__type_order_operator] = ACTIONS(10140),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6002] = {
    [sym_block_comment] = STATE(6002),
    [sym_line_comment] = STATE(6002),
    [ts_builtin_sym_end] = ACTIONS(10078),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_RBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6003] = {
    [sym_block_comment] = STATE(6003),
    [sym_line_comment] = STATE(6003),
    [ts_builtin_sym_end] = ACTIONS(10082),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_RBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6004] = {
    [sym_block_comment] = STATE(6004),
    [sym_line_comment] = STATE(6004),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10144),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10144),
    [anon_sym_RPAREN] = ACTIONS(10144),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10144),
    [anon_sym_RBRACK] = ACTIONS(10144),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_SEMI] = ACTIONS(10144),
    [anon_sym_LBRACE] = ACTIONS(10144),
    [anon_sym_RBRACE] = ACTIONS(10144),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10144),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10144),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10144),
    [anon_sym_QMARK] = ACTIONS(10144),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10144),
    [aux_sym_integer_literal_token2] = ACTIONS(10144),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10144),
    [aux_sym_float_literal_token3] = ACTIONS(10144),
    [aux_sym_float_literal_token4] = ACTIONS(10144),
    [sym_character_literal] = ACTIONS(10144),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10144),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10144),
    [sym__pair_operator] = ACTIONS(10144),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10144),
    [sym__lazy_and_operator] = ACTIONS(10144),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10144),
    [sym__pipe_left_operator] = ACTIONS(10144),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10144),
    [sym__bitshift_operator] = ACTIONS(10144),
    [sym__power_operator] = ACTIONS(10144),
    [sym__tilde_operator] = ACTIONS(10144),
    [sym__type_order_operator] = ACTIONS(10144),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6005] = {
    [sym_block_comment] = STATE(6005),
    [sym_line_comment] = STATE(6005),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_DASH_GT] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [6006] = {
    [sym_block_comment] = STATE(6006),
    [sym_line_comment] = STATE(6006),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DASH_GT] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6007] = {
    [sym_block_comment] = STATE(6007),
    [sym_line_comment] = STATE(6007),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_RPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_RBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_SEMI] = ACTIONS(10154),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_RBRACE] = ACTIONS(10154),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6008] = {
    [sym_block_comment] = STATE(6008),
    [sym_line_comment] = STATE(6008),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_DASH_GT] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [6009] = {
    [sym_block_comment] = STATE(6009),
    [sym_line_comment] = STATE(6009),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_DASH_GT] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [6010] = {
    [sym_block_comment] = STATE(6010),
    [sym_line_comment] = STATE(6010),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_DASH_GT] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [6011] = {
    [sym_block_comment] = STATE(6011),
    [sym_line_comment] = STATE(6011),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_DASH_GT] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [6012] = {
    [sym_block_comment] = STATE(6012),
    [sym_line_comment] = STATE(6012),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_DASH_GT] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6013] = {
    [sym_block_comment] = STATE(6013),
    [sym_line_comment] = STATE(6013),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_DASH_GT] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [6014] = {
    [sym_block_comment] = STATE(6014),
    [sym_line_comment] = STATE(6014),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_DASH_GT] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [6015] = {
    [sym_block_comment] = STATE(6015),
    [sym_line_comment] = STATE(6015),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_DASH_GT] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [6016] = {
    [sym_block_comment] = STATE(6016),
    [sym_line_comment] = STATE(6016),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_DASH_GT] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6017] = {
    [sym_block_comment] = STATE(6017),
    [sym_line_comment] = STATE(6017),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_DASH_GT] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [6018] = {
    [sym_block_comment] = STATE(6018),
    [sym_line_comment] = STATE(6018),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_DASH_GT] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6019] = {
    [sym_block_comment] = STATE(6019),
    [sym_line_comment] = STATE(6019),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_DASH_GT] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6020] = {
    [sym_block_comment] = STATE(6020),
    [sym_line_comment] = STATE(6020),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_DASH_GT] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6021] = {
    [sym_block_comment] = STATE(6021),
    [sym_line_comment] = STATE(6021),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_DASH_GT] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6022] = {
    [sym_block_comment] = STATE(6022),
    [sym_line_comment] = STATE(6022),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [6023] = {
    [sym_block_comment] = STATE(6023),
    [sym_line_comment] = STATE(6023),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_DASH_GT] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6024] = {
    [sym_block_comment] = STATE(6024),
    [sym_line_comment] = STATE(6024),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [6025] = {
    [sym_block_comment] = STATE(6025),
    [sym_line_comment] = STATE(6025),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6026] = {
    [sym_block_comment] = STATE(6026),
    [sym_line_comment] = STATE(6026),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_RPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_RBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_SEMI] = ACTIONS(10136),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_RBRACE] = ACTIONS(10136),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6027] = {
    [sym_block_comment] = STATE(6027),
    [sym_line_comment] = STATE(6027),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6028] = {
    [sym_block_comment] = STATE(6028),
    [sym_line_comment] = STATE(6028),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_DASH_GT] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [6029] = {
    [sym_block_comment] = STATE(6029),
    [sym_line_comment] = STATE(6029),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_DASH_GT] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [6030] = {
    [sym_block_comment] = STATE(6030),
    [sym_line_comment] = STATE(6030),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_RPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_RBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_SEMI] = ACTIONS(9728),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6031] = {
    [sym_block_comment] = STATE(6031),
    [sym_line_comment] = STATE(6031),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6032] = {
    [sym_block_comment] = STATE(6032),
    [sym_line_comment] = STATE(6032),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6033] = {
    [sym_block_comment] = STATE(6033),
    [sym_line_comment] = STATE(6033),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_RPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_RBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9740),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_RBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6034] = {
    [sym_block_comment] = STATE(6034),
    [sym_line_comment] = STATE(6034),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_RPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_RBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_SEMI] = ACTIONS(9746),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_RBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6035] = {
    [sym_block_comment] = STATE(6035),
    [sym_line_comment] = STATE(6035),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6036] = {
    [sym_block_comment] = STATE(6036),
    [sym_line_comment] = STATE(6036),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [6037] = {
    [sym_block_comment] = STATE(6037),
    [sym_line_comment] = STATE(6037),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_RPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_RBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_SEMI] = ACTIONS(9984),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_RBRACE] = ACTIONS(9984),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6038] = {
    [sym_block_comment] = STATE(6038),
    [sym_line_comment] = STATE(6038),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [6039] = {
    [sym_block_comment] = STATE(6039),
    [sym_line_comment] = STATE(6039),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_RPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_RBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_SEMI] = ACTIONS(9988),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_RBRACE] = ACTIONS(9988),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6040] = {
    [sym_block_comment] = STATE(6040),
    [sym_line_comment] = STATE(6040),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_RPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_RBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_SEMI] = ACTIONS(10002),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_RBRACE] = ACTIONS(10002),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6041] = {
    [sym_block_comment] = STATE(6041),
    [sym_line_comment] = STATE(6041),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_RPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_RBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_SEMI] = ACTIONS(10006),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_RBRACE] = ACTIONS(10006),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6042] = {
    [sym_block_comment] = STATE(6042),
    [sym_line_comment] = STATE(6042),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6043] = {
    [sym_block_comment] = STATE(6043),
    [sym_line_comment] = STATE(6043),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10525),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10525),
    [anon_sym_RPAREN] = ACTIONS(10525),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10525),
    [anon_sym_RBRACK] = ACTIONS(10525),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_SEMI] = ACTIONS(10525),
    [anon_sym_LBRACE] = ACTIONS(10525),
    [anon_sym_RBRACE] = ACTIONS(10525),
    [anon_sym_SQUOTE] = ACTIONS(10581),
    [anon_sym_DOT] = ACTIONS(10583),
    [anon_sym_DOLLAR] = ACTIONS(10525),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10525),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10525),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10525),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10525),
    [aux_sym_integer_literal_token2] = ACTIONS(10525),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10525),
    [aux_sym_float_literal_token3] = ACTIONS(10525),
    [aux_sym_float_literal_token4] = ACTIONS(10525),
    [sym_character_literal] = ACTIONS(10525),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10525),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10525),
    [sym__pair_operator] = ACTIONS(10525),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10525),
    [sym__lazy_and_operator] = ACTIONS(10525),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10525),
    [sym__pipe_left_operator] = ACTIONS(10525),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10525),
    [sym__bitshift_operator] = ACTIONS(10525),
    [sym__power_operator] = ACTIONS(10525),
    [sym__tilde_operator] = ACTIONS(10525),
    [sym__type_order_operator] = ACTIONS(10525),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10585),
    [sym__immediate_bracket] = ACTIONS(10587),
    [sym__immediate_brace] = ACTIONS(10589),
  },
  [6044] = {
    [sym_block_comment] = STATE(6044),
    [sym_line_comment] = STATE(6044),
    [ts_builtin_sym_end] = ACTIONS(10088),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_RBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6045] = {
    [sym_block_comment] = STATE(6045),
    [sym_line_comment] = STATE(6045),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_RPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_RBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_SEMI] = ACTIONS(10012),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_RBRACE] = ACTIONS(10012),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6046] = {
    [sym_block_comment] = STATE(6046),
    [sym_line_comment] = STATE(6046),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_RPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_RBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_SEMI] = ACTIONS(10016),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_RBRACE] = ACTIONS(10016),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6047] = {
    [sym_block_comment] = STATE(6047),
    [sym_line_comment] = STATE(6047),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_RPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_RBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_SEMI] = ACTIONS(10020),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_RBRACE] = ACTIONS(10020),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6048] = {
    [sym_block_comment] = STATE(6048),
    [sym_line_comment] = STATE(6048),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_RPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_RBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_SEMI] = ACTIONS(9918),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6049] = {
    [sym_block_comment] = STATE(6049),
    [sym_line_comment] = STATE(6049),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_RPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_RBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_SEMI] = ACTIONS(9922),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_RBRACE] = ACTIONS(9922),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6050] = {
    [sym_block_comment] = STATE(6050),
    [sym_line_comment] = STATE(6050),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_DASH_GT] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6051] = {
    [sym_block_comment] = STATE(6051),
    [sym_line_comment] = STATE(6051),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10539),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10539),
    [anon_sym_RPAREN] = ACTIONS(10539),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10539),
    [anon_sym_RBRACK] = ACTIONS(10539),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_SEMI] = ACTIONS(10539),
    [anon_sym_LBRACE] = ACTIONS(10539),
    [anon_sym_RBRACE] = ACTIONS(10539),
    [anon_sym_SQUOTE] = ACTIONS(10581),
    [anon_sym_DOT] = ACTIONS(10583),
    [anon_sym_DOLLAR] = ACTIONS(10539),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10539),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10539),
    [anon_sym_QMARK] = ACTIONS(10539),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10539),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10539),
    [aux_sym_integer_literal_token2] = ACTIONS(10539),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10539),
    [aux_sym_float_literal_token3] = ACTIONS(10539),
    [aux_sym_float_literal_token4] = ACTIONS(10539),
    [sym_character_literal] = ACTIONS(10539),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10539),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10539),
    [sym__pair_operator] = ACTIONS(10539),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10539),
    [sym__lazy_and_operator] = ACTIONS(10539),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10539),
    [sym__pipe_left_operator] = ACTIONS(10539),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10539),
    [sym__bitshift_operator] = ACTIONS(10539),
    [sym__power_operator] = ACTIONS(10539),
    [sym__tilde_operator] = ACTIONS(10539),
    [sym__type_order_operator] = ACTIONS(10539),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10585),
    [sym__immediate_bracket] = ACTIONS(10587),
    [sym__immediate_brace] = ACTIONS(10589),
  },
  [6052] = {
    [sym_block_comment] = STATE(6052),
    [sym_line_comment] = STATE(6052),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_RPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_RBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_SEMI] = ACTIONS(9992),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_RBRACE] = ACTIONS(9992),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6053] = {
    [sym_block_comment] = STATE(6053),
    [sym_line_comment] = STATE(6053),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_RPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_RBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_SEMI] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_RBRACE] = ACTIONS(9996),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6054] = {
    [sym_block_comment] = STATE(6054),
    [sym_line_comment] = STATE(6054),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_RPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_RBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_SEMI] = ACTIONS(9754),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_RBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6055] = {
    [sym_block_comment] = STATE(6055),
    [sym_line_comment] = STATE(6055),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_RBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9762),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6056] = {
    [sym_block_comment] = STATE(6056),
    [sym_line_comment] = STATE(6056),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_RPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_RBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_SEMI] = ACTIONS(10030),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_RBRACE] = ACTIONS(10030),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6057] = {
    [sym_block_comment] = STATE(6057),
    [sym_line_comment] = STATE(6057),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_RPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_RBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_SEMI] = ACTIONS(10034),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_RBRACE] = ACTIONS(10034),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6058] = {
    [sym_block_comment] = STATE(6058),
    [sym_line_comment] = STATE(6058),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_RPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_RBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_SEMI] = ACTIONS(10038),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_RBRACE] = ACTIONS(10038),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [6059] = {
    [sym_block_comment] = STATE(6059),
    [sym_line_comment] = STATE(6059),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_RPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_RBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_SEMI] = ACTIONS(10042),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6060] = {
    [sym_block_comment] = STATE(6060),
    [sym_line_comment] = STATE(6060),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_DASH_GT] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6061] = {
    [sym_block_comment] = STATE(6061),
    [sym_line_comment] = STATE(6061),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_DASH_GT] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6062] = {
    [sym_block_comment] = STATE(6062),
    [sym_line_comment] = STATE(6062),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_RPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_RBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_SEMI] = ACTIONS(9792),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6063] = {
    [sym_block_comment] = STATE(6063),
    [sym_line_comment] = STATE(6063),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_RPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_RBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_SEMI] = ACTIONS(10046),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_RBRACE] = ACTIONS(10046),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6064] = {
    [sym_block_comment] = STATE(6064),
    [sym_line_comment] = STATE(6064),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_RPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_RBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_SEMI] = ACTIONS(10050),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_RBRACE] = ACTIONS(10050),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6065] = {
    [sym_block_comment] = STATE(6065),
    [sym_line_comment] = STATE(6065),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_RBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_SEMI] = ACTIONS(10054),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_RBRACE] = ACTIONS(10054),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6066] = {
    [sym_block_comment] = STATE(6066),
    [sym_line_comment] = STATE(6066),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_RPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_RBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_SEMI] = ACTIONS(10058),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_RBRACE] = ACTIONS(10058),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6067] = {
    [sym_block_comment] = STATE(6067),
    [sym_line_comment] = STATE(6067),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_RPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_RBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_SEMI] = ACTIONS(9900),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_RBRACE] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6068] = {
    [sym_block_comment] = STATE(6068),
    [sym_line_comment] = STATE(6068),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_RPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_RBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_SEMI] = ACTIONS(10062),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_RBRACE] = ACTIONS(10062),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [6069] = {
    [sym_block_comment] = STATE(6069),
    [sym_line_comment] = STATE(6069),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_RPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_RBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_SEMI] = ACTIONS(10066),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_RBRACE] = ACTIONS(10066),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [6070] = {
    [sym_block_comment] = STATE(6070),
    [sym_line_comment] = STATE(6070),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_RPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_RBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_SEMI] = ACTIONS(10070),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [6071] = {
    [sym_block_comment] = STATE(6071),
    [sym_line_comment] = STATE(6071),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_RPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_RBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_SEMI] = ACTIONS(10074),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_RBRACE] = ACTIONS(10074),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6072] = {
    [sym_block_comment] = STATE(6072),
    [sym_line_comment] = STATE(6072),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_RPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_RBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_SEMI] = ACTIONS(10078),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_RBRACE] = ACTIONS(10078),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6073] = {
    [sym_block_comment] = STATE(6073),
    [sym_line_comment] = STATE(6073),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_RPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_RBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_SEMI] = ACTIONS(10082),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_RBRACE] = ACTIONS(10082),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6074] = {
    [sym_block_comment] = STATE(6074),
    [sym_line_comment] = STATE(6074),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_catch] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [6075] = {
    [sym_block_comment] = STATE(6075),
    [sym_line_comment] = STATE(6075),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_DASH_GT] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6076] = {
    [sym_block_comment] = STATE(6076),
    [sym_line_comment] = STATE(6076),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6077] = {
    [sym_block_comment] = STATE(6077),
    [sym_line_comment] = STATE(6077),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_DASH_GT] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6078] = {
    [sym_block_comment] = STATE(6078),
    [sym_line_comment] = STATE(6078),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_DASH_GT] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6079] = {
    [sym_block_comment] = STATE(6079),
    [sym_line_comment] = STATE(6079),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_DASH_GT] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6080] = {
    [sym_block_comment] = STATE(6080),
    [sym_line_comment] = STATE(6080),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6081] = {
    [sym_block_comment] = STATE(6081),
    [sym_line_comment] = STATE(6081),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [6082] = {
    [sym_block_comment] = STATE(6082),
    [sym_line_comment] = STATE(6082),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6083] = {
    [sym_block_comment] = STATE(6083),
    [sym_line_comment] = STATE(6083),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_DASH_GT] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6084] = {
    [sym_block_comment] = STATE(6084),
    [sym_line_comment] = STATE(6084),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_DASH_GT] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6085] = {
    [sym_block_comment] = STATE(6085),
    [sym_line_comment] = STATE(6085),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_DASH_GT] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6086] = {
    [sym_block_comment] = STATE(6086),
    [sym_line_comment] = STATE(6086),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_DASH_GT] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6087] = {
    [sym_block_comment] = STATE(6087),
    [sym_line_comment] = STATE(6087),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_DASH_GT] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6088] = {
    [sym_block_comment] = STATE(6088),
    [sym_line_comment] = STATE(6088),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [6089] = {
    [sym_block_comment] = STATE(6089),
    [sym_line_comment] = STATE(6089),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_catch] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [6090] = {
    [sym_block_comment] = STATE(6090),
    [sym_line_comment] = STATE(6090),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_catch] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [6091] = {
    [sym_block_comment] = STATE(6091),
    [sym_line_comment] = STATE(6091),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [6092] = {
    [sym_block_comment] = STATE(6092),
    [sym_line_comment] = STATE(6092),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6093] = {
    [sym_block_comment] = STATE(6093),
    [sym_line_comment] = STATE(6093),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_DASH_GT] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6094] = {
    [sym_block_comment] = STATE(6094),
    [sym_line_comment] = STATE(6094),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_DASH_GT] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6095] = {
    [sym_block_comment] = STATE(6095),
    [sym_line_comment] = STATE(6095),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_DASH_GT] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6096] = {
    [sym_block_comment] = STATE(6096),
    [sym_line_comment] = STATE(6096),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_DASH_GT] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6097] = {
    [sym_block_comment] = STATE(6097),
    [sym_line_comment] = STATE(6097),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_DASH_GT] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6098] = {
    [sym_block_comment] = STATE(6098),
    [sym_line_comment] = STATE(6098),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_DASH_GT] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6099] = {
    [sym_block_comment] = STATE(6099),
    [sym_line_comment] = STATE(6099),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_DASH_GT] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [6100] = {
    [sym_block_comment] = STATE(6100),
    [sym_line_comment] = STATE(6100),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_DASH_GT] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6101] = {
    [sym_block_comment] = STATE(6101),
    [sym_line_comment] = STATE(6101),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_catch] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [6102] = {
    [sym_block_comment] = STATE(6102),
    [sym_line_comment] = STATE(6102),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_catch] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [6103] = {
    [sym_block_comment] = STATE(6103),
    [sym_line_comment] = STATE(6103),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_DASH_GT] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6104] = {
    [sym_block_comment] = STATE(6104),
    [sym_line_comment] = STATE(6104),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_DASH_GT] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6105] = {
    [sym_block_comment] = STATE(6105),
    [sym_line_comment] = STATE(6105),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_DASH_GT] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6106] = {
    [sym_block_comment] = STATE(6106),
    [sym_line_comment] = STATE(6106),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_DASH_GT] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6107] = {
    [sym_block_comment] = STATE(6107),
    [sym_line_comment] = STATE(6107),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_DASH_GT] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6108] = {
    [sym_block_comment] = STATE(6108),
    [sym_line_comment] = STATE(6108),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_DASH_GT] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6109] = {
    [sym_block_comment] = STATE(6109),
    [sym_line_comment] = STATE(6109),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [6110] = {
    [sym_block_comment] = STATE(6110),
    [sym_line_comment] = STATE(6110),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_catch] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [6111] = {
    [sym_block_comment] = STATE(6111),
    [sym_line_comment] = STATE(6111),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6112] = {
    [sym_block_comment] = STATE(6112),
    [sym_line_comment] = STATE(6112),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_DASH_GT] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [6113] = {
    [sym_block_comment] = STATE(6113),
    [sym_line_comment] = STATE(6113),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_DASH_GT] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [6114] = {
    [sym_block_comment] = STATE(6114),
    [sym_line_comment] = STATE(6114),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_DASH_GT] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [6115] = {
    [sym_block_comment] = STATE(6115),
    [sym_line_comment] = STATE(6115),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_DASH_GT] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6116] = {
    [sym_block_comment] = STATE(6116),
    [sym_line_comment] = STATE(6116),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_catch] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6117] = {
    [sym_block_comment] = STATE(6117),
    [sym_line_comment] = STATE(6117),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_catch] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6118] = {
    [sym_block_comment] = STATE(6118),
    [sym_line_comment] = STATE(6118),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_DASH_GT] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6119] = {
    [sym_block_comment] = STATE(6119),
    [sym_line_comment] = STATE(6119),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_DASH_GT] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6120] = {
    [sym_block_comment] = STATE(6120),
    [sym_line_comment] = STATE(6120),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_catch] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6121] = {
    [sym_block_comment] = STATE(6121),
    [sym_line_comment] = STATE(6121),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6122] = {
    [sym_block_comment] = STATE(6122),
    [sym_line_comment] = STATE(6122),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6123] = {
    [sym_block_comment] = STATE(6123),
    [sym_line_comment] = STATE(6123),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10088),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10088),
    [anon_sym_RPAREN] = ACTIONS(10088),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10088),
    [anon_sym_RBRACK] = ACTIONS(10088),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_SEMI] = ACTIONS(10088),
    [anon_sym_LBRACE] = ACTIONS(10088),
    [anon_sym_RBRACE] = ACTIONS(10088),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10088),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10088),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10088),
    [anon_sym_QMARK] = ACTIONS(10088),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10088),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10088),
    [aux_sym_integer_literal_token2] = ACTIONS(10088),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10088),
    [aux_sym_float_literal_token3] = ACTIONS(10088),
    [aux_sym_float_literal_token4] = ACTIONS(10088),
    [sym_character_literal] = ACTIONS(10088),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10088),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10088),
    [sym__pair_operator] = ACTIONS(10088),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10088),
    [sym__lazy_and_operator] = ACTIONS(10088),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10088),
    [sym__pipe_left_operator] = ACTIONS(10088),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10088),
    [sym__bitshift_operator] = ACTIONS(10088),
    [sym__power_operator] = ACTIONS(10088),
    [sym__tilde_operator] = ACTIONS(10088),
    [sym__type_order_operator] = ACTIONS(10088),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6124] = {
    [sym_block_comment] = STATE(6124),
    [sym_line_comment] = STATE(6124),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_DASH_GT] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10591),
    [sym__immediate_command_start] = ACTIONS(10593),
  },
  [6125] = {
    [sym_identifier] = STATE(6407),
    [sym_block_comment] = STATE(6125),
    [sym_line_comment] = STATE(6125),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [6126] = {
    [sym_identifier] = STATE(6442),
    [sym_block_comment] = STATE(6126),
    [sym_line_comment] = STATE(6126),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [6127] = {
    [sym_identifier] = STATE(6383),
    [sym_block_comment] = STATE(6127),
    [sym_line_comment] = STATE(6127),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [6128] = {
    [sym_identifier] = STATE(6396),
    [sym_block_comment] = STATE(6128),
    [sym_line_comment] = STATE(6128),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [6129] = {
    [sym_block_comment] = STATE(6129),
    [sym_line_comment] = STATE(6129),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10591),
    [sym__immediate_command_start] = ACTIONS(10593),
  },
  [6130] = {
    [sym_block_comment] = STATE(6130),
    [sym_line_comment] = STATE(6130),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_DASH_GT] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6131] = {
    [sym_block_comment] = STATE(6131),
    [sym_line_comment] = STATE(6131),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_catch] = ACTIONS(10440),
    [anon_sym_finally] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10440),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10440),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10440),
    [anon_sym_SQUOTE] = ACTIONS(10595),
    [anon_sym_DOT] = ACTIONS(10597),
    [anon_sym_DOLLAR] = ACTIONS(10440),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10440),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10440),
    [anon_sym_QMARK] = ACTIONS(10440),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10440),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10440),
    [aux_sym_integer_literal_token2] = ACTIONS(10440),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10440),
    [aux_sym_float_literal_token3] = ACTIONS(10440),
    [aux_sym_float_literal_token4] = ACTIONS(10440),
    [sym_character_literal] = ACTIONS(10440),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10440),
    [sym__pair_operator] = ACTIONS(10440),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10440),
    [sym__lazy_and_operator] = ACTIONS(10440),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10440),
    [sym__pipe_left_operator] = ACTIONS(10440),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10440),
    [sym__bitshift_operator] = ACTIONS(10440),
    [sym__power_operator] = ACTIONS(10440),
    [sym__tilde_operator] = ACTIONS(10440),
    [sym__type_order_operator] = ACTIONS(10440),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym__terminator_token1] = ACTIONS(10525),
    [aux_sym__terminator_token2] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10599),
    [sym__immediate_bracket] = ACTIONS(10601),
    [sym__immediate_brace] = ACTIONS(10603),
  },
  [6132] = {
    [sym_block_comment] = STATE(6132),
    [sym_line_comment] = STATE(6132),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10537),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_catch] = ACTIONS(10537),
    [anon_sym_finally] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10537),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10537),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10537),
    [anon_sym_SQUOTE] = ACTIONS(10595),
    [anon_sym_DOT] = ACTIONS(10597),
    [anon_sym_DOLLAR] = ACTIONS(10537),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10537),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10537),
    [anon_sym_QMARK] = ACTIONS(10537),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10537),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10537),
    [aux_sym_integer_literal_token2] = ACTIONS(10537),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10537),
    [aux_sym_float_literal_token3] = ACTIONS(10537),
    [aux_sym_float_literal_token4] = ACTIONS(10537),
    [sym_character_literal] = ACTIONS(10537),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10537),
    [sym__pair_operator] = ACTIONS(10537),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10537),
    [sym__lazy_and_operator] = ACTIONS(10537),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10537),
    [sym__pipe_left_operator] = ACTIONS(10537),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10537),
    [sym__bitshift_operator] = ACTIONS(10537),
    [sym__power_operator] = ACTIONS(10537),
    [sym__tilde_operator] = ACTIONS(10537),
    [sym__type_order_operator] = ACTIONS(10537),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym__terminator_token1] = ACTIONS(10539),
    [aux_sym__terminator_token2] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10599),
    [sym__immediate_bracket] = ACTIONS(10601),
    [sym__immediate_brace] = ACTIONS(10603),
  },
  [6133] = {
    [sym_block_comment] = STATE(6133),
    [sym_line_comment] = STATE(6133),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6134] = {
    [sym_block_comment] = STATE(6134),
    [sym_line_comment] = STATE(6134),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6135] = {
    [sym_block_comment] = STATE(6135),
    [sym_line_comment] = STATE(6135),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6136] = {
    [sym_block_comment] = STATE(6136),
    [sym_line_comment] = STATE(6136),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6137] = {
    [sym_block_comment] = STATE(6137),
    [sym_line_comment] = STATE(6137),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6138] = {
    [sym_block_comment] = STATE(6138),
    [sym_line_comment] = STATE(6138),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [6139] = {
    [sym_block_comment] = STATE(6139),
    [sym_line_comment] = STATE(6139),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_catch] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [6140] = {
    [sym_block_comment] = STATE(6140),
    [sym_line_comment] = STATE(6140),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_catch] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6141] = {
    [sym_block_comment] = STATE(6141),
    [sym_line_comment] = STATE(6141),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_catch] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [6142] = {
    [sym_block_comment] = STATE(6142),
    [sym_line_comment] = STATE(6142),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_catch] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [6143] = {
    [sym_block_comment] = STATE(6143),
    [sym_line_comment] = STATE(6143),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_catch] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [6144] = {
    [sym_block_comment] = STATE(6144),
    [sym_line_comment] = STATE(6144),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_catch] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6145] = {
    [sym_block_comment] = STATE(6145),
    [sym_line_comment] = STATE(6145),
    [ts_builtin_sym_end] = ACTIONS(9960),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_RBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6146] = {
    [sym_block_comment] = STATE(6146),
    [sym_line_comment] = STATE(6146),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_catch] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [6147] = {
    [sym_block_comment] = STATE(6147),
    [sym_line_comment] = STATE(6147),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_catch] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [6148] = {
    [sym_block_comment] = STATE(6148),
    [sym_line_comment] = STATE(6148),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_elseif] = ACTIONS(10577),
    [anon_sym_else] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [6149] = {
    [sym_block_comment] = STATE(6149),
    [sym_line_comment] = STATE(6149),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_catch] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [6150] = {
    [sym_block_comment] = STATE(6150),
    [sym_line_comment] = STATE(6150),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_catch] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6151] = {
    [sym_block_comment] = STATE(6151),
    [sym_line_comment] = STATE(6151),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10322),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10605),
    [anon_sym_DOT] = ACTIONS(10607),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10609),
    [sym__immediate_bracket] = ACTIONS(10611),
    [sym__immediate_brace] = ACTIONS(10613),
  },
  [6152] = {
    [sym_block_comment] = STATE(6152),
    [sym_line_comment] = STATE(6152),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_catch] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6153] = {
    [sym_block_comment] = STATE(6153),
    [sym_line_comment] = STATE(6153),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_catch] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6154] = {
    [sym_block_comment] = STATE(6154),
    [sym_line_comment] = STATE(6154),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_catch] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6155] = {
    [sym_block_comment] = STATE(6155),
    [sym_line_comment] = STATE(6155),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [6156] = {
    [sym_block_comment] = STATE(6156),
    [sym_line_comment] = STATE(6156),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6157] = {
    [sym_block_comment] = STATE(6157),
    [sym_line_comment] = STATE(6157),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6158] = {
    [sym_block_comment] = STATE(6158),
    [sym_line_comment] = STATE(6158),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6159] = {
    [sym_block_comment] = STATE(6159),
    [sym_line_comment] = STATE(6159),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6160] = {
    [sym_block_comment] = STATE(6160),
    [sym_line_comment] = STATE(6160),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10573),
    [sym__immediate_command_start] = ACTIONS(10575),
  },
  [6161] = {
    [sym_block_comment] = STATE(6161),
    [sym_line_comment] = STATE(6161),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6162] = {
    [sym_block_comment] = STATE(6162),
    [sym_line_comment] = STATE(6162),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6163] = {
    [sym_block_comment] = STATE(6163),
    [sym_line_comment] = STATE(6163),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6164] = {
    [sym_block_comment] = STATE(6164),
    [sym_line_comment] = STATE(6164),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6165] = {
    [sym_block_comment] = STATE(6165),
    [sym_line_comment] = STATE(6165),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6166] = {
    [sym_block_comment] = STATE(6166),
    [sym_line_comment] = STATE(6166),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6167] = {
    [sym_block_comment] = STATE(6167),
    [sym_line_comment] = STATE(6167),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6168] = {
    [sym_block_comment] = STATE(6168),
    [sym_line_comment] = STATE(6168),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6169] = {
    [sym_block_comment] = STATE(6169),
    [sym_line_comment] = STATE(6169),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6170] = {
    [sym_block_comment] = STATE(6170),
    [sym_line_comment] = STATE(6170),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6171] = {
    [sym_block_comment] = STATE(6171),
    [sym_line_comment] = STATE(6171),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6172] = {
    [sym_block_comment] = STATE(6172),
    [sym_line_comment] = STATE(6172),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [6173] = {
    [sym_block_comment] = STATE(6173),
    [sym_line_comment] = STATE(6173),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6174] = {
    [sym_block_comment] = STATE(6174),
    [sym_line_comment] = STATE(6174),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6175] = {
    [sym_block_comment] = STATE(6175),
    [sym_line_comment] = STATE(6175),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6176] = {
    [sym_block_comment] = STATE(6176),
    [sym_line_comment] = STATE(6176),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6177] = {
    [sym_block_comment] = STATE(6177),
    [sym_line_comment] = STATE(6177),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6178] = {
    [sym_block_comment] = STATE(6178),
    [sym_line_comment] = STATE(6178),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6179] = {
    [sym_block_comment] = STATE(6179),
    [sym_line_comment] = STATE(6179),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6180] = {
    [sym_block_comment] = STATE(6180),
    [sym_line_comment] = STATE(6180),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [6181] = {
    [sym_block_comment] = STATE(6181),
    [sym_line_comment] = STATE(6181),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [6182] = {
    [sym_block_comment] = STATE(6182),
    [sym_line_comment] = STATE(6182),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [6183] = {
    [sym_block_comment] = STATE(6183),
    [sym_line_comment] = STATE(6183),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6184] = {
    [sym_block_comment] = STATE(6184),
    [sym_line_comment] = STATE(6184),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6185] = {
    [sym_block_comment] = STATE(6185),
    [sym_line_comment] = STATE(6185),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6186] = {
    [sym_block_comment] = STATE(6186),
    [sym_line_comment] = STATE(6186),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6187] = {
    [sym_block_comment] = STATE(6187),
    [sym_line_comment] = STATE(6187),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6188] = {
    [sym_block_comment] = STATE(6188),
    [sym_line_comment] = STATE(6188),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6189] = {
    [sym_block_comment] = STATE(6189),
    [sym_line_comment] = STATE(6189),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6190] = {
    [sym_block_comment] = STATE(6190),
    [sym_line_comment] = STATE(6190),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6191] = {
    [sym_block_comment] = STATE(6191),
    [sym_line_comment] = STATE(6191),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6192] = {
    [sym_block_comment] = STATE(6192),
    [sym_line_comment] = STATE(6192),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [6193] = {
    [sym_block_comment] = STATE(6193),
    [sym_line_comment] = STATE(6193),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_end] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_catch] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10440),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10440),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10440),
    [anon_sym_SQUOTE] = ACTIONS(10615),
    [anon_sym_DOT] = ACTIONS(10617),
    [anon_sym_DOLLAR] = ACTIONS(10440),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10440),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10440),
    [anon_sym_QMARK] = ACTIONS(10440),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10440),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10440),
    [aux_sym_integer_literal_token2] = ACTIONS(10440),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10440),
    [aux_sym_float_literal_token3] = ACTIONS(10440),
    [aux_sym_float_literal_token4] = ACTIONS(10440),
    [sym_character_literal] = ACTIONS(10440),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10440),
    [sym__pair_operator] = ACTIONS(10440),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10440),
    [sym__lazy_and_operator] = ACTIONS(10440),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10440),
    [sym__pipe_left_operator] = ACTIONS(10440),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10440),
    [sym__bitshift_operator] = ACTIONS(10440),
    [sym__power_operator] = ACTIONS(10440),
    [sym__tilde_operator] = ACTIONS(10440),
    [sym__type_order_operator] = ACTIONS(10440),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym__terminator_token1] = ACTIONS(10525),
    [aux_sym__terminator_token2] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10619),
    [sym__immediate_bracket] = ACTIONS(10621),
    [sym__immediate_brace] = ACTIONS(10623),
  },
  [6194] = {
    [sym_block_comment] = STATE(6194),
    [sym_line_comment] = STATE(6194),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_DASH_GT] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6195] = {
    [sym_block_comment] = STATE(6195),
    [sym_line_comment] = STATE(6195),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [6196] = {
    [sym_block_comment] = STATE(6196),
    [sym_line_comment] = STATE(6196),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_catch] = ACTIONS(10086),
    [anon_sym_finally] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6197] = {
    [sym_block_comment] = STATE(6197),
    [sym_line_comment] = STATE(6197),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [6198] = {
    [sym_block_comment] = STATE(6198),
    [sym_line_comment] = STATE(6198),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [6199] = {
    [sym_block_comment] = STATE(6199),
    [sym_line_comment] = STATE(6199),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6200] = {
    [sym_block_comment] = STATE(6200),
    [sym_line_comment] = STATE(6200),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [6201] = {
    [sym_block_comment] = STATE(6201),
    [sym_line_comment] = STATE(6201),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_DASH_GT] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6202] = {
    [sym_block_comment] = STATE(6202),
    [sym_line_comment] = STATE(6202),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6203] = {
    [sym_block_comment] = STATE(6203),
    [sym_line_comment] = STATE(6203),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_DASH_GT] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6204] = {
    [sym_block_comment] = STATE(6204),
    [sym_line_comment] = STATE(6204),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10537),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_end] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_catch] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10537),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10537),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10537),
    [anon_sym_SQUOTE] = ACTIONS(10615),
    [anon_sym_DOT] = ACTIONS(10617),
    [anon_sym_DOLLAR] = ACTIONS(10537),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10537),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10537),
    [anon_sym_QMARK] = ACTIONS(10537),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10537),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10537),
    [aux_sym_integer_literal_token2] = ACTIONS(10537),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10537),
    [aux_sym_float_literal_token3] = ACTIONS(10537),
    [aux_sym_float_literal_token4] = ACTIONS(10537),
    [sym_character_literal] = ACTIONS(10537),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10537),
    [sym__pair_operator] = ACTIONS(10537),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10537),
    [sym__lazy_and_operator] = ACTIONS(10537),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10537),
    [sym__pipe_left_operator] = ACTIONS(10537),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10537),
    [sym__bitshift_operator] = ACTIONS(10537),
    [sym__power_operator] = ACTIONS(10537),
    [sym__tilde_operator] = ACTIONS(10537),
    [sym__type_order_operator] = ACTIONS(10537),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym__terminator_token1] = ACTIONS(10539),
    [aux_sym__terminator_token2] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10619),
    [sym__immediate_bracket] = ACTIONS(10621),
    [sym__immediate_brace] = ACTIONS(10623),
  },
  [6205] = {
    [sym_block_comment] = STATE(6205),
    [sym_line_comment] = STATE(6205),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_finally] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [6206] = {
    [sym_block_comment] = STATE(6206),
    [sym_line_comment] = STATE(6206),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6207] = {
    [sym_block_comment] = STATE(6207),
    [sym_line_comment] = STATE(6207),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_finally] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6208] = {
    [sym_block_comment] = STATE(6208),
    [sym_line_comment] = STATE(6208),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6209] = {
    [sym_block_comment] = STATE(6209),
    [sym_line_comment] = STATE(6209),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6210] = {
    [sym_block_comment] = STATE(6210),
    [sym_line_comment] = STATE(6210),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_finally] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [6211] = {
    [sym_block_comment] = STATE(6211),
    [sym_line_comment] = STATE(6211),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_finally] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [6212] = {
    [sym_block_comment] = STATE(6212),
    [sym_line_comment] = STATE(6212),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_finally] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [6213] = {
    [sym_block_comment] = STATE(6213),
    [sym_line_comment] = STATE(6213),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_finally] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6214] = {
    [sym_block_comment] = STATE(6214),
    [sym_line_comment] = STATE(6214),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6215] = {
    [sym_block_comment] = STATE(6215),
    [sym_line_comment] = STATE(6215),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_finally] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [6216] = {
    [sym_block_comment] = STATE(6216),
    [sym_line_comment] = STATE(6216),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6217] = {
    [sym_block_comment] = STATE(6217),
    [sym_line_comment] = STATE(6217),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_finally] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [6218] = {
    [sym_block_comment] = STATE(6218),
    [sym_line_comment] = STATE(6218),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6219] = {
    [sym_block_comment] = STATE(6219),
    [sym_line_comment] = STATE(6219),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_finally] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [6220] = {
    [sym_block_comment] = STATE(6220),
    [sym_line_comment] = STATE(6220),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_finally] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6221] = {
    [sym_block_comment] = STATE(6221),
    [sym_line_comment] = STATE(6221),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_finally] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6222] = {
    [sym_block_comment] = STATE(6222),
    [sym_line_comment] = STATE(6222),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_finally] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6223] = {
    [sym_block_comment] = STATE(6223),
    [sym_line_comment] = STATE(6223),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_finally] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6224] = {
    [sym_block_comment] = STATE(6224),
    [sym_line_comment] = STATE(6224),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6225] = {
    [sym_block_comment] = STATE(6225),
    [sym_line_comment] = STATE(6225),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6226] = {
    [sym_block_comment] = STATE(6226),
    [sym_line_comment] = STATE(6226),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6227] = {
    [sym_block_comment] = STATE(6227),
    [sym_line_comment] = STATE(6227),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6228] = {
    [sym_block_comment] = STATE(6228),
    [sym_line_comment] = STATE(6228),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6229] = {
    [sym_block_comment] = STATE(6229),
    [sym_line_comment] = STATE(6229),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [6230] = {
    [sym_block_comment] = STATE(6230),
    [sym_line_comment] = STATE(6230),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6231] = {
    [sym_block_comment] = STATE(6231),
    [sym_line_comment] = STATE(6231),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6232] = {
    [sym_block_comment] = STATE(6232),
    [sym_line_comment] = STATE(6232),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6233] = {
    [sym_block_comment] = STATE(6233),
    [sym_line_comment] = STATE(6233),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6234] = {
    [sym_block_comment] = STATE(6234),
    [sym_line_comment] = STATE(6234),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6235] = {
    [sym_block_comment] = STATE(6235),
    [sym_line_comment] = STATE(6235),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_end] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_finally] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10440),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10440),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10440),
    [anon_sym_SQUOTE] = ACTIONS(10625),
    [anon_sym_DOT] = ACTIONS(10627),
    [anon_sym_DOLLAR] = ACTIONS(10440),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10440),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10440),
    [anon_sym_QMARK] = ACTIONS(10440),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10440),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10440),
    [aux_sym_integer_literal_token2] = ACTIONS(10440),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10440),
    [aux_sym_float_literal_token3] = ACTIONS(10440),
    [aux_sym_float_literal_token4] = ACTIONS(10440),
    [sym_character_literal] = ACTIONS(10440),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10440),
    [sym__pair_operator] = ACTIONS(10440),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10440),
    [sym__lazy_and_operator] = ACTIONS(10440),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10440),
    [sym__pipe_left_operator] = ACTIONS(10440),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10440),
    [sym__bitshift_operator] = ACTIONS(10440),
    [sym__power_operator] = ACTIONS(10440),
    [sym__tilde_operator] = ACTIONS(10440),
    [sym__type_order_operator] = ACTIONS(10440),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym__terminator_token1] = ACTIONS(10525),
    [aux_sym__terminator_token2] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10629),
    [sym__immediate_bracket] = ACTIONS(10631),
    [sym__immediate_brace] = ACTIONS(10633),
  },
  [6236] = {
    [sym_block_comment] = STATE(6236),
    [sym_line_comment] = STATE(6236),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6237] = {
    [sym_block_comment] = STATE(6237),
    [sym_line_comment] = STATE(6237),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_elseif] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10637),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6238] = {
    [sym_block_comment] = STATE(6238),
    [sym_line_comment] = STATE(6238),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10537),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_end] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_finally] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10537),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10537),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10537),
    [anon_sym_SQUOTE] = ACTIONS(10625),
    [anon_sym_DOT] = ACTIONS(10627),
    [anon_sym_DOLLAR] = ACTIONS(10537),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10537),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10537),
    [anon_sym_QMARK] = ACTIONS(10537),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10537),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10537),
    [aux_sym_integer_literal_token2] = ACTIONS(10537),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10537),
    [aux_sym_float_literal_token3] = ACTIONS(10537),
    [aux_sym_float_literal_token4] = ACTIONS(10537),
    [sym_character_literal] = ACTIONS(10537),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10537),
    [sym__pair_operator] = ACTIONS(10537),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10537),
    [sym__lazy_and_operator] = ACTIONS(10537),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10537),
    [sym__pipe_left_operator] = ACTIONS(10537),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10537),
    [sym__bitshift_operator] = ACTIONS(10537),
    [sym__power_operator] = ACTIONS(10537),
    [sym__tilde_operator] = ACTIONS(10537),
    [sym__type_order_operator] = ACTIONS(10537),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym__terminator_token1] = ACTIONS(10539),
    [aux_sym__terminator_token2] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10629),
    [sym__immediate_bracket] = ACTIONS(10631),
    [sym__immediate_brace] = ACTIONS(10633),
  },
  [6239] = {
    [sym_block_comment] = STATE(6239),
    [sym_line_comment] = STATE(6239),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6240] = {
    [sym_block_comment] = STATE(6240),
    [sym_line_comment] = STATE(6240),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [6241] = {
    [sym_block_comment] = STATE(6241),
    [sym_line_comment] = STATE(6241),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [6242] = {
    [sym_block_comment] = STATE(6242),
    [sym_line_comment] = STATE(6242),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [6243] = {
    [sym_block_comment] = STATE(6243),
    [sym_line_comment] = STATE(6243),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6244] = {
    [sym_block_comment] = STATE(6244),
    [sym_line_comment] = STATE(6244),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6245] = {
    [sym_block_comment] = STATE(6245),
    [sym_line_comment] = STATE(6245),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6246] = {
    [sym_block_comment] = STATE(6246),
    [sym_line_comment] = STATE(6246),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10641),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6247] = {
    [sym_block_comment] = STATE(6247),
    [sym_line_comment] = STATE(6247),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [6248] = {
    [sym_block_comment] = STATE(6248),
    [sym_line_comment] = STATE(6248),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6249] = {
    [sym_block_comment] = STATE(6249),
    [sym_line_comment] = STATE(6249),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_catch] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6250] = {
    [sym_block_comment] = STATE(6250),
    [sym_line_comment] = STATE(6250),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_DASH_GT] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10591),
    [sym__immediate_command_start] = ACTIONS(10593),
  },
  [6251] = {
    [sym_block_comment] = STATE(6251),
    [sym_line_comment] = STATE(6251),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6252] = {
    [sym_block_comment] = STATE(6252),
    [sym_line_comment] = STATE(6252),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10643),
    [sym__immediate_command_start] = ACTIONS(10645),
  },
  [6253] = {
    [sym_block_comment] = STATE(6253),
    [sym_line_comment] = STATE(6253),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [6254] = {
    [sym_block_comment] = STATE(6254),
    [sym_line_comment] = STATE(6254),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10647),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6255] = {
    [sym_block_comment] = STATE(6255),
    [sym_line_comment] = STATE(6255),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6256] = {
    [sym_do_clause] = STATE(6542),
    [sym_block_comment] = STATE(6256),
    [sym_line_comment] = STATE(6256),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9684),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9684),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9684),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10649),
    [anon_sym_DOLLAR] = ACTIONS(9684),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9684),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9684),
    [anon_sym_QMARK] = ACTIONS(9684),
    [anon_sym_DASH_GT] = ACTIONS(9684),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9684),
    [aux_sym_integer_literal_token2] = ACTIONS(9684),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9684),
    [aux_sym_float_literal_token3] = ACTIONS(9684),
    [aux_sym_float_literal_token4] = ACTIONS(9684),
    [sym_character_literal] = ACTIONS(9684),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9684),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9684),
    [sym__pair_operator] = ACTIONS(9684),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9684),
    [sym__lazy_and_operator] = ACTIONS(9684),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9684),
    [sym__pipe_left_operator] = ACTIONS(9684),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9684),
    [sym__bitshift_operator] = ACTIONS(9684),
    [sym__power_operator] = ACTIONS(9684),
    [sym__tilde_operator] = ACTIONS(9684),
    [sym__type_order_operator] = ACTIONS(9684),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [6257] = {
    [sym_block_comment] = STATE(6257),
    [sym_line_comment] = STATE(6257),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_DASH_GT] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10591),
    [sym__immediate_command_start] = ACTIONS(10593),
  },
  [6258] = {
    [sym_do_clause] = STATE(6544),
    [sym_block_comment] = STATE(6258),
    [sym_line_comment] = STATE(6258),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10649),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_DASH_GT] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6259] = {
    [sym_do_clause] = STATE(6552),
    [sym_block_comment] = STATE(6259),
    [sym_line_comment] = STATE(6259),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9700),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9700),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9700),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9700),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10649),
    [anon_sym_DOLLAR] = ACTIONS(9700),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9700),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9700),
    [anon_sym_QMARK] = ACTIONS(9700),
    [anon_sym_DASH_GT] = ACTIONS(9700),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9700),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9700),
    [aux_sym_integer_literal_token2] = ACTIONS(9700),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9700),
    [aux_sym_float_literal_token3] = ACTIONS(9700),
    [aux_sym_float_literal_token4] = ACTIONS(9700),
    [sym_character_literal] = ACTIONS(9700),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9700),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9700),
    [sym__pair_operator] = ACTIONS(9700),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9700),
    [sym__lazy_and_operator] = ACTIONS(9700),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9700),
    [sym__pipe_left_operator] = ACTIONS(9700),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9700),
    [sym__bitshift_operator] = ACTIONS(9700),
    [sym__power_operator] = ACTIONS(9700),
    [sym__tilde_operator] = ACTIONS(9700),
    [sym__type_order_operator] = ACTIONS(9700),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [6260] = {
    [sym_block_comment] = STATE(6260),
    [sym_line_comment] = STATE(6260),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6261] = {
    [sym_do_clause] = STATE(6560),
    [sym_block_comment] = STATE(6261),
    [sym_line_comment] = STATE(6261),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10649),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_DASH_GT] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6262] = {
    [sym_block_comment] = STATE(6262),
    [sym_line_comment] = STATE(6262),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6263] = {
    [sym_block_comment] = STATE(6263),
    [sym_line_comment] = STATE(6263),
    [ts_builtin_sym_end] = ACTIONS(10136),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_RBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6264] = {
    [sym_block_comment] = STATE(6264),
    [sym_line_comment] = STATE(6264),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9726),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9726),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9726),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9726),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9726),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9726),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9726),
    [anon_sym_QMARK] = ACTIONS(9726),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9726),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9726),
    [aux_sym_integer_literal_token2] = ACTIONS(9726),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9726),
    [aux_sym_float_literal_token3] = ACTIONS(9726),
    [aux_sym_float_literal_token4] = ACTIONS(9726),
    [sym_character_literal] = ACTIONS(9726),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9726),
    [sym__pair_operator] = ACTIONS(9726),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9726),
    [sym__lazy_and_operator] = ACTIONS(9726),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9726),
    [sym__pipe_left_operator] = ACTIONS(9726),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9726),
    [sym__bitshift_operator] = ACTIONS(9726),
    [sym__power_operator] = ACTIONS(9726),
    [sym__tilde_operator] = ACTIONS(9726),
    [sym__type_order_operator] = ACTIONS(9726),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym__terminator_token1] = ACTIONS(9756),
    [aux_sym__terminator_token2] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [6265] = {
    [sym_block_comment] = STATE(6265),
    [sym_line_comment] = STATE(6265),
    [ts_builtin_sym_end] = ACTIONS(9914),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_RBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [6266] = {
    [sym_block_comment] = STATE(6266),
    [sym_line_comment] = STATE(6266),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9744),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9744),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9744),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9744),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9744),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9744),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9744),
    [anon_sym_QMARK] = ACTIONS(9744),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9744),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9744),
    [aux_sym_integer_literal_token2] = ACTIONS(9744),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9744),
    [aux_sym_float_literal_token3] = ACTIONS(9744),
    [aux_sym_float_literal_token4] = ACTIONS(9744),
    [sym_character_literal] = ACTIONS(9744),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9744),
    [sym__pair_operator] = ACTIONS(9744),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9744),
    [sym__lazy_and_operator] = ACTIONS(9744),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9744),
    [sym__pipe_left_operator] = ACTIONS(9744),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9744),
    [sym__bitshift_operator] = ACTIONS(9744),
    [sym__power_operator] = ACTIONS(9744),
    [sym__tilde_operator] = ACTIONS(9744),
    [sym__type_order_operator] = ACTIONS(9744),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym__terminator_token1] = ACTIONS(9758),
    [aux_sym__terminator_token2] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [6267] = {
    [sym_block_comment] = STATE(6267),
    [sym_line_comment] = STATE(6267),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10643),
    [sym__immediate_command_start] = ACTIONS(10645),
  },
  [6268] = {
    [sym_block_comment] = STATE(6268),
    [sym_line_comment] = STATE(6268),
    [ts_builtin_sym_end] = ACTIONS(9980),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_RBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [6269] = {
    [sym_block_comment] = STATE(6269),
    [sym_line_comment] = STATE(6269),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [6270] = {
    [sym_block_comment] = STATE(6270),
    [sym_line_comment] = STATE(6270),
    [ts_builtin_sym_end] = ACTIONS(189),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6271] = {
    [sym_block_comment] = STATE(6271),
    [sym_line_comment] = STATE(6271),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [6272] = {
    [sym_block_comment] = STATE(6272),
    [sym_line_comment] = STATE(6272),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10322),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10322),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10322),
    [anon_sym_SQUOTE] = ACTIONS(10605),
    [anon_sym_DOT] = ACTIONS(10607),
    [anon_sym_DOLLAR] = ACTIONS(10322),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10322),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10322),
    [anon_sym_QMARK] = ACTIONS(10322),
    [anon_sym_DASH_GT] = ACTIONS(10322),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10322),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10322),
    [aux_sym_integer_literal_token2] = ACTIONS(10322),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10322),
    [aux_sym_float_literal_token3] = ACTIONS(10322),
    [aux_sym_float_literal_token4] = ACTIONS(10322),
    [sym_character_literal] = ACTIONS(10322),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10322),
    [sym__pair_operator] = ACTIONS(10322),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10322),
    [sym__lazy_and_operator] = ACTIONS(10322),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10322),
    [sym__pipe_left_operator] = ACTIONS(10322),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10322),
    [sym__bitshift_operator] = ACTIONS(10322),
    [sym__power_operator] = ACTIONS(10322),
    [sym__tilde_operator] = ACTIONS(10322),
    [sym__type_order_operator] = ACTIONS(10322),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym__terminator_token1] = ACTIONS(10328),
    [aux_sym__terminator_token2] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10609),
    [sym__immediate_bracket] = ACTIONS(10611),
    [sym__immediate_brace] = ACTIONS(10613),
  },
  [6273] = {
    [sym_block_comment] = STATE(6273),
    [sym_line_comment] = STATE(6273),
    [ts_builtin_sym_end] = ACTIONS(9928),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_RBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [6274] = {
    [sym_block_comment] = STATE(6274),
    [sym_line_comment] = STATE(6274),
    [ts_builtin_sym_end] = ACTIONS(9956),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_RBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [6275] = {
    [sym_block_comment] = STATE(6275),
    [sym_line_comment] = STATE(6275),
    [ts_builtin_sym_end] = ACTIONS(9964),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_RBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [6276] = {
    [sym_block_comment] = STATE(6276),
    [sym_line_comment] = STATE(6276),
    [ts_builtin_sym_end] = ACTIONS(9708),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_RBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [6277] = {
    [sym_block_comment] = STATE(6277),
    [sym_line_comment] = STATE(6277),
    [ts_builtin_sym_end] = ACTIONS(9712),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_RBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6278] = {
    [sym_block_comment] = STATE(6278),
    [sym_line_comment] = STATE(6278),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [6279] = {
    [sym_block_comment] = STATE(6279),
    [sym_line_comment] = STATE(6279),
    [ts_builtin_sym_end] = ACTIONS(10104),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_RBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [6280] = {
    [sym_block_comment] = STATE(6280),
    [sym_line_comment] = STATE(6280),
    [ts_builtin_sym_end] = ACTIONS(10108),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_RBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [6281] = {
    [sym_block_comment] = STATE(6281),
    [sym_line_comment] = STATE(6281),
    [ts_builtin_sym_end] = ACTIONS(10118),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_RBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [6282] = {
    [sym_block_comment] = STATE(6282),
    [sym_line_comment] = STATE(6282),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6283] = {
    [sym_block_comment] = STATE(6283),
    [sym_line_comment] = STATE(6283),
    [ts_builtin_sym_end] = ACTIONS(10124),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_RBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [6284] = {
    [sym_block_comment] = STATE(6284),
    [sym_line_comment] = STATE(6284),
    [ts_builtin_sym_end] = ACTIONS(9704),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_RBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6285] = {
    [sym_block_comment] = STATE(6285),
    [sym_line_comment] = STATE(6285),
    [ts_builtin_sym_end] = ACTIONS(10130),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_RBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6286] = {
    [sym_block_comment] = STATE(6286),
    [sym_line_comment] = STATE(6286),
    [ts_builtin_sym_end] = ACTIONS(10140),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_RBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6287] = {
    [sym_block_comment] = STATE(6287),
    [sym_line_comment] = STATE(6287),
    [ts_builtin_sym_end] = ACTIONS(10144),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_RBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6288] = {
    [sym_block_comment] = STATE(6288),
    [sym_line_comment] = STATE(6288),
    [ts_builtin_sym_end] = ACTIONS(10154),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_RBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6289] = {
    [sym_block_comment] = STATE(6289),
    [sym_line_comment] = STATE(6289),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9738),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9738),
    [anon_sym_QMARK] = ACTIONS(9738),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9738),
    [sym__lazy_and_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [6290] = {
    [sym_block_comment] = STATE(6290),
    [sym_line_comment] = STATE(6290),
    [ts_builtin_sym_end] = ACTIONS(9728),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_RBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6291] = {
    [sym_block_comment] = STATE(6291),
    [sym_line_comment] = STATE(6291),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9752),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9752),
    [anon_sym_QMARK] = ACTIONS(9752),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9752),
    [sym__lazy_and_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [6292] = {
    [sym_block_comment] = STATE(6292),
    [sym_line_comment] = STATE(6292),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9810),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9810),
    [anon_sym_QMARK] = ACTIONS(9810),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9810),
    [sym__lazy_and_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [6293] = {
    [sym_block_comment] = STATE(6293),
    [sym_line_comment] = STATE(6293),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9814),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9814),
    [anon_sym_QMARK] = ACTIONS(9814),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9814),
    [sym__lazy_and_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [6294] = {
    [sym_block_comment] = STATE(6294),
    [sym_line_comment] = STATE(6294),
    [ts_builtin_sym_end] = ACTIONS(9740),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6295] = {
    [sym_block_comment] = STATE(6295),
    [sym_line_comment] = STATE(6295),
    [ts_builtin_sym_end] = ACTIONS(9746),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_RBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6296] = {
    [sym_block_comment] = STATE(6296),
    [sym_line_comment] = STATE(6296),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_RPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_RBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_SEMI] = ACTIONS(9960),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_RBRACE] = ACTIONS(9960),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6297] = {
    [sym_block_comment] = STATE(6297),
    [sym_line_comment] = STATE(6297),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9818),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9818),
    [anon_sym_QMARK] = ACTIONS(9818),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9818),
    [sym__lazy_and_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [6298] = {
    [sym_block_comment] = STATE(6298),
    [sym_line_comment] = STATE(6298),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6299] = {
    [sym_block_comment] = STATE(6299),
    [sym_line_comment] = STATE(6299),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6300] = {
    [sym_block_comment] = STATE(6300),
    [sym_line_comment] = STATE(6300),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6301] = {
    [sym_block_comment] = STATE(6301),
    [sym_line_comment] = STATE(6301),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6302] = {
    [sym_block_comment] = STATE(6302),
    [sym_line_comment] = STATE(6302),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9790),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9790),
    [anon_sym_QMARK] = ACTIONS(9790),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9790),
    [sym__lazy_and_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [6303] = {
    [sym_block_comment] = STATE(6303),
    [sym_line_comment] = STATE(6303),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6304] = {
    [sym_block_comment] = STATE(6304),
    [sym_line_comment] = STATE(6304),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6305] = {
    [sym_block_comment] = STATE(6305),
    [sym_line_comment] = STATE(6305),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6306] = {
    [sym_block_comment] = STATE(6306),
    [sym_line_comment] = STATE(6306),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6307] = {
    [sym_block_comment] = STATE(6307),
    [sym_line_comment] = STATE(6307),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6308] = {
    [sym_block_comment] = STATE(6308),
    [sym_line_comment] = STATE(6308),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6309] = {
    [sym_block_comment] = STATE(6309),
    [sym_line_comment] = STATE(6309),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6310] = {
    [sym_block_comment] = STATE(6310),
    [sym_line_comment] = STATE(6310),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6311] = {
    [sym_block_comment] = STATE(6311),
    [sym_line_comment] = STATE(6311),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6312] = {
    [sym_block_comment] = STATE(6312),
    [sym_line_comment] = STATE(6312),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6313] = {
    [sym_block_comment] = STATE(6313),
    [sym_line_comment] = STATE(6313),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6314] = {
    [sym_block_comment] = STATE(6314),
    [sym_line_comment] = STATE(6314),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6315] = {
    [sym_block_comment] = STATE(6315),
    [sym_line_comment] = STATE(6315),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [6316] = {
    [sym_block_comment] = STATE(6316),
    [sym_line_comment] = STATE(6316),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6317] = {
    [sym_block_comment] = STATE(6317),
    [sym_line_comment] = STATE(6317),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6318] = {
    [sym_block_comment] = STATE(6318),
    [sym_line_comment] = STATE(6318),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6319] = {
    [sym_block_comment] = STATE(6319),
    [sym_line_comment] = STATE(6319),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6320] = {
    [sym_block_comment] = STATE(6320),
    [sym_line_comment] = STATE(6320),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6321] = {
    [sym_block_comment] = STATE(6321),
    [sym_line_comment] = STATE(6321),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6322] = {
    [sym_block_comment] = STATE(6322),
    [sym_line_comment] = STATE(6322),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6323] = {
    [sym_block_comment] = STATE(6323),
    [sym_line_comment] = STATE(6323),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6324] = {
    [sym_block_comment] = STATE(6324),
    [sym_line_comment] = STATE(6324),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6325] = {
    [sym_block_comment] = STATE(6325),
    [sym_line_comment] = STATE(6325),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [6326] = {
    [sym_block_comment] = STATE(6326),
    [sym_line_comment] = STATE(6326),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [6327] = {
    [sym_block_comment] = STATE(6327),
    [sym_line_comment] = STATE(6327),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [6328] = {
    [sym_block_comment] = STATE(6328),
    [sym_line_comment] = STATE(6328),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6329] = {
    [sym_block_comment] = STATE(6329),
    [sym_line_comment] = STATE(6329),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6330] = {
    [sym_block_comment] = STATE(6330),
    [sym_line_comment] = STATE(6330),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6331] = {
    [sym_block_comment] = STATE(6331),
    [sym_line_comment] = STATE(6331),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_RPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_RBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_SEMI] = ACTIONS(9708),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_RBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [6332] = {
    [sym_block_comment] = STATE(6332),
    [sym_line_comment] = STATE(6332),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10142),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10142),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10142),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10142),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10142),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10142),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10142),
    [anon_sym_QMARK] = ACTIONS(10142),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10142),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10142),
    [aux_sym_integer_literal_token2] = ACTIONS(10142),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10142),
    [aux_sym_float_literal_token3] = ACTIONS(10142),
    [aux_sym_float_literal_token4] = ACTIONS(10142),
    [sym_character_literal] = ACTIONS(10142),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10142),
    [sym__pair_operator] = ACTIONS(10142),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10142),
    [sym__lazy_and_operator] = ACTIONS(10142),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10142),
    [sym__pipe_left_operator] = ACTIONS(10142),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10142),
    [sym__bitshift_operator] = ACTIONS(10142),
    [sym__power_operator] = ACTIONS(10142),
    [sym__tilde_operator] = ACTIONS(10142),
    [sym__type_order_operator] = ACTIONS(10142),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym__terminator_token1] = ACTIONS(10144),
    [aux_sym__terminator_token2] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6333] = {
    [sym_block_comment] = STATE(6333),
    [sym_line_comment] = STATE(6333),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6334] = {
    [sym_block_comment] = STATE(6334),
    [sym_line_comment] = STATE(6334),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
    [sym__immediate_string_start] = ACTIONS(10651),
    [sym__immediate_command_start] = ACTIONS(10653),
  },
  [6335] = {
    [sym_block_comment] = STATE(6335),
    [sym_line_comment] = STATE(6335),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6336] = {
    [sym_block_comment] = STATE(6336),
    [sym_line_comment] = STATE(6336),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_catch] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [6337] = {
    [sym_block_comment] = STATE(6337),
    [sym_line_comment] = STATE(6337),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10655),
    [sym__immediate_command_start] = ACTIONS(10657),
  },
  [6338] = {
    [sym_block_comment] = STATE(6338),
    [sym_line_comment] = STATE(6338),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6339] = {
    [sym_block_comment] = STATE(6339),
    [sym_line_comment] = STATE(6339),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10659),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6340] = {
    [sym_identifier] = STATE(6502),
    [sym_block_comment] = STATE(6340),
    [sym_line_comment] = STATE(6340),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6341] = {
    [sym_identifier] = STATE(6505),
    [sym_block_comment] = STATE(6341),
    [sym_line_comment] = STATE(6341),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6342] = {
    [sym_identifier] = STATE(6510),
    [sym_block_comment] = STATE(6342),
    [sym_line_comment] = STATE(6342),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6343] = {
    [sym_identifier] = STATE(6511),
    [sym_block_comment] = STATE(6343),
    [sym_line_comment] = STATE(6343),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6344] = {
    [sym_block_comment] = STATE(6344),
    [sym_line_comment] = STATE(6344),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_DASH_GT] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10661),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6345] = {
    [sym_block_comment] = STATE(6345),
    [sym_line_comment] = STATE(6345),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6346] = {
    [sym_block_comment] = STATE(6346),
    [sym_line_comment] = STATE(6346),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6347] = {
    [sym_block_comment] = STATE(6347),
    [sym_line_comment] = STATE(6347),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6348] = {
    [sym_identifier] = STATE(6523),
    [sym_block_comment] = STATE(6348),
    [sym_line_comment] = STATE(6348),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_DASH_GT] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [6349] = {
    [sym_identifier] = STATE(6531),
    [sym_block_comment] = STATE(6349),
    [sym_line_comment] = STATE(6349),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_DASH_GT] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [6350] = {
    [sym_identifier] = STATE(6543),
    [sym_block_comment] = STATE(6350),
    [sym_line_comment] = STATE(6350),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_DASH_GT] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [6351] = {
    [sym_identifier] = STATE(6545),
    [sym_block_comment] = STATE(6351),
    [sym_line_comment] = STATE(6351),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_DASH_GT] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [6352] = {
    [sym_block_comment] = STATE(6352),
    [sym_line_comment] = STATE(6352),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6353] = {
    [sym_block_comment] = STATE(6353),
    [sym_line_comment] = STATE(6353),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [6354] = {
    [sym_block_comment] = STATE(6354),
    [sym_line_comment] = STATE(6354),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6355] = {
    [sym_block_comment] = STATE(6355),
    [sym_line_comment] = STATE(6355),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10663),
    [sym__immediate_command_start] = ACTIONS(10665),
  },
  [6356] = {
    [sym_block_comment] = STATE(6356),
    [sym_line_comment] = STATE(6356),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10667),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6357] = {
    [sym_block_comment] = STATE(6357),
    [sym_line_comment] = STATE(6357),
    [ts_builtin_sym_end] = ACTIONS(10639),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_RBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10669),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6358] = {
    [sym_do_clause] = STATE(7050),
    [sym_block_comment] = STATE(6358),
    [sym_line_comment] = STATE(6358),
    [sym__word_identifier] = ACTIONS(9680),
    [anon_sym_COMMA] = ACTIONS(9684),
    [anon_sym_EQ] = ACTIONS(9680),
    [anon_sym_begin] = ACTIONS(9680),
    [anon_sym_module] = ACTIONS(9680),
    [anon_sym_baremodule] = ACTIONS(9680),
    [anon_sym_end] = ACTIONS(9680),
    [anon_sym_abstract] = ACTIONS(9680),
    [anon_sym_primitive] = ACTIONS(9680),
    [anon_sym_mutable] = ACTIONS(9680),
    [anon_sym_struct] = ACTIONS(9680),
    [anon_sym_function] = ACTIONS(9680),
    [anon_sym_macro] = ACTIONS(9680),
    [anon_sym_quote] = ACTIONS(9680),
    [anon_sym_let] = ACTIONS(9680),
    [anon_sym_if] = ACTIONS(9680),
    [anon_sym_try] = ACTIONS(9680),
    [anon_sym_for] = ACTIONS(9680),
    [anon_sym_while] = ACTIONS(9680),
    [sym_break_statement] = ACTIONS(9680),
    [sym_continue_statement] = ACTIONS(9680),
    [anon_sym_return] = ACTIONS(9680),
    [anon_sym_const] = ACTIONS(9680),
    [anon_sym_global] = ACTIONS(9680),
    [anon_sym_local] = ACTIONS(9680),
    [anon_sym_LPAREN] = ACTIONS(9684),
    [anon_sym_COLON] = ACTIONS(9680),
    [anon_sym_export] = ACTIONS(9680),
    [anon_sym_public] = ACTIONS(9680),
    [anon_sym_import] = ACTIONS(9680),
    [anon_sym_using] = ACTIONS(9680),
    [anon_sym_LBRACK] = ACTIONS(9684),
    [anon_sym_in] = ACTIONS(9680),
    [anon_sym_LBRACE] = ACTIONS(9684),
    [anon_sym_SQUOTE] = ACTIONS(9680),
    [anon_sym_DOT] = ACTIONS(9680),
    [anon_sym_do] = ACTIONS(10671),
    [anon_sym_DOLLAR] = ACTIONS(9684),
    [anon_sym_COLON2] = ACTIONS(9680),
    [anon_sym_COLON_COLON] = ACTIONS(9684),
    [anon_sym_isa] = ACTIONS(9680),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9684),
    [anon_sym_QMARK] = ACTIONS(9684),
    [anon_sym_where] = ACTIONS(9680),
    [anon_sym_AT] = ACTIONS(9684),
    [anon_sym_true] = ACTIONS(9680),
    [anon_sym_false] = ACTIONS(9680),
    [aux_sym_integer_literal_token1] = ACTIONS(9684),
    [aux_sym_integer_literal_token2] = ACTIONS(9684),
    [aux_sym_integer_literal_token3] = ACTIONS(9680),
    [aux_sym_integer_literal_token4] = ACTIONS(9680),
    [aux_sym_float_literal_token1] = ACTIONS(9684),
    [aux_sym_float_literal_token3] = ACTIONS(9684),
    [aux_sym_float_literal_token4] = ACTIONS(9684),
    [sym_character_literal] = ACTIONS(9684),
    [anon_sym_DQUOTE] = ACTIONS(9680),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9684),
    [anon_sym_BQUOTE] = ACTIONS(9680),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9684),
    [sym__pair_operator] = ACTIONS(9684),
    [sym__arrow_operator] = ACTIONS(9680),
    [sym__lazy_or_operator] = ACTIONS(9684),
    [sym__lazy_and_operator] = ACTIONS(9684),
    [sym__comparison_operator] = ACTIONS(9680),
    [sym__pipe_right_operator] = ACTIONS(9684),
    [sym__pipe_left_operator] = ACTIONS(9684),
    [sym__ellipsis_operator] = ACTIONS(9680),
    [sym__plus_operator] = ACTIONS(9680),
    [sym__times_operator] = ACTIONS(9680),
    [sym__rational_operator] = ACTIONS(9684),
    [sym__bitshift_operator] = ACTIONS(9684),
    [sym__power_operator] = ACTIONS(9684),
    [sym__tilde_operator] = ACTIONS(9684),
    [sym__type_order_operator] = ACTIONS(9684),
    [sym__unary_operator] = ACTIONS(9680),
    [sym__unary_plus_operator] = ACTIONS(9680),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9684),
    [sym__immediate_bracket] = ACTIONS(9684),
    [sym__immediate_brace] = ACTIONS(9684),
  },
  [6359] = {
    [sym_block_comment] = STATE(6359),
    [sym_line_comment] = STATE(6359),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
    [sym__immediate_string_start] = ACTIONS(10651),
    [sym__immediate_command_start] = ACTIONS(10653),
  },
  [6360] = {
    [sym_do_clause] = STATE(7051),
    [sym_block_comment] = STATE(6360),
    [sym_line_comment] = STATE(6360),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_do] = ACTIONS(10671),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6361] = {
    [sym_block_comment] = STATE(6361),
    [sym_line_comment] = STATE(6361),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6362] = {
    [sym_block_comment] = STATE(6362),
    [sym_line_comment] = STATE(6362),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10440),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_end] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10440),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10440),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10440),
    [anon_sym_SQUOTE] = ACTIONS(10673),
    [anon_sym_DOT] = ACTIONS(10675),
    [anon_sym_DOLLAR] = ACTIONS(10440),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10440),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10440),
    [anon_sym_QMARK] = ACTIONS(10440),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10440),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10440),
    [aux_sym_integer_literal_token2] = ACTIONS(10440),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10440),
    [aux_sym_float_literal_token3] = ACTIONS(10440),
    [aux_sym_float_literal_token4] = ACTIONS(10440),
    [sym_character_literal] = ACTIONS(10440),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10440),
    [sym__pair_operator] = ACTIONS(10440),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10440),
    [sym__lazy_and_operator] = ACTIONS(10440),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10440),
    [sym__pipe_left_operator] = ACTIONS(10440),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10440),
    [sym__bitshift_operator] = ACTIONS(10440),
    [sym__power_operator] = ACTIONS(10440),
    [sym__tilde_operator] = ACTIONS(10440),
    [sym__type_order_operator] = ACTIONS(10440),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym__terminator_token1] = ACTIONS(10525),
    [aux_sym__terminator_token2] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10677),
    [sym__immediate_bracket] = ACTIONS(10679),
    [sym__immediate_brace] = ACTIONS(10681),
  },
  [6363] = {
    [sym_do_clause] = STATE(7053),
    [sym_block_comment] = STATE(6363),
    [sym_line_comment] = STATE(6363),
    [sym__word_identifier] = ACTIONS(9696),
    [anon_sym_COMMA] = ACTIONS(9700),
    [anon_sym_EQ] = ACTIONS(9696),
    [anon_sym_begin] = ACTIONS(9696),
    [anon_sym_module] = ACTIONS(9696),
    [anon_sym_baremodule] = ACTIONS(9696),
    [anon_sym_end] = ACTIONS(9696),
    [anon_sym_abstract] = ACTIONS(9696),
    [anon_sym_primitive] = ACTIONS(9696),
    [anon_sym_mutable] = ACTIONS(9696),
    [anon_sym_struct] = ACTIONS(9696),
    [anon_sym_function] = ACTIONS(9696),
    [anon_sym_macro] = ACTIONS(9696),
    [anon_sym_quote] = ACTIONS(9696),
    [anon_sym_let] = ACTIONS(9696),
    [anon_sym_if] = ACTIONS(9696),
    [anon_sym_try] = ACTIONS(9696),
    [anon_sym_for] = ACTIONS(9696),
    [anon_sym_while] = ACTIONS(9696),
    [sym_break_statement] = ACTIONS(9696),
    [sym_continue_statement] = ACTIONS(9696),
    [anon_sym_return] = ACTIONS(9696),
    [anon_sym_const] = ACTIONS(9696),
    [anon_sym_global] = ACTIONS(9696),
    [anon_sym_local] = ACTIONS(9696),
    [anon_sym_LPAREN] = ACTIONS(9700),
    [anon_sym_COLON] = ACTIONS(9696),
    [anon_sym_export] = ACTIONS(9696),
    [anon_sym_public] = ACTIONS(9696),
    [anon_sym_import] = ACTIONS(9696),
    [anon_sym_using] = ACTIONS(9696),
    [anon_sym_LBRACK] = ACTIONS(9700),
    [anon_sym_in] = ACTIONS(9696),
    [anon_sym_LBRACE] = ACTIONS(9700),
    [anon_sym_SQUOTE] = ACTIONS(9696),
    [anon_sym_DOT] = ACTIONS(9696),
    [anon_sym_do] = ACTIONS(10671),
    [anon_sym_DOLLAR] = ACTIONS(9700),
    [anon_sym_COLON2] = ACTIONS(9696),
    [anon_sym_COLON_COLON] = ACTIONS(9700),
    [anon_sym_isa] = ACTIONS(9696),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9700),
    [anon_sym_QMARK] = ACTIONS(9700),
    [anon_sym_where] = ACTIONS(9696),
    [anon_sym_AT] = ACTIONS(9700),
    [anon_sym_true] = ACTIONS(9696),
    [anon_sym_false] = ACTIONS(9696),
    [aux_sym_integer_literal_token1] = ACTIONS(9700),
    [aux_sym_integer_literal_token2] = ACTIONS(9700),
    [aux_sym_integer_literal_token3] = ACTIONS(9696),
    [aux_sym_integer_literal_token4] = ACTIONS(9696),
    [aux_sym_float_literal_token1] = ACTIONS(9700),
    [aux_sym_float_literal_token3] = ACTIONS(9700),
    [aux_sym_float_literal_token4] = ACTIONS(9700),
    [sym_character_literal] = ACTIONS(9700),
    [anon_sym_DQUOTE] = ACTIONS(9696),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9700),
    [anon_sym_BQUOTE] = ACTIONS(9696),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9700),
    [sym__pair_operator] = ACTIONS(9700),
    [sym__arrow_operator] = ACTIONS(9696),
    [sym__lazy_or_operator] = ACTIONS(9700),
    [sym__lazy_and_operator] = ACTIONS(9700),
    [sym__comparison_operator] = ACTIONS(9696),
    [sym__pipe_right_operator] = ACTIONS(9700),
    [sym__pipe_left_operator] = ACTIONS(9700),
    [sym__ellipsis_operator] = ACTIONS(9696),
    [sym__plus_operator] = ACTIONS(9696),
    [sym__times_operator] = ACTIONS(9696),
    [sym__rational_operator] = ACTIONS(9700),
    [sym__bitshift_operator] = ACTIONS(9700),
    [sym__power_operator] = ACTIONS(9700),
    [sym__tilde_operator] = ACTIONS(9700),
    [sym__type_order_operator] = ACTIONS(9700),
    [sym__unary_operator] = ACTIONS(9696),
    [sym__unary_plus_operator] = ACTIONS(9696),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9700),
    [sym__immediate_bracket] = ACTIONS(9700),
    [sym__immediate_brace] = ACTIONS(9700),
  },
  [6364] = {
    [sym_block_comment] = STATE(6364),
    [sym_line_comment] = STATE(6364),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_elseif] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6365] = {
    [sym_do_clause] = STATE(7057),
    [sym_block_comment] = STATE(6365),
    [sym_line_comment] = STATE(6365),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_do] = ACTIONS(10671),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6366] = {
    [sym_block_comment] = STATE(6366),
    [sym_line_comment] = STATE(6366),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6367] = {
    [sym_block_comment] = STATE(6367),
    [sym_line_comment] = STATE(6367),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6368] = {
    [sym_block_comment] = STATE(6368),
    [sym_line_comment] = STATE(6368),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10537),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_end] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10537),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10537),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10537),
    [anon_sym_SQUOTE] = ACTIONS(10673),
    [anon_sym_DOT] = ACTIONS(10675),
    [anon_sym_DOLLAR] = ACTIONS(10537),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10537),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10537),
    [anon_sym_QMARK] = ACTIONS(10537),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10537),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10537),
    [aux_sym_integer_literal_token2] = ACTIONS(10537),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10537),
    [aux_sym_float_literal_token3] = ACTIONS(10537),
    [aux_sym_float_literal_token4] = ACTIONS(10537),
    [sym_character_literal] = ACTIONS(10537),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10537),
    [sym__pair_operator] = ACTIONS(10537),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10537),
    [sym__lazy_and_operator] = ACTIONS(10537),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10537),
    [sym__pipe_left_operator] = ACTIONS(10537),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10537),
    [sym__bitshift_operator] = ACTIONS(10537),
    [sym__power_operator] = ACTIONS(10537),
    [sym__tilde_operator] = ACTIONS(10537),
    [sym__type_order_operator] = ACTIONS(10537),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym__terminator_token1] = ACTIONS(10539),
    [aux_sym__terminator_token2] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10677),
    [sym__immediate_bracket] = ACTIONS(10679),
    [sym__immediate_brace] = ACTIONS(10681),
  },
  [6369] = {
    [sym_block_comment] = STATE(6369),
    [sym_line_comment] = STATE(6369),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6370] = {
    [sym_block_comment] = STATE(6370),
    [sym_line_comment] = STATE(6370),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6371] = {
    [sym_block_comment] = STATE(6371),
    [sym_line_comment] = STATE(6371),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6372] = {
    [sym_block_comment] = STATE(6372),
    [sym_line_comment] = STATE(6372),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10655),
    [sym__immediate_command_start] = ACTIONS(10657),
  },
  [6373] = {
    [sym_block_comment] = STATE(6373),
    [sym_line_comment] = STATE(6373),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [6374] = {
    [sym_block_comment] = STATE(6374),
    [sym_line_comment] = STATE(6374),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6375] = {
    [sym_block_comment] = STATE(6375),
    [sym_line_comment] = STATE(6375),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6376] = {
    [sym_block_comment] = STATE(6376),
    [sym_line_comment] = STATE(6376),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [6377] = {
    [sym_block_comment] = STATE(6377),
    [sym_line_comment] = STATE(6377),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10683),
    [sym__immediate_command_start] = ACTIONS(10685),
  },
  [6378] = {
    [sym__primary_expression] = STATE(11841),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(11497),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(6378),
    [sym_line_comment] = STATE(6378),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(10687),
    [anon_sym_COLON2] = ACTIONS(10689),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6379] = {
    [sym_block_comment] = STATE(6379),
    [sym_line_comment] = STATE(6379),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10691),
    [sym__immediate_command_start] = ACTIONS(10693),
  },
  [6380] = {
    [sym_block_comment] = STATE(6380),
    [sym_line_comment] = STATE(6380),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9978),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9978),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9978),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9978),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9978),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9978),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9978),
    [anon_sym_QMARK] = ACTIONS(9978),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9978),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9978),
    [aux_sym_integer_literal_token2] = ACTIONS(9978),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9978),
    [aux_sym_float_literal_token3] = ACTIONS(9978),
    [aux_sym_float_literal_token4] = ACTIONS(9978),
    [sym_character_literal] = ACTIONS(9978),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9978),
    [sym__pair_operator] = ACTIONS(9978),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9978),
    [sym__lazy_and_operator] = ACTIONS(9978),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9978),
    [sym__pipe_left_operator] = ACTIONS(9978),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9978),
    [sym__bitshift_operator] = ACTIONS(9978),
    [sym__power_operator] = ACTIONS(9978),
    [sym__tilde_operator] = ACTIONS(9978),
    [sym__type_order_operator] = ACTIONS(9978),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym__terminator_token1] = ACTIONS(9980),
    [aux_sym__terminator_token2] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [6381] = {
    [sym_block_comment] = STATE(6381),
    [sym_line_comment] = STATE(6381),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(101),
    [aux_sym_integer_literal_token2] = ACTIONS(101),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(101),
    [aux_sym_float_literal_token3] = ACTIONS(101),
    [aux_sym_float_literal_token4] = ACTIONS(101),
    [sym_character_literal] = ACTIONS(101),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(101),
    [sym__pair_operator] = ACTIONS(101),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(101),
    [sym__lazy_and_operator] = ACTIONS(101),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(101),
    [sym__pipe_left_operator] = ACTIONS(101),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(101),
    [sym__bitshift_operator] = ACTIONS(101),
    [sym__power_operator] = ACTIONS(101),
    [sym__tilde_operator] = ACTIONS(101),
    [sym__type_order_operator] = ACTIONS(101),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym__terminator_token1] = ACTIONS(189),
    [aux_sym__terminator_token2] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6382] = {
    [sym_block_comment] = STATE(6382),
    [sym_line_comment] = STATE(6382),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [6383] = {
    [sym_block_comment] = STATE(6383),
    [sym_line_comment] = STATE(6383),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6384] = {
    [sym_block_comment] = STATE(6384),
    [sym_line_comment] = STATE(6384),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [6385] = {
    [sym_block_comment] = STATE(6385),
    [sym_line_comment] = STATE(6385),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9756),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9756),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9756),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9756),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9756),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9756),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9756),
    [anon_sym_QMARK] = ACTIONS(9756),
    [anon_sym_DASH_GT] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9756),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9756),
    [aux_sym_integer_literal_token2] = ACTIONS(9756),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9756),
    [aux_sym_float_literal_token3] = ACTIONS(9756),
    [aux_sym_float_literal_token4] = ACTIONS(9756),
    [sym_character_literal] = ACTIONS(9756),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9756),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9756),
    [sym__pair_operator] = ACTIONS(9756),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9756),
    [sym__lazy_and_operator] = ACTIONS(9756),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9756),
    [sym__pipe_left_operator] = ACTIONS(9756),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9756),
    [sym__bitshift_operator] = ACTIONS(9756),
    [sym__power_operator] = ACTIONS(9756),
    [sym__tilde_operator] = ACTIONS(9756),
    [sym__type_order_operator] = ACTIONS(9756),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [6386] = {
    [sym_block_comment] = STATE(6386),
    [sym_line_comment] = STATE(6386),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9954),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9954),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9954),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9954),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9954),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9954),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9954),
    [anon_sym_QMARK] = ACTIONS(9954),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9954),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9954),
    [aux_sym_integer_literal_token2] = ACTIONS(9954),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9954),
    [aux_sym_float_literal_token3] = ACTIONS(9954),
    [aux_sym_float_literal_token4] = ACTIONS(9954),
    [sym_character_literal] = ACTIONS(9954),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9954),
    [sym__pair_operator] = ACTIONS(9954),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9954),
    [sym__lazy_and_operator] = ACTIONS(9954),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9954),
    [sym__pipe_left_operator] = ACTIONS(9954),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9954),
    [sym__bitshift_operator] = ACTIONS(9954),
    [sym__power_operator] = ACTIONS(9954),
    [sym__tilde_operator] = ACTIONS(9954),
    [sym__type_order_operator] = ACTIONS(9954),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym__terminator_token1] = ACTIONS(9956),
    [aux_sym__terminator_token2] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [6387] = {
    [sym_block_comment] = STATE(6387),
    [sym_line_comment] = STATE(6387),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9962),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9962),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9962),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9962),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9962),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9962),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9962),
    [anon_sym_QMARK] = ACTIONS(9962),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9962),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9962),
    [aux_sym_integer_literal_token2] = ACTIONS(9962),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9962),
    [aux_sym_float_literal_token3] = ACTIONS(9962),
    [aux_sym_float_literal_token4] = ACTIONS(9962),
    [sym_character_literal] = ACTIONS(9962),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9962),
    [sym__pair_operator] = ACTIONS(9962),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9962),
    [sym__lazy_and_operator] = ACTIONS(9962),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9962),
    [sym__pipe_left_operator] = ACTIONS(9962),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9962),
    [sym__bitshift_operator] = ACTIONS(9962),
    [sym__power_operator] = ACTIONS(9962),
    [sym__tilde_operator] = ACTIONS(9962),
    [sym__type_order_operator] = ACTIONS(9962),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym__terminator_token1] = ACTIONS(9964),
    [aux_sym__terminator_token2] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [6388] = {
    [sym_block_comment] = STATE(6388),
    [sym_line_comment] = STATE(6388),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9758),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9758),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9758),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_DASH_GT] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9758),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9758),
    [aux_sym_integer_literal_token2] = ACTIONS(9758),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9758),
    [aux_sym_float_literal_token3] = ACTIONS(9758),
    [aux_sym_float_literal_token4] = ACTIONS(9758),
    [sym_character_literal] = ACTIONS(9758),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9758),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9758),
    [sym__pair_operator] = ACTIONS(9758),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9758),
    [sym__lazy_and_operator] = ACTIONS(9758),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9758),
    [sym__pipe_left_operator] = ACTIONS(9758),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9758),
    [sym__bitshift_operator] = ACTIONS(9758),
    [sym__power_operator] = ACTIONS(9758),
    [sym__tilde_operator] = ACTIONS(9758),
    [sym__type_order_operator] = ACTIONS(9758),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [6389] = {
    [sym_block_comment] = STATE(6389),
    [sym_line_comment] = STATE(6389),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
    [sym__immediate_string_start] = ACTIONS(10651),
    [sym__immediate_command_start] = ACTIONS(10653),
  },
  [6390] = {
    [sym_block_comment] = STATE(6390),
    [sym_line_comment] = STATE(6390),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9706),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9706),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9706),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9706),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9706),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9706),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9706),
    [anon_sym_QMARK] = ACTIONS(9706),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9706),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9706),
    [aux_sym_integer_literal_token2] = ACTIONS(9706),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9706),
    [aux_sym_float_literal_token3] = ACTIONS(9706),
    [aux_sym_float_literal_token4] = ACTIONS(9706),
    [sym_character_literal] = ACTIONS(9706),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9706),
    [sym__pair_operator] = ACTIONS(9706),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9706),
    [sym__lazy_and_operator] = ACTIONS(9706),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9706),
    [sym__pipe_left_operator] = ACTIONS(9706),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9706),
    [sym__bitshift_operator] = ACTIONS(9706),
    [sym__power_operator] = ACTIONS(9706),
    [sym__tilde_operator] = ACTIONS(9706),
    [sym__type_order_operator] = ACTIONS(9706),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym__terminator_token1] = ACTIONS(9708),
    [aux_sym__terminator_token2] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [6391] = {
    [sym_block_comment] = STATE(6391),
    [sym_line_comment] = STATE(6391),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9710),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9710),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9710),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9710),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9710),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9710),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9710),
    [anon_sym_QMARK] = ACTIONS(9710),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9710),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9710),
    [aux_sym_integer_literal_token2] = ACTIONS(9710),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9710),
    [aux_sym_float_literal_token3] = ACTIONS(9710),
    [aux_sym_float_literal_token4] = ACTIONS(9710),
    [sym_character_literal] = ACTIONS(9710),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9710),
    [sym__pair_operator] = ACTIONS(9710),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9710),
    [sym__lazy_and_operator] = ACTIONS(9710),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9710),
    [sym__pipe_left_operator] = ACTIONS(9710),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9710),
    [sym__bitshift_operator] = ACTIONS(9710),
    [sym__power_operator] = ACTIONS(9710),
    [sym__tilde_operator] = ACTIONS(9710),
    [sym__type_order_operator] = ACTIONS(9710),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym__terminator_token1] = ACTIONS(9712),
    [aux_sym__terminator_token2] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6392] = {
    [sym_block_comment] = STATE(6392),
    [sym_line_comment] = STATE(6392),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10102),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10102),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10102),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10102),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10102),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10102),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10102),
    [anon_sym_QMARK] = ACTIONS(10102),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10102),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10102),
    [aux_sym_integer_literal_token2] = ACTIONS(10102),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10102),
    [aux_sym_float_literal_token3] = ACTIONS(10102),
    [aux_sym_float_literal_token4] = ACTIONS(10102),
    [sym_character_literal] = ACTIONS(10102),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10102),
    [sym__pair_operator] = ACTIONS(10102),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10102),
    [sym__lazy_and_operator] = ACTIONS(10102),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10102),
    [sym__pipe_left_operator] = ACTIONS(10102),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10102),
    [sym__bitshift_operator] = ACTIONS(10102),
    [sym__power_operator] = ACTIONS(10102),
    [sym__tilde_operator] = ACTIONS(10102),
    [sym__type_order_operator] = ACTIONS(10102),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym__terminator_token1] = ACTIONS(10104),
    [aux_sym__terminator_token2] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [6393] = {
    [sym_block_comment] = STATE(6393),
    [sym_line_comment] = STATE(6393),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10695),
    [sym__immediate_command_start] = ACTIONS(10697),
  },
  [6394] = {
    [sym_block_comment] = STATE(6394),
    [sym_line_comment] = STATE(6394),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10106),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10106),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10106),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10106),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10106),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10106),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10106),
    [anon_sym_QMARK] = ACTIONS(10106),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10106),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10106),
    [aux_sym_integer_literal_token2] = ACTIONS(10106),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10106),
    [aux_sym_float_literal_token3] = ACTIONS(10106),
    [aux_sym_float_literal_token4] = ACTIONS(10106),
    [sym_character_literal] = ACTIONS(10106),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10106),
    [sym__pair_operator] = ACTIONS(10106),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10106),
    [sym__lazy_and_operator] = ACTIONS(10106),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10106),
    [sym__pipe_left_operator] = ACTIONS(10106),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10106),
    [sym__bitshift_operator] = ACTIONS(10106),
    [sym__power_operator] = ACTIONS(10106),
    [sym__tilde_operator] = ACTIONS(10106),
    [sym__type_order_operator] = ACTIONS(10106),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym__terminator_token1] = ACTIONS(10108),
    [aux_sym__terminator_token2] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [6395] = {
    [sym_block_comment] = STATE(6395),
    [sym_line_comment] = STATE(6395),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [6396] = {
    [sym_block_comment] = STATE(6396),
    [sym_line_comment] = STATE(6396),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6397] = {
    [sym_block_comment] = STATE(6397),
    [sym_line_comment] = STATE(6397),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10122),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10122),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10122),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10122),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10122),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10122),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10122),
    [anon_sym_QMARK] = ACTIONS(10122),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10122),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10122),
    [aux_sym_integer_literal_token2] = ACTIONS(10122),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10122),
    [aux_sym_float_literal_token3] = ACTIONS(10122),
    [aux_sym_float_literal_token4] = ACTIONS(10122),
    [sym_character_literal] = ACTIONS(10122),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10122),
    [sym__pair_operator] = ACTIONS(10122),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10122),
    [sym__lazy_and_operator] = ACTIONS(10122),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10122),
    [sym__pipe_left_operator] = ACTIONS(10122),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10122),
    [sym__bitshift_operator] = ACTIONS(10122),
    [sym__power_operator] = ACTIONS(10122),
    [sym__tilde_operator] = ACTIONS(10122),
    [sym__type_order_operator] = ACTIONS(10122),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym__terminator_token1] = ACTIONS(10124),
    [aux_sym__terminator_token2] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [6398] = {
    [sym_block_comment] = STATE(6398),
    [sym_line_comment] = STATE(6398),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10683),
    [sym__immediate_command_start] = ACTIONS(10685),
  },
  [6399] = {
    [sym_block_comment] = STATE(6399),
    [sym_line_comment] = STATE(6399),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9702),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9702),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9702),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9702),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9702),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9702),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9702),
    [anon_sym_QMARK] = ACTIONS(9702),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9702),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9702),
    [aux_sym_integer_literal_token2] = ACTIONS(9702),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9702),
    [aux_sym_float_literal_token3] = ACTIONS(9702),
    [aux_sym_float_literal_token4] = ACTIONS(9702),
    [sym_character_literal] = ACTIONS(9702),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9702),
    [sym__pair_operator] = ACTIONS(9702),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9702),
    [sym__lazy_and_operator] = ACTIONS(9702),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9702),
    [sym__pipe_left_operator] = ACTIONS(9702),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9702),
    [sym__bitshift_operator] = ACTIONS(9702),
    [sym__power_operator] = ACTIONS(9702),
    [sym__tilde_operator] = ACTIONS(9702),
    [sym__type_order_operator] = ACTIONS(9702),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym__terminator_token1] = ACTIONS(9704),
    [aux_sym__terminator_token2] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6400] = {
    [sym_block_comment] = STATE(6400),
    [sym_line_comment] = STATE(6400),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10579),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10579),
    [anon_sym_RPAREN] = ACTIONS(10579),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10579),
    [anon_sym_RBRACK] = ACTIONS(10579),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_SEMI] = ACTIONS(10579),
    [anon_sym_LBRACE] = ACTIONS(10579),
    [anon_sym_RBRACE] = ACTIONS(10579),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10579),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10579),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10579),
    [anon_sym_QMARK] = ACTIONS(10579),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10579),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10579),
    [aux_sym_integer_literal_token2] = ACTIONS(10579),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10579),
    [aux_sym_float_literal_token3] = ACTIONS(10579),
    [aux_sym_float_literal_token4] = ACTIONS(10579),
    [sym_character_literal] = ACTIONS(10579),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10579),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10579),
    [sym__pair_operator] = ACTIONS(10579),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10579),
    [sym__lazy_and_operator] = ACTIONS(10579),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10579),
    [sym__pipe_left_operator] = ACTIONS(10579),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10579),
    [sym__bitshift_operator] = ACTIONS(10579),
    [sym__power_operator] = ACTIONS(10579),
    [sym__tilde_operator] = ACTIONS(10579),
    [sym__type_order_operator] = ACTIONS(10579),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [6401] = {
    [sym_block_comment] = STATE(6401),
    [sym_line_comment] = STATE(6401),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10128),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10128),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10128),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10128),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10128),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10128),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10128),
    [anon_sym_QMARK] = ACTIONS(10128),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10128),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10128),
    [aux_sym_integer_literal_token2] = ACTIONS(10128),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10128),
    [aux_sym_float_literal_token3] = ACTIONS(10128),
    [aux_sym_float_literal_token4] = ACTIONS(10128),
    [sym_character_literal] = ACTIONS(10128),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10128),
    [sym__pair_operator] = ACTIONS(10128),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10128),
    [sym__lazy_and_operator] = ACTIONS(10128),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10128),
    [sym__pipe_left_operator] = ACTIONS(10128),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10128),
    [sym__bitshift_operator] = ACTIONS(10128),
    [sym__power_operator] = ACTIONS(10128),
    [sym__tilde_operator] = ACTIONS(10128),
    [sym__type_order_operator] = ACTIONS(10128),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym__terminator_token1] = ACTIONS(10130),
    [aux_sym__terminator_token2] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6402] = {
    [sym_block_comment] = STATE(6402),
    [sym_line_comment] = STATE(6402),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10138),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10138),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10138),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10138),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10138),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10138),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10138),
    [anon_sym_QMARK] = ACTIONS(10138),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10138),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10138),
    [aux_sym_integer_literal_token2] = ACTIONS(10138),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10138),
    [aux_sym_float_literal_token3] = ACTIONS(10138),
    [aux_sym_float_literal_token4] = ACTIONS(10138),
    [sym_character_literal] = ACTIONS(10138),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10138),
    [sym__pair_operator] = ACTIONS(10138),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10138),
    [sym__lazy_and_operator] = ACTIONS(10138),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10138),
    [sym__pipe_left_operator] = ACTIONS(10138),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10138),
    [sym__bitshift_operator] = ACTIONS(10138),
    [sym__power_operator] = ACTIONS(10138),
    [sym__tilde_operator] = ACTIONS(10138),
    [sym__type_order_operator] = ACTIONS(10138),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym__terminator_token1] = ACTIONS(10140),
    [aux_sym__terminator_token2] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6403] = {
    [sym_block_comment] = STATE(6403),
    [sym_line_comment] = STATE(6403),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6404] = {
    [sym_block_comment] = STATE(6404),
    [sym_line_comment] = STATE(6404),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10663),
    [sym__immediate_command_start] = ACTIONS(10665),
  },
  [6405] = {
    [sym_block_comment] = STATE(6405),
    [sym_line_comment] = STATE(6405),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6406] = {
    [sym_block_comment] = STATE(6406),
    [sym_line_comment] = STATE(6406),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10699),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6407] = {
    [sym_block_comment] = STATE(6407),
    [sym_line_comment] = STATE(6407),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [6408] = {
    [sym_block_comment] = STATE(6408),
    [sym_line_comment] = STATE(6408),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_catch] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [6409] = {
    [sym_block_comment] = STATE(6409),
    [sym_line_comment] = STATE(6409),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6410] = {
    [sym_block_comment] = STATE(6410),
    [sym_line_comment] = STATE(6410),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6411] = {
    [sym_block_comment] = STATE(6411),
    [sym_line_comment] = STATE(6411),
    [ts_builtin_sym_end] = ACTIONS(10579),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_RBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [6412] = {
    [sym_block_comment] = STATE(6412),
    [sym_line_comment] = STATE(6412),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6413] = {
    [sym_block_comment] = STATE(6413),
    [sym_line_comment] = STATE(6413),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10701),
    [sym__immediate_command_start] = ACTIONS(10703),
  },
  [6414] = {
    [sym_block_comment] = STATE(6414),
    [sym_line_comment] = STATE(6414),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6415] = {
    [sym_block_comment] = STATE(6415),
    [sym_line_comment] = STATE(6415),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10701),
    [sym__immediate_command_start] = ACTIONS(10703),
  },
  [6416] = {
    [sym_block_comment] = STATE(6416),
    [sym_line_comment] = STATE(6416),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9806),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9806),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9806),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9806),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9806),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9806),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9806),
    [anon_sym_QMARK] = ACTIONS(9806),
    [anon_sym_DASH_GT] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9806),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9806),
    [aux_sym_integer_literal_token2] = ACTIONS(9806),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9806),
    [aux_sym_float_literal_token3] = ACTIONS(9806),
    [aux_sym_float_literal_token4] = ACTIONS(9806),
    [sym_character_literal] = ACTIONS(9806),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9806),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9806),
    [sym__pair_operator] = ACTIONS(9806),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9806),
    [sym__lazy_and_operator] = ACTIONS(9806),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9806),
    [sym__pipe_left_operator] = ACTIONS(9806),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9806),
    [sym__bitshift_operator] = ACTIONS(9806),
    [sym__power_operator] = ACTIONS(9806),
    [sym__tilde_operator] = ACTIONS(9806),
    [sym__type_order_operator] = ACTIONS(9806),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [6417] = {
    [sym_block_comment] = STATE(6417),
    [sym_line_comment] = STATE(6417),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6418] = {
    [sym_block_comment] = STATE(6418),
    [sym_line_comment] = STATE(6418),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6419] = {
    [sym_block_comment] = STATE(6419),
    [sym_line_comment] = STATE(6419),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6420] = {
    [sym_block_comment] = STATE(6420),
    [sym_line_comment] = STATE(6420),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9808),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9808),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9808),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9808),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9808),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9808),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9808),
    [anon_sym_QMARK] = ACTIONS(9808),
    [anon_sym_DASH_GT] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9808),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9808),
    [aux_sym_integer_literal_token2] = ACTIONS(9808),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9808),
    [aux_sym_float_literal_token3] = ACTIONS(9808),
    [aux_sym_float_literal_token4] = ACTIONS(9808),
    [sym_character_literal] = ACTIONS(9808),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9808),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9808),
    [sym__pair_operator] = ACTIONS(9808),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9808),
    [sym__lazy_and_operator] = ACTIONS(9808),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9808),
    [sym__pipe_left_operator] = ACTIONS(9808),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9808),
    [sym__bitshift_operator] = ACTIONS(9808),
    [sym__power_operator] = ACTIONS(9808),
    [sym__tilde_operator] = ACTIONS(9808),
    [sym__type_order_operator] = ACTIONS(9808),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [6421] = {
    [sym_block_comment] = STATE(6421),
    [sym_line_comment] = STATE(6421),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9812),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9812),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9812),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9812),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9812),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9812),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9812),
    [anon_sym_QMARK] = ACTIONS(9812),
    [anon_sym_DASH_GT] = ACTIONS(9812),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9812),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9812),
    [aux_sym_integer_literal_token2] = ACTIONS(9812),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9812),
    [aux_sym_float_literal_token3] = ACTIONS(9812),
    [aux_sym_float_literal_token4] = ACTIONS(9812),
    [sym_character_literal] = ACTIONS(9812),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9812),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9812),
    [sym__pair_operator] = ACTIONS(9812),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9812),
    [sym__lazy_and_operator] = ACTIONS(9812),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9812),
    [sym__pipe_left_operator] = ACTIONS(9812),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9812),
    [sym__bitshift_operator] = ACTIONS(9812),
    [sym__power_operator] = ACTIONS(9812),
    [sym__tilde_operator] = ACTIONS(9812),
    [sym__type_order_operator] = ACTIONS(9812),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [6422] = {
    [sym_block_comment] = STATE(6422),
    [sym_line_comment] = STATE(6422),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6423] = {
    [sym_block_comment] = STATE(6423),
    [sym_line_comment] = STATE(6423),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9816),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9816),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9816),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9816),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9816),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9816),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9816),
    [anon_sym_QMARK] = ACTIONS(9816),
    [anon_sym_DASH_GT] = ACTIONS(9816),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9816),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9816),
    [aux_sym_integer_literal_token2] = ACTIONS(9816),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9816),
    [aux_sym_float_literal_token3] = ACTIONS(9816),
    [aux_sym_float_literal_token4] = ACTIONS(9816),
    [sym_character_literal] = ACTIONS(9816),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9816),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9816),
    [sym__pair_operator] = ACTIONS(9816),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9816),
    [sym__lazy_and_operator] = ACTIONS(9816),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9816),
    [sym__pipe_left_operator] = ACTIONS(9816),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9816),
    [sym__bitshift_operator] = ACTIONS(9816),
    [sym__power_operator] = ACTIONS(9816),
    [sym__tilde_operator] = ACTIONS(9816),
    [sym__type_order_operator] = ACTIONS(9816),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [6424] = {
    [sym_block_comment] = STATE(6424),
    [sym_line_comment] = STATE(6424),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6425] = {
    [sym_block_comment] = STATE(6425),
    [sym_line_comment] = STATE(6425),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6426] = {
    [sym_block_comment] = STATE(6426),
    [sym_line_comment] = STATE(6426),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6427] = {
    [sym_block_comment] = STATE(6427),
    [sym_line_comment] = STATE(6427),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10705),
    [sym__immediate_command_start] = ACTIONS(10707),
  },
  [6428] = {
    [sym_block_comment] = STATE(6428),
    [sym_line_comment] = STATE(6428),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9820),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9820),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9820),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9820),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9820),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9820),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9820),
    [anon_sym_QMARK] = ACTIONS(9820),
    [anon_sym_DASH_GT] = ACTIONS(9820),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9820),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9820),
    [aux_sym_integer_literal_token2] = ACTIONS(9820),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9820),
    [aux_sym_float_literal_token3] = ACTIONS(9820),
    [aux_sym_float_literal_token4] = ACTIONS(9820),
    [sym_character_literal] = ACTIONS(9820),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9820),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9820),
    [sym__pair_operator] = ACTIONS(9820),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9820),
    [sym__lazy_and_operator] = ACTIONS(9820),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9820),
    [sym__pipe_left_operator] = ACTIONS(9820),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9820),
    [sym__bitshift_operator] = ACTIONS(9820),
    [sym__power_operator] = ACTIONS(9820),
    [sym__tilde_operator] = ACTIONS(9820),
    [sym__type_order_operator] = ACTIONS(9820),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [6429] = {
    [sym_block_comment] = STATE(6429),
    [sym_line_comment] = STATE(6429),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9822),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9822),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9822),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9822),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9822),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9822),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9822),
    [anon_sym_QMARK] = ACTIONS(9822),
    [anon_sym_DASH_GT] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9822),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9822),
    [aux_sym_integer_literal_token2] = ACTIONS(9822),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9822),
    [aux_sym_float_literal_token3] = ACTIONS(9822),
    [aux_sym_float_literal_token4] = ACTIONS(9822),
    [sym_character_literal] = ACTIONS(9822),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9822),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9822),
    [sym__pair_operator] = ACTIONS(9822),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9822),
    [sym__lazy_and_operator] = ACTIONS(9822),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9822),
    [sym__pipe_left_operator] = ACTIONS(9822),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9822),
    [sym__bitshift_operator] = ACTIONS(9822),
    [sym__power_operator] = ACTIONS(9822),
    [sym__tilde_operator] = ACTIONS(9822),
    [sym__type_order_operator] = ACTIONS(9822),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [6430] = {
    [sym_block_comment] = STATE(6430),
    [sym_line_comment] = STATE(6430),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10705),
    [sym__immediate_command_start] = ACTIONS(10707),
  },
  [6431] = {
    [sym_block_comment] = STATE(6431),
    [sym_line_comment] = STATE(6431),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6432] = {
    [sym_block_comment] = STATE(6432),
    [sym_line_comment] = STATE(6432),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9826),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9826),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9826),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9826),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9826),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9826),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9826),
    [anon_sym_QMARK] = ACTIONS(9826),
    [anon_sym_DASH_GT] = ACTIONS(9826),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9826),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9826),
    [aux_sym_integer_literal_token2] = ACTIONS(9826),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9826),
    [aux_sym_float_literal_token3] = ACTIONS(9826),
    [aux_sym_float_literal_token4] = ACTIONS(9826),
    [sym_character_literal] = ACTIONS(9826),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9826),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9826),
    [sym__pair_operator] = ACTIONS(9826),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9826),
    [sym__lazy_and_operator] = ACTIONS(9826),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9826),
    [sym__pipe_left_operator] = ACTIONS(9826),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9826),
    [sym__bitshift_operator] = ACTIONS(9826),
    [sym__power_operator] = ACTIONS(9826),
    [sym__tilde_operator] = ACTIONS(9826),
    [sym__type_order_operator] = ACTIONS(9826),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [6433] = {
    [sym_block_comment] = STATE(6433),
    [sym_line_comment] = STATE(6433),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6434] = {
    [sym_block_comment] = STATE(6434),
    [sym_line_comment] = STATE(6434),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6435] = {
    [sym_block_comment] = STATE(6435),
    [sym_line_comment] = STATE(6435),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6436] = {
    [sym_block_comment] = STATE(6436),
    [sym_line_comment] = STATE(6436),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [6437] = {
    [sym_block_comment] = STATE(6437),
    [sym_line_comment] = STATE(6437),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6438] = {
    [sym_block_comment] = STATE(6438),
    [sym_line_comment] = STATE(6438),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9830),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9830),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9830),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9830),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9830),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9830),
    [anon_sym_QMARK] = ACTIONS(9830),
    [anon_sym_DASH_GT] = ACTIONS(9830),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9830),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9830),
    [aux_sym_integer_literal_token2] = ACTIONS(9830),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9830),
    [aux_sym_float_literal_token3] = ACTIONS(9830),
    [aux_sym_float_literal_token4] = ACTIONS(9830),
    [sym_character_literal] = ACTIONS(9830),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9830),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9830),
    [sym__pair_operator] = ACTIONS(9830),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9830),
    [sym__lazy_and_operator] = ACTIONS(9830),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9830),
    [sym__pipe_left_operator] = ACTIONS(9830),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9830),
    [sym__bitshift_operator] = ACTIONS(9830),
    [sym__power_operator] = ACTIONS(9830),
    [sym__tilde_operator] = ACTIONS(9830),
    [sym__type_order_operator] = ACTIONS(9830),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [6439] = {
    [sym_block_comment] = STATE(6439),
    [sym_line_comment] = STATE(6439),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9834),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9834),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9834),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9834),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9834),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9834),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9834),
    [anon_sym_QMARK] = ACTIONS(9834),
    [anon_sym_DASH_GT] = ACTIONS(9834),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9834),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9834),
    [aux_sym_integer_literal_token2] = ACTIONS(9834),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9834),
    [aux_sym_float_literal_token3] = ACTIONS(9834),
    [aux_sym_float_literal_token4] = ACTIONS(9834),
    [sym_character_literal] = ACTIONS(9834),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9834),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9834),
    [sym__pair_operator] = ACTIONS(9834),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9834),
    [sym__lazy_and_operator] = ACTIONS(9834),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9834),
    [sym__pipe_left_operator] = ACTIONS(9834),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9834),
    [sym__bitshift_operator] = ACTIONS(9834),
    [sym__power_operator] = ACTIONS(9834),
    [sym__tilde_operator] = ACTIONS(9834),
    [sym__type_order_operator] = ACTIONS(9834),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [6440] = {
    [sym_block_comment] = STATE(6440),
    [sym_line_comment] = STATE(6440),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6441] = {
    [sym_block_comment] = STATE(6441),
    [sym_line_comment] = STATE(6441),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9838),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9838),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9838),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9838),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9838),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9838),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9838),
    [anon_sym_QMARK] = ACTIONS(9838),
    [anon_sym_DASH_GT] = ACTIONS(9838),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9838),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9838),
    [aux_sym_integer_literal_token2] = ACTIONS(9838),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9838),
    [aux_sym_float_literal_token3] = ACTIONS(9838),
    [aux_sym_float_literal_token4] = ACTIONS(9838),
    [sym_character_literal] = ACTIONS(9838),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9838),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9838),
    [sym__pair_operator] = ACTIONS(9838),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9838),
    [sym__lazy_and_operator] = ACTIONS(9838),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9838),
    [sym__pipe_left_operator] = ACTIONS(9838),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9838),
    [sym__bitshift_operator] = ACTIONS(9838),
    [sym__power_operator] = ACTIONS(9838),
    [sym__tilde_operator] = ACTIONS(9838),
    [sym__type_order_operator] = ACTIONS(9838),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [6442] = {
    [sym_block_comment] = STATE(6442),
    [sym_line_comment] = STATE(6442),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [6443] = {
    [sym_block_comment] = STATE(6443),
    [sym_line_comment] = STATE(6443),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6444] = {
    [sym_block_comment] = STATE(6444),
    [sym_line_comment] = STATE(6444),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10709),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6445] = {
    [sym_block_comment] = STATE(6445),
    [sym_line_comment] = STATE(6445),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_RPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_RBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_SEMI] = ACTIONS(10639),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_RBRACE] = ACTIONS(10639),
    [anon_sym_DOT] = ACTIONS(10711),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6446] = {
    [sym_block_comment] = STATE(6446),
    [sym_line_comment] = STATE(6446),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10086),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10086),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10086),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10086),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10086),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10086),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10086),
    [anon_sym_QMARK] = ACTIONS(10086),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10086),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10086),
    [aux_sym_integer_literal_token2] = ACTIONS(10086),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10086),
    [aux_sym_float_literal_token3] = ACTIONS(10086),
    [aux_sym_float_literal_token4] = ACTIONS(10086),
    [sym_character_literal] = ACTIONS(10086),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10086),
    [sym__pair_operator] = ACTIONS(10086),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10086),
    [sym__lazy_and_operator] = ACTIONS(10086),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10086),
    [sym__pipe_left_operator] = ACTIONS(10086),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10086),
    [sym__bitshift_operator] = ACTIONS(10086),
    [sym__power_operator] = ACTIONS(10086),
    [sym__tilde_operator] = ACTIONS(10086),
    [sym__type_order_operator] = ACTIONS(10086),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym__terminator_token1] = ACTIONS(10088),
    [aux_sym__terminator_token2] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6447] = {
    [sym_block_comment] = STATE(6447),
    [sym_line_comment] = STATE(6447),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10695),
    [sym__immediate_command_start] = ACTIONS(10697),
  },
  [6448] = {
    [sym_identifier] = STATE(6680),
    [sym_block_comment] = STATE(6448),
    [sym_line_comment] = STATE(6448),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_elseif] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6449] = {
    [sym_identifier] = STATE(6687),
    [sym_block_comment] = STATE(6449),
    [sym_line_comment] = STATE(6449),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_elseif] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6450] = {
    [sym_block_comment] = STATE(6450),
    [sym_line_comment] = STATE(6450),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10713),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6451] = {
    [sym_block_comment] = STATE(6451),
    [sym_line_comment] = STATE(6451),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6452] = {
    [sym_block_comment] = STATE(6452),
    [sym_line_comment] = STATE(6452),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6453] = {
    [sym_identifier] = STATE(6471),
    [sym_block_comment] = STATE(6453),
    [sym_line_comment] = STATE(6453),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_elseif] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6454] = {
    [sym_block_comment] = STATE(6454),
    [sym_line_comment] = STATE(6454),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6455] = {
    [sym_identifier] = STATE(6474),
    [sym_block_comment] = STATE(6455),
    [sym_line_comment] = STATE(6455),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_elseif] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6456] = {
    [sym_block_comment] = STATE(6456),
    [sym_line_comment] = STATE(6456),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [6457] = {
    [sym_block_comment] = STATE(6457),
    [sym_line_comment] = STATE(6457),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
    [sym__immediate_string_start] = ACTIONS(10651),
    [sym__immediate_command_start] = ACTIONS(10653),
  },
  [6458] = {
    [sym_block_comment] = STATE(6458),
    [sym_line_comment] = STATE(6458),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10691),
    [sym__immediate_command_start] = ACTIONS(10693),
  },
  [6459] = {
    [sym_block_comment] = STATE(6459),
    [sym_line_comment] = STATE(6459),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6460] = {
    [sym_block_comment] = STATE(6460),
    [sym_line_comment] = STATE(6460),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [6461] = {
    [sym_block_comment] = STATE(6461),
    [sym_line_comment] = STATE(6461),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6462] = {
    [sym_block_comment] = STATE(6462),
    [sym_line_comment] = STATE(6462),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_elseif] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6463] = {
    [sym_block_comment] = STATE(6463),
    [sym_line_comment] = STATE(6463),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_DASH_GT] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6464] = {
    [sym_block_comment] = STATE(6464),
    [sym_line_comment] = STATE(6464),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_elseif] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6465] = {
    [sym_block_comment] = STATE(6465),
    [sym_line_comment] = STATE(6465),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_elseif] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6466] = {
    [sym_block_comment] = STATE(6466),
    [sym_line_comment] = STATE(6466),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_DASH_GT] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6467] = {
    [sym_block_comment] = STATE(6467),
    [sym_line_comment] = STATE(6467),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_DASH_GT] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6468] = {
    [sym_block_comment] = STATE(6468),
    [sym_line_comment] = STATE(6468),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_elseif] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10715),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6469] = {
    [sym_block_comment] = STATE(6469),
    [sym_line_comment] = STATE(6469),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_elseif] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6470] = {
    [sym_block_comment] = STATE(6470),
    [sym_line_comment] = STATE(6470),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10717),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6471] = {
    [sym_block_comment] = STATE(6471),
    [sym_line_comment] = STATE(6471),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_elseif] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6472] = {
    [sym_block_comment] = STATE(6472),
    [sym_line_comment] = STATE(6472),
    [sym__word_identifier] = ACTIONS(9726),
    [anon_sym_COMMA] = ACTIONS(9756),
    [anon_sym_EQ] = ACTIONS(9726),
    [anon_sym_begin] = ACTIONS(9726),
    [anon_sym_module] = ACTIONS(9726),
    [anon_sym_baremodule] = ACTIONS(9726),
    [anon_sym_end] = ACTIONS(9726),
    [anon_sym_abstract] = ACTIONS(9726),
    [anon_sym_primitive] = ACTIONS(9726),
    [anon_sym_mutable] = ACTIONS(9726),
    [anon_sym_struct] = ACTIONS(9726),
    [anon_sym_function] = ACTIONS(9726),
    [anon_sym_macro] = ACTIONS(9726),
    [anon_sym_quote] = ACTIONS(9726),
    [anon_sym_let] = ACTIONS(9726),
    [anon_sym_if] = ACTIONS(9726),
    [anon_sym_try] = ACTIONS(9726),
    [anon_sym_for] = ACTIONS(9726),
    [anon_sym_while] = ACTIONS(9726),
    [sym_break_statement] = ACTIONS(9726),
    [sym_continue_statement] = ACTIONS(9726),
    [anon_sym_return] = ACTIONS(9726),
    [anon_sym_const] = ACTIONS(9726),
    [anon_sym_global] = ACTIONS(9726),
    [anon_sym_local] = ACTIONS(9726),
    [anon_sym_LPAREN] = ACTIONS(9756),
    [anon_sym_COLON] = ACTIONS(9726),
    [anon_sym_export] = ACTIONS(9726),
    [anon_sym_public] = ACTIONS(9726),
    [anon_sym_import] = ACTIONS(9726),
    [anon_sym_using] = ACTIONS(9726),
    [anon_sym_LBRACK] = ACTIONS(9756),
    [anon_sym_in] = ACTIONS(9726),
    [anon_sym_LBRACE] = ACTIONS(9756),
    [anon_sym_SQUOTE] = ACTIONS(9726),
    [anon_sym_DOT] = ACTIONS(9726),
    [anon_sym_do] = ACTIONS(9726),
    [anon_sym_DOLLAR] = ACTIONS(9756),
    [anon_sym_COLON2] = ACTIONS(9726),
    [anon_sym_COLON_COLON] = ACTIONS(9756),
    [anon_sym_isa] = ACTIONS(9726),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9756),
    [anon_sym_QMARK] = ACTIONS(9756),
    [anon_sym_where] = ACTIONS(9726),
    [anon_sym_AT] = ACTIONS(9756),
    [anon_sym_true] = ACTIONS(9726),
    [anon_sym_false] = ACTIONS(9726),
    [aux_sym_integer_literal_token1] = ACTIONS(9756),
    [aux_sym_integer_literal_token2] = ACTIONS(9756),
    [aux_sym_integer_literal_token3] = ACTIONS(9726),
    [aux_sym_integer_literal_token4] = ACTIONS(9726),
    [aux_sym_float_literal_token1] = ACTIONS(9756),
    [aux_sym_float_literal_token3] = ACTIONS(9756),
    [aux_sym_float_literal_token4] = ACTIONS(9756),
    [sym_character_literal] = ACTIONS(9756),
    [anon_sym_DQUOTE] = ACTIONS(9726),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9756),
    [anon_sym_BQUOTE] = ACTIONS(9726),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9756),
    [sym__pair_operator] = ACTIONS(9756),
    [sym__arrow_operator] = ACTIONS(9726),
    [sym__lazy_or_operator] = ACTIONS(9756),
    [sym__lazy_and_operator] = ACTIONS(9756),
    [sym__comparison_operator] = ACTIONS(9726),
    [sym__pipe_right_operator] = ACTIONS(9756),
    [sym__pipe_left_operator] = ACTIONS(9756),
    [sym__ellipsis_operator] = ACTIONS(9726),
    [sym__plus_operator] = ACTIONS(9726),
    [sym__times_operator] = ACTIONS(9726),
    [sym__rational_operator] = ACTIONS(9756),
    [sym__bitshift_operator] = ACTIONS(9756),
    [sym__power_operator] = ACTIONS(9756),
    [sym__tilde_operator] = ACTIONS(9756),
    [sym__type_order_operator] = ACTIONS(9756),
    [sym__unary_operator] = ACTIONS(9726),
    [sym__unary_plus_operator] = ACTIONS(9726),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9756),
    [sym__immediate_bracket] = ACTIONS(9756),
    [sym__immediate_brace] = ACTIONS(9756),
  },
  [6473] = {
    [sym_identifier] = STATE(6865),
    [sym_block_comment] = STATE(6473),
    [sym_line_comment] = STATE(6473),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6474] = {
    [sym_block_comment] = STATE(6474),
    [sym_line_comment] = STATE(6474),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_elseif] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6475] = {
    [sym_identifier] = STATE(6870),
    [sym_block_comment] = STATE(6475),
    [sym_line_comment] = STATE(6475),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6476] = {
    [sym_block_comment] = STATE(6476),
    [sym_line_comment] = STATE(6476),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_DASH_GT] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6477] = {
    [sym_block_comment] = STATE(6477),
    [sym_line_comment] = STATE(6477),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_DASH_GT] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6478] = {
    [sym_block_comment] = STATE(6478),
    [sym_line_comment] = STATE(6478),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_DASH_GT] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6479] = {
    [sym_block_comment] = STATE(6479),
    [sym_line_comment] = STATE(6479),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_DASH_GT] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [6480] = {
    [sym_block_comment] = STATE(6480),
    [sym_line_comment] = STATE(6480),
    [sym__word_identifier] = ACTIONS(9744),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9744),
    [anon_sym_begin] = ACTIONS(9744),
    [anon_sym_module] = ACTIONS(9744),
    [anon_sym_baremodule] = ACTIONS(9744),
    [anon_sym_end] = ACTIONS(9744),
    [anon_sym_abstract] = ACTIONS(9744),
    [anon_sym_primitive] = ACTIONS(9744),
    [anon_sym_mutable] = ACTIONS(9744),
    [anon_sym_struct] = ACTIONS(9744),
    [anon_sym_function] = ACTIONS(9744),
    [anon_sym_macro] = ACTIONS(9744),
    [anon_sym_quote] = ACTIONS(9744),
    [anon_sym_let] = ACTIONS(9744),
    [anon_sym_if] = ACTIONS(9744),
    [anon_sym_try] = ACTIONS(9744),
    [anon_sym_for] = ACTIONS(9744),
    [anon_sym_while] = ACTIONS(9744),
    [sym_break_statement] = ACTIONS(9744),
    [sym_continue_statement] = ACTIONS(9744),
    [anon_sym_return] = ACTIONS(9744),
    [anon_sym_const] = ACTIONS(9744),
    [anon_sym_global] = ACTIONS(9744),
    [anon_sym_local] = ACTIONS(9744),
    [anon_sym_LPAREN] = ACTIONS(9758),
    [anon_sym_COLON] = ACTIONS(9744),
    [anon_sym_export] = ACTIONS(9744),
    [anon_sym_public] = ACTIONS(9744),
    [anon_sym_import] = ACTIONS(9744),
    [anon_sym_using] = ACTIONS(9744),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9744),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_SQUOTE] = ACTIONS(9744),
    [anon_sym_DOT] = ACTIONS(9744),
    [anon_sym_do] = ACTIONS(9744),
    [anon_sym_DOLLAR] = ACTIONS(9758),
    [anon_sym_COLON2] = ACTIONS(9744),
    [anon_sym_COLON_COLON] = ACTIONS(9758),
    [anon_sym_isa] = ACTIONS(9744),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_where] = ACTIONS(9744),
    [anon_sym_AT] = ACTIONS(9758),
    [anon_sym_true] = ACTIONS(9744),
    [anon_sym_false] = ACTIONS(9744),
    [aux_sym_integer_literal_token1] = ACTIONS(9758),
    [aux_sym_integer_literal_token2] = ACTIONS(9758),
    [aux_sym_integer_literal_token3] = ACTIONS(9744),
    [aux_sym_integer_literal_token4] = ACTIONS(9744),
    [aux_sym_float_literal_token1] = ACTIONS(9758),
    [aux_sym_float_literal_token3] = ACTIONS(9758),
    [aux_sym_float_literal_token4] = ACTIONS(9758),
    [sym_character_literal] = ACTIONS(9758),
    [anon_sym_DQUOTE] = ACTIONS(9744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9758),
    [anon_sym_BQUOTE] = ACTIONS(9744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9758),
    [sym__pair_operator] = ACTIONS(9758),
    [sym__arrow_operator] = ACTIONS(9744),
    [sym__lazy_or_operator] = ACTIONS(9758),
    [sym__lazy_and_operator] = ACTIONS(9758),
    [sym__comparison_operator] = ACTIONS(9744),
    [sym__pipe_right_operator] = ACTIONS(9758),
    [sym__pipe_left_operator] = ACTIONS(9758),
    [sym__ellipsis_operator] = ACTIONS(9744),
    [sym__plus_operator] = ACTIONS(9744),
    [sym__times_operator] = ACTIONS(9744),
    [sym__rational_operator] = ACTIONS(9758),
    [sym__bitshift_operator] = ACTIONS(9758),
    [sym__power_operator] = ACTIONS(9758),
    [sym__tilde_operator] = ACTIONS(9758),
    [sym__type_order_operator] = ACTIONS(9758),
    [sym__unary_operator] = ACTIONS(9744),
    [sym__unary_plus_operator] = ACTIONS(9744),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9758),
    [sym__immediate_bracket] = ACTIONS(9758),
    [sym__immediate_brace] = ACTIONS(9758),
  },
  [6481] = {
    [sym_identifier] = STATE(6888),
    [sym_block_comment] = STATE(6481),
    [sym_line_comment] = STATE(6481),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6482] = {
    [sym_block_comment] = STATE(6482),
    [sym_line_comment] = STATE(6482),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_DASH_GT] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6483] = {
    [sym_block_comment] = STATE(6483),
    [sym_line_comment] = STATE(6483),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_DASH_GT] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6484] = {
    [sym_identifier] = STATE(6929),
    [sym_block_comment] = STATE(6484),
    [sym_line_comment] = STATE(6484),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6485] = {
    [sym_block_comment] = STATE(6485),
    [sym_line_comment] = STATE(6485),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_DASH_GT] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6486] = {
    [sym_block_comment] = STATE(6486),
    [sym_line_comment] = STATE(6486),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_elseif] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6487] = {
    [sym_block_comment] = STATE(6487),
    [sym_line_comment] = STATE(6487),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_elseif] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6488] = {
    [sym_identifier] = STATE(7027),
    [sym_block_comment] = STATE(6488),
    [sym_line_comment] = STATE(6488),
    [ts_builtin_sym_end] = ACTIONS(9786),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_RBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6489] = {
    [sym_block_comment] = STATE(6489),
    [sym_line_comment] = STATE(6489),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_elseif] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6490] = {
    [sym_block_comment] = STATE(6490),
    [sym_line_comment] = STATE(6490),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_DASH_GT] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6491] = {
    [sym_block_comment] = STATE(6491),
    [sym_line_comment] = STATE(6491),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10719),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6492] = {
    [sym_block_comment] = STATE(6492),
    [sym_line_comment] = STATE(6492),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_DASH_GT] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6493] = {
    [sym_block_comment] = STATE(6493),
    [sym_line_comment] = STATE(6493),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10721),
    [sym__immediate_command_start] = ACTIONS(10723),
  },
  [6494] = {
    [sym_block_comment] = STATE(6494),
    [sym_line_comment] = STATE(6494),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6495] = {
    [sym_block_comment] = STATE(6495),
    [sym_line_comment] = STATE(6495),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_DASH_GT] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6496] = {
    [sym_block_comment] = STATE(6496),
    [sym_line_comment] = STATE(6496),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_else] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6497] = {
    [sym_block_comment] = STATE(6497),
    [sym_line_comment] = STATE(6497),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_DASH_GT] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6498] = {
    [sym_block_comment] = STATE(6498),
    [sym_line_comment] = STATE(6498),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_DASH_GT] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [6499] = {
    [sym_block_comment] = STATE(6499),
    [sym_line_comment] = STATE(6499),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_DASH_GT] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6500] = {
    [sym_block_comment] = STATE(6500),
    [sym_line_comment] = STATE(6500),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6501] = {
    [sym_block_comment] = STATE(6501),
    [sym_line_comment] = STATE(6501),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_DASH_GT] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [6502] = {
    [sym_block_comment] = STATE(6502),
    [sym_line_comment] = STATE(6502),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6503] = {
    [sym_block_comment] = STATE(6503),
    [sym_line_comment] = STATE(6503),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_elseif] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6504] = {
    [sym_identifier] = STATE(6921),
    [sym_block_comment] = STATE(6504),
    [sym_line_comment] = STATE(6504),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6505] = {
    [sym_block_comment] = STATE(6505),
    [sym_line_comment] = STATE(6505),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6506] = {
    [sym_block_comment] = STATE(6506),
    [sym_line_comment] = STATE(6506),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_DASH_GT] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [6507] = {
    [sym_identifier] = STATE(6923),
    [sym_block_comment] = STATE(6507),
    [sym_line_comment] = STATE(6507),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6508] = {
    [sym_block_comment] = STATE(6508),
    [sym_line_comment] = STATE(6508),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6509] = {
    [sym_block_comment] = STATE(6509),
    [sym_line_comment] = STATE(6509),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6510] = {
    [sym_block_comment] = STATE(6510),
    [sym_line_comment] = STATE(6510),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6511] = {
    [sym_block_comment] = STATE(6511),
    [sym_line_comment] = STATE(6511),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6512] = {
    [sym_identifier] = STATE(6927),
    [sym_block_comment] = STATE(6512),
    [sym_line_comment] = STATE(6512),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6513] = {
    [sym_block_comment] = STATE(6513),
    [sym_line_comment] = STATE(6513),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_DASH_GT] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [6514] = {
    [sym_identifier] = STATE(6928),
    [sym_block_comment] = STATE(6514),
    [sym_line_comment] = STATE(6514),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6515] = {
    [sym_block_comment] = STATE(6515),
    [sym_line_comment] = STATE(6515),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10725),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6516] = {
    [sym_block_comment] = STATE(6516),
    [sym_line_comment] = STATE(6516),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10727),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_end] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_else] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_finally] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10727),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10727),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10727),
    [anon_sym_DOT] = ACTIONS(10729),
    [anon_sym_DOLLAR] = ACTIONS(10727),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_QMARK] = ACTIONS(10727),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10727),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10727),
    [aux_sym_integer_literal_token2] = ACTIONS(10727),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10727),
    [aux_sym_float_literal_token3] = ACTIONS(10727),
    [aux_sym_float_literal_token4] = ACTIONS(10727),
    [sym_character_literal] = ACTIONS(10727),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10727),
    [sym__pair_operator] = ACTIONS(10727),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10727),
    [sym__lazy_and_operator] = ACTIONS(10727),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10727),
    [sym__pipe_left_operator] = ACTIONS(10727),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10727),
    [sym__bitshift_operator] = ACTIONS(10727),
    [sym__power_operator] = ACTIONS(10727),
    [sym__tilde_operator] = ACTIONS(10727),
    [sym__type_order_operator] = ACTIONS(10727),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym__terminator_token1] = ACTIONS(10731),
    [aux_sym__terminator_token2] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6517] = {
    [sym_block_comment] = STATE(6517),
    [sym_line_comment] = STATE(6517),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_DASH_GT] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6518] = {
    [sym_block_comment] = STATE(6518),
    [sym_line_comment] = STATE(6518),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_DASH_GT] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6519] = {
    [sym_block_comment] = STATE(6519),
    [sym_line_comment] = STATE(6519),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_elseif] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6520] = {
    [sym_block_comment] = STATE(6520),
    [sym_line_comment] = STATE(6520),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_elseif] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6521] = {
    [sym_block_comment] = STATE(6521),
    [sym_line_comment] = STATE(6521),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10733),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6522] = {
    [sym_block_comment] = STATE(6522),
    [sym_line_comment] = STATE(6522),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6523] = {
    [sym_block_comment] = STATE(6523),
    [sym_line_comment] = STATE(6523),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_DASH_GT] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [6524] = {
    [sym_block_comment] = STATE(6524),
    [sym_line_comment] = STATE(6524),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9980),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9980),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9980),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9980),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9980),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9980),
    [anon_sym_QMARK] = ACTIONS(9980),
    [anon_sym_DASH_GT] = ACTIONS(9980),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9980),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9980),
    [aux_sym_integer_literal_token2] = ACTIONS(9980),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9980),
    [aux_sym_float_literal_token3] = ACTIONS(9980),
    [aux_sym_float_literal_token4] = ACTIONS(9980),
    [sym_character_literal] = ACTIONS(9980),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9980),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9980),
    [sym__pair_operator] = ACTIONS(9980),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9980),
    [sym__lazy_and_operator] = ACTIONS(9980),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9980),
    [sym__pipe_left_operator] = ACTIONS(9980),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9980),
    [sym__bitshift_operator] = ACTIONS(9980),
    [sym__power_operator] = ACTIONS(9980),
    [sym__tilde_operator] = ACTIONS(9980),
    [sym__type_order_operator] = ACTIONS(9980),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [6525] = {
    [sym_block_comment] = STATE(6525),
    [sym_line_comment] = STATE(6525),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_DASH_GT] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6526] = {
    [sym_block_comment] = STATE(6526),
    [sym_line_comment] = STATE(6526),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_elseif] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6527] = {
    [sym_block_comment] = STATE(6527),
    [sym_line_comment] = STATE(6527),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6528] = {
    [sym_block_comment] = STATE(6528),
    [sym_line_comment] = STATE(6528),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_COMMA] = ACTIONS(9806),
    [anon_sym_EQ] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9806),
    [anon_sym_COLON] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9806),
    [anon_sym_in] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9806),
    [anon_sym_SQUOTE] = ACTIONS(9738),
    [anon_sym_DOT] = ACTIONS(9738),
    [anon_sym_do] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9806),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9806),
    [anon_sym_isa] = ACTIONS(9738),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9806),
    [anon_sym_QMARK] = ACTIONS(9806),
    [anon_sym_where] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9806),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9806),
    [aux_sym_integer_literal_token2] = ACTIONS(9806),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9806),
    [aux_sym_float_literal_token3] = ACTIONS(9806),
    [aux_sym_float_literal_token4] = ACTIONS(9806),
    [sym_character_literal] = ACTIONS(9806),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9806),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9806),
    [sym__pair_operator] = ACTIONS(9806),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__lazy_or_operator] = ACTIONS(9806),
    [sym__lazy_and_operator] = ACTIONS(9806),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9806),
    [sym__pipe_left_operator] = ACTIONS(9806),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9806),
    [sym__bitshift_operator] = ACTIONS(9806),
    [sym__power_operator] = ACTIONS(9806),
    [sym__tilde_operator] = ACTIONS(9806),
    [sym__type_order_operator] = ACTIONS(9806),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9806),
    [sym__immediate_bracket] = ACTIONS(9806),
    [sym__immediate_brace] = ACTIONS(9806),
  },
  [6529] = {
    [sym_identifier] = STATE(7030),
    [sym_block_comment] = STATE(6529),
    [sym_line_comment] = STATE(6529),
    [ts_builtin_sym_end] = ACTIONS(9798),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_RBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6530] = {
    [sym_block_comment] = STATE(6530),
    [sym_line_comment] = STATE(6530),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6531] = {
    [sym_block_comment] = STATE(6531),
    [sym_line_comment] = STATE(6531),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_DASH_GT] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [6532] = {
    [sym_block_comment] = STATE(6532),
    [sym_line_comment] = STATE(6532),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9956),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9956),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9956),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9956),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9956),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9956),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9956),
    [anon_sym_QMARK] = ACTIONS(9956),
    [anon_sym_DASH_GT] = ACTIONS(9956),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9956),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9956),
    [aux_sym_integer_literal_token2] = ACTIONS(9956),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9956),
    [aux_sym_float_literal_token3] = ACTIONS(9956),
    [aux_sym_float_literal_token4] = ACTIONS(9956),
    [sym_character_literal] = ACTIONS(9956),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9956),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9956),
    [sym__pair_operator] = ACTIONS(9956),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9956),
    [sym__lazy_and_operator] = ACTIONS(9956),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9956),
    [sym__pipe_left_operator] = ACTIONS(9956),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9956),
    [sym__bitshift_operator] = ACTIONS(9956),
    [sym__power_operator] = ACTIONS(9956),
    [sym__tilde_operator] = ACTIONS(9956),
    [sym__type_order_operator] = ACTIONS(9956),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [6533] = {
    [sym_block_comment] = STATE(6533),
    [sym_line_comment] = STATE(6533),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9964),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9964),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9964),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9964),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9964),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9964),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9964),
    [anon_sym_QMARK] = ACTIONS(9964),
    [anon_sym_DASH_GT] = ACTIONS(9964),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9964),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9964),
    [aux_sym_integer_literal_token2] = ACTIONS(9964),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9964),
    [aux_sym_float_literal_token3] = ACTIONS(9964),
    [aux_sym_float_literal_token4] = ACTIONS(9964),
    [sym_character_literal] = ACTIONS(9964),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9964),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9964),
    [sym__pair_operator] = ACTIONS(9964),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9964),
    [sym__lazy_and_operator] = ACTIONS(9964),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9964),
    [sym__pipe_left_operator] = ACTIONS(9964),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9964),
    [sym__bitshift_operator] = ACTIONS(9964),
    [sym__power_operator] = ACTIONS(9964),
    [sym__tilde_operator] = ACTIONS(9964),
    [sym__type_order_operator] = ACTIONS(9964),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [6534] = {
    [sym_block_comment] = STATE(6534),
    [sym_line_comment] = STATE(6534),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_DASH_GT] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [6535] = {
    [sym_block_comment] = STATE(6535),
    [sym_line_comment] = STATE(6535),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_DASH_GT] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [6536] = {
    [sym_block_comment] = STATE(6536),
    [sym_line_comment] = STATE(6536),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_DASH_GT] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [6537] = {
    [sym_block_comment] = STATE(6537),
    [sym_line_comment] = STATE(6537),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_DASH_GT] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [6538] = {
    [sym_block_comment] = STATE(6538),
    [sym_line_comment] = STATE(6538),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_COMMA] = ACTIONS(9808),
    [anon_sym_EQ] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9808),
    [anon_sym_COLON] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9808),
    [anon_sym_in] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9808),
    [anon_sym_SQUOTE] = ACTIONS(9752),
    [anon_sym_DOT] = ACTIONS(9752),
    [anon_sym_do] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9808),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9808),
    [anon_sym_isa] = ACTIONS(9752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9808),
    [anon_sym_QMARK] = ACTIONS(9808),
    [anon_sym_where] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9808),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9808),
    [aux_sym_integer_literal_token2] = ACTIONS(9808),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9808),
    [aux_sym_float_literal_token3] = ACTIONS(9808),
    [aux_sym_float_literal_token4] = ACTIONS(9808),
    [sym_character_literal] = ACTIONS(9808),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9808),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9808),
    [sym__pair_operator] = ACTIONS(9808),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__lazy_or_operator] = ACTIONS(9808),
    [sym__lazy_and_operator] = ACTIONS(9808),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9808),
    [sym__pipe_left_operator] = ACTIONS(9808),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9808),
    [sym__bitshift_operator] = ACTIONS(9808),
    [sym__power_operator] = ACTIONS(9808),
    [sym__tilde_operator] = ACTIONS(9808),
    [sym__type_order_operator] = ACTIONS(9808),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9808),
    [sym__immediate_bracket] = ACTIONS(9808),
    [sym__immediate_brace] = ACTIONS(9808),
  },
  [6539] = {
    [sym_block_comment] = STATE(6539),
    [sym_line_comment] = STATE(6539),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_COMMA] = ACTIONS(9812),
    [anon_sym_EQ] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9812),
    [anon_sym_COLON] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9812),
    [anon_sym_in] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9812),
    [anon_sym_SQUOTE] = ACTIONS(9810),
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_do] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9812),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9812),
    [anon_sym_isa] = ACTIONS(9810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9812),
    [anon_sym_QMARK] = ACTIONS(9812),
    [anon_sym_where] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9812),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9812),
    [aux_sym_integer_literal_token2] = ACTIONS(9812),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9812),
    [aux_sym_float_literal_token3] = ACTIONS(9812),
    [aux_sym_float_literal_token4] = ACTIONS(9812),
    [sym_character_literal] = ACTIONS(9812),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9812),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9812),
    [sym__pair_operator] = ACTIONS(9812),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__lazy_or_operator] = ACTIONS(9812),
    [sym__lazy_and_operator] = ACTIONS(9812),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9812),
    [sym__pipe_left_operator] = ACTIONS(9812),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9812),
    [sym__bitshift_operator] = ACTIONS(9812),
    [sym__power_operator] = ACTIONS(9812),
    [sym__tilde_operator] = ACTIONS(9812),
    [sym__type_order_operator] = ACTIONS(9812),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9812),
    [sym__immediate_bracket] = ACTIONS(9812),
    [sym__immediate_brace] = ACTIONS(9812),
  },
  [6540] = {
    [sym_block_comment] = STATE(6540),
    [sym_line_comment] = STATE(6540),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_COMMA] = ACTIONS(9816),
    [anon_sym_EQ] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9816),
    [anon_sym_COLON] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9816),
    [anon_sym_in] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9816),
    [anon_sym_SQUOTE] = ACTIONS(9814),
    [anon_sym_DOT] = ACTIONS(9814),
    [anon_sym_do] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9816),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9816),
    [anon_sym_isa] = ACTIONS(9814),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9816),
    [anon_sym_QMARK] = ACTIONS(9816),
    [anon_sym_where] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9816),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9816),
    [aux_sym_integer_literal_token2] = ACTIONS(9816),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9816),
    [aux_sym_float_literal_token3] = ACTIONS(9816),
    [aux_sym_float_literal_token4] = ACTIONS(9816),
    [sym_character_literal] = ACTIONS(9816),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9816),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9816),
    [sym__pair_operator] = ACTIONS(9816),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__lazy_or_operator] = ACTIONS(9816),
    [sym__lazy_and_operator] = ACTIONS(9816),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9816),
    [sym__pipe_left_operator] = ACTIONS(9816),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9816),
    [sym__bitshift_operator] = ACTIONS(9816),
    [sym__power_operator] = ACTIONS(9816),
    [sym__tilde_operator] = ACTIONS(9816),
    [sym__type_order_operator] = ACTIONS(9816),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9816),
    [sym__immediate_bracket] = ACTIONS(9816),
    [sym__immediate_brace] = ACTIONS(9816),
  },
  [6541] = {
    [sym_identifier] = STATE(7031),
    [sym_block_comment] = STATE(6541),
    [sym_line_comment] = STATE(6541),
    [ts_builtin_sym_end] = ACTIONS(9802),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_RBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6542] = {
    [sym_block_comment] = STATE(6542),
    [sym_line_comment] = STATE(6542),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10104),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10104),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10104),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10104),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10104),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10104),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10104),
    [anon_sym_QMARK] = ACTIONS(10104),
    [anon_sym_DASH_GT] = ACTIONS(10104),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10104),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10104),
    [aux_sym_integer_literal_token2] = ACTIONS(10104),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10104),
    [aux_sym_float_literal_token3] = ACTIONS(10104),
    [aux_sym_float_literal_token4] = ACTIONS(10104),
    [sym_character_literal] = ACTIONS(10104),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10104),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10104),
    [sym__pair_operator] = ACTIONS(10104),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10104),
    [sym__lazy_and_operator] = ACTIONS(10104),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10104),
    [sym__pipe_left_operator] = ACTIONS(10104),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10104),
    [sym__bitshift_operator] = ACTIONS(10104),
    [sym__power_operator] = ACTIONS(10104),
    [sym__tilde_operator] = ACTIONS(10104),
    [sym__type_order_operator] = ACTIONS(10104),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [6543] = {
    [sym_block_comment] = STATE(6543),
    [sym_line_comment] = STATE(6543),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_DASH_GT] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [6544] = {
    [sym_block_comment] = STATE(6544),
    [sym_line_comment] = STATE(6544),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10108),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10108),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10108),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10108),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10108),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10108),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10108),
    [anon_sym_QMARK] = ACTIONS(10108),
    [anon_sym_DASH_GT] = ACTIONS(10108),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10108),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10108),
    [aux_sym_integer_literal_token2] = ACTIONS(10108),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10108),
    [aux_sym_float_literal_token3] = ACTIONS(10108),
    [aux_sym_float_literal_token4] = ACTIONS(10108),
    [sym_character_literal] = ACTIONS(10108),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10108),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10108),
    [sym__pair_operator] = ACTIONS(10108),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10108),
    [sym__lazy_and_operator] = ACTIONS(10108),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10108),
    [sym__pipe_left_operator] = ACTIONS(10108),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10108),
    [sym__bitshift_operator] = ACTIONS(10108),
    [sym__power_operator] = ACTIONS(10108),
    [sym__tilde_operator] = ACTIONS(10108),
    [sym__type_order_operator] = ACTIONS(10108),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [6545] = {
    [sym_block_comment] = STATE(6545),
    [sym_line_comment] = STATE(6545),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_DASH_GT] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [6546] = {
    [sym_block_comment] = STATE(6546),
    [sym_line_comment] = STATE(6546),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_elseif] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6547] = {
    [sym_block_comment] = STATE(6547),
    [sym_line_comment] = STATE(6547),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_COMMA] = ACTIONS(9820),
    [anon_sym_EQ] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9820),
    [anon_sym_COLON] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9820),
    [anon_sym_in] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9820),
    [anon_sym_SQUOTE] = ACTIONS(9818),
    [anon_sym_DOT] = ACTIONS(9818),
    [anon_sym_do] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9820),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9820),
    [anon_sym_isa] = ACTIONS(9818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9820),
    [anon_sym_QMARK] = ACTIONS(9820),
    [anon_sym_where] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9820),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9820),
    [aux_sym_integer_literal_token2] = ACTIONS(9820),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9820),
    [aux_sym_float_literal_token3] = ACTIONS(9820),
    [aux_sym_float_literal_token4] = ACTIONS(9820),
    [sym_character_literal] = ACTIONS(9820),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9820),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9820),
    [sym__pair_operator] = ACTIONS(9820),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__lazy_or_operator] = ACTIONS(9820),
    [sym__lazy_and_operator] = ACTIONS(9820),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9820),
    [sym__pipe_left_operator] = ACTIONS(9820),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9820),
    [sym__bitshift_operator] = ACTIONS(9820),
    [sym__power_operator] = ACTIONS(9820),
    [sym__tilde_operator] = ACTIONS(9820),
    [sym__type_order_operator] = ACTIONS(9820),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9820),
    [sym__immediate_bracket] = ACTIONS(9820),
    [sym__immediate_brace] = ACTIONS(9820),
  },
  [6548] = {
    [sym_block_comment] = STATE(6548),
    [sym_line_comment] = STATE(6548),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_COMMA] = ACTIONS(9822),
    [anon_sym_EQ] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9822),
    [anon_sym_COLON] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9822),
    [anon_sym_in] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9822),
    [anon_sym_SQUOTE] = ACTIONS(9790),
    [anon_sym_DOT] = ACTIONS(9790),
    [anon_sym_do] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9822),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9822),
    [anon_sym_isa] = ACTIONS(9790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9822),
    [anon_sym_QMARK] = ACTIONS(9822),
    [anon_sym_where] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9822),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9822),
    [aux_sym_integer_literal_token2] = ACTIONS(9822),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9822),
    [aux_sym_float_literal_token3] = ACTIONS(9822),
    [aux_sym_float_literal_token4] = ACTIONS(9822),
    [sym_character_literal] = ACTIONS(9822),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9822),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9822),
    [sym__pair_operator] = ACTIONS(9822),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__lazy_or_operator] = ACTIONS(9822),
    [sym__lazy_and_operator] = ACTIONS(9822),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9822),
    [sym__pipe_left_operator] = ACTIONS(9822),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9822),
    [sym__bitshift_operator] = ACTIONS(9822),
    [sym__power_operator] = ACTIONS(9822),
    [sym__tilde_operator] = ACTIONS(9822),
    [sym__type_order_operator] = ACTIONS(9822),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9822),
    [sym__immediate_bracket] = ACTIONS(9822),
    [sym__immediate_brace] = ACTIONS(9822),
  },
  [6549] = {
    [sym_block_comment] = STATE(6549),
    [sym_line_comment] = STATE(6549),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_COMMA] = ACTIONS(9826),
    [anon_sym_EQ] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9826),
    [anon_sym_COLON] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9826),
    [anon_sym_in] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9826),
    [anon_sym_SQUOTE] = ACTIONS(9824),
    [anon_sym_DOT] = ACTIONS(9824),
    [anon_sym_do] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9826),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9826),
    [anon_sym_isa] = ACTIONS(9824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9826),
    [anon_sym_QMARK] = ACTIONS(9826),
    [anon_sym_where] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9826),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9826),
    [aux_sym_integer_literal_token2] = ACTIONS(9826),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9826),
    [aux_sym_float_literal_token3] = ACTIONS(9826),
    [aux_sym_float_literal_token4] = ACTIONS(9826),
    [sym_character_literal] = ACTIONS(9826),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9826),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9826),
    [sym__pair_operator] = ACTIONS(9826),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__lazy_or_operator] = ACTIONS(9826),
    [sym__lazy_and_operator] = ACTIONS(9826),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9826),
    [sym__pipe_left_operator] = ACTIONS(9826),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9826),
    [sym__bitshift_operator] = ACTIONS(9826),
    [sym__power_operator] = ACTIONS(9826),
    [sym__tilde_operator] = ACTIONS(9826),
    [sym__type_order_operator] = ACTIONS(9826),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9826),
    [sym__immediate_bracket] = ACTIONS(9826),
    [sym__immediate_brace] = ACTIONS(9826),
  },
  [6550] = {
    [sym_block_comment] = STATE(6550),
    [sym_line_comment] = STATE(6550),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6551] = {
    [sym_block_comment] = STATE(6551),
    [sym_line_comment] = STATE(6551),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6552] = {
    [sym_block_comment] = STATE(6552),
    [sym_line_comment] = STATE(6552),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10124),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10124),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10124),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10124),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10124),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10124),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10124),
    [anon_sym_QMARK] = ACTIONS(10124),
    [anon_sym_DASH_GT] = ACTIONS(10124),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10124),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10124),
    [aux_sym_integer_literal_token2] = ACTIONS(10124),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10124),
    [aux_sym_float_literal_token3] = ACTIONS(10124),
    [aux_sym_float_literal_token4] = ACTIONS(10124),
    [sym_character_literal] = ACTIONS(10124),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10124),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10124),
    [sym__pair_operator] = ACTIONS(10124),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10124),
    [sym__lazy_and_operator] = ACTIONS(10124),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10124),
    [sym__pipe_left_operator] = ACTIONS(10124),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10124),
    [sym__bitshift_operator] = ACTIONS(10124),
    [sym__power_operator] = ACTIONS(10124),
    [sym__tilde_operator] = ACTIONS(10124),
    [sym__type_order_operator] = ACTIONS(10124),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [6553] = {
    [sym_identifier] = STATE(6779),
    [sym_block_comment] = STATE(6553),
    [sym_line_comment] = STATE(6553),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6554] = {
    [sym_block_comment] = STATE(6554),
    [sym_line_comment] = STATE(6554),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_DASH_GT] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [6555] = {
    [sym_identifier] = STATE(6786),
    [sym_block_comment] = STATE(6555),
    [sym_line_comment] = STATE(6555),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6556] = {
    [sym_block_comment] = STATE(6556),
    [sym_line_comment] = STATE(6556),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10735),
    [sym__immediate_command_start] = ACTIONS(10737),
  },
  [6557] = {
    [sym_block_comment] = STATE(6557),
    [sym_line_comment] = STATE(6557),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_COMMA] = ACTIONS(9830),
    [anon_sym_EQ] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9830),
    [anon_sym_COLON] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9830),
    [anon_sym_in] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9830),
    [anon_sym_SQUOTE] = ACTIONS(9828),
    [anon_sym_DOT] = ACTIONS(9828),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9830),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9830),
    [anon_sym_isa] = ACTIONS(9828),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9830),
    [anon_sym_QMARK] = ACTIONS(9830),
    [anon_sym_where] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9830),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9830),
    [aux_sym_integer_literal_token2] = ACTIONS(9830),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9830),
    [aux_sym_float_literal_token3] = ACTIONS(9830),
    [aux_sym_float_literal_token4] = ACTIONS(9830),
    [sym_character_literal] = ACTIONS(9830),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9830),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9830),
    [sym__pair_operator] = ACTIONS(9830),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__lazy_or_operator] = ACTIONS(9830),
    [sym__lazy_and_operator] = ACTIONS(9830),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9830),
    [sym__pipe_left_operator] = ACTIONS(9830),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9830),
    [sym__bitshift_operator] = ACTIONS(9830),
    [sym__power_operator] = ACTIONS(9830),
    [sym__tilde_operator] = ACTIONS(9830),
    [sym__type_order_operator] = ACTIONS(9830),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9830),
    [sym__immediate_bracket] = ACTIONS(9830),
    [sym__immediate_brace] = ACTIONS(9830),
  },
  [6558] = {
    [sym_block_comment] = STATE(6558),
    [sym_line_comment] = STATE(6558),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_COMMA] = ACTIONS(9834),
    [anon_sym_EQ] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9834),
    [anon_sym_COLON] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9834),
    [anon_sym_in] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9834),
    [anon_sym_SQUOTE] = ACTIONS(9832),
    [anon_sym_DOT] = ACTIONS(9832),
    [anon_sym_do] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9834),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9834),
    [anon_sym_isa] = ACTIONS(9832),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9834),
    [anon_sym_QMARK] = ACTIONS(9834),
    [anon_sym_where] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9834),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9834),
    [aux_sym_integer_literal_token2] = ACTIONS(9834),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9834),
    [aux_sym_float_literal_token3] = ACTIONS(9834),
    [aux_sym_float_literal_token4] = ACTIONS(9834),
    [sym_character_literal] = ACTIONS(9834),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9834),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9834),
    [sym__pair_operator] = ACTIONS(9834),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__lazy_or_operator] = ACTIONS(9834),
    [sym__lazy_and_operator] = ACTIONS(9834),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9834),
    [sym__pipe_left_operator] = ACTIONS(9834),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9834),
    [sym__bitshift_operator] = ACTIONS(9834),
    [sym__power_operator] = ACTIONS(9834),
    [sym__tilde_operator] = ACTIONS(9834),
    [sym__type_order_operator] = ACTIONS(9834),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9834),
    [sym__immediate_bracket] = ACTIONS(9834),
    [sym__immediate_brace] = ACTIONS(9834),
  },
  [6559] = {
    [sym_block_comment] = STATE(6559),
    [sym_line_comment] = STATE(6559),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10130),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10130),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10130),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10130),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10130),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10130),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10130),
    [anon_sym_QMARK] = ACTIONS(10130),
    [anon_sym_DASH_GT] = ACTIONS(10130),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10130),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10130),
    [aux_sym_integer_literal_token2] = ACTIONS(10130),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10130),
    [aux_sym_float_literal_token3] = ACTIONS(10130),
    [aux_sym_float_literal_token4] = ACTIONS(10130),
    [sym_character_literal] = ACTIONS(10130),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10130),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10130),
    [sym__pair_operator] = ACTIONS(10130),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10130),
    [sym__lazy_and_operator] = ACTIONS(10130),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10130),
    [sym__pipe_left_operator] = ACTIONS(10130),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10130),
    [sym__bitshift_operator] = ACTIONS(10130),
    [sym__power_operator] = ACTIONS(10130),
    [sym__tilde_operator] = ACTIONS(10130),
    [sym__type_order_operator] = ACTIONS(10130),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [6560] = {
    [sym_block_comment] = STATE(6560),
    [sym_line_comment] = STATE(6560),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10140),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10140),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10140),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10140),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10140),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_QMARK] = ACTIONS(10140),
    [anon_sym_DASH_GT] = ACTIONS(10140),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10140),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10140),
    [aux_sym_integer_literal_token2] = ACTIONS(10140),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10140),
    [aux_sym_float_literal_token3] = ACTIONS(10140),
    [aux_sym_float_literal_token4] = ACTIONS(10140),
    [sym_character_literal] = ACTIONS(10140),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10140),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10140),
    [sym__pair_operator] = ACTIONS(10140),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10140),
    [sym__lazy_and_operator] = ACTIONS(10140),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10140),
    [sym__pipe_left_operator] = ACTIONS(10140),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10140),
    [sym__bitshift_operator] = ACTIONS(10140),
    [sym__power_operator] = ACTIONS(10140),
    [sym__tilde_operator] = ACTIONS(10140),
    [sym__type_order_operator] = ACTIONS(10140),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [6561] = {
    [sym_block_comment] = STATE(6561),
    [sym_line_comment] = STATE(6561),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_COMMA] = ACTIONS(9838),
    [anon_sym_EQ] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9838),
    [anon_sym_COLON] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9838),
    [anon_sym_in] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9838),
    [anon_sym_SQUOTE] = ACTIONS(9836),
    [anon_sym_DOT] = ACTIONS(9836),
    [anon_sym_do] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9838),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9838),
    [anon_sym_isa] = ACTIONS(9836),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9838),
    [anon_sym_QMARK] = ACTIONS(9838),
    [anon_sym_where] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9838),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9838),
    [aux_sym_integer_literal_token2] = ACTIONS(9838),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9838),
    [aux_sym_float_literal_token3] = ACTIONS(9838),
    [aux_sym_float_literal_token4] = ACTIONS(9838),
    [sym_character_literal] = ACTIONS(9838),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9838),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9838),
    [sym__pair_operator] = ACTIONS(9838),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__lazy_or_operator] = ACTIONS(9838),
    [sym__lazy_and_operator] = ACTIONS(9838),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9838),
    [sym__pipe_left_operator] = ACTIONS(9838),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9838),
    [sym__bitshift_operator] = ACTIONS(9838),
    [sym__power_operator] = ACTIONS(9838),
    [sym__tilde_operator] = ACTIONS(9838),
    [sym__type_order_operator] = ACTIONS(9838),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9838),
    [sym__immediate_bracket] = ACTIONS(9838),
    [sym__immediate_brace] = ACTIONS(9838),
  },
  [6562] = {
    [sym_block_comment] = STATE(6562),
    [sym_line_comment] = STATE(6562),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10144),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10144),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10144),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10144),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10144),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10144),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10144),
    [anon_sym_QMARK] = ACTIONS(10144),
    [anon_sym_DASH_GT] = ACTIONS(10144),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10144),
    [aux_sym_integer_literal_token2] = ACTIONS(10144),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10144),
    [aux_sym_float_literal_token3] = ACTIONS(10144),
    [aux_sym_float_literal_token4] = ACTIONS(10144),
    [sym_character_literal] = ACTIONS(10144),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10144),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10144),
    [sym__pair_operator] = ACTIONS(10144),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10144),
    [sym__lazy_and_operator] = ACTIONS(10144),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10144),
    [sym__pipe_left_operator] = ACTIONS(10144),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10144),
    [sym__bitshift_operator] = ACTIONS(10144),
    [sym__power_operator] = ACTIONS(10144),
    [sym__tilde_operator] = ACTIONS(10144),
    [sym__type_order_operator] = ACTIONS(10144),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [6563] = {
    [sym_block_comment] = STATE(6563),
    [sym_line_comment] = STATE(6563),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6564] = {
    [sym_block_comment] = STATE(6564),
    [sym_line_comment] = STATE(6564),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6565] = {
    [sym_block_comment] = STATE(6565),
    [sym_line_comment] = STATE(6565),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6566] = {
    [sym_identifier] = STATE(6798),
    [sym_block_comment] = STATE(6566),
    [sym_line_comment] = STATE(6566),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6567] = {
    [sym_block_comment] = STATE(6567),
    [sym_line_comment] = STATE(6567),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6568] = {
    [sym_block_comment] = STATE(6568),
    [sym_line_comment] = STATE(6568),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6569] = {
    [sym_block_comment] = STATE(6569),
    [sym_line_comment] = STATE(6569),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_DASH_GT] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6570] = {
    [sym_identifier] = STATE(6815),
    [sym_block_comment] = STATE(6570),
    [sym_line_comment] = STATE(6570),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6571] = {
    [sym_identifier] = STATE(7146),
    [sym_block_comment] = STATE(6571),
    [sym_line_comment] = STATE(6571),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_RPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_RBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_SEMI] = ACTIONS(9782),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_RBRACE] = ACTIONS(9782),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6572] = {
    [sym_block_comment] = STATE(6572),
    [sym_line_comment] = STATE(6572),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10739),
    [sym__immediate_command_start] = ACTIONS(10741),
  },
  [6573] = {
    [sym_block_comment] = STATE(6573),
    [sym_line_comment] = STATE(6573),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10743),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6574] = {
    [sym_block_comment] = STATE(6574),
    [sym_line_comment] = STATE(6574),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6575] = {
    [sym_block_comment] = STATE(6575),
    [sym_line_comment] = STATE(6575),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10745),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6576] = {
    [sym_block_comment] = STATE(6576),
    [sym_line_comment] = STATE(6576),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_elseif] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6577] = {
    [sym_block_comment] = STATE(6577),
    [sym_line_comment] = STATE(6577),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6578] = {
    [sym_block_comment] = STATE(6578),
    [sym_line_comment] = STATE(6578),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_elseif] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6579] = {
    [sym_block_comment] = STATE(6579),
    [sym_line_comment] = STATE(6579),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_elseif] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6580] = {
    [sym_block_comment] = STATE(6580),
    [sym_line_comment] = STATE(6580),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_DASH_GT] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6581] = {
    [sym_block_comment] = STATE(6581),
    [sym_line_comment] = STATE(6581),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6582] = {
    [sym_block_comment] = STATE(6582),
    [sym_line_comment] = STATE(6582),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6583] = {
    [sym_block_comment] = STATE(6583),
    [sym_line_comment] = STATE(6583),
    [aux_sym__import_list_repeat1] = STATE(7098),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10749),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_else] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10751),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10753),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6584] = {
    [sym_block_comment] = STATE(6584),
    [sym_line_comment] = STATE(6584),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_else] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_finally] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOT] = ACTIONS(10729),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6585] = {
    [sym_identifier] = STATE(7148),
    [sym_block_comment] = STATE(6585),
    [sym_line_comment] = STATE(6585),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_RPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_RBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_SEMI] = ACTIONS(9786),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6586] = {
    [sym_identifier] = STATE(7155),
    [sym_block_comment] = STATE(6586),
    [sym_line_comment] = STATE(6586),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_RPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_RBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_SEMI] = ACTIONS(9798),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_RBRACE] = ACTIONS(9798),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6587] = {
    [sym_identifier] = STATE(7156),
    [sym_block_comment] = STATE(6587),
    [sym_line_comment] = STATE(6587),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_RPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_RBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_SEMI] = ACTIONS(9802),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_RBRACE] = ACTIONS(9802),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6588] = {
    [sym_block_comment] = STATE(6588),
    [sym_line_comment] = STATE(6588),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_else] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(10729),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6589] = {
    [sym_block_comment] = STATE(6589),
    [sym_line_comment] = STATE(6589),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6590] = {
    [sym_block_comment] = STATE(6590),
    [sym_line_comment] = STATE(6590),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6591] = {
    [sym_block_comment] = STATE(6591),
    [sym_line_comment] = STATE(6591),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_elseif] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6592] = {
    [sym_block_comment] = STATE(6592),
    [sym_line_comment] = STATE(6592),
    [aux_sym__import_list_repeat1] = STATE(6889),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10765),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_elseif] = ACTIONS(10747),
    [anon_sym_else] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10767),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10769),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6593] = {
    [sym_block_comment] = STATE(6593),
    [sym_line_comment] = STATE(6593),
    [sym__word_identifier] = ACTIONS(10322),
    [anon_sym_COMMA] = ACTIONS(10328),
    [anon_sym_EQ] = ACTIONS(10322),
    [anon_sym_begin] = ACTIONS(10322),
    [anon_sym_module] = ACTIONS(10322),
    [anon_sym_baremodule] = ACTIONS(10322),
    [anon_sym_end] = ACTIONS(10322),
    [anon_sym_abstract] = ACTIONS(10322),
    [anon_sym_primitive] = ACTIONS(10322),
    [anon_sym_mutable] = ACTIONS(10322),
    [anon_sym_struct] = ACTIONS(10322),
    [anon_sym_function] = ACTIONS(10322),
    [anon_sym_macro] = ACTIONS(10322),
    [anon_sym_quote] = ACTIONS(10322),
    [anon_sym_let] = ACTIONS(10322),
    [anon_sym_if] = ACTIONS(10322),
    [anon_sym_try] = ACTIONS(10322),
    [anon_sym_for] = ACTIONS(10322),
    [anon_sym_while] = ACTIONS(10322),
    [sym_break_statement] = ACTIONS(10322),
    [sym_continue_statement] = ACTIONS(10322),
    [anon_sym_return] = ACTIONS(10322),
    [anon_sym_const] = ACTIONS(10322),
    [anon_sym_global] = ACTIONS(10322),
    [anon_sym_local] = ACTIONS(10322),
    [anon_sym_LPAREN] = ACTIONS(10328),
    [anon_sym_COLON] = ACTIONS(10322),
    [anon_sym_export] = ACTIONS(10322),
    [anon_sym_public] = ACTIONS(10322),
    [anon_sym_import] = ACTIONS(10322),
    [anon_sym_using] = ACTIONS(10322),
    [anon_sym_LBRACK] = ACTIONS(10328),
    [anon_sym_in] = ACTIONS(10322),
    [anon_sym_LBRACE] = ACTIONS(10328),
    [anon_sym_SQUOTE] = ACTIONS(10771),
    [anon_sym_DOT] = ACTIONS(10773),
    [anon_sym_DOLLAR] = ACTIONS(10328),
    [anon_sym_COLON2] = ACTIONS(10322),
    [anon_sym_COLON_COLON] = ACTIONS(10328),
    [anon_sym_isa] = ACTIONS(10322),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10328),
    [anon_sym_QMARK] = ACTIONS(10328),
    [anon_sym_DASH_GT] = ACTIONS(10328),
    [anon_sym_where] = ACTIONS(10322),
    [anon_sym_AT] = ACTIONS(10328),
    [anon_sym_true] = ACTIONS(10322),
    [anon_sym_false] = ACTIONS(10322),
    [aux_sym_integer_literal_token1] = ACTIONS(10328),
    [aux_sym_integer_literal_token2] = ACTIONS(10328),
    [aux_sym_integer_literal_token3] = ACTIONS(10322),
    [aux_sym_integer_literal_token4] = ACTIONS(10322),
    [aux_sym_float_literal_token1] = ACTIONS(10328),
    [aux_sym_float_literal_token3] = ACTIONS(10328),
    [aux_sym_float_literal_token4] = ACTIONS(10328),
    [sym_character_literal] = ACTIONS(10328),
    [anon_sym_DQUOTE] = ACTIONS(10322),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10328),
    [anon_sym_BQUOTE] = ACTIONS(10322),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10328),
    [sym__pair_operator] = ACTIONS(10328),
    [sym__arrow_operator] = ACTIONS(10322),
    [sym__lazy_or_operator] = ACTIONS(10328),
    [sym__lazy_and_operator] = ACTIONS(10328),
    [sym__comparison_operator] = ACTIONS(10322),
    [sym__pipe_right_operator] = ACTIONS(10328),
    [sym__pipe_left_operator] = ACTIONS(10328),
    [sym__ellipsis_operator] = ACTIONS(10322),
    [sym__plus_operator] = ACTIONS(10322),
    [sym__times_operator] = ACTIONS(10322),
    [sym__rational_operator] = ACTIONS(10328),
    [sym__bitshift_operator] = ACTIONS(10328),
    [sym__power_operator] = ACTIONS(10328),
    [sym__tilde_operator] = ACTIONS(10328),
    [sym__type_order_operator] = ACTIONS(10328),
    [sym__unary_operator] = ACTIONS(10322),
    [sym__unary_plus_operator] = ACTIONS(10322),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10775),
    [sym__immediate_bracket] = ACTIONS(10777),
    [sym__immediate_brace] = ACTIONS(10779),
  },
  [6594] = {
    [sym_block_comment] = STATE(6594),
    [sym_line_comment] = STATE(6594),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6595] = {
    [sym_block_comment] = STATE(6595),
    [sym_line_comment] = STATE(6595),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6596] = {
    [sym_block_comment] = STATE(6596),
    [sym_line_comment] = STATE(6596),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10727),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_end] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_elseif] = ACTIONS(10727),
    [anon_sym_else] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10727),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10727),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10727),
    [anon_sym_DOT] = ACTIONS(10715),
    [anon_sym_DOLLAR] = ACTIONS(10727),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_QMARK] = ACTIONS(10727),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10727),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10727),
    [aux_sym_integer_literal_token2] = ACTIONS(10727),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10727),
    [aux_sym_float_literal_token3] = ACTIONS(10727),
    [aux_sym_float_literal_token4] = ACTIONS(10727),
    [sym_character_literal] = ACTIONS(10727),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10727),
    [sym__pair_operator] = ACTIONS(10727),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10727),
    [sym__lazy_and_operator] = ACTIONS(10727),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10727),
    [sym__pipe_left_operator] = ACTIONS(10727),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10727),
    [sym__bitshift_operator] = ACTIONS(10727),
    [sym__power_operator] = ACTIONS(10727),
    [sym__tilde_operator] = ACTIONS(10727),
    [sym__type_order_operator] = ACTIONS(10727),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym__terminator_token1] = ACTIONS(10731),
    [aux_sym__terminator_token2] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6597] = {
    [sym_block_comment] = STATE(6597),
    [sym_line_comment] = STATE(6597),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6598] = {
    [sym_block_comment] = STATE(6598),
    [sym_line_comment] = STATE(6598),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6599] = {
    [sym_block_comment] = STATE(6599),
    [sym_line_comment] = STATE(6599),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10781),
    [sym__immediate_command_start] = ACTIONS(10783),
  },
  [6600] = {
    [sym_block_comment] = STATE(6600),
    [sym_line_comment] = STATE(6600),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10785),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6601] = {
    [sym_block_comment] = STATE(6601),
    [sym_line_comment] = STATE(6601),
    [aux_sym__import_list_repeat1] = STATE(7098),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10749),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_else] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10751),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6602] = {
    [sym_block_comment] = STATE(6602),
    [sym_line_comment] = STATE(6602),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6603] = {
    [sym_block_comment] = STATE(6603),
    [sym_line_comment] = STATE(6603),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_elseif] = ACTIONS(10757),
    [anon_sym_else] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOT] = ACTIONS(10715),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6604] = {
    [sym_block_comment] = STATE(6604),
    [sym_line_comment] = STATE(6604),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10739),
    [sym__immediate_command_start] = ACTIONS(10741),
  },
  [6605] = {
    [sym_block_comment] = STATE(6605),
    [sym_line_comment] = STATE(6605),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6606] = {
    [sym_block_comment] = STATE(6606),
    [sym_line_comment] = STATE(6606),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10729),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6607] = {
    [sym_block_comment] = STATE(6607),
    [sym_line_comment] = STATE(6607),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10787),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6608] = {
    [sym_identifier] = STATE(7026),
    [sym_block_comment] = STATE(6608),
    [sym_line_comment] = STATE(6608),
    [ts_builtin_sym_end] = ACTIONS(9782),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_RBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6609] = {
    [sym_identifier] = STATE(7004),
    [sym_block_comment] = STATE(6609),
    [sym_line_comment] = STATE(6609),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_SQUOTE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9782),
    [sym__immediate_bracket] = ACTIONS(9782),
    [sym__immediate_brace] = ACTIONS(9782),
  },
  [6610] = {
    [sym_identifier] = STATE(7006),
    [sym_block_comment] = STATE(6610),
    [sym_line_comment] = STATE(6610),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_SQUOTE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9786),
    [sym__immediate_bracket] = ACTIONS(9786),
    [sym__immediate_brace] = ACTIONS(9786),
  },
  [6611] = {
    [sym_identifier] = STATE(7024),
    [sym_block_comment] = STATE(6611),
    [sym_line_comment] = STATE(6611),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_SQUOTE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9798),
    [sym__immediate_bracket] = ACTIONS(9798),
    [sym__immediate_brace] = ACTIONS(9798),
  },
  [6612] = {
    [sym_identifier] = STATE(7025),
    [sym_block_comment] = STATE(6612),
    [sym_line_comment] = STATE(6612),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_SQUOTE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9802),
    [sym__immediate_bracket] = ACTIONS(9802),
    [sym__immediate_brace] = ACTIONS(9802),
  },
  [6613] = {
    [sym_identifier] = STATE(7149),
    [sym_block_comment] = STATE(6613),
    [sym_line_comment] = STATE(6613),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6614] = {
    [sym_identifier] = STATE(7150),
    [sym_block_comment] = STATE(6614),
    [sym_line_comment] = STATE(6614),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6615] = {
    [sym_block_comment] = STATE(6615),
    [sym_line_comment] = STATE(6615),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_elseif] = ACTIONS(10761),
    [anon_sym_else] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(10715),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6616] = {
    [sym_identifier] = STATE(7157),
    [sym_block_comment] = STATE(6616),
    [sym_line_comment] = STATE(6616),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6617] = {
    [sym_block_comment] = STATE(6617),
    [sym_line_comment] = STATE(6617),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6618] = {
    [sym_identifier] = STATE(7158),
    [sym_block_comment] = STATE(6618),
    [sym_line_comment] = STATE(6618),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6619] = {
    [sym_block_comment] = STATE(6619),
    [sym_line_comment] = STATE(6619),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_elseif] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6620] = {
    [sym_block_comment] = STATE(6620),
    [sym_line_comment] = STATE(6620),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6621] = {
    [sym_block_comment] = STATE(6621),
    [sym_line_comment] = STATE(6621),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_DASH_GT] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [6622] = {
    [sym_block_comment] = STATE(6622),
    [sym_line_comment] = STATE(6622),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6623] = {
    [sym_block_comment] = STATE(6623),
    [sym_line_comment] = STATE(6623),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_elseif] = ACTIONS(10577),
    [anon_sym_else] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6624] = {
    [sym_block_comment] = STATE(6624),
    [sym_line_comment] = STATE(6624),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10789),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6625] = {
    [sym_block_comment] = STATE(6625),
    [sym_line_comment] = STATE(6625),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6626] = {
    [sym_block_comment] = STATE(6626),
    [sym_line_comment] = STATE(6626),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_elseif] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6627] = {
    [sym_block_comment] = STATE(6627),
    [sym_line_comment] = STATE(6627),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6628] = {
    [sym_block_comment] = STATE(6628),
    [sym_line_comment] = STATE(6628),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_DASH_GT] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6629] = {
    [sym_block_comment] = STATE(6629),
    [sym_line_comment] = STATE(6629),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_elseif] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6630] = {
    [sym_block_comment] = STATE(6630),
    [sym_line_comment] = STATE(6630),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6631] = {
    [sym_identifier] = STATE(6806),
    [sym_block_comment] = STATE(6631),
    [sym_line_comment] = STATE(6631),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_elseif] = ACTIONS(9780),
    [anon_sym_else] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6632] = {
    [sym_identifier] = STATE(6807),
    [sym_block_comment] = STATE(6632),
    [sym_line_comment] = STATE(6632),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_elseif] = ACTIONS(9784),
    [anon_sym_else] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6633] = {
    [sym_block_comment] = STATE(6633),
    [sym_line_comment] = STATE(6633),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_DASH_GT] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6634] = {
    [sym_block_comment] = STATE(6634),
    [sym_line_comment] = STATE(6634),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_elseif] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6635] = {
    [sym_block_comment] = STATE(6635),
    [sym_line_comment] = STATE(6635),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_elseif] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6636] = {
    [sym_block_comment] = STATE(6636),
    [sym_line_comment] = STATE(6636),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_elseif] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6637] = {
    [sym_block_comment] = STATE(6637),
    [sym_line_comment] = STATE(6637),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10791),
    [sym__immediate_command_start] = ACTIONS(10793),
  },
  [6638] = {
    [sym_block_comment] = STATE(6638),
    [sym_line_comment] = STATE(6638),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6639] = {
    [sym_block_comment] = STATE(6639),
    [sym_line_comment] = STATE(6639),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_elseif] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6640] = {
    [sym_block_comment] = STATE(6640),
    [sym_line_comment] = STATE(6640),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_elseif] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6641] = {
    [sym_block_comment] = STATE(6641),
    [sym_line_comment] = STATE(6641),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_DASH_GT] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [6642] = {
    [sym_block_comment] = STATE(6642),
    [sym_line_comment] = STATE(6642),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_elseif] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6643] = {
    [sym_identifier] = STATE(6810),
    [sym_block_comment] = STATE(6643),
    [sym_line_comment] = STATE(6643),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_elseif] = ACTIONS(9796),
    [anon_sym_else] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6644] = {
    [sym_block_comment] = STATE(6644),
    [sym_line_comment] = STATE(6644),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10795),
    [sym__immediate_command_start] = ACTIONS(10797),
  },
  [6645] = {
    [sym_identifier] = STATE(6811),
    [sym_block_comment] = STATE(6645),
    [sym_line_comment] = STATE(6645),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_elseif] = ACTIONS(9800),
    [anon_sym_else] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6646] = {
    [sym_block_comment] = STATE(6646),
    [sym_line_comment] = STATE(6646),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6647] = {
    [sym_block_comment] = STATE(6647),
    [sym_line_comment] = STATE(6647),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_DASH_GT] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6648] = {
    [sym_block_comment] = STATE(6648),
    [sym_line_comment] = STATE(6648),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10088),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10088),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10088),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10088),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10088),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10088),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10088),
    [anon_sym_QMARK] = ACTIONS(10088),
    [anon_sym_DASH_GT] = ACTIONS(10088),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10088),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10088),
    [aux_sym_integer_literal_token2] = ACTIONS(10088),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10088),
    [aux_sym_float_literal_token3] = ACTIONS(10088),
    [aux_sym_float_literal_token4] = ACTIONS(10088),
    [sym_character_literal] = ACTIONS(10088),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10088),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10088),
    [sym__pair_operator] = ACTIONS(10088),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10088),
    [sym__lazy_and_operator] = ACTIONS(10088),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10088),
    [sym__pipe_left_operator] = ACTIONS(10088),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10088),
    [sym__bitshift_operator] = ACTIONS(10088),
    [sym__power_operator] = ACTIONS(10088),
    [sym__tilde_operator] = ACTIONS(10088),
    [sym__type_order_operator] = ACTIONS(10088),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6649] = {
    [sym_block_comment] = STATE(6649),
    [sym_line_comment] = STATE(6649),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10735),
    [sym__immediate_command_start] = ACTIONS(10737),
  },
  [6650] = {
    [sym_block_comment] = STATE(6650),
    [sym_line_comment] = STATE(6650),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10659),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6651] = {
    [sym_block_comment] = STATE(6651),
    [sym_line_comment] = STATE(6651),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_DASH_GT] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6652] = {
    [sym_block_comment] = STATE(6652),
    [sym_line_comment] = STATE(6652),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_elseif] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6653] = {
    [sym_block_comment] = STATE(6653),
    [sym_line_comment] = STATE(6653),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6654] = {
    [sym_block_comment] = STATE(6654),
    [sym_line_comment] = STATE(6654),
    [aux_sym__import_list_repeat1] = STATE(6889),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10765),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_elseif] = ACTIONS(10747),
    [anon_sym_else] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10767),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6655] = {
    [sym_block_comment] = STATE(6655),
    [sym_line_comment] = STATE(6655),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6656] = {
    [sym_block_comment] = STATE(6656),
    [sym_line_comment] = STATE(6656),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_elseif] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6657] = {
    [sym_block_comment] = STATE(6657),
    [sym_line_comment] = STATE(6657),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6658] = {
    [sym_block_comment] = STATE(6658),
    [sym_line_comment] = STATE(6658),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10791),
    [sym__immediate_command_start] = ACTIONS(10793),
  },
  [6659] = {
    [sym_block_comment] = STATE(6659),
    [sym_line_comment] = STATE(6659),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_DASH_GT] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6660] = {
    [sym_block_comment] = STATE(6660),
    [sym_line_comment] = STATE(6660),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [6661] = {
    [sym_block_comment] = STATE(6661),
    [sym_line_comment] = STATE(6661),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_elseif] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6662] = {
    [sym_block_comment] = STATE(6662),
    [sym_line_comment] = STATE(6662),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_elseif] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6663] = {
    [sym_block_comment] = STATE(6663),
    [sym_line_comment] = STATE(6663),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6664] = {
    [sym_block_comment] = STATE(6664),
    [sym_line_comment] = STATE(6664),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6665] = {
    [sym_block_comment] = STATE(6665),
    [sym_line_comment] = STATE(6665),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10713),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6666] = {
    [sym_block_comment] = STATE(6666),
    [sym_line_comment] = STATE(6666),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_elseif] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6667] = {
    [sym_block_comment] = STATE(6667),
    [sym_line_comment] = STATE(6667),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_elseif] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6668] = {
    [sym_block_comment] = STATE(6668),
    [sym_line_comment] = STATE(6668),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6669] = {
    [sym_block_comment] = STATE(6669),
    [sym_line_comment] = STATE(6669),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6670] = {
    [sym_block_comment] = STATE(6670),
    [sym_line_comment] = STATE(6670),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6671] = {
    [sym_block_comment] = STATE(6671),
    [sym_line_comment] = STATE(6671),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_elseif] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6672] = {
    [sym_block_comment] = STATE(6672),
    [sym_line_comment] = STATE(6672),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6673] = {
    [sym_block_comment] = STATE(6673),
    [sym_line_comment] = STATE(6673),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6674] = {
    [sym_block_comment] = STATE(6674),
    [sym_line_comment] = STATE(6674),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6675] = {
    [sym_block_comment] = STATE(6675),
    [sym_line_comment] = STATE(6675),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_elseif] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6676] = {
    [sym_block_comment] = STATE(6676),
    [sym_line_comment] = STATE(6676),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6677] = {
    [sym_block_comment] = STATE(6677),
    [sym_line_comment] = STATE(6677),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_DASH_GT] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6678] = {
    [sym_block_comment] = STATE(6678),
    [sym_line_comment] = STATE(6678),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_DASH_GT] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6679] = {
    [sym_block_comment] = STATE(6679),
    [sym_line_comment] = STATE(6679),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_RPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_RBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_SEMI] = ACTIONS(10639),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_RBRACE] = ACTIONS(10639),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6680] = {
    [sym_block_comment] = STATE(6680),
    [sym_line_comment] = STATE(6680),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_elseif] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6681] = {
    [sym_block_comment] = STATE(6681),
    [sym_line_comment] = STATE(6681),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_DASH_GT] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6682] = {
    [sym_block_comment] = STATE(6682),
    [sym_line_comment] = STATE(6682),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6683] = {
    [sym_block_comment] = STATE(6683),
    [sym_line_comment] = STATE(6683),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_elseif] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6684] = {
    [sym_block_comment] = STATE(6684),
    [sym_line_comment] = STATE(6684),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10781),
    [sym__immediate_command_start] = ACTIONS(10783),
  },
  [6685] = {
    [sym_block_comment] = STATE(6685),
    [sym_line_comment] = STATE(6685),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10795),
    [sym__immediate_command_start] = ACTIONS(10797),
  },
  [6686] = {
    [sym_block_comment] = STATE(6686),
    [sym_line_comment] = STATE(6686),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_DASH_GT] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [6687] = {
    [sym_block_comment] = STATE(6687),
    [sym_line_comment] = STATE(6687),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_elseif] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6688] = {
    [sym_block_comment] = STATE(6688),
    [sym_line_comment] = STATE(6688),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6689] = {
    [sym_block_comment] = STATE(6689),
    [sym_line_comment] = STATE(6689),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(10721),
    [sym__immediate_command_start] = ACTIONS(10723),
  },
  [6690] = {
    [sym__primary_expression] = STATE(10491),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10165),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(6690),
    [sym_line_comment] = STATE(6690),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9888),
    [anon_sym_COLON2] = ACTIONS(9135),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [6691] = {
    [sym_block_comment] = STATE(6691),
    [sym_line_comment] = STATE(6691),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_DASH_GT] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6692] = {
    [sym_block_comment] = STATE(6692),
    [sym_line_comment] = STATE(6692),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_DASH_GT] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6693] = {
    [sym_block_comment] = STATE(6693),
    [sym_line_comment] = STATE(6693),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6694] = {
    [sym_block_comment] = STATE(6694),
    [sym_line_comment] = STATE(6694),
    [ts_builtin_sym_end] = ACTIONS(10639),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_RBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6695] = {
    [sym_block_comment] = STATE(6695),
    [sym_line_comment] = STATE(6695),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6696] = {
    [sym_block_comment] = STATE(6696),
    [sym_line_comment] = STATE(6696),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6697] = {
    [sym_block_comment] = STATE(6697),
    [sym_line_comment] = STATE(6697),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6698] = {
    [sym_block_comment] = STATE(6698),
    [sym_line_comment] = STATE(6698),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_catch] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6699] = {
    [sym_block_comment] = STATE(6699),
    [sym_line_comment] = STATE(6699),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6700] = {
    [sym_block_comment] = STATE(6700),
    [sym_line_comment] = STATE(6700),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6701] = {
    [sym_block_comment] = STATE(6701),
    [sym_line_comment] = STATE(6701),
    [aux_sym__import_list_repeat1] = STATE(7749),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10799),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10801),
    [anon_sym_LPAREN] = ACTIONS(10755),
    [anon_sym_RPAREN] = ACTIONS(10755),
    [anon_sym_COLON] = ACTIONS(10803),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10755),
    [anon_sym_RBRACK] = ACTIONS(10755),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_SEMI] = ACTIONS(10755),
    [anon_sym_LBRACE] = ACTIONS(10755),
    [anon_sym_RBRACE] = ACTIONS(10755),
    [anon_sym_DOLLAR] = ACTIONS(10755),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10755),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10755),
    [anon_sym_QMARK] = ACTIONS(10755),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10755),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10755),
    [aux_sym_integer_literal_token2] = ACTIONS(10755),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10755),
    [aux_sym_float_literal_token3] = ACTIONS(10755),
    [aux_sym_float_literal_token4] = ACTIONS(10755),
    [sym_character_literal] = ACTIONS(10755),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10755),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10755),
    [sym__pair_operator] = ACTIONS(10755),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10755),
    [sym__lazy_and_operator] = ACTIONS(10755),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10755),
    [sym__pipe_left_operator] = ACTIONS(10755),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10755),
    [sym__bitshift_operator] = ACTIONS(10755),
    [sym__power_operator] = ACTIONS(10755),
    [sym__tilde_operator] = ACTIONS(10755),
    [sym__type_order_operator] = ACTIONS(10755),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6702] = {
    [sym_block_comment] = STATE(6702),
    [sym_line_comment] = STATE(6702),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10759),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10759),
    [anon_sym_RPAREN] = ACTIONS(10759),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10759),
    [anon_sym_RBRACK] = ACTIONS(10759),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_SEMI] = ACTIONS(10759),
    [anon_sym_LBRACE] = ACTIONS(10759),
    [anon_sym_RBRACE] = ACTIONS(10759),
    [anon_sym_DOT] = ACTIONS(10805),
    [anon_sym_DOLLAR] = ACTIONS(10759),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10759),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10759),
    [anon_sym_QMARK] = ACTIONS(10759),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10759),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10759),
    [aux_sym_integer_literal_token2] = ACTIONS(10759),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10759),
    [aux_sym_float_literal_token3] = ACTIONS(10759),
    [aux_sym_float_literal_token4] = ACTIONS(10759),
    [sym_character_literal] = ACTIONS(10759),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10759),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10759),
    [sym__pair_operator] = ACTIONS(10759),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10759),
    [sym__lazy_and_operator] = ACTIONS(10759),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10759),
    [sym__pipe_left_operator] = ACTIONS(10759),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10759),
    [sym__bitshift_operator] = ACTIONS(10759),
    [sym__power_operator] = ACTIONS(10759),
    [sym__tilde_operator] = ACTIONS(10759),
    [sym__type_order_operator] = ACTIONS(10759),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6703] = {
    [sym_block_comment] = STATE(6703),
    [sym_line_comment] = STATE(6703),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10763),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10763),
    [anon_sym_RPAREN] = ACTIONS(10763),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10763),
    [anon_sym_RBRACK] = ACTIONS(10763),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_SEMI] = ACTIONS(10763),
    [anon_sym_LBRACE] = ACTIONS(10763),
    [anon_sym_RBRACE] = ACTIONS(10763),
    [anon_sym_DOT] = ACTIONS(10805),
    [anon_sym_DOLLAR] = ACTIONS(10763),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10763),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10763),
    [anon_sym_QMARK] = ACTIONS(10763),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10763),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10763),
    [aux_sym_integer_literal_token2] = ACTIONS(10763),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10763),
    [aux_sym_float_literal_token3] = ACTIONS(10763),
    [aux_sym_float_literal_token4] = ACTIONS(10763),
    [sym_character_literal] = ACTIONS(10763),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10763),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10763),
    [sym__pair_operator] = ACTIONS(10763),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10763),
    [sym__lazy_and_operator] = ACTIONS(10763),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10763),
    [sym__pipe_left_operator] = ACTIONS(10763),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10763),
    [sym__bitshift_operator] = ACTIONS(10763),
    [sym__power_operator] = ACTIONS(10763),
    [sym__tilde_operator] = ACTIONS(10763),
    [sym__type_order_operator] = ACTIONS(10763),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6704] = {
    [sym_block_comment] = STATE(6704),
    [sym_line_comment] = STATE(6704),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
  },
  [6705] = {
    [sym_block_comment] = STATE(6705),
    [sym_line_comment] = STATE(6705),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
  },
  [6706] = {
    [sym_block_comment] = STATE(6706),
    [sym_line_comment] = STATE(6706),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_RPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_RBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_SEMI] = ACTIONS(10639),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_RBRACE] = ACTIONS(10639),
    [anon_sym_DOT] = ACTIONS(10805),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6707] = {
    [sym_block_comment] = STATE(6707),
    [sym_line_comment] = STATE(6707),
    [aux_sym_export_statement_repeat1] = STATE(6883),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(10809),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_end] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_elseif] = ACTIONS(10807),
    [anon_sym_else] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10807),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10807),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10807),
    [anon_sym_DOLLAR] = ACTIONS(10807),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10807),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10807),
    [anon_sym_QMARK] = ACTIONS(10807),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10807),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10807),
    [aux_sym_integer_literal_token2] = ACTIONS(10807),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10807),
    [aux_sym_float_literal_token3] = ACTIONS(10807),
    [aux_sym_float_literal_token4] = ACTIONS(10807),
    [sym_character_literal] = ACTIONS(10807),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10807),
    [sym__pair_operator] = ACTIONS(10807),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10807),
    [sym__lazy_and_operator] = ACTIONS(10807),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10807),
    [sym__pipe_left_operator] = ACTIONS(10807),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10807),
    [sym__bitshift_operator] = ACTIONS(10807),
    [sym__power_operator] = ACTIONS(10807),
    [sym__tilde_operator] = ACTIONS(10807),
    [sym__type_order_operator] = ACTIONS(10807),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym__terminator_token1] = ACTIONS(10811),
    [aux_sym__terminator_token2] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6708] = {
    [sym_block_comment] = STATE(6708),
    [sym_line_comment] = STATE(6708),
    [aux_sym_export_statement_repeat1] = STATE(6885),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(10809),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_end] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_elseif] = ACTIONS(10813),
    [anon_sym_else] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10813),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10813),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10813),
    [anon_sym_DOLLAR] = ACTIONS(10813),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10813),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10813),
    [anon_sym_QMARK] = ACTIONS(10813),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10813),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10813),
    [aux_sym_integer_literal_token2] = ACTIONS(10813),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10813),
    [aux_sym_float_literal_token3] = ACTIONS(10813),
    [aux_sym_float_literal_token4] = ACTIONS(10813),
    [sym_character_literal] = ACTIONS(10813),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10813),
    [sym__pair_operator] = ACTIONS(10813),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10813),
    [sym__lazy_and_operator] = ACTIONS(10813),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10813),
    [sym__pipe_left_operator] = ACTIONS(10813),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10813),
    [sym__bitshift_operator] = ACTIONS(10813),
    [sym__power_operator] = ACTIONS(10813),
    [sym__tilde_operator] = ACTIONS(10813),
    [sym__type_order_operator] = ACTIONS(10813),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym__terminator_token1] = ACTIONS(10815),
    [aux_sym__terminator_token2] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6709] = {
    [sym_block_comment] = STATE(6709),
    [sym_line_comment] = STATE(6709),
    [aux_sym__import_list_repeat1] = STATE(6889),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10765),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_elseif] = ACTIONS(10747),
    [anon_sym_else] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6710] = {
    [sym_block_comment] = STATE(6710),
    [sym_line_comment] = STATE(6710),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_elseif] = ACTIONS(10757),
    [anon_sym_else] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6711] = {
    [sym_block_comment] = STATE(6711),
    [sym_line_comment] = STATE(6711),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10725),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6712] = {
    [sym_identifier] = STATE(7664),
    [sym_block_comment] = STATE(6712),
    [sym_line_comment] = STATE(6712),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_RPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_RBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_SEMI] = ACTIONS(9782),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_RBRACE] = ACTIONS(9782),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6713] = {
    [sym_identifier] = STATE(7667),
    [sym_block_comment] = STATE(6713),
    [sym_line_comment] = STATE(6713),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_RPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_RBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_SEMI] = ACTIONS(9786),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_RBRACE] = ACTIONS(9786),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6714] = {
    [sym_identifier] = STATE(7674),
    [sym_block_comment] = STATE(6714),
    [sym_line_comment] = STATE(6714),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_RPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_RBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_SEMI] = ACTIONS(9798),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_RBRACE] = ACTIONS(9798),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6715] = {
    [sym_identifier] = STATE(7675),
    [sym_block_comment] = STATE(6715),
    [sym_line_comment] = STATE(6715),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_RPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_RBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_SEMI] = ACTIONS(9802),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_RBRACE] = ACTIONS(9802),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6716] = {
    [sym_block_comment] = STATE(6716),
    [sym_line_comment] = STATE(6716),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10733),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6717] = {
    [sym_block_comment] = STATE(6717),
    [sym_line_comment] = STATE(6717),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [6718] = {
    [sym_block_comment] = STATE(6718),
    [sym_line_comment] = STATE(6718),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10717),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6719] = {
    [sym_block_comment] = STATE(6719),
    [sym_line_comment] = STATE(6719),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6720] = {
    [sym_block_comment] = STATE(6720),
    [sym_line_comment] = STATE(6720),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6721] = {
    [sym_block_comment] = STATE(6721),
    [sym_line_comment] = STATE(6721),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10731),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10731),
    [anon_sym_RPAREN] = ACTIONS(10731),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10731),
    [anon_sym_RBRACK] = ACTIONS(10731),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_SEMI] = ACTIONS(10731),
    [anon_sym_LBRACE] = ACTIONS(10731),
    [anon_sym_RBRACE] = ACTIONS(10731),
    [anon_sym_DOT] = ACTIONS(10805),
    [anon_sym_DOLLAR] = ACTIONS(10731),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10731),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10731),
    [anon_sym_QMARK] = ACTIONS(10731),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10731),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10731),
    [aux_sym_integer_literal_token2] = ACTIONS(10731),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10731),
    [aux_sym_float_literal_token3] = ACTIONS(10731),
    [aux_sym_float_literal_token4] = ACTIONS(10731),
    [sym_character_literal] = ACTIONS(10731),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10731),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10731),
    [sym__pair_operator] = ACTIONS(10731),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10731),
    [sym__lazy_and_operator] = ACTIONS(10731),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10731),
    [sym__pipe_left_operator] = ACTIONS(10731),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10731),
    [sym__bitshift_operator] = ACTIONS(10731),
    [sym__power_operator] = ACTIONS(10731),
    [sym__tilde_operator] = ACTIONS(10731),
    [sym__type_order_operator] = ACTIONS(10731),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6722] = {
    [sym_block_comment] = STATE(6722),
    [sym_line_comment] = STATE(6722),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_elseif] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6723] = {
    [sym_block_comment] = STATE(6723),
    [sym_line_comment] = STATE(6723),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6724] = {
    [sym_block_comment] = STATE(6724),
    [sym_line_comment] = STATE(6724),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6725] = {
    [sym_block_comment] = STATE(6725),
    [sym_line_comment] = STATE(6725),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6726] = {
    [sym_block_comment] = STATE(6726),
    [sym_line_comment] = STATE(6726),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6727] = {
    [sym_block_comment] = STATE(6727),
    [sym_line_comment] = STATE(6727),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6728] = {
    [sym_block_comment] = STATE(6728),
    [sym_line_comment] = STATE(6728),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10817),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6729] = {
    [sym_block_comment] = STATE(6729),
    [sym_line_comment] = STATE(6729),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6730] = {
    [sym_block_comment] = STATE(6730),
    [sym_line_comment] = STATE(6730),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6731] = {
    [sym_block_comment] = STATE(6731),
    [sym_line_comment] = STATE(6731),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6732] = {
    [sym_block_comment] = STATE(6732),
    [sym_line_comment] = STATE(6732),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6733] = {
    [sym_block_comment] = STATE(6733),
    [sym_line_comment] = STATE(6733),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_SQUOTE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9734),
    [sym__immediate_bracket] = ACTIONS(9734),
    [sym__immediate_brace] = ACTIONS(9734),
  },
  [6734] = {
    [sym_block_comment] = STATE(6734),
    [sym_line_comment] = STATE(6734),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6735] = {
    [sym_block_comment] = STATE(6735),
    [sym_line_comment] = STATE(6735),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_SQUOTE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10136),
    [sym__immediate_bracket] = ACTIONS(10136),
    [sym__immediate_brace] = ACTIONS(10136),
  },
  [6736] = {
    [sym_block_comment] = STATE(6736),
    [sym_line_comment] = STATE(6736),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_elseif] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6737] = {
    [sym_block_comment] = STATE(6737),
    [sym_line_comment] = STATE(6737),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6738] = {
    [sym_block_comment] = STATE(6738),
    [sym_line_comment] = STATE(6738),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_SQUOTE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9914),
    [sym__immediate_bracket] = ACTIONS(9914),
    [sym__immediate_brace] = ACTIONS(9914),
  },
  [6739] = {
    [sym_block_comment] = STATE(6739),
    [sym_line_comment] = STATE(6739),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6740] = {
    [sym_block_comment] = STATE(6740),
    [sym_line_comment] = STATE(6740),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6741] = {
    [sym_block_comment] = STATE(6741),
    [sym_line_comment] = STATE(6741),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6742] = {
    [sym_block_comment] = STATE(6742),
    [sym_line_comment] = STATE(6742),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6743] = {
    [sym_block_comment] = STATE(6743),
    [sym_line_comment] = STATE(6743),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6744] = {
    [sym_block_comment] = STATE(6744),
    [sym_line_comment] = STATE(6744),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6745] = {
    [sym_block_comment] = STATE(6745),
    [sym_line_comment] = STATE(6745),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6746] = {
    [sym_block_comment] = STATE(6746),
    [sym_line_comment] = STATE(6746),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6747] = {
    [sym_block_comment] = STATE(6747),
    [sym_line_comment] = STATE(6747),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6748] = {
    [sym_block_comment] = STATE(6748),
    [sym_line_comment] = STATE(6748),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_elseif] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6749] = {
    [sym_block_comment] = STATE(6749),
    [sym_line_comment] = STATE(6749),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_elseif] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6750] = {
    [sym_block_comment] = STATE(6750),
    [sym_line_comment] = STATE(6750),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_else] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6751] = {
    [sym_block_comment] = STATE(6751),
    [sym_line_comment] = STATE(6751),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6752] = {
    [sym_block_comment] = STATE(6752),
    [sym_line_comment] = STATE(6752),
    [aux_sym__import_list_repeat1] = STATE(7490),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10819),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_catch] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10821),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10823),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6753] = {
    [sym_block_comment] = STATE(6753),
    [sym_line_comment] = STATE(6753),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10745),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6754] = {
    [sym_block_comment] = STATE(6754),
    [sym_line_comment] = STATE(6754),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6755] = {
    [sym_block_comment] = STATE(6755),
    [sym_line_comment] = STATE(6755),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6756] = {
    [sym_block_comment] = STATE(6756),
    [sym_line_comment] = STATE(6756),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6757] = {
    [sym_block_comment] = STATE(6757),
    [sym_line_comment] = STATE(6757),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6758] = {
    [sym_block_comment] = STATE(6758),
    [sym_line_comment] = STATE(6758),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6759] = {
    [sym_block_comment] = STATE(6759),
    [sym_line_comment] = STATE(6759),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_catch] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOT] = ACTIONS(10825),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6760] = {
    [sym_block_comment] = STATE(6760),
    [sym_line_comment] = STATE(6760),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_catch] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(10825),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6761] = {
    [sym_block_comment] = STATE(6761),
    [sym_line_comment] = STATE(6761),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6762] = {
    [sym_identifier] = STATE(7238),
    [sym_block_comment] = STATE(6762),
    [sym_line_comment] = STATE(6762),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6763] = {
    [sym_identifier] = STATE(7345),
    [sym_block_comment] = STATE(6763),
    [sym_line_comment] = STATE(6763),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6764] = {
    [sym_identifier] = STATE(7427),
    [sym_block_comment] = STATE(6764),
    [sym_line_comment] = STATE(6764),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6765] = {
    [sym_identifier] = STATE(7435),
    [sym_block_comment] = STATE(6765),
    [sym_line_comment] = STATE(6765),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6766] = {
    [sym_block_comment] = STATE(6766),
    [sym_line_comment] = STATE(6766),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6767] = {
    [sym_block_comment] = STATE(6767),
    [sym_line_comment] = STATE(6767),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6768] = {
    [sym_block_comment] = STATE(6768),
    [sym_line_comment] = STATE(6768),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6769] = {
    [sym_block_comment] = STATE(6769),
    [sym_line_comment] = STATE(6769),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6770] = {
    [sym_block_comment] = STATE(6770),
    [sym_line_comment] = STATE(6770),
    [aux_sym__import_list_repeat1] = STATE(7749),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10799),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10801),
    [anon_sym_LPAREN] = ACTIONS(10755),
    [anon_sym_RPAREN] = ACTIONS(10755),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10755),
    [anon_sym_RBRACK] = ACTIONS(10755),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_SEMI] = ACTIONS(10755),
    [anon_sym_LBRACE] = ACTIONS(10755),
    [anon_sym_RBRACE] = ACTIONS(10755),
    [anon_sym_DOLLAR] = ACTIONS(10755),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10755),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10755),
    [anon_sym_QMARK] = ACTIONS(10755),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10755),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10755),
    [aux_sym_integer_literal_token2] = ACTIONS(10755),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10755),
    [aux_sym_float_literal_token3] = ACTIONS(10755),
    [aux_sym_float_literal_token4] = ACTIONS(10755),
    [sym_character_literal] = ACTIONS(10755),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10755),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10755),
    [sym__pair_operator] = ACTIONS(10755),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10755),
    [sym__lazy_and_operator] = ACTIONS(10755),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10755),
    [sym__pipe_left_operator] = ACTIONS(10755),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10755),
    [sym__bitshift_operator] = ACTIONS(10755),
    [sym__power_operator] = ACTIONS(10755),
    [sym__tilde_operator] = ACTIONS(10755),
    [sym__type_order_operator] = ACTIONS(10755),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6771] = {
    [sym_block_comment] = STATE(6771),
    [sym_line_comment] = STATE(6771),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_elseif] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6772] = {
    [sym_block_comment] = STATE(6772),
    [sym_line_comment] = STATE(6772),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10827),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6773] = {
    [sym_block_comment] = STATE(6773),
    [sym_line_comment] = STATE(6773),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_elseif] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6774] = {
    [sym_block_comment] = STATE(6774),
    [sym_line_comment] = STATE(6774),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9636),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6775] = {
    [sym_block_comment] = STATE(6775),
    [sym_line_comment] = STATE(6775),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_elseif] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6776] = {
    [sym_block_comment] = STATE(6776),
    [sym_line_comment] = STATE(6776),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_elseif] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6777] = {
    [sym_block_comment] = STATE(6777),
    [sym_line_comment] = STATE(6777),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6778] = {
    [sym_block_comment] = STATE(6778),
    [sym_line_comment] = STATE(6778),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6779] = {
    [sym_block_comment] = STATE(6779),
    [sym_line_comment] = STATE(6779),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6780] = {
    [sym_block_comment] = STATE(6780),
    [sym_line_comment] = STATE(6780),
    [aux_sym_open_tuple_repeat1] = STATE(6787),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_end] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_else] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_finally] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10829),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10829),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10829),
    [anon_sym_DOLLAR] = ACTIONS(10829),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10829),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10829),
    [anon_sym_QMARK] = ACTIONS(10829),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10829),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10829),
    [aux_sym_integer_literal_token2] = ACTIONS(10829),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10829),
    [aux_sym_float_literal_token3] = ACTIONS(10829),
    [aux_sym_float_literal_token4] = ACTIONS(10829),
    [sym_character_literal] = ACTIONS(10829),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10829),
    [sym__pair_operator] = ACTIONS(10829),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10829),
    [sym__lazy_and_operator] = ACTIONS(10829),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10829),
    [sym__pipe_left_operator] = ACTIONS(10829),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10829),
    [sym__bitshift_operator] = ACTIONS(10829),
    [sym__power_operator] = ACTIONS(10829),
    [sym__tilde_operator] = ACTIONS(10829),
    [sym__type_order_operator] = ACTIONS(10829),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym__terminator_token1] = ACTIONS(10833),
    [aux_sym__terminator_token2] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6781] = {
    [sym_block_comment] = STATE(6781),
    [sym_line_comment] = STATE(6781),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_elseif] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6782] = {
    [sym_block_comment] = STATE(6782),
    [sym_line_comment] = STATE(6782),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_elseif] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6783] = {
    [sym_block_comment] = STATE(6783),
    [sym_line_comment] = STATE(6783),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_elseif] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6784] = {
    [sym_block_comment] = STATE(6784),
    [sym_line_comment] = STATE(6784),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_elseif] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6785] = {
    [sym_block_comment] = STATE(6785),
    [sym_line_comment] = STATE(6785),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_elseif] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6786] = {
    [sym_block_comment] = STATE(6786),
    [sym_line_comment] = STATE(6786),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6787] = {
    [sym_block_comment] = STATE(6787),
    [sym_line_comment] = STATE(6787),
    [aux_sym_open_tuple_repeat1] = STATE(6787),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10837),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_else] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_finally] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10835),
    [anon_sym_QMARK] = ACTIONS(10835),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10835),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10835),
    [sym__lazy_and_operator] = ACTIONS(10835),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10835),
    [sym__pipe_left_operator] = ACTIONS(10835),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10835),
    [sym__bitshift_operator] = ACTIONS(10835),
    [sym__power_operator] = ACTIONS(10835),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10835),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6788] = {
    [sym_block_comment] = STATE(6788),
    [sym_line_comment] = STATE(6788),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_elseif] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6789] = {
    [sym_block_comment] = STATE(6789),
    [sym_line_comment] = STATE(6789),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_elseif] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6790] = {
    [sym_block_comment] = STATE(6790),
    [sym_line_comment] = STATE(6790),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_elseif] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6791] = {
    [sym_block_comment] = STATE(6791),
    [sym_line_comment] = STATE(6791),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_elseif] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6792] = {
    [sym_block_comment] = STATE(6792),
    [sym_line_comment] = STATE(6792),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6793] = {
    [sym_block_comment] = STATE(6793),
    [sym_line_comment] = STATE(6793),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_elseif] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6794] = {
    [sym_block_comment] = STATE(6794),
    [sym_line_comment] = STATE(6794),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_elseif] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6795] = {
    [sym_block_comment] = STATE(6795),
    [sym_line_comment] = STATE(6795),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_elseif] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6796] = {
    [sym_block_comment] = STATE(6796),
    [sym_line_comment] = STATE(6796),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_elseif] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6797] = {
    [sym_block_comment] = STATE(6797),
    [sym_line_comment] = STATE(6797),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6798] = {
    [sym_block_comment] = STATE(6798),
    [sym_line_comment] = STATE(6798),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6799] = {
    [sym_block_comment] = STATE(6799),
    [sym_line_comment] = STATE(6799),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_elseif] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6800] = {
    [sym_block_comment] = STATE(6800),
    [sym_line_comment] = STATE(6800),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_elseif] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6801] = {
    [sym_block_comment] = STATE(6801),
    [sym_line_comment] = STATE(6801),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
  },
  [6802] = {
    [sym_block_comment] = STATE(6802),
    [sym_line_comment] = STATE(6802),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_elseif] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6803] = {
    [sym_block_comment] = STATE(6803),
    [sym_line_comment] = STATE(6803),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_elseif] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6804] = {
    [sym_block_comment] = STATE(6804),
    [sym_line_comment] = STATE(6804),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_elseif] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6805] = {
    [sym_block_comment] = STATE(6805),
    [sym_line_comment] = STATE(6805),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_elseif] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6806] = {
    [sym_block_comment] = STATE(6806),
    [sym_line_comment] = STATE(6806),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_elseif] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6807] = {
    [sym_block_comment] = STATE(6807),
    [sym_line_comment] = STATE(6807),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_elseif] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6808] = {
    [sym_block_comment] = STATE(6808),
    [sym_line_comment] = STATE(6808),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_elseif] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6809] = {
    [sym_block_comment] = STATE(6809),
    [sym_line_comment] = STATE(6809),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_elseif] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6810] = {
    [sym_block_comment] = STATE(6810),
    [sym_line_comment] = STATE(6810),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_elseif] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6811] = {
    [sym_block_comment] = STATE(6811),
    [sym_line_comment] = STATE(6811),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_elseif] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6812] = {
    [sym_block_comment] = STATE(6812),
    [sym_line_comment] = STATE(6812),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10842),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6813] = {
    [sym_block_comment] = STATE(6813),
    [sym_line_comment] = STATE(6813),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_elseif] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10844),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6814] = {
    [sym_block_comment] = STATE(6814),
    [sym_line_comment] = STATE(6814),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_elseif] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6815] = {
    [sym_block_comment] = STATE(6815),
    [sym_line_comment] = STATE(6815),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6816] = {
    [sym_block_comment] = STATE(6816),
    [sym_line_comment] = STATE(6816),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
  },
  [6817] = {
    [sym_block_comment] = STATE(6817),
    [sym_line_comment] = STATE(6817),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9654),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6818] = {
    [sym_block_comment] = STATE(6818),
    [sym_line_comment] = STATE(6818),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6819] = {
    [sym_block_comment] = STATE(6819),
    [sym_line_comment] = STATE(6819),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10846),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6820] = {
    [sym_block_comment] = STATE(6820),
    [sym_line_comment] = STATE(6820),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6821] = {
    [sym_block_comment] = STATE(6821),
    [sym_line_comment] = STATE(6821),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6822] = {
    [sym_block_comment] = STATE(6822),
    [sym_line_comment] = STATE(6822),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6823] = {
    [sym_block_comment] = STATE(6823),
    [sym_line_comment] = STATE(6823),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_SQUOTE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9644),
    [sym__immediate_bracket] = ACTIONS(9644),
    [sym__immediate_brace] = ACTIONS(9644),
  },
  [6824] = {
    [sym_block_comment] = STATE(6824),
    [sym_line_comment] = STATE(6824),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10848),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6825] = {
    [sym_identifier] = STATE(7523),
    [sym_block_comment] = STATE(6825),
    [sym_line_comment] = STATE(6825),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_catch] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6826] = {
    [sym_identifier] = STATE(7545),
    [sym_block_comment] = STATE(6826),
    [sym_line_comment] = STATE(6826),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_catch] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6827] = {
    [sym_identifier] = STATE(7701),
    [sym_block_comment] = STATE(6827),
    [sym_line_comment] = STATE(6827),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_catch] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6828] = {
    [sym_identifier] = STATE(7709),
    [sym_block_comment] = STATE(6828),
    [sym_line_comment] = STATE(6828),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_catch] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6829] = {
    [sym_block_comment] = STATE(6829),
    [sym_line_comment] = STATE(6829),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6830] = {
    [sym_block_comment] = STATE(6830),
    [sym_line_comment] = STATE(6830),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [6831] = {
    [sym_block_comment] = STATE(6831),
    [sym_line_comment] = STATE(6831),
    [aux_sym_export_statement_repeat1] = STATE(6831),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10852),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_else] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_finally] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6832] = {
    [sym_block_comment] = STATE(6832),
    [sym_line_comment] = STATE(6832),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10857),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6833] = {
    [sym_block_comment] = STATE(6833),
    [sym_line_comment] = STATE(6833),
    [sym__word_identifier] = ACTIONS(10086),
    [anon_sym_COMMA] = ACTIONS(10088),
    [anon_sym_EQ] = ACTIONS(10086),
    [anon_sym_begin] = ACTIONS(10086),
    [anon_sym_module] = ACTIONS(10086),
    [anon_sym_baremodule] = ACTIONS(10086),
    [anon_sym_end] = ACTIONS(10086),
    [anon_sym_abstract] = ACTIONS(10086),
    [anon_sym_primitive] = ACTIONS(10086),
    [anon_sym_mutable] = ACTIONS(10086),
    [anon_sym_struct] = ACTIONS(10086),
    [anon_sym_function] = ACTIONS(10086),
    [anon_sym_macro] = ACTIONS(10086),
    [anon_sym_quote] = ACTIONS(10086),
    [anon_sym_let] = ACTIONS(10086),
    [anon_sym_if] = ACTIONS(10086),
    [anon_sym_try] = ACTIONS(10086),
    [anon_sym_for] = ACTIONS(10086),
    [anon_sym_while] = ACTIONS(10086),
    [sym_break_statement] = ACTIONS(10086),
    [sym_continue_statement] = ACTIONS(10086),
    [anon_sym_return] = ACTIONS(10086),
    [anon_sym_const] = ACTIONS(10086),
    [anon_sym_global] = ACTIONS(10086),
    [anon_sym_local] = ACTIONS(10086),
    [anon_sym_LPAREN] = ACTIONS(10088),
    [anon_sym_COLON] = ACTIONS(10086),
    [anon_sym_export] = ACTIONS(10086),
    [anon_sym_public] = ACTIONS(10086),
    [anon_sym_import] = ACTIONS(10086),
    [anon_sym_using] = ACTIONS(10086),
    [anon_sym_LBRACK] = ACTIONS(10088),
    [anon_sym_in] = ACTIONS(10086),
    [anon_sym_LBRACE] = ACTIONS(10088),
    [anon_sym_SQUOTE] = ACTIONS(10086),
    [anon_sym_DOT] = ACTIONS(10086),
    [anon_sym_DOLLAR] = ACTIONS(10088),
    [anon_sym_COLON2] = ACTIONS(10086),
    [anon_sym_COLON_COLON] = ACTIONS(10088),
    [anon_sym_isa] = ACTIONS(10086),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10088),
    [anon_sym_QMARK] = ACTIONS(10088),
    [anon_sym_where] = ACTIONS(10086),
    [anon_sym_AT] = ACTIONS(10088),
    [anon_sym_true] = ACTIONS(10086),
    [anon_sym_false] = ACTIONS(10086),
    [aux_sym_integer_literal_token1] = ACTIONS(10088),
    [aux_sym_integer_literal_token2] = ACTIONS(10088),
    [aux_sym_integer_literal_token3] = ACTIONS(10086),
    [aux_sym_integer_literal_token4] = ACTIONS(10086),
    [aux_sym_float_literal_token1] = ACTIONS(10088),
    [aux_sym_float_literal_token3] = ACTIONS(10088),
    [aux_sym_float_literal_token4] = ACTIONS(10088),
    [sym_character_literal] = ACTIONS(10088),
    [anon_sym_DQUOTE] = ACTIONS(10086),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10088),
    [anon_sym_BQUOTE] = ACTIONS(10086),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10088),
    [sym__pair_operator] = ACTIONS(10088),
    [sym__arrow_operator] = ACTIONS(10086),
    [sym__lazy_or_operator] = ACTIONS(10088),
    [sym__lazy_and_operator] = ACTIONS(10088),
    [sym__comparison_operator] = ACTIONS(10086),
    [sym__pipe_right_operator] = ACTIONS(10088),
    [sym__pipe_left_operator] = ACTIONS(10088),
    [sym__ellipsis_operator] = ACTIONS(10086),
    [sym__plus_operator] = ACTIONS(10086),
    [sym__times_operator] = ACTIONS(10086),
    [sym__rational_operator] = ACTIONS(10088),
    [sym__bitshift_operator] = ACTIONS(10088),
    [sym__power_operator] = ACTIONS(10088),
    [sym__tilde_operator] = ACTIONS(10088),
    [sym__type_order_operator] = ACTIONS(10088),
    [sym__unary_operator] = ACTIONS(10086),
    [sym__unary_plus_operator] = ACTIONS(10086),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10088),
    [sym__immediate_bracket] = ACTIONS(10088),
    [sym__immediate_brace] = ACTIONS(10088),
  },
  [6834] = {
    [sym_block_comment] = STATE(6834),
    [sym_line_comment] = STATE(6834),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6835] = {
    [sym_block_comment] = STATE(6835),
    [sym_line_comment] = STATE(6835),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6836] = {
    [sym_block_comment] = STATE(6836),
    [sym_line_comment] = STATE(6836),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10859),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6837] = {
    [sym_block_comment] = STATE(6837),
    [sym_line_comment] = STATE(6837),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6838] = {
    [sym_block_comment] = STATE(6838),
    [sym_line_comment] = STATE(6838),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6839] = {
    [sym_block_comment] = STATE(6839),
    [sym_line_comment] = STATE(6839),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6840] = {
    [sym_block_comment] = STATE(6840),
    [sym_line_comment] = STATE(6840),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6841] = {
    [sym_block_comment] = STATE(6841),
    [sym_line_comment] = STATE(6841),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6842] = {
    [sym_block_comment] = STATE(6842),
    [sym_line_comment] = STATE(6842),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6843] = {
    [sym_block_comment] = STATE(6843),
    [sym_line_comment] = STATE(6843),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6844] = {
    [sym_block_comment] = STATE(6844),
    [sym_line_comment] = STATE(6844),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6845] = {
    [sym_block_comment] = STATE(6845),
    [sym_line_comment] = STATE(6845),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6846] = {
    [sym_block_comment] = STATE(6846),
    [sym_line_comment] = STATE(6846),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6847] = {
    [sym_identifier] = STATE(7583),
    [sym_block_comment] = STATE(6847),
    [sym_line_comment] = STATE(6847),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_finally] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6848] = {
    [sym_identifier] = STATE(7587),
    [sym_block_comment] = STATE(6848),
    [sym_line_comment] = STATE(6848),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_finally] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6849] = {
    [sym_identifier] = STATE(7590),
    [sym_block_comment] = STATE(6849),
    [sym_line_comment] = STATE(6849),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_finally] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6850] = {
    [sym_identifier] = STATE(7593),
    [sym_block_comment] = STATE(6850),
    [sym_line_comment] = STATE(6850),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_finally] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6851] = {
    [sym_block_comment] = STATE(6851),
    [sym_line_comment] = STATE(6851),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6852] = {
    [sym_block_comment] = STATE(6852),
    [sym_line_comment] = STATE(6852),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6853] = {
    [sym_block_comment] = STATE(6853),
    [sym_line_comment] = STATE(6853),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6854] = {
    [sym_block_comment] = STATE(6854),
    [sym_line_comment] = STATE(6854),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_else] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(10751),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6855] = {
    [sym_block_comment] = STATE(6855),
    [sym_line_comment] = STATE(6855),
    [aux_sym__import_list_repeat1] = STATE(6855),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10865),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_else] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6856] = {
    [sym_block_comment] = STATE(6856),
    [sym_line_comment] = STATE(6856),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6857] = {
    [sym_block_comment] = STATE(6857),
    [sym_line_comment] = STATE(6857),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
  },
  [6858] = {
    [sym_block_comment] = STATE(6858),
    [sym_line_comment] = STATE(6858),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6859] = {
    [sym_block_comment] = STATE(6859),
    [sym_line_comment] = STATE(6859),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6860] = {
    [sym_block_comment] = STATE(6860),
    [sym_line_comment] = STATE(6860),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6861] = {
    [sym_block_comment] = STATE(6861),
    [sym_line_comment] = STATE(6861),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6862] = {
    [sym_block_comment] = STATE(6862),
    [sym_line_comment] = STATE(6862),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6863] = {
    [sym_block_comment] = STATE(6863),
    [sym_line_comment] = STATE(6863),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6864] = {
    [sym_block_comment] = STATE(6864),
    [sym_line_comment] = STATE(6864),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6865] = {
    [sym_block_comment] = STATE(6865),
    [sym_line_comment] = STATE(6865),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6866] = {
    [sym_block_comment] = STATE(6866),
    [sym_line_comment] = STATE(6866),
    [aux_sym__import_list_repeat1] = STATE(7651),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10868),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_catch] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10870),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10872),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6867] = {
    [sym_block_comment] = STATE(6867),
    [sym_line_comment] = STATE(6867),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_catch] = ACTIONS(10757),
    [anon_sym_finally] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOT] = ACTIONS(10846),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6868] = {
    [sym_block_comment] = STATE(6868),
    [sym_line_comment] = STATE(6868),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_catch] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(10846),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6869] = {
    [sym_block_comment] = STATE(6869),
    [sym_line_comment] = STATE(6869),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10727),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_end] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_catch] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10727),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10727),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10727),
    [anon_sym_DOT] = ACTIONS(10825),
    [anon_sym_DOLLAR] = ACTIONS(10727),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_QMARK] = ACTIONS(10727),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10727),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10727),
    [aux_sym_integer_literal_token2] = ACTIONS(10727),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10727),
    [aux_sym_float_literal_token3] = ACTIONS(10727),
    [aux_sym_float_literal_token4] = ACTIONS(10727),
    [sym_character_literal] = ACTIONS(10727),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10727),
    [sym__pair_operator] = ACTIONS(10727),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10727),
    [sym__lazy_and_operator] = ACTIONS(10727),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10727),
    [sym__pipe_left_operator] = ACTIONS(10727),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10727),
    [sym__bitshift_operator] = ACTIONS(10727),
    [sym__power_operator] = ACTIONS(10727),
    [sym__tilde_operator] = ACTIONS(10727),
    [sym__type_order_operator] = ACTIONS(10727),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym__terminator_token1] = ACTIONS(10731),
    [aux_sym__terminator_token2] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6870] = {
    [sym_block_comment] = STATE(6870),
    [sym_line_comment] = STATE(6870),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6871] = {
    [sym_block_comment] = STATE(6871),
    [sym_line_comment] = STATE(6871),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_else] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6872] = {
    [sym_block_comment] = STATE(6872),
    [sym_line_comment] = STATE(6872),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6873] = {
    [sym_block_comment] = STATE(6873),
    [sym_line_comment] = STATE(6873),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_else] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6874] = {
    [sym_block_comment] = STATE(6874),
    [sym_line_comment] = STATE(6874),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6875] = {
    [sym_block_comment] = STATE(6875),
    [sym_line_comment] = STATE(6875),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_elseif] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10789),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6876] = {
    [sym_block_comment] = STATE(6876),
    [sym_line_comment] = STATE(6876),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6877] = {
    [sym_block_comment] = STATE(6877),
    [sym_line_comment] = STATE(6877),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_elseif] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6878] = {
    [sym_block_comment] = STATE(6878),
    [sym_line_comment] = STATE(6878),
    [ts_builtin_sym_end] = ACTIONS(9960),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_RBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6879] = {
    [sym_block_comment] = STATE(6879),
    [sym_line_comment] = STATE(6879),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10874),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6880] = {
    [sym_block_comment] = STATE(6880),
    [sym_line_comment] = STATE(6880),
    [aux_sym__import_list_repeat1] = STATE(7490),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10819),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_catch] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10821),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6881] = {
    [sym_block_comment] = STATE(6881),
    [sym_line_comment] = STATE(6881),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_else] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6882] = {
    [sym_block_comment] = STATE(6882),
    [sym_line_comment] = STATE(6882),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_else] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6883] = {
    [sym_block_comment] = STATE(6883),
    [sym_line_comment] = STATE(6883),
    [aux_sym_export_statement_repeat1] = STATE(7061),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(10809),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_elseif] = ACTIONS(10876),
    [anon_sym_else] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10876),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10876),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(10876),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10876),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10876),
    [anon_sym_QMARK] = ACTIONS(10876),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10876),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10876),
    [aux_sym_integer_literal_token2] = ACTIONS(10876),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10876),
    [aux_sym_float_literal_token3] = ACTIONS(10876),
    [aux_sym_float_literal_token4] = ACTIONS(10876),
    [sym_character_literal] = ACTIONS(10876),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10876),
    [sym__pair_operator] = ACTIONS(10876),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10876),
    [sym__lazy_and_operator] = ACTIONS(10876),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10876),
    [sym__pipe_left_operator] = ACTIONS(10876),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10876),
    [sym__bitshift_operator] = ACTIONS(10876),
    [sym__power_operator] = ACTIONS(10876),
    [sym__tilde_operator] = ACTIONS(10876),
    [sym__type_order_operator] = ACTIONS(10876),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym__terminator_token1] = ACTIONS(10878),
    [aux_sym__terminator_token2] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6884] = {
    [sym_block_comment] = STATE(6884),
    [sym_line_comment] = STATE(6884),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6885] = {
    [sym_block_comment] = STATE(6885),
    [sym_line_comment] = STATE(6885),
    [aux_sym_export_statement_repeat1] = STATE(7061),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(10809),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_end] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_elseif] = ACTIONS(10880),
    [anon_sym_else] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10880),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10880),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10880),
    [anon_sym_DOLLAR] = ACTIONS(10880),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10880),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10880),
    [anon_sym_QMARK] = ACTIONS(10880),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10880),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10880),
    [aux_sym_integer_literal_token2] = ACTIONS(10880),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10880),
    [aux_sym_float_literal_token3] = ACTIONS(10880),
    [aux_sym_float_literal_token4] = ACTIONS(10880),
    [sym_character_literal] = ACTIONS(10880),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10880),
    [sym__pair_operator] = ACTIONS(10880),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10880),
    [sym__lazy_and_operator] = ACTIONS(10880),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10880),
    [sym__pipe_left_operator] = ACTIONS(10880),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10880),
    [sym__bitshift_operator] = ACTIONS(10880),
    [sym__power_operator] = ACTIONS(10880),
    [sym__tilde_operator] = ACTIONS(10880),
    [sym__type_order_operator] = ACTIONS(10880),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym__terminator_token1] = ACTIONS(10882),
    [aux_sym__terminator_token2] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6886] = {
    [sym_block_comment] = STATE(6886),
    [sym_line_comment] = STATE(6886),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10727),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_catch] = ACTIONS(10727),
    [anon_sym_finally] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10727),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10727),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10727),
    [anon_sym_DOT] = ACTIONS(10846),
    [anon_sym_DOLLAR] = ACTIONS(10727),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_QMARK] = ACTIONS(10727),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10727),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10727),
    [aux_sym_integer_literal_token2] = ACTIONS(10727),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10727),
    [aux_sym_float_literal_token3] = ACTIONS(10727),
    [aux_sym_float_literal_token4] = ACTIONS(10727),
    [sym_character_literal] = ACTIONS(10727),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10727),
    [sym__pair_operator] = ACTIONS(10727),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10727),
    [sym__lazy_and_operator] = ACTIONS(10727),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10727),
    [sym__pipe_left_operator] = ACTIONS(10727),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10727),
    [sym__bitshift_operator] = ACTIONS(10727),
    [sym__power_operator] = ACTIONS(10727),
    [sym__tilde_operator] = ACTIONS(10727),
    [sym__type_order_operator] = ACTIONS(10727),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym__terminator_token1] = ACTIONS(10731),
    [aux_sym__terminator_token2] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6887] = {
    [sym_block_comment] = STATE(6887),
    [sym_line_comment] = STATE(6887),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6888] = {
    [sym_block_comment] = STATE(6888),
    [sym_line_comment] = STATE(6888),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6889] = {
    [sym_block_comment] = STATE(6889),
    [sym_line_comment] = STATE(6889),
    [aux_sym__import_list_repeat1] = STATE(7132),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(10765),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_end] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_elseif] = ACTIONS(10884),
    [anon_sym_else] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10884),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10884),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(10884),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10884),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10884),
    [anon_sym_QMARK] = ACTIONS(10884),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10884),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10884),
    [aux_sym_integer_literal_token2] = ACTIONS(10884),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10884),
    [aux_sym_float_literal_token3] = ACTIONS(10884),
    [aux_sym_float_literal_token4] = ACTIONS(10884),
    [sym_character_literal] = ACTIONS(10884),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10884),
    [sym__pair_operator] = ACTIONS(10884),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10884),
    [sym__lazy_and_operator] = ACTIONS(10884),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10884),
    [sym__pipe_left_operator] = ACTIONS(10884),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10884),
    [sym__bitshift_operator] = ACTIONS(10884),
    [sym__power_operator] = ACTIONS(10884),
    [sym__tilde_operator] = ACTIONS(10884),
    [sym__type_order_operator] = ACTIONS(10884),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym__terminator_token1] = ACTIONS(10886),
    [aux_sym__terminator_token2] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6890] = {
    [sym_block_comment] = STATE(6890),
    [sym_line_comment] = STATE(6890),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_elseif] = ACTIONS(10761),
    [anon_sym_else] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6891] = {
    [sym_block_comment] = STATE(6891),
    [sym_line_comment] = STATE(6891),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_else] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6892] = {
    [sym_block_comment] = STATE(6892),
    [sym_line_comment] = STATE(6892),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9860),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9636),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6893] = {
    [sym_block_comment] = STATE(6893),
    [sym_line_comment] = STATE(6893),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_else] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6894] = {
    [sym_block_comment] = STATE(6894),
    [sym_line_comment] = STATE(6894),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_else] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6895] = {
    [sym_block_comment] = STATE(6895),
    [sym_line_comment] = STATE(6895),
    [aux_sym__import_list_repeat1] = STATE(7651),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10868),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_catch] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10870),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6896] = {
    [sym_block_comment] = STATE(6896),
    [sym_line_comment] = STATE(6896),
    [aux_sym__import_list_repeat1] = STATE(7758),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10888),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10890),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10892),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6897] = {
    [sym_block_comment] = STATE(6897),
    [sym_line_comment] = STATE(6897),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_finally] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOT] = ACTIONS(10894),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6898] = {
    [sym_block_comment] = STATE(6898),
    [sym_line_comment] = STATE(6898),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(10894),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6899] = {
    [sym_block_comment] = STATE(6899),
    [sym_line_comment] = STATE(6899),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_else] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6900] = {
    [sym_block_comment] = STATE(6900),
    [sym_line_comment] = STATE(6900),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_else] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6901] = {
    [sym_block_comment] = STATE(6901),
    [sym_line_comment] = STATE(6901),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_else] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6902] = {
    [sym_block_comment] = STATE(6902),
    [sym_line_comment] = STATE(6902),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6903] = {
    [sym_block_comment] = STATE(6903),
    [sym_line_comment] = STATE(6903),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_else] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6904] = {
    [sym_block_comment] = STATE(6904),
    [sym_line_comment] = STATE(6904),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_else] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6905] = {
    [sym_block_comment] = STATE(6905),
    [sym_line_comment] = STATE(6905),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_else] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6906] = {
    [sym_block_comment] = STATE(6906),
    [sym_line_comment] = STATE(6906),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_else] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6907] = {
    [sym_block_comment] = STATE(6907),
    [sym_line_comment] = STATE(6907),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_else] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6908] = {
    [sym_block_comment] = STATE(6908),
    [sym_line_comment] = STATE(6908),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_elseif] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6909] = {
    [sym_block_comment] = STATE(6909),
    [sym_line_comment] = STATE(6909),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_else] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6910] = {
    [sym_block_comment] = STATE(6910),
    [sym_line_comment] = STATE(6910),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_else] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6911] = {
    [sym_block_comment] = STATE(6911),
    [sym_line_comment] = STATE(6911),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10727),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_end] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_finally] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10727),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10727),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10727),
    [anon_sym_DOT] = ACTIONS(10894),
    [anon_sym_DOLLAR] = ACTIONS(10727),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_QMARK] = ACTIONS(10727),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10727),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10727),
    [aux_sym_integer_literal_token2] = ACTIONS(10727),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10727),
    [aux_sym_float_literal_token3] = ACTIONS(10727),
    [aux_sym_float_literal_token4] = ACTIONS(10727),
    [sym_character_literal] = ACTIONS(10727),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10727),
    [sym__pair_operator] = ACTIONS(10727),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10727),
    [sym__lazy_and_operator] = ACTIONS(10727),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10727),
    [sym__pipe_left_operator] = ACTIONS(10727),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10727),
    [sym__bitshift_operator] = ACTIONS(10727),
    [sym__power_operator] = ACTIONS(10727),
    [sym__tilde_operator] = ACTIONS(10727),
    [sym__type_order_operator] = ACTIONS(10727),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym__terminator_token1] = ACTIONS(10731),
    [aux_sym__terminator_token2] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6912] = {
    [sym_block_comment] = STATE(6912),
    [sym_line_comment] = STATE(6912),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_else] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6913] = {
    [sym_block_comment] = STATE(6913),
    [sym_line_comment] = STATE(6913),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_else] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6914] = {
    [sym_block_comment] = STATE(6914),
    [sym_line_comment] = STATE(6914),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_else] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6915] = {
    [sym_block_comment] = STATE(6915),
    [sym_line_comment] = STATE(6915),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_else] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6916] = {
    [sym_block_comment] = STATE(6916),
    [sym_line_comment] = STATE(6916),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_else] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6917] = {
    [sym_block_comment] = STATE(6917),
    [sym_line_comment] = STATE(6917),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_else] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6918] = {
    [sym_block_comment] = STATE(6918),
    [sym_line_comment] = STATE(6918),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_else] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6919] = {
    [sym_block_comment] = STATE(6919),
    [sym_line_comment] = STATE(6919),
    [aux_sym__import_list_repeat1] = STATE(7758),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10888),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10890),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6920] = {
    [sym_block_comment] = STATE(6920),
    [sym_line_comment] = STATE(6920),
    [ts_builtin_sym_end] = ACTIONS(10579),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_RBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6921] = {
    [sym_block_comment] = STATE(6921),
    [sym_line_comment] = STATE(6921),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_else] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6922] = {
    [sym_block_comment] = STATE(6922),
    [sym_line_comment] = STATE(6922),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9654),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6923] = {
    [sym_block_comment] = STATE(6923),
    [sym_line_comment] = STATE(6923),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_else] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6924] = {
    [sym_block_comment] = STATE(6924),
    [sym_line_comment] = STATE(6924),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10825),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6925] = {
    [sym_block_comment] = STATE(6925),
    [sym_line_comment] = STATE(6925),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_else] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6926] = {
    [sym_block_comment] = STATE(6926),
    [sym_line_comment] = STATE(6926),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_else] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6927] = {
    [sym_block_comment] = STATE(6927),
    [sym_line_comment] = STATE(6927),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_else] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6928] = {
    [sym_block_comment] = STATE(6928),
    [sym_line_comment] = STATE(6928),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_else] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6929] = {
    [sym_block_comment] = STATE(6929),
    [sym_line_comment] = STATE(6929),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6930] = {
    [sym_block_comment] = STATE(6930),
    [sym_line_comment] = STATE(6930),
    [sym__word_identifier] = ACTIONS(10440),
    [anon_sym_COMMA] = ACTIONS(10525),
    [anon_sym_EQ] = ACTIONS(10440),
    [anon_sym_begin] = ACTIONS(10440),
    [anon_sym_module] = ACTIONS(10440),
    [anon_sym_baremodule] = ACTIONS(10440),
    [anon_sym_end] = ACTIONS(10440),
    [anon_sym_abstract] = ACTIONS(10440),
    [anon_sym_primitive] = ACTIONS(10440),
    [anon_sym_mutable] = ACTIONS(10440),
    [anon_sym_struct] = ACTIONS(10440),
    [anon_sym_function] = ACTIONS(10440),
    [anon_sym_macro] = ACTIONS(10440),
    [anon_sym_quote] = ACTIONS(10440),
    [anon_sym_let] = ACTIONS(10440),
    [anon_sym_if] = ACTIONS(10440),
    [anon_sym_try] = ACTIONS(10440),
    [anon_sym_for] = ACTIONS(10440),
    [anon_sym_while] = ACTIONS(10440),
    [sym_break_statement] = ACTIONS(10440),
    [sym_continue_statement] = ACTIONS(10440),
    [anon_sym_return] = ACTIONS(10440),
    [anon_sym_const] = ACTIONS(10440),
    [anon_sym_global] = ACTIONS(10440),
    [anon_sym_local] = ACTIONS(10440),
    [anon_sym_LPAREN] = ACTIONS(10525),
    [anon_sym_COLON] = ACTIONS(10440),
    [anon_sym_export] = ACTIONS(10440),
    [anon_sym_public] = ACTIONS(10440),
    [anon_sym_import] = ACTIONS(10440),
    [anon_sym_using] = ACTIONS(10440),
    [anon_sym_LBRACK] = ACTIONS(10525),
    [anon_sym_in] = ACTIONS(10440),
    [anon_sym_LBRACE] = ACTIONS(10525),
    [anon_sym_SQUOTE] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_DOLLAR] = ACTIONS(10525),
    [anon_sym_COLON2] = ACTIONS(10440),
    [anon_sym_COLON_COLON] = ACTIONS(10525),
    [anon_sym_isa] = ACTIONS(10440),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10525),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_where] = ACTIONS(10440),
    [anon_sym_AT] = ACTIONS(10525),
    [anon_sym_true] = ACTIONS(10440),
    [anon_sym_false] = ACTIONS(10440),
    [aux_sym_integer_literal_token1] = ACTIONS(10525),
    [aux_sym_integer_literal_token2] = ACTIONS(10525),
    [aux_sym_integer_literal_token3] = ACTIONS(10440),
    [aux_sym_integer_literal_token4] = ACTIONS(10440),
    [aux_sym_float_literal_token1] = ACTIONS(10525),
    [aux_sym_float_literal_token3] = ACTIONS(10525),
    [aux_sym_float_literal_token4] = ACTIONS(10525),
    [sym_character_literal] = ACTIONS(10525),
    [anon_sym_DQUOTE] = ACTIONS(10440),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10525),
    [anon_sym_BQUOTE] = ACTIONS(10440),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10525),
    [sym__pair_operator] = ACTIONS(10525),
    [sym__arrow_operator] = ACTIONS(10440),
    [sym__lazy_or_operator] = ACTIONS(10525),
    [sym__lazy_and_operator] = ACTIONS(10525),
    [sym__comparison_operator] = ACTIONS(10440),
    [sym__pipe_right_operator] = ACTIONS(10525),
    [sym__pipe_left_operator] = ACTIONS(10525),
    [sym__ellipsis_operator] = ACTIONS(10440),
    [sym__plus_operator] = ACTIONS(10440),
    [sym__times_operator] = ACTIONS(10440),
    [sym__rational_operator] = ACTIONS(10525),
    [sym__bitshift_operator] = ACTIONS(10525),
    [sym__power_operator] = ACTIONS(10525),
    [sym__tilde_operator] = ACTIONS(10525),
    [sym__type_order_operator] = ACTIONS(10525),
    [sym__unary_operator] = ACTIONS(10440),
    [sym__unary_plus_operator] = ACTIONS(10440),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10900),
    [sym__immediate_bracket] = ACTIONS(10902),
    [sym__immediate_brace] = ACTIONS(10904),
  },
  [6931] = {
    [sym_block_comment] = STATE(6931),
    [sym_line_comment] = STATE(6931),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_RPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_RBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_SEMI] = ACTIONS(9914),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_RBRACE] = ACTIONS(9914),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6932] = {
    [sym_block_comment] = STATE(6932),
    [sym_line_comment] = STATE(6932),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6933] = {
    [sym_block_comment] = STATE(6933),
    [sym_line_comment] = STATE(6933),
    [aux_sym_open_tuple_repeat1] = STATE(6941),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_end] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_elseif] = ACTIONS(10829),
    [anon_sym_else] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10829),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10829),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10829),
    [anon_sym_DOLLAR] = ACTIONS(10829),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10829),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10829),
    [anon_sym_QMARK] = ACTIONS(10829),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10829),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10829),
    [aux_sym_integer_literal_token2] = ACTIONS(10829),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10829),
    [aux_sym_float_literal_token3] = ACTIONS(10829),
    [aux_sym_float_literal_token4] = ACTIONS(10829),
    [sym_character_literal] = ACTIONS(10829),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10829),
    [sym__pair_operator] = ACTIONS(10829),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10829),
    [sym__lazy_and_operator] = ACTIONS(10829),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10829),
    [sym__pipe_left_operator] = ACTIONS(10829),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10829),
    [sym__bitshift_operator] = ACTIONS(10829),
    [sym__power_operator] = ACTIONS(10829),
    [sym__tilde_operator] = ACTIONS(10829),
    [sym__type_order_operator] = ACTIONS(10829),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym__terminator_token1] = ACTIONS(10833),
    [aux_sym__terminator_token2] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6934] = {
    [sym_block_comment] = STATE(6934),
    [sym_line_comment] = STATE(6934),
    [sym__word_identifier] = ACTIONS(10537),
    [anon_sym_COMMA] = ACTIONS(10539),
    [anon_sym_EQ] = ACTIONS(10537),
    [anon_sym_begin] = ACTIONS(10537),
    [anon_sym_module] = ACTIONS(10537),
    [anon_sym_baremodule] = ACTIONS(10537),
    [anon_sym_end] = ACTIONS(10537),
    [anon_sym_abstract] = ACTIONS(10537),
    [anon_sym_primitive] = ACTIONS(10537),
    [anon_sym_mutable] = ACTIONS(10537),
    [anon_sym_struct] = ACTIONS(10537),
    [anon_sym_function] = ACTIONS(10537),
    [anon_sym_macro] = ACTIONS(10537),
    [anon_sym_quote] = ACTIONS(10537),
    [anon_sym_let] = ACTIONS(10537),
    [anon_sym_if] = ACTIONS(10537),
    [anon_sym_try] = ACTIONS(10537),
    [anon_sym_for] = ACTIONS(10537),
    [anon_sym_while] = ACTIONS(10537),
    [sym_break_statement] = ACTIONS(10537),
    [sym_continue_statement] = ACTIONS(10537),
    [anon_sym_return] = ACTIONS(10537),
    [anon_sym_const] = ACTIONS(10537),
    [anon_sym_global] = ACTIONS(10537),
    [anon_sym_local] = ACTIONS(10537),
    [anon_sym_LPAREN] = ACTIONS(10539),
    [anon_sym_COLON] = ACTIONS(10537),
    [anon_sym_export] = ACTIONS(10537),
    [anon_sym_public] = ACTIONS(10537),
    [anon_sym_import] = ACTIONS(10537),
    [anon_sym_using] = ACTIONS(10537),
    [anon_sym_LBRACK] = ACTIONS(10539),
    [anon_sym_in] = ACTIONS(10537),
    [anon_sym_LBRACE] = ACTIONS(10539),
    [anon_sym_SQUOTE] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_DOLLAR] = ACTIONS(10539),
    [anon_sym_COLON2] = ACTIONS(10537),
    [anon_sym_COLON_COLON] = ACTIONS(10539),
    [anon_sym_isa] = ACTIONS(10537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10539),
    [anon_sym_QMARK] = ACTIONS(10539),
    [anon_sym_where] = ACTIONS(10537),
    [anon_sym_AT] = ACTIONS(10539),
    [anon_sym_true] = ACTIONS(10537),
    [anon_sym_false] = ACTIONS(10537),
    [aux_sym_integer_literal_token1] = ACTIONS(10539),
    [aux_sym_integer_literal_token2] = ACTIONS(10539),
    [aux_sym_integer_literal_token3] = ACTIONS(10537),
    [aux_sym_integer_literal_token4] = ACTIONS(10537),
    [aux_sym_float_literal_token1] = ACTIONS(10539),
    [aux_sym_float_literal_token3] = ACTIONS(10539),
    [aux_sym_float_literal_token4] = ACTIONS(10539),
    [sym_character_literal] = ACTIONS(10539),
    [anon_sym_DQUOTE] = ACTIONS(10537),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10539),
    [anon_sym_BQUOTE] = ACTIONS(10537),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10539),
    [sym__pair_operator] = ACTIONS(10539),
    [sym__arrow_operator] = ACTIONS(10537),
    [sym__lazy_or_operator] = ACTIONS(10539),
    [sym__lazy_and_operator] = ACTIONS(10539),
    [sym__comparison_operator] = ACTIONS(10537),
    [sym__pipe_right_operator] = ACTIONS(10539),
    [sym__pipe_left_operator] = ACTIONS(10539),
    [sym__ellipsis_operator] = ACTIONS(10537),
    [sym__plus_operator] = ACTIONS(10537),
    [sym__times_operator] = ACTIONS(10537),
    [sym__rational_operator] = ACTIONS(10539),
    [sym__bitshift_operator] = ACTIONS(10539),
    [sym__power_operator] = ACTIONS(10539),
    [sym__tilde_operator] = ACTIONS(10539),
    [sym__type_order_operator] = ACTIONS(10539),
    [sym__unary_operator] = ACTIONS(10537),
    [sym__unary_plus_operator] = ACTIONS(10537),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10900),
    [sym__immediate_bracket] = ACTIONS(10902),
    [sym__immediate_brace] = ACTIONS(10904),
  },
  [6935] = {
    [sym_block_comment] = STATE(6935),
    [sym_line_comment] = STATE(6935),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6936] = {
    [sym_block_comment] = STATE(6936),
    [sym_line_comment] = STATE(6936),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_else] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10743),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6937] = {
    [sym_block_comment] = STATE(6937),
    [sym_line_comment] = STATE(6937),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_else] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6938] = {
    [sym_block_comment] = STATE(6938),
    [sym_line_comment] = STATE(6938),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_elseif] = ACTIONS(10908),
    [anon_sym_else] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6939] = {
    [sym_block_comment] = STATE(6939),
    [sym_line_comment] = STATE(6939),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_SQUOTE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9984),
    [sym__immediate_bracket] = ACTIONS(9984),
    [sym__immediate_brace] = ACTIONS(9984),
  },
  [6940] = {
    [sym_block_comment] = STATE(6940),
    [sym_line_comment] = STATE(6940),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_RPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_RBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_SEMI] = ACTIONS(9960),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_RBRACE] = ACTIONS(9960),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6941] = {
    [sym_block_comment] = STATE(6941),
    [sym_line_comment] = STATE(6941),
    [aux_sym_open_tuple_repeat1] = STATE(6941),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10912),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_elseif] = ACTIONS(10835),
    [anon_sym_else] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10835),
    [anon_sym_QMARK] = ACTIONS(10835),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10835),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10835),
    [sym__lazy_and_operator] = ACTIONS(10835),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10835),
    [sym__pipe_left_operator] = ACTIONS(10835),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10835),
    [sym__bitshift_operator] = ACTIONS(10835),
    [sym__power_operator] = ACTIONS(10835),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10835),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6942] = {
    [sym_block_comment] = STATE(6942),
    [sym_line_comment] = STATE(6942),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_else] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6943] = {
    [sym_block_comment] = STATE(6943),
    [sym_line_comment] = STATE(6943),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_SQUOTE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9988),
    [sym__immediate_bracket] = ACTIONS(9988),
    [sym__immediate_brace] = ACTIONS(9988),
  },
  [6944] = {
    [sym_block_comment] = STATE(6944),
    [sym_line_comment] = STATE(6944),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_SQUOTE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10002),
    [sym__immediate_bracket] = ACTIONS(10002),
    [sym__immediate_brace] = ACTIONS(10002),
  },
  [6945] = {
    [sym_block_comment] = STATE(6945),
    [sym_line_comment] = STATE(6945),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_SQUOTE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10006),
    [sym__immediate_bracket] = ACTIONS(10006),
    [sym__immediate_brace] = ACTIONS(10006),
  },
  [6946] = {
    [sym_block_comment] = STATE(6946),
    [sym_line_comment] = STATE(6946),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6947] = {
    [sym_block_comment] = STATE(6947),
    [sym_line_comment] = STATE(6947),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6948] = {
    [sym_block_comment] = STATE(6948),
    [sym_line_comment] = STATE(6948),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6949] = {
    [sym_block_comment] = STATE(6949),
    [sym_line_comment] = STATE(6949),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6950] = {
    [sym_block_comment] = STATE(6950),
    [sym_line_comment] = STATE(6950),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_SQUOTE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9664),
    [sym__immediate_bracket] = ACTIONS(9664),
    [sym__immediate_brace] = ACTIONS(9664),
  },
  [6951] = {
    [sym_block_comment] = STATE(6951),
    [sym_line_comment] = STATE(6951),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_SQUOTE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10012),
    [sym__immediate_bracket] = ACTIONS(10012),
    [sym__immediate_brace] = ACTIONS(10012),
  },
  [6952] = {
    [sym_block_comment] = STATE(6952),
    [sym_line_comment] = STATE(6952),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_SQUOTE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10016),
    [sym__immediate_bracket] = ACTIONS(10016),
    [sym__immediate_brace] = ACTIONS(10016),
  },
  [6953] = {
    [sym_block_comment] = STATE(6953),
    [sym_line_comment] = STATE(6953),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6954] = {
    [sym_block_comment] = STATE(6954),
    [sym_line_comment] = STATE(6954),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_SQUOTE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10020),
    [sym__immediate_bracket] = ACTIONS(10020),
    [sym__immediate_brace] = ACTIONS(10020),
  },
  [6955] = {
    [sym_block_comment] = STATE(6955),
    [sym_line_comment] = STATE(6955),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_SQUOTE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9918),
    [sym__immediate_bracket] = ACTIONS(9918),
    [sym__immediate_brace] = ACTIONS(9918),
  },
  [6956] = {
    [sym_block_comment] = STATE(6956),
    [sym_line_comment] = STATE(6956),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_SQUOTE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9922),
    [sym__immediate_bracket] = ACTIONS(9922),
    [sym__immediate_brace] = ACTIONS(9922),
  },
  [6957] = {
    [sym_block_comment] = STATE(6957),
    [sym_line_comment] = STATE(6957),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10894),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6958] = {
    [sym_block_comment] = STATE(6958),
    [sym_line_comment] = STATE(6958),
    [ts_builtin_sym_end] = ACTIONS(9728),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_RBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6959] = {
    [sym_block_comment] = STATE(6959),
    [sym_line_comment] = STATE(6959),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9648),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6960] = {
    [sym_block_comment] = STATE(6960),
    [sym_line_comment] = STATE(6960),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
  },
  [6961] = {
    [sym_block_comment] = STATE(6961),
    [sym_line_comment] = STATE(6961),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
  },
  [6962] = {
    [sym_block_comment] = STATE(6962),
    [sym_line_comment] = STATE(6962),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9654),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6963] = {
    [sym_block_comment] = STATE(6963),
    [sym_line_comment] = STATE(6963),
    [ts_builtin_sym_end] = ACTIONS(9740),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6964] = {
    [sym_block_comment] = STATE(6964),
    [sym_line_comment] = STATE(6964),
    [ts_builtin_sym_end] = ACTIONS(9746),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_RBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6965] = {
    [sym_block_comment] = STATE(6965),
    [sym_line_comment] = STATE(6965),
    [aux_sym_export_statement_repeat1] = STATE(7067),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(10915),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_end] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_else] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_finally] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10807),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10807),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10807),
    [anon_sym_DOLLAR] = ACTIONS(10807),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10807),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10807),
    [anon_sym_QMARK] = ACTIONS(10807),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10807),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10807),
    [aux_sym_integer_literal_token2] = ACTIONS(10807),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10807),
    [aux_sym_float_literal_token3] = ACTIONS(10807),
    [aux_sym_float_literal_token4] = ACTIONS(10807),
    [sym_character_literal] = ACTIONS(10807),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10807),
    [sym__pair_operator] = ACTIONS(10807),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10807),
    [sym__lazy_and_operator] = ACTIONS(10807),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10807),
    [sym__pipe_left_operator] = ACTIONS(10807),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10807),
    [sym__bitshift_operator] = ACTIONS(10807),
    [sym__power_operator] = ACTIONS(10807),
    [sym__tilde_operator] = ACTIONS(10807),
    [sym__type_order_operator] = ACTIONS(10807),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym__terminator_token1] = ACTIONS(10811),
    [aux_sym__terminator_token2] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6966] = {
    [sym_block_comment] = STATE(6966),
    [sym_line_comment] = STATE(6966),
    [aux_sym_export_statement_repeat1] = STATE(7085),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(10915),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_end] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_else] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_finally] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10813),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10813),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10813),
    [anon_sym_DOLLAR] = ACTIONS(10813),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10813),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10813),
    [anon_sym_QMARK] = ACTIONS(10813),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10813),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10813),
    [aux_sym_integer_literal_token2] = ACTIONS(10813),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10813),
    [aux_sym_float_literal_token3] = ACTIONS(10813),
    [aux_sym_float_literal_token4] = ACTIONS(10813),
    [sym_character_literal] = ACTIONS(10813),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10813),
    [sym__pair_operator] = ACTIONS(10813),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10813),
    [sym__lazy_and_operator] = ACTIONS(10813),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10813),
    [sym__pipe_left_operator] = ACTIONS(10813),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10813),
    [sym__bitshift_operator] = ACTIONS(10813),
    [sym__power_operator] = ACTIONS(10813),
    [sym__tilde_operator] = ACTIONS(10813),
    [sym__type_order_operator] = ACTIONS(10813),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym__terminator_token1] = ACTIONS(10815),
    [aux_sym__terminator_token2] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6967] = {
    [sym_block_comment] = STATE(6967),
    [sym_line_comment] = STATE(6967),
    [aux_sym__import_list_repeat1] = STATE(7098),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10749),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_else] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6968] = {
    [sym_block_comment] = STATE(6968),
    [sym_line_comment] = STATE(6968),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_SQUOTE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9728),
    [sym__immediate_bracket] = ACTIONS(9728),
    [sym__immediate_brace] = ACTIONS(9728),
  },
  [6969] = {
    [sym_block_comment] = STATE(6969),
    [sym_line_comment] = STATE(6969),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_else] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_finally] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6970] = {
    [sym_block_comment] = STATE(6970),
    [sym_line_comment] = STATE(6970),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6971] = {
    [sym_block_comment] = STATE(6971),
    [sym_line_comment] = STATE(6971),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9646),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6972] = {
    [sym_block_comment] = STATE(6972),
    [sym_line_comment] = STATE(6972),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_SQUOTE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9992),
    [sym__immediate_bracket] = ACTIONS(9992),
    [sym__immediate_brace] = ACTIONS(9992),
  },
  [6973] = {
    [sym_block_comment] = STATE(6973),
    [sym_line_comment] = STATE(6973),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_SQUOTE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9996),
    [sym__immediate_bracket] = ACTIONS(9996),
    [sym__immediate_brace] = ACTIONS(9996),
  },
  [6974] = {
    [sym_block_comment] = STATE(6974),
    [sym_line_comment] = STATE(6974),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_SQUOTE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9754),
    [sym__immediate_bracket] = ACTIONS(9754),
    [sym__immediate_brace] = ACTIONS(9754),
  },
  [6975] = {
    [sym_block_comment] = STATE(6975),
    [sym_line_comment] = STATE(6975),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_SQUOTE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9762),
    [sym__immediate_bracket] = ACTIONS(9762),
    [sym__immediate_brace] = ACTIONS(9762),
  },
  [6976] = {
    [sym_block_comment] = STATE(6976),
    [sym_line_comment] = STATE(6976),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_SQUOTE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10030),
    [sym__immediate_bracket] = ACTIONS(10030),
    [sym__immediate_brace] = ACTIONS(10030),
  },
  [6977] = {
    [sym_block_comment] = STATE(6977),
    [sym_line_comment] = STATE(6977),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_SQUOTE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10034),
    [sym__immediate_bracket] = ACTIONS(10034),
    [sym__immediate_brace] = ACTIONS(10034),
  },
  [6978] = {
    [sym_block_comment] = STATE(6978),
    [sym_line_comment] = STATE(6978),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_SQUOTE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9960),
    [sym__immediate_bracket] = ACTIONS(9960),
    [sym__immediate_brace] = ACTIONS(9960),
  },
  [6979] = {
    [sym_block_comment] = STATE(6979),
    [sym_line_comment] = STATE(6979),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_SQUOTE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10042),
    [sym__immediate_bracket] = ACTIONS(10042),
    [sym__immediate_brace] = ACTIONS(10042),
  },
  [6980] = {
    [sym_block_comment] = STATE(6980),
    [sym_line_comment] = STATE(6980),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_SQUOTE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9740),
    [sym__immediate_bracket] = ACTIONS(9740),
    [sym__immediate_brace] = ACTIONS(9740),
  },
  [6981] = {
    [sym_block_comment] = STATE(6981),
    [sym_line_comment] = STATE(6981),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9646),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6982] = {
    [sym_block_comment] = STATE(6982),
    [sym_line_comment] = STATE(6982),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_SQUOTE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9746),
    [sym__immediate_bracket] = ACTIONS(9746),
    [sym__immediate_brace] = ACTIONS(9746),
  },
  [6983] = {
    [sym_identifier] = STATE(7331),
    [sym_block_comment] = STATE(6983),
    [sym_line_comment] = STATE(6983),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6984] = {
    [sym_block_comment] = STATE(6984),
    [sym_line_comment] = STATE(6984),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6985] = {
    [sym_identifier] = STATE(7332),
    [sym_block_comment] = STATE(6985),
    [sym_line_comment] = STATE(6985),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6986] = {
    [sym_block_comment] = STATE(6986),
    [sym_line_comment] = STATE(6986),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_SQUOTE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9792),
    [sym__immediate_bracket] = ACTIONS(9792),
    [sym__immediate_brace] = ACTIONS(9792),
  },
  [6987] = {
    [sym_block_comment] = STATE(6987),
    [sym_line_comment] = STATE(6987),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_SQUOTE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10046),
    [sym__immediate_bracket] = ACTIONS(10046),
    [sym__immediate_brace] = ACTIONS(10046),
  },
  [6988] = {
    [sym_block_comment] = STATE(6988),
    [sym_line_comment] = STATE(6988),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_SQUOTE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10050),
    [sym__immediate_bracket] = ACTIONS(10050),
    [sym__immediate_brace] = ACTIONS(10050),
  },
  [6989] = {
    [sym_block_comment] = STATE(6989),
    [sym_line_comment] = STATE(6989),
    [ts_builtin_sym_end] = ACTIONS(9984),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_RBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6990] = {
    [sym_block_comment] = STATE(6990),
    [sym_line_comment] = STATE(6990),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_SQUOTE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10054),
    [sym__immediate_bracket] = ACTIONS(10054),
    [sym__immediate_brace] = ACTIONS(10054),
  },
  [6991] = {
    [sym_block_comment] = STATE(6991),
    [sym_line_comment] = STATE(6991),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_SQUOTE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10058),
    [sym__immediate_bracket] = ACTIONS(10058),
    [sym__immediate_brace] = ACTIONS(10058),
  },
  [6992] = {
    [sym_block_comment] = STATE(6992),
    [sym_line_comment] = STATE(6992),
    [ts_builtin_sym_end] = ACTIONS(9988),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_RBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6993] = {
    [sym_block_comment] = STATE(6993),
    [sym_line_comment] = STATE(6993),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9646),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6994] = {
    [sym_block_comment] = STATE(6994),
    [sym_line_comment] = STATE(6994),
    [ts_builtin_sym_end] = ACTIONS(10002),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_RBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6995] = {
    [sym_block_comment] = STATE(6995),
    [sym_line_comment] = STATE(6995),
    [ts_builtin_sym_end] = ACTIONS(10006),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_RBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6996] = {
    [sym_block_comment] = STATE(6996),
    [sym_line_comment] = STATE(6996),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_SQUOTE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9900),
    [sym__immediate_bracket] = ACTIONS(9900),
    [sym__immediate_brace] = ACTIONS(9900),
  },
  [6997] = {
    [sym_block_comment] = STATE(6997),
    [sym_line_comment] = STATE(6997),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6998] = {
    [sym_block_comment] = STATE(6998),
    [sym_line_comment] = STATE(6998),
    [ts_builtin_sym_end] = ACTIONS(10012),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_RBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [6999] = {
    [sym_block_comment] = STATE(6999),
    [sym_line_comment] = STATE(6999),
    [ts_builtin_sym_end] = ACTIONS(10016),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_RBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7000] = {
    [sym_block_comment] = STATE(7000),
    [sym_line_comment] = STATE(7000),
    [ts_builtin_sym_end] = ACTIONS(10020),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_RBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7001] = {
    [sym_block_comment] = STATE(7001),
    [sym_line_comment] = STATE(7001),
    [ts_builtin_sym_end] = ACTIONS(9918),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_RBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7002] = {
    [sym_block_comment] = STATE(7002),
    [sym_line_comment] = STATE(7002),
    [ts_builtin_sym_end] = ACTIONS(9922),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_RBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7003] = {
    [sym_block_comment] = STATE(7003),
    [sym_line_comment] = STATE(7003),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10579),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10579),
    [anon_sym_RPAREN] = ACTIONS(10579),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10579),
    [anon_sym_RBRACK] = ACTIONS(10579),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_SEMI] = ACTIONS(10579),
    [anon_sym_LBRACE] = ACTIONS(10579),
    [anon_sym_RBRACE] = ACTIONS(10579),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10579),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10579),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10579),
    [anon_sym_QMARK] = ACTIONS(10579),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10579),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10579),
    [aux_sym_integer_literal_token2] = ACTIONS(10579),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10579),
    [aux_sym_float_literal_token3] = ACTIONS(10579),
    [aux_sym_float_literal_token4] = ACTIONS(10579),
    [sym_character_literal] = ACTIONS(10579),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10579),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10579),
    [sym__pair_operator] = ACTIONS(10579),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10579),
    [sym__lazy_and_operator] = ACTIONS(10579),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10579),
    [sym__pipe_left_operator] = ACTIONS(10579),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10579),
    [sym__bitshift_operator] = ACTIONS(10579),
    [sym__power_operator] = ACTIONS(10579),
    [sym__tilde_operator] = ACTIONS(10579),
    [sym__type_order_operator] = ACTIONS(10579),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7004] = {
    [sym_block_comment] = STATE(7004),
    [sym_line_comment] = STATE(7004),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_SQUOTE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10062),
    [sym__immediate_bracket] = ACTIONS(10062),
    [sym__immediate_brace] = ACTIONS(10062),
  },
  [7005] = {
    [sym_identifier] = STATE(7338),
    [sym_block_comment] = STATE(7005),
    [sym_line_comment] = STATE(7005),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7006] = {
    [sym_block_comment] = STATE(7006),
    [sym_line_comment] = STATE(7006),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_SQUOTE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10066),
    [sym__immediate_bracket] = ACTIONS(10066),
    [sym__immediate_brace] = ACTIONS(10066),
  },
  [7007] = {
    [sym_block_comment] = STATE(7007),
    [sym_line_comment] = STATE(7007),
    [ts_builtin_sym_end] = ACTIONS(9992),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_RBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7008] = {
    [sym_block_comment] = STATE(7008),
    [sym_line_comment] = STATE(7008),
    [ts_builtin_sym_end] = ACTIONS(9996),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_RBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7009] = {
    [sym_block_comment] = STATE(7009),
    [sym_line_comment] = STATE(7009),
    [ts_builtin_sym_end] = ACTIONS(9754),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_RBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7010] = {
    [sym_block_comment] = STATE(7010),
    [sym_line_comment] = STATE(7010),
    [ts_builtin_sym_end] = ACTIONS(9762),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_RBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7011] = {
    [sym_block_comment] = STATE(7011),
    [sym_line_comment] = STATE(7011),
    [ts_builtin_sym_end] = ACTIONS(10030),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_RBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7012] = {
    [sym_block_comment] = STATE(7012),
    [sym_line_comment] = STATE(7012),
    [ts_builtin_sym_end] = ACTIONS(10034),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_RBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7013] = {
    [sym_block_comment] = STATE(7013),
    [sym_line_comment] = STATE(7013),
    [ts_builtin_sym_end] = ACTIONS(10038),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_RBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7014] = {
    [sym_block_comment] = STATE(7014),
    [sym_line_comment] = STATE(7014),
    [ts_builtin_sym_end] = ACTIONS(10042),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_RBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7015] = {
    [sym_identifier] = STATE(7339),
    [sym_block_comment] = STATE(7015),
    [sym_line_comment] = STATE(7015),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7016] = {
    [sym_block_comment] = STATE(7016),
    [sym_line_comment] = STATE(7016),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_SQUOTE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10070),
    [sym__immediate_bracket] = ACTIONS(10070),
    [sym__immediate_brace] = ACTIONS(10070),
  },
  [7017] = {
    [sym_block_comment] = STATE(7017),
    [sym_line_comment] = STATE(7017),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_SQUOTE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10074),
    [sym__immediate_bracket] = ACTIONS(10074),
    [sym__immediate_brace] = ACTIONS(10074),
  },
  [7018] = {
    [sym_block_comment] = STATE(7018),
    [sym_line_comment] = STATE(7018),
    [ts_builtin_sym_end] = ACTIONS(9792),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_RBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7019] = {
    [sym_block_comment] = STATE(7019),
    [sym_line_comment] = STATE(7019),
    [ts_builtin_sym_end] = ACTIONS(10046),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_RBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7020] = {
    [sym_block_comment] = STATE(7020),
    [sym_line_comment] = STATE(7020),
    [ts_builtin_sym_end] = ACTIONS(10050),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_RBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7021] = {
    [sym_block_comment] = STATE(7021),
    [sym_line_comment] = STATE(7021),
    [ts_builtin_sym_end] = ACTIONS(10054),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_RBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7022] = {
    [sym_block_comment] = STATE(7022),
    [sym_line_comment] = STATE(7022),
    [ts_builtin_sym_end] = ACTIONS(10058),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_RBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7023] = {
    [sym_block_comment] = STATE(7023),
    [sym_line_comment] = STATE(7023),
    [ts_builtin_sym_end] = ACTIONS(9900),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_RBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7024] = {
    [sym_block_comment] = STATE(7024),
    [sym_line_comment] = STATE(7024),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_SQUOTE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10078),
    [sym__immediate_bracket] = ACTIONS(10078),
    [sym__immediate_brace] = ACTIONS(10078),
  },
  [7025] = {
    [sym_block_comment] = STATE(7025),
    [sym_line_comment] = STATE(7025),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_SQUOTE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10082),
    [sym__immediate_bracket] = ACTIONS(10082),
    [sym__immediate_brace] = ACTIONS(10082),
  },
  [7026] = {
    [sym_block_comment] = STATE(7026),
    [sym_line_comment] = STATE(7026),
    [ts_builtin_sym_end] = ACTIONS(10062),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_RBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7027] = {
    [sym_block_comment] = STATE(7027),
    [sym_line_comment] = STATE(7027),
    [ts_builtin_sym_end] = ACTIONS(10066),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_RBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7028] = {
    [sym_block_comment] = STATE(7028),
    [sym_line_comment] = STATE(7028),
    [ts_builtin_sym_end] = ACTIONS(10070),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_RBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7029] = {
    [sym_block_comment] = STATE(7029),
    [sym_line_comment] = STATE(7029),
    [ts_builtin_sym_end] = ACTIONS(10074),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_RBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7030] = {
    [sym_block_comment] = STATE(7030),
    [sym_line_comment] = STATE(7030),
    [ts_builtin_sym_end] = ACTIONS(10078),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_RBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7031] = {
    [sym_block_comment] = STATE(7031),
    [sym_line_comment] = STATE(7031),
    [ts_builtin_sym_end] = ACTIONS(10082),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_RBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7032] = {
    [sym_block_comment] = STATE(7032),
    [sym_line_comment] = STATE(7032),
    [sym__word_identifier] = ACTIONS(9978),
    [anon_sym_COMMA] = ACTIONS(9980),
    [anon_sym_EQ] = ACTIONS(9978),
    [anon_sym_begin] = ACTIONS(9978),
    [anon_sym_module] = ACTIONS(9978),
    [anon_sym_baremodule] = ACTIONS(9978),
    [anon_sym_end] = ACTIONS(9978),
    [anon_sym_abstract] = ACTIONS(9978),
    [anon_sym_primitive] = ACTIONS(9978),
    [anon_sym_mutable] = ACTIONS(9978),
    [anon_sym_struct] = ACTIONS(9978),
    [anon_sym_function] = ACTIONS(9978),
    [anon_sym_macro] = ACTIONS(9978),
    [anon_sym_quote] = ACTIONS(9978),
    [anon_sym_let] = ACTIONS(9978),
    [anon_sym_if] = ACTIONS(9978),
    [anon_sym_try] = ACTIONS(9978),
    [anon_sym_for] = ACTIONS(9978),
    [anon_sym_while] = ACTIONS(9978),
    [sym_break_statement] = ACTIONS(9978),
    [sym_continue_statement] = ACTIONS(9978),
    [anon_sym_return] = ACTIONS(9978),
    [anon_sym_const] = ACTIONS(9978),
    [anon_sym_global] = ACTIONS(9978),
    [anon_sym_local] = ACTIONS(9978),
    [anon_sym_LPAREN] = ACTIONS(9980),
    [anon_sym_COLON] = ACTIONS(9978),
    [anon_sym_export] = ACTIONS(9978),
    [anon_sym_public] = ACTIONS(9978),
    [anon_sym_import] = ACTIONS(9978),
    [anon_sym_using] = ACTIONS(9978),
    [anon_sym_LBRACK] = ACTIONS(9980),
    [anon_sym_in] = ACTIONS(9978),
    [anon_sym_LBRACE] = ACTIONS(9980),
    [anon_sym_SQUOTE] = ACTIONS(9978),
    [anon_sym_DOT] = ACTIONS(9978),
    [anon_sym_DOLLAR] = ACTIONS(9980),
    [anon_sym_COLON2] = ACTIONS(9978),
    [anon_sym_COLON_COLON] = ACTIONS(9980),
    [anon_sym_isa] = ACTIONS(9978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9980),
    [anon_sym_QMARK] = ACTIONS(9980),
    [anon_sym_where] = ACTIONS(9978),
    [anon_sym_AT] = ACTIONS(9980),
    [anon_sym_true] = ACTIONS(9978),
    [anon_sym_false] = ACTIONS(9978),
    [aux_sym_integer_literal_token1] = ACTIONS(9980),
    [aux_sym_integer_literal_token2] = ACTIONS(9980),
    [aux_sym_integer_literal_token3] = ACTIONS(9978),
    [aux_sym_integer_literal_token4] = ACTIONS(9978),
    [aux_sym_float_literal_token1] = ACTIONS(9980),
    [aux_sym_float_literal_token3] = ACTIONS(9980),
    [aux_sym_float_literal_token4] = ACTIONS(9980),
    [sym_character_literal] = ACTIONS(9980),
    [anon_sym_DQUOTE] = ACTIONS(9978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9980),
    [anon_sym_BQUOTE] = ACTIONS(9978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9980),
    [sym__pair_operator] = ACTIONS(9980),
    [sym__arrow_operator] = ACTIONS(9978),
    [sym__lazy_or_operator] = ACTIONS(9980),
    [sym__lazy_and_operator] = ACTIONS(9980),
    [sym__comparison_operator] = ACTIONS(9978),
    [sym__pipe_right_operator] = ACTIONS(9980),
    [sym__pipe_left_operator] = ACTIONS(9980),
    [sym__ellipsis_operator] = ACTIONS(9978),
    [sym__plus_operator] = ACTIONS(9978),
    [sym__times_operator] = ACTIONS(9978),
    [sym__rational_operator] = ACTIONS(9980),
    [sym__bitshift_operator] = ACTIONS(9980),
    [sym__power_operator] = ACTIONS(9980),
    [sym__tilde_operator] = ACTIONS(9980),
    [sym__type_order_operator] = ACTIONS(9980),
    [sym__unary_operator] = ACTIONS(9978),
    [sym__unary_plus_operator] = ACTIONS(9978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9980),
    [sym__immediate_bracket] = ACTIONS(9980),
    [sym__immediate_brace] = ACTIONS(9980),
  },
  [7033] = {
    [sym_block_comment] = STATE(7033),
    [sym_line_comment] = STATE(7033),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7034] = {
    [sym_block_comment] = STATE(7034),
    [sym_line_comment] = STATE(7034),
    [sym__word_identifier] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(189),
    [anon_sym_EQ] = ACTIONS(101),
    [anon_sym_begin] = ACTIONS(101),
    [anon_sym_module] = ACTIONS(101),
    [anon_sym_baremodule] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_abstract] = ACTIONS(101),
    [anon_sym_primitive] = ACTIONS(101),
    [anon_sym_mutable] = ACTIONS(101),
    [anon_sym_struct] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(101),
    [anon_sym_macro] = ACTIONS(101),
    [anon_sym_quote] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_try] = ACTIONS(101),
    [anon_sym_for] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [sym_break_statement] = ACTIONS(101),
    [sym_continue_statement] = ACTIONS(101),
    [anon_sym_return] = ACTIONS(101),
    [anon_sym_const] = ACTIONS(101),
    [anon_sym_global] = ACTIONS(101),
    [anon_sym_local] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_export] = ACTIONS(101),
    [anon_sym_public] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(101),
    [anon_sym_using] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(189),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(189),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(189),
    [anon_sym_COLON2] = ACTIONS(101),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(189),
    [anon_sym_true] = ACTIONS(101),
    [anon_sym_false] = ACTIONS(101),
    [aux_sym_integer_literal_token1] = ACTIONS(189),
    [aux_sym_integer_literal_token2] = ACTIONS(189),
    [aux_sym_integer_literal_token3] = ACTIONS(101),
    [aux_sym_integer_literal_token4] = ACTIONS(101),
    [aux_sym_float_literal_token1] = ACTIONS(189),
    [aux_sym_float_literal_token3] = ACTIONS(189),
    [aux_sym_float_literal_token4] = ACTIONS(189),
    [sym_character_literal] = ACTIONS(189),
    [anon_sym_DQUOTE] = ACTIONS(101),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(189),
    [sym__arrow_operator] = ACTIONS(101),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(101),
    [sym__pipe_right_operator] = ACTIONS(189),
    [sym__pipe_left_operator] = ACTIONS(189),
    [sym__ellipsis_operator] = ACTIONS(101),
    [sym__plus_operator] = ACTIONS(101),
    [sym__times_operator] = ACTIONS(101),
    [sym__rational_operator] = ACTIONS(189),
    [sym__bitshift_operator] = ACTIONS(189),
    [sym__power_operator] = ACTIONS(189),
    [sym__tilde_operator] = ACTIONS(189),
    [sym__type_order_operator] = ACTIONS(189),
    [sym__unary_operator] = ACTIONS(101),
    [sym__unary_plus_operator] = ACTIONS(101),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [7035] = {
    [sym_block_comment] = STATE(7035),
    [sym_line_comment] = STATE(7035),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_SQUOTE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
    [sym__immediate_bracket] = ACTIONS(3075),
    [sym__immediate_brace] = ACTIONS(3075),
  },
  [7036] = {
    [sym_block_comment] = STATE(7036),
    [sym_line_comment] = STATE(7036),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7037] = {
    [sym_block_comment] = STATE(7037),
    [sym_line_comment] = STATE(7037),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_elseif] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7038] = {
    [sym_block_comment] = STATE(7038),
    [sym_line_comment] = STATE(7038),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_RPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_RBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_SEMI] = ACTIONS(9728),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7039] = {
    [sym_block_comment] = STATE(7039),
    [sym_line_comment] = STATE(7039),
    [ts_builtin_sym_end] = ACTIONS(9928),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_RBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7040] = {
    [sym_block_comment] = STATE(7040),
    [sym_line_comment] = STATE(7040),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7041] = {
    [sym_block_comment] = STATE(7041),
    [sym_line_comment] = STATE(7041),
    [sym__word_identifier] = ACTIONS(9954),
    [anon_sym_COMMA] = ACTIONS(9956),
    [anon_sym_EQ] = ACTIONS(9954),
    [anon_sym_begin] = ACTIONS(9954),
    [anon_sym_module] = ACTIONS(9954),
    [anon_sym_baremodule] = ACTIONS(9954),
    [anon_sym_end] = ACTIONS(9954),
    [anon_sym_abstract] = ACTIONS(9954),
    [anon_sym_primitive] = ACTIONS(9954),
    [anon_sym_mutable] = ACTIONS(9954),
    [anon_sym_struct] = ACTIONS(9954),
    [anon_sym_function] = ACTIONS(9954),
    [anon_sym_macro] = ACTIONS(9954),
    [anon_sym_quote] = ACTIONS(9954),
    [anon_sym_let] = ACTIONS(9954),
    [anon_sym_if] = ACTIONS(9954),
    [anon_sym_try] = ACTIONS(9954),
    [anon_sym_for] = ACTIONS(9954),
    [anon_sym_while] = ACTIONS(9954),
    [sym_break_statement] = ACTIONS(9954),
    [sym_continue_statement] = ACTIONS(9954),
    [anon_sym_return] = ACTIONS(9954),
    [anon_sym_const] = ACTIONS(9954),
    [anon_sym_global] = ACTIONS(9954),
    [anon_sym_local] = ACTIONS(9954),
    [anon_sym_LPAREN] = ACTIONS(9956),
    [anon_sym_COLON] = ACTIONS(9954),
    [anon_sym_export] = ACTIONS(9954),
    [anon_sym_public] = ACTIONS(9954),
    [anon_sym_import] = ACTIONS(9954),
    [anon_sym_using] = ACTIONS(9954),
    [anon_sym_LBRACK] = ACTIONS(9956),
    [anon_sym_in] = ACTIONS(9954),
    [anon_sym_LBRACE] = ACTIONS(9956),
    [anon_sym_SQUOTE] = ACTIONS(9954),
    [anon_sym_DOT] = ACTIONS(9954),
    [anon_sym_DOLLAR] = ACTIONS(9956),
    [anon_sym_COLON2] = ACTIONS(9954),
    [anon_sym_COLON_COLON] = ACTIONS(9956),
    [anon_sym_isa] = ACTIONS(9954),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9956),
    [anon_sym_QMARK] = ACTIONS(9956),
    [anon_sym_where] = ACTIONS(9954),
    [anon_sym_AT] = ACTIONS(9956),
    [anon_sym_true] = ACTIONS(9954),
    [anon_sym_false] = ACTIONS(9954),
    [aux_sym_integer_literal_token1] = ACTIONS(9956),
    [aux_sym_integer_literal_token2] = ACTIONS(9956),
    [aux_sym_integer_literal_token3] = ACTIONS(9954),
    [aux_sym_integer_literal_token4] = ACTIONS(9954),
    [aux_sym_float_literal_token1] = ACTIONS(9956),
    [aux_sym_float_literal_token3] = ACTIONS(9956),
    [aux_sym_float_literal_token4] = ACTIONS(9956),
    [sym_character_literal] = ACTIONS(9956),
    [anon_sym_DQUOTE] = ACTIONS(9954),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9956),
    [anon_sym_BQUOTE] = ACTIONS(9954),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9956),
    [sym__pair_operator] = ACTIONS(9956),
    [sym__arrow_operator] = ACTIONS(9954),
    [sym__lazy_or_operator] = ACTIONS(9956),
    [sym__lazy_and_operator] = ACTIONS(9956),
    [sym__comparison_operator] = ACTIONS(9954),
    [sym__pipe_right_operator] = ACTIONS(9956),
    [sym__pipe_left_operator] = ACTIONS(9956),
    [sym__ellipsis_operator] = ACTIONS(9954),
    [sym__plus_operator] = ACTIONS(9954),
    [sym__times_operator] = ACTIONS(9954),
    [sym__rational_operator] = ACTIONS(9956),
    [sym__bitshift_operator] = ACTIONS(9956),
    [sym__power_operator] = ACTIONS(9956),
    [sym__tilde_operator] = ACTIONS(9956),
    [sym__type_order_operator] = ACTIONS(9956),
    [sym__unary_operator] = ACTIONS(9954),
    [sym__unary_plus_operator] = ACTIONS(9954),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9956),
    [sym__immediate_bracket] = ACTIONS(9956),
    [sym__immediate_brace] = ACTIONS(9956),
  },
  [7042] = {
    [sym_block_comment] = STATE(7042),
    [sym_line_comment] = STATE(7042),
    [sym__word_identifier] = ACTIONS(9962),
    [anon_sym_COMMA] = ACTIONS(9964),
    [anon_sym_EQ] = ACTIONS(9962),
    [anon_sym_begin] = ACTIONS(9962),
    [anon_sym_module] = ACTIONS(9962),
    [anon_sym_baremodule] = ACTIONS(9962),
    [anon_sym_end] = ACTIONS(9962),
    [anon_sym_abstract] = ACTIONS(9962),
    [anon_sym_primitive] = ACTIONS(9962),
    [anon_sym_mutable] = ACTIONS(9962),
    [anon_sym_struct] = ACTIONS(9962),
    [anon_sym_function] = ACTIONS(9962),
    [anon_sym_macro] = ACTIONS(9962),
    [anon_sym_quote] = ACTIONS(9962),
    [anon_sym_let] = ACTIONS(9962),
    [anon_sym_if] = ACTIONS(9962),
    [anon_sym_try] = ACTIONS(9962),
    [anon_sym_for] = ACTIONS(9962),
    [anon_sym_while] = ACTIONS(9962),
    [sym_break_statement] = ACTIONS(9962),
    [sym_continue_statement] = ACTIONS(9962),
    [anon_sym_return] = ACTIONS(9962),
    [anon_sym_const] = ACTIONS(9962),
    [anon_sym_global] = ACTIONS(9962),
    [anon_sym_local] = ACTIONS(9962),
    [anon_sym_LPAREN] = ACTIONS(9964),
    [anon_sym_COLON] = ACTIONS(9962),
    [anon_sym_export] = ACTIONS(9962),
    [anon_sym_public] = ACTIONS(9962),
    [anon_sym_import] = ACTIONS(9962),
    [anon_sym_using] = ACTIONS(9962),
    [anon_sym_LBRACK] = ACTIONS(9964),
    [anon_sym_in] = ACTIONS(9962),
    [anon_sym_LBRACE] = ACTIONS(9964),
    [anon_sym_SQUOTE] = ACTIONS(9962),
    [anon_sym_DOT] = ACTIONS(9962),
    [anon_sym_DOLLAR] = ACTIONS(9964),
    [anon_sym_COLON2] = ACTIONS(9962),
    [anon_sym_COLON_COLON] = ACTIONS(9964),
    [anon_sym_isa] = ACTIONS(9962),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9964),
    [anon_sym_QMARK] = ACTIONS(9964),
    [anon_sym_where] = ACTIONS(9962),
    [anon_sym_AT] = ACTIONS(9964),
    [anon_sym_true] = ACTIONS(9962),
    [anon_sym_false] = ACTIONS(9962),
    [aux_sym_integer_literal_token1] = ACTIONS(9964),
    [aux_sym_integer_literal_token2] = ACTIONS(9964),
    [aux_sym_integer_literal_token3] = ACTIONS(9962),
    [aux_sym_integer_literal_token4] = ACTIONS(9962),
    [aux_sym_float_literal_token1] = ACTIONS(9964),
    [aux_sym_float_literal_token3] = ACTIONS(9964),
    [aux_sym_float_literal_token4] = ACTIONS(9964),
    [sym_character_literal] = ACTIONS(9964),
    [anon_sym_DQUOTE] = ACTIONS(9962),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9964),
    [anon_sym_BQUOTE] = ACTIONS(9962),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9964),
    [sym__pair_operator] = ACTIONS(9964),
    [sym__arrow_operator] = ACTIONS(9962),
    [sym__lazy_or_operator] = ACTIONS(9964),
    [sym__lazy_and_operator] = ACTIONS(9964),
    [sym__comparison_operator] = ACTIONS(9962),
    [sym__pipe_right_operator] = ACTIONS(9964),
    [sym__pipe_left_operator] = ACTIONS(9964),
    [sym__ellipsis_operator] = ACTIONS(9962),
    [sym__plus_operator] = ACTIONS(9962),
    [sym__times_operator] = ACTIONS(9962),
    [sym__rational_operator] = ACTIONS(9964),
    [sym__bitshift_operator] = ACTIONS(9964),
    [sym__power_operator] = ACTIONS(9964),
    [sym__tilde_operator] = ACTIONS(9964),
    [sym__type_order_operator] = ACTIONS(9964),
    [sym__unary_operator] = ACTIONS(9962),
    [sym__unary_plus_operator] = ACTIONS(9962),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9964),
    [sym__immediate_bracket] = ACTIONS(9964),
    [sym__immediate_brace] = ACTIONS(9964),
  },
  [7043] = {
    [sym_block_comment] = STATE(7043),
    [sym_line_comment] = STATE(7043),
    [sym__word_identifier] = ACTIONS(9706),
    [anon_sym_COMMA] = ACTIONS(9708),
    [anon_sym_EQ] = ACTIONS(9706),
    [anon_sym_begin] = ACTIONS(9706),
    [anon_sym_module] = ACTIONS(9706),
    [anon_sym_baremodule] = ACTIONS(9706),
    [anon_sym_end] = ACTIONS(9706),
    [anon_sym_abstract] = ACTIONS(9706),
    [anon_sym_primitive] = ACTIONS(9706),
    [anon_sym_mutable] = ACTIONS(9706),
    [anon_sym_struct] = ACTIONS(9706),
    [anon_sym_function] = ACTIONS(9706),
    [anon_sym_macro] = ACTIONS(9706),
    [anon_sym_quote] = ACTIONS(9706),
    [anon_sym_let] = ACTIONS(9706),
    [anon_sym_if] = ACTIONS(9706),
    [anon_sym_try] = ACTIONS(9706),
    [anon_sym_for] = ACTIONS(9706),
    [anon_sym_while] = ACTIONS(9706),
    [sym_break_statement] = ACTIONS(9706),
    [sym_continue_statement] = ACTIONS(9706),
    [anon_sym_return] = ACTIONS(9706),
    [anon_sym_const] = ACTIONS(9706),
    [anon_sym_global] = ACTIONS(9706),
    [anon_sym_local] = ACTIONS(9706),
    [anon_sym_LPAREN] = ACTIONS(9708),
    [anon_sym_COLON] = ACTIONS(9706),
    [anon_sym_export] = ACTIONS(9706),
    [anon_sym_public] = ACTIONS(9706),
    [anon_sym_import] = ACTIONS(9706),
    [anon_sym_using] = ACTIONS(9706),
    [anon_sym_LBRACK] = ACTIONS(9708),
    [anon_sym_in] = ACTIONS(9706),
    [anon_sym_LBRACE] = ACTIONS(9708),
    [anon_sym_SQUOTE] = ACTIONS(9706),
    [anon_sym_DOT] = ACTIONS(9706),
    [anon_sym_DOLLAR] = ACTIONS(9708),
    [anon_sym_COLON2] = ACTIONS(9706),
    [anon_sym_COLON_COLON] = ACTIONS(9708),
    [anon_sym_isa] = ACTIONS(9706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9708),
    [anon_sym_QMARK] = ACTIONS(9708),
    [anon_sym_where] = ACTIONS(9706),
    [anon_sym_AT] = ACTIONS(9708),
    [anon_sym_true] = ACTIONS(9706),
    [anon_sym_false] = ACTIONS(9706),
    [aux_sym_integer_literal_token1] = ACTIONS(9708),
    [aux_sym_integer_literal_token2] = ACTIONS(9708),
    [aux_sym_integer_literal_token3] = ACTIONS(9706),
    [aux_sym_integer_literal_token4] = ACTIONS(9706),
    [aux_sym_float_literal_token1] = ACTIONS(9708),
    [aux_sym_float_literal_token3] = ACTIONS(9708),
    [aux_sym_float_literal_token4] = ACTIONS(9708),
    [sym_character_literal] = ACTIONS(9708),
    [anon_sym_DQUOTE] = ACTIONS(9706),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9708),
    [anon_sym_BQUOTE] = ACTIONS(9706),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9708),
    [sym__pair_operator] = ACTIONS(9708),
    [sym__arrow_operator] = ACTIONS(9706),
    [sym__lazy_or_operator] = ACTIONS(9708),
    [sym__lazy_and_operator] = ACTIONS(9708),
    [sym__comparison_operator] = ACTIONS(9706),
    [sym__pipe_right_operator] = ACTIONS(9708),
    [sym__pipe_left_operator] = ACTIONS(9708),
    [sym__ellipsis_operator] = ACTIONS(9706),
    [sym__plus_operator] = ACTIONS(9706),
    [sym__times_operator] = ACTIONS(9706),
    [sym__rational_operator] = ACTIONS(9708),
    [sym__bitshift_operator] = ACTIONS(9708),
    [sym__power_operator] = ACTIONS(9708),
    [sym__tilde_operator] = ACTIONS(9708),
    [sym__type_order_operator] = ACTIONS(9708),
    [sym__unary_operator] = ACTIONS(9706),
    [sym__unary_plus_operator] = ACTIONS(9706),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9708),
    [sym__immediate_bracket] = ACTIONS(9708),
    [sym__immediate_brace] = ACTIONS(9708),
  },
  [7044] = {
    [sym_block_comment] = STATE(7044),
    [sym_line_comment] = STATE(7044),
    [sym__word_identifier] = ACTIONS(9710),
    [anon_sym_COMMA] = ACTIONS(9712),
    [anon_sym_EQ] = ACTIONS(9710),
    [anon_sym_begin] = ACTIONS(9710),
    [anon_sym_module] = ACTIONS(9710),
    [anon_sym_baremodule] = ACTIONS(9710),
    [anon_sym_end] = ACTIONS(9710),
    [anon_sym_abstract] = ACTIONS(9710),
    [anon_sym_primitive] = ACTIONS(9710),
    [anon_sym_mutable] = ACTIONS(9710),
    [anon_sym_struct] = ACTIONS(9710),
    [anon_sym_function] = ACTIONS(9710),
    [anon_sym_macro] = ACTIONS(9710),
    [anon_sym_quote] = ACTIONS(9710),
    [anon_sym_let] = ACTIONS(9710),
    [anon_sym_if] = ACTIONS(9710),
    [anon_sym_try] = ACTIONS(9710),
    [anon_sym_for] = ACTIONS(9710),
    [anon_sym_while] = ACTIONS(9710),
    [sym_break_statement] = ACTIONS(9710),
    [sym_continue_statement] = ACTIONS(9710),
    [anon_sym_return] = ACTIONS(9710),
    [anon_sym_const] = ACTIONS(9710),
    [anon_sym_global] = ACTIONS(9710),
    [anon_sym_local] = ACTIONS(9710),
    [anon_sym_LPAREN] = ACTIONS(9712),
    [anon_sym_COLON] = ACTIONS(9710),
    [anon_sym_export] = ACTIONS(9710),
    [anon_sym_public] = ACTIONS(9710),
    [anon_sym_import] = ACTIONS(9710),
    [anon_sym_using] = ACTIONS(9710),
    [anon_sym_LBRACK] = ACTIONS(9712),
    [anon_sym_in] = ACTIONS(9710),
    [anon_sym_LBRACE] = ACTIONS(9712),
    [anon_sym_SQUOTE] = ACTIONS(9710),
    [anon_sym_DOT] = ACTIONS(9710),
    [anon_sym_DOLLAR] = ACTIONS(9712),
    [anon_sym_COLON2] = ACTIONS(9710),
    [anon_sym_COLON_COLON] = ACTIONS(9712),
    [anon_sym_isa] = ACTIONS(9710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9712),
    [anon_sym_QMARK] = ACTIONS(9712),
    [anon_sym_where] = ACTIONS(9710),
    [anon_sym_AT] = ACTIONS(9712),
    [anon_sym_true] = ACTIONS(9710),
    [anon_sym_false] = ACTIONS(9710),
    [aux_sym_integer_literal_token1] = ACTIONS(9712),
    [aux_sym_integer_literal_token2] = ACTIONS(9712),
    [aux_sym_integer_literal_token3] = ACTIONS(9710),
    [aux_sym_integer_literal_token4] = ACTIONS(9710),
    [aux_sym_float_literal_token1] = ACTIONS(9712),
    [aux_sym_float_literal_token3] = ACTIONS(9712),
    [aux_sym_float_literal_token4] = ACTIONS(9712),
    [sym_character_literal] = ACTIONS(9712),
    [anon_sym_DQUOTE] = ACTIONS(9710),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9712),
    [anon_sym_BQUOTE] = ACTIONS(9710),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9712),
    [sym__pair_operator] = ACTIONS(9712),
    [sym__arrow_operator] = ACTIONS(9710),
    [sym__lazy_or_operator] = ACTIONS(9712),
    [sym__lazy_and_operator] = ACTIONS(9712),
    [sym__comparison_operator] = ACTIONS(9710),
    [sym__pipe_right_operator] = ACTIONS(9712),
    [sym__pipe_left_operator] = ACTIONS(9712),
    [sym__ellipsis_operator] = ACTIONS(9710),
    [sym__plus_operator] = ACTIONS(9710),
    [sym__times_operator] = ACTIONS(9710),
    [sym__rational_operator] = ACTIONS(9712),
    [sym__bitshift_operator] = ACTIONS(9712),
    [sym__power_operator] = ACTIONS(9712),
    [sym__tilde_operator] = ACTIONS(9712),
    [sym__type_order_operator] = ACTIONS(9712),
    [sym__unary_operator] = ACTIONS(9710),
    [sym__unary_plus_operator] = ACTIONS(9710),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9712),
    [sym__immediate_bracket] = ACTIONS(9712),
    [sym__immediate_brace] = ACTIONS(9712),
  },
  [7045] = {
    [sym_block_comment] = STATE(7045),
    [sym_line_comment] = STATE(7045),
    [aux_sym__import_list_repeat1] = STATE(7743),
    [ts_builtin_sym_end] = ACTIONS(10755),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10917),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10919),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10921),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_RBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7046] = {
    [sym_block_comment] = STATE(7046),
    [sym_line_comment] = STATE(7046),
    [ts_builtin_sym_end] = ACTIONS(10759),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_RBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOT] = ACTIONS(10923),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7047] = {
    [sym_block_comment] = STATE(7047),
    [sym_line_comment] = STATE(7047),
    [ts_builtin_sym_end] = ACTIONS(10763),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_RBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(10923),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7048] = {
    [sym_block_comment] = STATE(7048),
    [sym_line_comment] = STATE(7048),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_RPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_RBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9740),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_RBRACE] = ACTIONS(9740),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7049] = {
    [sym_block_comment] = STATE(7049),
    [sym_line_comment] = STATE(7049),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_RPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_RBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_SEMI] = ACTIONS(9746),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_RBRACE] = ACTIONS(9746),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7050] = {
    [sym_block_comment] = STATE(7050),
    [sym_line_comment] = STATE(7050),
    [sym__word_identifier] = ACTIONS(10102),
    [anon_sym_COMMA] = ACTIONS(10104),
    [anon_sym_EQ] = ACTIONS(10102),
    [anon_sym_begin] = ACTIONS(10102),
    [anon_sym_module] = ACTIONS(10102),
    [anon_sym_baremodule] = ACTIONS(10102),
    [anon_sym_end] = ACTIONS(10102),
    [anon_sym_abstract] = ACTIONS(10102),
    [anon_sym_primitive] = ACTIONS(10102),
    [anon_sym_mutable] = ACTIONS(10102),
    [anon_sym_struct] = ACTIONS(10102),
    [anon_sym_function] = ACTIONS(10102),
    [anon_sym_macro] = ACTIONS(10102),
    [anon_sym_quote] = ACTIONS(10102),
    [anon_sym_let] = ACTIONS(10102),
    [anon_sym_if] = ACTIONS(10102),
    [anon_sym_try] = ACTIONS(10102),
    [anon_sym_for] = ACTIONS(10102),
    [anon_sym_while] = ACTIONS(10102),
    [sym_break_statement] = ACTIONS(10102),
    [sym_continue_statement] = ACTIONS(10102),
    [anon_sym_return] = ACTIONS(10102),
    [anon_sym_const] = ACTIONS(10102),
    [anon_sym_global] = ACTIONS(10102),
    [anon_sym_local] = ACTIONS(10102),
    [anon_sym_LPAREN] = ACTIONS(10104),
    [anon_sym_COLON] = ACTIONS(10102),
    [anon_sym_export] = ACTIONS(10102),
    [anon_sym_public] = ACTIONS(10102),
    [anon_sym_import] = ACTIONS(10102),
    [anon_sym_using] = ACTIONS(10102),
    [anon_sym_LBRACK] = ACTIONS(10104),
    [anon_sym_in] = ACTIONS(10102),
    [anon_sym_LBRACE] = ACTIONS(10104),
    [anon_sym_SQUOTE] = ACTIONS(10102),
    [anon_sym_DOT] = ACTIONS(10102),
    [anon_sym_DOLLAR] = ACTIONS(10104),
    [anon_sym_COLON2] = ACTIONS(10102),
    [anon_sym_COLON_COLON] = ACTIONS(10104),
    [anon_sym_isa] = ACTIONS(10102),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10104),
    [anon_sym_QMARK] = ACTIONS(10104),
    [anon_sym_where] = ACTIONS(10102),
    [anon_sym_AT] = ACTIONS(10104),
    [anon_sym_true] = ACTIONS(10102),
    [anon_sym_false] = ACTIONS(10102),
    [aux_sym_integer_literal_token1] = ACTIONS(10104),
    [aux_sym_integer_literal_token2] = ACTIONS(10104),
    [aux_sym_integer_literal_token3] = ACTIONS(10102),
    [aux_sym_integer_literal_token4] = ACTIONS(10102),
    [aux_sym_float_literal_token1] = ACTIONS(10104),
    [aux_sym_float_literal_token3] = ACTIONS(10104),
    [aux_sym_float_literal_token4] = ACTIONS(10104),
    [sym_character_literal] = ACTIONS(10104),
    [anon_sym_DQUOTE] = ACTIONS(10102),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10104),
    [anon_sym_BQUOTE] = ACTIONS(10102),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10104),
    [sym__pair_operator] = ACTIONS(10104),
    [sym__arrow_operator] = ACTIONS(10102),
    [sym__lazy_or_operator] = ACTIONS(10104),
    [sym__lazy_and_operator] = ACTIONS(10104),
    [sym__comparison_operator] = ACTIONS(10102),
    [sym__pipe_right_operator] = ACTIONS(10104),
    [sym__pipe_left_operator] = ACTIONS(10104),
    [sym__ellipsis_operator] = ACTIONS(10102),
    [sym__plus_operator] = ACTIONS(10102),
    [sym__times_operator] = ACTIONS(10102),
    [sym__rational_operator] = ACTIONS(10104),
    [sym__bitshift_operator] = ACTIONS(10104),
    [sym__power_operator] = ACTIONS(10104),
    [sym__tilde_operator] = ACTIONS(10104),
    [sym__type_order_operator] = ACTIONS(10104),
    [sym__unary_operator] = ACTIONS(10102),
    [sym__unary_plus_operator] = ACTIONS(10102),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10104),
    [sym__immediate_bracket] = ACTIONS(10104),
    [sym__immediate_brace] = ACTIONS(10104),
  },
  [7051] = {
    [sym_block_comment] = STATE(7051),
    [sym_line_comment] = STATE(7051),
    [sym__word_identifier] = ACTIONS(10106),
    [anon_sym_COMMA] = ACTIONS(10108),
    [anon_sym_EQ] = ACTIONS(10106),
    [anon_sym_begin] = ACTIONS(10106),
    [anon_sym_module] = ACTIONS(10106),
    [anon_sym_baremodule] = ACTIONS(10106),
    [anon_sym_end] = ACTIONS(10106),
    [anon_sym_abstract] = ACTIONS(10106),
    [anon_sym_primitive] = ACTIONS(10106),
    [anon_sym_mutable] = ACTIONS(10106),
    [anon_sym_struct] = ACTIONS(10106),
    [anon_sym_function] = ACTIONS(10106),
    [anon_sym_macro] = ACTIONS(10106),
    [anon_sym_quote] = ACTIONS(10106),
    [anon_sym_let] = ACTIONS(10106),
    [anon_sym_if] = ACTIONS(10106),
    [anon_sym_try] = ACTIONS(10106),
    [anon_sym_for] = ACTIONS(10106),
    [anon_sym_while] = ACTIONS(10106),
    [sym_break_statement] = ACTIONS(10106),
    [sym_continue_statement] = ACTIONS(10106),
    [anon_sym_return] = ACTIONS(10106),
    [anon_sym_const] = ACTIONS(10106),
    [anon_sym_global] = ACTIONS(10106),
    [anon_sym_local] = ACTIONS(10106),
    [anon_sym_LPAREN] = ACTIONS(10108),
    [anon_sym_COLON] = ACTIONS(10106),
    [anon_sym_export] = ACTIONS(10106),
    [anon_sym_public] = ACTIONS(10106),
    [anon_sym_import] = ACTIONS(10106),
    [anon_sym_using] = ACTIONS(10106),
    [anon_sym_LBRACK] = ACTIONS(10108),
    [anon_sym_in] = ACTIONS(10106),
    [anon_sym_LBRACE] = ACTIONS(10108),
    [anon_sym_SQUOTE] = ACTIONS(10106),
    [anon_sym_DOT] = ACTIONS(10106),
    [anon_sym_DOLLAR] = ACTIONS(10108),
    [anon_sym_COLON2] = ACTIONS(10106),
    [anon_sym_COLON_COLON] = ACTIONS(10108),
    [anon_sym_isa] = ACTIONS(10106),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10108),
    [anon_sym_QMARK] = ACTIONS(10108),
    [anon_sym_where] = ACTIONS(10106),
    [anon_sym_AT] = ACTIONS(10108),
    [anon_sym_true] = ACTIONS(10106),
    [anon_sym_false] = ACTIONS(10106),
    [aux_sym_integer_literal_token1] = ACTIONS(10108),
    [aux_sym_integer_literal_token2] = ACTIONS(10108),
    [aux_sym_integer_literal_token3] = ACTIONS(10106),
    [aux_sym_integer_literal_token4] = ACTIONS(10106),
    [aux_sym_float_literal_token1] = ACTIONS(10108),
    [aux_sym_float_literal_token3] = ACTIONS(10108),
    [aux_sym_float_literal_token4] = ACTIONS(10108),
    [sym_character_literal] = ACTIONS(10108),
    [anon_sym_DQUOTE] = ACTIONS(10106),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10108),
    [anon_sym_BQUOTE] = ACTIONS(10106),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10108),
    [sym__pair_operator] = ACTIONS(10108),
    [sym__arrow_operator] = ACTIONS(10106),
    [sym__lazy_or_operator] = ACTIONS(10108),
    [sym__lazy_and_operator] = ACTIONS(10108),
    [sym__comparison_operator] = ACTIONS(10106),
    [sym__pipe_right_operator] = ACTIONS(10108),
    [sym__pipe_left_operator] = ACTIONS(10108),
    [sym__ellipsis_operator] = ACTIONS(10106),
    [sym__plus_operator] = ACTIONS(10106),
    [sym__times_operator] = ACTIONS(10106),
    [sym__rational_operator] = ACTIONS(10108),
    [sym__bitshift_operator] = ACTIONS(10108),
    [sym__power_operator] = ACTIONS(10108),
    [sym__tilde_operator] = ACTIONS(10108),
    [sym__type_order_operator] = ACTIONS(10108),
    [sym__unary_operator] = ACTIONS(10106),
    [sym__unary_plus_operator] = ACTIONS(10106),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10108),
    [sym__immediate_bracket] = ACTIONS(10108),
    [sym__immediate_brace] = ACTIONS(10108),
  },
  [7052] = {
    [sym_block_comment] = STATE(7052),
    [sym_line_comment] = STATE(7052),
    [ts_builtin_sym_end] = ACTIONS(10118),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_RBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7053] = {
    [sym_block_comment] = STATE(7053),
    [sym_line_comment] = STATE(7053),
    [sym__word_identifier] = ACTIONS(10122),
    [anon_sym_COMMA] = ACTIONS(10124),
    [anon_sym_EQ] = ACTIONS(10122),
    [anon_sym_begin] = ACTIONS(10122),
    [anon_sym_module] = ACTIONS(10122),
    [anon_sym_baremodule] = ACTIONS(10122),
    [anon_sym_end] = ACTIONS(10122),
    [anon_sym_abstract] = ACTIONS(10122),
    [anon_sym_primitive] = ACTIONS(10122),
    [anon_sym_mutable] = ACTIONS(10122),
    [anon_sym_struct] = ACTIONS(10122),
    [anon_sym_function] = ACTIONS(10122),
    [anon_sym_macro] = ACTIONS(10122),
    [anon_sym_quote] = ACTIONS(10122),
    [anon_sym_let] = ACTIONS(10122),
    [anon_sym_if] = ACTIONS(10122),
    [anon_sym_try] = ACTIONS(10122),
    [anon_sym_for] = ACTIONS(10122),
    [anon_sym_while] = ACTIONS(10122),
    [sym_break_statement] = ACTIONS(10122),
    [sym_continue_statement] = ACTIONS(10122),
    [anon_sym_return] = ACTIONS(10122),
    [anon_sym_const] = ACTIONS(10122),
    [anon_sym_global] = ACTIONS(10122),
    [anon_sym_local] = ACTIONS(10122),
    [anon_sym_LPAREN] = ACTIONS(10124),
    [anon_sym_COLON] = ACTIONS(10122),
    [anon_sym_export] = ACTIONS(10122),
    [anon_sym_public] = ACTIONS(10122),
    [anon_sym_import] = ACTIONS(10122),
    [anon_sym_using] = ACTIONS(10122),
    [anon_sym_LBRACK] = ACTIONS(10124),
    [anon_sym_in] = ACTIONS(10122),
    [anon_sym_LBRACE] = ACTIONS(10124),
    [anon_sym_SQUOTE] = ACTIONS(10122),
    [anon_sym_DOT] = ACTIONS(10122),
    [anon_sym_DOLLAR] = ACTIONS(10124),
    [anon_sym_COLON2] = ACTIONS(10122),
    [anon_sym_COLON_COLON] = ACTIONS(10124),
    [anon_sym_isa] = ACTIONS(10122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10124),
    [anon_sym_QMARK] = ACTIONS(10124),
    [anon_sym_where] = ACTIONS(10122),
    [anon_sym_AT] = ACTIONS(10124),
    [anon_sym_true] = ACTIONS(10122),
    [anon_sym_false] = ACTIONS(10122),
    [aux_sym_integer_literal_token1] = ACTIONS(10124),
    [aux_sym_integer_literal_token2] = ACTIONS(10124),
    [aux_sym_integer_literal_token3] = ACTIONS(10122),
    [aux_sym_integer_literal_token4] = ACTIONS(10122),
    [aux_sym_float_literal_token1] = ACTIONS(10124),
    [aux_sym_float_literal_token3] = ACTIONS(10124),
    [aux_sym_float_literal_token4] = ACTIONS(10124),
    [sym_character_literal] = ACTIONS(10124),
    [anon_sym_DQUOTE] = ACTIONS(10122),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10124),
    [anon_sym_BQUOTE] = ACTIONS(10122),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10124),
    [sym__pair_operator] = ACTIONS(10124),
    [sym__arrow_operator] = ACTIONS(10122),
    [sym__lazy_or_operator] = ACTIONS(10124),
    [sym__lazy_and_operator] = ACTIONS(10124),
    [sym__comparison_operator] = ACTIONS(10122),
    [sym__pipe_right_operator] = ACTIONS(10124),
    [sym__pipe_left_operator] = ACTIONS(10124),
    [sym__ellipsis_operator] = ACTIONS(10122),
    [sym__plus_operator] = ACTIONS(10122),
    [sym__times_operator] = ACTIONS(10122),
    [sym__rational_operator] = ACTIONS(10124),
    [sym__bitshift_operator] = ACTIONS(10124),
    [sym__power_operator] = ACTIONS(10124),
    [sym__tilde_operator] = ACTIONS(10124),
    [sym__type_order_operator] = ACTIONS(10124),
    [sym__unary_operator] = ACTIONS(10122),
    [sym__unary_plus_operator] = ACTIONS(10122),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10124),
    [sym__immediate_bracket] = ACTIONS(10124),
    [sym__immediate_brace] = ACTIONS(10124),
  },
  [7054] = {
    [sym_block_comment] = STATE(7054),
    [sym_line_comment] = STATE(7054),
    [sym__word_identifier] = ACTIONS(9702),
    [anon_sym_COMMA] = ACTIONS(9704),
    [anon_sym_EQ] = ACTIONS(9702),
    [anon_sym_begin] = ACTIONS(9702),
    [anon_sym_module] = ACTIONS(9702),
    [anon_sym_baremodule] = ACTIONS(9702),
    [anon_sym_end] = ACTIONS(9702),
    [anon_sym_abstract] = ACTIONS(9702),
    [anon_sym_primitive] = ACTIONS(9702),
    [anon_sym_mutable] = ACTIONS(9702),
    [anon_sym_struct] = ACTIONS(9702),
    [anon_sym_function] = ACTIONS(9702),
    [anon_sym_macro] = ACTIONS(9702),
    [anon_sym_quote] = ACTIONS(9702),
    [anon_sym_let] = ACTIONS(9702),
    [anon_sym_if] = ACTIONS(9702),
    [anon_sym_try] = ACTIONS(9702),
    [anon_sym_for] = ACTIONS(9702),
    [anon_sym_while] = ACTIONS(9702),
    [sym_break_statement] = ACTIONS(9702),
    [sym_continue_statement] = ACTIONS(9702),
    [anon_sym_return] = ACTIONS(9702),
    [anon_sym_const] = ACTIONS(9702),
    [anon_sym_global] = ACTIONS(9702),
    [anon_sym_local] = ACTIONS(9702),
    [anon_sym_LPAREN] = ACTIONS(9704),
    [anon_sym_COLON] = ACTIONS(9702),
    [anon_sym_export] = ACTIONS(9702),
    [anon_sym_public] = ACTIONS(9702),
    [anon_sym_import] = ACTIONS(9702),
    [anon_sym_using] = ACTIONS(9702),
    [anon_sym_LBRACK] = ACTIONS(9704),
    [anon_sym_in] = ACTIONS(9702),
    [anon_sym_LBRACE] = ACTIONS(9704),
    [anon_sym_SQUOTE] = ACTIONS(9702),
    [anon_sym_DOT] = ACTIONS(9702),
    [anon_sym_DOLLAR] = ACTIONS(9704),
    [anon_sym_COLON2] = ACTIONS(9702),
    [anon_sym_COLON_COLON] = ACTIONS(9704),
    [anon_sym_isa] = ACTIONS(9702),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9704),
    [anon_sym_QMARK] = ACTIONS(9704),
    [anon_sym_where] = ACTIONS(9702),
    [anon_sym_AT] = ACTIONS(9704),
    [anon_sym_true] = ACTIONS(9702),
    [anon_sym_false] = ACTIONS(9702),
    [aux_sym_integer_literal_token1] = ACTIONS(9704),
    [aux_sym_integer_literal_token2] = ACTIONS(9704),
    [aux_sym_integer_literal_token3] = ACTIONS(9702),
    [aux_sym_integer_literal_token4] = ACTIONS(9702),
    [aux_sym_float_literal_token1] = ACTIONS(9704),
    [aux_sym_float_literal_token3] = ACTIONS(9704),
    [aux_sym_float_literal_token4] = ACTIONS(9704),
    [sym_character_literal] = ACTIONS(9704),
    [anon_sym_DQUOTE] = ACTIONS(9702),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9704),
    [anon_sym_BQUOTE] = ACTIONS(9702),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9704),
    [sym__pair_operator] = ACTIONS(9704),
    [sym__arrow_operator] = ACTIONS(9702),
    [sym__lazy_or_operator] = ACTIONS(9704),
    [sym__lazy_and_operator] = ACTIONS(9704),
    [sym__comparison_operator] = ACTIONS(9702),
    [sym__pipe_right_operator] = ACTIONS(9704),
    [sym__pipe_left_operator] = ACTIONS(9704),
    [sym__ellipsis_operator] = ACTIONS(9702),
    [sym__plus_operator] = ACTIONS(9702),
    [sym__times_operator] = ACTIONS(9702),
    [sym__rational_operator] = ACTIONS(9704),
    [sym__bitshift_operator] = ACTIONS(9704),
    [sym__power_operator] = ACTIONS(9704),
    [sym__tilde_operator] = ACTIONS(9704),
    [sym__type_order_operator] = ACTIONS(9704),
    [sym__unary_operator] = ACTIONS(9702),
    [sym__unary_plus_operator] = ACTIONS(9702),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9704),
    [sym__immediate_bracket] = ACTIONS(9704),
    [sym__immediate_brace] = ACTIONS(9704),
  },
  [7055] = {
    [sym_block_comment] = STATE(7055),
    [sym_line_comment] = STATE(7055),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_elseif] = ACTIONS(10577),
    [anon_sym_else] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7056] = {
    [sym_block_comment] = STATE(7056),
    [sym_line_comment] = STATE(7056),
    [sym__word_identifier] = ACTIONS(10128),
    [anon_sym_COMMA] = ACTIONS(10130),
    [anon_sym_EQ] = ACTIONS(10128),
    [anon_sym_begin] = ACTIONS(10128),
    [anon_sym_module] = ACTIONS(10128),
    [anon_sym_baremodule] = ACTIONS(10128),
    [anon_sym_end] = ACTIONS(10128),
    [anon_sym_abstract] = ACTIONS(10128),
    [anon_sym_primitive] = ACTIONS(10128),
    [anon_sym_mutable] = ACTIONS(10128),
    [anon_sym_struct] = ACTIONS(10128),
    [anon_sym_function] = ACTIONS(10128),
    [anon_sym_macro] = ACTIONS(10128),
    [anon_sym_quote] = ACTIONS(10128),
    [anon_sym_let] = ACTIONS(10128),
    [anon_sym_if] = ACTIONS(10128),
    [anon_sym_try] = ACTIONS(10128),
    [anon_sym_for] = ACTIONS(10128),
    [anon_sym_while] = ACTIONS(10128),
    [sym_break_statement] = ACTIONS(10128),
    [sym_continue_statement] = ACTIONS(10128),
    [anon_sym_return] = ACTIONS(10128),
    [anon_sym_const] = ACTIONS(10128),
    [anon_sym_global] = ACTIONS(10128),
    [anon_sym_local] = ACTIONS(10128),
    [anon_sym_LPAREN] = ACTIONS(10130),
    [anon_sym_COLON] = ACTIONS(10128),
    [anon_sym_export] = ACTIONS(10128),
    [anon_sym_public] = ACTIONS(10128),
    [anon_sym_import] = ACTIONS(10128),
    [anon_sym_using] = ACTIONS(10128),
    [anon_sym_LBRACK] = ACTIONS(10130),
    [anon_sym_in] = ACTIONS(10128),
    [anon_sym_LBRACE] = ACTIONS(10130),
    [anon_sym_SQUOTE] = ACTIONS(10128),
    [anon_sym_DOT] = ACTIONS(10128),
    [anon_sym_DOLLAR] = ACTIONS(10130),
    [anon_sym_COLON2] = ACTIONS(10128),
    [anon_sym_COLON_COLON] = ACTIONS(10130),
    [anon_sym_isa] = ACTIONS(10128),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10130),
    [anon_sym_QMARK] = ACTIONS(10130),
    [anon_sym_where] = ACTIONS(10128),
    [anon_sym_AT] = ACTIONS(10130),
    [anon_sym_true] = ACTIONS(10128),
    [anon_sym_false] = ACTIONS(10128),
    [aux_sym_integer_literal_token1] = ACTIONS(10130),
    [aux_sym_integer_literal_token2] = ACTIONS(10130),
    [aux_sym_integer_literal_token3] = ACTIONS(10128),
    [aux_sym_integer_literal_token4] = ACTIONS(10128),
    [aux_sym_float_literal_token1] = ACTIONS(10130),
    [aux_sym_float_literal_token3] = ACTIONS(10130),
    [aux_sym_float_literal_token4] = ACTIONS(10130),
    [sym_character_literal] = ACTIONS(10130),
    [anon_sym_DQUOTE] = ACTIONS(10128),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10130),
    [anon_sym_BQUOTE] = ACTIONS(10128),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10130),
    [sym__pair_operator] = ACTIONS(10130),
    [sym__arrow_operator] = ACTIONS(10128),
    [sym__lazy_or_operator] = ACTIONS(10130),
    [sym__lazy_and_operator] = ACTIONS(10130),
    [sym__comparison_operator] = ACTIONS(10128),
    [sym__pipe_right_operator] = ACTIONS(10130),
    [sym__pipe_left_operator] = ACTIONS(10130),
    [sym__ellipsis_operator] = ACTIONS(10128),
    [sym__plus_operator] = ACTIONS(10128),
    [sym__times_operator] = ACTIONS(10128),
    [sym__rational_operator] = ACTIONS(10130),
    [sym__bitshift_operator] = ACTIONS(10130),
    [sym__power_operator] = ACTIONS(10130),
    [sym__tilde_operator] = ACTIONS(10130),
    [sym__type_order_operator] = ACTIONS(10130),
    [sym__unary_operator] = ACTIONS(10128),
    [sym__unary_plus_operator] = ACTIONS(10128),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10130),
    [sym__immediate_bracket] = ACTIONS(10130),
    [sym__immediate_brace] = ACTIONS(10130),
  },
  [7057] = {
    [sym_block_comment] = STATE(7057),
    [sym_line_comment] = STATE(7057),
    [sym__word_identifier] = ACTIONS(10138),
    [anon_sym_COMMA] = ACTIONS(10140),
    [anon_sym_EQ] = ACTIONS(10138),
    [anon_sym_begin] = ACTIONS(10138),
    [anon_sym_module] = ACTIONS(10138),
    [anon_sym_baremodule] = ACTIONS(10138),
    [anon_sym_end] = ACTIONS(10138),
    [anon_sym_abstract] = ACTIONS(10138),
    [anon_sym_primitive] = ACTIONS(10138),
    [anon_sym_mutable] = ACTIONS(10138),
    [anon_sym_struct] = ACTIONS(10138),
    [anon_sym_function] = ACTIONS(10138),
    [anon_sym_macro] = ACTIONS(10138),
    [anon_sym_quote] = ACTIONS(10138),
    [anon_sym_let] = ACTIONS(10138),
    [anon_sym_if] = ACTIONS(10138),
    [anon_sym_try] = ACTIONS(10138),
    [anon_sym_for] = ACTIONS(10138),
    [anon_sym_while] = ACTIONS(10138),
    [sym_break_statement] = ACTIONS(10138),
    [sym_continue_statement] = ACTIONS(10138),
    [anon_sym_return] = ACTIONS(10138),
    [anon_sym_const] = ACTIONS(10138),
    [anon_sym_global] = ACTIONS(10138),
    [anon_sym_local] = ACTIONS(10138),
    [anon_sym_LPAREN] = ACTIONS(10140),
    [anon_sym_COLON] = ACTIONS(10138),
    [anon_sym_export] = ACTIONS(10138),
    [anon_sym_public] = ACTIONS(10138),
    [anon_sym_import] = ACTIONS(10138),
    [anon_sym_using] = ACTIONS(10138),
    [anon_sym_LBRACK] = ACTIONS(10140),
    [anon_sym_in] = ACTIONS(10138),
    [anon_sym_LBRACE] = ACTIONS(10140),
    [anon_sym_SQUOTE] = ACTIONS(10138),
    [anon_sym_DOT] = ACTIONS(10138),
    [anon_sym_DOLLAR] = ACTIONS(10140),
    [anon_sym_COLON2] = ACTIONS(10138),
    [anon_sym_COLON_COLON] = ACTIONS(10140),
    [anon_sym_isa] = ACTIONS(10138),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10140),
    [anon_sym_QMARK] = ACTIONS(10140),
    [anon_sym_where] = ACTIONS(10138),
    [anon_sym_AT] = ACTIONS(10140),
    [anon_sym_true] = ACTIONS(10138),
    [anon_sym_false] = ACTIONS(10138),
    [aux_sym_integer_literal_token1] = ACTIONS(10140),
    [aux_sym_integer_literal_token2] = ACTIONS(10140),
    [aux_sym_integer_literal_token3] = ACTIONS(10138),
    [aux_sym_integer_literal_token4] = ACTIONS(10138),
    [aux_sym_float_literal_token1] = ACTIONS(10140),
    [aux_sym_float_literal_token3] = ACTIONS(10140),
    [aux_sym_float_literal_token4] = ACTIONS(10140),
    [sym_character_literal] = ACTIONS(10140),
    [anon_sym_DQUOTE] = ACTIONS(10138),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10140),
    [anon_sym_BQUOTE] = ACTIONS(10138),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10140),
    [sym__pair_operator] = ACTIONS(10140),
    [sym__arrow_operator] = ACTIONS(10138),
    [sym__lazy_or_operator] = ACTIONS(10140),
    [sym__lazy_and_operator] = ACTIONS(10140),
    [sym__comparison_operator] = ACTIONS(10138),
    [sym__pipe_right_operator] = ACTIONS(10140),
    [sym__pipe_left_operator] = ACTIONS(10140),
    [sym__ellipsis_operator] = ACTIONS(10138),
    [sym__plus_operator] = ACTIONS(10138),
    [sym__times_operator] = ACTIONS(10138),
    [sym__rational_operator] = ACTIONS(10140),
    [sym__bitshift_operator] = ACTIONS(10140),
    [sym__power_operator] = ACTIONS(10140),
    [sym__tilde_operator] = ACTIONS(10140),
    [sym__type_order_operator] = ACTIONS(10140),
    [sym__unary_operator] = ACTIONS(10138),
    [sym__unary_plus_operator] = ACTIONS(10138),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10140),
    [sym__immediate_bracket] = ACTIONS(10140),
    [sym__immediate_brace] = ACTIONS(10140),
  },
  [7058] = {
    [sym_block_comment] = STATE(7058),
    [sym_line_comment] = STATE(7058),
    [sym__word_identifier] = ACTIONS(10142),
    [anon_sym_COMMA] = ACTIONS(10144),
    [anon_sym_EQ] = ACTIONS(10142),
    [anon_sym_begin] = ACTIONS(10142),
    [anon_sym_module] = ACTIONS(10142),
    [anon_sym_baremodule] = ACTIONS(10142),
    [anon_sym_end] = ACTIONS(10142),
    [anon_sym_abstract] = ACTIONS(10142),
    [anon_sym_primitive] = ACTIONS(10142),
    [anon_sym_mutable] = ACTIONS(10142),
    [anon_sym_struct] = ACTIONS(10142),
    [anon_sym_function] = ACTIONS(10142),
    [anon_sym_macro] = ACTIONS(10142),
    [anon_sym_quote] = ACTIONS(10142),
    [anon_sym_let] = ACTIONS(10142),
    [anon_sym_if] = ACTIONS(10142),
    [anon_sym_try] = ACTIONS(10142),
    [anon_sym_for] = ACTIONS(10142),
    [anon_sym_while] = ACTIONS(10142),
    [sym_break_statement] = ACTIONS(10142),
    [sym_continue_statement] = ACTIONS(10142),
    [anon_sym_return] = ACTIONS(10142),
    [anon_sym_const] = ACTIONS(10142),
    [anon_sym_global] = ACTIONS(10142),
    [anon_sym_local] = ACTIONS(10142),
    [anon_sym_LPAREN] = ACTIONS(10144),
    [anon_sym_COLON] = ACTIONS(10142),
    [anon_sym_export] = ACTIONS(10142),
    [anon_sym_public] = ACTIONS(10142),
    [anon_sym_import] = ACTIONS(10142),
    [anon_sym_using] = ACTIONS(10142),
    [anon_sym_LBRACK] = ACTIONS(10144),
    [anon_sym_in] = ACTIONS(10142),
    [anon_sym_LBRACE] = ACTIONS(10144),
    [anon_sym_SQUOTE] = ACTIONS(10142),
    [anon_sym_DOT] = ACTIONS(10142),
    [anon_sym_DOLLAR] = ACTIONS(10144),
    [anon_sym_COLON2] = ACTIONS(10142),
    [anon_sym_COLON_COLON] = ACTIONS(10144),
    [anon_sym_isa] = ACTIONS(10142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10144),
    [anon_sym_QMARK] = ACTIONS(10144),
    [anon_sym_where] = ACTIONS(10142),
    [anon_sym_AT] = ACTIONS(10144),
    [anon_sym_true] = ACTIONS(10142),
    [anon_sym_false] = ACTIONS(10142),
    [aux_sym_integer_literal_token1] = ACTIONS(10144),
    [aux_sym_integer_literal_token2] = ACTIONS(10144),
    [aux_sym_integer_literal_token3] = ACTIONS(10142),
    [aux_sym_integer_literal_token4] = ACTIONS(10142),
    [aux_sym_float_literal_token1] = ACTIONS(10144),
    [aux_sym_float_literal_token3] = ACTIONS(10144),
    [aux_sym_float_literal_token4] = ACTIONS(10144),
    [sym_character_literal] = ACTIONS(10144),
    [anon_sym_DQUOTE] = ACTIONS(10142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10144),
    [anon_sym_BQUOTE] = ACTIONS(10142),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10144),
    [sym__pair_operator] = ACTIONS(10144),
    [sym__arrow_operator] = ACTIONS(10142),
    [sym__lazy_or_operator] = ACTIONS(10144),
    [sym__lazy_and_operator] = ACTIONS(10144),
    [sym__comparison_operator] = ACTIONS(10142),
    [sym__pipe_right_operator] = ACTIONS(10144),
    [sym__pipe_left_operator] = ACTIONS(10144),
    [sym__ellipsis_operator] = ACTIONS(10142),
    [sym__plus_operator] = ACTIONS(10142),
    [sym__times_operator] = ACTIONS(10142),
    [sym__rational_operator] = ACTIONS(10144),
    [sym__bitshift_operator] = ACTIONS(10144),
    [sym__power_operator] = ACTIONS(10144),
    [sym__tilde_operator] = ACTIONS(10144),
    [sym__type_order_operator] = ACTIONS(10144),
    [sym__unary_operator] = ACTIONS(10142),
    [sym__unary_plus_operator] = ACTIONS(10142),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10144),
    [sym__immediate_bracket] = ACTIONS(10144),
    [sym__immediate_brace] = ACTIONS(10144),
  },
  [7059] = {
    [sym_block_comment] = STATE(7059),
    [sym_line_comment] = STATE(7059),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7060] = {
    [sym_block_comment] = STATE(7060),
    [sym_line_comment] = STATE(7060),
    [ts_builtin_sym_end] = ACTIONS(10154),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_RBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7061] = {
    [sym_block_comment] = STATE(7061),
    [sym_line_comment] = STATE(7061),
    [aux_sym_export_statement_repeat1] = STATE(7061),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10925),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_elseif] = ACTIONS(10850),
    [anon_sym_else] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7062] = {
    [sym_block_comment] = STATE(7062),
    [sym_line_comment] = STATE(7062),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7063] = {
    [sym_block_comment] = STATE(7063),
    [sym_line_comment] = STATE(7063),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_SQUOTE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9928),
    [sym__immediate_bracket] = ACTIONS(9928),
    [sym__immediate_brace] = ACTIONS(9928),
  },
  [7064] = {
    [sym_block_comment] = STATE(7064),
    [sym_line_comment] = STATE(7064),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7065] = {
    [sym_block_comment] = STATE(7065),
    [sym_line_comment] = STATE(7065),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_elseif] = ACTIONS(10861),
    [anon_sym_else] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(10767),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7066] = {
    [sym_block_comment] = STATE(7066),
    [sym_line_comment] = STATE(7066),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7067] = {
    [sym_block_comment] = STATE(7067),
    [sym_line_comment] = STATE(7067),
    [aux_sym_export_statement_repeat1] = STATE(6831),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(10915),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_else] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_finally] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10876),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10876),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(10876),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10876),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10876),
    [anon_sym_QMARK] = ACTIONS(10876),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10876),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10876),
    [aux_sym_integer_literal_token2] = ACTIONS(10876),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10876),
    [aux_sym_float_literal_token3] = ACTIONS(10876),
    [aux_sym_float_literal_token4] = ACTIONS(10876),
    [sym_character_literal] = ACTIONS(10876),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10876),
    [sym__pair_operator] = ACTIONS(10876),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10876),
    [sym__lazy_and_operator] = ACTIONS(10876),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10876),
    [sym__pipe_left_operator] = ACTIONS(10876),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10876),
    [sym__bitshift_operator] = ACTIONS(10876),
    [sym__power_operator] = ACTIONS(10876),
    [sym__tilde_operator] = ACTIONS(10876),
    [sym__type_order_operator] = ACTIONS(10876),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym__terminator_token1] = ACTIONS(10878),
    [aux_sym__terminator_token2] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7068] = {
    [sym_block_comment] = STATE(7068),
    [sym_line_comment] = STATE(7068),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7069] = {
    [sym_block_comment] = STATE(7069),
    [sym_line_comment] = STATE(7069),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7070] = {
    [sym_block_comment] = STATE(7070),
    [sym_line_comment] = STATE(7070),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7071] = {
    [sym_block_comment] = STATE(7071),
    [sym_line_comment] = STATE(7071),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_elseif] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7072] = {
    [sym_block_comment] = STATE(7072),
    [sym_line_comment] = STATE(7072),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_elseif] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7073] = {
    [sym_block_comment] = STATE(7073),
    [sym_line_comment] = STATE(7073),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_elseif] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7074] = {
    [sym_block_comment] = STATE(7074),
    [sym_line_comment] = STATE(7074),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_elseif] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7075] = {
    [sym_block_comment] = STATE(7075),
    [sym_line_comment] = STATE(7075),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10980),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_elseif] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7076] = {
    [sym_block_comment] = STATE(7076),
    [sym_line_comment] = STATE(7076),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7077] = {
    [sym_block_comment] = STATE(7077),
    [sym_line_comment] = STATE(7077),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7078] = {
    [sym_block_comment] = STATE(7078),
    [sym_line_comment] = STATE(7078),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7079] = {
    [sym_block_comment] = STATE(7079),
    [sym_line_comment] = STATE(7079),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7080] = {
    [sym_block_comment] = STATE(7080),
    [sym_line_comment] = STATE(7080),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_elseif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7081] = {
    [sym_block_comment] = STATE(7081),
    [sym_line_comment] = STATE(7081),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_RPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_RBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_SEMI] = ACTIONS(10136),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_RBRACE] = ACTIONS(10136),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7082] = {
    [sym_block_comment] = STATE(7082),
    [sym_line_comment] = STATE(7082),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_elseif] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7083] = {
    [sym_block_comment] = STATE(7083),
    [sym_line_comment] = STATE(7083),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7084] = {
    [sym_block_comment] = STATE(7084),
    [sym_line_comment] = STATE(7084),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7085] = {
    [sym_block_comment] = STATE(7085),
    [sym_line_comment] = STATE(7085),
    [aux_sym_export_statement_repeat1] = STATE(6831),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(10915),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_end] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_else] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_finally] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10880),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10880),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10880),
    [anon_sym_DOLLAR] = ACTIONS(10880),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10880),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10880),
    [anon_sym_QMARK] = ACTIONS(10880),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10880),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10880),
    [aux_sym_integer_literal_token2] = ACTIONS(10880),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10880),
    [aux_sym_float_literal_token3] = ACTIONS(10880),
    [aux_sym_float_literal_token4] = ACTIONS(10880),
    [sym_character_literal] = ACTIONS(10880),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10880),
    [sym__pair_operator] = ACTIONS(10880),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10880),
    [sym__lazy_and_operator] = ACTIONS(10880),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10880),
    [sym__pipe_left_operator] = ACTIONS(10880),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10880),
    [sym__bitshift_operator] = ACTIONS(10880),
    [sym__power_operator] = ACTIONS(10880),
    [sym__tilde_operator] = ACTIONS(10880),
    [sym__type_order_operator] = ACTIONS(10880),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym__terminator_token1] = ACTIONS(10882),
    [aux_sym__terminator_token2] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7086] = {
    [sym_block_comment] = STATE(7086),
    [sym_line_comment] = STATE(7086),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_else] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7087] = {
    [sym_block_comment] = STATE(7087),
    [sym_line_comment] = STATE(7087),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7088] = {
    [sym_block_comment] = STATE(7088),
    [sym_line_comment] = STATE(7088),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7089] = {
    [sym_block_comment] = STATE(7089),
    [sym_line_comment] = STATE(7089),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7090] = {
    [sym_block_comment] = STATE(7090),
    [sym_line_comment] = STATE(7090),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7091] = {
    [sym_block_comment] = STATE(7091),
    [sym_line_comment] = STATE(7091),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7092] = {
    [sym_block_comment] = STATE(7092),
    [sym_line_comment] = STATE(7092),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7093] = {
    [sym_block_comment] = STATE(7093),
    [sym_line_comment] = STATE(7093),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7094] = {
    [sym_block_comment] = STATE(7094),
    [sym_line_comment] = STATE(7094),
    [ts_builtin_sym_end] = ACTIONS(10136),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_RBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7095] = {
    [sym_block_comment] = STATE(7095),
    [sym_line_comment] = STATE(7095),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_RPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_RBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_SEMI] = ACTIONS(9984),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_RBRACE] = ACTIONS(9984),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7096] = {
    [sym_block_comment] = STATE(7096),
    [sym_line_comment] = STATE(7096),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7097] = {
    [sym_block_comment] = STATE(7097),
    [sym_line_comment] = STATE(7097),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_RPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_RBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_SEMI] = ACTIONS(9988),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_RBRACE] = ACTIONS(9988),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7098] = {
    [sym_block_comment] = STATE(7098),
    [sym_line_comment] = STATE(7098),
    [aux_sym__import_list_repeat1] = STATE(6855),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(10749),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_end] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_else] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_finally] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10884),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10884),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(10884),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10884),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10884),
    [anon_sym_QMARK] = ACTIONS(10884),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10884),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10884),
    [aux_sym_integer_literal_token2] = ACTIONS(10884),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10884),
    [aux_sym_float_literal_token3] = ACTIONS(10884),
    [aux_sym_float_literal_token4] = ACTIONS(10884),
    [sym_character_literal] = ACTIONS(10884),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10884),
    [sym__pair_operator] = ACTIONS(10884),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10884),
    [sym__lazy_and_operator] = ACTIONS(10884),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10884),
    [sym__pipe_left_operator] = ACTIONS(10884),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10884),
    [sym__bitshift_operator] = ACTIONS(10884),
    [sym__power_operator] = ACTIONS(10884),
    [sym__tilde_operator] = ACTIONS(10884),
    [sym__type_order_operator] = ACTIONS(10884),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym__terminator_token1] = ACTIONS(10886),
    [aux_sym__terminator_token2] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7099] = {
    [sym_block_comment] = STATE(7099),
    [sym_line_comment] = STATE(7099),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_RPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_RBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_SEMI] = ACTIONS(10002),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_RBRACE] = ACTIONS(10002),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7100] = {
    [sym_block_comment] = STATE(7100),
    [sym_line_comment] = STATE(7100),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_RPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_RBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_SEMI] = ACTIONS(10006),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_RBRACE] = ACTIONS(10006),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7101] = {
    [sym_block_comment] = STATE(7101),
    [sym_line_comment] = STATE(7101),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7102] = {
    [sym_block_comment] = STATE(7102),
    [sym_line_comment] = STATE(7102),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_else] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_finally] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7103] = {
    [sym_block_comment] = STATE(7103),
    [sym_line_comment] = STATE(7103),
    [ts_builtin_sym_end] = ACTIONS(9914),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_RBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7104] = {
    [sym_block_comment] = STATE(7104),
    [sym_line_comment] = STATE(7104),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_RPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_RBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_SEMI] = ACTIONS(10012),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_RBRACE] = ACTIONS(10012),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7105] = {
    [sym_block_comment] = STATE(7105),
    [sym_line_comment] = STATE(7105),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9874),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9648),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7106] = {
    [sym_block_comment] = STATE(7106),
    [sym_line_comment] = STATE(7106),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9874),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
  },
  [7107] = {
    [sym_block_comment] = STATE(7107),
    [sym_line_comment] = STATE(7107),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_RPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_RBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_SEMI] = ACTIONS(10016),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_RBRACE] = ACTIONS(10016),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7108] = {
    [sym_block_comment] = STATE(7108),
    [sym_line_comment] = STATE(7108),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7109] = {
    [sym_block_comment] = STATE(7109),
    [sym_line_comment] = STATE(7109),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_RPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_RBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_SEMI] = ACTIONS(10020),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_RBRACE] = ACTIONS(10020),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7110] = {
    [sym_block_comment] = STATE(7110),
    [sym_line_comment] = STATE(7110),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_RPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_RBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_SEMI] = ACTIONS(9918),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7111] = {
    [sym_block_comment] = STATE(7111),
    [sym_line_comment] = STATE(7111),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_RPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_RBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_SEMI] = ACTIONS(9922),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_RBRACE] = ACTIONS(9922),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7112] = {
    [sym_block_comment] = STATE(7112),
    [sym_line_comment] = STATE(7112),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7113] = {
    [sym_block_comment] = STATE(7113),
    [sym_line_comment] = STATE(7113),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7114] = {
    [sym_block_comment] = STATE(7114),
    [sym_line_comment] = STATE(7114),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7115] = {
    [sym_block_comment] = STATE(7115),
    [sym_line_comment] = STATE(7115),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7116] = {
    [sym_block_comment] = STATE(7116),
    [sym_line_comment] = STATE(7116),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7117] = {
    [sym_block_comment] = STATE(7117),
    [sym_line_comment] = STATE(7117),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7118] = {
    [sym_block_comment] = STATE(7118),
    [sym_line_comment] = STATE(7118),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7119] = {
    [sym_block_comment] = STATE(7119),
    [sym_line_comment] = STATE(7119),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7120] = {
    [sym_block_comment] = STATE(7120),
    [sym_line_comment] = STATE(7120),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7121] = {
    [sym_block_comment] = STATE(7121),
    [sym_line_comment] = STATE(7121),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_RPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_RBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_SEMI] = ACTIONS(9992),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_RBRACE] = ACTIONS(9992),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7122] = {
    [sym_block_comment] = STATE(7122),
    [sym_line_comment] = STATE(7122),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_RPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_RBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_SEMI] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_RBRACE] = ACTIONS(9996),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7123] = {
    [sym_block_comment] = STATE(7123),
    [sym_line_comment] = STATE(7123),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7124] = {
    [sym_block_comment] = STATE(7124),
    [sym_line_comment] = STATE(7124),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7125] = {
    [sym_block_comment] = STATE(7125),
    [sym_line_comment] = STATE(7125),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_RPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_RBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_SEMI] = ACTIONS(9754),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_RBRACE] = ACTIONS(9754),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7126] = {
    [sym_block_comment] = STATE(7126),
    [sym_line_comment] = STATE(7126),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7127] = {
    [sym_block_comment] = STATE(7127),
    [sym_line_comment] = STATE(7127),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_RBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9762),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7128] = {
    [sym_block_comment] = STATE(7128),
    [sym_line_comment] = STATE(7128),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_RPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_RBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_SEMI] = ACTIONS(10030),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_RBRACE] = ACTIONS(10030),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7129] = {
    [sym_block_comment] = STATE(7129),
    [sym_line_comment] = STATE(7129),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_RPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_RBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_SEMI] = ACTIONS(10034),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_RBRACE] = ACTIONS(10034),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7130] = {
    [sym_block_comment] = STATE(7130),
    [sym_line_comment] = STATE(7130),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_RPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_RBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_SEMI] = ACTIONS(10038),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_RBRACE] = ACTIONS(10038),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7131] = {
    [sym_block_comment] = STATE(7131),
    [sym_line_comment] = STATE(7131),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_RPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_RBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_SEMI] = ACTIONS(10042),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7132] = {
    [sym_block_comment] = STATE(7132),
    [sym_line_comment] = STATE(7132),
    [aux_sym__import_list_repeat1] = STATE(7132),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(11024),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_elseif] = ACTIONS(10861),
    [anon_sym_else] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7133] = {
    [sym_block_comment] = STATE(7133),
    [sym_line_comment] = STATE(7133),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
  },
  [7134] = {
    [sym_block_comment] = STATE(7134),
    [sym_line_comment] = STATE(7134),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7135] = {
    [sym_block_comment] = STATE(7135),
    [sym_line_comment] = STATE(7135),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7136] = {
    [sym_block_comment] = STATE(7136),
    [sym_line_comment] = STATE(7136),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7137] = {
    [sym_block_comment] = STATE(7137),
    [sym_line_comment] = STATE(7137),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7138] = {
    [sym_block_comment] = STATE(7138),
    [sym_line_comment] = STATE(7138),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_RPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_RBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_SEMI] = ACTIONS(9792),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7139] = {
    [sym_block_comment] = STATE(7139),
    [sym_line_comment] = STATE(7139),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_RPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_RBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_SEMI] = ACTIONS(10046),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_RBRACE] = ACTIONS(10046),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7140] = {
    [sym_block_comment] = STATE(7140),
    [sym_line_comment] = STATE(7140),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_RPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_RBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_SEMI] = ACTIONS(10050),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_RBRACE] = ACTIONS(10050),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7141] = {
    [sym_block_comment] = STATE(7141),
    [sym_line_comment] = STATE(7141),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_RBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_SEMI] = ACTIONS(10054),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_RBRACE] = ACTIONS(10054),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7142] = {
    [sym_block_comment] = STATE(7142),
    [sym_line_comment] = STATE(7142),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_RPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_RBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_SEMI] = ACTIONS(10058),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_RBRACE] = ACTIONS(10058),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7143] = {
    [sym_block_comment] = STATE(7143),
    [sym_line_comment] = STATE(7143),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_RPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_RBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_SEMI] = ACTIONS(9900),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_RBRACE] = ACTIONS(9900),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7144] = {
    [sym_block_comment] = STATE(7144),
    [sym_line_comment] = STATE(7144),
    [ts_builtin_sym_end] = ACTIONS(10731),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10727),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10727),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10727),
    [anon_sym_RBRACK] = ACTIONS(10727),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10727),
    [anon_sym_DOT] = ACTIONS(10923),
    [anon_sym_DOLLAR] = ACTIONS(10727),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_QMARK] = ACTIONS(10727),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10727),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10727),
    [aux_sym_integer_literal_token2] = ACTIONS(10727),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10727),
    [aux_sym_float_literal_token3] = ACTIONS(10727),
    [aux_sym_float_literal_token4] = ACTIONS(10727),
    [sym_character_literal] = ACTIONS(10727),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10727),
    [sym__pair_operator] = ACTIONS(10727),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10727),
    [sym__lazy_and_operator] = ACTIONS(10727),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10727),
    [sym__pipe_left_operator] = ACTIONS(10727),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10727),
    [sym__bitshift_operator] = ACTIONS(10727),
    [sym__power_operator] = ACTIONS(10727),
    [sym__tilde_operator] = ACTIONS(10727),
    [sym__type_order_operator] = ACTIONS(10727),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym__terminator_token1] = ACTIONS(10731),
    [aux_sym__terminator_token2] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7145] = {
    [sym_block_comment] = STATE(7145),
    [sym_line_comment] = STATE(7145),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7146] = {
    [sym_block_comment] = STATE(7146),
    [sym_line_comment] = STATE(7146),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_RPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_RBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_SEMI] = ACTIONS(10062),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_RBRACE] = ACTIONS(10062),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7147] = {
    [sym_block_comment] = STATE(7147),
    [sym_line_comment] = STATE(7147),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7148] = {
    [sym_block_comment] = STATE(7148),
    [sym_line_comment] = STATE(7148),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_RPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_RBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_SEMI] = ACTIONS(10066),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_RBRACE] = ACTIONS(10066),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7149] = {
    [sym_block_comment] = STATE(7149),
    [sym_line_comment] = STATE(7149),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7150] = {
    [sym_block_comment] = STATE(7150),
    [sym_line_comment] = STATE(7150),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7151] = {
    [sym_block_comment] = STATE(7151),
    [sym_line_comment] = STATE(7151),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7152] = {
    [sym_block_comment] = STATE(7152),
    [sym_line_comment] = STATE(7152),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_RPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_RBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_SEMI] = ACTIONS(10070),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7153] = {
    [sym_block_comment] = STATE(7153),
    [sym_line_comment] = STATE(7153),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_RPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_RBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_SEMI] = ACTIONS(10074),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_RBRACE] = ACTIONS(10074),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7154] = {
    [sym_block_comment] = STATE(7154),
    [sym_line_comment] = STATE(7154),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7155] = {
    [sym_block_comment] = STATE(7155),
    [sym_line_comment] = STATE(7155),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_RPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_RBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_SEMI] = ACTIONS(10078),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_RBRACE] = ACTIONS(10078),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7156] = {
    [sym_block_comment] = STATE(7156),
    [sym_line_comment] = STATE(7156),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_RPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_RBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_SEMI] = ACTIONS(10082),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_RBRACE] = ACTIONS(10082),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7157] = {
    [sym_block_comment] = STATE(7157),
    [sym_line_comment] = STATE(7157),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7158] = {
    [sym_block_comment] = STATE(7158),
    [sym_line_comment] = STATE(7158),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7159] = {
    [sym_block_comment] = STATE(7159),
    [sym_line_comment] = STATE(7159),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10787),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7160] = {
    [sym_block_comment] = STATE(7160),
    [sym_line_comment] = STATE(7160),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(11027),
    [sym__immediate_command_start] = ACTIONS(11029),
  },
  [7161] = {
    [sym_block_comment] = STATE(7161),
    [sym_line_comment] = STATE(7161),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7162] = {
    [sym_block_comment] = STATE(7162),
    [sym_line_comment] = STATE(7162),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7163] = {
    [sym_block_comment] = STATE(7163),
    [sym_line_comment] = STATE(7163),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7164] = {
    [sym_block_comment] = STATE(7164),
    [sym_line_comment] = STATE(7164),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7165] = {
    [sym_block_comment] = STATE(7165),
    [sym_line_comment] = STATE(7165),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7166] = {
    [sym_block_comment] = STATE(7166),
    [sym_line_comment] = STATE(7166),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7167] = {
    [sym_block_comment] = STATE(7167),
    [sym_line_comment] = STATE(7167),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_RPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_RBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_SEMI] = ACTIONS(9928),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_RBRACE] = ACTIONS(9928),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7168] = {
    [sym_block_comment] = STATE(7168),
    [sym_line_comment] = STATE(7168),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_else] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7169] = {
    [sym_block_comment] = STATE(7169),
    [sym_line_comment] = STATE(7169),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7170] = {
    [sym_block_comment] = STATE(7170),
    [sym_line_comment] = STATE(7170),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7171] = {
    [sym_block_comment] = STATE(7171),
    [sym_line_comment] = STATE(7171),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_SQUOTE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10118),
    [sym__immediate_bracket] = ACTIONS(10118),
    [sym__immediate_brace] = ACTIONS(10118),
  },
  [7172] = {
    [sym_block_comment] = STATE(7172),
    [sym_line_comment] = STATE(7172),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_else] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7173] = {
    [sym_block_comment] = STATE(7173),
    [sym_line_comment] = STATE(7173),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_else] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7174] = {
    [sym_block_comment] = STATE(7174),
    [sym_line_comment] = STATE(7174),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_SQUOTE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10154),
    [sym__immediate_bracket] = ACTIONS(10154),
    [sym__immediate_brace] = ACTIONS(10154),
  },
  [7175] = {
    [sym_block_comment] = STATE(7175),
    [sym_line_comment] = STATE(7175),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_RPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_RBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_SEMI] = ACTIONS(10118),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_RBRACE] = ACTIONS(10118),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7176] = {
    [sym_block_comment] = STATE(7176),
    [sym_line_comment] = STATE(7176),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9860),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9770),
  },
  [7177] = {
    [sym_block_comment] = STATE(7177),
    [sym_line_comment] = STATE(7177),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7178] = {
    [sym_block_comment] = STATE(7178),
    [sym_line_comment] = STATE(7178),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_elseif] = ACTIONS(9958),
    [anon_sym_else] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7179] = {
    [sym_block_comment] = STATE(7179),
    [sym_line_comment] = STATE(7179),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7180] = {
    [sym_block_comment] = STATE(7180),
    [sym_line_comment] = STATE(7180),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_RPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_RBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_SEMI] = ACTIONS(10154),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_RBRACE] = ACTIONS(10154),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7181] = {
    [sym_block_comment] = STATE(7181),
    [sym_line_comment] = STATE(7181),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_elseif] = ACTIONS(9662),
    [anon_sym_else] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7182] = {
    [sym_block_comment] = STATE(7182),
    [sym_line_comment] = STATE(7182),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_elseif] = ACTIONS(9926),
    [anon_sym_else] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7183] = {
    [sym_block_comment] = STATE(7183),
    [sym_line_comment] = STATE(7183),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_catch] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7184] = {
    [sym_block_comment] = STATE(7184),
    [sym_line_comment] = STATE(7184),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_elseif] = ACTIONS(10116),
    [anon_sym_else] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7185] = {
    [sym_block_comment] = STATE(7185),
    [sym_line_comment] = STATE(7185),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7186] = {
    [sym_block_comment] = STATE(7186),
    [sym_line_comment] = STATE(7186),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_SQUOTE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9716),
    [sym__immediate_bracket] = ACTIONS(9716),
    [sym__immediate_brace] = ACTIONS(9716),
  },
  [7187] = {
    [sym_block_comment] = STATE(7187),
    [sym_line_comment] = STATE(7187),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7188] = {
    [sym_block_comment] = STATE(7188),
    [sym_line_comment] = STATE(7188),
    [aux_sym__import_list_repeat1] = STATE(7743),
    [ts_builtin_sym_end] = ACTIONS(10755),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10917),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(10919),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_RBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7189] = {
    [sym_block_comment] = STATE(7189),
    [sym_line_comment] = STATE(7189),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7190] = {
    [sym_block_comment] = STATE(7190),
    [sym_line_comment] = STATE(7190),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(11027),
    [sym__immediate_command_start] = ACTIONS(11029),
  },
  [7191] = {
    [sym_block_comment] = STATE(7191),
    [sym_line_comment] = STATE(7191),
    [ts_builtin_sym_end] = ACTIONS(10639),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_RBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(10923),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7192] = {
    [sym_identifier] = STATE(7406),
    [sym_block_comment] = STATE(7192),
    [sym_line_comment] = STATE(7192),
    [ts_builtin_sym_end] = ACTIONS(9782),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_RBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7193] = {
    [sym_block_comment] = STATE(7193),
    [sym_line_comment] = STATE(7193),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_elseif] = ACTIONS(10152),
    [anon_sym_else] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7194] = {
    [sym_identifier] = STATE(7407),
    [sym_block_comment] = STATE(7194),
    [sym_line_comment] = STATE(7194),
    [ts_builtin_sym_end] = ACTIONS(9786),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_RBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7195] = {
    [sym_identifier] = STATE(7414),
    [sym_block_comment] = STATE(7195),
    [sym_line_comment] = STATE(7195),
    [ts_builtin_sym_end] = ACTIONS(9798),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_RBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7196] = {
    [sym_identifier] = STATE(7415),
    [sym_block_comment] = STATE(7196),
    [sym_line_comment] = STATE(7196),
    [ts_builtin_sym_end] = ACTIONS(9802),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_RBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7197] = {
    [sym_block_comment] = STATE(7197),
    [sym_line_comment] = STATE(7197),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7198] = {
    [sym_block_comment] = STATE(7198),
    [sym_line_comment] = STATE(7198),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7199] = {
    [sym__primary_expression] = STATE(10491),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10165),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(7199),
    [sym_line_comment] = STATE(7199),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_COLON] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_SQUOTE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_DOLLAR] = ACTIONS(9888),
    [anon_sym_COLON2] = ACTIONS(9890),
    [anon_sym_COLON_COLON] = ACTIONS(189),
    [anon_sym_COLON_EQ] = ACTIONS(189),
    [anon_sym_DOT_EQ] = ACTIONS(101),
    [anon_sym_isa] = ACTIONS(101),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(189),
    [anon_sym_QMARK] = ACTIONS(189),
    [anon_sym_where] = ACTIONS(101),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(189),
    [aux_sym__assignment_operator_token1] = ACTIONS(189),
    [sym__pair_operator] = ACTIONS(9045),
    [sym__arrow_operator] = ACTIONS(8937),
    [sym__lazy_or_operator] = ACTIONS(189),
    [sym__lazy_and_operator] = ACTIONS(189),
    [sym__comparison_operator] = ACTIONS(8937),
    [sym__pipe_right_operator] = ACTIONS(9045),
    [sym__pipe_left_operator] = ACTIONS(9045),
    [sym__ellipsis_operator] = ACTIONS(8937),
    [sym__plus_operator] = ACTIONS(8937),
    [sym__times_operator] = ACTIONS(8937),
    [sym__rational_operator] = ACTIONS(8937),
    [sym__bitshift_operator] = ACTIONS(8937),
    [sym__power_operator] = ACTIONS(8937),
    [sym__tilde_operator] = ACTIONS(9045),
    [sym__type_order_operator] = ACTIONS(9045),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(8937),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(189),
    [sym__immediate_bracket] = ACTIONS(189),
    [sym__immediate_brace] = ACTIONS(189),
  },
  [7200] = {
    [sym__primary_expression] = STATE(10491),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10165),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(7200),
    [sym_line_comment] = STATE(7200),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(11031),
    [anon_sym_COLON2] = ACTIONS(9890),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9212),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(9343),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9343),
    [sym__pipe_left_operator] = ACTIONS(9343),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9343),
    [sym__bitshift_operator] = ACTIONS(9343),
    [sym__power_operator] = ACTIONS(9343),
    [sym__tilde_operator] = ACTIONS(1823),
    [sym__type_order_operator] = ACTIONS(9343),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7201] = {
    [sym_block_comment] = STATE(7201),
    [sym_line_comment] = STATE(7201),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7202] = {
    [sym_block_comment] = STATE(7202),
    [sym_line_comment] = STATE(7202),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7203] = {
    [sym_block_comment] = STATE(7203),
    [sym_line_comment] = STATE(7203),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_else] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7204] = {
    [sym_block_comment] = STATE(7204),
    [sym_line_comment] = STATE(7204),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_SQUOTE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10038),
    [sym__immediate_bracket] = ACTIONS(10038),
    [sym__immediate_brace] = ACTIONS(10038),
  },
  [7205] = {
    [sym_block_comment] = STATE(7205),
    [sym_line_comment] = STATE(7205),
    [ts_builtin_sym_end] = ACTIONS(10054),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_RBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7206] = {
    [sym_block_comment] = STATE(7206),
    [sym_line_comment] = STATE(7206),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7207] = {
    [sym_block_comment] = STATE(7207),
    [sym_line_comment] = STATE(7207),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11033),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_end] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_else] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_finally] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11033),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11033),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11033),
    [anon_sym_DOLLAR] = ACTIONS(11033),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11033),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11033),
    [anon_sym_QMARK] = ACTIONS(11033),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11033),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11033),
    [aux_sym_integer_literal_token2] = ACTIONS(11033),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11033),
    [aux_sym_float_literal_token3] = ACTIONS(11033),
    [aux_sym_float_literal_token4] = ACTIONS(11033),
    [sym_character_literal] = ACTIONS(11033),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11033),
    [sym__pair_operator] = ACTIONS(11033),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11033),
    [sym__lazy_and_operator] = ACTIONS(11033),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11033),
    [sym__pipe_left_operator] = ACTIONS(11033),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11033),
    [sym__bitshift_operator] = ACTIONS(11033),
    [sym__power_operator] = ACTIONS(11033),
    [sym__tilde_operator] = ACTIONS(11033),
    [sym__type_order_operator] = ACTIONS(11033),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym__terminator_token1] = ACTIONS(11035),
    [aux_sym__terminator_token2] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7208] = {
    [sym_block_comment] = STATE(7208),
    [sym_line_comment] = STATE(7208),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10727),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_end] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10727),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10727),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10727),
    [anon_sym_DOT] = ACTIONS(11037),
    [anon_sym_DOLLAR] = ACTIONS(10727),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10727),
    [anon_sym_QMARK] = ACTIONS(10727),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10727),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10727),
    [aux_sym_integer_literal_token2] = ACTIONS(10727),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10727),
    [aux_sym_float_literal_token3] = ACTIONS(10727),
    [aux_sym_float_literal_token4] = ACTIONS(10727),
    [sym_character_literal] = ACTIONS(10727),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10727),
    [sym__pair_operator] = ACTIONS(10727),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10727),
    [sym__lazy_and_operator] = ACTIONS(10727),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10727),
    [sym__pipe_left_operator] = ACTIONS(10727),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10727),
    [sym__bitshift_operator] = ACTIONS(10727),
    [sym__power_operator] = ACTIONS(10727),
    [sym__tilde_operator] = ACTIONS(10727),
    [sym__type_order_operator] = ACTIONS(10727),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym__terminator_token1] = ACTIONS(10731),
    [aux_sym__terminator_token2] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7209] = {
    [sym_block_comment] = STATE(7209),
    [sym_line_comment] = STATE(7209),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11039),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_end] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_else] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_finally] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11039),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11039),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11039),
    [anon_sym_DOLLAR] = ACTIONS(11039),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11039),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11039),
    [anon_sym_QMARK] = ACTIONS(11039),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11039),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11039),
    [aux_sym_integer_literal_token2] = ACTIONS(11039),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11039),
    [aux_sym_float_literal_token3] = ACTIONS(11039),
    [aux_sym_float_literal_token4] = ACTIONS(11039),
    [sym_character_literal] = ACTIONS(11039),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11039),
    [sym__pair_operator] = ACTIONS(11039),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11039),
    [sym__lazy_and_operator] = ACTIONS(11039),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11039),
    [sym__pipe_left_operator] = ACTIONS(11039),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11039),
    [sym__bitshift_operator] = ACTIONS(11039),
    [sym__power_operator] = ACTIONS(11039),
    [sym__tilde_operator] = ACTIONS(11039),
    [sym__type_order_operator] = ACTIONS(11039),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym__terminator_token1] = ACTIONS(11041),
    [aux_sym__terminator_token2] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7210] = {
    [sym_block_comment] = STATE(7210),
    [sym_line_comment] = STATE(7210),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11043),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_end] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_else] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_finally] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11043),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11043),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11043),
    [anon_sym_DOLLAR] = ACTIONS(11043),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11043),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11043),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11043),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11043),
    [aux_sym_integer_literal_token2] = ACTIONS(11043),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11043),
    [aux_sym_float_literal_token3] = ACTIONS(11043),
    [aux_sym_float_literal_token4] = ACTIONS(11043),
    [sym_character_literal] = ACTIONS(11043),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11043),
    [sym__pair_operator] = ACTIONS(11043),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11043),
    [sym__lazy_and_operator] = ACTIONS(11043),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11043),
    [sym__pipe_left_operator] = ACTIONS(11043),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11043),
    [sym__bitshift_operator] = ACTIONS(11043),
    [sym__power_operator] = ACTIONS(11043),
    [sym__tilde_operator] = ACTIONS(11043),
    [sym__type_order_operator] = ACTIONS(11043),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym__terminator_token1] = ACTIONS(11045),
    [aux_sym__terminator_token2] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7211] = {
    [sym_block_comment] = STATE(7211),
    [sym_line_comment] = STATE(7211),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_catch] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7212] = {
    [sym_block_comment] = STATE(7212),
    [sym_line_comment] = STATE(7212),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7213] = {
    [sym_block_comment] = STATE(7213),
    [sym_line_comment] = STATE(7213),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7214] = {
    [sym__comprehension_clause] = STATE(19408),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7214),
    [sym_line_comment] = STATE(7214),
    [aux_sym_vector_expression_repeat1] = STATE(17339),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11049),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11056),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11092),
    [aux_sym__terminator_token2] = ACTIONS(11095),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7215] = {
    [sym_identifier] = STATE(8409),
    [sym_block_comment] = STATE(7215),
    [sym_line_comment] = STATE(7215),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9780),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9780),
    [anon_sym_QMARK] = ACTIONS(9780),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9780),
    [sym__lazy_and_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7216] = {
    [sym_identifier] = STATE(8410),
    [sym_block_comment] = STATE(7216),
    [sym_line_comment] = STATE(7216),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9784),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9784),
    [anon_sym_QMARK] = ACTIONS(9784),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9784),
    [sym__lazy_and_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7217] = {
    [sym__comprehension_clause] = STATE(19357),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7217),
    [sym_line_comment] = STATE(7217),
    [aux_sym_vector_expression_repeat1] = STATE(17321),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11098),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11100),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11102),
    [aux_sym__terminator_token2] = ACTIONS(11105),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7218] = {
    [sym_identifier] = STATE(8413),
    [sym_block_comment] = STATE(7218),
    [sym_line_comment] = STATE(7218),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9796),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9796),
    [anon_sym_QMARK] = ACTIONS(9796),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9796),
    [sym__lazy_and_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7219] = {
    [sym_block_comment] = STATE(7219),
    [sym_line_comment] = STATE(7219),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11108),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7220] = {
    [sym_identifier] = STATE(8414),
    [sym_block_comment] = STATE(7220),
    [sym_line_comment] = STATE(7220),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9800),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9800),
    [anon_sym_QMARK] = ACTIONS(9800),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9800),
    [sym__lazy_and_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7221] = {
    [sym_block_comment] = STATE(7221),
    [sym_line_comment] = STATE(7221),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9688),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7222] = {
    [sym_block_comment] = STATE(7222),
    [sym_line_comment] = STATE(7222),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_else] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_finally] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7223] = {
    [sym_block_comment] = STATE(7223),
    [sym_line_comment] = STATE(7223),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11116),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_end] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_else] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_finally] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11116),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11116),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11116),
    [anon_sym_DOLLAR] = ACTIONS(11116),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11116),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11116),
    [anon_sym_QMARK] = ACTIONS(11116),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11116),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11116),
    [aux_sym_integer_literal_token2] = ACTIONS(11116),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11116),
    [aux_sym_float_literal_token3] = ACTIONS(11116),
    [aux_sym_float_literal_token4] = ACTIONS(11116),
    [sym_character_literal] = ACTIONS(11116),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11116),
    [sym__pair_operator] = ACTIONS(11116),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11116),
    [sym__lazy_and_operator] = ACTIONS(11116),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11116),
    [sym__pipe_left_operator] = ACTIONS(11116),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11116),
    [sym__bitshift_operator] = ACTIONS(11116),
    [sym__power_operator] = ACTIONS(11116),
    [sym__tilde_operator] = ACTIONS(11116),
    [sym__type_order_operator] = ACTIONS(11116),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym__terminator_token1] = ACTIONS(11118),
    [aux_sym__terminator_token2] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7224] = {
    [sym_block_comment] = STATE(7224),
    [sym_line_comment] = STATE(7224),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11120),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_end] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_else] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_finally] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11120),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11120),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11120),
    [anon_sym_DOLLAR] = ACTIONS(11120),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11120),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11120),
    [anon_sym_QMARK] = ACTIONS(11120),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11120),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11120),
    [aux_sym_integer_literal_token2] = ACTIONS(11120),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11120),
    [aux_sym_float_literal_token3] = ACTIONS(11120),
    [aux_sym_float_literal_token4] = ACTIONS(11120),
    [sym_character_literal] = ACTIONS(11120),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11120),
    [sym__pair_operator] = ACTIONS(11120),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11120),
    [sym__lazy_and_operator] = ACTIONS(11120),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11120),
    [sym__pipe_left_operator] = ACTIONS(11120),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11120),
    [sym__bitshift_operator] = ACTIONS(11120),
    [sym__power_operator] = ACTIONS(11120),
    [sym__tilde_operator] = ACTIONS(11120),
    [sym__type_order_operator] = ACTIONS(11120),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym__terminator_token1] = ACTIONS(11122),
    [aux_sym__terminator_token2] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7225] = {
    [sym_block_comment] = STATE(7225),
    [sym_line_comment] = STATE(7225),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7226] = {
    [sym_block_comment] = STATE(7226),
    [sym_line_comment] = STATE(7226),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7227] = {
    [sym__comprehension_clause] = STATE(19449),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7227),
    [sym_line_comment] = STATE(7227),
    [aux_sym_vector_expression_repeat1] = STATE(17463),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11124),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11126),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11128),
    [aux_sym__terminator_token2] = ACTIONS(11131),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7228] = {
    [sym_block_comment] = STATE(7228),
    [sym_line_comment] = STATE(7228),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9720),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7229] = {
    [sym_block_comment] = STATE(7229),
    [sym_line_comment] = STATE(7229),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_elseif] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7230] = {
    [sym_block_comment] = STATE(7230),
    [sym_line_comment] = STATE(7230),
    [aux_sym_open_tuple_repeat1] = STATE(7230),
    [ts_builtin_sym_end] = ACTIONS(10840),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(11134),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_RBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10835),
    [anon_sym_QMARK] = ACTIONS(10835),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10835),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10835),
    [sym__lazy_and_operator] = ACTIONS(10835),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10835),
    [sym__pipe_left_operator] = ACTIONS(10835),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10835),
    [sym__bitshift_operator] = ACTIONS(10835),
    [sym__power_operator] = ACTIONS(10835),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10835),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7231] = {
    [sym_block_comment] = STATE(7231),
    [sym_line_comment] = STATE(7231),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11116),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_end] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_elseif] = ACTIONS(11116),
    [anon_sym_else] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11116),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11116),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11116),
    [anon_sym_DOLLAR] = ACTIONS(11116),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11116),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11116),
    [anon_sym_QMARK] = ACTIONS(11116),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11116),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11116),
    [aux_sym_integer_literal_token2] = ACTIONS(11116),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11116),
    [aux_sym_float_literal_token3] = ACTIONS(11116),
    [aux_sym_float_literal_token4] = ACTIONS(11116),
    [sym_character_literal] = ACTIONS(11116),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11116),
    [sym__pair_operator] = ACTIONS(11116),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11116),
    [sym__lazy_and_operator] = ACTIONS(11116),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11116),
    [sym__pipe_left_operator] = ACTIONS(11116),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11116),
    [sym__bitshift_operator] = ACTIONS(11116),
    [sym__power_operator] = ACTIONS(11116),
    [sym__tilde_operator] = ACTIONS(11116),
    [sym__type_order_operator] = ACTIONS(11116),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym__terminator_token1] = ACTIONS(11118),
    [aux_sym__terminator_token2] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7232] = {
    [sym_block_comment] = STATE(7232),
    [sym_line_comment] = STATE(7232),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7233] = {
    [sym__comprehension_clause] = STATE(18532),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7233),
    [sym_line_comment] = STATE(7233),
    [aux_sym_vector_expression_repeat1] = STATE(17483),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11137),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11139),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11141),
    [aux_sym__terminator_token2] = ACTIONS(11144),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7234] = {
    [sym_block_comment] = STATE(7234),
    [sym_line_comment] = STATE(7234),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7235] = {
    [sym_block_comment] = STATE(7235),
    [sym_line_comment] = STATE(7235),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7236] = {
    [sym__comprehension_clause] = STATE(18950),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7236),
    [sym_line_comment] = STATE(7236),
    [aux_sym_vector_expression_repeat1] = STATE(17599),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11147),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11149),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11151),
    [aux_sym__terminator_token2] = ACTIONS(11154),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7237] = {
    [sym_block_comment] = STATE(7237),
    [sym_line_comment] = STATE(7237),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9688),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7238] = {
    [sym_block_comment] = STATE(7238),
    [sym_line_comment] = STATE(7238),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7239] = {
    [sym_block_comment] = STATE(7239),
    [sym_line_comment] = STATE(7239),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7240] = {
    [sym_block_comment] = STATE(7240),
    [sym_line_comment] = STATE(7240),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7241] = {
    [sym__comprehension_clause] = STATE(19526),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7241),
    [sym_line_comment] = STATE(7241),
    [aux_sym_vector_expression_repeat1] = STATE(17218),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11159),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11161),
    [aux_sym__terminator_token2] = ACTIONS(11164),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7242] = {
    [sym_block_comment] = STATE(7242),
    [sym_line_comment] = STATE(7242),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(11167),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7243] = {
    [sym_block_comment] = STATE(7243),
    [sym_line_comment] = STATE(7243),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11169),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_end] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_elseif] = ACTIONS(11169),
    [anon_sym_else] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11169),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11169),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11169),
    [anon_sym_DOLLAR] = ACTIONS(11169),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11169),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11169),
    [anon_sym_QMARK] = ACTIONS(11169),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11169),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11169),
    [aux_sym_integer_literal_token2] = ACTIONS(11169),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11169),
    [aux_sym_float_literal_token3] = ACTIONS(11169),
    [aux_sym_float_literal_token4] = ACTIONS(11169),
    [sym_character_literal] = ACTIONS(11169),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11169),
    [sym__pair_operator] = ACTIONS(11169),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11169),
    [sym__lazy_and_operator] = ACTIONS(11169),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11169),
    [sym__pipe_left_operator] = ACTIONS(11169),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11169),
    [sym__bitshift_operator] = ACTIONS(11169),
    [sym__power_operator] = ACTIONS(11169),
    [sym__tilde_operator] = ACTIONS(11169),
    [sym__type_order_operator] = ACTIONS(11169),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym__terminator_token1] = ACTIONS(11171),
    [aux_sym__terminator_token2] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7244] = {
    [sym_block_comment] = STATE(7244),
    [sym_line_comment] = STATE(7244),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11173),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_end] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_else] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_finally] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11173),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11173),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11173),
    [anon_sym_DOLLAR] = ACTIONS(11173),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11173),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11173),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11173),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11173),
    [aux_sym_integer_literal_token2] = ACTIONS(11173),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11173),
    [aux_sym_float_literal_token3] = ACTIONS(11173),
    [aux_sym_float_literal_token4] = ACTIONS(11173),
    [sym_character_literal] = ACTIONS(11173),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11173),
    [sym__pair_operator] = ACTIONS(11173),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11173),
    [sym__lazy_and_operator] = ACTIONS(11173),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11173),
    [sym__pipe_left_operator] = ACTIONS(11173),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11173),
    [sym__bitshift_operator] = ACTIONS(11173),
    [sym__power_operator] = ACTIONS(11173),
    [sym__tilde_operator] = ACTIONS(11173),
    [sym__type_order_operator] = ACTIONS(11173),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym__terminator_token1] = ACTIONS(11175),
    [aux_sym__terminator_token2] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7245] = {
    [sym__comprehension_clause] = STATE(18693),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7245),
    [sym_line_comment] = STATE(7245),
    [aux_sym_vector_expression_repeat1] = STATE(17151),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11177),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11179),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11181),
    [aux_sym__terminator_token2] = ACTIONS(11184),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7246] = {
    [sym_block_comment] = STATE(7246),
    [sym_line_comment] = STATE(7246),
    [ts_builtin_sym_end] = ACTIONS(9728),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_RBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7247] = {
    [sym__comprehension_clause] = STATE(19271),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7247),
    [sym_line_comment] = STATE(7247),
    [aux_sym_vector_expression_repeat1] = STATE(17503),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11187),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11189),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11191),
    [aux_sym__terminator_token2] = ACTIONS(11194),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7248] = {
    [sym_block_comment] = STATE(7248),
    [sym_line_comment] = STATE(7248),
    [ts_builtin_sym_end] = ACTIONS(10910),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_RBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7249] = {
    [sym_block_comment] = STATE(7249),
    [sym_line_comment] = STATE(7249),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7250] = {
    [sym_block_comment] = STATE(7250),
    [sym_line_comment] = STATE(7250),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11197),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_end] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_else] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_finally] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11197),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11197),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11197),
    [anon_sym_DOLLAR] = ACTIONS(11197),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11197),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11197),
    [anon_sym_QMARK] = ACTIONS(11197),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11197),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11197),
    [aux_sym_integer_literal_token2] = ACTIONS(11197),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11197),
    [aux_sym_float_literal_token3] = ACTIONS(11197),
    [aux_sym_float_literal_token4] = ACTIONS(11197),
    [sym_character_literal] = ACTIONS(11197),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11197),
    [sym__pair_operator] = ACTIONS(11197),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11197),
    [sym__lazy_and_operator] = ACTIONS(11197),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11197),
    [sym__pipe_left_operator] = ACTIONS(11197),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11197),
    [sym__bitshift_operator] = ACTIONS(11197),
    [sym__power_operator] = ACTIONS(11197),
    [sym__tilde_operator] = ACTIONS(11197),
    [sym__type_order_operator] = ACTIONS(11197),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym__terminator_token1] = ACTIONS(11199),
    [aux_sym__terminator_token2] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7251] = {
    [sym_block_comment] = STATE(7251),
    [sym_line_comment] = STATE(7251),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11120),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_end] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_elseif] = ACTIONS(11120),
    [anon_sym_else] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11120),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11120),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11120),
    [anon_sym_DOLLAR] = ACTIONS(11120),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11120),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11120),
    [anon_sym_QMARK] = ACTIONS(11120),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11120),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11120),
    [aux_sym_integer_literal_token2] = ACTIONS(11120),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11120),
    [aux_sym_float_literal_token3] = ACTIONS(11120),
    [aux_sym_float_literal_token4] = ACTIONS(11120),
    [sym_character_literal] = ACTIONS(11120),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11120),
    [sym__pair_operator] = ACTIONS(11120),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11120),
    [sym__lazy_and_operator] = ACTIONS(11120),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11120),
    [sym__pipe_left_operator] = ACTIONS(11120),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11120),
    [sym__bitshift_operator] = ACTIONS(11120),
    [sym__power_operator] = ACTIONS(11120),
    [sym__tilde_operator] = ACTIONS(11120),
    [sym__type_order_operator] = ACTIONS(11120),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym__terminator_token1] = ACTIONS(11122),
    [aux_sym__terminator_token2] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7252] = {
    [sym__comprehension_clause] = STATE(19543),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7252),
    [sym_line_comment] = STATE(7252),
    [aux_sym_vector_expression_repeat1] = STATE(17215),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11201),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11203),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11205),
    [aux_sym__terminator_token2] = ACTIONS(11208),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7253] = {
    [sym_block_comment] = STATE(7253),
    [sym_line_comment] = STATE(7253),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11197),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_end] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_elseif] = ACTIONS(11197),
    [anon_sym_else] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11197),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11197),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11197),
    [anon_sym_DOLLAR] = ACTIONS(11197),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11197),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11197),
    [anon_sym_QMARK] = ACTIONS(11197),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11197),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11197),
    [aux_sym_integer_literal_token2] = ACTIONS(11197),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11197),
    [aux_sym_float_literal_token3] = ACTIONS(11197),
    [aux_sym_float_literal_token4] = ACTIONS(11197),
    [sym_character_literal] = ACTIONS(11197),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11197),
    [sym__pair_operator] = ACTIONS(11197),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11197),
    [sym__lazy_and_operator] = ACTIONS(11197),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11197),
    [sym__pipe_left_operator] = ACTIONS(11197),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11197),
    [sym__bitshift_operator] = ACTIONS(11197),
    [sym__power_operator] = ACTIONS(11197),
    [sym__tilde_operator] = ACTIONS(11197),
    [sym__type_order_operator] = ACTIONS(11197),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym__terminator_token1] = ACTIONS(11199),
    [aux_sym__terminator_token2] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7254] = {
    [sym_block_comment] = STATE(7254),
    [sym_line_comment] = STATE(7254),
    [ts_builtin_sym_end] = ACTIONS(9740),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_RBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7255] = {
    [sym_block_comment] = STATE(7255),
    [sym_line_comment] = STATE(7255),
    [ts_builtin_sym_end] = ACTIONS(9746),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_RBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7256] = {
    [sym_block_comment] = STATE(7256),
    [sym_line_comment] = STATE(7256),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_finally] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11211),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOLLAR] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11211),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11211),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11211),
    [aux_sym_integer_literal_token2] = ACTIONS(11211),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11211),
    [aux_sym_float_literal_token3] = ACTIONS(11211),
    [aux_sym_float_literal_token4] = ACTIONS(11211),
    [sym_character_literal] = ACTIONS(11211),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11211),
    [sym__pair_operator] = ACTIONS(11211),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11211),
    [sym__lazy_and_operator] = ACTIONS(11211),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11211),
    [sym__pipe_left_operator] = ACTIONS(11211),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11211),
    [sym__bitshift_operator] = ACTIONS(11211),
    [sym__power_operator] = ACTIONS(11211),
    [sym__tilde_operator] = ACTIONS(11211),
    [sym__type_order_operator] = ACTIONS(11211),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym__terminator_token1] = ACTIONS(11213),
    [aux_sym__terminator_token2] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7257] = {
    [sym_block_comment] = STATE(7257),
    [sym_line_comment] = STATE(7257),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7258] = {
    [sym_block_comment] = STATE(7258),
    [sym_line_comment] = STATE(7258),
    [aux_sym__import_list_repeat1] = STATE(8275),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(11215),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(11217),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7259] = {
    [sym_block_comment] = STATE(7259),
    [sym_line_comment] = STATE(7259),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7260] = {
    [sym_block_comment] = STATE(7260),
    [sym_line_comment] = STATE(7260),
    [ts_builtin_sym_end] = ACTIONS(10154),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_RBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7261] = {
    [sym_block_comment] = STATE(7261),
    [sym_line_comment] = STATE(7261),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_elseif] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7262] = {
    [sym_block_comment] = STATE(7262),
    [sym_line_comment] = STATE(7262),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7263] = {
    [sym_block_comment] = STATE(7263),
    [sym_line_comment] = STATE(7263),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_elseif] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7264] = {
    [sym_block_comment] = STATE(7264),
    [sym_line_comment] = STATE(7264),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11221),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7265] = {
    [sym_block_comment] = STATE(7265),
    [sym_line_comment] = STATE(7265),
    [ts_builtin_sym_end] = ACTIONS(9734),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_RBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10827),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7266] = {
    [sym_block_comment] = STATE(7266),
    [sym_line_comment] = STATE(7266),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11223),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_end] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_elseif] = ACTIONS(11223),
    [anon_sym_else] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11223),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11223),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11223),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11223),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11223),
    [anon_sym_QMARK] = ACTIONS(11223),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11223),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11223),
    [aux_sym_integer_literal_token2] = ACTIONS(11223),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11223),
    [aux_sym_float_literal_token3] = ACTIONS(11223),
    [aux_sym_float_literal_token4] = ACTIONS(11223),
    [sym_character_literal] = ACTIONS(11223),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11223),
    [sym__pair_operator] = ACTIONS(11223),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11223),
    [sym__lazy_and_operator] = ACTIONS(11223),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11223),
    [sym__pipe_left_operator] = ACTIONS(11223),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11223),
    [sym__bitshift_operator] = ACTIONS(11223),
    [sym__power_operator] = ACTIONS(11223),
    [sym__tilde_operator] = ACTIONS(11223),
    [sym__type_order_operator] = ACTIONS(11223),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym__terminator_token1] = ACTIONS(11225),
    [aux_sym__terminator_token2] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7267] = {
    [sym_block_comment] = STATE(7267),
    [sym_line_comment] = STATE(7267),
    [ts_builtin_sym_end] = ACTIONS(10136),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_RBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7268] = {
    [sym_block_comment] = STATE(7268),
    [sym_line_comment] = STATE(7268),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7269] = {
    [sym_block_comment] = STATE(7269),
    [sym_line_comment] = STATE(7269),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10857),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7270] = {
    [sym_block_comment] = STATE(7270),
    [sym_line_comment] = STATE(7270),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7271] = {
    [sym_block_comment] = STATE(7271),
    [sym_line_comment] = STATE(7271),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7272] = {
    [sym_block_comment] = STATE(7272),
    [sym_line_comment] = STATE(7272),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_elseif] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7273] = {
    [sym_block_comment] = STATE(7273),
    [sym_line_comment] = STATE(7273),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_elseif] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7274] = {
    [sym_block_comment] = STATE(7274),
    [sym_line_comment] = STATE(7274),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7275] = {
    [sym_block_comment] = STATE(7275),
    [sym_line_comment] = STATE(7275),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7276] = {
    [sym_block_comment] = STATE(7276),
    [sym_line_comment] = STATE(7276),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7277] = {
    [sym_block_comment] = STATE(7277),
    [sym_line_comment] = STATE(7277),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_elseif] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7278] = {
    [sym__comprehension_clause] = STATE(18832),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7278),
    [sym_line_comment] = STATE(7278),
    [aux_sym_vector_expression_repeat1] = STATE(17454),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11227),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11229),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11231),
    [aux_sym__terminator_token2] = ACTIONS(11234),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7279] = {
    [sym__comprehension_clause] = STATE(18865),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7279),
    [sym_line_comment] = STATE(7279),
    [aux_sym_vector_expression_repeat1] = STATE(17457),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11237),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11239),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11241),
    [aux_sym__terminator_token2] = ACTIONS(11244),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7280] = {
    [sym_block_comment] = STATE(7280),
    [sym_line_comment] = STATE(7280),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7281] = {
    [sym_block_comment] = STATE(7281),
    [sym_line_comment] = STATE(7281),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7282] = {
    [sym_block_comment] = STATE(7282),
    [sym_line_comment] = STATE(7282),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7283] = {
    [sym_block_comment] = STATE(7283),
    [sym_line_comment] = STATE(7283),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7284] = {
    [sym_block_comment] = STATE(7284),
    [sym_line_comment] = STATE(7284),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7285] = {
    [sym_block_comment] = STATE(7285),
    [sym_line_comment] = STATE(7285),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7286] = {
    [sym_block_comment] = STATE(7286),
    [sym_line_comment] = STATE(7286),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_elseif] = ACTIONS(11211),
    [anon_sym_else] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11211),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOLLAR] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11211),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11211),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11211),
    [aux_sym_integer_literal_token2] = ACTIONS(11211),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11211),
    [aux_sym_float_literal_token3] = ACTIONS(11211),
    [aux_sym_float_literal_token4] = ACTIONS(11211),
    [sym_character_literal] = ACTIONS(11211),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11211),
    [sym__pair_operator] = ACTIONS(11211),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11211),
    [sym__lazy_and_operator] = ACTIONS(11211),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11211),
    [sym__pipe_left_operator] = ACTIONS(11211),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11211),
    [sym__bitshift_operator] = ACTIONS(11211),
    [sym__power_operator] = ACTIONS(11211),
    [sym__tilde_operator] = ACTIONS(11211),
    [sym__type_order_operator] = ACTIONS(11211),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym__terminator_token1] = ACTIONS(11213),
    [aux_sym__terminator_token2] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7287] = {
    [sym_block_comment] = STATE(7287),
    [sym_line_comment] = STATE(7287),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7288] = {
    [sym_block_comment] = STATE(7288),
    [sym_line_comment] = STATE(7288),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7289] = {
    [sym_block_comment] = STATE(7289),
    [sym_line_comment] = STATE(7289),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_elseif] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11247),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11247),
    [anon_sym_QMARK] = ACTIONS(11247),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11247),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11247),
    [sym__lazy_and_operator] = ACTIONS(11247),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11247),
    [sym__pipe_left_operator] = ACTIONS(11247),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11247),
    [sym__bitshift_operator] = ACTIONS(11247),
    [sym__power_operator] = ACTIONS(11247),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11247),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7290] = {
    [sym_block_comment] = STATE(7290),
    [sym_line_comment] = STATE(7290),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_elseif] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7291] = {
    [sym_block_comment] = STATE(7291),
    [sym_line_comment] = STATE(7291),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11251),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_end] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_else] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_finally] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11251),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11251),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11251),
    [anon_sym_DOLLAR] = ACTIONS(11251),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11251),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11251),
    [anon_sym_QMARK] = ACTIONS(11251),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11251),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11251),
    [aux_sym_integer_literal_token2] = ACTIONS(11251),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11251),
    [aux_sym_float_literal_token3] = ACTIONS(11251),
    [aux_sym_float_literal_token4] = ACTIONS(11251),
    [sym_character_literal] = ACTIONS(11251),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11251),
    [sym__pair_operator] = ACTIONS(11251),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11251),
    [sym__lazy_and_operator] = ACTIONS(11251),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11251),
    [sym__pipe_left_operator] = ACTIONS(11251),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11251),
    [sym__bitshift_operator] = ACTIONS(11251),
    [sym__power_operator] = ACTIONS(11251),
    [sym__tilde_operator] = ACTIONS(11251),
    [sym__type_order_operator] = ACTIONS(11251),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym__terminator_token1] = ACTIONS(11253),
    [aux_sym__terminator_token2] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7292] = {
    [sym_block_comment] = STATE(7292),
    [sym_line_comment] = STATE(7292),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7293] = {
    [sym_block_comment] = STATE(7293),
    [sym_line_comment] = STATE(7293),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7294] = {
    [sym_block_comment] = STATE(7294),
    [sym_line_comment] = STATE(7294),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10850),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_else] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_finally] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7295] = {
    [sym_block_comment] = STATE(7295),
    [sym_line_comment] = STATE(7295),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11255),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_end] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_else] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_finally] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11255),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11255),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11255),
    [anon_sym_DOLLAR] = ACTIONS(11255),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11255),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11255),
    [anon_sym_QMARK] = ACTIONS(11255),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11255),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11255),
    [aux_sym_integer_literal_token2] = ACTIONS(11255),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11255),
    [aux_sym_float_literal_token3] = ACTIONS(11255),
    [aux_sym_float_literal_token4] = ACTIONS(11255),
    [sym_character_literal] = ACTIONS(11255),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11255),
    [sym__pair_operator] = ACTIONS(11255),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11255),
    [sym__lazy_and_operator] = ACTIONS(11255),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11255),
    [sym__pipe_left_operator] = ACTIONS(11255),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11255),
    [sym__bitshift_operator] = ACTIONS(11255),
    [sym__power_operator] = ACTIONS(11255),
    [sym__tilde_operator] = ACTIONS(11255),
    [sym__type_order_operator] = ACTIONS(11255),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym__terminator_token1] = ACTIONS(11257),
    [aux_sym__terminator_token2] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7296] = {
    [sym_block_comment] = STATE(7296),
    [sym_line_comment] = STATE(7296),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7297] = {
    [sym_block_comment] = STATE(7297),
    [sym_line_comment] = STATE(7297),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11259),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_end] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_else] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_finally] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11259),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11259),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11259),
    [anon_sym_DOLLAR] = ACTIONS(11259),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11259),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11259),
    [anon_sym_QMARK] = ACTIONS(11259),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11259),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11259),
    [aux_sym_integer_literal_token2] = ACTIONS(11259),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11259),
    [aux_sym_float_literal_token3] = ACTIONS(11259),
    [aux_sym_float_literal_token4] = ACTIONS(11259),
    [sym_character_literal] = ACTIONS(11259),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11259),
    [sym__pair_operator] = ACTIONS(11259),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11259),
    [sym__lazy_and_operator] = ACTIONS(11259),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11259),
    [sym__pipe_left_operator] = ACTIONS(11259),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11259),
    [sym__bitshift_operator] = ACTIONS(11259),
    [sym__power_operator] = ACTIONS(11259),
    [sym__tilde_operator] = ACTIONS(11259),
    [sym__type_order_operator] = ACTIONS(11259),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym__terminator_token1] = ACTIONS(11261),
    [aux_sym__terminator_token2] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7298] = {
    [sym_block_comment] = STATE(7298),
    [sym_line_comment] = STATE(7298),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10022),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9656),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7299] = {
    [sym_block_comment] = STATE(7299),
    [sym_line_comment] = STATE(7299),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10022),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [7300] = {
    [sym_block_comment] = STATE(7300),
    [sym_line_comment] = STATE(7300),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7301] = {
    [sym_block_comment] = STATE(7301),
    [sym_line_comment] = STATE(7301),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7302] = {
    [sym_block_comment] = STATE(7302),
    [sym_line_comment] = STATE(7302),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7303] = {
    [sym_block_comment] = STATE(7303),
    [sym_line_comment] = STATE(7303),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7304] = {
    [sym_block_comment] = STATE(7304),
    [sym_line_comment] = STATE(7304),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7305] = {
    [sym_block_comment] = STATE(7305),
    [sym_line_comment] = STATE(7305),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_elseif] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7306] = {
    [sym_block_comment] = STATE(7306),
    [sym_line_comment] = STATE(7306),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(11263),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_elseif] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7307] = {
    [sym_block_comment] = STATE(7307),
    [sym_line_comment] = STATE(7307),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(11263),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_elseif] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7308] = {
    [sym_block_comment] = STATE(7308),
    [sym_line_comment] = STATE(7308),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(11263),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_elseif] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7309] = {
    [sym_block_comment] = STATE(7309),
    [sym_line_comment] = STATE(7309),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_elseif] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7310] = {
    [sym_block_comment] = STATE(7310),
    [sym_line_comment] = STATE(7310),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11269),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_end] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_elseif] = ACTIONS(11269),
    [anon_sym_else] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11269),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11269),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11269),
    [anon_sym_DOLLAR] = ACTIONS(11269),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11269),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11269),
    [anon_sym_QMARK] = ACTIONS(11269),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11269),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11269),
    [aux_sym_integer_literal_token2] = ACTIONS(11269),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11269),
    [aux_sym_float_literal_token3] = ACTIONS(11269),
    [aux_sym_float_literal_token4] = ACTIONS(11269),
    [sym_character_literal] = ACTIONS(11269),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11269),
    [sym__pair_operator] = ACTIONS(11269),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11269),
    [sym__lazy_and_operator] = ACTIONS(11269),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11269),
    [sym__pipe_left_operator] = ACTIONS(11269),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11269),
    [sym__bitshift_operator] = ACTIONS(11269),
    [sym__power_operator] = ACTIONS(11269),
    [sym__tilde_operator] = ACTIONS(11269),
    [sym__type_order_operator] = ACTIONS(11269),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym__terminator_token1] = ACTIONS(11271),
    [aux_sym__terminator_token2] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7311] = {
    [sym_block_comment] = STATE(7311),
    [sym_line_comment] = STATE(7311),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7312] = {
    [sym_block_comment] = STATE(7312),
    [sym_line_comment] = STATE(7312),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7313] = {
    [sym_block_comment] = STATE(7313),
    [sym_line_comment] = STATE(7313),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7314] = {
    [sym_block_comment] = STATE(7314),
    [sym_line_comment] = STATE(7314),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7315] = {
    [sym_block_comment] = STATE(7315),
    [sym_line_comment] = STATE(7315),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11223),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_end] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_else] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_finally] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11223),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11223),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11223),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11223),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11223),
    [anon_sym_QMARK] = ACTIONS(11223),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11223),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11223),
    [aux_sym_integer_literal_token2] = ACTIONS(11223),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11223),
    [aux_sym_float_literal_token3] = ACTIONS(11223),
    [aux_sym_float_literal_token4] = ACTIONS(11223),
    [sym_character_literal] = ACTIONS(11223),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11223),
    [sym__pair_operator] = ACTIONS(11223),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11223),
    [sym__lazy_and_operator] = ACTIONS(11223),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11223),
    [sym__pipe_left_operator] = ACTIONS(11223),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11223),
    [sym__bitshift_operator] = ACTIONS(11223),
    [sym__power_operator] = ACTIONS(11223),
    [sym__tilde_operator] = ACTIONS(11223),
    [sym__type_order_operator] = ACTIONS(11223),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym__terminator_token1] = ACTIONS(11225),
    [aux_sym__terminator_token2] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7316] = {
    [sym_block_comment] = STATE(7316),
    [sym_line_comment] = STATE(7316),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7317] = {
    [sym_block_comment] = STATE(7317),
    [sym_line_comment] = STATE(7317),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7318] = {
    [sym_block_comment] = STATE(7318),
    [sym_line_comment] = STATE(7318),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7319] = {
    [sym_block_comment] = STATE(7319),
    [sym_line_comment] = STATE(7319),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7320] = {
    [sym_block_comment] = STATE(7320),
    [sym_line_comment] = STATE(7320),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7321] = {
    [sym_block_comment] = STATE(7321),
    [sym_line_comment] = STATE(7321),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(11263),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_elseif] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7322] = {
    [sym_block_comment] = STATE(7322),
    [sym_line_comment] = STATE(7322),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_elseif] = ACTIONS(11275),
    [anon_sym_else] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7323] = {
    [sym_block_comment] = STATE(7323),
    [sym_line_comment] = STATE(7323),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7324] = {
    [sym_block_comment] = STATE(7324),
    [sym_line_comment] = STATE(7324),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7325] = {
    [sym_block_comment] = STATE(7325),
    [sym_line_comment] = STATE(7325),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7326] = {
    [sym_block_comment] = STATE(7326),
    [sym_line_comment] = STATE(7326),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7327] = {
    [sym_block_comment] = STATE(7327),
    [sym_line_comment] = STATE(7327),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7328] = {
    [sym_block_comment] = STATE(7328),
    [sym_line_comment] = STATE(7328),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7329] = {
    [sym_block_comment] = STATE(7329),
    [sym_line_comment] = STATE(7329),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(11221),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7330] = {
    [sym_block_comment] = STATE(7330),
    [sym_line_comment] = STATE(7330),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7331] = {
    [sym_block_comment] = STATE(7331),
    [sym_line_comment] = STATE(7331),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7332] = {
    [sym_block_comment] = STATE(7332),
    [sym_line_comment] = STATE(7332),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7333] = {
    [sym_block_comment] = STATE(7333),
    [sym_line_comment] = STATE(7333),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7334] = {
    [sym_block_comment] = STATE(7334),
    [sym_line_comment] = STATE(7334),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7335] = {
    [sym_block_comment] = STATE(7335),
    [sym_line_comment] = STATE(7335),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7336] = {
    [sym_block_comment] = STATE(7336),
    [sym_line_comment] = STATE(7336),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_end] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_elseif] = ACTIONS(11279),
    [anon_sym_else] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11279),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11279),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11279),
    [anon_sym_DOLLAR] = ACTIONS(11279),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11279),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11279),
    [anon_sym_QMARK] = ACTIONS(11279),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11279),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11279),
    [aux_sym_integer_literal_token2] = ACTIONS(11279),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11279),
    [aux_sym_float_literal_token3] = ACTIONS(11279),
    [aux_sym_float_literal_token4] = ACTIONS(11279),
    [sym_character_literal] = ACTIONS(11279),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11279),
    [sym__pair_operator] = ACTIONS(11279),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11279),
    [sym__lazy_and_operator] = ACTIONS(11279),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11279),
    [sym__pipe_left_operator] = ACTIONS(11279),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11279),
    [sym__bitshift_operator] = ACTIONS(11279),
    [sym__power_operator] = ACTIONS(11279),
    [sym__tilde_operator] = ACTIONS(11279),
    [sym__type_order_operator] = ACTIONS(11279),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym__terminator_token1] = ACTIONS(11281),
    [aux_sym__terminator_token2] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7337] = {
    [sym_block_comment] = STATE(7337),
    [sym_line_comment] = STATE(7337),
    [ts_builtin_sym_end] = ACTIONS(10763),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_RBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7338] = {
    [sym_block_comment] = STATE(7338),
    [sym_line_comment] = STATE(7338),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7339] = {
    [sym_block_comment] = STATE(7339),
    [sym_line_comment] = STATE(7339),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7340] = {
    [sym_block_comment] = STATE(7340),
    [sym_line_comment] = STATE(7340),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11283),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_end] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_else] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_finally] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11283),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11283),
    [anon_sym_DOLLAR] = ACTIONS(11283),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11283),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11283),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11283),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11283),
    [aux_sym_integer_literal_token2] = ACTIONS(11283),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11283),
    [aux_sym_float_literal_token3] = ACTIONS(11283),
    [aux_sym_float_literal_token4] = ACTIONS(11283),
    [sym_character_literal] = ACTIONS(11283),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11283),
    [sym__pair_operator] = ACTIONS(11283),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11283),
    [sym__lazy_and_operator] = ACTIONS(11283),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11283),
    [sym__pipe_left_operator] = ACTIONS(11283),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11283),
    [sym__bitshift_operator] = ACTIONS(11283),
    [sym__power_operator] = ACTIONS(11283),
    [sym__tilde_operator] = ACTIONS(11283),
    [sym__type_order_operator] = ACTIONS(11283),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym__terminator_token1] = ACTIONS(11285),
    [aux_sym__terminator_token2] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7341] = {
    [sym_block_comment] = STATE(7341),
    [sym_line_comment] = STATE(7341),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_elseif] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_QMARK] = ACTIONS(11287),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11287),
    [sym__lazy_and_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7342] = {
    [sym_block_comment] = STATE(7342),
    [sym_line_comment] = STATE(7342),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7343] = {
    [sym_block_comment] = STATE(7343),
    [sym_line_comment] = STATE(7343),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_elseif] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7344] = {
    [sym_block_comment] = STATE(7344),
    [sym_line_comment] = STATE(7344),
    [ts_builtin_sym_end] = ACTIONS(9984),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_RBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7345] = {
    [sym_block_comment] = STATE(7345),
    [sym_line_comment] = STATE(7345),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7346] = {
    [sym_block_comment] = STATE(7346),
    [sym_line_comment] = STATE(7346),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10579),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10579),
    [anon_sym_RPAREN] = ACTIONS(10579),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10579),
    [anon_sym_RBRACK] = ACTIONS(10579),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_SEMI] = ACTIONS(10579),
    [anon_sym_LBRACE] = ACTIONS(10579),
    [anon_sym_RBRACE] = ACTIONS(10579),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10579),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10579),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10579),
    [anon_sym_QMARK] = ACTIONS(10579),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10579),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10579),
    [aux_sym_integer_literal_token2] = ACTIONS(10579),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10579),
    [aux_sym_float_literal_token3] = ACTIONS(10579),
    [aux_sym_float_literal_token4] = ACTIONS(10579),
    [sym_character_literal] = ACTIONS(10579),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10579),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10579),
    [sym__pair_operator] = ACTIONS(10579),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10579),
    [sym__lazy_and_operator] = ACTIONS(10579),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10579),
    [sym__pipe_left_operator] = ACTIONS(10579),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10579),
    [sym__bitshift_operator] = ACTIONS(10579),
    [sym__power_operator] = ACTIONS(10579),
    [sym__tilde_operator] = ACTIONS(10579),
    [sym__type_order_operator] = ACTIONS(10579),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7347] = {
    [sym_block_comment] = STATE(7347),
    [sym_line_comment] = STATE(7347),
    [ts_builtin_sym_end] = ACTIONS(9988),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_RBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7348] = {
    [sym_block_comment] = STATE(7348),
    [sym_line_comment] = STATE(7348),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(11221),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7349] = {
    [sym_block_comment] = STATE(7349),
    [sym_line_comment] = STATE(7349),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(11221),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7350] = {
    [sym_block_comment] = STATE(7350),
    [sym_line_comment] = STATE(7350),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(11221),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_else] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7351] = {
    [sym_block_comment] = STATE(7351),
    [sym_line_comment] = STATE(7351),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_elseif] = ACTIONS(10761),
    [anon_sym_else] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7352] = {
    [sym_block_comment] = STATE(7352),
    [sym_line_comment] = STATE(7352),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7353] = {
    [sym_block_comment] = STATE(7353),
    [sym_line_comment] = STATE(7353),
    [ts_builtin_sym_end] = ACTIONS(10002),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_RBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7354] = {
    [sym_block_comment] = STATE(7354),
    [sym_line_comment] = STATE(7354),
    [ts_builtin_sym_end] = ACTIONS(10006),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_RBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7355] = {
    [sym_block_comment] = STATE(7355),
    [sym_line_comment] = STATE(7355),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11291),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_end] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_else] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_finally] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11291),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11291),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11291),
    [anon_sym_DOLLAR] = ACTIONS(11291),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11291),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11291),
    [anon_sym_QMARK] = ACTIONS(11291),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11291),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11291),
    [aux_sym_integer_literal_token2] = ACTIONS(11291),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11291),
    [aux_sym_float_literal_token3] = ACTIONS(11291),
    [aux_sym_float_literal_token4] = ACTIONS(11291),
    [sym_character_literal] = ACTIONS(11291),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11291),
    [sym__pair_operator] = ACTIONS(11291),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11291),
    [sym__lazy_and_operator] = ACTIONS(11291),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11291),
    [sym__pipe_left_operator] = ACTIONS(11291),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11291),
    [sym__bitshift_operator] = ACTIONS(11291),
    [sym__power_operator] = ACTIONS(11291),
    [sym__tilde_operator] = ACTIONS(11291),
    [sym__type_order_operator] = ACTIONS(11291),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym__terminator_token1] = ACTIONS(11293),
    [aux_sym__terminator_token2] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7356] = {
    [sym_block_comment] = STATE(7356),
    [sym_line_comment] = STATE(7356),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9636),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7357] = {
    [sym__comprehension_clause] = STATE(19458),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7357),
    [sym_line_comment] = STATE(7357),
    [aux_sym_vector_expression_repeat1] = STATE(17239),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11295),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11297),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11299),
    [aux_sym__terminator_token2] = ACTIONS(11302),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7358] = {
    [sym_block_comment] = STATE(7358),
    [sym_line_comment] = STATE(7358),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_finally] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7359] = {
    [sym_block_comment] = STATE(7359),
    [sym_line_comment] = STATE(7359),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11305),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_end] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_else] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_finally] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11305),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11305),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11305),
    [anon_sym_DOLLAR] = ACTIONS(11305),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11305),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11305),
    [anon_sym_QMARK] = ACTIONS(11305),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11305),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11305),
    [aux_sym_integer_literal_token2] = ACTIONS(11305),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11305),
    [aux_sym_float_literal_token3] = ACTIONS(11305),
    [aux_sym_float_literal_token4] = ACTIONS(11305),
    [sym_character_literal] = ACTIONS(11305),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11305),
    [sym__pair_operator] = ACTIONS(11305),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11305),
    [sym__lazy_and_operator] = ACTIONS(11305),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11305),
    [sym__pipe_left_operator] = ACTIONS(11305),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11305),
    [sym__bitshift_operator] = ACTIONS(11305),
    [sym__power_operator] = ACTIONS(11305),
    [sym__tilde_operator] = ACTIONS(11305),
    [sym__type_order_operator] = ACTIONS(11305),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym__terminator_token1] = ACTIONS(11307),
    [aux_sym__terminator_token2] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7360] = {
    [sym_block_comment] = STATE(7360),
    [sym_line_comment] = STATE(7360),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_else] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7361] = {
    [sym_block_comment] = STATE(7361),
    [sym_line_comment] = STATE(7361),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11309),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_end] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_elseif] = ACTIONS(11309),
    [anon_sym_else] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11309),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11309),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11309),
    [anon_sym_DOLLAR] = ACTIONS(11309),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11309),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11309),
    [anon_sym_QMARK] = ACTIONS(11309),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11309),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11309),
    [aux_sym_integer_literal_token2] = ACTIONS(11309),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11309),
    [aux_sym_float_literal_token3] = ACTIONS(11309),
    [aux_sym_float_literal_token4] = ACTIONS(11309),
    [sym_character_literal] = ACTIONS(11309),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11309),
    [sym__pair_operator] = ACTIONS(11309),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11309),
    [sym__lazy_and_operator] = ACTIONS(11309),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11309),
    [sym__pipe_left_operator] = ACTIONS(11309),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11309),
    [sym__bitshift_operator] = ACTIONS(11309),
    [sym__power_operator] = ACTIONS(11309),
    [sym__tilde_operator] = ACTIONS(11309),
    [sym__type_order_operator] = ACTIONS(11309),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym__terminator_token1] = ACTIONS(11311),
    [aux_sym__terminator_token2] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7362] = {
    [sym_block_comment] = STATE(7362),
    [sym_line_comment] = STATE(7362),
    [aux_sym_export_statement_repeat1] = STATE(7482),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(11313),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_end] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_catch] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10807),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10807),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10807),
    [anon_sym_DOLLAR] = ACTIONS(10807),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10807),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10807),
    [anon_sym_QMARK] = ACTIONS(10807),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10807),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10807),
    [aux_sym_integer_literal_token2] = ACTIONS(10807),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10807),
    [aux_sym_float_literal_token3] = ACTIONS(10807),
    [aux_sym_float_literal_token4] = ACTIONS(10807),
    [sym_character_literal] = ACTIONS(10807),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10807),
    [sym__pair_operator] = ACTIONS(10807),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10807),
    [sym__lazy_and_operator] = ACTIONS(10807),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10807),
    [sym__pipe_left_operator] = ACTIONS(10807),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10807),
    [sym__bitshift_operator] = ACTIONS(10807),
    [sym__power_operator] = ACTIONS(10807),
    [sym__tilde_operator] = ACTIONS(10807),
    [sym__type_order_operator] = ACTIONS(10807),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym__terminator_token1] = ACTIONS(10811),
    [aux_sym__terminator_token2] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7363] = {
    [sym_block_comment] = STATE(7363),
    [sym_line_comment] = STATE(7363),
    [ts_builtin_sym_end] = ACTIONS(10012),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_RBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7364] = {
    [sym_block_comment] = STATE(7364),
    [sym_line_comment] = STATE(7364),
    [ts_builtin_sym_end] = ACTIONS(10016),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_RBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7365] = {
    [sym_block_comment] = STATE(7365),
    [sym_line_comment] = STATE(7365),
    [ts_builtin_sym_end] = ACTIONS(10020),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_RBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7366] = {
    [sym_block_comment] = STATE(7366),
    [sym_line_comment] = STATE(7366),
    [ts_builtin_sym_end] = ACTIONS(9918),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_RBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7367] = {
    [sym_block_comment] = STATE(7367),
    [sym_line_comment] = STATE(7367),
    [ts_builtin_sym_end] = ACTIONS(9922),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_RBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7368] = {
    [sym_block_comment] = STATE(7368),
    [sym_line_comment] = STATE(7368),
    [aux_sym_export_statement_repeat1] = STATE(7746),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(11315),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10811),
    [anon_sym_RPAREN] = ACTIONS(10811),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10811),
    [anon_sym_RBRACK] = ACTIONS(10811),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_SEMI] = ACTIONS(10811),
    [anon_sym_LBRACE] = ACTIONS(10811),
    [anon_sym_RBRACE] = ACTIONS(10811),
    [anon_sym_DOLLAR] = ACTIONS(10811),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10811),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10811),
    [anon_sym_QMARK] = ACTIONS(10811),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10811),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10811),
    [aux_sym_integer_literal_token2] = ACTIONS(10811),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10811),
    [aux_sym_float_literal_token3] = ACTIONS(10811),
    [aux_sym_float_literal_token4] = ACTIONS(10811),
    [sym_character_literal] = ACTIONS(10811),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10811),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10811),
    [sym__pair_operator] = ACTIONS(10811),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10811),
    [sym__lazy_and_operator] = ACTIONS(10811),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10811),
    [sym__pipe_left_operator] = ACTIONS(10811),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10811),
    [sym__bitshift_operator] = ACTIONS(10811),
    [sym__power_operator] = ACTIONS(10811),
    [sym__tilde_operator] = ACTIONS(10811),
    [sym__type_order_operator] = ACTIONS(10811),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7369] = {
    [sym_block_comment] = STATE(7369),
    [sym_line_comment] = STATE(7369),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11317),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_end] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_elseif] = ACTIONS(11317),
    [anon_sym_else] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11317),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11317),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11317),
    [anon_sym_DOLLAR] = ACTIONS(11317),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11317),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11317),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11317),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11317),
    [aux_sym_integer_literal_token2] = ACTIONS(11317),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11317),
    [aux_sym_float_literal_token3] = ACTIONS(11317),
    [aux_sym_float_literal_token4] = ACTIONS(11317),
    [sym_character_literal] = ACTIONS(11317),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11317),
    [sym__pair_operator] = ACTIONS(11317),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11317),
    [sym__lazy_and_operator] = ACTIONS(11317),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11317),
    [sym__pipe_left_operator] = ACTIONS(11317),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11317),
    [sym__bitshift_operator] = ACTIONS(11317),
    [sym__power_operator] = ACTIONS(11317),
    [sym__tilde_operator] = ACTIONS(11317),
    [sym__type_order_operator] = ACTIONS(11317),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym__terminator_token1] = ACTIONS(11319),
    [aux_sym__terminator_token2] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7370] = {
    [sym_block_comment] = STATE(7370),
    [sym_line_comment] = STATE(7370),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7371] = {
    [sym_block_comment] = STATE(7371),
    [sym_line_comment] = STATE(7371),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_RPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_RBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_SEMI] = ACTIONS(9734),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_RBRACE] = ACTIONS(9734),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10842),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7372] = {
    [sym_block_comment] = STATE(7372),
    [sym_line_comment] = STATE(7372),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_RPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_RBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_SEMI] = ACTIONS(10136),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_RBRACE] = ACTIONS(10136),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7373] = {
    [sym_block_comment] = STATE(7373),
    [sym_line_comment] = STATE(7373),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7374] = {
    [sym__comprehension_clause] = STATE(18458),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7374),
    [sym_line_comment] = STATE(7374),
    [aux_sym_vector_expression_repeat1] = STATE(17147),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11321),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11323),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11325),
    [aux_sym__terminator_token2] = ACTIONS(11328),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7375] = {
    [sym_block_comment] = STATE(7375),
    [sym_line_comment] = STATE(7375),
    [ts_builtin_sym_end] = ACTIONS(9992),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_RBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7376] = {
    [sym_block_comment] = STATE(7376),
    [sym_line_comment] = STATE(7376),
    [ts_builtin_sym_end] = ACTIONS(9996),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_RBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7377] = {
    [sym_block_comment] = STATE(7377),
    [sym_line_comment] = STATE(7377),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11331),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_end] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_elseif] = ACTIONS(11331),
    [anon_sym_else] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11331),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11331),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11331),
    [anon_sym_DOLLAR] = ACTIONS(11331),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11331),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11331),
    [anon_sym_QMARK] = ACTIONS(11331),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11331),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11331),
    [aux_sym_integer_literal_token2] = ACTIONS(11331),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11331),
    [aux_sym_float_literal_token3] = ACTIONS(11331),
    [aux_sym_float_literal_token4] = ACTIONS(11331),
    [sym_character_literal] = ACTIONS(11331),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11331),
    [sym__pair_operator] = ACTIONS(11331),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11331),
    [sym__lazy_and_operator] = ACTIONS(11331),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11331),
    [sym__pipe_left_operator] = ACTIONS(11331),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11331),
    [sym__bitshift_operator] = ACTIONS(11331),
    [sym__power_operator] = ACTIONS(11331),
    [sym__tilde_operator] = ACTIONS(11331),
    [sym__type_order_operator] = ACTIONS(11331),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym__terminator_token1] = ACTIONS(11333),
    [aux_sym__terminator_token2] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7378] = {
    [sym_block_comment] = STATE(7378),
    [sym_line_comment] = STATE(7378),
    [ts_builtin_sym_end] = ACTIONS(9754),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_RBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7379] = {
    [sym_block_comment] = STATE(7379),
    [sym_line_comment] = STATE(7379),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_elseif] = ACTIONS(11335),
    [anon_sym_else] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11335),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_DOLLAR] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11335),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11335),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11335),
    [aux_sym_integer_literal_token2] = ACTIONS(11335),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11335),
    [aux_sym_float_literal_token3] = ACTIONS(11335),
    [aux_sym_float_literal_token4] = ACTIONS(11335),
    [sym_character_literal] = ACTIONS(11335),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11335),
    [sym__pair_operator] = ACTIONS(11335),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11335),
    [sym__lazy_and_operator] = ACTIONS(11335),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11335),
    [sym__pipe_left_operator] = ACTIONS(11335),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11335),
    [sym__bitshift_operator] = ACTIONS(11335),
    [sym__power_operator] = ACTIONS(11335),
    [sym__tilde_operator] = ACTIONS(11335),
    [sym__type_order_operator] = ACTIONS(11335),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym__terminator_token1] = ACTIONS(11337),
    [aux_sym__terminator_token2] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7380] = {
    [sym_block_comment] = STATE(7380),
    [sym_line_comment] = STATE(7380),
    [ts_builtin_sym_end] = ACTIONS(9762),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_RBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7381] = {
    [sym_block_comment] = STATE(7381),
    [sym_line_comment] = STATE(7381),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7382] = {
    [sym_block_comment] = STATE(7382),
    [sym_line_comment] = STATE(7382),
    [ts_builtin_sym_end] = ACTIONS(10030),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_RBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7383] = {
    [sym_block_comment] = STATE(7383),
    [sym_line_comment] = STATE(7383),
    [ts_builtin_sym_end] = ACTIONS(10034),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_RBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7384] = {
    [sym_block_comment] = STATE(7384),
    [sym_line_comment] = STATE(7384),
    [ts_builtin_sym_end] = ACTIONS(10038),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_RBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7385] = {
    [sym_block_comment] = STATE(7385),
    [sym_line_comment] = STATE(7385),
    [ts_builtin_sym_end] = ACTIONS(10042),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_RBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7386] = {
    [sym_block_comment] = STATE(7386),
    [sym_line_comment] = STATE(7386),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_catch] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7387] = {
    [sym_block_comment] = STATE(7387),
    [sym_line_comment] = STATE(7387),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [7388] = {
    [sym_block_comment] = STATE(7388),
    [sym_line_comment] = STATE(7388),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_catch] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7389] = {
    [sym_block_comment] = STATE(7389),
    [sym_line_comment] = STATE(7389),
    [aux_sym_export_statement_repeat1] = STATE(7484),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(11313),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_end] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_catch] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10813),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10813),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10813),
    [anon_sym_DOLLAR] = ACTIONS(10813),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10813),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10813),
    [anon_sym_QMARK] = ACTIONS(10813),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10813),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10813),
    [aux_sym_integer_literal_token2] = ACTIONS(10813),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10813),
    [aux_sym_float_literal_token3] = ACTIONS(10813),
    [aux_sym_float_literal_token4] = ACTIONS(10813),
    [sym_character_literal] = ACTIONS(10813),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10813),
    [sym__pair_operator] = ACTIONS(10813),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10813),
    [sym__lazy_and_operator] = ACTIONS(10813),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10813),
    [sym__pipe_left_operator] = ACTIONS(10813),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10813),
    [sym__bitshift_operator] = ACTIONS(10813),
    [sym__power_operator] = ACTIONS(10813),
    [sym__tilde_operator] = ACTIONS(10813),
    [sym__type_order_operator] = ACTIONS(10813),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym__terminator_token1] = ACTIONS(10815),
    [aux_sym__terminator_token2] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7390] = {
    [sym_block_comment] = STATE(7390),
    [sym_line_comment] = STATE(7390),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_end] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_elseif] = ACTIONS(11339),
    [anon_sym_else] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11339),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11339),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11339),
    [anon_sym_DOLLAR] = ACTIONS(11339),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11339),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(11339),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11339),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11339),
    [aux_sym_integer_literal_token2] = ACTIONS(11339),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11339),
    [aux_sym_float_literal_token3] = ACTIONS(11339),
    [aux_sym_float_literal_token4] = ACTIONS(11339),
    [sym_character_literal] = ACTIONS(11339),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11339),
    [sym__pair_operator] = ACTIONS(11339),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11339),
    [sym__lazy_and_operator] = ACTIONS(11339),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11339),
    [sym__pipe_left_operator] = ACTIONS(11339),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11339),
    [sym__bitshift_operator] = ACTIONS(11339),
    [sym__power_operator] = ACTIONS(11339),
    [sym__tilde_operator] = ACTIONS(11339),
    [sym__type_order_operator] = ACTIONS(11339),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym__terminator_token1] = ACTIONS(11341),
    [aux_sym__terminator_token2] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7391] = {
    [sym_block_comment] = STATE(7391),
    [sym_line_comment] = STATE(7391),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7392] = {
    [sym_block_comment] = STATE(7392),
    [sym_line_comment] = STATE(7392),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_elseif] = ACTIONS(10635),
    [anon_sym_else] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7393] = {
    [sym_block_comment] = STATE(7393),
    [sym_line_comment] = STATE(7393),
    [ts_builtin_sym_end] = ACTIONS(9914),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_RBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7394] = {
    [sym_block_comment] = STATE(7394),
    [sym_line_comment] = STATE(7394),
    [ts_builtin_sym_end] = ACTIONS(9792),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_RBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7395] = {
    [sym_block_comment] = STATE(7395),
    [sym_line_comment] = STATE(7395),
    [ts_builtin_sym_end] = ACTIONS(10046),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_RBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7396] = {
    [sym_block_comment] = STATE(7396),
    [sym_line_comment] = STATE(7396),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_finally] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7397] = {
    [sym_block_comment] = STATE(7397),
    [sym_line_comment] = STATE(7397),
    [ts_builtin_sym_end] = ACTIONS(10050),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_RBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7398] = {
    [sym_block_comment] = STATE(7398),
    [sym_line_comment] = STATE(7398),
    [aux_sym__import_list_repeat1] = STATE(7490),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10819),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_catch] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7399] = {
    [sym_block_comment] = STATE(7399),
    [sym_line_comment] = STATE(7399),
    [ts_builtin_sym_end] = ACTIONS(10058),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_RBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7400] = {
    [sym_block_comment] = STATE(7400),
    [sym_line_comment] = STATE(7400),
    [ts_builtin_sym_end] = ACTIONS(9900),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_RBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7401] = {
    [sym_block_comment] = STATE(7401),
    [sym_line_comment] = STATE(7401),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7402] = {
    [sym_block_comment] = STATE(7402),
    [sym_line_comment] = STATE(7402),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11343),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_end] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_elseif] = ACTIONS(11343),
    [anon_sym_else] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11343),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11343),
    [anon_sym_DOLLAR] = ACTIONS(11343),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11343),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11343),
    [anon_sym_QMARK] = ACTIONS(11343),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11343),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11343),
    [aux_sym_integer_literal_token2] = ACTIONS(11343),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11343),
    [aux_sym_float_literal_token3] = ACTIONS(11343),
    [aux_sym_float_literal_token4] = ACTIONS(11343),
    [sym_character_literal] = ACTIONS(11343),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11343),
    [sym__pair_operator] = ACTIONS(11343),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11343),
    [sym__lazy_and_operator] = ACTIONS(11343),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11343),
    [sym__pipe_left_operator] = ACTIONS(11343),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11343),
    [sym__bitshift_operator] = ACTIONS(11343),
    [sym__power_operator] = ACTIONS(11343),
    [sym__tilde_operator] = ACTIONS(11343),
    [sym__type_order_operator] = ACTIONS(11343),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym__terminator_token1] = ACTIONS(11345),
    [aux_sym__terminator_token2] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7403] = {
    [sym_block_comment] = STATE(7403),
    [sym_line_comment] = STATE(7403),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_RPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_RBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_SEMI] = ACTIONS(9914),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_RBRACE] = ACTIONS(9914),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7404] = {
    [sym_block_comment] = STATE(7404),
    [sym_line_comment] = STATE(7404),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11347),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_end] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_elseif] = ACTIONS(11347),
    [anon_sym_else] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11347),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11347),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11347),
    [anon_sym_DOLLAR] = ACTIONS(11347),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11347),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11347),
    [anon_sym_QMARK] = ACTIONS(11347),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11347),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11347),
    [aux_sym_integer_literal_token2] = ACTIONS(11347),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11347),
    [aux_sym_float_literal_token3] = ACTIONS(11347),
    [aux_sym_float_literal_token4] = ACTIONS(11347),
    [sym_character_literal] = ACTIONS(11347),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11347),
    [sym__pair_operator] = ACTIONS(11347),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11347),
    [sym__lazy_and_operator] = ACTIONS(11347),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11347),
    [sym__pipe_left_operator] = ACTIONS(11347),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11347),
    [sym__bitshift_operator] = ACTIONS(11347),
    [sym__power_operator] = ACTIONS(11347),
    [sym__tilde_operator] = ACTIONS(11347),
    [sym__type_order_operator] = ACTIONS(11347),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym__terminator_token1] = ACTIONS(11349),
    [aux_sym__terminator_token2] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7405] = {
    [sym_block_comment] = STATE(7405),
    [sym_line_comment] = STATE(7405),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10980),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_elseif] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7406] = {
    [sym_block_comment] = STATE(7406),
    [sym_line_comment] = STATE(7406),
    [ts_builtin_sym_end] = ACTIONS(10062),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_RBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7407] = {
    [sym_block_comment] = STATE(7407),
    [sym_line_comment] = STATE(7407),
    [ts_builtin_sym_end] = ACTIONS(10066),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_RBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7408] = {
    [sym_block_comment] = STATE(7408),
    [sym_line_comment] = STATE(7408),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11351),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_end] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_elseif] = ACTIONS(11351),
    [anon_sym_else] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11351),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11351),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11351),
    [anon_sym_DOLLAR] = ACTIONS(11351),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11351),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11351),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11351),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11351),
    [aux_sym_integer_literal_token2] = ACTIONS(11351),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11351),
    [aux_sym_float_literal_token3] = ACTIONS(11351),
    [aux_sym_float_literal_token4] = ACTIONS(11351),
    [sym_character_literal] = ACTIONS(11351),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11351),
    [sym__pair_operator] = ACTIONS(11351),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11351),
    [sym__lazy_and_operator] = ACTIONS(11351),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11351),
    [sym__pipe_left_operator] = ACTIONS(11351),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11351),
    [sym__bitshift_operator] = ACTIONS(11351),
    [sym__power_operator] = ACTIONS(11351),
    [sym__tilde_operator] = ACTIONS(11351),
    [sym__type_order_operator] = ACTIONS(11351),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym__terminator_token1] = ACTIONS(11353),
    [aux_sym__terminator_token2] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7409] = {
    [sym_block_comment] = STATE(7409),
    [sym_line_comment] = STATE(7409),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11355),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_end] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_elseif] = ACTIONS(11355),
    [anon_sym_else] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11355),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11355),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11355),
    [anon_sym_DOLLAR] = ACTIONS(11355),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11355),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_QMARK] = ACTIONS(11355),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11355),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11355),
    [aux_sym_integer_literal_token2] = ACTIONS(11355),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11355),
    [aux_sym_float_literal_token3] = ACTIONS(11355),
    [aux_sym_float_literal_token4] = ACTIONS(11355),
    [sym_character_literal] = ACTIONS(11355),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11355),
    [sym__pair_operator] = ACTIONS(11355),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11355),
    [sym__lazy_and_operator] = ACTIONS(11355),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11355),
    [sym__pipe_left_operator] = ACTIONS(11355),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11355),
    [sym__bitshift_operator] = ACTIONS(11355),
    [sym__power_operator] = ACTIONS(11355),
    [sym__tilde_operator] = ACTIONS(11355),
    [sym__type_order_operator] = ACTIONS(11355),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym__terminator_token1] = ACTIONS(11357),
    [aux_sym__terminator_token2] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7410] = {
    [sym_block_comment] = STATE(7410),
    [sym_line_comment] = STATE(7410),
    [ts_builtin_sym_end] = ACTIONS(10070),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_RBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7411] = {
    [sym_block_comment] = STATE(7411),
    [sym_line_comment] = STATE(7411),
    [ts_builtin_sym_end] = ACTIONS(10074),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_RBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7412] = {
    [sym_block_comment] = STATE(7412),
    [sym_line_comment] = STATE(7412),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11359),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_end] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_elseif] = ACTIONS(11359),
    [anon_sym_else] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11359),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11359),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11359),
    [anon_sym_DOLLAR] = ACTIONS(11359),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11359),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11359),
    [anon_sym_QMARK] = ACTIONS(11359),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11359),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11359),
    [aux_sym_integer_literal_token2] = ACTIONS(11359),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11359),
    [aux_sym_float_literal_token3] = ACTIONS(11359),
    [aux_sym_float_literal_token4] = ACTIONS(11359),
    [sym_character_literal] = ACTIONS(11359),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11359),
    [sym__pair_operator] = ACTIONS(11359),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11359),
    [sym__lazy_and_operator] = ACTIONS(11359),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11359),
    [sym__pipe_left_operator] = ACTIONS(11359),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11359),
    [sym__bitshift_operator] = ACTIONS(11359),
    [sym__power_operator] = ACTIONS(11359),
    [sym__tilde_operator] = ACTIONS(11359),
    [sym__type_order_operator] = ACTIONS(11359),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym__terminator_token1] = ACTIONS(11361),
    [aux_sym__terminator_token2] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7413] = {
    [sym__comprehension_clause] = STATE(18414),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7413),
    [sym_line_comment] = STATE(7413),
    [aux_sym_vector_expression_repeat1] = STATE(17226),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11363),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11365),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11367),
    [aux_sym__terminator_token2] = ACTIONS(11370),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7414] = {
    [sym_block_comment] = STATE(7414),
    [sym_line_comment] = STATE(7414),
    [ts_builtin_sym_end] = ACTIONS(10078),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_RBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7415] = {
    [sym_block_comment] = STATE(7415),
    [sym_line_comment] = STATE(7415),
    [ts_builtin_sym_end] = ACTIONS(10082),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_RBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7416] = {
    [sym_block_comment] = STATE(7416),
    [sym_line_comment] = STATE(7416),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11169),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_end] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_else] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_finally] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11169),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11169),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11169),
    [anon_sym_DOLLAR] = ACTIONS(11169),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11169),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11169),
    [anon_sym_QMARK] = ACTIONS(11169),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11169),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11169),
    [aux_sym_integer_literal_token2] = ACTIONS(11169),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11169),
    [aux_sym_float_literal_token3] = ACTIONS(11169),
    [aux_sym_float_literal_token4] = ACTIONS(11169),
    [sym_character_literal] = ACTIONS(11169),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11169),
    [sym__pair_operator] = ACTIONS(11169),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11169),
    [sym__lazy_and_operator] = ACTIONS(11169),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11169),
    [sym__pipe_left_operator] = ACTIONS(11169),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11169),
    [sym__bitshift_operator] = ACTIONS(11169),
    [sym__power_operator] = ACTIONS(11169),
    [sym__tilde_operator] = ACTIONS(11169),
    [sym__type_order_operator] = ACTIONS(11169),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym__terminator_token1] = ACTIONS(11171),
    [aux_sym__terminator_token2] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7417] = {
    [sym_block_comment] = STATE(7417),
    [sym_line_comment] = STATE(7417),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10835),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_else] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_finally] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7418] = {
    [sym_block_comment] = STATE(7418),
    [sym_line_comment] = STATE(7418),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_else] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_finally] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7419] = {
    [sym_block_comment] = STATE(7419),
    [sym_line_comment] = STATE(7419),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_catch] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7420] = {
    [sym_block_comment] = STATE(7420),
    [sym_line_comment] = STATE(7420),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11373),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_end] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_elseif] = ACTIONS(11373),
    [anon_sym_else] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11373),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11373),
    [anon_sym_DOLLAR] = ACTIONS(11373),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11373),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11373),
    [anon_sym_QMARK] = ACTIONS(11373),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11373),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11373),
    [aux_sym_integer_literal_token2] = ACTIONS(11373),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11373),
    [aux_sym_float_literal_token3] = ACTIONS(11373),
    [aux_sym_float_literal_token4] = ACTIONS(11373),
    [sym_character_literal] = ACTIONS(11373),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11373),
    [sym__pair_operator] = ACTIONS(11373),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11373),
    [sym__lazy_and_operator] = ACTIONS(11373),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11373),
    [sym__pipe_left_operator] = ACTIONS(11373),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11373),
    [sym__bitshift_operator] = ACTIONS(11373),
    [sym__power_operator] = ACTIONS(11373),
    [sym__tilde_operator] = ACTIONS(11373),
    [sym__type_order_operator] = ACTIONS(11373),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym__terminator_token1] = ACTIONS(11375),
    [aux_sym__terminator_token2] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7421] = {
    [sym_block_comment] = STATE(7421),
    [sym_line_comment] = STATE(7421),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_end] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_elseif] = ACTIONS(11377),
    [anon_sym_else] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11377),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11377),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11377),
    [anon_sym_DOLLAR] = ACTIONS(11377),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11377),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11377),
    [anon_sym_QMARK] = ACTIONS(11377),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11377),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11377),
    [aux_sym_integer_literal_token2] = ACTIONS(11377),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11377),
    [aux_sym_float_literal_token3] = ACTIONS(11377),
    [aux_sym_float_literal_token4] = ACTIONS(11377),
    [sym_character_literal] = ACTIONS(11377),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11377),
    [sym__pair_operator] = ACTIONS(11377),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11377),
    [sym__lazy_and_operator] = ACTIONS(11377),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11377),
    [sym__pipe_left_operator] = ACTIONS(11377),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11377),
    [sym__bitshift_operator] = ACTIONS(11377),
    [sym__power_operator] = ACTIONS(11377),
    [sym__tilde_operator] = ACTIONS(11377),
    [sym__type_order_operator] = ACTIONS(11377),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym__terminator_token1] = ACTIONS(11379),
    [aux_sym__terminator_token2] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7422] = {
    [sym_block_comment] = STATE(7422),
    [sym_line_comment] = STATE(7422),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7423] = {
    [sym_block_comment] = STATE(7423),
    [sym_line_comment] = STATE(7423),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11291),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_end] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_elseif] = ACTIONS(11291),
    [anon_sym_else] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11291),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11291),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11291),
    [anon_sym_DOLLAR] = ACTIONS(11291),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11291),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11291),
    [anon_sym_QMARK] = ACTIONS(11291),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11291),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11291),
    [aux_sym_integer_literal_token2] = ACTIONS(11291),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11291),
    [aux_sym_float_literal_token3] = ACTIONS(11291),
    [aux_sym_float_literal_token4] = ACTIONS(11291),
    [sym_character_literal] = ACTIONS(11291),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11291),
    [sym__pair_operator] = ACTIONS(11291),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11291),
    [sym__lazy_and_operator] = ACTIONS(11291),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11291),
    [sym__pipe_left_operator] = ACTIONS(11291),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11291),
    [sym__bitshift_operator] = ACTIONS(11291),
    [sym__power_operator] = ACTIONS(11291),
    [sym__tilde_operator] = ACTIONS(11291),
    [sym__type_order_operator] = ACTIONS(11291),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym__terminator_token1] = ACTIONS(11293),
    [aux_sym__terminator_token2] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7424] = {
    [sym_block_comment] = STATE(7424),
    [sym_line_comment] = STATE(7424),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11381),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_end] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_elseif] = ACTIONS(11381),
    [anon_sym_else] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11381),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11381),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11381),
    [anon_sym_DOLLAR] = ACTIONS(11381),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11381),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11381),
    [anon_sym_QMARK] = ACTIONS(11381),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11381),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11381),
    [aux_sym_integer_literal_token2] = ACTIONS(11381),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11381),
    [aux_sym_float_literal_token3] = ACTIONS(11381),
    [aux_sym_float_literal_token4] = ACTIONS(11381),
    [sym_character_literal] = ACTIONS(11381),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11381),
    [sym__pair_operator] = ACTIONS(11381),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11381),
    [sym__lazy_and_operator] = ACTIONS(11381),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11381),
    [sym__pipe_left_operator] = ACTIONS(11381),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11381),
    [sym__bitshift_operator] = ACTIONS(11381),
    [sym__power_operator] = ACTIONS(11381),
    [sym__tilde_operator] = ACTIONS(11381),
    [sym__type_order_operator] = ACTIONS(11381),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym__terminator_token1] = ACTIONS(11383),
    [aux_sym__terminator_token2] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7425] = {
    [sym_block_comment] = STATE(7425),
    [sym_line_comment] = STATE(7425),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7426] = {
    [sym_block_comment] = STATE(7426),
    [sym_line_comment] = STATE(7426),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_end] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_elseif] = ACTIONS(11385),
    [anon_sym_else] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11385),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11385),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11385),
    [anon_sym_DOLLAR] = ACTIONS(11385),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11385),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11385),
    [anon_sym_QMARK] = ACTIONS(11385),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11385),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11385),
    [aux_sym_integer_literal_token2] = ACTIONS(11385),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11385),
    [aux_sym_float_literal_token3] = ACTIONS(11385),
    [aux_sym_float_literal_token4] = ACTIONS(11385),
    [sym_character_literal] = ACTIONS(11385),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11385),
    [sym__pair_operator] = ACTIONS(11385),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11385),
    [sym__lazy_and_operator] = ACTIONS(11385),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11385),
    [sym__pipe_left_operator] = ACTIONS(11385),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11385),
    [sym__bitshift_operator] = ACTIONS(11385),
    [sym__power_operator] = ACTIONS(11385),
    [sym__tilde_operator] = ACTIONS(11385),
    [sym__type_order_operator] = ACTIONS(11385),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym__terminator_token1] = ACTIONS(11387),
    [aux_sym__terminator_token2] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7427] = {
    [sym_block_comment] = STATE(7427),
    [sym_line_comment] = STATE(7427),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7428] = {
    [sym__comprehension_clause] = STATE(19591),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7428),
    [sym_line_comment] = STATE(7428),
    [aux_sym_vector_expression_repeat1] = STATE(17065),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11389),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11391),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11393),
    [aux_sym__terminator_token2] = ACTIONS(11396),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7429] = {
    [sym_block_comment] = STATE(7429),
    [sym_line_comment] = STATE(7429),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11043),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_end] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_elseif] = ACTIONS(11043),
    [anon_sym_else] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11043),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11043),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11043),
    [anon_sym_DOLLAR] = ACTIONS(11043),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11043),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11043),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11043),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11043),
    [aux_sym_integer_literal_token2] = ACTIONS(11043),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11043),
    [aux_sym_float_literal_token3] = ACTIONS(11043),
    [aux_sym_float_literal_token4] = ACTIONS(11043),
    [sym_character_literal] = ACTIONS(11043),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11043),
    [sym__pair_operator] = ACTIONS(11043),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11043),
    [sym__lazy_and_operator] = ACTIONS(11043),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11043),
    [sym__pipe_left_operator] = ACTIONS(11043),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11043),
    [sym__bitshift_operator] = ACTIONS(11043),
    [sym__power_operator] = ACTIONS(11043),
    [sym__tilde_operator] = ACTIONS(11043),
    [sym__type_order_operator] = ACTIONS(11043),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym__terminator_token1] = ACTIONS(11045),
    [aux_sym__terminator_token2] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7430] = {
    [sym_block_comment] = STATE(7430),
    [sym_line_comment] = STATE(7430),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11399),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_end] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_elseif] = ACTIONS(11399),
    [anon_sym_else] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11399),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11399),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11399),
    [anon_sym_DOLLAR] = ACTIONS(11399),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11399),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11399),
    [anon_sym_QMARK] = ACTIONS(11399),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11399),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11399),
    [aux_sym_integer_literal_token2] = ACTIONS(11399),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11399),
    [aux_sym_float_literal_token3] = ACTIONS(11399),
    [aux_sym_float_literal_token4] = ACTIONS(11399),
    [sym_character_literal] = ACTIONS(11399),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11399),
    [sym__pair_operator] = ACTIONS(11399),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11399),
    [sym__lazy_and_operator] = ACTIONS(11399),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11399),
    [sym__pipe_left_operator] = ACTIONS(11399),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11399),
    [sym__bitshift_operator] = ACTIONS(11399),
    [sym__power_operator] = ACTIONS(11399),
    [sym__tilde_operator] = ACTIONS(11399),
    [sym__type_order_operator] = ACTIONS(11399),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym__terminator_token1] = ACTIONS(11401),
    [aux_sym__terminator_token2] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7431] = {
    [sym_block_comment] = STATE(7431),
    [sym_line_comment] = STATE(7431),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_end] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_elseif] = ACTIONS(11403),
    [anon_sym_else] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11403),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11403),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11403),
    [anon_sym_DOLLAR] = ACTIONS(11403),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11403),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11403),
    [anon_sym_QMARK] = ACTIONS(11403),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11403),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11403),
    [aux_sym_integer_literal_token2] = ACTIONS(11403),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11403),
    [aux_sym_float_literal_token3] = ACTIONS(11403),
    [aux_sym_float_literal_token4] = ACTIONS(11403),
    [sym_character_literal] = ACTIONS(11403),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11403),
    [sym__pair_operator] = ACTIONS(11403),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11403),
    [sym__lazy_and_operator] = ACTIONS(11403),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11403),
    [sym__pipe_left_operator] = ACTIONS(11403),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11403),
    [sym__bitshift_operator] = ACTIONS(11403),
    [sym__power_operator] = ACTIONS(11403),
    [sym__tilde_operator] = ACTIONS(11403),
    [sym__type_order_operator] = ACTIONS(11403),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym__terminator_token1] = ACTIONS(11405),
    [aux_sym__terminator_token2] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7432] = {
    [sym_block_comment] = STATE(7432),
    [sym_line_comment] = STATE(7432),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11255),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_end] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_elseif] = ACTIONS(11255),
    [anon_sym_else] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11255),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11255),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11255),
    [anon_sym_DOLLAR] = ACTIONS(11255),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11255),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11255),
    [anon_sym_QMARK] = ACTIONS(11255),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11255),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11255),
    [aux_sym_integer_literal_token2] = ACTIONS(11255),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11255),
    [aux_sym_float_literal_token3] = ACTIONS(11255),
    [aux_sym_float_literal_token4] = ACTIONS(11255),
    [sym_character_literal] = ACTIONS(11255),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11255),
    [sym__pair_operator] = ACTIONS(11255),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11255),
    [sym__lazy_and_operator] = ACTIONS(11255),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11255),
    [sym__pipe_left_operator] = ACTIONS(11255),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11255),
    [sym__bitshift_operator] = ACTIONS(11255),
    [sym__power_operator] = ACTIONS(11255),
    [sym__tilde_operator] = ACTIONS(11255),
    [sym__type_order_operator] = ACTIONS(11255),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym__terminator_token1] = ACTIONS(11257),
    [aux_sym__terminator_token2] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7433] = {
    [sym_block_comment] = STATE(7433),
    [sym_line_comment] = STATE(7433),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11407),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_end] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_elseif] = ACTIONS(11407),
    [anon_sym_else] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11407),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11407),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11407),
    [anon_sym_DOLLAR] = ACTIONS(11407),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11407),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11407),
    [anon_sym_QMARK] = ACTIONS(11407),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11407),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11407),
    [aux_sym_integer_literal_token2] = ACTIONS(11407),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11407),
    [aux_sym_float_literal_token3] = ACTIONS(11407),
    [aux_sym_float_literal_token4] = ACTIONS(11407),
    [sym_character_literal] = ACTIONS(11407),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11407),
    [sym__pair_operator] = ACTIONS(11407),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11407),
    [sym__lazy_and_operator] = ACTIONS(11407),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11407),
    [sym__pipe_left_operator] = ACTIONS(11407),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11407),
    [sym__bitshift_operator] = ACTIONS(11407),
    [sym__power_operator] = ACTIONS(11407),
    [sym__tilde_operator] = ACTIONS(11407),
    [sym__type_order_operator] = ACTIONS(11407),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym__terminator_token1] = ACTIONS(11409),
    [aux_sym__terminator_token2] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7434] = {
    [sym_block_comment] = STATE(7434),
    [sym_line_comment] = STATE(7434),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7435] = {
    [sym_block_comment] = STATE(7435),
    [sym_line_comment] = STATE(7435),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7436] = {
    [sym_block_comment] = STATE(7436),
    [sym_line_comment] = STATE(7436),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11411),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_end] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_elseif] = ACTIONS(11411),
    [anon_sym_else] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11411),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11411),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11411),
    [anon_sym_DOLLAR] = ACTIONS(11411),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11411),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11411),
    [anon_sym_QMARK] = ACTIONS(11411),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11411),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11411),
    [aux_sym_integer_literal_token2] = ACTIONS(11411),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11411),
    [aux_sym_float_literal_token3] = ACTIONS(11411),
    [aux_sym_float_literal_token4] = ACTIONS(11411),
    [sym_character_literal] = ACTIONS(11411),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11411),
    [sym__pair_operator] = ACTIONS(11411),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11411),
    [sym__lazy_and_operator] = ACTIONS(11411),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11411),
    [sym__pipe_left_operator] = ACTIONS(11411),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11411),
    [sym__bitshift_operator] = ACTIONS(11411),
    [sym__power_operator] = ACTIONS(11411),
    [sym__tilde_operator] = ACTIONS(11411),
    [sym__type_order_operator] = ACTIONS(11411),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym__terminator_token1] = ACTIONS(11413),
    [aux_sym__terminator_token2] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7437] = {
    [sym_block_comment] = STATE(7437),
    [sym_line_comment] = STATE(7437),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_catch] = ACTIONS(10908),
    [anon_sym_finally] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7438] = {
    [sym_block_comment] = STATE(7438),
    [sym_line_comment] = STATE(7438),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7439] = {
    [sym_block_comment] = STATE(7439),
    [sym_line_comment] = STATE(7439),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7440] = {
    [sym__comprehension_clause] = STATE(18955),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7440),
    [sym_line_comment] = STATE(7440),
    [aux_sym_vector_expression_repeat1] = STATE(17367),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11415),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11417),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11419),
    [aux_sym__terminator_token2] = ACTIONS(11422),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7441] = {
    [sym_block_comment] = STATE(7441),
    [sym_line_comment] = STATE(7441),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7442] = {
    [sym_block_comment] = STATE(7442),
    [sym_line_comment] = STATE(7442),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7443] = {
    [sym_block_comment] = STATE(7443),
    [sym_line_comment] = STATE(7443),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_RPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_RBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_SEMI] = ACTIONS(9728),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_RBRACE] = ACTIONS(9728),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7444] = {
    [sym_block_comment] = STATE(7444),
    [sym_line_comment] = STATE(7444),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7445] = {
    [sym_block_comment] = STATE(7445),
    [sym_line_comment] = STATE(7445),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
  },
  [7446] = {
    [sym_block_comment] = STATE(7446),
    [sym_line_comment] = STATE(7446),
    [ts_builtin_sym_end] = ACTIONS(9960),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_RBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7447] = {
    [sym_block_comment] = STATE(7447),
    [sym_line_comment] = STATE(7447),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
  },
  [7448] = {
    [sym_block_comment] = STATE(7448),
    [sym_line_comment] = STATE(7448),
    [aux_sym_open_tuple_repeat1] = STATE(7230),
    [ts_builtin_sym_end] = ACTIONS(10833),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10829),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10829),
    [anon_sym_RBRACK] = ACTIONS(10829),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10829),
    [anon_sym_DOLLAR] = ACTIONS(10829),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10829),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10829),
    [anon_sym_QMARK] = ACTIONS(10829),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10829),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10829),
    [aux_sym_integer_literal_token2] = ACTIONS(10829),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10829),
    [aux_sym_float_literal_token3] = ACTIONS(10829),
    [aux_sym_float_literal_token4] = ACTIONS(10829),
    [sym_character_literal] = ACTIONS(10829),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10829),
    [sym__pair_operator] = ACTIONS(10829),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10829),
    [sym__lazy_and_operator] = ACTIONS(10829),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10829),
    [sym__pipe_left_operator] = ACTIONS(10829),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10829),
    [sym__bitshift_operator] = ACTIONS(10829),
    [sym__power_operator] = ACTIONS(10829),
    [sym__tilde_operator] = ACTIONS(10829),
    [sym__type_order_operator] = ACTIONS(10829),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym__terminator_token1] = ACTIONS(10833),
    [aux_sym__terminator_token2] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7449] = {
    [sym_block_comment] = STATE(7449),
    [sym_line_comment] = STATE(7449),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_DOT] = ACTIONS(11427),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [7450] = {
    [sym_block_comment] = STATE(7450),
    [sym_line_comment] = STATE(7450),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7451] = {
    [sym_block_comment] = STATE(7451),
    [sym_line_comment] = STATE(7451),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(11429),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7452] = {
    [sym_block_comment] = STATE(7452),
    [sym_line_comment] = STATE(7452),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9686),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7453] = {
    [sym__comprehension_clause] = STATE(19116),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7453),
    [sym_line_comment] = STATE(7453),
    [aux_sym_vector_expression_repeat1] = STATE(17159),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11431),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11433),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11435),
    [aux_sym__terminator_token2] = ACTIONS(11438),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7454] = {
    [sym_block_comment] = STATE(7454),
    [sym_line_comment] = STATE(7454),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
  },
  [7455] = {
    [sym_block_comment] = STATE(7455),
    [sym_line_comment] = STATE(7455),
    [aux_sym_open_tuple_repeat1] = STATE(7461),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_end] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_catch] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10829),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10829),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10829),
    [anon_sym_DOLLAR] = ACTIONS(10829),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10829),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10829),
    [anon_sym_QMARK] = ACTIONS(10829),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10829),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10829),
    [aux_sym_integer_literal_token2] = ACTIONS(10829),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10829),
    [aux_sym_float_literal_token3] = ACTIONS(10829),
    [aux_sym_float_literal_token4] = ACTIONS(10829),
    [sym_character_literal] = ACTIONS(10829),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10829),
    [sym__pair_operator] = ACTIONS(10829),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10829),
    [sym__lazy_and_operator] = ACTIONS(10829),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10829),
    [sym__pipe_left_operator] = ACTIONS(10829),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10829),
    [sym__bitshift_operator] = ACTIONS(10829),
    [sym__power_operator] = ACTIONS(10829),
    [sym__tilde_operator] = ACTIONS(10829),
    [sym__type_order_operator] = ACTIONS(10829),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym__terminator_token1] = ACTIONS(10833),
    [aux_sym__terminator_token2] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7456] = {
    [sym_block_comment] = STATE(7456),
    [sym_line_comment] = STATE(7456),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7457] = {
    [sym_block_comment] = STATE(7457),
    [sym_line_comment] = STATE(7457),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_RPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_RBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_SEMI] = ACTIONS(9740),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_RBRACE] = ACTIONS(9740),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7458] = {
    [sym_block_comment] = STATE(7458),
    [sym_line_comment] = STATE(7458),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_RPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_RBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_SEMI] = ACTIONS(9746),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_RBRACE] = ACTIONS(9746),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7459] = {
    [sym_block_comment] = STATE(7459),
    [sym_line_comment] = STATE(7459),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11305),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_end] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_elseif] = ACTIONS(11305),
    [anon_sym_else] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11305),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11305),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11305),
    [anon_sym_DOLLAR] = ACTIONS(11305),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11305),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11305),
    [anon_sym_QMARK] = ACTIONS(11305),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11305),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11305),
    [aux_sym_integer_literal_token2] = ACTIONS(11305),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11305),
    [aux_sym_float_literal_token3] = ACTIONS(11305),
    [aux_sym_float_literal_token4] = ACTIONS(11305),
    [sym_character_literal] = ACTIONS(11305),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11305),
    [sym__pair_operator] = ACTIONS(11305),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11305),
    [sym__lazy_and_operator] = ACTIONS(11305),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11305),
    [sym__pipe_left_operator] = ACTIONS(11305),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11305),
    [sym__bitshift_operator] = ACTIONS(11305),
    [sym__power_operator] = ACTIONS(11305),
    [sym__tilde_operator] = ACTIONS(11305),
    [sym__type_order_operator] = ACTIONS(11305),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym__terminator_token1] = ACTIONS(11307),
    [aux_sym__terminator_token2] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7460] = {
    [sym_block_comment] = STATE(7460),
    [sym_line_comment] = STATE(7460),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_elseif] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7461] = {
    [sym_block_comment] = STATE(7461),
    [sym_line_comment] = STATE(7461),
    [aux_sym_open_tuple_repeat1] = STATE(7461),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(11443),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_catch] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10835),
    [anon_sym_QMARK] = ACTIONS(10835),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10835),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10835),
    [sym__lazy_and_operator] = ACTIONS(10835),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10835),
    [sym__pipe_left_operator] = ACTIONS(10835),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10835),
    [sym__bitshift_operator] = ACTIONS(10835),
    [sym__power_operator] = ACTIONS(10835),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10835),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7462] = {
    [sym_block_comment] = STATE(7462),
    [sym_line_comment] = STATE(7462),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [7463] = {
    [sym_block_comment] = STATE(7463),
    [sym_line_comment] = STATE(7463),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7464] = {
    [sym_block_comment] = STATE(7464),
    [sym_line_comment] = STATE(7464),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7465] = {
    [sym__comprehension_clause] = STATE(19545),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7465),
    [sym_line_comment] = STATE(7465),
    [aux_sym_vector_expression_repeat1] = STATE(17583),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11446),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11448),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11450),
    [aux_sym__terminator_token2] = ACTIONS(11453),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7466] = {
    [sym_block_comment] = STATE(7466),
    [sym_line_comment] = STATE(7466),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11456),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_end] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_elseif] = ACTIONS(11456),
    [anon_sym_else] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11456),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11456),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11456),
    [anon_sym_DOLLAR] = ACTIONS(11456),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11456),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11456),
    [anon_sym_QMARK] = ACTIONS(11456),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11456),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11456),
    [aux_sym_integer_literal_token2] = ACTIONS(11456),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11456),
    [aux_sym_float_literal_token3] = ACTIONS(11456),
    [aux_sym_float_literal_token4] = ACTIONS(11456),
    [sym_character_literal] = ACTIONS(11456),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11456),
    [sym__pair_operator] = ACTIONS(11456),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11456),
    [sym__lazy_and_operator] = ACTIONS(11456),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11456),
    [sym__pipe_left_operator] = ACTIONS(11456),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11456),
    [sym__bitshift_operator] = ACTIONS(11456),
    [sym__power_operator] = ACTIONS(11456),
    [sym__tilde_operator] = ACTIONS(11456),
    [sym__type_order_operator] = ACTIONS(11456),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym__terminator_token1] = ACTIONS(11458),
    [aux_sym__terminator_token2] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7467] = {
    [sym_block_comment] = STATE(7467),
    [sym_line_comment] = STATE(7467),
    [aux_sym_export_statement_repeat1] = STATE(7636),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(11460),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_catch] = ACTIONS(10807),
    [anon_sym_finally] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10807),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10807),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10807),
    [anon_sym_DOLLAR] = ACTIONS(10807),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10807),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10807),
    [anon_sym_QMARK] = ACTIONS(10807),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10807),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10807),
    [aux_sym_integer_literal_token2] = ACTIONS(10807),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10807),
    [aux_sym_float_literal_token3] = ACTIONS(10807),
    [aux_sym_float_literal_token4] = ACTIONS(10807),
    [sym_character_literal] = ACTIONS(10807),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10807),
    [sym__pair_operator] = ACTIONS(10807),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10807),
    [sym__lazy_and_operator] = ACTIONS(10807),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10807),
    [sym__pipe_left_operator] = ACTIONS(10807),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10807),
    [sym__bitshift_operator] = ACTIONS(10807),
    [sym__power_operator] = ACTIONS(10807),
    [sym__tilde_operator] = ACTIONS(10807),
    [sym__type_order_operator] = ACTIONS(10807),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym__terminator_token1] = ACTIONS(10811),
    [aux_sym__terminator_token2] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7468] = {
    [sym_block_comment] = STATE(7468),
    [sym_line_comment] = STATE(7468),
    [aux_sym_export_statement_repeat1] = STATE(7639),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(11460),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_catch] = ACTIONS(10813),
    [anon_sym_finally] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10813),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10813),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10813),
    [anon_sym_DOLLAR] = ACTIONS(10813),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10813),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10813),
    [anon_sym_QMARK] = ACTIONS(10813),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10813),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10813),
    [aux_sym_integer_literal_token2] = ACTIONS(10813),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10813),
    [aux_sym_float_literal_token3] = ACTIONS(10813),
    [aux_sym_float_literal_token4] = ACTIONS(10813),
    [sym_character_literal] = ACTIONS(10813),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10813),
    [sym__pair_operator] = ACTIONS(10813),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10813),
    [sym__lazy_and_operator] = ACTIONS(10813),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10813),
    [sym__pipe_left_operator] = ACTIONS(10813),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10813),
    [sym__bitshift_operator] = ACTIONS(10813),
    [sym__power_operator] = ACTIONS(10813),
    [sym__tilde_operator] = ACTIONS(10813),
    [sym__type_order_operator] = ACTIONS(10813),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym__terminator_token1] = ACTIONS(10815),
    [aux_sym__terminator_token2] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7469] = {
    [sym_block_comment] = STATE(7469),
    [sym_line_comment] = STATE(7469),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7470] = {
    [sym_block_comment] = STATE(7470),
    [sym_line_comment] = STATE(7470),
    [aux_sym__import_list_repeat1] = STATE(7651),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10868),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_catch] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7471] = {
    [sym__comprehension_clause] = STATE(18980),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7471),
    [sym_line_comment] = STATE(7471),
    [aux_sym_vector_expression_repeat1] = STATE(17402),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11462),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11464),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11466),
    [aux_sym__terminator_token2] = ACTIONS(11469),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7472] = {
    [sym_block_comment] = STATE(7472),
    [sym_line_comment] = STATE(7472),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7473] = {
    [sym_block_comment] = STATE(7473),
    [sym_line_comment] = STATE(7473),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_catch] = ACTIONS(10757),
    [anon_sym_finally] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7474] = {
    [sym_block_comment] = STATE(7474),
    [sym_line_comment] = STATE(7474),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7475] = {
    [sym_block_comment] = STATE(7475),
    [sym_line_comment] = STATE(7475),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11472),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_end] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_else] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_finally] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11472),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11472),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11472),
    [anon_sym_DOLLAR] = ACTIONS(11472),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11472),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11472),
    [anon_sym_QMARK] = ACTIONS(11472),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11472),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11472),
    [aux_sym_integer_literal_token2] = ACTIONS(11472),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11472),
    [aux_sym_float_literal_token3] = ACTIONS(11472),
    [aux_sym_float_literal_token4] = ACTIONS(11472),
    [sym_character_literal] = ACTIONS(11472),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11472),
    [sym__pair_operator] = ACTIONS(11472),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11472),
    [sym__lazy_and_operator] = ACTIONS(11472),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11472),
    [sym__pipe_left_operator] = ACTIONS(11472),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11472),
    [sym__bitshift_operator] = ACTIONS(11472),
    [sym__power_operator] = ACTIONS(11472),
    [sym__tilde_operator] = ACTIONS(11472),
    [sym__type_order_operator] = ACTIONS(11472),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym__terminator_token1] = ACTIONS(11474),
    [aux_sym__terminator_token2] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7476] = {
    [sym_block_comment] = STATE(7476),
    [sym_line_comment] = STATE(7476),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_elseif] = ACTIONS(10908),
    [anon_sym_else] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7477] = {
    [sym_block_comment] = STATE(7477),
    [sym_line_comment] = STATE(7477),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7478] = {
    [sym_block_comment] = STATE(7478),
    [sym_line_comment] = STATE(7478),
    [aux_sym_export_statement_repeat1] = STATE(7478),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(11476),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10855),
    [anon_sym_RPAREN] = ACTIONS(10855),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10855),
    [anon_sym_RBRACK] = ACTIONS(10855),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_SEMI] = ACTIONS(10855),
    [anon_sym_LBRACE] = ACTIONS(10855),
    [anon_sym_RBRACE] = ACTIONS(10855),
    [anon_sym_DOLLAR] = ACTIONS(10855),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10855),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10855),
    [anon_sym_QMARK] = ACTIONS(10855),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10855),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10855),
    [aux_sym_integer_literal_token2] = ACTIONS(10855),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10855),
    [aux_sym_float_literal_token3] = ACTIONS(10855),
    [aux_sym_float_literal_token4] = ACTIONS(10855),
    [sym_character_literal] = ACTIONS(10855),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10855),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10855),
    [sym__pair_operator] = ACTIONS(10855),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10855),
    [sym__lazy_and_operator] = ACTIONS(10855),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10855),
    [sym__pipe_left_operator] = ACTIONS(10855),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10855),
    [sym__bitshift_operator] = ACTIONS(10855),
    [sym__power_operator] = ACTIONS(10855),
    [sym__tilde_operator] = ACTIONS(10855),
    [sym__type_order_operator] = ACTIONS(10855),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7479] = {
    [sym_block_comment] = STATE(7479),
    [sym_line_comment] = STATE(7479),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7480] = {
    [sym_block_comment] = STATE(7480),
    [sym_line_comment] = STATE(7480),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [7481] = {
    [sym_block_comment] = STATE(7481),
    [sym_line_comment] = STATE(7481),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11283),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_end] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_elseif] = ACTIONS(11283),
    [anon_sym_else] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11283),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11283),
    [anon_sym_DOLLAR] = ACTIONS(11283),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11283),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11283),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11283),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11283),
    [aux_sym_integer_literal_token2] = ACTIONS(11283),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11283),
    [aux_sym_float_literal_token3] = ACTIONS(11283),
    [aux_sym_float_literal_token4] = ACTIONS(11283),
    [sym_character_literal] = ACTIONS(11283),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11283),
    [sym__pair_operator] = ACTIONS(11283),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11283),
    [sym__lazy_and_operator] = ACTIONS(11283),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11283),
    [sym__pipe_left_operator] = ACTIONS(11283),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11283),
    [sym__bitshift_operator] = ACTIONS(11283),
    [sym__power_operator] = ACTIONS(11283),
    [sym__tilde_operator] = ACTIONS(11283),
    [sym__type_order_operator] = ACTIONS(11283),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym__terminator_token1] = ACTIONS(11285),
    [aux_sym__terminator_token2] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7482] = {
    [sym_block_comment] = STATE(7482),
    [sym_line_comment] = STATE(7482),
    [aux_sym_export_statement_repeat1] = STATE(7547),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(11313),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_catch] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10876),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10876),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(10876),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10876),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10876),
    [anon_sym_QMARK] = ACTIONS(10876),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10876),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10876),
    [aux_sym_integer_literal_token2] = ACTIONS(10876),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10876),
    [aux_sym_float_literal_token3] = ACTIONS(10876),
    [aux_sym_float_literal_token4] = ACTIONS(10876),
    [sym_character_literal] = ACTIONS(10876),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10876),
    [sym__pair_operator] = ACTIONS(10876),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10876),
    [sym__lazy_and_operator] = ACTIONS(10876),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10876),
    [sym__pipe_left_operator] = ACTIONS(10876),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10876),
    [sym__bitshift_operator] = ACTIONS(10876),
    [sym__power_operator] = ACTIONS(10876),
    [sym__tilde_operator] = ACTIONS(10876),
    [sym__type_order_operator] = ACTIONS(10876),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym__terminator_token1] = ACTIONS(10878),
    [aux_sym__terminator_token2] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7483] = {
    [sym_block_comment] = STATE(7483),
    [sym_line_comment] = STATE(7483),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7484] = {
    [sym_block_comment] = STATE(7484),
    [sym_line_comment] = STATE(7484),
    [aux_sym_export_statement_repeat1] = STATE(7547),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(11313),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_end] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_catch] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10880),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10880),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10880),
    [anon_sym_DOLLAR] = ACTIONS(10880),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10880),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10880),
    [anon_sym_QMARK] = ACTIONS(10880),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10880),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10880),
    [aux_sym_integer_literal_token2] = ACTIONS(10880),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10880),
    [aux_sym_float_literal_token3] = ACTIONS(10880),
    [aux_sym_float_literal_token4] = ACTIONS(10880),
    [sym_character_literal] = ACTIONS(10880),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10880),
    [sym__pair_operator] = ACTIONS(10880),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10880),
    [sym__lazy_and_operator] = ACTIONS(10880),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10880),
    [sym__pipe_left_operator] = ACTIONS(10880),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10880),
    [sym__bitshift_operator] = ACTIONS(10880),
    [sym__power_operator] = ACTIONS(10880),
    [sym__tilde_operator] = ACTIONS(10880),
    [sym__type_order_operator] = ACTIONS(10880),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym__terminator_token1] = ACTIONS(10882),
    [aux_sym__terminator_token2] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7485] = {
    [sym_block_comment] = STATE(7485),
    [sym_line_comment] = STATE(7485),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7486] = {
    [sym_block_comment] = STATE(7486),
    [sym_line_comment] = STATE(7486),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10817),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7487] = {
    [sym_block_comment] = STATE(7487),
    [sym_line_comment] = STATE(7487),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7488] = {
    [sym_block_comment] = STATE(7488),
    [sym_line_comment] = STATE(7488),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7489] = {
    [sym_block_comment] = STATE(7489),
    [sym_line_comment] = STATE(7489),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7490] = {
    [sym_block_comment] = STATE(7490),
    [sym_line_comment] = STATE(7490),
    [aux_sym__import_list_repeat1] = STATE(7607),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(10819),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_end] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_catch] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10884),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10884),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(10884),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10884),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10884),
    [anon_sym_QMARK] = ACTIONS(10884),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10884),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10884),
    [aux_sym_integer_literal_token2] = ACTIONS(10884),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10884),
    [aux_sym_float_literal_token3] = ACTIONS(10884),
    [aux_sym_float_literal_token4] = ACTIONS(10884),
    [sym_character_literal] = ACTIONS(10884),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10884),
    [sym__pair_operator] = ACTIONS(10884),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10884),
    [sym__lazy_and_operator] = ACTIONS(10884),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10884),
    [sym__pipe_left_operator] = ACTIONS(10884),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10884),
    [sym__bitshift_operator] = ACTIONS(10884),
    [sym__power_operator] = ACTIONS(10884),
    [sym__tilde_operator] = ACTIONS(10884),
    [sym__type_order_operator] = ACTIONS(10884),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym__terminator_token1] = ACTIONS(10886),
    [aux_sym__terminator_token2] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7491] = {
    [sym__comprehension_clause] = STATE(19419),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7491),
    [sym_line_comment] = STATE(7491),
    [aux_sym_vector_expression_repeat1] = STATE(17532),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11479),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11481),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11483),
    [aux_sym__terminator_token2] = ACTIONS(11486),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7492] = {
    [sym_block_comment] = STATE(7492),
    [sym_line_comment] = STATE(7492),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9674),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7493] = {
    [sym_block_comment] = STATE(7493),
    [sym_line_comment] = STATE(7493),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9674),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7494] = {
    [sym__comprehension_clause] = STATE(18765),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7494),
    [sym_line_comment] = STATE(7494),
    [aux_sym_vector_expression_repeat1] = STATE(17283),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11489),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11491),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11493),
    [aux_sym__terminator_token2] = ACTIONS(11496),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7495] = {
    [sym_block_comment] = STATE(7495),
    [sym_line_comment] = STATE(7495),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7496] = {
    [sym_block_comment] = STATE(7496),
    [sym_line_comment] = STATE(7496),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7497] = {
    [sym_block_comment] = STATE(7497),
    [sym_line_comment] = STATE(7497),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10092),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9722),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7498] = {
    [sym_block_comment] = STATE(7498),
    [sym_line_comment] = STATE(7498),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11499),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_end] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_else] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_finally] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11499),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11499),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11499),
    [anon_sym_DOLLAR] = ACTIONS(11499),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11499),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11499),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11499),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11499),
    [aux_sym_integer_literal_token2] = ACTIONS(11499),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11499),
    [aux_sym_float_literal_token3] = ACTIONS(11499),
    [aux_sym_float_literal_token4] = ACTIONS(11499),
    [sym_character_literal] = ACTIONS(11499),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11499),
    [sym__pair_operator] = ACTIONS(11499),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11499),
    [sym__lazy_and_operator] = ACTIONS(11499),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11499),
    [sym__pipe_left_operator] = ACTIONS(11499),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11499),
    [sym__bitshift_operator] = ACTIONS(11499),
    [sym__power_operator] = ACTIONS(11499),
    [sym__tilde_operator] = ACTIONS(11499),
    [sym__type_order_operator] = ACTIONS(11499),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym__terminator_token1] = ACTIONS(11501),
    [aux_sym__terminator_token2] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7499] = {
    [sym_block_comment] = STATE(7499),
    [sym_line_comment] = STATE(7499),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7500] = {
    [sym__comprehension_clause] = STATE(18379),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7500),
    [sym_line_comment] = STATE(7500),
    [aux_sym_vector_expression_repeat1] = STATE(17106),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11503),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11505),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11507),
    [aux_sym__terminator_token2] = ACTIONS(11510),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7501] = {
    [sym_block_comment] = STATE(7501),
    [sym_line_comment] = STATE(7501),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9674),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7502] = {
    [sym_block_comment] = STATE(7502),
    [sym_line_comment] = STATE(7502),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7503] = {
    [sym_block_comment] = STATE(7503),
    [sym_line_comment] = STATE(7503),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10092),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9848),
  },
  [7504] = {
    [sym_block_comment] = STATE(7504),
    [sym_line_comment] = STATE(7504),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_else] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7505] = {
    [sym_block_comment] = STATE(7505),
    [sym_line_comment] = STATE(7505),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7506] = {
    [sym_block_comment] = STATE(7506),
    [sym_line_comment] = STATE(7506),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11513),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_end] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_else] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_finally] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11513),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11513),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11513),
    [anon_sym_DOLLAR] = ACTIONS(11513),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11513),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11513),
    [anon_sym_QMARK] = ACTIONS(11513),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11513),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11513),
    [aux_sym_integer_literal_token2] = ACTIONS(11513),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11513),
    [aux_sym_float_literal_token3] = ACTIONS(11513),
    [aux_sym_float_literal_token4] = ACTIONS(11513),
    [sym_character_literal] = ACTIONS(11513),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11513),
    [sym__pair_operator] = ACTIONS(11513),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11513),
    [sym__lazy_and_operator] = ACTIONS(11513),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11513),
    [sym__pipe_left_operator] = ACTIONS(11513),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11513),
    [sym__bitshift_operator] = ACTIONS(11513),
    [sym__power_operator] = ACTIONS(11513),
    [sym__tilde_operator] = ACTIONS(11513),
    [sym__type_order_operator] = ACTIONS(11513),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym__terminator_token1] = ACTIONS(11515),
    [aux_sym__terminator_token2] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7507] = {
    [sym_block_comment] = STATE(7507),
    [sym_line_comment] = STATE(7507),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_finally] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7508] = {
    [sym_block_comment] = STATE(7508),
    [sym_line_comment] = STATE(7508),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11517),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_end] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_else] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_finally] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11517),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11517),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11517),
    [anon_sym_DOLLAR] = ACTIONS(11517),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11517),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11517),
    [anon_sym_QMARK] = ACTIONS(11517),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11517),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11517),
    [aux_sym_integer_literal_token2] = ACTIONS(11517),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11517),
    [aux_sym_float_literal_token3] = ACTIONS(11517),
    [aux_sym_float_literal_token4] = ACTIONS(11517),
    [sym_character_literal] = ACTIONS(11517),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11517),
    [sym__pair_operator] = ACTIONS(11517),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11517),
    [sym__lazy_and_operator] = ACTIONS(11517),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11517),
    [sym__pipe_left_operator] = ACTIONS(11517),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11517),
    [sym__bitshift_operator] = ACTIONS(11517),
    [sym__power_operator] = ACTIONS(11517),
    [sym__tilde_operator] = ACTIONS(11517),
    [sym__type_order_operator] = ACTIONS(11517),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym__terminator_token1] = ACTIONS(11519),
    [aux_sym__terminator_token2] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7509] = {
    [sym_block_comment] = STATE(7509),
    [sym_line_comment] = STATE(7509),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7510] = {
    [sym_block_comment] = STATE(7510),
    [sym_line_comment] = STATE(7510),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10863),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(10801),
    [anon_sym_LPAREN] = ACTIONS(10863),
    [anon_sym_RPAREN] = ACTIONS(10863),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10863),
    [anon_sym_RBRACK] = ACTIONS(10863),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_SEMI] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(10863),
    [anon_sym_RBRACE] = ACTIONS(10863),
    [anon_sym_DOLLAR] = ACTIONS(10863),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10863),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10863),
    [anon_sym_QMARK] = ACTIONS(10863),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10863),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10863),
    [aux_sym_integer_literal_token2] = ACTIONS(10863),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10863),
    [aux_sym_float_literal_token3] = ACTIONS(10863),
    [aux_sym_float_literal_token4] = ACTIONS(10863),
    [sym_character_literal] = ACTIONS(10863),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10863),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10863),
    [sym__pair_operator] = ACTIONS(10863),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10863),
    [sym__lazy_and_operator] = ACTIONS(10863),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10863),
    [sym__pipe_left_operator] = ACTIONS(10863),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10863),
    [sym__bitshift_operator] = ACTIONS(10863),
    [sym__power_operator] = ACTIONS(10863),
    [sym__tilde_operator] = ACTIONS(10863),
    [sym__type_order_operator] = ACTIONS(10863),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7511] = {
    [sym_block_comment] = STATE(7511),
    [sym_line_comment] = STATE(7511),
    [aux_sym__import_list_repeat1] = STATE(7511),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(11521),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10863),
    [anon_sym_RPAREN] = ACTIONS(10863),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10863),
    [anon_sym_RBRACK] = ACTIONS(10863),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_SEMI] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(10863),
    [anon_sym_RBRACE] = ACTIONS(10863),
    [anon_sym_DOLLAR] = ACTIONS(10863),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10863),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10863),
    [anon_sym_QMARK] = ACTIONS(10863),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10863),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10863),
    [aux_sym_integer_literal_token2] = ACTIONS(10863),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10863),
    [aux_sym_float_literal_token3] = ACTIONS(10863),
    [aux_sym_float_literal_token4] = ACTIONS(10863),
    [sym_character_literal] = ACTIONS(10863),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10863),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10863),
    [sym__pair_operator] = ACTIONS(10863),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10863),
    [sym__lazy_and_operator] = ACTIONS(10863),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10863),
    [sym__pipe_left_operator] = ACTIONS(10863),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10863),
    [sym__bitshift_operator] = ACTIONS(10863),
    [sym__power_operator] = ACTIONS(10863),
    [sym__tilde_operator] = ACTIONS(10863),
    [sym__type_order_operator] = ACTIONS(10863),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7512] = {
    [sym_block_comment] = STATE(7512),
    [sym_line_comment] = STATE(7512),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11472),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_end] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_elseif] = ACTIONS(11472),
    [anon_sym_else] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11472),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11472),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11472),
    [anon_sym_DOLLAR] = ACTIONS(11472),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11472),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11472),
    [anon_sym_QMARK] = ACTIONS(11472),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11472),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11472),
    [aux_sym_integer_literal_token2] = ACTIONS(11472),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11472),
    [aux_sym_float_literal_token3] = ACTIONS(11472),
    [aux_sym_float_literal_token4] = ACTIONS(11472),
    [sym_character_literal] = ACTIONS(11472),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11472),
    [sym__pair_operator] = ACTIONS(11472),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11472),
    [sym__lazy_and_operator] = ACTIONS(11472),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11472),
    [sym__pipe_left_operator] = ACTIONS(11472),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11472),
    [sym__bitshift_operator] = ACTIONS(11472),
    [sym__power_operator] = ACTIONS(11472),
    [sym__tilde_operator] = ACTIONS(11472),
    [sym__type_order_operator] = ACTIONS(11472),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym__terminator_token1] = ACTIONS(11474),
    [aux_sym__terminator_token2] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7513] = {
    [sym_block_comment] = STATE(7513),
    [sym_line_comment] = STATE(7513),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7514] = {
    [sym_block_comment] = STATE(7514),
    [sym_line_comment] = STATE(7514),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_finally] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7515] = {
    [sym_block_comment] = STATE(7515),
    [sym_line_comment] = STATE(7515),
    [ts_builtin_sym_end] = ACTIONS(10579),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_RBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7516] = {
    [sym_block_comment] = STATE(7516),
    [sym_line_comment] = STATE(7516),
    [aux_sym_export_statement_repeat1] = STATE(7740),
    [ts_builtin_sym_end] = ACTIONS(10811),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(11524),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10807),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10807),
    [anon_sym_RBRACK] = ACTIONS(10807),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10807),
    [anon_sym_DOLLAR] = ACTIONS(10807),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10807),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10807),
    [anon_sym_QMARK] = ACTIONS(10807),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10807),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10807),
    [aux_sym_integer_literal_token2] = ACTIONS(10807),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10807),
    [aux_sym_float_literal_token3] = ACTIONS(10807),
    [aux_sym_float_literal_token4] = ACTIONS(10807),
    [sym_character_literal] = ACTIONS(10807),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10807),
    [sym__pair_operator] = ACTIONS(10807),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10807),
    [sym__lazy_and_operator] = ACTIONS(10807),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10807),
    [sym__pipe_left_operator] = ACTIONS(10807),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10807),
    [sym__bitshift_operator] = ACTIONS(10807),
    [sym__power_operator] = ACTIONS(10807),
    [sym__tilde_operator] = ACTIONS(10807),
    [sym__type_order_operator] = ACTIONS(10807),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym__terminator_token1] = ACTIONS(10811),
    [aux_sym__terminator_token2] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7517] = {
    [sym_block_comment] = STATE(7517),
    [sym_line_comment] = STATE(7517),
    [aux_sym_export_statement_repeat1] = STATE(7741),
    [ts_builtin_sym_end] = ACTIONS(10815),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(11524),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10813),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10813),
    [anon_sym_RBRACK] = ACTIONS(10813),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10813),
    [anon_sym_DOLLAR] = ACTIONS(10813),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10813),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10813),
    [anon_sym_QMARK] = ACTIONS(10813),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10813),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10813),
    [aux_sym_integer_literal_token2] = ACTIONS(10813),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10813),
    [aux_sym_float_literal_token3] = ACTIONS(10813),
    [aux_sym_float_literal_token4] = ACTIONS(10813),
    [sym_character_literal] = ACTIONS(10813),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10813),
    [sym__pair_operator] = ACTIONS(10813),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10813),
    [sym__lazy_and_operator] = ACTIONS(10813),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10813),
    [sym__pipe_left_operator] = ACTIONS(10813),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10813),
    [sym__bitshift_operator] = ACTIONS(10813),
    [sym__power_operator] = ACTIONS(10813),
    [sym__tilde_operator] = ACTIONS(10813),
    [sym__type_order_operator] = ACTIONS(10813),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym__terminator_token1] = ACTIONS(10815),
    [aux_sym__terminator_token2] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7518] = {
    [sym_block_comment] = STATE(7518),
    [sym_line_comment] = STATE(7518),
    [aux_sym_export_statement_repeat1] = STATE(7747),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(11315),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10815),
    [anon_sym_RPAREN] = ACTIONS(10815),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10815),
    [anon_sym_RBRACK] = ACTIONS(10815),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_SEMI] = ACTIONS(10815),
    [anon_sym_LBRACE] = ACTIONS(10815),
    [anon_sym_RBRACE] = ACTIONS(10815),
    [anon_sym_DOLLAR] = ACTIONS(10815),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10815),
    [anon_sym_QMARK] = ACTIONS(10815),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10815),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10815),
    [aux_sym_integer_literal_token2] = ACTIONS(10815),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10815),
    [aux_sym_float_literal_token3] = ACTIONS(10815),
    [aux_sym_float_literal_token4] = ACTIONS(10815),
    [sym_character_literal] = ACTIONS(10815),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10815),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10815),
    [sym__pair_operator] = ACTIONS(10815),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10815),
    [sym__lazy_and_operator] = ACTIONS(10815),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10815),
    [sym__pipe_left_operator] = ACTIONS(10815),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10815),
    [sym__bitshift_operator] = ACTIONS(10815),
    [sym__power_operator] = ACTIONS(10815),
    [sym__tilde_operator] = ACTIONS(10815),
    [sym__type_order_operator] = ACTIONS(10815),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7519] = {
    [sym_block_comment] = STATE(7519),
    [sym_line_comment] = STATE(7519),
    [aux_sym__import_list_repeat1] = STATE(7743),
    [ts_builtin_sym_end] = ACTIONS(10755),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10917),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_RBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7520] = {
    [sym_block_comment] = STATE(7520),
    [sym_line_comment] = STATE(7520),
    [ts_builtin_sym_end] = ACTIONS(10759),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_RBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7521] = {
    [sym_block_comment] = STATE(7521),
    [sym_line_comment] = STATE(7521),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11526),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_end] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_else] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_finally] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11526),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11526),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11526),
    [anon_sym_DOLLAR] = ACTIONS(11526),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11526),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11526),
    [anon_sym_QMARK] = ACTIONS(11526),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11526),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11526),
    [aux_sym_integer_literal_token2] = ACTIONS(11526),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11526),
    [aux_sym_float_literal_token3] = ACTIONS(11526),
    [aux_sym_float_literal_token4] = ACTIONS(11526),
    [sym_character_literal] = ACTIONS(11526),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11526),
    [sym__pair_operator] = ACTIONS(11526),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11526),
    [sym__lazy_and_operator] = ACTIONS(11526),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11526),
    [sym__pipe_left_operator] = ACTIONS(11526),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11526),
    [sym__bitshift_operator] = ACTIONS(11526),
    [sym__power_operator] = ACTIONS(11526),
    [sym__tilde_operator] = ACTIONS(11526),
    [sym__type_order_operator] = ACTIONS(11526),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym__terminator_token1] = ACTIONS(11528),
    [aux_sym__terminator_token2] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7522] = {
    [sym_block_comment] = STATE(7522),
    [sym_line_comment] = STATE(7522),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11530),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_end] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_else] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_finally] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11530),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11530),
    [anon_sym_DOLLAR] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11530),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11530),
    [anon_sym_QMARK] = ACTIONS(11530),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11530),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11530),
    [aux_sym_integer_literal_token2] = ACTIONS(11530),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11530),
    [aux_sym_float_literal_token3] = ACTIONS(11530),
    [aux_sym_float_literal_token4] = ACTIONS(11530),
    [sym_character_literal] = ACTIONS(11530),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11530),
    [sym__pair_operator] = ACTIONS(11530),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11530),
    [sym__lazy_and_operator] = ACTIONS(11530),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11530),
    [sym__pipe_left_operator] = ACTIONS(11530),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11530),
    [sym__bitshift_operator] = ACTIONS(11530),
    [sym__power_operator] = ACTIONS(11530),
    [sym__tilde_operator] = ACTIONS(11530),
    [sym__type_order_operator] = ACTIONS(11530),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym__terminator_token1] = ACTIONS(11532),
    [aux_sym__terminator_token2] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7523] = {
    [sym_block_comment] = STATE(7523),
    [sym_line_comment] = STATE(7523),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_catch] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7524] = {
    [sym_block_comment] = STATE(7524),
    [sym_line_comment] = STATE(7524),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11534),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_end] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_else] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_finally] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11534),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11534),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11534),
    [anon_sym_DOLLAR] = ACTIONS(11534),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11534),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11534),
    [anon_sym_QMARK] = ACTIONS(11534),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11534),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11534),
    [aux_sym_integer_literal_token2] = ACTIONS(11534),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11534),
    [aux_sym_float_literal_token3] = ACTIONS(11534),
    [aux_sym_float_literal_token4] = ACTIONS(11534),
    [sym_character_literal] = ACTIONS(11534),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11534),
    [sym__pair_operator] = ACTIONS(11534),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11534),
    [sym__lazy_and_operator] = ACTIONS(11534),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11534),
    [sym__pipe_left_operator] = ACTIONS(11534),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11534),
    [sym__bitshift_operator] = ACTIONS(11534),
    [sym__power_operator] = ACTIONS(11534),
    [sym__tilde_operator] = ACTIONS(11534),
    [sym__type_order_operator] = ACTIONS(11534),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym__terminator_token1] = ACTIONS(11536),
    [aux_sym__terminator_token2] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7525] = {
    [sym_block_comment] = STATE(7525),
    [sym_line_comment] = STATE(7525),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11499),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_end] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_elseif] = ACTIONS(11499),
    [anon_sym_else] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11499),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11499),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11499),
    [anon_sym_DOLLAR] = ACTIONS(11499),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11499),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11499),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11499),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11499),
    [aux_sym_integer_literal_token2] = ACTIONS(11499),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11499),
    [aux_sym_float_literal_token3] = ACTIONS(11499),
    [aux_sym_float_literal_token4] = ACTIONS(11499),
    [sym_character_literal] = ACTIONS(11499),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11499),
    [sym__pair_operator] = ACTIONS(11499),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11499),
    [sym__lazy_and_operator] = ACTIONS(11499),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11499),
    [sym__pipe_left_operator] = ACTIONS(11499),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11499),
    [sym__bitshift_operator] = ACTIONS(11499),
    [sym__power_operator] = ACTIONS(11499),
    [sym__tilde_operator] = ACTIONS(11499),
    [sym__type_order_operator] = ACTIONS(11499),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym__terminator_token1] = ACTIONS(11501),
    [aux_sym__terminator_token2] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7526] = {
    [sym_block_comment] = STATE(7526),
    [sym_line_comment] = STATE(7526),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7527] = {
    [sym__comprehension_clause] = STATE(18593),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7527),
    [sym_line_comment] = STATE(7527),
    [aux_sym_vector_expression_repeat1] = STATE(17197),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11538),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11540),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11542),
    [aux_sym__terminator_token2] = ACTIONS(11545),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7528] = {
    [sym_block_comment] = STATE(7528),
    [sym_line_comment] = STATE(7528),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7529] = {
    [sym_block_comment] = STATE(7529),
    [sym_line_comment] = STATE(7529),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_catch] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7530] = {
    [sym_block_comment] = STATE(7530),
    [sym_line_comment] = STATE(7530),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9688),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7531] = {
    [sym_block_comment] = STATE(7531),
    [sym_line_comment] = STATE(7531),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
  },
  [7532] = {
    [sym_block_comment] = STATE(7532),
    [sym_line_comment] = STATE(7532),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_finally] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7533] = {
    [sym_block_comment] = STATE(7533),
    [sym_line_comment] = STATE(7533),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11513),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_end] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_elseif] = ACTIONS(11513),
    [anon_sym_else] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11513),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11513),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11513),
    [anon_sym_DOLLAR] = ACTIONS(11513),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11513),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11513),
    [anon_sym_QMARK] = ACTIONS(11513),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11513),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11513),
    [aux_sym_integer_literal_token2] = ACTIONS(11513),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11513),
    [aux_sym_float_literal_token3] = ACTIONS(11513),
    [aux_sym_float_literal_token4] = ACTIONS(11513),
    [sym_character_literal] = ACTIONS(11513),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11513),
    [sym__pair_operator] = ACTIONS(11513),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11513),
    [sym__lazy_and_operator] = ACTIONS(11513),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11513),
    [sym__pipe_left_operator] = ACTIONS(11513),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11513),
    [sym__bitshift_operator] = ACTIONS(11513),
    [sym__power_operator] = ACTIONS(11513),
    [sym__tilde_operator] = ACTIONS(11513),
    [sym__type_order_operator] = ACTIONS(11513),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym__terminator_token1] = ACTIONS(11515),
    [aux_sym__terminator_token2] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7534] = {
    [sym_block_comment] = STATE(7534),
    [sym_line_comment] = STATE(7534),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_finally] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7535] = {
    [sym_block_comment] = STATE(7535),
    [sym_line_comment] = STATE(7535),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11526),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_end] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_elseif] = ACTIONS(11526),
    [anon_sym_else] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11526),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11526),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11526),
    [anon_sym_DOLLAR] = ACTIONS(11526),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11526),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11526),
    [anon_sym_QMARK] = ACTIONS(11526),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11526),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11526),
    [aux_sym_integer_literal_token2] = ACTIONS(11526),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11526),
    [aux_sym_float_literal_token3] = ACTIONS(11526),
    [aux_sym_float_literal_token4] = ACTIONS(11526),
    [sym_character_literal] = ACTIONS(11526),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11526),
    [sym__pair_operator] = ACTIONS(11526),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11526),
    [sym__lazy_and_operator] = ACTIONS(11526),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11526),
    [sym__pipe_left_operator] = ACTIONS(11526),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11526),
    [sym__bitshift_operator] = ACTIONS(11526),
    [sym__power_operator] = ACTIONS(11526),
    [sym__tilde_operator] = ACTIONS(11526),
    [sym__type_order_operator] = ACTIONS(11526),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym__terminator_token1] = ACTIONS(11528),
    [aux_sym__terminator_token2] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7536] = {
    [sym_block_comment] = STATE(7536),
    [sym_line_comment] = STATE(7536),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11548),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_end] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_else] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_finally] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11548),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11548),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11548),
    [anon_sym_DOLLAR] = ACTIONS(11548),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11548),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11548),
    [anon_sym_QMARK] = ACTIONS(11548),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11548),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11548),
    [aux_sym_integer_literal_token2] = ACTIONS(11548),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11548),
    [aux_sym_float_literal_token3] = ACTIONS(11548),
    [aux_sym_float_literal_token4] = ACTIONS(11548),
    [sym_character_literal] = ACTIONS(11548),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11548),
    [sym__pair_operator] = ACTIONS(11548),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11548),
    [sym__lazy_and_operator] = ACTIONS(11548),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11548),
    [sym__pipe_left_operator] = ACTIONS(11548),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11548),
    [sym__bitshift_operator] = ACTIONS(11548),
    [sym__power_operator] = ACTIONS(11548),
    [sym__tilde_operator] = ACTIONS(11548),
    [sym__type_order_operator] = ACTIONS(11548),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym__terminator_token1] = ACTIONS(11550),
    [aux_sym__terminator_token2] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7537] = {
    [sym_block_comment] = STATE(7537),
    [sym_line_comment] = STATE(7537),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11552),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_end] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_else] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_finally] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11552),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11552),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11552),
    [anon_sym_DOLLAR] = ACTIONS(11552),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11552),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11552),
    [anon_sym_QMARK] = ACTIONS(11552),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11552),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11552),
    [aux_sym_integer_literal_token2] = ACTIONS(11552),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11552),
    [aux_sym_float_literal_token3] = ACTIONS(11552),
    [aux_sym_float_literal_token4] = ACTIONS(11552),
    [sym_character_literal] = ACTIONS(11552),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11552),
    [sym__pair_operator] = ACTIONS(11552),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11552),
    [sym__lazy_and_operator] = ACTIONS(11552),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11552),
    [sym__pipe_left_operator] = ACTIONS(11552),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11552),
    [sym__bitshift_operator] = ACTIONS(11552),
    [sym__power_operator] = ACTIONS(11552),
    [sym__tilde_operator] = ACTIONS(11552),
    [sym__type_order_operator] = ACTIONS(11552),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym__terminator_token1] = ACTIONS(11554),
    [aux_sym__terminator_token2] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7538] = {
    [sym_block_comment] = STATE(7538),
    [sym_line_comment] = STATE(7538),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_finally] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7539] = {
    [sym_block_comment] = STATE(7539),
    [sym_line_comment] = STATE(7539),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_finally] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7540] = {
    [sym_block_comment] = STATE(7540),
    [sym_line_comment] = STATE(7540),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10850),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_elseif] = ACTIONS(10850),
    [anon_sym_else] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7541] = {
    [sym_block_comment] = STATE(7541),
    [sym_line_comment] = STATE(7541),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_finally] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7542] = {
    [sym_block_comment] = STATE(7542),
    [sym_line_comment] = STATE(7542),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7543] = {
    [sym_block_comment] = STATE(7543),
    [sym_line_comment] = STATE(7543),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7544] = {
    [sym_block_comment] = STATE(7544),
    [sym_line_comment] = STATE(7544),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7545] = {
    [sym_block_comment] = STATE(7545),
    [sym_line_comment] = STATE(7545),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_catch] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7546] = {
    [sym_block_comment] = STATE(7546),
    [sym_line_comment] = STATE(7546),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7547] = {
    [sym_block_comment] = STATE(7547),
    [sym_line_comment] = STATE(7547),
    [aux_sym_export_statement_repeat1] = STATE(7547),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(11556),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_catch] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7548] = {
    [sym_block_comment] = STATE(7548),
    [sym_line_comment] = STATE(7548),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7549] = {
    [sym_block_comment] = STATE(7549),
    [sym_line_comment] = STATE(7549),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
  },
  [7550] = {
    [sym_block_comment] = STATE(7550),
    [sym_line_comment] = STATE(7550),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7551] = {
    [sym_block_comment] = STATE(7551),
    [sym_line_comment] = STATE(7551),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7552] = {
    [sym_block_comment] = STATE(7552),
    [sym_line_comment] = STATE(7552),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11559),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_end] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_else] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_finally] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11559),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11559),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11559),
    [anon_sym_DOLLAR] = ACTIONS(11559),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11559),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11559),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11559),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11559),
    [aux_sym_integer_literal_token2] = ACTIONS(11559),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11559),
    [aux_sym_float_literal_token3] = ACTIONS(11559),
    [aux_sym_float_literal_token4] = ACTIONS(11559),
    [sym_character_literal] = ACTIONS(11559),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11559),
    [sym__pair_operator] = ACTIONS(11559),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11559),
    [sym__lazy_and_operator] = ACTIONS(11559),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11559),
    [sym__pipe_left_operator] = ACTIONS(11559),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11559),
    [sym__bitshift_operator] = ACTIONS(11559),
    [sym__power_operator] = ACTIONS(11559),
    [sym__tilde_operator] = ACTIONS(11559),
    [sym__type_order_operator] = ACTIONS(11559),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym__terminator_token1] = ACTIONS(11561),
    [aux_sym__terminator_token2] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7553] = {
    [sym_block_comment] = STATE(7553),
    [sym_line_comment] = STATE(7553),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11563),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_end] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_else] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_finally] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11563),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11563),
    [anon_sym_DOLLAR] = ACTIONS(11563),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11563),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_QMARK] = ACTIONS(11563),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11563),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11563),
    [aux_sym_integer_literal_token2] = ACTIONS(11563),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11563),
    [aux_sym_float_literal_token3] = ACTIONS(11563),
    [aux_sym_float_literal_token4] = ACTIONS(11563),
    [sym_character_literal] = ACTIONS(11563),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11563),
    [sym__pair_operator] = ACTIONS(11563),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11563),
    [sym__lazy_and_operator] = ACTIONS(11563),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11563),
    [sym__pipe_left_operator] = ACTIONS(11563),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11563),
    [sym__bitshift_operator] = ACTIONS(11563),
    [sym__power_operator] = ACTIONS(11563),
    [sym__tilde_operator] = ACTIONS(11563),
    [sym__type_order_operator] = ACTIONS(11563),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym__terminator_token1] = ACTIONS(11565),
    [aux_sym__terminator_token2] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7554] = {
    [sym_block_comment] = STATE(7554),
    [sym_line_comment] = STATE(7554),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_else] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_finally] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7555] = {
    [sym_block_comment] = STATE(7555),
    [sym_line_comment] = STATE(7555),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11530),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_end] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_elseif] = ACTIONS(11530),
    [anon_sym_else] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11530),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11530),
    [anon_sym_DOLLAR] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11530),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11530),
    [anon_sym_QMARK] = ACTIONS(11530),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11530),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11530),
    [aux_sym_integer_literal_token2] = ACTIONS(11530),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11530),
    [aux_sym_float_literal_token3] = ACTIONS(11530),
    [aux_sym_float_literal_token4] = ACTIONS(11530),
    [sym_character_literal] = ACTIONS(11530),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11530),
    [sym__pair_operator] = ACTIONS(11530),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11530),
    [sym__lazy_and_operator] = ACTIONS(11530),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11530),
    [sym__pipe_left_operator] = ACTIONS(11530),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11530),
    [sym__bitshift_operator] = ACTIONS(11530),
    [sym__power_operator] = ACTIONS(11530),
    [sym__tilde_operator] = ACTIONS(11530),
    [sym__type_order_operator] = ACTIONS(11530),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym__terminator_token1] = ACTIONS(11532),
    [aux_sym__terminator_token2] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7556] = {
    [sym_block_comment] = STATE(7556),
    [sym_line_comment] = STATE(7556),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11534),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_end] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_elseif] = ACTIONS(11534),
    [anon_sym_else] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11534),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11534),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11534),
    [anon_sym_DOLLAR] = ACTIONS(11534),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11534),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11534),
    [anon_sym_QMARK] = ACTIONS(11534),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11534),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11534),
    [aux_sym_integer_literal_token2] = ACTIONS(11534),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11534),
    [aux_sym_float_literal_token3] = ACTIONS(11534),
    [aux_sym_float_literal_token4] = ACTIONS(11534),
    [sym_character_literal] = ACTIONS(11534),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11534),
    [sym__pair_operator] = ACTIONS(11534),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11534),
    [sym__lazy_and_operator] = ACTIONS(11534),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11534),
    [sym__pipe_left_operator] = ACTIONS(11534),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11534),
    [sym__bitshift_operator] = ACTIONS(11534),
    [sym__power_operator] = ACTIONS(11534),
    [sym__tilde_operator] = ACTIONS(11534),
    [sym__type_order_operator] = ACTIONS(11534),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym__terminator_token1] = ACTIONS(11536),
    [aux_sym__terminator_token2] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7557] = {
    [sym_block_comment] = STATE(7557),
    [sym_line_comment] = STATE(7557),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11548),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_end] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_elseif] = ACTIONS(11548),
    [anon_sym_else] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11548),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11548),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11548),
    [anon_sym_DOLLAR] = ACTIONS(11548),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11548),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11548),
    [anon_sym_QMARK] = ACTIONS(11548),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11548),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11548),
    [aux_sym_integer_literal_token2] = ACTIONS(11548),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11548),
    [aux_sym_float_literal_token3] = ACTIONS(11548),
    [aux_sym_float_literal_token4] = ACTIONS(11548),
    [sym_character_literal] = ACTIONS(11548),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11548),
    [sym__pair_operator] = ACTIONS(11548),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11548),
    [sym__lazy_and_operator] = ACTIONS(11548),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11548),
    [sym__pipe_left_operator] = ACTIONS(11548),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11548),
    [sym__bitshift_operator] = ACTIONS(11548),
    [sym__power_operator] = ACTIONS(11548),
    [sym__tilde_operator] = ACTIONS(11548),
    [sym__type_order_operator] = ACTIONS(11548),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym__terminator_token1] = ACTIONS(11550),
    [aux_sym__terminator_token2] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7558] = {
    [sym_block_comment] = STATE(7558),
    [sym_line_comment] = STATE(7558),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7559] = {
    [sym_block_comment] = STATE(7559),
    [sym_line_comment] = STATE(7559),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7560] = {
    [sym_block_comment] = STATE(7560),
    [sym_line_comment] = STATE(7560),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11567),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_end] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_else] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_finally] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11567),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11567),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11567),
    [anon_sym_DOLLAR] = ACTIONS(11567),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11567),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11567),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11567),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11567),
    [aux_sym_integer_literal_token2] = ACTIONS(11567),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11567),
    [aux_sym_float_literal_token3] = ACTIONS(11567),
    [aux_sym_float_literal_token4] = ACTIONS(11567),
    [sym_character_literal] = ACTIONS(11567),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11567),
    [sym__pair_operator] = ACTIONS(11567),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11567),
    [sym__lazy_and_operator] = ACTIONS(11567),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11567),
    [sym__pipe_left_operator] = ACTIONS(11567),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11567),
    [sym__bitshift_operator] = ACTIONS(11567),
    [sym__power_operator] = ACTIONS(11567),
    [sym__tilde_operator] = ACTIONS(11567),
    [sym__type_order_operator] = ACTIONS(11567),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym__terminator_token1] = ACTIONS(11569),
    [aux_sym__terminator_token2] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7561] = {
    [sym_block_comment] = STATE(7561),
    [sym_line_comment] = STATE(7561),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11552),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_end] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_elseif] = ACTIONS(11552),
    [anon_sym_else] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11552),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11552),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11552),
    [anon_sym_DOLLAR] = ACTIONS(11552),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11552),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11552),
    [anon_sym_QMARK] = ACTIONS(11552),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11552),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11552),
    [aux_sym_integer_literal_token2] = ACTIONS(11552),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11552),
    [aux_sym_float_literal_token3] = ACTIONS(11552),
    [aux_sym_float_literal_token4] = ACTIONS(11552),
    [sym_character_literal] = ACTIONS(11552),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11552),
    [sym__pair_operator] = ACTIONS(11552),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11552),
    [sym__lazy_and_operator] = ACTIONS(11552),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11552),
    [sym__pipe_left_operator] = ACTIONS(11552),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11552),
    [sym__bitshift_operator] = ACTIONS(11552),
    [sym__power_operator] = ACTIONS(11552),
    [sym__tilde_operator] = ACTIONS(11552),
    [sym__type_order_operator] = ACTIONS(11552),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym__terminator_token1] = ACTIONS(11554),
    [aux_sym__terminator_token2] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7562] = {
    [sym_block_comment] = STATE(7562),
    [sym_line_comment] = STATE(7562),
    [ts_builtin_sym_end] = ACTIONS(9644),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_RBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7563] = {
    [sym_block_comment] = STATE(7563),
    [sym_line_comment] = STATE(7563),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7564] = {
    [sym_block_comment] = STATE(7564),
    [sym_line_comment] = STATE(7564),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7565] = {
    [sym_block_comment] = STATE(7565),
    [sym_line_comment] = STATE(7565),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7566] = {
    [sym_block_comment] = STATE(7566),
    [sym_line_comment] = STATE(7566),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7567] = {
    [sym_block_comment] = STATE(7567),
    [sym_line_comment] = STATE(7567),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_RPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_RBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_SEMI] = ACTIONS(9984),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_RBRACE] = ACTIONS(9984),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7568] = {
    [sym_block_comment] = STATE(7568),
    [sym_line_comment] = STATE(7568),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7569] = {
    [sym_block_comment] = STATE(7569),
    [sym_line_comment] = STATE(7569),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7570] = {
    [sym_block_comment] = STATE(7570),
    [sym_line_comment] = STATE(7570),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_RPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_RBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_SEMI] = ACTIONS(9988),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_RBRACE] = ACTIONS(9988),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7571] = {
    [sym_block_comment] = STATE(7571),
    [sym_line_comment] = STATE(7571),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9668),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7572] = {
    [sym_block_comment] = STATE(7572),
    [sym_line_comment] = STATE(7572),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11571),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_end] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_else] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_finally] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11571),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11571),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11571),
    [anon_sym_DOLLAR] = ACTIONS(11571),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11571),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_QMARK] = ACTIONS(11571),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11571),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11571),
    [aux_sym_integer_literal_token2] = ACTIONS(11571),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11571),
    [aux_sym_float_literal_token3] = ACTIONS(11571),
    [aux_sym_float_literal_token4] = ACTIONS(11571),
    [sym_character_literal] = ACTIONS(11571),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11571),
    [sym__pair_operator] = ACTIONS(11571),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11571),
    [sym__lazy_and_operator] = ACTIONS(11571),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11571),
    [sym__pipe_left_operator] = ACTIONS(11571),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11571),
    [sym__bitshift_operator] = ACTIONS(11571),
    [sym__power_operator] = ACTIONS(11571),
    [sym__tilde_operator] = ACTIONS(11571),
    [sym__type_order_operator] = ACTIONS(11571),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym__terminator_token1] = ACTIONS(11573),
    [aux_sym__terminator_token2] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7573] = {
    [sym_block_comment] = STATE(7573),
    [sym_line_comment] = STATE(7573),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_RPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_RBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_SEMI] = ACTIONS(10002),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_RBRACE] = ACTIONS(10002),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7574] = {
    [sym_block_comment] = STATE(7574),
    [sym_line_comment] = STATE(7574),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_RPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_RBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_SEMI] = ACTIONS(10006),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_RBRACE] = ACTIONS(10006),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7575] = {
    [sym_block_comment] = STATE(7575),
    [sym_line_comment] = STATE(7575),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11559),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_end] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_elseif] = ACTIONS(11559),
    [anon_sym_else] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11559),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11559),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11559),
    [anon_sym_DOLLAR] = ACTIONS(11559),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11559),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11559),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11559),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11559),
    [aux_sym_integer_literal_token2] = ACTIONS(11559),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11559),
    [aux_sym_float_literal_token3] = ACTIONS(11559),
    [aux_sym_float_literal_token4] = ACTIONS(11559),
    [sym_character_literal] = ACTIONS(11559),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11559),
    [sym__pair_operator] = ACTIONS(11559),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11559),
    [sym__lazy_and_operator] = ACTIONS(11559),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11559),
    [sym__pipe_left_operator] = ACTIONS(11559),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11559),
    [sym__bitshift_operator] = ACTIONS(11559),
    [sym__power_operator] = ACTIONS(11559),
    [sym__tilde_operator] = ACTIONS(11559),
    [sym__type_order_operator] = ACTIONS(11559),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym__terminator_token1] = ACTIONS(11561),
    [aux_sym__terminator_token2] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7576] = {
    [sym_block_comment] = STATE(7576),
    [sym_line_comment] = STATE(7576),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7577] = {
    [sym_block_comment] = STATE(7577),
    [sym_line_comment] = STATE(7577),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7578] = {
    [sym_block_comment] = STATE(7578),
    [sym_line_comment] = STATE(7578),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11563),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_end] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_elseif] = ACTIONS(11563),
    [anon_sym_else] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11563),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11563),
    [anon_sym_DOLLAR] = ACTIONS(11563),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11563),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_QMARK] = ACTIONS(11563),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11563),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11563),
    [aux_sym_integer_literal_token2] = ACTIONS(11563),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11563),
    [aux_sym_float_literal_token3] = ACTIONS(11563),
    [aux_sym_float_literal_token4] = ACTIONS(11563),
    [sym_character_literal] = ACTIONS(11563),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11563),
    [sym__pair_operator] = ACTIONS(11563),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11563),
    [sym__lazy_and_operator] = ACTIONS(11563),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11563),
    [sym__pipe_left_operator] = ACTIONS(11563),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11563),
    [sym__bitshift_operator] = ACTIONS(11563),
    [sym__power_operator] = ACTIONS(11563),
    [sym__tilde_operator] = ACTIONS(11563),
    [sym__type_order_operator] = ACTIONS(11563),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym__terminator_token1] = ACTIONS(11565),
    [aux_sym__terminator_token2] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7579] = {
    [sym_block_comment] = STATE(7579),
    [sym_line_comment] = STATE(7579),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7580] = {
    [sym_block_comment] = STATE(7580),
    [sym_line_comment] = STATE(7580),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7581] = {
    [sym_block_comment] = STATE(7581),
    [sym_line_comment] = STATE(7581),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_RPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_RBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_SEMI] = ACTIONS(10012),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_RBRACE] = ACTIONS(10012),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7582] = {
    [sym_block_comment] = STATE(7582),
    [sym_line_comment] = STATE(7582),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_RPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_RBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_SEMI] = ACTIONS(10016),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_RBRACE] = ACTIONS(10016),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7583] = {
    [sym_block_comment] = STATE(7583),
    [sym_line_comment] = STATE(7583),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_finally] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7584] = {
    [sym_block_comment] = STATE(7584),
    [sym_line_comment] = STATE(7584),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_RPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_RBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_SEMI] = ACTIONS(10020),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_RBRACE] = ACTIONS(10020),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7585] = {
    [sym_block_comment] = STATE(7585),
    [sym_line_comment] = STATE(7585),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_RPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_RBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_SEMI] = ACTIONS(9918),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_RBRACE] = ACTIONS(9918),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7586] = {
    [sym_block_comment] = STATE(7586),
    [sym_line_comment] = STATE(7586),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_RPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_RBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_SEMI] = ACTIONS(9922),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_RBRACE] = ACTIONS(9922),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7587] = {
    [sym_block_comment] = STATE(7587),
    [sym_line_comment] = STATE(7587),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_finally] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7588] = {
    [sym_block_comment] = STATE(7588),
    [sym_line_comment] = STATE(7588),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7589] = {
    [sym_block_comment] = STATE(7589),
    [sym_line_comment] = STATE(7589),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7590] = {
    [sym_block_comment] = STATE(7590),
    [sym_line_comment] = STATE(7590),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_finally] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7591] = {
    [sym__comprehension_clause] = STATE(18752),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7591),
    [sym_line_comment] = STATE(7591),
    [aux_sym_vector_expression_repeat1] = STATE(17276),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11575),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11577),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11579),
    [aux_sym__terminator_token2] = ACTIONS(11582),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7592] = {
    [sym_block_comment] = STATE(7592),
    [sym_line_comment] = STATE(7592),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_elseif] = ACTIONS(10861),
    [anon_sym_else] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7593] = {
    [sym_block_comment] = STATE(7593),
    [sym_line_comment] = STATE(7593),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_finally] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7594] = {
    [sym_block_comment] = STATE(7594),
    [sym_line_comment] = STATE(7594),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_RPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_RBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_SEMI] = ACTIONS(9992),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_RBRACE] = ACTIONS(9992),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7595] = {
    [sym_block_comment] = STATE(7595),
    [sym_line_comment] = STATE(7595),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_RPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_RBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_SEMI] = ACTIONS(9996),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_RBRACE] = ACTIONS(9996),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7596] = {
    [sym_block_comment] = STATE(7596),
    [sym_line_comment] = STATE(7596),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11567),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_end] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_elseif] = ACTIONS(11567),
    [anon_sym_else] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11567),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11567),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11567),
    [anon_sym_DOLLAR] = ACTIONS(11567),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11567),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11567),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11567),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11567),
    [aux_sym_integer_literal_token2] = ACTIONS(11567),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11567),
    [aux_sym_float_literal_token3] = ACTIONS(11567),
    [aux_sym_float_literal_token4] = ACTIONS(11567),
    [sym_character_literal] = ACTIONS(11567),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11567),
    [sym__pair_operator] = ACTIONS(11567),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11567),
    [sym__lazy_and_operator] = ACTIONS(11567),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11567),
    [sym__pipe_left_operator] = ACTIONS(11567),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11567),
    [sym__bitshift_operator] = ACTIONS(11567),
    [sym__power_operator] = ACTIONS(11567),
    [sym__tilde_operator] = ACTIONS(11567),
    [sym__type_order_operator] = ACTIONS(11567),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym__terminator_token1] = ACTIONS(11569),
    [aux_sym__terminator_token2] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7597] = {
    [sym__comprehension_clause] = STATE(19420),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7597),
    [sym_line_comment] = STATE(7597),
    [aux_sym_vector_expression_repeat1] = STATE(17248),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11585),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11587),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11589),
    [aux_sym__terminator_token2] = ACTIONS(11592),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7598] = {
    [sym_block_comment] = STATE(7598),
    [sym_line_comment] = STATE(7598),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_RPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_RBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_SEMI] = ACTIONS(9754),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_RBRACE] = ACTIONS(9754),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7599] = {
    [sym_block_comment] = STATE(7599),
    [sym_line_comment] = STATE(7599),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7600] = {
    [sym_block_comment] = STATE(7600),
    [sym_line_comment] = STATE(7600),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_RPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_RBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9762),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_RBRACE] = ACTIONS(9762),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7601] = {
    [sym_block_comment] = STATE(7601),
    [sym_line_comment] = STATE(7601),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_RPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_RBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_SEMI] = ACTIONS(10030),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_RBRACE] = ACTIONS(10030),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7602] = {
    [sym_block_comment] = STATE(7602),
    [sym_line_comment] = STATE(7602),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_RPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_RBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_SEMI] = ACTIONS(10034),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_RBRACE] = ACTIONS(10034),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7603] = {
    [sym_block_comment] = STATE(7603),
    [sym_line_comment] = STATE(7603),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_RPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_RBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_SEMI] = ACTIONS(10038),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_RBRACE] = ACTIONS(10038),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7604] = {
    [sym_block_comment] = STATE(7604),
    [sym_line_comment] = STATE(7604),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_RPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_RBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_SEMI] = ACTIONS(10042),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_RBRACE] = ACTIONS(10042),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7605] = {
    [sym_block_comment] = STATE(7605),
    [sym_line_comment] = STATE(7605),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_catch] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(10821),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7606] = {
    [sym_block_comment] = STATE(7606),
    [sym_line_comment] = STATE(7606),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11571),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_end] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_elseif] = ACTIONS(11571),
    [anon_sym_else] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11571),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11571),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11571),
    [anon_sym_DOLLAR] = ACTIONS(11571),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11571),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_QMARK] = ACTIONS(11571),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11571),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11571),
    [aux_sym_integer_literal_token2] = ACTIONS(11571),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11571),
    [aux_sym_float_literal_token3] = ACTIONS(11571),
    [aux_sym_float_literal_token4] = ACTIONS(11571),
    [sym_character_literal] = ACTIONS(11571),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11571),
    [sym__pair_operator] = ACTIONS(11571),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11571),
    [sym__lazy_and_operator] = ACTIONS(11571),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11571),
    [sym__pipe_left_operator] = ACTIONS(11571),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11571),
    [sym__bitshift_operator] = ACTIONS(11571),
    [sym__power_operator] = ACTIONS(11571),
    [sym__tilde_operator] = ACTIONS(11571),
    [sym__type_order_operator] = ACTIONS(11571),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym__terminator_token1] = ACTIONS(11573),
    [aux_sym__terminator_token2] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7607] = {
    [sym_block_comment] = STATE(7607),
    [sym_line_comment] = STATE(7607),
    [aux_sym__import_list_repeat1] = STATE(7607),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(11595),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_catch] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7608] = {
    [sym__comprehension_clause] = STATE(18892),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7608),
    [sym_line_comment] = STATE(7608),
    [aux_sym_vector_expression_repeat1] = STATE(17336),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11598),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11600),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11602),
    [aux_sym__terminator_token2] = ACTIONS(11605),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7609] = {
    [sym_block_comment] = STATE(7609),
    [sym_line_comment] = STATE(7609),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10120),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
  },
  [7610] = {
    [sym_block_comment] = STATE(7610),
    [sym_line_comment] = STATE(7610),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7611] = {
    [sym_block_comment] = STATE(7611),
    [sym_line_comment] = STATE(7611),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7612] = {
    [sym_block_comment] = STATE(7612),
    [sym_line_comment] = STATE(7612),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7613] = {
    [sym_block_comment] = STATE(7613),
    [sym_line_comment] = STATE(7613),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_RPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_RBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_SEMI] = ACTIONS(9792),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_RBRACE] = ACTIONS(9792),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7614] = {
    [sym_block_comment] = STATE(7614),
    [sym_line_comment] = STATE(7614),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_RPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_RBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_SEMI] = ACTIONS(10046),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_RBRACE] = ACTIONS(10046),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7615] = {
    [sym_block_comment] = STATE(7615),
    [sym_line_comment] = STATE(7615),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7616] = {
    [sym_block_comment] = STATE(7616),
    [sym_line_comment] = STATE(7616),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_RPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_RBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_SEMI] = ACTIONS(10050),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_RBRACE] = ACTIONS(10050),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7617] = {
    [sym_block_comment] = STATE(7617),
    [sym_line_comment] = STATE(7617),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7618] = {
    [sym__comprehension_clause] = STATE(18990),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7618),
    [sym_line_comment] = STATE(7618),
    [aux_sym_vector_expression_repeat1] = STATE(17378),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11608),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11610),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11612),
    [aux_sym__terminator_token2] = ACTIONS(11615),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7619] = {
    [sym_block_comment] = STATE(7619),
    [sym_line_comment] = STATE(7619),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_catch] = ACTIONS(10577),
    [anon_sym_finally] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7620] = {
    [sym_block_comment] = STATE(7620),
    [sym_line_comment] = STATE(7620),
    [aux_sym__import_list_repeat1] = STATE(7749),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10799),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10755),
    [anon_sym_RPAREN] = ACTIONS(10755),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10755),
    [anon_sym_RBRACK] = ACTIONS(10755),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_SEMI] = ACTIONS(10755),
    [anon_sym_LBRACE] = ACTIONS(10755),
    [anon_sym_RBRACE] = ACTIONS(10755),
    [anon_sym_DOLLAR] = ACTIONS(10755),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10755),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10755),
    [anon_sym_QMARK] = ACTIONS(10755),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10755),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10755),
    [aux_sym_integer_literal_token2] = ACTIONS(10755),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10755),
    [aux_sym_float_literal_token3] = ACTIONS(10755),
    [aux_sym_float_literal_token4] = ACTIONS(10755),
    [sym_character_literal] = ACTIONS(10755),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10755),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10755),
    [sym__pair_operator] = ACTIONS(10755),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10755),
    [sym__lazy_and_operator] = ACTIONS(10755),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10755),
    [sym__pipe_left_operator] = ACTIONS(10755),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10755),
    [sym__bitshift_operator] = ACTIONS(10755),
    [sym__power_operator] = ACTIONS(10755),
    [sym__tilde_operator] = ACTIONS(10755),
    [sym__type_order_operator] = ACTIONS(10755),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7621] = {
    [sym_block_comment] = STATE(7621),
    [sym_line_comment] = STATE(7621),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10759),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10759),
    [anon_sym_RPAREN] = ACTIONS(10759),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10759),
    [anon_sym_RBRACK] = ACTIONS(10759),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_SEMI] = ACTIONS(10759),
    [anon_sym_LBRACE] = ACTIONS(10759),
    [anon_sym_RBRACE] = ACTIONS(10759),
    [anon_sym_DOLLAR] = ACTIONS(10759),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10759),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10759),
    [anon_sym_QMARK] = ACTIONS(10759),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10759),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10759),
    [aux_sym_integer_literal_token2] = ACTIONS(10759),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10759),
    [aux_sym_float_literal_token3] = ACTIONS(10759),
    [aux_sym_float_literal_token4] = ACTIONS(10759),
    [sym_character_literal] = ACTIONS(10759),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10759),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10759),
    [sym__pair_operator] = ACTIONS(10759),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10759),
    [sym__lazy_and_operator] = ACTIONS(10759),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10759),
    [sym__pipe_left_operator] = ACTIONS(10759),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10759),
    [sym__bitshift_operator] = ACTIONS(10759),
    [sym__power_operator] = ACTIONS(10759),
    [sym__tilde_operator] = ACTIONS(10759),
    [sym__type_order_operator] = ACTIONS(10759),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7622] = {
    [sym_block_comment] = STATE(7622),
    [sym_line_comment] = STATE(7622),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(11022),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7623] = {
    [sym_block_comment] = STATE(7623),
    [sym_line_comment] = STATE(7623),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7624] = {
    [sym_block_comment] = STATE(7624),
    [sym_line_comment] = STATE(7624),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10964),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_RBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7625] = {
    [sym_block_comment] = STATE(7625),
    [sym_line_comment] = STATE(7625),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10968),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_RBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7626] = {
    [sym_block_comment] = STATE(7626),
    [sym_line_comment] = STATE(7626),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10972),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_RBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7627] = {
    [sym_block_comment] = STATE(7627),
    [sym_line_comment] = STATE(7627),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7628] = {
    [sym__comprehension_clause] = STATE(19034),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7628),
    [sym_line_comment] = STATE(7628),
    [aux_sym_vector_expression_repeat1] = STATE(17397),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11658),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11660),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11662),
    [aux_sym__terminator_token2] = ACTIONS(11665),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7629] = {
    [sym_block_comment] = STATE(7629),
    [sym_line_comment] = STATE(7629),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_RPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_RBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_SEMI] = ACTIONS(10054),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_RBRACE] = ACTIONS(10054),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7630] = {
    [sym_block_comment] = STATE(7630),
    [sym_line_comment] = STATE(7630),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7631] = {
    [sym_block_comment] = STATE(7631),
    [sym_line_comment] = STATE(7631),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7632] = {
    [sym_block_comment] = STATE(7632),
    [sym_line_comment] = STATE(7632),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7633] = {
    [sym_block_comment] = STATE(7633),
    [sym_line_comment] = STATE(7633),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7634] = {
    [sym__comprehension_clause] = STATE(19514),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7634),
    [sym_line_comment] = STATE(7634),
    [aux_sym_vector_expression_repeat1] = STATE(17636),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11704),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11706),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11708),
    [aux_sym__terminator_token2] = ACTIONS(11711),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7635] = {
    [sym_block_comment] = STATE(7635),
    [sym_line_comment] = STATE(7635),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11411),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_end] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_else] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_finally] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11411),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11411),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11411),
    [anon_sym_DOLLAR] = ACTIONS(11411),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11411),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11411),
    [anon_sym_QMARK] = ACTIONS(11411),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11411),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11411),
    [aux_sym_integer_literal_token2] = ACTIONS(11411),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11411),
    [aux_sym_float_literal_token3] = ACTIONS(11411),
    [aux_sym_float_literal_token4] = ACTIONS(11411),
    [sym_character_literal] = ACTIONS(11411),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11411),
    [sym__pair_operator] = ACTIONS(11411),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11411),
    [sym__lazy_and_operator] = ACTIONS(11411),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11411),
    [sym__pipe_left_operator] = ACTIONS(11411),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11411),
    [sym__bitshift_operator] = ACTIONS(11411),
    [sym__power_operator] = ACTIONS(11411),
    [sym__tilde_operator] = ACTIONS(11411),
    [sym__type_order_operator] = ACTIONS(11411),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym__terminator_token1] = ACTIONS(11413),
    [aux_sym__terminator_token2] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7636] = {
    [sym_block_comment] = STATE(7636),
    [sym_line_comment] = STATE(7636),
    [aux_sym_export_statement_repeat1] = STATE(7706),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(11460),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_catch] = ACTIONS(10876),
    [anon_sym_finally] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10876),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10876),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(10876),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10876),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10876),
    [anon_sym_QMARK] = ACTIONS(10876),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10876),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10876),
    [aux_sym_integer_literal_token2] = ACTIONS(10876),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10876),
    [aux_sym_float_literal_token3] = ACTIONS(10876),
    [aux_sym_float_literal_token4] = ACTIONS(10876),
    [sym_character_literal] = ACTIONS(10876),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10876),
    [sym__pair_operator] = ACTIONS(10876),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10876),
    [sym__lazy_and_operator] = ACTIONS(10876),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10876),
    [sym__pipe_left_operator] = ACTIONS(10876),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10876),
    [sym__bitshift_operator] = ACTIONS(10876),
    [sym__power_operator] = ACTIONS(10876),
    [sym__tilde_operator] = ACTIONS(10876),
    [sym__type_order_operator] = ACTIONS(10876),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym__terminator_token1] = ACTIONS(10878),
    [aux_sym__terminator_token2] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7637] = {
    [sym_block_comment] = STATE(7637),
    [sym_line_comment] = STATE(7637),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7638] = {
    [sym_block_comment] = STATE(7638),
    [sym_line_comment] = STATE(7638),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_RPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_RBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_SEMI] = ACTIONS(10058),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_RBRACE] = ACTIONS(10058),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7639] = {
    [sym_block_comment] = STATE(7639),
    [sym_line_comment] = STATE(7639),
    [aux_sym_export_statement_repeat1] = STATE(7706),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(11460),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_catch] = ACTIONS(10880),
    [anon_sym_finally] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10880),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10880),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10880),
    [anon_sym_DOLLAR] = ACTIONS(10880),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10880),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10880),
    [anon_sym_QMARK] = ACTIONS(10880),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10880),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10880),
    [aux_sym_integer_literal_token2] = ACTIONS(10880),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10880),
    [aux_sym_float_literal_token3] = ACTIONS(10880),
    [aux_sym_float_literal_token4] = ACTIONS(10880),
    [sym_character_literal] = ACTIONS(10880),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10880),
    [sym__pair_operator] = ACTIONS(10880),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10880),
    [sym__lazy_and_operator] = ACTIONS(10880),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10880),
    [sym__pipe_left_operator] = ACTIONS(10880),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10880),
    [sym__bitshift_operator] = ACTIONS(10880),
    [sym__power_operator] = ACTIONS(10880),
    [sym__tilde_operator] = ACTIONS(10880),
    [sym__type_order_operator] = ACTIONS(10880),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym__terminator_token1] = ACTIONS(10882),
    [aux_sym__terminator_token2] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7640] = {
    [sym_block_comment] = STATE(7640),
    [sym_line_comment] = STATE(7640),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_elseif] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10978),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10978),
    [anon_sym_QMARK] = ACTIONS(10978),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10978),
    [sym__lazy_and_operator] = ACTIONS(10978),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10978),
    [sym__pipe_left_operator] = ACTIONS(10978),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10978),
    [sym__bitshift_operator] = ACTIONS(10978),
    [sym__power_operator] = ACTIONS(10978),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10978),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7641] = {
    [sym_block_comment] = STATE(7641),
    [sym_line_comment] = STATE(7641),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7642] = {
    [sym_block_comment] = STATE(7642),
    [sym_line_comment] = STATE(7642),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7643] = {
    [sym_block_comment] = STATE(7643),
    [sym_line_comment] = STATE(7643),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7644] = {
    [sym_block_comment] = STATE(7644),
    [sym_line_comment] = STATE(7644),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [ts_builtin_sym_end] = ACTIONS(10982),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_RBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7645] = {
    [sym_block_comment] = STATE(7645),
    [sym_line_comment] = STATE(7645),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7646] = {
    [sym_block_comment] = STATE(7646),
    [sym_line_comment] = STATE(7646),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7647] = {
    [sym_block_comment] = STATE(7647),
    [sym_line_comment] = STATE(7647),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7648] = {
    [sym_block_comment] = STATE(7648),
    [sym_line_comment] = STATE(7648),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7649] = {
    [sym_block_comment] = STATE(7649),
    [sym_line_comment] = STATE(7649),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7650] = {
    [sym__comprehension_clause] = STATE(19123),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7650),
    [sym_line_comment] = STATE(7650),
    [aux_sym_vector_expression_repeat1] = STATE(17437),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11752),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11754),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11756),
    [aux_sym__terminator_token2] = ACTIONS(11759),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7651] = {
    [sym_block_comment] = STATE(7651),
    [sym_line_comment] = STATE(7651),
    [aux_sym__import_list_repeat1] = STATE(7708),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(10868),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_catch] = ACTIONS(10884),
    [anon_sym_finally] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10884),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10884),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(10884),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10884),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10884),
    [anon_sym_QMARK] = ACTIONS(10884),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10884),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10884),
    [aux_sym_integer_literal_token2] = ACTIONS(10884),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10884),
    [aux_sym_float_literal_token3] = ACTIONS(10884),
    [aux_sym_float_literal_token4] = ACTIONS(10884),
    [sym_character_literal] = ACTIONS(10884),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10884),
    [sym__pair_operator] = ACTIONS(10884),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10884),
    [sym__lazy_and_operator] = ACTIONS(10884),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10884),
    [sym__pipe_left_operator] = ACTIONS(10884),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10884),
    [sym__bitshift_operator] = ACTIONS(10884),
    [sym__power_operator] = ACTIONS(10884),
    [sym__tilde_operator] = ACTIONS(10884),
    [sym__type_order_operator] = ACTIONS(10884),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym__terminator_token1] = ACTIONS(10886),
    [aux_sym__terminator_token2] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7652] = {
    [sym_block_comment] = STATE(7652),
    [sym_line_comment] = STATE(7652),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7653] = {
    [sym_block_comment] = STATE(7653),
    [sym_line_comment] = STATE(7653),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7654] = {
    [sym_block_comment] = STATE(7654),
    [sym_line_comment] = STATE(7654),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_catch] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7655] = {
    [sym_block_comment] = STATE(7655),
    [sym_line_comment] = STATE(7655),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7656] = {
    [sym__comprehension_clause] = STATE(19206),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7656),
    [sym_line_comment] = STATE(7656),
    [aux_sym_vector_expression_repeat1] = STATE(17477),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11762),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11764),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11766),
    [aux_sym__terminator_token2] = ACTIONS(11769),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7657] = {
    [sym_block_comment] = STATE(7657),
    [sym_line_comment] = STATE(7657),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_catch] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7658] = {
    [sym_block_comment] = STATE(7658),
    [sym_line_comment] = STATE(7658),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7659] = {
    [sym_block_comment] = STATE(7659),
    [sym_line_comment] = STATE(7659),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_RPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_RBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_SEMI] = ACTIONS(9900),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_RBRACE] = ACTIONS(9900),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7660] = {
    [sym_block_comment] = STATE(7660),
    [sym_line_comment] = STATE(7660),
    [ts_builtin_sym_end] = ACTIONS(9664),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_RBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7661] = {
    [sym_block_comment] = STATE(7661),
    [sym_line_comment] = STATE(7661),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9694),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7662] = {
    [sym_block_comment] = STATE(7662),
    [sym_line_comment] = STATE(7662),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
  },
  [7663] = {
    [sym_block_comment] = STATE(7663),
    [sym_line_comment] = STATE(7663),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(11772),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7664] = {
    [sym_block_comment] = STATE(7664),
    [sym_line_comment] = STATE(7664),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_RPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_RBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_SEMI] = ACTIONS(10062),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_RBRACE] = ACTIONS(10062),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7665] = {
    [sym_block_comment] = STATE(7665),
    [sym_line_comment] = STATE(7665),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_elseif] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7666] = {
    [sym_block_comment] = STATE(7666),
    [sym_line_comment] = STATE(7666),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_elseif] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7667] = {
    [sym_block_comment] = STATE(7667),
    [sym_line_comment] = STATE(7667),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_RPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_RBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_SEMI] = ACTIONS(10066),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_RBRACE] = ACTIONS(10066),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7668] = {
    [sym__comprehension_clause] = STATE(19094),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7668),
    [sym_line_comment] = STATE(7668),
    [aux_sym_vector_expression_repeat1] = STATE(17493),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11774),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11776),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11778),
    [aux_sym__terminator_token2] = ACTIONS(11781),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7669] = {
    [sym__comprehension_clause] = STATE(19276),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7669),
    [sym_line_comment] = STATE(7669),
    [aux_sym_vector_expression_repeat1] = STATE(17510),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11784),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11786),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11788),
    [aux_sym__terminator_token2] = ACTIONS(11791),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7670] = {
    [sym_block_comment] = STATE(7670),
    [sym_line_comment] = STATE(7670),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_RPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_RBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_SEMI] = ACTIONS(10070),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_RBRACE] = ACTIONS(10070),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7671] = {
    [sym_block_comment] = STATE(7671),
    [sym_line_comment] = STATE(7671),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_RPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_RBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_SEMI] = ACTIONS(10074),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_RBRACE] = ACTIONS(10074),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7672] = {
    [sym_block_comment] = STATE(7672),
    [sym_line_comment] = STATE(7672),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(11037),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7673] = {
    [sym_block_comment] = STATE(7673),
    [sym_line_comment] = STATE(7673),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11517),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_end] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_elseif] = ACTIONS(11517),
    [anon_sym_else] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11517),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11517),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11517),
    [anon_sym_DOLLAR] = ACTIONS(11517),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11517),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11517),
    [anon_sym_QMARK] = ACTIONS(11517),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11517),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11517),
    [aux_sym_integer_literal_token2] = ACTIONS(11517),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11517),
    [aux_sym_float_literal_token3] = ACTIONS(11517),
    [aux_sym_float_literal_token4] = ACTIONS(11517),
    [sym_character_literal] = ACTIONS(11517),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11517),
    [sym__pair_operator] = ACTIONS(11517),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11517),
    [sym__lazy_and_operator] = ACTIONS(11517),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11517),
    [sym__pipe_left_operator] = ACTIONS(11517),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11517),
    [sym__bitshift_operator] = ACTIONS(11517),
    [sym__power_operator] = ACTIONS(11517),
    [sym__tilde_operator] = ACTIONS(11517),
    [sym__type_order_operator] = ACTIONS(11517),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym__terminator_token1] = ACTIONS(11519),
    [aux_sym__terminator_token2] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7674] = {
    [sym_block_comment] = STATE(7674),
    [sym_line_comment] = STATE(7674),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_RPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_RBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_SEMI] = ACTIONS(10078),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_RBRACE] = ACTIONS(10078),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7675] = {
    [sym_block_comment] = STATE(7675),
    [sym_line_comment] = STATE(7675),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_RPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_RBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_SEMI] = ACTIONS(10082),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_RBRACE] = ACTIONS(10082),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7676] = {
    [sym_block_comment] = STATE(7676),
    [sym_line_comment] = STATE(7676),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_catch] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7677] = {
    [sym__comprehension_clause] = STATE(18641),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7677),
    [sym_line_comment] = STATE(7677),
    [aux_sym_vector_expression_repeat1] = STATE(17219),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11794),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11796),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11798),
    [aux_sym__terminator_token2] = ACTIONS(11801),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7678] = {
    [sym_block_comment] = STATE(7678),
    [sym_line_comment] = STATE(7678),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7679] = {
    [sym_block_comment] = STATE(7679),
    [sym_line_comment] = STATE(7679),
    [aux_sym__import_list_repeat1] = STATE(8275),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(11215),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(11217),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(11804),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7680] = {
    [sym_block_comment] = STATE(7680),
    [sym_line_comment] = STATE(7680),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_catch] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7681] = {
    [sym__comprehension_clause] = STATE(19392),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7681),
    [sym_line_comment] = STATE(7681),
    [aux_sym_vector_expression_repeat1] = STATE(17566),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11806),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11808),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11810),
    [aux_sym__terminator_token2] = ACTIONS(11813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7682] = {
    [sym_block_comment] = STATE(7682),
    [sym_line_comment] = STATE(7682),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
  },
  [7683] = {
    [sym_block_comment] = STATE(7683),
    [sym_line_comment] = STATE(7683),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7684] = {
    [sym_block_comment] = STATE(7684),
    [sym_line_comment] = STATE(7684),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7685] = {
    [sym_block_comment] = STATE(7685),
    [sym_line_comment] = STATE(7685),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_RPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_RBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_SEMI] = ACTIONS(9716),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_RBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7686] = {
    [sym_block_comment] = STATE(7686),
    [sym_line_comment] = STATE(7686),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOT] = ACTIONS(11037),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7687] = {
    [sym_block_comment] = STATE(7687),
    [sym_line_comment] = STATE(7687),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10120),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9668),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7688] = {
    [sym_block_comment] = STATE(7688),
    [sym_line_comment] = STATE(7688),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_elseif] = ACTIONS(11112),
    [anon_sym_else] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7689] = {
    [sym_block_comment] = STATE(7689),
    [sym_line_comment] = STATE(7689),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9718),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7690] = {
    [sym_block_comment] = STATE(7690),
    [sym_line_comment] = STATE(7690),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7691] = {
    [sym_block_comment] = STATE(7691),
    [sym_line_comment] = STATE(7691),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_catch] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7692] = {
    [sym__comprehension_clause] = STATE(19504),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7692),
    [sym_line_comment] = STATE(7692),
    [aux_sym_vector_expression_repeat1] = STATE(17616),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11816),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11818),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11820),
    [aux_sym__terminator_token2] = ACTIONS(11823),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7693] = {
    [sym_block_comment] = STATE(7693),
    [sym_line_comment] = STATE(7693),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOT] = ACTIONS(11037),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7694] = {
    [sym_block_comment] = STATE(7694),
    [sym_line_comment] = STATE(7694),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
  },
  [7695] = {
    [sym_block_comment] = STATE(7695),
    [sym_line_comment] = STATE(7695),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9874),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7696] = {
    [sym_block_comment] = STATE(7696),
    [sym_line_comment] = STATE(7696),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
  },
  [7697] = {
    [sym__comprehension_clause] = STATE(18266),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7697),
    [sym_line_comment] = STATE(7697),
    [aux_sym_vector_expression_repeat1] = STATE(17189),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11826),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11828),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11830),
    [aux_sym__terminator_token2] = ACTIONS(11833),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7698] = {
    [sym__comprehension_clause] = STATE(19606),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7698),
    [sym_line_comment] = STATE(7698),
    [aux_sym_vector_expression_repeat1] = STATE(17666),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11836),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11838),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11840),
    [aux_sym__terminator_token2] = ACTIONS(11843),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7699] = {
    [sym_block_comment] = STATE(7699),
    [sym_line_comment] = STATE(7699),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9942),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
  },
  [7700] = {
    [sym_block_comment] = STATE(7700),
    [sym_line_comment] = STATE(7700),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10579),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10579),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10579),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10579),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10579),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10579),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10579),
    [anon_sym_QMARK] = ACTIONS(10579),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10579),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10579),
    [aux_sym_integer_literal_token2] = ACTIONS(10579),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10579),
    [aux_sym_float_literal_token3] = ACTIONS(10579),
    [aux_sym_float_literal_token4] = ACTIONS(10579),
    [sym_character_literal] = ACTIONS(10579),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10579),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10579),
    [sym__pair_operator] = ACTIONS(10579),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10579),
    [sym__lazy_and_operator] = ACTIONS(10579),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10579),
    [sym__pipe_left_operator] = ACTIONS(10579),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10579),
    [sym__bitshift_operator] = ACTIONS(10579),
    [sym__power_operator] = ACTIONS(10579),
    [sym__tilde_operator] = ACTIONS(10579),
    [sym__type_order_operator] = ACTIONS(10579),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10579),
    [sym__immediate_bracket] = ACTIONS(10579),
    [sym__immediate_brace] = ACTIONS(10579),
  },
  [7701] = {
    [sym_block_comment] = STATE(7701),
    [sym_line_comment] = STATE(7701),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_catch] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7702] = {
    [sym_block_comment] = STATE(7702),
    [sym_line_comment] = STATE(7702),
    [aux_sym_export_statement_repeat1] = STATE(7751),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_end] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_finally] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10807),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10807),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10807),
    [anon_sym_DOLLAR] = ACTIONS(10807),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10807),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10807),
    [anon_sym_QMARK] = ACTIONS(10807),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10807),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10807),
    [aux_sym_integer_literal_token2] = ACTIONS(10807),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10807),
    [aux_sym_float_literal_token3] = ACTIONS(10807),
    [aux_sym_float_literal_token4] = ACTIONS(10807),
    [sym_character_literal] = ACTIONS(10807),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10807),
    [sym__pair_operator] = ACTIONS(10807),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10807),
    [sym__lazy_and_operator] = ACTIONS(10807),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10807),
    [sym__pipe_left_operator] = ACTIONS(10807),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10807),
    [sym__bitshift_operator] = ACTIONS(10807),
    [sym__power_operator] = ACTIONS(10807),
    [sym__tilde_operator] = ACTIONS(10807),
    [sym__type_order_operator] = ACTIONS(10807),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym__terminator_token1] = ACTIONS(10811),
    [aux_sym__terminator_token2] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7703] = {
    [sym_block_comment] = STATE(7703),
    [sym_line_comment] = STATE(7703),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10763),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10763),
    [anon_sym_RPAREN] = ACTIONS(10763),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10763),
    [anon_sym_RBRACK] = ACTIONS(10763),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_SEMI] = ACTIONS(10763),
    [anon_sym_LBRACE] = ACTIONS(10763),
    [anon_sym_RBRACE] = ACTIONS(10763),
    [anon_sym_DOLLAR] = ACTIONS(10763),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10763),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10763),
    [anon_sym_QMARK] = ACTIONS(10763),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10763),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10763),
    [aux_sym_integer_literal_token2] = ACTIONS(10763),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10763),
    [aux_sym_float_literal_token3] = ACTIONS(10763),
    [aux_sym_float_literal_token4] = ACTIONS(10763),
    [sym_character_literal] = ACTIONS(10763),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10763),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10763),
    [sym__pair_operator] = ACTIONS(10763),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10763),
    [sym__lazy_and_operator] = ACTIONS(10763),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10763),
    [sym__pipe_left_operator] = ACTIONS(10763),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10763),
    [sym__bitshift_operator] = ACTIONS(10763),
    [sym__power_operator] = ACTIONS(10763),
    [sym__tilde_operator] = ACTIONS(10763),
    [sym__type_order_operator] = ACTIONS(10763),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7704] = {
    [sym__comprehension_clause] = STATE(18770),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7704),
    [sym_line_comment] = STATE(7704),
    [aux_sym_vector_expression_repeat1] = STATE(17349),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11848),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11850),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11852),
    [aux_sym__terminator_token2] = ACTIONS(11855),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7705] = {
    [sym_block_comment] = STATE(7705),
    [sym_line_comment] = STATE(7705),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7706] = {
    [sym_block_comment] = STATE(7706),
    [sym_line_comment] = STATE(7706),
    [aux_sym_export_statement_repeat1] = STATE(7706),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(11858),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_catch] = ACTIONS(10850),
    [anon_sym_finally] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7707] = {
    [sym_block_comment] = STATE(7707),
    [sym_line_comment] = STATE(7707),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_catch] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(10870),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7708] = {
    [sym_block_comment] = STATE(7708),
    [sym_line_comment] = STATE(7708),
    [aux_sym__import_list_repeat1] = STATE(7708),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(11861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_catch] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7709] = {
    [sym_block_comment] = STATE(7709),
    [sym_line_comment] = STATE(7709),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_catch] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7710] = {
    [sym_block_comment] = STATE(7710),
    [sym_line_comment] = STATE(7710),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_elseif] = ACTIONS(11864),
    [anon_sym_else] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7711] = {
    [sym_block_comment] = STATE(7711),
    [sym_line_comment] = STATE(7711),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7712] = {
    [sym_block_comment] = STATE(7712),
    [sym_line_comment] = STATE(7712),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7713] = {
    [sym_block_comment] = STATE(7713),
    [sym_line_comment] = STATE(7713),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7714] = {
    [sym_block_comment] = STATE(7714),
    [sym_line_comment] = STATE(7714),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7715] = {
    [sym__comprehension_clause] = STATE(18763),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7715),
    [sym_line_comment] = STATE(7715),
    [aux_sym_vector_expression_repeat1] = STATE(17136),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11870),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11872),
    [aux_sym__terminator_token2] = ACTIONS(11875),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7716] = {
    [sym_block_comment] = STATE(7716),
    [sym_line_comment] = STATE(7716),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7717] = {
    [sym_block_comment] = STATE(7717),
    [sym_line_comment] = STATE(7717),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7718] = {
    [sym_block_comment] = STATE(7718),
    [sym_line_comment] = STATE(7718),
    [aux_sym_export_statement_repeat1] = STATE(7755),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_end] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_finally] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10813),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10813),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10813),
    [anon_sym_DOLLAR] = ACTIONS(10813),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10813),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10813),
    [anon_sym_QMARK] = ACTIONS(10813),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10813),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10813),
    [aux_sym_integer_literal_token2] = ACTIONS(10813),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10813),
    [aux_sym_float_literal_token3] = ACTIONS(10813),
    [aux_sym_float_literal_token4] = ACTIONS(10813),
    [sym_character_literal] = ACTIONS(10813),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10813),
    [sym__pair_operator] = ACTIONS(10813),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10813),
    [sym__lazy_and_operator] = ACTIONS(10813),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10813),
    [sym__pipe_left_operator] = ACTIONS(10813),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10813),
    [sym__bitshift_operator] = ACTIONS(10813),
    [sym__power_operator] = ACTIONS(10813),
    [sym__tilde_operator] = ACTIONS(10813),
    [sym__type_order_operator] = ACTIONS(10813),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym__terminator_token1] = ACTIONS(10815),
    [aux_sym__terminator_token2] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7719] = {
    [sym_block_comment] = STATE(7719),
    [sym_line_comment] = STATE(7719),
    [aux_sym__import_list_repeat1] = STATE(7758),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(10888),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_finally] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7720] = {
    [sym_block_comment] = STATE(7720),
    [sym_line_comment] = STATE(7720),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_finally] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7721] = {
    [sym_block_comment] = STATE(7721),
    [sym_line_comment] = STATE(7721),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_catch] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7722] = {
    [sym_block_comment] = STATE(7722),
    [sym_line_comment] = STATE(7722),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7723] = {
    [sym__comprehension_clause] = STATE(18415),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7723),
    [sym_line_comment] = STATE(7723),
    [aux_sym_vector_expression_repeat1] = STATE(17220),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11880),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11882),
    [aux_sym__terminator_token2] = ACTIONS(11885),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7724] = {
    [sym_block_comment] = STATE(7724),
    [sym_line_comment] = STATE(7724),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_elseif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7725] = {
    [sym_block_comment] = STATE(7725),
    [sym_line_comment] = STATE(7725),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [7726] = {
    [sym_block_comment] = STATE(7726),
    [sym_line_comment] = STATE(7726),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7727] = {
    [sym_block_comment] = STATE(7727),
    [sym_line_comment] = STATE(7727),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7728] = {
    [sym_block_comment] = STATE(7728),
    [sym_line_comment] = STATE(7728),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_catch] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7729] = {
    [sym_block_comment] = STATE(7729),
    [sym_line_comment] = STATE(7729),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7730] = {
    [sym_block_comment] = STATE(7730),
    [sym_line_comment] = STATE(7730),
    [ts_builtin_sym_end] = ACTIONS(9928),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_RBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7731] = {
    [sym_block_comment] = STATE(7731),
    [sym_line_comment] = STATE(7731),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_else] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7732] = {
    [sym__comprehension_clause] = STATE(19197),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7732),
    [sym_line_comment] = STATE(7732),
    [aux_sym_vector_expression_repeat1] = STATE(17472),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [aux_sym__terminator_token2] = ACTIONS(11895),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7733] = {
    [sym_block_comment] = STATE(7733),
    [sym_line_comment] = STATE(7733),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_end] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_else] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_finally] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym__terminator_token1] = ACTIONS(11900),
    [aux_sym__terminator_token2] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7734] = {
    [sym_block_comment] = STATE(7734),
    [sym_line_comment] = STATE(7734),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_catch] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7735] = {
    [sym_block_comment] = STATE(7735),
    [sym_line_comment] = STATE(7735),
    [ts_builtin_sym_end] = ACTIONS(10639),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_RBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7736] = {
    [sym_block_comment] = STATE(7736),
    [sym_line_comment] = STATE(7736),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_catch] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7737] = {
    [sym__comprehension_clause] = STATE(18622),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7737),
    [sym_line_comment] = STATE(7737),
    [aux_sym_vector_expression_repeat1] = STATE(17598),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11904),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11906),
    [aux_sym__terminator_token2] = ACTIONS(11909),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7738] = {
    [sym_block_comment] = STATE(7738),
    [sym_line_comment] = STATE(7738),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_else] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7739] = {
    [sym_block_comment] = STATE(7739),
    [sym_line_comment] = STATE(7739),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_catch] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7740] = {
    [sym_block_comment] = STATE(7740),
    [sym_line_comment] = STATE(7740),
    [aux_sym_export_statement_repeat1] = STATE(7857),
    [ts_builtin_sym_end] = ACTIONS(10878),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(11524),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10876),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10876),
    [anon_sym_RBRACK] = ACTIONS(10876),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(10876),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10876),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10876),
    [anon_sym_QMARK] = ACTIONS(10876),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10876),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10876),
    [aux_sym_integer_literal_token2] = ACTIONS(10876),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10876),
    [aux_sym_float_literal_token3] = ACTIONS(10876),
    [aux_sym_float_literal_token4] = ACTIONS(10876),
    [sym_character_literal] = ACTIONS(10876),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10876),
    [sym__pair_operator] = ACTIONS(10876),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10876),
    [sym__lazy_and_operator] = ACTIONS(10876),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10876),
    [sym__pipe_left_operator] = ACTIONS(10876),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10876),
    [sym__bitshift_operator] = ACTIONS(10876),
    [sym__power_operator] = ACTIONS(10876),
    [sym__tilde_operator] = ACTIONS(10876),
    [sym__type_order_operator] = ACTIONS(10876),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym__terminator_token1] = ACTIONS(10878),
    [aux_sym__terminator_token2] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7741] = {
    [sym_block_comment] = STATE(7741),
    [sym_line_comment] = STATE(7741),
    [aux_sym_export_statement_repeat1] = STATE(7857),
    [ts_builtin_sym_end] = ACTIONS(10882),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(11524),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10880),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10880),
    [anon_sym_RBRACK] = ACTIONS(10880),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10880),
    [anon_sym_DOLLAR] = ACTIONS(10880),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10880),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10880),
    [anon_sym_QMARK] = ACTIONS(10880),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10880),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10880),
    [aux_sym_integer_literal_token2] = ACTIONS(10880),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10880),
    [aux_sym_float_literal_token3] = ACTIONS(10880),
    [aux_sym_float_literal_token4] = ACTIONS(10880),
    [sym_character_literal] = ACTIONS(10880),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10880),
    [sym__pair_operator] = ACTIONS(10880),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10880),
    [sym__lazy_and_operator] = ACTIONS(10880),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10880),
    [sym__pipe_left_operator] = ACTIONS(10880),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10880),
    [sym__bitshift_operator] = ACTIONS(10880),
    [sym__power_operator] = ACTIONS(10880),
    [sym__tilde_operator] = ACTIONS(10880),
    [sym__type_order_operator] = ACTIONS(10880),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym__terminator_token1] = ACTIONS(10882),
    [aux_sym__terminator_token2] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7742] = {
    [sym_block_comment] = STATE(7742),
    [sym_line_comment] = STATE(7742),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(11912),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7743] = {
    [sym_block_comment] = STATE(7743),
    [sym_line_comment] = STATE(7743),
    [aux_sym__import_list_repeat1] = STATE(7860),
    [ts_builtin_sym_end] = ACTIONS(10886),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(10917),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10884),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10884),
    [anon_sym_RBRACK] = ACTIONS(10884),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(10884),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10884),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10884),
    [anon_sym_QMARK] = ACTIONS(10884),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10884),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10884),
    [aux_sym_integer_literal_token2] = ACTIONS(10884),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10884),
    [aux_sym_float_literal_token3] = ACTIONS(10884),
    [aux_sym_float_literal_token4] = ACTIONS(10884),
    [sym_character_literal] = ACTIONS(10884),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10884),
    [sym__pair_operator] = ACTIONS(10884),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10884),
    [sym__lazy_and_operator] = ACTIONS(10884),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10884),
    [sym__pipe_left_operator] = ACTIONS(10884),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10884),
    [sym__bitshift_operator] = ACTIONS(10884),
    [sym__power_operator] = ACTIONS(10884),
    [sym__tilde_operator] = ACTIONS(10884),
    [sym__type_order_operator] = ACTIONS(10884),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym__terminator_token1] = ACTIONS(10886),
    [aux_sym__terminator_token2] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7744] = {
    [sym__comprehension_clause] = STATE(18508),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7744),
    [sym_line_comment] = STATE(7744),
    [aux_sym_vector_expression_repeat1] = STATE(17395),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11918),
    [aux_sym__terminator_token2] = ACTIONS(11921),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7745] = {
    [sym_block_comment] = STATE(7745),
    [sym_line_comment] = STATE(7745),
    [aux_sym_open_tuple_repeat1] = STATE(7753),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_end] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_finally] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10829),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10829),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10829),
    [anon_sym_DOLLAR] = ACTIONS(10829),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10829),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10829),
    [anon_sym_QMARK] = ACTIONS(10829),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10829),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10829),
    [aux_sym_integer_literal_token2] = ACTIONS(10829),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10829),
    [aux_sym_float_literal_token3] = ACTIONS(10829),
    [aux_sym_float_literal_token4] = ACTIONS(10829),
    [sym_character_literal] = ACTIONS(10829),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10829),
    [sym__pair_operator] = ACTIONS(10829),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10829),
    [sym__lazy_and_operator] = ACTIONS(10829),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10829),
    [sym__pipe_left_operator] = ACTIONS(10829),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10829),
    [sym__bitshift_operator] = ACTIONS(10829),
    [sym__power_operator] = ACTIONS(10829),
    [sym__tilde_operator] = ACTIONS(10829),
    [sym__type_order_operator] = ACTIONS(10829),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym__terminator_token1] = ACTIONS(10833),
    [aux_sym__terminator_token2] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7746] = {
    [sym_block_comment] = STATE(7746),
    [sym_line_comment] = STATE(7746),
    [aux_sym_export_statement_repeat1] = STATE(7478),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(11315),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10878),
    [anon_sym_RPAREN] = ACTIONS(10878),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10878),
    [anon_sym_RBRACK] = ACTIONS(10878),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_SEMI] = ACTIONS(10878),
    [anon_sym_LBRACE] = ACTIONS(10878),
    [anon_sym_RBRACE] = ACTIONS(10878),
    [anon_sym_DOLLAR] = ACTIONS(10878),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10878),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10878),
    [anon_sym_QMARK] = ACTIONS(10878),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10878),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10878),
    [aux_sym_integer_literal_token2] = ACTIONS(10878),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10878),
    [aux_sym_float_literal_token3] = ACTIONS(10878),
    [aux_sym_float_literal_token4] = ACTIONS(10878),
    [sym_character_literal] = ACTIONS(10878),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10878),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10878),
    [sym__pair_operator] = ACTIONS(10878),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10878),
    [sym__lazy_and_operator] = ACTIONS(10878),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10878),
    [sym__pipe_left_operator] = ACTIONS(10878),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10878),
    [sym__bitshift_operator] = ACTIONS(10878),
    [sym__power_operator] = ACTIONS(10878),
    [sym__tilde_operator] = ACTIONS(10878),
    [sym__type_order_operator] = ACTIONS(10878),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7747] = {
    [sym_block_comment] = STATE(7747),
    [sym_line_comment] = STATE(7747),
    [aux_sym_export_statement_repeat1] = STATE(7478),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(11315),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10882),
    [anon_sym_RPAREN] = ACTIONS(10882),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10882),
    [anon_sym_RBRACK] = ACTIONS(10882),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_SEMI] = ACTIONS(10882),
    [anon_sym_LBRACE] = ACTIONS(10882),
    [anon_sym_RBRACE] = ACTIONS(10882),
    [anon_sym_DOLLAR] = ACTIONS(10882),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10882),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10882),
    [anon_sym_QMARK] = ACTIONS(10882),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10882),
    [aux_sym_integer_literal_token2] = ACTIONS(10882),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10882),
    [aux_sym_float_literal_token3] = ACTIONS(10882),
    [aux_sym_float_literal_token4] = ACTIONS(10882),
    [sym_character_literal] = ACTIONS(10882),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10882),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10882),
    [sym__pair_operator] = ACTIONS(10882),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10882),
    [sym__lazy_and_operator] = ACTIONS(10882),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10882),
    [sym__pipe_left_operator] = ACTIONS(10882),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10882),
    [sym__bitshift_operator] = ACTIONS(10882),
    [sym__power_operator] = ACTIONS(10882),
    [sym__tilde_operator] = ACTIONS(10882),
    [sym__type_order_operator] = ACTIONS(10882),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7748] = {
    [sym_block_comment] = STATE(7748),
    [sym_line_comment] = STATE(7748),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9840),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7749] = {
    [sym_block_comment] = STATE(7749),
    [sym_line_comment] = STATE(7749),
    [aux_sym__import_list_repeat1] = STATE(7511),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(10799),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10886),
    [anon_sym_RPAREN] = ACTIONS(10886),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10886),
    [anon_sym_RBRACK] = ACTIONS(10886),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_SEMI] = ACTIONS(10886),
    [anon_sym_LBRACE] = ACTIONS(10886),
    [anon_sym_RBRACE] = ACTIONS(10886),
    [anon_sym_DOLLAR] = ACTIONS(10886),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10886),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10886),
    [anon_sym_QMARK] = ACTIONS(10886),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10886),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10886),
    [aux_sym_integer_literal_token2] = ACTIONS(10886),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10886),
    [aux_sym_float_literal_token3] = ACTIONS(10886),
    [aux_sym_float_literal_token4] = ACTIONS(10886),
    [sym_character_literal] = ACTIONS(10886),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10886),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10886),
    [sym__pair_operator] = ACTIONS(10886),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10886),
    [sym__lazy_and_operator] = ACTIONS(10886),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10886),
    [sym__pipe_left_operator] = ACTIONS(10886),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10886),
    [sym__bitshift_operator] = ACTIONS(10886),
    [sym__power_operator] = ACTIONS(10886),
    [sym__tilde_operator] = ACTIONS(10886),
    [sym__type_order_operator] = ACTIONS(10886),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7750] = {
    [sym_block_comment] = STATE(7750),
    [sym_line_comment] = STATE(7750),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11924),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_end] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_else] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_finally] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11924),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11924),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11924),
    [anon_sym_DOLLAR] = ACTIONS(11924),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11924),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11924),
    [anon_sym_QMARK] = ACTIONS(11924),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11924),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11924),
    [aux_sym_integer_literal_token2] = ACTIONS(11924),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11924),
    [aux_sym_float_literal_token3] = ACTIONS(11924),
    [aux_sym_float_literal_token4] = ACTIONS(11924),
    [sym_character_literal] = ACTIONS(11924),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11924),
    [sym__pair_operator] = ACTIONS(11924),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11924),
    [sym__lazy_and_operator] = ACTIONS(11924),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11924),
    [sym__pipe_left_operator] = ACTIONS(11924),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11924),
    [sym__bitshift_operator] = ACTIONS(11924),
    [sym__power_operator] = ACTIONS(11924),
    [sym__tilde_operator] = ACTIONS(11924),
    [sym__type_order_operator] = ACTIONS(11924),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym__terminator_token1] = ACTIONS(11926),
    [aux_sym__terminator_token2] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7751] = {
    [sym_block_comment] = STATE(7751),
    [sym_line_comment] = STATE(7751),
    [aux_sym_export_statement_repeat1] = STATE(7820),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_finally] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10876),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10876),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(10876),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10876),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10876),
    [anon_sym_QMARK] = ACTIONS(10876),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10876),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10876),
    [aux_sym_integer_literal_token2] = ACTIONS(10876),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10876),
    [aux_sym_float_literal_token3] = ACTIONS(10876),
    [aux_sym_float_literal_token4] = ACTIONS(10876),
    [sym_character_literal] = ACTIONS(10876),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10876),
    [sym__pair_operator] = ACTIONS(10876),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10876),
    [sym__lazy_and_operator] = ACTIONS(10876),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10876),
    [sym__pipe_left_operator] = ACTIONS(10876),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10876),
    [sym__bitshift_operator] = ACTIONS(10876),
    [sym__power_operator] = ACTIONS(10876),
    [sym__tilde_operator] = ACTIONS(10876),
    [sym__type_order_operator] = ACTIONS(10876),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym__terminator_token1] = ACTIONS(10878),
    [aux_sym__terminator_token2] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7752] = {
    [sym__comprehension_clause] = STATE(19216),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7752),
    [sym_line_comment] = STATE(7752),
    [aux_sym_vector_expression_repeat1] = STATE(17310),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [aux_sym__terminator_token2] = ACTIONS(11935),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7753] = {
    [sym_block_comment] = STATE(7753),
    [sym_line_comment] = STATE(7753),
    [aux_sym_open_tuple_repeat1] = STATE(7753),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(11938),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_finally] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10835),
    [anon_sym_QMARK] = ACTIONS(10835),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10835),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10835),
    [sym__lazy_and_operator] = ACTIONS(10835),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10835),
    [sym__pipe_left_operator] = ACTIONS(10835),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10835),
    [sym__bitshift_operator] = ACTIONS(10835),
    [sym__power_operator] = ACTIONS(10835),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10835),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7754] = {
    [sym_block_comment] = STATE(7754),
    [sym_line_comment] = STATE(7754),
    [aux_sym_open_tuple_repeat1] = STATE(6780),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(10831),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7755] = {
    [sym_block_comment] = STATE(7755),
    [sym_line_comment] = STATE(7755),
    [aux_sym_export_statement_repeat1] = STATE(7820),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(11846),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_end] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_finally] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10880),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10880),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10880),
    [anon_sym_DOLLAR] = ACTIONS(10880),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10880),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10880),
    [anon_sym_QMARK] = ACTIONS(10880),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10880),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10880),
    [aux_sym_integer_literal_token2] = ACTIONS(10880),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10880),
    [aux_sym_float_literal_token3] = ACTIONS(10880),
    [aux_sym_float_literal_token4] = ACTIONS(10880),
    [sym_character_literal] = ACTIONS(10880),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10880),
    [sym__pair_operator] = ACTIONS(10880),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10880),
    [sym__lazy_and_operator] = ACTIONS(10880),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10880),
    [sym__pipe_left_operator] = ACTIONS(10880),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10880),
    [sym__bitshift_operator] = ACTIONS(10880),
    [sym__power_operator] = ACTIONS(10880),
    [sym__tilde_operator] = ACTIONS(10880),
    [sym__type_order_operator] = ACTIONS(10880),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym__terminator_token1] = ACTIONS(10882),
    [aux_sym__terminator_token2] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7756] = {
    [sym_block_comment] = STATE(7756),
    [sym_line_comment] = STATE(7756),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_RPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_RBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_SEMI] = ACTIONS(10154),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_RBRACE] = ACTIONS(10154),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7757] = {
    [sym_block_comment] = STATE(7757),
    [sym_line_comment] = STATE(7757),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_else] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_finally] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7758] = {
    [sym_block_comment] = STATE(7758),
    [sym_line_comment] = STATE(7758),
    [aux_sym__import_list_repeat1] = STATE(7830),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(10888),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_end] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_finally] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10884),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10884),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(10884),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10884),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10884),
    [anon_sym_QMARK] = ACTIONS(10884),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10884),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10884),
    [aux_sym_integer_literal_token2] = ACTIONS(10884),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10884),
    [aux_sym_float_literal_token3] = ACTIONS(10884),
    [aux_sym_float_literal_token4] = ACTIONS(10884),
    [sym_character_literal] = ACTIONS(10884),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10884),
    [sym__pair_operator] = ACTIONS(10884),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10884),
    [sym__lazy_and_operator] = ACTIONS(10884),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10884),
    [sym__pipe_left_operator] = ACTIONS(10884),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10884),
    [sym__bitshift_operator] = ACTIONS(10884),
    [sym__power_operator] = ACTIONS(10884),
    [sym__tilde_operator] = ACTIONS(10884),
    [sym__type_order_operator] = ACTIONS(10884),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym__terminator_token1] = ACTIONS(10886),
    [aux_sym__terminator_token2] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7759] = {
    [sym_block_comment] = STATE(7759),
    [sym_line_comment] = STATE(7759),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_elseif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7760] = {
    [sym_block_comment] = STATE(7760),
    [sym_line_comment] = STATE(7760),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10835),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_elseif] = ACTIONS(10835),
    [anon_sym_else] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7761] = {
    [sym_block_comment] = STATE(7761),
    [sym_line_comment] = STATE(7761),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11941),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_end] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_else] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_finally] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11941),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11941),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11941),
    [anon_sym_DOLLAR] = ACTIONS(11941),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11941),
    [anon_sym_QMARK] = ACTIONS(11941),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11941),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11941),
    [aux_sym_integer_literal_token2] = ACTIONS(11941),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11941),
    [aux_sym_float_literal_token3] = ACTIONS(11941),
    [aux_sym_float_literal_token4] = ACTIONS(11941),
    [sym_character_literal] = ACTIONS(11941),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11941),
    [sym__pair_operator] = ACTIONS(11941),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11941),
    [sym__lazy_and_operator] = ACTIONS(11941),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11941),
    [sym__pipe_left_operator] = ACTIONS(11941),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11941),
    [sym__bitshift_operator] = ACTIONS(11941),
    [sym__power_operator] = ACTIONS(11941),
    [sym__tilde_operator] = ACTIONS(11941),
    [sym__type_order_operator] = ACTIONS(11941),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym__terminator_token1] = ACTIONS(11943),
    [aux_sym__terminator_token2] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7762] = {
    [sym__comprehension_clause] = STATE(18346),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7762),
    [sym_line_comment] = STATE(7762),
    [aux_sym_vector_expression_repeat1] = STATE(17534),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11945),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11947),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11949),
    [aux_sym__terminator_token2] = ACTIONS(11952),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7763] = {
    [sym__comprehension_clause] = STATE(19047),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7763),
    [sym_line_comment] = STATE(7763),
    [aux_sym_vector_expression_repeat1] = STATE(17638),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11955),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11957),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11959),
    [aux_sym__terminator_token2] = ACTIONS(11962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7764] = {
    [sym_block_comment] = STATE(7764),
    [sym_line_comment] = STATE(7764),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11965),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_end] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_else] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_finally] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11965),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11965),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11965),
    [anon_sym_DOLLAR] = ACTIONS(11965),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11965),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11965),
    [anon_sym_QMARK] = ACTIONS(11965),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11965),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11965),
    [aux_sym_integer_literal_token2] = ACTIONS(11965),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11965),
    [aux_sym_float_literal_token3] = ACTIONS(11965),
    [aux_sym_float_literal_token4] = ACTIONS(11965),
    [sym_character_literal] = ACTIONS(11965),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11965),
    [sym__pair_operator] = ACTIONS(11965),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11965),
    [sym__lazy_and_operator] = ACTIONS(11965),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11965),
    [sym__pipe_left_operator] = ACTIONS(11965),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11965),
    [sym__bitshift_operator] = ACTIONS(11965),
    [sym__power_operator] = ACTIONS(11965),
    [sym__tilde_operator] = ACTIONS(11965),
    [sym__type_order_operator] = ACTIONS(11965),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym__terminator_token1] = ACTIONS(11967),
    [aux_sym__terminator_token2] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7765] = {
    [sym_block_comment] = STATE(7765),
    [sym_line_comment] = STATE(7765),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7766] = {
    [sym_block_comment] = STATE(7766),
    [sym_line_comment] = STATE(7766),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9666),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7767] = {
    [sym_block_comment] = STATE(7767),
    [sym_line_comment] = STATE(7767),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11969),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_end] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_else] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_finally] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11969),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11969),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11969),
    [anon_sym_DOLLAR] = ACTIONS(11969),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11969),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11969),
    [anon_sym_QMARK] = ACTIONS(11969),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11969),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11969),
    [aux_sym_integer_literal_token2] = ACTIONS(11969),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11969),
    [aux_sym_float_literal_token3] = ACTIONS(11969),
    [aux_sym_float_literal_token4] = ACTIONS(11969),
    [sym_character_literal] = ACTIONS(11969),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11969),
    [sym__pair_operator] = ACTIONS(11969),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11969),
    [sym__lazy_and_operator] = ACTIONS(11969),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11969),
    [sym__pipe_left_operator] = ACTIONS(11969),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11969),
    [sym__bitshift_operator] = ACTIONS(11969),
    [sym__power_operator] = ACTIONS(11969),
    [sym__tilde_operator] = ACTIONS(11969),
    [sym__type_order_operator] = ACTIONS(11969),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym__terminator_token1] = ACTIONS(11971),
    [aux_sym__terminator_token2] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7768] = {
    [sym_block_comment] = STATE(7768),
    [sym_line_comment] = STATE(7768),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_finally] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7769] = {
    [sym_block_comment] = STATE(7769),
    [sym_line_comment] = STATE(7769),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_catch] = ACTIONS(9994),
    [anon_sym_finally] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7770] = {
    [sym_block_comment] = STATE(7770),
    [sym_line_comment] = STATE(7770),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7771] = {
    [sym_block_comment] = STATE(7771),
    [sym_line_comment] = STATE(7771),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_catch] = ACTIONS(9750),
    [anon_sym_finally] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7772] = {
    [sym_block_comment] = STATE(7772),
    [sym_line_comment] = STATE(7772),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9686),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7773] = {
    [sym_block_comment] = STATE(7773),
    [sym_line_comment] = STATE(7773),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_catch] = ACTIONS(9760),
    [anon_sym_finally] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7774] = {
    [sym_block_comment] = STATE(7774),
    [sym_line_comment] = STATE(7774),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_catch] = ACTIONS(10028),
    [anon_sym_finally] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7775] = {
    [sym_block_comment] = STATE(7775),
    [sym_line_comment] = STATE(7775),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_elseif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7776] = {
    [sym__comprehension_clause] = STATE(19385),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7776),
    [sym_line_comment] = STATE(7776),
    [aux_sym_vector_expression_repeat1] = STATE(17155),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11973),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11975),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11977),
    [aux_sym__terminator_token2] = ACTIONS(11980),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7777] = {
    [sym_block_comment] = STATE(7777),
    [sym_line_comment] = STATE(7777),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(11983),
    [sym__immediate_command_start] = ACTIONS(11985),
  },
  [7778] = {
    [sym_block_comment] = STATE(7778),
    [sym_line_comment] = STATE(7778),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7779] = {
    [sym_block_comment] = STATE(7779),
    [sym_line_comment] = STATE(7779),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7780] = {
    [sym_block_comment] = STATE(7780),
    [sym_line_comment] = STATE(7780),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7781] = {
    [sym_block_comment] = STATE(7781),
    [sym_line_comment] = STATE(7781),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_catch] = ACTIONS(10032),
    [anon_sym_finally] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7782] = {
    [sym_block_comment] = STATE(7782),
    [sym_line_comment] = STATE(7782),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_catch] = ACTIONS(10036),
    [anon_sym_finally] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7783] = {
    [sym_block_comment] = STATE(7783),
    [sym_line_comment] = STATE(7783),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7784] = {
    [sym__comprehension_clause] = STATE(18691),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7784),
    [sym_line_comment] = STATE(7784),
    [aux_sym_vector_expression_repeat1] = STATE(17251),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11987),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11989),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11991),
    [aux_sym__terminator_token2] = ACTIONS(11994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7785] = {
    [sym_block_comment] = STATE(7785),
    [sym_line_comment] = STATE(7785),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_catch] = ACTIONS(10040),
    [anon_sym_finally] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7786] = {
    [sym__comprehension_clause] = STATE(19004),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7786),
    [sym_line_comment] = STATE(7786),
    [aux_sym_vector_expression_repeat1] = STATE(17298),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11997),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11999),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12001),
    [aux_sym__terminator_token2] = ACTIONS(12004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7787] = {
    [sym_block_comment] = STATE(7787),
    [sym_line_comment] = STATE(7787),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(9854),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_elseif] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7788] = {
    [sym_block_comment] = STATE(7788),
    [sym_line_comment] = STATE(7788),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_elseif] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7789] = {
    [sym_block_comment] = STATE(7789),
    [sym_line_comment] = STATE(7789),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_catch] = ACTIONS(9788),
    [anon_sym_finally] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7790] = {
    [sym_block_comment] = STATE(7790),
    [sym_line_comment] = STATE(7790),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_catch] = ACTIONS(10044),
    [anon_sym_finally] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7791] = {
    [sym_block_comment] = STATE(7791),
    [sym_line_comment] = STATE(7791),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_catch] = ACTIONS(10048),
    [anon_sym_finally] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7792] = {
    [sym_block_comment] = STATE(7792),
    [sym_line_comment] = STATE(7792),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_catch] = ACTIONS(10052),
    [anon_sym_finally] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7793] = {
    [sym_block_comment] = STATE(7793),
    [sym_line_comment] = STATE(7793),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_catch] = ACTIONS(10056),
    [anon_sym_finally] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7794] = {
    [sym_block_comment] = STATE(7794),
    [sym_line_comment] = STATE(7794),
    [aux_sym_open_tuple_repeat1] = STATE(6933),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10906),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_elseif] = ACTIONS(10974),
    [anon_sym_else] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7795] = {
    [sym_block_comment] = STATE(7795),
    [sym_line_comment] = STATE(7795),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_RPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_RBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_SEMI] = ACTIONS(9644),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_RBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7796] = {
    [sym_block_comment] = STATE(7796),
    [sym_line_comment] = STATE(7796),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7797] = {
    [sym_block_comment] = STATE(7797),
    [sym_line_comment] = STATE(7797),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7798] = {
    [sym_block_comment] = STATE(7798),
    [sym_line_comment] = STATE(7798),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7799] = {
    [sym_block_comment] = STATE(7799),
    [sym_line_comment] = STATE(7799),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_catch] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7800] = {
    [sym_block_comment] = STATE(7800),
    [sym_line_comment] = STATE(7800),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_catch] = ACTIONS(9898),
    [anon_sym_finally] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7801] = {
    [sym_block_comment] = STATE(7801),
    [sym_line_comment] = STATE(7801),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_catch] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7802] = {
    [sym_block_comment] = STATE(7802),
    [sym_line_comment] = STATE(7802),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_QMARK] = ACTIONS(11287),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11287),
    [sym__lazy_and_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7803] = {
    [sym_block_comment] = STATE(7803),
    [sym_line_comment] = STATE(7803),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_RPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_RBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_SEMI] = ACTIONS(9664),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_RBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7804] = {
    [sym_block_comment] = STATE(7804),
    [sym_line_comment] = STATE(7804),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_catch] = ACTIONS(9982),
    [anon_sym_finally] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7805] = {
    [sym_block_comment] = STATE(7805),
    [sym_line_comment] = STATE(7805),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7806] = {
    [sym_block_comment] = STATE(7806),
    [sym_line_comment] = STATE(7806),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_else] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10978),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10978),
    [anon_sym_QMARK] = ACTIONS(10978),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10978),
    [sym__lazy_and_operator] = ACTIONS(10978),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10978),
    [sym__pipe_left_operator] = ACTIONS(10978),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10978),
    [sym__bitshift_operator] = ACTIONS(10978),
    [sym__power_operator] = ACTIONS(10978),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10978),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7807] = {
    [sym_block_comment] = STATE(7807),
    [sym_line_comment] = STATE(7807),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9686),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7808] = {
    [sym_block_comment] = STATE(7808),
    [sym_line_comment] = STATE(7808),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9860),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7809] = {
    [sym_block_comment] = STATE(7809),
    [sym_line_comment] = STATE(7809),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9942),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9718),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7810] = {
    [sym_block_comment] = STATE(7810),
    [sym_line_comment] = STATE(7810),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11263),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_elseif] = ACTIONS(11020),
    [anon_sym_else] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7811] = {
    [sym_block_comment] = STATE(7811),
    [sym_line_comment] = STATE(7811),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_catch] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7812] = {
    [sym__comprehension_clause] = STATE(18792),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7812),
    [sym_line_comment] = STATE(7812),
    [aux_sym_vector_expression_repeat1] = STATE(17287),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12007),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12009),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12011),
    [aux_sym__terminator_token2] = ACTIONS(12014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7813] = {
    [sym_block_comment] = STATE(7813),
    [sym_line_comment] = STATE(7813),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
  },
  [7814] = {
    [sym_block_comment] = STATE(7814),
    [sym_line_comment] = STATE(7814),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10910),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10910),
    [anon_sym_RPAREN] = ACTIONS(10910),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10910),
    [anon_sym_RBRACK] = ACTIONS(10910),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_SEMI] = ACTIONS(10910),
    [anon_sym_LBRACE] = ACTIONS(10910),
    [anon_sym_RBRACE] = ACTIONS(10910),
    [anon_sym_DOLLAR] = ACTIONS(10910),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10910),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10910),
    [anon_sym_QMARK] = ACTIONS(10910),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10910),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10910),
    [aux_sym_integer_literal_token2] = ACTIONS(10910),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10910),
    [aux_sym_float_literal_token3] = ACTIONS(10910),
    [aux_sym_float_literal_token4] = ACTIONS(10910),
    [sym_character_literal] = ACTIONS(10910),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10910),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10910),
    [sym__pair_operator] = ACTIONS(10910),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10910),
    [sym__lazy_and_operator] = ACTIONS(10910),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10910),
    [sym__pipe_left_operator] = ACTIONS(10910),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10910),
    [sym__bitshift_operator] = ACTIONS(10910),
    [sym__power_operator] = ACTIONS(10910),
    [sym__tilde_operator] = ACTIONS(10910),
    [sym__type_order_operator] = ACTIONS(10910),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7815] = {
    [sym_block_comment] = STATE(7815),
    [sym_line_comment] = STATE(7815),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9694),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7816] = {
    [sym_block_comment] = STATE(7816),
    [sym_line_comment] = STATE(7816),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11924),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_end] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_elseif] = ACTIONS(11924),
    [anon_sym_else] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11924),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11924),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11924),
    [anon_sym_DOLLAR] = ACTIONS(11924),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11924),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11924),
    [anon_sym_QMARK] = ACTIONS(11924),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11924),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11924),
    [aux_sym_integer_literal_token2] = ACTIONS(11924),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11924),
    [aux_sym_float_literal_token3] = ACTIONS(11924),
    [aux_sym_float_literal_token4] = ACTIONS(11924),
    [sym_character_literal] = ACTIONS(11924),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11924),
    [sym__pair_operator] = ACTIONS(11924),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11924),
    [sym__lazy_and_operator] = ACTIONS(11924),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11924),
    [sym__pipe_left_operator] = ACTIONS(11924),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11924),
    [sym__bitshift_operator] = ACTIONS(11924),
    [sym__power_operator] = ACTIONS(11924),
    [sym__tilde_operator] = ACTIONS(11924),
    [sym__type_order_operator] = ACTIONS(11924),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym__terminator_token1] = ACTIONS(11926),
    [aux_sym__terminator_token2] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7817] = {
    [sym__comprehension_clause] = STATE(18540),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7817),
    [sym_line_comment] = STATE(7817),
    [aux_sym_vector_expression_repeat1] = STATE(17449),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12017),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12019),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12021),
    [aux_sym__terminator_token2] = ACTIONS(12024),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7818] = {
    [sym_block_comment] = STATE(7818),
    [sym_line_comment] = STATE(7818),
    [ts_builtin_sym_end] = ACTIONS(10639),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_RBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(12027),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7819] = {
    [sym_block_comment] = STATE(7819),
    [sym_line_comment] = STATE(7819),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9648),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7820] = {
    [sym_block_comment] = STATE(7820),
    [sym_line_comment] = STATE(7820),
    [aux_sym_export_statement_repeat1] = STATE(7820),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(12029),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_finally] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7821] = {
    [sym_block_comment] = STATE(7821),
    [sym_line_comment] = STATE(7821),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(10890),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7822] = {
    [sym_block_comment] = STATE(7822),
    [sym_line_comment] = STATE(7822),
    [aux_sym_open_tuple_repeat1] = STATE(7837),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_catch] = ACTIONS(10829),
    [anon_sym_finally] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10829),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10829),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10829),
    [anon_sym_DOLLAR] = ACTIONS(10829),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10829),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10829),
    [anon_sym_QMARK] = ACTIONS(10829),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10829),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10829),
    [aux_sym_integer_literal_token2] = ACTIONS(10829),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10829),
    [aux_sym_float_literal_token3] = ACTIONS(10829),
    [aux_sym_float_literal_token4] = ACTIONS(10829),
    [sym_character_literal] = ACTIONS(10829),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10829),
    [sym__pair_operator] = ACTIONS(10829),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10829),
    [sym__lazy_and_operator] = ACTIONS(10829),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10829),
    [sym__pipe_left_operator] = ACTIONS(10829),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10829),
    [sym__bitshift_operator] = ACTIONS(10829),
    [sym__power_operator] = ACTIONS(10829),
    [sym__tilde_operator] = ACTIONS(10829),
    [sym__type_order_operator] = ACTIONS(10829),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym__terminator_token1] = ACTIONS(10833),
    [aux_sym__terminator_token2] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7823] = {
    [sym_block_comment] = STATE(7823),
    [sym_line_comment] = STATE(7823),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_RPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_RBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_SEMI] = ACTIONS(9928),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_RBRACE] = ACTIONS(9928),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7824] = {
    [sym_block_comment] = STATE(7824),
    [sym_line_comment] = STATE(7824),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7825] = {
    [sym_block_comment] = STATE(7825),
    [sym_line_comment] = STATE(7825),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(10992),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7826] = {
    [sym_block_comment] = STATE(7826),
    [sym_line_comment] = STATE(7826),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7827] = {
    [sym_block_comment] = STATE(7827),
    [sym_line_comment] = STATE(7827),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7828] = {
    [sym_block_comment] = STATE(7828),
    [sym_line_comment] = STATE(7828),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7829] = {
    [sym_block_comment] = STATE(7829),
    [sym_line_comment] = STATE(7829),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7830] = {
    [sym_block_comment] = STATE(7830),
    [sym_line_comment] = STATE(7830),
    [aux_sym__import_list_repeat1] = STATE(7830),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(12032),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7831] = {
    [sym_block_comment] = STATE(7831),
    [sym_line_comment] = STATE(7831),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7832] = {
    [sym_block_comment] = STATE(7832),
    [sym_line_comment] = STATE(7832),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7833] = {
    [sym_block_comment] = STATE(7833),
    [sym_line_comment] = STATE(7833),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7834] = {
    [sym_block_comment] = STATE(7834),
    [sym_line_comment] = STATE(7834),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7835] = {
    [sym_block_comment] = STATE(7835),
    [sym_line_comment] = STATE(7835),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7836] = {
    [sym_block_comment] = STATE(7836),
    [sym_line_comment] = STATE(7836),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7837] = {
    [sym_block_comment] = STATE(7837),
    [sym_line_comment] = STATE(7837),
    [aux_sym_open_tuple_repeat1] = STATE(7837),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(12035),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_catch] = ACTIONS(10835),
    [anon_sym_finally] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10835),
    [anon_sym_QMARK] = ACTIONS(10835),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10835),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10835),
    [sym__lazy_and_operator] = ACTIONS(10835),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10835),
    [sym__pipe_left_operator] = ACTIONS(10835),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10835),
    [sym__bitshift_operator] = ACTIONS(10835),
    [sym__power_operator] = ACTIONS(10835),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10835),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7838] = {
    [sym_block_comment] = STATE(7838),
    [sym_line_comment] = STATE(7838),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11941),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_end] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_elseif] = ACTIONS(11941),
    [anon_sym_else] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11941),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11941),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11941),
    [anon_sym_DOLLAR] = ACTIONS(11941),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11941),
    [anon_sym_QMARK] = ACTIONS(11941),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11941),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11941),
    [aux_sym_integer_literal_token2] = ACTIONS(11941),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11941),
    [aux_sym_float_literal_token3] = ACTIONS(11941),
    [aux_sym_float_literal_token4] = ACTIONS(11941),
    [sym_character_literal] = ACTIONS(11941),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11941),
    [sym__pair_operator] = ACTIONS(11941),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11941),
    [sym__lazy_and_operator] = ACTIONS(11941),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11941),
    [sym__pipe_left_operator] = ACTIONS(11941),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11941),
    [sym__bitshift_operator] = ACTIONS(11941),
    [sym__power_operator] = ACTIONS(11941),
    [sym__tilde_operator] = ACTIONS(11941),
    [sym__type_order_operator] = ACTIONS(11941),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym__terminator_token1] = ACTIONS(11943),
    [aux_sym__terminator_token2] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7839] = {
    [sym_block_comment] = STATE(7839),
    [sym_line_comment] = STATE(7839),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11965),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_end] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_elseif] = ACTIONS(11965),
    [anon_sym_else] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11965),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11965),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11965),
    [anon_sym_DOLLAR] = ACTIONS(11965),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11965),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11965),
    [anon_sym_QMARK] = ACTIONS(11965),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11965),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11965),
    [aux_sym_integer_literal_token2] = ACTIONS(11965),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11965),
    [aux_sym_float_literal_token3] = ACTIONS(11965),
    [aux_sym_float_literal_token4] = ACTIONS(11965),
    [sym_character_literal] = ACTIONS(11965),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11965),
    [sym__pair_operator] = ACTIONS(11965),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11965),
    [sym__lazy_and_operator] = ACTIONS(11965),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11965),
    [sym__pipe_left_operator] = ACTIONS(11965),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11965),
    [sym__bitshift_operator] = ACTIONS(11965),
    [sym__power_operator] = ACTIONS(11965),
    [sym__tilde_operator] = ACTIONS(11965),
    [sym__type_order_operator] = ACTIONS(11965),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym__terminator_token1] = ACTIONS(11967),
    [aux_sym__terminator_token2] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7840] = {
    [sym_block_comment] = STATE(7840),
    [sym_line_comment] = STATE(7840),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7841] = {
    [sym__comprehension_clause] = STATE(18472),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7841),
    [sym_line_comment] = STATE(7841),
    [aux_sym_vector_expression_repeat1] = STATE(17489),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12038),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12040),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12042),
    [aux_sym__terminator_token2] = ACTIONS(12045),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7842] = {
    [sym_block_comment] = STATE(7842),
    [sym_line_comment] = STATE(7842),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11108),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7843] = {
    [sym_block_comment] = STATE(7843),
    [sym_line_comment] = STATE(7843),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(11983),
    [sym__immediate_command_start] = ACTIONS(11985),
  },
  [7844] = {
    [sym_block_comment] = STATE(7844),
    [sym_line_comment] = STATE(7844),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_catch] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7845] = {
    [sym_block_comment] = STATE(7845),
    [sym_line_comment] = STATE(7845),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
  },
  [7846] = {
    [sym_block_comment] = STATE(7846),
    [sym_line_comment] = STATE(7846),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11969),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_end] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_elseif] = ACTIONS(11969),
    [anon_sym_else] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11969),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11969),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11969),
    [anon_sym_DOLLAR] = ACTIONS(11969),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11969),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11969),
    [anon_sym_QMARK] = ACTIONS(11969),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11969),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11969),
    [aux_sym_integer_literal_token2] = ACTIONS(11969),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11969),
    [aux_sym_float_literal_token3] = ACTIONS(11969),
    [aux_sym_float_literal_token4] = ACTIONS(11969),
    [sym_character_literal] = ACTIONS(11969),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11969),
    [sym__pair_operator] = ACTIONS(11969),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11969),
    [sym__lazy_and_operator] = ACTIONS(11969),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11969),
    [sym__pipe_left_operator] = ACTIONS(11969),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11969),
    [sym__bitshift_operator] = ACTIONS(11969),
    [sym__power_operator] = ACTIONS(11969),
    [sym__tilde_operator] = ACTIONS(11969),
    [sym__type_order_operator] = ACTIONS(11969),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym__terminator_token1] = ACTIONS(11971),
    [aux_sym__terminator_token2] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7847] = {
    [sym_block_comment] = STATE(7847),
    [sym_line_comment] = STATE(7847),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_finally] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7848] = {
    [sym_block_comment] = STATE(7848),
    [sym_line_comment] = STATE(7848),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_elseif] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12050),
    [aux_sym__terminator_token2] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7849] = {
    [sym_block_comment] = STATE(7849),
    [sym_line_comment] = STATE(7849),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_end] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_elseif] = ACTIONS(12052),
    [anon_sym_else] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [aux_sym__terminator_token2] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7850] = {
    [sym_block_comment] = STATE(7850),
    [sym_line_comment] = STATE(7850),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_finally] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7851] = {
    [sym_block_comment] = STATE(7851),
    [sym_line_comment] = STATE(7851),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_finally] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7852] = {
    [sym_block_comment] = STATE(7852),
    [sym_line_comment] = STATE(7852),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_catch] = ACTIONS(9642),
    [anon_sym_finally] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7853] = {
    [sym_block_comment] = STATE(7853),
    [sym_line_comment] = STATE(7853),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11269),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_end] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_else] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_finally] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11269),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11269),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11269),
    [anon_sym_DOLLAR] = ACTIONS(11269),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11269),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11269),
    [anon_sym_QMARK] = ACTIONS(11269),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11269),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11269),
    [aux_sym_integer_literal_token2] = ACTIONS(11269),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11269),
    [aux_sym_float_literal_token3] = ACTIONS(11269),
    [aux_sym_float_literal_token4] = ACTIONS(11269),
    [sym_character_literal] = ACTIONS(11269),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11269),
    [sym__pair_operator] = ACTIONS(11269),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11269),
    [sym__lazy_and_operator] = ACTIONS(11269),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11269),
    [sym__pipe_left_operator] = ACTIONS(11269),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11269),
    [sym__bitshift_operator] = ACTIONS(11269),
    [sym__power_operator] = ACTIONS(11269),
    [sym__tilde_operator] = ACTIONS(11269),
    [sym__type_order_operator] = ACTIONS(11269),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym__terminator_token1] = ACTIONS(11271),
    [aux_sym__terminator_token2] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7854] = {
    [sym_block_comment] = STATE(7854),
    [sym_line_comment] = STATE(7854),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_catch] = ACTIONS(10068),
    [anon_sym_finally] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7855] = {
    [sym_block_comment] = STATE(7855),
    [sym_line_comment] = STATE(7855),
    [ts_builtin_sym_end] = ACTIONS(10118),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_RBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7856] = {
    [sym_block_comment] = STATE(7856),
    [sym_line_comment] = STATE(7856),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_catch] = ACTIONS(10072),
    [anon_sym_finally] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7857] = {
    [sym_block_comment] = STATE(7857),
    [sym_line_comment] = STATE(7857),
    [aux_sym_export_statement_repeat1] = STATE(7857),
    [ts_builtin_sym_end] = ACTIONS(10855),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(12056),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_RBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7858] = {
    [sym_block_comment] = STATE(7858),
    [sym_line_comment] = STATE(7858),
    [ts_builtin_sym_end] = ACTIONS(10863),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(10919),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_RBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7859] = {
    [sym__comprehension_clause] = STATE(18880),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7859),
    [sym_line_comment] = STATE(7859),
    [aux_sym_vector_expression_repeat1] = STATE(17082),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12059),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12061),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12063),
    [aux_sym__terminator_token2] = ACTIONS(12066),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7860] = {
    [sym_block_comment] = STATE(7860),
    [sym_line_comment] = STATE(7860),
    [aux_sym__import_list_repeat1] = STATE(7860),
    [ts_builtin_sym_end] = ACTIONS(10863),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_RBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7861] = {
    [sym__comprehension_clause] = STATE(19008),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7861),
    [sym_line_comment] = STATE(7861),
    [aux_sym_vector_expression_repeat1] = STATE(17408),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12072),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12074),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12076),
    [aux_sym__terminator_token2] = ACTIONS(12079),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7862] = {
    [sym_block_comment] = STATE(7862),
    [sym_line_comment] = STATE(7862),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_else] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12050),
    [aux_sym__terminator_token2] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7863] = {
    [sym_block_comment] = STATE(7863),
    [sym_line_comment] = STATE(7863),
    [ts_builtin_sym_end] = ACTIONS(9716),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_RBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7864] = {
    [sym_block_comment] = STATE(7864),
    [sym_line_comment] = STATE(7864),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10090),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9972),
  },
  [7865] = {
    [sym_block_comment] = STATE(7865),
    [sym_line_comment] = STATE(7865),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9906),
  },
  [7866] = {
    [sym_block_comment] = STATE(7866),
    [sym_line_comment] = STATE(7866),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_end] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_elseif] = ACTIONS(11898),
    [anon_sym_else] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym__terminator_token1] = ACTIONS(11900),
    [aux_sym__terminator_token2] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7867] = {
    [sym_block_comment] = STATE(7867),
    [sym_line_comment] = STATE(7867),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7868] = {
    [sym_block_comment] = STATE(7868),
    [sym_line_comment] = STATE(7868),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_end] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_else] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_finally] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11279),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11279),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11279),
    [anon_sym_DOLLAR] = ACTIONS(11279),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11279),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11279),
    [anon_sym_QMARK] = ACTIONS(11279),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11279),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11279),
    [aux_sym_integer_literal_token2] = ACTIONS(11279),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11279),
    [aux_sym_float_literal_token3] = ACTIONS(11279),
    [aux_sym_float_literal_token4] = ACTIONS(11279),
    [sym_character_literal] = ACTIONS(11279),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11279),
    [sym__pair_operator] = ACTIONS(11279),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11279),
    [sym__lazy_and_operator] = ACTIONS(11279),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11279),
    [sym__pipe_left_operator] = ACTIONS(11279),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11279),
    [sym__bitshift_operator] = ACTIONS(11279),
    [sym__power_operator] = ACTIONS(11279),
    [sym__tilde_operator] = ACTIONS(11279),
    [sym__type_order_operator] = ACTIONS(11279),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym__terminator_token1] = ACTIONS(11281),
    [aux_sym__terminator_token2] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7869] = {
    [sym_block_comment] = STATE(7869),
    [sym_line_comment] = STATE(7869),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11173),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_end] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_elseif] = ACTIONS(11173),
    [anon_sym_else] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11173),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11173),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11173),
    [anon_sym_DOLLAR] = ACTIONS(11173),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11173),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11173),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11173),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11173),
    [aux_sym_integer_literal_token2] = ACTIONS(11173),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11173),
    [aux_sym_float_literal_token3] = ACTIONS(11173),
    [aux_sym_float_literal_token4] = ACTIONS(11173),
    [sym_character_literal] = ACTIONS(11173),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11173),
    [sym__pair_operator] = ACTIONS(11173),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11173),
    [sym__lazy_and_operator] = ACTIONS(11173),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11173),
    [sym__pipe_left_operator] = ACTIONS(11173),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11173),
    [sym__bitshift_operator] = ACTIONS(11173),
    [sym__power_operator] = ACTIONS(11173),
    [sym__tilde_operator] = ACTIONS(11173),
    [sym__type_order_operator] = ACTIONS(11173),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym__terminator_token1] = ACTIONS(11175),
    [aux_sym__terminator_token2] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7870] = {
    [sym_block_comment] = STATE(7870),
    [sym_line_comment] = STATE(7870),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10090),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9720),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7871] = {
    [sym_block_comment] = STATE(7871),
    [sym_line_comment] = STATE(7871),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_RPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_RBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_SEMI] = ACTIONS(10639),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_RBRACE] = ACTIONS(10639),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7872] = {
    [sym_block_comment] = STATE(7872),
    [sym_line_comment] = STATE(7872),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_catch] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7873] = {
    [sym__comprehension_clause] = STATE(18709),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7873),
    [sym_line_comment] = STATE(7873),
    [aux_sym_vector_expression_repeat1] = STATE(17545),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12082),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12084),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12086),
    [aux_sym__terminator_token2] = ACTIONS(12089),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7874] = {
    [sym_block_comment] = STATE(7874),
    [sym_line_comment] = STATE(7874),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7875] = {
    [sym_block_comment] = STATE(7875),
    [sym_line_comment] = STATE(7875),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_RPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_RBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_SEMI] = ACTIONS(9960),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_RBRACE] = ACTIONS(9960),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7876] = {
    [sym_block_comment] = STATE(7876),
    [sym_line_comment] = STATE(7876),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_end] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_else] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_finally] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [aux_sym__terminator_token2] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7877] = {
    [sym_block_comment] = STATE(7877),
    [sym_line_comment] = STATE(7877),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_finally] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7878] = {
    [sym__comprehension_clause] = STATE(19007),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7878),
    [sym_line_comment] = STATE(7878),
    [aux_sym_vector_expression_repeat1] = STATE(17384),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12092),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12096),
    [aux_sym__terminator_token2] = ACTIONS(12099),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7879] = {
    [sym_block_comment] = STATE(7879),
    [sym_line_comment] = STATE(7879),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7880] = {
    [sym_block_comment] = STATE(7880),
    [sym_line_comment] = STATE(7880),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11309),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_end] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_else] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_finally] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11309),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11309),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11309),
    [anon_sym_DOLLAR] = ACTIONS(11309),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11309),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11309),
    [anon_sym_QMARK] = ACTIONS(11309),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11309),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11309),
    [aux_sym_integer_literal_token2] = ACTIONS(11309),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11309),
    [aux_sym_float_literal_token3] = ACTIONS(11309),
    [aux_sym_float_literal_token4] = ACTIONS(11309),
    [sym_character_literal] = ACTIONS(11309),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11309),
    [sym__pair_operator] = ACTIONS(11309),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11309),
    [sym__lazy_and_operator] = ACTIONS(11309),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11309),
    [sym__pipe_left_operator] = ACTIONS(11309),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11309),
    [sym__bitshift_operator] = ACTIONS(11309),
    [sym__power_operator] = ACTIONS(11309),
    [sym__tilde_operator] = ACTIONS(11309),
    [sym__type_order_operator] = ACTIONS(11309),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym__terminator_token1] = ACTIONS(11311),
    [aux_sym__terminator_token2] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7881] = {
    [sym_block_comment] = STATE(7881),
    [sym_line_comment] = STATE(7881),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11317),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_end] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_else] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_finally] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11317),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11317),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11317),
    [anon_sym_DOLLAR] = ACTIONS(11317),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11317),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11317),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11317),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11317),
    [aux_sym_integer_literal_token2] = ACTIONS(11317),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11317),
    [aux_sym_float_literal_token3] = ACTIONS(11317),
    [aux_sym_float_literal_token4] = ACTIONS(11317),
    [sym_character_literal] = ACTIONS(11317),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11317),
    [sym__pair_operator] = ACTIONS(11317),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11317),
    [sym__lazy_and_operator] = ACTIONS(11317),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11317),
    [sym__pipe_left_operator] = ACTIONS(11317),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11317),
    [sym__bitshift_operator] = ACTIONS(11317),
    [sym__power_operator] = ACTIONS(11317),
    [sym__tilde_operator] = ACTIONS(11317),
    [sym__type_order_operator] = ACTIONS(11317),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym__terminator_token1] = ACTIONS(11319),
    [aux_sym__terminator_token2] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7882] = {
    [sym_block_comment] = STATE(7882),
    [sym_line_comment] = STATE(7882),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11456),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_end] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_else] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_finally] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11456),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11456),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11456),
    [anon_sym_DOLLAR] = ACTIONS(11456),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11456),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11456),
    [anon_sym_QMARK] = ACTIONS(11456),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11456),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11456),
    [aux_sym_integer_literal_token2] = ACTIONS(11456),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11456),
    [aux_sym_float_literal_token3] = ACTIONS(11456),
    [aux_sym_float_literal_token4] = ACTIONS(11456),
    [sym_character_literal] = ACTIONS(11456),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11456),
    [sym__pair_operator] = ACTIONS(11456),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11456),
    [sym__lazy_and_operator] = ACTIONS(11456),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11456),
    [sym__pipe_left_operator] = ACTIONS(11456),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11456),
    [sym__bitshift_operator] = ACTIONS(11456),
    [sym__power_operator] = ACTIONS(11456),
    [sym__tilde_operator] = ACTIONS(11456),
    [sym__type_order_operator] = ACTIONS(11456),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym__terminator_token1] = ACTIONS(11458),
    [aux_sym__terminator_token2] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7883] = {
    [sym__comprehension_clause] = STATE(18463),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7883),
    [sym_line_comment] = STATE(7883),
    [aux_sym_vector_expression_repeat1] = STATE(17145),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12102),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12104),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12106),
    [aux_sym__terminator_token2] = ACTIONS(12109),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7884] = {
    [sym_block_comment] = STATE(7884),
    [sym_line_comment] = STATE(7884),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11359),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_end] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_else] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_finally] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11359),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11359),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11359),
    [anon_sym_DOLLAR] = ACTIONS(11359),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11359),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11359),
    [anon_sym_QMARK] = ACTIONS(11359),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11359),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11359),
    [aux_sym_integer_literal_token2] = ACTIONS(11359),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11359),
    [aux_sym_float_literal_token3] = ACTIONS(11359),
    [aux_sym_float_literal_token4] = ACTIONS(11359),
    [sym_character_literal] = ACTIONS(11359),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11359),
    [sym__pair_operator] = ACTIONS(11359),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11359),
    [sym__lazy_and_operator] = ACTIONS(11359),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11359),
    [sym__pipe_left_operator] = ACTIONS(11359),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11359),
    [sym__bitshift_operator] = ACTIONS(11359),
    [sym__power_operator] = ACTIONS(11359),
    [sym__tilde_operator] = ACTIONS(11359),
    [sym__type_order_operator] = ACTIONS(11359),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym__terminator_token1] = ACTIONS(11361),
    [aux_sym__terminator_token2] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7885] = {
    [sym_block_comment] = STATE(7885),
    [sym_line_comment] = STATE(7885),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9666),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7886] = {
    [sym_block_comment] = STATE(7886),
    [sym_line_comment] = STATE(7886),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11381),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_end] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_else] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_finally] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11381),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11381),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11381),
    [anon_sym_DOLLAR] = ACTIONS(11381),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11381),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11381),
    [anon_sym_QMARK] = ACTIONS(11381),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11381),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11381),
    [aux_sym_integer_literal_token2] = ACTIONS(11381),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11381),
    [aux_sym_float_literal_token3] = ACTIONS(11381),
    [aux_sym_float_literal_token4] = ACTIONS(11381),
    [sym_character_literal] = ACTIONS(11381),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11381),
    [sym__pair_operator] = ACTIONS(11381),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11381),
    [sym__lazy_and_operator] = ACTIONS(11381),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11381),
    [sym__pipe_left_operator] = ACTIONS(11381),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11381),
    [sym__bitshift_operator] = ACTIONS(11381),
    [sym__power_operator] = ACTIONS(11381),
    [sym__tilde_operator] = ACTIONS(11381),
    [sym__type_order_operator] = ACTIONS(11381),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym__terminator_token1] = ACTIONS(11383),
    [aux_sym__terminator_token2] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7887] = {
    [sym__comprehension_clause] = STATE(19168),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7887),
    [sym_line_comment] = STATE(7887),
    [aux_sym_vector_expression_repeat1] = STATE(17264),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12112),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12114),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12116),
    [aux_sym__terminator_token2] = ACTIONS(12119),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7888] = {
    [sym_block_comment] = STATE(7888),
    [sym_line_comment] = STATE(7888),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7889] = {
    [sym_block_comment] = STATE(7889),
    [sym_line_comment] = STATE(7889),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_catch] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10848),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7890] = {
    [sym_block_comment] = STATE(7890),
    [sym_line_comment] = STATE(7890),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_catch] = ACTIONS(10134),
    [anon_sym_finally] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7891] = {
    [sym_block_comment] = STATE(7891),
    [sym_line_comment] = STATE(7891),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11407),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_end] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_else] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_finally] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11407),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11407),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11407),
    [anon_sym_DOLLAR] = ACTIONS(11407),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11407),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11407),
    [anon_sym_QMARK] = ACTIONS(11407),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11407),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11407),
    [aux_sym_integer_literal_token2] = ACTIONS(11407),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11407),
    [aux_sym_float_literal_token3] = ACTIONS(11407),
    [aux_sym_float_literal_token4] = ACTIONS(11407),
    [sym_character_literal] = ACTIONS(11407),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11407),
    [sym__pair_operator] = ACTIONS(11407),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11407),
    [sym__lazy_and_operator] = ACTIONS(11407),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11407),
    [sym__pipe_left_operator] = ACTIONS(11407),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11407),
    [sym__bitshift_operator] = ACTIONS(11407),
    [sym__power_operator] = ACTIONS(11407),
    [sym__tilde_operator] = ACTIONS(11407),
    [sym__type_order_operator] = ACTIONS(11407),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym__terminator_token1] = ACTIONS(11409),
    [aux_sym__terminator_token2] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7892] = {
    [sym__comprehension_clause] = STATE(18402),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7892),
    [sym_line_comment] = STATE(7892),
    [aux_sym_vector_expression_repeat1] = STATE(17338),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12122),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12124),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12126),
    [aux_sym__terminator_token2] = ACTIONS(12129),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7893] = {
    [sym_block_comment] = STATE(7893),
    [sym_line_comment] = STATE(7893),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
  },
  [7894] = {
    [sym_block_comment] = STATE(7894),
    [sym_line_comment] = STATE(7894),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9948),
  },
  [7895] = {
    [sym_block_comment] = STATE(7895),
    [sym_line_comment] = STATE(7895),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7896] = {
    [sym_block_comment] = STATE(7896),
    [sym_line_comment] = STATE(7896),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7897] = {
    [sym_block_comment] = STATE(7897),
    [sym_line_comment] = STATE(7897),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_RPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_RBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_SEMI] = ACTIONS(10118),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_RBRACE] = ACTIONS(10118),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7898] = {
    [sym_block_comment] = STATE(7898),
    [sym_line_comment] = STATE(7898),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11033),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_end] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_elseif] = ACTIONS(11033),
    [anon_sym_else] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11033),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11033),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11033),
    [anon_sym_DOLLAR] = ACTIONS(11033),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11033),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11033),
    [anon_sym_QMARK] = ACTIONS(11033),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11033),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11033),
    [aux_sym_integer_literal_token2] = ACTIONS(11033),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11033),
    [aux_sym_float_literal_token3] = ACTIONS(11033),
    [aux_sym_float_literal_token4] = ACTIONS(11033),
    [sym_character_literal] = ACTIONS(11033),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11033),
    [sym__pair_operator] = ACTIONS(11033),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11033),
    [sym__lazy_and_operator] = ACTIONS(11033),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11033),
    [sym__pipe_left_operator] = ACTIONS(11033),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11033),
    [sym__bitshift_operator] = ACTIONS(11033),
    [sym__power_operator] = ACTIONS(11033),
    [sym__tilde_operator] = ACTIONS(11033),
    [sym__type_order_operator] = ACTIONS(11033),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym__terminator_token1] = ACTIONS(11035),
    [aux_sym__terminator_token2] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7899] = {
    [sym_block_comment] = STATE(7899),
    [sym_line_comment] = STATE(7899),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9656),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7900] = {
    [sym_block_comment] = STATE(7900),
    [sym_line_comment] = STATE(7900),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_RPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_RBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_SEMI] = ACTIONS(10639),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_RBRACE] = ACTIONS(10639),
    [anon_sym_DOT] = ACTIONS(12132),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7901] = {
    [sym_block_comment] = STATE(7901),
    [sym_line_comment] = STATE(7901),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11039),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_end] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_elseif] = ACTIONS(11039),
    [anon_sym_else] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11039),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11039),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11039),
    [anon_sym_DOLLAR] = ACTIONS(11039),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11039),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11039),
    [anon_sym_QMARK] = ACTIONS(11039),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11039),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11039),
    [aux_sym_integer_literal_token2] = ACTIONS(11039),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11039),
    [aux_sym_float_literal_token3] = ACTIONS(11039),
    [aux_sym_float_literal_token4] = ACTIONS(11039),
    [sym_character_literal] = ACTIONS(11039),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11039),
    [sym__pair_operator] = ACTIONS(11039),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11039),
    [sym__lazy_and_operator] = ACTIONS(11039),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11039),
    [sym__pipe_left_operator] = ACTIONS(11039),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11039),
    [sym__bitshift_operator] = ACTIONS(11039),
    [sym__power_operator] = ACTIONS(11039),
    [sym__tilde_operator] = ACTIONS(11039),
    [sym__type_order_operator] = ACTIONS(11039),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym__terminator_token1] = ACTIONS(11041),
    [aux_sym__terminator_token2] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7902] = {
    [sym_block_comment] = STATE(7902),
    [sym_line_comment] = STATE(7902),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11247),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11247),
    [anon_sym_QMARK] = ACTIONS(11247),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11247),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11247),
    [sym__lazy_and_operator] = ACTIONS(11247),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11247),
    [sym__pipe_left_operator] = ACTIONS(11247),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11247),
    [sym__bitshift_operator] = ACTIONS(11247),
    [sym__power_operator] = ACTIONS(11247),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11247),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7903] = {
    [sym_block_comment] = STATE(7903),
    [sym_line_comment] = STATE(7903),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_catch] = ACTIONS(9912),
    [anon_sym_finally] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7904] = {
    [sym_block_comment] = STATE(7904),
    [sym_line_comment] = STATE(7904),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_finally] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7905] = {
    [sym_block_comment] = STATE(7905),
    [sym_line_comment] = STATE(7905),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [7906] = {
    [sym_block_comment] = STATE(7906),
    [sym_line_comment] = STATE(7906),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11251),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_end] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_elseif] = ACTIONS(11251),
    [anon_sym_else] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11251),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11251),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11251),
    [anon_sym_DOLLAR] = ACTIONS(11251),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11251),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11251),
    [anon_sym_QMARK] = ACTIONS(11251),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11251),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11251),
    [aux_sym_integer_literal_token2] = ACTIONS(11251),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11251),
    [aux_sym_float_literal_token3] = ACTIONS(11251),
    [aux_sym_float_literal_token4] = ACTIONS(11251),
    [sym_character_literal] = ACTIONS(11251),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11251),
    [sym__pair_operator] = ACTIONS(11251),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11251),
    [sym__lazy_and_operator] = ACTIONS(11251),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11251),
    [sym__pipe_left_operator] = ACTIONS(11251),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11251),
    [sym__bitshift_operator] = ACTIONS(11251),
    [sym__power_operator] = ACTIONS(11251),
    [sym__tilde_operator] = ACTIONS(11251),
    [sym__type_order_operator] = ACTIONS(11251),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym__terminator_token1] = ACTIONS(11253),
    [aux_sym__terminator_token2] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7907] = {
    [sym__comprehension_clause] = STATE(18233),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7907),
    [sym_line_comment] = STATE(7907),
    [aux_sym_vector_expression_repeat1] = STATE(17614),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12134),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12136),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12138),
    [aux_sym__terminator_token2] = ACTIONS(12141),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7908] = {
    [sym_block_comment] = STATE(7908),
    [sym_line_comment] = STATE(7908),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7909] = {
    [sym_block_comment] = STATE(7909),
    [sym_line_comment] = STATE(7909),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7910] = {
    [sym_block_comment] = STATE(7910),
    [sym_line_comment] = STATE(7910),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_catch] = ACTIONS(10152),
    [anon_sym_finally] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7911] = {
    [sym_block_comment] = STATE(7911),
    [sym_line_comment] = STATE(7911),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9694),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7912] = {
    [sym_block_comment] = STATE(7912),
    [sym_line_comment] = STATE(7912),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_catch] = ACTIONS(10000),
    [anon_sym_finally] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7913] = {
    [sym_block_comment] = STATE(7913),
    [sym_line_comment] = STATE(7913),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_finally] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(10859),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7914] = {
    [sym_block_comment] = STATE(7914),
    [sym_line_comment] = STATE(7914),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7915] = {
    [sym_block_comment] = STATE(7915),
    [sym_line_comment] = STATE(7915),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11259),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_end] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_elseif] = ACTIONS(11259),
    [anon_sym_else] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11259),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11259),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11259),
    [anon_sym_DOLLAR] = ACTIONS(11259),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11259),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11259),
    [anon_sym_QMARK] = ACTIONS(11259),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11259),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11259),
    [aux_sym_integer_literal_token2] = ACTIONS(11259),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11259),
    [aux_sym_float_literal_token3] = ACTIONS(11259),
    [aux_sym_float_literal_token4] = ACTIONS(11259),
    [sym_character_literal] = ACTIONS(11259),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11259),
    [sym__pair_operator] = ACTIONS(11259),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11259),
    [sym__lazy_and_operator] = ACTIONS(11259),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11259),
    [sym__pipe_left_operator] = ACTIONS(11259),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11259),
    [sym__bitshift_operator] = ACTIONS(11259),
    [sym__power_operator] = ACTIONS(11259),
    [sym__tilde_operator] = ACTIONS(11259),
    [sym__type_order_operator] = ACTIONS(11259),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym__terminator_token1] = ACTIONS(11261),
    [aux_sym__terminator_token2] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7916] = {
    [sym_block_comment] = STATE(7916),
    [sym_line_comment] = STATE(7916),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
  },
  [7917] = {
    [sym_block_comment] = STATE(7917),
    [sym_line_comment] = STATE(7917),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11331),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_end] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_else] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_finally] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11331),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11331),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11331),
    [anon_sym_DOLLAR] = ACTIONS(11331),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11331),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11331),
    [anon_sym_QMARK] = ACTIONS(11331),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11331),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11331),
    [aux_sym_integer_literal_token2] = ACTIONS(11331),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11331),
    [aux_sym_float_literal_token3] = ACTIONS(11331),
    [aux_sym_float_literal_token4] = ACTIONS(11331),
    [sym_character_literal] = ACTIONS(11331),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11331),
    [sym__pair_operator] = ACTIONS(11331),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11331),
    [sym__lazy_and_operator] = ACTIONS(11331),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11331),
    [sym__pipe_left_operator] = ACTIONS(11331),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11331),
    [sym__bitshift_operator] = ACTIONS(11331),
    [sym__power_operator] = ACTIONS(11331),
    [sym__tilde_operator] = ACTIONS(11331),
    [sym__type_order_operator] = ACTIONS(11331),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym__terminator_token1] = ACTIONS(11333),
    [aux_sym__terminator_token2] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7918] = {
    [sym_block_comment] = STATE(7918),
    [sym_line_comment] = STATE(7918),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_else] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_finally] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11335),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_DOLLAR] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11335),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11335),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11335),
    [aux_sym_integer_literal_token2] = ACTIONS(11335),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11335),
    [aux_sym_float_literal_token3] = ACTIONS(11335),
    [aux_sym_float_literal_token4] = ACTIONS(11335),
    [sym_character_literal] = ACTIONS(11335),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11335),
    [sym__pair_operator] = ACTIONS(11335),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11335),
    [sym__lazy_and_operator] = ACTIONS(11335),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11335),
    [sym__pipe_left_operator] = ACTIONS(11335),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11335),
    [sym__bitshift_operator] = ACTIONS(11335),
    [sym__power_operator] = ACTIONS(11335),
    [sym__tilde_operator] = ACTIONS(11335),
    [sym__type_order_operator] = ACTIONS(11335),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym__terminator_token1] = ACTIONS(11337),
    [aux_sym__terminator_token2] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7919] = {
    [sym_block_comment] = STATE(7919),
    [sym_line_comment] = STATE(7919),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_end] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_else] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_finally] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11339),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11339),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11339),
    [anon_sym_DOLLAR] = ACTIONS(11339),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11339),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(11339),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11339),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11339),
    [aux_sym_integer_literal_token2] = ACTIONS(11339),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11339),
    [aux_sym_float_literal_token3] = ACTIONS(11339),
    [aux_sym_float_literal_token4] = ACTIONS(11339),
    [sym_character_literal] = ACTIONS(11339),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11339),
    [sym__pair_operator] = ACTIONS(11339),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11339),
    [sym__lazy_and_operator] = ACTIONS(11339),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11339),
    [sym__pipe_left_operator] = ACTIONS(11339),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11339),
    [sym__bitshift_operator] = ACTIONS(11339),
    [sym__power_operator] = ACTIONS(11339),
    [sym__tilde_operator] = ACTIONS(11339),
    [sym__type_order_operator] = ACTIONS(11339),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym__terminator_token1] = ACTIONS(11341),
    [aux_sym__terminator_token2] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7920] = {
    [sym_block_comment] = STATE(7920),
    [sym_line_comment] = STATE(7920),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11343),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_end] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_else] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_finally] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11343),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11343),
    [anon_sym_DOLLAR] = ACTIONS(11343),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11343),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11343),
    [anon_sym_QMARK] = ACTIONS(11343),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11343),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11343),
    [aux_sym_integer_literal_token2] = ACTIONS(11343),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11343),
    [aux_sym_float_literal_token3] = ACTIONS(11343),
    [aux_sym_float_literal_token4] = ACTIONS(11343),
    [sym_character_literal] = ACTIONS(11343),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11343),
    [sym__pair_operator] = ACTIONS(11343),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11343),
    [sym__lazy_and_operator] = ACTIONS(11343),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11343),
    [sym__pipe_left_operator] = ACTIONS(11343),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11343),
    [sym__bitshift_operator] = ACTIONS(11343),
    [sym__power_operator] = ACTIONS(11343),
    [sym__tilde_operator] = ACTIONS(11343),
    [sym__type_order_operator] = ACTIONS(11343),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym__terminator_token1] = ACTIONS(11345),
    [aux_sym__terminator_token2] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7921] = {
    [sym_block_comment] = STATE(7921),
    [sym_line_comment] = STATE(7921),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11347),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_end] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_else] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_finally] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11347),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11347),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11347),
    [anon_sym_DOLLAR] = ACTIONS(11347),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11347),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11347),
    [anon_sym_QMARK] = ACTIONS(11347),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11347),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11347),
    [aux_sym_integer_literal_token2] = ACTIONS(11347),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11347),
    [aux_sym_float_literal_token3] = ACTIONS(11347),
    [aux_sym_float_literal_token4] = ACTIONS(11347),
    [sym_character_literal] = ACTIONS(11347),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11347),
    [sym__pair_operator] = ACTIONS(11347),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11347),
    [sym__lazy_and_operator] = ACTIONS(11347),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11347),
    [sym__pipe_left_operator] = ACTIONS(11347),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11347),
    [sym__bitshift_operator] = ACTIONS(11347),
    [sym__power_operator] = ACTIONS(11347),
    [sym__tilde_operator] = ACTIONS(11347),
    [sym__type_order_operator] = ACTIONS(11347),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym__terminator_token1] = ACTIONS(11349),
    [aux_sym__terminator_token2] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7922] = {
    [sym_block_comment] = STATE(7922),
    [sym_line_comment] = STATE(7922),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_catch] = ACTIONS(9724),
    [anon_sym_finally] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7923] = {
    [sym__comprehension_clause] = STATE(18430),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(7923),
    [sym_line_comment] = STATE(7923),
    [aux_sym_vector_expression_repeat1] = STATE(17130),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12144),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12146),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(12148),
    [aux_sym__terminator_token2] = ACTIONS(12151),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7924] = {
    [sym_block_comment] = STATE(7924),
    [sym_line_comment] = STATE(7924),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11351),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_end] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_else] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_finally] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11351),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11351),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11351),
    [anon_sym_DOLLAR] = ACTIONS(11351),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11351),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11351),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11351),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11351),
    [aux_sym_integer_literal_token2] = ACTIONS(11351),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11351),
    [aux_sym_float_literal_token3] = ACTIONS(11351),
    [aux_sym_float_literal_token4] = ACTIONS(11351),
    [sym_character_literal] = ACTIONS(11351),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11351),
    [sym__pair_operator] = ACTIONS(11351),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11351),
    [sym__lazy_and_operator] = ACTIONS(11351),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11351),
    [sym__pipe_left_operator] = ACTIONS(11351),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11351),
    [sym__bitshift_operator] = ACTIONS(11351),
    [sym__power_operator] = ACTIONS(11351),
    [sym__tilde_operator] = ACTIONS(11351),
    [sym__type_order_operator] = ACTIONS(11351),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym__terminator_token1] = ACTIONS(11353),
    [aux_sym__terminator_token2] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7925] = {
    [sym_block_comment] = STATE(7925),
    [sym_line_comment] = STATE(7925),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11355),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_end] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_else] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_finally] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11355),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11355),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11355),
    [anon_sym_DOLLAR] = ACTIONS(11355),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11355),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_QMARK] = ACTIONS(11355),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11355),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11355),
    [aux_sym_integer_literal_token2] = ACTIONS(11355),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11355),
    [aux_sym_float_literal_token3] = ACTIONS(11355),
    [aux_sym_float_literal_token4] = ACTIONS(11355),
    [sym_character_literal] = ACTIONS(11355),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11355),
    [sym__pair_operator] = ACTIONS(11355),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11355),
    [sym__lazy_and_operator] = ACTIONS(11355),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11355),
    [sym__pipe_left_operator] = ACTIONS(11355),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11355),
    [sym__bitshift_operator] = ACTIONS(11355),
    [sym__power_operator] = ACTIONS(11355),
    [sym__tilde_operator] = ACTIONS(11355),
    [sym__type_order_operator] = ACTIONS(11355),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym__terminator_token1] = ACTIONS(11357),
    [aux_sym__terminator_token2] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7926] = {
    [sym_block_comment] = STATE(7926),
    [sym_line_comment] = STATE(7926),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11373),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_end] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_else] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_finally] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11373),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11373),
    [anon_sym_DOLLAR] = ACTIONS(11373),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11373),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11373),
    [anon_sym_QMARK] = ACTIONS(11373),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11373),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11373),
    [aux_sym_integer_literal_token2] = ACTIONS(11373),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11373),
    [aux_sym_float_literal_token3] = ACTIONS(11373),
    [aux_sym_float_literal_token4] = ACTIONS(11373),
    [sym_character_literal] = ACTIONS(11373),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11373),
    [sym__pair_operator] = ACTIONS(11373),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11373),
    [sym__lazy_and_operator] = ACTIONS(11373),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11373),
    [sym__pipe_left_operator] = ACTIONS(11373),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11373),
    [sym__bitshift_operator] = ACTIONS(11373),
    [sym__power_operator] = ACTIONS(11373),
    [sym__tilde_operator] = ACTIONS(11373),
    [sym__type_order_operator] = ACTIONS(11373),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym__terminator_token1] = ACTIONS(11375),
    [aux_sym__terminator_token2] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7927] = {
    [sym_block_comment] = STATE(7927),
    [sym_line_comment] = STATE(7927),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_end] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_else] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_finally] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11377),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11377),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11377),
    [anon_sym_DOLLAR] = ACTIONS(11377),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11377),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11377),
    [anon_sym_QMARK] = ACTIONS(11377),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11377),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11377),
    [aux_sym_integer_literal_token2] = ACTIONS(11377),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11377),
    [aux_sym_float_literal_token3] = ACTIONS(11377),
    [aux_sym_float_literal_token4] = ACTIONS(11377),
    [sym_character_literal] = ACTIONS(11377),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11377),
    [sym__pair_operator] = ACTIONS(11377),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11377),
    [sym__lazy_and_operator] = ACTIONS(11377),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11377),
    [sym__pipe_left_operator] = ACTIONS(11377),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11377),
    [sym__bitshift_operator] = ACTIONS(11377),
    [sym__power_operator] = ACTIONS(11377),
    [sym__tilde_operator] = ACTIONS(11377),
    [sym__type_order_operator] = ACTIONS(11377),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym__terminator_token1] = ACTIONS(11379),
    [aux_sym__terminator_token2] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7928] = {
    [sym_block_comment] = STATE(7928),
    [sym_line_comment] = STATE(7928),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_end] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_else] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_finally] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11385),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11385),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11385),
    [anon_sym_DOLLAR] = ACTIONS(11385),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11385),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11385),
    [anon_sym_QMARK] = ACTIONS(11385),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11385),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11385),
    [aux_sym_integer_literal_token2] = ACTIONS(11385),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11385),
    [aux_sym_float_literal_token3] = ACTIONS(11385),
    [aux_sym_float_literal_token4] = ACTIONS(11385),
    [sym_character_literal] = ACTIONS(11385),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11385),
    [sym__pair_operator] = ACTIONS(11385),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11385),
    [sym__lazy_and_operator] = ACTIONS(11385),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11385),
    [sym__pipe_left_operator] = ACTIONS(11385),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11385),
    [sym__bitshift_operator] = ACTIONS(11385),
    [sym__power_operator] = ACTIONS(11385),
    [sym__tilde_operator] = ACTIONS(11385),
    [sym__type_order_operator] = ACTIONS(11385),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym__terminator_token1] = ACTIONS(11387),
    [aux_sym__terminator_token2] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7929] = {
    [sym_block_comment] = STATE(7929),
    [sym_line_comment] = STATE(7929),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11399),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_end] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_else] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_finally] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11399),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11399),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11399),
    [anon_sym_DOLLAR] = ACTIONS(11399),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11399),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11399),
    [anon_sym_QMARK] = ACTIONS(11399),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11399),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11399),
    [aux_sym_integer_literal_token2] = ACTIONS(11399),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11399),
    [aux_sym_float_literal_token3] = ACTIONS(11399),
    [aux_sym_float_literal_token4] = ACTIONS(11399),
    [sym_character_literal] = ACTIONS(11399),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11399),
    [sym__pair_operator] = ACTIONS(11399),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11399),
    [sym__lazy_and_operator] = ACTIONS(11399),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11399),
    [sym__pipe_left_operator] = ACTIONS(11399),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11399),
    [sym__bitshift_operator] = ACTIONS(11399),
    [sym__power_operator] = ACTIONS(11399),
    [sym__tilde_operator] = ACTIONS(11399),
    [sym__type_order_operator] = ACTIONS(11399),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym__terminator_token1] = ACTIONS(11401),
    [aux_sym__terminator_token2] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7930] = {
    [sym_block_comment] = STATE(7930),
    [sym_line_comment] = STATE(7930),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_catch] = ACTIONS(9736),
    [anon_sym_finally] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7931] = {
    [sym_block_comment] = STATE(7931),
    [sym_line_comment] = STATE(7931),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_catch] = ACTIONS(9742),
    [anon_sym_finally] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7932] = {
    [sym_block_comment] = STATE(7932),
    [sym_line_comment] = STATE(7932),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_end] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_else] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_finally] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11403),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11403),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11403),
    [anon_sym_DOLLAR] = ACTIONS(11403),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11403),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11403),
    [anon_sym_QMARK] = ACTIONS(11403),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11403),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11403),
    [aux_sym_integer_literal_token2] = ACTIONS(11403),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11403),
    [aux_sym_float_literal_token3] = ACTIONS(11403),
    [aux_sym_float_literal_token4] = ACTIONS(11403),
    [sym_character_literal] = ACTIONS(11403),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11403),
    [sym__pair_operator] = ACTIONS(11403),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11403),
    [sym__lazy_and_operator] = ACTIONS(11403),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11403),
    [sym__pipe_left_operator] = ACTIONS(11403),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11403),
    [sym__bitshift_operator] = ACTIONS(11403),
    [sym__power_operator] = ACTIONS(11403),
    [sym__tilde_operator] = ACTIONS(11403),
    [sym__type_order_operator] = ACTIONS(11403),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym__terminator_token1] = ACTIONS(11405),
    [aux_sym__terminator_token2] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7933] = {
    [sym_block_comment] = STATE(7933),
    [sym_line_comment] = STATE(7933),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10976),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_RBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7934] = {
    [sym_block_comment] = STATE(7934),
    [sym_line_comment] = STATE(7934),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11536),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11536),
    [anon_sym_RPAREN] = ACTIONS(11536),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11536),
    [anon_sym_RBRACK] = ACTIONS(11536),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_SEMI] = ACTIONS(11536),
    [anon_sym_LBRACE] = ACTIONS(11536),
    [anon_sym_RBRACE] = ACTIONS(11536),
    [anon_sym_DOLLAR] = ACTIONS(11536),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11536),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11536),
    [anon_sym_QMARK] = ACTIONS(11536),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11536),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11536),
    [aux_sym_integer_literal_token2] = ACTIONS(11536),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11536),
    [aux_sym_float_literal_token3] = ACTIONS(11536),
    [aux_sym_float_literal_token4] = ACTIONS(11536),
    [sym_character_literal] = ACTIONS(11536),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11536),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11536),
    [sym__pair_operator] = ACTIONS(11536),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11536),
    [sym__lazy_and_operator] = ACTIONS(11536),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11536),
    [sym__pipe_left_operator] = ACTIONS(11536),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11536),
    [sym__bitshift_operator] = ACTIONS(11536),
    [sym__power_operator] = ACTIONS(11536),
    [sym__tilde_operator] = ACTIONS(11536),
    [sym__type_order_operator] = ACTIONS(11536),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7935] = {
    [sym_block_comment] = STATE(7935),
    [sym_line_comment] = STATE(7935),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11567),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_end] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_catch] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11567),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11567),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11567),
    [anon_sym_DOLLAR] = ACTIONS(11567),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11567),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11567),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11567),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11567),
    [aux_sym_integer_literal_token2] = ACTIONS(11567),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11567),
    [aux_sym_float_literal_token3] = ACTIONS(11567),
    [aux_sym_float_literal_token4] = ACTIONS(11567),
    [sym_character_literal] = ACTIONS(11567),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11567),
    [sym__pair_operator] = ACTIONS(11567),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11567),
    [sym__lazy_and_operator] = ACTIONS(11567),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11567),
    [sym__pipe_left_operator] = ACTIONS(11567),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11567),
    [sym__bitshift_operator] = ACTIONS(11567),
    [sym__power_operator] = ACTIONS(11567),
    [sym__tilde_operator] = ACTIONS(11567),
    [sym__type_order_operator] = ACTIONS(11567),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym__terminator_token1] = ACTIONS(11569),
    [aux_sym__terminator_token2] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7936] = {
    [sym_block_comment] = STATE(7936),
    [sym_line_comment] = STATE(7936),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11571),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_end] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_catch] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11571),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11571),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11571),
    [anon_sym_DOLLAR] = ACTIONS(11571),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11571),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_QMARK] = ACTIONS(11571),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11571),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11571),
    [aux_sym_integer_literal_token2] = ACTIONS(11571),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11571),
    [aux_sym_float_literal_token3] = ACTIONS(11571),
    [aux_sym_float_literal_token4] = ACTIONS(11571),
    [sym_character_literal] = ACTIONS(11571),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11571),
    [sym__pair_operator] = ACTIONS(11571),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11571),
    [sym__lazy_and_operator] = ACTIONS(11571),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11571),
    [sym__pipe_left_operator] = ACTIONS(11571),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11571),
    [sym__bitshift_operator] = ACTIONS(11571),
    [sym__power_operator] = ACTIONS(11571),
    [sym__tilde_operator] = ACTIONS(11571),
    [sym__type_order_operator] = ACTIONS(11571),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym__terminator_token1] = ACTIONS(11573),
    [aux_sym__terminator_token2] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7937] = {
    [sym_block_comment] = STATE(7937),
    [sym_line_comment] = STATE(7937),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11108),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7938] = {
    [sym_block_comment] = STATE(7938),
    [sym_line_comment] = STATE(7938),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
  },
  [7939] = {
    [sym_block_comment] = STATE(7939),
    [sym_line_comment] = STATE(7939),
    [ts_builtin_sym_end] = ACTIONS(11249),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_RBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11247),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11247),
    [anon_sym_QMARK] = ACTIONS(11247),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11247),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11247),
    [sym__lazy_and_operator] = ACTIONS(11247),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11247),
    [sym__pipe_left_operator] = ACTIONS(11247),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11247),
    [sym__bitshift_operator] = ACTIONS(11247),
    [sym__power_operator] = ACTIONS(11247),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11247),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7940] = {
    [sym_block_comment] = STATE(7940),
    [sym_line_comment] = STATE(7940),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_RPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_RBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_SEMI] = ACTIONS(10639),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_RBRACE] = ACTIONS(10639),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7941] = {
    [sym_block_comment] = STATE(7941),
    [sym_line_comment] = STATE(7941),
    [ts_builtin_sym_end] = ACTIONS(11333),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11331),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11331),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11331),
    [anon_sym_RBRACK] = ACTIONS(11331),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11331),
    [anon_sym_DOLLAR] = ACTIONS(11331),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11331),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11331),
    [anon_sym_QMARK] = ACTIONS(11331),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11331),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11331),
    [aux_sym_integer_literal_token2] = ACTIONS(11331),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11331),
    [aux_sym_float_literal_token3] = ACTIONS(11331),
    [aux_sym_float_literal_token4] = ACTIONS(11331),
    [sym_character_literal] = ACTIONS(11331),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11331),
    [sym__pair_operator] = ACTIONS(11331),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11331),
    [sym__lazy_and_operator] = ACTIONS(11331),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11331),
    [sym__pipe_left_operator] = ACTIONS(11331),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11331),
    [sym__bitshift_operator] = ACTIONS(11331),
    [sym__power_operator] = ACTIONS(11331),
    [sym__tilde_operator] = ACTIONS(11331),
    [sym__type_order_operator] = ACTIONS(11331),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym__terminator_token1] = ACTIONS(11333),
    [aux_sym__terminator_token2] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7942] = {
    [sym_block_comment] = STATE(7942),
    [sym_line_comment] = STATE(7942),
    [ts_builtin_sym_end] = ACTIONS(11337),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11335),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_RBRACK] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_DOLLAR] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11335),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11335),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11335),
    [aux_sym_integer_literal_token2] = ACTIONS(11335),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11335),
    [aux_sym_float_literal_token3] = ACTIONS(11335),
    [aux_sym_float_literal_token4] = ACTIONS(11335),
    [sym_character_literal] = ACTIONS(11335),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11335),
    [sym__pair_operator] = ACTIONS(11335),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11335),
    [sym__lazy_and_operator] = ACTIONS(11335),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11335),
    [sym__pipe_left_operator] = ACTIONS(11335),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11335),
    [sym__bitshift_operator] = ACTIONS(11335),
    [sym__power_operator] = ACTIONS(11335),
    [sym__tilde_operator] = ACTIONS(11335),
    [sym__type_order_operator] = ACTIONS(11335),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym__terminator_token1] = ACTIONS(11337),
    [aux_sym__terminator_token2] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7943] = {
    [sym_block_comment] = STATE(7943),
    [sym_line_comment] = STATE(7943),
    [ts_builtin_sym_end] = ACTIONS(11341),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11339),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11339),
    [anon_sym_RBRACK] = ACTIONS(11339),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11339),
    [anon_sym_DOLLAR] = ACTIONS(11339),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11339),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(11339),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11339),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11339),
    [aux_sym_integer_literal_token2] = ACTIONS(11339),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11339),
    [aux_sym_float_literal_token3] = ACTIONS(11339),
    [aux_sym_float_literal_token4] = ACTIONS(11339),
    [sym_character_literal] = ACTIONS(11339),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11339),
    [sym__pair_operator] = ACTIONS(11339),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11339),
    [sym__lazy_and_operator] = ACTIONS(11339),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11339),
    [sym__pipe_left_operator] = ACTIONS(11339),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11339),
    [sym__bitshift_operator] = ACTIONS(11339),
    [sym__power_operator] = ACTIONS(11339),
    [sym__tilde_operator] = ACTIONS(11339),
    [sym__type_order_operator] = ACTIONS(11339),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym__terminator_token1] = ACTIONS(11341),
    [aux_sym__terminator_token2] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7944] = {
    [sym_block_comment] = STATE(7944),
    [sym_line_comment] = STATE(7944),
    [ts_builtin_sym_end] = ACTIONS(11345),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11343),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11343),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_RBRACK] = ACTIONS(11343),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11343),
    [anon_sym_DOLLAR] = ACTIONS(11343),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11343),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11343),
    [anon_sym_QMARK] = ACTIONS(11343),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11343),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11343),
    [aux_sym_integer_literal_token2] = ACTIONS(11343),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11343),
    [aux_sym_float_literal_token3] = ACTIONS(11343),
    [aux_sym_float_literal_token4] = ACTIONS(11343),
    [sym_character_literal] = ACTIONS(11343),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11343),
    [sym__pair_operator] = ACTIONS(11343),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11343),
    [sym__lazy_and_operator] = ACTIONS(11343),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11343),
    [sym__pipe_left_operator] = ACTIONS(11343),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11343),
    [sym__bitshift_operator] = ACTIONS(11343),
    [sym__power_operator] = ACTIONS(11343),
    [sym__tilde_operator] = ACTIONS(11343),
    [sym__type_order_operator] = ACTIONS(11343),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym__terminator_token1] = ACTIONS(11345),
    [aux_sym__terminator_token2] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7945] = {
    [sym_block_comment] = STATE(7945),
    [sym_line_comment] = STATE(7945),
    [ts_builtin_sym_end] = ACTIONS(11349),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11347),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11347),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11347),
    [anon_sym_RBRACK] = ACTIONS(11347),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11347),
    [anon_sym_DOLLAR] = ACTIONS(11347),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11347),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11347),
    [anon_sym_QMARK] = ACTIONS(11347),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11347),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11347),
    [aux_sym_integer_literal_token2] = ACTIONS(11347),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11347),
    [aux_sym_float_literal_token3] = ACTIONS(11347),
    [aux_sym_float_literal_token4] = ACTIONS(11347),
    [sym_character_literal] = ACTIONS(11347),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11347),
    [sym__pair_operator] = ACTIONS(11347),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11347),
    [sym__lazy_and_operator] = ACTIONS(11347),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11347),
    [sym__pipe_left_operator] = ACTIONS(11347),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11347),
    [sym__bitshift_operator] = ACTIONS(11347),
    [sym__power_operator] = ACTIONS(11347),
    [sym__tilde_operator] = ACTIONS(11347),
    [sym__type_order_operator] = ACTIONS(11347),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym__terminator_token1] = ACTIONS(11349),
    [aux_sym__terminator_token2] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7946] = {
    [sym_block_comment] = STATE(7946),
    [sym_line_comment] = STATE(7946),
    [ts_builtin_sym_end] = ACTIONS(11353),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11351),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11351),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11351),
    [anon_sym_RBRACK] = ACTIONS(11351),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11351),
    [anon_sym_DOLLAR] = ACTIONS(11351),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11351),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11351),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11351),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11351),
    [aux_sym_integer_literal_token2] = ACTIONS(11351),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11351),
    [aux_sym_float_literal_token3] = ACTIONS(11351),
    [aux_sym_float_literal_token4] = ACTIONS(11351),
    [sym_character_literal] = ACTIONS(11351),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11351),
    [sym__pair_operator] = ACTIONS(11351),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11351),
    [sym__lazy_and_operator] = ACTIONS(11351),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11351),
    [sym__pipe_left_operator] = ACTIONS(11351),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11351),
    [sym__bitshift_operator] = ACTIONS(11351),
    [sym__power_operator] = ACTIONS(11351),
    [sym__tilde_operator] = ACTIONS(11351),
    [sym__type_order_operator] = ACTIONS(11351),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym__terminator_token1] = ACTIONS(11353),
    [aux_sym__terminator_token2] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7947] = {
    [sym_block_comment] = STATE(7947),
    [sym_line_comment] = STATE(7947),
    [ts_builtin_sym_end] = ACTIONS(11357),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11355),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11355),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11355),
    [anon_sym_RBRACK] = ACTIONS(11355),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11355),
    [anon_sym_DOLLAR] = ACTIONS(11355),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11355),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_QMARK] = ACTIONS(11355),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11355),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11355),
    [aux_sym_integer_literal_token2] = ACTIONS(11355),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11355),
    [aux_sym_float_literal_token3] = ACTIONS(11355),
    [aux_sym_float_literal_token4] = ACTIONS(11355),
    [sym_character_literal] = ACTIONS(11355),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11355),
    [sym__pair_operator] = ACTIONS(11355),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11355),
    [sym__lazy_and_operator] = ACTIONS(11355),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11355),
    [sym__pipe_left_operator] = ACTIONS(11355),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11355),
    [sym__bitshift_operator] = ACTIONS(11355),
    [sym__power_operator] = ACTIONS(11355),
    [sym__tilde_operator] = ACTIONS(11355),
    [sym__type_order_operator] = ACTIONS(11355),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym__terminator_token1] = ACTIONS(11357),
    [aux_sym__terminator_token2] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7948] = {
    [sym_block_comment] = STATE(7948),
    [sym_line_comment] = STATE(7948),
    [ts_builtin_sym_end] = ACTIONS(11375),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11373),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11373),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_RBRACK] = ACTIONS(11373),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11373),
    [anon_sym_DOLLAR] = ACTIONS(11373),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11373),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11373),
    [anon_sym_QMARK] = ACTIONS(11373),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11373),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11373),
    [aux_sym_integer_literal_token2] = ACTIONS(11373),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11373),
    [aux_sym_float_literal_token3] = ACTIONS(11373),
    [aux_sym_float_literal_token4] = ACTIONS(11373),
    [sym_character_literal] = ACTIONS(11373),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11373),
    [sym__pair_operator] = ACTIONS(11373),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11373),
    [sym__lazy_and_operator] = ACTIONS(11373),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11373),
    [sym__pipe_left_operator] = ACTIONS(11373),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11373),
    [sym__bitshift_operator] = ACTIONS(11373),
    [sym__power_operator] = ACTIONS(11373),
    [sym__tilde_operator] = ACTIONS(11373),
    [sym__type_order_operator] = ACTIONS(11373),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym__terminator_token1] = ACTIONS(11375),
    [aux_sym__terminator_token2] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7949] = {
    [sym_block_comment] = STATE(7949),
    [sym_line_comment] = STATE(7949),
    [ts_builtin_sym_end] = ACTIONS(11379),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11377),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11377),
    [anon_sym_RBRACK] = ACTIONS(11377),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11377),
    [anon_sym_DOLLAR] = ACTIONS(11377),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11377),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11377),
    [anon_sym_QMARK] = ACTIONS(11377),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11377),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11377),
    [aux_sym_integer_literal_token2] = ACTIONS(11377),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11377),
    [aux_sym_float_literal_token3] = ACTIONS(11377),
    [aux_sym_float_literal_token4] = ACTIONS(11377),
    [sym_character_literal] = ACTIONS(11377),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11377),
    [sym__pair_operator] = ACTIONS(11377),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11377),
    [sym__lazy_and_operator] = ACTIONS(11377),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11377),
    [sym__pipe_left_operator] = ACTIONS(11377),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11377),
    [sym__bitshift_operator] = ACTIONS(11377),
    [sym__power_operator] = ACTIONS(11377),
    [sym__tilde_operator] = ACTIONS(11377),
    [sym__type_order_operator] = ACTIONS(11377),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym__terminator_token1] = ACTIONS(11379),
    [aux_sym__terminator_token2] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7950] = {
    [sym_block_comment] = STATE(7950),
    [sym_line_comment] = STATE(7950),
    [ts_builtin_sym_end] = ACTIONS(11387),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11385),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11385),
    [anon_sym_RBRACK] = ACTIONS(11385),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11385),
    [anon_sym_DOLLAR] = ACTIONS(11385),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11385),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11385),
    [anon_sym_QMARK] = ACTIONS(11385),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11385),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11385),
    [aux_sym_integer_literal_token2] = ACTIONS(11385),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11385),
    [aux_sym_float_literal_token3] = ACTIONS(11385),
    [aux_sym_float_literal_token4] = ACTIONS(11385),
    [sym_character_literal] = ACTIONS(11385),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11385),
    [sym__pair_operator] = ACTIONS(11385),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11385),
    [sym__lazy_and_operator] = ACTIONS(11385),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11385),
    [sym__pipe_left_operator] = ACTIONS(11385),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11385),
    [sym__bitshift_operator] = ACTIONS(11385),
    [sym__power_operator] = ACTIONS(11385),
    [sym__tilde_operator] = ACTIONS(11385),
    [sym__type_order_operator] = ACTIONS(11385),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym__terminator_token1] = ACTIONS(11387),
    [aux_sym__terminator_token2] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7951] = {
    [sym_block_comment] = STATE(7951),
    [sym_line_comment] = STATE(7951),
    [ts_builtin_sym_end] = ACTIONS(11401),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11399),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11399),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11399),
    [anon_sym_RBRACK] = ACTIONS(11399),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11399),
    [anon_sym_DOLLAR] = ACTIONS(11399),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11399),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11399),
    [anon_sym_QMARK] = ACTIONS(11399),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11399),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11399),
    [aux_sym_integer_literal_token2] = ACTIONS(11399),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11399),
    [aux_sym_float_literal_token3] = ACTIONS(11399),
    [aux_sym_float_literal_token4] = ACTIONS(11399),
    [sym_character_literal] = ACTIONS(11399),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11399),
    [sym__pair_operator] = ACTIONS(11399),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11399),
    [sym__lazy_and_operator] = ACTIONS(11399),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11399),
    [sym__pipe_left_operator] = ACTIONS(11399),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11399),
    [sym__bitshift_operator] = ACTIONS(11399),
    [sym__power_operator] = ACTIONS(11399),
    [sym__tilde_operator] = ACTIONS(11399),
    [sym__type_order_operator] = ACTIONS(11399),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym__terminator_token1] = ACTIONS(11401),
    [aux_sym__terminator_token2] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7952] = {
    [sym_block_comment] = STATE(7952),
    [sym_line_comment] = STATE(7952),
    [ts_builtin_sym_end] = ACTIONS(11405),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11403),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11403),
    [anon_sym_RBRACK] = ACTIONS(11403),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11403),
    [anon_sym_DOLLAR] = ACTIONS(11403),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11403),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11403),
    [anon_sym_QMARK] = ACTIONS(11403),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11403),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11403),
    [aux_sym_integer_literal_token2] = ACTIONS(11403),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11403),
    [aux_sym_float_literal_token3] = ACTIONS(11403),
    [aux_sym_float_literal_token4] = ACTIONS(11403),
    [sym_character_literal] = ACTIONS(11403),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11403),
    [sym__pair_operator] = ACTIONS(11403),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11403),
    [sym__lazy_and_operator] = ACTIONS(11403),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11403),
    [sym__pipe_left_operator] = ACTIONS(11403),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11403),
    [sym__bitshift_operator] = ACTIONS(11403),
    [sym__power_operator] = ACTIONS(11403),
    [sym__tilde_operator] = ACTIONS(11403),
    [sym__type_order_operator] = ACTIONS(11403),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym__terminator_token1] = ACTIONS(11405),
    [aux_sym__terminator_token2] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7953] = {
    [sym_block_comment] = STATE(7953),
    [sym_line_comment] = STATE(7953),
    [ts_builtin_sym_end] = ACTIONS(11257),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11255),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11255),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11255),
    [anon_sym_RBRACK] = ACTIONS(11255),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11255),
    [anon_sym_DOLLAR] = ACTIONS(11255),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11255),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11255),
    [anon_sym_QMARK] = ACTIONS(11255),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11255),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11255),
    [aux_sym_integer_literal_token2] = ACTIONS(11255),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11255),
    [aux_sym_float_literal_token3] = ACTIONS(11255),
    [aux_sym_float_literal_token4] = ACTIONS(11255),
    [sym_character_literal] = ACTIONS(11255),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11255),
    [sym__pair_operator] = ACTIONS(11255),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11255),
    [sym__lazy_and_operator] = ACTIONS(11255),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11255),
    [sym__pipe_left_operator] = ACTIONS(11255),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11255),
    [sym__bitshift_operator] = ACTIONS(11255),
    [sym__power_operator] = ACTIONS(11255),
    [sym__tilde_operator] = ACTIONS(11255),
    [sym__type_order_operator] = ACTIONS(11255),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym__terminator_token1] = ACTIONS(11257),
    [aux_sym__terminator_token2] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7954] = {
    [sym_block_comment] = STATE(7954),
    [sym_line_comment] = STATE(7954),
    [ts_builtin_sym_end] = ACTIONS(11413),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11411),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11411),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11411),
    [anon_sym_RBRACK] = ACTIONS(11411),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11411),
    [anon_sym_DOLLAR] = ACTIONS(11411),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11411),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11411),
    [anon_sym_QMARK] = ACTIONS(11411),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11411),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11411),
    [aux_sym_integer_literal_token2] = ACTIONS(11411),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11411),
    [aux_sym_float_literal_token3] = ACTIONS(11411),
    [aux_sym_float_literal_token4] = ACTIONS(11411),
    [sym_character_literal] = ACTIONS(11411),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11411),
    [sym__pair_operator] = ACTIONS(11411),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11411),
    [sym__lazy_and_operator] = ACTIONS(11411),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11411),
    [sym__pipe_left_operator] = ACTIONS(11411),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11411),
    [sym__bitshift_operator] = ACTIONS(11411),
    [sym__power_operator] = ACTIONS(11411),
    [sym__tilde_operator] = ACTIONS(11411),
    [sym__type_order_operator] = ACTIONS(11411),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym__terminator_token1] = ACTIONS(11413),
    [aux_sym__terminator_token2] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7955] = {
    [sym_block_comment] = STATE(7955),
    [sym_line_comment] = STATE(7955),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7956] = {
    [sym_block_comment] = STATE(7956),
    [sym_line_comment] = STATE(7956),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7957] = {
    [sym_block_comment] = STATE(7957),
    [sym_line_comment] = STATE(7957),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_catch] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7958] = {
    [sym_block_comment] = STATE(7958),
    [sym_line_comment] = STATE(7958),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11108),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7959] = {
    [sym_block_comment] = STATE(7959),
    [sym_line_comment] = STATE(7959),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_catch] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11247),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11247),
    [anon_sym_QMARK] = ACTIONS(11247),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11247),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11247),
    [sym__lazy_and_operator] = ACTIONS(11247),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11247),
    [sym__pipe_left_operator] = ACTIONS(11247),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11247),
    [sym__bitshift_operator] = ACTIONS(11247),
    [sym__power_operator] = ACTIONS(11247),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11247),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7960] = {
    [sym_block_comment] = STATE(7960),
    [sym_line_comment] = STATE(7960),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11331),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_end] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_catch] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11331),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11331),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11331),
    [anon_sym_DOLLAR] = ACTIONS(11331),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11331),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11331),
    [anon_sym_QMARK] = ACTIONS(11331),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11331),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11331),
    [aux_sym_integer_literal_token2] = ACTIONS(11331),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11331),
    [aux_sym_float_literal_token3] = ACTIONS(11331),
    [aux_sym_float_literal_token4] = ACTIONS(11331),
    [sym_character_literal] = ACTIONS(11331),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11331),
    [sym__pair_operator] = ACTIONS(11331),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11331),
    [sym__lazy_and_operator] = ACTIONS(11331),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11331),
    [sym__pipe_left_operator] = ACTIONS(11331),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11331),
    [sym__bitshift_operator] = ACTIONS(11331),
    [sym__power_operator] = ACTIONS(11331),
    [sym__tilde_operator] = ACTIONS(11331),
    [sym__type_order_operator] = ACTIONS(11331),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym__terminator_token1] = ACTIONS(11333),
    [aux_sym__terminator_token2] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7961] = {
    [sym_block_comment] = STATE(7961),
    [sym_line_comment] = STATE(7961),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_catch] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11335),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_DOLLAR] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11335),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11335),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11335),
    [aux_sym_integer_literal_token2] = ACTIONS(11335),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11335),
    [aux_sym_float_literal_token3] = ACTIONS(11335),
    [aux_sym_float_literal_token4] = ACTIONS(11335),
    [sym_character_literal] = ACTIONS(11335),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11335),
    [sym__pair_operator] = ACTIONS(11335),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11335),
    [sym__lazy_and_operator] = ACTIONS(11335),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11335),
    [sym__pipe_left_operator] = ACTIONS(11335),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11335),
    [sym__bitshift_operator] = ACTIONS(11335),
    [sym__power_operator] = ACTIONS(11335),
    [sym__tilde_operator] = ACTIONS(11335),
    [sym__type_order_operator] = ACTIONS(11335),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym__terminator_token1] = ACTIONS(11337),
    [aux_sym__terminator_token2] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7962] = {
    [sym_block_comment] = STATE(7962),
    [sym_line_comment] = STATE(7962),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_end] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_catch] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11339),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11339),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11339),
    [anon_sym_DOLLAR] = ACTIONS(11339),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11339),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(11339),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11339),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11339),
    [aux_sym_integer_literal_token2] = ACTIONS(11339),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11339),
    [aux_sym_float_literal_token3] = ACTIONS(11339),
    [aux_sym_float_literal_token4] = ACTIONS(11339),
    [sym_character_literal] = ACTIONS(11339),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11339),
    [sym__pair_operator] = ACTIONS(11339),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11339),
    [sym__lazy_and_operator] = ACTIONS(11339),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11339),
    [sym__pipe_left_operator] = ACTIONS(11339),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11339),
    [sym__bitshift_operator] = ACTIONS(11339),
    [sym__power_operator] = ACTIONS(11339),
    [sym__tilde_operator] = ACTIONS(11339),
    [sym__type_order_operator] = ACTIONS(11339),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym__terminator_token1] = ACTIONS(11341),
    [aux_sym__terminator_token2] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7963] = {
    [sym_block_comment] = STATE(7963),
    [sym_line_comment] = STATE(7963),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11343),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_end] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_catch] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11343),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11343),
    [anon_sym_DOLLAR] = ACTIONS(11343),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11343),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11343),
    [anon_sym_QMARK] = ACTIONS(11343),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11343),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11343),
    [aux_sym_integer_literal_token2] = ACTIONS(11343),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11343),
    [aux_sym_float_literal_token3] = ACTIONS(11343),
    [aux_sym_float_literal_token4] = ACTIONS(11343),
    [sym_character_literal] = ACTIONS(11343),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11343),
    [sym__pair_operator] = ACTIONS(11343),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11343),
    [sym__lazy_and_operator] = ACTIONS(11343),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11343),
    [sym__pipe_left_operator] = ACTIONS(11343),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11343),
    [sym__bitshift_operator] = ACTIONS(11343),
    [sym__power_operator] = ACTIONS(11343),
    [sym__tilde_operator] = ACTIONS(11343),
    [sym__type_order_operator] = ACTIONS(11343),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym__terminator_token1] = ACTIONS(11345),
    [aux_sym__terminator_token2] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7964] = {
    [sym_block_comment] = STATE(7964),
    [sym_line_comment] = STATE(7964),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_catch] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7965] = {
    [sym_block_comment] = STATE(7965),
    [sym_line_comment] = STATE(7965),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11347),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_end] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_catch] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11347),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11347),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11347),
    [anon_sym_DOLLAR] = ACTIONS(11347),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11347),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11347),
    [anon_sym_QMARK] = ACTIONS(11347),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11347),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11347),
    [aux_sym_integer_literal_token2] = ACTIONS(11347),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11347),
    [aux_sym_float_literal_token3] = ACTIONS(11347),
    [aux_sym_float_literal_token4] = ACTIONS(11347),
    [sym_character_literal] = ACTIONS(11347),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11347),
    [sym__pair_operator] = ACTIONS(11347),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11347),
    [sym__lazy_and_operator] = ACTIONS(11347),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11347),
    [sym__pipe_left_operator] = ACTIONS(11347),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11347),
    [sym__bitshift_operator] = ACTIONS(11347),
    [sym__power_operator] = ACTIONS(11347),
    [sym__tilde_operator] = ACTIONS(11347),
    [sym__type_order_operator] = ACTIONS(11347),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym__terminator_token1] = ACTIONS(11349),
    [aux_sym__terminator_token2] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7966] = {
    [sym_block_comment] = STATE(7966),
    [sym_line_comment] = STATE(7966),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11351),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_end] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_catch] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11351),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11351),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11351),
    [anon_sym_DOLLAR] = ACTIONS(11351),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11351),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11351),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11351),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11351),
    [aux_sym_integer_literal_token2] = ACTIONS(11351),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11351),
    [aux_sym_float_literal_token3] = ACTIONS(11351),
    [aux_sym_float_literal_token4] = ACTIONS(11351),
    [sym_character_literal] = ACTIONS(11351),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11351),
    [sym__pair_operator] = ACTIONS(11351),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11351),
    [sym__lazy_and_operator] = ACTIONS(11351),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11351),
    [sym__pipe_left_operator] = ACTIONS(11351),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11351),
    [sym__bitshift_operator] = ACTIONS(11351),
    [sym__power_operator] = ACTIONS(11351),
    [sym__tilde_operator] = ACTIONS(11351),
    [sym__type_order_operator] = ACTIONS(11351),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym__terminator_token1] = ACTIONS(11353),
    [aux_sym__terminator_token2] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7967] = {
    [sym_block_comment] = STATE(7967),
    [sym_line_comment] = STATE(7967),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11355),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_end] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_catch] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11355),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11355),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11355),
    [anon_sym_DOLLAR] = ACTIONS(11355),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11355),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_QMARK] = ACTIONS(11355),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11355),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11355),
    [aux_sym_integer_literal_token2] = ACTIONS(11355),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11355),
    [aux_sym_float_literal_token3] = ACTIONS(11355),
    [aux_sym_float_literal_token4] = ACTIONS(11355),
    [sym_character_literal] = ACTIONS(11355),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11355),
    [sym__pair_operator] = ACTIONS(11355),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11355),
    [sym__lazy_and_operator] = ACTIONS(11355),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11355),
    [sym__pipe_left_operator] = ACTIONS(11355),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11355),
    [sym__bitshift_operator] = ACTIONS(11355),
    [sym__power_operator] = ACTIONS(11355),
    [sym__tilde_operator] = ACTIONS(11355),
    [sym__type_order_operator] = ACTIONS(11355),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym__terminator_token1] = ACTIONS(11357),
    [aux_sym__terminator_token2] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7968] = {
    [sym_block_comment] = STATE(7968),
    [sym_line_comment] = STATE(7968),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11373),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_end] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_catch] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11373),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11373),
    [anon_sym_DOLLAR] = ACTIONS(11373),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11373),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11373),
    [anon_sym_QMARK] = ACTIONS(11373),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11373),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11373),
    [aux_sym_integer_literal_token2] = ACTIONS(11373),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11373),
    [aux_sym_float_literal_token3] = ACTIONS(11373),
    [aux_sym_float_literal_token4] = ACTIONS(11373),
    [sym_character_literal] = ACTIONS(11373),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11373),
    [sym__pair_operator] = ACTIONS(11373),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11373),
    [sym__lazy_and_operator] = ACTIONS(11373),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11373),
    [sym__pipe_left_operator] = ACTIONS(11373),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11373),
    [sym__bitshift_operator] = ACTIONS(11373),
    [sym__power_operator] = ACTIONS(11373),
    [sym__tilde_operator] = ACTIONS(11373),
    [sym__type_order_operator] = ACTIONS(11373),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym__terminator_token1] = ACTIONS(11375),
    [aux_sym__terminator_token2] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7969] = {
    [sym_block_comment] = STATE(7969),
    [sym_line_comment] = STATE(7969),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_end] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_catch] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11377),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11377),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11377),
    [anon_sym_DOLLAR] = ACTIONS(11377),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11377),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11377),
    [anon_sym_QMARK] = ACTIONS(11377),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11377),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11377),
    [aux_sym_integer_literal_token2] = ACTIONS(11377),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11377),
    [aux_sym_float_literal_token3] = ACTIONS(11377),
    [aux_sym_float_literal_token4] = ACTIONS(11377),
    [sym_character_literal] = ACTIONS(11377),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11377),
    [sym__pair_operator] = ACTIONS(11377),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11377),
    [sym__lazy_and_operator] = ACTIONS(11377),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11377),
    [sym__pipe_left_operator] = ACTIONS(11377),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11377),
    [sym__bitshift_operator] = ACTIONS(11377),
    [sym__power_operator] = ACTIONS(11377),
    [sym__tilde_operator] = ACTIONS(11377),
    [sym__type_order_operator] = ACTIONS(11377),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym__terminator_token1] = ACTIONS(11379),
    [aux_sym__terminator_token2] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7970] = {
    [sym_block_comment] = STATE(7970),
    [sym_line_comment] = STATE(7970),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_catch] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_QMARK] = ACTIONS(11287),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11287),
    [sym__lazy_and_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7971] = {
    [sym_block_comment] = STATE(7971),
    [sym_line_comment] = STATE(7971),
    [ts_builtin_sym_end] = ACTIONS(10855),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10850),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_RBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7972] = {
    [sym_block_comment] = STATE(7972),
    [sym_line_comment] = STATE(7972),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_end] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_catch] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11385),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11385),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11385),
    [anon_sym_DOLLAR] = ACTIONS(11385),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11385),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11385),
    [anon_sym_QMARK] = ACTIONS(11385),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11385),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11385),
    [aux_sym_integer_literal_token2] = ACTIONS(11385),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11385),
    [aux_sym_float_literal_token3] = ACTIONS(11385),
    [aux_sym_float_literal_token4] = ACTIONS(11385),
    [sym_character_literal] = ACTIONS(11385),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11385),
    [sym__pair_operator] = ACTIONS(11385),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11385),
    [sym__lazy_and_operator] = ACTIONS(11385),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11385),
    [sym__pipe_left_operator] = ACTIONS(11385),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11385),
    [sym__bitshift_operator] = ACTIONS(11385),
    [sym__power_operator] = ACTIONS(11385),
    [sym__tilde_operator] = ACTIONS(11385),
    [sym__type_order_operator] = ACTIONS(11385),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym__terminator_token1] = ACTIONS(11387),
    [aux_sym__terminator_token2] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7973] = {
    [sym_block_comment] = STATE(7973),
    [sym_line_comment] = STATE(7973),
    [ts_builtin_sym_end] = ACTIONS(10863),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_RBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7974] = {
    [sym_block_comment] = STATE(7974),
    [sym_line_comment] = STATE(7974),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11399),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_end] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_catch] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11399),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11399),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11399),
    [anon_sym_DOLLAR] = ACTIONS(11399),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11399),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11399),
    [anon_sym_QMARK] = ACTIONS(11399),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11399),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11399),
    [aux_sym_integer_literal_token2] = ACTIONS(11399),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11399),
    [aux_sym_float_literal_token3] = ACTIONS(11399),
    [aux_sym_float_literal_token4] = ACTIONS(11399),
    [sym_character_literal] = ACTIONS(11399),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11399),
    [sym__pair_operator] = ACTIONS(11399),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11399),
    [sym__lazy_and_operator] = ACTIONS(11399),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11399),
    [sym__pipe_left_operator] = ACTIONS(11399),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11399),
    [sym__bitshift_operator] = ACTIONS(11399),
    [sym__power_operator] = ACTIONS(11399),
    [sym__tilde_operator] = ACTIONS(11399),
    [sym__type_order_operator] = ACTIONS(11399),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym__terminator_token1] = ACTIONS(11401),
    [aux_sym__terminator_token2] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7975] = {
    [sym_block_comment] = STATE(7975),
    [sym_line_comment] = STATE(7975),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_end] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_catch] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11403),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11403),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11403),
    [anon_sym_DOLLAR] = ACTIONS(11403),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11403),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11403),
    [anon_sym_QMARK] = ACTIONS(11403),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11403),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11403),
    [aux_sym_integer_literal_token2] = ACTIONS(11403),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11403),
    [aux_sym_float_literal_token3] = ACTIONS(11403),
    [aux_sym_float_literal_token4] = ACTIONS(11403),
    [sym_character_literal] = ACTIONS(11403),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11403),
    [sym__pair_operator] = ACTIONS(11403),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11403),
    [sym__lazy_and_operator] = ACTIONS(11403),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11403),
    [sym__pipe_left_operator] = ACTIONS(11403),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11403),
    [sym__bitshift_operator] = ACTIONS(11403),
    [sym__power_operator] = ACTIONS(11403),
    [sym__tilde_operator] = ACTIONS(11403),
    [sym__type_order_operator] = ACTIONS(11403),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym__terminator_token1] = ACTIONS(11405),
    [aux_sym__terminator_token2] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7976] = {
    [sym_block_comment] = STATE(7976),
    [sym_line_comment] = STATE(7976),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11255),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_end] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_catch] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11255),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11255),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11255),
    [anon_sym_DOLLAR] = ACTIONS(11255),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11255),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11255),
    [anon_sym_QMARK] = ACTIONS(11255),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11255),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11255),
    [aux_sym_integer_literal_token2] = ACTIONS(11255),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11255),
    [aux_sym_float_literal_token3] = ACTIONS(11255),
    [aux_sym_float_literal_token4] = ACTIONS(11255),
    [sym_character_literal] = ACTIONS(11255),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11255),
    [sym__pair_operator] = ACTIONS(11255),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11255),
    [sym__lazy_and_operator] = ACTIONS(11255),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11255),
    [sym__pipe_left_operator] = ACTIONS(11255),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11255),
    [sym__bitshift_operator] = ACTIONS(11255),
    [sym__power_operator] = ACTIONS(11255),
    [sym__tilde_operator] = ACTIONS(11255),
    [sym__type_order_operator] = ACTIONS(11255),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym__terminator_token1] = ACTIONS(11257),
    [aux_sym__terminator_token2] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7977] = {
    [sym_block_comment] = STATE(7977),
    [sym_line_comment] = STATE(7977),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11411),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_end] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_catch] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11411),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11411),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11411),
    [anon_sym_DOLLAR] = ACTIONS(11411),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11411),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11411),
    [anon_sym_QMARK] = ACTIONS(11411),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11411),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11411),
    [aux_sym_integer_literal_token2] = ACTIONS(11411),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11411),
    [aux_sym_float_literal_token3] = ACTIONS(11411),
    [aux_sym_float_literal_token4] = ACTIONS(11411),
    [sym_character_literal] = ACTIONS(11411),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11411),
    [sym__pair_operator] = ACTIONS(11411),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11411),
    [sym__lazy_and_operator] = ACTIONS(11411),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11411),
    [sym__pipe_left_operator] = ACTIONS(11411),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11411),
    [sym__bitshift_operator] = ACTIONS(11411),
    [sym__power_operator] = ACTIONS(11411),
    [sym__tilde_operator] = ACTIONS(11411),
    [sym__type_order_operator] = ACTIONS(11411),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym__terminator_token1] = ACTIONS(11413),
    [aux_sym__terminator_token2] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7978] = {
    [sym_block_comment] = STATE(7978),
    [sym_line_comment] = STATE(7978),
    [ts_builtin_sym_end] = ACTIONS(11900),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_RBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym__terminator_token1] = ACTIONS(11900),
    [aux_sym__terminator_token2] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7979] = {
    [sym_block_comment] = STATE(7979),
    [sym_line_comment] = STATE(7979),
    [ts_builtin_sym_end] = ACTIONS(11175),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11173),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11173),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11173),
    [anon_sym_RBRACK] = ACTIONS(11173),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11173),
    [anon_sym_DOLLAR] = ACTIONS(11173),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11173),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11173),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11173),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11173),
    [aux_sym_integer_literal_token2] = ACTIONS(11173),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11173),
    [aux_sym_float_literal_token3] = ACTIONS(11173),
    [aux_sym_float_literal_token4] = ACTIONS(11173),
    [sym_character_literal] = ACTIONS(11173),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11173),
    [sym__pair_operator] = ACTIONS(11173),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11173),
    [sym__lazy_and_operator] = ACTIONS(11173),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11173),
    [sym__pipe_left_operator] = ACTIONS(11173),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11173),
    [sym__bitshift_operator] = ACTIONS(11173),
    [sym__power_operator] = ACTIONS(11173),
    [sym__tilde_operator] = ACTIONS(11173),
    [sym__type_order_operator] = ACTIONS(11173),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym__terminator_token1] = ACTIONS(11175),
    [aux_sym__terminator_token2] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7980] = {
    [sym_block_comment] = STATE(7980),
    [sym_line_comment] = STATE(7980),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10090),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7981] = {
    [sym_block_comment] = STATE(7981),
    [sym_line_comment] = STATE(7981),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7982] = {
    [sym_block_comment] = STATE(7982),
    [sym_line_comment] = STATE(7982),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9714),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9714),
    [anon_sym_QMARK] = ACTIONS(9714),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9714),
    [sym__lazy_and_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7983] = {
    [sym_block_comment] = STATE(7983),
    [sym_line_comment] = STATE(7983),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [7984] = {
    [sym_block_comment] = STATE(7984),
    [sym_line_comment] = STATE(7984),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10910),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10910),
    [anon_sym_RPAREN] = ACTIONS(10910),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10910),
    [anon_sym_RBRACK] = ACTIONS(10910),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_SEMI] = ACTIONS(10910),
    [anon_sym_LBRACE] = ACTIONS(10910),
    [anon_sym_RBRACE] = ACTIONS(10910),
    [anon_sym_DOLLAR] = ACTIONS(10910),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10910),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10910),
    [anon_sym_QMARK] = ACTIONS(10910),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10910),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10910),
    [aux_sym_integer_literal_token2] = ACTIONS(10910),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10910),
    [aux_sym_float_literal_token3] = ACTIONS(10910),
    [aux_sym_float_literal_token4] = ACTIONS(10910),
    [sym_character_literal] = ACTIONS(10910),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10910),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10910),
    [sym__pair_operator] = ACTIONS(10910),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10910),
    [sym__lazy_and_operator] = ACTIONS(10910),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10910),
    [sym__pipe_left_operator] = ACTIONS(10910),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10910),
    [sym__bitshift_operator] = ACTIONS(10910),
    [sym__power_operator] = ACTIONS(10910),
    [sym__tilde_operator] = ACTIONS(10910),
    [sym__type_order_operator] = ACTIONS(10910),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7985] = {
    [sym_block_comment] = STATE(7985),
    [sym_line_comment] = STATE(7985),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10976),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_RBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7986] = {
    [sym_block_comment] = STATE(7986),
    [sym_line_comment] = STATE(7986),
    [ts_builtin_sym_end] = ACTIONS(11519),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11517),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11517),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11517),
    [anon_sym_RBRACK] = ACTIONS(11517),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11517),
    [anon_sym_DOLLAR] = ACTIONS(11517),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11517),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11517),
    [anon_sym_QMARK] = ACTIONS(11517),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11517),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11517),
    [aux_sym_integer_literal_token2] = ACTIONS(11517),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11517),
    [aux_sym_float_literal_token3] = ACTIONS(11517),
    [aux_sym_float_literal_token4] = ACTIONS(11517),
    [sym_character_literal] = ACTIONS(11517),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11517),
    [sym__pair_operator] = ACTIONS(11517),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11517),
    [sym__lazy_and_operator] = ACTIONS(11517),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11517),
    [sym__pipe_left_operator] = ACTIONS(11517),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11517),
    [sym__bitshift_operator] = ACTIONS(11517),
    [sym__power_operator] = ACTIONS(11517),
    [sym__tilde_operator] = ACTIONS(11517),
    [sym__type_order_operator] = ACTIONS(11517),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym__terminator_token1] = ACTIONS(11519),
    [aux_sym__terminator_token2] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7987] = {
    [sym_block_comment] = STATE(7987),
    [sym_line_comment] = STATE(7987),
    [ts_builtin_sym_end] = ACTIONS(11926),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11924),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11924),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11924),
    [anon_sym_RBRACK] = ACTIONS(11924),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11924),
    [anon_sym_DOLLAR] = ACTIONS(11924),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11924),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11924),
    [anon_sym_QMARK] = ACTIONS(11924),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11924),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11924),
    [aux_sym_integer_literal_token2] = ACTIONS(11924),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11924),
    [aux_sym_float_literal_token3] = ACTIONS(11924),
    [aux_sym_float_literal_token4] = ACTIONS(11924),
    [sym_character_literal] = ACTIONS(11924),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11924),
    [sym__pair_operator] = ACTIONS(11924),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11924),
    [sym__lazy_and_operator] = ACTIONS(11924),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11924),
    [sym__pipe_left_operator] = ACTIONS(11924),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11924),
    [sym__bitshift_operator] = ACTIONS(11924),
    [sym__power_operator] = ACTIONS(11924),
    [sym__tilde_operator] = ACTIONS(11924),
    [sym__type_order_operator] = ACTIONS(11924),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym__terminator_token1] = ACTIONS(11926),
    [aux_sym__terminator_token2] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7988] = {
    [sym_block_comment] = STATE(7988),
    [sym_line_comment] = STATE(7988),
    [ts_builtin_sym_end] = ACTIONS(11943),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11941),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11941),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11941),
    [anon_sym_RBRACK] = ACTIONS(11941),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11941),
    [anon_sym_DOLLAR] = ACTIONS(11941),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11941),
    [anon_sym_QMARK] = ACTIONS(11941),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11941),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11941),
    [aux_sym_integer_literal_token2] = ACTIONS(11941),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11941),
    [aux_sym_float_literal_token3] = ACTIONS(11941),
    [aux_sym_float_literal_token4] = ACTIONS(11941),
    [sym_character_literal] = ACTIONS(11941),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11941),
    [sym__pair_operator] = ACTIONS(11941),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11941),
    [sym__lazy_and_operator] = ACTIONS(11941),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11941),
    [sym__pipe_left_operator] = ACTIONS(11941),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11941),
    [sym__bitshift_operator] = ACTIONS(11941),
    [sym__power_operator] = ACTIONS(11941),
    [sym__tilde_operator] = ACTIONS(11941),
    [sym__type_order_operator] = ACTIONS(11941),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym__terminator_token1] = ACTIONS(11943),
    [aux_sym__terminator_token2] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7989] = {
    [sym_block_comment] = STATE(7989),
    [sym_line_comment] = STATE(7989),
    [ts_builtin_sym_end] = ACTIONS(11967),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11965),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11965),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11965),
    [anon_sym_RBRACK] = ACTIONS(11965),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11965),
    [anon_sym_DOLLAR] = ACTIONS(11965),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11965),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11965),
    [anon_sym_QMARK] = ACTIONS(11965),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11965),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11965),
    [aux_sym_integer_literal_token2] = ACTIONS(11965),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11965),
    [aux_sym_float_literal_token3] = ACTIONS(11965),
    [aux_sym_float_literal_token4] = ACTIONS(11965),
    [sym_character_literal] = ACTIONS(11965),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11965),
    [sym__pair_operator] = ACTIONS(11965),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11965),
    [sym__lazy_and_operator] = ACTIONS(11965),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11965),
    [sym__pipe_left_operator] = ACTIONS(11965),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11965),
    [sym__bitshift_operator] = ACTIONS(11965),
    [sym__power_operator] = ACTIONS(11965),
    [sym__tilde_operator] = ACTIONS(11965),
    [sym__type_order_operator] = ACTIONS(11965),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym__terminator_token1] = ACTIONS(11967),
    [aux_sym__terminator_token2] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7990] = {
    [sym_block_comment] = STATE(7990),
    [sym_line_comment] = STATE(7990),
    [ts_builtin_sym_end] = ACTIONS(11971),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11969),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11969),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11969),
    [anon_sym_RBRACK] = ACTIONS(11969),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11969),
    [anon_sym_DOLLAR] = ACTIONS(11969),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11969),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11969),
    [anon_sym_QMARK] = ACTIONS(11969),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11969),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11969),
    [aux_sym_integer_literal_token2] = ACTIONS(11969),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11969),
    [aux_sym_float_literal_token3] = ACTIONS(11969),
    [aux_sym_float_literal_token4] = ACTIONS(11969),
    [sym_character_literal] = ACTIONS(11969),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11969),
    [sym__pair_operator] = ACTIONS(11969),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11969),
    [sym__lazy_and_operator] = ACTIONS(11969),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11969),
    [sym__pipe_left_operator] = ACTIONS(11969),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11969),
    [sym__bitshift_operator] = ACTIONS(11969),
    [sym__power_operator] = ACTIONS(11969),
    [sym__tilde_operator] = ACTIONS(11969),
    [sym__type_order_operator] = ACTIONS(11969),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym__terminator_token1] = ACTIONS(11971),
    [aux_sym__terminator_token2] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7991] = {
    [sym_block_comment] = STATE(7991),
    [sym_line_comment] = STATE(7991),
    [ts_builtin_sym_end] = ACTIONS(12050),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_RBRACK] = ACTIONS(12048),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12050),
    [aux_sym__terminator_token2] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7992] = {
    [sym_block_comment] = STATE(7992),
    [sym_line_comment] = STATE(7992),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11563),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_end] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_catch] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11563),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11563),
    [anon_sym_DOLLAR] = ACTIONS(11563),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11563),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_QMARK] = ACTIONS(11563),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11563),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11563),
    [aux_sym_integer_literal_token2] = ACTIONS(11563),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11563),
    [aux_sym_float_literal_token3] = ACTIONS(11563),
    [aux_sym_float_literal_token4] = ACTIONS(11563),
    [sym_character_literal] = ACTIONS(11563),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11563),
    [sym__pair_operator] = ACTIONS(11563),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11563),
    [sym__lazy_and_operator] = ACTIONS(11563),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11563),
    [sym__pipe_left_operator] = ACTIONS(11563),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11563),
    [sym__bitshift_operator] = ACTIONS(11563),
    [sym__power_operator] = ACTIONS(11563),
    [sym__tilde_operator] = ACTIONS(11563),
    [sym__type_order_operator] = ACTIONS(11563),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym__terminator_token1] = ACTIONS(11565),
    [aux_sym__terminator_token2] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7993] = {
    [sym_block_comment] = STATE(7993),
    [sym_line_comment] = STATE(7993),
    [ts_builtin_sym_end] = ACTIONS(11035),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11033),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11033),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11033),
    [anon_sym_RBRACK] = ACTIONS(11033),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11033),
    [anon_sym_DOLLAR] = ACTIONS(11033),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11033),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11033),
    [anon_sym_QMARK] = ACTIONS(11033),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11033),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11033),
    [aux_sym_integer_literal_token2] = ACTIONS(11033),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11033),
    [aux_sym_float_literal_token3] = ACTIONS(11033),
    [aux_sym_float_literal_token4] = ACTIONS(11033),
    [sym_character_literal] = ACTIONS(11033),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11033),
    [sym__pair_operator] = ACTIONS(11033),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11033),
    [sym__lazy_and_operator] = ACTIONS(11033),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11033),
    [sym__pipe_left_operator] = ACTIONS(11033),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11033),
    [sym__bitshift_operator] = ACTIONS(11033),
    [sym__power_operator] = ACTIONS(11033),
    [sym__tilde_operator] = ACTIONS(11033),
    [sym__type_order_operator] = ACTIONS(11033),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym__terminator_token1] = ACTIONS(11035),
    [aux_sym__terminator_token2] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7994] = {
    [sym_block_comment] = STATE(7994),
    [sym_line_comment] = STATE(7994),
    [ts_builtin_sym_end] = ACTIONS(11041),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11039),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11039),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11039),
    [anon_sym_RBRACK] = ACTIONS(11039),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11039),
    [anon_sym_DOLLAR] = ACTIONS(11039),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11039),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11039),
    [anon_sym_QMARK] = ACTIONS(11039),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11039),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11039),
    [aux_sym_integer_literal_token2] = ACTIONS(11039),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11039),
    [aux_sym_float_literal_token3] = ACTIONS(11039),
    [aux_sym_float_literal_token4] = ACTIONS(11039),
    [sym_character_literal] = ACTIONS(11039),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11039),
    [sym__pair_operator] = ACTIONS(11039),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11039),
    [sym__lazy_and_operator] = ACTIONS(11039),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11039),
    [sym__pipe_left_operator] = ACTIONS(11039),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11039),
    [sym__bitshift_operator] = ACTIONS(11039),
    [sym__power_operator] = ACTIONS(11039),
    [sym__tilde_operator] = ACTIONS(11039),
    [sym__type_order_operator] = ACTIONS(11039),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym__terminator_token1] = ACTIONS(11041),
    [aux_sym__terminator_token2] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7995] = {
    [sym_block_comment] = STATE(7995),
    [sym_line_comment] = STATE(7995),
    [ts_builtin_sym_end] = ACTIONS(11045),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11043),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11043),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11043),
    [anon_sym_RBRACK] = ACTIONS(11043),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11043),
    [anon_sym_DOLLAR] = ACTIONS(11043),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11043),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11043),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11043),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11043),
    [aux_sym_integer_literal_token2] = ACTIONS(11043),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11043),
    [aux_sym_float_literal_token3] = ACTIONS(11043),
    [aux_sym_float_literal_token4] = ACTIONS(11043),
    [sym_character_literal] = ACTIONS(11043),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11043),
    [sym__pair_operator] = ACTIONS(11043),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11043),
    [sym__lazy_and_operator] = ACTIONS(11043),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11043),
    [sym__pipe_left_operator] = ACTIONS(11043),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11043),
    [sym__bitshift_operator] = ACTIONS(11043),
    [sym__power_operator] = ACTIONS(11043),
    [sym__tilde_operator] = ACTIONS(11043),
    [sym__type_order_operator] = ACTIONS(11043),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym__terminator_token1] = ACTIONS(11045),
    [aux_sym__terminator_token2] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7996] = {
    [sym_block_comment] = STATE(7996),
    [sym_line_comment] = STATE(7996),
    [ts_builtin_sym_end] = ACTIONS(11118),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11116),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11116),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11116),
    [anon_sym_RBRACK] = ACTIONS(11116),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11116),
    [anon_sym_DOLLAR] = ACTIONS(11116),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11116),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11116),
    [anon_sym_QMARK] = ACTIONS(11116),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11116),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11116),
    [aux_sym_integer_literal_token2] = ACTIONS(11116),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11116),
    [aux_sym_float_literal_token3] = ACTIONS(11116),
    [aux_sym_float_literal_token4] = ACTIONS(11116),
    [sym_character_literal] = ACTIONS(11116),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11116),
    [sym__pair_operator] = ACTIONS(11116),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11116),
    [sym__lazy_and_operator] = ACTIONS(11116),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11116),
    [sym__pipe_left_operator] = ACTIONS(11116),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11116),
    [sym__bitshift_operator] = ACTIONS(11116),
    [sym__power_operator] = ACTIONS(11116),
    [sym__tilde_operator] = ACTIONS(11116),
    [sym__type_order_operator] = ACTIONS(11116),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym__terminator_token1] = ACTIONS(11118),
    [aux_sym__terminator_token2] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7997] = {
    [sym_block_comment] = STATE(7997),
    [sym_line_comment] = STATE(7997),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10850),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_catch] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7998] = {
    [sym_block_comment] = STATE(7998),
    [sym_line_comment] = STATE(7998),
    [ts_builtin_sym_end] = ACTIONS(11122),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11120),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11120),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11120),
    [anon_sym_RBRACK] = ACTIONS(11120),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11120),
    [anon_sym_DOLLAR] = ACTIONS(11120),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11120),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11120),
    [anon_sym_QMARK] = ACTIONS(11120),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11120),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11120),
    [aux_sym_integer_literal_token2] = ACTIONS(11120),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11120),
    [aux_sym_float_literal_token3] = ACTIONS(11120),
    [aux_sym_float_literal_token4] = ACTIONS(11120),
    [sym_character_literal] = ACTIONS(11120),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11120),
    [sym__pair_operator] = ACTIONS(11120),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11120),
    [sym__lazy_and_operator] = ACTIONS(11120),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11120),
    [sym__pipe_left_operator] = ACTIONS(11120),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11120),
    [sym__bitshift_operator] = ACTIONS(11120),
    [sym__power_operator] = ACTIONS(11120),
    [sym__tilde_operator] = ACTIONS(11120),
    [sym__type_order_operator] = ACTIONS(11120),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym__terminator_token1] = ACTIONS(11122),
    [aux_sym__terminator_token2] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [7999] = {
    [sym_block_comment] = STATE(7999),
    [sym_line_comment] = STATE(7999),
    [ts_builtin_sym_end] = ACTIONS(11199),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11197),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11197),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11197),
    [anon_sym_RBRACK] = ACTIONS(11197),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11197),
    [anon_sym_DOLLAR] = ACTIONS(11197),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11197),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11197),
    [anon_sym_QMARK] = ACTIONS(11197),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11197),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11197),
    [aux_sym_integer_literal_token2] = ACTIONS(11197),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11197),
    [aux_sym_float_literal_token3] = ACTIONS(11197),
    [aux_sym_float_literal_token4] = ACTIONS(11197),
    [sym_character_literal] = ACTIONS(11197),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11197),
    [sym__pair_operator] = ACTIONS(11197),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11197),
    [sym__lazy_and_operator] = ACTIONS(11197),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11197),
    [sym__pipe_left_operator] = ACTIONS(11197),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11197),
    [sym__bitshift_operator] = ACTIONS(11197),
    [sym__power_operator] = ACTIONS(11197),
    [sym__tilde_operator] = ACTIONS(11197),
    [sym__type_order_operator] = ACTIONS(11197),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym__terminator_token1] = ACTIONS(11199),
    [aux_sym__terminator_token2] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8000] = {
    [sym_block_comment] = STATE(8000),
    [sym_line_comment] = STATE(8000),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8001] = {
    [sym_block_comment] = STATE(8001),
    [sym_line_comment] = STATE(8001),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8002] = {
    [sym_block_comment] = STATE(8002),
    [sym_line_comment] = STATE(8002),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8003] = {
    [sym_block_comment] = STATE(8003),
    [sym_line_comment] = STATE(8003),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8004] = {
    [sym_block_comment] = STATE(8004),
    [sym_line_comment] = STATE(8004),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8005] = {
    [sym_block_comment] = STATE(8005),
    [sym_line_comment] = STATE(8005),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8006] = {
    [sym_block_comment] = STATE(8006),
    [sym_line_comment] = STATE(8006),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8007] = {
    [sym_block_comment] = STATE(8007),
    [sym_line_comment] = STATE(8007),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8008] = {
    [sym_block_comment] = STATE(8008),
    [sym_line_comment] = STATE(8008),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8009] = {
    [sym_block_comment] = STATE(8009),
    [sym_line_comment] = STATE(8009),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8010] = {
    [sym_block_comment] = STATE(8010),
    [sym_line_comment] = STATE(8010),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8011] = {
    [sym_block_comment] = STATE(8011),
    [sym_line_comment] = STATE(8011),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8012] = {
    [sym_block_comment] = STATE(8012),
    [sym_line_comment] = STATE(8012),
    [ts_builtin_sym_end] = ACTIONS(11213),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11211),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_RBRACK] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOLLAR] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11211),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11211),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11211),
    [aux_sym_integer_literal_token2] = ACTIONS(11211),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11211),
    [aux_sym_float_literal_token3] = ACTIONS(11211),
    [aux_sym_float_literal_token4] = ACTIONS(11211),
    [sym_character_literal] = ACTIONS(11211),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11211),
    [sym__pair_operator] = ACTIONS(11211),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11211),
    [sym__lazy_and_operator] = ACTIONS(11211),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11211),
    [sym__pipe_left_operator] = ACTIONS(11211),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11211),
    [sym__bitshift_operator] = ACTIONS(11211),
    [sym__power_operator] = ACTIONS(11211),
    [sym__tilde_operator] = ACTIONS(11211),
    [sym__type_order_operator] = ACTIONS(11211),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym__terminator_token1] = ACTIONS(11213),
    [aux_sym__terminator_token2] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8013] = {
    [sym_block_comment] = STATE(8013),
    [sym_line_comment] = STATE(8013),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_catch] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8014] = {
    [sym_block_comment] = STATE(8014),
    [sym_line_comment] = STATE(8014),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_end] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_catch] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym__terminator_token1] = ACTIONS(11900),
    [aux_sym__terminator_token2] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8015] = {
    [sym_block_comment] = STATE(8015),
    [sym_line_comment] = STATE(8015),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_finally] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8016] = {
    [sym_block_comment] = STATE(8016),
    [sym_line_comment] = STATE(8016),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10577),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10577),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10577),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10577),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10577),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10577),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10577),
    [anon_sym_QMARK] = ACTIONS(10577),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10577),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10577),
    [aux_sym_integer_literal_token2] = ACTIONS(10577),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10577),
    [aux_sym_float_literal_token3] = ACTIONS(10577),
    [aux_sym_float_literal_token4] = ACTIONS(10577),
    [sym_character_literal] = ACTIONS(10577),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10577),
    [sym__pair_operator] = ACTIONS(10577),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10577),
    [sym__lazy_and_operator] = ACTIONS(10577),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10577),
    [sym__pipe_left_operator] = ACTIONS(10577),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10577),
    [sym__bitshift_operator] = ACTIONS(10577),
    [sym__power_operator] = ACTIONS(10577),
    [sym__tilde_operator] = ACTIONS(10577),
    [sym__type_order_operator] = ACTIONS(10577),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym__terminator_token1] = ACTIONS(10579),
    [aux_sym__terminator_token2] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8017] = {
    [sym_block_comment] = STATE(8017),
    [sym_line_comment] = STATE(8017),
    [ts_builtin_sym_end] = ACTIONS(10982),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_RBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10978),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10978),
    [anon_sym_QMARK] = ACTIONS(10978),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10978),
    [sym__lazy_and_operator] = ACTIONS(10978),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10978),
    [sym__pipe_left_operator] = ACTIONS(10978),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10978),
    [sym__bitshift_operator] = ACTIONS(10978),
    [sym__power_operator] = ACTIONS(10978),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10978),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8018] = {
    [sym_block_comment] = STATE(8018),
    [sym_line_comment] = STATE(8018),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10116),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10116),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10116),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10116),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10116),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10116),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10116),
    [anon_sym_QMARK] = ACTIONS(10116),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10116),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10116),
    [aux_sym_integer_literal_token2] = ACTIONS(10116),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10116),
    [aux_sym_float_literal_token3] = ACTIONS(10116),
    [aux_sym_float_literal_token4] = ACTIONS(10116),
    [sym_character_literal] = ACTIONS(10116),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10116),
    [sym__pair_operator] = ACTIONS(10116),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10116),
    [sym__lazy_and_operator] = ACTIONS(10116),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10116),
    [sym__pipe_left_operator] = ACTIONS(10116),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10116),
    [sym__bitshift_operator] = ACTIONS(10116),
    [sym__power_operator] = ACTIONS(10116),
    [sym__tilde_operator] = ACTIONS(10116),
    [sym__type_order_operator] = ACTIONS(10116),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym__terminator_token1] = ACTIONS(10118),
    [aux_sym__terminator_token2] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8019] = {
    [sym_block_comment] = STATE(8019),
    [sym_line_comment] = STATE(8019),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11173),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_end] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_catch] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11173),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11173),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11173),
    [anon_sym_DOLLAR] = ACTIONS(11173),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11173),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11173),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11173),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11173),
    [aux_sym_integer_literal_token2] = ACTIONS(11173),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11173),
    [aux_sym_float_literal_token3] = ACTIONS(11173),
    [aux_sym_float_literal_token4] = ACTIONS(11173),
    [sym_character_literal] = ACTIONS(11173),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11173),
    [sym__pair_operator] = ACTIONS(11173),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11173),
    [sym__lazy_and_operator] = ACTIONS(11173),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11173),
    [sym__pipe_left_operator] = ACTIONS(11173),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11173),
    [sym__bitshift_operator] = ACTIONS(11173),
    [sym__power_operator] = ACTIONS(11173),
    [sym__tilde_operator] = ACTIONS(11173),
    [sym__type_order_operator] = ACTIONS(11173),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym__terminator_token1] = ACTIONS(11175),
    [aux_sym__terminator_token2] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8020] = {
    [sym_block_comment] = STATE(8020),
    [sym_line_comment] = STATE(8020),
    [ts_builtin_sym_end] = ACTIONS(11271),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11269),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11269),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11269),
    [anon_sym_RBRACK] = ACTIONS(11269),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11269),
    [anon_sym_DOLLAR] = ACTIONS(11269),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11269),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11269),
    [anon_sym_QMARK] = ACTIONS(11269),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11269),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11269),
    [aux_sym_integer_literal_token2] = ACTIONS(11269),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11269),
    [aux_sym_float_literal_token3] = ACTIONS(11269),
    [aux_sym_float_literal_token4] = ACTIONS(11269),
    [sym_character_literal] = ACTIONS(11269),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11269),
    [sym__pair_operator] = ACTIONS(11269),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11269),
    [sym__lazy_and_operator] = ACTIONS(11269),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11269),
    [sym__pipe_left_operator] = ACTIONS(11269),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11269),
    [sym__bitshift_operator] = ACTIONS(11269),
    [sym__power_operator] = ACTIONS(11269),
    [sym__tilde_operator] = ACTIONS(11269),
    [sym__type_order_operator] = ACTIONS(11269),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym__terminator_token1] = ACTIONS(11271),
    [aux_sym__terminator_token2] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8021] = {
    [sym_block_comment] = STATE(8021),
    [sym_line_comment] = STATE(8021),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11251),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_end] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_catch] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11251),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11251),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11251),
    [anon_sym_DOLLAR] = ACTIONS(11251),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11251),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11251),
    [anon_sym_QMARK] = ACTIONS(11251),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11251),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11251),
    [aux_sym_integer_literal_token2] = ACTIONS(11251),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11251),
    [aux_sym_float_literal_token3] = ACTIONS(11251),
    [aux_sym_float_literal_token4] = ACTIONS(11251),
    [sym_character_literal] = ACTIONS(11251),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11251),
    [sym__pair_operator] = ACTIONS(11251),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11251),
    [sym__lazy_and_operator] = ACTIONS(11251),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11251),
    [sym__pipe_left_operator] = ACTIONS(11251),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11251),
    [sym__bitshift_operator] = ACTIONS(11251),
    [sym__power_operator] = ACTIONS(11251),
    [sym__tilde_operator] = ACTIONS(11251),
    [sym__type_order_operator] = ACTIONS(11251),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym__terminator_token1] = ACTIONS(11253),
    [aux_sym__terminator_token2] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8022] = {
    [sym_block_comment] = STATE(8022),
    [sym_line_comment] = STATE(8022),
    [ts_builtin_sym_end] = ACTIONS(11281),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11279),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11279),
    [anon_sym_RBRACK] = ACTIONS(11279),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11279),
    [anon_sym_DOLLAR] = ACTIONS(11279),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11279),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11279),
    [anon_sym_QMARK] = ACTIONS(11279),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11279),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11279),
    [aux_sym_integer_literal_token2] = ACTIONS(11279),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11279),
    [aux_sym_float_literal_token3] = ACTIONS(11279),
    [aux_sym_float_literal_token4] = ACTIONS(11279),
    [sym_character_literal] = ACTIONS(11279),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11279),
    [sym__pair_operator] = ACTIONS(11279),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11279),
    [sym__lazy_and_operator] = ACTIONS(11279),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11279),
    [sym__pipe_left_operator] = ACTIONS(11279),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11279),
    [sym__bitshift_operator] = ACTIONS(11279),
    [sym__power_operator] = ACTIONS(11279),
    [sym__tilde_operator] = ACTIONS(11279),
    [sym__type_order_operator] = ACTIONS(11279),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym__terminator_token1] = ACTIONS(11281),
    [aux_sym__terminator_token2] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8023] = {
    [sym_block_comment] = STATE(8023),
    [sym_line_comment] = STATE(8023),
    [ts_builtin_sym_end] = ACTIONS(11311),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11309),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11309),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11309),
    [anon_sym_RBRACK] = ACTIONS(11309),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11309),
    [anon_sym_DOLLAR] = ACTIONS(11309),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11309),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11309),
    [anon_sym_QMARK] = ACTIONS(11309),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11309),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11309),
    [aux_sym_integer_literal_token2] = ACTIONS(11309),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11309),
    [aux_sym_float_literal_token3] = ACTIONS(11309),
    [aux_sym_float_literal_token4] = ACTIONS(11309),
    [sym_character_literal] = ACTIONS(11309),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11309),
    [sym__pair_operator] = ACTIONS(11309),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11309),
    [sym__lazy_and_operator] = ACTIONS(11309),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11309),
    [sym__pipe_left_operator] = ACTIONS(11309),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11309),
    [sym__bitshift_operator] = ACTIONS(11309),
    [sym__power_operator] = ACTIONS(11309),
    [sym__tilde_operator] = ACTIONS(11309),
    [sym__type_order_operator] = ACTIONS(11309),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym__terminator_token1] = ACTIONS(11311),
    [aux_sym__terminator_token2] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8024] = {
    [sym_block_comment] = STATE(8024),
    [sym_line_comment] = STATE(8024),
    [ts_builtin_sym_end] = ACTIONS(11319),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11317),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11317),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11317),
    [anon_sym_RBRACK] = ACTIONS(11317),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11317),
    [anon_sym_DOLLAR] = ACTIONS(11317),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11317),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11317),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11317),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11317),
    [aux_sym_integer_literal_token2] = ACTIONS(11317),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11317),
    [aux_sym_float_literal_token3] = ACTIONS(11317),
    [aux_sym_float_literal_token4] = ACTIONS(11317),
    [sym_character_literal] = ACTIONS(11317),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11317),
    [sym__pair_operator] = ACTIONS(11317),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11317),
    [sym__lazy_and_operator] = ACTIONS(11317),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11317),
    [sym__pipe_left_operator] = ACTIONS(11317),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11317),
    [sym__bitshift_operator] = ACTIONS(11317),
    [sym__power_operator] = ACTIONS(11317),
    [sym__tilde_operator] = ACTIONS(11317),
    [sym__type_order_operator] = ACTIONS(11317),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym__terminator_token1] = ACTIONS(11319),
    [aux_sym__terminator_token2] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8025] = {
    [sym_block_comment] = STATE(8025),
    [sym_line_comment] = STATE(8025),
    [ts_builtin_sym_end] = ACTIONS(11361),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11359),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11359),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11359),
    [anon_sym_RBRACK] = ACTIONS(11359),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11359),
    [anon_sym_DOLLAR] = ACTIONS(11359),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11359),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11359),
    [anon_sym_QMARK] = ACTIONS(11359),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11359),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11359),
    [aux_sym_integer_literal_token2] = ACTIONS(11359),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11359),
    [aux_sym_float_literal_token3] = ACTIONS(11359),
    [aux_sym_float_literal_token4] = ACTIONS(11359),
    [sym_character_literal] = ACTIONS(11359),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11359),
    [sym__pair_operator] = ACTIONS(11359),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11359),
    [sym__lazy_and_operator] = ACTIONS(11359),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11359),
    [sym__pipe_left_operator] = ACTIONS(11359),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11359),
    [sym__bitshift_operator] = ACTIONS(11359),
    [sym__power_operator] = ACTIONS(11359),
    [sym__tilde_operator] = ACTIONS(11359),
    [sym__type_order_operator] = ACTIONS(11359),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym__terminator_token1] = ACTIONS(11361),
    [aux_sym__terminator_token2] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8026] = {
    [sym_block_comment] = STATE(8026),
    [sym_line_comment] = STATE(8026),
    [ts_builtin_sym_end] = ACTIONS(11383),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11381),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11381),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11381),
    [anon_sym_RBRACK] = ACTIONS(11381),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11381),
    [anon_sym_DOLLAR] = ACTIONS(11381),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11381),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11381),
    [anon_sym_QMARK] = ACTIONS(11381),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11381),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11381),
    [aux_sym_integer_literal_token2] = ACTIONS(11381),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11381),
    [aux_sym_float_literal_token3] = ACTIONS(11381),
    [aux_sym_float_literal_token4] = ACTIONS(11381),
    [sym_character_literal] = ACTIONS(11381),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11381),
    [sym__pair_operator] = ACTIONS(11381),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11381),
    [sym__lazy_and_operator] = ACTIONS(11381),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11381),
    [sym__pipe_left_operator] = ACTIONS(11381),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11381),
    [sym__bitshift_operator] = ACTIONS(11381),
    [sym__power_operator] = ACTIONS(11381),
    [sym__tilde_operator] = ACTIONS(11381),
    [sym__type_order_operator] = ACTIONS(11381),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym__terminator_token1] = ACTIONS(11383),
    [aux_sym__terminator_token2] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8027] = {
    [sym_block_comment] = STATE(8027),
    [sym_line_comment] = STATE(8027),
    [ts_builtin_sym_end] = ACTIONS(11409),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11407),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11407),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11407),
    [anon_sym_RBRACK] = ACTIONS(11407),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11407),
    [anon_sym_DOLLAR] = ACTIONS(11407),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11407),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11407),
    [anon_sym_QMARK] = ACTIONS(11407),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11407),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11407),
    [aux_sym_integer_literal_token2] = ACTIONS(11407),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11407),
    [aux_sym_float_literal_token3] = ACTIONS(11407),
    [aux_sym_float_literal_token4] = ACTIONS(11407),
    [sym_character_literal] = ACTIONS(11407),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11407),
    [sym__pair_operator] = ACTIONS(11407),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11407),
    [sym__lazy_and_operator] = ACTIONS(11407),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11407),
    [sym__pipe_left_operator] = ACTIONS(11407),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11407),
    [sym__bitshift_operator] = ACTIONS(11407),
    [sym__power_operator] = ACTIONS(11407),
    [sym__tilde_operator] = ACTIONS(11407),
    [sym__type_order_operator] = ACTIONS(11407),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym__terminator_token1] = ACTIONS(11409),
    [aux_sym__terminator_token2] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8028] = {
    [sym_block_comment] = STATE(8028),
    [sym_line_comment] = STATE(8028),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8029] = {
    [sym_block_comment] = STATE(8029),
    [sym_line_comment] = STATE(8029),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11517),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_end] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_catch] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11517),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11517),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11517),
    [anon_sym_DOLLAR] = ACTIONS(11517),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11517),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11517),
    [anon_sym_QMARK] = ACTIONS(11517),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11517),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11517),
    [aux_sym_integer_literal_token2] = ACTIONS(11517),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11517),
    [aux_sym_float_literal_token3] = ACTIONS(11517),
    [aux_sym_float_literal_token4] = ACTIONS(11517),
    [sym_character_literal] = ACTIONS(11517),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11517),
    [sym__pair_operator] = ACTIONS(11517),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11517),
    [sym__lazy_and_operator] = ACTIONS(11517),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11517),
    [sym__pipe_left_operator] = ACTIONS(11517),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11517),
    [sym__bitshift_operator] = ACTIONS(11517),
    [sym__power_operator] = ACTIONS(11517),
    [sym__tilde_operator] = ACTIONS(11517),
    [sym__type_order_operator] = ACTIONS(11517),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym__terminator_token1] = ACTIONS(11519),
    [aux_sym__terminator_token2] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8030] = {
    [sym_block_comment] = STATE(8030),
    [sym_line_comment] = STATE(8030),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9866),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8031] = {
    [sym_block_comment] = STATE(8031),
    [sym_line_comment] = STATE(8031),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8032] = {
    [sym_block_comment] = STATE(8032),
    [sym_line_comment] = STATE(8032),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11924),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_end] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_catch] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11924),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11924),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11924),
    [anon_sym_DOLLAR] = ACTIONS(11924),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11924),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11924),
    [anon_sym_QMARK] = ACTIONS(11924),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11924),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11924),
    [aux_sym_integer_literal_token2] = ACTIONS(11924),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11924),
    [aux_sym_float_literal_token3] = ACTIONS(11924),
    [aux_sym_float_literal_token4] = ACTIONS(11924),
    [sym_character_literal] = ACTIONS(11924),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11924),
    [sym__pair_operator] = ACTIONS(11924),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11924),
    [sym__lazy_and_operator] = ACTIONS(11924),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11924),
    [sym__pipe_left_operator] = ACTIONS(11924),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11924),
    [sym__bitshift_operator] = ACTIONS(11924),
    [sym__power_operator] = ACTIONS(11924),
    [sym__tilde_operator] = ACTIONS(11924),
    [sym__type_order_operator] = ACTIONS(11924),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym__terminator_token1] = ACTIONS(11926),
    [aux_sym__terminator_token2] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8033] = {
    [sym_block_comment] = STATE(8033),
    [sym_line_comment] = STATE(8033),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11941),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_end] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_catch] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11941),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11941),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11941),
    [anon_sym_DOLLAR] = ACTIONS(11941),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11941),
    [anon_sym_QMARK] = ACTIONS(11941),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11941),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11941),
    [aux_sym_integer_literal_token2] = ACTIONS(11941),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11941),
    [aux_sym_float_literal_token3] = ACTIONS(11941),
    [aux_sym_float_literal_token4] = ACTIONS(11941),
    [sym_character_literal] = ACTIONS(11941),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11941),
    [sym__pair_operator] = ACTIONS(11941),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11941),
    [sym__lazy_and_operator] = ACTIONS(11941),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11941),
    [sym__pipe_left_operator] = ACTIONS(11941),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11941),
    [sym__bitshift_operator] = ACTIONS(11941),
    [sym__power_operator] = ACTIONS(11941),
    [sym__tilde_operator] = ACTIONS(11941),
    [sym__type_order_operator] = ACTIONS(11941),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym__terminator_token1] = ACTIONS(11943),
    [aux_sym__terminator_token2] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8034] = {
    [sym_block_comment] = STATE(8034),
    [sym_line_comment] = STATE(8034),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11965),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_end] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_catch] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11965),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11965),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11965),
    [anon_sym_DOLLAR] = ACTIONS(11965),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11965),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11965),
    [anon_sym_QMARK] = ACTIONS(11965),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11965),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11965),
    [aux_sym_integer_literal_token2] = ACTIONS(11965),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11965),
    [aux_sym_float_literal_token3] = ACTIONS(11965),
    [aux_sym_float_literal_token4] = ACTIONS(11965),
    [sym_character_literal] = ACTIONS(11965),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11965),
    [sym__pair_operator] = ACTIONS(11965),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11965),
    [sym__lazy_and_operator] = ACTIONS(11965),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11965),
    [sym__pipe_left_operator] = ACTIONS(11965),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11965),
    [sym__bitshift_operator] = ACTIONS(11965),
    [sym__power_operator] = ACTIONS(11965),
    [sym__tilde_operator] = ACTIONS(11965),
    [sym__type_order_operator] = ACTIONS(11965),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym__terminator_token1] = ACTIONS(11967),
    [aux_sym__terminator_token2] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8035] = {
    [sym_block_comment] = STATE(8035),
    [sym_line_comment] = STATE(8035),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11969),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_end] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_catch] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11969),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11969),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11969),
    [anon_sym_DOLLAR] = ACTIONS(11969),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11969),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11969),
    [anon_sym_QMARK] = ACTIONS(11969),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11969),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11969),
    [aux_sym_integer_literal_token2] = ACTIONS(11969),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11969),
    [aux_sym_float_literal_token3] = ACTIONS(11969),
    [aux_sym_float_literal_token4] = ACTIONS(11969),
    [sym_character_literal] = ACTIONS(11969),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11969),
    [sym__pair_operator] = ACTIONS(11969),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11969),
    [sym__lazy_and_operator] = ACTIONS(11969),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11969),
    [sym__pipe_left_operator] = ACTIONS(11969),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11969),
    [sym__bitshift_operator] = ACTIONS(11969),
    [sym__power_operator] = ACTIONS(11969),
    [sym__tilde_operator] = ACTIONS(11969),
    [sym__type_order_operator] = ACTIONS(11969),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym__terminator_token1] = ACTIONS(11971),
    [aux_sym__terminator_token2] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8036] = {
    [sym_block_comment] = STATE(8036),
    [sym_line_comment] = STATE(8036),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8037] = {
    [sym_block_comment] = STATE(8037),
    [sym_line_comment] = STATE(8037),
    [ts_builtin_sym_end] = ACTIONS(11458),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11456),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11456),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11456),
    [anon_sym_RBRACK] = ACTIONS(11456),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11456),
    [anon_sym_DOLLAR] = ACTIONS(11456),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11456),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11456),
    [anon_sym_QMARK] = ACTIONS(11456),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11456),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11456),
    [aux_sym_integer_literal_token2] = ACTIONS(11456),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11456),
    [aux_sym_float_literal_token3] = ACTIONS(11456),
    [aux_sym_float_literal_token4] = ACTIONS(11456),
    [sym_character_literal] = ACTIONS(11456),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11456),
    [sym__pair_operator] = ACTIONS(11456),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11456),
    [sym__lazy_and_operator] = ACTIONS(11456),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11456),
    [sym__pipe_left_operator] = ACTIONS(11456),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11456),
    [sym__bitshift_operator] = ACTIONS(11456),
    [sym__power_operator] = ACTIONS(11456),
    [sym__tilde_operator] = ACTIONS(11456),
    [sym__type_order_operator] = ACTIONS(11456),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym__terminator_token1] = ACTIONS(11458),
    [aux_sym__terminator_token2] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8038] = {
    [sym_block_comment] = STATE(8038),
    [sym_line_comment] = STATE(8038),
    [ts_builtin_sym_end] = ACTIONS(11285),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11283),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11283),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_RBRACK] = ACTIONS(11283),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11283),
    [anon_sym_DOLLAR] = ACTIONS(11283),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11283),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11283),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11283),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11283),
    [aux_sym_integer_literal_token2] = ACTIONS(11283),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11283),
    [aux_sym_float_literal_token3] = ACTIONS(11283),
    [aux_sym_float_literal_token4] = ACTIONS(11283),
    [sym_character_literal] = ACTIONS(11283),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11283),
    [sym__pair_operator] = ACTIONS(11283),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11283),
    [sym__lazy_and_operator] = ACTIONS(11283),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11283),
    [sym__pipe_left_operator] = ACTIONS(11283),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11283),
    [sym__bitshift_operator] = ACTIONS(11283),
    [sym__power_operator] = ACTIONS(11283),
    [sym__tilde_operator] = ACTIONS(11283),
    [sym__type_order_operator] = ACTIONS(11283),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym__terminator_token1] = ACTIONS(11285),
    [aux_sym__terminator_token2] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8039] = {
    [sym_block_comment] = STATE(8039),
    [sym_line_comment] = STATE(8039),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12050),
    [aux_sym__terminator_token2] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8040] = {
    [sym_block_comment] = STATE(8040),
    [sym_line_comment] = STATE(8040),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_end] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_catch] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [aux_sym__terminator_token2] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8041] = {
    [sym_block_comment] = STATE(8041),
    [sym_line_comment] = STATE(8041),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11033),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_end] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_catch] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11033),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11033),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11033),
    [anon_sym_DOLLAR] = ACTIONS(11033),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11033),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11033),
    [anon_sym_QMARK] = ACTIONS(11033),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11033),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11033),
    [aux_sym_integer_literal_token2] = ACTIONS(11033),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11033),
    [aux_sym_float_literal_token3] = ACTIONS(11033),
    [aux_sym_float_literal_token4] = ACTIONS(11033),
    [sym_character_literal] = ACTIONS(11033),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11033),
    [sym__pair_operator] = ACTIONS(11033),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11033),
    [sym__lazy_and_operator] = ACTIONS(11033),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11033),
    [sym__pipe_left_operator] = ACTIONS(11033),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11033),
    [sym__bitshift_operator] = ACTIONS(11033),
    [sym__power_operator] = ACTIONS(11033),
    [sym__tilde_operator] = ACTIONS(11033),
    [sym__type_order_operator] = ACTIONS(11033),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym__terminator_token1] = ACTIONS(11035),
    [aux_sym__terminator_token2] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8042] = {
    [sym_block_comment] = STATE(8042),
    [sym_line_comment] = STATE(8042),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8043] = {
    [sym_block_comment] = STATE(8043),
    [sym_line_comment] = STATE(8043),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11039),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_end] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_catch] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11039),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11039),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11039),
    [anon_sym_DOLLAR] = ACTIONS(11039),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11039),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11039),
    [anon_sym_QMARK] = ACTIONS(11039),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11039),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11039),
    [aux_sym_integer_literal_token2] = ACTIONS(11039),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11039),
    [aux_sym_float_literal_token3] = ACTIONS(11039),
    [aux_sym_float_literal_token4] = ACTIONS(11039),
    [sym_character_literal] = ACTIONS(11039),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11039),
    [sym__pair_operator] = ACTIONS(11039),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11039),
    [sym__lazy_and_operator] = ACTIONS(11039),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11039),
    [sym__pipe_left_operator] = ACTIONS(11039),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11039),
    [sym__bitshift_operator] = ACTIONS(11039),
    [sym__power_operator] = ACTIONS(11039),
    [sym__tilde_operator] = ACTIONS(11039),
    [sym__type_order_operator] = ACTIONS(11039),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym__terminator_token1] = ACTIONS(11041),
    [aux_sym__terminator_token2] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8044] = {
    [sym_block_comment] = STATE(8044),
    [sym_line_comment] = STATE(8044),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11043),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_end] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_catch] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11043),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11043),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11043),
    [anon_sym_DOLLAR] = ACTIONS(11043),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11043),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11043),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11043),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11043),
    [aux_sym_integer_literal_token2] = ACTIONS(11043),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11043),
    [aux_sym_float_literal_token3] = ACTIONS(11043),
    [aux_sym_float_literal_token4] = ACTIONS(11043),
    [sym_character_literal] = ACTIONS(11043),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11043),
    [sym__pair_operator] = ACTIONS(11043),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11043),
    [sym__lazy_and_operator] = ACTIONS(11043),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11043),
    [sym__pipe_left_operator] = ACTIONS(11043),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11043),
    [sym__bitshift_operator] = ACTIONS(11043),
    [sym__power_operator] = ACTIONS(11043),
    [sym__tilde_operator] = ACTIONS(11043),
    [sym__type_order_operator] = ACTIONS(11043),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym__terminator_token1] = ACTIONS(11045),
    [aux_sym__terminator_token2] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8045] = {
    [sym_block_comment] = STATE(8045),
    [sym_line_comment] = STATE(8045),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11116),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_end] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_catch] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11116),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11116),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11116),
    [anon_sym_DOLLAR] = ACTIONS(11116),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11116),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11116),
    [anon_sym_QMARK] = ACTIONS(11116),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11116),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11116),
    [aux_sym_integer_literal_token2] = ACTIONS(11116),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11116),
    [aux_sym_float_literal_token3] = ACTIONS(11116),
    [aux_sym_float_literal_token4] = ACTIONS(11116),
    [sym_character_literal] = ACTIONS(11116),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11116),
    [sym__pair_operator] = ACTIONS(11116),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11116),
    [sym__lazy_and_operator] = ACTIONS(11116),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11116),
    [sym__pipe_left_operator] = ACTIONS(11116),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11116),
    [sym__bitshift_operator] = ACTIONS(11116),
    [sym__power_operator] = ACTIONS(11116),
    [sym__tilde_operator] = ACTIONS(11116),
    [sym__type_order_operator] = ACTIONS(11116),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym__terminator_token1] = ACTIONS(11118),
    [aux_sym__terminator_token2] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8046] = {
    [sym_block_comment] = STATE(8046),
    [sym_line_comment] = STATE(8046),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11120),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_end] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_catch] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11120),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11120),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11120),
    [anon_sym_DOLLAR] = ACTIONS(11120),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11120),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11120),
    [anon_sym_QMARK] = ACTIONS(11120),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11120),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11120),
    [aux_sym_integer_literal_token2] = ACTIONS(11120),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11120),
    [aux_sym_float_literal_token3] = ACTIONS(11120),
    [aux_sym_float_literal_token4] = ACTIONS(11120),
    [sym_character_literal] = ACTIONS(11120),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11120),
    [sym__pair_operator] = ACTIONS(11120),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11120),
    [sym__lazy_and_operator] = ACTIONS(11120),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11120),
    [sym__pipe_left_operator] = ACTIONS(11120),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11120),
    [sym__bitshift_operator] = ACTIONS(11120),
    [sym__power_operator] = ACTIONS(11120),
    [sym__tilde_operator] = ACTIONS(11120),
    [sym__type_order_operator] = ACTIONS(11120),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym__terminator_token1] = ACTIONS(11122),
    [aux_sym__terminator_token2] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8047] = {
    [sym_block_comment] = STATE(8047),
    [sym_line_comment] = STATE(8047),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8048] = {
    [sym_block_comment] = STATE(8048),
    [sym_line_comment] = STATE(8048),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9730),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9730),
    [anon_sym_QMARK] = ACTIONS(9730),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(11429),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9730),
    [sym__lazy_and_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8049] = {
    [sym_block_comment] = STATE(8049),
    [sym_line_comment] = STATE(8049),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10134),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10134),
    [anon_sym_QMARK] = ACTIONS(10134),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10134),
    [sym__lazy_and_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8050] = {
    [sym_block_comment] = STATE(8050),
    [sym_line_comment] = STATE(8050),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11197),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_end] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_catch] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11197),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11197),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11197),
    [anon_sym_DOLLAR] = ACTIONS(11197),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11197),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11197),
    [anon_sym_QMARK] = ACTIONS(11197),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11197),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11197),
    [aux_sym_integer_literal_token2] = ACTIONS(11197),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11197),
    [aux_sym_float_literal_token3] = ACTIONS(11197),
    [aux_sym_float_literal_token4] = ACTIONS(11197),
    [sym_character_literal] = ACTIONS(11197),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11197),
    [sym__pair_operator] = ACTIONS(11197),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11197),
    [sym__lazy_and_operator] = ACTIONS(11197),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11197),
    [sym__pipe_left_operator] = ACTIONS(11197),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11197),
    [sym__bitshift_operator] = ACTIONS(11197),
    [sym__power_operator] = ACTIONS(11197),
    [sym__tilde_operator] = ACTIONS(11197),
    [sym__type_order_operator] = ACTIONS(11197),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym__terminator_token1] = ACTIONS(11199),
    [aux_sym__terminator_token2] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8051] = {
    [sym_block_comment] = STATE(8051),
    [sym_line_comment] = STATE(8051),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_catch] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11211),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOLLAR] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11211),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11211),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11211),
    [aux_sym_integer_literal_token2] = ACTIONS(11211),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11211),
    [aux_sym_float_literal_token3] = ACTIONS(11211),
    [aux_sym_float_literal_token4] = ACTIONS(11211),
    [sym_character_literal] = ACTIONS(11211),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11211),
    [sym__pair_operator] = ACTIONS(11211),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11211),
    [sym__lazy_and_operator] = ACTIONS(11211),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11211),
    [sym__pipe_left_operator] = ACTIONS(11211),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11211),
    [sym__bitshift_operator] = ACTIONS(11211),
    [sym__power_operator] = ACTIONS(11211),
    [sym__tilde_operator] = ACTIONS(11211),
    [sym__type_order_operator] = ACTIONS(11211),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym__terminator_token1] = ACTIONS(11213),
    [aux_sym__terminator_token2] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8052] = {
    [sym_block_comment] = STATE(8052),
    [sym_line_comment] = STATE(8052),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
  },
  [8053] = {
    [sym_block_comment] = STATE(8053),
    [sym_line_comment] = STATE(8053),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8054] = {
    [sym_block_comment] = STATE(8054),
    [sym_line_comment] = STATE(8054),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11253),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11253),
    [anon_sym_RPAREN] = ACTIONS(11253),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11253),
    [anon_sym_RBRACK] = ACTIONS(11253),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_SEMI] = ACTIONS(11253),
    [anon_sym_LBRACE] = ACTIONS(11253),
    [anon_sym_RBRACE] = ACTIONS(11253),
    [anon_sym_DOLLAR] = ACTIONS(11253),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11253),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11253),
    [anon_sym_QMARK] = ACTIONS(11253),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11253),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11253),
    [aux_sym_integer_literal_token2] = ACTIONS(11253),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11253),
    [aux_sym_float_literal_token3] = ACTIONS(11253),
    [aux_sym_float_literal_token4] = ACTIONS(11253),
    [sym_character_literal] = ACTIONS(11253),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11253),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11253),
    [sym__pair_operator] = ACTIONS(11253),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11253),
    [sym__lazy_and_operator] = ACTIONS(11253),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11253),
    [sym__pipe_left_operator] = ACTIONS(11253),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11253),
    [sym__bitshift_operator] = ACTIONS(11253),
    [sym__power_operator] = ACTIONS(11253),
    [sym__tilde_operator] = ACTIONS(11253),
    [sym__type_order_operator] = ACTIONS(11253),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8055] = {
    [sym_block_comment] = STATE(8055),
    [sym_line_comment] = STATE(8055),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11261),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11261),
    [anon_sym_RPAREN] = ACTIONS(11261),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11261),
    [anon_sym_RBRACK] = ACTIONS(11261),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_SEMI] = ACTIONS(11261),
    [anon_sym_LBRACE] = ACTIONS(11261),
    [anon_sym_RBRACE] = ACTIONS(11261),
    [anon_sym_DOLLAR] = ACTIONS(11261),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11261),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11261),
    [anon_sym_QMARK] = ACTIONS(11261),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11261),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11261),
    [aux_sym_integer_literal_token2] = ACTIONS(11261),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11261),
    [aux_sym_float_literal_token3] = ACTIONS(11261),
    [aux_sym_float_literal_token4] = ACTIONS(11261),
    [sym_character_literal] = ACTIONS(11261),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11261),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11261),
    [sym__pair_operator] = ACTIONS(11261),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11261),
    [sym__lazy_and_operator] = ACTIONS(11261),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11261),
    [sym__pipe_left_operator] = ACTIONS(11261),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11261),
    [sym__bitshift_operator] = ACTIONS(11261),
    [sym__power_operator] = ACTIONS(11261),
    [sym__tilde_operator] = ACTIONS(11261),
    [sym__type_order_operator] = ACTIONS(11261),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8056] = {
    [sym_block_comment] = STATE(8056),
    [sym_line_comment] = STATE(8056),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_RBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_SEMI] = ACTIONS(10964),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_RBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8057] = {
    [sym_block_comment] = STATE(8057),
    [sym_line_comment] = STATE(8057),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11225),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11225),
    [anon_sym_RPAREN] = ACTIONS(11225),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11225),
    [anon_sym_RBRACK] = ACTIONS(11225),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_SEMI] = ACTIONS(11225),
    [anon_sym_LBRACE] = ACTIONS(11225),
    [anon_sym_RBRACE] = ACTIONS(11225),
    [anon_sym_DOLLAR] = ACTIONS(11225),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11225),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11225),
    [anon_sym_QMARK] = ACTIONS(11225),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11225),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11225),
    [aux_sym_integer_literal_token2] = ACTIONS(11225),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11225),
    [aux_sym_float_literal_token3] = ACTIONS(11225),
    [aux_sym_float_literal_token4] = ACTIONS(11225),
    [sym_character_literal] = ACTIONS(11225),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11225),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11225),
    [sym__pair_operator] = ACTIONS(11225),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11225),
    [sym__lazy_and_operator] = ACTIONS(11225),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11225),
    [sym__pipe_left_operator] = ACTIONS(11225),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11225),
    [sym__bitshift_operator] = ACTIONS(11225),
    [sym__power_operator] = ACTIONS(11225),
    [sym__tilde_operator] = ACTIONS(11225),
    [sym__type_order_operator] = ACTIONS(11225),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8058] = {
    [sym_block_comment] = STATE(8058),
    [sym_line_comment] = STATE(8058),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_catch] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10978),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10978),
    [anon_sym_QMARK] = ACTIONS(10978),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10978),
    [sym__lazy_and_operator] = ACTIONS(10978),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10978),
    [sym__pipe_left_operator] = ACTIONS(10978),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10978),
    [sym__bitshift_operator] = ACTIONS(10978),
    [sym__power_operator] = ACTIONS(10978),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10978),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8059] = {
    [sym_block_comment] = STATE(8059),
    [sym_line_comment] = STATE(8059),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [ts_builtin_sym_end] = ACTIONS(10982),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_RBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8060] = {
    [sym_block_comment] = STATE(8060),
    [sym_line_comment] = STATE(8060),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_RBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_SEMI] = ACTIONS(10968),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_RBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8061] = {
    [sym_block_comment] = STATE(8061),
    [sym_line_comment] = STATE(8061),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_RBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_SEMI] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_RBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8062] = {
    [sym_block_comment] = STATE(8062),
    [sym_line_comment] = STATE(8062),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8063] = {
    [sym_block_comment] = STATE(8063),
    [sym_line_comment] = STATE(8063),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11269),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_end] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_catch] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11269),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11269),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11269),
    [anon_sym_DOLLAR] = ACTIONS(11269),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11269),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11269),
    [anon_sym_QMARK] = ACTIONS(11269),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11269),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11269),
    [aux_sym_integer_literal_token2] = ACTIONS(11269),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11269),
    [aux_sym_float_literal_token3] = ACTIONS(11269),
    [aux_sym_float_literal_token4] = ACTIONS(11269),
    [sym_character_literal] = ACTIONS(11269),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11269),
    [sym__pair_operator] = ACTIONS(11269),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11269),
    [sym__lazy_and_operator] = ACTIONS(11269),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11269),
    [sym__pipe_left_operator] = ACTIONS(11269),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11269),
    [sym__bitshift_operator] = ACTIONS(11269),
    [sym__power_operator] = ACTIONS(11269),
    [sym__tilde_operator] = ACTIONS(11269),
    [sym__type_order_operator] = ACTIONS(11269),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym__terminator_token1] = ACTIONS(11271),
    [aux_sym__terminator_token2] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8064] = {
    [sym_block_comment] = STATE(8064),
    [sym_line_comment] = STATE(8064),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_end] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_catch] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11279),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11279),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11279),
    [anon_sym_DOLLAR] = ACTIONS(11279),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11279),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11279),
    [anon_sym_QMARK] = ACTIONS(11279),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11279),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11279),
    [aux_sym_integer_literal_token2] = ACTIONS(11279),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11279),
    [aux_sym_float_literal_token3] = ACTIONS(11279),
    [aux_sym_float_literal_token4] = ACTIONS(11279),
    [sym_character_literal] = ACTIONS(11279),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11279),
    [sym__pair_operator] = ACTIONS(11279),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11279),
    [sym__lazy_and_operator] = ACTIONS(11279),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11279),
    [sym__pipe_left_operator] = ACTIONS(11279),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11279),
    [sym__bitshift_operator] = ACTIONS(11279),
    [sym__power_operator] = ACTIONS(11279),
    [sym__tilde_operator] = ACTIONS(11279),
    [sym__type_order_operator] = ACTIONS(11279),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym__terminator_token1] = ACTIONS(11281),
    [aux_sym__terminator_token2] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8065] = {
    [sym_block_comment] = STATE(8065),
    [sym_line_comment] = STATE(8065),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11309),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_end] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_catch] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11309),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11309),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11309),
    [anon_sym_DOLLAR] = ACTIONS(11309),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11309),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11309),
    [anon_sym_QMARK] = ACTIONS(11309),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11309),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11309),
    [aux_sym_integer_literal_token2] = ACTIONS(11309),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11309),
    [aux_sym_float_literal_token3] = ACTIONS(11309),
    [aux_sym_float_literal_token4] = ACTIONS(11309),
    [sym_character_literal] = ACTIONS(11309),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11309),
    [sym__pair_operator] = ACTIONS(11309),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11309),
    [sym__lazy_and_operator] = ACTIONS(11309),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11309),
    [sym__pipe_left_operator] = ACTIONS(11309),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11309),
    [sym__bitshift_operator] = ACTIONS(11309),
    [sym__power_operator] = ACTIONS(11309),
    [sym__tilde_operator] = ACTIONS(11309),
    [sym__type_order_operator] = ACTIONS(11309),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym__terminator_token1] = ACTIONS(11311),
    [aux_sym__terminator_token2] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8066] = {
    [sym_block_comment] = STATE(8066),
    [sym_line_comment] = STATE(8066),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11317),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_end] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_catch] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11317),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11317),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11317),
    [anon_sym_DOLLAR] = ACTIONS(11317),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11317),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11317),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11317),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11317),
    [aux_sym_integer_literal_token2] = ACTIONS(11317),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11317),
    [aux_sym_float_literal_token3] = ACTIONS(11317),
    [aux_sym_float_literal_token4] = ACTIONS(11317),
    [sym_character_literal] = ACTIONS(11317),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11317),
    [sym__pair_operator] = ACTIONS(11317),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11317),
    [sym__lazy_and_operator] = ACTIONS(11317),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11317),
    [sym__pipe_left_operator] = ACTIONS(11317),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11317),
    [sym__bitshift_operator] = ACTIONS(11317),
    [sym__power_operator] = ACTIONS(11317),
    [sym__tilde_operator] = ACTIONS(11317),
    [sym__type_order_operator] = ACTIONS(11317),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym__terminator_token1] = ACTIONS(11319),
    [aux_sym__terminator_token2] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8067] = {
    [sym_block_comment] = STATE(8067),
    [sym_line_comment] = STATE(8067),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11359),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_end] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_catch] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11359),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11359),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11359),
    [anon_sym_DOLLAR] = ACTIONS(11359),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11359),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11359),
    [anon_sym_QMARK] = ACTIONS(11359),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11359),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11359),
    [aux_sym_integer_literal_token2] = ACTIONS(11359),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11359),
    [aux_sym_float_literal_token3] = ACTIONS(11359),
    [aux_sym_float_literal_token4] = ACTIONS(11359),
    [sym_character_literal] = ACTIONS(11359),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11359),
    [sym__pair_operator] = ACTIONS(11359),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11359),
    [sym__lazy_and_operator] = ACTIONS(11359),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11359),
    [sym__pipe_left_operator] = ACTIONS(11359),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11359),
    [sym__bitshift_operator] = ACTIONS(11359),
    [sym__power_operator] = ACTIONS(11359),
    [sym__tilde_operator] = ACTIONS(11359),
    [sym__type_order_operator] = ACTIONS(11359),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym__terminator_token1] = ACTIONS(11361),
    [aux_sym__terminator_token2] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8068] = {
    [sym_block_comment] = STATE(8068),
    [sym_line_comment] = STATE(8068),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11381),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_end] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_catch] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11381),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11381),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11381),
    [anon_sym_DOLLAR] = ACTIONS(11381),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11381),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11381),
    [anon_sym_QMARK] = ACTIONS(11381),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11381),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11381),
    [aux_sym_integer_literal_token2] = ACTIONS(11381),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11381),
    [aux_sym_float_literal_token3] = ACTIONS(11381),
    [aux_sym_float_literal_token4] = ACTIONS(11381),
    [sym_character_literal] = ACTIONS(11381),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11381),
    [sym__pair_operator] = ACTIONS(11381),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11381),
    [sym__lazy_and_operator] = ACTIONS(11381),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11381),
    [sym__pipe_left_operator] = ACTIONS(11381),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11381),
    [sym__bitshift_operator] = ACTIONS(11381),
    [sym__power_operator] = ACTIONS(11381),
    [sym__tilde_operator] = ACTIONS(11381),
    [sym__type_order_operator] = ACTIONS(11381),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym__terminator_token1] = ACTIONS(11383),
    [aux_sym__terminator_token2] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8069] = {
    [sym_block_comment] = STATE(8069),
    [sym_line_comment] = STATE(8069),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11293),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11293),
    [anon_sym_RPAREN] = ACTIONS(11293),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11293),
    [anon_sym_RBRACK] = ACTIONS(11293),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_SEMI] = ACTIONS(11293),
    [anon_sym_LBRACE] = ACTIONS(11293),
    [anon_sym_RBRACE] = ACTIONS(11293),
    [anon_sym_DOLLAR] = ACTIONS(11293),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11293),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11293),
    [anon_sym_QMARK] = ACTIONS(11293),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11293),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11293),
    [aux_sym_integer_literal_token2] = ACTIONS(11293),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11293),
    [aux_sym_float_literal_token3] = ACTIONS(11293),
    [aux_sym_float_literal_token4] = ACTIONS(11293),
    [sym_character_literal] = ACTIONS(11293),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11293),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11293),
    [sym__pair_operator] = ACTIONS(11293),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11293),
    [sym__lazy_and_operator] = ACTIONS(11293),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11293),
    [sym__pipe_left_operator] = ACTIONS(11293),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11293),
    [sym__bitshift_operator] = ACTIONS(11293),
    [sym__power_operator] = ACTIONS(11293),
    [sym__tilde_operator] = ACTIONS(11293),
    [sym__type_order_operator] = ACTIONS(11293),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8070] = {
    [sym_block_comment] = STATE(8070),
    [sym_line_comment] = STATE(8070),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11407),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_end] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_catch] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11407),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11407),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11407),
    [anon_sym_DOLLAR] = ACTIONS(11407),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11407),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11407),
    [anon_sym_QMARK] = ACTIONS(11407),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11407),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11407),
    [aux_sym_integer_literal_token2] = ACTIONS(11407),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11407),
    [aux_sym_float_literal_token3] = ACTIONS(11407),
    [aux_sym_float_literal_token4] = ACTIONS(11407),
    [sym_character_literal] = ACTIONS(11407),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11407),
    [sym__pair_operator] = ACTIONS(11407),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11407),
    [sym__lazy_and_operator] = ACTIONS(11407),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11407),
    [sym__pipe_left_operator] = ACTIONS(11407),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11407),
    [sym__bitshift_operator] = ACTIONS(11407),
    [sym__power_operator] = ACTIONS(11407),
    [sym__tilde_operator] = ACTIONS(11407),
    [sym__type_order_operator] = ACTIONS(11407),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym__terminator_token1] = ACTIONS(11409),
    [aux_sym__terminator_token2] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8071] = {
    [sym_block_comment] = STATE(8071),
    [sym_line_comment] = STATE(8071),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11307),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11307),
    [anon_sym_RPAREN] = ACTIONS(11307),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11307),
    [anon_sym_RBRACK] = ACTIONS(11307),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_SEMI] = ACTIONS(11307),
    [anon_sym_LBRACE] = ACTIONS(11307),
    [anon_sym_RBRACE] = ACTIONS(11307),
    [anon_sym_DOLLAR] = ACTIONS(11307),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11307),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11307),
    [anon_sym_QMARK] = ACTIONS(11307),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11307),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11307),
    [aux_sym_integer_literal_token2] = ACTIONS(11307),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11307),
    [aux_sym_float_literal_token3] = ACTIONS(11307),
    [aux_sym_float_literal_token4] = ACTIONS(11307),
    [sym_character_literal] = ACTIONS(11307),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11307),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11307),
    [sym__pair_operator] = ACTIONS(11307),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11307),
    [sym__lazy_and_operator] = ACTIONS(11307),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11307),
    [sym__pipe_left_operator] = ACTIONS(11307),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11307),
    [sym__bitshift_operator] = ACTIONS(11307),
    [sym__power_operator] = ACTIONS(11307),
    [sym__tilde_operator] = ACTIONS(11307),
    [sym__type_order_operator] = ACTIONS(11307),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8072] = {
    [sym_block_comment] = STATE(8072),
    [sym_line_comment] = STATE(8072),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(12160),
    [sym__immediate_command_start] = ACTIONS(12162),
  },
  [8073] = {
    [sym_block_comment] = STATE(8073),
    [sym_line_comment] = STATE(8073),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11456),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_end] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_catch] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11456),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11456),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11456),
    [anon_sym_DOLLAR] = ACTIONS(11456),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11456),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11456),
    [anon_sym_QMARK] = ACTIONS(11456),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11456),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11456),
    [aux_sym_integer_literal_token2] = ACTIONS(11456),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11456),
    [aux_sym_float_literal_token3] = ACTIONS(11456),
    [aux_sym_float_literal_token4] = ACTIONS(11456),
    [sym_character_literal] = ACTIONS(11456),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11456),
    [sym__pair_operator] = ACTIONS(11456),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11456),
    [sym__lazy_and_operator] = ACTIONS(11456),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11456),
    [sym__pipe_left_operator] = ACTIONS(11456),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11456),
    [sym__bitshift_operator] = ACTIONS(11456),
    [sym__power_operator] = ACTIONS(11456),
    [sym__tilde_operator] = ACTIONS(11456),
    [sym__type_order_operator] = ACTIONS(11456),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym__terminator_token1] = ACTIONS(11458),
    [aux_sym__terminator_token2] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8074] = {
    [sym_block_comment] = STATE(8074),
    [sym_line_comment] = STATE(8074),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11283),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_end] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_catch] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11283),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11283),
    [anon_sym_DOLLAR] = ACTIONS(11283),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11283),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11283),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11283),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11283),
    [aux_sym_integer_literal_token2] = ACTIONS(11283),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11283),
    [aux_sym_float_literal_token3] = ACTIONS(11283),
    [aux_sym_float_literal_token4] = ACTIONS(11283),
    [sym_character_literal] = ACTIONS(11283),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11283),
    [sym__pair_operator] = ACTIONS(11283),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11283),
    [sym__lazy_and_operator] = ACTIONS(11283),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11283),
    [sym__pipe_left_operator] = ACTIONS(11283),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11283),
    [sym__bitshift_operator] = ACTIONS(11283),
    [sym__power_operator] = ACTIONS(11283),
    [sym__tilde_operator] = ACTIONS(11283),
    [sym__type_order_operator] = ACTIONS(11283),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym__terminator_token1] = ACTIONS(11285),
    [aux_sym__terminator_token2] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8075] = {
    [sym_block_comment] = STATE(8075),
    [sym_line_comment] = STATE(8075),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8076] = {
    [sym_block_comment] = STATE(8076),
    [sym_line_comment] = STATE(8076),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9912),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9912),
    [anon_sym_QMARK] = ACTIONS(9912),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9912),
    [sym__lazy_and_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8077] = {
    [sym_block_comment] = STATE(8077),
    [sym_line_comment] = STATE(8077),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8078] = {
    [sym_block_comment] = STATE(8078),
    [sym_line_comment] = STATE(8078),
    [aux_sym_export_statement_repeat1] = STATE(8251),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_end] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10807),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10807),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10807),
    [anon_sym_DOLLAR] = ACTIONS(10807),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10807),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10807),
    [anon_sym_QMARK] = ACTIONS(10807),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10807),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10807),
    [aux_sym_integer_literal_token2] = ACTIONS(10807),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10807),
    [aux_sym_float_literal_token3] = ACTIONS(10807),
    [aux_sym_float_literal_token4] = ACTIONS(10807),
    [sym_character_literal] = ACTIONS(10807),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10807),
    [sym__pair_operator] = ACTIONS(10807),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10807),
    [sym__lazy_and_operator] = ACTIONS(10807),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10807),
    [sym__pipe_left_operator] = ACTIONS(10807),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10807),
    [sym__bitshift_operator] = ACTIONS(10807),
    [sym__power_operator] = ACTIONS(10807),
    [sym__tilde_operator] = ACTIONS(10807),
    [sym__type_order_operator] = ACTIONS(10807),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym__terminator_token1] = ACTIONS(10811),
    [aux_sym__terminator_token2] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8079] = {
    [sym_block_comment] = STATE(8079),
    [sym_line_comment] = STATE(8079),
    [aux_sym_export_statement_repeat1] = STATE(8273),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_end] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10813),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10813),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10813),
    [anon_sym_DOLLAR] = ACTIONS(10813),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10813),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10813),
    [anon_sym_QMARK] = ACTIONS(10813),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10813),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10813),
    [aux_sym_integer_literal_token2] = ACTIONS(10813),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10813),
    [aux_sym_float_literal_token3] = ACTIONS(10813),
    [aux_sym_float_literal_token4] = ACTIONS(10813),
    [sym_character_literal] = ACTIONS(10813),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10813),
    [sym__pair_operator] = ACTIONS(10813),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10813),
    [sym__lazy_and_operator] = ACTIONS(10813),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10813),
    [sym__pipe_left_operator] = ACTIONS(10813),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10813),
    [sym__bitshift_operator] = ACTIONS(10813),
    [sym__power_operator] = ACTIONS(10813),
    [sym__tilde_operator] = ACTIONS(10813),
    [sym__type_order_operator] = ACTIONS(10813),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym__terminator_token1] = ACTIONS(10815),
    [aux_sym__terminator_token2] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8080] = {
    [sym_block_comment] = STATE(8080),
    [sym_line_comment] = STATE(8080),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11171),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11171),
    [anon_sym_RPAREN] = ACTIONS(11171),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11171),
    [anon_sym_RBRACK] = ACTIONS(11171),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_SEMI] = ACTIONS(11171),
    [anon_sym_LBRACE] = ACTIONS(11171),
    [anon_sym_RBRACE] = ACTIONS(11171),
    [anon_sym_DOLLAR] = ACTIONS(11171),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11171),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11171),
    [anon_sym_QMARK] = ACTIONS(11171),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11171),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11171),
    [aux_sym_integer_literal_token2] = ACTIONS(11171),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11171),
    [aux_sym_float_literal_token3] = ACTIONS(11171),
    [aux_sym_float_literal_token4] = ACTIONS(11171),
    [sym_character_literal] = ACTIONS(11171),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11171),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11171),
    [sym__pair_operator] = ACTIONS(11171),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11171),
    [sym__lazy_and_operator] = ACTIONS(11171),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11171),
    [sym__pipe_left_operator] = ACTIONS(11171),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11171),
    [sym__bitshift_operator] = ACTIONS(11171),
    [sym__power_operator] = ACTIONS(11171),
    [sym__tilde_operator] = ACTIONS(11171),
    [sym__type_order_operator] = ACTIONS(11171),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8081] = {
    [sym_block_comment] = STATE(8081),
    [sym_line_comment] = STATE(8081),
    [aux_sym__import_list_repeat1] = STATE(8275),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(11215),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10747),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10747),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10747),
    [anon_sym_DOLLAR] = ACTIONS(10747),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10747),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10747),
    [anon_sym_QMARK] = ACTIONS(10747),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10747),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10747),
    [aux_sym_integer_literal_token2] = ACTIONS(10747),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10747),
    [aux_sym_float_literal_token3] = ACTIONS(10747),
    [aux_sym_float_literal_token4] = ACTIONS(10747),
    [sym_character_literal] = ACTIONS(10747),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10747),
    [sym__pair_operator] = ACTIONS(10747),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10747),
    [sym__lazy_and_operator] = ACTIONS(10747),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10747),
    [sym__pipe_left_operator] = ACTIONS(10747),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10747),
    [sym__bitshift_operator] = ACTIONS(10747),
    [sym__power_operator] = ACTIONS(10747),
    [sym__tilde_operator] = ACTIONS(10747),
    [sym__type_order_operator] = ACTIONS(10747),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym__terminator_token1] = ACTIONS(10755),
    [aux_sym__terminator_token2] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8082] = {
    [sym_block_comment] = STATE(8082),
    [sym_line_comment] = STATE(8082),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10757),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10757),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10757),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10757),
    [anon_sym_DOLLAR] = ACTIONS(10757),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10757),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10757),
    [anon_sym_QMARK] = ACTIONS(10757),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10757),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10757),
    [aux_sym_integer_literal_token2] = ACTIONS(10757),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10757),
    [aux_sym_float_literal_token3] = ACTIONS(10757),
    [aux_sym_float_literal_token4] = ACTIONS(10757),
    [sym_character_literal] = ACTIONS(10757),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10757),
    [sym__pair_operator] = ACTIONS(10757),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10757),
    [sym__lazy_and_operator] = ACTIONS(10757),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10757),
    [sym__pipe_left_operator] = ACTIONS(10757),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10757),
    [sym__bitshift_operator] = ACTIONS(10757),
    [sym__power_operator] = ACTIONS(10757),
    [sym__tilde_operator] = ACTIONS(10757),
    [sym__type_order_operator] = ACTIONS(10757),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym__terminator_token1] = ACTIONS(10759),
    [aux_sym__terminator_token2] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8083] = {
    [sym_block_comment] = STATE(8083),
    [sym_line_comment] = STATE(8083),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8084] = {
    [sym_block_comment] = STATE(8084),
    [sym_line_comment] = STATE(8084),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11259),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_end] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_catch] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11259),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11259),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11259),
    [anon_sym_DOLLAR] = ACTIONS(11259),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11259),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11259),
    [anon_sym_QMARK] = ACTIONS(11259),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11259),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11259),
    [aux_sym_integer_literal_token2] = ACTIONS(11259),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11259),
    [aux_sym_float_literal_token3] = ACTIONS(11259),
    [aux_sym_float_literal_token4] = ACTIONS(11259),
    [sym_character_literal] = ACTIONS(11259),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11259),
    [sym__pair_operator] = ACTIONS(11259),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11259),
    [sym__lazy_and_operator] = ACTIONS(11259),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11259),
    [sym__pipe_left_operator] = ACTIONS(11259),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11259),
    [sym__bitshift_operator] = ACTIONS(11259),
    [sym__power_operator] = ACTIONS(11259),
    [sym__tilde_operator] = ACTIONS(11259),
    [sym__type_order_operator] = ACTIONS(11259),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym__terminator_token1] = ACTIONS(11261),
    [aux_sym__terminator_token2] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8085] = {
    [sym_block_comment] = STATE(8085),
    [sym_line_comment] = STATE(8085),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11251),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_end] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_finally] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11251),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11251),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11251),
    [anon_sym_DOLLAR] = ACTIONS(11251),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11251),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11251),
    [anon_sym_QMARK] = ACTIONS(11251),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11251),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11251),
    [aux_sym_integer_literal_token2] = ACTIONS(11251),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11251),
    [aux_sym_float_literal_token3] = ACTIONS(11251),
    [aux_sym_float_literal_token4] = ACTIONS(11251),
    [sym_character_literal] = ACTIONS(11251),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11251),
    [sym__pair_operator] = ACTIONS(11251),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11251),
    [sym__lazy_and_operator] = ACTIONS(11251),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11251),
    [sym__pipe_left_operator] = ACTIONS(11251),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11251),
    [sym__bitshift_operator] = ACTIONS(11251),
    [sym__power_operator] = ACTIONS(11251),
    [sym__tilde_operator] = ACTIONS(11251),
    [sym__type_order_operator] = ACTIONS(11251),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym__terminator_token1] = ACTIONS(11253),
    [aux_sym__terminator_token2] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8086] = {
    [sym_block_comment] = STATE(8086),
    [sym_line_comment] = STATE(8086),
    [ts_builtin_sym_end] = ACTIONS(10964),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_RBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8087] = {
    [sym_block_comment] = STATE(8087),
    [sym_line_comment] = STATE(8087),
    [ts_builtin_sym_end] = ACTIONS(10968),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_RBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8088] = {
    [sym_block_comment] = STATE(8088),
    [sym_line_comment] = STATE(8088),
    [ts_builtin_sym_end] = ACTIONS(10972),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_RBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8089] = {
    [sym_block_comment] = STATE(8089),
    [sym_line_comment] = STATE(8089),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11259),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_end] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_finally] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11259),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11259),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11259),
    [anon_sym_DOLLAR] = ACTIONS(11259),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11259),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11259),
    [anon_sym_QMARK] = ACTIONS(11259),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11259),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11259),
    [aux_sym_integer_literal_token2] = ACTIONS(11259),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11259),
    [aux_sym_float_literal_token3] = ACTIONS(11259),
    [aux_sym_float_literal_token4] = ACTIONS(11259),
    [sym_character_literal] = ACTIONS(11259),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11259),
    [sym__pair_operator] = ACTIONS(11259),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11259),
    [sym__lazy_and_operator] = ACTIONS(11259),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11259),
    [sym__pipe_left_operator] = ACTIONS(11259),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11259),
    [sym__bitshift_operator] = ACTIONS(11259),
    [sym__power_operator] = ACTIONS(11259),
    [sym__tilde_operator] = ACTIONS(11259),
    [sym__type_order_operator] = ACTIONS(11259),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym__terminator_token1] = ACTIONS(11261),
    [aux_sym__terminator_token2] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8090] = {
    [sym_block_comment] = STATE(8090),
    [sym_line_comment] = STATE(8090),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11474),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11474),
    [anon_sym_RPAREN] = ACTIONS(11474),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11474),
    [anon_sym_RBRACK] = ACTIONS(11474),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_SEMI] = ACTIONS(11474),
    [anon_sym_LBRACE] = ACTIONS(11474),
    [anon_sym_RBRACE] = ACTIONS(11474),
    [anon_sym_DOLLAR] = ACTIONS(11474),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11474),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11474),
    [anon_sym_QMARK] = ACTIONS(11474),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11474),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11474),
    [aux_sym_integer_literal_token2] = ACTIONS(11474),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11474),
    [aux_sym_float_literal_token3] = ACTIONS(11474),
    [aux_sym_float_literal_token4] = ACTIONS(11474),
    [sym_character_literal] = ACTIONS(11474),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11474),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11474),
    [sym__pair_operator] = ACTIONS(11474),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11474),
    [sym__lazy_and_operator] = ACTIONS(11474),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11474),
    [sym__pipe_left_operator] = ACTIONS(11474),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11474),
    [sym__bitshift_operator] = ACTIONS(11474),
    [sym__power_operator] = ACTIONS(11474),
    [sym__tilde_operator] = ACTIONS(11474),
    [sym__type_order_operator] = ACTIONS(11474),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8091] = {
    [sym_block_comment] = STATE(8091),
    [sym_line_comment] = STATE(8091),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9942),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8092] = {
    [sym_block_comment] = STATE(8092),
    [sym_line_comment] = STATE(8092),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10200),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(9804),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8093] = {
    [sym_block_comment] = STATE(8093),
    [sym_line_comment] = STATE(8093),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8094] = {
    [sym_block_comment] = STATE(8094),
    [sym_line_comment] = STATE(8094),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8095] = {
    [sym_block_comment] = STATE(8095),
    [sym_line_comment] = STATE(8095),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8096] = {
    [sym_block_comment] = STATE(8096),
    [sym_line_comment] = STATE(8096),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11223),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_end] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_finally] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11223),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11223),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11223),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11223),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11223),
    [anon_sym_QMARK] = ACTIONS(11223),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11223),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11223),
    [aux_sym_integer_literal_token2] = ACTIONS(11223),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11223),
    [aux_sym_float_literal_token3] = ACTIONS(11223),
    [aux_sym_float_literal_token4] = ACTIONS(11223),
    [sym_character_literal] = ACTIONS(11223),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11223),
    [sym__pair_operator] = ACTIONS(11223),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11223),
    [sym__lazy_and_operator] = ACTIONS(11223),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11223),
    [sym__pipe_left_operator] = ACTIONS(11223),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11223),
    [sym__bitshift_operator] = ACTIONS(11223),
    [sym__power_operator] = ACTIONS(11223),
    [sym__tilde_operator] = ACTIONS(11223),
    [sym__type_order_operator] = ACTIONS(11223),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym__terminator_token1] = ACTIONS(11225),
    [aux_sym__terminator_token2] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8097] = {
    [sym_block_comment] = STATE(8097),
    [sym_line_comment] = STATE(8097),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8098] = {
    [sym_block_comment] = STATE(8098),
    [sym_line_comment] = STATE(8098),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8099] = {
    [sym_block_comment] = STATE(8099),
    [sym_line_comment] = STATE(8099),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8100] = {
    [sym_block_comment] = STATE(8100),
    [sym_line_comment] = STATE(8100),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11501),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11501),
    [anon_sym_RPAREN] = ACTIONS(11501),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11501),
    [anon_sym_RBRACK] = ACTIONS(11501),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_SEMI] = ACTIONS(11501),
    [anon_sym_LBRACE] = ACTIONS(11501),
    [anon_sym_RBRACE] = ACTIONS(11501),
    [anon_sym_DOLLAR] = ACTIONS(11501),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11501),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11501),
    [anon_sym_QMARK] = ACTIONS(11501),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11501),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11501),
    [aux_sym_integer_literal_token2] = ACTIONS(11501),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11501),
    [aux_sym_float_literal_token3] = ACTIONS(11501),
    [aux_sym_float_literal_token4] = ACTIONS(11501),
    [sym_character_literal] = ACTIONS(11501),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11501),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11501),
    [sym__pair_operator] = ACTIONS(11501),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11501),
    [sym__lazy_and_operator] = ACTIONS(11501),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11501),
    [sym__pipe_left_operator] = ACTIONS(11501),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11501),
    [sym__bitshift_operator] = ACTIONS(11501),
    [sym__power_operator] = ACTIONS(11501),
    [sym__tilde_operator] = ACTIONS(11501),
    [sym__type_order_operator] = ACTIONS(11501),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8101] = {
    [sym_block_comment] = STATE(8101),
    [sym_line_comment] = STATE(8101),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11515),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11515),
    [anon_sym_RPAREN] = ACTIONS(11515),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11515),
    [anon_sym_RBRACK] = ACTIONS(11515),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_SEMI] = ACTIONS(11515),
    [anon_sym_LBRACE] = ACTIONS(11515),
    [anon_sym_RBRACE] = ACTIONS(11515),
    [anon_sym_DOLLAR] = ACTIONS(11515),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11515),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11515),
    [anon_sym_QMARK] = ACTIONS(11515),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11515),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11515),
    [aux_sym_integer_literal_token2] = ACTIONS(11515),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11515),
    [aux_sym_float_literal_token3] = ACTIONS(11515),
    [aux_sym_float_literal_token4] = ACTIONS(11515),
    [sym_character_literal] = ACTIONS(11515),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11515),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11515),
    [sym__pair_operator] = ACTIONS(11515),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11515),
    [sym__lazy_and_operator] = ACTIONS(11515),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11515),
    [sym__pipe_left_operator] = ACTIONS(11515),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11515),
    [sym__bitshift_operator] = ACTIONS(11515),
    [sym__power_operator] = ACTIONS(11515),
    [sym__tilde_operator] = ACTIONS(11515),
    [sym__type_order_operator] = ACTIONS(11515),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8102] = {
    [sym_block_comment] = STATE(8102),
    [sym_line_comment] = STATE(8102),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11528),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11528),
    [anon_sym_RPAREN] = ACTIONS(11528),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11528),
    [anon_sym_RBRACK] = ACTIONS(11528),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_SEMI] = ACTIONS(11528),
    [anon_sym_LBRACE] = ACTIONS(11528),
    [anon_sym_RBRACE] = ACTIONS(11528),
    [anon_sym_DOLLAR] = ACTIONS(11528),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11528),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11528),
    [anon_sym_QMARK] = ACTIONS(11528),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11528),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11528),
    [aux_sym_integer_literal_token2] = ACTIONS(11528),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11528),
    [aux_sym_float_literal_token3] = ACTIONS(11528),
    [aux_sym_float_literal_token4] = ACTIONS(11528),
    [sym_character_literal] = ACTIONS(11528),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11528),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11528),
    [sym__pair_operator] = ACTIONS(11528),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11528),
    [sym__lazy_and_operator] = ACTIONS(11528),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11528),
    [sym__pipe_left_operator] = ACTIONS(11528),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11528),
    [sym__bitshift_operator] = ACTIONS(11528),
    [sym__power_operator] = ACTIONS(11528),
    [sym__tilde_operator] = ACTIONS(11528),
    [sym__type_order_operator] = ACTIONS(11528),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8103] = {
    [sym_block_comment] = STATE(8103),
    [sym_line_comment] = STATE(8103),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11532),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11532),
    [anon_sym_RPAREN] = ACTIONS(11532),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11532),
    [anon_sym_RBRACK] = ACTIONS(11532),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_SEMI] = ACTIONS(11532),
    [anon_sym_LBRACE] = ACTIONS(11532),
    [anon_sym_RBRACE] = ACTIONS(11532),
    [anon_sym_DOLLAR] = ACTIONS(11532),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11532),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11532),
    [anon_sym_QMARK] = ACTIONS(11532),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11532),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11532),
    [aux_sym_integer_literal_token2] = ACTIONS(11532),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11532),
    [aux_sym_float_literal_token3] = ACTIONS(11532),
    [aux_sym_float_literal_token4] = ACTIONS(11532),
    [sym_character_literal] = ACTIONS(11532),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11532),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11532),
    [sym__pair_operator] = ACTIONS(11532),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11532),
    [sym__lazy_and_operator] = ACTIONS(11532),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11532),
    [sym__pipe_left_operator] = ACTIONS(11532),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11532),
    [sym__bitshift_operator] = ACTIONS(11532),
    [sym__power_operator] = ACTIONS(11532),
    [sym__tilde_operator] = ACTIONS(11532),
    [sym__type_order_operator] = ACTIONS(11532),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8104] = {
    [sym_block_comment] = STATE(8104),
    [sym_line_comment] = STATE(8104),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8105] = {
    [sym_block_comment] = STATE(8105),
    [sym_line_comment] = STATE(8105),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8106] = {
    [sym_block_comment] = STATE(8106),
    [sym_line_comment] = STATE(8106),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8107] = {
    [sym_block_comment] = STATE(8107),
    [sym_line_comment] = STATE(8107),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11550),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11550),
    [anon_sym_RPAREN] = ACTIONS(11550),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11550),
    [anon_sym_RBRACK] = ACTIONS(11550),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_SEMI] = ACTIONS(11550),
    [anon_sym_LBRACE] = ACTIONS(11550),
    [anon_sym_RBRACE] = ACTIONS(11550),
    [anon_sym_DOLLAR] = ACTIONS(11550),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11550),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11550),
    [anon_sym_QMARK] = ACTIONS(11550),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11550),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11550),
    [aux_sym_integer_literal_token2] = ACTIONS(11550),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11550),
    [aux_sym_float_literal_token3] = ACTIONS(11550),
    [aux_sym_float_literal_token4] = ACTIONS(11550),
    [sym_character_literal] = ACTIONS(11550),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11550),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11550),
    [sym__pair_operator] = ACTIONS(11550),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11550),
    [sym__lazy_and_operator] = ACTIONS(11550),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11550),
    [sym__pipe_left_operator] = ACTIONS(11550),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11550),
    [sym__bitshift_operator] = ACTIONS(11550),
    [sym__power_operator] = ACTIONS(11550),
    [sym__tilde_operator] = ACTIONS(11550),
    [sym__type_order_operator] = ACTIONS(11550),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8108] = {
    [sym_block_comment] = STATE(8108),
    [sym_line_comment] = STATE(8108),
    [ts_builtin_sym_end] = ACTIONS(11022),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8109] = {
    [sym_block_comment] = STATE(8109),
    [sym_line_comment] = STATE(8109),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11554),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11554),
    [anon_sym_RPAREN] = ACTIONS(11554),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11554),
    [anon_sym_RBRACK] = ACTIONS(11554),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_SEMI] = ACTIONS(11554),
    [anon_sym_LBRACE] = ACTIONS(11554),
    [anon_sym_RBRACE] = ACTIONS(11554),
    [anon_sym_DOLLAR] = ACTIONS(11554),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11554),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11554),
    [anon_sym_QMARK] = ACTIONS(11554),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11554),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11554),
    [aux_sym_integer_literal_token2] = ACTIONS(11554),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11554),
    [aux_sym_float_literal_token3] = ACTIONS(11554),
    [aux_sym_float_literal_token4] = ACTIONS(11554),
    [sym_character_literal] = ACTIONS(11554),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11554),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11554),
    [sym__pair_operator] = ACTIONS(11554),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11554),
    [sym__lazy_and_operator] = ACTIONS(11554),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11554),
    [sym__pipe_left_operator] = ACTIONS(11554),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11554),
    [sym__bitshift_operator] = ACTIONS(11554),
    [sym__power_operator] = ACTIONS(11554),
    [sym__tilde_operator] = ACTIONS(11554),
    [sym__type_order_operator] = ACTIONS(11554),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8110] = {
    [sym_block_comment] = STATE(8110),
    [sym_line_comment] = STATE(8110),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11561),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11561),
    [anon_sym_RPAREN] = ACTIONS(11561),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11561),
    [anon_sym_RBRACK] = ACTIONS(11561),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_SEMI] = ACTIONS(11561),
    [anon_sym_LBRACE] = ACTIONS(11561),
    [anon_sym_RBRACE] = ACTIONS(11561),
    [anon_sym_DOLLAR] = ACTIONS(11561),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11561),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11561),
    [anon_sym_QMARK] = ACTIONS(11561),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11561),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11561),
    [aux_sym_integer_literal_token2] = ACTIONS(11561),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11561),
    [aux_sym_float_literal_token3] = ACTIONS(11561),
    [aux_sym_float_literal_token4] = ACTIONS(11561),
    [sym_character_literal] = ACTIONS(11561),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11561),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11561),
    [sym__pair_operator] = ACTIONS(11561),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11561),
    [sym__lazy_and_operator] = ACTIONS(11561),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11561),
    [sym__pipe_left_operator] = ACTIONS(11561),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11561),
    [sym__bitshift_operator] = ACTIONS(11561),
    [sym__power_operator] = ACTIONS(11561),
    [sym__tilde_operator] = ACTIONS(11561),
    [sym__type_order_operator] = ACTIONS(11561),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8111] = {
    [sym_block_comment] = STATE(8111),
    [sym_line_comment] = STATE(8111),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11565),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11565),
    [anon_sym_RPAREN] = ACTIONS(11565),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11565),
    [anon_sym_RBRACK] = ACTIONS(11565),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_SEMI] = ACTIONS(11565),
    [anon_sym_LBRACE] = ACTIONS(11565),
    [anon_sym_RBRACE] = ACTIONS(11565),
    [anon_sym_DOLLAR] = ACTIONS(11565),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11565),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11565),
    [anon_sym_QMARK] = ACTIONS(11565),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11565),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11565),
    [aux_sym_integer_literal_token2] = ACTIONS(11565),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11565),
    [aux_sym_float_literal_token3] = ACTIONS(11565),
    [aux_sym_float_literal_token4] = ACTIONS(11565),
    [sym_character_literal] = ACTIONS(11565),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11565),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11565),
    [sym__pair_operator] = ACTIONS(11565),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11565),
    [sym__lazy_and_operator] = ACTIONS(11565),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11565),
    [sym__pipe_left_operator] = ACTIONS(11565),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11565),
    [sym__bitshift_operator] = ACTIONS(11565),
    [sym__power_operator] = ACTIONS(11565),
    [sym__tilde_operator] = ACTIONS(11565),
    [sym__type_order_operator] = ACTIONS(11565),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8112] = {
    [sym_block_comment] = STATE(8112),
    [sym_line_comment] = STATE(8112),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11569),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11569),
    [anon_sym_RPAREN] = ACTIONS(11569),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11569),
    [anon_sym_RBRACK] = ACTIONS(11569),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_SEMI] = ACTIONS(11569),
    [anon_sym_LBRACE] = ACTIONS(11569),
    [anon_sym_RBRACE] = ACTIONS(11569),
    [anon_sym_DOLLAR] = ACTIONS(11569),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11569),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11569),
    [anon_sym_QMARK] = ACTIONS(11569),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11569),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11569),
    [aux_sym_integer_literal_token2] = ACTIONS(11569),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11569),
    [aux_sym_float_literal_token3] = ACTIONS(11569),
    [aux_sym_float_literal_token4] = ACTIONS(11569),
    [sym_character_literal] = ACTIONS(11569),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11569),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11569),
    [sym__pair_operator] = ACTIONS(11569),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11569),
    [sym__lazy_and_operator] = ACTIONS(11569),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11569),
    [sym__pipe_left_operator] = ACTIONS(11569),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11569),
    [sym__bitshift_operator] = ACTIONS(11569),
    [sym__power_operator] = ACTIONS(11569),
    [sym__tilde_operator] = ACTIONS(11569),
    [sym__type_order_operator] = ACTIONS(11569),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8113] = {
    [sym_block_comment] = STATE(8113),
    [sym_line_comment] = STATE(8113),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11573),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11573),
    [anon_sym_RPAREN] = ACTIONS(11573),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11573),
    [anon_sym_RBRACK] = ACTIONS(11573),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_SEMI] = ACTIONS(11573),
    [anon_sym_LBRACE] = ACTIONS(11573),
    [anon_sym_RBRACE] = ACTIONS(11573),
    [anon_sym_DOLLAR] = ACTIONS(11573),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11573),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11573),
    [anon_sym_QMARK] = ACTIONS(11573),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11573),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11573),
    [aux_sym_integer_literal_token2] = ACTIONS(11573),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11573),
    [aux_sym_float_literal_token3] = ACTIONS(11573),
    [aux_sym_float_literal_token4] = ACTIONS(11573),
    [sym_character_literal] = ACTIONS(11573),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11573),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11573),
    [sym__pair_operator] = ACTIONS(11573),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11573),
    [sym__lazy_and_operator] = ACTIONS(11573),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11573),
    [sym__pipe_left_operator] = ACTIONS(11573),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11573),
    [sym__bitshift_operator] = ACTIONS(11573),
    [sym__power_operator] = ACTIONS(11573),
    [sym__tilde_operator] = ACTIONS(11573),
    [sym__type_order_operator] = ACTIONS(11573),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8114] = {
    [sym_block_comment] = STATE(8114),
    [sym_line_comment] = STATE(8114),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11291),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_end] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_finally] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11291),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11291),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11291),
    [anon_sym_DOLLAR] = ACTIONS(11291),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11291),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11291),
    [anon_sym_QMARK] = ACTIONS(11291),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11291),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11291),
    [aux_sym_integer_literal_token2] = ACTIONS(11291),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11291),
    [aux_sym_float_literal_token3] = ACTIONS(11291),
    [aux_sym_float_literal_token4] = ACTIONS(11291),
    [sym_character_literal] = ACTIONS(11291),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11291),
    [sym__pair_operator] = ACTIONS(11291),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11291),
    [sym__lazy_and_operator] = ACTIONS(11291),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11291),
    [sym__pipe_left_operator] = ACTIONS(11291),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11291),
    [sym__bitshift_operator] = ACTIONS(11291),
    [sym__power_operator] = ACTIONS(11291),
    [sym__tilde_operator] = ACTIONS(11291),
    [sym__type_order_operator] = ACTIONS(11291),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym__terminator_token1] = ACTIONS(11293),
    [aux_sym__terminator_token2] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8115] = {
    [sym_block_comment] = STATE(8115),
    [sym_line_comment] = STATE(8115),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11305),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_end] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_finally] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11305),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11305),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11305),
    [anon_sym_DOLLAR] = ACTIONS(11305),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11305),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11305),
    [anon_sym_QMARK] = ACTIONS(11305),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11305),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11305),
    [aux_sym_integer_literal_token2] = ACTIONS(11305),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11305),
    [aux_sym_float_literal_token3] = ACTIONS(11305),
    [aux_sym_float_literal_token4] = ACTIONS(11305),
    [sym_character_literal] = ACTIONS(11305),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11305),
    [sym__pair_operator] = ACTIONS(11305),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11305),
    [sym__lazy_and_operator] = ACTIONS(11305),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11305),
    [sym__pipe_left_operator] = ACTIONS(11305),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11305),
    [sym__bitshift_operator] = ACTIONS(11305),
    [sym__power_operator] = ACTIONS(11305),
    [sym__tilde_operator] = ACTIONS(11305),
    [sym__type_order_operator] = ACTIONS(11305),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym__terminator_token1] = ACTIONS(11307),
    [aux_sym__terminator_token2] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8116] = {
    [sym_block_comment] = STATE(8116),
    [sym_line_comment] = STATE(8116),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8117] = {
    [sym_block_comment] = STATE(8117),
    [sym_line_comment] = STATE(8117),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(9858),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8118] = {
    [sym_block_comment] = STATE(8118),
    [sym_line_comment] = STATE(8118),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8119] = {
    [sym_block_comment] = STATE(8119),
    [sym_line_comment] = STATE(8119),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9866),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8120] = {
    [sym_block_comment] = STATE(8120),
    [sym_line_comment] = STATE(8120),
    [ts_builtin_sym_end] = ACTIONS(11022),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8121] = {
    [sym_block_comment] = STATE(8121),
    [sym_line_comment] = STATE(8121),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(11110),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8122] = {
    [sym_block_comment] = STATE(8122),
    [sym_line_comment] = STATE(8122),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_RPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_RBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_SEMI] = ACTIONS(11249),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_RBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11249),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11249),
    [anon_sym_QMARK] = ACTIONS(11249),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(11249),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11249),
    [sym__lazy_and_operator] = ACTIONS(11249),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11249),
    [sym__pipe_left_operator] = ACTIONS(11249),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11249),
    [sym__bitshift_operator] = ACTIONS(11249),
    [sym__power_operator] = ACTIONS(11249),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(11249),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8123] = {
    [sym_block_comment] = STATE(8123),
    [sym_line_comment] = STATE(8123),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_RBRACK] = ACTIONS(11333),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_DOLLAR] = ACTIONS(11333),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11333),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11333),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11333),
    [aux_sym_integer_literal_token2] = ACTIONS(11333),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11333),
    [aux_sym_float_literal_token3] = ACTIONS(11333),
    [aux_sym_float_literal_token4] = ACTIONS(11333),
    [sym_character_literal] = ACTIONS(11333),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11333),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11333),
    [sym__pair_operator] = ACTIONS(11333),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11333),
    [sym__lazy_and_operator] = ACTIONS(11333),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11333),
    [sym__pipe_left_operator] = ACTIONS(11333),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11333),
    [sym__bitshift_operator] = ACTIONS(11333),
    [sym__power_operator] = ACTIONS(11333),
    [sym__tilde_operator] = ACTIONS(11333),
    [sym__type_order_operator] = ACTIONS(11333),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8124] = {
    [sym_block_comment] = STATE(8124),
    [sym_line_comment] = STATE(8124),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11337),
    [anon_sym_RPAREN] = ACTIONS(11337),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11337),
    [anon_sym_RBRACK] = ACTIONS(11337),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11337),
    [anon_sym_LBRACE] = ACTIONS(11337),
    [anon_sym_RBRACE] = ACTIONS(11337),
    [anon_sym_DOLLAR] = ACTIONS(11337),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11337),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11337),
    [anon_sym_QMARK] = ACTIONS(11337),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11337),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11337),
    [aux_sym_integer_literal_token2] = ACTIONS(11337),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11337),
    [aux_sym_float_literal_token3] = ACTIONS(11337),
    [aux_sym_float_literal_token4] = ACTIONS(11337),
    [sym_character_literal] = ACTIONS(11337),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11337),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11337),
    [sym__pair_operator] = ACTIONS(11337),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11337),
    [sym__lazy_and_operator] = ACTIONS(11337),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11337),
    [sym__pipe_left_operator] = ACTIONS(11337),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11337),
    [sym__bitshift_operator] = ACTIONS(11337),
    [sym__power_operator] = ACTIONS(11337),
    [sym__tilde_operator] = ACTIONS(11337),
    [sym__type_order_operator] = ACTIONS(11337),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8125] = {
    [sym_block_comment] = STATE(8125),
    [sym_line_comment] = STATE(8125),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11341),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11341),
    [anon_sym_RPAREN] = ACTIONS(11341),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11341),
    [anon_sym_RBRACK] = ACTIONS(11341),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_SEMI] = ACTIONS(11341),
    [anon_sym_LBRACE] = ACTIONS(11341),
    [anon_sym_RBRACE] = ACTIONS(11341),
    [anon_sym_DOLLAR] = ACTIONS(11341),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11341),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11341),
    [anon_sym_QMARK] = ACTIONS(11341),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11341),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11341),
    [aux_sym_integer_literal_token2] = ACTIONS(11341),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11341),
    [aux_sym_float_literal_token3] = ACTIONS(11341),
    [aux_sym_float_literal_token4] = ACTIONS(11341),
    [sym_character_literal] = ACTIONS(11341),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11341),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11341),
    [sym__pair_operator] = ACTIONS(11341),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11341),
    [sym__lazy_and_operator] = ACTIONS(11341),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11341),
    [sym__pipe_left_operator] = ACTIONS(11341),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11341),
    [sym__bitshift_operator] = ACTIONS(11341),
    [sym__power_operator] = ACTIONS(11341),
    [sym__tilde_operator] = ACTIONS(11341),
    [sym__type_order_operator] = ACTIONS(11341),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8126] = {
    [sym_block_comment] = STATE(8126),
    [sym_line_comment] = STATE(8126),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_finally] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8127] = {
    [sym_block_comment] = STATE(8127),
    [sym_line_comment] = STATE(8127),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11345),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11345),
    [anon_sym_RPAREN] = ACTIONS(11345),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11345),
    [anon_sym_RBRACK] = ACTIONS(11345),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_SEMI] = ACTIONS(11345),
    [anon_sym_LBRACE] = ACTIONS(11345),
    [anon_sym_RBRACE] = ACTIONS(11345),
    [anon_sym_DOLLAR] = ACTIONS(11345),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11345),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11345),
    [anon_sym_QMARK] = ACTIONS(11345),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11345),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11345),
    [aux_sym_integer_literal_token2] = ACTIONS(11345),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11345),
    [aux_sym_float_literal_token3] = ACTIONS(11345),
    [aux_sym_float_literal_token4] = ACTIONS(11345),
    [sym_character_literal] = ACTIONS(11345),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11345),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11345),
    [sym__pair_operator] = ACTIONS(11345),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11345),
    [sym__lazy_and_operator] = ACTIONS(11345),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11345),
    [sym__pipe_left_operator] = ACTIONS(11345),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11345),
    [sym__bitshift_operator] = ACTIONS(11345),
    [sym__power_operator] = ACTIONS(11345),
    [sym__tilde_operator] = ACTIONS(11345),
    [sym__type_order_operator] = ACTIONS(11345),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8128] = {
    [sym_block_comment] = STATE(8128),
    [sym_line_comment] = STATE(8128),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11349),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11349),
    [anon_sym_RPAREN] = ACTIONS(11349),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11349),
    [anon_sym_RBRACK] = ACTIONS(11349),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_SEMI] = ACTIONS(11349),
    [anon_sym_LBRACE] = ACTIONS(11349),
    [anon_sym_RBRACE] = ACTIONS(11349),
    [anon_sym_DOLLAR] = ACTIONS(11349),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11349),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11349),
    [anon_sym_QMARK] = ACTIONS(11349),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11349),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11349),
    [aux_sym_integer_literal_token2] = ACTIONS(11349),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11349),
    [aux_sym_float_literal_token3] = ACTIONS(11349),
    [aux_sym_float_literal_token4] = ACTIONS(11349),
    [sym_character_literal] = ACTIONS(11349),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11349),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11349),
    [sym__pair_operator] = ACTIONS(11349),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11349),
    [sym__lazy_and_operator] = ACTIONS(11349),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11349),
    [sym__pipe_left_operator] = ACTIONS(11349),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11349),
    [sym__bitshift_operator] = ACTIONS(11349),
    [sym__power_operator] = ACTIONS(11349),
    [sym__tilde_operator] = ACTIONS(11349),
    [sym__type_order_operator] = ACTIONS(11349),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8129] = {
    [sym_block_comment] = STATE(8129),
    [sym_line_comment] = STATE(8129),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11169),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_end] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_finally] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11169),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11169),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11169),
    [anon_sym_DOLLAR] = ACTIONS(11169),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11169),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11169),
    [anon_sym_QMARK] = ACTIONS(11169),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11169),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11169),
    [aux_sym_integer_literal_token2] = ACTIONS(11169),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11169),
    [aux_sym_float_literal_token3] = ACTIONS(11169),
    [aux_sym_float_literal_token4] = ACTIONS(11169),
    [sym_character_literal] = ACTIONS(11169),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11169),
    [sym__pair_operator] = ACTIONS(11169),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11169),
    [sym__lazy_and_operator] = ACTIONS(11169),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11169),
    [sym__pipe_left_operator] = ACTIONS(11169),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11169),
    [sym__bitshift_operator] = ACTIONS(11169),
    [sym__power_operator] = ACTIONS(11169),
    [sym__tilde_operator] = ACTIONS(11169),
    [sym__type_order_operator] = ACTIONS(11169),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym__terminator_token1] = ACTIONS(11171),
    [aux_sym__terminator_token2] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8130] = {
    [sym_block_comment] = STATE(8130),
    [sym_line_comment] = STATE(8130),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8131] = {
    [sym_block_comment] = STATE(8131),
    [sym_line_comment] = STATE(8131),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_finally] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8132] = {
    [sym_block_comment] = STATE(8132),
    [sym_line_comment] = STATE(8132),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8133] = {
    [sym_block_comment] = STATE(8133),
    [sym_line_comment] = STATE(8133),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8134] = {
    [sym_block_comment] = STATE(8134),
    [sym_line_comment] = STATE(8134),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8135] = {
    [sym_block_comment] = STATE(8135),
    [sym_line_comment] = STATE(8135),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8136] = {
    [sym_block_comment] = STATE(8136),
    [sym_line_comment] = STATE(8136),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8137] = {
    [sym_block_comment] = STATE(8137),
    [sym_line_comment] = STATE(8137),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8138] = {
    [sym_block_comment] = STATE(8138),
    [sym_line_comment] = STATE(8138),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8139] = {
    [sym_block_comment] = STATE(8139),
    [sym_line_comment] = STATE(8139),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8140] = {
    [sym_block_comment] = STATE(8140),
    [sym_line_comment] = STATE(8140),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8141] = {
    [sym_block_comment] = STATE(8141),
    [sym_line_comment] = STATE(8141),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8142] = {
    [sym_block_comment] = STATE(8142),
    [sym_line_comment] = STATE(8142),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8143] = {
    [sym_block_comment] = STATE(8143),
    [sym_line_comment] = STATE(8143),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11353),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11353),
    [anon_sym_RPAREN] = ACTIONS(11353),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11353),
    [anon_sym_RBRACK] = ACTIONS(11353),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_SEMI] = ACTIONS(11353),
    [anon_sym_LBRACE] = ACTIONS(11353),
    [anon_sym_RBRACE] = ACTIONS(11353),
    [anon_sym_DOLLAR] = ACTIONS(11353),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11353),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11353),
    [anon_sym_QMARK] = ACTIONS(11353),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11353),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11353),
    [aux_sym_integer_literal_token2] = ACTIONS(11353),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11353),
    [aux_sym_float_literal_token3] = ACTIONS(11353),
    [aux_sym_float_literal_token4] = ACTIONS(11353),
    [sym_character_literal] = ACTIONS(11353),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11353),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11353),
    [sym__pair_operator] = ACTIONS(11353),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11353),
    [sym__lazy_and_operator] = ACTIONS(11353),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11353),
    [sym__pipe_left_operator] = ACTIONS(11353),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11353),
    [sym__bitshift_operator] = ACTIONS(11353),
    [sym__power_operator] = ACTIONS(11353),
    [sym__tilde_operator] = ACTIONS(11353),
    [sym__type_order_operator] = ACTIONS(11353),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8144] = {
    [sym_block_comment] = STATE(8144),
    [sym_line_comment] = STATE(8144),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11357),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11357),
    [anon_sym_RPAREN] = ACTIONS(11357),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11357),
    [anon_sym_RBRACK] = ACTIONS(11357),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_SEMI] = ACTIONS(11357),
    [anon_sym_LBRACE] = ACTIONS(11357),
    [anon_sym_RBRACE] = ACTIONS(11357),
    [anon_sym_DOLLAR] = ACTIONS(11357),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11357),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11357),
    [anon_sym_QMARK] = ACTIONS(11357),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11357),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11357),
    [aux_sym_integer_literal_token2] = ACTIONS(11357),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11357),
    [aux_sym_float_literal_token3] = ACTIONS(11357),
    [aux_sym_float_literal_token4] = ACTIONS(11357),
    [sym_character_literal] = ACTIONS(11357),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11357),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11357),
    [sym__pair_operator] = ACTIONS(11357),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11357),
    [sym__lazy_and_operator] = ACTIONS(11357),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11357),
    [sym__pipe_left_operator] = ACTIONS(11357),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11357),
    [sym__bitshift_operator] = ACTIONS(11357),
    [sym__power_operator] = ACTIONS(11357),
    [sym__tilde_operator] = ACTIONS(11357),
    [sym__type_order_operator] = ACTIONS(11357),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8145] = {
    [sym_block_comment] = STATE(8145),
    [sym_line_comment] = STATE(8145),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11375),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11375),
    [anon_sym_RPAREN] = ACTIONS(11375),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11375),
    [anon_sym_RBRACK] = ACTIONS(11375),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_SEMI] = ACTIONS(11375),
    [anon_sym_LBRACE] = ACTIONS(11375),
    [anon_sym_RBRACE] = ACTIONS(11375),
    [anon_sym_DOLLAR] = ACTIONS(11375),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11375),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11375),
    [anon_sym_QMARK] = ACTIONS(11375),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11375),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11375),
    [aux_sym_integer_literal_token2] = ACTIONS(11375),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11375),
    [aux_sym_float_literal_token3] = ACTIONS(11375),
    [aux_sym_float_literal_token4] = ACTIONS(11375),
    [sym_character_literal] = ACTIONS(11375),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11375),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11375),
    [sym__pair_operator] = ACTIONS(11375),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11375),
    [sym__lazy_and_operator] = ACTIONS(11375),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11375),
    [sym__pipe_left_operator] = ACTIONS(11375),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11375),
    [sym__bitshift_operator] = ACTIONS(11375),
    [sym__power_operator] = ACTIONS(11375),
    [sym__tilde_operator] = ACTIONS(11375),
    [sym__type_order_operator] = ACTIONS(11375),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8146] = {
    [sym_block_comment] = STATE(8146),
    [sym_line_comment] = STATE(8146),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11379),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11379),
    [anon_sym_RPAREN] = ACTIONS(11379),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11379),
    [anon_sym_RBRACK] = ACTIONS(11379),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_SEMI] = ACTIONS(11379),
    [anon_sym_LBRACE] = ACTIONS(11379),
    [anon_sym_RBRACE] = ACTIONS(11379),
    [anon_sym_DOLLAR] = ACTIONS(11379),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11379),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11379),
    [anon_sym_QMARK] = ACTIONS(11379),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11379),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11379),
    [aux_sym_integer_literal_token2] = ACTIONS(11379),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11379),
    [aux_sym_float_literal_token3] = ACTIONS(11379),
    [aux_sym_float_literal_token4] = ACTIONS(11379),
    [sym_character_literal] = ACTIONS(11379),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11379),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11379),
    [sym__pair_operator] = ACTIONS(11379),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11379),
    [sym__lazy_and_operator] = ACTIONS(11379),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11379),
    [sym__pipe_left_operator] = ACTIONS(11379),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11379),
    [sym__bitshift_operator] = ACTIONS(11379),
    [sym__power_operator] = ACTIONS(11379),
    [sym__tilde_operator] = ACTIONS(11379),
    [sym__type_order_operator] = ACTIONS(11379),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8147] = {
    [sym_block_comment] = STATE(8147),
    [sym_line_comment] = STATE(8147),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11387),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11387),
    [anon_sym_RPAREN] = ACTIONS(11387),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11387),
    [anon_sym_RBRACK] = ACTIONS(11387),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_SEMI] = ACTIONS(11387),
    [anon_sym_LBRACE] = ACTIONS(11387),
    [anon_sym_RBRACE] = ACTIONS(11387),
    [anon_sym_DOLLAR] = ACTIONS(11387),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11387),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11387),
    [anon_sym_QMARK] = ACTIONS(11387),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11387),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11387),
    [aux_sym_integer_literal_token2] = ACTIONS(11387),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11387),
    [aux_sym_float_literal_token3] = ACTIONS(11387),
    [aux_sym_float_literal_token4] = ACTIONS(11387),
    [sym_character_literal] = ACTIONS(11387),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11387),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11387),
    [sym__pair_operator] = ACTIONS(11387),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11387),
    [sym__lazy_and_operator] = ACTIONS(11387),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11387),
    [sym__pipe_left_operator] = ACTIONS(11387),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11387),
    [sym__bitshift_operator] = ACTIONS(11387),
    [sym__power_operator] = ACTIONS(11387),
    [sym__tilde_operator] = ACTIONS(11387),
    [sym__type_order_operator] = ACTIONS(11387),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8148] = {
    [sym_block_comment] = STATE(8148),
    [sym_line_comment] = STATE(8148),
    [aux_sym_open_tuple_repeat1] = STATE(8195),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10833),
    [anon_sym_RPAREN] = ACTIONS(10833),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10833),
    [anon_sym_RBRACK] = ACTIONS(10833),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10833),
    [anon_sym_RBRACE] = ACTIONS(10833),
    [anon_sym_DOLLAR] = ACTIONS(10833),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10833),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10833),
    [anon_sym_QMARK] = ACTIONS(10833),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10833),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10833),
    [aux_sym_integer_literal_token2] = ACTIONS(10833),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10833),
    [aux_sym_float_literal_token3] = ACTIONS(10833),
    [aux_sym_float_literal_token4] = ACTIONS(10833),
    [sym_character_literal] = ACTIONS(10833),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10833),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10833),
    [sym__pair_operator] = ACTIONS(10833),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10833),
    [sym__lazy_and_operator] = ACTIONS(10833),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10833),
    [sym__pipe_left_operator] = ACTIONS(10833),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10833),
    [sym__bitshift_operator] = ACTIONS(10833),
    [sym__power_operator] = ACTIONS(10833),
    [sym__tilde_operator] = ACTIONS(10833),
    [sym__type_order_operator] = ACTIONS(10833),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8149] = {
    [sym_block_comment] = STATE(8149),
    [sym_line_comment] = STATE(8149),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11401),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11401),
    [anon_sym_RPAREN] = ACTIONS(11401),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11401),
    [anon_sym_RBRACK] = ACTIONS(11401),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_SEMI] = ACTIONS(11401),
    [anon_sym_LBRACE] = ACTIONS(11401),
    [anon_sym_RBRACE] = ACTIONS(11401),
    [anon_sym_DOLLAR] = ACTIONS(11401),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11401),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11401),
    [anon_sym_QMARK] = ACTIONS(11401),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11401),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11401),
    [aux_sym_integer_literal_token2] = ACTIONS(11401),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11401),
    [aux_sym_float_literal_token3] = ACTIONS(11401),
    [aux_sym_float_literal_token4] = ACTIONS(11401),
    [sym_character_literal] = ACTIONS(11401),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11401),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11401),
    [sym__pair_operator] = ACTIONS(11401),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11401),
    [sym__lazy_and_operator] = ACTIONS(11401),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11401),
    [sym__pipe_left_operator] = ACTIONS(11401),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11401),
    [sym__bitshift_operator] = ACTIONS(11401),
    [sym__power_operator] = ACTIONS(11401),
    [sym__tilde_operator] = ACTIONS(11401),
    [sym__type_order_operator] = ACTIONS(11401),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8150] = {
    [sym_block_comment] = STATE(8150),
    [sym_line_comment] = STATE(8150),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11472),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_end] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_finally] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11472),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11472),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11472),
    [anon_sym_DOLLAR] = ACTIONS(11472),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11472),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11472),
    [anon_sym_QMARK] = ACTIONS(11472),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11472),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11472),
    [aux_sym_integer_literal_token2] = ACTIONS(11472),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11472),
    [aux_sym_float_literal_token3] = ACTIONS(11472),
    [aux_sym_float_literal_token4] = ACTIONS(11472),
    [sym_character_literal] = ACTIONS(11472),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11472),
    [sym__pair_operator] = ACTIONS(11472),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11472),
    [sym__lazy_and_operator] = ACTIONS(11472),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11472),
    [sym__pipe_left_operator] = ACTIONS(11472),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11472),
    [sym__bitshift_operator] = ACTIONS(11472),
    [sym__power_operator] = ACTIONS(11472),
    [sym__tilde_operator] = ACTIONS(11472),
    [sym__type_order_operator] = ACTIONS(11472),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym__terminator_token1] = ACTIONS(11474),
    [aux_sym__terminator_token2] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8151] = {
    [sym_block_comment] = STATE(8151),
    [sym_line_comment] = STATE(8151),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11405),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11405),
    [anon_sym_RPAREN] = ACTIONS(11405),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11405),
    [anon_sym_RBRACK] = ACTIONS(11405),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_SEMI] = ACTIONS(11405),
    [anon_sym_LBRACE] = ACTIONS(11405),
    [anon_sym_RBRACE] = ACTIONS(11405),
    [anon_sym_DOLLAR] = ACTIONS(11405),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11405),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11405),
    [anon_sym_QMARK] = ACTIONS(11405),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11405),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11405),
    [aux_sym_integer_literal_token2] = ACTIONS(11405),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11405),
    [aux_sym_float_literal_token3] = ACTIONS(11405),
    [aux_sym_float_literal_token4] = ACTIONS(11405),
    [sym_character_literal] = ACTIONS(11405),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11405),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11405),
    [sym__pair_operator] = ACTIONS(11405),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11405),
    [sym__lazy_and_operator] = ACTIONS(11405),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11405),
    [sym__pipe_left_operator] = ACTIONS(11405),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11405),
    [sym__bitshift_operator] = ACTIONS(11405),
    [sym__power_operator] = ACTIONS(11405),
    [sym__tilde_operator] = ACTIONS(11405),
    [sym__type_order_operator] = ACTIONS(11405),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8152] = {
    [sym_block_comment] = STATE(8152),
    [sym_line_comment] = STATE(8152),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11257),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11257),
    [anon_sym_RPAREN] = ACTIONS(11257),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11257),
    [anon_sym_RBRACK] = ACTIONS(11257),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_SEMI] = ACTIONS(11257),
    [anon_sym_LBRACE] = ACTIONS(11257),
    [anon_sym_RBRACE] = ACTIONS(11257),
    [anon_sym_DOLLAR] = ACTIONS(11257),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11257),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11257),
    [anon_sym_QMARK] = ACTIONS(11257),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11257),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11257),
    [aux_sym_integer_literal_token2] = ACTIONS(11257),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11257),
    [aux_sym_float_literal_token3] = ACTIONS(11257),
    [aux_sym_float_literal_token4] = ACTIONS(11257),
    [sym_character_literal] = ACTIONS(11257),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11257),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11257),
    [sym__pair_operator] = ACTIONS(11257),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11257),
    [sym__lazy_and_operator] = ACTIONS(11257),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11257),
    [sym__pipe_left_operator] = ACTIONS(11257),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11257),
    [sym__bitshift_operator] = ACTIONS(11257),
    [sym__power_operator] = ACTIONS(11257),
    [sym__tilde_operator] = ACTIONS(11257),
    [sym__type_order_operator] = ACTIONS(11257),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8153] = {
    [sym_block_comment] = STATE(8153),
    [sym_line_comment] = STATE(8153),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11413),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11413),
    [anon_sym_RPAREN] = ACTIONS(11413),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11413),
    [anon_sym_RBRACK] = ACTIONS(11413),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_SEMI] = ACTIONS(11413),
    [anon_sym_LBRACE] = ACTIONS(11413),
    [anon_sym_RBRACE] = ACTIONS(11413),
    [anon_sym_DOLLAR] = ACTIONS(11413),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11413),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11413),
    [anon_sym_QMARK] = ACTIONS(11413),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11413),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11413),
    [aux_sym_integer_literal_token2] = ACTIONS(11413),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11413),
    [aux_sym_float_literal_token3] = ACTIONS(11413),
    [aux_sym_float_literal_token4] = ACTIONS(11413),
    [sym_character_literal] = ACTIONS(11413),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11413),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11413),
    [sym__pair_operator] = ACTIONS(11413),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11413),
    [sym__lazy_and_operator] = ACTIONS(11413),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11413),
    [sym__pipe_left_operator] = ACTIONS(11413),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11413),
    [sym__bitshift_operator] = ACTIONS(11413),
    [sym__power_operator] = ACTIONS(11413),
    [sym__tilde_operator] = ACTIONS(11413),
    [sym__type_order_operator] = ACTIONS(11413),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8154] = {
    [sym_block_comment] = STATE(8154),
    [sym_line_comment] = STATE(8154),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9662),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9662),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9662),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9662),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9662),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9662),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9662),
    [anon_sym_QMARK] = ACTIONS(9662),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9662),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9662),
    [aux_sym_integer_literal_token2] = ACTIONS(9662),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9662),
    [aux_sym_float_literal_token3] = ACTIONS(9662),
    [aux_sym_float_literal_token4] = ACTIONS(9662),
    [sym_character_literal] = ACTIONS(9662),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9662),
    [sym__pair_operator] = ACTIONS(9662),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9662),
    [sym__lazy_and_operator] = ACTIONS(9662),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9662),
    [sym__pipe_left_operator] = ACTIONS(9662),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9662),
    [sym__bitshift_operator] = ACTIONS(9662),
    [sym__power_operator] = ACTIONS(9662),
    [sym__tilde_operator] = ACTIONS(9662),
    [sym__type_order_operator] = ACTIONS(9662),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym__terminator_token1] = ACTIONS(9664),
    [aux_sym__terminator_token2] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8155] = {
    [sym_block_comment] = STATE(8155),
    [sym_line_comment] = STATE(8155),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11499),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_end] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_finally] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11499),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11499),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11499),
    [anon_sym_DOLLAR] = ACTIONS(11499),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11499),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11499),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11499),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11499),
    [aux_sym_integer_literal_token2] = ACTIONS(11499),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11499),
    [aux_sym_float_literal_token3] = ACTIONS(11499),
    [aux_sym_float_literal_token4] = ACTIONS(11499),
    [sym_character_literal] = ACTIONS(11499),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11499),
    [sym__pair_operator] = ACTIONS(11499),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11499),
    [sym__lazy_and_operator] = ACTIONS(11499),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11499),
    [sym__pipe_left_operator] = ACTIONS(11499),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11499),
    [sym__bitshift_operator] = ACTIONS(11499),
    [sym__power_operator] = ACTIONS(11499),
    [sym__tilde_operator] = ACTIONS(11499),
    [sym__type_order_operator] = ACTIONS(11499),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym__terminator_token1] = ACTIONS(11501),
    [aux_sym__terminator_token2] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8156] = {
    [sym_block_comment] = STATE(8156),
    [sym_line_comment] = STATE(8156),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11513),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_end] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_finally] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11513),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11513),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11513),
    [anon_sym_DOLLAR] = ACTIONS(11513),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11513),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11513),
    [anon_sym_QMARK] = ACTIONS(11513),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11513),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11513),
    [aux_sym_integer_literal_token2] = ACTIONS(11513),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11513),
    [aux_sym_float_literal_token3] = ACTIONS(11513),
    [aux_sym_float_literal_token4] = ACTIONS(11513),
    [sym_character_literal] = ACTIONS(11513),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11513),
    [sym__pair_operator] = ACTIONS(11513),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11513),
    [sym__lazy_and_operator] = ACTIONS(11513),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11513),
    [sym__pipe_left_operator] = ACTIONS(11513),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11513),
    [sym__bitshift_operator] = ACTIONS(11513),
    [sym__power_operator] = ACTIONS(11513),
    [sym__tilde_operator] = ACTIONS(11513),
    [sym__type_order_operator] = ACTIONS(11513),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym__terminator_token1] = ACTIONS(11515),
    [aux_sym__terminator_token2] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8157] = {
    [sym_block_comment] = STATE(8157),
    [sym_line_comment] = STATE(8157),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11526),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_end] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_finally] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11526),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11526),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11526),
    [anon_sym_DOLLAR] = ACTIONS(11526),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11526),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11526),
    [anon_sym_QMARK] = ACTIONS(11526),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11526),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11526),
    [aux_sym_integer_literal_token2] = ACTIONS(11526),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11526),
    [aux_sym_float_literal_token3] = ACTIONS(11526),
    [aux_sym_float_literal_token4] = ACTIONS(11526),
    [sym_character_literal] = ACTIONS(11526),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11526),
    [sym__pair_operator] = ACTIONS(11526),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11526),
    [sym__lazy_and_operator] = ACTIONS(11526),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11526),
    [sym__pipe_left_operator] = ACTIONS(11526),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11526),
    [sym__bitshift_operator] = ACTIONS(11526),
    [sym__power_operator] = ACTIONS(11526),
    [sym__tilde_operator] = ACTIONS(11526),
    [sym__type_order_operator] = ACTIONS(11526),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym__terminator_token1] = ACTIONS(11528),
    [aux_sym__terminator_token2] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8158] = {
    [sym_block_comment] = STATE(8158),
    [sym_line_comment] = STATE(8158),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11530),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_end] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_finally] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11530),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11530),
    [anon_sym_DOLLAR] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11530),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11530),
    [anon_sym_QMARK] = ACTIONS(11530),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11530),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11530),
    [aux_sym_integer_literal_token2] = ACTIONS(11530),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11530),
    [aux_sym_float_literal_token3] = ACTIONS(11530),
    [aux_sym_float_literal_token4] = ACTIONS(11530),
    [sym_character_literal] = ACTIONS(11530),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11530),
    [sym__pair_operator] = ACTIONS(11530),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11530),
    [sym__lazy_and_operator] = ACTIONS(11530),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11530),
    [sym__pipe_left_operator] = ACTIONS(11530),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11530),
    [sym__bitshift_operator] = ACTIONS(11530),
    [sym__power_operator] = ACTIONS(11530),
    [sym__tilde_operator] = ACTIONS(11530),
    [sym__type_order_operator] = ACTIONS(11530),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym__terminator_token1] = ACTIONS(11532),
    [aux_sym__terminator_token2] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8159] = {
    [sym_block_comment] = STATE(8159),
    [sym_line_comment] = STATE(8159),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11534),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_end] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_finally] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11534),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11534),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11534),
    [anon_sym_DOLLAR] = ACTIONS(11534),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11534),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11534),
    [anon_sym_QMARK] = ACTIONS(11534),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11534),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11534),
    [aux_sym_integer_literal_token2] = ACTIONS(11534),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11534),
    [aux_sym_float_literal_token3] = ACTIONS(11534),
    [aux_sym_float_literal_token4] = ACTIONS(11534),
    [sym_character_literal] = ACTIONS(11534),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11534),
    [sym__pair_operator] = ACTIONS(11534),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11534),
    [sym__lazy_and_operator] = ACTIONS(11534),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11534),
    [sym__pipe_left_operator] = ACTIONS(11534),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11534),
    [sym__bitshift_operator] = ACTIONS(11534),
    [sym__power_operator] = ACTIONS(11534),
    [sym__tilde_operator] = ACTIONS(11534),
    [sym__type_order_operator] = ACTIONS(11534),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym__terminator_token1] = ACTIONS(11536),
    [aux_sym__terminator_token2] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8160] = {
    [sym_block_comment] = STATE(8160),
    [sym_line_comment] = STATE(8160),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11548),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_end] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_finally] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11548),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11548),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11548),
    [anon_sym_DOLLAR] = ACTIONS(11548),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11548),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11548),
    [anon_sym_QMARK] = ACTIONS(11548),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11548),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11548),
    [aux_sym_integer_literal_token2] = ACTIONS(11548),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11548),
    [aux_sym_float_literal_token3] = ACTIONS(11548),
    [aux_sym_float_literal_token4] = ACTIONS(11548),
    [sym_character_literal] = ACTIONS(11548),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11548),
    [sym__pair_operator] = ACTIONS(11548),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11548),
    [sym__lazy_and_operator] = ACTIONS(11548),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11548),
    [sym__pipe_left_operator] = ACTIONS(11548),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11548),
    [sym__bitshift_operator] = ACTIONS(11548),
    [sym__power_operator] = ACTIONS(11548),
    [sym__tilde_operator] = ACTIONS(11548),
    [sym__type_order_operator] = ACTIONS(11548),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym__terminator_token1] = ACTIONS(11550),
    [aux_sym__terminator_token2] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8161] = {
    [sym_block_comment] = STATE(8161),
    [sym_line_comment] = STATE(8161),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_catch] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8162] = {
    [sym_block_comment] = STATE(8162),
    [sym_line_comment] = STATE(8162),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11552),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_end] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_finally] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11552),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11552),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11552),
    [anon_sym_DOLLAR] = ACTIONS(11552),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11552),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11552),
    [anon_sym_QMARK] = ACTIONS(11552),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11552),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11552),
    [aux_sym_integer_literal_token2] = ACTIONS(11552),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11552),
    [aux_sym_float_literal_token3] = ACTIONS(11552),
    [aux_sym_float_literal_token4] = ACTIONS(11552),
    [sym_character_literal] = ACTIONS(11552),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11552),
    [sym__pair_operator] = ACTIONS(11552),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11552),
    [sym__lazy_and_operator] = ACTIONS(11552),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11552),
    [sym__pipe_left_operator] = ACTIONS(11552),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11552),
    [sym__bitshift_operator] = ACTIONS(11552),
    [sym__power_operator] = ACTIONS(11552),
    [sym__tilde_operator] = ACTIONS(11552),
    [sym__type_order_operator] = ACTIONS(11552),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym__terminator_token1] = ACTIONS(11554),
    [aux_sym__terminator_token2] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8163] = {
    [sym_block_comment] = STATE(8163),
    [sym_line_comment] = STATE(8163),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11559),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_end] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_finally] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11559),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11559),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11559),
    [anon_sym_DOLLAR] = ACTIONS(11559),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11559),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11559),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11559),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11559),
    [aux_sym_integer_literal_token2] = ACTIONS(11559),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11559),
    [aux_sym_float_literal_token3] = ACTIONS(11559),
    [aux_sym_float_literal_token4] = ACTIONS(11559),
    [sym_character_literal] = ACTIONS(11559),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11559),
    [sym__pair_operator] = ACTIONS(11559),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11559),
    [sym__lazy_and_operator] = ACTIONS(11559),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11559),
    [sym__pipe_left_operator] = ACTIONS(11559),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11559),
    [sym__bitshift_operator] = ACTIONS(11559),
    [sym__power_operator] = ACTIONS(11559),
    [sym__tilde_operator] = ACTIONS(11559),
    [sym__type_order_operator] = ACTIONS(11559),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym__terminator_token1] = ACTIONS(11561),
    [aux_sym__terminator_token2] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8164] = {
    [sym_block_comment] = STATE(8164),
    [sym_line_comment] = STATE(8164),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11563),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_end] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_finally] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11563),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11563),
    [anon_sym_DOLLAR] = ACTIONS(11563),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11563),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_QMARK] = ACTIONS(11563),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11563),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11563),
    [aux_sym_integer_literal_token2] = ACTIONS(11563),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11563),
    [aux_sym_float_literal_token3] = ACTIONS(11563),
    [aux_sym_float_literal_token4] = ACTIONS(11563),
    [sym_character_literal] = ACTIONS(11563),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11563),
    [sym__pair_operator] = ACTIONS(11563),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11563),
    [sym__lazy_and_operator] = ACTIONS(11563),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11563),
    [sym__pipe_left_operator] = ACTIONS(11563),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11563),
    [sym__bitshift_operator] = ACTIONS(11563),
    [sym__power_operator] = ACTIONS(11563),
    [sym__tilde_operator] = ACTIONS(11563),
    [sym__type_order_operator] = ACTIONS(11563),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym__terminator_token1] = ACTIONS(11565),
    [aux_sym__terminator_token2] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8165] = {
    [sym_block_comment] = STATE(8165),
    [sym_line_comment] = STATE(8165),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8166] = {
    [sym_block_comment] = STATE(8166),
    [sym_line_comment] = STATE(8166),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10855),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10855),
    [anon_sym_RPAREN] = ACTIONS(10855),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10855),
    [anon_sym_RBRACK] = ACTIONS(10855),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_SEMI] = ACTIONS(10855),
    [anon_sym_LBRACE] = ACTIONS(10855),
    [anon_sym_RBRACE] = ACTIONS(10855),
    [anon_sym_DOLLAR] = ACTIONS(10855),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10855),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10855),
    [anon_sym_QMARK] = ACTIONS(10855),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10855),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10855),
    [aux_sym_integer_literal_token2] = ACTIONS(10855),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10855),
    [aux_sym_float_literal_token3] = ACTIONS(10855),
    [aux_sym_float_literal_token4] = ACTIONS(10855),
    [sym_character_literal] = ACTIONS(10855),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10855),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10855),
    [sym__pair_operator] = ACTIONS(10855),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10855),
    [sym__lazy_and_operator] = ACTIONS(10855),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10855),
    [sym__pipe_left_operator] = ACTIONS(10855),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10855),
    [sym__bitshift_operator] = ACTIONS(10855),
    [sym__power_operator] = ACTIONS(10855),
    [sym__tilde_operator] = ACTIONS(10855),
    [sym__type_order_operator] = ACTIONS(10855),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8167] = {
    [sym_block_comment] = STATE(8167),
    [sym_line_comment] = STATE(8167),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11567),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_end] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_finally] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11567),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11567),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11567),
    [anon_sym_DOLLAR] = ACTIONS(11567),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11567),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11567),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11567),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11567),
    [aux_sym_integer_literal_token2] = ACTIONS(11567),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11567),
    [aux_sym_float_literal_token3] = ACTIONS(11567),
    [aux_sym_float_literal_token4] = ACTIONS(11567),
    [sym_character_literal] = ACTIONS(11567),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11567),
    [sym__pair_operator] = ACTIONS(11567),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11567),
    [sym__lazy_and_operator] = ACTIONS(11567),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11567),
    [sym__pipe_left_operator] = ACTIONS(11567),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11567),
    [sym__bitshift_operator] = ACTIONS(11567),
    [sym__power_operator] = ACTIONS(11567),
    [sym__tilde_operator] = ACTIONS(11567),
    [sym__type_order_operator] = ACTIONS(11567),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym__terminator_token1] = ACTIONS(11569),
    [aux_sym__terminator_token2] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8168] = {
    [sym_block_comment] = STATE(8168),
    [sym_line_comment] = STATE(8168),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11571),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_end] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_finally] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11571),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11571),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11571),
    [anon_sym_DOLLAR] = ACTIONS(11571),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11571),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_QMARK] = ACTIONS(11571),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11571),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11571),
    [aux_sym_integer_literal_token2] = ACTIONS(11571),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11571),
    [aux_sym_float_literal_token3] = ACTIONS(11571),
    [aux_sym_float_literal_token4] = ACTIONS(11571),
    [sym_character_literal] = ACTIONS(11571),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11571),
    [sym__pair_operator] = ACTIONS(11571),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11571),
    [sym__lazy_and_operator] = ACTIONS(11571),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11571),
    [sym__pipe_left_operator] = ACTIONS(11571),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11571),
    [sym__bitshift_operator] = ACTIONS(11571),
    [sym__power_operator] = ACTIONS(11571),
    [sym__tilde_operator] = ACTIONS(11571),
    [sym__type_order_operator] = ACTIONS(11571),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym__terminator_token1] = ACTIONS(11573),
    [aux_sym__terminator_token2] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8169] = {
    [sym_block_comment] = STATE(8169),
    [sym_line_comment] = STATE(8169),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10863),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10863),
    [anon_sym_RPAREN] = ACTIONS(10863),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10863),
    [anon_sym_RBRACK] = ACTIONS(10863),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_SEMI] = ACTIONS(10863),
    [anon_sym_LBRACE] = ACTIONS(10863),
    [anon_sym_RBRACE] = ACTIONS(10863),
    [anon_sym_DOLLAR] = ACTIONS(10863),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10863),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10863),
    [anon_sym_QMARK] = ACTIONS(10863),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10863),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10863),
    [aux_sym_integer_literal_token2] = ACTIONS(10863),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10863),
    [aux_sym_float_literal_token3] = ACTIONS(10863),
    [aux_sym_float_literal_token4] = ACTIONS(10863),
    [sym_character_literal] = ACTIONS(10863),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10863),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10863),
    [sym__pair_operator] = ACTIONS(10863),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10863),
    [sym__lazy_and_operator] = ACTIONS(10863),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10863),
    [sym__pipe_left_operator] = ACTIONS(10863),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10863),
    [sym__bitshift_operator] = ACTIONS(10863),
    [sym__power_operator] = ACTIONS(10863),
    [sym__tilde_operator] = ACTIONS(10863),
    [sym__type_order_operator] = ACTIONS(10863),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8170] = {
    [sym_block_comment] = STATE(8170),
    [sym_line_comment] = STATE(8170),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11900),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11900),
    [anon_sym_RPAREN] = ACTIONS(11900),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11900),
    [anon_sym_RBRACK] = ACTIONS(11900),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_SEMI] = ACTIONS(11900),
    [anon_sym_LBRACE] = ACTIONS(11900),
    [anon_sym_RBRACE] = ACTIONS(11900),
    [anon_sym_DOLLAR] = ACTIONS(11900),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11900),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11900),
    [anon_sym_QMARK] = ACTIONS(11900),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11900),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11900),
    [aux_sym_integer_literal_token2] = ACTIONS(11900),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11900),
    [aux_sym_float_literal_token3] = ACTIONS(11900),
    [aux_sym_float_literal_token4] = ACTIONS(11900),
    [sym_character_literal] = ACTIONS(11900),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11900),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11900),
    [sym__pair_operator] = ACTIONS(11900),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11900),
    [sym__lazy_and_operator] = ACTIONS(11900),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11900),
    [sym__pipe_left_operator] = ACTIONS(11900),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11900),
    [sym__bitshift_operator] = ACTIONS(11900),
    [sym__power_operator] = ACTIONS(11900),
    [sym__tilde_operator] = ACTIONS(11900),
    [sym__type_order_operator] = ACTIONS(11900),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8171] = {
    [sym_block_comment] = STATE(8171),
    [sym_line_comment] = STATE(8171),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11175),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11175),
    [anon_sym_RPAREN] = ACTIONS(11175),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11175),
    [anon_sym_RBRACK] = ACTIONS(11175),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_SEMI] = ACTIONS(11175),
    [anon_sym_LBRACE] = ACTIONS(11175),
    [anon_sym_RBRACE] = ACTIONS(11175),
    [anon_sym_DOLLAR] = ACTIONS(11175),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11175),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11175),
    [anon_sym_QMARK] = ACTIONS(11175),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11175),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11175),
    [aux_sym_integer_literal_token2] = ACTIONS(11175),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11175),
    [aux_sym_float_literal_token3] = ACTIONS(11175),
    [aux_sym_float_literal_token4] = ACTIONS(11175),
    [sym_character_literal] = ACTIONS(11175),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11175),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11175),
    [sym__pair_operator] = ACTIONS(11175),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11175),
    [sym__lazy_and_operator] = ACTIONS(11175),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11175),
    [sym__pipe_left_operator] = ACTIONS(11175),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11175),
    [sym__bitshift_operator] = ACTIONS(11175),
    [sym__power_operator] = ACTIONS(11175),
    [sym__tilde_operator] = ACTIONS(11175),
    [sym__type_order_operator] = ACTIONS(11175),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8172] = {
    [sym_block_comment] = STATE(8172),
    [sym_line_comment] = STATE(8172),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3071),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3071),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3071),
    [anon_sym_QMARK] = ACTIONS(3071),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3071),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3071),
    [aux_sym_integer_literal_token2] = ACTIONS(3071),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3071),
    [aux_sym_float_literal_token3] = ACTIONS(3071),
    [aux_sym_float_literal_token4] = ACTIONS(3071),
    [sym_character_literal] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3071),
    [sym__pair_operator] = ACTIONS(3071),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3071),
    [sym__lazy_and_operator] = ACTIONS(3071),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3071),
    [sym__pipe_left_operator] = ACTIONS(3071),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3071),
    [sym__bitshift_operator] = ACTIONS(3071),
    [sym__power_operator] = ACTIONS(3071),
    [sym__tilde_operator] = ACTIONS(3071),
    [sym__type_order_operator] = ACTIONS(3071),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8173] = {
    [sym_block_comment] = STATE(8173),
    [sym_line_comment] = STATE(8173),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8174] = {
    [sym_block_comment] = STATE(8174),
    [sym_line_comment] = STATE(8174),
    [ts_builtin_sym_end] = ACTIONS(11114),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_RBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8175] = {
    [sym_block_comment] = STATE(8175),
    [sym_line_comment] = STATE(8175),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10120),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8176] = {
    [sym_block_comment] = STATE(8176),
    [sym_line_comment] = STATE(8176),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(9858),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8177] = {
    [sym_block_comment] = STATE(8177),
    [sym_line_comment] = STATE(8177),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9958),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9958),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9958),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9958),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9958),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9958),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9958),
    [anon_sym_QMARK] = ACTIONS(9958),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9958),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9958),
    [aux_sym_integer_literal_token2] = ACTIONS(9958),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9958),
    [aux_sym_float_literal_token3] = ACTIONS(9958),
    [aux_sym_float_literal_token4] = ACTIONS(9958),
    [sym_character_literal] = ACTIONS(9958),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9958),
    [sym__pair_operator] = ACTIONS(9958),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9958),
    [sym__lazy_and_operator] = ACTIONS(9958),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9958),
    [sym__pipe_left_operator] = ACTIONS(9958),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9958),
    [sym__bitshift_operator] = ACTIONS(9958),
    [sym__power_operator] = ACTIONS(9958),
    [sym__tilde_operator] = ACTIONS(9958),
    [sym__type_order_operator] = ACTIONS(9958),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym__terminator_token1] = ACTIONS(9960),
    [aux_sym__terminator_token2] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8178] = {
    [sym_block_comment] = STATE(8178),
    [sym_line_comment] = STATE(8178),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10639),
    [sym__immediate_bracket] = ACTIONS(10639),
    [sym__immediate_brace] = ACTIONS(10639),
  },
  [8179] = {
    [sym_block_comment] = STATE(8179),
    [sym_line_comment] = STATE(8179),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11519),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11519),
    [anon_sym_RPAREN] = ACTIONS(11519),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11519),
    [anon_sym_RBRACK] = ACTIONS(11519),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_SEMI] = ACTIONS(11519),
    [anon_sym_LBRACE] = ACTIONS(11519),
    [anon_sym_RBRACE] = ACTIONS(11519),
    [anon_sym_DOLLAR] = ACTIONS(11519),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11519),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11519),
    [anon_sym_QMARK] = ACTIONS(11519),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11519),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11519),
    [aux_sym_integer_literal_token2] = ACTIONS(11519),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11519),
    [aux_sym_float_literal_token3] = ACTIONS(11519),
    [aux_sym_float_literal_token4] = ACTIONS(11519),
    [sym_character_literal] = ACTIONS(11519),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11519),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11519),
    [sym__pair_operator] = ACTIONS(11519),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11519),
    [sym__lazy_and_operator] = ACTIONS(11519),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11519),
    [sym__pipe_left_operator] = ACTIONS(11519),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11519),
    [sym__bitshift_operator] = ACTIONS(11519),
    [sym__power_operator] = ACTIONS(11519),
    [sym__tilde_operator] = ACTIONS(11519),
    [sym__type_order_operator] = ACTIONS(11519),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8180] = {
    [sym_block_comment] = STATE(8180),
    [sym_line_comment] = STATE(8180),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11926),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11926),
    [anon_sym_RPAREN] = ACTIONS(11926),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11926),
    [anon_sym_RBRACK] = ACTIONS(11926),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_SEMI] = ACTIONS(11926),
    [anon_sym_LBRACE] = ACTIONS(11926),
    [anon_sym_RBRACE] = ACTIONS(11926),
    [anon_sym_DOLLAR] = ACTIONS(11926),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11926),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11926),
    [anon_sym_QMARK] = ACTIONS(11926),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11926),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11926),
    [aux_sym_integer_literal_token2] = ACTIONS(11926),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11926),
    [aux_sym_float_literal_token3] = ACTIONS(11926),
    [aux_sym_float_literal_token4] = ACTIONS(11926),
    [sym_character_literal] = ACTIONS(11926),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11926),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11926),
    [sym__pair_operator] = ACTIONS(11926),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11926),
    [sym__lazy_and_operator] = ACTIONS(11926),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11926),
    [sym__pipe_left_operator] = ACTIONS(11926),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11926),
    [sym__bitshift_operator] = ACTIONS(11926),
    [sym__power_operator] = ACTIONS(11926),
    [sym__tilde_operator] = ACTIONS(11926),
    [sym__type_order_operator] = ACTIONS(11926),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8181] = {
    [sym_block_comment] = STATE(8181),
    [sym_line_comment] = STATE(8181),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11943),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11943),
    [anon_sym_RPAREN] = ACTIONS(11943),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11943),
    [anon_sym_RBRACK] = ACTIONS(11943),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_SEMI] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(11943),
    [anon_sym_RBRACE] = ACTIONS(11943),
    [anon_sym_DOLLAR] = ACTIONS(11943),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11943),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11943),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11943),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11943),
    [aux_sym_integer_literal_token2] = ACTIONS(11943),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11943),
    [aux_sym_float_literal_token3] = ACTIONS(11943),
    [aux_sym_float_literal_token4] = ACTIONS(11943),
    [sym_character_literal] = ACTIONS(11943),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11943),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11943),
    [sym__pair_operator] = ACTIONS(11943),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11943),
    [sym__lazy_and_operator] = ACTIONS(11943),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11943),
    [sym__pipe_left_operator] = ACTIONS(11943),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11943),
    [sym__bitshift_operator] = ACTIONS(11943),
    [sym__power_operator] = ACTIONS(11943),
    [sym__tilde_operator] = ACTIONS(11943),
    [sym__type_order_operator] = ACTIONS(11943),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8182] = {
    [sym_block_comment] = STATE(8182),
    [sym_line_comment] = STATE(8182),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11967),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11967),
    [anon_sym_RPAREN] = ACTIONS(11967),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11967),
    [anon_sym_RBRACK] = ACTIONS(11967),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_SEMI] = ACTIONS(11967),
    [anon_sym_LBRACE] = ACTIONS(11967),
    [anon_sym_RBRACE] = ACTIONS(11967),
    [anon_sym_DOLLAR] = ACTIONS(11967),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11967),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11967),
    [anon_sym_QMARK] = ACTIONS(11967),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11967),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11967),
    [aux_sym_integer_literal_token2] = ACTIONS(11967),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11967),
    [aux_sym_float_literal_token3] = ACTIONS(11967),
    [aux_sym_float_literal_token4] = ACTIONS(11967),
    [sym_character_literal] = ACTIONS(11967),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11967),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11967),
    [sym__pair_operator] = ACTIONS(11967),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11967),
    [sym__lazy_and_operator] = ACTIONS(11967),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11967),
    [sym__pipe_left_operator] = ACTIONS(11967),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11967),
    [sym__bitshift_operator] = ACTIONS(11967),
    [sym__power_operator] = ACTIONS(11967),
    [sym__tilde_operator] = ACTIONS(11967),
    [sym__type_order_operator] = ACTIONS(11967),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8183] = {
    [sym_block_comment] = STATE(8183),
    [sym_line_comment] = STATE(8183),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11971),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11971),
    [anon_sym_RPAREN] = ACTIONS(11971),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11971),
    [anon_sym_RBRACK] = ACTIONS(11971),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_SEMI] = ACTIONS(11971),
    [anon_sym_LBRACE] = ACTIONS(11971),
    [anon_sym_RBRACE] = ACTIONS(11971),
    [anon_sym_DOLLAR] = ACTIONS(11971),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11971),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11971),
    [anon_sym_QMARK] = ACTIONS(11971),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11971),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11971),
    [aux_sym_integer_literal_token2] = ACTIONS(11971),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11971),
    [aux_sym_float_literal_token3] = ACTIONS(11971),
    [aux_sym_float_literal_token4] = ACTIONS(11971),
    [sym_character_literal] = ACTIONS(11971),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11971),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11971),
    [sym__pair_operator] = ACTIONS(11971),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11971),
    [sym__lazy_and_operator] = ACTIONS(11971),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11971),
    [sym__pipe_left_operator] = ACTIONS(11971),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11971),
    [sym__bitshift_operator] = ACTIONS(11971),
    [sym__power_operator] = ACTIONS(11971),
    [sym__tilde_operator] = ACTIONS(11971),
    [sym__type_order_operator] = ACTIONS(11971),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8184] = {
    [sym_block_comment] = STATE(8184),
    [sym_line_comment] = STATE(8184),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12050),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12050),
    [anon_sym_RPAREN] = ACTIONS(12050),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12050),
    [anon_sym_RBRACK] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_SEMI] = ACTIONS(12050),
    [anon_sym_LBRACE] = ACTIONS(12050),
    [anon_sym_RBRACE] = ACTIONS(12050),
    [anon_sym_DOLLAR] = ACTIONS(12050),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12050),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12050),
    [anon_sym_QMARK] = ACTIONS(12050),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12050),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12050),
    [aux_sym_integer_literal_token2] = ACTIONS(12050),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12050),
    [aux_sym_float_literal_token3] = ACTIONS(12050),
    [aux_sym_float_literal_token4] = ACTIONS(12050),
    [sym_character_literal] = ACTIONS(12050),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12050),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12050),
    [sym__pair_operator] = ACTIONS(12050),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12050),
    [sym__lazy_and_operator] = ACTIONS(12050),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12050),
    [sym__pipe_left_operator] = ACTIONS(12050),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12050),
    [sym__bitshift_operator] = ACTIONS(12050),
    [sym__power_operator] = ACTIONS(12050),
    [sym__tilde_operator] = ACTIONS(12050),
    [sym__type_order_operator] = ACTIONS(12050),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8185] = {
    [sym_block_comment] = STATE(8185),
    [sym_line_comment] = STATE(8185),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_RPAREN] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_RBRACK] = ACTIONS(12054),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_SEMI] = ACTIONS(12054),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_RBRACE] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12054),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8186] = {
    [sym_block_comment] = STATE(8186),
    [sym_line_comment] = STATE(8186),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11035),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11035),
    [anon_sym_RPAREN] = ACTIONS(11035),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11035),
    [anon_sym_RBRACK] = ACTIONS(11035),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_SEMI] = ACTIONS(11035),
    [anon_sym_LBRACE] = ACTIONS(11035),
    [anon_sym_RBRACE] = ACTIONS(11035),
    [anon_sym_DOLLAR] = ACTIONS(11035),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11035),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11035),
    [anon_sym_QMARK] = ACTIONS(11035),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11035),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11035),
    [aux_sym_integer_literal_token2] = ACTIONS(11035),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11035),
    [aux_sym_float_literal_token3] = ACTIONS(11035),
    [aux_sym_float_literal_token4] = ACTIONS(11035),
    [sym_character_literal] = ACTIONS(11035),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11035),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11035),
    [sym__pair_operator] = ACTIONS(11035),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11035),
    [sym__lazy_and_operator] = ACTIONS(11035),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11035),
    [sym__pipe_left_operator] = ACTIONS(11035),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11035),
    [sym__bitshift_operator] = ACTIONS(11035),
    [sym__power_operator] = ACTIONS(11035),
    [sym__tilde_operator] = ACTIONS(11035),
    [sym__type_order_operator] = ACTIONS(11035),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8187] = {
    [sym_block_comment] = STATE(8187),
    [sym_line_comment] = STATE(8187),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11041),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11041),
    [anon_sym_RPAREN] = ACTIONS(11041),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11041),
    [anon_sym_RBRACK] = ACTIONS(11041),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_SEMI] = ACTIONS(11041),
    [anon_sym_LBRACE] = ACTIONS(11041),
    [anon_sym_RBRACE] = ACTIONS(11041),
    [anon_sym_DOLLAR] = ACTIONS(11041),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11041),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11041),
    [anon_sym_QMARK] = ACTIONS(11041),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11041),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11041),
    [aux_sym_integer_literal_token2] = ACTIONS(11041),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11041),
    [aux_sym_float_literal_token3] = ACTIONS(11041),
    [aux_sym_float_literal_token4] = ACTIONS(11041),
    [sym_character_literal] = ACTIONS(11041),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11041),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11041),
    [sym__pair_operator] = ACTIONS(11041),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11041),
    [sym__lazy_and_operator] = ACTIONS(11041),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11041),
    [sym__pipe_left_operator] = ACTIONS(11041),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11041),
    [sym__bitshift_operator] = ACTIONS(11041),
    [sym__power_operator] = ACTIONS(11041),
    [sym__tilde_operator] = ACTIONS(11041),
    [sym__type_order_operator] = ACTIONS(11041),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8188] = {
    [sym_block_comment] = STATE(8188),
    [sym_line_comment] = STATE(8188),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11045),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11045),
    [anon_sym_RPAREN] = ACTIONS(11045),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11045),
    [anon_sym_RBRACK] = ACTIONS(11045),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_SEMI] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(11045),
    [anon_sym_RBRACE] = ACTIONS(11045),
    [anon_sym_DOLLAR] = ACTIONS(11045),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11045),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11045),
    [anon_sym_QMARK] = ACTIONS(11045),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11045),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11045),
    [aux_sym_integer_literal_token2] = ACTIONS(11045),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11045),
    [aux_sym_float_literal_token3] = ACTIONS(11045),
    [aux_sym_float_literal_token4] = ACTIONS(11045),
    [sym_character_literal] = ACTIONS(11045),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11045),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11045),
    [sym__pair_operator] = ACTIONS(11045),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11045),
    [sym__lazy_and_operator] = ACTIONS(11045),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11045),
    [sym__pipe_left_operator] = ACTIONS(11045),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11045),
    [sym__bitshift_operator] = ACTIONS(11045),
    [sym__power_operator] = ACTIONS(11045),
    [sym__tilde_operator] = ACTIONS(11045),
    [sym__type_order_operator] = ACTIONS(11045),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8189] = {
    [sym_block_comment] = STATE(8189),
    [sym_line_comment] = STATE(8189),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11118),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11118),
    [anon_sym_RPAREN] = ACTIONS(11118),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11118),
    [anon_sym_RBRACK] = ACTIONS(11118),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_SEMI] = ACTIONS(11118),
    [anon_sym_LBRACE] = ACTIONS(11118),
    [anon_sym_RBRACE] = ACTIONS(11118),
    [anon_sym_DOLLAR] = ACTIONS(11118),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11118),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11118),
    [anon_sym_QMARK] = ACTIONS(11118),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11118),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11118),
    [aux_sym_integer_literal_token2] = ACTIONS(11118),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11118),
    [aux_sym_float_literal_token3] = ACTIONS(11118),
    [aux_sym_float_literal_token4] = ACTIONS(11118),
    [sym_character_literal] = ACTIONS(11118),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11118),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11118),
    [sym__pair_operator] = ACTIONS(11118),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11118),
    [sym__lazy_and_operator] = ACTIONS(11118),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11118),
    [sym__pipe_left_operator] = ACTIONS(11118),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11118),
    [sym__bitshift_operator] = ACTIONS(11118),
    [sym__power_operator] = ACTIONS(11118),
    [sym__tilde_operator] = ACTIONS(11118),
    [sym__type_order_operator] = ACTIONS(11118),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8190] = {
    [sym_block_comment] = STATE(8190),
    [sym_line_comment] = STATE(8190),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10835),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_catch] = ACTIONS(10835),
    [anon_sym_finally] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8191] = {
    [sym_block_comment] = STATE(8191),
    [sym_line_comment] = STATE(8191),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11122),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11122),
    [anon_sym_RPAREN] = ACTIONS(11122),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11122),
    [anon_sym_RBRACK] = ACTIONS(11122),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_SEMI] = ACTIONS(11122),
    [anon_sym_LBRACE] = ACTIONS(11122),
    [anon_sym_RBRACE] = ACTIONS(11122),
    [anon_sym_DOLLAR] = ACTIONS(11122),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11122),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11122),
    [anon_sym_QMARK] = ACTIONS(11122),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11122),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11122),
    [aux_sym_integer_literal_token2] = ACTIONS(11122),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11122),
    [aux_sym_float_literal_token3] = ACTIONS(11122),
    [aux_sym_float_literal_token4] = ACTIONS(11122),
    [sym_character_literal] = ACTIONS(11122),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11122),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11122),
    [sym__pair_operator] = ACTIONS(11122),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11122),
    [sym__lazy_and_operator] = ACTIONS(11122),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11122),
    [sym__pipe_left_operator] = ACTIONS(11122),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11122),
    [sym__bitshift_operator] = ACTIONS(11122),
    [sym__power_operator] = ACTIONS(11122),
    [sym__tilde_operator] = ACTIONS(11122),
    [sym__type_order_operator] = ACTIONS(11122),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8192] = {
    [sym_block_comment] = STATE(8192),
    [sym_line_comment] = STATE(8192),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11199),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11199),
    [anon_sym_RPAREN] = ACTIONS(11199),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11199),
    [anon_sym_RBRACK] = ACTIONS(11199),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_SEMI] = ACTIONS(11199),
    [anon_sym_LBRACE] = ACTIONS(11199),
    [anon_sym_RBRACE] = ACTIONS(11199),
    [anon_sym_DOLLAR] = ACTIONS(11199),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11199),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11199),
    [anon_sym_QMARK] = ACTIONS(11199),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11199),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11199),
    [aux_sym_integer_literal_token2] = ACTIONS(11199),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11199),
    [aux_sym_float_literal_token3] = ACTIONS(11199),
    [aux_sym_float_literal_token4] = ACTIONS(11199),
    [sym_character_literal] = ACTIONS(11199),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11199),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11199),
    [sym__pair_operator] = ACTIONS(11199),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11199),
    [sym__lazy_and_operator] = ACTIONS(11199),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11199),
    [sym__pipe_left_operator] = ACTIONS(11199),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11199),
    [sym__bitshift_operator] = ACTIONS(11199),
    [sym__power_operator] = ACTIONS(11199),
    [sym__tilde_operator] = ACTIONS(11199),
    [sym__type_order_operator] = ACTIONS(11199),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8193] = {
    [sym_block_comment] = STATE(8193),
    [sym_line_comment] = STATE(8193),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11213),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11213),
    [anon_sym_RPAREN] = ACTIONS(11213),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11213),
    [anon_sym_RBRACK] = ACTIONS(11213),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_SEMI] = ACTIONS(11213),
    [anon_sym_LBRACE] = ACTIONS(11213),
    [anon_sym_RBRACE] = ACTIONS(11213),
    [anon_sym_DOLLAR] = ACTIONS(11213),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11213),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11213),
    [anon_sym_QMARK] = ACTIONS(11213),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11213),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11213),
    [aux_sym_integer_literal_token2] = ACTIONS(11213),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11213),
    [aux_sym_float_literal_token3] = ACTIONS(11213),
    [aux_sym_float_literal_token4] = ACTIONS(11213),
    [sym_character_literal] = ACTIONS(11213),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11213),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11213),
    [sym__pair_operator] = ACTIONS(11213),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11213),
    [sym__lazy_and_operator] = ACTIONS(11213),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11213),
    [sym__pipe_left_operator] = ACTIONS(11213),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11213),
    [sym__bitshift_operator] = ACTIONS(11213),
    [sym__power_operator] = ACTIONS(11213),
    [sym__tilde_operator] = ACTIONS(11213),
    [sym__type_order_operator] = ACTIONS(11213),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8194] = {
    [sym_block_comment] = STATE(8194),
    [sym_line_comment] = STATE(8194),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11108),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8195] = {
    [sym_block_comment] = STATE(8195),
    [sym_line_comment] = STATE(8195),
    [aux_sym_open_tuple_repeat1] = STATE(8195),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(12172),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10840),
    [anon_sym_RPAREN] = ACTIONS(10840),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10840),
    [anon_sym_RBRACK] = ACTIONS(10840),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10840),
    [anon_sym_RBRACE] = ACTIONS(10840),
    [anon_sym_DOLLAR] = ACTIONS(10840),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10840),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10840),
    [anon_sym_QMARK] = ACTIONS(10840),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10840),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10840),
    [aux_sym_integer_literal_token2] = ACTIONS(10840),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10840),
    [aux_sym_float_literal_token3] = ACTIONS(10840),
    [aux_sym_float_literal_token4] = ACTIONS(10840),
    [sym_character_literal] = ACTIONS(10840),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10840),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10840),
    [sym__pair_operator] = ACTIONS(10840),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10840),
    [sym__lazy_and_operator] = ACTIONS(10840),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10840),
    [sym__pipe_left_operator] = ACTIONS(10840),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10840),
    [sym__bitshift_operator] = ACTIONS(10840),
    [sym__power_operator] = ACTIONS(10840),
    [sym__tilde_operator] = ACTIONS(10840),
    [sym__type_order_operator] = ACTIONS(10840),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8196] = {
    [sym_block_comment] = STATE(8196),
    [sym_line_comment] = STATE(8196),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9722),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8197] = {
    [sym_block_comment] = STATE(8197),
    [sym_line_comment] = STATE(8197),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11247),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11247),
    [anon_sym_QMARK] = ACTIONS(11247),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11247),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11247),
    [sym__lazy_and_operator] = ACTIONS(11247),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11247),
    [sym__pipe_left_operator] = ACTIONS(11247),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11247),
    [sym__bitshift_operator] = ACTIONS(11247),
    [sym__power_operator] = ACTIONS(11247),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11247),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8198] = {
    [sym_block_comment] = STATE(8198),
    [sym_line_comment] = STATE(8198),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8199] = {
    [sym_block_comment] = STATE(8199),
    [sym_line_comment] = STATE(8199),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11331),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_end] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_finally] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11331),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11331),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11331),
    [anon_sym_DOLLAR] = ACTIONS(11331),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11331),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11331),
    [anon_sym_QMARK] = ACTIONS(11331),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11331),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11331),
    [aux_sym_integer_literal_token2] = ACTIONS(11331),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11331),
    [aux_sym_float_literal_token3] = ACTIONS(11331),
    [aux_sym_float_literal_token4] = ACTIONS(11331),
    [sym_character_literal] = ACTIONS(11331),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11331),
    [sym__pair_operator] = ACTIONS(11331),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11331),
    [sym__lazy_and_operator] = ACTIONS(11331),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11331),
    [sym__pipe_left_operator] = ACTIONS(11331),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11331),
    [sym__bitshift_operator] = ACTIONS(11331),
    [sym__power_operator] = ACTIONS(11331),
    [sym__tilde_operator] = ACTIONS(11331),
    [sym__type_order_operator] = ACTIONS(11331),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym__terminator_token1] = ACTIONS(11333),
    [aux_sym__terminator_token2] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8200] = {
    [sym_block_comment] = STATE(8200),
    [sym_line_comment] = STATE(8200),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_finally] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11335),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_DOLLAR] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11335),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11335),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11335),
    [aux_sym_integer_literal_token2] = ACTIONS(11335),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11335),
    [aux_sym_float_literal_token3] = ACTIONS(11335),
    [aux_sym_float_literal_token4] = ACTIONS(11335),
    [sym_character_literal] = ACTIONS(11335),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11335),
    [sym__pair_operator] = ACTIONS(11335),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11335),
    [sym__lazy_and_operator] = ACTIONS(11335),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11335),
    [sym__pipe_left_operator] = ACTIONS(11335),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11335),
    [sym__bitshift_operator] = ACTIONS(11335),
    [sym__power_operator] = ACTIONS(11335),
    [sym__tilde_operator] = ACTIONS(11335),
    [sym__type_order_operator] = ACTIONS(11335),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym__terminator_token1] = ACTIONS(11337),
    [aux_sym__terminator_token2] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8201] = {
    [sym_block_comment] = STATE(8201),
    [sym_line_comment] = STATE(8201),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_end] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_finally] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11339),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11339),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11339),
    [anon_sym_DOLLAR] = ACTIONS(11339),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11339),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(11339),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11339),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11339),
    [aux_sym_integer_literal_token2] = ACTIONS(11339),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11339),
    [aux_sym_float_literal_token3] = ACTIONS(11339),
    [aux_sym_float_literal_token4] = ACTIONS(11339),
    [sym_character_literal] = ACTIONS(11339),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11339),
    [sym__pair_operator] = ACTIONS(11339),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11339),
    [sym__lazy_and_operator] = ACTIONS(11339),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11339),
    [sym__pipe_left_operator] = ACTIONS(11339),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11339),
    [sym__bitshift_operator] = ACTIONS(11339),
    [sym__power_operator] = ACTIONS(11339),
    [sym__tilde_operator] = ACTIONS(11339),
    [sym__type_order_operator] = ACTIONS(11339),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym__terminator_token1] = ACTIONS(11341),
    [aux_sym__terminator_token2] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8202] = {
    [sym_block_comment] = STATE(8202),
    [sym_line_comment] = STATE(8202),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11343),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_end] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_finally] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11343),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11343),
    [anon_sym_DOLLAR] = ACTIONS(11343),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11343),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11343),
    [anon_sym_QMARK] = ACTIONS(11343),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11343),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11343),
    [aux_sym_integer_literal_token2] = ACTIONS(11343),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11343),
    [aux_sym_float_literal_token3] = ACTIONS(11343),
    [aux_sym_float_literal_token4] = ACTIONS(11343),
    [sym_character_literal] = ACTIONS(11343),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11343),
    [sym__pair_operator] = ACTIONS(11343),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11343),
    [sym__lazy_and_operator] = ACTIONS(11343),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11343),
    [sym__pipe_left_operator] = ACTIONS(11343),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11343),
    [sym__bitshift_operator] = ACTIONS(11343),
    [sym__power_operator] = ACTIONS(11343),
    [sym__tilde_operator] = ACTIONS(11343),
    [sym__type_order_operator] = ACTIONS(11343),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym__terminator_token1] = ACTIONS(11345),
    [aux_sym__terminator_token2] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8203] = {
    [sym_block_comment] = STATE(8203),
    [sym_line_comment] = STATE(8203),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11347),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_end] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_finally] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11347),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11347),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11347),
    [anon_sym_DOLLAR] = ACTIONS(11347),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11347),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11347),
    [anon_sym_QMARK] = ACTIONS(11347),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11347),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11347),
    [aux_sym_integer_literal_token2] = ACTIONS(11347),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11347),
    [aux_sym_float_literal_token3] = ACTIONS(11347),
    [aux_sym_float_literal_token4] = ACTIONS(11347),
    [sym_character_literal] = ACTIONS(11347),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11347),
    [sym__pair_operator] = ACTIONS(11347),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11347),
    [sym__lazy_and_operator] = ACTIONS(11347),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11347),
    [sym__pipe_left_operator] = ACTIONS(11347),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11347),
    [sym__bitshift_operator] = ACTIONS(11347),
    [sym__power_operator] = ACTIONS(11347),
    [sym__tilde_operator] = ACTIONS(11347),
    [sym__type_order_operator] = ACTIONS(11347),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym__terminator_token1] = ACTIONS(11349),
    [aux_sym__terminator_token2] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8204] = {
    [sym_block_comment] = STATE(8204),
    [sym_line_comment] = STATE(8204),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11351),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_end] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_finally] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11351),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11351),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11351),
    [anon_sym_DOLLAR] = ACTIONS(11351),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11351),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11351),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11351),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11351),
    [aux_sym_integer_literal_token2] = ACTIONS(11351),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11351),
    [aux_sym_float_literal_token3] = ACTIONS(11351),
    [aux_sym_float_literal_token4] = ACTIONS(11351),
    [sym_character_literal] = ACTIONS(11351),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11351),
    [sym__pair_operator] = ACTIONS(11351),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11351),
    [sym__lazy_and_operator] = ACTIONS(11351),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11351),
    [sym__pipe_left_operator] = ACTIONS(11351),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11351),
    [sym__bitshift_operator] = ACTIONS(11351),
    [sym__power_operator] = ACTIONS(11351),
    [sym__tilde_operator] = ACTIONS(11351),
    [sym__type_order_operator] = ACTIONS(11351),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym__terminator_token1] = ACTIONS(11353),
    [aux_sym__terminator_token2] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8205] = {
    [sym_block_comment] = STATE(8205),
    [sym_line_comment] = STATE(8205),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_RPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_RBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_SEMI] = ACTIONS(10982),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_RBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10982),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10982),
    [anon_sym_QMARK] = ACTIONS(10982),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10982),
    [sym__lazy_and_operator] = ACTIONS(10982),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10982),
    [sym__pipe_left_operator] = ACTIONS(10982),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10982),
    [sym__bitshift_operator] = ACTIONS(10982),
    [sym__power_operator] = ACTIONS(10982),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(10982),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8206] = {
    [sym_block_comment] = STATE(8206),
    [sym_line_comment] = STATE(8206),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11355),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_end] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_finally] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11355),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11355),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11355),
    [anon_sym_DOLLAR] = ACTIONS(11355),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11355),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_QMARK] = ACTIONS(11355),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11355),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11355),
    [aux_sym_integer_literal_token2] = ACTIONS(11355),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11355),
    [aux_sym_float_literal_token3] = ACTIONS(11355),
    [aux_sym_float_literal_token4] = ACTIONS(11355),
    [sym_character_literal] = ACTIONS(11355),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11355),
    [sym__pair_operator] = ACTIONS(11355),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11355),
    [sym__lazy_and_operator] = ACTIONS(11355),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11355),
    [sym__pipe_left_operator] = ACTIONS(11355),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11355),
    [sym__bitshift_operator] = ACTIONS(11355),
    [sym__power_operator] = ACTIONS(11355),
    [sym__tilde_operator] = ACTIONS(11355),
    [sym__type_order_operator] = ACTIONS(11355),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym__terminator_token1] = ACTIONS(11357),
    [aux_sym__terminator_token2] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8207] = {
    [sym_block_comment] = STATE(8207),
    [sym_line_comment] = STATE(8207),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11373),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_end] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_finally] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11373),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11373),
    [anon_sym_DOLLAR] = ACTIONS(11373),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11373),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11373),
    [anon_sym_QMARK] = ACTIONS(11373),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11373),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11373),
    [aux_sym_integer_literal_token2] = ACTIONS(11373),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11373),
    [aux_sym_float_literal_token3] = ACTIONS(11373),
    [aux_sym_float_literal_token4] = ACTIONS(11373),
    [sym_character_literal] = ACTIONS(11373),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11373),
    [sym__pair_operator] = ACTIONS(11373),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11373),
    [sym__lazy_and_operator] = ACTIONS(11373),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11373),
    [sym__pipe_left_operator] = ACTIONS(11373),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11373),
    [sym__bitshift_operator] = ACTIONS(11373),
    [sym__power_operator] = ACTIONS(11373),
    [sym__tilde_operator] = ACTIONS(11373),
    [sym__type_order_operator] = ACTIONS(11373),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym__terminator_token1] = ACTIONS(11375),
    [aux_sym__terminator_token2] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8208] = {
    [sym_block_comment] = STATE(8208),
    [sym_line_comment] = STATE(8208),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_end] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_finally] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11377),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11377),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11377),
    [anon_sym_DOLLAR] = ACTIONS(11377),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11377),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11377),
    [anon_sym_QMARK] = ACTIONS(11377),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11377),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11377),
    [aux_sym_integer_literal_token2] = ACTIONS(11377),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11377),
    [aux_sym_float_literal_token3] = ACTIONS(11377),
    [aux_sym_float_literal_token4] = ACTIONS(11377),
    [sym_character_literal] = ACTIONS(11377),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11377),
    [sym__pair_operator] = ACTIONS(11377),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11377),
    [sym__lazy_and_operator] = ACTIONS(11377),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11377),
    [sym__pipe_left_operator] = ACTIONS(11377),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11377),
    [sym__bitshift_operator] = ACTIONS(11377),
    [sym__power_operator] = ACTIONS(11377),
    [sym__tilde_operator] = ACTIONS(11377),
    [sym__type_order_operator] = ACTIONS(11377),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym__terminator_token1] = ACTIONS(11379),
    [aux_sym__terminator_token2] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8209] = {
    [sym_block_comment] = STATE(8209),
    [sym_line_comment] = STATE(8209),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_end] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_finally] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11385),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11385),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11385),
    [anon_sym_DOLLAR] = ACTIONS(11385),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11385),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11385),
    [anon_sym_QMARK] = ACTIONS(11385),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11385),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11385),
    [aux_sym_integer_literal_token2] = ACTIONS(11385),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11385),
    [aux_sym_float_literal_token3] = ACTIONS(11385),
    [aux_sym_float_literal_token4] = ACTIONS(11385),
    [sym_character_literal] = ACTIONS(11385),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11385),
    [sym__pair_operator] = ACTIONS(11385),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11385),
    [sym__lazy_and_operator] = ACTIONS(11385),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11385),
    [sym__pipe_left_operator] = ACTIONS(11385),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11385),
    [sym__bitshift_operator] = ACTIONS(11385),
    [sym__power_operator] = ACTIONS(11385),
    [sym__tilde_operator] = ACTIONS(11385),
    [sym__type_order_operator] = ACTIONS(11385),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym__terminator_token1] = ACTIONS(11387),
    [aux_sym__terminator_token2] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8210] = {
    [sym_block_comment] = STATE(8210),
    [sym_line_comment] = STATE(8210),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11399),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_end] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_finally] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11399),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11399),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11399),
    [anon_sym_DOLLAR] = ACTIONS(11399),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11399),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11399),
    [anon_sym_QMARK] = ACTIONS(11399),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11399),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11399),
    [aux_sym_integer_literal_token2] = ACTIONS(11399),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11399),
    [aux_sym_float_literal_token3] = ACTIONS(11399),
    [aux_sym_float_literal_token4] = ACTIONS(11399),
    [sym_character_literal] = ACTIONS(11399),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11399),
    [sym__pair_operator] = ACTIONS(11399),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11399),
    [sym__lazy_and_operator] = ACTIONS(11399),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11399),
    [sym__pipe_left_operator] = ACTIONS(11399),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11399),
    [sym__bitshift_operator] = ACTIONS(11399),
    [sym__power_operator] = ACTIONS(11399),
    [sym__tilde_operator] = ACTIONS(11399),
    [sym__type_order_operator] = ACTIONS(11399),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym__terminator_token1] = ACTIONS(11401),
    [aux_sym__terminator_token2] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8211] = {
    [sym_block_comment] = STATE(8211),
    [sym_line_comment] = STATE(8211),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11271),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11271),
    [anon_sym_RPAREN] = ACTIONS(11271),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11271),
    [anon_sym_RBRACK] = ACTIONS(11271),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_SEMI] = ACTIONS(11271),
    [anon_sym_LBRACE] = ACTIONS(11271),
    [anon_sym_RBRACE] = ACTIONS(11271),
    [anon_sym_DOLLAR] = ACTIONS(11271),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11271),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11271),
    [anon_sym_QMARK] = ACTIONS(11271),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11271),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11271),
    [aux_sym_integer_literal_token2] = ACTIONS(11271),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11271),
    [aux_sym_float_literal_token3] = ACTIONS(11271),
    [aux_sym_float_literal_token4] = ACTIONS(11271),
    [sym_character_literal] = ACTIONS(11271),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11271),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11271),
    [sym__pair_operator] = ACTIONS(11271),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11271),
    [sym__lazy_and_operator] = ACTIONS(11271),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11271),
    [sym__pipe_left_operator] = ACTIONS(11271),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11271),
    [sym__bitshift_operator] = ACTIONS(11271),
    [sym__power_operator] = ACTIONS(11271),
    [sym__tilde_operator] = ACTIONS(11271),
    [sym__type_order_operator] = ACTIONS(11271),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8212] = {
    [sym_block_comment] = STATE(8212),
    [sym_line_comment] = STATE(8212),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11281),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11281),
    [anon_sym_RPAREN] = ACTIONS(11281),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11281),
    [anon_sym_RBRACK] = ACTIONS(11281),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_SEMI] = ACTIONS(11281),
    [anon_sym_LBRACE] = ACTIONS(11281),
    [anon_sym_RBRACE] = ACTIONS(11281),
    [anon_sym_DOLLAR] = ACTIONS(11281),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11281),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11281),
    [anon_sym_QMARK] = ACTIONS(11281),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11281),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11281),
    [aux_sym_integer_literal_token2] = ACTIONS(11281),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11281),
    [aux_sym_float_literal_token3] = ACTIONS(11281),
    [aux_sym_float_literal_token4] = ACTIONS(11281),
    [sym_character_literal] = ACTIONS(11281),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11281),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11281),
    [sym__pair_operator] = ACTIONS(11281),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11281),
    [sym__lazy_and_operator] = ACTIONS(11281),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11281),
    [sym__pipe_left_operator] = ACTIONS(11281),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11281),
    [sym__bitshift_operator] = ACTIONS(11281),
    [sym__power_operator] = ACTIONS(11281),
    [sym__tilde_operator] = ACTIONS(11281),
    [sym__type_order_operator] = ACTIONS(11281),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8213] = {
    [sym_block_comment] = STATE(8213),
    [sym_line_comment] = STATE(8213),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11311),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11311),
    [anon_sym_RPAREN] = ACTIONS(11311),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11311),
    [anon_sym_RBRACK] = ACTIONS(11311),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_SEMI] = ACTIONS(11311),
    [anon_sym_LBRACE] = ACTIONS(11311),
    [anon_sym_RBRACE] = ACTIONS(11311),
    [anon_sym_DOLLAR] = ACTIONS(11311),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11311),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11311),
    [anon_sym_QMARK] = ACTIONS(11311),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11311),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11311),
    [aux_sym_integer_literal_token2] = ACTIONS(11311),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11311),
    [aux_sym_float_literal_token3] = ACTIONS(11311),
    [aux_sym_float_literal_token4] = ACTIONS(11311),
    [sym_character_literal] = ACTIONS(11311),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11311),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11311),
    [sym__pair_operator] = ACTIONS(11311),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11311),
    [sym__lazy_and_operator] = ACTIONS(11311),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11311),
    [sym__pipe_left_operator] = ACTIONS(11311),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11311),
    [sym__bitshift_operator] = ACTIONS(11311),
    [sym__power_operator] = ACTIONS(11311),
    [sym__tilde_operator] = ACTIONS(11311),
    [sym__type_order_operator] = ACTIONS(11311),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8214] = {
    [sym_block_comment] = STATE(8214),
    [sym_line_comment] = STATE(8214),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11319),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11319),
    [anon_sym_RPAREN] = ACTIONS(11319),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11319),
    [anon_sym_RBRACK] = ACTIONS(11319),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_SEMI] = ACTIONS(11319),
    [anon_sym_LBRACE] = ACTIONS(11319),
    [anon_sym_RBRACE] = ACTIONS(11319),
    [anon_sym_DOLLAR] = ACTIONS(11319),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11319),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11319),
    [anon_sym_QMARK] = ACTIONS(11319),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11319),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11319),
    [aux_sym_integer_literal_token2] = ACTIONS(11319),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11319),
    [aux_sym_float_literal_token3] = ACTIONS(11319),
    [aux_sym_float_literal_token4] = ACTIONS(11319),
    [sym_character_literal] = ACTIONS(11319),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11319),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11319),
    [sym__pair_operator] = ACTIONS(11319),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11319),
    [sym__lazy_and_operator] = ACTIONS(11319),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11319),
    [sym__pipe_left_operator] = ACTIONS(11319),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11319),
    [sym__bitshift_operator] = ACTIONS(11319),
    [sym__power_operator] = ACTIONS(11319),
    [sym__tilde_operator] = ACTIONS(11319),
    [sym__type_order_operator] = ACTIONS(11319),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8215] = {
    [sym_block_comment] = STATE(8215),
    [sym_line_comment] = STATE(8215),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11361),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11361),
    [anon_sym_RPAREN] = ACTIONS(11361),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11361),
    [anon_sym_RBRACK] = ACTIONS(11361),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_SEMI] = ACTIONS(11361),
    [anon_sym_LBRACE] = ACTIONS(11361),
    [anon_sym_RBRACE] = ACTIONS(11361),
    [anon_sym_DOLLAR] = ACTIONS(11361),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11361),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11361),
    [anon_sym_QMARK] = ACTIONS(11361),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11361),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11361),
    [aux_sym_integer_literal_token2] = ACTIONS(11361),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11361),
    [aux_sym_float_literal_token3] = ACTIONS(11361),
    [aux_sym_float_literal_token4] = ACTIONS(11361),
    [sym_character_literal] = ACTIONS(11361),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11361),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11361),
    [sym__pair_operator] = ACTIONS(11361),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11361),
    [sym__lazy_and_operator] = ACTIONS(11361),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11361),
    [sym__pipe_left_operator] = ACTIONS(11361),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11361),
    [sym__bitshift_operator] = ACTIONS(11361),
    [sym__power_operator] = ACTIONS(11361),
    [sym__tilde_operator] = ACTIONS(11361),
    [sym__type_order_operator] = ACTIONS(11361),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8216] = {
    [sym_block_comment] = STATE(8216),
    [sym_line_comment] = STATE(8216),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11383),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11383),
    [anon_sym_RPAREN] = ACTIONS(11383),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11383),
    [anon_sym_RBRACK] = ACTIONS(11383),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_SEMI] = ACTIONS(11383),
    [anon_sym_LBRACE] = ACTIONS(11383),
    [anon_sym_RBRACE] = ACTIONS(11383),
    [anon_sym_DOLLAR] = ACTIONS(11383),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11383),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11383),
    [anon_sym_QMARK] = ACTIONS(11383),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11383),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11383),
    [aux_sym_integer_literal_token2] = ACTIONS(11383),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11383),
    [aux_sym_float_literal_token3] = ACTIONS(11383),
    [aux_sym_float_literal_token4] = ACTIONS(11383),
    [sym_character_literal] = ACTIONS(11383),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11383),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11383),
    [sym__pair_operator] = ACTIONS(11383),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11383),
    [sym__lazy_and_operator] = ACTIONS(11383),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11383),
    [sym__pipe_left_operator] = ACTIONS(11383),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11383),
    [sym__bitshift_operator] = ACTIONS(11383),
    [sym__power_operator] = ACTIONS(11383),
    [sym__tilde_operator] = ACTIONS(11383),
    [sym__type_order_operator] = ACTIONS(11383),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8217] = {
    [sym_block_comment] = STATE(8217),
    [sym_line_comment] = STATE(8217),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11409),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11409),
    [anon_sym_RPAREN] = ACTIONS(11409),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11409),
    [anon_sym_RBRACK] = ACTIONS(11409),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_SEMI] = ACTIONS(11409),
    [anon_sym_LBRACE] = ACTIONS(11409),
    [anon_sym_RBRACE] = ACTIONS(11409),
    [anon_sym_DOLLAR] = ACTIONS(11409),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11409),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11409),
    [anon_sym_QMARK] = ACTIONS(11409),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11409),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11409),
    [aux_sym_integer_literal_token2] = ACTIONS(11409),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11409),
    [aux_sym_float_literal_token3] = ACTIONS(11409),
    [aux_sym_float_literal_token4] = ACTIONS(11409),
    [sym_character_literal] = ACTIONS(11409),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11409),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11409),
    [sym__pair_operator] = ACTIONS(11409),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11409),
    [sym__lazy_and_operator] = ACTIONS(11409),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11409),
    [sym__pipe_left_operator] = ACTIONS(11409),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11409),
    [sym__bitshift_operator] = ACTIONS(11409),
    [sym__power_operator] = ACTIONS(11409),
    [sym__tilde_operator] = ACTIONS(11409),
    [sym__type_order_operator] = ACTIONS(11409),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8218] = {
    [sym_block_comment] = STATE(8218),
    [sym_line_comment] = STATE(8218),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_end] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_finally] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11403),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11403),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11403),
    [anon_sym_DOLLAR] = ACTIONS(11403),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11403),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11403),
    [anon_sym_QMARK] = ACTIONS(11403),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11403),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11403),
    [aux_sym_integer_literal_token2] = ACTIONS(11403),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11403),
    [aux_sym_float_literal_token3] = ACTIONS(11403),
    [aux_sym_float_literal_token4] = ACTIONS(11403),
    [sym_character_literal] = ACTIONS(11403),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11403),
    [sym__pair_operator] = ACTIONS(11403),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11403),
    [sym__lazy_and_operator] = ACTIONS(11403),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11403),
    [sym__pipe_left_operator] = ACTIONS(11403),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11403),
    [sym__bitshift_operator] = ACTIONS(11403),
    [sym__power_operator] = ACTIONS(11403),
    [sym__tilde_operator] = ACTIONS(11403),
    [sym__type_order_operator] = ACTIONS(11403),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym__terminator_token1] = ACTIONS(11405),
    [aux_sym__terminator_token2] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8219] = {
    [sym_block_comment] = STATE(8219),
    [sym_line_comment] = STATE(8219),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11255),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_end] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_finally] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11255),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11255),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11255),
    [anon_sym_DOLLAR] = ACTIONS(11255),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11255),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11255),
    [anon_sym_QMARK] = ACTIONS(11255),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11255),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11255),
    [aux_sym_integer_literal_token2] = ACTIONS(11255),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11255),
    [aux_sym_float_literal_token3] = ACTIONS(11255),
    [aux_sym_float_literal_token4] = ACTIONS(11255),
    [sym_character_literal] = ACTIONS(11255),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11255),
    [sym__pair_operator] = ACTIONS(11255),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11255),
    [sym__lazy_and_operator] = ACTIONS(11255),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11255),
    [sym__pipe_left_operator] = ACTIONS(11255),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11255),
    [sym__bitshift_operator] = ACTIONS(11255),
    [sym__power_operator] = ACTIONS(11255),
    [sym__tilde_operator] = ACTIONS(11255),
    [sym__type_order_operator] = ACTIONS(11255),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym__terminator_token1] = ACTIONS(11257),
    [aux_sym__terminator_token2] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8220] = {
    [sym_block_comment] = STATE(8220),
    [sym_line_comment] = STATE(8220),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11411),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_end] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_finally] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11411),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11411),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11411),
    [anon_sym_DOLLAR] = ACTIONS(11411),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11411),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11411),
    [anon_sym_QMARK] = ACTIONS(11411),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11411),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11411),
    [aux_sym_integer_literal_token2] = ACTIONS(11411),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11411),
    [aux_sym_float_literal_token3] = ACTIONS(11411),
    [aux_sym_float_literal_token4] = ACTIONS(11411),
    [sym_character_literal] = ACTIONS(11411),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11411),
    [sym__pair_operator] = ACTIONS(11411),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11411),
    [sym__lazy_and_operator] = ACTIONS(11411),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11411),
    [sym__pipe_left_operator] = ACTIONS(11411),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11411),
    [sym__bitshift_operator] = ACTIONS(11411),
    [sym__power_operator] = ACTIONS(11411),
    [sym__tilde_operator] = ACTIONS(11411),
    [sym__type_order_operator] = ACTIONS(11411),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym__terminator_token1] = ACTIONS(11413),
    [aux_sym__terminator_token2] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8221] = {
    [sym_block_comment] = STATE(8221),
    [sym_line_comment] = STATE(8221),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11458),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11458),
    [anon_sym_RPAREN] = ACTIONS(11458),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11458),
    [anon_sym_RBRACK] = ACTIONS(11458),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_SEMI] = ACTIONS(11458),
    [anon_sym_LBRACE] = ACTIONS(11458),
    [anon_sym_RBRACE] = ACTIONS(11458),
    [anon_sym_DOLLAR] = ACTIONS(11458),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11458),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11458),
    [anon_sym_QMARK] = ACTIONS(11458),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11458),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11458),
    [aux_sym_integer_literal_token2] = ACTIONS(11458),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11458),
    [aux_sym_float_literal_token3] = ACTIONS(11458),
    [aux_sym_float_literal_token4] = ACTIONS(11458),
    [sym_character_literal] = ACTIONS(11458),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11458),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11458),
    [sym__pair_operator] = ACTIONS(11458),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11458),
    [sym__lazy_and_operator] = ACTIONS(11458),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11458),
    [sym__pipe_left_operator] = ACTIONS(11458),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11458),
    [sym__bitshift_operator] = ACTIONS(11458),
    [sym__power_operator] = ACTIONS(11458),
    [sym__tilde_operator] = ACTIONS(11458),
    [sym__type_order_operator] = ACTIONS(11458),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8222] = {
    [sym_block_comment] = STATE(8222),
    [sym_line_comment] = STATE(8222),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11285),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11285),
    [anon_sym_RPAREN] = ACTIONS(11285),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11285),
    [anon_sym_RBRACK] = ACTIONS(11285),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_SEMI] = ACTIONS(11285),
    [anon_sym_LBRACE] = ACTIONS(11285),
    [anon_sym_RBRACE] = ACTIONS(11285),
    [anon_sym_DOLLAR] = ACTIONS(11285),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11285),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11285),
    [anon_sym_QMARK] = ACTIONS(11285),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11285),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11285),
    [aux_sym_integer_literal_token2] = ACTIONS(11285),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11285),
    [aux_sym_float_literal_token3] = ACTIONS(11285),
    [aux_sym_float_literal_token4] = ACTIONS(11285),
    [sym_character_literal] = ACTIONS(11285),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11285),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11285),
    [sym__pair_operator] = ACTIONS(11285),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11285),
    [sym__lazy_and_operator] = ACTIONS(11285),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11285),
    [sym__pipe_left_operator] = ACTIONS(11285),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11285),
    [sym__bitshift_operator] = ACTIONS(11285),
    [sym__power_operator] = ACTIONS(11285),
    [sym__tilde_operator] = ACTIONS(11285),
    [sym__type_order_operator] = ACTIONS(11285),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8223] = {
    [sym_block_comment] = STATE(8223),
    [sym_line_comment] = STATE(8223),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10850),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_finally] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8224] = {
    [sym_block_comment] = STATE(8224),
    [sym_line_comment] = STATE(8224),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8225] = {
    [sym_block_comment] = STATE(8225),
    [sym_line_comment] = STATE(8225),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8226] = {
    [sym_block_comment] = STATE(8226),
    [sym_line_comment] = STATE(8226),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8227] = {
    [sym_block_comment] = STATE(8227),
    [sym_line_comment] = STATE(8227),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11223),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_end] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_catch] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11223),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11223),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11223),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11223),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11223),
    [anon_sym_QMARK] = ACTIONS(11223),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11223),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11223),
    [aux_sym_integer_literal_token2] = ACTIONS(11223),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11223),
    [aux_sym_float_literal_token3] = ACTIONS(11223),
    [aux_sym_float_literal_token4] = ACTIONS(11223),
    [sym_character_literal] = ACTIONS(11223),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11223),
    [sym__pair_operator] = ACTIONS(11223),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11223),
    [sym__lazy_and_operator] = ACTIONS(11223),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11223),
    [sym__pipe_left_operator] = ACTIONS(11223),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11223),
    [sym__bitshift_operator] = ACTIONS(11223),
    [sym__power_operator] = ACTIONS(11223),
    [sym__tilde_operator] = ACTIONS(11223),
    [sym__type_order_operator] = ACTIONS(11223),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym__terminator_token1] = ACTIONS(11225),
    [aux_sym__terminator_token2] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8228] = {
    [sym_block_comment] = STATE(8228),
    [sym_line_comment] = STATE(8228),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_end] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_finally] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym__terminator_token1] = ACTIONS(11900),
    [aux_sym__terminator_token2] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8229] = {
    [sym_block_comment] = STATE(8229),
    [sym_line_comment] = STATE(8229),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11173),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_end] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_finally] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11173),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11173),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11173),
    [anon_sym_DOLLAR] = ACTIONS(11173),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11173),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11173),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11173),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11173),
    [aux_sym_integer_literal_token2] = ACTIONS(11173),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11173),
    [aux_sym_float_literal_token3] = ACTIONS(11173),
    [aux_sym_float_literal_token4] = ACTIONS(11173),
    [sym_character_literal] = ACTIONS(11173),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11173),
    [sym__pair_operator] = ACTIONS(11173),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11173),
    [sym__lazy_and_operator] = ACTIONS(11173),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11173),
    [sym__pipe_left_operator] = ACTIONS(11173),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11173),
    [sym__bitshift_operator] = ACTIONS(11173),
    [sym__power_operator] = ACTIONS(11173),
    [sym__tilde_operator] = ACTIONS(11173),
    [sym__type_order_operator] = ACTIONS(11173),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym__terminator_token1] = ACTIONS(11175),
    [aux_sym__terminator_token2] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8230] = {
    [sym_block_comment] = STATE(8230),
    [sym_line_comment] = STATE(8230),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8231] = {
    [sym_block_comment] = STATE(8231),
    [sym_line_comment] = STATE(8231),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10204),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9656),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8232] = {
    [sym_block_comment] = STATE(8232),
    [sym_line_comment] = STATE(8232),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10204),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [8233] = {
    [sym_block_comment] = STATE(8233),
    [sym_line_comment] = STATE(8233),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8234] = {
    [sym_block_comment] = STATE(8234),
    [sym_line_comment] = STATE(8234),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11517),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_end] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_finally] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11517),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11517),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11517),
    [anon_sym_DOLLAR] = ACTIONS(11517),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11517),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11517),
    [anon_sym_QMARK] = ACTIONS(11517),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11517),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11517),
    [aux_sym_integer_literal_token2] = ACTIONS(11517),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11517),
    [aux_sym_float_literal_token3] = ACTIONS(11517),
    [aux_sym_float_literal_token4] = ACTIONS(11517),
    [sym_character_literal] = ACTIONS(11517),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11517),
    [sym__pair_operator] = ACTIONS(11517),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11517),
    [sym__lazy_and_operator] = ACTIONS(11517),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11517),
    [sym__pipe_left_operator] = ACTIONS(11517),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11517),
    [sym__bitshift_operator] = ACTIONS(11517),
    [sym__power_operator] = ACTIONS(11517),
    [sym__tilde_operator] = ACTIONS(11517),
    [sym__type_order_operator] = ACTIONS(11517),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym__terminator_token1] = ACTIONS(11519),
    [aux_sym__terminator_token2] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8235] = {
    [sym_block_comment] = STATE(8235),
    [sym_line_comment] = STATE(8235),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11924),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_end] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_finally] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11924),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11924),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11924),
    [anon_sym_DOLLAR] = ACTIONS(11924),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11924),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11924),
    [anon_sym_QMARK] = ACTIONS(11924),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11924),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11924),
    [aux_sym_integer_literal_token2] = ACTIONS(11924),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11924),
    [aux_sym_float_literal_token3] = ACTIONS(11924),
    [aux_sym_float_literal_token4] = ACTIONS(11924),
    [sym_character_literal] = ACTIONS(11924),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11924),
    [sym__pair_operator] = ACTIONS(11924),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11924),
    [sym__lazy_and_operator] = ACTIONS(11924),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11924),
    [sym__pipe_left_operator] = ACTIONS(11924),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11924),
    [sym__bitshift_operator] = ACTIONS(11924),
    [sym__power_operator] = ACTIONS(11924),
    [sym__tilde_operator] = ACTIONS(11924),
    [sym__type_order_operator] = ACTIONS(11924),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym__terminator_token1] = ACTIONS(11926),
    [aux_sym__terminator_token2] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8236] = {
    [sym_block_comment] = STATE(8236),
    [sym_line_comment] = STATE(8236),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11941),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_end] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_finally] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11941),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11941),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11941),
    [anon_sym_DOLLAR] = ACTIONS(11941),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11941),
    [anon_sym_QMARK] = ACTIONS(11941),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11941),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11941),
    [aux_sym_integer_literal_token2] = ACTIONS(11941),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11941),
    [aux_sym_float_literal_token3] = ACTIONS(11941),
    [aux_sym_float_literal_token4] = ACTIONS(11941),
    [sym_character_literal] = ACTIONS(11941),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11941),
    [sym__pair_operator] = ACTIONS(11941),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11941),
    [sym__lazy_and_operator] = ACTIONS(11941),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11941),
    [sym__pipe_left_operator] = ACTIONS(11941),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11941),
    [sym__bitshift_operator] = ACTIONS(11941),
    [sym__power_operator] = ACTIONS(11941),
    [sym__tilde_operator] = ACTIONS(11941),
    [sym__type_order_operator] = ACTIONS(11941),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym__terminator_token1] = ACTIONS(11943),
    [aux_sym__terminator_token2] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8237] = {
    [sym_block_comment] = STATE(8237),
    [sym_line_comment] = STATE(8237),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11965),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_end] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_finally] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11965),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11965),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11965),
    [anon_sym_DOLLAR] = ACTIONS(11965),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11965),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11965),
    [anon_sym_QMARK] = ACTIONS(11965),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11965),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11965),
    [aux_sym_integer_literal_token2] = ACTIONS(11965),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11965),
    [aux_sym_float_literal_token3] = ACTIONS(11965),
    [aux_sym_float_literal_token4] = ACTIONS(11965),
    [sym_character_literal] = ACTIONS(11965),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11965),
    [sym__pair_operator] = ACTIONS(11965),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11965),
    [sym__lazy_and_operator] = ACTIONS(11965),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11965),
    [sym__pipe_left_operator] = ACTIONS(11965),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11965),
    [sym__bitshift_operator] = ACTIONS(11965),
    [sym__power_operator] = ACTIONS(11965),
    [sym__tilde_operator] = ACTIONS(11965),
    [sym__type_order_operator] = ACTIONS(11965),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym__terminator_token1] = ACTIONS(11967),
    [aux_sym__terminator_token2] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8238] = {
    [sym_block_comment] = STATE(8238),
    [sym_line_comment] = STATE(8238),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11969),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_end] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_finally] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11969),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11969),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11969),
    [anon_sym_DOLLAR] = ACTIONS(11969),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11969),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11969),
    [anon_sym_QMARK] = ACTIONS(11969),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11969),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11969),
    [aux_sym_integer_literal_token2] = ACTIONS(11969),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11969),
    [aux_sym_float_literal_token3] = ACTIONS(11969),
    [aux_sym_float_literal_token4] = ACTIONS(11969),
    [sym_character_literal] = ACTIONS(11969),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11969),
    [sym__pair_operator] = ACTIONS(11969),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11969),
    [sym__lazy_and_operator] = ACTIONS(11969),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11969),
    [sym__pipe_left_operator] = ACTIONS(11969),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11969),
    [sym__bitshift_operator] = ACTIONS(11969),
    [sym__power_operator] = ACTIONS(11969),
    [sym__tilde_operator] = ACTIONS(11969),
    [sym__type_order_operator] = ACTIONS(11969),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym__terminator_token1] = ACTIONS(11971),
    [aux_sym__terminator_token2] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8239] = {
    [sym_block_comment] = STATE(8239),
    [sym_line_comment] = STATE(8239),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12050),
    [aux_sym__terminator_token2] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8240] = {
    [sym_block_comment] = STATE(8240),
    [sym_line_comment] = STATE(8240),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_end] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_finally] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [aux_sym__terminator_token2] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8241] = {
    [sym_block_comment] = STATE(8241),
    [sym_line_comment] = STATE(8241),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11033),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_end] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_finally] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11033),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11033),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11033),
    [anon_sym_DOLLAR] = ACTIONS(11033),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11033),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11033),
    [anon_sym_QMARK] = ACTIONS(11033),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11033),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11033),
    [aux_sym_integer_literal_token2] = ACTIONS(11033),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11033),
    [aux_sym_float_literal_token3] = ACTIONS(11033),
    [aux_sym_float_literal_token4] = ACTIONS(11033),
    [sym_character_literal] = ACTIONS(11033),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11033),
    [sym__pair_operator] = ACTIONS(11033),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11033),
    [sym__lazy_and_operator] = ACTIONS(11033),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11033),
    [sym__pipe_left_operator] = ACTIONS(11033),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11033),
    [sym__bitshift_operator] = ACTIONS(11033),
    [sym__power_operator] = ACTIONS(11033),
    [sym__tilde_operator] = ACTIONS(11033),
    [sym__type_order_operator] = ACTIONS(11033),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym__terminator_token1] = ACTIONS(11035),
    [aux_sym__terminator_token2] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8242] = {
    [sym_block_comment] = STATE(8242),
    [sym_line_comment] = STATE(8242),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11039),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_end] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_finally] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11039),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11039),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11039),
    [anon_sym_DOLLAR] = ACTIONS(11039),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11039),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11039),
    [anon_sym_QMARK] = ACTIONS(11039),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11039),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11039),
    [aux_sym_integer_literal_token2] = ACTIONS(11039),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11039),
    [aux_sym_float_literal_token3] = ACTIONS(11039),
    [aux_sym_float_literal_token4] = ACTIONS(11039),
    [sym_character_literal] = ACTIONS(11039),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11039),
    [sym__pair_operator] = ACTIONS(11039),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11039),
    [sym__lazy_and_operator] = ACTIONS(11039),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11039),
    [sym__pipe_left_operator] = ACTIONS(11039),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11039),
    [sym__bitshift_operator] = ACTIONS(11039),
    [sym__power_operator] = ACTIONS(11039),
    [sym__tilde_operator] = ACTIONS(11039),
    [sym__type_order_operator] = ACTIONS(11039),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym__terminator_token1] = ACTIONS(11041),
    [aux_sym__terminator_token2] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8243] = {
    [sym_block_comment] = STATE(8243),
    [sym_line_comment] = STATE(8243),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11043),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_end] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_finally] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11043),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11043),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11043),
    [anon_sym_DOLLAR] = ACTIONS(11043),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11043),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11043),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11043),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11043),
    [aux_sym_integer_literal_token2] = ACTIONS(11043),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11043),
    [aux_sym_float_literal_token3] = ACTIONS(11043),
    [aux_sym_float_literal_token4] = ACTIONS(11043),
    [sym_character_literal] = ACTIONS(11043),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11043),
    [sym__pair_operator] = ACTIONS(11043),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11043),
    [sym__lazy_and_operator] = ACTIONS(11043),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11043),
    [sym__pipe_left_operator] = ACTIONS(11043),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11043),
    [sym__bitshift_operator] = ACTIONS(11043),
    [sym__power_operator] = ACTIONS(11043),
    [sym__tilde_operator] = ACTIONS(11043),
    [sym__type_order_operator] = ACTIONS(11043),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym__terminator_token1] = ACTIONS(11045),
    [aux_sym__terminator_token2] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8244] = {
    [sym_block_comment] = STATE(8244),
    [sym_line_comment] = STATE(8244),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11116),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_end] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_finally] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11116),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11116),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11116),
    [anon_sym_DOLLAR] = ACTIONS(11116),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11116),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11116),
    [anon_sym_QMARK] = ACTIONS(11116),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11116),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11116),
    [aux_sym_integer_literal_token2] = ACTIONS(11116),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11116),
    [aux_sym_float_literal_token3] = ACTIONS(11116),
    [aux_sym_float_literal_token4] = ACTIONS(11116),
    [sym_character_literal] = ACTIONS(11116),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11116),
    [sym__pair_operator] = ACTIONS(11116),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11116),
    [sym__lazy_and_operator] = ACTIONS(11116),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11116),
    [sym__pipe_left_operator] = ACTIONS(11116),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11116),
    [sym__bitshift_operator] = ACTIONS(11116),
    [sym__power_operator] = ACTIONS(11116),
    [sym__tilde_operator] = ACTIONS(11116),
    [sym__type_order_operator] = ACTIONS(11116),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym__terminator_token1] = ACTIONS(11118),
    [aux_sym__terminator_token2] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8245] = {
    [sym_block_comment] = STATE(8245),
    [sym_line_comment] = STATE(8245),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11120),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_end] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_finally] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11120),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11120),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11120),
    [anon_sym_DOLLAR] = ACTIONS(11120),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11120),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11120),
    [anon_sym_QMARK] = ACTIONS(11120),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11120),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11120),
    [aux_sym_integer_literal_token2] = ACTIONS(11120),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11120),
    [aux_sym_float_literal_token3] = ACTIONS(11120),
    [aux_sym_float_literal_token4] = ACTIONS(11120),
    [sym_character_literal] = ACTIONS(11120),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11120),
    [sym__pair_operator] = ACTIONS(11120),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11120),
    [sym__lazy_and_operator] = ACTIONS(11120),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11120),
    [sym__pipe_left_operator] = ACTIONS(11120),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11120),
    [sym__bitshift_operator] = ACTIONS(11120),
    [sym__power_operator] = ACTIONS(11120),
    [sym__tilde_operator] = ACTIONS(11120),
    [sym__type_order_operator] = ACTIONS(11120),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym__terminator_token1] = ACTIONS(11122),
    [aux_sym__terminator_token2] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8246] = {
    [sym_block_comment] = STATE(8246),
    [sym_line_comment] = STATE(8246),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11197),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_end] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_finally] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11197),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11197),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11197),
    [anon_sym_DOLLAR] = ACTIONS(11197),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11197),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11197),
    [anon_sym_QMARK] = ACTIONS(11197),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11197),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11197),
    [aux_sym_integer_literal_token2] = ACTIONS(11197),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11197),
    [aux_sym_float_literal_token3] = ACTIONS(11197),
    [aux_sym_float_literal_token4] = ACTIONS(11197),
    [sym_character_literal] = ACTIONS(11197),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11197),
    [sym__pair_operator] = ACTIONS(11197),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11197),
    [sym__lazy_and_operator] = ACTIONS(11197),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11197),
    [sym__pipe_left_operator] = ACTIONS(11197),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11197),
    [sym__bitshift_operator] = ACTIONS(11197),
    [sym__power_operator] = ACTIONS(11197),
    [sym__tilde_operator] = ACTIONS(11197),
    [sym__type_order_operator] = ACTIONS(11197),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym__terminator_token1] = ACTIONS(11199),
    [aux_sym__terminator_token2] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8247] = {
    [sym_block_comment] = STATE(8247),
    [sym_line_comment] = STATE(8247),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_finally] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11211),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOLLAR] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11211),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11211),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11211),
    [aux_sym_integer_literal_token2] = ACTIONS(11211),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11211),
    [aux_sym_float_literal_token3] = ACTIONS(11211),
    [aux_sym_float_literal_token4] = ACTIONS(11211),
    [sym_character_literal] = ACTIONS(11211),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11211),
    [sym__pair_operator] = ACTIONS(11211),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11211),
    [sym__lazy_and_operator] = ACTIONS(11211),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11211),
    [sym__pipe_left_operator] = ACTIONS(11211),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11211),
    [sym__bitshift_operator] = ACTIONS(11211),
    [sym__power_operator] = ACTIONS(11211),
    [sym__tilde_operator] = ACTIONS(11211),
    [sym__type_order_operator] = ACTIONS(11211),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym__terminator_token1] = ACTIONS(11213),
    [aux_sym__terminator_token2] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8248] = {
    [sym_block_comment] = STATE(8248),
    [sym_line_comment] = STATE(8248),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8249] = {
    [sym_block_comment] = STATE(8249),
    [sym_line_comment] = STATE(8249),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8250] = {
    [sym_block_comment] = STATE(8250),
    [sym_line_comment] = STATE(8250),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10978),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10978),
    [anon_sym_QMARK] = ACTIONS(10978),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10978),
    [sym__lazy_and_operator] = ACTIONS(10978),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10978),
    [sym__pipe_left_operator] = ACTIONS(10978),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10978),
    [sym__bitshift_operator] = ACTIONS(10978),
    [sym__power_operator] = ACTIONS(10978),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10978),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8251] = {
    [sym_block_comment] = STATE(8251),
    [sym_line_comment] = STATE(8251),
    [aux_sym_export_statement_repeat1] = STATE(8370),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10876),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10876),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10876),
    [anon_sym_DOLLAR] = ACTIONS(10876),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10876),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10876),
    [anon_sym_QMARK] = ACTIONS(10876),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10876),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10876),
    [aux_sym_integer_literal_token2] = ACTIONS(10876),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10876),
    [aux_sym_float_literal_token3] = ACTIONS(10876),
    [aux_sym_float_literal_token4] = ACTIONS(10876),
    [sym_character_literal] = ACTIONS(10876),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10876),
    [sym__pair_operator] = ACTIONS(10876),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10876),
    [sym__lazy_and_operator] = ACTIONS(10876),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10876),
    [sym__pipe_left_operator] = ACTIONS(10876),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10876),
    [sym__bitshift_operator] = ACTIONS(10876),
    [sym__power_operator] = ACTIONS(10876),
    [sym__tilde_operator] = ACTIONS(10876),
    [sym__type_order_operator] = ACTIONS(10876),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym__terminator_token1] = ACTIONS(10878),
    [aux_sym__terminator_token2] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8252] = {
    [sym_block_comment] = STATE(8252),
    [sym_line_comment] = STATE(8252),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(9804),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8253] = {
    [sym_block_comment] = STATE(8253),
    [sym_line_comment] = STATE(8253),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
  },
  [8254] = {
    [sym_block_comment] = STATE(8254),
    [sym_line_comment] = STATE(8254),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11251),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_catch] = ACTIONS(11251),
    [anon_sym_finally] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11251),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11251),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11251),
    [anon_sym_DOLLAR] = ACTIONS(11251),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11251),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11251),
    [anon_sym_QMARK] = ACTIONS(11251),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11251),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11251),
    [aux_sym_integer_literal_token2] = ACTIONS(11251),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11251),
    [aux_sym_float_literal_token3] = ACTIONS(11251),
    [aux_sym_float_literal_token4] = ACTIONS(11251),
    [sym_character_literal] = ACTIONS(11251),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11251),
    [sym__pair_operator] = ACTIONS(11251),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11251),
    [sym__lazy_and_operator] = ACTIONS(11251),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11251),
    [sym__pipe_left_operator] = ACTIONS(11251),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11251),
    [sym__bitshift_operator] = ACTIONS(11251),
    [sym__power_operator] = ACTIONS(11251),
    [sym__tilde_operator] = ACTIONS(11251),
    [sym__type_order_operator] = ACTIONS(11251),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym__terminator_token1] = ACTIONS(11253),
    [aux_sym__terminator_token2] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8255] = {
    [sym_block_comment] = STATE(8255),
    [sym_line_comment] = STATE(8255),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11269),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_end] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_finally] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11269),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11269),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11269),
    [anon_sym_DOLLAR] = ACTIONS(11269),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11269),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11269),
    [anon_sym_QMARK] = ACTIONS(11269),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11269),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11269),
    [aux_sym_integer_literal_token2] = ACTIONS(11269),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11269),
    [aux_sym_float_literal_token3] = ACTIONS(11269),
    [aux_sym_float_literal_token4] = ACTIONS(11269),
    [sym_character_literal] = ACTIONS(11269),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11269),
    [sym__pair_operator] = ACTIONS(11269),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11269),
    [sym__lazy_and_operator] = ACTIONS(11269),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11269),
    [sym__pipe_left_operator] = ACTIONS(11269),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11269),
    [sym__bitshift_operator] = ACTIONS(11269),
    [sym__power_operator] = ACTIONS(11269),
    [sym__tilde_operator] = ACTIONS(11269),
    [sym__type_order_operator] = ACTIONS(11269),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym__terminator_token1] = ACTIONS(11271),
    [aux_sym__terminator_token2] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8256] = {
    [sym_block_comment] = STATE(8256),
    [sym_line_comment] = STATE(8256),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11259),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_catch] = ACTIONS(11259),
    [anon_sym_finally] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11259),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11259),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11259),
    [anon_sym_DOLLAR] = ACTIONS(11259),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11259),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11259),
    [anon_sym_QMARK] = ACTIONS(11259),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11259),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11259),
    [aux_sym_integer_literal_token2] = ACTIONS(11259),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11259),
    [aux_sym_float_literal_token3] = ACTIONS(11259),
    [aux_sym_float_literal_token4] = ACTIONS(11259),
    [sym_character_literal] = ACTIONS(11259),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11259),
    [sym__pair_operator] = ACTIONS(11259),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11259),
    [sym__lazy_and_operator] = ACTIONS(11259),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11259),
    [sym__pipe_left_operator] = ACTIONS(11259),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11259),
    [sym__bitshift_operator] = ACTIONS(11259),
    [sym__power_operator] = ACTIONS(11259),
    [sym__tilde_operator] = ACTIONS(11259),
    [sym__type_order_operator] = ACTIONS(11259),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym__terminator_token1] = ACTIONS(11261),
    [aux_sym__terminator_token2] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8257] = {
    [sym_block_comment] = STATE(8257),
    [sym_line_comment] = STATE(8257),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_end] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_finally] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11279),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11279),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11279),
    [anon_sym_DOLLAR] = ACTIONS(11279),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11279),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11279),
    [anon_sym_QMARK] = ACTIONS(11279),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11279),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11279),
    [aux_sym_integer_literal_token2] = ACTIONS(11279),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11279),
    [aux_sym_float_literal_token3] = ACTIONS(11279),
    [aux_sym_float_literal_token4] = ACTIONS(11279),
    [sym_character_literal] = ACTIONS(11279),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11279),
    [sym__pair_operator] = ACTIONS(11279),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11279),
    [sym__lazy_and_operator] = ACTIONS(11279),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11279),
    [sym__pipe_left_operator] = ACTIONS(11279),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11279),
    [sym__bitshift_operator] = ACTIONS(11279),
    [sym__power_operator] = ACTIONS(11279),
    [sym__tilde_operator] = ACTIONS(11279),
    [sym__type_order_operator] = ACTIONS(11279),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym__terminator_token1] = ACTIONS(11281),
    [aux_sym__terminator_token2] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8258] = {
    [sym_block_comment] = STATE(8258),
    [sym_line_comment] = STATE(8258),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11309),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_end] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_finally] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11309),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11309),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11309),
    [anon_sym_DOLLAR] = ACTIONS(11309),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11309),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11309),
    [anon_sym_QMARK] = ACTIONS(11309),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11309),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11309),
    [aux_sym_integer_literal_token2] = ACTIONS(11309),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11309),
    [aux_sym_float_literal_token3] = ACTIONS(11309),
    [aux_sym_float_literal_token4] = ACTIONS(11309),
    [sym_character_literal] = ACTIONS(11309),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11309),
    [sym__pair_operator] = ACTIONS(11309),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11309),
    [sym__lazy_and_operator] = ACTIONS(11309),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11309),
    [sym__pipe_left_operator] = ACTIONS(11309),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11309),
    [sym__bitshift_operator] = ACTIONS(11309),
    [sym__power_operator] = ACTIONS(11309),
    [sym__tilde_operator] = ACTIONS(11309),
    [sym__type_order_operator] = ACTIONS(11309),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym__terminator_token1] = ACTIONS(11311),
    [aux_sym__terminator_token2] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8259] = {
    [sym_block_comment] = STATE(8259),
    [sym_line_comment] = STATE(8259),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8260] = {
    [sym_block_comment] = STATE(8260),
    [sym_line_comment] = STATE(8260),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8261] = {
    [sym_block_comment] = STATE(8261),
    [sym_line_comment] = STATE(8261),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8262] = {
    [sym_block_comment] = STATE(8262),
    [sym_line_comment] = STATE(8262),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11223),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_catch] = ACTIONS(11223),
    [anon_sym_finally] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11223),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11223),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11223),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11223),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11223),
    [anon_sym_QMARK] = ACTIONS(11223),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11223),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11223),
    [aux_sym_integer_literal_token2] = ACTIONS(11223),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11223),
    [aux_sym_float_literal_token3] = ACTIONS(11223),
    [aux_sym_float_literal_token4] = ACTIONS(11223),
    [sym_character_literal] = ACTIONS(11223),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11223),
    [sym__pair_operator] = ACTIONS(11223),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11223),
    [sym__lazy_and_operator] = ACTIONS(11223),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11223),
    [sym__pipe_left_operator] = ACTIONS(11223),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11223),
    [sym__bitshift_operator] = ACTIONS(11223),
    [sym__power_operator] = ACTIONS(11223),
    [sym__tilde_operator] = ACTIONS(11223),
    [sym__type_order_operator] = ACTIONS(11223),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym__terminator_token1] = ACTIONS(11225),
    [aux_sym__terminator_token2] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8263] = {
    [sym_block_comment] = STATE(8263),
    [sym_line_comment] = STATE(8263),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8264] = {
    [sym_block_comment] = STATE(8264),
    [sym_line_comment] = STATE(8264),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8265] = {
    [sym_block_comment] = STATE(8265),
    [sym_line_comment] = STATE(8265),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8266] = {
    [sym_block_comment] = STATE(8266),
    [sym_line_comment] = STATE(8266),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8267] = {
    [sym_block_comment] = STATE(8267),
    [sym_line_comment] = STATE(8267),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11317),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_end] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_finally] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11317),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11317),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11317),
    [anon_sym_DOLLAR] = ACTIONS(11317),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11317),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11317),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11317),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11317),
    [aux_sym_integer_literal_token2] = ACTIONS(11317),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11317),
    [aux_sym_float_literal_token3] = ACTIONS(11317),
    [aux_sym_float_literal_token4] = ACTIONS(11317),
    [sym_character_literal] = ACTIONS(11317),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11317),
    [sym__pair_operator] = ACTIONS(11317),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11317),
    [sym__lazy_and_operator] = ACTIONS(11317),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11317),
    [sym__pipe_left_operator] = ACTIONS(11317),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11317),
    [sym__bitshift_operator] = ACTIONS(11317),
    [sym__power_operator] = ACTIONS(11317),
    [sym__tilde_operator] = ACTIONS(11317),
    [sym__type_order_operator] = ACTIONS(11317),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym__terminator_token1] = ACTIONS(11319),
    [aux_sym__terminator_token2] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8268] = {
    [sym_block_comment] = STATE(8268),
    [sym_line_comment] = STATE(8268),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8269] = {
    [sym_block_comment] = STATE(8269),
    [sym_line_comment] = STATE(8269),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11359),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_end] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_finally] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11359),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11359),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11359),
    [anon_sym_DOLLAR] = ACTIONS(11359),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11359),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11359),
    [anon_sym_QMARK] = ACTIONS(11359),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11359),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11359),
    [aux_sym_integer_literal_token2] = ACTIONS(11359),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11359),
    [aux_sym_float_literal_token3] = ACTIONS(11359),
    [aux_sym_float_literal_token4] = ACTIONS(11359),
    [sym_character_literal] = ACTIONS(11359),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11359),
    [sym__pair_operator] = ACTIONS(11359),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11359),
    [sym__lazy_and_operator] = ACTIONS(11359),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11359),
    [sym__pipe_left_operator] = ACTIONS(11359),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11359),
    [sym__bitshift_operator] = ACTIONS(11359),
    [sym__power_operator] = ACTIONS(11359),
    [sym__tilde_operator] = ACTIONS(11359),
    [sym__type_order_operator] = ACTIONS(11359),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym__terminator_token1] = ACTIONS(11361),
    [aux_sym__terminator_token2] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8270] = {
    [sym_block_comment] = STATE(8270),
    [sym_line_comment] = STATE(8270),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8271] = {
    [sym_block_comment] = STATE(8271),
    [sym_line_comment] = STATE(8271),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11381),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_end] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_finally] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11381),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11381),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11381),
    [anon_sym_DOLLAR] = ACTIONS(11381),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11381),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11381),
    [anon_sym_QMARK] = ACTIONS(11381),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11381),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11381),
    [aux_sym_integer_literal_token2] = ACTIONS(11381),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11381),
    [aux_sym_float_literal_token3] = ACTIONS(11381),
    [aux_sym_float_literal_token4] = ACTIONS(11381),
    [sym_character_literal] = ACTIONS(11381),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11381),
    [sym__pair_operator] = ACTIONS(11381),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11381),
    [sym__lazy_and_operator] = ACTIONS(11381),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11381),
    [sym__pipe_left_operator] = ACTIONS(11381),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11381),
    [sym__bitshift_operator] = ACTIONS(11381),
    [sym__power_operator] = ACTIONS(11381),
    [sym__tilde_operator] = ACTIONS(11381),
    [sym__type_order_operator] = ACTIONS(11381),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym__terminator_token1] = ACTIONS(11383),
    [aux_sym__terminator_token2] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8272] = {
    [sym_block_comment] = STATE(8272),
    [sym_line_comment] = STATE(8272),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11407),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_end] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_finally] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11407),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11407),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11407),
    [anon_sym_DOLLAR] = ACTIONS(11407),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11407),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11407),
    [anon_sym_QMARK] = ACTIONS(11407),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11407),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11407),
    [aux_sym_integer_literal_token2] = ACTIONS(11407),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11407),
    [aux_sym_float_literal_token3] = ACTIONS(11407),
    [aux_sym_float_literal_token4] = ACTIONS(11407),
    [sym_character_literal] = ACTIONS(11407),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11407),
    [sym__pair_operator] = ACTIONS(11407),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11407),
    [sym__lazy_and_operator] = ACTIONS(11407),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11407),
    [sym__pipe_left_operator] = ACTIONS(11407),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11407),
    [sym__bitshift_operator] = ACTIONS(11407),
    [sym__power_operator] = ACTIONS(11407),
    [sym__tilde_operator] = ACTIONS(11407),
    [sym__type_order_operator] = ACTIONS(11407),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym__terminator_token1] = ACTIONS(11409),
    [aux_sym__terminator_token2] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8273] = {
    [sym_block_comment] = STATE(8273),
    [sym_line_comment] = STATE(8273),
    [aux_sym_export_statement_repeat1] = STATE(8370),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(12164),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_end] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10880),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10880),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10880),
    [anon_sym_DOLLAR] = ACTIONS(10880),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10880),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10880),
    [anon_sym_QMARK] = ACTIONS(10880),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10880),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10880),
    [aux_sym_integer_literal_token2] = ACTIONS(10880),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10880),
    [aux_sym_float_literal_token3] = ACTIONS(10880),
    [aux_sym_float_literal_token4] = ACTIONS(10880),
    [sym_character_literal] = ACTIONS(10880),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10880),
    [sym__pair_operator] = ACTIONS(10880),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10880),
    [sym__lazy_and_operator] = ACTIONS(10880),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10880),
    [sym__pipe_left_operator] = ACTIONS(10880),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10880),
    [sym__bitshift_operator] = ACTIONS(10880),
    [sym__power_operator] = ACTIONS(10880),
    [sym__tilde_operator] = ACTIONS(10880),
    [sym__type_order_operator] = ACTIONS(10880),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym__terminator_token1] = ACTIONS(10882),
    [aux_sym__terminator_token2] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8274] = {
    [sym_block_comment] = STATE(8274),
    [sym_line_comment] = STATE(8274),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8275] = {
    [sym_block_comment] = STATE(8275),
    [sym_line_comment] = STATE(8275),
    [aux_sym__import_list_repeat1] = STATE(8373),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(11215),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_end] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10884),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10884),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10884),
    [anon_sym_DOLLAR] = ACTIONS(10884),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10884),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10884),
    [anon_sym_QMARK] = ACTIONS(10884),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10884),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10884),
    [aux_sym_integer_literal_token2] = ACTIONS(10884),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10884),
    [aux_sym_float_literal_token3] = ACTIONS(10884),
    [aux_sym_float_literal_token4] = ACTIONS(10884),
    [sym_character_literal] = ACTIONS(10884),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10884),
    [sym__pair_operator] = ACTIONS(10884),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10884),
    [sym__lazy_and_operator] = ACTIONS(10884),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10884),
    [sym__pipe_left_operator] = ACTIONS(10884),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10884),
    [sym__bitshift_operator] = ACTIONS(10884),
    [sym__power_operator] = ACTIONS(10884),
    [sym__tilde_operator] = ACTIONS(10884),
    [sym__type_order_operator] = ACTIONS(10884),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym__terminator_token1] = ACTIONS(10886),
    [aux_sym__terminator_token2] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8276] = {
    [sym_block_comment] = STATE(8276),
    [sym_line_comment] = STATE(8276),
    [ts_builtin_sym_end] = ACTIONS(10763),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_RBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8277] = {
    [sym_block_comment] = STATE(8277),
    [sym_line_comment] = STATE(8277),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_catch] = ACTIONS(11112),
    [anon_sym_finally] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8278] = {
    [sym_block_comment] = STATE(8278),
    [sym_line_comment] = STATE(8278),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11291),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_catch] = ACTIONS(11291),
    [anon_sym_finally] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11291),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11291),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11291),
    [anon_sym_DOLLAR] = ACTIONS(11291),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11291),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11291),
    [anon_sym_QMARK] = ACTIONS(11291),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11291),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11291),
    [aux_sym_integer_literal_token2] = ACTIONS(11291),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11291),
    [aux_sym_float_literal_token3] = ACTIONS(11291),
    [aux_sym_float_literal_token4] = ACTIONS(11291),
    [sym_character_literal] = ACTIONS(11291),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11291),
    [sym__pair_operator] = ACTIONS(11291),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11291),
    [sym__lazy_and_operator] = ACTIONS(11291),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11291),
    [sym__pipe_left_operator] = ACTIONS(11291),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11291),
    [sym__bitshift_operator] = ACTIONS(11291),
    [sym__power_operator] = ACTIONS(11291),
    [sym__tilde_operator] = ACTIONS(11291),
    [sym__type_order_operator] = ACTIONS(11291),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym__terminator_token1] = ACTIONS(11293),
    [aux_sym__terminator_token2] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8279] = {
    [sym_block_comment] = STATE(8279),
    [sym_line_comment] = STATE(8279),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11305),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_catch] = ACTIONS(11305),
    [anon_sym_finally] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11305),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11305),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11305),
    [anon_sym_DOLLAR] = ACTIONS(11305),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11305),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11305),
    [anon_sym_QMARK] = ACTIONS(11305),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11305),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11305),
    [aux_sym_integer_literal_token2] = ACTIONS(11305),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11305),
    [aux_sym_float_literal_token3] = ACTIONS(11305),
    [aux_sym_float_literal_token4] = ACTIONS(11305),
    [sym_character_literal] = ACTIONS(11305),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11305),
    [sym__pair_operator] = ACTIONS(11305),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11305),
    [sym__lazy_and_operator] = ACTIONS(11305),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11305),
    [sym__pipe_left_operator] = ACTIONS(11305),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11305),
    [sym__bitshift_operator] = ACTIONS(11305),
    [sym__power_operator] = ACTIONS(11305),
    [sym__tilde_operator] = ACTIONS(11305),
    [sym__type_order_operator] = ACTIONS(11305),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym__terminator_token1] = ACTIONS(11307),
    [aux_sym__terminator_token2] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8280] = {
    [sym_block_comment] = STATE(8280),
    [sym_line_comment] = STATE(8280),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11456),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_end] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_finally] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11456),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11456),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11456),
    [anon_sym_DOLLAR] = ACTIONS(11456),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11456),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11456),
    [anon_sym_QMARK] = ACTIONS(11456),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11456),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11456),
    [aux_sym_integer_literal_token2] = ACTIONS(11456),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11456),
    [aux_sym_float_literal_token3] = ACTIONS(11456),
    [aux_sym_float_literal_token4] = ACTIONS(11456),
    [sym_character_literal] = ACTIONS(11456),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11456),
    [sym__pair_operator] = ACTIONS(11456),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11456),
    [sym__lazy_and_operator] = ACTIONS(11456),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11456),
    [sym__pipe_left_operator] = ACTIONS(11456),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11456),
    [sym__bitshift_operator] = ACTIONS(11456),
    [sym__power_operator] = ACTIONS(11456),
    [sym__tilde_operator] = ACTIONS(11456),
    [sym__type_order_operator] = ACTIONS(11456),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym__terminator_token1] = ACTIONS(11458),
    [aux_sym__terminator_token2] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8281] = {
    [sym_block_comment] = STATE(8281),
    [sym_line_comment] = STATE(8281),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11283),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_end] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_finally] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11283),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11283),
    [anon_sym_DOLLAR] = ACTIONS(11283),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11283),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11283),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11283),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11283),
    [aux_sym_integer_literal_token2] = ACTIONS(11283),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11283),
    [aux_sym_float_literal_token3] = ACTIONS(11283),
    [aux_sym_float_literal_token4] = ACTIONS(11283),
    [sym_character_literal] = ACTIONS(11283),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11283),
    [sym__pair_operator] = ACTIONS(11283),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11283),
    [sym__lazy_and_operator] = ACTIONS(11283),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11283),
    [sym__pipe_left_operator] = ACTIONS(11283),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11283),
    [sym__bitshift_operator] = ACTIONS(11283),
    [sym__power_operator] = ACTIONS(11283),
    [sym__tilde_operator] = ACTIONS(11283),
    [sym__type_order_operator] = ACTIONS(11283),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym__terminator_token1] = ACTIONS(11285),
    [aux_sym__terminator_token2] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8282] = {
    [sym_block_comment] = STATE(8282),
    [sym_line_comment] = STATE(8282),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(11022),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8283] = {
    [sym_block_comment] = STATE(8283),
    [sym_line_comment] = STATE(8283),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_catch] = ACTIONS(11265),
    [anon_sym_finally] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8284] = {
    [sym_block_comment] = STATE(8284),
    [sym_line_comment] = STATE(8284),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_RBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_SEMI] = ACTIONS(10976),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_RBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8285] = {
    [sym_block_comment] = STATE(8285),
    [sym_line_comment] = STATE(8285),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11169),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_catch] = ACTIONS(11169),
    [anon_sym_finally] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11169),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11169),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11169),
    [anon_sym_DOLLAR] = ACTIONS(11169),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11169),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11169),
    [anon_sym_QMARK] = ACTIONS(11169),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11169),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11169),
    [aux_sym_integer_literal_token2] = ACTIONS(11169),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11169),
    [aux_sym_float_literal_token3] = ACTIONS(11169),
    [aux_sym_float_literal_token4] = ACTIONS(11169),
    [sym_character_literal] = ACTIONS(11169),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11169),
    [sym__pair_operator] = ACTIONS(11169),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11169),
    [sym__lazy_and_operator] = ACTIONS(11169),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11169),
    [sym__pipe_left_operator] = ACTIONS(11169),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11169),
    [sym__bitshift_operator] = ACTIONS(11169),
    [sym__power_operator] = ACTIONS(11169),
    [sym__tilde_operator] = ACTIONS(11169),
    [sym__type_order_operator] = ACTIONS(11169),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym__terminator_token1] = ACTIONS(11171),
    [aux_sym__terminator_token2] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8286] = {
    [sym_block_comment] = STATE(8286),
    [sym_line_comment] = STATE(8286),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8287] = {
    [sym_block_comment] = STATE(8287),
    [sym_line_comment] = STATE(8287),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_catch] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8288] = {
    [sym_block_comment] = STATE(8288),
    [sym_line_comment] = STATE(8288),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(9966),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8289] = {
    [sym_block_comment] = STATE(8289),
    [sym_line_comment] = STATE(8289),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8290] = {
    [sym_block_comment] = STATE(8290),
    [sym_line_comment] = STATE(8290),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8291] = {
    [sym_block_comment] = STATE(8291),
    [sym_line_comment] = STATE(8291),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11472),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_catch] = ACTIONS(11472),
    [anon_sym_finally] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11472),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11472),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11472),
    [anon_sym_DOLLAR] = ACTIONS(11472),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11472),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11472),
    [anon_sym_QMARK] = ACTIONS(11472),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11472),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11472),
    [aux_sym_integer_literal_token2] = ACTIONS(11472),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11472),
    [aux_sym_float_literal_token3] = ACTIONS(11472),
    [aux_sym_float_literal_token4] = ACTIONS(11472),
    [sym_character_literal] = ACTIONS(11472),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11472),
    [sym__pair_operator] = ACTIONS(11472),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11472),
    [sym__lazy_and_operator] = ACTIONS(11472),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11472),
    [sym__pipe_left_operator] = ACTIONS(11472),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11472),
    [sym__bitshift_operator] = ACTIONS(11472),
    [sym__power_operator] = ACTIONS(11472),
    [sym__tilde_operator] = ACTIONS(11472),
    [sym__type_order_operator] = ACTIONS(11472),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym__terminator_token1] = ACTIONS(11474),
    [aux_sym__terminator_token2] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8292] = {
    [sym_block_comment] = STATE(8292),
    [sym_line_comment] = STATE(8292),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11499),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_catch] = ACTIONS(11499),
    [anon_sym_finally] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11499),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11499),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11499),
    [anon_sym_DOLLAR] = ACTIONS(11499),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11499),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11499),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11499),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11499),
    [aux_sym_integer_literal_token2] = ACTIONS(11499),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11499),
    [aux_sym_float_literal_token3] = ACTIONS(11499),
    [aux_sym_float_literal_token4] = ACTIONS(11499),
    [sym_character_literal] = ACTIONS(11499),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11499),
    [sym__pair_operator] = ACTIONS(11499),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11499),
    [sym__lazy_and_operator] = ACTIONS(11499),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11499),
    [sym__pipe_left_operator] = ACTIONS(11499),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11499),
    [sym__bitshift_operator] = ACTIONS(11499),
    [sym__power_operator] = ACTIONS(11499),
    [sym__tilde_operator] = ACTIONS(11499),
    [sym__type_order_operator] = ACTIONS(11499),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym__terminator_token1] = ACTIONS(11501),
    [aux_sym__terminator_token2] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8293] = {
    [sym_block_comment] = STATE(8293),
    [sym_line_comment] = STATE(8293),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11513),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_catch] = ACTIONS(11513),
    [anon_sym_finally] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11513),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11513),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11513),
    [anon_sym_DOLLAR] = ACTIONS(11513),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11513),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11513),
    [anon_sym_QMARK] = ACTIONS(11513),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11513),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11513),
    [aux_sym_integer_literal_token2] = ACTIONS(11513),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11513),
    [aux_sym_float_literal_token3] = ACTIONS(11513),
    [aux_sym_float_literal_token4] = ACTIONS(11513),
    [sym_character_literal] = ACTIONS(11513),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11513),
    [sym__pair_operator] = ACTIONS(11513),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11513),
    [sym__lazy_and_operator] = ACTIONS(11513),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11513),
    [sym__pipe_left_operator] = ACTIONS(11513),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11513),
    [sym__bitshift_operator] = ACTIONS(11513),
    [sym__power_operator] = ACTIONS(11513),
    [sym__tilde_operator] = ACTIONS(11513),
    [sym__type_order_operator] = ACTIONS(11513),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym__terminator_token1] = ACTIONS(11515),
    [aux_sym__terminator_token2] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8294] = {
    [sym_block_comment] = STATE(8294),
    [sym_line_comment] = STATE(8294),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11526),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_catch] = ACTIONS(11526),
    [anon_sym_finally] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11526),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11526),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11526),
    [anon_sym_DOLLAR] = ACTIONS(11526),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11526),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11526),
    [anon_sym_QMARK] = ACTIONS(11526),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11526),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11526),
    [aux_sym_integer_literal_token2] = ACTIONS(11526),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11526),
    [aux_sym_float_literal_token3] = ACTIONS(11526),
    [aux_sym_float_literal_token4] = ACTIONS(11526),
    [sym_character_literal] = ACTIONS(11526),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11526),
    [sym__pair_operator] = ACTIONS(11526),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11526),
    [sym__lazy_and_operator] = ACTIONS(11526),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11526),
    [sym__pipe_left_operator] = ACTIONS(11526),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11526),
    [sym__bitshift_operator] = ACTIONS(11526),
    [sym__power_operator] = ACTIONS(11526),
    [sym__tilde_operator] = ACTIONS(11526),
    [sym__type_order_operator] = ACTIONS(11526),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym__terminator_token1] = ACTIONS(11528),
    [aux_sym__terminator_token2] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8295] = {
    [sym_block_comment] = STATE(8295),
    [sym_line_comment] = STATE(8295),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11530),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_catch] = ACTIONS(11530),
    [anon_sym_finally] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11530),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11530),
    [anon_sym_DOLLAR] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11530),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11530),
    [anon_sym_QMARK] = ACTIONS(11530),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11530),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11530),
    [aux_sym_integer_literal_token2] = ACTIONS(11530),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11530),
    [aux_sym_float_literal_token3] = ACTIONS(11530),
    [aux_sym_float_literal_token4] = ACTIONS(11530),
    [sym_character_literal] = ACTIONS(11530),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11530),
    [sym__pair_operator] = ACTIONS(11530),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11530),
    [sym__lazy_and_operator] = ACTIONS(11530),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11530),
    [sym__pipe_left_operator] = ACTIONS(11530),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11530),
    [sym__bitshift_operator] = ACTIONS(11530),
    [sym__power_operator] = ACTIONS(11530),
    [sym__tilde_operator] = ACTIONS(11530),
    [sym__type_order_operator] = ACTIONS(11530),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym__terminator_token1] = ACTIONS(11532),
    [aux_sym__terminator_token2] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8296] = {
    [sym_block_comment] = STATE(8296),
    [sym_line_comment] = STATE(8296),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11534),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_catch] = ACTIONS(11534),
    [anon_sym_finally] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11534),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11534),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11534),
    [anon_sym_DOLLAR] = ACTIONS(11534),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11534),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11534),
    [anon_sym_QMARK] = ACTIONS(11534),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11534),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11534),
    [aux_sym_integer_literal_token2] = ACTIONS(11534),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11534),
    [aux_sym_float_literal_token3] = ACTIONS(11534),
    [aux_sym_float_literal_token4] = ACTIONS(11534),
    [sym_character_literal] = ACTIONS(11534),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11534),
    [sym__pair_operator] = ACTIONS(11534),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11534),
    [sym__lazy_and_operator] = ACTIONS(11534),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11534),
    [sym__pipe_left_operator] = ACTIONS(11534),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11534),
    [sym__bitshift_operator] = ACTIONS(11534),
    [sym__power_operator] = ACTIONS(11534),
    [sym__tilde_operator] = ACTIONS(11534),
    [sym__type_order_operator] = ACTIONS(11534),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym__terminator_token1] = ACTIONS(11536),
    [aux_sym__terminator_token2] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8297] = {
    [sym_block_comment] = STATE(8297),
    [sym_line_comment] = STATE(8297),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11548),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_catch] = ACTIONS(11548),
    [anon_sym_finally] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11548),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11548),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11548),
    [anon_sym_DOLLAR] = ACTIONS(11548),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11548),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11548),
    [anon_sym_QMARK] = ACTIONS(11548),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11548),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11548),
    [aux_sym_integer_literal_token2] = ACTIONS(11548),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11548),
    [aux_sym_float_literal_token3] = ACTIONS(11548),
    [aux_sym_float_literal_token4] = ACTIONS(11548),
    [sym_character_literal] = ACTIONS(11548),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11548),
    [sym__pair_operator] = ACTIONS(11548),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11548),
    [sym__lazy_and_operator] = ACTIONS(11548),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11548),
    [sym__pipe_left_operator] = ACTIONS(11548),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11548),
    [sym__bitshift_operator] = ACTIONS(11548),
    [sym__power_operator] = ACTIONS(11548),
    [sym__tilde_operator] = ACTIONS(11548),
    [sym__type_order_operator] = ACTIONS(11548),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym__terminator_token1] = ACTIONS(11550),
    [aux_sym__terminator_token2] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8298] = {
    [sym_block_comment] = STATE(8298),
    [sym_line_comment] = STATE(8298),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11552),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_catch] = ACTIONS(11552),
    [anon_sym_finally] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11552),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11552),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11552),
    [anon_sym_DOLLAR] = ACTIONS(11552),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11552),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11552),
    [anon_sym_QMARK] = ACTIONS(11552),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11552),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11552),
    [aux_sym_integer_literal_token2] = ACTIONS(11552),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11552),
    [aux_sym_float_literal_token3] = ACTIONS(11552),
    [aux_sym_float_literal_token4] = ACTIONS(11552),
    [sym_character_literal] = ACTIONS(11552),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11552),
    [sym__pair_operator] = ACTIONS(11552),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11552),
    [sym__lazy_and_operator] = ACTIONS(11552),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11552),
    [sym__pipe_left_operator] = ACTIONS(11552),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11552),
    [sym__bitshift_operator] = ACTIONS(11552),
    [sym__power_operator] = ACTIONS(11552),
    [sym__tilde_operator] = ACTIONS(11552),
    [sym__type_order_operator] = ACTIONS(11552),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym__terminator_token1] = ACTIONS(11554),
    [aux_sym__terminator_token2] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8299] = {
    [sym_block_comment] = STATE(8299),
    [sym_line_comment] = STATE(8299),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11559),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_catch] = ACTIONS(11559),
    [anon_sym_finally] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11559),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11559),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11559),
    [anon_sym_DOLLAR] = ACTIONS(11559),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11559),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11559),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11559),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11559),
    [aux_sym_integer_literal_token2] = ACTIONS(11559),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11559),
    [aux_sym_float_literal_token3] = ACTIONS(11559),
    [aux_sym_float_literal_token4] = ACTIONS(11559),
    [sym_character_literal] = ACTIONS(11559),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11559),
    [sym__pair_operator] = ACTIONS(11559),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11559),
    [sym__lazy_and_operator] = ACTIONS(11559),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11559),
    [sym__pipe_left_operator] = ACTIONS(11559),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11559),
    [sym__bitshift_operator] = ACTIONS(11559),
    [sym__power_operator] = ACTIONS(11559),
    [sym__tilde_operator] = ACTIONS(11559),
    [sym__type_order_operator] = ACTIONS(11559),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym__terminator_token1] = ACTIONS(11561),
    [aux_sym__terminator_token2] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8300] = {
    [sym_block_comment] = STATE(8300),
    [sym_line_comment] = STATE(8300),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11563),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_catch] = ACTIONS(11563),
    [anon_sym_finally] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11563),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11563),
    [anon_sym_DOLLAR] = ACTIONS(11563),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11563),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_QMARK] = ACTIONS(11563),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11563),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11563),
    [aux_sym_integer_literal_token2] = ACTIONS(11563),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11563),
    [aux_sym_float_literal_token3] = ACTIONS(11563),
    [aux_sym_float_literal_token4] = ACTIONS(11563),
    [sym_character_literal] = ACTIONS(11563),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11563),
    [sym__pair_operator] = ACTIONS(11563),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11563),
    [sym__lazy_and_operator] = ACTIONS(11563),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11563),
    [sym__pipe_left_operator] = ACTIONS(11563),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11563),
    [sym__bitshift_operator] = ACTIONS(11563),
    [sym__power_operator] = ACTIONS(11563),
    [sym__tilde_operator] = ACTIONS(11563),
    [sym__type_order_operator] = ACTIONS(11563),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym__terminator_token1] = ACTIONS(11565),
    [aux_sym__terminator_token2] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8301] = {
    [sym_block_comment] = STATE(8301),
    [sym_line_comment] = STATE(8301),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11567),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_catch] = ACTIONS(11567),
    [anon_sym_finally] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11567),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11567),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11567),
    [anon_sym_DOLLAR] = ACTIONS(11567),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11567),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11567),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11567),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11567),
    [aux_sym_integer_literal_token2] = ACTIONS(11567),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11567),
    [aux_sym_float_literal_token3] = ACTIONS(11567),
    [aux_sym_float_literal_token4] = ACTIONS(11567),
    [sym_character_literal] = ACTIONS(11567),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11567),
    [sym__pair_operator] = ACTIONS(11567),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11567),
    [sym__lazy_and_operator] = ACTIONS(11567),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11567),
    [sym__pipe_left_operator] = ACTIONS(11567),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11567),
    [sym__bitshift_operator] = ACTIONS(11567),
    [sym__power_operator] = ACTIONS(11567),
    [sym__tilde_operator] = ACTIONS(11567),
    [sym__type_order_operator] = ACTIONS(11567),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym__terminator_token1] = ACTIONS(11569),
    [aux_sym__terminator_token2] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8302] = {
    [sym_block_comment] = STATE(8302),
    [sym_line_comment] = STATE(8302),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11571),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_catch] = ACTIONS(11571),
    [anon_sym_finally] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11571),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11571),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11571),
    [anon_sym_DOLLAR] = ACTIONS(11571),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11571),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_QMARK] = ACTIONS(11571),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11571),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11571),
    [aux_sym_integer_literal_token2] = ACTIONS(11571),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11571),
    [aux_sym_float_literal_token3] = ACTIONS(11571),
    [aux_sym_float_literal_token4] = ACTIONS(11571),
    [sym_character_literal] = ACTIONS(11571),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11571),
    [sym__pair_operator] = ACTIONS(11571),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11571),
    [sym__lazy_and_operator] = ACTIONS(11571),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11571),
    [sym__pipe_left_operator] = ACTIONS(11571),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11571),
    [sym__bitshift_operator] = ACTIONS(11571),
    [sym__power_operator] = ACTIONS(11571),
    [sym__tilde_operator] = ACTIONS(11571),
    [sym__type_order_operator] = ACTIONS(11571),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym__terminator_token1] = ACTIONS(11573),
    [aux_sym__terminator_token2] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8303] = {
    [sym_block_comment] = STATE(8303),
    [sym_line_comment] = STATE(8303),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8304] = {
    [sym_block_comment] = STATE(8304),
    [sym_line_comment] = STATE(8304),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8305] = {
    [sym_block_comment] = STATE(8305),
    [sym_line_comment] = STATE(8305),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8306] = {
    [sym_block_comment] = STATE(8306),
    [sym_line_comment] = STATE(8306),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8307] = {
    [sym_block_comment] = STATE(8307),
    [sym_line_comment] = STATE(8307),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_catch] = ACTIONS(10761),
    [anon_sym_finally] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8308] = {
    [sym_block_comment] = STATE(8308),
    [sym_line_comment] = STATE(8308),
    [ts_builtin_sym_end] = ACTIONS(11277),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_RBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8309] = {
    [sym_block_comment] = STATE(8309),
    [sym_line_comment] = STATE(8309),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(12175),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8310] = {
    [sym_block_comment] = STATE(8310),
    [sym_line_comment] = STATE(8310),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_else] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_finally] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12179),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(12179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12179),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12179),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8311] = {
    [sym_block_comment] = STATE(8311),
    [sym_line_comment] = STATE(8311),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11108),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8312] = {
    [sym_block_comment] = STATE(8312),
    [sym_line_comment] = STATE(8312),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_catch] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11247),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11247),
    [anon_sym_QMARK] = ACTIONS(11247),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11247),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11247),
    [sym__lazy_and_operator] = ACTIONS(11247),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11247),
    [sym__pipe_left_operator] = ACTIONS(11247),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11247),
    [sym__bitshift_operator] = ACTIONS(11247),
    [sym__power_operator] = ACTIONS(11247),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11247),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8313] = {
    [sym_block_comment] = STATE(8313),
    [sym_line_comment] = STATE(8313),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8314] = {
    [sym_block_comment] = STATE(8314),
    [sym_line_comment] = STATE(8314),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11331),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_catch] = ACTIONS(11331),
    [anon_sym_finally] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11331),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11331),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11331),
    [anon_sym_DOLLAR] = ACTIONS(11331),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11331),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11331),
    [anon_sym_QMARK] = ACTIONS(11331),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11331),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11331),
    [aux_sym_integer_literal_token2] = ACTIONS(11331),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11331),
    [aux_sym_float_literal_token3] = ACTIONS(11331),
    [aux_sym_float_literal_token4] = ACTIONS(11331),
    [sym_character_literal] = ACTIONS(11331),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11331),
    [sym__pair_operator] = ACTIONS(11331),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11331),
    [sym__lazy_and_operator] = ACTIONS(11331),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11331),
    [sym__pipe_left_operator] = ACTIONS(11331),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11331),
    [sym__bitshift_operator] = ACTIONS(11331),
    [sym__power_operator] = ACTIONS(11331),
    [sym__tilde_operator] = ACTIONS(11331),
    [sym__type_order_operator] = ACTIONS(11331),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym__terminator_token1] = ACTIONS(11333),
    [aux_sym__terminator_token2] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8315] = {
    [sym_block_comment] = STATE(8315),
    [sym_line_comment] = STATE(8315),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_catch] = ACTIONS(11335),
    [anon_sym_finally] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11335),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_DOLLAR] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11335),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11335),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11335),
    [aux_sym_integer_literal_token2] = ACTIONS(11335),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11335),
    [aux_sym_float_literal_token3] = ACTIONS(11335),
    [aux_sym_float_literal_token4] = ACTIONS(11335),
    [sym_character_literal] = ACTIONS(11335),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11335),
    [sym__pair_operator] = ACTIONS(11335),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11335),
    [sym__lazy_and_operator] = ACTIONS(11335),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11335),
    [sym__pipe_left_operator] = ACTIONS(11335),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11335),
    [sym__bitshift_operator] = ACTIONS(11335),
    [sym__power_operator] = ACTIONS(11335),
    [sym__tilde_operator] = ACTIONS(11335),
    [sym__type_order_operator] = ACTIONS(11335),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym__terminator_token1] = ACTIONS(11337),
    [aux_sym__terminator_token2] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8316] = {
    [sym_block_comment] = STATE(8316),
    [sym_line_comment] = STATE(8316),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_catch] = ACTIONS(11339),
    [anon_sym_finally] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11339),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11339),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11339),
    [anon_sym_DOLLAR] = ACTIONS(11339),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11339),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(11339),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11339),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11339),
    [aux_sym_integer_literal_token2] = ACTIONS(11339),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11339),
    [aux_sym_float_literal_token3] = ACTIONS(11339),
    [aux_sym_float_literal_token4] = ACTIONS(11339),
    [sym_character_literal] = ACTIONS(11339),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11339),
    [sym__pair_operator] = ACTIONS(11339),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11339),
    [sym__lazy_and_operator] = ACTIONS(11339),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11339),
    [sym__pipe_left_operator] = ACTIONS(11339),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11339),
    [sym__bitshift_operator] = ACTIONS(11339),
    [sym__power_operator] = ACTIONS(11339),
    [sym__tilde_operator] = ACTIONS(11339),
    [sym__type_order_operator] = ACTIONS(11339),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym__terminator_token1] = ACTIONS(11341),
    [aux_sym__terminator_token2] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8317] = {
    [sym_block_comment] = STATE(8317),
    [sym_line_comment] = STATE(8317),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11343),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_catch] = ACTIONS(11343),
    [anon_sym_finally] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11343),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11343),
    [anon_sym_DOLLAR] = ACTIONS(11343),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11343),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11343),
    [anon_sym_QMARK] = ACTIONS(11343),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11343),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11343),
    [aux_sym_integer_literal_token2] = ACTIONS(11343),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11343),
    [aux_sym_float_literal_token3] = ACTIONS(11343),
    [aux_sym_float_literal_token4] = ACTIONS(11343),
    [sym_character_literal] = ACTIONS(11343),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11343),
    [sym__pair_operator] = ACTIONS(11343),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11343),
    [sym__lazy_and_operator] = ACTIONS(11343),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11343),
    [sym__pipe_left_operator] = ACTIONS(11343),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11343),
    [sym__bitshift_operator] = ACTIONS(11343),
    [sym__power_operator] = ACTIONS(11343),
    [sym__tilde_operator] = ACTIONS(11343),
    [sym__type_order_operator] = ACTIONS(11343),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym__terminator_token1] = ACTIONS(11345),
    [aux_sym__terminator_token2] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8318] = {
    [sym_block_comment] = STATE(8318),
    [sym_line_comment] = STATE(8318),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11347),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_catch] = ACTIONS(11347),
    [anon_sym_finally] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11347),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11347),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11347),
    [anon_sym_DOLLAR] = ACTIONS(11347),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11347),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11347),
    [anon_sym_QMARK] = ACTIONS(11347),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11347),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11347),
    [aux_sym_integer_literal_token2] = ACTIONS(11347),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11347),
    [aux_sym_float_literal_token3] = ACTIONS(11347),
    [aux_sym_float_literal_token4] = ACTIONS(11347),
    [sym_character_literal] = ACTIONS(11347),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11347),
    [sym__pair_operator] = ACTIONS(11347),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11347),
    [sym__lazy_and_operator] = ACTIONS(11347),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11347),
    [sym__pipe_left_operator] = ACTIONS(11347),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11347),
    [sym__bitshift_operator] = ACTIONS(11347),
    [sym__power_operator] = ACTIONS(11347),
    [sym__tilde_operator] = ACTIONS(11347),
    [sym__type_order_operator] = ACTIONS(11347),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym__terminator_token1] = ACTIONS(11349),
    [aux_sym__terminator_token2] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8319] = {
    [sym_block_comment] = STATE(8319),
    [sym_line_comment] = STATE(8319),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11351),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_catch] = ACTIONS(11351),
    [anon_sym_finally] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11351),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11351),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11351),
    [anon_sym_DOLLAR] = ACTIONS(11351),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11351),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11351),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11351),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11351),
    [aux_sym_integer_literal_token2] = ACTIONS(11351),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11351),
    [aux_sym_float_literal_token3] = ACTIONS(11351),
    [aux_sym_float_literal_token4] = ACTIONS(11351),
    [sym_character_literal] = ACTIONS(11351),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11351),
    [sym__pair_operator] = ACTIONS(11351),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11351),
    [sym__lazy_and_operator] = ACTIONS(11351),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11351),
    [sym__pipe_left_operator] = ACTIONS(11351),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11351),
    [sym__bitshift_operator] = ACTIONS(11351),
    [sym__power_operator] = ACTIONS(11351),
    [sym__tilde_operator] = ACTIONS(11351),
    [sym__type_order_operator] = ACTIONS(11351),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym__terminator_token1] = ACTIONS(11353),
    [aux_sym__terminator_token2] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8320] = {
    [sym_block_comment] = STATE(8320),
    [sym_line_comment] = STATE(8320),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11355),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_catch] = ACTIONS(11355),
    [anon_sym_finally] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11355),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11355),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11355),
    [anon_sym_DOLLAR] = ACTIONS(11355),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11355),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_QMARK] = ACTIONS(11355),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11355),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11355),
    [aux_sym_integer_literal_token2] = ACTIONS(11355),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11355),
    [aux_sym_float_literal_token3] = ACTIONS(11355),
    [aux_sym_float_literal_token4] = ACTIONS(11355),
    [sym_character_literal] = ACTIONS(11355),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11355),
    [sym__pair_operator] = ACTIONS(11355),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11355),
    [sym__lazy_and_operator] = ACTIONS(11355),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11355),
    [sym__pipe_left_operator] = ACTIONS(11355),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11355),
    [sym__bitshift_operator] = ACTIONS(11355),
    [sym__power_operator] = ACTIONS(11355),
    [sym__tilde_operator] = ACTIONS(11355),
    [sym__type_order_operator] = ACTIONS(11355),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym__terminator_token1] = ACTIONS(11357),
    [aux_sym__terminator_token2] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8321] = {
    [sym_block_comment] = STATE(8321),
    [sym_line_comment] = STATE(8321),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11373),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_catch] = ACTIONS(11373),
    [anon_sym_finally] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11373),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11373),
    [anon_sym_DOLLAR] = ACTIONS(11373),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11373),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11373),
    [anon_sym_QMARK] = ACTIONS(11373),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11373),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11373),
    [aux_sym_integer_literal_token2] = ACTIONS(11373),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11373),
    [aux_sym_float_literal_token3] = ACTIONS(11373),
    [aux_sym_float_literal_token4] = ACTIONS(11373),
    [sym_character_literal] = ACTIONS(11373),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11373),
    [sym__pair_operator] = ACTIONS(11373),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11373),
    [sym__lazy_and_operator] = ACTIONS(11373),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11373),
    [sym__pipe_left_operator] = ACTIONS(11373),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11373),
    [sym__bitshift_operator] = ACTIONS(11373),
    [sym__power_operator] = ACTIONS(11373),
    [sym__tilde_operator] = ACTIONS(11373),
    [sym__type_order_operator] = ACTIONS(11373),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym__terminator_token1] = ACTIONS(11375),
    [aux_sym__terminator_token2] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8322] = {
    [sym_block_comment] = STATE(8322),
    [sym_line_comment] = STATE(8322),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_catch] = ACTIONS(11377),
    [anon_sym_finally] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11377),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11377),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11377),
    [anon_sym_DOLLAR] = ACTIONS(11377),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11377),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11377),
    [anon_sym_QMARK] = ACTIONS(11377),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11377),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11377),
    [aux_sym_integer_literal_token2] = ACTIONS(11377),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11377),
    [aux_sym_float_literal_token3] = ACTIONS(11377),
    [aux_sym_float_literal_token4] = ACTIONS(11377),
    [sym_character_literal] = ACTIONS(11377),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11377),
    [sym__pair_operator] = ACTIONS(11377),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11377),
    [sym__lazy_and_operator] = ACTIONS(11377),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11377),
    [sym__pipe_left_operator] = ACTIONS(11377),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11377),
    [sym__bitshift_operator] = ACTIONS(11377),
    [sym__power_operator] = ACTIONS(11377),
    [sym__tilde_operator] = ACTIONS(11377),
    [sym__type_order_operator] = ACTIONS(11377),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym__terminator_token1] = ACTIONS(11379),
    [aux_sym__terminator_token2] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8323] = {
    [sym_block_comment] = STATE(8323),
    [sym_line_comment] = STATE(8323),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_catch] = ACTIONS(11385),
    [anon_sym_finally] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11385),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11385),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11385),
    [anon_sym_DOLLAR] = ACTIONS(11385),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11385),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11385),
    [anon_sym_QMARK] = ACTIONS(11385),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11385),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11385),
    [aux_sym_integer_literal_token2] = ACTIONS(11385),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11385),
    [aux_sym_float_literal_token3] = ACTIONS(11385),
    [aux_sym_float_literal_token4] = ACTIONS(11385),
    [sym_character_literal] = ACTIONS(11385),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11385),
    [sym__pair_operator] = ACTIONS(11385),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11385),
    [sym__lazy_and_operator] = ACTIONS(11385),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11385),
    [sym__pipe_left_operator] = ACTIONS(11385),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11385),
    [sym__bitshift_operator] = ACTIONS(11385),
    [sym__power_operator] = ACTIONS(11385),
    [sym__tilde_operator] = ACTIONS(11385),
    [sym__type_order_operator] = ACTIONS(11385),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym__terminator_token1] = ACTIONS(11387),
    [aux_sym__terminator_token2] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8324] = {
    [sym_block_comment] = STATE(8324),
    [sym_line_comment] = STATE(8324),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11399),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_catch] = ACTIONS(11399),
    [anon_sym_finally] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11399),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11399),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11399),
    [anon_sym_DOLLAR] = ACTIONS(11399),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11399),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11399),
    [anon_sym_QMARK] = ACTIONS(11399),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11399),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11399),
    [aux_sym_integer_literal_token2] = ACTIONS(11399),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11399),
    [aux_sym_float_literal_token3] = ACTIONS(11399),
    [aux_sym_float_literal_token4] = ACTIONS(11399),
    [sym_character_literal] = ACTIONS(11399),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11399),
    [sym__pair_operator] = ACTIONS(11399),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11399),
    [sym__lazy_and_operator] = ACTIONS(11399),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11399),
    [sym__pipe_left_operator] = ACTIONS(11399),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11399),
    [sym__bitshift_operator] = ACTIONS(11399),
    [sym__power_operator] = ACTIONS(11399),
    [sym__tilde_operator] = ACTIONS(11399),
    [sym__type_order_operator] = ACTIONS(11399),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym__terminator_token1] = ACTIONS(11401),
    [aux_sym__terminator_token2] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8325] = {
    [sym_block_comment] = STATE(8325),
    [sym_line_comment] = STATE(8325),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_catch] = ACTIONS(11403),
    [anon_sym_finally] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11403),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11403),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11403),
    [anon_sym_DOLLAR] = ACTIONS(11403),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11403),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11403),
    [anon_sym_QMARK] = ACTIONS(11403),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11403),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11403),
    [aux_sym_integer_literal_token2] = ACTIONS(11403),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11403),
    [aux_sym_float_literal_token3] = ACTIONS(11403),
    [aux_sym_float_literal_token4] = ACTIONS(11403),
    [sym_character_literal] = ACTIONS(11403),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11403),
    [sym__pair_operator] = ACTIONS(11403),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11403),
    [sym__lazy_and_operator] = ACTIONS(11403),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11403),
    [sym__pipe_left_operator] = ACTIONS(11403),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11403),
    [sym__bitshift_operator] = ACTIONS(11403),
    [sym__power_operator] = ACTIONS(11403),
    [sym__tilde_operator] = ACTIONS(11403),
    [sym__type_order_operator] = ACTIONS(11403),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym__terminator_token1] = ACTIONS(11405),
    [aux_sym__terminator_token2] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8326] = {
    [sym_block_comment] = STATE(8326),
    [sym_line_comment] = STATE(8326),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11255),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_catch] = ACTIONS(11255),
    [anon_sym_finally] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11255),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11255),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11255),
    [anon_sym_DOLLAR] = ACTIONS(11255),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11255),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11255),
    [anon_sym_QMARK] = ACTIONS(11255),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11255),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11255),
    [aux_sym_integer_literal_token2] = ACTIONS(11255),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11255),
    [aux_sym_float_literal_token3] = ACTIONS(11255),
    [aux_sym_float_literal_token4] = ACTIONS(11255),
    [sym_character_literal] = ACTIONS(11255),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11255),
    [sym__pair_operator] = ACTIONS(11255),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11255),
    [sym__lazy_and_operator] = ACTIONS(11255),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11255),
    [sym__pipe_left_operator] = ACTIONS(11255),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11255),
    [sym__bitshift_operator] = ACTIONS(11255),
    [sym__power_operator] = ACTIONS(11255),
    [sym__tilde_operator] = ACTIONS(11255),
    [sym__type_order_operator] = ACTIONS(11255),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym__terminator_token1] = ACTIONS(11257),
    [aux_sym__terminator_token2] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8327] = {
    [sym_block_comment] = STATE(8327),
    [sym_line_comment] = STATE(8327),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11411),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_catch] = ACTIONS(11411),
    [anon_sym_finally] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11411),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11411),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11411),
    [anon_sym_DOLLAR] = ACTIONS(11411),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11411),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11411),
    [anon_sym_QMARK] = ACTIONS(11411),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11411),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11411),
    [aux_sym_integer_literal_token2] = ACTIONS(11411),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11411),
    [aux_sym_float_literal_token3] = ACTIONS(11411),
    [aux_sym_float_literal_token4] = ACTIONS(11411),
    [sym_character_literal] = ACTIONS(11411),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11411),
    [sym__pair_operator] = ACTIONS(11411),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11411),
    [sym__lazy_and_operator] = ACTIONS(11411),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11411),
    [sym__pipe_left_operator] = ACTIONS(11411),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11411),
    [sym__bitshift_operator] = ACTIONS(11411),
    [sym__power_operator] = ACTIONS(11411),
    [sym__tilde_operator] = ACTIONS(11411),
    [sym__type_order_operator] = ACTIONS(11411),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym__terminator_token1] = ACTIONS(11413),
    [aux_sym__terminator_token2] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8328] = {
    [sym_block_comment] = STATE(8328),
    [sym_line_comment] = STATE(8328),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_RBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_SEMI] = ACTIONS(11022),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_RBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8329] = {
    [sym_block_comment] = STATE(8329),
    [sym_line_comment] = STATE(8329),
    [ts_builtin_sym_end] = ACTIONS(10910),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_RBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8330] = {
    [sym_block_comment] = STATE(8330),
    [sym_line_comment] = STATE(8330),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10850),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_catch] = ACTIONS(10850),
    [anon_sym_finally] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8331] = {
    [sym_block_comment] = STATE(8331),
    [sym_line_comment] = STATE(8331),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_catch] = ACTIONS(10861),
    [anon_sym_finally] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8332] = {
    [sym_block_comment] = STATE(8332),
    [sym_line_comment] = STATE(8332),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_catch] = ACTIONS(11898),
    [anon_sym_finally] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym__terminator_token1] = ACTIONS(11900),
    [aux_sym__terminator_token2] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8333] = {
    [sym_block_comment] = STATE(8333),
    [sym_line_comment] = STATE(8333),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8334] = {
    [sym_block_comment] = STATE(8334),
    [sym_line_comment] = STATE(8334),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11173),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_catch] = ACTIONS(11173),
    [anon_sym_finally] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11173),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11173),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11173),
    [anon_sym_DOLLAR] = ACTIONS(11173),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11173),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11173),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11173),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11173),
    [aux_sym_integer_literal_token2] = ACTIONS(11173),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11173),
    [aux_sym_float_literal_token3] = ACTIONS(11173),
    [aux_sym_float_literal_token4] = ACTIONS(11173),
    [sym_character_literal] = ACTIONS(11173),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11173),
    [sym__pair_operator] = ACTIONS(11173),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11173),
    [sym__lazy_and_operator] = ACTIONS(11173),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11173),
    [sym__pipe_left_operator] = ACTIONS(11173),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11173),
    [sym__bitshift_operator] = ACTIONS(11173),
    [sym__power_operator] = ACTIONS(11173),
    [sym__tilde_operator] = ACTIONS(11173),
    [sym__type_order_operator] = ACTIONS(11173),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym__terminator_token1] = ACTIONS(11175),
    [aux_sym__terminator_token2] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8335] = {
    [sym_block_comment] = STATE(8335),
    [sym_line_comment] = STATE(8335),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8336] = {
    [sym_block_comment] = STATE(8336),
    [sym_line_comment] = STATE(8336),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11517),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_catch] = ACTIONS(11517),
    [anon_sym_finally] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11517),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11517),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11517),
    [anon_sym_DOLLAR] = ACTIONS(11517),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11517),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11517),
    [anon_sym_QMARK] = ACTIONS(11517),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11517),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11517),
    [aux_sym_integer_literal_token2] = ACTIONS(11517),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11517),
    [aux_sym_float_literal_token3] = ACTIONS(11517),
    [aux_sym_float_literal_token4] = ACTIONS(11517),
    [sym_character_literal] = ACTIONS(11517),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11517),
    [sym__pair_operator] = ACTIONS(11517),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11517),
    [sym__lazy_and_operator] = ACTIONS(11517),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11517),
    [sym__pipe_left_operator] = ACTIONS(11517),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11517),
    [sym__bitshift_operator] = ACTIONS(11517),
    [sym__power_operator] = ACTIONS(11517),
    [sym__tilde_operator] = ACTIONS(11517),
    [sym__type_order_operator] = ACTIONS(11517),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym__terminator_token1] = ACTIONS(11519),
    [aux_sym__terminator_token2] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8337] = {
    [sym_block_comment] = STATE(8337),
    [sym_line_comment] = STATE(8337),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12179),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(12179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(12197),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12199),
    [sym__arrow_operator] = ACTIONS(12201),
    [sym__lazy_or_operator] = ACTIONS(12203),
    [sym__lazy_and_operator] = ACTIONS(12205),
    [sym__comparison_operator] = ACTIONS(12179),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12179),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8338] = {
    [sym_block_comment] = STATE(8338),
    [sym_line_comment] = STATE(8338),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12179),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(12179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12197),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12201),
    [sym__lazy_or_operator] = ACTIONS(12203),
    [sym__lazy_and_operator] = ACTIONS(12205),
    [sym__comparison_operator] = ACTIONS(12179),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12179),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8339] = {
    [sym_block_comment] = STATE(8339),
    [sym_line_comment] = STATE(8339),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12179),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(12179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12197),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12205),
    [sym__comparison_operator] = ACTIONS(12179),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12179),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8340] = {
    [sym_block_comment] = STATE(8340),
    [sym_line_comment] = STATE(8340),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12179),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(12179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12197),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12179),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12179),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8341] = {
    [sym_block_comment] = STATE(8341),
    [sym_line_comment] = STATE(8341),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8342] = {
    [sym_block_comment] = STATE(8342),
    [sym_line_comment] = STATE(8342),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8343] = {
    [sym_block_comment] = STATE(8343),
    [sym_line_comment] = STATE(8343),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8344] = {
    [sym_block_comment] = STATE(8344),
    [sym_line_comment] = STATE(8344),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8345] = {
    [sym_block_comment] = STATE(8345),
    [sym_line_comment] = STATE(8345),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8346] = {
    [sym_block_comment] = STATE(8346),
    [sym_line_comment] = STATE(8346),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8347] = {
    [sym_block_comment] = STATE(8347),
    [sym_line_comment] = STATE(8347),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8348] = {
    [sym_block_comment] = STATE(8348),
    [sym_line_comment] = STATE(8348),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_catch] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8349] = {
    [sym_block_comment] = STATE(8349),
    [sym_line_comment] = STATE(8349),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_finally] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8350] = {
    [sym_block_comment] = STATE(8350),
    [sym_line_comment] = STATE(8350),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11924),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_catch] = ACTIONS(11924),
    [anon_sym_finally] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11924),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11924),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11924),
    [anon_sym_DOLLAR] = ACTIONS(11924),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11924),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11924),
    [anon_sym_QMARK] = ACTIONS(11924),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11924),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11924),
    [aux_sym_integer_literal_token2] = ACTIONS(11924),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11924),
    [aux_sym_float_literal_token3] = ACTIONS(11924),
    [aux_sym_float_literal_token4] = ACTIONS(11924),
    [sym_character_literal] = ACTIONS(11924),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11924),
    [sym__pair_operator] = ACTIONS(11924),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11924),
    [sym__lazy_and_operator] = ACTIONS(11924),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11924),
    [sym__pipe_left_operator] = ACTIONS(11924),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11924),
    [sym__bitshift_operator] = ACTIONS(11924),
    [sym__power_operator] = ACTIONS(11924),
    [sym__tilde_operator] = ACTIONS(11924),
    [sym__type_order_operator] = ACTIONS(11924),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym__terminator_token1] = ACTIONS(11926),
    [aux_sym__terminator_token2] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8351] = {
    [sym_block_comment] = STATE(8351),
    [sym_line_comment] = STATE(8351),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11941),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_catch] = ACTIONS(11941),
    [anon_sym_finally] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11941),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11941),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11941),
    [anon_sym_DOLLAR] = ACTIONS(11941),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11941),
    [anon_sym_QMARK] = ACTIONS(11941),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11941),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11941),
    [aux_sym_integer_literal_token2] = ACTIONS(11941),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11941),
    [aux_sym_float_literal_token3] = ACTIONS(11941),
    [aux_sym_float_literal_token4] = ACTIONS(11941),
    [sym_character_literal] = ACTIONS(11941),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11941),
    [sym__pair_operator] = ACTIONS(11941),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11941),
    [sym__lazy_and_operator] = ACTIONS(11941),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11941),
    [sym__pipe_left_operator] = ACTIONS(11941),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11941),
    [sym__bitshift_operator] = ACTIONS(11941),
    [sym__power_operator] = ACTIONS(11941),
    [sym__tilde_operator] = ACTIONS(11941),
    [sym__type_order_operator] = ACTIONS(11941),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym__terminator_token1] = ACTIONS(11943),
    [aux_sym__terminator_token2] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8352] = {
    [sym_block_comment] = STATE(8352),
    [sym_line_comment] = STATE(8352),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9724),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9724),
    [anon_sym_QMARK] = ACTIONS(9724),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9724),
    [sym__lazy_and_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8353] = {
    [sym_block_comment] = STATE(8353),
    [sym_line_comment] = STATE(8353),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8354] = {
    [sym_block_comment] = STATE(8354),
    [sym_line_comment] = STATE(8354),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11965),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_catch] = ACTIONS(11965),
    [anon_sym_finally] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11965),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11965),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11965),
    [anon_sym_DOLLAR] = ACTIONS(11965),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11965),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11965),
    [anon_sym_QMARK] = ACTIONS(11965),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11965),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11965),
    [aux_sym_integer_literal_token2] = ACTIONS(11965),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11965),
    [aux_sym_float_literal_token3] = ACTIONS(11965),
    [aux_sym_float_literal_token4] = ACTIONS(11965),
    [sym_character_literal] = ACTIONS(11965),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11965),
    [sym__pair_operator] = ACTIONS(11965),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11965),
    [sym__lazy_and_operator] = ACTIONS(11965),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11965),
    [sym__pipe_left_operator] = ACTIONS(11965),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11965),
    [sym__bitshift_operator] = ACTIONS(11965),
    [sym__power_operator] = ACTIONS(11965),
    [sym__tilde_operator] = ACTIONS(11965),
    [sym__type_order_operator] = ACTIONS(11965),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym__terminator_token1] = ACTIONS(11967),
    [aux_sym__terminator_token2] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8355] = {
    [sym_block_comment] = STATE(8355),
    [sym_line_comment] = STATE(8355),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11969),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_catch] = ACTIONS(11969),
    [anon_sym_finally] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11969),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11969),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11969),
    [anon_sym_DOLLAR] = ACTIONS(11969),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11969),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11969),
    [anon_sym_QMARK] = ACTIONS(11969),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11969),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11969),
    [aux_sym_integer_literal_token2] = ACTIONS(11969),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11969),
    [aux_sym_float_literal_token3] = ACTIONS(11969),
    [aux_sym_float_literal_token4] = ACTIONS(11969),
    [sym_character_literal] = ACTIONS(11969),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11969),
    [sym__pair_operator] = ACTIONS(11969),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11969),
    [sym__lazy_and_operator] = ACTIONS(11969),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11969),
    [sym__pipe_left_operator] = ACTIONS(11969),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11969),
    [sym__bitshift_operator] = ACTIONS(11969),
    [sym__power_operator] = ACTIONS(11969),
    [sym__tilde_operator] = ACTIONS(11969),
    [sym__type_order_operator] = ACTIONS(11969),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym__terminator_token1] = ACTIONS(11971),
    [aux_sym__terminator_token2] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8356] = {
    [sym_block_comment] = STATE(8356),
    [sym_line_comment] = STATE(8356),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_catch] = ACTIONS(12048),
    [anon_sym_finally] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12050),
    [aux_sym__terminator_token2] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8357] = {
    [sym_block_comment] = STATE(8357),
    [sym_line_comment] = STATE(8357),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_catch] = ACTIONS(12052),
    [anon_sym_finally] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [aux_sym__terminator_token2] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8358] = {
    [sym_block_comment] = STATE(8358),
    [sym_line_comment] = STATE(8358),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11033),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_catch] = ACTIONS(11033),
    [anon_sym_finally] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11033),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11033),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11033),
    [anon_sym_DOLLAR] = ACTIONS(11033),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11033),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11033),
    [anon_sym_QMARK] = ACTIONS(11033),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11033),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11033),
    [aux_sym_integer_literal_token2] = ACTIONS(11033),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11033),
    [aux_sym_float_literal_token3] = ACTIONS(11033),
    [aux_sym_float_literal_token4] = ACTIONS(11033),
    [sym_character_literal] = ACTIONS(11033),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11033),
    [sym__pair_operator] = ACTIONS(11033),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11033),
    [sym__lazy_and_operator] = ACTIONS(11033),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11033),
    [sym__pipe_left_operator] = ACTIONS(11033),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11033),
    [sym__bitshift_operator] = ACTIONS(11033),
    [sym__power_operator] = ACTIONS(11033),
    [sym__tilde_operator] = ACTIONS(11033),
    [sym__type_order_operator] = ACTIONS(11033),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym__terminator_token1] = ACTIONS(11035),
    [aux_sym__terminator_token2] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8359] = {
    [sym_block_comment] = STATE(8359),
    [sym_line_comment] = STATE(8359),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11039),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_catch] = ACTIONS(11039),
    [anon_sym_finally] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11039),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11039),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11039),
    [anon_sym_DOLLAR] = ACTIONS(11039),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11039),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11039),
    [anon_sym_QMARK] = ACTIONS(11039),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11039),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11039),
    [aux_sym_integer_literal_token2] = ACTIONS(11039),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11039),
    [aux_sym_float_literal_token3] = ACTIONS(11039),
    [aux_sym_float_literal_token4] = ACTIONS(11039),
    [sym_character_literal] = ACTIONS(11039),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11039),
    [sym__pair_operator] = ACTIONS(11039),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11039),
    [sym__lazy_and_operator] = ACTIONS(11039),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11039),
    [sym__pipe_left_operator] = ACTIONS(11039),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11039),
    [sym__bitshift_operator] = ACTIONS(11039),
    [sym__power_operator] = ACTIONS(11039),
    [sym__tilde_operator] = ACTIONS(11039),
    [sym__type_order_operator] = ACTIONS(11039),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym__terminator_token1] = ACTIONS(11041),
    [aux_sym__terminator_token2] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8360] = {
    [sym_block_comment] = STATE(8360),
    [sym_line_comment] = STATE(8360),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11043),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_catch] = ACTIONS(11043),
    [anon_sym_finally] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11043),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11043),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11043),
    [anon_sym_DOLLAR] = ACTIONS(11043),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11043),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11043),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11043),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11043),
    [aux_sym_integer_literal_token2] = ACTIONS(11043),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11043),
    [aux_sym_float_literal_token3] = ACTIONS(11043),
    [aux_sym_float_literal_token4] = ACTIONS(11043),
    [sym_character_literal] = ACTIONS(11043),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11043),
    [sym__pair_operator] = ACTIONS(11043),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11043),
    [sym__lazy_and_operator] = ACTIONS(11043),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11043),
    [sym__pipe_left_operator] = ACTIONS(11043),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11043),
    [sym__bitshift_operator] = ACTIONS(11043),
    [sym__power_operator] = ACTIONS(11043),
    [sym__tilde_operator] = ACTIONS(11043),
    [sym__type_order_operator] = ACTIONS(11043),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym__terminator_token1] = ACTIONS(11045),
    [aux_sym__terminator_token2] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8361] = {
    [sym_block_comment] = STATE(8361),
    [sym_line_comment] = STATE(8361),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11116),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_catch] = ACTIONS(11116),
    [anon_sym_finally] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11116),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11116),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11116),
    [anon_sym_DOLLAR] = ACTIONS(11116),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11116),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11116),
    [anon_sym_QMARK] = ACTIONS(11116),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11116),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11116),
    [aux_sym_integer_literal_token2] = ACTIONS(11116),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11116),
    [aux_sym_float_literal_token3] = ACTIONS(11116),
    [aux_sym_float_literal_token4] = ACTIONS(11116),
    [sym_character_literal] = ACTIONS(11116),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11116),
    [sym__pair_operator] = ACTIONS(11116),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11116),
    [sym__lazy_and_operator] = ACTIONS(11116),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11116),
    [sym__pipe_left_operator] = ACTIONS(11116),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11116),
    [sym__bitshift_operator] = ACTIONS(11116),
    [sym__power_operator] = ACTIONS(11116),
    [sym__tilde_operator] = ACTIONS(11116),
    [sym__type_order_operator] = ACTIONS(11116),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym__terminator_token1] = ACTIONS(11118),
    [aux_sym__terminator_token2] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8362] = {
    [sym_block_comment] = STATE(8362),
    [sym_line_comment] = STATE(8362),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11120),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_catch] = ACTIONS(11120),
    [anon_sym_finally] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11120),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11120),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11120),
    [anon_sym_DOLLAR] = ACTIONS(11120),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11120),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11120),
    [anon_sym_QMARK] = ACTIONS(11120),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11120),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11120),
    [aux_sym_integer_literal_token2] = ACTIONS(11120),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11120),
    [aux_sym_float_literal_token3] = ACTIONS(11120),
    [aux_sym_float_literal_token4] = ACTIONS(11120),
    [sym_character_literal] = ACTIONS(11120),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11120),
    [sym__pair_operator] = ACTIONS(11120),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11120),
    [sym__lazy_and_operator] = ACTIONS(11120),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11120),
    [sym__pipe_left_operator] = ACTIONS(11120),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11120),
    [sym__bitshift_operator] = ACTIONS(11120),
    [sym__power_operator] = ACTIONS(11120),
    [sym__tilde_operator] = ACTIONS(11120),
    [sym__type_order_operator] = ACTIONS(11120),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym__terminator_token1] = ACTIONS(11122),
    [aux_sym__terminator_token2] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8363] = {
    [sym_block_comment] = STATE(8363),
    [sym_line_comment] = STATE(8363),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11197),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_catch] = ACTIONS(11197),
    [anon_sym_finally] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11197),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11197),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11197),
    [anon_sym_DOLLAR] = ACTIONS(11197),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11197),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11197),
    [anon_sym_QMARK] = ACTIONS(11197),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11197),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11197),
    [aux_sym_integer_literal_token2] = ACTIONS(11197),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11197),
    [aux_sym_float_literal_token3] = ACTIONS(11197),
    [aux_sym_float_literal_token4] = ACTIONS(11197),
    [sym_character_literal] = ACTIONS(11197),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11197),
    [sym__pair_operator] = ACTIONS(11197),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11197),
    [sym__lazy_and_operator] = ACTIONS(11197),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11197),
    [sym__pipe_left_operator] = ACTIONS(11197),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11197),
    [sym__bitshift_operator] = ACTIONS(11197),
    [sym__power_operator] = ACTIONS(11197),
    [sym__tilde_operator] = ACTIONS(11197),
    [sym__type_order_operator] = ACTIONS(11197),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym__terminator_token1] = ACTIONS(11199),
    [aux_sym__terminator_token2] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8364] = {
    [sym_block_comment] = STATE(8364),
    [sym_line_comment] = STATE(8364),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9736),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9736),
    [anon_sym_QMARK] = ACTIONS(9736),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9736),
    [sym__lazy_and_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8365] = {
    [sym_block_comment] = STATE(8365),
    [sym_line_comment] = STATE(8365),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9742),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9742),
    [anon_sym_QMARK] = ACTIONS(9742),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9742),
    [sym__lazy_and_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8366] = {
    [sym_block_comment] = STATE(8366),
    [sym_line_comment] = STATE(8366),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_catch] = ACTIONS(11211),
    [anon_sym_finally] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11211),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOLLAR] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11211),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11211),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11211),
    [aux_sym_integer_literal_token2] = ACTIONS(11211),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11211),
    [aux_sym_float_literal_token3] = ACTIONS(11211),
    [aux_sym_float_literal_token4] = ACTIONS(11211),
    [sym_character_literal] = ACTIONS(11211),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11211),
    [sym__pair_operator] = ACTIONS(11211),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11211),
    [sym__lazy_and_operator] = ACTIONS(11211),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11211),
    [sym__pipe_left_operator] = ACTIONS(11211),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11211),
    [sym__bitshift_operator] = ACTIONS(11211),
    [sym__power_operator] = ACTIONS(11211),
    [sym__tilde_operator] = ACTIONS(11211),
    [sym__type_order_operator] = ACTIONS(11211),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym__terminator_token1] = ACTIONS(11213),
    [aux_sym__terminator_token2] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8367] = {
    [sym_block_comment] = STATE(8367),
    [sym_line_comment] = STATE(8367),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_catch] = ACTIONS(10978),
    [anon_sym_finally] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10978),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10978),
    [anon_sym_QMARK] = ACTIONS(10978),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10978),
    [sym__lazy_and_operator] = ACTIONS(10978),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10978),
    [sym__pipe_left_operator] = ACTIONS(10978),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10978),
    [sym__bitshift_operator] = ACTIONS(10978),
    [sym__power_operator] = ACTIONS(10978),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10978),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8368] = {
    [sym_block_comment] = STATE(8368),
    [sym_line_comment] = STATE(8368),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8369] = {
    [sym_block_comment] = STATE(8369),
    [sym_line_comment] = STATE(8369),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11269),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_catch] = ACTIONS(11269),
    [anon_sym_finally] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11269),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11269),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11269),
    [anon_sym_DOLLAR] = ACTIONS(11269),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11269),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11269),
    [anon_sym_QMARK] = ACTIONS(11269),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11269),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11269),
    [aux_sym_integer_literal_token2] = ACTIONS(11269),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11269),
    [aux_sym_float_literal_token3] = ACTIONS(11269),
    [aux_sym_float_literal_token4] = ACTIONS(11269),
    [sym_character_literal] = ACTIONS(11269),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11269),
    [sym__pair_operator] = ACTIONS(11269),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11269),
    [sym__lazy_and_operator] = ACTIONS(11269),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11269),
    [sym__pipe_left_operator] = ACTIONS(11269),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11269),
    [sym__bitshift_operator] = ACTIONS(11269),
    [sym__power_operator] = ACTIONS(11269),
    [sym__tilde_operator] = ACTIONS(11269),
    [sym__type_order_operator] = ACTIONS(11269),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym__terminator_token1] = ACTIONS(11271),
    [aux_sym__terminator_token2] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8370] = {
    [sym_block_comment] = STATE(8370),
    [sym_line_comment] = STATE(8370),
    [aux_sym_export_statement_repeat1] = STATE(8370),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(12207),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8371] = {
    [sym_block_comment] = STATE(8371),
    [sym_line_comment] = STATE(8371),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_catch] = ACTIONS(11279),
    [anon_sym_finally] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11279),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11279),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11279),
    [anon_sym_DOLLAR] = ACTIONS(11279),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11279),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11279),
    [anon_sym_QMARK] = ACTIONS(11279),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11279),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11279),
    [aux_sym_integer_literal_token2] = ACTIONS(11279),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11279),
    [aux_sym_float_literal_token3] = ACTIONS(11279),
    [aux_sym_float_literal_token4] = ACTIONS(11279),
    [sym_character_literal] = ACTIONS(11279),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11279),
    [sym__pair_operator] = ACTIONS(11279),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11279),
    [sym__lazy_and_operator] = ACTIONS(11279),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11279),
    [sym__pipe_left_operator] = ACTIONS(11279),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11279),
    [sym__bitshift_operator] = ACTIONS(11279),
    [sym__power_operator] = ACTIONS(11279),
    [sym__tilde_operator] = ACTIONS(11279),
    [sym__type_order_operator] = ACTIONS(11279),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym__terminator_token1] = ACTIONS(11281),
    [aux_sym__terminator_token2] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8372] = {
    [sym_block_comment] = STATE(8372),
    [sym_line_comment] = STATE(8372),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(11217),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8373] = {
    [sym_block_comment] = STATE(8373),
    [sym_line_comment] = STATE(8373),
    [aux_sym__import_list_repeat1] = STATE(8373),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(12210),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8374] = {
    [sym_block_comment] = STATE(8374),
    [sym_line_comment] = STATE(8374),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11309),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_catch] = ACTIONS(11309),
    [anon_sym_finally] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11309),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11309),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11309),
    [anon_sym_DOLLAR] = ACTIONS(11309),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11309),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11309),
    [anon_sym_QMARK] = ACTIONS(11309),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11309),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11309),
    [aux_sym_integer_literal_token2] = ACTIONS(11309),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11309),
    [aux_sym_float_literal_token3] = ACTIONS(11309),
    [aux_sym_float_literal_token4] = ACTIONS(11309),
    [sym_character_literal] = ACTIONS(11309),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11309),
    [sym__pair_operator] = ACTIONS(11309),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11309),
    [sym__lazy_and_operator] = ACTIONS(11309),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11309),
    [sym__pipe_left_operator] = ACTIONS(11309),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11309),
    [sym__bitshift_operator] = ACTIONS(11309),
    [sym__power_operator] = ACTIONS(11309),
    [sym__tilde_operator] = ACTIONS(11309),
    [sym__type_order_operator] = ACTIONS(11309),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym__terminator_token1] = ACTIONS(11311),
    [aux_sym__terminator_token2] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8375] = {
    [sym_block_comment] = STATE(8375),
    [sym_line_comment] = STATE(8375),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8376] = {
    [sym_block_comment] = STATE(8376),
    [sym_line_comment] = STATE(8376),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_catch] = ACTIONS(11275),
    [anon_sym_finally] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8377] = {
    [sym_block_comment] = STATE(8377),
    [sym_line_comment] = STATE(8377),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11317),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_catch] = ACTIONS(11317),
    [anon_sym_finally] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11317),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11317),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11317),
    [anon_sym_DOLLAR] = ACTIONS(11317),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11317),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11317),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11317),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11317),
    [aux_sym_integer_literal_token2] = ACTIONS(11317),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11317),
    [aux_sym_float_literal_token3] = ACTIONS(11317),
    [aux_sym_float_literal_token4] = ACTIONS(11317),
    [sym_character_literal] = ACTIONS(11317),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11317),
    [sym__pair_operator] = ACTIONS(11317),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11317),
    [sym__lazy_and_operator] = ACTIONS(11317),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11317),
    [sym__pipe_left_operator] = ACTIONS(11317),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11317),
    [sym__bitshift_operator] = ACTIONS(11317),
    [sym__power_operator] = ACTIONS(11317),
    [sym__tilde_operator] = ACTIONS(11317),
    [sym__type_order_operator] = ACTIONS(11317),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym__terminator_token1] = ACTIONS(11319),
    [aux_sym__terminator_token2] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8378] = {
    [sym_block_comment] = STATE(8378),
    [sym_line_comment] = STATE(8378),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11359),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_catch] = ACTIONS(11359),
    [anon_sym_finally] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11359),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11359),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11359),
    [anon_sym_DOLLAR] = ACTIONS(11359),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11359),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11359),
    [anon_sym_QMARK] = ACTIONS(11359),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11359),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11359),
    [aux_sym_integer_literal_token2] = ACTIONS(11359),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11359),
    [aux_sym_float_literal_token3] = ACTIONS(11359),
    [aux_sym_float_literal_token4] = ACTIONS(11359),
    [sym_character_literal] = ACTIONS(11359),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11359),
    [sym__pair_operator] = ACTIONS(11359),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11359),
    [sym__lazy_and_operator] = ACTIONS(11359),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11359),
    [sym__pipe_left_operator] = ACTIONS(11359),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11359),
    [sym__bitshift_operator] = ACTIONS(11359),
    [sym__power_operator] = ACTIONS(11359),
    [sym__tilde_operator] = ACTIONS(11359),
    [sym__type_order_operator] = ACTIONS(11359),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym__terminator_token1] = ACTIONS(11361),
    [aux_sym__terminator_token2] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8379] = {
    [sym_block_comment] = STATE(8379),
    [sym_line_comment] = STATE(8379),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11381),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_catch] = ACTIONS(11381),
    [anon_sym_finally] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11381),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11381),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11381),
    [anon_sym_DOLLAR] = ACTIONS(11381),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11381),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11381),
    [anon_sym_QMARK] = ACTIONS(11381),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11381),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11381),
    [aux_sym_integer_literal_token2] = ACTIONS(11381),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11381),
    [aux_sym_float_literal_token3] = ACTIONS(11381),
    [aux_sym_float_literal_token4] = ACTIONS(11381),
    [sym_character_literal] = ACTIONS(11381),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11381),
    [sym__pair_operator] = ACTIONS(11381),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11381),
    [sym__lazy_and_operator] = ACTIONS(11381),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11381),
    [sym__pipe_left_operator] = ACTIONS(11381),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11381),
    [sym__bitshift_operator] = ACTIONS(11381),
    [sym__power_operator] = ACTIONS(11381),
    [sym__tilde_operator] = ACTIONS(11381),
    [sym__type_order_operator] = ACTIONS(11381),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym__terminator_token1] = ACTIONS(11383),
    [aux_sym__terminator_token2] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8380] = {
    [sym_block_comment] = STATE(8380),
    [sym_line_comment] = STATE(8380),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11407),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_catch] = ACTIONS(11407),
    [anon_sym_finally] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11407),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11407),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11407),
    [anon_sym_DOLLAR] = ACTIONS(11407),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11407),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11407),
    [anon_sym_QMARK] = ACTIONS(11407),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11407),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11407),
    [aux_sym_integer_literal_token2] = ACTIONS(11407),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11407),
    [aux_sym_float_literal_token3] = ACTIONS(11407),
    [aux_sym_float_literal_token4] = ACTIONS(11407),
    [sym_character_literal] = ACTIONS(11407),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11407),
    [sym__pair_operator] = ACTIONS(11407),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11407),
    [sym__lazy_and_operator] = ACTIONS(11407),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11407),
    [sym__pipe_left_operator] = ACTIONS(11407),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11407),
    [sym__bitshift_operator] = ACTIONS(11407),
    [sym__power_operator] = ACTIONS(11407),
    [sym__tilde_operator] = ACTIONS(11407),
    [sym__type_order_operator] = ACTIONS(11407),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym__terminator_token1] = ACTIONS(11409),
    [aux_sym__terminator_token2] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8381] = {
    [sym_block_comment] = STATE(8381),
    [sym_line_comment] = STATE(8381),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_catch] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_QMARK] = ACTIONS(11287),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11287),
    [sym__lazy_and_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8382] = {
    [sym_block_comment] = STATE(8382),
    [sym_line_comment] = STATE(8382),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9982),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9982),
    [anon_sym_QMARK] = ACTIONS(9982),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9982),
    [sym__lazy_and_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8383] = {
    [sym_block_comment] = STATE(8383),
    [sym_line_comment] = STATE(8383),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9986),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9986),
    [anon_sym_QMARK] = ACTIONS(9986),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9986),
    [sym__lazy_and_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8384] = {
    [sym_block_comment] = STATE(8384),
    [sym_line_comment] = STATE(8384),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10000),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10000),
    [anon_sym_QMARK] = ACTIONS(10000),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10000),
    [sym__lazy_and_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8385] = {
    [sym_block_comment] = STATE(8385),
    [sym_line_comment] = STATE(8385),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10004),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10004),
    [anon_sym_QMARK] = ACTIONS(10004),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10004),
    [sym__lazy_and_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8386] = {
    [sym_block_comment] = STATE(8386),
    [sym_line_comment] = STATE(8386),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10010),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10010),
    [anon_sym_QMARK] = ACTIONS(10010),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10010),
    [sym__lazy_and_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8387] = {
    [sym_block_comment] = STATE(8387),
    [sym_line_comment] = STATE(8387),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10014),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10014),
    [anon_sym_QMARK] = ACTIONS(10014),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10014),
    [sym__lazy_and_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8388] = {
    [sym_block_comment] = STATE(8388),
    [sym_line_comment] = STATE(8388),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10018),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10018),
    [anon_sym_QMARK] = ACTIONS(10018),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10018),
    [sym__lazy_and_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8389] = {
    [sym_block_comment] = STATE(8389),
    [sym_line_comment] = STATE(8389),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9916),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9916),
    [anon_sym_QMARK] = ACTIONS(9916),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9916),
    [sym__lazy_and_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8390] = {
    [sym_block_comment] = STATE(8390),
    [sym_line_comment] = STATE(8390),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9920),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9920),
    [anon_sym_QMARK] = ACTIONS(9920),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9920),
    [sym__lazy_and_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8391] = {
    [sym_block_comment] = STATE(8391),
    [sym_line_comment] = STATE(8391),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_finally] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8392] = {
    [sym_block_comment] = STATE(8392),
    [sym_line_comment] = STATE(8392),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11456),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_catch] = ACTIONS(11456),
    [anon_sym_finally] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11456),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11456),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11456),
    [anon_sym_DOLLAR] = ACTIONS(11456),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11456),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11456),
    [anon_sym_QMARK] = ACTIONS(11456),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11456),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11456),
    [aux_sym_integer_literal_token2] = ACTIONS(11456),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11456),
    [aux_sym_float_literal_token3] = ACTIONS(11456),
    [aux_sym_float_literal_token4] = ACTIONS(11456),
    [sym_character_literal] = ACTIONS(11456),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11456),
    [sym__pair_operator] = ACTIONS(11456),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11456),
    [sym__lazy_and_operator] = ACTIONS(11456),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11456),
    [sym__pipe_left_operator] = ACTIONS(11456),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11456),
    [sym__bitshift_operator] = ACTIONS(11456),
    [sym__power_operator] = ACTIONS(11456),
    [sym__tilde_operator] = ACTIONS(11456),
    [sym__type_order_operator] = ACTIONS(11456),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym__terminator_token1] = ACTIONS(11458),
    [aux_sym__terminator_token2] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8393] = {
    [sym_block_comment] = STATE(8393),
    [sym_line_comment] = STATE(8393),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9990),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9990),
    [anon_sym_QMARK] = ACTIONS(9990),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9990),
    [sym__lazy_and_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8394] = {
    [sym_block_comment] = STATE(8394),
    [sym_line_comment] = STATE(8394),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9994),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9994),
    [anon_sym_QMARK] = ACTIONS(9994),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9994),
    [sym__lazy_and_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8395] = {
    [sym_block_comment] = STATE(8395),
    [sym_line_comment] = STATE(8395),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11283),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_catch] = ACTIONS(11283),
    [anon_sym_finally] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11283),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11283),
    [anon_sym_DOLLAR] = ACTIONS(11283),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11283),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11283),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11283),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11283),
    [aux_sym_integer_literal_token2] = ACTIONS(11283),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11283),
    [aux_sym_float_literal_token3] = ACTIONS(11283),
    [aux_sym_float_literal_token4] = ACTIONS(11283),
    [sym_character_literal] = ACTIONS(11283),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11283),
    [sym__pair_operator] = ACTIONS(11283),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11283),
    [sym__lazy_and_operator] = ACTIONS(11283),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11283),
    [sym__pipe_left_operator] = ACTIONS(11283),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11283),
    [sym__bitshift_operator] = ACTIONS(11283),
    [sym__power_operator] = ACTIONS(11283),
    [sym__tilde_operator] = ACTIONS(11283),
    [sym__type_order_operator] = ACTIONS(11283),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym__terminator_token1] = ACTIONS(11285),
    [aux_sym__terminator_token2] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8396] = {
    [sym_block_comment] = STATE(8396),
    [sym_line_comment] = STATE(8396),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9750),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9750),
    [anon_sym_QMARK] = ACTIONS(9750),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9750),
    [sym__lazy_and_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8397] = {
    [sym_block_comment] = STATE(8397),
    [sym_line_comment] = STATE(8397),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9760),
    [anon_sym_QMARK] = ACTIONS(9760),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9760),
    [sym__lazy_and_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8398] = {
    [sym_block_comment] = STATE(8398),
    [sym_line_comment] = STATE(8398),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10028),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10028),
    [anon_sym_QMARK] = ACTIONS(10028),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10028),
    [sym__lazy_and_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8399] = {
    [sym_block_comment] = STATE(8399),
    [sym_line_comment] = STATE(8399),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10032),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10032),
    [anon_sym_QMARK] = ACTIONS(10032),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10032),
    [sym__lazy_and_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8400] = {
    [sym_block_comment] = STATE(8400),
    [sym_line_comment] = STATE(8400),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10036),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10036),
    [anon_sym_QMARK] = ACTIONS(10036),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10036),
    [sym__lazy_and_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8401] = {
    [sym_block_comment] = STATE(8401),
    [sym_line_comment] = STATE(8401),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10040),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10040),
    [anon_sym_QMARK] = ACTIONS(10040),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10040),
    [sym__lazy_and_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8402] = {
    [sym_block_comment] = STATE(8402),
    [sym_line_comment] = STATE(8402),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_catch] = ACTIONS(10908),
    [anon_sym_finally] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8403] = {
    [sym_block_comment] = STATE(8403),
    [sym_line_comment] = STATE(8403),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9788),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9788),
    [anon_sym_QMARK] = ACTIONS(9788),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9788),
    [sym__lazy_and_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8404] = {
    [sym_block_comment] = STATE(8404),
    [sym_line_comment] = STATE(8404),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10044),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10044),
    [anon_sym_QMARK] = ACTIONS(10044),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10044),
    [sym__lazy_and_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8405] = {
    [sym_block_comment] = STATE(8405),
    [sym_line_comment] = STATE(8405),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10048),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10048),
    [anon_sym_QMARK] = ACTIONS(10048),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10048),
    [sym__lazy_and_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8406] = {
    [sym_block_comment] = STATE(8406),
    [sym_line_comment] = STATE(8406),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10052),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10052),
    [anon_sym_QMARK] = ACTIONS(10052),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10052),
    [sym__lazy_and_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8407] = {
    [sym_block_comment] = STATE(8407),
    [sym_line_comment] = STATE(8407),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10056),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10056),
    [anon_sym_QMARK] = ACTIONS(10056),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10056),
    [sym__lazy_and_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8408] = {
    [sym_block_comment] = STATE(8408),
    [sym_line_comment] = STATE(8408),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9898),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9898),
    [anon_sym_QMARK] = ACTIONS(9898),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9898),
    [sym__lazy_and_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8409] = {
    [sym_block_comment] = STATE(8409),
    [sym_line_comment] = STATE(8409),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10060),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10060),
    [anon_sym_QMARK] = ACTIONS(10060),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10060),
    [sym__lazy_and_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8410] = {
    [sym_block_comment] = STATE(8410),
    [sym_line_comment] = STATE(8410),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10064),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10064),
    [anon_sym_QMARK] = ACTIONS(10064),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10064),
    [sym__lazy_and_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8411] = {
    [sym_block_comment] = STATE(8411),
    [sym_line_comment] = STATE(8411),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10068),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10068),
    [anon_sym_QMARK] = ACTIONS(10068),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10068),
    [sym__lazy_and_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8412] = {
    [sym_block_comment] = STATE(8412),
    [sym_line_comment] = STATE(8412),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10072),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10072),
    [anon_sym_QMARK] = ACTIONS(10072),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10072),
    [sym__lazy_and_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8413] = {
    [sym_block_comment] = STATE(8413),
    [sym_line_comment] = STATE(8413),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10076),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10076),
    [anon_sym_QMARK] = ACTIONS(10076),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10076),
    [sym__lazy_and_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8414] = {
    [sym_block_comment] = STATE(8414),
    [sym_line_comment] = STATE(8414),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10080),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10080),
    [anon_sym_QMARK] = ACTIONS(10080),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10080),
    [sym__lazy_and_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8415] = {
    [sym_block_comment] = STATE(8415),
    [sym_line_comment] = STATE(8415),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9642),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9642),
    [anon_sym_QMARK] = ACTIONS(9642),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9642),
    [sym__lazy_and_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8416] = {
    [sym_block_comment] = STATE(8416),
    [sym_line_comment] = STATE(8416),
    [aux_sym_open_tuple_repeat1] = STATE(7455),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11441),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8417] = {
    [sym_block_comment] = STATE(8417),
    [sym_line_comment] = STATE(8417),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10763),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10763),
    [anon_sym_RPAREN] = ACTIONS(10763),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10763),
    [anon_sym_RBRACK] = ACTIONS(10763),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_SEMI] = ACTIONS(10763),
    [anon_sym_LBRACE] = ACTIONS(10763),
    [anon_sym_RBRACE] = ACTIONS(10763),
    [anon_sym_DOLLAR] = ACTIONS(10763),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10763),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10763),
    [anon_sym_QMARK] = ACTIONS(10763),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10763),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10763),
    [aux_sym_integer_literal_token2] = ACTIONS(10763),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10763),
    [aux_sym_float_literal_token3] = ACTIONS(10763),
    [aux_sym_float_literal_token4] = ACTIONS(10763),
    [sym_character_literal] = ACTIONS(10763),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10763),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10763),
    [sym__pair_operator] = ACTIONS(10763),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10763),
    [sym__lazy_and_operator] = ACTIONS(10763),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10763),
    [sym__pipe_left_operator] = ACTIONS(10763),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10763),
    [sym__bitshift_operator] = ACTIONS(10763),
    [sym__power_operator] = ACTIONS(10763),
    [sym__tilde_operator] = ACTIONS(10763),
    [sym__type_order_operator] = ACTIONS(10763),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8418] = {
    [sym_block_comment] = STATE(8418),
    [sym_line_comment] = STATE(8418),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(9858),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8419] = {
    [sym_block_comment] = STATE(8419),
    [sym_line_comment] = STATE(8419),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(12213),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8420] = {
    [sym_block_comment] = STATE(8420),
    [sym_line_comment] = STATE(8420),
    [ts_builtin_sym_end] = ACTIONS(10976),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(12166),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_RBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8421] = {
    [sym_block_comment] = STATE(8421),
    [sym_line_comment] = STATE(8421),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10022),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8422] = {
    [sym_block_comment] = STATE(8422),
    [sym_line_comment] = STATE(8422),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9866),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8423] = {
    [sym_block_comment] = STATE(8423),
    [sym_line_comment] = STATE(8423),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10200),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
  },
  [8424] = {
    [sym_block_comment] = STATE(8424),
    [sym_line_comment] = STATE(8424),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(12215),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8425] = {
    [sym_block_comment] = STATE(8425),
    [sym_line_comment] = STATE(8425),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(12175),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8426] = {
    [sym_block_comment] = STATE(8426),
    [sym_line_comment] = STATE(8426),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9656),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8427] = {
    [sym_block_comment] = STATE(8427),
    [sym_line_comment] = STATE(8427),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(12175),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8428] = {
    [sym_block_comment] = STATE(8428),
    [sym_line_comment] = STATE(8428),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(12175),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8429] = {
    [sym_block_comment] = STATE(8429),
    [sym_line_comment] = STATE(8429),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(12175),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8430] = {
    [sym_block_comment] = STATE(8430),
    [sym_line_comment] = STATE(8430),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(12213),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8431] = {
    [sym_block_comment] = STATE(8431),
    [sym_line_comment] = STATE(8431),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_finally] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8432] = {
    [sym_block_comment] = STATE(8432),
    [sym_line_comment] = STATE(8432),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(12215),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8433] = {
    [sym_block_comment] = STATE(8433),
    [sym_line_comment] = STATE(8433),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(12213),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_catch] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8434] = {
    [sym_block_comment] = STATE(8434),
    [sym_line_comment] = STATE(8434),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(12213),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_catch] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8435] = {
    [sym_block_comment] = STATE(8435),
    [sym_line_comment] = STATE(8435),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(12213),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_catch] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8436] = {
    [sym_block_comment] = STATE(8436),
    [sym_line_comment] = STATE(8436),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9718),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8437] = {
    [sym_block_comment] = STATE(8437),
    [sym_line_comment] = STATE(8437),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(12215),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_finally] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8438] = {
    [sym_block_comment] = STATE(8438),
    [sym_line_comment] = STATE(8438),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(12215),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_finally] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8439] = {
    [sym_block_comment] = STATE(8439),
    [sym_line_comment] = STATE(8439),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(12215),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_finally] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8440] = {
    [sym_block_comment] = STATE(8440),
    [sym_line_comment] = STATE(8440),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_else] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_finally] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8441] = {
    [sym_block_comment] = STATE(8441),
    [sym_line_comment] = STATE(8441),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9720),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8442] = {
    [sym_block_comment] = STATE(8442),
    [sym_line_comment] = STATE(8442),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9668),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8443] = {
    [sym_block_comment] = STATE(8443),
    [sym_line_comment] = STATE(8443),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(12160),
    [sym__immediate_command_start] = ACTIONS(12162),
  },
  [8444] = {
    [sym_block_comment] = STATE(8444),
    [sym_line_comment] = STATE(8444),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11291),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_end] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_catch] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11291),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11291),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11291),
    [anon_sym_DOLLAR] = ACTIONS(11291),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11291),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11291),
    [anon_sym_QMARK] = ACTIONS(11291),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11291),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11291),
    [aux_sym_integer_literal_token2] = ACTIONS(11291),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11291),
    [aux_sym_float_literal_token3] = ACTIONS(11291),
    [aux_sym_float_literal_token4] = ACTIONS(11291),
    [sym_character_literal] = ACTIONS(11291),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11291),
    [sym__pair_operator] = ACTIONS(11291),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11291),
    [sym__lazy_and_operator] = ACTIONS(11291),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11291),
    [sym__pipe_left_operator] = ACTIONS(11291),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11291),
    [sym__bitshift_operator] = ACTIONS(11291),
    [sym__power_operator] = ACTIONS(11291),
    [sym__tilde_operator] = ACTIONS(11291),
    [sym__type_order_operator] = ACTIONS(11291),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym__terminator_token1] = ACTIONS(11293),
    [aux_sym__terminator_token2] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8445] = {
    [sym_block_comment] = STATE(8445),
    [sym_line_comment] = STATE(8445),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8446] = {
    [sym_block_comment] = STATE(8446),
    [sym_line_comment] = STATE(8446),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11305),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_end] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_catch] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11305),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11305),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11305),
    [anon_sym_DOLLAR] = ACTIONS(11305),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11305),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11305),
    [anon_sym_QMARK] = ACTIONS(11305),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11305),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11305),
    [aux_sym_integer_literal_token2] = ACTIONS(11305),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11305),
    [aux_sym_float_literal_token3] = ACTIONS(11305),
    [aux_sym_float_literal_token4] = ACTIONS(11305),
    [sym_character_literal] = ACTIONS(11305),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11305),
    [sym__pair_operator] = ACTIONS(11305),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11305),
    [sym__lazy_and_operator] = ACTIONS(11305),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11305),
    [sym__pipe_left_operator] = ACTIONS(11305),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11305),
    [sym__bitshift_operator] = ACTIONS(11305),
    [sym__power_operator] = ACTIONS(11305),
    [sym__tilde_operator] = ACTIONS(11305),
    [sym__type_order_operator] = ACTIONS(11305),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym__terminator_token1] = ACTIONS(11307),
    [aux_sym__terminator_token2] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8447] = {
    [sym_block_comment] = STATE(8447),
    [sym_line_comment] = STATE(8447),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_RPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_RBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_SEMI] = ACTIONS(11289),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_RBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11289),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11289),
    [anon_sym_QMARK] = ACTIONS(11289),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(11289),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11289),
    [sym__lazy_and_operator] = ACTIONS(11289),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11289),
    [sym__pipe_left_operator] = ACTIONS(11289),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11289),
    [sym__bitshift_operator] = ACTIONS(11289),
    [sym__power_operator] = ACTIONS(11289),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(11289),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8448] = {
    [sym_block_comment] = STATE(8448),
    [sym_line_comment] = STATE(8448),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8449] = {
    [sym_block_comment] = STATE(8449),
    [sym_line_comment] = STATE(8449),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8450] = {
    [sym_block_comment] = STATE(8450),
    [sym_line_comment] = STATE(8450),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8451] = {
    [sym_block_comment] = STATE(8451),
    [sym_line_comment] = STATE(8451),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_QMARK] = ACTIONS(11287),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11287),
    [sym__lazy_and_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8452] = {
    [sym_block_comment] = STATE(8452),
    [sym_line_comment] = STATE(8452),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8453] = {
    [sym_block_comment] = STATE(8453),
    [sym_line_comment] = STATE(8453),
    [aux_sym_open_tuple_repeat1] = STATE(8579),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_end] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10829),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10829),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10829),
    [anon_sym_DOLLAR] = ACTIONS(10829),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10829),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10829),
    [anon_sym_QMARK] = ACTIONS(10829),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10829),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10829),
    [aux_sym_integer_literal_token2] = ACTIONS(10829),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10829),
    [aux_sym_float_literal_token3] = ACTIONS(10829),
    [aux_sym_float_literal_token4] = ACTIONS(10829),
    [sym_character_literal] = ACTIONS(10829),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10829),
    [sym__pair_operator] = ACTIONS(10829),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10829),
    [sym__lazy_and_operator] = ACTIONS(10829),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10829),
    [sym__pipe_left_operator] = ACTIONS(10829),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10829),
    [sym__bitshift_operator] = ACTIONS(10829),
    [sym__power_operator] = ACTIONS(10829),
    [sym__tilde_operator] = ACTIONS(10829),
    [sym__type_order_operator] = ACTIONS(10829),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym__terminator_token1] = ACTIONS(10833),
    [aux_sym__terminator_token2] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8454] = {
    [sym_block_comment] = STATE(8454),
    [sym_line_comment] = STATE(8454),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10112),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8455] = {
    [sym_block_comment] = STATE(8455),
    [sym_line_comment] = STATE(8455),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8456] = {
    [sym_block_comment] = STATE(8456),
    [sym_line_comment] = STATE(8456),
    [aux_sym_open_tuple_repeat1] = STATE(7745),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11714),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8457] = {
    [sym_block_comment] = STATE(8457),
    [sym_line_comment] = STATE(8457),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9876),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8458] = {
    [sym_block_comment] = STATE(8458),
    [sym_line_comment] = STATE(8458),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
  },
  [8459] = {
    [sym_block_comment] = STATE(8459),
    [sym_line_comment] = STATE(8459),
    [ts_builtin_sym_end] = ACTIONS(11253),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11251),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11251),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11251),
    [anon_sym_RBRACK] = ACTIONS(11251),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11251),
    [anon_sym_DOLLAR] = ACTIONS(11251),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11251),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11251),
    [anon_sym_QMARK] = ACTIONS(11251),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11251),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11251),
    [aux_sym_integer_literal_token2] = ACTIONS(11251),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11251),
    [aux_sym_float_literal_token3] = ACTIONS(11251),
    [aux_sym_float_literal_token4] = ACTIONS(11251),
    [sym_character_literal] = ACTIONS(11251),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11251),
    [sym__pair_operator] = ACTIONS(11251),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11251),
    [sym__lazy_and_operator] = ACTIONS(11251),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11251),
    [sym__pipe_left_operator] = ACTIONS(11251),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11251),
    [sym__bitshift_operator] = ACTIONS(11251),
    [sym__power_operator] = ACTIONS(11251),
    [sym__tilde_operator] = ACTIONS(11251),
    [sym__type_order_operator] = ACTIONS(11251),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym__terminator_token1] = ACTIONS(11253),
    [aux_sym__terminator_token2] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8460] = {
    [sym_block_comment] = STATE(8460),
    [sym_line_comment] = STATE(8460),
    [ts_builtin_sym_end] = ACTIONS(11261),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11259),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11259),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11259),
    [anon_sym_RBRACK] = ACTIONS(11259),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11259),
    [anon_sym_DOLLAR] = ACTIONS(11259),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11259),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11259),
    [anon_sym_QMARK] = ACTIONS(11259),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11259),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11259),
    [aux_sym_integer_literal_token2] = ACTIONS(11259),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11259),
    [aux_sym_float_literal_token3] = ACTIONS(11259),
    [aux_sym_float_literal_token4] = ACTIONS(11259),
    [sym_character_literal] = ACTIONS(11259),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11259),
    [sym__pair_operator] = ACTIONS(11259),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11259),
    [sym__lazy_and_operator] = ACTIONS(11259),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11259),
    [sym__pipe_left_operator] = ACTIONS(11259),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11259),
    [sym__bitshift_operator] = ACTIONS(11259),
    [sym__power_operator] = ACTIONS(11259),
    [sym__tilde_operator] = ACTIONS(11259),
    [sym__type_order_operator] = ACTIONS(11259),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym__terminator_token1] = ACTIONS(11261),
    [aux_sym__terminator_token2] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8461] = {
    [sym_block_comment] = STATE(8461),
    [sym_line_comment] = STATE(8461),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10092),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8462] = {
    [sym_block_comment] = STATE(8462),
    [sym_line_comment] = STATE(8462),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
  },
  [8463] = {
    [sym_block_comment] = STATE(8463),
    [sym_line_comment] = STATE(8463),
    [ts_builtin_sym_end] = ACTIONS(10964),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_RBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8464] = {
    [sym_block_comment] = STATE(8464),
    [sym_line_comment] = STATE(8464),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10152),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10152),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10152),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10152),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10152),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10152),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10152),
    [anon_sym_QMARK] = ACTIONS(10152),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10152),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10152),
    [aux_sym_integer_literal_token2] = ACTIONS(10152),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10152),
    [aux_sym_float_literal_token3] = ACTIONS(10152),
    [aux_sym_float_literal_token4] = ACTIONS(10152),
    [sym_character_literal] = ACTIONS(10152),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10152),
    [sym__pair_operator] = ACTIONS(10152),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10152),
    [sym__lazy_and_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10152),
    [sym__pipe_left_operator] = ACTIONS(10152),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10152),
    [sym__bitshift_operator] = ACTIONS(10152),
    [sym__power_operator] = ACTIONS(10152),
    [sym__tilde_operator] = ACTIONS(10152),
    [sym__type_order_operator] = ACTIONS(10152),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym__terminator_token1] = ACTIONS(10154),
    [aux_sym__terminator_token2] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8465] = {
    [sym_block_comment] = STATE(8465),
    [sym_line_comment] = STATE(8465),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_catch] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8466] = {
    [sym_block_comment] = STATE(8466),
    [sym_line_comment] = STATE(8466),
    [ts_builtin_sym_end] = ACTIONS(10964),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_RBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8467] = {
    [sym_block_comment] = STATE(8467),
    [sym_line_comment] = STATE(8467),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOT] = ACTIONS(12219),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8468] = {
    [sym_block_comment] = STATE(8468),
    [sym_line_comment] = STATE(8468),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8469] = {
    [sym_block_comment] = STATE(8469),
    [sym_line_comment] = STATE(8469),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10964),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_RBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8470] = {
    [sym_block_comment] = STATE(8470),
    [sym_line_comment] = STATE(8470),
    [ts_builtin_sym_end] = ACTIONS(11225),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11223),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11223),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11223),
    [anon_sym_RBRACK] = ACTIONS(11223),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11223),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11223),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11223),
    [anon_sym_QMARK] = ACTIONS(11223),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11223),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11223),
    [aux_sym_integer_literal_token2] = ACTIONS(11223),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11223),
    [aux_sym_float_literal_token3] = ACTIONS(11223),
    [aux_sym_float_literal_token4] = ACTIONS(11223),
    [sym_character_literal] = ACTIONS(11223),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11223),
    [sym__pair_operator] = ACTIONS(11223),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11223),
    [sym__lazy_and_operator] = ACTIONS(11223),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11223),
    [sym__pipe_left_operator] = ACTIONS(11223),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11223),
    [sym__bitshift_operator] = ACTIONS(11223),
    [sym__power_operator] = ACTIONS(11223),
    [sym__tilde_operator] = ACTIONS(11223),
    [sym__type_order_operator] = ACTIONS(11223),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym__terminator_token1] = ACTIONS(11225),
    [aux_sym__terminator_token2] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8471] = {
    [sym_block_comment] = STATE(8471),
    [sym_line_comment] = STATE(8471),
    [ts_builtin_sym_end] = ACTIONS(10968),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_RBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8472] = {
    [sym_block_comment] = STATE(8472),
    [sym_line_comment] = STATE(8472),
    [ts_builtin_sym_end] = ACTIONS(10968),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_RBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8473] = {
    [sym_block_comment] = STATE(8473),
    [sym_line_comment] = STATE(8473),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10968),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_RBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8474] = {
    [sym_block_comment] = STATE(8474),
    [sym_line_comment] = STATE(8474),
    [ts_builtin_sym_end] = ACTIONS(10972),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_RBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8475] = {
    [sym_block_comment] = STATE(8475),
    [sym_line_comment] = STATE(8475),
    [ts_builtin_sym_end] = ACTIONS(10972),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_RBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8476] = {
    [sym_block_comment] = STATE(8476),
    [sym_line_comment] = STATE(8476),
    [aux_sym_open_tuple_repeat1] = STATE(7448),
    [ts_builtin_sym_end] = ACTIONS(10972),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(11425),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_RBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8477] = {
    [sym_block_comment] = STATE(8477),
    [sym_line_comment] = STATE(8477),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9926),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9926),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9926),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9926),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9926),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9926),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9926),
    [anon_sym_QMARK] = ACTIONS(9926),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9926),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9926),
    [aux_sym_integer_literal_token2] = ACTIONS(9926),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9926),
    [aux_sym_float_literal_token3] = ACTIONS(9926),
    [aux_sym_float_literal_token4] = ACTIONS(9926),
    [sym_character_literal] = ACTIONS(9926),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9926),
    [sym__pair_operator] = ACTIONS(9926),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9926),
    [sym__lazy_and_operator] = ACTIONS(9926),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9926),
    [sym__pipe_left_operator] = ACTIONS(9926),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9926),
    [sym__bitshift_operator] = ACTIONS(9926),
    [sym__power_operator] = ACTIONS(9926),
    [sym__tilde_operator] = ACTIONS(9926),
    [sym__type_order_operator] = ACTIONS(9926),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym__terminator_token1] = ACTIONS(9928),
    [aux_sym__terminator_token2] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8478] = {
    [sym_block_comment] = STATE(8478),
    [sym_line_comment] = STATE(8478),
    [ts_builtin_sym_end] = ACTIONS(11293),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11291),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11291),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11291),
    [anon_sym_RBRACK] = ACTIONS(11291),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11291),
    [anon_sym_DOLLAR] = ACTIONS(11291),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11291),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11291),
    [anon_sym_QMARK] = ACTIONS(11291),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11291),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11291),
    [aux_sym_integer_literal_token2] = ACTIONS(11291),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11291),
    [aux_sym_float_literal_token3] = ACTIONS(11291),
    [aux_sym_float_literal_token4] = ACTIONS(11291),
    [sym_character_literal] = ACTIONS(11291),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11291),
    [sym__pair_operator] = ACTIONS(11291),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11291),
    [sym__lazy_and_operator] = ACTIONS(11291),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11291),
    [sym__pipe_left_operator] = ACTIONS(11291),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11291),
    [sym__bitshift_operator] = ACTIONS(11291),
    [sym__power_operator] = ACTIONS(11291),
    [sym__tilde_operator] = ACTIONS(11291),
    [sym__type_order_operator] = ACTIONS(11291),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym__terminator_token1] = ACTIONS(11293),
    [aux_sym__terminator_token2] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8479] = {
    [sym_block_comment] = STATE(8479),
    [sym_line_comment] = STATE(8479),
    [ts_builtin_sym_end] = ACTIONS(11307),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11305),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11305),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11305),
    [anon_sym_RBRACK] = ACTIONS(11305),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11305),
    [anon_sym_DOLLAR] = ACTIONS(11305),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11305),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11305),
    [anon_sym_QMARK] = ACTIONS(11305),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11305),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11305),
    [aux_sym_integer_literal_token2] = ACTIONS(11305),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11305),
    [aux_sym_float_literal_token3] = ACTIONS(11305),
    [aux_sym_float_literal_token4] = ACTIONS(11305),
    [sym_character_literal] = ACTIONS(11305),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11305),
    [sym__pair_operator] = ACTIONS(11305),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11305),
    [sym__lazy_and_operator] = ACTIONS(11305),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11305),
    [sym__pipe_left_operator] = ACTIONS(11305),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11305),
    [sym__bitshift_operator] = ACTIONS(11305),
    [sym__power_operator] = ACTIONS(11305),
    [sym__tilde_operator] = ACTIONS(11305),
    [sym__type_order_operator] = ACTIONS(11305),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym__terminator_token1] = ACTIONS(11307),
    [aux_sym__terminator_token2] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8480] = {
    [sym_block_comment] = STATE(8480),
    [sym_line_comment] = STATE(8480),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11169),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_end] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_catch] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11169),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11169),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11169),
    [anon_sym_DOLLAR] = ACTIONS(11169),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11169),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11169),
    [anon_sym_QMARK] = ACTIONS(11169),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11169),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11169),
    [aux_sym_integer_literal_token2] = ACTIONS(11169),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11169),
    [aux_sym_float_literal_token3] = ACTIONS(11169),
    [aux_sym_float_literal_token4] = ACTIONS(11169),
    [sym_character_literal] = ACTIONS(11169),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11169),
    [sym__pair_operator] = ACTIONS(11169),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11169),
    [sym__lazy_and_operator] = ACTIONS(11169),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11169),
    [sym__pipe_left_operator] = ACTIONS(11169),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11169),
    [sym__bitshift_operator] = ACTIONS(11169),
    [sym__power_operator] = ACTIONS(11169),
    [sym__tilde_operator] = ACTIONS(11169),
    [sym__type_order_operator] = ACTIONS(11169),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym__terminator_token1] = ACTIONS(11171),
    [aux_sym__terminator_token2] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8481] = {
    [sym_block_comment] = STATE(8481),
    [sym_line_comment] = STATE(8481),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10835),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_catch] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8482] = {
    [sym_block_comment] = STATE(8482),
    [sym_line_comment] = STATE(8482),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_catch] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8483] = {
    [sym_block_comment] = STATE(8483),
    [sym_line_comment] = STATE(8483),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_catch] = ACTIONS(11864),
    [anon_sym_finally] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8484] = {
    [sym_block_comment] = STATE(8484),
    [sym_line_comment] = STATE(8484),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(12221),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8485] = {
    [sym_block_comment] = STATE(8485),
    [sym_line_comment] = STATE(8485),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8486] = {
    [sym_block_comment] = STATE(8486),
    [sym_line_comment] = STATE(8486),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_RBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_RBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8487] = {
    [sym_block_comment] = STATE(8487),
    [sym_line_comment] = STATE(8487),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8488] = {
    [sym_block_comment] = STATE(8488),
    [sym_line_comment] = STATE(8488),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8489] = {
    [sym_block_comment] = STATE(8489),
    [sym_line_comment] = STATE(8489),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8490] = {
    [sym_block_comment] = STATE(8490),
    [sym_line_comment] = STATE(8490),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_elseif] = ACTIONS(11112),
    [anon_sym_else] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12295),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(12297),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12299),
    [sym__arrow_operator] = ACTIONS(12301),
    [sym__lazy_or_operator] = ACTIONS(12303),
    [sym__lazy_and_operator] = ACTIONS(12305),
    [sym__comparison_operator] = ACTIONS(12295),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12295),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8491] = {
    [sym_block_comment] = STATE(8491),
    [sym_line_comment] = STATE(8491),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_elseif] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8492] = {
    [sym_block_comment] = STATE(8492),
    [sym_line_comment] = STATE(8492),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8493] = {
    [sym_block_comment] = STATE(8493),
    [sym_line_comment] = STATE(8493),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12295),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(12297),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12299),
    [sym__arrow_operator] = ACTIONS(12301),
    [sym__lazy_or_operator] = ACTIONS(12303),
    [sym__lazy_and_operator] = ACTIONS(12305),
    [sym__comparison_operator] = ACTIONS(12295),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12295),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8494] = {
    [sym_block_comment] = STATE(8494),
    [sym_line_comment] = STATE(8494),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_elseif] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(10930),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(10932),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(10932),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11219),
    [anon_sym_where] = ACTIONS(10938),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(10940),
    [sym__arrow_operator] = ACTIONS(10942),
    [sym__lazy_or_operator] = ACTIONS(10944),
    [sym__lazy_and_operator] = ACTIONS(10946),
    [sym__comparison_operator] = ACTIONS(10932),
    [sym__pipe_right_operator] = ACTIONS(10948),
    [sym__pipe_left_operator] = ACTIONS(10950),
    [sym__ellipsis_operator] = ACTIONS(10952),
    [sym__plus_operator] = ACTIONS(10954),
    [sym__times_operator] = ACTIONS(10956),
    [sym__rational_operator] = ACTIONS(10958),
    [sym__bitshift_operator] = ACTIONS(10960),
    [sym__power_operator] = ACTIONS(10962),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(10932),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(10954),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8495] = {
    [sym_block_comment] = STATE(8495),
    [sym_line_comment] = STATE(8495),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_RBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_RBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8496] = {
    [sym_block_comment] = STATE(8496),
    [sym_line_comment] = STATE(8496),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_RBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_RBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8497] = {
    [sym_block_comment] = STATE(8497),
    [sym_line_comment] = STATE(8497),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_RBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_RBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8498] = {
    [sym_block_comment] = STATE(8498),
    [sym_line_comment] = STATE(8498),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10980),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8499] = {
    [sym_block_comment] = STATE(8499),
    [sym_line_comment] = STATE(8499),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_RBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_RBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8500] = {
    [sym_block_comment] = STATE(8500),
    [sym_line_comment] = STATE(8500),
    [ts_builtin_sym_end] = ACTIONS(11249),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_RBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8501] = {
    [sym_block_comment] = STATE(8501),
    [sym_line_comment] = STATE(8501),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8502] = {
    [sym_block_comment] = STATE(8502),
    [sym_line_comment] = STATE(8502),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_catch] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8503] = {
    [sym_block_comment] = STATE(8503),
    [sym_line_comment] = STATE(8503),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_RPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_RBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_RBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8504] = {
    [sym_block_comment] = STATE(8504),
    [sym_line_comment] = STATE(8504),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_catch] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8505] = {
    [sym_block_comment] = STATE(8505),
    [sym_line_comment] = STATE(8505),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_catch] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8506] = {
    [sym_block_comment] = STATE(8506),
    [sym_line_comment] = STATE(8506),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8507] = {
    [sym_block_comment] = STATE(8507),
    [sym_line_comment] = STATE(8507),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_catch] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11676),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8508] = {
    [sym_block_comment] = STATE(8508),
    [sym_line_comment] = STATE(8508),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10980),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_RBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8509] = {
    [sym_block_comment] = STATE(8509),
    [sym_line_comment] = STATE(8509),
    [ts_builtin_sym_end] = ACTIONS(11267),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_RBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8510] = {
    [sym_block_comment] = STATE(8510),
    [sym_line_comment] = STATE(8510),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8511] = {
    [sym_block_comment] = STATE(8511),
    [sym_line_comment] = STATE(8511),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_elseif] = ACTIONS(11112),
    [anon_sym_else] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(12327),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12331),
    [sym__arrow_operator] = ACTIONS(12333),
    [sym__lazy_or_operator] = ACTIONS(12335),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8512] = {
    [sym_block_comment] = STATE(8512),
    [sym_line_comment] = STATE(8512),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(12327),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12331),
    [sym__arrow_operator] = ACTIONS(12333),
    [sym__lazy_or_operator] = ACTIONS(12335),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8513] = {
    [sym_block_comment] = STATE(8513),
    [sym_line_comment] = STATE(8513),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8514] = {
    [sym_block_comment] = STATE(8514),
    [sym_line_comment] = STATE(8514),
    [ts_builtin_sym_end] = ACTIONS(11289),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_RBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8515] = {
    [sym_block_comment] = STATE(8515),
    [sym_line_comment] = STATE(8515),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_elseif] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(12327),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12331),
    [sym__arrow_operator] = ACTIONS(12333),
    [sym__lazy_or_operator] = ACTIONS(12335),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8516] = {
    [sym_block_comment] = STATE(8516),
    [sym_line_comment] = STATE(8516),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_elseif] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(12327),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12331),
    [sym__arrow_operator] = ACTIONS(12333),
    [sym__lazy_or_operator] = ACTIONS(12335),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8517] = {
    [sym_block_comment] = STATE(8517),
    [sym_line_comment] = STATE(8517),
    [ts_builtin_sym_end] = ACTIONS(10639),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_RBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8518] = {
    [sym_block_comment] = STATE(8518),
    [sym_line_comment] = STATE(8518),
    [ts_builtin_sym_end] = ACTIONS(10976),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_RBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8519] = {
    [sym_block_comment] = STATE(8519),
    [sym_line_comment] = STATE(8519),
    [ts_builtin_sym_end] = ACTIONS(11171),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11169),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11169),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11169),
    [anon_sym_RBRACK] = ACTIONS(11169),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11169),
    [anon_sym_DOLLAR] = ACTIONS(11169),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11169),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11169),
    [anon_sym_QMARK] = ACTIONS(11169),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11169),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11169),
    [aux_sym_integer_literal_token2] = ACTIONS(11169),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11169),
    [aux_sym_float_literal_token3] = ACTIONS(11169),
    [aux_sym_float_literal_token4] = ACTIONS(11169),
    [sym_character_literal] = ACTIONS(11169),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11169),
    [sym__pair_operator] = ACTIONS(11169),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11169),
    [sym__lazy_and_operator] = ACTIONS(11169),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11169),
    [sym__pipe_left_operator] = ACTIONS(11169),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11169),
    [sym__bitshift_operator] = ACTIONS(11169),
    [sym__power_operator] = ACTIONS(11169),
    [sym__tilde_operator] = ACTIONS(11169),
    [sym__type_order_operator] = ACTIONS(11169),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym__terminator_token1] = ACTIONS(11171),
    [aux_sym__terminator_token2] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8520] = {
    [sym_block_comment] = STATE(8520),
    [sym_line_comment] = STATE(8520),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
  },
  [8521] = {
    [sym_block_comment] = STATE(8521),
    [sym_line_comment] = STATE(8521),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8522] = {
    [sym_block_comment] = STATE(8522),
    [sym_line_comment] = STATE(8522),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9876),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8523] = {
    [sym_block_comment] = STATE(8523),
    [sym_line_comment] = STATE(8523),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10835),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_finally] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11724),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8524] = {
    [sym_block_comment] = STATE(8524),
    [sym_line_comment] = STATE(8524),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_finally] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8525] = {
    [sym_block_comment] = STATE(8525),
    [sym_line_comment] = STATE(8525),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8526] = {
    [sym_block_comment] = STATE(8526),
    [sym_line_comment] = STATE(8526),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11630),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8527] = {
    [sym_block_comment] = STATE(8527),
    [sym_line_comment] = STATE(8527),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8528] = {
    [sym_block_comment] = STATE(8528),
    [sym_line_comment] = STATE(8528),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8529] = {
    [sym_block_comment] = STATE(8529),
    [sym_line_comment] = STATE(8529),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8530] = {
    [sym_block_comment] = STATE(8530),
    [sym_line_comment] = STATE(8530),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8531] = {
    [sym_block_comment] = STATE(8531),
    [sym_line_comment] = STATE(8531),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8532] = {
    [sym_block_comment] = STATE(8532),
    [sym_line_comment] = STATE(8532),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8533] = {
    [sym_block_comment] = STATE(8533),
    [sym_line_comment] = STATE(8533),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8534] = {
    [sym_block_comment] = STATE(8534),
    [sym_line_comment] = STATE(8534),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8535] = {
    [sym_block_comment] = STATE(8535),
    [sym_line_comment] = STATE(8535),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8536] = {
    [sym_block_comment] = STATE(8536),
    [sym_line_comment] = STATE(8536),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8537] = {
    [sym_block_comment] = STATE(8537),
    [sym_line_comment] = STATE(8537),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8538] = {
    [sym_block_comment] = STATE(8538),
    [sym_line_comment] = STATE(8538),
    [aux_sym_open_tuple_repeat1] = STATE(7822),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(11620),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_catch] = ACTIONS(10974),
    [anon_sym_finally] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8539] = {
    [sym_block_comment] = STATE(8539),
    [sym_line_comment] = STATE(8539),
    [ts_builtin_sym_end] = ACTIONS(11474),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11472),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11472),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11472),
    [anon_sym_RBRACK] = ACTIONS(11472),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11472),
    [anon_sym_DOLLAR] = ACTIONS(11472),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11472),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11472),
    [anon_sym_QMARK] = ACTIONS(11472),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11472),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11472),
    [aux_sym_integer_literal_token2] = ACTIONS(11472),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11472),
    [aux_sym_float_literal_token3] = ACTIONS(11472),
    [aux_sym_float_literal_token4] = ACTIONS(11472),
    [sym_character_literal] = ACTIONS(11472),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11472),
    [sym__pair_operator] = ACTIONS(11472),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11472),
    [sym__lazy_and_operator] = ACTIONS(11472),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11472),
    [sym__pipe_left_operator] = ACTIONS(11472),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11472),
    [sym__bitshift_operator] = ACTIONS(11472),
    [sym__power_operator] = ACTIONS(11472),
    [sym__tilde_operator] = ACTIONS(11472),
    [sym__type_order_operator] = ACTIONS(11472),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym__terminator_token1] = ACTIONS(11474),
    [aux_sym__terminator_token2] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8540] = {
    [sym_block_comment] = STATE(8540),
    [sym_line_comment] = STATE(8540),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8541] = {
    [sym_block_comment] = STATE(8541),
    [sym_line_comment] = STATE(8541),
    [ts_builtin_sym_end] = ACTIONS(11501),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11499),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11499),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11499),
    [anon_sym_RBRACK] = ACTIONS(11499),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11499),
    [anon_sym_DOLLAR] = ACTIONS(11499),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11499),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11499),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11499),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11499),
    [aux_sym_integer_literal_token2] = ACTIONS(11499),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11499),
    [aux_sym_float_literal_token3] = ACTIONS(11499),
    [aux_sym_float_literal_token4] = ACTIONS(11499),
    [sym_character_literal] = ACTIONS(11499),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11499),
    [sym__pair_operator] = ACTIONS(11499),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11499),
    [sym__lazy_and_operator] = ACTIONS(11499),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11499),
    [sym__pipe_left_operator] = ACTIONS(11499),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11499),
    [sym__bitshift_operator] = ACTIONS(11499),
    [sym__power_operator] = ACTIONS(11499),
    [sym__tilde_operator] = ACTIONS(11499),
    [sym__type_order_operator] = ACTIONS(11499),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym__terminator_token1] = ACTIONS(11501),
    [aux_sym__terminator_token2] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8542] = {
    [sym_block_comment] = STATE(8542),
    [sym_line_comment] = STATE(8542),
    [ts_builtin_sym_end] = ACTIONS(11515),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11513),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11513),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11513),
    [anon_sym_RBRACK] = ACTIONS(11513),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11513),
    [anon_sym_DOLLAR] = ACTIONS(11513),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11513),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11513),
    [anon_sym_QMARK] = ACTIONS(11513),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11513),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11513),
    [aux_sym_integer_literal_token2] = ACTIONS(11513),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11513),
    [aux_sym_float_literal_token3] = ACTIONS(11513),
    [aux_sym_float_literal_token4] = ACTIONS(11513),
    [sym_character_literal] = ACTIONS(11513),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11513),
    [sym__pair_operator] = ACTIONS(11513),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11513),
    [sym__lazy_and_operator] = ACTIONS(11513),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11513),
    [sym__pipe_left_operator] = ACTIONS(11513),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11513),
    [sym__bitshift_operator] = ACTIONS(11513),
    [sym__power_operator] = ACTIONS(11513),
    [sym__tilde_operator] = ACTIONS(11513),
    [sym__type_order_operator] = ACTIONS(11513),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym__terminator_token1] = ACTIONS(11515),
    [aux_sym__terminator_token2] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8543] = {
    [sym_block_comment] = STATE(8543),
    [sym_line_comment] = STATE(8543),
    [ts_builtin_sym_end] = ACTIONS(11528),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11526),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11526),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11526),
    [anon_sym_RBRACK] = ACTIONS(11526),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11526),
    [anon_sym_DOLLAR] = ACTIONS(11526),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11526),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11526),
    [anon_sym_QMARK] = ACTIONS(11526),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11526),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11526),
    [aux_sym_integer_literal_token2] = ACTIONS(11526),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11526),
    [aux_sym_float_literal_token3] = ACTIONS(11526),
    [aux_sym_float_literal_token4] = ACTIONS(11526),
    [sym_character_literal] = ACTIONS(11526),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11526),
    [sym__pair_operator] = ACTIONS(11526),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11526),
    [sym__lazy_and_operator] = ACTIONS(11526),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11526),
    [sym__pipe_left_operator] = ACTIONS(11526),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11526),
    [sym__bitshift_operator] = ACTIONS(11526),
    [sym__power_operator] = ACTIONS(11526),
    [sym__tilde_operator] = ACTIONS(11526),
    [sym__type_order_operator] = ACTIONS(11526),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym__terminator_token1] = ACTIONS(11528),
    [aux_sym__terminator_token2] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8544] = {
    [sym_block_comment] = STATE(8544),
    [sym_line_comment] = STATE(8544),
    [ts_builtin_sym_end] = ACTIONS(11866),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8545] = {
    [sym_block_comment] = STATE(8545),
    [sym_line_comment] = STATE(8545),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8546] = {
    [sym_block_comment] = STATE(8546),
    [sym_line_comment] = STATE(8546),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8547] = {
    [sym_block_comment] = STATE(8547),
    [sym_line_comment] = STATE(8547),
    [ts_builtin_sym_end] = ACTIONS(11532),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11530),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11530),
    [anon_sym_RBRACK] = ACTIONS(11530),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11530),
    [anon_sym_DOLLAR] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11530),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11530),
    [anon_sym_QMARK] = ACTIONS(11530),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11530),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11530),
    [aux_sym_integer_literal_token2] = ACTIONS(11530),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11530),
    [aux_sym_float_literal_token3] = ACTIONS(11530),
    [aux_sym_float_literal_token4] = ACTIONS(11530),
    [sym_character_literal] = ACTIONS(11530),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11530),
    [sym__pair_operator] = ACTIONS(11530),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11530),
    [sym__lazy_and_operator] = ACTIONS(11530),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11530),
    [sym__pipe_left_operator] = ACTIONS(11530),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11530),
    [sym__bitshift_operator] = ACTIONS(11530),
    [sym__power_operator] = ACTIONS(11530),
    [sym__tilde_operator] = ACTIONS(11530),
    [sym__type_order_operator] = ACTIONS(11530),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym__terminator_token1] = ACTIONS(11532),
    [aux_sym__terminator_token2] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8548] = {
    [sym_block_comment] = STATE(8548),
    [sym_line_comment] = STATE(8548),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8549] = {
    [sym_block_comment] = STATE(8549),
    [sym_line_comment] = STATE(8549),
    [ts_builtin_sym_end] = ACTIONS(11536),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11534),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11534),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11534),
    [anon_sym_RBRACK] = ACTIONS(11534),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11534),
    [anon_sym_DOLLAR] = ACTIONS(11534),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11534),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11534),
    [anon_sym_QMARK] = ACTIONS(11534),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11534),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11534),
    [aux_sym_integer_literal_token2] = ACTIONS(11534),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11534),
    [aux_sym_float_literal_token3] = ACTIONS(11534),
    [aux_sym_float_literal_token4] = ACTIONS(11534),
    [sym_character_literal] = ACTIONS(11534),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11534),
    [sym__pair_operator] = ACTIONS(11534),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11534),
    [sym__lazy_and_operator] = ACTIONS(11534),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11534),
    [sym__pipe_left_operator] = ACTIONS(11534),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11534),
    [sym__bitshift_operator] = ACTIONS(11534),
    [sym__power_operator] = ACTIONS(11534),
    [sym__tilde_operator] = ACTIONS(11534),
    [sym__type_order_operator] = ACTIONS(11534),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym__terminator_token1] = ACTIONS(11536),
    [aux_sym__terminator_token2] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8550] = {
    [sym_block_comment] = STATE(8550),
    [sym_line_comment] = STATE(8550),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8551] = {
    [sym_block_comment] = STATE(8551),
    [sym_line_comment] = STATE(8551),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8552] = {
    [sym_block_comment] = STATE(8552),
    [sym_line_comment] = STATE(8552),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8553] = {
    [sym_block_comment] = STATE(8553),
    [sym_line_comment] = STATE(8553),
    [ts_builtin_sym_end] = ACTIONS(11550),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11548),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11548),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11548),
    [anon_sym_RBRACK] = ACTIONS(11548),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11548),
    [anon_sym_DOLLAR] = ACTIONS(11548),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11548),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11548),
    [anon_sym_QMARK] = ACTIONS(11548),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11548),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11548),
    [aux_sym_integer_literal_token2] = ACTIONS(11548),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11548),
    [aux_sym_float_literal_token3] = ACTIONS(11548),
    [aux_sym_float_literal_token4] = ACTIONS(11548),
    [sym_character_literal] = ACTIONS(11548),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11548),
    [sym__pair_operator] = ACTIONS(11548),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11548),
    [sym__lazy_and_operator] = ACTIONS(11548),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11548),
    [sym__pipe_left_operator] = ACTIONS(11548),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11548),
    [sym__bitshift_operator] = ACTIONS(11548),
    [sym__power_operator] = ACTIONS(11548),
    [sym__tilde_operator] = ACTIONS(11548),
    [sym__type_order_operator] = ACTIONS(11548),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym__terminator_token1] = ACTIONS(11550),
    [aux_sym__terminator_token2] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8554] = {
    [sym_block_comment] = STATE(8554),
    [sym_line_comment] = STATE(8554),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_catch] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8555] = {
    [sym_block_comment] = STATE(8555),
    [sym_line_comment] = STATE(8555),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8556] = {
    [sym_block_comment] = STATE(8556),
    [sym_line_comment] = STATE(8556),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8557] = {
    [sym_block_comment] = STATE(8557),
    [sym_line_comment] = STATE(8557),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8558] = {
    [sym_block_comment] = STATE(8558),
    [sym_line_comment] = STATE(8558),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8559] = {
    [sym_block_comment] = STATE(8559),
    [sym_line_comment] = STATE(8559),
    [ts_builtin_sym_end] = ACTIONS(11554),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11552),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11552),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11552),
    [anon_sym_RBRACK] = ACTIONS(11552),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11552),
    [anon_sym_DOLLAR] = ACTIONS(11552),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11552),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11552),
    [anon_sym_QMARK] = ACTIONS(11552),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11552),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11552),
    [aux_sym_integer_literal_token2] = ACTIONS(11552),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11552),
    [aux_sym_float_literal_token3] = ACTIONS(11552),
    [aux_sym_float_literal_token4] = ACTIONS(11552),
    [sym_character_literal] = ACTIONS(11552),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11552),
    [sym__pair_operator] = ACTIONS(11552),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11552),
    [sym__lazy_and_operator] = ACTIONS(11552),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11552),
    [sym__pipe_left_operator] = ACTIONS(11552),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11552),
    [sym__bitshift_operator] = ACTIONS(11552),
    [sym__power_operator] = ACTIONS(11552),
    [sym__tilde_operator] = ACTIONS(11552),
    [sym__type_order_operator] = ACTIONS(11552),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym__terminator_token1] = ACTIONS(11554),
    [aux_sym__terminator_token2] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8560] = {
    [sym_block_comment] = STATE(8560),
    [sym_line_comment] = STATE(8560),
    [ts_builtin_sym_end] = ACTIONS(11561),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11559),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11559),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11559),
    [anon_sym_RBRACK] = ACTIONS(11559),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11559),
    [anon_sym_DOLLAR] = ACTIONS(11559),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11559),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11559),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11559),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11559),
    [aux_sym_integer_literal_token2] = ACTIONS(11559),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11559),
    [aux_sym_float_literal_token3] = ACTIONS(11559),
    [aux_sym_float_literal_token4] = ACTIONS(11559),
    [sym_character_literal] = ACTIONS(11559),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11559),
    [sym__pair_operator] = ACTIONS(11559),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11559),
    [sym__lazy_and_operator] = ACTIONS(11559),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11559),
    [sym__pipe_left_operator] = ACTIONS(11559),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11559),
    [sym__bitshift_operator] = ACTIONS(11559),
    [sym__power_operator] = ACTIONS(11559),
    [sym__tilde_operator] = ACTIONS(11559),
    [sym__type_order_operator] = ACTIONS(11559),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym__terminator_token1] = ACTIONS(11561),
    [aux_sym__terminator_token2] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8561] = {
    [sym_block_comment] = STATE(8561),
    [sym_line_comment] = STATE(8561),
    [ts_builtin_sym_end] = ACTIONS(11565),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11563),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11563),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_RBRACK] = ACTIONS(11563),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11563),
    [anon_sym_DOLLAR] = ACTIONS(11563),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11563),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_QMARK] = ACTIONS(11563),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11563),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11563),
    [aux_sym_integer_literal_token2] = ACTIONS(11563),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11563),
    [aux_sym_float_literal_token3] = ACTIONS(11563),
    [aux_sym_float_literal_token4] = ACTIONS(11563),
    [sym_character_literal] = ACTIONS(11563),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11563),
    [sym__pair_operator] = ACTIONS(11563),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11563),
    [sym__lazy_and_operator] = ACTIONS(11563),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11563),
    [sym__pipe_left_operator] = ACTIONS(11563),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11563),
    [sym__bitshift_operator] = ACTIONS(11563),
    [sym__power_operator] = ACTIONS(11563),
    [sym__tilde_operator] = ACTIONS(11563),
    [sym__type_order_operator] = ACTIONS(11563),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym__terminator_token1] = ACTIONS(11565),
    [aux_sym__terminator_token2] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8562] = {
    [sym_block_comment] = STATE(8562),
    [sym_line_comment] = STATE(8562),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8563] = {
    [sym_identifier] = STATE(8848),
    [sym_block_comment] = STATE(8563),
    [sym_line_comment] = STATE(8563),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_as] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8564] = {
    [sym_identifier] = STATE(8849),
    [sym_block_comment] = STATE(8564),
    [sym_line_comment] = STATE(8564),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_as] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8565] = {
    [sym_block_comment] = STATE(8565),
    [sym_line_comment] = STATE(8565),
    [ts_builtin_sym_end] = ACTIONS(11569),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11567),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11567),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11567),
    [anon_sym_RBRACK] = ACTIONS(11567),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11567),
    [anon_sym_DOLLAR] = ACTIONS(11567),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11567),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11567),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11567),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11567),
    [aux_sym_integer_literal_token2] = ACTIONS(11567),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11567),
    [aux_sym_float_literal_token3] = ACTIONS(11567),
    [aux_sym_float_literal_token4] = ACTIONS(11567),
    [sym_character_literal] = ACTIONS(11567),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11567),
    [sym__pair_operator] = ACTIONS(11567),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11567),
    [sym__lazy_and_operator] = ACTIONS(11567),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11567),
    [sym__pipe_left_operator] = ACTIONS(11567),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11567),
    [sym__bitshift_operator] = ACTIONS(11567),
    [sym__power_operator] = ACTIONS(11567),
    [sym__tilde_operator] = ACTIONS(11567),
    [sym__type_order_operator] = ACTIONS(11567),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym__terminator_token1] = ACTIONS(11569),
    [aux_sym__terminator_token2] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8566] = {
    [sym_block_comment] = STATE(8566),
    [sym_line_comment] = STATE(8566),
    [ts_builtin_sym_end] = ACTIONS(11573),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11571),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11571),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11571),
    [anon_sym_RBRACK] = ACTIONS(11571),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11571),
    [anon_sym_DOLLAR] = ACTIONS(11571),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11571),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_QMARK] = ACTIONS(11571),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11571),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11571),
    [aux_sym_integer_literal_token2] = ACTIONS(11571),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11571),
    [aux_sym_float_literal_token3] = ACTIONS(11571),
    [aux_sym_float_literal_token4] = ACTIONS(11571),
    [sym_character_literal] = ACTIONS(11571),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11571),
    [sym__pair_operator] = ACTIONS(11571),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11571),
    [sym__lazy_and_operator] = ACTIONS(11571),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11571),
    [sym__pipe_left_operator] = ACTIONS(11571),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11571),
    [sym__bitshift_operator] = ACTIONS(11571),
    [sym__power_operator] = ACTIONS(11571),
    [sym__tilde_operator] = ACTIONS(11571),
    [sym__type_order_operator] = ACTIONS(11571),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym__terminator_token1] = ACTIONS(11573),
    [aux_sym__terminator_token2] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8567] = {
    [sym_identifier] = STATE(8878),
    [sym_block_comment] = STATE(8567),
    [sym_line_comment] = STATE(8567),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_as] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8568] = {
    [sym_block_comment] = STATE(8568),
    [sym_line_comment] = STATE(8568),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8569] = {
    [sym_identifier] = STATE(8891),
    [sym_block_comment] = STATE(8569),
    [sym_line_comment] = STATE(8569),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_as] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8570] = {
    [sym_block_comment] = STATE(8570),
    [sym_line_comment] = STATE(8570),
    [ts_builtin_sym_end] = ACTIONS(10976),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_RBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8571] = {
    [sym_block_comment] = STATE(8571),
    [sym_line_comment] = STATE(8571),
    [ts_builtin_sym_end] = ACTIONS(11022),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(10110),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_RBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8572] = {
    [sym_block_comment] = STATE(8572),
    [sym_line_comment] = STATE(8572),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8573] = {
    [sym_block_comment] = STATE(8573),
    [sym_line_comment] = STATE(8573),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_elseif] = ACTIONS(11864),
    [anon_sym_else] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12295),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12295),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12295),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8574] = {
    [sym_block_comment] = STATE(8574),
    [sym_line_comment] = STATE(8574),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12295),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12297),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12301),
    [sym__lazy_or_operator] = ACTIONS(12303),
    [sym__lazy_and_operator] = ACTIONS(12305),
    [sym__comparison_operator] = ACTIONS(12295),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12295),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8575] = {
    [sym_block_comment] = STATE(8575),
    [sym_line_comment] = STATE(8575),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12295),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12297),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12305),
    [sym__comparison_operator] = ACTIONS(12295),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12295),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8576] = {
    [sym_block_comment] = STATE(8576),
    [sym_line_comment] = STATE(8576),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12295),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12297),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12295),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12295),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8577] = {
    [sym_block_comment] = STATE(8577),
    [sym_line_comment] = STATE(8577),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8578] = {
    [sym_block_comment] = STATE(8578),
    [sym_line_comment] = STATE(8578),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12293),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12307),
    [sym__pipe_left_operator] = ACTIONS(12309),
    [sym__ellipsis_operator] = ACTIONS(12311),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8579] = {
    [sym_block_comment] = STATE(8579),
    [sym_line_comment] = STATE(8579),
    [aux_sym_open_tuple_repeat1] = STATE(8579),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(12355),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10835),
    [anon_sym_QMARK] = ACTIONS(10835),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(10835),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10835),
    [sym__lazy_and_operator] = ACTIONS(10835),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10835),
    [sym__pipe_left_operator] = ACTIONS(10835),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10835),
    [sym__bitshift_operator] = ACTIONS(10835),
    [sym__power_operator] = ACTIONS(10835),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(10835),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8580] = {
    [sym_block_comment] = STATE(8580),
    [sym_line_comment] = STATE(8580),
    [ts_builtin_sym_end] = ACTIONS(10840),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10835),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_RBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11618),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8581] = {
    [sym_block_comment] = STATE(8581),
    [sym_line_comment] = STATE(8581),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(10098),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_catch] = ACTIONS(11020),
    [anon_sym_finally] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8582] = {
    [sym_block_comment] = STATE(8582),
    [sym_line_comment] = STATE(8582),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [8583] = {
    [sym_block_comment] = STATE(8583),
    [sym_line_comment] = STATE(8583),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_else] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_finally] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12177),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12179),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(12179),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(12197),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12199),
    [sym__arrow_operator] = ACTIONS(12201),
    [sym__lazy_or_operator] = ACTIONS(12203),
    [sym__lazy_and_operator] = ACTIONS(12205),
    [sym__comparison_operator] = ACTIONS(12179),
    [sym__pipe_right_operator] = ACTIONS(12181),
    [sym__pipe_left_operator] = ACTIONS(12183),
    [sym__ellipsis_operator] = ACTIONS(12185),
    [sym__plus_operator] = ACTIONS(12187),
    [sym__times_operator] = ACTIONS(12189),
    [sym__rational_operator] = ACTIONS(12191),
    [sym__bitshift_operator] = ACTIONS(12193),
    [sym__power_operator] = ACTIONS(12195),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12179),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12187),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8584] = {
    [sym_block_comment] = STATE(8584),
    [sym_line_comment] = STATE(8584),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(10984),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(10986),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(10988),
    [anon_sym_isa] = ACTIONS(10986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10990),
    [anon_sym_QMARK] = ACTIONS(11273),
    [anon_sym_where] = ACTIONS(10994),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(10996),
    [sym__arrow_operator] = ACTIONS(10998),
    [sym__lazy_or_operator] = ACTIONS(11000),
    [sym__lazy_and_operator] = ACTIONS(11002),
    [sym__comparison_operator] = ACTIONS(10986),
    [sym__pipe_right_operator] = ACTIONS(11004),
    [sym__pipe_left_operator] = ACTIONS(11006),
    [sym__ellipsis_operator] = ACTIONS(11008),
    [sym__plus_operator] = ACTIONS(11010),
    [sym__times_operator] = ACTIONS(11012),
    [sym__rational_operator] = ACTIONS(11014),
    [sym__bitshift_operator] = ACTIONS(11016),
    [sym__power_operator] = ACTIONS(11018),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(10986),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11010),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8585] = {
    [sym_block_comment] = STATE(8585),
    [sym_line_comment] = STATE(8585),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_catch] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8586] = {
    [sym_block_comment] = STATE(8586),
    [sym_line_comment] = STATE(8586),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11472),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_end] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_catch] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11472),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11472),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11472),
    [anon_sym_DOLLAR] = ACTIONS(11472),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11472),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11472),
    [anon_sym_QMARK] = ACTIONS(11472),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11472),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11472),
    [aux_sym_integer_literal_token2] = ACTIONS(11472),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11472),
    [aux_sym_float_literal_token3] = ACTIONS(11472),
    [aux_sym_float_literal_token4] = ACTIONS(11472),
    [sym_character_literal] = ACTIONS(11472),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11472),
    [sym__pair_operator] = ACTIONS(11472),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11472),
    [sym__lazy_and_operator] = ACTIONS(11472),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11472),
    [sym__pipe_left_operator] = ACTIONS(11472),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11472),
    [sym__bitshift_operator] = ACTIONS(11472),
    [sym__power_operator] = ACTIONS(11472),
    [sym__tilde_operator] = ACTIONS(11472),
    [sym__type_order_operator] = ACTIONS(11472),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym__terminator_token1] = ACTIONS(11474),
    [aux_sym__terminator_token2] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8587] = {
    [sym_block_comment] = STATE(8587),
    [sym_line_comment] = STATE(8587),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8588] = {
    [sym_block_comment] = STATE(8588),
    [sym_line_comment] = STATE(8588),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_elseif] = ACTIONS(11864),
    [anon_sym_else] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8589] = {
    [sym_block_comment] = STATE(8589),
    [sym_line_comment] = STATE(8589),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12333),
    [sym__lazy_or_operator] = ACTIONS(12335),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8590] = {
    [sym_block_comment] = STATE(8590),
    [sym_line_comment] = STATE(8590),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8591] = {
    [sym_block_comment] = STATE(8591),
    [sym_line_comment] = STATE(8591),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8592] = {
    [sym_block_comment] = STATE(8592),
    [sym_line_comment] = STATE(8592),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8593] = {
    [sym_block_comment] = STATE(8593),
    [sym_line_comment] = STATE(8593),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8594] = {
    [sym_block_comment] = STATE(8594),
    [sym_line_comment] = STATE(8594),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11499),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_end] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_catch] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11499),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11499),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11499),
    [anon_sym_DOLLAR] = ACTIONS(11499),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11499),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11499),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11499),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11499),
    [aux_sym_integer_literal_token2] = ACTIONS(11499),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11499),
    [aux_sym_float_literal_token3] = ACTIONS(11499),
    [aux_sym_float_literal_token4] = ACTIONS(11499),
    [sym_character_literal] = ACTIONS(11499),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11499),
    [sym__pair_operator] = ACTIONS(11499),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11499),
    [sym__lazy_and_operator] = ACTIONS(11499),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11499),
    [sym__pipe_left_operator] = ACTIONS(11499),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11499),
    [sym__bitshift_operator] = ACTIONS(11499),
    [sym__power_operator] = ACTIONS(11499),
    [sym__tilde_operator] = ACTIONS(11499),
    [sym__type_order_operator] = ACTIONS(11499),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym__terminator_token1] = ACTIONS(11501),
    [aux_sym__terminator_token2] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8595] = {
    [sym_block_comment] = STATE(8595),
    [sym_line_comment] = STATE(8595),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11513),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_end] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_catch] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11513),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11513),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11513),
    [anon_sym_DOLLAR] = ACTIONS(11513),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11513),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11513),
    [anon_sym_QMARK] = ACTIONS(11513),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11513),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11513),
    [aux_sym_integer_literal_token2] = ACTIONS(11513),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11513),
    [aux_sym_float_literal_token3] = ACTIONS(11513),
    [aux_sym_float_literal_token4] = ACTIONS(11513),
    [sym_character_literal] = ACTIONS(11513),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11513),
    [sym__pair_operator] = ACTIONS(11513),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11513),
    [sym__lazy_and_operator] = ACTIONS(11513),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11513),
    [sym__pipe_left_operator] = ACTIONS(11513),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11513),
    [sym__bitshift_operator] = ACTIONS(11513),
    [sym__power_operator] = ACTIONS(11513),
    [sym__tilde_operator] = ACTIONS(11513),
    [sym__type_order_operator] = ACTIONS(11513),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym__terminator_token1] = ACTIONS(11515),
    [aux_sym__terminator_token2] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8596] = {
    [sym_block_comment] = STATE(8596),
    [sym_line_comment] = STATE(8596),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11526),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_end] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_catch] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11526),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11526),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11526),
    [anon_sym_DOLLAR] = ACTIONS(11526),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11526),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11526),
    [anon_sym_QMARK] = ACTIONS(11526),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11526),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11526),
    [aux_sym_integer_literal_token2] = ACTIONS(11526),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11526),
    [aux_sym_float_literal_token3] = ACTIONS(11526),
    [aux_sym_float_literal_token4] = ACTIONS(11526),
    [sym_character_literal] = ACTIONS(11526),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11526),
    [sym__pair_operator] = ACTIONS(11526),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11526),
    [sym__lazy_and_operator] = ACTIONS(11526),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11526),
    [sym__pipe_left_operator] = ACTIONS(11526),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11526),
    [sym__bitshift_operator] = ACTIONS(11526),
    [sym__power_operator] = ACTIONS(11526),
    [sym__tilde_operator] = ACTIONS(11526),
    [sym__type_order_operator] = ACTIONS(11526),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym__terminator_token1] = ACTIONS(11528),
    [aux_sym__terminator_token2] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8597] = {
    [sym_block_comment] = STATE(8597),
    [sym_line_comment] = STATE(8597),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11530),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_end] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_catch] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11530),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11530),
    [anon_sym_DOLLAR] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11530),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11530),
    [anon_sym_QMARK] = ACTIONS(11530),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11530),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11530),
    [aux_sym_integer_literal_token2] = ACTIONS(11530),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11530),
    [aux_sym_float_literal_token3] = ACTIONS(11530),
    [aux_sym_float_literal_token4] = ACTIONS(11530),
    [sym_character_literal] = ACTIONS(11530),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11530),
    [sym__pair_operator] = ACTIONS(11530),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11530),
    [sym__lazy_and_operator] = ACTIONS(11530),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11530),
    [sym__pipe_left_operator] = ACTIONS(11530),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11530),
    [sym__bitshift_operator] = ACTIONS(11530),
    [sym__power_operator] = ACTIONS(11530),
    [sym__tilde_operator] = ACTIONS(11530),
    [sym__type_order_operator] = ACTIONS(11530),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym__terminator_token1] = ACTIONS(11532),
    [aux_sym__terminator_token2] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8598] = {
    [sym_block_comment] = STATE(8598),
    [sym_line_comment] = STATE(8598),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11534),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_end] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_catch] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11534),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11534),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11534),
    [anon_sym_DOLLAR] = ACTIONS(11534),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11534),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11534),
    [anon_sym_QMARK] = ACTIONS(11534),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11534),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11534),
    [aux_sym_integer_literal_token2] = ACTIONS(11534),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11534),
    [aux_sym_float_literal_token3] = ACTIONS(11534),
    [aux_sym_float_literal_token4] = ACTIONS(11534),
    [sym_character_literal] = ACTIONS(11534),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11534),
    [sym__pair_operator] = ACTIONS(11534),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11534),
    [sym__lazy_and_operator] = ACTIONS(11534),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11534),
    [sym__pipe_left_operator] = ACTIONS(11534),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11534),
    [sym__bitshift_operator] = ACTIONS(11534),
    [sym__power_operator] = ACTIONS(11534),
    [sym__tilde_operator] = ACTIONS(11534),
    [sym__type_order_operator] = ACTIONS(11534),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym__terminator_token1] = ACTIONS(11536),
    [aux_sym__terminator_token2] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8599] = {
    [sym_block_comment] = STATE(8599),
    [sym_line_comment] = STATE(8599),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11548),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_end] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_catch] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11548),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11548),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11548),
    [anon_sym_DOLLAR] = ACTIONS(11548),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11548),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11548),
    [anon_sym_QMARK] = ACTIONS(11548),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11548),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11548),
    [aux_sym_integer_literal_token2] = ACTIONS(11548),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11548),
    [aux_sym_float_literal_token3] = ACTIONS(11548),
    [aux_sym_float_literal_token4] = ACTIONS(11548),
    [sym_character_literal] = ACTIONS(11548),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11548),
    [sym__pair_operator] = ACTIONS(11548),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11548),
    [sym__lazy_and_operator] = ACTIONS(11548),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11548),
    [sym__pipe_left_operator] = ACTIONS(11548),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11548),
    [sym__bitshift_operator] = ACTIONS(11548),
    [sym__power_operator] = ACTIONS(11548),
    [sym__tilde_operator] = ACTIONS(11548),
    [sym__type_order_operator] = ACTIONS(11548),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym__terminator_token1] = ACTIONS(11550),
    [aux_sym__terminator_token2] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8600] = {
    [sym_block_comment] = STATE(8600),
    [sym_line_comment] = STATE(8600),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11552),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_end] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_catch] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11552),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11552),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11552),
    [anon_sym_DOLLAR] = ACTIONS(11552),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11552),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11552),
    [anon_sym_QMARK] = ACTIONS(11552),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11552),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11552),
    [aux_sym_integer_literal_token2] = ACTIONS(11552),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11552),
    [aux_sym_float_literal_token3] = ACTIONS(11552),
    [aux_sym_float_literal_token4] = ACTIONS(11552),
    [sym_character_literal] = ACTIONS(11552),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11552),
    [sym__pair_operator] = ACTIONS(11552),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11552),
    [sym__lazy_and_operator] = ACTIONS(11552),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11552),
    [sym__pipe_left_operator] = ACTIONS(11552),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11552),
    [sym__bitshift_operator] = ACTIONS(11552),
    [sym__power_operator] = ACTIONS(11552),
    [sym__tilde_operator] = ACTIONS(11552),
    [sym__type_order_operator] = ACTIONS(11552),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym__terminator_token1] = ACTIONS(11554),
    [aux_sym__terminator_token2] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8601] = {
    [sym_block_comment] = STATE(8601),
    [sym_line_comment] = STATE(8601),
    [ts_builtin_sym_end] = ACTIONS(11289),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_RBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_QMARK] = ACTIONS(11287),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11287),
    [sym__lazy_and_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8602] = {
    [sym_block_comment] = STATE(8602),
    [sym_line_comment] = STATE(8602),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11559),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_end] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_catch] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11559),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11559),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11559),
    [anon_sym_DOLLAR] = ACTIONS(11559),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11559),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11559),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11559),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11559),
    [aux_sym_integer_literal_token2] = ACTIONS(11559),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11559),
    [aux_sym_float_literal_token3] = ACTIONS(11559),
    [aux_sym_float_literal_token4] = ACTIONS(11559),
    [sym_character_literal] = ACTIONS(11559),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11559),
    [sym__pair_operator] = ACTIONS(11559),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11559),
    [sym__lazy_and_operator] = ACTIONS(11559),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11559),
    [sym__pipe_left_operator] = ACTIONS(11559),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11559),
    [sym__bitshift_operator] = ACTIONS(11559),
    [sym__power_operator] = ACTIONS(11559),
    [sym__tilde_operator] = ACTIONS(11559),
    [sym__type_order_operator] = ACTIONS(11559),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym__terminator_token1] = ACTIONS(11561),
    [aux_sym__terminator_token2] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8603] = {
    [sym_block_comment] = STATE(8603),
    [sym_line_comment] = STATE(8603),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_elseif] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8604] = {
    [sym_block_comment] = STATE(8604),
    [sym_line_comment] = STATE(8604),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_elseif] = ACTIONS(11275),
    [anon_sym_else] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8605] = {
    [sym_block_comment] = STATE(8605),
    [sym_line_comment] = STATE(8605),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8606] = {
    [sym_block_comment] = STATE(8606),
    [sym_line_comment] = STATE(8606),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8607] = {
    [sym_block_comment] = STATE(8607),
    [sym_line_comment] = STATE(8607),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8608] = {
    [sym_block_comment] = STATE(8608),
    [sym_line_comment] = STATE(8608),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8609] = {
    [sym_block_comment] = STATE(8609),
    [sym_line_comment] = STATE(8609),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8610] = {
    [sym_block_comment] = STATE(8610),
    [sym_line_comment] = STATE(8610),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_elseif] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8611] = {
    [sym_block_comment] = STATE(8611),
    [sym_line_comment] = STATE(8611),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_elseif] = ACTIONS(11275),
    [anon_sym_else] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8612] = {
    [sym_block_comment] = STATE(8612),
    [sym_line_comment] = STATE(8612),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12313),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12313),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8613] = {
    [sym_block_comment] = STATE(8613),
    [sym_line_comment] = STATE(8613),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12315),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8614] = {
    [sym_block_comment] = STATE(8614),
    [sym_line_comment] = STATE(8614),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12317),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8615] = {
    [sym_block_comment] = STATE(8615),
    [sym_line_comment] = STATE(8615),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12319),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8616] = {
    [sym_block_comment] = STATE(8616),
    [sym_line_comment] = STATE(8616),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12321),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8617] = {
    [sym_block_comment] = STATE(8617),
    [sym_line_comment] = STATE(8617),
    [ts_builtin_sym_end] = ACTIONS(12054),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_RBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [aux_sym__terminator_token2] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8618] = {
    [sym_block_comment] = STATE(8618),
    [sym_line_comment] = STATE(8618),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11022),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8619] = {
    [sym_block_comment] = STATE(8619),
    [sym_line_comment] = STATE(8619),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_RBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11866),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8620] = {
    [sym_block_comment] = STATE(8620),
    [sym_line_comment] = STATE(8620),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10835),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10835),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10835),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10835),
    [anon_sym_DOLLAR] = ACTIONS(10835),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10835),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10835),
    [aux_sym_integer_literal_token2] = ACTIONS(10835),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10835),
    [aux_sym_float_literal_token3] = ACTIONS(10835),
    [aux_sym_float_literal_token4] = ACTIONS(10835),
    [sym_character_literal] = ACTIONS(10835),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10835),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10835),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10840),
    [aux_sym__terminator_token2] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8621] = {
    [sym_block_comment] = STATE(8621),
    [sym_line_comment] = STATE(8621),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10292),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10096),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8622] = {
    [sym_block_comment] = STATE(8622),
    [sym_line_comment] = STATE(8622),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_elseif] = ACTIONS(11265),
    [anon_sym_else] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8623] = {
    [sym_block_comment] = STATE(8623),
    [sym_line_comment] = STATE(8623),
    [aux_sym_open_tuple_repeat1] = STATE(8623),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(12396),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10840),
    [anon_sym_RPAREN] = ACTIONS(10840),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10840),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_SEMI] = ACTIONS(10840),
    [anon_sym_LBRACE] = ACTIONS(10840),
    [anon_sym_DOLLAR] = ACTIONS(10840),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10840),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10840),
    [anon_sym_QMARK] = ACTIONS(10840),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10840),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10840),
    [aux_sym_integer_literal_token2] = ACTIONS(10840),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10840),
    [aux_sym_float_literal_token3] = ACTIONS(10840),
    [aux_sym_float_literal_token4] = ACTIONS(10840),
    [sym_character_literal] = ACTIONS(10840),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10840),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10840),
    [sym__pair_operator] = ACTIONS(10840),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10840),
    [sym__lazy_and_operator] = ACTIONS(10840),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10840),
    [sym__pipe_left_operator] = ACTIONS(10840),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10840),
    [sym__bitshift_operator] = ACTIONS(10840),
    [sym__power_operator] = ACTIONS(10840),
    [sym__tilde_operator] = ACTIONS(10840),
    [sym__type_order_operator] = ACTIONS(10840),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8624] = {
    [sym_block_comment] = STATE(8624),
    [sym_line_comment] = STATE(8624),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_as] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8625] = {
    [sym_block_comment] = STATE(8625),
    [sym_line_comment] = STATE(8625),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11267),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11267),
    [anon_sym_RPAREN] = ACTIONS(11267),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11267),
    [anon_sym_RBRACK] = ACTIONS(11267),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11267),
    [anon_sym_RBRACE] = ACTIONS(11267),
    [anon_sym_DOLLAR] = ACTIONS(11267),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11267),
    [anon_sym_QMARK] = ACTIONS(11267),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11267),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11267),
    [aux_sym_integer_literal_token2] = ACTIONS(11267),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11267),
    [aux_sym_float_literal_token3] = ACTIONS(11267),
    [aux_sym_float_literal_token4] = ACTIONS(11267),
    [sym_character_literal] = ACTIONS(11267),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11267),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11267),
    [sym__pair_operator] = ACTIONS(11267),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11267),
    [sym__lazy_and_operator] = ACTIONS(11267),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11267),
    [sym__pipe_left_operator] = ACTIONS(11267),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11267),
    [sym__bitshift_operator] = ACTIONS(11267),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11267),
    [sym__type_order_operator] = ACTIONS(11267),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8626] = {
    [sym_block_comment] = STATE(8626),
    [sym_line_comment] = STATE(8626),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11259),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_end] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11259),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11259),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11259),
    [anon_sym_DOLLAR] = ACTIONS(11259),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11259),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11259),
    [anon_sym_QMARK] = ACTIONS(11259),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11259),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11259),
    [aux_sym_integer_literal_token2] = ACTIONS(11259),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11259),
    [aux_sym_float_literal_token3] = ACTIONS(11259),
    [aux_sym_float_literal_token4] = ACTIONS(11259),
    [sym_character_literal] = ACTIONS(11259),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11259),
    [sym__pair_operator] = ACTIONS(11259),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11259),
    [sym__lazy_and_operator] = ACTIONS(11259),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11259),
    [sym__pipe_left_operator] = ACTIONS(11259),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11259),
    [sym__bitshift_operator] = ACTIONS(11259),
    [sym__power_operator] = ACTIONS(11259),
    [sym__tilde_operator] = ACTIONS(11259),
    [sym__type_order_operator] = ACTIONS(11259),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym__terminator_token1] = ACTIONS(11261),
    [aux_sym__terminator_token2] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8627] = {
    [sym_block_comment] = STATE(8627),
    [sym_line_comment] = STATE(8627),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_RBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_RBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8628] = {
    [sym_block_comment] = STATE(8628),
    [sym_line_comment] = STATE(8628),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(11108),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8629] = {
    [sym_block_comment] = STATE(8629),
    [sym_line_comment] = STATE(8629),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8630] = {
    [sym_block_comment] = STATE(8630),
    [sym_line_comment] = STATE(8630),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8631] = {
    [sym_block_comment] = STATE(8631),
    [sym_line_comment] = STATE(8631),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_as] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8632] = {
    [sym_block_comment] = STATE(8632),
    [sym_line_comment] = STATE(8632),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8633] = {
    [sym_block_comment] = STATE(8633),
    [sym_line_comment] = STATE(8633),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11291),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_end] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11291),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11291),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11291),
    [anon_sym_DOLLAR] = ACTIONS(11291),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11291),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11291),
    [anon_sym_QMARK] = ACTIONS(11291),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11291),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11291),
    [aux_sym_integer_literal_token2] = ACTIONS(11291),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11291),
    [aux_sym_float_literal_token3] = ACTIONS(11291),
    [aux_sym_float_literal_token4] = ACTIONS(11291),
    [sym_character_literal] = ACTIONS(11291),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11291),
    [sym__pair_operator] = ACTIONS(11291),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11291),
    [sym__lazy_and_operator] = ACTIONS(11291),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11291),
    [sym__pipe_left_operator] = ACTIONS(11291),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11291),
    [sym__bitshift_operator] = ACTIONS(11291),
    [sym__power_operator] = ACTIONS(11291),
    [sym__tilde_operator] = ACTIONS(11291),
    [sym__type_order_operator] = ACTIONS(11291),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym__terminator_token1] = ACTIONS(11293),
    [aux_sym__terminator_token2] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8634] = {
    [sym_block_comment] = STATE(8634),
    [sym_line_comment] = STATE(8634),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8635] = {
    [sym_block_comment] = STATE(8635),
    [sym_line_comment] = STATE(8635),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10292),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10180),
  },
  [8636] = {
    [sym_block_comment] = STATE(8636),
    [sym_line_comment] = STATE(8636),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8637] = {
    [sym_block_comment] = STATE(8637),
    [sym_line_comment] = STATE(8637),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_catch] = ACTIONS(11864),
    [anon_sym_finally] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12403),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(12403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12403),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12403),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8638] = {
    [sym_block_comment] = STATE(8638),
    [sym_line_comment] = STATE(8638),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8639] = {
    [sym_block_comment] = STATE(8639),
    [sym_line_comment] = STATE(8639),
    [aux_sym__import_list_repeat1] = STATE(9097),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(12421),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(12423),
    [anon_sym_LPAREN] = ACTIONS(10755),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10755),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10755),
    [anon_sym_DOLLAR] = ACTIONS(10755),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10755),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10755),
    [anon_sym_QMARK] = ACTIONS(10755),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10755),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10755),
    [aux_sym_integer_literal_token2] = ACTIONS(10755),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10755),
    [aux_sym_float_literal_token3] = ACTIONS(10755),
    [aux_sym_float_literal_token4] = ACTIONS(10755),
    [sym_character_literal] = ACTIONS(10755),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10755),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10755),
    [sym__pair_operator] = ACTIONS(10755),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10755),
    [sym__lazy_and_operator] = ACTIONS(10755),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10755),
    [sym__pipe_left_operator] = ACTIONS(10755),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10755),
    [sym__bitshift_operator] = ACTIONS(10755),
    [sym__power_operator] = ACTIONS(10755),
    [sym__tilde_operator] = ACTIONS(10755),
    [sym__type_order_operator] = ACTIONS(10755),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8640] = {
    [sym_block_comment] = STATE(8640),
    [sym_line_comment] = STATE(8640),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8641] = {
    [sym_block_comment] = STATE(8641),
    [sym_line_comment] = STATE(8641),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8642] = {
    [sym_block_comment] = STATE(8642),
    [sym_line_comment] = STATE(8642),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8643] = {
    [sym_block_comment] = STATE(8643),
    [sym_line_comment] = STATE(8643),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8644] = {
    [sym_block_comment] = STATE(8644),
    [sym_line_comment] = STATE(8644),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8645] = {
    [sym_block_comment] = STATE(8645),
    [sym_line_comment] = STATE(8645),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8646] = {
    [sym_block_comment] = STATE(8646),
    [sym_line_comment] = STATE(8646),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_RBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_RBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8647] = {
    [sym_block_comment] = STATE(8647),
    [sym_line_comment] = STATE(8647),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_RBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_RBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8648] = {
    [sym_block_comment] = STATE(8648),
    [sym_line_comment] = STATE(8648),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11305),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_end] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11305),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11305),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11305),
    [anon_sym_DOLLAR] = ACTIONS(11305),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11305),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11305),
    [anon_sym_QMARK] = ACTIONS(11305),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11305),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11305),
    [aux_sym_integer_literal_token2] = ACTIONS(11305),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11305),
    [aux_sym_float_literal_token3] = ACTIONS(11305),
    [aux_sym_float_literal_token4] = ACTIONS(11305),
    [sym_character_literal] = ACTIONS(11305),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11305),
    [sym__pair_operator] = ACTIONS(11305),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11305),
    [sym__lazy_and_operator] = ACTIONS(11305),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11305),
    [sym__pipe_left_operator] = ACTIONS(11305),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11305),
    [sym__bitshift_operator] = ACTIONS(11305),
    [sym__power_operator] = ACTIONS(11305),
    [sym__tilde_operator] = ACTIONS(11305),
    [sym__type_order_operator] = ACTIONS(11305),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym__terminator_token1] = ACTIONS(11307),
    [aux_sym__terminator_token2] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8649] = {
    [sym_block_comment] = STATE(8649),
    [sym_line_comment] = STATE(8649),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11517),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_end] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11517),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11517),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11517),
    [anon_sym_DOLLAR] = ACTIONS(11517),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11517),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11517),
    [anon_sym_QMARK] = ACTIONS(11517),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11517),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11517),
    [aux_sym_integer_literal_token2] = ACTIONS(11517),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11517),
    [aux_sym_float_literal_token3] = ACTIONS(11517),
    [aux_sym_float_literal_token4] = ACTIONS(11517),
    [sym_character_literal] = ACTIONS(11517),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11517),
    [sym__pair_operator] = ACTIONS(11517),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11517),
    [sym__lazy_and_operator] = ACTIONS(11517),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11517),
    [sym__pipe_left_operator] = ACTIONS(11517),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11517),
    [sym__bitshift_operator] = ACTIONS(11517),
    [sym__power_operator] = ACTIONS(11517),
    [sym__tilde_operator] = ACTIONS(11517),
    [sym__type_order_operator] = ACTIONS(11517),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym__terminator_token1] = ACTIONS(11519),
    [aux_sym__terminator_token2] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8650] = {
    [sym_block_comment] = STATE(8650),
    [sym_line_comment] = STATE(8650),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(12425),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8651] = {
    [sym_block_comment] = STATE(8651),
    [sym_line_comment] = STATE(8651),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10579),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_as] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10579),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10579),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10579),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10579),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10579),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10579),
    [anon_sym_QMARK] = ACTIONS(10579),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10579),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10579),
    [aux_sym_integer_literal_token2] = ACTIONS(10579),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10579),
    [aux_sym_float_literal_token3] = ACTIONS(10579),
    [aux_sym_float_literal_token4] = ACTIONS(10579),
    [sym_character_literal] = ACTIONS(10579),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10579),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10579),
    [sym__pair_operator] = ACTIONS(10579),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10579),
    [sym__lazy_and_operator] = ACTIONS(10579),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10579),
    [sym__pipe_left_operator] = ACTIONS(10579),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10579),
    [sym__bitshift_operator] = ACTIONS(10579),
    [sym__power_operator] = ACTIONS(10579),
    [sym__tilde_operator] = ACTIONS(10579),
    [sym__type_order_operator] = ACTIONS(10579),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8652] = {
    [sym_block_comment] = STATE(8652),
    [sym_line_comment] = STATE(8652),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11924),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_end] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11924),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11924),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11924),
    [anon_sym_DOLLAR] = ACTIONS(11924),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11924),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11924),
    [anon_sym_QMARK] = ACTIONS(11924),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11924),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11924),
    [aux_sym_integer_literal_token2] = ACTIONS(11924),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11924),
    [aux_sym_float_literal_token3] = ACTIONS(11924),
    [aux_sym_float_literal_token4] = ACTIONS(11924),
    [sym_character_literal] = ACTIONS(11924),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11924),
    [sym__pair_operator] = ACTIONS(11924),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11924),
    [sym__lazy_and_operator] = ACTIONS(11924),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11924),
    [sym__pipe_left_operator] = ACTIONS(11924),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11924),
    [sym__bitshift_operator] = ACTIONS(11924),
    [sym__power_operator] = ACTIONS(11924),
    [sym__tilde_operator] = ACTIONS(11924),
    [sym__type_order_operator] = ACTIONS(11924),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym__terminator_token1] = ACTIONS(11926),
    [aux_sym__terminator_token2] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8653] = {
    [sym_block_comment] = STATE(8653),
    [sym_line_comment] = STATE(8653),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_RBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_RBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8654] = {
    [sym_block_comment] = STATE(8654),
    [sym_line_comment] = STATE(8654),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11941),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_end] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11941),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11941),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11941),
    [anon_sym_DOLLAR] = ACTIONS(11941),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11941),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11941),
    [anon_sym_QMARK] = ACTIONS(11941),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11941),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11941),
    [aux_sym_integer_literal_token2] = ACTIONS(11941),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11941),
    [aux_sym_float_literal_token3] = ACTIONS(11941),
    [aux_sym_float_literal_token4] = ACTIONS(11941),
    [sym_character_literal] = ACTIONS(11941),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11941),
    [sym__pair_operator] = ACTIONS(11941),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11941),
    [sym__lazy_and_operator] = ACTIONS(11941),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11941),
    [sym__pipe_left_operator] = ACTIONS(11941),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11941),
    [sym__bitshift_operator] = ACTIONS(11941),
    [sym__power_operator] = ACTIONS(11941),
    [sym__tilde_operator] = ACTIONS(11941),
    [sym__type_order_operator] = ACTIONS(11941),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym__terminator_token1] = ACTIONS(11943),
    [aux_sym__terminator_token2] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8655] = {
    [sym_block_comment] = STATE(8655),
    [sym_line_comment] = STATE(8655),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11965),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_end] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11965),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11965),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11965),
    [anon_sym_DOLLAR] = ACTIONS(11965),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11965),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11965),
    [anon_sym_QMARK] = ACTIONS(11965),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11965),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11965),
    [aux_sym_integer_literal_token2] = ACTIONS(11965),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11965),
    [aux_sym_float_literal_token3] = ACTIONS(11965),
    [aux_sym_float_literal_token4] = ACTIONS(11965),
    [sym_character_literal] = ACTIONS(11965),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11965),
    [sym__pair_operator] = ACTIONS(11965),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11965),
    [sym__lazy_and_operator] = ACTIONS(11965),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11965),
    [sym__pipe_left_operator] = ACTIONS(11965),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11965),
    [sym__bitshift_operator] = ACTIONS(11965),
    [sym__power_operator] = ACTIONS(11965),
    [sym__tilde_operator] = ACTIONS(11965),
    [sym__type_order_operator] = ACTIONS(11965),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym__terminator_token1] = ACTIONS(11967),
    [aux_sym__terminator_token2] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8656] = {
    [sym_block_comment] = STATE(8656),
    [sym_line_comment] = STATE(8656),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11969),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_end] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11969),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11969),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11969),
    [anon_sym_DOLLAR] = ACTIONS(11969),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11969),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11969),
    [anon_sym_QMARK] = ACTIONS(11969),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11969),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11969),
    [aux_sym_integer_literal_token2] = ACTIONS(11969),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11969),
    [aux_sym_float_literal_token3] = ACTIONS(11969),
    [aux_sym_float_literal_token4] = ACTIONS(11969),
    [sym_character_literal] = ACTIONS(11969),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11969),
    [sym__pair_operator] = ACTIONS(11969),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11969),
    [sym__lazy_and_operator] = ACTIONS(11969),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11969),
    [sym__pipe_left_operator] = ACTIONS(11969),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11969),
    [sym__bitshift_operator] = ACTIONS(11969),
    [sym__power_operator] = ACTIONS(11969),
    [sym__tilde_operator] = ACTIONS(11969),
    [sym__type_order_operator] = ACTIONS(11969),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym__terminator_token1] = ACTIONS(11971),
    [aux_sym__terminator_token2] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8657] = {
    [sym_block_comment] = STATE(8657),
    [sym_line_comment] = STATE(8657),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10200),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8658] = {
    [sym_block_comment] = STATE(8658),
    [sym_line_comment] = STATE(8658),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_elseif] = ACTIONS(11275),
    [anon_sym_else] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8659] = {
    [sym_block_comment] = STATE(8659),
    [sym_line_comment] = STATE(8659),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(12437),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_RBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_RBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8660] = {
    [sym_block_comment] = STATE(8660),
    [sym_line_comment] = STATE(8660),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8661] = {
    [sym_block_comment] = STATE(8661),
    [sym_line_comment] = STATE(8661),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8662] = {
    [sym_block_comment] = STATE(8662),
    [sym_line_comment] = STATE(8662),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8663] = {
    [sym_block_comment] = STATE(8663),
    [sym_line_comment] = STATE(8663),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8664] = {
    [sym_block_comment] = STATE(8664),
    [sym_line_comment] = STATE(8664),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8665] = {
    [sym_block_comment] = STATE(8665),
    [sym_line_comment] = STATE(8665),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8666] = {
    [sym_block_comment] = STATE(8666),
    [sym_line_comment] = STATE(8666),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8667] = {
    [sym_block_comment] = STATE(8667),
    [sym_line_comment] = STATE(8667),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8668] = {
    [sym_block_comment] = STATE(8668),
    [sym_line_comment] = STATE(8668),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8669] = {
    [sym_block_comment] = STATE(8669),
    [sym_line_comment] = STATE(8669),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8670] = {
    [sym_block_comment] = STATE(8670),
    [sym_line_comment] = STATE(8670),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8671] = {
    [sym_block_comment] = STATE(8671),
    [sym_line_comment] = STATE(8671),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8672] = {
    [sym_block_comment] = STATE(8672),
    [sym_line_comment] = STATE(8672),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10928),
    [anon_sym_EQ] = ACTIONS(12425),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10928),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10928),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10928),
    [anon_sym_DOLLAR] = ACTIONS(10928),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10928),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10928),
    [anon_sym_QMARK] = ACTIONS(10928),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10928),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10928),
    [aux_sym_integer_literal_token2] = ACTIONS(10928),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10928),
    [aux_sym_float_literal_token3] = ACTIONS(10928),
    [aux_sym_float_literal_token4] = ACTIONS(10928),
    [sym_character_literal] = ACTIONS(10928),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10928),
    [sym__pair_operator] = ACTIONS(10928),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10928),
    [sym__lazy_and_operator] = ACTIONS(10928),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10928),
    [sym__pipe_left_operator] = ACTIONS(10928),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10928),
    [sym__bitshift_operator] = ACTIONS(10928),
    [sym__power_operator] = ACTIONS(10928),
    [sym__tilde_operator] = ACTIONS(10928),
    [sym__type_order_operator] = ACTIONS(10928),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym__terminator_token1] = ACTIONS(10964),
    [aux_sym__terminator_token2] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8673] = {
    [sym_block_comment] = STATE(8673),
    [sym_line_comment] = STATE(8673),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(12425),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8674] = {
    [sym_block_comment] = STATE(8674),
    [sym_line_comment] = STATE(8674),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(12425),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8675] = {
    [sym_block_comment] = STATE(8675),
    [sym_line_comment] = STATE(8675),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8676] = {
    [sym_block_comment] = STATE(8676),
    [sym_line_comment] = STATE(8676),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8677] = {
    [sym_block_comment] = STATE(8677),
    [sym_line_comment] = STATE(8677),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_RPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_RBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_RBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8678] = {
    [sym_block_comment] = STATE(8678),
    [sym_line_comment] = STATE(8678),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8679] = {
    [sym_block_comment] = STATE(8679),
    [sym_line_comment] = STATE(8679),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8680] = {
    [sym_block_comment] = STATE(8680),
    [sym_line_comment] = STATE(8680),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12048),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12048),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12048),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12048),
    [anon_sym_DOLLAR] = ACTIONS(12048),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12048),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12048),
    [anon_sym_QMARK] = ACTIONS(12048),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12048),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12048),
    [aux_sym_integer_literal_token2] = ACTIONS(12048),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12048),
    [aux_sym_float_literal_token3] = ACTIONS(12048),
    [aux_sym_float_literal_token4] = ACTIONS(12048),
    [sym_character_literal] = ACTIONS(12048),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12048),
    [sym__pair_operator] = ACTIONS(12048),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12048),
    [sym__lazy_and_operator] = ACTIONS(12048),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12048),
    [sym__pipe_left_operator] = ACTIONS(12048),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12048),
    [sym__bitshift_operator] = ACTIONS(12048),
    [sym__power_operator] = ACTIONS(12048),
    [sym__tilde_operator] = ACTIONS(12048),
    [sym__type_order_operator] = ACTIONS(12048),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym__terminator_token1] = ACTIONS(12050),
    [aux_sym__terminator_token2] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8681] = {
    [sym_block_comment] = STATE(8681),
    [sym_line_comment] = STATE(8681),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(12437),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_RBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_RBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8682] = {
    [sym_block_comment] = STATE(8682),
    [sym_line_comment] = STATE(8682),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(12437),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_RBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_RBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8683] = {
    [sym_block_comment] = STATE(8683),
    [sym_line_comment] = STATE(8683),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(12437),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_RBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_RBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8684] = {
    [sym_block_comment] = STATE(8684),
    [sym_line_comment] = STATE(8684),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8685] = {
    [sym_block_comment] = STATE(8685),
    [sym_line_comment] = STATE(8685),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_as] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8686] = {
    [sym_block_comment] = STATE(8686),
    [sym_line_comment] = STATE(8686),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8687] = {
    [sym_block_comment] = STATE(8687),
    [sym_line_comment] = STATE(8687),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12403),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(12403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(12439),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12441),
    [sym__arrow_operator] = ACTIONS(12443),
    [sym__lazy_or_operator] = ACTIONS(12445),
    [sym__lazy_and_operator] = ACTIONS(12447),
    [sym__comparison_operator] = ACTIONS(12403),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12403),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8688] = {
    [sym_block_comment] = STATE(8688),
    [sym_line_comment] = STATE(8688),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_catch] = ACTIONS(11265),
    [anon_sym_finally] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8689] = {
    [sym_block_comment] = STATE(8689),
    [sym_line_comment] = STATE(8689),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12052),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_end] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12052),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12052),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12052),
    [anon_sym_DOLLAR] = ACTIONS(12052),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12052),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12052),
    [anon_sym_QMARK] = ACTIONS(12052),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12052),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12052),
    [aux_sym_integer_literal_token2] = ACTIONS(12052),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12052),
    [aux_sym_float_literal_token3] = ACTIONS(12052),
    [aux_sym_float_literal_token4] = ACTIONS(12052),
    [sym_character_literal] = ACTIONS(12052),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12052),
    [sym__pair_operator] = ACTIONS(12052),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12052),
    [sym__lazy_and_operator] = ACTIONS(12052),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12052),
    [sym__pipe_left_operator] = ACTIONS(12052),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12052),
    [sym__bitshift_operator] = ACTIONS(12052),
    [sym__power_operator] = ACTIONS(12052),
    [sym__tilde_operator] = ACTIONS(12052),
    [sym__type_order_operator] = ACTIONS(12052),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym__terminator_token1] = ACTIONS(12054),
    [aux_sym__terminator_token2] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8690] = {
    [sym_block_comment] = STATE(8690),
    [sym_line_comment] = STATE(8690),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12403),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(12403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12439),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12443),
    [sym__lazy_or_operator] = ACTIONS(12445),
    [sym__lazy_and_operator] = ACTIONS(12447),
    [sym__comparison_operator] = ACTIONS(12403),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12403),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8691] = {
    [sym_block_comment] = STATE(8691),
    [sym_line_comment] = STATE(8691),
    [ts_builtin_sym_end] = ACTIONS(11277),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_RBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8692] = {
    [sym_block_comment] = STATE(8692),
    [sym_line_comment] = STATE(8692),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(9804),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8693] = {
    [sym_block_comment] = STATE(8693),
    [sym_line_comment] = STATE(8693),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12403),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(12403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12439),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12447),
    [sym__comparison_operator] = ACTIONS(12403),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12403),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8694] = {
    [sym_block_comment] = STATE(8694),
    [sym_line_comment] = STATE(8694),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11033),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_end] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11033),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11033),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11033),
    [anon_sym_DOLLAR] = ACTIONS(11033),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11033),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11033),
    [anon_sym_QMARK] = ACTIONS(11033),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11033),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11033),
    [aux_sym_integer_literal_token2] = ACTIONS(11033),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11033),
    [aux_sym_float_literal_token3] = ACTIONS(11033),
    [aux_sym_float_literal_token4] = ACTIONS(11033),
    [sym_character_literal] = ACTIONS(11033),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11033),
    [sym__pair_operator] = ACTIONS(11033),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11033),
    [sym__lazy_and_operator] = ACTIONS(11033),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11033),
    [sym__pipe_left_operator] = ACTIONS(11033),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11033),
    [sym__bitshift_operator] = ACTIONS(11033),
    [sym__power_operator] = ACTIONS(11033),
    [sym__tilde_operator] = ACTIONS(11033),
    [sym__type_order_operator] = ACTIONS(11033),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym__terminator_token1] = ACTIONS(11035),
    [aux_sym__terminator_token2] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8695] = {
    [sym_block_comment] = STATE(8695),
    [sym_line_comment] = STATE(8695),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11039),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_end] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11039),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11039),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11039),
    [anon_sym_DOLLAR] = ACTIONS(11039),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11039),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11039),
    [anon_sym_QMARK] = ACTIONS(11039),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11039),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11039),
    [aux_sym_integer_literal_token2] = ACTIONS(11039),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11039),
    [aux_sym_float_literal_token3] = ACTIONS(11039),
    [aux_sym_float_literal_token4] = ACTIONS(11039),
    [sym_character_literal] = ACTIONS(11039),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11039),
    [sym__pair_operator] = ACTIONS(11039),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11039),
    [sym__lazy_and_operator] = ACTIONS(11039),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11039),
    [sym__pipe_left_operator] = ACTIONS(11039),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11039),
    [sym__bitshift_operator] = ACTIONS(11039),
    [sym__power_operator] = ACTIONS(11039),
    [sym__tilde_operator] = ACTIONS(11039),
    [sym__type_order_operator] = ACTIONS(11039),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym__terminator_token1] = ACTIONS(11041),
    [aux_sym__terminator_token2] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8696] = {
    [sym_block_comment] = STATE(8696),
    [sym_line_comment] = STATE(8696),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12403),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(12403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12439),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12403),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12403),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8697] = {
    [sym_block_comment] = STATE(8697),
    [sym_line_comment] = STATE(8697),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8698] = {
    [sym_block_comment] = STATE(8698),
    [sym_line_comment] = STATE(8698),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8699] = {
    [sym_block_comment] = STATE(8699),
    [sym_line_comment] = STATE(8699),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8700] = {
    [sym_block_comment] = STATE(8700),
    [sym_line_comment] = STATE(8700),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8701] = {
    [sym_block_comment] = STATE(8701),
    [sym_line_comment] = STATE(8701),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8702] = {
    [sym_block_comment] = STATE(8702),
    [sym_line_comment] = STATE(8702),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11043),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_end] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11043),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11043),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11043),
    [anon_sym_DOLLAR] = ACTIONS(11043),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11043),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11043),
    [anon_sym_QMARK] = ACTIONS(11043),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11043),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11043),
    [aux_sym_integer_literal_token2] = ACTIONS(11043),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11043),
    [aux_sym_float_literal_token3] = ACTIONS(11043),
    [aux_sym_float_literal_token4] = ACTIONS(11043),
    [sym_character_literal] = ACTIONS(11043),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11043),
    [sym__pair_operator] = ACTIONS(11043),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11043),
    [sym__lazy_and_operator] = ACTIONS(11043),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11043),
    [sym__pipe_left_operator] = ACTIONS(11043),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11043),
    [sym__bitshift_operator] = ACTIONS(11043),
    [sym__power_operator] = ACTIONS(11043),
    [sym__tilde_operator] = ACTIONS(11043),
    [sym__type_order_operator] = ACTIONS(11043),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym__terminator_token1] = ACTIONS(11045),
    [aux_sym__terminator_token2] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8703] = {
    [sym_block_comment] = STATE(8703),
    [sym_line_comment] = STATE(8703),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_catch] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8704] = {
    [sym_block_comment] = STATE(8704),
    [sym_line_comment] = STATE(8704),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11116),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_end] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11116),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11116),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11116),
    [anon_sym_DOLLAR] = ACTIONS(11116),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11116),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11116),
    [anon_sym_QMARK] = ACTIONS(11116),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11116),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11116),
    [aux_sym_integer_literal_token2] = ACTIONS(11116),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11116),
    [aux_sym_float_literal_token3] = ACTIONS(11116),
    [aux_sym_float_literal_token4] = ACTIONS(11116),
    [sym_character_literal] = ACTIONS(11116),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11116),
    [sym__pair_operator] = ACTIONS(11116),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11116),
    [sym__lazy_and_operator] = ACTIONS(11116),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11116),
    [sym__pipe_left_operator] = ACTIONS(11116),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11116),
    [sym__bitshift_operator] = ACTIONS(11116),
    [sym__power_operator] = ACTIONS(11116),
    [sym__tilde_operator] = ACTIONS(11116),
    [sym__type_order_operator] = ACTIONS(11116),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym__terminator_token1] = ACTIONS(11118),
    [aux_sym__terminator_token2] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8705] = {
    [sym_block_comment] = STATE(8705),
    [sym_line_comment] = STATE(8705),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10094),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8706] = {
    [sym_block_comment] = STATE(8706),
    [sym_line_comment] = STATE(8706),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(12437),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_RBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_RBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8707] = {
    [sym_block_comment] = STATE(8707),
    [sym_line_comment] = STATE(8707),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11120),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_end] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11120),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11120),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11120),
    [anon_sym_DOLLAR] = ACTIONS(11120),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11120),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11120),
    [anon_sym_QMARK] = ACTIONS(11120),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11120),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11120),
    [aux_sym_integer_literal_token2] = ACTIONS(11120),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11120),
    [aux_sym_float_literal_token3] = ACTIONS(11120),
    [aux_sym_float_literal_token4] = ACTIONS(11120),
    [sym_character_literal] = ACTIONS(11120),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11120),
    [sym__pair_operator] = ACTIONS(11120),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11120),
    [sym__lazy_and_operator] = ACTIONS(11120),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11120),
    [sym__pipe_left_operator] = ACTIONS(11120),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11120),
    [sym__bitshift_operator] = ACTIONS(11120),
    [sym__power_operator] = ACTIONS(11120),
    [sym__tilde_operator] = ACTIONS(11120),
    [sym__type_order_operator] = ACTIONS(11120),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym__terminator_token1] = ACTIONS(11122),
    [aux_sym__terminator_token2] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8708] = {
    [sym_block_comment] = STATE(8708),
    [sym_line_comment] = STATE(8708),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8709] = {
    [sym_block_comment] = STATE(8709),
    [sym_line_comment] = STATE(8709),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8710] = {
    [sym_block_comment] = STATE(8710),
    [sym_line_comment] = STATE(8710),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8711] = {
    [sym_block_comment] = STATE(8711),
    [sym_line_comment] = STATE(8711),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_finally] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8712] = {
    [sym_block_comment] = STATE(8712),
    [sym_line_comment] = STATE(8712),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8713] = {
    [sym_block_comment] = STATE(8713),
    [sym_line_comment] = STATE(8713),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8714] = {
    [sym_block_comment] = STATE(8714),
    [sym_line_comment] = STATE(8714),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8715] = {
    [sym_block_comment] = STATE(8715),
    [sym_line_comment] = STATE(8715),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8716] = {
    [sym_block_comment] = STATE(8716),
    [sym_line_comment] = STATE(8716),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_catch] = ACTIONS(11275),
    [anon_sym_finally] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8717] = {
    [sym_block_comment] = STATE(8717),
    [sym_line_comment] = STATE(8717),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11197),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_end] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11197),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11197),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11197),
    [anon_sym_DOLLAR] = ACTIONS(11197),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11197),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11197),
    [anon_sym_QMARK] = ACTIONS(11197),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11197),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11197),
    [aux_sym_integer_literal_token2] = ACTIONS(11197),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11197),
    [aux_sym_float_literal_token3] = ACTIONS(11197),
    [aux_sym_float_literal_token4] = ACTIONS(11197),
    [sym_character_literal] = ACTIONS(11197),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11197),
    [sym__pair_operator] = ACTIONS(11197),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11197),
    [sym__lazy_and_operator] = ACTIONS(11197),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11197),
    [sym__pipe_left_operator] = ACTIONS(11197),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11197),
    [sym__bitshift_operator] = ACTIONS(11197),
    [sym__power_operator] = ACTIONS(11197),
    [sym__tilde_operator] = ACTIONS(11197),
    [sym__type_order_operator] = ACTIONS(11197),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym__terminator_token1] = ACTIONS(11199),
    [aux_sym__terminator_token2] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8718] = {
    [sym_block_comment] = STATE(8718),
    [sym_line_comment] = STATE(8718),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8719] = {
    [sym_block_comment] = STATE(8719),
    [sym_line_comment] = STATE(8719),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11211),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11211),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11211),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11211),
    [anon_sym_DOLLAR] = ACTIONS(11211),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11211),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11211),
    [anon_sym_QMARK] = ACTIONS(11211),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11211),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11211),
    [aux_sym_integer_literal_token2] = ACTIONS(11211),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11211),
    [aux_sym_float_literal_token3] = ACTIONS(11211),
    [aux_sym_float_literal_token4] = ACTIONS(11211),
    [sym_character_literal] = ACTIONS(11211),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11211),
    [sym__pair_operator] = ACTIONS(11211),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11211),
    [sym__lazy_and_operator] = ACTIONS(11211),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11211),
    [sym__pipe_left_operator] = ACTIONS(11211),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11211),
    [sym__bitshift_operator] = ACTIONS(11211),
    [sym__power_operator] = ACTIONS(11211),
    [sym__tilde_operator] = ACTIONS(11211),
    [sym__type_order_operator] = ACTIONS(11211),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym__terminator_token1] = ACTIONS(11213),
    [aux_sym__terminator_token2] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8720] = {
    [sym_block_comment] = STATE(8720),
    [sym_line_comment] = STATE(8720),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_catch] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8721] = {
    [sym_block_comment] = STATE(8721),
    [sym_line_comment] = STATE(8721),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_finally] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8722] = {
    [sym__primary_expression] = STATE(11377),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(10685),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(8722),
    [sym_line_comment] = STATE(8722),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_elseif] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_DOLLAR] = ACTIONS(10308),
    [anon_sym_COLON2] = ACTIONS(10310),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(1825),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8723] = {
    [sym_block_comment] = STATE(8723),
    [sym_line_comment] = STATE(8723),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11114),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11114),
    [anon_sym_RPAREN] = ACTIONS(11114),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11114),
    [anon_sym_RBRACK] = ACTIONS(11114),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11114),
    [anon_sym_RBRACE] = ACTIONS(11114),
    [anon_sym_DOLLAR] = ACTIONS(11114),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11114),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11114),
    [aux_sym_integer_literal_token2] = ACTIONS(11114),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11114),
    [aux_sym_float_literal_token3] = ACTIONS(11114),
    [aux_sym_float_literal_token4] = ACTIONS(11114),
    [sym_character_literal] = ACTIONS(11114),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11114),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11114),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11114),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8724] = {
    [sym_block_comment] = STATE(8724),
    [sym_line_comment] = STATE(8724),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
  },
  [8725] = {
    [sym_block_comment] = STATE(8725),
    [sym_line_comment] = STATE(8725),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10908),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10908),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10908),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10908),
    [anon_sym_DOLLAR] = ACTIONS(10908),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10908),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10908),
    [anon_sym_QMARK] = ACTIONS(10908),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10908),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10908),
    [aux_sym_integer_literal_token2] = ACTIONS(10908),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10908),
    [aux_sym_float_literal_token3] = ACTIONS(10908),
    [aux_sym_float_literal_token4] = ACTIONS(10908),
    [sym_character_literal] = ACTIONS(10908),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10908),
    [sym__pair_operator] = ACTIONS(10908),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10908),
    [sym__lazy_and_operator] = ACTIONS(10908),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10908),
    [sym__pipe_left_operator] = ACTIONS(10908),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10908),
    [sym__bitshift_operator] = ACTIONS(10908),
    [sym__power_operator] = ACTIONS(10908),
    [sym__tilde_operator] = ACTIONS(10908),
    [sym__type_order_operator] = ACTIONS(10908),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym__terminator_token1] = ACTIONS(10910),
    [aux_sym__terminator_token2] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8726] = {
    [sym_block_comment] = STATE(8726),
    [sym_line_comment] = STATE(8726),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10978),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10978),
    [anon_sym_QMARK] = ACTIONS(10978),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10978),
    [sym__lazy_and_operator] = ACTIONS(10978),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10978),
    [sym__pipe_left_operator] = ACTIONS(10978),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10978),
    [sym__bitshift_operator] = ACTIONS(10978),
    [sym__power_operator] = ACTIONS(10978),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(10978),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8727] = {
    [sym__primary_expression] = STATE(11269),
    [sym__array] = STATE(11286),
    [sym_comprehension_expression] = STATE(11198),
    [sym_matrix_expression] = STATE(11198),
    [sym_vector_expression] = STATE(11198),
    [sym_parenthesized_expression] = STATE(11286),
    [sym_tuple_expression] = STATE(11286),
    [sym_curly_expression] = STATE(11286),
    [sym_adjoint_expression] = STATE(11286),
    [sym_field_expression] = STATE(11286),
    [sym_index_expression] = STATE(11286),
    [sym_parametrized_type_expression] = STATE(11286),
    [sym_call_expression] = STATE(11286),
    [sym_broadcast_call_expression] = STATE(11286),
    [sym__closed_macrocall_expression] = STATE(11286),
    [sym_interpolation_expression] = STATE(11286),
    [sym_quote_expression] = STATE(11286),
    [sym_macro_identifier] = STATE(17548),
    [sym_identifier] = STATE(10753),
    [sym_boolean_literal] = STATE(11286),
    [sym__string] = STATE(11286),
    [sym__delimiter_str_1] = STATE(14484),
    [sym__delimiter_str_3] = STATE(14542),
    [sym__delimiter_cmd_1] = STATE(14549),
    [sym__delimiter_cmd_3] = STATE(14550),
    [sym_string_literal] = STATE(11191),
    [sym_command_literal] = STATE(11191),
    [sym_prefixed_string_literal] = STATE(11191),
    [sym_prefixed_command_literal] = STATE(11191),
    [sym_operator] = STATE(19341),
    [sym_block_comment] = STATE(8727),
    [sym_line_comment] = STATE(8727),
    [sym__word_identifier] = ACTIONS(10250),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_else] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(10252),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(10254),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10256),
    [anon_sym_DOLLAR] = ACTIONS(10258),
    [anon_sym_COLON2] = ACTIONS(10260),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10264),
    [anon_sym_false] = ACTIONS(10264),
    [sym_character_literal] = ACTIONS(10266),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(1825),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8728] = {
    [sym_block_comment] = STATE(8728),
    [sym_line_comment] = STATE(8728),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10635),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10635),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10635),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10635),
    [anon_sym_DOLLAR] = ACTIONS(10635),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10635),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10635),
    [anon_sym_QMARK] = ACTIONS(10635),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10635),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10635),
    [aux_sym_integer_literal_token2] = ACTIONS(10635),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10635),
    [aux_sym_float_literal_token3] = ACTIONS(10635),
    [aux_sym_float_literal_token4] = ACTIONS(10635),
    [sym_character_literal] = ACTIONS(10635),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10635),
    [sym__pair_operator] = ACTIONS(10635),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10635),
    [sym__lazy_and_operator] = ACTIONS(10635),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10635),
    [sym__pipe_left_operator] = ACTIONS(10635),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10635),
    [sym__bitshift_operator] = ACTIONS(10635),
    [sym__power_operator] = ACTIONS(10635),
    [sym__tilde_operator] = ACTIONS(10635),
    [sym__type_order_operator] = ACTIONS(10635),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym__terminator_token1] = ACTIONS(10639),
    [aux_sym__terminator_token2] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8729] = {
    [sym_block_comment] = STATE(8729),
    [sym_line_comment] = STATE(8729),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11269),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_end] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11269),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11269),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11269),
    [anon_sym_DOLLAR] = ACTIONS(11269),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11269),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11269),
    [anon_sym_QMARK] = ACTIONS(11269),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11269),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11269),
    [aux_sym_integer_literal_token2] = ACTIONS(11269),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11269),
    [aux_sym_float_literal_token3] = ACTIONS(11269),
    [aux_sym_float_literal_token4] = ACTIONS(11269),
    [sym_character_literal] = ACTIONS(11269),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11269),
    [sym__pair_operator] = ACTIONS(11269),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11269),
    [sym__lazy_and_operator] = ACTIONS(11269),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11269),
    [sym__pipe_left_operator] = ACTIONS(11269),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11269),
    [sym__bitshift_operator] = ACTIONS(11269),
    [sym__power_operator] = ACTIONS(11269),
    [sym__tilde_operator] = ACTIONS(11269),
    [sym__type_order_operator] = ACTIONS(11269),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym__terminator_token1] = ACTIONS(11271),
    [aux_sym__terminator_token2] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8730] = {
    [sym_block_comment] = STATE(8730),
    [sym_line_comment] = STATE(8730),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11279),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_end] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11279),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11279),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11279),
    [anon_sym_DOLLAR] = ACTIONS(11279),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11279),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11279),
    [anon_sym_QMARK] = ACTIONS(11279),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11279),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11279),
    [aux_sym_integer_literal_token2] = ACTIONS(11279),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11279),
    [aux_sym_float_literal_token3] = ACTIONS(11279),
    [aux_sym_float_literal_token4] = ACTIONS(11279),
    [sym_character_literal] = ACTIONS(11279),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11279),
    [sym__pair_operator] = ACTIONS(11279),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11279),
    [sym__lazy_and_operator] = ACTIONS(11279),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11279),
    [sym__pipe_left_operator] = ACTIONS(11279),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11279),
    [sym__bitshift_operator] = ACTIONS(11279),
    [sym__power_operator] = ACTIONS(11279),
    [sym__tilde_operator] = ACTIONS(11279),
    [sym__type_order_operator] = ACTIONS(11279),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym__terminator_token1] = ACTIONS(11281),
    [aux_sym__terminator_token2] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8731] = {
    [sym_block_comment] = STATE(8731),
    [sym_line_comment] = STATE(8731),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11309),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_end] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11309),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11309),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11309),
    [anon_sym_DOLLAR] = ACTIONS(11309),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11309),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11309),
    [anon_sym_QMARK] = ACTIONS(11309),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11309),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11309),
    [aux_sym_integer_literal_token2] = ACTIONS(11309),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11309),
    [aux_sym_float_literal_token3] = ACTIONS(11309),
    [aux_sym_float_literal_token4] = ACTIONS(11309),
    [sym_character_literal] = ACTIONS(11309),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11309),
    [sym__pair_operator] = ACTIONS(11309),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11309),
    [sym__lazy_and_operator] = ACTIONS(11309),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11309),
    [sym__pipe_left_operator] = ACTIONS(11309),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11309),
    [sym__bitshift_operator] = ACTIONS(11309),
    [sym__power_operator] = ACTIONS(11309),
    [sym__tilde_operator] = ACTIONS(11309),
    [sym__type_order_operator] = ACTIONS(11309),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym__terminator_token1] = ACTIONS(11311),
    [aux_sym__terminator_token2] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8732] = {
    [sym_block_comment] = STATE(8732),
    [sym_line_comment] = STATE(8732),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11317),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_end] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11317),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11317),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11317),
    [anon_sym_DOLLAR] = ACTIONS(11317),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11317),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11317),
    [anon_sym_QMARK] = ACTIONS(11317),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11317),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11317),
    [aux_sym_integer_literal_token2] = ACTIONS(11317),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11317),
    [aux_sym_float_literal_token3] = ACTIONS(11317),
    [aux_sym_float_literal_token4] = ACTIONS(11317),
    [sym_character_literal] = ACTIONS(11317),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11317),
    [sym__pair_operator] = ACTIONS(11317),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11317),
    [sym__lazy_and_operator] = ACTIONS(11317),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11317),
    [sym__pipe_left_operator] = ACTIONS(11317),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11317),
    [sym__bitshift_operator] = ACTIONS(11317),
    [sym__power_operator] = ACTIONS(11317),
    [sym__tilde_operator] = ACTIONS(11317),
    [sym__type_order_operator] = ACTIONS(11317),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym__terminator_token1] = ACTIONS(11319),
    [aux_sym__terminator_token2] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8733] = {
    [sym_block_comment] = STATE(8733),
    [sym_line_comment] = STATE(8733),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11359),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_end] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11359),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11359),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11359),
    [anon_sym_DOLLAR] = ACTIONS(11359),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11359),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11359),
    [anon_sym_QMARK] = ACTIONS(11359),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11359),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11359),
    [aux_sym_integer_literal_token2] = ACTIONS(11359),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11359),
    [aux_sym_float_literal_token3] = ACTIONS(11359),
    [aux_sym_float_literal_token4] = ACTIONS(11359),
    [sym_character_literal] = ACTIONS(11359),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11359),
    [sym__pair_operator] = ACTIONS(11359),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11359),
    [sym__lazy_and_operator] = ACTIONS(11359),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11359),
    [sym__pipe_left_operator] = ACTIONS(11359),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11359),
    [sym__bitshift_operator] = ACTIONS(11359),
    [sym__power_operator] = ACTIONS(11359),
    [sym__tilde_operator] = ACTIONS(11359),
    [sym__type_order_operator] = ACTIONS(11359),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym__terminator_token1] = ACTIONS(11361),
    [aux_sym__terminator_token2] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8734] = {
    [sym_block_comment] = STATE(8734),
    [sym_line_comment] = STATE(8734),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11381),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_end] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11381),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11381),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11381),
    [anon_sym_DOLLAR] = ACTIONS(11381),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11381),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11381),
    [anon_sym_QMARK] = ACTIONS(11381),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11381),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11381),
    [aux_sym_integer_literal_token2] = ACTIONS(11381),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11381),
    [aux_sym_float_literal_token3] = ACTIONS(11381),
    [aux_sym_float_literal_token4] = ACTIONS(11381),
    [sym_character_literal] = ACTIONS(11381),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11381),
    [sym__pair_operator] = ACTIONS(11381),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11381),
    [sym__lazy_and_operator] = ACTIONS(11381),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11381),
    [sym__pipe_left_operator] = ACTIONS(11381),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11381),
    [sym__bitshift_operator] = ACTIONS(11381),
    [sym__power_operator] = ACTIONS(11381),
    [sym__tilde_operator] = ACTIONS(11381),
    [sym__type_order_operator] = ACTIONS(11381),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym__terminator_token1] = ACTIONS(11383),
    [aux_sym__terminator_token2] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8735] = {
    [sym_block_comment] = STATE(8735),
    [sym_line_comment] = STATE(8735),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11407),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_end] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11407),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11407),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11407),
    [anon_sym_DOLLAR] = ACTIONS(11407),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11407),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11407),
    [anon_sym_QMARK] = ACTIONS(11407),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11407),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11407),
    [aux_sym_integer_literal_token2] = ACTIONS(11407),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11407),
    [aux_sym_float_literal_token3] = ACTIONS(11407),
    [aux_sym_float_literal_token4] = ACTIONS(11407),
    [sym_character_literal] = ACTIONS(11407),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11407),
    [sym__pair_operator] = ACTIONS(11407),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11407),
    [sym__lazy_and_operator] = ACTIONS(11407),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11407),
    [sym__pipe_left_operator] = ACTIONS(11407),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11407),
    [sym__bitshift_operator] = ACTIONS(11407),
    [sym__power_operator] = ACTIONS(11407),
    [sym__tilde_operator] = ACTIONS(11407),
    [sym__type_order_operator] = ACTIONS(11407),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym__terminator_token1] = ACTIONS(11409),
    [aux_sym__terminator_token2] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8736] = {
    [sym_block_comment] = STATE(8736),
    [sym_line_comment] = STATE(8736),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8737] = {
    [sym_block_comment] = STATE(8737),
    [sym_line_comment] = STATE(8737),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8738] = {
    [sym_block_comment] = STATE(8738),
    [sym_line_comment] = STATE(8738),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_as] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8739] = {
    [sym_block_comment] = STATE(8739),
    [sym_line_comment] = STATE(8739),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11456),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_end] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11456),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11456),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11456),
    [anon_sym_DOLLAR] = ACTIONS(11456),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11456),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11456),
    [anon_sym_QMARK] = ACTIONS(11456),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11456),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11456),
    [aux_sym_integer_literal_token2] = ACTIONS(11456),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11456),
    [aux_sym_float_literal_token3] = ACTIONS(11456),
    [aux_sym_float_literal_token4] = ACTIONS(11456),
    [sym_character_literal] = ACTIONS(11456),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11456),
    [sym__pair_operator] = ACTIONS(11456),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11456),
    [sym__lazy_and_operator] = ACTIONS(11456),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11456),
    [sym__pipe_left_operator] = ACTIONS(11456),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11456),
    [sym__bitshift_operator] = ACTIONS(11456),
    [sym__power_operator] = ACTIONS(11456),
    [sym__tilde_operator] = ACTIONS(11456),
    [sym__type_order_operator] = ACTIONS(11456),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym__terminator_token1] = ACTIONS(11458),
    [aux_sym__terminator_token2] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8740] = {
    [sym_block_comment] = STATE(8740),
    [sym_line_comment] = STATE(8740),
    [ts_builtin_sym_end] = ACTIONS(11289),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_RBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8741] = {
    [sym_block_comment] = STATE(8741),
    [sym_line_comment] = STATE(8741),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11283),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_end] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11283),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11283),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11283),
    [anon_sym_DOLLAR] = ACTIONS(11283),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11283),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11283),
    [anon_sym_QMARK] = ACTIONS(11283),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11283),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11283),
    [aux_sym_integer_literal_token2] = ACTIONS(11283),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11283),
    [aux_sym_float_literal_token3] = ACTIONS(11283),
    [aux_sym_float_literal_token4] = ACTIONS(11283),
    [sym_character_literal] = ACTIONS(11283),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11283),
    [sym__pair_operator] = ACTIONS(11283),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11283),
    [sym__lazy_and_operator] = ACTIONS(11283),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11283),
    [sym__pipe_left_operator] = ACTIONS(11283),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11283),
    [sym__bitshift_operator] = ACTIONS(11283),
    [sym__power_operator] = ACTIONS(11283),
    [sym__tilde_operator] = ACTIONS(11283),
    [sym__type_order_operator] = ACTIONS(11283),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym__terminator_token1] = ACTIONS(11285),
    [aux_sym__terminator_token2] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8742] = {
    [sym_block_comment] = STATE(8742),
    [sym_line_comment] = STATE(8742),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_RBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_RBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8743] = {
    [sym_block_comment] = STATE(8743),
    [sym_line_comment] = STATE(8743),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_DOT] = ACTIONS(12479),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8744] = {
    [sym_block_comment] = STATE(8744),
    [sym_line_comment] = STATE(8744),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8745] = {
    [sym_block_comment] = STATE(8745),
    [sym_line_comment] = STATE(8745),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(12221),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8746] = {
    [sym_block_comment] = STATE(8746),
    [sym_line_comment] = STATE(8746),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11223),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_end] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11223),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11223),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11223),
    [anon_sym_DOLLAR] = ACTIONS(11223),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11223),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11223),
    [anon_sym_QMARK] = ACTIONS(11223),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11223),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11223),
    [aux_sym_integer_literal_token2] = ACTIONS(11223),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11223),
    [aux_sym_float_literal_token3] = ACTIONS(11223),
    [aux_sym_float_literal_token4] = ACTIONS(11223),
    [sym_character_literal] = ACTIONS(11223),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11223),
    [sym__pair_operator] = ACTIONS(11223),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11223),
    [sym__lazy_and_operator] = ACTIONS(11223),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11223),
    [sym__pipe_left_operator] = ACTIONS(11223),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11223),
    [sym__bitshift_operator] = ACTIONS(11223),
    [sym__power_operator] = ACTIONS(11223),
    [sym__tilde_operator] = ACTIONS(11223),
    [sym__type_order_operator] = ACTIONS(11223),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym__terminator_token1] = ACTIONS(11225),
    [aux_sym__terminator_token2] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8747] = {
    [sym_block_comment] = STATE(8747),
    [sym_line_comment] = STATE(8747),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8748] = {
    [sym_block_comment] = STATE(8748),
    [sym_line_comment] = STATE(8748),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_RBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_RBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8749] = {
    [sym_block_comment] = STATE(8749),
    [sym_line_comment] = STATE(8749),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10980),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_RBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8750] = {
    [sym_block_comment] = STATE(8750),
    [sym_line_comment] = STATE(8750),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10026),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8751] = {
    [sym_block_comment] = STATE(8751),
    [sym_line_comment] = STATE(8751),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10230),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10170),
  },
  [8752] = {
    [sym_block_comment] = STATE(8752),
    [sym_line_comment] = STATE(8752),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8753] = {
    [sym_block_comment] = STATE(8753),
    [sym_line_comment] = STATE(8753),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8754] = {
    [sym_block_comment] = STATE(8754),
    [sym_line_comment] = STATE(8754),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_finally] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12483),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(12483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12485),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12487),
    [sym__arrow_operator] = ACTIONS(12489),
    [sym__lazy_or_operator] = ACTIONS(12491),
    [sym__lazy_and_operator] = ACTIONS(12493),
    [sym__comparison_operator] = ACTIONS(12483),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12483),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8755] = {
    [sym_block_comment] = STATE(8755),
    [sym_line_comment] = STATE(8755),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8756] = {
    [sym_block_comment] = STATE(8756),
    [sym_line_comment] = STATE(8756),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_RBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_RBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8757] = {
    [sym_block_comment] = STATE(8757),
    [sym_line_comment] = STATE(8757),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_elseif] = ACTIONS(11112),
    [anon_sym_else] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12501),
    [sym__arrow_operator] = ACTIONS(12503),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1091),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(1091),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8758] = {
    [sym_block_comment] = STATE(8758),
    [sym_line_comment] = STATE(8758),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8759] = {
    [sym_block_comment] = STATE(8759),
    [sym_line_comment] = STATE(8759),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8760] = {
    [sym_block_comment] = STATE(8760),
    [sym_line_comment] = STATE(8760),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_RBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_RBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8761] = {
    [sym_block_comment] = STATE(8761),
    [sym_line_comment] = STATE(8761),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8762] = {
    [sym_block_comment] = STATE(8762),
    [sym_line_comment] = STATE(8762),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10840),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10840),
    [anon_sym_RPAREN] = ACTIONS(10840),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10840),
    [anon_sym_RBRACK] = ACTIONS(10840),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10840),
    [anon_sym_RBRACE] = ACTIONS(10840),
    [anon_sym_DOLLAR] = ACTIONS(10840),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10840),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10840),
    [aux_sym_integer_literal_token2] = ACTIONS(10840),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10840),
    [aux_sym_float_literal_token3] = ACTIONS(10840),
    [aux_sym_float_literal_token4] = ACTIONS(10840),
    [sym_character_literal] = ACTIONS(10840),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10840),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10840),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10840),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8763] = {
    [sym_block_comment] = STATE(8763),
    [sym_line_comment] = STATE(8763),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_RBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_RBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8764] = {
    [sym_block_comment] = STATE(8764),
    [sym_line_comment] = STATE(8764),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10974),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10974),
    [anon_sym_QMARK] = ACTIONS(10974),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(10974),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10974),
    [sym__lazy_and_operator] = ACTIONS(10974),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10974),
    [sym__pipe_left_operator] = ACTIONS(10974),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10974),
    [sym__bitshift_operator] = ACTIONS(10974),
    [sym__power_operator] = ACTIONS(10974),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(10974),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8765] = {
    [sym_block_comment] = STATE(8765),
    [sym_line_comment] = STATE(8765),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10980),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8766] = {
    [sym_block_comment] = STATE(8766),
    [sym_line_comment] = STATE(8766),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_as] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8767] = {
    [sym_block_comment] = STATE(8767),
    [sym_line_comment] = STATE(8767),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10761),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10761),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10761),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10761),
    [anon_sym_DOLLAR] = ACTIONS(10761),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10761),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10761),
    [anon_sym_QMARK] = ACTIONS(10761),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10761),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10761),
    [aux_sym_integer_literal_token2] = ACTIONS(10761),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10761),
    [aux_sym_float_literal_token3] = ACTIONS(10761),
    [aux_sym_float_literal_token4] = ACTIONS(10761),
    [sym_character_literal] = ACTIONS(10761),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10761),
    [sym__pair_operator] = ACTIONS(10761),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10761),
    [sym__lazy_and_operator] = ACTIONS(10761),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10761),
    [sym__pipe_left_operator] = ACTIONS(10761),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10761),
    [sym__bitshift_operator] = ACTIONS(10761),
    [sym__power_operator] = ACTIONS(10761),
    [sym__tilde_operator] = ACTIONS(10761),
    [sym__type_order_operator] = ACTIONS(10761),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym__terminator_token1] = ACTIONS(10763),
    [aux_sym__terminator_token2] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8768] = {
    [sym_block_comment] = STATE(8768),
    [sym_line_comment] = STATE(8768),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_as] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8769] = {
    [sym_block_comment] = STATE(8769),
    [sym_line_comment] = STATE(8769),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_as] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8770] = {
    [sym_block_comment] = STATE(8770),
    [sym_line_comment] = STATE(8770),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_as] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8771] = {
    [sym_block_comment] = STATE(8771),
    [sym_line_comment] = STATE(8771),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_catch] = ACTIONS(11112),
    [anon_sym_finally] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12401),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12403),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(12403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(12439),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12441),
    [sym__arrow_operator] = ACTIONS(12443),
    [sym__lazy_or_operator] = ACTIONS(12445),
    [sym__lazy_and_operator] = ACTIONS(12447),
    [sym__comparison_operator] = ACTIONS(12403),
    [sym__pipe_right_operator] = ACTIONS(12405),
    [sym__pipe_left_operator] = ACTIONS(12407),
    [sym__ellipsis_operator] = ACTIONS(12409),
    [sym__plus_operator] = ACTIONS(12411),
    [sym__times_operator] = ACTIONS(12413),
    [sym__rational_operator] = ACTIONS(12415),
    [sym__bitshift_operator] = ACTIONS(12417),
    [sym__power_operator] = ACTIONS(12419),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12403),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12411),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8772] = {
    [sym_block_comment] = STATE(8772),
    [sym_line_comment] = STATE(8772),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_catch] = ACTIONS(11247),
    [anon_sym_finally] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8773] = {
    [sym_block_comment] = STATE(8773),
    [sym_line_comment] = STATE(8773),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_as] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8774] = {
    [sym_block_comment] = STATE(8774),
    [sym_line_comment] = STATE(8774),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_catch] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8775] = {
    [sym_block_comment] = STATE(8775),
    [sym_line_comment] = STATE(8775),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_as] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8776] = {
    [sym_block_comment] = STATE(8776),
    [sym_line_comment] = STATE(8776),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_as] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8777] = {
    [sym_block_comment] = STATE(8777),
    [sym_line_comment] = STATE(8777),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_as] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8778] = {
    [sym_block_comment] = STATE(8778),
    [sym_line_comment] = STATE(8778),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_as] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8779] = {
    [sym_block_comment] = STATE(8779),
    [sym_line_comment] = STATE(8779),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_as] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8780] = {
    [sym_block_comment] = STATE(8780),
    [sym_line_comment] = STATE(8780),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10974),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10974),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10974),
    [anon_sym_DOLLAR] = ACTIONS(10974),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10974),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10974),
    [aux_sym_integer_literal_token2] = ACTIONS(10974),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10974),
    [aux_sym_float_literal_token3] = ACTIONS(10974),
    [aux_sym_float_literal_token4] = ACTIONS(10974),
    [sym_character_literal] = ACTIONS(10974),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10974),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10974),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10976),
    [aux_sym__terminator_token2] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8781] = {
    [sym_block_comment] = STATE(8781),
    [sym_line_comment] = STATE(8781),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_as] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8782] = {
    [sym_block_comment] = STATE(8782),
    [sym_line_comment] = STATE(8782),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_catch] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12513),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(12513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12515),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12517),
    [sym__arrow_operator] = ACTIONS(12519),
    [sym__lazy_or_operator] = ACTIONS(12521),
    [sym__lazy_and_operator] = ACTIONS(12523),
    [sym__comparison_operator] = ACTIONS(12513),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12513),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8783] = {
    [sym_block_comment] = STATE(8783),
    [sym_line_comment] = STATE(8783),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_as] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8784] = {
    [sym_block_comment] = STATE(8784),
    [sym_line_comment] = STATE(8784),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11169),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_end] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11169),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11169),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11169),
    [anon_sym_DOLLAR] = ACTIONS(11169),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11169),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11169),
    [anon_sym_QMARK] = ACTIONS(11169),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11169),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11169),
    [aux_sym_integer_literal_token2] = ACTIONS(11169),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11169),
    [aux_sym_float_literal_token3] = ACTIONS(11169),
    [aux_sym_float_literal_token4] = ACTIONS(11169),
    [sym_character_literal] = ACTIONS(11169),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11169),
    [sym__pair_operator] = ACTIONS(11169),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11169),
    [sym__lazy_and_operator] = ACTIONS(11169),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11169),
    [sym__pipe_left_operator] = ACTIONS(11169),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11169),
    [sym__bitshift_operator] = ACTIONS(11169),
    [sym__power_operator] = ACTIONS(11169),
    [sym__tilde_operator] = ACTIONS(11169),
    [sym__type_order_operator] = ACTIONS(11169),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym__terminator_token1] = ACTIONS(11171),
    [aux_sym__terminator_token2] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8785] = {
    [sym_block_comment] = STATE(8785),
    [sym_line_comment] = STATE(8785),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11287),
    [anon_sym_QMARK] = ACTIONS(11287),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11287),
    [sym__lazy_and_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8786] = {
    [sym_block_comment] = STATE(8786),
    [sym_line_comment] = STATE(8786),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_as] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8787] = {
    [sym_block_comment] = STATE(8787),
    [sym_line_comment] = STATE(8787),
    [ts_builtin_sym_end] = ACTIONS(11267),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_RBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8788] = {
    [sym_block_comment] = STATE(8788),
    [sym_line_comment] = STATE(8788),
    [aux_sym__import_list_repeat1] = STATE(9097),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(12421),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_as] = ACTIONS(12423),
    [anon_sym_LPAREN] = ACTIONS(10755),
    [anon_sym_COLON] = ACTIONS(12531),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10755),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10755),
    [anon_sym_DOLLAR] = ACTIONS(10755),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10755),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10755),
    [anon_sym_QMARK] = ACTIONS(10755),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10755),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10755),
    [aux_sym_integer_literal_token2] = ACTIONS(10755),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10755),
    [aux_sym_float_literal_token3] = ACTIONS(10755),
    [aux_sym_float_literal_token4] = ACTIONS(10755),
    [sym_character_literal] = ACTIONS(10755),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10755),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10755),
    [sym__pair_operator] = ACTIONS(10755),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10755),
    [sym__lazy_and_operator] = ACTIONS(10755),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10755),
    [sym__pipe_left_operator] = ACTIONS(10755),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10755),
    [sym__bitshift_operator] = ACTIONS(10755),
    [sym__power_operator] = ACTIONS(10755),
    [sym__tilde_operator] = ACTIONS(10755),
    [sym__type_order_operator] = ACTIONS(10755),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8789] = {
    [sym_block_comment] = STATE(8789),
    [sym_line_comment] = STATE(8789),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10759),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10759),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10759),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10759),
    [anon_sym_DOT] = ACTIONS(12479),
    [anon_sym_DOLLAR] = ACTIONS(10759),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10759),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10759),
    [anon_sym_QMARK] = ACTIONS(10759),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10759),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10759),
    [aux_sym_integer_literal_token2] = ACTIONS(10759),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10759),
    [aux_sym_float_literal_token3] = ACTIONS(10759),
    [aux_sym_float_literal_token4] = ACTIONS(10759),
    [sym_character_literal] = ACTIONS(10759),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10759),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10759),
    [sym__pair_operator] = ACTIONS(10759),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10759),
    [sym__lazy_and_operator] = ACTIONS(10759),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10759),
    [sym__pipe_left_operator] = ACTIONS(10759),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10759),
    [sym__bitshift_operator] = ACTIONS(10759),
    [sym__power_operator] = ACTIONS(10759),
    [sym__tilde_operator] = ACTIONS(10759),
    [sym__type_order_operator] = ACTIONS(10759),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8790] = {
    [sym_block_comment] = STATE(8790),
    [sym_line_comment] = STATE(8790),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8791] = {
    [sym_block_comment] = STATE(8791),
    [sym_line_comment] = STATE(8791),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_as] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8792] = {
    [sym_block_comment] = STATE(8792),
    [sym_line_comment] = STATE(8792),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_as] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8793] = {
    [sym_block_comment] = STATE(8793),
    [sym_line_comment] = STATE(8793),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_as] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8794] = {
    [sym_block_comment] = STATE(8794),
    [sym_line_comment] = STATE(8794),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10763),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10763),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10763),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10763),
    [anon_sym_DOT] = ACTIONS(12479),
    [anon_sym_DOLLAR] = ACTIONS(10763),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10763),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10763),
    [anon_sym_QMARK] = ACTIONS(10763),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10763),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10763),
    [aux_sym_integer_literal_token2] = ACTIONS(10763),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10763),
    [aux_sym_float_literal_token3] = ACTIONS(10763),
    [aux_sym_float_literal_token4] = ACTIONS(10763),
    [sym_character_literal] = ACTIONS(10763),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10763),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10763),
    [sym__pair_operator] = ACTIONS(10763),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10763),
    [sym__lazy_and_operator] = ACTIONS(10763),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10763),
    [sym__pipe_left_operator] = ACTIONS(10763),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10763),
    [sym__bitshift_operator] = ACTIONS(10763),
    [sym__power_operator] = ACTIONS(10763),
    [sym__tilde_operator] = ACTIONS(10763),
    [sym__type_order_operator] = ACTIONS(10763),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8795] = {
    [sym_block_comment] = STATE(8795),
    [sym_line_comment] = STATE(8795),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(12533),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8796] = {
    [sym_block_comment] = STATE(8796),
    [sym_line_comment] = STATE(8796),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_RPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_RBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_RBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8797] = {
    [sym_block_comment] = STATE(8797),
    [sym_line_comment] = STATE(8797),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_as] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8798] = {
    [sym_block_comment] = STATE(8798),
    [sym_line_comment] = STATE(8798),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_RPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_RBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_RBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12263),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8799] = {
    [sym_block_comment] = STATE(8799),
    [sym_line_comment] = STATE(8799),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11247),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11247),
    [anon_sym_QMARK] = ACTIONS(11247),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11247),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11247),
    [sym__lazy_and_operator] = ACTIONS(11247),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11247),
    [sym__pipe_left_operator] = ACTIONS(11247),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11247),
    [sym__bitshift_operator] = ACTIONS(11247),
    [sym__power_operator] = ACTIONS(11247),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11247),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8800] = {
    [sym_block_comment] = STATE(8800),
    [sym_line_comment] = STATE(8800),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_elseif] = ACTIONS(11247),
    [anon_sym_else] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12331),
    [sym__arrow_operator] = ACTIONS(12333),
    [sym__lazy_or_operator] = ACTIONS(12335),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8801] = {
    [sym_block_comment] = STATE(8801),
    [sym_line_comment] = STATE(8801),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8802] = {
    [sym_block_comment] = STATE(8802),
    [sym_line_comment] = STATE(8802),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8803] = {
    [sym_block_comment] = STATE(8803),
    [sym_line_comment] = STATE(8803),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_as] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8804] = {
    [sym_block_comment] = STATE(8804),
    [sym_line_comment] = STATE(8804),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_as] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8805] = {
    [sym_block_comment] = STATE(8805),
    [sym_line_comment] = STATE(8805),
    [aux_sym_open_tuple_repeat1] = STATE(8148),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12170),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_RBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_RBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8806] = {
    [sym_block_comment] = STATE(8806),
    [sym_line_comment] = STATE(8806),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_RPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10982),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8807] = {
    [sym_block_comment] = STATE(8807),
    [sym_line_comment] = STATE(8807),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10966),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10966),
    [anon_sym_QMARK] = ACTIONS(10966),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(10966),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10966),
    [sym__lazy_and_operator] = ACTIONS(10966),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10966),
    [sym__pipe_left_operator] = ACTIONS(10966),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10966),
    [sym__bitshift_operator] = ACTIONS(10966),
    [sym__power_operator] = ACTIONS(10966),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(10966),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8808] = {
    [sym_block_comment] = STATE(8808),
    [sym_line_comment] = STATE(8808),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10966),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10966),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10966),
    [anon_sym_DOLLAR] = ACTIONS(10966),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10966),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10966),
    [aux_sym_integer_literal_token2] = ACTIONS(10966),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10966),
    [aux_sym_float_literal_token3] = ACTIONS(10966),
    [aux_sym_float_literal_token4] = ACTIONS(10966),
    [sym_character_literal] = ACTIONS(10966),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10966),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10966),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10968),
    [aux_sym__terminator_token2] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8809] = {
    [sym_block_comment] = STATE(8809),
    [sym_line_comment] = STATE(8809),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_as] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8810] = {
    [sym_block_comment] = STATE(8810),
    [sym_line_comment] = STATE(8810),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10976),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8811] = {
    [sym_block_comment] = STATE(8811),
    [sym_line_comment] = STATE(8811),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_as] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8812] = {
    [sym_block_comment] = STATE(8812),
    [sym_line_comment] = STATE(8812),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11331),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_end] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11331),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11331),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11331),
    [anon_sym_DOLLAR] = ACTIONS(11331),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11331),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11331),
    [anon_sym_QMARK] = ACTIONS(11331),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11331),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11331),
    [aux_sym_integer_literal_token2] = ACTIONS(11331),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11331),
    [aux_sym_float_literal_token3] = ACTIONS(11331),
    [aux_sym_float_literal_token4] = ACTIONS(11331),
    [sym_character_literal] = ACTIONS(11331),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11331),
    [sym__pair_operator] = ACTIONS(11331),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11331),
    [sym__lazy_and_operator] = ACTIONS(11331),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11331),
    [sym__pipe_left_operator] = ACTIONS(11331),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11331),
    [sym__bitshift_operator] = ACTIONS(11331),
    [sym__power_operator] = ACTIONS(11331),
    [sym__tilde_operator] = ACTIONS(11331),
    [sym__type_order_operator] = ACTIONS(11331),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym__terminator_token1] = ACTIONS(11333),
    [aux_sym__terminator_token2] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8813] = {
    [sym_block_comment] = STATE(8813),
    [sym_line_comment] = STATE(8813),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_catch] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11668),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11670),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11670),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(11678),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11680),
    [sym__arrow_operator] = ACTIONS(11682),
    [sym__lazy_or_operator] = ACTIONS(11684),
    [sym__lazy_and_operator] = ACTIONS(11686),
    [sym__comparison_operator] = ACTIONS(11670),
    [sym__pipe_right_operator] = ACTIONS(11688),
    [sym__pipe_left_operator] = ACTIONS(11690),
    [sym__ellipsis_operator] = ACTIONS(11692),
    [sym__plus_operator] = ACTIONS(11694),
    [sym__times_operator] = ACTIONS(11696),
    [sym__rational_operator] = ACTIONS(11698),
    [sym__bitshift_operator] = ACTIONS(11700),
    [sym__power_operator] = ACTIONS(11702),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11670),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11694),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8814] = {
    [sym_block_comment] = STATE(8814),
    [sym_line_comment] = STATE(8814),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10964),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8815] = {
    [sym_block_comment] = STATE(8815),
    [sym_line_comment] = STATE(8815),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10968),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8816] = {
    [sym_block_comment] = STATE(8816),
    [sym_line_comment] = STATE(8816),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8817] = {
    [sym_block_comment] = STATE(8817),
    [sym_line_comment] = STATE(8817),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_catch] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12513),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(12513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12513),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12513),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8818] = {
    [sym_block_comment] = STATE(8818),
    [sym_line_comment] = STATE(8818),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10270),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10148),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8819] = {
    [sym_block_comment] = STATE(8819),
    [sym_line_comment] = STATE(8819),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10270),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [8820] = {
    [sym_block_comment] = STATE(8820),
    [sym_line_comment] = STATE(8820),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_as] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8821] = {
    [sym_block_comment] = STATE(8821),
    [sym_line_comment] = STATE(8821),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11472),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_end] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11472),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11472),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11472),
    [anon_sym_DOLLAR] = ACTIONS(11472),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11472),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11472),
    [anon_sym_QMARK] = ACTIONS(11472),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11472),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11472),
    [aux_sym_integer_literal_token2] = ACTIONS(11472),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11472),
    [aux_sym_float_literal_token3] = ACTIONS(11472),
    [aux_sym_float_literal_token4] = ACTIONS(11472),
    [sym_character_literal] = ACTIONS(11472),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11472),
    [sym__pair_operator] = ACTIONS(11472),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11472),
    [sym__lazy_and_operator] = ACTIONS(11472),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11472),
    [sym__pipe_left_operator] = ACTIONS(11472),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11472),
    [sym__bitshift_operator] = ACTIONS(11472),
    [sym__power_operator] = ACTIONS(11472),
    [sym__tilde_operator] = ACTIONS(11472),
    [sym__type_order_operator] = ACTIONS(11472),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym__terminator_token1] = ACTIONS(11474),
    [aux_sym__terminator_token2] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8822] = {
    [sym_block_comment] = STATE(8822),
    [sym_line_comment] = STATE(8822),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8823] = {
    [sym_block_comment] = STATE(8823),
    [sym_line_comment] = STATE(8823),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12229),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8824] = {
    [sym_block_comment] = STATE(8824),
    [sym_line_comment] = STATE(8824),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_as] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8825] = {
    [sym_block_comment] = STATE(8825),
    [sym_line_comment] = STATE(8825),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11020),
    [anon_sym_EQ] = ACTIONS(12425),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11020),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11020),
    [anon_sym_QMARK] = ACTIONS(11020),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(11020),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11020),
    [sym__lazy_and_operator] = ACTIONS(11020),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11020),
    [sym__pipe_left_operator] = ACTIONS(11020),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11020),
    [sym__bitshift_operator] = ACTIONS(11020),
    [sym__power_operator] = ACTIONS(11020),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(11020),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8826] = {
    [sym_block_comment] = STATE(8826),
    [sym_line_comment] = STATE(8826),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11499),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_end] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11499),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11499),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11499),
    [anon_sym_DOLLAR] = ACTIONS(11499),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11499),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11499),
    [anon_sym_QMARK] = ACTIONS(11499),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11499),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11499),
    [aux_sym_integer_literal_token2] = ACTIONS(11499),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11499),
    [aux_sym_float_literal_token3] = ACTIONS(11499),
    [aux_sym_float_literal_token4] = ACTIONS(11499),
    [sym_character_literal] = ACTIONS(11499),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11499),
    [sym__pair_operator] = ACTIONS(11499),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11499),
    [sym__lazy_and_operator] = ACTIONS(11499),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11499),
    [sym__pipe_left_operator] = ACTIONS(11499),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11499),
    [sym__bitshift_operator] = ACTIONS(11499),
    [sym__power_operator] = ACTIONS(11499),
    [sym__tilde_operator] = ACTIONS(11499),
    [sym__type_order_operator] = ACTIONS(11499),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym__terminator_token1] = ACTIONS(11501),
    [aux_sym__terminator_token2] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8827] = {
    [sym_block_comment] = STATE(8827),
    [sym_line_comment] = STATE(8827),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_as] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8828] = {
    [sym_block_comment] = STATE(8828),
    [sym_line_comment] = STATE(8828),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11513),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_end] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11513),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11513),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11513),
    [anon_sym_DOLLAR] = ACTIONS(11513),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11513),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11513),
    [anon_sym_QMARK] = ACTIONS(11513),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11513),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11513),
    [aux_sym_integer_literal_token2] = ACTIONS(11513),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11513),
    [aux_sym_float_literal_token3] = ACTIONS(11513),
    [aux_sym_float_literal_token4] = ACTIONS(11513),
    [sym_character_literal] = ACTIONS(11513),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11513),
    [sym__pair_operator] = ACTIONS(11513),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11513),
    [sym__lazy_and_operator] = ACTIONS(11513),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11513),
    [sym__pipe_left_operator] = ACTIONS(11513),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11513),
    [sym__bitshift_operator] = ACTIONS(11513),
    [sym__power_operator] = ACTIONS(11513),
    [sym__tilde_operator] = ACTIONS(11513),
    [sym__type_order_operator] = ACTIONS(11513),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym__terminator_token1] = ACTIONS(11515),
    [aux_sym__terminator_token2] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8829] = {
    [sym_block_comment] = STATE(8829),
    [sym_line_comment] = STATE(8829),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11251),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_end] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11251),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11251),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11251),
    [anon_sym_DOLLAR] = ACTIONS(11251),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11251),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11251),
    [anon_sym_QMARK] = ACTIONS(11251),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11251),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11251),
    [aux_sym_integer_literal_token2] = ACTIONS(11251),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11251),
    [aux_sym_float_literal_token3] = ACTIONS(11251),
    [aux_sym_float_literal_token4] = ACTIONS(11251),
    [sym_character_literal] = ACTIONS(11251),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11251),
    [sym__pair_operator] = ACTIONS(11251),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11251),
    [sym__lazy_and_operator] = ACTIONS(11251),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11251),
    [sym__pipe_left_operator] = ACTIONS(11251),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11251),
    [sym__bitshift_operator] = ACTIONS(11251),
    [sym__power_operator] = ACTIONS(11251),
    [sym__tilde_operator] = ACTIONS(11251),
    [sym__type_order_operator] = ACTIONS(11251),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym__terminator_token1] = ACTIONS(11253),
    [aux_sym__terminator_token2] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8830] = {
    [sym_block_comment] = STATE(8830),
    [sym_line_comment] = STATE(8830),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_as] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8831] = {
    [sym_block_comment] = STATE(8831),
    [sym_line_comment] = STATE(8831),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10206),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8832] = {
    [sym_block_comment] = STATE(8832),
    [sym_line_comment] = STATE(8832),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8833] = {
    [sym_block_comment] = STATE(8833),
    [sym_line_comment] = STATE(8833),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_as] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8834] = {
    [sym_block_comment] = STATE(8834),
    [sym_line_comment] = STATE(8834),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10094),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8835] = {
    [sym_block_comment] = STATE(8835),
    [sym_line_comment] = STATE(8835),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8836] = {
    [sym_block_comment] = STATE(8836),
    [sym_line_comment] = STATE(8836),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_elseif] = ACTIONS(11287),
    [anon_sym_else] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12323),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12325),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(12325),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(12329),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12331),
    [sym__arrow_operator] = ACTIONS(12333),
    [sym__lazy_or_operator] = ACTIONS(12335),
    [sym__lazy_and_operator] = ACTIONS(12337),
    [sym__comparison_operator] = ACTIONS(12325),
    [sym__pipe_right_operator] = ACTIONS(12339),
    [sym__pipe_left_operator] = ACTIONS(12341),
    [sym__ellipsis_operator] = ACTIONS(12343),
    [sym__plus_operator] = ACTIONS(12345),
    [sym__times_operator] = ACTIONS(12347),
    [sym__rational_operator] = ACTIONS(12349),
    [sym__bitshift_operator] = ACTIONS(12351),
    [sym__power_operator] = ACTIONS(12353),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12325),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12345),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8837] = {
    [sym_block_comment] = STATE(8837),
    [sym_line_comment] = STATE(8837),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10204),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8838] = {
    [sym_block_comment] = STATE(8838),
    [sym_line_comment] = STATE(8838),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11335),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11335),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11335),
    [anon_sym_DOLLAR] = ACTIONS(11335),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11335),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11335),
    [anon_sym_QMARK] = ACTIONS(11335),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11335),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11335),
    [aux_sym_integer_literal_token2] = ACTIONS(11335),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11335),
    [aux_sym_float_literal_token3] = ACTIONS(11335),
    [aux_sym_float_literal_token4] = ACTIONS(11335),
    [sym_character_literal] = ACTIONS(11335),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11335),
    [sym__pair_operator] = ACTIONS(11335),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11335),
    [sym__lazy_and_operator] = ACTIONS(11335),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11335),
    [sym__pipe_left_operator] = ACTIONS(11335),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11335),
    [sym__bitshift_operator] = ACTIONS(11335),
    [sym__power_operator] = ACTIONS(11335),
    [sym__tilde_operator] = ACTIONS(11335),
    [sym__type_order_operator] = ACTIONS(11335),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym__terminator_token1] = ACTIONS(11337),
    [aux_sym__terminator_token2] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8839] = {
    [sym_block_comment] = STATE(8839),
    [sym_line_comment] = STATE(8839),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_end] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11339),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11339),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11339),
    [anon_sym_DOLLAR] = ACTIONS(11339),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11339),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11339),
    [anon_sym_QMARK] = ACTIONS(11339),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11339),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11339),
    [aux_sym_integer_literal_token2] = ACTIONS(11339),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11339),
    [aux_sym_float_literal_token3] = ACTIONS(11339),
    [aux_sym_float_literal_token4] = ACTIONS(11339),
    [sym_character_literal] = ACTIONS(11339),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11339),
    [sym__pair_operator] = ACTIONS(11339),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11339),
    [sym__lazy_and_operator] = ACTIONS(11339),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11339),
    [sym__pipe_left_operator] = ACTIONS(11339),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11339),
    [sym__bitshift_operator] = ACTIONS(11339),
    [sym__power_operator] = ACTIONS(11339),
    [sym__tilde_operator] = ACTIONS(11339),
    [sym__type_order_operator] = ACTIONS(11339),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym__terminator_token1] = ACTIONS(11341),
    [aux_sym__terminator_token2] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8840] = {
    [sym_block_comment] = STATE(8840),
    [sym_line_comment] = STATE(8840),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11343),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_end] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11343),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11343),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11343),
    [anon_sym_DOLLAR] = ACTIONS(11343),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11343),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11343),
    [anon_sym_QMARK] = ACTIONS(11343),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11343),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11343),
    [aux_sym_integer_literal_token2] = ACTIONS(11343),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11343),
    [aux_sym_float_literal_token3] = ACTIONS(11343),
    [aux_sym_float_literal_token4] = ACTIONS(11343),
    [sym_character_literal] = ACTIONS(11343),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11343),
    [sym__pair_operator] = ACTIONS(11343),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11343),
    [sym__lazy_and_operator] = ACTIONS(11343),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11343),
    [sym__pipe_left_operator] = ACTIONS(11343),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11343),
    [sym__bitshift_operator] = ACTIONS(11343),
    [sym__power_operator] = ACTIONS(11343),
    [sym__tilde_operator] = ACTIONS(11343),
    [sym__type_order_operator] = ACTIONS(11343),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym__terminator_token1] = ACTIONS(11345),
    [aux_sym__terminator_token2] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8841] = {
    [sym_block_comment] = STATE(8841),
    [sym_line_comment] = STATE(8841),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10230),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10026),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8842] = {
    [sym_block_comment] = STATE(8842),
    [sym_line_comment] = STATE(8842),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11347),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_end] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11347),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11347),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11347),
    [anon_sym_DOLLAR] = ACTIONS(11347),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11347),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11347),
    [anon_sym_QMARK] = ACTIONS(11347),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11347),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11347),
    [aux_sym_integer_literal_token2] = ACTIONS(11347),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11347),
    [aux_sym_float_literal_token3] = ACTIONS(11347),
    [aux_sym_float_literal_token4] = ACTIONS(11347),
    [sym_character_literal] = ACTIONS(11347),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11347),
    [sym__pair_operator] = ACTIONS(11347),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11347),
    [sym__lazy_and_operator] = ACTIONS(11347),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11347),
    [sym__pipe_left_operator] = ACTIONS(11347),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11347),
    [sym__bitshift_operator] = ACTIONS(11347),
    [sym__power_operator] = ACTIONS(11347),
    [sym__tilde_operator] = ACTIONS(11347),
    [sym__type_order_operator] = ACTIONS(11347),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym__terminator_token1] = ACTIONS(11349),
    [aux_sym__terminator_token2] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8843] = {
    [sym_block_comment] = STATE(8843),
    [sym_line_comment] = STATE(8843),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11351),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_end] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11351),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11351),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11351),
    [anon_sym_DOLLAR] = ACTIONS(11351),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11351),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11351),
    [anon_sym_QMARK] = ACTIONS(11351),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11351),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11351),
    [aux_sym_integer_literal_token2] = ACTIONS(11351),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11351),
    [aux_sym_float_literal_token3] = ACTIONS(11351),
    [aux_sym_float_literal_token4] = ACTIONS(11351),
    [sym_character_literal] = ACTIONS(11351),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11351),
    [sym__pair_operator] = ACTIONS(11351),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11351),
    [sym__lazy_and_operator] = ACTIONS(11351),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11351),
    [sym__pipe_left_operator] = ACTIONS(11351),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11351),
    [sym__bitshift_operator] = ACTIONS(11351),
    [sym__power_operator] = ACTIONS(11351),
    [sym__tilde_operator] = ACTIONS(11351),
    [sym__type_order_operator] = ACTIONS(11351),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym__terminator_token1] = ACTIONS(11353),
    [aux_sym__terminator_token2] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8844] = {
    [sym_block_comment] = STATE(8844),
    [sym_line_comment] = STATE(8844),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11355),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_end] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11355),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11355),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11355),
    [anon_sym_DOLLAR] = ACTIONS(11355),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11355),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11355),
    [anon_sym_QMARK] = ACTIONS(11355),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11355),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11355),
    [aux_sym_integer_literal_token2] = ACTIONS(11355),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11355),
    [aux_sym_float_literal_token3] = ACTIONS(11355),
    [aux_sym_float_literal_token4] = ACTIONS(11355),
    [sym_character_literal] = ACTIONS(11355),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11355),
    [sym__pair_operator] = ACTIONS(11355),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11355),
    [sym__lazy_and_operator] = ACTIONS(11355),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11355),
    [sym__pipe_left_operator] = ACTIONS(11355),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11355),
    [sym__bitshift_operator] = ACTIONS(11355),
    [sym__power_operator] = ACTIONS(11355),
    [sym__tilde_operator] = ACTIONS(11355),
    [sym__type_order_operator] = ACTIONS(11355),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym__terminator_token1] = ACTIONS(11357),
    [aux_sym__terminator_token2] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8845] = {
    [sym_block_comment] = STATE(8845),
    [sym_line_comment] = STATE(8845),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_as] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8846] = {
    [sym_block_comment] = STATE(8846),
    [sym_line_comment] = STATE(8846),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11716),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11718),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(11726),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11728),
    [sym__arrow_operator] = ACTIONS(11730),
    [sym__lazy_or_operator] = ACTIONS(11732),
    [sym__lazy_and_operator] = ACTIONS(11734),
    [sym__comparison_operator] = ACTIONS(11718),
    [sym__pipe_right_operator] = ACTIONS(11736),
    [sym__pipe_left_operator] = ACTIONS(11738),
    [sym__ellipsis_operator] = ACTIONS(11740),
    [sym__plus_operator] = ACTIONS(11742),
    [sym__times_operator] = ACTIONS(11744),
    [sym__rational_operator] = ACTIONS(11746),
    [sym__bitshift_operator] = ACTIONS(11748),
    [sym__power_operator] = ACTIONS(11750),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11718),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11742),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8847] = {
    [sym_block_comment] = STATE(8847),
    [sym_line_comment] = STATE(8847),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_as] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8848] = {
    [sym_block_comment] = STATE(8848),
    [sym_line_comment] = STATE(8848),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_as] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8849] = {
    [sym_block_comment] = STATE(8849),
    [sym_line_comment] = STATE(8849),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_as] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8850] = {
    [sym_block_comment] = STATE(8850),
    [sym_line_comment] = STATE(8850),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11373),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_end] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11373),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11373),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11373),
    [anon_sym_DOLLAR] = ACTIONS(11373),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11373),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11373),
    [anon_sym_QMARK] = ACTIONS(11373),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11373),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11373),
    [aux_sym_integer_literal_token2] = ACTIONS(11373),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11373),
    [aux_sym_float_literal_token3] = ACTIONS(11373),
    [aux_sym_float_literal_token4] = ACTIONS(11373),
    [sym_character_literal] = ACTIONS(11373),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11373),
    [sym__pair_operator] = ACTIONS(11373),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11373),
    [sym__lazy_and_operator] = ACTIONS(11373),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11373),
    [sym__pipe_left_operator] = ACTIONS(11373),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11373),
    [sym__bitshift_operator] = ACTIONS(11373),
    [sym__power_operator] = ACTIONS(11373),
    [sym__tilde_operator] = ACTIONS(11373),
    [sym__type_order_operator] = ACTIONS(11373),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym__terminator_token1] = ACTIONS(11375),
    [aux_sym__terminator_token2] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8851] = {
    [sym_block_comment] = STATE(8851),
    [sym_line_comment] = STATE(8851),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11377),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_end] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11377),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11377),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11377),
    [anon_sym_DOLLAR] = ACTIONS(11377),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11377),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11377),
    [anon_sym_QMARK] = ACTIONS(11377),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11377),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11377),
    [aux_sym_integer_literal_token2] = ACTIONS(11377),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11377),
    [aux_sym_float_literal_token3] = ACTIONS(11377),
    [aux_sym_float_literal_token4] = ACTIONS(11377),
    [sym_character_literal] = ACTIONS(11377),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11377),
    [sym__pair_operator] = ACTIONS(11377),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11377),
    [sym__lazy_and_operator] = ACTIONS(11377),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11377),
    [sym__pipe_left_operator] = ACTIONS(11377),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11377),
    [sym__bitshift_operator] = ACTIONS(11377),
    [sym__power_operator] = ACTIONS(11377),
    [sym__tilde_operator] = ACTIONS(11377),
    [sym__type_order_operator] = ACTIONS(11377),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym__terminator_token1] = ACTIONS(11379),
    [aux_sym__terminator_token2] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8852] = {
    [sym_block_comment] = STATE(8852),
    [sym_line_comment] = STATE(8852),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_as] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8853] = {
    [sym_block_comment] = STATE(8853),
    [sym_line_comment] = STATE(8853),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_as] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8854] = {
    [sym_block_comment] = STATE(8854),
    [sym_line_comment] = STATE(8854),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11277),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11277),
    [anon_sym_RPAREN] = ACTIONS(11277),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11277),
    [anon_sym_RBRACK] = ACTIONS(11277),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11277),
    [anon_sym_RBRACE] = ACTIONS(11277),
    [anon_sym_DOLLAR] = ACTIONS(11277),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11277),
    [anon_sym_QMARK] = ACTIONS(11277),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11277),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11277),
    [aux_sym_integer_literal_token2] = ACTIONS(11277),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11277),
    [aux_sym_float_literal_token3] = ACTIONS(11277),
    [aux_sym_float_literal_token4] = ACTIONS(11277),
    [sym_character_literal] = ACTIONS(11277),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11277),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11277),
    [sym__pair_operator] = ACTIONS(11277),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11277),
    [sym__lazy_and_operator] = ACTIONS(11277),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11277),
    [sym__pipe_left_operator] = ACTIONS(11277),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11277),
    [sym__type_order_operator] = ACTIONS(11277),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8855] = {
    [sym_block_comment] = STATE(8855),
    [sym_line_comment] = STATE(8855),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11385),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_end] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11385),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11385),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11385),
    [anon_sym_DOLLAR] = ACTIONS(11385),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11385),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11385),
    [anon_sym_QMARK] = ACTIONS(11385),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11385),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11385),
    [aux_sym_integer_literal_token2] = ACTIONS(11385),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11385),
    [aux_sym_float_literal_token3] = ACTIONS(11385),
    [aux_sym_float_literal_token4] = ACTIONS(11385),
    [sym_character_literal] = ACTIONS(11385),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11385),
    [sym__pair_operator] = ACTIONS(11385),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11385),
    [sym__lazy_and_operator] = ACTIONS(11385),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11385),
    [sym__pipe_left_operator] = ACTIONS(11385),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11385),
    [sym__bitshift_operator] = ACTIONS(11385),
    [sym__power_operator] = ACTIONS(11385),
    [sym__tilde_operator] = ACTIONS(11385),
    [sym__type_order_operator] = ACTIONS(11385),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym__terminator_token1] = ACTIONS(11387),
    [aux_sym__terminator_token2] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8856] = {
    [sym_block_comment] = STATE(8856),
    [sym_line_comment] = STATE(8856),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10126),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8857] = {
    [sym_block_comment] = STATE(8857),
    [sym_line_comment] = STATE(8857),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10094),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8858] = {
    [sym_block_comment] = STATE(8858),
    [sym_line_comment] = STATE(8858),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11399),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_end] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11399),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11399),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11399),
    [anon_sym_DOLLAR] = ACTIONS(11399),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11399),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11399),
    [anon_sym_QMARK] = ACTIONS(11399),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11399),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11399),
    [aux_sym_integer_literal_token2] = ACTIONS(11399),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11399),
    [aux_sym_float_literal_token3] = ACTIONS(11399),
    [aux_sym_float_literal_token4] = ACTIONS(11399),
    [sym_character_literal] = ACTIONS(11399),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11399),
    [sym__pair_operator] = ACTIONS(11399),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11399),
    [sym__lazy_and_operator] = ACTIONS(11399),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11399),
    [sym__pipe_left_operator] = ACTIONS(11399),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11399),
    [sym__bitshift_operator] = ACTIONS(11399),
    [sym__power_operator] = ACTIONS(11399),
    [sym__tilde_operator] = ACTIONS(11399),
    [sym__type_order_operator] = ACTIONS(11399),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym__terminator_token1] = ACTIONS(11401),
    [aux_sym__terminator_token2] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8859] = {
    [sym_block_comment] = STATE(8859),
    [sym_line_comment] = STATE(8859),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_end] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11403),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11403),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11403),
    [anon_sym_DOLLAR] = ACTIONS(11403),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11403),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11403),
    [anon_sym_QMARK] = ACTIONS(11403),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11403),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11403),
    [aux_sym_integer_literal_token2] = ACTIONS(11403),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11403),
    [aux_sym_float_literal_token3] = ACTIONS(11403),
    [aux_sym_float_literal_token4] = ACTIONS(11403),
    [sym_character_literal] = ACTIONS(11403),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11403),
    [sym__pair_operator] = ACTIONS(11403),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11403),
    [sym__lazy_and_operator] = ACTIONS(11403),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11403),
    [sym__pipe_left_operator] = ACTIONS(11403),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11403),
    [sym__bitshift_operator] = ACTIONS(11403),
    [sym__power_operator] = ACTIONS(11403),
    [sym__tilde_operator] = ACTIONS(11403),
    [sym__type_order_operator] = ACTIONS(11403),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym__terminator_token1] = ACTIONS(11405),
    [aux_sym__terminator_token2] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8860] = {
    [sym_block_comment] = STATE(8860),
    [sym_line_comment] = STATE(8860),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11255),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_end] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11255),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11255),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11255),
    [anon_sym_DOLLAR] = ACTIONS(11255),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11255),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11255),
    [anon_sym_QMARK] = ACTIONS(11255),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11255),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11255),
    [aux_sym_integer_literal_token2] = ACTIONS(11255),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11255),
    [aux_sym_float_literal_token3] = ACTIONS(11255),
    [aux_sym_float_literal_token4] = ACTIONS(11255),
    [sym_character_literal] = ACTIONS(11255),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11255),
    [sym__pair_operator] = ACTIONS(11255),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11255),
    [sym__lazy_and_operator] = ACTIONS(11255),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11255),
    [sym__pipe_left_operator] = ACTIONS(11255),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11255),
    [sym__bitshift_operator] = ACTIONS(11255),
    [sym__power_operator] = ACTIONS(11255),
    [sym__tilde_operator] = ACTIONS(11255),
    [sym__type_order_operator] = ACTIONS(11255),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym__terminator_token1] = ACTIONS(11257),
    [aux_sym__terminator_token2] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8861] = {
    [sym_block_comment] = STATE(8861),
    [sym_line_comment] = STATE(8861),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_as] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8862] = {
    [sym_block_comment] = STATE(8862),
    [sym_line_comment] = STATE(8862),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11526),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_end] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11526),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11526),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11526),
    [anon_sym_DOLLAR] = ACTIONS(11526),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11526),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11526),
    [anon_sym_QMARK] = ACTIONS(11526),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11526),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11526),
    [aux_sym_integer_literal_token2] = ACTIONS(11526),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11526),
    [aux_sym_float_literal_token3] = ACTIONS(11526),
    [aux_sym_float_literal_token4] = ACTIONS(11526),
    [sym_character_literal] = ACTIONS(11526),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11526),
    [sym__pair_operator] = ACTIONS(11526),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11526),
    [sym__lazy_and_operator] = ACTIONS(11526),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11526),
    [sym__pipe_left_operator] = ACTIONS(11526),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11526),
    [sym__bitshift_operator] = ACTIONS(11526),
    [sym__power_operator] = ACTIONS(11526),
    [sym__tilde_operator] = ACTIONS(11526),
    [sym__type_order_operator] = ACTIONS(11526),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym__terminator_token1] = ACTIONS(11528),
    [aux_sym__terminator_token2] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8863] = {
    [sym_block_comment] = STATE(8863),
    [sym_line_comment] = STATE(8863),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11530),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_end] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11530),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11530),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11530),
    [anon_sym_DOLLAR] = ACTIONS(11530),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11530),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11530),
    [anon_sym_QMARK] = ACTIONS(11530),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11530),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11530),
    [aux_sym_integer_literal_token2] = ACTIONS(11530),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11530),
    [aux_sym_float_literal_token3] = ACTIONS(11530),
    [aux_sym_float_literal_token4] = ACTIONS(11530),
    [sym_character_literal] = ACTIONS(11530),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11530),
    [sym__pair_operator] = ACTIONS(11530),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11530),
    [sym__lazy_and_operator] = ACTIONS(11530),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11530),
    [sym__pipe_left_operator] = ACTIONS(11530),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11530),
    [sym__bitshift_operator] = ACTIONS(11530),
    [sym__power_operator] = ACTIONS(11530),
    [sym__tilde_operator] = ACTIONS(11530),
    [sym__type_order_operator] = ACTIONS(11530),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym__terminator_token1] = ACTIONS(11532),
    [aux_sym__terminator_token2] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8864] = {
    [sym_block_comment] = STATE(8864),
    [sym_line_comment] = STATE(8864),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11534),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_end] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11534),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11534),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11534),
    [anon_sym_DOLLAR] = ACTIONS(11534),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11534),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11534),
    [anon_sym_QMARK] = ACTIONS(11534),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11534),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11534),
    [aux_sym_integer_literal_token2] = ACTIONS(11534),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11534),
    [aux_sym_float_literal_token3] = ACTIONS(11534),
    [aux_sym_float_literal_token4] = ACTIONS(11534),
    [sym_character_literal] = ACTIONS(11534),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11534),
    [sym__pair_operator] = ACTIONS(11534),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11534),
    [sym__lazy_and_operator] = ACTIONS(11534),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11534),
    [sym__pipe_left_operator] = ACTIONS(11534),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11534),
    [sym__bitshift_operator] = ACTIONS(11534),
    [sym__power_operator] = ACTIONS(11534),
    [sym__tilde_operator] = ACTIONS(11534),
    [sym__type_order_operator] = ACTIONS(11534),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym__terminator_token1] = ACTIONS(11536),
    [aux_sym__terminator_token2] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8865] = {
    [sym_block_comment] = STATE(8865),
    [sym_line_comment] = STATE(8865),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11548),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_end] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11548),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11548),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11548),
    [anon_sym_DOLLAR] = ACTIONS(11548),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11548),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11548),
    [anon_sym_QMARK] = ACTIONS(11548),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11548),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11548),
    [aux_sym_integer_literal_token2] = ACTIONS(11548),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11548),
    [aux_sym_float_literal_token3] = ACTIONS(11548),
    [aux_sym_float_literal_token4] = ACTIONS(11548),
    [sym_character_literal] = ACTIONS(11548),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11548),
    [sym__pair_operator] = ACTIONS(11548),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11548),
    [sym__lazy_and_operator] = ACTIONS(11548),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11548),
    [sym__pipe_left_operator] = ACTIONS(11548),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11548),
    [sym__bitshift_operator] = ACTIONS(11548),
    [sym__power_operator] = ACTIONS(11548),
    [sym__tilde_operator] = ACTIONS(11548),
    [sym__type_order_operator] = ACTIONS(11548),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym__terminator_token1] = ACTIONS(11550),
    [aux_sym__terminator_token2] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8866] = {
    [sym_block_comment] = STATE(8866),
    [sym_line_comment] = STATE(8866),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_as] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8867] = {
    [sym_block_comment] = STATE(8867),
    [sym_line_comment] = STATE(8867),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11552),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_end] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11552),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11552),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11552),
    [anon_sym_DOLLAR] = ACTIONS(11552),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11552),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11552),
    [anon_sym_QMARK] = ACTIONS(11552),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11552),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11552),
    [aux_sym_integer_literal_token2] = ACTIONS(11552),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11552),
    [aux_sym_float_literal_token3] = ACTIONS(11552),
    [aux_sym_float_literal_token4] = ACTIONS(11552),
    [sym_character_literal] = ACTIONS(11552),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11552),
    [sym__pair_operator] = ACTIONS(11552),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11552),
    [sym__lazy_and_operator] = ACTIONS(11552),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11552),
    [sym__pipe_left_operator] = ACTIONS(11552),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11552),
    [sym__bitshift_operator] = ACTIONS(11552),
    [sym__power_operator] = ACTIONS(11552),
    [sym__tilde_operator] = ACTIONS(11552),
    [sym__type_order_operator] = ACTIONS(11552),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym__terminator_token1] = ACTIONS(11554),
    [aux_sym__terminator_token2] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8868] = {
    [sym_block_comment] = STATE(8868),
    [sym_line_comment] = STATE(8868),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11411),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_end] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11411),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11411),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11411),
    [anon_sym_DOLLAR] = ACTIONS(11411),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11411),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11411),
    [anon_sym_QMARK] = ACTIONS(11411),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11411),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11411),
    [aux_sym_integer_literal_token2] = ACTIONS(11411),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11411),
    [aux_sym_float_literal_token3] = ACTIONS(11411),
    [aux_sym_float_literal_token4] = ACTIONS(11411),
    [sym_character_literal] = ACTIONS(11411),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11411),
    [sym__pair_operator] = ACTIONS(11411),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11411),
    [sym__lazy_and_operator] = ACTIONS(11411),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11411),
    [sym__pipe_left_operator] = ACTIONS(11411),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11411),
    [sym__bitshift_operator] = ACTIONS(11411),
    [sym__power_operator] = ACTIONS(11411),
    [sym__tilde_operator] = ACTIONS(11411),
    [sym__type_order_operator] = ACTIONS(11411),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym__terminator_token1] = ACTIONS(11413),
    [aux_sym__terminator_token2] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8869] = {
    [sym_identifier] = STATE(9122),
    [sym_block_comment] = STATE(8869),
    [sym_line_comment] = STATE(8869),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_COMMA] = ACTIONS(9782),
    [anon_sym_EQ] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9782),
    [anon_sym_COLON] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9782),
    [anon_sym_in] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9782),
    [anon_sym_DOT] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9782),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9782),
    [anon_sym_isa] = ACTIONS(9780),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9782),
    [anon_sym_QMARK] = ACTIONS(9782),
    [anon_sym_where] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9782),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9782),
    [aux_sym_integer_literal_token2] = ACTIONS(9782),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9782),
    [aux_sym_float_literal_token3] = ACTIONS(9782),
    [aux_sym_float_literal_token4] = ACTIONS(9782),
    [sym_character_literal] = ACTIONS(9782),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9782),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9782),
    [sym__pair_operator] = ACTIONS(9782),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__lazy_or_operator] = ACTIONS(9782),
    [sym__lazy_and_operator] = ACTIONS(9782),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9782),
    [sym__pipe_left_operator] = ACTIONS(9782),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9782),
    [sym__bitshift_operator] = ACTIONS(9782),
    [sym__power_operator] = ACTIONS(9782),
    [sym__tilde_operator] = ACTIONS(9782),
    [sym__type_order_operator] = ACTIONS(9782),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8870] = {
    [sym_block_comment] = STATE(8870),
    [sym_line_comment] = STATE(8870),
    [aux_sym_open_tuple_repeat1] = STATE(8623),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10833),
    [anon_sym_RPAREN] = ACTIONS(10833),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10833),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_SEMI] = ACTIONS(10833),
    [anon_sym_LBRACE] = ACTIONS(10833),
    [anon_sym_DOLLAR] = ACTIONS(10833),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10833),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10833),
    [anon_sym_QMARK] = ACTIONS(10833),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10833),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10833),
    [aux_sym_integer_literal_token2] = ACTIONS(10833),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10833),
    [aux_sym_float_literal_token3] = ACTIONS(10833),
    [aux_sym_float_literal_token4] = ACTIONS(10833),
    [sym_character_literal] = ACTIONS(10833),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10833),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10833),
    [sym__pair_operator] = ACTIONS(10833),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10833),
    [sym__lazy_and_operator] = ACTIONS(10833),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10833),
    [sym__pipe_left_operator] = ACTIONS(10833),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10833),
    [sym__bitshift_operator] = ACTIONS(10833),
    [sym__power_operator] = ACTIONS(10833),
    [sym__tilde_operator] = ACTIONS(10833),
    [sym__type_order_operator] = ACTIONS(10833),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8871] = {
    [sym_block_comment] = STATE(8871),
    [sym_line_comment] = STATE(8871),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10194),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8872] = {
    [sym_block_comment] = STATE(8872),
    [sym_line_comment] = STATE(8872),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8873] = {
    [sym_identifier] = STATE(9129),
    [sym_block_comment] = STATE(8873),
    [sym_line_comment] = STATE(8873),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_COMMA] = ACTIONS(9786),
    [anon_sym_EQ] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9786),
    [anon_sym_COLON] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9786),
    [anon_sym_in] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9786),
    [anon_sym_DOT] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9786),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9786),
    [anon_sym_isa] = ACTIONS(9784),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9786),
    [anon_sym_QMARK] = ACTIONS(9786),
    [anon_sym_where] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9786),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9786),
    [aux_sym_integer_literal_token2] = ACTIONS(9786),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9786),
    [aux_sym_float_literal_token3] = ACTIONS(9786),
    [aux_sym_float_literal_token4] = ACTIONS(9786),
    [sym_character_literal] = ACTIONS(9786),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9786),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9786),
    [sym__pair_operator] = ACTIONS(9786),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__lazy_or_operator] = ACTIONS(9786),
    [sym__lazy_and_operator] = ACTIONS(9786),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9786),
    [sym__pipe_left_operator] = ACTIONS(9786),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9786),
    [sym__bitshift_operator] = ACTIONS(9786),
    [sym__power_operator] = ACTIONS(9786),
    [sym__tilde_operator] = ACTIONS(9786),
    [sym__type_order_operator] = ACTIONS(9786),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8874] = {
    [sym_identifier] = STATE(9137),
    [sym_block_comment] = STATE(8874),
    [sym_line_comment] = STATE(8874),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_COMMA] = ACTIONS(9798),
    [anon_sym_EQ] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9798),
    [anon_sym_COLON] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9798),
    [anon_sym_in] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9798),
    [anon_sym_DOT] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9798),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9798),
    [anon_sym_isa] = ACTIONS(9796),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9798),
    [anon_sym_QMARK] = ACTIONS(9798),
    [anon_sym_where] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9798),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9798),
    [aux_sym_integer_literal_token2] = ACTIONS(9798),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9798),
    [aux_sym_float_literal_token3] = ACTIONS(9798),
    [aux_sym_float_literal_token4] = ACTIONS(9798),
    [sym_character_literal] = ACTIONS(9798),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9798),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9798),
    [sym__pair_operator] = ACTIONS(9798),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__lazy_or_operator] = ACTIONS(9798),
    [sym__lazy_and_operator] = ACTIONS(9798),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9798),
    [sym__pipe_left_operator] = ACTIONS(9798),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9798),
    [sym__bitshift_operator] = ACTIONS(9798),
    [sym__power_operator] = ACTIONS(9798),
    [sym__tilde_operator] = ACTIONS(9798),
    [sym__type_order_operator] = ACTIONS(9798),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8875] = {
    [sym_identifier] = STATE(8963),
    [sym_block_comment] = STATE(8875),
    [sym_line_comment] = STATE(8875),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_COMMA] = ACTIONS(9802),
    [anon_sym_EQ] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9802),
    [anon_sym_COLON] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9802),
    [anon_sym_in] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9802),
    [anon_sym_DOT] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9802),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9802),
    [anon_sym_isa] = ACTIONS(9800),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9802),
    [anon_sym_QMARK] = ACTIONS(9802),
    [anon_sym_where] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9802),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9802),
    [aux_sym_integer_literal_token2] = ACTIONS(9802),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9802),
    [aux_sym_float_literal_token3] = ACTIONS(9802),
    [aux_sym_float_literal_token4] = ACTIONS(9802),
    [sym_character_literal] = ACTIONS(9802),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9802),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9802),
    [sym__pair_operator] = ACTIONS(9802),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__lazy_or_operator] = ACTIONS(9802),
    [sym__lazy_and_operator] = ACTIONS(9802),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9802),
    [sym__pipe_left_operator] = ACTIONS(9802),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9802),
    [sym__bitshift_operator] = ACTIONS(9802),
    [sym__power_operator] = ACTIONS(9802),
    [sym__tilde_operator] = ACTIONS(9802),
    [sym__type_order_operator] = ACTIONS(9802),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8876] = {
    [sym_block_comment] = STATE(8876),
    [sym_line_comment] = STATE(8876),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_as] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8877] = {
    [sym_block_comment] = STATE(8877),
    [sym_line_comment] = STATE(8877),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10970),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10970),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10970),
    [anon_sym_QMARK] = ACTIONS(10970),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(10970),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10970),
    [sym__lazy_and_operator] = ACTIONS(10970),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10970),
    [sym__pipe_left_operator] = ACTIONS(10970),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10970),
    [sym__bitshift_operator] = ACTIONS(10970),
    [sym__power_operator] = ACTIONS(10970),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(10970),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8878] = {
    [sym_block_comment] = STATE(8878),
    [sym_line_comment] = STATE(8878),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_as] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8879] = {
    [sym_block_comment] = STATE(8879),
    [sym_line_comment] = STATE(8879),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8880] = {
    [sym_block_comment] = STATE(8880),
    [sym_line_comment] = STATE(8880),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12513),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(12513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(12154),
    [anon_sym_where] = ACTIONS(12515),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12517),
    [sym__arrow_operator] = ACTIONS(12519),
    [sym__lazy_or_operator] = ACTIONS(12521),
    [sym__lazy_and_operator] = ACTIONS(12523),
    [sym__comparison_operator] = ACTIONS(12513),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12513),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8881] = {
    [sym_block_comment] = STATE(8881),
    [sym_line_comment] = STATE(8881),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12513),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(12513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12515),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12519),
    [sym__lazy_or_operator] = ACTIONS(12521),
    [sym__lazy_and_operator] = ACTIONS(12523),
    [sym__comparison_operator] = ACTIONS(12513),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12513),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8882] = {
    [sym_block_comment] = STATE(8882),
    [sym_line_comment] = STATE(8882),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12513),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(12513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12515),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12523),
    [sym__comparison_operator] = ACTIONS(12513),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12513),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8883] = {
    [sym_block_comment] = STATE(8883),
    [sym_line_comment] = STATE(8883),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10296),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10148),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8884] = {
    [sym_block_comment] = STATE(8884),
    [sym_line_comment] = STATE(8884),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10296),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9936),
  },
  [8885] = {
    [sym_block_comment] = STATE(8885),
    [sym_line_comment] = STATE(8885),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(9876),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8886] = {
    [sym_block_comment] = STATE(8886),
    [sym_line_comment] = STATE(8886),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12513),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(12513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12515),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12513),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12513),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8887] = {
    [sym_block_comment] = STATE(8887),
    [sym_line_comment] = STATE(8887),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8888] = {
    [sym_block_comment] = STATE(8888),
    [sym_line_comment] = STATE(8888),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12511),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11674),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12525),
    [sym__pipe_left_operator] = ACTIONS(12527),
    [sym__ellipsis_operator] = ACTIONS(12529),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8889] = {
    [sym_block_comment] = STATE(8889),
    [sym_line_comment] = STATE(8889),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12463),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12463),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8890] = {
    [sym_block_comment] = STATE(8890),
    [sym_line_comment] = STATE(8890),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12465),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8891] = {
    [sym_block_comment] = STATE(8891),
    [sym_line_comment] = STATE(8891),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_as] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8892] = {
    [sym_block_comment] = STATE(8892),
    [sym_line_comment] = STATE(8892),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12467),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8893] = {
    [sym_block_comment] = STATE(8893),
    [sym_line_comment] = STATE(8893),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12469),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8894] = {
    [sym_block_comment] = STATE(8894),
    [sym_line_comment] = STATE(8894),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11020),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11020),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11020),
    [anon_sym_DOLLAR] = ACTIONS(11020),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11020),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11020),
    [aux_sym_integer_literal_token2] = ACTIONS(11020),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11020),
    [aux_sym_float_literal_token3] = ACTIONS(11020),
    [aux_sym_float_literal_token4] = ACTIONS(11020),
    [sym_character_literal] = ACTIONS(11020),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11020),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11020),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11022),
    [aux_sym__terminator_token2] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8895] = {
    [sym_block_comment] = STATE(8895),
    [sym_line_comment] = STATE(8895),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_catch] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11672),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12459),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8896] = {
    [sym__primary_expression] = STATE(11331),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10688),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(8896),
    [sym_line_comment] = STATE(8896),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_DOLLAR] = ACTIONS(12535),
    [anon_sym_COLON2] = ACTIONS(10320),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(9343),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9343),
    [sym__pipe_left_operator] = ACTIONS(9343),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9343),
    [sym__bitshift_operator] = ACTIONS(9343),
    [sym__power_operator] = ACTIONS(9343),
    [sym__tilde_operator] = ACTIONS(1823),
    [sym__type_order_operator] = ACTIONS(9343),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8897] = {
    [sym_block_comment] = STATE(8897),
    [sym_line_comment] = STATE(8897),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8898] = {
    [sym_block_comment] = STATE(8898),
    [sym_line_comment] = STATE(8898),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10850),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10850),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10850),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10850),
    [anon_sym_DOLLAR] = ACTIONS(10850),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10850),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10850),
    [anon_sym_QMARK] = ACTIONS(10850),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10850),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10850),
    [aux_sym_integer_literal_token2] = ACTIONS(10850),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10850),
    [aux_sym_float_literal_token3] = ACTIONS(10850),
    [aux_sym_float_literal_token4] = ACTIONS(10850),
    [sym_character_literal] = ACTIONS(10850),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10850),
    [sym__pair_operator] = ACTIONS(10850),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10850),
    [sym__lazy_and_operator] = ACTIONS(10850),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10850),
    [sym__pipe_left_operator] = ACTIONS(10850),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10850),
    [sym__bitshift_operator] = ACTIONS(10850),
    [sym__power_operator] = ACTIONS(10850),
    [sym__tilde_operator] = ACTIONS(10850),
    [sym__type_order_operator] = ACTIONS(10850),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym__terminator_token1] = ACTIONS(10855),
    [aux_sym__terminator_token2] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8899] = {
    [sym_block_comment] = STATE(8899),
    [sym_line_comment] = STATE(8899),
    [ts_builtin_sym_end] = ACTIONS(11866),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12545),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12545),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12545),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8900] = {
    [sym_block_comment] = STATE(8900),
    [sym_line_comment] = STATE(8900),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12545),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(12547),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12549),
    [sym__arrow_operator] = ACTIONS(12551),
    [sym__lazy_or_operator] = ACTIONS(12553),
    [sym__lazy_and_operator] = ACTIONS(12555),
    [sym__comparison_operator] = ACTIONS(12545),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12545),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8901] = {
    [sym_block_comment] = STATE(8901),
    [sym_line_comment] = STATE(8901),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10861),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10861),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10861),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10861),
    [anon_sym_DOLLAR] = ACTIONS(10861),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10861),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10861),
    [anon_sym_QMARK] = ACTIONS(10861),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10861),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10861),
    [aux_sym_integer_literal_token2] = ACTIONS(10861),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10861),
    [aux_sym_float_literal_token3] = ACTIONS(10861),
    [aux_sym_float_literal_token4] = ACTIONS(10861),
    [sym_character_literal] = ACTIONS(10861),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10861),
    [sym__pair_operator] = ACTIONS(10861),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10861),
    [sym__lazy_and_operator] = ACTIONS(10861),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10861),
    [sym__pipe_left_operator] = ACTIONS(10861),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10861),
    [sym__bitshift_operator] = ACTIONS(10861),
    [sym__power_operator] = ACTIONS(10861),
    [sym__tilde_operator] = ACTIONS(10861),
    [sym__type_order_operator] = ACTIONS(10861),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym__terminator_token1] = ACTIONS(10863),
    [aux_sym__terminator_token2] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8902] = {
    [sym_block_comment] = STATE(8902),
    [sym_line_comment] = STATE(8902),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12545),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12547),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12551),
    [sym__lazy_or_operator] = ACTIONS(12553),
    [sym__lazy_and_operator] = ACTIONS(12555),
    [sym__comparison_operator] = ACTIONS(12545),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12545),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8903] = {
    [sym_block_comment] = STATE(8903),
    [sym_line_comment] = STATE(8903),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8904] = {
    [sym_block_comment] = STATE(8904),
    [sym_line_comment] = STATE(8904),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10132),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8905] = {
    [sym_block_comment] = STATE(8905),
    [sym_line_comment] = STATE(8905),
    [sym__word_identifier] = ACTIONS(10727),
    [anon_sym_COMMA] = ACTIONS(10731),
    [anon_sym_EQ] = ACTIONS(10727),
    [anon_sym_begin] = ACTIONS(10727),
    [anon_sym_module] = ACTIONS(10727),
    [anon_sym_baremodule] = ACTIONS(10727),
    [anon_sym_end] = ACTIONS(10727),
    [anon_sym_abstract] = ACTIONS(10727),
    [anon_sym_primitive] = ACTIONS(10727),
    [anon_sym_mutable] = ACTIONS(10727),
    [anon_sym_struct] = ACTIONS(10727),
    [anon_sym_function] = ACTIONS(10727),
    [anon_sym_macro] = ACTIONS(10727),
    [anon_sym_quote] = ACTIONS(10727),
    [anon_sym_let] = ACTIONS(10727),
    [anon_sym_if] = ACTIONS(10727),
    [anon_sym_try] = ACTIONS(10727),
    [anon_sym_for] = ACTIONS(10727),
    [anon_sym_while] = ACTIONS(10727),
    [sym_break_statement] = ACTIONS(10727),
    [sym_continue_statement] = ACTIONS(10727),
    [anon_sym_return] = ACTIONS(10727),
    [anon_sym_const] = ACTIONS(10727),
    [anon_sym_global] = ACTIONS(10727),
    [anon_sym_local] = ACTIONS(10727),
    [anon_sym_as] = ACTIONS(10727),
    [anon_sym_LPAREN] = ACTIONS(10731),
    [anon_sym_COLON] = ACTIONS(10727),
    [anon_sym_export] = ACTIONS(10727),
    [anon_sym_public] = ACTIONS(10727),
    [anon_sym_import] = ACTIONS(10727),
    [anon_sym_using] = ACTIONS(10727),
    [anon_sym_LBRACK] = ACTIONS(10731),
    [anon_sym_in] = ACTIONS(10727),
    [anon_sym_LBRACE] = ACTIONS(10731),
    [anon_sym_DOT] = ACTIONS(12479),
    [anon_sym_DOLLAR] = ACTIONS(10731),
    [anon_sym_COLON2] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10731),
    [anon_sym_isa] = ACTIONS(10727),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10731),
    [anon_sym_QMARK] = ACTIONS(10731),
    [anon_sym_where] = ACTIONS(10727),
    [anon_sym_AT] = ACTIONS(10731),
    [anon_sym_true] = ACTIONS(10727),
    [anon_sym_false] = ACTIONS(10727),
    [aux_sym_integer_literal_token1] = ACTIONS(10731),
    [aux_sym_integer_literal_token2] = ACTIONS(10731),
    [aux_sym_integer_literal_token3] = ACTIONS(10727),
    [aux_sym_integer_literal_token4] = ACTIONS(10727),
    [aux_sym_float_literal_token1] = ACTIONS(10731),
    [aux_sym_float_literal_token3] = ACTIONS(10731),
    [aux_sym_float_literal_token4] = ACTIONS(10731),
    [sym_character_literal] = ACTIONS(10731),
    [anon_sym_DQUOTE] = ACTIONS(10727),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10731),
    [anon_sym_BQUOTE] = ACTIONS(10727),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10731),
    [sym__pair_operator] = ACTIONS(10731),
    [sym__arrow_operator] = ACTIONS(10727),
    [sym__lazy_or_operator] = ACTIONS(10731),
    [sym__lazy_and_operator] = ACTIONS(10731),
    [sym__comparison_operator] = ACTIONS(10727),
    [sym__pipe_right_operator] = ACTIONS(10731),
    [sym__pipe_left_operator] = ACTIONS(10731),
    [sym__ellipsis_operator] = ACTIONS(10727),
    [sym__plus_operator] = ACTIONS(10727),
    [sym__times_operator] = ACTIONS(10727),
    [sym__rational_operator] = ACTIONS(10731),
    [sym__bitshift_operator] = ACTIONS(10731),
    [sym__power_operator] = ACTIONS(10731),
    [sym__tilde_operator] = ACTIONS(10731),
    [sym__type_order_operator] = ACTIONS(10731),
    [sym__unary_operator] = ACTIONS(10727),
    [sym__unary_plus_operator] = ACTIONS(10727),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8906] = {
    [sym_block_comment] = STATE(8906),
    [sym_line_comment] = STATE(8906),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_elseif] = ACTIONS(11864),
    [anon_sym_else] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(1091),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(1091),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8907] = {
    [sym_block_comment] = STATE(8907),
    [sym_line_comment] = STATE(8907),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(1101),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12501),
    [sym__arrow_operator] = ACTIONS(12503),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1091),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(1091),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8908] = {
    [sym_block_comment] = STATE(8908),
    [sym_line_comment] = STATE(8908),
    [ts_builtin_sym_end] = ACTIONS(11114),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_RBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12545),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(12547),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12549),
    [sym__arrow_operator] = ACTIONS(12551),
    [sym__lazy_or_operator] = ACTIONS(12553),
    [sym__lazy_and_operator] = ACTIONS(12555),
    [sym__comparison_operator] = ACTIONS(12545),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12545),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8909] = {
    [sym_block_comment] = STATE(8909),
    [sym_line_comment] = STATE(8909),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10132),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8910] = {
    [sym_block_comment] = STATE(8910),
    [sym_line_comment] = STATE(8910),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10126),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8911] = {
    [sym_block_comment] = STATE(8911),
    [sym_line_comment] = STATE(8911),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12545),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12547),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12555),
    [sym__comparison_operator] = ACTIONS(12545),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12545),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8912] = {
    [sym_block_comment] = STATE(8912),
    [sym_line_comment] = STATE(8912),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11898),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_end] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11898),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11898),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11898),
    [anon_sym_DOLLAR] = ACTIONS(11898),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11898),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11898),
    [anon_sym_QMARK] = ACTIONS(11898),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11898),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11898),
    [aux_sym_integer_literal_token2] = ACTIONS(11898),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11898),
    [aux_sym_float_literal_token3] = ACTIONS(11898),
    [aux_sym_float_literal_token4] = ACTIONS(11898),
    [sym_character_literal] = ACTIONS(11898),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11898),
    [sym__pair_operator] = ACTIONS(11898),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11898),
    [sym__lazy_and_operator] = ACTIONS(11898),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11898),
    [sym__pipe_left_operator] = ACTIONS(11898),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11898),
    [sym__bitshift_operator] = ACTIONS(11898),
    [sym__power_operator] = ACTIONS(11898),
    [sym__tilde_operator] = ACTIONS(11898),
    [sym__type_order_operator] = ACTIONS(11898),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym__terminator_token1] = ACTIONS(11900),
    [aux_sym__terminator_token2] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8913] = {
    [sym_block_comment] = STATE(8913),
    [sym_line_comment] = STATE(8913),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12503),
    [sym__lazy_or_operator] = ACTIONS(1115),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1091),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(1091),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8914] = {
    [sym_block_comment] = STATE(8914),
    [sym_line_comment] = STATE(8914),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11559),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_end] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11559),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11559),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11559),
    [anon_sym_DOLLAR] = ACTIONS(11559),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11559),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11559),
    [anon_sym_QMARK] = ACTIONS(11559),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11559),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11559),
    [aux_sym_integer_literal_token2] = ACTIONS(11559),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11559),
    [aux_sym_float_literal_token3] = ACTIONS(11559),
    [aux_sym_float_literal_token4] = ACTIONS(11559),
    [sym_character_literal] = ACTIONS(11559),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11559),
    [sym__pair_operator] = ACTIONS(11559),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11559),
    [sym__lazy_and_operator] = ACTIONS(11559),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11559),
    [sym__pipe_left_operator] = ACTIONS(11559),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11559),
    [sym__bitshift_operator] = ACTIONS(11559),
    [sym__power_operator] = ACTIONS(11559),
    [sym__tilde_operator] = ACTIONS(11559),
    [sym__type_order_operator] = ACTIONS(11559),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym__terminator_token1] = ACTIONS(11561),
    [aux_sym__terminator_token2] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8915] = {
    [sym_block_comment] = STATE(8915),
    [sym_line_comment] = STATE(8915),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11563),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_end] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11563),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11563),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11563),
    [anon_sym_DOLLAR] = ACTIONS(11563),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11563),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11563),
    [anon_sym_QMARK] = ACTIONS(11563),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11563),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11563),
    [aux_sym_integer_literal_token2] = ACTIONS(11563),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11563),
    [aux_sym_float_literal_token3] = ACTIONS(11563),
    [aux_sym_float_literal_token4] = ACTIONS(11563),
    [sym_character_literal] = ACTIONS(11563),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11563),
    [sym__pair_operator] = ACTIONS(11563),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11563),
    [sym__lazy_and_operator] = ACTIONS(11563),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11563),
    [sym__pipe_left_operator] = ACTIONS(11563),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11563),
    [sym__bitshift_operator] = ACTIONS(11563),
    [sym__power_operator] = ACTIONS(11563),
    [sym__tilde_operator] = ACTIONS(11563),
    [sym__type_order_operator] = ACTIONS(11563),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym__terminator_token1] = ACTIONS(11565),
    [aux_sym__terminator_token2] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8916] = {
    [sym_block_comment] = STATE(8916),
    [sym_line_comment] = STATE(8916),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11567),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_end] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11567),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11567),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11567),
    [anon_sym_DOLLAR] = ACTIONS(11567),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11567),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11567),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11567),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11567),
    [aux_sym_integer_literal_token2] = ACTIONS(11567),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11567),
    [aux_sym_float_literal_token3] = ACTIONS(11567),
    [aux_sym_float_literal_token4] = ACTIONS(11567),
    [sym_character_literal] = ACTIONS(11567),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11567),
    [sym__pair_operator] = ACTIONS(11567),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11567),
    [sym__lazy_and_operator] = ACTIONS(11567),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11567),
    [sym__pipe_left_operator] = ACTIONS(11567),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11567),
    [sym__bitshift_operator] = ACTIONS(11567),
    [sym__power_operator] = ACTIONS(11567),
    [sym__tilde_operator] = ACTIONS(11567),
    [sym__type_order_operator] = ACTIONS(11567),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym__terminator_token1] = ACTIONS(11569),
    [aux_sym__terminator_token2] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8917] = {
    [sym_block_comment] = STATE(8917),
    [sym_line_comment] = STATE(8917),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11571),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_end] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11571),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11571),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11571),
    [anon_sym_DOLLAR] = ACTIONS(11571),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11571),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_QMARK] = ACTIONS(11571),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11571),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11571),
    [aux_sym_integer_literal_token2] = ACTIONS(11571),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11571),
    [aux_sym_float_literal_token3] = ACTIONS(11571),
    [aux_sym_float_literal_token4] = ACTIONS(11571),
    [sym_character_literal] = ACTIONS(11571),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11571),
    [sym__pair_operator] = ACTIONS(11571),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11571),
    [sym__lazy_and_operator] = ACTIONS(11571),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11571),
    [sym__pipe_left_operator] = ACTIONS(11571),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11571),
    [sym__bitshift_operator] = ACTIONS(11571),
    [sym__power_operator] = ACTIONS(11571),
    [sym__tilde_operator] = ACTIONS(11571),
    [sym__type_order_operator] = ACTIONS(11571),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym__terminator_token1] = ACTIONS(11573),
    [aux_sym__terminator_token2] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8918] = {
    [sym_block_comment] = STATE(8918),
    [sym_line_comment] = STATE(8918),
    [aux_sym_open_tuple_repeat1] = STATE(8453),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12217),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10970),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10970),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10970),
    [anon_sym_DOLLAR] = ACTIONS(10970),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10970),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10970),
    [aux_sym_integer_literal_token2] = ACTIONS(10970),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10970),
    [aux_sym_float_literal_token3] = ACTIONS(10970),
    [aux_sym_float_literal_token4] = ACTIONS(10970),
    [sym_character_literal] = ACTIONS(10970),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10970),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10970),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10972),
    [aux_sym__terminator_token2] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8919] = {
    [sym_block_comment] = STATE(8919),
    [sym_line_comment] = STATE(8919),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12545),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12545),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12547),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12545),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12545),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8920] = {
    [sym_block_comment] = STATE(8920),
    [sym_line_comment] = STATE(8920),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(1117),
    [sym__comparison_operator] = ACTIONS(1091),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(1091),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8921] = {
    [sym_block_comment] = STATE(8921),
    [sym_line_comment] = STATE(8921),
    [ts_builtin_sym_end] = ACTIONS(11249),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(11054),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_RBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(11058),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11058),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11064),
    [anon_sym_where] = ACTIONS(11066),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(11068),
    [sym__arrow_operator] = ACTIONS(11070),
    [sym__lazy_or_operator] = ACTIONS(11072),
    [sym__lazy_and_operator] = ACTIONS(11074),
    [sym__comparison_operator] = ACTIONS(11058),
    [sym__pipe_right_operator] = ACTIONS(11076),
    [sym__pipe_left_operator] = ACTIONS(11078),
    [sym__ellipsis_operator] = ACTIONS(11080),
    [sym__plus_operator] = ACTIONS(11082),
    [sym__times_operator] = ACTIONS(11084),
    [sym__rational_operator] = ACTIONS(11086),
    [sym__bitshift_operator] = ACTIONS(11088),
    [sym__power_operator] = ACTIONS(11090),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(11058),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11082),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8922] = {
    [sym_block_comment] = STATE(8922),
    [sym_line_comment] = STATE(8922),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(1091),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(1091),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(1103),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(1091),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(1091),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8923] = {
    [sym_block_comment] = STATE(8923),
    [sym_line_comment] = STATE(8923),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8924] = {
    [sym_block_comment] = STATE(8924),
    [sym_line_comment] = STATE(8924),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11173),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_end] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11173),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11173),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11173),
    [anon_sym_DOLLAR] = ACTIONS(11173),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11173),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11173),
    [anon_sym_QMARK] = ACTIONS(11173),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11173),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11173),
    [aux_sym_integer_literal_token2] = ACTIONS(11173),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11173),
    [aux_sym_float_literal_token3] = ACTIONS(11173),
    [aux_sym_float_literal_token4] = ACTIONS(11173),
    [sym_character_literal] = ACTIONS(11173),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11173),
    [sym__pair_operator] = ACTIONS(11173),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11173),
    [sym__lazy_and_operator] = ACTIONS(11173),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11173),
    [sym__pipe_left_operator] = ACTIONS(11173),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11173),
    [sym__bitshift_operator] = ACTIONS(11173),
    [sym__power_operator] = ACTIONS(11173),
    [sym__tilde_operator] = ACTIONS(11173),
    [sym__type_order_operator] = ACTIONS(11173),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym__terminator_token1] = ACTIONS(11175),
    [aux_sym__terminator_token2] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8925] = {
    [sym_block_comment] = STATE(8925),
    [sym_line_comment] = STATE(8925),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8926] = {
    [sym_block_comment] = STATE(8926),
    [sym_line_comment] = STATE(8926),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_catch] = ACTIONS(11287),
    [anon_sym_finally] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(11622),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(11624),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11626),
    [anon_sym_isa] = ACTIONS(11624),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_QMARK] = ACTIONS(12156),
    [anon_sym_where] = ACTIONS(11632),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11634),
    [sym__arrow_operator] = ACTIONS(11636),
    [sym__lazy_or_operator] = ACTIONS(11638),
    [sym__lazy_and_operator] = ACTIONS(11640),
    [sym__comparison_operator] = ACTIONS(11624),
    [sym__pipe_right_operator] = ACTIONS(11642),
    [sym__pipe_left_operator] = ACTIONS(11644),
    [sym__ellipsis_operator] = ACTIONS(11646),
    [sym__plus_operator] = ACTIONS(11648),
    [sym__times_operator] = ACTIONS(11650),
    [sym__rational_operator] = ACTIONS(11652),
    [sym__bitshift_operator] = ACTIONS(11654),
    [sym__power_operator] = ACTIONS(11656),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11624),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11648),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8927] = {
    [sym_block_comment] = STATE(8927),
    [sym_line_comment] = STATE(8927),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10978),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10978),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(10978),
    [anon_sym_DOLLAR] = ACTIONS(10978),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(10978),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10978),
    [aux_sym_integer_literal_token2] = ACTIONS(10978),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10978),
    [aux_sym_float_literal_token3] = ACTIONS(10978),
    [aux_sym_float_literal_token4] = ACTIONS(10978),
    [sym_character_literal] = ACTIONS(10978),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10978),
    [sym__pair_operator] = ACTIONS(10978),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(10978),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(10982),
    [aux_sym__terminator_token2] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8928] = {
    [sym_block_comment] = STATE(8928),
    [sym_line_comment] = STATE(8928),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8929] = {
    [sym_block_comment] = STATE(8929),
    [sym_line_comment] = STATE(8929),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8930] = {
    [sym_block_comment] = STATE(8930),
    [sym_line_comment] = STATE(8930),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(1081),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1099),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12505),
    [sym__pipe_left_operator] = ACTIONS(12507),
    [sym__ellipsis_operator] = ACTIONS(12509),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8931] = {
    [sym_block_comment] = STATE(8931),
    [sym_line_comment] = STATE(8931),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_finally] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12483),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(12483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12483),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12483),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8932] = {
    [sym_block_comment] = STATE(8932),
    [sym_line_comment] = STATE(8932),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12429),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12429),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8933] = {
    [sym_block_comment] = STATE(8933),
    [sym_line_comment] = STATE(8933),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12483),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(12483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(12158),
    [anon_sym_where] = ACTIONS(12485),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12487),
    [sym__arrow_operator] = ACTIONS(12489),
    [sym__lazy_or_operator] = ACTIONS(12491),
    [sym__lazy_and_operator] = ACTIONS(12493),
    [sym__comparison_operator] = ACTIONS(12483),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12483),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8934] = {
    [sym_block_comment] = STATE(8934),
    [sym_line_comment] = STATE(8934),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_elseif] = ACTIONS(11108),
    [anon_sym_else] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(10934),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12431),
    [sym__rational_operator] = ACTIONS(12433),
    [sym__bitshift_operator] = ACTIONS(12435),
    [sym__power_operator] = ACTIONS(12394),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8935] = {
    [sym_block_comment] = STATE(8935),
    [sym_line_comment] = STATE(8935),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10208),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_RBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_RBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8936] = {
    [sym_block_comment] = STATE(8936),
    [sym_line_comment] = STATE(8936),
    [ts_builtin_sym_end] = ACTIONS(11110),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12537),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12539),
    [sym__pipe_left_operator] = ACTIONS(12541),
    [sym__ellipsis_operator] = ACTIONS(12543),
    [sym__plus_operator] = ACTIONS(12449),
    [sym__times_operator] = ACTIONS(12451),
    [sym__rational_operator] = ACTIONS(12453),
    [sym__bitshift_operator] = ACTIONS(12455),
    [sym__power_operator] = ACTIONS(12457),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12449),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8937] = {
    [sym_block_comment] = STATE(8937),
    [sym_line_comment] = STATE(8937),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12483),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(12483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12485),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12489),
    [sym__lazy_or_operator] = ACTIONS(12491),
    [sym__lazy_and_operator] = ACTIONS(12493),
    [sym__comparison_operator] = ACTIONS(12483),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12483),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8938] = {
    [sym_block_comment] = STATE(8938),
    [sym_line_comment] = STATE(8938),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12483),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(12483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12485),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12493),
    [sym__comparison_operator] = ACTIONS(12483),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12483),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8939] = {
    [sym_block_comment] = STATE(8939),
    [sym_line_comment] = STATE(8939),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12483),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(12483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12485),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12483),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12483),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8940] = {
    [sym_block_comment] = STATE(8940),
    [sym_line_comment] = STATE(8940),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8941] = {
    [sym_block_comment] = STATE(8941),
    [sym_line_comment] = STATE(8941),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12481),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11722),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12495),
    [sym__pipe_left_operator] = ACTIONS(12497),
    [sym__ellipsis_operator] = ACTIONS(12499),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8942] = {
    [sym_block_comment] = STATE(8942),
    [sym_line_comment] = STATE(8942),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12471),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12471),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8943] = {
    [sym_block_comment] = STATE(8943),
    [sym_line_comment] = STATE(8943),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12473),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8944] = {
    [sym_block_comment] = STATE(8944),
    [sym_line_comment] = STATE(8944),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_finally] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11720),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12475),
    [sym__bitshift_operator] = ACTIONS(12477),
    [sym__power_operator] = ACTIONS(12461),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8945] = {
    [sym_block_comment] = STATE(8945),
    [sym_line_comment] = STATE(8945),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_as] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8946] = {
    [sym_block_comment] = STATE(8946),
    [sym_line_comment] = STATE(8946),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_as] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8947] = {
    [sym_block_comment] = STATE(8947),
    [sym_line_comment] = STATE(8947),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12561),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12565),
    [sym__arrow_operator] = ACTIONS(12567),
    [sym__lazy_or_operator] = ACTIONS(12569),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8948] = {
    [sym_block_comment] = STATE(8948),
    [sym_line_comment] = STATE(8948),
    [aux_sym_export_statement_repeat1] = STATE(9064),
    [sym__word_identifier] = ACTIONS(10807),
    [anon_sym_COMMA] = ACTIONS(12589),
    [anon_sym_EQ] = ACTIONS(10807),
    [anon_sym_begin] = ACTIONS(10807),
    [anon_sym_module] = ACTIONS(10807),
    [anon_sym_baremodule] = ACTIONS(10807),
    [anon_sym_end] = ACTIONS(10807),
    [anon_sym_abstract] = ACTIONS(10807),
    [anon_sym_primitive] = ACTIONS(10807),
    [anon_sym_mutable] = ACTIONS(10807),
    [anon_sym_struct] = ACTIONS(10807),
    [anon_sym_function] = ACTIONS(10807),
    [anon_sym_macro] = ACTIONS(10807),
    [anon_sym_quote] = ACTIONS(10807),
    [anon_sym_let] = ACTIONS(10807),
    [anon_sym_if] = ACTIONS(10807),
    [anon_sym_try] = ACTIONS(10807),
    [anon_sym_for] = ACTIONS(10807),
    [anon_sym_while] = ACTIONS(10807),
    [sym_break_statement] = ACTIONS(10807),
    [sym_continue_statement] = ACTIONS(10807),
    [anon_sym_return] = ACTIONS(10807),
    [anon_sym_const] = ACTIONS(10807),
    [anon_sym_global] = ACTIONS(10807),
    [anon_sym_local] = ACTIONS(10807),
    [anon_sym_LPAREN] = ACTIONS(10811),
    [anon_sym_COLON] = ACTIONS(10807),
    [anon_sym_export] = ACTIONS(10807),
    [anon_sym_public] = ACTIONS(10807),
    [anon_sym_import] = ACTIONS(10807),
    [anon_sym_using] = ACTIONS(10807),
    [anon_sym_LBRACK] = ACTIONS(10811),
    [anon_sym_in] = ACTIONS(10807),
    [anon_sym_LBRACE] = ACTIONS(10811),
    [anon_sym_DOLLAR] = ACTIONS(10811),
    [anon_sym_COLON2] = ACTIONS(10807),
    [anon_sym_COLON_COLON] = ACTIONS(10811),
    [anon_sym_isa] = ACTIONS(10807),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10811),
    [anon_sym_QMARK] = ACTIONS(10811),
    [anon_sym_where] = ACTIONS(10807),
    [anon_sym_AT] = ACTIONS(10811),
    [anon_sym_true] = ACTIONS(10807),
    [anon_sym_false] = ACTIONS(10807),
    [aux_sym_integer_literal_token1] = ACTIONS(10811),
    [aux_sym_integer_literal_token2] = ACTIONS(10811),
    [aux_sym_integer_literal_token3] = ACTIONS(10807),
    [aux_sym_integer_literal_token4] = ACTIONS(10807),
    [aux_sym_float_literal_token1] = ACTIONS(10811),
    [aux_sym_float_literal_token3] = ACTIONS(10811),
    [aux_sym_float_literal_token4] = ACTIONS(10811),
    [sym_character_literal] = ACTIONS(10811),
    [anon_sym_DQUOTE] = ACTIONS(10807),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10811),
    [anon_sym_BQUOTE] = ACTIONS(10807),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10811),
    [sym__pair_operator] = ACTIONS(10811),
    [sym__arrow_operator] = ACTIONS(10807),
    [sym__lazy_or_operator] = ACTIONS(10811),
    [sym__lazy_and_operator] = ACTIONS(10811),
    [sym__comparison_operator] = ACTIONS(10807),
    [sym__pipe_right_operator] = ACTIONS(10811),
    [sym__pipe_left_operator] = ACTIONS(10811),
    [sym__ellipsis_operator] = ACTIONS(10807),
    [sym__plus_operator] = ACTIONS(10807),
    [sym__times_operator] = ACTIONS(10807),
    [sym__rational_operator] = ACTIONS(10811),
    [sym__bitshift_operator] = ACTIONS(10811),
    [sym__power_operator] = ACTIONS(10811),
    [sym__tilde_operator] = ACTIONS(10811),
    [sym__type_order_operator] = ACTIONS(10811),
    [sym__unary_operator] = ACTIONS(10807),
    [sym__unary_plus_operator] = ACTIONS(10807),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8949] = {
    [sym_block_comment] = STATE(8949),
    [sym_line_comment] = STATE(8949),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_COMMA] = ACTIONS(10020),
    [anon_sym_EQ] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10020),
    [anon_sym_COLON] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10020),
    [anon_sym_in] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10020),
    [anon_sym_DOT] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10020),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10020),
    [anon_sym_isa] = ACTIONS(10018),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10020),
    [anon_sym_QMARK] = ACTIONS(10020),
    [anon_sym_where] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10020),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10020),
    [aux_sym_integer_literal_token2] = ACTIONS(10020),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10020),
    [aux_sym_float_literal_token3] = ACTIONS(10020),
    [aux_sym_float_literal_token4] = ACTIONS(10020),
    [sym_character_literal] = ACTIONS(10020),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10020),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10020),
    [sym__pair_operator] = ACTIONS(10020),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__lazy_or_operator] = ACTIONS(10020),
    [sym__lazy_and_operator] = ACTIONS(10020),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10020),
    [sym__pipe_left_operator] = ACTIONS(10020),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10020),
    [sym__bitshift_operator] = ACTIONS(10020),
    [sym__power_operator] = ACTIONS(10020),
    [sym__tilde_operator] = ACTIONS(10020),
    [sym__type_order_operator] = ACTIONS(10020),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8950] = {
    [sym_block_comment] = STATE(8950),
    [sym_line_comment] = STATE(8950),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_SEMI] = ACTIONS(11022),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8951] = {
    [sym_block_comment] = STATE(8951),
    [sym_line_comment] = STATE(8951),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_COMMA] = ACTIONS(9918),
    [anon_sym_EQ] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9918),
    [anon_sym_COLON] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9918),
    [anon_sym_in] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9918),
    [anon_sym_DOT] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9918),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9918),
    [anon_sym_isa] = ACTIONS(9916),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9918),
    [anon_sym_QMARK] = ACTIONS(9918),
    [anon_sym_where] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9918),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9918),
    [aux_sym_integer_literal_token2] = ACTIONS(9918),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9918),
    [aux_sym_float_literal_token3] = ACTIONS(9918),
    [aux_sym_float_literal_token4] = ACTIONS(9918),
    [sym_character_literal] = ACTIONS(9918),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9918),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9918),
    [sym__pair_operator] = ACTIONS(9918),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__lazy_or_operator] = ACTIONS(9918),
    [sym__lazy_and_operator] = ACTIONS(9918),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9918),
    [sym__pipe_left_operator] = ACTIONS(9918),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9918),
    [sym__bitshift_operator] = ACTIONS(9918),
    [sym__power_operator] = ACTIONS(9918),
    [sym__tilde_operator] = ACTIONS(9918),
    [sym__type_order_operator] = ACTIONS(9918),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8952] = {
    [sym_block_comment] = STATE(8952),
    [sym_line_comment] = STATE(8952),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_COMMA] = ACTIONS(9922),
    [anon_sym_EQ] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9922),
    [anon_sym_COLON] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9922),
    [anon_sym_in] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9922),
    [anon_sym_DOT] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9922),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9922),
    [anon_sym_isa] = ACTIONS(9920),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9922),
    [anon_sym_QMARK] = ACTIONS(9922),
    [anon_sym_where] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9922),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9922),
    [aux_sym_integer_literal_token2] = ACTIONS(9922),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9922),
    [aux_sym_float_literal_token3] = ACTIONS(9922),
    [aux_sym_float_literal_token4] = ACTIONS(9922),
    [sym_character_literal] = ACTIONS(9922),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9922),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9922),
    [sym__pair_operator] = ACTIONS(9922),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__lazy_or_operator] = ACTIONS(9922),
    [sym__lazy_and_operator] = ACTIONS(9922),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9922),
    [sym__pipe_left_operator] = ACTIONS(9922),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9922),
    [sym__bitshift_operator] = ACTIONS(9922),
    [sym__power_operator] = ACTIONS(9922),
    [sym__tilde_operator] = ACTIONS(9922),
    [sym__type_order_operator] = ACTIONS(9922),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8953] = {
    [sym_block_comment] = STATE(8953),
    [sym_line_comment] = STATE(8953),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11022),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8954] = {
    [sym_block_comment] = STATE(8954),
    [sym_line_comment] = STATE(8954),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
  },
  [8955] = {
    [sym_block_comment] = STATE(8955),
    [sym_line_comment] = STATE(8955),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_COMMA] = ACTIONS(9728),
    [anon_sym_EQ] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9728),
    [anon_sym_COLON] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9728),
    [anon_sym_in] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9728),
    [anon_sym_DOT] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9728),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9728),
    [anon_sym_isa] = ACTIONS(9724),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9728),
    [anon_sym_QMARK] = ACTIONS(9728),
    [anon_sym_where] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9728),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9728),
    [aux_sym_integer_literal_token2] = ACTIONS(9728),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9728),
    [aux_sym_float_literal_token3] = ACTIONS(9728),
    [aux_sym_float_literal_token4] = ACTIONS(9728),
    [sym_character_literal] = ACTIONS(9728),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9728),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9728),
    [sym__pair_operator] = ACTIONS(9728),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__lazy_or_operator] = ACTIONS(9728),
    [sym__lazy_and_operator] = ACTIONS(9728),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9728),
    [sym__pipe_left_operator] = ACTIONS(9728),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9728),
    [sym__bitshift_operator] = ACTIONS(9728),
    [sym__power_operator] = ACTIONS(9728),
    [sym__tilde_operator] = ACTIONS(9728),
    [sym__type_order_operator] = ACTIONS(9728),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8956] = {
    [sym_block_comment] = STATE(8956),
    [sym_line_comment] = STATE(8956),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(12533),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8957] = {
    [sym_block_comment] = STATE(8957),
    [sym_line_comment] = STATE(8957),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11866),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8958] = {
    [sym_block_comment] = STATE(8958),
    [sym_line_comment] = STATE(8958),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10186),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8959] = {
    [sym_block_comment] = STATE(8959),
    [sym_line_comment] = STATE(8959),
    [aux_sym__import_list_repeat1] = STATE(8959),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(12593),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10863),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10863),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10863),
    [anon_sym_DOLLAR] = ACTIONS(10863),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10863),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10863),
    [anon_sym_QMARK] = ACTIONS(10863),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10863),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10863),
    [aux_sym_integer_literal_token2] = ACTIONS(10863),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10863),
    [aux_sym_float_literal_token3] = ACTIONS(10863),
    [aux_sym_float_literal_token4] = ACTIONS(10863),
    [sym_character_literal] = ACTIONS(10863),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10863),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10863),
    [sym__pair_operator] = ACTIONS(10863),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10863),
    [sym__lazy_and_operator] = ACTIONS(10863),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10863),
    [sym__pipe_left_operator] = ACTIONS(10863),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10863),
    [sym__bitshift_operator] = ACTIONS(10863),
    [sym__power_operator] = ACTIONS(10863),
    [sym__tilde_operator] = ACTIONS(10863),
    [sym__type_order_operator] = ACTIONS(10863),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8960] = {
    [sym_block_comment] = STATE(8960),
    [sym_line_comment] = STATE(8960),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_COMMA] = ACTIONS(9984),
    [anon_sym_EQ] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9984),
    [anon_sym_COLON] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9984),
    [anon_sym_in] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9984),
    [anon_sym_DOT] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9984),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9984),
    [anon_sym_isa] = ACTIONS(9982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9984),
    [anon_sym_QMARK] = ACTIONS(9984),
    [anon_sym_where] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9984),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9984),
    [aux_sym_integer_literal_token2] = ACTIONS(9984),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9984),
    [aux_sym_float_literal_token3] = ACTIONS(9984),
    [aux_sym_float_literal_token4] = ACTIONS(9984),
    [sym_character_literal] = ACTIONS(9984),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9984),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9984),
    [sym__pair_operator] = ACTIONS(9984),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__lazy_or_operator] = ACTIONS(9984),
    [sym__lazy_and_operator] = ACTIONS(9984),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9984),
    [sym__pipe_left_operator] = ACTIONS(9984),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9984),
    [sym__bitshift_operator] = ACTIONS(9984),
    [sym__power_operator] = ACTIONS(9984),
    [sym__tilde_operator] = ACTIONS(9984),
    [sym__type_order_operator] = ACTIONS(9984),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8961] = {
    [sym_block_comment] = STATE(8961),
    [sym_line_comment] = STATE(8961),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
  },
  [8962] = {
    [sym_block_comment] = STATE(8962),
    [sym_line_comment] = STATE(8962),
    [sym__word_identifier] = ACTIONS(9926),
    [anon_sym_COMMA] = ACTIONS(9928),
    [anon_sym_EQ] = ACTIONS(9926),
    [anon_sym_begin] = ACTIONS(9926),
    [anon_sym_module] = ACTIONS(9926),
    [anon_sym_baremodule] = ACTIONS(9926),
    [anon_sym_end] = ACTIONS(9926),
    [anon_sym_abstract] = ACTIONS(9926),
    [anon_sym_primitive] = ACTIONS(9926),
    [anon_sym_mutable] = ACTIONS(9926),
    [anon_sym_struct] = ACTIONS(9926),
    [anon_sym_function] = ACTIONS(9926),
    [anon_sym_macro] = ACTIONS(9926),
    [anon_sym_quote] = ACTIONS(9926),
    [anon_sym_let] = ACTIONS(9926),
    [anon_sym_if] = ACTIONS(9926),
    [anon_sym_try] = ACTIONS(9926),
    [anon_sym_for] = ACTIONS(9926),
    [anon_sym_while] = ACTIONS(9926),
    [sym_break_statement] = ACTIONS(9926),
    [sym_continue_statement] = ACTIONS(9926),
    [anon_sym_return] = ACTIONS(9926),
    [anon_sym_const] = ACTIONS(9926),
    [anon_sym_global] = ACTIONS(9926),
    [anon_sym_local] = ACTIONS(9926),
    [anon_sym_LPAREN] = ACTIONS(9928),
    [anon_sym_COLON] = ACTIONS(9926),
    [anon_sym_export] = ACTIONS(9926),
    [anon_sym_public] = ACTIONS(9926),
    [anon_sym_import] = ACTIONS(9926),
    [anon_sym_using] = ACTIONS(9926),
    [anon_sym_LBRACK] = ACTIONS(9928),
    [anon_sym_in] = ACTIONS(9926),
    [anon_sym_LBRACE] = ACTIONS(9928),
    [anon_sym_DOT] = ACTIONS(9926),
    [anon_sym_DOLLAR] = ACTIONS(9928),
    [anon_sym_COLON2] = ACTIONS(9926),
    [anon_sym_COLON_COLON] = ACTIONS(9928),
    [anon_sym_isa] = ACTIONS(9926),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9928),
    [anon_sym_QMARK] = ACTIONS(9928),
    [anon_sym_where] = ACTIONS(9926),
    [anon_sym_AT] = ACTIONS(9928),
    [anon_sym_true] = ACTIONS(9926),
    [anon_sym_false] = ACTIONS(9926),
    [aux_sym_integer_literal_token1] = ACTIONS(9928),
    [aux_sym_integer_literal_token2] = ACTIONS(9928),
    [aux_sym_integer_literal_token3] = ACTIONS(9926),
    [aux_sym_integer_literal_token4] = ACTIONS(9926),
    [aux_sym_float_literal_token1] = ACTIONS(9928),
    [aux_sym_float_literal_token3] = ACTIONS(9928),
    [aux_sym_float_literal_token4] = ACTIONS(9928),
    [sym_character_literal] = ACTIONS(9928),
    [anon_sym_DQUOTE] = ACTIONS(9926),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9928),
    [anon_sym_BQUOTE] = ACTIONS(9926),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9928),
    [sym__pair_operator] = ACTIONS(9928),
    [sym__arrow_operator] = ACTIONS(9926),
    [sym__lazy_or_operator] = ACTIONS(9928),
    [sym__lazy_and_operator] = ACTIONS(9928),
    [sym__comparison_operator] = ACTIONS(9926),
    [sym__pipe_right_operator] = ACTIONS(9928),
    [sym__pipe_left_operator] = ACTIONS(9928),
    [sym__ellipsis_operator] = ACTIONS(9926),
    [sym__plus_operator] = ACTIONS(9926),
    [sym__times_operator] = ACTIONS(9926),
    [sym__rational_operator] = ACTIONS(9928),
    [sym__bitshift_operator] = ACTIONS(9928),
    [sym__power_operator] = ACTIONS(9928),
    [sym__tilde_operator] = ACTIONS(9928),
    [sym__type_order_operator] = ACTIONS(9928),
    [sym__unary_operator] = ACTIONS(9926),
    [sym__unary_plus_operator] = ACTIONS(9926),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8963] = {
    [sym_block_comment] = STATE(8963),
    [sym_line_comment] = STATE(8963),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_COMMA] = ACTIONS(10082),
    [anon_sym_EQ] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10082),
    [anon_sym_COLON] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10082),
    [anon_sym_in] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10082),
    [anon_sym_DOT] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10082),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10082),
    [anon_sym_isa] = ACTIONS(10080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10082),
    [anon_sym_QMARK] = ACTIONS(10082),
    [anon_sym_where] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10082),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10082),
    [aux_sym_integer_literal_token2] = ACTIONS(10082),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10082),
    [aux_sym_float_literal_token3] = ACTIONS(10082),
    [aux_sym_float_literal_token4] = ACTIONS(10082),
    [sym_character_literal] = ACTIONS(10082),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10082),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10082),
    [sym__pair_operator] = ACTIONS(10082),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__lazy_or_operator] = ACTIONS(10082),
    [sym__lazy_and_operator] = ACTIONS(10082),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10082),
    [sym__pipe_left_operator] = ACTIONS(10082),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10082),
    [sym__bitshift_operator] = ACTIONS(10082),
    [sym__power_operator] = ACTIONS(10082),
    [sym__tilde_operator] = ACTIONS(10082),
    [sym__type_order_operator] = ACTIONS(10082),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8964] = {
    [sym_block_comment] = STATE(8964),
    [sym_line_comment] = STATE(8964),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_COMMA] = ACTIONS(9988),
    [anon_sym_EQ] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9988),
    [anon_sym_COLON] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9988),
    [anon_sym_in] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9988),
    [anon_sym_DOT] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9988),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9988),
    [anon_sym_isa] = ACTIONS(9986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9988),
    [anon_sym_QMARK] = ACTIONS(9988),
    [anon_sym_where] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9988),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9988),
    [aux_sym_integer_literal_token2] = ACTIONS(9988),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9988),
    [aux_sym_float_literal_token3] = ACTIONS(9988),
    [aux_sym_float_literal_token4] = ACTIONS(9988),
    [sym_character_literal] = ACTIONS(9988),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9988),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9988),
    [sym__pair_operator] = ACTIONS(9988),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__lazy_or_operator] = ACTIONS(9988),
    [sym__lazy_and_operator] = ACTIONS(9988),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9988),
    [sym__pipe_left_operator] = ACTIONS(9988),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9988),
    [sym__bitshift_operator] = ACTIONS(9988),
    [sym__power_operator] = ACTIONS(9988),
    [sym__tilde_operator] = ACTIONS(9988),
    [sym__type_order_operator] = ACTIONS(9988),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8965] = {
    [sym_block_comment] = STATE(8965),
    [sym_line_comment] = STATE(8965),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10336),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
  },
  [8966] = {
    [sym_block_comment] = STATE(8966),
    [sym_line_comment] = STATE(8966),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8967] = {
    [sym_block_comment] = STATE(8967),
    [sym_line_comment] = STATE(8967),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10096),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8968] = {
    [sym_block_comment] = STATE(8968),
    [sym_line_comment] = STATE(8968),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12614),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12616),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12620),
    [sym__lazy_or_operator] = ACTIONS(12622),
    [sym__lazy_and_operator] = ACTIONS(12624),
    [sym__comparison_operator] = ACTIONS(12614),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12626),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8969] = {
    [sym_block_comment] = STATE(8969),
    [sym_line_comment] = STATE(8969),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12614),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12616),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(12620),
    [sym__lazy_or_operator] = ACTIONS(12622),
    [sym__lazy_and_operator] = ACTIONS(12624),
    [sym__comparison_operator] = ACTIONS(12614),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12626),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8970] = {
    [sym_block_comment] = STATE(8970),
    [sym_line_comment] = STATE(8970),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_SEMI] = ACTIONS(10968),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8971] = {
    [sym_block_comment] = STATE(8971),
    [sym_line_comment] = STATE(8971),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_as] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8972] = {
    [sym_block_comment] = STATE(8972),
    [sym_line_comment] = STATE(8972),
    [aux_sym_open_tuple_repeat1] = STATE(8978),
    [sym__word_identifier] = ACTIONS(10829),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_EQ] = ACTIONS(10829),
    [anon_sym_begin] = ACTIONS(10829),
    [anon_sym_module] = ACTIONS(10829),
    [anon_sym_baremodule] = ACTIONS(10829),
    [anon_sym_end] = ACTIONS(10829),
    [anon_sym_abstract] = ACTIONS(10829),
    [anon_sym_primitive] = ACTIONS(10829),
    [anon_sym_mutable] = ACTIONS(10829),
    [anon_sym_struct] = ACTIONS(10829),
    [anon_sym_function] = ACTIONS(10829),
    [anon_sym_macro] = ACTIONS(10829),
    [anon_sym_quote] = ACTIONS(10829),
    [anon_sym_let] = ACTIONS(10829),
    [anon_sym_if] = ACTIONS(10829),
    [anon_sym_try] = ACTIONS(10829),
    [anon_sym_for] = ACTIONS(10829),
    [anon_sym_while] = ACTIONS(10829),
    [sym_break_statement] = ACTIONS(10829),
    [sym_continue_statement] = ACTIONS(10829),
    [anon_sym_return] = ACTIONS(10829),
    [anon_sym_const] = ACTIONS(10829),
    [anon_sym_global] = ACTIONS(10829),
    [anon_sym_local] = ACTIONS(10829),
    [anon_sym_LPAREN] = ACTIONS(10833),
    [anon_sym_COLON] = ACTIONS(10829),
    [anon_sym_export] = ACTIONS(10829),
    [anon_sym_public] = ACTIONS(10829),
    [anon_sym_import] = ACTIONS(10829),
    [anon_sym_using] = ACTIONS(10829),
    [anon_sym_LBRACK] = ACTIONS(10833),
    [anon_sym_in] = ACTIONS(10829),
    [anon_sym_LBRACE] = ACTIONS(10833),
    [anon_sym_DOLLAR] = ACTIONS(10833),
    [anon_sym_COLON2] = ACTIONS(10829),
    [anon_sym_COLON_COLON] = ACTIONS(10833),
    [anon_sym_isa] = ACTIONS(10829),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10833),
    [anon_sym_QMARK] = ACTIONS(10833),
    [anon_sym_where] = ACTIONS(10829),
    [anon_sym_AT] = ACTIONS(10833),
    [anon_sym_true] = ACTIONS(10829),
    [anon_sym_false] = ACTIONS(10829),
    [aux_sym_integer_literal_token1] = ACTIONS(10833),
    [aux_sym_integer_literal_token2] = ACTIONS(10833),
    [aux_sym_integer_literal_token3] = ACTIONS(10829),
    [aux_sym_integer_literal_token4] = ACTIONS(10829),
    [aux_sym_float_literal_token1] = ACTIONS(10833),
    [aux_sym_float_literal_token3] = ACTIONS(10833),
    [aux_sym_float_literal_token4] = ACTIONS(10833),
    [sym_character_literal] = ACTIONS(10833),
    [anon_sym_DQUOTE] = ACTIONS(10829),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10833),
    [anon_sym_BQUOTE] = ACTIONS(10829),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10833),
    [sym__pair_operator] = ACTIONS(10833),
    [sym__arrow_operator] = ACTIONS(10829),
    [sym__lazy_or_operator] = ACTIONS(10833),
    [sym__lazy_and_operator] = ACTIONS(10833),
    [sym__comparison_operator] = ACTIONS(10829),
    [sym__pipe_right_operator] = ACTIONS(10833),
    [sym__pipe_left_operator] = ACTIONS(10833),
    [sym__ellipsis_operator] = ACTIONS(10829),
    [sym__plus_operator] = ACTIONS(10829),
    [sym__times_operator] = ACTIONS(10829),
    [sym__rational_operator] = ACTIONS(10833),
    [sym__bitshift_operator] = ACTIONS(10833),
    [sym__power_operator] = ACTIONS(10833),
    [sym__tilde_operator] = ACTIONS(10833),
    [sym__type_order_operator] = ACTIONS(10833),
    [sym__unary_operator] = ACTIONS(10829),
    [sym__unary_plus_operator] = ACTIONS(10829),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8973] = {
    [sym_block_comment] = STATE(8973),
    [sym_line_comment] = STATE(8973),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12614),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12616),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(12624),
    [sym__comparison_operator] = ACTIONS(12614),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12626),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8974] = {
    [sym_block_comment] = STATE(8974),
    [sym_line_comment] = STATE(8974),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12614),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12616),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(12614),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12626),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8975] = {
    [sym_block_comment] = STATE(8975),
    [sym_line_comment] = STATE(8975),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_SEMI] = ACTIONS(10976),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8976] = {
    [sym_block_comment] = STATE(8976),
    [sym_line_comment] = STATE(8976),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8977] = {
    [sym_block_comment] = STATE(8977),
    [sym_line_comment] = STATE(8977),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_SEMI] = ACTIONS(10976),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8978] = {
    [sym_block_comment] = STATE(8978),
    [sym_line_comment] = STATE(8978),
    [aux_sym_open_tuple_repeat1] = STATE(8978),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(12632),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10840),
    [anon_sym_COLON] = ACTIONS(10835),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10840),
    [anon_sym_in] = ACTIONS(10835),
    [anon_sym_LBRACE] = ACTIONS(10840),
    [anon_sym_DOLLAR] = ACTIONS(10840),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10840),
    [anon_sym_isa] = ACTIONS(10835),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10840),
    [anon_sym_QMARK] = ACTIONS(10840),
    [anon_sym_where] = ACTIONS(10835),
    [anon_sym_AT] = ACTIONS(10840),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10840),
    [aux_sym_integer_literal_token2] = ACTIONS(10840),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10840),
    [aux_sym_float_literal_token3] = ACTIONS(10840),
    [aux_sym_float_literal_token4] = ACTIONS(10840),
    [sym_character_literal] = ACTIONS(10840),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10840),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10840),
    [sym__pair_operator] = ACTIONS(10840),
    [sym__arrow_operator] = ACTIONS(10835),
    [sym__lazy_or_operator] = ACTIONS(10840),
    [sym__lazy_and_operator] = ACTIONS(10840),
    [sym__comparison_operator] = ACTIONS(10835),
    [sym__pipe_right_operator] = ACTIONS(10840),
    [sym__pipe_left_operator] = ACTIONS(10840),
    [sym__ellipsis_operator] = ACTIONS(10835),
    [sym__plus_operator] = ACTIONS(10835),
    [sym__times_operator] = ACTIONS(10835),
    [sym__rational_operator] = ACTIONS(10840),
    [sym__bitshift_operator] = ACTIONS(10840),
    [sym__power_operator] = ACTIONS(10840),
    [sym__tilde_operator] = ACTIONS(10840),
    [sym__type_order_operator] = ACTIONS(10840),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(10835),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8979] = {
    [sym_block_comment] = STATE(8979),
    [sym_line_comment] = STATE(8979),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_COMMA] = ACTIONS(10002),
    [anon_sym_EQ] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10002),
    [anon_sym_COLON] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10002),
    [anon_sym_in] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10002),
    [anon_sym_DOT] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10002),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10002),
    [anon_sym_isa] = ACTIONS(10000),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10002),
    [anon_sym_QMARK] = ACTIONS(10002),
    [anon_sym_where] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10002),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10002),
    [aux_sym_integer_literal_token2] = ACTIONS(10002),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10002),
    [aux_sym_float_literal_token3] = ACTIONS(10002),
    [aux_sym_float_literal_token4] = ACTIONS(10002),
    [sym_character_literal] = ACTIONS(10002),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10002),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10002),
    [sym__pair_operator] = ACTIONS(10002),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__lazy_or_operator] = ACTIONS(10002),
    [sym__lazy_and_operator] = ACTIONS(10002),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10002),
    [sym__pipe_left_operator] = ACTIONS(10002),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10002),
    [sym__bitshift_operator] = ACTIONS(10002),
    [sym__power_operator] = ACTIONS(10002),
    [sym__tilde_operator] = ACTIONS(10002),
    [sym__type_order_operator] = ACTIONS(10002),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8980] = {
    [sym_block_comment] = STATE(8980),
    [sym_line_comment] = STATE(8980),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_SEMI] = ACTIONS(10964),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8981] = {
    [sym_block_comment] = STATE(8981),
    [sym_line_comment] = STATE(8981),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_COMMA] = ACTIONS(10154),
    [anon_sym_EQ] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_end] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_COLON] = ACTIONS(10152),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_in] = ACTIONS(10152),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_DOT] = ACTIONS(10152),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_isa] = ACTIONS(10152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10154),
    [anon_sym_QMARK] = ACTIONS(10154),
    [anon_sym_where] = ACTIONS(10152),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__lazy_or_operator] = ACTIONS(10154),
    [sym__lazy_and_operator] = ACTIONS(10154),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10152),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8982] = {
    [sym_block_comment] = STATE(8982),
    [sym_line_comment] = STATE(8982),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10336),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10160),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8983] = {
    [sym_block_comment] = STATE(8983),
    [sym_line_comment] = STATE(8983),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_COMMA] = ACTIONS(9992),
    [anon_sym_EQ] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9992),
    [anon_sym_COLON] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9992),
    [anon_sym_in] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9992),
    [anon_sym_DOT] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9992),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9992),
    [anon_sym_isa] = ACTIONS(9990),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9992),
    [anon_sym_QMARK] = ACTIONS(9992),
    [anon_sym_where] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9992),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9992),
    [aux_sym_integer_literal_token2] = ACTIONS(9992),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9992),
    [aux_sym_float_literal_token3] = ACTIONS(9992),
    [aux_sym_float_literal_token4] = ACTIONS(9992),
    [sym_character_literal] = ACTIONS(9992),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9992),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9992),
    [sym__pair_operator] = ACTIONS(9992),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__lazy_or_operator] = ACTIONS(9992),
    [sym__lazy_and_operator] = ACTIONS(9992),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9992),
    [sym__pipe_left_operator] = ACTIONS(9992),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9992),
    [sym__bitshift_operator] = ACTIONS(9992),
    [sym__power_operator] = ACTIONS(9992),
    [sym__tilde_operator] = ACTIONS(9992),
    [sym__type_order_operator] = ACTIONS(9992),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8984] = {
    [sym_block_comment] = STATE(8984),
    [sym_line_comment] = STATE(8984),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_SEMI] = ACTIONS(10968),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8985] = {
    [sym_block_comment] = STATE(8985),
    [sym_line_comment] = STATE(8985),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_COMMA] = ACTIONS(9914),
    [anon_sym_EQ] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9914),
    [anon_sym_COLON] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9914),
    [anon_sym_in] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9914),
    [anon_sym_DOT] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9914),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9914),
    [anon_sym_isa] = ACTIONS(9912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9914),
    [anon_sym_QMARK] = ACTIONS(9914),
    [anon_sym_where] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9914),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9914),
    [aux_sym_integer_literal_token2] = ACTIONS(9914),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9914),
    [aux_sym_float_literal_token3] = ACTIONS(9914),
    [aux_sym_float_literal_token4] = ACTIONS(9914),
    [sym_character_literal] = ACTIONS(9914),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9914),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9914),
    [sym__pair_operator] = ACTIONS(9914),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__lazy_or_operator] = ACTIONS(9914),
    [sym__lazy_and_operator] = ACTIONS(9914),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9914),
    [sym__pipe_left_operator] = ACTIONS(9914),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9914),
    [sym__bitshift_operator] = ACTIONS(9914),
    [sym__power_operator] = ACTIONS(9914),
    [sym__tilde_operator] = ACTIONS(9914),
    [sym__type_order_operator] = ACTIONS(9914),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8986] = {
    [sym_block_comment] = STATE(8986),
    [sym_line_comment] = STATE(8986),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8987] = {
    [sym_block_comment] = STATE(8987),
    [sym_line_comment] = STATE(8987),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12567),
    [sym__lazy_or_operator] = ACTIONS(12569),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8988] = {
    [sym_block_comment] = STATE(8988),
    [sym_line_comment] = STATE(8988),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8989] = {
    [sym_block_comment] = STATE(8989),
    [sym_line_comment] = STATE(8989),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8990] = {
    [sym_block_comment] = STATE(8990),
    [sym_line_comment] = STATE(8990),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8991] = {
    [sym_block_comment] = STATE(8991),
    [sym_line_comment] = STATE(8991),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8992] = {
    [sym_block_comment] = STATE(8992),
    [sym_line_comment] = STATE(8992),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8993] = {
    [sym_block_comment] = STATE(8993),
    [sym_line_comment] = STATE(8993),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8994] = {
    [sym_block_comment] = STATE(8994),
    [sym_line_comment] = STATE(8994),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8995] = {
    [sym_block_comment] = STATE(8995),
    [sym_line_comment] = STATE(8995),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8996] = {
    [sym_block_comment] = STATE(8996),
    [sym_line_comment] = STATE(8996),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8997] = {
    [sym_block_comment] = STATE(8997),
    [sym_line_comment] = STATE(8997),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8998] = {
    [sym_block_comment] = STATE(8998),
    [sym_line_comment] = STATE(8998),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [8999] = {
    [sym_block_comment] = STATE(8999),
    [sym_line_comment] = STATE(8999),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9000] = {
    [sym_block_comment] = STATE(9000),
    [sym_line_comment] = STATE(9000),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10148),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9001] = {
    [sym_block_comment] = STATE(9001),
    [sym_line_comment] = STATE(9001),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_COMMA] = ACTIONS(9644),
    [anon_sym_EQ] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9644),
    [anon_sym_COLON] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9644),
    [anon_sym_in] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9644),
    [anon_sym_DOT] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9644),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9644),
    [anon_sym_isa] = ACTIONS(9642),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9644),
    [anon_sym_QMARK] = ACTIONS(9644),
    [anon_sym_where] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9644),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9644),
    [aux_sym_integer_literal_token2] = ACTIONS(9644),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9644),
    [aux_sym_float_literal_token3] = ACTIONS(9644),
    [aux_sym_float_literal_token4] = ACTIONS(9644),
    [sym_character_literal] = ACTIONS(9644),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9644),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9644),
    [sym__pair_operator] = ACTIONS(9644),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__lazy_or_operator] = ACTIONS(9644),
    [sym__lazy_and_operator] = ACTIONS(9644),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9644),
    [sym__pipe_left_operator] = ACTIONS(9644),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9644),
    [sym__bitshift_operator] = ACTIONS(9644),
    [sym__power_operator] = ACTIONS(9644),
    [sym__tilde_operator] = ACTIONS(9644),
    [sym__type_order_operator] = ACTIONS(9644),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9002] = {
    [sym_block_comment] = STATE(9002),
    [sym_line_comment] = STATE(9002),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_SEMI] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9003] = {
    [sym_block_comment] = STATE(9003),
    [sym_line_comment] = STATE(9003),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_RPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10982),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9004] = {
    [sym_block_comment] = STATE(9004),
    [sym_line_comment] = STATE(9004),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_COMMA] = ACTIONS(10006),
    [anon_sym_EQ] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10006),
    [anon_sym_COLON] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10006),
    [anon_sym_in] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10006),
    [anon_sym_DOT] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10006),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10006),
    [anon_sym_isa] = ACTIONS(10004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10006),
    [anon_sym_QMARK] = ACTIONS(10006),
    [anon_sym_where] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10006),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10006),
    [aux_sym_integer_literal_token2] = ACTIONS(10006),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10006),
    [aux_sym_float_literal_token3] = ACTIONS(10006),
    [aux_sym_float_literal_token4] = ACTIONS(10006),
    [sym_character_literal] = ACTIONS(10006),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10006),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10006),
    [sym__pair_operator] = ACTIONS(10006),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__lazy_or_operator] = ACTIONS(10006),
    [sym__lazy_and_operator] = ACTIONS(10006),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10006),
    [sym__pipe_left_operator] = ACTIONS(10006),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10006),
    [sym__bitshift_operator] = ACTIONS(10006),
    [sym__power_operator] = ACTIONS(10006),
    [sym__tilde_operator] = ACTIONS(10006),
    [sym__type_order_operator] = ACTIONS(10006),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9005] = {
    [sym_block_comment] = STATE(9005),
    [sym_line_comment] = STATE(9005),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(3075),
  },
  [9006] = {
    [sym_block_comment] = STATE(9006),
    [sym_line_comment] = STATE(9006),
    [aux_sym_export_statement_repeat1] = STATE(9006),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(12635),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10855),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10855),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10855),
    [anon_sym_DOLLAR] = ACTIONS(10855),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10855),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10855),
    [anon_sym_QMARK] = ACTIONS(10855),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10855),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10855),
    [aux_sym_integer_literal_token2] = ACTIONS(10855),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10855),
    [aux_sym_float_literal_token3] = ACTIONS(10855),
    [aux_sym_float_literal_token4] = ACTIONS(10855),
    [sym_character_literal] = ACTIONS(10855),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10855),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10855),
    [sym__pair_operator] = ACTIONS(10855),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10855),
    [sym__lazy_and_operator] = ACTIONS(10855),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10855),
    [sym__pipe_left_operator] = ACTIONS(10855),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10855),
    [sym__bitshift_operator] = ACTIONS(10855),
    [sym__power_operator] = ACTIONS(10855),
    [sym__tilde_operator] = ACTIONS(10855),
    [sym__type_order_operator] = ACTIONS(10855),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9007] = {
    [sym_block_comment] = STATE(9007),
    [sym_line_comment] = STATE(9007),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_COMMA] = ACTIONS(9996),
    [anon_sym_EQ] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9996),
    [anon_sym_COLON] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9996),
    [anon_sym_in] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9996),
    [anon_sym_DOT] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9996),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9996),
    [anon_sym_isa] = ACTIONS(9994),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9996),
    [anon_sym_QMARK] = ACTIONS(9996),
    [anon_sym_where] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9996),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9996),
    [aux_sym_integer_literal_token2] = ACTIONS(9996),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9996),
    [aux_sym_float_literal_token3] = ACTIONS(9996),
    [aux_sym_float_literal_token4] = ACTIONS(9996),
    [sym_character_literal] = ACTIONS(9996),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9996),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9996),
    [sym__pair_operator] = ACTIONS(9996),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__lazy_or_operator] = ACTIONS(9996),
    [sym__lazy_and_operator] = ACTIONS(9996),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9996),
    [sym__pipe_left_operator] = ACTIONS(9996),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9996),
    [sym__bitshift_operator] = ACTIONS(9996),
    [sym__power_operator] = ACTIONS(9996),
    [sym__tilde_operator] = ACTIONS(9996),
    [sym__type_order_operator] = ACTIONS(9996),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9008] = {
    [sym_block_comment] = STATE(9008),
    [sym_line_comment] = STATE(9008),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11277),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11277),
    [anon_sym_RPAREN] = ACTIONS(11277),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11277),
    [anon_sym_RBRACK] = ACTIONS(11277),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11277),
    [anon_sym_RBRACE] = ACTIONS(11277),
    [anon_sym_DOLLAR] = ACTIONS(11277),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11277),
    [anon_sym_QMARK] = ACTIONS(11277),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11277),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11277),
    [aux_sym_integer_literal_token2] = ACTIONS(11277),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11277),
    [aux_sym_float_literal_token3] = ACTIONS(11277),
    [aux_sym_float_literal_token4] = ACTIONS(11277),
    [sym_character_literal] = ACTIONS(11277),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11277),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11277),
    [sym__pair_operator] = ACTIONS(11277),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11277),
    [sym__lazy_and_operator] = ACTIONS(11277),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11277),
    [sym__pipe_left_operator] = ACTIONS(11277),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11277),
    [sym__type_order_operator] = ACTIONS(11277),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9009] = {
    [sym_block_comment] = STATE(9009),
    [sym_line_comment] = STATE(9009),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_RPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10976),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9010] = {
    [sym_block_comment] = STATE(9010),
    [sym_line_comment] = STATE(9010),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10910),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_as] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10910),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10910),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10910),
    [anon_sym_DOLLAR] = ACTIONS(10910),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10910),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10910),
    [anon_sym_QMARK] = ACTIONS(10910),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10910),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10910),
    [aux_sym_integer_literal_token2] = ACTIONS(10910),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10910),
    [aux_sym_float_literal_token3] = ACTIONS(10910),
    [aux_sym_float_literal_token4] = ACTIONS(10910),
    [sym_character_literal] = ACTIONS(10910),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10910),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10910),
    [sym__pair_operator] = ACTIONS(10910),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10910),
    [sym__lazy_and_operator] = ACTIONS(10910),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10910),
    [sym__pipe_left_operator] = ACTIONS(10910),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10910),
    [sym__bitshift_operator] = ACTIONS(10910),
    [sym__power_operator] = ACTIONS(10910),
    [sym__tilde_operator] = ACTIONS(10910),
    [sym__type_order_operator] = ACTIONS(10910),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9011] = {
    [sym_block_comment] = STATE(9011),
    [sym_line_comment] = STATE(9011),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12642),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12644),
    [sym__arrow_operator] = ACTIONS(12646),
    [sym__lazy_or_operator] = ACTIONS(12648),
    [sym__lazy_and_operator] = ACTIONS(12650),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9012] = {
    [sym_block_comment] = STATE(9012),
    [sym_line_comment] = STATE(9012),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10186),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9013] = {
    [sym_block_comment] = STATE(9013),
    [sym_line_comment] = STATE(9013),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
  },
  [9014] = {
    [sym_block_comment] = STATE(9014),
    [sym_line_comment] = STATE(9014),
    [aux_sym_export_statement_repeat1] = STATE(9069),
    [sym__word_identifier] = ACTIONS(10813),
    [anon_sym_COMMA] = ACTIONS(12589),
    [anon_sym_EQ] = ACTIONS(10813),
    [anon_sym_begin] = ACTIONS(10813),
    [anon_sym_module] = ACTIONS(10813),
    [anon_sym_baremodule] = ACTIONS(10813),
    [anon_sym_end] = ACTIONS(10813),
    [anon_sym_abstract] = ACTIONS(10813),
    [anon_sym_primitive] = ACTIONS(10813),
    [anon_sym_mutable] = ACTIONS(10813),
    [anon_sym_struct] = ACTIONS(10813),
    [anon_sym_function] = ACTIONS(10813),
    [anon_sym_macro] = ACTIONS(10813),
    [anon_sym_quote] = ACTIONS(10813),
    [anon_sym_let] = ACTIONS(10813),
    [anon_sym_if] = ACTIONS(10813),
    [anon_sym_try] = ACTIONS(10813),
    [anon_sym_for] = ACTIONS(10813),
    [anon_sym_while] = ACTIONS(10813),
    [sym_break_statement] = ACTIONS(10813),
    [sym_continue_statement] = ACTIONS(10813),
    [anon_sym_return] = ACTIONS(10813),
    [anon_sym_const] = ACTIONS(10813),
    [anon_sym_global] = ACTIONS(10813),
    [anon_sym_local] = ACTIONS(10813),
    [anon_sym_LPAREN] = ACTIONS(10815),
    [anon_sym_COLON] = ACTIONS(10813),
    [anon_sym_export] = ACTIONS(10813),
    [anon_sym_public] = ACTIONS(10813),
    [anon_sym_import] = ACTIONS(10813),
    [anon_sym_using] = ACTIONS(10813),
    [anon_sym_LBRACK] = ACTIONS(10815),
    [anon_sym_in] = ACTIONS(10813),
    [anon_sym_LBRACE] = ACTIONS(10815),
    [anon_sym_DOLLAR] = ACTIONS(10815),
    [anon_sym_COLON2] = ACTIONS(10813),
    [anon_sym_COLON_COLON] = ACTIONS(10815),
    [anon_sym_isa] = ACTIONS(10813),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10815),
    [anon_sym_QMARK] = ACTIONS(10815),
    [anon_sym_where] = ACTIONS(10813),
    [anon_sym_AT] = ACTIONS(10815),
    [anon_sym_true] = ACTIONS(10813),
    [anon_sym_false] = ACTIONS(10813),
    [aux_sym_integer_literal_token1] = ACTIONS(10815),
    [aux_sym_integer_literal_token2] = ACTIONS(10815),
    [aux_sym_integer_literal_token3] = ACTIONS(10813),
    [aux_sym_integer_literal_token4] = ACTIONS(10813),
    [aux_sym_float_literal_token1] = ACTIONS(10815),
    [aux_sym_float_literal_token3] = ACTIONS(10815),
    [aux_sym_float_literal_token4] = ACTIONS(10815),
    [sym_character_literal] = ACTIONS(10815),
    [anon_sym_DQUOTE] = ACTIONS(10813),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10815),
    [anon_sym_BQUOTE] = ACTIONS(10813),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10815),
    [sym__pair_operator] = ACTIONS(10815),
    [sym__arrow_operator] = ACTIONS(10813),
    [sym__lazy_or_operator] = ACTIONS(10815),
    [sym__lazy_and_operator] = ACTIONS(10815),
    [sym__comparison_operator] = ACTIONS(10813),
    [sym__pipe_right_operator] = ACTIONS(10815),
    [sym__pipe_left_operator] = ACTIONS(10815),
    [sym__ellipsis_operator] = ACTIONS(10813),
    [sym__plus_operator] = ACTIONS(10813),
    [sym__times_operator] = ACTIONS(10813),
    [sym__rational_operator] = ACTIONS(10815),
    [sym__bitshift_operator] = ACTIONS(10815),
    [sym__power_operator] = ACTIONS(10815),
    [sym__tilde_operator] = ACTIONS(10815),
    [sym__type_order_operator] = ACTIONS(10815),
    [sym__unary_operator] = ACTIONS(10813),
    [sym__unary_plus_operator] = ACTIONS(10813),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9015] = {
    [sym_block_comment] = STATE(9015),
    [sym_line_comment] = STATE(9015),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_COMMA] = ACTIONS(9754),
    [anon_sym_EQ] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9754),
    [anon_sym_COLON] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9754),
    [anon_sym_in] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9754),
    [anon_sym_DOT] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9754),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9754),
    [anon_sym_isa] = ACTIONS(9750),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9754),
    [anon_sym_QMARK] = ACTIONS(9754),
    [anon_sym_where] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9754),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9754),
    [aux_sym_integer_literal_token2] = ACTIONS(9754),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9754),
    [aux_sym_float_literal_token3] = ACTIONS(9754),
    [aux_sym_float_literal_token4] = ACTIONS(9754),
    [sym_character_literal] = ACTIONS(9754),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9754),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9754),
    [sym__pair_operator] = ACTIONS(9754),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__lazy_or_operator] = ACTIONS(9754),
    [sym__lazy_and_operator] = ACTIONS(9754),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9754),
    [sym__pipe_left_operator] = ACTIONS(9754),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9754),
    [sym__bitshift_operator] = ACTIONS(9754),
    [sym__power_operator] = ACTIONS(9754),
    [sym__tilde_operator] = ACTIONS(9754),
    [sym__type_order_operator] = ACTIONS(9754),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9016] = {
    [sym_block_comment] = STATE(9016),
    [sym_line_comment] = STATE(9016),
    [aux_sym__import_list_repeat1] = STATE(9097),
    [sym__word_identifier] = ACTIONS(10747),
    [anon_sym_COMMA] = ACTIONS(12421),
    [anon_sym_EQ] = ACTIONS(10747),
    [anon_sym_begin] = ACTIONS(10747),
    [anon_sym_module] = ACTIONS(10747),
    [anon_sym_baremodule] = ACTIONS(10747),
    [anon_sym_end] = ACTIONS(10747),
    [anon_sym_abstract] = ACTIONS(10747),
    [anon_sym_primitive] = ACTIONS(10747),
    [anon_sym_mutable] = ACTIONS(10747),
    [anon_sym_struct] = ACTIONS(10747),
    [anon_sym_function] = ACTIONS(10747),
    [anon_sym_macro] = ACTIONS(10747),
    [anon_sym_quote] = ACTIONS(10747),
    [anon_sym_let] = ACTIONS(10747),
    [anon_sym_if] = ACTIONS(10747),
    [anon_sym_try] = ACTIONS(10747),
    [anon_sym_for] = ACTIONS(10747),
    [anon_sym_while] = ACTIONS(10747),
    [sym_break_statement] = ACTIONS(10747),
    [sym_continue_statement] = ACTIONS(10747),
    [anon_sym_return] = ACTIONS(10747),
    [anon_sym_const] = ACTIONS(10747),
    [anon_sym_global] = ACTIONS(10747),
    [anon_sym_local] = ACTIONS(10747),
    [anon_sym_LPAREN] = ACTIONS(10755),
    [anon_sym_COLON] = ACTIONS(10747),
    [anon_sym_export] = ACTIONS(10747),
    [anon_sym_public] = ACTIONS(10747),
    [anon_sym_import] = ACTIONS(10747),
    [anon_sym_using] = ACTIONS(10747),
    [anon_sym_LBRACK] = ACTIONS(10755),
    [anon_sym_in] = ACTIONS(10747),
    [anon_sym_LBRACE] = ACTIONS(10755),
    [anon_sym_DOLLAR] = ACTIONS(10755),
    [anon_sym_COLON2] = ACTIONS(10747),
    [anon_sym_COLON_COLON] = ACTIONS(10755),
    [anon_sym_isa] = ACTIONS(10747),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10755),
    [anon_sym_QMARK] = ACTIONS(10755),
    [anon_sym_where] = ACTIONS(10747),
    [anon_sym_AT] = ACTIONS(10755),
    [anon_sym_true] = ACTIONS(10747),
    [anon_sym_false] = ACTIONS(10747),
    [aux_sym_integer_literal_token1] = ACTIONS(10755),
    [aux_sym_integer_literal_token2] = ACTIONS(10755),
    [aux_sym_integer_literal_token3] = ACTIONS(10747),
    [aux_sym_integer_literal_token4] = ACTIONS(10747),
    [aux_sym_float_literal_token1] = ACTIONS(10755),
    [aux_sym_float_literal_token3] = ACTIONS(10755),
    [aux_sym_float_literal_token4] = ACTIONS(10755),
    [sym_character_literal] = ACTIONS(10755),
    [anon_sym_DQUOTE] = ACTIONS(10747),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10755),
    [anon_sym_BQUOTE] = ACTIONS(10747),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10755),
    [sym__pair_operator] = ACTIONS(10755),
    [sym__arrow_operator] = ACTIONS(10747),
    [sym__lazy_or_operator] = ACTIONS(10755),
    [sym__lazy_and_operator] = ACTIONS(10755),
    [sym__comparison_operator] = ACTIONS(10747),
    [sym__pipe_right_operator] = ACTIONS(10755),
    [sym__pipe_left_operator] = ACTIONS(10755),
    [sym__ellipsis_operator] = ACTIONS(10747),
    [sym__plus_operator] = ACTIONS(10747),
    [sym__times_operator] = ACTIONS(10747),
    [sym__rational_operator] = ACTIONS(10755),
    [sym__bitshift_operator] = ACTIONS(10755),
    [sym__power_operator] = ACTIONS(10755),
    [sym__tilde_operator] = ACTIONS(10755),
    [sym__type_order_operator] = ACTIONS(10755),
    [sym__unary_operator] = ACTIONS(10747),
    [sym__unary_plus_operator] = ACTIONS(10747),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9017] = {
    [sym_block_comment] = STATE(9017),
    [sym_line_comment] = STATE(9017),
    [sym__word_identifier] = ACTIONS(10757),
    [anon_sym_COMMA] = ACTIONS(10759),
    [anon_sym_EQ] = ACTIONS(10757),
    [anon_sym_begin] = ACTIONS(10757),
    [anon_sym_module] = ACTIONS(10757),
    [anon_sym_baremodule] = ACTIONS(10757),
    [anon_sym_end] = ACTIONS(10757),
    [anon_sym_abstract] = ACTIONS(10757),
    [anon_sym_primitive] = ACTIONS(10757),
    [anon_sym_mutable] = ACTIONS(10757),
    [anon_sym_struct] = ACTIONS(10757),
    [anon_sym_function] = ACTIONS(10757),
    [anon_sym_macro] = ACTIONS(10757),
    [anon_sym_quote] = ACTIONS(10757),
    [anon_sym_let] = ACTIONS(10757),
    [anon_sym_if] = ACTIONS(10757),
    [anon_sym_try] = ACTIONS(10757),
    [anon_sym_for] = ACTIONS(10757),
    [anon_sym_while] = ACTIONS(10757),
    [sym_break_statement] = ACTIONS(10757),
    [sym_continue_statement] = ACTIONS(10757),
    [anon_sym_return] = ACTIONS(10757),
    [anon_sym_const] = ACTIONS(10757),
    [anon_sym_global] = ACTIONS(10757),
    [anon_sym_local] = ACTIONS(10757),
    [anon_sym_as] = ACTIONS(10757),
    [anon_sym_LPAREN] = ACTIONS(10759),
    [anon_sym_COLON] = ACTIONS(10757),
    [anon_sym_export] = ACTIONS(10757),
    [anon_sym_public] = ACTIONS(10757),
    [anon_sym_import] = ACTIONS(10757),
    [anon_sym_using] = ACTIONS(10757),
    [anon_sym_LBRACK] = ACTIONS(10759),
    [anon_sym_in] = ACTIONS(10757),
    [anon_sym_LBRACE] = ACTIONS(10759),
    [anon_sym_DOLLAR] = ACTIONS(10759),
    [anon_sym_COLON2] = ACTIONS(10757),
    [anon_sym_COLON_COLON] = ACTIONS(10759),
    [anon_sym_isa] = ACTIONS(10757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10759),
    [anon_sym_QMARK] = ACTIONS(10759),
    [anon_sym_where] = ACTIONS(10757),
    [anon_sym_AT] = ACTIONS(10759),
    [anon_sym_true] = ACTIONS(10757),
    [anon_sym_false] = ACTIONS(10757),
    [aux_sym_integer_literal_token1] = ACTIONS(10759),
    [aux_sym_integer_literal_token2] = ACTIONS(10759),
    [aux_sym_integer_literal_token3] = ACTIONS(10757),
    [aux_sym_integer_literal_token4] = ACTIONS(10757),
    [aux_sym_float_literal_token1] = ACTIONS(10759),
    [aux_sym_float_literal_token3] = ACTIONS(10759),
    [aux_sym_float_literal_token4] = ACTIONS(10759),
    [sym_character_literal] = ACTIONS(10759),
    [anon_sym_DQUOTE] = ACTIONS(10757),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10759),
    [anon_sym_BQUOTE] = ACTIONS(10757),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10759),
    [sym__pair_operator] = ACTIONS(10759),
    [sym__arrow_operator] = ACTIONS(10757),
    [sym__lazy_or_operator] = ACTIONS(10759),
    [sym__lazy_and_operator] = ACTIONS(10759),
    [sym__comparison_operator] = ACTIONS(10757),
    [sym__pipe_right_operator] = ACTIONS(10759),
    [sym__pipe_left_operator] = ACTIONS(10759),
    [sym__ellipsis_operator] = ACTIONS(10757),
    [sym__plus_operator] = ACTIONS(10757),
    [sym__times_operator] = ACTIONS(10757),
    [sym__rational_operator] = ACTIONS(10759),
    [sym__bitshift_operator] = ACTIONS(10759),
    [sym__power_operator] = ACTIONS(10759),
    [sym__tilde_operator] = ACTIONS(10759),
    [sym__type_order_operator] = ACTIONS(10759),
    [sym__unary_operator] = ACTIONS(10757),
    [sym__unary_plus_operator] = ACTIONS(10757),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9018] = {
    [sym_block_comment] = STATE(9018),
    [sym_line_comment] = STATE(9018),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9762),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9762),
    [anon_sym_COLON] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9762),
    [anon_sym_in] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9762),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9762),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9762),
    [anon_sym_isa] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9762),
    [anon_sym_QMARK] = ACTIONS(9762),
    [anon_sym_where] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9762),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9762),
    [aux_sym_integer_literal_token2] = ACTIONS(9762),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9762),
    [aux_sym_float_literal_token3] = ACTIONS(9762),
    [aux_sym_float_literal_token4] = ACTIONS(9762),
    [sym_character_literal] = ACTIONS(9762),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9762),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9762),
    [sym__pair_operator] = ACTIONS(9762),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__lazy_or_operator] = ACTIONS(9762),
    [sym__lazy_and_operator] = ACTIONS(9762),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9762),
    [sym__pipe_left_operator] = ACTIONS(9762),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9762),
    [sym__bitshift_operator] = ACTIONS(9762),
    [sym__power_operator] = ACTIONS(9762),
    [sym__tilde_operator] = ACTIONS(9762),
    [sym__type_order_operator] = ACTIONS(9762),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9019] = {
    [sym_block_comment] = STATE(9019),
    [sym_line_comment] = STATE(9019),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_COMMA] = ACTIONS(10030),
    [anon_sym_EQ] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10030),
    [anon_sym_COLON] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10030),
    [anon_sym_in] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10030),
    [anon_sym_DOT] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10030),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10030),
    [anon_sym_isa] = ACTIONS(10028),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10030),
    [anon_sym_QMARK] = ACTIONS(10030),
    [anon_sym_where] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10030),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10030),
    [aux_sym_integer_literal_token2] = ACTIONS(10030),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10030),
    [aux_sym_float_literal_token3] = ACTIONS(10030),
    [aux_sym_float_literal_token4] = ACTIONS(10030),
    [sym_character_literal] = ACTIONS(10030),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10030),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10030),
    [sym__pair_operator] = ACTIONS(10030),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__lazy_or_operator] = ACTIONS(10030),
    [sym__lazy_and_operator] = ACTIONS(10030),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10030),
    [sym__pipe_left_operator] = ACTIONS(10030),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10030),
    [sym__bitshift_operator] = ACTIONS(10030),
    [sym__power_operator] = ACTIONS(10030),
    [sym__tilde_operator] = ACTIONS(10030),
    [sym__type_order_operator] = ACTIONS(10030),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9020] = {
    [sym_block_comment] = STATE(9020),
    [sym_line_comment] = STATE(9020),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_COMMA] = ACTIONS(10034),
    [anon_sym_EQ] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10034),
    [anon_sym_COLON] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10034),
    [anon_sym_in] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10034),
    [anon_sym_DOT] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10034),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10034),
    [anon_sym_isa] = ACTIONS(10032),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10034),
    [anon_sym_QMARK] = ACTIONS(10034),
    [anon_sym_where] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10034),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10034),
    [aux_sym_integer_literal_token2] = ACTIONS(10034),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10034),
    [aux_sym_float_literal_token3] = ACTIONS(10034),
    [aux_sym_float_literal_token4] = ACTIONS(10034),
    [sym_character_literal] = ACTIONS(10034),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10034),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10034),
    [sym__pair_operator] = ACTIONS(10034),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__lazy_or_operator] = ACTIONS(10034),
    [sym__lazy_and_operator] = ACTIONS(10034),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10034),
    [sym__pipe_left_operator] = ACTIONS(10034),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10034),
    [sym__bitshift_operator] = ACTIONS(10034),
    [sym__power_operator] = ACTIONS(10034),
    [sym__tilde_operator] = ACTIONS(10034),
    [sym__type_order_operator] = ACTIONS(10034),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9021] = {
    [sym_block_comment] = STATE(9021),
    [sym_line_comment] = STATE(9021),
    [sym__word_identifier] = ACTIONS(12668),
    [anon_sym_COMMA] = ACTIONS(12668),
    [anon_sym_begin] = ACTIONS(12668),
    [anon_sym_module] = ACTIONS(12668),
    [anon_sym_baremodule] = ACTIONS(12668),
    [anon_sym_end] = ACTIONS(12668),
    [anon_sym_abstract] = ACTIONS(12668),
    [anon_sym_primitive] = ACTIONS(12668),
    [anon_sym_mutable] = ACTIONS(12668),
    [anon_sym_struct] = ACTIONS(12668),
    [anon_sym_function] = ACTIONS(12668),
    [anon_sym_macro] = ACTIONS(12668),
    [anon_sym_quote] = ACTIONS(12668),
    [anon_sym_let] = ACTIONS(12668),
    [anon_sym_if] = ACTIONS(12668),
    [anon_sym_try] = ACTIONS(12668),
    [anon_sym_for] = ACTIONS(12668),
    [anon_sym_while] = ACTIONS(12668),
    [sym_break_statement] = ACTIONS(12668),
    [sym_continue_statement] = ACTIONS(12668),
    [anon_sym_return] = ACTIONS(12668),
    [anon_sym_const] = ACTIONS(12668),
    [anon_sym_global] = ACTIONS(12668),
    [anon_sym_local] = ACTIONS(12668),
    [anon_sym_LPAREN] = ACTIONS(12668),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(12668),
    [anon_sym_public] = ACTIONS(12668),
    [anon_sym_import] = ACTIONS(12668),
    [anon_sym_using] = ACTIONS(12668),
    [anon_sym_LBRACK] = ACTIONS(12668),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(12668),
    [anon_sym_DOLLAR] = ACTIONS(12668),
    [anon_sym_COLON2] = ACTIONS(12668),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12642),
    [anon_sym_AT] = ACTIONS(12668),
    [anon_sym_true] = ACTIONS(12668),
    [anon_sym_false] = ACTIONS(12668),
    [aux_sym_integer_literal_token1] = ACTIONS(12668),
    [aux_sym_integer_literal_token2] = ACTIONS(12668),
    [aux_sym_integer_literal_token3] = ACTIONS(12668),
    [aux_sym_integer_literal_token4] = ACTIONS(12668),
    [aux_sym_float_literal_token1] = ACTIONS(12668),
    [aux_sym_float_literal_token3] = ACTIONS(12668),
    [aux_sym_float_literal_token4] = ACTIONS(12668),
    [sym_character_literal] = ACTIONS(12668),
    [anon_sym_DQUOTE] = ACTIONS(12668),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12668),
    [anon_sym_BQUOTE] = ACTIONS(12668),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12668),
    [sym__pair_operator] = ACTIONS(12644),
    [sym__arrow_operator] = ACTIONS(12646),
    [sym__lazy_or_operator] = ACTIONS(12648),
    [sym__lazy_and_operator] = ACTIONS(12650),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(12668),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(12668),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(12670),
    [aux_sym__terminator_token2] = ACTIONS(12668),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9022] = {
    [sym_block_comment] = STATE(9022),
    [sym_line_comment] = STATE(9022),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11114),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11114),
    [anon_sym_RPAREN] = ACTIONS(11114),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11114),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11114),
    [anon_sym_LBRACE] = ACTIONS(11114),
    [anon_sym_DOLLAR] = ACTIONS(11114),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11114),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11114),
    [aux_sym_integer_literal_token2] = ACTIONS(11114),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11114),
    [aux_sym_float_literal_token3] = ACTIONS(11114),
    [aux_sym_float_literal_token4] = ACTIONS(11114),
    [sym_character_literal] = ACTIONS(11114),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11114),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11114),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11114),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9023] = {
    [sym_block_comment] = STATE(9023),
    [sym_line_comment] = STATE(9023),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11277),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11277),
    [anon_sym_RPAREN] = ACTIONS(11277),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11277),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(11277),
    [anon_sym_LBRACE] = ACTIONS(11277),
    [anon_sym_DOLLAR] = ACTIONS(11277),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11277),
    [anon_sym_QMARK] = ACTIONS(11277),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11277),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11277),
    [aux_sym_integer_literal_token2] = ACTIONS(11277),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11277),
    [aux_sym_float_literal_token3] = ACTIONS(11277),
    [aux_sym_float_literal_token4] = ACTIONS(11277),
    [sym_character_literal] = ACTIONS(11277),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11277),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11277),
    [sym__pair_operator] = ACTIONS(11277),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11277),
    [sym__lazy_and_operator] = ACTIONS(11277),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11277),
    [sym__pipe_left_operator] = ACTIONS(11277),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11277),
    [sym__type_order_operator] = ACTIONS(11277),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9024] = {
    [sym_block_comment] = STATE(9024),
    [sym_line_comment] = STATE(9024),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10160),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9025] = {
    [sym_block_comment] = STATE(9025),
    [sym_line_comment] = STATE(9025),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9026] = {
    [sym_block_comment] = STATE(9026),
    [sym_line_comment] = STATE(9026),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(12630),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_RPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_SEMI] = ACTIONS(11022),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9027] = {
    [sym_block_comment] = STATE(9027),
    [sym_line_comment] = STATE(9027),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_COMMA] = ACTIONS(10038),
    [anon_sym_EQ] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10038),
    [anon_sym_COLON] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10038),
    [anon_sym_in] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10038),
    [anon_sym_DOT] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10038),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10038),
    [anon_sym_isa] = ACTIONS(10036),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10038),
    [anon_sym_QMARK] = ACTIONS(10038),
    [anon_sym_where] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10038),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10038),
    [aux_sym_integer_literal_token2] = ACTIONS(10038),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10038),
    [aux_sym_float_literal_token3] = ACTIONS(10038),
    [aux_sym_float_literal_token4] = ACTIONS(10038),
    [sym_character_literal] = ACTIONS(10038),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10038),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10038),
    [sym__pair_operator] = ACTIONS(10038),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__lazy_or_operator] = ACTIONS(10038),
    [sym__lazy_and_operator] = ACTIONS(10038),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10038),
    [sym__pipe_left_operator] = ACTIONS(10038),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10038),
    [sym__bitshift_operator] = ACTIONS(10038),
    [sym__power_operator] = ACTIONS(10038),
    [sym__tilde_operator] = ACTIONS(10038),
    [sym__type_order_operator] = ACTIONS(10038),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9028] = {
    [sym_block_comment] = STATE(9028),
    [sym_line_comment] = STATE(9028),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_COMMA] = ACTIONS(9716),
    [anon_sym_EQ] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9716),
    [anon_sym_COLON] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9716),
    [anon_sym_in] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9716),
    [anon_sym_DOT] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9716),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9716),
    [anon_sym_isa] = ACTIONS(9714),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9716),
    [anon_sym_QMARK] = ACTIONS(9716),
    [anon_sym_where] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9716),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9716),
    [aux_sym_integer_literal_token2] = ACTIONS(9716),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9716),
    [aux_sym_float_literal_token3] = ACTIONS(9716),
    [aux_sym_float_literal_token4] = ACTIONS(9716),
    [sym_character_literal] = ACTIONS(9716),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9716),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9716),
    [sym__pair_operator] = ACTIONS(9716),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__lazy_or_operator] = ACTIONS(9716),
    [sym__lazy_and_operator] = ACTIONS(9716),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9716),
    [sym__pipe_left_operator] = ACTIONS(9716),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9716),
    [sym__bitshift_operator] = ACTIONS(9716),
    [sym__power_operator] = ACTIONS(9716),
    [sym__tilde_operator] = ACTIONS(9716),
    [sym__type_order_operator] = ACTIONS(9716),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9029] = {
    [sym_block_comment] = STATE(9029),
    [sym_line_comment] = STATE(9029),
    [sym__word_identifier] = ACTIONS(10214),
    [anon_sym_begin] = ACTIONS(10214),
    [anon_sym_module] = ACTIONS(10214),
    [anon_sym_baremodule] = ACTIONS(10214),
    [anon_sym_end] = ACTIONS(10214),
    [anon_sym_abstract] = ACTIONS(10214),
    [anon_sym_primitive] = ACTIONS(10214),
    [anon_sym_mutable] = ACTIONS(10214),
    [anon_sym_struct] = ACTIONS(10214),
    [anon_sym_function] = ACTIONS(10214),
    [anon_sym_macro] = ACTIONS(10214),
    [anon_sym_quote] = ACTIONS(10214),
    [anon_sym_let] = ACTIONS(10214),
    [anon_sym_if] = ACTIONS(10214),
    [anon_sym_try] = ACTIONS(10214),
    [anon_sym_for] = ACTIONS(10214),
    [anon_sym_while] = ACTIONS(10214),
    [sym_break_statement] = ACTIONS(10214),
    [sym_continue_statement] = ACTIONS(10214),
    [anon_sym_return] = ACTIONS(10214),
    [anon_sym_const] = ACTIONS(10214),
    [anon_sym_global] = ACTIONS(10214),
    [anon_sym_local] = ACTIONS(10214),
    [anon_sym_LPAREN] = ACTIONS(10214),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(10214),
    [anon_sym_public] = ACTIONS(10214),
    [anon_sym_import] = ACTIONS(10214),
    [anon_sym_using] = ACTIONS(10214),
    [anon_sym_LBRACK] = ACTIONS(10214),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10214),
    [anon_sym_DOLLAR] = ACTIONS(10214),
    [anon_sym_COLON2] = ACTIONS(10214),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_DASH_GT] = ACTIONS(10198),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10214),
    [anon_sym_true] = ACTIONS(10214),
    [anon_sym_false] = ACTIONS(10214),
    [aux_sym_integer_literal_token1] = ACTIONS(10214),
    [aux_sym_integer_literal_token2] = ACTIONS(10214),
    [aux_sym_integer_literal_token3] = ACTIONS(10214),
    [aux_sym_integer_literal_token4] = ACTIONS(10214),
    [aux_sym_float_literal_token1] = ACTIONS(10214),
    [aux_sym_float_literal_token3] = ACTIONS(10214),
    [aux_sym_float_literal_token4] = ACTIONS(10214),
    [sym_character_literal] = ACTIONS(10214),
    [anon_sym_DQUOTE] = ACTIONS(10214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10214),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(10214),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(10214),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(10216),
    [aux_sym__terminator_token2] = ACTIONS(10214),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9030] = {
    [sym_block_comment] = STATE(9030),
    [sym_line_comment] = STATE(9030),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12642),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12644),
    [sym__arrow_operator] = ACTIONS(12646),
    [sym__lazy_or_operator] = ACTIONS(12648),
    [sym__lazy_and_operator] = ACTIONS(12650),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9031] = {
    [sym_block_comment] = STATE(9031),
    [sym_line_comment] = STATE(9031),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10296),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9032] = {
    [sym_block_comment] = STATE(9032),
    [sym_line_comment] = STATE(9032),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9033] = {
    [sym_block_comment] = STATE(9033),
    [sym_line_comment] = STATE(9033),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9034] = {
    [sym_block_comment] = STATE(9034),
    [sym_line_comment] = STATE(9034),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_COMMA] = ACTIONS(10042),
    [anon_sym_EQ] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10042),
    [anon_sym_COLON] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10042),
    [anon_sym_in] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10042),
    [anon_sym_DOT] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10042),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10042),
    [anon_sym_isa] = ACTIONS(10040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10042),
    [anon_sym_QMARK] = ACTIONS(10042),
    [anon_sym_where] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10042),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10042),
    [aux_sym_integer_literal_token2] = ACTIONS(10042),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10042),
    [aux_sym_float_literal_token3] = ACTIONS(10042),
    [aux_sym_float_literal_token4] = ACTIONS(10042),
    [sym_character_literal] = ACTIONS(10042),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10042),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10042),
    [sym__pair_operator] = ACTIONS(10042),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__lazy_or_operator] = ACTIONS(10042),
    [sym__lazy_and_operator] = ACTIONS(10042),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10042),
    [sym__pipe_left_operator] = ACTIONS(10042),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10042),
    [sym__bitshift_operator] = ACTIONS(10042),
    [sym__power_operator] = ACTIONS(10042),
    [sym__tilde_operator] = ACTIONS(10042),
    [sym__type_order_operator] = ACTIONS(10042),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9035] = {
    [sym__primary_expression] = STATE(11422),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11097),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(9035),
    [sym_line_comment] = STATE(9035),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_DOLLAR] = ACTIONS(10375),
    [anon_sym_COLON2] = ACTIONS(10377),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(1825),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9036] = {
    [sym_block_comment] = STATE(9036),
    [sym_line_comment] = STATE(9036),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_COMMA] = ACTIONS(9734),
    [anon_sym_EQ] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9734),
    [anon_sym_COLON] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9734),
    [anon_sym_in] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9734),
    [anon_sym_DOT] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9734),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9734),
    [anon_sym_isa] = ACTIONS(9730),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9734),
    [anon_sym_QMARK] = ACTIONS(9734),
    [anon_sym_where] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9734),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9734),
    [aux_sym_integer_literal_token2] = ACTIONS(9734),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9734),
    [aux_sym_float_literal_token3] = ACTIONS(9734),
    [aux_sym_float_literal_token4] = ACTIONS(9734),
    [sym_character_literal] = ACTIONS(9734),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9734),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9734),
    [sym__pair_operator] = ACTIONS(9734),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__lazy_or_operator] = ACTIONS(9734),
    [sym__lazy_and_operator] = ACTIONS(9734),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9734),
    [sym__pipe_left_operator] = ACTIONS(9734),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9734),
    [sym__bitshift_operator] = ACTIONS(9734),
    [sym__power_operator] = ACTIONS(9734),
    [sym__tilde_operator] = ACTIONS(9734),
    [sym__type_order_operator] = ACTIONS(9734),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9037] = {
    [sym_block_comment] = STATE(9037),
    [sym_line_comment] = STATE(9037),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12223),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12225),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12225),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12231),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12233),
    [sym__arrow_operator] = ACTIONS(12235),
    [sym__lazy_or_operator] = ACTIONS(12237),
    [sym__lazy_and_operator] = ACTIONS(12239),
    [sym__comparison_operator] = ACTIONS(12225),
    [sym__pipe_right_operator] = ACTIONS(12241),
    [sym__pipe_left_operator] = ACTIONS(12243),
    [sym__ellipsis_operator] = ACTIONS(12245),
    [sym__plus_operator] = ACTIONS(12247),
    [sym__times_operator] = ACTIONS(12249),
    [sym__rational_operator] = ACTIONS(12251),
    [sym__bitshift_operator] = ACTIONS(12253),
    [sym__power_operator] = ACTIONS(12255),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12225),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12247),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9038] = {
    [sym_block_comment] = STATE(9038),
    [sym_line_comment] = STATE(9038),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_COMMA] = ACTIONS(9740),
    [anon_sym_EQ] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9740),
    [anon_sym_COLON] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9740),
    [anon_sym_in] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9740),
    [anon_sym_DOT] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9740),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9740),
    [anon_sym_isa] = ACTIONS(9736),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9740),
    [anon_sym_QMARK] = ACTIONS(9740),
    [anon_sym_where] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9740),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9740),
    [aux_sym_integer_literal_token2] = ACTIONS(9740),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9740),
    [aux_sym_float_literal_token3] = ACTIONS(9740),
    [aux_sym_float_literal_token4] = ACTIONS(9740),
    [sym_character_literal] = ACTIONS(9740),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9740),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9740),
    [sym__pair_operator] = ACTIONS(9740),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__lazy_or_operator] = ACTIONS(9740),
    [sym__lazy_and_operator] = ACTIONS(9740),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9740),
    [sym__pipe_left_operator] = ACTIONS(9740),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9740),
    [sym__bitshift_operator] = ACTIONS(9740),
    [sym__power_operator] = ACTIONS(9740),
    [sym__tilde_operator] = ACTIONS(9740),
    [sym__type_order_operator] = ACTIONS(9740),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9039] = {
    [sym_block_comment] = STATE(9039),
    [sym_line_comment] = STATE(9039),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12680),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9040] = {
    [sym_block_comment] = STATE(9040),
    [sym_line_comment] = STATE(9040),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9041] = {
    [sym_block_comment] = STATE(9041),
    [sym_line_comment] = STATE(9041),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9042] = {
    [sym_block_comment] = STATE(9042),
    [sym_line_comment] = STATE(9042),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12642),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12646),
    [sym__lazy_or_operator] = ACTIONS(12648),
    [sym__lazy_and_operator] = ACTIONS(12650),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9043] = {
    [sym_block_comment] = STATE(9043),
    [sym_line_comment] = STATE(9043),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12642),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12650),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9044] = {
    [sym_block_comment] = STATE(9044),
    [sym_line_comment] = STATE(9044),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12642),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9045] = {
    [sym_block_comment] = STATE(9045),
    [sym_line_comment] = STATE(9045),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9046] = {
    [sym_block_comment] = STATE(9046),
    [sym_line_comment] = STATE(9046),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9047] = {
    [sym_block_comment] = STATE(9047),
    [sym_line_comment] = STATE(9047),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9048] = {
    [sym_block_comment] = STATE(9048),
    [sym_line_comment] = STATE(9048),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9049] = {
    [sym_block_comment] = STATE(9049),
    [sym_line_comment] = STATE(9049),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9050] = {
    [sym_block_comment] = STATE(9050),
    [sym_line_comment] = STATE(9050),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9051] = {
    [sym_block_comment] = STATE(9051),
    [sym_line_comment] = STATE(9051),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9052] = {
    [sym_block_comment] = STATE(9052),
    [sym_line_comment] = STATE(9052),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9053] = {
    [sym_block_comment] = STATE(9053),
    [sym_line_comment] = STATE(9053),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_COMMA] = ACTIONS(10136),
    [anon_sym_EQ] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10136),
    [anon_sym_COLON] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10136),
    [anon_sym_in] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10136),
    [anon_sym_DOT] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10136),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10136),
    [anon_sym_isa] = ACTIONS(10134),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10136),
    [anon_sym_QMARK] = ACTIONS(10136),
    [anon_sym_where] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10136),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10136),
    [aux_sym_integer_literal_token2] = ACTIONS(10136),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10136),
    [aux_sym_float_literal_token3] = ACTIONS(10136),
    [aux_sym_float_literal_token4] = ACTIONS(10136),
    [sym_character_literal] = ACTIONS(10136),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10136),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10136),
    [sym__pair_operator] = ACTIONS(10136),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__lazy_or_operator] = ACTIONS(10136),
    [sym__lazy_and_operator] = ACTIONS(10136),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10136),
    [sym__pipe_left_operator] = ACTIONS(10136),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10136),
    [sym__bitshift_operator] = ACTIONS(10136),
    [sym__power_operator] = ACTIONS(10136),
    [sym__tilde_operator] = ACTIONS(10136),
    [sym__type_order_operator] = ACTIONS(10136),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9054] = {
    [sym_block_comment] = STATE(9054),
    [sym_line_comment] = STATE(9054),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9055] = {
    [sym_block_comment] = STATE(9055),
    [sym_line_comment] = STATE(9055),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10292),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9056] = {
    [sym_block_comment] = STATE(9056),
    [sym_line_comment] = STATE(9056),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9057] = {
    [sym_block_comment] = STATE(9057),
    [sym_line_comment] = STATE(9057),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_COMMA] = ACTIONS(9746),
    [anon_sym_EQ] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9746),
    [anon_sym_COLON] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9746),
    [anon_sym_in] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9746),
    [anon_sym_DOT] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9746),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9746),
    [anon_sym_isa] = ACTIONS(9742),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9746),
    [anon_sym_QMARK] = ACTIONS(9746),
    [anon_sym_where] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9746),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9746),
    [aux_sym_integer_literal_token2] = ACTIONS(9746),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9746),
    [aux_sym_float_literal_token3] = ACTIONS(9746),
    [aux_sym_float_literal_token4] = ACTIONS(9746),
    [sym_character_literal] = ACTIONS(9746),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9746),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9746),
    [sym__pair_operator] = ACTIONS(9746),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__lazy_or_operator] = ACTIONS(9746),
    [sym__lazy_and_operator] = ACTIONS(9746),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9746),
    [sym__pipe_left_operator] = ACTIONS(9746),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9746),
    [sym__bitshift_operator] = ACTIONS(9746),
    [sym__power_operator] = ACTIONS(9746),
    [sym__tilde_operator] = ACTIONS(9746),
    [sym__type_order_operator] = ACTIONS(9746),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9058] = {
    [sym_block_comment] = STATE(9058),
    [sym_line_comment] = STATE(9058),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10026),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9059] = {
    [sym_block_comment] = STATE(9059),
    [sym_line_comment] = STATE(9059),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9060] = {
    [sym_block_comment] = STATE(9060),
    [sym_line_comment] = STATE(9060),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9061] = {
    [sym_block_comment] = STATE(9061),
    [sym_line_comment] = STATE(9061),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9062] = {
    [sym_block_comment] = STATE(9062),
    [sym_line_comment] = STATE(9062),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11114),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11114),
    [anon_sym_RPAREN] = ACTIONS(11114),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11114),
    [anon_sym_RBRACK] = ACTIONS(11114),
    [anon_sym_in] = ACTIONS(12614),
    [anon_sym_LBRACE] = ACTIONS(11114),
    [anon_sym_RBRACE] = ACTIONS(11114),
    [anon_sym_DOLLAR] = ACTIONS(11114),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12616),
    [anon_sym_AT] = ACTIONS(11114),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11114),
    [aux_sym_integer_literal_token2] = ACTIONS(11114),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11114),
    [aux_sym_float_literal_token3] = ACTIONS(11114),
    [aux_sym_float_literal_token4] = ACTIONS(11114),
    [sym_character_literal] = ACTIONS(11114),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11114),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11114),
    [sym__pair_operator] = ACTIONS(12618),
    [sym__arrow_operator] = ACTIONS(12620),
    [sym__lazy_or_operator] = ACTIONS(12622),
    [sym__lazy_and_operator] = ACTIONS(12624),
    [sym__comparison_operator] = ACTIONS(12614),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11114),
    [sym__type_order_operator] = ACTIONS(12626),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9063] = {
    [sym_block_comment] = STATE(9063),
    [sym_line_comment] = STATE(9063),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9064] = {
    [sym_block_comment] = STATE(9064),
    [sym_line_comment] = STATE(9064),
    [aux_sym_export_statement_repeat1] = STATE(9006),
    [sym__word_identifier] = ACTIONS(10876),
    [anon_sym_COMMA] = ACTIONS(12589),
    [anon_sym_EQ] = ACTIONS(10876),
    [anon_sym_begin] = ACTIONS(10876),
    [anon_sym_module] = ACTIONS(10876),
    [anon_sym_baremodule] = ACTIONS(10876),
    [anon_sym_end] = ACTIONS(10876),
    [anon_sym_abstract] = ACTIONS(10876),
    [anon_sym_primitive] = ACTIONS(10876),
    [anon_sym_mutable] = ACTIONS(10876),
    [anon_sym_struct] = ACTIONS(10876),
    [anon_sym_function] = ACTIONS(10876),
    [anon_sym_macro] = ACTIONS(10876),
    [anon_sym_quote] = ACTIONS(10876),
    [anon_sym_let] = ACTIONS(10876),
    [anon_sym_if] = ACTIONS(10876),
    [anon_sym_try] = ACTIONS(10876),
    [anon_sym_for] = ACTIONS(10876),
    [anon_sym_while] = ACTIONS(10876),
    [sym_break_statement] = ACTIONS(10876),
    [sym_continue_statement] = ACTIONS(10876),
    [anon_sym_return] = ACTIONS(10876),
    [anon_sym_const] = ACTIONS(10876),
    [anon_sym_global] = ACTIONS(10876),
    [anon_sym_local] = ACTIONS(10876),
    [anon_sym_LPAREN] = ACTIONS(10878),
    [anon_sym_COLON] = ACTIONS(10876),
    [anon_sym_export] = ACTIONS(10876),
    [anon_sym_public] = ACTIONS(10876),
    [anon_sym_import] = ACTIONS(10876),
    [anon_sym_using] = ACTIONS(10876),
    [anon_sym_LBRACK] = ACTIONS(10878),
    [anon_sym_in] = ACTIONS(10876),
    [anon_sym_LBRACE] = ACTIONS(10878),
    [anon_sym_DOLLAR] = ACTIONS(10878),
    [anon_sym_COLON2] = ACTIONS(10876),
    [anon_sym_COLON_COLON] = ACTIONS(10878),
    [anon_sym_isa] = ACTIONS(10876),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10878),
    [anon_sym_QMARK] = ACTIONS(10878),
    [anon_sym_where] = ACTIONS(10876),
    [anon_sym_AT] = ACTIONS(10878),
    [anon_sym_true] = ACTIONS(10876),
    [anon_sym_false] = ACTIONS(10876),
    [aux_sym_integer_literal_token1] = ACTIONS(10878),
    [aux_sym_integer_literal_token2] = ACTIONS(10878),
    [aux_sym_integer_literal_token3] = ACTIONS(10876),
    [aux_sym_integer_literal_token4] = ACTIONS(10876),
    [aux_sym_float_literal_token1] = ACTIONS(10878),
    [aux_sym_float_literal_token3] = ACTIONS(10878),
    [aux_sym_float_literal_token4] = ACTIONS(10878),
    [sym_character_literal] = ACTIONS(10878),
    [anon_sym_DQUOTE] = ACTIONS(10876),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10878),
    [anon_sym_BQUOTE] = ACTIONS(10876),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10878),
    [sym__pair_operator] = ACTIONS(10878),
    [sym__arrow_operator] = ACTIONS(10876),
    [sym__lazy_or_operator] = ACTIONS(10878),
    [sym__lazy_and_operator] = ACTIONS(10878),
    [sym__comparison_operator] = ACTIONS(10876),
    [sym__pipe_right_operator] = ACTIONS(10878),
    [sym__pipe_left_operator] = ACTIONS(10878),
    [sym__ellipsis_operator] = ACTIONS(10876),
    [sym__plus_operator] = ACTIONS(10876),
    [sym__times_operator] = ACTIONS(10876),
    [sym__rational_operator] = ACTIONS(10878),
    [sym__bitshift_operator] = ACTIONS(10878),
    [sym__power_operator] = ACTIONS(10878),
    [sym__tilde_operator] = ACTIONS(10878),
    [sym__type_order_operator] = ACTIONS(10878),
    [sym__unary_operator] = ACTIONS(10876),
    [sym__unary_plus_operator] = ACTIONS(10876),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9065] = {
    [sym_block_comment] = STATE(9065),
    [sym_line_comment] = STATE(9065),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9066] = {
    [sym_block_comment] = STATE(9066),
    [sym_line_comment] = STATE(9066),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_RBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_RBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9067] = {
    [sym_block_comment] = STATE(9067),
    [sym_line_comment] = STATE(9067),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9068] = {
    [sym_block_comment] = STATE(9068),
    [sym_line_comment] = STATE(9068),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_SEMI] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9069] = {
    [sym_block_comment] = STATE(9069),
    [sym_line_comment] = STATE(9069),
    [aux_sym_export_statement_repeat1] = STATE(9006),
    [sym__word_identifier] = ACTIONS(10880),
    [anon_sym_COMMA] = ACTIONS(12589),
    [anon_sym_EQ] = ACTIONS(10880),
    [anon_sym_begin] = ACTIONS(10880),
    [anon_sym_module] = ACTIONS(10880),
    [anon_sym_baremodule] = ACTIONS(10880),
    [anon_sym_end] = ACTIONS(10880),
    [anon_sym_abstract] = ACTIONS(10880),
    [anon_sym_primitive] = ACTIONS(10880),
    [anon_sym_mutable] = ACTIONS(10880),
    [anon_sym_struct] = ACTIONS(10880),
    [anon_sym_function] = ACTIONS(10880),
    [anon_sym_macro] = ACTIONS(10880),
    [anon_sym_quote] = ACTIONS(10880),
    [anon_sym_let] = ACTIONS(10880),
    [anon_sym_if] = ACTIONS(10880),
    [anon_sym_try] = ACTIONS(10880),
    [anon_sym_for] = ACTIONS(10880),
    [anon_sym_while] = ACTIONS(10880),
    [sym_break_statement] = ACTIONS(10880),
    [sym_continue_statement] = ACTIONS(10880),
    [anon_sym_return] = ACTIONS(10880),
    [anon_sym_const] = ACTIONS(10880),
    [anon_sym_global] = ACTIONS(10880),
    [anon_sym_local] = ACTIONS(10880),
    [anon_sym_LPAREN] = ACTIONS(10882),
    [anon_sym_COLON] = ACTIONS(10880),
    [anon_sym_export] = ACTIONS(10880),
    [anon_sym_public] = ACTIONS(10880),
    [anon_sym_import] = ACTIONS(10880),
    [anon_sym_using] = ACTIONS(10880),
    [anon_sym_LBRACK] = ACTIONS(10882),
    [anon_sym_in] = ACTIONS(10880),
    [anon_sym_LBRACE] = ACTIONS(10882),
    [anon_sym_DOLLAR] = ACTIONS(10882),
    [anon_sym_COLON2] = ACTIONS(10880),
    [anon_sym_COLON_COLON] = ACTIONS(10882),
    [anon_sym_isa] = ACTIONS(10880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10882),
    [anon_sym_QMARK] = ACTIONS(10882),
    [anon_sym_where] = ACTIONS(10880),
    [anon_sym_AT] = ACTIONS(10882),
    [anon_sym_true] = ACTIONS(10880),
    [anon_sym_false] = ACTIONS(10880),
    [aux_sym_integer_literal_token1] = ACTIONS(10882),
    [aux_sym_integer_literal_token2] = ACTIONS(10882),
    [aux_sym_integer_literal_token3] = ACTIONS(10880),
    [aux_sym_integer_literal_token4] = ACTIONS(10880),
    [aux_sym_float_literal_token1] = ACTIONS(10882),
    [aux_sym_float_literal_token3] = ACTIONS(10882),
    [aux_sym_float_literal_token4] = ACTIONS(10882),
    [sym_character_literal] = ACTIONS(10882),
    [anon_sym_DQUOTE] = ACTIONS(10880),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10882),
    [anon_sym_BQUOTE] = ACTIONS(10880),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10882),
    [sym__pair_operator] = ACTIONS(10882),
    [sym__arrow_operator] = ACTIONS(10880),
    [sym__lazy_or_operator] = ACTIONS(10882),
    [sym__lazy_and_operator] = ACTIONS(10882),
    [sym__comparison_operator] = ACTIONS(10880),
    [sym__pipe_right_operator] = ACTIONS(10882),
    [sym__pipe_left_operator] = ACTIONS(10882),
    [sym__ellipsis_operator] = ACTIONS(10880),
    [sym__plus_operator] = ACTIONS(10880),
    [sym__times_operator] = ACTIONS(10880),
    [sym__rational_operator] = ACTIONS(10882),
    [sym__bitshift_operator] = ACTIONS(10882),
    [sym__power_operator] = ACTIONS(10882),
    [sym__tilde_operator] = ACTIONS(10882),
    [sym__type_order_operator] = ACTIONS(10882),
    [sym__unary_operator] = ACTIONS(10880),
    [sym__unary_plus_operator] = ACTIONS(10880),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9070] = {
    [sym_block_comment] = STATE(9070),
    [sym_line_comment] = STATE(9070),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9071] = {
    [sym_block_comment] = STATE(9071),
    [sym_line_comment] = STATE(9071),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_RPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11249),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9072] = {
    [sym_block_comment] = STATE(9072),
    [sym_line_comment] = STATE(9072),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9073] = {
    [sym_block_comment] = STATE(9073),
    [sym_line_comment] = STATE(9073),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9074] = {
    [sym_block_comment] = STATE(9074),
    [sym_line_comment] = STATE(9074),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9075] = {
    [sym_block_comment] = STATE(9075),
    [sym_line_comment] = STATE(9075),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9076] = {
    [sym_block_comment] = STATE(9076),
    [sym_line_comment] = STATE(9076),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9077] = {
    [sym_block_comment] = STATE(9077),
    [sym_line_comment] = STATE(9077),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9078] = {
    [sym_block_comment] = STATE(9078),
    [sym_line_comment] = STATE(9078),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9079] = {
    [sym_block_comment] = STATE(9079),
    [sym_line_comment] = STATE(9079),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_RBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9080] = {
    [sym_block_comment] = STATE(9080),
    [sym_line_comment] = STATE(9080),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9081] = {
    [sym_block_comment] = STATE(9081),
    [sym_line_comment] = STATE(9081),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9082] = {
    [sym_block_comment] = STATE(9082),
    [sym_line_comment] = STATE(9082),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9083] = {
    [sym_block_comment] = STATE(9083),
    [sym_line_comment] = STATE(9083),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9084] = {
    [sym_block_comment] = STATE(9084),
    [sym_line_comment] = STATE(9084),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9085] = {
    [sym_block_comment] = STATE(9085),
    [sym_line_comment] = STATE(9085),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9086] = {
    [sym_block_comment] = STATE(9086),
    [sym_line_comment] = STATE(9086),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9087] = {
    [sym_block_comment] = STATE(9087),
    [sym_line_comment] = STATE(9087),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9088] = {
    [sym_block_comment] = STATE(9088),
    [sym_line_comment] = STATE(9088),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9089] = {
    [sym_block_comment] = STATE(9089),
    [sym_line_comment] = STATE(9089),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9090] = {
    [sym_block_comment] = STATE(9090),
    [sym_line_comment] = STATE(9090),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9091] = {
    [sym_block_comment] = STATE(9091),
    [sym_line_comment] = STATE(9091),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9092] = {
    [sym_block_comment] = STATE(9092),
    [sym_line_comment] = STATE(9092),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9093] = {
    [sym_block_comment] = STATE(9093),
    [sym_line_comment] = STATE(9093),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9094] = {
    [sym_block_comment] = STATE(9094),
    [sym_line_comment] = STATE(9094),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9095] = {
    [sym_block_comment] = STATE(9095),
    [sym_line_comment] = STATE(9095),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9096] = {
    [sym_block_comment] = STATE(9096),
    [sym_line_comment] = STATE(9096),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_COMMA] = ACTIONS(9792),
    [anon_sym_EQ] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9792),
    [anon_sym_COLON] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9792),
    [anon_sym_in] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9792),
    [anon_sym_DOT] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9792),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9792),
    [anon_sym_isa] = ACTIONS(9788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9792),
    [anon_sym_QMARK] = ACTIONS(9792),
    [anon_sym_where] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9792),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9792),
    [aux_sym_integer_literal_token2] = ACTIONS(9792),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9792),
    [aux_sym_float_literal_token3] = ACTIONS(9792),
    [aux_sym_float_literal_token4] = ACTIONS(9792),
    [sym_character_literal] = ACTIONS(9792),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9792),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9792),
    [sym__pair_operator] = ACTIONS(9792),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__lazy_or_operator] = ACTIONS(9792),
    [sym__lazy_and_operator] = ACTIONS(9792),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9792),
    [sym__pipe_left_operator] = ACTIONS(9792),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9792),
    [sym__bitshift_operator] = ACTIONS(9792),
    [sym__power_operator] = ACTIONS(9792),
    [sym__tilde_operator] = ACTIONS(9792),
    [sym__type_order_operator] = ACTIONS(9792),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9097] = {
    [sym_block_comment] = STATE(9097),
    [sym_line_comment] = STATE(9097),
    [aux_sym__import_list_repeat1] = STATE(8959),
    [sym__word_identifier] = ACTIONS(10884),
    [anon_sym_COMMA] = ACTIONS(12421),
    [anon_sym_EQ] = ACTIONS(10884),
    [anon_sym_begin] = ACTIONS(10884),
    [anon_sym_module] = ACTIONS(10884),
    [anon_sym_baremodule] = ACTIONS(10884),
    [anon_sym_end] = ACTIONS(10884),
    [anon_sym_abstract] = ACTIONS(10884),
    [anon_sym_primitive] = ACTIONS(10884),
    [anon_sym_mutable] = ACTIONS(10884),
    [anon_sym_struct] = ACTIONS(10884),
    [anon_sym_function] = ACTIONS(10884),
    [anon_sym_macro] = ACTIONS(10884),
    [anon_sym_quote] = ACTIONS(10884),
    [anon_sym_let] = ACTIONS(10884),
    [anon_sym_if] = ACTIONS(10884),
    [anon_sym_try] = ACTIONS(10884),
    [anon_sym_for] = ACTIONS(10884),
    [anon_sym_while] = ACTIONS(10884),
    [sym_break_statement] = ACTIONS(10884),
    [sym_continue_statement] = ACTIONS(10884),
    [anon_sym_return] = ACTIONS(10884),
    [anon_sym_const] = ACTIONS(10884),
    [anon_sym_global] = ACTIONS(10884),
    [anon_sym_local] = ACTIONS(10884),
    [anon_sym_LPAREN] = ACTIONS(10886),
    [anon_sym_COLON] = ACTIONS(10884),
    [anon_sym_export] = ACTIONS(10884),
    [anon_sym_public] = ACTIONS(10884),
    [anon_sym_import] = ACTIONS(10884),
    [anon_sym_using] = ACTIONS(10884),
    [anon_sym_LBRACK] = ACTIONS(10886),
    [anon_sym_in] = ACTIONS(10884),
    [anon_sym_LBRACE] = ACTIONS(10886),
    [anon_sym_DOLLAR] = ACTIONS(10886),
    [anon_sym_COLON2] = ACTIONS(10884),
    [anon_sym_COLON_COLON] = ACTIONS(10886),
    [anon_sym_isa] = ACTIONS(10884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10886),
    [anon_sym_QMARK] = ACTIONS(10886),
    [anon_sym_where] = ACTIONS(10884),
    [anon_sym_AT] = ACTIONS(10886),
    [anon_sym_true] = ACTIONS(10884),
    [anon_sym_false] = ACTIONS(10884),
    [aux_sym_integer_literal_token1] = ACTIONS(10886),
    [aux_sym_integer_literal_token2] = ACTIONS(10886),
    [aux_sym_integer_literal_token3] = ACTIONS(10884),
    [aux_sym_integer_literal_token4] = ACTIONS(10884),
    [aux_sym_float_literal_token1] = ACTIONS(10886),
    [aux_sym_float_literal_token3] = ACTIONS(10886),
    [aux_sym_float_literal_token4] = ACTIONS(10886),
    [sym_character_literal] = ACTIONS(10886),
    [anon_sym_DQUOTE] = ACTIONS(10884),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10886),
    [anon_sym_BQUOTE] = ACTIONS(10884),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10886),
    [sym__pair_operator] = ACTIONS(10886),
    [sym__arrow_operator] = ACTIONS(10884),
    [sym__lazy_or_operator] = ACTIONS(10886),
    [sym__lazy_and_operator] = ACTIONS(10886),
    [sym__comparison_operator] = ACTIONS(10884),
    [sym__pipe_right_operator] = ACTIONS(10886),
    [sym__pipe_left_operator] = ACTIONS(10886),
    [sym__ellipsis_operator] = ACTIONS(10884),
    [sym__plus_operator] = ACTIONS(10884),
    [sym__times_operator] = ACTIONS(10884),
    [sym__rational_operator] = ACTIONS(10886),
    [sym__bitshift_operator] = ACTIONS(10886),
    [sym__power_operator] = ACTIONS(10886),
    [sym__tilde_operator] = ACTIONS(10886),
    [sym__type_order_operator] = ACTIONS(10886),
    [sym__unary_operator] = ACTIONS(10884),
    [sym__unary_plus_operator] = ACTIONS(10884),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9098] = {
    [sym_block_comment] = STATE(9098),
    [sym_line_comment] = STATE(9098),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10964),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9099] = {
    [sym_block_comment] = STATE(9099),
    [sym_line_comment] = STATE(9099),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_COMMA] = ACTIONS(10046),
    [anon_sym_EQ] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10046),
    [anon_sym_COLON] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10046),
    [anon_sym_in] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10046),
    [anon_sym_DOT] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10046),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10046),
    [anon_sym_isa] = ACTIONS(10044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10046),
    [anon_sym_QMARK] = ACTIONS(10046),
    [anon_sym_where] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10046),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10046),
    [aux_sym_integer_literal_token2] = ACTIONS(10046),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10046),
    [aux_sym_float_literal_token3] = ACTIONS(10046),
    [aux_sym_float_literal_token4] = ACTIONS(10046),
    [sym_character_literal] = ACTIONS(10046),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10046),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10046),
    [sym__pair_operator] = ACTIONS(10046),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__lazy_or_operator] = ACTIONS(10046),
    [sym__lazy_and_operator] = ACTIONS(10046),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10046),
    [sym__pipe_left_operator] = ACTIONS(10046),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10046),
    [sym__bitshift_operator] = ACTIONS(10046),
    [sym__power_operator] = ACTIONS(10046),
    [sym__tilde_operator] = ACTIONS(10046),
    [sym__type_order_operator] = ACTIONS(10046),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9100] = {
    [sym_block_comment] = STATE(9100),
    [sym_line_comment] = STATE(9100),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(12596),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_RBRACK] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(12614),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_RBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12614),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11866),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(12614),
    [sym__pipe_right_operator] = ACTIONS(12598),
    [sym__pipe_left_operator] = ACTIONS(12600),
    [sym__ellipsis_operator] = ACTIONS(12602),
    [sym__plus_operator] = ACTIONS(12604),
    [sym__times_operator] = ACTIONS(12606),
    [sym__rational_operator] = ACTIONS(12608),
    [sym__bitshift_operator] = ACTIONS(12610),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(12626),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12604),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9101] = {
    [sym_block_comment] = STATE(9101),
    [sym_line_comment] = STATE(9101),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10863),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_as] = ACTIONS(12423),
    [anon_sym_LPAREN] = ACTIONS(10863),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10863),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10863),
    [anon_sym_DOLLAR] = ACTIONS(10863),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10863),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10863),
    [anon_sym_QMARK] = ACTIONS(10863),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10863),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10863),
    [aux_sym_integer_literal_token2] = ACTIONS(10863),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10863),
    [aux_sym_float_literal_token3] = ACTIONS(10863),
    [aux_sym_float_literal_token4] = ACTIONS(10863),
    [sym_character_literal] = ACTIONS(10863),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10863),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10863),
    [sym__pair_operator] = ACTIONS(10863),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10863),
    [sym__lazy_and_operator] = ACTIONS(10863),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10863),
    [sym__pipe_left_operator] = ACTIONS(10863),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10863),
    [sym__bitshift_operator] = ACTIONS(10863),
    [sym__power_operator] = ACTIONS(10863),
    [sym__tilde_operator] = ACTIONS(10863),
    [sym__type_order_operator] = ACTIONS(10863),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9102] = {
    [sym_block_comment] = STATE(9102),
    [sym_line_comment] = STATE(9102),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_DOT] = ACTIONS(12742),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9103] = {
    [sym_block_comment] = STATE(9103),
    [sym_line_comment] = STATE(9103),
    [sym__word_identifier] = ACTIONS(9662),
    [anon_sym_COMMA] = ACTIONS(9664),
    [anon_sym_EQ] = ACTIONS(9662),
    [anon_sym_begin] = ACTIONS(9662),
    [anon_sym_module] = ACTIONS(9662),
    [anon_sym_baremodule] = ACTIONS(9662),
    [anon_sym_end] = ACTIONS(9662),
    [anon_sym_abstract] = ACTIONS(9662),
    [anon_sym_primitive] = ACTIONS(9662),
    [anon_sym_mutable] = ACTIONS(9662),
    [anon_sym_struct] = ACTIONS(9662),
    [anon_sym_function] = ACTIONS(9662),
    [anon_sym_macro] = ACTIONS(9662),
    [anon_sym_quote] = ACTIONS(9662),
    [anon_sym_let] = ACTIONS(9662),
    [anon_sym_if] = ACTIONS(9662),
    [anon_sym_try] = ACTIONS(9662),
    [anon_sym_for] = ACTIONS(9662),
    [anon_sym_while] = ACTIONS(9662),
    [sym_break_statement] = ACTIONS(9662),
    [sym_continue_statement] = ACTIONS(9662),
    [anon_sym_return] = ACTIONS(9662),
    [anon_sym_const] = ACTIONS(9662),
    [anon_sym_global] = ACTIONS(9662),
    [anon_sym_local] = ACTIONS(9662),
    [anon_sym_LPAREN] = ACTIONS(9664),
    [anon_sym_COLON] = ACTIONS(9662),
    [anon_sym_export] = ACTIONS(9662),
    [anon_sym_public] = ACTIONS(9662),
    [anon_sym_import] = ACTIONS(9662),
    [anon_sym_using] = ACTIONS(9662),
    [anon_sym_LBRACK] = ACTIONS(9664),
    [anon_sym_in] = ACTIONS(9662),
    [anon_sym_LBRACE] = ACTIONS(9664),
    [anon_sym_DOT] = ACTIONS(9662),
    [anon_sym_DOLLAR] = ACTIONS(9664),
    [anon_sym_COLON2] = ACTIONS(9662),
    [anon_sym_COLON_COLON] = ACTIONS(9664),
    [anon_sym_isa] = ACTIONS(9662),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9664),
    [anon_sym_QMARK] = ACTIONS(9664),
    [anon_sym_where] = ACTIONS(9662),
    [anon_sym_AT] = ACTIONS(9664),
    [anon_sym_true] = ACTIONS(9662),
    [anon_sym_false] = ACTIONS(9662),
    [aux_sym_integer_literal_token1] = ACTIONS(9664),
    [aux_sym_integer_literal_token2] = ACTIONS(9664),
    [aux_sym_integer_literal_token3] = ACTIONS(9662),
    [aux_sym_integer_literal_token4] = ACTIONS(9662),
    [aux_sym_float_literal_token1] = ACTIONS(9664),
    [aux_sym_float_literal_token3] = ACTIONS(9664),
    [aux_sym_float_literal_token4] = ACTIONS(9664),
    [sym_character_literal] = ACTIONS(9664),
    [anon_sym_DQUOTE] = ACTIONS(9662),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9664),
    [anon_sym_BQUOTE] = ACTIONS(9662),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9664),
    [sym__pair_operator] = ACTIONS(9664),
    [sym__arrow_operator] = ACTIONS(9662),
    [sym__lazy_or_operator] = ACTIONS(9664),
    [sym__lazy_and_operator] = ACTIONS(9664),
    [sym__comparison_operator] = ACTIONS(9662),
    [sym__pipe_right_operator] = ACTIONS(9664),
    [sym__pipe_left_operator] = ACTIONS(9664),
    [sym__ellipsis_operator] = ACTIONS(9662),
    [sym__plus_operator] = ACTIONS(9662),
    [sym__times_operator] = ACTIONS(9662),
    [sym__rational_operator] = ACTIONS(9664),
    [sym__bitshift_operator] = ACTIONS(9664),
    [sym__power_operator] = ACTIONS(9664),
    [sym__tilde_operator] = ACTIONS(9664),
    [sym__type_order_operator] = ACTIONS(9664),
    [sym__unary_operator] = ACTIONS(9662),
    [sym__unary_plus_operator] = ACTIONS(9662),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9104] = {
    [sym__primary_expression] = STATE(11417),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11070),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(9104),
    [sym_line_comment] = STATE(9104),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_finally] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_DOLLAR] = ACTIONS(10411),
    [anon_sym_COLON2] = ACTIONS(10413),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(1825),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9105] = {
    [sym_block_comment] = STATE(9105),
    [sym_line_comment] = STATE(9105),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_RPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_SEMI] = ACTIONS(10964),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9106] = {
    [sym_block_comment] = STATE(9106),
    [sym_line_comment] = STATE(9106),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9107] = {
    [sym_block_comment] = STATE(9107),
    [sym_line_comment] = STATE(9107),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9108] = {
    [sym_block_comment] = STATE(9108),
    [sym_line_comment] = STATE(9108),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_RPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_RBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_RBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9109] = {
    [sym_block_comment] = STATE(9109),
    [sym_line_comment] = STATE(9109),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_COMMA] = ACTIONS(10050),
    [anon_sym_EQ] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10050),
    [anon_sym_COLON] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10050),
    [anon_sym_in] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10050),
    [anon_sym_DOT] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10050),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10050),
    [anon_sym_isa] = ACTIONS(10048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10050),
    [anon_sym_QMARK] = ACTIONS(10050),
    [anon_sym_where] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10050),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10050),
    [aux_sym_integer_literal_token2] = ACTIONS(10050),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10050),
    [aux_sym_float_literal_token3] = ACTIONS(10050),
    [aux_sym_float_literal_token4] = ACTIONS(10050),
    [sym_character_literal] = ACTIONS(10050),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10050),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10050),
    [sym__pair_operator] = ACTIONS(10050),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__lazy_or_operator] = ACTIONS(10050),
    [sym__lazy_and_operator] = ACTIONS(10050),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10050),
    [sym__pipe_left_operator] = ACTIONS(10050),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10050),
    [sym__bitshift_operator] = ACTIONS(10050),
    [sym__power_operator] = ACTIONS(10050),
    [sym__tilde_operator] = ACTIONS(10050),
    [sym__type_order_operator] = ACTIONS(10050),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9110] = {
    [sym_block_comment] = STATE(9110),
    [sym_line_comment] = STATE(9110),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10186),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9111] = {
    [sym_block_comment] = STATE(9111),
    [sym_line_comment] = STATE(9111),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_COMMA] = ACTIONS(10054),
    [anon_sym_EQ] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10054),
    [anon_sym_COLON] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10054),
    [anon_sym_in] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10054),
    [anon_sym_DOT] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10054),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10054),
    [anon_sym_isa] = ACTIONS(10052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10054),
    [anon_sym_QMARK] = ACTIONS(10054),
    [anon_sym_where] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10054),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10054),
    [aux_sym_integer_literal_token2] = ACTIONS(10054),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10054),
    [aux_sym_float_literal_token3] = ACTIONS(10054),
    [aux_sym_float_literal_token4] = ACTIONS(10054),
    [sym_character_literal] = ACTIONS(10054),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10054),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10054),
    [sym__pair_operator] = ACTIONS(10054),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__lazy_or_operator] = ACTIONS(10054),
    [sym__lazy_and_operator] = ACTIONS(10054),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10054),
    [sym__pipe_left_operator] = ACTIONS(10054),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10054),
    [sym__bitshift_operator] = ACTIONS(10054),
    [sym__power_operator] = ACTIONS(10054),
    [sym__tilde_operator] = ACTIONS(10054),
    [sym__type_order_operator] = ACTIONS(10054),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9112] = {
    [sym_block_comment] = STATE(9112),
    [sym_line_comment] = STATE(9112),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_COMMA] = ACTIONS(10058),
    [anon_sym_EQ] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10058),
    [anon_sym_COLON] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10058),
    [anon_sym_in] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10058),
    [anon_sym_DOT] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10058),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10058),
    [anon_sym_isa] = ACTIONS(10056),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10058),
    [anon_sym_QMARK] = ACTIONS(10058),
    [anon_sym_where] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10058),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10058),
    [aux_sym_integer_literal_token2] = ACTIONS(10058),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10058),
    [aux_sym_float_literal_token3] = ACTIONS(10058),
    [aux_sym_float_literal_token4] = ACTIONS(10058),
    [sym_character_literal] = ACTIONS(10058),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10058),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10058),
    [sym__pair_operator] = ACTIONS(10058),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__lazy_or_operator] = ACTIONS(10058),
    [sym__lazy_and_operator] = ACTIONS(10058),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10058),
    [sym__pipe_left_operator] = ACTIONS(10058),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10058),
    [sym__bitshift_operator] = ACTIONS(10058),
    [sym__power_operator] = ACTIONS(10058),
    [sym__tilde_operator] = ACTIONS(10058),
    [sym__type_order_operator] = ACTIONS(10058),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9113] = {
    [sym_block_comment] = STATE(9113),
    [sym_line_comment] = STATE(9113),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_COMMA] = ACTIONS(9900),
    [anon_sym_EQ] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9900),
    [anon_sym_COLON] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9900),
    [anon_sym_in] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9900),
    [anon_sym_DOT] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9900),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9900),
    [anon_sym_isa] = ACTIONS(9898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9900),
    [anon_sym_QMARK] = ACTIONS(9900),
    [anon_sym_where] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9900),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9900),
    [aux_sym_integer_literal_token2] = ACTIONS(9900),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9900),
    [aux_sym_float_literal_token3] = ACTIONS(9900),
    [aux_sym_float_literal_token4] = ACTIONS(9900),
    [sym_character_literal] = ACTIONS(9900),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9900),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9900),
    [sym__pair_operator] = ACTIONS(9900),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__lazy_or_operator] = ACTIONS(9900),
    [sym__lazy_and_operator] = ACTIONS(9900),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9900),
    [sym__pipe_left_operator] = ACTIONS(9900),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9900),
    [sym__bitshift_operator] = ACTIONS(9900),
    [sym__power_operator] = ACTIONS(9900),
    [sym__tilde_operator] = ACTIONS(9900),
    [sym__type_order_operator] = ACTIONS(9900),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9114] = {
    [sym_block_comment] = STATE(9114),
    [sym_line_comment] = STATE(9114),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10230),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9115] = {
    [sym_block_comment] = STATE(9115),
    [sym_line_comment] = STATE(9115),
    [sym__word_identifier] = ACTIONS(10116),
    [anon_sym_COMMA] = ACTIONS(10118),
    [anon_sym_EQ] = ACTIONS(10116),
    [anon_sym_begin] = ACTIONS(10116),
    [anon_sym_module] = ACTIONS(10116),
    [anon_sym_baremodule] = ACTIONS(10116),
    [anon_sym_end] = ACTIONS(10116),
    [anon_sym_abstract] = ACTIONS(10116),
    [anon_sym_primitive] = ACTIONS(10116),
    [anon_sym_mutable] = ACTIONS(10116),
    [anon_sym_struct] = ACTIONS(10116),
    [anon_sym_function] = ACTIONS(10116),
    [anon_sym_macro] = ACTIONS(10116),
    [anon_sym_quote] = ACTIONS(10116),
    [anon_sym_let] = ACTIONS(10116),
    [anon_sym_if] = ACTIONS(10116),
    [anon_sym_try] = ACTIONS(10116),
    [anon_sym_for] = ACTIONS(10116),
    [anon_sym_while] = ACTIONS(10116),
    [sym_break_statement] = ACTIONS(10116),
    [sym_continue_statement] = ACTIONS(10116),
    [anon_sym_return] = ACTIONS(10116),
    [anon_sym_const] = ACTIONS(10116),
    [anon_sym_global] = ACTIONS(10116),
    [anon_sym_local] = ACTIONS(10116),
    [anon_sym_LPAREN] = ACTIONS(10118),
    [anon_sym_COLON] = ACTIONS(10116),
    [anon_sym_export] = ACTIONS(10116),
    [anon_sym_public] = ACTIONS(10116),
    [anon_sym_import] = ACTIONS(10116),
    [anon_sym_using] = ACTIONS(10116),
    [anon_sym_LBRACK] = ACTIONS(10118),
    [anon_sym_in] = ACTIONS(10116),
    [anon_sym_LBRACE] = ACTIONS(10118),
    [anon_sym_DOT] = ACTIONS(10116),
    [anon_sym_DOLLAR] = ACTIONS(10118),
    [anon_sym_COLON2] = ACTIONS(10116),
    [anon_sym_COLON_COLON] = ACTIONS(10118),
    [anon_sym_isa] = ACTIONS(10116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10118),
    [anon_sym_QMARK] = ACTIONS(10118),
    [anon_sym_where] = ACTIONS(10116),
    [anon_sym_AT] = ACTIONS(10118),
    [anon_sym_true] = ACTIONS(10116),
    [anon_sym_false] = ACTIONS(10116),
    [aux_sym_integer_literal_token1] = ACTIONS(10118),
    [aux_sym_integer_literal_token2] = ACTIONS(10118),
    [aux_sym_integer_literal_token3] = ACTIONS(10116),
    [aux_sym_integer_literal_token4] = ACTIONS(10116),
    [aux_sym_float_literal_token1] = ACTIONS(10118),
    [aux_sym_float_literal_token3] = ACTIONS(10118),
    [aux_sym_float_literal_token4] = ACTIONS(10118),
    [sym_character_literal] = ACTIONS(10118),
    [anon_sym_DQUOTE] = ACTIONS(10116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10118),
    [anon_sym_BQUOTE] = ACTIONS(10116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10118),
    [sym__pair_operator] = ACTIONS(10118),
    [sym__arrow_operator] = ACTIONS(10116),
    [sym__lazy_or_operator] = ACTIONS(10118),
    [sym__lazy_and_operator] = ACTIONS(10118),
    [sym__comparison_operator] = ACTIONS(10116),
    [sym__pipe_right_operator] = ACTIONS(10118),
    [sym__pipe_left_operator] = ACTIONS(10118),
    [sym__ellipsis_operator] = ACTIONS(10116),
    [sym__plus_operator] = ACTIONS(10116),
    [sym__times_operator] = ACTIONS(10116),
    [sym__rational_operator] = ACTIONS(10118),
    [sym__bitshift_operator] = ACTIONS(10118),
    [sym__power_operator] = ACTIONS(10118),
    [sym__tilde_operator] = ACTIONS(10118),
    [sym__type_order_operator] = ACTIONS(10118),
    [sym__unary_operator] = ACTIONS(10116),
    [sym__unary_plus_operator] = ACTIONS(10116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9116] = {
    [sym_block_comment] = STATE(9116),
    [sym_line_comment] = STATE(9116),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12561),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12565),
    [sym__arrow_operator] = ACTIONS(12567),
    [sym__lazy_or_operator] = ACTIONS(12569),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9117] = {
    [sym_block_comment] = STATE(9117),
    [sym_line_comment] = STATE(9117),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_RBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12680),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9118] = {
    [sym_block_comment] = STATE(9118),
    [sym_line_comment] = STATE(9118),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_RPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11289),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9119] = {
    [sym_block_comment] = STATE(9119),
    [sym_line_comment] = STATE(9119),
    [sym__word_identifier] = ACTIONS(9958),
    [anon_sym_COMMA] = ACTIONS(9960),
    [anon_sym_EQ] = ACTIONS(9958),
    [anon_sym_begin] = ACTIONS(9958),
    [anon_sym_module] = ACTIONS(9958),
    [anon_sym_baremodule] = ACTIONS(9958),
    [anon_sym_end] = ACTIONS(9958),
    [anon_sym_abstract] = ACTIONS(9958),
    [anon_sym_primitive] = ACTIONS(9958),
    [anon_sym_mutable] = ACTIONS(9958),
    [anon_sym_struct] = ACTIONS(9958),
    [anon_sym_function] = ACTIONS(9958),
    [anon_sym_macro] = ACTIONS(9958),
    [anon_sym_quote] = ACTIONS(9958),
    [anon_sym_let] = ACTIONS(9958),
    [anon_sym_if] = ACTIONS(9958),
    [anon_sym_try] = ACTIONS(9958),
    [anon_sym_for] = ACTIONS(9958),
    [anon_sym_while] = ACTIONS(9958),
    [sym_break_statement] = ACTIONS(9958),
    [sym_continue_statement] = ACTIONS(9958),
    [anon_sym_return] = ACTIONS(9958),
    [anon_sym_const] = ACTIONS(9958),
    [anon_sym_global] = ACTIONS(9958),
    [anon_sym_local] = ACTIONS(9958),
    [anon_sym_LPAREN] = ACTIONS(9960),
    [anon_sym_COLON] = ACTIONS(9958),
    [anon_sym_export] = ACTIONS(9958),
    [anon_sym_public] = ACTIONS(9958),
    [anon_sym_import] = ACTIONS(9958),
    [anon_sym_using] = ACTIONS(9958),
    [anon_sym_LBRACK] = ACTIONS(9960),
    [anon_sym_in] = ACTIONS(9958),
    [anon_sym_LBRACE] = ACTIONS(9960),
    [anon_sym_DOT] = ACTIONS(9958),
    [anon_sym_DOLLAR] = ACTIONS(9960),
    [anon_sym_COLON2] = ACTIONS(9958),
    [anon_sym_COLON_COLON] = ACTIONS(9960),
    [anon_sym_isa] = ACTIONS(9958),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9960),
    [anon_sym_QMARK] = ACTIONS(9960),
    [anon_sym_where] = ACTIONS(9958),
    [anon_sym_AT] = ACTIONS(9960),
    [anon_sym_true] = ACTIONS(9958),
    [anon_sym_false] = ACTIONS(9958),
    [aux_sym_integer_literal_token1] = ACTIONS(9960),
    [aux_sym_integer_literal_token2] = ACTIONS(9960),
    [aux_sym_integer_literal_token3] = ACTIONS(9958),
    [aux_sym_integer_literal_token4] = ACTIONS(9958),
    [aux_sym_float_literal_token1] = ACTIONS(9960),
    [aux_sym_float_literal_token3] = ACTIONS(9960),
    [aux_sym_float_literal_token4] = ACTIONS(9960),
    [sym_character_literal] = ACTIONS(9960),
    [anon_sym_DQUOTE] = ACTIONS(9958),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9960),
    [anon_sym_BQUOTE] = ACTIONS(9958),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9960),
    [sym__pair_operator] = ACTIONS(9960),
    [sym__arrow_operator] = ACTIONS(9958),
    [sym__lazy_or_operator] = ACTIONS(9960),
    [sym__lazy_and_operator] = ACTIONS(9960),
    [sym__comparison_operator] = ACTIONS(9958),
    [sym__pipe_right_operator] = ACTIONS(9960),
    [sym__pipe_left_operator] = ACTIONS(9960),
    [sym__ellipsis_operator] = ACTIONS(9958),
    [sym__plus_operator] = ACTIONS(9958),
    [sym__times_operator] = ACTIONS(9958),
    [sym__rational_operator] = ACTIONS(9960),
    [sym__bitshift_operator] = ACTIONS(9960),
    [sym__power_operator] = ACTIONS(9960),
    [sym__tilde_operator] = ACTIONS(9960),
    [sym__type_order_operator] = ACTIONS(9960),
    [sym__unary_operator] = ACTIONS(9958),
    [sym__unary_plus_operator] = ACTIONS(9958),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9120] = {
    [sym_block_comment] = STATE(9120),
    [sym_line_comment] = STATE(9120),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(10270),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9171),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9171),
    [anon_sym_RBRACK] = ACTIONS(9171),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9171),
    [anon_sym_DOLLAR] = ACTIONS(9171),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9171),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9171),
    [aux_sym_integer_literal_token2] = ACTIONS(9171),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9171),
    [aux_sym_float_literal_token3] = ACTIONS(9171),
    [aux_sym_float_literal_token4] = ACTIONS(9171),
    [sym_character_literal] = ACTIONS(9171),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9171),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(9171),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9121] = {
    [sym_block_comment] = STATE(9121),
    [sym_line_comment] = STATE(9121),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_COMMA] = ACTIONS(10012),
    [anon_sym_EQ] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10012),
    [anon_sym_COLON] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10012),
    [anon_sym_in] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10012),
    [anon_sym_DOT] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10012),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10012),
    [anon_sym_isa] = ACTIONS(10010),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10012),
    [anon_sym_QMARK] = ACTIONS(10012),
    [anon_sym_where] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10012),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10012),
    [aux_sym_integer_literal_token2] = ACTIONS(10012),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10012),
    [aux_sym_float_literal_token3] = ACTIONS(10012),
    [aux_sym_float_literal_token4] = ACTIONS(10012),
    [sym_character_literal] = ACTIONS(10012),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10012),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10012),
    [sym__pair_operator] = ACTIONS(10012),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__lazy_or_operator] = ACTIONS(10012),
    [sym__lazy_and_operator] = ACTIONS(10012),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10012),
    [sym__pipe_left_operator] = ACTIONS(10012),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10012),
    [sym__bitshift_operator] = ACTIONS(10012),
    [sym__power_operator] = ACTIONS(10012),
    [sym__tilde_operator] = ACTIONS(10012),
    [sym__type_order_operator] = ACTIONS(10012),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9122] = {
    [sym_block_comment] = STATE(9122),
    [sym_line_comment] = STATE(9122),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_COMMA] = ACTIONS(10062),
    [anon_sym_EQ] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10062),
    [anon_sym_COLON] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10062),
    [anon_sym_in] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10062),
    [anon_sym_DOT] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10062),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10062),
    [anon_sym_isa] = ACTIONS(10060),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10062),
    [anon_sym_QMARK] = ACTIONS(10062),
    [anon_sym_where] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10062),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10062),
    [aux_sym_integer_literal_token2] = ACTIONS(10062),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10062),
    [aux_sym_float_literal_token3] = ACTIONS(10062),
    [aux_sym_float_literal_token4] = ACTIONS(10062),
    [sym_character_literal] = ACTIONS(10062),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10062),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10062),
    [sym__pair_operator] = ACTIONS(10062),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__lazy_or_operator] = ACTIONS(10062),
    [sym__lazy_and_operator] = ACTIONS(10062),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10062),
    [sym__pipe_left_operator] = ACTIONS(10062),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10062),
    [sym__bitshift_operator] = ACTIONS(10062),
    [sym__power_operator] = ACTIONS(10062),
    [sym__tilde_operator] = ACTIONS(10062),
    [sym__type_order_operator] = ACTIONS(10062),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9123] = {
    [sym_block_comment] = STATE(9123),
    [sym_line_comment] = STATE(9123),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12561),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12565),
    [sym__arrow_operator] = ACTIONS(12567),
    [sym__lazy_or_operator] = ACTIONS(12569),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9124] = {
    [sym_block_comment] = STATE(9124),
    [sym_line_comment] = STATE(9124),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(10342),
  },
  [9125] = {
    [sym_block_comment] = STATE(9125),
    [sym_line_comment] = STATE(9125),
    [sym__word_identifier] = ACTIONS(12744),
    [anon_sym_COMMA] = ACTIONS(12744),
    [anon_sym_begin] = ACTIONS(12744),
    [anon_sym_module] = ACTIONS(12744),
    [anon_sym_baremodule] = ACTIONS(12744),
    [anon_sym_end] = ACTIONS(12744),
    [anon_sym_abstract] = ACTIONS(12744),
    [anon_sym_primitive] = ACTIONS(12744),
    [anon_sym_mutable] = ACTIONS(12744),
    [anon_sym_struct] = ACTIONS(12744),
    [anon_sym_function] = ACTIONS(12744),
    [anon_sym_macro] = ACTIONS(12744),
    [anon_sym_quote] = ACTIONS(12744),
    [anon_sym_let] = ACTIONS(12744),
    [anon_sym_if] = ACTIONS(12744),
    [anon_sym_try] = ACTIONS(12744),
    [anon_sym_for] = ACTIONS(12744),
    [anon_sym_while] = ACTIONS(12744),
    [sym_break_statement] = ACTIONS(12744),
    [sym_continue_statement] = ACTIONS(12744),
    [anon_sym_return] = ACTIONS(12744),
    [anon_sym_const] = ACTIONS(12744),
    [anon_sym_global] = ACTIONS(12744),
    [anon_sym_local] = ACTIONS(12744),
    [anon_sym_LPAREN] = ACTIONS(12744),
    [anon_sym_COLON] = ACTIONS(12638),
    [anon_sym_export] = ACTIONS(12744),
    [anon_sym_public] = ACTIONS(12744),
    [anon_sym_import] = ACTIONS(12744),
    [anon_sym_using] = ACTIONS(12744),
    [anon_sym_LBRACK] = ACTIONS(12744),
    [anon_sym_in] = ACTIONS(12640),
    [anon_sym_LBRACE] = ACTIONS(12744),
    [anon_sym_DOLLAR] = ACTIONS(12744),
    [anon_sym_COLON2] = ACTIONS(12744),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12640),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12399),
    [anon_sym_where] = ACTIONS(12642),
    [anon_sym_AT] = ACTIONS(12744),
    [anon_sym_true] = ACTIONS(12744),
    [anon_sym_false] = ACTIONS(12744),
    [aux_sym_integer_literal_token1] = ACTIONS(12744),
    [aux_sym_integer_literal_token2] = ACTIONS(12744),
    [aux_sym_integer_literal_token3] = ACTIONS(12744),
    [aux_sym_integer_literal_token4] = ACTIONS(12744),
    [aux_sym_float_literal_token1] = ACTIONS(12744),
    [aux_sym_float_literal_token3] = ACTIONS(12744),
    [aux_sym_float_literal_token4] = ACTIONS(12744),
    [sym_character_literal] = ACTIONS(12744),
    [anon_sym_DQUOTE] = ACTIONS(12744),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12744),
    [anon_sym_BQUOTE] = ACTIONS(12744),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12744),
    [sym__pair_operator] = ACTIONS(12644),
    [sym__arrow_operator] = ACTIONS(12646),
    [sym__lazy_or_operator] = ACTIONS(12648),
    [sym__lazy_and_operator] = ACTIONS(12650),
    [sym__comparison_operator] = ACTIONS(12640),
    [sym__pipe_right_operator] = ACTIONS(12652),
    [sym__pipe_left_operator] = ACTIONS(12654),
    [sym__ellipsis_operator] = ACTIONS(12656),
    [sym__plus_operator] = ACTIONS(12658),
    [sym__times_operator] = ACTIONS(12660),
    [sym__rational_operator] = ACTIONS(12662),
    [sym__bitshift_operator] = ACTIONS(12664),
    [sym__power_operator] = ACTIONS(12666),
    [sym__tilde_operator] = ACTIONS(12744),
    [sym__type_order_operator] = ACTIONS(12640),
    [sym__unary_operator] = ACTIONS(12744),
    [sym__unary_plus_operator] = ACTIONS(12658),
    [aux_sym__terminator_token1] = ACTIONS(12746),
    [aux_sym__terminator_token2] = ACTIONS(12744),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9126] = {
    [sym_block_comment] = STATE(9126),
    [sym_line_comment] = STATE(9126),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_RPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(12257),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_RBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(12259),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_RBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12427),
    [anon_sym_where] = ACTIONS(12265),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(12267),
    [sym__arrow_operator] = ACTIONS(12269),
    [sym__lazy_or_operator] = ACTIONS(12271),
    [sym__lazy_and_operator] = ACTIONS(12273),
    [sym__comparison_operator] = ACTIONS(12259),
    [sym__pipe_right_operator] = ACTIONS(12275),
    [sym__pipe_left_operator] = ACTIONS(12277),
    [sym__ellipsis_operator] = ACTIONS(12279),
    [sym__plus_operator] = ACTIONS(12281),
    [sym__times_operator] = ACTIONS(12283),
    [sym__rational_operator] = ACTIONS(12285),
    [sym__bitshift_operator] = ACTIONS(12287),
    [sym__power_operator] = ACTIONS(12289),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(12291),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12281),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9127] = {
    [sym_block_comment] = STATE(9127),
    [sym_line_comment] = STATE(9127),
    [sym__word_identifier] = ACTIONS(3071),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_begin] = ACTIONS(3071),
    [anon_sym_module] = ACTIONS(3071),
    [anon_sym_baremodule] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_abstract] = ACTIONS(3071),
    [anon_sym_primitive] = ACTIONS(3071),
    [anon_sym_mutable] = ACTIONS(3071),
    [anon_sym_struct] = ACTIONS(3071),
    [anon_sym_function] = ACTIONS(3071),
    [anon_sym_macro] = ACTIONS(3071),
    [anon_sym_quote] = ACTIONS(3071),
    [anon_sym_let] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_try] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_while] = ACTIONS(3071),
    [sym_break_statement] = ACTIONS(3071),
    [sym_continue_statement] = ACTIONS(3071),
    [anon_sym_return] = ACTIONS(3071),
    [anon_sym_const] = ACTIONS(3071),
    [anon_sym_global] = ACTIONS(3071),
    [anon_sym_local] = ACTIONS(3071),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_export] = ACTIONS(3071),
    [anon_sym_public] = ACTIONS(3071),
    [anon_sym_import] = ACTIONS(3071),
    [anon_sym_using] = ACTIONS(3071),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_LBRACE] = ACTIONS(3075),
    [anon_sym_DOT] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(3075),
    [anon_sym_COLON2] = ACTIONS(3071),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3071),
    [anon_sym_AT] = ACTIONS(3075),
    [anon_sym_true] = ACTIONS(3071),
    [anon_sym_false] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(3075),
    [aux_sym_integer_literal_token2] = ACTIONS(3075),
    [aux_sym_integer_literal_token3] = ACTIONS(3071),
    [aux_sym_integer_literal_token4] = ACTIONS(3071),
    [aux_sym_float_literal_token1] = ACTIONS(3075),
    [aux_sym_float_literal_token3] = ACTIONS(3075),
    [aux_sym_float_literal_token4] = ACTIONS(3075),
    [sym_character_literal] = ACTIONS(3075),
    [anon_sym_DQUOTE] = ACTIONS(3071),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3075),
    [anon_sym_BQUOTE] = ACTIONS(3071),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(3075),
    [sym__pair_operator] = ACTIONS(3075),
    [sym__arrow_operator] = ACTIONS(3071),
    [sym__lazy_or_operator] = ACTIONS(3075),
    [sym__lazy_and_operator] = ACTIONS(3075),
    [sym__comparison_operator] = ACTIONS(3071),
    [sym__pipe_right_operator] = ACTIONS(3075),
    [sym__pipe_left_operator] = ACTIONS(3075),
    [sym__ellipsis_operator] = ACTIONS(3071),
    [sym__plus_operator] = ACTIONS(3071),
    [sym__times_operator] = ACTIONS(3071),
    [sym__rational_operator] = ACTIONS(3075),
    [sym__bitshift_operator] = ACTIONS(3075),
    [sym__power_operator] = ACTIONS(3075),
    [sym__tilde_operator] = ACTIONS(3075),
    [sym__type_order_operator] = ACTIONS(3075),
    [sym__unary_operator] = ACTIONS(3071),
    [sym__unary_plus_operator] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9128] = {
    [sym_block_comment] = STATE(9128),
    [sym_line_comment] = STATE(9128),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10222),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9129] = {
    [sym_block_comment] = STATE(9129),
    [sym_line_comment] = STATE(9129),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_COMMA] = ACTIONS(10066),
    [anon_sym_EQ] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10066),
    [anon_sym_COLON] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10066),
    [anon_sym_in] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10066),
    [anon_sym_DOT] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10066),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10066),
    [anon_sym_isa] = ACTIONS(10064),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10066),
    [anon_sym_QMARK] = ACTIONS(10066),
    [anon_sym_where] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10066),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10066),
    [aux_sym_integer_literal_token2] = ACTIONS(10066),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10066),
    [aux_sym_float_literal_token3] = ACTIONS(10066),
    [aux_sym_float_literal_token4] = ACTIONS(10066),
    [sym_character_literal] = ACTIONS(10066),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10066),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10066),
    [sym__pair_operator] = ACTIONS(10066),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__lazy_or_operator] = ACTIONS(10066),
    [sym__lazy_and_operator] = ACTIONS(10066),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10066),
    [sym__pipe_left_operator] = ACTIONS(10066),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10066),
    [sym__bitshift_operator] = ACTIONS(10066),
    [sym__power_operator] = ACTIONS(10066),
    [sym__tilde_operator] = ACTIONS(10066),
    [sym__type_order_operator] = ACTIONS(10066),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9130] = {
    [sym__primary_expression] = STATE(11421),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11089),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(9130),
    [sym_line_comment] = STATE(9130),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_catch] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_DOLLAR] = ACTIONS(10444),
    [anon_sym_COLON2] = ACTIONS(10446),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(1825),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9131] = {
    [sym_block_comment] = STATE(9131),
    [sym_line_comment] = STATE(9131),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_RBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12680),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9132] = {
    [sym_block_comment] = STATE(9132),
    [sym_line_comment] = STATE(9132),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_COMMA] = ACTIONS(10070),
    [anon_sym_EQ] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10070),
    [anon_sym_COLON] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10070),
    [anon_sym_in] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10070),
    [anon_sym_DOT] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10070),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10070),
    [anon_sym_isa] = ACTIONS(10068),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10070),
    [anon_sym_QMARK] = ACTIONS(10070),
    [anon_sym_where] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10070),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10070),
    [aux_sym_integer_literal_token2] = ACTIONS(10070),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10070),
    [aux_sym_float_literal_token3] = ACTIONS(10070),
    [aux_sym_float_literal_token4] = ACTIONS(10070),
    [sym_character_literal] = ACTIONS(10070),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10070),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10070),
    [sym__pair_operator] = ACTIONS(10070),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__lazy_or_operator] = ACTIONS(10070),
    [sym__lazy_and_operator] = ACTIONS(10070),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10070),
    [sym__pipe_left_operator] = ACTIONS(10070),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10070),
    [sym__bitshift_operator] = ACTIONS(10070),
    [sym__power_operator] = ACTIONS(10070),
    [sym__tilde_operator] = ACTIONS(10070),
    [sym__type_order_operator] = ACTIONS(10070),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9133] = {
    [sym_block_comment] = STATE(9133),
    [sym_line_comment] = STATE(9133),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_COMMA] = ACTIONS(10074),
    [anon_sym_EQ] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10074),
    [anon_sym_COLON] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10074),
    [anon_sym_in] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10074),
    [anon_sym_DOT] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10074),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10074),
    [anon_sym_isa] = ACTIONS(10072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10074),
    [anon_sym_QMARK] = ACTIONS(10074),
    [anon_sym_where] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10074),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10074),
    [aux_sym_integer_literal_token2] = ACTIONS(10074),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10074),
    [aux_sym_float_literal_token3] = ACTIONS(10074),
    [aux_sym_float_literal_token4] = ACTIONS(10074),
    [sym_character_literal] = ACTIONS(10074),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10074),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10074),
    [sym__pair_operator] = ACTIONS(10074),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__lazy_or_operator] = ACTIONS(10074),
    [sym__lazy_and_operator] = ACTIONS(10074),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10074),
    [sym__pipe_left_operator] = ACTIONS(10074),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10074),
    [sym__bitshift_operator] = ACTIONS(10074),
    [sym__power_operator] = ACTIONS(10074),
    [sym__tilde_operator] = ACTIONS(10074),
    [sym__type_order_operator] = ACTIONS(10074),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9134] = {
    [sym_block_comment] = STATE(9134),
    [sym_line_comment] = STATE(9134),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(12561),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12565),
    [sym__arrow_operator] = ACTIONS(12567),
    [sym__lazy_or_operator] = ACTIONS(12569),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9135] = {
    [sym_block_comment] = STATE(9135),
    [sym_line_comment] = STATE(9135),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11267),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11267),
    [anon_sym_RPAREN] = ACTIONS(11267),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11267),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_SEMI] = ACTIONS(11267),
    [anon_sym_LBRACE] = ACTIONS(11267),
    [anon_sym_DOLLAR] = ACTIONS(11267),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11267),
    [anon_sym_QMARK] = ACTIONS(11267),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11267),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11267),
    [aux_sym_integer_literal_token2] = ACTIONS(11267),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11267),
    [aux_sym_float_literal_token3] = ACTIONS(11267),
    [aux_sym_float_literal_token4] = ACTIONS(11267),
    [sym_character_literal] = ACTIONS(11267),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11267),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11267),
    [sym__pair_operator] = ACTIONS(11267),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11267),
    [sym__lazy_and_operator] = ACTIONS(11267),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11267),
    [sym__pipe_left_operator] = ACTIONS(11267),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11267),
    [sym__bitshift_operator] = ACTIONS(11267),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11267),
    [sym__type_order_operator] = ACTIONS(11267),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9136] = {
    [sym_block_comment] = STATE(9136),
    [sym_line_comment] = STATE(9136),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_RBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12676),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12680),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9137] = {
    [sym_block_comment] = STATE(9137),
    [sym_line_comment] = STATE(9137),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_COMMA] = ACTIONS(10078),
    [anon_sym_EQ] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10078),
    [anon_sym_COLON] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10078),
    [anon_sym_in] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10078),
    [anon_sym_DOT] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10078),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10078),
    [anon_sym_isa] = ACTIONS(10076),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10078),
    [anon_sym_QMARK] = ACTIONS(10078),
    [anon_sym_where] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10078),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10078),
    [aux_sym_integer_literal_token2] = ACTIONS(10078),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10078),
    [aux_sym_float_literal_token3] = ACTIONS(10078),
    [aux_sym_float_literal_token4] = ACTIONS(10078),
    [sym_character_literal] = ACTIONS(10078),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10078),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10078),
    [sym__pair_operator] = ACTIONS(10078),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__lazy_or_operator] = ACTIONS(10078),
    [sym__lazy_and_operator] = ACTIONS(10078),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10078),
    [sym__pipe_left_operator] = ACTIONS(10078),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10078),
    [sym__bitshift_operator] = ACTIONS(10078),
    [sym__power_operator] = ACTIONS(10078),
    [sym__tilde_operator] = ACTIONS(10078),
    [sym__type_order_operator] = ACTIONS(10078),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9138] = {
    [sym_block_comment] = STATE(9138),
    [sym_line_comment] = STATE(9138),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11267),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11267),
    [anon_sym_RPAREN] = ACTIONS(11267),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11267),
    [anon_sym_RBRACK] = ACTIONS(11267),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11267),
    [anon_sym_RBRACE] = ACTIONS(11267),
    [anon_sym_DOLLAR] = ACTIONS(11267),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11267),
    [anon_sym_QMARK] = ACTIONS(11267),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11267),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11267),
    [aux_sym_integer_literal_token2] = ACTIONS(11267),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11267),
    [aux_sym_float_literal_token3] = ACTIONS(11267),
    [aux_sym_float_literal_token4] = ACTIONS(11267),
    [sym_character_literal] = ACTIONS(11267),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11267),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11267),
    [sym__pair_operator] = ACTIONS(11267),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11267),
    [sym__lazy_and_operator] = ACTIONS(11267),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11267),
    [sym__pipe_left_operator] = ACTIONS(11267),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11267),
    [sym__bitshift_operator] = ACTIONS(11267),
    [sym__power_operator] = ACTIONS(12612),
    [sym__tilde_operator] = ACTIONS(11267),
    [sym__type_order_operator] = ACTIONS(11267),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9139] = {
    [sym_block_comment] = STATE(9139),
    [sym_line_comment] = STATE(9139),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_RBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9140] = {
    [sym_block_comment] = STATE(9140),
    [sym_line_comment] = STATE(9140),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_RPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10968),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9141] = {
    [sym_block_comment] = STATE(9141),
    [sym_line_comment] = STATE(9141),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10840),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10840),
    [anon_sym_RPAREN] = ACTIONS(10840),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10840),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10840),
    [anon_sym_LBRACE] = ACTIONS(10840),
    [anon_sym_DOLLAR] = ACTIONS(10840),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12364),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10840),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10840),
    [aux_sym_integer_literal_token2] = ACTIONS(10840),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10840),
    [aux_sym_float_literal_token3] = ACTIONS(10840),
    [aux_sym_float_literal_token4] = ACTIONS(10840),
    [sym_character_literal] = ACTIONS(10840),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10840),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10840),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10840),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9142] = {
    [sym_block_comment] = STATE(9142),
    [sym_line_comment] = STATE(9142),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10763),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_as] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10763),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10763),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10763),
    [anon_sym_DOLLAR] = ACTIONS(10763),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10763),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10763),
    [anon_sym_QMARK] = ACTIONS(10763),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10763),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10763),
    [aux_sym_integer_literal_token2] = ACTIONS(10763),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10763),
    [aux_sym_float_literal_token3] = ACTIONS(10763),
    [aux_sym_float_literal_token4] = ACTIONS(10763),
    [sym_character_literal] = ACTIONS(10763),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10763),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10763),
    [sym__pair_operator] = ACTIONS(10763),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10763),
    [sym__lazy_and_operator] = ACTIONS(10763),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10763),
    [sym__pipe_left_operator] = ACTIONS(10763),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10763),
    [sym__bitshift_operator] = ACTIONS(10763),
    [sym__power_operator] = ACTIONS(10763),
    [sym__tilde_operator] = ACTIONS(10763),
    [sym__type_order_operator] = ACTIONS(10763),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9143] = {
    [sym_block_comment] = STATE(9143),
    [sym_line_comment] = STATE(9143),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_COMMA] = ACTIONS(10016),
    [anon_sym_EQ] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10016),
    [anon_sym_COLON] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10016),
    [anon_sym_in] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10016),
    [anon_sym_DOT] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10016),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10016),
    [anon_sym_isa] = ACTIONS(10014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10016),
    [anon_sym_QMARK] = ACTIONS(10016),
    [anon_sym_where] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10016),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10016),
    [aux_sym_integer_literal_token2] = ACTIONS(10016),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10016),
    [aux_sym_float_literal_token3] = ACTIONS(10016),
    [aux_sym_float_literal_token4] = ACTIONS(10016),
    [sym_character_literal] = ACTIONS(10016),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10016),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10016),
    [sym__pair_operator] = ACTIONS(10016),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__lazy_or_operator] = ACTIONS(10016),
    [sym__lazy_and_operator] = ACTIONS(10016),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10016),
    [sym__pipe_left_operator] = ACTIONS(10016),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10016),
    [sym__bitshift_operator] = ACTIONS(10016),
    [sym__power_operator] = ACTIONS(10016),
    [sym__tilde_operator] = ACTIONS(10016),
    [sym__type_order_operator] = ACTIONS(10016),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9144] = {
    [sym_block_comment] = STATE(9144),
    [sym_line_comment] = STATE(9144),
    [aux_sym_open_tuple_repeat1] = STATE(8870),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12358),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_RPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(10972),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9145] = {
    [sym_block_comment] = STATE(9145),
    [sym_line_comment] = STATE(9145),
    [sym__word_identifier] = ACTIONS(10577),
    [anon_sym_COMMA] = ACTIONS(10579),
    [anon_sym_EQ] = ACTIONS(10577),
    [anon_sym_begin] = ACTIONS(10577),
    [anon_sym_module] = ACTIONS(10577),
    [anon_sym_baremodule] = ACTIONS(10577),
    [anon_sym_end] = ACTIONS(10577),
    [anon_sym_abstract] = ACTIONS(10577),
    [anon_sym_primitive] = ACTIONS(10577),
    [anon_sym_mutable] = ACTIONS(10577),
    [anon_sym_struct] = ACTIONS(10577),
    [anon_sym_function] = ACTIONS(10577),
    [anon_sym_macro] = ACTIONS(10577),
    [anon_sym_quote] = ACTIONS(10577),
    [anon_sym_let] = ACTIONS(10577),
    [anon_sym_if] = ACTIONS(10577),
    [anon_sym_try] = ACTIONS(10577),
    [anon_sym_for] = ACTIONS(10577),
    [anon_sym_while] = ACTIONS(10577),
    [sym_break_statement] = ACTIONS(10577),
    [sym_continue_statement] = ACTIONS(10577),
    [anon_sym_return] = ACTIONS(10577),
    [anon_sym_const] = ACTIONS(10577),
    [anon_sym_global] = ACTIONS(10577),
    [anon_sym_local] = ACTIONS(10577),
    [anon_sym_LPAREN] = ACTIONS(10579),
    [anon_sym_COLON] = ACTIONS(10577),
    [anon_sym_export] = ACTIONS(10577),
    [anon_sym_public] = ACTIONS(10577),
    [anon_sym_import] = ACTIONS(10577),
    [anon_sym_using] = ACTIONS(10577),
    [anon_sym_LBRACK] = ACTIONS(10579),
    [anon_sym_in] = ACTIONS(10577),
    [anon_sym_LBRACE] = ACTIONS(10579),
    [anon_sym_DOT] = ACTIONS(10577),
    [anon_sym_DOLLAR] = ACTIONS(10579),
    [anon_sym_COLON2] = ACTIONS(10577),
    [anon_sym_COLON_COLON] = ACTIONS(10579),
    [anon_sym_isa] = ACTIONS(10577),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10579),
    [anon_sym_QMARK] = ACTIONS(10579),
    [anon_sym_where] = ACTIONS(10577),
    [anon_sym_AT] = ACTIONS(10579),
    [anon_sym_true] = ACTIONS(10577),
    [anon_sym_false] = ACTIONS(10577),
    [aux_sym_integer_literal_token1] = ACTIONS(10579),
    [aux_sym_integer_literal_token2] = ACTIONS(10579),
    [aux_sym_integer_literal_token3] = ACTIONS(10577),
    [aux_sym_integer_literal_token4] = ACTIONS(10577),
    [aux_sym_float_literal_token1] = ACTIONS(10579),
    [aux_sym_float_literal_token3] = ACTIONS(10579),
    [aux_sym_float_literal_token4] = ACTIONS(10579),
    [sym_character_literal] = ACTIONS(10579),
    [anon_sym_DQUOTE] = ACTIONS(10577),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10579),
    [anon_sym_BQUOTE] = ACTIONS(10577),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10579),
    [sym__pair_operator] = ACTIONS(10579),
    [sym__arrow_operator] = ACTIONS(10577),
    [sym__lazy_or_operator] = ACTIONS(10579),
    [sym__lazy_and_operator] = ACTIONS(10579),
    [sym__comparison_operator] = ACTIONS(10577),
    [sym__pipe_right_operator] = ACTIONS(10579),
    [sym__pipe_left_operator] = ACTIONS(10579),
    [sym__ellipsis_operator] = ACTIONS(10577),
    [sym__plus_operator] = ACTIONS(10577),
    [sym__times_operator] = ACTIONS(10577),
    [sym__rational_operator] = ACTIONS(10579),
    [sym__bitshift_operator] = ACTIONS(10579),
    [sym__power_operator] = ACTIONS(10579),
    [sym__tilde_operator] = ACTIONS(10579),
    [sym__type_order_operator] = ACTIONS(10579),
    [sym__unary_operator] = ACTIONS(10577),
    [sym__unary_plus_operator] = ACTIONS(10577),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9146] = {
    [sym_block_comment] = STATE(9146),
    [sym_line_comment] = STATE(9146),
    [sym__word_identifier] = ACTIONS(11559),
    [anon_sym_COMMA] = ACTIONS(11561),
    [anon_sym_EQ] = ACTIONS(11559),
    [anon_sym_begin] = ACTIONS(11559),
    [anon_sym_module] = ACTIONS(11559),
    [anon_sym_baremodule] = ACTIONS(11559),
    [anon_sym_end] = ACTIONS(11559),
    [anon_sym_abstract] = ACTIONS(11559),
    [anon_sym_primitive] = ACTIONS(11559),
    [anon_sym_mutable] = ACTIONS(11559),
    [anon_sym_struct] = ACTIONS(11559),
    [anon_sym_function] = ACTIONS(11559),
    [anon_sym_macro] = ACTIONS(11559),
    [anon_sym_quote] = ACTIONS(11559),
    [anon_sym_let] = ACTIONS(11559),
    [anon_sym_if] = ACTIONS(11559),
    [anon_sym_try] = ACTIONS(11559),
    [anon_sym_for] = ACTIONS(11559),
    [anon_sym_while] = ACTIONS(11559),
    [sym_break_statement] = ACTIONS(11559),
    [sym_continue_statement] = ACTIONS(11559),
    [anon_sym_return] = ACTIONS(11559),
    [anon_sym_const] = ACTIONS(11559),
    [anon_sym_global] = ACTIONS(11559),
    [anon_sym_local] = ACTIONS(11559),
    [anon_sym_LPAREN] = ACTIONS(11561),
    [anon_sym_COLON] = ACTIONS(11559),
    [anon_sym_export] = ACTIONS(11559),
    [anon_sym_public] = ACTIONS(11559),
    [anon_sym_import] = ACTIONS(11559),
    [anon_sym_using] = ACTIONS(11559),
    [anon_sym_LBRACK] = ACTIONS(11561),
    [anon_sym_in] = ACTIONS(11559),
    [anon_sym_LBRACE] = ACTIONS(11561),
    [anon_sym_DOLLAR] = ACTIONS(11561),
    [anon_sym_COLON2] = ACTIONS(11559),
    [anon_sym_COLON_COLON] = ACTIONS(11561),
    [anon_sym_isa] = ACTIONS(11559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11561),
    [anon_sym_QMARK] = ACTIONS(11561),
    [anon_sym_where] = ACTIONS(11559),
    [anon_sym_AT] = ACTIONS(11561),
    [anon_sym_true] = ACTIONS(11559),
    [anon_sym_false] = ACTIONS(11559),
    [aux_sym_integer_literal_token1] = ACTIONS(11561),
    [aux_sym_integer_literal_token2] = ACTIONS(11561),
    [aux_sym_integer_literal_token3] = ACTIONS(11559),
    [aux_sym_integer_literal_token4] = ACTIONS(11559),
    [aux_sym_float_literal_token1] = ACTIONS(11561),
    [aux_sym_float_literal_token3] = ACTIONS(11561),
    [aux_sym_float_literal_token4] = ACTIONS(11561),
    [sym_character_literal] = ACTIONS(11561),
    [anon_sym_DQUOTE] = ACTIONS(11559),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11561),
    [anon_sym_BQUOTE] = ACTIONS(11559),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11561),
    [sym__pair_operator] = ACTIONS(11561),
    [sym__arrow_operator] = ACTIONS(11559),
    [sym__lazy_or_operator] = ACTIONS(11561),
    [sym__lazy_and_operator] = ACTIONS(11561),
    [sym__comparison_operator] = ACTIONS(11559),
    [sym__pipe_right_operator] = ACTIONS(11561),
    [sym__pipe_left_operator] = ACTIONS(11561),
    [sym__ellipsis_operator] = ACTIONS(11559),
    [sym__plus_operator] = ACTIONS(11559),
    [sym__times_operator] = ACTIONS(11559),
    [sym__rational_operator] = ACTIONS(11561),
    [sym__bitshift_operator] = ACTIONS(11561),
    [sym__power_operator] = ACTIONS(11561),
    [sym__tilde_operator] = ACTIONS(11561),
    [sym__type_order_operator] = ACTIONS(11561),
    [sym__unary_operator] = ACTIONS(11559),
    [sym__unary_plus_operator] = ACTIONS(11559),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9147] = {
    [sym_block_comment] = STATE(9147),
    [sym_line_comment] = STATE(9147),
    [sym__word_identifier] = ACTIONS(11259),
    [anon_sym_COMMA] = ACTIONS(11261),
    [anon_sym_EQ] = ACTIONS(11259),
    [anon_sym_begin] = ACTIONS(11259),
    [anon_sym_module] = ACTIONS(11259),
    [anon_sym_baremodule] = ACTIONS(11259),
    [anon_sym_end] = ACTIONS(11259),
    [anon_sym_abstract] = ACTIONS(11259),
    [anon_sym_primitive] = ACTIONS(11259),
    [anon_sym_mutable] = ACTIONS(11259),
    [anon_sym_struct] = ACTIONS(11259),
    [anon_sym_function] = ACTIONS(11259),
    [anon_sym_macro] = ACTIONS(11259),
    [anon_sym_quote] = ACTIONS(11259),
    [anon_sym_let] = ACTIONS(11259),
    [anon_sym_if] = ACTIONS(11259),
    [anon_sym_try] = ACTIONS(11259),
    [anon_sym_for] = ACTIONS(11259),
    [anon_sym_while] = ACTIONS(11259),
    [sym_break_statement] = ACTIONS(11259),
    [sym_continue_statement] = ACTIONS(11259),
    [anon_sym_return] = ACTIONS(11259),
    [anon_sym_const] = ACTIONS(11259),
    [anon_sym_global] = ACTIONS(11259),
    [anon_sym_local] = ACTIONS(11259),
    [anon_sym_LPAREN] = ACTIONS(11261),
    [anon_sym_COLON] = ACTIONS(11259),
    [anon_sym_export] = ACTIONS(11259),
    [anon_sym_public] = ACTIONS(11259),
    [anon_sym_import] = ACTIONS(11259),
    [anon_sym_using] = ACTIONS(11259),
    [anon_sym_LBRACK] = ACTIONS(11261),
    [anon_sym_in] = ACTIONS(11259),
    [anon_sym_LBRACE] = ACTIONS(11261),
    [anon_sym_DOLLAR] = ACTIONS(11261),
    [anon_sym_COLON2] = ACTIONS(11259),
    [anon_sym_COLON_COLON] = ACTIONS(11261),
    [anon_sym_isa] = ACTIONS(11259),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11261),
    [anon_sym_QMARK] = ACTIONS(11261),
    [anon_sym_where] = ACTIONS(11259),
    [anon_sym_AT] = ACTIONS(11261),
    [anon_sym_true] = ACTIONS(11259),
    [anon_sym_false] = ACTIONS(11259),
    [aux_sym_integer_literal_token1] = ACTIONS(11261),
    [aux_sym_integer_literal_token2] = ACTIONS(11261),
    [aux_sym_integer_literal_token3] = ACTIONS(11259),
    [aux_sym_integer_literal_token4] = ACTIONS(11259),
    [aux_sym_float_literal_token1] = ACTIONS(11261),
    [aux_sym_float_literal_token3] = ACTIONS(11261),
    [aux_sym_float_literal_token4] = ACTIONS(11261),
    [sym_character_literal] = ACTIONS(11261),
    [anon_sym_DQUOTE] = ACTIONS(11259),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11261),
    [anon_sym_BQUOTE] = ACTIONS(11259),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11261),
    [sym__pair_operator] = ACTIONS(11261),
    [sym__arrow_operator] = ACTIONS(11259),
    [sym__lazy_or_operator] = ACTIONS(11261),
    [sym__lazy_and_operator] = ACTIONS(11261),
    [sym__comparison_operator] = ACTIONS(11259),
    [sym__pipe_right_operator] = ACTIONS(11261),
    [sym__pipe_left_operator] = ACTIONS(11261),
    [sym__ellipsis_operator] = ACTIONS(11259),
    [sym__plus_operator] = ACTIONS(11259),
    [sym__times_operator] = ACTIONS(11259),
    [sym__rational_operator] = ACTIONS(11261),
    [sym__bitshift_operator] = ACTIONS(11261),
    [sym__power_operator] = ACTIONS(11261),
    [sym__tilde_operator] = ACTIONS(11261),
    [sym__type_order_operator] = ACTIONS(11261),
    [sym__unary_operator] = ACTIONS(11259),
    [sym__unary_plus_operator] = ACTIONS(11259),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9148] = {
    [sym_block_comment] = STATE(9148),
    [sym_line_comment] = STATE(9148),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10928),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9149] = {
    [sym_block_comment] = STATE(9149),
    [sym_line_comment] = STATE(9149),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9150] = {
    [sym_block_comment] = STATE(9150),
    [sym_line_comment] = STATE(9150),
    [sym__word_identifier] = ACTIONS(11223),
    [anon_sym_COMMA] = ACTIONS(11225),
    [anon_sym_EQ] = ACTIONS(11223),
    [anon_sym_begin] = ACTIONS(11223),
    [anon_sym_module] = ACTIONS(11223),
    [anon_sym_baremodule] = ACTIONS(11223),
    [anon_sym_end] = ACTIONS(11223),
    [anon_sym_abstract] = ACTIONS(11223),
    [anon_sym_primitive] = ACTIONS(11223),
    [anon_sym_mutable] = ACTIONS(11223),
    [anon_sym_struct] = ACTIONS(11223),
    [anon_sym_function] = ACTIONS(11223),
    [anon_sym_macro] = ACTIONS(11223),
    [anon_sym_quote] = ACTIONS(11223),
    [anon_sym_let] = ACTIONS(11223),
    [anon_sym_if] = ACTIONS(11223),
    [anon_sym_try] = ACTIONS(11223),
    [anon_sym_for] = ACTIONS(11223),
    [anon_sym_while] = ACTIONS(11223),
    [sym_break_statement] = ACTIONS(11223),
    [sym_continue_statement] = ACTIONS(11223),
    [anon_sym_return] = ACTIONS(11223),
    [anon_sym_const] = ACTIONS(11223),
    [anon_sym_global] = ACTIONS(11223),
    [anon_sym_local] = ACTIONS(11223),
    [anon_sym_LPAREN] = ACTIONS(11225),
    [anon_sym_COLON] = ACTIONS(11223),
    [anon_sym_export] = ACTIONS(11223),
    [anon_sym_public] = ACTIONS(11223),
    [anon_sym_import] = ACTIONS(11223),
    [anon_sym_using] = ACTIONS(11223),
    [anon_sym_LBRACK] = ACTIONS(11225),
    [anon_sym_in] = ACTIONS(11223),
    [anon_sym_LBRACE] = ACTIONS(11225),
    [anon_sym_DOLLAR] = ACTIONS(11225),
    [anon_sym_COLON2] = ACTIONS(11223),
    [anon_sym_COLON_COLON] = ACTIONS(11225),
    [anon_sym_isa] = ACTIONS(11223),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11225),
    [anon_sym_QMARK] = ACTIONS(11225),
    [anon_sym_where] = ACTIONS(11223),
    [anon_sym_AT] = ACTIONS(11225),
    [anon_sym_true] = ACTIONS(11223),
    [anon_sym_false] = ACTIONS(11223),
    [aux_sym_integer_literal_token1] = ACTIONS(11225),
    [aux_sym_integer_literal_token2] = ACTIONS(11225),
    [aux_sym_integer_literal_token3] = ACTIONS(11223),
    [aux_sym_integer_literal_token4] = ACTIONS(11223),
    [aux_sym_float_literal_token1] = ACTIONS(11225),
    [aux_sym_float_literal_token3] = ACTIONS(11225),
    [aux_sym_float_literal_token4] = ACTIONS(11225),
    [sym_character_literal] = ACTIONS(11225),
    [anon_sym_DQUOTE] = ACTIONS(11223),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11225),
    [anon_sym_BQUOTE] = ACTIONS(11223),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11225),
    [sym__pair_operator] = ACTIONS(11225),
    [sym__arrow_operator] = ACTIONS(11223),
    [sym__lazy_or_operator] = ACTIONS(11225),
    [sym__lazy_and_operator] = ACTIONS(11225),
    [sym__comparison_operator] = ACTIONS(11223),
    [sym__pipe_right_operator] = ACTIONS(11225),
    [sym__pipe_left_operator] = ACTIONS(11225),
    [sym__ellipsis_operator] = ACTIONS(11223),
    [sym__plus_operator] = ACTIONS(11223),
    [sym__times_operator] = ACTIONS(11223),
    [sym__rational_operator] = ACTIONS(11225),
    [sym__bitshift_operator] = ACTIONS(11225),
    [sym__power_operator] = ACTIONS(11225),
    [sym__tilde_operator] = ACTIONS(11225),
    [sym__type_order_operator] = ACTIONS(11225),
    [sym__unary_operator] = ACTIONS(11223),
    [sym__unary_plus_operator] = ACTIONS(11223),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9151] = {
    [sym_block_comment] = STATE(9151),
    [sym_line_comment] = STATE(9151),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(10966),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9152] = {
    [sym_block_comment] = STATE(9152),
    [sym_line_comment] = STATE(9152),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9153] = {
    [sym_block_comment] = STATE(9153),
    [sym_line_comment] = STATE(9153),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(10970),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9154] = {
    [sym_block_comment] = STATE(9154),
    [sym_line_comment] = STATE(9154),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9155] = {
    [sym_block_comment] = STATE(9155),
    [sym_line_comment] = STATE(9155),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9156] = {
    [sym_block_comment] = STATE(9156),
    [sym_line_comment] = STATE(9156),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12768),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12770),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(12772),
    [sym__arrow_operator] = ACTIONS(12774),
    [sym__lazy_or_operator] = ACTIONS(12776),
    [sym__lazy_and_operator] = ACTIONS(12778),
    [sym__comparison_operator] = ACTIONS(12768),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12780),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9157] = {
    [sym_block_comment] = STATE(9157),
    [sym_line_comment] = STATE(9157),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12768),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12770),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(12774),
    [sym__lazy_or_operator] = ACTIONS(12776),
    [sym__lazy_and_operator] = ACTIONS(12778),
    [sym__comparison_operator] = ACTIONS(12768),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12780),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9158] = {
    [sym_block_comment] = STATE(9158),
    [sym_line_comment] = STATE(9158),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12768),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12770),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(12778),
    [sym__comparison_operator] = ACTIONS(12768),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12780),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9159] = {
    [sym_block_comment] = STATE(9159),
    [sym_line_comment] = STATE(9159),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12768),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12770),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(12768),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12780),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9160] = {
    [sym_block_comment] = STATE(9160),
    [sym_line_comment] = STATE(9160),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9161] = {
    [sym_block_comment] = STATE(9161),
    [sym_line_comment] = STATE(9161),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9162] = {
    [sym_block_comment] = STATE(9162),
    [sym_line_comment] = STATE(9162),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9163] = {
    [sym_block_comment] = STATE(9163),
    [sym_line_comment] = STATE(9163),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9164] = {
    [sym_block_comment] = STATE(9164),
    [sym_line_comment] = STATE(9164),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9165] = {
    [sym_block_comment] = STATE(9165),
    [sym_line_comment] = STATE(9165),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9166] = {
    [sym_block_comment] = STATE(9166),
    [sym_line_comment] = STATE(9166),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_RPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_SEMI] = ACTIONS(11110),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9167] = {
    [sym_block_comment] = STATE(9167),
    [sym_line_comment] = STATE(9167),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12565),
    [sym__arrow_operator] = ACTIONS(12567),
    [sym__lazy_or_operator] = ACTIONS(12569),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9168] = {
    [sym_block_comment] = STATE(9168),
    [sym_line_comment] = STATE(9168),
    [sym__word_identifier] = ACTIONS(11291),
    [anon_sym_COMMA] = ACTIONS(11293),
    [anon_sym_EQ] = ACTIONS(11291),
    [anon_sym_begin] = ACTIONS(11291),
    [anon_sym_module] = ACTIONS(11291),
    [anon_sym_baremodule] = ACTIONS(11291),
    [anon_sym_end] = ACTIONS(11291),
    [anon_sym_abstract] = ACTIONS(11291),
    [anon_sym_primitive] = ACTIONS(11291),
    [anon_sym_mutable] = ACTIONS(11291),
    [anon_sym_struct] = ACTIONS(11291),
    [anon_sym_function] = ACTIONS(11291),
    [anon_sym_macro] = ACTIONS(11291),
    [anon_sym_quote] = ACTIONS(11291),
    [anon_sym_let] = ACTIONS(11291),
    [anon_sym_if] = ACTIONS(11291),
    [anon_sym_try] = ACTIONS(11291),
    [anon_sym_for] = ACTIONS(11291),
    [anon_sym_while] = ACTIONS(11291),
    [sym_break_statement] = ACTIONS(11291),
    [sym_continue_statement] = ACTIONS(11291),
    [anon_sym_return] = ACTIONS(11291),
    [anon_sym_const] = ACTIONS(11291),
    [anon_sym_global] = ACTIONS(11291),
    [anon_sym_local] = ACTIONS(11291),
    [anon_sym_LPAREN] = ACTIONS(11293),
    [anon_sym_COLON] = ACTIONS(11291),
    [anon_sym_export] = ACTIONS(11291),
    [anon_sym_public] = ACTIONS(11291),
    [anon_sym_import] = ACTIONS(11291),
    [anon_sym_using] = ACTIONS(11291),
    [anon_sym_LBRACK] = ACTIONS(11293),
    [anon_sym_in] = ACTIONS(11291),
    [anon_sym_LBRACE] = ACTIONS(11293),
    [anon_sym_DOLLAR] = ACTIONS(11293),
    [anon_sym_COLON2] = ACTIONS(11291),
    [anon_sym_COLON_COLON] = ACTIONS(11293),
    [anon_sym_isa] = ACTIONS(11291),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11293),
    [anon_sym_QMARK] = ACTIONS(11293),
    [anon_sym_where] = ACTIONS(11291),
    [anon_sym_AT] = ACTIONS(11293),
    [anon_sym_true] = ACTIONS(11291),
    [anon_sym_false] = ACTIONS(11291),
    [aux_sym_integer_literal_token1] = ACTIONS(11293),
    [aux_sym_integer_literal_token2] = ACTIONS(11293),
    [aux_sym_integer_literal_token3] = ACTIONS(11291),
    [aux_sym_integer_literal_token4] = ACTIONS(11291),
    [aux_sym_float_literal_token1] = ACTIONS(11293),
    [aux_sym_float_literal_token3] = ACTIONS(11293),
    [aux_sym_float_literal_token4] = ACTIONS(11293),
    [sym_character_literal] = ACTIONS(11293),
    [anon_sym_DQUOTE] = ACTIONS(11291),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11293),
    [anon_sym_BQUOTE] = ACTIONS(11291),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11293),
    [sym__pair_operator] = ACTIONS(11293),
    [sym__arrow_operator] = ACTIONS(11291),
    [sym__lazy_or_operator] = ACTIONS(11293),
    [sym__lazy_and_operator] = ACTIONS(11293),
    [sym__comparison_operator] = ACTIONS(11291),
    [sym__pipe_right_operator] = ACTIONS(11293),
    [sym__pipe_left_operator] = ACTIONS(11293),
    [sym__ellipsis_operator] = ACTIONS(11291),
    [sym__plus_operator] = ACTIONS(11291),
    [sym__times_operator] = ACTIONS(11291),
    [sym__rational_operator] = ACTIONS(11293),
    [sym__bitshift_operator] = ACTIONS(11293),
    [sym__power_operator] = ACTIONS(11293),
    [sym__tilde_operator] = ACTIONS(11293),
    [sym__type_order_operator] = ACTIONS(11293),
    [sym__unary_operator] = ACTIONS(11291),
    [sym__unary_plus_operator] = ACTIONS(11291),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9169] = {
    [sym_block_comment] = STATE(9169),
    [sym_line_comment] = STATE(9169),
    [sym__word_identifier] = ACTIONS(11305),
    [anon_sym_COMMA] = ACTIONS(11307),
    [anon_sym_EQ] = ACTIONS(11305),
    [anon_sym_begin] = ACTIONS(11305),
    [anon_sym_module] = ACTIONS(11305),
    [anon_sym_baremodule] = ACTIONS(11305),
    [anon_sym_end] = ACTIONS(11305),
    [anon_sym_abstract] = ACTIONS(11305),
    [anon_sym_primitive] = ACTIONS(11305),
    [anon_sym_mutable] = ACTIONS(11305),
    [anon_sym_struct] = ACTIONS(11305),
    [anon_sym_function] = ACTIONS(11305),
    [anon_sym_macro] = ACTIONS(11305),
    [anon_sym_quote] = ACTIONS(11305),
    [anon_sym_let] = ACTIONS(11305),
    [anon_sym_if] = ACTIONS(11305),
    [anon_sym_try] = ACTIONS(11305),
    [anon_sym_for] = ACTIONS(11305),
    [anon_sym_while] = ACTIONS(11305),
    [sym_break_statement] = ACTIONS(11305),
    [sym_continue_statement] = ACTIONS(11305),
    [anon_sym_return] = ACTIONS(11305),
    [anon_sym_const] = ACTIONS(11305),
    [anon_sym_global] = ACTIONS(11305),
    [anon_sym_local] = ACTIONS(11305),
    [anon_sym_LPAREN] = ACTIONS(11307),
    [anon_sym_COLON] = ACTIONS(11305),
    [anon_sym_export] = ACTIONS(11305),
    [anon_sym_public] = ACTIONS(11305),
    [anon_sym_import] = ACTIONS(11305),
    [anon_sym_using] = ACTIONS(11305),
    [anon_sym_LBRACK] = ACTIONS(11307),
    [anon_sym_in] = ACTIONS(11305),
    [anon_sym_LBRACE] = ACTIONS(11307),
    [anon_sym_DOLLAR] = ACTIONS(11307),
    [anon_sym_COLON2] = ACTIONS(11305),
    [anon_sym_COLON_COLON] = ACTIONS(11307),
    [anon_sym_isa] = ACTIONS(11305),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11307),
    [anon_sym_QMARK] = ACTIONS(11307),
    [anon_sym_where] = ACTIONS(11305),
    [anon_sym_AT] = ACTIONS(11307),
    [anon_sym_true] = ACTIONS(11305),
    [anon_sym_false] = ACTIONS(11305),
    [aux_sym_integer_literal_token1] = ACTIONS(11307),
    [aux_sym_integer_literal_token2] = ACTIONS(11307),
    [aux_sym_integer_literal_token3] = ACTIONS(11305),
    [aux_sym_integer_literal_token4] = ACTIONS(11305),
    [aux_sym_float_literal_token1] = ACTIONS(11307),
    [aux_sym_float_literal_token3] = ACTIONS(11307),
    [aux_sym_float_literal_token4] = ACTIONS(11307),
    [sym_character_literal] = ACTIONS(11307),
    [anon_sym_DQUOTE] = ACTIONS(11305),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11307),
    [anon_sym_BQUOTE] = ACTIONS(11305),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11307),
    [sym__pair_operator] = ACTIONS(11307),
    [sym__arrow_operator] = ACTIONS(11305),
    [sym__lazy_or_operator] = ACTIONS(11307),
    [sym__lazy_and_operator] = ACTIONS(11307),
    [sym__comparison_operator] = ACTIONS(11305),
    [sym__pipe_right_operator] = ACTIONS(11307),
    [sym__pipe_left_operator] = ACTIONS(11307),
    [sym__ellipsis_operator] = ACTIONS(11305),
    [sym__plus_operator] = ACTIONS(11305),
    [sym__times_operator] = ACTIONS(11305),
    [sym__rational_operator] = ACTIONS(11307),
    [sym__bitshift_operator] = ACTIONS(11307),
    [sym__power_operator] = ACTIONS(11307),
    [sym__tilde_operator] = ACTIONS(11307),
    [sym__type_order_operator] = ACTIONS(11307),
    [sym__unary_operator] = ACTIONS(11305),
    [sym__unary_plus_operator] = ACTIONS(11305),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9170] = {
    [sym_block_comment] = STATE(9170),
    [sym_line_comment] = STATE(9170),
    [sym__word_identifier] = ACTIONS(10908),
    [anon_sym_COMMA] = ACTIONS(10910),
    [anon_sym_EQ] = ACTIONS(10908),
    [anon_sym_begin] = ACTIONS(10908),
    [anon_sym_module] = ACTIONS(10908),
    [anon_sym_baremodule] = ACTIONS(10908),
    [anon_sym_end] = ACTIONS(10908),
    [anon_sym_abstract] = ACTIONS(10908),
    [anon_sym_primitive] = ACTIONS(10908),
    [anon_sym_mutable] = ACTIONS(10908),
    [anon_sym_struct] = ACTIONS(10908),
    [anon_sym_function] = ACTIONS(10908),
    [anon_sym_macro] = ACTIONS(10908),
    [anon_sym_quote] = ACTIONS(10908),
    [anon_sym_let] = ACTIONS(10908),
    [anon_sym_if] = ACTIONS(10908),
    [anon_sym_try] = ACTIONS(10908),
    [anon_sym_for] = ACTIONS(10908),
    [anon_sym_while] = ACTIONS(10908),
    [sym_break_statement] = ACTIONS(10908),
    [sym_continue_statement] = ACTIONS(10908),
    [anon_sym_return] = ACTIONS(10908),
    [anon_sym_const] = ACTIONS(10908),
    [anon_sym_global] = ACTIONS(10908),
    [anon_sym_local] = ACTIONS(10908),
    [anon_sym_LPAREN] = ACTIONS(10910),
    [anon_sym_COLON] = ACTIONS(10908),
    [anon_sym_export] = ACTIONS(10908),
    [anon_sym_public] = ACTIONS(10908),
    [anon_sym_import] = ACTIONS(10908),
    [anon_sym_using] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(10910),
    [anon_sym_in] = ACTIONS(10908),
    [anon_sym_LBRACE] = ACTIONS(10910),
    [anon_sym_DOLLAR] = ACTIONS(10910),
    [anon_sym_COLON2] = ACTIONS(10908),
    [anon_sym_COLON_COLON] = ACTIONS(10910),
    [anon_sym_isa] = ACTIONS(10908),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10910),
    [anon_sym_QMARK] = ACTIONS(10910),
    [anon_sym_where] = ACTIONS(10908),
    [anon_sym_AT] = ACTIONS(10910),
    [anon_sym_true] = ACTIONS(10908),
    [anon_sym_false] = ACTIONS(10908),
    [aux_sym_integer_literal_token1] = ACTIONS(10910),
    [aux_sym_integer_literal_token2] = ACTIONS(10910),
    [aux_sym_integer_literal_token3] = ACTIONS(10908),
    [aux_sym_integer_literal_token4] = ACTIONS(10908),
    [aux_sym_float_literal_token1] = ACTIONS(10910),
    [aux_sym_float_literal_token3] = ACTIONS(10910),
    [aux_sym_float_literal_token4] = ACTIONS(10910),
    [sym_character_literal] = ACTIONS(10910),
    [anon_sym_DQUOTE] = ACTIONS(10908),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10910),
    [anon_sym_BQUOTE] = ACTIONS(10908),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10910),
    [sym__pair_operator] = ACTIONS(10910),
    [sym__arrow_operator] = ACTIONS(10908),
    [sym__lazy_or_operator] = ACTIONS(10910),
    [sym__lazy_and_operator] = ACTIONS(10910),
    [sym__comparison_operator] = ACTIONS(10908),
    [sym__pipe_right_operator] = ACTIONS(10910),
    [sym__pipe_left_operator] = ACTIONS(10910),
    [sym__ellipsis_operator] = ACTIONS(10908),
    [sym__plus_operator] = ACTIONS(10908),
    [sym__times_operator] = ACTIONS(10908),
    [sym__rational_operator] = ACTIONS(10910),
    [sym__bitshift_operator] = ACTIONS(10910),
    [sym__power_operator] = ACTIONS(10910),
    [sym__tilde_operator] = ACTIONS(10910),
    [sym__type_order_operator] = ACTIONS(10910),
    [sym__unary_operator] = ACTIONS(10908),
    [sym__unary_plus_operator] = ACTIONS(10908),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9171] = {
    [sym_block_comment] = STATE(9171),
    [sym_line_comment] = STATE(9171),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11267),
    [anon_sym_EQ] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11267),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11267),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11267),
    [anon_sym_DOLLAR] = ACTIONS(11267),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11267),
    [anon_sym_QMARK] = ACTIONS(11267),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11267),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11267),
    [aux_sym_integer_literal_token2] = ACTIONS(11267),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11267),
    [aux_sym_float_literal_token3] = ACTIONS(11267),
    [aux_sym_float_literal_token4] = ACTIONS(11267),
    [sym_character_literal] = ACTIONS(11267),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11267),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11267),
    [sym__pair_operator] = ACTIONS(11267),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11267),
    [sym__lazy_and_operator] = ACTIONS(11267),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11267),
    [sym__pipe_left_operator] = ACTIONS(11267),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11267),
    [sym__bitshift_operator] = ACTIONS(11267),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11267),
    [sym__type_order_operator] = ACTIONS(11267),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9172] = {
    [sym_block_comment] = STATE(9172),
    [sym_line_comment] = STATE(9172),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9173] = {
    [sym__primary_expression] = STATE(11470),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11233),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(9173),
    [sym_line_comment] = STATE(9173),
    [ts_builtin_sym_end] = ACTIONS(9212),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_DOLLAR] = ACTIONS(10481),
    [anon_sym_COLON2] = ACTIONS(10483),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(1825),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9174] = {
    [sym_block_comment] = STATE(9174),
    [sym_line_comment] = STATE(9174),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12798),
    [sym__arrow_operator] = ACTIONS(12800),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3623),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(3623),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9175] = {
    [sym_block_comment] = STATE(9175),
    [sym_line_comment] = STATE(9175),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9176] = {
    [sym_block_comment] = STATE(9176),
    [sym_line_comment] = STATE(9176),
    [sym__word_identifier] = ACTIONS(11169),
    [anon_sym_COMMA] = ACTIONS(11171),
    [anon_sym_EQ] = ACTIONS(11169),
    [anon_sym_begin] = ACTIONS(11169),
    [anon_sym_module] = ACTIONS(11169),
    [anon_sym_baremodule] = ACTIONS(11169),
    [anon_sym_end] = ACTIONS(11169),
    [anon_sym_abstract] = ACTIONS(11169),
    [anon_sym_primitive] = ACTIONS(11169),
    [anon_sym_mutable] = ACTIONS(11169),
    [anon_sym_struct] = ACTIONS(11169),
    [anon_sym_function] = ACTIONS(11169),
    [anon_sym_macro] = ACTIONS(11169),
    [anon_sym_quote] = ACTIONS(11169),
    [anon_sym_let] = ACTIONS(11169),
    [anon_sym_if] = ACTIONS(11169),
    [anon_sym_try] = ACTIONS(11169),
    [anon_sym_for] = ACTIONS(11169),
    [anon_sym_while] = ACTIONS(11169),
    [sym_break_statement] = ACTIONS(11169),
    [sym_continue_statement] = ACTIONS(11169),
    [anon_sym_return] = ACTIONS(11169),
    [anon_sym_const] = ACTIONS(11169),
    [anon_sym_global] = ACTIONS(11169),
    [anon_sym_local] = ACTIONS(11169),
    [anon_sym_LPAREN] = ACTIONS(11171),
    [anon_sym_COLON] = ACTIONS(11169),
    [anon_sym_export] = ACTIONS(11169),
    [anon_sym_public] = ACTIONS(11169),
    [anon_sym_import] = ACTIONS(11169),
    [anon_sym_using] = ACTIONS(11169),
    [anon_sym_LBRACK] = ACTIONS(11171),
    [anon_sym_in] = ACTIONS(11169),
    [anon_sym_LBRACE] = ACTIONS(11171),
    [anon_sym_DOLLAR] = ACTIONS(11171),
    [anon_sym_COLON2] = ACTIONS(11169),
    [anon_sym_COLON_COLON] = ACTIONS(11171),
    [anon_sym_isa] = ACTIONS(11169),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11171),
    [anon_sym_QMARK] = ACTIONS(11171),
    [anon_sym_where] = ACTIONS(11169),
    [anon_sym_AT] = ACTIONS(11171),
    [anon_sym_true] = ACTIONS(11169),
    [anon_sym_false] = ACTIONS(11169),
    [aux_sym_integer_literal_token1] = ACTIONS(11171),
    [aux_sym_integer_literal_token2] = ACTIONS(11171),
    [aux_sym_integer_literal_token3] = ACTIONS(11169),
    [aux_sym_integer_literal_token4] = ACTIONS(11169),
    [aux_sym_float_literal_token1] = ACTIONS(11171),
    [aux_sym_float_literal_token3] = ACTIONS(11171),
    [aux_sym_float_literal_token4] = ACTIONS(11171),
    [sym_character_literal] = ACTIONS(11171),
    [anon_sym_DQUOTE] = ACTIONS(11169),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11171),
    [anon_sym_BQUOTE] = ACTIONS(11169),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11171),
    [sym__pair_operator] = ACTIONS(11171),
    [sym__arrow_operator] = ACTIONS(11169),
    [sym__lazy_or_operator] = ACTIONS(11171),
    [sym__lazy_and_operator] = ACTIONS(11171),
    [sym__comparison_operator] = ACTIONS(11169),
    [sym__pipe_right_operator] = ACTIONS(11171),
    [sym__pipe_left_operator] = ACTIONS(11171),
    [sym__ellipsis_operator] = ACTIONS(11169),
    [sym__plus_operator] = ACTIONS(11169),
    [sym__times_operator] = ACTIONS(11169),
    [sym__rational_operator] = ACTIONS(11171),
    [sym__bitshift_operator] = ACTIONS(11171),
    [sym__power_operator] = ACTIONS(11171),
    [sym__tilde_operator] = ACTIONS(11171),
    [sym__type_order_operator] = ACTIONS(11171),
    [sym__unary_operator] = ACTIONS(11169),
    [sym__unary_plus_operator] = ACTIONS(11169),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9177] = {
    [sym_block_comment] = STATE(9177),
    [sym_line_comment] = STATE(9177),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11289),
    [anon_sym_isa] = ACTIONS(11287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11289),
    [anon_sym_QMARK] = ACTIONS(11289),
    [anon_sym_where] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(11289),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__lazy_or_operator] = ACTIONS(11289),
    [sym__lazy_and_operator] = ACTIONS(11289),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11289),
    [sym__pipe_left_operator] = ACTIONS(11289),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11289),
    [sym__bitshift_operator] = ACTIONS(11289),
    [sym__power_operator] = ACTIONS(11289),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(11289),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9178] = {
    [sym_block_comment] = STATE(9178),
    [sym_line_comment] = STATE(9178),
    [sym__word_identifier] = ACTIONS(11472),
    [anon_sym_COMMA] = ACTIONS(11474),
    [anon_sym_EQ] = ACTIONS(11472),
    [anon_sym_begin] = ACTIONS(11472),
    [anon_sym_module] = ACTIONS(11472),
    [anon_sym_baremodule] = ACTIONS(11472),
    [anon_sym_end] = ACTIONS(11472),
    [anon_sym_abstract] = ACTIONS(11472),
    [anon_sym_primitive] = ACTIONS(11472),
    [anon_sym_mutable] = ACTIONS(11472),
    [anon_sym_struct] = ACTIONS(11472),
    [anon_sym_function] = ACTIONS(11472),
    [anon_sym_macro] = ACTIONS(11472),
    [anon_sym_quote] = ACTIONS(11472),
    [anon_sym_let] = ACTIONS(11472),
    [anon_sym_if] = ACTIONS(11472),
    [anon_sym_try] = ACTIONS(11472),
    [anon_sym_for] = ACTIONS(11472),
    [anon_sym_while] = ACTIONS(11472),
    [sym_break_statement] = ACTIONS(11472),
    [sym_continue_statement] = ACTIONS(11472),
    [anon_sym_return] = ACTIONS(11472),
    [anon_sym_const] = ACTIONS(11472),
    [anon_sym_global] = ACTIONS(11472),
    [anon_sym_local] = ACTIONS(11472),
    [anon_sym_LPAREN] = ACTIONS(11474),
    [anon_sym_COLON] = ACTIONS(11472),
    [anon_sym_export] = ACTIONS(11472),
    [anon_sym_public] = ACTIONS(11472),
    [anon_sym_import] = ACTIONS(11472),
    [anon_sym_using] = ACTIONS(11472),
    [anon_sym_LBRACK] = ACTIONS(11474),
    [anon_sym_in] = ACTIONS(11472),
    [anon_sym_LBRACE] = ACTIONS(11474),
    [anon_sym_DOLLAR] = ACTIONS(11474),
    [anon_sym_COLON2] = ACTIONS(11472),
    [anon_sym_COLON_COLON] = ACTIONS(11474),
    [anon_sym_isa] = ACTIONS(11472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11474),
    [anon_sym_QMARK] = ACTIONS(11474),
    [anon_sym_where] = ACTIONS(11472),
    [anon_sym_AT] = ACTIONS(11474),
    [anon_sym_true] = ACTIONS(11472),
    [anon_sym_false] = ACTIONS(11472),
    [aux_sym_integer_literal_token1] = ACTIONS(11474),
    [aux_sym_integer_literal_token2] = ACTIONS(11474),
    [aux_sym_integer_literal_token3] = ACTIONS(11472),
    [aux_sym_integer_literal_token4] = ACTIONS(11472),
    [aux_sym_float_literal_token1] = ACTIONS(11474),
    [aux_sym_float_literal_token3] = ACTIONS(11474),
    [aux_sym_float_literal_token4] = ACTIONS(11474),
    [sym_character_literal] = ACTIONS(11474),
    [anon_sym_DQUOTE] = ACTIONS(11472),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11474),
    [anon_sym_BQUOTE] = ACTIONS(11472),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11474),
    [sym__pair_operator] = ACTIONS(11474),
    [sym__arrow_operator] = ACTIONS(11472),
    [sym__lazy_or_operator] = ACTIONS(11474),
    [sym__lazy_and_operator] = ACTIONS(11474),
    [sym__comparison_operator] = ACTIONS(11472),
    [sym__pipe_right_operator] = ACTIONS(11474),
    [sym__pipe_left_operator] = ACTIONS(11474),
    [sym__ellipsis_operator] = ACTIONS(11472),
    [sym__plus_operator] = ACTIONS(11472),
    [sym__times_operator] = ACTIONS(11472),
    [sym__rational_operator] = ACTIONS(11474),
    [sym__bitshift_operator] = ACTIONS(11474),
    [sym__power_operator] = ACTIONS(11474),
    [sym__tilde_operator] = ACTIONS(11474),
    [sym__type_order_operator] = ACTIONS(11474),
    [sym__unary_operator] = ACTIONS(11472),
    [sym__unary_plus_operator] = ACTIONS(11472),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9179] = {
    [sym_block_comment] = STATE(9179),
    [sym_line_comment] = STATE(9179),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12800),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3623),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(3623),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9180] = {
    [sym_block_comment] = STATE(9180),
    [sym_line_comment] = STATE(9180),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3623),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(3623),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9181] = {
    [sym_block_comment] = STATE(9181),
    [sym_line_comment] = STATE(9181),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(3623),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(3623),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9182] = {
    [sym_block_comment] = STATE(9182),
    [sym_line_comment] = STATE(9182),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9183] = {
    [sym_block_comment] = STATE(9183),
    [sym_line_comment] = STATE(9183),
    [sym__word_identifier] = ACTIONS(11499),
    [anon_sym_COMMA] = ACTIONS(11501),
    [anon_sym_EQ] = ACTIONS(11499),
    [anon_sym_begin] = ACTIONS(11499),
    [anon_sym_module] = ACTIONS(11499),
    [anon_sym_baremodule] = ACTIONS(11499),
    [anon_sym_end] = ACTIONS(11499),
    [anon_sym_abstract] = ACTIONS(11499),
    [anon_sym_primitive] = ACTIONS(11499),
    [anon_sym_mutable] = ACTIONS(11499),
    [anon_sym_struct] = ACTIONS(11499),
    [anon_sym_function] = ACTIONS(11499),
    [anon_sym_macro] = ACTIONS(11499),
    [anon_sym_quote] = ACTIONS(11499),
    [anon_sym_let] = ACTIONS(11499),
    [anon_sym_if] = ACTIONS(11499),
    [anon_sym_try] = ACTIONS(11499),
    [anon_sym_for] = ACTIONS(11499),
    [anon_sym_while] = ACTIONS(11499),
    [sym_break_statement] = ACTIONS(11499),
    [sym_continue_statement] = ACTIONS(11499),
    [anon_sym_return] = ACTIONS(11499),
    [anon_sym_const] = ACTIONS(11499),
    [anon_sym_global] = ACTIONS(11499),
    [anon_sym_local] = ACTIONS(11499),
    [anon_sym_LPAREN] = ACTIONS(11501),
    [anon_sym_COLON] = ACTIONS(11499),
    [anon_sym_export] = ACTIONS(11499),
    [anon_sym_public] = ACTIONS(11499),
    [anon_sym_import] = ACTIONS(11499),
    [anon_sym_using] = ACTIONS(11499),
    [anon_sym_LBRACK] = ACTIONS(11501),
    [anon_sym_in] = ACTIONS(11499),
    [anon_sym_LBRACE] = ACTIONS(11501),
    [anon_sym_DOLLAR] = ACTIONS(11501),
    [anon_sym_COLON2] = ACTIONS(11499),
    [anon_sym_COLON_COLON] = ACTIONS(11501),
    [anon_sym_isa] = ACTIONS(11499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11501),
    [anon_sym_QMARK] = ACTIONS(11501),
    [anon_sym_where] = ACTIONS(11499),
    [anon_sym_AT] = ACTIONS(11501),
    [anon_sym_true] = ACTIONS(11499),
    [anon_sym_false] = ACTIONS(11499),
    [aux_sym_integer_literal_token1] = ACTIONS(11501),
    [aux_sym_integer_literal_token2] = ACTIONS(11501),
    [aux_sym_integer_literal_token3] = ACTIONS(11499),
    [aux_sym_integer_literal_token4] = ACTIONS(11499),
    [aux_sym_float_literal_token1] = ACTIONS(11501),
    [aux_sym_float_literal_token3] = ACTIONS(11501),
    [aux_sym_float_literal_token4] = ACTIONS(11501),
    [sym_character_literal] = ACTIONS(11501),
    [anon_sym_DQUOTE] = ACTIONS(11499),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11501),
    [anon_sym_BQUOTE] = ACTIONS(11499),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11501),
    [sym__pair_operator] = ACTIONS(11501),
    [sym__arrow_operator] = ACTIONS(11499),
    [sym__lazy_or_operator] = ACTIONS(11501),
    [sym__lazy_and_operator] = ACTIONS(11501),
    [sym__comparison_operator] = ACTIONS(11499),
    [sym__pipe_right_operator] = ACTIONS(11501),
    [sym__pipe_left_operator] = ACTIONS(11501),
    [sym__ellipsis_operator] = ACTIONS(11499),
    [sym__plus_operator] = ACTIONS(11499),
    [sym__times_operator] = ACTIONS(11499),
    [sym__rational_operator] = ACTIONS(11501),
    [sym__bitshift_operator] = ACTIONS(11501),
    [sym__power_operator] = ACTIONS(11501),
    [sym__tilde_operator] = ACTIONS(11501),
    [sym__type_order_operator] = ACTIONS(11501),
    [sym__unary_operator] = ACTIONS(11499),
    [sym__unary_plus_operator] = ACTIONS(11499),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9184] = {
    [sym_block_comment] = STATE(9184),
    [sym_line_comment] = STATE(9184),
    [sym__word_identifier] = ACTIONS(11513),
    [anon_sym_COMMA] = ACTIONS(11515),
    [anon_sym_EQ] = ACTIONS(11513),
    [anon_sym_begin] = ACTIONS(11513),
    [anon_sym_module] = ACTIONS(11513),
    [anon_sym_baremodule] = ACTIONS(11513),
    [anon_sym_end] = ACTIONS(11513),
    [anon_sym_abstract] = ACTIONS(11513),
    [anon_sym_primitive] = ACTIONS(11513),
    [anon_sym_mutable] = ACTIONS(11513),
    [anon_sym_struct] = ACTIONS(11513),
    [anon_sym_function] = ACTIONS(11513),
    [anon_sym_macro] = ACTIONS(11513),
    [anon_sym_quote] = ACTIONS(11513),
    [anon_sym_let] = ACTIONS(11513),
    [anon_sym_if] = ACTIONS(11513),
    [anon_sym_try] = ACTIONS(11513),
    [anon_sym_for] = ACTIONS(11513),
    [anon_sym_while] = ACTIONS(11513),
    [sym_break_statement] = ACTIONS(11513),
    [sym_continue_statement] = ACTIONS(11513),
    [anon_sym_return] = ACTIONS(11513),
    [anon_sym_const] = ACTIONS(11513),
    [anon_sym_global] = ACTIONS(11513),
    [anon_sym_local] = ACTIONS(11513),
    [anon_sym_LPAREN] = ACTIONS(11515),
    [anon_sym_COLON] = ACTIONS(11513),
    [anon_sym_export] = ACTIONS(11513),
    [anon_sym_public] = ACTIONS(11513),
    [anon_sym_import] = ACTIONS(11513),
    [anon_sym_using] = ACTIONS(11513),
    [anon_sym_LBRACK] = ACTIONS(11515),
    [anon_sym_in] = ACTIONS(11513),
    [anon_sym_LBRACE] = ACTIONS(11515),
    [anon_sym_DOLLAR] = ACTIONS(11515),
    [anon_sym_COLON2] = ACTIONS(11513),
    [anon_sym_COLON_COLON] = ACTIONS(11515),
    [anon_sym_isa] = ACTIONS(11513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11515),
    [anon_sym_QMARK] = ACTIONS(11515),
    [anon_sym_where] = ACTIONS(11513),
    [anon_sym_AT] = ACTIONS(11515),
    [anon_sym_true] = ACTIONS(11513),
    [anon_sym_false] = ACTIONS(11513),
    [aux_sym_integer_literal_token1] = ACTIONS(11515),
    [aux_sym_integer_literal_token2] = ACTIONS(11515),
    [aux_sym_integer_literal_token3] = ACTIONS(11513),
    [aux_sym_integer_literal_token4] = ACTIONS(11513),
    [aux_sym_float_literal_token1] = ACTIONS(11515),
    [aux_sym_float_literal_token3] = ACTIONS(11515),
    [aux_sym_float_literal_token4] = ACTIONS(11515),
    [sym_character_literal] = ACTIONS(11515),
    [anon_sym_DQUOTE] = ACTIONS(11513),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11515),
    [anon_sym_BQUOTE] = ACTIONS(11513),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11515),
    [sym__pair_operator] = ACTIONS(11515),
    [sym__arrow_operator] = ACTIONS(11513),
    [sym__lazy_or_operator] = ACTIONS(11515),
    [sym__lazy_and_operator] = ACTIONS(11515),
    [sym__comparison_operator] = ACTIONS(11513),
    [sym__pipe_right_operator] = ACTIONS(11515),
    [sym__pipe_left_operator] = ACTIONS(11515),
    [sym__ellipsis_operator] = ACTIONS(11513),
    [sym__plus_operator] = ACTIONS(11513),
    [sym__times_operator] = ACTIONS(11513),
    [sym__rational_operator] = ACTIONS(11515),
    [sym__bitshift_operator] = ACTIONS(11515),
    [sym__power_operator] = ACTIONS(11515),
    [sym__tilde_operator] = ACTIONS(11515),
    [sym__type_order_operator] = ACTIONS(11515),
    [sym__unary_operator] = ACTIONS(11513),
    [sym__unary_plus_operator] = ACTIONS(11513),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9185] = {
    [sym_block_comment] = STATE(9185),
    [sym_line_comment] = STATE(9185),
    [sym__word_identifier] = ACTIONS(11526),
    [anon_sym_COMMA] = ACTIONS(11528),
    [anon_sym_EQ] = ACTIONS(11526),
    [anon_sym_begin] = ACTIONS(11526),
    [anon_sym_module] = ACTIONS(11526),
    [anon_sym_baremodule] = ACTIONS(11526),
    [anon_sym_end] = ACTIONS(11526),
    [anon_sym_abstract] = ACTIONS(11526),
    [anon_sym_primitive] = ACTIONS(11526),
    [anon_sym_mutable] = ACTIONS(11526),
    [anon_sym_struct] = ACTIONS(11526),
    [anon_sym_function] = ACTIONS(11526),
    [anon_sym_macro] = ACTIONS(11526),
    [anon_sym_quote] = ACTIONS(11526),
    [anon_sym_let] = ACTIONS(11526),
    [anon_sym_if] = ACTIONS(11526),
    [anon_sym_try] = ACTIONS(11526),
    [anon_sym_for] = ACTIONS(11526),
    [anon_sym_while] = ACTIONS(11526),
    [sym_break_statement] = ACTIONS(11526),
    [sym_continue_statement] = ACTIONS(11526),
    [anon_sym_return] = ACTIONS(11526),
    [anon_sym_const] = ACTIONS(11526),
    [anon_sym_global] = ACTIONS(11526),
    [anon_sym_local] = ACTIONS(11526),
    [anon_sym_LPAREN] = ACTIONS(11528),
    [anon_sym_COLON] = ACTIONS(11526),
    [anon_sym_export] = ACTIONS(11526),
    [anon_sym_public] = ACTIONS(11526),
    [anon_sym_import] = ACTIONS(11526),
    [anon_sym_using] = ACTIONS(11526),
    [anon_sym_LBRACK] = ACTIONS(11528),
    [anon_sym_in] = ACTIONS(11526),
    [anon_sym_LBRACE] = ACTIONS(11528),
    [anon_sym_DOLLAR] = ACTIONS(11528),
    [anon_sym_COLON2] = ACTIONS(11526),
    [anon_sym_COLON_COLON] = ACTIONS(11528),
    [anon_sym_isa] = ACTIONS(11526),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11528),
    [anon_sym_QMARK] = ACTIONS(11528),
    [anon_sym_where] = ACTIONS(11526),
    [anon_sym_AT] = ACTIONS(11528),
    [anon_sym_true] = ACTIONS(11526),
    [anon_sym_false] = ACTIONS(11526),
    [aux_sym_integer_literal_token1] = ACTIONS(11528),
    [aux_sym_integer_literal_token2] = ACTIONS(11528),
    [aux_sym_integer_literal_token3] = ACTIONS(11526),
    [aux_sym_integer_literal_token4] = ACTIONS(11526),
    [aux_sym_float_literal_token1] = ACTIONS(11528),
    [aux_sym_float_literal_token3] = ACTIONS(11528),
    [aux_sym_float_literal_token4] = ACTIONS(11528),
    [sym_character_literal] = ACTIONS(11528),
    [anon_sym_DQUOTE] = ACTIONS(11526),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11528),
    [anon_sym_BQUOTE] = ACTIONS(11526),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11528),
    [sym__pair_operator] = ACTIONS(11528),
    [sym__arrow_operator] = ACTIONS(11526),
    [sym__lazy_or_operator] = ACTIONS(11528),
    [sym__lazy_and_operator] = ACTIONS(11528),
    [sym__comparison_operator] = ACTIONS(11526),
    [sym__pipe_right_operator] = ACTIONS(11528),
    [sym__pipe_left_operator] = ACTIONS(11528),
    [sym__ellipsis_operator] = ACTIONS(11526),
    [sym__plus_operator] = ACTIONS(11526),
    [sym__times_operator] = ACTIONS(11526),
    [sym__rational_operator] = ACTIONS(11528),
    [sym__bitshift_operator] = ACTIONS(11528),
    [sym__power_operator] = ACTIONS(11528),
    [sym__tilde_operator] = ACTIONS(11528),
    [sym__type_order_operator] = ACTIONS(11528),
    [sym__unary_operator] = ACTIONS(11526),
    [sym__unary_plus_operator] = ACTIONS(11526),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9186] = {
    [sym_block_comment] = STATE(9186),
    [sym_line_comment] = STATE(9186),
    [sym__word_identifier] = ACTIONS(11530),
    [anon_sym_COMMA] = ACTIONS(11532),
    [anon_sym_EQ] = ACTIONS(11530),
    [anon_sym_begin] = ACTIONS(11530),
    [anon_sym_module] = ACTIONS(11530),
    [anon_sym_baremodule] = ACTIONS(11530),
    [anon_sym_end] = ACTIONS(11530),
    [anon_sym_abstract] = ACTIONS(11530),
    [anon_sym_primitive] = ACTIONS(11530),
    [anon_sym_mutable] = ACTIONS(11530),
    [anon_sym_struct] = ACTIONS(11530),
    [anon_sym_function] = ACTIONS(11530),
    [anon_sym_macro] = ACTIONS(11530),
    [anon_sym_quote] = ACTIONS(11530),
    [anon_sym_let] = ACTIONS(11530),
    [anon_sym_if] = ACTIONS(11530),
    [anon_sym_try] = ACTIONS(11530),
    [anon_sym_for] = ACTIONS(11530),
    [anon_sym_while] = ACTIONS(11530),
    [sym_break_statement] = ACTIONS(11530),
    [sym_continue_statement] = ACTIONS(11530),
    [anon_sym_return] = ACTIONS(11530),
    [anon_sym_const] = ACTIONS(11530),
    [anon_sym_global] = ACTIONS(11530),
    [anon_sym_local] = ACTIONS(11530),
    [anon_sym_LPAREN] = ACTIONS(11532),
    [anon_sym_COLON] = ACTIONS(11530),
    [anon_sym_export] = ACTIONS(11530),
    [anon_sym_public] = ACTIONS(11530),
    [anon_sym_import] = ACTIONS(11530),
    [anon_sym_using] = ACTIONS(11530),
    [anon_sym_LBRACK] = ACTIONS(11532),
    [anon_sym_in] = ACTIONS(11530),
    [anon_sym_LBRACE] = ACTIONS(11532),
    [anon_sym_DOLLAR] = ACTIONS(11532),
    [anon_sym_COLON2] = ACTIONS(11530),
    [anon_sym_COLON_COLON] = ACTIONS(11532),
    [anon_sym_isa] = ACTIONS(11530),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11532),
    [anon_sym_QMARK] = ACTIONS(11532),
    [anon_sym_where] = ACTIONS(11530),
    [anon_sym_AT] = ACTIONS(11532),
    [anon_sym_true] = ACTIONS(11530),
    [anon_sym_false] = ACTIONS(11530),
    [aux_sym_integer_literal_token1] = ACTIONS(11532),
    [aux_sym_integer_literal_token2] = ACTIONS(11532),
    [aux_sym_integer_literal_token3] = ACTIONS(11530),
    [aux_sym_integer_literal_token4] = ACTIONS(11530),
    [aux_sym_float_literal_token1] = ACTIONS(11532),
    [aux_sym_float_literal_token3] = ACTIONS(11532),
    [aux_sym_float_literal_token4] = ACTIONS(11532),
    [sym_character_literal] = ACTIONS(11532),
    [anon_sym_DQUOTE] = ACTIONS(11530),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11532),
    [anon_sym_BQUOTE] = ACTIONS(11530),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11532),
    [sym__pair_operator] = ACTIONS(11532),
    [sym__arrow_operator] = ACTIONS(11530),
    [sym__lazy_or_operator] = ACTIONS(11532),
    [sym__lazy_and_operator] = ACTIONS(11532),
    [sym__comparison_operator] = ACTIONS(11530),
    [sym__pipe_right_operator] = ACTIONS(11532),
    [sym__pipe_left_operator] = ACTIONS(11532),
    [sym__ellipsis_operator] = ACTIONS(11530),
    [sym__plus_operator] = ACTIONS(11530),
    [sym__times_operator] = ACTIONS(11530),
    [sym__rational_operator] = ACTIONS(11532),
    [sym__bitshift_operator] = ACTIONS(11532),
    [sym__power_operator] = ACTIONS(11532),
    [sym__tilde_operator] = ACTIONS(11532),
    [sym__type_order_operator] = ACTIONS(11532),
    [sym__unary_operator] = ACTIONS(11530),
    [sym__unary_plus_operator] = ACTIONS(11530),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9187] = {
    [sym_block_comment] = STATE(9187),
    [sym_line_comment] = STATE(9187),
    [sym__word_identifier] = ACTIONS(11534),
    [anon_sym_COMMA] = ACTIONS(11536),
    [anon_sym_EQ] = ACTIONS(11534),
    [anon_sym_begin] = ACTIONS(11534),
    [anon_sym_module] = ACTIONS(11534),
    [anon_sym_baremodule] = ACTIONS(11534),
    [anon_sym_end] = ACTIONS(11534),
    [anon_sym_abstract] = ACTIONS(11534),
    [anon_sym_primitive] = ACTIONS(11534),
    [anon_sym_mutable] = ACTIONS(11534),
    [anon_sym_struct] = ACTIONS(11534),
    [anon_sym_function] = ACTIONS(11534),
    [anon_sym_macro] = ACTIONS(11534),
    [anon_sym_quote] = ACTIONS(11534),
    [anon_sym_let] = ACTIONS(11534),
    [anon_sym_if] = ACTIONS(11534),
    [anon_sym_try] = ACTIONS(11534),
    [anon_sym_for] = ACTIONS(11534),
    [anon_sym_while] = ACTIONS(11534),
    [sym_break_statement] = ACTIONS(11534),
    [sym_continue_statement] = ACTIONS(11534),
    [anon_sym_return] = ACTIONS(11534),
    [anon_sym_const] = ACTIONS(11534),
    [anon_sym_global] = ACTIONS(11534),
    [anon_sym_local] = ACTIONS(11534),
    [anon_sym_LPAREN] = ACTIONS(11536),
    [anon_sym_COLON] = ACTIONS(11534),
    [anon_sym_export] = ACTIONS(11534),
    [anon_sym_public] = ACTIONS(11534),
    [anon_sym_import] = ACTIONS(11534),
    [anon_sym_using] = ACTIONS(11534),
    [anon_sym_LBRACK] = ACTIONS(11536),
    [anon_sym_in] = ACTIONS(11534),
    [anon_sym_LBRACE] = ACTIONS(11536),
    [anon_sym_DOLLAR] = ACTIONS(11536),
    [anon_sym_COLON2] = ACTIONS(11534),
    [anon_sym_COLON_COLON] = ACTIONS(11536),
    [anon_sym_isa] = ACTIONS(11534),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11536),
    [anon_sym_QMARK] = ACTIONS(11536),
    [anon_sym_where] = ACTIONS(11534),
    [anon_sym_AT] = ACTIONS(11536),
    [anon_sym_true] = ACTIONS(11534),
    [anon_sym_false] = ACTIONS(11534),
    [aux_sym_integer_literal_token1] = ACTIONS(11536),
    [aux_sym_integer_literal_token2] = ACTIONS(11536),
    [aux_sym_integer_literal_token3] = ACTIONS(11534),
    [aux_sym_integer_literal_token4] = ACTIONS(11534),
    [aux_sym_float_literal_token1] = ACTIONS(11536),
    [aux_sym_float_literal_token3] = ACTIONS(11536),
    [aux_sym_float_literal_token4] = ACTIONS(11536),
    [sym_character_literal] = ACTIONS(11536),
    [anon_sym_DQUOTE] = ACTIONS(11534),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11536),
    [anon_sym_BQUOTE] = ACTIONS(11534),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11536),
    [sym__pair_operator] = ACTIONS(11536),
    [sym__arrow_operator] = ACTIONS(11534),
    [sym__lazy_or_operator] = ACTIONS(11536),
    [sym__lazy_and_operator] = ACTIONS(11536),
    [sym__comparison_operator] = ACTIONS(11534),
    [sym__pipe_right_operator] = ACTIONS(11536),
    [sym__pipe_left_operator] = ACTIONS(11536),
    [sym__ellipsis_operator] = ACTIONS(11534),
    [sym__plus_operator] = ACTIONS(11534),
    [sym__times_operator] = ACTIONS(11534),
    [sym__rational_operator] = ACTIONS(11536),
    [sym__bitshift_operator] = ACTIONS(11536),
    [sym__power_operator] = ACTIONS(11536),
    [sym__tilde_operator] = ACTIONS(11536),
    [sym__type_order_operator] = ACTIONS(11536),
    [sym__unary_operator] = ACTIONS(11534),
    [sym__unary_plus_operator] = ACTIONS(11534),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9188] = {
    [sym_block_comment] = STATE(9188),
    [sym_line_comment] = STATE(9188),
    [sym__word_identifier] = ACTIONS(11548),
    [anon_sym_COMMA] = ACTIONS(11550),
    [anon_sym_EQ] = ACTIONS(11548),
    [anon_sym_begin] = ACTIONS(11548),
    [anon_sym_module] = ACTIONS(11548),
    [anon_sym_baremodule] = ACTIONS(11548),
    [anon_sym_end] = ACTIONS(11548),
    [anon_sym_abstract] = ACTIONS(11548),
    [anon_sym_primitive] = ACTIONS(11548),
    [anon_sym_mutable] = ACTIONS(11548),
    [anon_sym_struct] = ACTIONS(11548),
    [anon_sym_function] = ACTIONS(11548),
    [anon_sym_macro] = ACTIONS(11548),
    [anon_sym_quote] = ACTIONS(11548),
    [anon_sym_let] = ACTIONS(11548),
    [anon_sym_if] = ACTIONS(11548),
    [anon_sym_try] = ACTIONS(11548),
    [anon_sym_for] = ACTIONS(11548),
    [anon_sym_while] = ACTIONS(11548),
    [sym_break_statement] = ACTIONS(11548),
    [sym_continue_statement] = ACTIONS(11548),
    [anon_sym_return] = ACTIONS(11548),
    [anon_sym_const] = ACTIONS(11548),
    [anon_sym_global] = ACTIONS(11548),
    [anon_sym_local] = ACTIONS(11548),
    [anon_sym_LPAREN] = ACTIONS(11550),
    [anon_sym_COLON] = ACTIONS(11548),
    [anon_sym_export] = ACTIONS(11548),
    [anon_sym_public] = ACTIONS(11548),
    [anon_sym_import] = ACTIONS(11548),
    [anon_sym_using] = ACTIONS(11548),
    [anon_sym_LBRACK] = ACTIONS(11550),
    [anon_sym_in] = ACTIONS(11548),
    [anon_sym_LBRACE] = ACTIONS(11550),
    [anon_sym_DOLLAR] = ACTIONS(11550),
    [anon_sym_COLON2] = ACTIONS(11548),
    [anon_sym_COLON_COLON] = ACTIONS(11550),
    [anon_sym_isa] = ACTIONS(11548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11550),
    [anon_sym_QMARK] = ACTIONS(11550),
    [anon_sym_where] = ACTIONS(11548),
    [anon_sym_AT] = ACTIONS(11550),
    [anon_sym_true] = ACTIONS(11548),
    [anon_sym_false] = ACTIONS(11548),
    [aux_sym_integer_literal_token1] = ACTIONS(11550),
    [aux_sym_integer_literal_token2] = ACTIONS(11550),
    [aux_sym_integer_literal_token3] = ACTIONS(11548),
    [aux_sym_integer_literal_token4] = ACTIONS(11548),
    [aux_sym_float_literal_token1] = ACTIONS(11550),
    [aux_sym_float_literal_token3] = ACTIONS(11550),
    [aux_sym_float_literal_token4] = ACTIONS(11550),
    [sym_character_literal] = ACTIONS(11550),
    [anon_sym_DQUOTE] = ACTIONS(11548),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11550),
    [anon_sym_BQUOTE] = ACTIONS(11548),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11550),
    [sym__pair_operator] = ACTIONS(11550),
    [sym__arrow_operator] = ACTIONS(11548),
    [sym__lazy_or_operator] = ACTIONS(11550),
    [sym__lazy_and_operator] = ACTIONS(11550),
    [sym__comparison_operator] = ACTIONS(11548),
    [sym__pipe_right_operator] = ACTIONS(11550),
    [sym__pipe_left_operator] = ACTIONS(11550),
    [sym__ellipsis_operator] = ACTIONS(11548),
    [sym__plus_operator] = ACTIONS(11548),
    [sym__times_operator] = ACTIONS(11548),
    [sym__rational_operator] = ACTIONS(11550),
    [sym__bitshift_operator] = ACTIONS(11550),
    [sym__power_operator] = ACTIONS(11550),
    [sym__tilde_operator] = ACTIONS(11550),
    [sym__type_order_operator] = ACTIONS(11550),
    [sym__unary_operator] = ACTIONS(11548),
    [sym__unary_plus_operator] = ACTIONS(11548),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9189] = {
    [sym_block_comment] = STATE(9189),
    [sym_line_comment] = STATE(9189),
    [sym__word_identifier] = ACTIONS(11552),
    [anon_sym_COMMA] = ACTIONS(11554),
    [anon_sym_EQ] = ACTIONS(11552),
    [anon_sym_begin] = ACTIONS(11552),
    [anon_sym_module] = ACTIONS(11552),
    [anon_sym_baremodule] = ACTIONS(11552),
    [anon_sym_end] = ACTIONS(11552),
    [anon_sym_abstract] = ACTIONS(11552),
    [anon_sym_primitive] = ACTIONS(11552),
    [anon_sym_mutable] = ACTIONS(11552),
    [anon_sym_struct] = ACTIONS(11552),
    [anon_sym_function] = ACTIONS(11552),
    [anon_sym_macro] = ACTIONS(11552),
    [anon_sym_quote] = ACTIONS(11552),
    [anon_sym_let] = ACTIONS(11552),
    [anon_sym_if] = ACTIONS(11552),
    [anon_sym_try] = ACTIONS(11552),
    [anon_sym_for] = ACTIONS(11552),
    [anon_sym_while] = ACTIONS(11552),
    [sym_break_statement] = ACTIONS(11552),
    [sym_continue_statement] = ACTIONS(11552),
    [anon_sym_return] = ACTIONS(11552),
    [anon_sym_const] = ACTIONS(11552),
    [anon_sym_global] = ACTIONS(11552),
    [anon_sym_local] = ACTIONS(11552),
    [anon_sym_LPAREN] = ACTIONS(11554),
    [anon_sym_COLON] = ACTIONS(11552),
    [anon_sym_export] = ACTIONS(11552),
    [anon_sym_public] = ACTIONS(11552),
    [anon_sym_import] = ACTIONS(11552),
    [anon_sym_using] = ACTIONS(11552),
    [anon_sym_LBRACK] = ACTIONS(11554),
    [anon_sym_in] = ACTIONS(11552),
    [anon_sym_LBRACE] = ACTIONS(11554),
    [anon_sym_DOLLAR] = ACTIONS(11554),
    [anon_sym_COLON2] = ACTIONS(11552),
    [anon_sym_COLON_COLON] = ACTIONS(11554),
    [anon_sym_isa] = ACTIONS(11552),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11554),
    [anon_sym_QMARK] = ACTIONS(11554),
    [anon_sym_where] = ACTIONS(11552),
    [anon_sym_AT] = ACTIONS(11554),
    [anon_sym_true] = ACTIONS(11552),
    [anon_sym_false] = ACTIONS(11552),
    [aux_sym_integer_literal_token1] = ACTIONS(11554),
    [aux_sym_integer_literal_token2] = ACTIONS(11554),
    [aux_sym_integer_literal_token3] = ACTIONS(11552),
    [aux_sym_integer_literal_token4] = ACTIONS(11552),
    [aux_sym_float_literal_token1] = ACTIONS(11554),
    [aux_sym_float_literal_token3] = ACTIONS(11554),
    [aux_sym_float_literal_token4] = ACTIONS(11554),
    [sym_character_literal] = ACTIONS(11554),
    [anon_sym_DQUOTE] = ACTIONS(11552),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11554),
    [anon_sym_BQUOTE] = ACTIONS(11552),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11554),
    [sym__pair_operator] = ACTIONS(11554),
    [sym__arrow_operator] = ACTIONS(11552),
    [sym__lazy_or_operator] = ACTIONS(11554),
    [sym__lazy_and_operator] = ACTIONS(11554),
    [sym__comparison_operator] = ACTIONS(11552),
    [sym__pipe_right_operator] = ACTIONS(11554),
    [sym__pipe_left_operator] = ACTIONS(11554),
    [sym__ellipsis_operator] = ACTIONS(11552),
    [sym__plus_operator] = ACTIONS(11552),
    [sym__times_operator] = ACTIONS(11552),
    [sym__rational_operator] = ACTIONS(11554),
    [sym__bitshift_operator] = ACTIONS(11554),
    [sym__power_operator] = ACTIONS(11554),
    [sym__tilde_operator] = ACTIONS(11554),
    [sym__type_order_operator] = ACTIONS(11554),
    [sym__unary_operator] = ACTIONS(11552),
    [sym__unary_plus_operator] = ACTIONS(11552),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9190] = {
    [sym_block_comment] = STATE(9190),
    [sym_line_comment] = STATE(9190),
    [sym__word_identifier] = ACTIONS(11563),
    [anon_sym_COMMA] = ACTIONS(11565),
    [anon_sym_EQ] = ACTIONS(11563),
    [anon_sym_begin] = ACTIONS(11563),
    [anon_sym_module] = ACTIONS(11563),
    [anon_sym_baremodule] = ACTIONS(11563),
    [anon_sym_end] = ACTIONS(11563),
    [anon_sym_abstract] = ACTIONS(11563),
    [anon_sym_primitive] = ACTIONS(11563),
    [anon_sym_mutable] = ACTIONS(11563),
    [anon_sym_struct] = ACTIONS(11563),
    [anon_sym_function] = ACTIONS(11563),
    [anon_sym_macro] = ACTIONS(11563),
    [anon_sym_quote] = ACTIONS(11563),
    [anon_sym_let] = ACTIONS(11563),
    [anon_sym_if] = ACTIONS(11563),
    [anon_sym_try] = ACTIONS(11563),
    [anon_sym_for] = ACTIONS(11563),
    [anon_sym_while] = ACTIONS(11563),
    [sym_break_statement] = ACTIONS(11563),
    [sym_continue_statement] = ACTIONS(11563),
    [anon_sym_return] = ACTIONS(11563),
    [anon_sym_const] = ACTIONS(11563),
    [anon_sym_global] = ACTIONS(11563),
    [anon_sym_local] = ACTIONS(11563),
    [anon_sym_LPAREN] = ACTIONS(11565),
    [anon_sym_COLON] = ACTIONS(11563),
    [anon_sym_export] = ACTIONS(11563),
    [anon_sym_public] = ACTIONS(11563),
    [anon_sym_import] = ACTIONS(11563),
    [anon_sym_using] = ACTIONS(11563),
    [anon_sym_LBRACK] = ACTIONS(11565),
    [anon_sym_in] = ACTIONS(11563),
    [anon_sym_LBRACE] = ACTIONS(11565),
    [anon_sym_DOLLAR] = ACTIONS(11565),
    [anon_sym_COLON2] = ACTIONS(11563),
    [anon_sym_COLON_COLON] = ACTIONS(11565),
    [anon_sym_isa] = ACTIONS(11563),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11565),
    [anon_sym_QMARK] = ACTIONS(11565),
    [anon_sym_where] = ACTIONS(11563),
    [anon_sym_AT] = ACTIONS(11565),
    [anon_sym_true] = ACTIONS(11563),
    [anon_sym_false] = ACTIONS(11563),
    [aux_sym_integer_literal_token1] = ACTIONS(11565),
    [aux_sym_integer_literal_token2] = ACTIONS(11565),
    [aux_sym_integer_literal_token3] = ACTIONS(11563),
    [aux_sym_integer_literal_token4] = ACTIONS(11563),
    [aux_sym_float_literal_token1] = ACTIONS(11565),
    [aux_sym_float_literal_token3] = ACTIONS(11565),
    [aux_sym_float_literal_token4] = ACTIONS(11565),
    [sym_character_literal] = ACTIONS(11565),
    [anon_sym_DQUOTE] = ACTIONS(11563),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11565),
    [anon_sym_BQUOTE] = ACTIONS(11563),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11565),
    [sym__pair_operator] = ACTIONS(11565),
    [sym__arrow_operator] = ACTIONS(11563),
    [sym__lazy_or_operator] = ACTIONS(11565),
    [sym__lazy_and_operator] = ACTIONS(11565),
    [sym__comparison_operator] = ACTIONS(11563),
    [sym__pipe_right_operator] = ACTIONS(11565),
    [sym__pipe_left_operator] = ACTIONS(11565),
    [sym__ellipsis_operator] = ACTIONS(11563),
    [sym__plus_operator] = ACTIONS(11563),
    [sym__times_operator] = ACTIONS(11563),
    [sym__rational_operator] = ACTIONS(11565),
    [sym__bitshift_operator] = ACTIONS(11565),
    [sym__power_operator] = ACTIONS(11565),
    [sym__tilde_operator] = ACTIONS(11565),
    [sym__type_order_operator] = ACTIONS(11565),
    [sym__unary_operator] = ACTIONS(11563),
    [sym__unary_plus_operator] = ACTIONS(11563),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9191] = {
    [sym_block_comment] = STATE(9191),
    [sym_line_comment] = STATE(9191),
    [sym__word_identifier] = ACTIONS(11567),
    [anon_sym_COMMA] = ACTIONS(11569),
    [anon_sym_EQ] = ACTIONS(11567),
    [anon_sym_begin] = ACTIONS(11567),
    [anon_sym_module] = ACTIONS(11567),
    [anon_sym_baremodule] = ACTIONS(11567),
    [anon_sym_end] = ACTIONS(11567),
    [anon_sym_abstract] = ACTIONS(11567),
    [anon_sym_primitive] = ACTIONS(11567),
    [anon_sym_mutable] = ACTIONS(11567),
    [anon_sym_struct] = ACTIONS(11567),
    [anon_sym_function] = ACTIONS(11567),
    [anon_sym_macro] = ACTIONS(11567),
    [anon_sym_quote] = ACTIONS(11567),
    [anon_sym_let] = ACTIONS(11567),
    [anon_sym_if] = ACTIONS(11567),
    [anon_sym_try] = ACTIONS(11567),
    [anon_sym_for] = ACTIONS(11567),
    [anon_sym_while] = ACTIONS(11567),
    [sym_break_statement] = ACTIONS(11567),
    [sym_continue_statement] = ACTIONS(11567),
    [anon_sym_return] = ACTIONS(11567),
    [anon_sym_const] = ACTIONS(11567),
    [anon_sym_global] = ACTIONS(11567),
    [anon_sym_local] = ACTIONS(11567),
    [anon_sym_LPAREN] = ACTIONS(11569),
    [anon_sym_COLON] = ACTIONS(11567),
    [anon_sym_export] = ACTIONS(11567),
    [anon_sym_public] = ACTIONS(11567),
    [anon_sym_import] = ACTIONS(11567),
    [anon_sym_using] = ACTIONS(11567),
    [anon_sym_LBRACK] = ACTIONS(11569),
    [anon_sym_in] = ACTIONS(11567),
    [anon_sym_LBRACE] = ACTIONS(11569),
    [anon_sym_DOLLAR] = ACTIONS(11569),
    [anon_sym_COLON2] = ACTIONS(11567),
    [anon_sym_COLON_COLON] = ACTIONS(11569),
    [anon_sym_isa] = ACTIONS(11567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11569),
    [anon_sym_QMARK] = ACTIONS(11569),
    [anon_sym_where] = ACTIONS(11567),
    [anon_sym_AT] = ACTIONS(11569),
    [anon_sym_true] = ACTIONS(11567),
    [anon_sym_false] = ACTIONS(11567),
    [aux_sym_integer_literal_token1] = ACTIONS(11569),
    [aux_sym_integer_literal_token2] = ACTIONS(11569),
    [aux_sym_integer_literal_token3] = ACTIONS(11567),
    [aux_sym_integer_literal_token4] = ACTIONS(11567),
    [aux_sym_float_literal_token1] = ACTIONS(11569),
    [aux_sym_float_literal_token3] = ACTIONS(11569),
    [aux_sym_float_literal_token4] = ACTIONS(11569),
    [sym_character_literal] = ACTIONS(11569),
    [anon_sym_DQUOTE] = ACTIONS(11567),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11569),
    [anon_sym_BQUOTE] = ACTIONS(11567),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11569),
    [sym__pair_operator] = ACTIONS(11569),
    [sym__arrow_operator] = ACTIONS(11567),
    [sym__lazy_or_operator] = ACTIONS(11569),
    [sym__lazy_and_operator] = ACTIONS(11569),
    [sym__comparison_operator] = ACTIONS(11567),
    [sym__pipe_right_operator] = ACTIONS(11569),
    [sym__pipe_left_operator] = ACTIONS(11569),
    [sym__ellipsis_operator] = ACTIONS(11567),
    [sym__plus_operator] = ACTIONS(11567),
    [sym__times_operator] = ACTIONS(11567),
    [sym__rational_operator] = ACTIONS(11569),
    [sym__bitshift_operator] = ACTIONS(11569),
    [sym__power_operator] = ACTIONS(11569),
    [sym__tilde_operator] = ACTIONS(11569),
    [sym__type_order_operator] = ACTIONS(11569),
    [sym__unary_operator] = ACTIONS(11567),
    [sym__unary_plus_operator] = ACTIONS(11567),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9192] = {
    [sym_block_comment] = STATE(9192),
    [sym_line_comment] = STATE(9192),
    [sym__word_identifier] = ACTIONS(11571),
    [anon_sym_COMMA] = ACTIONS(11573),
    [anon_sym_EQ] = ACTIONS(11571),
    [anon_sym_begin] = ACTIONS(11571),
    [anon_sym_module] = ACTIONS(11571),
    [anon_sym_baremodule] = ACTIONS(11571),
    [anon_sym_end] = ACTIONS(11571),
    [anon_sym_abstract] = ACTIONS(11571),
    [anon_sym_primitive] = ACTIONS(11571),
    [anon_sym_mutable] = ACTIONS(11571),
    [anon_sym_struct] = ACTIONS(11571),
    [anon_sym_function] = ACTIONS(11571),
    [anon_sym_macro] = ACTIONS(11571),
    [anon_sym_quote] = ACTIONS(11571),
    [anon_sym_let] = ACTIONS(11571),
    [anon_sym_if] = ACTIONS(11571),
    [anon_sym_try] = ACTIONS(11571),
    [anon_sym_for] = ACTIONS(11571),
    [anon_sym_while] = ACTIONS(11571),
    [sym_break_statement] = ACTIONS(11571),
    [sym_continue_statement] = ACTIONS(11571),
    [anon_sym_return] = ACTIONS(11571),
    [anon_sym_const] = ACTIONS(11571),
    [anon_sym_global] = ACTIONS(11571),
    [anon_sym_local] = ACTIONS(11571),
    [anon_sym_LPAREN] = ACTIONS(11573),
    [anon_sym_COLON] = ACTIONS(11571),
    [anon_sym_export] = ACTIONS(11571),
    [anon_sym_public] = ACTIONS(11571),
    [anon_sym_import] = ACTIONS(11571),
    [anon_sym_using] = ACTIONS(11571),
    [anon_sym_LBRACK] = ACTIONS(11573),
    [anon_sym_in] = ACTIONS(11571),
    [anon_sym_LBRACE] = ACTIONS(11573),
    [anon_sym_DOLLAR] = ACTIONS(11573),
    [anon_sym_COLON2] = ACTIONS(11571),
    [anon_sym_COLON_COLON] = ACTIONS(11573),
    [anon_sym_isa] = ACTIONS(11571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11573),
    [anon_sym_QMARK] = ACTIONS(11573),
    [anon_sym_where] = ACTIONS(11571),
    [anon_sym_AT] = ACTIONS(11573),
    [anon_sym_true] = ACTIONS(11571),
    [anon_sym_false] = ACTIONS(11571),
    [aux_sym_integer_literal_token1] = ACTIONS(11573),
    [aux_sym_integer_literal_token2] = ACTIONS(11573),
    [aux_sym_integer_literal_token3] = ACTIONS(11571),
    [aux_sym_integer_literal_token4] = ACTIONS(11571),
    [aux_sym_float_literal_token1] = ACTIONS(11573),
    [aux_sym_float_literal_token3] = ACTIONS(11573),
    [aux_sym_float_literal_token4] = ACTIONS(11573),
    [sym_character_literal] = ACTIONS(11573),
    [anon_sym_DQUOTE] = ACTIONS(11571),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11573),
    [anon_sym_BQUOTE] = ACTIONS(11571),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11573),
    [sym__pair_operator] = ACTIONS(11573),
    [sym__arrow_operator] = ACTIONS(11571),
    [sym__lazy_or_operator] = ACTIONS(11573),
    [sym__lazy_and_operator] = ACTIONS(11573),
    [sym__comparison_operator] = ACTIONS(11571),
    [sym__pipe_right_operator] = ACTIONS(11573),
    [sym__pipe_left_operator] = ACTIONS(11573),
    [sym__ellipsis_operator] = ACTIONS(11571),
    [sym__plus_operator] = ACTIONS(11571),
    [sym__times_operator] = ACTIONS(11571),
    [sym__rational_operator] = ACTIONS(11573),
    [sym__bitshift_operator] = ACTIONS(11573),
    [sym__power_operator] = ACTIONS(11573),
    [sym__tilde_operator] = ACTIONS(11573),
    [sym__type_order_operator] = ACTIONS(11573),
    [sym__unary_operator] = ACTIONS(11571),
    [sym__unary_plus_operator] = ACTIONS(11571),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9193] = {
    [sym_block_comment] = STATE(9193),
    [sym_line_comment] = STATE(9193),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9194] = {
    [sym_block_comment] = STATE(9194),
    [sym_line_comment] = STATE(9194),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(11110),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9195] = {
    [sym_block_comment] = STATE(9195),
    [sym_line_comment] = STATE(9195),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(11247),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(11247),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11249),
    [anon_sym_isa] = ACTIONS(11247),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11249),
    [anon_sym_QMARK] = ACTIONS(11249),
    [anon_sym_where] = ACTIONS(11247),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(11249),
    [sym__arrow_operator] = ACTIONS(11247),
    [sym__lazy_or_operator] = ACTIONS(11249),
    [sym__lazy_and_operator] = ACTIONS(11249),
    [sym__comparison_operator] = ACTIONS(11247),
    [sym__pipe_right_operator] = ACTIONS(11249),
    [sym__pipe_left_operator] = ACTIONS(11249),
    [sym__ellipsis_operator] = ACTIONS(11247),
    [sym__plus_operator] = ACTIONS(11247),
    [sym__times_operator] = ACTIONS(11247),
    [sym__rational_operator] = ACTIONS(11249),
    [sym__bitshift_operator] = ACTIONS(11249),
    [sym__power_operator] = ACTIONS(11249),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(11249),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9196] = {
    [sym_block_comment] = STATE(9196),
    [sym_line_comment] = STATE(9196),
    [sym__word_identifier] = ACTIONS(11331),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_EQ] = ACTIONS(11331),
    [anon_sym_begin] = ACTIONS(11331),
    [anon_sym_module] = ACTIONS(11331),
    [anon_sym_baremodule] = ACTIONS(11331),
    [anon_sym_end] = ACTIONS(11331),
    [anon_sym_abstract] = ACTIONS(11331),
    [anon_sym_primitive] = ACTIONS(11331),
    [anon_sym_mutable] = ACTIONS(11331),
    [anon_sym_struct] = ACTIONS(11331),
    [anon_sym_function] = ACTIONS(11331),
    [anon_sym_macro] = ACTIONS(11331),
    [anon_sym_quote] = ACTIONS(11331),
    [anon_sym_let] = ACTIONS(11331),
    [anon_sym_if] = ACTIONS(11331),
    [anon_sym_try] = ACTIONS(11331),
    [anon_sym_for] = ACTIONS(11331),
    [anon_sym_while] = ACTIONS(11331),
    [sym_break_statement] = ACTIONS(11331),
    [sym_continue_statement] = ACTIONS(11331),
    [anon_sym_return] = ACTIONS(11331),
    [anon_sym_const] = ACTIONS(11331),
    [anon_sym_global] = ACTIONS(11331),
    [anon_sym_local] = ACTIONS(11331),
    [anon_sym_LPAREN] = ACTIONS(11333),
    [anon_sym_COLON] = ACTIONS(11331),
    [anon_sym_export] = ACTIONS(11331),
    [anon_sym_public] = ACTIONS(11331),
    [anon_sym_import] = ACTIONS(11331),
    [anon_sym_using] = ACTIONS(11331),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_in] = ACTIONS(11331),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_DOLLAR] = ACTIONS(11333),
    [anon_sym_COLON2] = ACTIONS(11331),
    [anon_sym_COLON_COLON] = ACTIONS(11333),
    [anon_sym_isa] = ACTIONS(11331),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_where] = ACTIONS(11331),
    [anon_sym_AT] = ACTIONS(11333),
    [anon_sym_true] = ACTIONS(11331),
    [anon_sym_false] = ACTIONS(11331),
    [aux_sym_integer_literal_token1] = ACTIONS(11333),
    [aux_sym_integer_literal_token2] = ACTIONS(11333),
    [aux_sym_integer_literal_token3] = ACTIONS(11331),
    [aux_sym_integer_literal_token4] = ACTIONS(11331),
    [aux_sym_float_literal_token1] = ACTIONS(11333),
    [aux_sym_float_literal_token3] = ACTIONS(11333),
    [aux_sym_float_literal_token4] = ACTIONS(11333),
    [sym_character_literal] = ACTIONS(11333),
    [anon_sym_DQUOTE] = ACTIONS(11331),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11333),
    [anon_sym_BQUOTE] = ACTIONS(11331),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11333),
    [sym__pair_operator] = ACTIONS(11333),
    [sym__arrow_operator] = ACTIONS(11331),
    [sym__lazy_or_operator] = ACTIONS(11333),
    [sym__lazy_and_operator] = ACTIONS(11333),
    [sym__comparison_operator] = ACTIONS(11331),
    [sym__pipe_right_operator] = ACTIONS(11333),
    [sym__pipe_left_operator] = ACTIONS(11333),
    [sym__ellipsis_operator] = ACTIONS(11331),
    [sym__plus_operator] = ACTIONS(11331),
    [sym__times_operator] = ACTIONS(11331),
    [sym__rational_operator] = ACTIONS(11333),
    [sym__bitshift_operator] = ACTIONS(11333),
    [sym__power_operator] = ACTIONS(11333),
    [sym__tilde_operator] = ACTIONS(11333),
    [sym__type_order_operator] = ACTIONS(11333),
    [sym__unary_operator] = ACTIONS(11331),
    [sym__unary_plus_operator] = ACTIONS(11331),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9197] = {
    [sym_block_comment] = STATE(9197),
    [sym_line_comment] = STATE(9197),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9198] = {
    [sym_block_comment] = STATE(9198),
    [sym_line_comment] = STATE(9198),
    [sym__word_identifier] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11337),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_begin] = ACTIONS(11335),
    [anon_sym_module] = ACTIONS(11335),
    [anon_sym_baremodule] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11335),
    [anon_sym_abstract] = ACTIONS(11335),
    [anon_sym_primitive] = ACTIONS(11335),
    [anon_sym_mutable] = ACTIONS(11335),
    [anon_sym_struct] = ACTIONS(11335),
    [anon_sym_function] = ACTIONS(11335),
    [anon_sym_macro] = ACTIONS(11335),
    [anon_sym_quote] = ACTIONS(11335),
    [anon_sym_let] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11335),
    [anon_sym_try] = ACTIONS(11335),
    [anon_sym_for] = ACTIONS(11335),
    [anon_sym_while] = ACTIONS(11335),
    [sym_break_statement] = ACTIONS(11335),
    [sym_continue_statement] = ACTIONS(11335),
    [anon_sym_return] = ACTIONS(11335),
    [anon_sym_const] = ACTIONS(11335),
    [anon_sym_global] = ACTIONS(11335),
    [anon_sym_local] = ACTIONS(11335),
    [anon_sym_LPAREN] = ACTIONS(11337),
    [anon_sym_COLON] = ACTIONS(11335),
    [anon_sym_export] = ACTIONS(11335),
    [anon_sym_public] = ACTIONS(11335),
    [anon_sym_import] = ACTIONS(11335),
    [anon_sym_using] = ACTIONS(11335),
    [anon_sym_LBRACK] = ACTIONS(11337),
    [anon_sym_in] = ACTIONS(11335),
    [anon_sym_LBRACE] = ACTIONS(11337),
    [anon_sym_DOLLAR] = ACTIONS(11337),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_COLON_COLON] = ACTIONS(11337),
    [anon_sym_isa] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11337),
    [anon_sym_QMARK] = ACTIONS(11337),
    [anon_sym_where] = ACTIONS(11335),
    [anon_sym_AT] = ACTIONS(11337),
    [anon_sym_true] = ACTIONS(11335),
    [anon_sym_false] = ACTIONS(11335),
    [aux_sym_integer_literal_token1] = ACTIONS(11337),
    [aux_sym_integer_literal_token2] = ACTIONS(11337),
    [aux_sym_integer_literal_token3] = ACTIONS(11335),
    [aux_sym_integer_literal_token4] = ACTIONS(11335),
    [aux_sym_float_literal_token1] = ACTIONS(11337),
    [aux_sym_float_literal_token3] = ACTIONS(11337),
    [aux_sym_float_literal_token4] = ACTIONS(11337),
    [sym_character_literal] = ACTIONS(11337),
    [anon_sym_DQUOTE] = ACTIONS(11335),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11337),
    [anon_sym_BQUOTE] = ACTIONS(11335),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11337),
    [sym__pair_operator] = ACTIONS(11337),
    [sym__arrow_operator] = ACTIONS(11335),
    [sym__lazy_or_operator] = ACTIONS(11337),
    [sym__lazy_and_operator] = ACTIONS(11337),
    [sym__comparison_operator] = ACTIONS(11335),
    [sym__pipe_right_operator] = ACTIONS(11337),
    [sym__pipe_left_operator] = ACTIONS(11337),
    [sym__ellipsis_operator] = ACTIONS(11335),
    [sym__plus_operator] = ACTIONS(11335),
    [sym__times_operator] = ACTIONS(11335),
    [sym__rational_operator] = ACTIONS(11337),
    [sym__bitshift_operator] = ACTIONS(11337),
    [sym__power_operator] = ACTIONS(11337),
    [sym__tilde_operator] = ACTIONS(11337),
    [sym__type_order_operator] = ACTIONS(11337),
    [sym__unary_operator] = ACTIONS(11335),
    [sym__unary_plus_operator] = ACTIONS(11335),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9199] = {
    [sym_block_comment] = STATE(9199),
    [sym_line_comment] = STATE(9199),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9200] = {
    [sym_block_comment] = STATE(9200),
    [sym_line_comment] = STATE(9200),
    [sym__word_identifier] = ACTIONS(11339),
    [anon_sym_COMMA] = ACTIONS(11341),
    [anon_sym_EQ] = ACTIONS(11339),
    [anon_sym_begin] = ACTIONS(11339),
    [anon_sym_module] = ACTIONS(11339),
    [anon_sym_baremodule] = ACTIONS(11339),
    [anon_sym_end] = ACTIONS(11339),
    [anon_sym_abstract] = ACTIONS(11339),
    [anon_sym_primitive] = ACTIONS(11339),
    [anon_sym_mutable] = ACTIONS(11339),
    [anon_sym_struct] = ACTIONS(11339),
    [anon_sym_function] = ACTIONS(11339),
    [anon_sym_macro] = ACTIONS(11339),
    [anon_sym_quote] = ACTIONS(11339),
    [anon_sym_let] = ACTIONS(11339),
    [anon_sym_if] = ACTIONS(11339),
    [anon_sym_try] = ACTIONS(11339),
    [anon_sym_for] = ACTIONS(11339),
    [anon_sym_while] = ACTIONS(11339),
    [sym_break_statement] = ACTIONS(11339),
    [sym_continue_statement] = ACTIONS(11339),
    [anon_sym_return] = ACTIONS(11339),
    [anon_sym_const] = ACTIONS(11339),
    [anon_sym_global] = ACTIONS(11339),
    [anon_sym_local] = ACTIONS(11339),
    [anon_sym_LPAREN] = ACTIONS(11341),
    [anon_sym_COLON] = ACTIONS(11339),
    [anon_sym_export] = ACTIONS(11339),
    [anon_sym_public] = ACTIONS(11339),
    [anon_sym_import] = ACTIONS(11339),
    [anon_sym_using] = ACTIONS(11339),
    [anon_sym_LBRACK] = ACTIONS(11341),
    [anon_sym_in] = ACTIONS(11339),
    [anon_sym_LBRACE] = ACTIONS(11341),
    [anon_sym_DOLLAR] = ACTIONS(11341),
    [anon_sym_COLON2] = ACTIONS(11339),
    [anon_sym_COLON_COLON] = ACTIONS(11341),
    [anon_sym_isa] = ACTIONS(11339),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11341),
    [anon_sym_QMARK] = ACTIONS(11341),
    [anon_sym_where] = ACTIONS(11339),
    [anon_sym_AT] = ACTIONS(11341),
    [anon_sym_true] = ACTIONS(11339),
    [anon_sym_false] = ACTIONS(11339),
    [aux_sym_integer_literal_token1] = ACTIONS(11341),
    [aux_sym_integer_literal_token2] = ACTIONS(11341),
    [aux_sym_integer_literal_token3] = ACTIONS(11339),
    [aux_sym_integer_literal_token4] = ACTIONS(11339),
    [aux_sym_float_literal_token1] = ACTIONS(11341),
    [aux_sym_float_literal_token3] = ACTIONS(11341),
    [aux_sym_float_literal_token4] = ACTIONS(11341),
    [sym_character_literal] = ACTIONS(11341),
    [anon_sym_DQUOTE] = ACTIONS(11339),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11341),
    [anon_sym_BQUOTE] = ACTIONS(11339),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11341),
    [sym__pair_operator] = ACTIONS(11341),
    [sym__arrow_operator] = ACTIONS(11339),
    [sym__lazy_or_operator] = ACTIONS(11341),
    [sym__lazy_and_operator] = ACTIONS(11341),
    [sym__comparison_operator] = ACTIONS(11339),
    [sym__pipe_right_operator] = ACTIONS(11341),
    [sym__pipe_left_operator] = ACTIONS(11341),
    [sym__ellipsis_operator] = ACTIONS(11339),
    [sym__plus_operator] = ACTIONS(11339),
    [sym__times_operator] = ACTIONS(11339),
    [sym__rational_operator] = ACTIONS(11341),
    [sym__bitshift_operator] = ACTIONS(11341),
    [sym__power_operator] = ACTIONS(11341),
    [sym__tilde_operator] = ACTIONS(11341),
    [sym__type_order_operator] = ACTIONS(11341),
    [sym__unary_operator] = ACTIONS(11339),
    [sym__unary_plus_operator] = ACTIONS(11339),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9201] = {
    [sym_block_comment] = STATE(9201),
    [sym_line_comment] = STATE(9201),
    [sym__word_identifier] = ACTIONS(11343),
    [anon_sym_COMMA] = ACTIONS(11345),
    [anon_sym_EQ] = ACTIONS(11343),
    [anon_sym_begin] = ACTIONS(11343),
    [anon_sym_module] = ACTIONS(11343),
    [anon_sym_baremodule] = ACTIONS(11343),
    [anon_sym_end] = ACTIONS(11343),
    [anon_sym_abstract] = ACTIONS(11343),
    [anon_sym_primitive] = ACTIONS(11343),
    [anon_sym_mutable] = ACTIONS(11343),
    [anon_sym_struct] = ACTIONS(11343),
    [anon_sym_function] = ACTIONS(11343),
    [anon_sym_macro] = ACTIONS(11343),
    [anon_sym_quote] = ACTIONS(11343),
    [anon_sym_let] = ACTIONS(11343),
    [anon_sym_if] = ACTIONS(11343),
    [anon_sym_try] = ACTIONS(11343),
    [anon_sym_for] = ACTIONS(11343),
    [anon_sym_while] = ACTIONS(11343),
    [sym_break_statement] = ACTIONS(11343),
    [sym_continue_statement] = ACTIONS(11343),
    [anon_sym_return] = ACTIONS(11343),
    [anon_sym_const] = ACTIONS(11343),
    [anon_sym_global] = ACTIONS(11343),
    [anon_sym_local] = ACTIONS(11343),
    [anon_sym_LPAREN] = ACTIONS(11345),
    [anon_sym_COLON] = ACTIONS(11343),
    [anon_sym_export] = ACTIONS(11343),
    [anon_sym_public] = ACTIONS(11343),
    [anon_sym_import] = ACTIONS(11343),
    [anon_sym_using] = ACTIONS(11343),
    [anon_sym_LBRACK] = ACTIONS(11345),
    [anon_sym_in] = ACTIONS(11343),
    [anon_sym_LBRACE] = ACTIONS(11345),
    [anon_sym_DOLLAR] = ACTIONS(11345),
    [anon_sym_COLON2] = ACTIONS(11343),
    [anon_sym_COLON_COLON] = ACTIONS(11345),
    [anon_sym_isa] = ACTIONS(11343),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11345),
    [anon_sym_QMARK] = ACTIONS(11345),
    [anon_sym_where] = ACTIONS(11343),
    [anon_sym_AT] = ACTIONS(11345),
    [anon_sym_true] = ACTIONS(11343),
    [anon_sym_false] = ACTIONS(11343),
    [aux_sym_integer_literal_token1] = ACTIONS(11345),
    [aux_sym_integer_literal_token2] = ACTIONS(11345),
    [aux_sym_integer_literal_token3] = ACTIONS(11343),
    [aux_sym_integer_literal_token4] = ACTIONS(11343),
    [aux_sym_float_literal_token1] = ACTIONS(11345),
    [aux_sym_float_literal_token3] = ACTIONS(11345),
    [aux_sym_float_literal_token4] = ACTIONS(11345),
    [sym_character_literal] = ACTIONS(11345),
    [anon_sym_DQUOTE] = ACTIONS(11343),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11345),
    [anon_sym_BQUOTE] = ACTIONS(11343),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11345),
    [sym__pair_operator] = ACTIONS(11345),
    [sym__arrow_operator] = ACTIONS(11343),
    [sym__lazy_or_operator] = ACTIONS(11345),
    [sym__lazy_and_operator] = ACTIONS(11345),
    [sym__comparison_operator] = ACTIONS(11343),
    [sym__pipe_right_operator] = ACTIONS(11345),
    [sym__pipe_left_operator] = ACTIONS(11345),
    [sym__ellipsis_operator] = ACTIONS(11343),
    [sym__plus_operator] = ACTIONS(11343),
    [sym__times_operator] = ACTIONS(11343),
    [sym__rational_operator] = ACTIONS(11345),
    [sym__bitshift_operator] = ACTIONS(11345),
    [sym__power_operator] = ACTIONS(11345),
    [sym__tilde_operator] = ACTIONS(11345),
    [sym__type_order_operator] = ACTIONS(11345),
    [sym__unary_operator] = ACTIONS(11343),
    [sym__unary_plus_operator] = ACTIONS(11343),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9202] = {
    [sym_block_comment] = STATE(9202),
    [sym_line_comment] = STATE(9202),
    [sym__word_identifier] = ACTIONS(11347),
    [anon_sym_COMMA] = ACTIONS(11349),
    [anon_sym_EQ] = ACTIONS(11347),
    [anon_sym_begin] = ACTIONS(11347),
    [anon_sym_module] = ACTIONS(11347),
    [anon_sym_baremodule] = ACTIONS(11347),
    [anon_sym_end] = ACTIONS(11347),
    [anon_sym_abstract] = ACTIONS(11347),
    [anon_sym_primitive] = ACTIONS(11347),
    [anon_sym_mutable] = ACTIONS(11347),
    [anon_sym_struct] = ACTIONS(11347),
    [anon_sym_function] = ACTIONS(11347),
    [anon_sym_macro] = ACTIONS(11347),
    [anon_sym_quote] = ACTIONS(11347),
    [anon_sym_let] = ACTIONS(11347),
    [anon_sym_if] = ACTIONS(11347),
    [anon_sym_try] = ACTIONS(11347),
    [anon_sym_for] = ACTIONS(11347),
    [anon_sym_while] = ACTIONS(11347),
    [sym_break_statement] = ACTIONS(11347),
    [sym_continue_statement] = ACTIONS(11347),
    [anon_sym_return] = ACTIONS(11347),
    [anon_sym_const] = ACTIONS(11347),
    [anon_sym_global] = ACTIONS(11347),
    [anon_sym_local] = ACTIONS(11347),
    [anon_sym_LPAREN] = ACTIONS(11349),
    [anon_sym_COLON] = ACTIONS(11347),
    [anon_sym_export] = ACTIONS(11347),
    [anon_sym_public] = ACTIONS(11347),
    [anon_sym_import] = ACTIONS(11347),
    [anon_sym_using] = ACTIONS(11347),
    [anon_sym_LBRACK] = ACTIONS(11349),
    [anon_sym_in] = ACTIONS(11347),
    [anon_sym_LBRACE] = ACTIONS(11349),
    [anon_sym_DOLLAR] = ACTIONS(11349),
    [anon_sym_COLON2] = ACTIONS(11347),
    [anon_sym_COLON_COLON] = ACTIONS(11349),
    [anon_sym_isa] = ACTIONS(11347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11349),
    [anon_sym_QMARK] = ACTIONS(11349),
    [anon_sym_where] = ACTIONS(11347),
    [anon_sym_AT] = ACTIONS(11349),
    [anon_sym_true] = ACTIONS(11347),
    [anon_sym_false] = ACTIONS(11347),
    [aux_sym_integer_literal_token1] = ACTIONS(11349),
    [aux_sym_integer_literal_token2] = ACTIONS(11349),
    [aux_sym_integer_literal_token3] = ACTIONS(11347),
    [aux_sym_integer_literal_token4] = ACTIONS(11347),
    [aux_sym_float_literal_token1] = ACTIONS(11349),
    [aux_sym_float_literal_token3] = ACTIONS(11349),
    [aux_sym_float_literal_token4] = ACTIONS(11349),
    [sym_character_literal] = ACTIONS(11349),
    [anon_sym_DQUOTE] = ACTIONS(11347),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11349),
    [anon_sym_BQUOTE] = ACTIONS(11347),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11349),
    [sym__pair_operator] = ACTIONS(11349),
    [sym__arrow_operator] = ACTIONS(11347),
    [sym__lazy_or_operator] = ACTIONS(11349),
    [sym__lazy_and_operator] = ACTIONS(11349),
    [sym__comparison_operator] = ACTIONS(11347),
    [sym__pipe_right_operator] = ACTIONS(11349),
    [sym__pipe_left_operator] = ACTIONS(11349),
    [sym__ellipsis_operator] = ACTIONS(11347),
    [sym__plus_operator] = ACTIONS(11347),
    [sym__times_operator] = ACTIONS(11347),
    [sym__rational_operator] = ACTIONS(11349),
    [sym__bitshift_operator] = ACTIONS(11349),
    [sym__power_operator] = ACTIONS(11349),
    [sym__tilde_operator] = ACTIONS(11349),
    [sym__type_order_operator] = ACTIONS(11349),
    [sym__unary_operator] = ACTIONS(11347),
    [sym__unary_plus_operator] = ACTIONS(11347),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9203] = {
    [sym_block_comment] = STATE(9203),
    [sym_line_comment] = STATE(9203),
    [sym__word_identifier] = ACTIONS(11351),
    [anon_sym_COMMA] = ACTIONS(11353),
    [anon_sym_EQ] = ACTIONS(11351),
    [anon_sym_begin] = ACTIONS(11351),
    [anon_sym_module] = ACTIONS(11351),
    [anon_sym_baremodule] = ACTIONS(11351),
    [anon_sym_end] = ACTIONS(11351),
    [anon_sym_abstract] = ACTIONS(11351),
    [anon_sym_primitive] = ACTIONS(11351),
    [anon_sym_mutable] = ACTIONS(11351),
    [anon_sym_struct] = ACTIONS(11351),
    [anon_sym_function] = ACTIONS(11351),
    [anon_sym_macro] = ACTIONS(11351),
    [anon_sym_quote] = ACTIONS(11351),
    [anon_sym_let] = ACTIONS(11351),
    [anon_sym_if] = ACTIONS(11351),
    [anon_sym_try] = ACTIONS(11351),
    [anon_sym_for] = ACTIONS(11351),
    [anon_sym_while] = ACTIONS(11351),
    [sym_break_statement] = ACTIONS(11351),
    [sym_continue_statement] = ACTIONS(11351),
    [anon_sym_return] = ACTIONS(11351),
    [anon_sym_const] = ACTIONS(11351),
    [anon_sym_global] = ACTIONS(11351),
    [anon_sym_local] = ACTIONS(11351),
    [anon_sym_LPAREN] = ACTIONS(11353),
    [anon_sym_COLON] = ACTIONS(11351),
    [anon_sym_export] = ACTIONS(11351),
    [anon_sym_public] = ACTIONS(11351),
    [anon_sym_import] = ACTIONS(11351),
    [anon_sym_using] = ACTIONS(11351),
    [anon_sym_LBRACK] = ACTIONS(11353),
    [anon_sym_in] = ACTIONS(11351),
    [anon_sym_LBRACE] = ACTIONS(11353),
    [anon_sym_DOLLAR] = ACTIONS(11353),
    [anon_sym_COLON2] = ACTIONS(11351),
    [anon_sym_COLON_COLON] = ACTIONS(11353),
    [anon_sym_isa] = ACTIONS(11351),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11353),
    [anon_sym_QMARK] = ACTIONS(11353),
    [anon_sym_where] = ACTIONS(11351),
    [anon_sym_AT] = ACTIONS(11353),
    [anon_sym_true] = ACTIONS(11351),
    [anon_sym_false] = ACTIONS(11351),
    [aux_sym_integer_literal_token1] = ACTIONS(11353),
    [aux_sym_integer_literal_token2] = ACTIONS(11353),
    [aux_sym_integer_literal_token3] = ACTIONS(11351),
    [aux_sym_integer_literal_token4] = ACTIONS(11351),
    [aux_sym_float_literal_token1] = ACTIONS(11353),
    [aux_sym_float_literal_token3] = ACTIONS(11353),
    [aux_sym_float_literal_token4] = ACTIONS(11353),
    [sym_character_literal] = ACTIONS(11353),
    [anon_sym_DQUOTE] = ACTIONS(11351),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11353),
    [anon_sym_BQUOTE] = ACTIONS(11351),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11353),
    [sym__pair_operator] = ACTIONS(11353),
    [sym__arrow_operator] = ACTIONS(11351),
    [sym__lazy_or_operator] = ACTIONS(11353),
    [sym__lazy_and_operator] = ACTIONS(11353),
    [sym__comparison_operator] = ACTIONS(11351),
    [sym__pipe_right_operator] = ACTIONS(11353),
    [sym__pipe_left_operator] = ACTIONS(11353),
    [sym__ellipsis_operator] = ACTIONS(11351),
    [sym__plus_operator] = ACTIONS(11351),
    [sym__times_operator] = ACTIONS(11351),
    [sym__rational_operator] = ACTIONS(11353),
    [sym__bitshift_operator] = ACTIONS(11353),
    [sym__power_operator] = ACTIONS(11353),
    [sym__tilde_operator] = ACTIONS(11353),
    [sym__type_order_operator] = ACTIONS(11353),
    [sym__unary_operator] = ACTIONS(11351),
    [sym__unary_plus_operator] = ACTIONS(11351),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9204] = {
    [sym_block_comment] = STATE(9204),
    [sym_line_comment] = STATE(9204),
    [sym__word_identifier] = ACTIONS(11355),
    [anon_sym_COMMA] = ACTIONS(11357),
    [anon_sym_EQ] = ACTIONS(11355),
    [anon_sym_begin] = ACTIONS(11355),
    [anon_sym_module] = ACTIONS(11355),
    [anon_sym_baremodule] = ACTIONS(11355),
    [anon_sym_end] = ACTIONS(11355),
    [anon_sym_abstract] = ACTIONS(11355),
    [anon_sym_primitive] = ACTIONS(11355),
    [anon_sym_mutable] = ACTIONS(11355),
    [anon_sym_struct] = ACTIONS(11355),
    [anon_sym_function] = ACTIONS(11355),
    [anon_sym_macro] = ACTIONS(11355),
    [anon_sym_quote] = ACTIONS(11355),
    [anon_sym_let] = ACTIONS(11355),
    [anon_sym_if] = ACTIONS(11355),
    [anon_sym_try] = ACTIONS(11355),
    [anon_sym_for] = ACTIONS(11355),
    [anon_sym_while] = ACTIONS(11355),
    [sym_break_statement] = ACTIONS(11355),
    [sym_continue_statement] = ACTIONS(11355),
    [anon_sym_return] = ACTIONS(11355),
    [anon_sym_const] = ACTIONS(11355),
    [anon_sym_global] = ACTIONS(11355),
    [anon_sym_local] = ACTIONS(11355),
    [anon_sym_LPAREN] = ACTIONS(11357),
    [anon_sym_COLON] = ACTIONS(11355),
    [anon_sym_export] = ACTIONS(11355),
    [anon_sym_public] = ACTIONS(11355),
    [anon_sym_import] = ACTIONS(11355),
    [anon_sym_using] = ACTIONS(11355),
    [anon_sym_LBRACK] = ACTIONS(11357),
    [anon_sym_in] = ACTIONS(11355),
    [anon_sym_LBRACE] = ACTIONS(11357),
    [anon_sym_DOLLAR] = ACTIONS(11357),
    [anon_sym_COLON2] = ACTIONS(11355),
    [anon_sym_COLON_COLON] = ACTIONS(11357),
    [anon_sym_isa] = ACTIONS(11355),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11357),
    [anon_sym_QMARK] = ACTIONS(11357),
    [anon_sym_where] = ACTIONS(11355),
    [anon_sym_AT] = ACTIONS(11357),
    [anon_sym_true] = ACTIONS(11355),
    [anon_sym_false] = ACTIONS(11355),
    [aux_sym_integer_literal_token1] = ACTIONS(11357),
    [aux_sym_integer_literal_token2] = ACTIONS(11357),
    [aux_sym_integer_literal_token3] = ACTIONS(11355),
    [aux_sym_integer_literal_token4] = ACTIONS(11355),
    [aux_sym_float_literal_token1] = ACTIONS(11357),
    [aux_sym_float_literal_token3] = ACTIONS(11357),
    [aux_sym_float_literal_token4] = ACTIONS(11357),
    [sym_character_literal] = ACTIONS(11357),
    [anon_sym_DQUOTE] = ACTIONS(11355),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11357),
    [anon_sym_BQUOTE] = ACTIONS(11355),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11357),
    [sym__pair_operator] = ACTIONS(11357),
    [sym__arrow_operator] = ACTIONS(11355),
    [sym__lazy_or_operator] = ACTIONS(11357),
    [sym__lazy_and_operator] = ACTIONS(11357),
    [sym__comparison_operator] = ACTIONS(11355),
    [sym__pipe_right_operator] = ACTIONS(11357),
    [sym__pipe_left_operator] = ACTIONS(11357),
    [sym__ellipsis_operator] = ACTIONS(11355),
    [sym__plus_operator] = ACTIONS(11355),
    [sym__times_operator] = ACTIONS(11355),
    [sym__rational_operator] = ACTIONS(11357),
    [sym__bitshift_operator] = ACTIONS(11357),
    [sym__power_operator] = ACTIONS(11357),
    [sym__tilde_operator] = ACTIONS(11357),
    [sym__type_order_operator] = ACTIONS(11357),
    [sym__unary_operator] = ACTIONS(11355),
    [sym__unary_plus_operator] = ACTIONS(11355),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9205] = {
    [sym_block_comment] = STATE(9205),
    [sym_line_comment] = STATE(9205),
    [sym__word_identifier] = ACTIONS(11373),
    [anon_sym_COMMA] = ACTIONS(11375),
    [anon_sym_EQ] = ACTIONS(11373),
    [anon_sym_begin] = ACTIONS(11373),
    [anon_sym_module] = ACTIONS(11373),
    [anon_sym_baremodule] = ACTIONS(11373),
    [anon_sym_end] = ACTIONS(11373),
    [anon_sym_abstract] = ACTIONS(11373),
    [anon_sym_primitive] = ACTIONS(11373),
    [anon_sym_mutable] = ACTIONS(11373),
    [anon_sym_struct] = ACTIONS(11373),
    [anon_sym_function] = ACTIONS(11373),
    [anon_sym_macro] = ACTIONS(11373),
    [anon_sym_quote] = ACTIONS(11373),
    [anon_sym_let] = ACTIONS(11373),
    [anon_sym_if] = ACTIONS(11373),
    [anon_sym_try] = ACTIONS(11373),
    [anon_sym_for] = ACTIONS(11373),
    [anon_sym_while] = ACTIONS(11373),
    [sym_break_statement] = ACTIONS(11373),
    [sym_continue_statement] = ACTIONS(11373),
    [anon_sym_return] = ACTIONS(11373),
    [anon_sym_const] = ACTIONS(11373),
    [anon_sym_global] = ACTIONS(11373),
    [anon_sym_local] = ACTIONS(11373),
    [anon_sym_LPAREN] = ACTIONS(11375),
    [anon_sym_COLON] = ACTIONS(11373),
    [anon_sym_export] = ACTIONS(11373),
    [anon_sym_public] = ACTIONS(11373),
    [anon_sym_import] = ACTIONS(11373),
    [anon_sym_using] = ACTIONS(11373),
    [anon_sym_LBRACK] = ACTIONS(11375),
    [anon_sym_in] = ACTIONS(11373),
    [anon_sym_LBRACE] = ACTIONS(11375),
    [anon_sym_DOLLAR] = ACTIONS(11375),
    [anon_sym_COLON2] = ACTIONS(11373),
    [anon_sym_COLON_COLON] = ACTIONS(11375),
    [anon_sym_isa] = ACTIONS(11373),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11375),
    [anon_sym_QMARK] = ACTIONS(11375),
    [anon_sym_where] = ACTIONS(11373),
    [anon_sym_AT] = ACTIONS(11375),
    [anon_sym_true] = ACTIONS(11373),
    [anon_sym_false] = ACTIONS(11373),
    [aux_sym_integer_literal_token1] = ACTIONS(11375),
    [aux_sym_integer_literal_token2] = ACTIONS(11375),
    [aux_sym_integer_literal_token3] = ACTIONS(11373),
    [aux_sym_integer_literal_token4] = ACTIONS(11373),
    [aux_sym_float_literal_token1] = ACTIONS(11375),
    [aux_sym_float_literal_token3] = ACTIONS(11375),
    [aux_sym_float_literal_token4] = ACTIONS(11375),
    [sym_character_literal] = ACTIONS(11375),
    [anon_sym_DQUOTE] = ACTIONS(11373),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11375),
    [anon_sym_BQUOTE] = ACTIONS(11373),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11375),
    [sym__pair_operator] = ACTIONS(11375),
    [sym__arrow_operator] = ACTIONS(11373),
    [sym__lazy_or_operator] = ACTIONS(11375),
    [sym__lazy_and_operator] = ACTIONS(11375),
    [sym__comparison_operator] = ACTIONS(11373),
    [sym__pipe_right_operator] = ACTIONS(11375),
    [sym__pipe_left_operator] = ACTIONS(11375),
    [sym__ellipsis_operator] = ACTIONS(11373),
    [sym__plus_operator] = ACTIONS(11373),
    [sym__times_operator] = ACTIONS(11373),
    [sym__rational_operator] = ACTIONS(11375),
    [sym__bitshift_operator] = ACTIONS(11375),
    [sym__power_operator] = ACTIONS(11375),
    [sym__tilde_operator] = ACTIONS(11375),
    [sym__type_order_operator] = ACTIONS(11375),
    [sym__unary_operator] = ACTIONS(11373),
    [sym__unary_plus_operator] = ACTIONS(11373),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9206] = {
    [sym_block_comment] = STATE(9206),
    [sym_line_comment] = STATE(9206),
    [sym__word_identifier] = ACTIONS(11377),
    [anon_sym_COMMA] = ACTIONS(11379),
    [anon_sym_EQ] = ACTIONS(11377),
    [anon_sym_begin] = ACTIONS(11377),
    [anon_sym_module] = ACTIONS(11377),
    [anon_sym_baremodule] = ACTIONS(11377),
    [anon_sym_end] = ACTIONS(11377),
    [anon_sym_abstract] = ACTIONS(11377),
    [anon_sym_primitive] = ACTIONS(11377),
    [anon_sym_mutable] = ACTIONS(11377),
    [anon_sym_struct] = ACTIONS(11377),
    [anon_sym_function] = ACTIONS(11377),
    [anon_sym_macro] = ACTIONS(11377),
    [anon_sym_quote] = ACTIONS(11377),
    [anon_sym_let] = ACTIONS(11377),
    [anon_sym_if] = ACTIONS(11377),
    [anon_sym_try] = ACTIONS(11377),
    [anon_sym_for] = ACTIONS(11377),
    [anon_sym_while] = ACTIONS(11377),
    [sym_break_statement] = ACTIONS(11377),
    [sym_continue_statement] = ACTIONS(11377),
    [anon_sym_return] = ACTIONS(11377),
    [anon_sym_const] = ACTIONS(11377),
    [anon_sym_global] = ACTIONS(11377),
    [anon_sym_local] = ACTIONS(11377),
    [anon_sym_LPAREN] = ACTIONS(11379),
    [anon_sym_COLON] = ACTIONS(11377),
    [anon_sym_export] = ACTIONS(11377),
    [anon_sym_public] = ACTIONS(11377),
    [anon_sym_import] = ACTIONS(11377),
    [anon_sym_using] = ACTIONS(11377),
    [anon_sym_LBRACK] = ACTIONS(11379),
    [anon_sym_in] = ACTIONS(11377),
    [anon_sym_LBRACE] = ACTIONS(11379),
    [anon_sym_DOLLAR] = ACTIONS(11379),
    [anon_sym_COLON2] = ACTIONS(11377),
    [anon_sym_COLON_COLON] = ACTIONS(11379),
    [anon_sym_isa] = ACTIONS(11377),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11379),
    [anon_sym_QMARK] = ACTIONS(11379),
    [anon_sym_where] = ACTIONS(11377),
    [anon_sym_AT] = ACTIONS(11379),
    [anon_sym_true] = ACTIONS(11377),
    [anon_sym_false] = ACTIONS(11377),
    [aux_sym_integer_literal_token1] = ACTIONS(11379),
    [aux_sym_integer_literal_token2] = ACTIONS(11379),
    [aux_sym_integer_literal_token3] = ACTIONS(11377),
    [aux_sym_integer_literal_token4] = ACTIONS(11377),
    [aux_sym_float_literal_token1] = ACTIONS(11379),
    [aux_sym_float_literal_token3] = ACTIONS(11379),
    [aux_sym_float_literal_token4] = ACTIONS(11379),
    [sym_character_literal] = ACTIONS(11379),
    [anon_sym_DQUOTE] = ACTIONS(11377),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11379),
    [anon_sym_BQUOTE] = ACTIONS(11377),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11379),
    [sym__pair_operator] = ACTIONS(11379),
    [sym__arrow_operator] = ACTIONS(11377),
    [sym__lazy_or_operator] = ACTIONS(11379),
    [sym__lazy_and_operator] = ACTIONS(11379),
    [sym__comparison_operator] = ACTIONS(11377),
    [sym__pipe_right_operator] = ACTIONS(11379),
    [sym__pipe_left_operator] = ACTIONS(11379),
    [sym__ellipsis_operator] = ACTIONS(11377),
    [sym__plus_operator] = ACTIONS(11377),
    [sym__times_operator] = ACTIONS(11377),
    [sym__rational_operator] = ACTIONS(11379),
    [sym__bitshift_operator] = ACTIONS(11379),
    [sym__power_operator] = ACTIONS(11379),
    [sym__tilde_operator] = ACTIONS(11379),
    [sym__type_order_operator] = ACTIONS(11379),
    [sym__unary_operator] = ACTIONS(11377),
    [sym__unary_plus_operator] = ACTIONS(11377),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9207] = {
    [sym_block_comment] = STATE(9207),
    [sym_line_comment] = STATE(9207),
    [sym__word_identifier] = ACTIONS(11385),
    [anon_sym_COMMA] = ACTIONS(11387),
    [anon_sym_EQ] = ACTIONS(11385),
    [anon_sym_begin] = ACTIONS(11385),
    [anon_sym_module] = ACTIONS(11385),
    [anon_sym_baremodule] = ACTIONS(11385),
    [anon_sym_end] = ACTIONS(11385),
    [anon_sym_abstract] = ACTIONS(11385),
    [anon_sym_primitive] = ACTIONS(11385),
    [anon_sym_mutable] = ACTIONS(11385),
    [anon_sym_struct] = ACTIONS(11385),
    [anon_sym_function] = ACTIONS(11385),
    [anon_sym_macro] = ACTIONS(11385),
    [anon_sym_quote] = ACTIONS(11385),
    [anon_sym_let] = ACTIONS(11385),
    [anon_sym_if] = ACTIONS(11385),
    [anon_sym_try] = ACTIONS(11385),
    [anon_sym_for] = ACTIONS(11385),
    [anon_sym_while] = ACTIONS(11385),
    [sym_break_statement] = ACTIONS(11385),
    [sym_continue_statement] = ACTIONS(11385),
    [anon_sym_return] = ACTIONS(11385),
    [anon_sym_const] = ACTIONS(11385),
    [anon_sym_global] = ACTIONS(11385),
    [anon_sym_local] = ACTIONS(11385),
    [anon_sym_LPAREN] = ACTIONS(11387),
    [anon_sym_COLON] = ACTIONS(11385),
    [anon_sym_export] = ACTIONS(11385),
    [anon_sym_public] = ACTIONS(11385),
    [anon_sym_import] = ACTIONS(11385),
    [anon_sym_using] = ACTIONS(11385),
    [anon_sym_LBRACK] = ACTIONS(11387),
    [anon_sym_in] = ACTIONS(11385),
    [anon_sym_LBRACE] = ACTIONS(11387),
    [anon_sym_DOLLAR] = ACTIONS(11387),
    [anon_sym_COLON2] = ACTIONS(11385),
    [anon_sym_COLON_COLON] = ACTIONS(11387),
    [anon_sym_isa] = ACTIONS(11385),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11387),
    [anon_sym_QMARK] = ACTIONS(11387),
    [anon_sym_where] = ACTIONS(11385),
    [anon_sym_AT] = ACTIONS(11387),
    [anon_sym_true] = ACTIONS(11385),
    [anon_sym_false] = ACTIONS(11385),
    [aux_sym_integer_literal_token1] = ACTIONS(11387),
    [aux_sym_integer_literal_token2] = ACTIONS(11387),
    [aux_sym_integer_literal_token3] = ACTIONS(11385),
    [aux_sym_integer_literal_token4] = ACTIONS(11385),
    [aux_sym_float_literal_token1] = ACTIONS(11387),
    [aux_sym_float_literal_token3] = ACTIONS(11387),
    [aux_sym_float_literal_token4] = ACTIONS(11387),
    [sym_character_literal] = ACTIONS(11387),
    [anon_sym_DQUOTE] = ACTIONS(11385),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11387),
    [anon_sym_BQUOTE] = ACTIONS(11385),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11387),
    [sym__pair_operator] = ACTIONS(11387),
    [sym__arrow_operator] = ACTIONS(11385),
    [sym__lazy_or_operator] = ACTIONS(11387),
    [sym__lazy_and_operator] = ACTIONS(11387),
    [sym__comparison_operator] = ACTIONS(11385),
    [sym__pipe_right_operator] = ACTIONS(11387),
    [sym__pipe_left_operator] = ACTIONS(11387),
    [sym__ellipsis_operator] = ACTIONS(11385),
    [sym__plus_operator] = ACTIONS(11385),
    [sym__times_operator] = ACTIONS(11385),
    [sym__rational_operator] = ACTIONS(11387),
    [sym__bitshift_operator] = ACTIONS(11387),
    [sym__power_operator] = ACTIONS(11387),
    [sym__tilde_operator] = ACTIONS(11387),
    [sym__type_order_operator] = ACTIONS(11387),
    [sym__unary_operator] = ACTIONS(11385),
    [sym__unary_plus_operator] = ACTIONS(11385),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9208] = {
    [sym_block_comment] = STATE(9208),
    [sym_line_comment] = STATE(9208),
    [sym__word_identifier] = ACTIONS(11399),
    [anon_sym_COMMA] = ACTIONS(11401),
    [anon_sym_EQ] = ACTIONS(11399),
    [anon_sym_begin] = ACTIONS(11399),
    [anon_sym_module] = ACTIONS(11399),
    [anon_sym_baremodule] = ACTIONS(11399),
    [anon_sym_end] = ACTIONS(11399),
    [anon_sym_abstract] = ACTIONS(11399),
    [anon_sym_primitive] = ACTIONS(11399),
    [anon_sym_mutable] = ACTIONS(11399),
    [anon_sym_struct] = ACTIONS(11399),
    [anon_sym_function] = ACTIONS(11399),
    [anon_sym_macro] = ACTIONS(11399),
    [anon_sym_quote] = ACTIONS(11399),
    [anon_sym_let] = ACTIONS(11399),
    [anon_sym_if] = ACTIONS(11399),
    [anon_sym_try] = ACTIONS(11399),
    [anon_sym_for] = ACTIONS(11399),
    [anon_sym_while] = ACTIONS(11399),
    [sym_break_statement] = ACTIONS(11399),
    [sym_continue_statement] = ACTIONS(11399),
    [anon_sym_return] = ACTIONS(11399),
    [anon_sym_const] = ACTIONS(11399),
    [anon_sym_global] = ACTIONS(11399),
    [anon_sym_local] = ACTIONS(11399),
    [anon_sym_LPAREN] = ACTIONS(11401),
    [anon_sym_COLON] = ACTIONS(11399),
    [anon_sym_export] = ACTIONS(11399),
    [anon_sym_public] = ACTIONS(11399),
    [anon_sym_import] = ACTIONS(11399),
    [anon_sym_using] = ACTIONS(11399),
    [anon_sym_LBRACK] = ACTIONS(11401),
    [anon_sym_in] = ACTIONS(11399),
    [anon_sym_LBRACE] = ACTIONS(11401),
    [anon_sym_DOLLAR] = ACTIONS(11401),
    [anon_sym_COLON2] = ACTIONS(11399),
    [anon_sym_COLON_COLON] = ACTIONS(11401),
    [anon_sym_isa] = ACTIONS(11399),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11401),
    [anon_sym_QMARK] = ACTIONS(11401),
    [anon_sym_where] = ACTIONS(11399),
    [anon_sym_AT] = ACTIONS(11401),
    [anon_sym_true] = ACTIONS(11399),
    [anon_sym_false] = ACTIONS(11399),
    [aux_sym_integer_literal_token1] = ACTIONS(11401),
    [aux_sym_integer_literal_token2] = ACTIONS(11401),
    [aux_sym_integer_literal_token3] = ACTIONS(11399),
    [aux_sym_integer_literal_token4] = ACTIONS(11399),
    [aux_sym_float_literal_token1] = ACTIONS(11401),
    [aux_sym_float_literal_token3] = ACTIONS(11401),
    [aux_sym_float_literal_token4] = ACTIONS(11401),
    [sym_character_literal] = ACTIONS(11401),
    [anon_sym_DQUOTE] = ACTIONS(11399),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11401),
    [anon_sym_BQUOTE] = ACTIONS(11399),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11401),
    [sym__pair_operator] = ACTIONS(11401),
    [sym__arrow_operator] = ACTIONS(11399),
    [sym__lazy_or_operator] = ACTIONS(11401),
    [sym__lazy_and_operator] = ACTIONS(11401),
    [sym__comparison_operator] = ACTIONS(11399),
    [sym__pipe_right_operator] = ACTIONS(11401),
    [sym__pipe_left_operator] = ACTIONS(11401),
    [sym__ellipsis_operator] = ACTIONS(11399),
    [sym__plus_operator] = ACTIONS(11399),
    [sym__times_operator] = ACTIONS(11399),
    [sym__rational_operator] = ACTIONS(11401),
    [sym__bitshift_operator] = ACTIONS(11401),
    [sym__power_operator] = ACTIONS(11401),
    [sym__tilde_operator] = ACTIONS(11401),
    [sym__type_order_operator] = ACTIONS(11401),
    [sym__unary_operator] = ACTIONS(11399),
    [sym__unary_plus_operator] = ACTIONS(11399),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9209] = {
    [sym_block_comment] = STATE(9209),
    [sym_line_comment] = STATE(9209),
    [sym__word_identifier] = ACTIONS(11403),
    [anon_sym_COMMA] = ACTIONS(11405),
    [anon_sym_EQ] = ACTIONS(11403),
    [anon_sym_begin] = ACTIONS(11403),
    [anon_sym_module] = ACTIONS(11403),
    [anon_sym_baremodule] = ACTIONS(11403),
    [anon_sym_end] = ACTIONS(11403),
    [anon_sym_abstract] = ACTIONS(11403),
    [anon_sym_primitive] = ACTIONS(11403),
    [anon_sym_mutable] = ACTIONS(11403),
    [anon_sym_struct] = ACTIONS(11403),
    [anon_sym_function] = ACTIONS(11403),
    [anon_sym_macro] = ACTIONS(11403),
    [anon_sym_quote] = ACTIONS(11403),
    [anon_sym_let] = ACTIONS(11403),
    [anon_sym_if] = ACTIONS(11403),
    [anon_sym_try] = ACTIONS(11403),
    [anon_sym_for] = ACTIONS(11403),
    [anon_sym_while] = ACTIONS(11403),
    [sym_break_statement] = ACTIONS(11403),
    [sym_continue_statement] = ACTIONS(11403),
    [anon_sym_return] = ACTIONS(11403),
    [anon_sym_const] = ACTIONS(11403),
    [anon_sym_global] = ACTIONS(11403),
    [anon_sym_local] = ACTIONS(11403),
    [anon_sym_LPAREN] = ACTIONS(11405),
    [anon_sym_COLON] = ACTIONS(11403),
    [anon_sym_export] = ACTIONS(11403),
    [anon_sym_public] = ACTIONS(11403),
    [anon_sym_import] = ACTIONS(11403),
    [anon_sym_using] = ACTIONS(11403),
    [anon_sym_LBRACK] = ACTIONS(11405),
    [anon_sym_in] = ACTIONS(11403),
    [anon_sym_LBRACE] = ACTIONS(11405),
    [anon_sym_DOLLAR] = ACTIONS(11405),
    [anon_sym_COLON2] = ACTIONS(11403),
    [anon_sym_COLON_COLON] = ACTIONS(11405),
    [anon_sym_isa] = ACTIONS(11403),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11405),
    [anon_sym_QMARK] = ACTIONS(11405),
    [anon_sym_where] = ACTIONS(11403),
    [anon_sym_AT] = ACTIONS(11405),
    [anon_sym_true] = ACTIONS(11403),
    [anon_sym_false] = ACTIONS(11403),
    [aux_sym_integer_literal_token1] = ACTIONS(11405),
    [aux_sym_integer_literal_token2] = ACTIONS(11405),
    [aux_sym_integer_literal_token3] = ACTIONS(11403),
    [aux_sym_integer_literal_token4] = ACTIONS(11403),
    [aux_sym_float_literal_token1] = ACTIONS(11405),
    [aux_sym_float_literal_token3] = ACTIONS(11405),
    [aux_sym_float_literal_token4] = ACTIONS(11405),
    [sym_character_literal] = ACTIONS(11405),
    [anon_sym_DQUOTE] = ACTIONS(11403),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11405),
    [anon_sym_BQUOTE] = ACTIONS(11403),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11405),
    [sym__pair_operator] = ACTIONS(11405),
    [sym__arrow_operator] = ACTIONS(11403),
    [sym__lazy_or_operator] = ACTIONS(11405),
    [sym__lazy_and_operator] = ACTIONS(11405),
    [sym__comparison_operator] = ACTIONS(11403),
    [sym__pipe_right_operator] = ACTIONS(11405),
    [sym__pipe_left_operator] = ACTIONS(11405),
    [sym__ellipsis_operator] = ACTIONS(11403),
    [sym__plus_operator] = ACTIONS(11403),
    [sym__times_operator] = ACTIONS(11403),
    [sym__rational_operator] = ACTIONS(11405),
    [sym__bitshift_operator] = ACTIONS(11405),
    [sym__power_operator] = ACTIONS(11405),
    [sym__tilde_operator] = ACTIONS(11405),
    [sym__type_order_operator] = ACTIONS(11405),
    [sym__unary_operator] = ACTIONS(11403),
    [sym__unary_plus_operator] = ACTIONS(11403),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9210] = {
    [sym_block_comment] = STATE(9210),
    [sym_line_comment] = STATE(9210),
    [sym__word_identifier] = ACTIONS(11255),
    [anon_sym_COMMA] = ACTIONS(11257),
    [anon_sym_EQ] = ACTIONS(11255),
    [anon_sym_begin] = ACTIONS(11255),
    [anon_sym_module] = ACTIONS(11255),
    [anon_sym_baremodule] = ACTIONS(11255),
    [anon_sym_end] = ACTIONS(11255),
    [anon_sym_abstract] = ACTIONS(11255),
    [anon_sym_primitive] = ACTIONS(11255),
    [anon_sym_mutable] = ACTIONS(11255),
    [anon_sym_struct] = ACTIONS(11255),
    [anon_sym_function] = ACTIONS(11255),
    [anon_sym_macro] = ACTIONS(11255),
    [anon_sym_quote] = ACTIONS(11255),
    [anon_sym_let] = ACTIONS(11255),
    [anon_sym_if] = ACTIONS(11255),
    [anon_sym_try] = ACTIONS(11255),
    [anon_sym_for] = ACTIONS(11255),
    [anon_sym_while] = ACTIONS(11255),
    [sym_break_statement] = ACTIONS(11255),
    [sym_continue_statement] = ACTIONS(11255),
    [anon_sym_return] = ACTIONS(11255),
    [anon_sym_const] = ACTIONS(11255),
    [anon_sym_global] = ACTIONS(11255),
    [anon_sym_local] = ACTIONS(11255),
    [anon_sym_LPAREN] = ACTIONS(11257),
    [anon_sym_COLON] = ACTIONS(11255),
    [anon_sym_export] = ACTIONS(11255),
    [anon_sym_public] = ACTIONS(11255),
    [anon_sym_import] = ACTIONS(11255),
    [anon_sym_using] = ACTIONS(11255),
    [anon_sym_LBRACK] = ACTIONS(11257),
    [anon_sym_in] = ACTIONS(11255),
    [anon_sym_LBRACE] = ACTIONS(11257),
    [anon_sym_DOLLAR] = ACTIONS(11257),
    [anon_sym_COLON2] = ACTIONS(11255),
    [anon_sym_COLON_COLON] = ACTIONS(11257),
    [anon_sym_isa] = ACTIONS(11255),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11257),
    [anon_sym_QMARK] = ACTIONS(11257),
    [anon_sym_where] = ACTIONS(11255),
    [anon_sym_AT] = ACTIONS(11257),
    [anon_sym_true] = ACTIONS(11255),
    [anon_sym_false] = ACTIONS(11255),
    [aux_sym_integer_literal_token1] = ACTIONS(11257),
    [aux_sym_integer_literal_token2] = ACTIONS(11257),
    [aux_sym_integer_literal_token3] = ACTIONS(11255),
    [aux_sym_integer_literal_token4] = ACTIONS(11255),
    [aux_sym_float_literal_token1] = ACTIONS(11257),
    [aux_sym_float_literal_token3] = ACTIONS(11257),
    [aux_sym_float_literal_token4] = ACTIONS(11257),
    [sym_character_literal] = ACTIONS(11257),
    [anon_sym_DQUOTE] = ACTIONS(11255),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11257),
    [anon_sym_BQUOTE] = ACTIONS(11255),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11257),
    [sym__pair_operator] = ACTIONS(11257),
    [sym__arrow_operator] = ACTIONS(11255),
    [sym__lazy_or_operator] = ACTIONS(11257),
    [sym__lazy_and_operator] = ACTIONS(11257),
    [sym__comparison_operator] = ACTIONS(11255),
    [sym__pipe_right_operator] = ACTIONS(11257),
    [sym__pipe_left_operator] = ACTIONS(11257),
    [sym__ellipsis_operator] = ACTIONS(11255),
    [sym__plus_operator] = ACTIONS(11255),
    [sym__times_operator] = ACTIONS(11255),
    [sym__rational_operator] = ACTIONS(11257),
    [sym__bitshift_operator] = ACTIONS(11257),
    [sym__power_operator] = ACTIONS(11257),
    [sym__tilde_operator] = ACTIONS(11257),
    [sym__type_order_operator] = ACTIONS(11257),
    [sym__unary_operator] = ACTIONS(11255),
    [sym__unary_plus_operator] = ACTIONS(11255),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9211] = {
    [sym_block_comment] = STATE(9211),
    [sym_line_comment] = STATE(9211),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(3631),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12798),
    [sym__arrow_operator] = ACTIONS(12800),
    [sym__lazy_or_operator] = ACTIONS(3637),
    [sym__lazy_and_operator] = ACTIONS(3639),
    [sym__comparison_operator] = ACTIONS(3623),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(3623),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9212] = {
    [sym_block_comment] = STATE(9212),
    [sym_line_comment] = STATE(9212),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9213] = {
    [sym_block_comment] = STATE(9213),
    [sym_line_comment] = STATE(9213),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12557),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12559),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(12559),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(3629),
    [anon_sym_where] = ACTIONS(12563),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12565),
    [sym__arrow_operator] = ACTIONS(12567),
    [sym__lazy_or_operator] = ACTIONS(12569),
    [sym__lazy_and_operator] = ACTIONS(12571),
    [sym__comparison_operator] = ACTIONS(12559),
    [sym__pipe_right_operator] = ACTIONS(12573),
    [sym__pipe_left_operator] = ACTIONS(12575),
    [sym__ellipsis_operator] = ACTIONS(12577),
    [sym__plus_operator] = ACTIONS(12579),
    [sym__times_operator] = ACTIONS(12581),
    [sym__rational_operator] = ACTIONS(12583),
    [sym__bitshift_operator] = ACTIONS(12585),
    [sym__power_operator] = ACTIONS(12587),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12559),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12579),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9214] = {
    [sym_block_comment] = STATE(9214),
    [sym_line_comment] = STATE(9214),
    [sym__word_identifier] = ACTIONS(10635),
    [anon_sym_COMMA] = ACTIONS(10639),
    [anon_sym_EQ] = ACTIONS(10635),
    [anon_sym_begin] = ACTIONS(10635),
    [anon_sym_module] = ACTIONS(10635),
    [anon_sym_baremodule] = ACTIONS(10635),
    [anon_sym_end] = ACTIONS(10635),
    [anon_sym_abstract] = ACTIONS(10635),
    [anon_sym_primitive] = ACTIONS(10635),
    [anon_sym_mutable] = ACTIONS(10635),
    [anon_sym_struct] = ACTIONS(10635),
    [anon_sym_function] = ACTIONS(10635),
    [anon_sym_macro] = ACTIONS(10635),
    [anon_sym_quote] = ACTIONS(10635),
    [anon_sym_let] = ACTIONS(10635),
    [anon_sym_if] = ACTIONS(10635),
    [anon_sym_try] = ACTIONS(10635),
    [anon_sym_for] = ACTIONS(10635),
    [anon_sym_while] = ACTIONS(10635),
    [sym_break_statement] = ACTIONS(10635),
    [sym_continue_statement] = ACTIONS(10635),
    [anon_sym_return] = ACTIONS(10635),
    [anon_sym_const] = ACTIONS(10635),
    [anon_sym_global] = ACTIONS(10635),
    [anon_sym_local] = ACTIONS(10635),
    [anon_sym_LPAREN] = ACTIONS(10639),
    [anon_sym_COLON] = ACTIONS(10635),
    [anon_sym_export] = ACTIONS(10635),
    [anon_sym_public] = ACTIONS(10635),
    [anon_sym_import] = ACTIONS(10635),
    [anon_sym_using] = ACTIONS(10635),
    [anon_sym_LBRACK] = ACTIONS(10639),
    [anon_sym_in] = ACTIONS(10635),
    [anon_sym_LBRACE] = ACTIONS(10639),
    [anon_sym_DOLLAR] = ACTIONS(10639),
    [anon_sym_COLON2] = ACTIONS(10635),
    [anon_sym_COLON_COLON] = ACTIONS(10639),
    [anon_sym_isa] = ACTIONS(10635),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10639),
    [anon_sym_QMARK] = ACTIONS(10639),
    [anon_sym_where] = ACTIONS(10635),
    [anon_sym_AT] = ACTIONS(10639),
    [anon_sym_true] = ACTIONS(10635),
    [anon_sym_false] = ACTIONS(10635),
    [aux_sym_integer_literal_token1] = ACTIONS(10639),
    [aux_sym_integer_literal_token2] = ACTIONS(10639),
    [aux_sym_integer_literal_token3] = ACTIONS(10635),
    [aux_sym_integer_literal_token4] = ACTIONS(10635),
    [aux_sym_float_literal_token1] = ACTIONS(10639),
    [aux_sym_float_literal_token3] = ACTIONS(10639),
    [aux_sym_float_literal_token4] = ACTIONS(10639),
    [sym_character_literal] = ACTIONS(10639),
    [anon_sym_DQUOTE] = ACTIONS(10635),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10639),
    [anon_sym_BQUOTE] = ACTIONS(10635),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10639),
    [sym__pair_operator] = ACTIONS(10639),
    [sym__arrow_operator] = ACTIONS(10635),
    [sym__lazy_or_operator] = ACTIONS(10639),
    [sym__lazy_and_operator] = ACTIONS(10639),
    [sym__comparison_operator] = ACTIONS(10635),
    [sym__pipe_right_operator] = ACTIONS(10639),
    [sym__pipe_left_operator] = ACTIONS(10639),
    [sym__ellipsis_operator] = ACTIONS(10635),
    [sym__plus_operator] = ACTIONS(10635),
    [sym__times_operator] = ACTIONS(10635),
    [sym__rational_operator] = ACTIONS(10639),
    [sym__bitshift_operator] = ACTIONS(10639),
    [sym__power_operator] = ACTIONS(10639),
    [sym__tilde_operator] = ACTIONS(10639),
    [sym__type_order_operator] = ACTIONS(10639),
    [sym__unary_operator] = ACTIONS(10635),
    [sym__unary_plus_operator] = ACTIONS(10635),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9215] = {
    [sym_block_comment] = STATE(9215),
    [sym_line_comment] = STATE(9215),
    [sym__word_identifier] = ACTIONS(11411),
    [anon_sym_COMMA] = ACTIONS(11413),
    [anon_sym_EQ] = ACTIONS(11411),
    [anon_sym_begin] = ACTIONS(11411),
    [anon_sym_module] = ACTIONS(11411),
    [anon_sym_baremodule] = ACTIONS(11411),
    [anon_sym_end] = ACTIONS(11411),
    [anon_sym_abstract] = ACTIONS(11411),
    [anon_sym_primitive] = ACTIONS(11411),
    [anon_sym_mutable] = ACTIONS(11411),
    [anon_sym_struct] = ACTIONS(11411),
    [anon_sym_function] = ACTIONS(11411),
    [anon_sym_macro] = ACTIONS(11411),
    [anon_sym_quote] = ACTIONS(11411),
    [anon_sym_let] = ACTIONS(11411),
    [anon_sym_if] = ACTIONS(11411),
    [anon_sym_try] = ACTIONS(11411),
    [anon_sym_for] = ACTIONS(11411),
    [anon_sym_while] = ACTIONS(11411),
    [sym_break_statement] = ACTIONS(11411),
    [sym_continue_statement] = ACTIONS(11411),
    [anon_sym_return] = ACTIONS(11411),
    [anon_sym_const] = ACTIONS(11411),
    [anon_sym_global] = ACTIONS(11411),
    [anon_sym_local] = ACTIONS(11411),
    [anon_sym_LPAREN] = ACTIONS(11413),
    [anon_sym_COLON] = ACTIONS(11411),
    [anon_sym_export] = ACTIONS(11411),
    [anon_sym_public] = ACTIONS(11411),
    [anon_sym_import] = ACTIONS(11411),
    [anon_sym_using] = ACTIONS(11411),
    [anon_sym_LBRACK] = ACTIONS(11413),
    [anon_sym_in] = ACTIONS(11411),
    [anon_sym_LBRACE] = ACTIONS(11413),
    [anon_sym_DOLLAR] = ACTIONS(11413),
    [anon_sym_COLON2] = ACTIONS(11411),
    [anon_sym_COLON_COLON] = ACTIONS(11413),
    [anon_sym_isa] = ACTIONS(11411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11413),
    [anon_sym_QMARK] = ACTIONS(11413),
    [anon_sym_where] = ACTIONS(11411),
    [anon_sym_AT] = ACTIONS(11413),
    [anon_sym_true] = ACTIONS(11411),
    [anon_sym_false] = ACTIONS(11411),
    [aux_sym_integer_literal_token1] = ACTIONS(11413),
    [aux_sym_integer_literal_token2] = ACTIONS(11413),
    [aux_sym_integer_literal_token3] = ACTIONS(11411),
    [aux_sym_integer_literal_token4] = ACTIONS(11411),
    [aux_sym_float_literal_token1] = ACTIONS(11413),
    [aux_sym_float_literal_token3] = ACTIONS(11413),
    [aux_sym_float_literal_token4] = ACTIONS(11413),
    [sym_character_literal] = ACTIONS(11413),
    [anon_sym_DQUOTE] = ACTIONS(11411),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11413),
    [anon_sym_BQUOTE] = ACTIONS(11411),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11413),
    [sym__pair_operator] = ACTIONS(11413),
    [sym__arrow_operator] = ACTIONS(11411),
    [sym__lazy_or_operator] = ACTIONS(11413),
    [sym__lazy_and_operator] = ACTIONS(11413),
    [sym__comparison_operator] = ACTIONS(11411),
    [sym__pipe_right_operator] = ACTIONS(11413),
    [sym__pipe_left_operator] = ACTIONS(11413),
    [sym__ellipsis_operator] = ACTIONS(11411),
    [sym__plus_operator] = ACTIONS(11411),
    [sym__times_operator] = ACTIONS(11411),
    [sym__rational_operator] = ACTIONS(11413),
    [sym__bitshift_operator] = ACTIONS(11413),
    [sym__power_operator] = ACTIONS(11413),
    [sym__tilde_operator] = ACTIONS(11413),
    [sym__type_order_operator] = ACTIONS(11413),
    [sym__unary_operator] = ACTIONS(11411),
    [sym__unary_plus_operator] = ACTIONS(11411),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9216] = {
    [sym_block_comment] = STATE(9216),
    [sym_line_comment] = STATE(9216),
    [sym__word_identifier] = ACTIONS(10835),
    [anon_sym_COMMA] = ACTIONS(10840),
    [anon_sym_EQ] = ACTIONS(10835),
    [anon_sym_begin] = ACTIONS(10835),
    [anon_sym_module] = ACTIONS(10835),
    [anon_sym_baremodule] = ACTIONS(10835),
    [anon_sym_end] = ACTIONS(10835),
    [anon_sym_abstract] = ACTIONS(10835),
    [anon_sym_primitive] = ACTIONS(10835),
    [anon_sym_mutable] = ACTIONS(10835),
    [anon_sym_struct] = ACTIONS(10835),
    [anon_sym_function] = ACTIONS(10835),
    [anon_sym_macro] = ACTIONS(10835),
    [anon_sym_quote] = ACTIONS(10835),
    [anon_sym_let] = ACTIONS(10835),
    [anon_sym_if] = ACTIONS(10835),
    [anon_sym_try] = ACTIONS(10835),
    [anon_sym_for] = ACTIONS(10835),
    [anon_sym_while] = ACTIONS(10835),
    [sym_break_statement] = ACTIONS(10835),
    [sym_continue_statement] = ACTIONS(10835),
    [anon_sym_return] = ACTIONS(10835),
    [anon_sym_const] = ACTIONS(10835),
    [anon_sym_global] = ACTIONS(10835),
    [anon_sym_local] = ACTIONS(10835),
    [anon_sym_LPAREN] = ACTIONS(10840),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10835),
    [anon_sym_public] = ACTIONS(10835),
    [anon_sym_import] = ACTIONS(10835),
    [anon_sym_using] = ACTIONS(10835),
    [anon_sym_LBRACK] = ACTIONS(10840),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10840),
    [anon_sym_DOLLAR] = ACTIONS(10840),
    [anon_sym_COLON2] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10840),
    [anon_sym_true] = ACTIONS(10835),
    [anon_sym_false] = ACTIONS(10835),
    [aux_sym_integer_literal_token1] = ACTIONS(10840),
    [aux_sym_integer_literal_token2] = ACTIONS(10840),
    [aux_sym_integer_literal_token3] = ACTIONS(10835),
    [aux_sym_integer_literal_token4] = ACTIONS(10835),
    [aux_sym_float_literal_token1] = ACTIONS(10840),
    [aux_sym_float_literal_token3] = ACTIONS(10840),
    [aux_sym_float_literal_token4] = ACTIONS(10840),
    [sym_character_literal] = ACTIONS(10840),
    [anon_sym_DQUOTE] = ACTIONS(10835),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10840),
    [anon_sym_BQUOTE] = ACTIONS(10835),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10840),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10840),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10835),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9217] = {
    [sym_block_comment] = STATE(9217),
    [sym_line_comment] = STATE(9217),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9218] = {
    [sym_block_comment] = STATE(9218),
    [sym_line_comment] = STATE(9218),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9219] = {
    [sym_block_comment] = STATE(9219),
    [sym_line_comment] = STATE(9219),
    [sym__word_identifier] = ACTIONS(10850),
    [anon_sym_COMMA] = ACTIONS(10855),
    [anon_sym_EQ] = ACTIONS(10850),
    [anon_sym_begin] = ACTIONS(10850),
    [anon_sym_module] = ACTIONS(10850),
    [anon_sym_baremodule] = ACTIONS(10850),
    [anon_sym_end] = ACTIONS(10850),
    [anon_sym_abstract] = ACTIONS(10850),
    [anon_sym_primitive] = ACTIONS(10850),
    [anon_sym_mutable] = ACTIONS(10850),
    [anon_sym_struct] = ACTIONS(10850),
    [anon_sym_function] = ACTIONS(10850),
    [anon_sym_macro] = ACTIONS(10850),
    [anon_sym_quote] = ACTIONS(10850),
    [anon_sym_let] = ACTIONS(10850),
    [anon_sym_if] = ACTIONS(10850),
    [anon_sym_try] = ACTIONS(10850),
    [anon_sym_for] = ACTIONS(10850),
    [anon_sym_while] = ACTIONS(10850),
    [sym_break_statement] = ACTIONS(10850),
    [sym_continue_statement] = ACTIONS(10850),
    [anon_sym_return] = ACTIONS(10850),
    [anon_sym_const] = ACTIONS(10850),
    [anon_sym_global] = ACTIONS(10850),
    [anon_sym_local] = ACTIONS(10850),
    [anon_sym_LPAREN] = ACTIONS(10855),
    [anon_sym_COLON] = ACTIONS(10850),
    [anon_sym_export] = ACTIONS(10850),
    [anon_sym_public] = ACTIONS(10850),
    [anon_sym_import] = ACTIONS(10850),
    [anon_sym_using] = ACTIONS(10850),
    [anon_sym_LBRACK] = ACTIONS(10855),
    [anon_sym_in] = ACTIONS(10850),
    [anon_sym_LBRACE] = ACTIONS(10855),
    [anon_sym_DOLLAR] = ACTIONS(10855),
    [anon_sym_COLON2] = ACTIONS(10850),
    [anon_sym_COLON_COLON] = ACTIONS(10855),
    [anon_sym_isa] = ACTIONS(10850),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10855),
    [anon_sym_QMARK] = ACTIONS(10855),
    [anon_sym_where] = ACTIONS(10850),
    [anon_sym_AT] = ACTIONS(10855),
    [anon_sym_true] = ACTIONS(10850),
    [anon_sym_false] = ACTIONS(10850),
    [aux_sym_integer_literal_token1] = ACTIONS(10855),
    [aux_sym_integer_literal_token2] = ACTIONS(10855),
    [aux_sym_integer_literal_token3] = ACTIONS(10850),
    [aux_sym_integer_literal_token4] = ACTIONS(10850),
    [aux_sym_float_literal_token1] = ACTIONS(10855),
    [aux_sym_float_literal_token3] = ACTIONS(10855),
    [aux_sym_float_literal_token4] = ACTIONS(10855),
    [sym_character_literal] = ACTIONS(10855),
    [anon_sym_DQUOTE] = ACTIONS(10850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10855),
    [anon_sym_BQUOTE] = ACTIONS(10850),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10855),
    [sym__pair_operator] = ACTIONS(10855),
    [sym__arrow_operator] = ACTIONS(10850),
    [sym__lazy_or_operator] = ACTIONS(10855),
    [sym__lazy_and_operator] = ACTIONS(10855),
    [sym__comparison_operator] = ACTIONS(10850),
    [sym__pipe_right_operator] = ACTIONS(10855),
    [sym__pipe_left_operator] = ACTIONS(10855),
    [sym__ellipsis_operator] = ACTIONS(10850),
    [sym__plus_operator] = ACTIONS(10850),
    [sym__times_operator] = ACTIONS(10850),
    [sym__rational_operator] = ACTIONS(10855),
    [sym__bitshift_operator] = ACTIONS(10855),
    [sym__power_operator] = ACTIONS(10855),
    [sym__tilde_operator] = ACTIONS(10855),
    [sym__type_order_operator] = ACTIONS(10855),
    [sym__unary_operator] = ACTIONS(10850),
    [sym__unary_plus_operator] = ACTIONS(10850),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9220] = {
    [sym_block_comment] = STATE(9220),
    [sym_line_comment] = STATE(9220),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9221] = {
    [sym_block_comment] = STATE(9221),
    [sym_line_comment] = STATE(9221),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9222] = {
    [sym_block_comment] = STATE(9222),
    [sym_line_comment] = STATE(9222),
    [sym__word_identifier] = ACTIONS(10861),
    [anon_sym_COMMA] = ACTIONS(10863),
    [anon_sym_EQ] = ACTIONS(10861),
    [anon_sym_begin] = ACTIONS(10861),
    [anon_sym_module] = ACTIONS(10861),
    [anon_sym_baremodule] = ACTIONS(10861),
    [anon_sym_end] = ACTIONS(10861),
    [anon_sym_abstract] = ACTIONS(10861),
    [anon_sym_primitive] = ACTIONS(10861),
    [anon_sym_mutable] = ACTIONS(10861),
    [anon_sym_struct] = ACTIONS(10861),
    [anon_sym_function] = ACTIONS(10861),
    [anon_sym_macro] = ACTIONS(10861),
    [anon_sym_quote] = ACTIONS(10861),
    [anon_sym_let] = ACTIONS(10861),
    [anon_sym_if] = ACTIONS(10861),
    [anon_sym_try] = ACTIONS(10861),
    [anon_sym_for] = ACTIONS(10861),
    [anon_sym_while] = ACTIONS(10861),
    [sym_break_statement] = ACTIONS(10861),
    [sym_continue_statement] = ACTIONS(10861),
    [anon_sym_return] = ACTIONS(10861),
    [anon_sym_const] = ACTIONS(10861),
    [anon_sym_global] = ACTIONS(10861),
    [anon_sym_local] = ACTIONS(10861),
    [anon_sym_LPAREN] = ACTIONS(10863),
    [anon_sym_COLON] = ACTIONS(10861),
    [anon_sym_export] = ACTIONS(10861),
    [anon_sym_public] = ACTIONS(10861),
    [anon_sym_import] = ACTIONS(10861),
    [anon_sym_using] = ACTIONS(10861),
    [anon_sym_LBRACK] = ACTIONS(10863),
    [anon_sym_in] = ACTIONS(10861),
    [anon_sym_LBRACE] = ACTIONS(10863),
    [anon_sym_DOLLAR] = ACTIONS(10863),
    [anon_sym_COLON2] = ACTIONS(10861),
    [anon_sym_COLON_COLON] = ACTIONS(10863),
    [anon_sym_isa] = ACTIONS(10861),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10863),
    [anon_sym_QMARK] = ACTIONS(10863),
    [anon_sym_where] = ACTIONS(10861),
    [anon_sym_AT] = ACTIONS(10863),
    [anon_sym_true] = ACTIONS(10861),
    [anon_sym_false] = ACTIONS(10861),
    [aux_sym_integer_literal_token1] = ACTIONS(10863),
    [aux_sym_integer_literal_token2] = ACTIONS(10863),
    [aux_sym_integer_literal_token3] = ACTIONS(10861),
    [aux_sym_integer_literal_token4] = ACTIONS(10861),
    [aux_sym_float_literal_token1] = ACTIONS(10863),
    [aux_sym_float_literal_token3] = ACTIONS(10863),
    [aux_sym_float_literal_token4] = ACTIONS(10863),
    [sym_character_literal] = ACTIONS(10863),
    [anon_sym_DQUOTE] = ACTIONS(10861),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10863),
    [anon_sym_BQUOTE] = ACTIONS(10861),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10863),
    [sym__pair_operator] = ACTIONS(10863),
    [sym__arrow_operator] = ACTIONS(10861),
    [sym__lazy_or_operator] = ACTIONS(10863),
    [sym__lazy_and_operator] = ACTIONS(10863),
    [sym__comparison_operator] = ACTIONS(10861),
    [sym__pipe_right_operator] = ACTIONS(10863),
    [sym__pipe_left_operator] = ACTIONS(10863),
    [sym__ellipsis_operator] = ACTIONS(10861),
    [sym__plus_operator] = ACTIONS(10861),
    [sym__times_operator] = ACTIONS(10861),
    [sym__rational_operator] = ACTIONS(10863),
    [sym__bitshift_operator] = ACTIONS(10863),
    [sym__power_operator] = ACTIONS(10863),
    [sym__tilde_operator] = ACTIONS(10863),
    [sym__type_order_operator] = ACTIONS(10863),
    [sym__unary_operator] = ACTIONS(10861),
    [sym__unary_plus_operator] = ACTIONS(10861),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9223] = {
    [sym_block_comment] = STATE(9223),
    [sym_line_comment] = STATE(9223),
    [sym__word_identifier] = ACTIONS(11898),
    [anon_sym_COMMA] = ACTIONS(11900),
    [anon_sym_EQ] = ACTIONS(11898),
    [anon_sym_begin] = ACTIONS(11898),
    [anon_sym_module] = ACTIONS(11898),
    [anon_sym_baremodule] = ACTIONS(11898),
    [anon_sym_end] = ACTIONS(11898),
    [anon_sym_abstract] = ACTIONS(11898),
    [anon_sym_primitive] = ACTIONS(11898),
    [anon_sym_mutable] = ACTIONS(11898),
    [anon_sym_struct] = ACTIONS(11898),
    [anon_sym_function] = ACTIONS(11898),
    [anon_sym_macro] = ACTIONS(11898),
    [anon_sym_quote] = ACTIONS(11898),
    [anon_sym_let] = ACTIONS(11898),
    [anon_sym_if] = ACTIONS(11898),
    [anon_sym_try] = ACTIONS(11898),
    [anon_sym_for] = ACTIONS(11898),
    [anon_sym_while] = ACTIONS(11898),
    [sym_break_statement] = ACTIONS(11898),
    [sym_continue_statement] = ACTIONS(11898),
    [anon_sym_return] = ACTIONS(11898),
    [anon_sym_const] = ACTIONS(11898),
    [anon_sym_global] = ACTIONS(11898),
    [anon_sym_local] = ACTIONS(11898),
    [anon_sym_LPAREN] = ACTIONS(11900),
    [anon_sym_COLON] = ACTIONS(11898),
    [anon_sym_export] = ACTIONS(11898),
    [anon_sym_public] = ACTIONS(11898),
    [anon_sym_import] = ACTIONS(11898),
    [anon_sym_using] = ACTIONS(11898),
    [anon_sym_LBRACK] = ACTIONS(11900),
    [anon_sym_in] = ACTIONS(11898),
    [anon_sym_LBRACE] = ACTIONS(11900),
    [anon_sym_DOLLAR] = ACTIONS(11900),
    [anon_sym_COLON2] = ACTIONS(11898),
    [anon_sym_COLON_COLON] = ACTIONS(11900),
    [anon_sym_isa] = ACTIONS(11898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11900),
    [anon_sym_QMARK] = ACTIONS(11900),
    [anon_sym_where] = ACTIONS(11898),
    [anon_sym_AT] = ACTIONS(11900),
    [anon_sym_true] = ACTIONS(11898),
    [anon_sym_false] = ACTIONS(11898),
    [aux_sym_integer_literal_token1] = ACTIONS(11900),
    [aux_sym_integer_literal_token2] = ACTIONS(11900),
    [aux_sym_integer_literal_token3] = ACTIONS(11898),
    [aux_sym_integer_literal_token4] = ACTIONS(11898),
    [aux_sym_float_literal_token1] = ACTIONS(11900),
    [aux_sym_float_literal_token3] = ACTIONS(11900),
    [aux_sym_float_literal_token4] = ACTIONS(11900),
    [sym_character_literal] = ACTIONS(11900),
    [anon_sym_DQUOTE] = ACTIONS(11898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11900),
    [anon_sym_BQUOTE] = ACTIONS(11898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11900),
    [sym__pair_operator] = ACTIONS(11900),
    [sym__arrow_operator] = ACTIONS(11898),
    [sym__lazy_or_operator] = ACTIONS(11900),
    [sym__lazy_and_operator] = ACTIONS(11900),
    [sym__comparison_operator] = ACTIONS(11898),
    [sym__pipe_right_operator] = ACTIONS(11900),
    [sym__pipe_left_operator] = ACTIONS(11900),
    [sym__ellipsis_operator] = ACTIONS(11898),
    [sym__plus_operator] = ACTIONS(11898),
    [sym__times_operator] = ACTIONS(11898),
    [sym__rational_operator] = ACTIONS(11900),
    [sym__bitshift_operator] = ACTIONS(11900),
    [sym__power_operator] = ACTIONS(11900),
    [sym__tilde_operator] = ACTIONS(11900),
    [sym__type_order_operator] = ACTIONS(11900),
    [sym__unary_operator] = ACTIONS(11898),
    [sym__unary_plus_operator] = ACTIONS(11898),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9224] = {
    [sym_block_comment] = STATE(9224),
    [sym_line_comment] = STATE(9224),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9225] = {
    [sym_block_comment] = STATE(9225),
    [sym_line_comment] = STATE(9225),
    [sym__word_identifier] = ACTIONS(11173),
    [anon_sym_COMMA] = ACTIONS(11175),
    [anon_sym_EQ] = ACTIONS(11173),
    [anon_sym_begin] = ACTIONS(11173),
    [anon_sym_module] = ACTIONS(11173),
    [anon_sym_baremodule] = ACTIONS(11173),
    [anon_sym_end] = ACTIONS(11173),
    [anon_sym_abstract] = ACTIONS(11173),
    [anon_sym_primitive] = ACTIONS(11173),
    [anon_sym_mutable] = ACTIONS(11173),
    [anon_sym_struct] = ACTIONS(11173),
    [anon_sym_function] = ACTIONS(11173),
    [anon_sym_macro] = ACTIONS(11173),
    [anon_sym_quote] = ACTIONS(11173),
    [anon_sym_let] = ACTIONS(11173),
    [anon_sym_if] = ACTIONS(11173),
    [anon_sym_try] = ACTIONS(11173),
    [anon_sym_for] = ACTIONS(11173),
    [anon_sym_while] = ACTIONS(11173),
    [sym_break_statement] = ACTIONS(11173),
    [sym_continue_statement] = ACTIONS(11173),
    [anon_sym_return] = ACTIONS(11173),
    [anon_sym_const] = ACTIONS(11173),
    [anon_sym_global] = ACTIONS(11173),
    [anon_sym_local] = ACTIONS(11173),
    [anon_sym_LPAREN] = ACTIONS(11175),
    [anon_sym_COLON] = ACTIONS(11173),
    [anon_sym_export] = ACTIONS(11173),
    [anon_sym_public] = ACTIONS(11173),
    [anon_sym_import] = ACTIONS(11173),
    [anon_sym_using] = ACTIONS(11173),
    [anon_sym_LBRACK] = ACTIONS(11175),
    [anon_sym_in] = ACTIONS(11173),
    [anon_sym_LBRACE] = ACTIONS(11175),
    [anon_sym_DOLLAR] = ACTIONS(11175),
    [anon_sym_COLON2] = ACTIONS(11173),
    [anon_sym_COLON_COLON] = ACTIONS(11175),
    [anon_sym_isa] = ACTIONS(11173),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11175),
    [anon_sym_QMARK] = ACTIONS(11175),
    [anon_sym_where] = ACTIONS(11173),
    [anon_sym_AT] = ACTIONS(11175),
    [anon_sym_true] = ACTIONS(11173),
    [anon_sym_false] = ACTIONS(11173),
    [aux_sym_integer_literal_token1] = ACTIONS(11175),
    [aux_sym_integer_literal_token2] = ACTIONS(11175),
    [aux_sym_integer_literal_token3] = ACTIONS(11173),
    [aux_sym_integer_literal_token4] = ACTIONS(11173),
    [aux_sym_float_literal_token1] = ACTIONS(11175),
    [aux_sym_float_literal_token3] = ACTIONS(11175),
    [aux_sym_float_literal_token4] = ACTIONS(11175),
    [sym_character_literal] = ACTIONS(11175),
    [anon_sym_DQUOTE] = ACTIONS(11173),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11175),
    [anon_sym_BQUOTE] = ACTIONS(11173),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11175),
    [sym__pair_operator] = ACTIONS(11175),
    [sym__arrow_operator] = ACTIONS(11173),
    [sym__lazy_or_operator] = ACTIONS(11175),
    [sym__lazy_and_operator] = ACTIONS(11175),
    [sym__comparison_operator] = ACTIONS(11173),
    [sym__pipe_right_operator] = ACTIONS(11175),
    [sym__pipe_left_operator] = ACTIONS(11175),
    [sym__ellipsis_operator] = ACTIONS(11173),
    [sym__plus_operator] = ACTIONS(11173),
    [sym__times_operator] = ACTIONS(11173),
    [sym__rational_operator] = ACTIONS(11175),
    [sym__bitshift_operator] = ACTIONS(11175),
    [sym__power_operator] = ACTIONS(11175),
    [sym__tilde_operator] = ACTIONS(11175),
    [sym__type_order_operator] = ACTIONS(11175),
    [sym__unary_operator] = ACTIONS(11173),
    [sym__unary_plus_operator] = ACTIONS(11173),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9226] = {
    [sym_block_comment] = STATE(9226),
    [sym_line_comment] = STATE(9226),
    [sym__word_identifier] = ACTIONS(11517),
    [anon_sym_COMMA] = ACTIONS(11519),
    [anon_sym_EQ] = ACTIONS(11517),
    [anon_sym_begin] = ACTIONS(11517),
    [anon_sym_module] = ACTIONS(11517),
    [anon_sym_baremodule] = ACTIONS(11517),
    [anon_sym_end] = ACTIONS(11517),
    [anon_sym_abstract] = ACTIONS(11517),
    [anon_sym_primitive] = ACTIONS(11517),
    [anon_sym_mutable] = ACTIONS(11517),
    [anon_sym_struct] = ACTIONS(11517),
    [anon_sym_function] = ACTIONS(11517),
    [anon_sym_macro] = ACTIONS(11517),
    [anon_sym_quote] = ACTIONS(11517),
    [anon_sym_let] = ACTIONS(11517),
    [anon_sym_if] = ACTIONS(11517),
    [anon_sym_try] = ACTIONS(11517),
    [anon_sym_for] = ACTIONS(11517),
    [anon_sym_while] = ACTIONS(11517),
    [sym_break_statement] = ACTIONS(11517),
    [sym_continue_statement] = ACTIONS(11517),
    [anon_sym_return] = ACTIONS(11517),
    [anon_sym_const] = ACTIONS(11517),
    [anon_sym_global] = ACTIONS(11517),
    [anon_sym_local] = ACTIONS(11517),
    [anon_sym_LPAREN] = ACTIONS(11519),
    [anon_sym_COLON] = ACTIONS(11517),
    [anon_sym_export] = ACTIONS(11517),
    [anon_sym_public] = ACTIONS(11517),
    [anon_sym_import] = ACTIONS(11517),
    [anon_sym_using] = ACTIONS(11517),
    [anon_sym_LBRACK] = ACTIONS(11519),
    [anon_sym_in] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(11519),
    [anon_sym_DOLLAR] = ACTIONS(11519),
    [anon_sym_COLON2] = ACTIONS(11517),
    [anon_sym_COLON_COLON] = ACTIONS(11519),
    [anon_sym_isa] = ACTIONS(11517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11519),
    [anon_sym_QMARK] = ACTIONS(11519),
    [anon_sym_where] = ACTIONS(11517),
    [anon_sym_AT] = ACTIONS(11519),
    [anon_sym_true] = ACTIONS(11517),
    [anon_sym_false] = ACTIONS(11517),
    [aux_sym_integer_literal_token1] = ACTIONS(11519),
    [aux_sym_integer_literal_token2] = ACTIONS(11519),
    [aux_sym_integer_literal_token3] = ACTIONS(11517),
    [aux_sym_integer_literal_token4] = ACTIONS(11517),
    [aux_sym_float_literal_token1] = ACTIONS(11519),
    [aux_sym_float_literal_token3] = ACTIONS(11519),
    [aux_sym_float_literal_token4] = ACTIONS(11519),
    [sym_character_literal] = ACTIONS(11519),
    [anon_sym_DQUOTE] = ACTIONS(11517),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11519),
    [anon_sym_BQUOTE] = ACTIONS(11517),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11519),
    [sym__pair_operator] = ACTIONS(11519),
    [sym__arrow_operator] = ACTIONS(11517),
    [sym__lazy_or_operator] = ACTIONS(11519),
    [sym__lazy_and_operator] = ACTIONS(11519),
    [sym__comparison_operator] = ACTIONS(11517),
    [sym__pipe_right_operator] = ACTIONS(11519),
    [sym__pipe_left_operator] = ACTIONS(11519),
    [sym__ellipsis_operator] = ACTIONS(11517),
    [sym__plus_operator] = ACTIONS(11517),
    [sym__times_operator] = ACTIONS(11517),
    [sym__rational_operator] = ACTIONS(11519),
    [sym__bitshift_operator] = ACTIONS(11519),
    [sym__power_operator] = ACTIONS(11519),
    [sym__tilde_operator] = ACTIONS(11519),
    [sym__type_order_operator] = ACTIONS(11519),
    [sym__unary_operator] = ACTIONS(11517),
    [sym__unary_plus_operator] = ACTIONS(11517),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9227] = {
    [sym_block_comment] = STATE(9227),
    [sym_line_comment] = STATE(9227),
    [sym__word_identifier] = ACTIONS(11924),
    [anon_sym_COMMA] = ACTIONS(11926),
    [anon_sym_EQ] = ACTIONS(11924),
    [anon_sym_begin] = ACTIONS(11924),
    [anon_sym_module] = ACTIONS(11924),
    [anon_sym_baremodule] = ACTIONS(11924),
    [anon_sym_end] = ACTIONS(11924),
    [anon_sym_abstract] = ACTIONS(11924),
    [anon_sym_primitive] = ACTIONS(11924),
    [anon_sym_mutable] = ACTIONS(11924),
    [anon_sym_struct] = ACTIONS(11924),
    [anon_sym_function] = ACTIONS(11924),
    [anon_sym_macro] = ACTIONS(11924),
    [anon_sym_quote] = ACTIONS(11924),
    [anon_sym_let] = ACTIONS(11924),
    [anon_sym_if] = ACTIONS(11924),
    [anon_sym_try] = ACTIONS(11924),
    [anon_sym_for] = ACTIONS(11924),
    [anon_sym_while] = ACTIONS(11924),
    [sym_break_statement] = ACTIONS(11924),
    [sym_continue_statement] = ACTIONS(11924),
    [anon_sym_return] = ACTIONS(11924),
    [anon_sym_const] = ACTIONS(11924),
    [anon_sym_global] = ACTIONS(11924),
    [anon_sym_local] = ACTIONS(11924),
    [anon_sym_LPAREN] = ACTIONS(11926),
    [anon_sym_COLON] = ACTIONS(11924),
    [anon_sym_export] = ACTIONS(11924),
    [anon_sym_public] = ACTIONS(11924),
    [anon_sym_import] = ACTIONS(11924),
    [anon_sym_using] = ACTIONS(11924),
    [anon_sym_LBRACK] = ACTIONS(11926),
    [anon_sym_in] = ACTIONS(11924),
    [anon_sym_LBRACE] = ACTIONS(11926),
    [anon_sym_DOLLAR] = ACTIONS(11926),
    [anon_sym_COLON2] = ACTIONS(11924),
    [anon_sym_COLON_COLON] = ACTIONS(11926),
    [anon_sym_isa] = ACTIONS(11924),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11926),
    [anon_sym_QMARK] = ACTIONS(11926),
    [anon_sym_where] = ACTIONS(11924),
    [anon_sym_AT] = ACTIONS(11926),
    [anon_sym_true] = ACTIONS(11924),
    [anon_sym_false] = ACTIONS(11924),
    [aux_sym_integer_literal_token1] = ACTIONS(11926),
    [aux_sym_integer_literal_token2] = ACTIONS(11926),
    [aux_sym_integer_literal_token3] = ACTIONS(11924),
    [aux_sym_integer_literal_token4] = ACTIONS(11924),
    [aux_sym_float_literal_token1] = ACTIONS(11926),
    [aux_sym_float_literal_token3] = ACTIONS(11926),
    [aux_sym_float_literal_token4] = ACTIONS(11926),
    [sym_character_literal] = ACTIONS(11926),
    [anon_sym_DQUOTE] = ACTIONS(11924),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11926),
    [anon_sym_BQUOTE] = ACTIONS(11924),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11926),
    [sym__pair_operator] = ACTIONS(11926),
    [sym__arrow_operator] = ACTIONS(11924),
    [sym__lazy_or_operator] = ACTIONS(11926),
    [sym__lazy_and_operator] = ACTIONS(11926),
    [sym__comparison_operator] = ACTIONS(11924),
    [sym__pipe_right_operator] = ACTIONS(11926),
    [sym__pipe_left_operator] = ACTIONS(11926),
    [sym__ellipsis_operator] = ACTIONS(11924),
    [sym__plus_operator] = ACTIONS(11924),
    [sym__times_operator] = ACTIONS(11924),
    [sym__rational_operator] = ACTIONS(11926),
    [sym__bitshift_operator] = ACTIONS(11926),
    [sym__power_operator] = ACTIONS(11926),
    [sym__tilde_operator] = ACTIONS(11926),
    [sym__type_order_operator] = ACTIONS(11926),
    [sym__unary_operator] = ACTIONS(11924),
    [sym__unary_plus_operator] = ACTIONS(11924),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9228] = {
    [sym_block_comment] = STATE(9228),
    [sym_line_comment] = STATE(9228),
    [sym__word_identifier] = ACTIONS(11941),
    [anon_sym_COMMA] = ACTIONS(11943),
    [anon_sym_EQ] = ACTIONS(11941),
    [anon_sym_begin] = ACTIONS(11941),
    [anon_sym_module] = ACTIONS(11941),
    [anon_sym_baremodule] = ACTIONS(11941),
    [anon_sym_end] = ACTIONS(11941),
    [anon_sym_abstract] = ACTIONS(11941),
    [anon_sym_primitive] = ACTIONS(11941),
    [anon_sym_mutable] = ACTIONS(11941),
    [anon_sym_struct] = ACTIONS(11941),
    [anon_sym_function] = ACTIONS(11941),
    [anon_sym_macro] = ACTIONS(11941),
    [anon_sym_quote] = ACTIONS(11941),
    [anon_sym_let] = ACTIONS(11941),
    [anon_sym_if] = ACTIONS(11941),
    [anon_sym_try] = ACTIONS(11941),
    [anon_sym_for] = ACTIONS(11941),
    [anon_sym_while] = ACTIONS(11941),
    [sym_break_statement] = ACTIONS(11941),
    [sym_continue_statement] = ACTIONS(11941),
    [anon_sym_return] = ACTIONS(11941),
    [anon_sym_const] = ACTIONS(11941),
    [anon_sym_global] = ACTIONS(11941),
    [anon_sym_local] = ACTIONS(11941),
    [anon_sym_LPAREN] = ACTIONS(11943),
    [anon_sym_COLON] = ACTIONS(11941),
    [anon_sym_export] = ACTIONS(11941),
    [anon_sym_public] = ACTIONS(11941),
    [anon_sym_import] = ACTIONS(11941),
    [anon_sym_using] = ACTIONS(11941),
    [anon_sym_LBRACK] = ACTIONS(11943),
    [anon_sym_in] = ACTIONS(11941),
    [anon_sym_LBRACE] = ACTIONS(11943),
    [anon_sym_DOLLAR] = ACTIONS(11943),
    [anon_sym_COLON2] = ACTIONS(11941),
    [anon_sym_COLON_COLON] = ACTIONS(11943),
    [anon_sym_isa] = ACTIONS(11941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11943),
    [anon_sym_QMARK] = ACTIONS(11943),
    [anon_sym_where] = ACTIONS(11941),
    [anon_sym_AT] = ACTIONS(11943),
    [anon_sym_true] = ACTIONS(11941),
    [anon_sym_false] = ACTIONS(11941),
    [aux_sym_integer_literal_token1] = ACTIONS(11943),
    [aux_sym_integer_literal_token2] = ACTIONS(11943),
    [aux_sym_integer_literal_token3] = ACTIONS(11941),
    [aux_sym_integer_literal_token4] = ACTIONS(11941),
    [aux_sym_float_literal_token1] = ACTIONS(11943),
    [aux_sym_float_literal_token3] = ACTIONS(11943),
    [aux_sym_float_literal_token4] = ACTIONS(11943),
    [sym_character_literal] = ACTIONS(11943),
    [anon_sym_DQUOTE] = ACTIONS(11941),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11943),
    [anon_sym_BQUOTE] = ACTIONS(11941),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11943),
    [sym__pair_operator] = ACTIONS(11943),
    [sym__arrow_operator] = ACTIONS(11941),
    [sym__lazy_or_operator] = ACTIONS(11943),
    [sym__lazy_and_operator] = ACTIONS(11943),
    [sym__comparison_operator] = ACTIONS(11941),
    [sym__pipe_right_operator] = ACTIONS(11943),
    [sym__pipe_left_operator] = ACTIONS(11943),
    [sym__ellipsis_operator] = ACTIONS(11941),
    [sym__plus_operator] = ACTIONS(11941),
    [sym__times_operator] = ACTIONS(11941),
    [sym__rational_operator] = ACTIONS(11943),
    [sym__bitshift_operator] = ACTIONS(11943),
    [sym__power_operator] = ACTIONS(11943),
    [sym__tilde_operator] = ACTIONS(11943),
    [sym__type_order_operator] = ACTIONS(11943),
    [sym__unary_operator] = ACTIONS(11941),
    [sym__unary_plus_operator] = ACTIONS(11941),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9229] = {
    [sym_block_comment] = STATE(9229),
    [sym_line_comment] = STATE(9229),
    [sym__word_identifier] = ACTIONS(11965),
    [anon_sym_COMMA] = ACTIONS(11967),
    [anon_sym_EQ] = ACTIONS(11965),
    [anon_sym_begin] = ACTIONS(11965),
    [anon_sym_module] = ACTIONS(11965),
    [anon_sym_baremodule] = ACTIONS(11965),
    [anon_sym_end] = ACTIONS(11965),
    [anon_sym_abstract] = ACTIONS(11965),
    [anon_sym_primitive] = ACTIONS(11965),
    [anon_sym_mutable] = ACTIONS(11965),
    [anon_sym_struct] = ACTIONS(11965),
    [anon_sym_function] = ACTIONS(11965),
    [anon_sym_macro] = ACTIONS(11965),
    [anon_sym_quote] = ACTIONS(11965),
    [anon_sym_let] = ACTIONS(11965),
    [anon_sym_if] = ACTIONS(11965),
    [anon_sym_try] = ACTIONS(11965),
    [anon_sym_for] = ACTIONS(11965),
    [anon_sym_while] = ACTIONS(11965),
    [sym_break_statement] = ACTIONS(11965),
    [sym_continue_statement] = ACTIONS(11965),
    [anon_sym_return] = ACTIONS(11965),
    [anon_sym_const] = ACTIONS(11965),
    [anon_sym_global] = ACTIONS(11965),
    [anon_sym_local] = ACTIONS(11965),
    [anon_sym_LPAREN] = ACTIONS(11967),
    [anon_sym_COLON] = ACTIONS(11965),
    [anon_sym_export] = ACTIONS(11965),
    [anon_sym_public] = ACTIONS(11965),
    [anon_sym_import] = ACTIONS(11965),
    [anon_sym_using] = ACTIONS(11965),
    [anon_sym_LBRACK] = ACTIONS(11967),
    [anon_sym_in] = ACTIONS(11965),
    [anon_sym_LBRACE] = ACTIONS(11967),
    [anon_sym_DOLLAR] = ACTIONS(11967),
    [anon_sym_COLON2] = ACTIONS(11965),
    [anon_sym_COLON_COLON] = ACTIONS(11967),
    [anon_sym_isa] = ACTIONS(11965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11967),
    [anon_sym_QMARK] = ACTIONS(11967),
    [anon_sym_where] = ACTIONS(11965),
    [anon_sym_AT] = ACTIONS(11967),
    [anon_sym_true] = ACTIONS(11965),
    [anon_sym_false] = ACTIONS(11965),
    [aux_sym_integer_literal_token1] = ACTIONS(11967),
    [aux_sym_integer_literal_token2] = ACTIONS(11967),
    [aux_sym_integer_literal_token3] = ACTIONS(11965),
    [aux_sym_integer_literal_token4] = ACTIONS(11965),
    [aux_sym_float_literal_token1] = ACTIONS(11967),
    [aux_sym_float_literal_token3] = ACTIONS(11967),
    [aux_sym_float_literal_token4] = ACTIONS(11967),
    [sym_character_literal] = ACTIONS(11967),
    [anon_sym_DQUOTE] = ACTIONS(11965),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11967),
    [anon_sym_BQUOTE] = ACTIONS(11965),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11967),
    [sym__pair_operator] = ACTIONS(11967),
    [sym__arrow_operator] = ACTIONS(11965),
    [sym__lazy_or_operator] = ACTIONS(11967),
    [sym__lazy_and_operator] = ACTIONS(11967),
    [sym__comparison_operator] = ACTIONS(11965),
    [sym__pipe_right_operator] = ACTIONS(11967),
    [sym__pipe_left_operator] = ACTIONS(11967),
    [sym__ellipsis_operator] = ACTIONS(11965),
    [sym__plus_operator] = ACTIONS(11965),
    [sym__times_operator] = ACTIONS(11965),
    [sym__rational_operator] = ACTIONS(11967),
    [sym__bitshift_operator] = ACTIONS(11967),
    [sym__power_operator] = ACTIONS(11967),
    [sym__tilde_operator] = ACTIONS(11967),
    [sym__type_order_operator] = ACTIONS(11967),
    [sym__unary_operator] = ACTIONS(11965),
    [sym__unary_plus_operator] = ACTIONS(11965),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9230] = {
    [sym_block_comment] = STATE(9230),
    [sym_line_comment] = STATE(9230),
    [sym__word_identifier] = ACTIONS(11969),
    [anon_sym_COMMA] = ACTIONS(11971),
    [anon_sym_EQ] = ACTIONS(11969),
    [anon_sym_begin] = ACTIONS(11969),
    [anon_sym_module] = ACTIONS(11969),
    [anon_sym_baremodule] = ACTIONS(11969),
    [anon_sym_end] = ACTIONS(11969),
    [anon_sym_abstract] = ACTIONS(11969),
    [anon_sym_primitive] = ACTIONS(11969),
    [anon_sym_mutable] = ACTIONS(11969),
    [anon_sym_struct] = ACTIONS(11969),
    [anon_sym_function] = ACTIONS(11969),
    [anon_sym_macro] = ACTIONS(11969),
    [anon_sym_quote] = ACTIONS(11969),
    [anon_sym_let] = ACTIONS(11969),
    [anon_sym_if] = ACTIONS(11969),
    [anon_sym_try] = ACTIONS(11969),
    [anon_sym_for] = ACTIONS(11969),
    [anon_sym_while] = ACTIONS(11969),
    [sym_break_statement] = ACTIONS(11969),
    [sym_continue_statement] = ACTIONS(11969),
    [anon_sym_return] = ACTIONS(11969),
    [anon_sym_const] = ACTIONS(11969),
    [anon_sym_global] = ACTIONS(11969),
    [anon_sym_local] = ACTIONS(11969),
    [anon_sym_LPAREN] = ACTIONS(11971),
    [anon_sym_COLON] = ACTIONS(11969),
    [anon_sym_export] = ACTIONS(11969),
    [anon_sym_public] = ACTIONS(11969),
    [anon_sym_import] = ACTIONS(11969),
    [anon_sym_using] = ACTIONS(11969),
    [anon_sym_LBRACK] = ACTIONS(11971),
    [anon_sym_in] = ACTIONS(11969),
    [anon_sym_LBRACE] = ACTIONS(11971),
    [anon_sym_DOLLAR] = ACTIONS(11971),
    [anon_sym_COLON2] = ACTIONS(11969),
    [anon_sym_COLON_COLON] = ACTIONS(11971),
    [anon_sym_isa] = ACTIONS(11969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11971),
    [anon_sym_QMARK] = ACTIONS(11971),
    [anon_sym_where] = ACTIONS(11969),
    [anon_sym_AT] = ACTIONS(11971),
    [anon_sym_true] = ACTIONS(11969),
    [anon_sym_false] = ACTIONS(11969),
    [aux_sym_integer_literal_token1] = ACTIONS(11971),
    [aux_sym_integer_literal_token2] = ACTIONS(11971),
    [aux_sym_integer_literal_token3] = ACTIONS(11969),
    [aux_sym_integer_literal_token4] = ACTIONS(11969),
    [aux_sym_float_literal_token1] = ACTIONS(11971),
    [aux_sym_float_literal_token3] = ACTIONS(11971),
    [aux_sym_float_literal_token4] = ACTIONS(11971),
    [sym_character_literal] = ACTIONS(11971),
    [anon_sym_DQUOTE] = ACTIONS(11969),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11971),
    [anon_sym_BQUOTE] = ACTIONS(11969),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11971),
    [sym__pair_operator] = ACTIONS(11971),
    [sym__arrow_operator] = ACTIONS(11969),
    [sym__lazy_or_operator] = ACTIONS(11971),
    [sym__lazy_and_operator] = ACTIONS(11971),
    [sym__comparison_operator] = ACTIONS(11969),
    [sym__pipe_right_operator] = ACTIONS(11971),
    [sym__pipe_left_operator] = ACTIONS(11971),
    [sym__ellipsis_operator] = ACTIONS(11969),
    [sym__plus_operator] = ACTIONS(11969),
    [sym__times_operator] = ACTIONS(11969),
    [sym__rational_operator] = ACTIONS(11971),
    [sym__bitshift_operator] = ACTIONS(11971),
    [sym__power_operator] = ACTIONS(11971),
    [sym__tilde_operator] = ACTIONS(11971),
    [sym__type_order_operator] = ACTIONS(11971),
    [sym__unary_operator] = ACTIONS(11969),
    [sym__unary_plus_operator] = ACTIONS(11969),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9231] = {
    [sym_block_comment] = STATE(9231),
    [sym_line_comment] = STATE(9231),
    [sym__word_identifier] = ACTIONS(12048),
    [anon_sym_COMMA] = ACTIONS(12050),
    [anon_sym_EQ] = ACTIONS(12048),
    [anon_sym_begin] = ACTIONS(12048),
    [anon_sym_module] = ACTIONS(12048),
    [anon_sym_baremodule] = ACTIONS(12048),
    [anon_sym_end] = ACTIONS(12048),
    [anon_sym_abstract] = ACTIONS(12048),
    [anon_sym_primitive] = ACTIONS(12048),
    [anon_sym_mutable] = ACTIONS(12048),
    [anon_sym_struct] = ACTIONS(12048),
    [anon_sym_function] = ACTIONS(12048),
    [anon_sym_macro] = ACTIONS(12048),
    [anon_sym_quote] = ACTIONS(12048),
    [anon_sym_let] = ACTIONS(12048),
    [anon_sym_if] = ACTIONS(12048),
    [anon_sym_try] = ACTIONS(12048),
    [anon_sym_for] = ACTIONS(12048),
    [anon_sym_while] = ACTIONS(12048),
    [sym_break_statement] = ACTIONS(12048),
    [sym_continue_statement] = ACTIONS(12048),
    [anon_sym_return] = ACTIONS(12048),
    [anon_sym_const] = ACTIONS(12048),
    [anon_sym_global] = ACTIONS(12048),
    [anon_sym_local] = ACTIONS(12048),
    [anon_sym_LPAREN] = ACTIONS(12050),
    [anon_sym_COLON] = ACTIONS(12048),
    [anon_sym_export] = ACTIONS(12048),
    [anon_sym_public] = ACTIONS(12048),
    [anon_sym_import] = ACTIONS(12048),
    [anon_sym_using] = ACTIONS(12048),
    [anon_sym_LBRACK] = ACTIONS(12050),
    [anon_sym_in] = ACTIONS(12048),
    [anon_sym_LBRACE] = ACTIONS(12050),
    [anon_sym_DOLLAR] = ACTIONS(12050),
    [anon_sym_COLON2] = ACTIONS(12048),
    [anon_sym_COLON_COLON] = ACTIONS(12050),
    [anon_sym_isa] = ACTIONS(12048),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12050),
    [anon_sym_QMARK] = ACTIONS(12050),
    [anon_sym_where] = ACTIONS(12048),
    [anon_sym_AT] = ACTIONS(12050),
    [anon_sym_true] = ACTIONS(12048),
    [anon_sym_false] = ACTIONS(12048),
    [aux_sym_integer_literal_token1] = ACTIONS(12050),
    [aux_sym_integer_literal_token2] = ACTIONS(12050),
    [aux_sym_integer_literal_token3] = ACTIONS(12048),
    [aux_sym_integer_literal_token4] = ACTIONS(12048),
    [aux_sym_float_literal_token1] = ACTIONS(12050),
    [aux_sym_float_literal_token3] = ACTIONS(12050),
    [aux_sym_float_literal_token4] = ACTIONS(12050),
    [sym_character_literal] = ACTIONS(12050),
    [anon_sym_DQUOTE] = ACTIONS(12048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12050),
    [anon_sym_BQUOTE] = ACTIONS(12048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12050),
    [sym__pair_operator] = ACTIONS(12050),
    [sym__arrow_operator] = ACTIONS(12048),
    [sym__lazy_or_operator] = ACTIONS(12050),
    [sym__lazy_and_operator] = ACTIONS(12050),
    [sym__comparison_operator] = ACTIONS(12048),
    [sym__pipe_right_operator] = ACTIONS(12050),
    [sym__pipe_left_operator] = ACTIONS(12050),
    [sym__ellipsis_operator] = ACTIONS(12048),
    [sym__plus_operator] = ACTIONS(12048),
    [sym__times_operator] = ACTIONS(12048),
    [sym__rational_operator] = ACTIONS(12050),
    [sym__bitshift_operator] = ACTIONS(12050),
    [sym__power_operator] = ACTIONS(12050),
    [sym__tilde_operator] = ACTIONS(12050),
    [sym__type_order_operator] = ACTIONS(12050),
    [sym__unary_operator] = ACTIONS(12048),
    [sym__unary_plus_operator] = ACTIONS(12048),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9232] = {
    [sym_block_comment] = STATE(9232),
    [sym_line_comment] = STATE(9232),
    [sym__word_identifier] = ACTIONS(12052),
    [anon_sym_COMMA] = ACTIONS(12054),
    [anon_sym_EQ] = ACTIONS(12052),
    [anon_sym_begin] = ACTIONS(12052),
    [anon_sym_module] = ACTIONS(12052),
    [anon_sym_baremodule] = ACTIONS(12052),
    [anon_sym_end] = ACTIONS(12052),
    [anon_sym_abstract] = ACTIONS(12052),
    [anon_sym_primitive] = ACTIONS(12052),
    [anon_sym_mutable] = ACTIONS(12052),
    [anon_sym_struct] = ACTIONS(12052),
    [anon_sym_function] = ACTIONS(12052),
    [anon_sym_macro] = ACTIONS(12052),
    [anon_sym_quote] = ACTIONS(12052),
    [anon_sym_let] = ACTIONS(12052),
    [anon_sym_if] = ACTIONS(12052),
    [anon_sym_try] = ACTIONS(12052),
    [anon_sym_for] = ACTIONS(12052),
    [anon_sym_while] = ACTIONS(12052),
    [sym_break_statement] = ACTIONS(12052),
    [sym_continue_statement] = ACTIONS(12052),
    [anon_sym_return] = ACTIONS(12052),
    [anon_sym_const] = ACTIONS(12052),
    [anon_sym_global] = ACTIONS(12052),
    [anon_sym_local] = ACTIONS(12052),
    [anon_sym_LPAREN] = ACTIONS(12054),
    [anon_sym_COLON] = ACTIONS(12052),
    [anon_sym_export] = ACTIONS(12052),
    [anon_sym_public] = ACTIONS(12052),
    [anon_sym_import] = ACTIONS(12052),
    [anon_sym_using] = ACTIONS(12052),
    [anon_sym_LBRACK] = ACTIONS(12054),
    [anon_sym_in] = ACTIONS(12052),
    [anon_sym_LBRACE] = ACTIONS(12054),
    [anon_sym_DOLLAR] = ACTIONS(12054),
    [anon_sym_COLON2] = ACTIONS(12052),
    [anon_sym_COLON_COLON] = ACTIONS(12054),
    [anon_sym_isa] = ACTIONS(12052),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12054),
    [anon_sym_QMARK] = ACTIONS(12054),
    [anon_sym_where] = ACTIONS(12052),
    [anon_sym_AT] = ACTIONS(12054),
    [anon_sym_true] = ACTIONS(12052),
    [anon_sym_false] = ACTIONS(12052),
    [aux_sym_integer_literal_token1] = ACTIONS(12054),
    [aux_sym_integer_literal_token2] = ACTIONS(12054),
    [aux_sym_integer_literal_token3] = ACTIONS(12052),
    [aux_sym_integer_literal_token4] = ACTIONS(12052),
    [aux_sym_float_literal_token1] = ACTIONS(12054),
    [aux_sym_float_literal_token3] = ACTIONS(12054),
    [aux_sym_float_literal_token4] = ACTIONS(12054),
    [sym_character_literal] = ACTIONS(12054),
    [anon_sym_DQUOTE] = ACTIONS(12052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12054),
    [anon_sym_BQUOTE] = ACTIONS(12052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12054),
    [sym__pair_operator] = ACTIONS(12054),
    [sym__arrow_operator] = ACTIONS(12052),
    [sym__lazy_or_operator] = ACTIONS(12054),
    [sym__lazy_and_operator] = ACTIONS(12054),
    [sym__comparison_operator] = ACTIONS(12052),
    [sym__pipe_right_operator] = ACTIONS(12054),
    [sym__pipe_left_operator] = ACTIONS(12054),
    [sym__ellipsis_operator] = ACTIONS(12052),
    [sym__plus_operator] = ACTIONS(12052),
    [sym__times_operator] = ACTIONS(12052),
    [sym__rational_operator] = ACTIONS(12054),
    [sym__bitshift_operator] = ACTIONS(12054),
    [sym__power_operator] = ACTIONS(12054),
    [sym__tilde_operator] = ACTIONS(12054),
    [sym__type_order_operator] = ACTIONS(12054),
    [sym__unary_operator] = ACTIONS(12052),
    [sym__unary_plus_operator] = ACTIONS(12052),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9233] = {
    [sym_block_comment] = STATE(9233),
    [sym_line_comment] = STATE(9233),
    [sym__word_identifier] = ACTIONS(11033),
    [anon_sym_COMMA] = ACTIONS(11035),
    [anon_sym_EQ] = ACTIONS(11033),
    [anon_sym_begin] = ACTIONS(11033),
    [anon_sym_module] = ACTIONS(11033),
    [anon_sym_baremodule] = ACTIONS(11033),
    [anon_sym_end] = ACTIONS(11033),
    [anon_sym_abstract] = ACTIONS(11033),
    [anon_sym_primitive] = ACTIONS(11033),
    [anon_sym_mutable] = ACTIONS(11033),
    [anon_sym_struct] = ACTIONS(11033),
    [anon_sym_function] = ACTIONS(11033),
    [anon_sym_macro] = ACTIONS(11033),
    [anon_sym_quote] = ACTIONS(11033),
    [anon_sym_let] = ACTIONS(11033),
    [anon_sym_if] = ACTIONS(11033),
    [anon_sym_try] = ACTIONS(11033),
    [anon_sym_for] = ACTIONS(11033),
    [anon_sym_while] = ACTIONS(11033),
    [sym_break_statement] = ACTIONS(11033),
    [sym_continue_statement] = ACTIONS(11033),
    [anon_sym_return] = ACTIONS(11033),
    [anon_sym_const] = ACTIONS(11033),
    [anon_sym_global] = ACTIONS(11033),
    [anon_sym_local] = ACTIONS(11033),
    [anon_sym_LPAREN] = ACTIONS(11035),
    [anon_sym_COLON] = ACTIONS(11033),
    [anon_sym_export] = ACTIONS(11033),
    [anon_sym_public] = ACTIONS(11033),
    [anon_sym_import] = ACTIONS(11033),
    [anon_sym_using] = ACTIONS(11033),
    [anon_sym_LBRACK] = ACTIONS(11035),
    [anon_sym_in] = ACTIONS(11033),
    [anon_sym_LBRACE] = ACTIONS(11035),
    [anon_sym_DOLLAR] = ACTIONS(11035),
    [anon_sym_COLON2] = ACTIONS(11033),
    [anon_sym_COLON_COLON] = ACTIONS(11035),
    [anon_sym_isa] = ACTIONS(11033),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11035),
    [anon_sym_QMARK] = ACTIONS(11035),
    [anon_sym_where] = ACTIONS(11033),
    [anon_sym_AT] = ACTIONS(11035),
    [anon_sym_true] = ACTIONS(11033),
    [anon_sym_false] = ACTIONS(11033),
    [aux_sym_integer_literal_token1] = ACTIONS(11035),
    [aux_sym_integer_literal_token2] = ACTIONS(11035),
    [aux_sym_integer_literal_token3] = ACTIONS(11033),
    [aux_sym_integer_literal_token4] = ACTIONS(11033),
    [aux_sym_float_literal_token1] = ACTIONS(11035),
    [aux_sym_float_literal_token3] = ACTIONS(11035),
    [aux_sym_float_literal_token4] = ACTIONS(11035),
    [sym_character_literal] = ACTIONS(11035),
    [anon_sym_DQUOTE] = ACTIONS(11033),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11035),
    [anon_sym_BQUOTE] = ACTIONS(11033),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11035),
    [sym__pair_operator] = ACTIONS(11035),
    [sym__arrow_operator] = ACTIONS(11033),
    [sym__lazy_or_operator] = ACTIONS(11035),
    [sym__lazy_and_operator] = ACTIONS(11035),
    [sym__comparison_operator] = ACTIONS(11033),
    [sym__pipe_right_operator] = ACTIONS(11035),
    [sym__pipe_left_operator] = ACTIONS(11035),
    [sym__ellipsis_operator] = ACTIONS(11033),
    [sym__plus_operator] = ACTIONS(11033),
    [sym__times_operator] = ACTIONS(11033),
    [sym__rational_operator] = ACTIONS(11035),
    [sym__bitshift_operator] = ACTIONS(11035),
    [sym__power_operator] = ACTIONS(11035),
    [sym__tilde_operator] = ACTIONS(11035),
    [sym__type_order_operator] = ACTIONS(11035),
    [sym__unary_operator] = ACTIONS(11033),
    [sym__unary_plus_operator] = ACTIONS(11033),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9234] = {
    [sym_block_comment] = STATE(9234),
    [sym_line_comment] = STATE(9234),
    [sym__word_identifier] = ACTIONS(11039),
    [anon_sym_COMMA] = ACTIONS(11041),
    [anon_sym_EQ] = ACTIONS(11039),
    [anon_sym_begin] = ACTIONS(11039),
    [anon_sym_module] = ACTIONS(11039),
    [anon_sym_baremodule] = ACTIONS(11039),
    [anon_sym_end] = ACTIONS(11039),
    [anon_sym_abstract] = ACTIONS(11039),
    [anon_sym_primitive] = ACTIONS(11039),
    [anon_sym_mutable] = ACTIONS(11039),
    [anon_sym_struct] = ACTIONS(11039),
    [anon_sym_function] = ACTIONS(11039),
    [anon_sym_macro] = ACTIONS(11039),
    [anon_sym_quote] = ACTIONS(11039),
    [anon_sym_let] = ACTIONS(11039),
    [anon_sym_if] = ACTIONS(11039),
    [anon_sym_try] = ACTIONS(11039),
    [anon_sym_for] = ACTIONS(11039),
    [anon_sym_while] = ACTIONS(11039),
    [sym_break_statement] = ACTIONS(11039),
    [sym_continue_statement] = ACTIONS(11039),
    [anon_sym_return] = ACTIONS(11039),
    [anon_sym_const] = ACTIONS(11039),
    [anon_sym_global] = ACTIONS(11039),
    [anon_sym_local] = ACTIONS(11039),
    [anon_sym_LPAREN] = ACTIONS(11041),
    [anon_sym_COLON] = ACTIONS(11039),
    [anon_sym_export] = ACTIONS(11039),
    [anon_sym_public] = ACTIONS(11039),
    [anon_sym_import] = ACTIONS(11039),
    [anon_sym_using] = ACTIONS(11039),
    [anon_sym_LBRACK] = ACTIONS(11041),
    [anon_sym_in] = ACTIONS(11039),
    [anon_sym_LBRACE] = ACTIONS(11041),
    [anon_sym_DOLLAR] = ACTIONS(11041),
    [anon_sym_COLON2] = ACTIONS(11039),
    [anon_sym_COLON_COLON] = ACTIONS(11041),
    [anon_sym_isa] = ACTIONS(11039),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11041),
    [anon_sym_QMARK] = ACTIONS(11041),
    [anon_sym_where] = ACTIONS(11039),
    [anon_sym_AT] = ACTIONS(11041),
    [anon_sym_true] = ACTIONS(11039),
    [anon_sym_false] = ACTIONS(11039),
    [aux_sym_integer_literal_token1] = ACTIONS(11041),
    [aux_sym_integer_literal_token2] = ACTIONS(11041),
    [aux_sym_integer_literal_token3] = ACTIONS(11039),
    [aux_sym_integer_literal_token4] = ACTIONS(11039),
    [aux_sym_float_literal_token1] = ACTIONS(11041),
    [aux_sym_float_literal_token3] = ACTIONS(11041),
    [aux_sym_float_literal_token4] = ACTIONS(11041),
    [sym_character_literal] = ACTIONS(11041),
    [anon_sym_DQUOTE] = ACTIONS(11039),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11041),
    [anon_sym_BQUOTE] = ACTIONS(11039),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11041),
    [sym__pair_operator] = ACTIONS(11041),
    [sym__arrow_operator] = ACTIONS(11039),
    [sym__lazy_or_operator] = ACTIONS(11041),
    [sym__lazy_and_operator] = ACTIONS(11041),
    [sym__comparison_operator] = ACTIONS(11039),
    [sym__pipe_right_operator] = ACTIONS(11041),
    [sym__pipe_left_operator] = ACTIONS(11041),
    [sym__ellipsis_operator] = ACTIONS(11039),
    [sym__plus_operator] = ACTIONS(11039),
    [sym__times_operator] = ACTIONS(11039),
    [sym__rational_operator] = ACTIONS(11041),
    [sym__bitshift_operator] = ACTIONS(11041),
    [sym__power_operator] = ACTIONS(11041),
    [sym__tilde_operator] = ACTIONS(11041),
    [sym__type_order_operator] = ACTIONS(11041),
    [sym__unary_operator] = ACTIONS(11039),
    [sym__unary_plus_operator] = ACTIONS(11039),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9235] = {
    [sym_block_comment] = STATE(9235),
    [sym_line_comment] = STATE(9235),
    [sym__word_identifier] = ACTIONS(11043),
    [anon_sym_COMMA] = ACTIONS(11045),
    [anon_sym_EQ] = ACTIONS(11043),
    [anon_sym_begin] = ACTIONS(11043),
    [anon_sym_module] = ACTIONS(11043),
    [anon_sym_baremodule] = ACTIONS(11043),
    [anon_sym_end] = ACTIONS(11043),
    [anon_sym_abstract] = ACTIONS(11043),
    [anon_sym_primitive] = ACTIONS(11043),
    [anon_sym_mutable] = ACTIONS(11043),
    [anon_sym_struct] = ACTIONS(11043),
    [anon_sym_function] = ACTIONS(11043),
    [anon_sym_macro] = ACTIONS(11043),
    [anon_sym_quote] = ACTIONS(11043),
    [anon_sym_let] = ACTIONS(11043),
    [anon_sym_if] = ACTIONS(11043),
    [anon_sym_try] = ACTIONS(11043),
    [anon_sym_for] = ACTIONS(11043),
    [anon_sym_while] = ACTIONS(11043),
    [sym_break_statement] = ACTIONS(11043),
    [sym_continue_statement] = ACTIONS(11043),
    [anon_sym_return] = ACTIONS(11043),
    [anon_sym_const] = ACTIONS(11043),
    [anon_sym_global] = ACTIONS(11043),
    [anon_sym_local] = ACTIONS(11043),
    [anon_sym_LPAREN] = ACTIONS(11045),
    [anon_sym_COLON] = ACTIONS(11043),
    [anon_sym_export] = ACTIONS(11043),
    [anon_sym_public] = ACTIONS(11043),
    [anon_sym_import] = ACTIONS(11043),
    [anon_sym_using] = ACTIONS(11043),
    [anon_sym_LBRACK] = ACTIONS(11045),
    [anon_sym_in] = ACTIONS(11043),
    [anon_sym_LBRACE] = ACTIONS(11045),
    [anon_sym_DOLLAR] = ACTIONS(11045),
    [anon_sym_COLON2] = ACTIONS(11043),
    [anon_sym_COLON_COLON] = ACTIONS(11045),
    [anon_sym_isa] = ACTIONS(11043),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11045),
    [anon_sym_QMARK] = ACTIONS(11045),
    [anon_sym_where] = ACTIONS(11043),
    [anon_sym_AT] = ACTIONS(11045),
    [anon_sym_true] = ACTIONS(11043),
    [anon_sym_false] = ACTIONS(11043),
    [aux_sym_integer_literal_token1] = ACTIONS(11045),
    [aux_sym_integer_literal_token2] = ACTIONS(11045),
    [aux_sym_integer_literal_token3] = ACTIONS(11043),
    [aux_sym_integer_literal_token4] = ACTIONS(11043),
    [aux_sym_float_literal_token1] = ACTIONS(11045),
    [aux_sym_float_literal_token3] = ACTIONS(11045),
    [aux_sym_float_literal_token4] = ACTIONS(11045),
    [sym_character_literal] = ACTIONS(11045),
    [anon_sym_DQUOTE] = ACTIONS(11043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11045),
    [anon_sym_BQUOTE] = ACTIONS(11043),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11045),
    [sym__pair_operator] = ACTIONS(11045),
    [sym__arrow_operator] = ACTIONS(11043),
    [sym__lazy_or_operator] = ACTIONS(11045),
    [sym__lazy_and_operator] = ACTIONS(11045),
    [sym__comparison_operator] = ACTIONS(11043),
    [sym__pipe_right_operator] = ACTIONS(11045),
    [sym__pipe_left_operator] = ACTIONS(11045),
    [sym__ellipsis_operator] = ACTIONS(11043),
    [sym__plus_operator] = ACTIONS(11043),
    [sym__times_operator] = ACTIONS(11043),
    [sym__rational_operator] = ACTIONS(11045),
    [sym__bitshift_operator] = ACTIONS(11045),
    [sym__power_operator] = ACTIONS(11045),
    [sym__tilde_operator] = ACTIONS(11045),
    [sym__type_order_operator] = ACTIONS(11045),
    [sym__unary_operator] = ACTIONS(11043),
    [sym__unary_plus_operator] = ACTIONS(11043),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9236] = {
    [sym_block_comment] = STATE(9236),
    [sym_line_comment] = STATE(9236),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9237] = {
    [sym_block_comment] = STATE(9237),
    [sym_line_comment] = STATE(9237),
    [sym__word_identifier] = ACTIONS(11116),
    [anon_sym_COMMA] = ACTIONS(11118),
    [anon_sym_EQ] = ACTIONS(11116),
    [anon_sym_begin] = ACTIONS(11116),
    [anon_sym_module] = ACTIONS(11116),
    [anon_sym_baremodule] = ACTIONS(11116),
    [anon_sym_end] = ACTIONS(11116),
    [anon_sym_abstract] = ACTIONS(11116),
    [anon_sym_primitive] = ACTIONS(11116),
    [anon_sym_mutable] = ACTIONS(11116),
    [anon_sym_struct] = ACTIONS(11116),
    [anon_sym_function] = ACTIONS(11116),
    [anon_sym_macro] = ACTIONS(11116),
    [anon_sym_quote] = ACTIONS(11116),
    [anon_sym_let] = ACTIONS(11116),
    [anon_sym_if] = ACTIONS(11116),
    [anon_sym_try] = ACTIONS(11116),
    [anon_sym_for] = ACTIONS(11116),
    [anon_sym_while] = ACTIONS(11116),
    [sym_break_statement] = ACTIONS(11116),
    [sym_continue_statement] = ACTIONS(11116),
    [anon_sym_return] = ACTIONS(11116),
    [anon_sym_const] = ACTIONS(11116),
    [anon_sym_global] = ACTIONS(11116),
    [anon_sym_local] = ACTIONS(11116),
    [anon_sym_LPAREN] = ACTIONS(11118),
    [anon_sym_COLON] = ACTIONS(11116),
    [anon_sym_export] = ACTIONS(11116),
    [anon_sym_public] = ACTIONS(11116),
    [anon_sym_import] = ACTIONS(11116),
    [anon_sym_using] = ACTIONS(11116),
    [anon_sym_LBRACK] = ACTIONS(11118),
    [anon_sym_in] = ACTIONS(11116),
    [anon_sym_LBRACE] = ACTIONS(11118),
    [anon_sym_DOLLAR] = ACTIONS(11118),
    [anon_sym_COLON2] = ACTIONS(11116),
    [anon_sym_COLON_COLON] = ACTIONS(11118),
    [anon_sym_isa] = ACTIONS(11116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11118),
    [anon_sym_QMARK] = ACTIONS(11118),
    [anon_sym_where] = ACTIONS(11116),
    [anon_sym_AT] = ACTIONS(11118),
    [anon_sym_true] = ACTIONS(11116),
    [anon_sym_false] = ACTIONS(11116),
    [aux_sym_integer_literal_token1] = ACTIONS(11118),
    [aux_sym_integer_literal_token2] = ACTIONS(11118),
    [aux_sym_integer_literal_token3] = ACTIONS(11116),
    [aux_sym_integer_literal_token4] = ACTIONS(11116),
    [aux_sym_float_literal_token1] = ACTIONS(11118),
    [aux_sym_float_literal_token3] = ACTIONS(11118),
    [aux_sym_float_literal_token4] = ACTIONS(11118),
    [sym_character_literal] = ACTIONS(11118),
    [anon_sym_DQUOTE] = ACTIONS(11116),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11118),
    [anon_sym_BQUOTE] = ACTIONS(11116),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11118),
    [sym__pair_operator] = ACTIONS(11118),
    [sym__arrow_operator] = ACTIONS(11116),
    [sym__lazy_or_operator] = ACTIONS(11118),
    [sym__lazy_and_operator] = ACTIONS(11118),
    [sym__comparison_operator] = ACTIONS(11116),
    [sym__pipe_right_operator] = ACTIONS(11118),
    [sym__pipe_left_operator] = ACTIONS(11118),
    [sym__ellipsis_operator] = ACTIONS(11116),
    [sym__plus_operator] = ACTIONS(11116),
    [sym__times_operator] = ACTIONS(11116),
    [sym__rational_operator] = ACTIONS(11118),
    [sym__bitshift_operator] = ACTIONS(11118),
    [sym__power_operator] = ACTIONS(11118),
    [sym__tilde_operator] = ACTIONS(11118),
    [sym__type_order_operator] = ACTIONS(11118),
    [sym__unary_operator] = ACTIONS(11116),
    [sym__unary_plus_operator] = ACTIONS(11116),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9238] = {
    [sym_block_comment] = STATE(9238),
    [sym_line_comment] = STATE(9238),
    [sym__word_identifier] = ACTIONS(11251),
    [anon_sym_COMMA] = ACTIONS(11253),
    [anon_sym_EQ] = ACTIONS(11251),
    [anon_sym_begin] = ACTIONS(11251),
    [anon_sym_module] = ACTIONS(11251),
    [anon_sym_baremodule] = ACTIONS(11251),
    [anon_sym_end] = ACTIONS(11251),
    [anon_sym_abstract] = ACTIONS(11251),
    [anon_sym_primitive] = ACTIONS(11251),
    [anon_sym_mutable] = ACTIONS(11251),
    [anon_sym_struct] = ACTIONS(11251),
    [anon_sym_function] = ACTIONS(11251),
    [anon_sym_macro] = ACTIONS(11251),
    [anon_sym_quote] = ACTIONS(11251),
    [anon_sym_let] = ACTIONS(11251),
    [anon_sym_if] = ACTIONS(11251),
    [anon_sym_try] = ACTIONS(11251),
    [anon_sym_for] = ACTIONS(11251),
    [anon_sym_while] = ACTIONS(11251),
    [sym_break_statement] = ACTIONS(11251),
    [sym_continue_statement] = ACTIONS(11251),
    [anon_sym_return] = ACTIONS(11251),
    [anon_sym_const] = ACTIONS(11251),
    [anon_sym_global] = ACTIONS(11251),
    [anon_sym_local] = ACTIONS(11251),
    [anon_sym_LPAREN] = ACTIONS(11253),
    [anon_sym_COLON] = ACTIONS(11251),
    [anon_sym_export] = ACTIONS(11251),
    [anon_sym_public] = ACTIONS(11251),
    [anon_sym_import] = ACTIONS(11251),
    [anon_sym_using] = ACTIONS(11251),
    [anon_sym_LBRACK] = ACTIONS(11253),
    [anon_sym_in] = ACTIONS(11251),
    [anon_sym_LBRACE] = ACTIONS(11253),
    [anon_sym_DOLLAR] = ACTIONS(11253),
    [anon_sym_COLON2] = ACTIONS(11251),
    [anon_sym_COLON_COLON] = ACTIONS(11253),
    [anon_sym_isa] = ACTIONS(11251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11253),
    [anon_sym_QMARK] = ACTIONS(11253),
    [anon_sym_where] = ACTIONS(11251),
    [anon_sym_AT] = ACTIONS(11253),
    [anon_sym_true] = ACTIONS(11251),
    [anon_sym_false] = ACTIONS(11251),
    [aux_sym_integer_literal_token1] = ACTIONS(11253),
    [aux_sym_integer_literal_token2] = ACTIONS(11253),
    [aux_sym_integer_literal_token3] = ACTIONS(11251),
    [aux_sym_integer_literal_token4] = ACTIONS(11251),
    [aux_sym_float_literal_token1] = ACTIONS(11253),
    [aux_sym_float_literal_token3] = ACTIONS(11253),
    [aux_sym_float_literal_token4] = ACTIONS(11253),
    [sym_character_literal] = ACTIONS(11253),
    [anon_sym_DQUOTE] = ACTIONS(11251),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11253),
    [anon_sym_BQUOTE] = ACTIONS(11251),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11253),
    [sym__pair_operator] = ACTIONS(11253),
    [sym__arrow_operator] = ACTIONS(11251),
    [sym__lazy_or_operator] = ACTIONS(11253),
    [sym__lazy_and_operator] = ACTIONS(11253),
    [sym__comparison_operator] = ACTIONS(11251),
    [sym__pipe_right_operator] = ACTIONS(11253),
    [sym__pipe_left_operator] = ACTIONS(11253),
    [sym__ellipsis_operator] = ACTIONS(11251),
    [sym__plus_operator] = ACTIONS(11251),
    [sym__times_operator] = ACTIONS(11251),
    [sym__rational_operator] = ACTIONS(11253),
    [sym__bitshift_operator] = ACTIONS(11253),
    [sym__power_operator] = ACTIONS(11253),
    [sym__tilde_operator] = ACTIONS(11253),
    [sym__type_order_operator] = ACTIONS(11253),
    [sym__unary_operator] = ACTIONS(11251),
    [sym__unary_plus_operator] = ACTIONS(11251),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9239] = {
    [sym_block_comment] = STATE(9239),
    [sym_line_comment] = STATE(9239),
    [sym__word_identifier] = ACTIONS(11197),
    [anon_sym_COMMA] = ACTIONS(11199),
    [anon_sym_EQ] = ACTIONS(11197),
    [anon_sym_begin] = ACTIONS(11197),
    [anon_sym_module] = ACTIONS(11197),
    [anon_sym_baremodule] = ACTIONS(11197),
    [anon_sym_end] = ACTIONS(11197),
    [anon_sym_abstract] = ACTIONS(11197),
    [anon_sym_primitive] = ACTIONS(11197),
    [anon_sym_mutable] = ACTIONS(11197),
    [anon_sym_struct] = ACTIONS(11197),
    [anon_sym_function] = ACTIONS(11197),
    [anon_sym_macro] = ACTIONS(11197),
    [anon_sym_quote] = ACTIONS(11197),
    [anon_sym_let] = ACTIONS(11197),
    [anon_sym_if] = ACTIONS(11197),
    [anon_sym_try] = ACTIONS(11197),
    [anon_sym_for] = ACTIONS(11197),
    [anon_sym_while] = ACTIONS(11197),
    [sym_break_statement] = ACTIONS(11197),
    [sym_continue_statement] = ACTIONS(11197),
    [anon_sym_return] = ACTIONS(11197),
    [anon_sym_const] = ACTIONS(11197),
    [anon_sym_global] = ACTIONS(11197),
    [anon_sym_local] = ACTIONS(11197),
    [anon_sym_LPAREN] = ACTIONS(11199),
    [anon_sym_COLON] = ACTIONS(11197),
    [anon_sym_export] = ACTIONS(11197),
    [anon_sym_public] = ACTIONS(11197),
    [anon_sym_import] = ACTIONS(11197),
    [anon_sym_using] = ACTIONS(11197),
    [anon_sym_LBRACK] = ACTIONS(11199),
    [anon_sym_in] = ACTIONS(11197),
    [anon_sym_LBRACE] = ACTIONS(11199),
    [anon_sym_DOLLAR] = ACTIONS(11199),
    [anon_sym_COLON2] = ACTIONS(11197),
    [anon_sym_COLON_COLON] = ACTIONS(11199),
    [anon_sym_isa] = ACTIONS(11197),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11199),
    [anon_sym_QMARK] = ACTIONS(11199),
    [anon_sym_where] = ACTIONS(11197),
    [anon_sym_AT] = ACTIONS(11199),
    [anon_sym_true] = ACTIONS(11197),
    [anon_sym_false] = ACTIONS(11197),
    [aux_sym_integer_literal_token1] = ACTIONS(11199),
    [aux_sym_integer_literal_token2] = ACTIONS(11199),
    [aux_sym_integer_literal_token3] = ACTIONS(11197),
    [aux_sym_integer_literal_token4] = ACTIONS(11197),
    [aux_sym_float_literal_token1] = ACTIONS(11199),
    [aux_sym_float_literal_token3] = ACTIONS(11199),
    [aux_sym_float_literal_token4] = ACTIONS(11199),
    [sym_character_literal] = ACTIONS(11199),
    [anon_sym_DQUOTE] = ACTIONS(11197),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11199),
    [anon_sym_BQUOTE] = ACTIONS(11197),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11199),
    [sym__pair_operator] = ACTIONS(11199),
    [sym__arrow_operator] = ACTIONS(11197),
    [sym__lazy_or_operator] = ACTIONS(11199),
    [sym__lazy_and_operator] = ACTIONS(11199),
    [sym__comparison_operator] = ACTIONS(11197),
    [sym__pipe_right_operator] = ACTIONS(11199),
    [sym__pipe_left_operator] = ACTIONS(11199),
    [sym__ellipsis_operator] = ACTIONS(11197),
    [sym__plus_operator] = ACTIONS(11197),
    [sym__times_operator] = ACTIONS(11197),
    [sym__rational_operator] = ACTIONS(11199),
    [sym__bitshift_operator] = ACTIONS(11199),
    [sym__power_operator] = ACTIONS(11199),
    [sym__tilde_operator] = ACTIONS(11199),
    [sym__type_order_operator] = ACTIONS(11199),
    [sym__unary_operator] = ACTIONS(11197),
    [sym__unary_plus_operator] = ACTIONS(11197),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9240] = {
    [sym_block_comment] = STATE(9240),
    [sym_line_comment] = STATE(9240),
    [sym__word_identifier] = ACTIONS(11211),
    [anon_sym_COMMA] = ACTIONS(11213),
    [anon_sym_EQ] = ACTIONS(11211),
    [anon_sym_begin] = ACTIONS(11211),
    [anon_sym_module] = ACTIONS(11211),
    [anon_sym_baremodule] = ACTIONS(11211),
    [anon_sym_end] = ACTIONS(11211),
    [anon_sym_abstract] = ACTIONS(11211),
    [anon_sym_primitive] = ACTIONS(11211),
    [anon_sym_mutable] = ACTIONS(11211),
    [anon_sym_struct] = ACTIONS(11211),
    [anon_sym_function] = ACTIONS(11211),
    [anon_sym_macro] = ACTIONS(11211),
    [anon_sym_quote] = ACTIONS(11211),
    [anon_sym_let] = ACTIONS(11211),
    [anon_sym_if] = ACTIONS(11211),
    [anon_sym_try] = ACTIONS(11211),
    [anon_sym_for] = ACTIONS(11211),
    [anon_sym_while] = ACTIONS(11211),
    [sym_break_statement] = ACTIONS(11211),
    [sym_continue_statement] = ACTIONS(11211),
    [anon_sym_return] = ACTIONS(11211),
    [anon_sym_const] = ACTIONS(11211),
    [anon_sym_global] = ACTIONS(11211),
    [anon_sym_local] = ACTIONS(11211),
    [anon_sym_LPAREN] = ACTIONS(11213),
    [anon_sym_COLON] = ACTIONS(11211),
    [anon_sym_export] = ACTIONS(11211),
    [anon_sym_public] = ACTIONS(11211),
    [anon_sym_import] = ACTIONS(11211),
    [anon_sym_using] = ACTIONS(11211),
    [anon_sym_LBRACK] = ACTIONS(11213),
    [anon_sym_in] = ACTIONS(11211),
    [anon_sym_LBRACE] = ACTIONS(11213),
    [anon_sym_DOLLAR] = ACTIONS(11213),
    [anon_sym_COLON2] = ACTIONS(11211),
    [anon_sym_COLON_COLON] = ACTIONS(11213),
    [anon_sym_isa] = ACTIONS(11211),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11213),
    [anon_sym_QMARK] = ACTIONS(11213),
    [anon_sym_where] = ACTIONS(11211),
    [anon_sym_AT] = ACTIONS(11213),
    [anon_sym_true] = ACTIONS(11211),
    [anon_sym_false] = ACTIONS(11211),
    [aux_sym_integer_literal_token1] = ACTIONS(11213),
    [aux_sym_integer_literal_token2] = ACTIONS(11213),
    [aux_sym_integer_literal_token3] = ACTIONS(11211),
    [aux_sym_integer_literal_token4] = ACTIONS(11211),
    [aux_sym_float_literal_token1] = ACTIONS(11213),
    [aux_sym_float_literal_token3] = ACTIONS(11213),
    [aux_sym_float_literal_token4] = ACTIONS(11213),
    [sym_character_literal] = ACTIONS(11213),
    [anon_sym_DQUOTE] = ACTIONS(11211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11213),
    [anon_sym_BQUOTE] = ACTIONS(11211),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11213),
    [sym__pair_operator] = ACTIONS(11213),
    [sym__arrow_operator] = ACTIONS(11211),
    [sym__lazy_or_operator] = ACTIONS(11213),
    [sym__lazy_and_operator] = ACTIONS(11213),
    [sym__comparison_operator] = ACTIONS(11211),
    [sym__pipe_right_operator] = ACTIONS(11213),
    [sym__pipe_left_operator] = ACTIONS(11213),
    [sym__ellipsis_operator] = ACTIONS(11211),
    [sym__plus_operator] = ACTIONS(11211),
    [sym__times_operator] = ACTIONS(11211),
    [sym__rational_operator] = ACTIONS(11213),
    [sym__bitshift_operator] = ACTIONS(11213),
    [sym__power_operator] = ACTIONS(11213),
    [sym__tilde_operator] = ACTIONS(11213),
    [sym__type_order_operator] = ACTIONS(11213),
    [sym__unary_operator] = ACTIONS(11211),
    [sym__unary_plus_operator] = ACTIONS(11211),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9241] = {
    [sym_block_comment] = STATE(9241),
    [sym_line_comment] = STATE(9241),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11114),
    [anon_sym_EQ] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11114),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11114),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11114),
    [anon_sym_DOLLAR] = ACTIONS(11114),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11114),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11114),
    [aux_sym_integer_literal_token2] = ACTIONS(11114),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11114),
    [aux_sym_float_literal_token3] = ACTIONS(11114),
    [aux_sym_float_literal_token4] = ACTIONS(11114),
    [sym_character_literal] = ACTIONS(11114),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11114),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11114),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11114),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9242] = {
    [sym_block_comment] = STATE(9242),
    [sym_line_comment] = STATE(9242),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_EQ] = ACTIONS(10978),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(10978),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(10978),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(10982),
    [anon_sym_isa] = ACTIONS(10978),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10982),
    [anon_sym_QMARK] = ACTIONS(10982),
    [anon_sym_where] = ACTIONS(10978),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(10978),
    [sym__lazy_or_operator] = ACTIONS(10982),
    [sym__lazy_and_operator] = ACTIONS(10982),
    [sym__comparison_operator] = ACTIONS(10978),
    [sym__pipe_right_operator] = ACTIONS(10982),
    [sym__pipe_left_operator] = ACTIONS(10982),
    [sym__ellipsis_operator] = ACTIONS(10978),
    [sym__plus_operator] = ACTIONS(10978),
    [sym__times_operator] = ACTIONS(10978),
    [sym__rational_operator] = ACTIONS(10982),
    [sym__bitshift_operator] = ACTIONS(10982),
    [sym__power_operator] = ACTIONS(10982),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(10982),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(10978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9243] = {
    [sym_block_comment] = STATE(9243),
    [sym_line_comment] = STATE(9243),
    [sym__word_identifier] = ACTIONS(11269),
    [anon_sym_COMMA] = ACTIONS(11271),
    [anon_sym_EQ] = ACTIONS(11269),
    [anon_sym_begin] = ACTIONS(11269),
    [anon_sym_module] = ACTIONS(11269),
    [anon_sym_baremodule] = ACTIONS(11269),
    [anon_sym_end] = ACTIONS(11269),
    [anon_sym_abstract] = ACTIONS(11269),
    [anon_sym_primitive] = ACTIONS(11269),
    [anon_sym_mutable] = ACTIONS(11269),
    [anon_sym_struct] = ACTIONS(11269),
    [anon_sym_function] = ACTIONS(11269),
    [anon_sym_macro] = ACTIONS(11269),
    [anon_sym_quote] = ACTIONS(11269),
    [anon_sym_let] = ACTIONS(11269),
    [anon_sym_if] = ACTIONS(11269),
    [anon_sym_try] = ACTIONS(11269),
    [anon_sym_for] = ACTIONS(11269),
    [anon_sym_while] = ACTIONS(11269),
    [sym_break_statement] = ACTIONS(11269),
    [sym_continue_statement] = ACTIONS(11269),
    [anon_sym_return] = ACTIONS(11269),
    [anon_sym_const] = ACTIONS(11269),
    [anon_sym_global] = ACTIONS(11269),
    [anon_sym_local] = ACTIONS(11269),
    [anon_sym_LPAREN] = ACTIONS(11271),
    [anon_sym_COLON] = ACTIONS(11269),
    [anon_sym_export] = ACTIONS(11269),
    [anon_sym_public] = ACTIONS(11269),
    [anon_sym_import] = ACTIONS(11269),
    [anon_sym_using] = ACTIONS(11269),
    [anon_sym_LBRACK] = ACTIONS(11271),
    [anon_sym_in] = ACTIONS(11269),
    [anon_sym_LBRACE] = ACTIONS(11271),
    [anon_sym_DOLLAR] = ACTIONS(11271),
    [anon_sym_COLON2] = ACTIONS(11269),
    [anon_sym_COLON_COLON] = ACTIONS(11271),
    [anon_sym_isa] = ACTIONS(11269),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11271),
    [anon_sym_QMARK] = ACTIONS(11271),
    [anon_sym_where] = ACTIONS(11269),
    [anon_sym_AT] = ACTIONS(11271),
    [anon_sym_true] = ACTIONS(11269),
    [anon_sym_false] = ACTIONS(11269),
    [aux_sym_integer_literal_token1] = ACTIONS(11271),
    [aux_sym_integer_literal_token2] = ACTIONS(11271),
    [aux_sym_integer_literal_token3] = ACTIONS(11269),
    [aux_sym_integer_literal_token4] = ACTIONS(11269),
    [aux_sym_float_literal_token1] = ACTIONS(11271),
    [aux_sym_float_literal_token3] = ACTIONS(11271),
    [aux_sym_float_literal_token4] = ACTIONS(11271),
    [sym_character_literal] = ACTIONS(11271),
    [anon_sym_DQUOTE] = ACTIONS(11269),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11271),
    [anon_sym_BQUOTE] = ACTIONS(11269),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11271),
    [sym__pair_operator] = ACTIONS(11271),
    [sym__arrow_operator] = ACTIONS(11269),
    [sym__lazy_or_operator] = ACTIONS(11271),
    [sym__lazy_and_operator] = ACTIONS(11271),
    [sym__comparison_operator] = ACTIONS(11269),
    [sym__pipe_right_operator] = ACTIONS(11271),
    [sym__pipe_left_operator] = ACTIONS(11271),
    [sym__ellipsis_operator] = ACTIONS(11269),
    [sym__plus_operator] = ACTIONS(11269),
    [sym__times_operator] = ACTIONS(11269),
    [sym__rational_operator] = ACTIONS(11271),
    [sym__bitshift_operator] = ACTIONS(11271),
    [sym__power_operator] = ACTIONS(11271),
    [sym__tilde_operator] = ACTIONS(11271),
    [sym__type_order_operator] = ACTIONS(11271),
    [sym__unary_operator] = ACTIONS(11269),
    [sym__unary_plus_operator] = ACTIONS(11269),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9244] = {
    [sym_block_comment] = STATE(9244),
    [sym_line_comment] = STATE(9244),
    [sym__word_identifier] = ACTIONS(11279),
    [anon_sym_COMMA] = ACTIONS(11281),
    [anon_sym_EQ] = ACTIONS(11279),
    [anon_sym_begin] = ACTIONS(11279),
    [anon_sym_module] = ACTIONS(11279),
    [anon_sym_baremodule] = ACTIONS(11279),
    [anon_sym_end] = ACTIONS(11279),
    [anon_sym_abstract] = ACTIONS(11279),
    [anon_sym_primitive] = ACTIONS(11279),
    [anon_sym_mutable] = ACTIONS(11279),
    [anon_sym_struct] = ACTIONS(11279),
    [anon_sym_function] = ACTIONS(11279),
    [anon_sym_macro] = ACTIONS(11279),
    [anon_sym_quote] = ACTIONS(11279),
    [anon_sym_let] = ACTIONS(11279),
    [anon_sym_if] = ACTIONS(11279),
    [anon_sym_try] = ACTIONS(11279),
    [anon_sym_for] = ACTIONS(11279),
    [anon_sym_while] = ACTIONS(11279),
    [sym_break_statement] = ACTIONS(11279),
    [sym_continue_statement] = ACTIONS(11279),
    [anon_sym_return] = ACTIONS(11279),
    [anon_sym_const] = ACTIONS(11279),
    [anon_sym_global] = ACTIONS(11279),
    [anon_sym_local] = ACTIONS(11279),
    [anon_sym_LPAREN] = ACTIONS(11281),
    [anon_sym_COLON] = ACTIONS(11279),
    [anon_sym_export] = ACTIONS(11279),
    [anon_sym_public] = ACTIONS(11279),
    [anon_sym_import] = ACTIONS(11279),
    [anon_sym_using] = ACTIONS(11279),
    [anon_sym_LBRACK] = ACTIONS(11281),
    [anon_sym_in] = ACTIONS(11279),
    [anon_sym_LBRACE] = ACTIONS(11281),
    [anon_sym_DOLLAR] = ACTIONS(11281),
    [anon_sym_COLON2] = ACTIONS(11279),
    [anon_sym_COLON_COLON] = ACTIONS(11281),
    [anon_sym_isa] = ACTIONS(11279),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11281),
    [anon_sym_QMARK] = ACTIONS(11281),
    [anon_sym_where] = ACTIONS(11279),
    [anon_sym_AT] = ACTIONS(11281),
    [anon_sym_true] = ACTIONS(11279),
    [anon_sym_false] = ACTIONS(11279),
    [aux_sym_integer_literal_token1] = ACTIONS(11281),
    [aux_sym_integer_literal_token2] = ACTIONS(11281),
    [aux_sym_integer_literal_token3] = ACTIONS(11279),
    [aux_sym_integer_literal_token4] = ACTIONS(11279),
    [aux_sym_float_literal_token1] = ACTIONS(11281),
    [aux_sym_float_literal_token3] = ACTIONS(11281),
    [aux_sym_float_literal_token4] = ACTIONS(11281),
    [sym_character_literal] = ACTIONS(11281),
    [anon_sym_DQUOTE] = ACTIONS(11279),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11281),
    [anon_sym_BQUOTE] = ACTIONS(11279),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11281),
    [sym__pair_operator] = ACTIONS(11281),
    [sym__arrow_operator] = ACTIONS(11279),
    [sym__lazy_or_operator] = ACTIONS(11281),
    [sym__lazy_and_operator] = ACTIONS(11281),
    [sym__comparison_operator] = ACTIONS(11279),
    [sym__pipe_right_operator] = ACTIONS(11281),
    [sym__pipe_left_operator] = ACTIONS(11281),
    [sym__ellipsis_operator] = ACTIONS(11279),
    [sym__plus_operator] = ACTIONS(11279),
    [sym__times_operator] = ACTIONS(11279),
    [sym__rational_operator] = ACTIONS(11281),
    [sym__bitshift_operator] = ACTIONS(11281),
    [sym__power_operator] = ACTIONS(11281),
    [sym__tilde_operator] = ACTIONS(11281),
    [sym__type_order_operator] = ACTIONS(11281),
    [sym__unary_operator] = ACTIONS(11279),
    [sym__unary_plus_operator] = ACTIONS(11279),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9245] = {
    [sym_block_comment] = STATE(9245),
    [sym_line_comment] = STATE(9245),
    [sym__word_identifier] = ACTIONS(11309),
    [anon_sym_COMMA] = ACTIONS(11311),
    [anon_sym_EQ] = ACTIONS(11309),
    [anon_sym_begin] = ACTIONS(11309),
    [anon_sym_module] = ACTIONS(11309),
    [anon_sym_baremodule] = ACTIONS(11309),
    [anon_sym_end] = ACTIONS(11309),
    [anon_sym_abstract] = ACTIONS(11309),
    [anon_sym_primitive] = ACTIONS(11309),
    [anon_sym_mutable] = ACTIONS(11309),
    [anon_sym_struct] = ACTIONS(11309),
    [anon_sym_function] = ACTIONS(11309),
    [anon_sym_macro] = ACTIONS(11309),
    [anon_sym_quote] = ACTIONS(11309),
    [anon_sym_let] = ACTIONS(11309),
    [anon_sym_if] = ACTIONS(11309),
    [anon_sym_try] = ACTIONS(11309),
    [anon_sym_for] = ACTIONS(11309),
    [anon_sym_while] = ACTIONS(11309),
    [sym_break_statement] = ACTIONS(11309),
    [sym_continue_statement] = ACTIONS(11309),
    [anon_sym_return] = ACTIONS(11309),
    [anon_sym_const] = ACTIONS(11309),
    [anon_sym_global] = ACTIONS(11309),
    [anon_sym_local] = ACTIONS(11309),
    [anon_sym_LPAREN] = ACTIONS(11311),
    [anon_sym_COLON] = ACTIONS(11309),
    [anon_sym_export] = ACTIONS(11309),
    [anon_sym_public] = ACTIONS(11309),
    [anon_sym_import] = ACTIONS(11309),
    [anon_sym_using] = ACTIONS(11309),
    [anon_sym_LBRACK] = ACTIONS(11311),
    [anon_sym_in] = ACTIONS(11309),
    [anon_sym_LBRACE] = ACTIONS(11311),
    [anon_sym_DOLLAR] = ACTIONS(11311),
    [anon_sym_COLON2] = ACTIONS(11309),
    [anon_sym_COLON_COLON] = ACTIONS(11311),
    [anon_sym_isa] = ACTIONS(11309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11311),
    [anon_sym_QMARK] = ACTIONS(11311),
    [anon_sym_where] = ACTIONS(11309),
    [anon_sym_AT] = ACTIONS(11311),
    [anon_sym_true] = ACTIONS(11309),
    [anon_sym_false] = ACTIONS(11309),
    [aux_sym_integer_literal_token1] = ACTIONS(11311),
    [aux_sym_integer_literal_token2] = ACTIONS(11311),
    [aux_sym_integer_literal_token3] = ACTIONS(11309),
    [aux_sym_integer_literal_token4] = ACTIONS(11309),
    [aux_sym_float_literal_token1] = ACTIONS(11311),
    [aux_sym_float_literal_token3] = ACTIONS(11311),
    [aux_sym_float_literal_token4] = ACTIONS(11311),
    [sym_character_literal] = ACTIONS(11311),
    [anon_sym_DQUOTE] = ACTIONS(11309),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11311),
    [anon_sym_BQUOTE] = ACTIONS(11309),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11311),
    [sym__pair_operator] = ACTIONS(11311),
    [sym__arrow_operator] = ACTIONS(11309),
    [sym__lazy_or_operator] = ACTIONS(11311),
    [sym__lazy_and_operator] = ACTIONS(11311),
    [sym__comparison_operator] = ACTIONS(11309),
    [sym__pipe_right_operator] = ACTIONS(11311),
    [sym__pipe_left_operator] = ACTIONS(11311),
    [sym__ellipsis_operator] = ACTIONS(11309),
    [sym__plus_operator] = ACTIONS(11309),
    [sym__times_operator] = ACTIONS(11309),
    [sym__rational_operator] = ACTIONS(11311),
    [sym__bitshift_operator] = ACTIONS(11311),
    [sym__power_operator] = ACTIONS(11311),
    [sym__tilde_operator] = ACTIONS(11311),
    [sym__type_order_operator] = ACTIONS(11311),
    [sym__unary_operator] = ACTIONS(11309),
    [sym__unary_plus_operator] = ACTIONS(11309),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9246] = {
    [sym_block_comment] = STATE(9246),
    [sym_line_comment] = STATE(9246),
    [sym__word_identifier] = ACTIONS(11317),
    [anon_sym_COMMA] = ACTIONS(11319),
    [anon_sym_EQ] = ACTIONS(11317),
    [anon_sym_begin] = ACTIONS(11317),
    [anon_sym_module] = ACTIONS(11317),
    [anon_sym_baremodule] = ACTIONS(11317),
    [anon_sym_end] = ACTIONS(11317),
    [anon_sym_abstract] = ACTIONS(11317),
    [anon_sym_primitive] = ACTIONS(11317),
    [anon_sym_mutable] = ACTIONS(11317),
    [anon_sym_struct] = ACTIONS(11317),
    [anon_sym_function] = ACTIONS(11317),
    [anon_sym_macro] = ACTIONS(11317),
    [anon_sym_quote] = ACTIONS(11317),
    [anon_sym_let] = ACTIONS(11317),
    [anon_sym_if] = ACTIONS(11317),
    [anon_sym_try] = ACTIONS(11317),
    [anon_sym_for] = ACTIONS(11317),
    [anon_sym_while] = ACTIONS(11317),
    [sym_break_statement] = ACTIONS(11317),
    [sym_continue_statement] = ACTIONS(11317),
    [anon_sym_return] = ACTIONS(11317),
    [anon_sym_const] = ACTIONS(11317),
    [anon_sym_global] = ACTIONS(11317),
    [anon_sym_local] = ACTIONS(11317),
    [anon_sym_LPAREN] = ACTIONS(11319),
    [anon_sym_COLON] = ACTIONS(11317),
    [anon_sym_export] = ACTIONS(11317),
    [anon_sym_public] = ACTIONS(11317),
    [anon_sym_import] = ACTIONS(11317),
    [anon_sym_using] = ACTIONS(11317),
    [anon_sym_LBRACK] = ACTIONS(11319),
    [anon_sym_in] = ACTIONS(11317),
    [anon_sym_LBRACE] = ACTIONS(11319),
    [anon_sym_DOLLAR] = ACTIONS(11319),
    [anon_sym_COLON2] = ACTIONS(11317),
    [anon_sym_COLON_COLON] = ACTIONS(11319),
    [anon_sym_isa] = ACTIONS(11317),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11319),
    [anon_sym_QMARK] = ACTIONS(11319),
    [anon_sym_where] = ACTIONS(11317),
    [anon_sym_AT] = ACTIONS(11319),
    [anon_sym_true] = ACTIONS(11317),
    [anon_sym_false] = ACTIONS(11317),
    [aux_sym_integer_literal_token1] = ACTIONS(11319),
    [aux_sym_integer_literal_token2] = ACTIONS(11319),
    [aux_sym_integer_literal_token3] = ACTIONS(11317),
    [aux_sym_integer_literal_token4] = ACTIONS(11317),
    [aux_sym_float_literal_token1] = ACTIONS(11319),
    [aux_sym_float_literal_token3] = ACTIONS(11319),
    [aux_sym_float_literal_token4] = ACTIONS(11319),
    [sym_character_literal] = ACTIONS(11319),
    [anon_sym_DQUOTE] = ACTIONS(11317),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11319),
    [anon_sym_BQUOTE] = ACTIONS(11317),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11319),
    [sym__pair_operator] = ACTIONS(11319),
    [sym__arrow_operator] = ACTIONS(11317),
    [sym__lazy_or_operator] = ACTIONS(11319),
    [sym__lazy_and_operator] = ACTIONS(11319),
    [sym__comparison_operator] = ACTIONS(11317),
    [sym__pipe_right_operator] = ACTIONS(11319),
    [sym__pipe_left_operator] = ACTIONS(11319),
    [sym__ellipsis_operator] = ACTIONS(11317),
    [sym__plus_operator] = ACTIONS(11317),
    [sym__times_operator] = ACTIONS(11317),
    [sym__rational_operator] = ACTIONS(11319),
    [sym__bitshift_operator] = ACTIONS(11319),
    [sym__power_operator] = ACTIONS(11319),
    [sym__tilde_operator] = ACTIONS(11319),
    [sym__type_order_operator] = ACTIONS(11319),
    [sym__unary_operator] = ACTIONS(11317),
    [sym__unary_plus_operator] = ACTIONS(11317),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9247] = {
    [sym_block_comment] = STATE(9247),
    [sym_line_comment] = STATE(9247),
    [sym__word_identifier] = ACTIONS(11359),
    [anon_sym_COMMA] = ACTIONS(11361),
    [anon_sym_EQ] = ACTIONS(11359),
    [anon_sym_begin] = ACTIONS(11359),
    [anon_sym_module] = ACTIONS(11359),
    [anon_sym_baremodule] = ACTIONS(11359),
    [anon_sym_end] = ACTIONS(11359),
    [anon_sym_abstract] = ACTIONS(11359),
    [anon_sym_primitive] = ACTIONS(11359),
    [anon_sym_mutable] = ACTIONS(11359),
    [anon_sym_struct] = ACTIONS(11359),
    [anon_sym_function] = ACTIONS(11359),
    [anon_sym_macro] = ACTIONS(11359),
    [anon_sym_quote] = ACTIONS(11359),
    [anon_sym_let] = ACTIONS(11359),
    [anon_sym_if] = ACTIONS(11359),
    [anon_sym_try] = ACTIONS(11359),
    [anon_sym_for] = ACTIONS(11359),
    [anon_sym_while] = ACTIONS(11359),
    [sym_break_statement] = ACTIONS(11359),
    [sym_continue_statement] = ACTIONS(11359),
    [anon_sym_return] = ACTIONS(11359),
    [anon_sym_const] = ACTIONS(11359),
    [anon_sym_global] = ACTIONS(11359),
    [anon_sym_local] = ACTIONS(11359),
    [anon_sym_LPAREN] = ACTIONS(11361),
    [anon_sym_COLON] = ACTIONS(11359),
    [anon_sym_export] = ACTIONS(11359),
    [anon_sym_public] = ACTIONS(11359),
    [anon_sym_import] = ACTIONS(11359),
    [anon_sym_using] = ACTIONS(11359),
    [anon_sym_LBRACK] = ACTIONS(11361),
    [anon_sym_in] = ACTIONS(11359),
    [anon_sym_LBRACE] = ACTIONS(11361),
    [anon_sym_DOLLAR] = ACTIONS(11361),
    [anon_sym_COLON2] = ACTIONS(11359),
    [anon_sym_COLON_COLON] = ACTIONS(11361),
    [anon_sym_isa] = ACTIONS(11359),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11361),
    [anon_sym_QMARK] = ACTIONS(11361),
    [anon_sym_where] = ACTIONS(11359),
    [anon_sym_AT] = ACTIONS(11361),
    [anon_sym_true] = ACTIONS(11359),
    [anon_sym_false] = ACTIONS(11359),
    [aux_sym_integer_literal_token1] = ACTIONS(11361),
    [aux_sym_integer_literal_token2] = ACTIONS(11361),
    [aux_sym_integer_literal_token3] = ACTIONS(11359),
    [aux_sym_integer_literal_token4] = ACTIONS(11359),
    [aux_sym_float_literal_token1] = ACTIONS(11361),
    [aux_sym_float_literal_token3] = ACTIONS(11361),
    [aux_sym_float_literal_token4] = ACTIONS(11361),
    [sym_character_literal] = ACTIONS(11361),
    [anon_sym_DQUOTE] = ACTIONS(11359),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11361),
    [anon_sym_BQUOTE] = ACTIONS(11359),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11361),
    [sym__pair_operator] = ACTIONS(11361),
    [sym__arrow_operator] = ACTIONS(11359),
    [sym__lazy_or_operator] = ACTIONS(11361),
    [sym__lazy_and_operator] = ACTIONS(11361),
    [sym__comparison_operator] = ACTIONS(11359),
    [sym__pipe_right_operator] = ACTIONS(11361),
    [sym__pipe_left_operator] = ACTIONS(11361),
    [sym__ellipsis_operator] = ACTIONS(11359),
    [sym__plus_operator] = ACTIONS(11359),
    [sym__times_operator] = ACTIONS(11359),
    [sym__rational_operator] = ACTIONS(11361),
    [sym__bitshift_operator] = ACTIONS(11361),
    [sym__power_operator] = ACTIONS(11361),
    [sym__tilde_operator] = ACTIONS(11361),
    [sym__type_order_operator] = ACTIONS(11361),
    [sym__unary_operator] = ACTIONS(11359),
    [sym__unary_plus_operator] = ACTIONS(11359),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9248] = {
    [sym_block_comment] = STATE(9248),
    [sym_line_comment] = STATE(9248),
    [sym__word_identifier] = ACTIONS(11381),
    [anon_sym_COMMA] = ACTIONS(11383),
    [anon_sym_EQ] = ACTIONS(11381),
    [anon_sym_begin] = ACTIONS(11381),
    [anon_sym_module] = ACTIONS(11381),
    [anon_sym_baremodule] = ACTIONS(11381),
    [anon_sym_end] = ACTIONS(11381),
    [anon_sym_abstract] = ACTIONS(11381),
    [anon_sym_primitive] = ACTIONS(11381),
    [anon_sym_mutable] = ACTIONS(11381),
    [anon_sym_struct] = ACTIONS(11381),
    [anon_sym_function] = ACTIONS(11381),
    [anon_sym_macro] = ACTIONS(11381),
    [anon_sym_quote] = ACTIONS(11381),
    [anon_sym_let] = ACTIONS(11381),
    [anon_sym_if] = ACTIONS(11381),
    [anon_sym_try] = ACTIONS(11381),
    [anon_sym_for] = ACTIONS(11381),
    [anon_sym_while] = ACTIONS(11381),
    [sym_break_statement] = ACTIONS(11381),
    [sym_continue_statement] = ACTIONS(11381),
    [anon_sym_return] = ACTIONS(11381),
    [anon_sym_const] = ACTIONS(11381),
    [anon_sym_global] = ACTIONS(11381),
    [anon_sym_local] = ACTIONS(11381),
    [anon_sym_LPAREN] = ACTIONS(11383),
    [anon_sym_COLON] = ACTIONS(11381),
    [anon_sym_export] = ACTIONS(11381),
    [anon_sym_public] = ACTIONS(11381),
    [anon_sym_import] = ACTIONS(11381),
    [anon_sym_using] = ACTIONS(11381),
    [anon_sym_LBRACK] = ACTIONS(11383),
    [anon_sym_in] = ACTIONS(11381),
    [anon_sym_LBRACE] = ACTIONS(11383),
    [anon_sym_DOLLAR] = ACTIONS(11383),
    [anon_sym_COLON2] = ACTIONS(11381),
    [anon_sym_COLON_COLON] = ACTIONS(11383),
    [anon_sym_isa] = ACTIONS(11381),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11383),
    [anon_sym_QMARK] = ACTIONS(11383),
    [anon_sym_where] = ACTIONS(11381),
    [anon_sym_AT] = ACTIONS(11383),
    [anon_sym_true] = ACTIONS(11381),
    [anon_sym_false] = ACTIONS(11381),
    [aux_sym_integer_literal_token1] = ACTIONS(11383),
    [aux_sym_integer_literal_token2] = ACTIONS(11383),
    [aux_sym_integer_literal_token3] = ACTIONS(11381),
    [aux_sym_integer_literal_token4] = ACTIONS(11381),
    [aux_sym_float_literal_token1] = ACTIONS(11383),
    [aux_sym_float_literal_token3] = ACTIONS(11383),
    [aux_sym_float_literal_token4] = ACTIONS(11383),
    [sym_character_literal] = ACTIONS(11383),
    [anon_sym_DQUOTE] = ACTIONS(11381),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11383),
    [anon_sym_BQUOTE] = ACTIONS(11381),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11383),
    [sym__pair_operator] = ACTIONS(11383),
    [sym__arrow_operator] = ACTIONS(11381),
    [sym__lazy_or_operator] = ACTIONS(11383),
    [sym__lazy_and_operator] = ACTIONS(11383),
    [sym__comparison_operator] = ACTIONS(11381),
    [sym__pipe_right_operator] = ACTIONS(11383),
    [sym__pipe_left_operator] = ACTIONS(11383),
    [sym__ellipsis_operator] = ACTIONS(11381),
    [sym__plus_operator] = ACTIONS(11381),
    [sym__times_operator] = ACTIONS(11381),
    [sym__rational_operator] = ACTIONS(11383),
    [sym__bitshift_operator] = ACTIONS(11383),
    [sym__power_operator] = ACTIONS(11383),
    [sym__tilde_operator] = ACTIONS(11383),
    [sym__type_order_operator] = ACTIONS(11383),
    [sym__unary_operator] = ACTIONS(11381),
    [sym__unary_plus_operator] = ACTIONS(11381),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9249] = {
    [sym_block_comment] = STATE(9249),
    [sym_line_comment] = STATE(9249),
    [sym__word_identifier] = ACTIONS(11407),
    [anon_sym_COMMA] = ACTIONS(11409),
    [anon_sym_EQ] = ACTIONS(11407),
    [anon_sym_begin] = ACTIONS(11407),
    [anon_sym_module] = ACTIONS(11407),
    [anon_sym_baremodule] = ACTIONS(11407),
    [anon_sym_end] = ACTIONS(11407),
    [anon_sym_abstract] = ACTIONS(11407),
    [anon_sym_primitive] = ACTIONS(11407),
    [anon_sym_mutable] = ACTIONS(11407),
    [anon_sym_struct] = ACTIONS(11407),
    [anon_sym_function] = ACTIONS(11407),
    [anon_sym_macro] = ACTIONS(11407),
    [anon_sym_quote] = ACTIONS(11407),
    [anon_sym_let] = ACTIONS(11407),
    [anon_sym_if] = ACTIONS(11407),
    [anon_sym_try] = ACTIONS(11407),
    [anon_sym_for] = ACTIONS(11407),
    [anon_sym_while] = ACTIONS(11407),
    [sym_break_statement] = ACTIONS(11407),
    [sym_continue_statement] = ACTIONS(11407),
    [anon_sym_return] = ACTIONS(11407),
    [anon_sym_const] = ACTIONS(11407),
    [anon_sym_global] = ACTIONS(11407),
    [anon_sym_local] = ACTIONS(11407),
    [anon_sym_LPAREN] = ACTIONS(11409),
    [anon_sym_COLON] = ACTIONS(11407),
    [anon_sym_export] = ACTIONS(11407),
    [anon_sym_public] = ACTIONS(11407),
    [anon_sym_import] = ACTIONS(11407),
    [anon_sym_using] = ACTIONS(11407),
    [anon_sym_LBRACK] = ACTIONS(11409),
    [anon_sym_in] = ACTIONS(11407),
    [anon_sym_LBRACE] = ACTIONS(11409),
    [anon_sym_DOLLAR] = ACTIONS(11409),
    [anon_sym_COLON2] = ACTIONS(11407),
    [anon_sym_COLON_COLON] = ACTIONS(11409),
    [anon_sym_isa] = ACTIONS(11407),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11409),
    [anon_sym_QMARK] = ACTIONS(11409),
    [anon_sym_where] = ACTIONS(11407),
    [anon_sym_AT] = ACTIONS(11409),
    [anon_sym_true] = ACTIONS(11407),
    [anon_sym_false] = ACTIONS(11407),
    [aux_sym_integer_literal_token1] = ACTIONS(11409),
    [aux_sym_integer_literal_token2] = ACTIONS(11409),
    [aux_sym_integer_literal_token3] = ACTIONS(11407),
    [aux_sym_integer_literal_token4] = ACTIONS(11407),
    [aux_sym_float_literal_token1] = ACTIONS(11409),
    [aux_sym_float_literal_token3] = ACTIONS(11409),
    [aux_sym_float_literal_token4] = ACTIONS(11409),
    [sym_character_literal] = ACTIONS(11409),
    [anon_sym_DQUOTE] = ACTIONS(11407),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11409),
    [anon_sym_BQUOTE] = ACTIONS(11407),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11409),
    [sym__pair_operator] = ACTIONS(11409),
    [sym__arrow_operator] = ACTIONS(11407),
    [sym__lazy_or_operator] = ACTIONS(11409),
    [sym__lazy_and_operator] = ACTIONS(11409),
    [sym__comparison_operator] = ACTIONS(11407),
    [sym__pipe_right_operator] = ACTIONS(11409),
    [sym__pipe_left_operator] = ACTIONS(11409),
    [sym__ellipsis_operator] = ACTIONS(11407),
    [sym__plus_operator] = ACTIONS(11407),
    [sym__times_operator] = ACTIONS(11407),
    [sym__rational_operator] = ACTIONS(11409),
    [sym__bitshift_operator] = ACTIONS(11409),
    [sym__power_operator] = ACTIONS(11409),
    [sym__tilde_operator] = ACTIONS(11409),
    [sym__type_order_operator] = ACTIONS(11409),
    [sym__unary_operator] = ACTIONS(11407),
    [sym__unary_plus_operator] = ACTIONS(11407),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9250] = {
    [sym_block_comment] = STATE(9250),
    [sym_line_comment] = STATE(9250),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11047),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11047),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12802),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(12680),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(12804),
    [aux_sym__terminator_token2] = ACTIONS(11047),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9251] = {
    [sym_block_comment] = STATE(9251),
    [sym_line_comment] = STATE(9251),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(12806),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9252] = {
    [sym_block_comment] = STATE(9252),
    [sym_line_comment] = STATE(9252),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_RPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11289),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9253] = {
    [sym_block_comment] = STATE(9253),
    [sym_line_comment] = STATE(9253),
    [sym__word_identifier] = ACTIONS(11456),
    [anon_sym_COMMA] = ACTIONS(11458),
    [anon_sym_EQ] = ACTIONS(11456),
    [anon_sym_begin] = ACTIONS(11456),
    [anon_sym_module] = ACTIONS(11456),
    [anon_sym_baremodule] = ACTIONS(11456),
    [anon_sym_end] = ACTIONS(11456),
    [anon_sym_abstract] = ACTIONS(11456),
    [anon_sym_primitive] = ACTIONS(11456),
    [anon_sym_mutable] = ACTIONS(11456),
    [anon_sym_struct] = ACTIONS(11456),
    [anon_sym_function] = ACTIONS(11456),
    [anon_sym_macro] = ACTIONS(11456),
    [anon_sym_quote] = ACTIONS(11456),
    [anon_sym_let] = ACTIONS(11456),
    [anon_sym_if] = ACTIONS(11456),
    [anon_sym_try] = ACTIONS(11456),
    [anon_sym_for] = ACTIONS(11456),
    [anon_sym_while] = ACTIONS(11456),
    [sym_break_statement] = ACTIONS(11456),
    [sym_continue_statement] = ACTIONS(11456),
    [anon_sym_return] = ACTIONS(11456),
    [anon_sym_const] = ACTIONS(11456),
    [anon_sym_global] = ACTIONS(11456),
    [anon_sym_local] = ACTIONS(11456),
    [anon_sym_LPAREN] = ACTIONS(11458),
    [anon_sym_COLON] = ACTIONS(11456),
    [anon_sym_export] = ACTIONS(11456),
    [anon_sym_public] = ACTIONS(11456),
    [anon_sym_import] = ACTIONS(11456),
    [anon_sym_using] = ACTIONS(11456),
    [anon_sym_LBRACK] = ACTIONS(11458),
    [anon_sym_in] = ACTIONS(11456),
    [anon_sym_LBRACE] = ACTIONS(11458),
    [anon_sym_DOLLAR] = ACTIONS(11458),
    [anon_sym_COLON2] = ACTIONS(11456),
    [anon_sym_COLON_COLON] = ACTIONS(11458),
    [anon_sym_isa] = ACTIONS(11456),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11458),
    [anon_sym_QMARK] = ACTIONS(11458),
    [anon_sym_where] = ACTIONS(11456),
    [anon_sym_AT] = ACTIONS(11458),
    [anon_sym_true] = ACTIONS(11456),
    [anon_sym_false] = ACTIONS(11456),
    [aux_sym_integer_literal_token1] = ACTIONS(11458),
    [aux_sym_integer_literal_token2] = ACTIONS(11458),
    [aux_sym_integer_literal_token3] = ACTIONS(11456),
    [aux_sym_integer_literal_token4] = ACTIONS(11456),
    [aux_sym_float_literal_token1] = ACTIONS(11458),
    [aux_sym_float_literal_token3] = ACTIONS(11458),
    [aux_sym_float_literal_token4] = ACTIONS(11458),
    [sym_character_literal] = ACTIONS(11458),
    [anon_sym_DQUOTE] = ACTIONS(11456),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11458),
    [anon_sym_BQUOTE] = ACTIONS(11456),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11458),
    [sym__pair_operator] = ACTIONS(11458),
    [sym__arrow_operator] = ACTIONS(11456),
    [sym__lazy_or_operator] = ACTIONS(11458),
    [sym__lazy_and_operator] = ACTIONS(11458),
    [sym__comparison_operator] = ACTIONS(11456),
    [sym__pipe_right_operator] = ACTIONS(11458),
    [sym__pipe_left_operator] = ACTIONS(11458),
    [sym__ellipsis_operator] = ACTIONS(11456),
    [sym__plus_operator] = ACTIONS(11456),
    [sym__times_operator] = ACTIONS(11456),
    [sym__rational_operator] = ACTIONS(11458),
    [sym__bitshift_operator] = ACTIONS(11458),
    [sym__power_operator] = ACTIONS(11458),
    [sym__tilde_operator] = ACTIONS(11458),
    [sym__type_order_operator] = ACTIONS(11458),
    [sym__unary_operator] = ACTIONS(11456),
    [sym__unary_plus_operator] = ACTIONS(11456),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9254] = {
    [sym_block_comment] = STATE(9254),
    [sym_line_comment] = STATE(9254),
    [sym__word_identifier] = ACTIONS(11283),
    [anon_sym_COMMA] = ACTIONS(11285),
    [anon_sym_EQ] = ACTIONS(11283),
    [anon_sym_begin] = ACTIONS(11283),
    [anon_sym_module] = ACTIONS(11283),
    [anon_sym_baremodule] = ACTIONS(11283),
    [anon_sym_end] = ACTIONS(11283),
    [anon_sym_abstract] = ACTIONS(11283),
    [anon_sym_primitive] = ACTIONS(11283),
    [anon_sym_mutable] = ACTIONS(11283),
    [anon_sym_struct] = ACTIONS(11283),
    [anon_sym_function] = ACTIONS(11283),
    [anon_sym_macro] = ACTIONS(11283),
    [anon_sym_quote] = ACTIONS(11283),
    [anon_sym_let] = ACTIONS(11283),
    [anon_sym_if] = ACTIONS(11283),
    [anon_sym_try] = ACTIONS(11283),
    [anon_sym_for] = ACTIONS(11283),
    [anon_sym_while] = ACTIONS(11283),
    [sym_break_statement] = ACTIONS(11283),
    [sym_continue_statement] = ACTIONS(11283),
    [anon_sym_return] = ACTIONS(11283),
    [anon_sym_const] = ACTIONS(11283),
    [anon_sym_global] = ACTIONS(11283),
    [anon_sym_local] = ACTIONS(11283),
    [anon_sym_LPAREN] = ACTIONS(11285),
    [anon_sym_COLON] = ACTIONS(11283),
    [anon_sym_export] = ACTIONS(11283),
    [anon_sym_public] = ACTIONS(11283),
    [anon_sym_import] = ACTIONS(11283),
    [anon_sym_using] = ACTIONS(11283),
    [anon_sym_LBRACK] = ACTIONS(11285),
    [anon_sym_in] = ACTIONS(11283),
    [anon_sym_LBRACE] = ACTIONS(11285),
    [anon_sym_DOLLAR] = ACTIONS(11285),
    [anon_sym_COLON2] = ACTIONS(11283),
    [anon_sym_COLON_COLON] = ACTIONS(11285),
    [anon_sym_isa] = ACTIONS(11283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11285),
    [anon_sym_QMARK] = ACTIONS(11285),
    [anon_sym_where] = ACTIONS(11283),
    [anon_sym_AT] = ACTIONS(11285),
    [anon_sym_true] = ACTIONS(11283),
    [anon_sym_false] = ACTIONS(11283),
    [aux_sym_integer_literal_token1] = ACTIONS(11285),
    [aux_sym_integer_literal_token2] = ACTIONS(11285),
    [aux_sym_integer_literal_token3] = ACTIONS(11283),
    [aux_sym_integer_literal_token4] = ACTIONS(11283),
    [aux_sym_float_literal_token1] = ACTIONS(11285),
    [aux_sym_float_literal_token3] = ACTIONS(11285),
    [aux_sym_float_literal_token4] = ACTIONS(11285),
    [sym_character_literal] = ACTIONS(11285),
    [anon_sym_DQUOTE] = ACTIONS(11283),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11285),
    [anon_sym_BQUOTE] = ACTIONS(11283),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11285),
    [sym__pair_operator] = ACTIONS(11285),
    [sym__arrow_operator] = ACTIONS(11283),
    [sym__lazy_or_operator] = ACTIONS(11285),
    [sym__lazy_and_operator] = ACTIONS(11285),
    [sym__comparison_operator] = ACTIONS(11283),
    [sym__pipe_right_operator] = ACTIONS(11285),
    [sym__pipe_left_operator] = ACTIONS(11285),
    [sym__ellipsis_operator] = ACTIONS(11283),
    [sym__plus_operator] = ACTIONS(11283),
    [sym__times_operator] = ACTIONS(11283),
    [sym__rational_operator] = ACTIONS(11285),
    [sym__bitshift_operator] = ACTIONS(11285),
    [sym__power_operator] = ACTIONS(11285),
    [sym__tilde_operator] = ACTIONS(11285),
    [sym__type_order_operator] = ACTIONS(11285),
    [sym__unary_operator] = ACTIONS(11283),
    [sym__unary_plus_operator] = ACTIONS(11283),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9255] = {
    [sym_block_comment] = STATE(9255),
    [sym_line_comment] = STATE(9255),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(12806),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9256] = {
    [sym_block_comment] = STATE(9256),
    [sym_line_comment] = STATE(9256),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(12806),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9257] = {
    [sym_block_comment] = STATE(9257),
    [sym_line_comment] = STATE(9257),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(12806),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9258] = {
    [sym_block_comment] = STATE(9258),
    [sym_line_comment] = STATE(9258),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_DASH_GT] = ACTIONS(10160),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9259] = {
    [sym_block_comment] = STATE(9259),
    [sym_line_comment] = STATE(9259),
    [sym__word_identifier] = ACTIONS(10928),
    [anon_sym_COMMA] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(10928),
    [anon_sym_module] = ACTIONS(10928),
    [anon_sym_baremodule] = ACTIONS(10928),
    [anon_sym_end] = ACTIONS(10928),
    [anon_sym_abstract] = ACTIONS(10928),
    [anon_sym_primitive] = ACTIONS(10928),
    [anon_sym_mutable] = ACTIONS(10928),
    [anon_sym_struct] = ACTIONS(10928),
    [anon_sym_function] = ACTIONS(10928),
    [anon_sym_macro] = ACTIONS(10928),
    [anon_sym_quote] = ACTIONS(10928),
    [anon_sym_let] = ACTIONS(10928),
    [anon_sym_if] = ACTIONS(10928),
    [anon_sym_try] = ACTIONS(10928),
    [anon_sym_for] = ACTIONS(10928),
    [anon_sym_while] = ACTIONS(10928),
    [sym_break_statement] = ACTIONS(10928),
    [sym_continue_statement] = ACTIONS(10928),
    [anon_sym_return] = ACTIONS(10928),
    [anon_sym_const] = ACTIONS(10928),
    [anon_sym_global] = ACTIONS(10928),
    [anon_sym_local] = ACTIONS(10928),
    [anon_sym_LPAREN] = ACTIONS(10964),
    [anon_sym_COLON] = ACTIONS(10928),
    [anon_sym_export] = ACTIONS(10928),
    [anon_sym_public] = ACTIONS(10928),
    [anon_sym_import] = ACTIONS(10928),
    [anon_sym_using] = ACTIONS(10928),
    [anon_sym_LBRACK] = ACTIONS(10964),
    [anon_sym_in] = ACTIONS(10928),
    [anon_sym_LBRACE] = ACTIONS(10964),
    [anon_sym_DOLLAR] = ACTIONS(10964),
    [anon_sym_COLON2] = ACTIONS(10928),
    [anon_sym_COLON_COLON] = ACTIONS(10964),
    [anon_sym_isa] = ACTIONS(10928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10964),
    [anon_sym_QMARK] = ACTIONS(10964),
    [anon_sym_where] = ACTIONS(10928),
    [anon_sym_AT] = ACTIONS(10964),
    [anon_sym_true] = ACTIONS(10928),
    [anon_sym_false] = ACTIONS(10928),
    [aux_sym_integer_literal_token1] = ACTIONS(10964),
    [aux_sym_integer_literal_token2] = ACTIONS(10964),
    [aux_sym_integer_literal_token3] = ACTIONS(10928),
    [aux_sym_integer_literal_token4] = ACTIONS(10928),
    [aux_sym_float_literal_token1] = ACTIONS(10964),
    [aux_sym_float_literal_token3] = ACTIONS(10964),
    [aux_sym_float_literal_token4] = ACTIONS(10964),
    [sym_character_literal] = ACTIONS(10964),
    [anon_sym_DQUOTE] = ACTIONS(10928),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10964),
    [anon_sym_BQUOTE] = ACTIONS(10928),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10964),
    [sym__pair_operator] = ACTIONS(10964),
    [sym__arrow_operator] = ACTIONS(10928),
    [sym__lazy_or_operator] = ACTIONS(10964),
    [sym__lazy_and_operator] = ACTIONS(10964),
    [sym__comparison_operator] = ACTIONS(10928),
    [sym__pipe_right_operator] = ACTIONS(10964),
    [sym__pipe_left_operator] = ACTIONS(10964),
    [sym__ellipsis_operator] = ACTIONS(10928),
    [sym__plus_operator] = ACTIONS(10928),
    [sym__times_operator] = ACTIONS(10928),
    [sym__rational_operator] = ACTIONS(10964),
    [sym__bitshift_operator] = ACTIONS(10964),
    [sym__power_operator] = ACTIONS(10964),
    [sym__tilde_operator] = ACTIONS(10964),
    [sym__type_order_operator] = ACTIONS(10964),
    [sym__unary_operator] = ACTIONS(10928),
    [sym__unary_plus_operator] = ACTIONS(10928),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9260] = {
    [sym_block_comment] = STATE(9260),
    [sym_line_comment] = STATE(9260),
    [sym__word_identifier] = ACTIONS(10966),
    [anon_sym_COMMA] = ACTIONS(10968),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(10966),
    [anon_sym_module] = ACTIONS(10966),
    [anon_sym_baremodule] = ACTIONS(10966),
    [anon_sym_end] = ACTIONS(10966),
    [anon_sym_abstract] = ACTIONS(10966),
    [anon_sym_primitive] = ACTIONS(10966),
    [anon_sym_mutable] = ACTIONS(10966),
    [anon_sym_struct] = ACTIONS(10966),
    [anon_sym_function] = ACTIONS(10966),
    [anon_sym_macro] = ACTIONS(10966),
    [anon_sym_quote] = ACTIONS(10966),
    [anon_sym_let] = ACTIONS(10966),
    [anon_sym_if] = ACTIONS(10966),
    [anon_sym_try] = ACTIONS(10966),
    [anon_sym_for] = ACTIONS(10966),
    [anon_sym_while] = ACTIONS(10966),
    [sym_break_statement] = ACTIONS(10966),
    [sym_continue_statement] = ACTIONS(10966),
    [anon_sym_return] = ACTIONS(10966),
    [anon_sym_const] = ACTIONS(10966),
    [anon_sym_global] = ACTIONS(10966),
    [anon_sym_local] = ACTIONS(10966),
    [anon_sym_LPAREN] = ACTIONS(10968),
    [anon_sym_COLON] = ACTIONS(10966),
    [anon_sym_export] = ACTIONS(10966),
    [anon_sym_public] = ACTIONS(10966),
    [anon_sym_import] = ACTIONS(10966),
    [anon_sym_using] = ACTIONS(10966),
    [anon_sym_LBRACK] = ACTIONS(10968),
    [anon_sym_in] = ACTIONS(10966),
    [anon_sym_LBRACE] = ACTIONS(10968),
    [anon_sym_DOLLAR] = ACTIONS(10968),
    [anon_sym_COLON2] = ACTIONS(10966),
    [anon_sym_COLON_COLON] = ACTIONS(10968),
    [anon_sym_isa] = ACTIONS(10966),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10968),
    [anon_sym_QMARK] = ACTIONS(10968),
    [anon_sym_where] = ACTIONS(10966),
    [anon_sym_AT] = ACTIONS(10968),
    [anon_sym_true] = ACTIONS(10966),
    [anon_sym_false] = ACTIONS(10966),
    [aux_sym_integer_literal_token1] = ACTIONS(10968),
    [aux_sym_integer_literal_token2] = ACTIONS(10968),
    [aux_sym_integer_literal_token3] = ACTIONS(10966),
    [aux_sym_integer_literal_token4] = ACTIONS(10966),
    [aux_sym_float_literal_token1] = ACTIONS(10968),
    [aux_sym_float_literal_token3] = ACTIONS(10968),
    [aux_sym_float_literal_token4] = ACTIONS(10968),
    [sym_character_literal] = ACTIONS(10968),
    [anon_sym_DQUOTE] = ACTIONS(10966),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10968),
    [anon_sym_BQUOTE] = ACTIONS(10966),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10968),
    [sym__pair_operator] = ACTIONS(10968),
    [sym__arrow_operator] = ACTIONS(10966),
    [sym__lazy_or_operator] = ACTIONS(10968),
    [sym__lazy_and_operator] = ACTIONS(10968),
    [sym__comparison_operator] = ACTIONS(10966),
    [sym__pipe_right_operator] = ACTIONS(10968),
    [sym__pipe_left_operator] = ACTIONS(10968),
    [sym__ellipsis_operator] = ACTIONS(10966),
    [sym__plus_operator] = ACTIONS(10966),
    [sym__times_operator] = ACTIONS(10966),
    [sym__rational_operator] = ACTIONS(10968),
    [sym__bitshift_operator] = ACTIONS(10968),
    [sym__power_operator] = ACTIONS(10968),
    [sym__tilde_operator] = ACTIONS(10968),
    [sym__type_order_operator] = ACTIONS(10968),
    [sym__unary_operator] = ACTIONS(10966),
    [sym__unary_plus_operator] = ACTIONS(10966),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9261] = {
    [sym_block_comment] = STATE(9261),
    [sym_line_comment] = STATE(9261),
    [sym__word_identifier] = ACTIONS(10970),
    [anon_sym_COMMA] = ACTIONS(10972),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(10970),
    [anon_sym_module] = ACTIONS(10970),
    [anon_sym_baremodule] = ACTIONS(10970),
    [anon_sym_end] = ACTIONS(10970),
    [anon_sym_abstract] = ACTIONS(10970),
    [anon_sym_primitive] = ACTIONS(10970),
    [anon_sym_mutable] = ACTIONS(10970),
    [anon_sym_struct] = ACTIONS(10970),
    [anon_sym_function] = ACTIONS(10970),
    [anon_sym_macro] = ACTIONS(10970),
    [anon_sym_quote] = ACTIONS(10970),
    [anon_sym_let] = ACTIONS(10970),
    [anon_sym_if] = ACTIONS(10970),
    [anon_sym_try] = ACTIONS(10970),
    [anon_sym_for] = ACTIONS(10970),
    [anon_sym_while] = ACTIONS(10970),
    [sym_break_statement] = ACTIONS(10970),
    [sym_continue_statement] = ACTIONS(10970),
    [anon_sym_return] = ACTIONS(10970),
    [anon_sym_const] = ACTIONS(10970),
    [anon_sym_global] = ACTIONS(10970),
    [anon_sym_local] = ACTIONS(10970),
    [anon_sym_LPAREN] = ACTIONS(10972),
    [anon_sym_COLON] = ACTIONS(10970),
    [anon_sym_export] = ACTIONS(10970),
    [anon_sym_public] = ACTIONS(10970),
    [anon_sym_import] = ACTIONS(10970),
    [anon_sym_using] = ACTIONS(10970),
    [anon_sym_LBRACK] = ACTIONS(10972),
    [anon_sym_in] = ACTIONS(10970),
    [anon_sym_LBRACE] = ACTIONS(10972),
    [anon_sym_DOLLAR] = ACTIONS(10972),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_COLON_COLON] = ACTIONS(10972),
    [anon_sym_isa] = ACTIONS(10970),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10972),
    [anon_sym_QMARK] = ACTIONS(10972),
    [anon_sym_where] = ACTIONS(10970),
    [anon_sym_AT] = ACTIONS(10972),
    [anon_sym_true] = ACTIONS(10970),
    [anon_sym_false] = ACTIONS(10970),
    [aux_sym_integer_literal_token1] = ACTIONS(10972),
    [aux_sym_integer_literal_token2] = ACTIONS(10972),
    [aux_sym_integer_literal_token3] = ACTIONS(10970),
    [aux_sym_integer_literal_token4] = ACTIONS(10970),
    [aux_sym_float_literal_token1] = ACTIONS(10972),
    [aux_sym_float_literal_token3] = ACTIONS(10972),
    [aux_sym_float_literal_token4] = ACTIONS(10972),
    [sym_character_literal] = ACTIONS(10972),
    [anon_sym_DQUOTE] = ACTIONS(10970),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10972),
    [anon_sym_BQUOTE] = ACTIONS(10970),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10972),
    [sym__pair_operator] = ACTIONS(10972),
    [sym__arrow_operator] = ACTIONS(10970),
    [sym__lazy_or_operator] = ACTIONS(10972),
    [sym__lazy_and_operator] = ACTIONS(10972),
    [sym__comparison_operator] = ACTIONS(10970),
    [sym__pipe_right_operator] = ACTIONS(10972),
    [sym__pipe_left_operator] = ACTIONS(10972),
    [sym__ellipsis_operator] = ACTIONS(10970),
    [sym__plus_operator] = ACTIONS(10970),
    [sym__times_operator] = ACTIONS(10970),
    [sym__rational_operator] = ACTIONS(10972),
    [sym__bitshift_operator] = ACTIONS(10972),
    [sym__power_operator] = ACTIONS(10972),
    [sym__tilde_operator] = ACTIONS(10972),
    [sym__type_order_operator] = ACTIONS(10972),
    [sym__unary_operator] = ACTIONS(10970),
    [sym__unary_plus_operator] = ACTIONS(10970),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9262] = {
    [sym_block_comment] = STATE(9262),
    [sym_line_comment] = STATE(9262),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(12806),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9263] = {
    [sym_block_comment] = STATE(9263),
    [sym_line_comment] = STATE(9263),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9264] = {
    [sym__primary_expression] = STATE(11579),
    [sym__array] = STATE(10625),
    [sym_comprehension_expression] = STATE(10565),
    [sym_matrix_expression] = STATE(10565),
    [sym_vector_expression] = STATE(10565),
    [sym_parenthesized_expression] = STATE(10625),
    [sym_tuple_expression] = STATE(10625),
    [sym_curly_expression] = STATE(10625),
    [sym_adjoint_expression] = STATE(10625),
    [sym_field_expression] = STATE(10625),
    [sym_index_expression] = STATE(10625),
    [sym_parametrized_type_expression] = STATE(10625),
    [sym_call_expression] = STATE(10625),
    [sym_broadcast_call_expression] = STATE(10625),
    [sym__closed_macrocall_expression] = STATE(10625),
    [sym_interpolation_expression] = STATE(10625),
    [sym_quote_expression] = STATE(10625),
    [sym_macro_identifier] = STATE(17618),
    [sym_identifier] = STATE(11374),
    [sym_boolean_literal] = STATE(10625),
    [sym__string] = STATE(10625),
    [sym__delimiter_str_1] = STATE(14612),
    [sym__delimiter_str_3] = STATE(14613),
    [sym__delimiter_cmd_1] = STATE(14621),
    [sym__delimiter_cmd_3] = STATE(14622),
    [sym_string_literal] = STATE(10679),
    [sym_command_literal] = STATE(10679),
    [sym_prefixed_string_literal] = STATE(10679),
    [sym_prefixed_command_literal] = STATE(10679),
    [sym_operator] = STATE(19350),
    [sym_block_comment] = STATE(9264),
    [sym_line_comment] = STATE(9264),
    [sym__word_identifier] = ACTIONS(10300),
    [anon_sym_COMMA] = ACTIONS(9171),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(10302),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(10304),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10306),
    [anon_sym_DOLLAR] = ACTIONS(10507),
    [anon_sym_COLON2] = ACTIONS(10509),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10262),
    [anon_sym_true] = ACTIONS(10312),
    [anon_sym_false] = ACTIONS(10312),
    [sym_character_literal] = ACTIONS(10314),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [sym__pair_operator] = ACTIONS(9209),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9209),
    [sym__pipe_left_operator] = ACTIONS(9209),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9209),
    [sym__bitshift_operator] = ACTIONS(9209),
    [sym__power_operator] = ACTIONS(9209),
    [sym__tilde_operator] = ACTIONS(1825),
    [sym__type_order_operator] = ACTIONS(9209),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym__terminator_token1] = ACTIONS(9212),
    [aux_sym__terminator_token2] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9265] = {
    [sym_block_comment] = STATE(9265),
    [sym_line_comment] = STATE(9265),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11267),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11267),
    [anon_sym_RPAREN] = ACTIONS(11267),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11267),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_SEMI] = ACTIONS(11267),
    [anon_sym_LBRACE] = ACTIONS(11267),
    [anon_sym_DOLLAR] = ACTIONS(11267),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11267),
    [anon_sym_QMARK] = ACTIONS(11267),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11267),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11267),
    [aux_sym_integer_literal_token2] = ACTIONS(11267),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11267),
    [aux_sym_float_literal_token3] = ACTIONS(11267),
    [aux_sym_float_literal_token4] = ACTIONS(11267),
    [sym_character_literal] = ACTIONS(11267),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11267),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11267),
    [sym__pair_operator] = ACTIONS(11267),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11267),
    [sym__lazy_and_operator] = ACTIONS(11267),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11267),
    [sym__pipe_left_operator] = ACTIONS(11267),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11267),
    [sym__bitshift_operator] = ACTIONS(11267),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11267),
    [sym__type_order_operator] = ACTIONS(11267),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9266] = {
    [sym_block_comment] = STATE(9266),
    [sym_line_comment] = STATE(9266),
    [sym__word_identifier] = ACTIONS(10415),
    [anon_sym_begin] = ACTIONS(10415),
    [anon_sym_module] = ACTIONS(10415),
    [anon_sym_baremodule] = ACTIONS(10415),
    [anon_sym_end] = ACTIONS(10415),
    [anon_sym_abstract] = ACTIONS(10415),
    [anon_sym_primitive] = ACTIONS(10415),
    [anon_sym_mutable] = ACTIONS(10415),
    [anon_sym_struct] = ACTIONS(10415),
    [anon_sym_function] = ACTIONS(10415),
    [anon_sym_macro] = ACTIONS(10415),
    [anon_sym_quote] = ACTIONS(10415),
    [anon_sym_let] = ACTIONS(10415),
    [anon_sym_if] = ACTIONS(10415),
    [anon_sym_try] = ACTIONS(10415),
    [anon_sym_for] = ACTIONS(10415),
    [anon_sym_while] = ACTIONS(10415),
    [sym_break_statement] = ACTIONS(10415),
    [sym_continue_statement] = ACTIONS(10415),
    [anon_sym_return] = ACTIONS(10415),
    [anon_sym_const] = ACTIONS(10415),
    [anon_sym_global] = ACTIONS(10415),
    [anon_sym_local] = ACTIONS(10415),
    [anon_sym_LPAREN] = ACTIONS(10415),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(10415),
    [anon_sym_public] = ACTIONS(10415),
    [anon_sym_import] = ACTIONS(10415),
    [anon_sym_using] = ACTIONS(10415),
    [anon_sym_LBRACK] = ACTIONS(10415),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10415),
    [anon_sym_DOLLAR] = ACTIONS(10415),
    [anon_sym_COLON2] = ACTIONS(10415),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10415),
    [anon_sym_true] = ACTIONS(10415),
    [anon_sym_false] = ACTIONS(10415),
    [aux_sym_integer_literal_token1] = ACTIONS(10415),
    [aux_sym_integer_literal_token2] = ACTIONS(10415),
    [aux_sym_integer_literal_token3] = ACTIONS(10415),
    [aux_sym_integer_literal_token4] = ACTIONS(10415),
    [aux_sym_float_literal_token1] = ACTIONS(10415),
    [aux_sym_float_literal_token3] = ACTIONS(10415),
    [aux_sym_float_literal_token4] = ACTIONS(10415),
    [sym_character_literal] = ACTIONS(10415),
    [anon_sym_DQUOTE] = ACTIONS(10415),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10415),
    [anon_sym_BQUOTE] = ACTIONS(10415),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10415),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(10415),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(10415),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(10421),
    [aux_sym__terminator_token2] = ACTIONS(10415),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9267] = {
    [sym_block_comment] = STATE(9267),
    [sym_line_comment] = STATE(9267),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11277),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11277),
    [anon_sym_RPAREN] = ACTIONS(11277),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11277),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_SEMI] = ACTIONS(11277),
    [anon_sym_LBRACE] = ACTIONS(11277),
    [anon_sym_DOLLAR] = ACTIONS(11277),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11277),
    [anon_sym_QMARK] = ACTIONS(11277),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11277),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11277),
    [aux_sym_integer_literal_token2] = ACTIONS(11277),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11277),
    [aux_sym_float_literal_token3] = ACTIONS(11277),
    [aux_sym_float_literal_token4] = ACTIONS(11277),
    [sym_character_literal] = ACTIONS(11277),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11277),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11277),
    [sym__pair_operator] = ACTIONS(11277),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11277),
    [sym__lazy_and_operator] = ACTIONS(11277),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11277),
    [sym__pipe_left_operator] = ACTIONS(11277),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11277),
    [sym__type_order_operator] = ACTIONS(11277),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9268] = {
    [sym_block_comment] = STATE(9268),
    [sym_line_comment] = STATE(9268),
    [aux_sym_open_tuple_repeat1] = STATE(17652),
    [sym__word_identifier] = ACTIONS(10978),
    [anon_sym_COMMA] = ACTIONS(10982),
    [anon_sym_begin] = ACTIONS(10978),
    [anon_sym_module] = ACTIONS(10978),
    [anon_sym_baremodule] = ACTIONS(10978),
    [anon_sym_end] = ACTIONS(10978),
    [anon_sym_abstract] = ACTIONS(10978),
    [anon_sym_primitive] = ACTIONS(10978),
    [anon_sym_mutable] = ACTIONS(10978),
    [anon_sym_struct] = ACTIONS(10978),
    [anon_sym_function] = ACTIONS(10978),
    [anon_sym_macro] = ACTIONS(10978),
    [anon_sym_quote] = ACTIONS(10978),
    [anon_sym_let] = ACTIONS(10978),
    [anon_sym_if] = ACTIONS(10978),
    [anon_sym_try] = ACTIONS(10978),
    [anon_sym_for] = ACTIONS(10978),
    [anon_sym_while] = ACTIONS(10978),
    [sym_break_statement] = ACTIONS(10978),
    [sym_continue_statement] = ACTIONS(10978),
    [anon_sym_return] = ACTIONS(10978),
    [anon_sym_const] = ACTIONS(10978),
    [anon_sym_global] = ACTIONS(10978),
    [anon_sym_local] = ACTIONS(10978),
    [anon_sym_LPAREN] = ACTIONS(10982),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10978),
    [anon_sym_public] = ACTIONS(10978),
    [anon_sym_import] = ACTIONS(10978),
    [anon_sym_using] = ACTIONS(10978),
    [anon_sym_LBRACK] = ACTIONS(10982),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10982),
    [anon_sym_DOLLAR] = ACTIONS(10982),
    [anon_sym_COLON2] = ACTIONS(10978),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10982),
    [anon_sym_true] = ACTIONS(10978),
    [anon_sym_false] = ACTIONS(10978),
    [aux_sym_integer_literal_token1] = ACTIONS(10982),
    [aux_sym_integer_literal_token2] = ACTIONS(10982),
    [aux_sym_integer_literal_token3] = ACTIONS(10978),
    [aux_sym_integer_literal_token4] = ACTIONS(10978),
    [aux_sym_float_literal_token1] = ACTIONS(10982),
    [aux_sym_float_literal_token3] = ACTIONS(10982),
    [aux_sym_float_literal_token4] = ACTIONS(10982),
    [sym_character_literal] = ACTIONS(10982),
    [anon_sym_DQUOTE] = ACTIONS(10978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10982),
    [anon_sym_BQUOTE] = ACTIONS(10978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10982),
    [sym__pair_operator] = ACTIONS(10982),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10982),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10978),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9269] = {
    [sym_block_comment] = STATE(9269),
    [sym_line_comment] = STATE(9269),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(10336),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9270] = {
    [sym_block_comment] = STATE(9270),
    [sym_line_comment] = STATE(9270),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_RBRACK] = ACTIONS(11287),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12802),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(12680),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9271] = {
    [sym_block_comment] = STATE(9271),
    [sym_line_comment] = STATE(9271),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11112),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11112),
    [anon_sym_RBRACK] = ACTIONS(11112),
    [anon_sym_in] = ACTIONS(12810),
    [anon_sym_LBRACE] = ACTIONS(11112),
    [anon_sym_DOLLAR] = ACTIONS(11112),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12802),
    [anon_sym_where] = ACTIONS(12812),
    [anon_sym_AT] = ACTIONS(11112),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11112),
    [aux_sym_integer_literal_token2] = ACTIONS(11112),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11112),
    [aux_sym_float_literal_token3] = ACTIONS(11112),
    [aux_sym_float_literal_token4] = ACTIONS(11112),
    [sym_character_literal] = ACTIONS(11112),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11112),
    [sym__pair_operator] = ACTIONS(12814),
    [sym__arrow_operator] = ACTIONS(12816),
    [sym__lazy_or_operator] = ACTIONS(12818),
    [sym__lazy_and_operator] = ACTIONS(12820),
    [sym__comparison_operator] = ACTIONS(12810),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11112),
    [sym__type_order_operator] = ACTIONS(12810),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11114),
    [aux_sym__terminator_token2] = ACTIONS(11112),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9272] = {
    [sym_block_comment] = STATE(9272),
    [sym_line_comment] = STATE(9272),
    [sym__word_identifier] = ACTIONS(10214),
    [anon_sym_begin] = ACTIONS(10214),
    [anon_sym_module] = ACTIONS(10214),
    [anon_sym_baremodule] = ACTIONS(10214),
    [anon_sym_end] = ACTIONS(10214),
    [anon_sym_abstract] = ACTIONS(10214),
    [anon_sym_primitive] = ACTIONS(10214),
    [anon_sym_mutable] = ACTIONS(10214),
    [anon_sym_struct] = ACTIONS(10214),
    [anon_sym_function] = ACTIONS(10214),
    [anon_sym_macro] = ACTIONS(10214),
    [anon_sym_quote] = ACTIONS(10214),
    [anon_sym_let] = ACTIONS(10214),
    [anon_sym_if] = ACTIONS(10214),
    [anon_sym_try] = ACTIONS(10214),
    [anon_sym_for] = ACTIONS(10214),
    [anon_sym_while] = ACTIONS(10214),
    [sym_break_statement] = ACTIONS(10214),
    [sym_continue_statement] = ACTIONS(10214),
    [anon_sym_return] = ACTIONS(10214),
    [anon_sym_const] = ACTIONS(10214),
    [anon_sym_global] = ACTIONS(10214),
    [anon_sym_local] = ACTIONS(10214),
    [anon_sym_LPAREN] = ACTIONS(10214),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(10214),
    [anon_sym_public] = ACTIONS(10214),
    [anon_sym_import] = ACTIONS(10214),
    [anon_sym_using] = ACTIONS(10214),
    [anon_sym_LBRACK] = ACTIONS(10214),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(10214),
    [anon_sym_DOLLAR] = ACTIONS(10214),
    [anon_sym_COLON2] = ACTIONS(10214),
    [anon_sym_COLON_COLON] = ACTIONS(9171),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9171),
    [anon_sym_QMARK] = ACTIONS(9171),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(10214),
    [anon_sym_true] = ACTIONS(10214),
    [anon_sym_false] = ACTIONS(10214),
    [aux_sym_integer_literal_token1] = ACTIONS(10214),
    [aux_sym_integer_literal_token2] = ACTIONS(10214),
    [aux_sym_integer_literal_token3] = ACTIONS(10214),
    [aux_sym_integer_literal_token4] = ACTIONS(10214),
    [aux_sym_float_literal_token1] = ACTIONS(10214),
    [aux_sym_float_literal_token3] = ACTIONS(10214),
    [aux_sym_float_literal_token4] = ACTIONS(10214),
    [sym_character_literal] = ACTIONS(10214),
    [anon_sym_DQUOTE] = ACTIONS(10214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10214),
    [sym__pair_operator] = ACTIONS(9171),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9171),
    [sym__lazy_and_operator] = ACTIONS(9171),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9171),
    [sym__pipe_left_operator] = ACTIONS(9171),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9171),
    [sym__bitshift_operator] = ACTIONS(9171),
    [sym__power_operator] = ACTIONS(9171),
    [sym__tilde_operator] = ACTIONS(10214),
    [sym__type_order_operator] = ACTIONS(9171),
    [sym__unary_operator] = ACTIONS(10214),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym__terminator_token1] = ACTIONS(10216),
    [aux_sym__terminator_token2] = ACTIONS(10214),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9273] = {
    [sym_block_comment] = STATE(9273),
    [sym_line_comment] = STATE(9273),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_EQ] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9274] = {
    [sym_block_comment] = STATE(9274),
    [sym_line_comment] = STATE(9274),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_EQ] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9275] = {
    [sym_block_comment] = STATE(9275),
    [sym_line_comment] = STATE(9275),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12810),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12802),
    [anon_sym_where] = ACTIONS(12812),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(12814),
    [sym__arrow_operator] = ACTIONS(12816),
    [sym__lazy_or_operator] = ACTIONS(12818),
    [sym__lazy_and_operator] = ACTIONS(12820),
    [sym__comparison_operator] = ACTIONS(12810),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12810),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9276] = {
    [sym_block_comment] = STATE(9276),
    [sym_line_comment] = STATE(9276),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11247),
    [anon_sym_COLON] = ACTIONS(12672),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11247),
    [anon_sym_RBRACK] = ACTIONS(11247),
    [anon_sym_in] = ACTIONS(12674),
    [anon_sym_LBRACE] = ACTIONS(11247),
    [anon_sym_DOLLAR] = ACTIONS(11247),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(12802),
    [anon_sym_where] = ACTIONS(12678),
    [anon_sym_AT] = ACTIONS(11247),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11247),
    [aux_sym_integer_literal_token2] = ACTIONS(11247),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11247),
    [aux_sym_float_literal_token3] = ACTIONS(11247),
    [aux_sym_float_literal_token4] = ACTIONS(11247),
    [sym_character_literal] = ACTIONS(11247),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11247),
    [sym__pair_operator] = ACTIONS(12680),
    [sym__arrow_operator] = ACTIONS(12682),
    [sym__lazy_or_operator] = ACTIONS(12684),
    [sym__lazy_and_operator] = ACTIONS(12686),
    [sym__comparison_operator] = ACTIONS(12674),
    [sym__pipe_right_operator] = ACTIONS(12688),
    [sym__pipe_left_operator] = ACTIONS(12690),
    [sym__ellipsis_operator] = ACTIONS(12692),
    [sym__plus_operator] = ACTIONS(12694),
    [sym__times_operator] = ACTIONS(12696),
    [sym__rational_operator] = ACTIONS(12698),
    [sym__bitshift_operator] = ACTIONS(12700),
    [sym__power_operator] = ACTIONS(12702),
    [sym__tilde_operator] = ACTIONS(11247),
    [sym__type_order_operator] = ACTIONS(12674),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12694),
    [aux_sym__terminator_token1] = ACTIONS(11249),
    [aux_sym__terminator_token2] = ACTIONS(11247),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9277] = {
    [sym_block_comment] = STATE(9277),
    [sym_line_comment] = STATE(9277),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11114),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11114),
    [anon_sym_RPAREN] = ACTIONS(11114),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11114),
    [anon_sym_in] = ACTIONS(12768),
    [anon_sym_SEMI] = ACTIONS(11114),
    [anon_sym_LBRACE] = ACTIONS(11114),
    [anon_sym_DOLLAR] = ACTIONS(11114),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12770),
    [anon_sym_AT] = ACTIONS(11114),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11114),
    [aux_sym_integer_literal_token2] = ACTIONS(11114),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11114),
    [aux_sym_float_literal_token3] = ACTIONS(11114),
    [aux_sym_float_literal_token4] = ACTIONS(11114),
    [sym_character_literal] = ACTIONS(11114),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11114),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11114),
    [sym__pair_operator] = ACTIONS(12772),
    [sym__arrow_operator] = ACTIONS(12774),
    [sym__lazy_or_operator] = ACTIONS(12776),
    [sym__lazy_and_operator] = ACTIONS(12778),
    [sym__comparison_operator] = ACTIONS(12768),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11114),
    [sym__type_order_operator] = ACTIONS(12780),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9278] = {
    [sym_block_comment] = STATE(9278),
    [sym_line_comment] = STATE(9278),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_RPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(12360),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(12362),
    [anon_sym_SEMI] = ACTIONS(11249),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12362),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(12591),
    [anon_sym_where] = ACTIONS(12366),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(12368),
    [sym__arrow_operator] = ACTIONS(12370),
    [sym__lazy_or_operator] = ACTIONS(12372),
    [sym__lazy_and_operator] = ACTIONS(12374),
    [sym__comparison_operator] = ACTIONS(12362),
    [sym__pipe_right_operator] = ACTIONS(12376),
    [sym__pipe_left_operator] = ACTIONS(12378),
    [sym__ellipsis_operator] = ACTIONS(12380),
    [sym__plus_operator] = ACTIONS(12382),
    [sym__times_operator] = ACTIONS(12384),
    [sym__rational_operator] = ACTIONS(12386),
    [sym__bitshift_operator] = ACTIONS(12388),
    [sym__power_operator] = ACTIONS(12390),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(12392),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12382),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9279] = {
    [sym__primary_expression] = STATE(11535),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(11378),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(9279),
    [sym_line_comment] = STATE(9279),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_RPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_SEMI] = ACTIONS(9212),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_DOLLAR] = ACTIONS(12838),
    [anon_sym_COLON2] = ACTIONS(10535),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(9343),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9343),
    [sym__pipe_left_operator] = ACTIONS(9343),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9343),
    [sym__bitshift_operator] = ACTIONS(9343),
    [sym__power_operator] = ACTIONS(9343),
    [sym__tilde_operator] = ACTIONS(1823),
    [sym__type_order_operator] = ACTIONS(9343),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9280] = {
    [sym_block_comment] = STATE(9280),
    [sym_line_comment] = STATE(9280),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11275),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11275),
    [anon_sym_RBRACK] = ACTIONS(11275),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11275),
    [anon_sym_DOLLAR] = ACTIONS(11275),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11275),
    [anon_sym_QMARK] = ACTIONS(11275),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11275),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11275),
    [aux_sym_integer_literal_token2] = ACTIONS(11275),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11275),
    [aux_sym_float_literal_token3] = ACTIONS(11275),
    [aux_sym_float_literal_token4] = ACTIONS(11275),
    [sym_character_literal] = ACTIONS(11275),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11275),
    [sym__pair_operator] = ACTIONS(11275),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11275),
    [sym__lazy_and_operator] = ACTIONS(11275),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11275),
    [sym__pipe_left_operator] = ACTIONS(11275),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11275),
    [sym__type_order_operator] = ACTIONS(11275),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11277),
    [aux_sym__terminator_token2] = ACTIONS(11275),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9281] = {
    [sym_block_comment] = STATE(9281),
    [sym_line_comment] = STATE(9281),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9282] = {
    [sym_block_comment] = STATE(9282),
    [sym_line_comment] = STATE(9282),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9283] = {
    [sym_block_comment] = STATE(9283),
    [sym_line_comment] = STATE(9283),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9284] = {
    [sym_block_comment] = STATE(9284),
    [sym_line_comment] = STATE(9284),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9285] = {
    [sym_block_comment] = STATE(9285),
    [sym_line_comment] = STATE(9285),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11108),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11108),
    [sym__bitshift_operator] = ACTIONS(11108),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9286] = {
    [sym_block_comment] = STATE(9286),
    [sym_line_comment] = STATE(9286),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9287] = {
    [sym_block_comment] = STATE(9287),
    [sym_line_comment] = STATE(9287),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9288] = {
    [sym_block_comment] = STATE(9288),
    [sym_line_comment] = STATE(9288),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9289] = {
    [sym_block_comment] = STATE(9289),
    [sym_line_comment] = STATE(9289),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9290] = {
    [sym_block_comment] = STATE(9290),
    [sym_line_comment] = STATE(9290),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9291] = {
    [sym_block_comment] = STATE(9291),
    [sym_line_comment] = STATE(9291),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11265),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11265),
    [anon_sym_RBRACK] = ACTIONS(11265),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11265),
    [anon_sym_DOLLAR] = ACTIONS(11265),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11265),
    [anon_sym_QMARK] = ACTIONS(11265),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11265),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11265),
    [aux_sym_integer_literal_token2] = ACTIONS(11265),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11265),
    [aux_sym_float_literal_token3] = ACTIONS(11265),
    [aux_sym_float_literal_token4] = ACTIONS(11265),
    [sym_character_literal] = ACTIONS(11265),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11265),
    [sym__pair_operator] = ACTIONS(11265),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11265),
    [sym__lazy_and_operator] = ACTIONS(11265),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11265),
    [sym__pipe_left_operator] = ACTIONS(11265),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11265),
    [sym__bitshift_operator] = ACTIONS(11265),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11265),
    [sym__type_order_operator] = ACTIONS(11265),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym__terminator_token1] = ACTIONS(11267),
    [aux_sym__terminator_token2] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9292] = {
    [sym_block_comment] = STATE(9292),
    [sym_line_comment] = STATE(9292),
    [sym__word_identifier] = ACTIONS(11020),
    [anon_sym_COMMA] = ACTIONS(11022),
    [anon_sym_EQ] = ACTIONS(11020),
    [anon_sym_begin] = ACTIONS(11020),
    [anon_sym_module] = ACTIONS(11020),
    [anon_sym_baremodule] = ACTIONS(11020),
    [anon_sym_end] = ACTIONS(11020),
    [anon_sym_abstract] = ACTIONS(11020),
    [anon_sym_primitive] = ACTIONS(11020),
    [anon_sym_mutable] = ACTIONS(11020),
    [anon_sym_struct] = ACTIONS(11020),
    [anon_sym_function] = ACTIONS(11020),
    [anon_sym_macro] = ACTIONS(11020),
    [anon_sym_quote] = ACTIONS(11020),
    [anon_sym_let] = ACTIONS(11020),
    [anon_sym_if] = ACTIONS(11020),
    [anon_sym_try] = ACTIONS(11020),
    [anon_sym_for] = ACTIONS(11020),
    [anon_sym_while] = ACTIONS(11020),
    [sym_break_statement] = ACTIONS(11020),
    [sym_continue_statement] = ACTIONS(11020),
    [anon_sym_return] = ACTIONS(11020),
    [anon_sym_const] = ACTIONS(11020),
    [anon_sym_global] = ACTIONS(11020),
    [anon_sym_local] = ACTIONS(11020),
    [anon_sym_LPAREN] = ACTIONS(11022),
    [anon_sym_COLON] = ACTIONS(11020),
    [anon_sym_export] = ACTIONS(11020),
    [anon_sym_public] = ACTIONS(11020),
    [anon_sym_import] = ACTIONS(11020),
    [anon_sym_using] = ACTIONS(11020),
    [anon_sym_LBRACK] = ACTIONS(11022),
    [anon_sym_in] = ACTIONS(11020),
    [anon_sym_LBRACE] = ACTIONS(11022),
    [anon_sym_DOLLAR] = ACTIONS(11022),
    [anon_sym_COLON2] = ACTIONS(11020),
    [anon_sym_COLON_COLON] = ACTIONS(11022),
    [anon_sym_isa] = ACTIONS(11020),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11022),
    [anon_sym_QMARK] = ACTIONS(11022),
    [anon_sym_where] = ACTIONS(11020),
    [anon_sym_AT] = ACTIONS(11022),
    [anon_sym_true] = ACTIONS(11020),
    [anon_sym_false] = ACTIONS(11020),
    [aux_sym_integer_literal_token1] = ACTIONS(11022),
    [aux_sym_integer_literal_token2] = ACTIONS(11022),
    [aux_sym_integer_literal_token3] = ACTIONS(11020),
    [aux_sym_integer_literal_token4] = ACTIONS(11020),
    [aux_sym_float_literal_token1] = ACTIONS(11022),
    [aux_sym_float_literal_token3] = ACTIONS(11022),
    [aux_sym_float_literal_token4] = ACTIONS(11022),
    [sym_character_literal] = ACTIONS(11022),
    [anon_sym_DQUOTE] = ACTIONS(11020),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11022),
    [anon_sym_BQUOTE] = ACTIONS(11020),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11022),
    [sym__pair_operator] = ACTIONS(11022),
    [sym__arrow_operator] = ACTIONS(11020),
    [sym__lazy_or_operator] = ACTIONS(11022),
    [sym__lazy_and_operator] = ACTIONS(11022),
    [sym__comparison_operator] = ACTIONS(11020),
    [sym__pipe_right_operator] = ACTIONS(11022),
    [sym__pipe_left_operator] = ACTIONS(11022),
    [sym__ellipsis_operator] = ACTIONS(11020),
    [sym__plus_operator] = ACTIONS(11020),
    [sym__times_operator] = ACTIONS(11020),
    [sym__rational_operator] = ACTIONS(11022),
    [sym__bitshift_operator] = ACTIONS(11022),
    [sym__power_operator] = ACTIONS(11022),
    [sym__tilde_operator] = ACTIONS(11022),
    [sym__type_order_operator] = ACTIONS(11022),
    [sym__unary_operator] = ACTIONS(11020),
    [sym__unary_plus_operator] = ACTIONS(11020),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9293] = {
    [sym_block_comment] = STATE(9293),
    [sym_line_comment] = STATE(9293),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9294] = {
    [sym_block_comment] = STATE(9294),
    [sym_line_comment] = STATE(9294),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11277),
    [anon_sym_EQ] = ACTIONS(11275),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11277),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11277),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11277),
    [anon_sym_DOLLAR] = ACTIONS(11277),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11277),
    [anon_sym_QMARK] = ACTIONS(11277),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11277),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11277),
    [aux_sym_integer_literal_token2] = ACTIONS(11277),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11277),
    [aux_sym_float_literal_token3] = ACTIONS(11277),
    [aux_sym_float_literal_token4] = ACTIONS(11277),
    [sym_character_literal] = ACTIONS(11277),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11277),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11277),
    [sym__pair_operator] = ACTIONS(11277),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11277),
    [sym__lazy_and_operator] = ACTIONS(11277),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11277),
    [sym__pipe_left_operator] = ACTIONS(11277),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11277),
    [sym__type_order_operator] = ACTIONS(11277),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9295] = {
    [sym_block_comment] = STATE(9295),
    [sym_line_comment] = STATE(9295),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(3621),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(3623),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12227),
    [anon_sym_isa] = ACTIONS(3623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3627),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(3623),
    [sym__pipe_right_operator] = ACTIONS(12782),
    [sym__pipe_left_operator] = ACTIONS(12784),
    [sym__ellipsis_operator] = ACTIONS(12786),
    [sym__plus_operator] = ACTIONS(12788),
    [sym__times_operator] = ACTIONS(12790),
    [sym__rational_operator] = ACTIONS(12792),
    [sym__bitshift_operator] = ACTIONS(12794),
    [sym__power_operator] = ACTIONS(12796),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(3623),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12788),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9296] = {
    [sym_block_comment] = STATE(9296),
    [sym_line_comment] = STATE(9296),
    [sym__word_identifier] = ACTIONS(9171),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_begin] = ACTIONS(9171),
    [anon_sym_module] = ACTIONS(9171),
    [anon_sym_baremodule] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_abstract] = ACTIONS(9171),
    [anon_sym_primitive] = ACTIONS(9171),
    [anon_sym_mutable] = ACTIONS(9171),
    [anon_sym_struct] = ACTIONS(9171),
    [anon_sym_function] = ACTIONS(9171),
    [anon_sym_macro] = ACTIONS(9171),
    [anon_sym_quote] = ACTIONS(9171),
    [anon_sym_let] = ACTIONS(9171),
    [anon_sym_if] = ACTIONS(9171),
    [anon_sym_try] = ACTIONS(9171),
    [anon_sym_for] = ACTIONS(9171),
    [anon_sym_while] = ACTIONS(9171),
    [sym_break_statement] = ACTIONS(9171),
    [sym_continue_statement] = ACTIONS(9171),
    [anon_sym_return] = ACTIONS(9171),
    [anon_sym_const] = ACTIONS(9171),
    [anon_sym_global] = ACTIONS(9171),
    [anon_sym_local] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9212),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_export] = ACTIONS(9171),
    [anon_sym_public] = ACTIONS(9171),
    [anon_sym_import] = ACTIONS(9171),
    [anon_sym_using] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9212),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9212),
    [anon_sym_DOLLAR] = ACTIONS(9212),
    [anon_sym_COLON2] = ACTIONS(9171),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9212),
    [anon_sym_true] = ACTIONS(9171),
    [anon_sym_false] = ACTIONS(9171),
    [aux_sym_integer_literal_token1] = ACTIONS(9212),
    [aux_sym_integer_literal_token2] = ACTIONS(9212),
    [aux_sym_integer_literal_token3] = ACTIONS(9171),
    [aux_sym_integer_literal_token4] = ACTIONS(9171),
    [aux_sym_float_literal_token1] = ACTIONS(9212),
    [aux_sym_float_literal_token3] = ACTIONS(9212),
    [aux_sym_float_literal_token4] = ACTIONS(9212),
    [sym_character_literal] = ACTIONS(9212),
    [anon_sym_DQUOTE] = ACTIONS(9171),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9212),
    [anon_sym_BQUOTE] = ACTIONS(9171),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9212),
    [sym__pair_operator] = ACTIONS(9212),
    [sym__arrow_operator] = ACTIONS(9171),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9171),
    [sym__pipe_right_operator] = ACTIONS(9212),
    [sym__pipe_left_operator] = ACTIONS(9212),
    [sym__ellipsis_operator] = ACTIONS(9171),
    [sym__plus_operator] = ACTIONS(9171),
    [sym__times_operator] = ACTIONS(9171),
    [sym__rational_operator] = ACTIONS(9212),
    [sym__bitshift_operator] = ACTIONS(9212),
    [sym__power_operator] = ACTIONS(9212),
    [sym__tilde_operator] = ACTIONS(9212),
    [sym__type_order_operator] = ACTIONS(9212),
    [sym__unary_operator] = ACTIONS(9171),
    [sym__unary_plus_operator] = ACTIONS(9171),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9297] = {
    [sym_block_comment] = STATE(9297),
    [sym_line_comment] = STATE(9297),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_RPAREN] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(12750),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(12768),
    [anon_sym_SEMI] = ACTIONS(11866),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12168),
    [anon_sym_isa] = ACTIONS(12768),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12261),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11866),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(12768),
    [sym__pipe_right_operator] = ACTIONS(12752),
    [sym__pipe_left_operator] = ACTIONS(12754),
    [sym__ellipsis_operator] = ACTIONS(12756),
    [sym__plus_operator] = ACTIONS(12758),
    [sym__times_operator] = ACTIONS(12760),
    [sym__rational_operator] = ACTIONS(12762),
    [sym__bitshift_operator] = ACTIONS(12764),
    [sym__power_operator] = ACTIONS(12766),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(12780),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12758),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9298] = {
    [sym_block_comment] = STATE(9298),
    [sym_line_comment] = STATE(9298),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(10361),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9299] = {
    [sym_block_comment] = STATE(9299),
    [sym_line_comment] = STATE(9299),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(10976),
    [anon_sym_EQ] = ACTIONS(10974),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(10974),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(10974),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(10976),
    [anon_sym_isa] = ACTIONS(10974),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10976),
    [anon_sym_QMARK] = ACTIONS(10976),
    [anon_sym_where] = ACTIONS(10974),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(10976),
    [sym__arrow_operator] = ACTIONS(10974),
    [sym__lazy_or_operator] = ACTIONS(10976),
    [sym__lazy_and_operator] = ACTIONS(10976),
    [sym__comparison_operator] = ACTIONS(10974),
    [sym__pipe_right_operator] = ACTIONS(10976),
    [sym__pipe_left_operator] = ACTIONS(10976),
    [sym__ellipsis_operator] = ACTIONS(10974),
    [sym__plus_operator] = ACTIONS(10974),
    [sym__times_operator] = ACTIONS(10974),
    [sym__rational_operator] = ACTIONS(10976),
    [sym__bitshift_operator] = ACTIONS(10976),
    [sym__power_operator] = ACTIONS(10976),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(10976),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(10974),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9300] = {
    [sym_block_comment] = STATE(9300),
    [sym_line_comment] = STATE(9300),
    [aux_sym_open_tuple_repeat1] = STATE(8972),
    [sym__word_identifier] = ACTIONS(10974),
    [anon_sym_COMMA] = ACTIONS(12628),
    [anon_sym_begin] = ACTIONS(10974),
    [anon_sym_module] = ACTIONS(10974),
    [anon_sym_baremodule] = ACTIONS(10974),
    [anon_sym_end] = ACTIONS(10974),
    [anon_sym_abstract] = ACTIONS(10974),
    [anon_sym_primitive] = ACTIONS(10974),
    [anon_sym_mutable] = ACTIONS(10974),
    [anon_sym_struct] = ACTIONS(10974),
    [anon_sym_function] = ACTIONS(10974),
    [anon_sym_macro] = ACTIONS(10974),
    [anon_sym_quote] = ACTIONS(10974),
    [anon_sym_let] = ACTIONS(10974),
    [anon_sym_if] = ACTIONS(10974),
    [anon_sym_try] = ACTIONS(10974),
    [anon_sym_for] = ACTIONS(10974),
    [anon_sym_while] = ACTIONS(10974),
    [sym_break_statement] = ACTIONS(10974),
    [sym_continue_statement] = ACTIONS(10974),
    [anon_sym_return] = ACTIONS(10974),
    [anon_sym_const] = ACTIONS(10974),
    [anon_sym_global] = ACTIONS(10974),
    [anon_sym_local] = ACTIONS(10974),
    [anon_sym_LPAREN] = ACTIONS(10976),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(10974),
    [anon_sym_public] = ACTIONS(10974),
    [anon_sym_import] = ACTIONS(10974),
    [anon_sym_using] = ACTIONS(10974),
    [anon_sym_LBRACK] = ACTIONS(10976),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(10976),
    [anon_sym_DOLLAR] = ACTIONS(10976),
    [anon_sym_COLON2] = ACTIONS(10974),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(10976),
    [anon_sym_true] = ACTIONS(10974),
    [anon_sym_false] = ACTIONS(10974),
    [aux_sym_integer_literal_token1] = ACTIONS(10976),
    [aux_sym_integer_literal_token2] = ACTIONS(10976),
    [aux_sym_integer_literal_token3] = ACTIONS(10974),
    [aux_sym_integer_literal_token4] = ACTIONS(10974),
    [aux_sym_float_literal_token1] = ACTIONS(10976),
    [aux_sym_float_literal_token3] = ACTIONS(10976),
    [aux_sym_float_literal_token4] = ACTIONS(10976),
    [sym_character_literal] = ACTIONS(10976),
    [anon_sym_DQUOTE] = ACTIONS(10974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10976),
    [anon_sym_BQUOTE] = ACTIONS(10974),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10976),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(10976),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(10974),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9301] = {
    [sym_block_comment] = STATE(9301),
    [sym_line_comment] = STATE(9301),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9302] = {
    [sym_block_comment] = STATE(9302),
    [sym_line_comment] = STATE(9302),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11864),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11864),
    [anon_sym_RBRACK] = ACTIONS(11864),
    [anon_sym_in] = ACTIONS(12810),
    [anon_sym_LBRACE] = ACTIONS(11864),
    [anon_sym_DOLLAR] = ACTIONS(11864),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11864),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11864),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11864),
    [aux_sym_integer_literal_token2] = ACTIONS(11864),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11864),
    [aux_sym_float_literal_token3] = ACTIONS(11864),
    [aux_sym_float_literal_token4] = ACTIONS(11864),
    [sym_character_literal] = ACTIONS(11864),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11864),
    [sym__pair_operator] = ACTIONS(11864),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11864),
    [sym__lazy_and_operator] = ACTIONS(11864),
    [sym__comparison_operator] = ACTIONS(12810),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11864),
    [sym__type_order_operator] = ACTIONS(12810),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11866),
    [aux_sym__terminator_token2] = ACTIONS(11864),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9303] = {
    [sym_block_comment] = STATE(9303),
    [sym_line_comment] = STATE(9303),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12810),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12812),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(12816),
    [sym__lazy_or_operator] = ACTIONS(12818),
    [sym__lazy_and_operator] = ACTIONS(12820),
    [sym__comparison_operator] = ACTIONS(12810),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12810),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9304] = {
    [sym_block_comment] = STATE(9304),
    [sym_line_comment] = STATE(9304),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12810),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12812),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(12820),
    [sym__comparison_operator] = ACTIONS(12810),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12810),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9305] = {
    [sym_block_comment] = STATE(9305),
    [sym_line_comment] = STATE(9305),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(12810),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(12810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(12812),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(12810),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(12810),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9306] = {
    [sym_block_comment] = STATE(9306),
    [sym_line_comment] = STATE(9306),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11108),
    [sym__pipe_left_operator] = ACTIONS(11108),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9307] = {
    [sym_block_comment] = STATE(9307),
    [sym_line_comment] = STATE(9307),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11108),
    [anon_sym_COLON] = ACTIONS(12808),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11108),
    [anon_sym_RBRACK] = ACTIONS(11108),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11108),
    [anon_sym_DOLLAR] = ACTIONS(11108),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(11060),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11062),
    [anon_sym_QMARK] = ACTIONS(11108),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11108),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11108),
    [aux_sym_integer_literal_token2] = ACTIONS(11108),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11108),
    [aux_sym_float_literal_token3] = ACTIONS(11108),
    [aux_sym_float_literal_token4] = ACTIONS(11108),
    [sym_character_literal] = ACTIONS(11108),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11108),
    [sym__pair_operator] = ACTIONS(11108),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11108),
    [sym__lazy_and_operator] = ACTIONS(11108),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12822),
    [sym__pipe_left_operator] = ACTIONS(12824),
    [sym__ellipsis_operator] = ACTIONS(12826),
    [sym__plus_operator] = ACTIONS(12828),
    [sym__times_operator] = ACTIONS(12830),
    [sym__rational_operator] = ACTIONS(12832),
    [sym__bitshift_operator] = ACTIONS(12834),
    [sym__power_operator] = ACTIONS(12836),
    [sym__tilde_operator] = ACTIONS(11108),
    [sym__type_order_operator] = ACTIONS(11108),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12828),
    [aux_sym__terminator_token1] = ACTIONS(11110),
    [aux_sym__terminator_token2] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9308] = {
    [sym_block_comment] = STATE(9308),
    [sym_line_comment] = STATE(9308),
    [sym__word_identifier] = ACTIONS(10761),
    [anon_sym_COMMA] = ACTIONS(10763),
    [anon_sym_EQ] = ACTIONS(10761),
    [anon_sym_begin] = ACTIONS(10761),
    [anon_sym_module] = ACTIONS(10761),
    [anon_sym_baremodule] = ACTIONS(10761),
    [anon_sym_end] = ACTIONS(10761),
    [anon_sym_abstract] = ACTIONS(10761),
    [anon_sym_primitive] = ACTIONS(10761),
    [anon_sym_mutable] = ACTIONS(10761),
    [anon_sym_struct] = ACTIONS(10761),
    [anon_sym_function] = ACTIONS(10761),
    [anon_sym_macro] = ACTIONS(10761),
    [anon_sym_quote] = ACTIONS(10761),
    [anon_sym_let] = ACTIONS(10761),
    [anon_sym_if] = ACTIONS(10761),
    [anon_sym_try] = ACTIONS(10761),
    [anon_sym_for] = ACTIONS(10761),
    [anon_sym_while] = ACTIONS(10761),
    [sym_break_statement] = ACTIONS(10761),
    [sym_continue_statement] = ACTIONS(10761),
    [anon_sym_return] = ACTIONS(10761),
    [anon_sym_const] = ACTIONS(10761),
    [anon_sym_global] = ACTIONS(10761),
    [anon_sym_local] = ACTIONS(10761),
    [anon_sym_LPAREN] = ACTIONS(10763),
    [anon_sym_COLON] = ACTIONS(10761),
    [anon_sym_export] = ACTIONS(10761),
    [anon_sym_public] = ACTIONS(10761),
    [anon_sym_import] = ACTIONS(10761),
    [anon_sym_using] = ACTIONS(10761),
    [anon_sym_LBRACK] = ACTIONS(10763),
    [anon_sym_in] = ACTIONS(10761),
    [anon_sym_LBRACE] = ACTIONS(10763),
    [anon_sym_DOLLAR] = ACTIONS(10763),
    [anon_sym_COLON2] = ACTIONS(10761),
    [anon_sym_COLON_COLON] = ACTIONS(10763),
    [anon_sym_isa] = ACTIONS(10761),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10763),
    [anon_sym_QMARK] = ACTIONS(10763),
    [anon_sym_where] = ACTIONS(10761),
    [anon_sym_AT] = ACTIONS(10763),
    [anon_sym_true] = ACTIONS(10761),
    [anon_sym_false] = ACTIONS(10761),
    [aux_sym_integer_literal_token1] = ACTIONS(10763),
    [aux_sym_integer_literal_token2] = ACTIONS(10763),
    [aux_sym_integer_literal_token3] = ACTIONS(10761),
    [aux_sym_integer_literal_token4] = ACTIONS(10761),
    [aux_sym_float_literal_token1] = ACTIONS(10763),
    [aux_sym_float_literal_token3] = ACTIONS(10763),
    [aux_sym_float_literal_token4] = ACTIONS(10763),
    [sym_character_literal] = ACTIONS(10763),
    [anon_sym_DQUOTE] = ACTIONS(10761),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10763),
    [anon_sym_BQUOTE] = ACTIONS(10761),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10763),
    [sym__pair_operator] = ACTIONS(10763),
    [sym__arrow_operator] = ACTIONS(10761),
    [sym__lazy_or_operator] = ACTIONS(10763),
    [sym__lazy_and_operator] = ACTIONS(10763),
    [sym__comparison_operator] = ACTIONS(10761),
    [sym__pipe_right_operator] = ACTIONS(10763),
    [sym__pipe_left_operator] = ACTIONS(10763),
    [sym__ellipsis_operator] = ACTIONS(10761),
    [sym__plus_operator] = ACTIONS(10761),
    [sym__times_operator] = ACTIONS(10761),
    [sym__rational_operator] = ACTIONS(10763),
    [sym__bitshift_operator] = ACTIONS(10763),
    [sym__power_operator] = ACTIONS(10763),
    [sym__tilde_operator] = ACTIONS(10763),
    [sym__type_order_operator] = ACTIONS(10763),
    [sym__unary_operator] = ACTIONS(10761),
    [sym__unary_plus_operator] = ACTIONS(10761),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9309] = {
    [sym_block_comment] = STATE(9309),
    [sym_line_comment] = STATE(9309),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9310] = {
    [sym_block_comment] = STATE(9310),
    [sym_line_comment] = STATE(9310),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_EQ] = ACTIONS(11864),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11866),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9311] = {
    [sym_block_comment] = STATE(9311),
    [sym_line_comment] = STATE(9311),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12712),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9312] = {
    [sym_block_comment] = STATE(9312),
    [sym_line_comment] = STATE(9312),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9313] = {
    [sym_block_comment] = STATE(9313),
    [sym_line_comment] = STATE(9313),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9314] = {
    [sym_block_comment] = STATE(9314),
    [sym_line_comment] = STATE(9314),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9315] = {
    [sym_block_comment] = STATE(9315),
    [sym_line_comment] = STATE(9315),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9316] = {
    [sym_block_comment] = STATE(9316),
    [sym_line_comment] = STATE(9316),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_EQ] = ACTIONS(11108),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9317] = {
    [sym_block_comment] = STATE(9317),
    [sym_line_comment] = STATE(9317),
    [sym__word_identifier] = ACTIONS(11120),
    [anon_sym_COMMA] = ACTIONS(11122),
    [anon_sym_EQ] = ACTIONS(11120),
    [anon_sym_begin] = ACTIONS(11120),
    [anon_sym_module] = ACTIONS(11120),
    [anon_sym_baremodule] = ACTIONS(11120),
    [anon_sym_end] = ACTIONS(11120),
    [anon_sym_abstract] = ACTIONS(11120),
    [anon_sym_primitive] = ACTIONS(11120),
    [anon_sym_mutable] = ACTIONS(11120),
    [anon_sym_struct] = ACTIONS(11120),
    [anon_sym_function] = ACTIONS(11120),
    [anon_sym_macro] = ACTIONS(11120),
    [anon_sym_quote] = ACTIONS(11120),
    [anon_sym_let] = ACTIONS(11120),
    [anon_sym_if] = ACTIONS(11120),
    [anon_sym_try] = ACTIONS(11120),
    [anon_sym_for] = ACTIONS(11120),
    [anon_sym_while] = ACTIONS(11120),
    [sym_break_statement] = ACTIONS(11120),
    [sym_continue_statement] = ACTIONS(11120),
    [anon_sym_return] = ACTIONS(11120),
    [anon_sym_const] = ACTIONS(11120),
    [anon_sym_global] = ACTIONS(11120),
    [anon_sym_local] = ACTIONS(11120),
    [anon_sym_LPAREN] = ACTIONS(11122),
    [anon_sym_COLON] = ACTIONS(11120),
    [anon_sym_export] = ACTIONS(11120),
    [anon_sym_public] = ACTIONS(11120),
    [anon_sym_import] = ACTIONS(11120),
    [anon_sym_using] = ACTIONS(11120),
    [anon_sym_LBRACK] = ACTIONS(11122),
    [anon_sym_in] = ACTIONS(11120),
    [anon_sym_LBRACE] = ACTIONS(11122),
    [anon_sym_DOLLAR] = ACTIONS(11122),
    [anon_sym_COLON2] = ACTIONS(11120),
    [anon_sym_COLON_COLON] = ACTIONS(11122),
    [anon_sym_isa] = ACTIONS(11120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11122),
    [anon_sym_QMARK] = ACTIONS(11122),
    [anon_sym_where] = ACTIONS(11120),
    [anon_sym_AT] = ACTIONS(11122),
    [anon_sym_true] = ACTIONS(11120),
    [anon_sym_false] = ACTIONS(11120),
    [aux_sym_integer_literal_token1] = ACTIONS(11122),
    [aux_sym_integer_literal_token2] = ACTIONS(11122),
    [aux_sym_integer_literal_token3] = ACTIONS(11120),
    [aux_sym_integer_literal_token4] = ACTIONS(11120),
    [aux_sym_float_literal_token1] = ACTIONS(11122),
    [aux_sym_float_literal_token3] = ACTIONS(11122),
    [aux_sym_float_literal_token4] = ACTIONS(11122),
    [sym_character_literal] = ACTIONS(11122),
    [anon_sym_DQUOTE] = ACTIONS(11120),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11122),
    [anon_sym_BQUOTE] = ACTIONS(11120),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11122),
    [sym__pair_operator] = ACTIONS(11122),
    [sym__arrow_operator] = ACTIONS(11120),
    [sym__lazy_or_operator] = ACTIONS(11122),
    [sym__lazy_and_operator] = ACTIONS(11122),
    [sym__comparison_operator] = ACTIONS(11120),
    [sym__pipe_right_operator] = ACTIONS(11122),
    [sym__pipe_left_operator] = ACTIONS(11122),
    [sym__ellipsis_operator] = ACTIONS(11120),
    [sym__plus_operator] = ACTIONS(11120),
    [sym__times_operator] = ACTIONS(11120),
    [sym__rational_operator] = ACTIONS(11122),
    [sym__bitshift_operator] = ACTIONS(11122),
    [sym__power_operator] = ACTIONS(11122),
    [sym__tilde_operator] = ACTIONS(11122),
    [sym__type_order_operator] = ACTIONS(11122),
    [sym__unary_operator] = ACTIONS(11120),
    [sym__unary_plus_operator] = ACTIONS(11120),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9318] = {
    [sym_block_comment] = STATE(9318),
    [sym_line_comment] = STATE(9318),
    [sym__word_identifier] = ACTIONS(11112),
    [anon_sym_COMMA] = ACTIONS(11114),
    [anon_sym_begin] = ACTIONS(11112),
    [anon_sym_module] = ACTIONS(11112),
    [anon_sym_baremodule] = ACTIONS(11112),
    [anon_sym_end] = ACTIONS(11112),
    [anon_sym_abstract] = ACTIONS(11112),
    [anon_sym_primitive] = ACTIONS(11112),
    [anon_sym_mutable] = ACTIONS(11112),
    [anon_sym_struct] = ACTIONS(11112),
    [anon_sym_function] = ACTIONS(11112),
    [anon_sym_macro] = ACTIONS(11112),
    [anon_sym_quote] = ACTIONS(11112),
    [anon_sym_let] = ACTIONS(11112),
    [anon_sym_if] = ACTIONS(11112),
    [anon_sym_try] = ACTIONS(11112),
    [anon_sym_for] = ACTIONS(11112),
    [anon_sym_while] = ACTIONS(11112),
    [sym_break_statement] = ACTIONS(11112),
    [sym_continue_statement] = ACTIONS(11112),
    [anon_sym_return] = ACTIONS(11112),
    [anon_sym_const] = ACTIONS(11112),
    [anon_sym_global] = ACTIONS(11112),
    [anon_sym_local] = ACTIONS(11112),
    [anon_sym_LPAREN] = ACTIONS(11114),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11112),
    [anon_sym_public] = ACTIONS(11112),
    [anon_sym_import] = ACTIONS(11112),
    [anon_sym_using] = ACTIONS(11112),
    [anon_sym_LBRACK] = ACTIONS(11114),
    [anon_sym_in] = ACTIONS(12842),
    [anon_sym_LBRACE] = ACTIONS(11114),
    [anon_sym_DOLLAR] = ACTIONS(11114),
    [anon_sym_COLON2] = ACTIONS(11112),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12844),
    [anon_sym_AT] = ACTIONS(11114),
    [anon_sym_true] = ACTIONS(11112),
    [anon_sym_false] = ACTIONS(11112),
    [aux_sym_integer_literal_token1] = ACTIONS(11114),
    [aux_sym_integer_literal_token2] = ACTIONS(11114),
    [aux_sym_integer_literal_token3] = ACTIONS(11112),
    [aux_sym_integer_literal_token4] = ACTIONS(11112),
    [aux_sym_float_literal_token1] = ACTIONS(11114),
    [aux_sym_float_literal_token3] = ACTIONS(11114),
    [aux_sym_float_literal_token4] = ACTIONS(11114),
    [sym_character_literal] = ACTIONS(11114),
    [anon_sym_DQUOTE] = ACTIONS(11112),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11114),
    [anon_sym_BQUOTE] = ACTIONS(11112),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11114),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12848),
    [sym__lazy_or_operator] = ACTIONS(12850),
    [sym__lazy_and_operator] = ACTIONS(12852),
    [sym__comparison_operator] = ACTIONS(12842),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11114),
    [sym__type_order_operator] = ACTIONS(12870),
    [sym__unary_operator] = ACTIONS(11112),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9319] = {
    [sym_block_comment] = STATE(9319),
    [sym_line_comment] = STATE(9319),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(11110),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9320] = {
    [sym_block_comment] = STATE(9320),
    [sym_line_comment] = STATE(9320),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9321] = {
    [sym_block_comment] = STATE(9321),
    [sym_line_comment] = STATE(9321),
    [sym__word_identifier] = ACTIONS(11864),
    [anon_sym_COMMA] = ACTIONS(11866),
    [anon_sym_begin] = ACTIONS(11864),
    [anon_sym_module] = ACTIONS(11864),
    [anon_sym_baremodule] = ACTIONS(11864),
    [anon_sym_end] = ACTIONS(11864),
    [anon_sym_abstract] = ACTIONS(11864),
    [anon_sym_primitive] = ACTIONS(11864),
    [anon_sym_mutable] = ACTIONS(11864),
    [anon_sym_struct] = ACTIONS(11864),
    [anon_sym_function] = ACTIONS(11864),
    [anon_sym_macro] = ACTIONS(11864),
    [anon_sym_quote] = ACTIONS(11864),
    [anon_sym_let] = ACTIONS(11864),
    [anon_sym_if] = ACTIONS(11864),
    [anon_sym_try] = ACTIONS(11864),
    [anon_sym_for] = ACTIONS(11864),
    [anon_sym_while] = ACTIONS(11864),
    [sym_break_statement] = ACTIONS(11864),
    [sym_continue_statement] = ACTIONS(11864),
    [anon_sym_return] = ACTIONS(11864),
    [anon_sym_const] = ACTIONS(11864),
    [anon_sym_global] = ACTIONS(11864),
    [anon_sym_local] = ACTIONS(11864),
    [anon_sym_LPAREN] = ACTIONS(11866),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11864),
    [anon_sym_public] = ACTIONS(11864),
    [anon_sym_import] = ACTIONS(11864),
    [anon_sym_using] = ACTIONS(11864),
    [anon_sym_LBRACK] = ACTIONS(11866),
    [anon_sym_in] = ACTIONS(12842),
    [anon_sym_LBRACE] = ACTIONS(11866),
    [anon_sym_DOLLAR] = ACTIONS(11866),
    [anon_sym_COLON2] = ACTIONS(11864),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11866),
    [anon_sym_where] = ACTIONS(11864),
    [anon_sym_AT] = ACTIONS(11866),
    [anon_sym_true] = ACTIONS(11864),
    [anon_sym_false] = ACTIONS(11864),
    [aux_sym_integer_literal_token1] = ACTIONS(11866),
    [aux_sym_integer_literal_token2] = ACTIONS(11866),
    [aux_sym_integer_literal_token3] = ACTIONS(11864),
    [aux_sym_integer_literal_token4] = ACTIONS(11864),
    [aux_sym_float_literal_token1] = ACTIONS(11866),
    [aux_sym_float_literal_token3] = ACTIONS(11866),
    [aux_sym_float_literal_token4] = ACTIONS(11866),
    [sym_character_literal] = ACTIONS(11866),
    [anon_sym_DQUOTE] = ACTIONS(11864),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11866),
    [anon_sym_BQUOTE] = ACTIONS(11864),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11866),
    [sym__pair_operator] = ACTIONS(11866),
    [sym__arrow_operator] = ACTIONS(11864),
    [sym__lazy_or_operator] = ACTIONS(11866),
    [sym__lazy_and_operator] = ACTIONS(11866),
    [sym__comparison_operator] = ACTIONS(12842),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11866),
    [sym__type_order_operator] = ACTIONS(12870),
    [sym__unary_operator] = ACTIONS(11864),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9322] = {
    [sym_block_comment] = STATE(9322),
    [sym_line_comment] = STATE(9322),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12842),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12844),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(12846),
    [sym__arrow_operator] = ACTIONS(12848),
    [sym__lazy_or_operator] = ACTIONS(12850),
    [sym__lazy_and_operator] = ACTIONS(12852),
    [sym__comparison_operator] = ACTIONS(12842),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12870),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9323] = {
    [sym_block_comment] = STATE(9323),
    [sym_line_comment] = STATE(9323),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12842),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12844),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(12848),
    [sym__lazy_or_operator] = ACTIONS(12850),
    [sym__lazy_and_operator] = ACTIONS(12852),
    [sym__comparison_operator] = ACTIONS(12842),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12870),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9324] = {
    [sym_block_comment] = STATE(9324),
    [sym_line_comment] = STATE(9324),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12842),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12844),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(12852),
    [sym__comparison_operator] = ACTIONS(12842),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12870),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9325] = {
    [sym_block_comment] = STATE(9325),
    [sym_line_comment] = STATE(9325),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(12842),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12842),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(12844),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(12842),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(12870),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9326] = {
    [sym_block_comment] = STATE(9326),
    [sym_line_comment] = STATE(9326),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9327] = {
    [sym_block_comment] = STATE(9327),
    [sym_line_comment] = STATE(9327),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(12840),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(12854),
    [sym__pipe_left_operator] = ACTIONS(12856),
    [sym__ellipsis_operator] = ACTIONS(12858),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9328] = {
    [sym_block_comment] = STATE(9328),
    [sym_line_comment] = STATE(9328),
    [sym__word_identifier] = ACTIONS(11265),
    [anon_sym_COMMA] = ACTIONS(11267),
    [anon_sym_begin] = ACTIONS(11265),
    [anon_sym_module] = ACTIONS(11265),
    [anon_sym_baremodule] = ACTIONS(11265),
    [anon_sym_end] = ACTIONS(11265),
    [anon_sym_abstract] = ACTIONS(11265),
    [anon_sym_primitive] = ACTIONS(11265),
    [anon_sym_mutable] = ACTIONS(11265),
    [anon_sym_struct] = ACTIONS(11265),
    [anon_sym_function] = ACTIONS(11265),
    [anon_sym_macro] = ACTIONS(11265),
    [anon_sym_quote] = ACTIONS(11265),
    [anon_sym_let] = ACTIONS(11265),
    [anon_sym_if] = ACTIONS(11265),
    [anon_sym_try] = ACTIONS(11265),
    [anon_sym_for] = ACTIONS(11265),
    [anon_sym_while] = ACTIONS(11265),
    [sym_break_statement] = ACTIONS(11265),
    [sym_continue_statement] = ACTIONS(11265),
    [anon_sym_return] = ACTIONS(11265),
    [anon_sym_const] = ACTIONS(11265),
    [anon_sym_global] = ACTIONS(11265),
    [anon_sym_local] = ACTIONS(11265),
    [anon_sym_LPAREN] = ACTIONS(11267),
    [anon_sym_COLON] = ACTIONS(11265),
    [anon_sym_export] = ACTIONS(11265),
    [anon_sym_public] = ACTIONS(11265),
    [anon_sym_import] = ACTIONS(11265),
    [anon_sym_using] = ACTIONS(11265),
    [anon_sym_LBRACK] = ACTIONS(11267),
    [anon_sym_in] = ACTIONS(11265),
    [anon_sym_LBRACE] = ACTIONS(11267),
    [anon_sym_DOLLAR] = ACTIONS(11267),
    [anon_sym_COLON2] = ACTIONS(11265),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11265),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11267),
    [anon_sym_QMARK] = ACTIONS(11267),
    [anon_sym_where] = ACTIONS(11265),
    [anon_sym_AT] = ACTIONS(11267),
    [anon_sym_true] = ACTIONS(11265),
    [anon_sym_false] = ACTIONS(11265),
    [aux_sym_integer_literal_token1] = ACTIONS(11267),
    [aux_sym_integer_literal_token2] = ACTIONS(11267),
    [aux_sym_integer_literal_token3] = ACTIONS(11265),
    [aux_sym_integer_literal_token4] = ACTIONS(11265),
    [aux_sym_float_literal_token1] = ACTIONS(11267),
    [aux_sym_float_literal_token3] = ACTIONS(11267),
    [aux_sym_float_literal_token4] = ACTIONS(11267),
    [sym_character_literal] = ACTIONS(11267),
    [anon_sym_DQUOTE] = ACTIONS(11265),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11267),
    [anon_sym_BQUOTE] = ACTIONS(11265),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11267),
    [sym__pair_operator] = ACTIONS(11267),
    [sym__arrow_operator] = ACTIONS(11265),
    [sym__lazy_or_operator] = ACTIONS(11267),
    [sym__lazy_and_operator] = ACTIONS(11267),
    [sym__comparison_operator] = ACTIONS(11265),
    [sym__pipe_right_operator] = ACTIONS(11267),
    [sym__pipe_left_operator] = ACTIONS(11267),
    [sym__ellipsis_operator] = ACTIONS(11265),
    [sym__plus_operator] = ACTIONS(11265),
    [sym__times_operator] = ACTIONS(11265),
    [sym__rational_operator] = ACTIONS(11267),
    [sym__bitshift_operator] = ACTIONS(11267),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11267),
    [sym__type_order_operator] = ACTIONS(11267),
    [sym__unary_operator] = ACTIONS(11265),
    [sym__unary_plus_operator] = ACTIONS(11265),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9329] = {
    [sym_block_comment] = STATE(9329),
    [sym_line_comment] = STATE(9329),
    [sym__word_identifier] = ACTIONS(11275),
    [anon_sym_COMMA] = ACTIONS(11277),
    [anon_sym_begin] = ACTIONS(11275),
    [anon_sym_module] = ACTIONS(11275),
    [anon_sym_baremodule] = ACTIONS(11275),
    [anon_sym_end] = ACTIONS(11275),
    [anon_sym_abstract] = ACTIONS(11275),
    [anon_sym_primitive] = ACTIONS(11275),
    [anon_sym_mutable] = ACTIONS(11275),
    [anon_sym_struct] = ACTIONS(11275),
    [anon_sym_function] = ACTIONS(11275),
    [anon_sym_macro] = ACTIONS(11275),
    [anon_sym_quote] = ACTIONS(11275),
    [anon_sym_let] = ACTIONS(11275),
    [anon_sym_if] = ACTIONS(11275),
    [anon_sym_try] = ACTIONS(11275),
    [anon_sym_for] = ACTIONS(11275),
    [anon_sym_while] = ACTIONS(11275),
    [sym_break_statement] = ACTIONS(11275),
    [sym_continue_statement] = ACTIONS(11275),
    [anon_sym_return] = ACTIONS(11275),
    [anon_sym_const] = ACTIONS(11275),
    [anon_sym_global] = ACTIONS(11275),
    [anon_sym_local] = ACTIONS(11275),
    [anon_sym_LPAREN] = ACTIONS(11277),
    [anon_sym_COLON] = ACTIONS(11275),
    [anon_sym_export] = ACTIONS(11275),
    [anon_sym_public] = ACTIONS(11275),
    [anon_sym_import] = ACTIONS(11275),
    [anon_sym_using] = ACTIONS(11275),
    [anon_sym_LBRACK] = ACTIONS(11277),
    [anon_sym_in] = ACTIONS(11275),
    [anon_sym_LBRACE] = ACTIONS(11277),
    [anon_sym_DOLLAR] = ACTIONS(11277),
    [anon_sym_COLON2] = ACTIONS(11275),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11277),
    [anon_sym_QMARK] = ACTIONS(11277),
    [anon_sym_where] = ACTIONS(11275),
    [anon_sym_AT] = ACTIONS(11277),
    [anon_sym_true] = ACTIONS(11275),
    [anon_sym_false] = ACTIONS(11275),
    [aux_sym_integer_literal_token1] = ACTIONS(11277),
    [aux_sym_integer_literal_token2] = ACTIONS(11277),
    [aux_sym_integer_literal_token3] = ACTIONS(11275),
    [aux_sym_integer_literal_token4] = ACTIONS(11275),
    [aux_sym_float_literal_token1] = ACTIONS(11277),
    [aux_sym_float_literal_token3] = ACTIONS(11277),
    [aux_sym_float_literal_token4] = ACTIONS(11277),
    [sym_character_literal] = ACTIONS(11277),
    [anon_sym_DQUOTE] = ACTIONS(11275),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11277),
    [anon_sym_BQUOTE] = ACTIONS(11275),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11277),
    [sym__pair_operator] = ACTIONS(11277),
    [sym__arrow_operator] = ACTIONS(11275),
    [sym__lazy_or_operator] = ACTIONS(11277),
    [sym__lazy_and_operator] = ACTIONS(11277),
    [sym__comparison_operator] = ACTIONS(11275),
    [sym__pipe_right_operator] = ACTIONS(11277),
    [sym__pipe_left_operator] = ACTIONS(11277),
    [sym__ellipsis_operator] = ACTIONS(11275),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11277),
    [sym__type_order_operator] = ACTIONS(11277),
    [sym__unary_operator] = ACTIONS(11275),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9330] = {
    [sym_block_comment] = STATE(9330),
    [sym_line_comment] = STATE(9330),
    [sym__word_identifier] = ACTIONS(11247),
    [anon_sym_COMMA] = ACTIONS(11249),
    [anon_sym_begin] = ACTIONS(11247),
    [anon_sym_module] = ACTIONS(11247),
    [anon_sym_baremodule] = ACTIONS(11247),
    [anon_sym_end] = ACTIONS(11247),
    [anon_sym_abstract] = ACTIONS(11247),
    [anon_sym_primitive] = ACTIONS(11247),
    [anon_sym_mutable] = ACTIONS(11247),
    [anon_sym_struct] = ACTIONS(11247),
    [anon_sym_function] = ACTIONS(11247),
    [anon_sym_macro] = ACTIONS(11247),
    [anon_sym_quote] = ACTIONS(11247),
    [anon_sym_let] = ACTIONS(11247),
    [anon_sym_if] = ACTIONS(11247),
    [anon_sym_try] = ACTIONS(11247),
    [anon_sym_for] = ACTIONS(11247),
    [anon_sym_while] = ACTIONS(11247),
    [sym_break_statement] = ACTIONS(11247),
    [sym_continue_statement] = ACTIONS(11247),
    [anon_sym_return] = ACTIONS(11247),
    [anon_sym_const] = ACTIONS(11247),
    [anon_sym_global] = ACTIONS(11247),
    [anon_sym_local] = ACTIONS(11247),
    [anon_sym_LPAREN] = ACTIONS(11249),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11247),
    [anon_sym_public] = ACTIONS(11247),
    [anon_sym_import] = ACTIONS(11247),
    [anon_sym_using] = ACTIONS(11247),
    [anon_sym_LBRACK] = ACTIONS(11249),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11249),
    [anon_sym_DOLLAR] = ACTIONS(11249),
    [anon_sym_COLON2] = ACTIONS(11247),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11249),
    [anon_sym_true] = ACTIONS(11247),
    [anon_sym_false] = ACTIONS(11247),
    [aux_sym_integer_literal_token1] = ACTIONS(11249),
    [aux_sym_integer_literal_token2] = ACTIONS(11249),
    [aux_sym_integer_literal_token3] = ACTIONS(11247),
    [aux_sym_integer_literal_token4] = ACTIONS(11247),
    [aux_sym_float_literal_token1] = ACTIONS(11249),
    [aux_sym_float_literal_token3] = ACTIONS(11249),
    [aux_sym_float_literal_token4] = ACTIONS(11249),
    [sym_character_literal] = ACTIONS(11249),
    [anon_sym_DQUOTE] = ACTIONS(11247),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11249),
    [anon_sym_BQUOTE] = ACTIONS(11247),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11249),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11249),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11247),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9331] = {
    [sym_block_comment] = STATE(9331),
    [sym_line_comment] = STATE(9331),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9332] = {
    [sym_block_comment] = STATE(9332),
    [sym_line_comment] = STATE(9332),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(12860),
    [sym__times_operator] = ACTIONS(12862),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(12860),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9333] = {
    [sym_block_comment] = STATE(9333),
    [sym_line_comment] = STATE(9333),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11289),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_end] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11289),
    [anon_sym_COLON] = ACTIONS(12704),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11289),
    [anon_sym_in] = ACTIONS(12706),
    [anon_sym_LBRACE] = ACTIONS(11289),
    [anon_sym_DOLLAR] = ACTIONS(11289),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(12706),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12710),
    [anon_sym_QMARK] = ACTIONS(12748),
    [anon_sym_where] = ACTIONS(12714),
    [anon_sym_AT] = ACTIONS(11289),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11289),
    [aux_sym_integer_literal_token2] = ACTIONS(11289),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11289),
    [aux_sym_float_literal_token3] = ACTIONS(11289),
    [aux_sym_float_literal_token4] = ACTIONS(11289),
    [sym_character_literal] = ACTIONS(11289),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11289),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11289),
    [sym__pair_operator] = ACTIONS(12716),
    [sym__arrow_operator] = ACTIONS(12718),
    [sym__lazy_or_operator] = ACTIONS(12720),
    [sym__lazy_and_operator] = ACTIONS(12722),
    [sym__comparison_operator] = ACTIONS(12706),
    [sym__pipe_right_operator] = ACTIONS(12724),
    [sym__pipe_left_operator] = ACTIONS(12726),
    [sym__ellipsis_operator] = ACTIONS(12728),
    [sym__plus_operator] = ACTIONS(12730),
    [sym__times_operator] = ACTIONS(12732),
    [sym__rational_operator] = ACTIONS(12734),
    [sym__bitshift_operator] = ACTIONS(12736),
    [sym__power_operator] = ACTIONS(12738),
    [sym__tilde_operator] = ACTIONS(11289),
    [sym__type_order_operator] = ACTIONS(12740),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(12730),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9334] = {
    [sym_block_comment] = STATE(9334),
    [sym_line_comment] = STATE(9334),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(12864),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9335] = {
    [sym_block_comment] = STATE(9335),
    [sym_line_comment] = STATE(9335),
    [sym__word_identifier] = ACTIONS(11108),
    [anon_sym_COMMA] = ACTIONS(11110),
    [anon_sym_begin] = ACTIONS(11108),
    [anon_sym_module] = ACTIONS(11108),
    [anon_sym_baremodule] = ACTIONS(11108),
    [anon_sym_end] = ACTIONS(11108),
    [anon_sym_abstract] = ACTIONS(11108),
    [anon_sym_primitive] = ACTIONS(11108),
    [anon_sym_mutable] = ACTIONS(11108),
    [anon_sym_struct] = ACTIONS(11108),
    [anon_sym_function] = ACTIONS(11108),
    [anon_sym_macro] = ACTIONS(11108),
    [anon_sym_quote] = ACTIONS(11108),
    [anon_sym_let] = ACTIONS(11108),
    [anon_sym_if] = ACTIONS(11108),
    [anon_sym_try] = ACTIONS(11108),
    [anon_sym_for] = ACTIONS(11108),
    [anon_sym_while] = ACTIONS(11108),
    [sym_break_statement] = ACTIONS(11108),
    [sym_continue_statement] = ACTIONS(11108),
    [anon_sym_return] = ACTIONS(11108),
    [anon_sym_const] = ACTIONS(11108),
    [anon_sym_global] = ACTIONS(11108),
    [anon_sym_local] = ACTIONS(11108),
    [anon_sym_LPAREN] = ACTIONS(11110),
    [anon_sym_COLON] = ACTIONS(11108),
    [anon_sym_export] = ACTIONS(11108),
    [anon_sym_public] = ACTIONS(11108),
    [anon_sym_import] = ACTIONS(11108),
    [anon_sym_using] = ACTIONS(11108),
    [anon_sym_LBRACK] = ACTIONS(11110),
    [anon_sym_in] = ACTIONS(11108),
    [anon_sym_LBRACE] = ACTIONS(11110),
    [anon_sym_DOLLAR] = ACTIONS(11110),
    [anon_sym_COLON2] = ACTIONS(11108),
    [anon_sym_COLON_COLON] = ACTIONS(12708),
    [anon_sym_isa] = ACTIONS(11108),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11110),
    [anon_sym_QMARK] = ACTIONS(11110),
    [anon_sym_where] = ACTIONS(11108),
    [anon_sym_AT] = ACTIONS(11110),
    [anon_sym_true] = ACTIONS(11108),
    [anon_sym_false] = ACTIONS(11108),
    [aux_sym_integer_literal_token1] = ACTIONS(11110),
    [aux_sym_integer_literal_token2] = ACTIONS(11110),
    [aux_sym_integer_literal_token3] = ACTIONS(11108),
    [aux_sym_integer_literal_token4] = ACTIONS(11108),
    [aux_sym_float_literal_token1] = ACTIONS(11110),
    [aux_sym_float_literal_token3] = ACTIONS(11110),
    [aux_sym_float_literal_token4] = ACTIONS(11110),
    [sym_character_literal] = ACTIONS(11110),
    [anon_sym_DQUOTE] = ACTIONS(11108),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11110),
    [anon_sym_BQUOTE] = ACTIONS(11108),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11110),
    [sym__pair_operator] = ACTIONS(11110),
    [sym__arrow_operator] = ACTIONS(11108),
    [sym__lazy_or_operator] = ACTIONS(11110),
    [sym__lazy_and_operator] = ACTIONS(11110),
    [sym__comparison_operator] = ACTIONS(11108),
    [sym__pipe_right_operator] = ACTIONS(11110),
    [sym__pipe_left_operator] = ACTIONS(11110),
    [sym__ellipsis_operator] = ACTIONS(11108),
    [sym__plus_operator] = ACTIONS(11108),
    [sym__times_operator] = ACTIONS(11108),
    [sym__rational_operator] = ACTIONS(11110),
    [sym__bitshift_operator] = ACTIONS(12866),
    [sym__power_operator] = ACTIONS(12868),
    [sym__tilde_operator] = ACTIONS(11110),
    [sym__type_order_operator] = ACTIONS(11110),
    [sym__unary_operator] = ACTIONS(11108),
    [sym__unary_plus_operator] = ACTIONS(11108),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9336] = {
    [sym_identifier] = STATE(10044),
    [sym_integer_literal] = STATE(10283),
    [sym_float_literal] = STATE(10283),
    [sym__string] = STATE(10283),
    [sym__delimiter_str_1] = STATE(14632),
    [sym__delimiter_str_3] = STATE(14633),
    [sym__delimiter_cmd_1] = STATE(14641),
    [sym__delimiter_cmd_3] = STATE(14642),
    [sym_string_literal] = STATE(10364),
    [sym_command_literal] = STATE(10364),
    [sym_prefixed_string_literal] = STATE(10364),
    [sym_prefixed_command_literal] = STATE(10364),
    [sym_operator] = STATE(10283),
    [sym__assignment_operator] = STATE(10283),
    [sym__syntactic_operator] = STATE(10283),
    [sym_block_comment] = STATE(9336),
    [sym_line_comment] = STATE(9336),
    [sym__word_identifier] = ACTIONS(12872),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12874),
    [anon_sym_COLON2] = ACTIONS(12876),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(12878),
    [anon_sym_DOT_EQ] = ACTIONS(12878),
    [aux_sym_quote_expression_token1] = ACTIONS(12880),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12874),
    [anon_sym_QMARK] = ACTIONS(12874),
    [anon_sym_DASH_GT] = ACTIONS(12874),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12882),
    [aux_sym_integer_literal_token2] = ACTIONS(12882),
    [aux_sym_integer_literal_token3] = ACTIONS(12882),
    [aux_sym_integer_literal_token4] = ACTIONS(12884),
    [aux_sym_float_literal_token1] = ACTIONS(12886),
    [aux_sym_float_literal_token3] = ACTIONS(12886),
    [aux_sym_float_literal_token4] = ACTIONS(12886),
    [sym_character_literal] = ACTIONS(175),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12878),
    [aux_sym__assignment_operator_token1] = ACTIONS(12878),
    [sym__pair_operator] = ACTIONS(12876),
    [sym__arrow_operator] = ACTIONS(12876),
    [sym__lazy_or_operator] = ACTIONS(12880),
    [sym__lazy_and_operator] = ACTIONS(12880),
    [sym__comparison_operator] = ACTIONS(12876),
    [sym__pipe_right_operator] = ACTIONS(12876),
    [sym__pipe_left_operator] = ACTIONS(12876),
    [sym__ellipsis_operator] = ACTIONS(12876),
    [sym__plus_operator] = ACTIONS(12876),
    [sym__times_operator] = ACTIONS(12876),
    [sym__rational_operator] = ACTIONS(12876),
    [sym__bitshift_operator] = ACTIONS(12876),
    [sym__power_operator] = ACTIONS(12876),
    [sym__tilde_operator] = ACTIONS(12876),
    [sym__type_order_operator] = ACTIONS(12876),
    [sym__unary_operator] = ACTIONS(12876),
    [sym__unary_plus_operator] = ACTIONS(12876),
    [anon_sym_DOT2] = ACTIONS(12874),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12888),
    [sym__immediate_bracket] = ACTIONS(12890),
    [sym__immediate_brace] = ACTIONS(12892),
  },
  [9337] = {
    [sym_identifier] = STATE(10076),
    [sym_integer_literal] = STATE(9803),
    [sym_float_literal] = STATE(9803),
    [sym__string] = STATE(9803),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(9803),
    [sym__assignment_operator] = STATE(9803),
    [sym__syntactic_operator] = STATE(9803),
    [sym_block_comment] = STATE(9337),
    [sym_line_comment] = STATE(9337),
    [sym__word_identifier] = ACTIONS(12894),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(12896),
    [anon_sym_COLON2] = ACTIONS(12898),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(12900),
    [anon_sym_DOT_EQ] = ACTIONS(12902),
    [aux_sym_quote_expression_token1] = ACTIONS(12904),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12906),
    [anon_sym_QMARK] = ACTIONS(12906),
    [anon_sym_DASH_GT] = ACTIONS(12906),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12908),
    [aux_sym_integer_literal_token2] = ACTIONS(12908),
    [aux_sym_integer_literal_token3] = ACTIONS(12910),
    [aux_sym_integer_literal_token4] = ACTIONS(12912),
    [aux_sym_float_literal_token1] = ACTIONS(12914),
    [aux_sym_float_literal_token3] = ACTIONS(12914),
    [aux_sym_float_literal_token4] = ACTIONS(12914),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12900),
    [aux_sym__assignment_operator_token1] = ACTIONS(12900),
    [sym__pair_operator] = ACTIONS(12916),
    [sym__arrow_operator] = ACTIONS(12898),
    [sym__lazy_or_operator] = ACTIONS(12918),
    [sym__lazy_and_operator] = ACTIONS(12918),
    [sym__comparison_operator] = ACTIONS(12898),
    [sym__pipe_right_operator] = ACTIONS(12916),
    [sym__pipe_left_operator] = ACTIONS(12916),
    [sym__ellipsis_operator] = ACTIONS(12898),
    [sym__plus_operator] = ACTIONS(12898),
    [sym__times_operator] = ACTIONS(12898),
    [sym__rational_operator] = ACTIONS(12898),
    [sym__bitshift_operator] = ACTIONS(12898),
    [sym__power_operator] = ACTIONS(12898),
    [sym__tilde_operator] = ACTIONS(12916),
    [sym__type_order_operator] = ACTIONS(12916),
    [sym__unary_operator] = ACTIONS(12898),
    [sym__unary_plus_operator] = ACTIONS(12898),
    [anon_sym_DOT2] = ACTIONS(12896),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12920),
    [sym__immediate_bracket] = ACTIONS(12922),
    [sym__immediate_brace] = ACTIONS(12924),
  },
  [9338] = {
    [sym_identifier] = STATE(10075),
    [sym_integer_literal] = STATE(9979),
    [sym_float_literal] = STATE(9979),
    [sym__string] = STATE(9979),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(9979),
    [sym__assignment_operator] = STATE(9979),
    [sym__syntactic_operator] = STATE(9979),
    [sym_block_comment] = STATE(9338),
    [sym_line_comment] = STATE(9338),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_elseif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12928),
    [anon_sym_COLON2] = ACTIONS(12930),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(12932),
    [anon_sym_DOT_EQ] = ACTIONS(12932),
    [aux_sym_quote_expression_token1] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12928),
    [anon_sym_QMARK] = ACTIONS(12928),
    [anon_sym_DASH_GT] = ACTIONS(12928),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12936),
    [aux_sym_integer_literal_token2] = ACTIONS(12936),
    [aux_sym_integer_literal_token3] = ACTIONS(12936),
    [aux_sym_integer_literal_token4] = ACTIONS(12938),
    [aux_sym_float_literal_token1] = ACTIONS(12940),
    [aux_sym_float_literal_token3] = ACTIONS(12940),
    [aux_sym_float_literal_token4] = ACTIONS(12940),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12932),
    [aux_sym__assignment_operator_token1] = ACTIONS(12932),
    [sym__pair_operator] = ACTIONS(12930),
    [sym__arrow_operator] = ACTIONS(12930),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12930),
    [sym__pipe_right_operator] = ACTIONS(12930),
    [sym__pipe_left_operator] = ACTIONS(12930),
    [sym__ellipsis_operator] = ACTIONS(12930),
    [sym__plus_operator] = ACTIONS(12930),
    [sym__times_operator] = ACTIONS(12930),
    [sym__rational_operator] = ACTIONS(12930),
    [sym__bitshift_operator] = ACTIONS(12930),
    [sym__power_operator] = ACTIONS(12930),
    [sym__tilde_operator] = ACTIONS(12930),
    [sym__type_order_operator] = ACTIONS(12930),
    [sym__unary_operator] = ACTIONS(12930),
    [sym__unary_plus_operator] = ACTIONS(12930),
    [anon_sym_DOT2] = ACTIONS(12928),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12942),
    [sym__immediate_bracket] = ACTIONS(12944),
    [sym__immediate_brace] = ACTIONS(12946),
  },
  [9339] = {
    [sym__primary_expression] = STATE(11841),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(11497),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(9339),
    [sym_line_comment] = STATE(9339),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_end] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_DOLLAR] = ACTIONS(12948),
    [anon_sym_COLON2] = ACTIONS(10689),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(9343),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9343),
    [sym__pipe_left_operator] = ACTIONS(9343),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9343),
    [sym__bitshift_operator] = ACTIONS(9343),
    [sym__power_operator] = ACTIONS(9343),
    [sym__tilde_operator] = ACTIONS(1823),
    [sym__type_order_operator] = ACTIONS(9343),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9340] = {
    [sym_identifier] = STATE(9836),
    [sym_integer_literal] = STATE(9803),
    [sym_float_literal] = STATE(9803),
    [sym__string] = STATE(9803),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(9803),
    [sym__assignment_operator] = STATE(9803),
    [sym__syntactic_operator] = STATE(9803),
    [sym_block_comment] = STATE(9340),
    [sym_line_comment] = STATE(9340),
    [sym__word_identifier] = ACTIONS(12894),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(12896),
    [anon_sym_COLON2] = ACTIONS(12898),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(12900),
    [anon_sym_DOT_EQ] = ACTIONS(12902),
    [aux_sym_quote_expression_token1] = ACTIONS(12904),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12906),
    [anon_sym_QMARK] = ACTIONS(12906),
    [anon_sym_DASH_GT] = ACTIONS(12906),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12908),
    [aux_sym_integer_literal_token2] = ACTIONS(12908),
    [aux_sym_integer_literal_token3] = ACTIONS(12910),
    [aux_sym_integer_literal_token4] = ACTIONS(12912),
    [aux_sym_float_literal_token1] = ACTIONS(12914),
    [aux_sym_float_literal_token3] = ACTIONS(12914),
    [aux_sym_float_literal_token4] = ACTIONS(12914),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12900),
    [aux_sym__assignment_operator_token1] = ACTIONS(12900),
    [sym__pair_operator] = ACTIONS(12916),
    [sym__arrow_operator] = ACTIONS(12898),
    [sym__lazy_or_operator] = ACTIONS(12918),
    [sym__lazy_and_operator] = ACTIONS(12918),
    [sym__comparison_operator] = ACTIONS(12898),
    [sym__pipe_right_operator] = ACTIONS(12916),
    [sym__pipe_left_operator] = ACTIONS(12916),
    [sym__ellipsis_operator] = ACTIONS(12898),
    [sym__plus_operator] = ACTIONS(12898),
    [sym__times_operator] = ACTIONS(12898),
    [sym__rational_operator] = ACTIONS(12898),
    [sym__bitshift_operator] = ACTIONS(12898),
    [sym__power_operator] = ACTIONS(12898),
    [sym__tilde_operator] = ACTIONS(12916),
    [sym__type_order_operator] = ACTIONS(12916),
    [sym__unary_operator] = ACTIONS(12898),
    [sym__unary_plus_operator] = ACTIONS(12898),
    [anon_sym_DOT2] = ACTIONS(12896),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12920),
    [sym__immediate_bracket] = ACTIONS(12922),
    [sym__immediate_brace] = ACTIONS(12924),
  },
  [9341] = {
    [sym_identifier] = STATE(10209),
    [sym_integer_literal] = STATE(9979),
    [sym_float_literal] = STATE(9979),
    [sym__string] = STATE(9979),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(9979),
    [sym__assignment_operator] = STATE(9979),
    [sym__syntactic_operator] = STATE(9979),
    [sym_block_comment] = STATE(9341),
    [sym_line_comment] = STATE(9341),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12928),
    [anon_sym_COLON2] = ACTIONS(12930),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(12932),
    [anon_sym_DOT_EQ] = ACTIONS(12932),
    [aux_sym_quote_expression_token1] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12928),
    [anon_sym_QMARK] = ACTIONS(12928),
    [anon_sym_DASH_GT] = ACTIONS(12928),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12936),
    [aux_sym_integer_literal_token2] = ACTIONS(12936),
    [aux_sym_integer_literal_token3] = ACTIONS(12936),
    [aux_sym_integer_literal_token4] = ACTIONS(12938),
    [aux_sym_float_literal_token1] = ACTIONS(12940),
    [aux_sym_float_literal_token3] = ACTIONS(12940),
    [aux_sym_float_literal_token4] = ACTIONS(12940),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12932),
    [aux_sym__assignment_operator_token1] = ACTIONS(12932),
    [sym__pair_operator] = ACTIONS(12930),
    [sym__arrow_operator] = ACTIONS(12930),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12930),
    [sym__pipe_right_operator] = ACTIONS(12930),
    [sym__pipe_left_operator] = ACTIONS(12930),
    [sym__ellipsis_operator] = ACTIONS(12930),
    [sym__plus_operator] = ACTIONS(12930),
    [sym__times_operator] = ACTIONS(12930),
    [sym__rational_operator] = ACTIONS(12930),
    [sym__bitshift_operator] = ACTIONS(12930),
    [sym__power_operator] = ACTIONS(12930),
    [sym__tilde_operator] = ACTIONS(12930),
    [sym__type_order_operator] = ACTIONS(12930),
    [sym__unary_operator] = ACTIONS(12930),
    [sym__unary_plus_operator] = ACTIONS(12930),
    [anon_sym_DOT2] = ACTIONS(12928),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12942),
    [sym__immediate_bracket] = ACTIONS(12944),
    [sym__immediate_brace] = ACTIONS(12946),
  },
  [9342] = {
    [sym_identifier] = STATE(10184),
    [sym_integer_literal] = STATE(9979),
    [sym_float_literal] = STATE(9979),
    [sym__string] = STATE(9979),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(9979),
    [sym__assignment_operator] = STATE(9979),
    [sym__syntactic_operator] = STATE(9979),
    [sym_block_comment] = STATE(9342),
    [sym_line_comment] = STATE(9342),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_finally] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12928),
    [anon_sym_COLON2] = ACTIONS(12930),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(12932),
    [anon_sym_DOT_EQ] = ACTIONS(12932),
    [aux_sym_quote_expression_token1] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12928),
    [anon_sym_QMARK] = ACTIONS(12928),
    [anon_sym_DASH_GT] = ACTIONS(12928),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12936),
    [aux_sym_integer_literal_token2] = ACTIONS(12936),
    [aux_sym_integer_literal_token3] = ACTIONS(12936),
    [aux_sym_integer_literal_token4] = ACTIONS(12938),
    [aux_sym_float_literal_token1] = ACTIONS(12940),
    [aux_sym_float_literal_token3] = ACTIONS(12940),
    [aux_sym_float_literal_token4] = ACTIONS(12940),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12932),
    [aux_sym__assignment_operator_token1] = ACTIONS(12932),
    [sym__pair_operator] = ACTIONS(12930),
    [sym__arrow_operator] = ACTIONS(12930),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12930),
    [sym__pipe_right_operator] = ACTIONS(12930),
    [sym__pipe_left_operator] = ACTIONS(12930),
    [sym__ellipsis_operator] = ACTIONS(12930),
    [sym__plus_operator] = ACTIONS(12930),
    [sym__times_operator] = ACTIONS(12930),
    [sym__rational_operator] = ACTIONS(12930),
    [sym__bitshift_operator] = ACTIONS(12930),
    [sym__power_operator] = ACTIONS(12930),
    [sym__tilde_operator] = ACTIONS(12930),
    [sym__type_order_operator] = ACTIONS(12930),
    [sym__unary_operator] = ACTIONS(12930),
    [sym__unary_plus_operator] = ACTIONS(12930),
    [anon_sym_DOT2] = ACTIONS(12928),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12942),
    [sym__immediate_bracket] = ACTIONS(12944),
    [sym__immediate_brace] = ACTIONS(12946),
  },
  [9343] = {
    [sym_identifier] = STATE(10206),
    [sym_integer_literal] = STATE(9979),
    [sym_float_literal] = STATE(9979),
    [sym__string] = STATE(9979),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(9979),
    [sym__assignment_operator] = STATE(9979),
    [sym__syntactic_operator] = STATE(9979),
    [sym_block_comment] = STATE(9343),
    [sym_line_comment] = STATE(9343),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_catch] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12928),
    [anon_sym_COLON2] = ACTIONS(12930),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(12932),
    [anon_sym_DOT_EQ] = ACTIONS(12932),
    [aux_sym_quote_expression_token1] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12928),
    [anon_sym_QMARK] = ACTIONS(12928),
    [anon_sym_DASH_GT] = ACTIONS(12928),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12936),
    [aux_sym_integer_literal_token2] = ACTIONS(12936),
    [aux_sym_integer_literal_token3] = ACTIONS(12936),
    [aux_sym_integer_literal_token4] = ACTIONS(12938),
    [aux_sym_float_literal_token1] = ACTIONS(12940),
    [aux_sym_float_literal_token3] = ACTIONS(12940),
    [aux_sym_float_literal_token4] = ACTIONS(12940),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12932),
    [aux_sym__assignment_operator_token1] = ACTIONS(12932),
    [sym__pair_operator] = ACTIONS(12930),
    [sym__arrow_operator] = ACTIONS(12930),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12930),
    [sym__pipe_right_operator] = ACTIONS(12930),
    [sym__pipe_left_operator] = ACTIONS(12930),
    [sym__ellipsis_operator] = ACTIONS(12930),
    [sym__plus_operator] = ACTIONS(12930),
    [sym__times_operator] = ACTIONS(12930),
    [sym__rational_operator] = ACTIONS(12930),
    [sym__bitshift_operator] = ACTIONS(12930),
    [sym__power_operator] = ACTIONS(12930),
    [sym__tilde_operator] = ACTIONS(12930),
    [sym__type_order_operator] = ACTIONS(12930),
    [sym__unary_operator] = ACTIONS(12930),
    [sym__unary_plus_operator] = ACTIONS(12930),
    [anon_sym_DOT2] = ACTIONS(12928),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12942),
    [sym__immediate_bracket] = ACTIONS(12944),
    [sym__immediate_brace] = ACTIONS(12946),
  },
  [9344] = {
    [sym__primary_expression] = STATE(10491),
    [sym__array] = STATE(10053),
    [sym_comprehension_expression] = STATE(10083),
    [sym_matrix_expression] = STATE(10083),
    [sym_vector_expression] = STATE(10083),
    [sym_parenthesized_expression] = STATE(10053),
    [sym_tuple_expression] = STATE(10053),
    [sym_curly_expression] = STATE(10053),
    [sym_adjoint_expression] = STATE(10053),
    [sym_field_expression] = STATE(10053),
    [sym_index_expression] = STATE(10053),
    [sym_parametrized_type_expression] = STATE(10053),
    [sym_call_expression] = STATE(10053),
    [sym_broadcast_call_expression] = STATE(10053),
    [sym__closed_macrocall_expression] = STATE(10053),
    [sym_interpolation_expression] = STATE(10053),
    [sym_quote_expression] = STATE(10053),
    [sym_macro_identifier] = STATE(17364),
    [sym_identifier] = STATE(10165),
    [sym_boolean_literal] = STATE(10053),
    [sym__string] = STATE(10053),
    [sym__delimiter_str_1] = STATE(15005),
    [sym__delimiter_str_3] = STATE(15006),
    [sym__delimiter_cmd_1] = STATE(15007),
    [sym__delimiter_cmd_3] = STATE(15008),
    [sym_string_literal] = STATE(10125),
    [sym_command_literal] = STATE(10125),
    [sym_prefixed_string_literal] = STATE(10125),
    [sym_prefixed_command_literal] = STATE(10125),
    [sym_operator] = STATE(18422),
    [sym_block_comment] = STATE(9344),
    [sym_line_comment] = STATE(9344),
    [sym__word_identifier] = ACTIONS(9880),
    [anon_sym_COMMA] = ACTIONS(9212),
    [anon_sym_EQ] = ACTIONS(9171),
    [anon_sym_LPAREN] = ACTIONS(9882),
    [anon_sym_COLON] = ACTIONS(9171),
    [anon_sym_LBRACK] = ACTIONS(9884),
    [anon_sym_in] = ACTIONS(9171),
    [anon_sym_LBRACE] = ACTIONS(9886),
    [anon_sym_DOLLAR] = ACTIONS(11031),
    [anon_sym_COLON2] = ACTIONS(12950),
    [anon_sym_COLON_COLON] = ACTIONS(9212),
    [anon_sym_isa] = ACTIONS(9171),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9212),
    [anon_sym_QMARK] = ACTIONS(9212),
    [anon_sym_where] = ACTIONS(9171),
    [anon_sym_AT] = ACTIONS(9892),
    [anon_sym_true] = ACTIONS(9894),
    [anon_sym_false] = ACTIONS(9894),
    [sym_character_literal] = ACTIONS(9896),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [sym__pair_operator] = ACTIONS(9343),
    [sym__arrow_operator] = ACTIONS(9209),
    [sym__lazy_or_operator] = ACTIONS(9212),
    [sym__lazy_and_operator] = ACTIONS(9212),
    [sym__comparison_operator] = ACTIONS(9209),
    [sym__pipe_right_operator] = ACTIONS(9343),
    [sym__pipe_left_operator] = ACTIONS(9343),
    [sym__ellipsis_operator] = ACTIONS(9209),
    [sym__plus_operator] = ACTIONS(9209),
    [sym__times_operator] = ACTIONS(9209),
    [sym__rational_operator] = ACTIONS(9343),
    [sym__bitshift_operator] = ACTIONS(9343),
    [sym__power_operator] = ACTIONS(9343),
    [sym__tilde_operator] = ACTIONS(1823),
    [sym__type_order_operator] = ACTIONS(9343),
    [sym__unary_operator] = ACTIONS(1825),
    [sym__unary_plus_operator] = ACTIONS(9209),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9345] = {
    [sym_identifier] = STATE(10284),
    [sym_integer_literal] = STATE(9979),
    [sym_float_literal] = STATE(9979),
    [sym__string] = STATE(9979),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(9979),
    [sym__assignment_operator] = STATE(9979),
    [sym__syntactic_operator] = STATE(9979),
    [sym_block_comment] = STATE(9345),
    [sym_line_comment] = STATE(9345),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12928),
    [anon_sym_COLON2] = ACTIONS(12930),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(12932),
    [anon_sym_DOT_EQ] = ACTIONS(12932),
    [aux_sym_quote_expression_token1] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12928),
    [anon_sym_QMARK] = ACTIONS(12928),
    [anon_sym_DASH_GT] = ACTIONS(12928),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12936),
    [aux_sym_integer_literal_token2] = ACTIONS(12936),
    [aux_sym_integer_literal_token3] = ACTIONS(12936),
    [aux_sym_integer_literal_token4] = ACTIONS(12938),
    [aux_sym_float_literal_token1] = ACTIONS(12940),
    [aux_sym_float_literal_token3] = ACTIONS(12940),
    [aux_sym_float_literal_token4] = ACTIONS(12940),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12932),
    [aux_sym__assignment_operator_token1] = ACTIONS(12932),
    [sym__pair_operator] = ACTIONS(12930),
    [sym__arrow_operator] = ACTIONS(12930),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12930),
    [sym__pipe_right_operator] = ACTIONS(12930),
    [sym__pipe_left_operator] = ACTIONS(12930),
    [sym__ellipsis_operator] = ACTIONS(12930),
    [sym__plus_operator] = ACTIONS(12930),
    [sym__times_operator] = ACTIONS(12930),
    [sym__rational_operator] = ACTIONS(12930),
    [sym__bitshift_operator] = ACTIONS(12930),
    [sym__power_operator] = ACTIONS(12930),
    [sym__tilde_operator] = ACTIONS(12930),
    [sym__type_order_operator] = ACTIONS(12930),
    [sym__unary_operator] = ACTIONS(12930),
    [sym__unary_plus_operator] = ACTIONS(12930),
    [anon_sym_DOT2] = ACTIONS(12928),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12942),
    [sym__immediate_bracket] = ACTIONS(12944),
    [sym__immediate_brace] = ACTIONS(12946),
  },
  [9346] = {
    [sym__comprehension_clause] = STATE(18763),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9346),
    [sym_line_comment] = STATE(9346),
    [aux_sym_vector_expression_repeat1] = STATE(17136),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11868),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11870),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11872),
    [aux_sym__terminator_token2] = ACTIONS(11875),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9347] = {
    [sym__comprehension_clause] = STATE(19458),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9347),
    [sym_line_comment] = STATE(9347),
    [aux_sym_vector_expression_repeat1] = STATE(17239),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11295),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11297),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11299),
    [aux_sym__terminator_token2] = ACTIONS(11302),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9348] = {
    [sym__comprehension_clause] = STATE(18463),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9348),
    [sym_line_comment] = STATE(9348),
    [aux_sym_vector_expression_repeat1] = STATE(17145),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12102),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12104),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12106),
    [aux_sym__terminator_token2] = ACTIONS(12109),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9349] = {
    [sym__comprehension_clause] = STATE(19392),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9349),
    [sym_line_comment] = STATE(9349),
    [aux_sym_vector_expression_repeat1] = STATE(17566),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11806),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11808),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11810),
    [aux_sym__terminator_token2] = ACTIONS(11813),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9350] = {
    [sym__comprehension_clause] = STATE(19206),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9350),
    [sym_line_comment] = STATE(9350),
    [aux_sym_vector_expression_repeat1] = STATE(17477),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11762),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11764),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11766),
    [aux_sym__terminator_token2] = ACTIONS(11769),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9351] = {
    [sym__comprehension_clause] = STATE(18990),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9351),
    [sym_line_comment] = STATE(9351),
    [aux_sym_vector_expression_repeat1] = STATE(17378),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11608),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11610),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11612),
    [aux_sym__terminator_token2] = ACTIONS(11615),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9352] = {
    [sym__comprehension_clause] = STATE(19449),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9352),
    [sym_line_comment] = STATE(9352),
    [aux_sym_vector_expression_repeat1] = STATE(17463),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11124),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11126),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11128),
    [aux_sym__terminator_token2] = ACTIONS(11131),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9353] = {
    [sym__comprehension_clause] = STATE(19514),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9353),
    [sym_line_comment] = STATE(9353),
    [aux_sym_vector_expression_repeat1] = STATE(17636),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11704),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11706),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11708),
    [aux_sym__terminator_token2] = ACTIONS(11711),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9354] = {
    [sym__comprehension_clause] = STATE(18414),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9354),
    [sym_line_comment] = STATE(9354),
    [aux_sym_vector_expression_repeat1] = STATE(17226),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11363),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11365),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11367),
    [aux_sym__terminator_token2] = ACTIONS(11370),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9355] = {
    [sym__comprehension_clause] = STATE(18415),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9355),
    [sym_line_comment] = STATE(9355),
    [aux_sym_vector_expression_repeat1] = STATE(17220),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11880),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11882),
    [aux_sym__terminator_token2] = ACTIONS(11885),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9356] = {
    [sym__comprehension_clause] = STATE(18266),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9356),
    [sym_line_comment] = STATE(9356),
    [aux_sym_vector_expression_repeat1] = STATE(17189),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11826),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11828),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11830),
    [aux_sym__terminator_token2] = ACTIONS(11833),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9357] = {
    [sym__comprehension_clause] = STATE(19271),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9357),
    [sym_line_comment] = STATE(9357),
    [aux_sym_vector_expression_repeat1] = STATE(17503),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11187),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11189),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11191),
    [aux_sym__terminator_token2] = ACTIONS(11194),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9358] = {
    [sym__comprehension_clause] = STATE(18622),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9358),
    [sym_line_comment] = STATE(9358),
    [aux_sym_vector_expression_repeat1] = STATE(17598),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11902),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11904),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11906),
    [aux_sym__terminator_token2] = ACTIONS(11909),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9359] = {
    [sym__comprehension_clause] = STATE(18402),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9359),
    [sym_line_comment] = STATE(9359),
    [aux_sym_vector_expression_repeat1] = STATE(17338),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12122),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12124),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12126),
    [aux_sym__terminator_token2] = ACTIONS(12129),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9360] = {
    [sym__comprehension_clause] = STATE(18980),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9360),
    [sym_line_comment] = STATE(9360),
    [aux_sym_vector_expression_repeat1] = STATE(17402),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11462),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11464),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11466),
    [aux_sym__terminator_token2] = ACTIONS(11469),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9361] = {
    [sym__comprehension_clause] = STATE(19216),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9361),
    [sym_line_comment] = STATE(9361),
    [aux_sym_vector_expression_repeat1] = STATE(17310),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11928),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11930),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11932),
    [aux_sym__terminator_token2] = ACTIONS(11935),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9362] = {
    [sym__comprehension_clause] = STATE(18346),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9362),
    [sym_line_comment] = STATE(9362),
    [aux_sym_vector_expression_repeat1] = STATE(17534),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11945),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11947),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11949),
    [aux_sym__terminator_token2] = ACTIONS(11952),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9363] = {
    [sym__comprehension_clause] = STATE(19419),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9363),
    [sym_line_comment] = STATE(9363),
    [aux_sym_vector_expression_repeat1] = STATE(17532),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11479),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11481),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11483),
    [aux_sym__terminator_token2] = ACTIONS(11486),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9364] = {
    [sym__comprehension_clause] = STATE(18472),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9364),
    [sym_line_comment] = STATE(9364),
    [aux_sym_vector_expression_repeat1] = STATE(17489),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12038),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12040),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12042),
    [aux_sym__terminator_token2] = ACTIONS(12045),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9365] = {
    [sym__comprehension_clause] = STATE(19357),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9365),
    [sym_line_comment] = STATE(9365),
    [aux_sym_vector_expression_repeat1] = STATE(17321),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11098),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11100),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11102),
    [aux_sym__terminator_token2] = ACTIONS(11105),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9366] = {
    [sym__comprehension_clause] = STATE(18950),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9366),
    [sym_line_comment] = STATE(9366),
    [aux_sym_vector_expression_repeat1] = STATE(17599),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11147),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11149),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11151),
    [aux_sym__terminator_token2] = ACTIONS(11154),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9367] = {
    [sym__comprehension_clause] = STATE(18233),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9367),
    [sym_line_comment] = STATE(9367),
    [aux_sym_vector_expression_repeat1] = STATE(17614),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12134),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12136),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12138),
    [aux_sym__terminator_token2] = ACTIONS(12141),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9368] = {
    [sym__comprehension_clause] = STATE(19526),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9368),
    [sym_line_comment] = STATE(9368),
    [aux_sym_vector_expression_repeat1] = STATE(17218),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11157),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11159),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11161),
    [aux_sym__terminator_token2] = ACTIONS(11164),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9369] = {
    [sym__comprehension_clause] = STATE(19420),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9369),
    [sym_line_comment] = STATE(9369),
    [aux_sym_vector_expression_repeat1] = STATE(17248),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11585),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11587),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11589),
    [aux_sym__terminator_token2] = ACTIONS(11592),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9370] = {
    [sym__comprehension_clause] = STATE(18508),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9370),
    [sym_line_comment] = STATE(9370),
    [aux_sym_vector_expression_repeat1] = STATE(17395),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11914),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11916),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11918),
    [aux_sym__terminator_token2] = ACTIONS(11921),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9371] = {
    [sym_identifier] = STATE(10251),
    [sym_integer_literal] = STATE(9979),
    [sym_float_literal] = STATE(9979),
    [sym__string] = STATE(9979),
    [sym__delimiter_str_1] = STATE(14840),
    [sym__delimiter_str_3] = STATE(14862),
    [sym__delimiter_cmd_1] = STATE(14480),
    [sym__delimiter_cmd_3] = STATE(14939),
    [sym_string_literal] = STATE(9921),
    [sym_command_literal] = STATE(9921),
    [sym_prefixed_string_literal] = STATE(9921),
    [sym_prefixed_command_literal] = STATE(9921),
    [sym_operator] = STATE(9979),
    [sym__assignment_operator] = STATE(9979),
    [sym__syntactic_operator] = STATE(9979),
    [sym_block_comment] = STATE(9371),
    [sym_line_comment] = STATE(9371),
    [ts_builtin_sym_end] = ACTIONS(3075),
    [sym__word_identifier] = ACTIONS(12926),
    [anon_sym_COMMA] = ACTIONS(3071),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12928),
    [anon_sym_COLON2] = ACTIONS(12930),
    [anon_sym_COLON_COLON] = ACTIONS(3071),
    [anon_sym_COLON_EQ] = ACTIONS(12932),
    [anon_sym_DOT_EQ] = ACTIONS(12932),
    [aux_sym_quote_expression_token1] = ACTIONS(12934),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12928),
    [anon_sym_QMARK] = ACTIONS(12928),
    [anon_sym_DASH_GT] = ACTIONS(12928),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12936),
    [aux_sym_integer_literal_token2] = ACTIONS(12936),
    [aux_sym_integer_literal_token3] = ACTIONS(12936),
    [aux_sym_integer_literal_token4] = ACTIONS(12938),
    [aux_sym_float_literal_token1] = ACTIONS(12940),
    [aux_sym_float_literal_token3] = ACTIONS(12940),
    [aux_sym_float_literal_token4] = ACTIONS(12940),
    [sym_character_literal] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(177),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(179),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12932),
    [aux_sym__assignment_operator_token1] = ACTIONS(12932),
    [sym__pair_operator] = ACTIONS(12930),
    [sym__arrow_operator] = ACTIONS(12930),
    [sym__lazy_or_operator] = ACTIONS(12934),
    [sym__lazy_and_operator] = ACTIONS(12934),
    [sym__comparison_operator] = ACTIONS(12930),
    [sym__pipe_right_operator] = ACTIONS(12930),
    [sym__pipe_left_operator] = ACTIONS(12930),
    [sym__ellipsis_operator] = ACTIONS(12930),
    [sym__plus_operator] = ACTIONS(12930),
    [sym__times_operator] = ACTIONS(12930),
    [sym__rational_operator] = ACTIONS(12930),
    [sym__bitshift_operator] = ACTIONS(12930),
    [sym__power_operator] = ACTIONS(12930),
    [sym__tilde_operator] = ACTIONS(12930),
    [sym__type_order_operator] = ACTIONS(12930),
    [sym__unary_operator] = ACTIONS(12930),
    [sym__unary_plus_operator] = ACTIONS(12930),
    [anon_sym_DOT2] = ACTIONS(12928),
    [aux_sym__terminator_token1] = ACTIONS(3075),
    [aux_sym__terminator_token2] = ACTIONS(3071),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12942),
    [sym__immediate_bracket] = ACTIONS(12944),
    [sym__immediate_brace] = ACTIONS(12946),
  },
  [9372] = {
    [sym__comprehension_clause] = STATE(18532),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9372),
    [sym_line_comment] = STATE(9372),
    [aux_sym_vector_expression_repeat1] = STATE(17483),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11137),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11141),
    [aux_sym__terminator_token2] = ACTIONS(11144),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9373] = {
    [sym__comprehension_clause] = STATE(19007),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9373),
    [sym_line_comment] = STATE(9373),
    [aux_sym_vector_expression_repeat1] = STATE(17384),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12092),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12094),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12096),
    [aux_sym__terminator_token2] = ACTIONS(12099),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9374] = {
    [sym__comprehension_clause] = STATE(18865),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9374),
    [sym_line_comment] = STATE(9374),
    [aux_sym_vector_expression_repeat1] = STATE(17457),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11237),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11239),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11241),
    [aux_sym__terminator_token2] = ACTIONS(11244),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9375] = {
    [sym__comprehension_clause] = STATE(18693),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9375),
    [sym_line_comment] = STATE(9375),
    [aux_sym_vector_expression_repeat1] = STATE(17151),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11177),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11179),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11181),
    [aux_sym__terminator_token2] = ACTIONS(11184),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9376] = {
    [sym__comprehension_clause] = STATE(18430),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9376),
    [sym_line_comment] = STATE(9376),
    [aux_sym_vector_expression_repeat1] = STATE(17130),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12144),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12146),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12148),
    [aux_sym__terminator_token2] = ACTIONS(12151),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9377] = {
    [sym__comprehension_clause] = STATE(18458),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9377),
    [sym_line_comment] = STATE(9377),
    [aux_sym_vector_expression_repeat1] = STATE(17147),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11321),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11323),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11325),
    [aux_sym__terminator_token2] = ACTIONS(11328),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9378] = {
    [sym__comprehension_clause] = STATE(18955),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9378),
    [sym_line_comment] = STATE(9378),
    [aux_sym_vector_expression_repeat1] = STATE(17367),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11415),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11417),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11419),
    [aux_sym__terminator_token2] = ACTIONS(11422),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9379] = {
    [sym__comprehension_clause] = STATE(18641),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9379),
    [sym_line_comment] = STATE(9379),
    [aux_sym_vector_expression_repeat1] = STATE(17219),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11794),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11796),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11798),
    [aux_sym__terminator_token2] = ACTIONS(11801),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9380] = {
    [sym__comprehension_clause] = STATE(18765),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9380),
    [sym_line_comment] = STATE(9380),
    [aux_sym_vector_expression_repeat1] = STATE(17283),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11489),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11491),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11493),
    [aux_sym__terminator_token2] = ACTIONS(11496),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9381] = {
    [sym__comprehension_clause] = STATE(19543),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9381),
    [sym_line_comment] = STATE(9381),
    [aux_sym_vector_expression_repeat1] = STATE(17215),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11201),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11203),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11205),
    [aux_sym__terminator_token2] = ACTIONS(11208),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9382] = {
    [sym__comprehension_clause] = STATE(18691),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9382),
    [sym_line_comment] = STATE(9382),
    [aux_sym_vector_expression_repeat1] = STATE(17251),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11987),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11989),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11991),
    [aux_sym__terminator_token2] = ACTIONS(11994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9383] = {
    [sym__comprehension_clause] = STATE(19116),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9383),
    [sym_line_comment] = STATE(9383),
    [aux_sym_vector_expression_repeat1] = STATE(17159),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11431),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11433),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11435),
    [aux_sym__terminator_token2] = ACTIONS(11438),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9384] = {
    [sym__comprehension_clause] = STATE(19047),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9384),
    [sym_line_comment] = STATE(9384),
    [aux_sym_vector_expression_repeat1] = STATE(17638),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11955),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11957),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11959),
    [aux_sym__terminator_token2] = ACTIONS(11962),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9385] = {
    [sym__comprehension_clause] = STATE(18709),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9385),
    [sym_line_comment] = STATE(9385),
    [aux_sym_vector_expression_repeat1] = STATE(17545),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12082),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12084),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12086),
    [aux_sym__terminator_token2] = ACTIONS(12089),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9386] = {
    [sym__comprehension_clause] = STATE(19276),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9386),
    [sym_line_comment] = STATE(9386),
    [aux_sym_vector_expression_repeat1] = STATE(17510),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11784),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11786),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11788),
    [aux_sym__terminator_token2] = ACTIONS(11791),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9387] = {
    [sym__comprehension_clause] = STATE(19504),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9387),
    [sym_line_comment] = STATE(9387),
    [aux_sym_vector_expression_repeat1] = STATE(17616),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11816),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11818),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11820),
    [aux_sym__terminator_token2] = ACTIONS(11823),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9388] = {
    [sym__comprehension_clause] = STATE(18792),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9388),
    [sym_line_comment] = STATE(9388),
    [aux_sym_vector_expression_repeat1] = STATE(17287),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12007),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12009),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12011),
    [aux_sym__terminator_token2] = ACTIONS(12014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9389] = {
    [sym_identifier] = STATE(10294),
    [sym_integer_literal] = STATE(9803),
    [sym_float_literal] = STATE(9803),
    [sym__string] = STATE(9803),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(9803),
    [sym__assignment_operator] = STATE(9803),
    [sym__syntactic_operator] = STATE(9803),
    [sym_block_comment] = STATE(9389),
    [sym_line_comment] = STATE(9389),
    [sym__word_identifier] = ACTIONS(12894),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_for] = ACTIONS(3071),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_DOLLAR] = ACTIONS(12896),
    [anon_sym_COLON2] = ACTIONS(12898),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(12900),
    [anon_sym_DOT_EQ] = ACTIONS(12902),
    [aux_sym_quote_expression_token1] = ACTIONS(12904),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12906),
    [anon_sym_QMARK] = ACTIONS(12906),
    [anon_sym_DASH_GT] = ACTIONS(12906),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12908),
    [aux_sym_integer_literal_token2] = ACTIONS(12908),
    [aux_sym_integer_literal_token3] = ACTIONS(12910),
    [aux_sym_integer_literal_token4] = ACTIONS(12912),
    [aux_sym_float_literal_token1] = ACTIONS(12914),
    [aux_sym_float_literal_token3] = ACTIONS(12914),
    [aux_sym_float_literal_token4] = ACTIONS(12914),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12900),
    [aux_sym__assignment_operator_token1] = ACTIONS(12900),
    [sym__pair_operator] = ACTIONS(12916),
    [sym__arrow_operator] = ACTIONS(12898),
    [sym__lazy_or_operator] = ACTIONS(12918),
    [sym__lazy_and_operator] = ACTIONS(12918),
    [sym__comparison_operator] = ACTIONS(12898),
    [sym__pipe_right_operator] = ACTIONS(12916),
    [sym__pipe_left_operator] = ACTIONS(12916),
    [sym__ellipsis_operator] = ACTIONS(12898),
    [sym__plus_operator] = ACTIONS(12898),
    [sym__times_operator] = ACTIONS(12898),
    [sym__rational_operator] = ACTIONS(12898),
    [sym__bitshift_operator] = ACTIONS(12898),
    [sym__power_operator] = ACTIONS(12898),
    [sym__tilde_operator] = ACTIONS(12916),
    [sym__type_order_operator] = ACTIONS(12916),
    [sym__unary_operator] = ACTIONS(12898),
    [sym__unary_plus_operator] = ACTIONS(12898),
    [anon_sym_DOT2] = ACTIONS(12896),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12920),
    [sym__immediate_bracket] = ACTIONS(12922),
    [sym__immediate_brace] = ACTIONS(12924),
  },
  [9390] = {
    [sym__comprehension_clause] = STATE(19004),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9390),
    [sym_line_comment] = STATE(9390),
    [aux_sym_vector_expression_repeat1] = STATE(17298),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11997),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11999),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12001),
    [aux_sym__terminator_token2] = ACTIONS(12004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9391] = {
    [sym__comprehension_clause] = STATE(18832),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9391),
    [sym_line_comment] = STATE(9391),
    [aux_sym_vector_expression_repeat1] = STATE(17454),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11227),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11229),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11231),
    [aux_sym__terminator_token2] = ACTIONS(11234),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9392] = {
    [sym__comprehension_clause] = STATE(19197),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9392),
    [sym_line_comment] = STATE(9392),
    [aux_sym_vector_expression_repeat1] = STATE(17472),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11888),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11890),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11892),
    [aux_sym__terminator_token2] = ACTIONS(11895),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9393] = {
    [sym__comprehension_clause] = STATE(19545),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9393),
    [sym_line_comment] = STATE(9393),
    [aux_sym_vector_expression_repeat1] = STATE(17583),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11446),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11448),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11450),
    [aux_sym__terminator_token2] = ACTIONS(11453),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9394] = {
    [sym__comprehension_clause] = STATE(19591),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9394),
    [sym_line_comment] = STATE(9394),
    [aux_sym_vector_expression_repeat1] = STATE(17065),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11389),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11391),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11393),
    [aux_sym__terminator_token2] = ACTIONS(11396),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9395] = {
    [sym__comprehension_clause] = STATE(18379),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9395),
    [sym_line_comment] = STATE(9395),
    [aux_sym_vector_expression_repeat1] = STATE(17106),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11503),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11505),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11507),
    [aux_sym__terminator_token2] = ACTIONS(11510),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9396] = {
    [sym__comprehension_clause] = STATE(19034),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9396),
    [sym_line_comment] = STATE(9396),
    [aux_sym_vector_expression_repeat1] = STATE(17397),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11658),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11660),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11662),
    [aux_sym__terminator_token2] = ACTIONS(11665),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9397] = {
    [sym__comprehension_clause] = STATE(18593),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9397),
    [sym_line_comment] = STATE(9397),
    [aux_sym_vector_expression_repeat1] = STATE(17197),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11538),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11540),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11542),
    [aux_sym__terminator_token2] = ACTIONS(11545),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9398] = {
    [sym__comprehension_clause] = STATE(19168),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9398),
    [sym_line_comment] = STATE(9398),
    [aux_sym_vector_expression_repeat1] = STATE(17264),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12112),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12114),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12116),
    [aux_sym__terminator_token2] = ACTIONS(12119),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9399] = {
    [sym__comprehension_clause] = STATE(19385),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9399),
    [sym_line_comment] = STATE(9399),
    [aux_sym_vector_expression_repeat1] = STATE(17155),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11973),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11975),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11977),
    [aux_sym__terminator_token2] = ACTIONS(11980),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9400] = {
    [sym__comprehension_clause] = STATE(18540),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9400),
    [sym_line_comment] = STATE(9400),
    [aux_sym_vector_expression_repeat1] = STATE(17449),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12017),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12019),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12021),
    [aux_sym__terminator_token2] = ACTIONS(12024),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9401] = {
    [sym__comprehension_clause] = STATE(19123),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9401),
    [sym_line_comment] = STATE(9401),
    [aux_sym_vector_expression_repeat1] = STATE(17437),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11752),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11754),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11756),
    [aux_sym__terminator_token2] = ACTIONS(11759),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9402] = {
    [sym__comprehension_clause] = STATE(19606),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9402),
    [sym_line_comment] = STATE(9402),
    [aux_sym_vector_expression_repeat1] = STATE(17666),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11836),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11838),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11840),
    [aux_sym__terminator_token2] = ACTIONS(11843),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9403] = {
    [sym__comprehension_clause] = STATE(19008),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9403),
    [sym_line_comment] = STATE(9403),
    [aux_sym_vector_expression_repeat1] = STATE(17408),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12072),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12074),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12076),
    [aux_sym__terminator_token2] = ACTIONS(12079),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9404] = {
    [sym__comprehension_clause] = STATE(18752),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9404),
    [sym_line_comment] = STATE(9404),
    [aux_sym_vector_expression_repeat1] = STATE(17276),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11575),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11577),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11579),
    [aux_sym__terminator_token2] = ACTIONS(11582),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9405] = {
    [sym__comprehension_clause] = STATE(18880),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9405),
    [sym_line_comment] = STATE(9405),
    [aux_sym_vector_expression_repeat1] = STATE(17082),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(12059),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(12061),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12063),
    [aux_sym__terminator_token2] = ACTIONS(12066),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9406] = {
    [sym__comprehension_clause] = STATE(18770),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9406),
    [sym_line_comment] = STATE(9406),
    [aux_sym_vector_expression_repeat1] = STATE(17349),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11848),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11850),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11852),
    [aux_sym__terminator_token2] = ACTIONS(11855),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9407] = {
    [sym__comprehension_clause] = STATE(18892),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9407),
    [sym_line_comment] = STATE(9407),
    [aux_sym_vector_expression_repeat1] = STATE(17336),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11598),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11600),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11602),
    [aux_sym__terminator_token2] = ACTIONS(11605),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9408] = {
    [sym__comprehension_clause] = STATE(19408),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9408),
    [sym_line_comment] = STATE(9408),
    [aux_sym_vector_expression_repeat1] = STATE(17339),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11049),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11056),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11092),
    [aux_sym__terminator_token2] = ACTIONS(11095),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9409] = {
    [sym__comprehension_clause] = STATE(19094),
    [sym_for_clause] = STATE(14271),
    [sym_block_comment] = STATE(9409),
    [sym_line_comment] = STATE(9409),
    [aux_sym_vector_expression_repeat1] = STATE(17493),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_COMMA] = ACTIONS(11774),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11051),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11776),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(11778),
    [aux_sym__terminator_token2] = ACTIONS(11781),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9410] = {
    [sym_identifier] = STATE(10550),
    [sym_integer_literal] = STATE(9803),
    [sym_float_literal] = STATE(9803),
    [sym__string] = STATE(9803),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(9803),
    [sym__assignment_operator] = STATE(9803),
    [sym__syntactic_operator] = STATE(9803),
    [sym_block_comment] = STATE(9410),
    [sym_line_comment] = STATE(9410),
    [sym__word_identifier] = ACTIONS(12894),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_end] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12896),
    [anon_sym_COLON2] = ACTIONS(12898),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(12900),
    [anon_sym_DOT_EQ] = ACTIONS(12902),
    [aux_sym_quote_expression_token1] = ACTIONS(12904),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12906),
    [anon_sym_QMARK] = ACTIONS(12906),
    [anon_sym_DASH_GT] = ACTIONS(12906),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12908),
    [aux_sym_integer_literal_token2] = ACTIONS(12908),
    [aux_sym_integer_literal_token3] = ACTIONS(12910),
    [aux_sym_integer_literal_token4] = ACTIONS(12912),
    [aux_sym_float_literal_token1] = ACTIONS(12914),
    [aux_sym_float_literal_token3] = ACTIONS(12914),
    [aux_sym_float_literal_token4] = ACTIONS(12914),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12900),
    [aux_sym__assignment_operator_token1] = ACTIONS(12900),
    [sym__pair_operator] = ACTIONS(12916),
    [sym__arrow_operator] = ACTIONS(12898),
    [sym__lazy_or_operator] = ACTIONS(12918),
    [sym__lazy_and_operator] = ACTIONS(12918),
    [sym__comparison_operator] = ACTIONS(12898),
    [sym__pipe_right_operator] = ACTIONS(12916),
    [sym__pipe_left_operator] = ACTIONS(12916),
    [sym__ellipsis_operator] = ACTIONS(12898),
    [sym__plus_operator] = ACTIONS(12898),
    [sym__times_operator] = ACTIONS(12898),
    [sym__rational_operator] = ACTIONS(12898),
    [sym__bitshift_operator] = ACTIONS(12898),
    [sym__power_operator] = ACTIONS(12898),
    [sym__tilde_operator] = ACTIONS(12916),
    [sym__type_order_operator] = ACTIONS(12916),
    [sym__unary_operator] = ACTIONS(12898),
    [sym__unary_plus_operator] = ACTIONS(12898),
    [anon_sym_DOT2] = ACTIONS(12896),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12920),
    [sym__immediate_bracket] = ACTIONS(12922),
    [sym__immediate_brace] = ACTIONS(12924),
  },
  [9411] = {
    [sym_block_comment] = STATE(9411),
    [sym_line_comment] = STATE(9411),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(9644),
    [sym__immediate_command_start] = ACTIONS(9644),
  },
  [9412] = {
    [sym_block_comment] = STATE(9412),
    [sym_line_comment] = STATE(9412),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_string_start] = ACTIONS(12953),
    [sym__immediate_command_start] = ACTIONS(12955),
  },
  [9413] = {
    [sym_block_comment] = STATE(9413),
    [sym_line_comment] = STATE(9413),
    [aux_sym_for_statement_repeat1] = STATE(9413),
    [sym__word_identifier] = ACTIONS(12957),
    [anon_sym_COMMA] = ACTIONS(12959),
    [anon_sym_begin] = ACTIONS(12957),
    [anon_sym_module] = ACTIONS(12957),
    [anon_sym_baremodule] = ACTIONS(12957),
    [anon_sym_end] = ACTIONS(12957),
    [anon_sym_abstract] = ACTIONS(12957),
    [anon_sym_primitive] = ACTIONS(12957),
    [anon_sym_mutable] = ACTIONS(12957),
    [anon_sym_struct] = ACTIONS(12957),
    [anon_sym_function] = ACTIONS(12957),
    [anon_sym_macro] = ACTIONS(12957),
    [anon_sym_quote] = ACTIONS(12957),
    [anon_sym_let] = ACTIONS(12957),
    [anon_sym_if] = ACTIONS(12957),
    [anon_sym_try] = ACTIONS(12957),
    [anon_sym_for] = ACTIONS(12957),
    [anon_sym_while] = ACTIONS(12957),
    [sym_break_statement] = ACTIONS(12957),
    [sym_continue_statement] = ACTIONS(12957),
    [anon_sym_return] = ACTIONS(12957),
    [anon_sym_const] = ACTIONS(12957),
    [anon_sym_global] = ACTIONS(12957),
    [anon_sym_local] = ACTIONS(12957),
    [anon_sym_LPAREN] = ACTIONS(12957),
    [anon_sym_export] = ACTIONS(12957),
    [anon_sym_public] = ACTIONS(12957),
    [anon_sym_import] = ACTIONS(12957),
    [anon_sym_using] = ACTIONS(12957),
    [anon_sym_LBRACK] = ACTIONS(12957),
    [anon_sym_LBRACE] = ACTIONS(12957),
    [anon_sym_DOLLAR] = ACTIONS(12957),
    [anon_sym_COLON2] = ACTIONS(12957),
    [anon_sym_COLON_COLON] = ACTIONS(12957),
    [anon_sym_AT] = ACTIONS(12957),
    [anon_sym_true] = ACTIONS(12957),
    [anon_sym_false] = ACTIONS(12957),
    [aux_sym_integer_literal_token1] = ACTIONS(12957),
    [aux_sym_integer_literal_token2] = ACTIONS(12957),
    [aux_sym_integer_literal_token3] = ACTIONS(12957),
    [aux_sym_integer_literal_token4] = ACTIONS(12957),
    [aux_sym_float_literal_token1] = ACTIONS(12957),
    [aux_sym_float_literal_token3] = ACTIONS(12957),
    [aux_sym_float_literal_token4] = ACTIONS(12957),
    [sym_character_literal] = ACTIONS(12957),
    [anon_sym_DQUOTE] = ACTIONS(12957),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12957),
    [anon_sym_BQUOTE] = ACTIONS(12957),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12957),
    [sym__pair_operator] = ACTIONS(12957),
    [sym__arrow_operator] = ACTIONS(12957),
    [sym__comparison_operator] = ACTIONS(12957),
    [sym__pipe_right_operator] = ACTIONS(12957),
    [sym__pipe_left_operator] = ACTIONS(12957),
    [sym__ellipsis_operator] = ACTIONS(12957),
    [sym__plus_operator] = ACTIONS(12957),
    [sym__times_operator] = ACTIONS(12957),
    [sym__rational_operator] = ACTIONS(12957),
    [sym__bitshift_operator] = ACTIONS(12957),
    [sym__power_operator] = ACTIONS(12957),
    [sym__tilde_operator] = ACTIONS(12957),
    [sym__type_order_operator] = ACTIONS(12957),
    [sym__unary_operator] = ACTIONS(12957),
    [sym__unary_plus_operator] = ACTIONS(12957),
    [aux_sym__terminator_token1] = ACTIONS(12962),
    [aux_sym__terminator_token2] = ACTIONS(12957),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9414] = {
    [sym_block_comment] = STATE(9414),
    [sym_line_comment] = STATE(9414),
    [sym__word_identifier] = ACTIONS(9790),
    [anon_sym_begin] = ACTIONS(9790),
    [anon_sym_module] = ACTIONS(9790),
    [anon_sym_baremodule] = ACTIONS(9790),
    [anon_sym_end] = ACTIONS(9790),
    [anon_sym_abstract] = ACTIONS(9790),
    [anon_sym_primitive] = ACTIONS(9790),
    [anon_sym_mutable] = ACTIONS(9790),
    [anon_sym_struct] = ACTIONS(9790),
    [anon_sym_function] = ACTIONS(9790),
    [anon_sym_macro] = ACTIONS(9790),
    [anon_sym_quote] = ACTIONS(9790),
    [anon_sym_let] = ACTIONS(9790),
    [anon_sym_if] = ACTIONS(9790),
    [anon_sym_try] = ACTIONS(9790),
    [anon_sym_for] = ACTIONS(9790),
    [anon_sym_while] = ACTIONS(9790),
    [sym_break_statement] = ACTIONS(9790),
    [sym_continue_statement] = ACTIONS(9790),
    [anon_sym_return] = ACTIONS(9790),
    [anon_sym_const] = ACTIONS(9790),
    [anon_sym_global] = ACTIONS(9790),
    [anon_sym_local] = ACTIONS(9790),
    [anon_sym_LPAREN] = ACTIONS(9790),
    [anon_sym_export] = ACTIONS(9790),
    [anon_sym_public] = ACTIONS(9790),
    [anon_sym_import] = ACTIONS(9790),
    [anon_sym_using] = ACTIONS(9790),
    [anon_sym_LBRACK] = ACTIONS(9790),
    [anon_sym_LBRACE] = ACTIONS(9790),
    [anon_sym_DOLLAR] = ACTIONS(9790),
    [anon_sym_COLON2] = ACTIONS(9790),
    [anon_sym_COLON_COLON] = ACTIONS(9790),
    [anon_sym_DASH_GT] = ACTIONS(9790),
    [anon_sym_AT] = ACTIONS(9790),
    [anon_sym_true] = ACTIONS(9790),
    [anon_sym_false] = ACTIONS(9790),
    [aux_sym_integer_literal_token1] = ACTIONS(9790),
    [aux_sym_integer_literal_token2] = ACTIONS(9790),
    [aux_sym_integer_literal_token3] = ACTIONS(9790),
    [aux_sym_integer_literal_token4] = ACTIONS(9790),
    [aux_sym_float_literal_token1] = ACTIONS(9790),
    [aux_sym_float_literal_token3] = ACTIONS(9790),
    [aux_sym_float_literal_token4] = ACTIONS(9790),
    [sym_character_literal] = ACTIONS(9790),
    [anon_sym_DQUOTE] = ACTIONS(9790),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE] = ACTIONS(9790),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9790),
    [sym__pair_operator] = ACTIONS(9790),
    [sym__arrow_operator] = ACTIONS(9790),
    [sym__comparison_operator] = ACTIONS(9790),
    [sym__pipe_right_operator] = ACTIONS(9790),
    [sym__pipe_left_operator] = ACTIONS(9790),
    [sym__ellipsis_operator] = ACTIONS(9790),
    [sym__plus_operator] = ACTIONS(9790),
    [sym__times_operator] = ACTIONS(9790),
    [sym__rational_operator] = ACTIONS(9790),
    [sym__bitshift_operator] = ACTIONS(9790),
    [sym__power_operator] = ACTIONS(9790),
    [sym__tilde_operator] = ACTIONS(9790),
    [sym__type_order_operator] = ACTIONS(9790),
    [sym__unary_operator] = ACTIONS(9790),
    [sym__unary_plus_operator] = ACTIONS(9790),
    [aux_sym__terminator_token1] = ACTIONS(9822),
    [aux_sym__terminator_token2] = ACTIONS(9790),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9415] = {
    [sym_block_comment] = STATE(9415),
    [sym_line_comment] = STATE(9415),
    [sym__word_identifier] = ACTIONS(9832),
    [anon_sym_begin] = ACTIONS(9832),
    [anon_sym_module] = ACTIONS(9832),
    [anon_sym_baremodule] = ACTIONS(9832),
    [anon_sym_end] = ACTIONS(9832),
    [anon_sym_abstract] = ACTIONS(9832),
    [anon_sym_primitive] = ACTIONS(9832),
    [anon_sym_mutable] = ACTIONS(9832),
    [anon_sym_struct] = ACTIONS(9832),
    [anon_sym_function] = ACTIONS(9832),
    [anon_sym_macro] = ACTIONS(9832),
    [anon_sym_quote] = ACTIONS(9832),
    [anon_sym_let] = ACTIONS(9832),
    [anon_sym_if] = ACTIONS(9832),
    [anon_sym_try] = ACTIONS(9832),
    [anon_sym_for] = ACTIONS(9832),
    [anon_sym_while] = ACTIONS(9832),
    [sym_break_statement] = ACTIONS(9832),
    [sym_continue_statement] = ACTIONS(9832),
    [anon_sym_return] = ACTIONS(9832),
    [anon_sym_const] = ACTIONS(9832),
    [anon_sym_global] = ACTIONS(9832),
    [anon_sym_local] = ACTIONS(9832),
    [anon_sym_LPAREN] = ACTIONS(9832),
    [anon_sym_export] = ACTIONS(9832),
    [anon_sym_public] = ACTIONS(9832),
    [anon_sym_import] = ACTIONS(9832),
    [anon_sym_using] = ACTIONS(9832),
    [anon_sym_LBRACK] = ACTIONS(9832),
    [anon_sym_LBRACE] = ACTIONS(9832),
    [anon_sym_DOLLAR] = ACTIONS(9832),
    [anon_sym_COLON2] = ACTIONS(9832),
    [anon_sym_COLON_COLON] = ACTIONS(9832),
    [anon_sym_DASH_GT] = ACTIONS(9832),
    [anon_sym_AT] = ACTIONS(9832),
    [anon_sym_true] = ACTIONS(9832),
    [anon_sym_false] = ACTIONS(9832),
    [aux_sym_integer_literal_token1] = ACTIONS(9832),
    [aux_sym_integer_literal_token2] = ACTIONS(9832),
    [aux_sym_integer_literal_token3] = ACTIONS(9832),
    [aux_sym_integer_literal_token4] = ACTIONS(9832),
    [aux_sym_float_literal_token1] = ACTIONS(9832),
    [aux_sym_float_literal_token3] = ACTIONS(9832),
    [aux_sym_float_literal_token4] = ACTIONS(9832),
    [sym_character_literal] = ACTIONS(9832),
    [anon_sym_DQUOTE] = ACTIONS(9832),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE] = ACTIONS(9832),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9832),
    [sym__pair_operator] = ACTIONS(9832),
    [sym__arrow_operator] = ACTIONS(9832),
    [sym__comparison_operator] = ACTIONS(9832),
    [sym__pipe_right_operator] = ACTIONS(9832),
    [sym__pipe_left_operator] = ACTIONS(9832),
    [sym__ellipsis_operator] = ACTIONS(9832),
    [sym__plus_operator] = ACTIONS(9832),
    [sym__times_operator] = ACTIONS(9832),
    [sym__rational_operator] = ACTIONS(9832),
    [sym__bitshift_operator] = ACTIONS(9832),
    [sym__power_operator] = ACTIONS(9832),
    [sym__tilde_operator] = ACTIONS(9832),
    [sym__type_order_operator] = ACTIONS(9832),
    [sym__unary_operator] = ACTIONS(9832),
    [sym__unary_plus_operator] = ACTIONS(9832),
    [aux_sym__terminator_token1] = ACTIONS(9834),
    [aux_sym__terminator_token2] = ACTIONS(9832),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9416] = {
    [sym_block_comment] = STATE(9416),
    [sym_line_comment] = STATE(9416),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token2] = ACTIONS(12964),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9417] = {
    [sym_identifier] = STATE(9469),
    [sym_block_comment] = STATE(9417),
    [sym_line_comment] = STATE(9417),
    [sym__word_identifier] = ACTIONS(9800),
    [anon_sym_begin] = ACTIONS(9800),
    [anon_sym_module] = ACTIONS(9800),
    [anon_sym_baremodule] = ACTIONS(9800),
    [anon_sym_end] = ACTIONS(9800),
    [anon_sym_abstract] = ACTIONS(9800),
    [anon_sym_primitive] = ACTIONS(9800),
    [anon_sym_mutable] = ACTIONS(9800),
    [anon_sym_struct] = ACTIONS(9800),
    [anon_sym_function] = ACTIONS(9800),
    [anon_sym_macro] = ACTIONS(9800),
    [anon_sym_quote] = ACTIONS(9800),
    [anon_sym_let] = ACTIONS(9800),
    [anon_sym_if] = ACTIONS(9800),
    [anon_sym_try] = ACTIONS(9800),
    [anon_sym_for] = ACTIONS(9800),
    [anon_sym_while] = ACTIONS(9800),
    [sym_break_statement] = ACTIONS(9800),
    [sym_continue_statement] = ACTIONS(9800),
    [anon_sym_return] = ACTIONS(9800),
    [anon_sym_const] = ACTIONS(9800),
    [anon_sym_global] = ACTIONS(9800),
    [anon_sym_local] = ACTIONS(9800),
    [anon_sym_LPAREN] = ACTIONS(9800),
    [anon_sym_export] = ACTIONS(9800),
    [anon_sym_public] = ACTIONS(9800),
    [anon_sym_import] = ACTIONS(9800),
    [anon_sym_using] = ACTIONS(9800),
    [anon_sym_LBRACK] = ACTIONS(9800),
    [anon_sym_LBRACE] = ACTIONS(9800),
    [anon_sym_DOLLAR] = ACTIONS(9800),
    [anon_sym_COLON2] = ACTIONS(9800),
    [anon_sym_COLON_COLON] = ACTIONS(9800),
    [anon_sym_AT] = ACTIONS(9800),
    [anon_sym_true] = ACTIONS(9800),
    [anon_sym_false] = ACTIONS(9800),
    [aux_sym_integer_literal_token1] = ACTIONS(9800),
    [aux_sym_integer_literal_token2] = ACTIONS(9800),
    [aux_sym_integer_literal_token3] = ACTIONS(9800),
    [aux_sym_integer_literal_token4] = ACTIONS(9800),
    [aux_sym_float_literal_token1] = ACTIONS(9800),
    [aux_sym_float_literal_token3] = ACTIONS(9800),
    [aux_sym_float_literal_token4] = ACTIONS(9800),
    [sym_character_literal] = ACTIONS(9800),
    [anon_sym_DQUOTE] = ACTIONS(9800),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE] = ACTIONS(9800),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9800),
    [sym__pair_operator] = ACTIONS(9800),
    [sym__arrow_operator] = ACTIONS(9800),
    [sym__comparison_operator] = ACTIONS(9800),
    [sym__pipe_right_operator] = ACTIONS(9800),
    [sym__pipe_left_operator] = ACTIONS(9800),
    [sym__ellipsis_operator] = ACTIONS(9800),
    [sym__plus_operator] = ACTIONS(9800),
    [sym__times_operator] = ACTIONS(9800),
    [sym__rational_operator] = ACTIONS(9800),
    [sym__bitshift_operator] = ACTIONS(9800),
    [sym__power_operator] = ACTIONS(9800),
    [sym__tilde_operator] = ACTIONS(9800),
    [sym__type_order_operator] = ACTIONS(9800),
    [sym__unary_operator] = ACTIONS(9800),
    [sym__unary_plus_operator] = ACTIONS(9800),
    [aux_sym__terminator_token1] = ACTIONS(9802),
    [aux_sym__terminator_token2] = ACTIONS(9800),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9418] = {
    [sym_block_comment] = STATE(9418),
    [sym_line_comment] = STATE(9418),
    [sym__word_identifier] = ACTIONS(9752),
    [anon_sym_begin] = ACTIONS(9752),
    [anon_sym_module] = ACTIONS(9752),
    [anon_sym_baremodule] = ACTIONS(9752),
    [anon_sym_end] = ACTIONS(9752),
    [anon_sym_abstract] = ACTIONS(9752),
    [anon_sym_primitive] = ACTIONS(9752),
    [anon_sym_mutable] = ACTIONS(9752),
    [anon_sym_struct] = ACTIONS(9752),
    [anon_sym_function] = ACTIONS(9752),
    [anon_sym_macro] = ACTIONS(9752),
    [anon_sym_quote] = ACTIONS(9752),
    [anon_sym_let] = ACTIONS(9752),
    [anon_sym_if] = ACTIONS(9752),
    [anon_sym_try] = ACTIONS(9752),
    [anon_sym_for] = ACTIONS(9752),
    [anon_sym_while] = ACTIONS(9752),
    [sym_break_statement] = ACTIONS(9752),
    [sym_continue_statement] = ACTIONS(9752),
    [anon_sym_return] = ACTIONS(9752),
    [anon_sym_const] = ACTIONS(9752),
    [anon_sym_global] = ACTIONS(9752),
    [anon_sym_local] = ACTIONS(9752),
    [anon_sym_LPAREN] = ACTIONS(9752),
    [anon_sym_export] = ACTIONS(9752),
    [anon_sym_public] = ACTIONS(9752),
    [anon_sym_import] = ACTIONS(9752),
    [anon_sym_using] = ACTIONS(9752),
    [anon_sym_LBRACK] = ACTIONS(9752),
    [anon_sym_LBRACE] = ACTIONS(9752),
    [anon_sym_DOLLAR] = ACTIONS(9752),
    [anon_sym_COLON2] = ACTIONS(9752),
    [anon_sym_COLON_COLON] = ACTIONS(9752),
    [anon_sym_DASH_GT] = ACTIONS(9752),
    [anon_sym_AT] = ACTIONS(9752),
    [anon_sym_true] = ACTIONS(9752),
    [anon_sym_false] = ACTIONS(9752),
    [aux_sym_integer_literal_token1] = ACTIONS(9752),
    [aux_sym_integer_literal_token2] = ACTIONS(9752),
    [aux_sym_integer_literal_token3] = ACTIONS(9752),
    [aux_sym_integer_literal_token4] = ACTIONS(9752),
    [aux_sym_float_literal_token1] = ACTIONS(9752),
    [aux_sym_float_literal_token3] = ACTIONS(9752),
    [aux_sym_float_literal_token4] = ACTIONS(9752),
    [sym_character_literal] = ACTIONS(9752),
    [anon_sym_DQUOTE] = ACTIONS(9752),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE] = ACTIONS(9752),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9752),
    [sym__pair_operator] = ACTIONS(9752),
    [sym__arrow_operator] = ACTIONS(9752),
    [sym__comparison_operator] = ACTIONS(9752),
    [sym__pipe_right_operator] = ACTIONS(9752),
    [sym__pipe_left_operator] = ACTIONS(9752),
    [sym__ellipsis_operator] = ACTIONS(9752),
    [sym__plus_operator] = ACTIONS(9752),
    [sym__times_operator] = ACTIONS(9752),
    [sym__rational_operator] = ACTIONS(9752),
    [sym__bitshift_operator] = ACTIONS(9752),
    [sym__power_operator] = ACTIONS(9752),
    [sym__tilde_operator] = ACTIONS(9752),
    [sym__type_order_operator] = ACTIONS(9752),
    [sym__unary_operator] = ACTIONS(9752),
    [sym__unary_plus_operator] = ACTIONS(9752),
    [aux_sym__terminator_token1] = ACTIONS(9808),
    [aux_sym__terminator_token2] = ACTIONS(9752),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9419] = {
    [sym_block_comment] = STATE(9419),
    [sym_line_comment] = STATE(9419),
    [sym__word_identifier] = ACTIONS(9810),
    [anon_sym_begin] = ACTIONS(9810),
    [anon_sym_module] = ACTIONS(9810),
    [anon_sym_baremodule] = ACTIONS(9810),
    [anon_sym_end] = ACTIONS(9810),
    [anon_sym_abstract] = ACTIONS(9810),
    [anon_sym_primitive] = ACTIONS(9810),
    [anon_sym_mutable] = ACTIONS(9810),
    [anon_sym_struct] = ACTIONS(9810),
    [anon_sym_function] = ACTIONS(9810),
    [anon_sym_macro] = ACTIONS(9810),
    [anon_sym_quote] = ACTIONS(9810),
    [anon_sym_let] = ACTIONS(9810),
    [anon_sym_if] = ACTIONS(9810),
    [anon_sym_try] = ACTIONS(9810),
    [anon_sym_for] = ACTIONS(9810),
    [anon_sym_while] = ACTIONS(9810),
    [sym_break_statement] = ACTIONS(9810),
    [sym_continue_statement] = ACTIONS(9810),
    [anon_sym_return] = ACTIONS(9810),
    [anon_sym_const] = ACTIONS(9810),
    [anon_sym_global] = ACTIONS(9810),
    [anon_sym_local] = ACTIONS(9810),
    [anon_sym_LPAREN] = ACTIONS(9810),
    [anon_sym_export] = ACTIONS(9810),
    [anon_sym_public] = ACTIONS(9810),
    [anon_sym_import] = ACTIONS(9810),
    [anon_sym_using] = ACTIONS(9810),
    [anon_sym_LBRACK] = ACTIONS(9810),
    [anon_sym_LBRACE] = ACTIONS(9810),
    [anon_sym_DOLLAR] = ACTIONS(9810),
    [anon_sym_COLON2] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [anon_sym_DASH_GT] = ACTIONS(9810),
    [anon_sym_AT] = ACTIONS(9810),
    [anon_sym_true] = ACTIONS(9810),
    [anon_sym_false] = ACTIONS(9810),
    [aux_sym_integer_literal_token1] = ACTIONS(9810),
    [aux_sym_integer_literal_token2] = ACTIONS(9810),
    [aux_sym_integer_literal_token3] = ACTIONS(9810),
    [aux_sym_integer_literal_token4] = ACTIONS(9810),
    [aux_sym_float_literal_token1] = ACTIONS(9810),
    [aux_sym_float_literal_token3] = ACTIONS(9810),
    [aux_sym_float_literal_token4] = ACTIONS(9810),
    [sym_character_literal] = ACTIONS(9810),
    [anon_sym_DQUOTE] = ACTIONS(9810),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE] = ACTIONS(9810),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9810),
    [sym__pair_operator] = ACTIONS(9810),
    [sym__arrow_operator] = ACTIONS(9810),
    [sym__comparison_operator] = ACTIONS(9810),
    [sym__pipe_right_operator] = ACTIONS(9810),
    [sym__pipe_left_operator] = ACTIONS(9810),
    [sym__ellipsis_operator] = ACTIONS(9810),
    [sym__plus_operator] = ACTIONS(9810),
    [sym__times_operator] = ACTIONS(9810),
    [sym__rational_operator] = ACTIONS(9810),
    [sym__bitshift_operator] = ACTIONS(9810),
    [sym__power_operator] = ACTIONS(9810),
    [sym__tilde_operator] = ACTIONS(9810),
    [sym__type_order_operator] = ACTIONS(9810),
    [sym__unary_operator] = ACTIONS(9810),
    [sym__unary_plus_operator] = ACTIONS(9810),
    [aux_sym__terminator_token1] = ACTIONS(9812),
    [aux_sym__terminator_token2] = ACTIONS(9810),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9420] = {
    [sym_block_comment] = STATE(9420),
    [sym_line_comment] = STATE(9420),
    [sym__word_identifier] = ACTIONS(9824),
    [anon_sym_begin] = ACTIONS(9824),
    [anon_sym_module] = ACTIONS(9824),
    [anon_sym_baremodule] = ACTIONS(9824),
    [anon_sym_end] = ACTIONS(9824),
    [anon_sym_abstract] = ACTIONS(9824),
    [anon_sym_primitive] = ACTIONS(9824),
    [anon_sym_mutable] = ACTIONS(9824),
    [anon_sym_struct] = ACTIONS(9824),
    [anon_sym_function] = ACTIONS(9824),
    [anon_sym_macro] = ACTIONS(9824),
    [anon_sym_quote] = ACTIONS(9824),
    [anon_sym_let] = ACTIONS(9824),
    [anon_sym_if] = ACTIONS(9824),
    [anon_sym_try] = ACTIONS(9824),
    [anon_sym_for] = ACTIONS(9824),
    [anon_sym_while] = ACTIONS(9824),
    [sym_break_statement] = ACTIONS(9824),
    [sym_continue_statement] = ACTIONS(9824),
    [anon_sym_return] = ACTIONS(9824),
    [anon_sym_const] = ACTIONS(9824),
    [anon_sym_global] = ACTIONS(9824),
    [anon_sym_local] = ACTIONS(9824),
    [anon_sym_LPAREN] = ACTIONS(9824),
    [anon_sym_export] = ACTIONS(9824),
    [anon_sym_public] = ACTIONS(9824),
    [anon_sym_import] = ACTIONS(9824),
    [anon_sym_using] = ACTIONS(9824),
    [anon_sym_LBRACK] = ACTIONS(9824),
    [anon_sym_LBRACE] = ACTIONS(9824),
    [anon_sym_DOLLAR] = ACTIONS(9824),
    [anon_sym_COLON2] = ACTIONS(9824),
    [anon_sym_COLON_COLON] = ACTIONS(9824),
    [anon_sym_DASH_GT] = ACTIONS(9824),
    [anon_sym_AT] = ACTIONS(9824),
    [anon_sym_true] = ACTIONS(9824),
    [anon_sym_false] = ACTIONS(9824),
    [aux_sym_integer_literal_token1] = ACTIONS(9824),
    [aux_sym_integer_literal_token2] = ACTIONS(9824),
    [aux_sym_integer_literal_token3] = ACTIONS(9824),
    [aux_sym_integer_literal_token4] = ACTIONS(9824),
    [aux_sym_float_literal_token1] = ACTIONS(9824),
    [aux_sym_float_literal_token3] = ACTIONS(9824),
    [aux_sym_float_literal_token4] = ACTIONS(9824),
    [sym_character_literal] = ACTIONS(9824),
    [anon_sym_DQUOTE] = ACTIONS(9824),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE] = ACTIONS(9824),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9824),
    [sym__pair_operator] = ACTIONS(9824),
    [sym__arrow_operator] = ACTIONS(9824),
    [sym__comparison_operator] = ACTIONS(9824),
    [sym__pipe_right_operator] = ACTIONS(9824),
    [sym__pipe_left_operator] = ACTIONS(9824),
    [sym__ellipsis_operator] = ACTIONS(9824),
    [sym__plus_operator] = ACTIONS(9824),
    [sym__times_operator] = ACTIONS(9824),
    [sym__rational_operator] = ACTIONS(9824),
    [sym__bitshift_operator] = ACTIONS(9824),
    [sym__power_operator] = ACTIONS(9824),
    [sym__tilde_operator] = ACTIONS(9824),
    [sym__type_order_operator] = ACTIONS(9824),
    [sym__unary_operator] = ACTIONS(9824),
    [sym__unary_plus_operator] = ACTIONS(9824),
    [aux_sym__terminator_token1] = ACTIONS(9826),
    [aux_sym__terminator_token2] = ACTIONS(9824),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9421] = {
    [sym_block_comment] = STATE(9421),
    [sym_line_comment] = STATE(9421),
    [sym__word_identifier] = ACTIONS(9814),
    [anon_sym_begin] = ACTIONS(9814),
    [anon_sym_module] = ACTIONS(9814),
    [anon_sym_baremodule] = ACTIONS(9814),
    [anon_sym_end] = ACTIONS(9814),
    [anon_sym_abstract] = ACTIONS(9814),
    [anon_sym_primitive] = ACTIONS(9814),
    [anon_sym_mutable] = ACTIONS(9814),
    [anon_sym_struct] = ACTIONS(9814),
    [anon_sym_function] = ACTIONS(9814),
    [anon_sym_macro] = ACTIONS(9814),
    [anon_sym_quote] = ACTIONS(9814),
    [anon_sym_let] = ACTIONS(9814),
    [anon_sym_if] = ACTIONS(9814),
    [anon_sym_try] = ACTIONS(9814),
    [anon_sym_for] = ACTIONS(9814),
    [anon_sym_while] = ACTIONS(9814),
    [sym_break_statement] = ACTIONS(9814),
    [sym_continue_statement] = ACTIONS(9814),
    [anon_sym_return] = ACTIONS(9814),
    [anon_sym_const] = ACTIONS(9814),
    [anon_sym_global] = ACTIONS(9814),
    [anon_sym_local] = ACTIONS(9814),
    [anon_sym_LPAREN] = ACTIONS(9814),
    [anon_sym_export] = ACTIONS(9814),
    [anon_sym_public] = ACTIONS(9814),
    [anon_sym_import] = ACTIONS(9814),
    [anon_sym_using] = ACTIONS(9814),
    [anon_sym_LBRACK] = ACTIONS(9814),
    [anon_sym_LBRACE] = ACTIONS(9814),
    [anon_sym_DOLLAR] = ACTIONS(9814),
    [anon_sym_COLON2] = ACTIONS(9814),
    [anon_sym_COLON_COLON] = ACTIONS(9814),
    [anon_sym_DASH_GT] = ACTIONS(9814),
    [anon_sym_AT] = ACTIONS(9814),
    [anon_sym_true] = ACTIONS(9814),
    [anon_sym_false] = ACTIONS(9814),
    [aux_sym_integer_literal_token1] = ACTIONS(9814),
    [aux_sym_integer_literal_token2] = ACTIONS(9814),
    [aux_sym_integer_literal_token3] = ACTIONS(9814),
    [aux_sym_integer_literal_token4] = ACTIONS(9814),
    [aux_sym_float_literal_token1] = ACTIONS(9814),
    [aux_sym_float_literal_token3] = ACTIONS(9814),
    [aux_sym_float_literal_token4] = ACTIONS(9814),
    [sym_character_literal] = ACTIONS(9814),
    [anon_sym_DQUOTE] = ACTIONS(9814),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE] = ACTIONS(9814),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9814),
    [sym__pair_operator] = ACTIONS(9814),
    [sym__arrow_operator] = ACTIONS(9814),
    [sym__comparison_operator] = ACTIONS(9814),
    [sym__pipe_right_operator] = ACTIONS(9814),
    [sym__pipe_left_operator] = ACTIONS(9814),
    [sym__ellipsis_operator] = ACTIONS(9814),
    [sym__plus_operator] = ACTIONS(9814),
    [sym__times_operator] = ACTIONS(9814),
    [sym__rational_operator] = ACTIONS(9814),
    [sym__bitshift_operator] = ACTIONS(9814),
    [sym__power_operator] = ACTIONS(9814),
    [sym__tilde_operator] = ACTIONS(9814),
    [sym__type_order_operator] = ACTIONS(9814),
    [sym__unary_operator] = ACTIONS(9814),
    [sym__unary_plus_operator] = ACTIONS(9814),
    [aux_sym__terminator_token1] = ACTIONS(9816),
    [aux_sym__terminator_token2] = ACTIONS(9814),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9422] = {
    [sym_block_comment] = STATE(9422),
    [sym_line_comment] = STATE(9422),
    [sym__word_identifier] = ACTIONS(9836),
    [anon_sym_begin] = ACTIONS(9836),
    [anon_sym_module] = ACTIONS(9836),
    [anon_sym_baremodule] = ACTIONS(9836),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_abstract] = ACTIONS(9836),
    [anon_sym_primitive] = ACTIONS(9836),
    [anon_sym_mutable] = ACTIONS(9836),
    [anon_sym_struct] = ACTIONS(9836),
    [anon_sym_function] = ACTIONS(9836),
    [anon_sym_macro] = ACTIONS(9836),
    [anon_sym_quote] = ACTIONS(9836),
    [anon_sym_let] = ACTIONS(9836),
    [anon_sym_if] = ACTIONS(9836),
    [anon_sym_try] = ACTIONS(9836),
    [anon_sym_for] = ACTIONS(9836),
    [anon_sym_while] = ACTIONS(9836),
    [sym_break_statement] = ACTIONS(9836),
    [sym_continue_statement] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(9836),
    [anon_sym_const] = ACTIONS(9836),
    [anon_sym_global] = ACTIONS(9836),
    [anon_sym_local] = ACTIONS(9836),
    [anon_sym_LPAREN] = ACTIONS(9836),
    [anon_sym_export] = ACTIONS(9836),
    [anon_sym_public] = ACTIONS(9836),
    [anon_sym_import] = ACTIONS(9836),
    [anon_sym_using] = ACTIONS(9836),
    [anon_sym_LBRACK] = ACTIONS(9836),
    [anon_sym_LBRACE] = ACTIONS(9836),
    [anon_sym_DOLLAR] = ACTIONS(9836),
    [anon_sym_COLON2] = ACTIONS(9836),
    [anon_sym_COLON_COLON] = ACTIONS(9836),
    [anon_sym_DASH_GT] = ACTIONS(9836),
    [anon_sym_AT] = ACTIONS(9836),
    [anon_sym_true] = ACTIONS(9836),
    [anon_sym_false] = ACTIONS(9836),
    [aux_sym_integer_literal_token1] = ACTIONS(9836),
    [aux_sym_integer_literal_token2] = ACTIONS(9836),
    [aux_sym_integer_literal_token3] = ACTIONS(9836),
    [aux_sym_integer_literal_token4] = ACTIONS(9836),
    [aux_sym_float_literal_token1] = ACTIONS(9836),
    [aux_sym_float_literal_token3] = ACTIONS(9836),
    [aux_sym_float_literal_token4] = ACTIONS(9836),
    [sym_character_literal] = ACTIONS(9836),
    [anon_sym_DQUOTE] = ACTIONS(9836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE] = ACTIONS(9836),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9836),
    [sym__pair_operator] = ACTIONS(9836),
    [sym__arrow_operator] = ACTIONS(9836),
    [sym__comparison_operator] = ACTIONS(9836),
    [sym__pipe_right_operator] = ACTIONS(9836),
    [sym__pipe_left_operator] = ACTIONS(9836),
    [sym__ellipsis_operator] = ACTIONS(9836),
    [sym__plus_operator] = ACTIONS(9836),
    [sym__times_operator] = ACTIONS(9836),
    [sym__rational_operator] = ACTIONS(9836),
    [sym__bitshift_operator] = ACTIONS(9836),
    [sym__power_operator] = ACTIONS(9836),
    [sym__tilde_operator] = ACTIONS(9836),
    [sym__type_order_operator] = ACTIONS(9836),
    [sym__unary_operator] = ACTIONS(9836),
    [sym__unary_plus_operator] = ACTIONS(9836),
    [aux_sym__terminator_token1] = ACTIONS(9838),
    [aux_sym__terminator_token2] = ACTIONS(9836),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9423] = {
    [sym_block_comment] = STATE(9423),
    [sym_line_comment] = STATE(9423),
    [sym__word_identifier] = ACTIONS(10214),
    [anon_sym_begin] = ACTIONS(10214),
    [anon_sym_module] = ACTIONS(10214),
    [anon_sym_baremodule] = ACTIONS(10214),
    [anon_sym_end] = ACTIONS(10214),
    [anon_sym_abstract] = ACTIONS(10214),
    [anon_sym_primitive] = ACTIONS(10214),
    [anon_sym_mutable] = ACTIONS(10214),
    [anon_sym_struct] = ACTIONS(10214),
    [anon_sym_function] = ACTIONS(10214),
    [anon_sym_macro] = ACTIONS(10214),
    [anon_sym_quote] = ACTIONS(10214),
    [anon_sym_let] = ACTIONS(10214),
    [anon_sym_if] = ACTIONS(10214),
    [anon_sym_try] = ACTIONS(10214),
    [anon_sym_for] = ACTIONS(10214),
    [anon_sym_while] = ACTIONS(10214),
    [sym_break_statement] = ACTIONS(10214),
    [sym_continue_statement] = ACTIONS(10214),
    [anon_sym_return] = ACTIONS(10214),
    [anon_sym_const] = ACTIONS(10214),
    [anon_sym_global] = ACTIONS(10214),
    [anon_sym_local] = ACTIONS(10214),
    [anon_sym_LPAREN] = ACTIONS(10214),
    [anon_sym_export] = ACTIONS(10214),
    [anon_sym_public] = ACTIONS(10214),
    [anon_sym_import] = ACTIONS(10214),
    [anon_sym_using] = ACTIONS(10214),
    [anon_sym_LBRACK] = ACTIONS(10214),
    [anon_sym_LBRACE] = ACTIONS(10214),
    [anon_sym_DOLLAR] = ACTIONS(10214),
    [anon_sym_COLON2] = ACTIONS(10214),
    [anon_sym_COLON_COLON] = ACTIONS(10214),
    [anon_sym_DASH_GT] = ACTIONS(10198),
    [anon_sym_AT] = ACTIONS(10214),
    [anon_sym_true] = ACTIONS(10214),
    [anon_sym_false] = ACTIONS(10214),
    [aux_sym_integer_literal_token1] = ACTIONS(10214),
    [aux_sym_integer_literal_token2] = ACTIONS(10214),
    [aux_sym_integer_literal_token3] = ACTIONS(10214),
    [aux_sym_integer_literal_token4] = ACTIONS(10214),
    [aux_sym_float_literal_token1] = ACTIONS(10214),
    [aux_sym_float_literal_token3] = ACTIONS(10214),
    [aux_sym_float_literal_token4] = ACTIONS(10214),
    [sym_character_literal] = ACTIONS(10214),
    [anon_sym_DQUOTE] = ACTIONS(10214),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE] = ACTIONS(10214),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10214),
    [sym__pair_operator] = ACTIONS(10214),
    [sym__arrow_operator] = ACTIONS(10214),
    [sym__comparison_operator] = ACTIONS(10214),
    [sym__pipe_right_operator] = ACTIONS(10214),
    [sym__pipe_left_operator] = ACTIONS(10214),
    [sym__ellipsis_operator] = ACTIONS(10214),
    [sym__plus_operator] = ACTIONS(10214),
    [sym__times_operator] = ACTIONS(10214),
    [sym__rational_operator] = ACTIONS(10214),
    [sym__bitshift_operator] = ACTIONS(10214),
    [sym__power_operator] = ACTIONS(10214),
    [sym__tilde_operator] = ACTIONS(10214),
    [sym__type_order_operator] = ACTIONS(10214),
    [sym__unary_operator] = ACTIONS(10214),
    [sym__unary_plus_operator] = ACTIONS(10214),
    [aux_sym__terminator_token1] = ACTIONS(10216),
    [aux_sym__terminator_token2] = ACTIONS(10214),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9424] = {
    [sym_identifier] = STATE(9459),
    [sym_block_comment] = STATE(9424),
    [sym_line_comment] = STATE(9424),
    [sym__word_identifier] = ACTIONS(9784),
    [anon_sym_begin] = ACTIONS(9784),
    [anon_sym_module] = ACTIONS(9784),
    [anon_sym_baremodule] = ACTIONS(9784),
    [anon_sym_end] = ACTIONS(9784),
    [anon_sym_abstract] = ACTIONS(9784),
    [anon_sym_primitive] = ACTIONS(9784),
    [anon_sym_mutable] = ACTIONS(9784),
    [anon_sym_struct] = ACTIONS(9784),
    [anon_sym_function] = ACTIONS(9784),
    [anon_sym_macro] = ACTIONS(9784),
    [anon_sym_quote] = ACTIONS(9784),
    [anon_sym_let] = ACTIONS(9784),
    [anon_sym_if] = ACTIONS(9784),
    [anon_sym_try] = ACTIONS(9784),
    [anon_sym_for] = ACTIONS(9784),
    [anon_sym_while] = ACTIONS(9784),
    [sym_break_statement] = ACTIONS(9784),
    [sym_continue_statement] = ACTIONS(9784),
    [anon_sym_return] = ACTIONS(9784),
    [anon_sym_const] = ACTIONS(9784),
    [anon_sym_global] = ACTIONS(9784),
    [anon_sym_local] = ACTIONS(9784),
    [anon_sym_LPAREN] = ACTIONS(9784),
    [anon_sym_export] = ACTIONS(9784),
    [anon_sym_public] = ACTIONS(9784),
    [anon_sym_import] = ACTIONS(9784),
    [anon_sym_using] = ACTIONS(9784),
    [anon_sym_LBRACK] = ACTIONS(9784),
    [anon_sym_LBRACE] = ACTIONS(9784),
    [anon_sym_DOLLAR] = ACTIONS(9784),
    [anon_sym_COLON2] = ACTIONS(9784),
    [anon_sym_COLON_COLON] = ACTIONS(9784),
    [anon_sym_AT] = ACTIONS(9784),
    [anon_sym_true] = ACTIONS(9784),
    [anon_sym_false] = ACTIONS(9784),
    [aux_sym_integer_literal_token1] = ACTIONS(9784),
    [aux_sym_integer_literal_token2] = ACTIONS(9784),
    [aux_sym_integer_literal_token3] = ACTIONS(9784),
    [aux_sym_integer_literal_token4] = ACTIONS(9784),
    [aux_sym_float_literal_token1] = ACTIONS(9784),
    [aux_sym_float_literal_token3] = ACTIONS(9784),
    [aux_sym_float_literal_token4] = ACTIONS(9784),
    [sym_character_literal] = ACTIONS(9784),
    [anon_sym_DQUOTE] = ACTIONS(9784),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE] = ACTIONS(9784),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9784),
    [sym__pair_operator] = ACTIONS(9784),
    [sym__arrow_operator] = ACTIONS(9784),
    [sym__comparison_operator] = ACTIONS(9784),
    [sym__pipe_right_operator] = ACTIONS(9784),
    [sym__pipe_left_operator] = ACTIONS(9784),
    [sym__ellipsis_operator] = ACTIONS(9784),
    [sym__plus_operator] = ACTIONS(9784),
    [sym__times_operator] = ACTIONS(9784),
    [sym__rational_operator] = ACTIONS(9784),
    [sym__bitshift_operator] = ACTIONS(9784),
    [sym__power_operator] = ACTIONS(9784),
    [sym__tilde_operator] = ACTIONS(9784),
    [sym__type_order_operator] = ACTIONS(9784),
    [sym__unary_operator] = ACTIONS(9784),
    [sym__unary_plus_operator] = ACTIONS(9784),
    [aux_sym__terminator_token1] = ACTIONS(9786),
    [aux_sym__terminator_token2] = ACTIONS(9784),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9425] = {
    [sym_identifier] = STATE(9460),
    [sym_block_comment] = STATE(9425),
    [sym_line_comment] = STATE(9425),
    [sym__word_identifier] = ACTIONS(9796),
    [anon_sym_begin] = ACTIONS(9796),
    [anon_sym_module] = ACTIONS(9796),
    [anon_sym_baremodule] = ACTIONS(9796),
    [anon_sym_end] = ACTIONS(9796),
    [anon_sym_abstract] = ACTIONS(9796),
    [anon_sym_primitive] = ACTIONS(9796),
    [anon_sym_mutable] = ACTIONS(9796),
    [anon_sym_struct] = ACTIONS(9796),
    [anon_sym_function] = ACTIONS(9796),
    [anon_sym_macro] = ACTIONS(9796),
    [anon_sym_quote] = ACTIONS(9796),
    [anon_sym_let] = ACTIONS(9796),
    [anon_sym_if] = ACTIONS(9796),
    [anon_sym_try] = ACTIONS(9796),
    [anon_sym_for] = ACTIONS(9796),
    [anon_sym_while] = ACTIONS(9796),
    [sym_break_statement] = ACTIONS(9796),
    [sym_continue_statement] = ACTIONS(9796),
    [anon_sym_return] = ACTIONS(9796),
    [anon_sym_const] = ACTIONS(9796),
    [anon_sym_global] = ACTIONS(9796),
    [anon_sym_local] = ACTIONS(9796),
    [anon_sym_LPAREN] = ACTIONS(9796),
    [anon_sym_export] = ACTIONS(9796),
    [anon_sym_public] = ACTIONS(9796),
    [anon_sym_import] = ACTIONS(9796),
    [anon_sym_using] = ACTIONS(9796),
    [anon_sym_LBRACK] = ACTIONS(9796),
    [anon_sym_LBRACE] = ACTIONS(9796),
    [anon_sym_DOLLAR] = ACTIONS(9796),
    [anon_sym_COLON2] = ACTIONS(9796),
    [anon_sym_COLON_COLON] = ACTIONS(9796),
    [anon_sym_AT] = ACTIONS(9796),
    [anon_sym_true] = ACTIONS(9796),
    [anon_sym_false] = ACTIONS(9796),
    [aux_sym_integer_literal_token1] = ACTIONS(9796),
    [aux_sym_integer_literal_token2] = ACTIONS(9796),
    [aux_sym_integer_literal_token3] = ACTIONS(9796),
    [aux_sym_integer_literal_token4] = ACTIONS(9796),
    [aux_sym_float_literal_token1] = ACTIONS(9796),
    [aux_sym_float_literal_token3] = ACTIONS(9796),
    [aux_sym_float_literal_token4] = ACTIONS(9796),
    [sym_character_literal] = ACTIONS(9796),
    [anon_sym_DQUOTE] = ACTIONS(9796),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE] = ACTIONS(9796),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9796),
    [sym__pair_operator] = ACTIONS(9796),
    [sym__arrow_operator] = ACTIONS(9796),
    [sym__comparison_operator] = ACTIONS(9796),
    [sym__pipe_right_operator] = ACTIONS(9796),
    [sym__pipe_left_operator] = ACTIONS(9796),
    [sym__ellipsis_operator] = ACTIONS(9796),
    [sym__plus_operator] = ACTIONS(9796),
    [sym__times_operator] = ACTIONS(9796),
    [sym__rational_operator] = ACTIONS(9796),
    [sym__bitshift_operator] = ACTIONS(9796),
    [sym__power_operator] = ACTIONS(9796),
    [sym__tilde_operator] = ACTIONS(9796),
    [sym__type_order_operator] = ACTIONS(9796),
    [sym__unary_operator] = ACTIONS(9796),
    [sym__unary_plus_operator] = ACTIONS(9796),
    [aux_sym__terminator_token1] = ACTIONS(9798),
    [aux_sym__terminator_token2] = ACTIONS(9796),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9426] = {
    [sym_identifier] = STATE(9454),
    [sym_block_comment] = STATE(9426),
    [sym_line_comment] = STATE(9426),
    [sym__word_identifier] = ACTIONS(9780),
    [anon_sym_begin] = ACTIONS(9780),
    [anon_sym_module] = ACTIONS(9780),
    [anon_sym_baremodule] = ACTIONS(9780),
    [anon_sym_end] = ACTIONS(9780),
    [anon_sym_abstract] = ACTIONS(9780),
    [anon_sym_primitive] = ACTIONS(9780),
    [anon_sym_mutable] = ACTIONS(9780),
    [anon_sym_struct] = ACTIONS(9780),
    [anon_sym_function] = ACTIONS(9780),
    [anon_sym_macro] = ACTIONS(9780),
    [anon_sym_quote] = ACTIONS(9780),
    [anon_sym_let] = ACTIONS(9780),
    [anon_sym_if] = ACTIONS(9780),
    [anon_sym_try] = ACTIONS(9780),
    [anon_sym_for] = ACTIONS(9780),
    [anon_sym_while] = ACTIONS(9780),
    [sym_break_statement] = ACTIONS(9780),
    [sym_continue_statement] = ACTIONS(9780),
    [anon_sym_return] = ACTIONS(9780),
    [anon_sym_const] = ACTIONS(9780),
    [anon_sym_global] = ACTIONS(9780),
    [anon_sym_local] = ACTIONS(9780),
    [anon_sym_LPAREN] = ACTIONS(9780),
    [anon_sym_export] = ACTIONS(9780),
    [anon_sym_public] = ACTIONS(9780),
    [anon_sym_import] = ACTIONS(9780),
    [anon_sym_using] = ACTIONS(9780),
    [anon_sym_LBRACK] = ACTIONS(9780),
    [anon_sym_LBRACE] = ACTIONS(9780),
    [anon_sym_DOLLAR] = ACTIONS(9780),
    [anon_sym_COLON2] = ACTIONS(9780),
    [anon_sym_COLON_COLON] = ACTIONS(9780),
    [anon_sym_AT] = ACTIONS(9780),
    [anon_sym_true] = ACTIONS(9780),
    [anon_sym_false] = ACTIONS(9780),
    [aux_sym_integer_literal_token1] = ACTIONS(9780),
    [aux_sym_integer_literal_token2] = ACTIONS(9780),
    [aux_sym_integer_literal_token3] = ACTIONS(9780),
    [aux_sym_integer_literal_token4] = ACTIONS(9780),
    [aux_sym_float_literal_token1] = ACTIONS(9780),
    [aux_sym_float_literal_token3] = ACTIONS(9780),
    [aux_sym_float_literal_token4] = ACTIONS(9780),
    [sym_character_literal] = ACTIONS(9780),
    [anon_sym_DQUOTE] = ACTIONS(9780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE] = ACTIONS(9780),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9780),
    [sym__pair_operator] = ACTIONS(9780),
    [sym__arrow_operator] = ACTIONS(9780),
    [sym__comparison_operator] = ACTIONS(9780),
    [sym__pipe_right_operator] = ACTIONS(9780),
    [sym__pipe_left_operator] = ACTIONS(9780),
    [sym__ellipsis_operator] = ACTIONS(9780),
    [sym__plus_operator] = ACTIONS(9780),
    [sym__times_operator] = ACTIONS(9780),
    [sym__rational_operator] = ACTIONS(9780),
    [sym__bitshift_operator] = ACTIONS(9780),
    [sym__power_operator] = ACTIONS(9780),
    [sym__tilde_operator] = ACTIONS(9780),
    [sym__type_order_operator] = ACTIONS(9780),
    [sym__unary_operator] = ACTIONS(9780),
    [sym__unary_plus_operator] = ACTIONS(9780),
    [aux_sym__terminator_token1] = ACTIONS(9782),
    [aux_sym__terminator_token2] = ACTIONS(9780),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9427] = {
    [sym_block_comment] = STATE(9427),
    [sym_line_comment] = STATE(9427),
    [sym__word_identifier] = ACTIONS(12957),
    [anon_sym_COMMA] = ACTIONS(12957),
    [anon_sym_begin] = ACTIONS(12957),
    [anon_sym_module] = ACTIONS(12957),
    [anon_sym_baremodule] = ACTIONS(12957),
    [anon_sym_end] = ACTIONS(12957),
    [anon_sym_abstract] = ACTIONS(12957),
    [anon_sym_primitive] = ACTIONS(12957),
    [anon_sym_mutable] = ACTIONS(12957),
    [anon_sym_struct] = ACTIONS(12957),
    [anon_sym_function] = ACTIONS(12957),
    [anon_sym_macro] = ACTIONS(12957),
    [anon_sym_quote] = ACTIONS(12957),
    [anon_sym_let] = ACTIONS(12957),
    [anon_sym_if] = ACTIONS(12957),
    [anon_sym_try] = ACTIONS(12957),
    [anon_sym_for] = ACTIONS(12957),
    [anon_sym_while] = ACTIONS(12957),
    [sym_break_statement] = ACTIONS(12957),
    [sym_continue_statement] = ACTIONS(12957),
    [anon_sym_return] = ACTIONS(12957),
    [anon_sym_const] = ACTIONS(12957),
    [anon_sym_global] = ACTIONS(12957),
    [anon_sym_local] = ACTIONS(12957),
    [anon_sym_LPAREN] = ACTIONS(12957),
    [anon_sym_export] = ACTIONS(12957),
    [anon_sym_public] = ACTIONS(12957),
    [anon_sym_import] = ACTIONS(12957),
    [anon_sym_using] = ACTIONS(12957),
    [anon_sym_LBRACK] = ACTIONS(12957),
    [anon_sym_LBRACE] = ACTIONS(12957),
    [anon_sym_DOLLAR] = ACTIONS(12957),
    [anon_sym_COLON2] = ACTIONS(12957),
    [anon_sym_COLON_COLON] = ACTIONS(12957),
    [anon_sym_AT] = ACTIONS(12957),
    [anon_sym_true] = ACTIONS(12957),
    [anon_sym_false] = ACTIONS(12957),
    [aux_sym_integer_literal_token1] = ACTIONS(12957),
    [aux_sym_integer_literal_token2] = ACTIONS(12957),
    [aux_sym_integer_literal_token3] = ACTIONS(12957),
    [aux_sym_integer_literal_token4] = ACTIONS(12957),
    [aux_sym_float_literal_token1] = ACTIONS(12957),
    [aux_sym_float_literal_token3] = ACTIONS(12957),
    [aux_sym_float_literal_token4] = ACTIONS(12957),
    [sym_character_literal] = ACTIONS(12957),
    [anon_sym_DQUOTE] = ACTIONS(12957),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12957),
    [anon_sym_BQUOTE] = ACTIONS(12957),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12957),
    [sym__pair_operator] = ACTIONS(12957),
    [sym__arrow_operator] = ACTIONS(12957),
    [sym__comparison_operator] = ACTIONS(12957),
    [sym__pipe_right_operator] = ACTIONS(12957),
    [sym__pipe_left_operator] = ACTIONS(12957),
    [sym__ellipsis_operator] = ACTIONS(12957),
    [sym__plus_operator] = ACTIONS(12957),
    [sym__times_operator] = ACTIONS(12957),
    [sym__rational_operator] = ACTIONS(12957),
    [sym__bitshift_operator] = ACTIONS(12957),
    [sym__power_operator] = ACTIONS(12957),
    [sym__tilde_operator] = ACTIONS(12957),
    [sym__type_order_operator] = ACTIONS(12957),
    [sym__unary_operator] = ACTIONS(12957),
    [sym__unary_plus_operator] = ACTIONS(12957),
    [aux_sym__terminator_token1] = ACTIONS(12962),
    [aux_sym__terminator_token2] = ACTIONS(12957),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9428] = {
    [sym_block_comment] = STATE(9428),
    [sym_line_comment] = STATE(9428),
    [sym__word_identifier] = ACTIONS(11287),
    [anon_sym_COMMA] = ACTIONS(11287),
    [anon_sym_begin] = ACTIONS(11287),
    [anon_sym_module] = ACTIONS(11287),
    [anon_sym_baremodule] = ACTIONS(11287),
    [anon_sym_abstract] = ACTIONS(11287),
    [anon_sym_primitive] = ACTIONS(11287),
    [anon_sym_mutable] = ACTIONS(11287),
    [anon_sym_struct] = ACTIONS(11287),
    [anon_sym_function] = ACTIONS(11287),
    [anon_sym_macro] = ACTIONS(11287),
    [anon_sym_quote] = ACTIONS(11287),
    [anon_sym_let] = ACTIONS(11287),
    [anon_sym_if] = ACTIONS(11287),
    [anon_sym_try] = ACTIONS(11287),
    [anon_sym_for] = ACTIONS(11287),
    [anon_sym_while] = ACTIONS(11287),
    [sym_break_statement] = ACTIONS(11287),
    [sym_continue_statement] = ACTIONS(11287),
    [anon_sym_return] = ACTIONS(11287),
    [anon_sym_const] = ACTIONS(11287),
    [anon_sym_global] = ACTIONS(11287),
    [anon_sym_local] = ACTIONS(11287),
    [anon_sym_LPAREN] = ACTIONS(11287),
    [anon_sym_export] = ACTIONS(11287),
    [anon_sym_public] = ACTIONS(11287),
    [anon_sym_import] = ACTIONS(11287),
    [anon_sym_using] = ACTIONS(11287),
    [anon_sym_LBRACK] = ACTIONS(11287),
    [anon_sym_RBRACK] = ACTIONS(11287),
    [anon_sym_LBRACE] = ACTIONS(11287),
    [anon_sym_DOLLAR] = ACTIONS(11287),
    [anon_sym_COLON2] = ACTIONS(11287),
    [anon_sym_COLON_COLON] = ACTIONS(11287),
    [anon_sym_AT] = ACTIONS(11287),
    [anon_sym_true] = ACTIONS(11287),
    [anon_sym_false] = ACTIONS(11287),
    [aux_sym_integer_literal_token1] = ACTIONS(11287),
    [aux_sym_integer_literal_token2] = ACTIONS(11287),
    [aux_sym_integer_literal_token3] = ACTIONS(11287),
    [aux_sym_integer_literal_token4] = ACTIONS(11287),
    [aux_sym_float_literal_token1] = ACTIONS(11287),
    [aux_sym_float_literal_token3] = ACTIONS(11287),
    [aux_sym_float_literal_token4] = ACTIONS(11287),
    [sym_character_literal] = ACTIONS(11287),
    [anon_sym_DQUOTE] = ACTIONS(11287),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE] = ACTIONS(11287),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11287),
    [sym__pair_operator] = ACTIONS(11287),
    [sym__arrow_operator] = ACTIONS(11287),
    [sym__comparison_operator] = ACTIONS(11287),
    [sym__pipe_right_operator] = ACTIONS(11287),
    [sym__pipe_left_operator] = ACTIONS(11287),
    [sym__ellipsis_operator] = ACTIONS(11287),
    [sym__plus_operator] = ACTIONS(11287),
    [sym__times_operator] = ACTIONS(11287),
    [sym__rational_operator] = ACTIONS(11287),
    [sym__bitshift_operator] = ACTIONS(11287),
    [sym__power_operator] = ACTIONS(11287),
    [sym__tilde_operator] = ACTIONS(11287),
    [sym__type_order_operator] = ACTIONS(11287),
    [sym__unary_operator] = ACTIONS(11287),
    [sym__unary_plus_operator] = ACTIONS(11287),
    [aux_sym__terminator_token1] = ACTIONS(11289),
    [aux_sym__terminator_token2] = ACTIONS(11287),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9429] = {
    [sym_block_comment] = STATE(9429),
    [sym_line_comment] = STATE(9429),
    [sym__word_identifier] = ACTIONS(9738),
    [anon_sym_begin] = ACTIONS(9738),
    [anon_sym_module] = ACTIONS(9738),
    [anon_sym_baremodule] = ACTIONS(9738),
    [anon_sym_end] = ACTIONS(9738),
    [anon_sym_abstract] = ACTIONS(9738),
    [anon_sym_primitive] = ACTIONS(9738),
    [anon_sym_mutable] = ACTIONS(9738),
    [anon_sym_struct] = ACTIONS(9738),
    [anon_sym_function] = ACTIONS(9738),
    [anon_sym_macro] = ACTIONS(9738),
    [anon_sym_quote] = ACTIONS(9738),
    [anon_sym_let] = ACTIONS(9738),
    [anon_sym_if] = ACTIONS(9738),
    [anon_sym_try] = ACTIONS(9738),
    [anon_sym_for] = ACTIONS(9738),
    [anon_sym_while] = ACTIONS(9738),
    [sym_break_statement] = ACTIONS(9738),
    [sym_continue_statement] = ACTIONS(9738),
    [anon_sym_return] = ACTIONS(9738),
    [anon_sym_const] = ACTIONS(9738),
    [anon_sym_global] = ACTIONS(9738),
    [anon_sym_local] = ACTIONS(9738),
    [anon_sym_LPAREN] = ACTIONS(9738),
    [anon_sym_export] = ACTIONS(9738),
    [anon_sym_public] = ACTIONS(9738),
    [anon_sym_import] = ACTIONS(9738),
    [anon_sym_using] = ACTIONS(9738),
    [anon_sym_LBRACK] = ACTIONS(9738),
    [anon_sym_LBRACE] = ACTIONS(9738),
    [anon_sym_DOLLAR] = ACTIONS(9738),
    [anon_sym_COLON2] = ACTIONS(9738),
    [anon_sym_COLON_COLON] = ACTIONS(9738),
    [anon_sym_DASH_GT] = ACTIONS(9738),
    [anon_sym_AT] = ACTIONS(9738),
    [anon_sym_true] = ACTIONS(9738),
    [anon_sym_false] = ACTIONS(9738),
    [aux_sym_integer_literal_token1] = ACTIONS(9738),
    [aux_sym_integer_literal_token2] = ACTIONS(9738),
    [aux_sym_integer_literal_token3] = ACTIONS(9738),
    [aux_sym_integer_literal_token4] = ACTIONS(9738),
    [aux_sym_float_literal_token1] = ACTIONS(9738),
    [aux_sym_float_literal_token3] = ACTIONS(9738),
    [aux_sym_float_literal_token4] = ACTIONS(9738),
    [sym_character_literal] = ACTIONS(9738),
    [anon_sym_DQUOTE] = ACTIONS(9738),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE] = ACTIONS(9738),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9738),
    [sym__pair_operator] = ACTIONS(9738),
    [sym__arrow_operator] = ACTIONS(9738),
    [sym__comparison_operator] = ACTIONS(9738),
    [sym__pipe_right_operator] = ACTIONS(9738),
    [sym__pipe_left_operator] = ACTIONS(9738),
    [sym__ellipsis_operator] = ACTIONS(9738),
    [sym__plus_operator] = ACTIONS(9738),
    [sym__times_operator] = ACTIONS(9738),
    [sym__rational_operator] = ACTIONS(9738),
    [sym__bitshift_operator] = ACTIONS(9738),
    [sym__power_operator] = ACTIONS(9738),
    [sym__tilde_operator] = ACTIONS(9738),
    [sym__type_order_operator] = ACTIONS(9738),
    [sym__unary_operator] = ACTIONS(9738),
    [sym__unary_plus_operator] = ACTIONS(9738),
    [aux_sym__terminator_token1] = ACTIONS(9806),
    [aux_sym__terminator_token2] = ACTIONS(9738),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9430] = {
    [sym_block_comment] = STATE(9430),
    [sym_line_comment] = STATE(9430),
    [sym__word_identifier] = ACTIONS(9818),
    [anon_sym_begin] = ACTIONS(9818),
    [anon_sym_module] = ACTIONS(9818),
    [anon_sym_baremodule] = ACTIONS(9818),
    [anon_sym_end] = ACTIONS(9818),
    [anon_sym_abstract] = ACTIONS(9818),
    [anon_sym_primitive] = ACTIONS(9818),
    [anon_sym_mutable] = ACTIONS(9818),
    [anon_sym_struct] = ACTIONS(9818),
    [anon_sym_function] = ACTIONS(9818),
    [anon_sym_macro] = ACTIONS(9818),
    [anon_sym_quote] = ACTIONS(9818),
    [anon_sym_let] = ACTIONS(9818),
    [anon_sym_if] = ACTIONS(9818),
    [anon_sym_try] = ACTIONS(9818),
    [anon_sym_for] = ACTIONS(9818),
    [anon_sym_while] = ACTIONS(9818),
    [sym_break_statement] = ACTIONS(9818),
    [sym_continue_statement] = ACTIONS(9818),
    [anon_sym_return] = ACTIONS(9818),
    [anon_sym_const] = ACTIONS(9818),
    [anon_sym_global] = ACTIONS(9818),
    [anon_sym_local] = ACTIONS(9818),
    [anon_sym_LPAREN] = ACTIONS(9818),
    [anon_sym_export] = ACTIONS(9818),
    [anon_sym_public] = ACTIONS(9818),
    [anon_sym_import] = ACTIONS(9818),
    [anon_sym_using] = ACTIONS(9818),
    [anon_sym_LBRACK] = ACTIONS(9818),
    [anon_sym_LBRACE] = ACTIONS(9818),
    [anon_sym_DOLLAR] = ACTIONS(9818),
    [anon_sym_COLON2] = ACTIONS(9818),
    [anon_sym_COLON_COLON] = ACTIONS(9818),
    [anon_sym_DASH_GT] = ACTIONS(9818),
    [anon_sym_AT] = ACTIONS(9818),
    [anon_sym_true] = ACTIONS(9818),
    [anon_sym_false] = ACTIONS(9818),
    [aux_sym_integer_literal_token1] = ACTIONS(9818),
    [aux_sym_integer_literal_token2] = ACTIONS(9818),
    [aux_sym_integer_literal_token3] = ACTIONS(9818),
    [aux_sym_integer_literal_token4] = ACTIONS(9818),
    [aux_sym_float_literal_token1] = ACTIONS(9818),
    [aux_sym_float_literal_token3] = ACTIONS(9818),
    [aux_sym_float_literal_token4] = ACTIONS(9818),
    [sym_character_literal] = ACTIONS(9818),
    [anon_sym_DQUOTE] = ACTIONS(9818),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE] = ACTIONS(9818),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9818),
    [sym__pair_operator] = ACTIONS(9818),
    [sym__arrow_operator] = ACTIONS(9818),
    [sym__comparison_operator] = ACTIONS(9818),
    [sym__pipe_right_operator] = ACTIONS(9818),
    [sym__pipe_left_operator] = ACTIONS(9818),
    [sym__ellipsis_operator] = ACTIONS(9818),
    [sym__plus_operator] = ACTIONS(9818),
    [sym__times_operator] = ACTIONS(9818),
    [sym__rational_operator] = ACTIONS(9818),
    [sym__bitshift_operator] = ACTIONS(9818),
    [sym__power_operator] = ACTIONS(9818),
    [sym__tilde_operator] = ACTIONS(9818),
    [sym__type_order_operator] = ACTIONS(9818),
    [sym__unary_operator] = ACTIONS(9818),
    [sym__unary_plus_operator] = ACTIONS(9818),
    [aux_sym__terminator_token1] = ACTIONS(9820),
    [aux_sym__terminator_token2] = ACTIONS(9818),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9431] = {
    [sym_block_comment] = STATE(9431),
    [sym_line_comment] = STATE(9431),
    [sym__word_identifier] = ACTIONS(9828),
    [anon_sym_begin] = ACTIONS(9828),
    [anon_sym_module] = ACTIONS(9828),
    [anon_sym_baremodule] = ACTIONS(9828),
    [anon_sym_end] = ACTIONS(9828),
    [anon_sym_abstract] = ACTIONS(9828),
    [anon_sym_primitive] = ACTIONS(9828),
    [anon_sym_mutable] = ACTIONS(9828),
    [anon_sym_struct] = ACTIONS(9828),
    [anon_sym_function] = ACTIONS(9828),
    [anon_sym_macro] = ACTIONS(9828),
    [anon_sym_quote] = ACTIONS(9828),
    [anon_sym_let] = ACTIONS(9828),
    [anon_sym_if] = ACTIONS(9828),
    [anon_sym_try] = ACTIONS(9828),
    [anon_sym_for] = ACTIONS(9828),
    [anon_sym_while] = ACTIONS(9828),
    [sym_break_statement] = ACTIONS(9828),
    [sym_continue_statement] = ACTIONS(9828),
    [anon_sym_return] = ACTIONS(9828),
    [anon_sym_const] = ACTIONS(9828),
    [anon_sym_global] = ACTIONS(9828),
    [anon_sym_local] = ACTIONS(9828),
    [anon_sym_LPAREN] = ACTIONS(9828),
    [anon_sym_export] = ACTIONS(9828),
    [anon_sym_public] = ACTIONS(9828),
    [anon_sym_import] = ACTIONS(9828),
    [anon_sym_using] = ACTIONS(9828),
    [anon_sym_LBRACK] = ACTIONS(9828),
    [anon_sym_LBRACE] = ACTIONS(9828),
    [anon_sym_DOLLAR] = ACTIONS(9828),
    [anon_sym_COLON2] = ACTIONS(9828),
    [anon_sym_COLON_COLON] = ACTIONS(9828),
    [anon_sym_DASH_GT] = ACTIONS(9828),
    [anon_sym_AT] = ACTIONS(9828),
    [anon_sym_true] = ACTIONS(9828),
    [anon_sym_false] = ACTIONS(9828),
    [aux_sym_integer_literal_token1] = ACTIONS(9828),
    [aux_sym_integer_literal_token2] = ACTIONS(9828),
    [aux_sym_integer_literal_token3] = ACTIONS(9828),
    [aux_sym_integer_literal_token4] = ACTIONS(9828),
    [aux_sym_float_literal_token1] = ACTIONS(9828),
    [aux_sym_float_literal_token3] = ACTIONS(9828),
    [aux_sym_float_literal_token4] = ACTIONS(9828),
    [sym_character_literal] = ACTIONS(9828),
    [anon_sym_DQUOTE] = ACTIONS(9828),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE] = ACTIONS(9828),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9828),
    [sym__pair_operator] = ACTIONS(9828),
    [sym__arrow_operator] = ACTIONS(9828),
    [sym__comparison_operator] = ACTIONS(9828),
    [sym__pipe_right_operator] = ACTIONS(9828),
    [sym__pipe_left_operator] = ACTIONS(9828),
    [sym__ellipsis_operator] = ACTIONS(9828),
    [sym__plus_operator] = ACTIONS(9828),
    [sym__times_operator] = ACTIONS(9828),
    [sym__rational_operator] = ACTIONS(9828),
    [sym__bitshift_operator] = ACTIONS(9828),
    [sym__power_operator] = ACTIONS(9828),
    [sym__tilde_operator] = ACTIONS(9828),
    [sym__type_order_operator] = ACTIONS(9828),
    [sym__unary_operator] = ACTIONS(9828),
    [sym__unary_plus_operator] = ACTIONS(9828),
    [aux_sym__terminator_token1] = ACTIONS(9830),
    [aux_sym__terminator_token2] = ACTIONS(9828),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9432] = {
    [sym_block_comment] = STATE(9432),
    [sym_line_comment] = STATE(9432),
    [sym__word_identifier] = ACTIONS(9742),
    [anon_sym_begin] = ACTIONS(9742),
    [anon_sym_module] = ACTIONS(9742),
    [anon_sym_baremodule] = ACTIONS(9742),
    [anon_sym_end] = ACTIONS(9742),
    [anon_sym_abstract] = ACTIONS(9742),
    [anon_sym_primitive] = ACTIONS(9742),
    [anon_sym_mutable] = ACTIONS(9742),
    [anon_sym_struct] = ACTIONS(9742),
    [anon_sym_function] = ACTIONS(9742),
    [anon_sym_macro] = ACTIONS(9742),
    [anon_sym_quote] = ACTIONS(9742),
    [anon_sym_let] = ACTIONS(9742),
    [anon_sym_if] = ACTIONS(9742),
    [anon_sym_try] = ACTIONS(9742),
    [anon_sym_for] = ACTIONS(9742),
    [anon_sym_while] = ACTIONS(9742),
    [sym_break_statement] = ACTIONS(9742),
    [sym_continue_statement] = ACTIONS(9742),
    [anon_sym_return] = ACTIONS(9742),
    [anon_sym_const] = ACTIONS(9742),
    [anon_sym_global] = ACTIONS(9742),
    [anon_sym_local] = ACTIONS(9742),
    [anon_sym_LPAREN] = ACTIONS(9742),
    [anon_sym_export] = ACTIONS(9742),
    [anon_sym_public] = ACTIONS(9742),
    [anon_sym_import] = ACTIONS(9742),
    [anon_sym_using] = ACTIONS(9742),
    [anon_sym_LBRACK] = ACTIONS(9742),
    [anon_sym_LBRACE] = ACTIONS(9742),
    [anon_sym_DOLLAR] = ACTIONS(9742),
    [anon_sym_COLON2] = ACTIONS(9742),
    [anon_sym_COLON_COLON] = ACTIONS(9742),
    [anon_sym_AT] = ACTIONS(9742),
    [anon_sym_true] = ACTIONS(9742),
    [anon_sym_false] = ACTIONS(9742),
    [aux_sym_integer_literal_token1] = ACTIONS(9742),
    [aux_sym_integer_literal_token2] = ACTIONS(9742),
    [aux_sym_integer_literal_token3] = ACTIONS(9742),
    [aux_sym_integer_literal_token4] = ACTIONS(9742),
    [aux_sym_float_literal_token1] = ACTIONS(9742),
    [aux_sym_float_literal_token3] = ACTIONS(9742),
    [aux_sym_float_literal_token4] = ACTIONS(9742),
    [sym_character_literal] = ACTIONS(9742),
    [anon_sym_DQUOTE] = ACTIONS(9742),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE] = ACTIONS(9742),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9742),
    [sym__pair_operator] = ACTIONS(9742),
    [sym__arrow_operator] = ACTIONS(9742),
    [sym__comparison_operator] = ACTIONS(9742),
    [sym__pipe_right_operator] = ACTIONS(9742),
    [sym__pipe_left_operator] = ACTIONS(9742),
    [sym__ellipsis_operator] = ACTIONS(9742),
    [sym__plus_operator] = ACTIONS(9742),
    [sym__times_operator] = ACTIONS(9742),
    [sym__rational_operator] = ACTIONS(9742),
    [sym__bitshift_operator] = ACTIONS(9742),
    [sym__power_operator] = ACTIONS(9742),
    [sym__tilde_operator] = ACTIONS(9742),
    [sym__type_order_operator] = ACTIONS(9742),
    [sym__unary_operator] = ACTIONS(9742),
    [sym__unary_plus_operator] = ACTIONS(9742),
    [aux_sym__terminator_token1] = ACTIONS(9746),
    [aux_sym__terminator_token2] = ACTIONS(9742),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9433] = {
    [sym_block_comment] = STATE(9433),
    [sym_line_comment] = STATE(9433),
    [sym__word_identifier] = ACTIONS(10014),
    [anon_sym_begin] = ACTIONS(10014),
    [anon_sym_module] = ACTIONS(10014),
    [anon_sym_baremodule] = ACTIONS(10014),
    [anon_sym_end] = ACTIONS(10014),
    [anon_sym_abstract] = ACTIONS(10014),
    [anon_sym_primitive] = ACTIONS(10014),
    [anon_sym_mutable] = ACTIONS(10014),
    [anon_sym_struct] = ACTIONS(10014),
    [anon_sym_function] = ACTIONS(10014),
    [anon_sym_macro] = ACTIONS(10014),
    [anon_sym_quote] = ACTIONS(10014),
    [anon_sym_let] = ACTIONS(10014),
    [anon_sym_if] = ACTIONS(10014),
    [anon_sym_try] = ACTIONS(10014),
    [anon_sym_for] = ACTIONS(10014),
    [anon_sym_while] = ACTIONS(10014),
    [sym_break_statement] = ACTIONS(10014),
    [sym_continue_statement] = ACTIONS(10014),
    [anon_sym_return] = ACTIONS(10014),
    [anon_sym_const] = ACTIONS(10014),
    [anon_sym_global] = ACTIONS(10014),
    [anon_sym_local] = ACTIONS(10014),
    [anon_sym_LPAREN] = ACTIONS(10014),
    [anon_sym_export] = ACTIONS(10014),
    [anon_sym_public] = ACTIONS(10014),
    [anon_sym_import] = ACTIONS(10014),
    [anon_sym_using] = ACTIONS(10014),
    [anon_sym_LBRACK] = ACTIONS(10014),
    [anon_sym_LBRACE] = ACTIONS(10014),
    [anon_sym_DOLLAR] = ACTIONS(10014),
    [anon_sym_COLON2] = ACTIONS(10014),
    [anon_sym_COLON_COLON] = ACTIONS(10014),
    [anon_sym_AT] = ACTIONS(10014),
    [anon_sym_true] = ACTIONS(10014),
    [anon_sym_false] = ACTIONS(10014),
    [aux_sym_integer_literal_token1] = ACTIONS(10014),
    [aux_sym_integer_literal_token2] = ACTIONS(10014),
    [aux_sym_integer_literal_token3] = ACTIONS(10014),
    [aux_sym_integer_literal_token4] = ACTIONS(10014),
    [aux_sym_float_literal_token1] = ACTIONS(10014),
    [aux_sym_float_literal_token3] = ACTIONS(10014),
    [aux_sym_float_literal_token4] = ACTIONS(10014),
    [sym_character_literal] = ACTIONS(10014),
    [anon_sym_DQUOTE] = ACTIONS(10014),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE] = ACTIONS(10014),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10014),
    [sym__pair_operator] = ACTIONS(10014),
    [sym__arrow_operator] = ACTIONS(10014),
    [sym__comparison_operator] = ACTIONS(10014),
    [sym__pipe_right_operator] = ACTIONS(10014),
    [sym__pipe_left_operator] = ACTIONS(10014),
    [sym__ellipsis_operator] = ACTIONS(10014),
    [sym__plus_operator] = ACTIONS(10014),
    [sym__times_operator] = ACTIONS(10014),
    [sym__rational_operator] = ACTIONS(10014),
    [sym__bitshift_operator] = ACTIONS(10014),
    [sym__power_operator] = ACTIONS(10014),
    [sym__tilde_operator] = ACTIONS(10014),
    [sym__type_order_operator] = ACTIONS(10014),
    [sym__unary_operator] = ACTIONS(10014),
    [sym__unary_plus_operator] = ACTIONS(10014),
    [aux_sym__terminator_token1] = ACTIONS(10016),
    [aux_sym__terminator_token2] = ACTIONS(10014),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9434] = {
    [sym_block_comment] = STATE(9434),
    [sym_line_comment] = STATE(9434),
    [sym__word_identifier] = ACTIONS(9990),
    [anon_sym_begin] = ACTIONS(9990),
    [anon_sym_module] = ACTIONS(9990),
    [anon_sym_baremodule] = ACTIONS(9990),
    [anon_sym_end] = ACTIONS(9990),
    [anon_sym_abstract] = ACTIONS(9990),
    [anon_sym_primitive] = ACTIONS(9990),
    [anon_sym_mutable] = ACTIONS(9990),
    [anon_sym_struct] = ACTIONS(9990),
    [anon_sym_function] = ACTIONS(9990),
    [anon_sym_macro] = ACTIONS(9990),
    [anon_sym_quote] = ACTIONS(9990),
    [anon_sym_let] = ACTIONS(9990),
    [anon_sym_if] = ACTIONS(9990),
    [anon_sym_try] = ACTIONS(9990),
    [anon_sym_for] = ACTIONS(9990),
    [anon_sym_while] = ACTIONS(9990),
    [sym_break_statement] = ACTIONS(9990),
    [sym_continue_statement] = ACTIONS(9990),
    [anon_sym_return] = ACTIONS(9990),
    [anon_sym_const] = ACTIONS(9990),
    [anon_sym_global] = ACTIONS(9990),
    [anon_sym_local] = ACTIONS(9990),
    [anon_sym_LPAREN] = ACTIONS(9990),
    [anon_sym_export] = ACTIONS(9990),
    [anon_sym_public] = ACTIONS(9990),
    [anon_sym_import] = ACTIONS(9990),
    [anon_sym_using] = ACTIONS(9990),
    [anon_sym_LBRACK] = ACTIONS(9990),
    [anon_sym_LBRACE] = ACTIONS(9990),
    [anon_sym_DOLLAR] = ACTIONS(9990),
    [anon_sym_COLON2] = ACTIONS(9990),
    [anon_sym_COLON_COLON] = ACTIONS(9990),
    [anon_sym_AT] = ACTIONS(9990),
    [anon_sym_true] = ACTIONS(9990),
    [anon_sym_false] = ACTIONS(9990),
    [aux_sym_integer_literal_token1] = ACTIONS(9990),
    [aux_sym_integer_literal_token2] = ACTIONS(9990),
    [aux_sym_integer_literal_token3] = ACTIONS(9990),
    [aux_sym_integer_literal_token4] = ACTIONS(9990),
    [aux_sym_float_literal_token1] = ACTIONS(9990),
    [aux_sym_float_literal_token3] = ACTIONS(9990),
    [aux_sym_float_literal_token4] = ACTIONS(9990),
    [sym_character_literal] = ACTIONS(9990),
    [anon_sym_DQUOTE] = ACTIONS(9990),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE] = ACTIONS(9990),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9990),
    [sym__pair_operator] = ACTIONS(9990),
    [sym__arrow_operator] = ACTIONS(9990),
    [sym__comparison_operator] = ACTIONS(9990),
    [sym__pipe_right_operator] = ACTIONS(9990),
    [sym__pipe_left_operator] = ACTIONS(9990),
    [sym__ellipsis_operator] = ACTIONS(9990),
    [sym__plus_operator] = ACTIONS(9990),
    [sym__times_operator] = ACTIONS(9990),
    [sym__rational_operator] = ACTIONS(9990),
    [sym__bitshift_operator] = ACTIONS(9990),
    [sym__power_operator] = ACTIONS(9990),
    [sym__tilde_operator] = ACTIONS(9990),
    [sym__type_order_operator] = ACTIONS(9990),
    [sym__unary_operator] = ACTIONS(9990),
    [sym__unary_plus_operator] = ACTIONS(9990),
    [aux_sym__terminator_token1] = ACTIONS(9992),
    [aux_sym__terminator_token2] = ACTIONS(9990),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9435] = {
    [sym_block_comment] = STATE(9435),
    [sym_line_comment] = STATE(9435),
    [sym__word_identifier] = ACTIONS(10000),
    [anon_sym_begin] = ACTIONS(10000),
    [anon_sym_module] = ACTIONS(10000),
    [anon_sym_baremodule] = ACTIONS(10000),
    [anon_sym_end] = ACTIONS(10000),
    [anon_sym_abstract] = ACTIONS(10000),
    [anon_sym_primitive] = ACTIONS(10000),
    [anon_sym_mutable] = ACTIONS(10000),
    [anon_sym_struct] = ACTIONS(10000),
    [anon_sym_function] = ACTIONS(10000),
    [anon_sym_macro] = ACTIONS(10000),
    [anon_sym_quote] = ACTIONS(10000),
    [anon_sym_let] = ACTIONS(10000),
    [anon_sym_if] = ACTIONS(10000),
    [anon_sym_try] = ACTIONS(10000),
    [anon_sym_for] = ACTIONS(10000),
    [anon_sym_while] = ACTIONS(10000),
    [sym_break_statement] = ACTIONS(10000),
    [sym_continue_statement] = ACTIONS(10000),
    [anon_sym_return] = ACTIONS(10000),
    [anon_sym_const] = ACTIONS(10000),
    [anon_sym_global] = ACTIONS(10000),
    [anon_sym_local] = ACTIONS(10000),
    [anon_sym_LPAREN] = ACTIONS(10000),
    [anon_sym_export] = ACTIONS(10000),
    [anon_sym_public] = ACTIONS(10000),
    [anon_sym_import] = ACTIONS(10000),
    [anon_sym_using] = ACTIONS(10000),
    [anon_sym_LBRACK] = ACTIONS(10000),
    [anon_sym_LBRACE] = ACTIONS(10000),
    [anon_sym_DOLLAR] = ACTIONS(10000),
    [anon_sym_COLON2] = ACTIONS(10000),
    [anon_sym_COLON_COLON] = ACTIONS(10000),
    [anon_sym_AT] = ACTIONS(10000),
    [anon_sym_true] = ACTIONS(10000),
    [anon_sym_false] = ACTIONS(10000),
    [aux_sym_integer_literal_token1] = ACTIONS(10000),
    [aux_sym_integer_literal_token2] = ACTIONS(10000),
    [aux_sym_integer_literal_token3] = ACTIONS(10000),
    [aux_sym_integer_literal_token4] = ACTIONS(10000),
    [aux_sym_float_literal_token1] = ACTIONS(10000),
    [aux_sym_float_literal_token3] = ACTIONS(10000),
    [aux_sym_float_literal_token4] = ACTIONS(10000),
    [sym_character_literal] = ACTIONS(10000),
    [anon_sym_DQUOTE] = ACTIONS(10000),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE] = ACTIONS(10000),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10000),
    [sym__pair_operator] = ACTIONS(10000),
    [sym__arrow_operator] = ACTIONS(10000),
    [sym__comparison_operator] = ACTIONS(10000),
    [sym__pipe_right_operator] = ACTIONS(10000),
    [sym__pipe_left_operator] = ACTIONS(10000),
    [sym__ellipsis_operator] = ACTIONS(10000),
    [sym__plus_operator] = ACTIONS(10000),
    [sym__times_operator] = ACTIONS(10000),
    [sym__rational_operator] = ACTIONS(10000),
    [sym__bitshift_operator] = ACTIONS(10000),
    [sym__power_operator] = ACTIONS(10000),
    [sym__tilde_operator] = ACTIONS(10000),
    [sym__type_order_operator] = ACTIONS(10000),
    [sym__unary_operator] = ACTIONS(10000),
    [sym__unary_plus_operator] = ACTIONS(10000),
    [aux_sym__terminator_token1] = ACTIONS(10002),
    [aux_sym__terminator_token2] = ACTIONS(10000),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9436] = {
    [sym_block_comment] = STATE(9436),
    [sym_line_comment] = STATE(9436),
    [sym__word_identifier] = ACTIONS(10004),
    [anon_sym_begin] = ACTIONS(10004),
    [anon_sym_module] = ACTIONS(10004),
    [anon_sym_baremodule] = ACTIONS(10004),
    [anon_sym_end] = ACTIONS(10004),
    [anon_sym_abstract] = ACTIONS(10004),
    [anon_sym_primitive] = ACTIONS(10004),
    [anon_sym_mutable] = ACTIONS(10004),
    [anon_sym_struct] = ACTIONS(10004),
    [anon_sym_function] = ACTIONS(10004),
    [anon_sym_macro] = ACTIONS(10004),
    [anon_sym_quote] = ACTIONS(10004),
    [anon_sym_let] = ACTIONS(10004),
    [anon_sym_if] = ACTIONS(10004),
    [anon_sym_try] = ACTIONS(10004),
    [anon_sym_for] = ACTIONS(10004),
    [anon_sym_while] = ACTIONS(10004),
    [sym_break_statement] = ACTIONS(10004),
    [sym_continue_statement] = ACTIONS(10004),
    [anon_sym_return] = ACTIONS(10004),
    [anon_sym_const] = ACTIONS(10004),
    [anon_sym_global] = ACTIONS(10004),
    [anon_sym_local] = ACTIONS(10004),
    [anon_sym_LPAREN] = ACTIONS(10004),
    [anon_sym_export] = ACTIONS(10004),
    [anon_sym_public] = ACTIONS(10004),
    [anon_sym_import] = ACTIONS(10004),
    [anon_sym_using] = ACTIONS(10004),
    [anon_sym_LBRACK] = ACTIONS(10004),
    [anon_sym_LBRACE] = ACTIONS(10004),
    [anon_sym_DOLLAR] = ACTIONS(10004),
    [anon_sym_COLON2] = ACTIONS(10004),
    [anon_sym_COLON_COLON] = ACTIONS(10004),
    [anon_sym_AT] = ACTIONS(10004),
    [anon_sym_true] = ACTIONS(10004),
    [anon_sym_false] = ACTIONS(10004),
    [aux_sym_integer_literal_token1] = ACTIONS(10004),
    [aux_sym_integer_literal_token2] = ACTIONS(10004),
    [aux_sym_integer_literal_token3] = ACTIONS(10004),
    [aux_sym_integer_literal_token4] = ACTIONS(10004),
    [aux_sym_float_literal_token1] = ACTIONS(10004),
    [aux_sym_float_literal_token3] = ACTIONS(10004),
    [aux_sym_float_literal_token4] = ACTIONS(10004),
    [sym_character_literal] = ACTIONS(10004),
    [anon_sym_DQUOTE] = ACTIONS(10004),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE] = ACTIONS(10004),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10004),
    [sym__pair_operator] = ACTIONS(10004),
    [sym__arrow_operator] = ACTIONS(10004),
    [sym__comparison_operator] = ACTIONS(10004),
    [sym__pipe_right_operator] = ACTIONS(10004),
    [sym__pipe_left_operator] = ACTIONS(10004),
    [sym__ellipsis_operator] = ACTIONS(10004),
    [sym__plus_operator] = ACTIONS(10004),
    [sym__times_operator] = ACTIONS(10004),
    [sym__rational_operator] = ACTIONS(10004),
    [sym__bitshift_operator] = ACTIONS(10004),
    [sym__power_operator] = ACTIONS(10004),
    [sym__tilde_operator] = ACTIONS(10004),
    [sym__type_order_operator] = ACTIONS(10004),
    [sym__unary_operator] = ACTIONS(10004),
    [sym__unary_plus_operator] = ACTIONS(10004),
    [aux_sym__terminator_token1] = ACTIONS(10006),
    [aux_sym__terminator_token2] = ACTIONS(10004),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9437] = {
    [sym_block_comment] = STATE(9437),
    [sym_line_comment] = STATE(9437),
    [sym__word_identifier] = ACTIONS(10048),
    [anon_sym_begin] = ACTIONS(10048),
    [anon_sym_module] = ACTIONS(10048),
    [anon_sym_baremodule] = ACTIONS(10048),
    [anon_sym_end] = ACTIONS(10048),
    [anon_sym_abstract] = ACTIONS(10048),
    [anon_sym_primitive] = ACTIONS(10048),
    [anon_sym_mutable] = ACTIONS(10048),
    [anon_sym_struct] = ACTIONS(10048),
    [anon_sym_function] = ACTIONS(10048),
    [anon_sym_macro] = ACTIONS(10048),
    [anon_sym_quote] = ACTIONS(10048),
    [anon_sym_let] = ACTIONS(10048),
    [anon_sym_if] = ACTIONS(10048),
    [anon_sym_try] = ACTIONS(10048),
    [anon_sym_for] = ACTIONS(10048),
    [anon_sym_while] = ACTIONS(10048),
    [sym_break_statement] = ACTIONS(10048),
    [sym_continue_statement] = ACTIONS(10048),
    [anon_sym_return] = ACTIONS(10048),
    [anon_sym_const] = ACTIONS(10048),
    [anon_sym_global] = ACTIONS(10048),
    [anon_sym_local] = ACTIONS(10048),
    [anon_sym_LPAREN] = ACTIONS(10048),
    [anon_sym_export] = ACTIONS(10048),
    [anon_sym_public] = ACTIONS(10048),
    [anon_sym_import] = ACTIONS(10048),
    [anon_sym_using] = ACTIONS(10048),
    [anon_sym_LBRACK] = ACTIONS(10048),
    [anon_sym_LBRACE] = ACTIONS(10048),
    [anon_sym_DOLLAR] = ACTIONS(10048),
    [anon_sym_COLON2] = ACTIONS(10048),
    [anon_sym_COLON_COLON] = ACTIONS(10048),
    [anon_sym_AT] = ACTIONS(10048),
    [anon_sym_true] = ACTIONS(10048),
    [anon_sym_false] = ACTIONS(10048),
    [aux_sym_integer_literal_token1] = ACTIONS(10048),
    [aux_sym_integer_literal_token2] = ACTIONS(10048),
    [aux_sym_integer_literal_token3] = ACTIONS(10048),
    [aux_sym_integer_literal_token4] = ACTIONS(10048),
    [aux_sym_float_literal_token1] = ACTIONS(10048),
    [aux_sym_float_literal_token3] = ACTIONS(10048),
    [aux_sym_float_literal_token4] = ACTIONS(10048),
    [sym_character_literal] = ACTIONS(10048),
    [anon_sym_DQUOTE] = ACTIONS(10048),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE] = ACTIONS(10048),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10048),
    [sym__pair_operator] = ACTIONS(10048),
    [sym__arrow_operator] = ACTIONS(10048),
    [sym__comparison_operator] = ACTIONS(10048),
    [sym__pipe_right_operator] = ACTIONS(10048),
    [sym__pipe_left_operator] = ACTIONS(10048),
    [sym__ellipsis_operator] = ACTIONS(10048),
    [sym__plus_operator] = ACTIONS(10048),
    [sym__times_operator] = ACTIONS(10048),
    [sym__rational_operator] = ACTIONS(10048),
    [sym__bitshift_operator] = ACTIONS(10048),
    [sym__power_operator] = ACTIONS(10048),
    [sym__tilde_operator] = ACTIONS(10048),
    [sym__type_order_operator] = ACTIONS(10048),
    [sym__unary_operator] = ACTIONS(10048),
    [sym__unary_plus_operator] = ACTIONS(10048),
    [aux_sym__terminator_token1] = ACTIONS(10050),
    [aux_sym__terminator_token2] = ACTIONS(10048),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9438] = {
    [sym_block_comment] = STATE(9438),
    [sym_line_comment] = STATE(9438),
    [sym__word_identifier] = ACTIONS(10052),
    [anon_sym_begin] = ACTIONS(10052),
    [anon_sym_module] = ACTIONS(10052),
    [anon_sym_baremodule] = ACTIONS(10052),
    [anon_sym_end] = ACTIONS(10052),
    [anon_sym_abstract] = ACTIONS(10052),
    [anon_sym_primitive] = ACTIONS(10052),
    [anon_sym_mutable] = ACTIONS(10052),
    [anon_sym_struct] = ACTIONS(10052),
    [anon_sym_function] = ACTIONS(10052),
    [anon_sym_macro] = ACTIONS(10052),
    [anon_sym_quote] = ACTIONS(10052),
    [anon_sym_let] = ACTIONS(10052),
    [anon_sym_if] = ACTIONS(10052),
    [anon_sym_try] = ACTIONS(10052),
    [anon_sym_for] = ACTIONS(10052),
    [anon_sym_while] = ACTIONS(10052),
    [sym_break_statement] = ACTIONS(10052),
    [sym_continue_statement] = ACTIONS(10052),
    [anon_sym_return] = ACTIONS(10052),
    [anon_sym_const] = ACTIONS(10052),
    [anon_sym_global] = ACTIONS(10052),
    [anon_sym_local] = ACTIONS(10052),
    [anon_sym_LPAREN] = ACTIONS(10052),
    [anon_sym_export] = ACTIONS(10052),
    [anon_sym_public] = ACTIONS(10052),
    [anon_sym_import] = ACTIONS(10052),
    [anon_sym_using] = ACTIONS(10052),
    [anon_sym_LBRACK] = ACTIONS(10052),
    [anon_sym_LBRACE] = ACTIONS(10052),
    [anon_sym_DOLLAR] = ACTIONS(10052),
    [anon_sym_COLON2] = ACTIONS(10052),
    [anon_sym_COLON_COLON] = ACTIONS(10052),
    [anon_sym_AT] = ACTIONS(10052),
    [anon_sym_true] = ACTIONS(10052),
    [anon_sym_false] = ACTIONS(10052),
    [aux_sym_integer_literal_token1] = ACTIONS(10052),
    [aux_sym_integer_literal_token2] = ACTIONS(10052),
    [aux_sym_integer_literal_token3] = ACTIONS(10052),
    [aux_sym_integer_literal_token4] = ACTIONS(10052),
    [aux_sym_float_literal_token1] = ACTIONS(10052),
    [aux_sym_float_literal_token3] = ACTIONS(10052),
    [aux_sym_float_literal_token4] = ACTIONS(10052),
    [sym_character_literal] = ACTIONS(10052),
    [anon_sym_DQUOTE] = ACTIONS(10052),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE] = ACTIONS(10052),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10052),
    [sym__pair_operator] = ACTIONS(10052),
    [sym__arrow_operator] = ACTIONS(10052),
    [sym__comparison_operator] = ACTIONS(10052),
    [sym__pipe_right_operator] = ACTIONS(10052),
    [sym__pipe_left_operator] = ACTIONS(10052),
    [sym__ellipsis_operator] = ACTIONS(10052),
    [sym__plus_operator] = ACTIONS(10052),
    [sym__times_operator] = ACTIONS(10052),
    [sym__rational_operator] = ACTIONS(10052),
    [sym__bitshift_operator] = ACTIONS(10052),
    [sym__power_operator] = ACTIONS(10052),
    [sym__tilde_operator] = ACTIONS(10052),
    [sym__type_order_operator] = ACTIONS(10052),
    [sym__unary_operator] = ACTIONS(10052),
    [sym__unary_plus_operator] = ACTIONS(10052),
    [aux_sym__terminator_token1] = ACTIONS(10054),
    [aux_sym__terminator_token2] = ACTIONS(10052),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9439] = {
    [sym_block_comment] = STATE(9439),
    [sym_line_comment] = STATE(9439),
    [sym__word_identifier] = ACTIONS(10036),
    [anon_sym_begin] = ACTIONS(10036),
    [anon_sym_module] = ACTIONS(10036),
    [anon_sym_baremodule] = ACTIONS(10036),
    [anon_sym_end] = ACTIONS(10036),
    [anon_sym_abstract] = ACTIONS(10036),
    [anon_sym_primitive] = ACTIONS(10036),
    [anon_sym_mutable] = ACTIONS(10036),
    [anon_sym_struct] = ACTIONS(10036),
    [anon_sym_function] = ACTIONS(10036),
    [anon_sym_macro] = ACTIONS(10036),
    [anon_sym_quote] = ACTIONS(10036),
    [anon_sym_let] = ACTIONS(10036),
    [anon_sym_if] = ACTIONS(10036),
    [anon_sym_try] = ACTIONS(10036),
    [anon_sym_for] = ACTIONS(10036),
    [anon_sym_while] = ACTIONS(10036),
    [sym_break_statement] = ACTIONS(10036),
    [sym_continue_statement] = ACTIONS(10036),
    [anon_sym_return] = ACTIONS(10036),
    [anon_sym_const] = ACTIONS(10036),
    [anon_sym_global] = ACTIONS(10036),
    [anon_sym_local] = ACTIONS(10036),
    [anon_sym_LPAREN] = ACTIONS(10036),
    [anon_sym_export] = ACTIONS(10036),
    [anon_sym_public] = ACTIONS(10036),
    [anon_sym_import] = ACTIONS(10036),
    [anon_sym_using] = ACTIONS(10036),
    [anon_sym_LBRACK] = ACTIONS(10036),
    [anon_sym_LBRACE] = ACTIONS(10036),
    [anon_sym_DOLLAR] = ACTIONS(10036),
    [anon_sym_COLON2] = ACTIONS(10036),
    [anon_sym_COLON_COLON] = ACTIONS(10036),
    [anon_sym_AT] = ACTIONS(10036),
    [anon_sym_true] = ACTIONS(10036),
    [anon_sym_false] = ACTIONS(10036),
    [aux_sym_integer_literal_token1] = ACTIONS(10036),
    [aux_sym_integer_literal_token2] = ACTIONS(10036),
    [aux_sym_integer_literal_token3] = ACTIONS(10036),
    [aux_sym_integer_literal_token4] = ACTIONS(10036),
    [aux_sym_float_literal_token1] = ACTIONS(10036),
    [aux_sym_float_literal_token3] = ACTIONS(10036),
    [aux_sym_float_literal_token4] = ACTIONS(10036),
    [sym_character_literal] = ACTIONS(10036),
    [anon_sym_DQUOTE] = ACTIONS(10036),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE] = ACTIONS(10036),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10036),
    [sym__pair_operator] = ACTIONS(10036),
    [sym__arrow_operator] = ACTIONS(10036),
    [sym__comparison_operator] = ACTIONS(10036),
    [sym__pipe_right_operator] = ACTIONS(10036),
    [sym__pipe_left_operator] = ACTIONS(10036),
    [sym__ellipsis_operator] = ACTIONS(10036),
    [sym__plus_operator] = ACTIONS(10036),
    [sym__times_operator] = ACTIONS(10036),
    [sym__rational_operator] = ACTIONS(10036),
    [sym__bitshift_operator] = ACTIONS(10036),
    [sym__power_operator] = ACTIONS(10036),
    [sym__tilde_operator] = ACTIONS(10036),
    [sym__type_order_operator] = ACTIONS(10036),
    [sym__unary_operator] = ACTIONS(10036),
    [sym__unary_plus_operator] = ACTIONS(10036),
    [aux_sym__terminator_token1] = ACTIONS(10038),
    [aux_sym__terminator_token2] = ACTIONS(10036),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9440] = {
    [sym_block_comment] = STATE(9440),
    [sym_line_comment] = STATE(9440),
    [sym__word_identifier] = ACTIONS(9994),
    [anon_sym_begin] = ACTIONS(9994),
    [anon_sym_module] = ACTIONS(9994),
    [anon_sym_baremodule] = ACTIONS(9994),
    [anon_sym_end] = ACTIONS(9994),
    [anon_sym_abstract] = ACTIONS(9994),
    [anon_sym_primitive] = ACTIONS(9994),
    [anon_sym_mutable] = ACTIONS(9994),
    [anon_sym_struct] = ACTIONS(9994),
    [anon_sym_function] = ACTIONS(9994),
    [anon_sym_macro] = ACTIONS(9994),
    [anon_sym_quote] = ACTIONS(9994),
    [anon_sym_let] = ACTIONS(9994),
    [anon_sym_if] = ACTIONS(9994),
    [anon_sym_try] = ACTIONS(9994),
    [anon_sym_for] = ACTIONS(9994),
    [anon_sym_while] = ACTIONS(9994),
    [sym_break_statement] = ACTIONS(9994),
    [sym_continue_statement] = ACTIONS(9994),
    [anon_sym_return] = ACTIONS(9994),
    [anon_sym_const] = ACTIONS(9994),
    [anon_sym_global] = ACTIONS(9994),
    [anon_sym_local] = ACTIONS(9994),
    [anon_sym_LPAREN] = ACTIONS(9994),
    [anon_sym_export] = ACTIONS(9994),
    [anon_sym_public] = ACTIONS(9994),
    [anon_sym_import] = ACTIONS(9994),
    [anon_sym_using] = ACTIONS(9994),
    [anon_sym_LBRACK] = ACTIONS(9994),
    [anon_sym_LBRACE] = ACTIONS(9994),
    [anon_sym_DOLLAR] = ACTIONS(9994),
    [anon_sym_COLON2] = ACTIONS(9994),
    [anon_sym_COLON_COLON] = ACTIONS(9994),
    [anon_sym_AT] = ACTIONS(9994),
    [anon_sym_true] = ACTIONS(9994),
    [anon_sym_false] = ACTIONS(9994),
    [aux_sym_integer_literal_token1] = ACTIONS(9994),
    [aux_sym_integer_literal_token2] = ACTIONS(9994),
    [aux_sym_integer_literal_token3] = ACTIONS(9994),
    [aux_sym_integer_literal_token4] = ACTIONS(9994),
    [aux_sym_float_literal_token1] = ACTIONS(9994),
    [aux_sym_float_literal_token3] = ACTIONS(9994),
    [aux_sym_float_literal_token4] = ACTIONS(9994),
    [sym_character_literal] = ACTIONS(9994),
    [anon_sym_DQUOTE] = ACTIONS(9994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE] = ACTIONS(9994),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9994),
    [sym__pair_operator] = ACTIONS(9994),
    [sym__arrow_operator] = ACTIONS(9994),
    [sym__comparison_operator] = ACTIONS(9994),
    [sym__pipe_right_operator] = ACTIONS(9994),
    [sym__pipe_left_operator] = ACTIONS(9994),
    [sym__ellipsis_operator] = ACTIONS(9994),
    [sym__plus_operator] = ACTIONS(9994),
    [sym__times_operator] = ACTIONS(9994),
    [sym__rational_operator] = ACTIONS(9994),
    [sym__bitshift_operator] = ACTIONS(9994),
    [sym__power_operator] = ACTIONS(9994),
    [sym__tilde_operator] = ACTIONS(9994),
    [sym__type_order_operator] = ACTIONS(9994),
    [sym__unary_operator] = ACTIONS(9994),
    [sym__unary_plus_operator] = ACTIONS(9994),
    [aux_sym__terminator_token1] = ACTIONS(9996),
    [aux_sym__terminator_token2] = ACTIONS(9994),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9441] = {
    [sym_block_comment] = STATE(9441),
    [sym_line_comment] = STATE(9441),
    [sym__word_identifier] = ACTIONS(9788),
    [anon_sym_begin] = ACTIONS(9788),
    [anon_sym_module] = ACTIONS(9788),
    [anon_sym_baremodule] = ACTIONS(9788),
    [anon_sym_end] = ACTIONS(9788),
    [anon_sym_abstract] = ACTIONS(9788),
    [anon_sym_primitive] = ACTIONS(9788),
    [anon_sym_mutable] = ACTIONS(9788),
    [anon_sym_struct] = ACTIONS(9788),
    [anon_sym_function] = ACTIONS(9788),
    [anon_sym_macro] = ACTIONS(9788),
    [anon_sym_quote] = ACTIONS(9788),
    [anon_sym_let] = ACTIONS(9788),
    [anon_sym_if] = ACTIONS(9788),
    [anon_sym_try] = ACTIONS(9788),
    [anon_sym_for] = ACTIONS(9788),
    [anon_sym_while] = ACTIONS(9788),
    [sym_break_statement] = ACTIONS(9788),
    [sym_continue_statement] = ACTIONS(9788),
    [anon_sym_return] = ACTIONS(9788),
    [anon_sym_const] = ACTIONS(9788),
    [anon_sym_global] = ACTIONS(9788),
    [anon_sym_local] = ACTIONS(9788),
    [anon_sym_LPAREN] = ACTIONS(9788),
    [anon_sym_export] = ACTIONS(9788),
    [anon_sym_public] = ACTIONS(9788),
    [anon_sym_import] = ACTIONS(9788),
    [anon_sym_using] = ACTIONS(9788),
    [anon_sym_LBRACK] = ACTIONS(9788),
    [anon_sym_LBRACE] = ACTIONS(9788),
    [anon_sym_DOLLAR] = ACTIONS(9788),
    [anon_sym_COLON2] = ACTIONS(9788),
    [anon_sym_COLON_COLON] = ACTIONS(9788),
    [anon_sym_AT] = ACTIONS(9788),
    [anon_sym_true] = ACTIONS(9788),
    [anon_sym_false] = ACTIONS(9788),
    [aux_sym_integer_literal_token1] = ACTIONS(9788),
    [aux_sym_integer_literal_token2] = ACTIONS(9788),
    [aux_sym_integer_literal_token3] = ACTIONS(9788),
    [aux_sym_integer_literal_token4] = ACTIONS(9788),
    [aux_sym_float_literal_token1] = ACTIONS(9788),
    [aux_sym_float_literal_token3] = ACTIONS(9788),
    [aux_sym_float_literal_token4] = ACTIONS(9788),
    [sym_character_literal] = ACTIONS(9788),
    [anon_sym_DQUOTE] = ACTIONS(9788),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE] = ACTIONS(9788),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9788),
    [sym__pair_operator] = ACTIONS(9788),
    [sym__arrow_operator] = ACTIONS(9788),
    [sym__comparison_operator] = ACTIONS(9788),
    [sym__pipe_right_operator] = ACTIONS(9788),
    [sym__pipe_left_operator] = ACTIONS(9788),
    [sym__ellipsis_operator] = ACTIONS(9788),
    [sym__plus_operator] = ACTIONS(9788),
    [sym__times_operator] = ACTIONS(9788),
    [sym__rational_operator] = ACTIONS(9788),
    [sym__bitshift_operator] = ACTIONS(9788),
    [sym__power_operator] = ACTIONS(9788),
    [sym__tilde_operator] = ACTIONS(9788),
    [sym__type_order_operator] = ACTIONS(9788),
    [sym__unary_operator] = ACTIONS(9788),
    [sym__unary_plus_operator] = ACTIONS(9788),
    [aux_sym__terminator_token1] = ACTIONS(9792),
    [aux_sym__terminator_token2] = ACTIONS(9788),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9442] = {
    [sym_block_comment] = STATE(9442),
    [sym_line_comment] = STATE(9442),
    [sym__word_identifier] = ACTIONS(10056),
    [anon_sym_begin] = ACTIONS(10056),
    [anon_sym_module] = ACTIONS(10056),
    [anon_sym_baremodule] = ACTIONS(10056),
    [anon_sym_end] = ACTIONS(10056),
    [anon_sym_abstract] = ACTIONS(10056),
    [anon_sym_primitive] = ACTIONS(10056),
    [anon_sym_mutable] = ACTIONS(10056),
    [anon_sym_struct] = ACTIONS(10056),
    [anon_sym_function] = ACTIONS(10056),
    [anon_sym_macro] = ACTIONS(10056),
    [anon_sym_quote] = ACTIONS(10056),
    [anon_sym_let] = ACTIONS(10056),
    [anon_sym_if] = ACTIONS(10056),
    [anon_sym_try] = ACTIONS(10056),
    [anon_sym_for] = ACTIONS(10056),
    [anon_sym_while] = ACTIONS(10056),
    [sym_break_statement] = ACTIONS(10056),
    [sym_continue_statement] = ACTIONS(10056),
    [anon_sym_return] = ACTIONS(10056),
    [anon_sym_const] = ACTIONS(10056),
    [anon_sym_global] = ACTIONS(10056),
    [anon_sym_local] = ACTIONS(10056),
    [anon_sym_LPAREN] = ACTIONS(10056),
    [anon_sym_export] = ACTIONS(10056),
    [anon_sym_public] = ACTIONS(10056),
    [anon_sym_import] = ACTIONS(10056),
    [anon_sym_using] = ACTIONS(10056),
    [anon_sym_LBRACK] = ACTIONS(10056),
    [anon_sym_LBRACE] = ACTIONS(10056),
    [anon_sym_DOLLAR] = ACTIONS(10056),
    [anon_sym_COLON2] = ACTIONS(10056),
    [anon_sym_COLON_COLON] = ACTIONS(10056),
    [anon_sym_AT] = ACTIONS(10056),
    [anon_sym_true] = ACTIONS(10056),
    [anon_sym_false] = ACTIONS(10056),
    [aux_sym_integer_literal_token1] = ACTIONS(10056),
    [aux_sym_integer_literal_token2] = ACTIONS(10056),
    [aux_sym_integer_literal_token3] = ACTIONS(10056),
    [aux_sym_integer_literal_token4] = ACTIONS(10056),
    [aux_sym_float_literal_token1] = ACTIONS(10056),
    [aux_sym_float_literal_token3] = ACTIONS(10056),
    [aux_sym_float_literal_token4] = ACTIONS(10056),
    [sym_character_literal] = ACTIONS(10056),
    [anon_sym_DQUOTE] = ACTIONS(10056),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE] = ACTIONS(10056),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10056),
    [sym__pair_operator] = ACTIONS(10056),
    [sym__arrow_operator] = ACTIONS(10056),
    [sym__comparison_operator] = ACTIONS(10056),
    [sym__pipe_right_operator] = ACTIONS(10056),
    [sym__pipe_left_operator] = ACTIONS(10056),
    [sym__ellipsis_operator] = ACTIONS(10056),
    [sym__plus_operator] = ACTIONS(10056),
    [sym__times_operator] = ACTIONS(10056),
    [sym__rational_operator] = ACTIONS(10056),
    [sym__bitshift_operator] = ACTIONS(10056),
    [sym__power_operator] = ACTIONS(10056),
    [sym__tilde_operator] = ACTIONS(10056),
    [sym__type_order_operator] = ACTIONS(10056),
    [sym__unary_operator] = ACTIONS(10056),
    [sym__unary_plus_operator] = ACTIONS(10056),
    [aux_sym__terminator_token1] = ACTIONS(10058),
    [aux_sym__terminator_token2] = ACTIONS(10056),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9443] = {
    [sym_block_comment] = STATE(9443),
    [sym_line_comment] = STATE(9443),
    [sym__word_identifier] = ACTIONS(10068),
    [anon_sym_begin] = ACTIONS(10068),
    [anon_sym_module] = ACTIONS(10068),
    [anon_sym_baremodule] = ACTIONS(10068),
    [anon_sym_end] = ACTIONS(10068),
    [anon_sym_abstract] = ACTIONS(10068),
    [anon_sym_primitive] = ACTIONS(10068),
    [anon_sym_mutable] = ACTIONS(10068),
    [anon_sym_struct] = ACTIONS(10068),
    [anon_sym_function] = ACTIONS(10068),
    [anon_sym_macro] = ACTIONS(10068),
    [anon_sym_quote] = ACTIONS(10068),
    [anon_sym_let] = ACTIONS(10068),
    [anon_sym_if] = ACTIONS(10068),
    [anon_sym_try] = ACTIONS(10068),
    [anon_sym_for] = ACTIONS(10068),
    [anon_sym_while] = ACTIONS(10068),
    [sym_break_statement] = ACTIONS(10068),
    [sym_continue_statement] = ACTIONS(10068),
    [anon_sym_return] = ACTIONS(10068),
    [anon_sym_const] = ACTIONS(10068),
    [anon_sym_global] = ACTIONS(10068),
    [anon_sym_local] = ACTIONS(10068),
    [anon_sym_LPAREN] = ACTIONS(10068),
    [anon_sym_export] = ACTIONS(10068),
    [anon_sym_public] = ACTIONS(10068),
    [anon_sym_import] = ACTIONS(10068),
    [anon_sym_using] = ACTIONS(10068),
    [anon_sym_LBRACK] = ACTIONS(10068),
    [anon_sym_LBRACE] = ACTIONS(10068),
    [anon_sym_DOLLAR] = ACTIONS(10068),
    [anon_sym_COLON2] = ACTIONS(10068),
    [anon_sym_COLON_COLON] = ACTIONS(10068),
    [anon_sym_AT] = ACTIONS(10068),
    [anon_sym_true] = ACTIONS(10068),
    [anon_sym_false] = ACTIONS(10068),
    [aux_sym_integer_literal_token1] = ACTIONS(10068),
    [aux_sym_integer_literal_token2] = ACTIONS(10068),
    [aux_sym_integer_literal_token3] = ACTIONS(10068),
    [aux_sym_integer_literal_token4] = ACTIONS(10068),
    [aux_sym_float_literal_token1] = ACTIONS(10068),
    [aux_sym_float_literal_token3] = ACTIONS(10068),
    [aux_sym_float_literal_token4] = ACTIONS(10068),
    [sym_character_literal] = ACTIONS(10068),
    [anon_sym_DQUOTE] = ACTIONS(10068),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE] = ACTIONS(10068),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10068),
    [sym__pair_operator] = ACTIONS(10068),
    [sym__arrow_operator] = ACTIONS(10068),
    [sym__comparison_operator] = ACTIONS(10068),
    [sym__pipe_right_operator] = ACTIONS(10068),
    [sym__pipe_left_operator] = ACTIONS(10068),
    [sym__ellipsis_operator] = ACTIONS(10068),
    [sym__plus_operator] = ACTIONS(10068),
    [sym__times_operator] = ACTIONS(10068),
    [sym__rational_operator] = ACTIONS(10068),
    [sym__bitshift_operator] = ACTIONS(10068),
    [sym__power_operator] = ACTIONS(10068),
    [sym__tilde_operator] = ACTIONS(10068),
    [sym__type_order_operator] = ACTIONS(10068),
    [sym__unary_operator] = ACTIONS(10068),
    [sym__unary_plus_operator] = ACTIONS(10068),
    [aux_sym__terminator_token1] = ACTIONS(10070),
    [aux_sym__terminator_token2] = ACTIONS(10068),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9444] = {
    [sym_block_comment] = STATE(9444),
    [sym_line_comment] = STATE(9444),
    [sym__word_identifier] = ACTIONS(9750),
    [anon_sym_begin] = ACTIONS(9750),
    [anon_sym_module] = ACTIONS(9750),
    [anon_sym_baremodule] = ACTIONS(9750),
    [anon_sym_end] = ACTIONS(9750),
    [anon_sym_abstract] = ACTIONS(9750),
    [anon_sym_primitive] = ACTIONS(9750),
    [anon_sym_mutable] = ACTIONS(9750),
    [anon_sym_struct] = ACTIONS(9750),
    [anon_sym_function] = ACTIONS(9750),
    [anon_sym_macro] = ACTIONS(9750),
    [anon_sym_quote] = ACTIONS(9750),
    [anon_sym_let] = ACTIONS(9750),
    [anon_sym_if] = ACTIONS(9750),
    [anon_sym_try] = ACTIONS(9750),
    [anon_sym_for] = ACTIONS(9750),
    [anon_sym_while] = ACTIONS(9750),
    [sym_break_statement] = ACTIONS(9750),
    [sym_continue_statement] = ACTIONS(9750),
    [anon_sym_return] = ACTIONS(9750),
    [anon_sym_const] = ACTIONS(9750),
    [anon_sym_global] = ACTIONS(9750),
    [anon_sym_local] = ACTIONS(9750),
    [anon_sym_LPAREN] = ACTIONS(9750),
    [anon_sym_export] = ACTIONS(9750),
    [anon_sym_public] = ACTIONS(9750),
    [anon_sym_import] = ACTIONS(9750),
    [anon_sym_using] = ACTIONS(9750),
    [anon_sym_LBRACK] = ACTIONS(9750),
    [anon_sym_LBRACE] = ACTIONS(9750),
    [anon_sym_DOLLAR] = ACTIONS(9750),
    [anon_sym_COLON2] = ACTIONS(9750),
    [anon_sym_COLON_COLON] = ACTIONS(9750),
    [anon_sym_AT] = ACTIONS(9750),
    [anon_sym_true] = ACTIONS(9750),
    [anon_sym_false] = ACTIONS(9750),
    [aux_sym_integer_literal_token1] = ACTIONS(9750),
    [aux_sym_integer_literal_token2] = ACTIONS(9750),
    [aux_sym_integer_literal_token3] = ACTIONS(9750),
    [aux_sym_integer_literal_token4] = ACTIONS(9750),
    [aux_sym_float_literal_token1] = ACTIONS(9750),
    [aux_sym_float_literal_token3] = ACTIONS(9750),
    [aux_sym_float_literal_token4] = ACTIONS(9750),
    [sym_character_literal] = ACTIONS(9750),
    [anon_sym_DQUOTE] = ACTIONS(9750),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE] = ACTIONS(9750),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9750),
    [sym__pair_operator] = ACTIONS(9750),
    [sym__arrow_operator] = ACTIONS(9750),
    [sym__comparison_operator] = ACTIONS(9750),
    [sym__pipe_right_operator] = ACTIONS(9750),
    [sym__pipe_left_operator] = ACTIONS(9750),
    [sym__ellipsis_operator] = ACTIONS(9750),
    [sym__plus_operator] = ACTIONS(9750),
    [sym__times_operator] = ACTIONS(9750),
    [sym__rational_operator] = ACTIONS(9750),
    [sym__bitshift_operator] = ACTIONS(9750),
    [sym__power_operator] = ACTIONS(9750),
    [sym__tilde_operator] = ACTIONS(9750),
    [sym__type_order_operator] = ACTIONS(9750),
    [sym__unary_operator] = ACTIONS(9750),
    [sym__unary_plus_operator] = ACTIONS(9750),
    [aux_sym__terminator_token1] = ACTIONS(9754),
    [aux_sym__terminator_token2] = ACTIONS(9750),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9445] = {
    [sym_block_comment] = STATE(9445),
    [sym_line_comment] = STATE(9445),
    [sym__word_identifier] = ACTIONS(9714),
    [anon_sym_begin] = ACTIONS(9714),
    [anon_sym_module] = ACTIONS(9714),
    [anon_sym_baremodule] = ACTIONS(9714),
    [anon_sym_end] = ACTIONS(9714),
    [anon_sym_abstract] = ACTIONS(9714),
    [anon_sym_primitive] = ACTIONS(9714),
    [anon_sym_mutable] = ACTIONS(9714),
    [anon_sym_struct] = ACTIONS(9714),
    [anon_sym_function] = ACTIONS(9714),
    [anon_sym_macro] = ACTIONS(9714),
    [anon_sym_quote] = ACTIONS(9714),
    [anon_sym_let] = ACTIONS(9714),
    [anon_sym_if] = ACTIONS(9714),
    [anon_sym_try] = ACTIONS(9714),
    [anon_sym_for] = ACTIONS(9714),
    [anon_sym_while] = ACTIONS(9714),
    [sym_break_statement] = ACTIONS(9714),
    [sym_continue_statement] = ACTIONS(9714),
    [anon_sym_return] = ACTIONS(9714),
    [anon_sym_const] = ACTIONS(9714),
    [anon_sym_global] = ACTIONS(9714),
    [anon_sym_local] = ACTIONS(9714),
    [anon_sym_LPAREN] = ACTIONS(9714),
    [anon_sym_export] = ACTIONS(9714),
    [anon_sym_public] = ACTIONS(9714),
    [anon_sym_import] = ACTIONS(9714),
    [anon_sym_using] = ACTIONS(9714),
    [anon_sym_LBRACK] = ACTIONS(9714),
    [anon_sym_LBRACE] = ACTIONS(9714),
    [anon_sym_DOLLAR] = ACTIONS(9714),
    [anon_sym_COLON2] = ACTIONS(9714),
    [anon_sym_COLON_COLON] = ACTIONS(9714),
    [anon_sym_AT] = ACTIONS(9714),
    [anon_sym_true] = ACTIONS(9714),
    [anon_sym_false] = ACTIONS(9714),
    [aux_sym_integer_literal_token1] = ACTIONS(9714),
    [aux_sym_integer_literal_token2] = ACTIONS(9714),
    [aux_sym_integer_literal_token3] = ACTIONS(9714),
    [aux_sym_integer_literal_token4] = ACTIONS(9714),
    [aux_sym_float_literal_token1] = ACTIONS(9714),
    [aux_sym_float_literal_token3] = ACTIONS(9714),
    [aux_sym_float_literal_token4] = ACTIONS(9714),
    [sym_character_literal] = ACTIONS(9714),
    [anon_sym_DQUOTE] = ACTIONS(9714),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE] = ACTIONS(9714),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9714),
    [sym__pair_operator] = ACTIONS(9714),
    [sym__arrow_operator] = ACTIONS(9714),
    [sym__comparison_operator] = ACTIONS(9714),
    [sym__pipe_right_operator] = ACTIONS(9714),
    [sym__pipe_left_operator] = ACTIONS(9714),
    [sym__ellipsis_operator] = ACTIONS(9714),
    [sym__plus_operator] = ACTIONS(9714),
    [sym__times_operator] = ACTIONS(9714),
    [sym__rational_operator] = ACTIONS(9714),
    [sym__bitshift_operator] = ACTIONS(9714),
    [sym__power_operator] = ACTIONS(9714),
    [sym__tilde_operator] = ACTIONS(9714),
    [sym__type_order_operator] = ACTIONS(9714),
    [sym__unary_operator] = ACTIONS(9714),
    [sym__unary_plus_operator] = ACTIONS(9714),
    [aux_sym__terminator_token1] = ACTIONS(9716),
    [aux_sym__terminator_token2] = ACTIONS(9714),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9446] = {
    [sym_block_comment] = STATE(9446),
    [sym_line_comment] = STATE(9446),
    [sym__word_identifier] = ACTIONS(9642),
    [anon_sym_begin] = ACTIONS(9642),
    [anon_sym_module] = ACTIONS(9642),
    [anon_sym_baremodule] = ACTIONS(9642),
    [anon_sym_end] = ACTIONS(9642),
    [anon_sym_abstract] = ACTIONS(9642),
    [anon_sym_primitive] = ACTIONS(9642),
    [anon_sym_mutable] = ACTIONS(9642),
    [anon_sym_struct] = ACTIONS(9642),
    [anon_sym_function] = ACTIONS(9642),
    [anon_sym_macro] = ACTIONS(9642),
    [anon_sym_quote] = ACTIONS(9642),
    [anon_sym_let] = ACTIONS(9642),
    [anon_sym_if] = ACTIONS(9642),
    [anon_sym_try] = ACTIONS(9642),
    [anon_sym_for] = ACTIONS(9642),
    [anon_sym_while] = ACTIONS(9642),
    [sym_break_statement] = ACTIONS(9642),
    [sym_continue_statement] = ACTIONS(9642),
    [anon_sym_return] = ACTIONS(9642),
    [anon_sym_const] = ACTIONS(9642),
    [anon_sym_global] = ACTIONS(9642),
    [anon_sym_local] = ACTIONS(9642),
    [anon_sym_LPAREN] = ACTIONS(9642),
    [anon_sym_export] = ACTIONS(9642),
    [anon_sym_public] = ACTIONS(9642),
    [anon_sym_import] = ACTIONS(9642),
    [anon_sym_using] = ACTIONS(9642),
    [anon_sym_LBRACK] = ACTIONS(9642),
    [anon_sym_LBRACE] = ACTIONS(9642),
    [anon_sym_DOLLAR] = ACTIONS(9642),
    [anon_sym_COLON2] = ACTIONS(9642),
    [anon_sym_COLON_COLON] = ACTIONS(9642),
    [anon_sym_AT] = ACTIONS(9642),
    [anon_sym_true] = ACTIONS(9642),
    [anon_sym_false] = ACTIONS(9642),
    [aux_sym_integer_literal_token1] = ACTIONS(9642),
    [aux_sym_integer_literal_token2] = ACTIONS(9642),
    [aux_sym_integer_literal_token3] = ACTIONS(9642),
    [aux_sym_integer_literal_token4] = ACTIONS(9642),
    [aux_sym_float_literal_token1] = ACTIONS(9642),
    [aux_sym_float_literal_token3] = ACTIONS(9642),
    [aux_sym_float_literal_token4] = ACTIONS(9642),
    [sym_character_literal] = ACTIONS(9642),
    [anon_sym_DQUOTE] = ACTIONS(9642),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE] = ACTIONS(9642),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9642),
    [sym__pair_operator] = ACTIONS(9642),
    [sym__arrow_operator] = ACTIONS(9642),
    [sym__comparison_operator] = ACTIONS(9642),
    [sym__pipe_right_operator] = ACTIONS(9642),
    [sym__pipe_left_operator] = ACTIONS(9642),
    [sym__ellipsis_operator] = ACTIONS(9642),
    [sym__plus_operator] = ACTIONS(9642),
    [sym__times_operator] = ACTIONS(9642),
    [sym__rational_operator] = ACTIONS(9642),
    [sym__bitshift_operator] = ACTIONS(9642),
    [sym__power_operator] = ACTIONS(9642),
    [sym__tilde_operator] = ACTIONS(9642),
    [sym__type_order_operator] = ACTIONS(9642),
    [sym__unary_operator] = ACTIONS(9642),
    [sym__unary_plus_operator] = ACTIONS(9642),
    [aux_sym__terminator_token1] = ACTIONS(9644),
    [aux_sym__terminator_token2] = ACTIONS(9642),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9447] = {
    [sym_block_comment] = STATE(9447),
    [sym_line_comment] = STATE(9447),
    [sym__word_identifier] = ACTIONS(10134),
    [anon_sym_begin] = ACTIONS(10134),
    [anon_sym_module] = ACTIONS(10134),
    [anon_sym_baremodule] = ACTIONS(10134),
    [anon_sym_end] = ACTIONS(10134),
    [anon_sym_abstract] = ACTIONS(10134),
    [anon_sym_primitive] = ACTIONS(10134),
    [anon_sym_mutable] = ACTIONS(10134),
    [anon_sym_struct] = ACTIONS(10134),
    [anon_sym_function] = ACTIONS(10134),
    [anon_sym_macro] = ACTIONS(10134),
    [anon_sym_quote] = ACTIONS(10134),
    [anon_sym_let] = ACTIONS(10134),
    [anon_sym_if] = ACTIONS(10134),
    [anon_sym_try] = ACTIONS(10134),
    [anon_sym_for] = ACTIONS(10134),
    [anon_sym_while] = ACTIONS(10134),
    [sym_break_statement] = ACTIONS(10134),
    [sym_continue_statement] = ACTIONS(10134),
    [anon_sym_return] = ACTIONS(10134),
    [anon_sym_const] = ACTIONS(10134),
    [anon_sym_global] = ACTIONS(10134),
    [anon_sym_local] = ACTIONS(10134),
    [anon_sym_LPAREN] = ACTIONS(10134),
    [anon_sym_export] = ACTIONS(10134),
    [anon_sym_public] = ACTIONS(10134),
    [anon_sym_import] = ACTIONS(10134),
    [anon_sym_using] = ACTIONS(10134),
    [anon_sym_LBRACK] = ACTIONS(10134),
    [anon_sym_LBRACE] = ACTIONS(10134),
    [anon_sym_DOLLAR] = ACTIONS(10134),
    [anon_sym_COLON2] = ACTIONS(10134),
    [anon_sym_COLON_COLON] = ACTIONS(10134),
    [anon_sym_AT] = ACTIONS(10134),
    [anon_sym_true] = ACTIONS(10134),
    [anon_sym_false] = ACTIONS(10134),
    [aux_sym_integer_literal_token1] = ACTIONS(10134),
    [aux_sym_integer_literal_token2] = ACTIONS(10134),
    [aux_sym_integer_literal_token3] = ACTIONS(10134),
    [aux_sym_integer_literal_token4] = ACTIONS(10134),
    [aux_sym_float_literal_token1] = ACTIONS(10134),
    [aux_sym_float_literal_token3] = ACTIONS(10134),
    [aux_sym_float_literal_token4] = ACTIONS(10134),
    [sym_character_literal] = ACTIONS(10134),
    [anon_sym_DQUOTE] = ACTIONS(10134),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE] = ACTIONS(10134),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10134),
    [sym__pair_operator] = ACTIONS(10134),
    [sym__arrow_operator] = ACTIONS(10134),
    [sym__comparison_operator] = ACTIONS(10134),
    [sym__pipe_right_operator] = ACTIONS(10134),
    [sym__pipe_left_operator] = ACTIONS(10134),
    [sym__ellipsis_operator] = ACTIONS(10134),
    [sym__plus_operator] = ACTIONS(10134),
    [sym__times_operator] = ACTIONS(10134),
    [sym__rational_operator] = ACTIONS(10134),
    [sym__bitshift_operator] = ACTIONS(10134),
    [sym__power_operator] = ACTIONS(10134),
    [sym__tilde_operator] = ACTIONS(10134),
    [sym__type_order_operator] = ACTIONS(10134),
    [sym__unary_operator] = ACTIONS(10134),
    [sym__unary_plus_operator] = ACTIONS(10134),
    [aux_sym__terminator_token1] = ACTIONS(10136),
    [aux_sym__terminator_token2] = ACTIONS(10134),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9448] = {
    [sym_block_comment] = STATE(9448),
    [sym_line_comment] = STATE(9448),
    [sym__word_identifier] = ACTIONS(9912),
    [anon_sym_begin] = ACTIONS(9912),
    [anon_sym_module] = ACTIONS(9912),
    [anon_sym_baremodule] = ACTIONS(9912),
    [anon_sym_end] = ACTIONS(9912),
    [anon_sym_abstract] = ACTIONS(9912),
    [anon_sym_primitive] = ACTIONS(9912),
    [anon_sym_mutable] = ACTIONS(9912),
    [anon_sym_struct] = ACTIONS(9912),
    [anon_sym_function] = ACTIONS(9912),
    [anon_sym_macro] = ACTIONS(9912),
    [anon_sym_quote] = ACTIONS(9912),
    [anon_sym_let] = ACTIONS(9912),
    [anon_sym_if] = ACTIONS(9912),
    [anon_sym_try] = ACTIONS(9912),
    [anon_sym_for] = ACTIONS(9912),
    [anon_sym_while] = ACTIONS(9912),
    [sym_break_statement] = ACTIONS(9912),
    [sym_continue_statement] = ACTIONS(9912),
    [anon_sym_return] = ACTIONS(9912),
    [anon_sym_const] = ACTIONS(9912),
    [anon_sym_global] = ACTIONS(9912),
    [anon_sym_local] = ACTIONS(9912),
    [anon_sym_LPAREN] = ACTIONS(9912),
    [anon_sym_export] = ACTIONS(9912),
    [anon_sym_public] = ACTIONS(9912),
    [anon_sym_import] = ACTIONS(9912),
    [anon_sym_using] = ACTIONS(9912),
    [anon_sym_LBRACK] = ACTIONS(9912),
    [anon_sym_LBRACE] = ACTIONS(9912),
    [anon_sym_DOLLAR] = ACTIONS(9912),
    [anon_sym_COLON2] = ACTIONS(9912),
    [anon_sym_COLON_COLON] = ACTIONS(9912),
    [anon_sym_AT] = ACTIONS(9912),
    [anon_sym_true] = ACTIONS(9912),
    [anon_sym_false] = ACTIONS(9912),
    [aux_sym_integer_literal_token1] = ACTIONS(9912),
    [aux_sym_integer_literal_token2] = ACTIONS(9912),
    [aux_sym_integer_literal_token3] = ACTIONS(9912),
    [aux_sym_integer_literal_token4] = ACTIONS(9912),
    [aux_sym_float_literal_token1] = ACTIONS(9912),
    [aux_sym_float_literal_token3] = ACTIONS(9912),
    [aux_sym_float_literal_token4] = ACTIONS(9912),
    [sym_character_literal] = ACTIONS(9912),
    [anon_sym_DQUOTE] = ACTIONS(9912),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE] = ACTIONS(9912),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9912),
    [sym__pair_operator] = ACTIONS(9912),
    [sym__arrow_operator] = ACTIONS(9912),
    [sym__comparison_operator] = ACTIONS(9912),
    [sym__pipe_right_operator] = ACTIONS(9912),
    [sym__pipe_left_operator] = ACTIONS(9912),
    [sym__ellipsis_operator] = ACTIONS(9912),
    [sym__plus_operator] = ACTIONS(9912),
    [sym__times_operator] = ACTIONS(9912),
    [sym__rational_operator] = ACTIONS(9912),
    [sym__bitshift_operator] = ACTIONS(9912),
    [sym__power_operator] = ACTIONS(9912),
    [sym__tilde_operator] = ACTIONS(9912),
    [sym__type_order_operator] = ACTIONS(9912),
    [sym__unary_operator] = ACTIONS(9912),
    [sym__unary_plus_operator] = ACTIONS(9912),
    [aux_sym__terminator_token1] = ACTIONS(9914),
    [aux_sym__terminator_token2] = ACTIONS(9912),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9449] = {
    [sym_block_comment] = STATE(9449),
    [sym_line_comment] = STATE(9449),
    [sym__word_identifier] = ACTIONS(9898),
    [anon_sym_begin] = ACTIONS(9898),
    [anon_sym_module] = ACTIONS(9898),
    [anon_sym_baremodule] = ACTIONS(9898),
    [anon_sym_end] = ACTIONS(9898),
    [anon_sym_abstract] = ACTIONS(9898),
    [anon_sym_primitive] = ACTIONS(9898),
    [anon_sym_mutable] = ACTIONS(9898),
    [anon_sym_struct] = ACTIONS(9898),
    [anon_sym_function] = ACTIONS(9898),
    [anon_sym_macro] = ACTIONS(9898),
    [anon_sym_quote] = ACTIONS(9898),
    [anon_sym_let] = ACTIONS(9898),
    [anon_sym_if] = ACTIONS(9898),
    [anon_sym_try] = ACTIONS(9898),
    [anon_sym_for] = ACTIONS(9898),
    [anon_sym_while] = ACTIONS(9898),
    [sym_break_statement] = ACTIONS(9898),
    [sym_continue_statement] = ACTIONS(9898),
    [anon_sym_return] = ACTIONS(9898),
    [anon_sym_const] = ACTIONS(9898),
    [anon_sym_global] = ACTIONS(9898),
    [anon_sym_local] = ACTIONS(9898),
    [anon_sym_LPAREN] = ACTIONS(9898),
    [anon_sym_export] = ACTIONS(9898),
    [anon_sym_public] = ACTIONS(9898),
    [anon_sym_import] = ACTIONS(9898),
    [anon_sym_using] = ACTIONS(9898),
    [anon_sym_LBRACK] = ACTIONS(9898),
    [anon_sym_LBRACE] = ACTIONS(9898),
    [anon_sym_DOLLAR] = ACTIONS(9898),
    [anon_sym_COLON2] = ACTIONS(9898),
    [anon_sym_COLON_COLON] = ACTIONS(9898),
    [anon_sym_AT] = ACTIONS(9898),
    [anon_sym_true] = ACTIONS(9898),
    [anon_sym_false] = ACTIONS(9898),
    [aux_sym_integer_literal_token1] = ACTIONS(9898),
    [aux_sym_integer_literal_token2] = ACTIONS(9898),
    [aux_sym_integer_literal_token3] = ACTIONS(9898),
    [aux_sym_integer_literal_token4] = ACTIONS(9898),
    [aux_sym_float_literal_token1] = ACTIONS(9898),
    [aux_sym_float_literal_token3] = ACTIONS(9898),
    [aux_sym_float_literal_token4] = ACTIONS(9898),
    [sym_character_literal] = ACTIONS(9898),
    [anon_sym_DQUOTE] = ACTIONS(9898),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE] = ACTIONS(9898),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9898),
    [sym__pair_operator] = ACTIONS(9898),
    [sym__arrow_operator] = ACTIONS(9898),
    [sym__comparison_operator] = ACTIONS(9898),
    [sym__pipe_right_operator] = ACTIONS(9898),
    [sym__pipe_left_operator] = ACTIONS(9898),
    [sym__ellipsis_operator] = ACTIONS(9898),
    [sym__plus_operator] = ACTIONS(9898),
    [sym__times_operator] = ACTIONS(9898),
    [sym__rational_operator] = ACTIONS(9898),
    [sym__bitshift_operator] = ACTIONS(9898),
    [sym__power_operator] = ACTIONS(9898),
    [sym__tilde_operator] = ACTIONS(9898),
    [sym__type_order_operator] = ACTIONS(9898),
    [sym__unary_operator] = ACTIONS(9898),
    [sym__unary_plus_operator] = ACTIONS(9898),
    [aux_sym__terminator_token1] = ACTIONS(9900),
    [aux_sym__terminator_token2] = ACTIONS(9898),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9450] = {
    [sym_block_comment] = STATE(9450),
    [sym_line_comment] = STATE(9450),
    [sym__word_identifier] = ACTIONS(9920),
    [anon_sym_begin] = ACTIONS(9920),
    [anon_sym_module] = ACTIONS(9920),
    [anon_sym_baremodule] = ACTIONS(9920),
    [anon_sym_end] = ACTIONS(9920),
    [anon_sym_abstract] = ACTIONS(9920),
    [anon_sym_primitive] = ACTIONS(9920),
    [anon_sym_mutable] = ACTIONS(9920),
    [anon_sym_struct] = ACTIONS(9920),
    [anon_sym_function] = ACTIONS(9920),
    [anon_sym_macro] = ACTIONS(9920),
    [anon_sym_quote] = ACTIONS(9920),
    [anon_sym_let] = ACTIONS(9920),
    [anon_sym_if] = ACTIONS(9920),
    [anon_sym_try] = ACTIONS(9920),
    [anon_sym_for] = ACTIONS(9920),
    [anon_sym_while] = ACTIONS(9920),
    [sym_break_statement] = ACTIONS(9920),
    [sym_continue_statement] = ACTIONS(9920),
    [anon_sym_return] = ACTIONS(9920),
    [anon_sym_const] = ACTIONS(9920),
    [anon_sym_global] = ACTIONS(9920),
    [anon_sym_local] = ACTIONS(9920),
    [anon_sym_LPAREN] = ACTIONS(9920),
    [anon_sym_export] = ACTIONS(9920),
    [anon_sym_public] = ACTIONS(9920),
    [anon_sym_import] = ACTIONS(9920),
    [anon_sym_using] = ACTIONS(9920),
    [anon_sym_LBRACK] = ACTIONS(9920),
    [anon_sym_LBRACE] = ACTIONS(9920),
    [anon_sym_DOLLAR] = ACTIONS(9920),
    [anon_sym_COLON2] = ACTIONS(9920),
    [anon_sym_COLON_COLON] = ACTIONS(9920),
    [anon_sym_AT] = ACTIONS(9920),
    [anon_sym_true] = ACTIONS(9920),
    [anon_sym_false] = ACTIONS(9920),
    [aux_sym_integer_literal_token1] = ACTIONS(9920),
    [aux_sym_integer_literal_token2] = ACTIONS(9920),
    [aux_sym_integer_literal_token3] = ACTIONS(9920),
    [aux_sym_integer_literal_token4] = ACTIONS(9920),
    [aux_sym_float_literal_token1] = ACTIONS(9920),
    [aux_sym_float_literal_token3] = ACTIONS(9920),
    [aux_sym_float_literal_token4] = ACTIONS(9920),
    [sym_character_literal] = ACTIONS(9920),
    [anon_sym_DQUOTE] = ACTIONS(9920),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE] = ACTIONS(9920),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9920),
    [sym__pair_operator] = ACTIONS(9920),
    [sym__arrow_operator] = ACTIONS(9920),
    [sym__comparison_operator] = ACTIONS(9920),
    [sym__pipe_right_operator] = ACTIONS(9920),
    [sym__pipe_left_operator] = ACTIONS(9920),
    [sym__ellipsis_operator] = ACTIONS(9920),
    [sym__plus_operator] = ACTIONS(9920),
    [sym__times_operator] = ACTIONS(9920),
    [sym__rational_operator] = ACTIONS(9920),
    [sym__bitshift_operator] = ACTIONS(9920),
    [sym__power_operator] = ACTIONS(9920),
    [sym__tilde_operator] = ACTIONS(9920),
    [sym__type_order_operator] = ACTIONS(9920),
    [sym__unary_operator] = ACTIONS(9920),
    [sym__unary_plus_operator] = ACTIONS(9920),
    [aux_sym__terminator_token1] = ACTIONS(9922),
    [aux_sym__terminator_token2] = ACTIONS(9920),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9451] = {
    [sym_block_comment] = STATE(9451),
    [sym_line_comment] = STATE(9451),
    [sym__word_identifier] = ACTIONS(10044),
    [anon_sym_begin] = ACTIONS(10044),
    [anon_sym_module] = ACTIONS(10044),
    [anon_sym_baremodule] = ACTIONS(10044),
    [anon_sym_end] = ACTIONS(10044),
    [anon_sym_abstract] = ACTIONS(10044),
    [anon_sym_primitive] = ACTIONS(10044),
    [anon_sym_mutable] = ACTIONS(10044),
    [anon_sym_struct] = ACTIONS(10044),
    [anon_sym_function] = ACTIONS(10044),
    [anon_sym_macro] = ACTIONS(10044),
    [anon_sym_quote] = ACTIONS(10044),
    [anon_sym_let] = ACTIONS(10044),
    [anon_sym_if] = ACTIONS(10044),
    [anon_sym_try] = ACTIONS(10044),
    [anon_sym_for] = ACTIONS(10044),
    [anon_sym_while] = ACTIONS(10044),
    [sym_break_statement] = ACTIONS(10044),
    [sym_continue_statement] = ACTIONS(10044),
    [anon_sym_return] = ACTIONS(10044),
    [anon_sym_const] = ACTIONS(10044),
    [anon_sym_global] = ACTIONS(10044),
    [anon_sym_local] = ACTIONS(10044),
    [anon_sym_LPAREN] = ACTIONS(10044),
    [anon_sym_export] = ACTIONS(10044),
    [anon_sym_public] = ACTIONS(10044),
    [anon_sym_import] = ACTIONS(10044),
    [anon_sym_using] = ACTIONS(10044),
    [anon_sym_LBRACK] = ACTIONS(10044),
    [anon_sym_LBRACE] = ACTIONS(10044),
    [anon_sym_DOLLAR] = ACTIONS(10044),
    [anon_sym_COLON2] = ACTIONS(10044),
    [anon_sym_COLON_COLON] = ACTIONS(10044),
    [anon_sym_AT] = ACTIONS(10044),
    [anon_sym_true] = ACTIONS(10044),
    [anon_sym_false] = ACTIONS(10044),
    [aux_sym_integer_literal_token1] = ACTIONS(10044),
    [aux_sym_integer_literal_token2] = ACTIONS(10044),
    [aux_sym_integer_literal_token3] = ACTIONS(10044),
    [aux_sym_integer_literal_token4] = ACTIONS(10044),
    [aux_sym_float_literal_token1] = ACTIONS(10044),
    [aux_sym_float_literal_token3] = ACTIONS(10044),
    [aux_sym_float_literal_token4] = ACTIONS(10044),
    [sym_character_literal] = ACTIONS(10044),
    [anon_sym_DQUOTE] = ACTIONS(10044),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE] = ACTIONS(10044),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10044),
    [sym__pair_operator] = ACTIONS(10044),
    [sym__arrow_operator] = ACTIONS(10044),
    [sym__comparison_operator] = ACTIONS(10044),
    [sym__pipe_right_operator] = ACTIONS(10044),
    [sym__pipe_left_operator] = ACTIONS(10044),
    [sym__ellipsis_operator] = ACTIONS(10044),
    [sym__plus_operator] = ACTIONS(10044),
    [sym__times_operator] = ACTIONS(10044),
    [sym__rational_operator] = ACTIONS(10044),
    [sym__bitshift_operator] = ACTIONS(10044),
    [sym__power_operator] = ACTIONS(10044),
    [sym__tilde_operator] = ACTIONS(10044),
    [sym__type_order_operator] = ACTIONS(10044),
    [sym__unary_operator] = ACTIONS(10044),
    [sym__unary_plus_operator] = ACTIONS(10044),
    [aux_sym__terminator_token1] = ACTIONS(10046),
    [aux_sym__terminator_token2] = ACTIONS(10044),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9452] = {
    [sym_block_comment] = STATE(9452),
    [sym_line_comment] = STATE(9452),
    [sym__word_identifier] = ACTIONS(9986),
    [anon_sym_begin] = ACTIONS(9986),
    [anon_sym_module] = ACTIONS(9986),
    [anon_sym_baremodule] = ACTIONS(9986),
    [anon_sym_end] = ACTIONS(9986),
    [anon_sym_abstract] = ACTIONS(9986),
    [anon_sym_primitive] = ACTIONS(9986),
    [anon_sym_mutable] = ACTIONS(9986),
    [anon_sym_struct] = ACTIONS(9986),
    [anon_sym_function] = ACTIONS(9986),
    [anon_sym_macro] = ACTIONS(9986),
    [anon_sym_quote] = ACTIONS(9986),
    [anon_sym_let] = ACTIONS(9986),
    [anon_sym_if] = ACTIONS(9986),
    [anon_sym_try] = ACTIONS(9986),
    [anon_sym_for] = ACTIONS(9986),
    [anon_sym_while] = ACTIONS(9986),
    [sym_break_statement] = ACTIONS(9986),
    [sym_continue_statement] = ACTIONS(9986),
    [anon_sym_return] = ACTIONS(9986),
    [anon_sym_const] = ACTIONS(9986),
    [anon_sym_global] = ACTIONS(9986),
    [anon_sym_local] = ACTIONS(9986),
    [anon_sym_LPAREN] = ACTIONS(9986),
    [anon_sym_export] = ACTIONS(9986),
    [anon_sym_public] = ACTIONS(9986),
    [anon_sym_import] = ACTIONS(9986),
    [anon_sym_using] = ACTIONS(9986),
    [anon_sym_LBRACK] = ACTIONS(9986),
    [anon_sym_LBRACE] = ACTIONS(9986),
    [anon_sym_DOLLAR] = ACTIONS(9986),
    [anon_sym_COLON2] = ACTIONS(9986),
    [anon_sym_COLON_COLON] = ACTIONS(9986),
    [anon_sym_AT] = ACTIONS(9986),
    [anon_sym_true] = ACTIONS(9986),
    [anon_sym_false] = ACTIONS(9986),
    [aux_sym_integer_literal_token1] = ACTIONS(9986),
    [aux_sym_integer_literal_token2] = ACTIONS(9986),
    [aux_sym_integer_literal_token3] = ACTIONS(9986),
    [aux_sym_integer_literal_token4] = ACTIONS(9986),
    [aux_sym_float_literal_token1] = ACTIONS(9986),
    [aux_sym_float_literal_token3] = ACTIONS(9986),
    [aux_sym_float_literal_token4] = ACTIONS(9986),
    [sym_character_literal] = ACTIONS(9986),
    [anon_sym_DQUOTE] = ACTIONS(9986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE] = ACTIONS(9986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9986),
    [sym__pair_operator] = ACTIONS(9986),
    [sym__arrow_operator] = ACTIONS(9986),
    [sym__comparison_operator] = ACTIONS(9986),
    [sym__pipe_right_operator] = ACTIONS(9986),
    [sym__pipe_left_operator] = ACTIONS(9986),
    [sym__ellipsis_operator] = ACTIONS(9986),
    [sym__plus_operator] = ACTIONS(9986),
    [sym__times_operator] = ACTIONS(9986),
    [sym__rational_operator] = ACTIONS(9986),
    [sym__bitshift_operator] = ACTIONS(9986),
    [sym__power_operator] = ACTIONS(9986),
    [sym__tilde_operator] = ACTIONS(9986),
    [sym__type_order_operator] = ACTIONS(9986),
    [sym__unary_operator] = ACTIONS(9986),
    [sym__unary_plus_operator] = ACTIONS(9986),
    [aux_sym__terminator_token1] = ACTIONS(9988),
    [aux_sym__terminator_token2] = ACTIONS(9986),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9453] = {
    [sym_block_comment] = STATE(9453),
    [sym_line_comment] = STATE(9453),
    [sym__word_identifier] = ACTIONS(9724),
    [anon_sym_begin] = ACTIONS(9724),
    [anon_sym_module] = ACTIONS(9724),
    [anon_sym_baremodule] = ACTIONS(9724),
    [anon_sym_end] = ACTIONS(9724),
    [anon_sym_abstract] = ACTIONS(9724),
    [anon_sym_primitive] = ACTIONS(9724),
    [anon_sym_mutable] = ACTIONS(9724),
    [anon_sym_struct] = ACTIONS(9724),
    [anon_sym_function] = ACTIONS(9724),
    [anon_sym_macro] = ACTIONS(9724),
    [anon_sym_quote] = ACTIONS(9724),
    [anon_sym_let] = ACTIONS(9724),
    [anon_sym_if] = ACTIONS(9724),
    [anon_sym_try] = ACTIONS(9724),
    [anon_sym_for] = ACTIONS(9724),
    [anon_sym_while] = ACTIONS(9724),
    [sym_break_statement] = ACTIONS(9724),
    [sym_continue_statement] = ACTIONS(9724),
    [anon_sym_return] = ACTIONS(9724),
    [anon_sym_const] = ACTIONS(9724),
    [anon_sym_global] = ACTIONS(9724),
    [anon_sym_local] = ACTIONS(9724),
    [anon_sym_LPAREN] = ACTIONS(9724),
    [anon_sym_export] = ACTIONS(9724),
    [anon_sym_public] = ACTIONS(9724),
    [anon_sym_import] = ACTIONS(9724),
    [anon_sym_using] = ACTIONS(9724),
    [anon_sym_LBRACK] = ACTIONS(9724),
    [anon_sym_LBRACE] = ACTIONS(9724),
    [anon_sym_DOLLAR] = ACTIONS(9724),
    [anon_sym_COLON2] = ACTIONS(9724),
    [anon_sym_COLON_COLON] = ACTIONS(9724),
    [anon_sym_AT] = ACTIONS(9724),
    [anon_sym_true] = ACTIONS(9724),
    [anon_sym_false] = ACTIONS(9724),
    [aux_sym_integer_literal_token1] = ACTIONS(9724),
    [aux_sym_integer_literal_token2] = ACTIONS(9724),
    [aux_sym_integer_literal_token3] = ACTIONS(9724),
    [aux_sym_integer_literal_token4] = ACTIONS(9724),
    [aux_sym_float_literal_token1] = ACTIONS(9724),
    [aux_sym_float_literal_token3] = ACTIONS(9724),
    [aux_sym_float_literal_token4] = ACTIONS(9724),
    [sym_character_literal] = ACTIONS(9724),
    [anon_sym_DQUOTE] = ACTIONS(9724),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE] = ACTIONS(9724),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9724),
    [sym__pair_operator] = ACTIONS(9724),
    [sym__arrow_operator] = ACTIONS(9724),
    [sym__comparison_operator] = ACTIONS(9724),
    [sym__pipe_right_operator] = ACTIONS(9724),
    [sym__pipe_left_operator] = ACTIONS(9724),
    [sym__ellipsis_operator] = ACTIONS(9724),
    [sym__plus_operator] = ACTIONS(9724),
    [sym__times_operator] = ACTIONS(9724),
    [sym__rational_operator] = ACTIONS(9724),
    [sym__bitshift_operator] = ACTIONS(9724),
    [sym__power_operator] = ACTIONS(9724),
    [sym__tilde_operator] = ACTIONS(9724),
    [sym__type_order_operator] = ACTIONS(9724),
    [sym__unary_operator] = ACTIONS(9724),
    [sym__unary_plus_operator] = ACTIONS(9724),
    [aux_sym__terminator_token1] = ACTIONS(9728),
    [aux_sym__terminator_token2] = ACTIONS(9724),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9454] = {
    [sym_block_comment] = STATE(9454),
    [sym_line_comment] = STATE(9454),
    [sym__word_identifier] = ACTIONS(10060),
    [anon_sym_begin] = ACTIONS(10060),
    [anon_sym_module] = ACTIONS(10060),
    [anon_sym_baremodule] = ACTIONS(10060),
    [anon_sym_end] = ACTIONS(10060),
    [anon_sym_abstract] = ACTIONS(10060),
    [anon_sym_primitive] = ACTIONS(10060),
    [anon_sym_mutable] = ACTIONS(10060),
    [anon_sym_struct] = ACTIONS(10060),
    [anon_sym_function] = ACTIONS(10060),
    [anon_sym_macro] = ACTIONS(10060),
    [anon_sym_quote] = ACTIONS(10060),
    [anon_sym_let] = ACTIONS(10060),
    [anon_sym_if] = ACTIONS(10060),
    [anon_sym_try] = ACTIONS(10060),
    [anon_sym_for] = ACTIONS(10060),
    [anon_sym_while] = ACTIONS(10060),
    [sym_break_statement] = ACTIONS(10060),
    [sym_continue_statement] = ACTIONS(10060),
    [anon_sym_return] = ACTIONS(10060),
    [anon_sym_const] = ACTIONS(10060),
    [anon_sym_global] = ACTIONS(10060),
    [anon_sym_local] = ACTIONS(10060),
    [anon_sym_LPAREN] = ACTIONS(10060),
    [anon_sym_export] = ACTIONS(10060),
    [anon_sym_public] = ACTIONS(10060),
    [anon_sym_import] = ACTIONS(10060),
    [anon_sym_using] = ACTIONS(10060),
    [anon_sym_LBRACK] = ACTIONS(10060),
    [anon_sym_LBRACE] = ACTIONS(10060),
    [anon_sym_DOLLAR] = ACTIONS(10060),
    [anon_sym_COLON2] = ACTIONS(10060),
    [anon_sym_COLON_COLON] = ACTIONS(10060),
    [anon_sym_AT] = ACTIONS(10060),
    [anon_sym_true] = ACTIONS(10060),
    [anon_sym_false] = ACTIONS(10060),
    [aux_sym_integer_literal_token1] = ACTIONS(10060),
    [aux_sym_integer_literal_token2] = ACTIONS(10060),
    [aux_sym_integer_literal_token3] = ACTIONS(10060),
    [aux_sym_integer_literal_token4] = ACTIONS(10060),
    [aux_sym_float_literal_token1] = ACTIONS(10060),
    [aux_sym_float_literal_token3] = ACTIONS(10060),
    [aux_sym_float_literal_token4] = ACTIONS(10060),
    [sym_character_literal] = ACTIONS(10060),
    [anon_sym_DQUOTE] = ACTIONS(10060),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE] = ACTIONS(10060),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10060),
    [sym__pair_operator] = ACTIONS(10060),
    [sym__arrow_operator] = ACTIONS(10060),
    [sym__comparison_operator] = ACTIONS(10060),
    [sym__pipe_right_operator] = ACTIONS(10060),
    [sym__pipe_left_operator] = ACTIONS(10060),
    [sym__ellipsis_operator] = ACTIONS(10060),
    [sym__plus_operator] = ACTIONS(10060),
    [sym__times_operator] = ACTIONS(10060),
    [sym__rational_operator] = ACTIONS(10060),
    [sym__bitshift_operator] = ACTIONS(10060),
    [sym__power_operator] = ACTIONS(10060),
    [sym__tilde_operator] = ACTIONS(10060),
    [sym__type_order_operator] = ACTIONS(10060),
    [sym__unary_operator] = ACTIONS(10060),
    [sym__unary_plus_operator] = ACTIONS(10060),
    [aux_sym__terminator_token1] = ACTIONS(10062),
    [aux_sym__terminator_token2] = ACTIONS(10060),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9455] = {
    [sym_block_comment] = STATE(9455),
    [sym_line_comment] = STATE(9455),
    [sym__word_identifier] = ACTIONS(10072),
    [anon_sym_begin] = ACTIONS(10072),
    [anon_sym_module] = ACTIONS(10072),
    [anon_sym_baremodule] = ACTIONS(10072),
    [anon_sym_end] = ACTIONS(10072),
    [anon_sym_abstract] = ACTIONS(10072),
    [anon_sym_primitive] = ACTIONS(10072),
    [anon_sym_mutable] = ACTIONS(10072),
    [anon_sym_struct] = ACTIONS(10072),
    [anon_sym_function] = ACTIONS(10072),
    [anon_sym_macro] = ACTIONS(10072),
    [anon_sym_quote] = ACTIONS(10072),
    [anon_sym_let] = ACTIONS(10072),
    [anon_sym_if] = ACTIONS(10072),
    [anon_sym_try] = ACTIONS(10072),
    [anon_sym_for] = ACTIONS(10072),
    [anon_sym_while] = ACTIONS(10072),
    [sym_break_statement] = ACTIONS(10072),
    [sym_continue_statement] = ACTIONS(10072),
    [anon_sym_return] = ACTIONS(10072),
    [anon_sym_const] = ACTIONS(10072),
    [anon_sym_global] = ACTIONS(10072),
    [anon_sym_local] = ACTIONS(10072),
    [anon_sym_LPAREN] = ACTIONS(10072),
    [anon_sym_export] = ACTIONS(10072),
    [anon_sym_public] = ACTIONS(10072),
    [anon_sym_import] = ACTIONS(10072),
    [anon_sym_using] = ACTIONS(10072),
    [anon_sym_LBRACK] = ACTIONS(10072),
    [anon_sym_LBRACE] = ACTIONS(10072),
    [anon_sym_DOLLAR] = ACTIONS(10072),
    [anon_sym_COLON2] = ACTIONS(10072),
    [anon_sym_COLON_COLON] = ACTIONS(10072),
    [anon_sym_AT] = ACTIONS(10072),
    [anon_sym_true] = ACTIONS(10072),
    [anon_sym_false] = ACTIONS(10072),
    [aux_sym_integer_literal_token1] = ACTIONS(10072),
    [aux_sym_integer_literal_token2] = ACTIONS(10072),
    [aux_sym_integer_literal_token3] = ACTIONS(10072),
    [aux_sym_integer_literal_token4] = ACTIONS(10072),
    [aux_sym_float_literal_token1] = ACTIONS(10072),
    [aux_sym_float_literal_token3] = ACTIONS(10072),
    [aux_sym_float_literal_token4] = ACTIONS(10072),
    [sym_character_literal] = ACTIONS(10072),
    [anon_sym_DQUOTE] = ACTIONS(10072),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE] = ACTIONS(10072),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10072),
    [sym__pair_operator] = ACTIONS(10072),
    [sym__arrow_operator] = ACTIONS(10072),
    [sym__comparison_operator] = ACTIONS(10072),
    [sym__pipe_right_operator] = ACTIONS(10072),
    [sym__pipe_left_operator] = ACTIONS(10072),
    [sym__ellipsis_operator] = ACTIONS(10072),
    [sym__plus_operator] = ACTIONS(10072),
    [sym__times_operator] = ACTIONS(10072),
    [sym__rational_operator] = ACTIONS(10072),
    [sym__bitshift_operator] = ACTIONS(10072),
    [sym__power_operator] = ACTIONS(10072),
    [sym__tilde_operator] = ACTIONS(10072),
    [sym__type_order_operator] = ACTIONS(10072),
    [sym__unary_operator] = ACTIONS(10072),
    [sym__unary_plus_operator] = ACTIONS(10072),
    [aux_sym__terminator_token1] = ACTIONS(10074),
    [aux_sym__terminator_token2] = ACTIONS(10072),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9456] = {
    [sym_block_comment] = STATE(9456),
    [sym_line_comment] = STATE(9456),
    [sym__word_identifier] = ACTIONS(9760),
    [anon_sym_begin] = ACTIONS(9760),
    [anon_sym_module] = ACTIONS(9760),
    [anon_sym_baremodule] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9760),
    [anon_sym_abstract] = ACTIONS(9760),
    [anon_sym_primitive] = ACTIONS(9760),
    [anon_sym_mutable] = ACTIONS(9760),
    [anon_sym_struct] = ACTIONS(9760),
    [anon_sym_function] = ACTIONS(9760),
    [anon_sym_macro] = ACTIONS(9760),
    [anon_sym_quote] = ACTIONS(9760),
    [anon_sym_let] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9760),
    [anon_sym_try] = ACTIONS(9760),
    [anon_sym_for] = ACTIONS(9760),
    [anon_sym_while] = ACTIONS(9760),
    [sym_break_statement] = ACTIONS(9760),
    [sym_continue_statement] = ACTIONS(9760),
    [anon_sym_return] = ACTIONS(9760),
    [anon_sym_const] = ACTIONS(9760),
    [anon_sym_global] = ACTIONS(9760),
    [anon_sym_local] = ACTIONS(9760),
    [anon_sym_LPAREN] = ACTIONS(9760),
    [anon_sym_export] = ACTIONS(9760),
    [anon_sym_public] = ACTIONS(9760),
    [anon_sym_import] = ACTIONS(9760),
    [anon_sym_using] = ACTIONS(9760),
    [anon_sym_LBRACK] = ACTIONS(9760),
    [anon_sym_LBRACE] = ACTIONS(9760),
    [anon_sym_DOLLAR] = ACTIONS(9760),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_COLON_COLON] = ACTIONS(9760),
    [anon_sym_AT] = ACTIONS(9760),
    [anon_sym_true] = ACTIONS(9760),
    [anon_sym_false] = ACTIONS(9760),
    [aux_sym_integer_literal_token1] = ACTIONS(9760),
    [aux_sym_integer_literal_token2] = ACTIONS(9760),
    [aux_sym_integer_literal_token3] = ACTIONS(9760),
    [aux_sym_integer_literal_token4] = ACTIONS(9760),
    [aux_sym_float_literal_token1] = ACTIONS(9760),
    [aux_sym_float_literal_token3] = ACTIONS(9760),
    [aux_sym_float_literal_token4] = ACTIONS(9760),
    [sym_character_literal] = ACTIONS(9760),
    [anon_sym_DQUOTE] = ACTIONS(9760),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE] = ACTIONS(9760),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9760),
    [sym__pair_operator] = ACTIONS(9760),
    [sym__arrow_operator] = ACTIONS(9760),
    [sym__comparison_operator] = ACTIONS(9760),
    [sym__pipe_right_operator] = ACTIONS(9760),
    [sym__pipe_left_operator] = ACTIONS(9760),
    [sym__ellipsis_operator] = ACTIONS(9760),
    [sym__plus_operator] = ACTIONS(9760),
    [sym__times_operator] = ACTIONS(9760),
    [sym__rational_operator] = ACTIONS(9760),
    [sym__bitshift_operator] = ACTIONS(9760),
    [sym__power_operator] = ACTIONS(9760),
    [sym__tilde_operator] = ACTIONS(9760),
    [sym__type_order_operator] = ACTIONS(9760),
    [sym__unary_operator] = ACTIONS(9760),
    [sym__unary_plus_operator] = ACTIONS(9760),
    [aux_sym__terminator_token1] = ACTIONS(9762),
    [aux_sym__terminator_token2] = ACTIONS(9760),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9457] = {
    [sym_block_comment] = STATE(9457),
    [sym_line_comment] = STATE(9457),
    [sym__word_identifier] = ACTIONS(10040),
    [anon_sym_begin] = ACTIONS(10040),
    [anon_sym_module] = ACTIONS(10040),
    [anon_sym_baremodule] = ACTIONS(10040),
    [anon_sym_end] = ACTIONS(10040),
    [anon_sym_abstract] = ACTIONS(10040),
    [anon_sym_primitive] = ACTIONS(10040),
    [anon_sym_mutable] = ACTIONS(10040),
    [anon_sym_struct] = ACTIONS(10040),
    [anon_sym_function] = ACTIONS(10040),
    [anon_sym_macro] = ACTIONS(10040),
    [anon_sym_quote] = ACTIONS(10040),
    [anon_sym_let] = ACTIONS(10040),
    [anon_sym_if] = ACTIONS(10040),
    [anon_sym_try] = ACTIONS(10040),
    [anon_sym_for] = ACTIONS(10040),
    [anon_sym_while] = ACTIONS(10040),
    [sym_break_statement] = ACTIONS(10040),
    [sym_continue_statement] = ACTIONS(10040),
    [anon_sym_return] = ACTIONS(10040),
    [anon_sym_const] = ACTIONS(10040),
    [anon_sym_global] = ACTIONS(10040),
    [anon_sym_local] = ACTIONS(10040),
    [anon_sym_LPAREN] = ACTIONS(10040),
    [anon_sym_export] = ACTIONS(10040),
    [anon_sym_public] = ACTIONS(10040),
    [anon_sym_import] = ACTIONS(10040),
    [anon_sym_using] = ACTIONS(10040),
    [anon_sym_LBRACK] = ACTIONS(10040),
    [anon_sym_LBRACE] = ACTIONS(10040),
    [anon_sym_DOLLAR] = ACTIONS(10040),
    [anon_sym_COLON2] = ACTIONS(10040),
    [anon_sym_COLON_COLON] = ACTIONS(10040),
    [anon_sym_AT] = ACTIONS(10040),
    [anon_sym_true] = ACTIONS(10040),
    [anon_sym_false] = ACTIONS(10040),
    [aux_sym_integer_literal_token1] = ACTIONS(10040),
    [aux_sym_integer_literal_token2] = ACTIONS(10040),
    [aux_sym_integer_literal_token3] = ACTIONS(10040),
    [aux_sym_integer_literal_token4] = ACTIONS(10040),
    [aux_sym_float_literal_token1] = ACTIONS(10040),
    [aux_sym_float_literal_token3] = ACTIONS(10040),
    [aux_sym_float_literal_token4] = ACTIONS(10040),
    [sym_character_literal] = ACTIONS(10040),
    [anon_sym_DQUOTE] = ACTIONS(10040),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE] = ACTIONS(10040),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10040),
    [sym__pair_operator] = ACTIONS(10040),
    [sym__arrow_operator] = ACTIONS(10040),
    [sym__comparison_operator] = ACTIONS(10040),
    [sym__pipe_right_operator] = ACTIONS(10040),
    [sym__pipe_left_operator] = ACTIONS(10040),
    [sym__ellipsis_operator] = ACTIONS(10040),
    [sym__plus_operator] = ACTIONS(10040),
    [sym__times_operator] = ACTIONS(10040),
    [sym__rational_operator] = ACTIONS(10040),
    [sym__bitshift_operator] = ACTIONS(10040),
    [sym__power_operator] = ACTIONS(10040),
    [sym__tilde_operator] = ACTIONS(10040),
    [sym__type_order_operator] = ACTIONS(10040),
    [sym__unary_operator] = ACTIONS(10040),
    [sym__unary_plus_operator] = ACTIONS(10040),
    [aux_sym__terminator_token1] = ACTIONS(10042),
    [aux_sym__terminator_token2] = ACTIONS(10040),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9458] = {
    [sym_block_comment] = STATE(9458),
    [sym_line_comment] = STATE(9458),
    [sym__word_identifier] = ACTIONS(9736),
    [anon_sym_begin] = ACTIONS(9736),
    [anon_sym_module] = ACTIONS(9736),
    [anon_sym_baremodule] = ACTIONS(9736),
    [anon_sym_end] = ACTIONS(9736),
    [anon_sym_abstract] = ACTIONS(9736),
    [anon_sym_primitive] = ACTIONS(9736),
    [anon_sym_mutable] = ACTIONS(9736),
    [anon_sym_struct] = ACTIONS(9736),
    [anon_sym_function] = ACTIONS(9736),
    [anon_sym_macro] = ACTIONS(9736),
    [anon_sym_quote] = ACTIONS(9736),
    [anon_sym_let] = ACTIONS(9736),
    [anon_sym_if] = ACTIONS(9736),
    [anon_sym_try] = ACTIONS(9736),
    [anon_sym_for] = ACTIONS(9736),
    [anon_sym_while] = ACTIONS(9736),
    [sym_break_statement] = ACTIONS(9736),
    [sym_continue_statement] = ACTIONS(9736),
    [anon_sym_return] = ACTIONS(9736),
    [anon_sym_const] = ACTIONS(9736),
    [anon_sym_global] = ACTIONS(9736),
    [anon_sym_local] = ACTIONS(9736),
    [anon_sym_LPAREN] = ACTIONS(9736),
    [anon_sym_export] = ACTIONS(9736),
    [anon_sym_public] = ACTIONS(9736),
    [anon_sym_import] = ACTIONS(9736),
    [anon_sym_using] = ACTIONS(9736),
    [anon_sym_LBRACK] = ACTIONS(9736),
    [anon_sym_LBRACE] = ACTIONS(9736),
    [anon_sym_DOLLAR] = ACTIONS(9736),
    [anon_sym_COLON2] = ACTIONS(9736),
    [anon_sym_COLON_COLON] = ACTIONS(9736),
    [anon_sym_AT] = ACTIONS(9736),
    [anon_sym_true] = ACTIONS(9736),
    [anon_sym_false] = ACTIONS(9736),
    [aux_sym_integer_literal_token1] = ACTIONS(9736),
    [aux_sym_integer_literal_token2] = ACTIONS(9736),
    [aux_sym_integer_literal_token3] = ACTIONS(9736),
    [aux_sym_integer_literal_token4] = ACTIONS(9736),
    [aux_sym_float_literal_token1] = ACTIONS(9736),
    [aux_sym_float_literal_token3] = ACTIONS(9736),
    [aux_sym_float_literal_token4] = ACTIONS(9736),
    [sym_character_literal] = ACTIONS(9736),
    [anon_sym_DQUOTE] = ACTIONS(9736),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE] = ACTIONS(9736),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9736),
    [sym__pair_operator] = ACTIONS(9736),
    [sym__arrow_operator] = ACTIONS(9736),
    [sym__comparison_operator] = ACTIONS(9736),
    [sym__pipe_right_operator] = ACTIONS(9736),
    [sym__pipe_left_operator] = ACTIONS(9736),
    [sym__ellipsis_operator] = ACTIONS(9736),
    [sym__plus_operator] = ACTIONS(9736),
    [sym__times_operator] = ACTIONS(9736),
    [sym__rational_operator] = ACTIONS(9736),
    [sym__bitshift_operator] = ACTIONS(9736),
    [sym__power_operator] = ACTIONS(9736),
    [sym__tilde_operator] = ACTIONS(9736),
    [sym__type_order_operator] = ACTIONS(9736),
    [sym__unary_operator] = ACTIONS(9736),
    [sym__unary_plus_operator] = ACTIONS(9736),
    [aux_sym__terminator_token1] = ACTIONS(9740),
    [aux_sym__terminator_token2] = ACTIONS(9736),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9459] = {
    [sym_block_comment] = STATE(9459),
    [sym_line_comment] = STATE(9459),
    [sym__word_identifier] = ACTIONS(10064),
    [anon_sym_begin] = ACTIONS(10064),
    [anon_sym_module] = ACTIONS(10064),
    [anon_sym_baremodule] = ACTIONS(10064),
    [anon_sym_end] = ACTIONS(10064),
    [anon_sym_abstract] = ACTIONS(10064),
    [anon_sym_primitive] = ACTIONS(10064),
    [anon_sym_mutable] = ACTIONS(10064),
    [anon_sym_struct] = ACTIONS(10064),
    [anon_sym_function] = ACTIONS(10064),
    [anon_sym_macro] = ACTIONS(10064),
    [anon_sym_quote] = ACTIONS(10064),
    [anon_sym_let] = ACTIONS(10064),
    [anon_sym_if] = ACTIONS(10064),
    [anon_sym_try] = ACTIONS(10064),
    [anon_sym_for] = ACTIONS(10064),
    [anon_sym_while] = ACTIONS(10064),
    [sym_break_statement] = ACTIONS(10064),
    [sym_continue_statement] = ACTIONS(10064),
    [anon_sym_return] = ACTIONS(10064),
    [anon_sym_const] = ACTIONS(10064),
    [anon_sym_global] = ACTIONS(10064),
    [anon_sym_local] = ACTIONS(10064),
    [anon_sym_LPAREN] = ACTIONS(10064),
    [anon_sym_export] = ACTIONS(10064),
    [anon_sym_public] = ACTIONS(10064),
    [anon_sym_import] = ACTIONS(10064),
    [anon_sym_using] = ACTIONS(10064),
    [anon_sym_LBRACK] = ACTIONS(10064),
    [anon_sym_LBRACE] = ACTIONS(10064),
    [anon_sym_DOLLAR] = ACTIONS(10064),
    [anon_sym_COLON2] = ACTIONS(10064),
    [anon_sym_COLON_COLON] = ACTIONS(10064),
    [anon_sym_AT] = ACTIONS(10064),
    [anon_sym_true] = ACTIONS(10064),
    [anon_sym_false] = ACTIONS(10064),
    [aux_sym_integer_literal_token1] = ACTIONS(10064),
    [aux_sym_integer_literal_token2] = ACTIONS(10064),
    [aux_sym_integer_literal_token3] = ACTIONS(10064),
    [aux_sym_integer_literal_token4] = ACTIONS(10064),
    [aux_sym_float_literal_token1] = ACTIONS(10064),
    [aux_sym_float_literal_token3] = ACTIONS(10064),
    [aux_sym_float_literal_token4] = ACTIONS(10064),
    [sym_character_literal] = ACTIONS(10064),
    [anon_sym_DQUOTE] = ACTIONS(10064),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE] = ACTIONS(10064),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10064),
    [sym__pair_operator] = ACTIONS(10064),
    [sym__arrow_operator] = ACTIONS(10064),
    [sym__comparison_operator] = ACTIONS(10064),
    [sym__pipe_right_operator] = ACTIONS(10064),
    [sym__pipe_left_operator] = ACTIONS(10064),
    [sym__ellipsis_operator] = ACTIONS(10064),
    [sym__plus_operator] = ACTIONS(10064),
    [sym__times_operator] = ACTIONS(10064),
    [sym__rational_operator] = ACTIONS(10064),
    [sym__bitshift_operator] = ACTIONS(10064),
    [sym__power_operator] = ACTIONS(10064),
    [sym__tilde_operator] = ACTIONS(10064),
    [sym__type_order_operator] = ACTIONS(10064),
    [sym__unary_operator] = ACTIONS(10064),
    [sym__unary_plus_operator] = ACTIONS(10064),
    [aux_sym__terminator_token1] = ACTIONS(10066),
    [aux_sym__terminator_token2] = ACTIONS(10064),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9460] = {
    [sym_block_comment] = STATE(9460),
    [sym_line_comment] = STATE(9460),
    [sym__word_identifier] = ACTIONS(10076),
    [anon_sym_begin] = ACTIONS(10076),
    [anon_sym_module] = ACTIONS(10076),
    [anon_sym_baremodule] = ACTIONS(10076),
    [anon_sym_end] = ACTIONS(10076),
    [anon_sym_abstract] = ACTIONS(10076),
    [anon_sym_primitive] = ACTIONS(10076),
    [anon_sym_mutable] = ACTIONS(10076),
    [anon_sym_struct] = ACTIONS(10076),
    [anon_sym_function] = ACTIONS(10076),
    [anon_sym_macro] = ACTIONS(10076),
    [anon_sym_quote] = ACTIONS(10076),
    [anon_sym_let] = ACTIONS(10076),
    [anon_sym_if] = ACTIONS(10076),
    [anon_sym_try] = ACTIONS(10076),
    [anon_sym_for] = ACTIONS(10076),
    [anon_sym_while] = ACTIONS(10076),
    [sym_break_statement] = ACTIONS(10076),
    [sym_continue_statement] = ACTIONS(10076),
    [anon_sym_return] = ACTIONS(10076),
    [anon_sym_const] = ACTIONS(10076),
    [anon_sym_global] = ACTIONS(10076),
    [anon_sym_local] = ACTIONS(10076),
    [anon_sym_LPAREN] = ACTIONS(10076),
    [anon_sym_export] = ACTIONS(10076),
    [anon_sym_public] = ACTIONS(10076),
    [anon_sym_import] = ACTIONS(10076),
    [anon_sym_using] = ACTIONS(10076),
    [anon_sym_LBRACK] = ACTIONS(10076),
    [anon_sym_LBRACE] = ACTIONS(10076),
    [anon_sym_DOLLAR] = ACTIONS(10076),
    [anon_sym_COLON2] = ACTIONS(10076),
    [anon_sym_COLON_COLON] = ACTIONS(10076),
    [anon_sym_AT] = ACTIONS(10076),
    [anon_sym_true] = ACTIONS(10076),
    [anon_sym_false] = ACTIONS(10076),
    [aux_sym_integer_literal_token1] = ACTIONS(10076),
    [aux_sym_integer_literal_token2] = ACTIONS(10076),
    [aux_sym_integer_literal_token3] = ACTIONS(10076),
    [aux_sym_integer_literal_token4] = ACTIONS(10076),
    [aux_sym_float_literal_token1] = ACTIONS(10076),
    [aux_sym_float_literal_token3] = ACTIONS(10076),
    [aux_sym_float_literal_token4] = ACTIONS(10076),
    [sym_character_literal] = ACTIONS(10076),
    [anon_sym_DQUOTE] = ACTIONS(10076),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE] = ACTIONS(10076),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10076),
    [sym__pair_operator] = ACTIONS(10076),
    [sym__arrow_operator] = ACTIONS(10076),
    [sym__comparison_operator] = ACTIONS(10076),
    [sym__pipe_right_operator] = ACTIONS(10076),
    [sym__pipe_left_operator] = ACTIONS(10076),
    [sym__ellipsis_operator] = ACTIONS(10076),
    [sym__plus_operator] = ACTIONS(10076),
    [sym__times_operator] = ACTIONS(10076),
    [sym__rational_operator] = ACTIONS(10076),
    [sym__bitshift_operator] = ACTIONS(10076),
    [sym__power_operator] = ACTIONS(10076),
    [sym__tilde_operator] = ACTIONS(10076),
    [sym__type_order_operator] = ACTIONS(10076),
    [sym__unary_operator] = ACTIONS(10076),
    [sym__unary_plus_operator] = ACTIONS(10076),
    [aux_sym__terminator_token1] = ACTIONS(10078),
    [aux_sym__terminator_token2] = ACTIONS(10076),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9461] = {
    [sym_block_comment] = STATE(9461),
    [sym_line_comment] = STATE(9461),
    [sym__word_identifier] = ACTIONS(10018),
    [anon_sym_begin] = ACTIONS(10018),
    [anon_sym_module] = ACTIONS(10018),
    [anon_sym_baremodule] = ACTIONS(10018),
    [anon_sym_end] = ACTIONS(10018),
    [anon_sym_abstract] = ACTIONS(10018),
    [anon_sym_primitive] = ACTIONS(10018),
    [anon_sym_mutable] = ACTIONS(10018),
    [anon_sym_struct] = ACTIONS(10018),
    [anon_sym_function] = ACTIONS(10018),
    [anon_sym_macro] = ACTIONS(10018),
    [anon_sym_quote] = ACTIONS(10018),
    [anon_sym_let] = ACTIONS(10018),
    [anon_sym_if] = ACTIONS(10018),
    [anon_sym_try] = ACTIONS(10018),
    [anon_sym_for] = ACTIONS(10018),
    [anon_sym_while] = ACTIONS(10018),
    [sym_break_statement] = ACTIONS(10018),
    [sym_continue_statement] = ACTIONS(10018),
    [anon_sym_return] = ACTIONS(10018),
    [anon_sym_const] = ACTIONS(10018),
    [anon_sym_global] = ACTIONS(10018),
    [anon_sym_local] = ACTIONS(10018),
    [anon_sym_LPAREN] = ACTIONS(10018),
    [anon_sym_export] = ACTIONS(10018),
    [anon_sym_public] = ACTIONS(10018),
    [anon_sym_import] = ACTIONS(10018),
    [anon_sym_using] = ACTIONS(10018),
    [anon_sym_LBRACK] = ACTIONS(10018),
    [anon_sym_LBRACE] = ACTIONS(10018),
    [anon_sym_DOLLAR] = ACTIONS(10018),
    [anon_sym_COLON2] = ACTIONS(10018),
    [anon_sym_COLON_COLON] = ACTIONS(10018),
    [anon_sym_AT] = ACTIONS(10018),
    [anon_sym_true] = ACTIONS(10018),
    [anon_sym_false] = ACTIONS(10018),
    [aux_sym_integer_literal_token1] = ACTIONS(10018),
    [aux_sym_integer_literal_token2] = ACTIONS(10018),
    [aux_sym_integer_literal_token3] = ACTIONS(10018),
    [aux_sym_integer_literal_token4] = ACTIONS(10018),
    [aux_sym_float_literal_token1] = ACTIONS(10018),
    [aux_sym_float_literal_token3] = ACTIONS(10018),
    [aux_sym_float_literal_token4] = ACTIONS(10018),
    [sym_character_literal] = ACTIONS(10018),
    [anon_sym_DQUOTE] = ACTIONS(10018),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE] = ACTIONS(10018),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10018),
    [sym__pair_operator] = ACTIONS(10018),
    [sym__arrow_operator] = ACTIONS(10018),
    [sym__comparison_operator] = ACTIONS(10018),
    [sym__pipe_right_operator] = ACTIONS(10018),
    [sym__pipe_left_operator] = ACTIONS(10018),
    [sym__ellipsis_operator] = ACTIONS(10018),
    [sym__plus_operator] = ACTIONS(10018),
    [sym__times_operator] = ACTIONS(10018),
    [sym__rational_operator] = ACTIONS(10018),
    [sym__bitshift_operator] = ACTIONS(10018),
    [sym__power_operator] = ACTIONS(10018),
    [sym__tilde_operator] = ACTIONS(10018),
    [sym__type_order_operator] = ACTIONS(10018),
    [sym__unary_operator] = ACTIONS(10018),
    [sym__unary_plus_operator] = ACTIONS(10018),
    [aux_sym__terminator_token1] = ACTIONS(10020),
    [aux_sym__terminator_token2] = ACTIONS(10018),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9462] = {
    [sym_block_comment] = STATE(9462),
    [sym_line_comment] = STATE(9462),
    [sym__word_identifier] = ACTIONS(9982),
    [anon_sym_begin] = ACTIONS(9982),
    [anon_sym_module] = ACTIONS(9982),
    [anon_sym_baremodule] = ACTIONS(9982),
    [anon_sym_end] = ACTIONS(9982),
    [anon_sym_abstract] = ACTIONS(9982),
    [anon_sym_primitive] = ACTIONS(9982),
    [anon_sym_mutable] = ACTIONS(9982),
    [anon_sym_struct] = ACTIONS(9982),
    [anon_sym_function] = ACTIONS(9982),
    [anon_sym_macro] = ACTIONS(9982),
    [anon_sym_quote] = ACTIONS(9982),
    [anon_sym_let] = ACTIONS(9982),
    [anon_sym_if] = ACTIONS(9982),
    [anon_sym_try] = ACTIONS(9982),
    [anon_sym_for] = ACTIONS(9982),
    [anon_sym_while] = ACTIONS(9982),
    [sym_break_statement] = ACTIONS(9982),
    [sym_continue_statement] = ACTIONS(9982),
    [anon_sym_return] = ACTIONS(9982),
    [anon_sym_const] = ACTIONS(9982),
    [anon_sym_global] = ACTIONS(9982),
    [anon_sym_local] = ACTIONS(9982),
    [anon_sym_LPAREN] = ACTIONS(9982),
    [anon_sym_export] = ACTIONS(9982),
    [anon_sym_public] = ACTIONS(9982),
    [anon_sym_import] = ACTIONS(9982),
    [anon_sym_using] = ACTIONS(9982),
    [anon_sym_LBRACK] = ACTIONS(9982),
    [anon_sym_LBRACE] = ACTIONS(9982),
    [anon_sym_DOLLAR] = ACTIONS(9982),
    [anon_sym_COLON2] = ACTIONS(9982),
    [anon_sym_COLON_COLON] = ACTIONS(9982),
    [anon_sym_AT] = ACTIONS(9982),
    [anon_sym_true] = ACTIONS(9982),
    [anon_sym_false] = ACTIONS(9982),
    [aux_sym_integer_literal_token1] = ACTIONS(9982),
    [aux_sym_integer_literal_token2] = ACTIONS(9982),
    [aux_sym_integer_literal_token3] = ACTIONS(9982),
    [aux_sym_integer_literal_token4] = ACTIONS(9982),
    [aux_sym_float_literal_token1] = ACTIONS(9982),
    [aux_sym_float_literal_token3] = ACTIONS(9982),
    [aux_sym_float_literal_token4] = ACTIONS(9982),
    [sym_character_literal] = ACTIONS(9982),
    [anon_sym_DQUOTE] = ACTIONS(9982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE] = ACTIONS(9982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9982),
    [sym__pair_operator] = ACTIONS(9982),
    [sym__arrow_operator] = ACTIONS(9982),
    [sym__comparison_operator] = ACTIONS(9982),
    [sym__pipe_right_operator] = ACTIONS(9982),
    [sym__pipe_left_operator] = ACTIONS(9982),
    [sym__ellipsis_operator] = ACTIONS(9982),
    [sym__plus_operator] = ACTIONS(9982),
    [sym__times_operator] = ACTIONS(9982),
    [sym__rational_operator] = ACTIONS(9982),
    [sym__bitshift_operator] = ACTIONS(9982),
    [sym__power_operator] = ACTIONS(9982),
    [sym__tilde_operator] = ACTIONS(9982),
    [sym__type_order_operator] = ACTIONS(9982),
    [sym__unary_operator] = ACTIONS(9982),
    [sym__unary_plus_operator] = ACTIONS(9982),
    [aux_sym__terminator_token1] = ACTIONS(9984),
    [aux_sym__terminator_token2] = ACTIONS(9982),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9463] = {
    [sym_block_comment] = STATE(9463),
    [sym_line_comment] = STATE(9463),
    [sym__word_identifier] = ACTIONS(9916),
    [anon_sym_begin] = ACTIONS(9916),
    [anon_sym_module] = ACTIONS(9916),
    [anon_sym_baremodule] = ACTIONS(9916),
    [anon_sym_end] = ACTIONS(9916),
    [anon_sym_abstract] = ACTIONS(9916),
    [anon_sym_primitive] = ACTIONS(9916),
    [anon_sym_mutable] = ACTIONS(9916),
    [anon_sym_struct] = ACTIONS(9916),
    [anon_sym_function] = ACTIONS(9916),
    [anon_sym_macro] = ACTIONS(9916),
    [anon_sym_quote] = ACTIONS(9916),
    [anon_sym_let] = ACTIONS(9916),
    [anon_sym_if] = ACTIONS(9916),
    [anon_sym_try] = ACTIONS(9916),
    [anon_sym_for] = ACTIONS(9916),
    [anon_sym_while] = ACTIONS(9916),
    [sym_break_statement] = ACTIONS(9916),
    [sym_continue_statement] = ACTIONS(9916),
    [anon_sym_return] = ACTIONS(9916),
    [anon_sym_const] = ACTIONS(9916),
    [anon_sym_global] = ACTIONS(9916),
    [anon_sym_local] = ACTIONS(9916),
    [anon_sym_LPAREN] = ACTIONS(9916),
    [anon_sym_export] = ACTIONS(9916),
    [anon_sym_public] = ACTIONS(9916),
    [anon_sym_import] = ACTIONS(9916),
    [anon_sym_using] = ACTIONS(9916),
    [anon_sym_LBRACK] = ACTIONS(9916),
    [anon_sym_LBRACE] = ACTIONS(9916),
    [anon_sym_DOLLAR] = ACTIONS(9916),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_COLON_COLON] = ACTIONS(9916),
    [anon_sym_AT] = ACTIONS(9916),
    [anon_sym_true] = ACTIONS(9916),
    [anon_sym_false] = ACTIONS(9916),
    [aux_sym_integer_literal_token1] = ACTIONS(9916),
    [aux_sym_integer_literal_token2] = ACTIONS(9916),
    [aux_sym_integer_literal_token3] = ACTIONS(9916),
    [aux_sym_integer_literal_token4] = ACTIONS(9916),
    [aux_sym_float_literal_token1] = ACTIONS(9916),
    [aux_sym_float_literal_token3] = ACTIONS(9916),
    [aux_sym_float_literal_token4] = ACTIONS(9916),
    [sym_character_literal] = ACTIONS(9916),
    [anon_sym_DQUOTE] = ACTIONS(9916),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE] = ACTIONS(9916),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9916),
    [sym__pair_operator] = ACTIONS(9916),
    [sym__arrow_operator] = ACTIONS(9916),
    [sym__comparison_operator] = ACTIONS(9916),
    [sym__pipe_right_operator] = ACTIONS(9916),
    [sym__pipe_left_operator] = ACTIONS(9916),
    [sym__ellipsis_operator] = ACTIONS(9916),
    [sym__plus_operator] = ACTIONS(9916),
    [sym__times_operator] = ACTIONS(9916),
    [sym__rational_operator] = ACTIONS(9916),
    [sym__bitshift_operator] = ACTIONS(9916),
    [sym__power_operator] = ACTIONS(9916),
    [sym__tilde_operator] = ACTIONS(9916),
    [sym__type_order_operator] = ACTIONS(9916),
    [sym__unary_operator] = ACTIONS(9916),
    [sym__unary_plus_operator] = ACTIONS(9916),
    [aux_sym__terminator_token1] = ACTIONS(9918),
    [aux_sym__terminator_token2] = ACTIONS(9916),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9464] = {
    [sym_block_comment] = STATE(9464),
    [sym_line_comment] = STATE(9464),
    [sym__word_identifier] = ACTIONS(11047),
    [anon_sym_begin] = ACTIONS(11047),
    [anon_sym_module] = ACTIONS(11047),
    [anon_sym_baremodule] = ACTIONS(11047),
    [anon_sym_abstract] = ACTIONS(11047),
    [anon_sym_primitive] = ACTIONS(11047),
    [anon_sym_mutable] = ACTIONS(11047),
    [anon_sym_struct] = ACTIONS(11047),
    [anon_sym_function] = ACTIONS(11047),
    [anon_sym_macro] = ACTIONS(11047),
    [anon_sym_quote] = ACTIONS(11047),
    [anon_sym_let] = ACTIONS(11047),
    [anon_sym_if] = ACTIONS(11047),
    [anon_sym_try] = ACTIONS(11047),
    [anon_sym_for] = ACTIONS(11047),
    [anon_sym_while] = ACTIONS(11047),
    [sym_break_statement] = ACTIONS(11047),
    [sym_continue_statement] = ACTIONS(11047),
    [anon_sym_return] = ACTIONS(11047),
    [anon_sym_const] = ACTIONS(11047),
    [anon_sym_global] = ACTIONS(11047),
    [anon_sym_local] = ACTIONS(11047),
    [anon_sym_LPAREN] = ACTIONS(11047),
    [anon_sym_export] = ACTIONS(11047),
    [anon_sym_public] = ACTIONS(11047),
    [anon_sym_import] = ACTIONS(11047),
    [anon_sym_using] = ACTIONS(11047),
    [anon_sym_LBRACK] = ACTIONS(11047),
    [anon_sym_RBRACK] = ACTIONS(11047),
    [anon_sym_LBRACE] = ACTIONS(11047),
    [anon_sym_DOLLAR] = ACTIONS(11047),
    [anon_sym_COLON2] = ACTIONS(11047),
    [anon_sym_COLON_COLON] = ACTIONS(11047),
    [anon_sym_AT] = ACTIONS(11047),
    [anon_sym_true] = ACTIONS(11047),
    [anon_sym_false] = ACTIONS(11047),
    [aux_sym_integer_literal_token1] = ACTIONS(11047),
    [aux_sym_integer_literal_token2] = ACTIONS(11047),
    [aux_sym_integer_literal_token3] = ACTIONS(11047),
    [aux_sym_integer_literal_token4] = ACTIONS(11047),
    [aux_sym_float_literal_token1] = ACTIONS(11047),
    [aux_sym_float_literal_token3] = ACTIONS(11047),
    [aux_sym_float_literal_token4] = ACTIONS(11047),
    [sym_character_literal] = ACTIONS(11047),
    [anon_sym_DQUOTE] = ACTIONS(11047),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE] = ACTIONS(11047),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(11047),
    [sym__pair_operator] = ACTIONS(11047),
    [sym__arrow_operator] = ACTIONS(11047),
    [sym__comparison_operator] = ACTIONS(11047),
    [sym__pipe_right_operator] = ACTIONS(11047),
    [sym__pipe_left_operator] = ACTIONS(11047),
    [sym__ellipsis_operator] = ACTIONS(11047),
    [sym__plus_operator] = ACTIONS(11047),
    [sym__times_operator] = ACTIONS(11047),
    [sym__rational_operator] = ACTIONS(11047),
    [sym__bitshift_operator] = ACTIONS(11047),
    [sym__power_operator] = ACTIONS(11047),
    [sym__tilde_operator] = ACTIONS(11047),
    [sym__type_order_operator] = ACTIONS(11047),
    [sym__unary_operator] = ACTIONS(11047),
    [sym__unary_plus_operator] = ACTIONS(11047),
    [aux_sym__terminator_token1] = ACTIONS(12804),
    [aux_sym__terminator_token2] = ACTIONS(11047),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9465] = {
    [sym_block_comment] = STATE(9465),
    [sym_line_comment] = STATE(9465),
    [sym__word_identifier] = ACTIONS(9730),
    [anon_sym_begin] = ACTIONS(9730),
    [anon_sym_module] = ACTIONS(9730),
    [anon_sym_baremodule] = ACTIONS(9730),
    [anon_sym_end] = ACTIONS(9730),
    [anon_sym_abstract] = ACTIONS(9730),
    [anon_sym_primitive] = ACTIONS(9730),
    [anon_sym_mutable] = ACTIONS(9730),
    [anon_sym_struct] = ACTIONS(9730),
    [anon_sym_function] = ACTIONS(9730),
    [anon_sym_macro] = ACTIONS(9730),
    [anon_sym_quote] = ACTIONS(9730),
    [anon_sym_let] = ACTIONS(9730),
    [anon_sym_if] = ACTIONS(9730),
    [anon_sym_try] = ACTIONS(9730),
    [anon_sym_for] = ACTIONS(9730),
    [anon_sym_while] = ACTIONS(9730),
    [sym_break_statement] = ACTIONS(9730),
    [sym_continue_statement] = ACTIONS(9730),
    [anon_sym_return] = ACTIONS(9730),
    [anon_sym_const] = ACTIONS(9730),
    [anon_sym_global] = ACTIONS(9730),
    [anon_sym_local] = ACTIONS(9730),
    [anon_sym_LPAREN] = ACTIONS(9730),
    [anon_sym_export] = ACTIONS(9730),
    [anon_sym_public] = ACTIONS(9730),
    [anon_sym_import] = ACTIONS(9730),
    [anon_sym_using] = ACTIONS(9730),
    [anon_sym_LBRACK] = ACTIONS(9730),
    [anon_sym_LBRACE] = ACTIONS(9730),
    [anon_sym_DOLLAR] = ACTIONS(9730),
    [anon_sym_COLON2] = ACTIONS(9730),
    [anon_sym_COLON_COLON] = ACTIONS(9730),
    [anon_sym_AT] = ACTIONS(9730),
    [anon_sym_true] = ACTIONS(9730),
    [anon_sym_false] = ACTIONS(9730),
    [aux_sym_integer_literal_token1] = ACTIONS(9730),
    [aux_sym_integer_literal_token2] = ACTIONS(9730),
    [aux_sym_integer_literal_token3] = ACTIONS(9730),
    [aux_sym_integer_literal_token4] = ACTIONS(9730),
    [aux_sym_float_literal_token1] = ACTIONS(9730),
    [aux_sym_float_literal_token3] = ACTIONS(9730),
    [aux_sym_float_literal_token4] = ACTIONS(9730),
    [sym_character_literal] = ACTIONS(9730),
    [anon_sym_DQUOTE] = ACTIONS(9730),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE] = ACTIONS(9730),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(9730),
    [sym__pair_operator] = ACTIONS(9730),
    [sym__arrow_operator] = ACTIONS(9730),
    [sym__comparison_operator] = ACTIONS(9730),
    [sym__pipe_right_operator] = ACTIONS(9730),
    [sym__pipe_left_operator] = ACTIONS(9730),
    [sym__ellipsis_operator] = ACTIONS(9730),
    [sym__plus_operator] = ACTIONS(9730),
    [sym__times_operator] = ACTIONS(9730),
    [sym__rational_operator] = ACTIONS(9730),
    [sym__bitshift_operator] = ACTIONS(9730),
    [sym__power_operator] = ACTIONS(9730),
    [sym__tilde_operator] = ACTIONS(9730),
    [sym__type_order_operator] = ACTIONS(9730),
    [sym__unary_operator] = ACTIONS(9730),
    [sym__unary_plus_operator] = ACTIONS(9730),
    [aux_sym__terminator_token1] = ACTIONS(9734),
    [aux_sym__terminator_token2] = ACTIONS(9730),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9466] = {
    [sym_block_comment] = STATE(9466),
    [sym_line_comment] = STATE(9466),
    [sym__word_identifier] = ACTIONS(10028),
    [anon_sym_begin] = ACTIONS(10028),
    [anon_sym_module] = ACTIONS(10028),
    [anon_sym_baremodule] = ACTIONS(10028),
    [anon_sym_end] = ACTIONS(10028),
    [anon_sym_abstract] = ACTIONS(10028),
    [anon_sym_primitive] = ACTIONS(10028),
    [anon_sym_mutable] = ACTIONS(10028),
    [anon_sym_struct] = ACTIONS(10028),
    [anon_sym_function] = ACTIONS(10028),
    [anon_sym_macro] = ACTIONS(10028),
    [anon_sym_quote] = ACTIONS(10028),
    [anon_sym_let] = ACTIONS(10028),
    [anon_sym_if] = ACTIONS(10028),
    [anon_sym_try] = ACTIONS(10028),
    [anon_sym_for] = ACTIONS(10028),
    [anon_sym_while] = ACTIONS(10028),
    [sym_break_statement] = ACTIONS(10028),
    [sym_continue_statement] = ACTIONS(10028),
    [anon_sym_return] = ACTIONS(10028),
    [anon_sym_const] = ACTIONS(10028),
    [anon_sym_global] = ACTIONS(10028),
    [anon_sym_local] = ACTIONS(10028),
    [anon_sym_LPAREN] = ACTIONS(10028),
    [anon_sym_export] = ACTIONS(10028),
    [anon_sym_public] = ACTIONS(10028),
    [anon_sym_import] = ACTIONS(10028),
    [anon_sym_using] = ACTIONS(10028),
    [anon_sym_LBRACK] = ACTIONS(10028),
    [anon_sym_LBRACE] = ACTIONS(10028),
    [anon_sym_DOLLAR] = ACTIONS(10028),
    [anon_sym_COLON2] = ACTIONS(10028),
    [anon_sym_COLON_COLON] = ACTIONS(10028),
    [anon_sym_AT] = ACTIONS(10028),
    [anon_sym_true] = ACTIONS(10028),
    [anon_sym_false] = ACTIONS(10028),
    [aux_sym_integer_literal_token1] = ACTIONS(10028),
    [aux_sym_integer_literal_token2] = ACTIONS(10028),
    [aux_sym_integer_literal_token3] = ACTIONS(10028),
    [aux_sym_integer_literal_token4] = ACTIONS(10028),
    [aux_sym_float_literal_token1] = ACTIONS(10028),
    [aux_sym_float_literal_token3] = ACTIONS(10028),
    [aux_sym_float_literal_token4] = ACTIONS(10028),
    [sym_character_literal] = ACTIONS(10028),
    [anon_sym_DQUOTE] = ACTIONS(10028),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE] = ACTIONS(10028),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10028),
    [sym__pair_operator] = ACTIONS(10028),
    [sym__arrow_operator] = ACTIONS(10028),
    [sym__comparison_operator] = ACTIONS(10028),
    [sym__pipe_right_operator] = ACTIONS(10028),
    [sym__pipe_left_operator] = ACTIONS(10028),
    [sym__ellipsis_operator] = ACTIONS(10028),
    [sym__plus_operator] = ACTIONS(10028),
    [sym__times_operator] = ACTIONS(10028),
    [sym__rational_operator] = ACTIONS(10028),
    [sym__bitshift_operator] = ACTIONS(10028),
    [sym__power_operator] = ACTIONS(10028),
    [sym__tilde_operator] = ACTIONS(10028),
    [sym__type_order_operator] = ACTIONS(10028),
    [sym__unary_operator] = ACTIONS(10028),
    [sym__unary_plus_operator] = ACTIONS(10028),
    [aux_sym__terminator_token1] = ACTIONS(10030),
    [aux_sym__terminator_token2] = ACTIONS(10028),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9467] = {
    [sym_block_comment] = STATE(9467),
    [sym_line_comment] = STATE(9467),
    [sym__word_identifier] = ACTIONS(10010),
    [anon_sym_begin] = ACTIONS(10010),
    [anon_sym_module] = ACTIONS(10010),
    [anon_sym_baremodule] = ACTIONS(10010),
    [anon_sym_end] = ACTIONS(10010),
    [anon_sym_abstract] = ACTIONS(10010),
    [anon_sym_primitive] = ACTIONS(10010),
    [anon_sym_mutable] = ACTIONS(10010),
    [anon_sym_struct] = ACTIONS(10010),
    [anon_sym_function] = ACTIONS(10010),
    [anon_sym_macro] = ACTIONS(10010),
    [anon_sym_quote] = ACTIONS(10010),
    [anon_sym_let] = ACTIONS(10010),
    [anon_sym_if] = ACTIONS(10010),
    [anon_sym_try] = ACTIONS(10010),
    [anon_sym_for] = ACTIONS(10010),
    [anon_sym_while] = ACTIONS(10010),
    [sym_break_statement] = ACTIONS(10010),
    [sym_continue_statement] = ACTIONS(10010),
    [anon_sym_return] = ACTIONS(10010),
    [anon_sym_const] = ACTIONS(10010),
    [anon_sym_global] = ACTIONS(10010),
    [anon_sym_local] = ACTIONS(10010),
    [anon_sym_LPAREN] = ACTIONS(10010),
    [anon_sym_export] = ACTIONS(10010),
    [anon_sym_public] = ACTIONS(10010),
    [anon_sym_import] = ACTIONS(10010),
    [anon_sym_using] = ACTIONS(10010),
    [anon_sym_LBRACK] = ACTIONS(10010),
    [anon_sym_LBRACE] = ACTIONS(10010),
    [anon_sym_DOLLAR] = ACTIONS(10010),
    [anon_sym_COLON2] = ACTIONS(10010),
    [anon_sym_COLON_COLON] = ACTIONS(10010),
    [anon_sym_AT] = ACTIONS(10010),
    [anon_sym_true] = ACTIONS(10010),
    [anon_sym_false] = ACTIONS(10010),
    [aux_sym_integer_literal_token1] = ACTIONS(10010),
    [aux_sym_integer_literal_token2] = ACTIONS(10010),
    [aux_sym_integer_literal_token3] = ACTIONS(10010),
    [aux_sym_integer_literal_token4] = ACTIONS(10010),
    [aux_sym_float_literal_token1] = ACTIONS(10010),
    [aux_sym_float_literal_token3] = ACTIONS(10010),
    [aux_sym_float_literal_token4] = ACTIONS(10010),
    [sym_character_literal] = ACTIONS(10010),
    [anon_sym_DQUOTE] = ACTIONS(10010),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE] = ACTIONS(10010),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10010),
    [sym__pair_operator] = ACTIONS(10010),
    [sym__arrow_operator] = ACTIONS(10010),
    [sym__comparison_operator] = ACTIONS(10010),
    [sym__pipe_right_operator] = ACTIONS(10010),
    [sym__pipe_left_operator] = ACTIONS(10010),
    [sym__ellipsis_operator] = ACTIONS(10010),
    [sym__plus_operator] = ACTIONS(10010),
    [sym__times_operator] = ACTIONS(10010),
    [sym__rational_operator] = ACTIONS(10010),
    [sym__bitshift_operator] = ACTIONS(10010),
    [sym__power_operator] = ACTIONS(10010),
    [sym__tilde_operator] = ACTIONS(10010),
    [sym__type_order_operator] = ACTIONS(10010),
    [sym__unary_operator] = ACTIONS(10010),
    [sym__unary_plus_operator] = ACTIONS(10010),
    [aux_sym__terminator_token1] = ACTIONS(10012),
    [aux_sym__terminator_token2] = ACTIONS(10010),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9468] = {
    [sym_block_comment] = STATE(9468),
    [sym_line_comment] = STATE(9468),
    [sym__word_identifier] = ACTIONS(10032),
    [anon_sym_begin] = ACTIONS(10032),
    [anon_sym_module] = ACTIONS(10032),
    [anon_sym_baremodule] = ACTIONS(10032),
    [anon_sym_end] = ACTIONS(10032),
    [anon_sym_abstract] = ACTIONS(10032),
    [anon_sym_primitive] = ACTIONS(10032),
    [anon_sym_mutable] = ACTIONS(10032),
    [anon_sym_struct] = ACTIONS(10032),
    [anon_sym_function] = ACTIONS(10032),
    [anon_sym_macro] = ACTIONS(10032),
    [anon_sym_quote] = ACTIONS(10032),
    [anon_sym_let] = ACTIONS(10032),
    [anon_sym_if] = ACTIONS(10032),
    [anon_sym_try] = ACTIONS(10032),
    [anon_sym_for] = ACTIONS(10032),
    [anon_sym_while] = ACTIONS(10032),
    [sym_break_statement] = ACTIONS(10032),
    [sym_continue_statement] = ACTIONS(10032),
    [anon_sym_return] = ACTIONS(10032),
    [anon_sym_const] = ACTIONS(10032),
    [anon_sym_global] = ACTIONS(10032),
    [anon_sym_local] = ACTIONS(10032),
    [anon_sym_LPAREN] = ACTIONS(10032),
    [anon_sym_export] = ACTIONS(10032),
    [anon_sym_public] = ACTIONS(10032),
    [anon_sym_import] = ACTIONS(10032),
    [anon_sym_using] = ACTIONS(10032),
    [anon_sym_LBRACK] = ACTIONS(10032),
    [anon_sym_LBRACE] = ACTIONS(10032),
    [anon_sym_DOLLAR] = ACTIONS(10032),
    [anon_sym_COLON2] = ACTIONS(10032),
    [anon_sym_COLON_COLON] = ACTIONS(10032),
    [anon_sym_AT] = ACTIONS(10032),
    [anon_sym_true] = ACTIONS(10032),
    [anon_sym_false] = ACTIONS(10032),
    [aux_sym_integer_literal_token1] = ACTIONS(10032),
    [aux_sym_integer_literal_token2] = ACTIONS(10032),
    [aux_sym_integer_literal_token3] = ACTIONS(10032),
    [aux_sym_integer_literal_token4] = ACTIONS(10032),
    [aux_sym_float_literal_token1] = ACTIONS(10032),
    [aux_sym_float_literal_token3] = ACTIONS(10032),
    [aux_sym_float_literal_token4] = ACTIONS(10032),
    [sym_character_literal] = ACTIONS(10032),
    [anon_sym_DQUOTE] = ACTIONS(10032),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE] = ACTIONS(10032),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10032),
    [sym__pair_operator] = ACTIONS(10032),
    [sym__arrow_operator] = ACTIONS(10032),
    [sym__comparison_operator] = ACTIONS(10032),
    [sym__pipe_right_operator] = ACTIONS(10032),
    [sym__pipe_left_operator] = ACTIONS(10032),
    [sym__ellipsis_operator] = ACTIONS(10032),
    [sym__plus_operator] = ACTIONS(10032),
    [sym__times_operator] = ACTIONS(10032),
    [sym__rational_operator] = ACTIONS(10032),
    [sym__bitshift_operator] = ACTIONS(10032),
    [sym__power_operator] = ACTIONS(10032),
    [sym__tilde_operator] = ACTIONS(10032),
    [sym__type_order_operator] = ACTIONS(10032),
    [sym__unary_operator] = ACTIONS(10032),
    [sym__unary_plus_operator] = ACTIONS(10032),
    [aux_sym__terminator_token1] = ACTIONS(10034),
    [aux_sym__terminator_token2] = ACTIONS(10032),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9469] = {
    [sym_block_comment] = STATE(9469),
    [sym_line_comment] = STATE(9469),
    [sym__word_identifier] = ACTIONS(10080),
    [anon_sym_begin] = ACTIONS(10080),
    [anon_sym_module] = ACTIONS(10080),
    [anon_sym_baremodule] = ACTIONS(10080),
    [anon_sym_end] = ACTIONS(10080),
    [anon_sym_abstract] = ACTIONS(10080),
    [anon_sym_primitive] = ACTIONS(10080),
    [anon_sym_mutable] = ACTIONS(10080),
    [anon_sym_struct] = ACTIONS(10080),
    [anon_sym_function] = ACTIONS(10080),
    [anon_sym_macro] = ACTIONS(10080),
    [anon_sym_quote] = ACTIONS(10080),
    [anon_sym_let] = ACTIONS(10080),
    [anon_sym_if] = ACTIONS(10080),
    [anon_sym_try] = ACTIONS(10080),
    [anon_sym_for] = ACTIONS(10080),
    [anon_sym_while] = ACTIONS(10080),
    [sym_break_statement] = ACTIONS(10080),
    [sym_continue_statement] = ACTIONS(10080),
    [anon_sym_return] = ACTIONS(10080),
    [anon_sym_const] = ACTIONS(10080),
    [anon_sym_global] = ACTIONS(10080),
    [anon_sym_local] = ACTIONS(10080),
    [anon_sym_LPAREN] = ACTIONS(10080),
    [anon_sym_export] = ACTIONS(10080),
    [anon_sym_public] = ACTIONS(10080),
    [anon_sym_import] = ACTIONS(10080),
    [anon_sym_using] = ACTIONS(10080),
    [anon_sym_LBRACK] = ACTIONS(10080),
    [anon_sym_LBRACE] = ACTIONS(10080),
    [anon_sym_DOLLAR] = ACTIONS(10080),
    [anon_sym_COLON2] = ACTIONS(10080),
    [anon_sym_COLON_COLON] = ACTIONS(10080),
    [anon_sym_AT] = ACTIONS(10080),
    [anon_sym_true] = ACTIONS(10080),
    [anon_sym_false] = ACTIONS(10080),
    [aux_sym_integer_literal_token1] = ACTIONS(10080),
    [aux_sym_integer_literal_token2] = ACTIONS(10080),
    [aux_sym_integer_literal_token3] = ACTIONS(10080),
    [aux_sym_integer_literal_token4] = ACTIONS(10080),
    [aux_sym_float_literal_token1] = ACTIONS(10080),
    [aux_sym_float_literal_token3] = ACTIONS(10080),
    [aux_sym_float_literal_token4] = ACTIONS(10080),
    [sym_character_literal] = ACTIONS(10080),
    [anon_sym_DQUOTE] = ACTIONS(10080),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE] = ACTIONS(10080),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10080),
    [sym__pair_operator] = ACTIONS(10080),
    [sym__arrow_operator] = ACTIONS(10080),
    [sym__comparison_operator] = ACTIONS(10080),
    [sym__pipe_right_operator] = ACTIONS(10080),
    [sym__pipe_left_operator] = ACTIONS(10080),
    [sym__ellipsis_operator] = ACTIONS(10080),
    [sym__plus_operator] = ACTIONS(10080),
    [sym__times_operator] = ACTIONS(10080),
    [sym__rational_operator] = ACTIONS(10080),
    [sym__bitshift_operator] = ACTIONS(10080),
    [sym__power_operator] = ACTIONS(10080),
    [sym__tilde_operator] = ACTIONS(10080),
    [sym__type_order_operator] = ACTIONS(10080),
    [sym__unary_operator] = ACTIONS(10080),
    [sym__unary_plus_operator] = ACTIONS(10080),
    [aux_sym__terminator_token1] = ACTIONS(10082),
    [aux_sym__terminator_token2] = ACTIONS(10080),
    [aux_sym_block_comment_token1] = ACTIONS(187),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9470] = {
    [sym_identifier] = STATE(4438),
    [sym_integer_literal] = STATE(5017),
    [sym_float_literal] = STATE(5017),
    [sym__string] = STATE(5017),
    [sym__delimiter_str_1] = STATE(14985),
    [sym__delimiter_str_3] = STATE(14986),
    [sym__delimiter_cmd_1] = STATE(14993),
    [sym__delimiter_cmd_3] = STATE(15001),
    [sym_string_literal] = STATE(4966),
    [sym_command_literal] = STATE(4966),
    [sym_prefixed_string_literal] = STATE(4966),
    [sym_prefixed_command_literal] = STATE(4966),
    [sym_operator] = STATE(5017),
    [sym__assignment_operator] = STATE(5017),
    [sym__syntactic_operator] = STATE(5017),
    [sym_block_comment] = STATE(9470),
    [sym_line_comment] = STATE(9470),
    [sym__word_identifier] = ACTIONS(9582),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(9584),
    [anon_sym_COLON2] = ACTIONS(9586),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(12966),
    [anon_sym_DOT_EQ] = ACTIONS(9588),
    [aux_sym_quote_expression_token1] = ACTIONS(9590),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12968),
    [anon_sym_QMARK] = ACTIONS(12968),
    [anon_sym_DASH_GT] = ACTIONS(12968),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12970),
    [aux_sym_integer_literal_token2] = ACTIONS(12970),
    [aux_sym_integer_literal_token3] = ACTIONS(9592),
    [aux_sym_integer_literal_token4] = ACTIONS(9594),
    [aux_sym_float_literal_token1] = ACTIONS(12972),
    [aux_sym_float_literal_token3] = ACTIONS(12972),
    [aux_sym_float_literal_token4] = ACTIONS(12972),
    [sym_character_literal] = ACTIONS(6900),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12966),
    [aux_sym__assignment_operator_token1] = ACTIONS(12966),
    [sym__pair_operator] = ACTIONS(12974),
    [sym__arrow_operator] = ACTIONS(9586),
    [sym__lazy_or_operator] = ACTIONS(12976),
    [sym__lazy_and_operator] = ACTIONS(12976),
    [sym__comparison_operator] = ACTIONS(9586),
    [sym__pipe_right_operator] = ACTIONS(12974),
    [sym__pipe_left_operator] = ACTIONS(12974),
    [sym__ellipsis_operator] = ACTIONS(9586),
    [sym__plus_operator] = ACTIONS(9586),
    [sym__times_operator] = ACTIONS(9586),
    [sym__rational_operator] = ACTIONS(9586),
    [sym__bitshift_operator] = ACTIONS(9586),
    [sym__power_operator] = ACTIONS(9586),
    [sym__tilde_operator] = ACTIONS(12974),
    [sym__type_order_operator] = ACTIONS(12974),
    [sym__unary_operator] = ACTIONS(9586),
    [sym__unary_plus_operator] = ACTIONS(9586),
    [anon_sym_DOT2] = ACTIONS(9584),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(9598),
    [sym__immediate_bracket] = ACTIONS(9600),
    [sym__immediate_brace] = ACTIONS(9602),
  },
  [9471] = {
    [sym_identifier] = STATE(10550),
    [sym_integer_literal] = STATE(9803),
    [sym_float_literal] = STATE(9803),
    [sym__string] = STATE(9803),
    [sym__delimiter_str_1] = STATE(15068),
    [sym__delimiter_str_3] = STATE(15103),
    [sym__delimiter_cmd_1] = STATE(15105),
    [sym__delimiter_cmd_3] = STATE(15106),
    [sym_string_literal] = STATE(9808),
    [sym_command_literal] = STATE(9808),
    [sym_prefixed_string_literal] = STATE(9808),
    [sym_prefixed_command_literal] = STATE(9808),
    [sym_operator] = STATE(9803),
    [sym__assignment_operator] = STATE(9803),
    [sym__syntactic_operator] = STATE(9803),
    [sym_block_comment] = STATE(9471),
    [sym_line_comment] = STATE(9471),
    [sym__word_identifier] = ACTIONS(12894),
    [anon_sym_COLON] = ACTIONS(3071),
    [anon_sym_in] = ACTIONS(3071),
    [anon_sym_DOLLAR] = ACTIONS(12896),
    [anon_sym_COLON2] = ACTIONS(12898),
    [anon_sym_COLON_COLON] = ACTIONS(3075),
    [anon_sym_COLON_EQ] = ACTIONS(12900),
    [anon_sym_DOT_EQ] = ACTIONS(12902),
    [aux_sym_quote_expression_token1] = ACTIONS(12904),
    [anon_sym_isa] = ACTIONS(3071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12906),
    [anon_sym_QMARK] = ACTIONS(12906),
    [anon_sym_DASH_GT] = ACTIONS(12906),
    [anon_sym_where] = ACTIONS(3071),
    [aux_sym_integer_literal_token1] = ACTIONS(12908),
    [aux_sym_integer_literal_token2] = ACTIONS(12908),
    [aux_sym_integer_literal_token3] = ACTIONS(12910),
    [aux_sym_integer_literal_token4] = ACTIONS(12912),
    [aux_sym_float_literal_token1] = ACTIONS(12914),
    [aux_sym_float_literal_token3] = ACTIONS(12914),
    [aux_sym_float_literal_token4] = ACTIONS(12914),
    [sym_character_literal] = ACTIONS(1819),
    [anon_sym_DQUOTE] = ACTIONS(83),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(87),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(89),
    [anon_sym_DOLLAR_EQ] = ACTIONS(12900),
    [aux_sym__assignment_operator_token1] = ACTIONS(12900),
    [sym__pair_operator] = ACTIONS(12916),
    [sym__arrow_operator] = ACTIONS(12898),
    [sym__lazy_or_operator] = ACTIONS(12918),
    [sym__lazy_and_operator] = ACTIONS(12918),
    [sym__comparison_operator] = ACTIONS(12898),
    [sym__pipe_right_operator] = ACTIONS(12916),
    [sym__pipe_left_operator] = ACTIONS(12916),
    [sym__ellipsis_operator] = ACTIONS(12898),
    [sym__plus_operator] = ACTIONS(12898),
    [sym__times_operator] = ACTIONS(12898),
    [sym__rational_operator] = ACTIONS(12898),
    [sym__bitshift_operator] = ACTIONS(12898),
    [sym__power_operator] = ACTIONS(12898),
    [sym__tilde_operator] = ACTIONS(12916),
    [sym__type_order_operator] = ACTIONS(12916),
    [sym__unary_operator] = ACTIONS(12898),
    [sym__unary_plus_operator] = ACTIONS(12898),
    [anon_sym_DOT2] = ACTIONS(12896),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
    [sym__immediate_paren] = ACTIONS(12920),
    [sym__immediate_bracket] = ACTIONS(12922),
    [sym__immediate_brace] = ACTIONS(12924),
  },
  [9472] = {
    [sym_block_comment] = STATE(9472),
    [sym_line_comment] = STATE(9472),
    [sym__word_identifier] = ACTIONS(12978),
    [anon_sym_begin] = ACTIONS(12978),
    [anon_sym_module] = ACTIONS(12978),
    [anon_sym_baremodule] = ACTIONS(12978),
    [anon_sym_end] = ACTIONS(12978),
    [anon_sym_abstract] = ACTIONS(12978),
    [anon_sym_primitive] = ACTIONS(12978),
    [anon_sym_mutable] = ACTIONS(12978),
    [anon_sym_struct] = ACTIONS(12978),
    [anon_sym_function] = ACTIONS(12978),
    [anon_sym_macro] = ACTIONS(12978),
    [anon_sym_quote] = ACTIONS(12978),
    [anon_sym_let] = ACTIONS(12978),
    [anon_sym_if] = ACTIONS(12978),
    [anon_sym_try] = ACTIONS(12978),
    [anon_sym_for] = ACTIONS(12978),
    [anon_sym_while] = ACTIONS(12978),
    [sym_break_statement] = ACTIONS(12978),
    [sym_continue_statement] = ACTIONS(12978),
    [anon_sym_return] = ACTIONS(12978),
    [anon_sym_const] = ACTIONS(12978),
    [anon_sym_global] = ACTIONS(12978),
    [anon_sym_local] = ACTIONS(12978),
    [anon_sym_LPAREN] = ACTIONS(12980),
    [anon_sym_export] = ACTIONS(12978),
    [anon_sym_public] = ACTIONS(12978),
    [anon_sym_import] = ACTIONS(12978),
    [anon_sym_using] = ACTIONS(12978),
    [anon_sym_LBRACK] = ACTIONS(12980),
    [anon_sym_LBRACE] = ACTIONS(12980),
    [anon_sym_DOLLAR] = ACTIONS(12980),
    [anon_sym_COLON2] = ACTIONS(12978),
    [anon_sym_COLON_COLON] = ACTIONS(12980),
    [anon_sym_AT] = ACTIONS(12980),
    [anon_sym_true] = ACTIONS(12978),
    [anon_sym_false] = ACTIONS(12978),
    [aux_sym_integer_literal_token1] = ACTIONS(12980),
    [aux_sym_integer_literal_token2] = ACTIONS(12980),
    [aux_sym_integer_literal_token3] = ACTIONS(12978),
    [aux_sym_integer_literal_token4] = ACTIONS(12978),
    [aux_sym_float_literal_token1] = ACTIONS(12980),
    [aux_sym_float_literal_token3] = ACTIONS(12980),
    [aux_sym_float_literal_token4] = ACTIONS(12980),
    [sym_character_literal] = ACTIONS(12980),
    [anon_sym_DQUOTE] = ACTIONS(12978),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12980),
    [anon_sym_BQUOTE] = ACTIONS(12978),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12980),
    [sym__pair_operator] = ACTIONS(12980),
    [sym__arrow_operator] = ACTIONS(12978),
    [sym__comparison_operator] = ACTIONS(12978),
    [sym__pipe_right_operator] = ACTIONS(12980),
    [sym__pipe_left_operator] = ACTIONS(12980),
    [sym__ellipsis_operator] = ACTIONS(12980),
    [sym__plus_operator] = ACTIONS(12978),
    [sym__times_operator] = ACTIONS(12978),
    [sym__rational_operator] = ACTIONS(12980),
    [sym__bitshift_operator] = ACTIONS(12980),
    [sym__power_operator] = ACTIONS(12980),
    [sym__tilde_operator] = ACTIONS(12980),
    [sym__type_order_operator] = ACTIONS(12980),
    [sym__unary_operator] = ACTIONS(12978),
    [sym__unary_plus_operator] = ACTIONS(12978),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9473] = {
    [sym_block_comment] = STATE(9473),
    [sym_line_comment] = STATE(9473),
    [sym__word_identifier] = ACTIONS(12982),
    [anon_sym_begin] = ACTIONS(12982),
    [anon_sym_module] = ACTIONS(12982),
    [anon_sym_baremodule] = ACTIONS(12982),
    [anon_sym_end] = ACTIONS(12982),
    [anon_sym_abstract] = ACTIONS(12982),
    [anon_sym_primitive] = ACTIONS(12982),
    [anon_sym_mutable] = ACTIONS(12982),
    [anon_sym_struct] = ACTIONS(12982),
    [anon_sym_function] = ACTIONS(12982),
    [anon_sym_macro] = ACTIONS(12982),
    [anon_sym_quote] = ACTIONS(12982),
    [anon_sym_let] = ACTIONS(12982),
    [anon_sym_if] = ACTIONS(12982),
    [anon_sym_try] = ACTIONS(12982),
    [anon_sym_for] = ACTIONS(12982),
    [anon_sym_while] = ACTIONS(12982),
    [sym_break_statement] = ACTIONS(12982),
    [sym_continue_statement] = ACTIONS(12982),
    [anon_sym_return] = ACTIONS(12982),
    [anon_sym_const] = ACTIONS(12982),
    [anon_sym_global] = ACTIONS(12982),
    [anon_sym_local] = ACTIONS(12982),
    [anon_sym_LPAREN] = ACTIONS(12984),
    [anon_sym_export] = ACTIONS(12982),
    [anon_sym_public] = ACTIONS(12982),
    [anon_sym_import] = ACTIONS(12982),
    [anon_sym_using] = ACTIONS(12982),
    [anon_sym_LBRACK] = ACTIONS(12984),
    [anon_sym_LBRACE] = ACTIONS(12984),
    [anon_sym_DOLLAR] = ACTIONS(12984),
    [anon_sym_COLON2] = ACTIONS(12982),
    [anon_sym_COLON_COLON] = ACTIONS(12984),
    [anon_sym_AT] = ACTIONS(12984),
    [anon_sym_true] = ACTIONS(12982),
    [anon_sym_false] = ACTIONS(12982),
    [aux_sym_integer_literal_token1] = ACTIONS(12984),
    [aux_sym_integer_literal_token2] = ACTIONS(12984),
    [aux_sym_integer_literal_token3] = ACTIONS(12982),
    [aux_sym_integer_literal_token4] = ACTIONS(12982),
    [aux_sym_float_literal_token1] = ACTIONS(12984),
    [aux_sym_float_literal_token3] = ACTIONS(12984),
    [aux_sym_float_literal_token4] = ACTIONS(12984),
    [sym_character_literal] = ACTIONS(12984),
    [anon_sym_DQUOTE] = ACTIONS(12982),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12984),
    [anon_sym_BQUOTE] = ACTIONS(12982),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12984),
    [sym__pair_operator] = ACTIONS(12984),
    [sym__arrow_operator] = ACTIONS(12982),
    [sym__comparison_operator] = ACTIONS(12982),
    [sym__pipe_right_operator] = ACTIONS(12984),
    [sym__pipe_left_operator] = ACTIONS(12984),
    [sym__ellipsis_operator] = ACTIONS(12984),
    [sym__plus_operator] = ACTIONS(12982),
    [sym__times_operator] = ACTIONS(12982),
    [sym__rational_operator] = ACTIONS(12984),
    [sym__bitshift_operator] = ACTIONS(12984),
    [sym__power_operator] = ACTIONS(12984),
    [sym__tilde_operator] = ACTIONS(12984),
    [sym__type_order_operator] = ACTIONS(12984),
    [sym__unary_operator] = ACTIONS(12982),
    [sym__unary_plus_operator] = ACTIONS(12982),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9474] = {
    [sym_block_comment] = STATE(9474),
    [sym_line_comment] = STATE(9474),
    [sym__word_identifier] = ACTIONS(10152),
    [anon_sym_begin] = ACTIONS(10152),
    [anon_sym_module] = ACTIONS(10152),
    [anon_sym_baremodule] = ACTIONS(10152),
    [anon_sym_abstract] = ACTIONS(10152),
    [anon_sym_primitive] = ACTIONS(10152),
    [anon_sym_mutable] = ACTIONS(10152),
    [anon_sym_struct] = ACTIONS(10152),
    [anon_sym_function] = ACTIONS(10152),
    [anon_sym_macro] = ACTIONS(10152),
    [anon_sym_quote] = ACTIONS(10152),
    [anon_sym_let] = ACTIONS(10152),
    [anon_sym_if] = ACTIONS(10152),
    [anon_sym_try] = ACTIONS(10152),
    [anon_sym_for] = ACTIONS(10152),
    [anon_sym_while] = ACTIONS(10152),
    [sym_break_statement] = ACTIONS(10152),
    [sym_continue_statement] = ACTIONS(10152),
    [anon_sym_return] = ACTIONS(10152),
    [anon_sym_const] = ACTIONS(10152),
    [anon_sym_global] = ACTIONS(10152),
    [anon_sym_local] = ACTIONS(10152),
    [anon_sym_LPAREN] = ACTIONS(10154),
    [anon_sym_RPAREN] = ACTIONS(10154),
    [anon_sym_export] = ACTIONS(10152),
    [anon_sym_public] = ACTIONS(10152),
    [anon_sym_import] = ACTIONS(10152),
    [anon_sym_using] = ACTIONS(10152),
    [anon_sym_LBRACK] = ACTIONS(10154),
    [anon_sym_LBRACE] = ACTIONS(10154),
    [anon_sym_DOLLAR] = ACTIONS(10154),
    [anon_sym_COLON2] = ACTIONS(10152),
    [anon_sym_COLON_COLON] = ACTIONS(10154),
    [anon_sym_AT] = ACTIONS(10154),
    [anon_sym_true] = ACTIONS(10152),
    [anon_sym_false] = ACTIONS(10152),
    [aux_sym_integer_literal_token1] = ACTIONS(10154),
    [aux_sym_integer_literal_token2] = ACTIONS(10154),
    [aux_sym_integer_literal_token3] = ACTIONS(10152),
    [aux_sym_integer_literal_token4] = ACTIONS(10152),
    [aux_sym_float_literal_token1] = ACTIONS(10154),
    [aux_sym_float_literal_token3] = ACTIONS(10154),
    [aux_sym_float_literal_token4] = ACTIONS(10154),
    [sym_character_literal] = ACTIONS(10154),
    [anon_sym_DQUOTE] = ACTIONS(10152),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(10154),
    [anon_sym_BQUOTE] = ACTIONS(10152),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(10154),
    [sym__pair_operator] = ACTIONS(10154),
    [sym__arrow_operator] = ACTIONS(10152),
    [sym__comparison_operator] = ACTIONS(10152),
    [sym__pipe_right_operator] = ACTIONS(10154),
    [sym__pipe_left_operator] = ACTIONS(10154),
    [sym__ellipsis_operator] = ACTIONS(10154),
    [sym__plus_operator] = ACTIONS(10152),
    [sym__times_operator] = ACTIONS(10152),
    [sym__rational_operator] = ACTIONS(10154),
    [sym__bitshift_operator] = ACTIONS(10154),
    [sym__power_operator] = ACTIONS(10154),
    [sym__tilde_operator] = ACTIONS(10154),
    [sym__type_order_operator] = ACTIONS(10154),
    [sym__unary_operator] = ACTIONS(10152),
    [sym__unary_plus_operator] = ACTIONS(10152),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
  [9475] = {
    [sym_block_comment] = STATE(9475),
    [sym_line_comment] = STATE(9475),
    [sym__word_identifier] = ACTIONS(12986),
    [anon_sym_begin] = ACTIONS(12986),
    [anon_sym_module] = ACTIONS(12986),
    [anon_sym_baremodule] = ACTIONS(12986),
    [anon_sym_end] = ACTIONS(12986),
    [anon_sym_abstract] = ACTIONS(12986),
    [anon_sym_primitive] = ACTIONS(12986),
    [anon_sym_mutable] = ACTIONS(12986),
    [anon_sym_struct] = ACTIONS(12986),
    [anon_sym_function] = ACTIONS(12986),
    [anon_sym_macro] = ACTIONS(12986),
    [anon_sym_quote] = ACTIONS(12986),
    [anon_sym_let] = ACTIONS(12986),
    [anon_sym_if] = ACTIONS(12986),
    [anon_sym_try] = ACTIONS(12986),
    [anon_sym_for] = ACTIONS(12986),
    [anon_sym_while] = ACTIONS(12986),
    [sym_break_statement] = ACTIONS(12986),
    [sym_continue_statement] = ACTIONS(12986),
    [anon_sym_return] = ACTIONS(12986),
    [anon_sym_const] = ACTIONS(12986),
    [anon_sym_global] = ACTIONS(12986),
    [anon_sym_local] = ACTIONS(12986),
    [anon_sym_LPAREN] = ACTIONS(12988),
    [anon_sym_export] = ACTIONS(12986),
    [anon_sym_public] = ACTIONS(12986),
    [anon_sym_import] = ACTIONS(12986),
    [anon_sym_using] = ACTIONS(12986),
    [anon_sym_LBRACK] = ACTIONS(12988),
    [anon_sym_LBRACE] = ACTIONS(12988),
    [anon_sym_DOLLAR] = ACTIONS(12988),
    [anon_sym_COLON2] = ACTIONS(12986),
    [anon_sym_COLON_COLON] = ACTIONS(12988),
    [anon_sym_AT] = ACTIONS(12988),
    [anon_sym_true] = ACTIONS(12986),
    [anon_sym_false] = ACTIONS(12986),
    [aux_sym_integer_literal_token1] = ACTIONS(12988),
    [aux_sym_integer_literal_token2] = ACTIONS(12988),
    [aux_sym_integer_literal_token3] = ACTIONS(12986),
    [aux_sym_integer_literal_token4] = ACTIONS(12986),
    [aux_sym_float_literal_token1] = ACTIONS(12988),
    [aux_sym_float_literal_token3] = ACTIONS(12988),
    [aux_sym_float_literal_token4] = ACTIONS(12988),
    [sym_character_literal] = ACTIONS(12988),
    [anon_sym_DQUOTE] = ACTIONS(12986),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(12988),
    [anon_sym_BQUOTE] = ACTIONS(12986),
    [anon_sym_BQUOTE_BQUOTE_BQUOTE] = ACTIONS(12988),
    [sym__pair_operator] = ACTIONS(12988),
    [sym__arrow_operator] = ACTIONS(12986),
    [sym__comparison_operator] = ACTIONS(12986),
    [sym__pipe_right_operator] = ACTIONS(12988),
    [sym__pipe_left_operator] = ACTIONS(12988),
    [sym__ellipsis_operator] = ACTIONS(12988),
    [sym__plus_operator] = ACTIONS(12986),
    [sym__times_operator] = ACTIONS(12986),
    [sym__rational_operator] = ACTIONS(12988),
    [sym__bitshift_operator] = ACTIONS(12988),
    [sym__power_operator] = ACTIONS(12988),
    [sym__tilde_operator] = ACTIONS(12988),
    [sym__type_order_operator] = ACTIONS(12988),
    [sym__unary_operator] = ACTIONS(12986),
    [sym__unary_plus_operator] = ACTIONS(12986),
    [aux_sym_block_comment_token1] = ACTIONS(3),
    [aux_sym_line_comment_token1] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12990), 1,
      anon_sym_RPAREN,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9476), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(12994), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9477), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(12996), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9478), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(12998), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9479), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [500] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13000), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9480), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [625] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13002), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9481), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [750] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13004), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9482), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [875] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13006), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9483), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1000] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13008), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9484), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13010), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9485), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13012), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9486), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13014), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9487), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1500] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13016), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9488), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1625] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13018), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9489), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1750] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13020), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9490), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [1875] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13022), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9491), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2000] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13024), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9492), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13026), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9493), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13028), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9494), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13030), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9495), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2500] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13032), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9496), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2625] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13034), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9497), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2750] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13036), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9498), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [2875] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13038), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9499), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3000] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13040), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9500), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13042), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9501), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13044), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9502), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13046), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9503), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3500] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13048), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9504), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3625] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13050), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9505), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3750] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13052), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9506), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [3875] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13054), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9507), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4000] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13056), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9508), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13058), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9509), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13060), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9510), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13062), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9511), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4500] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13064), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9512), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4625] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13066), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9513), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4750] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13068), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9514), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [4875] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13070), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9515), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5000] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13072), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9516), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13074), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9517), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13076), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9518), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13078), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9519), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5500] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13080), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9520), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5625] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13082), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9521), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5750] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13084), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9522), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [5875] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13086), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9523), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6000] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13088), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9524), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13090), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9525), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13092), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9526), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13094), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9527), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6500] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13096), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9528), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6625] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13098), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9529), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6750] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13100), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9530), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [6875] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13102), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9531), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [7000] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13104), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9532), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [7125] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13106), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9533), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [7250] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13108), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9534), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [7375] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    ACTIONS(13110), 1,
      anon_sym_RPAREN,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9535), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [7500] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13112), 1,
      sym__word_identifier,
    ACTIONS(13120), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13122), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13128), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13130), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13134), 1,
      sym_character_literal,
    ACTIONS(13140), 1,
      sym__immediate_paren,
    ACTIONS(13142), 1,
      sym__immediate_bracket,
    ACTIONS(13144), 1,
      sym__immediate_brace,
    STATE(6389), 1,
      sym_identifier,
    STATE(14487), 1,
      sym__delimiter_str_1,
    STATE(14488), 1,
      sym__delimiter_str_3,
    STATE(14489), 1,
      sym__delimiter_cmd_1,
    STATE(14490), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13114), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13126), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13138), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9536), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13118), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13124), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13132), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6939), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13136), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6950), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13116), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [7626] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13146), 1,
      sym__word_identifier,
    ACTIONS(13154), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13156), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13162), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13164), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13168), 1,
      sym_character_literal,
    ACTIONS(13174), 1,
      sym__immediate_paren,
    ACTIONS(13176), 1,
      sym__immediate_bracket,
    ACTIONS(13178), 1,
      sym__immediate_brace,
    STATE(5130), 1,
      sym_identifier,
    STATE(14982), 1,
      sym__delimiter_str_1,
    STATE(14987), 1,
      sym__delimiter_str_3,
    STATE(14990), 1,
      sym__delimiter_cmd_1,
    STATE(15013), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13148), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13160), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13172), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9537), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13152), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13158), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13166), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6298), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13170), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6195), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13150), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [7752] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13180), 1,
      sym__word_identifier,
    ACTIONS(13188), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13190), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13196), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13198), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13202), 1,
      sym_character_literal,
    ACTIONS(13208), 1,
      sym__immediate_paren,
    ACTIONS(13210), 1,
      sym__immediate_bracket,
    ACTIONS(13212), 1,
      sym__immediate_brace,
    STATE(5057), 1,
      sym_identifier,
    STATE(15069), 1,
      sym__delimiter_str_1,
    STATE(15071), 1,
      sym__delimiter_str_3,
    STATE(15072), 1,
      sym__delimiter_cmd_1,
    STATE(15073), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13182), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13194), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13206), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9538), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13186), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13192), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13200), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6037), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13204), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13184), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [7878] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13214), 1,
      sym__word_identifier,
    ACTIONS(13216), 1,
      anon_sym_LPAREN,
    ACTIONS(13218), 1,
      anon_sym_LBRACK,
    ACTIONS(13220), 1,
      anon_sym_LBRACE,
    ACTIONS(13222), 1,
      anon_sym_DOLLAR,
    ACTIONS(13224), 1,
      anon_sym_COLON2,
    ACTIONS(13228), 1,
      sym_character_literal,
    STATE(6129), 1,
      sym_identifier,
    STATE(6593), 1,
      sym__primary_expression,
    STATE(14738), 1,
      sym__delimiter_str_1,
    STATE(14739), 1,
      sym__delimiter_str_3,
    STATE(14741), 1,
      sym__delimiter_cmd_1,
    STATE(14743), 1,
      sym__delimiter_cmd_3,
    STATE(17128), 1,
      sym_macro_identifier,
    STATE(18562), 1,
      sym_operator,
    ACTIONS(13226), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9539), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6580), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6569), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6525), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [8000] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13230), 1,
      sym__word_identifier,
    ACTIONS(13238), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13240), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13246), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13248), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13252), 1,
      sym_character_literal,
    ACTIONS(13258), 1,
      sym__immediate_paren,
    ACTIONS(13260), 1,
      sym__immediate_bracket,
    ACTIONS(13262), 1,
      sym__immediate_brace,
    STATE(5091), 1,
      sym_identifier,
    STATE(14392), 1,
      sym__delimiter_str_1,
    STATE(14393), 1,
      sym__delimiter_str_3,
    STATE(14394), 1,
      sym__delimiter_cmd_1,
    STATE(14395), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13232), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13244), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13256), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9540), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13236), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13242), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13250), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6156), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13254), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6081), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13234), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [8126] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13264), 1,
      sym__word_identifier,
    ACTIONS(13266), 1,
      anon_sym_LPAREN,
    ACTIONS(13268), 1,
      anon_sym_LBRACK,
    ACTIONS(13270), 1,
      anon_sym_LBRACE,
    ACTIONS(13272), 1,
      anon_sym_DOLLAR,
    ACTIONS(13274), 1,
      anon_sym_COLON2,
    ACTIONS(13278), 1,
      sym_character_literal,
    STATE(4995), 1,
      sym_identifier,
    STATE(5607), 1,
      sym__primary_expression,
    STATE(14572), 1,
      sym__delimiter_str_1,
    STATE(14573), 1,
      sym__delimiter_str_3,
    STATE(14574), 1,
      sym__delimiter_cmd_1,
    STATE(14576), 1,
      sym__delimiter_cmd_3,
    STATE(17121), 1,
      sym_macro_identifier,
    STATE(18235), 1,
      sym_operator,
    ACTIONS(13276), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9541), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5501), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5499), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5834), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [8248] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10250), 1,
      sym__word_identifier,
    ACTIONS(13286), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13288), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13300), 1,
      sym_character_literal,
    ACTIONS(13306), 1,
      sym__immediate_paren,
    ACTIONS(13308), 1,
      sym__immediate_bracket,
    ACTIONS(13310), 1,
      sym__immediate_brace,
    STATE(10766), 1,
      sym_identifier,
    STATE(14484), 1,
      sym__delimiter_str_1,
    STATE(14542), 1,
      sym__delimiter_str_3,
    STATE(14549), 1,
      sym__delimiter_cmd_1,
    STATE(14550), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13280), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13304), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9542), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13284), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13290), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11191), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13302), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11339), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13282), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [8374] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13318), 1,
      anon_sym_DOLLAR,
    ACTIONS(13320), 1,
      anon_sym_COLON2,
    ACTIONS(13322), 1,
      sym_character_literal,
    STATE(10685), 1,
      sym_identifier,
    STATE(11275), 1,
      sym__primary_expression,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17618), 1,
      sym_macro_identifier,
    STATE(19350), 1,
      sym_operator,
    ACTIONS(10312), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9543), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10625), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [8496] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(309), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13324), 1,
      sym__word_identifier,
    ACTIONS(13332), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13334), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13338), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13340), 1,
      sym_character_literal,
    ACTIONS(13346), 1,
      sym__immediate_paren,
    ACTIONS(13348), 1,
      sym__immediate_bracket,
    ACTIONS(13350), 1,
      sym__immediate_brace,
    STATE(6379), 1,
      sym_identifier,
    STATE(14991), 1,
      sym__delimiter_str_1,
    STATE(14996), 1,
      sym__delimiter_str_3,
    STATE(14997), 1,
      sym__delimiter_cmd_1,
    STATE(14998), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7754), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13326), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13344), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9544), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7756), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(13330), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13336), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(6871), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13342), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6949), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13328), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [8622] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(8302), 1,
      sym_character_literal,
    ACTIONS(9538), 1,
      sym__word_identifier,
    ACTIONS(9544), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9546), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9548), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9550), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9554), 1,
      sym__immediate_paren,
    ACTIONS(9556), 1,
      sym__immediate_bracket,
    ACTIONS(9558), 1,
      sym__immediate_brace,
    STATE(4212), 1,
      sym_identifier,
    STATE(14404), 1,
      sym__delimiter_str_1,
    STATE(14415), 1,
      sym__delimiter_str_3,
    STATE(14435), 1,
      sym__delimiter_cmd_1,
    STATE(14436), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9540), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13356), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13362), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9545), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13352), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13354), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13358), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4757), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13360), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4669), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9542), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [8748] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13364), 1,
      sym__word_identifier,
    ACTIONS(13372), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13374), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13380), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13382), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13386), 1,
      sym_character_literal,
    ACTIONS(13392), 1,
      sym__immediate_paren,
    ACTIONS(13394), 1,
      sym__immediate_bracket,
    ACTIONS(13396), 1,
      sym__immediate_brace,
    STATE(4874), 1,
      sym_identifier,
    STATE(15097), 1,
      sym__delimiter_str_1,
    STATE(15098), 1,
      sym__delimiter_str_3,
    STATE(15099), 1,
      sym__delimiter_cmd_1,
    STATE(15101), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13366), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13378), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13390), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9546), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13370), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13376), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13384), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5867), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13388), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5720), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13368), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [8874] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(10636), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9547), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [9000] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13428), 1,
      sym__word_identifier,
    ACTIONS(13436), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13438), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13444), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13446), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13450), 1,
      sym_character_literal,
    ACTIONS(13456), 1,
      sym__immediate_paren,
    ACTIONS(13458), 1,
      sym__immediate_bracket,
    ACTIONS(13460), 1,
      sym__immediate_brace,
    STATE(6637), 1,
      sym_identifier,
    STATE(14687), 1,
      sym__delimiter_str_1,
    STATE(14688), 1,
      sym__delimiter_str_3,
    STATE(14689), 1,
      sym__delimiter_cmd_1,
    STATE(14690), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13430), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13442), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13454), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9548), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13434), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13440), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13448), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7271), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13452), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7434), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13432), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [9126] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13462), 1,
      sym__word_identifier,
    ACTIONS(13470), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13472), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13484), 1,
      sym_character_literal,
    ACTIONS(13490), 1,
      sym__immediate_paren,
    ACTIONS(13492), 1,
      sym__immediate_bracket,
    ACTIONS(13494), 1,
      sym__immediate_brace,
    STATE(10557), 1,
      sym_identifier,
    STATE(14545), 1,
      sym__delimiter_str_1,
    STATE(14546), 1,
      sym__delimiter_str_3,
    STATE(14551), 1,
      sym__delimiter_cmd_1,
    STATE(14552), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13464), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13488), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9549), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13468), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13474), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11110), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13486), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11042), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13466), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [9252] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13496), 1,
      sym__word_identifier,
    ACTIONS(13498), 1,
      anon_sym_LPAREN,
    ACTIONS(13500), 1,
      anon_sym_LBRACK,
    ACTIONS(13502), 1,
      anon_sym_LBRACE,
    ACTIONS(13504), 1,
      anon_sym_DOLLAR,
    ACTIONS(13506), 1,
      anon_sym_COLON2,
    ACTIONS(13510), 1,
      sym_character_literal,
    STATE(5580), 1,
      sym_identifier,
    STATE(6362), 1,
      sym__primary_expression,
    STATE(14382), 1,
      sym__delimiter_str_1,
    STATE(14383), 1,
      sym__delimiter_str_3,
    STATE(14385), 1,
      sym__delimiter_cmd_1,
    STATE(14386), 1,
      sym__delimiter_cmd_3,
    STATE(17306), 1,
      sym_macro_identifier,
    STATE(18786), 1,
      sym_operator,
    ACTIONS(13508), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9550), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6410), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6409), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6381), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [9374] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(403), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13512), 1,
      sym__word_identifier,
    ACTIONS(13520), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13522), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13526), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13528), 1,
      sym_character_literal,
    ACTIONS(13534), 1,
      sym__immediate_paren,
    ACTIONS(13536), 1,
      sym__immediate_bracket,
    ACTIONS(13538), 1,
      sym__immediate_brace,
    STATE(6413), 1,
      sym_identifier,
    STATE(14769), 1,
      sym__delimiter_str_1,
    STATE(14770), 1,
      sym__delimiter_str_3,
    STATE(14776), 1,
      sym__delimiter_cmd_1,
    STATE(14788), 1,
      sym__delimiter_cmd_3,
    ACTIONS(6874), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13514), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13532), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9551), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6876), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(13518), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13524), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(6771), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13530), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7181), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13516), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [9500] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13540), 1,
      sym__word_identifier,
    ACTIONS(13542), 1,
      anon_sym_LPAREN,
    ACTIONS(13544), 1,
      anon_sym_LBRACK,
    ACTIONS(13546), 1,
      anon_sym_LBRACE,
    ACTIONS(13548), 1,
      anon_sym_DOLLAR,
    ACTIONS(13550), 1,
      anon_sym_COLON2,
    ACTIONS(13554), 1,
      sym_character_literal,
    STATE(5080), 1,
      sym_identifier,
    STATE(6272), 1,
      sym__primary_expression,
    STATE(14816), 1,
      sym__delimiter_str_1,
    STATE(14819), 1,
      sym__delimiter_str_3,
    STATE(14983), 1,
      sym__delimiter_cmd_1,
    STATE(15076), 1,
      sym__delimiter_cmd_3,
    STATE(17488), 1,
      sym_macro_identifier,
    STATE(19226), 1,
      sym_operator,
    ACTIONS(13552), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9552), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6077), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6075), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6006), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [9622] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13556), 1,
      sym__word_identifier,
    ACTIONS(13564), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13566), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13572), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13574), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13578), 1,
      sym_character_literal,
    ACTIONS(13584), 1,
      sym__immediate_paren,
    ACTIONS(13586), 1,
      sym__immediate_bracket,
    ACTIONS(13588), 1,
      sym__immediate_brace,
    STATE(4861), 1,
      sym_identifier,
    STATE(14988), 1,
      sym__delimiter_str_1,
    STATE(14989), 1,
      sym__delimiter_str_3,
    STATE(14999), 1,
      sym__delimiter_cmd_1,
    STATE(15012), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13558), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13570), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13582), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9553), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13562), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13568), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13576), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5575), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13580), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5557), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13560), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [9748] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13590), 1,
      sym__word_identifier,
    ACTIONS(13592), 1,
      anon_sym_LPAREN,
    ACTIONS(13594), 1,
      anon_sym_LBRACK,
    ACTIONS(13596), 1,
      anon_sym_LBRACE,
    ACTIONS(13598), 1,
      anon_sym_DOLLAR,
    ACTIONS(13600), 1,
      anon_sym_COLON2,
    ACTIONS(13604), 1,
      sym_character_literal,
    STATE(11480), 1,
      sym_identifier,
    STATE(11772), 1,
      sym__primary_expression,
    STATE(14493), 1,
      sym__delimiter_str_1,
    STATE(14494), 1,
      sym__delimiter_str_3,
    STATE(14497), 1,
      sym__delimiter_cmd_1,
    STATE(14499), 1,
      sym__delimiter_cmd_3,
    STATE(17604), 1,
      sym_macro_identifier,
    STATE(19425), 1,
      sym_operator,
    ACTIONS(13602), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9554), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11788), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11786), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(12009), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [9870] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13614), 1,
      anon_sym_DOLLAR,
    ACTIONS(13616), 1,
      anon_sym_COLON2,
    ACTIONS(13620), 1,
      sym_character_literal,
    STATE(10097), 1,
      sym_identifier,
    STATE(10359), 1,
      sym__primary_expression,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17418), 1,
      sym_macro_identifier,
    STATE(19091), 1,
      sym_operator,
    ACTIONS(13618), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9555), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9949), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [9992] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13180), 1,
      sym__word_identifier,
    ACTIONS(13188), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13190), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13196), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13198), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13202), 1,
      sym_character_literal,
    ACTIONS(13208), 1,
      sym__immediate_paren,
    ACTIONS(13210), 1,
      sym__immediate_bracket,
    ACTIONS(13212), 1,
      sym__immediate_brace,
    STATE(5057), 1,
      sym_identifier,
    STATE(15069), 1,
      sym__delimiter_str_1,
    STATE(15071), 1,
      sym__delimiter_str_3,
    STATE(15072), 1,
      sym__delimiter_cmd_1,
    STATE(15073), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13182), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13194), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13206), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9556), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13186), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13192), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13200), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6037), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13204), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13184), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [10118] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11273), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9557), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [10244] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13652), 1,
      sym__word_identifier,
    ACTIONS(13660), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13662), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13668), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13670), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13674), 1,
      sym_character_literal,
    ACTIONS(13680), 1,
      sym__immediate_paren,
    ACTIONS(13682), 1,
      sym__immediate_bracket,
    ACTIONS(13684), 1,
      sym__immediate_brace,
    STATE(4756), 1,
      sym_identifier,
    STATE(14319), 1,
      sym__delimiter_str_1,
    STATE(14320), 1,
      sym__delimiter_str_3,
    STATE(14321), 1,
      sym__delimiter_cmd_1,
    STATE(14322), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13654), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13666), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13678), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9558), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13658), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13664), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13672), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5163), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13676), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5081), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13656), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [10370] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13652), 1,
      sym__word_identifier,
    ACTIONS(13674), 1,
      sym_character_literal,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    ACTIONS(13688), 1,
      anon_sym_LBRACK,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    ACTIONS(13692), 1,
      anon_sym_DOLLAR,
    ACTIONS(13694), 1,
      anon_sym_COLON2,
    STATE(4628), 1,
      sym_identifier,
    STATE(5044), 1,
      sym__primary_expression,
    STATE(14319), 1,
      sym__delimiter_str_1,
    STATE(14320), 1,
      sym__delimiter_str_3,
    STATE(14321), 1,
      sym__delimiter_cmd_1,
    STATE(14322), 1,
      sym__delimiter_cmd_3,
    STATE(17085), 1,
      sym_macro_identifier,
    STATE(19588), 1,
      sym_operator,
    ACTIONS(13696), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9559), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5164), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5163), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5330), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [10492] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13698), 1,
      sym__word_identifier,
    ACTIONS(13700), 1,
      anon_sym_LPAREN,
    ACTIONS(13702), 1,
      anon_sym_LBRACK,
    ACTIONS(13704), 1,
      anon_sym_LBRACE,
    ACTIONS(13706), 1,
      anon_sym_DOLLAR,
    ACTIONS(13708), 1,
      anon_sym_COLON2,
    ACTIONS(13712), 1,
      sym_character_literal,
    STATE(5340), 1,
      sym_identifier,
    STATE(6235), 1,
      sym__primary_expression,
    STATE(14407), 1,
      sym__delimiter_str_1,
    STATE(14408), 1,
      sym__delimiter_str_3,
    STATE(14409), 1,
      sym__delimiter_cmd_1,
    STATE(14414), 1,
      sym__delimiter_cmd_3,
    STATE(17104), 1,
      sym_macro_identifier,
    STATE(18735), 1,
      sym_operator,
    ACTIONS(13710), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9560), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6188), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6187), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6207), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [10614] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13112), 1,
      sym__word_identifier,
    ACTIONS(13120), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13122), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13128), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13130), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13134), 1,
      sym_character_literal,
    ACTIONS(13140), 1,
      sym__immediate_paren,
    ACTIONS(13142), 1,
      sym__immediate_bracket,
    ACTIONS(13144), 1,
      sym__immediate_brace,
    STATE(6389), 1,
      sym_identifier,
    STATE(14487), 1,
      sym__delimiter_str_1,
    STATE(14488), 1,
      sym__delimiter_str_3,
    STATE(14489), 1,
      sym__delimiter_cmd_1,
    STATE(14490), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13114), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13126), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13138), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9561), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13118), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13124), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13132), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6939), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13136), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6950), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13116), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [10740] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13714), 1,
      sym__word_identifier,
    ACTIONS(13722), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13724), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13730), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13732), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13736), 1,
      sym_character_literal,
    ACTIONS(13742), 1,
      sym__immediate_paren,
    ACTIONS(13744), 1,
      sym__immediate_bracket,
    ACTIONS(13746), 1,
      sym__immediate_brace,
    STATE(4949), 1,
      sym_identifier,
    STATE(14755), 1,
      sym__delimiter_str_1,
    STATE(14765), 1,
      sym__delimiter_str_3,
    STATE(14767), 1,
      sym__delimiter_cmd_1,
    STATE(14806), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13716), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13728), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13740), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9562), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13720), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13726), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13734), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5907), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13738), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5734), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13718), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [10866] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(891), 1,
      sym_character_literal,
    ACTIONS(9462), 1,
      sym__word_identifier,
    ACTIONS(9470), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9472), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9488), 1,
      sym__immediate_paren,
    ACTIONS(9490), 1,
      sym__immediate_bracket,
    ACTIONS(9492), 1,
      sym__immediate_brace,
    STATE(4197), 1,
      sym_identifier,
    STATE(14318), 1,
      sym__delimiter_cmd_1,
    STATE(14504), 1,
      sym__delimiter_cmd_3,
    STATE(14701), 1,
      sym__delimiter_str_1,
    STATE(14899), 1,
      sym__delimiter_str_3,
    ACTIONS(9464), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(9476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(9486), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9563), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9468), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9474), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(9482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4665), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(9484), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4564), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9466), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [10992] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13748), 1,
      sym__word_identifier,
    ACTIONS(13756), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13758), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13764), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13766), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13770), 1,
      sym_character_literal,
    ACTIONS(13776), 1,
      sym__immediate_paren,
    ACTIONS(13778), 1,
      sym__immediate_bracket,
    ACTIONS(13780), 1,
      sym__immediate_brace,
    STATE(6355), 1,
      sym_identifier,
    STATE(14829), 1,
      sym__delimiter_str_1,
    STATE(14830), 1,
      sym__delimiter_str_3,
    STATE(14831), 1,
      sym__delimiter_cmd_1,
    STATE(14832), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13750), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13762), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13774), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9564), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13754), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13760), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13768), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6989), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13772), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7036), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13752), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [11118] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(7970), 1,
      sym_character_literal,
    ACTIONS(9494), 1,
      sym__word_identifier,
    ACTIONS(9500), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9502), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9504), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9506), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9510), 1,
      sym__immediate_paren,
    ACTIONS(9512), 1,
      sym__immediate_bracket,
    ACTIONS(9514), 1,
      sym__immediate_brace,
    STATE(4157), 1,
      sym_identifier,
    STATE(15043), 1,
      sym__delimiter_str_1,
    STATE(15045), 1,
      sym__delimiter_str_3,
    STATE(15046), 1,
      sym__delimiter_cmd_1,
    STATE(15047), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9496), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13786), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13792), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9565), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13782), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13784), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13788), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4580), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13790), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4743), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9498), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [11244] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13462), 1,
      sym__word_identifier,
    ACTIONS(13470), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13472), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13484), 1,
      sym_character_literal,
    ACTIONS(13490), 1,
      sym__immediate_paren,
    ACTIONS(13492), 1,
      sym__immediate_bracket,
    ACTIONS(13494), 1,
      sym__immediate_brace,
    STATE(10557), 1,
      sym_identifier,
    STATE(14545), 1,
      sym__delimiter_str_1,
    STATE(14546), 1,
      sym__delimiter_str_3,
    STATE(14551), 1,
      sym__delimiter_cmd_1,
    STATE(14552), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13464), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13488), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9566), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13468), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13474), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11110), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13486), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11042), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13466), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [11370] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13794), 1,
      sym__word_identifier,
    ACTIONS(13802), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13804), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13810), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13812), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13816), 1,
      sym_character_literal,
    ACTIONS(13822), 1,
      sym__immediate_paren,
    ACTIONS(13824), 1,
      sym__immediate_bracket,
    ACTIONS(13826), 1,
      sym__immediate_brace,
    STATE(4868), 1,
      sym_identifier,
    STATE(14855), 1,
      sym__delimiter_str_1,
    STATE(14857), 1,
      sym__delimiter_str_3,
    STATE(14860), 1,
      sym__delimiter_cmd_1,
    STATE(14864), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13796), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13808), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13820), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9567), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13800), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13806), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13814), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5376), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13818), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5775), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13798), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [11496] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(599), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13828), 1,
      sym__word_identifier,
    ACTIONS(13836), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13838), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13842), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13844), 1,
      sym_character_literal,
    ACTIONS(13850), 1,
      sym__immediate_paren,
    ACTIONS(13852), 1,
      sym__immediate_bracket,
    ACTIONS(13854), 1,
      sym__immediate_brace,
    STATE(6556), 1,
      sym_identifier,
    STATE(14340), 1,
      sym__delimiter_str_1,
    STATE(14341), 1,
      sym__delimiter_str_3,
    STATE(14342), 1,
      sym__delimiter_cmd_1,
    STATE(14343), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7966), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13830), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13848), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9568), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7968), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(13834), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13840), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(7617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13846), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7526), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13832), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [11622] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13856), 1,
      sym__word_identifier,
    ACTIONS(13858), 1,
      anon_sym_LPAREN,
    ACTIONS(13860), 1,
      anon_sym_LBRACK,
    ACTIONS(13862), 1,
      anon_sym_LBRACE,
    ACTIONS(13864), 1,
      anon_sym_DOLLAR,
    ACTIONS(13866), 1,
      anon_sym_COLON2,
    ACTIONS(13870), 1,
      sym_character_literal,
    STATE(5273), 1,
      sym_identifier,
    STATE(5948), 1,
      sym__primary_expression,
    STATE(14607), 1,
      sym__delimiter_str_1,
    STATE(14609), 1,
      sym__delimiter_str_3,
    STATE(14610), 1,
      sym__delimiter_cmd_1,
    STATE(14611), 1,
      sym__delimiter_cmd_3,
    STATE(17341), 1,
      sym_macro_identifier,
    STATE(18896), 1,
      sym_operator,
    ACTIONS(13868), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9569), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5960), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5958), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6270), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [11744] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12926), 1,
      sym__word_identifier,
    ACTIONS(12932), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12934), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12942), 1,
      sym__immediate_paren,
    ACTIONS(12944), 1,
      sym__immediate_bracket,
    ACTIONS(12946), 1,
      sym__immediate_brace,
    STATE(10284), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12928), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13882), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9570), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13872), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13874), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13880), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9979), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12930), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [11870] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12894), 1,
      sym__word_identifier,
    ACTIONS(12902), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12904), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12920), 1,
      sym__immediate_paren,
    ACTIONS(12922), 1,
      sym__immediate_bracket,
    ACTIONS(12924), 1,
      sym__immediate_brace,
    STATE(10294), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12896), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(12918), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9571), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12900), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(12906), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(12916), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9803), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12898), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [11996] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13230), 1,
      sym__word_identifier,
    ACTIONS(13238), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13240), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13246), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13248), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13252), 1,
      sym_character_literal,
    ACTIONS(13258), 1,
      sym__immediate_paren,
    ACTIONS(13260), 1,
      sym__immediate_bracket,
    ACTIONS(13262), 1,
      sym__immediate_brace,
    STATE(5091), 1,
      sym_identifier,
    STATE(14392), 1,
      sym__delimiter_str_1,
    STATE(14393), 1,
      sym__delimiter_str_3,
    STATE(14394), 1,
      sym__delimiter_cmd_1,
    STATE(14395), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13232), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13244), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13256), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9572), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13236), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13242), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13250), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6156), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13254), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6081), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13234), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [12122] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11192), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9573), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [12248] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13884), 1,
      sym__word_identifier,
    ACTIONS(13886), 1,
      anon_sym_LPAREN,
    ACTIONS(13888), 1,
      anon_sym_LBRACK,
    ACTIONS(13890), 1,
      anon_sym_LBRACE,
    ACTIONS(13892), 1,
      anon_sym_DOLLAR,
    ACTIONS(13894), 1,
      anon_sym_COLON2,
    ACTIONS(13898), 1,
      sym_character_literal,
    STATE(4919), 1,
      sym_identifier,
    STATE(5630), 1,
      sym__primary_expression,
    STATE(14940), 1,
      sym__delimiter_str_1,
    STATE(14941), 1,
      sym__delimiter_str_3,
    STATE(14942), 1,
      sym__delimiter_cmd_1,
    STATE(14943), 1,
      sym__delimiter_cmd_3,
    STATE(17622), 1,
      sym_macro_identifier,
    STATE(19451), 1,
      sym_operator,
    ACTIONS(13896), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9574), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5804), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5803), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5665), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [12370] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(689), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13900), 1,
      sym__word_identifier,
    ACTIONS(13908), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13910), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13914), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13916), 1,
      sym_character_literal,
    ACTIONS(13922), 1,
      sym__immediate_paren,
    ACTIONS(13924), 1,
      sym__immediate_bracket,
    ACTIONS(13926), 1,
      sym__immediate_brace,
    STATE(6685), 1,
      sym_identifier,
    STATE(14757), 1,
      sym__delimiter_str_1,
    STATE(14758), 1,
      sym__delimiter_str_3,
    STATE(14760), 1,
      sym__delimiter_cmd_1,
    STATE(14768), 1,
      sym__delimiter_cmd_3,
    ACTIONS(4948), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13902), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13920), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9575), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4950), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(13906), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13912), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(7344), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13918), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7660), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13904), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [12496] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6900), 1,
      sym_character_literal,
    ACTIONS(9582), 1,
      sym__word_identifier,
    ACTIONS(9588), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9590), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9592), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9594), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9598), 1,
      sym__immediate_paren,
    ACTIONS(9600), 1,
      sym__immediate_bracket,
    ACTIONS(9602), 1,
      sym__immediate_brace,
    STATE(4438), 1,
      sym_identifier,
    STATE(14985), 1,
      sym__delimiter_str_1,
    STATE(14986), 1,
      sym__delimiter_str_3,
    STATE(14993), 1,
      sym__delimiter_cmd_1,
    STATE(15001), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9584), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(12970), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(12976), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9576), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12966), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(12968), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(12972), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4966), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(12974), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5017), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9586), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [12622] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(7380), 1,
      sym_character_literal,
    ACTIONS(9516), 1,
      sym__word_identifier,
    ACTIONS(9522), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9524), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9526), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9528), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9532), 1,
      sym__immediate_paren,
    ACTIONS(9534), 1,
      sym__immediate_bracket,
    ACTIONS(9536), 1,
      sym__immediate_brace,
    STATE(4219), 1,
      sym_identifier,
    STATE(14818), 1,
      sym__delimiter_str_1,
    STATE(14828), 1,
      sym__delimiter_str_3,
    STATE(14844), 1,
      sym__delimiter_cmd_1,
    STATE(14846), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9518), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13932), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13938), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9577), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13928), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13930), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13934), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4741), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13936), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4720), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9520), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [12748] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13940), 1,
      sym__word_identifier,
    ACTIONS(13948), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13950), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13956), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13958), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13962), 1,
      sym_character_literal,
    ACTIONS(13968), 1,
      sym__immediate_paren,
    ACTIONS(13970), 1,
      sym__immediate_bracket,
    ACTIONS(13972), 1,
      sym__immediate_brace,
    STATE(4941), 1,
      sym_identifier,
    STATE(14374), 1,
      sym__delimiter_str_1,
    STATE(14375), 1,
      sym__delimiter_str_3,
    STATE(14376), 1,
      sym__delimiter_cmd_1,
    STATE(14377), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13942), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13954), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13966), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9578), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13946), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13952), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13960), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5445), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13964), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5940), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13944), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [12874] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11192), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9579), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13000] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(11195), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9580), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13126] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(11195), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9581), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13252] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(11051), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9582), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13378] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(11053), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9583), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13504] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(11051), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9584), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13630] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(11053), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9585), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13756] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12894), 1,
      sym__word_identifier,
    ACTIONS(12902), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12904), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12920), 1,
      sym__immediate_paren,
    ACTIONS(12922), 1,
      sym__immediate_bracket,
    ACTIONS(12924), 1,
      sym__immediate_brace,
    STATE(9836), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12896), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(12918), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9586), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12900), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(12906), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(12916), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9803), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12898), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [13882] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14068), 1,
      sym__word_identifier,
    ACTIONS(14076), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14078), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14084), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14086), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14090), 1,
      sym_character_literal,
    ACTIONS(14096), 1,
      sym__immediate_paren,
    ACTIONS(14098), 1,
      sym__immediate_bracket,
    ACTIONS(14100), 1,
      sym__immediate_brace,
    STATE(6337), 1,
      sym_identifier,
    STATE(14756), 1,
      sym__delimiter_str_1,
    STATE(14759), 1,
      sym__delimiter_str_3,
    STATE(14762), 1,
      sym__delimiter_cmd_1,
    STATE(14763), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14070), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14082), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14094), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9587), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14074), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14080), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14088), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6729), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14092), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6829), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14072), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [14008] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(12992), 1,
      anon_sym_COLON2,
    STATE(11378), 1,
      sym_identifier,
    STATE(11534), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9588), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [14130] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14102), 1,
      anon_sym_DOLLAR,
    ACTIONS(14104), 1,
      anon_sym_COLON2,
    STATE(11048), 1,
      sym_identifier,
    STATE(11405), 1,
      sym__primary_expression,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17418), 1,
      sym_macro_identifier,
    STATE(19091), 1,
      sym_operator,
    ACTIONS(13618), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9589), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9949), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [14252] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10920), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9590), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [14378] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14106), 1,
      sym__word_identifier,
    ACTIONS(14114), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14116), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14122), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14124), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14128), 1,
      sym_character_literal,
    ACTIONS(14134), 1,
      sym__immediate_paren,
    ACTIONS(14136), 1,
      sym__immediate_bracket,
    ACTIONS(14138), 1,
      sym__immediate_brace,
    STATE(4547), 1,
      sym_identifier,
    STATE(14959), 1,
      sym__delimiter_str_1,
    STATE(14976), 1,
      sym__delimiter_str_3,
    STATE(14979), 1,
      sym__delimiter_cmd_1,
    STATE(15037), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14108), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14120), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14132), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9591), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14112), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14118), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14126), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5349), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14130), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5361), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14110), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [14504] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14140), 1,
      sym__word_identifier,
    ACTIONS(14148), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14150), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14156), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14158), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14162), 1,
      sym_character_literal,
    ACTIONS(14168), 1,
      sym__immediate_paren,
    ACTIONS(14170), 1,
      sym__immediate_bracket,
    ACTIONS(14172), 1,
      sym__immediate_brace,
    STATE(11492), 1,
      sym_identifier,
    STATE(14817), 1,
      sym__delimiter_str_1,
    STATE(14906), 1,
      sym__delimiter_str_3,
    STATE(14951), 1,
      sym__delimiter_cmd_1,
    STATE(14954), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14142), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14154), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14166), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9592), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14146), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14152), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14160), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14164), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11706), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14144), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [14630] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14174), 1,
      sym__word_identifier,
    ACTIONS(14182), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14184), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14190), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14192), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14196), 1,
      sym_character_literal,
    ACTIONS(14202), 1,
      sym__immediate_paren,
    ACTIONS(14204), 1,
      sym__immediate_bracket,
    ACTIONS(14206), 1,
      sym__immediate_brace,
    STATE(6398), 1,
      sym_identifier,
    STATE(14554), 1,
      sym__delimiter_str_1,
    STATE(14555), 1,
      sym__delimiter_str_3,
    STATE(14556), 1,
      sym__delimiter_cmd_1,
    STATE(14557), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14176), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14188), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14200), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9593), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14180), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14186), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14194), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7064), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14198), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7070), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14178), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [14756] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(10109), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9594), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [14882] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12926), 1,
      sym__word_identifier,
    ACTIONS(12932), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12934), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12942), 1,
      sym__immediate_paren,
    ACTIONS(12944), 1,
      sym__immediate_bracket,
    ACTIONS(12946), 1,
      sym__immediate_brace,
    STATE(10184), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12928), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13882), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9595), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13872), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13874), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13880), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9979), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12930), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15008] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12894), 1,
      sym__word_identifier,
    ACTIONS(12902), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12904), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12920), 1,
      sym__immediate_paren,
    ACTIONS(12922), 1,
      sym__immediate_bracket,
    ACTIONS(12924), 1,
      sym__immediate_brace,
    STATE(10550), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12896), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(12918), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9596), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12900), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(12906), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(12916), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9803), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12898), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15134] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11071), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9597), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15260] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11071), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9598), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15386] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(11501), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9599), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15512] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(11501), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9600), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15638] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10695), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9601), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15764] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(11406), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9602), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [15890] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10695), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9603), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [16016] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(11406), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9604), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [16142] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12948), 1,
      anon_sym_DOLLAR,
    ACTIONS(14208), 1,
      anon_sym_COLON2,
    STATE(11497), 1,
      sym_identifier,
    STATE(11840), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9605), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [16264] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14210), 1,
      anon_sym_DOLLAR,
    ACTIONS(14212), 1,
      anon_sym_COLON2,
    STATE(11414), 1,
      sym_identifier,
    STATE(11691), 1,
      sym__primary_expression,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17418), 1,
      sym_macro_identifier,
    STATE(19091), 1,
      sym_operator,
    ACTIONS(13618), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9606), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9949), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [16386] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12926), 1,
      sym__word_identifier,
    ACTIONS(12932), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12934), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12942), 1,
      sym__immediate_paren,
    ACTIONS(12944), 1,
      sym__immediate_bracket,
    ACTIONS(12946), 1,
      sym__immediate_brace,
    STATE(10075), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12928), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13882), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9607), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13872), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13874), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13880), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9979), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12930), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [16512] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12894), 1,
      sym__word_identifier,
    ACTIONS(12902), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12904), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12920), 1,
      sym__immediate_paren,
    ACTIONS(12922), 1,
      sym__immediate_bracket,
    ACTIONS(12924), 1,
      sym__immediate_brace,
    STATE(10076), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12896), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(12918), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9608), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12900), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(12906), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(12916), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9803), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12898), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [16638] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(10731), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9609), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [16764] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(10731), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9610), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [16890] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(10747), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9611), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [17016] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(10747), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9612), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [17142] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10607), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9613), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [17268] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(10612), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9614), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [17394] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10607), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9615), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [17520] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(10612), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9616), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [17646] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12535), 1,
      anon_sym_DOLLAR,
    ACTIONS(14214), 1,
      anon_sym_COLON2,
    STATE(10688), 1,
      sym_identifier,
    STATE(11330), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9617), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [17768] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14216), 1,
      anon_sym_DOLLAR,
    ACTIONS(14218), 1,
      anon_sym_COLON2,
    STATE(10593), 1,
      sym_identifier,
    STATE(11158), 1,
      sym__primary_expression,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17418), 1,
      sym_macro_identifier,
    STATE(19091), 1,
      sym_operator,
    ACTIONS(13618), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9618), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9949), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [17890] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12926), 1,
      sym__word_identifier,
    ACTIONS(12932), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12934), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12942), 1,
      sym__immediate_paren,
    ACTIONS(12944), 1,
      sym__immediate_bracket,
    ACTIONS(12946), 1,
      sym__immediate_brace,
    STATE(10206), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12928), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13882), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9619), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13872), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13874), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13880), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9979), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12930), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18016] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11090), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9620), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18142] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11090), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9621), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18268] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10718), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9622), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18394] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10718), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9623), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18520] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12926), 1,
      sym__word_identifier,
    ACTIONS(12932), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12934), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12942), 1,
      sym__immediate_paren,
    ACTIONS(12944), 1,
      sym__immediate_bracket,
    ACTIONS(12946), 1,
      sym__immediate_brace,
    STATE(10209), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12928), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13882), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9624), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13872), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13874), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13880), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9979), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12930), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18646] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11098), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9625), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18772] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11098), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9626), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [18898] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10742), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9627), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19024] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10742), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9628), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19150] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14220), 1,
      anon_sym_DOLLAR,
    ACTIONS(14222), 1,
      anon_sym_COLON2,
    STATE(11374), 1,
      sym_identifier,
    STATE(11578), 1,
      sym__primary_expression,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17618), 1,
      sym_macro_identifier,
    STATE(19350), 1,
      sym_operator,
    ACTIONS(10312), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9629), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10625), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [19272] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(14230), 1,
      anon_sym_DOLLAR,
    ACTIONS(14232), 1,
      anon_sym_COLON2,
    STATE(11047), 1,
      sym_identifier,
    STATE(11403), 1,
      sym__primary_expression,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17385), 1,
      sym_macro_identifier,
    STATE(18997), 1,
      sym_operator,
    ACTIONS(14234), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9630), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10434), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [19394] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13146), 1,
      sym__word_identifier,
    ACTIONS(13154), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13156), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13162), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13164), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13168), 1,
      sym_character_literal,
    ACTIONS(13174), 1,
      sym__immediate_paren,
    ACTIONS(13176), 1,
      sym__immediate_bracket,
    ACTIONS(13178), 1,
      sym__immediate_brace,
    STATE(5130), 1,
      sym_identifier,
    STATE(14982), 1,
      sym__delimiter_str_1,
    STATE(14987), 1,
      sym__delimiter_str_3,
    STATE(14990), 1,
      sym__delimiter_cmd_1,
    STATE(15013), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13148), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13160), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13172), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9631), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13152), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13158), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13166), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6298), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13170), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6195), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13150), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19520] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(14236), 1,
      anon_sym_DOLLAR,
    ACTIONS(14238), 1,
      anon_sym_COLON2,
    STATE(10980), 1,
      sym_identifier,
    STATE(11383), 1,
      sym__primary_expression,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17385), 1,
      sym_macro_identifier,
    STATE(18997), 1,
      sym_operator,
    ACTIONS(14234), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9632), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10434), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [19642] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11601), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9633), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19768] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13540), 1,
      sym__word_identifier,
    ACTIONS(13554), 1,
      sym_character_literal,
    ACTIONS(14280), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14282), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14288), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14290), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14298), 1,
      sym__immediate_paren,
    ACTIONS(14300), 1,
      sym__immediate_bracket,
    ACTIONS(14302), 1,
      sym__immediate_brace,
    STATE(5132), 1,
      sym_identifier,
    STATE(14816), 1,
      sym__delimiter_str_1,
    STATE(14819), 1,
      sym__delimiter_str_3,
    STATE(14983), 1,
      sym__delimiter_cmd_1,
    STATE(15076), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14274), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14286), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14296), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9634), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14278), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14284), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14292), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6075), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14294), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6008), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14276), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [19894] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14304), 1,
      sym__word_identifier,
    ACTIONS(14312), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14314), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14326), 1,
      sym_character_literal,
    ACTIONS(14332), 1,
      sym__immediate_paren,
    ACTIONS(14334), 1,
      sym__immediate_bracket,
    ACTIONS(14336), 1,
      sym__immediate_brace,
    STATE(14444), 1,
      sym__delimiter_str_1,
    STATE(14447), 1,
      sym__delimiter_str_3,
    STATE(14448), 1,
      sym__delimiter_cmd_1,
    STATE(14449), 1,
      sym__delimiter_cmd_3,
    STATE(14553), 1,
      sym_identifier,
    ACTIONS(14306), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14318), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14330), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9635), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14310), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14316), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(16651), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14328), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(15550), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14308), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20020] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13652), 1,
      sym__word_identifier,
    ACTIONS(13660), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13662), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13668), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13670), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13674), 1,
      sym_character_literal,
    ACTIONS(13680), 1,
      sym__immediate_paren,
    ACTIONS(13682), 1,
      sym__immediate_bracket,
    ACTIONS(13684), 1,
      sym__immediate_brace,
    STATE(4756), 1,
      sym_identifier,
    STATE(14319), 1,
      sym__delimiter_str_1,
    STATE(14320), 1,
      sym__delimiter_str_3,
    STATE(14321), 1,
      sym__delimiter_cmd_1,
    STATE(14322), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13654), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13666), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13678), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9636), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13658), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13664), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13672), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5163), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13676), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5081), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13656), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20146] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14338), 1,
      sym__word_identifier,
    ACTIONS(14346), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14348), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14354), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14356), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14360), 1,
      sym_character_literal,
    ACTIONS(14366), 1,
      sym__immediate_paren,
    ACTIONS(14368), 1,
      sym__immediate_bracket,
    ACTIONS(14370), 1,
      sym__immediate_brace,
    STATE(7777), 1,
      sym_identifier,
    STATE(14708), 1,
      sym__delimiter_str_1,
    STATE(14718), 1,
      sym__delimiter_str_3,
    STATE(14719), 1,
      sym__delimiter_cmd_1,
    STATE(14720), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14340), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14352), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14364), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9637), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14344), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14350), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14358), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8768), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14362), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(8631), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14342), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20272] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13180), 1,
      sym__word_identifier,
    ACTIONS(13202), 1,
      sym_character_literal,
    ACTIONS(14372), 1,
      anon_sym_LPAREN,
    ACTIONS(14374), 1,
      anon_sym_LBRACK,
    ACTIONS(14376), 1,
      anon_sym_LBRACE,
    ACTIONS(14378), 1,
      anon_sym_DOLLAR,
    ACTIONS(14380), 1,
      anon_sym_COLON2,
    STATE(5051), 1,
      sym_identifier,
    STATE(6043), 1,
      sym__primary_expression,
    STATE(15069), 1,
      sym__delimiter_str_1,
    STATE(15071), 1,
      sym__delimiter_str_3,
    STATE(15072), 1,
      sym__delimiter_cmd_1,
    STATE(15073), 1,
      sym__delimiter_cmd_3,
    STATE(17448), 1,
      sym_macro_identifier,
    STATE(19159), 1,
      sym_operator,
    ACTIONS(14382), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9638), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6039), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6037), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5959), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [20394] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14384), 1,
      sym__word_identifier,
    ACTIONS(14392), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14394), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14400), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14402), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14406), 1,
      sym_character_literal,
    ACTIONS(14412), 1,
      sym__immediate_paren,
    ACTIONS(14414), 1,
      sym__immediate_bracket,
    ACTIONS(14416), 1,
      sym__immediate_brace,
    STATE(6427), 1,
      sym_identifier,
    STATE(14356), 1,
      sym__delimiter_str_1,
    STATE(14357), 1,
      sym__delimiter_str_3,
    STATE(14358), 1,
      sym__delimiter_cmd_1,
    STATE(14360), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14386), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14398), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14410), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9639), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14390), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14396), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6719), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14408), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6731), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14388), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20520] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14418), 1,
      sym__word_identifier,
    ACTIONS(14426), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14428), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14434), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14436), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14440), 1,
      sym_character_literal,
    ACTIONS(14446), 1,
      sym__immediate_paren,
    ACTIONS(14448), 1,
      sym__immediate_bracket,
    ACTIONS(14450), 1,
      sym__immediate_brace,
    STATE(6160), 1,
      sym_identifier,
    STATE(14821), 1,
      sym__delimiter_str_1,
    STATE(14824), 1,
      sym__delimiter_str_3,
    STATE(14825), 1,
      sym__delimiter_cmd_1,
    STATE(14826), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14420), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14432), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14444), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9640), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14424), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14430), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14438), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6576), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14442), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6673), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14422), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20646] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13364), 1,
      sym__word_identifier,
    ACTIONS(13386), 1,
      sym_character_literal,
    ACTIONS(14452), 1,
      anon_sym_LPAREN,
    ACTIONS(14454), 1,
      anon_sym_LBRACK,
    ACTIONS(14456), 1,
      anon_sym_LBRACE,
    ACTIONS(14458), 1,
      anon_sym_DOLLAR,
    ACTIONS(14460), 1,
      anon_sym_COLON2,
    STATE(4961), 1,
      sym_identifier,
    STATE(5660), 1,
      sym__primary_expression,
    STATE(15097), 1,
      sym__delimiter_str_1,
    STATE(15098), 1,
      sym__delimiter_str_3,
    STATE(15099), 1,
      sym__delimiter_cmd_1,
    STATE(15101), 1,
      sym__delimiter_cmd_3,
    STATE(17633), 1,
      sym_macro_identifier,
    STATE(19478), 1,
      sym_operator,
    ACTIONS(14462), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9641), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5868), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5867), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5942), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [20768] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13714), 1,
      sym__word_identifier,
    ACTIONS(13722), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13724), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13730), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13732), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13736), 1,
      sym_character_literal,
    ACTIONS(13742), 1,
      sym__immediate_paren,
    ACTIONS(13744), 1,
      sym__immediate_bracket,
    ACTIONS(13746), 1,
      sym__immediate_brace,
    STATE(4949), 1,
      sym_identifier,
    STATE(14755), 1,
      sym__delimiter_str_1,
    STATE(14765), 1,
      sym__delimiter_str_3,
    STATE(14767), 1,
      sym__delimiter_cmd_1,
    STATE(14806), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13716), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13728), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13740), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9642), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13720), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13726), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13734), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5907), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13738), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5734), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13718), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [20894] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13590), 1,
      sym__word_identifier,
    ACTIONS(13604), 1,
      sym_character_literal,
    ACTIONS(14470), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14472), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14488), 1,
      sym__immediate_paren,
    ACTIONS(14490), 1,
      sym__immediate_bracket,
    ACTIONS(14492), 1,
      sym__immediate_brace,
    STATE(11536), 1,
      sym_identifier,
    STATE(14493), 1,
      sym__delimiter_str_1,
    STATE(14494), 1,
      sym__delimiter_str_3,
    STATE(14497), 1,
      sym__delimiter_cmd_1,
    STATE(14499), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14464), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14486), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9643), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14468), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14474), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11786), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14484), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11752), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14466), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21020] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(515), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14494), 1,
      sym__word_identifier,
    ACTIONS(14502), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14504), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14508), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14510), 1,
      sym_character_literal,
    ACTIONS(14516), 1,
      sym__immediate_paren,
    ACTIONS(14518), 1,
      sym__immediate_bracket,
    ACTIONS(14520), 1,
      sym__immediate_brace,
    STATE(6689), 1,
      sym_identifier,
    STATE(14520), 1,
      sym__delimiter_str_1,
    STATE(14521), 1,
      sym__delimiter_str_3,
    STATE(14523), 1,
      sym__delimiter_cmd_1,
    STATE(14524), 1,
      sym__delimiter_cmd_3,
    ACTIONS(8298), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14496), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14514), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9644), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8300), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(14500), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14506), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(7483), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14512), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7847), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14498), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21146] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14106), 1,
      sym__word_identifier,
    ACTIONS(14128), 1,
      sym_character_literal,
    ACTIONS(14522), 1,
      anon_sym_LPAREN,
    ACTIONS(14524), 1,
      anon_sym_LBRACK,
    ACTIONS(14526), 1,
      anon_sym_LBRACE,
    ACTIONS(14528), 1,
      anon_sym_DOLLAR,
    ACTIONS(14530), 1,
      anon_sym_COLON2,
    STATE(4722), 1,
      sym_identifier,
    STATE(5256), 1,
      sym__primary_expression,
    STATE(14959), 1,
      sym__delimiter_str_1,
    STATE(14976), 1,
      sym__delimiter_str_3,
    STATE(14979), 1,
      sym__delimiter_cmd_1,
    STATE(15037), 1,
      sym__delimiter_cmd_3,
    STATE(17523), 1,
      sym_macro_identifier,
    STATE(19292), 1,
      sym_operator,
    ACTIONS(14532), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9645), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5351), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5349), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5324), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [21268] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(10199), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9646), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21394] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14534), 1,
      sym__word_identifier,
    ACTIONS(14542), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14544), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14550), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14552), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14556), 1,
      sym_character_literal,
    ACTIONS(14562), 1,
      sym__immediate_paren,
    ACTIONS(14564), 1,
      sym__immediate_bracket,
    ACTIONS(14566), 1,
      sym__immediate_brace,
    STATE(6393), 1,
      sym_identifier,
    STATE(15049), 1,
      sym__delimiter_str_1,
    STATE(15051), 1,
      sym__delimiter_str_3,
    STATE(15053), 1,
      sym__delimiter_cmd_1,
    STATE(15055), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14536), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14548), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14560), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9647), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14540), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14546), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14554), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7095), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14558), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7164), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14538), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21520] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13940), 1,
      sym__word_identifier,
    ACTIONS(13948), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13950), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13956), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13958), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13962), 1,
      sym_character_literal,
    ACTIONS(13968), 1,
      sym__immediate_paren,
    ACTIONS(13970), 1,
      sym__immediate_bracket,
    ACTIONS(13972), 1,
      sym__immediate_brace,
    STATE(4941), 1,
      sym_identifier,
    STATE(14374), 1,
      sym__delimiter_str_1,
    STATE(14375), 1,
      sym__delimiter_str_3,
    STATE(14376), 1,
      sym__delimiter_cmd_1,
    STATE(14377), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13942), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13954), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13966), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9648), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13946), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13952), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13960), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5445), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13964), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5940), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13944), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21646] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(10250), 1,
      sym__word_identifier,
    ACTIONS(13300), 1,
      sym_character_literal,
    ACTIONS(14568), 1,
      anon_sym_LPAREN,
    ACTIONS(14570), 1,
      anon_sym_LBRACK,
    ACTIONS(14572), 1,
      anon_sym_LBRACE,
    ACTIONS(14574), 1,
      anon_sym_DOLLAR,
    ACTIONS(14576), 1,
      anon_sym_COLON2,
    STATE(10753), 1,
      sym_identifier,
    STATE(11207), 1,
      sym__primary_expression,
    STATE(14484), 1,
      sym__delimiter_str_1,
    STATE(14542), 1,
      sym__delimiter_str_3,
    STATE(14549), 1,
      sym__delimiter_cmd_1,
    STATE(14550), 1,
      sym__delimiter_cmd_3,
    STATE(17548), 1,
      sym_macro_identifier,
    STATE(19341), 1,
      sym_operator,
    ACTIONS(10264), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9649), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11198), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11191), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11286), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [21768] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4952), 1,
      sym_character_literal,
    ACTIONS(9560), 1,
      sym__word_identifier,
    ACTIONS(9566), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9568), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9570), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9572), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9576), 1,
      sym__immediate_paren,
    ACTIONS(9578), 1,
      sym__immediate_bracket,
    ACTIONS(9580), 1,
      sym__immediate_brace,
    STATE(4143), 1,
      sym_identifier,
    STATE(14410), 1,
      sym__delimiter_str_1,
    STATE(14411), 1,
      sym__delimiter_str_3,
    STATE(14412), 1,
      sym__delimiter_cmd_1,
    STATE(14413), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9562), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14582), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14588), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9650), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14578), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14580), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14584), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4855), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14586), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4670), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9564), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [21894] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13264), 1,
      sym__word_identifier,
    ACTIONS(13278), 1,
      sym_character_literal,
    ACTIONS(14596), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14598), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14604), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14606), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14614), 1,
      sym__immediate_paren,
    ACTIONS(14616), 1,
      sym__immediate_bracket,
    ACTIONS(14618), 1,
      sym__immediate_brace,
    STATE(4980), 1,
      sym_identifier,
    STATE(14572), 1,
      sym__delimiter_str_1,
    STATE(14573), 1,
      sym__delimiter_str_3,
    STATE(14574), 1,
      sym__delimiter_cmd_1,
    STATE(14576), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14590), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14602), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14612), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9651), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14594), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14600), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14608), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5499), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14610), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5449), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14592), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22020] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(885), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14620), 1,
      sym__word_identifier,
    ACTIONS(14628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14634), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14636), 1,
      sym_character_literal,
    ACTIONS(14642), 1,
      sym__immediate_paren,
    ACTIONS(14644), 1,
      sym__immediate_bracket,
    ACTIONS(14646), 1,
      sym__immediate_brace,
    STATE(6572), 1,
      sym_identifier,
    STATE(15003), 1,
      sym__delimiter_str_1,
    STATE(15004), 1,
      sym__delimiter_str_3,
    STATE(15009), 1,
      sym__delimiter_cmd_1,
    STATE(15011), 1,
      sym__delimiter_cmd_3,
    ACTIONS(883), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14640), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9652), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(889), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(14626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(7567), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14638), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7803), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22146] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13112), 1,
      sym__word_identifier,
    ACTIONS(13134), 1,
      sym_character_literal,
    ACTIONS(14648), 1,
      anon_sym_LPAREN,
    ACTIONS(14650), 1,
      anon_sym_LBRACK,
    ACTIONS(14652), 1,
      anon_sym_LBRACE,
    ACTIONS(14654), 1,
      anon_sym_DOLLAR,
    ACTIONS(14656), 1,
      anon_sym_COLON2,
    STATE(6334), 1,
      sym_identifier,
    STATE(6930), 1,
      sym__primary_expression,
    STATE(14487), 1,
      sym__delimiter_str_1,
    STATE(14488), 1,
      sym__delimiter_str_3,
    STATE(14489), 1,
      sym__delimiter_cmd_1,
    STATE(14490), 1,
      sym__delimiter_cmd_3,
    STATE(17115), 1,
      sym_macro_identifier,
    STATE(18902), 1,
      sym_operator,
    ACTIONS(14658), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9653), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6943), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6939), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7034), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [22268] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14660), 1,
      anon_sym_DOLLAR,
    ACTIONS(14662), 1,
      anon_sym_COLON2,
    STATE(11070), 1,
      sym_identifier,
    STATE(11416), 1,
      sym__primary_expression,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17618), 1,
      sym_macro_identifier,
    STATE(19350), 1,
      sym_operator,
    ACTIONS(10312), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9654), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10625), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [22390] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(14664), 1,
      anon_sym_DOLLAR,
    ACTIONS(14666), 1,
      anon_sym_COLON2,
    STATE(10829), 1,
      sym_identifier,
    STATE(11324), 1,
      sym__primary_expression,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17385), 1,
      sym_macro_identifier,
    STATE(18997), 1,
      sym_operator,
    ACTIONS(14234), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9655), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10434), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [22512] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11509), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9656), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22638] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(10774), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9657), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [22764] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14668), 1,
      anon_sym_DOLLAR,
    ACTIONS(14670), 1,
      anon_sym_COLON2,
    STATE(11089), 1,
      sym_identifier,
    STATE(11418), 1,
      sym__primary_expression,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17618), 1,
      sym_macro_identifier,
    STATE(19350), 1,
      sym_operator,
    ACTIONS(10312), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9658), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10625), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [22886] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(14672), 1,
      anon_sym_DOLLAR,
    ACTIONS(14674), 1,
      anon_sym_COLON2,
    STATE(10590), 1,
      sym_identifier,
    STATE(11157), 1,
      sym__primary_expression,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17385), 1,
      sym_macro_identifier,
    STATE(18997), 1,
      sym_operator,
    ACTIONS(14234), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9659), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10434), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [23008] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11808), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9660), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23134] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(11826), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9661), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23260] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14676), 1,
      anon_sym_DOLLAR,
    ACTIONS(14678), 1,
      anon_sym_COLON2,
    STATE(11097), 1,
      sym_identifier,
    STATE(11420), 1,
      sym__primary_expression,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17618), 1,
      sym_macro_identifier,
    STATE(19350), 1,
      sym_operator,
    ACTIONS(10312), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9662), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10625), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [23382] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(14680), 1,
      anon_sym_DOLLAR,
    ACTIONS(14682), 1,
      anon_sym_COLON2,
    STATE(10713), 1,
      sym_identifier,
    STATE(11337), 1,
      sym__primary_expression,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17385), 1,
      sym_macro_identifier,
    STATE(18997), 1,
      sym_operator,
    ACTIONS(14234), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9663), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10434), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [23504] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11876), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9664), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23630] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(12184), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9665), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [23756] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(14684), 1,
      anon_sym_DOLLAR,
    ACTIONS(14686), 1,
      anon_sym_COLON2,
    STATE(10738), 1,
      sym_identifier,
    STATE(11342), 1,
      sym__primary_expression,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17385), 1,
      sym_macro_identifier,
    STATE(18997), 1,
      sym_operator,
    ACTIONS(14234), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9666), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10434), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [23878] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11399), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9667), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24004] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(11400), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9668), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24130] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11523), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9669), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24256] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(12671), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9670), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24382] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11645), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9671), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24508] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(11527), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9672), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24634] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11528), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9673), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24760] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11649), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9674), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [24886] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11530), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9675), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25012] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11652), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9676), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25138] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14106), 1,
      sym__word_identifier,
    ACTIONS(14128), 1,
      sym_character_literal,
    ACTIONS(14522), 1,
      anon_sym_LPAREN,
    ACTIONS(14524), 1,
      anon_sym_LBRACK,
    ACTIONS(14526), 1,
      anon_sym_LBRACE,
    ACTIONS(14528), 1,
      anon_sym_DOLLAR,
    ACTIONS(14530), 1,
      anon_sym_COLON2,
    STATE(4722), 1,
      sym_identifier,
    STATE(5061), 1,
      sym__primary_expression,
    STATE(14959), 1,
      sym__delimiter_str_1,
    STATE(14976), 1,
      sym__delimiter_str_3,
    STATE(14979), 1,
      sym__delimiter_cmd_1,
    STATE(15037), 1,
      sym__delimiter_cmd_3,
    STATE(17523), 1,
      sym_macro_identifier,
    STATE(19292), 1,
      sym_operator,
    ACTIONS(14532), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9677), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5351), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5349), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5324), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [25260] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14688), 1,
      sym__word_identifier,
    ACTIONS(14696), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14698), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14704), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14706), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14710), 1,
      sym_character_literal,
    ACTIONS(14716), 1,
      sym__immediate_paren,
    ACTIONS(14718), 1,
      sym__immediate_bracket,
    ACTIONS(14720), 1,
      sym__immediate_brace,
    STATE(14608), 1,
      sym__delimiter_str_1,
    STATE(14614), 1,
      sym__delimiter_str_3,
    STATE(14615), 1,
      sym__delimiter_cmd_1,
    STATE(14617), 1,
      sym__delimiter_cmd_3,
    STATE(16052), 1,
      sym_identifier,
    ACTIONS(14690), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14702), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14714), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9678), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14694), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14700), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14708), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(17780), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14712), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(17752), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14692), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25386] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14140), 1,
      sym__word_identifier,
    ACTIONS(14148), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14150), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14156), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14158), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14162), 1,
      sym_character_literal,
    ACTIONS(14168), 1,
      sym__immediate_paren,
    ACTIONS(14170), 1,
      sym__immediate_bracket,
    ACTIONS(14172), 1,
      sym__immediate_brace,
    STATE(11423), 1,
      sym_identifier,
    STATE(14817), 1,
      sym__delimiter_str_1,
    STATE(14906), 1,
      sym__delimiter_str_3,
    STATE(14951), 1,
      sym__delimiter_cmd_1,
    STATE(14954), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14142), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14154), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14166), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9679), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14146), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14152), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14160), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14164), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11706), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14144), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25512] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12926), 1,
      sym__word_identifier,
    ACTIONS(12932), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12934), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12942), 1,
      sym__immediate_paren,
    ACTIONS(12944), 1,
      sym__immediate_bracket,
    ACTIONS(12946), 1,
      sym__immediate_brace,
    STATE(10251), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12928), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13882), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9680), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13872), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13874), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13880), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9979), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12930), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25638] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10250), 1,
      sym__word_identifier,
    ACTIONS(13286), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13288), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13300), 1,
      sym_character_literal,
    ACTIONS(13306), 1,
      sym__immediate_paren,
    ACTIONS(13308), 1,
      sym__immediate_bracket,
    ACTIONS(13310), 1,
      sym__immediate_brace,
    STATE(10766), 1,
      sym_identifier,
    STATE(14484), 1,
      sym__delimiter_str_1,
    STATE(14542), 1,
      sym__delimiter_str_3,
    STATE(14549), 1,
      sym__delimiter_cmd_1,
    STATE(14550), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13280), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13304), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9681), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13284), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13290), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11191), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13302), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11339), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13282), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [25764] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13940), 1,
      sym__word_identifier,
    ACTIONS(13962), 1,
      sym_character_literal,
    ACTIONS(14722), 1,
      anon_sym_LPAREN,
    ACTIONS(14724), 1,
      anon_sym_LBRACK,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(14728), 1,
      anon_sym_DOLLAR,
    ACTIONS(14730), 1,
      anon_sym_COLON2,
    STATE(4952), 1,
      sym_identifier,
    STATE(5587), 1,
      sym__primary_expression,
    STATE(14374), 1,
      sym__delimiter_str_1,
    STATE(14375), 1,
      sym__delimiter_str_3,
    STATE(14376), 1,
      sym__delimiter_cmd_1,
    STATE(14377), 1,
      sym__delimiter_cmd_3,
    STATE(17095), 1,
      sym_macro_identifier,
    STATE(19607), 1,
      sym_operator,
    ACTIONS(14732), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9682), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5446), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5445), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5774), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [25886] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1307), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14734), 1,
      sym__word_identifier,
    ACTIONS(14742), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14744), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14748), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14750), 1,
      sym_character_literal,
    ACTIONS(14756), 1,
      sym__immediate_paren,
    ACTIONS(14758), 1,
      sym__immediate_bracket,
    ACTIONS(14760), 1,
      sym__immediate_brace,
    STATE(8443), 1,
      sym_identifier,
    STATE(14660), 1,
      sym__delimiter_str_1,
    STATE(14662), 1,
      sym__delimiter_str_3,
    STATE(14663), 1,
      sym__delimiter_cmd_1,
    STATE(14664), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1305), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14736), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14754), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9683), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1311), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(14740), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14746), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(8960), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14752), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9103), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14738), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26012] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13714), 1,
      sym__word_identifier,
    ACTIONS(13736), 1,
      sym_character_literal,
    ACTIONS(14762), 1,
      anon_sym_LPAREN,
    ACTIONS(14764), 1,
      anon_sym_LBRACK,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(14768), 1,
      anon_sym_DOLLAR,
    ACTIONS(14770), 1,
      anon_sym_COLON2,
    STATE(5015), 1,
      sym_identifier,
    STATE(5787), 1,
      sym__primary_expression,
    STATE(14755), 1,
      sym__delimiter_str_1,
    STATE(14765), 1,
      sym__delimiter_str_3,
    STATE(14767), 1,
      sym__delimiter_cmd_1,
    STATE(14806), 1,
      sym__delimiter_cmd_3,
    STATE(17667), 1,
      sym_macro_identifier,
    STATE(19520), 1,
      sym_operator,
    ACTIONS(14772), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9684), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5908), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5907), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5707), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [26134] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13214), 1,
      sym__word_identifier,
    ACTIONS(13228), 1,
      sym_character_literal,
    ACTIONS(14780), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14782), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14788), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14790), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14798), 1,
      sym__immediate_paren,
    ACTIONS(14800), 1,
      sym__immediate_bracket,
    ACTIONS(14802), 1,
      sym__immediate_brace,
    STATE(6250), 1,
      sym_identifier,
    STATE(14738), 1,
      sym__delimiter_str_1,
    STATE(14739), 1,
      sym__delimiter_str_3,
    STATE(14741), 1,
      sym__delimiter_cmd_1,
    STATE(14743), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14774), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14786), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14796), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9685), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14778), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14784), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14792), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6569), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14794), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6498), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14776), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26260] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14804), 1,
      anon_sym_DOLLAR,
    ACTIONS(14806), 1,
      anon_sym_COLON2,
    STATE(11233), 1,
      sym_identifier,
    STATE(11513), 1,
      sym__primary_expression,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17618), 1,
      sym_macro_identifier,
    STATE(19350), 1,
      sym_operator,
    ACTIONS(10312), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9686), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10625), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [26382] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13856), 1,
      sym__word_identifier,
    ACTIONS(13870), 1,
      sym_character_literal,
    ACTIONS(14814), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14816), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14822), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14824), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14832), 1,
      sym__immediate_paren,
    ACTIONS(14834), 1,
      sym__immediate_bracket,
    ACTIONS(14836), 1,
      sym__immediate_brace,
    STATE(5140), 1,
      sym_identifier,
    STATE(14607), 1,
      sym__delimiter_str_1,
    STATE(14609), 1,
      sym__delimiter_str_3,
    STATE(14610), 1,
      sym__delimiter_cmd_1,
    STATE(14611), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14808), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14820), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14830), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9687), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14812), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14818), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14826), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5958), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14828), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6271), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14810), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26508] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13794), 1,
      sym__word_identifier,
    ACTIONS(13816), 1,
      sym_character_literal,
    ACTIONS(14838), 1,
      anon_sym_LPAREN,
    ACTIONS(14840), 1,
      anon_sym_LBRACK,
    ACTIONS(14842), 1,
      anon_sym_LBRACE,
    ACTIONS(14844), 1,
      anon_sym_DOLLAR,
    ACTIONS(14846), 1,
      anon_sym_COLON2,
    STATE(4900), 1,
      sym_identifier,
    STATE(5875), 1,
      sym__primary_expression,
    STATE(14855), 1,
      sym__delimiter_str_1,
    STATE(14857), 1,
      sym__delimiter_str_3,
    STATE(14860), 1,
      sym__delimiter_cmd_1,
    STATE(14864), 1,
      sym__delimiter_cmd_3,
    STATE(17080), 1,
      sym_macro_identifier,
    STATE(19571), 1,
      sym_operator,
    ACTIONS(14848), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9688), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5377), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5376), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5733), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [26630] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13980), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13982), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13998), 1,
      sym__immediate_paren,
    ACTIONS(14000), 1,
      sym__immediate_bracket,
    ACTIONS(14002), 1,
      sym__immediate_brace,
    STATE(10199), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13974), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13996), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9689), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13978), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13984), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13994), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10039), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13976), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26756] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14850), 1,
      sym__word_identifier,
    ACTIONS(14858), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14860), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14866), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14868), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14872), 1,
      sym_character_literal,
    ACTIONS(14878), 1,
      sym__immediate_paren,
    ACTIONS(14880), 1,
      sym__immediate_bracket,
    ACTIONS(14882), 1,
      sym__immediate_brace,
    STATE(6267), 1,
      sym_identifier,
    STATE(14292), 1,
      sym__delimiter_str_3,
    STATE(14293), 1,
      sym__delimiter_cmd_1,
    STATE(14294), 1,
      sym__delimiter_cmd_3,
    STATE(15107), 1,
      sym__delimiter_str_1,
    ACTIONS(14852), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14864), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14876), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9690), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14856), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14862), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14870), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6657), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14874), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6574), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14854), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [26882] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14106), 1,
      sym__word_identifier,
    ACTIONS(14114), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14116), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14122), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14124), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14128), 1,
      sym_character_literal,
    ACTIONS(14134), 1,
      sym__immediate_paren,
    ACTIONS(14136), 1,
      sym__immediate_bracket,
    ACTIONS(14138), 1,
      sym__immediate_brace,
    STATE(4547), 1,
      sym_identifier,
    STATE(14959), 1,
      sym__delimiter_str_1,
    STATE(14976), 1,
      sym__delimiter_str_3,
    STATE(14979), 1,
      sym__delimiter_cmd_1,
    STATE(15037), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14108), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14120), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14132), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9691), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14112), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14118), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14126), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5349), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14130), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5361), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14110), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27008] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13364), 1,
      sym__word_identifier,
    ACTIONS(13372), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13374), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13380), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13382), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13386), 1,
      sym_character_literal,
    ACTIONS(13392), 1,
      sym__immediate_paren,
    ACTIONS(13394), 1,
      sym__immediate_bracket,
    ACTIONS(13396), 1,
      sym__immediate_brace,
    STATE(4874), 1,
      sym_identifier,
    STATE(15097), 1,
      sym__delimiter_str_1,
    STATE(15098), 1,
      sym__delimiter_str_3,
    STATE(15099), 1,
      sym__delimiter_cmd_1,
    STATE(15101), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13366), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13378), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13390), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9692), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13370), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13376), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13384), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5867), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13388), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5720), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13368), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27134] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(777), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14884), 1,
      sym__word_identifier,
    ACTIONS(14892), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14894), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14898), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14900), 1,
      sym_character_literal,
    ACTIONS(14906), 1,
      sym__immediate_paren,
    ACTIONS(14908), 1,
      sym__immediate_bracket,
    ACTIONS(14910), 1,
      sym__immediate_brace,
    STATE(6599), 1,
      sym_identifier,
    STATE(14597), 1,
      sym__delimiter_str_1,
    STATE(14599), 1,
      sym__delimiter_str_3,
    STATE(14600), 1,
      sym__delimiter_cmd_1,
    STATE(14601), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7376), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14886), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14904), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9693), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7378), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(14890), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14896), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(7804), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14902), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(7680), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14888), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27260] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13556), 1,
      sym__word_identifier,
    ACTIONS(13564), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13566), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13572), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13574), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13578), 1,
      sym_character_literal,
    ACTIONS(13584), 1,
      sym__immediate_paren,
    ACTIONS(13586), 1,
      sym__immediate_bracket,
    ACTIONS(13588), 1,
      sym__immediate_brace,
    STATE(4861), 1,
      sym_identifier,
    STATE(14988), 1,
      sym__delimiter_str_1,
    STATE(14989), 1,
      sym__delimiter_str_3,
    STATE(14999), 1,
      sym__delimiter_cmd_1,
    STATE(15012), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13558), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13570), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13582), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9694), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13562), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13568), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13576), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5575), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13580), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5557), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13560), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27386] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13856), 1,
      sym__word_identifier,
    ACTIONS(13870), 1,
      sym_character_literal,
    ACTIONS(14814), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14816), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14822), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14824), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14832), 1,
      sym__immediate_paren,
    ACTIONS(14834), 1,
      sym__immediate_bracket,
    ACTIONS(14836), 1,
      sym__immediate_brace,
    STATE(5140), 1,
      sym_identifier,
    STATE(14607), 1,
      sym__delimiter_str_1,
    STATE(14609), 1,
      sym__delimiter_str_3,
    STATE(14610), 1,
      sym__delimiter_cmd_1,
    STATE(14611), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14808), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14820), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14830), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9695), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14812), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14818), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14826), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5958), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14828), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6271), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14810), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27512] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13214), 1,
      sym__word_identifier,
    ACTIONS(13228), 1,
      sym_character_literal,
    ACTIONS(14780), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14782), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14788), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14790), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14798), 1,
      sym__immediate_paren,
    ACTIONS(14800), 1,
      sym__immediate_bracket,
    ACTIONS(14802), 1,
      sym__immediate_brace,
    STATE(6250), 1,
      sym_identifier,
    STATE(14738), 1,
      sym__delimiter_str_1,
    STATE(14739), 1,
      sym__delimiter_str_3,
    STATE(14741), 1,
      sym__delimiter_cmd_1,
    STATE(14743), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14774), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14786), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14796), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9696), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14778), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14784), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14792), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6569), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14794), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6498), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14776), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27638] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13264), 1,
      sym__word_identifier,
    ACTIONS(13278), 1,
      sym_character_literal,
    ACTIONS(14596), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14598), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14604), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14606), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14614), 1,
      sym__immediate_paren,
    ACTIONS(14616), 1,
      sym__immediate_bracket,
    ACTIONS(14618), 1,
      sym__immediate_brace,
    STATE(4980), 1,
      sym_identifier,
    STATE(14572), 1,
      sym__delimiter_str_1,
    STATE(14573), 1,
      sym__delimiter_str_3,
    STATE(14574), 1,
      sym__delimiter_cmd_1,
    STATE(14576), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14590), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14602), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14612), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9697), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14594), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14600), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14608), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5499), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14610), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5449), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14592), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27764] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6878), 1,
      sym_character_literal,
    ACTIONS(9440), 1,
      sym__word_identifier,
    ACTIONS(9446), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9448), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9450), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9452), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9456), 1,
      sym__immediate_paren,
    ACTIONS(9458), 1,
      sym__immediate_bracket,
    ACTIONS(9460), 1,
      sym__immediate_brace,
    STATE(4112), 1,
      sym_identifier,
    STATE(14869), 1,
      sym__delimiter_str_1,
    STATE(14870), 1,
      sym__delimiter_str_3,
    STATE(14871), 1,
      sym__delimiter_cmd_1,
    STATE(14872), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9442), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14916), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14922), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9698), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14912), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14914), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14918), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4291), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14920), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4506), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9444), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [27890] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13540), 1,
      sym__word_identifier,
    ACTIONS(13554), 1,
      sym_character_literal,
    ACTIONS(14280), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14282), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14288), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14290), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14298), 1,
      sym__immediate_paren,
    ACTIONS(14300), 1,
      sym__immediate_bracket,
    ACTIONS(14302), 1,
      sym__immediate_brace,
    STATE(5132), 1,
      sym_identifier,
    STATE(14816), 1,
      sym__delimiter_str_1,
    STATE(14819), 1,
      sym__delimiter_str_3,
    STATE(14983), 1,
      sym__delimiter_cmd_1,
    STATE(15076), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14274), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14286), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14296), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9699), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14278), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14284), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14292), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6075), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14294), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6008), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14276), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28016] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13698), 1,
      sym__word_identifier,
    ACTIONS(13712), 1,
      sym_character_literal,
    ACTIONS(14930), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14932), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14938), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14940), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14948), 1,
      sym__immediate_paren,
    ACTIONS(14950), 1,
      sym__immediate_bracket,
    ACTIONS(14952), 1,
      sym__immediate_brace,
    STATE(5127), 1,
      sym_identifier,
    STATE(14407), 1,
      sym__delimiter_str_1,
    STATE(14408), 1,
      sym__delimiter_str_3,
    STATE(14409), 1,
      sym__delimiter_cmd_1,
    STATE(14414), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14924), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14936), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14946), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9700), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14928), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14934), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14942), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6187), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14944), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5955), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14926), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28142] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13146), 1,
      sym__word_identifier,
    ACTIONS(13168), 1,
      sym_character_literal,
    ACTIONS(14954), 1,
      anon_sym_LPAREN,
    ACTIONS(14956), 1,
      anon_sym_LBRACK,
    ACTIONS(14958), 1,
      anon_sym_LBRACE,
    ACTIONS(14960), 1,
      anon_sym_DOLLAR,
    ACTIONS(14962), 1,
      anon_sym_COLON2,
    STATE(5206), 1,
      sym_identifier,
    STATE(6193), 1,
      sym__primary_expression,
    STATE(14982), 1,
      sym__delimiter_str_1,
    STATE(14987), 1,
      sym__delimiter_str_3,
    STATE(14990), 1,
      sym__delimiter_cmd_1,
    STATE(15013), 1,
      sym__delimiter_cmd_3,
    STATE(17072), 1,
      sym_macro_identifier,
    STATE(19544), 1,
      sym_operator,
    ACTIONS(14964), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9701), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6299), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6298), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6140), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [28264] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13230), 1,
      sym__word_identifier,
    ACTIONS(13252), 1,
      sym_character_literal,
    ACTIONS(14966), 1,
      anon_sym_LPAREN,
    ACTIONS(14968), 1,
      anon_sym_LBRACK,
    ACTIONS(14970), 1,
      anon_sym_LBRACE,
    ACTIONS(14972), 1,
      anon_sym_DOLLAR,
    ACTIONS(14974), 1,
      anon_sym_COLON2,
    STATE(5217), 1,
      sym_identifier,
    STATE(6131), 1,
      sym__primary_expression,
    STATE(14392), 1,
      sym__delimiter_str_1,
    STATE(14393), 1,
      sym__delimiter_str_3,
    STATE(14394), 1,
      sym__delimiter_cmd_1,
    STATE(14395), 1,
      sym__delimiter_cmd_3,
    STATE(17585), 1,
      sym_macro_identifier,
    STATE(19401), 1,
      sym_operator,
    ACTIONS(14976), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9702), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6157), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6156), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6076), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [28386] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14004), 1,
      sym__word_identifier,
    ACTIONS(14012), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14014), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14032), 1,
      sym__immediate_paren,
    ACTIONS(14034), 1,
      sym__immediate_bracket,
    ACTIONS(14036), 1,
      sym__immediate_brace,
    STATE(10920), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14006), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14030), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9703), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14010), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14016), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14028), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10479), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14008), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28512] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1313), 1,
      sym_character_literal,
    ACTIONS(9604), 1,
      sym__word_identifier,
    ACTIONS(9612), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9614), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9620), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9622), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9630), 1,
      sym__immediate_paren,
    ACTIONS(9632), 1,
      sym__immediate_bracket,
    ACTIONS(9634), 1,
      sym__immediate_brace,
    STATE(4932), 1,
      sym_identifier,
    STATE(14900), 1,
      sym__delimiter_str_1,
    STATE(14902), 1,
      sym__delimiter_str_3,
    STATE(14903), 1,
      sym__delimiter_cmd_1,
    STATE(14904), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9606), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(9618), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(9628), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9704), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9610), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9616), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(9624), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5408), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(9626), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5859), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9608), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28638] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13462), 1,
      sym__word_identifier,
    ACTIONS(13484), 1,
      sym_character_literal,
    ACTIONS(14978), 1,
      anon_sym_LPAREN,
    ACTIONS(14980), 1,
      anon_sym_LBRACK,
    ACTIONS(14982), 1,
      anon_sym_LBRACE,
    ACTIONS(14984), 1,
      anon_sym_DOLLAR,
    ACTIONS(14986), 1,
      anon_sym_COLON2,
    STATE(10606), 1,
      sym_identifier,
    STATE(10928), 1,
      sym__primary_expression,
    STATE(14545), 1,
      sym__delimiter_str_1,
    STATE(14546), 1,
      sym__delimiter_str_3,
    STATE(14551), 1,
      sym__delimiter_cmd_1,
    STATE(14552), 1,
      sym__delimiter_cmd_3,
    STATE(17644), 1,
      sym_macro_identifier,
    STATE(19505), 1,
      sym_operator,
    ACTIONS(14988), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9705), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11111), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11110), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10852), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [28760] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14240), 1,
      sym__word_identifier,
    ACTIONS(14248), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14250), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(14268), 1,
      sym__immediate_paren,
    ACTIONS(14270), 1,
      sym__immediate_bracket,
    ACTIONS(14272), 1,
      sym__immediate_brace,
    STATE(11731), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14242), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14266), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9706), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14246), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14252), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14264), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11284), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14244), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [28886] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13698), 1,
      sym__word_identifier,
    ACTIONS(13712), 1,
      sym_character_literal,
    ACTIONS(14930), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14932), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14938), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14940), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14948), 1,
      sym__immediate_paren,
    ACTIONS(14950), 1,
      sym__immediate_bracket,
    ACTIONS(14952), 1,
      sym__immediate_brace,
    STATE(5127), 1,
      sym_identifier,
    STATE(14407), 1,
      sym__delimiter_str_1,
    STATE(14408), 1,
      sym__delimiter_str_3,
    STATE(14409), 1,
      sym__delimiter_cmd_1,
    STATE(14414), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14924), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14936), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14946), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9707), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14928), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14934), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14942), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6187), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14944), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5955), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14926), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29012] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13496), 1,
      sym__word_identifier,
    ACTIONS(13510), 1,
      sym_character_literal,
    ACTIONS(14996), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14998), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(15004), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15006), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15014), 1,
      sym__immediate_paren,
    ACTIONS(15016), 1,
      sym__immediate_bracket,
    ACTIONS(15018), 1,
      sym__immediate_brace,
    STATE(5606), 1,
      sym_identifier,
    STATE(14382), 1,
      sym__delimiter_str_1,
    STATE(14383), 1,
      sym__delimiter_str_3,
    STATE(14385), 1,
      sym__delimiter_cmd_1,
    STATE(14386), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14990), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(15002), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15012), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9708), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14994), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(15000), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(15008), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6409), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(15010), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14992), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29138] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9880), 1,
      sym__word_identifier,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(11031), 1,
      anon_sym_DOLLAR,
    ACTIONS(15020), 1,
      anon_sym_COLON2,
    STATE(10165), 1,
      sym_identifier,
    STATE(10509), 1,
      sym__primary_expression,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17364), 1,
      sym_macro_identifier,
    STATE(18422), 1,
      sym_operator,
    ACTIONS(9894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9709), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10053), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [29260] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13496), 1,
      sym__word_identifier,
    ACTIONS(13510), 1,
      sym_character_literal,
    ACTIONS(14996), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14998), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(15004), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15006), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15014), 1,
      sym__immediate_paren,
    ACTIONS(15016), 1,
      sym__immediate_bracket,
    ACTIONS(15018), 1,
      sym__immediate_brace,
    STATE(5606), 1,
      sym_identifier,
    STATE(14382), 1,
      sym__delimiter_str_1,
    STATE(14383), 1,
      sym__delimiter_str_3,
    STATE(14385), 1,
      sym__delimiter_cmd_1,
    STATE(14386), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14990), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(15002), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15012), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9710), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14994), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(15000), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(15008), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6409), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(15010), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14992), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29386] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13556), 1,
      sym__word_identifier,
    ACTIONS(13578), 1,
      sym_character_literal,
    ACTIONS(15022), 1,
      anon_sym_LPAREN,
    ACTIONS(15024), 1,
      anon_sym_LBRACK,
    ACTIONS(15026), 1,
      anon_sym_LBRACE,
    ACTIONS(15028), 1,
      anon_sym_DOLLAR,
    ACTIONS(15030), 1,
      anon_sym_COLON2,
    STATE(4860), 1,
      sym_identifier,
    STATE(5662), 1,
      sym__primary_expression,
    STATE(14988), 1,
      sym__delimiter_str_1,
    STATE(14989), 1,
      sym__delimiter_str_3,
    STATE(14999), 1,
      sym__delimiter_cmd_1,
    STATE(15012), 1,
      sym__delimiter_cmd_3,
    STATE(17256), 1,
      sym_macro_identifier,
    STATE(18688), 1,
      sym_operator,
    ACTIONS(15032), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9711), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5576), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5575), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5533), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [29508] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(10300), 1,
      sym__word_identifier,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13628), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13630), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13646), 1,
      sym__immediate_paren,
    ACTIONS(13648), 1,
      sym__immediate_bracket,
    ACTIONS(13650), 1,
      sym__immediate_brace,
    STATE(11273), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13622), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13644), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9712), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13626), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13632), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13642), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10658), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13624), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29634] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13794), 1,
      sym__word_identifier,
    ACTIONS(13802), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13804), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13810), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13812), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13816), 1,
      sym_character_literal,
    ACTIONS(13822), 1,
      sym__immediate_paren,
    ACTIONS(13824), 1,
      sym__immediate_bracket,
    ACTIONS(13826), 1,
      sym__immediate_brace,
    STATE(4868), 1,
      sym_identifier,
    STATE(14855), 1,
      sym__delimiter_str_1,
    STATE(14857), 1,
      sym__delimiter_str_3,
    STATE(14860), 1,
      sym__delimiter_cmd_1,
    STATE(14864), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13796), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13808), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13820), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9713), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13800), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13806), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13814), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5376), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13818), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5775), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13798), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29760] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4506), 1,
      sym_character_literal,
    ACTIONS(12872), 1,
      sym__word_identifier,
    ACTIONS(12878), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12880), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(12882), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12884), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(12888), 1,
      sym__immediate_paren,
    ACTIONS(12890), 1,
      sym__immediate_bracket,
    ACTIONS(12892), 1,
      sym__immediate_brace,
    STATE(10044), 1,
      sym_identifier,
    STATE(14632), 1,
      sym__delimiter_str_1,
    STATE(14633), 1,
      sym__delimiter_str_3,
    STATE(14641), 1,
      sym__delimiter_cmd_1,
    STATE(14642), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12874), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(15038), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15044), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9714), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15034), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(15036), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(15040), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10364), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(15042), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10283), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(12876), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [29886] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13884), 1,
      sym__word_identifier,
    ACTIONS(13898), 1,
      sym_character_literal,
    ACTIONS(15052), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15054), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(15060), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15062), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15070), 1,
      sym__immediate_paren,
    ACTIONS(15072), 1,
      sym__immediate_bracket,
    ACTIONS(15074), 1,
      sym__immediate_brace,
    STATE(5036), 1,
      sym_identifier,
    STATE(14940), 1,
      sym__delimiter_str_1,
    STATE(14941), 1,
      sym__delimiter_str_3,
    STATE(14942), 1,
      sym__delimiter_cmd_1,
    STATE(14943), 1,
      sym__delimiter_cmd_3,
    ACTIONS(15046), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(15058), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15068), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9715), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15050), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(15056), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(15064), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5803), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(15066), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5689), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(15048), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30012] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13540), 1,
      sym__word_identifier,
    ACTIONS(13542), 1,
      anon_sym_LPAREN,
    ACTIONS(13544), 1,
      anon_sym_LBRACK,
    ACTIONS(13546), 1,
      anon_sym_LBRACE,
    ACTIONS(13548), 1,
      anon_sym_DOLLAR,
    ACTIONS(13550), 1,
      anon_sym_COLON2,
    ACTIONS(13554), 1,
      sym_character_literal,
    STATE(5080), 1,
      sym_identifier,
    STATE(6151), 1,
      sym__primary_expression,
    STATE(14816), 1,
      sym__delimiter_str_1,
    STATE(14819), 1,
      sym__delimiter_str_3,
    STATE(14983), 1,
      sym__delimiter_cmd_1,
    STATE(15076), 1,
      sym__delimiter_cmd_3,
    STATE(17488), 1,
      sym_macro_identifier,
    STATE(19226), 1,
      sym_operator,
    ACTIONS(13552), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(9716), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6077), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6075), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(1825), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(1823), 9,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(6006), 15,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_adjoint_expression,
      sym_field_expression,
      sym_index_expression,
      sym_parametrized_type_expression,
      sym_call_expression,
      sym_broadcast_call_expression,
      sym__closed_macrocall_expression,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_boolean_literal,
      sym__string,
  [30134] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(983), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15076), 1,
      sym__word_identifier,
    ACTIONS(15084), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15086), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(15090), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15092), 1,
      sym_character_literal,
    ACTIONS(15098), 1,
      sym__immediate_paren,
    ACTIONS(15100), 1,
      sym__immediate_bracket,
    ACTIONS(15102), 1,
      sym__immediate_brace,
    STATE(7160), 1,
      sym_identifier,
    STATE(14575), 1,
      sym__delimiter_str_1,
    STATE(14578), 1,
      sym__delimiter_str_3,
    STATE(14582), 1,
      sym__delimiter_cmd_1,
    STATE(14583), 1,
      sym__delimiter_cmd_3,
    ACTIONS(6896), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15078), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(15096), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9717), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6898), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    ACTIONS(15082), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(15088), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    STATE(8382), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(15094), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(8154), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(15080), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30260] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13606), 1,
      sym__word_identifier,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14044), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14046), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14062), 1,
      sym__immediate_paren,
    ACTIONS(14064), 1,
      sym__immediate_bracket,
    ACTIONS(14066), 1,
      sym__immediate_brace,
    STATE(10109), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14038), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14060), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9718), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14042), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14048), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14058), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(9964), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14040), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30386] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(7758), 1,
      sym_character_literal,
    ACTIONS(9418), 1,
      sym__word_identifier,
    ACTIONS(9424), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9426), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(9428), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9430), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(9434), 1,
      sym__immediate_paren,
    ACTIONS(9436), 1,
      sym__immediate_bracket,
    ACTIONS(9438), 1,
      sym__immediate_brace,
    STATE(4126), 1,
      sym_identifier,
    STATE(14791), 1,
      sym__delimiter_str_1,
    STATE(14793), 1,
      sym__delimiter_str_3,
    STATE(14798), 1,
      sym__delimiter_cmd_1,
    STATE(14800), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9420), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(15108), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15114), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9719), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15104), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(15106), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(15110), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4317), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(15112), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(4369), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(9422), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30512] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13884), 1,
      sym__word_identifier,
    ACTIONS(13898), 1,
      sym_character_literal,
    ACTIONS(15052), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15054), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(15060), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15062), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15070), 1,
      sym__immediate_paren,
    ACTIONS(15072), 1,
      sym__immediate_bracket,
    ACTIONS(15074), 1,
      sym__immediate_brace,
    STATE(5036), 1,
      sym_identifier,
    STATE(14940), 1,
      sym__delimiter_str_1,
    STATE(14941), 1,
      sym__delimiter_str_3,
    STATE(14942), 1,
      sym__delimiter_cmd_1,
    STATE(14943), 1,
      sym__delimiter_cmd_3,
    ACTIONS(15046), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(15058), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(15068), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9720), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15050), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(15056), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(15064), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5803), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(15066), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(5689), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(15048), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30638] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13590), 1,
      sym__word_identifier,
    ACTIONS(13604), 1,
      sym_character_literal,
    ACTIONS(14470), 1,
      anon_sym_DOT_EQ,
    ACTIONS(14472), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(14478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14488), 1,
      sym__immediate_paren,
    ACTIONS(14490), 1,
      sym__immediate_bracket,
    ACTIONS(14492), 1,
      sym__immediate_brace,
    STATE(11536), 1,
      sym_identifier,
    STATE(14493), 1,
      sym__delimiter_str_1,
    STATE(14494), 1,
      sym__delimiter_str_3,
    STATE(14497), 1,
      sym__delimiter_cmd_1,
    STATE(14499), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14464), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(14476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(14486), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9721), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14468), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(14474), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11786), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(14484), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(11752), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(14466), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30764] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13398), 1,
      sym__word_identifier,
    ACTIONS(13404), 1,
      anon_sym_DOT_EQ,
    ACTIONS(13406), 1,
      aux_sym_quote_expression_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(13422), 1,
      sym__immediate_paren,
    ACTIONS(13424), 1,
      sym__immediate_bracket,
    ACTIONS(13426), 1,
      sym__immediate_brace,
    STATE(11602), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1833), 2,
      anon_sym_DOLLAR,
      anon_sym_DOT2,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    ACTIONS(13420), 2,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
    STATE(9722), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 3,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13402), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    ACTIONS(13418), 5,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    STATE(10382), 6,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
      sym_operator,
      sym__assignment_operator,
      sym__syntactic_operator,
    ACTIONS(13400), 11,
      anon_sym_COLON2,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [30890] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9723), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10086), 26,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token4,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(10088), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [30962] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9724), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      aux_sym__terminator_token1,
    ACTIONS(10086), 50,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [31031] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9725), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      aux_sym__terminator_token1,
    ACTIONS(10086), 50,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [31100] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9726), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      aux_sym__terminator_token1,
    ACTIONS(10086), 49,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [31168] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9727), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      aux_sym__terminator_token1,
    ACTIONS(10086), 49,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [31236] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9728), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      aux_sym__terminator_token1,
    ACTIONS(10086), 49,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [31304] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9729), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      aux_sym__terminator_token1,
    ACTIONS(10086), 48,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [31371] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9730), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(10086), 47,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [31438] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9731), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10086), 26,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(10088), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [31505] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9732), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
    ACTIONS(10086), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_DOT,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
  [31570] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15116), 1,
      aux_sym_float_literal_token2,
    STATE(9733), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token4,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [31636] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9734), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 35,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [31700] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9735), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token4,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [31763] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9736), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 34,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [31826] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15118), 1,
      anon_sym_do,
    STATE(9804), 1,
      sym_do_clause,
    STATE(9737), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [31893] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15118), 1,
      anon_sym_do,
    STATE(9814), 1,
      sym_do_clause,
    STATE(9738), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9680), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9684), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [31960] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15118), 1,
      anon_sym_do,
    STATE(9779), 1,
      sym_do_clause,
    STATE(9739), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32027] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15118), 1,
      anon_sym_do,
    STATE(9781), 1,
      sym_do_clause,
    STATE(9740), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9696), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9700), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32094] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9741), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token4,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32157] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9742), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 19,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      aux_sym_integer_literal_token4,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 29,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32220] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9743), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9744), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9758), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32282] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9808), 1,
      anon_sym_DASH_GT,
    STATE(9744), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9762), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32346] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9745), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9832), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9834), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32408] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9822), 1,
      anon_sym_DASH_GT,
    STATE(9746), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32472] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15120), 1,
      aux_sym_float_literal_token2,
    STATE(9747), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32536] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9748), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9738), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9806), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32598] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9749), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9824), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9826), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32660] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9750), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9836), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9838), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32722] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9758), 1,
      anon_sym_DASH_GT,
    STATE(9751), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32786] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9752), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9814), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9816), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32848] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9753), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9818), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9820), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32910] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9754), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9726), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9756), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [32972] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9755), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9752), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9808), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33034] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9806), 1,
      anon_sym_DASH_GT,
    STATE(9756), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33098] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9757), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9810), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9812), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33160] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9758), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9790), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9822), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33222] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9808), 1,
      anon_sym_DASH_GT,
    STATE(9759), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33286] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9756), 1,
      anon_sym_DASH_GT,
    STATE(9760), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33350] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9806), 1,
      anon_sym_DASH_GT,
    STATE(9761), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33414] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9762), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9828), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9830), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33476] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9763), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10006), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33537] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9764), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9992), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33598] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9765), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33659] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9766), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(3075), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33720] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9767), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9996), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33781] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9768), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10142), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10144), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33842] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9769), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33903] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9770), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [33964] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9771), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9962), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9964), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34025] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9772), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34086] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9773), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34147] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9774), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9988), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34208] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9775), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10152), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10154), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34269] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9776), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34330] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9777), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10054), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34391] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9778), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34452] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9779), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10106), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10108), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34513] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9780), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9762), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34574] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9781), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10122), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10124), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34635] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9782), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9958), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9960), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34696] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9783), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34757] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9784), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34818] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9785), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10050), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34879] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9786), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10062), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [34940] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9787), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10046), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35001] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9788), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35062] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9789), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10074), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35123] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9790), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10116), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10118), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35184] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9791), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9900), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35245] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9792), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10012), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35306] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9793), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10016), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35367] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9794), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10020), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35428] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9795), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10066), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35489] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9796), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35550] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9797), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10070), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35611] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9798), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9926), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9928), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35672] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9799), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35733] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9800), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10030), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35794] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9801), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10034), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35855] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9802), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10128), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10130), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35916] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9803), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [35977] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9804), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10138), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10140), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36038] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9805), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10078), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36099] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9806), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10082), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36160] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9807), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9978), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9980), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36221] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9808), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9984), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36282] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9809), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9918), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36343] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9810), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36404] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9811), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10038), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36465] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9812), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10042), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36526] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(15122), 1,
      aux_sym_float_literal_token2,
    STATE(9813), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [36589] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9814), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10102), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10104), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36650] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(15124), 1,
      aux_sym_float_literal_token2,
    STATE(9815), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [36713] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9816), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9954), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9956), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36774] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9817), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36835] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9818), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10002), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36896] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9819), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9922), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [36957] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9820), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10058), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37018] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9821), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37078] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(15126), 1,
      aux_sym_float_literal_token2,
    STATE(9822), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37140] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    STATE(9823), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37204] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9805), 1,
      sym_identifier,
    STATE(9824), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37268] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9806), 1,
      sym_identifier,
    STATE(9825), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37332] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(15130), 1,
      aux_sym_float_literal_token2,
    STATE(9826), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37394] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(15132), 1,
      aux_sym_float_literal_token2,
    STATE(9827), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37456] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    STATE(9828), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37516] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 1,
      aux_sym__terminator_token1,
    STATE(9829), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37576] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    STATE(9830), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37636] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 1,
      aux_sym__terminator_token1,
    STATE(9831), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37696] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 1,
      aux_sym__terminator_token1,
    STATE(9832), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37756] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9795), 1,
      sym_identifier,
    STATE(9833), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37820] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 1,
      aux_sym__terminator_token1,
    STATE(9834), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 44,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [37880] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9786), 1,
      sym_identifier,
    STATE(9835), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 18,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [37944] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    STATE(9836), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [38008] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    STATE(9837), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [38072] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    STATE(9838), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38131] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 1,
      aux_sym__terminator_token1,
    STATE(9839), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38190] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15134), 1,
      anon_sym_do,
    STATE(9976), 1,
      sym_do_clause,
    STATE(9840), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9680), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9684), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [38253] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15136), 1,
      anon_sym_do,
    STATE(9913), 1,
      sym_do_clause,
    STATE(9841), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38316] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15138), 1,
      aux_sym_float_literal_token2,
    ACTIONS(9734), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(9842), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 41,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38377] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9843), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 34,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [38436] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15134), 1,
      anon_sym_do,
    STATE(9984), 1,
      sym_do_clause,
    STATE(9844), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [38499] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15136), 1,
      anon_sym_do,
    STATE(9982), 1,
      sym_do_clause,
    STATE(9845), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9700), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9696), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38562] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(15140), 1,
      aux_sym_float_literal_token2,
    STATE(9846), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 42,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38623] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 1,
      aux_sym__terminator_token1,
    STATE(9847), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38682] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9848), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38741] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    STATE(9849), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38800] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 1,
      aux_sym__terminator_token1,
    STATE(9850), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38859] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15134), 1,
      anon_sym_do,
    STATE(9980), 1,
      sym_do_clause,
    STATE(9851), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9696), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9700), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [38922] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15136), 1,
      anon_sym_do,
    STATE(9912), 1,
      sym_do_clause,
    STATE(9852), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9684), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9680), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [38985] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15142), 1,
      aux_sym_float_literal_token2,
    STATE(9853), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 19,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 24,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [39046] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 1,
      aux_sym__terminator_token1,
    STATE(9854), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39105] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 1,
      aux_sym__terminator_token1,
    STATE(9855), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39164] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15136), 1,
      anon_sym_do,
    STATE(10032), 1,
      sym_do_clause,
    STATE(9856), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39227] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 1,
      aux_sym__terminator_token1,
    STATE(9857), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39286] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    STATE(9858), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 43,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39345] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15134), 1,
      anon_sym_do,
    STATE(9977), 1,
      sym_do_clause,
    STATE(9859), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [39408] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9860), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9806), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9738), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39466] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9861), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9808), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9752), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39524] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 1,
      aux_sym__terminator_token1,
    STATE(9862), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 42,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39582] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15144), 1,
      anon_sym_do,
    STATE(10048), 1,
      sym_do_clause,
    STATE(9863), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [39644] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9864), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9818), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9820), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [39702] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9865), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9812), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9810), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39760] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9866), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9826), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9824), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39818] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(9867), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 41,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39876] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9752), 1,
      anon_sym_DASH_GT,
    STATE(9868), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [39936] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9869), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9790), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9822), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [39994] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9870), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9834), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9832), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40052] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9871), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9744), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9758), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [40110] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9872), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9838), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9836), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40168] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9873), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9822), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9790), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40226] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9744), 1,
      anon_sym_DASH_GT,
    STATE(9874), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40286] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9875), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9810), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9812), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [40344] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9876), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9738), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9806), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [40402] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9877), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9814), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9816), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [40460] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(9878), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 41,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40518] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9879), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9816), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9814), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40576] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15146), 1,
      aux_sym_float_literal_token2,
    STATE(9880), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [40636] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9881), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9828), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9830), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [40694] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9882), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9758), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9744), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40752] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9738), 1,
      anon_sym_DASH_GT,
    STATE(9883), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40812] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9738), 1,
      anon_sym_DASH_GT,
    STATE(9884), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [40872] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9885), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9832), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9834), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [40930] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9886), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 19,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 24,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [40988] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9790), 1,
      anon_sym_DASH_GT,
    STATE(9887), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41048] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9752), 1,
      anon_sym_DASH_GT,
    STATE(9888), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41108] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 1,
      aux_sym__terminator_token1,
    STATE(9889), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 42,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41166] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9890), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 19,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 24,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [41224] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9891), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9752), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9808), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [41282] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9726), 1,
      anon_sym_DASH_GT,
    STATE(9892), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41342] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9893), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9756), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9726), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41400] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9894), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9836), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9838), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [41458] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9895), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [41516] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(9896), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 41,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41574] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15144), 1,
      anon_sym_do,
    STATE(10093), 1,
      sym_do_clause,
    STATE(9897), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [41636] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9898), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9824), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9826), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [41694] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9899), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9726), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9756), 33,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [41752] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9900), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9830), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9828), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41810] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15144), 1,
      anon_sym_do,
    STATE(10087), 1,
      sym_do_clause,
    STATE(9901), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9680), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9684), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [41872] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9902), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9820), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9818), 37,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [41930] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9903), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 19,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 24,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [41988] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15144), 1,
      anon_sym_do,
    STATE(10135), 1,
      sym_do_clause,
    STATE(9904), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9696), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9700), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [42050] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    STATE(9905), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 42,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON2,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_AT,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      sym_character_literal,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42108] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15148), 1,
      aux_sym_float_literal_token2,
    STATE(9906), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42168] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9907), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10144), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10142), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42225] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9908), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10050), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10048), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42282] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9909), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10054), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10052), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42339] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9910), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9964), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9962), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42396] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9911), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9918), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9916), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42453] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9912), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10104), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10102), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42510] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9913), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10108), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10106), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42567] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9914), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9814), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9816), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [42624] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9915), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42681] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9916), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10002), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [42738] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9917), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9912), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42795] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9918), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10006), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [42852] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9919), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10074), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10072), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [42909] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9920), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9836), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9838), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [42966] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9921), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9984), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9982), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43023] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9922), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43080] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9923), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10002), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10000), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43137] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9924), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9744), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9758), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [43194] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9925), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43251] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9926), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10058), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10056), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43308] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9927), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9900), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9898), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43365] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9928), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10012), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10010), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43422] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9929), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43479] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9930), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43536] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15150), 1,
      anon_sym_DASH_GT,
    ACTIONS(15152), 1,
      sym__immediate_string_start,
    ACTIONS(15154), 1,
      sym__immediate_command_start,
    STATE(9931), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43599] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9932), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9726), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9756), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [43656] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9933), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9928), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9926), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43713] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9934), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [43770] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9935), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [43827] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9936), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43884] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9937), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [43941] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9938), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10012), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [43998] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9939), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10136), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10134), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [44055] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9940), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10118), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10116), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [44112] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9941), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10016), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44169] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9942), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9978), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9980), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44226] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9943), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9818), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9820), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44283] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9944), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10020), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44340] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9945), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9918), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44397] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9946), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9922), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44454] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9947), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9790), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9822), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44511] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9948), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(3075), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44568] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9949), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44625] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(163), 1,
      anon_sym_DASH_GT,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(191), 1,
      sym__immediate_string_start,
    ACTIONS(193), 1,
      sym__immediate_command_start,
    STATE(9950), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [44688] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9951), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9810), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9812), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44745] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9952), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10078), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10076), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [44802] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9953), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10154), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10152), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [44859] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9954), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9992), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [44916] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9955), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10006), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10004), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [44973] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9956), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10082), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10080), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [45030] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9957), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9996), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45087] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9958), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9824), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9826), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45144] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9959), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10020), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10018), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [45201] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9960), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45258] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9961), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9762), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45315] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9962), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10030), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45372] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9963), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10034), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45429] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9964), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45486] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9965), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10038), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45543] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9966), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10042), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45600] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9967), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [45657] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9968), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9926), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9928), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45714] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9969), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9958), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9960), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45771] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9970), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9954), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9956), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45828] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9971), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9962), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9964), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45885] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9972), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45942] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9973), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [45999] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9974), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [46056] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9975), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(3071), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [46113] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9976), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10102), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10104), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46170] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9977), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10106), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10108), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46227] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9978), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10116), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10118), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46284] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9979), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [46341] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9980), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10122), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10124), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46398] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9981), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46455] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9982), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10124), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10122), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [46512] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9983), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10128), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10130), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46569] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9984), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10138), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10140), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46626] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9985), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10142), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10144), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46683] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9986), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46740] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9987), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10046), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46797] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9988), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10016), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10014), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [46854] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9989), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9956), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9954), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [46911] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9990), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10050), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [46968] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9991), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10054), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47025] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9992), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10058), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47082] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9993), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9900), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47139] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9994), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10130), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10128), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [47196] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9995), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [47253] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9996), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10062), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47310] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9997), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10066), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47367] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(9998), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [47424] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(9999), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10152), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10154), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47481] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10000), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10070), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47538] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10001), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10074), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47595] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10002), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9922), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9920), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [47652] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10003), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10078), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47709] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10004), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10082), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [47766] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10005), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10062), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10060), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [47823] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10006), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9988), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9986), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [47880] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10007), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10066), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10064), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [47937] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(191), 1,
      sym__immediate_string_start,
    ACTIONS(193), 1,
      sym__immediate_command_start,
    ACTIONS(15156), 1,
      anon_sym_DASH_GT,
    STATE(10008), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48000] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10009), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10030), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10028), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48057] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10010), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10034), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10032), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48114] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10011), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10086), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10088), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48171] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10012), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10070), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10068), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48228] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10013), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9992), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9990), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48285] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15158), 1,
      aux_sym_float_literal_token2,
    STATE(10014), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48344] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10015), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10038), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10036), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48401] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10016), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48458] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10017), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48515] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10018), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10042), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10040), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48572] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10019), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48629] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10020), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9828), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9830), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48686] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10021), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48743] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15152), 1,
      sym__immediate_string_start,
    ACTIONS(15154), 1,
      sym__immediate_command_start,
    ACTIONS(15160), 1,
      anon_sym_DASH_GT,
    STATE(10022), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48806] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10023), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9984), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48863] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10024), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [48920] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10025), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9832), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9834), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [48977] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10026), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9988), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49034] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10027), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9960), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9958), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [49091] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10028), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49148] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15162), 1,
      aux_sym_float_literal_token2,
    STATE(10029), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 19,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49207] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10030), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49264] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10031), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9980), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9978), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [49321] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10032), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10140), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10138), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [49378] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10033), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49435] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10034), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9738), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9806), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49492] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10035), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49549] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10036), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10046), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10044), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [49606] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10037), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9996), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9994), 36,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [49663] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10038), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9752), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9808), 32,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49720] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10039), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49776] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15164), 1,
      anon_sym_DASH_GT,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    STATE(10040), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [49838] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10041), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10058), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49894] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10042), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10062), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [49950] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    ACTIONS(15170), 1,
      anon_sym_DASH_GT,
    STATE(10043), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50012] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(191), 1,
      sym__immediate_string_start,
    ACTIONS(193), 1,
      sym__immediate_command_start,
    STATE(10044), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [50072] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9806), 1,
      sym_identifier,
    STATE(10045), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 18,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50132] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15172), 1,
      anon_sym_DASH_GT,
    STATE(10046), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50194] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    ACTIONS(15174), 1,
      anon_sym_DASH_GT,
    STATE(10047), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [50256] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10048), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10106), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10108), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50312] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10049), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9762), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50368] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10050), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(3075), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50424] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10051), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10050), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50480] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10052), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50536] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10053), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50592] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10054), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10034), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50648] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10005), 1,
      sym_identifier,
    STATE(10055), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [50708] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    STATE(10056), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [50768] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9996), 1,
      sym_identifier,
    STATE(10057), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50828] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9997), 1,
      sym_identifier,
    STATE(10058), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [50888] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15180), 1,
      anon_sym_do,
    STATE(10323), 1,
      sym_do_clause,
    STATE(10059), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9684), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9680), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [50948] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(191), 1,
      sym__immediate_string_start,
    ACTIONS(193), 1,
      sym__immediate_command_start,
    STATE(10060), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51008] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15180), 1,
      anon_sym_do,
    STATE(10325), 1,
      sym_do_clause,
    STATE(10061), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51068] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15152), 1,
      sym__immediate_string_start,
    ACTIONS(15154), 1,
      sym__immediate_command_start,
    STATE(10062), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51128] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10003), 1,
      sym_identifier,
    STATE(10063), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51188] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10064), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10082), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51244] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10065), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10116), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10118), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51300] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15182), 1,
      sym__word_identifier,
    STATE(10278), 1,
      sym_identifier,
    STATE(10066), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51360] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15180), 1,
      anon_sym_do,
    STATE(10349), 1,
      sym_do_clause,
    STATE(10067), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9700), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9696), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51420] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10068), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9900), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51476] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10069), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10038), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51532] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10070), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10016), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [51588] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15152), 1,
      sym__immediate_string_start,
    ACTIONS(15154), 1,
      sym__immediate_command_start,
    STATE(10071), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51648] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15180), 1,
      anon_sym_do,
    STATE(10379), 1,
      sym_do_clause,
    STATE(10072), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51708] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15184), 1,
      anon_sym_DASH_GT,
    ACTIONS(15186), 1,
      sym__immediate_string_start,
    ACTIONS(15188), 1,
      sym__immediate_command_start,
    STATE(10073), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51770] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9952), 1,
      sym_identifier,
    STATE(10074), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51830] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15152), 1,
      sym__immediate_string_start,
    ACTIONS(15154), 1,
      sym__immediate_command_start,
    STATE(10075), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [51890] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    STATE(10076), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [51950] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15182), 1,
      sym__word_identifier,
    STATE(10282), 1,
      sym_identifier,
    STATE(10077), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [52010] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15182), 1,
      sym__word_identifier,
    STATE(10333), 1,
      sym_identifier,
    STATE(10078), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [52070] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    STATE(10079), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [52130] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10080), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10002), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52186] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10081), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10006), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52242] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10082), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10128), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10130), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52298] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10083), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9988), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52354] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10084), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10152), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10154), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52410] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9956), 1,
      sym_identifier,
    STATE(10085), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [52470] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    STATE(10086), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [52530] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10087), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10102), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10104), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52586] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15182), 1,
      sym__word_identifier,
    STATE(10308), 1,
      sym_identifier,
    STATE(10088), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [52646] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10089), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9962), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9964), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52702] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10090), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52758] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9786), 1,
      sym_identifier,
    STATE(10091), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 18,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [52818] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10092), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52874] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10093), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10138), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10140), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52930] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10094), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10030), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [52986] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    ACTIONS(15190), 1,
      anon_sym_DASH_GT,
    STATE(10095), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53048] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10096), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53104] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    STATE(10097), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53164] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10098), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9926), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9928), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53220] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10099), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9958), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9960), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53276] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15196), 1,
      anon_sym_DASH_GT,
    ACTIONS(15198), 1,
      sym__immediate_string_start,
    ACTIONS(15200), 1,
      sym__immediate_command_start,
    STATE(10100), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [53338] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15186), 1,
      sym__immediate_string_start,
    ACTIONS(15188), 1,
      sym__immediate_command_start,
    ACTIONS(15202), 1,
      anon_sym_DASH_GT,
    STATE(10101), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [53400] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15204), 1,
      anon_sym_DASH_GT,
    STATE(10102), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53462] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10103), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10078), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53518] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10104), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53574] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10105), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53630] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10106), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53686] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10107), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 19,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53742] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10108), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 19,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [53798] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    STATE(10109), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53858] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10110), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10066), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53914] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10111), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [53970] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10112), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54026] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9795), 1,
      sym_identifier,
    STATE(10113), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 18,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [54086] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10114), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 19,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      sym__word_identifier,
      anon_sym_true,
      anon_sym_false,
      anon_sym_DQUOTE,
      anon_sym_BQUOTE,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 22,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOLLAR,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_AT,
      sym_character_literal,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [54142] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    STATE(10115), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [54204] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10116), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10020), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54260] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    STATE(10117), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54320] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10118), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [54376] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10119), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9918), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54432] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10120), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9922), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54488] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10121), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10074), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54544] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10122), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10086), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10088), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54600] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10123), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10042), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54656] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15198), 1,
      sym__immediate_string_start,
    ACTIONS(15200), 1,
      sym__immediate_command_start,
    ACTIONS(15208), 1,
      anon_sym_DASH_GT,
    STATE(10124), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [54718] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10125), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9984), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54774] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10126), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54830] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10127), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10070), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54886] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10128), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10142), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10144), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54942] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10129), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9978), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9980), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [54998] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10130), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55054] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(191), 1,
      sym__immediate_string_start,
    ACTIONS(193), 1,
      sym__immediate_command_start,
    STATE(10131), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [55114] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10132), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10046), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55170] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15210), 1,
      anon_sym_DASH_GT,
    ACTIONS(15212), 1,
      sym__immediate_string_start,
    ACTIONS(15214), 1,
      sym__immediate_command_start,
    STATE(10133), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [55232] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10134), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10054), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55288] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10135), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10122), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10124), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55344] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10136), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9992), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55400] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10137), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55456] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10138), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9996), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55512] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10139), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10012), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55568] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10140), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9954), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9956), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55624] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15192), 1,
      sym__immediate_string_start,
    ACTIONS(15194), 1,
      sym__immediate_command_start,
    STATE(10141), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 29,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55684] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10142), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 31,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55740] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9805), 1,
      sym_identifier,
    STATE(10143), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 18,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [55800] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15212), 1,
      sym__immediate_string_start,
    ACTIONS(15214), 1,
      sym__immediate_command_start,
    ACTIONS(15216), 1,
      anon_sym_DASH_GT,
    STATE(10144), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [55862] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10004), 1,
      sym_identifier,
    STATE(10145), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [55922] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10146), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9838), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9836), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [55977] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15220), 1,
      aux_sym__terminator_token1,
    ACTIONS(15222), 1,
      aux_sym__terminator_token2,
    STATE(16290), 1,
      aux_sym_let_statement_repeat1,
    STATE(10147), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56046] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15224), 1,
      aux_sym_float_literal_token2,
    STATE(10148), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56103] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15226), 1,
      sym__immediate_string_start,
    ACTIONS(15228), 1,
      sym__immediate_command_start,
    STATE(10149), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [56162] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15230), 1,
      anon_sym_SQUOTE,
    ACTIONS(15232), 1,
      anon_sym_DOT,
    ACTIONS(15234), 1,
      sym__tilde_operator,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    STATE(3367), 1,
      sym__assignment_operator,
    STATE(10150), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56233] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10005), 1,
      sym_identifier,
    STATE(10151), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56292] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9752), 1,
      anon_sym_DASH_GT,
    STATE(10152), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56349] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15242), 1,
      aux_sym__terminator_token1,
    ACTIONS(15244), 1,
      aux_sym__terminator_token2,
    STATE(16226), 1,
      aux_sym_let_statement_repeat1,
    STATE(10153), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56418] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15246), 1,
      aux_sym__terminator_token1,
    ACTIONS(15248), 1,
      aux_sym__terminator_token2,
    STATE(16242), 1,
      aux_sym_let_statement_repeat1,
    STATE(10154), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56487] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    STATE(10155), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56546] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9790), 1,
      anon_sym_DASH_GT,
    STATE(10156), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56603] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15250), 1,
      anon_sym_EQ,
    ACTIONS(15252), 1,
      anon_sym_SQUOTE,
    ACTIONS(15254), 1,
      anon_sym_DOT,
    ACTIONS(15256), 1,
      sym__tilde_operator,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15260), 1,
      sym__immediate_bracket,
    ACTIONS(15262), 1,
      sym__immediate_brace,
    STATE(2906), 1,
      sym__assignment_operator,
    STATE(10157), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56676] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15264), 1,
      aux_sym__terminator_token1,
    ACTIONS(15266), 1,
      aux_sym__terminator_token2,
    STATE(16303), 1,
      aux_sym_let_statement_repeat1,
    STATE(10158), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [56745] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15268), 1,
      anon_sym_EQ,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    STATE(10159), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [56808] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10160), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 30,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [56863] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9744), 1,
      anon_sym_DASH_GT,
    STATE(10161), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56920] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9738), 1,
      anon_sym_DASH_GT,
    STATE(10162), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [56977] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    ACTIONS(15277), 1,
      anon_sym_DASH_GT,
    STATE(10163), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57038] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    ACTIONS(15279), 1,
      anon_sym_DASH_GT,
    STATE(10164), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57099] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15226), 1,
      sym__immediate_string_start,
    ACTIONS(15228), 1,
      sym__immediate_command_start,
    STATE(10165), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [57158] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15281), 1,
      anon_sym_do,
    STATE(10463), 1,
      sym_do_clause,
    STATE(10166), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9684), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9680), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57217] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    STATE(10167), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [57278] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15281), 1,
      anon_sym_do,
    STATE(10467), 1,
      sym_do_clause,
    STATE(10168), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57337] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15252), 1,
      anon_sym_SQUOTE,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15260), 1,
      sym__immediate_bracket,
    ACTIONS(15262), 1,
      sym__immediate_brace,
    ACTIONS(15283), 1,
      anon_sym_DOT,
    ACTIONS(15285), 1,
      sym__tilde_operator,
    STATE(3383), 1,
      sym__assignment_operator,
    STATE(10169), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57408] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9752), 1,
      anon_sym_DASH_GT,
    STATE(10170), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57465] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15252), 1,
      anon_sym_SQUOTE,
    ACTIONS(15254), 1,
      anon_sym_DOT,
    ACTIONS(15256), 1,
      sym__tilde_operator,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15260), 1,
      sym__immediate_bracket,
    ACTIONS(15262), 1,
      sym__immediate_brace,
    ACTIONS(15287), 1,
      anon_sym_EQ,
    STATE(2906), 1,
      sym__assignment_operator,
    STATE(10171), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57538] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15252), 1,
      anon_sym_SQUOTE,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15260), 1,
      sym__immediate_bracket,
    ACTIONS(15262), 1,
      sym__immediate_brace,
    ACTIONS(15283), 1,
      anon_sym_DOT,
    ACTIONS(15285), 1,
      sym__tilde_operator,
    STATE(3383), 1,
      sym__assignment_operator,
    STATE(10172), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57609] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10173), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9756), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9726), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57664] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15226), 1,
      sym__immediate_string_start,
    ACTIONS(15228), 1,
      sym__immediate_command_start,
    STATE(10174), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [57723] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9952), 1,
      sym_identifier,
    STATE(10175), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57782] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9952), 1,
      sym_identifier,
    STATE(10176), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57841] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15289), 1,
      anon_sym_DASH_GT,
    ACTIONS(15291), 1,
      sym__immediate_string_start,
    ACTIONS(15293), 1,
      sym__immediate_command_start,
    STATE(10177), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57902] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10178), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9758), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9744), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [57957] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9726), 1,
      anon_sym_DASH_GT,
    STATE(10179), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58014] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9956), 1,
      sym_identifier,
    STATE(10180), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58073] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9956), 1,
      sym_identifier,
    STATE(10181), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58132] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15295), 1,
      anon_sym_DASH_GT,
    STATE(10182), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [58193] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15186), 1,
      sym__immediate_string_start,
    ACTIONS(15188), 1,
      sym__immediate_command_start,
    STATE(10183), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58252] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15186), 1,
      sym__immediate_string_start,
    ACTIONS(15188), 1,
      sym__immediate_command_start,
    STATE(10184), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58311] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15281), 1,
      anon_sym_do,
    STATE(10527), 1,
      sym_do_clause,
    STATE(10185), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9700), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9696), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58370] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10042), 1,
      sym_identifier,
    STATE(10186), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [58429] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10110), 1,
      sym_identifier,
    STATE(10187), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [58488] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10005), 1,
      sym_identifier,
    STATE(10188), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58547] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    STATE(10189), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58606] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    ACTIONS(15299), 1,
      anon_sym_DASH_GT,
    STATE(10190), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [58667] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15230), 1,
      anon_sym_SQUOTE,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15301), 1,
      anon_sym_EQ,
    ACTIONS(15303), 1,
      anon_sym_DOT,
    ACTIONS(15305), 1,
      sym__tilde_operator,
    STATE(3767), 1,
      sym__assignment_operator,
    STATE(10191), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58740] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15212), 1,
      sym__immediate_string_start,
    ACTIONS(15214), 1,
      sym__immediate_command_start,
    STATE(10192), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [58799] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15307), 1,
      aux_sym__terminator_token1,
    ACTIONS(15309), 1,
      aux_sym__terminator_token2,
    STATE(16274), 1,
      aux_sym_let_statement_repeat1,
    STATE(10193), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [58868] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15311), 1,
      anon_sym_DASH_GT,
    STATE(10194), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [58929] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15313), 1,
      aux_sym__terminator_token1,
    ACTIONS(15315), 1,
      aux_sym__terminator_token2,
    STATE(16315), 1,
      aux_sym_let_statement_repeat1,
    STATE(10195), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [58998] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15317), 1,
      aux_sym__terminator_token1,
    ACTIONS(15319), 1,
      aux_sym__terminator_token2,
    STATE(16056), 1,
      aux_sym_let_statement_repeat1,
    STATE(10196), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [59067] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10005), 1,
      sym_identifier,
    STATE(10197), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59126] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15291), 1,
      sym__immediate_string_start,
    ACTIONS(15293), 1,
      sym__immediate_command_start,
    ACTIONS(15321), 1,
      anon_sym_DASH_GT,
    STATE(10198), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59187] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15226), 1,
      sym__immediate_string_start,
    ACTIONS(15228), 1,
      sym__immediate_command_start,
    STATE(10199), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 28,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [59246] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15323), 1,
      aux_sym__terminator_token1,
    ACTIONS(15325), 1,
      aux_sym__terminator_token2,
    STATE(16261), 1,
      aux_sym_let_statement_repeat1,
    STATE(10200), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [59315] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    ACTIONS(15327), 1,
      anon_sym_EQ,
    STATE(10201), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [59378] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15230), 1,
      anon_sym_SQUOTE,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15303), 1,
      anon_sym_DOT,
    ACTIONS(15305), 1,
      sym__tilde_operator,
    ACTIONS(15330), 1,
      anon_sym_EQ,
    STATE(3767), 1,
      sym__assignment_operator,
    STATE(10202), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59451] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(241), 1,
      sym__immediate_string_start,
    ACTIONS(243), 1,
      sym__immediate_command_start,
    ACTIONS(15332), 1,
      anon_sym_DASH_GT,
    STATE(10203), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59512] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15198), 1,
      sym__immediate_string_start,
    ACTIONS(15200), 1,
      sym__immediate_command_start,
    STATE(10204), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59571] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15212), 1,
      sym__immediate_string_start,
    ACTIONS(15214), 1,
      sym__immediate_command_start,
    STATE(10205), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59630] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15212), 1,
      sym__immediate_string_start,
    ACTIONS(15214), 1,
      sym__immediate_command_start,
    STATE(10206), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59689] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15230), 1,
      anon_sym_SQUOTE,
    ACTIONS(15232), 1,
      anon_sym_DOT,
    ACTIONS(15234), 1,
      sym__tilde_operator,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    STATE(3367), 1,
      sym__assignment_operator,
    STATE(10207), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59760] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15198), 1,
      sym__immediate_string_start,
    ACTIONS(15200), 1,
      sym__immediate_command_start,
    STATE(10208), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59819] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15198), 1,
      sym__immediate_string_start,
    ACTIONS(15200), 1,
      sym__immediate_command_start,
    STATE(10209), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [59878] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15334), 1,
      aux_sym__terminator_token1,
    ACTIONS(15336), 1,
      aux_sym__terminator_token2,
    STATE(16308), 1,
      aux_sym_let_statement_repeat1,
    STATE(10210), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [59947] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15252), 1,
      anon_sym_SQUOTE,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15260), 1,
      sym__immediate_bracket,
    ACTIONS(15262), 1,
      sym__immediate_brace,
    ACTIONS(15283), 1,
      anon_sym_DOT,
    ACTIONS(15285), 1,
      sym__tilde_operator,
    STATE(3383), 1,
      sym__assignment_operator,
    STATE(10211), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60018] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(10212), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [60079] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    STATE(10213), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60138] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10214), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9806), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9738), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60193] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    ACTIONS(15340), 1,
      anon_sym_DASH_GT,
    STATE(10215), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [60254] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15230), 1,
      anon_sym_SQUOTE,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15303), 1,
      anon_sym_DOT,
    ACTIONS(15305), 1,
      sym__tilde_operator,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(3767), 1,
      sym__assignment_operator,
    STATE(10216), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60327] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10217), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9808), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9752), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60382] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10218), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9812), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9810), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60437] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15281), 1,
      anon_sym_do,
    STATE(10396), 1,
      sym_do_clause,
    STATE(10219), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60496] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10220), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9816), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9814), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60551] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10221), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9820), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9818), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60606] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10222), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9822), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9790), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60661] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10223), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9826), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9824), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [60716] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10103), 1,
      sym_identifier,
    STATE(10224), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [60775] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15344), 1,
      anon_sym_DASH_GT,
    STATE(10225), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [60836] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15346), 1,
      aux_sym__terminator_token1,
    ACTIONS(15348), 1,
      aux_sym__terminator_token2,
    STATE(16326), 1,
      aux_sym_let_statement_repeat1,
    STATE(10226), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [60905] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10064), 1,
      sym_identifier,
    STATE(10227), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [60964] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10228), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9830), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9828), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61019] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10229), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9834), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9832), 35,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61074] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10230), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61129] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9956), 1,
      sym_identifier,
    STATE(10231), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61188] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15230), 1,
      anon_sym_SQUOTE,
    ACTIONS(15232), 1,
      anon_sym_DOT,
    ACTIONS(15234), 1,
      sym__tilde_operator,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    STATE(3367), 1,
      sym__assignment_operator,
    STATE(10232), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61259] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15350), 1,
      aux_sym__terminator_token1,
    ACTIONS(15352), 1,
      aux_sym__terminator_token2,
    STATE(16188), 1,
      aux_sym_let_statement_repeat1,
    STATE(10233), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61328] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9738), 1,
      anon_sym_DASH_GT,
    STATE(10234), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61385] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9952), 1,
      sym_identifier,
    STATE(10235), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61444] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15186), 1,
      sym__immediate_string_start,
    ACTIONS(15188), 1,
      sym__immediate_command_start,
    STATE(10236), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61503] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15166), 1,
      sym__immediate_string_start,
    ACTIONS(15168), 1,
      sym__immediate_command_start,
    ACTIONS(15354), 1,
      anon_sym_DASH_GT,
    STATE(10237), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [61564] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(223), 1,
      anon_sym_DASH_GT,
    ACTIONS(241), 1,
      sym__immediate_string_start,
    ACTIONS(243), 1,
      sym__immediate_command_start,
    STATE(10238), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61625] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(15356), 1,
      aux_sym__terminator_token1,
    ACTIONS(15358), 1,
      aux_sym__terminator_token2,
    STATE(16211), 1,
      aux_sym_let_statement_repeat1,
    STATE(10239), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [61694] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15252), 1,
      anon_sym_SQUOTE,
    ACTIONS(15254), 1,
      anon_sym_DOT,
    ACTIONS(15256), 1,
      sym__tilde_operator,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15260), 1,
      sym__immediate_bracket,
    ACTIONS(15262), 1,
      sym__immediate_brace,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(2906), 1,
      sym__assignment_operator,
    STATE(10240), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61767] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(241), 1,
      sym__immediate_string_start,
    ACTIONS(243), 1,
      sym__immediate_command_start,
    STATE(10241), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61825] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10242), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9756), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9726), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61879] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10243), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10142), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61933] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10244), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9988), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9986), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [61987] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10245), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10002), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10000), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62041] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15362), 1,
      anon_sym_SQUOTE,
    ACTIONS(15364), 1,
      anon_sym_DOT,
    ACTIONS(15366), 1,
      sym__tilde_operator,
    STATE(3499), 1,
      sym__assignment_operator,
    STATE(10246), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62111] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15370), 1,
      anon_sym_DOT,
    ACTIONS(15372), 1,
      sym__tilde_operator,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    STATE(3641), 1,
      sym__assignment_operator,
    STATE(10247), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [62183] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15362), 1,
      anon_sym_SQUOTE,
    ACTIONS(15364), 1,
      anon_sym_DOT,
    ACTIONS(15366), 1,
      sym__tilde_operator,
    STATE(3499), 1,
      sym__assignment_operator,
    STATE(10248), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62253] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15380), 1,
      anon_sym_DASH_GT,
    STATE(10249), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [62313] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10250), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9980), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9978), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62367] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15291), 1,
      sym__immediate_string_start,
    ACTIONS(15293), 1,
      sym__immediate_command_start,
    STATE(10251), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62425] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10252), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9918), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9916), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62479] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15384), 1,
      anon_sym_DOT,
    ACTIONS(15386), 1,
      sym__tilde_operator,
    STATE(3628), 1,
      sym__assignment_operator,
    STATE(10253), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [62551] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    ACTIONS(15390), 1,
      anon_sym_DOT,
    ACTIONS(15392), 1,
      sym__tilde_operator,
    STATE(3853), 1,
      sym__assignment_operator,
    STATE(10254), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [62625] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10255), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9922), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9920), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62679] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10256), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10118), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10116), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62733] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15394), 1,
      anon_sym_do,
    STATE(10599), 1,
      sym_do_clause,
    STATE(10257), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9700), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9696), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62791] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15394), 1,
      anon_sym_do,
    STATE(10573), 1,
      sym_do_clause,
    STATE(10258), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9684), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9680), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62849] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10259), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10012), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10010), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62903] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10260), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [62957] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10261), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63011] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9786), 1,
      sym_identifier,
    STATE(10262), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 17,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [63069] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10263), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9992), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9990), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63123] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15396), 1,
      aux_sym_float_literal_token2,
    STATE(10264), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [63179] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10265), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10070), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10068), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63233] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10266), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9996), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9994), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63287] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9795), 1,
      sym_identifier,
    STATE(10267), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 17,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [63345] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15252), 1,
      anon_sym_SQUOTE,
    ACTIONS(15254), 1,
      anon_sym_DOT,
    ACTIONS(15256), 1,
      sym__tilde_operator,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15260), 1,
      sym__immediate_bracket,
    ACTIONS(15262), 1,
      sym__immediate_brace,
    STATE(2906), 1,
      sym__assignment_operator,
    STATE(10268), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63415] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    STATE(10269), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63473] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15400), 1,
      aux_sym__terminator_token1,
    ACTIONS(15398), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    STATE(10270), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 29,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [63537] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10271), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63591] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    ACTIONS(15402), 1,
      anon_sym_DASH_GT,
    STATE(10272), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [63651] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9952), 1,
      sym_identifier,
    STATE(10273), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63709] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15394), 1,
      anon_sym_do,
    STATE(10620), 1,
      sym_do_clause,
    STATE(10274), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63767] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10275), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63821] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10276), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10074), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10072), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [63875] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15404), 1,
      anon_sym_DOT,
    ACTIONS(15406), 1,
      sym__tilde_operator,
    STATE(3635), 1,
      sym__assignment_operator,
    STATE(10277), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [63947] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10278), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10078), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10076), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64001] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10279), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9838), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9836), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64055] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10280), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9960), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9958), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64109] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9956), 1,
      sym_identifier,
    STATE(10281), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64167] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10282), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10082), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10080), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64221] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10283), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64275] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(241), 1,
      sym__immediate_string_start,
    ACTIONS(243), 1,
      sym__immediate_command_start,
    STATE(10284), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64333] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10285), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9928), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9926), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64387] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9956), 1,
      sym_identifier,
    STATE(10286), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64445] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10287), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9954), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64499] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10288), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9964), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9962), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64553] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15362), 1,
      anon_sym_SQUOTE,
    ACTIONS(15408), 1,
      anon_sym_EQ,
    ACTIONS(15410), 1,
      anon_sym_DOT,
    ACTIONS(15412), 1,
      sym__tilde_operator,
    STATE(3055), 1,
      sym__assignment_operator,
    STATE(10289), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64625] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10290), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(3071), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64679] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10291), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64733] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10292), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9806), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9738), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64787] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    ACTIONS(15416), 1,
      anon_sym_DOT,
    ACTIONS(15418), 1,
      sym__tilde_operator,
    STATE(3806), 1,
      sym__assignment_operator,
    STATE(10293), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [64861] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    STATE(10294), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [64919] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15420), 1,
      anon_sym_SQUOTE,
    ACTIONS(15422), 1,
      anon_sym_DOT,
    ACTIONS(15424), 1,
      sym__tilde_operator,
    STATE(3289), 1,
      sym__assignment_operator,
    STATE(10295), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [64989] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10296), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65043] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10297), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65097] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15420), 1,
      anon_sym_SQUOTE,
    ACTIONS(15426), 1,
      anon_sym_EQ,
    ACTIONS(15428), 1,
      anon_sym_DOT,
    ACTIONS(15430), 1,
      sym__tilde_operator,
    STATE(3232), 1,
      sym__assignment_operator,
    STATE(10298), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65169] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    ACTIONS(15402), 1,
      anon_sym_DASH_GT,
    ACTIONS(15432), 1,
      anon_sym_EQ,
    STATE(10299), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [65231] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15434), 1,
      aux_sym_float_literal_token2,
    STATE(10300), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65287] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15291), 1,
      sym__immediate_string_start,
    ACTIONS(15293), 1,
      sym__immediate_command_start,
    STATE(10301), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65345] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15370), 1,
      anon_sym_DOT,
    ACTIONS(15372), 1,
      sym__tilde_operator,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    STATE(3641), 1,
      sym__assignment_operator,
    STATE(10302), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [65417] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10303), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9912), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65471] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    STATE(10304), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [65529] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    ACTIONS(15436), 1,
      anon_sym_DASH_GT,
    STATE(10305), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [65589] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10306), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10028), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65643] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15362), 1,
      anon_sym_SQUOTE,
    ACTIONS(15410), 1,
      anon_sym_DOT,
    ACTIONS(15412), 1,
      sym__tilde_operator,
    ACTIONS(15438), 1,
      anon_sym_EQ,
    STATE(3055), 1,
      sym__assignment_operator,
    STATE(10307), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65715] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10308), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10066), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10064), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65769] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15440), 1,
      anon_sym_SQUOTE,
    ACTIONS(15442), 1,
      anon_sym_DOT,
    ACTIONS(15444), 1,
      sym__tilde_operator,
    STATE(3400), 1,
      sym__assignment_operator,
    STATE(10309), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65839] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15440), 1,
      anon_sym_SQUOTE,
    ACTIONS(15446), 1,
      anon_sym_EQ,
    ACTIONS(15448), 1,
      anon_sym_DOT,
    ACTIONS(15450), 1,
      sym__tilde_operator,
    STATE(2945), 1,
      sym__assignment_operator,
    STATE(10310), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65911] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(241), 1,
      sym__immediate_string_start,
    ACTIONS(243), 1,
      sym__immediate_command_start,
    STATE(10311), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [65969] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10312), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10032), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66023] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10313), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66077] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15404), 1,
      anon_sym_DOT,
    ACTIONS(15406), 1,
      sym__tilde_operator,
    STATE(3635), 1,
      sym__assignment_operator,
    STATE(10314), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [66149] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10315), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9900), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9898), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66203] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    STATE(10316), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [66261] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9806), 1,
      sym_identifier,
    STATE(10317), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 17,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [66319] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10318), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10046), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10044), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66373] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10319), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10016), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10014), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66427] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15362), 1,
      anon_sym_SQUOTE,
    ACTIONS(15410), 1,
      anon_sym_DOT,
    ACTIONS(15412), 1,
      sym__tilde_operator,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(3055), 1,
      sym__assignment_operator,
    STATE(10320), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66499] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10321), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10020), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10018), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66553] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10322), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 8,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66607] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10323), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10104), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10102), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66661] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15420), 1,
      anon_sym_SQUOTE,
    ACTIONS(15428), 1,
      anon_sym_DOT,
    ACTIONS(15430), 1,
      sym__tilde_operator,
    ACTIONS(15454), 1,
      anon_sym_EQ,
    STATE(3232), 1,
      sym__assignment_operator,
    STATE(10324), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66733] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10325), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10108), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10106), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66787] = 12,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15456), 1,
      anon_sym_COMMA,
    ACTIONS(15458), 1,
      aux_sym__terminator_token1,
    ACTIONS(15460), 1,
      aux_sym__terminator_token2,
    STATE(16994), 1,
      aux_sym__do_parameter_list_repeat1,
    STATE(10326), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 28,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [66855] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10327), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9808), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9752), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66909] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10328), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9812), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9810), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [66963] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10329), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67017] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10330), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9816), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9814), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67071] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10331), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67125] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15462), 1,
      anon_sym_DASH_GT,
    STATE(10332), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [67185] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10333), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10062), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10060), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67239] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10005), 1,
      sym_identifier,
    STATE(10334), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67297] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    ACTIONS(15464), 1,
      anon_sym_DASH_GT,
    STATE(10335), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [67357] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10007), 1,
      sym_identifier,
    STATE(10336), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67415] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15384), 1,
      anon_sym_DOT,
    ACTIONS(15386), 1,
      sym__tilde_operator,
    STATE(3628), 1,
      sym__assignment_operator,
    STATE(10337), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [67487] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(9952), 1,
      sym_identifier,
    STATE(10338), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67545] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15404), 1,
      anon_sym_DOT,
    ACTIONS(15406), 1,
      sym__tilde_operator,
    STATE(3635), 1,
      sym__assignment_operator,
    STATE(10339), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [67617] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15390), 1,
      anon_sym_DOT,
    ACTIONS(15392), 1,
      sym__tilde_operator,
    ACTIONS(15466), 1,
      anon_sym_EQ,
    STATE(3853), 1,
      sym__assignment_operator,
    STATE(10340), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [67691] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10341), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10136), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10134), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67745] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15384), 1,
      anon_sym_DOT,
    ACTIONS(15386), 1,
      sym__tilde_operator,
    STATE(3628), 1,
      sym__assignment_operator,
    STATE(10342), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [67817] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15291), 1,
      sym__immediate_string_start,
    ACTIONS(15293), 1,
      sym__immediate_command_start,
    STATE(10343), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [67875] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15468), 1,
      anon_sym_EQ,
    ACTIONS(15470), 1,
      anon_sym_DOT,
    ACTIONS(15472), 1,
      sym__tilde_operator,
    STATE(3805), 1,
      sym__assignment_operator,
    STATE(10344), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [67949] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15420), 1,
      anon_sym_SQUOTE,
    ACTIONS(15422), 1,
      anon_sym_DOT,
    ACTIONS(15424), 1,
      sym__tilde_operator,
    STATE(3289), 1,
      sym__assignment_operator,
    STATE(10345), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68019] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15416), 1,
      anon_sym_DOT,
    ACTIONS(15418), 1,
      sym__tilde_operator,
    ACTIONS(15474), 1,
      anon_sym_EQ,
    STATE(3806), 1,
      sym__assignment_operator,
    STATE(10346), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [68093] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10347), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10058), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10056), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68147] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10348), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10054), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10052), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68201] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10349), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10124), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10122), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68255] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10350), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10040), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68309] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10351), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68363] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15420), 1,
      anon_sym_SQUOTE,
    ACTIONS(15428), 1,
      anon_sym_DOT,
    ACTIONS(15430), 1,
      sym__tilde_operator,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(3232), 1,
      sym__assignment_operator,
    STATE(10352), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68435] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15440), 1,
      anon_sym_SQUOTE,
    ACTIONS(15442), 1,
      anon_sym_DOT,
    ACTIONS(15444), 1,
      sym__tilde_operator,
    STATE(3400), 1,
      sym__assignment_operator,
    STATE(10353), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68505] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10354), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68559] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9805), 1,
      sym_identifier,
    STATE(10355), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 17,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [68617] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10356), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10154), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10152), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68671] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15394), 1,
      anon_sym_do,
    STATE(10575), 1,
      sym_do_clause,
    STATE(10357), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68729] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15273), 1,
      sym__immediate_string_start,
    ACTIONS(15275), 1,
      sym__immediate_command_start,
    ACTIONS(15478), 1,
      anon_sym_DASH_GT,
    STATE(10358), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [68789] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15480), 1,
      anon_sym_SQUOTE,
    ACTIONS(15482), 1,
      anon_sym_DOT,
    ACTIONS(15484), 1,
      sym__immediate_paren,
    ACTIONS(15486), 1,
      sym__immediate_bracket,
    ACTIONS(15488), 1,
      sym__immediate_brace,
    STATE(10359), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10328), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [68853] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15176), 1,
      sym__word_identifier,
    STATE(10005), 1,
      sym_identifier,
    STATE(10360), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68911] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10361), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9820), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9818), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [68965] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10362), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9822), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9790), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69019] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15440), 1,
      anon_sym_SQUOTE,
    ACTIONS(15442), 1,
      anon_sym_DOT,
    ACTIONS(15444), 1,
      sym__tilde_operator,
    STATE(3400), 1,
      sym__assignment_operator,
    STATE(10363), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69089] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10364), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9984), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9982), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69143] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10365), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10006), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10004), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69197] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10366), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69251] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10367), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9826), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9824), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69305] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15230), 1,
      anon_sym_SQUOTE,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15303), 1,
      anon_sym_DOT,
    ACTIONS(15305), 1,
      sym__tilde_operator,
    STATE(3767), 1,
      sym__assignment_operator,
    STATE(10368), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69375] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15362), 1,
      anon_sym_SQUOTE,
    ACTIONS(15364), 1,
      anon_sym_DOT,
    ACTIONS(15366), 1,
      sym__tilde_operator,
    STATE(3499), 1,
      sym__assignment_operator,
    STATE(10369), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69445] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15470), 1,
      anon_sym_DOT,
    ACTIONS(15472), 1,
      sym__tilde_operator,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(3805), 1,
      sym__assignment_operator,
    STATE(10370), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [69519] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15370), 1,
      anon_sym_DOT,
    ACTIONS(15372), 1,
      sym__tilde_operator,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    STATE(3641), 1,
      sym__assignment_operator,
    STATE(10371), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [69591] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15420), 1,
      anon_sym_SQUOTE,
    ACTIONS(15422), 1,
      anon_sym_DOT,
    ACTIONS(15424), 1,
      sym__tilde_operator,
    STATE(3289), 1,
      sym__assignment_operator,
    STATE(10372), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69661] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10373), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10036), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69715] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10374), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10130), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10128), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69769] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15440), 1,
      anon_sym_SQUOTE,
    ACTIONS(15448), 1,
      anon_sym_DOT,
    ACTIONS(15450), 1,
      sym__tilde_operator,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(2945), 1,
      sym__assignment_operator,
    STATE(10375), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69841] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10376), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9830), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9828), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69895] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10377), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9834), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9832), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [69949] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15440), 1,
      anon_sym_SQUOTE,
    ACTIONS(15448), 1,
      anon_sym_DOT,
    ACTIONS(15450), 1,
      sym__tilde_operator,
    ACTIONS(15494), 1,
      anon_sym_EQ,
    STATE(2945), 1,
      sym__assignment_operator,
    STATE(10378), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70021] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10379), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10138), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70075] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10380), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10048), 34,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70129] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10381), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9758), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9744), 33,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70183] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10382), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [70236] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15362), 1,
      anon_sym_SQUOTE,
    ACTIONS(15410), 1,
      anon_sym_DOT,
    ACTIONS(15412), 1,
      sym__tilde_operator,
    STATE(3055), 1,
      sym__assignment_operator,
    STATE(10383), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70305] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10384), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10038), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10036), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70358] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10385), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10042), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10040), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70411] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10386), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9996), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9994), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70464] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10387), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [70537] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10388), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10050), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10048), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70590] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15502), 1,
      anon_sym_SQUOTE,
    ACTIONS(15504), 1,
      anon_sym_DOT,
    ACTIONS(15506), 1,
      sym__tilde_operator,
    STATE(3248), 1,
      sym__assignment_operator,
    STATE(10389), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70659] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15508), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15512), 1,
      anon_sym_DOT,
    ACTIONS(15514), 1,
      sym__tilde_operator,
    STATE(3482), 1,
      sym__assignment_operator,
    STATE(10390), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [70732] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10391), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10054), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10052), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70785] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10392), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9988), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9986), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70838] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10393), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10058), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10056), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70891] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10394), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9980), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9978), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70944] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10395), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10130), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10128), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [70997] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10396), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10140), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10138), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71050] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10397), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71103] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10398), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71156] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10399), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71209] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10400), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10144), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10142), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71262] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10401), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9900), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9898), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71315] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15512), 1,
      anon_sym_DOT,
    ACTIONS(15514), 1,
      sym__tilde_operator,
    ACTIONS(15516), 1,
      anon_sym_EQ,
    STATE(3482), 1,
      sym__assignment_operator,
    STATE(10402), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [71388] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10403), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9960), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9958), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71441] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15416), 1,
      anon_sym_DOT,
    ACTIONS(15518), 1,
      anon_sym_EQ,
    ACTIONS(15520), 1,
      sym__tilde_operator,
    STATE(3181), 1,
      sym__assignment_operator,
    STATE(10404), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [71514] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15470), 1,
      anon_sym_DOT,
    ACTIONS(15472), 1,
      sym__tilde_operator,
    STATE(3805), 1,
      sym__assignment_operator,
    STATE(10405), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [71585] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15416), 1,
      anon_sym_DOT,
    ACTIONS(15418), 1,
      sym__tilde_operator,
    STATE(3806), 1,
      sym__assignment_operator,
    STATE(10406), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [71656] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15522), 1,
      anon_sym_EQ,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15526), 1,
      anon_sym_DOT,
    ACTIONS(15528), 1,
      sym__tilde_operator,
    STATE(3207), 1,
      sym__assignment_operator,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10407), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71727] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15502), 1,
      anon_sym_SQUOTE,
    ACTIONS(15504), 1,
      anon_sym_DOT,
    ACTIONS(15506), 1,
      sym__tilde_operator,
    STATE(3248), 1,
      sym__assignment_operator,
    STATE(10408), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71796] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10409), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [71849] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10410), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [71902] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10411), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9984), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9982), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [71955] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10412), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [72008] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10413), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9758), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9744), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72061] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10414), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9928), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9926), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72114] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10415), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72167] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15530), 1,
      anon_sym_DOT,
    ACTIONS(15532), 1,
      sym__tilde_operator,
    STATE(3312), 1,
      sym__assignment_operator,
    STATE(10416), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [72238] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10417), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10062), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [72291] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10418), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10002), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10000), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72344] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15534), 1,
      anon_sym_DOT,
    ACTIONS(15536), 1,
      sym__tilde_operator,
    STATE(3205), 1,
      sym__assignment_operator,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10419), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72413] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15538), 1,
      anon_sym_DASH_GT,
    STATE(10420), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [72472] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10421), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [72525] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10422), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10116), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10118), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [72578] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10423), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10006), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10004), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72631] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15390), 1,
      anon_sym_DOT,
    ACTIONS(15540), 1,
      anon_sym_EQ,
    ACTIONS(15542), 1,
      sym__tilde_operator,
    STATE(2909), 1,
      sym__assignment_operator,
    STATE(10424), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [72704] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15534), 1,
      anon_sym_DOT,
    ACTIONS(15536), 1,
      sym__tilde_operator,
    STATE(3205), 1,
      sym__assignment_operator,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10425), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72773] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15526), 1,
      anon_sym_DOT,
    ACTIONS(15528), 1,
      sym__tilde_operator,
    ACTIONS(15544), 1,
      anon_sym_EQ,
    STATE(3207), 1,
      sym__assignment_operator,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10426), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72844] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10427), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9762), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [72897] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10428), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9956), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9954), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [72950] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10429), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9826), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9824), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73003] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15546), 1,
      anon_sym_DASH_GT,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    STATE(10430), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [73062] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10431), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9964), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9962), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73115] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10432), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73168] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10433), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73221] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10434), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73274] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15534), 1,
      anon_sym_DOT,
    ACTIONS(15536), 1,
      sym__tilde_operator,
    STATE(3205), 1,
      sym__assignment_operator,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10435), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73343] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15440), 1,
      anon_sym_SQUOTE,
    ACTIONS(15448), 1,
      anon_sym_DOT,
    ACTIONS(15450), 1,
      sym__tilde_operator,
    STATE(2945), 1,
      sym__assignment_operator,
    STATE(10436), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73412] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15502), 1,
      anon_sym_SQUOTE,
    ACTIONS(15504), 1,
      anon_sym_DOT,
    ACTIONS(15506), 1,
      sym__tilde_operator,
    STATE(3248), 1,
      sym__assignment_operator,
    STATE(10437), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73481] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10438), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73534] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10439), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10012), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [73587] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10440), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9816), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9814), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73640] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10441), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9988), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [73693] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10442), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10062), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10060), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73746] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15470), 1,
      anon_sym_DOT,
    ACTIONS(15552), 1,
      anon_sym_EQ,
    ACTIONS(15554), 1,
      sym__tilde_operator,
    STATE(3164), 1,
      sym__assignment_operator,
    STATE(10443), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [73819] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10444), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9806), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9738), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73872] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15526), 1,
      anon_sym_DOT,
    ACTIONS(15528), 1,
      sym__tilde_operator,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    STATE(3207), 1,
      sym__assignment_operator,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10445), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [73943] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15530), 1,
      anon_sym_DOT,
    ACTIONS(15532), 1,
      sym__tilde_operator,
    STATE(3312), 1,
      sym__assignment_operator,
    STATE(10446), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [74014] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10447), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10066), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74067] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10448), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10030), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74120] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10449), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10034), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74173] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10450), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [74226] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10451), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10066), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10064), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [74279] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10452), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10136), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10134), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [74332] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10453), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10038), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74385] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10454), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10042), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74438] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10455), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10016), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [74491] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15384), 1,
      anon_sym_DOT,
    ACTIONS(15558), 1,
      sym__tilde_operator,
    STATE(3906), 1,
      sym__assignment_operator,
    STATE(10456), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [74562] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15404), 1,
      anon_sym_DOT,
    ACTIONS(15560), 1,
      sym__tilde_operator,
    STATE(3912), 1,
      sym__assignment_operator,
    STATE(10457), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [74633] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15562), 1,
      anon_sym_DOT,
    ACTIONS(15564), 1,
      sym__tilde_operator,
    STATE(3808), 1,
      sym__assignment_operator,
    STATE(10458), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [74704] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15390), 1,
      anon_sym_DOT,
    ACTIONS(15392), 1,
      sym__tilde_operator,
    STATE(3853), 1,
      sym__assignment_operator,
    STATE(10459), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [74775] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15370), 1,
      anon_sym_DOT,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15566), 1,
      sym__tilde_operator,
    STATE(3913), 1,
      sym__assignment_operator,
    STATE(10460), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [74846] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15370), 1,
      anon_sym_DOT,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15566), 1,
      sym__tilde_operator,
    STATE(3913), 1,
      sym__assignment_operator,
    STATE(10461), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [74917] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10462), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10086), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [74970] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10463), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10104), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10102), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75023] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10464), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9756), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9726), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75076] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10465), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9820), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9818), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75129] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10466), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9812), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9810), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75182] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10467), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10108), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10106), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75235] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10468), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10020), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75288] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15512), 1,
      anon_sym_DOT,
    ACTIONS(15514), 1,
      sym__tilde_operator,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(3482), 1,
      sym__assignment_operator,
    STATE(10469), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [75361] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10470), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75414] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10471), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10070), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75467] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10472), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10074), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75520] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10473), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9918), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75573] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15502), 1,
      anon_sym_SQUOTE,
    ACTIONS(15570), 1,
      anon_sym_EQ,
    ACTIONS(15572), 1,
      anon_sym_DOT,
    ACTIONS(15574), 1,
      sym__tilde_operator,
    STATE(3128), 1,
      sym__assignment_operator,
    STATE(10474), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75644] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15576), 1,
      aux_sym_float_literal_token2,
    STATE(10475), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75699] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10476), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9912), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75752] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10477), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9958), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9960), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75805] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10478), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10078), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [75858] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10479), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75911] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15420), 1,
      anon_sym_SQUOTE,
    ACTIONS(15428), 1,
      anon_sym_DOT,
    ACTIONS(15430), 1,
      sym__tilde_operator,
    STATE(3232), 1,
      sym__assignment_operator,
    STATE(10480), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [75980] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10481), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10070), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10068), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76033] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10482), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9922), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76086] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10483), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10082), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76139] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10484), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10074), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10072), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76192] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10485), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9992), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76245] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10486), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10012), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10010), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76298] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10487), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10016), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10014), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76351] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10488), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9830), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9828), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76404] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10489), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76457] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10490), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76510] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15580), 1,
      anon_sym_DOT,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    STATE(10491), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10539), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76573] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10492), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9838), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9836), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76626] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10493), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76679] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10494), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10046), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76732] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10495), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10577), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10579), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76785] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10496), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9834), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9832), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76838] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10497), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9984), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [76891] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10498), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9822), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9790), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [76944] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15502), 1,
      anon_sym_SQUOTE,
    ACTIONS(15572), 1,
      anon_sym_DOT,
    ACTIONS(15574), 1,
      sym__tilde_operator,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(3128), 1,
      sym__assignment_operator,
    STATE(10499), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [77015] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10500), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9996), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77068] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10501), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10078), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10076), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [77121] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15590), 1,
      anon_sym_DASH_GT,
    STATE(10502), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 13,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [77180] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10503), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10082), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10080), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [77233] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15562), 1,
      anon_sym_DOT,
    ACTIONS(15564), 1,
      sym__tilde_operator,
    STATE(3808), 1,
      sym__assignment_operator,
    STATE(10504), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [77304] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15592), 1,
      anon_sym_EQ,
    STATE(10505), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [77365] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    ACTIONS(15594), 1,
      anon_sym_DASH_GT,
    STATE(10506), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [77424] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15562), 1,
      anon_sym_DOT,
    ACTIONS(15564), 1,
      sym__tilde_operator,
    STATE(3808), 1,
      sym__assignment_operator,
    STATE(10507), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [77495] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10508), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10006), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77548] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15580), 1,
      anon_sym_DOT,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    STATE(10509), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10525), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77611] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10510), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10050), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77664] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10511), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10154), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10152), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [77717] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10512), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10054), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [77770] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10513), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9808), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9752), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [77823] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15384), 1,
      anon_sym_DOT,
    ACTIONS(15558), 1,
      sym__tilde_operator,
    STATE(3906), 1,
      sym__assignment_operator,
    STATE(10514), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [77894] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15404), 1,
      anon_sym_DOT,
    ACTIONS(15560), 1,
      sym__tilde_operator,
    STATE(3912), 1,
      sym__assignment_operator,
    STATE(10515), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [77965] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10516), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78018] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10517), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78071] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10518), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78124] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10519), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10002), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [78177] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10520), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10030), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10028), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78230] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10521), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9992), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9990), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78283] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10522), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10118), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10116), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78336] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10523), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10034), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10032), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78389] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10524), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10020), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10018), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78442] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10525), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9918), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9916), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78495] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10526), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9922), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9920), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78548] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10527), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10124), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10122), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78601] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10528), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(3071), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78654] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10529), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78707] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15502), 1,
      anon_sym_SQUOTE,
    ACTIONS(15572), 1,
      anon_sym_DOT,
    ACTIONS(15574), 1,
      sym__tilde_operator,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    STATE(3128), 1,
      sym__assignment_operator,
    STATE(10530), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78778] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15600), 1,
      aux_sym__terminator_token1,
    ACTIONS(15598), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    STATE(10531), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 28,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [78841] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10532), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10046), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10044), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [78894] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15602), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10533), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [78967] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15530), 1,
      anon_sym_DOT,
    ACTIONS(15532), 1,
      sym__tilde_operator,
    STATE(3312), 1,
      sym__assignment_operator,
    STATE(10534), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [79038] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10535), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10058), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79091] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10536), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9926), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9928), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79144] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10537), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9900), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79197] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10538), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [79250] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10539), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(3075), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79303] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15512), 1,
      anon_sym_DOT,
    ACTIONS(15514), 1,
      sym__tilde_operator,
    ACTIONS(15604), 1,
      anon_sym_EQ,
    STATE(3482), 1,
      sym__assignment_operator,
    STATE(10540), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [79376] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10541), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79429] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15396), 1,
      aux_sym_float_literal_token2,
    STATE(10542), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79484] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10543), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10152), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10154), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79537] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15606), 1,
      anon_sym_EQ,
    ACTIONS(15608), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(10544), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [79599] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15470), 1,
      anon_sym_DOT,
    ACTIONS(15554), 1,
      sym__tilde_operator,
    STATE(3164), 1,
      sym__assignment_operator,
    STATE(10545), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [79669] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9795), 1,
      sym_identifier,
    STATE(10546), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 17,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [79725] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10547), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10062), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10060), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [79777] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10548), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10070), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10068), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [79829] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15610), 1,
      sym__immediate_string_start,
    ACTIONS(15612), 1,
      sym__immediate_command_start,
    STATE(10549), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [79885] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    STATE(10550), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [79941] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    STATE(10551), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [79997] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15382), 1,
      anon_sym_SQUOTE,
    ACTIONS(15416), 1,
      anon_sym_DOT,
    ACTIONS(15520), 1,
      sym__tilde_operator,
    STATE(3181), 1,
      sym__assignment_operator,
    STATE(10552), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [80067] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10553), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80119] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10554), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80171] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    STATE(10555), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [80227] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10556), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10038), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10036), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80279] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15614), 1,
      sym__immediate_string_start,
    ACTIONS(15616), 1,
      sym__immediate_command_start,
    STATE(10557), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80335] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15618), 1,
      anon_sym_EQ,
    ACTIONS(15620), 1,
      anon_sym_DOT,
    ACTIONS(15622), 1,
      sym__tilde_operator,
    STATE(3076), 1,
      sym__assignment_operator,
    STATE(10558), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [80407] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10559), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10066), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10064), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80459] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15624), 1,
      anon_sym_DOT,
    ACTIONS(15626), 1,
      sym__tilde_operator,
    STATE(3551), 1,
      sym__assignment_operator,
    STATE(10560), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [80529] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10561), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9992), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9990), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80581] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9806), 1,
      sym_identifier,
    STATE(10562), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 17,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [80637] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10563), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(3071), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80689] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10564), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9996), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9994), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80741] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10565), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9988), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9986), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80793] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10566), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [80863] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10567), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(3075), 28,
      sym__immediate_paren,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [80915] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10568), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10058), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10056), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [80967] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9786), 1,
      sym_identifier,
    STATE(10569), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 17,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [81023] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(10570), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [81077] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15508), 1,
      anon_sym_EQ,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15512), 1,
      anon_sym_DOT,
    ACTIONS(15628), 1,
      sym__tilde_operator,
    STATE(3798), 1,
      sym__assignment_operator,
    STATE(10571), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [81149] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15630), 1,
      anon_sym_EQ,
    ACTIONS(15632), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(10572), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [81211] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10573), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10104), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10102), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81263] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10574), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9900), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9898), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81315] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10575), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10108), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10106), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81367] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10576), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10078), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10076), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81419] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10577), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10012), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10010), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81471] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10578), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81523] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10579), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10042), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10040), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81575] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10580), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10763), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [81627] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10581), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9922), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9920), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81679] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10582), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81731] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10583), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81783] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(10584), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [81837] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10585), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10136), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10134), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81889] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10442), 1,
      sym_identifier,
    STATE(10586), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81945] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10587), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [81997] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15636), 1,
      anon_sym_EQ,
    STATE(10588), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [82057] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10451), 1,
      sym_identifier,
    STATE(10589), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82113] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15638), 1,
      sym__immediate_string_start,
    ACTIONS(15640), 1,
      sym__immediate_command_start,
    STATE(10590), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82169] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10501), 1,
      sym_identifier,
    STATE(10591), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82225] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10592), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10154), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10152), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82277] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15642), 1,
      sym__immediate_string_start,
    ACTIONS(15644), 1,
      sym__immediate_command_start,
    STATE(10593), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82333] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15646), 1,
      sym__word_identifier,
    STATE(11144), 1,
      sym_identifier,
    STATE(10594), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82389] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10595), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82441] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10596), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9960), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9958), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82493] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(10597), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82547] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15646), 1,
      sym__word_identifier,
    STATE(11145), 1,
      sym_identifier,
    STATE(10598), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82603] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10599), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10124), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10122), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82655] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15624), 1,
      anon_sym_DOT,
    ACTIONS(15626), 1,
      sym__tilde_operator,
    STATE(3551), 1,
      sym__assignment_operator,
    STATE(10600), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [82725] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15128), 1,
      sym__word_identifier,
    STATE(9805), 1,
      sym_identifier,
    STATE(10601), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 17,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [82781] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10602), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10759), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [82833] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15526), 1,
      anon_sym_DOT,
    ACTIONS(15528), 1,
      sym__tilde_operator,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    STATE(3207), 1,
      sym__assignment_operator,
    STATE(10603), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82903] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15646), 1,
      sym__word_identifier,
    STATE(11149), 1,
      sym_identifier,
    STATE(10604), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [82959] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10605), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10020), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10018), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83011] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15614), 1,
      sym__immediate_string_start,
    ACTIONS(15616), 1,
      sym__immediate_command_start,
    STATE(10606), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83067] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15638), 1,
      sym__immediate_string_start,
    ACTIONS(15640), 1,
      sym__immediate_command_start,
    STATE(10607), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83123] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10503), 1,
      sym_identifier,
    STATE(10608), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83179] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15638), 1,
      sym__immediate_string_start,
    ACTIONS(15640), 1,
      sym__immediate_command_start,
    STATE(10609), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83235] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15650), 1,
      anon_sym_DOT,
    ACTIONS(15652), 1,
      sym__tilde_operator,
    STATE(3598), 1,
      sym__assignment_operator,
    STATE(10610), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [83305] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10611), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83357] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15642), 1,
      sym__immediate_string_start,
    ACTIONS(15644), 1,
      sym__immediate_command_start,
    STATE(10612), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [83413] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15642), 1,
      sym__immediate_string_start,
    ACTIONS(15644), 1,
      sym__immediate_command_start,
    STATE(10613), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [83469] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10614), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10144), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10142), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83521] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10415), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15654), 1,
      sym__tilde_operator,
    STATE(2973), 1,
      sym__assignment_operator,
    STATE(10615), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(10421), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 13,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [83595] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DOT,
    ACTIONS(15622), 1,
      sym__tilde_operator,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(3076), 1,
      sym__assignment_operator,
    STATE(10616), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [83667] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10617), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10016), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10014), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83719] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15638), 1,
      sym__immediate_string_start,
    ACTIONS(15640), 1,
      sym__immediate_command_start,
    STATE(10618), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83775] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15642), 1,
      sym__immediate_string_start,
    ACTIONS(15644), 1,
      sym__immediate_command_start,
    STATE(10619), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 27,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [83831] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10620), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10140), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10138), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83883] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10621), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10050), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10048), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [83935] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15650), 1,
      anon_sym_DOT,
    ACTIONS(15652), 1,
      sym__tilde_operator,
    STATE(3598), 1,
      sym__assignment_operator,
    STATE(10622), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [84005] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15658), 1,
      anon_sym_EQ,
    ACTIONS(15660), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(10623), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [84067] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15662), 1,
      anon_sym_EQ,
    ACTIONS(15664), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(10624), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [84129] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10625), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84181] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10626), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10030), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10028), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84233] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10627), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10118), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10116), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84285] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15646), 1,
      sym__word_identifier,
    STATE(11150), 1,
      sym_identifier,
    STATE(10628), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84341] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10629), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9980), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9978), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84393] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15530), 1,
      anon_sym_DOT,
    ACTIONS(15666), 1,
      sym__tilde_operator,
    STATE(3843), 1,
      sym__assignment_operator,
    STATE(10630), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [84463] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15668), 1,
      anon_sym_do,
    STATE(10860), 1,
      sym_do_clause,
    STATE(10631), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9684), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9680), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84519] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15614), 1,
      sym__immediate_string_start,
    ACTIONS(15616), 1,
      sym__immediate_command_start,
    STATE(10632), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84575] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15524), 1,
      anon_sym_SQUOTE,
    ACTIONS(15526), 1,
      anon_sym_DOT,
    ACTIONS(15528), 1,
      sym__tilde_operator,
    STATE(3207), 1,
      sym__assignment_operator,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10633), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84643] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15668), 1,
      anon_sym_do,
    STATE(10861), 1,
      sym_do_clause,
    STATE(10634), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84699] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9996), 1,
      sym_identifier,
    STATE(10635), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [84755] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15610), 1,
      sym__immediate_string_start,
    ACTIONS(15612), 1,
      sym__immediate_command_start,
    STATE(10636), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [84811] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(10637), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 15,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [84867] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15672), 1,
      anon_sym_EQ,
    ACTIONS(15674), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(10638), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [84929] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10639), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [84981] = 13,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15238), 1,
      sym__immediate_bracket,
    ACTIONS(15240), 1,
      sym__immediate_brace,
    ACTIONS(15502), 1,
      anon_sym_SQUOTE,
    ACTIONS(15572), 1,
      anon_sym_DOT,
    ACTIONS(15574), 1,
      sym__tilde_operator,
    STATE(3128), 1,
      sym__assignment_operator,
    STATE(10640), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9768), 4,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [85049] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15624), 1,
      anon_sym_DOT,
    ACTIONS(15626), 1,
      sym__tilde_operator,
    STATE(3551), 1,
      sym__assignment_operator,
    STATE(10641), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [85119] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10642), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9956), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9954), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [85171] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15668), 1,
      anon_sym_do,
    STATE(10862), 1,
      sym_do_clause,
    STATE(10643), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9700), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9696), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [85227] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(10644), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 15,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [85283] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15390), 1,
      anon_sym_DOT,
    ACTIONS(15542), 1,
      sym__tilde_operator,
    STATE(2909), 1,
      sym__assignment_operator,
    STATE(10645), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [85353] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(10646), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 15,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [85409] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9997), 1,
      sym_identifier,
    STATE(10647), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [85465] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15650), 1,
      anon_sym_DOT,
    ACTIONS(15652), 1,
      sym__tilde_operator,
    STATE(3598), 1,
      sym__assignment_operator,
    STATE(10648), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [85535] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10003), 1,
      sym_identifier,
    STATE(10649), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [85591] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10004), 1,
      sym_identifier,
    STATE(10650), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 21,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [85647] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15530), 1,
      anon_sym_DOT,
    ACTIONS(15666), 1,
      sym__tilde_operator,
    STATE(3843), 1,
      sym__assignment_operator,
    STATE(10651), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [85717] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10652), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [85769] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15676), 1,
      anon_sym_EQ,
    ACTIONS(15678), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(10653), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [85831] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15668), 1,
      anon_sym_do,
    STATE(10865), 1,
      sym_do_clause,
    STATE(10654), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [85887] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10655), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10082), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10080), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [85939] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10656), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9964), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9962), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [85991] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10657), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10002), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10000), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86043] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10658), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86095] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10659), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9914), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9912), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86147] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10660), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9928), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9926), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86199] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15614), 1,
      sym__immediate_string_start,
    ACTIONS(15616), 1,
      sym__immediate_command_start,
    STATE(10661), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86255] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    ACTIONS(15680), 1,
      anon_sym_DASH_GT,
    STATE(10662), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [86313] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10663), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10054), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10052), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86365] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10664), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10908), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10910), 28,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [86417] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    ACTIONS(15684), 1,
      anon_sym_DOT,
    ACTIONS(15686), 1,
      sym__tilde_operator,
    STATE(3146), 1,
      sym__assignment_operator,
    STATE(10665), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [86489] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15512), 1,
      anon_sym_DOT,
    ACTIONS(15514), 1,
      sym__tilde_operator,
    STATE(3482), 1,
      sym__assignment_operator,
    STATE(10666), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [86559] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10667), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86611] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10668), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10074), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10072), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86663] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10669), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10034), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10032), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86715] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10670), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86767] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10671), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10006), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10004), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86819] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10672), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [86871] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15516), 1,
      anon_sym_EQ,
    ACTIONS(15684), 1,
      anon_sym_DOT,
    ACTIONS(15686), 1,
      sym__tilde_operator,
    STATE(3146), 1,
      sym__assignment_operator,
    STATE(10673), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [86943] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10674), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [86995] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10675), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9918), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9916), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87047] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10218), 1,
      sym__immediate_string_start,
    ACTIONS(10220), 1,
      sym__immediate_command_start,
    ACTIONS(15688), 1,
      anon_sym_DASH_GT,
    STATE(10676), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [87105] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10677), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10086), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87157] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    ACTIONS(15690), 1,
      anon_sym_DASH_GT,
    STATE(10678), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [87215] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10679), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9984), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9982), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87267] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10680), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10130), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10128), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87319] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10681), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10046), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10044), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87371] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10682), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87423] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(10683), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 15,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87479] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15692), 1,
      sym__immediate_string_start,
    ACTIONS(15694), 1,
      sym__immediate_command_start,
    STATE(10684), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87534] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15696), 1,
      sym__immediate_string_start,
    ACTIONS(15698), 1,
      sym__immediate_command_start,
    STATE(10685), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87589] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10042), 1,
      sym_identifier,
    STATE(10686), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87644] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10687), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11456), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11458), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87695] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15700), 1,
      sym__immediate_string_start,
    ACTIONS(15702), 1,
      sym__immediate_command_start,
    STATE(10688), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87750] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10689), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11291), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11293), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [87801] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15706), 1,
      anon_sym_DOT,
    ACTIONS(15708), 1,
      sym__tilde_operator,
    STATE(3516), 1,
      sym__assignment_operator,
    STATE(10690), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [87870] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15710), 1,
      sym__word_identifier,
    STATE(11326), 1,
      sym_identifier,
    STATE(10691), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [87925] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10442), 1,
      sym_identifier,
    STATE(10692), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [87980] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10693), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 4,
      sym__immediate_string_start,
      sym__immediate_command_start,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(9642), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88031] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10694), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9822), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9790), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88082] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15712), 1,
      sym__immediate_string_start,
    ACTIONS(15714), 1,
      sym__immediate_command_start,
    STATE(10695), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88137] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10110), 1,
      sym_identifier,
    STATE(10696), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88192] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10697), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9816), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9814), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88243] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10655), 1,
      sym_identifier,
    STATE(10698), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88298] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10699), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11530), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11532), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88349] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10103), 1,
      sym_identifier,
    STATE(10700), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88404] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15706), 1,
      anon_sym_DOT,
    ACTIONS(15708), 1,
      sym__tilde_operator,
    STATE(3516), 1,
      sym__assignment_operator,
    STATE(10701), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [88473] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10702), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11534), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11536), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88524] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    ACTIONS(15720), 1,
      anon_sym_DOT,
    ACTIONS(15722), 1,
      sym__tilde_operator,
    STATE(3712), 1,
      sym__assignment_operator,
    STATE(10703), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [88595] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DOT,
    ACTIONS(15622), 1,
      sym__tilde_operator,
    STATE(3076), 1,
      sym__assignment_operator,
    STATE(10704), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [88664] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10705), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11407), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11409), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88715] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15724), 1,
      anon_sym_do,
    STATE(11356), 1,
      sym_do_clause,
    STATE(10706), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9684), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9680), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88770] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10707), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9806), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9738), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88821] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10503), 1,
      sym_identifier,
    STATE(10708), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88876] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10709), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11513), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11515), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [88927] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15726), 1,
      sym__immediate_string_start,
    ACTIONS(15728), 1,
      sym__immediate_command_start,
    STATE(10710), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [88982] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15724), 1,
      anon_sym_do,
    STATE(11358), 1,
      sym_do_clause,
    STATE(10711), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [89037] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10712), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11548), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11550), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89088] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15692), 1,
      sym__immediate_string_start,
    ACTIONS(15694), 1,
      sym__immediate_command_start,
    STATE(10713), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [89143] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10714), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9826), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9824), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [89194] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10715), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11552), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11554), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89245] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10716), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9820), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9818), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [89296] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10717), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11385), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11387), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89347] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15692), 1,
      sym__immediate_string_start,
    ACTIONS(15694), 1,
      sym__immediate_command_start,
    STATE(10718), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [89402] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10719), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11399), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11401), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89453] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10720), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89504] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15692), 1,
      sym__immediate_string_start,
    ACTIONS(15694), 1,
      sym__immediate_command_start,
    STATE(10721), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [89559] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15730), 1,
      anon_sym_DOT,
    ACTIONS(15732), 1,
      sym__tilde_operator,
    STATE(3799), 1,
      sym__assignment_operator,
    STATE(10722), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [89628] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(10723), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89683] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10724), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10850), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10855), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89734] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10064), 1,
      sym_identifier,
    STATE(10725), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89789] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10442), 1,
      sym_identifier,
    STATE(10726), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [89844] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(10727), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89899] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10728), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11279), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11281), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [89950] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10729), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [90001] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10501), 1,
      sym_identifier,
    STATE(10730), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90056] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15696), 1,
      sym__immediate_string_start,
    ACTIONS(15698), 1,
      sym__immediate_command_start,
    STATE(10731), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90111] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10732), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90162] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10733), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11335), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11337), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90213] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15712), 1,
      sym__immediate_string_start,
    ACTIONS(15714), 1,
      sym__immediate_command_start,
    STATE(10734), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90268] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10735), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11403), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11405), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90319] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10736), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90370] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10737), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11269), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11271), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90421] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15734), 1,
      sym__immediate_string_start,
    ACTIONS(15736), 1,
      sym__immediate_command_start,
    STATE(10738), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90476] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10739), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11339), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11341), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90527] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10740), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9838), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9836), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90578] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10741), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 7,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90629] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15734), 1,
      sym__immediate_string_start,
    ACTIONS(15736), 1,
      sym__immediate_command_start,
    STATE(10742), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90684] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(10743), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90739] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15734), 1,
      sym__immediate_string_start,
    ACTIONS(15736), 1,
      sym__immediate_command_start,
    STATE(10744), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90794] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15696), 1,
      sym__immediate_string_start,
    ACTIONS(15698), 1,
      sym__immediate_command_start,
    STATE(10745), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90849] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10451), 1,
      sym_identifier,
    STATE(10746), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [90904] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15700), 1,
      sym__immediate_string_start,
    ACTIONS(15702), 1,
      sym__immediate_command_start,
    STATE(10747), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [90959] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15734), 1,
      sym__immediate_string_start,
    ACTIONS(15736), 1,
      sym__immediate_command_start,
    STATE(10748), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91014] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10749), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11317), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11319), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91065] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10750), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9756), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9726), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91116] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10751), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11381), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11383), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91167] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15738), 1,
      anon_sym_EQ,
    ACTIONS(15740), 1,
      anon_sym_DOT,
    ACTIONS(15742), 1,
      sym__tilde_operator,
    STATE(3803), 1,
      sym__assignment_operator,
    STATE(10752), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [91238] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15726), 1,
      sym__immediate_string_start,
    ACTIONS(15728), 1,
      sym__immediate_command_start,
    STATE(10753), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91293] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15700), 1,
      sym__immediate_string_start,
    ACTIONS(15702), 1,
      sym__immediate_command_start,
    STATE(10754), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91348] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10755), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10978), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10982), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91399] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15456), 1,
      anon_sym_COMMA,
    ACTIONS(15458), 1,
      aux_sym__terminator_token1,
    ACTIONS(15460), 1,
      aux_sym__terminator_token2,
    STATE(16994), 1,
      aux_sym__do_parameter_list_repeat1,
    STATE(10756), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 28,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [91458] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15684), 1,
      anon_sym_DOT,
    ACTIONS(15686), 1,
      sym__tilde_operator,
    STATE(3146), 1,
      sym__assignment_operator,
    STATE(10757), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [91527] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15726), 1,
      sym__immediate_string_start,
    ACTIONS(15728), 1,
      sym__immediate_command_start,
    STATE(10758), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91582] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15548), 1,
      sym__immediate_string_start,
    ACTIONS(15550), 1,
      sym__immediate_command_start,
    STATE(10759), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [91639] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10760), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11343), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11345), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91690] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10761), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11283), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11285), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [91741] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10501), 1,
      sym_identifier,
    STATE(10762), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91796] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10503), 1,
      sym_identifier,
    STATE(10763), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91851] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10451), 1,
      sym_identifier,
    STATE(10764), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91906] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15696), 1,
      sym__immediate_string_start,
    ACTIONS(15698), 1,
      sym__immediate_command_start,
    STATE(10765), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [91961] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15726), 1,
      sym__immediate_string_start,
    ACTIONS(15728), 1,
      sym__immediate_command_start,
    STATE(10766), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [92016] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10767), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9758), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9744), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [92067] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10768), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92118] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15712), 1,
      sym__immediate_string_start,
    ACTIONS(15714), 1,
      sym__immediate_command_start,
    STATE(10769), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [92173] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15730), 1,
      anon_sym_DOT,
    ACTIONS(15732), 1,
      sym__tilde_operator,
    STATE(3799), 1,
      sym__assignment_operator,
    STATE(10770), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [92242] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10771), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92293] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15744), 1,
      sym__word_identifier,
    STATE(11250), 1,
      sym_identifier,
    STATE(10772), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [92348] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10773), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11517), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11519), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92399] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15746), 1,
      sym__immediate_string_start,
    ACTIONS(15748), 1,
      sym__immediate_command_start,
    STATE(10774), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92454] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10775), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11472), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11474), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92505] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15700), 1,
      sym__immediate_string_start,
    ACTIONS(15702), 1,
      sym__immediate_command_start,
    STATE(10776), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 26,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92560] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10777), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11499), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11501), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92611] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10576), 1,
      sym_identifier,
    STATE(10778), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [92666] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10779), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11305), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11307), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92717] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15724), 1,
      anon_sym_do,
    STATE(11368), 1,
      sym_do_clause,
    STATE(10780), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9700), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9696), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [92772] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10781), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11526), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11528), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92823] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10442), 1,
      sym_identifier,
    STATE(10782), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [92878] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10783), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11924), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11926), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92929] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10784), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11169), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [92980] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10785), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11255), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11257), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93031] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10786), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11941), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11943), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93082] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15740), 1,
      anon_sym_DOT,
    ACTIONS(15742), 1,
      sym__tilde_operator,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(3803), 1,
      sym__assignment_operator,
    STATE(10787), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [93153] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15710), 1,
      sym__word_identifier,
    STATE(11313), 1,
      sym_identifier,
    STATE(10788), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [93208] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10789), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11347), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11349), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93259] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10790), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11965), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11967), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93310] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10791), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11969), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11971), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93361] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10792), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12048), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12050), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93412] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10793), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12052), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(12054), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93463] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10559), 1,
      sym_identifier,
    STATE(10794), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [93518] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10795), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11033), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11035), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93569] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10796), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11039), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11041), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93620] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(10797), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON2,
      anon_sym_isa,
      anon_sym_where,
      aux_sym_integer_literal_token4,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93675] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10798), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93726] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10799), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11351), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11353), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93777] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10501), 1,
      sym_identifier,
    STATE(10800), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [93832] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10801), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11411), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11413), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93883] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10802), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11043), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11045), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [93934] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15706), 1,
      anon_sym_DOT,
    ACTIONS(15708), 1,
      sym__tilde_operator,
    STATE(3516), 1,
      sym__assignment_operator,
    STATE(10803), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [94003] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10804), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11116), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11118), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94054] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10547), 1,
      sym_identifier,
    STATE(10805), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [94109] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10806), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11571), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11573), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94160] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10807), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11120), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11122), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94211] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15510), 1,
      anon_sym_SQUOTE,
    ACTIONS(15512), 1,
      anon_sym_DOT,
    ACTIONS(15628), 1,
      sym__tilde_operator,
    STATE(3798), 1,
      sym__assignment_operator,
    STATE(10808), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [94280] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10809), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11197), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11199), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94331] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10810), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9830), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9828), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [94382] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10811), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11211), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11213), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94433] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15752), 1,
      aux_sym_float_literal_token2,
    STATE(10812), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [94486] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10813), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11309), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11311), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94537] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10814), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9834), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9832), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [94588] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10815), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11559), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11561), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94639] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10816), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11259), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11261), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94690] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10817), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94741] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10818), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11563), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11565), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94792] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15744), 1,
      sym__word_identifier,
    STATE(11244), 1,
      sym_identifier,
    STATE(10819), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [94847] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10820), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11355), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11357), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [94898] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10821), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9808), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9752), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [94949] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15746), 1,
      sym__immediate_string_start,
    ACTIONS(15748), 1,
      sym__immediate_command_start,
    STATE(10822), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95004] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10823), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11373), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11375), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95055] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10824), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95106] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15720), 1,
      anon_sym_DOT,
    ACTIONS(15722), 1,
      sym__tilde_operator,
    ACTIONS(15754), 1,
      anon_sym_EQ,
    STATE(3712), 1,
      sym__assignment_operator,
    STATE(10825), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [95177] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10826), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11567), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11569), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95228] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10827), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11377), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11379), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95279] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15710), 1,
      sym__word_identifier,
    STATE(11332), 1,
      sym_identifier,
    STATE(10828), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [95334] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15712), 1,
      sym__immediate_string_start,
    ACTIONS(15714), 1,
      sym__immediate_command_start,
    STATE(10829), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [95389] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15724), 1,
      anon_sym_do,
    STATE(11312), 1,
      sym_do_clause,
    STATE(10830), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [95444] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15730), 1,
      anon_sym_DOT,
    ACTIONS(15732), 1,
      sym__tilde_operator,
    STATE(3799), 1,
      sym__assignment_operator,
    STATE(10831), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 11,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [95513] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10832), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11898), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11900), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95564] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10833), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11289), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95615] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10834), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11249), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95666] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10503), 1,
      sym_identifier,
    STATE(10835), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [95721] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10836), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11223), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11225), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95772] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10837), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11359), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11361), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95823] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10838), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11331), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11333), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [95874] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15720), 1,
      anon_sym_DOT,
    ACTIONS(15722), 1,
      sym__tilde_operator,
    ACTIONS(15756), 1,
      anon_sym_EQ,
    STATE(3712), 1,
      sym__assignment_operator,
    STATE(10839), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [95945] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(9960), 1,
      anon_sym_RPAREN,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(15760), 1,
      anon_sym_LPAREN,
    STATE(10316), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10840), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9783), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [96036] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10841), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11251), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11253), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [96087] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15744), 1,
      sym__word_identifier,
    STATE(11247), 1,
      sym_identifier,
    STATE(10842), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96142] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15762), 1,
      sym__immediate_string_start,
    ACTIONS(15764), 1,
      sym__immediate_command_start,
    STATE(10843), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [96197] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10451), 1,
      sym_identifier,
    STATE(10844), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96252] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(10845), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11173), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11175), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [96303] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10846), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9812), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9810), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96354] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15710), 1,
      sym__word_identifier,
    STATE(11309), 1,
      sym_identifier,
    STATE(10847), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 16,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [96409] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15744), 1,
      sym__word_identifier,
    STATE(11251), 1,
      sym_identifier,
    STATE(10848), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96464] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(15768), 1,
      anon_sym_LPAREN,
    STATE(10241), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10849), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9930), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [96552] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10559), 1,
      sym_identifier,
    STATE(10850), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96606] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10851), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9980), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9978), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96656] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10852), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96706] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10576), 1,
      sym_identifier,
    STATE(10853), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96760] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10098), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10854), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [96830] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10855), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9954), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96880] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10856), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9964), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9962), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96930] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10857), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [96980] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10858), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97030] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15770), 1,
      sym__word_identifier,
    STATE(11287), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10859), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10682), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [97118] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10860), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10104), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10102), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97168] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10861), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10108), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10106), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97218] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10862), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10124), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10122), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97268] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10863), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97318] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10864), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10130), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10128), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97368] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10865), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10138), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97418] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10866), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10142), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97468] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10867), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [97538] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15774), 1,
      aux_sym_float_literal_token2,
    STATE(10868), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97590] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(10822), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10869), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [97678] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10870), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9806), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9738), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97728] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10871), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9808), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9752), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97778] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10872), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9812), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9810), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97828] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10873), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9816), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9814), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97878] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10874), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9820), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9818), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97928] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10875), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9822), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9790), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [97978] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10876), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9826), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9824), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [98028] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10222), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10877), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98098] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10878), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9830), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9828), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [98148] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15786), 1,
      sym__word_identifier,
    STATE(10174), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10879), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10111), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [98236] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10880), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9834), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9832), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [98286] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10881), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [98336] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10882), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9838), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9836), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [98386] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(15788), 1,
      sym__word_identifier,
    ACTIONS(15790), 1,
      anon_sym_LPAREN,
    ACTIONS(15792), 1,
      anon_sym_LBRACK,
    ACTIONS(15794), 1,
      anon_sym_LBRACE,
    ACTIONS(15798), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15800), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15804), 1,
      sym_character_literal,
    STATE(9412), 1,
      sym_identifier,
    STATE(14779), 1,
      sym__delimiter_str_1,
    STATE(14780), 1,
      sym__delimiter_str_3,
    STATE(14781), 1,
      sym__delimiter_cmd_1,
    STATE(14782), 1,
      sym__delimiter_cmd_3,
    ACTIONS(15796), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10883), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15802), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9452), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9462), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9445), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [98474] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(869), 1,
      anon_sym_LBRACK,
    ACTIONS(871), 1,
      anon_sym_LBRACE,
    ACTIONS(891), 1,
      sym_character_literal,
    ACTIONS(9478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15806), 1,
      sym__word_identifier,
    ACTIONS(15808), 1,
      anon_sym_LPAREN,
    STATE(4158), 1,
      sym_identifier,
    STATE(14318), 1,
      sym__delimiter_cmd_1,
    STATE(14504), 1,
      sym__delimiter_cmd_3,
    STATE(14701), 1,
      sym__delimiter_str_1,
    STATE(14899), 1,
      sym__delimiter_str_3,
    ACTIONS(9476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10884), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4666), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4665), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4788), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [98562] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(11263), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10885), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98632] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(403), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(405), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13528), 1,
      sym_character_literal,
    ACTIONS(15810), 1,
      sym__word_identifier,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(6415), 1,
      sym_identifier,
    STATE(14769), 1,
      sym__delimiter_str_1,
    STATE(14770), 1,
      sym__delimiter_str_3,
    STATE(14776), 1,
      sym__delimiter_cmd_1,
    STATE(14788), 1,
      sym__delimiter_cmd_3,
    ACTIONS(6874), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10886), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6876), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6773), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6771), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7037), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [98720] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10887), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98790] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14434), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14440), 1,
      sym_character_literal,
    ACTIONS(15820), 1,
      sym__word_identifier,
    ACTIONS(15822), 1,
      anon_sym_LPAREN,
    ACTIONS(15824), 1,
      anon_sym_LBRACK,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    ACTIONS(15828), 1,
      aux_sym_integer_literal_token4,
    STATE(5949), 1,
      sym_identifier,
    STATE(14821), 1,
      sym__delimiter_str_1,
    STATE(14824), 1,
      sym__delimiter_str_3,
    STATE(14825), 1,
      sym__delimiter_cmd_1,
    STATE(14826), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14432), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10888), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14438), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6619), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6576), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6461), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [98878] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10889), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [98948] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13572), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13574), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13578), 1,
      sym_character_literal,
    ACTIONS(15022), 1,
      anon_sym_LPAREN,
    ACTIONS(15024), 1,
      anon_sym_LBRACK,
    ACTIONS(15026), 1,
      anon_sym_LBRACE,
    ACTIONS(15832), 1,
      sym__word_identifier,
    STATE(4975), 1,
      sym_identifier,
    STATE(14988), 1,
      sym__delimiter_str_1,
    STATE(14989), 1,
      sym__delimiter_str_3,
    STATE(14999), 1,
      sym__delimiter_cmd_1,
    STATE(15012), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13570), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10890), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13576), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5576), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5575), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5629), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [99036] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9840), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10891), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99106] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4492), 1,
      anon_sym_LBRACK,
    ACTIONS(4494), 1,
      anon_sym_LBRACE,
    ACTIONS(4506), 1,
      sym_character_literal,
    ACTIONS(12882), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12884), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15834), 1,
      sym__word_identifier,
    ACTIONS(15836), 1,
      anon_sym_LPAREN,
    STATE(10131), 1,
      sym_identifier,
    STATE(14632), 1,
      sym__delimiter_str_1,
    STATE(14633), 1,
      sym__delimiter_str_3,
    STATE(14641), 1,
      sym__delimiter_cmd_1,
    STATE(14642), 1,
      sym__delimiter_cmd_3,
    ACTIONS(15038), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10892), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15040), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10244), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10364), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10366), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [99194] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10893), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99264] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(7368), 1,
      anon_sym_LBRACK,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    ACTIONS(7380), 1,
      sym_character_literal,
    ACTIONS(9526), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9528), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15840), 1,
      sym__word_identifier,
    ACTIONS(15842), 1,
      anon_sym_LPAREN,
    STATE(4141), 1,
      sym_identifier,
    STATE(14818), 1,
      sym__delimiter_str_1,
    STATE(14828), 1,
      sym__delimiter_str_3,
    STATE(14844), 1,
      sym__delimiter_cmd_1,
    STATE(14846), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13932), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10894), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13934), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4791), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4741), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4787), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [99352] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9966), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10895), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99422] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(983), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(985), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15092), 1,
      sym_character_literal,
    ACTIONS(15844), 1,
      sym__word_identifier,
    ACTIONS(15846), 1,
      anon_sym_LPAREN,
    ACTIONS(15848), 1,
      anon_sym_LBRACK,
    ACTIONS(15850), 1,
      anon_sym_LBRACE,
    STATE(7190), 1,
      sym_identifier,
    STATE(14575), 1,
      sym__delimiter_str_1,
    STATE(14578), 1,
      sym__delimiter_str_3,
    STATE(14582), 1,
      sym__delimiter_cmd_1,
    STATE(14583), 1,
      sym__delimiter_cmd_3,
    ACTIONS(6896), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10896), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6898), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8383), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(8382), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7982), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [99510] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12175), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10897), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99580] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13444), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13450), 1,
      sym_character_literal,
    ACTIONS(15852), 1,
      sym__word_identifier,
    ACTIONS(15854), 1,
      anon_sym_LPAREN,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    ACTIONS(15858), 1,
      anon_sym_LBRACE,
    ACTIONS(15860), 1,
      aux_sym_integer_literal_token4,
    STATE(6658), 1,
      sym_identifier,
    STATE(14687), 1,
      sym__delimiter_str_1,
    STATE(14688), 1,
      sym__delimiter_str_3,
    STATE(14689), 1,
      sym__delimiter_cmd_1,
    STATE(14690), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13442), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10898), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13448), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7274), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7271), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7896), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [99668] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10899), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99738] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13498), 1,
      anon_sym_LPAREN,
    ACTIONS(13500), 1,
      anon_sym_LBRACK,
    ACTIONS(13502), 1,
      anon_sym_LBRACE,
    ACTIONS(13510), 1,
      sym_character_literal,
    ACTIONS(15004), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15006), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15862), 1,
      sym__word_identifier,
    STATE(5658), 1,
      sym_identifier,
    STATE(14382), 1,
      sym__delimiter_str_1,
    STATE(14383), 1,
      sym__delimiter_str_3,
    STATE(14385), 1,
      sym__delimiter_cmd_1,
    STATE(14386), 1,
      sym__delimiter_cmd_3,
    ACTIONS(15002), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10900), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15008), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6410), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6409), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6354), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [99826] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12630), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10901), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [99896] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(3603), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15864), 1,
      aux_sym_integer_literal_token4,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    STATE(17156), 1,
      sym_identifier,
    ACTIONS(3601), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10902), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3607), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [99984] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10903), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100054] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(689), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(691), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13916), 1,
      sym_character_literal,
    ACTIONS(15866), 1,
      sym__word_identifier,
    ACTIONS(15868), 1,
      anon_sym_LPAREN,
    ACTIONS(15870), 1,
      anon_sym_LBRACK,
    ACTIONS(15872), 1,
      anon_sym_LBRACE,
    STATE(6644), 1,
      sym_identifier,
    STATE(14757), 1,
      sym__delimiter_str_1,
    STATE(14758), 1,
      sym__delimiter_str_3,
    STATE(14760), 1,
      sym__delimiter_cmd_1,
    STATE(14768), 1,
      sym__delimiter_cmd_3,
    ACTIONS(4948), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10904), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4950), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7347), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7344), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7863), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [100142] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10547), 1,
      sym_identifier,
    STATE(10905), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100196] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10906), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100266] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10559), 1,
      sym_identifier,
    STATE(10907), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100320] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10442), 1,
      sym_identifier,
    STATE(10908), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100374] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10451), 1,
      sym_identifier,
    STATE(10909), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100428] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13764), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13770), 1,
      sym_character_literal,
    ACTIONS(15874), 1,
      sym__word_identifier,
    ACTIONS(15876), 1,
      anon_sym_LPAREN,
    ACTIONS(15878), 1,
      anon_sym_LBRACK,
    ACTIONS(15880), 1,
      anon_sym_LBRACE,
    ACTIONS(15882), 1,
      aux_sym_integer_literal_token4,
    STATE(6404), 1,
      sym_identifier,
    STATE(14829), 1,
      sym__delimiter_str_1,
    STATE(14830), 1,
      sym__delimiter_str_3,
    STATE(14831), 1,
      sym__delimiter_cmd_1,
    STATE(14832), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13762), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10910), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13768), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6992), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6989), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6777), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [100516] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15884), 1,
      aux_sym_float_literal_token2,
    STATE(10911), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [100568] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10576), 1,
      sym_identifier,
    STATE(10912), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100622] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10655), 1,
      sym_identifier,
    STATE(10913), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100676] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(9854), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10914), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [100746] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10501), 1,
      sym_identifier,
    STATE(10915), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100800] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10503), 1,
      sym_identifier,
    STATE(10916), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [100854] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13858), 1,
      anon_sym_LPAREN,
    ACTIONS(13860), 1,
      anon_sym_LBRACK,
    ACTIONS(13862), 1,
      anon_sym_LBRACE,
    ACTIONS(13870), 1,
      sym_character_literal,
    ACTIONS(14822), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14824), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15886), 1,
      sym__word_identifier,
    STATE(5235), 1,
      sym_identifier,
    STATE(14607), 1,
      sym__delimiter_str_1,
    STATE(14609), 1,
      sym__delimiter_str_3,
    STATE(14610), 1,
      sym__delimiter_cmd_1,
    STATE(14611), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14820), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10917), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14826), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5960), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5958), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6122), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [100942] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(11221), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10918), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [101012] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(15888), 1,
      sym__word_identifier,
    STATE(11030), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10919), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10399), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [101100] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15890), 1,
      sym__immediate_string_start,
    ACTIONS(15892), 1,
      sym__immediate_command_start,
    STATE(10920), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [101154] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12213), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10921), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [101224] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15894), 1,
      sym__word_identifier,
    STATE(10117), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10922), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10021), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [101312] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(10923), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10086), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [101362] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10924), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [101432] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(885), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(887), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14636), 1,
      sym_character_literal,
    ACTIONS(15898), 1,
      sym__word_identifier,
    ACTIONS(15900), 1,
      anon_sym_LPAREN,
    ACTIONS(15902), 1,
      anon_sym_LBRACK,
    ACTIONS(15904), 1,
      anon_sym_LBRACE,
    STATE(6604), 1,
      sym_identifier,
    STATE(15003), 1,
      sym__delimiter_str_1,
    STATE(15004), 1,
      sym__delimiter_str_3,
    STATE(15009), 1,
      sym__delimiter_cmd_1,
    STATE(15011), 1,
      sym__delimiter_cmd_3,
    ACTIONS(883), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10925), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(889), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7570), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7567), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7685), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [101520] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10112), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10926), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [101590] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14550), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14556), 1,
      sym_character_literal,
    ACTIONS(15906), 1,
      sym__word_identifier,
    ACTIONS(15908), 1,
      anon_sym_LPAREN,
    ACTIONS(15910), 1,
      anon_sym_LBRACK,
    ACTIONS(15912), 1,
      anon_sym_LBRACE,
    ACTIONS(15914), 1,
      aux_sym_integer_literal_token4,
    STATE(6447), 1,
      sym_identifier,
    STATE(15049), 1,
      sym__delimiter_str_1,
    STATE(15051), 1,
      sym__delimiter_str_3,
    STATE(15053), 1,
      sym__delimiter_cmd_1,
    STATE(15055), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14548), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10927), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14554), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7097), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7095), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6902), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [101678] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10328), 1,
      aux_sym__terminator_token1,
    ACTIONS(15916), 1,
      anon_sym_SQUOTE,
    ACTIONS(15918), 1,
      anon_sym_DOT,
    ACTIONS(15920), 1,
      sym__immediate_paren,
    ACTIONS(15922), 1,
      sym__immediate_bracket,
    ACTIONS(15924), 1,
      sym__immediate_brace,
    STATE(10928), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [101738] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10547), 1,
      sym_identifier,
    STATE(10929), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [101792] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10930), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [101862] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10559), 1,
      sym_identifier,
    STATE(10931), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [101916] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13196), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13198), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13202), 1,
      sym_character_literal,
    ACTIONS(14372), 1,
      anon_sym_LPAREN,
    ACTIONS(14374), 1,
      anon_sym_LBRACK,
    ACTIONS(14376), 1,
      anon_sym_LBRACE,
    ACTIONS(15926), 1,
      sym__word_identifier,
    STATE(5110), 1,
      sym_identifier,
    STATE(15069), 1,
      sym__delimiter_str_1,
    STATE(15071), 1,
      sym__delimiter_str_3,
    STATE(15072), 1,
      sym__delimiter_cmd_1,
    STATE(15073), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13194), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10932), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13200), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6039), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6037), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6186), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [102004] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15890), 1,
      sym__immediate_string_start,
    ACTIONS(15892), 1,
      sym__immediate_command_start,
    STATE(10933), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [102058] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12425), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10934), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [102128] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10935), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [102198] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10576), 1,
      sym_identifier,
    STATE(10936), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [102252] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10655), 1,
      sym_identifier,
    STATE(10937), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [102306] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13542), 1,
      anon_sym_LPAREN,
    ACTIONS(13544), 1,
      anon_sym_LBRACK,
    ACTIONS(13546), 1,
      anon_sym_LBRACE,
    ACTIONS(13554), 1,
      sym_character_literal,
    ACTIONS(14288), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14290), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15928), 1,
      sym__word_identifier,
    STATE(5125), 1,
      sym_identifier,
    STATE(14816), 1,
      sym__delimiter_str_1,
    STATE(14819), 1,
      sym__delimiter_str_3,
    STATE(14983), 1,
      sym__delimiter_cmd_1,
    STATE(15076), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14286), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10938), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14292), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6077), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6075), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6194), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [102394] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15600), 1,
      aux_sym__terminator_token1,
    ACTIONS(15598), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    STATE(10939), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
    ACTIONS(101), 28,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_DOT_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [102448] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10940), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [102518] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14122), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14124), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14128), 1,
      sym_character_literal,
    ACTIONS(14522), 1,
      anon_sym_LPAREN,
    ACTIONS(14524), 1,
      anon_sym_LBRACK,
    ACTIONS(14526), 1,
      anon_sym_LBRACE,
    ACTIONS(15930), 1,
      sym__word_identifier,
    STATE(4667), 1,
      sym_identifier,
    STATE(14959), 1,
      sym__delimiter_str_1,
    STATE(14976), 1,
      sym__delimiter_str_3,
    STATE(14979), 1,
      sym__delimiter_cmd_1,
    STATE(15037), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14120), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10941), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14126), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5351), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5349), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5341), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [102606] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12215), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10942), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [102676] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14156), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14162), 1,
      sym_character_literal,
    ACTIONS(15932), 1,
      sym__word_identifier,
    ACTIONS(15934), 1,
      anon_sym_LPAREN,
    ACTIONS(15936), 1,
      anon_sym_LBRACK,
    ACTIONS(15938), 1,
      anon_sym_LBRACE,
    ACTIONS(15940), 1,
      aux_sym_integer_literal_token4,
    STATE(11481), 1,
      sym_identifier,
    STATE(14817), 1,
      sym__delimiter_str_1,
    STATE(14906), 1,
      sym__delimiter_str_3,
    STATE(14951), 1,
      sym__delimiter_cmd_1,
    STATE(14954), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14154), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10943), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14160), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11620), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11699), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [102764] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10944), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [102834] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10945), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [102904] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13294), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13296), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13300), 1,
      sym_character_literal,
    ACTIONS(14568), 1,
      anon_sym_LPAREN,
    ACTIONS(14570), 1,
      anon_sym_LBRACK,
    ACTIONS(14572), 1,
      anon_sym_LBRACE,
    ACTIONS(15944), 1,
      sym__word_identifier,
    STATE(10758), 1,
      sym_identifier,
    STATE(14484), 1,
      sym__delimiter_str_1,
    STATE(14542), 1,
      sym__delimiter_str_3,
    STATE(14549), 1,
      sym__delimiter_cmd_1,
    STATE(14550), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13292), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10946), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13298), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11198), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11191), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11263), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [102992] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10208), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10947), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103062] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10948), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103132] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10110), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10949), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103202] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(7746), 1,
      anon_sym_LBRACK,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    ACTIONS(7758), 1,
      sym_character_literal,
    ACTIONS(9428), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9430), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15948), 1,
      sym__word_identifier,
    ACTIONS(15950), 1,
      anon_sym_LPAREN,
    STATE(4131), 1,
      sym_identifier,
    STATE(14791), 1,
      sym__delimiter_str_1,
    STATE(14793), 1,
      sym__delimiter_str_3,
    STATE(14798), 1,
      sym__delimiter_cmd_1,
    STATE(14800), 1,
      sym__delimiter_cmd_3,
    ACTIONS(15108), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10950), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15110), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4319), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4317), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4405), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [103290] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10951), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103360] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(7958), 1,
      anon_sym_LBRACK,
    ACTIONS(7960), 1,
      anon_sym_LBRACE,
    ACTIONS(7970), 1,
      sym_character_literal,
    ACTIONS(9504), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9506), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15954), 1,
      sym__word_identifier,
    ACTIONS(15956), 1,
      anon_sym_LPAREN,
    STATE(4220), 1,
      sym_identifier,
    STATE(15043), 1,
      sym__delimiter_str_1,
    STATE(15045), 1,
      sym__delimiter_str_3,
    STATE(15046), 1,
      sym__delimiter_cmd_1,
    STATE(15047), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13786), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10952), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13788), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4582), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4580), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4728), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [103448] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15958), 1,
      anon_sym_COMMA,
    ACTIONS(15960), 1,
      anon_sym_as,
    ACTIONS(15962), 1,
      anon_sym_COLON,
    STATE(11277), 1,
      aux_sym__import_list_repeat1,
    STATE(10953), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 8,
      anon_sym_EQ,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [103506] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15964), 1,
      anon_sym_DOT,
    STATE(10954), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10759), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [103558] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15964), 1,
      anon_sym_DOT,
    STATE(10955), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10763), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [103610] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10442), 1,
      sym_identifier,
    STATE(10956), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [103664] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10451), 1,
      sym_identifier,
    STATE(10957), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [103718] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10958), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [103788] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(777), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(779), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14900), 1,
      sym_character_literal,
    ACTIONS(15968), 1,
      sym__word_identifier,
    ACTIONS(15970), 1,
      anon_sym_LPAREN,
    ACTIONS(15972), 1,
      anon_sym_LBRACK,
    ACTIONS(15974), 1,
      anon_sym_LBRACE,
    STATE(6684), 1,
      sym_identifier,
    STATE(14597), 1,
      sym__delimiter_str_1,
    STATE(14599), 1,
      sym__delimiter_str_3,
    STATE(14600), 1,
      sym__delimiter_cmd_1,
    STATE(14601), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7376), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10959), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7378), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7514), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7804), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7496), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [103876] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10501), 1,
      sym_identifier,
    STATE(10960), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [103930] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15634), 1,
      sym__word_identifier,
    STATE(10503), 1,
      sym_identifier,
    STATE(10961), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [103984] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10962), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [104054] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14084), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14090), 1,
      sym_character_literal,
    ACTIONS(15978), 1,
      sym__word_identifier,
    ACTIONS(15980), 1,
      anon_sym_LPAREN,
    ACTIONS(15982), 1,
      anon_sym_LBRACK,
    ACTIONS(15984), 1,
      anon_sym_LBRACE,
    ACTIONS(15986), 1,
      aux_sym_integer_literal_token4,
    STATE(6372), 1,
      sym_identifier,
    STATE(14756), 1,
      sym__delimiter_str_1,
    STATE(14759), 1,
      sym__delimiter_str_3,
    STATE(14762), 1,
      sym__delimiter_cmd_1,
    STATE(14763), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14082), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10963), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14088), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6730), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6729), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7059), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104142] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15988), 1,
      aux_sym_float_literal_token2,
    ACTIONS(9734), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(10964), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [104194] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13246), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13248), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13252), 1,
      sym_character_literal,
    ACTIONS(14966), 1,
      anon_sym_LPAREN,
    ACTIONS(14968), 1,
      anon_sym_LBRACK,
    ACTIONS(14970), 1,
      anon_sym_LBRACE,
    ACTIONS(15990), 1,
      sym__word_identifier,
    STATE(5046), 1,
      sym_identifier,
    STATE(14392), 1,
      sym__delimiter_str_1,
    STATE(14393), 1,
      sym__delimiter_str_3,
    STATE(14394), 1,
      sym__delimiter_cmd_1,
    STATE(14395), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13244), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10965), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13250), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6157), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6156), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6255), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104282] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13592), 1,
      anon_sym_LPAREN,
    ACTIONS(13594), 1,
      anon_sym_LBRACK,
    ACTIONS(13596), 1,
      anon_sym_LBRACE,
    ACTIONS(13604), 1,
      sym_character_literal,
    ACTIONS(14478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15992), 1,
      sym__word_identifier,
    STATE(11459), 1,
      sym_identifier,
    STATE(14493), 1,
      sym__delimiter_str_1,
    STATE(14494), 1,
      sym__delimiter_str_3,
    STATE(14497), 1,
      sym__delimiter_cmd_1,
    STATE(14499), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10966), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11788), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11786), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11844), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104370] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11694), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10967), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104458] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10968), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [104528] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13886), 1,
      anon_sym_LPAREN,
    ACTIONS(13888), 1,
      anon_sym_LBRACK,
    ACTIONS(13890), 1,
      anon_sym_LBRACE,
    ACTIONS(13898), 1,
      sym_character_literal,
    ACTIONS(15060), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15062), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16002), 1,
      sym__word_identifier,
    STATE(4935), 1,
      sym_identifier,
    STATE(14940), 1,
      sym__delimiter_str_1,
    STATE(14941), 1,
      sym__delimiter_str_3,
    STATE(14942), 1,
      sym__delimiter_cmd_1,
    STATE(14943), 1,
      sym__delimiter_cmd_3,
    ACTIONS(15058), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10969), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15064), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5804), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5803), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5911), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104616] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(10549), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10970), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104704] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13380), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13382), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13386), 1,
      sym_character_literal,
    ACTIONS(14452), 1,
      anon_sym_LPAREN,
    ACTIONS(14454), 1,
      anon_sym_LBRACK,
    ACTIONS(14456), 1,
      anon_sym_LBRACE,
    ACTIONS(16004), 1,
      sym__word_identifier,
    STATE(4937), 1,
      sym_identifier,
    STATE(15097), 1,
      sym__delimiter_str_1,
    STATE(15098), 1,
      sym__delimiter_str_3,
    STATE(15099), 1,
      sym__delimiter_cmd_1,
    STATE(15101), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13378), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10971), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13384), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5868), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5867), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5938), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104792] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14434), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14436), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14440), 1,
      sym_character_literal,
    ACTIONS(15820), 1,
      sym__word_identifier,
    ACTIONS(15822), 1,
      anon_sym_LPAREN,
    ACTIONS(15824), 1,
      anon_sym_LBRACK,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    STATE(5949), 1,
      sym_identifier,
    STATE(14821), 1,
      sym__delimiter_str_1,
    STATE(14824), 1,
      sym__delimiter_str_3,
    STATE(14825), 1,
      sym__delimiter_cmd_1,
    STATE(14826), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14432), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10972), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14438), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6619), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6576), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6461), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [104880] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9756), 1,
      anon_sym_DASH_GT,
    STATE(10973), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [104932] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13478), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13480), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13484), 1,
      sym_character_literal,
    ACTIONS(14978), 1,
      anon_sym_LPAREN,
    ACTIONS(14980), 1,
      anon_sym_LBRACK,
    ACTIONS(14982), 1,
      anon_sym_LBRACE,
    ACTIONS(16006), 1,
      sym__word_identifier,
    STATE(10661), 1,
      sym_identifier,
    STATE(14545), 1,
      sym__delimiter_str_1,
    STATE(14546), 1,
      sym__delimiter_str_3,
    STATE(14551), 1,
      sym__delimiter_cmd_1,
    STATE(14552), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13476), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10974), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13482), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11111), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11110), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11114), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105020] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(309), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(311), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13340), 1,
      sym_character_literal,
    ACTIONS(16008), 1,
      sym__word_identifier,
    ACTIONS(16010), 1,
      anon_sym_LPAREN,
    ACTIONS(16012), 1,
      anon_sym_LBRACK,
    ACTIONS(16014), 1,
      anon_sym_LBRACE,
    STATE(6458), 1,
      sym_identifier,
    STATE(14991), 1,
      sym__delimiter_str_1,
    STATE(14996), 1,
      sym__delimiter_str_3,
    STATE(14997), 1,
      sym__delimiter_cmd_1,
    STATE(14998), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7754), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10975), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7756), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6873), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6871), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7203), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105108] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14866), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14872), 1,
      sym_character_literal,
    ACTIONS(16016), 1,
      sym__word_identifier,
    ACTIONS(16018), 1,
      anon_sym_LPAREN,
    ACTIONS(16020), 1,
      anon_sym_LBRACK,
    ACTIONS(16022), 1,
      anon_sym_LBRACE,
    ACTIONS(16024), 1,
      aux_sym_integer_literal_token4,
    STATE(6252), 1,
      sym_identifier,
    STATE(14292), 1,
      sym__delimiter_str_3,
    STATE(14293), 1,
      sym__delimiter_cmd_1,
    STATE(14294), 1,
      sym__delimiter_cmd_3,
    STATE(15107), 1,
      sym__delimiter_str_1,
    ACTIONS(14864), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10976), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14870), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6674), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6657), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6669), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105196] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6888), 1,
      anon_sym_LBRACK,
    ACTIONS(6890), 1,
      anon_sym_LBRACE,
    ACTIONS(6900), 1,
      sym_character_literal,
    ACTIONS(9592), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9594), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16026), 1,
      sym__word_identifier,
    ACTIONS(16028), 1,
      anon_sym_LPAREN,
    STATE(4406), 1,
      sym_identifier,
    STATE(14985), 1,
      sym__delimiter_str_1,
    STATE(14986), 1,
      sym__delimiter_str_3,
    STATE(14993), 1,
      sym__delimiter_cmd_1,
    STATE(15001), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12970), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10977), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12972), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4905), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4966), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4965), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105284] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13730), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13732), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13736), 1,
      sym_character_literal,
    ACTIONS(14762), 1,
      anon_sym_LPAREN,
    ACTIONS(14764), 1,
      anon_sym_LBRACK,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(16030), 1,
      sym__word_identifier,
    STATE(4959), 1,
      sym_identifier,
    STATE(14755), 1,
      sym__delimiter_str_1,
    STATE(14765), 1,
      sym__delimiter_str_3,
    STATE(14767), 1,
      sym__delimiter_cmd_1,
    STATE(14806), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13728), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10978), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13734), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5908), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5907), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5371), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105372] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(599), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(601), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13844), 1,
      sym_character_literal,
    ACTIONS(16032), 1,
      sym__word_identifier,
    ACTIONS(16034), 1,
      anon_sym_LPAREN,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    STATE(6649), 1,
      sym_identifier,
    STATE(14340), 1,
      sym__delimiter_str_1,
    STATE(14341), 1,
      sym__delimiter_str_3,
    STATE(14342), 1,
      sym__delimiter_cmd_1,
    STATE(14343), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7966), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10979), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7968), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7676), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7529), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105460] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15890), 1,
      sym__immediate_string_start,
    ACTIONS(15892), 1,
      sym__immediate_command_start,
    STATE(10980), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [105514] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14400), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14406), 1,
      sym_character_literal,
    ACTIONS(16040), 1,
      sym__word_identifier,
    ACTIONS(16042), 1,
      anon_sym_LPAREN,
    ACTIONS(16044), 1,
      anon_sym_LBRACK,
    ACTIONS(16046), 1,
      anon_sym_LBRACE,
    ACTIONS(16048), 1,
      aux_sym_integer_literal_token4,
    STATE(6430), 1,
      sym_identifier,
    STATE(14356), 1,
      sym__delimiter_str_1,
    STATE(14357), 1,
      sym__delimiter_str_3,
    STATE(14358), 1,
      sym__delimiter_cmd_1,
    STATE(14360), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14398), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10981), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6720), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6719), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6821), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105602] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15964), 1,
      anon_sym_DOT,
    STATE(10982), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10731), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [105654] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13162), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13164), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13168), 1,
      sym_character_literal,
    ACTIONS(14954), 1,
      anon_sym_LPAREN,
    ACTIONS(14956), 1,
      anon_sym_LBRACK,
    ACTIONS(14958), 1,
      anon_sym_LBRACE,
    ACTIONS(16050), 1,
      sym__word_identifier,
    STATE(5143), 1,
      sym_identifier,
    STATE(14982), 1,
      sym__delimiter_str_1,
    STATE(14987), 1,
      sym__delimiter_str_3,
    STATE(14990), 1,
      sym__delimiter_cmd_1,
    STATE(15013), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13160), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10983), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13166), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6299), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6298), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6031), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105742] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(8290), 1,
      anon_sym_LBRACK,
    ACTIONS(8292), 1,
      anon_sym_LBRACE,
    ACTIONS(8302), 1,
      sym_character_literal,
    ACTIONS(9548), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9550), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16052), 1,
      sym__word_identifier,
    ACTIONS(16054), 1,
      anon_sym_LPAREN,
    STATE(4237), 1,
      sym_identifier,
    STATE(14404), 1,
      sym__delimiter_str_1,
    STATE(14415), 1,
      sym__delimiter_str_3,
    STATE(14435), 1,
      sym__delimiter_cmd_1,
    STATE(14436), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13356), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10984), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13358), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4758), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4757), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4794), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105830] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13810), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13812), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13816), 1,
      sym_character_literal,
    ACTIONS(14838), 1,
      anon_sym_LPAREN,
    ACTIONS(14840), 1,
      anon_sym_LBRACK,
    ACTIONS(14842), 1,
      anon_sym_LBRACE,
    ACTIONS(16056), 1,
      sym__word_identifier,
    STATE(4971), 1,
      sym_identifier,
    STATE(14855), 1,
      sym__delimiter_str_1,
    STATE(14857), 1,
      sym__delimiter_str_3,
    STATE(14860), 1,
      sym__delimiter_cmd_1,
    STATE(14864), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13808), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10985), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13814), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5377), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5376), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5437), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [105918] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13444), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13446), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13450), 1,
      sym_character_literal,
    ACTIONS(15852), 1,
      sym__word_identifier,
    ACTIONS(15854), 1,
      anon_sym_LPAREN,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    ACTIONS(15858), 1,
      anon_sym_LBRACE,
    STATE(6658), 1,
      sym_identifier,
    STATE(14687), 1,
      sym__delimiter_str_1,
    STATE(14688), 1,
      sym__delimiter_str_3,
    STATE(14689), 1,
      sym__delimiter_cmd_1,
    STATE(14690), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13442), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10986), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13448), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7274), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7271), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7896), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106006] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10194), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(10987), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [106076] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13764), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13766), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13770), 1,
      sym_character_literal,
    ACTIONS(15874), 1,
      sym__word_identifier,
    ACTIONS(15876), 1,
      anon_sym_LPAREN,
    ACTIONS(15878), 1,
      anon_sym_LBRACK,
    ACTIONS(15880), 1,
      anon_sym_LBRACE,
    STATE(6404), 1,
      sym_identifier,
    STATE(14829), 1,
      sym__delimiter_str_1,
    STATE(14830), 1,
      sym__delimiter_str_3,
    STATE(14831), 1,
      sym__delimiter_cmd_1,
    STATE(14832), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13762), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10988), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13768), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6992), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6989), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6777), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106164] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14320), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14322), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14326), 1,
      sym_character_literal,
    ACTIONS(16058), 1,
      sym__word_identifier,
    ACTIONS(16060), 1,
      anon_sym_LPAREN,
    ACTIONS(16062), 1,
      anon_sym_LBRACK,
    ACTIONS(16064), 1,
      anon_sym_LBRACE,
    STATE(14444), 1,
      sym__delimiter_str_1,
    STATE(14447), 1,
      sym__delimiter_str_3,
    STATE(14448), 1,
      sym__delimiter_cmd_1,
    STATE(14449), 1,
      sym__delimiter_cmd_3,
    STATE(14606), 1,
      sym_identifier,
    ACTIONS(14318), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10989), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14324), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(16652), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(16651), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(15468), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106252] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1291), 1,
      anon_sym_LBRACK,
    ACTIONS(1293), 1,
      anon_sym_LBRACE,
    ACTIONS(1313), 1,
      sym_character_literal,
    ACTIONS(9620), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9622), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16066), 1,
      sym__word_identifier,
    ACTIONS(16068), 1,
      anon_sym_LPAREN,
    STATE(4973), 1,
      sym_identifier,
    STATE(14900), 1,
      sym__delimiter_str_1,
    STATE(14902), 1,
      sym__delimiter_str_3,
    STATE(14903), 1,
      sym__delimiter_cmd_1,
    STATE(14904), 1,
      sym__delimiter_cmd_3,
    ACTIONS(9618), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10990), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9624), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5409), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5408), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5442), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106340] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14550), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14552), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14556), 1,
      sym_character_literal,
    ACTIONS(15906), 1,
      sym__word_identifier,
    ACTIONS(15908), 1,
      anon_sym_LPAREN,
    ACTIONS(15910), 1,
      anon_sym_LBRACK,
    ACTIONS(15912), 1,
      anon_sym_LBRACE,
    STATE(6447), 1,
      sym_identifier,
    STATE(15049), 1,
      sym__delimiter_str_1,
    STATE(15051), 1,
      sym__delimiter_str_3,
    STATE(15053), 1,
      sym__delimiter_cmd_1,
    STATE(15055), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14548), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10991), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14554), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7097), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7095), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6902), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106428] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15562), 1,
      anon_sym_DOT,
    ACTIONS(16070), 1,
      sym__tilde_operator,
    STATE(3253), 1,
      sym__assignment_operator,
    STATE(10992), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [106496] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(403), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13526), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13528), 1,
      sym_character_literal,
    ACTIONS(15810), 1,
      sym__word_identifier,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(6415), 1,
      sym_identifier,
    STATE(14769), 1,
      sym__delimiter_str_1,
    STATE(14770), 1,
      sym__delimiter_str_3,
    STATE(14776), 1,
      sym__delimiter_cmd_1,
    STATE(14788), 1,
      sym__delimiter_cmd_3,
    ACTIONS(6874), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10993), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6876), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6773), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6771), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7037), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106584] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9996), 1,
      sym_identifier,
    STATE(10994), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106638] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9997), 1,
      sym_identifier,
    STATE(10995), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106692] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14156), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14158), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14162), 1,
      sym_character_literal,
    ACTIONS(15932), 1,
      sym__word_identifier,
    ACTIONS(15934), 1,
      anon_sym_LPAREN,
    ACTIONS(15936), 1,
      anon_sym_LBRACK,
    ACTIONS(15938), 1,
      anon_sym_LBRACE,
    STATE(11396), 1,
      sym_identifier,
    STATE(14817), 1,
      sym__delimiter_str_1,
    STATE(14906), 1,
      sym__delimiter_str_3,
    STATE(14951), 1,
      sym__delimiter_cmd_1,
    STATE(14954), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14154), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10996), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14160), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11620), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11699), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106780] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10003), 1,
      sym_identifier,
    STATE(10997), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106834] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10004), 1,
      sym_identifier,
    STATE(10998), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [106888] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13668), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13670), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13674), 1,
      sym_character_literal,
    ACTIONS(13686), 1,
      anon_sym_LPAREN,
    ACTIONS(13688), 1,
      anon_sym_LBRACK,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    ACTIONS(16072), 1,
      sym__word_identifier,
    STATE(4806), 1,
      sym_identifier,
    STATE(14319), 1,
      sym__delimiter_str_1,
    STATE(14320), 1,
      sym__delimiter_str_3,
    STATE(14321), 1,
      sym__delimiter_cmd_1,
    STATE(14322), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13666), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(10999), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13672), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5164), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5163), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5202), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [106976] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13956), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13958), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13962), 1,
      sym_character_literal,
    ACTIONS(14722), 1,
      anon_sym_LPAREN,
    ACTIONS(14724), 1,
      anon_sym_LBRACK,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(16074), 1,
      sym__word_identifier,
    STATE(4981), 1,
      sym_identifier,
    STATE(14374), 1,
      sym__delimiter_str_1,
    STATE(14375), 1,
      sym__delimiter_str_3,
    STATE(14376), 1,
      sym__delimiter_cmd_1,
    STATE(14377), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13954), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11000), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13960), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5446), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5445), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5483), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107064] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(515), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(517), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14510), 1,
      sym_character_literal,
    ACTIONS(16076), 1,
      sym__word_identifier,
    ACTIONS(16078), 1,
      anon_sym_LPAREN,
    ACTIONS(16080), 1,
      anon_sym_LBRACK,
    ACTIONS(16082), 1,
      anon_sym_LBRACE,
    STATE(6493), 1,
      sym_identifier,
    STATE(14520), 1,
      sym__delimiter_str_1,
    STATE(14521), 1,
      sym__delimiter_str_3,
    STATE(14523), 1,
      sym__delimiter_cmd_1,
    STATE(14524), 1,
      sym__delimiter_cmd_3,
    ACTIONS(8298), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11001), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8300), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7495), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7483), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7877), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107152] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14190), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14196), 1,
      sym_character_literal,
    ACTIONS(16084), 1,
      sym__word_identifier,
    ACTIONS(16086), 1,
      anon_sym_LPAREN,
    ACTIONS(16088), 1,
      anon_sym_LBRACK,
    ACTIONS(16090), 1,
      anon_sym_LBRACE,
    ACTIONS(16092), 1,
      aux_sym_integer_literal_token4,
    STATE(6377), 1,
      sym_identifier,
    STATE(14554), 1,
      sym__delimiter_str_1,
    STATE(14555), 1,
      sym__delimiter_str_3,
    STATE(14556), 1,
      sym__delimiter_cmd_1,
    STATE(14557), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14188), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11002), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14194), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7066), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7064), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6946), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107240] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13700), 1,
      anon_sym_LPAREN,
    ACTIONS(13702), 1,
      anon_sym_LBRACK,
    ACTIONS(13704), 1,
      anon_sym_LBRACE,
    ACTIONS(13712), 1,
      sym_character_literal,
    ACTIONS(14938), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14940), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16094), 1,
      sym__word_identifier,
    STATE(5214), 1,
      sym_identifier,
    STATE(14407), 1,
      sym__delimiter_str_1,
    STATE(14408), 1,
      sym__delimiter_str_3,
    STATE(14409), 1,
      sym__delimiter_cmd_1,
    STATE(14414), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14936), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11003), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14942), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6188), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6187), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6260), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107328] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14084), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14086), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14090), 1,
      sym_character_literal,
    ACTIONS(15978), 1,
      sym__word_identifier,
    ACTIONS(15980), 1,
      anon_sym_LPAREN,
    ACTIONS(15982), 1,
      anon_sym_LBRACK,
    ACTIONS(15984), 1,
      anon_sym_LBRACE,
    STATE(6372), 1,
      sym_identifier,
    STATE(14756), 1,
      sym__delimiter_str_1,
    STATE(14759), 1,
      sym__delimiter_str_3,
    STATE(14762), 1,
      sym__delimiter_cmd_1,
    STATE(14763), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14082), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11004), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14088), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6730), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6729), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7059), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107416] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11005), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [107486] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(983), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(15090), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15092), 1,
      sym_character_literal,
    ACTIONS(15844), 1,
      sym__word_identifier,
    ACTIONS(15846), 1,
      anon_sym_LPAREN,
    ACTIONS(15848), 1,
      anon_sym_LBRACK,
    ACTIONS(15850), 1,
      anon_sym_LBRACE,
    STATE(7190), 1,
      sym_identifier,
    STATE(14575), 1,
      sym__delimiter_str_1,
    STATE(14578), 1,
      sym__delimiter_str_3,
    STATE(14582), 1,
      sym__delimiter_cmd_1,
    STATE(14583), 1,
      sym__delimiter_cmd_3,
    ACTIONS(6896), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11006), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(6898), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8383), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(8382), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7982), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107574] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14704), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14706), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14710), 1,
      sym_character_literal,
    ACTIONS(16096), 1,
      sym__word_identifier,
    ACTIONS(16098), 1,
      anon_sym_LPAREN,
    ACTIONS(16100), 1,
      anon_sym_LBRACK,
    ACTIONS(16102), 1,
      anon_sym_LBRACE,
    STATE(14608), 1,
      sym__delimiter_str_1,
    STATE(14614), 1,
      sym__delimiter_str_3,
    STATE(14615), 1,
      sym__delimiter_cmd_1,
    STATE(14617), 1,
      sym__delimiter_cmd_3,
    STATE(17057), 1,
      sym_identifier,
    ACTIONS(14702), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11007), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14708), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(17782), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(17780), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(18213), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107662] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(689), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13914), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13916), 1,
      sym_character_literal,
    ACTIONS(15866), 1,
      sym__word_identifier,
    ACTIONS(15868), 1,
      anon_sym_LPAREN,
    ACTIONS(15870), 1,
      anon_sym_LBRACK,
    ACTIONS(15872), 1,
      anon_sym_LBRACE,
    STATE(6644), 1,
      sym_identifier,
    STATE(14757), 1,
      sym__delimiter_str_1,
    STATE(14758), 1,
      sym__delimiter_str_3,
    STATE(14760), 1,
      sym__delimiter_cmd_1,
    STATE(14768), 1,
      sym__delimiter_cmd_3,
    ACTIONS(4948), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11008), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4950), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7347), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7344), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7863), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107750] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1307), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(1309), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14750), 1,
      sym_character_literal,
    ACTIONS(16104), 1,
      sym__word_identifier,
    ACTIONS(16106), 1,
      anon_sym_LPAREN,
    ACTIONS(16108), 1,
      anon_sym_LBRACK,
    ACTIONS(16110), 1,
      anon_sym_LBRACE,
    STATE(8072), 1,
      sym_identifier,
    STATE(14660), 1,
      sym__delimiter_str_1,
    STATE(14662), 1,
      sym__delimiter_str_3,
    STATE(14663), 1,
      sym__delimiter_cmd_1,
    STATE(14664), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1305), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11009), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1311), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8964), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(8960), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9028), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107838] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14354), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14360), 1,
      sym_character_literal,
    ACTIONS(16112), 1,
      sym__word_identifier,
    ACTIONS(16114), 1,
      anon_sym_LPAREN,
    ACTIONS(16116), 1,
      anon_sym_LBRACK,
    ACTIONS(16118), 1,
      anon_sym_LBRACE,
    ACTIONS(16120), 1,
      aux_sym_integer_literal_token4,
    STATE(7843), 1,
      sym_identifier,
    STATE(14708), 1,
      sym__delimiter_str_1,
    STATE(14718), 1,
      sym__delimiter_str_3,
    STATE(14719), 1,
      sym__delimiter_cmd_1,
    STATE(14720), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14352), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11010), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14358), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8769), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(8768), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(8946), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [107926] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13128), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13130), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13134), 1,
      sym_character_literal,
    ACTIONS(14648), 1,
      anon_sym_LPAREN,
    ACTIONS(14650), 1,
      anon_sym_LBRACK,
    ACTIONS(14652), 1,
      anon_sym_LBRACE,
    ACTIONS(16122), 1,
      sym__word_identifier,
    STATE(6457), 1,
      sym_identifier,
    STATE(14487), 1,
      sym__delimiter_str_1,
    STATE(14488), 1,
      sym__delimiter_str_3,
    STATE(14489), 1,
      sym__delimiter_cmd_1,
    STATE(14490), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13126), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11011), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13132), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6943), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6939), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7186), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108014] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(885), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14634), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14636), 1,
      sym_character_literal,
    ACTIONS(15898), 1,
      sym__word_identifier,
    ACTIONS(15900), 1,
      anon_sym_LPAREN,
    ACTIONS(15902), 1,
      anon_sym_LBRACK,
    ACTIONS(15904), 1,
      anon_sym_LBRACE,
    STATE(6604), 1,
      sym_identifier,
    STATE(15003), 1,
      sym__delimiter_str_1,
    STATE(15004), 1,
      sym__delimiter_str_3,
    STATE(15009), 1,
      sym__delimiter_cmd_1,
    STATE(15011), 1,
      sym__delimiter_cmd_3,
    ACTIONS(883), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11012), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(889), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7570), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7567), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7685), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108102] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14866), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14868), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14872), 1,
      sym_character_literal,
    ACTIONS(16016), 1,
      sym__word_identifier,
    ACTIONS(16018), 1,
      anon_sym_LPAREN,
    ACTIONS(16020), 1,
      anon_sym_LBRACK,
    ACTIONS(16022), 1,
      anon_sym_LBRACE,
    STATE(6252), 1,
      sym_identifier,
    STATE(14292), 1,
      sym__delimiter_str_3,
    STATE(14293), 1,
      sym__delimiter_cmd_1,
    STATE(14294), 1,
      sym__delimiter_cmd_3,
    STATE(15107), 1,
      sym__delimiter_str_1,
    ACTIONS(14864), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11013), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14870), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6674), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6657), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6669), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108190] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14400), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14402), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14406), 1,
      sym_character_literal,
    ACTIONS(16040), 1,
      sym__word_identifier,
    ACTIONS(16042), 1,
      anon_sym_LPAREN,
    ACTIONS(16044), 1,
      anon_sym_LBRACK,
    ACTIONS(16046), 1,
      anon_sym_LBRACE,
    STATE(6430), 1,
      sym_identifier,
    STATE(14356), 1,
      sym__delimiter_str_1,
    STATE(14357), 1,
      sym__delimiter_str_3,
    STATE(14358), 1,
      sym__delimiter_cmd_1,
    STATE(14360), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14398), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11014), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14404), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6720), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6719), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6821), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108278] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13266), 1,
      anon_sym_LPAREN,
    ACTIONS(13268), 1,
      anon_sym_LBRACK,
    ACTIONS(13270), 1,
      anon_sym_LBRACE,
    ACTIONS(13278), 1,
      sym_character_literal,
    ACTIONS(14604), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14606), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16124), 1,
      sym__word_identifier,
    STATE(4984), 1,
      sym_identifier,
    STATE(14572), 1,
      sym__delimiter_str_1,
    STATE(14573), 1,
      sym__delimiter_str_3,
    STATE(14574), 1,
      sym__delimiter_cmd_1,
    STATE(14576), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14602), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11015), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14608), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(5501), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(5499), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(5536), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108366] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(777), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14898), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14900), 1,
      sym_character_literal,
    ACTIONS(15968), 1,
      sym__word_identifier,
    ACTIONS(15970), 1,
      anon_sym_LPAREN,
    ACTIONS(15972), 1,
      anon_sym_LBRACK,
    ACTIONS(15974), 1,
      anon_sym_LBRACE,
    STATE(6684), 1,
      sym_identifier,
    STATE(14597), 1,
      sym__delimiter_str_1,
    STATE(14599), 1,
      sym__delimiter_str_3,
    STATE(14600), 1,
      sym__delimiter_cmd_1,
    STATE(14601), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7376), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11016), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7378), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7514), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7804), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7496), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108454] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(309), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13338), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13340), 1,
      sym_character_literal,
    ACTIONS(16008), 1,
      sym__word_identifier,
    ACTIONS(16010), 1,
      anon_sym_LPAREN,
    ACTIONS(16012), 1,
      anon_sym_LBRACK,
    ACTIONS(16014), 1,
      anon_sym_LBRACE,
    STATE(6458), 1,
      sym_identifier,
    STATE(14991), 1,
      sym__delimiter_str_1,
    STATE(14996), 1,
      sym__delimiter_str_3,
    STATE(14997), 1,
      sym__delimiter_cmd_1,
    STATE(14998), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7754), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11017), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7756), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6873), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6871), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7203), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108542] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(599), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13842), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13844), 1,
      sym_character_literal,
    ACTIONS(16032), 1,
      sym__word_identifier,
    ACTIONS(16034), 1,
      anon_sym_LPAREN,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    STATE(6649), 1,
      sym_identifier,
    STATE(14340), 1,
      sym__delimiter_str_1,
    STATE(14341), 1,
      sym__delimiter_str_3,
    STATE(14342), 1,
      sym__delimiter_cmd_1,
    STATE(14343), 1,
      sym__delimiter_cmd_3,
    ACTIONS(7966), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11018), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(7968), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7676), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7529), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108630] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14190), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14192), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14196), 1,
      sym_character_literal,
    ACTIONS(16084), 1,
      sym__word_identifier,
    ACTIONS(16086), 1,
      anon_sym_LPAREN,
    ACTIONS(16088), 1,
      anon_sym_LBRACK,
    ACTIONS(16090), 1,
      anon_sym_LBRACE,
    STATE(6377), 1,
      sym_identifier,
    STATE(14554), 1,
      sym__delimiter_str_1,
    STATE(14555), 1,
      sym__delimiter_str_3,
    STATE(14556), 1,
      sym__delimiter_cmd_1,
    STATE(14557), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14188), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11019), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14194), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7066), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7064), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6946), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108718] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14354), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14356), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14360), 1,
      sym_character_literal,
    ACTIONS(16112), 1,
      sym__word_identifier,
    ACTIONS(16114), 1,
      anon_sym_LPAREN,
    ACTIONS(16116), 1,
      anon_sym_LBRACK,
    ACTIONS(16118), 1,
      anon_sym_LBRACE,
    STATE(7843), 1,
      sym_identifier,
    STATE(14708), 1,
      sym__delimiter_str_1,
    STATE(14718), 1,
      sym__delimiter_str_3,
    STATE(14719), 1,
      sym__delimiter_cmd_1,
    STATE(14720), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14352), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11020), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14358), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8769), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(8768), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(8946), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108806] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(515), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14508), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14510), 1,
      sym_character_literal,
    ACTIONS(16076), 1,
      sym__word_identifier,
    ACTIONS(16078), 1,
      anon_sym_LPAREN,
    ACTIONS(16080), 1,
      anon_sym_LBRACK,
    ACTIONS(16082), 1,
      anon_sym_LBRACE,
    STATE(6493), 1,
      sym_identifier,
    STATE(14520), 1,
      sym__delimiter_str_1,
    STATE(14521), 1,
      sym__delimiter_str_3,
    STATE(14523), 1,
      sym__delimiter_cmd_1,
    STATE(14524), 1,
      sym__delimiter_cmd_3,
    ACTIONS(8298), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11021), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(8300), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(7495), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(7483), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(7877), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108894] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1307), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14748), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14750), 1,
      sym_character_literal,
    ACTIONS(16104), 1,
      sym__word_identifier,
    ACTIONS(16106), 1,
      anon_sym_LPAREN,
    ACTIONS(16108), 1,
      anon_sym_LBRACK,
    ACTIONS(16110), 1,
      anon_sym_LBRACE,
    STATE(8072), 1,
      sym_identifier,
    STATE(14660), 1,
      sym__delimiter_str_1,
    STATE(14662), 1,
      sym__delimiter_str_3,
    STATE(14663), 1,
      sym__delimiter_cmd_1,
    STATE(14664), 1,
      sym__delimiter_cmd_3,
    ACTIONS(1305), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11022), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1311), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(8964), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(8960), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9028), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [108982] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12166), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11023), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109052] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9806), 1,
      anon_sym_DASH_GT,
    STATE(11024), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [109104] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(15760), 1,
      anon_sym_LPAREN,
    STATE(9823), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11025), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9783), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [109192] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11026), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109262] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11027), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109332] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11028), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109402] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11029), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109472] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15890), 1,
      sym__immediate_string_start,
    ACTIONS(15892), 1,
      sym__immediate_command_start,
    STATE(11030), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [109526] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9808), 1,
      anon_sym_DASH_GT,
    STATE(11031), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [109578] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15562), 1,
      anon_sym_DOT,
    ACTIONS(16070), 1,
      sym__tilde_operator,
    STATE(3253), 1,
      sym__assignment_operator,
    STATE(11032), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109646] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11033), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109716] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11034), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109786] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11035), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109856] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15720), 1,
      anon_sym_DOT,
    ACTIONS(15722), 1,
      sym__tilde_operator,
    STATE(3712), 1,
      sym__assignment_operator,
    STATE(11036), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109924] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11037), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [109994] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15958), 1,
      anon_sym_COMMA,
    ACTIONS(15960), 1,
      anon_sym_as,
    STATE(11277), 1,
      aux_sym__import_list_repeat1,
    STATE(11038), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110050] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12437), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11039), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [110120] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11040), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [110190] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    ACTIONS(6878), 1,
      sym_character_literal,
    ACTIONS(9450), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9452), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16138), 1,
      sym__word_identifier,
    ACTIONS(16140), 1,
      anon_sym_LPAREN,
    STATE(4138), 1,
      sym_identifier,
    STATE(14869), 1,
      sym__delimiter_str_1,
    STATE(14870), 1,
      sym__delimiter_str_3,
    STATE(14871), 1,
      sym__delimiter_cmd_1,
    STATE(14872), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14916), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11041), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14918), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4293), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4291), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4322), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [110278] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11042), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110328] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11043), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9928), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9926), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110378] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(15768), 1,
      anon_sym_LPAREN,
    STATE(10301), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11044), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9930), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [110466] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11045), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10118), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10116), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110516] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9822), 1,
      anon_sym_DASH_GT,
    STATE(11046), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [110568] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16142), 1,
      sym__immediate_string_start,
    ACTIONS(16144), 1,
      sym__immediate_command_start,
    STATE(11047), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110622] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16146), 1,
      sym__immediate_string_start,
    ACTIONS(16148), 1,
      sym__immediate_command_start,
    STATE(11048), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110676] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11049), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9960), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9958), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110726] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11050), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10154), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10152), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110776] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16142), 1,
      sym__immediate_string_start,
    ACTIONS(16144), 1,
      sym__immediate_command_start,
    STATE(11051), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110830] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16142), 1,
      sym__immediate_string_start,
    ACTIONS(16144), 1,
      sym__immediate_command_start,
    STATE(11052), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [110884] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16146), 1,
      sym__immediate_string_start,
    ACTIONS(16148), 1,
      sym__immediate_command_start,
    STATE(11053), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110938] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16146), 1,
      sym__immediate_string_start,
    ACTIONS(16148), 1,
      sym__immediate_command_start,
    STATE(11054), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [110992] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16142), 1,
      sym__immediate_string_start,
    ACTIONS(16144), 1,
      sym__immediate_command_start,
    STATE(11055), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [111046] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16146), 1,
      sym__immediate_string_start,
    ACTIONS(16148), 1,
      sym__immediate_command_start,
    STATE(11056), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 25,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [111100] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11057), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [111170] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(15760), 1,
      anon_sym_LPAREN,
    STATE(10316), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11058), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9783), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111258] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11694), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11059), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111346] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15770), 1,
      sym__word_identifier,
    STATE(11201), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11060), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10682), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111434] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(10549), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11061), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111522] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15786), 1,
      sym__word_identifier,
    STATE(11203), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11062), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10111), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111610] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(15888), 1,
      sym__word_identifier,
    STATE(11055), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11063), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10399), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111698] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15894), 1,
      sym__word_identifier,
    STATE(11056), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11064), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10021), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111786] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14156), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14162), 1,
      sym_character_literal,
    ACTIONS(15932), 1,
      sym__word_identifier,
    ACTIONS(15934), 1,
      anon_sym_LPAREN,
    ACTIONS(15936), 1,
      anon_sym_LBRACK,
    ACTIONS(15938), 1,
      anon_sym_LBRACE,
    ACTIONS(15940), 1,
      aux_sym_integer_literal_token4,
    STATE(11396), 1,
      sym_identifier,
    STATE(14817), 1,
      sym__delimiter_str_1,
    STATE(14906), 1,
      sym__delimiter_str_3,
    STATE(14951), 1,
      sym__delimiter_cmd_1,
    STATE(14954), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14154), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11065), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14160), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11620), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11699), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111874] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11886), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11066), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [111962] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(10822), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11067), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112050] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14156), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14158), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14162), 1,
      sym_character_literal,
    ACTIONS(15932), 1,
      sym__word_identifier,
    ACTIONS(15934), 1,
      anon_sym_LPAREN,
    ACTIONS(15936), 1,
      anon_sym_LBRACK,
    ACTIONS(15938), 1,
      anon_sym_LBRACE,
    STATE(11481), 1,
      sym_identifier,
    STATE(14817), 1,
      sym__delimiter_str_1,
    STATE(14906), 1,
      sym__delimiter_str_3,
    STATE(14951), 1,
      sym__delimiter_cmd_1,
    STATE(14954), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14154), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11068), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14160), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11620), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11617), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11699), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112138] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10361), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11069), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [112208] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16152), 1,
      sym__immediate_string_start,
    ACTIONS(16154), 1,
      sym__immediate_command_start,
    STATE(11070), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [112262] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16152), 1,
      sym__immediate_string_start,
    ACTIONS(16154), 1,
      sym__immediate_command_start,
    STATE(11071), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [112316] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16152), 1,
      sym__immediate_string_start,
    ACTIONS(16154), 1,
      sym__immediate_command_start,
    STATE(11072), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [112370] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16152), 1,
      sym__immediate_string_start,
    ACTIONS(16154), 1,
      sym__immediate_command_start,
    STATE(11073), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [112424] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(16156), 1,
      sym__word_identifier,
    ACTIONS(16158), 1,
      anon_sym_LPAREN,
    ACTIONS(16160), 1,
      anon_sym_LBRACK,
    ACTIONS(16162), 1,
      anon_sym_LBRACE,
    ACTIONS(16166), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(16168), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16172), 1,
      sym_character_literal,
    STATE(10843), 1,
      sym_identifier,
    STATE(14963), 1,
      sym__delimiter_str_1,
    STATE(14965), 1,
      sym__delimiter_str_3,
    STATE(14971), 1,
      sym__delimiter_cmd_1,
    STATE(14973), 1,
      sym__delimiter_cmd_3,
    ACTIONS(16164), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11074), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16170), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11289), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11282), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11270), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112512] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(15760), 1,
      anon_sym_LPAREN,
    STATE(10555), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11075), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9783), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112600] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11940), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11076), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112688] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15770), 1,
      sym__word_identifier,
    STATE(11073), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11077), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10682), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112776] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(12004), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11078), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112864] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15786), 1,
      sym__word_identifier,
    STATE(11508), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11079), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10111), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [112952] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(15888), 1,
      sym__word_identifier,
    STATE(10769), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11080), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10399), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113040] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15894), 1,
      sym__word_identifier,
    STATE(11409), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11081), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10021), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113128] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(12910), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12912), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(15760), 1,
      anon_sym_LPAREN,
    STATE(10086), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    ACTIONS(12908), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11082), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12914), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9783), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113216] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11625), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11083), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113304] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15770), 1,
      sym__word_identifier,
    STATE(10765), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11084), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10682), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113392] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(11629), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11085), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113480] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9882), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(13988), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13990), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15786), 1,
      sym__word_identifier,
    STATE(10776), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13986), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11086), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13992), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10111), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113568] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(15888), 1,
      sym__word_identifier,
    STATE(10618), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11087), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10399), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113656] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13608), 1,
      anon_sym_LPAREN,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14052), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14054), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15894), 1,
      sym__word_identifier,
    STATE(10619), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14050), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11088), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14056), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10021), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [113744] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16174), 1,
      sym__immediate_string_start,
    ACTIONS(16176), 1,
      sym__immediate_command_start,
    STATE(11089), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [113798] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16174), 1,
      sym__immediate_string_start,
    ACTIONS(16176), 1,
      sym__immediate_command_start,
    STATE(11090), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [113852] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16174), 1,
      sym__immediate_string_start,
    ACTIONS(16176), 1,
      sym__immediate_command_start,
    STATE(11091), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [113906] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16174), 1,
      sym__immediate_string_start,
    ACTIONS(16176), 1,
      sym__immediate_command_start,
    STATE(11092), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [113960] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11638), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11093), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114048] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15770), 1,
      sym__word_identifier,
    STATE(11092), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11094), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10682), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114136] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(12623), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11095), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114224] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(15888), 1,
      sym__word_identifier,
    STATE(10684), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11096), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10399), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114312] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16178), 1,
      sym__immediate_string_start,
    ACTIONS(16180), 1,
      sym__immediate_command_start,
    STATE(11097), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [114366] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16178), 1,
      sym__immediate_string_start,
    ACTIONS(16180), 1,
      sym__immediate_command_start,
    STATE(11098), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [114420] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16178), 1,
      sym__immediate_string_start,
    ACTIONS(16180), 1,
      sym__immediate_command_start,
    STATE(11099), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [114474] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16178), 1,
      sym__immediate_string_start,
    ACTIONS(16180), 1,
      sym__immediate_command_start,
    STATE(11100), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [114528] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11518), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11101), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114616] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13312), 1,
      anon_sym_LPAREN,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(13636), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13638), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15770), 1,
      sym__word_identifier,
    STATE(11100), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13634), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11102), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13640), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10682), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114704] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14020), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14022), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14224), 1,
      anon_sym_LPAREN,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    ACTIONS(15888), 1,
      sym__word_identifier,
    STATE(10748), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14018), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11103), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14024), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10399), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114792] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11522), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11104), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114880] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11395), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11105), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [114968] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11647), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11106), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [115056] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11529), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11107), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [115144] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11651), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11108), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [115232] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11531), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11109), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [115320] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11110), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9984), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9982), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115370] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11111), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9988), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9986), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115420] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11112), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10002), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10000), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115470] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11113), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10006), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10004), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115520] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11114), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115570] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11115), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10012), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10010), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115620] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15654), 1,
      sym__tilde_operator,
    ACTIONS(16182), 1,
      anon_sym_EQ,
    STATE(2973), 1,
      sym__assignment_operator,
    STATE(11116), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115690] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15740), 1,
      anon_sym_DOT,
    ACTIONS(15742), 1,
      sym__tilde_operator,
    STATE(3803), 1,
      sym__assignment_operator,
    STATE(11117), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115758] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11118), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10016), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10014), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115808] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15706), 1,
      anon_sym_DOT,
    ACTIONS(16184), 1,
      sym__tilde_operator,
    STATE(3847), 1,
      sym__assignment_operator,
    STATE(11119), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [115876] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11120), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10020), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10018), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115926] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11121), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9918), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9916), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [115976] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11625), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11122), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [116064] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(11629), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11123), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [116152] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11124), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9922), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9920), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116202] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11125), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116252] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11126), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9992), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9990), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116302] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11127), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9996), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9994), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116352] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11128), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116402] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11129), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116452] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11130), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10028), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116502] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11131), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10032), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116552] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11132), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10036), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116602] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11133), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10040), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116652] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11134), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116702] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11135), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116752] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11136), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [116822] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11137), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116872] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11138), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10046), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10044), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116922] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11139), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10048), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [116972] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(12806), 1,
      anon_sym_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11140), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [117042] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11141), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10054), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10052), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117092] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11142), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10058), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10056), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117142] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11143), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9900), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9898), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117192] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11144), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10062), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10060), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117242] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11145), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10066), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10064), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117292] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    ACTIONS(16150), 1,
      aux_sym_integer_literal_token4,
    STATE(11886), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11146), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [117380] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11147), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10070), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10068), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117430] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11148), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10074), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10072), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117480] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11149), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10078), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10076), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117530] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11150), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10082), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10080), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [117580] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(12199), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11151), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [117668] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(15768), 1,
      anon_sym_LPAREN,
    STATE(10183), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11152), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9930), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [117756] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11518), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11153), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [117844] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(12004), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11154), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [117932] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(11526), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11155), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118020] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(15768), 1,
      anon_sym_LPAREN,
    STATE(10071), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11156), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9930), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118108] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10328), 1,
      aux_sym__terminator_token1,
    ACTIONS(16186), 1,
      anon_sym_SQUOTE,
    ACTIONS(16188), 1,
      anon_sym_DOT,
    ACTIONS(16190), 1,
      sym__immediate_paren,
    ACTIONS(16192), 1,
      sym__immediate_bracket,
    ACTIONS(16194), 1,
      sym__immediate_brace,
    STATE(11157), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [118168] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15480), 1,
      anon_sym_SQUOTE,
    ACTIONS(15484), 1,
      sym__immediate_paren,
    ACTIONS(15486), 1,
      sym__immediate_bracket,
    ACTIONS(15488), 1,
      sym__immediate_brace,
    ACTIONS(16196), 1,
      anon_sym_DOT,
    STATE(11158), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10328), 23,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [118228] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11940), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11159), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118316] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(12199), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11160), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118404] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    ACTIONS(15784), 1,
      aux_sym_integer_literal_token4,
    STATE(11397), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11161), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118492] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(15768), 1,
      anon_sym_LPAREN,
    STATE(10205), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11162), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9930), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118580] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11395), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11163), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118668] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(11397), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11164), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118756] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(12936), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(12938), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(15768), 1,
      anon_sym_LPAREN,
    STATE(10208), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13876), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11165), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13878), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(9930), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118844] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11529), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11166), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [118932] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(12623), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11167), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119020] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11638), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11168), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119108] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(13412), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(13416), 1,
      sym_character_literal,
    ACTIONS(15776), 1,
      sym__word_identifier,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(11526), 1,
      sym_identifier,
    STATE(14792), 1,
      sym__delimiter_str_1,
    STATE(14796), 1,
      sym__delimiter_str_3,
    STATE(14797), 1,
      sym__delimiter_cmd_1,
    STATE(14801), 1,
      sym__delimiter_cmd_3,
    ACTIONS(13408), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11169), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13414), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(10497), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(10421), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119196] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11522), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11170), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119284] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11647), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11171), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119372] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11531), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11172), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119460] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(14256), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14258), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(14262), 1,
      sym_character_literal,
    ACTIONS(15994), 1,
      sym__word_identifier,
    ACTIONS(15996), 1,
      anon_sym_LPAREN,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11651), 1,
      sym_identifier,
    STATE(14514), 1,
      sym__delimiter_str_1,
    STATE(14515), 1,
      sym__delimiter_str_3,
    STATE(14516), 1,
      sym__delimiter_cmd_1,
    STATE(14517), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14254), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11173), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14260), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(11311), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(11351), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119548] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11174), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9756), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9726), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [119598] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15964), 1,
      anon_sym_DOT,
    STATE(11175), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 25,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [119650] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15500), 1,
      sym__tilde_operator,
    STATE(3778), 1,
      sym__assignment_operator,
    STATE(11176), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [119720] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4938), 1,
      anon_sym_LBRACK,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    ACTIONS(4952), 1,
      sym_character_literal,
    ACTIONS(9570), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(9572), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16198), 1,
      sym__word_identifier,
    ACTIONS(16200), 1,
      anon_sym_LPAREN,
    STATE(4195), 1,
      sym_identifier,
    STATE(14410), 1,
      sym__delimiter_str_1,
    STATE(14411), 1,
      sym__delimiter_str_3,
    STATE(14412), 1,
      sym__delimiter_cmd_1,
    STATE(14413), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14582), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11177), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14584), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(4721), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(4855), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(4560), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [119808] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15706), 1,
      anon_sym_DOT,
    ACTIONS(16184), 1,
      sym__tilde_operator,
    STATE(3847), 1,
      sym__assignment_operator,
    STATE(11178), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 10,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [119876] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10655), 1,
      sym_identifier,
    STATE(11179), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [119930] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11180), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9758), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9744), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [119980] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15740), 1,
      anon_sym_DOT,
    ACTIONS(16202), 1,
      anon_sym_EQ,
    ACTIONS(16204), 1,
      sym__tilde_operator,
    STATE(3102), 1,
      sym__assignment_operator,
    STATE(11181), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [120050] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11182), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120100] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11183), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10136), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10134), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120150] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11184), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(3071), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120200] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11185), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9912), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120250] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10547), 1,
      sym_identifier,
    STATE(11186), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120304] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(13216), 1,
      anon_sym_LPAREN,
    ACTIONS(13218), 1,
      anon_sym_LBRACK,
    ACTIONS(13220), 1,
      anon_sym_LBRACE,
    ACTIONS(13228), 1,
      sym_character_literal,
    ACTIONS(14788), 1,
      aux_sym_integer_literal_token3,
    ACTIONS(14790), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16206), 1,
      sym__word_identifier,
    STATE(6124), 1,
      sym_identifier,
    STATE(14738), 1,
      sym__delimiter_str_1,
    STATE(14739), 1,
      sym__delimiter_str_3,
    STATE(14741), 1,
      sym__delimiter_cmd_1,
    STATE(14743), 1,
      sym__delimiter_cmd_3,
    ACTIONS(14786), 2,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
    STATE(11187), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14792), 3,
      aux_sym_float_literal_token1,
      aux_sym_float_literal_token3,
      aux_sym_float_literal_token4,
    STATE(6580), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
    STATE(6569), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
    STATE(6641), 7,
      sym__array,
      sym_parenthesized_expression,
      sym_tuple_expression,
      sym_curly_expression,
      sym_integer_literal,
      sym_float_literal,
      sym__string,
  [120392] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11188), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [120441] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9746), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11189), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120490] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11190), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10070), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [120539] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11191), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9984), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9982), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120588] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16208), 1,
      sym__immediate_string_start,
    ACTIONS(16210), 1,
      sym__immediate_command_start,
    STATE(11192), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120641] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16212), 1,
      anon_sym_DOT,
    STATE(11193), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [120692] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16208), 1,
      sym__immediate_string_start,
    ACTIONS(16210), 1,
      sym__immediate_command_start,
    STATE(11194), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120745] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16214), 1,
      sym__immediate_string_start,
    ACTIONS(16216), 1,
      sym__immediate_command_start,
    STATE(11195), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [120798] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9992), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11196), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120847] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16214), 1,
      sym__immediate_string_start,
    ACTIONS(16216), 1,
      sym__immediate_command_start,
    STATE(11197), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [120900] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11198), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9988), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9986), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120949] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11199), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10002), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10000), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [120998] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11200), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10006), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10004), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121047] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16208), 1,
      sym__immediate_string_start,
    ACTIONS(16210), 1,
      sym__immediate_command_start,
    STATE(11201), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121100] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9996), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11202), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121149] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16214), 1,
      sym__immediate_string_start,
    ACTIONS(16216), 1,
      sym__immediate_command_start,
    STATE(11203), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [121202] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11204), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [121251] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11205), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10012), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10010), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121300] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11206), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10016), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10014), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121349] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10525), 1,
      aux_sym__terminator_token1,
    ACTIONS(16218), 1,
      anon_sym_SQUOTE,
    ACTIONS(16220), 1,
      anon_sym_DOT,
    ACTIONS(16222), 1,
      sym__immediate_paren,
    ACTIONS(16224), 1,
      sym__immediate_bracket,
    ACTIONS(16226), 1,
      sym__immediate_brace,
    STATE(11207), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121408] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9754), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11208), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121457] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11209), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10020), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10018), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121506] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9762), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11210), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121555] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11211), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9918), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9916), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121604] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10030), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11212), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121653] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11213), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9922), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9920), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121702] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11214), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9724), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121751] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11215), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9992), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9990), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121800] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11216), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9996), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9994), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121849] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11217), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9750), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121898] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11218), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9760), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121947] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11219), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10030), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10028), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [121996] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11220), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10034), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10032), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122045] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11221), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10038), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10036), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122094] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11222), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10042), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10040), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122143] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11223), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9736), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122192] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11224), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9742), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122241] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11225), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9788), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122290] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10034), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11226), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122339] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10038), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11227), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122388] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11228), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10046), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10044), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122437] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11229), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10050), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10048), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122486] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11230), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10054), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10052), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122535] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11231), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9992), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [122584] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10042), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11232), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122633] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16228), 1,
      sym__immediate_string_start,
    ACTIONS(16230), 1,
      sym__immediate_command_start,
    STATE(11233), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122686] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11234), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [122735] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11235), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10058), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10056), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122784] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11236), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9996), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [122833] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9792), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11237), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122882] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10046), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11238), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122931] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10050), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11239), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [122980] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10054), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11240), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123029] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10058), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11241), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123078] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9900), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11242), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123127] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11243), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9900), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9898), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123176] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11244), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10062), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10060), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123225] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10103), 1,
      sym_identifier,
    STATE(11245), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [123278] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10547), 1,
      sym_identifier,
    STATE(11246), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123331] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11247), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10066), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10064), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123380] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11248), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10070), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10068), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123429] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11249), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10074), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10072), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123478] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11250), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10078), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10076), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123527] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11251), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10082), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10080), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123576] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10559), 1,
      sym_identifier,
    STATE(11252), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123629] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10062), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11253), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123678] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10064), 1,
      sym_identifier,
    STATE(11254), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [123731] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11255), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9980), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9978), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123780] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10066), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11256), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123829] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10070), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11257), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123878] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10074), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11258), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123927] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10078), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11259), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [123976] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10082), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11260), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124025] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10576), 1,
      sym_identifier,
    STATE(11261), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124078] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11262), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10088), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10086), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124127] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11263), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124176] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10655), 1,
      sym_identifier,
    STATE(11264), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124229] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15676), 1,
      anon_sym_EQ,
    ACTIONS(15678), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(11265), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [124282] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10576), 1,
      sym_identifier,
    STATE(11266), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9796), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124335] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10655), 1,
      sym_identifier,
    STATE(11267), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9800), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124388] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11268), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [124437] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10539), 1,
      aux_sym__terminator_token1,
    ACTIONS(16218), 1,
      anon_sym_SQUOTE,
    ACTIONS(16220), 1,
      anon_sym_DOT,
    ACTIONS(16222), 1,
      sym__immediate_paren,
    ACTIONS(16224), 1,
      sym__immediate_bracket,
    ACTIONS(16226), 1,
      sym__immediate_brace,
    STATE(11269), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124496] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11270), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [124545] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16232), 1,
      anon_sym_COMMA,
    STATE(11344), 1,
      aux_sym_export_statement_repeat1,
    STATE(11271), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10878), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [124598] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11272), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9762), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [124647] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16228), 1,
      sym__immediate_string_start,
    ACTIONS(16230), 1,
      sym__immediate_command_start,
    STATE(11273), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124700] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16232), 1,
      anon_sym_COMMA,
    STATE(11344), 1,
      aux_sym_export_statement_repeat1,
    STATE(11274), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10882), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [124753] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10525), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16236), 1,
      anon_sym_DOT,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    STATE(11275), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [124812] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11276), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10012), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [124861] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15958), 1,
      anon_sym_COMMA,
    STATE(11347), 1,
      aux_sym__import_list_repeat1,
    STATE(11277), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10886), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [124914] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11278), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10030), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [124963] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11279), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10034), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125012] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11280), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10038), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125061] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11281), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10042), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125110] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11282), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9984), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125159] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11283), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10016), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125208] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11284), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125257] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11285), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125306] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11286), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125355] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16228), 1,
      sym__immediate_string_start,
    ACTIONS(16230), 1,
      sym__immediate_command_start,
    STATE(11287), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9714), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125408] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11288), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125457] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11289), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9988), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125506] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11290), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10002), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125555] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11291), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10006), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125604] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11292), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10144), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10142), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125653] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9740), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11293), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125702] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10547), 1,
      sym_identifier,
    STATE(11294), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9780), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125755] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11295), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10050), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125804] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9928), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11296), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9926), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125853] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9960), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11297), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9958), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [125902] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15630), 1,
      anon_sym_EQ,
    ACTIONS(15632), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(11298), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [125955] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11299), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126004] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15988), 1,
      aux_sym_float_literal_token2,
    ACTIONS(9734), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11300), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126055] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11301), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126104] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11302), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10054), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126153] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11303), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10058), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126202] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15658), 1,
      anon_sym_EQ,
    ACTIONS(15660), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(11304), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126255] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11305), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9900), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126304] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11306), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126353] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15716), 1,
      sym__word_identifier,
    STATE(10559), 1,
      sym_identifier,
    STATE(11307), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9784), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126406] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11308), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126455] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11309), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10062), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126504] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10421), 1,
      anon_sym_end,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15654), 1,
      sym__tilde_operator,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(16244), 1,
      anon_sym_DOT,
    STATE(2973), 1,
      sym__assignment_operator,
    STATE(11310), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 13,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [126573] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9984), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11311), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126622] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11312), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10140), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10138), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126671] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11313), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10066), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126720] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9988), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11314), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126769] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10002), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11315), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126818] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10006), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11316), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [126867] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11317), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10074), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [126916] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15654), 1,
      sym__tilde_operator,
    STATE(2973), 1,
      sym__assignment_operator,
    STATE(11318), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [126983] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15662), 1,
      anon_sym_EQ,
    ACTIONS(15664), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(11319), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [127036] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15672), 1,
      anon_sym_EQ,
    ACTIONS(15674), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(11320), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [127089] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16232), 1,
      anon_sym_COMMA,
    STATE(11271), 1,
      aux_sym_export_statement_repeat1,
    STATE(11321), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10811), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127142] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16232), 1,
      anon_sym_COMMA,
    STATE(11274), 1,
      aux_sym_export_statement_repeat1,
    STATE(11322), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10815), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127195] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15958), 1,
      anon_sym_COMMA,
    STATE(11277), 1,
      aux_sym__import_list_repeat1,
    STATE(11323), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127248] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10328), 1,
      aux_sym__terminator_token1,
    ACTIONS(16186), 1,
      anon_sym_SQUOTE,
    ACTIONS(16190), 1,
      sym__immediate_paren,
    ACTIONS(16192), 1,
      sym__immediate_bracket,
    ACTIONS(16194), 1,
      sym__immediate_brace,
    ACTIONS(16246), 1,
      anon_sym_DOT,
    STATE(11324), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127307] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10118), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11325), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10116), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127356] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11326), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10078), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [127405] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16228), 1,
      sym__immediate_string_start,
    ACTIONS(16230), 1,
      sym__immediate_command_start,
    STATE(11327), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      ts_builtin_sym_end,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127458] = 15,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    ACTIONS(15654), 1,
      sym__tilde_operator,
    STATE(2973), 1,
      sym__assignment_operator,
    STATE(11328), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 13,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [127527] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9728), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11329), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127576] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    ACTIONS(16248), 1,
      anon_sym_DOT,
    STATE(11330), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10525), 22,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127635] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    ACTIONS(16248), 1,
      anon_sym_DOT,
    STATE(11331), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10539), 22,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [127694] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11332), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10082), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [127743] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11333), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9642), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127792] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10154), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11334), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10152), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127841] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(3075), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11335), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127890] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11336), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9956), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9954), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127939] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10328), 1,
      aux_sym__terminator_token1,
    ACTIONS(16186), 1,
      anon_sym_SQUOTE,
    ACTIONS(16190), 1,
      sym__immediate_paren,
    ACTIONS(16192), 1,
      sym__immediate_bracket,
    ACTIONS(16194), 1,
      sym__immediate_brace,
    ACTIONS(16250), 1,
      anon_sym_DOT,
    STATE(11337), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [127998] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11338), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9964), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9962), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128047] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11339), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128096] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11340), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [128145] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11341), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9928), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9926), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128194] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10328), 1,
      aux_sym__terminator_token1,
    ACTIONS(16186), 1,
      anon_sym_SQUOTE,
    ACTIONS(16190), 1,
      sym__immediate_paren,
    ACTIONS(16192), 1,
      sym__immediate_bracket,
    ACTIONS(16194), 1,
      sym__immediate_brace,
    ACTIONS(16252), 1,
      anon_sym_DOT,
    STATE(11342), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128253] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11343), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10020), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [128302] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16254), 1,
      anon_sym_COMMA,
    STATE(11344), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10855), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128353] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10012), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11345), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128402] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15960), 1,
      anon_sym_as,
    STATE(11346), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 24,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128453] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16257), 1,
      anon_sym_COMMA,
    STATE(11347), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 23,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [128504] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11348), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9918), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [128553] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10016), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11349), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128602] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11350), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9708), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9706), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128651] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11351), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128700] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11352), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9712), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9710), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128749] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10579), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11353), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10577), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128798] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9644), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11354), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128847] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11355), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10118), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10116), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128896] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11356), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10104), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10102), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128945] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10020), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11357), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [128994] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11358), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10108), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10106), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129043] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11359), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9922), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [129092] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11360), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9730), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129141] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15704), 1,
      anon_sym_SQUOTE,
    ACTIONS(15740), 1,
      anon_sym_DOT,
    ACTIONS(16204), 1,
      sym__tilde_operator,
    STATE(3102), 1,
      sym__assignment_operator,
    STATE(11361), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 14,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [129208] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11362), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9960), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9958), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129257] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11363), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10154), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10152), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129306] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9918), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11364), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129355] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11365), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10136), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10134), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129404] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11366), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(3071), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129453] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11367), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9914), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9912), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129502] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11368), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10124), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10122), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129551] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9922), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11369), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 32,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129600] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11370), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9704), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(9702), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129649] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11371), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [129698] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10042), 1,
      sym_identifier,
    STATE(11372), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129751] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10110), 1,
      sym_identifier,
    STATE(11373), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 19,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [129804] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16208), 1,
      sym__immediate_string_start,
    ACTIONS(16210), 1,
      sym__immediate_command_start,
    STATE(11374), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(189), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(101), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129857] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11375), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10130), 5,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      aux_sym__terminator_token1,
    ACTIONS(10128), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [129906] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15606), 1,
      anon_sym_EQ,
    ACTIONS(15608), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(11376), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 11,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 20,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [129959] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10539), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16236), 1,
      anon_sym_DOT,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    STATE(11377), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130018] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16214), 1,
      sym__immediate_string_start,
    ACTIONS(16216), 1,
      sym__immediate_command_start,
    STATE(11378), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130071] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11379), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      anon_sym_DOT_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(10046), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_COLON_EQ,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [130120] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11380), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130170] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(11381), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 15,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130222] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10003), 1,
      sym_identifier,
    STATE(11382), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130274] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16186), 1,
      anon_sym_SQUOTE,
    ACTIONS(16190), 1,
      sym__immediate_paren,
    ACTIONS(16192), 1,
      sym__immediate_bracket,
    ACTIONS(16194), 1,
      sym__immediate_brace,
    ACTIONS(16260), 1,
      anon_sym_DOT,
    ACTIONS(10328), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11383), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130332] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(11384), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 15,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130384] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(11385), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 15,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [130436] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11386), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130488] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11387), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130540] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11666), 1,
      sym_identifier,
    STATE(11388), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130592] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11667), 1,
      sym_identifier,
    STATE(11389), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130644] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11673), 1,
      sym_identifier,
    STATE(11390), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130696] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11674), 1,
      sym_identifier,
    STATE(11391), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130748] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11392), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130800] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11393), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130852] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10910), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11394), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10908), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130900] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16266), 1,
      sym__immediate_string_start,
    ACTIONS(16268), 1,
      sym__immediate_command_start,
    STATE(11395), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [130952] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16270), 1,
      sym__immediate_string_start,
    ACTIONS(16272), 1,
      sym__immediate_command_start,
    STATE(11396), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131004] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16274), 1,
      sym__immediate_string_start,
    ACTIONS(16276), 1,
      sym__immediate_command_start,
    STATE(11397), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 23,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131056] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9768), 1,
      anon_sym_DOT_EQ,
    ACTIONS(10180), 1,
      sym__immediate_paren,
    ACTIONS(15368), 1,
      anon_sym_SQUOTE,
    ACTIONS(15376), 1,
      sym__immediate_bracket,
    ACTIONS(15378), 1,
      sym__immediate_brace,
    ACTIONS(15498), 1,
      anon_sym_DOT,
    ACTIONS(15654), 1,
      sym__tilde_operator,
    STATE(2973), 1,
      sym__assignment_operator,
    STATE(11398), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1821), 3,
      anon_sym_COLON_EQ,
      anon_sym_DOLLAR_EQ,
      aux_sym__assignment_operator_token1,
    ACTIONS(9171), 9,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 13,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [131122] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16266), 1,
      sym__immediate_string_start,
    ACTIONS(16268), 1,
      sym__immediate_command_start,
    STATE(11399), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131174] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16274), 1,
      sym__immediate_string_start,
    ACTIONS(16276), 1,
      sym__immediate_command_start,
    STATE(11400), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 23,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131226] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11401), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131274] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11402), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131322] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10328), 1,
      aux_sym__terminator_token1,
    ACTIONS(16186), 1,
      anon_sym_SQUOTE,
    ACTIONS(16190), 1,
      sym__immediate_paren,
    ACTIONS(16192), 1,
      sym__immediate_bracket,
    ACTIONS(16194), 1,
      sym__immediate_brace,
    ACTIONS(16278), 1,
      anon_sym_DOT,
    STATE(11403), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131380] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9996), 1,
      sym_identifier,
    STATE(11404), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131432] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15480), 1,
      anon_sym_SQUOTE,
    ACTIONS(15484), 1,
      sym__immediate_paren,
    ACTIONS(15486), 1,
      sym__immediate_bracket,
    ACTIONS(15488), 1,
      sym__immediate_brace,
    ACTIONS(16280), 1,
      anon_sym_DOT,
    STATE(11405), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10328), 21,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131490] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16282), 1,
      sym__immediate_string_start,
    ACTIONS(16284), 1,
      sym__immediate_command_start,
    STATE(11406), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131542] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16282), 1,
      sym__immediate_string_start,
    ACTIONS(16284), 1,
      sym__immediate_command_start,
    STATE(11407), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131594] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(10004), 1,
      sym_identifier,
    STATE(11408), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131646] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16282), 1,
      sym__immediate_string_start,
    ACTIONS(16284), 1,
      sym__immediate_command_start,
    STATE(11409), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131698] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11410), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131748] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    STATE(11411), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 9,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 23,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131798] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11412), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 31,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131846] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11413), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 3,
      sym__immediate_string_start,
      sym__immediate_command_start,
      aux_sym__terminator_token1,
    ACTIONS(9642), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [131894] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16282), 1,
      sym__immediate_string_start,
    ACTIONS(16284), 1,
      sym__immediate_command_start,
    STATE(11414), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131946] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15178), 1,
      sym__word_identifier,
    STATE(9997), 1,
      sym_identifier,
    STATE(11415), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [131998] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10525), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16288), 1,
      anon_sym_DOT,
    STATE(11416), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132056] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10539), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16288), 1,
      anon_sym_DOT,
    STATE(11417), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132114] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10525), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16290), 1,
      anon_sym_DOT,
    STATE(11418), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132172] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11419), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132222] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10525), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16292), 1,
      anon_sym_DOT,
    STATE(11420), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132280] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10539), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16290), 1,
      anon_sym_DOT,
    STATE(11421), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132338] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10539), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16292), 1,
      anon_sym_DOT,
    STATE(11422), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132396] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16270), 1,
      sym__immediate_string_start,
    ACTIONS(16272), 1,
      sym__immediate_command_start,
    STATE(11423), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132448] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(11424), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 15,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132500] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11425), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132551] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16294), 1,
      sym__word_identifier,
    ACTIONS(16296), 1,
      aux_sym_import_path_token1,
    ACTIONS(16298), 1,
      anon_sym_LPAREN,
    ACTIONS(16300), 1,
      anon_sym_DOLLAR,
    ACTIONS(16302), 1,
      anon_sym_AT,
    STATE(6896), 1,
      sym__importable,
    STATE(6897), 1,
      sym_scoped_identifier,
    STATE(6898), 1,
      sym_identifier,
    STATE(7719), 1,
      sym_import_alias,
    STATE(7720), 2,
      sym_import_path,
      sym__exportable,
    STATE(8114), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11426), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7895), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14178), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14198), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [132622] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16294), 1,
      sym__word_identifier,
    ACTIONS(16296), 1,
      aux_sym_import_path_token1,
    ACTIONS(16298), 1,
      anon_sym_LPAREN,
    ACTIONS(16300), 1,
      anon_sym_DOLLAR,
    ACTIONS(16302), 1,
      anon_sym_AT,
    STATE(6896), 1,
      sym__importable,
    STATE(6897), 1,
      sym_scoped_identifier,
    STATE(6898), 1,
      sym_identifier,
    STATE(7719), 1,
      sym_import_alias,
    STATE(7720), 2,
      sym_import_path,
      sym__exportable,
    STATE(8115), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11427), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7895), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14178), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14198), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [132693] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11333), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11428), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11331), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132740] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11337), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11429), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11335), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132787] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11341), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11430), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11339), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132834] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11345), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11431), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11343), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132881] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10103), 1,
      sym_identifier,
    STATE(11432), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [132932] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11433), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [132979] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11434), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133030] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11435), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133081] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11436), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133128] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11349), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11437), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11347), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133175] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11353), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11438), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11351), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133222] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16304), 1,
      sym__word_identifier,
    ACTIONS(16306), 1,
      aux_sym_import_path_token1,
    ACTIONS(16308), 1,
      anon_sym_LPAREN,
    ACTIONS(16310), 1,
      anon_sym_DOLLAR,
    ACTIONS(16312), 1,
      anon_sym_AT,
    STATE(7679), 1,
      sym__importable,
    STATE(7686), 1,
      sym_scoped_identifier,
    STATE(7693), 1,
      sym_identifier,
    STATE(8081), 1,
      sym_import_alias,
    STATE(8082), 2,
      sym_import_path,
      sym__exportable,
    STATE(8633), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11439), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8062), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13432), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13452), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [133293] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16304), 1,
      sym__word_identifier,
    ACTIONS(16306), 1,
      aux_sym_import_path_token1,
    ACTIONS(16308), 1,
      anon_sym_LPAREN,
    ACTIONS(16310), 1,
      anon_sym_DOLLAR,
    ACTIONS(16312), 1,
      anon_sym_AT,
    STATE(7679), 1,
      sym__importable,
    STATE(7686), 1,
      sym_scoped_identifier,
    STATE(7693), 1,
      sym_identifier,
    STATE(8081), 1,
      sym_import_alias,
    STATE(8082), 2,
      sym_import_path,
      sym__exportable,
    STATE(8648), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11440), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8062), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13432), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13452), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [133364] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11357), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11441), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11355), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133411] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16316), 1,
      aux_sym_import_path_token1,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16320), 1,
      anon_sym_DOLLAR,
    ACTIONS(16322), 1,
      anon_sym_AT,
    STATE(10953), 1,
      sym__importable,
    STATE(10954), 1,
      sym_scoped_identifier,
    STATE(10955), 1,
      sym_identifier,
    STATE(11323), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10689), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11442), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [133482] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11375), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11443), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11373), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133529] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11271), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11444), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11269), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133576] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11281), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11445), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11279), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133623] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11379), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11446), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11377), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133670] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11311), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11447), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11309), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133717] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11319), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11448), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11317), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133764] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11261), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11449), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11259), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133811] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11361), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11450), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11359), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133858] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16316), 1,
      aux_sym_import_path_token1,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16320), 1,
      anon_sym_DOLLAR,
    ACTIONS(16322), 1,
      anon_sym_AT,
    STATE(10953), 1,
      sym__importable,
    STATE(10954), 1,
      sym_scoped_identifier,
    STATE(10955), 1,
      sym_identifier,
    STATE(11323), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10779), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11451), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [133929] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11383), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11452), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11381), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [133976] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11409), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11453), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11407), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134023] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11387), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11454), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11385), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134070] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11455), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134121] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11401), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11456), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11399), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134168] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11405), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11457), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11403), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134215] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11458), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134266] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16324), 1,
      sym__immediate_string_start,
    ACTIONS(16326), 1,
      sym__immediate_command_start,
    STATE(11459), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134317] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10064), 1,
      sym_identifier,
    STATE(11460), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [134368] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16328), 1,
      sym__word_identifier,
    ACTIONS(16330), 1,
      aux_sym_import_path_token1,
    ACTIONS(16332), 1,
      anon_sym_LPAREN,
    ACTIONS(16334), 1,
      anon_sym_DOLLAR,
    ACTIONS(16336), 1,
      anon_sym_AT,
    STATE(7045), 1,
      sym__importable,
    STATE(7046), 1,
      sym_scoped_identifier,
    STATE(7047), 1,
      sym_identifier,
    STATE(7519), 1,
      sym_import_alias,
    STATE(7520), 2,
      sym_import_path,
      sym__exportable,
    STATE(8478), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11461), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7337), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13752), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13772), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [134439] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16328), 1,
      sym__word_identifier,
    ACTIONS(16330), 1,
      aux_sym_import_path_token1,
    ACTIONS(16332), 1,
      anon_sym_LPAREN,
    ACTIONS(16334), 1,
      anon_sym_DOLLAR,
    ACTIONS(16336), 1,
      anon_sym_AT,
    STATE(7045), 1,
      sym__importable,
    STATE(7046), 1,
      sym_scoped_identifier,
    STATE(7047), 1,
      sym_identifier,
    STATE(7519), 1,
      sym_import_alias,
    STATE(7520), 2,
      sym_import_path,
      sym__exportable,
    STATE(8479), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11462), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7337), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13752), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13772), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [134510] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11463), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134557] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(12054), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11464), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12052), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134604] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11257), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11465), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11255), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134651] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11413), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11466), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11411), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134698] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11467), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134749] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11468), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134800] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11469), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134851] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16338), 1,
      anon_sym_DOT,
    ACTIONS(10539), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11470), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134908] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11471), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [134959] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11035), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11472), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11033), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135006] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11473), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 24,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [135053] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11528), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11474), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11526), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135100] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11519), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11475), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11517), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135147] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11458), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11476), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11456), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135194] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16340), 1,
      sym__word_identifier,
    ACTIONS(16342), 1,
      aux_sym_import_path_token1,
    ACTIONS(16344), 1,
      anon_sym_LPAREN,
    ACTIONS(16346), 1,
      anon_sym_DOLLAR,
    ACTIONS(16348), 1,
      anon_sym_AT,
    STATE(8788), 1,
      sym__importable,
    STATE(8789), 1,
      sym_scoped_identifier,
    STATE(8794), 1,
      sym_identifier,
    STATE(9016), 1,
      sym_import_alias,
    STATE(9017), 2,
      sym_import_path,
      sym__exportable,
    STATE(9168), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11477), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9142), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14342), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14362), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [135265] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11285), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11478), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11283), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135312] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16340), 1,
      sym__word_identifier,
    ACTIONS(16342), 1,
      aux_sym_import_path_token1,
    ACTIONS(16344), 1,
      anon_sym_LPAREN,
    ACTIONS(16346), 1,
      anon_sym_DOLLAR,
    ACTIONS(16348), 1,
      anon_sym_AT,
    STATE(8788), 1,
      sym__importable,
    STATE(8789), 1,
      sym_scoped_identifier,
    STATE(8794), 1,
      sym_identifier,
    STATE(9016), 1,
      sym_import_alias,
    STATE(9017), 2,
      sym_import_path,
      sym__exportable,
    STATE(9169), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11479), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9142), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14342), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14362), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [135383] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16324), 1,
      sym__immediate_string_start,
    ACTIONS(16326), 1,
      sym__immediate_command_start,
    STATE(11480), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [135434] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16350), 1,
      sym__immediate_string_start,
    ACTIONS(16352), 1,
      sym__immediate_command_start,
    STATE(11481), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135485] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11041), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11482), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11039), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135532] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11565), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11483), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11563), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135579] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11045), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11484), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11043), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135626] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11485), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135673] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11569), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11486), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11567), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135720] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11118), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11487), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11116), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135767] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11293), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11488), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11291), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135814] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11501), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11489), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11499), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135861] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11573), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11490), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11571), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135908] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11307), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11491), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11305), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [135955] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16350), 1,
      sym__immediate_string_start,
    ACTIONS(16352), 1,
      sym__immediate_command_start,
    STATE(11492), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136006] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11122), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11493), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11120), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136053] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11494), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136100] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16354), 1,
      sym__word_identifier,
    ACTIONS(16356), 1,
      aux_sym_import_path_token1,
    ACTIONS(16358), 1,
      anon_sym_LPAREN,
    ACTIONS(16360), 1,
      anon_sym_DOLLAR,
    ACTIONS(16362), 1,
      anon_sym_AT,
    STATE(6752), 1,
      sym__importable,
    STATE(6759), 1,
      sym_scoped_identifier,
    STATE(6760), 1,
      sym_identifier,
    STATE(7398), 1,
      sym_import_alias,
    STATE(7419), 2,
      sym_import_path,
      sym__exportable,
    STATE(8444), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11495), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7811), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14388), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14408), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [136171] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16354), 1,
      sym__word_identifier,
    ACTIONS(16356), 1,
      aux_sym_import_path_token1,
    ACTIONS(16358), 1,
      anon_sym_LPAREN,
    ACTIONS(16360), 1,
      anon_sym_DOLLAR,
    ACTIONS(16362), 1,
      anon_sym_AT,
    STATE(6752), 1,
      sym__importable,
    STATE(6759), 1,
      sym_scoped_identifier,
    STATE(6760), 1,
      sym_identifier,
    STATE(7398), 1,
      sym_import_alias,
    STATE(7419), 2,
      sym_import_path,
      sym__exportable,
    STATE(8446), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11496), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7811), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14388), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14408), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [136242] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16364), 1,
      sym__immediate_string_start,
    ACTIONS(16366), 1,
      sym__immediate_command_start,
    STATE(11497), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136293] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11199), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11498), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11197), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136340] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16368), 1,
      sym__word_identifier,
    ACTIONS(16370), 1,
      aux_sym_import_path_token1,
    ACTIONS(16372), 1,
      anon_sym_LPAREN,
    ACTIONS(16374), 1,
      anon_sym_DOLLAR,
    ACTIONS(16376), 1,
      anon_sym_AT,
    STATE(6583), 1,
      sym__importable,
    STATE(6584), 1,
      sym_scoped_identifier,
    STATE(6588), 1,
      sym_identifier,
    STATE(6967), 1,
      sym_import_alias,
    STATE(6969), 2,
      sym_import_path,
      sym__exportable,
    STATE(7355), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11499), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7086), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14854), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14874), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [136411] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16378), 1,
      sym__word_identifier,
    ACTIONS(16380), 1,
      aux_sym_import_path_token1,
    ACTIONS(16382), 1,
      anon_sym_LPAREN,
    ACTIONS(16384), 1,
      anon_sym_DOLLAR,
    ACTIONS(16386), 1,
      anon_sym_AT,
    STATE(6701), 1,
      sym__importable,
    STATE(6702), 1,
      sym_scoped_identifier,
    STATE(6703), 1,
      sym_identifier,
    STATE(7620), 1,
      sym_import_alias,
    STATE(7621), 2,
      sym_import_path,
      sym__exportable,
    STATE(8069), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11500), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7703), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14538), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14558), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [136482] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16364), 1,
      sym__immediate_string_start,
    ACTIONS(16366), 1,
      sym__immediate_command_start,
    STATE(11501), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136533] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11253), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11502), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11251), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136580] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16378), 1,
      sym__word_identifier,
    ACTIONS(16380), 1,
      aux_sym_import_path_token1,
    ACTIONS(16382), 1,
      anon_sym_LPAREN,
    ACTIONS(16384), 1,
      anon_sym_DOLLAR,
    ACTIONS(16386), 1,
      anon_sym_AT,
    STATE(6701), 1,
      sym__importable,
    STATE(6702), 1,
      sym_scoped_identifier,
    STATE(6703), 1,
      sym_identifier,
    STATE(7620), 1,
      sym_import_alias,
    STATE(7621), 2,
      sym_import_path,
      sym__exportable,
    STATE(8071), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11503), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7703), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14538), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14558), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [136651] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16364), 1,
      sym__immediate_string_start,
    ACTIONS(16366), 1,
      sym__immediate_command_start,
    STATE(11504), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136702] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16368), 1,
      sym__word_identifier,
    ACTIONS(16370), 1,
      aux_sym_import_path_token1,
    ACTIONS(16372), 1,
      anon_sym_LPAREN,
    ACTIONS(16374), 1,
      anon_sym_DOLLAR,
    ACTIONS(16376), 1,
      anon_sym_AT,
    STATE(6583), 1,
      sym__importable,
    STATE(6584), 1,
      sym_scoped_identifier,
    STATE(6588), 1,
      sym_identifier,
    STATE(6967), 1,
      sym_import_alias,
    STATE(6969), 2,
      sym_import_path,
      sym__exportable,
    STATE(7359), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11505), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7086), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14854), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14874), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [136773] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11515), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11506), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11513), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136820] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11213), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11507), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11211), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136867] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16364), 1,
      sym__immediate_string_start,
    ACTIONS(16366), 1,
      sym__immediate_command_start,
    STATE(11508), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [136918] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16388), 1,
      sym__immediate_string_start,
    ACTIONS(16390), 1,
      sym__immediate_command_start,
    STATE(11509), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [136969] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16394), 1,
      aux_sym_import_path_token1,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16398), 1,
      anon_sym_DOLLAR,
    ACTIONS(16400), 1,
      anon_sym_AT,
    STATE(12015), 1,
      sym__importable,
    STATE(12025), 1,
      sym_scoped_identifier,
    STATE(12026), 1,
      sym_identifier,
    STATE(12602), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11488), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11510), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [137040] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16402), 1,
      sym__word_identifier,
    STATE(11869), 1,
      sym_identifier,
    STATE(11511), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137091] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16402), 1,
      sym__word_identifier,
    STATE(11904), 1,
      sym_identifier,
    STATE(11512), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137142] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16338), 1,
      anon_sym_DOT,
    ACTIONS(10525), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11513), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137199] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11532), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11514), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11530), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137246] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16402), 1,
      sym__word_identifier,
    STATE(11769), 1,
      sym_identifier,
    STATE(11515), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137297] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16402), 1,
      sym__word_identifier,
    STATE(11952), 1,
      sym_identifier,
    STATE(11516), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 12,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 18,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137348] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(12050), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11517), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12048), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137395] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16388), 1,
      sym__immediate_string_start,
    ACTIONS(16390), 1,
      sym__immediate_command_start,
    STATE(11518), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137446] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(11519), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137497] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11520), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137544] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(11521), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137595] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16404), 1,
      sym__immediate_string_start,
    ACTIONS(16406), 1,
      sym__immediate_command_start,
    STATE(11522), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137646] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16408), 1,
      sym__immediate_string_start,
    ACTIONS(16410), 1,
      sym__immediate_command_start,
    STATE(11523), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137697] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(11524), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137748] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11536), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11525), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11534), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137795] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16412), 1,
      sym__immediate_string_start,
    ACTIONS(16414), 1,
      sym__immediate_command_start,
    STATE(11526), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 22,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137846] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16412), 1,
      sym__immediate_string_start,
    ACTIONS(16414), 1,
      sym__immediate_command_start,
    STATE(11527), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 22,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [137897] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16404), 1,
      sym__immediate_string_start,
    ACTIONS(16406), 1,
      sym__immediate_command_start,
    STATE(11528), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137948] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16408), 1,
      sym__immediate_string_start,
    ACTIONS(16410), 1,
      sym__immediate_command_start,
    STATE(11529), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [137999] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16416), 1,
      sym__immediate_string_start,
    ACTIONS(16418), 1,
      sym__immediate_command_start,
    STATE(11530), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138050] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16416), 1,
      sym__immediate_string_start,
    ACTIONS(16418), 1,
      sym__immediate_command_start,
    STATE(11531), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138101] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16420), 1,
      aux_sym_import_path_token1,
    ACTIONS(16422), 1,
      anon_sym_DOLLAR,
    ACTIONS(16424), 1,
      anon_sym_AT,
    STATE(12323), 1,
      sym__importable,
    STATE(12367), 1,
      sym_scoped_identifier,
    STATE(12368), 1,
      sym_identifier,
    STATE(12597), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11488), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11532), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [138172] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16420), 1,
      aux_sym_import_path_token1,
    ACTIONS(16422), 1,
      anon_sym_DOLLAR,
    ACTIONS(16424), 1,
      anon_sym_AT,
    STATE(12323), 1,
      sym__importable,
    STATE(12367), 1,
      sym_scoped_identifier,
    STATE(12368), 1,
      sym_identifier,
    STATE(12597), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11491), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11533), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [138243] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    ACTIONS(16426), 1,
      anon_sym_DOT,
    STATE(11534), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10525), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138300] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    ACTIONS(16426), 1,
      anon_sym_DOT,
    STATE(11535), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10539), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138357] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16324), 1,
      sym__immediate_string_start,
    ACTIONS(16326), 1,
      sym__immediate_command_start,
    STATE(11536), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138408] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16428), 1,
      aux_sym_import_path_token1,
    ACTIONS(16430), 1,
      anon_sym_DOLLAR,
    ACTIONS(16432), 1,
      anon_sym_AT,
    STATE(12325), 1,
      sym__importable,
    STATE(12326), 1,
      sym_scoped_identifier,
    STATE(12327), 1,
      sym_identifier,
    STATE(12605), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10689), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11537), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [138479] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16428), 1,
      aux_sym_import_path_token1,
    ACTIONS(16430), 1,
      anon_sym_DOLLAR,
    ACTIONS(16432), 1,
      anon_sym_AT,
    STATE(12325), 1,
      sym__importable,
    STATE(12326), 1,
      sym_scoped_identifier,
    STATE(12327), 1,
      sym_identifier,
    STATE(12605), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10779), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11538), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [138550] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11539), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138597] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11926), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11540), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11924), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138644] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11943), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11541), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11941), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138691] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11550), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11542), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11548), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138738] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16434), 1,
      anon_sym_do,
    STATE(11824), 1,
      sym_do_clause,
    STATE(11543), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9680), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9684), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138789] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11554), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11544), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11552), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138836] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11545), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138887] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11546), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [138938] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16324), 1,
      sym__immediate_string_start,
    ACTIONS(16326), 1,
      sym__immediate_command_start,
    STATE(11547), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [138989] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16434), 1,
      anon_sym_do,
    STATE(11746), 1,
      sym_do_clause,
    STATE(11548), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139040] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11549), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [139091] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16438), 1,
      aux_sym_import_path_token1,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(16442), 1,
      anon_sym_DOLLAR,
    ACTIONS(16444), 1,
      anon_sym_AT,
    STATE(11676), 1,
      sym__importable,
    STATE(11681), 1,
      sym_identifier,
    STATE(11745), 1,
      sym_scoped_identifier,
    STATE(11954), 1,
      sym_import_alias,
    STATE(11550), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11975), 2,
      sym_import_path,
      sym__exportable,
    STATE(12012), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11986), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14144), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139162] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16438), 1,
      aux_sym_import_path_token1,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(16442), 1,
      anon_sym_DOLLAR,
    ACTIONS(16444), 1,
      anon_sym_AT,
    STATE(11676), 1,
      sym__importable,
    STATE(11681), 1,
      sym_identifier,
    STATE(11745), 1,
      sym_scoped_identifier,
    STATE(11954), 1,
      sym_import_alias,
    STATE(11551), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11975), 2,
      sym_import_path,
      sym__exportable,
    STATE(12056), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11986), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14144), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139233] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11552), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [139284] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16434), 1,
      anon_sym_do,
    STATE(11877), 1,
      sym_do_clause,
    STATE(11553), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9696), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9700), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139335] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16446), 1,
      aux_sym_import_path_token1,
    ACTIONS(16448), 1,
      anon_sym_DOLLAR,
    ACTIONS(16450), 1,
      anon_sym_AT,
    STATE(11962), 1,
      sym__importable,
    STATE(11993), 1,
      sym_scoped_identifier,
    STATE(11994), 1,
      sym_identifier,
    STATE(12351), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11488), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11554), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139406] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16446), 1,
      aux_sym_import_path_token1,
    ACTIONS(16448), 1,
      anon_sym_DOLLAR,
    ACTIONS(16450), 1,
      anon_sym_AT,
    STATE(11962), 1,
      sym__importable,
    STATE(11993), 1,
      sym_scoped_identifier,
    STATE(11994), 1,
      sym_identifier,
    STATE(12351), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11491), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11555), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139477] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10042), 1,
      sym_identifier,
    STATE(11556), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [139528] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11557), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10850), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [139575] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16452), 1,
      aux_sym_import_path_token1,
    ACTIONS(16454), 1,
      anon_sym_DOLLAR,
    ACTIONS(16456), 1,
      anon_sym_AT,
    STATE(13115), 1,
      sym__importable,
    STATE(13116), 1,
      sym_scoped_identifier,
    STATE(13117), 1,
      sym_identifier,
    STATE(13404), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10689), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11558), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139646] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16452), 1,
      aux_sym_import_path_token1,
    ACTIONS(16454), 1,
      anon_sym_DOLLAR,
    ACTIONS(16456), 1,
      anon_sym_AT,
    STATE(13115), 1,
      sym__importable,
    STATE(13116), 1,
      sym_scoped_identifier,
    STATE(13117), 1,
      sym_identifier,
    STATE(13404), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10779), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11559), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139717] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11560), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [139764] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16458), 1,
      aux_sym_import_path_token1,
    ACTIONS(16460), 1,
      anon_sym_DOLLAR,
    ACTIONS(16462), 1,
      anon_sym_AT,
    STATE(11732), 1,
      sym__importable,
    STATE(11741), 1,
      sym_scoped_identifier,
    STATE(11742), 1,
      sym_identifier,
    STATE(11967), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11488), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11561), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139835] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16458), 1,
      aux_sym_import_path_token1,
    ACTIONS(16460), 1,
      anon_sym_DOLLAR,
    ACTIONS(16462), 1,
      anon_sym_AT,
    STATE(11732), 1,
      sym__importable,
    STATE(11741), 1,
      sym_scoped_identifier,
    STATE(11742), 1,
      sym_identifier,
    STATE(11967), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11491), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11562), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [139906] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11563), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [139953] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16464), 1,
      sym__word_identifier,
    ACTIONS(16466), 1,
      aux_sym_import_path_token1,
    ACTIONS(16468), 1,
      anon_sym_LPAREN,
    ACTIONS(16470), 1,
      anon_sym_DOLLAR,
    ACTIONS(16472), 1,
      anon_sym_AT,
    STATE(6592), 1,
      sym__importable,
    STATE(6603), 1,
      sym_scoped_identifier,
    STATE(6615), 1,
      sym_identifier,
    STATE(6709), 1,
      sym_import_alias,
    STATE(6710), 2,
      sym_import_path,
      sym__exportable,
    STATE(7423), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11564), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6890), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14422), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14442), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140024] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16474), 1,
      aux_sym_import_path_token1,
    ACTIONS(16476), 1,
      anon_sym_DOLLAR,
    ACTIONS(16478), 1,
      anon_sym_AT,
    STATE(11733), 1,
      sym__importable,
    STATE(11734), 1,
      sym_scoped_identifier,
    STATE(11735), 1,
      sym_identifier,
    STATE(11973), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10689), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11565), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140095] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16474), 1,
      aux_sym_import_path_token1,
    ACTIONS(16476), 1,
      anon_sym_DOLLAR,
    ACTIONS(16478), 1,
      anon_sym_AT,
    STATE(11733), 1,
      sym__importable,
    STATE(11734), 1,
      sym_scoped_identifier,
    STATE(11735), 1,
      sym_identifier,
    STATE(11973), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(10779), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11566), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140166] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11567), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [140213] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16464), 1,
      sym__word_identifier,
    ACTIONS(16466), 1,
      aux_sym_import_path_token1,
    ACTIONS(16468), 1,
      anon_sym_LPAREN,
    ACTIONS(16470), 1,
      anon_sym_DOLLAR,
    ACTIONS(16472), 1,
      anon_sym_AT,
    STATE(6592), 1,
      sym__importable,
    STATE(6603), 1,
      sym_scoped_identifier,
    STATE(6615), 1,
      sym_identifier,
    STATE(6709), 1,
      sym_import_alias,
    STATE(6710), 2,
      sym_import_path,
      sym__exportable,
    STATE(7459), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11568), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6890), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14422), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14442), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140284] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16480), 1,
      aux_sym_import_path_token1,
    ACTIONS(16482), 1,
      anon_sym_DOLLAR,
    ACTIONS(16484), 1,
      anon_sym_AT,
    STATE(11985), 1,
      sym__importable,
    STATE(12001), 1,
      sym_scoped_identifier,
    STATE(12002), 1,
      sym_identifier,
    STATE(12361), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11488), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11569), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140355] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16480), 1,
      aux_sym_import_path_token1,
    ACTIONS(16482), 1,
      anon_sym_DOLLAR,
    ACTIONS(16484), 1,
      anon_sym_AT,
    STATE(11985), 1,
      sym__importable,
    STATE(12001), 1,
      sym_scoped_identifier,
    STATE(12002), 1,
      sym_identifier,
    STATE(12361), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11491), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11570), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140426] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16434), 1,
      anon_sym_do,
    STATE(11896), 1,
      sym_do_clause,
    STATE(11571), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140477] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15297), 1,
      sym__word_identifier,
    STATE(10110), 1,
      sym_identifier,
    STATE(11572), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 17,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [140528] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16486), 1,
      aux_sym_import_path_token1,
    ACTIONS(16488), 1,
      anon_sym_DOLLAR,
    ACTIONS(16490), 1,
      anon_sym_AT,
    STATE(11988), 1,
      sym__importable,
    STATE(12005), 1,
      sym_scoped_identifier,
    STATE(12006), 1,
      sym_identifier,
    STATE(12364), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11488), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11573), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140599] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16486), 1,
      aux_sym_import_path_token1,
    ACTIONS(16488), 1,
      anon_sym_DOLLAR,
    ACTIONS(16490), 1,
      anon_sym_AT,
    STATE(11988), 1,
      sym__importable,
    STATE(12005), 1,
      sym_scoped_identifier,
    STATE(12006), 1,
      sym_identifier,
    STATE(12364), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11491), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11574), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [140670] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    STATE(11575), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 3,
      sym__immediate_paren,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(3071), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [140717] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11576), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10978), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [140764] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11666), 1,
      sym_identifier,
    STATE(11577), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [140815] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10525), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16492), 1,
      anon_sym_DOT,
    STATE(11578), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [140872] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10539), 1,
      aux_sym__terminator_token1,
    ACTIONS(16234), 1,
      anon_sym_SQUOTE,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    ACTIONS(16240), 1,
      sym__immediate_bracket,
    ACTIONS(16242), 1,
      sym__immediate_brace,
    ACTIONS(16492), 1,
      anon_sym_DOT,
    STATE(11579), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [140929] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11667), 1,
      sym_identifier,
    STATE(11580), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [140980] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11673), 1,
      sym_identifier,
    STATE(11581), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141031] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16264), 1,
      sym__word_identifier,
    STATE(11674), 1,
      sym_identifier,
    STATE(11582), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141082] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11900), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11583), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11898), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141129] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11175), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11584), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11173), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141176] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11474), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11585), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11472), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141223] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(16494), 1,
      aux_sym_float_literal_token2,
    STATE(11586), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141272] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11225), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11587), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11223), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141319] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16394), 1,
      aux_sym_import_path_token1,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16398), 1,
      anon_sym_DOLLAR,
    ACTIONS(16400), 1,
      anon_sym_AT,
    STATE(12015), 1,
      sym__importable,
    STATE(12025), 1,
      sym_scoped_identifier,
    STATE(12026), 1,
      sym_identifier,
    STATE(12602), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11491), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11588), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [141390] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16496), 1,
      sym__word_identifier,
    ACTIONS(16498), 1,
      aux_sym_import_path_token1,
    ACTIONS(16500), 1,
      anon_sym_LPAREN,
    ACTIONS(16502), 1,
      anon_sym_DOLLAR,
    ACTIONS(16504), 1,
      anon_sym_AT,
    STATE(6866), 1,
      sym__importable,
    STATE(6867), 1,
      sym_scoped_identifier,
    STATE(6868), 1,
      sym_identifier,
    STATE(7470), 1,
      sym_import_alias,
    STATE(7473), 2,
      sym_import_path,
      sym__exportable,
    STATE(8278), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11589), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7388), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14072), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14092), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [141461] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16496), 1,
      sym__word_identifier,
    ACTIONS(16498), 1,
      aux_sym_import_path_token1,
    ACTIONS(16500), 1,
      anon_sym_LPAREN,
    ACTIONS(16502), 1,
      anon_sym_DOLLAR,
    ACTIONS(16504), 1,
      anon_sym_AT,
    STATE(6866), 1,
      sym__importable,
    STATE(6867), 1,
      sym_scoped_identifier,
    STATE(6868), 1,
      sym_identifier,
    STATE(7470), 1,
      sym_import_alias,
    STATE(7473), 2,
      sym_import_path,
      sym__exportable,
    STATE(8279), 2,
      sym__import_list,
      sym_selected_import,
    STATE(11590), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7388), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14072), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14092), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [141532] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11591), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141583] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11592), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141634] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11593), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141685] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11561), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11594), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11559), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141732] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11967), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11595), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11965), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141779] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11971), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11596), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11969), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141826] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11171), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11597), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11169), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [141873] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(11598), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_if,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [141924] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(11599), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [141974] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    ACTIONS(16494), 1,
      aux_sym_float_literal_token2,
    STATE(11600), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142022] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16506), 1,
      sym__immediate_string_start,
    ACTIONS(16508), 1,
      sym__immediate_command_start,
    STATE(11601), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142072] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16510), 1,
      sym__immediate_string_start,
    ACTIONS(16512), 1,
      sym__immediate_command_start,
    STATE(11602), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 21,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [142122] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16514), 1,
      anon_sym_COMMA,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16518), 1,
      anon_sym_RPAREN,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16524), 1,
      anon_sym_SEMI,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14483), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14486), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15471), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11603), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [142220] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16560), 1,
      anon_sym_COMMA,
    ACTIONS(16562), 1,
      anon_sym_RPAREN,
    ACTIONS(16564), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14841), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14842), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15367), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11604), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [142318] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10118), 1,
      aux_sym__terminator_token1,
    STATE(11605), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10116), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142364] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16316), 1,
      aux_sym_import_path_token1,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16320), 1,
      anon_sym_DOLLAR,
    ACTIONS(16322), 1,
      anon_sym_AT,
    STATE(10845), 1,
      sym__import_list,
    STATE(10954), 1,
      sym_scoped_identifier,
    STATE(10955), 1,
      sym_identifier,
    STATE(11038), 1,
      sym__importable,
    STATE(11323), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11606), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [142434] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16368), 1,
      sym__word_identifier,
    ACTIONS(16370), 1,
      aux_sym_import_path_token1,
    ACTIONS(16372), 1,
      anon_sym_LPAREN,
    ACTIONS(16374), 1,
      anon_sym_DOLLAR,
    ACTIONS(16376), 1,
      anon_sym_AT,
    STATE(6584), 1,
      sym_scoped_identifier,
    STATE(6588), 1,
      sym_identifier,
    STATE(6601), 1,
      sym__importable,
    STATE(6967), 1,
      sym_import_alias,
    STATE(7244), 1,
      sym__import_list,
    STATE(6969), 2,
      sym_import_path,
      sym__exportable,
    STATE(11607), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7086), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14854), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14874), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [142504] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16566), 1,
      anon_sym_COMMA,
    ACTIONS(16568), 1,
      anon_sym_RPAREN,
    ACTIONS(16570), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14936), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14937), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16140), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11608), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [142602] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11609), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142652] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11610), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142702] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9960), 1,
      aux_sym__terminator_token1,
    STATE(11611), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9958), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142748] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11612), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142798] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11613), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [142848] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11614), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9828), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9830), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [142894] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16394), 1,
      aux_sym_import_path_token1,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16398), 1,
      anon_sym_DOLLAR,
    ACTIONS(16400), 1,
      anon_sym_AT,
    STATE(11584), 1,
      sym__import_list,
    STATE(12025), 1,
      sym_scoped_identifier,
    STATE(12026), 1,
      sym_identifier,
    STATE(12332), 1,
      sym__importable,
    STATE(12602), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11615), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [142964] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11616), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9832), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9834), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [143010] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9984), 1,
      aux_sym__terminator_token1,
    STATE(11617), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143056] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16572), 1,
      anon_sym_COMMA,
    ACTIONS(16574), 1,
      anon_sym_as,
    STATE(11927), 1,
      aux_sym__import_list_repeat1,
    STATE(11618), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143108] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16576), 1,
      aux_sym_float_literal_token2,
    STATE(11619), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [143156] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9988), 1,
      aux_sym__terminator_token1,
    STATE(11620), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143202] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10002), 1,
      aux_sym__terminator_token1,
    STATE(11621), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143248] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10006), 1,
      aux_sym__terminator_token1,
    STATE(11622), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143294] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10154), 1,
      aux_sym__terminator_token1,
    STATE(11623), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10152), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143340] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10012), 1,
      aux_sym__terminator_token1,
    STATE(11624), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143386] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16506), 1,
      sym__immediate_string_start,
    ACTIONS(16508), 1,
      sym__immediate_command_start,
    STATE(11625), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143436] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10016), 1,
      aux_sym__terminator_token1,
    STATE(11626), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143482] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10020), 1,
      aux_sym__terminator_token1,
    STATE(11627), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143528] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9918), 1,
      aux_sym__terminator_token1,
    STATE(11628), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143574] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16510), 1,
      sym__immediate_string_start,
    ACTIONS(16512), 1,
      sym__immediate_command_start,
    STATE(11629), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 21,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [143624] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9922), 1,
      aux_sym__terminator_token1,
    STATE(11630), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143670] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16578), 1,
      anon_sym_COMMA,
    ACTIONS(16580), 1,
      anon_sym_RPAREN,
    ACTIONS(16582), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14416), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14457), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16091), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11631), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [143768] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9728), 1,
      aux_sym__terminator_token1,
    STATE(11632), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143814] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9992), 1,
      aux_sym__terminator_token1,
    STATE(11633), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [143860] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16584), 1,
      anon_sym_COMMA,
    ACTIONS(16586), 1,
      anon_sym_RPAREN,
    ACTIONS(16588), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14290), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14405), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    STATE(17028), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11634), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [143958] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11635), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9738), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9806), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [144004] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10731), 1,
      aux_sym__terminator_token1,
    ACTIONS(16590), 1,
      anon_sym_DOT,
    STATE(11636), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144052] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9996), 1,
      aux_sym__terminator_token1,
    STATE(11637), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144098] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16592), 1,
      sym__immediate_string_start,
    ACTIONS(16594), 1,
      sym__immediate_command_start,
    STATE(11638), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144148] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9754), 1,
      aux_sym__terminator_token1,
    STATE(11639), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144194] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16596), 1,
      anon_sym_COMMA,
    ACTIONS(16598), 1,
      anon_sym_RPAREN,
    ACTIONS(16600), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14994), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15035), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16235), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11640), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [144292] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9762), 1,
      aux_sym__terminator_token1,
    STATE(11641), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144338] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10030), 1,
      aux_sym__terminator_token1,
    STATE(11642), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144384] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10034), 1,
      aux_sym__terminator_token1,
    STATE(11643), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144430] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    ACTIONS(9782), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11644), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144480] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16592), 1,
      sym__immediate_string_start,
    ACTIONS(16594), 1,
      sym__immediate_command_start,
    STATE(11645), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144530] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10038), 1,
      aux_sym__terminator_token1,
    STATE(11646), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144576] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16602), 1,
      sym__immediate_string_start,
    ACTIONS(16604), 1,
      sym__immediate_command_start,
    STATE(11647), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144626] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    ACTIONS(9786), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11648), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144676] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16602), 1,
      sym__immediate_string_start,
    ACTIONS(16604), 1,
      sym__immediate_command_start,
    STATE(11649), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144726] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10042), 1,
      aux_sym__terminator_token1,
    STATE(11650), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144772] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16606), 1,
      sym__immediate_string_start,
    ACTIONS(16608), 1,
      sym__immediate_command_start,
    STATE(11651), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144822] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16606), 1,
      sym__immediate_string_start,
    ACTIONS(16608), 1,
      sym__immediate_command_start,
    STATE(11652), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [144872] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16610), 1,
      anon_sym_COMMA,
    ACTIONS(16612), 1,
      anon_sym_RPAREN,
    ACTIONS(16614), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14967), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14968), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    STATE(16390), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11653), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [144970] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9740), 1,
      aux_sym__terminator_token1,
    STATE(11654), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145016] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9746), 1,
      aux_sym__terminator_token1,
    STATE(11655), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145062] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16420), 1,
      aux_sym_import_path_token1,
    ACTIONS(16422), 1,
      anon_sym_DOLLAR,
    ACTIONS(16424), 1,
      anon_sym_AT,
    STATE(11584), 1,
      sym__import_list,
    STATE(12220), 1,
      sym__importable,
    STATE(12367), 1,
      sym_scoped_identifier,
    STATE(12368), 1,
      sym_identifier,
    STATE(12597), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11656), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [145132] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11657), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9752), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9808), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [145178] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11658), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9810), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9812), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [145224] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9792), 1,
      aux_sym__terminator_token1,
    STATE(11659), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145270] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10046), 1,
      aux_sym__terminator_token1,
    STATE(11660), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145316] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10050), 1,
      aux_sym__terminator_token1,
    STATE(11661), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145362] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10054), 1,
      aux_sym__terminator_token1,
    STATE(11662), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145408] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10058), 1,
      aux_sym__terminator_token1,
    STATE(11663), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145454] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9900), 1,
      aux_sym__terminator_token1,
    STATE(11664), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145500] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16378), 1,
      sym__word_identifier,
    ACTIONS(16380), 1,
      aux_sym_import_path_token1,
    ACTIONS(16382), 1,
      anon_sym_LPAREN,
    ACTIONS(16384), 1,
      anon_sym_DOLLAR,
    ACTIONS(16386), 1,
      anon_sym_AT,
    STATE(6702), 1,
      sym_scoped_identifier,
    STATE(6703), 1,
      sym_identifier,
    STATE(6770), 1,
      sym__importable,
    STATE(7620), 1,
      sym_import_alias,
    STATE(8171), 1,
      sym__import_list,
    STATE(7621), 2,
      sym_import_path,
      sym__exportable,
    STATE(11665), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7703), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14538), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14558), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [145570] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10062), 1,
      aux_sym__terminator_token1,
    STATE(11666), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145616] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10066), 1,
      aux_sym__terminator_token1,
    STATE(11667), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145662] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10070), 1,
      aux_sym__terminator_token1,
    STATE(11668), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145708] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(16590), 1,
      anon_sym_DOT,
    STATE(11669), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145756] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11670), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9814), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9816), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [145802] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16428), 1,
      aux_sym_import_path_token1,
    ACTIONS(16430), 1,
      anon_sym_DOLLAR,
    ACTIONS(16432), 1,
      anon_sym_AT,
    STATE(10845), 1,
      sym__import_list,
    STATE(12326), 1,
      sym_scoped_identifier,
    STATE(12327), 1,
      sym_identifier,
    STATE(12329), 1,
      sym__importable,
    STATE(12605), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11671), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [145872] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10074), 1,
      aux_sym__terminator_token1,
    STATE(11672), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145918] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10078), 1,
      aux_sym__terminator_token1,
    STATE(11673), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [145964] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10082), 1,
      aux_sym__terminator_token1,
    STATE(11674), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [146010] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11675), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9836), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9838), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [146056] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16572), 1,
      anon_sym_COMMA,
    ACTIONS(16574), 1,
      anon_sym_as,
    ACTIONS(16616), 1,
      anon_sym_COLON,
    STATE(11927), 1,
      aux_sym__import_list_repeat1,
    STATE(11676), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [146110] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16354), 1,
      sym__word_identifier,
    ACTIONS(16356), 1,
      aux_sym_import_path_token1,
    ACTIONS(16358), 1,
      anon_sym_LPAREN,
    ACTIONS(16360), 1,
      anon_sym_DOLLAR,
    ACTIONS(16362), 1,
      anon_sym_AT,
    STATE(6759), 1,
      sym_scoped_identifier,
    STATE(6760), 1,
      sym_identifier,
    STATE(6880), 1,
      sym__importable,
    STATE(7398), 1,
      sym_import_alias,
    STATE(8019), 1,
      sym__import_list,
    STATE(7419), 2,
      sym_import_path,
      sym__exportable,
    STATE(11677), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7811), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14388), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14408), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [146180] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16618), 1,
      anon_sym_COMMA,
    ACTIONS(16620), 1,
      anon_sym_RPAREN,
    ACTIONS(16622), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14434), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14992), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    STATE(16876), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11678), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [146278] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16304), 1,
      sym__word_identifier,
    ACTIONS(16306), 1,
      aux_sym_import_path_token1,
    ACTIONS(16308), 1,
      anon_sym_LPAREN,
    ACTIONS(16310), 1,
      anon_sym_DOLLAR,
    ACTIONS(16312), 1,
      anon_sym_AT,
    STATE(7258), 1,
      sym__importable,
    STATE(7686), 1,
      sym_scoped_identifier,
    STATE(7693), 1,
      sym_identifier,
    STATE(8081), 1,
      sym_import_alias,
    STATE(8924), 1,
      sym__import_list,
    STATE(8082), 2,
      sym_import_path,
      sym__exportable,
    STATE(11679), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8062), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13432), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13452), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [146348] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16328), 1,
      sym__word_identifier,
    ACTIONS(16330), 1,
      aux_sym_import_path_token1,
    ACTIONS(16332), 1,
      anon_sym_LPAREN,
    ACTIONS(16334), 1,
      anon_sym_DOLLAR,
    ACTIONS(16336), 1,
      anon_sym_AT,
    STATE(7046), 1,
      sym_scoped_identifier,
    STATE(7047), 1,
      sym_identifier,
    STATE(7188), 1,
      sym__importable,
    STATE(7519), 1,
      sym_import_alias,
    STATE(7979), 1,
      sym__import_list,
    STATE(7520), 2,
      sym_import_path,
      sym__exportable,
    STATE(11680), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7337), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13752), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13772), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [146418] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 1,
      aux_sym__terminator_token1,
    ACTIONS(16590), 1,
      anon_sym_DOT,
    STATE(11681), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [146466] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11682), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9818), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9820), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [146512] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16294), 1,
      sym__word_identifier,
    ACTIONS(16296), 1,
      aux_sym_import_path_token1,
    ACTIONS(16298), 1,
      anon_sym_LPAREN,
    ACTIONS(16300), 1,
      anon_sym_DOLLAR,
    ACTIONS(16302), 1,
      anon_sym_AT,
    STATE(6897), 1,
      sym_scoped_identifier,
    STATE(6898), 1,
      sym_identifier,
    STATE(6919), 1,
      sym__importable,
    STATE(7719), 1,
      sym_import_alias,
    STATE(8229), 1,
      sym__import_list,
    STATE(7720), 2,
      sym_import_path,
      sym__exportable,
    STATE(11683), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7895), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14178), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14198), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [146582] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11684), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9790), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9822), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [146628] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11685), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9726), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9756), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [146674] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11686), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9824), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9826), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [146720] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16624), 1,
      anon_sym_COMMA,
    ACTIONS(16626), 1,
      anon_sym_RPAREN,
    ACTIONS(16628), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14280), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14694), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    STATE(16754), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11687), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [146818] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11688), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [146868] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16446), 1,
      aux_sym_import_path_token1,
    ACTIONS(16448), 1,
      anon_sym_DOLLAR,
    ACTIONS(16450), 1,
      anon_sym_AT,
    STATE(11584), 1,
      sym__import_list,
    STATE(11839), 1,
      sym__importable,
    STATE(11993), 1,
      sym_scoped_identifier,
    STATE(11994), 1,
      sym_identifier,
    STATE(12351), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11689), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [146938] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10579), 1,
      aux_sym__terminator_token1,
    STATE(11690), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10577), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [146984] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15480), 1,
      anon_sym_SQUOTE,
    ACTIONS(15484), 1,
      sym__immediate_paren,
    ACTIONS(15486), 1,
      sym__immediate_bracket,
    ACTIONS(15488), 1,
      sym__immediate_brace,
    ACTIONS(16630), 1,
      anon_sym_DOT,
    STATE(11691), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10328), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [147040] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16632), 1,
      anon_sym_COMMA,
    ACTIONS(16634), 1,
      anon_sym_RPAREN,
    ACTIONS(16636), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14324), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14328), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16191), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11692), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [147138] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16452), 1,
      aux_sym_import_path_token1,
    ACTIONS(16454), 1,
      anon_sym_DOLLAR,
    ACTIONS(16456), 1,
      anon_sym_AT,
    STATE(10845), 1,
      sym__import_list,
    STATE(13116), 1,
      sym_scoped_identifier,
    STATE(13117), 1,
      sym_identifier,
    STATE(13119), 1,
      sym__importable,
    STATE(13404), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11693), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [147208] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16638), 1,
      sym__immediate_string_start,
    ACTIONS(16640), 1,
      sym__immediate_command_start,
    ACTIONS(9716), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11694), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [147258] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16458), 1,
      aux_sym_import_path_token1,
    ACTIONS(16460), 1,
      anon_sym_DOLLAR,
    ACTIONS(16462), 1,
      anon_sym_AT,
    STATE(11584), 1,
      sym__import_list,
    STATE(11696), 1,
      sym__importable,
    STATE(11741), 1,
      sym_scoped_identifier,
    STATE(11742), 1,
      sym_identifier,
    STATE(11967), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11695), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [147328] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16642), 1,
      anon_sym_COMMA,
    ACTIONS(16644), 1,
      anon_sym_as,
    STATE(11858), 1,
      aux_sym__import_list_repeat1,
    STATE(11696), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [147380] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11697), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9744), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9758), 23,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_do,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [147426] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16474), 1,
      aux_sym_import_path_token1,
    ACTIONS(16476), 1,
      anon_sym_DOLLAR,
    ACTIONS(16478), 1,
      anon_sym_AT,
    STATE(10845), 1,
      sym__import_list,
    STATE(11734), 1,
      sym_scoped_identifier,
    STATE(11735), 1,
      sym_identifier,
    STATE(11737), 1,
      sym__importable,
    STATE(11973), 1,
      sym_import_alias,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11698), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [147496] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    STATE(11699), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [147542] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16646), 1,
      anon_sym_COMMA,
    ACTIONS(16648), 1,
      anon_sym_RPAREN,
    ACTIONS(16650), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14281), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15104), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16202), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11700), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [147640] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16580), 1,
      anon_sym_RPAREN,
    ACTIONS(16582), 1,
      anon_sym_SEMI,
    ACTIONS(16652), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14416), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14431), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(16091), 1,
      sym__comprehension_clause,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11701), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [147738] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16480), 1,
      aux_sym_import_path_token1,
    ACTIONS(16482), 1,
      anon_sym_DOLLAR,
    ACTIONS(16484), 1,
      anon_sym_AT,
    STATE(11584), 1,
      sym__import_list,
    STATE(11882), 1,
      sym__importable,
    STATE(12001), 1,
      sym_scoped_identifier,
    STATE(12002), 1,
      sym_identifier,
    STATE(12361), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11702), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [147808] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    ACTIONS(9798), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11703), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [147858] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    ACTIONS(9802), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11704), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [147908] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11705), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [147958] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    STATE(11706), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148004] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11707), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148054] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16486), 1,
      aux_sym_import_path_token1,
    ACTIONS(16488), 1,
      anon_sym_DOLLAR,
    ACTIONS(16490), 1,
      anon_sym_AT,
    STATE(11584), 1,
      sym__import_list,
    STATE(11892), 1,
      sym__importable,
    STATE(12005), 1,
      sym_scoped_identifier,
    STATE(12006), 1,
      sym_identifier,
    STATE(12364), 1,
      sym_import_alias,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11708), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [148124] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11709), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148174] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11710), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148224] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16438), 1,
      aux_sym_import_path_token1,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(16442), 1,
      anon_sym_DOLLAR,
    ACTIONS(16444), 1,
      anon_sym_AT,
    STATE(11618), 1,
      sym__importable,
    STATE(11681), 1,
      sym_identifier,
    STATE(11745), 1,
      sym_scoped_identifier,
    STATE(11954), 1,
      sym_import_alias,
    STATE(12276), 1,
      sym__import_list,
    STATE(11711), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11975), 2,
      sym_import_path,
      sym__exportable,
    STATE(11986), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14144), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [148294] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16582), 1,
      anon_sym_SEMI,
    ACTIONS(16654), 1,
      anon_sym_COMMA,
    ACTIONS(16656), 1,
      anon_sym_RPAREN,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14416), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14431), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15472), 1,
      sym__comprehension_clause,
    STATE(16198), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11712), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [148392] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(11713), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [148442] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(11714), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [148492] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9734), 1,
      aux_sym__terminator_token1,
    STATE(11715), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148538] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(3075), 1,
      aux_sym__terminator_token1,
    STATE(11716), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148584] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16340), 1,
      sym__word_identifier,
    ACTIONS(16342), 1,
      aux_sym_import_path_token1,
    ACTIONS(16344), 1,
      anon_sym_LPAREN,
    ACTIONS(16346), 1,
      anon_sym_DOLLAR,
    ACTIONS(16348), 1,
      anon_sym_AT,
    STATE(8639), 1,
      sym__importable,
    STATE(8789), 1,
      sym_scoped_identifier,
    STATE(8794), 1,
      sym_identifier,
    STATE(9016), 1,
      sym_import_alias,
    STATE(9225), 1,
      sym__import_list,
    STATE(9017), 2,
      sym_import_path,
      sym__exportable,
    STATE(11717), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9142), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14342), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14362), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [148654] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11718), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148704] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11719), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148754] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11720), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148804] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11721), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148854] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10136), 1,
      aux_sym__terminator_token1,
    STATE(11722), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148900] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9914), 1,
      aux_sym__terminator_token1,
    STATE(11723), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148946] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9928), 1,
      aux_sym__terminator_token1,
    STATE(11724), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9926), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [148992] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11725), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149042] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(11726), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [149092] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11727), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149142] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16464), 1,
      sym__word_identifier,
    ACTIONS(16466), 1,
      aux_sym_import_path_token1,
    ACTIONS(16468), 1,
      anon_sym_LPAREN,
    ACTIONS(16470), 1,
      anon_sym_DOLLAR,
    ACTIONS(16472), 1,
      anon_sym_AT,
    STATE(6603), 1,
      sym_scoped_identifier,
    STATE(6615), 1,
      sym_identifier,
    STATE(6654), 1,
      sym__importable,
    STATE(6709), 1,
      sym_import_alias,
    STATE(7869), 1,
      sym__import_list,
    STATE(6710), 2,
      sym_import_path,
      sym__exportable,
    STATE(11728), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6890), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14422), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14442), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [149212] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11729), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149262] = 31,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16658), 1,
      anon_sym_COMMA,
    ACTIONS(16660), 1,
      anon_sym_RPAREN,
    ACTIONS(16662), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(14571), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14853), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16255), 1,
      aux_sym_argument_list_repeat1,
    STATE(16935), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11730), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [149360] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16638), 1,
      sym__immediate_string_start,
    ACTIONS(16640), 1,
      sym__immediate_command_start,
    ACTIONS(9664), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11731), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149410] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16642), 1,
      anon_sym_COMMA,
    ACTIONS(16644), 1,
      anon_sym_as,
    ACTIONS(16664), 1,
      anon_sym_COLON,
    STATE(11858), 1,
      aux_sym__import_list_repeat1,
    STATE(11732), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149464] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16666), 1,
      anon_sym_COMMA,
    ACTIONS(16668), 1,
      anon_sym_as,
    ACTIONS(16670), 1,
      anon_sym_COLON,
    STATE(11980), 1,
      aux_sym__import_list_repeat1,
    STATE(11733), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 6,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [149518] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16672), 1,
      anon_sym_DOT,
    STATE(11734), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10759), 23,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [149566] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16672), 1,
      anon_sym_DOT,
    STATE(11735), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10763), 23,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [149614] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16672), 1,
      anon_sym_DOT,
    STATE(11736), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10731), 23,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [149662] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16666), 1,
      anon_sym_COMMA,
    ACTIONS(16668), 1,
      anon_sym_as,
    STATE(11980), 1,
      aux_sym__import_list_repeat1,
    STATE(11737), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [149714] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9644), 1,
      aux_sym__terminator_token1,
    STATE(11738), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 30,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149760] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16496), 1,
      sym__word_identifier,
    ACTIONS(16498), 1,
      aux_sym_import_path_token1,
    ACTIONS(16500), 1,
      anon_sym_LPAREN,
    ACTIONS(16502), 1,
      anon_sym_DOLLAR,
    ACTIONS(16504), 1,
      anon_sym_AT,
    STATE(6867), 1,
      sym_scoped_identifier,
    STATE(6868), 1,
      sym_identifier,
    STATE(6895), 1,
      sym__importable,
    STATE(7470), 1,
      sym_import_alias,
    STATE(8334), 1,
      sym__import_list,
    STATE(7473), 2,
      sym_import_path,
      sym__exportable,
    STATE(11739), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7388), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14072), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14092), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [149830] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16672), 1,
      anon_sym_DOT,
    STATE(11740), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 23,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [149878] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 1,
      aux_sym__terminator_token1,
    ACTIONS(16674), 1,
      anon_sym_DOT,
    STATE(11741), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149926] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 1,
      aux_sym__terminator_token1,
    ACTIONS(16674), 1,
      anon_sym_DOT,
    STATE(11742), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [149974] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10731), 1,
      aux_sym__terminator_token1,
    ACTIONS(16674), 1,
      anon_sym_DOT,
    STATE(11743), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [150022] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(16674), 1,
      anon_sym_DOT,
    STATE(11744), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [150070] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 1,
      aux_sym__terminator_token1,
    ACTIONS(16590), 1,
      anon_sym_DOT,
    STATE(11745), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [150118] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11746), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10106), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10108), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [150163] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16420), 1,
      aux_sym_import_path_token1,
    ACTIONS(16422), 1,
      anon_sym_DOLLAR,
    ACTIONS(16424), 1,
      anon_sym_AT,
    STATE(11560), 1,
      sym_import_alias,
    STATE(12367), 1,
      sym_scoped_identifier,
    STATE(12368), 1,
      sym_identifier,
    STATE(12760), 1,
      sym__importable,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11747), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [150230] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16676), 1,
      anon_sym_COMMA,
    ACTIONS(16678), 1,
      anon_sym_RPAREN,
    ACTIONS(16680), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14643), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14644), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17772), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11748), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [150325] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6678), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16682), 1,
      anon_sym_COMMA,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17212), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11749), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [150420] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15301), 1,
      anon_sym_EQ,
    STATE(11750), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [150469] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16686), 1,
      anon_sym_COMMA,
    ACTIONS(16688), 1,
      anon_sym_RPAREN,
    ACTIONS(16690), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14850), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14854), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18043), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11751), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [150564] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11752), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [150609] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    STATE(11753), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [150656] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11754), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10928), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [150741] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10882), 1,
      aux_sym__terminator_token1,
    ACTIONS(16730), 1,
      anon_sym_COMMA,
    STATE(11757), 1,
      aux_sym_export_statement_repeat1,
    STATE(11755), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [150790] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6448), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(16732), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17480), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11756), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [150885] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 1,
      aux_sym__terminator_token1,
    ACTIONS(16734), 1,
      anon_sym_COMMA,
    STATE(11757), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [150932] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11758), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10966), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [151017] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(16574), 1,
      anon_sym_as,
    STATE(11759), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [151064] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(16737), 1,
      anon_sym_COMMA,
    STATE(11760), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [151111] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16378), 1,
      sym__word_identifier,
    ACTIONS(16380), 1,
      aux_sym_import_path_token1,
    ACTIONS(16382), 1,
      anon_sym_LPAREN,
    ACTIONS(16384), 1,
      anon_sym_DOLLAR,
    ACTIONS(16386), 1,
      anon_sym_AT,
    STATE(6702), 1,
      sym_scoped_identifier,
    STATE(6703), 1,
      sym_identifier,
    STATE(7510), 1,
      sym__importable,
    STATE(8169), 1,
      sym_import_alias,
    STATE(7621), 2,
      sym_import_path,
      sym__exportable,
    STATE(11761), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7703), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14538), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14558), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [151178] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16496), 1,
      sym__word_identifier,
    ACTIONS(16498), 1,
      aux_sym_import_path_token1,
    ACTIONS(16500), 1,
      anon_sym_LPAREN,
    ACTIONS(16502), 1,
      anon_sym_DOLLAR,
    ACTIONS(16504), 1,
      anon_sym_AT,
    STATE(6867), 1,
      sym_scoped_identifier,
    STATE(6868), 1,
      sym_identifier,
    STATE(7707), 1,
      sym__importable,
    STATE(8331), 1,
      sym_import_alias,
    STATE(7473), 2,
      sym_import_path,
      sym__exportable,
    STATE(11762), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7388), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14072), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14092), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [151245] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11763), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10970), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [151330] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6848), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(16740), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17393), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11764), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [151425] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16742), 1,
      anon_sym_COMMA,
    ACTIONS(16744), 1,
      anon_sym_RPAREN,
    ACTIONS(16746), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14416), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14431), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18212), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11765), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [151520] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    ACTIONS(9782), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11766), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [151569] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15287), 1,
      anon_sym_EQ,
    STATE(11767), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [151618] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11768), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9742), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9746), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [151663] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11769), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10076), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10078), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [151708] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16428), 1,
      aux_sym_import_path_token1,
    ACTIONS(16430), 1,
      anon_sym_DOLLAR,
    ACTIONS(16432), 1,
      anon_sym_AT,
    STATE(10768), 1,
      sym_import_alias,
    STATE(12326), 1,
      sym_scoped_identifier,
    STATE(12327), 1,
      sym_identifier,
    STATE(12614), 1,
      sym__importable,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11770), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [151775] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16748), 1,
      anon_sym_COMMA,
    ACTIONS(16750), 1,
      anon_sym_RPAREN,
    ACTIONS(16752), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14634), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14635), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17898), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11771), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [151870] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16754), 1,
      anon_sym_SQUOTE,
    ACTIONS(16756), 1,
      anon_sym_DOT,
    ACTIONS(16758), 1,
      sym__immediate_paren,
    ACTIONS(16760), 1,
      sym__immediate_bracket,
    ACTIONS(16762), 1,
      sym__immediate_brace,
    STATE(11772), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10322), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10328), 18,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [151925] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16764), 1,
      anon_sym_COMMA,
    ACTIONS(16766), 1,
      anon_sym_RPAREN,
    ACTIONS(16768), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14338), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14344), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17879), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11773), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152020] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6798), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(16770), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17089), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11774), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152115] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    STATE(11775), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [152160] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16772), 1,
      anon_sym_COMMA,
    ACTIONS(16774), 1,
      anon_sym_RPAREN,
    ACTIONS(16776), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14281), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(15104), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17967), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11776), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152255] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6422), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(16778), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17066), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11777), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152350] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16780), 1,
      anon_sym_COMMA,
    ACTIONS(16782), 1,
      anon_sym_RPAREN,
    ACTIONS(16784), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15063), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15064), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18217), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11778), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152445] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    STATE(11779), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [152492] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11780), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10052), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10054), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [152537] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16354), 1,
      sym__word_identifier,
    ACTIONS(16356), 1,
      aux_sym_import_path_token1,
    ACTIONS(16358), 1,
      anon_sym_LPAREN,
    ACTIONS(16360), 1,
      anon_sym_DOLLAR,
    ACTIONS(16362), 1,
      anon_sym_AT,
    STATE(6759), 1,
      sym_scoped_identifier,
    STATE(6760), 1,
      sym_identifier,
    STATE(7605), 1,
      sym__importable,
    STATE(8013), 1,
      sym_import_alias,
    STATE(7419), 2,
      sym_import_path,
      sym__exportable,
    STATE(11781), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7811), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14388), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14408), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [152604] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11782), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9958), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9960), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [152649] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11783), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9730), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9734), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [152694] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16328), 1,
      sym__word_identifier,
    ACTIONS(16330), 1,
      aux_sym_import_path_token1,
    ACTIONS(16332), 1,
      anon_sym_LPAREN,
    ACTIONS(16334), 1,
      anon_sym_DOLLAR,
    ACTIONS(16336), 1,
      anon_sym_AT,
    STATE(7046), 1,
      sym_scoped_identifier,
    STATE(7047), 1,
      sym_identifier,
    STATE(7858), 1,
      sym__importable,
    STATE(7973), 1,
      sym_import_alias,
    STATE(7520), 2,
      sym_import_path,
      sym__exportable,
    STATE(11784), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7337), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13752), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13772), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [152761] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11785), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10134), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10136), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [152806] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11786), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9982), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9984), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [152851] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16786), 1,
      anon_sym_COMMA,
    ACTIONS(16788), 1,
      anon_sym_RPAREN,
    ACTIONS(16790), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14359), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14381), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18116), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11787), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [152946] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11788), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9986), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9988), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [152991] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16316), 1,
      aux_sym_import_path_token1,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16320), 1,
      anon_sym_DOLLAR,
    ACTIONS(16322), 1,
      anon_sym_AT,
    STATE(10768), 1,
      sym_import_alias,
    STATE(10954), 1,
      sym_scoped_identifier,
    STATE(10955), 1,
      sym_identifier,
    STATE(11346), 1,
      sym__importable,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11789), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [153058] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16792), 1,
      anon_sym_COMMA,
    ACTIONS(16794), 1,
      anon_sym_RPAREN,
    ACTIONS(16796), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14313), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14315), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18005), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11790), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153153] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16798), 1,
      anon_sym_COMMA,
    ACTIONS(16800), 1,
      anon_sym_RPAREN,
    ACTIONS(16802), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14450), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14454), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18219), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11791), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153248] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11792), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10000), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10002), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [153293] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11793), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10004), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10006), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [153338] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(163), 1,
      anon_sym_DASH_GT,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15250), 1,
      anon_sym_EQ,
    STATE(11794), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [153387] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(16804), 1,
      anon_sym_DOT,
    STATE(11795), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [153434] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    ACTIONS(9798), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11796), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [153483] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11797), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9926), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9928), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [153528] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16806), 1,
      anon_sym_COMMA,
    ACTIONS(16808), 1,
      anon_sym_RPAREN,
    ACTIONS(16810), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14655), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14666), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18068), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11798), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153623] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16812), 1,
      anon_sym_COMMA,
    ACTIONS(16814), 1,
      anon_sym_RPAREN,
    ACTIONS(16816), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14790), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14975), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18055), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11799), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153718] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11800), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9954), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9956), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [153763] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16818), 1,
      anon_sym_COMMA,
    ACTIONS(16820), 1,
      anon_sym_RPAREN,
    ACTIONS(16822), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14712), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14713), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18101), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11801), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153858] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11802), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9962), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9964), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [153903] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16824), 1,
      anon_sym_COMMA,
    ACTIONS(16826), 1,
      anon_sym_RPAREN,
    ACTIONS(16828), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14777), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14783), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18123), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11803), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [153998] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16294), 1,
      sym__word_identifier,
    ACTIONS(16296), 1,
      aux_sym_import_path_token1,
    ACTIONS(16298), 1,
      anon_sym_LPAREN,
    ACTIONS(16300), 1,
      anon_sym_DOLLAR,
    ACTIONS(16302), 1,
      anon_sym_AT,
    STATE(6897), 1,
      sym_scoped_identifier,
    STATE(6898), 1,
      sym_identifier,
    STATE(7821), 1,
      sym__importable,
    STATE(8225), 1,
      sym_import_alias,
    STATE(7720), 2,
      sym_import_path,
      sym__exportable,
    STATE(11804), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7895), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14178), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14198), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [154065] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11805), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10010), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10012), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [154110] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16368), 1,
      sym__word_identifier,
    ACTIONS(16370), 1,
      aux_sym_import_path_token1,
    ACTIONS(16372), 1,
      anon_sym_LPAREN,
    ACTIONS(16374), 1,
      anon_sym_DOLLAR,
    ACTIONS(16376), 1,
      anon_sym_AT,
    STATE(6584), 1,
      sym_scoped_identifier,
    STATE(6588), 1,
      sym_identifier,
    STATE(6854), 1,
      sym__importable,
    STATE(7360), 1,
      sym_import_alias,
    STATE(6969), 2,
      sym_import_path,
      sym__exportable,
    STATE(11806), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7086), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14854), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14874), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [154177] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11807), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9706), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9708), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [154222] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16830), 1,
      sym__immediate_string_start,
    ACTIONS(16832), 1,
      sym__immediate_command_start,
    ACTIONS(9664), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11808), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [154271] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11809), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10014), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10016), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [154316] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16834), 1,
      anon_sym_COMMA,
    ACTIONS(16836), 1,
      anon_sym_RPAREN,
    ACTIONS(16838), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14540), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14543), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17842), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11810), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154411] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11811), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9710), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9712), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [154456] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(16840), 1,
      anon_sym_DOT,
    STATE(11812), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [154503] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16842), 1,
      anon_sym_COMMA,
    ACTIONS(16844), 1,
      anon_sym_RPAREN,
    ACTIONS(16846), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14880), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14881), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18152), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11813), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154598] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10910), 1,
      aux_sym__terminator_token1,
    STATE(11814), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10908), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [154643] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16848), 1,
      anon_sym_COMMA,
    ACTIONS(16850), 1,
      anon_sym_RPAREN,
    ACTIONS(16852), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14434), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14992), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17964), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11815), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154738] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6814), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(16854), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17334), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11816), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [154833] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11817), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10056), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10058), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [154878] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11818), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10018), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10020), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [154923] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16856), 1,
      anon_sym_COMMA,
    ACTIONS(16858), 1,
      anon_sym_RPAREN,
    ACTIONS(16860), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14729), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14730), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17768), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11819), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155018] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11820), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9916), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9918), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155063] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(11821), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155112] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(11822), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155161] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16862), 1,
      anon_sym_COMMA,
    STATE(11823), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [155208] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11824), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10102), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10104), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155253] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16865), 1,
      anon_sym_COMMA,
    ACTIONS(16867), 1,
      anon_sym_RPAREN,
    ACTIONS(16869), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15018), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15024), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18221), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11825), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155348] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16871), 1,
      sym__immediate_string_start,
    ACTIONS(16873), 1,
      sym__immediate_command_start,
    STATE(11826), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155397] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11827), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10044), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10046), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155442] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(11828), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155491] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    ACTIONS(9786), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11829), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [155540] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11830), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9920), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9922), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155585] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(11831), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 13,
      anon_sym_EQ,
      anon_sym_for,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155634] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11832), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10086), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10088), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155679] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11833), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9898), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9900), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [155724] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16875), 1,
      anon_sym_COMMA,
    ACTIONS(16877), 1,
      anon_sym_RPAREN,
    ACTIONS(16879), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14753), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14754), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17836), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11834), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155819] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16881), 1,
      anon_sym_COMMA,
    ACTIONS(16883), 1,
      anon_sym_RPAREN,
    ACTIONS(16885), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14930), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14933), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18111), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11835), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [155914] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16446), 1,
      aux_sym_import_path_token1,
    ACTIONS(16448), 1,
      anon_sym_DOLLAR,
    ACTIONS(16450), 1,
      anon_sym_AT,
    STATE(11560), 1,
      sym_import_alias,
    STATE(11993), 1,
      sym_scoped_identifier,
    STATE(11994), 1,
      sym_identifier,
    STATE(12284), 1,
      sym__importable,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11836), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [155981] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15160), 1,
      anon_sym_DASH_GT,
    STATE(11837), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [156028] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11838), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9912), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9914), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [156073] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16887), 1,
      anon_sym_COMMA,
    ACTIONS(16889), 1,
      anon_sym_as,
    STATE(12281), 1,
      aux_sym__import_list_repeat1,
    STATE(11839), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [156124] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    ACTIONS(16891), 1,
      anon_sym_DOT,
    STATE(11840), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10440), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10525), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [156179] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15578), 1,
      anon_sym_SQUOTE,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    ACTIONS(15584), 1,
      sym__immediate_bracket,
    ACTIONS(15586), 1,
      sym__immediate_brace,
    ACTIONS(16891), 1,
      anon_sym_DOT,
    STATE(11841), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10537), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10539), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [156234] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10811), 1,
      aux_sym__terminator_token1,
    ACTIONS(16730), 1,
      anon_sym_COMMA,
    STATE(11912), 1,
      aux_sym_export_statement_repeat1,
    STATE(11842), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [156283] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16893), 1,
      anon_sym_COMMA,
    ACTIONS(16895), 1,
      anon_sym_RPAREN,
    ACTIONS(16897), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14468), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14469), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18084), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11843), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156378] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11844), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [156423] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    STATE(11976), 1,
      aux_sym_open_tuple_repeat1,
    STATE(11845), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [156472] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16452), 1,
      aux_sym_import_path_token1,
    ACTIONS(16454), 1,
      anon_sym_DOLLAR,
    ACTIONS(16456), 1,
      anon_sym_AT,
    STATE(10768), 1,
      sym_import_alias,
    STATE(13116), 1,
      sym_scoped_identifier,
    STATE(13117), 1,
      sym_identifier,
    STATE(13413), 1,
      sym__importable,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11846), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [156539] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16899), 1,
      anon_sym_COMMA,
    ACTIONS(16901), 1,
      anon_sym_RPAREN,
    ACTIONS(16903), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15025), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15026), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18012), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11847), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156634] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16905), 1,
      anon_sym_COMMA,
    ACTIONS(16907), 1,
      anon_sym_RPAREN,
    ACTIONS(16909), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14974), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14977), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18010), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11848), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156729] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(11849), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [156778] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16911), 1,
      anon_sym_COMMA,
    ACTIONS(16913), 1,
      anon_sym_RPAREN,
    ACTIONS(16915), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14303), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14304), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17843), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11850), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [156873] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    STATE(11823), 1,
      aux_sym_open_tuple_repeat1,
    STATE(11851), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [156922] = 27,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    ACTIONS(16923), 1,
      aux_sym__terminator_token1,
    ACTIONS(16925), 1,
      aux_sym__terminator_token2,
    STATE(14263), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14918), 1,
      aux_sym__block_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11852), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16919), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [157011] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11853), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10048), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10050), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [157056] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15156), 1,
      anon_sym_DASH_GT,
    STATE(11854), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157103] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10878), 1,
      aux_sym__terminator_token1,
    ACTIONS(16927), 1,
      anon_sym_COMMA,
    STATE(11861), 1,
      aux_sym_export_statement_repeat1,
    STATE(11855), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157152] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10882), 1,
      aux_sym__terminator_token1,
    ACTIONS(16927), 1,
      anon_sym_COMMA,
    STATE(11861), 1,
      aux_sym_export_statement_repeat1,
    STATE(11856), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157201] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16458), 1,
      aux_sym_import_path_token1,
    ACTIONS(16460), 1,
      anon_sym_DOLLAR,
    ACTIONS(16462), 1,
      anon_sym_AT,
    STATE(11560), 1,
      sym_import_alias,
    STATE(11741), 1,
      sym_scoped_identifier,
    STATE(11742), 1,
      sym_identifier,
    STATE(11862), 1,
      sym__importable,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11857), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [157268] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10886), 1,
      aux_sym__terminator_token1,
    ACTIONS(16642), 1,
      anon_sym_COMMA,
    STATE(11863), 1,
      aux_sym__import_list_repeat1,
    STATE(11858), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157317] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16929), 1,
      anon_sym_COMMA,
    ACTIONS(16931), 1,
      anon_sym_RPAREN,
    ACTIONS(16933), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14667), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14681), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17929), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11859), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157412] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(163), 1,
      anon_sym_DASH_GT,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(11860), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157461] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 1,
      aux_sym__terminator_token1,
    ACTIONS(16935), 1,
      anon_sym_COMMA,
    STATE(11861), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157508] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(16644), 1,
      anon_sym_as,
    STATE(11862), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157555] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(16938), 1,
      anon_sym_COMMA,
    STATE(11863), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157602] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16941), 1,
      anon_sym_COMMA,
    ACTIONS(16943), 1,
      anon_sym_RPAREN,
    ACTIONS(16945), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14994), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15035), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17930), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11864), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157697] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11865), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10116), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10118), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [157742] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15156), 1,
      anon_sym_DASH_GT,
    STATE(11866), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [157789] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16947), 1,
      anon_sym_COMMA,
    ACTIONS(16949), 1,
      anon_sym_RPAREN,
    ACTIONS(16951), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14679), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14680), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17711), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11867), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157884] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16953), 1,
      anon_sym_COMMA,
    ACTIONS(16955), 1,
      anon_sym_RPAREN,
    ACTIONS(16957), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14803), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14804), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17823), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11868), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [157979] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11869), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10060), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10062), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [158024] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(16474), 1,
      aux_sym_import_path_token1,
    ACTIONS(16476), 1,
      anon_sym_DOLLAR,
    ACTIONS(16478), 1,
      anon_sym_AT,
    STATE(10768), 1,
      sym_import_alias,
    STATE(11734), 1,
      sym_scoped_identifier,
    STATE(11735), 1,
      sym_identifier,
    STATE(11982), 1,
      sym__importable,
    STATE(10602), 2,
      sym_import_path,
      sym__exportable,
    STATE(11870), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [158091] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6470), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(16959), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17626), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11871), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158186] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15150), 1,
      anon_sym_DASH_GT,
    ACTIONS(15301), 1,
      anon_sym_EQ,
    STATE(11872), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [158235] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11873), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9978), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9980), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [158280] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11874), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9724), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9728), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [158325] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16961), 1,
      anon_sym_COMMA,
    ACTIONS(16963), 1,
      anon_sym_RPAREN,
    ACTIONS(16965), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14519), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14522), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18039), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11875), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158420] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9664), 1,
      aux_sym__terminator_token1,
    ACTIONS(16967), 1,
      sym__immediate_string_start,
    ACTIONS(16969), 1,
      sym__immediate_command_start,
    STATE(11876), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [158469] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11877), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10122), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10124), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [158514] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16971), 1,
      anon_sym_COMMA,
    ACTIONS(16973), 1,
      anon_sym_RPAREN,
    ACTIONS(16975), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14330), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14331), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17955), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11878), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158609] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16480), 1,
      aux_sym_import_path_token1,
    ACTIONS(16482), 1,
      anon_sym_DOLLAR,
    ACTIONS(16484), 1,
      anon_sym_AT,
    STATE(11560), 1,
      sym_import_alias,
    STATE(12001), 1,
      sym_scoped_identifier,
    STATE(12002), 1,
      sym_identifier,
    STATE(12305), 1,
      sym__importable,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11879), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [158676] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16977), 1,
      anon_sym_COMMA,
    ACTIONS(16979), 1,
      anon_sym_RPAREN,
    ACTIONS(16981), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14287), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14457), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17900), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11880), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [158771] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9798), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11259), 1,
      sym_identifier,
    STATE(11881), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [158820] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16983), 1,
      anon_sym_COMMA,
    ACTIONS(16985), 1,
      anon_sym_as,
    STATE(12302), 1,
      aux_sym__import_list_repeat1,
    STATE(11882), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [158871] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11883), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9702), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9704), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [158916] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    ACTIONS(9802), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11884), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [158965] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16987), 1,
      anon_sym_COMMA,
    ACTIONS(16989), 1,
      anon_sym_RPAREN,
    ACTIONS(16991), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14686), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14917), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17937), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11885), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [159060] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16830), 1,
      sym__immediate_string_start,
    ACTIONS(16832), 1,
      sym__immediate_command_start,
    ACTIONS(9716), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(11886), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [159109] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10815), 1,
      aux_sym__terminator_token1,
    ACTIONS(16730), 1,
      anon_sym_COMMA,
    STATE(11755), 1,
      aux_sym_export_statement_repeat1,
    STATE(11887), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [159158] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9802), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11260), 1,
      sym_identifier,
    STATE(11888), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [159207] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16486), 1,
      aux_sym_import_path_token1,
    ACTIONS(16488), 1,
      anon_sym_DOLLAR,
    ACTIONS(16490), 1,
      anon_sym_AT,
    STATE(11560), 1,
      sym_import_alias,
    STATE(12005), 1,
      sym_scoped_identifier,
    STATE(12006), 1,
      sym_identifier,
    STATE(12318), 1,
      sym__importable,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11889), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [159274] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11890), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11020), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [159359] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17029), 1,
      anon_sym_COMMA,
    ACTIONS(17031), 1,
      anon_sym_RPAREN,
    ACTIONS(17033), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14892), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14896), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17788), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11891), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [159454] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(17035), 1,
      anon_sym_COMMA,
    ACTIONS(17037), 1,
      anon_sym_as,
    STATE(12315), 1,
      aux_sym__import_list_repeat1,
    STATE(11892), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [159505] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17039), 1,
      anon_sym_COMMA,
    ACTIONS(17041), 1,
      anon_sym_RPAREN,
    ACTIONS(17043), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14349), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14350), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17695), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11893), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [159600] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11894), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9990), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9992), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [159645] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11895), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10128), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10130), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [159690] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11896), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10138), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10140), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [159735] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11897), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9994), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9996), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [159780] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17045), 1,
      anon_sym_COMMA,
    ACTIONS(17047), 1,
      anon_sym_RPAREN,
    ACTIONS(17049), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14451), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14495), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17743), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11898), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [159875] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11899), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9750), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9754), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [159920] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17051), 1,
      anon_sym_COMMA,
    ACTIONS(17053), 1,
      anon_sym_RPAREN,
    ACTIONS(17055), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14369), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14370), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17932), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11900), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160015] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11901), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10928), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [160100] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11902), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10966), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [160185] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11903), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10970), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [160270] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11904), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10064), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10066), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [160315] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6530), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17057), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17254), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11905), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160410] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6504), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17059), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17332), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11906), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160505] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17061), 1,
      anon_sym_COMMA,
    ACTIONS(17063), 1,
      anon_sym_RPAREN,
    ACTIONS(17065), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14591), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14592), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18201), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11907), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160600] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11908), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(3075), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [160645] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16438), 1,
      aux_sym_import_path_token1,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(16442), 1,
      anon_sym_DOLLAR,
    ACTIONS(16444), 1,
      anon_sym_AT,
    STATE(11681), 1,
      sym_identifier,
    STATE(11745), 1,
      sym_scoped_identifier,
    STATE(11759), 1,
      sym__importable,
    STATE(12263), 1,
      sym_import_alias,
    STATE(11909), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11975), 2,
      sym_import_path,
      sym__exportable,
    STATE(11986), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14144), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [160712] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17067), 1,
      anon_sym_COMMA,
    ACTIONS(17069), 1,
      anon_sym_RPAREN,
    ACTIONS(17071), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14363), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14961), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17840), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11910), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160807] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17073), 1,
      anon_sym_COMMA,
    ACTIONS(17075), 1,
      anon_sym_RPAREN,
    ACTIONS(17077), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14571), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14853), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18134), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11911), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [160902] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10878), 1,
      aux_sym__terminator_token1,
    ACTIONS(16730), 1,
      anon_sym_COMMA,
    STATE(11757), 1,
      aux_sym_export_statement_repeat1,
    STATE(11912), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [160951] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17079), 1,
      anon_sym_COMMA,
    ACTIONS(17081), 1,
      anon_sym_RPAREN,
    ACTIONS(17083), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14967), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14968), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17818), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11913), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161046] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11914), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 7,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [161127] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11915), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10142), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10144), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [161172] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11916), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9760), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9762), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [161217] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11917), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10028), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10030), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [161262] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17085), 1,
      anon_sym_COMMA,
    ACTIONS(17087), 1,
      anon_sym_RPAREN,
    ACTIONS(17089), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14396), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14397), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18090), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11918), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161357] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11919), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10032), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10034), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [161402] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16340), 1,
      sym__word_identifier,
    ACTIONS(16342), 1,
      aux_sym_import_path_token1,
    ACTIONS(16344), 1,
      anon_sym_LPAREN,
    ACTIONS(16346), 1,
      anon_sym_DOLLAR,
    ACTIONS(16348), 1,
      anon_sym_AT,
    STATE(8789), 1,
      sym_scoped_identifier,
    STATE(8794), 1,
      sym_identifier,
    STATE(9101), 1,
      sym__importable,
    STATE(9222), 1,
      sym_import_alias,
    STATE(9017), 2,
      sym_import_path,
      sym__exportable,
    STATE(11920), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9142), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14342), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14362), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [161469] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11921), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10036), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10038), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [161514] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11922), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10040), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10042), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [161559] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17091), 1,
      anon_sym_COMMA,
    ACTIONS(17093), 1,
      anon_sym_RPAREN,
    ACTIONS(17095), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14704), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14706), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17951), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11923), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161654] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17097), 1,
      anon_sym_COMMA,
    ACTIONS(17099), 1,
      anon_sym_RPAREN,
    ACTIONS(17101), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14483), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14486), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18030), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11924), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161749] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(163), 1,
      anon_sym_DASH_GT,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15287), 1,
      anon_sym_EQ,
    STATE(11925), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [161798] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(3075), 2,
      sym__immediate_paren,
      aux_sym__terminator_token1,
    STATE(11926), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [161843] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10886), 1,
      aux_sym__terminator_token1,
    ACTIONS(16572), 1,
      anon_sym_COMMA,
    STATE(11760), 1,
      aux_sym__import_list_repeat1,
    STATE(11927), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [161892] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17103), 1,
      anon_sym_COMMA,
    ACTIONS(17105), 1,
      anon_sym_RPAREN,
    ACTIONS(17107), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14966), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14969), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17897), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11928), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [161987] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15160), 1,
      anon_sym_DASH_GT,
    STATE(11929), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [162034] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17109), 1,
      anon_sym_COMMA,
    ACTIONS(17111), 1,
      anon_sym_RPAREN,
    ACTIONS(17113), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14841), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14842), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18169), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11930), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [162129] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9782), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11253), 1,
      sym_identifier,
    STATE(11931), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [162178] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17115), 1,
      anon_sym_COMMA,
    ACTIONS(17117), 1,
      anon_sym_RPAREN,
    ACTIONS(17119), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14290), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14405), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18153), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11932), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [162273] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17121), 1,
      anon_sym_COMMA,
    ACTIONS(17123), 1,
      anon_sym_RPAREN,
    ACTIONS(17125), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14639), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14640), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17676), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11933), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [162368] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6500), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17127), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17253), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11934), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [162463] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11935), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10068), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10070), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [162508] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11936), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9736), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9740), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [162553] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11937), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 7,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [162634] = 27,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    ACTIONS(17131), 1,
      aux_sym__terminator_token1,
    ACTIONS(17133), 1,
      aux_sym__terminator_token2,
    STATE(14255), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15078), 1,
      aux_sym__block_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11938), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16919), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [162723] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15150), 1,
      anon_sym_DASH_GT,
    ACTIONS(15330), 1,
      anon_sym_EQ,
    STATE(11939), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [162772] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9716), 1,
      aux_sym__terminator_token1,
    ACTIONS(16967), 1,
      sym__immediate_string_start,
    ACTIONS(16969), 1,
      sym__immediate_command_start,
    STATE(11940), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [162821] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17135), 1,
      anon_sym_COMMA,
    ACTIONS(17137), 1,
      anon_sym_RPAREN,
    ACTIONS(17139), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14424), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14425), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17681), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11941), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [162916] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15330), 1,
      anon_sym_EQ,
    STATE(11942), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [162965] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17141), 1,
      anon_sym_COMMA,
    ACTIONS(17143), 1,
      anon_sym_RPAREN,
    ACTIONS(17145), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14594), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14595), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18156), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11943), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163060] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6600), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17147), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16668), 1,
      sym__comprehension_clause,
    STATE(16670), 1,
      aux_sym_argument_list_repeat1,
    STATE(17081), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11944), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163155] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15150), 1,
      anon_sym_DASH_GT,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(11945), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [163204] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17149), 1,
      anon_sym_COMMA,
    ACTIONS(17151), 1,
      anon_sym_RPAREN,
    ACTIONS(17153), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14280), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14694), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17702), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11946), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163299] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(11947), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [163348] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17155), 1,
      anon_sym_COMMA,
    ACTIONS(17157), 1,
      anon_sym_RPAREN,
    ACTIONS(17159), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15090), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15094), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18214), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11948), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163443] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17161), 1,
      anon_sym_COMMA,
    ACTIONS(17163), 1,
      anon_sym_RPAREN,
    ACTIONS(17165), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14736), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(15000), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18195), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11949), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163538] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17167), 1,
      anon_sym_COMMA,
    ACTIONS(17169), 1,
      anon_sym_RPAREN,
    ACTIONS(17171), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14464), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14465), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17787), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11950), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163633] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16464), 1,
      sym__word_identifier,
    ACTIONS(16466), 1,
      aux_sym_import_path_token1,
    ACTIONS(16468), 1,
      anon_sym_LPAREN,
    ACTIONS(16470), 1,
      anon_sym_DOLLAR,
    ACTIONS(16472), 1,
      anon_sym_AT,
    STATE(6603), 1,
      sym_scoped_identifier,
    STATE(6615), 1,
      sym_identifier,
    STATE(7065), 1,
      sym__importable,
    STATE(7592), 1,
      sym_import_alias,
    STATE(6710), 2,
      sym_import_path,
      sym__exportable,
    STATE(11951), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6890), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14422), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14442), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [163700] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11952), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10080), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10082), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [163745] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6380), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17173), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17081), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11953), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163840] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16572), 1,
      anon_sym_COMMA,
    STATE(11927), 1,
      aux_sym__import_list_repeat1,
    STATE(11954), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [163889] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17175), 1,
      anon_sym_COMMA,
    ACTIONS(17177), 1,
      anon_sym_RPAREN,
    ACTIONS(17179), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14380), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(14916), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18093), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11955), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [163984] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17181), 1,
      anon_sym_COMMA,
    ACTIONS(17183), 1,
      anon_sym_RPAREN,
    ACTIONS(17185), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14324), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14328), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17945), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11956), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [164079] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17187), 1,
      anon_sym_COMMA,
    ACTIONS(17189), 1,
      anon_sym_RPAREN,
    ACTIONS(17191), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14936), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14937), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18194), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11957), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [164174] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6480), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17193), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17354), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11958), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [164269] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11959), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10152), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10154), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [164314] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17195), 1,
      anon_sym_COMMA,
    ACTIONS(17197), 1,
      anon_sym_RPAREN,
    ACTIONS(17199), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14502), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14503), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17917), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11960), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [164409] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11961), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9642), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9644), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [164454] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16887), 1,
      anon_sym_COMMA,
    ACTIONS(16889), 1,
      anon_sym_as,
    ACTIONS(17201), 1,
      anon_sym_COLON,
    STATE(12281), 1,
      aux_sym__import_list_repeat1,
    STATE(11962), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 25,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [164507] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16304), 1,
      sym__word_identifier,
    ACTIONS(16306), 1,
      aux_sym_import_path_token1,
    ACTIONS(16308), 1,
      anon_sym_LPAREN,
    ACTIONS(16310), 1,
      anon_sym_DOLLAR,
    ACTIONS(16312), 1,
      anon_sym_AT,
    STATE(7686), 1,
      sym_scoped_identifier,
    STATE(7693), 1,
      sym_identifier,
    STATE(8372), 1,
      sym__importable,
    STATE(8901), 1,
      sym_import_alias,
    STATE(8082), 2,
      sym_import_path,
      sym__exportable,
    STATE(11963), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8062), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(13432), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13452), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [164574] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17203), 1,
      anon_sym_COMMA,
    ACTIONS(17205), 1,
      anon_sym_RPAREN,
    ACTIONS(17207), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14885), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14893), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17973), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11964), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [164669] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10811), 1,
      aux_sym__terminator_token1,
    ACTIONS(16927), 1,
      anon_sym_COMMA,
    STATE(11855), 1,
      aux_sym_export_statement_repeat1,
    STATE(11965), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [164718] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10815), 1,
      aux_sym__terminator_token1,
    ACTIONS(16927), 1,
      anon_sym_COMMA,
    STATE(11856), 1,
      aux_sym_export_statement_repeat1,
    STATE(11966), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [164767] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16642), 1,
      anon_sym_COMMA,
    STATE(11858), 1,
      aux_sym__import_list_repeat1,
    STATE(11967), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [164816] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15156), 1,
      anon_sym_DASH_GT,
    STATE(11968), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [164863] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17209), 1,
      anon_sym_COMMA,
    ACTIONS(17211), 1,
      anon_sym_RPAREN,
    ACTIONS(17213), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14539), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14541), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17993), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11969), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [164958] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11970), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10072), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10074), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165003] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17215), 1,
      anon_sym_COMMA,
    STATE(11977), 1,
      aux_sym_export_statement_repeat1,
    STATE(11971), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10811), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165052] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17215), 1,
      anon_sym_COMMA,
    STATE(11978), 1,
      aux_sym_export_statement_repeat1,
    STATE(11972), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10815), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165101] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16666), 1,
      anon_sym_COMMA,
    STATE(11980), 1,
      aux_sym__import_list_repeat1,
    STATE(11973), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165150] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9786), 1,
      aux_sym__terminator_token1,
    ACTIONS(16262), 1,
      sym__word_identifier,
    STATE(11256), 1,
      sym_identifier,
    STATE(11974), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [165199] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 1,
      aux_sym__terminator_token1,
    STATE(11975), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [165244] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17217), 1,
      anon_sym_COMMA,
    STATE(11976), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 27,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [165291] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17215), 1,
      anon_sym_COMMA,
    STATE(11981), 1,
      aux_sym_export_statement_repeat1,
    STATE(11977), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10878), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165340] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17215), 1,
      anon_sym_COMMA,
    STATE(11981), 1,
      aux_sym_export_statement_repeat1,
    STATE(11978), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10882), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165389] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    STATE(11979), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [165436] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16666), 1,
      anon_sym_COMMA,
    STATE(11983), 1,
      aux_sym__import_list_repeat1,
    STATE(11980), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10886), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165485] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17220), 1,
      anon_sym_COMMA,
    STATE(11981), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10855), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165532] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16668), 1,
      anon_sym_as,
    STATE(11982), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 22,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165579] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17223), 1,
      anon_sym_COMMA,
    STATE(11983), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 21,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [165626] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6742), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17226), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16396), 1,
      sym__comprehension_clause,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17551), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11984), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [165721] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16983), 1,
      anon_sym_COMMA,
    ACTIONS(16985), 1,
      anon_sym_as,
    ACTIONS(17228), 1,
      anon_sym_COLON,
    STATE(12302), 1,
      aux_sym__import_list_repeat1,
    STATE(11985), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [165774] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 1,
      aux_sym__terminator_token1,
    STATE(11986), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 29,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [165819] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17230), 1,
      anon_sym_COMMA,
    ACTIONS(17232), 1,
      anon_sym_RPAREN,
    ACTIONS(17234), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14565), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14566), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18076), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11987), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [165914] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(17035), 1,
      anon_sym_COMMA,
    ACTIONS(17037), 1,
      anon_sym_as,
    ACTIONS(17236), 1,
      anon_sym_COLON,
    STATE(12315), 1,
      aux_sym__import_list_repeat1,
    STATE(11988), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [165967] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15250), 1,
      anon_sym_EQ,
    ACTIONS(15258), 1,
      sym__immediate_paren,
    STATE(11989), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166016] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17238), 1,
      anon_sym_DOT,
    STATE(11990), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 22,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [166063] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11991), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11020), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [166148] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(11992), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9788), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9792), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [166193] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 1,
      aux_sym__terminator_token1,
    ACTIONS(17240), 1,
      anon_sym_DOT,
    STATE(11993), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166240] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 1,
      aux_sym__terminator_token1,
    ACTIONS(17240), 1,
      anon_sym_DOT,
    STATE(11994), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166287] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10731), 1,
      aux_sym__terminator_token1,
    ACTIONS(17240), 1,
      anon_sym_DOT,
    STATE(11995), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166334] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17240), 1,
      anon_sym_DOT,
    STATE(11996), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166381] = 30,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17242), 1,
      anon_sym_COMMA,
    ACTIONS(17244), 1,
      anon_sym_RPAREN,
    ACTIONS(17246), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14560), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(14569), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17977), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(11997), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [166476] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16394), 1,
      aux_sym_import_path_token1,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(16398), 1,
      anon_sym_DOLLAR,
    ACTIONS(16400), 1,
      anon_sym_AT,
    STATE(11560), 1,
      sym_import_alias,
    STATE(12025), 1,
      sym_scoped_identifier,
    STATE(12026), 1,
      sym_identifier,
    STATE(12619), 1,
      sym__importable,
    STATE(11401), 2,
      sym_import_path,
      sym__exportable,
    STATE(11998), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 3,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_operator,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [166543] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15160), 1,
      anon_sym_DASH_GT,
    STATE(11999), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166590] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17248), 1,
      anon_sym_DOT,
    STATE(12000), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166637] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 1,
      aux_sym__terminator_token1,
    ACTIONS(17250), 1,
      anon_sym_DOT,
    STATE(12001), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166684] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 1,
      aux_sym__terminator_token1,
    ACTIONS(17250), 1,
      anon_sym_DOT,
    STATE(12002), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166731] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10731), 1,
      aux_sym__terminator_token1,
    ACTIONS(17250), 1,
      anon_sym_DOT,
    STATE(12003), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166778] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16871), 1,
      sym__immediate_string_start,
    ACTIONS(16873), 1,
      sym__immediate_command_start,
    STATE(12004), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [166827] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 1,
      aux_sym__terminator_token1,
    ACTIONS(16804), 1,
      anon_sym_DOT,
    STATE(12005), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166874] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 1,
      aux_sym__terminator_token1,
    ACTIONS(16804), 1,
      anon_sym_DOT,
    STATE(12006), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166921] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10731), 1,
      aux_sym__terminator_token1,
    ACTIONS(16804), 1,
      anon_sym_DOT,
    STATE(12007), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [166968] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17250), 1,
      anon_sym_DOT,
    STATE(12008), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167015] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(12009), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(101), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(189), 22,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_in,
      anon_sym_u2208,
      anon_sym_SQUOTE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [167060] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15196), 1,
      anon_sym_DASH_GT,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(12010), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167108] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12011), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [167188] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11293), 1,
      aux_sym__terminator_token1,
    STATE(12012), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11291), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167232] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15208), 1,
      anon_sym_DASH_GT,
    STATE(12013), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167278] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15204), 1,
      anon_sym_DASH_GT,
    STATE(12014), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [167324] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17252), 1,
      anon_sym_COMMA,
    ACTIONS(17254), 1,
      anon_sym_as,
    ACTIONS(17256), 1,
      anon_sym_COLON,
    STATE(12435), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(10755), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12015), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 23,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167376] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(12016), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [167424] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6842), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17258), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16048), 1,
      sym__comprehension_clause,
    STATE(16139), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12017), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [167516] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11261), 1,
      aux_sym__terminator_token1,
    STATE(12018), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11259), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167560] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15164), 1,
      anon_sym_DASH_GT,
    STATE(12019), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [167606] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7888), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17260), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16155), 1,
      sym__comprehension_clause,
    STATE(16156), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12020), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [167698] = 27,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17298), 1,
      aux_sym__terminator_token1,
    ACTIONS(17300), 1,
      aux_sym__terminator_token2,
    STATE(14277), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15176), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_end,
      anon_sym_catch,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12021), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [167786] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15330), 1,
      anon_sym_EQ,
    STATE(12022), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167832] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11926), 1,
      aux_sym__terminator_token1,
    STATE(12023), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11924), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167876] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11943), 1,
      aux_sym__terminator_token1,
    STATE(12024), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11941), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167920] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17302), 1,
      anon_sym_DOT,
    ACTIONS(10759), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12025), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [167966] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17302), 1,
      anon_sym_DOT,
    ACTIONS(10763), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12026), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168012] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11967), 1,
      aux_sym__terminator_token1,
    STATE(12027), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11965), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168056] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11971), 1,
      aux_sym__terminator_token1,
    STATE(12028), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11969), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168100] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(12050), 1,
      aux_sym__terminator_token1,
    STATE(12029), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12048), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168144] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(12054), 1,
      aux_sym__terminator_token1,
    STATE(12030), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12052), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168188] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6408), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17304), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16914), 1,
      sym__comprehension_clause,
    STATE(17058), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12031), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [168280] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6358), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17306), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16105), 1,
      sym__comprehension_clause,
    STATE(16232), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12032), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [168372] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11035), 1,
      aux_sym__terminator_token1,
    STATE(12033), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11033), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168416] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7928), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16252), 1,
      sym__comprehension_clause,
    STATE(16253), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12034), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [168508] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11041), 1,
      aux_sym__terminator_token1,
    STATE(12035), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11039), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168552] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    STATE(12036), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168596] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15174), 1,
      anon_sym_DASH_GT,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(12037), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [168644] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7286), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17310), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15349), 1,
      aux_sym_argument_list_repeat1,
    STATE(16854), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12038), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [168736] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11045), 1,
      aux_sym__terminator_token1,
    STATE(12039), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11043), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168780] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15196), 1,
      anon_sym_DASH_GT,
    ACTIONS(15408), 1,
      anon_sym_EQ,
    STATE(12040), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168828] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15190), 1,
      anon_sym_DASH_GT,
    STATE(12041), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [168874] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15408), 1,
      anon_sym_EQ,
    STATE(12042), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168922] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11118), 1,
      aux_sym__terminator_token1,
    STATE(12043), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11116), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [168966] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11122), 1,
      aux_sym__terminator_token1,
    STATE(12044), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11120), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [169010] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(12045), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [169056] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11199), 1,
      aux_sym__terminator_token1,
    STATE(12046), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11197), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [169100] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15210), 1,
      anon_sym_DASH_GT,
    ACTIONS(15446), 1,
      anon_sym_EQ,
    STATE(12047), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [169148] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11213), 1,
      aux_sym__terminator_token1,
    STATE(12048), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11211), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [169192] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6484), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17312), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16552), 1,
      aux_sym_argument_list_repeat1,
    STATE(17021), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12049), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [169284] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12050), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [169364] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6400), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17346), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16196), 1,
      sym__comprehension_clause,
    STATE(16362), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12051), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [169456] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7982), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17348), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16549), 1,
      sym__comprehension_clause,
    STATE(16551), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12052), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [169548] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6366), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17350), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16577), 1,
      sym__comprehension_clause,
    STATE(16937), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12053), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [169640] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7322), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17352), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16874), 1,
      sym__comprehension_clause,
    STATE(16887), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12054), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [169732] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15287), 1,
      anon_sym_EQ,
    STATE(12055), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [169778] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11307), 1,
      aux_sym__terminator_token1,
    STATE(12056), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11305), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [169822] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    STATE(14255), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12057), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [169906] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12058), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 21,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [169962] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7544), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17354), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16951), 1,
      sym__comprehension_clause,
    STATE(16952), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12059), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [170054] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12060), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 12,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [170122] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12061), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11287), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [170202] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11225), 1,
      aux_sym__terminator_token1,
    STATE(12062), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11223), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [170246] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12063), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11247), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [170326] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12064), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11287), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [170406] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15204), 1,
      anon_sym_DASH_GT,
    STATE(12065), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [170452] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    STATE(12066), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10978), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [170496] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12067), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11247), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [170576] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12068), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10835), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [170656] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6438), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17356), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16288), 1,
      sym__comprehension_clause,
    STATE(16608), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12069), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [170748] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17302), 1,
      anon_sym_DOT,
    ACTIONS(10731), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12070), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [170794] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8018), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17358), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16623), 1,
      sym__comprehension_clause,
    STATE(16624), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12071), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [170886] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12072), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 21,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [170942] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6556), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17360), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16051), 1,
      aux_sym_argument_list_repeat1,
    STATE(16906), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12073), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [171034] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12074), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [171114] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15454), 1,
      anon_sym_EQ,
    STATE(12075), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [171162] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15438), 1,
      anon_sym_EQ,
    STATE(12076), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [171210] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7360), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17364), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16137), 1,
      sym__comprehension_clause,
    STATE(16148), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12077), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [171302] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11271), 1,
      aux_sym__terminator_token1,
    STATE(12078), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11269), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [171346] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11281), 1,
      aux_sym__terminator_token1,
    STATE(12079), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11279), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [171390] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15204), 1,
      anon_sym_DASH_GT,
    STATE(12080), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [171436] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11311), 1,
      aux_sym__terminator_token1,
    STATE(12081), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11309), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [171480] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11319), 1,
      aux_sym__terminator_token1,
    STATE(12082), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11317), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [171524] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11361), 1,
      aux_sym__terminator_token1,
    STATE(12083), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11359), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [171568] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12084), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [171648] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6474), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17398), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16579), 1,
      sym__comprehension_clause,
    STATE(16675), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12085), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [171740] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12086), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11022), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [171826] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8052), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17438), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16685), 1,
      sym__comprehension_clause,
    STATE(16687), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12087), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [171918] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12088), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11022), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [172004] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11383), 1,
      aux_sym__terminator_token1,
    STATE(12089), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11381), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [172048] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15216), 1,
      anon_sym_DASH_GT,
    STATE(12090), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [172094] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12091), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [172178] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12092), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [172260] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12093), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      sym__pair_operator,
  [172344] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11409), 1,
      aux_sym__terminator_token1,
    STATE(12094), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11407), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [172388] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12095), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      sym__pair_operator,
  [172470] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12096), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [172554] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12097), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [172620] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12098), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [172704] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12099), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [172788] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12100), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [172872] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12101), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [172956] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12102), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173040] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    STATE(12200), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12103), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [173088] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12104), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173172] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12105), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173256] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12106), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173340] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12107), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173424] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12108), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173508] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12109), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [173592] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12110), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10964), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [173678] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12111), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10968), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [173764] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12112), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10972), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [173850] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12113), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10964), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [173936] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12114), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10968), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [174022] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12115), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10972), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [174108] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    STATE(12128), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12116), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [174156] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6672), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17486), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15431), 1,
      sym__comprehension_clause,
    STATE(16864), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12117), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174248] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7418), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17488), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16926), 1,
      sym__comprehension_clause,
    STATE(16936), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12118), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174340] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6512), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17490), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16644), 1,
      sym__comprehension_clause,
    STATE(16741), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12119), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174432] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12120), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [174512] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8090), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17492), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16752), 1,
      sym__comprehension_clause,
    STATE(16753), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12121), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174604] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6396), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17494), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16141), 1,
      aux_sym_argument_list_repeat1,
    STATE(16836), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12122), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174696] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15164), 1,
      anon_sym_DASH_GT,
    STATE(12123), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [174742] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6942), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17496), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16164), 1,
      sym__comprehension_clause,
    STATE(16165), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12124), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174834] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11458), 1,
      aux_sym__terminator_token1,
    STATE(12125), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11456), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [174878] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11020), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12126), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11022), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [174964] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12127), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [175040] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17534), 1,
      anon_sym_COMMA,
    STATE(12128), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [175086] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11285), 1,
      aux_sym__terminator_token1,
    STATE(12129), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11283), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [175130] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12130), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 10,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [175202] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    STATE(12131), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [175246] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15208), 1,
      anon_sym_DASH_GT,
    STATE(12132), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [175292] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6846), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17537), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15369), 1,
      aux_sym_argument_list_repeat1,
    STATE(16831), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12133), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [175384] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12134), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [175454] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12135), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 18,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [175516] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15190), 1,
      anon_sym_DASH_GT,
    STATE(12136), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [175562] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12137), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [175628] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17539), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15536), 1,
      sym__comprehension_clause,
    STATE(15537), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12138), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [175720] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17541), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15498), 1,
      aux_sym_argument_list_repeat1,
    STATE(16336), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12139), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [175812] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15210), 1,
      anon_sym_DASH_GT,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(12140), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [175860] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7462), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17543), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15557), 1,
      sym__comprehension_clause,
    STATE(15558), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12141), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [175952] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12142), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176036] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12143), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [176092] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(12144), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176140] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(12145), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176194] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(12146), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176246] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(12147), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176296] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(12148), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176344] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    STATE(12149), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176390] = 27,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    ACTIONS(17547), 1,
      aux_sym__terminator_token1,
    ACTIONS(17549), 1,
      aux_sym__terminator_token2,
    STATE(14278), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15288), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_end,
      anon_sym_finally,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12150), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176478] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    STATE(12151), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176522] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12152), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [176602] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15210), 1,
      anon_sym_DASH_GT,
    ACTIONS(15494), 1,
      anon_sym_EQ,
    STATE(12153), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176650] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12154), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [176734] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11253), 1,
      aux_sym__terminator_token1,
    STATE(12155), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11251), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176778] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    STATE(12156), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176822] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11474), 1,
      aux_sym__terminator_token1,
    STATE(12157), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11472), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176866] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15184), 1,
      anon_sym_DASH_GT,
    STATE(12158), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176912] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15494), 1,
      anon_sym_EQ,
    STATE(12159), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [176960] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6608), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17551), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15474), 1,
      aux_sym_argument_list_repeat1,
    STATE(16332), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12160), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [177052] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10928), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12161), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10964), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [177138] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10966), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12162), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10968), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [177224] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10970), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12163), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10972), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [177310] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    STATE(14263), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12164), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [177394] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10978), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12165), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [177478] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11333), 1,
      aux_sym__terminator_token1,
    STATE(12166), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11331), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [177522] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15202), 1,
      anon_sym_DASH_GT,
    ACTIONS(15454), 1,
      anon_sym_EQ,
    STATE(12167), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [177570] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6340), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17553), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16066), 1,
      sym__comprehension_clause,
    STATE(16378), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12168), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [177662] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10978), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12169), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [177744] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6834), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17555), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15364), 1,
      sym__comprehension_clause,
    STATE(16072), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12170), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [177836] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11337), 1,
      aux_sym__terminator_token1,
    STATE(12171), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11335), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [177880] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7508), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17557), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16118), 1,
      sym__comprehension_clause,
    STATE(16120), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12172), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [177972] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11341), 1,
      aux_sym__terminator_token1,
    STATE(12173), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11339), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [178016] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7034), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17559), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16562), 1,
      sym__comprehension_clause,
    STATE(16564), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12174), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [178108] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15172), 1,
      anon_sym_DASH_GT,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(12175), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [178156] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11345), 1,
      aux_sym__terminator_token1,
    STATE(12176), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11343), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [178200] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    STATE(12180), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12177), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [178248] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11349), 1,
      aux_sym__terminator_token1,
    STATE(12178), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11347), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [178292] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11353), 1,
      aux_sym__terminator_token1,
    STATE(12179), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11351), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [178336] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17561), 1,
      anon_sym_COMMA,
    STATE(12180), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [178382] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    STATE(12181), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [178426] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17027), 1,
      sym__power_operator,
    STATE(12182), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [178474] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15216), 1,
      anon_sym_DASH_GT,
    STATE(12183), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [178520] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17564), 1,
      sym__immediate_string_start,
    ACTIONS(17566), 1,
      sym__immediate_command_start,
    STATE(12184), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_as,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [178568] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15164), 1,
      anon_sym_DASH_GT,
    STATE(12185), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [178614] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6362), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17568), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15641), 1,
      sym__comprehension_clause,
    STATE(16339), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12186), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [178706] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7554), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17570), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16595), 1,
      sym__comprehension_clause,
    STATE(16596), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12187), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [178798] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8482), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17572), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16842), 1,
      sym__comprehension_clause,
    STATE(16848), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12188), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [178890] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12189), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10835), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [178970] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(12190), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179016] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(12191), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179062] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11501), 1,
      aux_sym__terminator_token1,
    STATE(12192), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11499), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179106] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15184), 1,
      anon_sym_DASH_GT,
    STATE(12193), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179152] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(12194), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179198] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(12195), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179244] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11357), 1,
      aux_sym__terminator_token1,
    STATE(12196), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11355), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179288] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11375), 1,
      aux_sym__terminator_token1,
    STATE(12197), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11373), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179332] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11379), 1,
      aux_sym__terminator_token1,
    STATE(12198), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11377), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179376] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17564), 1,
      sym__immediate_string_start,
    ACTIONS(17566), 1,
      sym__immediate_command_start,
    STATE(12199), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_as,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [179424] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17574), 1,
      anon_sym_COMMA,
    STATE(12200), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179470] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6412), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17577), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16197), 1,
      sym__comprehension_clause,
    STATE(16796), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12201), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [179562] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7592), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17579), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16844), 1,
      sym__comprehension_clause,
    STATE(16845), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12202), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [179654] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11515), 1,
      aux_sym__terminator_token1,
    STATE(12203), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11513), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179698] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11528), 1,
      aux_sym__terminator_token1,
    STATE(12204), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11526), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179742] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11387), 1,
      aux_sym__terminator_token1,
    STATE(12205), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11385), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179786] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11401), 1,
      aux_sym__terminator_token1,
    STATE(12206), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11399), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179830] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11405), 1,
      aux_sym__terminator_token1,
    STATE(12207), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11403), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [179874] = 27,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    ACTIONS(17583), 1,
      aux_sym__terminator_token1,
    ACTIONS(17585), 1,
      aux_sym__terminator_token2,
    STATE(14279), 1,
      aux_sym_open_tuple_repeat1,
    STATE(15305), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_catch,
      anon_sym_finally,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12208), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [179962] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6388), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17587), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16214), 1,
      sym__comprehension_clause,
    STATE(16615), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12209), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [180054] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15202), 1,
      anon_sym_DASH_GT,
    ACTIONS(15426), 1,
      anon_sym_EQ,
    STATE(12210), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180102] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7088), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17589), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16637), 1,
      sym__comprehension_clause,
    STATE(16639), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12211), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [180194] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11257), 1,
      aux_sym__terminator_token1,
    STATE(12212), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11255), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180238] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15426), 1,
      anon_sym_EQ,
    STATE(12213), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180286] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17591), 1,
      anon_sym_DOT,
    STATE(12214), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180332] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11413), 1,
      aux_sym__terminator_token1,
    STATE(12215), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11411), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180376] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7626), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17593), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16971), 1,
      sym__comprehension_clause,
    STATE(16977), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12216), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [180468] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11532), 1,
      aux_sym__terminator_token1,
    STATE(12217), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11530), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180512] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(12218), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [180560] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(12219), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180606] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(17595), 1,
      anon_sym_COMMA,
    ACTIONS(17597), 1,
      anon_sym_as,
    STATE(12750), 1,
      aux_sym__import_list_repeat1,
    STATE(12220), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180656] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11536), 1,
      aux_sym__terminator_token1,
    STATE(12221), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11534), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180700] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15216), 1,
      anon_sym_DASH_GT,
    STATE(12222), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180746] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6404), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17599), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15480), 1,
      aux_sym_argument_list_repeat1,
    STATE(17037), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12223), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [180838] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17302), 1,
      anon_sym_DOT,
    ACTIONS(10639), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12224), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180884] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11550), 1,
      aux_sym__terminator_token1,
    STATE(12225), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11548), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180928] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11554), 1,
      aux_sym__terminator_token1,
    STATE(12226), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11552), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [180972] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6826), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17601), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16203), 1,
      aux_sym_argument_list_repeat1,
    STATE(16777), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12227), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181064] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6520), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17603), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15363), 1,
      aux_sym_argument_list_repeat1,
    STATE(16872), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12228), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181156] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8844), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17605), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15701), 1,
      sym__comprehension_clause,
    STATE(15715), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12229), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181248] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7662), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17607), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15389), 1,
      sym__comprehension_clause,
    STATE(15390), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12230), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181340] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6524), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17609), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16591), 1,
      sym__comprehension_clause,
    STATE(16691), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12231), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181432] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12232), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [181516] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7140), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17611), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16715), 1,
      sym__comprehension_clause,
    STATE(16718), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12233), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181608] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(12234), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [181656] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    STATE(12260), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12235), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [181704] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15170), 1,
      anon_sym_DASH_GT,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(12236), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [181752] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11171), 1,
      aux_sym__terminator_token1,
    STATE(12237), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11169), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [181796] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11561), 1,
      aux_sym__terminator_token1,
    STATE(12238), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11559), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [181840] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6624), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17613), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16814), 1,
      sym__comprehension_clause,
    STATE(17035), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12239), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [181932] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17615), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16617), 1,
      sym__comprehension_clause,
    STATE(16629), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12240), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [182024] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11565), 1,
      aux_sym__terminator_token1,
    STATE(12241), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11563), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [182068] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15466), 1,
      anon_sym_EQ,
    STATE(12242), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182116] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    STATE(12243), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [182160] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11569), 1,
      aux_sym__terminator_token1,
    STATE(12244), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11567), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [182204] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15172), 1,
      anon_sym_DASH_GT,
    ACTIONS(15466), 1,
      anon_sym_EQ,
    STATE(12245), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182252] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15468), 1,
      anon_sym_EQ,
    STATE(12246), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182300] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15170), 1,
      anon_sym_DASH_GT,
    ACTIONS(15468), 1,
      anon_sym_EQ,
    STATE(12247), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182348] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15474), 1,
      anon_sym_EQ,
    STATE(12248), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182396] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15174), 1,
      anon_sym_DASH_GT,
    ACTIONS(15474), 1,
      anon_sym_EQ,
    STATE(12249), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [182444] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7880), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17617), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16886), 1,
      sym__comprehension_clause,
    STATE(17034), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12250), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [182536] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15208), 1,
      anon_sym_DASH_GT,
    STATE(12251), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [182582] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6572), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17619), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15467), 1,
      aux_sym_argument_list_repeat1,
    STATE(17029), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12252), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [182674] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6542), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17621), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15586), 1,
      sym__comprehension_clause,
    STATE(16393), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12253), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [182766] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7696), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17623), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15490), 1,
      sym__comprehension_clause,
    STATE(15493), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12254), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [182858] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8814), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17625), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16555), 1,
      sym__comprehension_clause,
    STATE(16556), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12255), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [182950] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12256), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [183034] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 1,
      aux_sym__terminator_token1,
    STATE(12257), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10850), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183078] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11573), 1,
      aux_sym__terminator_token1,
    STATE(12258), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11571), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183122] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    STATE(12294), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12259), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183170] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17627), 1,
      anon_sym_COMMA,
    STATE(12260), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183216] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6664), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17630), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16664), 1,
      sym__comprehension_clause,
    STATE(16774), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12261), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [183308] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15250), 1,
      anon_sym_EQ,
    STATE(12262), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183354] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    STATE(12263), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183398] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7178), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17632), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16808), 1,
      sym__comprehension_clause,
    STATE(16809), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12264), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [183490] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15301), 1,
      anon_sym_EQ,
    STATE(12265), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183536] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15196), 1,
      anon_sym_DASH_GT,
    ACTIONS(15438), 1,
      anon_sym_EQ,
    STATE(12266), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183584] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    STATE(12267), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183628] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15202), 1,
      anon_sym_DASH_GT,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(12268), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183676] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(12269), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183724] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11900), 1,
      aux_sym__terminator_token1,
    STATE(12270), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11898), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183768] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12271), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11112), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [183848] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(14255), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12272), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(17634), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [183932] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(12273), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [183978] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(12274), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184024] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(12275), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184070] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11175), 1,
      aux_sym__terminator_token1,
    STATE(12276), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11173), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184114] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6652), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17638), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15417), 1,
      sym__comprehension_clause,
    STATE(15575), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12277), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [184206] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7734), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17640), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15596), 1,
      sym__comprehension_clause,
    STATE(15597), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12278), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [184298] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10878), 1,
      aux_sym__terminator_token1,
    ACTIONS(17642), 1,
      anon_sym_COMMA,
    STATE(12283), 1,
      aux_sym_export_statement_repeat1,
    STATE(12279), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184346] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10882), 1,
      aux_sym__terminator_token1,
    ACTIONS(17642), 1,
      anon_sym_COMMA,
    STATE(12283), 1,
      aux_sym_export_statement_repeat1,
    STATE(12280), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184394] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10886), 1,
      aux_sym__terminator_token1,
    ACTIONS(16887), 1,
      anon_sym_COMMA,
    STATE(12285), 1,
      aux_sym__import_list_repeat1,
    STATE(12281), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184442] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(12282), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
    ACTIONS(9780), 14,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
  [184490] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 1,
      aux_sym__terminator_token1,
    ACTIONS(17644), 1,
      anon_sym_COMMA,
    STATE(12283), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184536] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(16889), 1,
      anon_sym_as,
    STATE(12284), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184582] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(17647), 1,
      anon_sym_COMMA,
    STATE(12285), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184628] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    STATE(12286), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [184672] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(12287), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
    ACTIONS(9784), 14,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
  [184720] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(12288), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
    ACTIONS(9796), 14,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
  [184768] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6668), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17650), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15348), 1,
      aux_sym_argument_list_repeat1,
    STATE(16811), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12289), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [184860] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6776), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17652), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16734), 1,
      sym__comprehension_clause,
    STATE(16884), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12290), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [184952] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7212), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17654), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16899), 1,
      sym__comprehension_clause,
    STATE(16900), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12291), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [185044] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15190), 1,
      anon_sym_DASH_GT,
    STATE(12292), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [185090] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    STATE(11851), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12293), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [185174] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17656), 1,
      anon_sym_COMMA,
    STATE(12294), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185220] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    STATE(12295), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185266] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6734), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17659), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15519), 1,
      sym__comprehension_clause,
    STATE(15654), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12296), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [185358] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    STATE(12297), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [185404] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17001), 1,
      anon_sym_QMARK,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12298), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11112), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [185484] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7796), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17661), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15706), 1,
      sym__comprehension_clause,
    STATE(15716), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12299), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [185576] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10878), 1,
      aux_sym__terminator_token1,
    ACTIONS(17663), 1,
      anon_sym_COMMA,
    STATE(12304), 1,
      aux_sym_export_statement_repeat1,
    STATE(12300), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185624] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10882), 1,
      aux_sym__terminator_token1,
    ACTIONS(17663), 1,
      anon_sym_COMMA,
    STATE(12304), 1,
      aux_sym_export_statement_repeat1,
    STATE(12301), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185672] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10886), 1,
      aux_sym__terminator_token1,
    ACTIONS(16983), 1,
      anon_sym_COMMA,
    STATE(12306), 1,
      aux_sym__import_list_repeat1,
    STATE(12302), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185720] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(12303), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185766] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 1,
      aux_sym__terminator_token1,
    ACTIONS(17665), 1,
      anon_sym_COMMA,
    STATE(12304), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185812] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(16985), 1,
      anon_sym_as,
    STATE(12305), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185858] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(17668), 1,
      anon_sym_COMMA,
    STATE(12306), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [185904] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12307), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [185988] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(12308), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186034] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12309), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [186118] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(12310), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186164] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    STATE(11845), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12311), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [186248] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11519), 1,
      aux_sym__terminator_token1,
    STATE(12312), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11517), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186292] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10878), 1,
      aux_sym__terminator_token1,
    ACTIONS(17671), 1,
      anon_sym_COMMA,
    STATE(12317), 1,
      aux_sym_export_statement_repeat1,
    STATE(12313), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186340] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10882), 1,
      aux_sym__terminator_token1,
    ACTIONS(17671), 1,
      anon_sym_COMMA,
    STATE(12317), 1,
      aux_sym_export_statement_repeat1,
    STATE(12314), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186388] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10886), 1,
      aux_sym__terminator_token1,
    ACTIONS(17035), 1,
      anon_sym_COMMA,
    STATE(12319), 1,
      aux_sym__import_list_repeat1,
    STATE(12315), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186436] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(12316), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
    ACTIONS(9800), 14,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
  [186484] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 1,
      aux_sym__terminator_token1,
    ACTIONS(17673), 1,
      anon_sym_COMMA,
    STATE(12317), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186530] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(17037), 1,
      anon_sym_as,
    STATE(12318), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186576] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(17676), 1,
      anon_sym_COMMA,
    STATE(12319), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186622] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(12320), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186670] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7122), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17679), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16121), 1,
      sym__comprehension_clause,
    STATE(16122), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12321), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [186762] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(12322), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186810] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(17595), 1,
      anon_sym_COMMA,
    ACTIONS(17597), 1,
      anon_sym_as,
    ACTIONS(17681), 1,
      anon_sym_COLON,
    STATE(12750), 1,
      aux_sym__import_list_repeat1,
    STATE(12323), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 24,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [186862] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6346), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17683), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16832), 1,
      sym__comprehension_clause,
    STATE(16949), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12324), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [186954] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17685), 1,
      anon_sym_COMMA,
    ACTIONS(17687), 1,
      anon_sym_as,
    ACTIONS(17689), 1,
      anon_sym_COLON,
    STATE(12612), 1,
      aux_sym__import_list_repeat1,
    STATE(12325), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 6,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [187006] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17691), 1,
      anon_sym_DOT,
    STATE(12326), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10759), 21,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [187052] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17691), 1,
      anon_sym_DOT,
    STATE(12327), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10763), 21,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [187098] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17691), 1,
      anon_sym_DOT,
    STATE(12328), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10731), 21,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [187144] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17685), 1,
      anon_sym_COMMA,
    ACTIONS(17687), 1,
      anon_sym_as,
    STATE(12612), 1,
      aux_sym__import_list_repeat1,
    STATE(12329), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [187194] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15150), 1,
      anon_sym_DASH_GT,
    STATE(12330), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187240] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    STATE(12333), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12331), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [187288] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17252), 1,
      anon_sym_COMMA,
    ACTIONS(17254), 1,
      anon_sym_as,
    STATE(12435), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(10755), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12332), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187338] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17693), 1,
      anon_sym_COMMA,
    STATE(12333), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [187384] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(163), 1,
      anon_sym_DASH_GT,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    STATE(12334), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187430] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(14263), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12335), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(17634), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [187514] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(12336), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187560] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(12337), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187606] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(12338), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187652] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6660), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17696), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16966), 1,
      sym__comprehension_clause,
    STATE(17043), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12339), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [187744] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(12340), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187790] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(12341), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [187836] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8226), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17698), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16221), 1,
      sym__comprehension_clause,
    STATE(16228), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12342), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [187928] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6460), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17700), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16146), 1,
      sym__comprehension_clause,
    STATE(16755), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12343), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [188020] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(12344), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [188066] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7098), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17702), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16784), 1,
      sym__comprehension_clause,
    STATE(16785), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12345), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [188158] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6792), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17704), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(15621), 1,
      sym__comprehension_clause,
    STATE(16077), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12346), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [188250] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    STATE(12347), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 28,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [188294] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15184), 1,
      anon_sym_DASH_GT,
    STATE(12348), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [188340] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10811), 1,
      aux_sym__terminator_token1,
    ACTIONS(17642), 1,
      anon_sym_COMMA,
    STATE(12279), 1,
      aux_sym_export_statement_repeat1,
    STATE(12349), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [188388] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10815), 1,
      aux_sym__terminator_token1,
    ACTIONS(17642), 1,
      anon_sym_COMMA,
    STATE(12280), 1,
      aux_sym_export_statement_repeat1,
    STATE(12350), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [188436] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16887), 1,
      anon_sym_COMMA,
    STATE(12281), 1,
      aux_sym__import_list_repeat1,
    STATE(12351), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [188484] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17706), 1,
      anon_sym_DOT,
    STATE(12352), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [188530] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12353), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [188596] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7840), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17708), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16086), 1,
      sym__comprehension_clause,
    STATE(16087), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12354), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [188688] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12355), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 12,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [188756] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16702), 1,
      anon_sym_QMARK,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12356), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [188836] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12357), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [188912] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17691), 1,
      anon_sym_DOT,
    STATE(12358), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 21,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_as,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [188958] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10811), 1,
      aux_sym__terminator_token1,
    ACTIONS(17663), 1,
      anon_sym_COMMA,
    STATE(12300), 1,
      aux_sym_export_statement_repeat1,
    STATE(12359), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189006] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10815), 1,
      aux_sym__terminator_token1,
    ACTIONS(17663), 1,
      anon_sym_COMMA,
    STATE(12301), 1,
      aux_sym_export_statement_repeat1,
    STATE(12360), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189054] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(16983), 1,
      anon_sym_COMMA,
    STATE(12302), 1,
      aux_sym__import_list_repeat1,
    STATE(12361), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189102] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10811), 1,
      aux_sym__terminator_token1,
    ACTIONS(17671), 1,
      anon_sym_COMMA,
    STATE(12313), 1,
      aux_sym_export_statement_repeat1,
    STATE(12362), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189150] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10815), 1,
      aux_sym__terminator_token1,
    ACTIONS(17671), 1,
      anon_sym_COMMA,
    STATE(12314), 1,
      aux_sym_export_statement_repeat1,
    STATE(12363), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189198] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(17035), 1,
      anon_sym_COMMA,
    STATE(12315), 1,
      aux_sym__import_list_repeat1,
    STATE(12364), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 26,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189246] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12365), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 10,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [189318] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12366), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [189388] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10759), 1,
      aux_sym__terminator_token1,
    ACTIONS(17706), 1,
      anon_sym_DOT,
    STATE(12367), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189434] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10763), 1,
      aux_sym__terminator_token1,
    ACTIONS(17706), 1,
      anon_sym_DOT,
    STATE(12368), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189480] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10731), 1,
      aux_sym__terminator_token1,
    ACTIONS(17706), 1,
      anon_sym_DOT,
    STATE(12369), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_as,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189526] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12370), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 18,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [189588] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17710), 1,
      anon_sym_DOT,
    STATE(12371), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189634] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12372), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [189700] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15446), 1,
      anon_sym_EQ,
    STATE(12373), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189748] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12374), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [189804] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(12375), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189858] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(12376), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189910] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(12377), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [189960] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16728), 1,
      sym__power_operator,
    STATE(12378), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [190008] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17712), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16988), 1,
      sym__comprehension_clause,
    STATE(16990), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12379), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [190100] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17714), 1,
      anon_sym_DOT,
    STATE(12380), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 27,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [190146] = 29,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6468), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17716), 1,
      anon_sym_COMMA,
    STATE(14264), 1,
      sym_for_clause,
    STATE(16671), 1,
      sym__comprehension_clause,
    STATE(16938), 1,
      aux_sym_argument_list_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12381), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [190238] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15468), 1,
      anon_sym_EQ,
    STATE(12382), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190283] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(17718), 1,
      anon_sym_COMMA,
    STATE(12383), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [190328] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15332), 1,
      anon_sym_DASH_GT,
    STATE(12384), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [190373] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(12385), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [190418] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12386), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [190501] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(12387), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [190546] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12388), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [190629] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12389), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [190712] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(12390), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [190757] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    STATE(12235), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12391), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [190840] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15299), 1,
      anon_sym_DASH_GT,
    STATE(12392), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190885] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17721), 1,
      anon_sym_COMMA,
    STATE(12393), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 19,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190930] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17724), 1,
      anon_sym_COMMA,
    STATE(12394), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [190975] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17727), 1,
      anon_sym_DOT,
    ACTIONS(10639), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12395), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [191020] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(12396), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [191065] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(12397), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [191110] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15196), 1,
      anon_sym_DASH_GT,
    STATE(12398), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [191155] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17344), 1,
      sym__power_operator,
    STATE(12399), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [191202] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17729), 1,
      anon_sym_COMMA,
    STATE(12518), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(10878), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12400), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [191249] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(223), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    STATE(12401), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [191296] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    STATE(14279), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12402), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [191379] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(12403), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [191424] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12404), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11112), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [191503] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(14279), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12405), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [191586] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    ACTIONS(15508), 1,
      anon_sym_EQ,
    STATE(12406), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [191633] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15508), 1,
      anon_sym_EQ,
    STATE(12407), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [191680] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12408), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11247), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [191759] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12409), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10964), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [191844] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12410), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10968), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [191929] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12411), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 20,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [191984] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12412), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10972), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [192069] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(12413), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [192114] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(12414), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [192159] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12415), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10835), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [192238] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12416), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [192293] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12417), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [192372] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17729), 1,
      anon_sym_COMMA,
    STATE(12518), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(10882), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12418), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [192419] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    STATE(12639), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12419), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [192466] = 27,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17740), 1,
      anon_sym_for,
    ACTIONS(17743), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(17562), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(17737), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(12420), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [192553] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(12421), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [192600] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12422), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [192683] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12423), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11022), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [192768] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15544), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12424), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [192815] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12425), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11022), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [192898] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15170), 1,
      anon_sym_DASH_GT,
    STATE(12426), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [192943] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15174), 1,
      anon_sym_DASH_GT,
    STATE(12427), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [192988] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15466), 1,
      anon_sym_EQ,
    STATE(12428), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193033] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    STATE(12429), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [193086] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15289), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12430), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [193131] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12431), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [193196] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    STATE(12432), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [193247] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12433), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11247), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [193326] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(12434), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [193371] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17252), 1,
      anon_sym_COMMA,
    STATE(12622), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(10886), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12435), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [193418] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12436), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [193497] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15474), 1,
      anon_sym_EQ,
    STATE(12437), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193542] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(12438), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193587] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17753), 1,
      anon_sym_where,
    ACTIONS(17755), 1,
      sym__pair_operator,
    ACTIONS(17757), 1,
      sym__arrow_operator,
    ACTIONS(17759), 1,
      sym__lazy_or_operator,
    ACTIONS(17761), 1,
      sym__lazy_and_operator,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12439), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17751), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11112), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [193666] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    STATE(12440), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [193715] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15277), 1,
      anon_sym_DASH_GT,
    STATE(12441), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193760] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15279), 1,
      anon_sym_DASH_GT,
    STATE(12442), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193805] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12443), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [193880] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12444), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [193951] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15311), 1,
      anon_sym_DASH_GT,
    STATE(12445), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [193996] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12446), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [194077] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15454), 1,
      anon_sym_EQ,
    STATE(12447), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [194122] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12448), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [194193] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12449), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 10,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [194262] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12450), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10964), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [194345] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12451), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10968), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [194428] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17400), 1,
      anon_sym_COMMA,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    STATE(12116), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12452), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10972), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [194511] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12453), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [194572] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(12454), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [194617] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12455), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [194682] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15438), 1,
      anon_sym_EQ,
    STATE(12456), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [194727] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12457), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [194782] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17396), 1,
      sym__power_operator,
    STATE(12458), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [194829] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12459), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [194882] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12460), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [194933] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12461), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11247), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [195012] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    STATE(12462), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [195059] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12463), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11247), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [195138] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    STATE(12711), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10833), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12464), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [195185] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15522), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12465), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [195232] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12466), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17751), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [195299] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10982), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12467), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10978), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      sym__pair_operator,
      aux_sym__terminator_token2,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [195378] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15494), 1,
      anon_sym_EQ,
    STATE(12468), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [195423] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12469), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10964), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [195508] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12470), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [195589] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12471), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10968), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [195674] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12472), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10835), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [195753] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15299), 1,
      anon_sym_DASH_GT,
    STATE(12473), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [195798] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12474), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [195847] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12475), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [195928] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12476), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10972), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [196013] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12477), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [196060] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    STATE(12478), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196107] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(12479), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9780), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9782), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196154] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(12480), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [196199] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(12481), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [196244] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12482), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11112), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [196323] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17729), 1,
      anon_sym_COMMA,
    STATE(12400), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(10811), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12483), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [196370] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12484), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [196451] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12485), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 10,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [196520] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(14278), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12486), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [196603] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12487), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [196684] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(12488), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9784), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9786), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196731] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12489), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [196810] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    STATE(12490), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196857] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    STATE(12394), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12491), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196904] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(12492), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196949] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(12493), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9796), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9798), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [196996] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17396), 1,
      sym__power_operator,
    STATE(12494), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [197043] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15172), 1,
      anon_sym_DASH_GT,
    STATE(12495), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197088] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15295), 1,
      anon_sym_DASH_GT,
    STATE(12496), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197133] = 27,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17743), 1,
      anon_sym_COMMA,
    ACTIONS(17879), 1,
      anon_sym_for,
    STATE(14264), 1,
      sym_for_clause,
    STATE(17562), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(17882), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(12497), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [197220] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15295), 1,
      anon_sym_DASH_GT,
    STATE(12498), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197265] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(12499), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [197310] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12500), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 5,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [197389] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12501), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 20,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [197444] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15670), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(12502), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9800), 13,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_DOT,
      anon_sym_isa,
      anon_sym_where,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9802), 13,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197491] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15332), 1,
      anon_sym_DASH_GT,
    STATE(12503), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [197536] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(12504), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [197581] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12505), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11112), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [197660] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(12506), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [197705] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(12507), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197750] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(12508), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197797] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12509), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [197864] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    STATE(12510), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [197909] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(12511), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [197954] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15344), 1,
      anon_sym_DASH_GT,
    ACTIONS(15540), 1,
      anon_sym_EQ,
    STATE(12512), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [198001] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16993), 1,
      anon_sym_COLON,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17003), 1,
      anon_sym_where,
    ACTIONS(17005), 1,
      sym__pair_operator,
    ACTIONS(17007), 1,
      sym__arrow_operator,
    ACTIONS(17009), 1,
      sym__lazy_or_operator,
    ACTIONS(17011), 1,
      sym__lazy_and_operator,
    ACTIONS(17013), 1,
      sym__pipe_right_operator,
    ACTIONS(17015), 1,
      sym__pipe_left_operator,
    ACTIONS(17017), 1,
      sym__ellipsis_operator,
    ACTIONS(17021), 1,
      sym__times_operator,
    ACTIONS(17023), 1,
      sym__rational_operator,
    ACTIONS(17025), 1,
      sym__bitshift_operator,
    ACTIONS(17027), 1,
      sym__power_operator,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    ACTIONS(17019), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12513), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16995), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11287), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [198080] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15289), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12514), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198125] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15408), 1,
      anon_sym_EQ,
    STATE(12515), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198170] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(10835), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12516), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10840), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [198251] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(12517), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [198296] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17885), 1,
      anon_sym_COMMA,
    ACTIONS(10855), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12518), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198341] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15202), 1,
      anon_sym_DASH_GT,
    STATE(12519), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198386] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12520), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [198447] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(12521), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198492] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(12522), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198537] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12523), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [198620] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12524), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [198703] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(12525), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198748] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12526), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [198813] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15210), 1,
      anon_sym_DASH_GT,
    STATE(12527), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [198858] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12528), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 20,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [198913] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12529), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [198996] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12530), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17890), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [199063] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10835), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12531), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10840), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [199144] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17753), 1,
      anon_sym_where,
    ACTIONS(17755), 1,
      sym__pair_operator,
    ACTIONS(17757), 1,
      sym__arrow_operator,
    ACTIONS(17759), 1,
      sym__lazy_or_operator,
    ACTIONS(17761), 1,
      sym__lazy_and_operator,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12532), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17751), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [199223] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17753), 1,
      anon_sym_where,
    ACTIONS(17757), 1,
      sym__arrow_operator,
    ACTIONS(17759), 1,
      sym__lazy_or_operator,
    ACTIONS(17761), 1,
      sym__lazy_and_operator,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12533), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17751), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [199298] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17753), 1,
      anon_sym_where,
    ACTIONS(17761), 1,
      sym__lazy_and_operator,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12534), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17751), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [199369] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15321), 1,
      anon_sym_DASH_GT,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12535), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [199416] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12536), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [199463] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(14264), 1,
      sym_for_clause,
    STATE(17562), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12537), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(17743), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [199548] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17753), 1,
      anon_sym_where,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12538), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17751), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [199617] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12539), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 17,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [199678] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17749), 1,
      anon_sym_COLON,
    ACTIONS(17763), 1,
      sym__pipe_right_operator,
    ACTIONS(17765), 1,
      sym__pipe_left_operator,
    ACTIONS(17767), 1,
      sym__ellipsis_operator,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12540), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [199743] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12541), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [199798] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    STATE(12542), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [199851] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    STATE(12543), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [199902] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(12544), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [199947] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12545), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [200030] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    STATE(12546), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [200079] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17777), 1,
      sym__power_operator,
    STATE(12547), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [200126] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(223), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(12548), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [200173] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(12549), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [200218] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12550), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [200301] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(12551), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [200348] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12552), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [200413] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12553), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [200480] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    ACTIONS(15516), 1,
      anon_sym_EQ,
    STATE(12554), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [200527] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15516), 1,
      anon_sym_EQ,
    STATE(12555), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [200574] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12556), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [200653] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12557), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11247), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [200732] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12558), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [200807] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12559), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [200882] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12560), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      sym__pair_operator,
  [200963] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12561), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [201034] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(12562), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [201079] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    STATE(12563), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [201124] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(12564), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [201169] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15299), 1,
      anon_sym_DASH_GT,
    STATE(12565), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [201214] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(12566), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [201259] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15332), 1,
      anon_sym_DASH_GT,
    STATE(12567), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [201304] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12568), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [201387] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12569), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [201470] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(223), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15570), 1,
      anon_sym_EQ,
    STATE(12570), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [201517] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15570), 1,
      anon_sym_EQ,
    STATE(12571), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [201564] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12572), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [201647] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12573), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 10,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [201716] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(12574), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [201761] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11020), 2,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(11022), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12575), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [201844] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12576), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 17,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [201905] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12577), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10964), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [201990] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12578), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10968), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [202075] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12579), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [202140] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    STATE(12580), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [202185] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12581), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10972), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [202270] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15311), 1,
      anon_sym_DASH_GT,
    STATE(12582), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [202315] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15289), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12583), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [202360] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15552), 1,
      anon_sym_EQ,
    STATE(12584), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [202407] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12585), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [202462] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17729), 1,
      anon_sym_COMMA,
    STATE(12418), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(10815), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12586), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [202509] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    STATE(12587), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [202562] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17498), 1,
      anon_sym_COMMA,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    STATE(12331), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12588), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11022), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [202647] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    STATE(12589), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [202698] = 27,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17743), 1,
      anon_sym_SEMI,
    STATE(14264), 1,
      sym_for_clause,
    STATE(17562), 1,
      sym__comprehension_clause,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(17737), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(12590), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [202785] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12591), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [202864] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17344), 1,
      sym__power_operator,
    STATE(12592), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [202911] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12593), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [202994] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15354), 1,
      anon_sym_DASH_GT,
    ACTIONS(15518), 1,
      anon_sym_EQ,
    STATE(12594), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203041] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10811), 1,
      aux_sym__terminator_token1,
    ACTIONS(17914), 1,
      anon_sym_COMMA,
    STATE(12747), 1,
      aux_sym_export_statement_repeat1,
    STATE(12595), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [203088] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10815), 1,
      aux_sym__terminator_token1,
    ACTIONS(17914), 1,
      anon_sym_COMMA,
    STATE(12748), 1,
      aux_sym_export_statement_repeat1,
    STATE(12596), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [203135] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10755), 1,
      aux_sym__terminator_token1,
    ACTIONS(17595), 1,
      anon_sym_COMMA,
    STATE(12750), 1,
      aux_sym__import_list_repeat1,
    STATE(12597), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [203182] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16694), 1,
      anon_sym_COLON,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16704), 1,
      anon_sym_where,
    ACTIONS(16706), 1,
      sym__pair_operator,
    ACTIONS(16708), 1,
      sym__arrow_operator,
    ACTIONS(16710), 1,
      sym__lazy_or_operator,
    ACTIONS(16712), 1,
      sym__lazy_and_operator,
    ACTIONS(16714), 1,
      sym__pipe_right_operator,
    ACTIONS(16716), 1,
      sym__pipe_left_operator,
    ACTIONS(16718), 1,
      sym__ellipsis_operator,
    ACTIONS(16722), 1,
      sym__times_operator,
    ACTIONS(16724), 1,
      sym__rational_operator,
    ACTIONS(16726), 1,
      sym__bitshift_operator,
    ACTIONS(16728), 1,
      sym__power_operator,
    ACTIONS(16921), 1,
      anon_sym_QMARK,
    ACTIONS(16720), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12598), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16696), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11287), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [203261] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10835), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12599), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10840), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [203342] = 27,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17916), 1,
      ts_builtin_sym_end,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    ACTIONS(17920), 1,
      aux_sym__terminator_token1,
    ACTIONS(17922), 1,
      aux_sym__terminator_token2,
    STATE(14419), 1,
      aux_sym_open_tuple_repeat1,
    STATE(17030), 1,
      aux_sym__block_repeat1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12600), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [203429] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    STATE(14278), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12601), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [203512] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17252), 1,
      anon_sym_COMMA,
    STATE(12435), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(10755), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12602), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [203559] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17924), 1,
      anon_sym_COMMA,
    STATE(12609), 1,
      aux_sym_export_statement_repeat1,
    STATE(12603), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10811), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203606] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17924), 1,
      anon_sym_COMMA,
    STATE(12610), 1,
      aux_sym_export_statement_repeat1,
    STATE(12604), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10815), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203653] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17685), 1,
      anon_sym_COMMA,
    STATE(12612), 1,
      aux_sym__import_list_repeat1,
    STATE(12605), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203700] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17362), 1,
      anon_sym_QMARK,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12606), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11287), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [203779] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(12607), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203824] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(12608), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [203869] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17924), 1,
      anon_sym_COMMA,
    STATE(12613), 1,
      aux_sym_export_statement_repeat1,
    STATE(12609), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10878), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203916] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17924), 1,
      anon_sym_COMMA,
    STATE(12613), 1,
      aux_sym_export_statement_repeat1,
    STATE(12610), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10882), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [203963] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12611), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11022), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [204048] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17685), 1,
      anon_sym_COMMA,
    STATE(12615), 1,
      aux_sym__import_list_repeat1,
    STATE(12612), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10886), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204095] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17926), 1,
      anon_sym_COMMA,
    STATE(12613), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10855), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204140] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17687), 1,
      anon_sym_as,
    STATE(12614), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204185] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17929), 1,
      anon_sym_COMMA,
    STATE(12615), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204230] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12616), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [204313] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17320), 1,
      anon_sym_QMARK,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12617), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11287), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [204392] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12618), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [204457] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17254), 1,
      anon_sym_as,
    ACTIONS(10863), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12619), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [204502] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12620), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [204581] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12621), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [204646] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17932), 1,
      anon_sym_COMMA,
    ACTIONS(10863), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12622), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [204691] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17935), 1,
      sym__immediate_string_start,
    ACTIONS(17937), 1,
      sym__immediate_command_start,
    STATE(12623), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9714), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9716), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [204738] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17771), 1,
      sym__times_operator,
    ACTIONS(17773), 1,
      sym__rational_operator,
    ACTIONS(17775), 1,
      sym__bitshift_operator,
    ACTIONS(17777), 1,
      sym__power_operator,
    ACTIONS(17769), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12624), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [204793] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(16698), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17777), 1,
      sym__power_operator,
    STATE(12625), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [204840] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(12626), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [204885] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12627), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11287), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [204964] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17939), 1,
      anon_sym_where,
    ACTIONS(17941), 1,
      sym__pair_operator,
    ACTIONS(17943), 1,
      sym__arrow_operator,
    ACTIONS(17945), 1,
      sym__lazy_or_operator,
    ACTIONS(17947), 1,
      sym__lazy_and_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12628), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17890), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [205043] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12629), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [205098] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17939), 1,
      anon_sym_where,
    ACTIONS(17943), 1,
      sym__arrow_operator,
    ACTIONS(17945), 1,
      sym__lazy_or_operator,
    ACTIONS(17947), 1,
      sym__lazy_and_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12630), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17890), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [205173] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(12631), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [205218] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17906), 1,
      sym__power_operator,
    STATE(12632), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [205265] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    ACTIONS(15604), 1,
      anon_sym_EQ,
    STATE(12633), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [205312] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    STATE(12393), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12634), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 19,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [205359] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(12635), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [205404] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(12636), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [205449] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(12637), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [205494] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17939), 1,
      anon_sym_where,
    ACTIONS(17947), 1,
      sym__lazy_and_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12638), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17890), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [205565] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17949), 1,
      anon_sym_COMMA,
    STATE(12639), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [205610] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11247), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12640), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [205691] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15604), 1,
      anon_sym_EQ,
    STATE(12641), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [205738] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12642), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 11,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [205805] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(12643), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [205850] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12644), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10964), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [205933] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(12645), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [205978] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12646), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10968), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [206061] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(12647), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [206106] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12648), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10972), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [206189] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15311), 1,
      anon_sym_DASH_GT,
    STATE(12649), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [206234] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12650), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [206317] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(12651), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [206362] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15321), 1,
      anon_sym_DASH_GT,
    ACTIONS(15522), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12652), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [206409] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12653), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [206474] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12654), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 11,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [206543] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12655), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [206624] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12656), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [206701] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12657), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [206774] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12658), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [206845] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12659), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [206906] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12660), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [206971] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12661), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207026] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12662), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207079] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12663), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207130] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12664), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [207179] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12665), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [207226] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17408), 1,
      anon_sym_QMARK,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12666), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [207307] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12667), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [207372] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12668), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 11,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [207441] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15277), 1,
      anon_sym_DASH_GT,
    STATE(12669), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [207486] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15279), 1,
      anon_sym_DASH_GT,
    STATE(12670), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [207531] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17935), 1,
      sym__immediate_string_start,
    ACTIONS(17937), 1,
      sym__immediate_command_start,
    STATE(12671), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9662), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_DOT,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9664), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [207578] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12672), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [207659] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12673), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
  [207736] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12674), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [207809] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12675), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [207880] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12676), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [207941] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12677), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [208006] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17446), 1,
      anon_sym_QMARK,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12678), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [208087] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(12679), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [208132] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11287), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12680), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [208213] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15540), 1,
      anon_sym_EQ,
    STATE(12681), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [208260] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12682), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10978), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [208339] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(12683), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [208384] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(12684), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [208429] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(12685), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [208474] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(12686), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [208519] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11864), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12687), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [208588] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11112), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12688), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [208669] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12689), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym__pair_operator,
  [208750] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12690), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [208815] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17504), 1,
      anon_sym_QMARK,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12691), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [208896] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17440), 1,
      anon_sym_COMMA,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    STATE(12177), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12692), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11022), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [208979] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12693), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [209056] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12694), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [209129] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10639), 1,
      aux_sym__terminator_token1,
    ACTIONS(17952), 1,
      anon_sym_DOT,
    STATE(12695), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [209174] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12259), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12696), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [209257] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15340), 1,
      anon_sym_DASH_GT,
    ACTIONS(15552), 1,
      anon_sym_EQ,
    STATE(12697), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [209304] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12698), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [209385] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12699), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [209456] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12700), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209517] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12701), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [209582] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17954), 1,
      anon_sym_DOT,
    STATE(12702), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [209627] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(12703), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [209672] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12704), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209727] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12705), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209780] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12706), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [209831] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12707), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [209880] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12708), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [209927] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17939), 1,
      anon_sym_where,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12709), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17890), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [209996] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(14277), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12710), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [210079] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17956), 1,
      anon_sym_COMMA,
    ACTIONS(10840), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12711), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 24,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [210124] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15518), 1,
      anon_sym_EQ,
    STATE(12712), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [210171] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12713), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 17,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [210232] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12714), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [210297] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15321), 1,
      anon_sym_DASH_GT,
    ACTIONS(15544), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12715), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [210344] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12716), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [210399] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12717), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [210452] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12718), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [210503] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12719), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [210552] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12720), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [210599] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(14277), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12721), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [210682] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15426), 1,
      anon_sym_EQ,
    STATE(12722), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [210727] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17296), 1,
      sym__power_operator,
    STATE(12723), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [210774] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12724), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [210855] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(12725), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [210900] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17532), 1,
      sym__power_operator,
    STATE(12726), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [210947] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12727), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [211002] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17436), 1,
      sym__power_operator,
    STATE(12728), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [211049] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12729), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [211104] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17474), 1,
      sym__power_operator,
    STATE(12730), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [211151] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12731), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [211216] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(12732), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [211261] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(12733), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211306] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12734), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [211361] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17372), 1,
      anon_sym_QMARK,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12735), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(10835), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [211440] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(12736), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211485] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(12737), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211530] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(12738), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211575] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15602), 1,
      anon_sym_EQ,
    STATE(12739), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211622] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10928), 2,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(10964), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12740), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [211705] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10966), 2,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(10968), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12741), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [211788] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10970), 2,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(10972), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12742), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [211871] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15602), 1,
      anon_sym_EQ,
    STATE(12743), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [211918] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15446), 1,
      anon_sym_EQ,
    STATE(12744), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 26,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [211963] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12745), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      sym__pair_operator,
  [212042] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12746), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [212097] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10878), 1,
      aux_sym__terminator_token1,
    ACTIONS(17914), 1,
      anon_sym_COMMA,
    STATE(12758), 1,
      aux_sym_export_statement_repeat1,
    STATE(12747), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212144] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10882), 1,
      aux_sym__terminator_token1,
    ACTIONS(17914), 1,
      anon_sym_COMMA,
    STATE(12758), 1,
      aux_sym_export_statement_repeat1,
    STATE(12748), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212191] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(12749), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 21,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [212236] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10886), 1,
      aux_sym__terminator_token1,
    ACTIONS(17595), 1,
      anon_sym_COMMA,
    STATE(12383), 1,
      aux_sym__import_list_repeat1,
    STATE(12750), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212283] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    STATE(12751), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212336] = 27,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16919), 1,
      anon_sym_end,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    ACTIONS(17961), 1,
      aux_sym__terminator_token1,
    ACTIONS(17963), 1,
      aux_sym__terminator_token2,
    STATE(14733), 1,
      aux_sym_open_tuple_repeat1,
    STATE(17044), 1,
      aux_sym__block_repeat1,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12752), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [212423] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    STATE(12753), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212474] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    STATE(12754), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212523] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17906), 1,
      sym__power_operator,
    STATE(12755), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212570] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    STATE(12103), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12756), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [212653] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(12757), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 20,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [212698] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10855), 1,
      aux_sym__terminator_token1,
    ACTIONS(17965), 1,
      anon_sym_COMMA,
    STATE(12758), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 25,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212743] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16997), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16999), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17129), 1,
      anon_sym_QMARK,
    ACTIONS(17888), 1,
      anon_sym_COLON,
    ACTIONS(17892), 1,
      sym__pipe_right_operator,
    ACTIONS(17894), 1,
      sym__pipe_left_operator,
    ACTIONS(17896), 1,
      sym__ellipsis_operator,
    ACTIONS(17900), 1,
      sym__times_operator,
    ACTIONS(17902), 1,
      sym__rational_operator,
    ACTIONS(17904), 1,
      sym__bitshift_operator,
    ACTIONS(17906), 1,
      sym__power_operator,
    ACTIONS(17939), 1,
      anon_sym_where,
    ACTIONS(17941), 1,
      sym__pair_operator,
    ACTIONS(17943), 1,
      sym__arrow_operator,
    ACTIONS(17945), 1,
      sym__lazy_or_operator,
    ACTIONS(17947), 1,
      sym__lazy_and_operator,
    ACTIONS(17898), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12759), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17890), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11112), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [212822] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10863), 1,
      aux_sym__terminator_token1,
    ACTIONS(17597), 1,
      anon_sym_as,
    STATE(12760), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 26,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212867] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    STATE(12761), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [212916] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15462), 1,
      anon_sym_DASH_GT,
    STATE(12762), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [212960] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15544), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12763), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [213004] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15321), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12764), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [213048] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    STATE(12767), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12765), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 18,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213094] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    STATE(12766), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [213140] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17972), 1,
      anon_sym_COMMA,
    STATE(12767), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 18,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213184] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10928), 1,
      aux_sym__terminator_token2,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10964), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12768), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [213266] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15462), 1,
      anon_sym_DASH_GT,
    STATE(12769), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213310] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(223), 1,
      anon_sym_DASH_GT,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    STATE(12770), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [213354] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10982), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12771), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10978), 3,
      anon_sym_COMMA,
      sym__pair_operator,
      aux_sym__terminator_token2,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [213432] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12772), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 19,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [213486] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    ACTIONS(10968), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12773), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [213530] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12774), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [213610] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(15456), 1,
      anon_sym_COMMA,
    ACTIONS(15458), 1,
      aux_sym__terminator_token1,
    ACTIONS(15460), 1,
      aux_sym__terminator_token2,
    STATE(16994), 1,
      aux_sym__do_parameter_list_repeat1,
    STATE(12775), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 22,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [213660] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12776), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [213724] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15436), 1,
      anon_sym_DASH_GT,
    STATE(12777), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [213768] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10966), 1,
      aux_sym__terminator_token2,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10968), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12778), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [213850] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12779), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [213918] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12780), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [213998] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12781), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [214074] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12782), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [214138] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12783), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17993), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 10,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [214204] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17995), 1,
      anon_sym_where,
    ACTIONS(17997), 1,
      sym__pair_operator,
    ACTIONS(17999), 1,
      sym__arrow_operator,
    ACTIONS(18001), 1,
      sym__lazy_or_operator,
    ACTIONS(18003), 1,
      sym__lazy_and_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12784), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17993), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [214282] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17995), 1,
      anon_sym_where,
    ACTIONS(17999), 1,
      sym__arrow_operator,
    ACTIONS(18001), 1,
      sym__lazy_or_operator,
    ACTIONS(18003), 1,
      sym__lazy_and_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12785), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17993), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 6,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [214356] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17995), 1,
      anon_sym_where,
    ACTIONS(18003), 1,
      sym__lazy_and_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12786), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17993), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [214426] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17995), 1,
      anon_sym_where,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12787), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17993), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [214494] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12788), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [214554] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12789), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [214618] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12790), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 19,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [214672] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    STATE(12791), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [214724] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    STATE(12792), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [214774] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    STATE(12793), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [214822] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17983), 1,
      sym__power_operator,
    STATE(12794), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [214868] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12795), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [214940] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12796), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [215010] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12797), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215070] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12798), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [215134] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12799), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215188] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(12800), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215240] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(12801), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [215290] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(12802), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [215338] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(12803), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [215384] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    ACTIONS(10972), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12804), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [215428] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(12805), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [215474] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10970), 1,
      aux_sym__terminator_token2,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10972), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12806), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [215556] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12807), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [215636] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(12808), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [215680] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15436), 1,
      anon_sym_DASH_GT,
    STATE(12809), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [215724] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15552), 1,
      anon_sym_EQ,
    STATE(12810), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [215768] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12811), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [215846] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12812), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11022), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [215928] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    ACTIONS(17977), 1,
      sym__times_operator,
    ACTIONS(17979), 1,
      sym__rational_operator,
    ACTIONS(17981), 1,
      sym__bitshift_operator,
    ACTIONS(17983), 1,
      sym__power_operator,
    ACTIONS(17985), 1,
      anon_sym_COLON,
    ACTIONS(17987), 1,
      sym__pipe_right_operator,
    ACTIONS(17989), 1,
      sym__pipe_left_operator,
    ACTIONS(17991), 1,
      sym__ellipsis_operator,
    ACTIONS(17995), 1,
      anon_sym_where,
    ACTIONS(17997), 1,
      sym__pair_operator,
    ACTIONS(17999), 1,
      sym__arrow_operator,
    ACTIONS(18001), 1,
      sym__lazy_or_operator,
    ACTIONS(18003), 1,
      sym__lazy_and_operator,
    ACTIONS(17975), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12813), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11112), 4,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17993), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [216006] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12814), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 4,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [216084] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12815), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18007), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [216150] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    STATE(12816), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [216196] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12817), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym__pair_operator,
  [216274] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12818), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [216338] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18027), 1,
      anon_sym_where,
    ACTIONS(18029), 1,
      sym__pair_operator,
    ACTIONS(18031), 1,
      sym__arrow_operator,
    ACTIONS(18033), 1,
      sym__lazy_or_operator,
    ACTIONS(18035), 1,
      sym__lazy_and_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12819), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(18007), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [216416] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18027), 1,
      anon_sym_where,
    ACTIONS(18031), 1,
      sym__arrow_operator,
    ACTIONS(18033), 1,
      sym__lazy_or_operator,
    ACTIONS(18035), 1,
      sym__lazy_and_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12820), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18007), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [216490] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18027), 1,
      anon_sym_where,
    ACTIONS(18035), 1,
      sym__lazy_and_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12821), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18007), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [216560] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18027), 1,
      anon_sym_where,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12822), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18007), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [216628] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12823), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [216688] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12824), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [216752] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12825), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [216806] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    STATE(12826), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [216858] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    STATE(12827), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [216908] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    STATE(12828), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [216956] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    STATE(12829), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [217002] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10415), 1,
      aux_sym_integer_literal_token4,
    STATE(12830), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10421), 4,
      anon_sym_end,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217048] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    STATE(12831), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [217092] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15380), 1,
      anon_sym_DASH_GT,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(12832), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217138] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    STATE(12833), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217182] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    STATE(12839), 1,
      aux_sym_open_tuple_repeat1,
    STATE(12834), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 18,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217228] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12835), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10964), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [217310] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    STATE(12836), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217354] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12837), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10968), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [217436] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    STATE(12838), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217480] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18039), 1,
      anon_sym_COMMA,
    STATE(12839), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 18,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217524] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12840), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10972), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [217606] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(12841), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217650] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15604), 1,
      anon_sym_EQ,
    STATE(12842), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [217694] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12843), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18044), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 10,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [217760] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11020), 1,
      aux_sym__terminator_token2,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    STATE(14419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11022), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12844), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [217842] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12845), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [217906] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18060), 1,
      anon_sym_where,
    ACTIONS(18062), 1,
      sym__pair_operator,
    ACTIONS(18064), 1,
      sym__arrow_operator,
    ACTIONS(18066), 1,
      sym__lazy_or_operator,
    ACTIONS(18068), 1,
      sym__lazy_and_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12846), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(18044), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [217984] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18060), 1,
      anon_sym_where,
    ACTIONS(18064), 1,
      sym__arrow_operator,
    ACTIONS(18066), 1,
      sym__lazy_or_operator,
    ACTIONS(18068), 1,
      sym__lazy_and_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12847), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18044), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [218058] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18060), 1,
      anon_sym_where,
    ACTIONS(18068), 1,
      sym__lazy_and_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12848), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18044), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [218128] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18060), 1,
      anon_sym_where,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12849), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18044), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [218196] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12850), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [218256] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12851), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [218320] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12852), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [218374] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    STATE(12853), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [218426] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    STATE(12854), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [218476] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    STATE(12855), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [218524] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    STATE(12856), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [218570] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17634), 1,
      aux_sym__terminator_token2,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    STATE(14419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17636), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12857), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [218652] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(10840), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12858), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10835), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [218730] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11277), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12859), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 18,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [218784] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12860), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 13,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [218848] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11866), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12861), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 9,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [218914] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12862), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [218992] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(12863), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [219036] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12864), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 5,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [219110] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    STATE(12865), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [219154] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10928), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12866), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [219236] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12867), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [219306] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12868), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [219374] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(12869), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [219418] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10966), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12870), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [219500] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12871), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [219560] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12872), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 13,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [219624] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(12873), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [219668] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10970), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12874), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [219750] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12875), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 18,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [219804] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12876), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [219856] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12877), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [219906] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12878), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [219954] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15570), 1,
      anon_sym_EQ,
    STATE(12879), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [219998] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12880), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [220044] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12881), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [220088] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(11267), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12882), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [220134] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17877), 1,
      sym__power_operator,
    STATE(12883), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [220180] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15496), 1,
      anon_sym_EQ,
    STATE(12884), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220224] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    STATE(12885), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220268] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15602), 1,
      anon_sym_EQ,
    STATE(12886), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [220312] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18005), 1,
      anon_sym_COLON,
    ACTIONS(18009), 1,
      sym__pipe_right_operator,
    ACTIONS(18011), 1,
      sym__pipe_left_operator,
    ACTIONS(18013), 1,
      sym__ellipsis_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18027), 1,
      anon_sym_where,
    ACTIONS(18029), 1,
      sym__pair_operator,
    ACTIONS(18031), 1,
      sym__arrow_operator,
    ACTIONS(18033), 1,
      sym__lazy_or_operator,
    ACTIONS(18035), 1,
      sym__lazy_and_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12887), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11112), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(18007), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [220390] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    STATE(14733), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11020), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12888), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [220472] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    STATE(14733), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17634), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12889), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [220554] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12890), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10835), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [220632] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12891), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 19,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [220686] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12892), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [220750] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12893), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 10,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [220816] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12894), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [220894] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12895), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 6,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [220968] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17264), 1,
      anon_sym_COLON,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17270), 1,
      anon_sym_QMARK,
    ACTIONS(17272), 1,
      anon_sym_where,
    ACTIONS(17274), 1,
      sym__pair_operator,
    ACTIONS(17276), 1,
      sym__arrow_operator,
    ACTIONS(17278), 1,
      sym__lazy_or_operator,
    ACTIONS(17280), 1,
      sym__lazy_and_operator,
    ACTIONS(17282), 1,
      sym__pipe_right_operator,
    ACTIONS(17284), 1,
      sym__pipe_left_operator,
    ACTIONS(17286), 1,
      sym__ellipsis_operator,
    ACTIONS(17290), 1,
      sym__times_operator,
    ACTIONS(17292), 1,
      sym__rational_operator,
    ACTIONS(17294), 1,
      sym__bitshift_operator,
    ACTIONS(17296), 1,
      sym__power_operator,
    ACTIONS(17288), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12896), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
    ACTIONS(17266), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [221046] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12897), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [221116] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12898), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 9,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [221184] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12899), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 16,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [221244] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12900), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [221308] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12901), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 19,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [221362] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(12902), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221406] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(12903), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221450] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(12904), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221494] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    STATE(12905), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221546] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    STATE(12906), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221596] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    STATE(12907), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221644] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17877), 1,
      sym__power_operator,
    STATE(12908), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 24,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221690] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(12909), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [221734] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12910), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [221812] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12911), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221856] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    ACTIONS(10964), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12912), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221900] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    ACTIONS(10968), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12913), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221944] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    ACTIONS(10972), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12914), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [221988] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(12915), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222032] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(12916), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222076] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(12917), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222120] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(12918), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222164] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(12919), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222208] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    STATE(12634), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12920), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11022), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [222290] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15516), 1,
      anon_sym_EQ,
    STATE(12921), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222334] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15402), 1,
      anon_sym_DASH_GT,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(12922), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [222380] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    ACTIONS(11022), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12923), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222424] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(12924), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222468] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    ACTIONS(11022), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(12925), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222512] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10835), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12926), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10840), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [222592] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12927), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [222670] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17314), 1,
      anon_sym_COLON,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17322), 1,
      anon_sym_where,
    ACTIONS(17324), 1,
      sym__arrow_operator,
    ACTIONS(17326), 1,
      sym__lazy_or_operator,
    ACTIONS(17328), 1,
      sym__lazy_and_operator,
    ACTIONS(17330), 1,
      sym__pipe_right_operator,
    ACTIONS(17332), 1,
      sym__pipe_left_operator,
    ACTIONS(17334), 1,
      sym__ellipsis_operator,
    ACTIONS(17338), 1,
      sym__times_operator,
    ACTIONS(17340), 1,
      sym__rational_operator,
    ACTIONS(17342), 1,
      sym__bitshift_operator,
    ACTIONS(17344), 1,
      sym__power_operator,
    ACTIONS(17480), 1,
      sym__pair_operator,
    ACTIONS(17581), 1,
      anon_sym_QMARK,
    ACTIONS(17336), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12928), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 4,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17316), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [222748] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10964), 1,
      aux_sym__terminator_token1,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(12929), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222792] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10968), 1,
      aux_sym__terminator_token1,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(12930), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222836] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10972), 1,
      aux_sym__terminator_token1,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(12931), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 25,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [222880] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18076), 1,
      sym__pair_operator,
    ACTIONS(18078), 1,
      sym__arrow_operator,
    ACTIONS(18080), 1,
      sym__lazy_or_operator,
    ACTIONS(18082), 1,
      sym__lazy_and_operator,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12932), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(12670), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [222958] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10835), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12933), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10840), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [223038] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15344), 1,
      anon_sym_DASH_GT,
    STATE(12934), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [223082] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17268), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17970), 1,
      sym__power_operator,
    ACTIONS(18017), 1,
      sym__times_operator,
    ACTIONS(18019), 1,
      sym__rational_operator,
    ACTIONS(18021), 1,
      sym__bitshift_operator,
    ACTIONS(18015), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12935), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_catch,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [223136] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(12936), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [223180] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15380), 1,
      anon_sym_DASH_GT,
    ACTIONS(15516), 1,
      anon_sym_EQ,
    STATE(12937), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [223226] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11020), 1,
      aux_sym__terminator_token2,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    STATE(12464), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11022), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12938), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [223308] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(11249), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12939), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [223386] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(11289), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12940), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [223464] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18076), 1,
      sym__pair_operator,
    ACTIONS(18078), 1,
      sym__arrow_operator,
    ACTIONS(18080), 1,
      sym__lazy_or_operator,
    ACTIONS(18082), 1,
      sym__lazy_and_operator,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12941), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(18102), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [223542] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12942), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [223620] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12943), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [223698] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12944), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [223778] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17787), 1,
      anon_sym_QMARK,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(11114), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12945), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11112), 3,
      anon_sym_COMMA,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [223856] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11022), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12946), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [223940] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11022), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12947), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224024] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18076), 1,
      sym__pair_operator,
    ACTIONS(18078), 1,
      sym__arrow_operator,
    ACTIONS(18080), 1,
      sym__lazy_or_operator,
    ACTIONS(18082), 1,
      sym__lazy_and_operator,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12948), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [224102] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12949), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [224180] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12950), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      sym__pair_operator,
  [224260] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18176), 1,
      anon_sym_where,
    ACTIONS(18178), 1,
      sym__pair_operator,
    ACTIONS(18180), 1,
      sym__arrow_operator,
    ACTIONS(18182), 1,
      sym__lazy_or_operator,
    ACTIONS(18184), 1,
      sym__lazy_and_operator,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12951), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [224338] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18176), 1,
      anon_sym_where,
    ACTIONS(18178), 1,
      sym__pair_operator,
    ACTIONS(18180), 1,
      sym__arrow_operator,
    ACTIONS(18182), 1,
      sym__lazy_or_operator,
    ACTIONS(18184), 1,
      sym__lazy_and_operator,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12952), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [224416] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12953), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [224494] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12954), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [224574] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12955), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [224654] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12956), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [224734] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10964), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12957), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224818] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10968), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12958), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224902] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10972), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12959), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [224986] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18208), 1,
      anon_sym_where,
    ACTIONS(18210), 1,
      sym__pair_operator,
    ACTIONS(18212), 1,
      sym__arrow_operator,
    ACTIONS(18214), 1,
      sym__lazy_or_operator,
    ACTIONS(18216), 1,
      sym__lazy_and_operator,
    ACTIONS(18218), 1,
      sym__comparison_operator,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12960), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18206), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [225066] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10964), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12961), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225150] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10968), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12962), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225234] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10972), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12963), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225318] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17402), 1,
      anon_sym_COLON,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17410), 1,
      anon_sym_where,
    ACTIONS(17412), 1,
      sym__pair_operator,
    ACTIONS(17414), 1,
      sym__arrow_operator,
    ACTIONS(17416), 1,
      sym__lazy_or_operator,
    ACTIONS(17418), 1,
      sym__lazy_and_operator,
    ACTIONS(17420), 1,
      sym__comparison_operator,
    ACTIONS(17422), 1,
      sym__pipe_right_operator,
    ACTIONS(17424), 1,
      sym__pipe_left_operator,
    ACTIONS(17426), 1,
      sym__ellipsis_operator,
    ACTIONS(17430), 1,
      sym__times_operator,
    ACTIONS(17432), 1,
      sym__rational_operator,
    ACTIONS(17434), 1,
      sym__bitshift_operator,
    ACTIONS(17436), 1,
      sym__power_operator,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    ACTIONS(17428), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12964), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17404), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [225396] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17442), 1,
      anon_sym_COLON,
    ACTIONS(17448), 1,
      anon_sym_where,
    ACTIONS(17450), 1,
      sym__pair_operator,
    ACTIONS(17452), 1,
      sym__arrow_operator,
    ACTIONS(17454), 1,
      sym__lazy_or_operator,
    ACTIONS(17456), 1,
      sym__lazy_and_operator,
    ACTIONS(17458), 1,
      sym__comparison_operator,
    ACTIONS(17460), 1,
      sym__pipe_right_operator,
    ACTIONS(17462), 1,
      sym__pipe_left_operator,
    ACTIONS(17464), 1,
      sym__ellipsis_operator,
    ACTIONS(17468), 1,
      sym__times_operator,
    ACTIONS(17470), 1,
      sym__rational_operator,
    ACTIONS(17472), 1,
      sym__bitshift_operator,
    ACTIONS(17474), 1,
      sym__power_operator,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    ACTIONS(17466), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12965), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17444), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [225474] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18240), 1,
      anon_sym_QMARK,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18244), 1,
      sym__pair_operator,
    ACTIONS(18246), 1,
      sym__arrow_operator,
    ACTIONS(18248), 1,
      sym__lazy_or_operator,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12966), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [225554] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18240), 1,
      anon_sym_QMARK,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18244), 1,
      sym__pair_operator,
    ACTIONS(18246), 1,
      sym__arrow_operator,
    ACTIONS(18248), 1,
      sym__lazy_or_operator,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12967), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [225634] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18274), 1,
      anon_sym_QMARK,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18278), 1,
      sym__pair_operator,
    ACTIONS(18280), 1,
      sym__arrow_operator,
    ACTIONS(18282), 1,
      sym__lazy_or_operator,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12968), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [225714] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18274), 1,
      anon_sym_QMARK,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18278), 1,
      sym__pair_operator,
    ACTIONS(18280), 1,
      sym__arrow_operator,
    ACTIONS(18282), 1,
      sym__lazy_or_operator,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12969), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [225794] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18308), 1,
      anon_sym_QMARK,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18312), 1,
      sym__pair_operator,
    ACTIONS(18314), 1,
      sym__arrow_operator,
    ACTIONS(18316), 1,
      sym__lazy_or_operator,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11112), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12970), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225874] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18308), 1,
      anon_sym_QMARK,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18312), 1,
      sym__pair_operator,
    ACTIONS(18314), 1,
      sym__arrow_operator,
    ACTIONS(18316), 1,
      sym__lazy_or_operator,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12971), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [225954] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18208), 1,
      anon_sym_where,
    ACTIONS(18210), 1,
      sym__pair_operator,
    ACTIONS(18212), 1,
      sym__arrow_operator,
    ACTIONS(18214), 1,
      sym__lazy_or_operator,
    ACTIONS(18216), 1,
      sym__lazy_and_operator,
    ACTIONS(18218), 1,
      sym__comparison_operator,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12972), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18206), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [226034] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12973), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [226088] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17747), 1,
      anon_sym_QMARK,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12974), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [226168] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18076), 1,
      sym__pair_operator,
    ACTIONS(18078), 1,
      sym__arrow_operator,
    ACTIONS(18080), 1,
      sym__lazy_or_operator,
    ACTIONS(18082), 1,
      sym__lazy_and_operator,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12975), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(12746), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [226246] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15340), 1,
      anon_sym_DASH_GT,
    STATE(12976), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [226290] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12977), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [226370] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15618), 1,
      anon_sym_EQ,
    STATE(12978), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [226416] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18240), 1,
      anon_sym_QMARK,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18244), 1,
      sym__pair_operator,
    ACTIONS(18246), 1,
      sym__arrow_operator,
    ACTIONS(18248), 1,
      sym__lazy_or_operator,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12979), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [226496] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18274), 1,
      anon_sym_QMARK,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18278), 1,
      sym__pair_operator,
    ACTIONS(18280), 1,
      sym__arrow_operator,
    ACTIONS(18282), 1,
      sym__lazy_or_operator,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12980), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [226576] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12981), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [226656] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18240), 1,
      anon_sym_QMARK,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18244), 1,
      sym__pair_operator,
    ACTIONS(18246), 1,
      sym__arrow_operator,
    ACTIONS(18248), 1,
      sym__lazy_or_operator,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12982), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [226736] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18274), 1,
      anon_sym_QMARK,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18278), 1,
      sym__pair_operator,
    ACTIONS(18280), 1,
      sym__arrow_operator,
    ACTIONS(18282), 1,
      sym__lazy_or_operator,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12983), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [226816] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12984), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [226896] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17500), 1,
      anon_sym_COLON,
    ACTIONS(17506), 1,
      anon_sym_where,
    ACTIONS(17508), 1,
      sym__pair_operator,
    ACTIONS(17510), 1,
      sym__arrow_operator,
    ACTIONS(17512), 1,
      sym__lazy_or_operator,
    ACTIONS(17514), 1,
      sym__lazy_and_operator,
    ACTIONS(17516), 1,
      sym__comparison_operator,
    ACTIONS(17518), 1,
      sym__pipe_right_operator,
    ACTIONS(17520), 1,
      sym__pipe_left_operator,
    ACTIONS(17522), 1,
      sym__ellipsis_operator,
    ACTIONS(17526), 1,
      sym__times_operator,
    ACTIONS(17528), 1,
      sym__rational_operator,
    ACTIONS(17530), 1,
      sym__bitshift_operator,
    ACTIONS(17532), 1,
      sym__power_operator,
    ACTIONS(17731), 1,
      anon_sym_QMARK,
    ACTIONS(17524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12985), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17502), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_COMMA,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [226976] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18308), 1,
      anon_sym_QMARK,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18312), 1,
      sym__pair_operator,
    ACTIONS(18314), 1,
      sym__arrow_operator,
    ACTIONS(18316), 1,
      sym__lazy_or_operator,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11247), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12986), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227056] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18308), 1,
      anon_sym_QMARK,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18312), 1,
      sym__pair_operator,
    ACTIONS(18314), 1,
      sym__arrow_operator,
    ACTIONS(18316), 1,
      sym__lazy_or_operator,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11287), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12987), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [227136] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    STATE(12988), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 25,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [227180] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    STATE(12989), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227224] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15508), 1,
      anon_sym_EQ,
    STATE(12990), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [227268] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12991), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [227332] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12992), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
  [227408] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12993), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [227480] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12994), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [227550] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12995), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [227610] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12996), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [227674] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(12997), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [227728] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(12998), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [227780] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(12999), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [227830] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(13000), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [227878] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(13001), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [227924] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(13002), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [227970] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13003), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [228024] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(13004), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228068] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13005), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10964), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228150] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(13006), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228194] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13007), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10968), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228276] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(13008), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 20,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228320] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(17745), 1,
      anon_sym_COMMA,
    STATE(12491), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13009), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10972), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [228402] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15354), 1,
      anon_sym_DASH_GT,
    STATE(13010), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228446] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15522), 1,
      anon_sym_EQ,
    ACTIONS(9212), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(13011), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [228490] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15402), 1,
      anon_sym_DASH_GT,
    ACTIONS(15618), 1,
      anon_sym_EQ,
    STATE(13012), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [228536] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13013), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [228600] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13014), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [228668] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18246), 1,
      sym__arrow_operator,
    ACTIONS(18248), 1,
      sym__lazy_or_operator,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13015), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [228744] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13016), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [228816] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13017), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [228886] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13018), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [228946] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13019), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [229010] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13020), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [229064] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    STATE(13021), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [229116] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    STATE(13022), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [229166] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    STATE(13023), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [229214] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18302), 1,
      sym__power_operator,
    STATE(13024), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [229260] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10982), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13025), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10978), 4,
      anon_sym_COMMA,
      anon_sym_end,
      sym__pair_operator,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [229338] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13026), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [229402] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13027), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [229470] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18280), 1,
      sym__arrow_operator,
    ACTIONS(18282), 1,
      sym__lazy_or_operator,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13028), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
  [229546] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13029), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [229618] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13030), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [229688] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13031), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [229748] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13032), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [229812] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16558), 1,
      sym__power_operator,
    STATE(13033), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [229858] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13034), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(11110), 12,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [229922] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18314), 1,
      sym__arrow_operator,
    ACTIONS(18316), 1,
      sym__lazy_or_operator,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13035), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [229998] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13036), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [230070] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13037), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [230140] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13038), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(11110), 14,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230200] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13039), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(11110), 12,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [230264] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13040), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230318] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    STATE(13041), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230370] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    STATE(13042), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230420] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    STATE(13043), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [230468] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18336), 1,
      sym__power_operator,
    STATE(13044), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [230514] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13045), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230568] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    STATE(13046), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230620] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    STATE(13047), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230670] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    STATE(13048), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [230718] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18268), 1,
      sym__power_operator,
    STATE(13049), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [230764] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18268), 1,
      sym__power_operator,
    STATE(13050), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [230810] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13051), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230864] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18302), 1,
      sym__power_operator,
    STATE(13052), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [230910] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13053), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [230964] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18336), 1,
      sym__power_operator,
    STATE(13054), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [231010] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13055), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [231064] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15478), 1,
      anon_sym_DASH_GT,
    ACTIONS(15508), 1,
      anon_sym_EQ,
    STATE(13056), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231110] = 25,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    STATE(12419), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11020), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13057), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [231192] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13058), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231236] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17853), 1,
      anon_sym_QMARK,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13059), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11112), 4,
      anon_sym_COMMA,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [231314] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15464), 1,
      anon_sym_DASH_GT,
    STATE(13060), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [231358] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18176), 1,
      anon_sym_where,
    ACTIONS(18178), 1,
      sym__pair_operator,
    ACTIONS(18180), 1,
      sym__arrow_operator,
    ACTIONS(18182), 1,
      sym__lazy_or_operator,
    ACTIONS(18184), 1,
      sym__lazy_and_operator,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13061), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(12670), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [231436] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13062), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [231500] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13063), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 11,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [231566] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18078), 1,
      sym__arrow_operator,
    ACTIONS(18080), 1,
      sym__lazy_or_operator,
    ACTIONS(18082), 1,
      sym__lazy_and_operator,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13064), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [231640] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18082), 1,
      sym__lazy_and_operator,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13065), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [231710] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13066), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [231778] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13067), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [231838] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13068), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [231902] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13069), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [231956] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    STATE(13070), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [232008] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    STATE(13071), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [232058] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    STATE(13072), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [232106] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18202), 1,
      sym__power_operator,
    STATE(13073), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [232152] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13074), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [232216] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13075), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 11,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [232282] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18176), 1,
      anon_sym_where,
    ACTIONS(18180), 1,
      sym__arrow_operator,
    ACTIONS(18182), 1,
      sym__lazy_or_operator,
    ACTIONS(18184), 1,
      sym__lazy_and_operator,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13076), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
  [232356] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18176), 1,
      anon_sym_where,
    ACTIONS(18184), 1,
      sym__lazy_and_operator,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13077), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [232426] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18176), 1,
      anon_sym_where,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13078), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [232494] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13079), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [232554] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13080), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [232618] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17908), 1,
      anon_sym_QMARK,
    ACTIONS(18172), 1,
      anon_sym_COLON,
    ACTIONS(18176), 1,
      anon_sym_where,
    ACTIONS(18178), 1,
      sym__pair_operator,
    ACTIONS(18180), 1,
      sym__arrow_operator,
    ACTIONS(18182), 1,
      sym__lazy_or_operator,
    ACTIONS(18184), 1,
      sym__lazy_and_operator,
    ACTIONS(18186), 1,
      sym__comparison_operator,
    ACTIONS(18188), 1,
      sym__pipe_right_operator,
    ACTIONS(18190), 1,
      sym__pipe_left_operator,
    ACTIONS(18192), 1,
      sym__ellipsis_operator,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13081), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18174), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(12746), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [232696] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15464), 1,
      anon_sym_DASH_GT,
    STATE(13082), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [232740] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13083), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [232808] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    ACTIONS(10964), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(13084), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [232852] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15462), 1,
      anon_sym_DASH_GT,
    STATE(13085), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [232896] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15540), 1,
      anon_sym_EQ,
    STATE(13086), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [232940] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17318), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17983), 1,
      sym__power_operator,
    STATE(13087), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 24,
      anon_sym_COMMA,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [232986] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13088), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [233050] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18208), 1,
      anon_sym_where,
    ACTIONS(18212), 1,
      sym__arrow_operator,
    ACTIONS(18214), 1,
      sym__lazy_or_operator,
    ACTIONS(18216), 1,
      sym__lazy_and_operator,
    ACTIONS(18218), 1,
      sym__comparison_operator,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13089), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18206), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [233126] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18208), 1,
      anon_sym_where,
    ACTIONS(18216), 1,
      sym__lazy_and_operator,
    ACTIONS(18218), 1,
      sym__comparison_operator,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13090), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18206), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [233198] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18208), 1,
      anon_sym_where,
    ACTIONS(18218), 1,
      sym__comparison_operator,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13091), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18206), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [233268] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13092), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [233328] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13093), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [233392] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13094), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [233446] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    STATE(13095), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [233498] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    STATE(13096), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [233548] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    STATE(13097), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [233596] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18234), 1,
      sym__power_operator,
    STATE(13098), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [233642] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13099), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [233696] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    STATE(13100), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [233748] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    STATE(13101), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [233798] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    STATE(13102), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [233846] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18100), 1,
      sym__power_operator,
    STATE(13103), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [233892] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15321), 1,
      anon_sym_DASH_GT,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    STATE(13104), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [233938] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18204), 1,
      anon_sym_COLON,
    ACTIONS(18218), 1,
      sym__comparison_operator,
    ACTIONS(18220), 1,
      sym__pipe_right_operator,
    ACTIONS(18222), 1,
      sym__pipe_left_operator,
    ACTIONS(18224), 1,
      sym__ellipsis_operator,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13105), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18206), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [234006] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18100), 1,
      sym__power_operator,
    STATE(13106), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [234052] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13107), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [234106] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18202), 1,
      sym__power_operator,
    STATE(13108), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 19,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [234152] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18196), 1,
      sym__times_operator,
    ACTIONS(18198), 1,
      sym__rational_operator,
    ACTIONS(18200), 1,
      sym__bitshift_operator,
    ACTIONS(18202), 1,
      sym__power_operator,
    ACTIONS(18194), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13109), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 17,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [234206] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15236), 1,
      sym__immediate_paren,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    STATE(13110), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [234252] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(11864), 2,
      anon_sym_EQ,
      aux_sym_integer_literal_token4,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13111), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [234320] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18234), 1,
      sym__power_operator,
    STATE(13112), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [234366] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18228), 1,
      sym__times_operator,
    ACTIONS(18230), 1,
      sym__rational_operator,
    ACTIONS(18232), 1,
      sym__bitshift_operator,
    ACTIONS(18234), 1,
      sym__power_operator,
    ACTIONS(18226), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13113), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [234420] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(13114), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234466] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18338), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_as,
    ACTIONS(18342), 1,
      anon_sym_COLON,
    STATE(13411), 1,
      aux_sym__import_list_repeat1,
    STATE(13115), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 6,
      anon_sym_EQ,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234516] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18344), 1,
      anon_sym_DOT,
    STATE(13116), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10757), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10759), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_as,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234560] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18344), 1,
      anon_sym_DOT,
    STATE(13117), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10761), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10763), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_as,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234604] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18344), 1,
      anon_sym_DOT,
    STATE(13118), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10727), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10731), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_as,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234648] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18338), 1,
      anon_sym_COMMA,
    ACTIONS(18340), 1,
      anon_sym_as,
    STATE(13411), 1,
      aux_sym__import_list_repeat1,
    STATE(13119), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234696] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15436), 1,
      anon_sym_DASH_GT,
    STATE(13120), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234740] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    ACTIONS(18023), 1,
      sym__power_operator,
    ACTIONS(18042), 1,
      anon_sym_COLON,
    ACTIONS(18046), 1,
      sym__pipe_right_operator,
    ACTIONS(18048), 1,
      sym__pipe_left_operator,
    ACTIONS(18050), 1,
      sym__ellipsis_operator,
    ACTIONS(18054), 1,
      sym__times_operator,
    ACTIONS(18056), 1,
      sym__rational_operator,
    ACTIONS(18058), 1,
      sym__bitshift_operator,
    ACTIONS(18060), 1,
      anon_sym_where,
    ACTIONS(18062), 1,
      sym__pair_operator,
    ACTIONS(18064), 1,
      sym__arrow_operator,
    ACTIONS(18066), 1,
      sym__lazy_or_operator,
    ACTIONS(18068), 1,
      sym__lazy_and_operator,
    ACTIONS(18052), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13121), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11112), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(18044), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [234818] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17366), 1,
      anon_sym_COLON,
    ACTIONS(17370), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17374), 1,
      anon_sym_where,
    ACTIONS(17376), 1,
      sym__arrow_operator,
    ACTIONS(17378), 1,
      sym__lazy_or_operator,
    ACTIONS(17380), 1,
      sym__lazy_and_operator,
    ACTIONS(17382), 1,
      sym__pipe_right_operator,
    ACTIONS(17384), 1,
      sym__pipe_left_operator,
    ACTIONS(17386), 1,
      sym__ellipsis_operator,
    ACTIONS(17390), 1,
      sym__times_operator,
    ACTIONS(17392), 1,
      sym__rational_operator,
    ACTIONS(17394), 1,
      sym__bitshift_operator,
    ACTIONS(17396), 1,
      sym__power_operator,
    ACTIONS(17484), 1,
      sym__pair_operator,
    ACTIONS(17545), 1,
      anon_sym_QMARK,
    ACTIONS(17388), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13122), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
    ACTIONS(17368), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [234896] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18344), 1,
      anon_sym_DOT,
    STATE(13123), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 19,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_as,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234940] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15518), 1,
      anon_sym_EQ,
    STATE(13124), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 20,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [234984] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13125), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [235038] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17733), 1,
      anon_sym_QMARK,
    ACTIONS(18070), 1,
      anon_sym_COLON,
    ACTIONS(18074), 1,
      anon_sym_where,
    ACTIONS(18076), 1,
      sym__pair_operator,
    ACTIONS(18078), 1,
      sym__arrow_operator,
    ACTIONS(18080), 1,
      sym__lazy_or_operator,
    ACTIONS(18082), 1,
      sym__lazy_and_operator,
    ACTIONS(18084), 1,
      sym__comparison_operator,
    ACTIONS(18086), 1,
      sym__pipe_right_operator,
    ACTIONS(18088), 1,
      sym__pipe_left_operator,
    ACTIONS(18090), 1,
      sym__ellipsis_operator,
    ACTIONS(18094), 1,
      sym__times_operator,
    ACTIONS(18096), 1,
      sym__rational_operator,
    ACTIONS(18098), 1,
      sym__bitshift_operator,
    ACTIONS(18100), 1,
      sym__power_operator,
    ACTIONS(18092), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13126), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18072), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [235116] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13127), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [235185] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(13128), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [235234] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(13129), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [235281] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(13130), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [235326] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18352), 1,
      anon_sym_COMMA,
    STATE(13131), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235369] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(18355), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13132), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18182), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [235420] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13133), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235499] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15546), 1,
      anon_sym_DASH_GT,
    STATE(13134), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235542] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_EQ,
    ACTIONS(11022), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13135), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235625] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13136), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235704] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(13137), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235747] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12214), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13138), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [235798] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18399), 1,
      anon_sym_where,
    ACTIONS(18401), 1,
      sym__pair_operator,
    ACTIONS(18403), 1,
      sym__arrow_operator,
    ACTIONS(18405), 1,
      sym__lazy_or_operator,
    ACTIONS(18407), 1,
      sym__lazy_and_operator,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11112), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    ACTIONS(11114), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13139), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18397), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [235875] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(13140), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [235918] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11022), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13141), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [235999] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(13142), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [236042] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    ACTIONS(11247), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    ACTIONS(11249), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13143), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [236119] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13182), 1,
      anon_sym_DOT2,
    ACTIONS(18421), 1,
      sym__word_identifier,
    STATE(6445), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6679), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13144), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13192), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13184), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13204), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [236170] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10982), 2,
      anon_sym_end,
      sym__pair_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13145), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236251] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(13146), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [236294] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13147), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10982), 3,
      anon_sym_COMMA,
      anon_sym_end,
      sym__pair_operator,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236373] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13830), 1,
      anon_sym_DOT2,
    ACTIONS(18423), 1,
      sym__word_identifier,
    STATE(7742), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8287), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13148), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13840), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13832), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13846), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [236424] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14886), 1,
      anon_sym_DOT2,
    ACTIONS(18425), 1,
      sym__word_identifier,
    STATE(7663), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8075), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13149), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14896), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14888), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14902), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [236475] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18431), 1,
      anon_sym_QMARK,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18435), 1,
      sym__pair_operator,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13150), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236554] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10835), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13151), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10840), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236633] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15546), 1,
      anon_sym_DASH_GT,
    STATE(13152), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [236676] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    STATE(13155), 1,
      aux_sym_open_tuple_repeat1,
    STATE(13153), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [236721] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13154), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236800] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18463), 1,
      anon_sym_COMMA,
    STATE(13155), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10840), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [236843] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11020), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13156), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [236924] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_EQ,
    ACTIONS(10964), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13157), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237007] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_EQ,
    ACTIONS(10968), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13158), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237090] = 26,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_EQ,
    ACTIONS(10972), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13159), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237173] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13160), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237252] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14070), 1,
      anon_sym_DOT2,
    ACTIONS(16496), 1,
      sym__word_identifier,
    STATE(6819), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7225), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13161), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14080), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14072), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14092), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [237303] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13114), 1,
      anon_sym_DOT2,
    ACTIONS(18500), 1,
      sym__word_identifier,
    STATE(7449), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8178), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13162), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13124), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13116), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13136), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [237354] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14386), 1,
      anon_sym_DOT2,
    ACTIONS(16354), 1,
      sym__word_identifier,
    STATE(6924), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7690), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13163), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14396), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14388), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14408), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [237405] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13514), 1,
      anon_sym_DOT2,
    ACTIONS(18502), 1,
      sym__word_identifier,
    STATE(6813), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7392), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13164), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13524), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13516), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13530), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [237456] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14496), 1,
      anon_sym_DOT2,
    ACTIONS(18504), 1,
      sym__word_identifier,
    STATE(7242), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8349), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13165), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14506), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14498), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14512), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [237507] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10928), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13166), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237588] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10966), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13167), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237669] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10970), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13168), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237750] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10978), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(10982), 2,
      anon_sym_COMMA,
      sym__pair_operator,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13169), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237829] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(13170), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [237872] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10835), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13171), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10840), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [237951] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(13172), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [237994] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(13173), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [238037] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14176), 1,
      anon_sym_DOT2,
    ACTIONS(16294), 1,
      sym__word_identifier,
    STATE(6957), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7879), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13174), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14186), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14178), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14198), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [238088] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10198), 1,
      anon_sym_DASH_GT,
    ACTIONS(15600), 1,
      aux_sym__terminator_token1,
    ACTIONS(15598), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    STATE(13175), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 22,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [238133] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13716), 1,
      anon_sym_DOT2,
    ACTIONS(18506), 1,
      sym__word_identifier,
    STATE(6254), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6361), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13176), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13726), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13718), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13738), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [238184] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15380), 1,
      anon_sym_DASH_GT,
    STATE(13177), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [238227] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10964), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13178), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238308] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14736), 1,
      anon_sym_DOT2,
    ACTIONS(18508), 1,
      sym__word_identifier,
    STATE(9102), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(9214), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13179), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14746), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14738), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14752), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [238359] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12395), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13180), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [238410] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13902), 1,
      anon_sym_DOT2,
    ACTIONS(18510), 1,
      sym__word_identifier,
    STATE(7818), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8517), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13181), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13912), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13904), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13918), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [238461] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18431), 1,
      anon_sym_QMARK,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18435), 1,
      sym__pair_operator,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13182), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238540] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10968), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13183), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238621] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14924), 1,
      anon_sym_DOT2,
    ACTIONS(18512), 1,
      sym__word_identifier,
    STATE(6356), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6663), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13184), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14934), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14926), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14944), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [238672] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15618), 1,
      anon_sym_EQ,
    STATE(13185), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [238715] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15590), 1,
      anon_sym_DASH_GT,
    ACTIONS(15756), 1,
      anon_sym_EQ,
    STATE(13186), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [238760] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17968), 1,
      anon_sym_COMMA,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    STATE(12765), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10972), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13187), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238841] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18431), 1,
      anon_sym_QMARK,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18435), 1,
      sym__pair_operator,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13188), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [238920] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18514), 1,
      sym__power_operator,
    STATE(13189), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [238965] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13190), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [239028] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18534), 1,
      sym__comparison_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13191), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [239093] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14340), 1,
      anon_sym_DOT2,
    ACTIONS(16340), 1,
      sym__word_identifier,
    STATE(8743), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8971), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13192), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14350), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14342), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14362), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [239144] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18534), 1,
      sym__comparison_operator,
    ACTIONS(18536), 1,
      anon_sym_where,
    ACTIONS(18538), 1,
      sym__pair_operator,
    ACTIONS(18540), 1,
      sym__arrow_operator,
    ACTIONS(18542), 1,
      sym__lazy_or_operator,
    ACTIONS(18544), 1,
      sym__lazy_and_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13193), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [239221] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18312), 1,
      sym__pair_operator,
    ACTIONS(18314), 1,
      sym__arrow_operator,
    ACTIONS(18316), 1,
      sym__lazy_or_operator,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(18546), 1,
      anon_sym_QMARK,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13194), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239300] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11267), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    STATE(13195), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [239345] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18304), 1,
      anon_sym_COLON,
    ACTIONS(18310), 1,
      anon_sym_where,
    ACTIONS(18312), 1,
      sym__pair_operator,
    ACTIONS(18314), 1,
      sym__arrow_operator,
    ACTIONS(18316), 1,
      sym__lazy_or_operator,
    ACTIONS(18318), 1,
      sym__lazy_and_operator,
    ACTIONS(18320), 1,
      sym__comparison_operator,
    ACTIONS(18322), 1,
      sym__pipe_right_operator,
    ACTIONS(18324), 1,
      sym__pipe_left_operator,
    ACTIONS(18326), 1,
      sym__ellipsis_operator,
    ACTIONS(18330), 1,
      sym__times_operator,
    ACTIONS(18332), 1,
      sym__rational_operator,
    ACTIONS(18334), 1,
      sym__bitshift_operator,
    ACTIONS(18336), 1,
      sym__power_operator,
    ACTIONS(18546), 1,
      anon_sym_QMARK,
    ACTIONS(18328), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13196), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18306), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239424] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13197), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [239477] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11114), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18554), 1,
      anon_sym_where,
    ACTIONS(18556), 1,
      sym__pair_operator,
    ACTIONS(18558), 1,
      sym__arrow_operator,
    ACTIONS(18560), 1,
      sym__lazy_or_operator,
    ACTIONS(18562), 1,
      sym__lazy_and_operator,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13198), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11112), 3,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(18552), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [239554] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(11022), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13199), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [239635] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13200), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [239698] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13750), 1,
      anon_sym_DOT2,
    ACTIONS(16328), 1,
      sym__word_identifier,
    STATE(7191), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7735), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13201), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13760), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13752), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13772), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [239749] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18600), 1,
      sym__comparison_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13202), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [239814] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18600), 1,
      sym__comparison_operator,
    ACTIONS(18602), 1,
      anon_sym_QMARK,
    ACTIONS(18604), 1,
      anon_sym_where,
    ACTIONS(18606), 1,
      sym__pair_operator,
    ACTIONS(18608), 1,
      sym__arrow_operator,
    ACTIONS(18610), 1,
      sym__lazy_or_operator,
    ACTIONS(18612), 1,
      sym__lazy_and_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13203), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [239891] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13204), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [239954] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13205), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
  [240027] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13206), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [240096] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13207), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [240163] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13208), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [240222] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13209), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [240285] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13210), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [240338] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    STATE(13211), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [240389] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    STATE(13212), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [240438] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    STATE(13213), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [240485] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18630), 1,
      sym__power_operator,
    STATE(13214), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [240530] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18600), 1,
      sym__comparison_operator,
    ACTIONS(18604), 1,
      anon_sym_where,
    ACTIONS(18608), 1,
      sym__arrow_operator,
    ACTIONS(18610), 1,
      sym__lazy_or_operator,
    ACTIONS(18612), 1,
      sym__lazy_and_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13215), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [240603] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18600), 1,
      sym__comparison_operator,
    ACTIONS(18604), 1,
      anon_sym_where,
    ACTIONS(18612), 1,
      sym__lazy_and_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13216), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [240672] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18600), 1,
      sym__comparison_operator,
    ACTIONS(18604), 1,
      anon_sym_where,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13217), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [240739] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13218), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [240802] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18546), 1,
      anon_sym_QMARK,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18664), 1,
      anon_sym_where,
    ACTIONS(18666), 1,
      sym__pair_operator,
    ACTIONS(18668), 1,
      sym__arrow_operator,
    ACTIONS(18670), 1,
      sym__lazy_or_operator,
    ACTIONS(18672), 1,
      sym__lazy_and_operator,
    ACTIONS(18674), 1,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13219), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18662), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [240881] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18664), 1,
      anon_sym_where,
    ACTIONS(18668), 1,
      sym__arrow_operator,
    ACTIONS(18670), 1,
      sym__lazy_or_operator,
    ACTIONS(18672), 1,
      sym__lazy_and_operator,
    ACTIONS(18674), 1,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13220), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18662), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
  [240956] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18664), 1,
      anon_sym_where,
    ACTIONS(18672), 1,
      sym__lazy_and_operator,
    ACTIONS(18674), 1,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13221), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18662), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [241027] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18664), 1,
      anon_sym_where,
    ACTIONS(18674), 1,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13222), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18662), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_QMARK,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [241096] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13223), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [241155] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13224), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [241218] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13225), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [241271] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    STATE(13226), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [241322] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18680), 1,
      anon_sym_QMARK,
    ACTIONS(18682), 1,
      anon_sym_where,
    ACTIONS(18684), 1,
      sym__pair_operator,
    ACTIONS(18686), 1,
      sym__arrow_operator,
    ACTIONS(18688), 1,
      sym__lazy_or_operator,
    ACTIONS(18690), 1,
      sym__lazy_and_operator,
    ACTIONS(18692), 1,
      sym__comparison_operator,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13227), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18678), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(18102), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [241399] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15478), 1,
      anon_sym_DASH_GT,
    STATE(13228), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241442] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12224), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13229), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [241493] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15738), 1,
      anon_sym_EQ,
    STATE(13230), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241538] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15594), 1,
      anon_sym_DASH_GT,
    ACTIONS(15738), 1,
      anon_sym_EQ,
    STATE(13231), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241583] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14142), 1,
      anon_sym_DOT2,
    ACTIONS(16436), 1,
      sym__word_identifier,
    STATE(11669), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(11775), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13232), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14152), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14144), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [241634] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    STATE(13233), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [241683] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(13234), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241726] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(13235), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241769] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(13236), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241812] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(13237), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [241855] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(13238), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [241900] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18244), 1,
      sym__pair_operator,
    ACTIONS(18246), 1,
      sym__arrow_operator,
    ACTIONS(18248), 1,
      sym__lazy_or_operator,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18602), 1,
      anon_sym_QMARK,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13239), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [241977] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    STATE(13240), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [242024] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13241), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242077] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(13242), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242120] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(13243), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [242163] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18660), 1,
      sym__power_operator,
    STATE(13244), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [242208] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13245), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242267] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13246), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [242330] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18534), 1,
      sym__comparison_operator,
    ACTIONS(18536), 1,
      anon_sym_where,
    ACTIONS(18540), 1,
      sym__arrow_operator,
    ACTIONS(18542), 1,
      sym__lazy_or_operator,
    ACTIONS(18544), 1,
      sym__lazy_and_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13247), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [242403] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13182), 1,
      anon_sym_DOT2,
    ACTIONS(18710), 1,
      sym__word_identifier,
    STATE(6679), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13248), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(15424), 2,
      sym_scoped_identifier,
      sym_identifier,
    ACTIONS(13192), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13184), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13204), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [242454] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13249), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242507] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13250), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242560] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14622), 1,
      anon_sym_DOT2,
    ACTIONS(18712), 1,
      sym__word_identifier,
    STATE(7900), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7940), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13251), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14632), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14624), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14638), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [242611] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    STATE(13252), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242662] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    STATE(13253), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242711] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    STATE(13254), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [242758] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18596), 1,
      sym__power_operator,
    STATE(13255), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [242803] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    STATE(13256), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242854] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    STATE(13257), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [242903] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    STATE(13258), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [242950] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14990), 1,
      anon_sym_DOT2,
    ACTIONS(18714), 1,
      sym__word_identifier,
    STATE(6600), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6830), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13259), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15000), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14992), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(15010), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243001] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18708), 1,
      sym__power_operator,
    STATE(13260), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [243046] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11249), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13261), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11247), 3,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [243123] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18600), 1,
      sym__comparison_operator,
    ACTIONS(18602), 1,
      anon_sym_QMARK,
    ACTIONS(18604), 1,
      anon_sym_where,
    ACTIONS(18606), 1,
      sym__pair_operator,
    ACTIONS(18608), 1,
      sym__arrow_operator,
    ACTIONS(18610), 1,
      sym__lazy_or_operator,
    ACTIONS(18612), 1,
      sym__lazy_and_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13262), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [243200] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18236), 1,
      anon_sym_COLON,
    ACTIONS(18242), 1,
      anon_sym_where,
    ACTIONS(18244), 1,
      sym__pair_operator,
    ACTIONS(18246), 1,
      sym__arrow_operator,
    ACTIONS(18248), 1,
      sym__lazy_or_operator,
    ACTIONS(18250), 1,
      sym__lazy_and_operator,
    ACTIONS(18252), 1,
      sym__comparison_operator,
    ACTIONS(18254), 1,
      sym__pipe_right_operator,
    ACTIONS(18256), 1,
      sym__pipe_left_operator,
    ACTIONS(18258), 1,
      sym__ellipsis_operator,
    ACTIONS(18262), 1,
      sym__times_operator,
    ACTIONS(18264), 1,
      sym__rational_operator,
    ACTIONS(18266), 1,
      sym__bitshift_operator,
    ACTIONS(18268), 1,
      sym__power_operator,
    ACTIONS(18602), 1,
      anon_sym_QMARK,
    ACTIONS(18260), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13263), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18238), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [243277] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13264), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      sym__pair_operator,
  [243354] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13558), 1,
      anon_sym_DOT2,
    ACTIONS(18716), 1,
      sym__word_identifier,
    STATE(6237), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6364), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13265), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13568), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13560), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13580), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [243405] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18534), 1,
      sym__comparison_operator,
    ACTIONS(18536), 1,
      anon_sym_where,
    ACTIONS(18544), 1,
      sym__lazy_and_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13266), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [243474] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18534), 1,
      sym__comparison_operator,
    ACTIONS(18536), 1,
      anon_sym_where,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13267), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [243541] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13268), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [243600] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(11267), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(13269), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 22,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [243645] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13270), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [243708] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13271), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [243761] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    STATE(13272), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [243812] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    STATE(13273), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [243861] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    STATE(13274), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [243908] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18514), 1,
      sym__power_operator,
    STATE(13275), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 18,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [243953] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15402), 1,
      anon_sym_DASH_GT,
    STATE(13276), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [243996] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17781), 1,
      anon_sym_COLON,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17789), 1,
      anon_sym_where,
    ACTIONS(17791), 1,
      sym__arrow_operator,
    ACTIONS(17793), 1,
      sym__lazy_or_operator,
    ACTIONS(17795), 1,
      sym__lazy_and_operator,
    ACTIONS(17797), 1,
      sym__pipe_right_operator,
    ACTIONS(17799), 1,
      sym__pipe_left_operator,
    ACTIONS(17801), 1,
      sym__ellipsis_operator,
    ACTIONS(17805), 1,
      sym__times_operator,
    ACTIONS(17807), 1,
      sym__rational_operator,
    ACTIONS(17809), 1,
      sym__bitshift_operator,
    ACTIONS(17811), 1,
      sym__power_operator,
    ACTIONS(17912), 1,
      sym__pair_operator,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    ACTIONS(11287), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    ACTIONS(11289), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(17803), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13277), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17783), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [244073] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(13278), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [244116] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15456), 1,
      anon_sym_COMMA,
    ACTIONS(15458), 1,
      aux_sym__terminator_token1,
    ACTIONS(15460), 1,
      aux_sym__terminator_token2,
    STATE(16994), 1,
      aux_sym__do_parameter_list_repeat1,
    STATE(13279), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 22,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [244163] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13326), 1,
      anon_sym_DOT2,
    ACTIONS(18718), 1,
      sym__word_identifier,
    STATE(6879), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7239), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13280), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13336), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13328), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13342), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244214] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15754), 1,
      anon_sym_EQ,
    STATE(13281), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [244259] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13282), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [244304] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13283), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [244381] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15078), 1,
      anon_sym_DOT2,
    ACTIONS(18720), 1,
      sym__word_identifier,
    STATE(8467), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8728), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13284), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(15088), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(15080), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(15094), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244432] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13285), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(10982), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      sym__pair_operator,
  [244509] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13286), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [244572] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11795), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13287), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [244623] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15538), 1,
      anon_sym_DASH_GT,
    STATE(13288), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [244666] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13289), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [244733] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13290), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [244812] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13291), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [244879] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13292), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [244958] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15538), 1,
      anon_sym_DASH_GT,
    STATE(13293), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [245001] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13294), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [245064] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(13295), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 19,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [245115] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13296), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
  [245190] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13297), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [245261] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10972), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13298), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [245342] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18708), 1,
      sym__power_operator,
    STATE(13299), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [245387] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14420), 1,
      anon_sym_DOT2,
    ACTIONS(16464), 1,
      sym__word_identifier,
    STATE(6468), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6814), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13300), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14430), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14422), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14442), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [245438] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13301), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [245497] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11277), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13302), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [245550] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13303), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 13,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [245613] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11866), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13304), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18552), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 9,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [245678] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18554), 1,
      anon_sym_where,
    ACTIONS(18556), 1,
      sym__pair_operator,
    ACTIONS(18558), 1,
      sym__arrow_operator,
    ACTIONS(18560), 1,
      sym__lazy_or_operator,
    ACTIONS(18562), 1,
      sym__lazy_and_operator,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13305), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(18552), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [245755] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18554), 1,
      anon_sym_where,
    ACTIONS(18558), 1,
      sym__arrow_operator,
    ACTIONS(18560), 1,
      sym__lazy_or_operator,
    ACTIONS(18562), 1,
      sym__lazy_and_operator,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13306), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18552), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 5,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
  [245828] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18554), 1,
      anon_sym_where,
    ACTIONS(18562), 1,
      sym__lazy_and_operator,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13307), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18552), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [245897] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18554), 1,
      anon_sym_where,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13308), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18552), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [245964] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13309), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [246027] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14536), 1,
      anon_sym_DOT2,
    ACTIONS(16378), 1,
      sym__word_identifier,
    STATE(6706), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(7871), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13310), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14546), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14538), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14558), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [246078] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13311), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [246137] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18550), 1,
      anon_sym_COLON,
    ACTIONS(18564), 1,
      sym__pipe_right_operator,
    ACTIONS(18566), 1,
      sym__pipe_left_operator,
    ACTIONS(18568), 1,
      sym__ellipsis_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13312), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 13,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [246200] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18630), 1,
      sym__power_operator,
    STATE(13313), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [246245] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    ACTIONS(18570), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13314), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [246298] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13315), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [246351] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13316), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [246416] = 10,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18572), 1,
      sym__times_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    STATE(13317), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 20,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [246467] = 9,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18574), 1,
      sym__rational_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    STATE(13318), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 21,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [246516] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    ACTIONS(18576), 1,
      sym__bitshift_operator,
    STATE(13319), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 22,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [246563] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13320), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [246626] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13321), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [246693] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13322), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [246768] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13323), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [246839] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13324), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [246908] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13325), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [246967] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13326), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [247030] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13327), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247083] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    STATE(13328), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247134] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    STATE(13329), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247183] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    STATE(13330), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [247230] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18459), 1,
      sym__power_operator,
    STATE(13331), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [247275] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11110), 1,
      aux_sym__terminator_token1,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18548), 1,
      sym__power_operator,
    STATE(13332), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 23,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [247320] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13333), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247373] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13334), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247426] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18596), 1,
      sym__power_operator,
    STATE(13335), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 18,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [247471] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18278), 1,
      sym__pair_operator,
    ACTIONS(18280), 1,
      sym__arrow_operator,
    ACTIONS(18282), 1,
      sym__lazy_or_operator,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18680), 1,
      anon_sym_QMARK,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13336), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [247548] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(13337), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247599] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13338), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 16,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247652] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13339), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11289), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [247729] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(13340), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [247778] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(13341), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [247825] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(13342), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [247870] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13343), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [247945] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15590), 1,
      anon_sym_DASH_GT,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13344), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [247990] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13345), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [248061] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13346), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [248130] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(13347), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248173] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(13348), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248216] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(13349), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248259] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13350), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [248318] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18546), 1,
      anon_sym_QMARK,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18664), 1,
      anon_sym_where,
    ACTIONS(18666), 1,
      sym__pair_operator,
    ACTIONS(18668), 1,
      sym__arrow_operator,
    ACTIONS(18670), 1,
      sym__lazy_or_operator,
    ACTIONS(18672), 1,
      sym__lazy_and_operator,
    ACTIONS(18674), 1,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13351), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
    ACTIONS(18662), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [248397] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13352), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [248460] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18136), 1,
      sym__power_operator,
    STATE(13353), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [248505] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13354), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [248558] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      aux_sym_integer_literal_token4,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18644), 1,
      anon_sym_COLON,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18674), 1,
      sym__comparison_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13355), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18662), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [248625] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15538), 1,
      anon_sym_DASH_GT,
    STATE(13356), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248668] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13357), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [248721] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18660), 1,
      sym__power_operator,
    STATE(13358), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [248766] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13359), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_COLON,
      aux_sym_integer_literal_token4,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [248819] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11193), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13360), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [248870] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13361), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248915] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15590), 1,
      anon_sym_DASH_GT,
    ACTIONS(15754), 1,
      anon_sym_EQ,
    STATE(13362), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [248960] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18459), 1,
      sym__power_operator,
    STATE(13363), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [249005] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13364), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [249058] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15594), 1,
      anon_sym_DASH_GT,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13365), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [249103] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(13366), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [249154] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13430), 1,
      anon_sym_DOT2,
    ACTIONS(16304), 1,
      sym__word_identifier,
    STATE(7672), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(8468), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13367), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13440), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13432), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13452), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [249205] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13368), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [249268] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18580), 1,
      anon_sym_COLON,
    ACTIONS(18582), 1,
      sym__pipe_right_operator,
    ACTIONS(18584), 1,
      sym__pipe_left_operator,
    ACTIONS(18586), 1,
      sym__ellipsis_operator,
    ACTIONS(18590), 1,
      sym__times_operator,
    ACTIONS(18592), 1,
      sym__rational_operator,
    ACTIONS(18594), 1,
      sym__bitshift_operator,
    ACTIONS(18596), 1,
      sym__power_operator,
    ACTIONS(18600), 1,
      sym__comparison_operator,
    ACTIONS(18602), 1,
      anon_sym_QMARK,
    ACTIONS(18604), 1,
      anon_sym_where,
    ACTIONS(18606), 1,
      sym__pair_operator,
    ACTIONS(18608), 1,
      sym__arrow_operator,
    ACTIONS(18610), 1,
      sym__lazy_or_operator,
    ACTIONS(18612), 1,
      sym__lazy_and_operator,
    ACTIONS(18588), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13369), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(18102), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [249345] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(9212), 1,
      aux_sym__terminator_token1,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    STATE(13370), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
      aux_sym__terminator_token2,
  [249388] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18692), 1,
      sym__comparison_operator,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13371), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18678), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 10,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [249453] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18680), 1,
      anon_sym_QMARK,
    ACTIONS(18682), 1,
      anon_sym_where,
    ACTIONS(18684), 1,
      sym__pair_operator,
    ACTIONS(18686), 1,
      sym__arrow_operator,
    ACTIONS(18688), 1,
      sym__lazy_or_operator,
    ACTIONS(18690), 1,
      sym__lazy_and_operator,
    ACTIONS(18692), 1,
      sym__comparison_operator,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13372), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18678), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [249530] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18682), 1,
      anon_sym_where,
    ACTIONS(18686), 1,
      sym__arrow_operator,
    ACTIONS(18688), 1,
      sym__lazy_or_operator,
    ACTIONS(18690), 1,
      sym__lazy_and_operator,
    ACTIONS(18692), 1,
      sym__comparison_operator,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13373), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18678), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
  [249603] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18682), 1,
      anon_sym_where,
    ACTIONS(18690), 1,
      sym__lazy_and_operator,
    ACTIONS(18692), 1,
      sym__comparison_operator,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13374), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18678), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [249672] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18682), 1,
      anon_sym_where,
    ACTIONS(18692), 1,
      sym__comparison_operator,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13375), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18678), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 9,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [249739] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13376), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 15,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [249798] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13377), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [249861] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14808), 1,
      anon_sym_DOT2,
    ACTIONS(18722), 1,
      sym__word_identifier,
    STATE(6357), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6694), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13378), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14818), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14810), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14828), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [249912] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13232), 1,
      anon_sym_DOT2,
    ACTIONS(18724), 1,
      sym__word_identifier,
    STATE(6444), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6670), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13379), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13242), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13234), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13254), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [249963] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(13380), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [250012] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11289), 1,
      aux_sym__terminator_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17847), 1,
      anon_sym_COLON,
    ACTIONS(17851), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17855), 1,
      anon_sym_where,
    ACTIONS(17857), 1,
      sym__arrow_operator,
    ACTIONS(17859), 1,
      sym__lazy_or_operator,
    ACTIONS(17861), 1,
      sym__lazy_and_operator,
    ACTIONS(17863), 1,
      sym__pipe_right_operator,
    ACTIONS(17865), 1,
      sym__pipe_left_operator,
    ACTIONS(17867), 1,
      sym__ellipsis_operator,
    ACTIONS(17871), 1,
      sym__times_operator,
    ACTIONS(17873), 1,
      sym__rational_operator,
    ACTIONS(17875), 1,
      sym__bitshift_operator,
    ACTIONS(17877), 1,
      sym__power_operator,
    ACTIONS(17910), 1,
      sym__pair_operator,
    ACTIONS(17959), 1,
      anon_sym_QMARK,
    ACTIONS(17869), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13381), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11287), 3,
      anon_sym_COMMA,
      anon_sym_end,
      aux_sym__terminator_token2,
    ACTIONS(17849), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [250089] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(13382), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [250136] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15756), 1,
      anon_sym_EQ,
    STATE(13383), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [250181] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18676), 1,
      anon_sym_COLON,
    ACTIONS(18680), 1,
      anon_sym_QMARK,
    ACTIONS(18682), 1,
      anon_sym_where,
    ACTIONS(18684), 1,
      sym__pair_operator,
    ACTIONS(18686), 1,
      sym__arrow_operator,
    ACTIONS(18688), 1,
      sym__lazy_or_operator,
    ACTIONS(18690), 1,
      sym__lazy_and_operator,
    ACTIONS(18692), 1,
      sym__comparison_operator,
    ACTIONS(18694), 1,
      sym__pipe_right_operator,
    ACTIONS(18696), 1,
      sym__pipe_left_operator,
    ACTIONS(18698), 1,
      sym__ellipsis_operator,
    ACTIONS(18702), 1,
      sym__times_operator,
    ACTIONS(18704), 1,
      sym__rational_operator,
    ACTIONS(18706), 1,
      sym__bitshift_operator,
    ACTIONS(18708), 1,
      sym__power_operator,
    ACTIONS(18700), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13384), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18678), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [250258] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17406), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18270), 1,
      anon_sym_COLON,
    ACTIONS(18276), 1,
      anon_sym_where,
    ACTIONS(18278), 1,
      sym__pair_operator,
    ACTIONS(18280), 1,
      sym__arrow_operator,
    ACTIONS(18282), 1,
      sym__lazy_or_operator,
    ACTIONS(18284), 1,
      sym__lazy_and_operator,
    ACTIONS(18286), 1,
      sym__comparison_operator,
    ACTIONS(18288), 1,
      sym__pipe_right_operator,
    ACTIONS(18290), 1,
      sym__pipe_left_operator,
    ACTIONS(18292), 1,
      sym__ellipsis_operator,
    ACTIONS(18296), 1,
      sym__times_operator,
    ACTIONS(18298), 1,
      sym__rational_operator,
    ACTIONS(18300), 1,
      sym__bitshift_operator,
    ACTIONS(18302), 1,
      sym__power_operator,
    ACTIONS(18680), 1,
      anon_sym_QMARK,
    ACTIONS(18294), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13385), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18272), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [250335] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18170), 1,
      sym__power_operator,
    STATE(13386), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [250380] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18142), 1,
      anon_sym_QMARK,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13387), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250459] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14852), 1,
      anon_sym_DOT2,
    ACTIONS(16368), 1,
      sym__word_identifier,
    STATE(6606), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6860), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13388), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14862), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14854), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14874), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [250510] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    STATE(13131), 1,
      aux_sym_open_tuple_repeat1,
    STATE(13389), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10833), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [250555] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(18514), 1,
      sym__power_operator,
    ACTIONS(18516), 1,
      anon_sym_COLON,
    ACTIONS(18518), 1,
      sym__pipe_right_operator,
    ACTIONS(18520), 1,
      sym__pipe_left_operator,
    ACTIONS(18522), 1,
      sym__ellipsis_operator,
    ACTIONS(18526), 1,
      sym__times_operator,
    ACTIONS(18528), 1,
      sym__rational_operator,
    ACTIONS(18530), 1,
      sym__bitshift_operator,
    ACTIONS(18534), 1,
      sym__comparison_operator,
    ACTIONS(18536), 1,
      anon_sym_where,
    ACTIONS(18538), 1,
      sym__pair_operator,
    ACTIONS(18540), 1,
      sym__arrow_operator,
    ACTIONS(18542), 1,
      sym__lazy_or_operator,
    ACTIONS(18544), 1,
      sym__lazy_and_operator,
    ACTIONS(18524), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13390), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [250632] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13391), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11114), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [250709] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11175), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13392), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [250760] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13393), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [250837] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11277), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13394), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [250890] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17817), 1,
      anon_sym_QMARK,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10982), 2,
      anon_sym_RPAREN,
      sym__pair_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13395), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [250971] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13396), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [251048] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13148), 1,
      anon_sym_DOT2,
    ACTIONS(18728), 1,
      sym__word_identifier,
    STATE(6406), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(6527), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13397), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13158), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13150), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13170), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251099] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13398), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 12,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [251162] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12695), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13399), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [251213] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(13400), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 19,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251256] = 17,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11866), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13401), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18397), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11864), 8,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [251321] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18730), 1,
      anon_sym_COMMA,
    STATE(13408), 1,
      aux_sym_export_statement_repeat1,
    STATE(13402), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10807), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10811), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251366] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18730), 1,
      anon_sym_COMMA,
    STATE(13409), 1,
      aux_sym_export_statement_repeat1,
    STATE(13403), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10813), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10815), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251411] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18338), 1,
      anon_sym_COMMA,
    STATE(13411), 1,
      aux_sym__import_list_repeat1,
    STATE(13404), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10747), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10755), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251456] = 23,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(17918), 1,
      anon_sym_QMARK,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18399), 1,
      anon_sym_where,
    ACTIONS(18401), 1,
      sym__pair_operator,
    ACTIONS(18403), 1,
      sym__arrow_operator,
    ACTIONS(18405), 1,
      sym__lazy_or_operator,
    ACTIONS(18407), 1,
      sym__lazy_and_operator,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11108), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13405), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18397), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [251533] = 21,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18399), 1,
      anon_sym_where,
    ACTIONS(18403), 1,
      sym__arrow_operator,
    ACTIONS(18405), 1,
      sym__lazy_or_operator,
    ACTIONS(18407), 1,
      sym__lazy_and_operator,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13406), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      aux_sym__terminator_token2,
    ACTIONS(18397), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
  [251606] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18431), 1,
      anon_sym_QMARK,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18435), 1,
      sym__pair_operator,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13407), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [251685] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18730), 1,
      anon_sym_COMMA,
    STATE(13412), 1,
      aux_sym_export_statement_repeat1,
    STATE(13408), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10876), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10878), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251730] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18730), 1,
      anon_sym_COMMA,
    STATE(13412), 1,
      aux_sym_export_statement_repeat1,
    STATE(13409), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10880), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10882), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251775] = 19,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18399), 1,
      anon_sym_where,
    ACTIONS(18407), 1,
      sym__lazy_and_operator,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13410), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18397), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      aux_sym__terminator_token2,
  [251844] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18338), 1,
      anon_sym_COMMA,
    STATE(13414), 1,
      aux_sym__import_list_repeat1,
    STATE(13411), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10884), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10886), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251889] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18732), 1,
      anon_sym_COMMA,
    STATE(13412), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_export_statement_repeat1,
    ACTIONS(10850), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10855), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251932] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18340), 1,
      anon_sym_as,
    STATE(13413), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10861), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [251975] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18735), 1,
      anon_sym_COMMA,
    STATE(13414), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__import_list_repeat1,
    ACTIONS(10861), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10863), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [252018] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16520), 1,
      anon_sym_COLON,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(16530), 1,
      anon_sym_QMARK,
    ACTIONS(16532), 1,
      anon_sym_where,
    ACTIONS(16534), 1,
      sym__pair_operator,
    ACTIONS(16536), 1,
      sym__arrow_operator,
    ACTIONS(16538), 1,
      sym__lazy_or_operator,
    ACTIONS(16540), 1,
      sym__lazy_and_operator,
    ACTIONS(16542), 1,
      sym__comparison_operator,
    ACTIONS(16544), 1,
      sym__pipe_right_operator,
    ACTIONS(16546), 1,
      sym__pipe_left_operator,
    ACTIONS(16548), 1,
      sym__ellipsis_operator,
    ACTIONS(16552), 1,
      sym__times_operator,
    ACTIONS(16554), 1,
      sym__rational_operator,
    ACTIONS(16556), 1,
      sym__bitshift_operator,
    ACTIONS(16558), 1,
      sym__power_operator,
    ACTIONS(16550), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13415), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16522), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11249), 4,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [252095] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15546), 1,
      anon_sym_DASH_GT,
    STATE(13416), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [252138] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12702), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13417), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252189] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12352), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13418), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252240] = 18,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18399), 1,
      anon_sym_where,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13419), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18397), 4,
      anon_sym_in,
      anon_sym_isa,
      sym__comparison_operator,
      sym__type_order_operator,
    ACTIONS(11108), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      aux_sym__terminator_token2,
  [252307] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14142), 1,
      anon_sym_DOT2,
    ACTIONS(16436), 1,
      sym__word_identifier,
    STATE(11775), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11812), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13420), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14152), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14144), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252358] = 14,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13421), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [252417] = 16,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16700), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18395), 1,
      anon_sym_COLON,
    ACTIONS(18409), 1,
      sym__pipe_right_operator,
    ACTIONS(18411), 1,
      sym__pipe_left_operator,
    ACTIONS(18413), 1,
      sym__ellipsis_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13422), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 12,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [252480] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12358), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13423), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252531] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18738), 1,
      anon_sym_DOT,
    STATE(13424), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10635), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10639), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [252574] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13424), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13425), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252625] = 11,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17785), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18346), 1,
      sym__rational_operator,
    ACTIONS(18348), 1,
      sym__bitshift_operator,
    ACTIONS(18350), 1,
      sym__power_operator,
    ACTIONS(18417), 1,
      sym__times_operator,
    ACTIONS(11110), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    ACTIONS(18415), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13426), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__type_order_operator,
      aux_sym__terminator_token2,
  [252678] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(13123), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13427), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252729] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11990), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13428), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252780] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1833), 1,
      anon_sym_DOT2,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10595), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11740), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13429), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(13400), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252831] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12371), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13430), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252882] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11996), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13431), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [252933] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10964), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13432), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253014] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12000), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13433), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [253065] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18037), 1,
      anon_sym_COMMA,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    STATE(12834), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10968), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13434), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253146] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(11744), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13435), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [253197] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12380), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13436), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [253248] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14242), 1,
      anon_sym_DOT2,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11412), 2,
      sym_operator,
      sym__syntactic_operator,
    STATE(12008), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(13437), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(14252), 4,
      anon_sym_DOLLAR,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_DASH_GT,
    ACTIONS(14244), 7,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 9,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [253299] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18108), 1,
      anon_sym_QMARK,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13438), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253378] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13439), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [253440] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18740), 1,
      anon_sym_COLON2,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13440), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253520] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9854), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13441), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [253564] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8180), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18744), 1,
      anon_sym_COMMA,
    STATE(17300), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13442), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253644] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18746), 1,
      anon_sym_COMMA,
    ACTIONS(18748), 1,
      anon_sym_RBRACE,
    STATE(17110), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13443), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253724] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18750), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13444), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253804] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7634), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18752), 1,
      anon_sym_COMMA,
    STATE(17332), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13445), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253884] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18754), 1,
      anon_sym_COMMA,
    ACTIONS(18756), 1,
      anon_sym_RBRACE,
    STATE(17101), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13446), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [253964] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18758), 1,
      anon_sym_COMMA,
    ACTIONS(18760), 1,
      anon_sym_RBRACE,
    STATE(17117), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13447), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254044] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18762), 1,
      anon_sym_COMMA,
    ACTIONS(18764), 1,
      anon_sym_RBRACE,
    STATE(17203), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13448), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254124] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7054), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18766), 1,
      anon_sym_COMMA,
    STATE(17212), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13449), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254204] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(13450), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [254248] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18768), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13451), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254328] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18423), 1,
      sym__word_identifier,
    ACTIONS(18770), 1,
      anon_sym_LPAREN,
    ACTIONS(18772), 1,
      anon_sym_DOLLAR,
    ACTIONS(18774), 1,
      anon_sym_AT,
    STATE(7997), 1,
      sym__exportable,
    STATE(13452), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8554), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13832), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13846), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [254380] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13453), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [254446] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(11114), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13454), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254524] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8204), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18776), 1,
      anon_sym_COMMA,
    STATE(17346), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13455), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254604] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18778), 1,
      anon_sym_COMMA,
    ACTIONS(18780), 1,
      anon_sym_RBRACE,
    STATE(17281), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13456), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254684] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18423), 1,
      sym__word_identifier,
    ACTIONS(18770), 1,
      anon_sym_LPAREN,
    ACTIONS(18772), 1,
      anon_sym_DOLLAR,
    ACTIONS(18774), 1,
      anon_sym_AT,
    STATE(8014), 1,
      sym__exportable,
    STATE(13457), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8554), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13832), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13846), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [254736] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18782), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13458), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254816] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18784), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13459), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [254896] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15606), 1,
      anon_sym_EQ,
    ACTIONS(15608), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(13460), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [254942] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8250), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18786), 1,
      anon_sym_COMMA,
    STATE(17450), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13461), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255022] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18788), 1,
      anon_sym_COMMA,
    ACTIONS(18790), 1,
      anon_sym_RBRACE,
    STATE(17340), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13462), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255102] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18792), 1,
      anon_sym_COMMA,
    ACTIONS(18794), 1,
      anon_sym_RBRACE,
    STATE(17520), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13463), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255182] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18796), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13464), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255262] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(13465), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [255304] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(13466), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [255348] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(13467), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [255390] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(13468), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [255432] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7186), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18798), 1,
      anon_sym_COMMA,
    STATE(17161), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13469), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255512] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8270), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18800), 1,
      anon_sym_COMMA,
    STATE(17530), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13470), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255592] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(13471), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [255636] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18802), 1,
      anon_sym_COMMA,
    ACTIONS(18804), 1,
      anon_sym_RBRACE,
    STATE(17382), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13472), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255716] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18806), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13473), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255796] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18808), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13474), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [255876] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10110), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13475), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [255920] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    STATE(16306), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13476), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [256000] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8308), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18810), 1,
      anon_sym_COMMA,
    STATE(17590), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13477), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [256080] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18718), 1,
      sym__word_identifier,
    ACTIONS(18812), 1,
      anon_sym_LPAREN,
    ACTIONS(18814), 1,
      anon_sym_DOLLAR,
    ACTIONS(18816), 1,
      anon_sym_AT,
    STATE(6966), 1,
      sym__exportable,
    STATE(13478), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7504), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13328), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13342), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [256132] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(13479), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [256176] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13480), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [256238] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18836), 1,
      anon_sym_COMMA,
    ACTIONS(18838), 1,
      anon_sym_RBRACE,
    STATE(17440), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13481), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [256318] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18842), 1,
      sym__comparison_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13482), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18840), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [256382] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18842), 1,
      sym__comparison_operator,
    ACTIONS(18844), 1,
      anon_sym_where,
    ACTIONS(18846), 1,
      sym__pair_operator,
    ACTIONS(18848), 1,
      sym__arrow_operator,
    ACTIONS(18850), 1,
      sym__lazy_or_operator,
    ACTIONS(18852), 1,
      sym__lazy_and_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13483), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18840), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [256458] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18842), 1,
      sym__comparison_operator,
    ACTIONS(18844), 1,
      anon_sym_where,
    ACTIONS(18848), 1,
      sym__arrow_operator,
    ACTIONS(18850), 1,
      sym__lazy_or_operator,
    ACTIONS(18852), 1,
      sym__lazy_and_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13484), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18840), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [256530] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18842), 1,
      sym__comparison_operator,
    ACTIONS(18844), 1,
      anon_sym_where,
    ACTIONS(18852), 1,
      sym__lazy_and_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13485), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18840), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [256598] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18842), 1,
      sym__comparison_operator,
    ACTIONS(18844), 1,
      anon_sym_where,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13486), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18840), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [256664] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13487), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [256722] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18854), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13488), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [256802] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13489), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [256864] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13490), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [256916] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    STATE(13491), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [256966] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    STATE(13492), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [257014] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    STATE(13493), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [257060] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18834), 1,
      sym__power_operator,
    STATE(13494), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [257104] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18508), 1,
      sym__word_identifier,
    ACTIONS(18856), 1,
      anon_sym_LPAREN,
    ACTIONS(18858), 1,
      anon_sym_DOLLAR,
    ACTIONS(18860), 1,
      anon_sym_AT,
    STATE(8948), 1,
      sym__exportable,
    STATE(13495), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9308), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14738), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14752), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [257156] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8344), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18862), 1,
      anon_sym_COMMA,
    STATE(17345), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13496), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257236] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18508), 1,
      sym__word_identifier,
    ACTIONS(18856), 1,
      anon_sym_LPAREN,
    ACTIONS(18858), 1,
      anon_sym_DOLLAR,
    ACTIONS(18860), 1,
      anon_sym_AT,
    STATE(9014), 1,
      sym__exportable,
    STATE(13497), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9308), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14738), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14752), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [257288] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    ACTIONS(18818), 1,
      anon_sym_COLON,
    ACTIONS(18820), 1,
      sym__pipe_right_operator,
    ACTIONS(18822), 1,
      sym__pipe_left_operator,
    ACTIONS(18824), 1,
      sym__ellipsis_operator,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18842), 1,
      sym__comparison_operator,
    ACTIONS(18844), 1,
      anon_sym_where,
    ACTIONS(18846), 1,
      sym__pair_operator,
    ACTIONS(18848), 1,
      sym__arrow_operator,
    ACTIONS(18850), 1,
      sym__lazy_or_operator,
    ACTIONS(18852), 1,
      sym__lazy_and_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13498), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18840), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257364] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13499), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257440] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18864), 1,
      anon_sym_COMMA,
    ACTIONS(18866), 1,
      anon_sym_RBRACE,
    STATE(17521), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13500), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257520] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18868), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13501), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257600] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18870), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13502), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257680] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8364), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18872), 1,
      anon_sym_COMMA,
    STATE(17327), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13503), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257760] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18874), 1,
      anon_sym_COMMA,
    ACTIONS(18876), 1,
      anon_sym_RBRACE,
    STATE(17570), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13504), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257840] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18878), 1,
      anon_sym_COMMA,
    ACTIONS(18880), 1,
      anon_sym_RBRACE,
    STATE(17078), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13505), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [257920] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18882), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13506), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258000] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8386), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18884), 1,
      anon_sym_COMMA,
    STATE(17344), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13507), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258080] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18886), 1,
      anon_sym_COMMA,
    ACTIONS(18888), 1,
      anon_sym_RBRACE,
    STATE(17619), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13508), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258160] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(13509), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [258202] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18890), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13510), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258282] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7670), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18892), 1,
      anon_sym_COMMA,
    STATE(17531), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13511), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258362] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8410), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18894), 1,
      anon_sym_COMMA,
    STATE(17368), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13512), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258442] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(18896), 1,
      anon_sym_LPAREN,
    ACTIONS(18898), 1,
      anon_sym_DOLLAR,
    ACTIONS(18900), 1,
      anon_sym_AT,
    STATE(6707), 1,
      sym__exportable,
    STATE(13513), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7351), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13516), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13530), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [258494] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(18896), 1,
      anon_sym_LPAREN,
    ACTIONS(18898), 1,
      anon_sym_DOLLAR,
    ACTIONS(18900), 1,
      anon_sym_AT,
    STATE(6708), 1,
      sym__exportable,
    STATE(13514), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7351), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13516), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13530), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [258546] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18902), 1,
      anon_sym_COMMA,
    ACTIONS(18904), 1,
      anon_sym_RBRACE,
    STATE(17164), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13515), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258626] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18906), 1,
      anon_sym_COMMA,
    ACTIONS(18908), 1,
      anon_sym_RBRACE,
    STATE(17405), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13516), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258706] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18910), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13517), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258786] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18912), 1,
      anon_sym_COMMA,
    STATE(17174), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13518), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258866] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18914), 1,
      anon_sym_COMMA,
    ACTIONS(18916), 1,
      anon_sym_RBRACE,
    STATE(17526), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13519), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [258946] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11221), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13520), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [258990] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18918), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13521), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259070] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18718), 1,
      sym__word_identifier,
    ACTIONS(18812), 1,
      anon_sym_LPAREN,
    ACTIONS(18814), 1,
      anon_sym_DOLLAR,
    ACTIONS(18816), 1,
      anon_sym_AT,
    STATE(7294), 1,
      sym__exportable,
    STATE(13522), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7504), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13328), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13342), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [259122] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10112), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13523), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [259166] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8458), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18920), 1,
      anon_sym_COMMA,
    STATE(17373), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13524), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259246] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18718), 1,
      sym__word_identifier,
    ACTIONS(18812), 1,
      anon_sym_LPAREN,
    ACTIONS(18814), 1,
      anon_sym_DOLLAR,
    ACTIONS(18816), 1,
      anon_sym_AT,
    STATE(7733), 1,
      sym__exportable,
    STATE(13525), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7504), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13328), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13342), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [259298] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18922), 1,
      anon_sym_COMMA,
    ACTIONS(18924), 1,
      anon_sym_RBRACE,
    STATE(17177), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13526), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259378] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18926), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13527), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259458] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8232), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18928), 1,
      anon_sym_COMMA,
    STATE(17393), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13528), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259538] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18930), 1,
      anon_sym_COMMA,
    ACTIONS(18932), 1,
      anon_sym_RBRACE,
    STATE(17249), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13529), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259618] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18934), 1,
      anon_sym_COMMA,
    ACTIONS(18936), 1,
      anon_sym_RBRACE,
    STATE(17291), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13530), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259698] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18938), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13531), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259778] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8484), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18940), 1,
      anon_sym_COMMA,
    STATE(17173), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13532), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259858] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18942), 1,
      anon_sym_COMMA,
    ACTIONS(18944), 1,
      anon_sym_RBRACE,
    STATE(17067), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13533), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [259938] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18946), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13534), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260018] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8508), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    STATE(17337), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13535), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260098] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18950), 1,
      anon_sym_COMMA,
    ACTIONS(18952), 1,
      anon_sym_RBRACE,
    STATE(17342), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13536), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260178] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18954), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13537), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260258] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8328), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18956), 1,
      anon_sym_COMMA,
    STATE(17626), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13538), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260338] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18958), 1,
      anon_sym_COMMA,
    ACTIONS(18960), 1,
      anon_sym_RBRACE,
    STATE(17087), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13539), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260418] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18962), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13540), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260498] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(18896), 1,
      anon_sym_LPAREN,
    ACTIONS(18898), 1,
      anon_sym_DOLLAR,
    ACTIONS(18900), 1,
      anon_sym_AT,
    STATE(7540), 1,
      sym__exportable,
    STATE(13541), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7351), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13516), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13530), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [260550] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(18896), 1,
      anon_sym_LPAREN,
    ACTIONS(18898), 1,
      anon_sym_DOLLAR,
    ACTIONS(18900), 1,
      anon_sym_AT,
    STATE(7866), 1,
      sym__exportable,
    STATE(13542), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7351), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13516), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13530), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [260602] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18964), 1,
      anon_sym_COMMA,
    STATE(17515), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13543), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260682] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18508), 1,
      sym__word_identifier,
    ACTIONS(18856), 1,
      anon_sym_LPAREN,
    ACTIONS(18858), 1,
      anon_sym_DOLLAR,
    ACTIONS(18860), 1,
      anon_sym_AT,
    STATE(9219), 1,
      sym__exportable,
    STATE(13544), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9308), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14738), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14752), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [260734] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18966), 1,
      anon_sym_COMMA,
    ACTIONS(18968), 1,
      anon_sym_RBRACE,
    STATE(17304), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13545), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260814] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18508), 1,
      sym__word_identifier,
    ACTIONS(18856), 1,
      anon_sym_LPAREN,
    ACTIONS(18858), 1,
      anon_sym_DOLLAR,
    ACTIONS(18860), 1,
      anon_sym_AT,
    STATE(9223), 1,
      sym__exportable,
    STATE(13546), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9308), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14738), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14752), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [260866] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18970), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13547), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [260946] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18972), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13548), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261026] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8546), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18974), 1,
      anon_sym_COMMA,
    STATE(17154), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13549), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261106] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18976), 1,
      anon_sym_COMMA,
    ACTIONS(18978), 1,
      anon_sym_RBRACE,
    STATE(17482), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13550), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261186] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10194), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13551), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [261230] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18980), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13552), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261310] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8564), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18982), 1,
      anon_sym_COMMA,
    STATE(17292), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13553), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261390] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18984), 1,
      anon_sym_COMMA,
    ACTIONS(18986), 1,
      anon_sym_RBRACE,
    STATE(17096), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13554), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261470] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18988), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13555), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261550] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10194), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13556), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [261594] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18990), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13557), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261674] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8586), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18992), 1,
      anon_sym_COMMA,
    STATE(17366), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13558), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261754] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18994), 1,
      anon_sym_COMMA,
    ACTIONS(18996), 1,
      anon_sym_RBRACE,
    STATE(17479), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13559), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261834] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18998), 1,
      anon_sym_COMMA,
    ACTIONS(19000), 1,
      anon_sym_RBRACE,
    STATE(17275), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13560), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261914] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19002), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13561), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [261994] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8604), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19004), 1,
      anon_sym_COMMA,
    STATE(17505), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13562), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262074] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19006), 1,
      anon_sym_COMMA,
    ACTIONS(19008), 1,
      anon_sym_RBRACE,
    STATE(17343), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13563), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262154] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19010), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13564), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262234] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19012), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13565), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262314] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15688), 1,
      anon_sym_DASH_GT,
    STATE(13566), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [262356] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8626), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19014), 1,
      anon_sym_COMMA,
    STATE(17070), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13567), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262436] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19016), 1,
      anon_sym_COMMA,
    ACTIONS(19018), 1,
      anon_sym_RBRACE,
    STATE(17481), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13568), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262516] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19020), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13569), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262596] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18138), 1,
      anon_sym_COLON,
    ACTIONS(18144), 1,
      anon_sym_where,
    ACTIONS(18146), 1,
      sym__pair_operator,
    ACTIONS(18148), 1,
      sym__arrow_operator,
    ACTIONS(18150), 1,
      sym__lazy_or_operator,
    ACTIONS(18152), 1,
      sym__lazy_and_operator,
    ACTIONS(18154), 1,
      sym__comparison_operator,
    ACTIONS(18156), 1,
      sym__pipe_right_operator,
    ACTIONS(18158), 1,
      sym__pipe_left_operator,
    ACTIONS(18160), 1,
      sym__ellipsis_operator,
    ACTIONS(18164), 1,
      sym__times_operator,
    ACTIONS(18166), 1,
      sym__rational_operator,
    ACTIONS(18168), 1,
      sym__bitshift_operator,
    ACTIONS(18170), 1,
      sym__power_operator,
    ACTIONS(18578), 1,
      anon_sym_QMARK,
    ACTIONS(18162), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13570), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18140), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262672] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8644), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19022), 1,
      anon_sym_COMMA,
    STATE(17353), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13571), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262752] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8648), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19024), 1,
      anon_sym_COMMA,
    STATE(17170), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13572), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262832] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19026), 1,
      anon_sym_COMMA,
    ACTIONS(19028), 1,
      anon_sym_RBRACE,
    STATE(17625), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13573), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262912] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19030), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13574), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [262992] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11864), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13575), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [263058] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19032), 1,
      anon_sym_COMMA,
    STATE(17242), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13576), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263138] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19034), 1,
      anon_sym_COMMA,
    ACTIONS(19036), 1,
      anon_sym_RBRACE,
    STATE(17157), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13577), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263218] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19038), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13578), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263298] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19040), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13579), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263378] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7522), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19042), 1,
      anon_sym_COMMA,
    STATE(17250), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13580), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263458] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13581), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [263500] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6990), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19044), 1,
      anon_sym_COMMA,
    STATE(17354), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13582), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263580] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19046), 1,
      anon_sym_COMMA,
    ACTIONS(19048), 1,
      anon_sym_RBRACE,
    STATE(17228), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13583), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263660] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12630), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13584), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [263704] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15656), 1,
      anon_sym_EQ,
    STATE(13585), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [263748] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11221), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13586), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [263792] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19050), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13587), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263872] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7704), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19052), 1,
      anon_sym_COMMA,
    STATE(17362), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13588), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [263952] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12213), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13589), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [263996] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19054), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13590), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264076] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19056), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13591), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264156] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19058), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13592), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264236] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19060), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13593), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264316] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19062), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13594), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264396] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19064), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13595), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264476] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15568), 1,
      anon_sym_EQ,
    STATE(13596), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [264520] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19066), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13597), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264600] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11020), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13598), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264680] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18718), 1,
      sym__word_identifier,
    ACTIONS(18812), 1,
      anon_sym_LPAREN,
    ACTIONS(18814), 1,
      anon_sym_DOLLAR,
    ACTIONS(18816), 1,
      anon_sym_AT,
    STATE(6965), 1,
      sym__exportable,
    STATE(13599), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7504), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13328), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13342), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [264732] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19068), 1,
      anon_sym_COMMA,
    ACTIONS(19070), 1,
      anon_sym_RBRACE,
    STATE(17461), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13600), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [264812] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12166), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13601), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [264856] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12166), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13602), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [264900] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18720), 1,
      sym__word_identifier,
    ACTIONS(19072), 1,
      anon_sym_LPAREN,
    ACTIONS(19074), 1,
      anon_sym_DOLLAR,
    ACTIONS(19076), 1,
      anon_sym_AT,
    STATE(8078), 1,
      sym__exportable,
    STATE(13603), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8767), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(15080), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(15094), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [264952] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18720), 1,
      sym__word_identifier,
    ACTIONS(19072), 1,
      anon_sym_LPAREN,
    ACTIONS(19074), 1,
      anon_sym_DOLLAR,
    ACTIONS(19076), 1,
      anon_sym_AT,
    STATE(8079), 1,
      sym__exportable,
    STATE(13604), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8767), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(15080), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(15094), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [265004] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15688), 1,
      anon_sym_DASH_GT,
    STATE(13605), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [265046] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15662), 1,
      anon_sym_EQ,
    ACTIONS(15664), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(13606), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [265092] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19078), 1,
      anon_sym_COMMA,
    ACTIONS(19080), 1,
      anon_sym_RBRACE,
    STATE(17414), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13607), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265172] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18874), 1,
      sym__exportable,
    STATE(13608), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [265224] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19086), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13609), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265304] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15672), 1,
      anon_sym_EQ,
    ACTIONS(15674), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(13610), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [265350] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19088), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13611), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265430] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    STATE(13612), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [265474] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    STATE(13613), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [265518] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10928), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13614), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265598] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19090), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13615), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265678] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10966), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13616), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265758] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13617), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [265800] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10970), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    STATE(13153), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13618), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265880] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7220), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19092), 1,
      anon_sym_COMMA,
    STATE(17289), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13619), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [265960] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(13620), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266004] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(13621), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266048] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19094), 1,
      anon_sym_COMMA,
    ACTIONS(19096), 1,
      anon_sym_RBRACE,
    STATE(17539), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13622), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [266128] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11263), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13623), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266172] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(13624), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266216] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10840), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(10835), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13625), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [266294] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15754), 1,
      anon_sym_EQ,
    STATE(13626), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266336] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(13627), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266380] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7766), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19098), 1,
      anon_sym_COMMA,
    STATE(17267), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13628), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [266460] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10978), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10982), 2,
      anon_sym_COMMA,
      sym__pair_operator,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13629), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [266538] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(13630), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266582] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18720), 1,
      sym__word_identifier,
    ACTIONS(19072), 1,
      anon_sym_LPAREN,
    ACTIONS(19074), 1,
      anon_sym_DOLLAR,
    ACTIONS(19076), 1,
      anon_sym_AT,
    STATE(8898), 1,
      sym__exportable,
    STATE(13631), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8767), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(15080), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(15094), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [266634] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(13632), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266678] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18720), 1,
      sym__word_identifier,
    ACTIONS(19072), 1,
      anon_sym_LPAREN,
    ACTIONS(19074), 1,
      anon_sym_DOLLAR,
    ACTIONS(19076), 1,
      anon_sym_AT,
    STATE(8912), 1,
      sym__exportable,
    STATE(13633), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8767), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(15080), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(15094), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [266730] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(13634), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [266774] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13635), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [266836] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13636), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [266914] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13637), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
  [266988] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13638), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [267058] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13639), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [267126] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13640), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [267184] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13641), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [267246] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13642), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [267298] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13643), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [267348] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13644), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [267396] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13645), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [267442] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13646), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [267486] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19118), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13647), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [267566] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19120), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_RBRACE,
    STATE(17168), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13648), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [267646] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15676), 1,
      anon_sym_EQ,
    ACTIONS(15678), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(13649), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [267692] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19126), 1,
      anon_sym_where,
    ACTIONS(19128), 1,
      sym__pair_operator,
    ACTIONS(19130), 1,
      sym__arrow_operator,
    ACTIONS(19132), 1,
      sym__lazy_or_operator,
    ACTIONS(19134), 1,
      sym__lazy_and_operator,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13650), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [267768] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19138), 1,
      anon_sym_COMMA,
    ACTIONS(19140), 1,
      anon_sym_RBRACE,
    STATE(17315), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13651), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [267848] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19126), 1,
      anon_sym_where,
    ACTIONS(19130), 1,
      sym__arrow_operator,
    ACTIONS(19132), 1,
      sym__lazy_or_operator,
    ACTIONS(19134), 1,
      sym__lazy_and_operator,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13652), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
  [267920] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19126), 1,
      anon_sym_where,
    ACTIONS(19134), 1,
      sym__lazy_and_operator,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13653), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [267988] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19126), 1,
      anon_sym_where,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13654), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [268054] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13655), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [268112] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10964), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13656), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [268192] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13657), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [268254] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10968), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13658), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [268334] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13659), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [268386] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10972), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13660), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [268466] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19116), 1,
      sym__power_operator,
    STATE(13661), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [268510] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19144), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13662), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [268590] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13663), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [268632] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19146), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13664), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [268712] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13665), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [268788] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8778), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19148), 1,
      anon_sym_COMMA,
    STATE(17081), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13666), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [268868] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    STATE(13667), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [268918] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    STATE(13668), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [268966] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    STATE(13669), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [269012] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18393), 1,
      sym__power_operator,
    STATE(13670), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [269056] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13671), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [269108] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13672), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [269160] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19116), 1,
      sym__power_operator,
    STATE(13673), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [269204] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11114), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11112), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13674), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [269282] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18666), 1,
      sym__exportable,
    STATE(13675), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [269334] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13676), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [269376] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13677), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [269418] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13678), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [269460] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13679), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 15,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [269504] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13680), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [269556] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13681), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [269600] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(13682), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [269644] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(13683), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11022), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [269686] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13684), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [269748] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11110), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13685), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [269826] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13686), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [269900] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13687), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [269970] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13688), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [270038] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13689), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [270096] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19336), 1,
      sym__exportable,
    STATE(13690), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [270148] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13691), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_EQ,
      anon_sym_COLON2,
      sym__comparison_operator,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [270210] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13692), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [270262] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13693), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [270312] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(13694), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [270354] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(13695), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [270396] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(13696), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [270438] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7806), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19150), 1,
      anon_sym_COMMA,
    STATE(17423), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13697), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [270518] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15718), 1,
      anon_sym_EQ,
    STATE(13698), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [270560] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(13699), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [270604] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13700), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [270652] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13701), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [270698] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18498), 1,
      sym__power_operator,
    STATE(13702), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 8,
      anon_sym_EQ,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [270742] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15590), 1,
      anon_sym_DASH_GT,
    STATE(13703), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [270784] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13704), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [270828] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18863), 1,
      sym__exportable,
    STATE(13705), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [270880] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19154), 1,
      anon_sym_AT,
    STATE(10724), 1,
      sym__exportable,
    STATE(13706), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [270932] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7260), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19156), 1,
      anon_sym_COMMA,
    STATE(17415), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13707), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [271012] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15388), 1,
      anon_sym_EQ,
    STATE(13708), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271056] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(13709), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271100] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10112), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13710), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271144] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(13711), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271188] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9840), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13712), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271232] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19154), 1,
      anon_sym_AT,
    STATE(10832), 1,
      sym__exportable,
    STATE(13713), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [271284] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18633), 1,
      sym__exportable,
    STATE(13714), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [271336] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(13715), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271380] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12437), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13716), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271424] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12437), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13717), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271468] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19190), 1,
      sym__exportable,
    STATE(13718), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [271520] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19158), 1,
      anon_sym_COMMA,
    ACTIONS(19160), 1,
      anon_sym_RBRACE,
    STATE(17498), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13719), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [271600] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(13720), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271644] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18510), 1,
      sym__word_identifier,
    ACTIONS(19162), 1,
      anon_sym_LPAREN,
    ACTIONS(19164), 1,
      anon_sym_DOLLAR,
    ACTIONS(19166), 1,
      anon_sym_AT,
    STATE(7516), 1,
      sym__exportable,
    STATE(13721), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8276), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13904), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13918), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [271696] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18510), 1,
      sym__word_identifier,
    ACTIONS(19162), 1,
      anon_sym_LPAREN,
    ACTIONS(19164), 1,
      anon_sym_DOLLAR,
    ACTIONS(19166), 1,
      anon_sym_AT,
    STATE(7517), 1,
      sym__exportable,
    STATE(13722), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8276), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13904), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13918), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [271748] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19168), 1,
      anon_sym_COMMA,
    ACTIONS(19170), 1,
      anon_sym_RBRACE,
    STATE(17465), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13723), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [271828] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18374), 1,
      sym__exportable,
    STATE(13724), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [271880] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(13725), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [271924] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18784), 1,
      sym__exportable,
    STATE(13726), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [271976] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10835), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(10840), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13727), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [272054] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15756), 1,
      anon_sym_EQ,
    STATE(13728), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [272096] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18585), 1,
      sym__exportable,
    STATE(13729), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272148] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18780), 1,
      sym__exportable,
    STATE(13730), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272200] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(13731), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [272244] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8094), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19172), 1,
      anon_sym_COMMA,
    STATE(17492), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13732), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [272324] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18265), 1,
      sym__exportable,
    STATE(13733), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272376] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18456), 1,
      sym__exportable,
    STATE(13734), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272428] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19615), 1,
      sym__exportable,
    STATE(13735), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272480] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19573), 1,
      sym__exportable,
    STATE(13736), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272532] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18426), 1,
      sym__exportable,
    STATE(13737), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272584] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(18674), 1,
      sym__exportable,
    STATE(13738), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272636] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19029), 1,
      sym__exportable,
    STATE(13739), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272688] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19250), 1,
      sym__exportable,
    STATE(13740), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272740] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19587), 1,
      sym__exportable,
    STATE(13741), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272792] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19324), 1,
      sym__exportable,
    STATE(13742), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272844] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18435), 1,
      sym__pair_operator,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(19176), 1,
      anon_sym_QMARK,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13743), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(19174), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [272920] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18510), 1,
      sym__word_identifier,
    ACTIONS(19162), 1,
      anon_sym_LPAREN,
    ACTIONS(19164), 1,
      anon_sym_DOLLAR,
    ACTIONS(19166), 1,
      anon_sym_AT,
    STATE(7971), 1,
      sym__exportable,
    STATE(13744), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8276), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13904), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13918), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [272972] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18510), 1,
      sym__word_identifier,
    ACTIONS(19162), 1,
      anon_sym_LPAREN,
    ACTIONS(19164), 1,
      anon_sym_DOLLAR,
    ACTIONS(19166), 1,
      anon_sym_AT,
    STATE(7978), 1,
      sym__exportable,
    STATE(13745), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8276), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13904), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13918), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [273024] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19178), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13746), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273104] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18435), 1,
      sym__pair_operator,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(19176), 1,
      anon_sym_QMARK,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13747), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11289), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273180] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19180), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13748), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273260] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19182), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13749), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273340] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10982), 2,
      anon_sym_end,
      sym__pair_operator,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13750), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273418] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19184), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13751), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273498] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19082), 1,
      anon_sym_DOLLAR,
    ACTIONS(19084), 1,
      anon_sym_AT,
    STATE(19111), 1,
      sym__exportable,
    STATE(13752), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [273550] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7854), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19186), 1,
      anon_sym_COMMA,
    STATE(17383), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13753), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273630] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19176), 1,
      anon_sym_QMARK,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19192), 1,
      anon_sym_where,
    ACTIONS(19194), 1,
      sym__pair_operator,
    ACTIONS(19196), 1,
      sym__arrow_operator,
    ACTIONS(19198), 1,
      sym__lazy_or_operator,
    ACTIONS(19200), 1,
      sym__lazy_and_operator,
    ACTIONS(19202), 1,
      sym__comparison_operator,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13754), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(19190), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [273706] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15682), 1,
      anon_sym_EQ,
    STATE(13755), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [273750] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12215), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13756), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [273794] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13757), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10928), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10964), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [273836] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13758), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10966), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10968), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [273878] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13759), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10970), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(10972), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [273920] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19220), 1,
      anon_sym_COMMA,
    ACTIONS(19222), 1,
      anon_sym_RBRACE,
    STATE(17295), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13760), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274000] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6998), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19224), 1,
      anon_sym_COMMA,
    STATE(17066), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13761), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274080] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7294), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19226), 1,
      anon_sym_COMMA,
    STATE(17546), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13762), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274160] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(13763), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [274204] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(13764), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [274248] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19228), 1,
      anon_sym_COMMA,
    ACTIONS(19230), 1,
      anon_sym_RBRACE,
    STATE(17620), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13765), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274328] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19232), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13766), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274408] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19234), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13767), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274488] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7740), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19236), 1,
      anon_sym_COMMA,
    STATE(17254), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13768), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274568] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12425), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13769), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [274612] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19176), 1,
      anon_sym_QMARK,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19192), 1,
      anon_sym_where,
    ACTIONS(19194), 1,
      sym__pair_operator,
    ACTIONS(19196), 1,
      sym__arrow_operator,
    ACTIONS(19198), 1,
      sym__lazy_or_operator,
    ACTIONS(19200), 1,
      sym__lazy_and_operator,
    ACTIONS(19202), 1,
      sym__comparison_operator,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13770), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(19190), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274688] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12425), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13771), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [274732] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10222), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13772), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [274776] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11263), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13773), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [274820] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7900), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19238), 1,
      anon_sym_COMMA,
    STATE(17502), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13774), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [274900] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(13775), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [274944] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19240), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13776), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [275024] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15490), 1,
      anon_sym_EQ,
    STATE(13777), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [275068] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(13778), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [275112] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18425), 1,
      sym__word_identifier,
    ACTIONS(19242), 1,
      anon_sym_LPAREN,
    ACTIONS(19244), 1,
      anon_sym_DOLLAR,
    ACTIONS(19246), 1,
      anon_sym_AT,
    STATE(8330), 1,
      sym__exportable,
    STATE(13779), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8307), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14888), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14902), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [275164] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18504), 1,
      sym__word_identifier,
    ACTIONS(19248), 1,
      anon_sym_LPAREN,
    ACTIONS(19250), 1,
      anon_sym_DOLLAR,
    ACTIONS(19252), 1,
      anon_sym_AT,
    STATE(7702), 1,
      sym__exportable,
    STATE(13780), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7981), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14498), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14512), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [275216] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18504), 1,
      sym__word_identifier,
    ACTIONS(19248), 1,
      anon_sym_LPAREN,
    ACTIONS(19250), 1,
      anon_sym_DOLLAR,
    ACTIONS(19252), 1,
      anon_sym_AT,
    STATE(7718), 1,
      sym__exportable,
    STATE(13781), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7981), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14498), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14512), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [275268] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13782), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [275312] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19254), 1,
      anon_sym_COMMA,
    ACTIONS(19256), 1,
      anon_sym_RBRACE,
    STATE(17086), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13783), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [275392] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11249), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11247), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13784), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [275470] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11289), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18470), 1,
      anon_sym_QMARK,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(11287), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13785), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [275548] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10361), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13786), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [275592] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10361), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13787), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [275636] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15600), 1,
      aux_sym__terminator_token1,
    ACTIONS(15598), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    STATE(13788), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 22,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__comparison_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
      sym__unary_plus_operator,
  [275678] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18712), 1,
      sym__word_identifier,
    ACTIONS(19258), 1,
      anon_sym_LPAREN,
    ACTIONS(19260), 1,
      anon_sym_DOLLAR,
    ACTIONS(19262), 1,
      anon_sym_AT,
    STATE(7368), 1,
      sym__exportable,
    STATE(13789), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8417), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14624), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14638), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [275730] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18712), 1,
      sym__word_identifier,
    ACTIONS(19258), 1,
      anon_sym_LPAREN,
    ACTIONS(19260), 1,
      anon_sym_DOLLAR,
    ACTIONS(19262), 1,
      anon_sym_AT,
    STATE(7518), 1,
      sym__exportable,
    STATE(13790), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8417), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14624), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14638), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [275782] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8810), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19264), 1,
      anon_sym_COMMA,
    STATE(17334), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13791), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [275862] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18427), 1,
      anon_sym_COLON,
    ACTIONS(18433), 1,
      anon_sym_where,
    ACTIONS(18435), 1,
      sym__pair_operator,
    ACTIONS(18437), 1,
      sym__arrow_operator,
    ACTIONS(18439), 1,
      sym__lazy_or_operator,
    ACTIONS(18441), 1,
      sym__lazy_and_operator,
    ACTIONS(18443), 1,
      sym__comparison_operator,
    ACTIONS(18445), 1,
      sym__pipe_right_operator,
    ACTIONS(18447), 1,
      sym__pipe_left_operator,
    ACTIONS(18449), 1,
      sym__ellipsis_operator,
    ACTIONS(18453), 1,
      sym__times_operator,
    ACTIONS(18455), 1,
      sym__rational_operator,
    ACTIONS(18457), 1,
      sym__bitshift_operator,
    ACTIONS(18459), 1,
      sym__power_operator,
    ACTIONS(19176), 1,
      anon_sym_QMARK,
    ACTIONS(18451), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13792), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    ACTIONS(18429), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [275938] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9840), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13793), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [275982] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9966), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13794), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [276026] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(11249), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13795), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276104] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18365), 1,
      anon_sym_QMARK,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(11289), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13796), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276182] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19266), 1,
      anon_sym_COMMA,
    ACTIONS(19268), 1,
      anon_sym_RBRACE,
    STATE(17135), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13797), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276262] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19270), 1,
      anon_sym_COMMA,
    ACTIONS(19272), 1,
      anon_sym_RBRACE,
    STATE(17280), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13798), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276342] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19274), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13799), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276422] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19126), 1,
      anon_sym_where,
    ACTIONS(19128), 1,
      sym__pair_operator,
    ACTIONS(19130), 1,
      sym__arrow_operator,
    ACTIONS(19132), 1,
      sym__lazy_or_operator,
    ACTIONS(19134), 1,
      sym__lazy_and_operator,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13800), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(19276), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
  [276498] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19278), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13801), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276578] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19280), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_RBRACE,
    STATE(17221), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13802), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276658] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7936), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19284), 1,
      anon_sym_COMMA,
    STATE(17180), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13803), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276738] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15414), 1,
      anon_sym_EQ,
    STATE(13804), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [276782] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7332), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19286), 1,
      anon_sym_COMMA,
    STATE(17540), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13805), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [276862] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(13806), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [276906] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12175), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13807), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [276950] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19288), 1,
      anon_sym_DOLLAR,
    ACTIONS(19290), 1,
      anon_sym_AT,
    STATE(12595), 1,
      sym__exportable,
    STATE(13808), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277002] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19288), 1,
      anon_sym_DOLLAR,
    ACTIONS(19290), 1,
      anon_sym_AT,
    STATE(12596), 1,
      sym__exportable,
    STATE(13809), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277054] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(13810), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [277098] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19288), 1,
      anon_sym_DOLLAR,
    ACTIONS(19290), 1,
      anon_sym_AT,
    STATE(11557), 1,
      sym__exportable,
    STATE(13811), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277150] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19288), 1,
      anon_sym_DOLLAR,
    ACTIONS(19290), 1,
      anon_sym_AT,
    STATE(11583), 1,
      sym__exportable,
    STATE(13812), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277202] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19292), 1,
      anon_sym_COMMA,
    ACTIONS(19294), 1,
      anon_sym_RBRACE,
    STATE(17258), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13813), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [277282] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19296), 1,
      anon_sym_COMMA,
    ACTIONS(19298), 1,
      anon_sym_RBRACE,
    STATE(17329), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13814), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [277362] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18712), 1,
      sym__word_identifier,
    ACTIONS(19258), 1,
      anon_sym_LPAREN,
    ACTIONS(19260), 1,
      anon_sym_DOLLAR,
    ACTIONS(19262), 1,
      anon_sym_AT,
    STATE(8166), 1,
      sym__exportable,
    STATE(13815), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8417), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14624), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14638), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277414] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18712), 1,
      sym__word_identifier,
    ACTIONS(19258), 1,
      anon_sym_LPAREN,
    ACTIONS(19260), 1,
      anon_sym_DOLLAR,
    ACTIONS(19262), 1,
      anon_sym_AT,
    STATE(8170), 1,
      sym__exportable,
    STATE(13816), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8417), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14624), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14638), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277466] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19300), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13817), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [277546] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19302), 1,
      anon_sym_DOLLAR,
    ACTIONS(19304), 1,
      anon_sym_AT,
    STATE(12603), 1,
      sym__exportable,
    STATE(13818), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277598] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19302), 1,
      anon_sym_DOLLAR,
    ACTIONS(19304), 1,
      anon_sym_AT,
    STATE(12604), 1,
      sym__exportable,
    STATE(13819), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277650] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19302), 1,
      anon_sym_DOLLAR,
    ACTIONS(19304), 1,
      anon_sym_AT,
    STATE(10724), 1,
      sym__exportable,
    STATE(13820), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277702] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19302), 1,
      anon_sym_DOLLAR,
    ACTIONS(19304), 1,
      anon_sym_AT,
    STATE(10832), 1,
      sym__exportable,
    STATE(13821), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277754] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19154), 1,
      anon_sym_AT,
    STATE(11321), 1,
      sym__exportable,
    STATE(13822), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [277806] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19306), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13823), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [277886] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7564), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19308), 1,
      anon_sym_COMMA,
    STATE(17647), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13824), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [277966] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13825), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [278028] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19202), 1,
      sym__comparison_operator,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13826), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19190), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [278092] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19192), 1,
      anon_sym_where,
    ACTIONS(19196), 1,
      sym__arrow_operator,
    ACTIONS(19198), 1,
      sym__lazy_or_operator,
    ACTIONS(19200), 1,
      sym__lazy_and_operator,
    ACTIONS(19202), 1,
      sym__comparison_operator,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13827), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19190), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
  [278164] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19192), 1,
      anon_sym_where,
    ACTIONS(19200), 1,
      sym__lazy_and_operator,
    ACTIONS(19202), 1,
      sym__comparison_operator,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13828), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19190), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [278232] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19192), 1,
      anon_sym_where,
    ACTIONS(19202), 1,
      sym__comparison_operator,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13829), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19190), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 8,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [278298] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13830), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 14,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [278356] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19188), 1,
      anon_sym_COLON,
    ACTIONS(19204), 1,
      sym__pipe_right_operator,
    ACTIONS(19206), 1,
      sym__pipe_left_operator,
    ACTIONS(19208), 1,
      sym__ellipsis_operator,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13831), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [278418] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13832), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [278470] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    STATE(13833), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [278520] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    STATE(13834), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [278568] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    STATE(13835), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [278614] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19218), 1,
      sym__power_operator,
    STATE(13836), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [278658] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19310), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13837), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [278738] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(16182), 1,
      anon_sym_EQ,
    STATE(13838), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [278782] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16182), 1,
      anon_sym_EQ,
    STATE(13839), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [278826] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19218), 1,
      sym__power_operator,
    STATE(13840), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [278870] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19212), 1,
      sym__times_operator,
    ACTIONS(19214), 1,
      sym__rational_operator,
    ACTIONS(19216), 1,
      sym__bitshift_operator,
    ACTIONS(19218), 1,
      sym__power_operator,
    ACTIONS(19210), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13841), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [278922] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15594), 1,
      anon_sym_DASH_GT,
    STATE(13842), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [278964] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19152), 1,
      anon_sym_DOLLAR,
    ACTIONS(19154), 1,
      anon_sym_AT,
    STATE(11322), 1,
      sym__exportable,
    STATE(13843), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [279016] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15738), 1,
      anon_sym_EQ,
    STATE(13844), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 18,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279058] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15680), 1,
      anon_sym_DASH_GT,
    STATE(13845), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279100] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7990), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19312), 1,
      anon_sym_COMMA,
    STATE(17411), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13846), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [279180] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12215), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13847), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279224] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(13848), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279268] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19314), 1,
      anon_sym_COMMA,
    ACTIONS(19316), 1,
      anon_sym_RBRACE,
    STATE(17434), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13849), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [279348] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6912), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19318), 1,
      anon_sym_COMMA,
    STATE(17603), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13850), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [279428] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15750), 1,
      anon_sym_EQ,
    STATE(13851), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279472] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13852), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 9,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [279536] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(13853), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279580] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(13854), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279624] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18834), 1,
      sym__power_operator,
    STATE(13855), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [279668] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12806), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13856), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279712] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7150), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19320), 1,
      anon_sym_COMMA,
    STATE(17642), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13857), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [279792] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12806), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13858), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279836] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7388), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19322), 1,
      anon_sym_COMMA,
    STATE(17381), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13859), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [279916] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15658), 1,
      anon_sym_EQ,
    ACTIONS(15660), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(13860), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [279962] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(19324), 1,
      anon_sym_DOLLAR,
    ACTIONS(19326), 1,
      anon_sym_AT,
    STATE(11842), 1,
      sym__exportable,
    STATE(13861), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11986), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14144), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [280014] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(19324), 1,
      anon_sym_DOLLAR,
    ACTIONS(19326), 1,
      anon_sym_AT,
    STATE(11887), 1,
      sym__exportable,
    STATE(13862), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11986), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14144), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [280066] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9966), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13863), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [280110] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(13864), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [280154] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19328), 1,
      anon_sym_COMMA,
    ACTIONS(19330), 1,
      anon_sym_RBRACE,
    STATE(17235), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13865), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [280234] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18828), 1,
      sym__times_operator,
    ACTIONS(18830), 1,
      sym__rational_operator,
    ACTIONS(18832), 1,
      sym__bitshift_operator,
    ACTIONS(18834), 1,
      sym__power_operator,
    ACTIONS(18826), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13866), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_SEMI,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [280286] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(16202), 1,
      anon_sym_EQ,
    STATE(13867), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [280330] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10208), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13868), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [280374] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12213), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13869), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [280418] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18425), 1,
      sym__word_identifier,
    ACTIONS(19242), 1,
      anon_sym_LPAREN,
    ACTIONS(19244), 1,
      anon_sym_DOLLAR,
    ACTIONS(19246), 1,
      anon_sym_AT,
    STATE(8332), 1,
      sym__exportable,
    STATE(13870), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8307), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14888), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14902), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [280470] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19332), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13871), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [280550] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19126), 1,
      anon_sym_where,
    ACTIONS(19128), 1,
      sym__pair_operator,
    ACTIONS(19130), 1,
      sym__arrow_operator,
    ACTIONS(19132), 1,
      sym__lazy_or_operator,
    ACTIONS(19134), 1,
      sym__lazy_and_operator,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13872), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(19334), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
  [280626] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19336), 1,
      anon_sym_COMMA,
    ACTIONS(19338), 1,
      anon_sym_RBRACE,
    STATE(17474), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13873), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [280706] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8026), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19340), 1,
      anon_sym_COMMA,
    STATE(17464), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13874), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [280786] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(13875), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [280830] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(13876), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [280874] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19342), 1,
      anon_sym_COMMA,
    ACTIONS(19344), 1,
      anon_sym_RBRACE,
    STATE(17406), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13877), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [280954] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19346), 1,
      anon_sym_COMMA,
    ACTIONS(19348), 1,
      anon_sym_RBRACE,
    STATE(17467), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13878), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [281034] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19350), 1,
      anon_sym_COMMA,
    ACTIONS(19352), 1,
      anon_sym_RBRACE,
    STATE(17401), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13879), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [281114] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19354), 1,
      anon_sym_DOLLAR,
    ACTIONS(19356), 1,
      anon_sym_AT,
    STATE(12349), 1,
      sym__exportable,
    STATE(13880), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281166] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19354), 1,
      anon_sym_DOLLAR,
    ACTIONS(19356), 1,
      anon_sym_AT,
    STATE(12350), 1,
      sym__exportable,
    STATE(13881), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281218] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19354), 1,
      anon_sym_DOLLAR,
    ACTIONS(19356), 1,
      anon_sym_AT,
    STATE(11557), 1,
      sym__exportable,
    STATE(13882), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281270] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19354), 1,
      anon_sym_DOLLAR,
    ACTIONS(19356), 1,
      anon_sym_AT,
    STATE(11583), 1,
      sym__exportable,
    STATE(13883), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281322] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    STATE(13884), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 17,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [281364] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19358), 1,
      anon_sym_DOLLAR,
    ACTIONS(19360), 1,
      anon_sym_AT,
    STATE(13402), 1,
      sym__exportable,
    STATE(13885), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281416] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19358), 1,
      anon_sym_DOLLAR,
    ACTIONS(19360), 1,
      anon_sym_AT,
    STATE(13403), 1,
      sym__exportable,
    STATE(13886), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281468] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19358), 1,
      anon_sym_DOLLAR,
    ACTIONS(19360), 1,
      anon_sym_AT,
    STATE(10724), 1,
      sym__exportable,
    STATE(13887), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281520] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19358), 1,
      anon_sym_DOLLAR,
    ACTIONS(19360), 1,
      anon_sym_AT,
    STATE(10832), 1,
      sym__exportable,
    STATE(13888), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281572] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(13889), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [281616] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19362), 1,
      anon_sym_DOLLAR,
    ACTIONS(19364), 1,
      anon_sym_AT,
    STATE(11965), 1,
      sym__exportable,
    STATE(13890), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281668] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19362), 1,
      anon_sym_DOLLAR,
    ACTIONS(19364), 1,
      anon_sym_AT,
    STATE(11966), 1,
      sym__exportable,
    STATE(13891), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281720] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10222), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13892), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [281764] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19362), 1,
      anon_sym_DOLLAR,
    ACTIONS(19364), 1,
      anon_sym_AT,
    STATE(11557), 1,
      sym__exportable,
    STATE(13893), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281816] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19362), 1,
      anon_sym_DOLLAR,
    ACTIONS(19364), 1,
      anon_sym_AT,
    STATE(11583), 1,
      sym__exportable,
    STATE(13894), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [281868] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19366), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13895), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [281948] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19368), 1,
      anon_sym_DOLLAR,
    ACTIONS(19370), 1,
      anon_sym_AT,
    STATE(11971), 1,
      sym__exportable,
    STATE(13896), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282000] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19368), 1,
      anon_sym_DOLLAR,
    ACTIONS(19370), 1,
      anon_sym_AT,
    STATE(11972), 1,
      sym__exportable,
    STATE(13897), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282052] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19368), 1,
      anon_sym_DOLLAR,
    ACTIONS(19370), 1,
      anon_sym_AT,
    STATE(10724), 1,
      sym__exportable,
    STATE(13898), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282104] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(16318), 1,
      anon_sym_LPAREN,
    ACTIONS(19368), 1,
      anon_sym_DOLLAR,
    ACTIONS(19370), 1,
      anon_sym_AT,
    STATE(10832), 1,
      sym__exportable,
    STATE(13899), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10580), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13400), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13418), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282156] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19372), 1,
      anon_sym_DOLLAR,
    ACTIONS(19374), 1,
      anon_sym_AT,
    STATE(12359), 1,
      sym__exportable,
    STATE(13900), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282208] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19372), 1,
      anon_sym_DOLLAR,
    ACTIONS(19374), 1,
      anon_sym_AT,
    STATE(12360), 1,
      sym__exportable,
    STATE(13901), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282260] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18423), 1,
      sym__word_identifier,
    ACTIONS(18770), 1,
      anon_sym_LPAREN,
    ACTIONS(18772), 1,
      anon_sym_DOLLAR,
    ACTIONS(18774), 1,
      anon_sym_AT,
    STATE(7362), 1,
      sym__exportable,
    STATE(13902), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8554), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13832), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13846), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282312] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18423), 1,
      sym__word_identifier,
    ACTIONS(18770), 1,
      anon_sym_LPAREN,
    ACTIONS(18772), 1,
      anon_sym_DOLLAR,
    ACTIONS(18774), 1,
      anon_sym_AT,
    STATE(7389), 1,
      sym__exportable,
    STATE(13903), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8554), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(13832), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(13846), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282364] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19372), 1,
      anon_sym_DOLLAR,
    ACTIONS(19374), 1,
      anon_sym_AT,
    STATE(11557), 1,
      sym__exportable,
    STATE(13904), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282416] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7110), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19376), 1,
      anon_sym_COMMA,
    STATE(17499), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13905), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [282496] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    ACTIONS(19100), 1,
      anon_sym_COLON,
    ACTIONS(19102), 1,
      sym__pipe_right_operator,
    ACTIONS(19104), 1,
      sym__pipe_left_operator,
    ACTIONS(19106), 1,
      sym__ellipsis_operator,
    ACTIONS(19110), 1,
      sym__times_operator,
    ACTIONS(19112), 1,
      sym__rational_operator,
    ACTIONS(19114), 1,
      sym__bitshift_operator,
    ACTIONS(19116), 1,
      sym__power_operator,
    ACTIONS(19126), 1,
      anon_sym_where,
    ACTIONS(19128), 1,
      sym__pair_operator,
    ACTIONS(19130), 1,
      sym__arrow_operator,
    ACTIONS(19132), 1,
      sym__lazy_or_operator,
    ACTIONS(19134), 1,
      sym__lazy_and_operator,
    ACTIONS(19136), 1,
      sym__comparison_operator,
    ACTIONS(19108), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13906), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11114), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(19124), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [282572] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19372), 1,
      anon_sym_DOLLAR,
    ACTIONS(19374), 1,
      anon_sym_AT,
    STATE(11583), 1,
      sym__exportable,
    STATE(13907), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282624] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16526), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18104), 1,
      anon_sym_COLON,
    ACTIONS(18110), 1,
      anon_sym_where,
    ACTIONS(18112), 1,
      sym__pair_operator,
    ACTIONS(18114), 1,
      sym__arrow_operator,
    ACTIONS(18116), 1,
      sym__lazy_or_operator,
    ACTIONS(18118), 1,
      sym__lazy_and_operator,
    ACTIONS(18120), 1,
      sym__comparison_operator,
    ACTIONS(18122), 1,
      sym__pipe_right_operator,
    ACTIONS(18124), 1,
      sym__pipe_left_operator,
    ACTIONS(18126), 1,
      sym__ellipsis_operator,
    ACTIONS(18130), 1,
      sym__times_operator,
    ACTIONS(18132), 1,
      sym__rational_operator,
    ACTIONS(18134), 1,
      sym__bitshift_operator,
    ACTIONS(18136), 1,
      sym__power_operator,
    ACTIONS(18419), 1,
      anon_sym_QMARK,
    ACTIONS(18128), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13908), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11249), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
    ACTIONS(18106), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [282700] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19378), 1,
      anon_sym_DOLLAR,
    ACTIONS(19380), 1,
      anon_sym_AT,
    STATE(12362), 1,
      sym__exportable,
    STATE(13909), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282752] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19378), 1,
      anon_sym_DOLLAR,
    ACTIONS(19380), 1,
      anon_sym_AT,
    STATE(12363), 1,
      sym__exportable,
    STATE(13910), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282804] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19378), 1,
      anon_sym_DOLLAR,
    ACTIONS(19380), 1,
      anon_sym_AT,
    STATE(11557), 1,
      sym__exportable,
    STATE(13911), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282856] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19378), 1,
      anon_sym_DOLLAR,
    ACTIONS(19380), 1,
      anon_sym_AT,
    STATE(11583), 1,
      sym__exportable,
    STATE(13912), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [282908] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7432), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19382), 1,
      anon_sym_COMMA,
    STATE(17141), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13913), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [282988] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19384), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13914), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [283068] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12175), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13915), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [283112] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12630), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13916), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [283156] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    STATE(13917), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [283200] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19386), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13918), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [283280] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10208), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13919), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [283324] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    STATE(13920), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [283368] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19388), 1,
      anon_sym_COMMA,
    ACTIONS(19390), 1,
      anon_sym_RBRACE,
    STATE(17516), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13921), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [283448] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(19324), 1,
      anon_sym_DOLLAR,
    ACTIONS(19326), 1,
      anon_sym_AT,
    STATE(12257), 1,
      sym__exportable,
    STATE(13922), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11986), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14144), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [283500] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(16440), 1,
      anon_sym_LPAREN,
    ACTIONS(19324), 1,
      anon_sym_DOLLAR,
    ACTIONS(19326), 1,
      anon_sym_AT,
    STATE(12270), 1,
      sym__exportable,
    STATE(13923), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11986), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14144), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14164), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [283552] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19392), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13924), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [283632] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8060), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19394), 1,
      anon_sym_COMMA,
    STATE(17611), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13925), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [283712] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13926), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(19396), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [283788] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(13927), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [283832] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(13928), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [283876] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6968), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19398), 1,
      anon_sym_COMMA,
    STATE(17089), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13929), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [283956] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19400), 1,
      anon_sym_COMMA,
    ACTIONS(19402), 1,
      anon_sym_RBRACE,
    STATE(17152), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13930), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284036] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10110), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13931), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [284080] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19404), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13932), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284160] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7422), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19406), 1,
      anon_sym_COMMA,
    STATE(17480), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13933), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284240] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(13934), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [284284] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10098), 1,
      anon_sym_EQ,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    STATE(13935), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [284328] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6906), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19408), 1,
      anon_sym_COMMA,
    STATE(17253), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13936), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284408] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18425), 1,
      sym__word_identifier,
    ACTIONS(19242), 1,
      anon_sym_LPAREN,
    ACTIONS(19244), 1,
      anon_sym_DOLLAR,
    ACTIONS(19246), 1,
      anon_sym_AT,
    STATE(7467), 1,
      sym__exportable,
    STATE(13937), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8307), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14888), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14902), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [284460] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18425), 1,
      sym__word_identifier,
    ACTIONS(19242), 1,
      anon_sym_LPAREN,
    ACTIONS(19244), 1,
      anon_sym_DOLLAR,
    ACTIONS(19246), 1,
      anon_sym_AT,
    STATE(7468), 1,
      sym__exportable,
    STATE(13938), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8307), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14888), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14902), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [284512] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19410), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13939), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284592] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11022), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18357), 1,
      anon_sym_COMMA,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    STATE(13389), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13940), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284672] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15630), 1,
      anon_sym_EQ,
    ACTIONS(15632), 2,
      anon_sym_in,
      anon_sym_u2208,
    STATE(13941), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 15,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [284718] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8384), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19412), 1,
      anon_sym_COMMA,
    STATE(17610), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13942), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284798] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19414), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13943), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [284878] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15680), 1,
      anon_sym_DASH_GT,
    STATE(13944), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [284920] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8104), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19416), 1,
      anon_sym_COMMA,
    STATE(17119), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13945), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285000] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(13946), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [285044] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18504), 1,
      sym__word_identifier,
    ACTIONS(19248), 1,
      anon_sym_LPAREN,
    ACTIONS(19250), 1,
      anon_sym_DOLLAR,
    ACTIONS(19252), 1,
      anon_sym_AT,
    STATE(8223), 1,
      sym__exportable,
    STATE(13947), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7981), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14498), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14512), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [285096] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15690), 1,
      anon_sym_DASH_GT,
    ACTIONS(16202), 1,
      anon_sym_EQ,
    STATE(13948), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [285140] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19418), 1,
      anon_sym_COMMA,
    ACTIONS(19420), 1,
      anon_sym_RBRACE,
    STATE(17376), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13949), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285220] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19422), 1,
      anon_sym_COMMA,
    ACTIONS(19424), 1,
      anon_sym_RBRACE,
    STATE(17407), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13950), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285300] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18504), 1,
      sym__word_identifier,
    ACTIONS(19248), 1,
      anon_sym_LPAREN,
    ACTIONS(19250), 1,
      anon_sym_DOLLAR,
    ACTIONS(19252), 1,
      anon_sym_AT,
    STATE(8228), 1,
      sym__exportable,
    STATE(13951), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7981), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14498), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14512), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [285352] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19426), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13952), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285432] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9854), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13953), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [285476] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19428), 1,
      anon_sym_DOLLAR,
    ACTIONS(19430), 1,
      anon_sym_AT,
    STATE(11557), 1,
      sym__exportable,
    STATE(13954), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [285528] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19432), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13955), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285608] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8138), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19434), 1,
      anon_sym_COMMA,
    STATE(17214), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13956), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285688] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19428), 1,
      anon_sym_DOLLAR,
    ACTIONS(19430), 1,
      anon_sym_AT,
    STATE(11583), 1,
      sym__exportable,
    STATE(13957), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [285740] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(13958), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [285784] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13959), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10982), 3,
      anon_sym_COMMA,
      anon_sym_end,
      sym__pair_operator,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285860] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7474), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19436), 1,
      anon_sym_COMMA,
    STATE(17456), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13960), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [285940] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10098), 1,
      anon_sym_EQ,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(13961), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [285984] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(13962), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [286028] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19438), 1,
      anon_sym_COMMA,
    ACTIONS(19440), 1,
      anon_sym_RBRACE,
    STATE(17204), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13963), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286108] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10982), 2,
      anon_sym_RPAREN,
      sym__pair_operator,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13964), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286186] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19442), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13965), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286266] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19444), 1,
      anon_sym_COMMA,
    ACTIONS(19446), 1,
      anon_sym_RBRACE,
    STATE(17542), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13966), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286346] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19448), 1,
      anon_sym_COMMA,
    ACTIONS(19450), 1,
      anon_sym_RBRACE,
    STATE(17662), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13967), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286426] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7600), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(19452), 1,
      anon_sym_COMMA,
    STATE(17551), 1,
      aux_sym_tuple_expression_repeat1,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13968), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286506] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(13969), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [286550] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19428), 1,
      anon_sym_DOLLAR,
    ACTIONS(19430), 1,
      anon_sym_AT,
    STATE(12483), 1,
      sym__exportable,
    STATE(13970), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [286602] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(16396), 1,
      anon_sym_LPAREN,
    ACTIONS(19428), 1,
      anon_sym_DOLLAR,
    ACTIONS(19430), 1,
      anon_sym_AT,
    STATE(12586), 1,
      sym__exportable,
    STATE(13971), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11402), 4,
      sym_interpolation_expression,
      sym_macro_identifier,
      sym_identifier,
      sym_operator,
    ACTIONS(14244), 6,
      sym__arrow_operator,
      sym__comparison_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_operator,
      sym__unary_plus_operator,
    ACTIONS(14264), 10,
      anon_sym_COLON2,
      sym__pair_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__ellipsis_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__tilde_operator,
      sym__type_order_operator,
  [286654] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(13972), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [286698] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19454), 1,
      anon_sym_COMMA,
    ACTIONS(19456), 1,
      anon_sym_RBRACE,
    STATE(17593), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13973), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286778] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19458), 1,
      anon_sym_COLON2,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13974), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286858] = 25,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(19460), 1,
      anon_sym_COMMA,
    ACTIONS(19462), 1,
      anon_sym_RBRACE,
    STATE(17271), 1,
      aux_sym_vector_expression_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13975), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [286938] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19468), 1,
      anon_sym_where,
    ACTIONS(19470), 1,
      sym__pair_operator,
    ACTIONS(19472), 1,
      sym__arrow_operator,
    ACTIONS(19474), 1,
      sym__lazy_or_operator,
    ACTIONS(19476), 1,
      sym__lazy_and_operator,
    ACTIONS(19478), 1,
      sym__comparison_operator,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(11110), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13976), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19466), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [287013] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(11289), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19500), 1,
      anon_sym_QMARK,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19504), 1,
      sym__pair_operator,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13977), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [287090] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19334), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(13978), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [287165] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(11249), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19534), 1,
      anon_sym_QMARK,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19538), 1,
      sym__pair_operator,
    ACTIONS(19540), 1,
      sym__arrow_operator,
    ACTIONS(19542), 1,
      sym__lazy_or_operator,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13979), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [287242] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13980), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [287299] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_EQ,
    ACTIONS(11289), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19534), 1,
      anon_sym_QMARK,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19538), 1,
      sym__pair_operator,
    ACTIONS(19540), 1,
      sym__arrow_operator,
    ACTIONS(19542), 1,
      sym__lazy_or_operator,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13981), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [287376] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    ACTIONS(17813), 1,
      anon_sym_COLON,
    ACTIONS(17819), 1,
      anon_sym_where,
    ACTIONS(17821), 1,
      sym__pair_operator,
    ACTIONS(17823), 1,
      sym__arrow_operator,
    ACTIONS(17825), 1,
      sym__lazy_or_operator,
    ACTIONS(17827), 1,
      sym__lazy_and_operator,
    ACTIONS(17829), 1,
      sym__comparison_operator,
    ACTIONS(17831), 1,
      sym__pipe_right_operator,
    ACTIONS(17833), 1,
      sym__pipe_left_operator,
    ACTIONS(17835), 1,
      sym__ellipsis_operator,
    ACTIONS(17839), 1,
      sym__times_operator,
    ACTIONS(17841), 1,
      sym__rational_operator,
    ACTIONS(17843), 1,
      sym__bitshift_operator,
    ACTIONS(17845), 1,
      sym__power_operator,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    STATE(17652), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(17837), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13982), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17815), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [287453] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15946), 1,
      anon_sym_EQ,
    STATE(13983), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287494] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12175), 1,
      anon_sym_EQ,
    STATE(13984), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287535] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10194), 1,
      anon_sym_EQ,
    STATE(13985), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287576] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15342), 1,
      anon_sym_EQ,
    STATE(13986), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287617] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13987), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [287678] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16132), 1,
      anon_sym_EQ,
    STATE(13988), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287719] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10110), 1,
      anon_sym_EQ,
    STATE(13989), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287760] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19564), 1,
      sym__power_operator,
    STATE(13990), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 15,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [287803] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13991), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [287854] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16134), 1,
      anon_sym_EQ,
    STATE(13992), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287895] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11221), 1,
      anon_sym_EQ,
    STATE(13993), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287936] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9840), 1,
      anon_sym_EQ,
    STATE(13994), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [287977] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(11110), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19500), 1,
      anon_sym_QMARK,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19504), 1,
      sym__pair_operator,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13995), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [288054] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    STATE(13996), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288097] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12437), 1,
      anon_sym_EQ,
    STATE(13997), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288138] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(13998), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [288211] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12213), 1,
      anon_sym_EQ,
    STATE(13999), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288252] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16182), 1,
      anon_sym_EQ,
    STATE(14000), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288293] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14001), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [288354] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16136), 1,
      anon_sym_EQ,
    STATE(14002), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288395] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15896), 1,
      anon_sym_EQ,
    STATE(14003), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288436] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15952), 1,
      anon_sym_EQ,
    STATE(14004), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288477] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15374), 1,
      sym__immediate_paren,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    STATE(14005), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288520] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15476), 1,
      anon_sym_EQ,
    STATE(14006), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288561] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15588), 1,
      anon_sym_EQ,
    STATE(14007), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288602] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15492), 1,
      anon_sym_EQ,
    STATE(14008), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288643] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15690), 1,
      anon_sym_DASH_GT,
    STATE(14009), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288684] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12806), 1,
      anon_sym_EQ,
    STATE(14010), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288725] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15452), 1,
      anon_sym_EQ,
    STATE(14011), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288766] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(11114), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19500), 1,
      anon_sym_QMARK,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19504), 1,
      sym__pair_operator,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14012), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [288843] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10208), 1,
      anon_sym_EQ,
    STATE(14013), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [288884] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14014), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [288945] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19540), 1,
      sym__arrow_operator,
    ACTIONS(19542), 1,
      sym__lazy_or_operator,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14015), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [289018] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14016), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [289087] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14017), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [289154] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14018), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [289211] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(11108), 2,
      anon_sym_EQ,
      sym__comparison_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14019), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [289272] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14020), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [289323] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    STATE(14021), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [289372] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    STATE(14022), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [289419] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    STATE(14023), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [289464] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19562), 1,
      sym__power_operator,
    STATE(14024), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [289507] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16202), 1,
      anon_sym_EQ,
    STATE(14025), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_end,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [289548] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14026), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [289599] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18025), 1,
      anon_sym_QMARK,
    ACTIONS(18614), 1,
      anon_sym_COLON,
    ACTIONS(18616), 1,
      sym__pipe_right_operator,
    ACTIONS(18618), 1,
      sym__pipe_left_operator,
    ACTIONS(18620), 1,
      sym__ellipsis_operator,
    ACTIONS(18624), 1,
      sym__times_operator,
    ACTIONS(18626), 1,
      sym__rational_operator,
    ACTIONS(18628), 1,
      sym__bitshift_operator,
    ACTIONS(18630), 1,
      sym__power_operator,
    ACTIONS(18634), 1,
      anon_sym_where,
    ACTIONS(18636), 1,
      sym__arrow_operator,
    ACTIONS(18638), 1,
      sym__lazy_or_operator,
    ACTIONS(18640), 1,
      sym__lazy_and_operator,
    ACTIONS(18642), 1,
      sym__comparison_operator,
    ACTIONS(18726), 1,
      sym__pair_operator,
    ACTIONS(18622), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(19276), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(14027), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18632), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [289674] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12166), 1,
      anon_sym_EQ,
    STATE(14028), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [289715] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15966), 1,
      anon_sym_EQ,
    STATE(14029), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [289756] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11287), 1,
      anon_sym_COLON2,
    ACTIONS(11289), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14030), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [289833] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19562), 1,
      sym__power_operator,
    STATE(14031), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 15,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [289876] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14032), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [289927] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10222), 1,
      anon_sym_EQ,
    STATE(14033), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [289968] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14034), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [290035] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14035), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [290104] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10112), 1,
      anon_sym_EQ,
    STATE(14036), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290145] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12215), 1,
      anon_sym_EQ,
    STATE(14037), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290186] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    STATE(14038), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [290235] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    STATE(14039), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290276] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9966), 1,
      anon_sym_EQ,
    STATE(14040), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290317] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    STATE(14041), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [290364] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    STATE(14042), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [290409] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16126), 1,
      anon_sym_EQ,
    STATE(14043), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290450] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15838), 1,
      anon_sym_EQ,
    STATE(14044), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290491] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12630), 1,
      anon_sym_EQ,
    STATE(14045), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290532] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19578), 1,
      sym__comparison_operator,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14046), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19576), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [290597] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15556), 1,
      anon_sym_EQ,
    STATE(14047), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290638] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19468), 1,
      anon_sym_where,
    ACTIONS(19470), 1,
      sym__pair_operator,
    ACTIONS(19472), 1,
      sym__arrow_operator,
    ACTIONS(19474), 1,
      sym__lazy_or_operator,
    ACTIONS(19476), 1,
      sym__lazy_and_operator,
    ACTIONS(19478), 1,
      sym__comparison_operator,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(11114), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14048), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19466), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [290713] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    ACTIONS(11249), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14049), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [290788] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19528), 1,
      sym__power_operator,
    STATE(14050), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [290831] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12425), 1,
      anon_sym_EQ,
    STATE(14051), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290872] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15976), 1,
      anon_sym_EQ,
    STATE(14052), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [290913] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(11108), 2,
      anon_sym_COLON2,
      sym__comparison_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14053), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [290974] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_COLON2,
    ACTIONS(11110), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19578), 1,
      sym__comparison_operator,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(19586), 1,
      anon_sym_where,
    ACTIONS(19588), 1,
      sym__pair_operator,
    ACTIONS(19590), 1,
      sym__arrow_operator,
    ACTIONS(19592), 1,
      sym__lazy_or_operator,
    ACTIONS(19594), 1,
      sym__lazy_and_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14054), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19576), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [291051] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19578), 1,
      sym__comparison_operator,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(19586), 1,
      anon_sym_where,
    ACTIONS(19590), 1,
      sym__arrow_operator,
    ACTIONS(19592), 1,
      sym__lazy_or_operator,
    ACTIONS(19594), 1,
      sym__lazy_and_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14055), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(19576), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [291124] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14056), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [291185] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19468), 1,
      anon_sym_where,
    ACTIONS(19472), 1,
      sym__arrow_operator,
    ACTIONS(19474), 1,
      sym__lazy_or_operator,
    ACTIONS(19476), 1,
      sym__lazy_and_operator,
    ACTIONS(19478), 1,
      sym__comparison_operator,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14057), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19466), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 4,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
  [291256] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19468), 1,
      anon_sym_where,
    ACTIONS(19476), 1,
      sym__lazy_and_operator,
    ACTIONS(19478), 1,
      sym__comparison_operator,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14058), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19466), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [291323] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19468), 1,
      anon_sym_where,
    ACTIONS(19478), 1,
      sym__comparison_operator,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14059), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19466), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 7,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [291388] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14060), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [291445] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14061), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 11,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [291506] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14062), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [291557] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    STATE(14063), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [291606] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    STATE(14064), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [291653] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    STATE(14065), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [291698] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19494), 1,
      sym__power_operator,
    STATE(14066), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [291741] = 20,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19578), 1,
      sym__comparison_operator,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(19586), 1,
      anon_sym_where,
    ACTIONS(19594), 1,
      sym__lazy_and_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14067), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19576), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [291810] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19464), 1,
      anon_sym_COLON,
    ACTIONS(19478), 1,
      sym__comparison_operator,
    ACTIONS(19480), 1,
      sym__pipe_right_operator,
    ACTIONS(19482), 1,
      sym__pipe_left_operator,
    ACTIONS(19484), 1,
      sym__ellipsis_operator,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14068), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19466), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 8,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [291873] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10098), 1,
      anon_sym_EQ,
    STATE(14069), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [291914] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_COLON2,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19578), 1,
      sym__comparison_operator,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(19586), 1,
      anon_sym_where,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14070), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19576), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [291981] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(11108), 2,
      anon_sym_COLON2,
      sym__comparison_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14071), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [292038] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(11108), 2,
      anon_sym_COLON2,
      sym__comparison_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14072), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [292099] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14073), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 4,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [292150] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    STATE(14074), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [292199] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    STATE(14075), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [292246] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    STATE(14076), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [292291] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19564), 1,
      sym__power_operator,
    STATE(14077), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 7,
      anon_sym_COLON,
      anon_sym_COLON2,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [292334] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15360), 1,
      anon_sym_EQ,
    STATE(14078), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [292375] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_EQ,
    ACTIONS(11114), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19534), 1,
      anon_sym_QMARK,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19538), 1,
      sym__pair_operator,
    ACTIONS(19540), 1,
      sym__arrow_operator,
    ACTIONS(19542), 1,
      sym__lazy_or_operator,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14079), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [292452] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11263), 1,
      anon_sym_EQ,
    STATE(14080), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [292493] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15772), 1,
      anon_sym_EQ,
    STATE(14081), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [292534] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14082), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 7,
      anon_sym_end,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [292599] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19528), 1,
      sym__power_operator,
    STATE(14083), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 7,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 15,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [292642] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_EQ,
    ACTIONS(11249), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19500), 1,
      anon_sym_QMARK,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19504), 1,
      sym__pair_operator,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14084), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [292719] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9854), 1,
      anon_sym_EQ,
    STATE(14085), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [292760] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15942), 1,
      anon_sym_EQ,
    STATE(14086), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [292801] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19494), 1,
      sym__power_operator,
    STATE(14087), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 16,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [292844] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19488), 1,
      sym__times_operator,
    ACTIONS(19490), 1,
      sym__rational_operator,
    ACTIONS(19492), 1,
      sym__bitshift_operator,
    ACTIONS(19494), 1,
      sym__power_operator,
    ACTIONS(19486), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14088), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 14,
      anon_sym_COMMA,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [292895] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16130), 1,
      anon_sym_EQ,
    STATE(14089), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [292936] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14090), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 4,
      anon_sym_EQ,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [292987] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18359), 1,
      anon_sym_COLON,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(18367), 1,
      anon_sym_where,
    ACTIONS(18369), 1,
      sym__pair_operator,
    ACTIONS(18371), 1,
      sym__arrow_operator,
    ACTIONS(18373), 1,
      sym__lazy_or_operator,
    ACTIONS(18375), 1,
      sym__lazy_and_operator,
    ACTIONS(18377), 1,
      sym__comparison_operator,
    ACTIONS(18379), 1,
      sym__pipe_right_operator,
    ACTIONS(18381), 1,
      sym__pipe_left_operator,
    ACTIONS(18383), 1,
      sym__ellipsis_operator,
    ACTIONS(18387), 1,
      sym__times_operator,
    ACTIONS(18389), 1,
      sym__rational_operator,
    ACTIONS(18391), 1,
      sym__bitshift_operator,
    ACTIONS(18393), 1,
      sym__power_operator,
    ACTIONS(19142), 1,
      anon_sym_QMARK,
    ACTIONS(11289), 2,
      anon_sym_COMMA,
      anon_sym_end,
    ACTIONS(18385), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14091), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18361), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [293062] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      anon_sym_EQ,
    ACTIONS(11110), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19534), 1,
      anon_sym_QMARK,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19538), 1,
      sym__pair_operator,
    ACTIONS(19540), 1,
      sym__arrow_operator,
    ACTIONS(19542), 1,
      sym__lazy_or_operator,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14092), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [293139] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11247), 1,
      anon_sym_COLON2,
    ACTIONS(11249), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18466), 1,
      anon_sym_COLON,
    ACTIONS(18472), 1,
      anon_sym_where,
    ACTIONS(18474), 1,
      sym__pair_operator,
    ACTIONS(18476), 1,
      sym__arrow_operator,
    ACTIONS(18478), 1,
      sym__lazy_or_operator,
    ACTIONS(18480), 1,
      sym__lazy_and_operator,
    ACTIONS(18482), 1,
      sym__comparison_operator,
    ACTIONS(18484), 1,
      sym__pipe_right_operator,
    ACTIONS(18486), 1,
      sym__pipe_left_operator,
    ACTIONS(18488), 1,
      sym__ellipsis_operator,
    ACTIONS(18492), 1,
      sym__times_operator,
    ACTIONS(18494), 1,
      sym__rational_operator,
    ACTIONS(18496), 1,
      sym__bitshift_operator,
    ACTIONS(18498), 1,
      sym__power_operator,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(18490), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14093), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18468), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [293216] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10361), 1,
      anon_sym_EQ,
    STATE(14094), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [293257] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11864), 1,
      anon_sym_EQ,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14095), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 7,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [293322] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15830), 1,
      anon_sym_EQ,
    STATE(14096), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [293363] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16128), 1,
      anon_sym_EQ,
    STATE(14097), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [293404] = 24,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11112), 1,
      anon_sym_COLON2,
    ACTIONS(11114), 1,
      anon_sym_COMMA,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18742), 1,
      anon_sym_QMARK,
    ACTIONS(19564), 1,
      sym__power_operator,
    ACTIONS(19568), 1,
      sym__times_operator,
    ACTIONS(19570), 1,
      sym__rational_operator,
    ACTIONS(19572), 1,
      sym__bitshift_operator,
    ACTIONS(19574), 1,
      anon_sym_COLON,
    ACTIONS(19578), 1,
      sym__comparison_operator,
    ACTIONS(19580), 1,
      sym__pipe_right_operator,
    ACTIONS(19582), 1,
      sym__pipe_left_operator,
    ACTIONS(19584), 1,
      sym__ellipsis_operator,
    ACTIONS(19586), 1,
      anon_sym_where,
    ACTIONS(19588), 1,
      sym__pair_operator,
    ACTIONS(19590), 1,
      sym__arrow_operator,
    ACTIONS(19592), 1,
      sym__lazy_or_operator,
    ACTIONS(19594), 1,
      sym__lazy_and_operator,
    ACTIONS(19566), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14098), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19576), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [293481] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15818), 1,
      anon_sym_EQ,
    STATE(14099), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 17,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [293522] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19600), 1,
      anon_sym_where,
    ACTIONS(19602), 1,
      sym__arrow_operator,
    ACTIONS(19604), 1,
      sym__lazy_or_operator,
    ACTIONS(19606), 1,
      sym__lazy_and_operator,
    ACTIONS(19608), 1,
      sym__comparison_operator,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14100), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(19598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [293592] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15648), 1,
      anon_sym_EQ,
    STATE(14101), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [293632] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5048), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_DOLLAR,
    ACTIONS(8302), 1,
      sym_character_literal,
    ACTIONS(16052), 1,
      sym__word_identifier,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19628), 1,
      sym__immediate_paren,
    STATE(50), 1,
      sym_macro_identifier,
    STATE(4202), 1,
      sym_identifier,
    STATE(14404), 1,
      sym__delimiter_str_1,
    STATE(14415), 1,
      sym__delimiter_str_3,
    STATE(14435), 1,
      sym__delimiter_cmd_1,
    STATE(14436), 1,
      sym__delimiter_cmd_3,
    STATE(14102), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4623), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4757), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [293702] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14664), 1,
      anon_sym_DOLLAR,
    ACTIONS(15888), 1,
      sym__word_identifier,
    ACTIONS(19630), 1,
      anon_sym_COLON2,
    ACTIONS(19632), 1,
      sym__immediate_paren,
    STATE(10734), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17394), 1,
      sym_macro_identifier,
    STATE(14103), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10432), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [293772] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(873), 1,
      anon_sym_DOLLAR,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(891), 1,
      sym_character_literal,
    ACTIONS(15806), 1,
      sym__word_identifier,
    ACTIONS(19634), 1,
      anon_sym_COLON2,
    ACTIONS(19636), 1,
      sym__immediate_paren,
    STATE(116), 1,
      sym_macro_identifier,
    STATE(4207), 1,
      sym_identifier,
    STATE(14318), 1,
      sym__delimiter_cmd_1,
    STATE(14504), 1,
      sym__delimiter_cmd_3,
    STATE(14701), 1,
      sym__delimiter_str_1,
    STATE(14899), 1,
      sym__delimiter_str_3,
    STATE(14104), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4652), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4665), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [293842] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14220), 1,
      anon_sym_DOLLAR,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(19638), 1,
      anon_sym_COLON2,
    ACTIONS(19640), 1,
      sym__immediate_paren,
    STATE(11194), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17607), 1,
      sym_macro_identifier,
    STATE(14105), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10582), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [293912] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4202), 1,
      anon_sym_DOLLAR,
    ACTIONS(4206), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19642), 1,
      anon_sym_COLON2,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    STATE(25), 1,
      sym_macro_identifier,
    STATE(10062), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14106), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [293982] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14107), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [294046] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14108), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [294102] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14109), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [294162] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5044), 1,
      anon_sym_DOLLAR,
    ACTIONS(5048), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19670), 1,
      anon_sym_COLON2,
    STATE(17), 1,
      sym_macro_identifier,
    STATE(10204), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14110), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294232] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14111), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [294282] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    STATE(14112), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [294330] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14210), 1,
      anon_sym_DOLLAR,
    ACTIONS(15894), 1,
      sym__word_identifier,
    ACTIONS(19672), 1,
      anon_sym_COLON2,
    ACTIONS(19674), 1,
      sym__immediate_paren,
    STATE(11407), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17430), 1,
      sym_macro_identifier,
    STATE(14113), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9972), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294400] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3978), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19676), 1,
      anon_sym_COLON2,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    STATE(62), 1,
      sym_macro_identifier,
    STATE(10551), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14114), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294470] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(69), 1,
      anon_sym_AT,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4944), 1,
      anon_sym_DOLLAR,
    ACTIONS(4952), 1,
      sym_character_literal,
    ACTIONS(16198), 1,
      sym__word_identifier,
    ACTIONS(19680), 1,
      anon_sym_COLON2,
    ACTIONS(19682), 1,
      sym__immediate_paren,
    STATE(24), 1,
      sym_macro_identifier,
    STATE(4149), 1,
      sym_identifier,
    STATE(14410), 1,
      sym__delimiter_str_1,
    STATE(14411), 1,
      sym__delimiter_str_3,
    STATE(14412), 1,
      sym__delimiter_cmd_1,
    STATE(14413), 1,
      sym__delimiter_cmd_3,
    STATE(14115), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4565), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4855), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294540] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5438), 1,
      anon_sym_AT,
    ACTIONS(6892), 1,
      anon_sym_DOLLAR,
    ACTIONS(6900), 1,
      sym_character_literal,
    ACTIONS(16026), 1,
      sym__word_identifier,
    ACTIONS(19684), 1,
      anon_sym_COLON2,
    ACTIONS(19686), 1,
      sym__immediate_paren,
    STATE(53), 1,
      sym_macro_identifier,
    STATE(4255), 1,
      sym_identifier,
    STATE(14985), 1,
      sym__delimiter_str_1,
    STATE(14986), 1,
      sym__delimiter_str_3,
    STATE(14993), 1,
      sym__delimiter_cmd_1,
    STATE(15001), 1,
      sym__delimiter_cmd_3,
    STATE(14116), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5011), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4966), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294610] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    STATE(14117), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [294654] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5044), 1,
      anon_sym_DOLLAR,
    ACTIONS(5048), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19670), 1,
      anon_sym_COLON2,
    STATE(54), 1,
      sym_macro_identifier,
    STATE(10204), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14118), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294724] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4448), 1,
      anon_sym_DOLLAR,
    ACTIONS(4452), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19688), 1,
      anon_sym_COLON2,
    STATE(29), 1,
      sym_macro_identifier,
    STATE(10236), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14119), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294794] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14236), 1,
      anon_sym_DOLLAR,
    ACTIONS(15888), 1,
      sym__word_identifier,
    ACTIONS(19632), 1,
      sym__immediate_paren,
    ACTIONS(19690), 1,
      anon_sym_COLON2,
    STATE(10933), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17394), 1,
      sym_macro_identifier,
    STATE(14120), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10432), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294864] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(63), 1,
      anon_sym_DOLLAR,
    ACTIONS(69), 1,
      anon_sym_AT,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19692), 1,
      anon_sym_COLON2,
    STATE(74), 1,
      sym_macro_identifier,
    STATE(10343), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14121), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [294934] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    STATE(14122), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [294980] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    STATE(14123), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 14,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__type_order_operator,
  [295024] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13864), 1,
      anon_sym_DOLLAR,
    ACTIONS(13870), 1,
      sym_character_literal,
    ACTIONS(15886), 1,
      sym__word_identifier,
    ACTIONS(19694), 1,
      anon_sym_COLON2,
    ACTIONS(19696), 1,
      sym__immediate_paren,
    STATE(5108), 1,
      sym_identifier,
    STATE(14607), 1,
      sym__delimiter_str_1,
    STATE(14609), 1,
      sym__delimiter_str_3,
    STATE(14610), 1,
      sym__delimiter_cmd_1,
    STATE(14611), 1,
      sym__delimiter_cmd_3,
    STATE(17352), 1,
      sym_macro_identifier,
    STATE(14124), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6276), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5958), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295094] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19698), 1,
      anon_sym_RPAREN,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14125), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [295168] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(11031), 1,
      anon_sym_DOLLAR,
    ACTIONS(15786), 1,
      sym__word_identifier,
    ACTIONS(19710), 1,
      anon_sym_COLON2,
    ACTIONS(19712), 1,
      sym__immediate_paren,
    STATE(10149), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17390), 1,
      sym_macro_identifier,
    STATE(14126), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10130), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295238] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14660), 1,
      anon_sym_DOLLAR,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(19640), 1,
      sym__immediate_paren,
    ACTIONS(19714), 1,
      anon_sym_COLON2,
    STATE(11072), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17607), 1,
      sym_macro_identifier,
    STATE(14127), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10582), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295308] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19276), 1,
      anon_sym_RPAREN,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14128), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [295382] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13892), 1,
      anon_sym_DOLLAR,
    ACTIONS(13898), 1,
      sym_character_literal,
    ACTIONS(16002), 1,
      sym__word_identifier,
    ACTIONS(19716), 1,
      anon_sym_COLON2,
    ACTIONS(19718), 1,
      sym__immediate_paren,
    STATE(5019), 1,
      sym_identifier,
    STATE(14940), 1,
      sym__delimiter_str_1,
    STATE(14941), 1,
      sym__delimiter_str_3,
    STATE(14942), 1,
      sym__delimiter_cmd_1,
    STATE(14943), 1,
      sym__delimiter_cmd_3,
    STATE(17630), 1,
      sym_macro_identifier,
    STATE(14129), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5669), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5803), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295452] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(163), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14130), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295522] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19668), 1,
      sym__power_operator,
    STATE(14131), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [295564] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5114), 1,
      anon_sym_AT,
    ACTIONS(7962), 1,
      anon_sym_DOLLAR,
    ACTIONS(7970), 1,
      sym_character_literal,
    ACTIONS(15954), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      anon_sym_COLON2,
    ACTIONS(19724), 1,
      sym__immediate_paren,
    STATE(32), 1,
      sym_macro_identifier,
    STATE(4166), 1,
      sym_identifier,
    STATE(15043), 1,
      sym__delimiter_str_1,
    STATE(15045), 1,
      sym__delimiter_str_3,
    STATE(15046), 1,
      sym__delimiter_cmd_1,
    STATE(15047), 1,
      sym__delimiter_cmd_3,
    STATE(14132), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4541), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4580), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295634] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14133), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 7,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [295696] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3687), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19726), 1,
      anon_sym_COLON2,
    STATE(160), 1,
      sym_macro_identifier,
    STATE(10304), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14134), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295766] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    STATE(14135), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [295812] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19728), 1,
      anon_sym_RPAREN,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14136), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [295886] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(873), 1,
      anon_sym_DOLLAR,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(891), 1,
      sym_character_literal,
    ACTIONS(15806), 1,
      sym__word_identifier,
    ACTIONS(19634), 1,
      anon_sym_COLON2,
    ACTIONS(19636), 1,
      sym__immediate_paren,
    STATE(65), 1,
      sym_macro_identifier,
    STATE(4207), 1,
      sym_identifier,
    STATE(14318), 1,
      sym__delimiter_cmd_1,
    STATE(14504), 1,
      sym__delimiter_cmd_3,
    STATE(14701), 1,
      sym__delimiter_str_1,
    STATE(14899), 1,
      sym__delimiter_str_3,
    STATE(14137), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4652), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4665), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [295956] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13168), 1,
      sym_character_literal,
    ACTIONS(14960), 1,
      anon_sym_DOLLAR,
    ACTIONS(16050), 1,
      sym__word_identifier,
    ACTIONS(19730), 1,
      anon_sym_COLON2,
    ACTIONS(19732), 1,
      sym__immediate_paren,
    STATE(5112), 1,
      sym_identifier,
    STATE(14982), 1,
      sym__delimiter_str_1,
    STATE(14987), 1,
      sym__delimiter_str_3,
    STATE(14990), 1,
      sym__delimiter_cmd_1,
    STATE(15013), 1,
      sym__delimiter_cmd_3,
    STATE(17077), 1,
      sym_macro_identifier,
    STATE(14138), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6143), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6298), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296026] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5434), 1,
      anon_sym_DOLLAR,
    ACTIONS(5438), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19734), 1,
      anon_sym_COLON2,
    STATE(41), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14139), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296096] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13318), 1,
      anon_sym_DOLLAR,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(19640), 1,
      sym__immediate_paren,
    ACTIONS(19736), 1,
      anon_sym_COLON2,
    STATE(10745), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17607), 1,
      sym_macro_identifier,
    STATE(14140), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10582), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296166] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13598), 1,
      anon_sym_DOLLAR,
    ACTIONS(13604), 1,
      sym_character_literal,
    ACTIONS(15992), 1,
      sym__word_identifier,
    ACTIONS(19738), 1,
      anon_sym_COLON2,
    ACTIONS(19740), 1,
      sym__immediate_paren,
    STATE(11547), 1,
      sym_identifier,
    STATE(14493), 1,
      sym__delimiter_str_1,
    STATE(14494), 1,
      sym__delimiter_str_3,
    STATE(14497), 1,
      sym__delimiter_cmd_1,
    STATE(14499), 1,
      sym__delimiter_cmd_3,
    STATE(17621), 1,
      sym_macro_identifier,
    STATE(14141), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11807), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(11786), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296236] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(62), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14142), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296306] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19624), 1,
      sym__power_operator,
    STATE(14143), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 15,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [296348] = 18,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19600), 1,
      anon_sym_where,
    ACTIONS(19608), 1,
      sym__comparison_operator,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14144), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 6,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [296412] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14145), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [296472] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(63), 1,
      anon_sym_DOLLAR,
    ACTIONS(69), 1,
      anon_sym_AT,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19692), 1,
      anon_sym_COLON2,
    STATE(39), 1,
      sym_macro_identifier,
    STATE(10343), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14146), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296542] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19624), 1,
      sym__power_operator,
    STATE(14147), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 15,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [296584] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5438), 1,
      anon_sym_AT,
    ACTIONS(6892), 1,
      anon_sym_DOLLAR,
    ACTIONS(6900), 1,
      sym_character_literal,
    ACTIONS(16026), 1,
      sym__word_identifier,
    ACTIONS(19684), 1,
      anon_sym_COLON2,
    ACTIONS(19686), 1,
      sym__immediate_paren,
    STATE(69), 1,
      sym_macro_identifier,
    STATE(4255), 1,
      sym_identifier,
    STATE(14985), 1,
      sym__delimiter_str_1,
    STATE(14986), 1,
      sym__delimiter_str_3,
    STATE(14993), 1,
      sym__delimiter_cmd_1,
    STATE(15001), 1,
      sym__delimiter_cmd_3,
    STATE(14148), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5011), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4966), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296654] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11289), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19538), 1,
      sym__pair_operator,
    ACTIONS(19540), 1,
      sym__arrow_operator,
    ACTIONS(19542), 1,
      sym__lazy_or_operator,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19742), 1,
      anon_sym_QMARK,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14149), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [296728] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14668), 1,
      anon_sym_DOLLAR,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(19640), 1,
      sym__immediate_paren,
    ACTIONS(19744), 1,
      anon_sym_COLON2,
    STATE(11091), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17607), 1,
      sym_macro_identifier,
    STATE(14150), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10582), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296798] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4496), 1,
      anon_sym_DOLLAR,
    ACTIONS(4500), 1,
      anon_sym_AT,
    ACTIONS(4506), 1,
      sym_character_literal,
    ACTIONS(15834), 1,
      sym__word_identifier,
    ACTIONS(19746), 1,
      anon_sym_COLON2,
    ACTIONS(19748), 1,
      sym__immediate_paren,
    STATE(18), 1,
      sym_macro_identifier,
    STATE(10060), 1,
      sym_identifier,
    STATE(14632), 1,
      sym__delimiter_str_1,
    STATE(14633), 1,
      sym__delimiter_str_3,
    STATE(14641), 1,
      sym__delimiter_cmd_1,
    STATE(14642), 1,
      sym__delimiter_cmd_3,
    STATE(14151), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10364), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296868] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(101), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14152), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [296938] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13202), 1,
      sym_character_literal,
    ACTIONS(14378), 1,
      anon_sym_DOLLAR,
    ACTIONS(15926), 1,
      sym__word_identifier,
    ACTIONS(19750), 1,
      anon_sym_COLON2,
    ACTIONS(19752), 1,
      sym__immediate_paren,
    STATE(5275), 1,
      sym_identifier,
    STATE(15069), 1,
      sym__delimiter_str_1,
    STATE(15071), 1,
      sym__delimiter_str_3,
    STATE(15072), 1,
      sym__delimiter_cmd_1,
    STATE(15073), 1,
      sym__delimiter_cmd_3,
    STATE(17462), 1,
      sym_macro_identifier,
    STATE(14153), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6331), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6037), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297008] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1295), 1,
      anon_sym_DOLLAR,
    ACTIONS(1301), 1,
      anon_sym_AT,
    ACTIONS(1313), 1,
      sym_character_literal,
    ACTIONS(16066), 1,
      sym__word_identifier,
    ACTIONS(19754), 1,
      anon_sym_COLON2,
    ACTIONS(19756), 1,
      sym__immediate_paren,
    STATE(136), 1,
      sym_macro_identifier,
    STATE(4968), 1,
      sym_identifier,
    STATE(14900), 1,
      sym__delimiter_str_1,
    STATE(14902), 1,
      sym__delimiter_str_3,
    STATE(14903), 1,
      sym__delimiter_cmd_1,
    STATE(14904), 1,
      sym__delimiter_cmd_3,
    STATE(14154), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5764), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5408), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297078] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14128), 1,
      sym_character_literal,
    ACTIONS(14528), 1,
      anon_sym_DOLLAR,
    ACTIONS(15930), 1,
      sym__word_identifier,
    ACTIONS(19758), 1,
      anon_sym_COLON2,
    ACTIONS(19760), 1,
      sym__immediate_paren,
    STATE(4845), 1,
      sym_identifier,
    STATE(14959), 1,
      sym__delimiter_str_1,
    STATE(14976), 1,
      sym__delimiter_str_3,
    STATE(14979), 1,
      sym__delimiter_cmd_1,
    STATE(15037), 1,
      sym__delimiter_cmd_3,
    STATE(17536), 1,
      sym_macro_identifier,
    STATE(14155), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5335), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5349), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297148] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14676), 1,
      anon_sym_DOLLAR,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(19640), 1,
      sym__immediate_paren,
    ACTIONS(19762), 1,
      anon_sym_COLON2,
    STATE(11099), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17607), 1,
      sym_macro_identifier,
    STATE(14156), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10582), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297218] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1301), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3978), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19676), 1,
      anon_sym_COLON2,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    STATE(153), 1,
      sym_macro_identifier,
    STATE(10551), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14157), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297288] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5048), 1,
      anon_sym_AT,
    ACTIONS(8294), 1,
      anon_sym_DOLLAR,
    ACTIONS(8302), 1,
      sym_character_literal,
    ACTIONS(16052), 1,
      sym__word_identifier,
    ACTIONS(19626), 1,
      anon_sym_COLON2,
    ACTIONS(19628), 1,
      sym__immediate_paren,
    STATE(16), 1,
      sym_macro_identifier,
    STATE(4202), 1,
      sym_identifier,
    STATE(14404), 1,
      sym__delimiter_str_1,
    STATE(14415), 1,
      sym__delimiter_str_3,
    STATE(14435), 1,
      sym__delimiter_cmd_1,
    STATE(14436), 1,
      sym__delimiter_cmd_3,
    STATE(14158), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4623), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4757), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297358] = 14,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14159), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 12,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [297414] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14160), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [297464] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5434), 1,
      anon_sym_DOLLAR,
    ACTIONS(5438), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19734), 1,
      anon_sym_COLON2,
    STATE(61), 1,
      sym_macro_identifier,
    STATE(10311), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14161), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297534] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(249), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14162), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297604] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13222), 1,
      anon_sym_DOLLAR,
    ACTIONS(13228), 1,
      sym_character_literal,
    ACTIONS(16206), 1,
      sym__word_identifier,
    ACTIONS(19764), 1,
      anon_sym_COLON2,
    ACTIONS(19766), 1,
      sym__immediate_paren,
    STATE(6257), 1,
      sym_identifier,
    STATE(14738), 1,
      sym__delimiter_str_1,
    STATE(14739), 1,
      sym__delimiter_str_3,
    STATE(14741), 1,
      sym__delimiter_cmd_1,
    STATE(14743), 1,
      sym__delimiter_cmd_3,
    STATE(17134), 1,
      sym_macro_identifier,
    STATE(14163), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6534), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6569), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297674] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4206), 1,
      anon_sym_AT,
    ACTIONS(6870), 1,
      anon_sym_DOLLAR,
    ACTIONS(6878), 1,
      sym_character_literal,
    ACTIONS(16138), 1,
      sym__word_identifier,
    ACTIONS(19768), 1,
      anon_sym_COLON2,
    ACTIONS(19770), 1,
      sym__immediate_paren,
    STATE(7), 1,
      sym_macro_identifier,
    STATE(4127), 1,
      sym_identifier,
    STATE(14869), 1,
      sym__delimiter_str_1,
    STATE(14870), 1,
      sym__delimiter_str_3,
    STATE(14871), 1,
      sym__delimiter_cmd_1,
    STATE(14872), 1,
      sym__delimiter_cmd_3,
    STATE(14164), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4275), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4291), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297744] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13706), 1,
      anon_sym_DOLLAR,
    ACTIONS(13712), 1,
      sym_character_literal,
    ACTIONS(16094), 1,
      sym__word_identifier,
    ACTIONS(19772), 1,
      anon_sym_COLON2,
    ACTIONS(19774), 1,
      sym__immediate_paren,
    STATE(5244), 1,
      sym_identifier,
    STATE(14407), 1,
      sym__delimiter_str_1,
    STATE(14408), 1,
      sym__delimiter_str_3,
    STATE(14409), 1,
      sym__delimiter_cmd_1,
    STATE(14414), 1,
      sym__delimiter_cmd_3,
    STATE(17114), 1,
      sym_macro_identifier,
    STATE(14165), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6212), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6187), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297814] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3868), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19776), 1,
      anon_sym_COLON2,
    STATE(104), 1,
      sym_macro_identifier,
    STATE(10079), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14166), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [297884] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19778), 1,
      anon_sym_RPAREN,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14167), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [297958] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13614), 1,
      anon_sym_DOLLAR,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(15894), 1,
      sym__word_identifier,
    ACTIONS(19674), 1,
      sym__immediate_paren,
    ACTIONS(19780), 1,
      anon_sym_COLON2,
    STATE(10141), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17430), 1,
      sym_macro_identifier,
    STATE(14168), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9972), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298028] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12535), 1,
      anon_sym_DOLLAR,
    ACTIONS(15786), 1,
      sym__word_identifier,
    ACTIONS(19712), 1,
      sym__immediate_paren,
    ACTIONS(19782), 1,
      anon_sym_COLON2,
    STATE(10754), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17390), 1,
      sym_macro_identifier,
    STATE(14169), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10130), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298098] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11114), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19600), 1,
      anon_sym_where,
    ACTIONS(19602), 1,
      sym__arrow_operator,
    ACTIONS(19604), 1,
      sym__lazy_or_operator,
    ACTIONS(19606), 1,
      sym__lazy_and_operator,
    ACTIONS(19608), 1,
      sym__comparison_operator,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19742), 1,
      anon_sym_QMARK,
    ACTIONS(19784), 1,
      sym__pair_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14170), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [298172] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13736), 1,
      sym_character_literal,
    ACTIONS(14768), 1,
      anon_sym_DOLLAR,
    ACTIONS(16030), 1,
      sym__word_identifier,
    ACTIONS(19786), 1,
      anon_sym_COLON2,
    ACTIONS(19788), 1,
      sym__immediate_paren,
    STATE(4939), 1,
      sym_identifier,
    STATE(14755), 1,
      sym__delimiter_str_1,
    STATE(14765), 1,
      sym__delimiter_str_3,
    STATE(14767), 1,
      sym__delimiter_cmd_1,
    STATE(14806), 1,
      sym__delimiter_cmd_3,
    STATE(17069), 1,
      sym_macro_identifier,
    STATE(14171), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5711), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5907), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298242] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12838), 1,
      anon_sym_DOLLAR,
    ACTIONS(15786), 1,
      sym__word_identifier,
    ACTIONS(19712), 1,
      sym__immediate_paren,
    ACTIONS(19790), 1,
      anon_sym_COLON2,
    STATE(11197), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17390), 1,
      sym_macro_identifier,
    STATE(14172), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10130), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298312] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11289), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19504), 1,
      sym__pair_operator,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14173), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [298386] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4448), 1,
      anon_sym_DOLLAR,
    ACTIONS(4452), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19688), 1,
      anon_sym_COLON2,
    STATE(37), 1,
      sym_macro_identifier,
    STATE(10236), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14174), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298456] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14672), 1,
      anon_sym_DOLLAR,
    ACTIONS(15888), 1,
      sym__word_identifier,
    ACTIONS(19632), 1,
      sym__immediate_paren,
    ACTIONS(19792), 1,
      anon_sym_COLON2,
    STATE(10609), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17394), 1,
      sym_macro_identifier,
    STATE(14175), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10432), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298526] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11249), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19530), 1,
      anon_sym_COLON,
    ACTIONS(19536), 1,
      anon_sym_where,
    ACTIONS(19538), 1,
      sym__pair_operator,
    ACTIONS(19540), 1,
      sym__arrow_operator,
    ACTIONS(19542), 1,
      sym__lazy_or_operator,
    ACTIONS(19544), 1,
      sym__lazy_and_operator,
    ACTIONS(19546), 1,
      sym__comparison_operator,
    ACTIONS(19548), 1,
      sym__pipe_right_operator,
    ACTIONS(19550), 1,
      sym__pipe_left_operator,
    ACTIONS(19552), 1,
      sym__ellipsis_operator,
    ACTIONS(19556), 1,
      sym__times_operator,
    ACTIONS(19558), 1,
      sym__rational_operator,
    ACTIONS(19560), 1,
      sym__bitshift_operator,
    ACTIONS(19562), 1,
      sym__power_operator,
    ACTIONS(19742), 1,
      anon_sym_QMARK,
    ACTIONS(19554), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14176), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19532), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [298600] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14216), 1,
      anon_sym_DOLLAR,
    ACTIONS(15894), 1,
      sym__word_identifier,
    ACTIONS(19674), 1,
      sym__immediate_paren,
    ACTIONS(19794), 1,
      anon_sym_COLON2,
    STATE(10613), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17430), 1,
      sym_macro_identifier,
    STATE(14177), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9972), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298670] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3868), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19776), 1,
      anon_sym_COLON2,
    STATE(113), 1,
      sym_macro_identifier,
    STATE(10079), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14178), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298740] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5110), 1,
      anon_sym_DOLLAR,
    ACTIONS(5114), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19796), 1,
      anon_sym_COLON2,
    STATE(15), 1,
      sym_macro_identifier,
    STATE(10192), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14179), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298810] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(6892), 1,
      anon_sym_DOLLAR,
    ACTIONS(6900), 1,
      sym_character_literal,
    ACTIONS(16026), 1,
      sym__word_identifier,
    ACTIONS(19684), 1,
      anon_sym_COLON2,
    ACTIONS(19686), 1,
      sym__immediate_paren,
    STATE(298), 1,
      sym_macro_identifier,
    STATE(4255), 1,
      sym_identifier,
    STATE(14985), 1,
      sym__delimiter_str_1,
    STATE(14986), 1,
      sym__delimiter_str_3,
    STATE(14993), 1,
      sym__delimiter_cmd_1,
    STATE(15001), 1,
      sym__delimiter_cmd_3,
    STATE(14180), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5011), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4966), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298880] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13484), 1,
      sym_character_literal,
    ACTIONS(14984), 1,
      anon_sym_DOLLAR,
    ACTIONS(16006), 1,
      sym__word_identifier,
    ACTIONS(19798), 1,
      anon_sym_COLON2,
    ACTIONS(19800), 1,
      sym__immediate_paren,
    STATE(10632), 1,
      sym_identifier,
    STATE(14545), 1,
      sym__delimiter_str_1,
    STATE(14546), 1,
      sym__delimiter_str_3,
    STATE(14551), 1,
      sym__delimiter_cmd_1,
    STATE(14552), 1,
      sym__delimiter_cmd_3,
    STATE(17661), 1,
      sym_macro_identifier,
    STATE(14181), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10857), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(11110), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [298950] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(873), 1,
      anon_sym_DOLLAR,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(891), 1,
      sym_character_literal,
    ACTIONS(15806), 1,
      sym__word_identifier,
    ACTIONS(19634), 1,
      anon_sym_COLON2,
    ACTIONS(19636), 1,
      sym__immediate_paren,
    STATE(71), 1,
      sym_macro_identifier,
    STATE(4207), 1,
      sym_identifier,
    STATE(14318), 1,
      sym__delimiter_cmd_1,
    STATE(14504), 1,
      sym__delimiter_cmd_3,
    STATE(14701), 1,
      sym__delimiter_str_1,
    STATE(14899), 1,
      sym__delimiter_str_3,
    STATE(14182), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4652), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4665), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299020] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13504), 1,
      anon_sym_DOLLAR,
    ACTIONS(13510), 1,
      sym_character_literal,
    ACTIONS(15862), 1,
      sym__word_identifier,
    ACTIONS(19802), 1,
      anon_sym_COLON2,
    ACTIONS(19804), 1,
      sym__immediate_paren,
    STATE(5609), 1,
      sym_identifier,
    STATE(14382), 1,
      sym__delimiter_str_1,
    STATE(14383), 1,
      sym__delimiter_str_3,
    STATE(14385), 1,
      sym__delimiter_cmd_1,
    STATE(14386), 1,
      sym__delimiter_cmd_3,
    STATE(17320), 1,
      sym_macro_identifier,
    STATE(14183), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6390), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6409), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299090] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19806), 1,
      anon_sym_RPAREN,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14184), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [299164] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13816), 1,
      sym_character_literal,
    ACTIONS(14844), 1,
      anon_sym_DOLLAR,
    ACTIONS(16056), 1,
      sym__word_identifier,
    ACTIONS(19808), 1,
      anon_sym_COLON2,
    ACTIONS(19810), 1,
      sym__immediate_paren,
    STATE(4951), 1,
      sym_identifier,
    STATE(14855), 1,
      sym__delimiter_str_1,
    STATE(14857), 1,
      sym__delimiter_str_3,
    STATE(14860), 1,
      sym__delimiter_cmd_1,
    STATE(14864), 1,
      sym__delimiter_cmd_3,
    STATE(17084), 1,
      sym_macro_identifier,
    STATE(14185), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5740), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5376), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299234] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14186), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11275), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11277), 13,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [299284] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14187), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [299344] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3687), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19726), 1,
      anon_sym_COLON2,
    STATE(92), 1,
      sym_macro_identifier,
    STATE(10304), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14188), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299414] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5114), 1,
      anon_sym_AT,
    ACTIONS(7962), 1,
      anon_sym_DOLLAR,
    ACTIONS(7970), 1,
      sym_character_literal,
    ACTIONS(15954), 1,
      sym__word_identifier,
    ACTIONS(19722), 1,
      anon_sym_COLON2,
    ACTIONS(19724), 1,
      sym__immediate_paren,
    STATE(48), 1,
      sym_macro_identifier,
    STATE(4166), 1,
      sym_identifier,
    STATE(15043), 1,
      sym__delimiter_str_1,
    STATE(15045), 1,
      sym__delimiter_str_3,
    STATE(15046), 1,
      sym__delimiter_cmd_1,
    STATE(15047), 1,
      sym__delimiter_cmd_3,
    STATE(14189), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4541), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4580), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299484] = 10,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    STATE(14190), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 5,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__unary_plus_operator,
    ACTIONS(11110), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [299532] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11114), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14191), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [299606] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(5110), 1,
      anon_sym_DOLLAR,
    ACTIONS(5114), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    ACTIONS(19796), 1,
      anon_sym_COLON2,
    STATE(46), 1,
      sym_macro_identifier,
    STATE(10192), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14192), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299676] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11110), 1,
      anon_sym_end,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19600), 1,
      anon_sym_where,
    ACTIONS(19602), 1,
      sym__arrow_operator,
    ACTIONS(19604), 1,
      sym__lazy_or_operator,
    ACTIONS(19606), 1,
      sym__lazy_and_operator,
    ACTIONS(19608), 1,
      sym__comparison_operator,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19742), 1,
      anon_sym_QMARK,
    ACTIONS(19784), 1,
      sym__pair_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14193), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [299750] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1301), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3978), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19676), 1,
      anon_sym_COLON2,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    STATE(97), 1,
      sym_macro_identifier,
    STATE(10551), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14194), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299820] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13322), 1,
      sym_character_literal,
    ACTIONS(14804), 1,
      anon_sym_DOLLAR,
    ACTIONS(15770), 1,
      sym__word_identifier,
    ACTIONS(19640), 1,
      sym__immediate_paren,
    ACTIONS(19812), 1,
      anon_sym_COLON2,
    STATE(11327), 1,
      sym_identifier,
    STATE(14612), 1,
      sym__delimiter_str_1,
    STATE(14613), 1,
      sym__delimiter_str_3,
    STATE(14621), 1,
      sym__delimiter_cmd_1,
    STATE(14622), 1,
      sym__delimiter_cmd_3,
    STATE(17607), 1,
      sym_macro_identifier,
    STATE(14195), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10582), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10679), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299890] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4206), 1,
      anon_sym_AT,
    ACTIONS(6870), 1,
      anon_sym_DOLLAR,
    ACTIONS(6878), 1,
      sym_character_literal,
    ACTIONS(16138), 1,
      sym__word_identifier,
    ACTIONS(19768), 1,
      anon_sym_COLON2,
    ACTIONS(19770), 1,
      sym__immediate_paren,
    STATE(30), 1,
      sym_macro_identifier,
    STATE(4127), 1,
      sym_identifier,
    STATE(14869), 1,
      sym__delimiter_str_1,
    STATE(14870), 1,
      sym__delimiter_str_3,
    STATE(14871), 1,
      sym__delimiter_cmd_1,
    STATE(14872), 1,
      sym__delimiter_cmd_3,
    STATE(14196), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4275), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4291), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [299960] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13134), 1,
      sym_character_literal,
    ACTIONS(14654), 1,
      anon_sym_DOLLAR,
    ACTIONS(16122), 1,
      sym__word_identifier,
    ACTIONS(19814), 1,
      anon_sym_COLON2,
    ACTIONS(19816), 1,
      sym__immediate_paren,
    STATE(6359), 1,
      sym_identifier,
    STATE(14487), 1,
      sym__delimiter_str_1,
    STATE(14488), 1,
      sym__delimiter_str_3,
    STATE(14489), 1,
      sym__delimiter_cmd_1,
    STATE(14490), 1,
      sym__delimiter_cmd_3,
    STATE(17120), 1,
      sym_macro_identifier,
    STATE(14197), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7043), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6939), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300030] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(873), 1,
      anon_sym_DOLLAR,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(891), 1,
      sym_character_literal,
    ACTIONS(15806), 1,
      sym__word_identifier,
    ACTIONS(19634), 1,
      anon_sym_COLON2,
    ACTIONS(19636), 1,
      sym__immediate_paren,
    STATE(35), 1,
      sym_macro_identifier,
    STATE(4207), 1,
      sym_identifier,
    STATE(14318), 1,
      sym__delimiter_cmd_1,
    STATE(14504), 1,
      sym__delimiter_cmd_3,
    STATE(14701), 1,
      sym__delimiter_str_1,
    STATE(14899), 1,
      sym__delimiter_str_3,
    STATE(14198), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4652), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4665), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300100] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13548), 1,
      anon_sym_DOLLAR,
    ACTIONS(13554), 1,
      sym_character_literal,
    ACTIONS(15928), 1,
      sym__word_identifier,
    ACTIONS(19818), 1,
      anon_sym_COLON2,
    ACTIONS(19820), 1,
      sym__immediate_paren,
    STATE(5363), 1,
      sym_identifier,
    STATE(14816), 1,
      sym__delimiter_str_1,
    STATE(14819), 1,
      sym__delimiter_str_3,
    STATE(14983), 1,
      sym__delimiter_cmd_1,
    STATE(15076), 1,
      sym__delimiter_cmd_3,
    STATE(17508), 1,
      sym_macro_identifier,
    STATE(14199), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5943), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6075), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300170] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14680), 1,
      anon_sym_DOLLAR,
    ACTIONS(15888), 1,
      sym__word_identifier,
    ACTIONS(19632), 1,
      sym__immediate_paren,
    ACTIONS(19822), 1,
      anon_sym_COLON2,
    STATE(10721), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17394), 1,
      sym_macro_identifier,
    STATE(14200), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10432), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300240] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(170), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14201), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300310] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3687), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19726), 1,
      anon_sym_COLON2,
    STATE(91), 1,
      sym_macro_identifier,
    STATE(10304), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14202), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300380] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13272), 1,
      anon_sym_DOLLAR,
    ACTIONS(13278), 1,
      sym_character_literal,
    ACTIONS(16124), 1,
      sym__word_identifier,
    ACTIONS(19824), 1,
      anon_sym_COLON2,
    ACTIONS(19826), 1,
      sym__immediate_paren,
    STATE(4926), 1,
      sym_identifier,
    STATE(14572), 1,
      sym__delimiter_str_1,
    STATE(14573), 1,
      sym__delimiter_str_3,
    STATE(14574), 1,
      sym__delimiter_cmd_1,
    STATE(14576), 1,
      sym__delimiter_cmd_3,
    STATE(17127), 1,
      sym_macro_identifier,
    STATE(14203), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5839), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5499), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300450] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4500), 1,
      anon_sym_AT,
    ACTIONS(7750), 1,
      anon_sym_DOLLAR,
    ACTIONS(7758), 1,
      sym_character_literal,
    ACTIONS(15948), 1,
      sym__word_identifier,
    ACTIONS(19828), 1,
      anon_sym_COLON2,
    ACTIONS(19830), 1,
      sym__immediate_paren,
    STATE(11), 1,
      sym_macro_identifier,
    STATE(4125), 1,
      sym_identifier,
    STATE(14791), 1,
      sym__delimiter_str_1,
    STATE(14793), 1,
      sym__delimiter_str_3,
    STATE(14798), 1,
      sym__delimiter_cmd_1,
    STATE(14800), 1,
      sym__delimiter_cmd_3,
    STATE(14204), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4386), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4317), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300520] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4500), 1,
      anon_sym_AT,
    ACTIONS(7750), 1,
      anon_sym_DOLLAR,
    ACTIONS(7758), 1,
      sym_character_literal,
    ACTIONS(15948), 1,
      sym__word_identifier,
    ACTIONS(19828), 1,
      anon_sym_COLON2,
    ACTIONS(19830), 1,
      sym__immediate_paren,
    STATE(22), 1,
      sym_macro_identifier,
    STATE(4125), 1,
      sym_identifier,
    STATE(14791), 1,
      sym__delimiter_str_1,
    STATE(14793), 1,
      sym__delimiter_str_3,
    STATE(14798), 1,
      sym__delimiter_cmd_1,
    STATE(14800), 1,
      sym__delimiter_cmd_3,
    STATE(14205), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4386), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4317), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300590] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11249), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19504), 1,
      sym__pair_operator,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14206), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [300664] = 17,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19608), 1,
      sym__comparison_operator,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14207), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11866), 7,
      anon_sym_end,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
  [300726] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(81), 1,
      sym_character_literal,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4202), 1,
      anon_sym_DOLLAR,
    ACTIONS(4206), 1,
      anon_sym_AT,
    ACTIONS(15766), 1,
      sym__word_identifier,
    ACTIONS(19642), 1,
      anon_sym_COLON2,
    ACTIONS(19644), 1,
      sym__immediate_paren,
    STATE(9), 1,
      sym_macro_identifier,
    STATE(10062), 1,
      sym_identifier,
    STATE(14480), 1,
      sym__delimiter_cmd_1,
    STATE(14840), 1,
      sym__delimiter_str_1,
    STATE(14862), 1,
      sym__delimiter_str_3,
    STATE(14939), 1,
      sym__delimiter_cmd_3,
    STATE(14208), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9967), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9921), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [300796] = 16,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11108), 1,
      sym__comparison_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14209), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 10,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__type_order_operator,
  [300856] = 23,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11110), 1,
      anon_sym_RPAREN,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14210), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [300930] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3868), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19776), 1,
      anon_sym_COLON2,
    STATE(89), 1,
      sym_macro_identifier,
    STATE(10079), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14211), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301000] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13386), 1,
      sym_character_literal,
    ACTIONS(14458), 1,
      anon_sym_DOLLAR,
    ACTIONS(16004), 1,
      sym__word_identifier,
    ACTIONS(19832), 1,
      anon_sym_COLON2,
    ACTIONS(19834), 1,
      sym__immediate_paren,
    STATE(4904), 1,
      sym_identifier,
    STATE(15097), 1,
      sym__delimiter_str_1,
    STATE(15098), 1,
      sym__delimiter_str_3,
    STATE(15099), 1,
      sym__delimiter_cmd_1,
    STATE(15101), 1,
      sym__delimiter_cmd_3,
    STATE(17641), 1,
      sym_macro_identifier,
    STATE(14212), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5694), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5867), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301070] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14213), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11110), 3,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [301140] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19596), 1,
      anon_sym_COLON,
    ACTIONS(19600), 1,
      anon_sym_where,
    ACTIONS(19606), 1,
      sym__lazy_and_operator,
    ACTIONS(19608), 1,
      sym__comparison_operator,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14214), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_end,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [301206] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13300), 1,
      sym_character_literal,
    ACTIONS(14574), 1,
      anon_sym_DOLLAR,
    ACTIONS(15944), 1,
      sym__word_identifier,
    ACTIONS(19836), 1,
      anon_sym_COLON2,
    ACTIONS(19838), 1,
      sym__immediate_paren,
    STATE(10710), 1,
      sym_identifier,
    STATE(14484), 1,
      sym__delimiter_str_1,
    STATE(14542), 1,
      sym__delimiter_str_3,
    STATE(14549), 1,
      sym__delimiter_cmd_1,
    STATE(14550), 1,
      sym__delimiter_cmd_3,
    STATE(17560), 1,
      sym_macro_identifier,
    STATE(14215), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11350), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(11191), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301276] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(232), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14216), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301346] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(42), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14217), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301416] = 19,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14218), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
    ACTIONS(11110), 5,
      anon_sym_RPAREN,
      anon_sym_QMARK,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
  [301482] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(1295), 1,
      anon_sym_DOLLAR,
    ACTIONS(1301), 1,
      anon_sym_AT,
    ACTIONS(1313), 1,
      sym_character_literal,
    ACTIONS(16066), 1,
      sym__word_identifier,
    ACTIONS(19754), 1,
      anon_sym_COLON2,
    ACTIONS(19756), 1,
      sym__immediate_paren,
    STATE(95), 1,
      sym_macro_identifier,
    STATE(4968), 1,
      sym_identifier,
    STATE(14900), 1,
      sym__delimiter_str_1,
    STATE(14902), 1,
      sym__delimiter_str_3,
    STATE(14903), 1,
      sym__delimiter_cmd_1,
    STATE(14904), 1,
      sym__delimiter_cmd_3,
    STATE(14219), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5764), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5408), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301552] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13578), 1,
      sym_character_literal,
    ACTIONS(15028), 1,
      anon_sym_DOLLAR,
    ACTIONS(15832), 1,
      sym__word_identifier,
    ACTIONS(19840), 1,
      anon_sym_COLON2,
    ACTIONS(19842), 1,
      sym__immediate_paren,
    STATE(4883), 1,
      sym_identifier,
    STATE(14988), 1,
      sym__delimiter_str_1,
    STATE(14989), 1,
      sym__delimiter_str_3,
    STATE(14999), 1,
      sym__delimiter_cmd_1,
    STATE(15012), 1,
      sym__delimiter_cmd_3,
    STATE(17277), 1,
      sym_macro_identifier,
    STATE(14220), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5565), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5575), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301622] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4452), 1,
      anon_sym_AT,
    ACTIONS(7372), 1,
      anon_sym_DOLLAR,
    ACTIONS(7380), 1,
      sym_character_literal,
    ACTIONS(15840), 1,
      sym__word_identifier,
    ACTIONS(19844), 1,
      anon_sym_COLON2,
    ACTIONS(19846), 1,
      sym__immediate_paren,
    STATE(28), 1,
      sym_macro_identifier,
    STATE(4224), 1,
      sym_identifier,
    STATE(14818), 1,
      sym__delimiter_str_1,
    STATE(14828), 1,
      sym__delimiter_str_3,
    STATE(14844), 1,
      sym__delimiter_cmd_1,
    STATE(14846), 1,
      sym__delimiter_cmd_3,
    STATE(14221), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4738), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4741), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301692] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14684), 1,
      anon_sym_DOLLAR,
    ACTIONS(15888), 1,
      sym__word_identifier,
    ACTIONS(19632), 1,
      sym__immediate_paren,
    ACTIONS(19848), 1,
      anon_sym_COLON2,
    STATE(10744), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17394), 1,
      sym_macro_identifier,
    STATE(14222), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10432), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301762] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(14026), 1,
      sym_character_literal,
    ACTIONS(14230), 1,
      anon_sym_DOLLAR,
    ACTIONS(15888), 1,
      sym__word_identifier,
    ACTIONS(19632), 1,
      sym__immediate_paren,
    ACTIONS(19850), 1,
      anon_sym_COLON2,
    STATE(11052), 1,
      sym_identifier,
    STATE(14672), 1,
      sym__delimiter_str_1,
    STATE(14673), 1,
      sym__delimiter_str_3,
    STATE(14675), 1,
      sym__delimiter_cmd_1,
    STATE(14676), 1,
      sym__delimiter_cmd_3,
    STATE(17394), 1,
      sym_macro_identifier,
    STATE(14223), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10432), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10411), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301832] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13620), 1,
      sym_character_literal,
    ACTIONS(14102), 1,
      anon_sym_DOLLAR,
    ACTIONS(15894), 1,
      sym__word_identifier,
    ACTIONS(19674), 1,
      sym__immediate_paren,
    ACTIONS(19852), 1,
      anon_sym_COLON2,
    STATE(11054), 1,
      sym_identifier,
    STATE(14908), 1,
      sym__delimiter_str_1,
    STATE(14909), 1,
      sym__delimiter_str_3,
    STATE(14910), 1,
      sym__delimiter_cmd_1,
    STATE(14911), 1,
      sym__delimiter_cmd_3,
    STATE(17430), 1,
      sym_macro_identifier,
    STATE(14224), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9972), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10023), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301902] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3687), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19726), 1,
      anon_sym_COLON2,
    STATE(111), 1,
      sym_macro_identifier,
    STATE(10304), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14225), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [301972] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4496), 1,
      anon_sym_DOLLAR,
    ACTIONS(4500), 1,
      anon_sym_AT,
    ACTIONS(4506), 1,
      sym_character_literal,
    ACTIONS(15834), 1,
      sym__word_identifier,
    ACTIONS(19746), 1,
      anon_sym_COLON2,
    ACTIONS(19748), 1,
      sym__immediate_paren,
    STATE(5), 1,
      sym_macro_identifier,
    STATE(10060), 1,
      sym_identifier,
    STATE(14632), 1,
      sym__delimiter_str_1,
    STATE(14633), 1,
      sym__delimiter_str_3,
    STATE(14641), 1,
      sym__delimiter_cmd_1,
    STATE(14642), 1,
      sym__delimiter_cmd_3,
    STATE(14226), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10291), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10364), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302042] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3595), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19720), 1,
      anon_sym_COLON2,
    STATE(79), 1,
      sym_macro_identifier,
    STATE(9837), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14227), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302112] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19668), 1,
      sym__power_operator,
    STATE(14228), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11265), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(11267), 15,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__type_order_operator,
  [302154] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18363), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14229), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11108), 3,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
    ACTIONS(11110), 13,
      anon_sym_end,
      anon_sym_in,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__type_order_operator,
  [302204] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4452), 1,
      anon_sym_AT,
    ACTIONS(7372), 1,
      anon_sym_DOLLAR,
    ACTIONS(7380), 1,
      sym_character_literal,
    ACTIONS(15840), 1,
      sym__word_identifier,
    ACTIONS(19844), 1,
      anon_sym_COLON2,
    ACTIONS(19846), 1,
      sym__immediate_paren,
    STATE(44), 1,
      sym_macro_identifier,
    STATE(4224), 1,
      sym_identifier,
    STATE(14818), 1,
      sym__delimiter_str_1,
    STATE(14828), 1,
      sym__delimiter_str_3,
    STATE(14844), 1,
      sym__delimiter_cmd_1,
    STATE(14846), 1,
      sym__delimiter_cmd_3,
    STATE(14230), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4738), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4741), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302274] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13252), 1,
      sym_character_literal,
    ACTIONS(14972), 1,
      anon_sym_DOLLAR,
    ACTIONS(15990), 1,
      sym__word_identifier,
    ACTIONS(19854), 1,
      anon_sym_COLON2,
    ACTIONS(19856), 1,
      sym__immediate_paren,
    STATE(5213), 1,
      sym_identifier,
    STATE(14392), 1,
      sym__delimiter_str_1,
    STATE(14393), 1,
      sym__delimiter_str_3,
    STATE(14394), 1,
      sym__delimiter_cmd_1,
    STATE(14395), 1,
      sym__delimiter_cmd_3,
    STATE(17601), 1,
      sym_macro_identifier,
    STATE(14231), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6091), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(6156), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302344] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(69), 1,
      anon_sym_AT,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(4944), 1,
      anon_sym_DOLLAR,
    ACTIONS(4952), 1,
      sym_character_literal,
    ACTIONS(16198), 1,
      sym__word_identifier,
    ACTIONS(19680), 1,
      anon_sym_COLON2,
    ACTIONS(19682), 1,
      sym__immediate_paren,
    STATE(56), 1,
      sym_macro_identifier,
    STATE(4149), 1,
      sym_identifier,
    STATE(14410), 1,
      sym__delimiter_str_1,
    STATE(14411), 1,
      sym__delimiter_str_3,
    STATE(14412), 1,
      sym__delimiter_cmd_1,
    STATE(14413), 1,
      sym__delimiter_cmd_3,
    STATE(14232), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4565), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(4855), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302414] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13962), 1,
      sym_character_literal,
    ACTIONS(14728), 1,
      anon_sym_DOLLAR,
    ACTIONS(16074), 1,
      sym__word_identifier,
    ACTIONS(19858), 1,
      anon_sym_COLON2,
    ACTIONS(19860), 1,
      sym__immediate_paren,
    STATE(4870), 1,
      sym_identifier,
    STATE(14374), 1,
      sym__delimiter_str_1,
    STATE(14375), 1,
      sym__delimiter_str_3,
    STATE(14376), 1,
      sym__delimiter_cmd_1,
    STATE(14377), 1,
      sym__delimiter_cmd_3,
    STATE(17102), 1,
      sym_macro_identifier,
    STATE(14233), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5782), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5445), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302484] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(879), 1,
      anon_sym_AT,
    ACTIONS(1819), 1,
      sym_character_literal,
    ACTIONS(3868), 1,
      anon_sym_DOLLAR,
    ACTIONS(15758), 1,
      sym__word_identifier,
    ACTIONS(19678), 1,
      sym__immediate_paren,
    ACTIONS(19776), 1,
      anon_sym_COLON2,
    STATE(82), 1,
      sym_macro_identifier,
    STATE(10079), 1,
      sym_identifier,
    STATE(15068), 1,
      sym__delimiter_str_1,
    STATE(15103), 1,
      sym__delimiter_str_3,
    STATE(15105), 1,
      sym__delimiter_cmd_1,
    STATE(15106), 1,
      sym__delimiter_cmd_3,
    STATE(14234), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9772), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(9808), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302554] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(13674), 1,
      sym_character_literal,
    ACTIONS(13692), 1,
      anon_sym_DOLLAR,
    ACTIONS(16072), 1,
      sym__word_identifier,
    ACTIONS(19862), 1,
      anon_sym_COLON2,
    ACTIONS(19864), 1,
      sym__immediate_paren,
    STATE(4677), 1,
      sym_identifier,
    STATE(14319), 1,
      sym__delimiter_str_1,
    STATE(14320), 1,
      sym__delimiter_str_3,
    STATE(14321), 1,
      sym__delimiter_cmd_1,
    STATE(14322), 1,
      sym__delimiter_cmd_3,
    STATE(17091), 1,
      sym_macro_identifier,
    STATE(14235), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5242), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(5163), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302624] = 21,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(83), 1,
      anon_sym_DQUOTE,
    ACTIONS(85), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(87), 1,
      anon_sym_BQUOTE,
    ACTIONS(89), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    ACTIONS(9892), 1,
      anon_sym_AT,
    ACTIONS(9896), 1,
      sym_character_literal,
    ACTIONS(12948), 1,
      anon_sym_DOLLAR,
    ACTIONS(15786), 1,
      sym__word_identifier,
    ACTIONS(19712), 1,
      sym__immediate_paren,
    ACTIONS(19866), 1,
      anon_sym_COLON2,
    STATE(11504), 1,
      sym_identifier,
    STATE(15005), 1,
      sym__delimiter_str_1,
    STATE(15006), 1,
      sym__delimiter_str_3,
    STATE(15007), 1,
      sym__delimiter_cmd_1,
    STATE(15008), 1,
      sym__delimiter_cmd_3,
    STATE(17390), 1,
      sym_macro_identifier,
    STATE(14236), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10130), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym__string,
    STATE(10125), 4,
      sym_string_literal,
      sym_command_literal,
      sym_prefixed_string_literal,
      sym_prefixed_command_literal,
  [302694] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10180), 1,
      sym__immediate_paren,
    STATE(14237), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9171), 6,
      anon_sym_COLON,
      sym__comparison_operator,
      sym__ellipsis_operator,
      sym__plus_operator,
      sym__times_operator,
      sym__unary_plus_operator,
    ACTIONS(9212), 16,
      anon_sym_in,
      anon_sym_COLON_COLON,
      anon_sym_isa,
      anon_sym_DOT_DOT_DOT,
      anon_sym_QMARK,
      anon_sym_where,
      sym__pair_operator,
      sym__arrow_operator,
      sym__lazy_or_operator,
      sym__lazy_and_operator,
      sym__pipe_right_operator,
      sym__pipe_left_operator,
      sym__rational_operator,
      sym__bitshift_operator,
      sym__power_operator,
      sym__type_order_operator,
  [302734] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(3623), 1,
      sym__comparison_operator,
    ACTIONS(12786), 1,
      sym__ellipsis_operator,
    ACTIONS(12790), 1,
      sym__times_operator,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19870), 1,
      sym__pair_operator,
    ACTIONS(19872), 1,
      sym__arrow_operator,
    ACTIONS(19874), 1,
      sym__lazy_or_operator,
    ACTIONS(19876), 1,
      sym__lazy_and_operator,
    ACTIONS(19878), 1,
      sym__pipe_right_operator,
    ACTIONS(19880), 1,
      sym__pipe_left_operator,
    ACTIONS(19882), 1,
      sym__rational_operator,
    ACTIONS(19884), 1,
      sym__bitshift_operator,
    ACTIONS(19886), 1,
      sym__power_operator,
    ACTIONS(12788), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14238), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19868), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [302805] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19496), 1,
      anon_sym_COLON,
    ACTIONS(19502), 1,
      anon_sym_where,
    ACTIONS(19504), 1,
      sym__pair_operator,
    ACTIONS(19506), 1,
      sym__arrow_operator,
    ACTIONS(19508), 1,
      sym__lazy_or_operator,
    ACTIONS(19510), 1,
      sym__lazy_and_operator,
    ACTIONS(19512), 1,
      sym__comparison_operator,
    ACTIONS(19514), 1,
      sym__pipe_right_operator,
    ACTIONS(19516), 1,
      sym__pipe_left_operator,
    ACTIONS(19518), 1,
      sym__ellipsis_operator,
    ACTIONS(19522), 1,
      sym__times_operator,
    ACTIONS(19524), 1,
      sym__rational_operator,
    ACTIONS(19526), 1,
      sym__bitshift_operator,
    ACTIONS(19528), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19520), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14239), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19498), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [302876] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19888), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14240), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [302947] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19890), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19892), 1,
      anon_sym_where,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14241), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [303018] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(18646), 1,
      sym__pipe_right_operator,
    ACTIONS(18648), 1,
      sym__pipe_left_operator,
    ACTIONS(18650), 1,
      sym__ellipsis_operator,
    ACTIONS(18654), 1,
      sym__times_operator,
    ACTIONS(18656), 1,
      sym__rational_operator,
    ACTIONS(18658), 1,
      sym__bitshift_operator,
    ACTIONS(18660), 1,
      sym__power_operator,
    ACTIONS(18666), 1,
      sym__pair_operator,
    ACTIONS(18668), 1,
      sym__arrow_operator,
    ACTIONS(18670), 1,
      sym__lazy_or_operator,
    ACTIONS(18672), 1,
      sym__lazy_and_operator,
    ACTIONS(18674), 1,
      sym__comparison_operator,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(18652), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14242), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(18662), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [303089] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(16528), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19602), 1,
      sym__arrow_operator,
    ACTIONS(19604), 1,
      sym__lazy_or_operator,
    ACTIONS(19606), 1,
      sym__lazy_and_operator,
    ACTIONS(19608), 1,
      sym__comparison_operator,
    ACTIONS(19610), 1,
      sym__pipe_right_operator,
    ACTIONS(19612), 1,
      sym__pipe_left_operator,
    ACTIONS(19614), 1,
      sym__ellipsis_operator,
    ACTIONS(19618), 1,
      sym__times_operator,
    ACTIONS(19620), 1,
      sym__rational_operator,
    ACTIONS(19622), 1,
      sym__bitshift_operator,
    ACTIONS(19624), 1,
      sym__power_operator,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19784), 1,
      sym__pair_operator,
    ACTIONS(19616), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14243), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19598), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [303160] = 22,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19646), 1,
      anon_sym_COLON,
    ACTIONS(19650), 1,
      anon_sym_where,
    ACTIONS(19652), 1,
      sym__comparison_operator,
    ACTIONS(19654), 1,
      sym__pipe_right_operator,
    ACTIONS(19656), 1,
      sym__pipe_left_operator,
    ACTIONS(19658), 1,
      sym__ellipsis_operator,
    ACTIONS(19662), 1,
      sym__times_operator,
    ACTIONS(19664), 1,
      sym__rational_operator,
    ACTIONS(19666), 1,
      sym__bitshift_operator,
    ACTIONS(19668), 1,
      sym__power_operator,
    ACTIONS(19700), 1,
      anon_sym_QMARK,
    ACTIONS(19702), 1,
      sym__pair_operator,
    ACTIONS(19704), 1,
      sym__arrow_operator,
    ACTIONS(19706), 1,
      sym__lazy_or_operator,
    ACTIONS(19708), 1,
      sym__lazy_and_operator,
    ACTIONS(19894), 1,
      anon_sym_COLON_COLON,
    ACTIONS(19896), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(19660), 2,
      sym__plus_operator,
      sym__unary_plus_operator,
    STATE(14244), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19648), 3,
      anon_sym_in,
      anon_sym_isa,
      sym__type_order_operator,
  [303231] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(16862), 1,
      anon_sym_COMMA,
    STATE(14245), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [303256] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16614), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19900), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14967), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(17818), 1,
      sym__comprehension_clause,
    STATE(14246), 2,
      sym_block_comment,
      sym_line_comment,
  [303291] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16628), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19902), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14280), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(17702), 1,
      sym__comprehension_clause,
    STATE(14247), 2,
      sym_block_comment,
      sym_line_comment,
  [303326] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16564), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19904), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14841), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(18169), 1,
      sym__comprehension_clause,
    STATE(14248), 2,
      sym_block_comment,
      sym_line_comment,
  [303361] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16570), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19906), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14936), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(18194), 1,
      sym__comprehension_clause,
    STATE(14249), 2,
      sym_block_comment,
      sym_line_comment,
  [303396] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16588), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19908), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14405), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(18153), 1,
      sym__comprehension_clause,
    STATE(14250), 2,
      sym_block_comment,
      sym_line_comment,
  [303431] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16662), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19910), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14853), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(18134), 1,
      sym__comprehension_clause,
    STATE(14251), 2,
      sym_block_comment,
      sym_line_comment,
  [303466] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17636), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(14252), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 6,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [303489] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17217), 1,
      anon_sym_COMMA,
    STATE(14253), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [303514] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16650), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19912), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15104), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(17967), 1,
      sym__comprehension_clause,
    STATE(14254), 2,
      sym_block_comment,
      sym_line_comment,
  [303549] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(16917), 1,
      anon_sym_COMMA,
    STATE(14245), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14255), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [303576] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16582), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19914), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14416), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(18212), 1,
      sym__comprehension_clause,
    STATE(14256), 2,
      sym_block_comment,
      sym_line_comment,
  [303611] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16600), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19916), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14994), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(17930), 1,
      sym__comprehension_clause,
    STATE(14257), 2,
      sym_block_comment,
      sym_line_comment,
  [303646] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16582), 1,
      anon_sym_SEMI,
    ACTIONS(19918), 1,
      anon_sym_COMMA,
    ACTIONS(19920), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14416), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16171), 1,
      aux_sym_argument_list_repeat1,
    STATE(18212), 1,
      sym__comprehension_clause,
    STATE(14258), 2,
      sym_block_comment,
      sym_line_comment,
  [303681] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16636), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19922), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14324), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(17945), 1,
      sym__comprehension_clause,
    STATE(14259), 2,
      sym_block_comment,
      sym_line_comment,
  [303716] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16524), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19924), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14483), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(18030), 1,
      sym__comprehension_clause,
    STATE(14260), 2,
      sym_block_comment,
      sym_line_comment,
  [303751] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(19928), 1,
      anon_sym_if,
    STATE(14265), 1,
      aux_sym__comprehension_clause_repeat1,
    STATE(14261), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(19926), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [303780] = 11,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16622), 1,
      anon_sym_SEMI,
    ACTIONS(19898), 1,
      anon_sym_COMMA,
    ACTIONS(19930), 1,
      anon_sym_RPAREN,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14992), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(16200), 1,
      aux_sym_argument_list_repeat1,
    STATE(17964), 1,
      sym__comprehension_clause,
    STATE(14262), 2,
      sym_block_comment,
      sym_line_comment,
  [303815] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(16692), 1,
      anon_sym_COMMA,
    STATE(14253), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14263), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 5,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [303842] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(19928), 1,
      anon_sym_if,
    STATE(14261), 1,
      aux_sym__comprehension_clause_repeat1,
    STATE(14264), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(19932), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [303871] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19936), 1,
      anon_sym_if,
    ACTIONS(19939), 1,
      anon_sym_for,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
    ACTIONS(19934), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14265), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__comprehension_clause_repeat1,
  [303898] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15330), 1,
      anon_sym_EQ,
    ACTIONS(16923), 1,
      aux_sym__terminator_token1,
    ACTIONS(16925), 1,
      aux_sym__terminator_token2,
    STATE(14918), 1,
      aux_sym__block_repeat1,
    STATE(14266), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16919), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
  [303926] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17574), 1,
      anon_sym_COMMA,
    STATE(14267), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [303950] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19942), 1,
      anon_sym_if,
    ACTIONS(19945), 1,
      anon_sym_for,
    ACTIONS(19934), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
    STATE(14268), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__comprehension_clause_repeat1,
  [303976] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19948), 1,
      anon_sym_if,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14268), 1,
      aux_sym__comprehension_clause_repeat1,
    ACTIONS(19926), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14269), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
  [304004] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19939), 1,
      anon_sym_for,
    ACTIONS(19952), 1,
      anon_sym_if,
    ACTIONS(19934), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
    STATE(14270), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__comprehension_clause_repeat1,
  [304030] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19948), 1,
      anon_sym_if,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14269), 1,
      aux_sym__comprehension_clause_repeat1,
    ACTIONS(19932), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    STATE(14271), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
  [304058] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17627), 1,
      anon_sym_COMMA,
    STATE(14272), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [304082] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(19955), 1,
      anon_sym_if,
    STATE(14270), 1,
      aux_sym__comprehension_clause_repeat1,
    ACTIONS(19926), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14273), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
  [304110] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15250), 1,
      anon_sym_EQ,
    ACTIONS(17131), 1,
      aux_sym__terminator_token1,
    ACTIONS(17133), 1,
      aux_sym__terminator_token2,
    STATE(15078), 1,
      aux_sym__block_repeat1,
    STATE(14274), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16919), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [304138] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(19955), 1,
      anon_sym_if,
    STATE(14273), 1,
      aux_sym__comprehension_clause_repeat1,
    ACTIONS(19932), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(14275), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(14629), 2,
      sym_if_clause,
      sym_for_clause,
  [304166] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17656), 1,
      anon_sym_COMMA,
    STATE(14276), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10835), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [304190] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17262), 1,
      anon_sym_COMMA,
    STATE(14276), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14277), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [304216] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17482), 1,
      anon_sym_COMMA,
    STATE(14267), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14278), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 4,
      anon_sym_EQ,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [304242] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17478), 1,
      anon_sym_COMMA,
    STATE(14272), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14279), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 4,
      anon_sym_EQ,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [304268] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7410), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(19957), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17805), 1,
      sym__comprehension_clause,
    STATE(14280), 2,
      sym_block_comment,
      sym_line_comment,
  [304297] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7634), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(19959), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18912), 1,
      sym__comprehension_clause,
    STATE(14281), 2,
      sym_block_comment,
      sym_line_comment,
  [304326] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(19965), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14282), 2,
      sym_block_comment,
      sym_line_comment,
  [304353] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19965), 1,
      sym__end_str,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14283), 2,
      sym_block_comment,
      sym_line_comment,
  [304380] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(19975), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14284), 2,
      sym_block_comment,
      sym_line_comment,
  [304407] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19975), 1,
      sym__end_cmd,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14285), 2,
      sym_block_comment,
      sym_line_comment,
  [304434] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19981), 1,
      anon_sym_end,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    STATE(14616), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18357), 1,
      sym_else_clause,
    STATE(14286), 2,
      sym_block_comment,
      sym_line_comment,
  [304463] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8236), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(19985), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17940), 1,
      sym__comprehension_clause,
    STATE(14287), 2,
      sym_block_comment,
      sym_line_comment,
  [304492] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(19987), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18515), 1,
      sym_else_clause,
    STATE(14288), 2,
      sym_block_comment,
      sym_line_comment,
  [304521] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(19989), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18418), 1,
      sym_else_clause,
    STATE(14289), 2,
      sym_block_comment,
      sym_line_comment,
  [304550] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7054), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(19991), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18623), 1,
      sym__comprehension_clause,
    STATE(14290), 2,
      sym_block_comment,
      sym_line_comment,
  [304579] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18502), 1,
      sym__word_identifier,
    ACTIONS(19993), 1,
      anon_sym_DOLLAR,
    ACTIONS(19995), 1,
      anon_sym_COLON2,
    STATE(14291), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7055), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [304604] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(19997), 1,
      sym__end_str,
    STATE(14300), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14292), 2,
      sym_block_comment,
      sym_line_comment,
  [304631] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(19999), 1,
      sym__end_cmd,
    STATE(14301), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14293), 2,
      sym_block_comment,
      sym_line_comment,
  [304658] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(19999), 1,
      sym__end_cmd,
    STATE(14302), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14294), 2,
      sym_block_comment,
      sym_line_comment,
  [304685] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18718), 1,
      sym__word_identifier,
    ACTIONS(20001), 1,
      anon_sym_DOLLAR,
    ACTIONS(20003), 1,
      anon_sym_COLON2,
    STATE(14295), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6912), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [304710] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20005), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14296), 2,
      sym_block_comment,
      sym_line_comment,
  [304737] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20007), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14297), 2,
      sym_block_comment,
      sym_line_comment,
  [304764] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20009), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14298), 2,
      sym_block_comment,
      sym_line_comment,
  [304791] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20011), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14299), 2,
      sym_block_comment,
      sym_line_comment,
  [304818] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20011), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14300), 2,
      sym_block_comment,
      sym_line_comment,
  [304845] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20013), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14301), 2,
      sym_block_comment,
      sym_line_comment,
  [304872] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20013), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14302), 2,
      sym_block_comment,
      sym_line_comment,
  [304899] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8286), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20015), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18190), 1,
      sym__comprehension_clause,
    STATE(14303), 2,
      sym_block_comment,
      sym_line_comment,
  [304928] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8364), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20017), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19519), 1,
      sym__comprehension_clause,
    STATE(14304), 2,
      sym_block_comment,
      sym_line_comment,
  [304957] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20007), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14305), 2,
      sym_block_comment,
      sym_line_comment,
  [304984] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20019), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14306), 2,
      sym_block_comment,
      sym_line_comment,
  [305011] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20021), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14307), 2,
      sym_block_comment,
      sym_line_comment,
  [305038] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20019), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14308), 2,
      sym_block_comment,
      sym_line_comment,
  [305065] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15330), 1,
      anon_sym_EQ,
    STATE(14309), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [305088] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16750), 1,
      anon_sym_RPAREN,
    ACTIONS(16752), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14634), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17898), 1,
      sym__comprehension_clause,
    STATE(14310), 2,
      sym_block_comment,
      sym_line_comment,
  [305117] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20021), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14311), 2,
      sym_block_comment,
      sym_line_comment,
  [305144] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17041), 1,
      anon_sym_RPAREN,
    ACTIONS(17043), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14349), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17695), 1,
      sym__comprehension_clause,
    STATE(14312), 2,
      sym_block_comment,
      sym_line_comment,
  [305173] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8172), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20023), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18011), 1,
      sym__comprehension_clause,
    STATE(14313), 2,
      sym_block_comment,
      sym_line_comment,
  [305202] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16963), 1,
      anon_sym_RPAREN,
    ACTIONS(16965), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14519), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18039), 1,
      sym__comprehension_clause,
    STATE(14314), 2,
      sym_block_comment,
      sym_line_comment,
  [305231] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8204), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20025), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18916), 1,
      sym__comprehension_clause,
    STATE(14315), 2,
      sym_block_comment,
      sym_line_comment,
  [305260] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20027), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14316), 2,
      sym_block_comment,
      sym_line_comment,
  [305287] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20029), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14317), 2,
      sym_block_comment,
      sym_line_comment,
  [305314] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20031), 1,
      sym__end_cmd,
    STATE(14744), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14318), 2,
      sym_block_comment,
      sym_line_comment,
  [305341] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20033), 1,
      sym__end_str,
    STATE(14325), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14319), 2,
      sym_block_comment,
      sym_line_comment,
  [305368] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20033), 1,
      sym__end_str,
    STATE(14326), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14320), 2,
      sym_block_comment,
      sym_line_comment,
  [305395] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20035), 1,
      sym__end_cmd,
    STATE(14327), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14321), 2,
      sym_block_comment,
      sym_line_comment,
  [305422] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20035), 1,
      sym__end_cmd,
    STATE(14329), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14322), 2,
      sym_block_comment,
      sym_line_comment,
  [305449] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16304), 1,
      sym__word_identifier,
    ACTIONS(20037), 1,
      anon_sym_DOLLAR,
    ACTIONS(20039), 1,
      anon_sym_COLON2,
    STATE(14323), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7610), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [305474] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6966), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20041), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17878), 1,
      sym__comprehension_clause,
    STATE(14324), 2,
      sym_block_comment,
      sym_line_comment,
  [305503] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20043), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14325), 2,
      sym_block_comment,
      sym_line_comment,
  [305530] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20043), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14326), 2,
      sym_block_comment,
      sym_line_comment,
  [305557] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20045), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14327), 2,
      sym_block_comment,
      sym_line_comment,
  [305584] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6968), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20047), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18425), 1,
      sym__comprehension_clause,
    STATE(14328), 2,
      sym_block_comment,
      sym_line_comment,
  [305613] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20045), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14329), 2,
      sym_block_comment,
      sym_line_comment,
  [305640] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8326), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20049), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18062), 1,
      sym__comprehension_clause,
    STATE(14330), 2,
      sym_block_comment,
      sym_line_comment,
  [305669] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8386), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20051), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19128), 1,
      sym__comprehension_clause,
    STATE(14331), 2,
      sym_block_comment,
      sym_line_comment,
  [305698] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16794), 1,
      anon_sym_RPAREN,
    ACTIONS(16796), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14313), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18005), 1,
      sym__comprehension_clause,
    STATE(14332), 2,
      sym_block_comment,
      sym_line_comment,
  [305727] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17053), 1,
      anon_sym_RPAREN,
    ACTIONS(17055), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14369), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17932), 1,
      sym__comprehension_clause,
    STATE(14333), 2,
      sym_block_comment,
      sym_line_comment,
  [305756] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20053), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14334), 2,
      sym_block_comment,
      sym_line_comment,
  [305783] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20055), 1,
      anon_sym_end,
    STATE(14707), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18396), 1,
      sym_else_clause,
    STATE(14335), 2,
      sym_block_comment,
      sym_line_comment,
  [305812] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20053), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14336), 2,
      sym_block_comment,
      sym_line_comment,
  [305839] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20057), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18479), 1,
      sym_else_clause,
    STATE(14337), 2,
      sym_block_comment,
      sym_line_comment,
  [305868] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7986), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20059), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17899), 1,
      sym__comprehension_clause,
    STATE(14338), 2,
      sym_block_comment,
      sym_line_comment,
  [305897] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20061), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19431), 1,
      sym_else_clause,
    STATE(14339), 2,
      sym_block_comment,
      sym_line_comment,
  [305926] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20063), 1,
      sym__end_str,
    STATE(14345), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14340), 2,
      sym_block_comment,
      sym_line_comment,
  [305953] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20063), 1,
      sym__end_str,
    STATE(14346), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14341), 2,
      sym_block_comment,
      sym_line_comment,
  [305980] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20065), 1,
      sym__end_cmd,
    STATE(14347), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14342), 2,
      sym_block_comment,
      sym_line_comment,
  [306007] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20065), 1,
      sym__end_cmd,
    STATE(14348), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14343), 2,
      sym_block_comment,
      sym_line_comment,
  [306034] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8104), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20067), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18431), 1,
      sym__comprehension_clause,
    STATE(14344), 2,
      sym_block_comment,
      sym_line_comment,
  [306063] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20069), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14345), 2,
      sym_block_comment,
      sym_line_comment,
  [306090] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20069), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14346), 2,
      sym_block_comment,
      sym_line_comment,
  [306117] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20071), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14347), 2,
      sym_block_comment,
      sym_line_comment,
  [306144] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20071), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14348), 2,
      sym_block_comment,
      sym_line_comment,
  [306171] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8342), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20073), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17766), 1,
      sym__comprehension_clause,
    STATE(14349), 2,
      sym_block_comment,
      sym_line_comment,
  [306200] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8410), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20075), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18620), 1,
      sym__comprehension_clause,
    STATE(14350), 2,
      sym_block_comment,
      sym_line_comment,
  [306229] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20077), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14351), 2,
      sym_block_comment,
      sym_line_comment,
  [306256] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17087), 1,
      anon_sym_RPAREN,
    ACTIONS(17089), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14396), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18090), 1,
      sym__comprehension_clause,
    STATE(14352), 2,
      sym_block_comment,
      sym_line_comment,
  [306285] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17111), 1,
      anon_sym_RPAREN,
    ACTIONS(17113), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14841), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18169), 1,
      sym__comprehension_clause,
    STATE(14353), 2,
      sym_block_comment,
      sym_line_comment,
  [306314] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20079), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18308), 1,
      sym_else_clause,
    STATE(14354), 2,
      sym_block_comment,
      sym_line_comment,
  [306343] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20077), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14355), 2,
      sym_block_comment,
      sym_line_comment,
  [306370] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20081), 1,
      sym__end_str,
    STATE(14365), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14356), 2,
      sym_block_comment,
      sym_line_comment,
  [306397] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20081), 1,
      sym__end_str,
    STATE(14366), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14357), 2,
      sym_block_comment,
      sym_line_comment,
  [306424] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20083), 1,
      sym__end_cmd,
    STATE(14367), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14358), 2,
      sym_block_comment,
      sym_line_comment,
  [306451] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7290), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20085), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17971), 1,
      sym__comprehension_clause,
    STATE(14359), 2,
      sym_block_comment,
      sym_line_comment,
  [306480] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20083), 1,
      sym__end_cmd,
    STATE(14368), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14360), 2,
      sym_block_comment,
      sym_line_comment,
  [306507] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20087), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14361), 2,
      sym_block_comment,
      sym_line_comment,
  [306534] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20087), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14362), 2,
      sym_block_comment,
      sym_line_comment,
  [306561] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8060), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20089), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18247), 1,
      sym__comprehension_clause,
    STATE(14363), 2,
      sym_block_comment,
      sym_line_comment,
  [306590] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20091), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14364), 2,
      sym_block_comment,
      sym_line_comment,
  [306617] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20093), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14365), 2,
      sym_block_comment,
      sym_line_comment,
  [306644] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20093), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14366), 2,
      sym_block_comment,
      sym_line_comment,
  [306671] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20095), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14367), 2,
      sym_block_comment,
      sym_line_comment,
  [306698] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20095), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14368), 2,
      sym_block_comment,
      sym_line_comment,
  [306725] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8362), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20097), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17991), 1,
      sym__comprehension_clause,
    STATE(14369), 2,
      sym_block_comment,
      sym_line_comment,
  [306754] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20099), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18847), 1,
      sym__comprehension_clause,
    STATE(14370), 2,
      sym_block_comment,
      sym_line_comment,
  [306783] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20091), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14371), 2,
      sym_block_comment,
      sym_line_comment,
  [306810] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17099), 1,
      anon_sym_RPAREN,
    ACTIONS(17101), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14483), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18030), 1,
      sym__comprehension_clause,
    STATE(14372), 2,
      sym_block_comment,
      sym_line_comment,
  [306839] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20101), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14373), 2,
      sym_block_comment,
      sym_line_comment,
  [306866] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20103), 1,
      sym__end_str,
    STATE(14387), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14374), 2,
      sym_block_comment,
      sym_line_comment,
  [306893] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20103), 1,
      sym__end_str,
    STATE(14388), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14375), 2,
      sym_block_comment,
      sym_line_comment,
  [306920] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20105), 1,
      sym__end_cmd,
    STATE(14389), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14376), 2,
      sym_block_comment,
      sym_line_comment,
  [306947] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20105), 1,
      sym__end_cmd,
    STATE(14390), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14377), 2,
      sym_block_comment,
      sym_line_comment,
  [306974] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13864), 1,
      anon_sym_DOLLAR,
    ACTIONS(18722), 1,
      sym__word_identifier,
    ACTIONS(19694), 1,
      anon_sym_COLON2,
    STATE(14378), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6411), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [306999] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20107), 1,
      anon_sym_end,
    STATE(14511), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18628), 1,
      sym_else_clause,
    STATE(14379), 2,
      sym_block_comment,
      sym_line_comment,
  [307028] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8384), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20109), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18364), 1,
      sym__comprehension_clause,
    STATE(14380), 2,
      sym_block_comment,
      sym_line_comment,
  [307057] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7432), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20111), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18229), 1,
      sym__comprehension_clause,
    STATE(14381), 2,
      sym_block_comment,
      sym_line_comment,
  [307086] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20113), 1,
      sym__end_str,
    STATE(14426), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14382), 2,
      sym_block_comment,
      sym_line_comment,
  [307113] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20113), 1,
      sym__end_str,
    STATE(14427), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14383), 2,
      sym_block_comment,
      sym_line_comment,
  [307140] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20101), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14384), 2,
      sym_block_comment,
      sym_line_comment,
  [307167] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20115), 1,
      sym__end_cmd,
    STATE(14428), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14385), 2,
      sym_block_comment,
      sym_line_comment,
  [307194] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20115), 1,
      sym__end_cmd,
    STATE(14429), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14386), 2,
      sym_block_comment,
      sym_line_comment,
  [307221] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20117), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14387), 2,
      sym_block_comment,
      sym_line_comment,
  [307248] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20117), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14388), 2,
      sym_block_comment,
      sym_line_comment,
  [307275] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20119), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14389), 2,
      sym_block_comment,
      sym_line_comment,
  [307302] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20119), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14390), 2,
      sym_block_comment,
      sym_line_comment,
  [307329] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16368), 1,
      sym__word_identifier,
    ACTIONS(20121), 1,
      anon_sym_DOLLAR,
    ACTIONS(20123), 1,
      anon_sym_COLON2,
    STATE(14391), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6496), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [307354] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20125), 1,
      sym__end_str,
    STATE(14422), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14392), 2,
      sym_block_comment,
      sym_line_comment,
  [307381] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20125), 1,
      sym__end_str,
    STATE(14423), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14393), 2,
      sym_block_comment,
      sym_line_comment,
  [307408] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20127), 1,
      sym__end_cmd,
    STATE(14430), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14394), 2,
      sym_block_comment,
      sym_line_comment,
  [307435] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20127), 1,
      sym__end_cmd,
    STATE(14433), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14395), 2,
      sym_block_comment,
      sym_line_comment,
  [307462] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8382), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20129), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18146), 1,
      sym__comprehension_clause,
    STATE(14396), 2,
      sym_block_comment,
      sym_line_comment,
  [307491] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8458), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20131), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19373), 1,
      sym__comprehension_clause,
    STATE(14397), 2,
      sym_block_comment,
      sym_line_comment,
  [307520] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20133), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18658), 1,
      sym_else_clause,
    STATE(14398), 2,
      sym_block_comment,
      sym_line_comment,
  [307549] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17137), 1,
      anon_sym_RPAREN,
    ACTIONS(17139), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14424), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17681), 1,
      sym__comprehension_clause,
    STATE(14399), 2,
      sym_block_comment,
      sym_line_comment,
  [307578] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16800), 1,
      anon_sym_RPAREN,
    ACTIONS(16802), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14450), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18219), 1,
      sym__comprehension_clause,
    STATE(14400), 2,
      sym_block_comment,
      sym_line_comment,
  [307607] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20135), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14401), 2,
      sym_block_comment,
      sym_line_comment,
  [307634] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20137), 1,
      anon_sym_DOLLAR,
    ACTIONS(20143), 1,
      sym__end_str,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(20140), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14402), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_string_literal_repeat1,
  [307659] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20135), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14403), 2,
      sym_block_comment,
      sym_line_comment,
  [307686] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20145), 1,
      sym__end_str,
    STATE(14473), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14404), 2,
      sym_block_comment,
      sym_line_comment,
  [307713] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7514), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20147), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17980), 1,
      sym__comprehension_clause,
    STATE(14405), 2,
      sym_block_comment,
      sym_line_comment,
  [307742] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15494), 1,
      anon_sym_EQ,
    ACTIONS(17298), 1,
      aux_sym__terminator_token1,
    ACTIONS(17300), 1,
      aux_sym__terminator_token2,
    STATE(15176), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_end,
      anon_sym_catch,
    STATE(14406), 2,
      sym_block_comment,
      sym_line_comment,
  [307769] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20149), 1,
      sym__end_str,
    STATE(14417), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14407), 2,
      sym_block_comment,
      sym_line_comment,
  [307796] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20149), 1,
      sym__end_str,
    STATE(14418), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14408), 2,
      sym_block_comment,
      sym_line_comment,
  [307823] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20151), 1,
      sym__end_cmd,
    STATE(14420), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14409), 2,
      sym_block_comment,
      sym_line_comment,
  [307850] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20153), 1,
      sym__end_str,
    STATE(14442), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14410), 2,
      sym_block_comment,
      sym_line_comment,
  [307877] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20153), 1,
      sym__end_str,
    STATE(14443), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14411), 2,
      sym_block_comment,
      sym_line_comment,
  [307904] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20155), 1,
      sym__end_cmd,
    STATE(14445), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14412), 2,
      sym_block_comment,
      sym_line_comment,
  [307931] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20155), 1,
      sym__end_cmd,
    STATE(14446), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14413), 2,
      sym_block_comment,
      sym_line_comment,
  [307958] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20151), 1,
      sym__end_cmd,
    STATE(14421), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14414), 2,
      sym_block_comment,
      sym_line_comment,
  [307985] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20145), 1,
      sym__end_str,
    STATE(14476), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14415), 2,
      sym_block_comment,
      sym_line_comment,
  [308012] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7118), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20157), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18017), 1,
      sym__comprehension_clause,
    STATE(14416), 2,
      sym_block_comment,
      sym_line_comment,
  [308041] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20159), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14417), 2,
      sym_block_comment,
      sym_line_comment,
  [308068] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20159), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14418), 2,
      sym_block_comment,
      sym_line_comment,
  [308095] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17779), 1,
      anon_sym_COMMA,
    STATE(14837), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10829), 2,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(10833), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(14419), 2,
      sym_block_comment,
      sym_line_comment,
  [308120] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20161), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14420), 2,
      sym_block_comment,
      sym_line_comment,
  [308147] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20161), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14421), 2,
      sym_block_comment,
      sym_line_comment,
  [308174] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20163), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14422), 2,
      sym_block_comment,
      sym_line_comment,
  [308201] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20163), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14423), 2,
      sym_block_comment,
      sym_line_comment,
  [308228] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8426), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20165), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17706), 1,
      sym__comprehension_clause,
    STATE(14424), 2,
      sym_block_comment,
      sym_line_comment,
  [308257] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8484), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20167), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18702), 1,
      sym__comprehension_clause,
    STATE(14425), 2,
      sym_block_comment,
      sym_line_comment,
  [308286] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20169), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14426), 2,
      sym_block_comment,
      sym_line_comment,
  [308313] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20169), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14427), 2,
      sym_block_comment,
      sym_line_comment,
  [308340] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20171), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14428), 2,
      sym_block_comment,
      sym_line_comment,
  [308367] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20171), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14429), 2,
      sym_block_comment,
      sym_line_comment,
  [308394] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20173), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14430), 2,
      sym_block_comment,
      sym_line_comment,
  [308421] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8778), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20175), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18992), 1,
      sym__comprehension_clause,
    STATE(14431), 2,
      sym_block_comment,
      sym_line_comment,
  [308450] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17169), 1,
      anon_sym_RPAREN,
    ACTIONS(17171), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14464), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17787), 1,
      sym__comprehension_clause,
    STATE(14432), 2,
      sym_block_comment,
      sym_line_comment,
  [308479] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20173), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14433), 2,
      sym_block_comment,
      sym_line_comment,
  [308506] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6990), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20177), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18911), 1,
      sym__comprehension_clause,
    STATE(14434), 2,
      sym_block_comment,
      sym_line_comment,
  [308535] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20179), 1,
      sym__end_cmd,
    STATE(14478), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14435), 2,
      sym_block_comment,
      sym_line_comment,
  [308562] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20179), 1,
      sym__end_cmd,
    STATE(14481), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14436), 2,
      sym_block_comment,
      sym_line_comment,
  [308589] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20181), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18461), 1,
      sym_else_clause,
    STATE(14437), 2,
      sym_block_comment,
      sym_line_comment,
  [308618] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13504), 1,
      anon_sym_DOLLAR,
    ACTIONS(18714), 1,
      sym__word_identifier,
    ACTIONS(19802), 1,
      anon_sym_COLON2,
    STATE(14438), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6660), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [308643] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16328), 1,
      sym__word_identifier,
    ACTIONS(20183), 1,
      anon_sym_DOLLAR,
    ACTIONS(20185), 1,
      anon_sym_COLON2,
    STATE(14439), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6920), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [308668] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16943), 1,
      anon_sym_RPAREN,
    ACTIONS(16945), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14994), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17930), 1,
      sym__comprehension_clause,
    STATE(14440), 2,
      sym_block_comment,
      sym_line_comment,
  [308697] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20187), 1,
      anon_sym_DOLLAR,
    ACTIONS(20193), 1,
      sym__end_str,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(20190), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14441), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_string_literal_repeat2,
  [308722] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20195), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14442), 2,
      sym_block_comment,
      sym_line_comment,
  [308749] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20195), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14443), 2,
      sym_block_comment,
      sym_line_comment,
  [308776] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20197), 1,
      sym__end_str,
    STATE(14456), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14444), 2,
      sym_block_comment,
      sym_line_comment,
  [308803] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20199), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14445), 2,
      sym_block_comment,
      sym_line_comment,
  [308830] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20199), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14446), 2,
      sym_block_comment,
      sym_line_comment,
  [308857] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20197), 1,
      sym__end_str,
    STATE(14458), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14447), 2,
      sym_block_comment,
      sym_line_comment,
  [308884] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20201), 1,
      sym__end_cmd,
    STATE(14459), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14448), 2,
      sym_block_comment,
      sym_line_comment,
  [308911] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20201), 1,
      sym__end_cmd,
    STATE(14463), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14449), 2,
      sym_block_comment,
      sym_line_comment,
  [308938] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8506), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20203), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17807), 1,
      sym__comprehension_clause,
    STATE(14450), 2,
      sym_block_comment,
      sym_line_comment,
  [308967] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7364), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20205), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18142), 1,
      sym__comprehension_clause,
    STATE(14451), 2,
      sym_block_comment,
      sym_line_comment,
  [308996] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20207), 1,
      anon_sym_end,
    STATE(14474), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18915), 1,
      sym_else_clause,
    STATE(14452), 2,
      sym_block_comment,
      sym_line_comment,
  [309025] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20209), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18968), 1,
      sym_else_clause,
    STATE(14453), 2,
      sym_block_comment,
      sym_line_comment,
  [309054] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7110), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20211), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19151), 1,
      sym__comprehension_clause,
    STATE(14454), 2,
      sym_block_comment,
      sym_line_comment,
  [309083] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16989), 1,
      anon_sym_RPAREN,
    ACTIONS(16991), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14686), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17937), 1,
      sym__comprehension_clause,
    STATE(14455), 2,
      sym_block_comment,
      sym_line_comment,
  [309112] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20213), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14456), 2,
      sym_block_comment,
      sym_line_comment,
  [309139] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7422), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20215), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19075), 1,
      sym__comprehension_clause,
    STATE(14457), 2,
      sym_block_comment,
      sym_line_comment,
  [309168] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20213), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14458), 2,
      sym_block_comment,
      sym_line_comment,
  [309195] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20217), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14459), 2,
      sym_block_comment,
      sym_line_comment,
  [309222] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(20219), 1,
      anon_sym_DOLLAR,
    ACTIONS(20221), 1,
      anon_sym_COLON2,
    STATE(14460), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11690), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [309247] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14378), 1,
      anon_sym_DOLLAR,
    ACTIONS(18421), 1,
      sym__word_identifier,
    ACTIONS(19750), 1,
      anon_sym_COLON2,
    STATE(14461), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6400), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [309272] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16814), 1,
      anon_sym_RPAREN,
    ACTIONS(16816), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14790), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18055), 1,
      sym__comprehension_clause,
    STATE(14462), 2,
      sym_block_comment,
      sym_line_comment,
  [309301] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20217), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14463), 2,
      sym_block_comment,
      sym_line_comment,
  [309328] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8454), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20223), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17848), 1,
      sym__comprehension_clause,
    STATE(14464), 2,
      sym_block_comment,
      sym_line_comment,
  [309357] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8508), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20225), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18243), 1,
      sym__comprehension_clause,
    STATE(14465), 2,
      sym_block_comment,
      sym_line_comment,
  [309386] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(20227), 1,
      aux_sym__terminator_token1,
    ACTIONS(20230), 1,
      aux_sym__terminator_token2,
    ACTIONS(17634), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
    STATE(14466), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__block_repeat1,
  [309409] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20233), 1,
      anon_sym_end,
    STATE(14491), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19177), 1,
      sym_else_clause,
    STATE(14467), 2,
      sym_block_comment,
      sym_line_comment,
  [309438] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7560), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20235), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18145), 1,
      sym__comprehension_clause,
    STATE(14468), 2,
      sym_block_comment,
      sym_line_comment,
  [309467] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7670), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20237), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19353), 1,
      sym__comprehension_clause,
    STATE(14469), 2,
      sym_block_comment,
      sym_line_comment,
  [309496] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17177), 1,
      anon_sym_RPAREN,
    ACTIONS(17179), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14916), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18093), 1,
      sym__comprehension_clause,
    STATE(14470), 2,
      sym_block_comment,
      sym_line_comment,
  [309525] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18423), 1,
      sym__word_identifier,
    ACTIONS(20239), 1,
      anon_sym_DOLLAR,
    ACTIONS(20241), 1,
      anon_sym_COLON2,
    STATE(14471), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7211), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [309550] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17093), 1,
      anon_sym_RPAREN,
    ACTIONS(17095), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14704), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17951), 1,
      sym__comprehension_clause,
    STATE(14472), 2,
      sym_block_comment,
      sym_line_comment,
  [309579] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20243), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14473), 2,
      sym_block_comment,
      sym_line_comment,
  [309606] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20245), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19180), 1,
      sym_else_clause,
    STATE(14474), 2,
      sym_block_comment,
      sym_line_comment,
  [309635] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17189), 1,
      anon_sym_RPAREN,
    ACTIONS(17191), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14936), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18194), 1,
      sym__comprehension_clause,
    STATE(14475), 2,
      sym_block_comment,
      sym_line_comment,
  [309664] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20243), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14476), 2,
      sym_block_comment,
      sym_line_comment,
  [309691] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17063), 1,
      anon_sym_RPAREN,
    ACTIONS(17065), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14591), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18201), 1,
      sym__comprehension_clause,
    STATE(14477), 2,
      sym_block_comment,
      sym_line_comment,
  [309720] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20247), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14478), 2,
      sym_block_comment,
      sym_line_comment,
  [309747] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20249), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14479), 2,
      sym_block_comment,
      sym_line_comment,
  [309774] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20251), 1,
      sym__end_cmd,
    STATE(15044), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14480), 2,
      sym_block_comment,
      sym_line_comment,
  [309801] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20247), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14481), 2,
      sym_block_comment,
      sym_line_comment,
  [309828] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20253), 1,
      anon_sym_COMMA,
    STATE(15002), 1,
      aux_sym_for_statement_repeat1,
    STATE(14482), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20255), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [309851] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6910), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20257), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18044), 1,
      sym__comprehension_clause,
    STATE(14483), 2,
      sym_block_comment,
      sym_line_comment,
  [309880] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20259), 1,
      sym__end_str,
    STATE(14603), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14484), 2,
      sym_block_comment,
      sym_line_comment,
  [309907] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20261), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19565), 1,
      sym_else_clause,
    STATE(14485), 2,
      sym_block_comment,
      sym_line_comment,
  [309936] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8232), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20263), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19028), 1,
      sym__comprehension_clause,
    STATE(14486), 2,
      sym_block_comment,
      sym_line_comment,
  [309965] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20265), 1,
      sym__end_str,
    STATE(14496), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14487), 2,
      sym_block_comment,
      sym_line_comment,
  [309992] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20265), 1,
      sym__end_str,
    STATE(14498), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14488), 2,
      sym_block_comment,
      sym_line_comment,
  [310019] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20267), 1,
      sym__end_cmd,
    STATE(14500), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14489), 2,
      sym_block_comment,
      sym_line_comment,
  [310046] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20267), 1,
      sym__end_cmd,
    STATE(14501), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14490), 2,
      sym_block_comment,
      sym_line_comment,
  [310073] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20269), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19210), 1,
      sym_else_clause,
    STATE(14491), 2,
      sym_block_comment,
      sym_line_comment,
  [310102] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16931), 1,
      anon_sym_RPAREN,
    ACTIONS(16933), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14667), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17929), 1,
      sym__comprehension_clause,
    STATE(14492), 2,
      sym_block_comment,
      sym_line_comment,
  [310131] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20271), 1,
      sym__end_str,
    STATE(14505), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14493), 2,
      sym_block_comment,
      sym_line_comment,
  [310158] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20271), 1,
      sym__end_str,
    STATE(14507), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14494), 2,
      sym_block_comment,
      sym_line_comment,
  [310185] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7522), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20273), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19395), 1,
      sym__comprehension_clause,
    STATE(14495), 2,
      sym_block_comment,
      sym_line_comment,
  [310214] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20275), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14496), 2,
      sym_block_comment,
      sym_line_comment,
  [310241] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20277), 1,
      sym__end_cmd,
    STATE(14513), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14497), 2,
      sym_block_comment,
      sym_line_comment,
  [310268] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20275), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14498), 2,
      sym_block_comment,
      sym_line_comment,
  [310295] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20277), 1,
      sym__end_cmd,
    STATE(14518), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14499), 2,
      sym_block_comment,
      sym_line_comment,
  [310322] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20279), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14500), 2,
      sym_block_comment,
      sym_line_comment,
  [310349] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20279), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14501), 2,
      sym_block_comment,
      sym_line_comment,
  [310376] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8504), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20281), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17941), 1,
      sym__comprehension_clause,
    STATE(14502), 2,
      sym_block_comment,
      sym_line_comment,
  [310405] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20283), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18646), 1,
      sym__comprehension_clause,
    STATE(14503), 2,
      sym_block_comment,
      sym_line_comment,
  [310434] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20031), 1,
      sym__end_cmd,
    STATE(14748), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14504), 2,
      sym_block_comment,
      sym_line_comment,
  [310461] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20285), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14505), 2,
      sym_block_comment,
      sym_line_comment,
  [310488] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16378), 1,
      sym__word_identifier,
    ACTIONS(20287), 1,
      anon_sym_DOLLAR,
    ACTIONS(20289), 1,
      anon_sym_COLON2,
    STATE(14506), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7003), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [310513] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20285), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14507), 2,
      sym_block_comment,
      sym_line_comment,
  [310540] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17197), 1,
      anon_sym_RPAREN,
    ACTIONS(17199), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14502), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17917), 1,
      sym__comprehension_clause,
    STATE(14508), 2,
      sym_block_comment,
      sym_line_comment,
  [310569] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13706), 1,
      anon_sym_DOLLAR,
    ACTIONS(18512), 1,
      sym__word_identifier,
    ACTIONS(19772), 1,
      anon_sym_COLON2,
    STATE(14509), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6376), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [310594] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20291), 1,
      anon_sym_end,
    STATE(14570), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19302), 1,
      sym_else_clause,
    STATE(14510), 2,
      sym_block_comment,
      sym_line_comment,
  [310623] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20293), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19310), 1,
      sym_else_clause,
    STATE(14511), 2,
      sym_block_comment,
      sym_line_comment,
  [310652] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20295), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14512), 2,
      sym_block_comment,
      sym_line_comment,
  [310679] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20297), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14513), 2,
      sym_block_comment,
      sym_line_comment,
  [310706] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20299), 1,
      sym__end_str,
    STATE(14534), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14514), 2,
      sym_block_comment,
      sym_line_comment,
  [310733] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20299), 1,
      sym__end_str,
    STATE(14535), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14515), 2,
      sym_block_comment,
      sym_line_comment,
  [310760] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20301), 1,
      sym__end_cmd,
    STATE(14536), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14516), 2,
      sym_block_comment,
      sym_line_comment,
  [310787] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20301), 1,
      sym__end_cmd,
    STATE(14538), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14517), 2,
      sym_block_comment,
      sym_line_comment,
  [310814] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20297), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14518), 2,
      sym_block_comment,
      sym_line_comment,
  [310841] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7596), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20303), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17923), 1,
      sym__comprehension_clause,
    STATE(14519), 2,
      sym_block_comment,
      sym_line_comment,
  [310870] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20305), 1,
      sym__end_str,
    STATE(14529), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14520), 2,
      sym_block_comment,
      sym_line_comment,
  [310897] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20305), 1,
      sym__end_str,
    STATE(14530), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14521), 2,
      sym_block_comment,
      sym_line_comment,
  [310924] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7704), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20307), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18596), 1,
      sym__comprehension_clause,
    STATE(14522), 2,
      sym_block_comment,
      sym_line_comment,
  [310953] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20309), 1,
      sym__end_cmd,
    STATE(14533), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14523), 2,
      sym_block_comment,
      sym_line_comment,
  [310980] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20309), 1,
      sym__end_cmd,
    STATE(14537), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14524), 2,
      sym_block_comment,
      sym_line_comment,
  [311007] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16294), 1,
      sym__word_identifier,
    ACTIONS(20311), 1,
      anon_sym_DOLLAR,
    ACTIONS(20313), 1,
      anon_sym_COLON2,
    STATE(14525), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6948), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [311032] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17047), 1,
      anon_sym_RPAREN,
    ACTIONS(17049), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14451), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17743), 1,
      sym__comprehension_clause,
    STATE(14526), 2,
      sym_block_comment,
      sym_line_comment,
  [311061] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16808), 1,
      anon_sym_RPAREN,
    ACTIONS(16810), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14655), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18068), 1,
      sym__comprehension_clause,
    STATE(14527), 2,
      sym_block_comment,
      sym_line_comment,
  [311090] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16820), 1,
      anon_sym_RPAREN,
    ACTIONS(16822), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14712), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18101), 1,
      sym__comprehension_clause,
    STATE(14528), 2,
      sym_block_comment,
      sym_line_comment,
  [311119] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20315), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14529), 2,
      sym_block_comment,
      sym_line_comment,
  [311146] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20315), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14530), 2,
      sym_block_comment,
      sym_line_comment,
  [311173] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15250), 1,
      anon_sym_EQ,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(14531), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [311196] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20317), 1,
      anon_sym_end,
    STATE(14339), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18751), 1,
      sym_else_clause,
    STATE(14532), 2,
      sym_block_comment,
      sym_line_comment,
  [311225] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20319), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14533), 2,
      sym_block_comment,
      sym_line_comment,
  [311252] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20321), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14534), 2,
      sym_block_comment,
      sym_line_comment,
  [311279] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20321), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14535), 2,
      sym_block_comment,
      sym_line_comment,
  [311306] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20323), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14536), 2,
      sym_block_comment,
      sym_line_comment,
  [311333] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20319), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14537), 2,
      sym_block_comment,
      sym_line_comment,
  [311360] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20323), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14538), 2,
      sym_block_comment,
      sym_line_comment,
  [311387] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8524), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20325), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18018), 1,
      sym__comprehension_clause,
    STATE(14539), 2,
      sym_block_comment,
      sym_line_comment,
  [311416] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8772), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20327), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17860), 1,
      sym__comprehension_clause,
    STATE(14540), 2,
      sym_block_comment,
      sym_line_comment,
  [311445] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8546), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20329), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18957), 1,
      sym__comprehension_clause,
    STATE(14541), 2,
      sym_block_comment,
      sym_line_comment,
  [311474] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20259), 1,
      sym__end_str,
    STATE(14618), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14542), 2,
      sym_block_comment,
      sym_line_comment,
  [311501] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7150), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20331), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18283), 1,
      sym__comprehension_clause,
    STATE(14543), 2,
      sym_block_comment,
      sym_line_comment,
  [311530] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17211), 1,
      anon_sym_RPAREN,
    ACTIONS(17213), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14539), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17993), 1,
      sym__comprehension_clause,
    STATE(14544), 2,
      sym_block_comment,
      sym_line_comment,
  [311559] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20333), 1,
      sym__end_str,
    STATE(14581), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14545), 2,
      sym_block_comment,
      sym_line_comment,
  [311586] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20333), 1,
      sym__end_str,
    STATE(14602), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14546), 2,
      sym_block_comment,
      sym_line_comment,
  [311613] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14768), 1,
      anon_sym_DOLLAR,
    ACTIONS(18506), 1,
      sym__word_identifier,
    ACTIONS(19786), 1,
      anon_sym_COLON2,
    STATE(14547), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5953), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [311638] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16678), 1,
      anon_sym_RPAREN,
    ACTIONS(16680), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14643), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17772), 1,
      sym__comprehension_clause,
    STATE(14548), 2,
      sym_block_comment,
      sym_line_comment,
  [311667] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20335), 1,
      sym__end_cmd,
    STATE(14619), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14549), 2,
      sym_block_comment,
      sym_line_comment,
  [311694] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20335), 1,
      sym__end_cmd,
    STATE(14623), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14550), 2,
      sym_block_comment,
      sym_line_comment,
  [311721] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20337), 1,
      sym__end_cmd,
    STATE(14620), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14551), 2,
      sym_block_comment,
      sym_line_comment,
  [311748] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20337), 1,
      sym__end_cmd,
    STATE(14645), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14552), 2,
      sym_block_comment,
      sym_line_comment,
  [311775] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20339), 1,
      sym__immediate_string_start,
    ACTIONS(20341), 1,
      sym__immediate_command_start,
    STATE(14553), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [311798] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20343), 1,
      sym__end_str,
    STATE(14561), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14554), 2,
      sym_block_comment,
      sym_line_comment,
  [311825] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20343), 1,
      sym__end_str,
    STATE(14562), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14555), 2,
      sym_block_comment,
      sym_line_comment,
  [311852] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20345), 1,
      sym__end_cmd,
    STATE(14563), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14556), 2,
      sym_block_comment,
      sym_line_comment,
  [311879] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20345), 1,
      sym__end_cmd,
    STATE(14564), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14557), 2,
      sym_block_comment,
      sym_line_comment,
  [311906] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20295), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14558), 2,
      sym_block_comment,
      sym_line_comment,
  [311933] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16688), 1,
      anon_sym_RPAREN,
    ACTIONS(16690), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14850), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18043), 1,
      sym__comprehension_clause,
    STATE(14559), 2,
      sym_block_comment,
      sym_line_comment,
  [311962] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7256), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20347), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18122), 1,
      sym__comprehension_clause,
    STATE(14560), 2,
      sym_block_comment,
      sym_line_comment,
  [311991] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20349), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14561), 2,
      sym_block_comment,
      sym_line_comment,
  [312018] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20349), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14562), 2,
      sym_block_comment,
      sym_line_comment,
  [312045] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20351), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14563), 2,
      sym_block_comment,
      sym_line_comment,
  [312072] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20351), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14564), 2,
      sym_block_comment,
      sym_line_comment,
  [312099] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8544), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20353), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18113), 1,
      sym__comprehension_clause,
    STATE(14565), 2,
      sym_block_comment,
      sym_line_comment,
  [312128] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8564), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20355), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19241), 1,
      sym__comprehension_clause,
    STATE(14566), 2,
      sym_block_comment,
      sym_line_comment,
  [312157] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17151), 1,
      anon_sym_RPAREN,
    ACTIONS(17153), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14280), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17702), 1,
      sym__comprehension_clause,
    STATE(14567), 2,
      sym_block_comment,
      sym_line_comment,
  [312186] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17232), 1,
      anon_sym_RPAREN,
    ACTIONS(17234), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14565), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18076), 1,
      sym__comprehension_clause,
    STATE(14568), 2,
      sym_block_comment,
      sym_line_comment,
  [312215] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7388), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20357), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19386), 1,
      sym__comprehension_clause,
    STATE(14569), 2,
      sym_block_comment,
      sym_line_comment,
  [312244] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20359), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19515), 1,
      sym_else_clause,
    STATE(14570), 2,
      sym_block_comment,
      sym_line_comment,
  [312273] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8810), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20361), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18983), 1,
      sym__comprehension_clause,
    STATE(14571), 2,
      sym_block_comment,
      sym_line_comment,
  [312302] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20363), 1,
      sym__end_str,
    STATE(14584), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14572), 2,
      sym_block_comment,
      sym_line_comment,
  [312329] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20363), 1,
      sym__end_str,
    STATE(14585), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14573), 2,
      sym_block_comment,
      sym_line_comment,
  [312356] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20365), 1,
      sym__end_cmd,
    STATE(14588), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14574), 2,
      sym_block_comment,
      sym_line_comment,
  [312383] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20367), 1,
      sym__end_str,
    STATE(14586), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14575), 2,
      sym_block_comment,
      sym_line_comment,
  [312410] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20365), 1,
      sym__end_cmd,
    STATE(14593), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14576), 2,
      sym_block_comment,
      sym_line_comment,
  [312437] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20369), 1,
      anon_sym_end,
    STATE(14668), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18559), 1,
      sym_else_clause,
    STATE(14577), 2,
      sym_block_comment,
      sym_line_comment,
  [312466] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20367), 1,
      sym__end_str,
    STATE(14587), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14578), 2,
      sym_block_comment,
      sym_line_comment,
  [312493] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20371), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18564), 1,
      sym_else_clause,
    STATE(14579), 2,
      sym_block_comment,
      sym_line_comment,
  [312522] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    ACTIONS(20373), 1,
      anon_sym_DOLLAR,
    ACTIONS(20375), 1,
      anon_sym_COLON2,
    STATE(14580), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11690), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [312547] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20377), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14581), 2,
      sym_block_comment,
      sym_line_comment,
  [312574] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20379), 1,
      sym__end_cmd,
    STATE(14589), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14582), 2,
      sym_block_comment,
      sym_line_comment,
  [312601] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20379), 1,
      sym__end_cmd,
    STATE(14590), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14583), 2,
      sym_block_comment,
      sym_line_comment,
  [312628] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20381), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14584), 2,
      sym_block_comment,
      sym_line_comment,
  [312655] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20381), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14585), 2,
      sym_block_comment,
      sym_line_comment,
  [312682] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20383), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14586), 2,
      sym_block_comment,
      sym_line_comment,
  [312709] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20383), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14587), 2,
      sym_block_comment,
      sym_line_comment,
  [312736] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20385), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14588), 2,
      sym_block_comment,
      sym_line_comment,
  [312763] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20387), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14589), 2,
      sym_block_comment,
      sym_line_comment,
  [312790] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20387), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14590), 2,
      sym_block_comment,
      sym_line_comment,
  [312817] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7630), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20389), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17784), 1,
      sym__comprehension_clause,
    STATE(14591), 2,
      sym_block_comment,
      sym_line_comment,
  [312846] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7766), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20391), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18828), 1,
      sym__comprehension_clause,
    STATE(14592), 2,
      sym_block_comment,
      sym_line_comment,
  [312875] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20385), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14593), 2,
      sym_block_comment,
      sym_line_comment,
  [312902] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8562), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20393), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18191), 1,
      sym__comprehension_clause,
    STATE(14594), 2,
      sym_block_comment,
      sym_line_comment,
  [312931] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8586), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20395), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19501), 1,
      sym__comprehension_clause,
    STATE(14595), 2,
      sym_block_comment,
      sym_line_comment,
  [312960] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16340), 1,
      sym__word_identifier,
    ACTIONS(20397), 1,
      anon_sym_DOLLAR,
    ACTIONS(20399), 1,
      anon_sym_COLON2,
    STATE(14596), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8651), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [312985] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20401), 1,
      sym__end_str,
    STATE(14649), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14597), 2,
      sym_block_comment,
      sym_line_comment,
  [313012] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17143), 1,
      anon_sym_RPAREN,
    ACTIONS(17145), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14594), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18156), 1,
      sym__comprehension_clause,
    STATE(14598), 2,
      sym_block_comment,
      sym_line_comment,
  [313041] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20401), 1,
      sym__end_str,
    STATE(14651), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14599), 2,
      sym_block_comment,
      sym_line_comment,
  [313068] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20403), 1,
      sym__end_cmd,
    STATE(14652), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14600), 2,
      sym_block_comment,
      sym_line_comment,
  [313095] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20403), 1,
      sym__end_cmd,
    STATE(14653), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14601), 2,
      sym_block_comment,
      sym_line_comment,
  [313122] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20377), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14602), 2,
      sym_block_comment,
      sym_line_comment,
  [313149] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20405), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14603), 2,
      sym_block_comment,
      sym_line_comment,
  [313176] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(14604), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 6,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_DOT,
  [313195] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15408), 1,
      anon_sym_EQ,
    ACTIONS(17547), 1,
      aux_sym__terminator_token1,
    ACTIONS(17549), 1,
      aux_sym__terminator_token2,
    STATE(15288), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_end,
      anon_sym_finally,
    STATE(14605), 2,
      sym_block_comment,
      sym_line_comment,
  [313222] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20339), 1,
      sym__immediate_string_start,
    ACTIONS(20341), 1,
      sym__immediate_command_start,
    STATE(14606), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [313245] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20407), 1,
      sym__end_str,
    STATE(14625), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14607), 2,
      sym_block_comment,
      sym_line_comment,
  [313272] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20409), 1,
      sym__end_str,
    STATE(14626), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14608), 2,
      sym_block_comment,
      sym_line_comment,
  [313299] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20407), 1,
      sym__end_str,
    STATE(14627), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14609), 2,
      sym_block_comment,
      sym_line_comment,
  [313326] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20411), 1,
      sym__end_cmd,
    STATE(14628), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14610), 2,
      sym_block_comment,
      sym_line_comment,
  [313353] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20411), 1,
      sym__end_cmd,
    STATE(14630), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14611), 2,
      sym_block_comment,
      sym_line_comment,
  [313380] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20413), 1,
      sym__end_str,
    STATE(14654), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14612), 2,
      sym_block_comment,
      sym_line_comment,
  [313407] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20413), 1,
      sym__end_str,
    STATE(14656), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14613), 2,
      sym_block_comment,
      sym_line_comment,
  [313434] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20409), 1,
      sym__end_str,
    STATE(14631), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14614), 2,
      sym_block_comment,
      sym_line_comment,
  [313461] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20415), 1,
      sym__end_cmd,
    STATE(14637), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14615), 2,
      sym_block_comment,
      sym_line_comment,
  [313488] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20417), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18723), 1,
      sym_else_clause,
    STATE(14616), 2,
      sym_block_comment,
      sym_line_comment,
  [313517] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20415), 1,
      sym__end_cmd,
    STATE(14638), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14617), 2,
      sym_block_comment,
      sym_line_comment,
  [313544] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20405), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14618), 2,
      sym_block_comment,
      sym_line_comment,
  [313571] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20419), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14619), 2,
      sym_block_comment,
      sym_line_comment,
  [313598] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20421), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14620), 2,
      sym_block_comment,
      sym_line_comment,
  [313625] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20423), 1,
      sym__end_cmd,
    STATE(14657), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14621), 2,
      sym_block_comment,
      sym_line_comment,
  [313652] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20423), 1,
      sym__end_cmd,
    STATE(14658), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14622), 2,
      sym_block_comment,
      sym_line_comment,
  [313679] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20419), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14623), 2,
      sym_block_comment,
      sym_line_comment,
  [313706] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16955), 1,
      anon_sym_RPAREN,
    ACTIONS(16957), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14803), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17823), 1,
      sym__comprehension_clause,
    STATE(14624), 2,
      sym_block_comment,
      sym_line_comment,
  [313735] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20425), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14625), 2,
      sym_block_comment,
      sym_line_comment,
  [313762] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20427), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14626), 2,
      sym_block_comment,
      sym_line_comment,
  [313789] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20425), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14627), 2,
      sym_block_comment,
      sym_line_comment,
  [313816] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20429), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14628), 2,
      sym_block_comment,
      sym_line_comment,
  [313843] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(14629), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20431), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
  [313862] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20429), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14630), 2,
      sym_block_comment,
      sym_line_comment,
  [313889] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20427), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14631), 2,
      sym_block_comment,
      sym_line_comment,
  [313916] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20433), 1,
      sym__end_str,
    STATE(14811), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14632), 2,
      sym_block_comment,
      sym_line_comment,
  [313943] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20433), 1,
      sym__end_str,
    STATE(14812), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14633), 2,
      sym_block_comment,
      sym_line_comment,
  [313970] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6948), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20435), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17914), 1,
      sym__comprehension_clause,
    STATE(14634), 2,
      sym_block_comment,
      sym_line_comment,
  [313999] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7186), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20437), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18499), 1,
      sym__comprehension_clause,
    STATE(14635), 2,
      sym_block_comment,
      sym_line_comment,
  [314028] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14960), 1,
      anon_sym_DOLLAR,
    ACTIONS(18728), 1,
      sym__word_identifier,
    ACTIONS(19730), 1,
      anon_sym_COLON2,
    STATE(14636), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6336), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [314053] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20439), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14637), 2,
      sym_block_comment,
      sym_line_comment,
  [314080] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20439), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14638), 2,
      sym_block_comment,
      sym_line_comment,
  [314107] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8584), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20441), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17691), 1,
      sym__comprehension_clause,
    STATE(14639), 2,
      sym_block_comment,
      sym_line_comment,
  [314136] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8604), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20443), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19432), 1,
      sym__comprehension_clause,
    STATE(14640), 2,
      sym_block_comment,
      sym_line_comment,
  [314165] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20445), 1,
      sym__end_cmd,
    STATE(14813), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14641), 2,
      sym_block_comment,
      sym_line_comment,
  [314192] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20445), 1,
      sym__end_cmd,
    STATE(14814), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14642), 2,
      sym_block_comment,
      sym_line_comment,
  [314219] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7466), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20447), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17871), 1,
      sym__comprehension_clause,
    STATE(14643), 2,
      sym_block_comment,
      sym_line_comment,
  [314248] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7564), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20449), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18371), 1,
      sym__comprehension_clause,
    STATE(14644), 2,
      sym_block_comment,
      sym_line_comment,
  [314277] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20421), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14645), 2,
      sym_block_comment,
      sym_line_comment,
  [314304] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16883), 1,
      anon_sym_RPAREN,
    ACTIONS(16885), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14930), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18111), 1,
      sym__comprehension_clause,
    STATE(14646), 2,
      sym_block_comment,
      sym_line_comment,
  [314333] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18425), 1,
      sym__word_identifier,
    ACTIONS(20451), 1,
      anon_sym_DOLLAR,
    ACTIONS(20453), 1,
      anon_sym_COLON2,
    STATE(14647), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7619), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [314358] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17123), 1,
      anon_sym_RPAREN,
    ACTIONS(17125), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14639), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17676), 1,
      sym__comprehension_clause,
    STATE(14648), 2,
      sym_block_comment,
      sym_line_comment,
  [314387] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20455), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14649), 2,
      sym_block_comment,
      sym_line_comment,
  [314414] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20457), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18756), 1,
      sym_else_clause,
    STATE(14650), 2,
      sym_block_comment,
      sym_line_comment,
  [314443] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20455), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14651), 2,
      sym_block_comment,
      sym_line_comment,
  [314470] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20459), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14652), 2,
      sym_block_comment,
      sym_line_comment,
  [314497] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20459), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14653), 2,
      sym_block_comment,
      sym_line_comment,
  [314524] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20461), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14654), 2,
      sym_block_comment,
      sym_line_comment,
  [314551] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20463), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18082), 1,
      sym__comprehension_clause,
    STATE(14655), 2,
      sym_block_comment,
      sym_line_comment,
  [314580] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20461), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14656), 2,
      sym_block_comment,
      sym_line_comment,
  [314607] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20465), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14657), 2,
      sym_block_comment,
      sym_line_comment,
  [314634] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20465), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14658), 2,
      sym_block_comment,
      sym_line_comment,
  [314661] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20467), 1,
      anon_sym_DOLLAR,
    ACTIONS(20473), 1,
      sym__end_cmd,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(20470), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14659), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_command_literal_repeat1,
  [314686] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20475), 1,
      sym__end_str,
    STATE(14669), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14660), 2,
      sym_block_comment,
      sym_line_comment,
  [314713] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18710), 1,
      sym__word_identifier,
    STATE(16779), 1,
      sym_identifier,
    STATE(14661), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9782), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [314736] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20475), 1,
      sym__end_str,
    STATE(14671), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14662), 2,
      sym_block_comment,
      sym_line_comment,
  [314763] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20477), 1,
      sym__end_cmd,
    STATE(14674), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14663), 2,
      sym_block_comment,
      sym_line_comment,
  [314790] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20477), 1,
      sym__end_cmd,
    STATE(14677), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14664), 2,
      sym_block_comment,
      sym_line_comment,
  [314817] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10840), 1,
      aux_sym__terminator_token1,
    ACTIONS(17949), 1,
      anon_sym_COMMA,
    ACTIONS(10835), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
    STATE(14665), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
  [314840] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8250), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20479), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19157), 1,
      sym__comprehension_clause,
    STATE(14666), 2,
      sym_block_comment,
      sym_line_comment,
  [314869] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8022), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20481), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17944), 1,
      sym__comprehension_clause,
    STATE(14667), 2,
      sym_block_comment,
      sym_line_comment,
  [314898] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20483), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18804), 1,
      sym_else_clause,
    STATE(14668), 2,
      sym_block_comment,
      sym_line_comment,
  [314927] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20485), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14669), 2,
      sym_block_comment,
      sym_line_comment,
  [314954] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18710), 1,
      sym__word_identifier,
    STATE(16780), 1,
      sym_identifier,
    STATE(14670), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9786), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [314977] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20485), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14671), 2,
      sym_block_comment,
      sym_line_comment,
  [315004] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20487), 1,
      sym__end_str,
    STATE(14695), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14672), 2,
      sym_block_comment,
      sym_line_comment,
  [315031] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20487), 1,
      sym__end_str,
    STATE(14696), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14673), 2,
      sym_block_comment,
      sym_line_comment,
  [315058] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20489), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14674), 2,
      sym_block_comment,
      sym_line_comment,
  [315085] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20491), 1,
      sym__end_cmd,
    STATE(14698), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14675), 2,
      sym_block_comment,
      sym_line_comment,
  [315112] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20491), 1,
      sym__end_cmd,
    STATE(15108), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14676), 2,
      sym_block_comment,
      sym_line_comment,
  [315139] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20489), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14677), 2,
      sym_block_comment,
      sym_line_comment,
  [315166] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(20493), 1,
      anon_sym_DOLLAR,
    ACTIONS(20495), 1,
      anon_sym_COLON2,
    STATE(14678), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [315191] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8602), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20497), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17735), 1,
      sym__comprehension_clause,
    STATE(14679), 2,
      sym_block_comment,
      sym_line_comment,
  [315220] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8626), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20499), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19548), 1,
      sym__comprehension_clause,
    STATE(14680), 2,
      sym_block_comment,
      sym_line_comment,
  [315249] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8138), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20501), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18639), 1,
      sym__comprehension_clause,
    STATE(14681), 2,
      sym_block_comment,
      sym_line_comment,
  [315278] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20503), 1,
      anon_sym_DOLLAR,
    ACTIONS(20509), 1,
      sym__end_cmd,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(20506), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14682), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_command_literal_repeat2,
  [315303] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20511), 1,
      anon_sym_end,
    STATE(14711), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18683), 1,
      sym_else_clause,
    STATE(14683), 2,
      sym_block_comment,
      sym_line_comment,
  [315332] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16949), 1,
      anon_sym_RPAREN,
    ACTIONS(16951), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14679), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17711), 1,
      sym__comprehension_clause,
    STATE(14684), 2,
      sym_block_comment,
      sym_line_comment,
  [315361] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20513), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18685), 1,
      sym_else_clause,
    STATE(14685), 2,
      sym_block_comment,
      sym_line_comment,
  [315390] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6944), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20515), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17962), 1,
      sym__comprehension_clause,
    STATE(14686), 2,
      sym_block_comment,
      sym_line_comment,
  [315419] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20517), 1,
      sym__end_str,
    STATE(14691), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14687), 2,
      sym_block_comment,
      sym_line_comment,
  [315446] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20517), 1,
      sym__end_str,
    STATE(14692), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14688), 2,
      sym_block_comment,
      sym_line_comment,
  [315473] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20519), 1,
      sym__end_cmd,
    STATE(14693), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14689), 2,
      sym_block_comment,
      sym_line_comment,
  [315500] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20519), 1,
      sym__end_cmd,
    STATE(14705), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14690), 2,
      sym_block_comment,
      sym_line_comment,
  [315527] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20521), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14691), 2,
      sym_block_comment,
      sym_line_comment,
  [315554] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20521), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14692), 2,
      sym_block_comment,
      sym_line_comment,
  [315581] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20523), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14693), 2,
      sym_block_comment,
      sym_line_comment,
  [315608] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7740), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20525), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18717), 1,
      sym__comprehension_clause,
    STATE(14694), 2,
      sym_block_comment,
      sym_line_comment,
  [315637] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20527), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14695), 2,
      sym_block_comment,
      sym_line_comment,
  [315664] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20527), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14696), 2,
      sym_block_comment,
      sym_line_comment,
  [315691] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17117), 1,
      anon_sym_RPAREN,
    ACTIONS(17119), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14405), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18153), 1,
      sym__comprehension_clause,
    STATE(14697), 2,
      sym_block_comment,
      sym_line_comment,
  [315720] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20529), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14698), 2,
      sym_block_comment,
      sym_line_comment,
  [315747] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16464), 1,
      sym__word_identifier,
    ACTIONS(20531), 1,
      anon_sym_DOLLAR,
    ACTIONS(20533), 1,
      anon_sym_COLON2,
    STATE(14699), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6623), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [315772] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16744), 1,
      anon_sym_RPAREN,
    ACTIONS(16746), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14416), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18212), 1,
      sym__comprehension_clause,
    STATE(14700), 2,
      sym_block_comment,
      sym_line_comment,
  [315801] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20535), 1,
      sym__end_str,
    STATE(14714), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14701), 2,
      sym_block_comment,
      sym_line_comment,
  [315828] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16826), 1,
      anon_sym_RPAREN,
    ACTIONS(16828), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14777), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18123), 1,
      sym__comprehension_clause,
    STATE(14702), 2,
      sym_block_comment,
      sym_line_comment,
  [315857] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20537), 1,
      anon_sym_end,
    STATE(14834), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18330), 1,
      sym_else_clause,
    STATE(14703), 2,
      sym_block_comment,
      sym_line_comment,
  [315886] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7038), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20539), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18228), 1,
      sym__comprehension_clause,
    STATE(14704), 2,
      sym_block_comment,
      sym_line_comment,
  [315915] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20523), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14705), 2,
      sym_block_comment,
      sym_line_comment,
  [315942] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7220), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20541), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18794), 1,
      sym__comprehension_clause,
    STATE(14706), 2,
      sym_block_comment,
      sym_line_comment,
  [315971] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20543), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18350), 1,
      sym_else_clause,
    STATE(14707), 2,
      sym_block_comment,
      sym_line_comment,
  [316000] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20545), 1,
      sym__end_str,
    STATE(14725), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14708), 2,
      sym_block_comment,
      sym_line_comment,
  [316027] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16496), 1,
      sym__word_identifier,
    ACTIONS(20547), 1,
      anon_sym_DOLLAR,
    ACTIONS(20549), 1,
      anon_sym_COLON2,
    STATE(14709), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7183), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [316052] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20551), 1,
      anon_sym_end,
    STATE(14742), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18762), 1,
      sym_else_clause,
    STATE(14710), 2,
      sym_block_comment,
      sym_line_comment,
  [316081] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20553), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18764), 1,
      sym_else_clause,
    STATE(14711), 2,
      sym_block_comment,
      sym_line_comment,
  [316110] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7666), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20555), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18224), 1,
      sym__comprehension_clause,
    STATE(14712), 2,
      sym_block_comment,
      sym_line_comment,
  [316139] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7806), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20557), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19614), 1,
      sym__comprehension_clause,
    STATE(14713), 2,
      sym_block_comment,
      sym_line_comment,
  [316168] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20559), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14714), 2,
      sym_block_comment,
      sym_line_comment,
  [316195] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18504), 1,
      sym__word_identifier,
    ACTIONS(20561), 1,
      anon_sym_DOLLAR,
    ACTIONS(20563), 1,
      anon_sym_COLON2,
    STATE(14715), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7381), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [316220] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20559), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14716), 2,
      sym_block_comment,
      sym_line_comment,
  [316247] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17031), 1,
      anon_sym_RPAREN,
    ACTIONS(17033), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14892), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17788), 1,
      sym__comprehension_clause,
    STATE(14717), 2,
      sym_block_comment,
      sym_line_comment,
  [316276] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20545), 1,
      sym__end_str,
    STATE(14726), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14718), 2,
      sym_block_comment,
      sym_line_comment,
  [316303] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20565), 1,
      sym__end_cmd,
    STATE(14727), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14719), 2,
      sym_block_comment,
      sym_line_comment,
  [316330] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20565), 1,
      sym__end_cmd,
    STATE(14728), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14720), 2,
      sym_block_comment,
      sym_line_comment,
  [316357] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20567), 1,
      anon_sym_end,
    STATE(14897), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18575), 1,
      sym_else_clause,
    STATE(14721), 2,
      sym_block_comment,
      sym_line_comment,
  [316386] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14972), 1,
      anon_sym_DOLLAR,
    ACTIONS(18724), 1,
      sym__word_identifier,
    ACTIONS(19854), 1,
      anon_sym_COLON2,
    STATE(14722), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6408), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [316411] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18710), 1,
      sym__word_identifier,
    STATE(16789), 1,
      sym_identifier,
    STATE(14723), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9798), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [316434] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17075), 1,
      anon_sym_RPAREN,
    ACTIONS(17077), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14853), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18134), 1,
      sym__comprehension_clause,
    STATE(14724), 2,
      sym_block_comment,
      sym_line_comment,
  [316463] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20569), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14725), 2,
      sym_block_comment,
      sym_line_comment,
  [316490] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20569), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14726), 2,
      sym_block_comment,
      sym_line_comment,
  [316517] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20571), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14727), 2,
      sym_block_comment,
      sym_line_comment,
  [316544] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20571), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14728), 2,
      sym_block_comment,
      sym_line_comment,
  [316571] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8622), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20573), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17791), 1,
      sym__comprehension_clause,
    STATE(14729), 2,
      sym_block_comment,
      sym_line_comment,
  [316600] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8648), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20575), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18868), 1,
      sym__comprehension_clause,
    STATE(14730), 2,
      sym_block_comment,
      sym_line_comment,
  [316629] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17205), 1,
      anon_sym_RPAREN,
    ACTIONS(17207), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14885), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17973), 1,
      sym__comprehension_clause,
    STATE(14731), 2,
      sym_block_comment,
      sym_line_comment,
  [316658] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16858), 1,
      anon_sym_RPAREN,
    ACTIONS(16860), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14729), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17768), 1,
      sym__comprehension_clause,
    STATE(14732), 2,
      sym_block_comment,
      sym_line_comment,
  [316687] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(10833), 1,
      aux_sym__terminator_token1,
    ACTIONS(17735), 1,
      anon_sym_COMMA,
    STATE(14665), 1,
      aux_sym_open_tuple_repeat1,
    STATE(14733), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10829), 3,
      anon_sym_EQ,
      anon_sym_end,
      aux_sym__terminator_token2,
  [316712] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20577), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14734), 2,
      sym_block_comment,
      sym_line_comment,
  [316739] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20577), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14735), 2,
      sym_block_comment,
      sym_line_comment,
  [316766] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7896), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20579), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18027), 1,
      sym__comprehension_clause,
    STATE(14736), 2,
      sym_block_comment,
      sym_line_comment,
  [316795] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18712), 1,
      sym__word_identifier,
    ACTIONS(20581), 1,
      anon_sym_DOLLAR,
    ACTIONS(20583), 1,
      anon_sym_COLON2,
    STATE(14737), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7346), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [316820] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20585), 1,
      sym__end_str,
    STATE(14749), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14738), 2,
      sym_block_comment,
      sym_line_comment,
  [316847] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20585), 1,
      sym__end_str,
    STATE(14750), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14739), 2,
      sym_block_comment,
      sym_line_comment,
  [316874] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20587), 1,
      anon_sym_DOLLAR,
    ACTIONS(20589), 1,
      anon_sym_COLON2,
    STATE(14740), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [316899] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20591), 1,
      sym__end_cmd,
    STATE(14751), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14741), 2,
      sym_block_comment,
      sym_line_comment,
  [316926] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20593), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18815), 1,
      sym_else_clause,
    STATE(14742), 2,
      sym_block_comment,
      sym_line_comment,
  [316955] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20591), 1,
      sym__end_cmd,
    STATE(14752), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14743), 2,
      sym_block_comment,
      sym_line_comment,
  [316982] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20595), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14744), 2,
      sym_block_comment,
      sym_line_comment,
  [317009] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18710), 1,
      sym__word_identifier,
    STATE(16792), 1,
      sym_identifier,
    STATE(14745), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9802), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [317032] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20597), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14746), 2,
      sym_block_comment,
      sym_line_comment,
  [317059] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20597), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14747), 2,
      sym_block_comment,
      sym_line_comment,
  [317086] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20595), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14748), 2,
      sym_block_comment,
      sym_line_comment,
  [317113] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20599), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14749), 2,
      sym_block_comment,
      sym_line_comment,
  [317140] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20599), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14750), 2,
      sym_block_comment,
      sym_line_comment,
  [317167] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20601), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14751), 2,
      sym_block_comment,
      sym_line_comment,
  [317194] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20601), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14752), 2,
      sym_block_comment,
      sym_line_comment,
  [317221] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8642), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20603), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17859), 1,
      sym__comprehension_clause,
    STATE(14753), 2,
      sym_block_comment,
      sym_line_comment,
  [317250] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20605), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18276), 1,
      sym__comprehension_clause,
    STATE(14754), 2,
      sym_block_comment,
      sym_line_comment,
  [317279] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20607), 1,
      sym__end_str,
    STATE(14833), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14755), 2,
      sym_block_comment,
      sym_line_comment,
  [317306] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20609), 1,
      sym__end_str,
    STATE(14771), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14756), 2,
      sym_block_comment,
      sym_line_comment,
  [317333] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20611), 1,
      sym__end_str,
    STATE(14778), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14757), 2,
      sym_block_comment,
      sym_line_comment,
  [317360] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20611), 1,
      sym__end_str,
    STATE(14794), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14758), 2,
      sym_block_comment,
      sym_line_comment,
  [317387] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20609), 1,
      sym__end_str,
    STATE(14772), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14759), 2,
      sym_block_comment,
      sym_line_comment,
  [317414] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20613), 1,
      sym__end_cmd,
    STATE(14795), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14760), 2,
      sym_block_comment,
      sym_line_comment,
  [317441] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16877), 1,
      anon_sym_RPAREN,
    ACTIONS(16879), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14753), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17836), 1,
      sym__comprehension_clause,
    STATE(14761), 2,
      sym_block_comment,
      sym_line_comment,
  [317470] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20615), 1,
      sym__end_cmd,
    STATE(14774), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14762), 2,
      sym_block_comment,
      sym_line_comment,
  [317497] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20615), 1,
      sym__end_cmd,
    STATE(14775), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14763), 2,
      sym_block_comment,
      sym_line_comment,
  [317524] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20617), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14764), 2,
      sym_block_comment,
      sym_line_comment,
  [317551] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20607), 1,
      sym__end_str,
    STATE(14843), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14765), 2,
      sym_block_comment,
      sym_line_comment,
  [317578] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20617), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14766), 2,
      sym_block_comment,
      sym_line_comment,
  [317605] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20619), 1,
      sym__end_cmd,
    STATE(14865), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14767), 2,
      sym_block_comment,
      sym_line_comment,
  [317632] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20613), 1,
      sym__end_cmd,
    STATE(14799), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14768), 2,
      sym_block_comment,
      sym_line_comment,
  [317659] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20621), 1,
      sym__end_str,
    STATE(15034), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14769), 2,
      sym_block_comment,
      sym_line_comment,
  [317686] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20621), 1,
      sym__end_str,
    STATE(14296), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14770), 2,
      sym_block_comment,
      sym_line_comment,
  [317713] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20623), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14771), 2,
      sym_block_comment,
      sym_line_comment,
  [317740] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20623), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14772), 2,
      sym_block_comment,
      sym_line_comment,
  [317767] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20625), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14773), 2,
      sym_block_comment,
      sym_line_comment,
  [317794] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20627), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14774), 2,
      sym_block_comment,
      sym_line_comment,
  [317821] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20627), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14775), 2,
      sym_block_comment,
      sym_line_comment,
  [317848] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20629), 1,
      sym__end_cmd,
    STATE(14351), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14776), 2,
      sym_block_comment,
      sym_line_comment,
  [317875] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8228), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20631), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18139), 1,
      sym__comprehension_clause,
    STATE(14777), 2,
      sym_block_comment,
      sym_line_comment,
  [317904] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20633), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14778), 2,
      sym_block_comment,
      sym_line_comment,
  [317931] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20635), 1,
      sym__end_str,
    STATE(14835), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14779), 2,
      sym_block_comment,
      sym_line_comment,
  [317958] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20635), 1,
      sym__end_str,
    STATE(14836), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14780), 2,
      sym_block_comment,
      sym_line_comment,
  [317985] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20637), 1,
      sym__end_cmd,
    STATE(14838), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14781), 2,
      sym_block_comment,
      sym_line_comment,
  [318012] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20637), 1,
      sym__end_cmd,
    STATE(14839), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14782), 2,
      sym_block_comment,
      sym_line_comment,
  [318039] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8270), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20639), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19322), 1,
      sym__comprehension_clause,
    STATE(14783), 2,
      sym_block_comment,
      sym_line_comment,
  [318068] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20625), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14784), 2,
      sym_block_comment,
      sym_line_comment,
  [318095] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20641), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14785), 2,
      sym_block_comment,
      sym_line_comment,
  [318122] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20641), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14786), 2,
      sym_block_comment,
      sym_line_comment,
  [318149] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16979), 1,
      anon_sym_RPAREN,
    ACTIONS(16981), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14287), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17900), 1,
      sym__comprehension_clause,
    STATE(14787), 2,
      sym_block_comment,
      sym_line_comment,
  [318178] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20629), 1,
      sym__end_cmd,
    STATE(14355), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14788), 2,
      sym_block_comment,
      sym_line_comment,
  [318205] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16907), 1,
      anon_sym_RPAREN,
    ACTIONS(16909), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14974), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18010), 1,
      sym__comprehension_clause,
    STATE(14789), 2,
      sym_block_comment,
      sym_line_comment,
  [318234] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8834), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20643), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17928), 1,
      sym__comprehension_clause,
    STATE(14790), 2,
      sym_block_comment,
      sym_line_comment,
  [318263] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20645), 1,
      sym__end_str,
    STATE(14820), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14791), 2,
      sym_block_comment,
      sym_line_comment,
  [318290] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20647), 1,
      sym__end_str,
    STATE(14845), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14792), 2,
      sym_block_comment,
      sym_line_comment,
  [318317] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20645), 1,
      sym__end_str,
    STATE(14822), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14793), 2,
      sym_block_comment,
      sym_line_comment,
  [318344] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20633), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14794), 2,
      sym_block_comment,
      sym_line_comment,
  [318371] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20649), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14795), 2,
      sym_block_comment,
      sym_line_comment,
  [318398] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20647), 1,
      sym__end_str,
    STATE(14847), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14796), 2,
      sym_block_comment,
      sym_line_comment,
  [318425] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20651), 1,
      sym__end_cmd,
    STATE(14848), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14797), 2,
      sym_block_comment,
      sym_line_comment,
  [318452] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20653), 1,
      sym__end_cmd,
    STATE(14823), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14798), 2,
      sym_block_comment,
      sym_line_comment,
  [318479] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20649), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14799), 2,
      sym_block_comment,
      sym_line_comment,
  [318506] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20653), 1,
      sym__end_cmd,
    STATE(14827), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14800), 2,
      sym_block_comment,
      sym_line_comment,
  [318533] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20651), 1,
      sym__end_cmd,
    STATE(14849), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14801), 2,
      sym_block_comment,
      sym_line_comment,
  [318560] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16844), 1,
      anon_sym_RPAREN,
    ACTIONS(16846), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14880), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18152), 1,
      sym__comprehension_clause,
    STATE(14802), 2,
      sym_block_comment,
      sym_line_comment,
  [318589] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7700), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20655), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17969), 1,
      sym__comprehension_clause,
    STATE(14803), 2,
      sym_block_comment,
      sym_line_comment,
  [318618] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7854), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20657), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18903), 1,
      sym__comprehension_clause,
    STATE(14804), 2,
      sym_block_comment,
      sym_line_comment,
  [318647] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18508), 1,
      sym__word_identifier,
    ACTIONS(20659), 1,
      anon_sym_DOLLAR,
    ACTIONS(20661), 1,
      anon_sym_COLON2,
    STATE(14805), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9145), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [318672] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20619), 1,
      sym__end_cmd,
    STATE(14882), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14806), 2,
      sym_block_comment,
      sym_line_comment,
  [318699] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17105), 1,
      anon_sym_RPAREN,
    ACTIONS(17107), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14966), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17897), 1,
      sym__comprehension_clause,
    STATE(14807), 2,
      sym_block_comment,
      sym_line_comment,
  [318728] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20249), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14808), 2,
      sym_block_comment,
      sym_line_comment,
  [318755] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20663), 1,
      anon_sym_end,
    STATE(14946), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18312), 1,
      sym_else_clause,
    STATE(14809), 2,
      sym_block_comment,
      sym_line_comment,
  [318784] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17131), 1,
      aux_sym__terminator_token1,
    ACTIONS(17133), 1,
      aux_sym__terminator_token2,
    STATE(15078), 1,
      aux_sym__block_repeat1,
    STATE(14810), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16919), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [318809] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20665), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14811), 2,
      sym_block_comment,
      sym_line_comment,
  [318836] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20665), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14812), 2,
      sym_block_comment,
      sym_line_comment,
  [318863] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20667), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14813), 2,
      sym_block_comment,
      sym_line_comment,
  [318890] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20667), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14814), 2,
      sym_block_comment,
      sym_line_comment,
  [318917] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20669), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18349), 1,
      sym_else_clause,
    STATE(14815), 2,
      sym_block_comment,
      sym_line_comment,
  [318946] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20671), 1,
      sym__end_str,
    STATE(14907), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14816), 2,
      sym_block_comment,
      sym_line_comment,
  [318973] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20673), 1,
      sym__end_str,
    STATE(15057), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14817), 2,
      sym_block_comment,
      sym_line_comment,
  [319000] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20675), 1,
      sym__end_str,
    STATE(14297), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14818), 2,
      sym_block_comment,
      sym_line_comment,
  [319027] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20671), 1,
      sym__end_str,
    STATE(14316), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14819), 2,
      sym_block_comment,
      sym_line_comment,
  [319054] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20677), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14820), 2,
      sym_block_comment,
      sym_line_comment,
  [319081] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20679), 1,
      sym__end_str,
    STATE(14891), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14821), 2,
      sym_block_comment,
      sym_line_comment,
  [319108] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20677), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14822), 2,
      sym_block_comment,
      sym_line_comment,
  [319135] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20681), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14823), 2,
      sym_block_comment,
      sym_line_comment,
  [319162] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20679), 1,
      sym__end_str,
    STATE(14914), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14824), 2,
      sym_block_comment,
      sym_line_comment,
  [319189] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20683), 1,
      sym__end_cmd,
    STATE(14915), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14825), 2,
      sym_block_comment,
      sym_line_comment,
  [319216] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20683), 1,
      sym__end_cmd,
    STATE(14944), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14826), 2,
      sym_block_comment,
      sym_line_comment,
  [319243] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20681), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14827), 2,
      sym_block_comment,
      sym_line_comment,
  [319270] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20675), 1,
      sym__end_str,
    STATE(14305), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14828), 2,
      sym_block_comment,
      sym_line_comment,
  [319297] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20685), 1,
      sym__end_str,
    STATE(14856), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14829), 2,
      sym_block_comment,
      sym_line_comment,
  [319324] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20685), 1,
      sym__end_str,
    STATE(14874), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14830), 2,
      sym_block_comment,
      sym_line_comment,
  [319351] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20687), 1,
      sym__end_cmd,
    STATE(14889), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14831), 2,
      sym_block_comment,
      sym_line_comment,
  [319378] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20687), 1,
      sym__end_cmd,
    STATE(14890), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14832), 2,
      sym_block_comment,
      sym_line_comment,
  [319405] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20689), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14833), 2,
      sym_block_comment,
      sym_line_comment,
  [319432] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20691), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18706), 1,
      sym_else_clause,
    STATE(14834), 2,
      sym_block_comment,
      sym_line_comment,
  [319461] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20693), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14835), 2,
      sym_block_comment,
      sym_line_comment,
  [319488] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20693), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14836), 2,
      sym_block_comment,
      sym_line_comment,
  [319515] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17956), 1,
      anon_sym_COMMA,
    ACTIONS(10835), 2,
      anon_sym_EQ,
      aux_sym__terminator_token2,
    ACTIONS(10840), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(14837), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
  [319538] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20695), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14838), 2,
      sym_block_comment,
      sym_line_comment,
  [319565] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20695), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14839), 2,
      sym_block_comment,
      sym_line_comment,
  [319592] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20697), 1,
      sym__end_str,
    STATE(14972), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14840), 2,
      sym_block_comment,
      sym_line_comment,
  [319619] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8056), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20699), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17830), 1,
      sym__comprehension_clause,
    STATE(14841), 2,
      sym_block_comment,
      sym_line_comment,
  [319648] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7600), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20701), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19453), 1,
      sym__comprehension_clause,
    STATE(14842), 2,
      sym_block_comment,
      sym_line_comment,
  [319677] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20689), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14843), 2,
      sym_block_comment,
      sym_line_comment,
  [319704] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20703), 1,
      sym__end_cmd,
    STATE(14307), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14844), 2,
      sym_block_comment,
      sym_line_comment,
  [319731] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20705), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14845), 2,
      sym_block_comment,
      sym_line_comment,
  [319758] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20703), 1,
      sym__end_cmd,
    STATE(14311), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14846), 2,
      sym_block_comment,
      sym_line_comment,
  [319785] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20705), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14847), 2,
      sym_block_comment,
      sym_line_comment,
  [319812] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20707), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14848), 2,
      sym_block_comment,
      sym_line_comment,
  [319839] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20707), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14849), 2,
      sym_block_comment,
      sym_line_comment,
  [319866] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7096), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20709), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18052), 1,
      sym__comprehension_clause,
    STATE(14850), 2,
      sym_block_comment,
      sym_line_comment,
  [319895] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14654), 1,
      anon_sym_DOLLAR,
    ACTIONS(18500), 1,
      sym__word_identifier,
    ACTIONS(19814), 1,
      anon_sym_COLON2,
    STATE(14851), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7700), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [319920] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16923), 1,
      aux_sym__terminator_token1,
    ACTIONS(16925), 1,
      aux_sym__terminator_token2,
    STATE(14918), 1,
      aux_sym__block_repeat1,
    STATE(14852), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(16919), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
  [319945] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7182), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20711), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18031), 1,
      sym__comprehension_clause,
    STATE(14853), 2,
      sym_block_comment,
      sym_line_comment,
  [319974] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7260), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20713), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19080), 1,
      sym__comprehension_clause,
    STATE(14854), 2,
      sym_block_comment,
      sym_line_comment,
  [320003] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20715), 1,
      sym__end_str,
    STATE(14868), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14855), 2,
      sym_block_comment,
      sym_line_comment,
  [320030] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20717), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14856), 2,
      sym_block_comment,
      sym_line_comment,
  [320057] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20715), 1,
      sym__end_str,
    STATE(14875), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14857), 2,
      sym_block_comment,
      sym_line_comment,
  [320084] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18720), 1,
      sym__word_identifier,
    ACTIONS(20719), 1,
      anon_sym_DOLLAR,
    ACTIONS(20721), 1,
      anon_sym_COLON2,
    STATE(14858), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8016), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [320109] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20723), 1,
      anon_sym_DOLLAR,
    ACTIONS(20725), 1,
      anon_sym_COLON2,
    STATE(14859), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [320134] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20727), 1,
      sym__end_cmd,
    STATE(14878), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14860), 2,
      sym_block_comment,
      sym_line_comment,
  [320161] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20729), 1,
      anon_sym_COMMA,
    STATE(14863), 1,
      aux_sym_for_statement_repeat1,
    STATE(14861), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20255), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [320184] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20697), 1,
      sym__end_str,
    STATE(15010), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14862), 2,
      sym_block_comment,
      sym_line_comment,
  [320211] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20729), 1,
      anon_sym_COMMA,
    STATE(14883), 1,
      aux_sym_for_statement_repeat1,
    STATE(14863), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20731), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [320234] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20727), 1,
      sym__end_cmd,
    STATE(14879), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14864), 2,
      sym_block_comment,
      sym_line_comment,
  [320261] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20733), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14865), 2,
      sym_block_comment,
      sym_line_comment,
  [320288] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20735), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14866), 2,
      sym_block_comment,
      sym_line_comment,
  [320315] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17157), 1,
      anon_sym_RPAREN,
    ACTIONS(17159), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15090), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18214), 1,
      sym__comprehension_clause,
    STATE(14867), 2,
      sym_block_comment,
      sym_line_comment,
  [320344] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20737), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14868), 2,
      sym_block_comment,
      sym_line_comment,
  [320371] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20739), 1,
      sym__end_str,
    STATE(14945), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14869), 2,
      sym_block_comment,
      sym_line_comment,
  [320398] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20739), 1,
      sym__end_str,
    STATE(14948), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14870), 2,
      sym_block_comment,
      sym_line_comment,
  [320425] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20741), 1,
      sym__end_cmd,
    STATE(14949), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14871), 2,
      sym_block_comment,
      sym_line_comment,
  [320452] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20741), 1,
      sym__end_cmd,
    STATE(14950), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14872), 2,
      sym_block_comment,
      sym_line_comment,
  [320479] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16895), 1,
      anon_sym_RPAREN,
    ACTIONS(16897), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14468), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18084), 1,
      sym__comprehension_clause,
    STATE(14873), 2,
      sym_block_comment,
      sym_line_comment,
  [320508] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20717), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14874), 2,
      sym_block_comment,
      sym_line_comment,
  [320535] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20737), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14875), 2,
      sym_block_comment,
      sym_line_comment,
  [320562] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20743), 1,
      anon_sym_DOLLAR,
    ACTIONS(20745), 1,
      anon_sym_COLON2,
    STATE(14876), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [320587] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17163), 1,
      anon_sym_RPAREN,
    ACTIONS(17165), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14736), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18195), 1,
      sym__comprehension_clause,
    STATE(14877), 2,
      sym_block_comment,
      sym_line_comment,
  [320616] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20747), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14878), 2,
      sym_block_comment,
      sym_line_comment,
  [320643] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20747), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14879), 2,
      sym_block_comment,
      sym_line_comment,
  [320670] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8248), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20749), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18173), 1,
      sym__comprehension_clause,
    STATE(14880), 2,
      sym_block_comment,
      sym_line_comment,
  [320699] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8308), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20751), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19441), 1,
      sym__comprehension_clause,
    STATE(14881), 2,
      sym_block_comment,
      sym_line_comment,
  [320728] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20733), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14882), 2,
      sym_block_comment,
      sym_line_comment,
  [320755] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20753), 1,
      anon_sym_COMMA,
    STATE(14883), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_for_statement_repeat1,
    ACTIONS(12962), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [320776] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16867), 1,
      anon_sym_RPAREN,
    ACTIONS(16869), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15018), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18221), 1,
      sym__comprehension_clause,
    STATE(14884), 2,
      sym_block_comment,
      sym_line_comment,
  [320805] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8096), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20756), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17989), 1,
      sym__comprehension_clause,
    STATE(14885), 2,
      sym_block_comment,
      sym_line_comment,
  [320834] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20758), 1,
      anon_sym_DOLLAR,
    ACTIONS(20760), 1,
      anon_sym_COLON2,
    STATE(14886), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [320859] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20762), 1,
      anon_sym_end,
    STATE(14485), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19455), 1,
      sym_else_clause,
    STATE(14887), 2,
      sym_block_comment,
      sym_line_comment,
  [320888] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20764), 1,
      anon_sym_end,
    STATE(14932), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19228), 1,
      sym_else_clause,
    STATE(14888), 2,
      sym_block_comment,
      sym_line_comment,
  [320917] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20766), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14889), 2,
      sym_block_comment,
      sym_line_comment,
  [320944] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20766), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14890), 2,
      sym_block_comment,
      sym_line_comment,
  [320971] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20768), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14891), 2,
      sym_block_comment,
      sym_line_comment,
  [320998] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7738), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20770), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17811), 1,
      sym__comprehension_clause,
    STATE(14892), 2,
      sym_block_comment,
      sym_line_comment,
  [321027] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8180), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20772), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18829), 1,
      sym__comprehension_clause,
    STATE(14893), 2,
      sym_block_comment,
      sym_line_comment,
  [321056] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20774), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19230), 1,
      sym_else_clause,
    STATE(14894), 2,
      sym_block_comment,
      sym_line_comment,
  [321085] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20776), 1,
      anon_sym_DOLLAR,
    ACTIONS(20778), 1,
      anon_sym_COLON2,
    STATE(14895), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [321110] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7900), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20780), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19247), 1,
      sym__comprehension_clause,
    STATE(14896), 2,
      sym_block_comment,
      sym_line_comment,
  [321139] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20782), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18861), 1,
      sym_else_clause,
    STATE(14897), 2,
      sym_block_comment,
      sym_line_comment,
  [321168] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20784), 1,
      anon_sym_DOLLAR,
    ACTIONS(20786), 1,
      anon_sym_COLON2,
    STATE(14898), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [321193] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20535), 1,
      sym__end_str,
    STATE(14716), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14899), 2,
      sym_block_comment,
      sym_line_comment,
  [321220] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20788), 1,
      sym__end_str,
    STATE(14920), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14900), 2,
      sym_block_comment,
      sym_line_comment,
  [321247] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20790), 1,
      anon_sym_DOLLAR,
    ACTIONS(20792), 1,
      anon_sym_COLON2,
    STATE(14901), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [321272] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20788), 1,
      sym__end_str,
    STATE(14928), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14902), 2,
      sym_block_comment,
      sym_line_comment,
  [321299] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20794), 1,
      sym__end_cmd,
    STATE(14929), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14903), 2,
      sym_block_comment,
      sym_line_comment,
  [321326] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20794), 1,
      sym__end_cmd,
    STATE(14934), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14904), 2,
      sym_block_comment,
      sym_line_comment,
  [321353] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16901), 1,
      anon_sym_RPAREN,
    ACTIONS(16903), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15025), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18012), 1,
      sym__comprehension_clause,
    STATE(14905), 2,
      sym_block_comment,
      sym_line_comment,
  [321382] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20673), 1,
      sym__end_str,
    STATE(14317), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14906), 2,
      sym_block_comment,
      sym_line_comment,
  [321409] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20027), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14907), 2,
      sym_block_comment,
      sym_line_comment,
  [321436] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20796), 1,
      sym__end_str,
    STATE(14919), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14908), 2,
      sym_block_comment,
      sym_line_comment,
  [321463] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20796), 1,
      sym__end_str,
    STATE(14921), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14909), 2,
      sym_block_comment,
      sym_line_comment,
  [321490] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20798), 1,
      sym__end_cmd,
    STATE(14923), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14910), 2,
      sym_block_comment,
      sym_line_comment,
  [321517] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20798), 1,
      sym__end_cmd,
    STATE(14925), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14911), 2,
      sym_block_comment,
      sym_line_comment,
  [321544] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(20800), 1,
      anon_sym_DOLLAR,
    ACTIONS(20802), 1,
      anon_sym_COLON2,
    STATE(14912), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [321569] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20804), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18875), 1,
      sym_else_clause,
    STATE(14913), 2,
      sym_block_comment,
      sym_line_comment,
  [321598] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20768), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14914), 2,
      sym_block_comment,
      sym_line_comment,
  [321625] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20806), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14915), 2,
      sym_block_comment,
      sym_line_comment,
  [321652] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7228), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20808), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18115), 1,
      sym__comprehension_clause,
    STATE(14916), 2,
      sym_block_comment,
      sym_line_comment,
  [321681] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8094), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20810), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19251), 1,
      sym__comprehension_clause,
    STATE(14917), 2,
      sym_block_comment,
      sym_line_comment,
  [321710] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(20812), 1,
      aux_sym__terminator_token1,
    ACTIONS(20814), 1,
      aux_sym__terminator_token2,
    STATE(15028), 1,
      aux_sym__block_repeat1,
    STATE(14918), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5134), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
  [321735] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20816), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14919), 2,
      sym_block_comment,
      sym_line_comment,
  [321762] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20818), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14920), 2,
      sym_block_comment,
      sym_line_comment,
  [321789] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20816), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14921), 2,
      sym_block_comment,
      sym_line_comment,
  [321816] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15028), 1,
      anon_sym_DOLLAR,
    ACTIONS(18716), 1,
      sym__word_identifier,
    ACTIONS(19840), 1,
      anon_sym_COLON2,
    STATE(14922), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6148), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [321841] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20820), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14923), 2,
      sym_block_comment,
      sym_line_comment,
  [321868] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20822), 1,
      anon_sym_end,
    STATE(15074), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18961), 1,
      sym_else_clause,
    STATE(14924), 2,
      sym_block_comment,
      sym_line_comment,
  [321897] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20820), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14925), 2,
      sym_block_comment,
      sym_line_comment,
  [321924] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20824), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19118), 1,
      sym_else_clause,
    STATE(14926), 2,
      sym_block_comment,
      sym_line_comment,
  [321953] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17081), 1,
      anon_sym_RPAREN,
    ACTIONS(17083), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14967), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17818), 1,
      sym__comprehension_clause,
    STATE(14927), 2,
      sym_block_comment,
      sym_line_comment,
  [321982] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20818), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14928), 2,
      sym_block_comment,
      sym_line_comment,
  [322009] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20826), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14929), 2,
      sym_block_comment,
      sym_line_comment,
  [322036] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20828), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18147), 1,
      sym__comprehension_clause,
    STATE(14930), 2,
      sym_block_comment,
      sym_line_comment,
  [322065] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20830), 1,
      anon_sym_end,
    STATE(14947), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19285), 1,
      sym_else_clause,
    STATE(14931), 2,
      sym_block_comment,
      sym_line_comment,
  [322094] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20832), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19287), 1,
      sym_else_clause,
    STATE(14932), 2,
      sym_block_comment,
      sym_line_comment,
  [322123] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7294), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20834), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19369), 1,
      sym__comprehension_clause,
    STATE(14933), 2,
      sym_block_comment,
      sym_line_comment,
  [322152] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20826), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14934), 2,
      sym_block_comment,
      sym_line_comment,
  [322179] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18355), 1,
      sym__word_identifier,
    ACTIONS(20836), 1,
      anon_sym_DOLLAR,
    ACTIONS(20838), 1,
      anon_sym_COLON2,
    STATE(14935), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(18165), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [322204] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6986), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20840), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18200), 1,
      sym__comprehension_clause,
    STATE(14936), 2,
      sym_block_comment,
      sym_line_comment,
  [322233] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8328), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20842), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19527), 1,
      sym__comprehension_clause,
    STATE(14937), 2,
      sym_block_comment,
      sym_line_comment,
  [322262] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16774), 1,
      anon_sym_RPAREN,
    ACTIONS(16776), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15104), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17967), 1,
      sym__comprehension_clause,
    STATE(14938), 2,
      sym_block_comment,
      sym_line_comment,
  [322291] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20251), 1,
      sym__end_cmd,
    STATE(14866), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14939), 2,
      sym_block_comment,
      sym_line_comment,
  [322318] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20844), 1,
      sym__end_str,
    STATE(14957), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14940), 2,
      sym_block_comment,
      sym_line_comment,
  [322345] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20844), 1,
      sym__end_str,
    STATE(14960), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14941), 2,
      sym_block_comment,
      sym_line_comment,
  [322372] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20846), 1,
      sym__end_cmd,
    STATE(14962), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14942), 2,
      sym_block_comment,
      sym_line_comment,
  [322399] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20846), 1,
      sym__end_cmd,
    STATE(14964), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14943), 2,
      sym_block_comment,
      sym_line_comment,
  [322426] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20806), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14944), 2,
      sym_block_comment,
      sym_line_comment,
  [322453] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20848), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14945), 2,
      sym_block_comment,
      sym_line_comment,
  [322480] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20850), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19468), 1,
      sym_else_clause,
    STATE(14946), 2,
      sym_block_comment,
      sym_line_comment,
  [322509] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20852), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19300), 1,
      sym_else_clause,
    STATE(14947), 2,
      sym_block_comment,
      sym_line_comment,
  [322538] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20848), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14948), 2,
      sym_block_comment,
      sym_line_comment,
  [322565] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20854), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14949), 2,
      sym_block_comment,
      sym_line_comment,
  [322592] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20854), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14950), 2,
      sym_block_comment,
      sym_line_comment,
  [322619] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20856), 1,
      sym__end_cmd,
    STATE(14334), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14951), 2,
      sym_block_comment,
      sym_line_comment,
  [322646] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20858), 1,
      anon_sym_end,
    STATE(14579), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18278), 1,
      sym_else_clause,
    STATE(14952), 2,
      sym_block_comment,
      sym_line_comment,
  [322675] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20860), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18282), 1,
      sym_else_clause,
    STATE(14953), 2,
      sym_block_comment,
      sym_line_comment,
  [322704] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20856), 1,
      sym__end_cmd,
    STATE(14336), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14954), 2,
      sym_block_comment,
      sym_line_comment,
  [322731] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20862), 1,
      anon_sym_end,
    STATE(15042), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18273), 1,
      sym_else_clause,
    STATE(14955), 2,
      sym_block_comment,
      sym_line_comment,
  [322760] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20864), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18281), 1,
      sym_else_clause,
    STATE(14956), 2,
      sym_block_comment,
      sym_line_comment,
  [322789] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20866), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14957), 2,
      sym_block_comment,
      sym_line_comment,
  [322816] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17244), 1,
      anon_sym_RPAREN,
    ACTIONS(17246), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14560), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17977), 1,
      sym__comprehension_clause,
    STATE(14958), 2,
      sym_block_comment,
      sym_line_comment,
  [322845] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20868), 1,
      sym__end_str,
    STATE(14373), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14959), 2,
      sym_block_comment,
      sym_line_comment,
  [322872] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20866), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14960), 2,
      sym_block_comment,
      sym_line_comment,
  [322899] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7932), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20870), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17850), 1,
      sym__comprehension_clause,
    STATE(14961), 2,
      sym_block_comment,
      sym_line_comment,
  [322928] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20872), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14962), 2,
      sym_block_comment,
      sym_line_comment,
  [322955] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20874), 1,
      sym__end_str,
    STATE(14282), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14963), 2,
      sym_block_comment,
      sym_line_comment,
  [322982] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20872), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14964), 2,
      sym_block_comment,
      sym_line_comment,
  [323009] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20874), 1,
      sym__end_str,
    STATE(14283), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14965), 2,
      sym_block_comment,
      sym_line_comment,
  [323036] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7800), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20876), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17931), 1,
      sym__comprehension_clause,
    STATE(14966), 2,
      sym_block_comment,
      sym_line_comment,
  [323065] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6988), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20878), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17869), 1,
      sym__comprehension_clause,
    STATE(14967), 2,
      sym_block_comment,
      sym_line_comment,
  [323094] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6998), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20880), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18336), 1,
      sym__comprehension_clause,
    STATE(14968), 2,
      sym_block_comment,
      sym_line_comment,
  [323123] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7936), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20882), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18598), 1,
      sym__comprehension_clause,
    STATE(14969), 2,
      sym_block_comment,
      sym_line_comment,
  [323152] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16913), 1,
      anon_sym_RPAREN,
    ACTIONS(16915), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14303), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17843), 1,
      sym__comprehension_clause,
    STATE(14970), 2,
      sym_block_comment,
      sym_line_comment,
  [323181] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20884), 1,
      sym__end_cmd,
    STATE(14284), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14971), 2,
      sym_block_comment,
      sym_line_comment,
  [323208] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20886), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14972), 2,
      sym_block_comment,
      sym_line_comment,
  [323235] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20884), 1,
      sym__end_cmd,
    STATE(14285), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14973), 2,
      sym_block_comment,
      sym_line_comment,
  [323262] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7326), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20888), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18121), 1,
      sym__comprehension_clause,
    STATE(14974), 2,
      sym_block_comment,
      sym_line_comment,
  [323291] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8644), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20890), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18318), 1,
      sym__comprehension_clause,
    STATE(14975), 2,
      sym_block_comment,
      sym_line_comment,
  [323320] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20868), 1,
      sym__end_str,
    STATE(14384), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14976), 2,
      sym_block_comment,
      sym_line_comment,
  [323347] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7474), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20892), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19268), 1,
      sym__comprehension_clause,
    STATE(14977), 2,
      sym_block_comment,
      sym_line_comment,
  [323376] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16782), 1,
      anon_sym_RPAREN,
    ACTIONS(16784), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(15063), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18217), 1,
      sym__comprehension_clause,
    STATE(14978), 2,
      sym_block_comment,
      sym_line_comment,
  [323405] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20894), 1,
      sym__end_cmd,
    STATE(14401), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14979), 2,
      sym_block_comment,
      sym_line_comment,
  [323432] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    ACTIONS(20896), 1,
      anon_sym_DOLLAR,
    ACTIONS(20898), 1,
      anon_sym_COLON2,
    STATE(14980), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10495), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [323457] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16354), 1,
      sym__word_identifier,
    ACTIONS(20900), 1,
      anon_sym_DOLLAR,
    ACTIONS(20902), 1,
      anon_sym_COLON2,
    STATE(14981), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6698), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [323482] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20904), 1,
      sym__end_str,
    STATE(15075), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14982), 2,
      sym_block_comment,
      sym_line_comment,
  [323509] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20906), 1,
      sym__end_cmd,
    STATE(14512), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14983), 2,
      sym_block_comment,
      sym_line_comment,
  [323536] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16850), 1,
      anon_sym_RPAREN,
    ACTIONS(16852), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14992), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17964), 1,
      sym__comprehension_clause,
    STATE(14984), 2,
      sym_block_comment,
      sym_line_comment,
  [323565] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20908), 1,
      sym__end_str,
    STATE(14773), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14985), 2,
      sym_block_comment,
      sym_line_comment,
  [323592] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20908), 1,
      sym__end_str,
    STATE(14784), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14986), 2,
      sym_block_comment,
      sym_line_comment,
  [323619] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20904), 1,
      sym__end_str,
    STATE(14298), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14987), 2,
      sym_block_comment,
      sym_line_comment,
  [323646] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20910), 1,
      sym__end_str,
    STATE(14764), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14988), 2,
      sym_block_comment,
      sym_line_comment,
  [323673] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20910), 1,
      sym__end_str,
    STATE(14766), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14989), 2,
      sym_block_comment,
      sym_line_comment,
  [323700] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20912), 1,
      sym__end_cmd,
    STATE(14306), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14990), 2,
      sym_block_comment,
      sym_line_comment,
  [323727] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20914), 1,
      sym__end_str,
    STATE(15014), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(14991), 2,
      sym_block_comment,
      sym_line_comment,
  [323754] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7424), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20916), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17851), 1,
      sym__comprehension_clause,
    STATE(14992), 2,
      sym_block_comment,
      sym_line_comment,
  [323783] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20918), 1,
      sym__end_cmd,
    STATE(14785), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14993), 2,
      sym_block_comment,
      sym_line_comment,
  [323810] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6884), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20920), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17946), 1,
      sym__comprehension_clause,
    STATE(14994), 2,
      sym_block_comment,
      sym_line_comment,
  [323839] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20922), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18329), 1,
      sym_else_clause,
    STATE(14995), 2,
      sym_block_comment,
      sym_line_comment,
  [323868] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20914), 1,
      sym__end_str,
    STATE(15015), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(14996), 2,
      sym_block_comment,
      sym_line_comment,
  [323895] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20924), 1,
      sym__end_cmd,
    STATE(15016), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14997), 2,
      sym_block_comment,
      sym_line_comment,
  [323922] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20924), 1,
      sym__end_cmd,
    STATE(15017), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(14998), 2,
      sym_block_comment,
      sym_line_comment,
  [323949] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20926), 1,
      sym__end_cmd,
    STATE(14808), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(14999), 2,
      sym_block_comment,
      sym_line_comment,
  [323976] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6912), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20928), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18294), 1,
      sym__comprehension_clause,
    STATE(15000), 2,
      sym_block_comment,
      sym_line_comment,
  [324005] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20918), 1,
      sym__end_cmd,
    STATE(14786), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15001), 2,
      sym_block_comment,
      sym_line_comment,
  [324032] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20253), 1,
      anon_sym_COMMA,
    STATE(15052), 1,
      aux_sym_for_statement_repeat1,
    STATE(15002), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(20731), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [324055] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20930), 1,
      sym__end_str,
    STATE(15020), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15003), 2,
      sym_block_comment,
      sym_line_comment,
  [324082] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20930), 1,
      sym__end_str,
    STATE(15021), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15004), 2,
      sym_block_comment,
      sym_line_comment,
  [324109] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20932), 1,
      sym__end_str,
    STATE(15029), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15005), 2,
      sym_block_comment,
      sym_line_comment,
  [324136] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20932), 1,
      sym__end_str,
    STATE(15030), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15006), 2,
      sym_block_comment,
      sym_line_comment,
  [324163] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20934), 1,
      sym__end_cmd,
    STATE(15031), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15007), 2,
      sym_block_comment,
      sym_line_comment,
  [324190] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20934), 1,
      sym__end_cmd,
    STATE(15032), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15008), 2,
      sym_block_comment,
      sym_line_comment,
  [324217] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20936), 1,
      sym__end_cmd,
    STATE(15022), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15009), 2,
      sym_block_comment,
      sym_line_comment,
  [324244] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20886), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15010), 2,
      sym_block_comment,
      sym_line_comment,
  [324271] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20936), 1,
      sym__end_cmd,
    STATE(15023), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15011), 2,
      sym_block_comment,
      sym_line_comment,
  [324298] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20926), 1,
      sym__end_cmd,
    STATE(14479), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15012), 2,
      sym_block_comment,
      sym_line_comment,
  [324325] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20912), 1,
      sym__end_cmd,
    STATE(14308), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15013), 2,
      sym_block_comment,
      sym_line_comment,
  [324352] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20938), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15014), 2,
      sym_block_comment,
      sym_line_comment,
  [324379] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20938), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15015), 2,
      sym_block_comment,
      sym_line_comment,
  [324406] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20940), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15016), 2,
      sym_block_comment,
      sym_line_comment,
  [324433] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20940), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15017), 2,
      sym_block_comment,
      sym_line_comment,
  [324460] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8268), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20942), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18004), 1,
      sym__comprehension_clause,
    STATE(15018), 2,
      sym_block_comment,
      sym_line_comment,
  [324489] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17183), 1,
      anon_sym_RPAREN,
    ACTIONS(17185), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14324), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17945), 1,
      sym__comprehension_clause,
    STATE(15019), 2,
      sym_block_comment,
      sym_line_comment,
  [324518] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20944), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15020), 2,
      sym_block_comment,
      sym_line_comment,
  [324545] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20944), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15021), 2,
      sym_block_comment,
      sym_line_comment,
  [324572] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20946), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15022), 2,
      sym_block_comment,
      sym_line_comment,
  [324599] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20946), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15023), 2,
      sym_block_comment,
      sym_line_comment,
  [324626] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8344), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20948), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18910), 1,
      sym__comprehension_clause,
    STATE(15024), 2,
      sym_block_comment,
      sym_line_comment,
  [324655] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7848), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20950), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18051), 1,
      sym__comprehension_clause,
    STATE(15025), 2,
      sym_block_comment,
      sym_line_comment,
  [324684] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7990), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20952), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19098), 1,
      sym__comprehension_clause,
    STATE(15026), 2,
      sym_block_comment,
      sym_line_comment,
  [324713] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18710), 1,
      sym__word_identifier,
    ACTIONS(20954), 1,
      anon_sym_DOLLAR,
    ACTIONS(20956), 1,
      anon_sym_COLON2,
    STATE(15027), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16412), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [324738] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(20958), 1,
      aux_sym__terminator_token1,
    ACTIONS(20961), 1,
      aux_sym__terminator_token2,
    ACTIONS(17634), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(15028), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__block_repeat1,
  [324761] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20964), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15029), 2,
      sym_block_comment,
      sym_line_comment,
  [324788] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20964), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15030), 2,
      sym_block_comment,
      sym_line_comment,
  [324815] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20966), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15031), 2,
      sym_block_comment,
      sym_line_comment,
  [324842] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20966), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15032), 2,
      sym_block_comment,
      sym_line_comment,
  [324869] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(17069), 1,
      anon_sym_RPAREN,
    ACTIONS(17071), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14961), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17840), 1,
      sym__comprehension_clause,
    STATE(15033), 2,
      sym_block_comment,
      sym_line_comment,
  [324898] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20005), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15034), 2,
      sym_block_comment,
      sym_line_comment,
  [324925] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6906), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(20968), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18898), 1,
      sym__comprehension_clause,
    STATE(15035), 2,
      sym_block_comment,
      sym_line_comment,
  [324954] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15330), 1,
      anon_sym_EQ,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(15036), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 4,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
      aux_sym__terminator_token2,
  [324977] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20894), 1,
      sym__end_cmd,
    STATE(14403), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15037), 2,
      sym_block_comment,
      sym_line_comment,
  [325004] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16836), 1,
      anon_sym_RPAREN,
    ACTIONS(16838), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14540), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17842), 1,
      sym__comprehension_clause,
    STATE(15038), 2,
      sym_block_comment,
      sym_line_comment,
  [325033] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15039), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(12962), 6,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_SEMI,
  [325052] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20970), 1,
      anon_sym_end,
    STATE(14288), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18439), 1,
      sym_else_clause,
    STATE(15040), 2,
      sym_block_comment,
      sym_line_comment,
  [325081] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15426), 1,
      anon_sym_EQ,
    ACTIONS(17583), 1,
      aux_sym__terminator_token1,
    ACTIONS(17585), 1,
      aux_sym__terminator_token2,
    STATE(15305), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_catch,
      anon_sym_finally,
    STATE(15041), 2,
      sym_block_comment,
      sym_line_comment,
  [325108] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20972), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18442), 1,
      sym_else_clause,
    STATE(15042), 2,
      sym_block_comment,
      sym_line_comment,
  [325137] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20974), 1,
      sym__end_str,
    STATE(15089), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15043), 2,
      sym_block_comment,
      sym_line_comment,
  [325164] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20735), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15044), 2,
      sym_block_comment,
      sym_line_comment,
  [325191] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20974), 1,
      sym__end_str,
    STATE(15093), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15045), 2,
      sym_block_comment,
      sym_line_comment,
  [325218] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20976), 1,
      sym__end_cmd,
    STATE(15095), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15046), 2,
      sym_block_comment,
      sym_line_comment,
  [325245] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20976), 1,
      sym__end_cmd,
    STATE(15100), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15047), 2,
      sym_block_comment,
      sym_line_comment,
  [325272] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(20978), 1,
      anon_sym_end,
    STATE(14354), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18493), 1,
      sym_else_clause,
    STATE(15048), 2,
      sym_block_comment,
      sym_line_comment,
  [325301] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20980), 1,
      sym__end_str,
    STATE(15058), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15049), 2,
      sym_block_comment,
      sym_line_comment,
  [325328] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16973), 1,
      anon_sym_RPAREN,
    ACTIONS(16975), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14330), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17955), 1,
      sym__comprehension_clause,
    STATE(15050), 2,
      sym_block_comment,
      sym_line_comment,
  [325357] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20980), 1,
      sym__end_str,
    STATE(15059), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15051), 2,
      sym_block_comment,
      sym_line_comment,
  [325384] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20982), 1,
      anon_sym_COMMA,
    STATE(15052), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_for_statement_repeat1,
    ACTIONS(12962), 4,
      anon_sym_if,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [325405] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20985), 1,
      sym__end_cmd,
    STATE(15060), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15053), 2,
      sym_block_comment,
      sym_line_comment,
  [325432] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(20987), 1,
      anon_sym_DOLLAR,
    ACTIONS(20989), 1,
      anon_sym_COLON2,
    STATE(15054), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [325457] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20985), 1,
      sym__end_cmd,
    STATE(15061), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15055), 2,
      sym_block_comment,
      sym_line_comment,
  [325484] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15250), 1,
      anon_sym_EQ,
    STATE(15056), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [325507] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20029), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15057), 2,
      sym_block_comment,
      sym_line_comment,
  [325534] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20991), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15058), 2,
      sym_block_comment,
      sym_line_comment,
  [325561] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(20991), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15059), 2,
      sym_block_comment,
      sym_line_comment,
  [325588] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(20993), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15060), 2,
      sym_block_comment,
      sym_line_comment,
  [325615] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20993), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15061), 2,
      sym_block_comment,
      sym_line_comment,
  [325642] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(20995), 1,
      anon_sym_DOLLAR,
    ACTIONS(20997), 1,
      anon_sym_COLON2,
    STATE(15062), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [325667] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7894), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(20999), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17799), 1,
      sym__comprehension_clause,
    STATE(15063), 2,
      sym_block_comment,
      sym_line_comment,
  [325696] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8026), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(21001), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18999), 1,
      sym__comprehension_clause,
    STATE(15064), 2,
      sym_block_comment,
      sym_line_comment,
  [325725] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16766), 1,
      anon_sym_RPAREN,
    ACTIONS(16768), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14338), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17879), 1,
      sym__comprehension_clause,
    STATE(15065), 2,
      sym_block_comment,
      sym_line_comment,
  [325754] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(21003), 1,
      anon_sym_end,
    STATE(14289), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18428), 1,
      sym_else_clause,
    STATE(15066), 2,
      sym_block_comment,
      sym_line_comment,
  [325783] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(21005), 1,
      anon_sym_end,
    STATE(14913), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18700), 1,
      sym_else_clause,
    STATE(15067), 2,
      sym_block_comment,
      sym_line_comment,
  [325812] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(21007), 1,
      sym__end_str,
    STATE(14361), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15068), 2,
      sym_block_comment,
      sym_line_comment,
  [325839] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(21009), 1,
      sym__end_str,
    STATE(15079), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15069), 2,
      sym_block_comment,
      sym_line_comment,
  [325866] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21011), 1,
      anon_sym_DOLLAR,
    ACTIONS(21013), 1,
      anon_sym_COLON2,
    STATE(15070), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [325891] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(21009), 1,
      sym__end_str,
    STATE(15080), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15071), 2,
      sym_block_comment,
      sym_line_comment,
  [325918] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(21015), 1,
      sym__end_cmd,
    STATE(15081), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15072), 2,
      sym_block_comment,
      sym_line_comment,
  [325945] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(21015), 1,
      sym__end_cmd,
    STATE(15082), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15073), 2,
      sym_block_comment,
      sym_line_comment,
  [325972] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(21017), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(18773), 1,
      sym_else_clause,
    STATE(15074), 2,
      sym_block_comment,
      sym_line_comment,
  [326001] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(20009), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15075), 2,
      sym_block_comment,
      sym_line_comment,
  [326028] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20906), 1,
      sym__end_cmd,
    STATE(14558), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15076), 2,
      sym_block_comment,
      sym_line_comment,
  [326055] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21019), 1,
      anon_sym_DOLLAR,
    ACTIONS(21021), 1,
      anon_sym_COLON2,
    STATE(15077), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326080] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21023), 1,
      aux_sym__terminator_token1,
    ACTIONS(21025), 1,
      aux_sym__terminator_token2,
    STATE(14466), 1,
      aux_sym__block_repeat1,
    STATE(15078), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5134), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [326105] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(21027), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15079), 2,
      sym_block_comment,
      sym_line_comment,
  [326132] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(21027), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15080), 2,
      sym_block_comment,
      sym_line_comment,
  [326159] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(21029), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15081), 2,
      sym_block_comment,
      sym_line_comment,
  [326186] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(21029), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15082), 2,
      sym_block_comment,
      sym_line_comment,
  [326213] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21031), 1,
      anon_sym_DOLLAR,
    ACTIONS(21033), 1,
      anon_sym_COLON2,
    STATE(15083), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326238] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21035), 1,
      anon_sym_DOLLAR,
    ACTIONS(21037), 1,
      anon_sym_COLON2,
    STATE(15084), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326263] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21039), 1,
      anon_sym_DOLLAR,
    ACTIONS(21041), 1,
      anon_sym_COLON2,
    STATE(15085), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326288] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21043), 1,
      anon_sym_DOLLAR,
    ACTIONS(21045), 1,
      anon_sym_COLON2,
    STATE(15086), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326313] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21047), 1,
      anon_sym_DOLLAR,
    ACTIONS(21049), 1,
      anon_sym_COLON2,
    STATE(15087), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326338] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    ACTIONS(21051), 1,
      anon_sym_DOLLAR,
    ACTIONS(21053), 1,
      anon_sym_COLON2,
    STATE(15088), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11353), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326363] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(21055), 1,
      sym__end_str,
    STATE(14402), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15089), 2,
      sym_block_comment,
      sym_line_comment,
  [326390] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7216), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(21057), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(17872), 1,
      sym__comprehension_clause,
    STATE(15090), 2,
      sym_block_comment,
      sym_line_comment,
  [326419] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(21059), 1,
      anon_sym_end,
    STATE(14995), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19052), 1,
      sym_else_clause,
    STATE(15091), 2,
      sym_block_comment,
      sym_line_comment,
  [326448] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1071), 1,
      anon_sym_else,
    ACTIONS(19983), 1,
      anon_sym_elseif,
    ACTIONS(21061), 1,
      anon_sym_end,
    STATE(15253), 1,
      aux_sym_if_statement_repeat1,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(19351), 1,
      sym_else_clause,
    STATE(15092), 2,
      sym_block_comment,
      sym_line_comment,
  [326477] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(21055), 1,
      sym__end_str,
    STATE(14441), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15093), 2,
      sym_block_comment,
      sym_line_comment,
  [326504] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7332), 1,
      anon_sym_RPAREN,
    ACTIONS(19950), 1,
      anon_sym_for,
    ACTIONS(21063), 1,
      anon_sym_COMMA,
    STATE(14271), 1,
      sym_for_clause,
    STATE(16859), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(19417), 1,
      sym__comprehension_clause,
    STATE(15094), 2,
      sym_block_comment,
      sym_line_comment,
  [326533] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(21065), 1,
      sym__end_cmd,
    STATE(14659), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15095), 2,
      sym_block_comment,
      sym_line_comment,
  [326560] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18510), 1,
      sym__word_identifier,
    ACTIONS(21067), 1,
      anon_sym_DOLLAR,
    ACTIONS(21069), 1,
      anon_sym_COLON2,
    STATE(15096), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7515), 3,
      sym_interpolation_expression,
      sym_quote_expression,
      sym_identifier,
  [326585] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(21071), 1,
      sym__end_str,
    STATE(14734), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15097), 2,
      sym_block_comment,
      sym_line_comment,
  [326612] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(21071), 1,
      sym__end_str,
    STATE(14735), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15098), 2,
      sym_block_comment,
      sym_line_comment,
  [326639] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(21073), 1,
      sym__end_cmd,
    STATE(14746), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15099), 2,
      sym_block_comment,
      sym_line_comment,
  [326666] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(21065), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15100), 2,
      sym_block_comment,
      sym_line_comment,
  [326693] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(21073), 1,
      sym__end_cmd,
    STATE(14747), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15101), 2,
      sym_block_comment,
      sym_line_comment,
  [326720] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(16788), 1,
      anon_sym_RPAREN,
    ACTIONS(16790), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(14359), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18116), 1,
      sym__comprehension_clause,
    STATE(15102), 2,
      sym_block_comment,
      sym_line_comment,
  [326749] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19967), 1,
      anon_sym_DOLLAR,
    ACTIONS(21007), 1,
      sym__end_str,
    STATE(14362), 1,
      aux_sym_string_literal_repeat2,
    STATE(16991), 1,
      sym_string_interpolation,
    ACTIONS(19969), 2,
      sym__content_str_3,
      sym_escape_sequence,
    STATE(15103), 2,
      sym_block_comment,
      sym_line_comment,
  [326776] = 9,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8134), 1,
      anon_sym_RPAREN,
    ACTIONS(16516), 1,
      anon_sym_for,
    ACTIONS(21075), 1,
      anon_sym_SEMI,
    STATE(14275), 1,
      sym_for_clause,
    STATE(16758), 1,
      aux_sym_parenthesized_expression_repeat1,
    STATE(18009), 1,
      sym__comprehension_clause,
    STATE(15104), 2,
      sym_block_comment,
      sym_line_comment,
  [326805] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19971), 1,
      anon_sym_DOLLAR,
    ACTIONS(21077), 1,
      sym__end_cmd,
    STATE(14364), 1,
      aux_sym_command_literal_repeat1,
    STATE(17014), 1,
      sym_string_interpolation,
    ACTIONS(19973), 2,
      sym__content_cmd_1,
      sym_escape_sequence,
    STATE(15105), 2,
      sym_block_comment,
      sym_line_comment,
  [326832] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(21077), 1,
      sym__end_cmd,
    STATE(14371), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15106), 2,
      sym_block_comment,
      sym_line_comment,
  [326859] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19961), 1,
      anon_sym_DOLLAR,
    ACTIONS(19997), 1,
      sym__end_str,
    STATE(14299), 1,
      aux_sym_string_literal_repeat1,
    STATE(16967), 1,
      sym_string_interpolation,
    ACTIONS(19963), 2,
      sym__content_str_1,
      sym_escape_sequence,
    STATE(15107), 2,
      sym_block_comment,
      sym_line_comment,
  [326886] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19977), 1,
      anon_sym_DOLLAR,
    ACTIONS(20529), 1,
      sym__end_cmd,
    STATE(14682), 1,
      aux_sym_command_literal_repeat2,
    STATE(16592), 1,
      sym_string_interpolation,
    ACTIONS(19979), 2,
      sym__content_cmd_3,
      sym_escape_sequence,
    STATE(15108), 2,
      sym_block_comment,
      sym_line_comment,
  [326913] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14968), 1,
      anon_sym_LBRACK,
    STATE(6111), 1,
      sym__array,
    STATE(15109), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6157), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [326935] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13688), 1,
      anon_sym_LBRACK,
    STATE(5258), 1,
      sym__array,
    STATE(15110), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5164), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [326957] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14840), 1,
      anon_sym_LBRACK,
    STATE(5741), 1,
      sym__array,
    STATE(15111), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5377), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [326979] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    STATE(10438), 1,
      sym__array,
    STATE(15112), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327001] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(19218), 1,
      sym_integer_literal,
    STATE(15113), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [327023] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21079), 1,
      anon_sym_end,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    STATE(17543), 1,
      sym_else_clause,
    STATE(18704), 1,
      sym_finally_clause,
    STATE(15114), 2,
      sym_block_comment,
      sym_line_comment,
  [327049] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13888), 1,
      anon_sym_LBRACK,
    STATE(5667), 1,
      sym__array,
    STATE(15115), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5804), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327071] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7368), 1,
      anon_sym_LBRACK,
    STATE(4824), 1,
      sym__array,
    STATE(15116), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4791), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327093] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    STATE(9765), 1,
      sym__array,
    STATE(15117), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327115] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15998), 1,
      anon_sym_LBRACK,
    STATE(11296), 1,
      sym__array,
    STATE(15118), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11314), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327137] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4492), 1,
      anon_sym_LBRACK,
    STATE(10285), 1,
      sym__array,
    STATE(15119), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10244), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327159] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21085), 1,
      anon_sym_end,
    STATE(17533), 1,
      sym_else_clause,
    STATE(19280), 1,
      sym_finally_clause,
    STATE(15120), 2,
      sym_block_comment,
      sym_line_comment,
  [327185] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    STATE(9981), 1,
      sym__array,
    STATE(15121), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327207] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13594), 1,
      anon_sym_LBRACK,
    STATE(11883), 1,
      sym__array,
    STATE(15122), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11788), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327229] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(19297), 1,
      sym_integer_literal,
    STATE(15123), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [327251] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21087), 1,
      anon_sym_end,
    STATE(17511), 1,
      sym_else_clause,
    STATE(19289), 1,
      sym_finally_clause,
    STATE(15124), 2,
      sym_block_comment,
      sym_line_comment,
  [327277] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15024), 1,
      anon_sym_LBRACK,
    STATE(5566), 1,
      sym__array,
    STATE(15125), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5576), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327299] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    STATE(4260), 1,
      sym__array,
    STATE(15126), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4293), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327321] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(869), 1,
      anon_sym_LBRACK,
    STATE(4661), 1,
      sym__array,
    STATE(15127), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4666), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327343] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    STATE(9929), 1,
      sym__array,
    STATE(15128), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327365] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21089), 1,
      anon_sym_end,
    STATE(17654), 1,
      sym_else_clause,
    STATE(18305), 1,
      sym_finally_clause,
    STATE(15129), 2,
      sym_block_comment,
      sym_line_comment,
  [327391] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    STATE(4290), 1,
      sym__array,
    STATE(15130), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4293), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327413] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13888), 1,
      anon_sym_LBRACK,
    STATE(5691), 1,
      sym__array,
    STATE(15131), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5804), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327435] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16036), 1,
      anon_sym_LBRACK,
    STATE(7543), 1,
      sym__array,
    STATE(15132), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7676), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327457] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    STATE(9968), 1,
      sym__array,
    STATE(15133), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327479] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21091), 1,
      aux_sym__terminator_token1,
    ACTIONS(21094), 1,
      aux_sym__terminator_token2,
    ACTIONS(17634), 2,
      anon_sym_catch,
      anon_sym_finally,
    STATE(15134), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__block_repeat1,
  [327501] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21097), 1,
      anon_sym_end,
    STATE(17518), 1,
      sym_else_clause,
    STATE(19182), 1,
      sym_finally_clause,
    STATE(15135), 2,
      sym_block_comment,
      sym_line_comment,
  [327527] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21099), 1,
      anon_sym_end,
    STATE(17436), 1,
      sym_else_clause,
    STATE(19495), 1,
      sym_finally_clause,
    STATE(15136), 2,
      sym_block_comment,
      sym_line_comment,
  [327553] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21101), 1,
      anon_sym_end,
    STATE(17246), 1,
      sym_else_clause,
    STATE(18689), 1,
      sym_finally_clause,
    STATE(15137), 2,
      sym_block_comment,
      sym_line_comment,
  [327579] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7746), 1,
      anon_sym_LBRACK,
    STATE(4447), 1,
      sym__array,
    STATE(15138), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4319), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327601] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13544), 1,
      anon_sym_LBRACK,
    STATE(6009), 1,
      sym__array,
    STATE(15139), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6077), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327623] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13544), 1,
      anon_sym_LBRACK,
    STATE(6010), 1,
      sym__array,
    STATE(15140), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6077), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327645] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15856), 1,
      anon_sym_LBRACK,
    STATE(7444), 1,
      sym__array,
    STATE(15141), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7274), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327667] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13702), 1,
      anon_sym_LBRACK,
    STATE(6210), 1,
      sym__array,
    STATE(15142), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6188), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327689] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    STATE(10142), 1,
      sym__array,
    STATE(15143), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327711] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16020), 1,
      anon_sym_LBRACK,
    STATE(6617), 1,
      sym__array,
    STATE(15144), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6674), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327733] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13702), 1,
      anon_sym_LBRACK,
    STATE(6213), 1,
      sym__array,
    STATE(15145), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6188), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327755] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13544), 1,
      anon_sym_LBRACK,
    STATE(6012), 1,
      sym__array,
    STATE(15146), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6077), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327777] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21103), 1,
      anon_sym_end,
    STATE(17445), 1,
      sym_else_clause,
    STATE(19137), 1,
      sym_finally_clause,
    STATE(15147), 2,
      sym_block_comment,
      sym_line_comment,
  [327803] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14454), 1,
      anon_sym_LBRACK,
    STATE(5692), 1,
      sym__array,
    STATE(15148), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5868), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327825] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18404), 1,
      sym_integer_literal,
    STATE(15149), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [327847] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14454), 1,
      anon_sym_LBRACK,
    STATE(5695), 1,
      sym__array,
    STATE(15150), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5868), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327869] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21105), 1,
      anon_sym_end,
    STATE(17602), 1,
      sym_else_clause,
    STATE(19474), 1,
      sym_finally_clause,
    STATE(15151), 2,
      sym_block_comment,
      sym_line_comment,
  [327895] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    STATE(9970), 1,
      sym__array,
    STATE(15152), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327917] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21107), 1,
      anon_sym_end,
    STATE(17660), 1,
      sym_else_clause,
    STATE(18290), 1,
      sym_finally_clause,
    STATE(15153), 2,
      sym_block_comment,
      sym_line_comment,
  [327943] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7958), 1,
      anon_sym_LBRACK,
    STATE(4539), 1,
      sym__array,
    STATE(15154), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4582), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327965] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14956), 1,
      anon_sym_LBRACK,
    STATE(6197), 1,
      sym__array,
    STATE(15155), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6299), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [327987] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1291), 1,
      anon_sym_LBRACK,
    STATE(5762), 1,
      sym__array,
    STATE(15156), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5409), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328009] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15780), 1,
      anon_sym_LBRACK,
    STATE(10536), 1,
      sym__array,
    STATE(15157), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10441), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328031] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7368), 1,
      anon_sym_LBRACK,
    STATE(4736), 1,
      sym__array,
    STATE(15158), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4791), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328053] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21109), 1,
      anon_sym_end,
    STATE(17637), 1,
      sym_else_clause,
    STATE(18297), 1,
      sym_finally_clause,
    STATE(15159), 2,
      sym_block_comment,
      sym_line_comment,
  [328079] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14980), 1,
      anon_sym_LBRACK,
    STATE(10855), 1,
      sym__array,
    STATE(15160), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11111), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328101] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15426), 1,
      anon_sym_EQ,
    STATE(15161), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [328123] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1291), 1,
      anon_sym_LBRACK,
    STATE(5765), 1,
      sym__array,
    STATE(15162), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5409), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328145] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13610), 1,
      anon_sym_LBRACK,
    STATE(9973), 1,
      sym__array,
    STATE(15163), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10026), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328167] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14980), 1,
      anon_sym_LBRACK,
    STATE(10858), 1,
      sym__array,
    STATE(15164), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11111), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328189] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7368), 1,
      anon_sym_LBRACK,
    STATE(4740), 1,
      sym__array,
    STATE(15165), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4791), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328211] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15824), 1,
      anon_sym_LBRACK,
    STATE(6683), 1,
      sym__array,
    STATE(15166), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6619), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328233] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4492), 1,
      anon_sym_LBRACK,
    STATE(10351), 1,
      sym__array,
    STATE(15167), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10244), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328255] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13688), 1,
      anon_sym_LBRACK,
    STATE(5093), 1,
      sym__array,
    STATE(15168), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5164), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328277] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17547), 1,
      aux_sym__terminator_token1,
    ACTIONS(17549), 1,
      aux_sym__terminator_token2,
    STATE(15288), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_end,
      anon_sym_finally,
    STATE(15169), 2,
      sym_block_comment,
      sym_line_comment,
  [328301] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6888), 1,
      anon_sym_LBRACK,
    STATE(4924), 1,
      sym__array,
    STATE(15170), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4905), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328323] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(15171), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 4,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [328343] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13500), 1,
      anon_sym_LBRACK,
    STATE(6399), 1,
      sym__array,
    STATE(15172), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6410), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328365] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15494), 1,
      anon_sym_EQ,
    STATE(15173), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [328387] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4938), 1,
      anon_sym_LBRACK,
    STATE(4520), 1,
      sym__array,
    STATE(15174), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4721), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328409] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13888), 1,
      anon_sym_LBRACK,
    STATE(5680), 1,
      sym__array,
    STATE(15175), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5804), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328431] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21111), 1,
      aux_sym__terminator_token1,
    ACTIONS(21113), 1,
      aux_sym__terminator_token2,
    STATE(15332), 1,
      aux_sym__block_repeat1,
    ACTIONS(5134), 2,
      anon_sym_end,
      anon_sym_catch,
    STATE(15176), 2,
      sym_block_comment,
      sym_line_comment,
  [328455] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    STATE(10098), 1,
      sym__array,
    STATE(15177), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328477] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21115), 1,
      anon_sym_end,
    STATE(17111), 1,
      sym_else_clause,
    STATE(18399), 1,
      sym_finally_clause,
    STATE(15178), 2,
      sym_block_comment,
      sym_line_comment,
  [328503] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15910), 1,
      anon_sym_LBRACK,
    STATE(7167), 1,
      sym__array,
    STATE(15179), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7097), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328525] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18673), 1,
      sym_integer_literal,
    STATE(15180), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [328547] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1291), 1,
      anon_sym_LBRACK,
    STATE(5861), 1,
      sym__array,
    STATE(15181), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5409), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328569] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18436), 1,
      sym_integer_literal,
    STATE(15182), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [328591] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17298), 1,
      aux_sym__terminator_token1,
    ACTIONS(17300), 1,
      aux_sym__terminator_token2,
    STATE(15176), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_end,
      anon_sym_catch,
    STATE(15183), 2,
      sym_block_comment,
      sym_line_comment,
  [328615] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21117), 1,
      aux_sym__terminator_token1,
    ACTIONS(21120), 1,
      aux_sym__terminator_token2,
    ACTIONS(17634), 2,
      anon_sym_end,
      anon_sym_finally,
    STATE(15184), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__block_repeat1,
  [328637] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15936), 1,
      anon_sym_LBRACK,
    STATE(11724), 1,
      sym__array,
    STATE(15185), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11620), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328659] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14968), 1,
      anon_sym_LBRACK,
    STATE(6092), 1,
      sym__array,
    STATE(15186), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6157), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328681] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13218), 1,
      anon_sym_LBRACK,
    STATE(6537), 1,
      sym__array,
    STATE(15187), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6580), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328703] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4938), 1,
      anon_sym_LBRACK,
    STATE(4557), 1,
      sym__array,
    STATE(15188), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4721), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328725] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4938), 1,
      anon_sym_LBRACK,
    STATE(4522), 1,
      sym__array,
    STATE(15189), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4721), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328747] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14956), 1,
      anon_sym_LBRACK,
    STATE(6150), 1,
      sym__array,
    STATE(15190), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6299), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328769] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    STATE(10140), 1,
      sym__array,
    STATE(15191), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328791] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13860), 1,
      anon_sym_LBRACK,
    STATE(6277), 1,
      sym__array,
    STATE(15192), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5960), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328813] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9884), 1,
      anon_sym_LBRACK,
    STATE(10137), 1,
      sym__array,
    STATE(15193), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10083), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328835] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13702), 1,
      anon_sym_LBRACK,
    STATE(6220), 1,
      sym__array,
    STATE(15194), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6188), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328857] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18695), 1,
      sym_integer_literal,
    STATE(15195), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [328879] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18253), 1,
      sym_integer_literal,
    STATE(15196), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [328901] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4938), 1,
      anon_sym_LBRACK,
    STATE(4626), 1,
      sym__array,
    STATE(15197), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4721), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328923] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8290), 1,
      anon_sym_LBRACK,
    STATE(4635), 1,
      sym__array,
    STATE(15198), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4758), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328945] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13594), 1,
      anon_sym_LBRACK,
    STATE(11797), 1,
      sym__array,
    STATE(15199), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11788), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328967] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14374), 1,
      anon_sym_LBRACK,
    STATE(5970), 1,
      sym__array,
    STATE(15200), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6039), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [328989] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    STATE(10414), 1,
      sym__array,
    STATE(15201), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329011] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21123), 1,
      anon_sym_end,
    STATE(17279), 1,
      sym_else_clause,
    STATE(18771), 1,
      sym_finally_clause,
    STATE(15202), 2,
      sym_block_comment,
      sym_line_comment,
  [329037] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14650), 1,
      anon_sym_LBRACK,
    STATE(7063), 1,
      sym__array,
    STATE(15203), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6943), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329059] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13594), 1,
      anon_sym_LBRACK,
    STATE(11800), 1,
      sym__array,
    STATE(15204), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11788), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329081] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14374), 1,
      anon_sym_LBRACK,
    STATE(5972), 1,
      sym__array,
    STATE(15205), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6039), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329103] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13594), 1,
      anon_sym_LBRACK,
    STATE(11811), 1,
      sym__array,
    STATE(15206), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11788), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329125] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14840), 1,
      anon_sym_LBRACK,
    STATE(5779), 1,
      sym__array,
    STATE(15207), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5377), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329147] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14374), 1,
      anon_sym_LBRACK,
    STATE(5974), 1,
      sym__array,
    STATE(15208), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6039), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329169] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21125), 1,
      anon_sym_end,
    STATE(17160), 1,
      sym_else_clause,
    STATE(19104), 1,
      sym_finally_clause,
    STATE(15209), 2,
      sym_block_comment,
      sym_line_comment,
  [329195] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14724), 1,
      anon_sym_LBRACK,
    STATE(5780), 1,
      sym__array,
    STATE(15210), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5446), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329217] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14724), 1,
      anon_sym_LBRACK,
    STATE(5784), 1,
      sym__array,
    STATE(15211), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5446), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329239] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16080), 1,
      anon_sym_LBRACK,
    STATE(7850), 1,
      sym__array,
    STATE(15212), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7495), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329261] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15902), 1,
      anon_sym_LBRACK,
    STATE(7823), 1,
      sym__array,
    STATE(15213), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7570), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329283] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18510), 1,
      sym_integer_literal,
    STATE(15214), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [329305] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14524), 1,
      anon_sym_LBRACK,
    STATE(5331), 1,
      sym__array,
    STATE(15215), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5351), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329327] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14524), 1,
      anon_sym_LBRACK,
    STATE(5333), 1,
      sym__array,
    STATE(15216), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5351), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329349] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21127), 1,
      anon_sym_end,
    STATE(17233), 1,
      sym_else_clause,
    STATE(18972), 1,
      sym_finally_clause,
    STATE(15217), 2,
      sym_block_comment,
      sym_line_comment,
  [329375] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14570), 1,
      anon_sym_LBRACK,
    STATE(11370), 1,
      sym__array,
    STATE(15218), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11198), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329397] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14524), 1,
      anon_sym_LBRACK,
    STATE(5339), 1,
      sym__array,
    STATE(15219), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5351), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329419] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15870), 1,
      anon_sym_LBRACK,
    STATE(7730), 1,
      sym__array,
    STATE(15220), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7347), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329441] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21129), 1,
      anon_sym_end,
    STATE(17650), 1,
      sym_else_clause,
    STATE(19581), 1,
      sym_finally_clause,
    STATE(15221), 2,
      sym_block_comment,
      sym_line_comment,
  [329467] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13268), 1,
      anon_sym_LBRACK,
    STATE(5455), 1,
      sym__array,
    STATE(15222), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5501), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329489] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21131), 1,
      anon_sym_end,
    STATE(17370), 1,
      sym_else_clause,
    STATE(19018), 1,
      sym_finally_clause,
    STATE(15223), 2,
      sym_block_comment,
      sym_line_comment,
  [329515] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16044), 1,
      anon_sym_LBRACK,
    STATE(6743), 1,
      sym__array,
    STATE(15224), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6720), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329537] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16012), 1,
      anon_sym_LBRACK,
    STATE(6970), 1,
      sym__array,
    STATE(15225), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6873), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329559] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21133), 1,
      anon_sym_end,
    STATE(17615), 1,
      sym_else_clause,
    STATE(18279), 1,
      sym_finally_clause,
    STATE(15226), 2,
      sym_block_comment,
      sym_line_comment,
  [329585] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15878), 1,
      anon_sym_LBRACK,
    STATE(7039), 1,
      sym__array,
    STATE(15227), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6992), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329607] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(869), 1,
      anon_sym_LBRACK,
    STATE(4648), 1,
      sym__array,
    STATE(15228), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4666), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329629] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14650), 1,
      anon_sym_LBRACK,
    STATE(7041), 1,
      sym__array,
    STATE(15229), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6943), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329651] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(869), 1,
      anon_sym_LBRACK,
    STATE(4649), 1,
      sym__array,
    STATE(15230), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4666), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329673] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    STATE(10529), 1,
      sym__array,
    STATE(15231), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329695] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14650), 1,
      anon_sym_LBRACK,
    STATE(7044), 1,
      sym__array,
    STATE(15232), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6943), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329717] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21135), 1,
      anon_sym_end,
    STATE(17138), 1,
      sym_else_clause,
    STATE(18453), 1,
      sym_finally_clause,
    STATE(15233), 2,
      sym_block_comment,
      sym_line_comment,
  [329743] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13218), 1,
      anon_sym_LBRACK,
    STATE(6554), 1,
      sym__array,
    STATE(15234), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6580), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329765] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21137), 1,
      anon_sym_end,
    STATE(17350), 1,
      sym_else_clause,
    STATE(18369), 1,
      sym_finally_clause,
    STATE(15235), 2,
      sym_block_comment,
      sym_line_comment,
  [329791] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    STATE(4503), 1,
      sym__array,
    STATE(15236), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4293), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329813] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13688), 1,
      anon_sym_LBRACK,
    STATE(5367), 1,
      sym__array,
    STATE(15237), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5164), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329835] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7958), 1,
      anon_sym_LBRACK,
    STATE(4518), 1,
      sym__array,
    STATE(15238), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4582), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329857] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21139), 1,
      anon_sym_end,
    STATE(17202), 1,
      sym_else_clause,
    STATE(18602), 1,
      sym_finally_clause,
    STATE(15239), 2,
      sym_block_comment,
      sym_line_comment,
  [329883] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(19442), 1,
      sym_integer_literal,
    STATE(15240), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [329905] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    STATE(9798), 1,
      sym__array,
    STATE(15241), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329927] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13500), 1,
      anon_sym_LBRACK,
    STATE(6384), 1,
      sym__array,
    STATE(15242), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6410), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329949] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(869), 1,
      anon_sym_LBRACK,
    STATE(4654), 1,
      sym__array,
    STATE(15243), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4666), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329971] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15972), 1,
      anon_sym_LBRACK,
    STATE(7736), 1,
      sym__array,
    STATE(15244), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7514), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [329993] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7958), 1,
      anon_sym_LBRACK,
    STATE(4542), 1,
      sym__array,
    STATE(15245), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4582), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330015] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16088), 1,
      anon_sym_LBRACK,
    STATE(7108), 1,
      sym__array,
    STATE(15246), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(7066), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330037] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18767), 1,
      sym_integer_literal,
    STATE(15247), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [330059] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15408), 1,
      anon_sym_EQ,
    STATE(15248), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(11020), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [330081] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14724), 1,
      anon_sym_LBRACK,
    STATE(5688), 1,
      sym__array,
    STATE(15249), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5446), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330103] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4492), 1,
      anon_sym_LBRACK,
    STATE(10287), 1,
      sym__array,
    STATE(15250), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10244), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330125] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    STATE(10672), 1,
      sym__array,
    STATE(15251), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330147] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    STATE(9989), 1,
      sym__array,
    STATE(15252), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330169] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21141), 1,
      anon_sym_end,
    ACTIONS(21143), 1,
      anon_sym_elseif,
    ACTIONS(21146), 1,
      anon_sym_else,
    STATE(17123), 1,
      sym_elseif_clause,
    STATE(15253), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_if_statement_repeat1,
  [330193] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21148), 1,
      anon_sym_end,
    STATE(17330), 1,
      sym_else_clause,
    STATE(19246), 1,
      sym_finally_clause,
    STATE(15254), 2,
      sym_block_comment,
      sym_line_comment,
  [330219] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14650), 1,
      anon_sym_LBRACK,
    STATE(7054), 1,
      sym__array,
    STATE(15255), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6943), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330241] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15848), 1,
      anon_sym_LBRACK,
    STATE(8477), 1,
      sym__array,
    STATE(15256), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8383), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330263] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21150), 1,
      anon_sym_end,
    STATE(17473), 1,
      sym_else_clause,
    STATE(18981), 1,
      sym_finally_clause,
    STATE(15257), 2,
      sym_block_comment,
      sym_line_comment,
  [330289] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15408), 1,
      anon_sym_EQ,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(15258), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 3,
      anon_sym_end,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [330311] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13860), 1,
      anon_sym_LBRACK,
    STATE(6273), 1,
      sym__array,
    STATE(15259), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5960), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330333] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14980), 1,
      anon_sym_LBRACK,
    STATE(11043), 1,
      sym__array,
    STATE(15260), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11111), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330355] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21152), 1,
      anon_sym_end,
    STATE(17137), 1,
      sym_else_clause,
    STATE(18446), 1,
      sym_finally_clause,
    STATE(15261), 2,
      sym_block_comment,
      sym_line_comment,
  [330381] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    STATE(9784), 1,
      sym__array,
    STATE(15262), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330403] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14840), 1,
      anon_sym_LBRACK,
    STATE(5752), 1,
      sym__array,
    STATE(15263), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5377), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330425] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8290), 1,
      anon_sym_LBRACK,
    STATE(4621), 1,
      sym__array,
    STATE(15264), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4758), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330447] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8290), 1,
      anon_sym_LBRACK,
    STATE(4627), 1,
      sym__array,
    STATE(15265), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4758), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330469] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15024), 1,
      anon_sym_LBRACK,
    STATE(5563), 1,
      sym__array,
    STATE(15266), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5576), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330491] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14454), 1,
      anon_sym_LBRACK,
    STATE(5701), 1,
      sym__array,
    STATE(15267), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5868), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330513] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13218), 1,
      anon_sym_LBRACK,
    STATE(6532), 1,
      sym__array,
    STATE(15268), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6580), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330535] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17583), 1,
      aux_sym__terminator_token1,
    ACTIONS(17585), 1,
      aux_sym__terminator_token2,
    STATE(15305), 1,
      aux_sym__block_repeat1,
    ACTIONS(16919), 2,
      anon_sym_catch,
      anon_sym_finally,
    STATE(15269), 2,
      sym_block_comment,
      sym_line_comment,
  [330559] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1291), 1,
      anon_sym_LBRACK,
    STATE(5769), 1,
      sym__array,
    STATE(15270), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5409), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330581] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13860), 1,
      anon_sym_LBRACK,
    STATE(6284), 1,
      sym__array,
    STATE(15271), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5960), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330603] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7958), 1,
      anon_sym_LBRACK,
    STATE(4566), 1,
      sym__array,
    STATE(15272), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4582), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330625] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14226), 1,
      anon_sym_LBRACK,
    STATE(10428), 1,
      sym__array,
    STATE(15273), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10392), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330647] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21154), 1,
      anon_sym_end,
    STATE(17210), 1,
      sym_else_clause,
    STATE(18617), 1,
      sym_finally_clause,
    STATE(15274), 2,
      sym_block_comment,
      sym_line_comment,
  [330673] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13702), 1,
      anon_sym_LBRACK,
    STATE(5993), 1,
      sym__array,
    STATE(15275), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6188), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330695] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    STATE(10660), 1,
      sym__array,
    STATE(15276), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330717] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13218), 1,
      anon_sym_LBRACK,
    STATE(6501), 1,
      sym__array,
    STATE(15277), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6580), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330739] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13500), 1,
      anon_sym_LBRACK,
    STATE(6386), 1,
      sym__array,
    STATE(15278), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6410), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330761] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16062), 1,
      anon_sym_LBRACK,
    STATE(15595), 1,
      sym__array,
    STATE(15279), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(16652), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330783] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13268), 1,
      anon_sym_LBRACK,
    STATE(5837), 1,
      sym__array,
    STATE(15280), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5501), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330805] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13268), 1,
      anon_sym_LBRACK,
    STATE(5840), 1,
      sym__array,
    STATE(15281), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5501), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330827] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15522), 1,
      anon_sym_EQ,
    ACTIONS(17916), 1,
      ts_builtin_sym_end,
    ACTIONS(17920), 1,
      aux_sym__terminator_token1,
    ACTIONS(17922), 1,
      aux_sym__terminator_token2,
    STATE(17030), 1,
      aux_sym__block_repeat1,
    STATE(15282), 2,
      sym_block_comment,
      sym_line_comment,
  [330853] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14968), 1,
      anon_sym_LBRACK,
    STATE(6088), 1,
      sym__array,
    STATE(15283), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6157), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330875] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14968), 1,
      anon_sym_LBRACK,
    STATE(6089), 1,
      sym__array,
    STATE(15284), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6157), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330897] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14524), 1,
      anon_sym_LBRACK,
    STATE(5162), 1,
      sym__array,
    STATE(15285), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5351), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330919] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9730), 1,
      anon_sym_DOT,
    ACTIONS(21156), 1,
      aux_sym_float_literal_token2,
    STATE(15286), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 3,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
  [330941] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14956), 1,
      anon_sym_LBRACK,
    STATE(6141), 1,
      sym__array,
    STATE(15287), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6299), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [330963] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21158), 1,
      aux_sym__terminator_token1,
    ACTIONS(21160), 1,
      aux_sym__terminator_token2,
    STATE(15184), 1,
      aux_sym__block_repeat1,
    ACTIONS(5134), 2,
      anon_sym_end,
      anon_sym_finally,
    STATE(15288), 2,
      sym_block_comment,
      sym_line_comment,
  [330987] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21162), 1,
      anon_sym_end,
    STATE(17512), 1,
      sym_else_clause,
    STATE(19202), 1,
      sym_finally_clause,
    STATE(15289), 2,
      sym_block_comment,
      sym_line_comment,
  [331013] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6888), 1,
      anon_sym_LBRACK,
    STATE(4922), 1,
      sym__array,
    STATE(15290), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4905), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331035] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13500), 1,
      anon_sym_LBRACK,
    STATE(6391), 1,
      sym__array,
    STATE(15291), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6410), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331057] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13688), 1,
      anon_sym_LBRACK,
    STATE(5084), 1,
      sym__array,
    STATE(15292), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5164), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331079] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    STATE(10642), 1,
      sym__array,
    STATE(15293), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331101] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18372), 1,
      sym_integer_literal,
    STATE(15294), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [331123] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21164), 1,
      anon_sym_end,
    STATE(17497), 1,
      sym_else_clause,
    STATE(18381), 1,
      sym_finally_clause,
    STATE(15295), 2,
      sym_block_comment,
      sym_line_comment,
  [331149] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15494), 1,
      anon_sym_EQ,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(15296), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 3,
      anon_sym_end,
      anon_sym_catch,
      aux_sym__terminator_token2,
  [331171] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7368), 1,
      anon_sym_LBRACK,
    STATE(4734), 1,
      sym__array,
    STATE(15297), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4791), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331193] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14980), 1,
      anon_sym_LBRACK,
    STATE(10863), 1,
      sym__array,
    STATE(15298), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11111), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331215] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21166), 1,
      anon_sym_end,
    STATE(17537), 1,
      sym_else_clause,
    STATE(19603), 1,
      sym_finally_clause,
    STATE(15299), 2,
      sym_block_comment,
      sym_line_comment,
  [331241] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13544), 1,
      anon_sym_LBRACK,
    STATE(6018), 1,
      sym__array,
    STATE(15300), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6077), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331263] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6888), 1,
      anon_sym_LBRACK,
    STATE(4987), 1,
      sym__array,
    STATE(15301), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4905), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331285] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14956), 1,
      anon_sym_LBRACK,
    STATE(6144), 1,
      sym__array,
    STATE(15302), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6299), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331307] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14454), 1,
      anon_sym_LBRACK,
    STATE(5721), 1,
      sym__array,
    STATE(15303), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5868), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331329] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7746), 1,
      anon_sym_LBRACK,
    STATE(4294), 1,
      sym__array,
    STATE(15304), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4319), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331351] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21168), 1,
      aux_sym__terminator_token1,
    ACTIONS(21170), 1,
      aux_sym__terminator_token2,
    STATE(15134), 1,
      aux_sym__block_repeat1,
    ACTIONS(5134), 2,
      anon_sym_catch,
      anon_sym_finally,
    STATE(15305), 2,
      sym_block_comment,
      sym_line_comment,
  [331375] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7746), 1,
      anon_sym_LBRACK,
    STATE(4367), 1,
      sym__array,
    STATE(15306), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4319), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331397] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7746), 1,
      anon_sym_LBRACK,
    STATE(4400), 1,
      sym__array,
    STATE(15307), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4319), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331419] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13314), 1,
      anon_sym_LBRACK,
    STATE(10553), 1,
      sym__array,
    STATE(15308), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10565), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331441] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15426), 1,
      anon_sym_EQ,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    STATE(15309), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(17634), 3,
      anon_sym_catch,
      anon_sym_finally,
      aux_sym__terminator_token2,
  [331463] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13268), 1,
      anon_sym_LBRACK,
    STATE(5852), 1,
      sym__array,
    STATE(15310), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5501), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331485] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21172), 1,
      anon_sym_end,
    STATE(17309), 1,
      sym_else_clause,
    STATE(19343), 1,
      sym_finally_clause,
    STATE(15311), 2,
      sym_block_comment,
      sym_line_comment,
  [331511] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21174), 1,
      anon_sym_end,
    STATE(17487), 1,
      sym_else_clause,
    STATE(19234), 1,
      sym_finally_clause,
    STATE(15312), 2,
      sym_block_comment,
      sym_line_comment,
  [331537] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4492), 1,
      anon_sym_LBRACK,
    STATE(10297), 1,
      sym__array,
    STATE(15313), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10244), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331559] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14764), 1,
      anon_sym_LBRACK,
    STATE(5716), 1,
      sym__array,
    STATE(15314), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5908), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331581] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21176), 1,
      anon_sym_end,
    STATE(17379), 1,
      sym_else_clause,
    STATE(19058), 1,
      sym_finally_clause,
    STATE(15315), 2,
      sym_block_comment,
      sym_line_comment,
  [331607] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21178), 1,
      anon_sym_end,
    STATE(17286), 1,
      sym_else_clause,
    STATE(18824), 1,
      sym_finally_clause,
    STATE(15316), 2,
      sym_block_comment,
      sym_line_comment,
  [331633] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    STATE(9933), 1,
      sym__array,
    STATE(15317), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331655] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21180), 1,
      anon_sym_end,
    STATE(17185), 1,
      sym_else_clause,
    STATE(18582), 1,
      sym_finally_clause,
    STATE(15318), 2,
      sym_block_comment,
      sym_line_comment,
  [331681] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14764), 1,
      anon_sym_LBRACK,
    STATE(5709), 1,
      sym__array,
    STATE(15319), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5908), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331703] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15814), 1,
      anon_sym_LBRACK,
    STATE(7182), 1,
      sym__array,
    STATE(15320), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6773), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331725] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14764), 1,
      anon_sym_LBRACK,
    STATE(5712), 1,
      sym__array,
    STATE(15321), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5908), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331747] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21182), 1,
      anon_sym_end,
    STATE(17150), 1,
      sym_else_clause,
    STATE(19411), 1,
      sym_finally_clause,
    STATE(15322), 2,
      sym_block_comment,
      sym_line_comment,
  [331773] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6888), 1,
      anon_sym_LBRACK,
    STATE(4872), 1,
      sym__array,
    STATE(15323), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4905), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331795] = 8,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    ACTIONS(16919), 1,
      anon_sym_end,
    ACTIONS(17961), 1,
      aux_sym__terminator_token1,
    ACTIONS(17963), 1,
      aux_sym__terminator_token2,
    STATE(17044), 1,
      aux_sym__block_repeat1,
    STATE(15324), 2,
      sym_block_comment,
      sym_line_comment,
  [331821] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21184), 1,
      anon_sym_end,
    STATE(17186), 1,
      sym_else_clause,
    STATE(18624), 1,
      sym_finally_clause,
    STATE(15325), 2,
      sym_block_comment,
      sym_line_comment,
  [331847] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15024), 1,
      anon_sym_LBRACK,
    STATE(5571), 1,
      sym__array,
    STATE(15326), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5576), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331869] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(59), 1,
      anon_sym_LBRACK,
    STATE(9998), 1,
      sym__array,
    STATE(15327), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(10006), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331891] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14374), 1,
      anon_sym_LBRACK,
    STATE(5995), 1,
      sym__array,
    STATE(15328), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6039), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331913] = 8,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21081), 1,
      anon_sym_else,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21186), 1,
      anon_sym_end,
    STATE(17243), 1,
      sym_else_clause,
    STATE(18491), 1,
      sym_finally_clause,
    STATE(15329), 2,
      sym_block_comment,
      sym_line_comment,
  [331939] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13888), 1,
      anon_sym_LBRACK,
    STATE(5670), 1,
      sym__array,
    STATE(15330), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5804), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331961] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15982), 1,
      anon_sym_LBRACK,
    STATE(6840), 1,
      sym__array,
    STATE(15331), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(6730), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [331983] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21188), 1,
      aux_sym__terminator_token1,
    ACTIONS(21191), 1,
      aux_sym__terminator_token2,
    ACTIONS(17634), 2,
      anon_sym_end,
      anon_sym_catch,
    STATE(15332), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__block_repeat1,
  [332005] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6866), 1,
      anon_sym_LBRACK,
    STATE(4252), 1,
      sym__array,
    STATE(15333), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4293), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332027] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16116), 1,
      anon_sym_LBRACK,
    STATE(8624), 1,
      sym__array,
    STATE(15334), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8769), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332049] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13410), 1,
      aux_sym_integer_literal_token4,
    STATE(18730), 1,
      sym_integer_literal,
    STATE(15335), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(13408), 3,
      aux_sym_integer_literal_token1,
      aux_sym_integer_literal_token2,
      aux_sym_integer_literal_token3,
  [332071] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14764), 1,
      anon_sym_LBRACK,
    STATE(5737), 1,
      sym__array,
    STATE(15336), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5908), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332093] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14724), 1,
      anon_sym_LBRACK,
    STATE(5792), 1,
      sym__array,
    STATE(15337), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5446), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332115] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16100), 1,
      anon_sym_LBRACK,
    STATE(17978), 1,
      sym__array,
    STATE(15338), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(17782), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332137] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    STATE(9816), 1,
      sym__array,
    STATE(15339), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(9774), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332159] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14570), 1,
      anon_sym_LBRACK,
    STATE(11341), 1,
      sym__array,
    STATE(15340), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11198), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332181] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14570), 1,
      anon_sym_LBRACK,
    STATE(11336), 1,
      sym__array,
    STATE(15341), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11198), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332203] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13860), 1,
      anon_sym_LBRACK,
    STATE(6274), 1,
      sym__array,
    STATE(15342), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5960), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332225] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14840), 1,
      anon_sym_LBRACK,
    STATE(5738), 1,
      sym__array,
    STATE(15343), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5377), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332247] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14570), 1,
      anon_sym_LBRACK,
    STATE(11352), 1,
      sym__array,
    STATE(15344), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(11198), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332269] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16108), 1,
      anon_sym_LBRACK,
    STATE(8962), 1,
      sym__array,
    STATE(15345), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(8964), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332291] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8290), 1,
      anon_sym_LBRACK,
    STATE(4675), 1,
      sym__array,
    STATE(15346), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(4758), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332313] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15024), 1,
      anon_sym_LBRACK,
    STATE(5562), 1,
      sym__array,
    STATE(15347), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(5576), 3,
      sym_comprehension_expression,
      sym_matrix_expression,
      sym_vector_expression,
  [332335] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7122), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17679), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15348), 2,
      sym_block_comment,
      sym_line_comment,
  [332358] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7346), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21194), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15349), 2,
      sym_block_comment,
      sym_line_comment,
  [332381] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21198), 1,
      sym__end_str,
    STATE(15356), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15350), 2,
      sym_block_comment,
      sym_line_comment,
  [332402] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21198), 1,
      sym__end_str,
    STATE(15357), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15351), 2,
      sym_block_comment,
      sym_line_comment,
  [332423] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21204), 1,
      sym__end_cmd,
    STATE(15358), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15352), 2,
      sym_block_comment,
      sym_line_comment,
  [332444] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21204), 1,
      sym__end_cmd,
    STATE(15359), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15353), 2,
      sym_block_comment,
      sym_line_comment,
  [332465] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7504), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21208), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15354), 2,
      sym_block_comment,
      sym_line_comment,
  [332488] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8806), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21210), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15355), 2,
      sym_block_comment,
      sym_line_comment,
  [332511] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21212), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15356), 2,
      sym_block_comment,
      sym_line_comment,
  [332532] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21212), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15357), 2,
      sym_block_comment,
      sym_line_comment,
  [332553] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21214), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15358), 2,
      sym_block_comment,
      sym_line_comment,
  [332574] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21214), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15359), 2,
      sym_block_comment,
      sym_line_comment,
  [332595] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21216), 1,
      anon_sym_COMMA,
    ACTIONS(21218), 1,
      anon_sym_RPAREN,
    STATE(15388), 1,
      aux_sym_argument_list_repeat1,
    STATE(15360), 2,
      sym_block_comment,
      sym_line_comment,
  [332618] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21220), 1,
      anon_sym_COMMA,
    ACTIONS(21222), 1,
      anon_sym_RPAREN,
    STATE(16877), 1,
      aux_sym_argument_list_repeat1,
    STATE(15361), 2,
      sym_block_comment,
      sym_line_comment,
  [332641] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7702), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21224), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15362), 2,
      sym_block_comment,
      sym_line_comment,
  [332664] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7662), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17607), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15363), 2,
      sym_block_comment,
      sym_line_comment,
  [332687] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7508), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17557), 1,
      anon_sym_COMMA,
    STATE(16120), 1,
      aux_sym_argument_list_repeat1,
    STATE(15364), 2,
      sym_block_comment,
      sym_line_comment,
  [332710] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15365), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21226), 4,
      sym__content_cmd_3,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [332727] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21228), 1,
      anon_sym_RBRACK,
    ACTIONS(21230), 1,
      aux_sym__terminator_token1,
    ACTIONS(21232), 1,
      aux_sym__terminator_token2,
    STATE(15371), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15366), 2,
      sym_block_comment,
      sym_line_comment,
  [332750] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(21236), 1,
      anon_sym_RPAREN,
    ACTIONS(21238), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(15367), 2,
      sym_block_comment,
      sym_line_comment,
  [332773] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21240), 1,
      anon_sym_RBRACK,
    ACTIONS(21242), 1,
      aux_sym__terminator_token1,
    ACTIONS(21244), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15368), 2,
      sym_block_comment,
      sym_line_comment,
  [332796] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8482), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17572), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15369), 2,
      sym_block_comment,
      sym_line_comment,
  [332819] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21246), 1,
      anon_sym_COMMA,
    ACTIONS(21248), 1,
      anon_sym_RPAREN,
    STATE(16855), 1,
      aux_sym_argument_list_repeat1,
    STATE(15370), 2,
      sym_block_comment,
      sym_line_comment,
  [332842] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21250), 1,
      anon_sym_RBRACK,
    ACTIONS(21252), 1,
      aux_sym__terminator_token1,
    ACTIONS(21254), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15371), 2,
      sym_block_comment,
      sym_line_comment,
  [332865] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15372), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 4,
      sym__immediate_string_start,
      sym__immediate_command_start,
      anon_sym_RPAREN,
      anon_sym_DOT,
  [332882] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21256), 1,
      sym__end_str,
    STATE(15379), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15373), 2,
      sym_block_comment,
      sym_line_comment,
  [332903] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21256), 1,
      sym__end_str,
    STATE(15380), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15374), 2,
      sym_block_comment,
      sym_line_comment,
  [332924] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21258), 1,
      sym__end_cmd,
    STATE(15381), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15375), 2,
      sym_block_comment,
      sym_line_comment,
  [332945] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21258), 1,
      sym__end_cmd,
    STATE(15382), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15376), 2,
      sym_block_comment,
      sym_line_comment,
  [332966] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21260), 1,
      sym__end_str,
    STATE(16720), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15377), 2,
      sym_block_comment,
      sym_line_comment,
  [332987] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21262), 1,
      sym__end_str,
    STATE(15407), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15378), 2,
      sym_block_comment,
      sym_line_comment,
  [333008] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21264), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15379), 2,
      sym_block_comment,
      sym_line_comment,
  [333029] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21264), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15380), 2,
      sym_block_comment,
      sym_line_comment,
  [333050] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21266), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15381), 2,
      sym_block_comment,
      sym_line_comment,
  [333071] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21266), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15382), 2,
      sym_block_comment,
      sym_line_comment,
  [333092] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21262), 1,
      sym__end_str,
    STATE(15409), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15383), 2,
      sym_block_comment,
      sym_line_comment,
  [333113] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21268), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15384), 2,
      sym_block_comment,
      sym_line_comment,
  [333134] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21270), 1,
      sym__end_cmd,
    STATE(15410), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15385), 2,
      sym_block_comment,
      sym_line_comment,
  [333155] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21270), 1,
      sym__end_cmd,
    STATE(15411), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15386), 2,
      sym_block_comment,
      sym_line_comment,
  [333176] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21272), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15387), 2,
      sym_block_comment,
      sym_line_comment,
  [333197] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7712), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21274), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15388), 2,
      sym_block_comment,
      sym_line_comment,
  [333220] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7720), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21276), 1,
      anon_sym_COMMA,
    STATE(15413), 1,
      aux_sym_argument_list_repeat1,
    STATE(15389), 2,
      sym_block_comment,
      sym_line_comment,
  [333243] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7720), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21276), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15390), 2,
      sym_block_comment,
      sym_line_comment,
  [333266] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21278), 1,
      anon_sym_RBRACK,
    ACTIONS(21280), 1,
      aux_sym__terminator_token1,
    ACTIONS(21282), 1,
      aux_sym__terminator_token2,
    STATE(15393), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15391), 2,
      sym_block_comment,
      sym_line_comment,
  [333289] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21284), 1,
      sym__end_str,
    STATE(16553), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15392), 2,
      sym_block_comment,
      sym_line_comment,
  [333310] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21286), 1,
      anon_sym_RBRACK,
    ACTIONS(21288), 1,
      aux_sym__terminator_token1,
    ACTIONS(21290), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15393), 2,
      sym_block_comment,
      sym_line_comment,
  [333333] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21292), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15394), 2,
      sym_block_comment,
      sym_line_comment,
  [333354] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21294), 1,
      sym__end_str,
    STATE(15400), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15395), 2,
      sym_block_comment,
      sym_line_comment,
  [333375] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21294), 1,
      sym__end_str,
    STATE(15401), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15396), 2,
      sym_block_comment,
      sym_line_comment,
  [333396] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21296), 1,
      sym__end_cmd,
    STATE(15402), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15397), 2,
      sym_block_comment,
      sym_line_comment,
  [333417] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21296), 1,
      sym__end_cmd,
    STATE(15403), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15398), 2,
      sym_block_comment,
      sym_line_comment,
  [333438] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21292), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15399), 2,
      sym_block_comment,
      sym_line_comment,
  [333459] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21298), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15400), 2,
      sym_block_comment,
      sym_line_comment,
  [333480] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21298), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15401), 2,
      sym_block_comment,
      sym_line_comment,
  [333501] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21300), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15402), 2,
      sym_block_comment,
      sym_line_comment,
  [333522] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21300), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15403), 2,
      sym_block_comment,
      sym_line_comment,
  [333543] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21302), 1,
      anon_sym_COMMA,
    ACTIONS(21304), 1,
      anon_sym_RPAREN,
    STATE(15574), 1,
      aux_sym_argument_list_repeat1,
    STATE(15404), 2,
      sym_block_comment,
      sym_line_comment,
  [333566] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21306), 1,
      anon_sym_RBRACK,
    ACTIONS(21308), 1,
      aux_sym__terminator_token1,
    ACTIONS(21310), 1,
      aux_sym__terminator_token2,
    STATE(15491), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15405), 2,
      sym_block_comment,
      sym_line_comment,
  [333589] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21312), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15406), 2,
      sym_block_comment,
      sym_line_comment,
  [333610] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21314), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15407), 2,
      sym_block_comment,
      sym_line_comment,
  [333631] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21316), 1,
      anon_sym_RBRACK,
    ACTIONS(21318), 1,
      aux_sym__terminator_token1,
    ACTIONS(21320), 1,
      aux_sym__terminator_token2,
    STATE(15415), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15408), 2,
      sym_block_comment,
      sym_line_comment,
  [333654] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21314), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15409), 2,
      sym_block_comment,
      sym_line_comment,
  [333675] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21322), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15410), 2,
      sym_block_comment,
      sym_line_comment,
  [333696] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21322), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15411), 2,
      sym_block_comment,
      sym_line_comment,
  [333717] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21312), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15412), 2,
      sym_block_comment,
      sym_line_comment,
  [333738] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7730), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21324), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15413), 2,
      sym_block_comment,
      sym_line_comment,
  [333761] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15414), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21326), 4,
      sym__content_str_1,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [333778] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21328), 1,
      anon_sym_RBRACK,
    ACTIONS(21330), 1,
      aux_sym__terminator_token1,
    ACTIONS(21332), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15415), 2,
      sym_block_comment,
      sym_line_comment,
  [333801] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21272), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15416), 2,
      sym_block_comment,
      sym_line_comment,
  [333822] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7734), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17640), 1,
      anon_sym_COMMA,
    STATE(15597), 1,
      aux_sym_argument_list_repeat1,
    STATE(15417), 2,
      sym_block_comment,
      sym_line_comment,
  [333845] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7414), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21334), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15418), 2,
      sym_block_comment,
      sym_line_comment,
  [333868] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21336), 1,
      sym__end_str,
    STATE(15425), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15419), 2,
      sym_block_comment,
      sym_line_comment,
  [333889] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21336), 1,
      sym__end_str,
    STATE(15426), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15420), 2,
      sym_block_comment,
      sym_line_comment,
  [333910] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21338), 1,
      sym__end_cmd,
    STATE(15427), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15421), 2,
      sym_block_comment,
      sym_line_comment,
  [333931] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21338), 1,
      sym__end_cmd,
    STATE(15428), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15422), 2,
      sym_block_comment,
      sym_line_comment,
  [333952] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15423), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21340), 4,
      sym__content_str_1,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [333969] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21342), 1,
      anon_sym_DOT,
    STATE(15424), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10639), 3,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
  [333988] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21344), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15425), 2,
      sym_block_comment,
      sym_line_comment,
  [334009] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21344), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15426), 2,
      sym_block_comment,
      sym_line_comment,
  [334030] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21346), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15427), 2,
      sym_block_comment,
      sym_line_comment,
  [334051] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21346), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15428), 2,
      sym_block_comment,
      sym_line_comment,
  [334072] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21348), 1,
      anon_sym_RBRACK,
    ACTIONS(21350), 1,
      aux_sym__terminator_token1,
    ACTIONS(21352), 1,
      aux_sym__terminator_token2,
    STATE(15432), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15429), 2,
      sym_block_comment,
      sym_line_comment,
  [334095] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21354), 1,
      anon_sym_RBRACK,
    ACTIONS(21356), 1,
      aux_sym__terminator_token1,
    ACTIONS(21358), 1,
      aux_sym__terminator_token2,
    STATE(15525), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15430), 2,
      sym_block_comment,
      sym_line_comment,
  [334118] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7418), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17488), 1,
      anon_sym_COMMA,
    STATE(16936), 1,
      aux_sym_argument_list_repeat1,
    STATE(15431), 2,
      sym_block_comment,
      sym_line_comment,
  [334141] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21360), 1,
      anon_sym_RBRACK,
    ACTIONS(21362), 1,
      aux_sym__terminator_token1,
    ACTIONS(21364), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15432), 2,
      sym_block_comment,
      sym_line_comment,
  [334164] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21366), 1,
      anon_sym_COMMA,
    ACTIONS(21368), 1,
      anon_sym_RPAREN,
    STATE(15685), 1,
      aux_sym_argument_list_repeat1,
    STATE(15433), 2,
      sym_block_comment,
      sym_line_comment,
  [334187] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21370), 1,
      anon_sym_RBRACK,
    ACTIONS(21372), 1,
      aux_sym__terminator_token1,
    ACTIONS(21374), 1,
      aux_sym__terminator_token2,
    STATE(15495), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15434), 2,
      sym_block_comment,
      sym_line_comment,
  [334210] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21376), 1,
      sym__end_str,
    STATE(15442), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15435), 2,
      sym_block_comment,
      sym_line_comment,
  [334231] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21376), 1,
      sym__end_str,
    STATE(15443), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15436), 2,
      sym_block_comment,
      sym_line_comment,
  [334252] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21378), 1,
      sym__end_cmd,
    STATE(15444), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15437), 2,
      sym_block_comment,
      sym_line_comment,
  [334273] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21378), 1,
      sym__end_cmd,
    STATE(15445), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15438), 2,
      sym_block_comment,
      sym_line_comment,
  [334294] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21260), 1,
      sym__end_str,
    STATE(16911), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15439), 2,
      sym_block_comment,
      sym_line_comment,
  [334315] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21380), 1,
      sym__end_cmd,
    STATE(17059), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15440), 2,
      sym_block_comment,
      sym_line_comment,
  [334336] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21380), 1,
      sym__end_cmd,
    STATE(16206), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15441), 2,
      sym_block_comment,
      sym_line_comment,
  [334357] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21382), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15442), 2,
      sym_block_comment,
      sym_line_comment,
  [334378] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21382), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15443), 2,
      sym_block_comment,
      sym_line_comment,
  [334399] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21384), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15444), 2,
      sym_block_comment,
      sym_line_comment,
  [334420] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21384), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15445), 2,
      sym_block_comment,
      sym_line_comment,
  [334441] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15446), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21386), 4,
      sym__content_str_1,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [334458] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21388), 1,
      anon_sym_RBRACK,
    ACTIONS(21390), 1,
      aux_sym__terminator_token1,
    ACTIONS(21392), 1,
      aux_sym__terminator_token2,
    STATE(15469), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15447), 2,
      sym_block_comment,
      sym_line_comment,
  [334481] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21394), 1,
      anon_sym_RBRACK,
    ACTIONS(21396), 1,
      aux_sym__terminator_token1,
    ACTIONS(21398), 1,
      aux_sym__terminator_token2,
    STATE(15449), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15448), 2,
      sym_block_comment,
      sym_line_comment,
  [334504] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21400), 1,
      anon_sym_RBRACK,
    ACTIONS(21402), 1,
      aux_sym__terminator_token1,
    ACTIONS(21404), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15449), 2,
      sym_block_comment,
      sym_line_comment,
  [334527] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21406), 1,
      anon_sym_RBRACK,
    ACTIONS(21408), 1,
      aux_sym__terminator_token1,
    ACTIONS(21410), 1,
      aux_sym__terminator_token2,
    STATE(15555), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15450), 2,
      sym_block_comment,
      sym_line_comment,
  [334550] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21412), 1,
      sym__end_str,
    STATE(15457), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15451), 2,
      sym_block_comment,
      sym_line_comment,
  [334571] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21412), 1,
      sym__end_str,
    STATE(15458), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15452), 2,
      sym_block_comment,
      sym_line_comment,
  [334592] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21414), 1,
      sym__end_cmd,
    STATE(15459), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15453), 2,
      sym_block_comment,
      sym_line_comment,
  [334613] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21414), 1,
      sym__end_cmd,
    STATE(15460), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15454), 2,
      sym_block_comment,
      sym_line_comment,
  [334634] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11022), 1,
      aux_sym__terminator_token1,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    ACTIONS(11020), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    STATE(15455), 2,
      sym_block_comment,
      sym_line_comment,
  [334655] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21416), 1,
      anon_sym_COMMA,
    ACTIONS(21418), 1,
      anon_sym_RPAREN,
    STATE(15489), 1,
      aux_sym_argument_list_repeat1,
    STATE(15456), 2,
      sym_block_comment,
      sym_line_comment,
  [334678] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21420), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15457), 2,
      sym_block_comment,
      sym_line_comment,
  [334699] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21420), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15458), 2,
      sym_block_comment,
      sym_line_comment,
  [334720] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21422), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15459), 2,
      sym_block_comment,
      sym_line_comment,
  [334741] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21422), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15460), 2,
      sym_block_comment,
      sym_line_comment,
  [334762] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21424), 1,
      anon_sym_COMMA,
    ACTIONS(21426), 1,
      anon_sym_RPAREN,
    STATE(15531), 1,
      aux_sym_argument_list_repeat1,
    STATE(15461), 2,
      sym_block_comment,
      sym_line_comment,
  [334785] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6984), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21428), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15462), 2,
      sym_block_comment,
      sym_line_comment,
  [334808] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7764), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21430), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15463), 2,
      sym_block_comment,
      sym_line_comment,
  [334831] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21432), 1,
      sym__end_cmd,
    STATE(16601), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15464), 2,
      sym_block_comment,
      sym_line_comment,
  [334852] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15596), 1,
      anon_sym_EQ,
    ACTIONS(17636), 1,
      aux_sym__terminator_token1,
    ACTIONS(17634), 2,
      anon_sym_end,
      aux_sym__terminator_token2,
    STATE(15465), 2,
      sym_block_comment,
      sym_line_comment,
  [334873] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21434), 1,
      anon_sym_RBRACK,
    ACTIONS(21436), 1,
      aux_sym__terminator_token1,
    ACTIONS(21438), 1,
      aux_sym__terminator_token2,
    STATE(15473), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15466), 2,
      sym_block_comment,
      sym_line_comment,
  [334896] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7696), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17623), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15467), 2,
      sym_block_comment,
      sym_line_comment,
  [334919] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15468), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9716), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [334936] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21440), 1,
      anon_sym_RBRACK,
    ACTIONS(21442), 1,
      aux_sym__terminator_token1,
    ACTIONS(21444), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15469), 2,
      sym_block_comment,
      sym_line_comment,
  [334959] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8776), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21446), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15470), 2,
      sym_block_comment,
      sym_line_comment,
  [334982] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(21448), 1,
      anon_sym_RPAREN,
    ACTIONS(21450), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(15471), 2,
      sym_block_comment,
      sym_line_comment,
  [335005] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21452), 1,
      anon_sym_COMMA,
    ACTIONS(21454), 1,
      anon_sym_RPAREN,
    ACTIONS(21456), 1,
      anon_sym_SEMI,
    STATE(16670), 1,
      aux_sym_argument_list_repeat1,
    STATE(15472), 2,
      sym_block_comment,
      sym_line_comment,
  [335028] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21458), 1,
      anon_sym_RBRACK,
    ACTIONS(21460), 1,
      aux_sym__terminator_token1,
    ACTIONS(21462), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15473), 2,
      sym_block_comment,
      sym_line_comment,
  [335051] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17539), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15474), 2,
      sym_block_comment,
      sym_line_comment,
  [335074] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21464), 1,
      anon_sym_COMMA,
    ACTIONS(21466), 1,
      anon_sym_RPAREN,
    STATE(15556), 1,
      aux_sym_argument_list_repeat1,
    STATE(15475), 2,
      sym_block_comment,
      sym_line_comment,
  [335097] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21468), 1,
      sym__end_str,
    STATE(15481), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15476), 2,
      sym_block_comment,
      sym_line_comment,
  [335118] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21468), 1,
      sym__end_str,
    STATE(15482), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15477), 2,
      sym_block_comment,
      sym_line_comment,
  [335139] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21470), 1,
      sym__end_cmd,
    STATE(15483), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15478), 2,
      sym_block_comment,
      sym_line_comment,
  [335160] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21470), 1,
      sym__end_cmd,
    STATE(15484), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15479), 2,
      sym_block_comment,
      sym_line_comment,
  [335181] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8844), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17605), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15480), 2,
      sym_block_comment,
      sym_line_comment,
  [335204] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21472), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15481), 2,
      sym_block_comment,
      sym_line_comment,
  [335225] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21472), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15482), 2,
      sym_block_comment,
      sym_line_comment,
  [335246] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21474), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15483), 2,
      sym_block_comment,
      sym_line_comment,
  [335267] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21474), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15484), 2,
      sym_block_comment,
      sym_line_comment,
  [335288] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21476), 1,
      sym__end_str,
    STATE(15512), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15485), 2,
      sym_block_comment,
      sym_line_comment,
  [335309] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21476), 1,
      sym__end_str,
    STATE(15513), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15486), 2,
      sym_block_comment,
      sym_line_comment,
  [335330] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21478), 1,
      sym__end_cmd,
    STATE(15514), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15487), 2,
      sym_block_comment,
      sym_line_comment,
  [335351] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21478), 1,
      sym__end_cmd,
    STATE(15516), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15488), 2,
      sym_block_comment,
      sym_line_comment,
  [335372] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7778), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21480), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15489), 2,
      sym_block_comment,
      sym_line_comment,
  [335395] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7784), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21482), 1,
      anon_sym_COMMA,
    STATE(15517), 1,
      aux_sym_argument_list_repeat1,
    STATE(15490), 2,
      sym_block_comment,
      sym_line_comment,
  [335418] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21484), 1,
      anon_sym_RBRACK,
    ACTIONS(21486), 1,
      aux_sym__terminator_token1,
    ACTIONS(21488), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15491), 2,
      sym_block_comment,
      sym_line_comment,
  [335441] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21490), 1,
      anon_sym_RBRACK,
    ACTIONS(21492), 1,
      aux_sym__terminator_token1,
    ACTIONS(21494), 1,
      aux_sym__terminator_token2,
    STATE(15496), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15492), 2,
      sym_block_comment,
      sym_line_comment,
  [335464] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7784), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21482), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15493), 2,
      sym_block_comment,
      sym_line_comment,
  [335487] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21432), 1,
      sym__end_cmd,
    STATE(16672), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15494), 2,
      sym_block_comment,
      sym_line_comment,
  [335508] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21496), 1,
      anon_sym_RBRACK,
    ACTIONS(21498), 1,
      aux_sym__terminator_token1,
    ACTIONS(21500), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15495), 2,
      sym_block_comment,
      sym_line_comment,
  [335531] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21502), 1,
      anon_sym_RBRACK,
    ACTIONS(21504), 1,
      aux_sym__terminator_token1,
    ACTIONS(21506), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15496), 2,
      sym_block_comment,
      sym_line_comment,
  [335554] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7520), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21508), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15497), 2,
      sym_block_comment,
      sym_line_comment,
  [335577] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7462), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17543), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15498), 2,
      sym_block_comment,
      sym_line_comment,
  [335600] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21510), 1,
      sym__end_str,
    STATE(15505), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15499), 2,
      sym_block_comment,
      sym_line_comment,
  [335621] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21510), 1,
      sym__end_str,
    STATE(15506), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15500), 2,
      sym_block_comment,
      sym_line_comment,
  [335642] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21512), 1,
      sym__end_cmd,
    STATE(15507), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15501), 2,
      sym_block_comment,
      sym_line_comment,
  [335663] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21512), 1,
      sym__end_cmd,
    STATE(15508), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15502), 2,
      sym_block_comment,
      sym_line_comment,
  [335684] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21514), 1,
      anon_sym_COMMA,
    ACTIONS(21516), 1,
      anon_sym_RPAREN,
    STATE(15653), 1,
      aux_sym_argument_list_repeat1,
    STATE(15503), 2,
      sym_block_comment,
      sym_line_comment,
  [335707] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21518), 1,
      sym__end_str,
    STATE(15566), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15504), 2,
      sym_block_comment,
      sym_line_comment,
  [335728] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21520), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15505), 2,
      sym_block_comment,
      sym_line_comment,
  [335749] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21520), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15506), 2,
      sym_block_comment,
      sym_line_comment,
  [335770] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21522), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15507), 2,
      sym_block_comment,
      sym_line_comment,
  [335791] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21522), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15508), 2,
      sym_block_comment,
      sym_line_comment,
  [335812] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21518), 1,
      sym__end_str,
    STATE(15567), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15509), 2,
      sym_block_comment,
      sym_line_comment,
  [335833] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21524), 1,
      sym__end_cmd,
    STATE(15568), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15510), 2,
      sym_block_comment,
      sym_line_comment,
  [335854] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21524), 1,
      sym__end_cmd,
    STATE(15569), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15511), 2,
      sym_block_comment,
      sym_line_comment,
  [335875] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21526), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15512), 2,
      sym_block_comment,
      sym_line_comment,
  [335896] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21526), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15513), 2,
      sym_block_comment,
      sym_line_comment,
  [335917] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21528), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15514), 2,
      sym_block_comment,
      sym_line_comment,
  [335938] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21530), 1,
      anon_sym_RBRACK,
    ACTIONS(21532), 1,
      aux_sym__terminator_token1,
    ACTIONS(21534), 1,
      aux_sym__terminator_token2,
    STATE(15520), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15515), 2,
      sym_block_comment,
      sym_line_comment,
  [335961] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21528), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15516), 2,
      sym_block_comment,
      sym_line_comment,
  [335982] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7792), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21536), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15517), 2,
      sym_block_comment,
      sym_line_comment,
  [336005] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15518), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9960), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [336022] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7796), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17661), 1,
      anon_sym_COMMA,
    STATE(15716), 1,
      aux_sym_argument_list_repeat1,
    STATE(15519), 2,
      sym_block_comment,
      sym_line_comment,
  [336045] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21538), 1,
      anon_sym_RBRACK,
    ACTIONS(21540), 1,
      aux_sym__terminator_token1,
    ACTIONS(21542), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15520), 2,
      sym_block_comment,
      sym_line_comment,
  [336068] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21544), 1,
      sym__end_str,
    STATE(15526), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15521), 2,
      sym_block_comment,
      sym_line_comment,
  [336089] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21544), 1,
      sym__end_str,
    STATE(15527), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15522), 2,
      sym_block_comment,
      sym_line_comment,
  [336110] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21546), 1,
      sym__end_cmd,
    STATE(15528), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15523), 2,
      sym_block_comment,
      sym_line_comment,
  [336131] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21546), 1,
      sym__end_cmd,
    STATE(15529), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15524), 2,
      sym_block_comment,
      sym_line_comment,
  [336152] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21548), 1,
      anon_sym_RBRACK,
    ACTIONS(21550), 1,
      aux_sym__terminator_token1,
    ACTIONS(21552), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15525), 2,
      sym_block_comment,
      sym_line_comment,
  [336175] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21554), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15526), 2,
      sym_block_comment,
      sym_line_comment,
  [336196] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21554), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15527), 2,
      sym_block_comment,
      sym_line_comment,
  [336217] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21556), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15528), 2,
      sym_block_comment,
      sym_line_comment,
  [336238] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21556), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15529), 2,
      sym_block_comment,
      sym_line_comment,
  [336259] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15598), 1,
      aux_sym__terminator_token2,
    ACTIONS(15600), 1,
      aux_sym__terminator_token1,
    ACTIONS(21558), 1,
      anon_sym_COMMA,
    STATE(15530), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__do_parameter_list_repeat1,
  [336280] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8786), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21561), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15531), 2,
      sym_block_comment,
      sym_line_comment,
  [336303] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21563), 1,
      anon_sym_RBRACK,
    ACTIONS(21565), 1,
      aux_sym__terminator_token1,
    ACTIONS(21567), 1,
      aux_sym__terminator_token2,
    STATE(15538), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15532), 2,
      sym_block_comment,
      sym_line_comment,
  [336326] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21569), 1,
      anon_sym_RBRACK,
    ACTIONS(21571), 1,
      aux_sym__terminator_token1,
    ACTIONS(21573), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15533), 2,
      sym_block_comment,
      sym_line_comment,
  [336349] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15534), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 4,
      sym__content_str_1,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [336366] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21575), 1,
      anon_sym_RBRACK,
    ACTIONS(21577), 1,
      aux_sym__terminator_token1,
    ACTIONS(21579), 1,
      aux_sym__terminator_token2,
    STATE(16669), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15535), 2,
      sym_block_comment,
      sym_line_comment,
  [336389] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8792), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21581), 1,
      anon_sym_COMMA,
    STATE(15579), 1,
      aux_sym_argument_list_repeat1,
    STATE(15536), 2,
      sym_block_comment,
      sym_line_comment,
  [336412] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8792), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21581), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15537), 2,
      sym_block_comment,
      sym_line_comment,
  [336435] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21583), 1,
      anon_sym_RBRACK,
    ACTIONS(21585), 1,
      aux_sym__terminator_token1,
    ACTIONS(21587), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15538), 2,
      sym_block_comment,
      sym_line_comment,
  [336458] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21589), 1,
      sym__end_str,
    STATE(15624), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15539), 2,
      sym_block_comment,
      sym_line_comment,
  [336479] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21591), 1,
      sym__end_str,
    STATE(15546), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15540), 2,
      sym_block_comment,
      sym_line_comment,
  [336500] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21591), 1,
      sym__end_str,
    STATE(15547), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15541), 2,
      sym_block_comment,
      sym_line_comment,
  [336521] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21593), 1,
      sym__end_cmd,
    STATE(15548), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15542), 2,
      sym_block_comment,
      sym_line_comment,
  [336542] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21593), 1,
      sym__end_cmd,
    STATE(15549), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15543), 2,
      sym_block_comment,
      sym_line_comment,
  [336563] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15544), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21386), 4,
      sym__content_cmd_1,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [336580] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21595), 1,
      anon_sym_RBRACK,
    ACTIONS(21597), 1,
      aux_sym__terminator_token1,
    ACTIONS(21599), 1,
      aux_sym__terminator_token2,
    STATE(15577), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15545), 2,
      sym_block_comment,
      sym_line_comment,
  [336603] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21601), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15546), 2,
      sym_block_comment,
      sym_line_comment,
  [336624] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21601), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15547), 2,
      sym_block_comment,
      sym_line_comment,
  [336645] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21603), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15548), 2,
      sym_block_comment,
      sym_line_comment,
  [336666] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21603), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15549), 2,
      sym_block_comment,
      sym_line_comment,
  [336687] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15550), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9664), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [336704] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21589), 1,
      sym__end_str,
    STATE(15625), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15551), 2,
      sym_block_comment,
      sym_line_comment,
  [336725] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21605), 1,
      sym__end_cmd,
    STATE(15627), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15552), 2,
      sym_block_comment,
      sym_line_comment,
  [336746] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21605), 1,
      sym__end_cmd,
    STATE(15632), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15553), 2,
      sym_block_comment,
      sym_line_comment,
  [336767] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21607), 1,
      anon_sym_RBRACK,
    ACTIONS(21609), 1,
      aux_sym__terminator_token1,
    ACTIONS(21611), 1,
      aux_sym__terminator_token2,
    STATE(15561), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15554), 2,
      sym_block_comment,
      sym_line_comment,
  [336790] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21613), 1,
      anon_sym_RBRACK,
    ACTIONS(21615), 1,
      aux_sym__terminator_token1,
    ACTIONS(21617), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15555), 2,
      sym_block_comment,
      sym_line_comment,
  [336813] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7534), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21619), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15556), 2,
      sym_block_comment,
      sym_line_comment,
  [336836] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7540), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21621), 1,
      anon_sym_COMMA,
    STATE(15638), 1,
      aux_sym_argument_list_repeat1,
    STATE(15557), 2,
      sym_block_comment,
      sym_line_comment,
  [336859] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7540), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21621), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15558), 2,
      sym_block_comment,
      sym_line_comment,
  [336882] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21623), 1,
      anon_sym_COMMA,
    ACTIONS(21625), 1,
      anon_sym_RPAREN,
    STATE(16387), 1,
      aux_sym_argument_list_repeat1,
    STATE(15559), 2,
      sym_block_comment,
      sym_line_comment,
  [336905] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21627), 1,
      anon_sym_COMMA,
    ACTIONS(21629), 1,
      anon_sym_RPAREN,
    STATE(15594), 1,
      aux_sym_argument_list_repeat1,
    STATE(15560), 2,
      sym_block_comment,
      sym_line_comment,
  [336928] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21631), 1,
      anon_sym_RBRACK,
    ACTIONS(21633), 1,
      aux_sym__terminator_token1,
    ACTIONS(21635), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15561), 2,
      sym_block_comment,
      sym_line_comment,
  [336951] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21637), 1,
      sym__end_str,
    STATE(15570), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15562), 2,
      sym_block_comment,
      sym_line_comment,
  [336972] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21637), 1,
      sym__end_str,
    STATE(15571), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15563), 2,
      sym_block_comment,
      sym_line_comment,
  [336993] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21639), 1,
      sym__end_cmd,
    STATE(15572), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15564), 2,
      sym_block_comment,
      sym_line_comment,
  [337014] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21639), 1,
      sym__end_cmd,
    STATE(15573), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15565), 2,
      sym_block_comment,
      sym_line_comment,
  [337035] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21641), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15566), 2,
      sym_block_comment,
      sym_line_comment,
  [337056] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21641), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15567), 2,
      sym_block_comment,
      sym_line_comment,
  [337077] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21643), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15568), 2,
      sym_block_comment,
      sym_line_comment,
  [337098] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21643), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15569), 2,
      sym_block_comment,
      sym_line_comment,
  [337119] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21645), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15570), 2,
      sym_block_comment,
      sym_line_comment,
  [337140] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21645), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15571), 2,
      sym_block_comment,
      sym_line_comment,
  [337161] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21647), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15572), 2,
      sym_block_comment,
      sym_line_comment,
  [337182] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21647), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15573), 2,
      sym_block_comment,
      sym_line_comment,
  [337203] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7804), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21649), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15574), 2,
      sym_block_comment,
      sym_line_comment,
  [337226] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7734), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17640), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15575), 2,
      sym_block_comment,
      sym_line_comment,
  [337249] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21651), 1,
      anon_sym_RBRACK,
    ACTIONS(21653), 1,
      aux_sym__terminator_token1,
    ACTIONS(21655), 1,
      aux_sym__terminator_token2,
    STATE(15580), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15576), 2,
      sym_block_comment,
      sym_line_comment,
  [337272] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21657), 1,
      anon_sym_RBRACK,
    ACTIONS(21659), 1,
      aux_sym__terminator_token1,
    ACTIONS(21661), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15577), 2,
      sym_block_comment,
      sym_line_comment,
  [337295] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15315), 1,
      sym_catch_clause,
    STATE(17365), 1,
      sym_finally_clause,
    STATE(15578), 2,
      sym_block_comment,
      sym_line_comment,
  [337318] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8804), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21667), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15579), 2,
      sym_block_comment,
      sym_line_comment,
  [337341] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21669), 1,
      anon_sym_RBRACK,
    ACTIONS(21671), 1,
      aux_sym__terminator_token1,
    ACTIONS(21673), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15580), 2,
      sym_block_comment,
      sym_line_comment,
  [337364] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21675), 1,
      sym__end_str,
    STATE(15589), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15581), 2,
      sym_block_comment,
      sym_line_comment,
  [337385] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21675), 1,
      sym__end_str,
    STATE(15590), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15582), 2,
      sym_block_comment,
      sym_line_comment,
  [337406] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21677), 1,
      sym__end_cmd,
    STATE(15591), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15583), 2,
      sym_block_comment,
      sym_line_comment,
  [337427] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21677), 1,
      sym__end_cmd,
    STATE(15592), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15584), 2,
      sym_block_comment,
      sym_line_comment,
  [337448] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21679), 1,
      sym__end_str,
    STATE(15608), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15585), 2,
      sym_block_comment,
      sym_line_comment,
  [337469] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8814), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17625), 1,
      anon_sym_COMMA,
    STATE(16556), 1,
      aux_sym_argument_list_repeat1,
    STATE(15586), 2,
      sym_block_comment,
      sym_line_comment,
  [337492] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21679), 1,
      sym__end_str,
    STATE(15609), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15587), 2,
      sym_block_comment,
      sym_line_comment,
  [337513] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21681), 1,
      sym__end_cmd,
    STATE(15610), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15588), 2,
      sym_block_comment,
      sym_line_comment,
  [337534] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21683), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15589), 2,
      sym_block_comment,
      sym_line_comment,
  [337555] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21683), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15590), 2,
      sym_block_comment,
      sym_line_comment,
  [337576] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21685), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15591), 2,
      sym_block_comment,
      sym_line_comment,
  [337597] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21685), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15592), 2,
      sym_block_comment,
      sym_line_comment,
  [337618] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21681), 1,
      sym__end_cmd,
    STATE(15611), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15593), 2,
      sym_block_comment,
      sym_line_comment,
  [337639] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7816), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21687), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15594), 2,
      sym_block_comment,
      sym_line_comment,
  [337662] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15595), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9928), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [337679] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7824), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21689), 1,
      anon_sym_COMMA,
    STATE(15619), 1,
      aux_sym_argument_list_repeat1,
    STATE(15596), 2,
      sym_block_comment,
      sym_line_comment,
  [337702] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7824), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21689), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15597), 2,
      sym_block_comment,
      sym_line_comment,
  [337725] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21691), 1,
      anon_sym_RBRACK,
    ACTIONS(21693), 1,
      aux_sym__terminator_token1,
    ACTIONS(21695), 1,
      aux_sym__terminator_token2,
    STATE(15600), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15598), 2,
      sym_block_comment,
      sym_line_comment,
  [337748] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21697), 1,
      anon_sym_RBRACK,
    ACTIONS(21699), 1,
      aux_sym__terminator_token1,
    ACTIONS(21701), 1,
      aux_sym__terminator_token2,
    STATE(16060), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15599), 2,
      sym_block_comment,
      sym_line_comment,
  [337771] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21703), 1,
      anon_sym_RBRACK,
    ACTIONS(21705), 1,
      aux_sym__terminator_token1,
    ACTIONS(21707), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15600), 2,
      sym_block_comment,
      sym_line_comment,
  [337794] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21709), 1,
      anon_sym_COMMA,
    ACTIONS(21711), 1,
      anon_sym_RPAREN,
    STATE(16076), 1,
      aux_sym_argument_list_repeat1,
    STATE(15601), 2,
      sym_block_comment,
      sym_line_comment,
  [337817] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21713), 1,
      sym__end_str,
    STATE(16039), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15602), 2,
      sym_block_comment,
      sym_line_comment,
  [337838] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21715), 1,
      anon_sym_COMMA,
    ACTIONS(21717), 1,
      anon_sym_RPAREN,
    STATE(16335), 1,
      aux_sym_argument_list_repeat1,
    STATE(15603), 2,
      sym_block_comment,
      sym_line_comment,
  [337861] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21719), 1,
      sym__end_str,
    STATE(15613), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15604), 2,
      sym_block_comment,
      sym_line_comment,
  [337882] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21719), 1,
      sym__end_str,
    STATE(15614), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15605), 2,
      sym_block_comment,
      sym_line_comment,
  [337903] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21721), 1,
      sym__end_cmd,
    STATE(15615), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15606), 2,
      sym_block_comment,
      sym_line_comment,
  [337924] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21721), 1,
      sym__end_cmd,
    STATE(15616), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15607), 2,
      sym_block_comment,
      sym_line_comment,
  [337945] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21723), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15608), 2,
      sym_block_comment,
      sym_line_comment,
  [337966] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21723), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15609), 2,
      sym_block_comment,
      sym_line_comment,
  [337987] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21725), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15610), 2,
      sym_block_comment,
      sym_line_comment,
  [338008] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21725), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15611), 2,
      sym_block_comment,
      sym_line_comment,
  [338029] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21713), 1,
      sym__end_str,
    STATE(16040), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15612), 2,
      sym_block_comment,
      sym_line_comment,
  [338050] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21727), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15613), 2,
      sym_block_comment,
      sym_line_comment,
  [338071] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21727), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15614), 2,
      sym_block_comment,
      sym_line_comment,
  [338092] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21729), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15615), 2,
      sym_block_comment,
      sym_line_comment,
  [338113] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21729), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15616), 2,
      sym_block_comment,
      sym_line_comment,
  [338134] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21731), 1,
      sym__end_cmd,
    STATE(16042), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15617), 2,
      sym_block_comment,
      sym_line_comment,
  [338155] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21731), 1,
      sym__end_cmd,
    STATE(16046), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15618), 2,
      sym_block_comment,
      sym_line_comment,
  [338176] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7836), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21733), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15619), 2,
      sym_block_comment,
      sym_line_comment,
  [338199] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21735), 1,
      anon_sym_RBRACK,
    ACTIONS(21737), 1,
      aux_sym__terminator_token1,
    ACTIONS(21739), 1,
      aux_sym__terminator_token2,
    STATE(15626), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15620), 2,
      sym_block_comment,
      sym_line_comment,
  [338222] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7840), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17708), 1,
      anon_sym_COMMA,
    STATE(16087), 1,
      aux_sym_argument_list_repeat1,
    STATE(15621), 2,
      sym_block_comment,
      sym_line_comment,
  [338245] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(15622), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21326), 4,
      sym__content_cmd_3,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [338262] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21741), 1,
      anon_sym_RBRACK,
    ACTIONS(21743), 1,
      aux_sym__terminator_token1,
    ACTIONS(21745), 1,
      aux_sym__terminator_token2,
    STATE(16257), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15623), 2,
      sym_block_comment,
      sym_line_comment,
  [338285] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21747), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15624), 2,
      sym_block_comment,
      sym_line_comment,
  [338306] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21747), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15625), 2,
      sym_block_comment,
      sym_line_comment,
  [338327] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21749), 1,
      anon_sym_RBRACK,
    ACTIONS(21751), 1,
      aux_sym__terminator_token1,
    ACTIONS(21753), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15626), 2,
      sym_block_comment,
      sym_line_comment,
  [338350] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21755), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15627), 2,
      sym_block_comment,
      sym_line_comment,
  [338371] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21757), 1,
      sym__end_str,
    STATE(15634), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15628), 2,
      sym_block_comment,
      sym_line_comment,
  [338392] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21757), 1,
      sym__end_str,
    STATE(15635), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15629), 2,
      sym_block_comment,
      sym_line_comment,
  [338413] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21759), 1,
      sym__end_cmd,
    STATE(15636), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15630), 2,
      sym_block_comment,
      sym_line_comment,
  [338434] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21759), 1,
      sym__end_cmd,
    STATE(15637), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15631), 2,
      sym_block_comment,
      sym_line_comment,
  [338455] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21755), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15632), 2,
      sym_block_comment,
      sym_line_comment,
  [338476] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21284), 1,
      sym__end_str,
    STATE(16345), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15633), 2,
      sym_block_comment,
      sym_line_comment,
  [338497] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21761), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15634), 2,
      sym_block_comment,
      sym_line_comment,
  [338518] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21761), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15635), 2,
      sym_block_comment,
      sym_line_comment,
  [338539] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21763), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15636), 2,
      sym_block_comment,
      sym_line_comment,
  [338560] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21763), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15637), 2,
      sym_block_comment,
      sym_line_comment,
  [338581] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7550), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21765), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15638), 2,
      sym_block_comment,
      sym_line_comment,
  [338604] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21767), 1,
      anon_sym_RBRACK,
    ACTIONS(21769), 1,
      aux_sym__terminator_token1,
    ACTIONS(21771), 1,
      aux_sym__terminator_token2,
    STATE(15642), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15639), 2,
      sym_block_comment,
      sym_line_comment,
  [338627] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21773), 1,
      anon_sym_RBRACK,
    ACTIONS(21775), 1,
      aux_sym__terminator_token1,
    ACTIONS(21777), 1,
      aux_sym__terminator_token2,
    STATE(15657), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15640), 2,
      sym_block_comment,
      sym_line_comment,
  [338650] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7554), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17570), 1,
      anon_sym_COMMA,
    STATE(16596), 1,
      aux_sym_argument_list_repeat1,
    STATE(15641), 2,
      sym_block_comment,
      sym_line_comment,
  [338673] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21779), 1,
      anon_sym_RBRACK,
    ACTIONS(21781), 1,
      aux_sym__terminator_token1,
    ACTIONS(21783), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15642), 2,
      sym_block_comment,
      sym_line_comment,
  [338696] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21785), 1,
      sym__end_str,
    STATE(15647), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15643), 2,
      sym_block_comment,
      sym_line_comment,
  [338717] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21785), 1,
      sym__end_str,
    STATE(15648), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15644), 2,
      sym_block_comment,
      sym_line_comment,
  [338738] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21787), 1,
      sym__end_cmd,
    STATE(15649), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15645), 2,
      sym_block_comment,
      sym_line_comment,
  [338759] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21787), 1,
      sym__end_cmd,
    STATE(15650), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15646), 2,
      sym_block_comment,
      sym_line_comment,
  [338780] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21789), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15647), 2,
      sym_block_comment,
      sym_line_comment,
  [338801] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21789), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15648), 2,
      sym_block_comment,
      sym_line_comment,
  [338822] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21791), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15649), 2,
      sym_block_comment,
      sym_line_comment,
  [338843] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21791), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15650), 2,
      sym_block_comment,
      sym_line_comment,
  [338864] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21793), 1,
      anon_sym_COMMA,
    ACTIONS(21795), 1,
      anon_sym_RPAREN,
    STATE(15696), 1,
      aux_sym_argument_list_repeat1,
    STATE(15651), 2,
      sym_block_comment,
      sym_line_comment,
  [338887] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21797), 1,
      anon_sym_RBRACK,
    ACTIONS(21799), 1,
      aux_sym__terminator_token1,
    ACTIONS(21801), 1,
      aux_sym__terminator_token2,
    STATE(15656), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15652), 2,
      sym_block_comment,
      sym_line_comment,
  [338910] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7852), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21803), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15653), 2,
      sym_block_comment,
      sym_line_comment,
  [338933] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7796), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17661), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15654), 2,
      sym_block_comment,
      sym_line_comment,
  [338956] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21805), 1,
      sym__end_cmd,
    STATE(15387), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15655), 2,
      sym_block_comment,
      sym_line_comment,
  [338977] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21807), 1,
      anon_sym_RBRACK,
    ACTIONS(21809), 1,
      aux_sym__terminator_token1,
    ACTIONS(21811), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15656), 2,
      sym_block_comment,
      sym_line_comment,
  [339000] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(21813), 1,
      anon_sym_RBRACK,
    ACTIONS(21815), 1,
      aux_sym__terminator_token1,
    ACTIONS(21817), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(15657), 2,
      sym_block_comment,
      sym_line_comment,
  [339023] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21819), 1,
      sym__end_str,
    STATE(15662), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15658), 2,
      sym_block_comment,
      sym_line_comment,
  [339044] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21819), 1,
      sym__end_str,
    STATE(15663), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15659), 2,
      sym_block_comment,
      sym_line_comment,
  [339065] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21821), 1,
      sym__end_cmd,
    STATE(15664), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15660), 2,
      sym_block_comment,
      sym_line_comment,
  [339086] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21821), 1,
      sym__end_cmd,
    STATE(15665), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15661), 2,
      sym_block_comment,
      sym_line_comment,
  [339107] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21823), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15662), 2,
      sym_block_comment,
      sym_line_comment,
  [339128] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21823), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15663), 2,
      sym_block_comment,
      sym_line_comment,
  [339149] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21825), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15664), 2,
      sym_block_comment,
      sym_line_comment,
  [339170] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21825), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15665), 2,
      sym_block_comment,
      sym_line_comment,
  [339191] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21827), 1,
      sym__end_str,
    STATE(16033), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15666), 2,
      sym_block_comment,
      sym_line_comment,
  [339212] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21829), 1,
      sym__end_str,
    STATE(15672), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15667), 2,
      sym_block_comment,
      sym_line_comment,
  [339233] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21829), 1,
      sym__end_str,
    STATE(15673), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15668), 2,
      sym_block_comment,
      sym_line_comment,
  [339254] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21831), 1,
      sym__end_cmd,
    STATE(15674), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15669), 2,
      sym_block_comment,
      sym_line_comment,
  [339275] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21831), 1,
      sym__end_cmd,
    STATE(15675), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15670), 2,
      sym_block_comment,
      sym_line_comment,
  [339296] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21827), 1,
      sym__end_str,
    STATE(16035), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15671), 2,
      sym_block_comment,
      sym_line_comment,
  [339317] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21833), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15672), 2,
      sym_block_comment,
      sym_line_comment,
  [339338] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21833), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15673), 2,
      sym_block_comment,
      sym_line_comment,
  [339359] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21835), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15674), 2,
      sym_block_comment,
      sym_line_comment,
  [339380] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21835), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15675), 2,
      sym_block_comment,
      sym_line_comment,
  [339401] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21837), 1,
      sym__end_cmd,
    STATE(16036), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15676), 2,
      sym_block_comment,
      sym_line_comment,
  [339422] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21839), 1,
      sym__end_str,
    STATE(15681), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15677), 2,
      sym_block_comment,
      sym_line_comment,
  [339443] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21839), 1,
      sym__end_str,
    STATE(15682), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15678), 2,
      sym_block_comment,
      sym_line_comment,
  [339464] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21841), 1,
      sym__end_cmd,
    STATE(15683), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15679), 2,
      sym_block_comment,
      sym_line_comment,
  [339485] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21841), 1,
      sym__end_cmd,
    STATE(15684), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15680), 2,
      sym_block_comment,
      sym_line_comment,
  [339506] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21843), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15681), 2,
      sym_block_comment,
      sym_line_comment,
  [339527] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21843), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15682), 2,
      sym_block_comment,
      sym_line_comment,
  [339548] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21845), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15683), 2,
      sym_block_comment,
      sym_line_comment,
  [339569] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21845), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15684), 2,
      sym_block_comment,
      sym_line_comment,
  [339590] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7008), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21847), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15685), 2,
      sym_block_comment,
      sym_line_comment,
  [339613] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21837), 1,
      sym__end_cmd,
    STATE(16037), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15686), 2,
      sym_block_comment,
      sym_line_comment,
  [339634] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21849), 1,
      sym__end_str,
    STATE(15691), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15687), 2,
      sym_block_comment,
      sym_line_comment,
  [339655] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21849), 1,
      sym__end_str,
    STATE(15692), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15688), 2,
      sym_block_comment,
      sym_line_comment,
  [339676] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21851), 1,
      sym__end_cmd,
    STATE(15693), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15689), 2,
      sym_block_comment,
      sym_line_comment,
  [339697] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21851), 1,
      sym__end_cmd,
    STATE(15694), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15690), 2,
      sym_block_comment,
      sym_line_comment,
  [339718] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21853), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15691), 2,
      sym_block_comment,
      sym_line_comment,
  [339739] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21853), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15692), 2,
      sym_block_comment,
      sym_line_comment,
  [339760] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21855), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15693), 2,
      sym_block_comment,
      sym_line_comment,
  [339781] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21855), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15694), 2,
      sym_block_comment,
      sym_line_comment,
  [339802] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21857), 1,
      anon_sym_COMMA,
    ACTIONS(21859), 1,
      anon_sym_RPAREN,
    STATE(16128), 1,
      aux_sym_argument_list_repeat1,
    STATE(15695), 2,
      sym_block_comment,
      sym_line_comment,
  [339825] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7866), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21861), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15696), 2,
      sym_block_comment,
      sym_line_comment,
  [339848] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21863), 1,
      sym__end_str,
    STATE(15702), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15697), 2,
      sym_block_comment,
      sym_line_comment,
  [339869] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21863), 1,
      sym__end_str,
    STATE(15703), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15698), 2,
      sym_block_comment,
      sym_line_comment,
  [339890] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21865), 1,
      sym__end_cmd,
    STATE(15704), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15699), 2,
      sym_block_comment,
      sym_line_comment,
  [339911] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21865), 1,
      sym__end_cmd,
    STATE(15705), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15700), 2,
      sym_block_comment,
      sym_line_comment,
  [339932] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7016), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21867), 1,
      anon_sym_COMMA,
    STATE(16058), 1,
      aux_sym_argument_list_repeat1,
    STATE(15701), 2,
      sym_block_comment,
      sym_line_comment,
  [339955] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21869), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15702), 2,
      sym_block_comment,
      sym_line_comment,
  [339976] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21869), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15703), 2,
      sym_block_comment,
      sym_line_comment,
  [339997] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21871), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15704), 2,
      sym_block_comment,
      sym_line_comment,
  [340018] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21871), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15705), 2,
      sym_block_comment,
      sym_line_comment,
  [340039] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7872), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21873), 1,
      anon_sym_COMMA,
    STATE(16044), 1,
      aux_sym_argument_list_repeat1,
    STATE(15706), 2,
      sym_block_comment,
      sym_line_comment,
  [340062] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21875), 1,
      sym__end_str,
    STATE(15711), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15707), 2,
      sym_block_comment,
      sym_line_comment,
  [340083] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21875), 1,
      sym__end_str,
    STATE(15712), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15708), 2,
      sym_block_comment,
      sym_line_comment,
  [340104] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21877), 1,
      sym__end_cmd,
    STATE(15713), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15709), 2,
      sym_block_comment,
      sym_line_comment,
  [340125] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21877), 1,
      sym__end_cmd,
    STATE(15714), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15710), 2,
      sym_block_comment,
      sym_line_comment,
  [340146] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21879), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15711), 2,
      sym_block_comment,
      sym_line_comment,
  [340167] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21879), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15712), 2,
      sym_block_comment,
      sym_line_comment,
  [340188] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21881), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15713), 2,
      sym_block_comment,
      sym_line_comment,
  [340209] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21881), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15714), 2,
      sym_block_comment,
      sym_line_comment,
  [340230] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7016), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21867), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15715), 2,
      sym_block_comment,
      sym_line_comment,
  [340253] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7872), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21873), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(15716), 2,
      sym_block_comment,
      sym_line_comment,
  [340276] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21883), 1,
      sym__end_str,
    STATE(15721), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15717), 2,
      sym_block_comment,
      sym_line_comment,
  [340297] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21883), 1,
      sym__end_str,
    STATE(15722), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15718), 2,
      sym_block_comment,
      sym_line_comment,
  [340318] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21885), 1,
      sym__end_cmd,
    STATE(15723), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15719), 2,
      sym_block_comment,
      sym_line_comment,
  [340339] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21885), 1,
      sym__end_cmd,
    STATE(15724), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15720), 2,
      sym_block_comment,
      sym_line_comment,
  [340360] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21887), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15721), 2,
      sym_block_comment,
      sym_line_comment,
  [340381] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21887), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15722), 2,
      sym_block_comment,
      sym_line_comment,
  [340402] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21889), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15723), 2,
      sym_block_comment,
      sym_line_comment,
  [340423] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21889), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15724), 2,
      sym_block_comment,
      sym_line_comment,
  [340444] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21891), 1,
      sym__end_str,
    STATE(15729), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15725), 2,
      sym_block_comment,
      sym_line_comment,
  [340465] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21891), 1,
      sym__end_str,
    STATE(15730), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15726), 2,
      sym_block_comment,
      sym_line_comment,
  [340486] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21893), 1,
      sym__end_cmd,
    STATE(15731), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15727), 2,
      sym_block_comment,
      sym_line_comment,
  [340507] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21893), 1,
      sym__end_cmd,
    STATE(15732), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15728), 2,
      sym_block_comment,
      sym_line_comment,
  [340528] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21895), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15729), 2,
      sym_block_comment,
      sym_line_comment,
  [340549] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21895), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15730), 2,
      sym_block_comment,
      sym_line_comment,
  [340570] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21897), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15731), 2,
      sym_block_comment,
      sym_line_comment,
  [340591] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21897), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15732), 2,
      sym_block_comment,
      sym_line_comment,
  [340612] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21899), 1,
      sym__end_str,
    STATE(15737), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15733), 2,
      sym_block_comment,
      sym_line_comment,
  [340633] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21899), 1,
      sym__end_str,
    STATE(15738), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15734), 2,
      sym_block_comment,
      sym_line_comment,
  [340654] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21901), 1,
      sym__end_cmd,
    STATE(15739), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15735), 2,
      sym_block_comment,
      sym_line_comment,
  [340675] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21901), 1,
      sym__end_cmd,
    STATE(15740), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15736), 2,
      sym_block_comment,
      sym_line_comment,
  [340696] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21903), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15737), 2,
      sym_block_comment,
      sym_line_comment,
  [340717] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21903), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15738), 2,
      sym_block_comment,
      sym_line_comment,
  [340738] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21905), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15739), 2,
      sym_block_comment,
      sym_line_comment,
  [340759] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21905), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15740), 2,
      sym_block_comment,
      sym_line_comment,
  [340780] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21907), 1,
      sym__end_str,
    STATE(15745), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15741), 2,
      sym_block_comment,
      sym_line_comment,
  [340801] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21907), 1,
      sym__end_str,
    STATE(15746), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15742), 2,
      sym_block_comment,
      sym_line_comment,
  [340822] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21909), 1,
      sym__end_cmd,
    STATE(15747), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15743), 2,
      sym_block_comment,
      sym_line_comment,
  [340843] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21909), 1,
      sym__end_cmd,
    STATE(15748), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15744), 2,
      sym_block_comment,
      sym_line_comment,
  [340864] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21911), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15745), 2,
      sym_block_comment,
      sym_line_comment,
  [340885] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21911), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15746), 2,
      sym_block_comment,
      sym_line_comment,
  [340906] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21913), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15747), 2,
      sym_block_comment,
      sym_line_comment,
  [340927] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21913), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15748), 2,
      sym_block_comment,
      sym_line_comment,
  [340948] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21915), 1,
      sym__end_str,
    STATE(15753), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15749), 2,
      sym_block_comment,
      sym_line_comment,
  [340969] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21915), 1,
      sym__end_str,
    STATE(15754), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15750), 2,
      sym_block_comment,
      sym_line_comment,
  [340990] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21917), 1,
      sym__end_cmd,
    STATE(15755), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15751), 2,
      sym_block_comment,
      sym_line_comment,
  [341011] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21917), 1,
      sym__end_cmd,
    STATE(15756), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15752), 2,
      sym_block_comment,
      sym_line_comment,
  [341032] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21919), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15753), 2,
      sym_block_comment,
      sym_line_comment,
  [341053] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21919), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15754), 2,
      sym_block_comment,
      sym_line_comment,
  [341074] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21921), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15755), 2,
      sym_block_comment,
      sym_line_comment,
  [341095] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21921), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15756), 2,
      sym_block_comment,
      sym_line_comment,
  [341116] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21923), 1,
      sym__end_str,
    STATE(15761), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15757), 2,
      sym_block_comment,
      sym_line_comment,
  [341137] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21923), 1,
      sym__end_str,
    STATE(15762), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15758), 2,
      sym_block_comment,
      sym_line_comment,
  [341158] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21925), 1,
      sym__end_cmd,
    STATE(15763), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15759), 2,
      sym_block_comment,
      sym_line_comment,
  [341179] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21925), 1,
      sym__end_cmd,
    STATE(15764), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15760), 2,
      sym_block_comment,
      sym_line_comment,
  [341200] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21927), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15761), 2,
      sym_block_comment,
      sym_line_comment,
  [341221] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21927), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15762), 2,
      sym_block_comment,
      sym_line_comment,
  [341242] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21929), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15763), 2,
      sym_block_comment,
      sym_line_comment,
  [341263] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21929), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15764), 2,
      sym_block_comment,
      sym_line_comment,
  [341284] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(21931), 1,
      aux_sym__terminator_token1,
    ACTIONS(21933), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(15765), 2,
      sym_block_comment,
      sym_line_comment,
  [341307] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21935), 1,
      sym__end_str,
    STATE(15770), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15766), 2,
      sym_block_comment,
      sym_line_comment,
  [341328] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21935), 1,
      sym__end_str,
    STATE(15771), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15767), 2,
      sym_block_comment,
      sym_line_comment,
  [341349] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21937), 1,
      sym__end_cmd,
    STATE(15772), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15768), 2,
      sym_block_comment,
      sym_line_comment,
  [341370] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21937), 1,
      sym__end_cmd,
    STATE(15773), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15769), 2,
      sym_block_comment,
      sym_line_comment,
  [341391] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21939), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15770), 2,
      sym_block_comment,
      sym_line_comment,
  [341412] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21939), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15771), 2,
      sym_block_comment,
      sym_line_comment,
  [341433] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21941), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15772), 2,
      sym_block_comment,
      sym_line_comment,
  [341454] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21941), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15773), 2,
      sym_block_comment,
      sym_line_comment,
  [341475] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21943), 1,
      sym__end_str,
    STATE(15778), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15774), 2,
      sym_block_comment,
      sym_line_comment,
  [341496] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21943), 1,
      sym__end_str,
    STATE(15779), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15775), 2,
      sym_block_comment,
      sym_line_comment,
  [341517] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21945), 1,
      sym__end_cmd,
    STATE(15780), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15776), 2,
      sym_block_comment,
      sym_line_comment,
  [341538] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21945), 1,
      sym__end_cmd,
    STATE(15781), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15777), 2,
      sym_block_comment,
      sym_line_comment,
  [341559] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21947), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15778), 2,
      sym_block_comment,
      sym_line_comment,
  [341580] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21947), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15779), 2,
      sym_block_comment,
      sym_line_comment,
  [341601] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21949), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15780), 2,
      sym_block_comment,
      sym_line_comment,
  [341622] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21949), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15781), 2,
      sym_block_comment,
      sym_line_comment,
  [341643] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21951), 1,
      sym__end_str,
    STATE(15786), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15782), 2,
      sym_block_comment,
      sym_line_comment,
  [341664] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21951), 1,
      sym__end_str,
    STATE(15787), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15783), 2,
      sym_block_comment,
      sym_line_comment,
  [341685] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21953), 1,
      sym__end_cmd,
    STATE(15788), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15784), 2,
      sym_block_comment,
      sym_line_comment,
  [341706] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21953), 1,
      sym__end_cmd,
    STATE(15789), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15785), 2,
      sym_block_comment,
      sym_line_comment,
  [341727] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21955), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15786), 2,
      sym_block_comment,
      sym_line_comment,
  [341748] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21955), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15787), 2,
      sym_block_comment,
      sym_line_comment,
  [341769] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21957), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15788), 2,
      sym_block_comment,
      sym_line_comment,
  [341790] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21957), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15789), 2,
      sym_block_comment,
      sym_line_comment,
  [341811] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21959), 1,
      sym__end_str,
    STATE(15794), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15790), 2,
      sym_block_comment,
      sym_line_comment,
  [341832] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21959), 1,
      sym__end_str,
    STATE(15795), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15791), 2,
      sym_block_comment,
      sym_line_comment,
  [341853] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21961), 1,
      sym__end_cmd,
    STATE(15796), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15792), 2,
      sym_block_comment,
      sym_line_comment,
  [341874] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21961), 1,
      sym__end_cmd,
    STATE(15797), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15793), 2,
      sym_block_comment,
      sym_line_comment,
  [341895] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21963), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15794), 2,
      sym_block_comment,
      sym_line_comment,
  [341916] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21963), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15795), 2,
      sym_block_comment,
      sym_line_comment,
  [341937] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21965), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15796), 2,
      sym_block_comment,
      sym_line_comment,
  [341958] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21965), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15797), 2,
      sym_block_comment,
      sym_line_comment,
  [341979] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21967), 1,
      sym__end_str,
    STATE(15802), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15798), 2,
      sym_block_comment,
      sym_line_comment,
  [342000] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21967), 1,
      sym__end_str,
    STATE(15803), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15799), 2,
      sym_block_comment,
      sym_line_comment,
  [342021] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21969), 1,
      sym__end_cmd,
    STATE(15804), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15800), 2,
      sym_block_comment,
      sym_line_comment,
  [342042] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21969), 1,
      sym__end_cmd,
    STATE(15805), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15801), 2,
      sym_block_comment,
      sym_line_comment,
  [342063] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21971), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15802), 2,
      sym_block_comment,
      sym_line_comment,
  [342084] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21971), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15803), 2,
      sym_block_comment,
      sym_line_comment,
  [342105] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21973), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15804), 2,
      sym_block_comment,
      sym_line_comment,
  [342126] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21973), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15805), 2,
      sym_block_comment,
      sym_line_comment,
  [342147] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21975), 1,
      sym__end_str,
    STATE(15810), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15806), 2,
      sym_block_comment,
      sym_line_comment,
  [342168] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21975), 1,
      sym__end_str,
    STATE(15811), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15807), 2,
      sym_block_comment,
      sym_line_comment,
  [342189] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21977), 1,
      sym__end_cmd,
    STATE(15812), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15808), 2,
      sym_block_comment,
      sym_line_comment,
  [342210] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21977), 1,
      sym__end_cmd,
    STATE(15813), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15809), 2,
      sym_block_comment,
      sym_line_comment,
  [342231] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21979), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15810), 2,
      sym_block_comment,
      sym_line_comment,
  [342252] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21979), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15811), 2,
      sym_block_comment,
      sym_line_comment,
  [342273] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21981), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15812), 2,
      sym_block_comment,
      sym_line_comment,
  [342294] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21981), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15813), 2,
      sym_block_comment,
      sym_line_comment,
  [342315] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21983), 1,
      sym__end_str,
    STATE(15818), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15814), 2,
      sym_block_comment,
      sym_line_comment,
  [342336] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21983), 1,
      sym__end_str,
    STATE(15819), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15815), 2,
      sym_block_comment,
      sym_line_comment,
  [342357] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21985), 1,
      sym__end_cmd,
    STATE(15820), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15816), 2,
      sym_block_comment,
      sym_line_comment,
  [342378] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21985), 1,
      sym__end_cmd,
    STATE(15821), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15817), 2,
      sym_block_comment,
      sym_line_comment,
  [342399] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21987), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15818), 2,
      sym_block_comment,
      sym_line_comment,
  [342420] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21987), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15819), 2,
      sym_block_comment,
      sym_line_comment,
  [342441] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21989), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15820), 2,
      sym_block_comment,
      sym_line_comment,
  [342462] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21989), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15821), 2,
      sym_block_comment,
      sym_line_comment,
  [342483] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21991), 1,
      sym__end_str,
    STATE(15826), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15822), 2,
      sym_block_comment,
      sym_line_comment,
  [342504] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21991), 1,
      sym__end_str,
    STATE(15827), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15823), 2,
      sym_block_comment,
      sym_line_comment,
  [342525] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21993), 1,
      sym__end_cmd,
    STATE(15828), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15824), 2,
      sym_block_comment,
      sym_line_comment,
  [342546] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21993), 1,
      sym__end_cmd,
    STATE(15829), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15825), 2,
      sym_block_comment,
      sym_line_comment,
  [342567] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21995), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15826), 2,
      sym_block_comment,
      sym_line_comment,
  [342588] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21995), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15827), 2,
      sym_block_comment,
      sym_line_comment,
  [342609] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21997), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15828), 2,
      sym_block_comment,
      sym_line_comment,
  [342630] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21997), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15829), 2,
      sym_block_comment,
      sym_line_comment,
  [342651] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21999), 1,
      sym__end_str,
    STATE(15834), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15830), 2,
      sym_block_comment,
      sym_line_comment,
  [342672] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21999), 1,
      sym__end_str,
    STATE(15835), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15831), 2,
      sym_block_comment,
      sym_line_comment,
  [342693] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22001), 1,
      sym__end_cmd,
    STATE(15836), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15832), 2,
      sym_block_comment,
      sym_line_comment,
  [342714] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22001), 1,
      sym__end_cmd,
    STATE(15837), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15833), 2,
      sym_block_comment,
      sym_line_comment,
  [342735] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22003), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15834), 2,
      sym_block_comment,
      sym_line_comment,
  [342756] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22003), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15835), 2,
      sym_block_comment,
      sym_line_comment,
  [342777] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22005), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15836), 2,
      sym_block_comment,
      sym_line_comment,
  [342798] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22005), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15837), 2,
      sym_block_comment,
      sym_line_comment,
  [342819] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22007), 1,
      sym__end_str,
    STATE(15842), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15838), 2,
      sym_block_comment,
      sym_line_comment,
  [342840] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22007), 1,
      sym__end_str,
    STATE(15843), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15839), 2,
      sym_block_comment,
      sym_line_comment,
  [342861] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22009), 1,
      sym__end_cmd,
    STATE(15844), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15840), 2,
      sym_block_comment,
      sym_line_comment,
  [342882] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22009), 1,
      sym__end_cmd,
    STATE(15845), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15841), 2,
      sym_block_comment,
      sym_line_comment,
  [342903] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22011), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15842), 2,
      sym_block_comment,
      sym_line_comment,
  [342924] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22011), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15843), 2,
      sym_block_comment,
      sym_line_comment,
  [342945] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22013), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15844), 2,
      sym_block_comment,
      sym_line_comment,
  [342966] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22013), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15845), 2,
      sym_block_comment,
      sym_line_comment,
  [342987] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22015), 1,
      anon_sym_COMMA,
    ACTIONS(22017), 1,
      anon_sym_RPAREN,
    STATE(16353), 1,
      aux_sym_argument_list_repeat1,
    STATE(15846), 2,
      sym_block_comment,
      sym_line_comment,
  [343010] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22019), 1,
      sym__end_str,
    STATE(15851), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15847), 2,
      sym_block_comment,
      sym_line_comment,
  [343031] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22019), 1,
      sym__end_str,
    STATE(15852), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15848), 2,
      sym_block_comment,
      sym_line_comment,
  [343052] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22021), 1,
      sym__end_cmd,
    STATE(15853), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15849), 2,
      sym_block_comment,
      sym_line_comment,
  [343073] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22021), 1,
      sym__end_cmd,
    STATE(15854), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15850), 2,
      sym_block_comment,
      sym_line_comment,
  [343094] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22023), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15851), 2,
      sym_block_comment,
      sym_line_comment,
  [343115] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22023), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15852), 2,
      sym_block_comment,
      sym_line_comment,
  [343136] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22025), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15853), 2,
      sym_block_comment,
      sym_line_comment,
  [343157] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22025), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15854), 2,
      sym_block_comment,
      sym_line_comment,
  [343178] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22027), 1,
      sym__end_str,
    STATE(15859), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15855), 2,
      sym_block_comment,
      sym_line_comment,
  [343199] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22027), 1,
      sym__end_str,
    STATE(15860), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15856), 2,
      sym_block_comment,
      sym_line_comment,
  [343220] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22029), 1,
      sym__end_cmd,
    STATE(15861), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15857), 2,
      sym_block_comment,
      sym_line_comment,
  [343241] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22029), 1,
      sym__end_cmd,
    STATE(15862), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15858), 2,
      sym_block_comment,
      sym_line_comment,
  [343262] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22031), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15859), 2,
      sym_block_comment,
      sym_line_comment,
  [343283] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22031), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15860), 2,
      sym_block_comment,
      sym_line_comment,
  [343304] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22033), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15861), 2,
      sym_block_comment,
      sym_line_comment,
  [343325] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22033), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15862), 2,
      sym_block_comment,
      sym_line_comment,
  [343346] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22035), 1,
      sym__end_str,
    STATE(15867), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15863), 2,
      sym_block_comment,
      sym_line_comment,
  [343367] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22035), 1,
      sym__end_str,
    STATE(15868), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15864), 2,
      sym_block_comment,
      sym_line_comment,
  [343388] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22037), 1,
      sym__end_cmd,
    STATE(15869), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15865), 2,
      sym_block_comment,
      sym_line_comment,
  [343409] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22037), 1,
      sym__end_cmd,
    STATE(15870), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15866), 2,
      sym_block_comment,
      sym_line_comment,
  [343430] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22039), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15867), 2,
      sym_block_comment,
      sym_line_comment,
  [343451] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22039), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15868), 2,
      sym_block_comment,
      sym_line_comment,
  [343472] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22041), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15869), 2,
      sym_block_comment,
      sym_line_comment,
  [343493] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22041), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15870), 2,
      sym_block_comment,
      sym_line_comment,
  [343514] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22043), 1,
      sym__end_str,
    STATE(15875), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15871), 2,
      sym_block_comment,
      sym_line_comment,
  [343535] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22043), 1,
      sym__end_str,
    STATE(15876), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15872), 2,
      sym_block_comment,
      sym_line_comment,
  [343556] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22045), 1,
      sym__end_cmd,
    STATE(15877), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15873), 2,
      sym_block_comment,
      sym_line_comment,
  [343577] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22045), 1,
      sym__end_cmd,
    STATE(15878), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15874), 2,
      sym_block_comment,
      sym_line_comment,
  [343598] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22047), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15875), 2,
      sym_block_comment,
      sym_line_comment,
  [343619] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22047), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15876), 2,
      sym_block_comment,
      sym_line_comment,
  [343640] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22049), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15877), 2,
      sym_block_comment,
      sym_line_comment,
  [343661] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22049), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15878), 2,
      sym_block_comment,
      sym_line_comment,
  [343682] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22051), 1,
      sym__end_str,
    STATE(15883), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15879), 2,
      sym_block_comment,
      sym_line_comment,
  [343703] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22051), 1,
      sym__end_str,
    STATE(15884), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15880), 2,
      sym_block_comment,
      sym_line_comment,
  [343724] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22053), 1,
      sym__end_cmd,
    STATE(15885), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15881), 2,
      sym_block_comment,
      sym_line_comment,
  [343745] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22053), 1,
      sym__end_cmd,
    STATE(15886), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15882), 2,
      sym_block_comment,
      sym_line_comment,
  [343766] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22055), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15883), 2,
      sym_block_comment,
      sym_line_comment,
  [343787] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22055), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15884), 2,
      sym_block_comment,
      sym_line_comment,
  [343808] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22057), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15885), 2,
      sym_block_comment,
      sym_line_comment,
  [343829] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22057), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15886), 2,
      sym_block_comment,
      sym_line_comment,
  [343850] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22059), 1,
      sym__end_str,
    STATE(15891), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15887), 2,
      sym_block_comment,
      sym_line_comment,
  [343871] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22059), 1,
      sym__end_str,
    STATE(15892), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15888), 2,
      sym_block_comment,
      sym_line_comment,
  [343892] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22061), 1,
      sym__end_cmd,
    STATE(15893), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15889), 2,
      sym_block_comment,
      sym_line_comment,
  [343913] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22061), 1,
      sym__end_cmd,
    STATE(15894), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15890), 2,
      sym_block_comment,
      sym_line_comment,
  [343934] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22063), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15891), 2,
      sym_block_comment,
      sym_line_comment,
  [343955] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22063), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15892), 2,
      sym_block_comment,
      sym_line_comment,
  [343976] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22065), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15893), 2,
      sym_block_comment,
      sym_line_comment,
  [343997] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22065), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15894), 2,
      sym_block_comment,
      sym_line_comment,
  [344018] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22067), 1,
      sym__end_str,
    STATE(15899), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15895), 2,
      sym_block_comment,
      sym_line_comment,
  [344039] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22067), 1,
      sym__end_str,
    STATE(15900), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15896), 2,
      sym_block_comment,
      sym_line_comment,
  [344060] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22069), 1,
      sym__end_cmd,
    STATE(15901), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15897), 2,
      sym_block_comment,
      sym_line_comment,
  [344081] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22069), 1,
      sym__end_cmd,
    STATE(15902), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15898), 2,
      sym_block_comment,
      sym_line_comment,
  [344102] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22071), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15899), 2,
      sym_block_comment,
      sym_line_comment,
  [344123] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22071), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15900), 2,
      sym_block_comment,
      sym_line_comment,
  [344144] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22073), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15901), 2,
      sym_block_comment,
      sym_line_comment,
  [344165] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22073), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15902), 2,
      sym_block_comment,
      sym_line_comment,
  [344186] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22075), 1,
      sym__end_str,
    STATE(15907), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15903), 2,
      sym_block_comment,
      sym_line_comment,
  [344207] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22075), 1,
      sym__end_str,
    STATE(15908), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15904), 2,
      sym_block_comment,
      sym_line_comment,
  [344228] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22077), 1,
      sym__end_cmd,
    STATE(15909), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15905), 2,
      sym_block_comment,
      sym_line_comment,
  [344249] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22077), 1,
      sym__end_cmd,
    STATE(15910), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15906), 2,
      sym_block_comment,
      sym_line_comment,
  [344270] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22079), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15907), 2,
      sym_block_comment,
      sym_line_comment,
  [344291] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22079), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15908), 2,
      sym_block_comment,
      sym_line_comment,
  [344312] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22081), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15909), 2,
      sym_block_comment,
      sym_line_comment,
  [344333] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22081), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15910), 2,
      sym_block_comment,
      sym_line_comment,
  [344354] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22083), 1,
      sym__end_str,
    STATE(15916), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15911), 2,
      sym_block_comment,
      sym_line_comment,
  [344375] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22083), 1,
      sym__end_str,
    STATE(15917), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15912), 2,
      sym_block_comment,
      sym_line_comment,
  [344396] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22085), 1,
      sym__end_cmd,
    STATE(15918), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15913), 2,
      sym_block_comment,
      sym_line_comment,
  [344417] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22085), 1,
      sym__end_cmd,
    STATE(15919), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15914), 2,
      sym_block_comment,
      sym_line_comment,
  [344438] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22087), 1,
      anon_sym_COMMA,
    ACTIONS(22089), 1,
      anon_sym_RPAREN,
    STATE(16038), 1,
      aux_sym_argument_list_repeat1,
    STATE(15915), 2,
      sym_block_comment,
      sym_line_comment,
  [344461] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22091), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15916), 2,
      sym_block_comment,
      sym_line_comment,
  [344482] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22091), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15917), 2,
      sym_block_comment,
      sym_line_comment,
  [344503] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22093), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15918), 2,
      sym_block_comment,
      sym_line_comment,
  [344524] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22093), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15919), 2,
      sym_block_comment,
      sym_line_comment,
  [344545] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22095), 1,
      sym__end_str,
    STATE(15924), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15920), 2,
      sym_block_comment,
      sym_line_comment,
  [344566] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22095), 1,
      sym__end_str,
    STATE(15925), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15921), 2,
      sym_block_comment,
      sym_line_comment,
  [344587] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22097), 1,
      sym__end_cmd,
    STATE(15926), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15922), 2,
      sym_block_comment,
      sym_line_comment,
  [344608] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22097), 1,
      sym__end_cmd,
    STATE(15927), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15923), 2,
      sym_block_comment,
      sym_line_comment,
  [344629] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22099), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15924), 2,
      sym_block_comment,
      sym_line_comment,
  [344650] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22099), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15925), 2,
      sym_block_comment,
      sym_line_comment,
  [344671] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22101), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15926), 2,
      sym_block_comment,
      sym_line_comment,
  [344692] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22101), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15927), 2,
      sym_block_comment,
      sym_line_comment,
  [344713] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22103), 1,
      sym__end_str,
    STATE(15932), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15928), 2,
      sym_block_comment,
      sym_line_comment,
  [344734] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22103), 1,
      sym__end_str,
    STATE(15933), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15929), 2,
      sym_block_comment,
      sym_line_comment,
  [344755] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22105), 1,
      sym__end_cmd,
    STATE(15934), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15930), 2,
      sym_block_comment,
      sym_line_comment,
  [344776] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22105), 1,
      sym__end_cmd,
    STATE(15935), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15931), 2,
      sym_block_comment,
      sym_line_comment,
  [344797] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22107), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15932), 2,
      sym_block_comment,
      sym_line_comment,
  [344818] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22107), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15933), 2,
      sym_block_comment,
      sym_line_comment,
  [344839] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22109), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15934), 2,
      sym_block_comment,
      sym_line_comment,
  [344860] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22109), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15935), 2,
      sym_block_comment,
      sym_line_comment,
  [344881] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22111), 1,
      sym__end_str,
    STATE(15940), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15936), 2,
      sym_block_comment,
      sym_line_comment,
  [344902] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22111), 1,
      sym__end_str,
    STATE(15941), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15937), 2,
      sym_block_comment,
      sym_line_comment,
  [344923] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22113), 1,
      sym__end_cmd,
    STATE(15942), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15938), 2,
      sym_block_comment,
      sym_line_comment,
  [344944] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22113), 1,
      sym__end_cmd,
    STATE(15943), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15939), 2,
      sym_block_comment,
      sym_line_comment,
  [344965] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22115), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15940), 2,
      sym_block_comment,
      sym_line_comment,
  [344986] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22115), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15941), 2,
      sym_block_comment,
      sym_line_comment,
  [345007] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22117), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15942), 2,
      sym_block_comment,
      sym_line_comment,
  [345028] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22117), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15943), 2,
      sym_block_comment,
      sym_line_comment,
  [345049] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22119), 1,
      sym__end_str,
    STATE(15948), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15944), 2,
      sym_block_comment,
      sym_line_comment,
  [345070] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22119), 1,
      sym__end_str,
    STATE(15949), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15945), 2,
      sym_block_comment,
      sym_line_comment,
  [345091] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22121), 1,
      sym__end_cmd,
    STATE(15950), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15946), 2,
      sym_block_comment,
      sym_line_comment,
  [345112] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22121), 1,
      sym__end_cmd,
    STATE(15951), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15947), 2,
      sym_block_comment,
      sym_line_comment,
  [345133] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22123), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15948), 2,
      sym_block_comment,
      sym_line_comment,
  [345154] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22123), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15949), 2,
      sym_block_comment,
      sym_line_comment,
  [345175] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22125), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15950), 2,
      sym_block_comment,
      sym_line_comment,
  [345196] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22125), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15951), 2,
      sym_block_comment,
      sym_line_comment,
  [345217] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22127), 1,
      sym__end_str,
    STATE(15956), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15952), 2,
      sym_block_comment,
      sym_line_comment,
  [345238] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22127), 1,
      sym__end_str,
    STATE(15957), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15953), 2,
      sym_block_comment,
      sym_line_comment,
  [345259] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22129), 1,
      sym__end_cmd,
    STATE(15958), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15954), 2,
      sym_block_comment,
      sym_line_comment,
  [345280] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22129), 1,
      sym__end_cmd,
    STATE(15959), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15955), 2,
      sym_block_comment,
      sym_line_comment,
  [345301] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22131), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15956), 2,
      sym_block_comment,
      sym_line_comment,
  [345322] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22131), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15957), 2,
      sym_block_comment,
      sym_line_comment,
  [345343] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22133), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15958), 2,
      sym_block_comment,
      sym_line_comment,
  [345364] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22133), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15959), 2,
      sym_block_comment,
      sym_line_comment,
  [345385] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22135), 1,
      sym__end_str,
    STATE(15964), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15960), 2,
      sym_block_comment,
      sym_line_comment,
  [345406] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22135), 1,
      sym__end_str,
    STATE(15965), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15961), 2,
      sym_block_comment,
      sym_line_comment,
  [345427] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22137), 1,
      sym__end_cmd,
    STATE(15966), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15962), 2,
      sym_block_comment,
      sym_line_comment,
  [345448] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22137), 1,
      sym__end_cmd,
    STATE(15967), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15963), 2,
      sym_block_comment,
      sym_line_comment,
  [345469] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22139), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15964), 2,
      sym_block_comment,
      sym_line_comment,
  [345490] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22139), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15965), 2,
      sym_block_comment,
      sym_line_comment,
  [345511] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22141), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15966), 2,
      sym_block_comment,
      sym_line_comment,
  [345532] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22141), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15967), 2,
      sym_block_comment,
      sym_line_comment,
  [345553] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22143), 1,
      sym__end_str,
    STATE(15972), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15968), 2,
      sym_block_comment,
      sym_line_comment,
  [345574] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22143), 1,
      sym__end_str,
    STATE(15973), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15969), 2,
      sym_block_comment,
      sym_line_comment,
  [345595] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22145), 1,
      sym__end_cmd,
    STATE(15974), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15970), 2,
      sym_block_comment,
      sym_line_comment,
  [345616] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22145), 1,
      sym__end_cmd,
    STATE(15975), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15971), 2,
      sym_block_comment,
      sym_line_comment,
  [345637] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22147), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15972), 2,
      sym_block_comment,
      sym_line_comment,
  [345658] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22147), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15973), 2,
      sym_block_comment,
      sym_line_comment,
  [345679] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22149), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15974), 2,
      sym_block_comment,
      sym_line_comment,
  [345700] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22149), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15975), 2,
      sym_block_comment,
      sym_line_comment,
  [345721] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22151), 1,
      sym__end_str,
    STATE(15981), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15976), 2,
      sym_block_comment,
      sym_line_comment,
  [345742] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22151), 1,
      sym__end_str,
    STATE(15982), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15977), 2,
      sym_block_comment,
      sym_line_comment,
  [345763] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22153), 1,
      sym__end_cmd,
    STATE(15983), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15978), 2,
      sym_block_comment,
      sym_line_comment,
  [345784] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22153), 1,
      sym__end_cmd,
    STATE(15984), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15979), 2,
      sym_block_comment,
      sym_line_comment,
  [345805] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22155), 1,
      anon_sym_COMMA,
    ACTIONS(22157), 1,
      anon_sym_RPAREN,
    STATE(16136), 1,
      aux_sym_argument_list_repeat1,
    STATE(15980), 2,
      sym_block_comment,
      sym_line_comment,
  [345828] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22159), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15981), 2,
      sym_block_comment,
      sym_line_comment,
  [345849] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22159), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15982), 2,
      sym_block_comment,
      sym_line_comment,
  [345870] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22161), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15983), 2,
      sym_block_comment,
      sym_line_comment,
  [345891] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22161), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15984), 2,
      sym_block_comment,
      sym_line_comment,
  [345912] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22163), 1,
      sym__end_str,
    STATE(15989), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15985), 2,
      sym_block_comment,
      sym_line_comment,
  [345933] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22163), 1,
      sym__end_str,
    STATE(15990), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15986), 2,
      sym_block_comment,
      sym_line_comment,
  [345954] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22165), 1,
      sym__end_cmd,
    STATE(15991), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15987), 2,
      sym_block_comment,
      sym_line_comment,
  [345975] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22165), 1,
      sym__end_cmd,
    STATE(15992), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15988), 2,
      sym_block_comment,
      sym_line_comment,
  [345996] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22167), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15989), 2,
      sym_block_comment,
      sym_line_comment,
  [346017] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22167), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15990), 2,
      sym_block_comment,
      sym_line_comment,
  [346038] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22169), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15991), 2,
      sym_block_comment,
      sym_line_comment,
  [346059] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22169), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15992), 2,
      sym_block_comment,
      sym_line_comment,
  [346080] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22171), 1,
      sym__end_str,
    STATE(15997), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15993), 2,
      sym_block_comment,
      sym_line_comment,
  [346101] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22171), 1,
      sym__end_str,
    STATE(15998), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15994), 2,
      sym_block_comment,
      sym_line_comment,
  [346122] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22173), 1,
      sym__end_cmd,
    STATE(15999), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15995), 2,
      sym_block_comment,
      sym_line_comment,
  [346143] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22173), 1,
      sym__end_cmd,
    STATE(16000), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(15996), 2,
      sym_block_comment,
      sym_line_comment,
  [346164] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22175), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(15997), 2,
      sym_block_comment,
      sym_line_comment,
  [346185] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22175), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(15998), 2,
      sym_block_comment,
      sym_line_comment,
  [346206] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22177), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(15999), 2,
      sym_block_comment,
      sym_line_comment,
  [346227] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22177), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16000), 2,
      sym_block_comment,
      sym_line_comment,
  [346248] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22179), 1,
      sym__end_str,
    STATE(16005), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16001), 2,
      sym_block_comment,
      sym_line_comment,
  [346269] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22179), 1,
      sym__end_str,
    STATE(16006), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16002), 2,
      sym_block_comment,
      sym_line_comment,
  [346290] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22181), 1,
      sym__end_cmd,
    STATE(16007), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16003), 2,
      sym_block_comment,
      sym_line_comment,
  [346311] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22181), 1,
      sym__end_cmd,
    STATE(16008), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16004), 2,
      sym_block_comment,
      sym_line_comment,
  [346332] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22183), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16005), 2,
      sym_block_comment,
      sym_line_comment,
  [346353] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22183), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16006), 2,
      sym_block_comment,
      sym_line_comment,
  [346374] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22185), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16007), 2,
      sym_block_comment,
      sym_line_comment,
  [346395] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22185), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16008), 2,
      sym_block_comment,
      sym_line_comment,
  [346416] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22187), 1,
      sym__end_str,
    STATE(16013), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16009), 2,
      sym_block_comment,
      sym_line_comment,
  [346437] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22187), 1,
      sym__end_str,
    STATE(16014), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16010), 2,
      sym_block_comment,
      sym_line_comment,
  [346458] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22189), 1,
      sym__end_cmd,
    STATE(16015), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16011), 2,
      sym_block_comment,
      sym_line_comment,
  [346479] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22189), 1,
      sym__end_cmd,
    STATE(16016), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16012), 2,
      sym_block_comment,
      sym_line_comment,
  [346500] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22191), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16013), 2,
      sym_block_comment,
      sym_line_comment,
  [346521] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22191), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16014), 2,
      sym_block_comment,
      sym_line_comment,
  [346542] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22193), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16015), 2,
      sym_block_comment,
      sym_line_comment,
  [346563] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22193), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16016), 2,
      sym_block_comment,
      sym_line_comment,
  [346584] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22195), 1,
      sym__end_str,
    STATE(16021), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16017), 2,
      sym_block_comment,
      sym_line_comment,
  [346605] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22195), 1,
      sym__end_str,
    STATE(16022), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16018), 2,
      sym_block_comment,
      sym_line_comment,
  [346626] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22197), 1,
      sym__end_cmd,
    STATE(16023), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16019), 2,
      sym_block_comment,
      sym_line_comment,
  [346647] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22197), 1,
      sym__end_cmd,
    STATE(16024), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16020), 2,
      sym_block_comment,
      sym_line_comment,
  [346668] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22199), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16021), 2,
      sym_block_comment,
      sym_line_comment,
  [346689] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22199), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16022), 2,
      sym_block_comment,
      sym_line_comment,
  [346710] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22201), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16023), 2,
      sym_block_comment,
      sym_line_comment,
  [346731] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22201), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16024), 2,
      sym_block_comment,
      sym_line_comment,
  [346752] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22203), 1,
      sym__end_str,
    STATE(16029), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16025), 2,
      sym_block_comment,
      sym_line_comment,
  [346773] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22203), 1,
      sym__end_str,
    STATE(16030), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16026), 2,
      sym_block_comment,
      sym_line_comment,
  [346794] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22205), 1,
      sym__end_cmd,
    STATE(16031), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16027), 2,
      sym_block_comment,
      sym_line_comment,
  [346815] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22205), 1,
      sym__end_cmd,
    STATE(16032), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16028), 2,
      sym_block_comment,
      sym_line_comment,
  [346836] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22207), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16029), 2,
      sym_block_comment,
      sym_line_comment,
  [346857] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22207), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16030), 2,
      sym_block_comment,
      sym_line_comment,
  [346878] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22209), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16031), 2,
      sym_block_comment,
      sym_line_comment,
  [346899] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22209), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16032), 2,
      sym_block_comment,
      sym_line_comment,
  [346920] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22211), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16033), 2,
      sym_block_comment,
      sym_line_comment,
  [346941] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16034), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10118), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [346958] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22211), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16035), 2,
      sym_block_comment,
      sym_line_comment,
  [346979] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22213), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16036), 2,
      sym_block_comment,
      sym_line_comment,
  [347000] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22213), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16037), 2,
      sym_block_comment,
      sym_line_comment,
  [347021] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7430), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22215), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16038), 2,
      sym_block_comment,
      sym_line_comment,
  [347044] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22217), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16039), 2,
      sym_block_comment,
      sym_line_comment,
  [347065] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22217), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16040), 2,
      sym_block_comment,
      sym_line_comment,
  [347086] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(523), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16041), 2,
      sym_block_comment,
      sym_line_comment,
  [347107] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22223), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16042), 2,
      sym_block_comment,
      sym_line_comment,
  [347128] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21805), 1,
      sym__end_cmd,
    STATE(15416), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16043), 2,
      sym_block_comment,
      sym_line_comment,
  [347149] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7884), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22225), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16044), 2,
      sym_block_comment,
      sym_line_comment,
  [347172] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16045), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21386), 4,
      sym__content_str_3,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [347189] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22223), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16046), 2,
      sym_block_comment,
      sym_line_comment,
  [347210] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22227), 1,
      anon_sym_RBRACK,
    ACTIONS(22229), 1,
      aux_sym__terminator_token1,
    ACTIONS(22231), 1,
      aux_sym__terminator_token2,
    STATE(16079), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16047), 2,
      sym_block_comment,
      sym_line_comment,
  [347233] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7888), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17260), 1,
      anon_sym_COMMA,
    STATE(16156), 1,
      aux_sym_argument_list_repeat1,
    STATE(16048), 2,
      sym_block_comment,
      sym_line_comment,
  [347256] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22233), 1,
      aux_sym__terminator_token1,
    ACTIONS(22235), 1,
      aux_sym__terminator_token2,
    STATE(16055), 1,
      aux_sym_let_statement_repeat1,
    STATE(16049), 2,
      sym_block_comment,
      sym_line_comment,
  [347279] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15153), 1,
      sym_catch_clause,
    STATE(17506), 1,
      sym_finally_clause,
    STATE(16050), 2,
      sym_block_comment,
      sym_line_comment,
  [347302] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7360), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17364), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16051), 2,
      sym_block_comment,
      sym_line_comment,
  [347325] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22237), 1,
      sym__immediate_string_start,
    ACTIONS(22239), 1,
      sym__immediate_command_start,
    ACTIONS(9664), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(16052), 2,
      sym_block_comment,
      sym_line_comment,
  [347346] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16597), 1,
      sym__delimiter_str_1,
    STATE(16598), 1,
      sym__delimiter_str_3,
    STATE(16053), 2,
      sym_block_comment,
      sym_line_comment,
  [347369] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16599), 1,
      sym__delimiter_cmd_1,
    STATE(16602), 1,
      sym__delimiter_cmd_3,
    STATE(16054), 2,
      sym_block_comment,
      sym_line_comment,
  [347392] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22249), 1,
      aux_sym__terminator_token1,
    ACTIONS(22251), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16055), 2,
      sym_block_comment,
      sym_line_comment,
  [347415] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22253), 1,
      aux_sym__terminator_token1,
    ACTIONS(22255), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16056), 2,
      sym_block_comment,
      sym_line_comment,
  [347438] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15318), 1,
      sym_catch_clause,
    STATE(17657), 1,
      sym_finally_clause,
    STATE(16057), 2,
      sym_block_comment,
      sym_line_comment,
  [347461] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7030), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22257), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16058), 2,
      sym_block_comment,
      sym_line_comment,
  [347484] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7340), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22259), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16059), 2,
      sym_block_comment,
      sym_line_comment,
  [347507] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22261), 1,
      anon_sym_RBRACK,
    ACTIONS(22263), 1,
      aux_sym__terminator_token1,
    ACTIONS(22265), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16060), 2,
      sym_block_comment,
      sym_line_comment,
  [347530] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22267), 1,
      anon_sym_RBRACK,
    ACTIONS(22269), 1,
      aux_sym__terminator_token1,
    ACTIONS(22271), 1,
      aux_sym__terminator_token2,
    STATE(16078), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16061), 2,
      sym_block_comment,
      sym_line_comment,
  [347553] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22273), 1,
      anon_sym_COMMA,
    ACTIONS(22275), 1,
      anon_sym_RPAREN,
    STATE(16117), 1,
      aux_sym_argument_list_repeat1,
    STATE(16062), 2,
      sym_block_comment,
      sym_line_comment,
  [347576] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18355), 1,
      sym__word_identifier,
    STATE(17698), 1,
      sym_identifier,
    ACTIONS(9782), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(16063), 2,
      sym_block_comment,
      sym_line_comment,
  [347597] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15398), 1,
      aux_sym__terminator_token2,
    ACTIONS(15400), 1,
      aux_sym__terminator_token1,
    ACTIONS(22277), 1,
      anon_sym_COMMA,
    STATE(16064), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_let_statement_repeat1,
  [347618] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17916), 1,
      ts_builtin_sym_end,
    ACTIONS(17920), 1,
      aux_sym__terminator_token1,
    ACTIONS(17922), 1,
      aux_sym__terminator_token2,
    STATE(17030), 1,
      aux_sym__block_repeat1,
    STATE(16065), 2,
      sym_block_comment,
      sym_line_comment,
  [347641] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7034), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17559), 1,
      anon_sym_COMMA,
    STATE(16564), 1,
      aux_sym_argument_list_repeat1,
    STATE(16066), 2,
      sym_block_comment,
      sym_line_comment,
  [347664] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7562), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22280), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16067), 2,
      sym_block_comment,
      sym_line_comment,
  [347687] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22282), 1,
      sym__end_str,
    STATE(16658), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16068), 2,
      sym_block_comment,
      sym_line_comment,
  [347708] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22282), 1,
      sym__end_str,
    STATE(16661), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16069), 2,
      sym_block_comment,
      sym_line_comment,
  [347729] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22284), 1,
      sym__end_cmd,
    STATE(16662), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16070), 2,
      sym_block_comment,
      sym_line_comment,
  [347750] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22284), 1,
      sym__end_cmd,
    STATE(16667), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16071), 2,
      sym_block_comment,
      sym_line_comment,
  [347771] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7508), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17557), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16072), 2,
      sym_block_comment,
      sym_line_comment,
  [347794] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22286), 1,
      anon_sym_COMMA,
    ACTIONS(22288), 1,
      anon_sym_RPAREN,
    STATE(16862), 1,
      aux_sym_argument_list_repeat1,
    STATE(16073), 2,
      sym_block_comment,
      sym_line_comment,
  [347817] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22290), 1,
      anon_sym_COMMA,
    ACTIONS(22292), 1,
      anon_sym_RPAREN,
    STATE(16085), 1,
      aux_sym_argument_list_repeat1,
    STATE(16074), 2,
      sym_block_comment,
      sym_line_comment,
  [347840] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22294), 1,
      anon_sym_RBRACK,
    ACTIONS(22296), 1,
      aux_sym__terminator_token1,
    ACTIONS(22298), 1,
      aux_sym__terminator_token2,
    STATE(16097), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16075), 2,
      sym_block_comment,
      sym_line_comment,
  [347863] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7898), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22300), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16076), 2,
      sym_block_comment,
      sym_line_comment,
  [347886] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7840), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17708), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16077), 2,
      sym_block_comment,
      sym_line_comment,
  [347909] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22302), 1,
      anon_sym_RBRACK,
    ACTIONS(22304), 1,
      aux_sym__terminator_token1,
    ACTIONS(22306), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16078), 2,
      sym_block_comment,
      sym_line_comment,
  [347932] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22308), 1,
      anon_sym_RBRACK,
    ACTIONS(22310), 1,
      aux_sym__terminator_token1,
    ACTIONS(22312), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16079), 2,
      sym_block_comment,
      sym_line_comment,
  [347955] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(16919), 1,
      anon_sym_end,
    ACTIONS(17961), 1,
      aux_sym__terminator_token1,
    ACTIONS(17963), 1,
      aux_sym__terminator_token2,
    STATE(17044), 1,
      aux_sym__block_repeat1,
    STATE(16080), 2,
      sym_block_comment,
      sym_line_comment,
  [347978] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22314), 1,
      sym__end_str,
    STATE(16098), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16081), 2,
      sym_block_comment,
      sym_line_comment,
  [347999] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22314), 1,
      sym__end_str,
    STATE(16099), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16082), 2,
      sym_block_comment,
      sym_line_comment,
  [348020] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22316), 1,
      sym__end_cmd,
    STATE(16100), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16083), 2,
      sym_block_comment,
      sym_line_comment,
  [348041] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22316), 1,
      sym__end_cmd,
    STATE(16101), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16084), 2,
      sym_block_comment,
      sym_line_comment,
  [348062] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7908), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22318), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16085), 2,
      sym_block_comment,
      sym_line_comment,
  [348085] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7916), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22320), 1,
      anon_sym_COMMA,
    STATE(16103), 1,
      aux_sym_argument_list_repeat1,
    STATE(16086), 2,
      sym_block_comment,
      sym_line_comment,
  [348108] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7916), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22320), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16087), 2,
      sym_block_comment,
      sym_line_comment,
  [348131] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16088), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10154), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [348148] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22322), 1,
      anon_sym_COMMA,
    ACTIONS(22324), 1,
      anon_sym_RPAREN,
    STATE(16119), 1,
      aux_sym_argument_list_repeat1,
    STATE(16089), 2,
      sym_block_comment,
      sym_line_comment,
  [348171] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6982), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22326), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16090), 2,
      sym_block_comment,
      sym_line_comment,
  [348194] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(21456), 1,
      anon_sym_SEMI,
    ACTIONS(22328), 1,
      anon_sym_RPAREN,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16091), 2,
      sym_block_comment,
      sym_line_comment,
  [348217] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(544), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16092), 2,
      sym_block_comment,
      sym_line_comment,
  [348238] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22330), 1,
      anon_sym_COMMA,
    ACTIONS(22332), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_argument_list_repeat1,
    STATE(16093), 2,
      sym_block_comment,
      sym_line_comment,
  [348261] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16094), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21340), 4,
      sym__content_cmd_3,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [348278] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22334), 1,
      sym__end_str,
    STATE(16267), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16095), 2,
      sym_block_comment,
      sym_line_comment,
  [348299] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22336), 1,
      aux_sym__terminator_token1,
    ACTIONS(22338), 1,
      aux_sym__terminator_token2,
    STATE(15765), 1,
      aux_sym_let_statement_repeat1,
    STATE(16096), 2,
      sym_block_comment,
      sym_line_comment,
  [348322] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22340), 1,
      anon_sym_RBRACK,
    ACTIONS(22342), 1,
      aux_sym__terminator_token1,
    ACTIONS(22344), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16097), 2,
      sym_block_comment,
      sym_line_comment,
  [348345] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22346), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16098), 2,
      sym_block_comment,
      sym_line_comment,
  [348366] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22346), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16099), 2,
      sym_block_comment,
      sym_line_comment,
  [348387] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22348), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16100), 2,
      sym_block_comment,
      sym_line_comment,
  [348408] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22348), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16101), 2,
      sym_block_comment,
      sym_line_comment,
  [348429] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22350), 1,
      anon_sym_COMMA,
    ACTIONS(22352), 1,
      anon_sym_RPAREN,
    STATE(16381), 1,
      aux_sym_argument_list_repeat1,
    STATE(16102), 2,
      sym_block_comment,
      sym_line_comment,
  [348452] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7924), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22354), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16103), 2,
      sym_block_comment,
      sym_line_comment,
  [348475] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22334), 1,
      sym__end_str,
    STATE(16270), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16104), 2,
      sym_block_comment,
      sym_line_comment,
  [348496] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7928), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    STATE(16253), 1,
      aux_sym_argument_list_repeat1,
    STATE(16105), 2,
      sym_block_comment,
      sym_line_comment,
  [348519] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22356), 1,
      sym__end_str,
    STATE(16992), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16106), 2,
      sym_block_comment,
      sym_line_comment,
  [348540] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22358), 1,
      sym__end_str,
    STATE(16162), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16107), 2,
      sym_block_comment,
      sym_line_comment,
  [348561] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22360), 1,
      anon_sym_RBRACK,
    ACTIONS(22362), 1,
      aux_sym__terminator_token1,
    ACTIONS(22364), 1,
      aux_sym__terminator_token2,
    STATE(16147), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16108), 2,
      sym_block_comment,
      sym_line_comment,
  [348584] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22366), 1,
      sym__end_str,
    STATE(16130), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16109), 2,
      sym_block_comment,
      sym_line_comment,
  [348605] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22366), 1,
      sym__end_str,
    STATE(16131), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16110), 2,
      sym_block_comment,
      sym_line_comment,
  [348626] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22368), 1,
      sym__end_cmd,
    STATE(16132), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16111), 2,
      sym_block_comment,
      sym_line_comment,
  [348647] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22368), 1,
      sym__end_cmd,
    STATE(16133), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16112), 2,
      sym_block_comment,
      sym_line_comment,
  [348668] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22358), 1,
      sym__end_str,
    STATE(16167), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16113), 2,
      sym_block_comment,
      sym_line_comment,
  [348689] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22370), 1,
      sym__end_cmd,
    STATE(16168), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16114), 2,
      sym_block_comment,
      sym_line_comment,
  [348710] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22370), 1,
      sym__end_cmd,
    STATE(16169), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16115), 2,
      sym_block_comment,
      sym_line_comment,
  [348731] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22356), 1,
      sym__end_str,
    STATE(16993), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16116), 2,
      sym_block_comment,
      sym_line_comment,
  [348752] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7572), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22372), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16117), 2,
      sym_block_comment,
      sym_line_comment,
  [348775] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7580), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22374), 1,
      anon_sym_COMMA,
    STATE(16174), 1,
      aux_sym_argument_list_repeat1,
    STATE(16118), 2,
      sym_block_comment,
      sym_line_comment,
  [348798] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7040), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22376), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16119), 2,
      sym_block_comment,
      sym_line_comment,
  [348821] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7580), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22374), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16120), 2,
      sym_block_comment,
      sym_line_comment,
  [348844] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7050), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22378), 1,
      anon_sym_COMMA,
    STATE(16144), 1,
      aux_sym_argument_list_repeat1,
    STATE(16121), 2,
      sym_block_comment,
      sym_line_comment,
  [348867] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7050), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22378), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16122), 2,
      sym_block_comment,
      sym_line_comment,
  [348890] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22380), 1,
      anon_sym_RBRACK,
    ACTIONS(22382), 1,
      aux_sym__terminator_token1,
    ACTIONS(22384), 1,
      aux_sym__terminator_token2,
    STATE(16142), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16123), 2,
      sym_block_comment,
      sym_line_comment,
  [348913] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22386), 1,
      sym__end_cmd,
    STATE(16995), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16124), 2,
      sym_block_comment,
      sym_line_comment,
  [348934] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22386), 1,
      sym__end_cmd,
    STATE(16999), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16125), 2,
      sym_block_comment,
      sym_line_comment,
  [348955] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22388), 1,
      sym__end_cmd,
    STATE(16281), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16126), 2,
      sym_block_comment,
      sym_line_comment,
  [348976] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22388), 1,
      sym__end_cmd,
    STATE(16292), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16127), 2,
      sym_block_comment,
      sym_line_comment,
  [348997] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7442), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22390), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16128), 2,
      sym_block_comment,
      sym_line_comment,
  [349020] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22392), 1,
      anon_sym_COMMA,
    ACTIONS(22394), 1,
      anon_sym_RPAREN,
    STATE(16745), 1,
      aux_sym_argument_list_repeat1,
    STATE(16129), 2,
      sym_block_comment,
      sym_line_comment,
  [349043] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22396), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16130), 2,
      sym_block_comment,
      sym_line_comment,
  [349064] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22396), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16131), 2,
      sym_block_comment,
      sym_line_comment,
  [349085] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22398), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16132), 2,
      sym_block_comment,
      sym_line_comment,
  [349106] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22398), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16133), 2,
      sym_block_comment,
      sym_line_comment,
  [349127] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22400), 1,
      anon_sym_COMMA,
    ACTIONS(22402), 1,
      anon_sym_RPAREN,
    STATE(16154), 1,
      aux_sym_argument_list_repeat1,
    STATE(16134), 2,
      sym_block_comment,
      sym_line_comment,
  [349150] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22404), 1,
      anon_sym_COMMA,
    ACTIONS(22406), 1,
      anon_sym_RPAREN,
    STATE(16163), 1,
      aux_sym_argument_list_repeat1,
    STATE(16135), 2,
      sym_block_comment,
      sym_line_comment,
  [349173] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7934), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22408), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16136), 2,
      sym_block_comment,
      sym_line_comment,
  [349196] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7448), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22410), 1,
      anon_sym_COMMA,
    STATE(16307), 1,
      aux_sym_argument_list_repeat1,
    STATE(16137), 2,
      sym_block_comment,
      sym_line_comment,
  [349219] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7052), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22412), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16138), 2,
      sym_block_comment,
      sym_line_comment,
  [349242] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7888), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17260), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16139), 2,
      sym_block_comment,
      sym_line_comment,
  [349265] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(22414), 1,
      anon_sym_RPAREN,
    ACTIONS(22416), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16140), 2,
      sym_block_comment,
      sym_line_comment,
  [349288] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6942), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17496), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16141), 2,
      sym_block_comment,
      sym_line_comment,
  [349311] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22418), 1,
      anon_sym_RBRACK,
    ACTIONS(22420), 1,
      aux_sym__terminator_token1,
    ACTIONS(22422), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16142), 2,
      sym_block_comment,
      sym_line_comment,
  [349334] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22424), 1,
      anon_sym_COMMA,
    ACTIONS(22426), 1,
      anon_sym_RPAREN,
    STATE(16794), 1,
      aux_sym_argument_list_repeat1,
    STATE(16143), 2,
      sym_block_comment,
      sym_line_comment,
  [349357] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7090), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22428), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16144), 2,
      sym_block_comment,
      sym_line_comment,
  [349380] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22430), 1,
      anon_sym_COMMA,
    ACTIONS(22432), 1,
      anon_sym_RPAREN,
    STATE(16614), 1,
      aux_sym_argument_list_repeat1,
    STATE(16145), 2,
      sym_block_comment,
      sym_line_comment,
  [349403] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7098), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17702), 1,
      anon_sym_COMMA,
    STATE(16785), 1,
      aux_sym_argument_list_repeat1,
    STATE(16146), 2,
      sym_block_comment,
      sym_line_comment,
  [349426] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22434), 1,
      anon_sym_RBRACK,
    ACTIONS(22436), 1,
      aux_sym__terminator_token1,
    ACTIONS(22438), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16147), 2,
      sym_block_comment,
      sym_line_comment,
  [349449] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7448), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22410), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16148), 2,
      sym_block_comment,
      sym_line_comment,
  [349472] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22440), 1,
      sym__end_str,
    STATE(16176), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16149), 2,
      sym_block_comment,
      sym_line_comment,
  [349493] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22440), 1,
      sym__end_str,
    STATE(16182), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16150), 2,
      sym_block_comment,
      sym_line_comment,
  [349514] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22442), 1,
      sym__end_cmd,
    STATE(16186), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16151), 2,
      sym_block_comment,
      sym_line_comment,
  [349535] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22442), 1,
      sym__end_cmd,
    STATE(16192), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16152), 2,
      sym_block_comment,
      sym_line_comment,
  [349556] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22444), 1,
      anon_sym_RBRACK,
    ACTIONS(22446), 1,
      aux_sym__terminator_token1,
    ACTIONS(22448), 1,
      aux_sym__terminator_token2,
    STATE(16576), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16153), 2,
      sym_block_comment,
      sym_line_comment,
  [349579] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7944), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22450), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16154), 2,
      sym_block_comment,
      sym_line_comment,
  [349602] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7950), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22452), 1,
      anon_sym_COMMA,
    STATE(16193), 1,
      aux_sym_argument_list_repeat1,
    STATE(16155), 2,
      sym_block_comment,
      sym_line_comment,
  [349625] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7950), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22452), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16156), 2,
      sym_block_comment,
      sym_line_comment,
  [349648] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22454), 1,
      sym__end_str,
    STATE(16175), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16157), 2,
      sym_block_comment,
      sym_line_comment,
  [349669] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22454), 1,
      sym__end_str,
    STATE(16177), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16158), 2,
      sym_block_comment,
      sym_line_comment,
  [349690] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22456), 1,
      sym__end_cmd,
    STATE(16179), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16159), 2,
      sym_block_comment,
      sym_line_comment,
  [349711] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22456), 1,
      sym__end_cmd,
    STATE(16183), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16160), 2,
      sym_block_comment,
      sym_line_comment,
  [349732] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22458), 1,
      anon_sym_COMMA,
    ACTIONS(22460), 1,
      anon_sym_RPAREN,
    STATE(16666), 1,
      aux_sym_argument_list_repeat1,
    STATE(16161), 2,
      sym_block_comment,
      sym_line_comment,
  [349755] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22462), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16162), 2,
      sym_block_comment,
      sym_line_comment,
  [349776] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7064), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22464), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16163), 2,
      sym_block_comment,
      sym_line_comment,
  [349799] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7074), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22466), 1,
      anon_sym_COMMA,
    STATE(16194), 1,
      aux_sym_argument_list_repeat1,
    STATE(16164), 2,
      sym_block_comment,
      sym_line_comment,
  [349822] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7074), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22466), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16165), 2,
      sym_block_comment,
      sym_line_comment,
  [349845] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16166), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 4,
      sym__content_str_3,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [349862] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22462), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16167), 2,
      sym_block_comment,
      sym_line_comment,
  [349883] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22468), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16168), 2,
      sym_block_comment,
      sym_line_comment,
  [349904] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22468), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16169), 2,
      sym_block_comment,
      sym_line_comment,
  [349925] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22470), 1,
      anon_sym_COMMA,
    ACTIONS(22472), 1,
      anon_sym_RPAREN,
    STATE(16350), 1,
      aux_sym_argument_list_repeat1,
    STATE(16170), 2,
      sym_block_comment,
      sym_line_comment,
  [349948] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6962), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22474), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16171), 2,
      sym_block_comment,
      sym_line_comment,
  [349971] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(528), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16172), 2,
      sym_block_comment,
      sym_line_comment,
  [349992] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22476), 1,
      anon_sym_COMMA,
    ACTIONS(22478), 1,
      anon_sym_RPAREN,
    STATE(16613), 1,
      aux_sym_argument_list_repeat1,
    STATE(16173), 2,
      sym_block_comment,
      sym_line_comment,
  [350015] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7588), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22480), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16174), 2,
      sym_block_comment,
      sym_line_comment,
  [350038] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22482), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16175), 2,
      sym_block_comment,
      sym_line_comment,
  [350059] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22484), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16176), 2,
      sym_block_comment,
      sym_line_comment,
  [350080] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22482), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16177), 2,
      sym_block_comment,
      sym_line_comment,
  [350101] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22486), 1,
      aux_sym__terminator_token1,
    ACTIONS(22488), 1,
      aux_sym__terminator_token2,
    STATE(16187), 1,
      aux_sym_let_statement_repeat1,
    STATE(16178), 2,
      sym_block_comment,
      sym_line_comment,
  [350124] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22490), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16179), 2,
      sym_block_comment,
      sym_line_comment,
  [350145] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16180), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9734), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [350162] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15114), 1,
      sym_catch_clause,
    STATE(17314), 1,
      sym_finally_clause,
    STATE(16181), 2,
      sym_block_comment,
      sym_line_comment,
  [350185] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22484), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16182), 2,
      sym_block_comment,
      sym_line_comment,
  [350206] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22490), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16183), 2,
      sym_block_comment,
      sym_line_comment,
  [350227] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15504), 1,
      sym__delimiter_str_1,
    STATE(15509), 1,
      sym__delimiter_str_3,
    STATE(16184), 2,
      sym_block_comment,
      sym_line_comment,
  [350250] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15510), 1,
      sym__delimiter_cmd_1,
    STATE(15511), 1,
      sym__delimiter_cmd_3,
    STATE(16185), 2,
      sym_block_comment,
      sym_line_comment,
  [350273] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22492), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16186), 2,
      sym_block_comment,
      sym_line_comment,
  [350294] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22494), 1,
      aux_sym__terminator_token1,
    ACTIONS(22496), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16187), 2,
      sym_block_comment,
      sym_line_comment,
  [350317] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22498), 1,
      aux_sym__terminator_token1,
    ACTIONS(22500), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16188), 2,
      sym_block_comment,
      sym_line_comment,
  [350340] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15311), 1,
      sym_catch_clause,
    STATE(17522), 1,
      sym_finally_clause,
    STATE(16189), 2,
      sym_block_comment,
      sym_line_comment,
  [350363] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16190), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10136), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [350380] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(22502), 1,
      anon_sym_RPAREN,
    ACTIONS(22504), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16191), 2,
      sym_block_comment,
      sym_line_comment,
  [350403] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22492), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16192), 2,
      sym_block_comment,
      sym_line_comment,
  [350424] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7978), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22506), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16193), 2,
      sym_block_comment,
      sym_line_comment,
  [350447] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7084), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22508), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16194), 2,
      sym_block_comment,
      sym_line_comment,
  [350470] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6908), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22510), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16195), 2,
      sym_block_comment,
      sym_line_comment,
  [350493] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7982), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17348), 1,
      anon_sym_COMMA,
    STATE(16551), 1,
      aux_sym_argument_list_repeat1,
    STATE(16196), 2,
      sym_block_comment,
      sym_line_comment,
  [350516] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7592), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17579), 1,
      anon_sym_COMMA,
    STATE(16845), 1,
      aux_sym_argument_list_repeat1,
    STATE(16197), 2,
      sym_block_comment,
      sym_line_comment,
  [350539] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21452), 1,
      anon_sym_COMMA,
    ACTIONS(22512), 1,
      anon_sym_RPAREN,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16198), 2,
      sym_block_comment,
      sym_line_comment,
  [350562] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(513), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16199), 2,
      sym_block_comment,
      sym_line_comment,
  [350583] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8670), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22514), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16200), 2,
      sym_block_comment,
      sym_line_comment,
  [350606] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8750), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22516), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16201), 2,
      sym_block_comment,
      sym_line_comment,
  [350629] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(22518), 1,
      anon_sym_RPAREN,
    ACTIONS(22520), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16202), 2,
      sym_block_comment,
      sym_line_comment,
  [350652] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17615), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16203), 2,
      sym_block_comment,
      sym_line_comment,
  [350675] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22522), 1,
      aux_sym__terminator_token1,
    ACTIONS(22524), 1,
      aux_sym__terminator_token2,
    STATE(16210), 1,
      aux_sym_let_statement_repeat1,
    STATE(16204), 2,
      sym_block_comment,
      sym_line_comment,
  [350698] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15159), 1,
      sym_catch_clause,
    STATE(17509), 1,
      sym_finally_clause,
    STATE(16205), 2,
      sym_block_comment,
      sym_line_comment,
  [350721] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22526), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16206), 2,
      sym_block_comment,
      sym_line_comment,
  [350742] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16109), 1,
      sym__delimiter_str_1,
    STATE(16110), 1,
      sym__delimiter_str_3,
    STATE(16207), 2,
      sym_block_comment,
      sym_line_comment,
  [350765] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16111), 1,
      sym__delimiter_cmd_1,
    STATE(16112), 1,
      sym__delimiter_cmd_3,
    STATE(16208), 2,
      sym_block_comment,
      sym_line_comment,
  [350788] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18355), 1,
      sym__word_identifier,
    STATE(17707), 1,
      sym_identifier,
    ACTIONS(9786), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(16209), 2,
      sym_block_comment,
      sym_line_comment,
  [350809] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22528), 1,
      aux_sym__terminator_token1,
    ACTIONS(22530), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16210), 2,
      sym_block_comment,
      sym_line_comment,
  [350832] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22532), 1,
      aux_sym__terminator_token1,
    ACTIONS(22534), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16211), 2,
      sym_block_comment,
      sym_line_comment,
  [350855] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15261), 1,
      sym_catch_clause,
    STATE(17631), 1,
      sym_finally_clause,
    STATE(16212), 2,
      sym_block_comment,
      sym_line_comment,
  [350878] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22536), 1,
      anon_sym_RBRACK,
    ACTIONS(22538), 1,
      aux_sym__terminator_token1,
    ACTIONS(22540), 1,
      aux_sym__terminator_token2,
    STATE(16236), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16213), 2,
      sym_block_comment,
      sym_line_comment,
  [350901] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7088), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17589), 1,
      anon_sym_COMMA,
    STATE(16639), 1,
      aux_sym_argument_list_repeat1,
    STATE(16214), 2,
      sym_block_comment,
      sym_line_comment,
  [350924] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(551), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16215), 2,
      sym_block_comment,
      sym_line_comment,
  [350945] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16216), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9914), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [350962] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22545), 1,
      sym__end_str,
    ACTIONS(22542), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16217), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_prefixed_string_literal_repeat1,
  [350981] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22547), 1,
      aux_sym__terminator_token1,
    ACTIONS(22549), 1,
      aux_sym__terminator_token2,
    STATE(16225), 1,
      aux_sym_let_statement_repeat1,
    STATE(16218), 2,
      sym_block_comment,
      sym_line_comment,
  [351004] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8380), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22551), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16219), 2,
      sym_block_comment,
      sym_line_comment,
  [351027] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15257), 1,
      sym_catch_clause,
    STATE(17144), 1,
      sym_finally_clause,
    STATE(16220), 2,
      sym_block_comment,
      sym_line_comment,
  [351050] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8756), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22553), 1,
      anon_sym_COMMA,
    STATE(16722), 1,
      aux_sym_argument_list_repeat1,
    STATE(16221), 2,
      sym_block_comment,
      sym_line_comment,
  [351073] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16450), 1,
      sym__delimiter_str_1,
    STATE(16453), 1,
      sym__delimiter_str_3,
    STATE(16222), 2,
      sym_block_comment,
      sym_line_comment,
  [351096] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16456), 1,
      sym__delimiter_cmd_1,
    STATE(16459), 1,
      sym__delimiter_cmd_3,
    STATE(16223), 2,
      sym_block_comment,
      sym_line_comment,
  [351119] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22555), 1,
      anon_sym_COMMA,
    ACTIONS(22557), 1,
      anon_sym_RPAREN,
    STATE(15497), 1,
      aux_sym_argument_list_repeat1,
    STATE(16224), 2,
      sym_block_comment,
      sym_line_comment,
  [351142] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22559), 1,
      aux_sym__terminator_token1,
    ACTIONS(22561), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16225), 2,
      sym_block_comment,
      sym_line_comment,
  [351165] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22563), 1,
      aux_sym__terminator_token1,
    ACTIONS(22565), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16226), 2,
      sym_block_comment,
      sym_line_comment,
  [351188] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15135), 1,
      sym_catch_clause,
    STATE(17470), 1,
      sym_finally_clause,
    STATE(16227), 2,
      sym_block_comment,
      sym_line_comment,
  [351211] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8756), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22553), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16228), 2,
      sym_block_comment,
      sym_line_comment,
  [351234] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22567), 1,
      anon_sym_COMMA,
    ACTIONS(22569), 1,
      anon_sym_RPAREN,
    STATE(16251), 1,
      aux_sym_argument_list_repeat1,
    STATE(16229), 2,
      sym_block_comment,
      sym_line_comment,
  [351257] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7988), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22571), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16230), 2,
      sym_block_comment,
      sym_line_comment,
  [351280] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7386), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22573), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16231), 2,
      sym_block_comment,
      sym_line_comment,
  [351303] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7928), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17308), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16232), 2,
      sym_block_comment,
      sym_line_comment,
  [351326] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(527), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16233), 2,
      sym_block_comment,
      sym_line_comment,
  [351347] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16234), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21386), 4,
      sym__content_cmd_3,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [351364] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(22575), 1,
      anon_sym_RPAREN,
    ACTIONS(22577), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16235), 2,
      sym_block_comment,
      sym_line_comment,
  [351387] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22579), 1,
      anon_sym_RBRACK,
    ACTIONS(22581), 1,
      aux_sym__terminator_token1,
    ACTIONS(22583), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16236), 2,
      sym_block_comment,
      sym_line_comment,
  [351410] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22585), 1,
      aux_sym__terminator_token1,
    ACTIONS(22587), 1,
      aux_sym__terminator_token2,
    STATE(16241), 1,
      aux_sym_let_statement_repeat1,
    STATE(16237), 2,
      sym_block_comment,
      sym_line_comment,
  [351433] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15137), 1,
      sym_catch_clause,
    STATE(17200), 1,
      sym_finally_clause,
    STATE(16238), 2,
      sym_block_comment,
      sym_line_comment,
  [351456] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16763), 1,
      sym__delimiter_str_1,
    STATE(16764), 1,
      sym__delimiter_str_3,
    STATE(16239), 2,
      sym_block_comment,
      sym_line_comment,
  [351479] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16765), 1,
      sym__delimiter_cmd_1,
    STATE(16766), 1,
      sym__delimiter_cmd_3,
    STATE(16240), 2,
      sym_block_comment,
      sym_line_comment,
  [351502] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22589), 1,
      aux_sym__terminator_token1,
    ACTIONS(22591), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16241), 2,
      sym_block_comment,
      sym_line_comment,
  [351525] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22593), 1,
      aux_sym__terminator_token1,
    ACTIONS(22595), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16242), 2,
      sym_block_comment,
      sym_line_comment,
  [351548] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15202), 1,
      sym_catch_clause,
    STATE(17245), 1,
      sym_finally_clause,
    STATE(16243), 2,
      sym_block_comment,
      sym_line_comment,
  [351571] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22600), 1,
      sym__end_str,
    ACTIONS(22597), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16244), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_prefixed_string_literal_repeat2,
  [351590] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22602), 1,
      anon_sym_RBRACK,
    ACTIONS(22604), 1,
      aux_sym__terminator_token1,
    ACTIONS(22606), 1,
      aux_sym__terminator_token2,
    STATE(16431), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16245), 2,
      sym_block_comment,
      sym_line_comment,
  [351613] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22608), 1,
      sym__end_str,
    STATE(16276), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16246), 2,
      sym_block_comment,
      sym_line_comment,
  [351634] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22608), 1,
      sym__end_str,
    STATE(16278), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16247), 2,
      sym_block_comment,
      sym_line_comment,
  [351655] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22610), 1,
      sym__end_cmd,
    STATE(16279), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16248), 2,
      sym_block_comment,
      sym_line_comment,
  [351676] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(562), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16249), 2,
      sym_block_comment,
      sym_line_comment,
  [351697] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22610), 1,
      sym__end_cmd,
    STATE(16280), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16250), 2,
      sym_block_comment,
      sym_line_comment,
  [351718] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7998), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22612), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16251), 2,
      sym_block_comment,
      sym_line_comment,
  [351741] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8006), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22614), 1,
      anon_sym_COMMA,
    STATE(16282), 1,
      aux_sym_argument_list_repeat1,
    STATE(16252), 2,
      sym_block_comment,
      sym_line_comment,
  [351764] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8006), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22614), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16253), 2,
      sym_block_comment,
      sym_line_comment,
  [351787] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22616), 1,
      aux_sym__terminator_token1,
    ACTIONS(22618), 1,
      aux_sym__terminator_token2,
    STATE(16260), 1,
      aux_sym_let_statement_repeat1,
    STATE(16254), 2,
      sym_block_comment,
      sym_line_comment,
  [351810] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(22620), 1,
      anon_sym_RPAREN,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16255), 2,
      sym_block_comment,
      sym_line_comment,
  [351833] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15312), 1,
      sym_catch_clause,
    STATE(17441), 1,
      sym_finally_clause,
    STATE(16256), 2,
      sym_block_comment,
      sym_line_comment,
  [351856] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22622), 1,
      anon_sym_RBRACK,
    ACTIONS(22624), 1,
      aux_sym__terminator_token1,
    ACTIONS(22626), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16257), 2,
      sym_block_comment,
      sym_line_comment,
  [351879] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16943), 1,
      sym__delimiter_str_1,
    STATE(16944), 1,
      sym__delimiter_str_3,
    STATE(16258), 2,
      sym_block_comment,
      sym_line_comment,
  [351902] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16945), 1,
      sym__delimiter_cmd_1,
    STATE(16946), 1,
      sym__delimiter_cmd_3,
    STATE(16259), 2,
      sym_block_comment,
      sym_line_comment,
  [351925] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22628), 1,
      aux_sym__terminator_token1,
    ACTIONS(22630), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16260), 2,
      sym_block_comment,
      sym_line_comment,
  [351948] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22632), 1,
      aux_sym__terminator_token1,
    ACTIONS(22634), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16261), 2,
      sym_block_comment,
      sym_line_comment,
  [351971] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15124), 1,
      sym_catch_clause,
    STATE(17486), 1,
      sym_finally_clause,
    STATE(16262), 2,
      sym_block_comment,
      sym_line_comment,
  [351994] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(505), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16263), 2,
      sym_block_comment,
      sym_line_comment,
  [352015] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22636), 1,
      anon_sym_RBRACK,
    ACTIONS(22638), 1,
      aux_sym__terminator_token1,
    ACTIONS(22640), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16264), 2,
      sym_block_comment,
      sym_line_comment,
  [352038] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22642), 1,
      anon_sym_RBRACK,
    ACTIONS(22644), 1,
      aux_sym__terminator_token1,
    ACTIONS(22646), 1,
      aux_sym__terminator_token2,
    STATE(16545), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16265), 2,
      sym_block_comment,
      sym_line_comment,
  [352061] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22648), 1,
      anon_sym_COMMA,
    ACTIONS(22650), 1,
      anon_sym_RPAREN,
    STATE(16607), 1,
      aux_sym_argument_list_repeat1,
    STATE(16266), 2,
      sym_block_comment,
      sym_line_comment,
  [352084] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22652), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16267), 2,
      sym_block_comment,
      sym_line_comment,
  [352105] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22654), 1,
      aux_sym__terminator_token1,
    ACTIONS(22656), 1,
      aux_sym__terminator_token2,
    STATE(16273), 1,
      aux_sym_let_statement_repeat1,
    STATE(16268), 2,
      sym_block_comment,
      sym_line_comment,
  [352128] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15329), 1,
      sym_catch_clause,
    STATE(17649), 1,
      sym_finally_clause,
    STATE(16269), 2,
      sym_block_comment,
      sym_line_comment,
  [352151] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22652), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16270), 2,
      sym_block_comment,
      sym_line_comment,
  [352172] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17017), 1,
      sym__delimiter_str_1,
    STATE(17042), 1,
      sym__delimiter_str_3,
    STATE(16271), 2,
      sym_block_comment,
      sym_line_comment,
  [352195] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15655), 1,
      sym__delimiter_cmd_1,
    STATE(16043), 1,
      sym__delimiter_cmd_3,
    STATE(16272), 2,
      sym_block_comment,
      sym_line_comment,
  [352218] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22658), 1,
      aux_sym__terminator_token1,
    ACTIONS(22660), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16273), 2,
      sym_block_comment,
      sym_line_comment,
  [352241] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22662), 1,
      aux_sym__terminator_token1,
    ACTIONS(22664), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16274), 2,
      sym_block_comment,
      sym_line_comment,
  [352264] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15217), 1,
      sym_catch_clause,
    STATE(17547), 1,
      sym_finally_clause,
    STATE(16275), 2,
      sym_block_comment,
      sym_line_comment,
  [352287] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22666), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16276), 2,
      sym_block_comment,
      sym_line_comment,
  [352308] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(535), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16277), 2,
      sym_block_comment,
      sym_line_comment,
  [352329] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22666), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16278), 2,
      sym_block_comment,
      sym_line_comment,
  [352350] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22668), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16279), 2,
      sym_block_comment,
      sym_line_comment,
  [352371] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22668), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16280), 2,
      sym_block_comment,
      sym_line_comment,
  [352392] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22670), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16281), 2,
      sym_block_comment,
      sym_line_comment,
  [352413] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8014), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22672), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16282), 2,
      sym_block_comment,
      sym_line_comment,
  [352436] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22674), 1,
      aux_sym__terminator_token1,
    ACTIONS(22676), 1,
      aux_sym__terminator_token2,
    STATE(16289), 1,
      aux_sym_let_statement_repeat1,
    STATE(16283), 2,
      sym_block_comment,
      sym_line_comment,
  [352459] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15274), 1,
      sym_catch_clause,
    STATE(17629), 1,
      sym_finally_clause,
    STATE(16284), 2,
      sym_block_comment,
      sym_line_comment,
  [352482] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16285), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3075), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [352499] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16068), 1,
      sym__delimiter_str_1,
    STATE(16069), 1,
      sym__delimiter_str_3,
    STATE(16286), 2,
      sym_block_comment,
      sym_line_comment,
  [352522] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16070), 1,
      sym__delimiter_cmd_1,
    STATE(16071), 1,
      sym__delimiter_cmd_3,
    STATE(16287), 2,
      sym_block_comment,
      sym_line_comment,
  [352545] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8018), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17358), 1,
      anon_sym_COMMA,
    STATE(16624), 1,
      aux_sym_argument_list_repeat1,
    STATE(16288), 2,
      sym_block_comment,
      sym_line_comment,
  [352568] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22678), 1,
      aux_sym__terminator_token1,
    ACTIONS(22680), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16289), 2,
      sym_block_comment,
      sym_line_comment,
  [352591] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22682), 1,
      aux_sym__terminator_token1,
    ACTIONS(22684), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16290), 2,
      sym_block_comment,
      sym_line_comment,
  [352614] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15233), 1,
      sym_catch_clause,
    STATE(17187), 1,
      sym_finally_clause,
    STATE(16291), 2,
      sym_block_comment,
      sym_line_comment,
  [352637] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22670), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16292), 2,
      sym_block_comment,
      sym_line_comment,
  [352658] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(552), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16293), 2,
      sym_block_comment,
      sym_line_comment,
  [352679] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22686), 1,
      sym__end_str,
    STATE(16696), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16294), 2,
      sym_block_comment,
      sym_line_comment,
  [352700] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22686), 1,
      sym__end_str,
    STATE(16717), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16295), 2,
      sym_block_comment,
      sym_line_comment,
  [352721] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22688), 1,
      sym__end_cmd,
    STATE(16719), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16296), 2,
      sym_block_comment,
      sym_line_comment,
  [352742] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22688), 1,
      sym__end_cmd,
    STATE(16746), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16297), 2,
      sym_block_comment,
      sym_line_comment,
  [352763] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22690), 1,
      aux_sym__terminator_token1,
    ACTIONS(22692), 1,
      aux_sym__terminator_token2,
    STATE(16302), 1,
      aux_sym_let_statement_repeat1,
    STATE(16298), 2,
      sym_block_comment,
      sym_line_comment,
  [352786] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15178), 1,
      sym_catch_clause,
    STATE(17184), 1,
      sym_finally_clause,
    STATE(16299), 2,
      sym_block_comment,
      sym_line_comment,
  [352809] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16106), 1,
      sym__delimiter_str_1,
    STATE(16116), 1,
      sym__delimiter_str_3,
    STATE(16300), 2,
      sym_block_comment,
      sym_line_comment,
  [352832] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16124), 1,
      sym__delimiter_cmd_1,
    STATE(16125), 1,
      sym__delimiter_cmd_3,
    STATE(16301), 2,
      sym_block_comment,
      sym_line_comment,
  [352855] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22694), 1,
      aux_sym__terminator_token1,
    ACTIONS(22696), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16302), 2,
      sym_block_comment,
      sym_line_comment,
  [352878] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22698), 1,
      aux_sym__terminator_token1,
    ACTIONS(22700), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16303), 2,
      sym_block_comment,
      sym_line_comment,
  [352901] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15151), 1,
      sym_catch_clause,
    STATE(17099), 1,
      sym_finally_clause,
    STATE(16304), 2,
      sym_block_comment,
      sym_line_comment,
  [352924] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(569), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16305), 2,
      sym_block_comment,
      sym_line_comment,
  [352945] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18461), 1,
      anon_sym_COMMA,
    STATE(16849), 1,
      aux_sym_open_tuple_repeat1,
    ACTIONS(10833), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    STATE(16306), 2,
      sym_block_comment,
      sym_line_comment,
  [352966] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7458), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22702), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16307), 2,
      sym_block_comment,
      sym_line_comment,
  [352989] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22704), 1,
      aux_sym__terminator_token1,
    ACTIONS(22706), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16308), 2,
      sym_block_comment,
      sym_line_comment,
  [353012] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22708), 1,
      aux_sym__terminator_token1,
    ACTIONS(22710), 1,
      aux_sym__terminator_token2,
    STATE(16314), 1,
      aux_sym_let_statement_repeat1,
    STATE(16309), 2,
      sym_block_comment,
      sym_line_comment,
  [353035] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22712), 1,
      anon_sym_COMMA,
    ACTIONS(22714), 1,
      anon_sym_RPAREN,
    STATE(16561), 1,
      aux_sym_argument_list_repeat1,
    STATE(16310), 2,
      sym_block_comment,
      sym_line_comment,
  [353058] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15120), 1,
      sym_catch_clause,
    STATE(17576), 1,
      sym_finally_clause,
    STATE(16311), 2,
      sym_block_comment,
      sym_line_comment,
  [353081] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16294), 1,
      sym__delimiter_str_1,
    STATE(16295), 1,
      sym__delimiter_str_3,
    STATE(16312), 2,
      sym_block_comment,
      sym_line_comment,
  [353104] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16296), 1,
      sym__delimiter_cmd_1,
    STATE(16297), 1,
      sym__delimiter_cmd_3,
    STATE(16313), 2,
      sym_block_comment,
      sym_line_comment,
  [353127] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22716), 1,
      aux_sym__terminator_token1,
    ACTIONS(22718), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16314), 2,
      sym_block_comment,
      sym_line_comment,
  [353150] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22720), 1,
      aux_sym__terminator_token1,
    ACTIONS(22722), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16315), 2,
      sym_block_comment,
      sym_line_comment,
  [353173] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15316), 1,
      sym_catch_clause,
    STATE(17527), 1,
      sym_finally_clause,
    STATE(16316), 2,
      sym_block_comment,
      sym_line_comment,
  [353196] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22219), 1,
      sym__word_identifier,
    ACTIONS(22221), 1,
      anon_sym_DOLLAR,
    STATE(557), 2,
      sym_interpolation_expression,
      sym_identifier,
    STATE(16317), 2,
      sym_block_comment,
      sym_line_comment,
  [353217] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22724), 1,
      anon_sym_RBRACK,
    ACTIONS(22726), 1,
      aux_sym__terminator_token1,
    ACTIONS(22728), 1,
      aux_sym__terminator_token2,
    STATE(16386), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16318), 2,
      sym_block_comment,
      sym_line_comment,
  [353240] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22730), 1,
      anon_sym_RBRACK,
    ACTIONS(22732), 1,
      aux_sym__terminator_token1,
    ACTIONS(22734), 1,
      aux_sym__terminator_token2,
    STATE(16421), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16319), 2,
      sym_block_comment,
      sym_line_comment,
  [353263] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22736), 1,
      anon_sym_RBRACK,
    ACTIONS(22738), 1,
      aux_sym__terminator_token1,
    ACTIONS(22740), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16320), 2,
      sym_block_comment,
      sym_line_comment,
  [353286] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22742), 1,
      aux_sym__terminator_token1,
    ACTIONS(22744), 1,
      aux_sym__terminator_token2,
    STATE(16325), 1,
      aux_sym_let_statement_repeat1,
    STATE(16321), 2,
      sym_block_comment,
      sym_line_comment,
  [353309] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15209), 1,
      sym_catch_clause,
    STATE(17399), 1,
      sym_finally_clause,
    STATE(16322), 2,
      sym_block_comment,
      sym_line_comment,
  [353332] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15602), 1,
      sym__delimiter_str_1,
    STATE(15612), 1,
      sym__delimiter_str_3,
    STATE(16323), 2,
      sym_block_comment,
      sym_line_comment,
  [353355] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15617), 1,
      sym__delimiter_cmd_1,
    STATE(15618), 1,
      sym__delimiter_cmd_3,
    STATE(16324), 2,
      sym_block_comment,
      sym_line_comment,
  [353378] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22746), 1,
      aux_sym__terminator_token1,
    ACTIONS(22748), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16325), 2,
      sym_block_comment,
      sym_line_comment,
  [353401] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15218), 1,
      anon_sym_COMMA,
    ACTIONS(22750), 1,
      aux_sym__terminator_token1,
    ACTIONS(22752), 1,
      aux_sym__terminator_token2,
    STATE(16064), 1,
      aux_sym_let_statement_repeat1,
    STATE(16326), 2,
      sym_block_comment,
      sym_line_comment,
  [353424] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15235), 1,
      sym_catch_clause,
    STATE(17142), 1,
      sym_finally_clause,
    STATE(16327), 2,
      sym_block_comment,
      sym_line_comment,
  [353447] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16157), 1,
      sym__delimiter_str_1,
    STATE(16158), 1,
      sym__delimiter_str_3,
    STATE(16328), 2,
      sym_block_comment,
      sym_line_comment,
  [353470] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16159), 1,
      sym__delimiter_cmd_1,
    STATE(16160), 1,
      sym__delimiter_cmd_3,
    STATE(16329), 2,
      sym_block_comment,
      sym_line_comment,
  [353493] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16557), 1,
      sym__delimiter_str_1,
    STATE(16558), 1,
      sym__delimiter_str_3,
    STATE(16330), 2,
      sym_block_comment,
      sym_line_comment,
  [353516] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16559), 1,
      sym__delimiter_cmd_1,
    STATE(16560), 1,
      sym__delimiter_cmd_3,
    STATE(16331), 2,
      sym_block_comment,
      sym_line_comment,
  [353539] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17539), 1,
      anon_sym_COMMA,
    STATE(15537), 1,
      aux_sym_argument_list_repeat1,
    STATE(16332), 2,
      sym_block_comment,
      sym_line_comment,
  [353562] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16631), 1,
      sym__delimiter_str_1,
    STATE(16632), 1,
      sym__delimiter_str_3,
    STATE(16333), 2,
      sym_block_comment,
      sym_line_comment,
  [353585] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16634), 1,
      sym__delimiter_cmd_1,
    STATE(16635), 1,
      sym__delimiter_cmd_3,
    STATE(16334), 2,
      sym_block_comment,
      sym_line_comment,
  [353608] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7598), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22754), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16335), 2,
      sym_block_comment,
      sym_line_comment,
  [353631] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7462), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17543), 1,
      anon_sym_COMMA,
    STATE(15558), 1,
      aux_sym_argument_list_repeat1,
    STATE(16336), 2,
      sym_block_comment,
      sym_line_comment,
  [353654] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16707), 1,
      sym__delimiter_str_1,
    STATE(16709), 1,
      sym__delimiter_str_3,
    STATE(16337), 2,
      sym_block_comment,
      sym_line_comment,
  [353677] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16710), 1,
      sym__delimiter_cmd_1,
    STATE(16711), 1,
      sym__delimiter_cmd_3,
    STATE(16338), 2,
      sym_block_comment,
      sym_line_comment,
  [353700] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7554), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17570), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16339), 2,
      sym_block_comment,
      sym_line_comment,
  [353723] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16803), 1,
      sym__delimiter_str_1,
    STATE(16804), 1,
      sym__delimiter_str_3,
    STATE(16340), 2,
      sym_block_comment,
      sym_line_comment,
  [353746] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16805), 1,
      sym__delimiter_cmd_1,
    STATE(16806), 1,
      sym__delimiter_cmd_3,
    STATE(16341), 2,
      sym_block_comment,
      sym_line_comment,
  [353769] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22756), 1,
      anon_sym_COMMA,
    ACTIONS(22758), 1,
      anon_sym_RPAREN,
    STATE(16548), 1,
      aux_sym_argument_list_repeat1,
    STATE(16342), 2,
      sym_block_comment,
      sym_line_comment,
  [353792] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16893), 1,
      sym__delimiter_str_1,
    STATE(16894), 1,
      sym__delimiter_str_3,
    STATE(16343), 2,
      sym_block_comment,
      sym_line_comment,
  [353815] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16895), 1,
      sym__delimiter_cmd_1,
    STATE(16896), 1,
      sym__delimiter_cmd_3,
    STATE(16344), 2,
      sym_block_comment,
      sym_line_comment,
  [353838] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22760), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16345), 2,
      sym_block_comment,
      sym_line_comment,
  [353859] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16980), 1,
      sym__delimiter_str_1,
    STATE(16981), 1,
      sym__delimiter_str_3,
    STATE(16346), 2,
      sym_block_comment,
      sym_line_comment,
  [353882] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16982), 1,
      sym__delimiter_cmd_1,
    STATE(16983), 1,
      sym__delimiter_cmd_3,
    STATE(16347), 2,
      sym_block_comment,
      sym_line_comment,
  [353905] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15392), 1,
      sym__delimiter_str_3,
    STATE(15633), 1,
      sym__delimiter_str_1,
    STATE(16348), 2,
      sym_block_comment,
      sym_line_comment,
  [353928] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15464), 1,
      sym__delimiter_cmd_1,
    STATE(15494), 1,
      sym__delimiter_cmd_3,
    STATE(16349), 2,
      sym_block_comment,
      sym_line_comment,
  [353951] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8024), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22762), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16350), 2,
      sym_block_comment,
      sym_line_comment,
  [353974] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16798), 1,
      sym__delimiter_str_1,
    STATE(16801), 1,
      sym__delimiter_str_3,
    STATE(16351), 2,
      sym_block_comment,
      sym_line_comment,
  [353997] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16812), 1,
      sym__delimiter_cmd_1,
    STATE(16824), 1,
      sym__delimiter_cmd_3,
    STATE(16352), 2,
      sym_block_comment,
      sym_line_comment,
  [354020] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7106), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22764), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16353), 2,
      sym_block_comment,
      sym_line_comment,
  [354043] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16095), 1,
      sym__delimiter_str_1,
    STATE(16104), 1,
      sym__delimiter_str_3,
    STATE(16354), 2,
      sym_block_comment,
      sym_line_comment,
  [354066] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16126), 1,
      sym__delimiter_cmd_1,
    STATE(16127), 1,
      sym__delimiter_cmd_3,
    STATE(16355), 2,
      sym_block_comment,
      sym_line_comment,
  [354089] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16913), 1,
      sym__delimiter_str_1,
    STATE(16915), 1,
      sym__delimiter_str_3,
    STATE(16356), 2,
      sym_block_comment,
      sym_line_comment,
  [354112] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16917), 1,
      sym__delimiter_cmd_1,
    STATE(16918), 1,
      sym__delimiter_cmd_3,
    STATE(16357), 2,
      sym_block_comment,
      sym_line_comment,
  [354135] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15539), 1,
      sym__delimiter_str_1,
    STATE(15551), 1,
      sym__delimiter_str_3,
    STATE(16358), 2,
      sym_block_comment,
      sym_line_comment,
  [354158] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15552), 1,
      sym__delimiter_cmd_1,
    STATE(15553), 1,
      sym__delimiter_cmd_3,
    STATE(16359), 2,
      sym_block_comment,
      sym_line_comment,
  [354181] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16107), 1,
      sym__delimiter_str_1,
    STATE(16113), 1,
      sym__delimiter_str_3,
    STATE(16360), 2,
      sym_block_comment,
      sym_line_comment,
  [354204] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16114), 1,
      sym__delimiter_cmd_1,
    STATE(16115), 1,
      sym__delimiter_cmd_3,
    STATE(16361), 2,
      sym_block_comment,
      sym_line_comment,
  [354227] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7982), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17348), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16362), 2,
      sym_block_comment,
      sym_line_comment,
  [354250] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16582), 1,
      sym__delimiter_str_1,
    STATE(16585), 1,
      sym__delimiter_str_3,
    STATE(16363), 2,
      sym_block_comment,
      sym_line_comment,
  [354273] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16586), 1,
      sym__delimiter_cmd_1,
    STATE(16588), 1,
      sym__delimiter_cmd_3,
    STATE(16364), 2,
      sym_block_comment,
      sym_line_comment,
  [354296] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16837), 1,
      sym__delimiter_str_1,
    STATE(16839), 1,
      sym__delimiter_str_3,
    STATE(16365), 2,
      sym_block_comment,
      sym_line_comment,
  [354319] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16840), 1,
      sym__delimiter_cmd_1,
    STATE(16841), 1,
      sym__delimiter_cmd_3,
    STATE(16366), 2,
      sym_block_comment,
      sym_line_comment,
  [354342] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16955), 1,
      sym__delimiter_str_1,
    STATE(16957), 1,
      sym__delimiter_str_3,
    STATE(16367), 2,
      sym_block_comment,
      sym_line_comment,
  [354365] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16965), 1,
      sym__delimiter_cmd_1,
    STATE(16969), 1,
      sym__delimiter_cmd_3,
    STATE(16368), 2,
      sym_block_comment,
      sym_line_comment,
  [354388] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15378), 1,
      sym__delimiter_str_1,
    STATE(15383), 1,
      sym__delimiter_str_3,
    STATE(16369), 2,
      sym_block_comment,
      sym_line_comment,
  [354411] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15385), 1,
      sym__delimiter_cmd_1,
    STATE(15386), 1,
      sym__delimiter_cmd_3,
    STATE(16370), 2,
      sym_block_comment,
      sym_line_comment,
  [354434] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15485), 1,
      sym__delimiter_str_1,
    STATE(15486), 1,
      sym__delimiter_str_3,
    STATE(16371), 2,
      sym_block_comment,
      sym_line_comment,
  [354457] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15487), 1,
      sym__delimiter_cmd_1,
    STATE(15488), 1,
      sym__delimiter_cmd_3,
    STATE(16372), 2,
      sym_block_comment,
      sym_line_comment,
  [354480] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15585), 1,
      sym__delimiter_str_1,
    STATE(15587), 1,
      sym__delimiter_str_3,
    STATE(16373), 2,
      sym_block_comment,
      sym_line_comment,
  [354503] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15588), 1,
      sym__delimiter_cmd_1,
    STATE(15593), 1,
      sym__delimiter_cmd_3,
    STATE(16374), 2,
      sym_block_comment,
      sym_line_comment,
  [354526] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15666), 1,
      sym__delimiter_str_1,
    STATE(15671), 1,
      sym__delimiter_str_3,
    STATE(16375), 2,
      sym_block_comment,
      sym_line_comment,
  [354549] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15676), 1,
      sym__delimiter_cmd_1,
    STATE(15686), 1,
      sym__delimiter_cmd_3,
    STATE(16376), 2,
      sym_block_comment,
      sym_line_comment,
  [354572] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22766), 1,
      anon_sym_COMMA,
    ACTIONS(22768), 1,
      anon_sym_RPAREN,
    STATE(16554), 1,
      aux_sym_argument_list_repeat1,
    STATE(16377), 2,
      sym_block_comment,
      sym_line_comment,
  [354595] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7034), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17559), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16378), 2,
      sym_block_comment,
      sym_line_comment,
  [354618] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16081), 1,
      sym__delimiter_str_1,
    STATE(16082), 1,
      sym__delimiter_str_3,
    STATE(16379), 2,
      sym_block_comment,
      sym_line_comment,
  [354641] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16083), 1,
      sym__delimiter_cmd_1,
    STATE(16084), 1,
      sym__delimiter_cmd_3,
    STATE(16380), 2,
      sym_block_comment,
      sym_line_comment,
  [354664] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8774), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22770), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16381), 2,
      sym_block_comment,
      sym_line_comment,
  [354687] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16149), 1,
      sym__delimiter_str_1,
    STATE(16150), 1,
      sym__delimiter_str_3,
    STATE(16382), 2,
      sym_block_comment,
      sym_line_comment,
  [354710] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16151), 1,
      sym__delimiter_cmd_1,
    STATE(16152), 1,
      sym__delimiter_cmd_3,
    STATE(16383), 2,
      sym_block_comment,
      sym_line_comment,
  [354733] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16246), 1,
      sym__delimiter_str_1,
    STATE(16247), 1,
      sym__delimiter_str_3,
    STATE(16384), 2,
      sym_block_comment,
      sym_line_comment,
  [354756] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16248), 1,
      sym__delimiter_cmd_1,
    STATE(16250), 1,
      sym__delimiter_cmd_3,
    STATE(16385), 2,
      sym_block_comment,
      sym_line_comment,
  [354779] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22772), 1,
      anon_sym_RBRACK,
    ACTIONS(22774), 1,
      aux_sym__terminator_token1,
    ACTIONS(22776), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16386), 2,
      sym_block_comment,
      sym_line_comment,
  [354802] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7406), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22778), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16387), 2,
      sym_block_comment,
      sym_line_comment,
  [354825] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16443), 1,
      sym__delimiter_str_1,
    STATE(16544), 1,
      sym__delimiter_str_3,
    STATE(16388), 2,
      sym_block_comment,
      sym_line_comment,
  [354848] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16546), 1,
      sym__delimiter_cmd_1,
    STATE(16547), 1,
      sym__delimiter_cmd_3,
    STATE(16389), 2,
      sym_block_comment,
      sym_line_comment,
  [354871] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(22780), 1,
      anon_sym_RPAREN,
    ACTIONS(22782), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16390), 2,
      sym_block_comment,
      sym_line_comment,
  [354894] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16618), 1,
      sym__delimiter_str_1,
    STATE(16619), 1,
      sym__delimiter_str_3,
    STATE(16391), 2,
      sym_block_comment,
      sym_line_comment,
  [354917] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16620), 1,
      sym__delimiter_cmd_1,
    STATE(16621), 1,
      sym__delimiter_cmd_3,
    STATE(16392), 2,
      sym_block_comment,
      sym_line_comment,
  [354940] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8814), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17625), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16393), 2,
      sym_block_comment,
      sym_line_comment,
  [354963] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16679), 1,
      sym__delimiter_str_1,
    STATE(16680), 1,
      sym__delimiter_str_3,
    STATE(16394), 2,
      sym_block_comment,
      sym_line_comment,
  [354986] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16681), 1,
      sym__delimiter_cmd_1,
    STATE(16682), 1,
      sym__delimiter_cmd_3,
    STATE(16395), 2,
      sym_block_comment,
      sym_line_comment,
  [355009] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8824), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22784), 1,
      anon_sym_COMMA,
    STATE(16767), 1,
      aux_sym_argument_list_repeat1,
    STATE(16396), 2,
      sym_block_comment,
      sym_line_comment,
  [355032] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16747), 1,
      sym__delimiter_str_1,
    STATE(16748), 1,
      sym__delimiter_str_3,
    STATE(16397), 2,
      sym_block_comment,
      sym_line_comment,
  [355055] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16749), 1,
      sym__delimiter_cmd_1,
    STATE(16750), 1,
      sym__delimiter_cmd_3,
    STATE(16398), 2,
      sym_block_comment,
      sym_line_comment,
  [355078] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16813), 1,
      sym__delimiter_str_1,
    STATE(16815), 1,
      sym__delimiter_str_3,
    STATE(16399), 2,
      sym_block_comment,
      sym_line_comment,
  [355101] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16816), 1,
      sym__delimiter_cmd_1,
    STATE(16817), 1,
      sym__delimiter_cmd_3,
    STATE(16400), 2,
      sym_block_comment,
      sym_line_comment,
  [355124] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16850), 1,
      sym__delimiter_str_1,
    STATE(16851), 1,
      sym__delimiter_str_3,
    STATE(16401), 2,
      sym_block_comment,
      sym_line_comment,
  [355147] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16852), 1,
      sym__delimiter_cmd_1,
    STATE(16853), 1,
      sym__delimiter_cmd_3,
    STATE(16402), 2,
      sym_block_comment,
      sym_line_comment,
  [355170] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16878), 1,
      sym__delimiter_str_1,
    STATE(16879), 1,
      sym__delimiter_str_3,
    STATE(16403), 2,
      sym_block_comment,
      sym_line_comment,
  [355193] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16881), 1,
      sym__delimiter_cmd_1,
    STATE(16882), 1,
      sym__delimiter_cmd_3,
    STATE(16404), 2,
      sym_block_comment,
      sym_line_comment,
  [355216] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16921), 1,
      sym__delimiter_str_1,
    STATE(16922), 1,
      sym__delimiter_str_3,
    STATE(16405), 2,
      sym_block_comment,
      sym_line_comment,
  [355239] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16923), 1,
      sym__delimiter_cmd_1,
    STATE(16924), 1,
      sym__delimiter_cmd_3,
    STATE(16406), 2,
      sym_block_comment,
      sym_line_comment,
  [355262] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22789), 1,
      sym__end_cmd,
    ACTIONS(22786), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16407), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_prefixed_command_literal_repeat1,
  [355281] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16972), 1,
      sym__delimiter_str_1,
    STATE(16973), 1,
      sym__delimiter_str_3,
    STATE(16408), 2,
      sym_block_comment,
      sym_line_comment,
  [355304] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16974), 1,
      sym__delimiter_cmd_1,
    STATE(16976), 1,
      sym__delimiter_cmd_3,
    STATE(16409), 2,
      sym_block_comment,
      sym_line_comment,
  [355327] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17012), 1,
      sym__delimiter_str_1,
    STATE(17015), 1,
      sym__delimiter_str_3,
    STATE(16410), 2,
      sym_block_comment,
      sym_line_comment,
  [355350] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(17018), 1,
      sym__delimiter_cmd_1,
    STATE(17019), 1,
      sym__delimiter_cmd_3,
    STATE(16411), 2,
      sym_block_comment,
      sym_line_comment,
  [355373] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16412), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10579), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [355390] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(17038), 1,
      sym__delimiter_str_1,
    STATE(17039), 1,
      sym__delimiter_str_3,
    STATE(16413), 2,
      sym_block_comment,
      sym_line_comment,
  [355413] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(17040), 1,
      sym__delimiter_cmd_1,
    STATE(17041), 1,
      sym__delimiter_cmd_3,
    STATE(16414), 2,
      sym_block_comment,
      sym_line_comment,
  [355436] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15350), 1,
      sym__delimiter_str_1,
    STATE(15351), 1,
      sym__delimiter_str_3,
    STATE(16415), 2,
      sym_block_comment,
      sym_line_comment,
  [355459] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15352), 1,
      sym__delimiter_cmd_1,
    STATE(15353), 1,
      sym__delimiter_cmd_3,
    STATE(16416), 2,
      sym_block_comment,
      sym_line_comment,
  [355482] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15373), 1,
      sym__delimiter_str_1,
    STATE(15374), 1,
      sym__delimiter_str_3,
    STATE(16417), 2,
      sym_block_comment,
      sym_line_comment,
  [355505] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15375), 1,
      sym__delimiter_cmd_1,
    STATE(15376), 1,
      sym__delimiter_cmd_3,
    STATE(16418), 2,
      sym_block_comment,
      sym_line_comment,
  [355528] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15395), 1,
      sym__delimiter_str_1,
    STATE(15396), 1,
      sym__delimiter_str_3,
    STATE(16419), 2,
      sym_block_comment,
      sym_line_comment,
  [355551] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15397), 1,
      sym__delimiter_cmd_1,
    STATE(15398), 1,
      sym__delimiter_cmd_3,
    STATE(16420), 2,
      sym_block_comment,
      sym_line_comment,
  [355574] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22791), 1,
      anon_sym_RBRACK,
    ACTIONS(22793), 1,
      aux_sym__terminator_token1,
    ACTIONS(22795), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16421), 2,
      sym_block_comment,
      sym_line_comment,
  [355597] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15419), 1,
      sym__delimiter_str_1,
    STATE(15420), 1,
      sym__delimiter_str_3,
    STATE(16422), 2,
      sym_block_comment,
      sym_line_comment,
  [355620] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15421), 1,
      sym__delimiter_cmd_1,
    STATE(15422), 1,
      sym__delimiter_cmd_3,
    STATE(16423), 2,
      sym_block_comment,
      sym_line_comment,
  [355643] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8824), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22784), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16424), 2,
      sym_block_comment,
      sym_line_comment,
  [355666] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15435), 1,
      sym__delimiter_str_1,
    STATE(15436), 1,
      sym__delimiter_str_3,
    STATE(16425), 2,
      sym_block_comment,
      sym_line_comment,
  [355689] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15437), 1,
      sym__delimiter_cmd_1,
    STATE(15438), 1,
      sym__delimiter_cmd_3,
    STATE(16426), 2,
      sym_block_comment,
      sym_line_comment,
  [355712] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15451), 1,
      sym__delimiter_str_1,
    STATE(15452), 1,
      sym__delimiter_str_3,
    STATE(16427), 2,
      sym_block_comment,
      sym_line_comment,
  [355735] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15453), 1,
      sym__delimiter_cmd_1,
    STATE(15454), 1,
      sym__delimiter_cmd_3,
    STATE(16428), 2,
      sym_block_comment,
      sym_line_comment,
  [355758] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15476), 1,
      sym__delimiter_str_1,
    STATE(15477), 1,
      sym__delimiter_str_3,
    STATE(16429), 2,
      sym_block_comment,
      sym_line_comment,
  [355781] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15478), 1,
      sym__delimiter_cmd_1,
    STATE(15479), 1,
      sym__delimiter_cmd_3,
    STATE(16430), 2,
      sym_block_comment,
      sym_line_comment,
  [355804] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22797), 1,
      anon_sym_RBRACK,
    ACTIONS(22799), 1,
      aux_sym__terminator_token1,
    ACTIONS(22801), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16431), 2,
      sym_block_comment,
      sym_line_comment,
  [355827] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15499), 1,
      sym__delimiter_str_1,
    STATE(15500), 1,
      sym__delimiter_str_3,
    STATE(16432), 2,
      sym_block_comment,
      sym_line_comment,
  [355850] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15501), 1,
      sym__delimiter_cmd_1,
    STATE(15502), 1,
      sym__delimiter_cmd_3,
    STATE(16433), 2,
      sym_block_comment,
      sym_line_comment,
  [355873] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15521), 1,
      sym__delimiter_str_1,
    STATE(15522), 1,
      sym__delimiter_str_3,
    STATE(16434), 2,
      sym_block_comment,
      sym_line_comment,
  [355896] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15523), 1,
      sym__delimiter_cmd_1,
    STATE(15524), 1,
      sym__delimiter_cmd_3,
    STATE(16435), 2,
      sym_block_comment,
      sym_line_comment,
  [355919] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22806), 1,
      sym__end_cmd,
    ACTIONS(22803), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16436), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_prefixed_command_literal_repeat2,
  [355938] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15540), 1,
      sym__delimiter_str_1,
    STATE(15541), 1,
      sym__delimiter_str_3,
    STATE(16437), 2,
      sym_block_comment,
      sym_line_comment,
  [355961] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15542), 1,
      sym__delimiter_cmd_1,
    STATE(15543), 1,
      sym__delimiter_cmd_3,
    STATE(16438), 2,
      sym_block_comment,
      sym_line_comment,
  [355984] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15562), 1,
      sym__delimiter_str_1,
    STATE(15563), 1,
      sym__delimiter_str_3,
    STATE(16439), 2,
      sym_block_comment,
      sym_line_comment,
  [356007] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15564), 1,
      sym__delimiter_cmd_1,
    STATE(15565), 1,
      sym__delimiter_cmd_3,
    STATE(16440), 2,
      sym_block_comment,
      sym_line_comment,
  [356030] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15581), 1,
      sym__delimiter_str_1,
    STATE(15582), 1,
      sym__delimiter_str_3,
    STATE(16441), 2,
      sym_block_comment,
      sym_line_comment,
  [356053] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15583), 1,
      sym__delimiter_cmd_1,
    STATE(15584), 1,
      sym__delimiter_cmd_3,
    STATE(16442), 2,
      sym_block_comment,
      sym_line_comment,
  [356076] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22808), 1,
      sym__end_str,
    STATE(16570), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16443), 2,
      sym_block_comment,
      sym_line_comment,
  [356097] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15604), 1,
      sym__delimiter_str_1,
    STATE(15605), 1,
      sym__delimiter_str_3,
    STATE(16444), 2,
      sym_block_comment,
      sym_line_comment,
  [356120] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15606), 1,
      sym__delimiter_cmd_1,
    STATE(15607), 1,
      sym__delimiter_cmd_3,
    STATE(16445), 2,
      sym_block_comment,
      sym_line_comment,
  [356143] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15628), 1,
      sym__delimiter_str_1,
    STATE(15629), 1,
      sym__delimiter_str_3,
    STATE(16446), 2,
      sym_block_comment,
      sym_line_comment,
  [356166] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15630), 1,
      sym__delimiter_cmd_1,
    STATE(15631), 1,
      sym__delimiter_cmd_3,
    STATE(16447), 2,
      sym_block_comment,
      sym_line_comment,
  [356189] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15643), 1,
      sym__delimiter_str_1,
    STATE(15644), 1,
      sym__delimiter_str_3,
    STATE(16448), 2,
      sym_block_comment,
      sym_line_comment,
  [356212] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15645), 1,
      sym__delimiter_cmd_1,
    STATE(15646), 1,
      sym__delimiter_cmd_3,
    STATE(16449), 2,
      sym_block_comment,
      sym_line_comment,
  [356235] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22810), 1,
      sym__end_str,
    STATE(16566), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16450), 2,
      sym_block_comment,
      sym_line_comment,
  [356256] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15658), 1,
      sym__delimiter_str_1,
    STATE(15659), 1,
      sym__delimiter_str_3,
    STATE(16451), 2,
      sym_block_comment,
      sym_line_comment,
  [356279] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15660), 1,
      sym__delimiter_cmd_1,
    STATE(15661), 1,
      sym__delimiter_cmd_3,
    STATE(16452), 2,
      sym_block_comment,
      sym_line_comment,
  [356302] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22810), 1,
      sym__end_str,
    STATE(16567), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16453), 2,
      sym_block_comment,
      sym_line_comment,
  [356323] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15667), 1,
      sym__delimiter_str_1,
    STATE(15668), 1,
      sym__delimiter_str_3,
    STATE(16454), 2,
      sym_block_comment,
      sym_line_comment,
  [356346] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15669), 1,
      sym__delimiter_cmd_1,
    STATE(15670), 1,
      sym__delimiter_cmd_3,
    STATE(16455), 2,
      sym_block_comment,
      sym_line_comment,
  [356369] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22812), 1,
      sym__end_cmd,
    STATE(16568), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16456), 2,
      sym_block_comment,
      sym_line_comment,
  [356390] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15677), 1,
      sym__delimiter_str_1,
    STATE(15678), 1,
      sym__delimiter_str_3,
    STATE(16457), 2,
      sym_block_comment,
      sym_line_comment,
  [356413] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15679), 1,
      sym__delimiter_cmd_1,
    STATE(15680), 1,
      sym__delimiter_cmd_3,
    STATE(16458), 2,
      sym_block_comment,
      sym_line_comment,
  [356436] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22812), 1,
      sym__end_cmd,
    STATE(16569), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16459), 2,
      sym_block_comment,
      sym_line_comment,
  [356457] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15687), 1,
      sym__delimiter_str_1,
    STATE(15688), 1,
      sym__delimiter_str_3,
    STATE(16460), 2,
      sym_block_comment,
      sym_line_comment,
  [356480] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15689), 1,
      sym__delimiter_cmd_1,
    STATE(15690), 1,
      sym__delimiter_cmd_3,
    STATE(16461), 2,
      sym_block_comment,
      sym_line_comment,
  [356503] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15697), 1,
      sym__delimiter_str_1,
    STATE(15698), 1,
      sym__delimiter_str_3,
    STATE(16462), 2,
      sym_block_comment,
      sym_line_comment,
  [356526] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15699), 1,
      sym__delimiter_cmd_1,
    STATE(15700), 1,
      sym__delimiter_cmd_3,
    STATE(16463), 2,
      sym_block_comment,
      sym_line_comment,
  [356549] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15707), 1,
      sym__delimiter_str_1,
    STATE(15708), 1,
      sym__delimiter_str_3,
    STATE(16464), 2,
      sym_block_comment,
      sym_line_comment,
  [356572] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15709), 1,
      sym__delimiter_cmd_1,
    STATE(15710), 1,
      sym__delimiter_cmd_3,
    STATE(16465), 2,
      sym_block_comment,
      sym_line_comment,
  [356595] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15717), 1,
      sym__delimiter_str_1,
    STATE(15718), 1,
      sym__delimiter_str_3,
    STATE(16466), 2,
      sym_block_comment,
      sym_line_comment,
  [356618] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15719), 1,
      sym__delimiter_cmd_1,
    STATE(15720), 1,
      sym__delimiter_cmd_3,
    STATE(16467), 2,
      sym_block_comment,
      sym_line_comment,
  [356641] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15725), 1,
      sym__delimiter_str_1,
    STATE(15726), 1,
      sym__delimiter_str_3,
    STATE(16468), 2,
      sym_block_comment,
      sym_line_comment,
  [356664] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15727), 1,
      sym__delimiter_cmd_1,
    STATE(15728), 1,
      sym__delimiter_cmd_3,
    STATE(16469), 2,
      sym_block_comment,
      sym_line_comment,
  [356687] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15733), 1,
      sym__delimiter_str_1,
    STATE(15734), 1,
      sym__delimiter_str_3,
    STATE(16470), 2,
      sym_block_comment,
      sym_line_comment,
  [356710] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15735), 1,
      sym__delimiter_cmd_1,
    STATE(15736), 1,
      sym__delimiter_cmd_3,
    STATE(16471), 2,
      sym_block_comment,
      sym_line_comment,
  [356733] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15741), 1,
      sym__delimiter_str_1,
    STATE(15742), 1,
      sym__delimiter_str_3,
    STATE(16472), 2,
      sym_block_comment,
      sym_line_comment,
  [356756] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15743), 1,
      sym__delimiter_cmd_1,
    STATE(15744), 1,
      sym__delimiter_cmd_3,
    STATE(16473), 2,
      sym_block_comment,
      sym_line_comment,
  [356779] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15749), 1,
      sym__delimiter_str_1,
    STATE(15750), 1,
      sym__delimiter_str_3,
    STATE(16474), 2,
      sym_block_comment,
      sym_line_comment,
  [356802] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15751), 1,
      sym__delimiter_cmd_1,
    STATE(15752), 1,
      sym__delimiter_cmd_3,
    STATE(16475), 2,
      sym_block_comment,
      sym_line_comment,
  [356825] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15757), 1,
      sym__delimiter_str_1,
    STATE(15758), 1,
      sym__delimiter_str_3,
    STATE(16476), 2,
      sym_block_comment,
      sym_line_comment,
  [356848] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15759), 1,
      sym__delimiter_cmd_1,
    STATE(15760), 1,
      sym__delimiter_cmd_3,
    STATE(16477), 2,
      sym_block_comment,
      sym_line_comment,
  [356871] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15766), 1,
      sym__delimiter_str_1,
    STATE(15767), 1,
      sym__delimiter_str_3,
    STATE(16478), 2,
      sym_block_comment,
      sym_line_comment,
  [356894] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15768), 1,
      sym__delimiter_cmd_1,
    STATE(15769), 1,
      sym__delimiter_cmd_3,
    STATE(16479), 2,
      sym_block_comment,
      sym_line_comment,
  [356917] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15774), 1,
      sym__delimiter_str_1,
    STATE(15775), 1,
      sym__delimiter_str_3,
    STATE(16480), 2,
      sym_block_comment,
      sym_line_comment,
  [356940] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15776), 1,
      sym__delimiter_cmd_1,
    STATE(15777), 1,
      sym__delimiter_cmd_3,
    STATE(16481), 2,
      sym_block_comment,
      sym_line_comment,
  [356963] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15782), 1,
      sym__delimiter_str_1,
    STATE(15783), 1,
      sym__delimiter_str_3,
    STATE(16482), 2,
      sym_block_comment,
      sym_line_comment,
  [356986] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15784), 1,
      sym__delimiter_cmd_1,
    STATE(15785), 1,
      sym__delimiter_cmd_3,
    STATE(16483), 2,
      sym_block_comment,
      sym_line_comment,
  [357009] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15790), 1,
      sym__delimiter_str_1,
    STATE(15791), 1,
      sym__delimiter_str_3,
    STATE(16484), 2,
      sym_block_comment,
      sym_line_comment,
  [357032] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15792), 1,
      sym__delimiter_cmd_1,
    STATE(15793), 1,
      sym__delimiter_cmd_3,
    STATE(16485), 2,
      sym_block_comment,
      sym_line_comment,
  [357055] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15798), 1,
      sym__delimiter_str_1,
    STATE(15799), 1,
      sym__delimiter_str_3,
    STATE(16486), 2,
      sym_block_comment,
      sym_line_comment,
  [357078] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15800), 1,
      sym__delimiter_cmd_1,
    STATE(15801), 1,
      sym__delimiter_cmd_3,
    STATE(16487), 2,
      sym_block_comment,
      sym_line_comment,
  [357101] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15806), 1,
      sym__delimiter_str_1,
    STATE(15807), 1,
      sym__delimiter_str_3,
    STATE(16488), 2,
      sym_block_comment,
      sym_line_comment,
  [357124] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15808), 1,
      sym__delimiter_cmd_1,
    STATE(15809), 1,
      sym__delimiter_cmd_3,
    STATE(16489), 2,
      sym_block_comment,
      sym_line_comment,
  [357147] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15814), 1,
      sym__delimiter_str_1,
    STATE(15815), 1,
      sym__delimiter_str_3,
    STATE(16490), 2,
      sym_block_comment,
      sym_line_comment,
  [357170] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15816), 1,
      sym__delimiter_cmd_1,
    STATE(15817), 1,
      sym__delimiter_cmd_3,
    STATE(16491), 2,
      sym_block_comment,
      sym_line_comment,
  [357193] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15822), 1,
      sym__delimiter_str_1,
    STATE(15823), 1,
      sym__delimiter_str_3,
    STATE(16492), 2,
      sym_block_comment,
      sym_line_comment,
  [357216] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15824), 1,
      sym__delimiter_cmd_1,
    STATE(15825), 1,
      sym__delimiter_cmd_3,
    STATE(16493), 2,
      sym_block_comment,
      sym_line_comment,
  [357239] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15830), 1,
      sym__delimiter_str_1,
    STATE(15831), 1,
      sym__delimiter_str_3,
    STATE(16494), 2,
      sym_block_comment,
      sym_line_comment,
  [357262] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15832), 1,
      sym__delimiter_cmd_1,
    STATE(15833), 1,
      sym__delimiter_cmd_3,
    STATE(16495), 2,
      sym_block_comment,
      sym_line_comment,
  [357285] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15838), 1,
      sym__delimiter_str_1,
    STATE(15839), 1,
      sym__delimiter_str_3,
    STATE(16496), 2,
      sym_block_comment,
      sym_line_comment,
  [357308] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15840), 1,
      sym__delimiter_cmd_1,
    STATE(15841), 1,
      sym__delimiter_cmd_3,
    STATE(16497), 2,
      sym_block_comment,
      sym_line_comment,
  [357331] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15847), 1,
      sym__delimiter_str_1,
    STATE(15848), 1,
      sym__delimiter_str_3,
    STATE(16498), 2,
      sym_block_comment,
      sym_line_comment,
  [357354] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15849), 1,
      sym__delimiter_cmd_1,
    STATE(15850), 1,
      sym__delimiter_cmd_3,
    STATE(16499), 2,
      sym_block_comment,
      sym_line_comment,
  [357377] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15855), 1,
      sym__delimiter_str_1,
    STATE(15856), 1,
      sym__delimiter_str_3,
    STATE(16500), 2,
      sym_block_comment,
      sym_line_comment,
  [357400] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15857), 1,
      sym__delimiter_cmd_1,
    STATE(15858), 1,
      sym__delimiter_cmd_3,
    STATE(16501), 2,
      sym_block_comment,
      sym_line_comment,
  [357423] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15863), 1,
      sym__delimiter_str_1,
    STATE(15864), 1,
      sym__delimiter_str_3,
    STATE(16502), 2,
      sym_block_comment,
      sym_line_comment,
  [357446] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15865), 1,
      sym__delimiter_cmd_1,
    STATE(15866), 1,
      sym__delimiter_cmd_3,
    STATE(16503), 2,
      sym_block_comment,
      sym_line_comment,
  [357469] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15871), 1,
      sym__delimiter_str_1,
    STATE(15872), 1,
      sym__delimiter_str_3,
    STATE(16504), 2,
      sym_block_comment,
      sym_line_comment,
  [357492] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15873), 1,
      sym__delimiter_cmd_1,
    STATE(15874), 1,
      sym__delimiter_cmd_3,
    STATE(16505), 2,
      sym_block_comment,
      sym_line_comment,
  [357515] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15879), 1,
      sym__delimiter_str_1,
    STATE(15880), 1,
      sym__delimiter_str_3,
    STATE(16506), 2,
      sym_block_comment,
      sym_line_comment,
  [357538] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15881), 1,
      sym__delimiter_cmd_1,
    STATE(15882), 1,
      sym__delimiter_cmd_3,
    STATE(16507), 2,
      sym_block_comment,
      sym_line_comment,
  [357561] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15887), 1,
      sym__delimiter_str_1,
    STATE(15888), 1,
      sym__delimiter_str_3,
    STATE(16508), 2,
      sym_block_comment,
      sym_line_comment,
  [357584] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15889), 1,
      sym__delimiter_cmd_1,
    STATE(15890), 1,
      sym__delimiter_cmd_3,
    STATE(16509), 2,
      sym_block_comment,
      sym_line_comment,
  [357607] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15895), 1,
      sym__delimiter_str_1,
    STATE(15896), 1,
      sym__delimiter_str_3,
    STATE(16510), 2,
      sym_block_comment,
      sym_line_comment,
  [357630] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15897), 1,
      sym__delimiter_cmd_1,
    STATE(15898), 1,
      sym__delimiter_cmd_3,
    STATE(16511), 2,
      sym_block_comment,
      sym_line_comment,
  [357653] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15903), 1,
      sym__delimiter_str_1,
    STATE(15904), 1,
      sym__delimiter_str_3,
    STATE(16512), 2,
      sym_block_comment,
      sym_line_comment,
  [357676] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15905), 1,
      sym__delimiter_cmd_1,
    STATE(15906), 1,
      sym__delimiter_cmd_3,
    STATE(16513), 2,
      sym_block_comment,
      sym_line_comment,
  [357699] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15911), 1,
      sym__delimiter_str_1,
    STATE(15912), 1,
      sym__delimiter_str_3,
    STATE(16514), 2,
      sym_block_comment,
      sym_line_comment,
  [357722] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15913), 1,
      sym__delimiter_cmd_1,
    STATE(15914), 1,
      sym__delimiter_cmd_3,
    STATE(16515), 2,
      sym_block_comment,
      sym_line_comment,
  [357745] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15920), 1,
      sym__delimiter_str_1,
    STATE(15921), 1,
      sym__delimiter_str_3,
    STATE(16516), 2,
      sym_block_comment,
      sym_line_comment,
  [357768] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15922), 1,
      sym__delimiter_cmd_1,
    STATE(15923), 1,
      sym__delimiter_cmd_3,
    STATE(16517), 2,
      sym_block_comment,
      sym_line_comment,
  [357791] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15928), 1,
      sym__delimiter_str_1,
    STATE(15929), 1,
      sym__delimiter_str_3,
    STATE(16518), 2,
      sym_block_comment,
      sym_line_comment,
  [357814] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15930), 1,
      sym__delimiter_cmd_1,
    STATE(15931), 1,
      sym__delimiter_cmd_3,
    STATE(16519), 2,
      sym_block_comment,
      sym_line_comment,
  [357837] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15936), 1,
      sym__delimiter_str_1,
    STATE(15937), 1,
      sym__delimiter_str_3,
    STATE(16520), 2,
      sym_block_comment,
      sym_line_comment,
  [357860] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15938), 1,
      sym__delimiter_cmd_1,
    STATE(15939), 1,
      sym__delimiter_cmd_3,
    STATE(16521), 2,
      sym_block_comment,
      sym_line_comment,
  [357883] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15944), 1,
      sym__delimiter_str_1,
    STATE(15945), 1,
      sym__delimiter_str_3,
    STATE(16522), 2,
      sym_block_comment,
      sym_line_comment,
  [357906] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15946), 1,
      sym__delimiter_cmd_1,
    STATE(15947), 1,
      sym__delimiter_cmd_3,
    STATE(16523), 2,
      sym_block_comment,
      sym_line_comment,
  [357929] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15952), 1,
      sym__delimiter_str_1,
    STATE(15953), 1,
      sym__delimiter_str_3,
    STATE(16524), 2,
      sym_block_comment,
      sym_line_comment,
  [357952] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15954), 1,
      sym__delimiter_cmd_1,
    STATE(15955), 1,
      sym__delimiter_cmd_3,
    STATE(16525), 2,
      sym_block_comment,
      sym_line_comment,
  [357975] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15960), 1,
      sym__delimiter_str_1,
    STATE(15961), 1,
      sym__delimiter_str_3,
    STATE(16526), 2,
      sym_block_comment,
      sym_line_comment,
  [357998] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15962), 1,
      sym__delimiter_cmd_1,
    STATE(15963), 1,
      sym__delimiter_cmd_3,
    STATE(16527), 2,
      sym_block_comment,
      sym_line_comment,
  [358021] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15968), 1,
      sym__delimiter_str_1,
    STATE(15969), 1,
      sym__delimiter_str_3,
    STATE(16528), 2,
      sym_block_comment,
      sym_line_comment,
  [358044] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15970), 1,
      sym__delimiter_cmd_1,
    STATE(15971), 1,
      sym__delimiter_cmd_3,
    STATE(16529), 2,
      sym_block_comment,
      sym_line_comment,
  [358067] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15976), 1,
      sym__delimiter_str_1,
    STATE(15977), 1,
      sym__delimiter_str_3,
    STATE(16530), 2,
      sym_block_comment,
      sym_line_comment,
  [358090] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15978), 1,
      sym__delimiter_cmd_1,
    STATE(15979), 1,
      sym__delimiter_cmd_3,
    STATE(16531), 2,
      sym_block_comment,
      sym_line_comment,
  [358113] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15985), 1,
      sym__delimiter_str_1,
    STATE(15986), 1,
      sym__delimiter_str_3,
    STATE(16532), 2,
      sym_block_comment,
      sym_line_comment,
  [358136] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15987), 1,
      sym__delimiter_cmd_1,
    STATE(15988), 1,
      sym__delimiter_cmd_3,
    STATE(16533), 2,
      sym_block_comment,
      sym_line_comment,
  [358159] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15993), 1,
      sym__delimiter_str_1,
    STATE(15994), 1,
      sym__delimiter_str_3,
    STATE(16534), 2,
      sym_block_comment,
      sym_line_comment,
  [358182] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15995), 1,
      sym__delimiter_cmd_1,
    STATE(15996), 1,
      sym__delimiter_cmd_3,
    STATE(16535), 2,
      sym_block_comment,
      sym_line_comment,
  [358205] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16001), 1,
      sym__delimiter_str_1,
    STATE(16002), 1,
      sym__delimiter_str_3,
    STATE(16536), 2,
      sym_block_comment,
      sym_line_comment,
  [358228] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16003), 1,
      sym__delimiter_cmd_1,
    STATE(16004), 1,
      sym__delimiter_cmd_3,
    STATE(16537), 2,
      sym_block_comment,
      sym_line_comment,
  [358251] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16009), 1,
      sym__delimiter_str_1,
    STATE(16010), 1,
      sym__delimiter_str_3,
    STATE(16538), 2,
      sym_block_comment,
      sym_line_comment,
  [358274] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16011), 1,
      sym__delimiter_cmd_1,
    STATE(16012), 1,
      sym__delimiter_cmd_3,
    STATE(16539), 2,
      sym_block_comment,
      sym_line_comment,
  [358297] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16017), 1,
      sym__delimiter_str_1,
    STATE(16018), 1,
      sym__delimiter_str_3,
    STATE(16540), 2,
      sym_block_comment,
      sym_line_comment,
  [358320] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16019), 1,
      sym__delimiter_cmd_1,
    STATE(16020), 1,
      sym__delimiter_cmd_3,
    STATE(16541), 2,
      sym_block_comment,
      sym_line_comment,
  [358343] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(16025), 1,
      sym__delimiter_str_1,
    STATE(16026), 1,
      sym__delimiter_str_3,
    STATE(16542), 2,
      sym_block_comment,
      sym_line_comment,
  [358366] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(16027), 1,
      sym__delimiter_cmd_1,
    STATE(16028), 1,
      sym__delimiter_cmd_3,
    STATE(16543), 2,
      sym_block_comment,
      sym_line_comment,
  [358389] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22808), 1,
      sym__end_str,
    STATE(16571), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16544), 2,
      sym_block_comment,
      sym_line_comment,
  [358410] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22814), 1,
      anon_sym_RBRACK,
    ACTIONS(22816), 1,
      aux_sym__terminator_token1,
    ACTIONS(22818), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16545), 2,
      sym_block_comment,
      sym_line_comment,
  [358433] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22820), 1,
      sym__end_cmd,
    STATE(16572), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16546), 2,
      sym_block_comment,
      sym_line_comment,
  [358454] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22820), 1,
      sym__end_cmd,
    STATE(16573), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16547), 2,
      sym_block_comment,
      sym_line_comment,
  [358475] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8034), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22822), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16548), 2,
      sym_block_comment,
      sym_line_comment,
  [358498] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8040), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22824), 1,
      anon_sym_COMMA,
    STATE(16574), 1,
      aux_sym_argument_list_repeat1,
    STATE(16549), 2,
      sym_block_comment,
      sym_line_comment,
  [358521] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17634), 1,
      anon_sym_end,
    ACTIONS(22826), 1,
      aux_sym__terminator_token1,
    ACTIONS(22829), 1,
      aux_sym__terminator_token2,
    STATE(16550), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__block_repeat1,
  [358542] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8040), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22824), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16551), 2,
      sym_block_comment,
      sym_line_comment,
  [358565] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7322), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17352), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16552), 2,
      sym_block_comment,
      sym_line_comment,
  [358588] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22760), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16553), 2,
      sym_block_comment,
      sym_line_comment,
  [358609] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7468), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22832), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16554), 2,
      sym_block_comment,
      sym_line_comment,
  [358632] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22834), 1,
      anon_sym_COMMA,
    STATE(16575), 1,
      aux_sym_argument_list_repeat1,
    STATE(16555), 2,
      sym_block_comment,
      sym_line_comment,
  [358655] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7498), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22834), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16556), 2,
      sym_block_comment,
      sym_line_comment,
  [358678] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22836), 1,
      sym__end_str,
    STATE(16581), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16557), 2,
      sym_block_comment,
      sym_line_comment,
  [358699] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22836), 1,
      sym__end_str,
    STATE(16583), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16558), 2,
      sym_block_comment,
      sym_line_comment,
  [358720] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22838), 1,
      sym__end_cmd,
    STATE(16584), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16559), 2,
      sym_block_comment,
      sym_line_comment,
  [358741] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22838), 1,
      sym__end_cmd,
    STATE(16587), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16560), 2,
      sym_block_comment,
      sym_line_comment,
  [358762] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7120), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22840), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16561), 2,
      sym_block_comment,
      sym_line_comment,
  [358785] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7128), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22842), 1,
      anon_sym_COMMA,
    STATE(16589), 1,
      aux_sym_argument_list_repeat1,
    STATE(16562), 2,
      sym_block_comment,
      sym_line_comment,
  [358808] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22844), 1,
      anon_sym_COMMA,
    ACTIONS(22846), 1,
      anon_sym_RPAREN,
    STATE(16933), 1,
      aux_sym_argument_list_repeat1,
    STATE(16563), 2,
      sym_block_comment,
      sym_line_comment,
  [358831] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7128), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22842), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16564), 2,
      sym_block_comment,
      sym_line_comment,
  [358854] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22848), 1,
      anon_sym_COMMA,
    ACTIONS(22850), 1,
      anon_sym_RPAREN,
    STATE(16674), 1,
      aux_sym_argument_list_repeat1,
    STATE(16565), 2,
      sym_block_comment,
      sym_line_comment,
  [358877] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22852), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16566), 2,
      sym_block_comment,
      sym_line_comment,
  [358898] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22852), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16567), 2,
      sym_block_comment,
      sym_line_comment,
  [358919] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22854), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16568), 2,
      sym_block_comment,
      sym_line_comment,
  [358940] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22854), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16569), 2,
      sym_block_comment,
      sym_line_comment,
  [358961] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22856), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16570), 2,
      sym_block_comment,
      sym_line_comment,
  [358982] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22856), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16571), 2,
      sym_block_comment,
      sym_line_comment,
  [359003] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22858), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16572), 2,
      sym_block_comment,
      sym_line_comment,
  [359024] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22858), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16573), 2,
      sym_block_comment,
      sym_line_comment,
  [359045] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8048), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22860), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16574), 2,
      sym_block_comment,
      sym_line_comment,
  [359068] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7526), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22862), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16575), 2,
      sym_block_comment,
      sym_line_comment,
  [359091] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22864), 1,
      anon_sym_RBRACK,
    ACTIONS(22866), 1,
      aux_sym__terminator_token1,
    ACTIONS(22868), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16576), 2,
      sym_block_comment,
      sym_line_comment,
  [359114] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7544), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17354), 1,
      anon_sym_COMMA,
    STATE(16952), 1,
      aux_sym_argument_list_repeat1,
    STATE(16577), 2,
      sym_block_comment,
      sym_line_comment,
  [359137] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22870), 1,
      anon_sym_COMMA,
    ACTIONS(22872), 1,
      anon_sym_RPAREN,
    STATE(16690), 1,
      aux_sym_argument_list_repeat1,
    STATE(16578), 2,
      sym_block_comment,
      sym_line_comment,
  [359160] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8052), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17438), 1,
      anon_sym_COMMA,
    STATE(16687), 1,
      aux_sym_argument_list_repeat1,
    STATE(16579), 2,
      sym_block_comment,
      sym_line_comment,
  [359183] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16580), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9728), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [359200] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22874), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16581), 2,
      sym_block_comment,
      sym_line_comment,
  [359221] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22876), 1,
      sym__end_str,
    STATE(16645), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16582), 2,
      sym_block_comment,
      sym_line_comment,
  [359242] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22874), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16583), 2,
      sym_block_comment,
      sym_line_comment,
  [359263] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22878), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16584), 2,
      sym_block_comment,
      sym_line_comment,
  [359284] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22876), 1,
      sym__end_str,
    STATE(16647), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16585), 2,
      sym_block_comment,
      sym_line_comment,
  [359305] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22880), 1,
      sym__end_cmd,
    STATE(16649), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16586), 2,
      sym_block_comment,
      sym_line_comment,
  [359326] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22878), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16587), 2,
      sym_block_comment,
      sym_line_comment,
  [359347] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22880), 1,
      sym__end_cmd,
    STATE(16650), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16588), 2,
      sym_block_comment,
      sym_line_comment,
  [359368] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7136), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22882), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16589), 2,
      sym_block_comment,
      sym_line_comment,
  [359391] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19174), 1,
      anon_sym_for,
    ACTIONS(22884), 1,
      anon_sym_COMMA,
    ACTIONS(22886), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(16590), 2,
      sym_block_comment,
      sym_line_comment,
  [359412] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7140), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17611), 1,
      anon_sym_COMMA,
    STATE(16718), 1,
      aux_sym_argument_list_repeat1,
    STATE(16591), 2,
      sym_block_comment,
      sym_line_comment,
  [359435] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16592), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22889), 4,
      sym__content_cmd_3,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [359452] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7608), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22891), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16593), 2,
      sym_block_comment,
      sym_line_comment,
  [359475] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8478), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22893), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16594), 2,
      sym_block_comment,
      sym_line_comment,
  [359498] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7614), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22895), 1,
      anon_sym_COMMA,
    STATE(16653), 1,
      aux_sym_argument_list_repeat1,
    STATE(16595), 2,
      sym_block_comment,
      sym_line_comment,
  [359521] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7614), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22895), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16596), 2,
      sym_block_comment,
      sym_line_comment,
  [359544] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22897), 1,
      sym__end_str,
    STATE(16729), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16597), 2,
      sym_block_comment,
      sym_line_comment,
  [359565] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22897), 1,
      sym__end_str,
    STATE(16731), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16598), 2,
      sym_block_comment,
      sym_line_comment,
  [359586] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22899), 1,
      sym__end_cmd,
    STATE(16733), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16599), 2,
      sym_block_comment,
      sym_line_comment,
  [359607] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22901), 1,
      anon_sym_RBRACK,
    ACTIONS(22903), 1,
      aux_sym__terminator_token1,
    ACTIONS(22905), 1,
      aux_sym__terminator_token2,
    STATE(16612), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16600), 2,
      sym_block_comment,
      sym_line_comment,
  [359630] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22907), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16601), 2,
      sym_block_comment,
      sym_line_comment,
  [359651] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22899), 1,
      sym__end_cmd,
    STATE(16735), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16602), 2,
      sym_block_comment,
      sym_line_comment,
  [359672] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16603), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 4,
      sym__content_cmd_3,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [359689] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22909), 1,
      anon_sym_RBRACK,
    ACTIONS(22911), 1,
      aux_sym__terminator_token1,
    ACTIONS(22913), 1,
      aux_sym__terminator_token2,
    STATE(16625), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16604), 2,
      sym_block_comment,
      sym_line_comment,
  [359712] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18355), 1,
      sym__word_identifier,
    STATE(17727), 1,
      sym_identifier,
    ACTIONS(9798), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(16605), 2,
      sym_block_comment,
      sym_line_comment,
  [359733] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22915), 1,
      anon_sym_COMMA,
    ACTIONS(22917), 1,
      anon_sym_RPAREN,
    STATE(16622), 1,
      aux_sym_argument_list_repeat1,
    STATE(16606), 2,
      sym_block_comment,
      sym_line_comment,
  [359756] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8058), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22919), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16607), 2,
      sym_block_comment,
      sym_line_comment,
  [359779] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8018), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17358), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16608), 2,
      sym_block_comment,
      sym_line_comment,
  [359802] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16609), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9740), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [359819] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16610), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9746), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [359836] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22921), 1,
      anon_sym_COMMA,
    ACTIONS(22923), 1,
      anon_sym_RPAREN,
    STATE(16636), 1,
      aux_sym_argument_list_repeat1,
    STATE(16611), 2,
      sym_block_comment,
      sym_line_comment,
  [359859] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22925), 1,
      anon_sym_RBRACK,
    ACTIONS(22927), 1,
      aux_sym__terminator_token1,
    ACTIONS(22929), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16612), 2,
      sym_block_comment,
      sym_line_comment,
  [359882] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7148), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22931), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16613), 2,
      sym_block_comment,
      sym_line_comment,
  [359905] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6920), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22933), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16614), 2,
      sym_block_comment,
      sym_line_comment,
  [359928] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7088), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17589), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16615), 2,
      sym_block_comment,
      sym_line_comment,
  [359951] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18355), 1,
      sym__word_identifier,
    STATE(17728), 1,
      sym_identifier,
    ACTIONS(9802), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(16616), 2,
      sym_block_comment,
      sym_line_comment,
  [359972] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6928), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22935), 1,
      anon_sym_COMMA,
    STATE(16834), 1,
      aux_sym_argument_list_repeat1,
    STATE(16617), 2,
      sym_block_comment,
      sym_line_comment,
  [359995] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22937), 1,
      sym__end_str,
    STATE(16638), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16618), 2,
      sym_block_comment,
      sym_line_comment,
  [360016] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22937), 1,
      sym__end_str,
    STATE(16640), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16619), 2,
      sym_block_comment,
      sym_line_comment,
  [360037] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22939), 1,
      sym__end_cmd,
    STATE(16641), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16620), 2,
      sym_block_comment,
      sym_line_comment,
  [360058] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22939), 1,
      sym__end_cmd,
    STATE(16642), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16621), 2,
      sym_block_comment,
      sym_line_comment,
  [360079] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8068), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22941), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16622), 2,
      sym_block_comment,
      sym_line_comment,
  [360102] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8076), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22943), 1,
      anon_sym_COMMA,
    STATE(16643), 1,
      aux_sym_argument_list_repeat1,
    STATE(16623), 2,
      sym_block_comment,
      sym_line_comment,
  [360125] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8076), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22943), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16624), 2,
      sym_block_comment,
      sym_line_comment,
  [360148] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22945), 1,
      anon_sym_RBRACK,
    ACTIONS(22947), 1,
      aux_sym__terminator_token1,
    ACTIONS(22949), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16625), 2,
      sym_block_comment,
      sym_line_comment,
  [360171] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22951), 1,
      anon_sym_COMMA,
    ACTIONS(22953), 1,
      anon_sym_RPAREN,
    STATE(16195), 1,
      aux_sym_argument_list_repeat1,
    STATE(16626), 2,
      sym_block_comment,
      sym_line_comment,
  [360194] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16627), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21326), 4,
      sym__content_cmd_1,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [360211] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16628), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21340), 4,
      sym__content_cmd_1,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [360228] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6928), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22935), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16629), 2,
      sym_block_comment,
      sym_line_comment,
  [360251] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22955), 1,
      anon_sym_COMMA,
    ACTIONS(22957), 1,
      anon_sym_RPAREN,
    STATE(16929), 1,
      aux_sym_argument_list_repeat1,
    STATE(16630), 2,
      sym_block_comment,
      sym_line_comment,
  [360274] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22959), 1,
      sym__end_str,
    STATE(16654), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16631), 2,
      sym_block_comment,
      sym_line_comment,
  [360295] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22959), 1,
      sym__end_str,
    STATE(16655), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16632), 2,
      sym_block_comment,
      sym_line_comment,
  [360316] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22961), 1,
      anon_sym_COMMA,
    ACTIONS(22963), 1,
      anon_sym_RPAREN,
    STATE(16740), 1,
      aux_sym_argument_list_repeat1,
    STATE(16633), 2,
      sym_block_comment,
      sym_line_comment,
  [360339] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22965), 1,
      sym__end_cmd,
    STATE(16656), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16634), 2,
      sym_block_comment,
      sym_line_comment,
  [360360] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22965), 1,
      sym__end_cmd,
    STATE(16657), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16635), 2,
      sym_block_comment,
      sym_line_comment,
  [360381] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7158), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22967), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16636), 2,
      sym_block_comment,
      sym_line_comment,
  [360404] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7166), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22969), 1,
      anon_sym_COMMA,
    STATE(16659), 1,
      aux_sym_argument_list_repeat1,
    STATE(16637), 2,
      sym_block_comment,
      sym_line_comment,
  [360427] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22971), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16638), 2,
      sym_block_comment,
      sym_line_comment,
  [360448] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7166), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22969), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16639), 2,
      sym_block_comment,
      sym_line_comment,
  [360471] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22971), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16640), 2,
      sym_block_comment,
      sym_line_comment,
  [360492] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22973), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16641), 2,
      sym_block_comment,
      sym_line_comment,
  [360513] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22973), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16642), 2,
      sym_block_comment,
      sym_line_comment,
  [360534] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8086), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22975), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16643), 2,
      sym_block_comment,
      sym_line_comment,
  [360557] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8090), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17492), 1,
      anon_sym_COMMA,
    STATE(16753), 1,
      aux_sym_argument_list_repeat1,
    STATE(16644), 2,
      sym_block_comment,
      sym_line_comment,
  [360580] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22977), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16645), 2,
      sym_block_comment,
      sym_line_comment,
  [360601] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22979), 1,
      anon_sym_COMMA,
    ACTIONS(22981), 1,
      anon_sym_RPAREN,
    STATE(16771), 1,
      aux_sym_argument_list_repeat1,
    STATE(16646), 2,
      sym_block_comment,
      sym_line_comment,
  [360624] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22977), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16647), 2,
      sym_block_comment,
      sym_line_comment,
  [360645] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(11020), 1,
      aux_sym__terminator_token2,
    ACTIONS(15522), 1,
      anon_sym_EQ,
    ACTIONS(11022), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(16648), 2,
      sym_block_comment,
      sym_line_comment,
  [360666] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22983), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16649), 2,
      sym_block_comment,
      sym_line_comment,
  [360687] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22983), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16650), 2,
      sym_block_comment,
      sym_line_comment,
  [360708] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16651), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9984), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [360725] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16652), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9988), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [360742] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7622), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22985), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16653), 2,
      sym_block_comment,
      sym_line_comment,
  [360765] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22987), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16654), 2,
      sym_block_comment,
      sym_line_comment,
  [360786] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22987), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16655), 2,
      sym_block_comment,
      sym_line_comment,
  [360807] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22989), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16656), 2,
      sym_block_comment,
      sym_line_comment,
  [360828] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22989), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16657), 2,
      sym_block_comment,
      sym_line_comment,
  [360849] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22991), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16658), 2,
      sym_block_comment,
      sym_line_comment,
  [360870] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7174), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(22993), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16659), 2,
      sym_block_comment,
      sym_line_comment,
  [360893] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16660), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10002), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [360910] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22991), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16661), 2,
      sym_block_comment,
      sym_line_comment,
  [360931] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22995), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16662), 2,
      sym_block_comment,
      sym_line_comment,
  [360952] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16663), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10006), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [360969] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7178), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17632), 1,
      anon_sym_COMMA,
    STATE(16809), 1,
      aux_sym_argument_list_repeat1,
    STATE(16664), 2,
      sym_block_comment,
      sym_line_comment,
  [360992] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(22997), 1,
      anon_sym_RBRACK,
    ACTIONS(22999), 1,
      aux_sym__terminator_token1,
    ACTIONS(23001), 1,
      aux_sym__terminator_token2,
    STATE(16678), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16665), 2,
      sym_block_comment,
      sym_line_comment,
  [361015] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6980), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23003), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16666), 2,
      sym_block_comment,
      sym_line_comment,
  [361038] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22995), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16667), 2,
      sym_block_comment,
      sym_line_comment,
  [361059] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7026), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23005), 1,
      anon_sym_COMMA,
    STATE(16776), 1,
      aux_sym_argument_list_repeat1,
    STATE(16668), 2,
      sym_block_comment,
      sym_line_comment,
  [361082] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23007), 1,
      anon_sym_RBRACK,
    ACTIONS(23009), 1,
      aux_sym__terminator_token1,
    ACTIONS(23011), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16669), 2,
      sym_block_comment,
      sym_line_comment,
  [361105] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7026), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23005), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16670), 2,
      sym_block_comment,
      sym_line_comment,
  [361128] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7626), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17593), 1,
      anon_sym_COMMA,
    STATE(16977), 1,
      aux_sym_argument_list_repeat1,
    STATE(16671), 2,
      sym_block_comment,
      sym_line_comment,
  [361151] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22907), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16672), 2,
      sym_block_comment,
      sym_line_comment,
  [361172] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23013), 1,
      anon_sym_COMMA,
    ACTIONS(23015), 1,
      anon_sym_RPAREN,
    STATE(16684), 1,
      aux_sym_argument_list_repeat1,
    STATE(16673), 2,
      sym_block_comment,
      sym_line_comment,
  [361195] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8102), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23017), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16674), 2,
      sym_block_comment,
      sym_line_comment,
  [361218] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8052), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17438), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16675), 2,
      sym_block_comment,
      sym_line_comment,
  [361241] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23019), 1,
      anon_sym_COMMA,
    ACTIONS(23021), 1,
      anon_sym_RPAREN,
    STATE(16138), 1,
      aux_sym_argument_list_repeat1,
    STATE(16676), 2,
      sym_block_comment,
      sym_line_comment,
  [361264] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23023), 1,
      anon_sym_RBRACK,
    ACTIONS(23025), 1,
      aux_sym__terminator_token1,
    ACTIONS(23027), 1,
      aux_sym__terminator_token2,
    STATE(16695), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16677), 2,
      sym_block_comment,
      sym_line_comment,
  [361287] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23029), 1,
      anon_sym_RBRACK,
    ACTIONS(23031), 1,
      aux_sym__terminator_token1,
    ACTIONS(23033), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16678), 2,
      sym_block_comment,
      sym_line_comment,
  [361310] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23035), 1,
      sym__end_str,
    STATE(16699), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16679), 2,
      sym_block_comment,
      sym_line_comment,
  [361331] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23035), 1,
      sym__end_str,
    STATE(16700), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16680), 2,
      sym_block_comment,
      sym_line_comment,
  [361352] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23037), 1,
      sym__end_cmd,
    STATE(16701), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16681), 2,
      sym_block_comment,
      sym_line_comment,
  [361373] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23037), 1,
      sym__end_cmd,
    STATE(16702), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16682), 2,
      sym_block_comment,
      sym_line_comment,
  [361394] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15522), 1,
      anon_sym_EQ,
    ACTIONS(17634), 1,
      aux_sym__terminator_token2,
    ACTIONS(17636), 2,
      ts_builtin_sym_end,
      aux_sym__terminator_token1,
    STATE(16683), 2,
      sym_block_comment,
      sym_line_comment,
  [361415] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8114), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23039), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16684), 2,
      sym_block_comment,
      sym_line_comment,
  [361438] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8120), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23041), 1,
      anon_sym_COMMA,
    STATE(16705), 1,
      aux_sym_argument_list_repeat1,
    STATE(16685), 2,
      sym_block_comment,
      sym_line_comment,
  [361461] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23043), 1,
      anon_sym_COMMA,
    ACTIONS(23045), 1,
      anon_sym_RPAREN,
    STATE(16713), 1,
      aux_sym_argument_list_repeat1,
    STATE(16686), 2,
      sym_block_comment,
      sym_line_comment,
  [361484] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8120), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23041), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16687), 2,
      sym_block_comment,
      sym_line_comment,
  [361507] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16688), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10012), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361524] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16689), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10016), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361541] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7184), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23047), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16690), 2,
      sym_block_comment,
      sym_line_comment,
  [361564] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7140), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17611), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16691), 2,
      sym_block_comment,
      sym_line_comment,
  [361587] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16692), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10020), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361604] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16693), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9918), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361621] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16694), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9922), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361638] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23049), 1,
      anon_sym_RBRACK,
    ACTIONS(23051), 1,
      aux_sym__terminator_token1,
    ACTIONS(23053), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16695), 2,
      sym_block_comment,
      sym_line_comment,
  [361661] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23055), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16696), 2,
      sym_block_comment,
      sym_line_comment,
  [361682] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23057), 1,
      anon_sym_RBRACK,
    ACTIONS(23059), 1,
      aux_sym__terminator_token1,
    ACTIONS(23061), 1,
      aux_sym__terminator_token2,
    STATE(16757), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16697), 2,
      sym_block_comment,
      sym_line_comment,
  [361705] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16698), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9992), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361722] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23063), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16699), 2,
      sym_block_comment,
      sym_line_comment,
  [361743] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23063), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16700), 2,
      sym_block_comment,
      sym_line_comment,
  [361764] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23065), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16701), 2,
      sym_block_comment,
      sym_line_comment,
  [361785] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23065), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16702), 2,
      sym_block_comment,
      sym_line_comment,
  [361806] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16703), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9996), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361823] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16704), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9754), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361840] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8128), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23067), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16705), 2,
      sym_block_comment,
      sym_line_comment,
  [361863] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16706), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9762), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361880] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23069), 1,
      sym__end_str,
    STATE(16725), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16707), 2,
      sym_block_comment,
      sym_line_comment,
  [361901] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16708), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10030), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361918] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23069), 1,
      sym__end_str,
    STATE(16726), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16709), 2,
      sym_block_comment,
      sym_line_comment,
  [361939] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23071), 1,
      sym__end_cmd,
    STATE(16727), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16710), 2,
      sym_block_comment,
      sym_line_comment,
  [361960] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23071), 1,
      sym__end_cmd,
    STATE(16728), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16711), 2,
      sym_block_comment,
      sym_line_comment,
  [361981] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16712), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10034), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [361998] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7194), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23073), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16713), 2,
      sym_block_comment,
      sym_line_comment,
  [362021] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16714), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10038), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [362038] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7200), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23075), 1,
      anon_sym_COMMA,
    STATE(16730), 1,
      aux_sym_argument_list_repeat1,
    STATE(16715), 2,
      sym_block_comment,
      sym_line_comment,
  [362061] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16716), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10042), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [362078] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23055), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16717), 2,
      sym_block_comment,
      sym_line_comment,
  [362099] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7200), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23075), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16718), 2,
      sym_block_comment,
      sym_line_comment,
  [362122] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23077), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16719), 2,
      sym_block_comment,
      sym_line_comment,
  [362143] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23079), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16720), 2,
      sym_block_comment,
      sym_line_comment,
  [362164] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23081), 1,
      anon_sym_COMMA,
    ACTIONS(23083), 1,
      anon_sym_RPAREN,
    STATE(16090), 1,
      aux_sym_argument_list_repeat1,
    STATE(16721), 2,
      sym_block_comment,
      sym_line_comment,
  [362187] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8764), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23085), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16722), 2,
      sym_block_comment,
      sym_line_comment,
  [362210] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7356), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23087), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16723), 2,
      sym_block_comment,
      sym_line_comment,
  [362233] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23089), 1,
      anon_sym_COMMA,
    ACTIONS(23091), 1,
      anon_sym_RPAREN,
    STATE(16883), 1,
      aux_sym_argument_list_repeat1,
    STATE(16724), 2,
      sym_block_comment,
      sym_line_comment,
  [362256] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23093), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16725), 2,
      sym_block_comment,
      sym_line_comment,
  [362277] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23093), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16726), 2,
      sym_block_comment,
      sym_line_comment,
  [362298] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23095), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16727), 2,
      sym_block_comment,
      sym_line_comment,
  [362319] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23095), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16728), 2,
      sym_block_comment,
      sym_line_comment,
  [362340] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23097), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16729), 2,
      sym_block_comment,
      sym_line_comment,
  [362361] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7208), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23099), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16730), 2,
      sym_block_comment,
      sym_line_comment,
  [362384] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23097), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16731), 2,
      sym_block_comment,
      sym_line_comment,
  [362405] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23101), 1,
      anon_sym_RBRACK,
    ACTIONS(23103), 1,
      aux_sym__terminator_token1,
    ACTIONS(23105), 1,
      aux_sym__terminator_token2,
    STATE(16743), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16732), 2,
      sym_block_comment,
      sym_line_comment,
  [362428] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23107), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16733), 2,
      sym_block_comment,
      sym_line_comment,
  [362449] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7212), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17654), 1,
      anon_sym_COMMA,
    STATE(16900), 1,
      aux_sym_argument_list_repeat1,
    STATE(16734), 2,
      sym_block_comment,
      sym_line_comment,
  [362472] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23107), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16735), 2,
      sym_block_comment,
      sym_line_comment,
  [362493] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16736), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [362510] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23109), 1,
      anon_sym_COMMA,
    ACTIONS(23111), 1,
      anon_sym_RPAREN,
    STATE(16751), 1,
      aux_sym_argument_list_repeat1,
    STATE(16737), 2,
      sym_block_comment,
      sym_line_comment,
  [362533] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23113), 1,
      anon_sym_RBRACK,
    ACTIONS(23115), 1,
      aux_sym__terminator_token1,
    ACTIONS(23117), 1,
      aux_sym__terminator_token2,
    STATE(16885), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16738), 2,
      sym_block_comment,
      sym_line_comment,
  [362556] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23119), 1,
      anon_sym_RBRACK,
    ACTIONS(23121), 1,
      aux_sym__terminator_token1,
    ACTIONS(23123), 1,
      aux_sym__terminator_token2,
    STATE(16822), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16739), 2,
      sym_block_comment,
      sym_line_comment,
  [362579] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8136), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23125), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16740), 2,
      sym_block_comment,
      sym_line_comment,
  [362602] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8090), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17492), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16741), 2,
      sym_block_comment,
      sym_line_comment,
  [362625] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23127), 1,
      anon_sym_RBRACK,
    ACTIONS(23129), 1,
      aux_sym__terminator_token1,
    ACTIONS(23131), 1,
      aux_sym__terminator_token2,
    STATE(16787), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16742), 2,
      sym_block_comment,
      sym_line_comment,
  [362648] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23133), 1,
      anon_sym_RBRACK,
    ACTIONS(23135), 1,
      aux_sym__terminator_token1,
    ACTIONS(23137), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16743), 2,
      sym_block_comment,
      sym_line_comment,
  [362671] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23139), 1,
      anon_sym_COMMA,
    ACTIONS(23141), 1,
      anon_sym_RPAREN,
    STATE(16783), 1,
      aux_sym_argument_list_repeat1,
    STATE(16744), 2,
      sym_block_comment,
      sym_line_comment,
  [362694] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7726), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23143), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16745), 2,
      sym_block_comment,
      sym_line_comment,
  [362717] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23077), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16746), 2,
      sym_block_comment,
      sym_line_comment,
  [362738] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23145), 1,
      sym__end_str,
    STATE(16769), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16747), 2,
      sym_block_comment,
      sym_line_comment,
  [362759] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23145), 1,
      sym__end_str,
    STATE(16770), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16748), 2,
      sym_block_comment,
      sym_line_comment,
  [362780] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23147), 1,
      sym__end_cmd,
    STATE(16772), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16749), 2,
      sym_block_comment,
      sym_line_comment,
  [362801] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23147), 1,
      sym__end_cmd,
    STATE(16773), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16750), 2,
      sym_block_comment,
      sym_line_comment,
  [362822] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8148), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23149), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16751), 2,
      sym_block_comment,
      sym_line_comment,
  [362845] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8156), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23151), 1,
      anon_sym_COMMA,
    STATE(16778), 1,
      aux_sym_argument_list_repeat1,
    STATE(16752), 2,
      sym_block_comment,
      sym_line_comment,
  [362868] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8156), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23151), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16753), 2,
      sym_block_comment,
      sym_line_comment,
  [362891] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(23153), 1,
      anon_sym_RPAREN,
    ACTIONS(23155), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16754), 2,
      sym_block_comment,
      sym_line_comment,
  [362914] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7098), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17702), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16755), 2,
      sym_block_comment,
      sym_line_comment,
  [362937] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16756), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9792), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [362954] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23157), 1,
      anon_sym_RBRACK,
    ACTIONS(23159), 1,
      aux_sym__terminator_token1,
    ACTIONS(23161), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16757), 2,
      sym_block_comment,
      sym_line_comment,
  [362977] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23163), 1,
      anon_sym_SEMI,
    ACTIONS(19174), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    STATE(16758), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_parenthesized_expression_repeat1,
  [362996] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16759), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10046), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363013] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23166), 1,
      anon_sym_COMMA,
    ACTIONS(23168), 1,
      anon_sym_RPAREN,
    STATE(16807), 1,
      aux_sym_argument_list_repeat1,
    STATE(16760), 2,
      sym_block_comment,
      sym_line_comment,
  [363036] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16761), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10050), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363053] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16762), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10054), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363070] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23170), 1,
      sym__end_str,
    STATE(16795), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16763), 2,
      sym_block_comment,
      sym_line_comment,
  [363091] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23170), 1,
      sym__end_str,
    STATE(16797), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16764), 2,
      sym_block_comment,
      sym_line_comment,
  [363112] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23172), 1,
      sym__end_cmd,
    STATE(16799), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16765), 2,
      sym_block_comment,
      sym_line_comment,
  [363133] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23172), 1,
      sym__end_cmd,
    STATE(16800), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16766), 2,
      sym_block_comment,
      sym_line_comment,
  [363154] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6976), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23174), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16767), 2,
      sym_block_comment,
      sym_line_comment,
  [363177] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16768), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10058), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363194] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23176), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16769), 2,
      sym_block_comment,
      sym_line_comment,
  [363215] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23176), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16770), 2,
      sym_block_comment,
      sym_line_comment,
  [363236] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7218), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23178), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16771), 2,
      sym_block_comment,
      sym_line_comment,
  [363259] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23180), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16772), 2,
      sym_block_comment,
      sym_line_comment,
  [363280] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23180), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16773), 2,
      sym_block_comment,
      sym_line_comment,
  [363301] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7178), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17632), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16774), 2,
      sym_block_comment,
      sym_line_comment,
  [363324] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16775), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9900), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363341] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7104), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23182), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16776), 2,
      sym_block_comment,
      sym_line_comment,
  [363364] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17615), 1,
      anon_sym_COMMA,
    STATE(16629), 1,
      aux_sym_argument_list_repeat1,
    STATE(16777), 2,
      sym_block_comment,
      sym_line_comment,
  [363387] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8164), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23184), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16778), 2,
      sym_block_comment,
      sym_line_comment,
  [363410] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16779), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10062), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363427] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16780), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10066), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363444] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(17636), 1,
      ts_builtin_sym_end,
    ACTIONS(23186), 1,
      aux_sym__terminator_token1,
    ACTIONS(23189), 1,
      aux_sym__terminator_token2,
    STATE(16781), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym__block_repeat1,
  [363465] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16782), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10070), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363482] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7802), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23192), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16783), 2,
      sym_block_comment,
      sym_line_comment,
  [363505] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7832), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23194), 1,
      anon_sym_COMMA,
    STATE(16810), 1,
      aux_sym_argument_list_repeat1,
    STATE(16784), 2,
      sym_block_comment,
      sym_line_comment,
  [363528] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7832), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23194), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16785), 2,
      sym_block_comment,
      sym_line_comment,
  [363551] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17743), 1,
      anon_sym_RPAREN,
    ACTIONS(23196), 2,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(16786), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_argument_list_repeat1,
  [363570] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23199), 1,
      anon_sym_RBRACK,
    ACTIONS(23201), 1,
      aux_sym__terminator_token1,
    ACTIONS(23203), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16787), 2,
      sym_block_comment,
      sym_line_comment,
  [363593] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16788), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10074), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363610] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16789), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10078), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363627] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23205), 1,
      anon_sym_RBRACK,
    ACTIONS(23207), 1,
      aux_sym__terminator_token1,
    ACTIONS(23209), 1,
      aux_sym__terminator_token2,
    STATE(16802), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16790), 2,
      sym_block_comment,
      sym_line_comment,
  [363650] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23211), 1,
      anon_sym_COMMA,
    ACTIONS(23213), 1,
      anon_sym_RPAREN,
    STATE(16843), 1,
      aux_sym_argument_list_repeat1,
    STATE(16791), 2,
      sym_block_comment,
      sym_line_comment,
  [363673] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16792), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(10082), 4,
      sym__immediate_paren,
      sym__immediate_bracket,
      sym__immediate_brace,
      anon_sym_DOT,
  [363690] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23215), 1,
      anon_sym_COMMA,
    ACTIONS(23217), 1,
      anon_sym_RPAREN,
    STATE(16219), 1,
      aux_sym_argument_list_repeat1,
    STATE(16793), 2,
      sym_block_comment,
      sym_line_comment,
  [363713] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7632), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23219), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16794), 2,
      sym_block_comment,
      sym_line_comment,
  [363736] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23221), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16795), 2,
      sym_block_comment,
      sym_line_comment,
  [363757] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7592), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17579), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16796), 2,
      sym_block_comment,
      sym_line_comment,
  [363780] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23221), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16797), 2,
      sym_block_comment,
      sym_line_comment,
  [363801] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23223), 1,
      sym__end_str,
    STATE(15394), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16798), 2,
      sym_block_comment,
      sym_line_comment,
  [363822] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23225), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16799), 2,
      sym_block_comment,
      sym_line_comment,
  [363843] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23225), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16800), 2,
      sym_block_comment,
      sym_line_comment,
  [363864] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23223), 1,
      sym__end_str,
    STATE(15399), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16801), 2,
      sym_block_comment,
      sym_line_comment,
  [363885] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23227), 1,
      anon_sym_RBRACK,
    ACTIONS(23229), 1,
      aux_sym__terminator_token1,
    ACTIONS(23231), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16802), 2,
      sym_block_comment,
      sym_line_comment,
  [363908] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23233), 1,
      sym__end_str,
    STATE(16819), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16803), 2,
      sym_block_comment,
      sym_line_comment,
  [363929] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23233), 1,
      sym__end_str,
    STATE(16820), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16804), 2,
      sym_block_comment,
      sym_line_comment,
  [363950] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23235), 1,
      sym__end_cmd,
    STATE(16821), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16805), 2,
      sym_block_comment,
      sym_line_comment,
  [363971] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23235), 1,
      sym__end_cmd,
    STATE(16823), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16806), 2,
      sym_block_comment,
      sym_line_comment,
  [363992] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7230), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23237), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16807), 2,
      sym_block_comment,
      sym_line_comment,
  [364015] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7238), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23239), 1,
      anon_sym_COMMA,
    STATE(16825), 1,
      aux_sym_argument_list_repeat1,
    STATE(16808), 2,
      sym_block_comment,
      sym_line_comment,
  [364038] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7238), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23239), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16809), 2,
      sym_block_comment,
      sym_line_comment,
  [364061] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7864), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23241), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16810), 2,
      sym_block_comment,
      sym_line_comment,
  [364084] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7122), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17679), 1,
      anon_sym_COMMA,
    STATE(16122), 1,
      aux_sym_argument_list_repeat1,
    STATE(16811), 2,
      sym_block_comment,
      sym_line_comment,
  [364107] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23243), 1,
      sym__end_cmd,
    STATE(15406), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16812), 2,
      sym_block_comment,
      sym_line_comment,
  [364128] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23245), 1,
      sym__end_str,
    STATE(16827), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16813), 2,
      sym_block_comment,
      sym_line_comment,
  [364149] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7880), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17617), 1,
      anon_sym_COMMA,
    STATE(17034), 1,
      aux_sym_argument_list_repeat1,
    STATE(16814), 2,
      sym_block_comment,
      sym_line_comment,
  [364172] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23245), 1,
      sym__end_str,
    STATE(16828), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16815), 2,
      sym_block_comment,
      sym_line_comment,
  [364193] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23247), 1,
      sym__end_cmd,
    STATE(16829), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16816), 2,
      sym_block_comment,
      sym_line_comment,
  [364214] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23247), 1,
      sym__end_cmd,
    STATE(16830), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16817), 2,
      sym_block_comment,
      sym_line_comment,
  [364235] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23249), 1,
      anon_sym_COMMA,
    ACTIONS(23251), 1,
      anon_sym_RPAREN,
    STATE(16947), 1,
      aux_sym_argument_list_repeat1,
    STATE(16818), 2,
      sym_block_comment,
      sym_line_comment,
  [364258] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23253), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16819), 2,
      sym_block_comment,
      sym_line_comment,
  [364279] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23253), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16820), 2,
      sym_block_comment,
      sym_line_comment,
  [364300] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23255), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16821), 2,
      sym_block_comment,
      sym_line_comment,
  [364321] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23257), 1,
      anon_sym_RBRACK,
    ACTIONS(23259), 1,
      aux_sym__terminator_token1,
    ACTIONS(23261), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16822), 2,
      sym_block_comment,
      sym_line_comment,
  [364344] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23255), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16823), 2,
      sym_block_comment,
      sym_line_comment,
  [364365] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23243), 1,
      sym__end_cmd,
    STATE(15412), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16824), 2,
      sym_block_comment,
      sym_line_comment,
  [364386] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7248), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23263), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16825), 2,
      sym_block_comment,
      sym_line_comment,
  [364409] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23265), 1,
      anon_sym_COMMA,
    ACTIONS(23267), 1,
      anon_sym_RPAREN,
    STATE(15355), 1,
      aux_sym_argument_list_repeat1,
    STATE(16826), 2,
      sym_block_comment,
      sym_line_comment,
  [364432] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23269), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16827), 2,
      sym_block_comment,
      sym_line_comment,
  [364453] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23269), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16828), 2,
      sym_block_comment,
      sym_line_comment,
  [364474] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23271), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16829), 2,
      sym_block_comment,
      sym_line_comment,
  [364495] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23271), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16830), 2,
      sym_block_comment,
      sym_line_comment,
  [364516] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8482), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17572), 1,
      anon_sym_COMMA,
    STATE(16848), 1,
      aux_sym_argument_list_repeat1,
    STATE(16831), 2,
      sym_block_comment,
      sym_line_comment,
  [364539] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17712), 1,
      anon_sym_COMMA,
    STATE(16990), 1,
      aux_sym_argument_list_repeat1,
    STATE(16832), 2,
      sym_block_comment,
      sym_line_comment,
  [364562] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23273), 1,
      anon_sym_COMMA,
    ACTIONS(23275), 1,
      anon_sym_RPAREN,
    STATE(16920), 1,
      aux_sym_argument_list_repeat1,
    STATE(16833), 2,
      sym_block_comment,
      sym_line_comment,
  [364585] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6938), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23277), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16834), 2,
      sym_block_comment,
      sym_line_comment,
  [364608] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8822), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23279), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16835), 2,
      sym_block_comment,
      sym_line_comment,
  [364631] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6942), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17496), 1,
      anon_sym_COMMA,
    STATE(16165), 1,
      aux_sym_argument_list_repeat1,
    STATE(16836), 2,
      sym_block_comment,
      sym_line_comment,
  [364654] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23281), 1,
      sym__end_str,
    STATE(16865), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16837), 2,
      sym_block_comment,
      sym_line_comment,
  [364675] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23283), 1,
      anon_sym_RBRACK,
    ACTIONS(23285), 1,
      aux_sym__terminator_token1,
    ACTIONS(23287), 1,
      aux_sym__terminator_token2,
    STATE(16847), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16838), 2,
      sym_block_comment,
      sym_line_comment,
  [364698] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23281), 1,
      sym__end_str,
    STATE(16866), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16839), 2,
      sym_block_comment,
      sym_line_comment,
  [364719] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23289), 1,
      sym__end_cmd,
    STATE(16867), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16840), 2,
      sym_block_comment,
      sym_line_comment,
  [364740] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23289), 1,
      sym__end_cmd,
    STATE(16869), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16841), 2,
      sym_block_comment,
      sym_line_comment,
  [364761] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8830), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23291), 1,
      anon_sym_COMMA,
    STATE(17032), 1,
      aux_sym_argument_list_repeat1,
    STATE(16842), 2,
      sym_block_comment,
      sym_line_comment,
  [364784] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7642), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23293), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16843), 2,
      sym_block_comment,
      sym_line_comment,
  [364807] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7650), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23295), 1,
      anon_sym_COMMA,
    STATE(16871), 1,
      aux_sym_argument_list_repeat1,
    STATE(16844), 2,
      sym_block_comment,
      sym_line_comment,
  [364830] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7650), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23295), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16845), 2,
      sym_block_comment,
      sym_line_comment,
  [364853] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21663), 1,
      anon_sym_catch,
    ACTIONS(21665), 1,
      anon_sym_finally,
    STATE(15223), 1,
      sym_catch_clause,
    STATE(17426), 1,
      sym_finally_clause,
    STATE(16846), 2,
      sym_block_comment,
      sym_line_comment,
  [364876] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23297), 1,
      anon_sym_RBRACK,
    ACTIONS(23299), 1,
      aux_sym__terminator_token1,
    ACTIONS(23301), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16847), 2,
      sym_block_comment,
      sym_line_comment,
  [364899] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8830), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23291), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16848), 2,
      sym_block_comment,
      sym_line_comment,
  [364922] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18463), 1,
      anon_sym_COMMA,
    ACTIONS(10840), 2,
      anon_sym_EQ,
      anon_sym_COLON2,
    STATE(16849), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
  [364941] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23303), 1,
      sym__end_str,
    STATE(16856), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16850), 2,
      sym_block_comment,
      sym_line_comment,
  [364962] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23303), 1,
      sym__end_str,
    STATE(16857), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16851), 2,
      sym_block_comment,
      sym_line_comment,
  [364983] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23305), 1,
      sym__end_cmd,
    STATE(16858), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16852), 2,
      sym_block_comment,
      sym_line_comment,
  [365004] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23305), 1,
      sym__end_cmd,
    STATE(16860), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16853), 2,
      sym_block_comment,
      sym_line_comment,
  [365025] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7346), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(21194), 1,
      anon_sym_COMMA,
    STATE(16723), 1,
      aux_sym_argument_list_repeat1,
    STATE(16854), 2,
      sym_block_comment,
      sym_line_comment,
  [365048] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7472), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23307), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16855), 2,
      sym_block_comment,
      sym_line_comment,
  [365071] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23309), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16856), 2,
      sym_block_comment,
      sym_line_comment,
  [365092] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23309), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16857), 2,
      sym_block_comment,
      sym_line_comment,
  [365113] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23311), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16858), 2,
      sym_block_comment,
      sym_line_comment,
  [365134] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23313), 1,
      anon_sym_COMMA,
    ACTIONS(19334), 2,
      anon_sym_for,
      anon_sym_RPAREN,
    STATE(16859), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_tuple_expression_repeat1,
  [365153] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23311), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16860), 2,
      sym_block_comment,
      sym_line_comment,
  [365174] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23316), 1,
      anon_sym_RBRACK,
    ACTIONS(23318), 1,
      aux_sym__terminator_token1,
    ACTIONS(23320), 1,
      aux_sym__terminator_token2,
    STATE(16940), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16861), 2,
      sym_block_comment,
      sym_line_comment,
  [365197] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6862), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23322), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16862), 2,
      sym_block_comment,
      sym_line_comment,
  [365220] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23324), 1,
      anon_sym_COMMA,
    ACTIONS(23326), 1,
      anon_sym_RPAREN,
    STATE(15362), 1,
      aux_sym_argument_list_repeat1,
    STATE(16863), 2,
      sym_block_comment,
      sym_line_comment,
  [365243] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7418), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17488), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16864), 2,
      sym_block_comment,
      sym_line_comment,
  [365266] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23328), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16865), 2,
      sym_block_comment,
      sym_line_comment,
  [365287] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23328), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16866), 2,
      sym_block_comment,
      sym_line_comment,
  [365308] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23330), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16867), 2,
      sym_block_comment,
      sym_line_comment,
  [365329] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23332), 1,
      anon_sym_RBRACK,
    ACTIONS(23334), 1,
      aux_sym__terminator_token1,
    ACTIONS(23336), 1,
      aux_sym__terminator_token2,
    STATE(16888), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16868), 2,
      sym_block_comment,
      sym_line_comment,
  [365352] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23330), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16869), 2,
      sym_block_comment,
      sym_line_comment,
  [365373] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23338), 1,
      anon_sym_RBRACK,
    ACTIONS(23340), 1,
      aux_sym__terminator_token1,
    ACTIONS(23342), 1,
      aux_sym__terminator_token2,
    STATE(16875), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16870), 2,
      sym_block_comment,
      sym_line_comment,
  [365396] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7658), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23344), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16871), 2,
      sym_block_comment,
      sym_line_comment,
  [365419] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7662), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17607), 1,
      anon_sym_COMMA,
    STATE(15390), 1,
      aux_sym_argument_list_repeat1,
    STATE(16872), 2,
      sym_block_comment,
      sym_line_comment,
  [365442] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23346), 1,
      anon_sym_RBRACK,
    ACTIONS(23348), 1,
      aux_sym__terminator_token1,
    ACTIONS(23350), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16873), 2,
      sym_block_comment,
      sym_line_comment,
  [365465] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7402), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23352), 1,
      anon_sym_COMMA,
    STATE(15418), 1,
      aux_sym_argument_list_repeat1,
    STATE(16874), 2,
      sym_block_comment,
      sym_line_comment,
  [365488] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23354), 1,
      anon_sym_RBRACK,
    ACTIONS(23356), 1,
      aux_sym__terminator_token1,
    ACTIONS(23358), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16875), 2,
      sym_block_comment,
      sym_line_comment,
  [365511] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(23360), 1,
      anon_sym_RPAREN,
    ACTIONS(23362), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16876), 2,
      sym_block_comment,
      sym_line_comment,
  [365534] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8428), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23364), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16877), 2,
      sym_block_comment,
      sym_line_comment,
  [365557] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23366), 1,
      sym__end_str,
    STATE(16889), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16878), 2,
      sym_block_comment,
      sym_line_comment,
  [365578] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23366), 1,
      sym__end_str,
    STATE(16890), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16879), 2,
      sym_block_comment,
      sym_line_comment,
  [365599] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23368), 1,
      anon_sym_COMMA,
    ACTIONS(23370), 1,
      anon_sym_RPAREN,
    STATE(16898), 1,
      aux_sym_argument_list_repeat1,
    STATE(16880), 2,
      sym_block_comment,
      sym_line_comment,
  [365622] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23372), 1,
      sym__end_cmd,
    STATE(16891), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16881), 2,
      sym_block_comment,
      sym_line_comment,
  [365643] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23372), 1,
      sym__end_cmd,
    STATE(16892), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16882), 2,
      sym_block_comment,
      sym_line_comment,
  [365664] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7258), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23374), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16883), 2,
      sym_block_comment,
      sym_line_comment,
  [365687] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7212), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17654), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16884), 2,
      sym_block_comment,
      sym_line_comment,
  [365710] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23376), 1,
      anon_sym_RBRACK,
    ACTIONS(23378), 1,
      aux_sym__terminator_token1,
    ACTIONS(23380), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16885), 2,
      sym_block_comment,
      sym_line_comment,
  [365733] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8452), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23382), 1,
      anon_sym_COMMA,
    STATE(16594), 1,
      aux_sym_argument_list_repeat1,
    STATE(16886), 2,
      sym_block_comment,
      sym_line_comment,
  [365756] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7402), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23352), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16887), 2,
      sym_block_comment,
      sym_line_comment,
  [365779] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23384), 1,
      anon_sym_RBRACK,
    ACTIONS(23386), 1,
      aux_sym__terminator_token1,
    ACTIONS(23388), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16888), 2,
      sym_block_comment,
      sym_line_comment,
  [365802] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23390), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16889), 2,
      sym_block_comment,
      sym_line_comment,
  [365823] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23390), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16890), 2,
      sym_block_comment,
      sym_line_comment,
  [365844] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23392), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16891), 2,
      sym_block_comment,
      sym_line_comment,
  [365865] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23392), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16892), 2,
      sym_block_comment,
      sym_line_comment,
  [365886] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23394), 1,
      sym__end_str,
    STATE(16907), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16893), 2,
      sym_block_comment,
      sym_line_comment,
  [365907] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23394), 1,
      sym__end_str,
    STATE(16908), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16894), 2,
      sym_block_comment,
      sym_line_comment,
  [365928] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23396), 1,
      sym__end_cmd,
    STATE(16909), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16895), 2,
      sym_block_comment,
      sym_line_comment,
  [365949] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23396), 1,
      sym__end_cmd,
    STATE(16910), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16896), 2,
      sym_block_comment,
      sym_line_comment,
  [365970] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23398), 1,
      anon_sym_COMMA,
    ACTIONS(23400), 1,
      anon_sym_RPAREN,
    STATE(15470), 1,
      aux_sym_argument_list_repeat1,
    STATE(16897), 2,
      sym_block_comment,
      sym_line_comment,
  [365993] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7268), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23402), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16898), 2,
      sym_block_comment,
      sym_line_comment,
  [366016] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7274), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23404), 1,
      anon_sym_COMMA,
    STATE(16912), 1,
      aux_sym_argument_list_repeat1,
    STATE(16899), 2,
      sym_block_comment,
      sym_line_comment,
  [366039] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7274), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23404), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16900), 2,
      sym_block_comment,
      sym_line_comment,
  [366062] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23406), 1,
      anon_sym_COMMA,
    ACTIONS(23408), 1,
      anon_sym_RPAREN,
    STATE(16201), 1,
      aux_sym_argument_list_repeat1,
    STATE(16901), 2,
      sym_block_comment,
      sym_line_comment,
  [366085] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16902), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(9644), 4,
      sym__content_cmd_1,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [366102] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23410), 1,
      anon_sym_RBRACK,
    ACTIONS(23412), 1,
      aux_sym__terminator_token1,
    ACTIONS(23414), 1,
      aux_sym__terminator_token2,
    STATE(16942), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16903), 2,
      sym_block_comment,
      sym_line_comment,
  [366125] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23416), 1,
      anon_sym_RBRACK,
    ACTIONS(23418), 1,
      aux_sym__terminator_token1,
    ACTIONS(23420), 1,
      aux_sym__terminator_token2,
    STATE(16916), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16904), 2,
      sym_block_comment,
      sym_line_comment,
  [366148] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23422), 1,
      anon_sym_COMMA,
    ACTIONS(23424), 1,
      anon_sym_RPAREN,
    STATE(17056), 1,
      aux_sym_argument_list_repeat1,
    STATE(16905), 2,
      sym_block_comment,
      sym_line_comment,
  [366171] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7360), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17364), 1,
      anon_sym_COMMA,
    STATE(16148), 1,
      aux_sym_argument_list_repeat1,
    STATE(16906), 2,
      sym_block_comment,
      sym_line_comment,
  [366194] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23426), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16907), 2,
      sym_block_comment,
      sym_line_comment,
  [366215] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23426), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16908), 2,
      sym_block_comment,
      sym_line_comment,
  [366236] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23428), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16909), 2,
      sym_block_comment,
      sym_line_comment,
  [366257] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23428), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16910), 2,
      sym_block_comment,
      sym_line_comment,
  [366278] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23079), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16911), 2,
      sym_block_comment,
      sym_line_comment,
  [366299] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7282), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23430), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16912), 2,
      sym_block_comment,
      sym_line_comment,
  [366322] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23432), 1,
      sym__end_str,
    STATE(17051), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16913), 2,
      sym_block_comment,
      sym_line_comment,
  [366343] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7286), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17310), 1,
      anon_sym_COMMA,
    STATE(15349), 1,
      aux_sym_argument_list_repeat1,
    STATE(16914), 2,
      sym_block_comment,
      sym_line_comment,
  [366366] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23432), 1,
      sym__end_str,
    STATE(17060), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16915), 2,
      sym_block_comment,
      sym_line_comment,
  [366387] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23434), 1,
      anon_sym_RBRACK,
    ACTIONS(23436), 1,
      aux_sym__terminator_token1,
    ACTIONS(23438), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16916), 2,
      sym_block_comment,
      sym_line_comment,
  [366410] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23440), 1,
      sym__end_cmd,
    STATE(17062), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16917), 2,
      sym_block_comment,
      sym_line_comment,
  [366431] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23440), 1,
      sym__end_cmd,
    STATE(17063), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16918), 2,
      sym_block_comment,
      sym_line_comment,
  [366452] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23442), 1,
      anon_sym_COMMA,
    ACTIONS(23444), 1,
      anon_sym_RPAREN,
    STATE(16835), 1,
      aux_sym_argument_list_repeat1,
    STATE(16919), 2,
      sym_block_comment,
      sym_line_comment,
  [366475] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7486), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23446), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16920), 2,
      sym_block_comment,
      sym_line_comment,
  [366498] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23448), 1,
      sym__end_str,
    STATE(16930), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16921), 2,
      sym_block_comment,
      sym_line_comment,
  [366519] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23448), 1,
      sym__end_str,
    STATE(16931), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16922), 2,
      sym_block_comment,
      sym_line_comment,
  [366540] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23450), 1,
      sym__end_cmd,
    STATE(16932), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16923), 2,
      sym_block_comment,
      sym_line_comment,
  [366561] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23450), 1,
      sym__end_cmd,
    STATE(16934), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16924), 2,
      sym_block_comment,
      sym_line_comment,
  [366582] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23452), 1,
      anon_sym_COMMA,
    ACTIONS(23454), 1,
      anon_sym_RPAREN,
    STATE(16970), 1,
      aux_sym_argument_list_repeat1,
    STATE(16925), 2,
      sym_block_comment,
      sym_line_comment,
  [366605] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7494), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23456), 1,
      anon_sym_COMMA,
    STATE(15354), 1,
      aux_sym_argument_list_repeat1,
    STATE(16926), 2,
      sym_block_comment,
      sym_line_comment,
  [366628] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23458), 1,
      anon_sym_COMMA,
    ACTIONS(23460), 1,
      anon_sym_RPAREN,
    STATE(16950), 1,
      aux_sym_argument_list_repeat1,
    STATE(16927), 2,
      sym_block_comment,
      sym_line_comment,
  [366651] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23462), 1,
      anon_sym_RBRACK,
    ACTIONS(23464), 1,
      aux_sym__terminator_token1,
    ACTIONS(23466), 1,
      aux_sym__terminator_token2,
    STATE(16963), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16928), 2,
      sym_block_comment,
      sym_line_comment,
  [366674] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7668), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23468), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16929), 2,
      sym_block_comment,
      sym_line_comment,
  [366697] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23470), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16930), 2,
      sym_block_comment,
      sym_line_comment,
  [366718] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23470), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16931), 2,
      sym_block_comment,
      sym_line_comment,
  [366739] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23472), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16932), 2,
      sym_block_comment,
      sym_line_comment,
  [366760] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8080), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23474), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16933), 2,
      sym_block_comment,
      sym_line_comment,
  [366783] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23472), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16934), 2,
      sym_block_comment,
      sym_line_comment,
  [366804] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(23476), 1,
      anon_sym_RPAREN,
    ACTIONS(23478), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(16935), 2,
      sym_block_comment,
      sym_line_comment,
  [366827] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7494), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23456), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16936), 2,
      sym_block_comment,
      sym_line_comment,
  [366850] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7544), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17354), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16937), 2,
      sym_block_comment,
      sym_line_comment,
  [366873] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7626), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17593), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16938), 2,
      sym_block_comment,
      sym_line_comment,
  [366896] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23480), 1,
      anon_sym_COMMA,
    ACTIONS(23482), 1,
      anon_sym_RPAREN,
    STATE(15462), 1,
      aux_sym_argument_list_repeat1,
    STATE(16939), 2,
      sym_block_comment,
      sym_line_comment,
  [366919] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23484), 1,
      anon_sym_RBRACK,
    ACTIONS(23486), 1,
      aux_sym__terminator_token1,
    ACTIONS(23488), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16940), 2,
      sym_block_comment,
      sym_line_comment,
  [366942] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23490), 1,
      anon_sym_COMMA,
    ACTIONS(23492), 1,
      anon_sym_RPAREN,
    STATE(16986), 1,
      aux_sym_argument_list_repeat1,
    STATE(16941), 2,
      sym_block_comment,
      sym_line_comment,
  [366965] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23494), 1,
      anon_sym_RBRACK,
    ACTIONS(23496), 1,
      aux_sym__terminator_token1,
    ACTIONS(23498), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16942), 2,
      sym_block_comment,
      sym_line_comment,
  [366988] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23500), 1,
      sym__end_str,
    STATE(16958), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16943), 2,
      sym_block_comment,
      sym_line_comment,
  [367009] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23500), 1,
      sym__end_str,
    STATE(16959), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16944), 2,
      sym_block_comment,
      sym_line_comment,
  [367030] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23502), 1,
      sym__end_cmd,
    STATE(16960), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16945), 2,
      sym_block_comment,
      sym_line_comment,
  [367051] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23502), 1,
      sym__end_cmd,
    STATE(16961), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16946), 2,
      sym_block_comment,
      sym_line_comment,
  [367072] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7292), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23504), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16947), 2,
      sym_block_comment,
      sym_line_comment,
  [367095] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23506), 1,
      anon_sym_RBRACK,
    ACTIONS(23508), 1,
      aux_sym__terminator_token1,
    ACTIONS(23510), 1,
      aux_sym__terminator_token2,
    STATE(16968), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16948), 2,
      sym_block_comment,
      sym_line_comment,
  [367118] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17712), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16949), 2,
      sym_block_comment,
      sym_line_comment,
  [367141] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8142), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23512), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16950), 2,
      sym_block_comment,
      sym_line_comment,
  [367164] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8178), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23514), 1,
      anon_sym_COMMA,
    STATE(16964), 1,
      aux_sym_argument_list_repeat1,
    STATE(16951), 2,
      sym_block_comment,
      sym_line_comment,
  [367187] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8178), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23514), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16952), 2,
      sym_block_comment,
      sym_line_comment,
  [367210] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22241), 1,
      anon_sym_DQUOTE,
    ACTIONS(22243), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(15377), 1,
      sym__delimiter_str_1,
    STATE(15439), 1,
      sym__delimiter_str_3,
    STATE(16953), 2,
      sym_block_comment,
      sym_line_comment,
  [367233] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23516), 1,
      anon_sym_COMMA,
    ACTIONS(19396), 2,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(16954), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_vector_expression_repeat1,
  [367252] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23519), 1,
      sym__end_str,
    STATE(17006), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16955), 2,
      sym_block_comment,
      sym_line_comment,
  [367273] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23521), 1,
      anon_sym_COMMA,
    ACTIONS(23523), 1,
      anon_sym_RPAREN,
    STATE(17001), 1,
      aux_sym_argument_list_repeat1,
    STATE(16956), 2,
      sym_block_comment,
      sym_line_comment,
  [367296] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23519), 1,
      sym__end_str,
    STATE(17007), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16957), 2,
      sym_block_comment,
      sym_line_comment,
  [367317] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23525), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16958), 2,
      sym_block_comment,
      sym_line_comment,
  [367338] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23525), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16959), 2,
      sym_block_comment,
      sym_line_comment,
  [367359] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23527), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16960), 2,
      sym_block_comment,
      sym_line_comment,
  [367380] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23527), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16961), 2,
      sym_block_comment,
      sym_line_comment,
  [367401] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22245), 1,
      anon_sym_BQUOTE,
    ACTIONS(22247), 1,
      anon_sym_BQUOTE_BQUOTE_BQUOTE,
    STATE(15440), 1,
      sym__delimiter_cmd_1,
    STATE(15441), 1,
      sym__delimiter_cmd_3,
    STATE(16962), 2,
      sym_block_comment,
      sym_line_comment,
  [367424] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23529), 1,
      anon_sym_RBRACK,
    ACTIONS(23531), 1,
      aux_sym__terminator_token1,
    ACTIONS(23533), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16963), 2,
      sym_block_comment,
      sym_line_comment,
  [367447] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8208), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23535), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16964), 2,
      sym_block_comment,
      sym_line_comment,
  [367470] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23537), 1,
      sym__end_cmd,
    STATE(17009), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16965), 2,
      sym_block_comment,
      sym_line_comment,
  [367491] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8226), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17698), 1,
      anon_sym_COMMA,
    STATE(16228), 1,
      aux_sym_argument_list_repeat1,
    STATE(16966), 2,
      sym_block_comment,
      sym_line_comment,
  [367514] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16967), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23539), 4,
      sym__content_str_1,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [367531] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23541), 1,
      anon_sym_RBRACK,
    ACTIONS(23543), 1,
      aux_sym__terminator_token1,
    ACTIONS(23545), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16968), 2,
      sym_block_comment,
      sym_line_comment,
  [367554] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23537), 1,
      sym__end_cmd,
    STATE(17022), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16969), 2,
      sym_block_comment,
      sym_line_comment,
  [367575] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7678), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23547), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16970), 2,
      sym_block_comment,
      sym_line_comment,
  [367598] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7684), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23549), 1,
      anon_sym_COMMA,
    STATE(17027), 1,
      aux_sym_argument_list_repeat1,
    STATE(16971), 2,
      sym_block_comment,
      sym_line_comment,
  [367621] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23551), 1,
      sym__end_str,
    STATE(16984), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16972), 2,
      sym_block_comment,
      sym_line_comment,
  [367642] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23551), 1,
      sym__end_str,
    STATE(16985), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16973), 2,
      sym_block_comment,
      sym_line_comment,
  [367663] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23553), 1,
      sym__end_cmd,
    STATE(16987), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16974), 2,
      sym_block_comment,
      sym_line_comment,
  [367684] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16975), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21326), 4,
      sym__content_str_3,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [367701] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23553), 1,
      sym__end_cmd,
    STATE(16989), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16976), 2,
      sym_block_comment,
      sym_line_comment,
  [367722] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7684), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23549), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16977), 2,
      sym_block_comment,
      sym_line_comment,
  [367745] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16978), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21340), 4,
      sym__content_str_3,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [367762] = 6,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23555), 1,
      anon_sym_RBRACK,
    ACTIONS(23557), 1,
      aux_sym__terminator_token1,
    ACTIONS(23560), 1,
      aux_sym__terminator_token2,
    STATE(16979), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_matrix_expression_repeat1,
  [367783] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23563), 1,
      sym__end_str,
    STATE(17008), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16980), 2,
      sym_block_comment,
      sym_line_comment,
  [367804] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23563), 1,
      sym__end_str,
    STATE(17010), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16981), 2,
      sym_block_comment,
      sym_line_comment,
  [367825] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23565), 1,
      sym__end_cmd,
    STATE(17011), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16982), 2,
      sym_block_comment,
      sym_line_comment,
  [367846] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23565), 1,
      sym__end_cmd,
    STATE(17013), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16983), 2,
      sym_block_comment,
      sym_line_comment,
  [367867] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23567), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16984), 2,
      sym_block_comment,
      sym_line_comment,
  [367888] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23567), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16985), 2,
      sym_block_comment,
      sym_line_comment,
  [367909] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7302), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23569), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16986), 2,
      sym_block_comment,
      sym_line_comment,
  [367932] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23571), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16987), 2,
      sym_block_comment,
      sym_line_comment,
  [367953] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7310), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23573), 1,
      anon_sym_COMMA,
    STATE(17016), 1,
      aux_sym_argument_list_repeat1,
    STATE(16988), 2,
      sym_block_comment,
      sym_line_comment,
  [367976] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23571), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16989), 2,
      sym_block_comment,
      sym_line_comment,
  [367997] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7310), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23573), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(16990), 2,
      sym_block_comment,
      sym_line_comment,
  [368020] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16991), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23575), 4,
      sym__content_str_3,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [368037] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23577), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(16992), 2,
      sym_block_comment,
      sym_line_comment,
  [368058] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23577), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(16993), 2,
      sym_block_comment,
      sym_line_comment,
  [368079] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(15456), 1,
      anon_sym_COMMA,
    ACTIONS(23579), 1,
      aux_sym__terminator_token1,
    ACTIONS(23581), 1,
      aux_sym__terminator_token2,
    STATE(15530), 1,
      aux_sym__do_parameter_list_repeat1,
    STATE(16994), 2,
      sym_block_comment,
      sym_line_comment,
  [368102] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23583), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(16995), 2,
      sym_block_comment,
      sym_line_comment,
  [368123] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(16996), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23585), 4,
      sym__content_str_1,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [368140] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23587), 1,
      anon_sym_RBRACK,
    ACTIONS(23589), 1,
      aux_sym__terminator_token1,
    ACTIONS(23591), 1,
      aux_sym__terminator_token2,
    STATE(16264), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16997), 2,
      sym_block_comment,
      sym_line_comment,
  [368163] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23593), 1,
      anon_sym_RBRACK,
    ACTIONS(23595), 1,
      aux_sym__terminator_token1,
    ACTIONS(23597), 1,
      aux_sym__terminator_token2,
    STATE(17004), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(16998), 2,
      sym_block_comment,
      sym_line_comment,
  [368186] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23583), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(16999), 2,
      sym_block_comment,
      sym_line_comment,
  [368207] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23599), 1,
      anon_sym_COMMA,
    ACTIONS(23601), 1,
      anon_sym_RPAREN,
    STATE(15463), 1,
      aux_sym_argument_list_repeat1,
    STATE(17000), 2,
      sym_block_comment,
      sym_line_comment,
  [368230] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8624), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23603), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17001), 2,
      sym_block_comment,
      sym_line_comment,
  [368253] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17002), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23605), 4,
      sym__content_str_3,
      sym__end_str,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [368270] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17003), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23607), 4,
      sym__content_cmd_1,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [368287] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23609), 1,
      anon_sym_RBRACK,
    ACTIONS(23611), 1,
      aux_sym__terminator_token1,
    ACTIONS(23613), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17004), 2,
      sym_block_comment,
      sym_line_comment,
  [368310] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23615), 1,
      anon_sym_COMMA,
    ACTIONS(23617), 1,
      anon_sym_RPAREN,
    STATE(16231), 1,
      aux_sym_argument_list_repeat1,
    STATE(17005), 2,
      sym_block_comment,
      sym_line_comment,
  [368333] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23619), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17006), 2,
      sym_block_comment,
      sym_line_comment,
  [368354] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23619), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17007), 2,
      sym_block_comment,
      sym_line_comment,
  [368375] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23621), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17008), 2,
      sym_block_comment,
      sym_line_comment,
  [368396] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23623), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17009), 2,
      sym_block_comment,
      sym_line_comment,
  [368417] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23621), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17010), 2,
      sym_block_comment,
      sym_line_comment,
  [368438] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23625), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17011), 2,
      sym_block_comment,
      sym_line_comment,
  [368459] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23627), 1,
      sym__end_str,
    STATE(17023), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17012), 2,
      sym_block_comment,
      sym_line_comment,
  [368480] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23625), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(17013), 2,
      sym_block_comment,
      sym_line_comment,
  [368501] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17014), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23629), 4,
      sym__content_cmd_1,
      sym__end_cmd,
      anon_sym_DOLLAR,
      sym_escape_sequence,
  [368518] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23627), 1,
      sym__end_str,
    STATE(17024), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17015), 2,
      sym_block_comment,
      sym_line_comment,
  [368539] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7318), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23631), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17016), 2,
      sym_block_comment,
      sym_line_comment,
  [368562] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23633), 1,
      sym__end_str,
    STATE(17052), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17017), 2,
      sym_block_comment,
      sym_line_comment,
  [368583] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23635), 1,
      sym__end_cmd,
    STATE(17025), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17018), 2,
      sym_block_comment,
      sym_line_comment,
  [368604] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23635), 1,
      sym__end_cmd,
    STATE(17026), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(17019), 2,
      sym_block_comment,
      sym_line_comment,
  [368625] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23637), 1,
      anon_sym_RBRACK,
    ACTIONS(23639), 1,
      aux_sym__terminator_token1,
    ACTIONS(23641), 1,
      aux_sym__terminator_token2,
    STATE(16873), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17020), 2,
      sym_block_comment,
      sym_line_comment,
  [368648] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7322), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17352), 1,
      anon_sym_COMMA,
    STATE(16887), 1,
      aux_sym_argument_list_repeat1,
    STATE(17021), 2,
      sym_block_comment,
      sym_line_comment,
  [368671] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23623), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(17022), 2,
      sym_block_comment,
      sym_line_comment,
  [368692] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23643), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17023), 2,
      sym_block_comment,
      sym_line_comment,
  [368713] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23643), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17024), 2,
      sym_block_comment,
      sym_line_comment,
  [368734] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23645), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17025), 2,
      sym_block_comment,
      sym_line_comment,
  [368755] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23645), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(17026), 2,
      sym_block_comment,
      sym_line_comment,
  [368776] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7692), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23647), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17027), 2,
      sym_block_comment,
      sym_line_comment,
  [368799] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21234), 1,
      anon_sym_COMMA,
    ACTIONS(23649), 1,
      anon_sym_RPAREN,
    ACTIONS(23651), 1,
      anon_sym_SEMI,
    STATE(16424), 1,
      aux_sym_argument_list_repeat1,
    STATE(17028), 2,
      sym_block_comment,
      sym_line_comment,
  [368822] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7696), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17623), 1,
      anon_sym_COMMA,
    STATE(15493), 1,
      aux_sym_argument_list_repeat1,
    STATE(17029), 2,
      sym_block_comment,
      sym_line_comment,
  [368845] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(6552), 1,
      ts_builtin_sym_end,
    ACTIONS(23653), 1,
      aux_sym__terminator_token1,
    ACTIONS(23655), 1,
      aux_sym__terminator_token2,
    STATE(16781), 1,
      aux_sym__block_repeat1,
    STATE(17030), 2,
      sym_block_comment,
      sym_line_comment,
  [368868] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23657), 1,
      anon_sym_RBRACK,
    ACTIONS(23659), 1,
      aux_sym__terminator_token1,
    ACTIONS(23661), 1,
      aux_sym__terminator_token2,
    STATE(17036), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17031), 2,
      sym_block_comment,
      sym_line_comment,
  [368891] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8840), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23663), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17032), 2,
      sym_block_comment,
      sym_line_comment,
  [368914] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23665), 1,
      anon_sym_COMMA,
    ACTIONS(23667), 1,
      anon_sym_RPAREN,
    STATE(16067), 1,
      aux_sym_argument_list_repeat1,
    STATE(17033), 2,
      sym_block_comment,
      sym_line_comment,
  [368937] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8452), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23382), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17034), 2,
      sym_block_comment,
      sym_line_comment,
  [368960] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7880), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17617), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17035), 2,
      sym_block_comment,
      sym_line_comment,
  [368983] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23669), 1,
      anon_sym_RBRACK,
    ACTIONS(23671), 1,
      aux_sym__terminator_token1,
    ACTIONS(23673), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17036), 2,
      sym_block_comment,
      sym_line_comment,
  [369006] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8844), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17605), 1,
      anon_sym_COMMA,
    STATE(15715), 1,
      aux_sym_argument_list_repeat1,
    STATE(17037), 2,
      sym_block_comment,
      sym_line_comment,
  [369029] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23675), 1,
      sym__end_str,
    STATE(17047), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17038), 2,
      sym_block_comment,
      sym_line_comment,
  [369050] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23675), 1,
      sym__end_str,
    STATE(17048), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17039), 2,
      sym_block_comment,
      sym_line_comment,
  [369071] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23677), 1,
      sym__end_cmd,
    STATE(17049), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17040), 2,
      sym_block_comment,
      sym_line_comment,
  [369092] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23677), 1,
      sym__end_cmd,
    STATE(17050), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(17041), 2,
      sym_block_comment,
      sym_line_comment,
  [369113] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23633), 1,
      sym__end_str,
    STATE(15384), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17042), 2,
      sym_block_comment,
      sym_line_comment,
  [369134] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8226), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17698), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17043), 2,
      sym_block_comment,
      sym_line_comment,
  [369157] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5134), 1,
      anon_sym_end,
    ACTIONS(23679), 1,
      aux_sym__terminator_token1,
    ACTIONS(23681), 1,
      aux_sym__terminator_token2,
    STATE(16550), 1,
      aux_sym__block_repeat1,
    STATE(17044), 2,
      sym_block_comment,
      sym_line_comment,
  [369180] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23683), 1,
      anon_sym_RBRACK,
    ACTIONS(23685), 1,
      aux_sym__terminator_token1,
    ACTIONS(23687), 1,
      aux_sym__terminator_token2,
    STATE(17061), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17045), 2,
      sym_block_comment,
      sym_line_comment,
  [369203] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23689), 1,
      anon_sym_RBRACK,
    ACTIONS(23691), 1,
      aux_sym__terminator_token1,
    ACTIONS(23693), 1,
      aux_sym__terminator_token2,
    STATE(15533), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17046), 2,
      sym_block_comment,
      sym_line_comment,
  [369226] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23695), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17047), 2,
      sym_block_comment,
      sym_line_comment,
  [369247] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23695), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17048), 2,
      sym_block_comment,
      sym_line_comment,
  [369268] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23697), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17049), 2,
      sym_block_comment,
      sym_line_comment,
  [369289] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23697), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(17050), 2,
      sym_block_comment,
      sym_line_comment,
  [369310] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23699), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17051), 2,
      sym_block_comment,
      sym_line_comment,
  [369331] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21268), 1,
      sym__end_str,
    STATE(16217), 1,
      aux_sym_prefixed_string_literal_repeat1,
    ACTIONS(21196), 2,
      sym__content_str_1_raw,
      sym_escape_sequence,
    STATE(17052), 2,
      sym_block_comment,
      sym_line_comment,
  [369352] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23701), 1,
      anon_sym_COMMA,
    ACTIONS(23703), 1,
      anon_sym_RPAREN,
    STATE(16059), 1,
      aux_sym_argument_list_repeat1,
    STATE(17053), 2,
      sym_block_comment,
      sym_line_comment,
  [369375] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23705), 1,
      anon_sym_RBRACK,
    ACTIONS(23707), 1,
      aux_sym__terminator_token1,
    ACTIONS(23709), 1,
      aux_sym__terminator_token2,
    STATE(15368), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17054), 2,
      sym_block_comment,
      sym_line_comment,
  [369398] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23711), 1,
      anon_sym_RBRACK,
    ACTIONS(23713), 1,
      aux_sym__terminator_token1,
    ACTIONS(23715), 1,
      aux_sym__terminator_token2,
    STATE(16320), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17055), 2,
      sym_block_comment,
      sym_line_comment,
  [369421] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7330), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23717), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17056), 2,
      sym_block_comment,
      sym_line_comment,
  [369444] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22237), 1,
      sym__immediate_string_start,
    ACTIONS(22239), 1,
      sym__immediate_command_start,
    ACTIONS(9716), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17057), 2,
      sym_block_comment,
      sym_line_comment,
  [369465] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7286), 1,
      anon_sym_RPAREN,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(17310), 1,
      anon_sym_COMMA,
    STATE(16786), 1,
      aux_sym_argument_list_repeat1,
    STATE(17058), 2,
      sym_block_comment,
      sym_line_comment,
  [369488] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22526), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17059), 2,
      sym_block_comment,
      sym_line_comment,
  [369509] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23699), 1,
      sym__end_str,
    STATE(16244), 1,
      aux_sym_prefixed_string_literal_repeat2,
    ACTIONS(21200), 2,
      sym__content_str_3_raw,
      sym_escape_sequence,
    STATE(17060), 2,
      sym_block_comment,
      sym_line_comment,
  [369530] = 7,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(23719), 1,
      anon_sym_RBRACK,
    ACTIONS(23721), 1,
      aux_sym__terminator_token1,
    ACTIONS(23723), 1,
      aux_sym__terminator_token2,
    STATE(16979), 1,
      aux_sym_matrix_expression_repeat1,
    STATE(17061), 2,
      sym_block_comment,
      sym_line_comment,
  [369553] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23725), 1,
      sym__end_cmd,
    STATE(16407), 1,
      aux_sym_prefixed_command_literal_repeat1,
    ACTIONS(21202), 2,
      sym__content_cmd_1_raw,
      sym_escape_sequence,
    STATE(17062), 2,
      sym_block_comment,
      sym_line_comment,
  [369574] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23725), 1,
      sym__end_cmd,
    STATE(16436), 1,
      aux_sym_prefixed_command_literal_repeat2,
    ACTIONS(21206), 2,
      sym__content_cmd_3_raw,
      sym_escape_sequence,
    STATE(17063), 2,
      sym_block_comment,
      sym_line_comment,
  [369595] = 7,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16684), 1,
      anon_sym_SEMI,
    ACTIONS(23727), 1,
      anon_sym_COMMA,
    ACTIONS(23729), 1,
      anon_sym_RPAREN,
    STATE(16593), 1,
      aux_sym_argument_list_repeat1,
    STATE(17064), 2,
      sym_block_comment,
      sym_line_comment,
  [369618] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7334), 1,
      anon_sym_RBRACK,
    ACTIONS(23731), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17065), 2,
      sym_block_comment,
      sym_line_comment,
  [369638] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8170), 1,
      anon_sym_RPAREN,
    ACTIONS(23733), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17066), 2,
      sym_block_comment,
      sym_line_comment,
  [369658] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8436), 1,
      anon_sym_RBRACE,
    ACTIONS(23735), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17067), 2,
      sym_block_comment,
      sym_line_comment,
  [369678] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18802), 1,
      sym__comprehension_clause,
    STATE(17068), 2,
      sym_block_comment,
      sym_line_comment,
  [369698] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23737), 1,
      sym__immediate_paren,
    ACTIONS(23739), 1,
      sym__immediate_bracket,
    ACTIONS(23741), 1,
      sym__immediate_brace,
    STATE(17069), 2,
      sym_block_comment,
      sym_line_comment,
  [369718] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8744), 1,
      anon_sym_RPAREN,
    ACTIONS(23743), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17070), 2,
      sym_block_comment,
      sym_line_comment,
  [369738] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8026), 1,
      anon_sym_RPAREN,
    ACTIONS(19340), 1,
      anon_sym_COMMA,
    STATE(17464), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17071), 2,
      sym_block_comment,
      sym_line_comment,
  [369758] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23745), 1,
      sym__immediate_paren,
    ACTIONS(23747), 1,
      sym__immediate_bracket,
    ACTIONS(23749), 1,
      sym__immediate_brace,
    STATE(17072), 2,
      sym_block_comment,
      sym_line_comment,
  [369778] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23751), 1,
      anon_sym_LPAREN,
    STATE(10285), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17073), 2,
      sym_block_comment,
      sym_line_comment,
  [369796] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19400), 1,
      anon_sym_COMMA,
    ACTIONS(19402), 1,
      anon_sym_RBRACE,
    STATE(17152), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17074), 2,
      sym_block_comment,
      sym_line_comment,
  [369816] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23753), 1,
      anon_sym_LPAREN,
    STATE(4734), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17075), 2,
      sym_block_comment,
      sym_line_comment,
  [369834] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19081), 1,
      sym__comprehension_clause,
    STATE(17076), 2,
      sym_block_comment,
      sym_line_comment,
  [369854] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23755), 1,
      sym__immediate_paren,
    ACTIONS(23757), 1,
      sym__immediate_bracket,
    ACTIONS(23759), 1,
      sym__immediate_brace,
    STATE(17077), 2,
      sym_block_comment,
      sym_line_comment,
  [369874] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6972), 1,
      anon_sym_RBRACE,
    ACTIONS(23761), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17078), 2,
      sym_block_comment,
      sym_line_comment,
  [369894] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23763), 1,
      anon_sym_LPAREN,
    STATE(7444), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17079), 2,
      sym_block_comment,
      sym_line_comment,
  [369912] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23765), 1,
      sym__immediate_paren,
    ACTIONS(23767), 1,
      sym__immediate_bracket,
    ACTIONS(23769), 1,
      sym__immediate_brace,
    STATE(17080), 2,
      sym_block_comment,
      sym_line_comment,
  [369932] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7470), 1,
      anon_sym_RPAREN,
    ACTIONS(23771), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17081), 2,
      sym_block_comment,
      sym_line_comment,
  [369952] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8548), 1,
      anon_sym_RBRACK,
    ACTIONS(23773), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17082), 2,
      sym_block_comment,
      sym_line_comment,
  [369972] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19377), 1,
      sym__comprehension_clause,
    STATE(17083), 2,
      sym_block_comment,
      sym_line_comment,
  [369992] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23775), 1,
      sym__immediate_paren,
    ACTIONS(23777), 1,
      sym__immediate_bracket,
    ACTIONS(23779), 1,
      sym__immediate_brace,
    STATE(17084), 2,
      sym_block_comment,
      sym_line_comment,
  [370012] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23781), 1,
      sym__immediate_paren,
    ACTIONS(23783), 1,
      sym__immediate_bracket,
    ACTIONS(23785), 1,
      sym__immediate_brace,
    STATE(17085), 2,
      sym_block_comment,
      sym_line_comment,
  [370032] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7772), 1,
      anon_sym_RBRACE,
    ACTIONS(23787), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17086), 2,
      sym_block_comment,
      sym_line_comment,
  [370052] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8488), 1,
      anon_sym_RBRACE,
    ACTIONS(23789), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17087), 2,
      sym_block_comment,
      sym_line_comment,
  [370072] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18679), 1,
      sym__comprehension_clause,
    STATE(17088), 2,
      sym_block_comment,
      sym_line_comment,
  [370092] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7044), 1,
      anon_sym_RPAREN,
    ACTIONS(23791), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17089), 2,
      sym_block_comment,
      sym_line_comment,
  [370112] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18746), 1,
      anon_sym_COMMA,
    ACTIONS(18748), 1,
      anon_sym_RBRACE,
    STATE(17110), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17090), 2,
      sym_block_comment,
      sym_line_comment,
  [370132] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23793), 1,
      sym__immediate_paren,
    ACTIONS(23795), 1,
      sym__immediate_bracket,
    ACTIONS(23797), 1,
      sym__immediate_brace,
    STATE(17091), 2,
      sym_block_comment,
      sym_line_comment,
  [370152] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21166), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19603), 1,
      sym_catch_clause,
    STATE(17092), 2,
      sym_block_comment,
      sym_line_comment,
  [370172] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23801), 1,
      anon_sym_LPAREN,
    STATE(7167), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17093), 2,
      sym_block_comment,
      sym_line_comment,
  [370190] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8386), 1,
      anon_sym_RPAREN,
    ACTIONS(18884), 1,
      anon_sym_COMMA,
    STATE(17344), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17094), 2,
      sym_block_comment,
      sym_line_comment,
  [370210] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23803), 1,
      sym__immediate_paren,
    ACTIONS(23805), 1,
      sym__immediate_bracket,
    ACTIONS(23807), 1,
      sym__immediate_brace,
    STATE(17095), 2,
      sym_block_comment,
      sym_line_comment,
  [370230] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8550), 1,
      anon_sym_RBRACE,
    ACTIONS(23809), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17096), 2,
      sym_block_comment,
      sym_line_comment,
  [370250] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23811), 1,
      anon_sym_LPAREN,
    STATE(6088), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17097), 2,
      sym_block_comment,
      sym_line_comment,
  [370268] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8104), 1,
      anon_sym_RPAREN,
    ACTIONS(19416), 1,
      anon_sym_COMMA,
    STATE(17119), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17098), 2,
      sym_block_comment,
      sym_line_comment,
  [370288] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21105), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19474), 1,
      sym_catch_clause,
    STATE(17099), 2,
      sym_block_comment,
      sym_line_comment,
  [370308] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19492), 1,
      sym__comprehension_clause,
    STATE(17100), 2,
      sym_block_comment,
      sym_line_comment,
  [370328] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7392), 1,
      anon_sym_RBRACE,
    ACTIONS(23813), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17101), 2,
      sym_block_comment,
      sym_line_comment,
  [370348] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23815), 1,
      sym__immediate_paren,
    ACTIONS(23817), 1,
      sym__immediate_bracket,
    ACTIONS(23819), 1,
      sym__immediate_brace,
    STATE(17102), 2,
      sym_block_comment,
      sym_line_comment,
  [370368] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18930), 1,
      anon_sym_COMMA,
    ACTIONS(18932), 1,
      anon_sym_RBRACE,
    STATE(17249), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17103), 2,
      sym_block_comment,
      sym_line_comment,
  [370388] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23821), 1,
      sym__immediate_paren,
    ACTIONS(23823), 1,
      sym__immediate_bracket,
    ACTIONS(23825), 1,
      sym__immediate_brace,
    STATE(17104), 2,
      sym_block_comment,
      sym_line_comment,
  [370408] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19266), 1,
      anon_sym_COMMA,
    ACTIONS(19268), 1,
      anon_sym_RBRACE,
    STATE(17135), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17105), 2,
      sym_block_comment,
      sym_line_comment,
  [370428] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8106), 1,
      anon_sym_RBRACK,
    ACTIONS(23827), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17106), 2,
      sym_block_comment,
      sym_line_comment,
  [370448] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23829), 1,
      anon_sym_LPAREN,
    STATE(5970), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17107), 2,
      sym_block_comment,
      sym_line_comment,
  [370466] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8384), 1,
      anon_sym_RPAREN,
    ACTIONS(19412), 1,
      anon_sym_COMMA,
    STATE(17610), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17108), 2,
      sym_block_comment,
      sym_line_comment,
  [370486] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7522), 1,
      anon_sym_RPAREN,
    ACTIONS(19042), 1,
      anon_sym_COMMA,
    STATE(17250), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17109), 2,
      sym_block_comment,
      sym_line_comment,
  [370506] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8110), 1,
      anon_sym_RBRACE,
    ACTIONS(23831), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17110), 2,
      sym_block_comment,
      sym_line_comment,
  [370526] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21105), 1,
      anon_sym_end,
    STATE(19474), 1,
      sym_finally_clause,
    STATE(17111), 2,
      sym_block_comment,
      sym_line_comment,
  [370546] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19034), 1,
      anon_sym_COMMA,
    ACTIONS(19036), 1,
      anon_sym_RBRACE,
    STATE(17157), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17112), 2,
      sym_block_comment,
      sym_line_comment,
  [370566] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18779), 1,
      sym__comprehension_clause,
    STATE(17113), 2,
      sym_block_comment,
      sym_line_comment,
  [370586] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23833), 1,
      sym__immediate_paren,
    ACTIONS(23835), 1,
      sym__immediate_bracket,
    ACTIONS(23837), 1,
      sym__immediate_brace,
    STATE(17114), 2,
      sym_block_comment,
      sym_line_comment,
  [370606] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23839), 1,
      sym__immediate_paren,
    ACTIONS(23841), 1,
      sym__immediate_bracket,
    ACTIONS(23843), 1,
      sym__immediate_brace,
    STATE(17115), 2,
      sym_block_comment,
      sym_line_comment,
  [370626] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7936), 1,
      anon_sym_RPAREN,
    ACTIONS(19284), 1,
      anon_sym_COMMA,
    STATE(17180), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17116), 2,
      sym_block_comment,
      sym_line_comment,
  [370646] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8816), 1,
      anon_sym_RBRACE,
    ACTIONS(23845), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17117), 2,
      sym_block_comment,
      sym_line_comment,
  [370666] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19326), 1,
      sym__comprehension_clause,
    STATE(17118), 2,
      sym_block_comment,
      sym_line_comment,
  [370686] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8700), 1,
      anon_sym_RPAREN,
    ACTIONS(23847), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17119), 2,
      sym_block_comment,
      sym_line_comment,
  [370706] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23849), 1,
      sym__immediate_paren,
    ACTIONS(23851), 1,
      sym__immediate_bracket,
    ACTIONS(23853), 1,
      sym__immediate_brace,
    STATE(17120), 2,
      sym_block_comment,
      sym_line_comment,
  [370726] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23855), 1,
      sym__immediate_paren,
    ACTIONS(23857), 1,
      sym__immediate_bracket,
    ACTIONS(23859), 1,
      sym__immediate_brace,
    STATE(17121), 2,
      sym_block_comment,
      sym_line_comment,
  [370746] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7186), 1,
      anon_sym_RPAREN,
    ACTIONS(18798), 1,
      anon_sym_COMMA,
    STATE(17161), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17122), 2,
      sym_block_comment,
      sym_line_comment,
  [370766] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23863), 1,
      anon_sym_else,
    ACTIONS(23861), 2,
      anon_sym_end,
      anon_sym_elseif,
    STATE(17123), 2,
      sym_block_comment,
      sym_line_comment,
  [370784] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21139), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18602), 1,
      sym_catch_clause,
    STATE(17124), 2,
      sym_block_comment,
      sym_line_comment,
  [370804] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7054), 1,
      anon_sym_RPAREN,
    ACTIONS(18766), 1,
      anon_sym_COMMA,
    STATE(17212), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17125), 2,
      sym_block_comment,
      sym_line_comment,
  [370824] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19423), 1,
      sym__comprehension_clause,
    STATE(17126), 2,
      sym_block_comment,
      sym_line_comment,
  [370844] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23865), 1,
      sym__immediate_paren,
    ACTIONS(23867), 1,
      sym__immediate_bracket,
    ACTIONS(23869), 1,
      sym__immediate_brace,
    STATE(17127), 2,
      sym_block_comment,
      sym_line_comment,
  [370864] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23871), 1,
      sym__immediate_paren,
    ACTIONS(23873), 1,
      sym__immediate_bracket,
    ACTIONS(23875), 1,
      sym__immediate_brace,
    STATE(17128), 2,
      sym_block_comment,
      sym_line_comment,
  [370884] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19328), 1,
      anon_sym_COMMA,
    ACTIONS(19330), 1,
      anon_sym_RBRACE,
    STATE(17235), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17129), 2,
      sym_block_comment,
      sym_line_comment,
  [370904] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7188), 1,
      anon_sym_RBRACK,
    ACTIONS(23877), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17130), 2,
      sym_block_comment,
      sym_line_comment,
  [370924] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16378), 1,
      sym__word_identifier,
    STATE(6721), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17131), 2,
      sym_block_comment,
      sym_line_comment,
  [370942] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8648), 1,
      anon_sym_RPAREN,
    ACTIONS(19024), 1,
      anon_sym_COMMA,
    STATE(17170), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17132), 2,
      sym_block_comment,
      sym_line_comment,
  [370962] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18373), 1,
      sym__comprehension_clause,
    STATE(17133), 2,
      sym_block_comment,
      sym_line_comment,
  [370982] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23879), 1,
      sym__immediate_paren,
    ACTIONS(23881), 1,
      sym__immediate_bracket,
    ACTIONS(23883), 1,
      sym__immediate_brace,
    STATE(17134), 2,
      sym_block_comment,
      sym_line_comment,
  [371002] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7190), 1,
      anon_sym_RBRACE,
    ACTIONS(23885), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17135), 2,
      sym_block_comment,
      sym_line_comment,
  [371022] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8388), 1,
      anon_sym_RBRACK,
    ACTIONS(23887), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17136), 2,
      sym_block_comment,
      sym_line_comment,
  [371042] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(23889), 1,
      anon_sym_end,
    STATE(18522), 1,
      sym_finally_clause,
    STATE(17137), 2,
      sym_block_comment,
      sym_line_comment,
  [371062] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(23891), 1,
      anon_sym_end,
    STATE(18759), 1,
      sym_finally_clause,
    STATE(17138), 2,
      sym_block_comment,
      sym_line_comment,
  [371082] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23893), 1,
      anon_sym_LPAREN,
    STATE(4675), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17139), 2,
      sym_block_comment,
      sym_line_comment,
  [371100] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19457), 1,
      sym__comprehension_clause,
    STATE(17140), 2,
      sym_block_comment,
      sym_line_comment,
  [371120] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8258), 1,
      anon_sym_RPAREN,
    ACTIONS(23895), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17141), 2,
      sym_block_comment,
      sym_line_comment,
  [371140] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21137), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18369), 1,
      sym_catch_clause,
    STATE(17142), 2,
      sym_block_comment,
      sym_line_comment,
  [371160] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18914), 1,
      sym__comprehension_clause,
    STATE(17143), 2,
      sym_block_comment,
      sym_line_comment,
  [371180] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21150), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18981), 1,
      sym_catch_clause,
    STATE(17144), 2,
      sym_block_comment,
      sym_line_comment,
  [371200] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7056), 1,
      anon_sym_RBRACK,
    ACTIONS(23897), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17145), 2,
      sym_block_comment,
      sym_line_comment,
  [371220] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19280), 1,
      anon_sym_COMMA,
    ACTIONS(19282), 1,
      anon_sym_RBRACE,
    STATE(17221), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17146), 2,
      sym_block_comment,
      sym_line_comment,
  [371240] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7938), 1,
      anon_sym_RBRACK,
    ACTIONS(23899), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17147), 2,
      sym_block_comment,
      sym_line_comment,
  [371260] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23901), 1,
      anon_sym_LPAREN,
    STATE(10660), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17148), 2,
      sym_block_comment,
      sym_line_comment,
  [371278] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19354), 1,
      sym__comprehension_clause,
    STATE(17149), 2,
      sym_block_comment,
      sym_line_comment,
  [371298] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21150), 1,
      anon_sym_end,
    STATE(18981), 1,
      sym_finally_clause,
    STATE(17150), 2,
      sym_block_comment,
      sym_line_comment,
  [371318] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8650), 1,
      anon_sym_RBRACK,
    ACTIONS(23903), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17151), 2,
      sym_block_comment,
      sym_line_comment,
  [371338] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7940), 1,
      anon_sym_RBRACE,
    ACTIONS(23905), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17152), 2,
      sym_block_comment,
      sym_line_comment,
  [371358] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18687), 1,
      sym__comprehension_clause,
    STATE(17153), 2,
      sym_block_comment,
      sym_line_comment,
  [371378] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8736), 1,
      anon_sym_RPAREN,
    ACTIONS(23907), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17154), 2,
      sym_block_comment,
      sym_line_comment,
  [371398] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8390), 1,
      anon_sym_RBRACK,
    ACTIONS(23909), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17155), 2,
      sym_block_comment,
      sym_line_comment,
  [371418] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9716), 1,
      anon_sym_RPAREN,
    ACTIONS(23911), 1,
      sym__immediate_string_start,
    ACTIONS(23913), 1,
      sym__immediate_command_start,
    STATE(17156), 2,
      sym_block_comment,
      sym_line_comment,
  [371438] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8654), 1,
      anon_sym_RBRACE,
    ACTIONS(23915), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17157), 2,
      sym_block_comment,
      sym_line_comment,
  [371458] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18951), 1,
      sym__comprehension_clause,
    STATE(17158), 2,
      sym_block_comment,
      sym_line_comment,
  [371478] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8028), 1,
      anon_sym_RBRACK,
    ACTIONS(23917), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17159), 2,
      sym_block_comment,
      sym_line_comment,
  [371498] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21137), 1,
      anon_sym_end,
    STATE(18369), 1,
      sym_finally_clause,
    STATE(17160), 2,
      sym_block_comment,
      sym_line_comment,
  [371518] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7818), 1,
      anon_sym_RPAREN,
    ACTIONS(23919), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17161), 2,
      sym_block_comment,
      sym_line_comment,
  [371538] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17162), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23921), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [371554] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18419), 1,
      sym__comprehension_clause,
    STATE(17163), 2,
      sym_block_comment,
      sym_line_comment,
  [371574] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6994), 1,
      anon_sym_RBRACE,
    ACTIONS(23923), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17164), 2,
      sym_block_comment,
      sym_line_comment,
  [371594] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17165), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23925), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [371610] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19136), 1,
      sym__comprehension_clause,
    STATE(17166), 2,
      sym_block_comment,
      sym_line_comment,
  [371630] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23927), 1,
      anon_sym_LPAREN,
    STATE(6617), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17167), 2,
      sym_block_comment,
      sym_line_comment,
  [371648] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7060), 1,
      anon_sym_RBRACE,
    ACTIONS(23929), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17168), 2,
      sym_block_comment,
      sym_line_comment,
  [371668] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23931), 1,
      anon_sym_LPAREN,
    STATE(7063), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17169), 2,
      sym_block_comment,
      sym_line_comment,
  [371686] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8746), 1,
      anon_sym_RPAREN,
    ACTIONS(23933), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17170), 2,
      sym_block_comment,
      sym_line_comment,
  [371706] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19262), 1,
      sym__comprehension_clause,
    STATE(17171), 2,
      sym_block_comment,
      sym_line_comment,
  [371726] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7422), 1,
      anon_sym_RPAREN,
    ACTIONS(19406), 1,
      anon_sym_COMMA,
    STATE(17480), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17172), 2,
      sym_block_comment,
      sym_line_comment,
  [371746] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8730), 1,
      anon_sym_RPAREN,
    ACTIONS(23935), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17173), 2,
      sym_block_comment,
      sym_line_comment,
  [371766] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8726), 1,
      anon_sym_RPAREN,
    ACTIONS(23937), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17174), 2,
      sym_block_comment,
      sym_line_comment,
  [371786] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23939), 1,
      anon_sym_LPAREN,
    STATE(5562), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17175), 2,
      sym_block_comment,
      sym_line_comment,
  [371804] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18600), 1,
      sym__comprehension_clause,
    STATE(17176), 2,
      sym_block_comment,
      sym_line_comment,
  [371824] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8392), 1,
      anon_sym_RBRACE,
    ACTIONS(23941), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17177), 2,
      sym_block_comment,
      sym_line_comment,
  [371844] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19296), 1,
      anon_sym_COMMA,
    ACTIONS(19298), 1,
      anon_sym_RBRACE,
    STATE(17329), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17178), 2,
      sym_block_comment,
      sym_line_comment,
  [371864] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19108), 1,
      sym__comprehension_clause,
    STATE(17179), 2,
      sym_block_comment,
      sym_line_comment,
  [371884] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8692), 1,
      anon_sym_RPAREN,
    ACTIONS(23943), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17180), 2,
      sym_block_comment,
      sym_line_comment,
  [371904] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7854), 1,
      anon_sym_RPAREN,
    ACTIONS(19186), 1,
      anon_sym_COMMA,
    STATE(17383), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17181), 2,
      sym_block_comment,
      sym_line_comment,
  [371924] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18762), 1,
      anon_sym_COMMA,
    ACTIONS(18764), 1,
      anon_sym_RBRACE,
    STATE(17203), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17182), 2,
      sym_block_comment,
      sym_line_comment,
  [371944] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23945), 1,
      anon_sym_LPAREN,
    STATE(7182), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17183), 2,
      sym_block_comment,
      sym_line_comment,
  [371962] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21115), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18399), 1,
      sym_catch_clause,
    STATE(17184), 2,
      sym_block_comment,
      sym_line_comment,
  [371982] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(23947), 1,
      anon_sym_end,
    STATE(18809), 1,
      sym_finally_clause,
    STATE(17185), 2,
      sym_block_comment,
      sym_line_comment,
  [372002] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21115), 1,
      anon_sym_end,
    STATE(18399), 1,
      sym_finally_clause,
    STATE(17186), 2,
      sym_block_comment,
      sym_line_comment,
  [372022] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21135), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18453), 1,
      sym_catch_clause,
    STATE(17187), 2,
      sym_block_comment,
      sym_line_comment,
  [372042] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8138), 1,
      anon_sym_RPAREN,
    ACTIONS(19434), 1,
      anon_sym_COMMA,
    STATE(17214), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17188), 2,
      sym_block_comment,
      sym_line_comment,
  [372062] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7706), 1,
      anon_sym_RBRACK,
    ACTIONS(23949), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17189), 2,
      sym_block_comment,
      sym_line_comment,
  [372082] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19001), 1,
      sym__comprehension_clause,
    STATE(17190), 2,
      sym_block_comment,
      sym_line_comment,
  [372102] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19046), 1,
      anon_sym_COMMA,
    ACTIONS(19048), 1,
      anon_sym_RBRACE,
    STATE(17228), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17191), 2,
      sym_block_comment,
      sym_line_comment,
  [372122] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8410), 1,
      anon_sym_RPAREN,
    ACTIONS(18894), 1,
      anon_sym_COMMA,
    STATE(17368), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17192), 2,
      sym_block_comment,
      sym_line_comment,
  [372142] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23951), 1,
      anon_sym_LPAREN,
    STATE(6197), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17193), 2,
      sym_block_comment,
      sym_line_comment,
  [372160] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19292), 1,
      anon_sym_COMMA,
    ACTIONS(19294), 1,
      anon_sym_RBRACE,
    STATE(17258), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17194), 2,
      sym_block_comment,
      sym_line_comment,
  [372180] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19138), 1,
      anon_sym_COMMA,
    ACTIONS(19140), 1,
      anon_sym_RBRACE,
    STATE(17315), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17195), 2,
      sym_block_comment,
      sym_line_comment,
  [372200] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23953), 1,
      anon_sym_LPAREN,
    STATE(6009), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17196), 2,
      sym_block_comment,
      sym_line_comment,
  [372218] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8140), 1,
      anon_sym_RBRACK,
    ACTIONS(23955), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17197), 2,
      sym_block_comment,
      sym_line_comment,
  [372238] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19342), 1,
      anon_sym_COMMA,
    ACTIONS(19344), 1,
      anon_sym_RBRACE,
    STATE(17406), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17198), 2,
      sym_block_comment,
      sym_line_comment,
  [372258] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18248), 1,
      sym__comprehension_clause,
    STATE(17199), 2,
      sym_block_comment,
      sym_line_comment,
  [372278] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21101), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18689), 1,
      sym_catch_clause,
    STATE(17200), 2,
      sym_block_comment,
      sym_line_comment,
  [372298] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23957), 1,
      anon_sym_LPAREN,
    STATE(5721), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17201), 2,
      sym_block_comment,
      sym_line_comment,
  [372316] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21101), 1,
      anon_sym_end,
    STATE(18689), 1,
      sym_finally_clause,
    STATE(17202), 2,
      sym_block_comment,
      sym_line_comment,
  [372336] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8144), 1,
      anon_sym_RBRACE,
    ACTIONS(23959), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17203), 2,
      sym_block_comment,
      sym_line_comment,
  [372356] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8030), 1,
      anon_sym_RBRACE,
    ACTIONS(23961), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17204), 2,
      sym_block_comment,
      sym_line_comment,
  [372376] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7740), 1,
      anon_sym_RPAREN,
    ACTIONS(19236), 1,
      anon_sym_COMMA,
    STATE(17254), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17205), 2,
      sym_block_comment,
      sym_line_comment,
  [372396] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    ACTIONS(19032), 1,
      anon_sym_COMMA,
    STATE(17242), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17206), 2,
      sym_block_comment,
      sym_line_comment,
  [372416] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17207), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23585), 3,
      sym__content_str_1_raw,
      sym__end_str,
      sym_escape_sequence,
  [372432] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23963), 1,
      anon_sym_LPAREN,
    STATE(9798), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17208), 2,
      sym_block_comment,
      sym_line_comment,
  [372450] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18433), 1,
      sym__comprehension_clause,
    STATE(17209), 2,
      sym_block_comment,
      sym_line_comment,
  [372470] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21135), 1,
      anon_sym_end,
    STATE(18453), 1,
      sym_finally_clause,
    STATE(17210), 2,
      sym_block_comment,
      sym_line_comment,
  [372490] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17211), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23605), 3,
      sym__content_str_3_raw,
      sym__end_str,
      sym_escape_sequence,
  [372506] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7574), 1,
      anon_sym_RPAREN,
    ACTIONS(23965), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17212), 2,
      sym_block_comment,
      sym_line_comment,
  [372526] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18640), 1,
      sym__comprehension_clause,
    STATE(17213), 2,
      sym_block_comment,
      sym_line_comment,
  [372546] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8702), 1,
      anon_sym_RPAREN,
    ACTIONS(23967), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17214), 2,
      sym_block_comment,
      sym_line_comment,
  [372566] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8674), 1,
      anon_sym_RBRACK,
    ACTIONS(23969), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17215), 2,
      sym_block_comment,
      sym_line_comment,
  [372586] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6968), 1,
      anon_sym_RPAREN,
    ACTIONS(19398), 1,
      anon_sym_COMMA,
    STATE(17089), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17216), 2,
      sym_block_comment,
      sym_line_comment,
  [372606] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18831), 1,
      sym__comprehension_clause,
    STATE(17217), 2,
      sym_block_comment,
      sym_line_comment,
  [372626] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7856), 1,
      anon_sym_RBRACK,
    ACTIONS(23971), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17218), 2,
      sym_block_comment,
      sym_line_comment,
  [372646] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7742), 1,
      anon_sym_RBRACK,
    ACTIONS(23973), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17219), 2,
      sym_block_comment,
      sym_line_comment,
  [372666] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8412), 1,
      anon_sym_RBRACK,
    ACTIONS(23975), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17220), 2,
      sym_block_comment,
      sym_line_comment,
  [372686] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7770), 1,
      anon_sym_RBRACE,
    ACTIONS(23977), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17221), 2,
      sym_block_comment,
      sym_line_comment,
  [372706] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18917), 1,
      sym__comprehension_clause,
    STATE(17222), 2,
      sym_block_comment,
      sym_line_comment,
  [372726] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17223), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(23607), 3,
      sym__content_cmd_1_raw,
      sym__end_cmd,
      sym_escape_sequence,
  [372742] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6912), 1,
      anon_sym_RPAREN,
    ACTIONS(19318), 1,
      anon_sym_COMMA,
    STATE(17603), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17224), 2,
      sym_block_comment,
      sym_line_comment,
  [372762] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19030), 1,
      sym__comprehension_clause,
    STATE(17225), 2,
      sym_block_comment,
      sym_line_comment,
  [372782] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7602), 1,
      anon_sym_RBRACK,
    ACTIONS(23979), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17226), 2,
      sym_block_comment,
      sym_line_comment,
  [372802] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7220), 1,
      anon_sym_RPAREN,
    ACTIONS(19092), 1,
      anon_sym_COMMA,
    STATE(17289), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17227), 2,
      sym_block_comment,
      sym_line_comment,
  [372822] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8676), 1,
      anon_sym_RBRACE,
    ACTIONS(23981), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17228), 2,
      sym_block_comment,
      sym_line_comment,
  [372842] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4632), 1,
      anon_sym_else,
    ACTIONS(23983), 2,
      anon_sym_end,
      anon_sym_elseif,
    STATE(17229), 2,
      sym_block_comment,
      sym_line_comment,
  [372860] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19158), 1,
      sym__comprehension_clause,
    STATE(17230), 2,
      sym_block_comment,
      sym_line_comment,
  [372880] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17231), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(21226), 3,
      sym__content_cmd_3_raw,
      sym__end_cmd,
      sym_escape_sequence,
  [372896] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9798), 1,
      anon_sym_RPAREN,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10478), 1,
      sym_identifier,
    STATE(17232), 2,
      sym_block_comment,
      sym_line_comment,
  [372916] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(23985), 1,
      anon_sym_end,
    STATE(18925), 1,
      sym_finally_clause,
    STATE(17233), 2,
      sym_block_comment,
      sym_line_comment,
  [372936] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19323), 1,
      sym__comprehension_clause,
    STATE(17234), 2,
      sym_block_comment,
      sym_line_comment,
  [372956] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7860), 1,
      anon_sym_RBRACE,
    ACTIONS(23987), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17235), 2,
      sym_block_comment,
      sym_line_comment,
  [372976] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18998), 1,
      anon_sym_COMMA,
    ACTIONS(19000), 1,
      anon_sym_RBRACE,
    STATE(17275), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17236), 2,
      sym_block_comment,
      sym_line_comment,
  [372996] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19443), 1,
      sym__comprehension_clause,
    STATE(17237), 2,
      sym_block_comment,
      sym_line_comment,
  [373016] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23989), 1,
      anon_sym_LPAREN,
    STATE(7108), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17238), 2,
      sym_block_comment,
      sym_line_comment,
  [373034] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8780), 1,
      anon_sym_RBRACK,
    ACTIONS(23991), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17239), 2,
      sym_block_comment,
      sym_line_comment,
  [373054] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7704), 1,
      anon_sym_RPAREN,
    ACTIONS(19052), 1,
      anon_sym_COMMA,
    STATE(17362), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17240), 2,
      sym_block_comment,
      sym_line_comment,
  [373074] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19528), 1,
      sym__comprehension_clause,
    STATE(17241), 2,
      sym_block_comment,
      sym_line_comment,
  [373094] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8748), 1,
      anon_sym_RPAREN,
    ACTIONS(23993), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17242), 2,
      sym_block_comment,
      sym_line_comment,
  [373114] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21127), 1,
      anon_sym_end,
    STATE(18972), 1,
      sym_finally_clause,
    STATE(17243), 2,
      sym_block_comment,
      sym_line_comment,
  [373134] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19311), 1,
      sym__comprehension_clause,
    STATE(17244), 2,
      sym_block_comment,
      sym_line_comment,
  [373154] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21123), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18771), 1,
      sym_catch_clause,
    STATE(17245), 2,
      sym_block_comment,
      sym_line_comment,
  [373174] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21123), 1,
      anon_sym_end,
    STATE(18771), 1,
      sym_finally_clause,
    STATE(17246), 2,
      sym_block_comment,
      sym_line_comment,
  [373194] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23995), 1,
      anon_sym_LPAREN,
    STATE(11797), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17247), 2,
      sym_block_comment,
      sym_line_comment,
  [373212] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7426), 1,
      anon_sym_RBRACK,
    ACTIONS(23997), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17248), 2,
      sym_block_comment,
      sym_line_comment,
  [373232] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8414), 1,
      anon_sym_RBRACE,
    ACTIONS(23999), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17249), 2,
      sym_block_comment,
      sym_line_comment,
  [373252] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8352), 1,
      anon_sym_RPAREN,
    ACTIONS(24001), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17250), 2,
      sym_block_comment,
      sym_line_comment,
  [373272] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7222), 1,
      anon_sym_RBRACK,
    ACTIONS(24003), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17251), 2,
      sym_block_comment,
      sym_line_comment,
  [373292] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19550), 1,
      sym__comprehension_clause,
    STATE(17252), 2,
      sym_block_comment,
      sym_line_comment,
  [373312] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7002), 1,
      anon_sym_RPAREN,
    ACTIONS(24005), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17253), 2,
      sym_block_comment,
      sym_line_comment,
  [373332] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6922), 1,
      anon_sym_RPAREN,
    ACTIONS(24007), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17254), 2,
      sym_block_comment,
      sym_line_comment,
  [373352] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8564), 1,
      anon_sym_RPAREN,
    ACTIONS(18982), 1,
      anon_sym_COMMA,
    STATE(17292), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17255), 2,
      sym_block_comment,
      sym_line_comment,
  [373372] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24009), 1,
      sym__immediate_paren,
    ACTIONS(24011), 1,
      sym__immediate_bracket,
    ACTIONS(24013), 1,
      sym__immediate_brace,
    STATE(17256), 2,
      sym_block_comment,
      sym_line_comment,
  [373392] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19176), 1,
      sym__comprehension_clause,
    STATE(17257), 2,
      sym_block_comment,
      sym_line_comment,
  [373412] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7224), 1,
      anon_sym_RBRACE,
    ACTIONS(24015), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17258), 2,
      sym_block_comment,
      sym_line_comment,
  [373432] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6990), 1,
      anon_sym_RPAREN,
    ACTIONS(19044), 1,
      anon_sym_COMMA,
    STATE(17354), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17259), 2,
      sym_block_comment,
      sym_line_comment,
  [373452] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8364), 1,
      anon_sym_RPAREN,
    ACTIONS(18872), 1,
      anon_sym_COMMA,
    STATE(17327), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17260), 2,
      sym_block_comment,
      sym_line_comment,
  [373472] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19254), 1,
      anon_sym_COMMA,
    ACTIONS(19256), 1,
      anon_sym_RBRACE,
    STATE(17086), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17261), 2,
      sym_block_comment,
      sym_line_comment,
  [373492] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18778), 1,
      anon_sym_COMMA,
    ACTIONS(18780), 1,
      anon_sym_RBRACE,
    STATE(17281), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17262), 2,
      sym_block_comment,
      sym_line_comment,
  [373512] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18632), 1,
      sym__comprehension_clause,
    STATE(17263), 2,
      sym_block_comment,
      sym_line_comment,
  [373532] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8566), 1,
      anon_sym_RBRACK,
    ACTIONS(24017), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17264), 2,
      sym_block_comment,
      sym_line_comment,
  [373552] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24019), 1,
      anon_sym_LPAREN,
    STATE(11724), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17265), 2,
      sym_block_comment,
      sym_line_comment,
  [373570] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7634), 1,
      anon_sym_RPAREN,
    ACTIONS(18752), 1,
      anon_sym_COMMA,
    STATE(17332), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17266), 2,
      sym_block_comment,
      sym_line_comment,
  [373590] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8612), 1,
      anon_sym_RPAREN,
    ACTIONS(24021), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17267), 2,
      sym_block_comment,
      sym_line_comment,
  [373610] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7806), 1,
      anon_sym_RPAREN,
    ACTIONS(19150), 1,
      anon_sym_COMMA,
    STATE(17423), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17268), 2,
      sym_block_comment,
      sym_line_comment,
  [373630] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8180), 1,
      anon_sym_RPAREN,
    ACTIONS(18744), 1,
      anon_sym_COMMA,
    STATE(17300), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17269), 2,
      sym_block_comment,
      sym_line_comment,
  [373650] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18854), 1,
      sym__comprehension_clause,
    STATE(17270), 2,
      sym_block_comment,
      sym_line_comment,
  [373670] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7428), 1,
      anon_sym_RBRACE,
    ACTIONS(24023), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17271), 2,
      sym_block_comment,
      sym_line_comment,
  [373690] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9802), 1,
      anon_sym_RPAREN,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10483), 1,
      sym_identifier,
    STATE(17272), 2,
      sym_block_comment,
      sym_line_comment,
  [373710] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19015), 1,
      sym__comprehension_clause,
    STATE(17273), 2,
      sym_block_comment,
      sym_line_comment,
  [373730] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19381), 1,
      sym__comprehension_clause,
    STATE(17274), 2,
      sym_block_comment,
      sym_line_comment,
  [373750] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8568), 1,
      anon_sym_RBRACE,
    ACTIONS(24025), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17275), 2,
      sym_block_comment,
      sym_line_comment,
  [373770] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8182), 1,
      anon_sym_RBRACK,
    ACTIONS(24027), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17276), 2,
      sym_block_comment,
      sym_line_comment,
  [373790] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24029), 1,
      sym__immediate_paren,
    ACTIONS(24031), 1,
      sym__immediate_bracket,
    ACTIONS(24033), 1,
      sym__immediate_brace,
    STATE(17277), 2,
      sym_block_comment,
      sym_line_comment,
  [373810] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18746), 1,
      sym__comprehension_clause,
    STATE(17278), 2,
      sym_block_comment,
      sym_line_comment,
  [373830] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24035), 1,
      anon_sym_end,
    STATE(18816), 1,
      sym_finally_clause,
    STATE(17279), 2,
      sym_block_comment,
      sym_line_comment,
  [373850] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8652), 1,
      anon_sym_RBRACE,
    ACTIONS(24037), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17280), 2,
      sym_block_comment,
      sym_line_comment,
  [373870] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8184), 1,
      anon_sym_RBRACE,
    ACTIONS(24039), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17281), 2,
      sym_block_comment,
      sym_line_comment,
  [373890] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24041), 1,
      anon_sym_LPAREN,
    STATE(11296), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17282), 2,
      sym_block_comment,
      sym_line_comment,
  [373908] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7636), 1,
      anon_sym_RBRACK,
    ACTIONS(24043), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17283), 2,
      sym_block_comment,
      sym_line_comment,
  [373928] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18966), 1,
      anon_sym_COMMA,
    ACTIONS(18968), 1,
      anon_sym_RBRACE,
    STATE(17304), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17284), 2,
      sym_block_comment,
      sym_line_comment,
  [373948] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18245), 1,
      sym__comprehension_clause,
    STATE(17285), 2,
      sym_block_comment,
      sym_line_comment,
  [373968] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24045), 1,
      anon_sym_end,
    STATE(18895), 1,
      sym_finally_clause,
    STATE(17286), 2,
      sym_block_comment,
      sym_line_comment,
  [373988] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8646), 1,
      anon_sym_RBRACK,
    ACTIONS(24047), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17287), 2,
      sym_block_comment,
      sym_line_comment,
  [374008] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24049), 1,
      sym__word_identifier,
    ACTIONS(24051), 1,
      sym__immediate_paren,
    STATE(16045), 1,
      sym_identifier,
    STATE(17288), 2,
      sym_block_comment,
      sym_line_comment,
  [374028] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7910), 1,
      anon_sym_RPAREN,
    ACTIONS(24053), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17289), 2,
      sym_block_comment,
      sym_line_comment,
  [374048] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18648), 1,
      sym__comprehension_clause,
    STATE(17290), 2,
      sym_block_comment,
      sym_line_comment,
  [374068] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8782), 1,
      anon_sym_RBRACE,
    ACTIONS(24055), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17291), 2,
      sym_block_comment,
      sym_line_comment,
  [374088] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8738), 1,
      anon_sym_RPAREN,
    ACTIONS(24057), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17292), 2,
      sym_block_comment,
      sym_line_comment,
  [374108] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24059), 1,
      anon_sym_LPAREN,
    STATE(6501), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17293), 2,
      sym_block_comment,
      sym_line_comment,
  [374126] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18960), 1,
      sym__comprehension_clause,
    STATE(17294), 2,
      sym_block_comment,
      sym_line_comment,
  [374146] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7708), 1,
      anon_sym_RBRACE,
    ACTIONS(24061), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17295), 2,
      sym_block_comment,
      sym_line_comment,
  [374166] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8508), 1,
      anon_sym_RPAREN,
    ACTIONS(18948), 1,
      anon_sym_COMMA,
    STATE(17337), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17296), 2,
      sym_block_comment,
      sym_line_comment,
  [374186] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19242), 1,
      sym__comprehension_clause,
    STATE(17297), 2,
      sym_block_comment,
      sym_line_comment,
  [374206] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8510), 1,
      anon_sym_RBRACK,
    ACTIONS(24063), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17298), 2,
      sym_block_comment,
      sym_line_comment,
  [374226] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18950), 1,
      anon_sym_COMMA,
    ACTIONS(18952), 1,
      anon_sym_RBRACE,
    STATE(17342), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17299), 2,
      sym_block_comment,
      sym_line_comment,
  [374246] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8704), 1,
      anon_sym_RPAREN,
    ACTIONS(24065), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17300), 2,
      sym_block_comment,
      sym_line_comment,
  [374266] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19502), 1,
      sym__comprehension_clause,
    STATE(17301), 2,
      sym_block_comment,
      sym_line_comment,
  [374286] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24067), 1,
      anon_sym_LPAREN,
    STATE(5737), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17302), 2,
      sym_block_comment,
      sym_line_comment,
  [374304] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24069), 1,
      anon_sym_LPAREN,
    STATE(5455), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17303), 2,
      sym_block_comment,
      sym_line_comment,
  [374322] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8512), 1,
      anon_sym_RBRACE,
    ACTIONS(24071), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17304), 2,
      sym_block_comment,
      sym_line_comment,
  [374342] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19439), 1,
      sym__comprehension_clause,
    STATE(17305), 2,
      sym_block_comment,
      sym_line_comment,
  [374362] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24073), 1,
      sym__immediate_paren,
    ACTIONS(24075), 1,
      sym__immediate_bracket,
    ACTIONS(24077), 1,
      sym__immediate_brace,
    STATE(17306), 2,
      sym_block_comment,
      sym_line_comment,
  [374382] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8458), 1,
      anon_sym_RPAREN,
    ACTIONS(18920), 1,
      anon_sym_COMMA,
    STATE(17373), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17307), 2,
      sym_block_comment,
      sym_line_comment,
  [374402] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19549), 1,
      sym__comprehension_clause,
    STATE(17308), 2,
      sym_block_comment,
      sym_line_comment,
  [374422] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24079), 1,
      anon_sym_end,
    STATE(19536), 1,
      sym_finally_clause,
    STATE(17309), 2,
      sym_block_comment,
      sym_line_comment,
  [374442] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8460), 1,
      anon_sym_RBRACK,
    ACTIONS(24081), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17310), 2,
      sym_block_comment,
      sym_line_comment,
  [374462] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18876), 1,
      sym__comprehension_clause,
    STATE(17311), 2,
      sym_block_comment,
      sym_line_comment,
  [374482] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18754), 1,
      anon_sym_COMMA,
    ACTIONS(18756), 1,
      anon_sym_RBRACE,
    STATE(17101), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17312), 2,
      sym_block_comment,
      sym_line_comment,
  [374502] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(12070), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17313), 2,
      sym_block_comment,
      sym_line_comment,
  [374520] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21079), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18704), 1,
      sym_catch_clause,
    STATE(17314), 2,
      sym_block_comment,
      sym_line_comment,
  [374540] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7638), 1,
      anon_sym_RBRACE,
    ACTIONS(24083), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17315), 2,
      sym_block_comment,
      sym_line_comment,
  [374560] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18288), 1,
      sym__comprehension_clause,
    STATE(17316), 2,
      sym_block_comment,
      sym_line_comment,
  [374580] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19006), 1,
      anon_sym_COMMA,
    ACTIONS(19008), 1,
      anon_sym_RBRACE,
    STATE(17343), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17317), 2,
      sym_block_comment,
      sym_line_comment,
  [374600] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18337), 1,
      sym__comprehension_clause,
    STATE(17318), 2,
      sym_block_comment,
      sym_line_comment,
  [374620] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7474), 1,
      anon_sym_RPAREN,
    ACTIONS(19436), 1,
      anon_sym_COMMA,
    STATE(17456), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17319), 2,
      sym_block_comment,
      sym_line_comment,
  [374640] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24085), 1,
      sym__immediate_paren,
    ACTIONS(24087), 1,
      sym__immediate_bracket,
    ACTIONS(24089), 1,
      sym__immediate_brace,
    STATE(17320), 2,
      sym_block_comment,
      sym_line_comment,
  [374660] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7808), 1,
      anon_sym_RBRACK,
    ACTIONS(24091), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17321), 2,
      sym_block_comment,
      sym_line_comment,
  [374680] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24093), 1,
      anon_sym_LPAREN,
    STATE(8624), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17322), 2,
      sym_block_comment,
      sym_line_comment,
  [374698] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18788), 1,
      anon_sym_COMMA,
    ACTIONS(18790), 1,
      anon_sym_RBRACE,
    STATE(17340), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17323), 2,
      sym_block_comment,
      sym_line_comment,
  [374718] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19418), 1,
      anon_sym_COMMA,
    ACTIONS(19420), 1,
      anon_sym_RBRACE,
    STATE(17376), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17324), 2,
      sym_block_comment,
      sym_line_comment,
  [374738] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24095), 1,
      anon_sym_LPAREN,
    STATE(5084), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17325), 2,
      sym_block_comment,
      sym_line_comment,
  [374756] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24097), 1,
      anon_sym_LPAREN,
    STATE(7039), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17326), 2,
      sym_block_comment,
      sym_line_comment,
  [374774] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8720), 1,
      anon_sym_RPAREN,
    ACTIONS(24099), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17327), 2,
      sym_block_comment,
      sym_line_comment,
  [374794] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17328), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24101), 3,
      anon_sym_end,
      anon_sym_else,
      anon_sym_finally,
  [374810] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7810), 1,
      anon_sym_RBRACE,
    ACTIONS(24103), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17329), 2,
      sym_block_comment,
      sym_line_comment,
  [374830] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21079), 1,
      anon_sym_end,
    ACTIONS(21083), 1,
      anon_sym_finally,
    STATE(18704), 1,
      sym_finally_clause,
    STATE(17330), 2,
      sym_block_comment,
      sym_line_comment,
  [374850] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8204), 1,
      anon_sym_RPAREN,
    ACTIONS(18776), 1,
      anon_sym_COMMA,
    STATE(17346), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17331), 2,
      sym_block_comment,
      sym_line_comment,
  [374870] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8492), 1,
      anon_sym_RPAREN,
    ACTIONS(24105), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17332), 2,
      sym_block_comment,
      sym_line_comment,
  [374890] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8586), 1,
      anon_sym_RPAREN,
    ACTIONS(18992), 1,
      anon_sym_COMMA,
    STATE(17366), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17333), 2,
      sym_block_comment,
      sym_line_comment,
  [374910] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7304), 1,
      anon_sym_RPAREN,
    ACTIONS(24107), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17334), 2,
      sym_block_comment,
      sym_line_comment,
  [374930] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17335), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19334), 3,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_RPAREN,
  [374946] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8206), 1,
      anon_sym_RBRACK,
    ACTIONS(24109), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17336), 2,
      sym_block_comment,
      sym_line_comment,
  [374966] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8732), 1,
      anon_sym_RPAREN,
    ACTIONS(24111), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17337), 2,
      sym_block_comment,
      sym_line_comment,
  [374986] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7112), 1,
      anon_sym_RBRACK,
    ACTIONS(24113), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17338), 2,
      sym_block_comment,
      sym_line_comment,
  [375006] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8588), 1,
      anon_sym_RBRACK,
    ACTIONS(24115), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17339), 2,
      sym_block_comment,
      sym_line_comment,
  [375026] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8210), 1,
      anon_sym_RBRACE,
    ACTIONS(24117), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17340), 2,
      sym_block_comment,
      sym_line_comment,
  [375046] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24119), 1,
      sym__immediate_paren,
    ACTIONS(24121), 1,
      sym__immediate_bracket,
    ACTIONS(24123), 1,
      sym__immediate_brace,
    STATE(17341), 2,
      sym_block_comment,
      sym_line_comment,
  [375066] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8464), 1,
      anon_sym_RBRACE,
    ACTIONS(24125), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17342), 2,
      sym_block_comment,
      sym_line_comment,
  [375086] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8590), 1,
      anon_sym_RBRACE,
    ACTIONS(24127), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17343), 2,
      sym_block_comment,
      sym_line_comment,
  [375106] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8722), 1,
      anon_sym_RPAREN,
    ACTIONS(24129), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17344), 2,
      sym_block_comment,
      sym_line_comment,
  [375126] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8718), 1,
      anon_sym_RPAREN,
    ACTIONS(24131), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17345), 2,
      sym_block_comment,
      sym_line_comment,
  [375146] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8706), 1,
      anon_sym_RPAREN,
    ACTIONS(24133), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17346), 2,
      sym_block_comment,
      sym_line_comment,
  [375166] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9782), 1,
      anon_sym_RPAREN,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10417), 1,
      sym_identifier,
    STATE(17347), 2,
      sym_block_comment,
      sym_line_comment,
  [375186] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21103), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19137), 1,
      sym_catch_clause,
    STATE(17348), 2,
      sym_block_comment,
      sym_line_comment,
  [375206] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8366), 1,
      anon_sym_RBRACK,
    ACTIONS(24135), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17349), 2,
      sym_block_comment,
      sym_line_comment,
  [375226] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24137), 1,
      anon_sym_end,
    STATE(18713), 1,
      sym_finally_clause,
    STATE(17350), 2,
      sym_block_comment,
      sym_line_comment,
  [375246] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19092), 1,
      sym__comprehension_clause,
    STATE(17351), 2,
      sym_block_comment,
      sym_line_comment,
  [375266] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24139), 1,
      sym__immediate_paren,
    ACTIONS(24141), 1,
      sym__immediate_bracket,
    ACTIONS(24143), 1,
      sym__immediate_brace,
    STATE(17352), 2,
      sym_block_comment,
      sym_line_comment,
  [375286] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7232), 1,
      anon_sym_RPAREN,
    ACTIONS(24145), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17353), 2,
      sym_block_comment,
      sym_line_comment,
  [375306] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7488), 1,
      anon_sym_RPAREN,
    ACTIONS(24147), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17354), 2,
      sym_block_comment,
      sym_line_comment,
  [375326] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16436), 1,
      sym__word_identifier,
    STATE(11636), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17355), 2,
      sym_block_comment,
      sym_line_comment,
  [375344] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(24151), 1,
      aux_sym__terminator_token1,
    ACTIONS(24149), 2,
      anon_sym_COMMA,
      aux_sym__terminator_token2,
    STATE(17356), 2,
      sym_block_comment,
      sym_line_comment,
  [375362] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19336), 1,
      anon_sym_COMMA,
    ACTIONS(19338), 1,
      anon_sym_RBRACE,
    STATE(17474), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17357), 2,
      sym_block_comment,
      sym_line_comment,
  [375382] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24153), 1,
      anon_sym_LPAREN,
    STATE(10098), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17358), 2,
      sym_block_comment,
      sym_line_comment,
  [375400] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7990), 1,
      anon_sym_RPAREN,
    ACTIONS(19312), 1,
      anon_sym_COMMA,
    STATE(17411), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17359), 2,
      sym_block_comment,
      sym_line_comment,
  [375420] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18994), 1,
      anon_sym_COMMA,
    ACTIONS(18996), 1,
      anon_sym_RBRACE,
    STATE(17479), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17360), 2,
      sym_block_comment,
      sym_line_comment,
  [375440] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9730), 1,
      anon_sym_DOT,
    ACTIONS(9734), 1,
      anon_sym_RPAREN,
    ACTIONS(24155), 1,
      aux_sym_float_literal_token2,
    STATE(17361), 2,
      sym_block_comment,
      sym_line_comment,
  [375460] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8572), 1,
      anon_sym_RPAREN,
    ACTIONS(24157), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17362), 2,
      sym_block_comment,
      sym_line_comment,
  [375480] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24159), 1,
      anon_sym_LPAREN,
    STATE(5691), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17363), 2,
      sym_block_comment,
      sym_line_comment,
  [375498] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24161), 1,
      sym__immediate_paren,
    ACTIONS(24163), 1,
      sym__immediate_bracket,
    ACTIONS(24165), 1,
      sym__immediate_brace,
    STATE(17364), 2,
      sym_block_comment,
      sym_line_comment,
  [375518] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21176), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19058), 1,
      sym_catch_clause,
    STATE(17365), 2,
      sym_block_comment,
      sym_line_comment,
  [375538] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8740), 1,
      anon_sym_RPAREN,
    ACTIONS(24167), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17366), 2,
      sym_block_comment,
      sym_line_comment,
  [375558] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7992), 1,
      anon_sym_RBRACK,
    ACTIONS(24169), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17367), 2,
      sym_block_comment,
      sym_line_comment,
  [375578] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8724), 1,
      anon_sym_RPAREN,
    ACTIONS(24171), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17368), 2,
      sym_block_comment,
      sym_line_comment,
  [375598] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18802), 1,
      anon_sym_COMMA,
    ACTIONS(18804), 1,
      anon_sym_RBRACE,
    STATE(17382), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17369), 2,
      sym_block_comment,
      sym_line_comment,
  [375618] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21176), 1,
      anon_sym_end,
    STATE(19058), 1,
      sym_finally_clause,
    STATE(17370), 2,
      sym_block_comment,
      sym_line_comment,
  [375638] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24173), 1,
      anon_sym_LPAREN,
    STATE(5688), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17371), 2,
      sym_block_comment,
      sym_line_comment,
  [375656] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17372), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24175), 3,
      sym__content_str_1_raw,
      sym__end_str,
      sym_escape_sequence,
  [375672] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8728), 1,
      anon_sym_RPAREN,
    ACTIONS(24177), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17373), 2,
      sym_block_comment,
      sym_line_comment,
  [375692] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8232), 1,
      anon_sym_RPAREN,
    ACTIONS(18928), 1,
      anon_sym_COMMA,
    STATE(17393), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17374), 2,
      sym_block_comment,
      sym_line_comment,
  [375712] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19350), 1,
      anon_sym_COMMA,
    ACTIONS(19352), 1,
      anon_sym_RBRACE,
    STATE(17401), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17375), 2,
      sym_block_comment,
      sym_line_comment,
  [375732] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7994), 1,
      anon_sym_RBRACE,
    ACTIONS(24179), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17376), 2,
      sym_block_comment,
      sym_line_comment,
  [375752] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24181), 1,
      anon_sym_LPAREN,
    STATE(5331), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17377), 2,
      sym_block_comment,
      sym_line_comment,
  [375770] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8234), 1,
      anon_sym_RBRACK,
    ACTIONS(24183), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17378), 2,
      sym_block_comment,
      sym_line_comment,
  [375790] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24185), 1,
      anon_sym_end,
    STATE(18358), 1,
      sym_finally_clause,
    STATE(17379), 2,
      sym_block_comment,
      sym_line_comment,
  [375810] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18914), 1,
      anon_sym_COMMA,
    ACTIONS(18916), 1,
      anon_sym_RBRACE,
    STATE(17526), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17380), 2,
      sym_block_comment,
      sym_line_comment,
  [375830] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8214), 1,
      anon_sym_RPAREN,
    ACTIONS(24187), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17381), 2,
      sym_block_comment,
      sym_line_comment,
  [375850] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8238), 1,
      anon_sym_RBRACE,
    ACTIONS(24189), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17382), 2,
      sym_block_comment,
      sym_line_comment,
  [375870] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8688), 1,
      anon_sym_RPAREN,
    ACTIONS(24191), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17383), 2,
      sym_block_comment,
      sym_line_comment,
  [375890] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7476), 1,
      anon_sym_RBRACK,
    ACTIONS(24193), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17384), 2,
      sym_block_comment,
      sym_line_comment,
  [375910] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24195), 1,
      sym__immediate_paren,
    ACTIONS(24197), 1,
      sym__immediate_bracket,
    ACTIONS(24199), 1,
      sym__immediate_brace,
    STATE(17385), 2,
      sym_block_comment,
      sym_line_comment,
  [375930] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9786), 1,
      anon_sym_RPAREN,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10447), 1,
      sym_identifier,
    STATE(17386), 2,
      sym_block_comment,
      sym_line_comment,
  [375950] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18440), 1,
      sym__comprehension_clause,
    STATE(17387), 2,
      sym_block_comment,
      sym_line_comment,
  [375970] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19334), 1,
      anon_sym_RPAREN,
    ACTIONS(24201), 1,
      anon_sym_COMMA,
    STATE(17388), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_tuple_expression_repeat1,
  [375988] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7260), 1,
      anon_sym_RPAREN,
    ACTIONS(19156), 1,
      anon_sym_COMMA,
    STATE(17415), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17389), 2,
      sym_block_comment,
      sym_line_comment,
  [376008] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24204), 1,
      sym__immediate_paren,
    ACTIONS(24206), 1,
      sym__immediate_bracket,
    ACTIONS(24208), 1,
      sym__immediate_brace,
    STATE(17390), 2,
      sym_block_comment,
      sym_line_comment,
  [376028] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21148), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19246), 1,
      sym_catch_clause,
    STATE(17391), 2,
      sym_block_comment,
      sym_line_comment,
  [376048] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18718), 1,
      sym__comprehension_clause,
    STATE(17392), 2,
      sym_block_comment,
      sym_line_comment,
  [376068] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8708), 1,
      anon_sym_RPAREN,
    ACTIONS(24210), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17393), 2,
      sym_block_comment,
      sym_line_comment,
  [376088] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24212), 1,
      sym__immediate_paren,
    ACTIONS(24214), 1,
      sym__immediate_bracket,
    ACTIONS(24216), 1,
      sym__immediate_brace,
    STATE(17394), 2,
      sym_block_comment,
      sym_line_comment,
  [376108] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7434), 1,
      anon_sym_RBRACK,
    ACTIONS(24218), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17395), 2,
      sym_block_comment,
      sym_line_comment,
  [376128] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16464), 1,
      sym__word_identifier,
    STATE(6596), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17396), 2,
      sym_block_comment,
      sym_line_comment,
  [376146] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7262), 1,
      anon_sym_RBRACK,
    ACTIONS(24220), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17397), 2,
      sym_block_comment,
      sym_line_comment,
  [376166] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16354), 1,
      sym__word_identifier,
    STATE(6869), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17398), 2,
      sym_block_comment,
      sym_line_comment,
  [376184] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21125), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19104), 1,
      sym_catch_clause,
    STATE(17399), 2,
      sym_block_comment,
      sym_line_comment,
  [376204] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19346), 1,
      anon_sym_COMMA,
    ACTIONS(19348), 1,
      anon_sym_RBRACE,
    STATE(17467), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17400), 2,
      sym_block_comment,
      sym_line_comment,
  [376224] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7264), 1,
      anon_sym_RBRACE,
    ACTIONS(24222), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17401), 2,
      sym_block_comment,
      sym_line_comment,
  [376244] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6970), 1,
      anon_sym_RBRACK,
    ACTIONS(24224), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17402), 2,
      sym_block_comment,
      sym_line_comment,
  [376264] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18922), 1,
      anon_sym_COMMA,
    ACTIONS(18924), 1,
      anon_sym_RBRACE,
    STATE(17177), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17403), 2,
      sym_block_comment,
      sym_line_comment,
  [376284] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7564), 1,
      anon_sym_RPAREN,
    ACTIONS(19308), 1,
      anon_sym_COMMA,
    STATE(17647), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17404), 2,
      sym_block_comment,
      sym_line_comment,
  [376304] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8348), 1,
      anon_sym_RBRACE,
    ACTIONS(24226), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17405), 2,
      sym_block_comment,
      sym_line_comment,
  [376324] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7480), 1,
      anon_sym_RBRACE,
    ACTIONS(24228), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17406), 2,
      sym_block_comment,
      sym_line_comment,
  [376344] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8406), 1,
      anon_sym_RBRACE,
    ACTIONS(24230), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17407), 2,
      sym_block_comment,
      sym_line_comment,
  [376364] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6914), 1,
      anon_sym_RBRACK,
    ACTIONS(24232), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17408), 2,
      sym_block_comment,
      sym_line_comment,
  [376384] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24234), 1,
      anon_sym_LPAREN,
    STATE(5779), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17409), 2,
      sym_block_comment,
      sym_line_comment,
  [376402] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18976), 1,
      anon_sym_COMMA,
    ACTIONS(18978), 1,
      anon_sym_RBRACE,
    STATE(17482), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17410), 2,
      sym_block_comment,
      sym_line_comment,
  [376422] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8694), 1,
      anon_sym_RPAREN,
    ACTIONS(24236), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17411), 2,
      sym_block_comment,
      sym_line_comment,
  [376442] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21184), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18624), 1,
      sym_catch_clause,
    STATE(17412), 2,
      sym_block_comment,
      sym_line_comment,
  [376462] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17413), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24238), 3,
      sym__content_cmd_3_raw,
      sym__end_cmd,
      sym_escape_sequence,
  [376478] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7438), 1,
      anon_sym_RBRACE,
    ACTIONS(24240), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17414), 2,
      sym_block_comment,
      sym_line_comment,
  [376498] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_RPAREN,
    ACTIONS(24242), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17415), 2,
      sym_block_comment,
      sym_line_comment,
  [376518] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24244), 1,
      anon_sym_LPAREN,
    STATE(6970), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17416), 2,
      sym_block_comment,
      sym_line_comment,
  [376536] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7766), 1,
      anon_sym_RPAREN,
    ACTIONS(19098), 1,
      anon_sym_COMMA,
    STATE(17267), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17417), 2,
      sym_block_comment,
      sym_line_comment,
  [376556] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24246), 1,
      sym__immediate_paren,
    ACTIONS(24248), 1,
      sym__immediate_bracket,
    ACTIONS(24250), 1,
      sym__immediate_brace,
    STATE(17418), 2,
      sym_block_comment,
      sym_line_comment,
  [376576] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19444), 1,
      anon_sym_COMMA,
    ACTIONS(19446), 1,
      anon_sym_RBRACE,
    STATE(17542), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17419), 2,
      sym_block_comment,
      sym_line_comment,
  [376596] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21162), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19202), 1,
      sym_catch_clause,
    STATE(17420), 2,
      sym_block_comment,
      sym_line_comment,
  [376616] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18836), 1,
      anon_sym_COMMA,
    ACTIONS(18838), 1,
      anon_sym_RBRACE,
    STATE(17440), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17421), 2,
      sym_block_comment,
      sym_line_comment,
  [376636] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19158), 1,
      anon_sym_COMMA,
    ACTIONS(19160), 1,
      anon_sym_RBRACE,
    STATE(17498), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17422), 2,
      sym_block_comment,
      sym_line_comment,
  [376656] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8658), 1,
      anon_sym_RPAREN,
    ACTIONS(24252), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17423), 2,
      sym_block_comment,
      sym_line_comment,
  [376676] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8526), 1,
      anon_sym_RPAREN,
    ACTIONS(18964), 1,
      anon_sym_COMMA,
    STATE(17515), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17424), 2,
      sym_block_comment,
      sym_line_comment,
  [376696] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24254), 1,
      anon_sym_LPAREN,
    STATE(5993), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17425), 2,
      sym_block_comment,
      sym_line_comment,
  [376714] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21131), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19018), 1,
      sym_catch_clause,
    STATE(17426), 2,
      sym_block_comment,
      sym_line_comment,
  [376734] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19270), 1,
      anon_sym_COMMA,
    ACTIONS(19272), 1,
      anon_sym_RBRACE,
    STATE(17280), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17427), 2,
      sym_block_comment,
      sym_line_comment,
  [376754] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19252), 1,
      sym__comprehension_clause,
    STATE(17428), 2,
      sym_block_comment,
      sym_line_comment,
  [376774] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24256), 1,
      anon_sym_LPAREN,
    STATE(6683), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17429), 2,
      sym_block_comment,
      sym_line_comment,
  [376792] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24258), 1,
      sym__immediate_paren,
    ACTIONS(24260), 1,
      sym__immediate_bracket,
    ACTIONS(24262), 1,
      sym__immediate_brace,
    STATE(17430), 2,
      sym_block_comment,
      sym_line_comment,
  [376812] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19068), 1,
      anon_sym_COMMA,
    ACTIONS(19070), 1,
      anon_sym_RBRACE,
    STATE(17461), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17431), 2,
      sym_block_comment,
      sym_line_comment,
  [376832] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19016), 1,
      anon_sym_COMMA,
    ACTIONS(19018), 1,
      anon_sym_RBRACE,
    STATE(17481), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17432), 2,
      sym_block_comment,
      sym_line_comment,
  [376852] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8250), 1,
      anon_sym_RPAREN,
    ACTIONS(18786), 1,
      anon_sym_COMMA,
    STATE(17450), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17433), 2,
      sym_block_comment,
      sym_line_comment,
  [376872] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6916), 1,
      anon_sym_RBRACE,
    ACTIONS(24264), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17434), 2,
      sym_block_comment,
      sym_line_comment,
  [376892] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24266), 1,
      anon_sym_LPAREN,
    STATE(7850), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17435), 2,
      sym_block_comment,
      sym_line_comment,
  [376910] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21131), 1,
      anon_sym_end,
    STATE(19018), 1,
      sym_finally_clause,
    STATE(17436), 2,
      sym_block_comment,
      sym_line_comment,
  [376930] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8252), 1,
      anon_sym_RBRACK,
    ACTIONS(24268), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17437), 2,
      sym_block_comment,
      sym_line_comment,
  [376950] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19168), 1,
      anon_sym_COMMA,
    ACTIONS(19170), 1,
      anon_sym_RBRACE,
    STATE(17465), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17438), 2,
      sym_block_comment,
      sym_line_comment,
  [376970] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16304), 1,
      sym__word_identifier,
    STATE(7208), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17439), 2,
      sym_block_comment,
      sym_line_comment,
  [376988] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8254), 1,
      anon_sym_RBRACE,
    ACTIONS(24270), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17440), 2,
      sym_block_comment,
      sym_line_comment,
  [377008] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21174), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19234), 1,
      sym_catch_clause,
    STATE(17441), 2,
      sym_block_comment,
      sym_line_comment,
  [377028] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7900), 1,
      anon_sym_RPAREN,
    ACTIONS(19238), 1,
      anon_sym_COMMA,
    STATE(17502), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17442), 2,
      sym_block_comment,
      sym_line_comment,
  [377048] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21133), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18279), 1,
      sym_catch_clause,
    STATE(17443), 2,
      sym_block_comment,
      sym_line_comment,
  [377068] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24272), 1,
      anon_sym_LPAREN,
    STATE(10414), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17444), 2,
      sym_block_comment,
      sym_line_comment,
  [377086] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21174), 1,
      anon_sym_end,
    STATE(19234), 1,
      sym_finally_clause,
    STATE(17445), 2,
      sym_block_comment,
      sym_line_comment,
  [377106] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19094), 1,
      anon_sym_COMMA,
    ACTIONS(19096), 1,
      anon_sym_RBRACE,
    STATE(17539), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17446), 2,
      sym_block_comment,
      sym_line_comment,
  [377126] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7388), 1,
      anon_sym_RPAREN,
    ACTIONS(19322), 1,
      anon_sym_COMMA,
    STATE(17381), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17447), 2,
      sym_block_comment,
      sym_line_comment,
  [377146] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24274), 1,
      sym__immediate_paren,
    ACTIONS(24276), 1,
      sym__immediate_bracket,
    ACTIONS(24278), 1,
      sym__immediate_brace,
    STATE(17448), 2,
      sym_block_comment,
      sym_line_comment,
  [377166] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8528), 1,
      anon_sym_RBRACK,
    ACTIONS(24280), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17449), 2,
      sym_block_comment,
      sym_line_comment,
  [377186] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8710), 1,
      anon_sym_RPAREN,
    ACTIONS(24282), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17450), 2,
      sym_block_comment,
      sym_line_comment,
  [377206] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8604), 1,
      anon_sym_RPAREN,
    ACTIONS(19004), 1,
      anon_sym_COMMA,
    STATE(17505), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17451), 2,
      sym_block_comment,
      sym_line_comment,
  [377226] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7670), 1,
      anon_sym_RPAREN,
    ACTIONS(18892), 1,
      anon_sym_COMMA,
    STATE(17531), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17452), 2,
      sym_block_comment,
      sym_line_comment,
  [377246] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24284), 1,
      anon_sym_LPAREN,
    STATE(4252), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17453), 2,
      sym_block_comment,
      sym_line_comment,
  [377264] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7566), 1,
      anon_sym_RBRACK,
    ACTIONS(24286), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17454), 2,
      sym_block_comment,
      sym_line_comment,
  [377284] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8094), 1,
      anon_sym_RPAREN,
    ACTIONS(19172), 1,
      anon_sym_COMMA,
    STATE(17492), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17455), 2,
      sym_block_comment,
      sym_line_comment,
  [377304] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8316), 1,
      anon_sym_RPAREN,
    ACTIONS(24288), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17456), 2,
      sym_block_comment,
      sym_line_comment,
  [377324] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7902), 1,
      anon_sym_RBRACK,
    ACTIONS(24290), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17457), 2,
      sym_block_comment,
      sym_line_comment,
  [377344] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19388), 1,
      anon_sym_COMMA,
    ACTIONS(19390), 1,
      anon_sym_RBRACE,
    STATE(17516), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17458), 2,
      sym_block_comment,
      sym_line_comment,
  [377364] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18812), 1,
      sym__comprehension_clause,
    STATE(17459), 2,
      sym_block_comment,
      sym_line_comment,
  [377384] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24292), 1,
      anon_sym_LPAREN,
    STATE(11341), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17460), 2,
      sym_block_comment,
      sym_line_comment,
  [377402] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7604), 1,
      anon_sym_RBRACE,
    ACTIONS(24294), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17461), 2,
      sym_block_comment,
      sym_line_comment,
  [377422] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24296), 1,
      sym__immediate_paren,
    ACTIONS(24298), 1,
      sym__immediate_bracket,
    ACTIONS(24300), 1,
      sym__immediate_brace,
    STATE(17462), 2,
      sym_block_comment,
      sym_line_comment,
  [377442] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8606), 1,
      anon_sym_RBRACK,
    ACTIONS(24302), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17463), 2,
      sym_block_comment,
      sym_line_comment,
  [377462] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8696), 1,
      anon_sym_RPAREN,
    ACTIONS(24304), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17464), 2,
      sym_block_comment,
      sym_line_comment,
  [377482] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7114), 1,
      anon_sym_RBRACE,
    ACTIONS(24306), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17465), 2,
      sym_block_comment,
      sym_line_comment,
  [377502] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8778), 1,
      anon_sym_RPAREN,
    ACTIONS(19148), 1,
      anon_sym_COMMA,
    STATE(17081), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17466), 2,
      sym_block_comment,
      sym_line_comment,
  [377522] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7904), 1,
      anon_sym_RBRACE,
    ACTIONS(24308), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17467), 2,
      sym_block_comment,
      sym_line_comment,
  [377542] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16368), 1,
      sym__word_identifier,
    STATE(6516), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17468), 2,
      sym_block_comment,
      sym_line_comment,
  [377560] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24310), 1,
      sym__word_identifier,
    ACTIONS(24312), 1,
      sym__immediate_paren,
    STATE(16234), 1,
      sym_identifier,
    STATE(17469), 2,
      sym_block_comment,
      sym_line_comment,
  [377580] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21097), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19182), 1,
      sym_catch_clause,
    STATE(17470), 2,
      sym_block_comment,
      sym_line_comment,
  [377600] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8644), 1,
      anon_sym_RPAREN,
    ACTIONS(19022), 1,
      anon_sym_COMMA,
    STATE(17353), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17471), 2,
      sym_block_comment,
      sym_line_comment,
  [377620] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8098), 1,
      anon_sym_RBRACK,
    ACTIONS(24314), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17472), 2,
      sym_block_comment,
      sym_line_comment,
  [377640] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21097), 1,
      anon_sym_end,
    STATE(19182), 1,
      sym_finally_clause,
    STATE(17473), 2,
      sym_block_comment,
      sym_line_comment,
  [377660] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8100), 1,
      anon_sym_RBRACE,
    ACTIONS(24316), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17474), 2,
      sym_block_comment,
      sym_line_comment,
  [377680] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19248), 1,
      sym__comprehension_clause,
    STATE(17475), 2,
      sym_block_comment,
      sym_line_comment,
  [377700] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7294), 1,
      anon_sym_RPAREN,
    ACTIONS(19226), 1,
      anon_sym_COMMA,
    STATE(17546), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17476), 2,
      sym_block_comment,
      sym_line_comment,
  [377720] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7672), 1,
      anon_sym_RBRACK,
    ACTIONS(24318), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17477), 2,
      sym_block_comment,
      sym_line_comment,
  [377740] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24320), 1,
      anon_sym_LPAREN,
    STATE(10536), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17478), 2,
      sym_block_comment,
      sym_line_comment,
  [377758] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7568), 1,
      anon_sym_RBRACE,
    ACTIONS(24322), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17479), 2,
      sym_block_comment,
      sym_line_comment,
  [377778] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8752), 1,
      anon_sym_RPAREN,
    ACTIONS(24324), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17480), 2,
      sym_block_comment,
      sym_line_comment,
  [377798] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8608), 1,
      anon_sym_RBRACE,
    ACTIONS(24326), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17481), 2,
      sym_block_comment,
      sym_line_comment,
  [377818] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8530), 1,
      anon_sym_RBRACE,
    ACTIONS(24328), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17482), 2,
      sym_block_comment,
      sym_line_comment,
  [377838] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7524), 1,
      anon_sym_RBRACK,
    ACTIONS(24330), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17483), 2,
      sym_block_comment,
      sym_line_comment,
  [377858] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8810), 1,
      anon_sym_RPAREN,
    ACTIONS(19264), 1,
      anon_sym_COMMA,
    STATE(17334), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17484), 2,
      sym_block_comment,
      sym_line_comment,
  [377878] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(10982), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17485), 2,
      sym_block_comment,
      sym_line_comment,
  [377896] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21087), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19289), 1,
      sym_catch_clause,
    STATE(17486), 2,
      sym_block_comment,
      sym_line_comment,
  [377916] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21087), 1,
      anon_sym_end,
    STATE(19289), 1,
      sym_finally_clause,
    STATE(17487), 2,
      sym_block_comment,
      sym_line_comment,
  [377936] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24332), 1,
      sym__immediate_paren,
    ACTIONS(24334), 1,
      sym__immediate_bracket,
    ACTIONS(24336), 1,
      sym__immediate_brace,
    STATE(17488), 2,
      sym_block_comment,
      sym_line_comment,
  [377956] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8812), 1,
      anon_sym_RBRACK,
    ACTIONS(24338), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17489), 2,
      sym_block_comment,
      sym_line_comment,
  [377976] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17490), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(22884), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [377992] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24340), 1,
      sym__word_identifier,
    ACTIONS(24342), 1,
      sym__immediate_paren,
    STATE(15544), 1,
      sym_identifier,
    STATE(17491), 2,
      sym_block_comment,
      sym_line_comment,
  [378012] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7068), 1,
      anon_sym_RPAREN,
    ACTIONS(24344), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17492), 2,
      sym_block_comment,
      sym_line_comment,
  [378032] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6958), 1,
      anon_sym_RBRACK,
    ACTIONS(24346), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17493), 2,
      sym_block_comment,
      sym_line_comment,
  [378052] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17494), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19396), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [378068] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18864), 1,
      anon_sym_COMMA,
    ACTIONS(18866), 1,
      anon_sym_RBRACE,
    STATE(17521), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17495), 2,
      sym_block_comment,
      sym_line_comment,
  [378088] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21099), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19495), 1,
      sym_catch_clause,
    STATE(17496), 2,
      sym_block_comment,
      sym_line_comment,
  [378108] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21125), 1,
      anon_sym_end,
    STATE(19104), 1,
      sym_finally_clause,
    STATE(17497), 2,
      sym_block_comment,
      sym_line_comment,
  [378128] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7674), 1,
      anon_sym_RBRACE,
    ACTIONS(24348), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17498), 2,
      sym_block_comment,
      sym_line_comment,
  [378148] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7644), 1,
      anon_sym_RPAREN,
    ACTIONS(24350), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17499), 2,
      sym_block_comment,
      sym_line_comment,
  [378168] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24352), 1,
      anon_sym_LPAREN,
    STATE(6840), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17500), 2,
      sym_block_comment,
      sym_line_comment,
  [378186] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8270), 1,
      anon_sym_RPAREN,
    ACTIONS(18800), 1,
      anon_sym_COMMA,
    STATE(17530), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17501), 2,
      sym_block_comment,
      sym_line_comment,
  [378206] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8690), 1,
      anon_sym_RPAREN,
    ACTIONS(24354), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17502), 2,
      sym_block_comment,
      sym_line_comment,
  [378226] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7296), 1,
      anon_sym_RBRACK,
    ACTIONS(24356), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17503), 2,
      sym_block_comment,
      sym_line_comment,
  [378246] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18942), 1,
      anon_sym_COMMA,
    ACTIONS(18944), 1,
      anon_sym_RBRACE,
    STATE(17067), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17504), 2,
      sym_block_comment,
      sym_line_comment,
  [378266] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8742), 1,
      anon_sym_RPAREN,
    ACTIONS(24358), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17505), 2,
      sym_block_comment,
      sym_line_comment,
  [378286] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21107), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18290), 1,
      sym_catch_clause,
    STATE(17506), 2,
      sym_block_comment,
      sym_line_comment,
  [378306] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18954), 1,
      sym__comprehension_clause,
    STATE(17507), 2,
      sym_block_comment,
      sym_line_comment,
  [378326] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24360), 1,
      sym__immediate_paren,
    ACTIONS(24362), 1,
      sym__immediate_bracket,
    ACTIONS(24364), 1,
      sym__immediate_brace,
    STATE(17508), 2,
      sym_block_comment,
      sym_line_comment,
  [378346] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21109), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18297), 1,
      sym_catch_clause,
    STATE(17509), 2,
      sym_block_comment,
      sym_line_comment,
  [378366] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8272), 1,
      anon_sym_RBRACK,
    ACTIONS(24366), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17510), 2,
      sym_block_comment,
      sym_line_comment,
  [378386] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24368), 1,
      anon_sym_end,
    STATE(19301), 1,
      sym_finally_clause,
    STATE(17511), 2,
      sym_block_comment,
      sym_line_comment,
  [378406] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21109), 1,
      anon_sym_end,
    STATE(18297), 1,
      sym_finally_clause,
    STATE(17512), 2,
      sym_block_comment,
      sym_line_comment,
  [378426] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24370), 1,
      anon_sym_LPAREN,
    STATE(6743), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17513), 2,
      sym_block_comment,
      sym_line_comment,
  [378444] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6998), 1,
      anon_sym_RPAREN,
    ACTIONS(19224), 1,
      anon_sym_COMMA,
    STATE(17066), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17514), 2,
      sym_block_comment,
      sym_line_comment,
  [378464] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8734), 1,
      anon_sym_RPAREN,
    ACTIONS(24372), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17515), 2,
      sym_block_comment,
      sym_line_comment,
  [378484] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7298), 1,
      anon_sym_RBRACE,
    ACTIONS(24374), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17516), 2,
      sym_block_comment,
      sym_line_comment,
  [378504] = 5,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(24376), 1,
      aux_sym__terminator_token1,
    ACTIONS(23555), 2,
      anon_sym_RBRACK,
      aux_sym__terminator_token2,
    STATE(17517), 2,
      sym_block_comment,
      sym_line_comment,
  [378522] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24378), 1,
      anon_sym_end,
    STATE(19212), 1,
      sym_finally_clause,
    STATE(17518), 2,
      sym_block_comment,
      sym_line_comment,
  [378542] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18958), 1,
      anon_sym_COMMA,
    ACTIONS(18960), 1,
      anon_sym_RBRACE,
    STATE(17087), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17519), 2,
      sym_block_comment,
      sym_line_comment,
  [378562] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7528), 1,
      anon_sym_RBRACE,
    ACTIONS(24380), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17520), 2,
      sym_block_comment,
      sym_line_comment,
  [378582] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8274), 1,
      anon_sym_RBRACE,
    ACTIONS(24382), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17521), 2,
      sym_block_comment,
      sym_line_comment,
  [378602] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21172), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19343), 1,
      sym_catch_clause,
    STATE(17522), 2,
      sym_block_comment,
      sym_line_comment,
  [378622] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24384), 1,
      sym__immediate_paren,
    ACTIONS(24386), 1,
      sym__immediate_bracket,
    ACTIONS(24388), 1,
      sym__immediate_brace,
    STATE(17523), 2,
      sym_block_comment,
      sym_line_comment,
  [378642] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21182), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19411), 1,
      sym_catch_clause,
    STATE(17524), 2,
      sym_block_comment,
      sym_line_comment,
  [378662] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24390), 1,
      anon_sym_LPAREN,
    STATE(9933), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17525), 2,
      sym_block_comment,
      sym_line_comment,
  [378680] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8368), 1,
      anon_sym_RBRACE,
    ACTIONS(24392), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17526), 2,
      sym_block_comment,
      sym_line_comment,
  [378700] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21178), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18824), 1,
      sym_catch_clause,
    STATE(17527), 2,
      sym_block_comment,
      sym_line_comment,
  [378720] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24394), 1,
      anon_sym_LPAREN,
    STATE(7736), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17528), 2,
      sym_block_comment,
      sym_line_comment,
  [378738] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7432), 1,
      anon_sym_RPAREN,
    ACTIONS(19382), 1,
      anon_sym_COMMA,
    STATE(17141), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17529), 2,
      sym_block_comment,
      sym_line_comment,
  [378758] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8712), 1,
      anon_sym_RPAREN,
    ACTIONS(24396), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17530), 2,
      sym_block_comment,
      sym_line_comment,
  [378778] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8534), 1,
      anon_sym_RPAREN,
    ACTIONS(24398), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17531), 2,
      sym_block_comment,
      sym_line_comment,
  [378798] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7000), 1,
      anon_sym_RBRACK,
    ACTIONS(24400), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17532), 2,
      sym_block_comment,
      sym_line_comment,
  [378818] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21178), 1,
      anon_sym_end,
    STATE(18824), 1,
      sym_finally_clause,
    STATE(17533), 2,
      sym_block_comment,
      sym_line_comment,
  [378838] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7768), 1,
      anon_sym_RBRACK,
    ACTIONS(24402), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17534), 2,
      sym_block_comment,
      sym_line_comment,
  [378858] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18985), 1,
      sym__comprehension_clause,
    STATE(17535), 2,
      sym_block_comment,
      sym_line_comment,
  [378878] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24404), 1,
      sym__immediate_paren,
    ACTIONS(24406), 1,
      sym__immediate_bracket,
    ACTIONS(24408), 1,
      sym__immediate_brace,
    STATE(17536), 2,
      sym_block_comment,
      sym_line_comment,
  [378898] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21107), 1,
      anon_sym_end,
    STATE(18290), 1,
      sym_finally_clause,
    STATE(17537), 2,
      sym_block_comment,
      sym_line_comment,
  [378918] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24410), 1,
      sym__word_identifier,
    ACTIONS(24412), 1,
      sym__immediate_paren,
    STATE(15446), 1,
      sym_identifier,
    STATE(17538), 2,
      sym_block_comment,
      sym_line_comment,
  [378938] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7004), 1,
      anon_sym_RBRACE,
    ACTIONS(24414), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17539), 2,
      sym_block_comment,
      sym_line_comment,
  [378958] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8150), 1,
      anon_sym_RPAREN,
    ACTIONS(24416), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17540), 2,
      sym_block_comment,
      sym_line_comment,
  [378978] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18792), 1,
      anon_sym_COMMA,
    ACTIONS(18794), 1,
      anon_sym_RBRACE,
    STATE(17520), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17541), 2,
      sym_block_comment,
      sym_line_comment,
  [378998] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7352), 1,
      anon_sym_RBRACE,
    ACTIONS(24418), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17542), 2,
      sym_block_comment,
      sym_line_comment,
  [379018] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21172), 1,
      anon_sym_end,
    STATE(19343), 1,
      sym_finally_clause,
    STATE(17543), 2,
      sym_block_comment,
      sym_line_comment,
  [379038] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19078), 1,
      anon_sym_COMMA,
    ACTIONS(19080), 1,
      anon_sym_RBRACE,
    STATE(17414), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17544), 2,
      sym_block_comment,
      sym_line_comment,
  [379058] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6992), 1,
      anon_sym_RBRACK,
    ACTIONS(24420), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17545), 2,
      sym_block_comment,
      sym_line_comment,
  [379078] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8070), 1,
      anon_sym_RPAREN,
    ACTIONS(24422), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17546), 2,
      sym_block_comment,
      sym_line_comment,
  [379098] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21127), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18972), 1,
      sym_catch_clause,
    STATE(17547), 2,
      sym_block_comment,
      sym_line_comment,
  [379118] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24424), 1,
      sym__immediate_paren,
    ACTIONS(24426), 1,
      sym__immediate_bracket,
    ACTIONS(24428), 1,
      sym__immediate_brace,
    STATE(17548), 2,
      sym_block_comment,
      sym_line_comment,
  [379138] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16328), 1,
      sym__word_identifier,
    STATE(7144), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17549), 2,
      sym_block_comment,
      sym_line_comment,
  [379156] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16294), 1,
      sym__word_identifier,
    STATE(6911), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17550), 2,
      sym_block_comment,
      sym_line_comment,
  [379174] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8440), 1,
      anon_sym_RPAREN,
    ACTIONS(24430), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17551), 2,
      sym_block_comment,
      sym_line_comment,
  [379194] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8484), 1,
      anon_sym_RPAREN,
    ACTIONS(18940), 1,
      anon_sym_COMMA,
    STATE(17173), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17552), 2,
      sym_block_comment,
      sym_line_comment,
  [379214] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19026), 1,
      anon_sym_COMMA,
    ACTIONS(19028), 1,
      anon_sym_RBRACE,
    STATE(17625), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17553), 2,
      sym_block_comment,
      sym_line_comment,
  [379234] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10840), 1,
      anon_sym_EQ,
    ACTIONS(17721), 1,
      anon_sym_COMMA,
    STATE(17554), 3,
      sym_block_comment,
      sym_line_comment,
      aux_sym_open_tuple_repeat1,
  [379252] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24432), 1,
      anon_sym_LPAREN,
    STATE(7823), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17555), 2,
      sym_block_comment,
      sym_line_comment,
  [379270] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18295), 1,
      sym__comprehension_clause,
    STATE(17556), 2,
      sym_block_comment,
      sym_line_comment,
  [379290] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18874), 1,
      anon_sym_COMMA,
    ACTIONS(18876), 1,
      anon_sym_RBRACE,
    STATE(17570), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17557), 2,
      sym_block_comment,
      sym_line_comment,
  [379310] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19454), 1,
      anon_sym_COMMA,
    ACTIONS(19456), 1,
      anon_sym_RBRACE,
    STATE(17593), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17558), 2,
      sym_block_comment,
      sym_line_comment,
  [379330] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24434), 1,
      anon_sym_LPAREN,
    STATE(8477), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17559), 2,
      sym_block_comment,
      sym_line_comment,
  [379348] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24436), 1,
      sym__immediate_paren,
    ACTIONS(24438), 1,
      sym__immediate_bracket,
    ACTIONS(24440), 1,
      sym__immediate_brace,
    STATE(17560), 2,
      sym_block_comment,
      sym_line_comment,
  [379368] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8308), 1,
      anon_sym_RPAREN,
    ACTIONS(18810), 1,
      anon_sym_COMMA,
    STATE(17590), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17561), 2,
      sym_block_comment,
      sym_line_comment,
  [379388] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17562), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24442), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [379404] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(12328), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17563), 2,
      sym_block_comment,
      sym_line_comment,
  [379422] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24444), 1,
      anon_sym_LPAREN,
    STATE(5861), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17564), 2,
      sym_block_comment,
      sym_line_comment,
  [379440] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6906), 1,
      anon_sym_RPAREN,
    ACTIONS(19408), 1,
      anon_sym_COMMA,
    STATE(17253), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17565), 2,
      sym_block_comment,
      sym_line_comment,
  [379460] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8310), 1,
      anon_sym_RBRACK,
    ACTIONS(24446), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17566), 2,
      sym_block_comment,
      sym_line_comment,
  [379480] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24448), 1,
      anon_sym_LPAREN,
    STATE(8962), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17567), 2,
      sym_block_comment,
      sym_line_comment,
  [379498] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8430), 1,
      anon_sym_RPAREN,
    ACTIONS(18912), 1,
      anon_sym_COMMA,
    STATE(17174), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17568), 2,
      sym_block_comment,
      sym_line_comment,
  [379518] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18878), 1,
      anon_sym_COMMA,
    ACTIONS(18880), 1,
      anon_sym_RBRACE,
    STATE(17078), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17569), 2,
      sym_block_comment,
      sym_line_comment,
  [379538] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8312), 1,
      anon_sym_RBRACE,
    ACTIONS(24450), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17570), 2,
      sym_block_comment,
      sym_line_comment,
  [379558] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19228), 1,
      anon_sym_COMMA,
    ACTIONS(19230), 1,
      anon_sym_RBRACE,
    STATE(17620), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17571), 2,
      sym_block_comment,
      sym_line_comment,
  [379578] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24452), 1,
      anon_sym_LPAREN,
    STATE(9968), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17572), 2,
      sym_block_comment,
      sym_line_comment,
  [379596] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19460), 1,
      anon_sym_COMMA,
    ACTIONS(19462), 1,
      anon_sym_RBRACE,
    STATE(17271), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17573), 2,
      sym_block_comment,
      sym_line_comment,
  [379616] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19438), 1,
      anon_sym_COMMA,
    ACTIONS(19440), 1,
      anon_sym_RBRACE,
    STATE(17204), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17574), 2,
      sym_block_comment,
      sym_line_comment,
  [379636] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8060), 1,
      anon_sym_RPAREN,
    ACTIONS(19394), 1,
      anon_sym_COMMA,
    STATE(17611), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17575), 2,
      sym_block_comment,
      sym_line_comment,
  [379656] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21085), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19280), 1,
      sym_catch_clause,
    STATE(17576), 2,
      sym_block_comment,
      sym_line_comment,
  [379676] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24454), 1,
      anon_sym_LPAREN,
    STATE(4520), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17577), 2,
      sym_block_comment,
      sym_line_comment,
  [379694] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7600), 1,
      anon_sym_RPAREN,
    ACTIONS(19452), 1,
      anon_sym_COMMA,
    STATE(17551), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17578), 2,
      sym_block_comment,
      sym_line_comment,
  [379714] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21129), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(19581), 1,
      sym_catch_clause,
    STATE(17579), 2,
      sym_block_comment,
      sym_line_comment,
  [379734] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24456), 1,
      anon_sym_LPAREN,
    STATE(4518), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17580), 2,
      sym_block_comment,
      sym_line_comment,
  [379752] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24458), 1,
      anon_sym_LPAREN,
    STATE(15595), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17581), 2,
      sym_block_comment,
      sym_line_comment,
  [379770] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7150), 1,
      anon_sym_RPAREN,
    ACTIONS(19320), 1,
      anon_sym_COMMA,
    STATE(17642), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17582), 2,
      sym_block_comment,
      sym_line_comment,
  [379790] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8062), 1,
      anon_sym_RBRACK,
    ACTIONS(24460), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17583), 2,
      sym_block_comment,
      sym_line_comment,
  [379810] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8626), 1,
      anon_sym_RPAREN,
    ACTIONS(19014), 1,
      anon_sym_COMMA,
    STATE(17070), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17584), 2,
      sym_block_comment,
      sym_line_comment,
  [379830] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24462), 1,
      sym__immediate_paren,
    ACTIONS(24464), 1,
      sym__immediate_bracket,
    ACTIONS(24466), 1,
      sym__immediate_brace,
    STATE(17585), 2,
      sym_block_comment,
      sym_line_comment,
  [379850] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16496), 1,
      sym__word_identifier,
    STATE(6886), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17586), 2,
      sym_block_comment,
      sym_line_comment,
  [379868] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7110), 1,
      anon_sym_RPAREN,
    ACTIONS(19376), 1,
      anon_sym_COMMA,
    STATE(17499), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17587), 2,
      sym_block_comment,
      sym_line_comment,
  [379888] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19314), 1,
      anon_sym_COMMA,
    ACTIONS(19316), 1,
      anon_sym_RBRACE,
    STATE(17434), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17588), 2,
      sym_block_comment,
      sym_line_comment,
  [379908] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19422), 1,
      anon_sym_COMMA,
    ACTIONS(19424), 1,
      anon_sym_RBRACE,
    STATE(17407), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17589), 2,
      sym_block_comment,
      sym_line_comment,
  [379928] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8714), 1,
      anon_sym_RPAREN,
    ACTIONS(24468), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17590), 2,
      sym_block_comment,
      sym_line_comment,
  [379948] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24470), 1,
      anon_sym_LPAREN,
    STATE(4648), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17591), 2,
      sym_block_comment,
      sym_line_comment,
  [379966] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24472), 1,
      anon_sym_LPAREN,
    STATE(4922), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17592), 2,
      sym_block_comment,
      sym_line_comment,
  [379984] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8064), 1,
      anon_sym_RBRACE,
    ACTIONS(24474), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17593), 2,
      sym_block_comment,
      sym_line_comment,
  [380004] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24478), 1,
      anon_sym_else,
    ACTIONS(24476), 2,
      anon_sym_end,
      anon_sym_elseif,
    STATE(17594), 2,
      sym_block_comment,
      sym_line_comment,
  [380022] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21164), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18381), 1,
      sym_catch_clause,
    STATE(17595), 2,
      sym_block_comment,
      sym_line_comment,
  [380042] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18984), 1,
      anon_sym_COMMA,
    ACTIONS(18986), 1,
      anon_sym_RBRACE,
    STATE(17096), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17596), 2,
      sym_block_comment,
      sym_line_comment,
  [380062] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19120), 1,
      anon_sym_COMMA,
    ACTIONS(19122), 1,
      anon_sym_RBRACE,
    STATE(17168), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17597), 2,
      sym_block_comment,
      sym_line_comment,
  [380082] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8432), 1,
      anon_sym_RBRACK,
    ACTIONS(24480), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17598), 2,
      sym_block_comment,
      sym_line_comment,
  [380102] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8628), 1,
      anon_sym_RBRACK,
    ACTIONS(24482), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17599), 2,
      sym_block_comment,
      sym_line_comment,
  [380122] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18956), 1,
      sym__comprehension_clause,
    STATE(17600), 2,
      sym_block_comment,
      sym_line_comment,
  [380142] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24484), 1,
      sym__immediate_paren,
    ACTIONS(24486), 1,
      sym__immediate_bracket,
    ACTIONS(24488), 1,
      sym__immediate_brace,
    STATE(17601), 2,
      sym_block_comment,
      sym_line_comment,
  [380162] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(24490), 1,
      anon_sym_end,
    STATE(19593), 1,
      sym_finally_clause,
    STATE(17602), 2,
      sym_block_comment,
      sym_line_comment,
  [380182] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7396), 1,
      anon_sym_RPAREN,
    ACTIONS(24492), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17603), 2,
      sym_block_comment,
      sym_line_comment,
  [380202] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24494), 1,
      sym__immediate_paren,
    ACTIONS(24496), 1,
      sym__immediate_bracket,
    ACTIONS(24498), 1,
      sym__immediate_brace,
    STATE(17604), 2,
      sym_block_comment,
      sym_line_comment,
  [380222] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24500), 1,
      anon_sym_LPAREN,
    STATE(7543), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17605), 2,
      sym_block_comment,
      sym_line_comment,
  [380240] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18886), 1,
      anon_sym_COMMA,
    ACTIONS(18888), 1,
      anon_sym_RBRACE,
    STATE(17619), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17606), 2,
      sym_block_comment,
      sym_line_comment,
  [380260] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24502), 1,
      sym__immediate_paren,
    ACTIONS(24504), 1,
      sym__immediate_bracket,
    ACTIONS(24506), 1,
      sym__immediate_brace,
    STATE(17607), 2,
      sym_block_comment,
      sym_line_comment,
  [380280] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24508), 1,
      anon_sym_LPAREN,
    STATE(17608), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(17978), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
  [380298] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21089), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18305), 1,
      sym_catch_clause,
    STATE(17609), 2,
      sym_block_comment,
      sym_line_comment,
  [380318] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7160), 1,
      anon_sym_RPAREN,
    ACTIONS(24510), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17610), 2,
      sym_block_comment,
      sym_line_comment,
  [380338] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8698), 1,
      anon_sym_RPAREN,
    ACTIONS(24512), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17611), 2,
      sym_block_comment,
      sym_line_comment,
  [380358] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17612), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24514), 3,
      sym__content_cmd_1_raw,
      sym__end_cmd,
      sym_escape_sequence,
  [380374] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8328), 1,
      anon_sym_RPAREN,
    ACTIONS(18956), 1,
      anon_sym_COMMA,
    STATE(17626), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17613), 2,
      sym_block_comment,
      sym_line_comment,
  [380394] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7152), 1,
      anon_sym_RBRACK,
    ACTIONS(24516), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17614), 2,
      sym_block_comment,
      sym_line_comment,
  [380414] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21085), 1,
      anon_sym_end,
    STATE(19280), 1,
      sym_finally_clause,
    STATE(17615), 2,
      sym_block_comment,
      sym_line_comment,
  [380434] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8330), 1,
      anon_sym_RBRACK,
    ACTIONS(24518), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17616), 2,
      sym_block_comment,
      sym_line_comment,
  [380454] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18625), 1,
      sym__comprehension_clause,
    STATE(17617), 2,
      sym_block_comment,
      sym_line_comment,
  [380474] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24520), 1,
      sym__immediate_paren,
    ACTIONS(24522), 1,
      sym__immediate_bracket,
    ACTIONS(24524), 1,
      sym__immediate_brace,
    STATE(17618), 2,
      sym_block_comment,
      sym_line_comment,
  [380494] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8332), 1,
      anon_sym_RBRACE,
    ACTIONS(24526), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17619), 2,
      sym_block_comment,
      sym_line_comment,
  [380514] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7154), 1,
      anon_sym_RBRACE,
    ACTIONS(24528), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17620), 2,
      sym_block_comment,
      sym_line_comment,
  [380534] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24530), 1,
      sym__immediate_paren,
    ACTIONS(24532), 1,
      sym__immediate_bracket,
    ACTIONS(24534), 1,
      sym__immediate_brace,
    STATE(17621), 2,
      sym_block_comment,
      sym_line_comment,
  [380554] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24536), 1,
      sym__immediate_paren,
    ACTIONS(24538), 1,
      sym__immediate_bracket,
    ACTIONS(24540), 1,
      sym__immediate_brace,
    STATE(17622), 2,
      sym_block_comment,
      sym_line_comment,
  [380574] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(13118), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17623), 2,
      sym_block_comment,
      sym_line_comment,
  [380592] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24542), 1,
      anon_sym_LPAREN,
    STATE(6273), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17624), 2,
      sym_block_comment,
      sym_line_comment,
  [380610] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8630), 1,
      anon_sym_RBRACE,
    ACTIONS(24544), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17625), 2,
      sym_block_comment,
      sym_line_comment,
  [380630] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8716), 1,
      anon_sym_RPAREN,
    ACTIONS(24546), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17626), 2,
      sym_block_comment,
      sym_line_comment,
  [380650] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(19152), 1,
      sym__comprehension_clause,
    STATE(17627), 2,
      sym_block_comment,
      sym_line_comment,
  [380670] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16340), 1,
      sym__word_identifier,
    STATE(8905), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17628), 2,
      sym_block_comment,
      sym_line_comment,
  [380688] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21154), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18617), 1,
      sym_catch_clause,
    STATE(17629), 2,
      sym_block_comment,
      sym_line_comment,
  [380708] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24548), 1,
      sym__immediate_paren,
    ACTIONS(24550), 1,
      sym__immediate_bracket,
    ACTIONS(24552), 1,
      sym__immediate_brace,
    STATE(17630), 2,
      sym_block_comment,
      sym_line_comment,
  [380728] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21152), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18446), 1,
      sym_catch_clause,
    STATE(17631), 2,
      sym_block_comment,
      sym_line_comment,
  [380748] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19448), 1,
      anon_sym_COMMA,
    ACTIONS(19450), 1,
      anon_sym_RBRACE,
    STATE(17662), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17632), 2,
      sym_block_comment,
      sym_line_comment,
  [380768] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24554), 1,
      sym__immediate_paren,
    ACTIONS(24556), 1,
      sym__immediate_bracket,
    ACTIONS(24558), 1,
      sym__immediate_brace,
    STATE(17633), 2,
      sym_block_comment,
      sym_line_comment,
  [380788] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24560), 1,
      anon_sym_LPAREN,
    STATE(4294), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17634), 2,
      sym_block_comment,
      sym_line_comment,
  [380806] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16314), 1,
      sym__word_identifier,
    STATE(11736), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17635), 2,
      sym_block_comment,
      sym_line_comment,
  [380824] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7390), 1,
      anon_sym_RBRACK,
    ACTIONS(24562), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17636), 2,
      sym_block_comment,
      sym_line_comment,
  [380844] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21152), 1,
      anon_sym_end,
    STATE(18446), 1,
      sym_finally_clause,
    STATE(17637), 2,
      sym_block_comment,
      sym_line_comment,
  [380864] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8486), 1,
      anon_sym_RBRACK,
    ACTIONS(24564), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17638), 2,
      sym_block_comment,
      sym_line_comment,
  [380884] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18285), 1,
      sym__comprehension_clause,
    STATE(17639), 2,
      sym_block_comment,
      sym_line_comment,
  [380904] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18902), 1,
      anon_sym_COMMA,
    ACTIONS(18904), 1,
      anon_sym_RBRACE,
    STATE(17164), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17640), 2,
      sym_block_comment,
      sym_line_comment,
  [380924] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24566), 1,
      sym__immediate_paren,
    ACTIONS(24568), 1,
      sym__immediate_bracket,
    ACTIONS(24570), 1,
      sym__immediate_brace,
    STATE(17641), 2,
      sym_block_comment,
      sym_line_comment,
  [380944] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7714), 1,
      anon_sym_RPAREN,
    ACTIONS(24572), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17642), 2,
      sym_block_comment,
      sym_line_comment,
  [380964] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18758), 1,
      anon_sym_COMMA,
    ACTIONS(18760), 1,
      anon_sym_RBRACE,
    STATE(17117), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17643), 2,
      sym_block_comment,
      sym_line_comment,
  [380984] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24574), 1,
      sym__immediate_paren,
    ACTIONS(24576), 1,
      sym__immediate_bracket,
    ACTIONS(24578), 1,
      sym__immediate_brace,
    STATE(17644), 2,
      sym_block_comment,
      sym_line_comment,
  [381004] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24580), 1,
      anon_sym_LPAREN,
    STATE(6384), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17645), 2,
      sym_block_comment,
      sym_line_comment,
  [381022] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7332), 1,
      anon_sym_RPAREN,
    ACTIONS(19286), 1,
      anon_sym_COMMA,
    STATE(17540), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17646), 2,
      sym_block_comment,
      sym_line_comment,
  [381042] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8396), 1,
      anon_sym_RPAREN,
    ACTIONS(24582), 1,
      anon_sym_COMMA,
    STATE(17388), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17647), 2,
      sym_block_comment,
      sym_line_comment,
  [381062] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18906), 1,
      anon_sym_COMMA,
    ACTIONS(18908), 1,
      anon_sym_RBRACE,
    STATE(17405), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17648), 2,
      sym_block_comment,
      sym_line_comment,
  [381082] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21186), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18491), 1,
      sym_catch_clause,
    STATE(17649), 2,
      sym_block_comment,
      sym_line_comment,
  [381102] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21186), 1,
      anon_sym_end,
    STATE(18491), 1,
      sym_finally_clause,
    STATE(17650), 2,
      sym_block_comment,
      sym_line_comment,
  [381122] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8546), 1,
      anon_sym_RPAREN,
    ACTIONS(18974), 1,
      anon_sym_COMMA,
    STATE(17154), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17651), 2,
      sym_block_comment,
      sym_line_comment,
  [381142] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10833), 1,
      anon_sym_EQ,
    ACTIONS(17476), 1,
      anon_sym_COMMA,
    STATE(17554), 1,
      aux_sym_open_tuple_repeat1,
    STATE(17652), 2,
      sym_block_comment,
      sym_line_comment,
  [381162] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24584), 1,
      anon_sym_LPAREN,
    STATE(7730), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17653), 2,
      sym_block_comment,
      sym_line_comment,
  [381180] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21154), 1,
      anon_sym_end,
    STATE(18617), 1,
      sym_finally_clause,
    STATE(17654), 2,
      sym_block_comment,
      sym_line_comment,
  [381200] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19950), 1,
      anon_sym_for,
    STATE(14271), 1,
      sym_for_clause,
    STATE(18501), 1,
      sym__comprehension_clause,
    STATE(17655), 2,
      sym_block_comment,
      sym_line_comment,
  [381220] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19220), 1,
      anon_sym_COMMA,
    ACTIONS(19222), 1,
      anon_sym_RBRACE,
    STATE(17295), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17656), 2,
      sym_block_comment,
      sym_line_comment,
  [381240] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21180), 1,
      anon_sym_end,
    ACTIONS(23799), 1,
      anon_sym_catch,
    STATE(18582), 1,
      sym_catch_clause,
    STATE(17657), 2,
      sym_block_comment,
      sym_line_comment,
  [381260] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(12007), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17658), 2,
      sym_block_comment,
      sym_line_comment,
  [381278] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24586), 1,
      anon_sym_LPAREN,
    STATE(11043), 2,
      sym_parenthesized_expression,
      sym_tuple_expression,
    STATE(17659), 2,
      sym_block_comment,
      sym_line_comment,
  [381296] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21083), 1,
      anon_sym_finally,
    ACTIONS(21180), 1,
      anon_sym_end,
    STATE(18582), 1,
      sym_finally_clause,
    STATE(17660), 2,
      sym_block_comment,
      sym_line_comment,
  [381316] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24588), 1,
      sym__immediate_paren,
    ACTIONS(24590), 1,
      sym__immediate_bracket,
    ACTIONS(24592), 1,
      sym__immediate_brace,
    STATE(17661), 2,
      sym_block_comment,
      sym_line_comment,
  [381336] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7336), 1,
      anon_sym_RBRACE,
    ACTIONS(24594), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17662), 2,
      sym_block_comment,
      sym_line_comment,
  [381356] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8344), 1,
      anon_sym_RPAREN,
    ACTIONS(18862), 1,
      anon_sym_COMMA,
    STATE(17345), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17663), 2,
      sym_block_comment,
      sym_line_comment,
  [381376] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17664), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(19174), 3,
      anon_sym_for,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [381392] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18934), 1,
      anon_sym_COMMA,
    ACTIONS(18936), 1,
      anon_sym_RBRACE,
    STATE(17291), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17665), 2,
      sym_block_comment,
      sym_line_comment,
  [381412] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8346), 1,
      anon_sym_RBRACK,
    ACTIONS(24596), 1,
      anon_sym_COMMA,
    STATE(16954), 1,
      aux_sym_vector_expression_repeat1,
    STATE(17666), 2,
      sym_block_comment,
      sym_line_comment,
  [381432] = 6,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24598), 1,
      sym__immediate_paren,
    ACTIONS(24600), 1,
      sym__immediate_bracket,
    ACTIONS(24602), 1,
      sym__immediate_brace,
    STATE(17667), 2,
      sym_block_comment,
      sym_line_comment,
  [381452] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(12369), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17668), 2,
      sym_block_comment,
      sym_line_comment,
  [381470] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11995), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17669), 2,
      sym_block_comment,
      sym_line_comment,
  [381488] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(11743), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17670), 2,
      sym_block_comment,
      sym_line_comment,
  [381506] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16392), 1,
      sym__word_identifier,
    STATE(12003), 2,
      sym_scoped_identifier,
      sym_identifier,
    STATE(17671), 2,
      sym_block_comment,
      sym_line_comment,
  [381524] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    STATE(17672), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(24604), 3,
      sym__content_str_3_raw,
      sym__end_str,
      sym_escape_sequence,
  [381540] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24606), 1,
      anon_sym_LPAREN,
    STATE(4118), 1,
      sym_argument_list,
    STATE(17673), 2,
      sym_block_comment,
      sym_line_comment,
  [381557] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15974), 1,
      anon_sym_LBRACE,
    STATE(7736), 1,
      sym_curly_expression,
    STATE(17674), 2,
      sym_block_comment,
      sym_line_comment,
  [381574] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16905), 1,
      anon_sym_COMMA,
    STATE(14977), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17675), 2,
      sym_block_comment,
      sym_line_comment,
  [381591] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8584), 1,
      anon_sym_RPAREN,
    ACTIONS(24608), 1,
      anon_sym_SEMI,
    STATE(17676), 2,
      sym_block_comment,
      sym_line_comment,
  [381608] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17045), 1,
      anon_sym_COMMA,
    STATE(14495), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17677), 2,
      sym_block_comment,
      sym_line_comment,
  [381625] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10054), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17678), 2,
      sym_block_comment,
      sym_line_comment,
  [381640] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16676), 1,
      anon_sym_COMMA,
    STATE(14644), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17679), 2,
      sym_block_comment,
      sym_line_comment,
  [381657] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24610), 1,
      anon_sym_LPAREN,
    STATE(4972), 1,
      sym_argument_list,
    STATE(17680), 2,
      sym_block_comment,
      sym_line_comment,
  [381674] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8426), 1,
      anon_sym_RPAREN,
    ACTIONS(24612), 1,
      anon_sym_SEMI,
    STATE(17681), 2,
      sym_block_comment,
      sym_line_comment,
  [381691] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10058), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17682), 2,
      sym_block_comment,
      sym_line_comment,
  [381706] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17109), 1,
      anon_sym_COMMA,
    STATE(14842), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17683), 2,
      sym_block_comment,
      sym_line_comment,
  [381723] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16772), 1,
      anon_sym_COMMA,
    STATE(14281), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17684), 2,
      sym_block_comment,
      sym_line_comment,
  [381740] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24614), 1,
      anon_sym_LPAREN,
    STATE(5610), 1,
      sym_argument_list,
    STATE(17685), 2,
      sym_block_comment,
      sym_line_comment,
  [381757] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16022), 1,
      anon_sym_LBRACE,
    STATE(6617), 1,
      sym_curly_expression,
    STATE(17686), 2,
      sym_block_comment,
      sym_line_comment,
  [381774] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16893), 1,
      anon_sym_COMMA,
    STATE(14469), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17687), 2,
      sym_block_comment,
      sym_line_comment,
  [381791] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1293), 1,
      anon_sym_LBRACE,
    STATE(5769), 1,
      sym_curly_expression,
    STATE(17688), 2,
      sym_block_comment,
      sym_line_comment,
  [381808] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9900), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17689), 2,
      sym_block_comment,
      sym_line_comment,
  [381823] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16961), 1,
      anon_sym_COMMA,
    STATE(14522), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17690), 2,
      sym_block_comment,
      sym_line_comment,
  [381840] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8614), 1,
      anon_sym_RPAREN,
    ACTIONS(24616), 1,
      anon_sym_SEMI,
    STATE(17691), 2,
      sym_block_comment,
      sym_line_comment,
  [381857] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17061), 1,
      anon_sym_COMMA,
    STATE(14592), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17692), 2,
      sym_block_comment,
      sym_line_comment,
  [381874] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16818), 1,
      anon_sym_COMMA,
    STATE(14713), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17693), 2,
      sym_block_comment,
      sym_line_comment,
  [381891] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    STATE(9910), 1,
      sym_curly_expression,
    STATE(17694), 2,
      sym_block_comment,
      sym_line_comment,
  [381908] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8342), 1,
      anon_sym_RPAREN,
    ACTIONS(24618), 1,
      anon_sym_SEMI,
    STATE(17695), 2,
      sym_block_comment,
      sym_line_comment,
  [381925] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16953), 1,
      anon_sym_COMMA,
    STATE(14804), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17696), 2,
      sym_block_comment,
      sym_line_comment,
  [381942] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17029), 1,
      anon_sym_COMMA,
    STATE(14896), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17697), 2,
      sym_block_comment,
      sym_line_comment,
  [381959] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10062), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17698), 2,
      sym_block_comment,
      sym_line_comment,
  [381974] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24620), 1,
      anon_sym_LPAREN,
    STATE(5030), 1,
      sym_argument_list,
    STATE(17699), 2,
      sym_block_comment,
      sym_line_comment,
  [381991] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17103), 1,
      anon_sym_COMMA,
    STATE(14969), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17700), 2,
      sym_block_comment,
      sym_line_comment,
  [382008] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16899), 1,
      anon_sym_COMMA,
    STATE(15026), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17701), 2,
      sym_block_comment,
      sym_line_comment,
  [382025] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7410), 1,
      anon_sym_RPAREN,
    ACTIONS(24622), 1,
      anon_sym_SEMI,
    STATE(17702), 2,
      sym_block_comment,
      sym_line_comment,
  [382042] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24624), 1,
      anon_sym_LPAREN,
    STATE(4256), 1,
      sym_argument_list,
    STATE(17703), 2,
      sym_block_comment,
      sym_line_comment,
  [382059] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16780), 1,
      anon_sym_COMMA,
    STATE(15064), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17704), 2,
      sym_block_comment,
      sym_line_comment,
  [382076] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17067), 1,
      anon_sym_COMMA,
    STATE(14363), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17705), 2,
      sym_block_comment,
      sym_line_comment,
  [382093] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8494), 1,
      anon_sym_RPAREN,
    ACTIONS(24626), 1,
      anon_sym_SEMI,
    STATE(17706), 2,
      sym_block_comment,
      sym_line_comment,
  [382110] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10066), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17707), 2,
      sym_block_comment,
      sym_line_comment,
  [382125] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16764), 1,
      anon_sym_COMMA,
    STATE(14344), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17708), 2,
      sym_block_comment,
      sym_line_comment,
  [382142] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16110), 1,
      anon_sym_LBRACE,
    STATE(8962), 1,
      sym_curly_expression,
    STATE(17709), 2,
      sym_block_comment,
      sym_line_comment,
  [382159] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16929), 1,
      anon_sym_COMMA,
    STATE(14681), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17710), 2,
      sym_block_comment,
      sym_line_comment,
  [382176] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8602), 1,
      anon_sym_RPAREN,
    ACTIONS(24628), 1,
      anon_sym_SEMI,
    STATE(17711), 2,
      sym_block_comment,
      sym_line_comment,
  [382193] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    STATE(9798), 1,
      sym_curly_expression,
    STATE(17712), 2,
      sym_block_comment,
      sym_line_comment,
  [382210] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17203), 1,
      anon_sym_COMMA,
    STATE(14893), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17713), 2,
      sym_block_comment,
      sym_line_comment,
  [382227] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13890), 1,
      anon_sym_LBRACE,
    STATE(5680), 1,
      sym_curly_expression,
    STATE(17714), 2,
      sym_block_comment,
      sym_line_comment,
  [382244] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24624), 1,
      anon_sym_LPAREN,
    STATE(4429), 1,
      sym_argument_list,
    STATE(17715), 2,
      sym_block_comment,
      sym_line_comment,
  [382261] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16792), 1,
      anon_sym_COMMA,
    STATE(14315), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17716), 2,
      sym_block_comment,
      sym_line_comment,
  [382278] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17097), 1,
      anon_sym_COMMA,
    STATE(14486), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17717), 2,
      sym_block_comment,
      sym_line_comment,
  [382295] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8292), 1,
      anon_sym_LBRACE,
    STATE(4627), 1,
      sym_curly_expression,
    STATE(17718), 2,
      sym_block_comment,
      sym_line_comment,
  [382312] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10070), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17719), 2,
      sym_block_comment,
      sym_line_comment,
  [382327] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16806), 1,
      anon_sym_COMMA,
    STATE(14666), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17720), 2,
      sym_block_comment,
      sym_line_comment,
  [382344] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24630), 1,
      anon_sym_LPAREN,
    STATE(4170), 1,
      sym_argument_list,
    STATE(17721), 2,
      sym_block_comment,
      sym_line_comment,
  [382361] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16824), 1,
      anon_sym_COMMA,
    STATE(14783), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17722), 2,
      sym_block_comment,
      sym_line_comment,
  [382378] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10074), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17723), 2,
      sym_block_comment,
      sym_line_comment,
  [382393] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16842), 1,
      anon_sym_COMMA,
    STATE(14881), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17724), 2,
      sym_block_comment,
      sym_line_comment,
  [382410] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24632), 1,
      anon_sym_LPAREN,
    STATE(4956), 1,
      sym_argument_list,
    STATE(17725), 2,
      sym_block_comment,
      sym_line_comment,
  [382427] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17187), 1,
      anon_sym_COMMA,
    STATE(14937), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17726), 2,
      sym_block_comment,
      sym_line_comment,
  [382444] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10078), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17727), 2,
      sym_block_comment,
      sym_line_comment,
  [382459] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10082), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17728), 2,
      sym_block_comment,
      sym_line_comment,
  [382474] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16865), 1,
      anon_sym_COMMA,
    STATE(15024), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17729), 2,
      sym_block_comment,
      sym_line_comment,
  [382491] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24614), 1,
      anon_sym_LPAREN,
    STATE(5614), 1,
      sym_argument_list,
    STATE(17730), 2,
      sym_block_comment,
      sym_line_comment,
  [382508] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24634), 1,
      anon_sym_LPAREN,
    STATE(4681), 1,
      sym_argument_list,
    STATE(17731), 2,
      sym_block_comment,
      sym_line_comment,
  [382525] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16911), 1,
      anon_sym_COMMA,
    STATE(14304), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17732), 2,
      sym_block_comment,
      sym_line_comment,
  [382542] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    STATE(5093), 1,
      sym_curly_expression,
    STATE(17733), 2,
      sym_block_comment,
      sym_line_comment,
  [382559] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16971), 1,
      anon_sym_COMMA,
    STATE(14331), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17734), 2,
      sym_block_comment,
      sym_line_comment,
  [382576] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8634), 1,
      anon_sym_RPAREN,
    ACTIONS(24636), 1,
      anon_sym_SEMI,
    STATE(17735), 2,
      sym_block_comment,
      sym_line_comment,
  [382593] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13502), 1,
      anon_sym_LBRACE,
    STATE(6399), 1,
      sym_curly_expression,
    STATE(17736), 2,
      sym_block_comment,
      sym_line_comment,
  [382610] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17039), 1,
      anon_sym_COMMA,
    STATE(14350), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17737), 2,
      sym_block_comment,
      sym_line_comment,
  [382627] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17051), 1,
      anon_sym_COMMA,
    STATE(14370), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17738), 2,
      sym_block_comment,
      sym_line_comment,
  [382644] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14652), 1,
      anon_sym_LBRACE,
    STATE(7063), 1,
      sym_curly_expression,
    STATE(17739), 2,
      sym_block_comment,
      sym_line_comment,
  [382661] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17085), 1,
      anon_sym_COMMA,
    STATE(14397), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17740), 2,
      sym_block_comment,
      sym_line_comment,
  [382678] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17135), 1,
      anon_sym_COMMA,
    STATE(14425), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17741), 2,
      sym_block_comment,
      sym_line_comment,
  [382695] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17167), 1,
      anon_sym_COMMA,
    STATE(14465), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17742), 2,
      sym_block_comment,
      sym_line_comment,
  [382712] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7364), 1,
      anon_sym_RPAREN,
    ACTIONS(24638), 1,
      anon_sym_SEMI,
    STATE(17743), 2,
      sym_block_comment,
      sym_line_comment,
  [382729] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17195), 1,
      anon_sym_COMMA,
    STATE(14503), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17744), 2,
      sym_block_comment,
      sym_line_comment,
  [382746] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17209), 1,
      anon_sym_COMMA,
    STATE(14541), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17745), 2,
      sym_block_comment,
      sym_line_comment,
  [382763] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24614), 1,
      anon_sym_LPAREN,
    STATE(5608), 1,
      sym_argument_list,
    STATE(17746), 2,
      sym_block_comment,
      sym_line_comment,
  [382780] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6890), 1,
      anon_sym_LBRACE,
    STATE(4924), 1,
      sym_curly_expression,
    STATE(17747), 2,
      sym_block_comment,
      sym_line_comment,
  [382797] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17230), 1,
      anon_sym_COMMA,
    STATE(14566), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17748), 2,
      sym_block_comment,
      sym_line_comment,
  [382814] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24640), 1,
      anon_sym_LPAREN,
    STATE(4928), 1,
      sym_argument_list,
    STATE(17749), 2,
      sym_block_comment,
      sym_line_comment,
  [382831] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17141), 1,
      anon_sym_COMMA,
    STATE(14595), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17750), 2,
      sym_block_comment,
      sym_line_comment,
  [382848] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17121), 1,
      anon_sym_COMMA,
    STATE(14640), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17751), 2,
      sym_block_comment,
      sym_line_comment,
  [382865] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9664), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17752), 2,
      sym_block_comment,
      sym_line_comment,
  [382880] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16947), 1,
      anon_sym_COMMA,
    STATE(14680), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17753), 2,
      sym_block_comment,
      sym_line_comment,
  [382897] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17181), 1,
      anon_sym_COMMA,
    STATE(14328), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17754), 2,
      sym_block_comment,
      sym_line_comment,
  [382914] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16856), 1,
      anon_sym_COMMA,
    STATE(14730), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17755), 2,
      sym_block_comment,
      sym_line_comment,
  [382931] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24642), 1,
      anon_sym_LPAREN,
    STATE(4155), 1,
      sym_argument_list,
    STATE(17756), 2,
      sym_block_comment,
      sym_line_comment,
  [382948] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7960), 1,
      anon_sym_LBRACE,
    STATE(4518), 1,
      sym_curly_expression,
    STATE(17757), 2,
      sym_block_comment,
      sym_line_comment,
  [382965] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24606), 1,
      anon_sym_LPAREN,
    STATE(4136), 1,
      sym_argument_list,
    STATE(17758), 2,
      sym_block_comment,
      sym_line_comment,
  [382982] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16875), 1,
      anon_sym_COMMA,
    STATE(14754), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17759), 2,
      sym_block_comment,
      sym_line_comment,
  [382999] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13890), 1,
      anon_sym_LBRACE,
    STATE(5691), 1,
      sym_curly_expression,
    STATE(17760), 2,
      sym_block_comment,
      sym_line_comment,
  [383016] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24644), 1,
      anon_sym_LPAREN,
    STATE(4902), 1,
      sym_argument_list,
    STATE(17761), 2,
      sym_block_comment,
      sym_line_comment,
  [383033] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14456), 1,
      anon_sym_LBRACE,
    STATE(5693), 1,
      sym_curly_expression,
    STATE(17762), 2,
      sym_block_comment,
      sym_line_comment,
  [383050] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24644), 1,
      anon_sym_LPAREN,
    STATE(4910), 1,
      sym_argument_list,
    STATE(17763), 2,
      sym_block_comment,
      sym_line_comment,
  [383067] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(4734), 1,
      sym_curly_expression,
    STATE(17764), 2,
      sym_block_comment,
      sym_line_comment,
  [383084] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14456), 1,
      anon_sym_LBRACE,
    STATE(5695), 1,
      sym_curly_expression,
    STATE(17765), 2,
      sym_block_comment,
      sym_line_comment,
  [383101] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8418), 1,
      anon_sym_RPAREN,
    ACTIONS(24646), 1,
      anon_sym_SEMI,
    STATE(17766), 2,
      sym_block_comment,
      sym_line_comment,
  [383118] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14970), 1,
      anon_sym_LBRACE,
    STATE(6088), 1,
      sym_curly_expression,
    STATE(17767), 2,
      sym_block_comment,
      sym_line_comment,
  [383135] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8622), 1,
      anon_sym_RPAREN,
    ACTIONS(24648), 1,
      anon_sym_SEMI,
    STATE(17768), 2,
      sym_block_comment,
      sym_line_comment,
  [383152] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24650), 1,
      anon_sym_LPAREN,
    STATE(4891), 1,
      sym_argument_list,
    STATE(17769), 2,
      sym_block_comment,
      sym_line_comment,
  [383169] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14842), 1,
      anon_sym_LBRACE,
    STATE(5779), 1,
      sym_curly_expression,
    STATE(17770), 2,
      sym_block_comment,
      sym_line_comment,
  [383186] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24652), 1,
      anon_sym_LPAREN,
    STATE(4869), 1,
      sym_argument_list,
    STATE(17771), 2,
      sym_block_comment,
      sym_line_comment,
  [383203] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7466), 1,
      anon_sym_RPAREN,
    ACTIONS(24654), 1,
      anon_sym_SEMI,
    STATE(17772), 2,
      sym_block_comment,
      sym_line_comment,
  [383220] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    STATE(5781), 1,
      sym_curly_expression,
    STATE(17773), 2,
      sym_block_comment,
      sym_line_comment,
  [383237] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24652), 1,
      anon_sym_LPAREN,
    STATE(4871), 1,
      sym_argument_list,
    STATE(17774), 2,
      sym_block_comment,
      sym_line_comment,
  [383254] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24656), 1,
      anon_sym_LPAREN,
    STATE(9738), 1,
      sym_argument_list,
    STATE(17775), 2,
      sym_block_comment,
      sym_line_comment,
  [383271] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24658), 1,
      anon_sym_LPAREN,
    STATE(5204), 1,
      sym_argument_list,
    STATE(17776), 2,
      sym_block_comment,
      sym_line_comment,
  [383288] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9734), 1,
      anon_sym_RPAREN,
    ACTIONS(24660), 1,
      aux_sym_float_literal_token2,
    STATE(17777), 2,
      sym_block_comment,
      sym_line_comment,
  [383305] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13220), 1,
      anon_sym_LBRACE,
    STATE(6501), 1,
      sym_curly_expression,
    STATE(17778), 2,
      sym_block_comment,
      sym_line_comment,
  [383322] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    STATE(5784), 1,
      sym_curly_expression,
    STATE(17779), 2,
      sym_block_comment,
      sym_line_comment,
  [383339] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9984), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17780), 2,
      sym_block_comment,
      sym_line_comment,
  [383354] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8292), 1,
      anon_sym_LBRACE,
    STATE(4675), 1,
      sym_curly_expression,
    STATE(17781), 2,
      sym_block_comment,
      sym_line_comment,
  [383371] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9988), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17782), 2,
      sym_block_comment,
      sym_line_comment,
  [383386] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24634), 1,
      anon_sym_LPAREN,
    STATE(4676), 1,
      sym_argument_list,
    STATE(17783), 2,
      sym_block_comment,
      sym_line_comment,
  [383403] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7780), 1,
      anon_sym_RPAREN,
    ACTIONS(24662), 1,
      anon_sym_SEMI,
    STATE(17784), 2,
      sym_block_comment,
      sym_line_comment,
  [383420] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24630), 1,
      anon_sym_LPAREN,
    STATE(4163), 1,
      sym_argument_list,
    STATE(17785), 2,
      sym_block_comment,
      sym_line_comment,
  [383437] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15026), 1,
      anon_sym_LBRACE,
    STATE(5562), 1,
      sym_curly_expression,
    STATE(17786), 2,
      sym_block_comment,
      sym_line_comment,
  [383454] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8454), 1,
      anon_sym_RPAREN,
    ACTIONS(24664), 1,
      anon_sym_SEMI,
    STATE(17787), 2,
      sym_block_comment,
      sym_line_comment,
  [383471] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7738), 1,
      anon_sym_RPAREN,
    ACTIONS(24666), 1,
      anon_sym_SEMI,
    STATE(17788), 2,
      sym_block_comment,
      sym_line_comment,
  [383488] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10002), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17789), 2,
      sym_block_comment,
      sym_line_comment,
  [383503] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10006), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17790), 2,
      sym_block_comment,
      sym_line_comment,
  [383518] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8660), 1,
      anon_sym_RPAREN,
    ACTIONS(24668), 1,
      anon_sym_SEMI,
    STATE(17791), 2,
      sym_block_comment,
      sym_line_comment,
  [383535] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    STATE(4252), 1,
      sym_curly_expression,
    STATE(17792), 2,
      sym_block_comment,
      sym_line_comment,
  [383552] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    STATE(5222), 1,
      sym_curly_expression,
    STATE(17793), 2,
      sym_block_comment,
      sym_line_comment,
  [383569] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24634), 1,
      anon_sym_LPAREN,
    STATE(4678), 1,
      sym_argument_list,
    STATE(17794), 2,
      sym_block_comment,
      sym_line_comment,
  [383586] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24670), 1,
      anon_sym_LPAREN,
    STATE(4140), 1,
      sym_argument_list,
    STATE(17795), 2,
      sym_block_comment,
      sym_line_comment,
  [383603] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    STATE(4268), 1,
      sym_curly_expression,
    STATE(17796), 2,
      sym_block_comment,
      sym_line_comment,
  [383620] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24670), 1,
      anon_sym_LPAREN,
    STATE(4129), 1,
      sym_argument_list,
    STATE(17797), 2,
      sym_block_comment,
      sym_line_comment,
  [383637] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    STATE(4290), 1,
      sym_curly_expression,
    STATE(17798), 2,
      sym_block_comment,
      sym_line_comment,
  [383654] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8036), 1,
      anon_sym_RPAREN,
    ACTIONS(24672), 1,
      anon_sym_SEMI,
    STATE(17799), 2,
      sym_block_comment,
      sym_line_comment,
  [383671] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24652), 1,
      anon_sym_LPAREN,
    STATE(4876), 1,
      sym_argument_list,
    STATE(17800), 2,
      sym_block_comment,
      sym_line_comment,
  [383688] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24674), 1,
      anon_sym_LPAREN,
    STATE(10185), 1,
      sym_argument_list,
    STATE(17801), 2,
      sym_block_comment,
      sym_line_comment,
  [383705] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    STATE(5258), 1,
      sym_curly_expression,
    STATE(17802), 2,
      sym_block_comment,
      sym_line_comment,
  [383722] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14970), 1,
      anon_sym_LBRACE,
    STATE(6090), 1,
      sym_curly_expression,
    STATE(17803), 2,
      sym_block_comment,
      sym_line_comment,
  [383739] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24658), 1,
      anon_sym_LPAREN,
    STATE(5306), 1,
      sym_argument_list,
    STATE(17804), 2,
      sym_block_comment,
      sym_line_comment,
  [383756] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7478), 1,
      anon_sym_RPAREN,
    ACTIONS(24676), 1,
      anon_sym_SEMI,
    STATE(17805), 2,
      sym_block_comment,
      sym_line_comment,
  [383773] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24642), 1,
      anon_sym_LPAREN,
    STATE(4162), 1,
      sym_argument_list,
    STATE(17806), 2,
      sym_block_comment,
      sym_line_comment,
  [383790] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7124), 1,
      anon_sym_RPAREN,
    ACTIONS(24678), 1,
      anon_sym_SEMI,
    STATE(17807), 2,
      sym_block_comment,
      sym_line_comment,
  [383807] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24640), 1,
      anon_sym_LPAREN,
    STATE(4930), 1,
      sym_argument_list,
    STATE(17808), 2,
      sym_block_comment,
      sym_line_comment,
  [383824] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    STATE(4522), 1,
      sym_curly_expression,
    STATE(17809), 2,
      sym_block_comment,
      sym_line_comment,
  [383841] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13270), 1,
      anon_sym_LBRACE,
    STATE(5852), 1,
      sym_curly_expression,
    STATE(17810), 2,
      sym_block_comment,
      sym_line_comment,
  [383858] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7912), 1,
      anon_sym_RPAREN,
    ACTIONS(24680), 1,
      anon_sym_SEMI,
    STATE(17811), 2,
      sym_block_comment,
      sym_line_comment,
  [383875] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    STATE(9771), 1,
      sym_curly_expression,
    STATE(17812), 2,
      sym_block_comment,
      sym_line_comment,
  [383892] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24658), 1,
      anon_sym_LPAREN,
    STATE(5316), 1,
      sym_argument_list,
    STATE(17813), 2,
      sym_block_comment,
      sym_line_comment,
  [383909] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24674), 1,
      anon_sym_LPAREN,
    STATE(10219), 1,
      sym_argument_list,
    STATE(17814), 2,
      sym_block_comment,
      sym_line_comment,
  [383926] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24682), 1,
      anon_sym_LPAREN,
    STATE(10643), 1,
      sym_argument_list,
    STATE(17815), 2,
      sym_block_comment,
      sym_line_comment,
  [383943] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    STATE(10529), 1,
      sym_curly_expression,
    STATE(17816), 2,
      sym_block_comment,
      sym_line_comment,
  [383960] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    STATE(9933), 1,
      sym_curly_expression,
    STATE(17817), 2,
      sym_block_comment,
      sym_line_comment,
  [383977] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6988), 1,
      anon_sym_RPAREN,
    ACTIONS(24684), 1,
      anon_sym_SEMI,
    STATE(17818), 2,
      sym_block_comment,
      sym_line_comment,
  [383994] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24686), 1,
      anon_sym_LPAREN,
    STATE(10067), 1,
      sym_argument_list,
    STATE(17819), 2,
      sym_block_comment,
      sym_line_comment,
  [384011] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24688), 2,
      anon_sym_end,
      anon_sym_finally,
    STATE(17820), 2,
      sym_block_comment,
      sym_line_comment,
  [384026] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24624), 1,
      anon_sym_LPAREN,
    STATE(4379), 1,
      sym_argument_list,
    STATE(17821), 2,
      sym_block_comment,
      sym_line_comment,
  [384043] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14970), 1,
      anon_sym_LBRACE,
    STATE(6092), 1,
      sym_curly_expression,
    STATE(17822), 2,
      sym_block_comment,
      sym_line_comment,
  [384060] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7700), 1,
      anon_sym_RPAREN,
    ACTIONS(24690), 1,
      anon_sym_SEMI,
    STATE(17823), 2,
      sym_block_comment,
      sym_line_comment,
  [384077] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24652), 1,
      anon_sym_LPAREN,
    STATE(4877), 1,
      sym_argument_list,
    STATE(17824), 2,
      sym_block_comment,
      sym_line_comment,
  [384094] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7960), 1,
      anon_sym_LBRACE,
    STATE(4540), 1,
      sym_curly_expression,
    STATE(17825), 2,
      sym_block_comment,
      sym_line_comment,
  [384111] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24686), 1,
      anon_sym_LPAREN,
    STATE(10061), 1,
      sym_argument_list,
    STATE(17826), 2,
      sym_block_comment,
      sym_line_comment,
  [384128] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1293), 1,
      anon_sym_LBRACE,
    STATE(5861), 1,
      sym_curly_expression,
    STATE(17827), 2,
      sym_block_comment,
      sym_line_comment,
  [384145] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24630), 1,
      anon_sym_LPAREN,
    STATE(4167), 1,
      sym_argument_list,
    STATE(17828), 2,
      sym_block_comment,
      sym_line_comment,
  [384162] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24692), 1,
      anon_sym_LPAREN,
    STATE(6256), 1,
      sym_argument_list,
    STATE(17829), 2,
      sym_block_comment,
      sym_line_comment,
  [384179] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7610), 1,
      anon_sym_RPAREN,
    ACTIONS(24694), 1,
      anon_sym_SEMI,
    STATE(17830), 2,
      sym_block_comment,
      sym_line_comment,
  [384196] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13220), 1,
      anon_sym_LBRACE,
    STATE(6533), 1,
      sym_curly_expression,
    STATE(17831), 2,
      sym_block_comment,
      sym_line_comment,
  [384213] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24692), 1,
      anon_sym_LPAREN,
    STATE(6258), 1,
      sym_argument_list,
    STATE(17832), 2,
      sym_block_comment,
      sym_line_comment,
  [384230] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13220), 1,
      anon_sym_LBRACE,
    STATE(6537), 1,
      sym_curly_expression,
    STATE(17833), 2,
      sym_block_comment,
      sym_line_comment,
  [384247] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    STATE(9968), 1,
      sym_curly_expression,
    STATE(17834), 2,
      sym_block_comment,
      sym_line_comment,
  [384264] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    STATE(5792), 1,
      sym_curly_expression,
    STATE(17835), 2,
      sym_block_comment,
      sym_line_comment,
  [384281] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8642), 1,
      anon_sym_RPAREN,
    ACTIONS(24696), 1,
      anon_sym_SEMI,
    STATE(17836), 2,
      sym_block_comment,
      sym_line_comment,
  [384298] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24698), 1,
      anon_sym_LPAREN,
    STATE(9840), 1,
      sym_argument_list,
    STATE(17837), 2,
      sym_block_comment,
      sym_line_comment,
  [384315] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    STATE(9971), 1,
      sym_curly_expression,
    STATE(17838), 2,
      sym_block_comment,
      sym_line_comment,
  [384332] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24698), 1,
      anon_sym_LPAREN,
    STATE(9859), 1,
      sym_argument_list,
    STATE(17839), 2,
      sym_block_comment,
      sym_line_comment,
  [384349] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7932), 1,
      anon_sym_RPAREN,
    ACTIONS(24700), 1,
      anon_sym_SEMI,
    STATE(17840), 2,
      sym_block_comment,
      sym_line_comment,
  [384366] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    STATE(9973), 1,
      sym_curly_expression,
    STATE(17841), 2,
      sym_block_comment,
      sym_line_comment,
  [384383] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8772), 1,
      anon_sym_RPAREN,
    ACTIONS(24702), 1,
      anon_sym_SEMI,
    STATE(17842), 2,
      sym_block_comment,
      sym_line_comment,
  [384400] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8286), 1,
      anon_sym_RPAREN,
    ACTIONS(24704), 1,
      anon_sym_SEMI,
    STATE(17843), 2,
      sym_block_comment,
      sym_line_comment,
  [384417] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24656), 1,
      anon_sym_LPAREN,
    STATE(9739), 1,
      sym_argument_list,
    STATE(17844), 2,
      sym_block_comment,
      sym_line_comment,
  [384434] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24692), 1,
      anon_sym_LPAREN,
    STATE(6259), 1,
      sym_argument_list,
    STATE(17845), 2,
      sym_block_comment,
      sym_line_comment,
  [384451] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24644), 1,
      anon_sym_LPAREN,
    STATE(4985), 1,
      sym_argument_list,
    STATE(17846), 2,
      sym_block_comment,
      sym_line_comment,
  [384468] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24670), 1,
      anon_sym_LPAREN,
    STATE(4123), 1,
      sym_argument_list,
    STATE(17847), 2,
      sym_block_comment,
      sym_line_comment,
  [384485] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8516), 1,
      anon_sym_RPAREN,
    ACTIONS(24706), 1,
      anon_sym_SEMI,
    STATE(17848), 2,
      sym_block_comment,
      sym_line_comment,
  [384502] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7960), 1,
      anon_sym_LBRACE,
    STATE(4542), 1,
      sym_curly_expression,
    STATE(17849), 2,
      sym_block_comment,
      sym_line_comment,
  [384519] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8072), 1,
      anon_sym_RPAREN,
    ACTIONS(24708), 1,
      anon_sym_SEMI,
    STATE(17850), 2,
      sym_block_comment,
      sym_line_comment,
  [384536] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6924), 1,
      anon_sym_RPAREN,
    ACTIONS(24710), 1,
      anon_sym_SEMI,
    STATE(17851), 2,
      sym_block_comment,
      sym_line_comment,
  [384553] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24698), 1,
      anon_sym_LPAREN,
    STATE(9851), 1,
      sym_argument_list,
    STATE(17852), 2,
      sym_block_comment,
      sym_line_comment,
  [384570] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24692), 1,
      anon_sym_LPAREN,
    STATE(6261), 1,
      sym_argument_list,
    STATE(17853), 2,
      sym_block_comment,
      sym_line_comment,
  [384587] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24682), 1,
      anon_sym_LPAREN,
    STATE(10654), 1,
      sym_argument_list,
    STATE(17854), 2,
      sym_block_comment,
      sym_line_comment,
  [384604] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24656), 1,
      anon_sym_LPAREN,
    STATE(9740), 1,
      sym_argument_list,
    STATE(17855), 2,
      sym_block_comment,
      sym_line_comment,
  [384621] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24650), 1,
      anon_sym_LPAREN,
    STATE(4881), 1,
      sym_argument_list,
    STATE(17856), 2,
      sym_block_comment,
      sym_line_comment,
  [384638] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24650), 1,
      anon_sym_LPAREN,
    STATE(4892), 1,
      sym_argument_list,
    STATE(17857), 2,
      sym_block_comment,
      sym_line_comment,
  [384655] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13220), 1,
      anon_sym_LBRACE,
    STATE(6554), 1,
      sym_curly_expression,
    STATE(17858), 2,
      sym_block_comment,
      sym_line_comment,
  [384672] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8680), 1,
      anon_sym_RPAREN,
    ACTIONS(24712), 1,
      anon_sym_SEMI,
    STATE(17859), 2,
      sym_block_comment,
      sym_line_comment,
  [384689] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7162), 1,
      anon_sym_RPAREN,
    ACTIONS(24714), 1,
      anon_sym_SEMI,
    STATE(17860), 2,
      sym_block_comment,
      sym_line_comment,
  [384706] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13862), 1,
      anon_sym_LBRACE,
    STATE(6273), 1,
      sym_curly_expression,
    STATE(17861), 2,
      sym_block_comment,
      sym_line_comment,
  [384723] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14982), 1,
      anon_sym_LBRACE,
    STATE(10863), 1,
      sym_curly_expression,
    STATE(17862), 2,
      sym_block_comment,
      sym_line_comment,
  [384740] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15026), 1,
      anon_sym_LBRACE,
    STATE(5571), 1,
      sym_curly_expression,
    STATE(17863), 2,
      sym_block_comment,
      sym_line_comment,
  [384757] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24698), 1,
      anon_sym_LPAREN,
    STATE(9844), 1,
      sym_argument_list,
    STATE(17864), 2,
      sym_block_comment,
      sym_line_comment,
  [384774] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24716), 1,
      anon_sym_LPAREN,
    STATE(4223), 1,
      sym_argument_list,
    STATE(17865), 2,
      sym_block_comment,
      sym_line_comment,
  [384791] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    STATE(9765), 1,
      sym_curly_expression,
    STATE(17866), 2,
      sym_block_comment,
      sym_line_comment,
  [384808] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13612), 1,
      anon_sym_LBRACE,
    STATE(9981), 1,
      sym_curly_expression,
    STATE(17867), 2,
      sym_block_comment,
      sym_line_comment,
  [384825] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24634), 1,
      anon_sym_LPAREN,
    STATE(4679), 1,
      sym_argument_list,
    STATE(17868), 2,
      sym_block_comment,
      sym_line_comment,
  [384842] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7046), 1,
      anon_sym_RPAREN,
    ACTIONS(24718), 1,
      anon_sym_SEMI,
    STATE(17869), 2,
      sym_block_comment,
      sym_line_comment,
  [384859] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24720), 1,
      anon_sym_LPAREN,
    STATE(5064), 1,
      sym_argument_list,
    STATE(17870), 2,
      sym_block_comment,
      sym_line_comment,
  [384876] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7576), 1,
      anon_sym_RPAREN,
    ACTIONS(24722), 1,
      anon_sym_SEMI,
    STATE(17871), 2,
      sym_block_comment,
      sym_line_comment,
  [384893] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7342), 1,
      anon_sym_RPAREN,
    ACTIONS(24724), 1,
      anon_sym_SEMI,
    STATE(17872), 2,
      sym_block_comment,
      sym_line_comment,
  [384910] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15858), 1,
      anon_sym_LBRACE,
    STATE(7444), 1,
      sym_curly_expression,
    STATE(17873), 2,
      sym_block_comment,
      sym_line_comment,
  [384927] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15912), 1,
      anon_sym_LBRACE,
    STATE(7167), 1,
      sym_curly_expression,
    STATE(17874), 2,
      sym_block_comment,
      sym_line_comment,
  [384944] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24726), 1,
      anon_sym_LPAREN,
    STATE(5243), 1,
      sym_argument_list,
    STATE(17875), 2,
      sym_block_comment,
      sym_line_comment,
  [384961] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13704), 1,
      anon_sym_LBRACE,
    STATE(6211), 1,
      sym_curly_expression,
    STATE(17876), 2,
      sym_block_comment,
      sym_line_comment,
  [384978] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24726), 1,
      anon_sym_LPAREN,
    STATE(5250), 1,
      sym_argument_list,
    STATE(17877), 2,
      sym_block_comment,
      sym_line_comment,
  [384995] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7010), 1,
      anon_sym_RPAREN,
    ACTIONS(24728), 1,
      anon_sym_SEMI,
    STATE(17878), 2,
      sym_block_comment,
      sym_line_comment,
  [385012] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7986), 1,
      anon_sym_RPAREN,
    ACTIONS(24730), 1,
      anon_sym_SEMI,
    STATE(17879), 2,
      sym_block_comment,
      sym_line_comment,
  [385029] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13704), 1,
      anon_sym_LBRACE,
    STATE(6213), 1,
      sym_curly_expression,
    STATE(17880), 2,
      sym_block_comment,
      sym_line_comment,
  [385046] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24632), 1,
      anon_sym_LPAREN,
    STATE(4958), 1,
      sym_argument_list,
    STATE(17881), 2,
      sym_block_comment,
      sym_line_comment,
  [385063] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13862), 1,
      anon_sym_LBRACE,
    STATE(6275), 1,
      sym_curly_expression,
    STATE(17882), 2,
      sym_block_comment,
      sym_line_comment,
  [385080] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14376), 1,
      anon_sym_LBRACE,
    STATE(5970), 1,
      sym_curly_expression,
    STATE(17883), 2,
      sym_block_comment,
      sym_line_comment,
  [385097] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24670), 1,
      anon_sym_LPAREN,
    STATE(4124), 1,
      sym_argument_list,
    STATE(17884), 2,
      sym_block_comment,
      sym_line_comment,
  [385114] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24716), 1,
      anon_sym_LPAREN,
    STATE(4240), 1,
      sym_argument_list,
    STATE(17885), 2,
      sym_block_comment,
      sym_line_comment,
  [385131] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24732), 1,
      anon_sym_LPAREN,
    STATE(5274), 1,
      sym_argument_list,
    STATE(17886), 2,
      sym_block_comment,
      sym_line_comment,
  [385148] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24734), 1,
      anon_sym_LPAREN,
    STATE(9841), 1,
      sym_argument_list,
    STATE(17887), 2,
      sym_block_comment,
      sym_line_comment,
  [385165] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14376), 1,
      anon_sym_LBRACE,
    STATE(5973), 1,
      sym_curly_expression,
    STATE(17888), 2,
      sym_block_comment,
      sym_line_comment,
  [385182] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24732), 1,
      anon_sym_LPAREN,
    STATE(5303), 1,
      sym_argument_list,
    STATE(17889), 2,
      sym_block_comment,
      sym_line_comment,
  [385199] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6868), 1,
      anon_sym_LBRACE,
    STATE(4503), 1,
      sym_curly_expression,
    STATE(17890), 2,
      sym_block_comment,
      sym_line_comment,
  [385216] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14376), 1,
      anon_sym_LBRACE,
    STATE(5974), 1,
      sym_curly_expression,
    STATE(17891), 2,
      sym_block_comment,
      sym_line_comment,
  [385233] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4494), 1,
      anon_sym_LBRACE,
    STATE(10285), 1,
      sym_curly_expression,
    STATE(17892), 2,
      sym_block_comment,
      sym_line_comment,
  [385250] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4494), 1,
      anon_sym_LBRACE,
    STATE(10297), 1,
      sym_curly_expression,
    STATE(17893), 2,
      sym_block_comment,
      sym_line_comment,
  [385267] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24720), 1,
      anon_sym_LPAREN,
    STATE(5114), 1,
      sym_argument_list,
    STATE(17894), 2,
      sym_block_comment,
      sym_line_comment,
  [385284] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13862), 1,
      anon_sym_LBRACE,
    STATE(6277), 1,
      sym_curly_expression,
    STATE(17895), 2,
      sym_block_comment,
      sym_line_comment,
  [385301] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14842), 1,
      anon_sym_LBRACE,
    STATE(5752), 1,
      sym_curly_expression,
    STATE(17896), 2,
      sym_block_comment,
      sym_line_comment,
  [385318] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7800), 1,
      anon_sym_RPAREN,
    ACTIONS(24736), 1,
      anon_sym_SEMI,
    STATE(17897), 2,
      sym_block_comment,
      sym_line_comment,
  [385335] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6948), 1,
      anon_sym_RPAREN,
    ACTIONS(24738), 1,
      anon_sym_SEMI,
    STATE(17898), 2,
      sym_block_comment,
      sym_line_comment,
  [385352] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8116), 1,
      anon_sym_RPAREN,
    ACTIONS(24740), 1,
      anon_sym_SEMI,
    STATE(17899), 2,
      sym_block_comment,
      sym_line_comment,
  [385369] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8236), 1,
      anon_sym_RPAREN,
    ACTIONS(24742), 1,
      anon_sym_SEMI,
    STATE(17900), 2,
      sym_block_comment,
      sym_line_comment,
  [385386] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10012), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17901), 2,
      sym_block_comment,
      sym_line_comment,
  [385401] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(4824), 1,
      sym_curly_expression,
    STATE(17902), 2,
      sym_block_comment,
      sym_line_comment,
  [385418] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24732), 1,
      anon_sym_LPAREN,
    STATE(5320), 1,
      sym_argument_list,
    STATE(17903), 2,
      sym_block_comment,
      sym_line_comment,
  [385435] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    STATE(10660), 1,
      sym_curly_expression,
    STATE(17904), 2,
      sym_block_comment,
      sym_line_comment,
  [385452] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10154), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17905), 2,
      sym_block_comment,
      sym_line_comment,
  [385467] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16014), 1,
      anon_sym_LBRACE,
    STATE(6970), 1,
      sym_curly_expression,
    STATE(17906), 2,
      sym_block_comment,
      sym_line_comment,
  [385484] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24744), 1,
      anon_sym_LPAREN,
    STATE(10258), 1,
      sym_argument_list,
    STATE(17907), 2,
      sym_block_comment,
      sym_line_comment,
  [385501] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    STATE(10656), 1,
      sym_curly_expression,
    STATE(17908), 2,
      sym_block_comment,
      sym_line_comment,
  [385518] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10016), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17909), 2,
      sym_block_comment,
      sym_line_comment,
  [385533] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4494), 1,
      anon_sym_LBRACE,
    STATE(10288), 1,
      sym_curly_expression,
    STATE(17910), 2,
      sym_block_comment,
      sym_line_comment,
  [385550] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15026), 1,
      anon_sym_LBRACE,
    STATE(5564), 1,
      sym_curly_expression,
    STATE(17911), 2,
      sym_block_comment,
      sym_line_comment,
  [385567] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24744), 1,
      anon_sym_LPAREN,
    STATE(10357), 1,
      sym_argument_list,
    STATE(17912), 2,
      sym_block_comment,
      sym_line_comment,
  [385584] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    STATE(10553), 1,
      sym_curly_expression,
    STATE(17913), 2,
      sym_block_comment,
      sym_line_comment,
  [385601] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7196), 1,
      anon_sym_RPAREN,
    ACTIONS(24746), 1,
      anon_sym_SEMI,
    STATE(17914), 2,
      sym_block_comment,
      sym_line_comment,
  [385618] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24644), 1,
      anon_sym_LPAREN,
    STATE(4889), 1,
      sym_argument_list,
    STATE(17915), 2,
      sym_block_comment,
      sym_line_comment,
  [385635] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15904), 1,
      anon_sym_LBRACE,
    STATE(7823), 1,
      sym_curly_expression,
    STATE(17916), 2,
      sym_block_comment,
      sym_line_comment,
  [385652] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8504), 1,
      anon_sym_RPAREN,
    ACTIONS(24748), 1,
      anon_sym_SEMI,
    STATE(17917), 2,
      sym_block_comment,
      sym_line_comment,
  [385669] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24624), 1,
      anon_sym_LPAREN,
    STATE(4407), 1,
      sym_argument_list,
    STATE(17918), 2,
      sym_block_comment,
      sym_line_comment,
  [385686] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24732), 1,
      anon_sym_LPAREN,
    STATE(5052), 1,
      sym_argument_list,
    STATE(17919), 2,
      sym_block_comment,
      sym_line_comment,
  [385703] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14376), 1,
      anon_sym_LBRACE,
    STATE(5995), 1,
      sym_curly_expression,
    STATE(17920), 2,
      sym_block_comment,
      sym_line_comment,
  [385720] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24726), 1,
      anon_sym_LPAREN,
    STATE(5255), 1,
      sym_argument_list,
    STATE(17921), 2,
      sym_block_comment,
      sym_line_comment,
  [385737] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6890), 1,
      anon_sym_LBRACE,
    STATE(4872), 1,
      sym_curly_expression,
    STATE(17922), 2,
      sym_block_comment,
      sym_line_comment,
  [385754] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7716), 1,
      anon_sym_RPAREN,
    ACTIONS(24750), 1,
      anon_sym_SEMI,
    STATE(17923), 2,
      sym_block_comment,
      sym_line_comment,
  [385771] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16046), 1,
      anon_sym_LBRACE,
    STATE(6743), 1,
      sym_curly_expression,
    STATE(17924), 2,
      sym_block_comment,
      sym_line_comment,
  [385788] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14456), 1,
      anon_sym_LBRACE,
    STATE(5701), 1,
      sym_curly_expression,
    STATE(17925), 2,
      sym_block_comment,
      sym_line_comment,
  [385805] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15816), 1,
      anon_sym_LBRACE,
    STATE(7182), 1,
      sym_curly_expression,
    STATE(17926), 2,
      sym_block_comment,
      sym_line_comment,
  [385822] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24720), 1,
      anon_sym_LPAREN,
    STATE(5297), 1,
      sym_argument_list,
    STATE(17927), 2,
      sym_block_comment,
      sym_line_comment,
  [385839] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8434), 1,
      anon_sym_RPAREN,
    ACTIONS(24752), 1,
      anon_sym_SEMI,
    STATE(17928), 2,
      sym_block_comment,
      sym_line_comment,
  [385856] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8022), 1,
      anon_sym_RPAREN,
    ACTIONS(24754), 1,
      anon_sym_SEMI,
    STATE(17929), 2,
      sym_block_comment,
      sym_line_comment,
  [385873] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6884), 1,
      anon_sym_RPAREN,
    ACTIONS(24756), 1,
      anon_sym_SEMI,
    STATE(17930), 2,
      sym_block_comment,
      sym_line_comment,
  [385890] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7946), 1,
      anon_sym_RPAREN,
    ACTIONS(24758), 1,
      anon_sym_SEMI,
    STATE(17931), 2,
      sym_block_comment,
      sym_line_comment,
  [385907] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8362), 1,
      anon_sym_RPAREN,
    ACTIONS(24760), 1,
      anon_sym_SEMI,
    STATE(17932), 2,
      sym_block_comment,
      sym_line_comment,
  [385924] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13546), 1,
      anon_sym_LBRACE,
    STATE(6009), 1,
      sym_curly_expression,
    STATE(17933), 2,
      sym_block_comment,
      sym_line_comment,
  [385941] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24762), 1,
      anon_sym_LPAREN,
    STATE(5357), 1,
      sym_argument_list,
    STATE(17934), 2,
      sym_block_comment,
      sym_line_comment,
  [385958] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13546), 1,
      anon_sym_LBRACE,
    STATE(6011), 1,
      sym_curly_expression,
    STATE(17935), 2,
      sym_block_comment,
      sym_line_comment,
  [385975] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24762), 1,
      anon_sym_LPAREN,
    STATE(5205), 1,
      sym_argument_list,
    STATE(17936), 2,
      sym_block_comment,
      sym_line_comment,
  [385992] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6944), 1,
      anon_sym_RPAREN,
    ACTIONS(24764), 1,
      anon_sym_SEMI,
    STATE(17937), 2,
      sym_block_comment,
      sym_line_comment,
  [386009] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14456), 1,
      anon_sym_LBRACE,
    STATE(5721), 1,
      sym_curly_expression,
    STATE(17938), 2,
      sym_block_comment,
      sym_line_comment,
  [386026] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24766), 1,
      anon_sym_LPAREN,
    STATE(4938), 1,
      sym_argument_list,
    STATE(17939), 2,
      sym_block_comment,
      sym_line_comment,
  [386043] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7070), 1,
      anon_sym_RPAREN,
    ACTIONS(24768), 1,
      anon_sym_SEMI,
    STATE(17940), 2,
      sym_block_comment,
      sym_line_comment,
  [386060] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8536), 1,
      anon_sym_RPAREN,
    ACTIONS(24770), 1,
      anon_sym_SEMI,
    STATE(17941), 2,
      sym_block_comment,
      sym_line_comment,
  [386077] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13546), 1,
      anon_sym_LBRACE,
    STATE(6012), 1,
      sym_curly_expression,
    STATE(17942), 2,
      sym_block_comment,
      sym_line_comment,
  [386094] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    STATE(5710), 1,
      sym_curly_expression,
    STATE(17943), 2,
      sym_block_comment,
      sym_line_comment,
  [386111] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8152), 1,
      anon_sym_RPAREN,
    ACTIONS(24772), 1,
      anon_sym_SEMI,
    STATE(17944), 2,
      sym_block_comment,
      sym_line_comment,
  [386128] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6966), 1,
      anon_sym_RPAREN,
    ACTIONS(24774), 1,
      anon_sym_SEMI,
    STATE(17945), 2,
      sym_block_comment,
      sym_line_comment,
  [386145] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8796), 1,
      anon_sym_RPAREN,
    ACTIONS(24776), 1,
      anon_sym_SEMI,
    STATE(17946), 2,
      sym_block_comment,
      sym_line_comment,
  [386162] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(4737), 1,
      sym_curly_expression,
    STATE(17947), 2,
      sym_block_comment,
      sym_line_comment,
  [386179] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24744), 1,
      anon_sym_LPAREN,
    STATE(10257), 1,
      sym_argument_list,
    STATE(17948), 2,
      sym_block_comment,
      sym_line_comment,
  [386196] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24726), 1,
      anon_sym_LPAREN,
    STATE(5283), 1,
      sym_argument_list,
    STATE(17949), 2,
      sym_block_comment,
      sym_line_comment,
  [386213] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24720), 1,
      anon_sym_LPAREN,
    STATE(5310), 1,
      sym_argument_list,
    STATE(17950), 2,
      sym_block_comment,
      sym_line_comment,
  [386230] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7038), 1,
      anon_sym_RPAREN,
    ACTIONS(24778), 1,
      anon_sym_SEMI,
    STATE(17951), 2,
      sym_block_comment,
      sym_line_comment,
  [386247] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13704), 1,
      anon_sym_LBRACE,
    STATE(6220), 1,
      sym_curly_expression,
    STATE(17952), 2,
      sym_block_comment,
      sym_line_comment,
  [386264] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13862), 1,
      anon_sym_LBRACE,
    STATE(6284), 1,
      sym_curly_expression,
    STATE(17953), 2,
      sym_block_comment,
      sym_line_comment,
  [386281] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24766), 1,
      anon_sym_LPAREN,
    STATE(4940), 1,
      sym_argument_list,
    STATE(17954), 2,
      sym_block_comment,
      sym_line_comment,
  [386298] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8326), 1,
      anon_sym_RPAREN,
    ACTIONS(24780), 1,
      anon_sym_SEMI,
    STATE(17955), 2,
      sym_block_comment,
      sym_line_comment,
  [386315] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16742), 1,
      anon_sym_COMMA,
    STATE(14431), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17956), 2,
      sym_block_comment,
      sym_line_comment,
  [386332] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10020), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17957), 2,
      sym_block_comment,
      sym_line_comment,
  [386347] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    STATE(5712), 1,
      sym_curly_expression,
    STATE(17958), 2,
      sym_block_comment,
      sym_line_comment,
  [386364] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13596), 1,
      anon_sym_LBRACE,
    STATE(11797), 1,
      sym_curly_expression,
    STATE(17959), 2,
      sym_block_comment,
      sym_line_comment,
  [386381] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24782), 1,
      anon_sym_LPAREN,
    STATE(11543), 1,
      sym_argument_list,
    STATE(17960), 2,
      sym_block_comment,
      sym_line_comment,
  [386398] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    STATE(9929), 1,
      sym_curly_expression,
    STATE(17961), 2,
      sym_block_comment,
      sym_line_comment,
  [386415] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7814), 1,
      anon_sym_RPAREN,
    ACTIONS(24784), 1,
      anon_sym_SEMI,
    STATE(17962), 2,
      sym_block_comment,
      sym_line_comment,
  [386432] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9918), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17963), 2,
      sym_block_comment,
      sym_line_comment,
  [386447] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7424), 1,
      anon_sym_RPAREN,
    ACTIONS(24786), 1,
      anon_sym_SEMI,
    STATE(17964), 2,
      sym_block_comment,
      sym_line_comment,
  [386464] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15938), 1,
      anon_sym_LBRACE,
    STATE(11724), 1,
      sym_curly_expression,
    STATE(17965), 2,
      sym_block_comment,
      sym_line_comment,
  [386481] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13596), 1,
      anon_sym_LBRACE,
    STATE(11802), 1,
      sym_curly_expression,
    STATE(17966), 2,
      sym_block_comment,
      sym_line_comment,
  [386498] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8134), 1,
      anon_sym_RPAREN,
    ACTIONS(24788), 1,
      anon_sym_SEMI,
    STATE(17967), 2,
      sym_block_comment,
      sym_line_comment,
  [386515] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24782), 1,
      anon_sym_LPAREN,
    STATE(11548), 1,
      sym_argument_list,
    STATE(17968), 2,
      sym_block_comment,
      sym_line_comment,
  [386532] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7868), 1,
      anon_sym_RPAREN,
    ACTIONS(24790), 1,
      anon_sym_SEMI,
    STATE(17969), 2,
      sym_block_comment,
      sym_line_comment,
  [386549] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24744), 1,
      anon_sym_LPAREN,
    STATE(10274), 1,
      sym_argument_list,
    STATE(17970), 2,
      sym_block_comment,
      sym_line_comment,
  [386566] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7444), 1,
      anon_sym_RPAREN,
    ACTIONS(24792), 1,
      anon_sym_SEMI,
    STATE(17971), 2,
      sym_block_comment,
      sym_line_comment,
  [386583] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13316), 1,
      anon_sym_LBRACE,
    STATE(10672), 1,
      sym_curly_expression,
    STATE(17972), 2,
      sym_block_comment,
      sym_line_comment,
  [386600] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8096), 1,
      anon_sym_RPAREN,
    ACTIONS(24794), 1,
      anon_sym_SEMI,
    STATE(17973), 2,
      sym_block_comment,
      sym_line_comment,
  [386617] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24630), 1,
      anon_sym_LPAREN,
    STATE(4169), 1,
      sym_argument_list,
    STATE(17974), 2,
      sym_block_comment,
      sym_line_comment,
  [386634] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13596), 1,
      anon_sym_LBRACE,
    STATE(11811), 1,
      sym_curly_expression,
    STATE(17975), 2,
      sym_block_comment,
      sym_line_comment,
  [386651] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6890), 1,
      anon_sym_LBRACE,
    STATE(4988), 1,
      sym_curly_expression,
    STATE(17976), 2,
      sym_block_comment,
      sym_line_comment,
  [386668] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7256), 1,
      anon_sym_RPAREN,
    ACTIONS(24796), 1,
      anon_sym_SEMI,
    STATE(17977), 2,
      sym_block_comment,
      sym_line_comment,
  [386685] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9928), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17978), 2,
      sym_block_comment,
      sym_line_comment,
  [386700] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24762), 1,
      anon_sym_LPAREN,
    STATE(5100), 1,
      sym_argument_list,
    STATE(17979), 2,
      sym_block_comment,
      sym_line_comment,
  [386717] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7012), 1,
      anon_sym_RPAREN,
    ACTIONS(24798), 1,
      anon_sym_SEMI,
    STATE(17980), 2,
      sym_block_comment,
      sym_line_comment,
  [386734] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24800), 1,
      anon_sym_LPAREN,
    STATE(4203), 1,
      sym_argument_list,
    STATE(17981), 2,
      sym_block_comment,
      sym_line_comment,
  [386751] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24650), 1,
      anon_sym_LPAREN,
    STATE(4884), 1,
      sym_argument_list,
    STATE(17982), 2,
      sym_block_comment,
      sym_line_comment,
  [386768] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17079), 1,
      anon_sym_COMMA,
    STATE(14968), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17983), 2,
      sym_block_comment,
      sym_line_comment,
  [386785] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11022), 1,
      anon_sym_COLON2,
    ACTIONS(24802), 1,
      anon_sym_EQ,
    STATE(17984), 2,
      sym_block_comment,
      sym_line_comment,
  [386802] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16786), 1,
      anon_sym_COMMA,
    STATE(14381), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(17985), 2,
      sym_block_comment,
      sym_line_comment,
  [386819] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16038), 1,
      anon_sym_LBRACE,
    STATE(7543), 1,
      sym_curly_expression,
    STATE(17986), 2,
      sym_block_comment,
      sym_line_comment,
  [386836] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9922), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17987), 2,
      sym_block_comment,
      sym_line_comment,
  [386851] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24762), 1,
      anon_sym_LPAREN,
    STATE(5195), 1,
      sym_argument_list,
    STATE(17988), 2,
      sym_block_comment,
      sym_line_comment,
  [386868] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8188), 1,
      anon_sym_RPAREN,
    ACTIONS(24804), 1,
      anon_sym_SEMI,
    STATE(17989), 2,
      sym_block_comment,
      sym_line_comment,
  [386885] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13546), 1,
      anon_sym_LBRACE,
    STATE(6018), 1,
      sym_curly_expression,
    STATE(17990), 2,
      sym_block_comment,
      sym_line_comment,
  [386902] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8442), 1,
      anon_sym_RPAREN,
    ACTIONS(24806), 1,
      anon_sym_SEMI,
    STATE(17991), 2,
      sym_block_comment,
      sym_line_comment,
  [386919] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    STATE(4447), 1,
      sym_curly_expression,
    STATE(17992), 2,
      sym_block_comment,
      sym_line_comment,
  [386936] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8524), 1,
      anon_sym_RPAREN,
    ACTIONS(24808), 1,
      anon_sym_SEMI,
    STATE(17993), 2,
      sym_block_comment,
      sym_line_comment,
  [386953] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24620), 1,
      anon_sym_LPAREN,
    STATE(5027), 1,
      sym_argument_list,
    STATE(17994), 2,
      sym_block_comment,
      sym_line_comment,
  [386970] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15880), 1,
      anon_sym_LBRACE,
    STATE(7039), 1,
      sym_curly_expression,
    STATE(17995), 2,
      sym_block_comment,
      sym_line_comment,
  [386987] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24810), 1,
      anon_sym_LPAREN,
    STATE(6358), 1,
      sym_argument_list,
    STATE(17996), 2,
      sym_block_comment,
      sym_line_comment,
  [387004] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24766), 1,
      anon_sym_LPAREN,
    STATE(4996), 1,
      sym_argument_list,
    STATE(17997), 2,
      sym_block_comment,
      sym_line_comment,
  [387021] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9728), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(17998), 2,
      sym_block_comment,
      sym_line_comment,
  [387036] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24812), 2,
      anon_sym_end,
      anon_sym_catch,
    STATE(17999), 2,
      sym_block_comment,
      sym_line_comment,
  [387051] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14652), 1,
      anon_sym_LBRACE,
    STATE(7042), 1,
      sym_curly_expression,
    STATE(18000), 2,
      sym_block_comment,
      sym_line_comment,
  [387068] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24810), 1,
      anon_sym_LPAREN,
    STATE(6360), 1,
      sym_argument_list,
    STATE(18001), 2,
      sym_block_comment,
      sym_line_comment,
  [387085] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13690), 1,
      anon_sym_LBRACE,
    STATE(5084), 1,
      sym_curly_expression,
    STATE(18002), 2,
      sym_block_comment,
      sym_line_comment,
  [387102] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14652), 1,
      anon_sym_LBRACE,
    STATE(7044), 1,
      sym_curly_expression,
    STATE(18003), 2,
      sym_block_comment,
      sym_line_comment,
  [387119] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8354), 1,
      anon_sym_RPAREN,
    ACTIONS(24814), 1,
      anon_sym_SEMI,
    STATE(18004), 2,
      sym_block_comment,
      sym_line_comment,
  [387136] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8172), 1,
      anon_sym_RPAREN,
    ACTIONS(24816), 1,
      anon_sym_SEMI,
    STATE(18005), 2,
      sym_block_comment,
      sym_line_comment,
  [387153] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16977), 1,
      anon_sym_COMMA,
    STATE(14457), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18006), 2,
      sym_block_comment,
      sym_line_comment,
  [387170] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9644), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18007), 2,
      sym_block_comment,
      sym_line_comment,
  [387185] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7960), 1,
      anon_sym_LBRACE,
    STATE(4566), 1,
      sym_curly_expression,
    STATE(18008), 2,
      sym_block_comment,
      sym_line_comment,
  [387202] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7646), 1,
      anon_sym_RPAREN,
    ACTIONS(24818), 1,
      anon_sym_SEMI,
    STATE(18009), 2,
      sym_block_comment,
      sym_line_comment,
  [387219] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7326), 1,
      anon_sym_RPAREN,
    ACTIONS(24820), 1,
      anon_sym_SEMI,
    STATE(18010), 2,
      sym_block_comment,
      sym_line_comment,
  [387236] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8216), 1,
      anon_sym_RPAREN,
    ACTIONS(24822), 1,
      anon_sym_SEMI,
    STATE(18011), 2,
      sym_block_comment,
      sym_line_comment,
  [387253] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7848), 1,
      anon_sym_RPAREN,
    ACTIONS(24824), 1,
      anon_sym_SEMI,
    STATE(18012), 2,
      sym_block_comment,
      sym_line_comment,
  [387270] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24658), 1,
      anon_sym_LPAREN,
    STATE(5151), 1,
      sym_argument_list,
    STATE(18013), 2,
      sym_block_comment,
      sym_line_comment,
  [387287] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9992), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18014), 2,
      sym_block_comment,
      sym_line_comment,
  [387302] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10136), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18015), 2,
      sym_block_comment,
      sym_line_comment,
  [387317] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    STATE(10098), 1,
      sym_curly_expression,
    STATE(18016), 2,
      sym_block_comment,
      sym_line_comment,
  [387334] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8788), 1,
      anon_sym_RPAREN,
    ACTIONS(24826), 1,
      anon_sym_SEMI,
    STATE(18017), 2,
      sym_block_comment,
      sym_line_comment,
  [387351] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8554), 1,
      anon_sym_RPAREN,
    ACTIONS(24828), 1,
      anon_sym_SEMI,
    STATE(18018), 2,
      sym_block_comment,
      sym_line_comment,
  [387368] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24766), 1,
      anon_sym_LPAREN,
    STATE(5028), 1,
      sym_argument_list,
    STATE(18019), 2,
      sym_block_comment,
      sym_line_comment,
  [387385] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    STATE(5716), 1,
      sym_curly_expression,
    STATE(18020), 2,
      sym_block_comment,
      sym_line_comment,
  [387402] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9914), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18021), 2,
      sym_block_comment,
      sym_line_comment,
  [387417] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24830), 1,
      anon_sym_LPAREN,
    STATE(9901), 1,
      sym_argument_list,
    STATE(18022), 2,
      sym_block_comment,
      sym_line_comment,
  [387434] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    STATE(10089), 1,
      sym_curly_expression,
    STATE(18023), 2,
      sym_block_comment,
      sym_line_comment,
  [387451] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10118), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18024), 2,
      sym_block_comment,
      sym_line_comment,
  [387466] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24830), 1,
      anon_sym_LPAREN,
    STATE(9863), 1,
      sym_argument_list,
    STATE(18025), 2,
      sym_block_comment,
      sym_line_comment,
  [387483] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    STATE(10137), 1,
      sym_curly_expression,
    STATE(18026), 2,
      sym_block_comment,
      sym_line_comment,
  [387500] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8826), 1,
      anon_sym_RPAREN,
    ACTIONS(24832), 1,
      anon_sym_SEMI,
    STATE(18027), 2,
      sym_block_comment,
      sym_line_comment,
  [387517] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9996), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18028), 2,
      sym_block_comment,
      sym_line_comment,
  [387532] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    STATE(5688), 1,
      sym_curly_expression,
    STATE(18029), 2,
      sym_block_comment,
      sym_line_comment,
  [387549] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6910), 1,
      anon_sym_RPAREN,
    ACTIONS(24834), 1,
      anon_sym_SEMI,
    STATE(18030), 2,
      sym_block_comment,
      sym_line_comment,
  [387566] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7842), 1,
      anon_sym_RPAREN,
    ACTIONS(24836), 1,
      anon_sym_SEMI,
    STATE(18031), 2,
      sym_block_comment,
      sym_line_comment,
  [387583] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17149), 1,
      anon_sym_COMMA,
    STATE(14694), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18032), 2,
      sym_block_comment,
      sym_line_comment,
  [387600] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14526), 1,
      anon_sym_LBRACE,
    STATE(5331), 1,
      sym_curly_expression,
    STATE(18033), 2,
      sym_block_comment,
      sym_line_comment,
  [387617] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24838), 1,
      anon_sym_LPAREN,
    STATE(4844), 1,
      sym_argument_list,
    STATE(18034), 2,
      sym_block_comment,
      sym_line_comment,
  [387634] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14970), 1,
      anon_sym_LBRACE,
    STATE(6111), 1,
      sym_curly_expression,
    STATE(18035), 2,
      sym_block_comment,
      sym_line_comment,
  [387651] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14526), 1,
      anon_sym_LBRACE,
    STATE(5334), 1,
      sym_curly_expression,
    STATE(18036), 2,
      sym_block_comment,
      sym_line_comment,
  [387668] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24838), 1,
      anon_sym_LPAREN,
    STATE(4846), 1,
      sym_argument_list,
    STATE(18037), 2,
      sym_block_comment,
      sym_line_comment,
  [387685] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14526), 1,
      anon_sym_LBRACE,
    STATE(5339), 1,
      sym_curly_expression,
    STATE(18038), 2,
      sym_block_comment,
      sym_line_comment,
  [387702] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7596), 1,
      anon_sym_RPAREN,
    ACTIONS(24840), 1,
      anon_sym_SEMI,
    STATE(18039), 2,
      sym_block_comment,
      sym_line_comment,
  [387719] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24686), 1,
      anon_sym_LPAREN,
    STATE(10059), 1,
      sym_argument_list,
    STATE(18040), 2,
      sym_block_comment,
      sym_line_comment,
  [387736] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13502), 1,
      anon_sym_LBRACE,
    STATE(6391), 1,
      sym_curly_expression,
    STATE(18041), 2,
      sym_block_comment,
      sym_line_comment,
  [387753] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9754), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18042), 2,
      sym_block_comment,
      sym_line_comment,
  [387768] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7096), 1,
      anon_sym_RPAREN,
    ACTIONS(24842), 1,
      anon_sym_SEMI,
    STATE(18043), 2,
      sym_block_comment,
      sym_line_comment,
  [387785] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6930), 1,
      anon_sym_RPAREN,
    ACTIONS(24844), 1,
      anon_sym_SEMI,
    STATE(18044), 2,
      sym_block_comment,
      sym_line_comment,
  [387802] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24810), 1,
      anon_sym_LPAREN,
    STATE(6363), 1,
      sym_argument_list,
    STATE(18045), 2,
      sym_block_comment,
      sym_line_comment,
  [387819] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9762), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18046), 2,
      sym_block_comment,
      sym_line_comment,
  [387834] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24838), 1,
      anon_sym_LPAREN,
    STATE(4853), 1,
      sym_argument_list,
    STATE(18047), 2,
      sym_block_comment,
      sym_line_comment,
  [387851] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24846), 2,
      anon_sym_end,
      anon_sym_finally,
    STATE(18048), 2,
      sym_block_comment,
      sym_line_comment,
  [387866] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14958), 1,
      anon_sym_LBRACE,
    STATE(6197), 1,
      sym_curly_expression,
    STATE(18049), 2,
      sym_block_comment,
      sym_line_comment,
  [387883] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24610), 1,
      anon_sym_LPAREN,
    STATE(4967), 1,
      sym_argument_list,
    STATE(18050), 2,
      sym_block_comment,
      sym_line_comment,
  [387900] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8002), 1,
      anon_sym_RPAREN,
    ACTIONS(24848), 1,
      anon_sym_SEMI,
    STATE(18051), 2,
      sym_block_comment,
      sym_line_comment,
  [387917] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7270), 1,
      anon_sym_RPAREN,
    ACTIONS(24850), 1,
      anon_sym_SEMI,
    STATE(18052), 2,
      sym_block_comment,
      sym_line_comment,
  [387934] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16987), 1,
      anon_sym_COMMA,
    STATE(14917), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18053), 2,
      sym_block_comment,
      sym_line_comment,
  [387951] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10030), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18054), 2,
      sym_block_comment,
      sym_line_comment,
  [387966] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8834), 1,
      anon_sym_RPAREN,
    ACTIONS(24852), 1,
      anon_sym_SEMI,
    STATE(18055), 2,
      sym_block_comment,
      sym_line_comment,
  [387983] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24838), 1,
      anon_sym_LPAREN,
    STATE(4819), 1,
      sym_argument_list,
    STATE(18056), 2,
      sym_block_comment,
      sym_line_comment,
  [388000] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14526), 1,
      anon_sym_LBRACE,
    STATE(5162), 1,
      sym_curly_expression,
    STATE(18057), 2,
      sym_block_comment,
      sym_line_comment,
  [388017] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1293), 1,
      anon_sym_LBRACE,
    STATE(5763), 1,
      sym_curly_expression,
    STATE(18058), 2,
      sym_block_comment,
      sym_line_comment,
  [388034] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24610), 1,
      anon_sym_LPAREN,
    STATE(4969), 1,
      sym_argument_list,
    STATE(18059), 2,
      sym_block_comment,
      sym_line_comment,
  [388051] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13704), 1,
      anon_sym_LBRACE,
    STATE(5993), 1,
      sym_curly_expression,
    STATE(18060), 2,
      sym_block_comment,
      sym_line_comment,
  [388068] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24800), 1,
      anon_sym_LPAREN,
    STATE(4204), 1,
      sym_argument_list,
    STATE(18061), 2,
      sym_block_comment,
      sym_line_comment,
  [388085] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8398), 1,
      anon_sym_RPAREN,
    ACTIONS(24854), 1,
      anon_sym_SEMI,
    STATE(18062), 2,
      sym_block_comment,
      sym_line_comment,
  [388102] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24782), 1,
      anon_sym_LPAREN,
    STATE(11553), 1,
      sym_argument_list,
    STATE(18063), 2,
      sym_block_comment,
      sym_line_comment,
  [388119] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15826), 1,
      anon_sym_LBRACE,
    STATE(6683), 1,
      sym_curly_expression,
    STATE(18064), 2,
      sym_block_comment,
      sym_line_comment,
  [388136] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24856), 1,
      anon_sym_LPAREN,
    STATE(5103), 1,
      sym_argument_list,
    STATE(18065), 2,
      sym_block_comment,
      sym_line_comment,
  [388153] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(61), 1,
      anon_sym_LBRACE,
    STATE(9998), 1,
      sym_curly_expression,
    STATE(18066), 2,
      sym_block_comment,
      sym_line_comment,
  [388170] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16090), 1,
      anon_sym_LBRACE,
    STATE(7108), 1,
      sym_curly_expression,
    STATE(18067), 2,
      sym_block_comment,
      sym_line_comment,
  [388187] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8198), 1,
      anon_sym_RPAREN,
    ACTIONS(24858), 1,
      anon_sym_SEMI,
    STATE(18068), 2,
      sym_block_comment,
      sym_line_comment,
  [388204] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1293), 1,
      anon_sym_LBRACE,
    STATE(5765), 1,
      sym_curly_expression,
    STATE(18069), 2,
      sym_block_comment,
      sym_line_comment,
  [388221] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14958), 1,
      anon_sym_LBRACE,
    STATE(6142), 1,
      sym_curly_expression,
    STATE(18070), 2,
      sym_block_comment,
      sym_line_comment,
  [388238] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24856), 1,
      anon_sym_LPAREN,
    STATE(5113), 1,
      sym_argument_list,
    STATE(18071), 2,
      sym_block_comment,
      sym_line_comment,
  [388255] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10034), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18072), 2,
      sym_block_comment,
      sym_line_comment,
  [388270] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14958), 1,
      anon_sym_LBRACE,
    STATE(6144), 1,
      sym_curly_expression,
    STATE(18073), 2,
      sym_block_comment,
      sym_line_comment,
  [388287] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13270), 1,
      anon_sym_LBRACE,
    STATE(5455), 1,
      sym_curly_expression,
    STATE(18074), 2,
      sym_block_comment,
      sym_line_comment,
  [388304] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(3075), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18075), 2,
      sym_block_comment,
      sym_line_comment,
  [388319] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8544), 1,
      anon_sym_RPAREN,
    ACTIONS(24860), 1,
      anon_sym_SEMI,
    STATE(18076), 2,
      sym_block_comment,
      sym_line_comment,
  [388336] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24810), 1,
      anon_sym_LPAREN,
    STATE(6365), 1,
      sym_argument_list,
    STATE(18077), 2,
      sym_block_comment,
      sym_line_comment,
  [388353] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    STATE(5737), 1,
      sym_curly_expression,
    STATE(18078), 2,
      sym_block_comment,
      sym_line_comment,
  [388370] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17175), 1,
      anon_sym_COMMA,
    STATE(14380), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18079), 2,
      sym_block_comment,
      sym_line_comment,
  [388387] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24632), 1,
      anon_sym_LPAREN,
    STATE(4950), 1,
      sym_argument_list,
    STATE(18080), 2,
      sym_block_comment,
      sym_line_comment,
  [388404] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10038), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18081), 2,
      sym_block_comment,
      sym_line_comment,
  [388419] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8260), 1,
      anon_sym_RPAREN,
    ACTIONS(24862), 1,
      anon_sym_SEMI,
    STATE(18082), 2,
      sym_block_comment,
      sym_line_comment,
  [388436] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16000), 1,
      anon_sym_LBRACE,
    STATE(11296), 1,
      sym_curly_expression,
    STATE(18083), 2,
      sym_block_comment,
      sym_line_comment,
  [388453] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7560), 1,
      anon_sym_RPAREN,
    ACTIONS(24864), 1,
      anon_sym_SEMI,
    STATE(18084), 2,
      sym_block_comment,
      sym_line_comment,
  [388470] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14652), 1,
      anon_sym_LBRACE,
    STATE(7054), 1,
      sym_curly_expression,
    STATE(18085), 2,
      sym_block_comment,
      sym_line_comment,
  [388487] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14842), 1,
      anon_sym_LBRACE,
    STATE(5739), 1,
      sym_curly_expression,
    STATE(18086), 2,
      sym_block_comment,
      sym_line_comment,
  [388504] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24656), 1,
      anon_sym_LPAREN,
    STATE(9737), 1,
      sym_argument_list,
    STATE(18087), 2,
      sym_block_comment,
      sym_line_comment,
  [388521] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14572), 1,
      anon_sym_LBRACE,
    STATE(11341), 1,
      sym_curly_expression,
    STATE(18088), 2,
      sym_block_comment,
      sym_line_comment,
  [388538] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24866), 1,
      anon_sym_LPAREN,
    STATE(10706), 1,
      sym_argument_list,
    STATE(18089), 2,
      sym_block_comment,
      sym_line_comment,
  [388555] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8382), 1,
      anon_sym_RPAREN,
    ACTIONS(24868), 1,
      anon_sym_SEMI,
    STATE(18090), 2,
      sym_block_comment,
      sym_line_comment,
  [388572] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14572), 1,
      anon_sym_LBRACE,
    STATE(11338), 1,
      sym_curly_expression,
    STATE(18091), 2,
      sym_block_comment,
      sym_line_comment,
  [388589] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24866), 1,
      anon_sym_LPAREN,
    STATE(10711), 1,
      sym_argument_list,
    STATE(18092), 2,
      sym_block_comment,
      sym_line_comment,
  [388606] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7228), 1,
      anon_sym_RPAREN,
    ACTIONS(24870), 1,
      anon_sym_SEMI,
    STATE(18093), 2,
      sym_block_comment,
      sym_line_comment,
  [388623] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24632), 1,
      anon_sym_LPAREN,
    STATE(4953), 1,
      sym_argument_list,
    STATE(18094), 2,
      sym_block_comment,
      sym_line_comment,
  [388640] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(1795), 1,
      anon_sym_LBRACE,
    STATE(9784), 1,
      sym_curly_expression,
    STATE(18095), 2,
      sym_block_comment,
      sym_line_comment,
  [388657] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10042), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18096), 2,
      sym_block_comment,
      sym_line_comment,
  [388672] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    STATE(10414), 1,
      sym_curly_expression,
    STATE(18097), 2,
      sym_block_comment,
      sym_line_comment,
  [388689] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15026), 1,
      anon_sym_LBRACE,
    STATE(5566), 1,
      sym_curly_expression,
    STATE(18098), 2,
      sym_block_comment,
      sym_line_comment,
  [388706] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14572), 1,
      anon_sym_LBRACE,
    STATE(11352), 1,
      sym_curly_expression,
    STATE(18099), 2,
      sym_block_comment,
      sym_line_comment,
  [388723] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24620), 1,
      anon_sym_LPAREN,
    STATE(5018), 1,
      sym_argument_list,
    STATE(18100), 2,
      sym_block_comment,
      sym_line_comment,
  [388740] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7666), 1,
      anon_sym_RPAREN,
    ACTIONS(24872), 1,
      anon_sym_SEMI,
    STATE(18101), 2,
      sym_block_comment,
      sym_line_comment,
  [388757] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9960), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18102), 2,
      sym_block_comment,
      sym_line_comment,
  [388772] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24874), 1,
      anon_sym_LPAREN,
    STATE(4210), 1,
      sym_argument_list,
    STATE(18103), 2,
      sym_block_comment,
      sym_line_comment,
  [388789] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24674), 1,
      anon_sym_LPAREN,
    STATE(10166), 1,
      sym_argument_list,
    STATE(18104), 2,
      sym_block_comment,
      sym_line_comment,
  [388806] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14842), 1,
      anon_sym_LBRACE,
    STATE(5741), 1,
      sym_curly_expression,
    STATE(18105), 2,
      sym_block_comment,
      sym_line_comment,
  [388823] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24686), 1,
      anon_sym_LPAREN,
    STATE(10072), 1,
      sym_argument_list,
    STATE(18106), 2,
      sym_block_comment,
      sym_line_comment,
  [388840] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15782), 1,
      anon_sym_LBRACE,
    STATE(10536), 1,
      sym_curly_expression,
    STATE(18107), 2,
      sym_block_comment,
      sym_line_comment,
  [388857] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24830), 1,
      anon_sym_LPAREN,
    STATE(9904), 1,
      sym_argument_list,
    STATE(18108), 2,
      sym_block_comment,
      sym_line_comment,
  [388874] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16812), 1,
      anon_sym_COMMA,
    STATE(14975), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18109), 2,
      sym_block_comment,
      sym_line_comment,
  [388891] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24682), 1,
      anon_sym_LPAREN,
    STATE(10631), 1,
      sym_argument_list,
    STATE(18110), 2,
      sym_block_comment,
      sym_line_comment,
  [388908] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7146), 1,
      anon_sym_RPAREN,
    ACTIONS(24876), 1,
      anon_sym_SEMI,
    STATE(18111), 2,
      sym_block_comment,
      sym_line_comment,
  [388925] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9740), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18112), 2,
      sym_block_comment,
      sym_line_comment,
  [388940] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8574), 1,
      anon_sym_RPAREN,
    ACTIONS(24878), 1,
      anon_sym_SEMI,
    STATE(18113), 2,
      sym_block_comment,
      sym_line_comment,
  [388957] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24716), 1,
      anon_sym_LPAREN,
    STATE(4229), 1,
      sym_argument_list,
    STATE(18114), 2,
      sym_block_comment,
      sym_line_comment,
  [388974] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8174), 1,
      anon_sym_RPAREN,
    ACTIONS(24880), 1,
      anon_sym_SEMI,
    STATE(18115), 2,
      sym_block_comment,
      sym_line_comment,
  [388991] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7290), 1,
      anon_sym_RPAREN,
    ACTIONS(24882), 1,
      anon_sym_SEMI,
    STATE(18116), 2,
      sym_block_comment,
      sym_line_comment,
  [389008] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14982), 1,
      anon_sym_LBRACE,
    STATE(10856), 1,
      sym_curly_expression,
    STATE(18117), 2,
      sym_block_comment,
      sym_line_comment,
  [389025] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24682), 1,
      anon_sym_LPAREN,
    STATE(10634), 1,
      sym_argument_list,
    STATE(18118), 2,
      sym_block_comment,
      sym_line_comment,
  [389042] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16941), 1,
      anon_sym_COMMA,
    STATE(15035), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18119), 2,
      sym_block_comment,
      sym_line_comment,
  [389059] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15984), 1,
      anon_sym_LBRACE,
    STATE(6840), 1,
      sym_curly_expression,
    STATE(18120), 2,
      sym_block_comment,
      sym_line_comment,
  [389076] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7490), 1,
      anon_sym_RPAREN,
    ACTIONS(24884), 1,
      anon_sym_SEMI,
    STATE(18121), 2,
      sym_block_comment,
      sym_line_comment,
  [389093] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7398), 1,
      anon_sym_RPAREN,
    ACTIONS(24886), 1,
      anon_sym_SEMI,
    STATE(18122), 2,
      sym_block_comment,
      sym_line_comment,
  [389110] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8228), 1,
      anon_sym_RPAREN,
    ACTIONS(24888), 1,
      anon_sym_SEMI,
    STATE(18123), 2,
      sym_block_comment,
      sym_line_comment,
  [389127] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24856), 1,
      anon_sym_LPAREN,
    STATE(5167), 1,
      sym_argument_list,
    STATE(18124), 2,
      sym_block_comment,
      sym_line_comment,
  [389144] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24734), 1,
      anon_sym_LPAREN,
    STATE(9852), 1,
      sym_argument_list,
    STATE(18125), 2,
      sym_block_comment,
      sym_line_comment,
  [389161] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24830), 1,
      anon_sym_LPAREN,
    STATE(9897), 1,
      sym_argument_list,
    STATE(18126), 2,
      sym_block_comment,
      sym_line_comment,
  [389178] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9886), 1,
      anon_sym_LBRACE,
    STATE(10142), 1,
      sym_curly_expression,
    STATE(18127), 2,
      sym_block_comment,
      sym_line_comment,
  [389195] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    STATE(10431), 1,
      sym_curly_expression,
    STATE(18128), 2,
      sym_block_comment,
      sym_line_comment,
  [389212] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14982), 1,
      anon_sym_LBRACE,
    STATE(10858), 1,
      sym_curly_expression,
    STATE(18129), 2,
      sym_block_comment,
      sym_line_comment,
  [389229] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13890), 1,
      anon_sym_LBRACE,
    STATE(5668), 1,
      sym_curly_expression,
    STATE(18130), 2,
      sym_block_comment,
      sym_line_comment,
  [389246] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17073), 1,
      anon_sym_COMMA,
    STATE(14571), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18131), 2,
      sym_block_comment,
      sym_line_comment,
  [389263] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24620), 1,
      anon_sym_LPAREN,
    STATE(5020), 1,
      sym_argument_list,
    STATE(18132), 2,
      sym_block_comment,
      sym_line_comment,
  [389280] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24716), 1,
      anon_sym_LPAREN,
    STATE(4225), 1,
      sym_argument_list,
    STATE(18133), 2,
      sym_block_comment,
      sym_line_comment,
  [389297] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7182), 1,
      anon_sym_RPAREN,
    ACTIONS(24890), 1,
      anon_sym_SEMI,
    STATE(18134), 2,
      sym_block_comment,
      sym_line_comment,
  [389314] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4494), 1,
      anon_sym_LBRACE,
    STATE(10351), 1,
      sym_curly_expression,
    STATE(18135), 2,
      sym_block_comment,
      sym_line_comment,
  [389331] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24674), 1,
      anon_sym_LPAREN,
    STATE(10168), 1,
      sym_argument_list,
    STATE(18136), 2,
      sym_block_comment,
      sym_line_comment,
  [389348] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14228), 1,
      anon_sym_LBRACE,
    STATE(10438), 1,
      sym_curly_expression,
    STATE(18137), 2,
      sym_block_comment,
      sym_line_comment,
  [389365] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9746), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18138), 2,
      sym_block_comment,
      sym_line_comment,
  [389380] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8278), 1,
      anon_sym_RPAREN,
    ACTIONS(24892), 1,
      anon_sym_SEMI,
    STATE(18139), 2,
      sym_block_comment,
      sym_line_comment,
  [389397] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24874), 1,
      anon_sym_LPAREN,
    STATE(4209), 1,
      sym_argument_list,
    STATE(18140), 2,
      sym_block_comment,
      sym_line_comment,
  [389414] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24866), 1,
      anon_sym_LPAREN,
    STATE(10780), 1,
      sym_argument_list,
    STATE(18141), 2,
      sym_block_comment,
      sym_line_comment,
  [389431] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7536), 1,
      anon_sym_RPAREN,
    ACTIONS(24894), 1,
      anon_sym_SEMI,
    STATE(18142), 2,
      sym_block_comment,
      sym_line_comment,
  [389448] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17161), 1,
      anon_sym_COMMA,
    STATE(15000), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18143), 2,
      sym_block_comment,
      sym_line_comment,
  [389465] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13502), 1,
      anon_sym_LBRACE,
    STATE(6387), 1,
      sym_curly_expression,
    STATE(18144), 2,
      sym_block_comment,
      sym_line_comment,
  [389482] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7680), 1,
      anon_sym_RPAREN,
    ACTIONS(24896), 1,
      anon_sym_SEMI,
    STATE(18145), 2,
      sym_block_comment,
      sym_line_comment,
  [389499] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8468), 1,
      anon_sym_RPAREN,
    ACTIONS(24898), 1,
      anon_sym_SEMI,
    STATE(18146), 2,
      sym_block_comment,
      sym_line_comment,
  [389516] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7306), 1,
      anon_sym_RPAREN,
    ACTIONS(24900), 1,
      anon_sym_SEMI,
    STATE(18147), 2,
      sym_block_comment,
      sym_line_comment,
  [389533] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16118), 1,
      anon_sym_LBRACE,
    STATE(8624), 1,
      sym_curly_expression,
    STATE(18148), 2,
      sym_block_comment,
      sym_line_comment,
  [389550] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15850), 1,
      anon_sym_LBRACE,
    STATE(8477), 1,
      sym_curly_expression,
    STATE(18149), 2,
      sym_block_comment,
      sym_line_comment,
  [389567] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24902), 2,
      anon_sym_end,
      anon_sym_catch,
    STATE(18150), 2,
      sym_block_comment,
      sym_line_comment,
  [389582] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24856), 1,
      anon_sym_LPAREN,
    STATE(5218), 1,
      sym_argument_list,
    STATE(18151), 2,
      sym_block_comment,
      sym_line_comment,
  [389599] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8248), 1,
      anon_sym_RPAREN,
    ACTIONS(24904), 1,
      anon_sym_SEMI,
    STATE(18152), 2,
      sym_block_comment,
      sym_line_comment,
  [389616] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7514), 1,
      anon_sym_RPAREN,
    ACTIONS(24906), 1,
      anon_sym_SEMI,
    STATE(18153), 2,
      sym_block_comment,
      sym_line_comment,
  [389633] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14958), 1,
      anon_sym_LBRACE,
    STATE(6150), 1,
      sym_curly_expression,
    STATE(18154), 2,
      sym_block_comment,
      sym_line_comment,
  [389650] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    STATE(4520), 1,
      sym_curly_expression,
    STATE(18155), 2,
      sym_block_comment,
      sym_line_comment,
  [389667] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8562), 1,
      anon_sym_RPAREN,
    ACTIONS(24908), 1,
      anon_sym_SEMI,
    STATE(18156), 2,
      sym_block_comment,
      sym_line_comment,
  [389684] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24734), 1,
      anon_sym_LPAREN,
    STATE(9856), 1,
      sym_argument_list,
    STATE(18157), 2,
      sym_block_comment,
      sym_line_comment,
  [389701] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16848), 1,
      anon_sym_COMMA,
    STATE(14434), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18158), 2,
      sym_block_comment,
      sym_line_comment,
  [389718] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9734), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18159), 2,
      sym_block_comment,
      sym_line_comment,
  [389733] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24866), 1,
      anon_sym_LPAREN,
    STATE(10830), 1,
      sym_argument_list,
    STATE(18160), 2,
      sym_block_comment,
      sym_line_comment,
  [389750] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(871), 1,
      anon_sym_LBRACE,
    STATE(4661), 1,
      sym_curly_expression,
    STATE(18161), 2,
      sym_block_comment,
      sym_line_comment,
  [389767] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14572), 1,
      anon_sym_LBRACE,
    STATE(11370), 1,
      sym_curly_expression,
    STATE(18162), 2,
      sym_block_comment,
      sym_line_comment,
  [389784] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9792), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18163), 2,
      sym_block_comment,
      sym_line_comment,
  [389799] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16064), 1,
      anon_sym_LBRACE,
    STATE(15595), 1,
      sym_curly_expression,
    STATE(18164), 2,
      sym_block_comment,
      sym_line_comment,
  [389816] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10579), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18165), 2,
      sym_block_comment,
      sym_line_comment,
  [389831] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24642), 1,
      anon_sym_LPAREN,
    STATE(4148), 1,
      sym_argument_list,
    STATE(18166), 2,
      sym_block_comment,
      sym_line_comment,
  [389848] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17115), 1,
      anon_sym_COMMA,
    STATE(14290), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18167), 2,
      sym_block_comment,
      sym_line_comment,
  [389865] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24640), 1,
      anon_sym_LPAREN,
    STATE(4925), 1,
      sym_argument_list,
    STATE(18168), 2,
      sym_block_comment,
      sym_line_comment,
  [389882] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8056), 1,
      anon_sym_RPAREN,
    ACTIONS(24910), 1,
      anon_sym_SEMI,
    STATE(18169), 2,
      sym_block_comment,
      sym_line_comment,
  [389899] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10046), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18170), 2,
      sym_block_comment,
      sym_line_comment,
  [389914] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    STATE(4562), 1,
      sym_curly_expression,
    STATE(18171), 2,
      sym_block_comment,
      sym_line_comment,
  [389931] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(871), 1,
      anon_sym_LBRACE,
    STATE(4648), 1,
      sym_curly_expression,
    STATE(18172), 2,
      sym_block_comment,
      sym_line_comment,
  [389948] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8318), 1,
      anon_sym_RPAREN,
    ACTIONS(24912), 1,
      anon_sym_SEMI,
    STATE(18173), 2,
      sym_block_comment,
      sym_line_comment,
  [389965] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16798), 1,
      anon_sym_COMMA,
    STATE(14454), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18174), 2,
      sym_block_comment,
      sym_line_comment,
  [389982] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24874), 1,
      anon_sym_LPAREN,
    STATE(4206), 1,
      sym_argument_list,
    STATE(18175), 2,
      sym_block_comment,
      sym_line_comment,
  [389999] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(871), 1,
      anon_sym_LBRACE,
    STATE(4651), 1,
      sym_curly_expression,
    STATE(18176), 2,
      sym_block_comment,
      sym_line_comment,
  [390016] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24874), 1,
      anon_sym_LPAREN,
    STATE(4208), 1,
      sym_argument_list,
    STATE(18177), 2,
      sym_block_comment,
      sym_line_comment,
  [390033] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24734), 1,
      anon_sym_LPAREN,
    STATE(9845), 1,
      sym_argument_list,
    STATE(18178), 2,
      sym_block_comment,
      sym_line_comment,
  [390050] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13270), 1,
      anon_sym_LBRACE,
    STATE(5838), 1,
      sym_curly_expression,
    STATE(18179), 2,
      sym_block_comment,
      sym_line_comment,
  [390067] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24610), 1,
      anon_sym_LPAREN,
    STATE(4970), 1,
      sym_argument_list,
    STATE(18180), 2,
      sym_block_comment,
      sym_line_comment,
  [390084] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24640), 1,
      anon_sym_LPAREN,
    STATE(4927), 1,
      sym_argument_list,
    STATE(18181), 2,
      sym_block_comment,
      sym_line_comment,
  [390101] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10639), 1,
      anon_sym_RPAREN,
    ACTIONS(24914), 1,
      anon_sym_DOT,
    STATE(18182), 2,
      sym_block_comment,
      sym_line_comment,
  [390118] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(871), 1,
      anon_sym_LBRACE,
    STATE(4654), 1,
      sym_curly_expression,
    STATE(18183), 2,
      sym_block_comment,
      sym_line_comment,
  [390135] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6890), 1,
      anon_sym_LBRACE,
    STATE(4922), 1,
      sym_curly_expression,
    STATE(18184), 2,
      sym_block_comment,
      sym_line_comment,
  [390152] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24642), 1,
      anon_sym_LPAREN,
    STATE(4150), 1,
      sym_argument_list,
    STATE(18185), 2,
      sym_block_comment,
      sym_line_comment,
  [390169] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16834), 1,
      anon_sym_COMMA,
    STATE(14543), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18186), 2,
      sym_block_comment,
      sym_line_comment,
  [390186] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13270), 1,
      anon_sym_LBRACE,
    STATE(5840), 1,
      sym_curly_expression,
    STATE(18187), 2,
      sym_block_comment,
      sym_line_comment,
  [390203] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10050), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18188), 2,
      sym_block_comment,
      sym_line_comment,
  [390218] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16102), 1,
      anon_sym_LBRACE,
    STATE(17978), 1,
      sym_curly_expression,
    STATE(18189), 2,
      sym_block_comment,
      sym_line_comment,
  [390235] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8372), 1,
      anon_sym_RPAREN,
    ACTIONS(24916), 1,
      anon_sym_SEMI,
    STATE(18190), 2,
      sym_block_comment,
      sym_line_comment,
  [390252] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8594), 1,
      anon_sym_RPAREN,
    ACTIONS(24918), 1,
      anon_sym_SEMI,
    STATE(18191), 2,
      sym_block_comment,
      sym_line_comment,
  [390269] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(4942), 1,
      anon_sym_LBRACE,
    STATE(4626), 1,
      sym_curly_expression,
    STATE(18192), 2,
      sym_block_comment,
      sym_line_comment,
  [390286] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16748), 1,
      anon_sym_COMMA,
    STATE(14635), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18193), 2,
      sym_block_comment,
      sym_line_comment,
  [390303] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6986), 1,
      anon_sym_RPAREN,
    ACTIONS(24920), 1,
      anon_sym_SEMI,
    STATE(18194), 2,
      sym_block_comment,
      sym_line_comment,
  [390320] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7896), 1,
      anon_sym_RPAREN,
    ACTIONS(24922), 1,
      anon_sym_SEMI,
    STATE(18195), 2,
      sym_block_comment,
      sym_line_comment,
  [390337] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24800), 1,
      anon_sym_LPAREN,
    STATE(4205), 1,
      sym_argument_list,
    STATE(18196), 2,
      sym_block_comment,
      sym_line_comment,
  [390354] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24782), 1,
      anon_sym_LPAREN,
    STATE(11571), 1,
      sym_argument_list,
    STATE(18197), 2,
      sym_block_comment,
      sym_line_comment,
  [390371] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17091), 1,
      anon_sym_COMMA,
    STATE(14706), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18198), 2,
      sym_block_comment,
      sym_line_comment,
  [390388] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8292), 1,
      anon_sym_LBRACE,
    STATE(4635), 1,
      sym_curly_expression,
    STATE(18199), 2,
      sym_block_comment,
      sym_line_comment,
  [390405] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7018), 1,
      anon_sym_RPAREN,
    ACTIONS(24924), 1,
      anon_sym_SEMI,
    STATE(18200), 2,
      sym_block_comment,
      sym_line_comment,
  [390422] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7630), 1,
      anon_sym_RPAREN,
    ACTIONS(24926), 1,
      anon_sym_SEMI,
    STATE(18201), 2,
      sym_block_comment,
      sym_line_comment,
  [390439] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16686), 1,
      anon_sym_COMMA,
    STATE(14854), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18202), 2,
      sym_block_comment,
      sym_line_comment,
  [390456] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13890), 1,
      anon_sym_LBRACE,
    STATE(5670), 1,
      sym_curly_expression,
    STATE(18203), 2,
      sym_block_comment,
      sym_line_comment,
  [390473] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    STATE(4294), 1,
      sym_curly_expression,
    STATE(18204), 2,
      sym_block_comment,
      sym_line_comment,
  [390490] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24606), 1,
      anon_sym_LPAREN,
    STATE(4133), 1,
      sym_argument_list,
    STATE(18205), 2,
      sym_block_comment,
      sym_line_comment,
  [390507] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    STATE(4383), 1,
      sym_curly_expression,
    STATE(18206), 2,
      sym_block_comment,
      sym_line_comment,
  [390524] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24606), 1,
      anon_sym_LPAREN,
    STATE(4130), 1,
      sym_argument_list,
    STATE(18207), 2,
      sym_block_comment,
      sym_line_comment,
  [390541] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7748), 1,
      anon_sym_LBRACE,
    STATE(4400), 1,
      sym_curly_expression,
    STATE(18208), 2,
      sym_block_comment,
      sym_line_comment,
  [390558] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13596), 1,
      anon_sym_LBRACE,
    STATE(11883), 1,
      sym_curly_expression,
    STATE(18209), 2,
      sym_block_comment,
      sym_line_comment,
  [390575] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24614), 1,
      anon_sym_LPAREN,
    STATE(5612), 1,
      sym_argument_list,
    STATE(18210), 2,
      sym_block_comment,
      sym_line_comment,
  [390592] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16881), 1,
      anon_sym_COMMA,
    STATE(14933), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18211), 2,
      sym_block_comment,
      sym_line_comment,
  [390609] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7118), 1,
      anon_sym_RPAREN,
    ACTIONS(24928), 1,
      anon_sym_SEMI,
    STATE(18212), 2,
      sym_block_comment,
      sym_line_comment,
  [390626] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9716), 2,
      anon_sym_RPAREN,
      anon_sym_DOT,
    STATE(18213), 2,
      sym_block_comment,
      sym_line_comment,
  [390641] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7216), 1,
      anon_sym_RPAREN,
    ACTIONS(24930), 1,
      anon_sym_SEMI,
    STATE(18214), 2,
      sym_block_comment,
      sym_line_comment,
  [390658] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7370), 1,
      anon_sym_LBRACE,
    STATE(4740), 1,
      sym_curly_expression,
    STATE(18215), 2,
      sym_block_comment,
      sym_line_comment,
  [390675] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17155), 1,
      anon_sym_COMMA,
    STATE(15094), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18216), 2,
      sym_block_comment,
      sym_line_comment,
  [390692] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7894), 1,
      anon_sym_RPAREN,
    ACTIONS(24932), 1,
      anon_sym_SEMI,
    STATE(18217), 2,
      sym_block_comment,
      sym_line_comment,
  [390709] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15872), 1,
      anon_sym_LBRACE,
    STATE(7730), 1,
      sym_curly_expression,
    STATE(18218), 2,
      sym_block_comment,
      sym_line_comment,
  [390726] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8506), 1,
      anon_sym_RPAREN,
    ACTIONS(24934), 1,
      anon_sym_SEMI,
    STATE(18219), 2,
      sym_block_comment,
      sym_line_comment,
  [390743] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(17242), 1,
      anon_sym_COMMA,
    STATE(14569), 1,
      aux_sym_tuple_expression_repeat1,
    STATE(18220), 2,
      sym_block_comment,
      sym_line_comment,
  [390760] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8268), 1,
      anon_sym_RPAREN,
    ACTIONS(24936), 1,
      anon_sym_SEMI,
    STATE(18221), 2,
      sym_block_comment,
      sym_line_comment,
  [390777] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(14982), 1,
      anon_sym_LBRACE,
    STATE(11043), 1,
      sym_curly_expression,
    STATE(18222), 2,
      sym_block_comment,
      sym_line_comment,
  [390794] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24800), 1,
      anon_sym_LPAREN,
    STATE(4201), 1,
      sym_argument_list,
    STATE(18223), 2,
      sym_block_comment,
      sym_line_comment,
  [390811] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7820), 1,
      anon_sym_RPAREN,
    ACTIONS(24938), 1,
      anon_sym_SEMI,
    STATE(18224), 2,
      sym_block_comment,
      sym_line_comment,
  [390828] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13502), 1,
      anon_sym_LBRACE,
    STATE(6384), 1,
      sym_curly_expression,
    STATE(18225), 2,
      sym_block_comment,
      sym_line_comment,
  [390845] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8292), 1,
      anon_sym_LBRACE,
    STATE(4622), 1,
      sym_curly_expression,
    STATE(18226), 2,
      sym_block_comment,
      sym_line_comment,
  [390862] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16082), 1,
      anon_sym_LBRACE,
    STATE(7850), 1,
      sym_curly_expression,
    STATE(18227), 2,
      sym_block_comment,
      sym_line_comment,
  [390879] = 5,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7234), 1,
      anon_sym_RPAREN,
    ACTIONS(24940), 1,
      anon_sym_SEMI,
    STATE(18228), 2,
      sym_block_comment,
      sym_line_comment,
  [390896] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8258), 1,
      anon_sym_RPAREN,
    STATE(18229), 2,
      sym_block_comment,
      sym_line_comment,
  [390910] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8516), 1,
      anon_sym_RPAREN,
    STATE(18230), 2,
      sym_block_comment,
      sym_line_comment,
  [390924] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24942), 1,
      anon_sym_EQ,
    STATE(18231), 2,
      sym_block_comment,
      sym_line_comment,
  [390938] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24944), 1,
      anon_sym_end,
    STATE(18232), 2,
      sym_block_comment,
      sym_line_comment,
  [390952] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24946), 1,
      anon_sym_RBRACK,
    STATE(18233), 2,
      sym_block_comment,
      sym_line_comment,
  [390966] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(11022), 1,
      anon_sym_COLON2,
    STATE(18234), 2,
      sym_block_comment,
      sym_line_comment,
  [390980] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10489), 1,
      sym__immediate_paren,
    STATE(18235), 2,
      sym_block_comment,
      sym_line_comment,
  [390994] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24948), 1,
      anon_sym_end,
    STATE(18236), 2,
      sym_block_comment,
      sym_line_comment,
  [391008] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19122), 1,
      anon_sym_RBRACE,
    STATE(18237), 2,
      sym_block_comment,
      sym_line_comment,
  [391022] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24950), 1,
      anon_sym_end,
    STATE(18238), 2,
      sym_block_comment,
      sym_line_comment,
  [391036] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24952), 1,
      anon_sym_end,
    STATE(18239), 2,
      sym_block_comment,
      sym_line_comment,
  [391050] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24954), 1,
      anon_sym_COLON2,
    STATE(18240), 2,
      sym_block_comment,
      sym_line_comment,
  [391064] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12996), 1,
      anon_sym_RPAREN,
    STATE(18241), 2,
      sym_block_comment,
      sym_line_comment,
  [391078] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8072), 1,
      anon_sym_RPAREN,
    STATE(18242), 2,
      sym_block_comment,
      sym_line_comment,
  [391092] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8732), 1,
      anon_sym_RPAREN,
    STATE(18243), 2,
      sym_block_comment,
      sym_line_comment,
  [391106] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24956), 1,
      anon_sym_end,
    STATE(18244), 2,
      sym_block_comment,
      sym_line_comment,
  [391120] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24958), 1,
      anon_sym_RBRACK,
    STATE(18245), 2,
      sym_block_comment,
      sym_line_comment,
  [391134] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24960), 1,
      anon_sym_end,
    STATE(18246), 2,
      sym_block_comment,
      sym_line_comment,
  [391148] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8698), 1,
      anon_sym_RPAREN,
    STATE(18247), 2,
      sym_block_comment,
      sym_line_comment,
  [391162] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24962), 1,
      anon_sym_RBRACK,
    STATE(18248), 2,
      sym_block_comment,
      sym_line_comment,
  [391176] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24964), 1,
      anon_sym_end,
    STATE(18249), 2,
      sym_block_comment,
      sym_line_comment,
  [391190] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24966), 1,
      anon_sym_RPAREN,
    STATE(18250), 2,
      sym_block_comment,
      sym_line_comment,
  [391204] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6924), 1,
      anon_sym_RPAREN,
    STATE(18251), 2,
      sym_block_comment,
      sym_line_comment,
  [391218] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24968), 1,
      anon_sym_COLON2,
    STATE(18252), 2,
      sym_block_comment,
      sym_line_comment,
  [391232] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24970), 1,
      anon_sym_end,
    STATE(18253), 2,
      sym_block_comment,
      sym_line_comment,
  [391246] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24972), 1,
      anon_sym_end,
    STATE(18254), 2,
      sym_block_comment,
      sym_line_comment,
  [391260] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13072), 1,
      anon_sym_RPAREN,
    STATE(18255), 2,
      sym_block_comment,
      sym_line_comment,
  [391274] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24974), 1,
      anon_sym_end,
    STATE(18256), 2,
      sym_block_comment,
      sym_line_comment,
  [391288] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13072), 1,
      anon_sym_RPAREN,
    STATE(18257), 2,
      sym_block_comment,
      sym_line_comment,
  [391302] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24976), 1,
      anon_sym_RBRACK,
    STATE(18258), 2,
      sym_block_comment,
      sym_line_comment,
  [391316] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24978), 1,
      anon_sym_end,
    STATE(18259), 2,
      sym_block_comment,
      sym_line_comment,
  [391330] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24980), 1,
      anon_sym_end,
    STATE(18260), 2,
      sym_block_comment,
      sym_line_comment,
  [391344] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24982), 1,
      anon_sym_end,
    STATE(18261), 2,
      sym_block_comment,
      sym_line_comment,
  [391358] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24984), 1,
      anon_sym_end,
    STATE(18262), 2,
      sym_block_comment,
      sym_line_comment,
  [391372] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24986), 1,
      anon_sym_end,
    STATE(18263), 2,
      sym_block_comment,
      sym_line_comment,
  [391386] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12996), 1,
      anon_sym_RPAREN,
    STATE(18264), 2,
      sym_block_comment,
      sym_line_comment,
  [391400] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24988), 1,
      anon_sym_RPAREN,
    STATE(18265), 2,
      sym_block_comment,
      sym_line_comment,
  [391414] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24990), 1,
      anon_sym_RBRACK,
    STATE(18266), 2,
      sym_block_comment,
      sym_line_comment,
  [391428] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24992), 1,
      anon_sym_EQ,
    STATE(18267), 2,
      sym_block_comment,
      sym_line_comment,
  [391442] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24994), 1,
      anon_sym_type,
    STATE(18268), 2,
      sym_block_comment,
      sym_line_comment,
  [391456] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24996), 1,
      anon_sym_end,
    STATE(18269), 2,
      sym_block_comment,
      sym_line_comment,
  [391470] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24998), 1,
      anon_sym_end,
    STATE(18270), 2,
      sym_block_comment,
      sym_line_comment,
  [391484] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13010), 1,
      anon_sym_RPAREN,
    STATE(18271), 2,
      sym_block_comment,
      sym_line_comment,
  [391498] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8680), 1,
      anon_sym_RPAREN,
    STATE(18272), 2,
      sym_block_comment,
      sym_line_comment,
  [391512] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20972), 1,
      anon_sym_end,
    STATE(18273), 2,
      sym_block_comment,
      sym_line_comment,
  [391526] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7360), 1,
      anon_sym_RPAREN,
    STATE(18274), 2,
      sym_block_comment,
      sym_line_comment,
  [391540] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25000), 1,
      anon_sym_end,
    STATE(18275), 2,
      sym_block_comment,
      sym_line_comment,
  [391554] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8748), 1,
      anon_sym_RPAREN,
    STATE(18276), 2,
      sym_block_comment,
      sym_line_comment,
  [391568] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7162), 1,
      anon_sym_RPAREN,
    STATE(18277), 2,
      sym_block_comment,
      sym_line_comment,
  [391582] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20371), 1,
      anon_sym_end,
    STATE(18278), 2,
      sym_block_comment,
      sym_line_comment,
  [391596] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21085), 1,
      anon_sym_end,
    STATE(18279), 2,
      sym_block_comment,
      sym_line_comment,
  [391610] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25002), 1,
      anon_sym_DASH_GT,
    STATE(18280), 2,
      sym_block_comment,
      sym_line_comment,
  [391624] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25004), 1,
      anon_sym_end,
    STATE(18281), 2,
      sym_block_comment,
      sym_line_comment,
  [391638] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25006), 1,
      anon_sym_end,
    STATE(18282), 2,
      sym_block_comment,
      sym_line_comment,
  [391652] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7714), 1,
      anon_sym_RPAREN,
    STATE(18283), 2,
      sym_block_comment,
      sym_line_comment,
  [391666] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20669), 1,
      anon_sym_end,
    STATE(18284), 2,
      sym_block_comment,
      sym_line_comment,
  [391680] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25008), 1,
      anon_sym_RBRACK,
    STATE(18285), 2,
      sym_block_comment,
      sym_line_comment,
  [391694] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25010), 1,
      anon_sym_end,
    STATE(18286), 2,
      sym_block_comment,
      sym_line_comment,
  [391708] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13106), 1,
      anon_sym_RPAREN,
    STATE(18287), 2,
      sym_block_comment,
      sym_line_comment,
  [391722] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25012), 1,
      anon_sym_RBRACK,
    STATE(18288), 2,
      sym_block_comment,
      sym_line_comment,
  [391736] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13030), 1,
      anon_sym_RPAREN,
    STATE(18289), 2,
      sym_block_comment,
      sym_line_comment,
  [391750] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21180), 1,
      anon_sym_end,
    STATE(18290), 2,
      sym_block_comment,
      sym_line_comment,
  [391764] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25014), 1,
      anon_sym_RPAREN,
    STATE(18291), 2,
      sym_block_comment,
      sym_line_comment,
  [391778] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13030), 1,
      anon_sym_RPAREN,
    STATE(18292), 2,
      sym_block_comment,
      sym_line_comment,
  [391792] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25016), 1,
      anon_sym_RPAREN,
    STATE(18293), 2,
      sym_block_comment,
      sym_line_comment,
  [391806] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7396), 1,
      anon_sym_RPAREN,
    STATE(18294), 2,
      sym_block_comment,
      sym_line_comment,
  [391820] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25018), 1,
      anon_sym_RBRACK,
    STATE(18295), 2,
      sym_block_comment,
      sym_line_comment,
  [391834] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25020), 1,
      anon_sym_COLON2,
    STATE(18296), 2,
      sym_block_comment,
      sym_line_comment,
  [391848] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21152), 1,
      anon_sym_end,
    STATE(18297), 2,
      sym_block_comment,
      sym_line_comment,
  [391862] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25022), 1,
      anon_sym_end,
    STATE(18298), 2,
      sym_block_comment,
      sym_line_comment,
  [391876] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15690), 1,
      anon_sym_DASH_GT,
    STATE(18299), 2,
      sym_block_comment,
      sym_line_comment,
  [391890] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25024), 1,
      anon_sym_end,
    STATE(18300), 2,
      sym_block_comment,
      sym_line_comment,
  [391904] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25026), 1,
      anon_sym_RPAREN,
    STATE(18301), 2,
      sym_block_comment,
      sym_line_comment,
  [391918] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25028), 1,
      anon_sym_end,
    STATE(18302), 2,
      sym_block_comment,
      sym_line_comment,
  [391932] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25030), 1,
      anon_sym_end,
    STATE(18303), 2,
      sym_block_comment,
      sym_line_comment,
  [391946] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25032), 1,
      anon_sym_COLON2,
    STATE(18304), 2,
      sym_block_comment,
      sym_line_comment,
  [391960] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21154), 1,
      anon_sym_end,
    STATE(18305), 2,
      sym_block_comment,
      sym_line_comment,
  [391974] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25034), 1,
      anon_sym_end,
    STATE(18306), 2,
      sym_block_comment,
      sym_line_comment,
  [391988] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25036), 1,
      anon_sym_end,
    STATE(18307), 2,
      sym_block_comment,
      sym_line_comment,
  [392002] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25038), 1,
      anon_sym_end,
    STATE(18308), 2,
      sym_block_comment,
      sym_line_comment,
  [392016] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13010), 1,
      anon_sym_RPAREN,
    STATE(18309), 2,
      sym_block_comment,
      sym_line_comment,
  [392030] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13076), 1,
      anon_sym_RPAREN,
    STATE(18310), 2,
      sym_block_comment,
      sym_line_comment,
  [392044] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25040), 1,
      anon_sym_DASH_GT,
    STATE(18311), 2,
      sym_block_comment,
      sym_line_comment,
  [392058] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20850), 1,
      anon_sym_end,
    STATE(18312), 2,
      sym_block_comment,
      sym_line_comment,
  [392072] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7716), 1,
      anon_sym_RPAREN,
    STATE(18313), 2,
      sym_block_comment,
      sym_line_comment,
  [392086] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25042), 1,
      anon_sym_type,
    STATE(18314), 2,
      sym_block_comment,
      sym_line_comment,
  [392100] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25044), 1,
      anon_sym_struct,
    STATE(18315), 2,
      sym_block_comment,
      sym_line_comment,
  [392114] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25046), 1,
      anon_sym_EQ,
    STATE(18316), 2,
      sym_block_comment,
      sym_line_comment,
  [392128] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25048), 1,
      anon_sym_RPAREN,
    STATE(18317), 2,
      sym_block_comment,
      sym_line_comment,
  [392142] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7232), 1,
      anon_sym_RPAREN,
    STATE(18318), 2,
      sym_block_comment,
      sym_line_comment,
  [392156] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25050), 1,
      anon_sym_end,
    STATE(18319), 2,
      sym_block_comment,
      sym_line_comment,
  [392170] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25052), 1,
      anon_sym_EQ,
    STATE(18320), 2,
      sym_block_comment,
      sym_line_comment,
  [392184] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25054), 1,
      anon_sym_LPAREN,
    STATE(18321), 2,
      sym_block_comment,
      sym_line_comment,
  [392198] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25056), 1,
      anon_sym_end,
    STATE(18322), 2,
      sym_block_comment,
      sym_line_comment,
  [392212] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25058), 1,
      anon_sym_RPAREN,
    STATE(18323), 2,
      sym_block_comment,
      sym_line_comment,
  [392226] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6842), 1,
      anon_sym_RPAREN,
    STATE(18324), 2,
      sym_block_comment,
      sym_line_comment,
  [392240] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25060), 1,
      anon_sym_end,
    STATE(18325), 2,
      sym_block_comment,
      sym_line_comment,
  [392254] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6474), 1,
      anon_sym_RPAREN,
    STATE(18326), 2,
      sym_block_comment,
      sym_line_comment,
  [392268] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7046), 1,
      anon_sym_RPAREN,
    STATE(18327), 2,
      sym_block_comment,
      sym_line_comment,
  [392282] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25062), 1,
      anon_sym_RBRACK,
    STATE(18328), 2,
      sym_block_comment,
      sym_line_comment,
  [392296] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25064), 1,
      anon_sym_end,
    STATE(18329), 2,
      sym_block_comment,
      sym_line_comment,
  [392310] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20691), 1,
      anon_sym_end,
    STATE(18330), 2,
      sym_block_comment,
      sym_line_comment,
  [392324] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25066), 1,
      anon_sym_end,
    STATE(18331), 2,
      sym_block_comment,
      sym_line_comment,
  [392338] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25068), 1,
      anon_sym_RPAREN,
    STATE(18332), 2,
      sym_block_comment,
      sym_line_comment,
  [392352] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25070), 1,
      anon_sym_RBRACK,
    STATE(18333), 2,
      sym_block_comment,
      sym_line_comment,
  [392366] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25072), 1,
      anon_sym_end,
    STATE(18334), 2,
      sym_block_comment,
      sym_line_comment,
  [392380] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7576), 1,
      anon_sym_RPAREN,
    STATE(18335), 2,
      sym_block_comment,
      sym_line_comment,
  [392394] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8170), 1,
      anon_sym_RPAREN,
    STATE(18336), 2,
      sym_block_comment,
      sym_line_comment,
  [392408] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25074), 1,
      anon_sym_RBRACK,
    STATE(18337), 2,
      sym_block_comment,
      sym_line_comment,
  [392422] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25076), 1,
      anon_sym_end,
    STATE(18338), 2,
      sym_block_comment,
      sym_line_comment,
  [392436] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18996), 1,
      anon_sym_RBRACE,
    STATE(18339), 2,
      sym_block_comment,
      sym_line_comment,
  [392450] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25078), 1,
      anon_sym_end,
    STATE(18340), 2,
      sym_block_comment,
      sym_line_comment,
  [392464] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19402), 1,
      anon_sym_RBRACE,
    STATE(18341), 2,
      sym_block_comment,
      sym_line_comment,
  [392478] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18748), 1,
      anon_sym_RBRACE,
    STATE(18342), 2,
      sym_block_comment,
      sym_line_comment,
  [392492] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25080), 1,
      anon_sym_COLON2,
    STATE(18343), 2,
      sym_block_comment,
      sym_line_comment,
  [392506] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25082), 1,
      anon_sym_end,
    STATE(18344), 2,
      sym_block_comment,
      sym_line_comment,
  [392520] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25084), 1,
      anon_sym_RPAREN,
    STATE(18345), 2,
      sym_block_comment,
      sym_line_comment,
  [392534] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25086), 1,
      anon_sym_RBRACK,
    STATE(18346), 2,
      sym_block_comment,
      sym_line_comment,
  [392548] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8814), 1,
      anon_sym_RPAREN,
    STATE(18347), 2,
      sym_block_comment,
      sym_line_comment,
  [392562] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25088), 1,
      anon_sym_EQ,
    STATE(18348), 2,
      sym_block_comment,
      sym_line_comment,
  [392576] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25090), 1,
      anon_sym_end,
    STATE(18349), 2,
      sym_block_comment,
      sym_line_comment,
  [392590] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25092), 1,
      anon_sym_end,
    STATE(18350), 2,
      sym_block_comment,
      sym_line_comment,
  [392604] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25094), 1,
      anon_sym_end,
    STATE(18351), 2,
      sym_block_comment,
      sym_line_comment,
  [392618] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7010), 1,
      anon_sym_RPAREN,
    STATE(18352), 2,
      sym_block_comment,
      sym_line_comment,
  [392632] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25096), 1,
      anon_sym_end,
    STATE(18353), 2,
      sym_block_comment,
      sym_line_comment,
  [392646] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25098), 1,
      anon_sym_DASH_GT,
    STATE(18354), 2,
      sym_block_comment,
      sym_line_comment,
  [392660] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25100), 1,
      anon_sym_RPAREN,
    STATE(18355), 2,
      sym_block_comment,
      sym_line_comment,
  [392674] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25102), 1,
      anon_sym_RPAREN,
    STATE(18356), 2,
      sym_block_comment,
      sym_line_comment,
  [392688] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20417), 1,
      anon_sym_end,
    STATE(18357), 2,
      sym_block_comment,
      sym_line_comment,
  [392702] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25104), 1,
      anon_sym_end,
    STATE(18358), 2,
      sym_block_comment,
      sym_line_comment,
  [392716] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25106), 1,
      anon_sym_DASH_GT,
    STATE(18359), 2,
      sym_block_comment,
      sym_line_comment,
  [392730] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25108), 1,
      anon_sym_end,
    STATE(18360), 2,
      sym_block_comment,
      sym_line_comment,
  [392744] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8052), 1,
      anon_sym_RPAREN,
    STATE(18361), 2,
      sym_block_comment,
      sym_line_comment,
  [392758] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25110), 1,
      anon_sym_DASH_GT,
    STATE(18362), 2,
      sym_block_comment,
      sym_line_comment,
  [392772] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25112), 1,
      anon_sym_COLON2,
    STATE(18363), 2,
      sym_block_comment,
      sym_line_comment,
  [392786] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7160), 1,
      anon_sym_RPAREN,
    STATE(18364), 2,
      sym_block_comment,
      sym_line_comment,
  [392800] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13076), 1,
      anon_sym_RPAREN,
    STATE(18365), 2,
      sym_block_comment,
      sym_line_comment,
  [392814] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25114), 1,
      anon_sym_EQ,
    STATE(18366), 2,
      sym_block_comment,
      sym_line_comment,
  [392828] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6524), 1,
      anon_sym_RPAREN,
    STATE(18367), 2,
      sym_block_comment,
      sym_line_comment,
  [392842] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25116), 1,
      anon_sym_RBRACK,
    STATE(18368), 2,
      sym_block_comment,
      sym_line_comment,
  [392856] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24137), 1,
      anon_sym_end,
    STATE(18369), 2,
      sym_block_comment,
      sym_line_comment,
  [392870] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15402), 1,
      anon_sym_DASH_GT,
    STATE(18370), 2,
      sym_block_comment,
      sym_line_comment,
  [392884] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8396), 1,
      anon_sym_RPAREN,
    STATE(18371), 2,
      sym_block_comment,
      sym_line_comment,
  [392898] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25118), 1,
      anon_sym_end,
    STATE(18372), 2,
      sym_block_comment,
      sym_line_comment,
  [392912] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25120), 1,
      anon_sym_RBRACK,
    STATE(18373), 2,
      sym_block_comment,
      sym_line_comment,
  [392926] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25122), 1,
      anon_sym_RPAREN,
    STATE(18374), 2,
      sym_block_comment,
      sym_line_comment,
  [392940] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25124), 1,
      anon_sym_end,
    STATE(18375), 2,
      sym_block_comment,
      sym_line_comment,
  [392954] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13022), 1,
      anon_sym_RPAREN,
    STATE(18376), 2,
      sym_block_comment,
      sym_line_comment,
  [392968] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25126), 1,
      anon_sym_end,
    STATE(18377), 2,
      sym_block_comment,
      sym_line_comment,
  [392982] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19268), 1,
      anon_sym_RBRACE,
    STATE(18378), 2,
      sym_block_comment,
      sym_line_comment,
  [392996] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25128), 1,
      anon_sym_RBRACK,
    STATE(18379), 2,
      sym_block_comment,
      sym_line_comment,
  [393010] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13022), 1,
      anon_sym_RPAREN,
    STATE(18380), 2,
      sym_block_comment,
      sym_line_comment,
  [393024] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21125), 1,
      anon_sym_end,
    STATE(18381), 2,
      sym_block_comment,
      sym_line_comment,
  [393038] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9820), 1,
      anon_sym_DASH_GT,
    STATE(18382), 2,
      sym_block_comment,
      sym_line_comment,
  [393052] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25130), 1,
      anon_sym_EQ,
    STATE(18383), 2,
      sym_block_comment,
      sym_line_comment,
  [393066] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25132), 1,
      anon_sym_COLON2,
    STATE(18384), 2,
      sym_block_comment,
      sym_line_comment,
  [393080] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25134), 1,
      anon_sym_end,
    STATE(18385), 2,
      sym_block_comment,
      sym_line_comment,
  [393094] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25136), 1,
      anon_sym_end,
    STATE(18386), 2,
      sym_block_comment,
      sym_line_comment,
  [393108] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25138), 1,
      anon_sym_type,
    STATE(18387), 2,
      sym_block_comment,
      sym_line_comment,
  [393122] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25140), 1,
      anon_sym_struct,
    STATE(18388), 2,
      sym_block_comment,
      sym_line_comment,
  [393136] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25142), 1,
      anon_sym_RBRACK,
    STATE(18389), 2,
      sym_block_comment,
      sym_line_comment,
  [393150] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25144), 1,
      anon_sym_EQ,
    STATE(18390), 2,
      sym_block_comment,
      sym_line_comment,
  [393164] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25146), 1,
      anon_sym_end,
    STATE(18391), 2,
      sym_block_comment,
      sym_line_comment,
  [393178] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25148), 1,
      anon_sym_end,
    STATE(18392), 2,
      sym_block_comment,
      sym_line_comment,
  [393192] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7888), 1,
      anon_sym_RPAREN,
    STATE(18393), 2,
      sym_block_comment,
      sym_line_comment,
  [393206] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25150), 1,
      anon_sym_LPAREN,
    STATE(18394), 2,
      sym_block_comment,
      sym_line_comment,
  [393220] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25152), 1,
      anon_sym_EQ,
    STATE(18395), 2,
      sym_block_comment,
      sym_line_comment,
  [393234] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20543), 1,
      anon_sym_end,
    STATE(18396), 2,
      sym_block_comment,
      sym_line_comment,
  [393248] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25154), 1,
      anon_sym_DASH_GT,
    STATE(18397), 2,
      sym_block_comment,
      sym_line_comment,
  [393262] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25156), 1,
      anon_sym_RPAREN,
    STATE(18398), 2,
      sym_block_comment,
      sym_line_comment,
  [393276] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21105), 1,
      anon_sym_end,
    STATE(18399), 2,
      sym_block_comment,
      sym_line_comment,
  [393290] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25158), 1,
      anon_sym_end,
    STATE(18400), 2,
      sym_block_comment,
      sym_line_comment,
  [393304] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25160), 1,
      anon_sym_COLON2,
    STATE(18401), 2,
      sym_block_comment,
      sym_line_comment,
  [393318] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25162), 1,
      anon_sym_RBRACK,
    STATE(18402), 2,
      sym_block_comment,
      sym_line_comment,
  [393332] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25164), 1,
      anon_sym_end,
    STATE(18403), 2,
      sym_block_comment,
      sym_line_comment,
  [393346] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25166), 1,
      anon_sym_end,
    STATE(18404), 2,
      sym_block_comment,
      sym_line_comment,
  [393360] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25168), 1,
      anon_sym_end,
    STATE(18405), 2,
      sym_block_comment,
      sym_line_comment,
  [393374] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13084), 1,
      anon_sym_RPAREN,
    STATE(18406), 2,
      sym_block_comment,
      sym_line_comment,
  [393388] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25170), 1,
      anon_sym_end,
    STATE(18407), 2,
      sym_block_comment,
      sym_line_comment,
  [393402] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25172), 1,
      anon_sym_end,
    STATE(18408), 2,
      sym_block_comment,
      sym_line_comment,
  [393416] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25174), 1,
      anon_sym_end,
    STATE(18409), 2,
      sym_block_comment,
      sym_line_comment,
  [393430] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7140), 1,
      anon_sym_RPAREN,
    STATE(18410), 2,
      sym_block_comment,
      sym_line_comment,
  [393444] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25176), 1,
      anon_sym_RBRACK,
    STATE(18411), 2,
      sym_block_comment,
      sym_line_comment,
  [393458] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25178), 1,
      anon_sym_COLON2,
    STATE(18412), 2,
      sym_block_comment,
      sym_line_comment,
  [393472] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25180), 1,
      anon_sym_end,
    STATE(18413), 2,
      sym_block_comment,
      sym_line_comment,
  [393486] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25182), 1,
      anon_sym_RBRACK,
    STATE(18414), 2,
      sym_block_comment,
      sym_line_comment,
  [393500] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25184), 1,
      anon_sym_RBRACK,
    STATE(18415), 2,
      sym_block_comment,
      sym_line_comment,
  [393514] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13064), 1,
      anon_sym_RPAREN,
    STATE(18416), 2,
      sym_block_comment,
      sym_line_comment,
  [393528] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8116), 1,
      anon_sym_RPAREN,
    STATE(18417), 2,
      sym_block_comment,
      sym_line_comment,
  [393542] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25186), 1,
      anon_sym_end,
    STATE(18418), 2,
      sym_block_comment,
      sym_line_comment,
  [393556] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25188), 1,
      anon_sym_RBRACK,
    STATE(18419), 2,
      sym_block_comment,
      sym_line_comment,
  [393570] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6942), 1,
      anon_sym_RPAREN,
    STATE(18420), 2,
      sym_block_comment,
      sym_line_comment,
  [393584] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25190), 1,
      anon_sym_RBRACK,
    STATE(18421), 2,
      sym_block_comment,
      sym_line_comment,
  [393598] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15582), 1,
      sym__immediate_paren,
    STATE(18422), 2,
      sym_block_comment,
      sym_line_comment,
  [393612] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6766), 1,
      anon_sym_RPAREN,
    STATE(18423), 2,
      sym_block_comment,
      sym_line_comment,
  [393626] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25192), 1,
      anon_sym_EQ,
    STATE(18424), 2,
      sym_block_comment,
      sym_line_comment,
  [393640] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7044), 1,
      anon_sym_RPAREN,
    STATE(18425), 2,
      sym_block_comment,
      sym_line_comment,
  [393654] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25194), 1,
      anon_sym_RPAREN,
    STATE(18426), 2,
      sym_block_comment,
      sym_line_comment,
  [393668] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25196), 1,
      anon_sym_RBRACK,
    STATE(18427), 2,
      sym_block_comment,
      sym_line_comment,
  [393682] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19989), 1,
      anon_sym_end,
    STATE(18428), 2,
      sym_block_comment,
      sym_line_comment,
  [393696] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6460), 1,
      anon_sym_RPAREN,
    STATE(18429), 2,
      sym_block_comment,
      sym_line_comment,
  [393710] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25198), 1,
      anon_sym_RBRACK,
    STATE(18430), 2,
      sym_block_comment,
      sym_line_comment,
  [393724] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8700), 1,
      anon_sym_RPAREN,
    STATE(18431), 2,
      sym_block_comment,
      sym_line_comment,
  [393738] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25200), 1,
      anon_sym_end,
    STATE(18432), 2,
      sym_block_comment,
      sym_line_comment,
  [393752] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25202), 1,
      anon_sym_RBRACK,
    STATE(18433), 2,
      sym_block_comment,
      sym_line_comment,
  [393766] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25204), 1,
      anon_sym_RBRACK,
    STATE(18434), 2,
      sym_block_comment,
      sym_line_comment,
  [393780] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25206), 1,
      anon_sym_RBRACK,
    STATE(18435), 2,
      sym_block_comment,
      sym_line_comment,
  [393794] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25208), 1,
      anon_sym_end,
    STATE(18436), 2,
      sym_block_comment,
      sym_line_comment,
  [393808] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25210), 1,
      anon_sym_RPAREN,
    STATE(18437), 2,
      sym_block_comment,
      sym_line_comment,
  [393822] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25212), 1,
      anon_sym_end,
    STATE(18438), 2,
      sym_block_comment,
      sym_line_comment,
  [393836] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19987), 1,
      anon_sym_end,
    STATE(18439), 2,
      sym_block_comment,
      sym_line_comment,
  [393850] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25214), 1,
      anon_sym_RBRACK,
    STATE(18440), 2,
      sym_block_comment,
      sym_line_comment,
  [393864] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25216), 1,
      anon_sym_end,
    STATE(18441), 2,
      sym_block_comment,
      sym_line_comment,
  [393878] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25218), 1,
      anon_sym_end,
    STATE(18442), 2,
      sym_block_comment,
      sym_line_comment,
  [393892] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19282), 1,
      anon_sym_RBRACE,
    STATE(18443), 2,
      sym_block_comment,
      sym_line_comment,
  [393906] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13082), 1,
      anon_sym_RPAREN,
    STATE(18444), 2,
      sym_block_comment,
      sym_line_comment,
  [393920] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25220), 1,
      anon_sym_RPAREN,
    STATE(18445), 2,
      sym_block_comment,
      sym_line_comment,
  [393934] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23889), 1,
      anon_sym_end,
    STATE(18446), 2,
      sym_block_comment,
      sym_line_comment,
  [393948] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13082), 1,
      anon_sym_RPAREN,
    STATE(18447), 2,
      sym_block_comment,
      sym_line_comment,
  [393962] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25222), 1,
      anon_sym_end,
    STATE(18448), 2,
      sym_block_comment,
      sym_line_comment,
  [393976] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13064), 1,
      anon_sym_RPAREN,
    STATE(18449), 2,
      sym_block_comment,
      sym_line_comment,
  [393990] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18978), 1,
      anon_sym_RBRACE,
    STATE(18450), 2,
      sym_block_comment,
      sym_line_comment,
  [394004] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18944), 1,
      anon_sym_RBRACE,
    STATE(18451), 2,
      sym_block_comment,
      sym_line_comment,
  [394018] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6660), 1,
      anon_sym_RPAREN,
    STATE(18452), 2,
      sym_block_comment,
      sym_line_comment,
  [394032] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23891), 1,
      anon_sym_end,
    STATE(18453), 2,
      sym_block_comment,
      sym_line_comment,
  [394046] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25224), 1,
      anon_sym_end,
    STATE(18454), 2,
      sym_block_comment,
      sym_line_comment,
  [394060] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25226), 1,
      anon_sym_COLON2,
    STATE(18455), 2,
      sym_block_comment,
      sym_line_comment,
  [394074] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25228), 1,
      anon_sym_RPAREN,
    STATE(18456), 2,
      sym_block_comment,
      sym_line_comment,
  [394088] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25230), 1,
      anon_sym_end,
    STATE(18457), 2,
      sym_block_comment,
      sym_line_comment,
  [394102] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25232), 1,
      anon_sym_RBRACK,
    STATE(18458), 2,
      sym_block_comment,
      sym_line_comment,
  [394116] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25234), 1,
      anon_sym_type,
    STATE(18459), 2,
      sym_block_comment,
      sym_line_comment,
  [394130] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25236), 1,
      anon_sym_struct,
    STATE(18460), 2,
      sym_block_comment,
      sym_line_comment,
  [394144] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25238), 1,
      anon_sym_end,
    STATE(18461), 2,
      sym_block_comment,
      sym_line_comment,
  [394158] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25240), 1,
      anon_sym_end,
    STATE(18462), 2,
      sym_block_comment,
      sym_line_comment,
  [394172] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25242), 1,
      anon_sym_RBRACK,
    STATE(18463), 2,
      sym_block_comment,
      sym_line_comment,
  [394186] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25244), 1,
      anon_sym_COLON2,
    STATE(18464), 2,
      sym_block_comment,
      sym_line_comment,
  [394200] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25246), 1,
      anon_sym_RPAREN,
    STATE(18465), 2,
      sym_block_comment,
      sym_line_comment,
  [394214] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25248), 1,
      anon_sym_end,
    STATE(18466), 2,
      sym_block_comment,
      sym_line_comment,
  [394228] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25250), 1,
      anon_sym_end,
    STATE(18467), 2,
      sym_block_comment,
      sym_line_comment,
  [394242] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25252), 1,
      anon_sym_RPAREN,
    STATE(18468), 2,
      sym_block_comment,
      sym_line_comment,
  [394256] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25254), 1,
      anon_sym_EQ,
    STATE(18469), 2,
      sym_block_comment,
      sym_line_comment,
  [394270] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25256), 1,
      anon_sym_EQ,
    STATE(18470), 2,
      sym_block_comment,
      sym_line_comment,
  [394284] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8768), 1,
      anon_sym_RPAREN,
    STATE(18471), 2,
      sym_block_comment,
      sym_line_comment,
  [394298] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25258), 1,
      anon_sym_RBRACK,
    STATE(18472), 2,
      sym_block_comment,
      sym_line_comment,
  [394312] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25260), 1,
      anon_sym_end,
    STATE(18473), 2,
      sym_block_comment,
      sym_line_comment,
  [394326] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6734), 1,
      anon_sym_RPAREN,
    STATE(18474), 2,
      sym_block_comment,
      sym_line_comment,
  [394340] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25262), 1,
      anon_sym_end,
    STATE(18475), 2,
      sym_block_comment,
      sym_line_comment,
  [394354] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25264), 1,
      anon_sym_end,
    STATE(18476), 2,
      sym_block_comment,
      sym_line_comment,
  [394368] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25266), 1,
      anon_sym_end,
    STATE(18477), 2,
      sym_block_comment,
      sym_line_comment,
  [394382] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25268), 1,
      anon_sym_RBRACK,
    STATE(18478), 2,
      sym_block_comment,
      sym_line_comment,
  [394396] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25270), 1,
      anon_sym_end,
    STATE(18479), 2,
      sym_block_comment,
      sym_line_comment,
  [394410] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25272), 1,
      anon_sym_RPAREN,
    STATE(18480), 2,
      sym_block_comment,
      sym_line_comment,
  [394424] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25274), 1,
      anon_sym_RBRACK,
    STATE(18481), 2,
      sym_block_comment,
      sym_line_comment,
  [394438] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25276), 1,
      anon_sym_COLON2,
    STATE(18482), 2,
      sym_block_comment,
      sym_line_comment,
  [394452] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9830), 1,
      anon_sym_DASH_GT,
    STATE(18483), 2,
      sym_block_comment,
      sym_line_comment,
  [394466] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25278), 1,
      anon_sym_end,
    STATE(18484), 2,
      sym_block_comment,
      sym_line_comment,
  [394480] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13100), 1,
      anon_sym_RPAREN,
    STATE(18485), 2,
      sym_block_comment,
      sym_line_comment,
  [394494] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7196), 1,
      anon_sym_RPAREN,
    STATE(18486), 2,
      sym_block_comment,
      sym_line_comment,
  [394508] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25280), 1,
      anon_sym_end,
    STATE(18487), 2,
      sym_block_comment,
      sym_line_comment,
  [394522] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25282), 1,
      anon_sym_type,
    STATE(18488), 2,
      sym_block_comment,
      sym_line_comment,
  [394536] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25284), 1,
      anon_sym_struct,
    STATE(18489), 2,
      sym_block_comment,
      sym_line_comment,
  [394550] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13000), 1,
      anon_sym_RPAREN,
    STATE(18490), 2,
      sym_block_comment,
      sym_line_comment,
  [394564] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21127), 1,
      anon_sym_end,
    STATE(18491), 2,
      sym_block_comment,
      sym_line_comment,
  [394578] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25286), 1,
      ts_builtin_sym_end,
    STATE(18492), 2,
      sym_block_comment,
      sym_line_comment,
  [394592] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20079), 1,
      anon_sym_end,
    STATE(18493), 2,
      sym_block_comment,
      sym_line_comment,
  [394606] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25288), 1,
      anon_sym_RPAREN,
    STATE(18494), 2,
      sym_block_comment,
      sym_line_comment,
  [394620] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25290), 1,
      anon_sym_DASH_GT,
    STATE(18495), 2,
      sym_block_comment,
      sym_line_comment,
  [394634] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13100), 1,
      anon_sym_RPAREN,
    STATE(18496), 2,
      sym_block_comment,
      sym_line_comment,
  [394648] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25292), 1,
      anon_sym_end,
    STATE(18497), 2,
      sym_block_comment,
      sym_line_comment,
  [394662] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25294), 1,
      anon_sym_end,
    STATE(18498), 2,
      sym_block_comment,
      sym_line_comment,
  [394676] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7818), 1,
      anon_sym_RPAREN,
    STATE(18499), 2,
      sym_block_comment,
      sym_line_comment,
  [394690] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25296), 1,
      anon_sym_EQ,
    STATE(18500), 2,
      sym_block_comment,
      sym_line_comment,
  [394704] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25298), 1,
      anon_sym_RBRACK,
    STATE(18501), 2,
      sym_block_comment,
      sym_line_comment,
  [394718] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25300), 1,
      anon_sym_end,
    STATE(18502), 2,
      sym_block_comment,
      sym_line_comment,
  [394732] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25302), 1,
      anon_sym_struct,
    STATE(18503), 2,
      sym_block_comment,
      sym_line_comment,
  [394746] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25304), 1,
      anon_sym_end,
    STATE(18504), 2,
      sym_block_comment,
      sym_line_comment,
  [394760] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25306), 1,
      anon_sym_COLON2,
    STATE(18505), 2,
      sym_block_comment,
      sym_line_comment,
  [394774] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25308), 1,
      anon_sym_end,
    STATE(18506), 2,
      sym_block_comment,
      sym_line_comment,
  [394788] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25310), 1,
      anon_sym_end,
    STATE(18507), 2,
      sym_block_comment,
      sym_line_comment,
  [394802] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25312), 1,
      anon_sym_RBRACK,
    STATE(18508), 2,
      sym_block_comment,
      sym_line_comment,
  [394816] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13040), 1,
      anon_sym_RPAREN,
    STATE(18509), 2,
      sym_block_comment,
      sym_line_comment,
  [394830] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25314), 1,
      anon_sym_end,
    STATE(18510), 2,
      sym_block_comment,
      sym_line_comment,
  [394844] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25316), 1,
      anon_sym_RPAREN,
    STATE(18511), 2,
      sym_block_comment,
      sym_line_comment,
  [394858] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25318), 1,
      anon_sym_EQ,
    STATE(18512), 2,
      sym_block_comment,
      sym_line_comment,
  [394872] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13040), 1,
      anon_sym_RPAREN,
    STATE(18513), 2,
      sym_block_comment,
      sym_line_comment,
  [394886] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6512), 1,
      anon_sym_RPAREN,
    STATE(18514), 2,
      sym_block_comment,
      sym_line_comment,
  [394900] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25320), 1,
      anon_sym_end,
    STATE(18515), 2,
      sym_block_comment,
      sym_line_comment,
  [394914] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25322), 1,
      anon_sym_type,
    STATE(18516), 2,
      sym_block_comment,
      sym_line_comment,
  [394928] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25324), 1,
      anon_sym_struct,
    STATE(18517), 2,
      sym_block_comment,
      sym_line_comment,
  [394942] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25326), 1,
      anon_sym_RBRACK,
    STATE(18518), 2,
      sym_block_comment,
      sym_line_comment,
  [394956] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25328), 1,
      anon_sym_DASH_GT,
    STATE(18519), 2,
      sym_block_comment,
      sym_line_comment,
  [394970] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25330), 1,
      anon_sym_DASH_GT,
    STATE(18520), 2,
      sym_block_comment,
      sym_line_comment,
  [394984] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13092), 1,
      anon_sym_RPAREN,
    STATE(18521), 2,
      sym_block_comment,
      sym_line_comment,
  [394998] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25332), 1,
      anon_sym_end,
    STATE(18522), 2,
      sym_block_comment,
      sym_line_comment,
  [395012] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25334), 1,
      anon_sym_end,
    STATE(18523), 2,
      sym_block_comment,
      sym_line_comment,
  [395026] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25336), 1,
      anon_sym_end,
    STATE(18524), 2,
      sym_block_comment,
      sym_line_comment,
  [395040] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19036), 1,
      anon_sym_RBRACE,
    STATE(18525), 2,
      sym_block_comment,
      sym_line_comment,
  [395054] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25338), 1,
      anon_sym_type,
    STATE(18526), 2,
      sym_block_comment,
      sym_line_comment,
  [395068] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25340), 1,
      anon_sym_struct,
    STATE(18527), 2,
      sym_block_comment,
      sym_line_comment,
  [395082] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25342), 1,
      anon_sym_end,
    STATE(18528), 2,
      sym_block_comment,
      sym_line_comment,
  [395096] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25344), 1,
      anon_sym_EQ,
    STATE(18529), 2,
      sym_block_comment,
      sym_line_comment,
  [395110] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8418), 1,
      anon_sym_RPAREN,
    STATE(18530), 2,
      sym_block_comment,
      sym_line_comment,
  [395124] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25346), 1,
      anon_sym_COLON2,
    STATE(18531), 2,
      sym_block_comment,
      sym_line_comment,
  [395138] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25348), 1,
      anon_sym_RBRACK,
    STATE(18532), 2,
      sym_block_comment,
      sym_line_comment,
  [395152] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15538), 1,
      anon_sym_DASH_GT,
    STATE(18533), 2,
      sym_block_comment,
      sym_line_comment,
  [395166] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25350), 1,
      anon_sym_end,
    STATE(18534), 2,
      sym_block_comment,
      sym_line_comment,
  [395180] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25352), 1,
      anon_sym_RPAREN,
    STATE(18535), 2,
      sym_block_comment,
      sym_line_comment,
  [395194] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25354), 1,
      anon_sym_type,
    STATE(18536), 2,
      sym_block_comment,
      sym_line_comment,
  [395208] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25356), 1,
      anon_sym_struct,
    STATE(18537), 2,
      sym_block_comment,
      sym_line_comment,
  [395222] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25358), 1,
      anon_sym_RPAREN,
    STATE(18538), 2,
      sym_block_comment,
      sym_line_comment,
  [395236] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25360), 1,
      anon_sym_end,
    STATE(18539), 2,
      sym_block_comment,
      sym_line_comment,
  [395250] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25362), 1,
      anon_sym_RBRACK,
    STATE(18540), 2,
      sym_block_comment,
      sym_line_comment,
  [395264] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25364), 1,
      anon_sym_end,
    STATE(18541), 2,
      sym_block_comment,
      sym_line_comment,
  [395278] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25366), 1,
      anon_sym_end,
    STATE(18542), 2,
      sym_block_comment,
      sym_line_comment,
  [395292] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25368), 1,
      anon_sym_type,
    STATE(18543), 2,
      sym_block_comment,
      sym_line_comment,
  [395306] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25370), 1,
      anon_sym_struct,
    STATE(18544), 2,
      sym_block_comment,
      sym_line_comment,
  [395320] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25372), 1,
      anon_sym_end,
    STATE(18545), 2,
      sym_block_comment,
      sym_line_comment,
  [395334] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25374), 1,
      anon_sym_end,
    STATE(18546), 2,
      sym_block_comment,
      sym_line_comment,
  [395348] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25376), 1,
      anon_sym_end,
    STATE(18547), 2,
      sym_block_comment,
      sym_line_comment,
  [395362] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18764), 1,
      anon_sym_RBRACE,
    STATE(18548), 2,
      sym_block_comment,
      sym_line_comment,
  [395376] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25378), 1,
      anon_sym_type,
    STATE(18549), 2,
      sym_block_comment,
      sym_line_comment,
  [395390] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25380), 1,
      anon_sym_struct,
    STATE(18550), 2,
      sym_block_comment,
      sym_line_comment,
  [395404] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25382), 1,
      anon_sym_end,
    STATE(18551), 2,
      sym_block_comment,
      sym_line_comment,
  [395418] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25384), 1,
      anon_sym_DASH_GT,
    STATE(18552), 2,
      sym_block_comment,
      sym_line_comment,
  [395432] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18794), 1,
      anon_sym_RBRACE,
    STATE(18553), 2,
      sym_block_comment,
      sym_line_comment,
  [395446] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6672), 1,
      anon_sym_RPAREN,
    STATE(18554), 2,
      sym_block_comment,
      sym_line_comment,
  [395460] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25386), 1,
      anon_sym_type,
    STATE(18555), 2,
      sym_block_comment,
      sym_line_comment,
  [395474] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25388), 1,
      anon_sym_struct,
    STATE(18556), 2,
      sym_block_comment,
      sym_line_comment,
  [395488] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25390), 1,
      anon_sym_end,
    STATE(18557), 2,
      sym_block_comment,
      sym_line_comment,
  [395502] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25392), 1,
      anon_sym_RBRACK,
    STATE(18558), 2,
      sym_block_comment,
      sym_line_comment,
  [395516] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20483), 1,
      anon_sym_end,
    STATE(18559), 2,
      sym_block_comment,
      sym_line_comment,
  [395530] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25394), 1,
      anon_sym_end,
    STATE(18560), 2,
      sym_block_comment,
      sym_line_comment,
  [395544] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25396), 1,
      anon_sym_type,
    STATE(18561), 2,
      sym_block_comment,
      sym_line_comment,
  [395558] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10775), 1,
      sym__immediate_paren,
    STATE(18562), 2,
      sym_block_comment,
      sym_line_comment,
  [395572] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25398), 1,
      anon_sym_RPAREN,
    STATE(18563), 2,
      sym_block_comment,
      sym_line_comment,
  [395586] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25400), 1,
      anon_sym_end,
    STATE(18564), 2,
      sym_block_comment,
      sym_line_comment,
  [395600] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25402), 1,
      anon_sym_COLON2,
    STATE(18565), 2,
      sym_block_comment,
      sym_line_comment,
  [395614] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25404), 1,
      anon_sym_end,
    STATE(18566), 2,
      sym_block_comment,
      sym_line_comment,
  [395628] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25406), 1,
      anon_sym_end,
    STATE(18567), 2,
      sym_block_comment,
      sym_line_comment,
  [395642] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25408), 1,
      anon_sym_EQ,
    STATE(18568), 2,
      sym_block_comment,
      sym_line_comment,
  [395656] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6412), 1,
      anon_sym_RPAREN,
    STATE(18569), 2,
      sym_block_comment,
      sym_line_comment,
  [395670] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15299), 1,
      anon_sym_DASH_GT,
    STATE(18570), 2,
      sym_block_comment,
      sym_line_comment,
  [395684] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25410), 1,
      anon_sym_RBRACK,
    STATE(18571), 2,
      sym_block_comment,
      sym_line_comment,
  [395698] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7946), 1,
      anon_sym_RPAREN,
    STATE(18572), 2,
      sym_block_comment,
      sym_line_comment,
  [395712] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8090), 1,
      anon_sym_RPAREN,
    STATE(18573), 2,
      sym_block_comment,
      sym_line_comment,
  [395726] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22512), 1,
      anon_sym_RPAREN,
    STATE(18574), 2,
      sym_block_comment,
      sym_line_comment,
  [395740] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20782), 1,
      anon_sym_end,
    STATE(18575), 2,
      sym_block_comment,
      sym_line_comment,
  [395754] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25412), 1,
      anon_sym_EQ,
    STATE(18576), 2,
      sym_block_comment,
      sym_line_comment,
  [395768] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6664), 1,
      anon_sym_RPAREN,
    STATE(18577), 2,
      sym_block_comment,
      sym_line_comment,
  [395782] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25414), 1,
      anon_sym_EQ,
    STATE(18578), 2,
      sym_block_comment,
      sym_line_comment,
  [395796] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25416), 1,
      anon_sym_RBRACK,
    STATE(18579), 2,
      sym_block_comment,
      sym_line_comment,
  [395810] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18968), 1,
      anon_sym_RBRACE,
    STATE(18580), 2,
      sym_block_comment,
      sym_line_comment,
  [395824] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20457), 1,
      anon_sym_end,
    STATE(18581), 2,
      sym_block_comment,
      sym_line_comment,
  [395838] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23947), 1,
      anon_sym_end,
    STATE(18582), 2,
      sym_block_comment,
      sym_line_comment,
  [395852] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25418), 1,
      anon_sym_COLON2,
    STATE(18583), 2,
      sym_block_comment,
      sym_line_comment,
  [395866] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19140), 1,
      anon_sym_RBRACE,
    STATE(18584), 2,
      sym_block_comment,
      sym_line_comment,
  [395880] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25420), 1,
      anon_sym_RPAREN,
    STATE(18585), 2,
      sym_block_comment,
      sym_line_comment,
  [395894] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25422), 1,
      anon_sym_end,
    STATE(18586), 2,
      sym_block_comment,
      sym_line_comment,
  [395908] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25424), 1,
      anon_sym_end,
    STATE(18587), 2,
      sym_block_comment,
      sym_line_comment,
  [395922] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19294), 1,
      anon_sym_RBRACE,
    STATE(18588), 2,
      sym_block_comment,
      sym_line_comment,
  [395936] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19330), 1,
      anon_sym_RBRACE,
    STATE(18589), 2,
      sym_block_comment,
      sym_line_comment,
  [395950] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25426), 1,
      anon_sym_RPAREN,
    STATE(18590), 2,
      sym_block_comment,
      sym_line_comment,
  [395964] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19344), 1,
      anon_sym_RBRACE,
    STATE(18591), 2,
      sym_block_comment,
      sym_line_comment,
  [395978] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9822), 1,
      anon_sym_DASH_GT,
    STATE(18592), 2,
      sym_block_comment,
      sym_line_comment,
  [395992] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25428), 1,
      anon_sym_RBRACK,
    STATE(18593), 2,
      sym_block_comment,
      sym_line_comment,
  [396006] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25430), 1,
      anon_sym_COLON2,
    STATE(18594), 2,
      sym_block_comment,
      sym_line_comment,
  [396020] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20513), 1,
      anon_sym_end,
    STATE(18595), 2,
      sym_block_comment,
      sym_line_comment,
  [396034] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8572), 1,
      anon_sym_RPAREN,
    STATE(18596), 2,
      sym_block_comment,
      sym_line_comment,
  [396048] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25432), 1,
      anon_sym_end,
    STATE(18597), 2,
      sym_block_comment,
      sym_line_comment,
  [396062] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8692), 1,
      anon_sym_RPAREN,
    STATE(18598), 2,
      sym_block_comment,
      sym_line_comment,
  [396076] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25434), 1,
      anon_sym_EQ,
    STATE(18599), 2,
      sym_block_comment,
      sym_line_comment,
  [396090] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25436), 1,
      anon_sym_RBRACK,
    STATE(18600), 2,
      sym_block_comment,
      sym_line_comment,
  [396104] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25438), 1,
      anon_sym_end,
    STATE(18601), 2,
      sym_block_comment,
      sym_line_comment,
  [396118] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21101), 1,
      anon_sym_end,
    STATE(18602), 2,
      sym_block_comment,
      sym_line_comment,
  [396132] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25440), 1,
      anon_sym_EQ,
    STATE(18603), 2,
      sym_block_comment,
      sym_line_comment,
  [396146] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25442), 1,
      anon_sym_end,
    STATE(18604), 2,
      sym_block_comment,
      sym_line_comment,
  [396160] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6792), 1,
      anon_sym_RPAREN,
    STATE(18605), 2,
      sym_block_comment,
      sym_line_comment,
  [396174] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25444), 1,
      anon_sym_RBRACK,
    STATE(18606), 2,
      sym_block_comment,
      sym_line_comment,
  [396188] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25446), 1,
      anon_sym_end,
    STATE(18607), 2,
      sym_block_comment,
      sym_line_comment,
  [396202] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7098), 1,
      anon_sym_RPAREN,
    STATE(18608), 2,
      sym_block_comment,
      sym_line_comment,
  [396216] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6572), 1,
      anon_sym_RPAREN,
    STATE(18609), 2,
      sym_block_comment,
      sym_line_comment,
  [396230] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25448), 1,
      anon_sym_COLON2,
    STATE(18610), 2,
      sym_block_comment,
      sym_line_comment,
  [396244] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25450), 1,
      anon_sym_end,
    STATE(18611), 2,
      sym_block_comment,
      sym_line_comment,
  [396258] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25452), 1,
      anon_sym_end,
    STATE(18612), 2,
      sym_block_comment,
      sym_line_comment,
  [396272] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7508), 1,
      anon_sym_RPAREN,
    STATE(18613), 2,
      sym_block_comment,
      sym_line_comment,
  [396286] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13070), 1,
      anon_sym_RPAREN,
    STATE(18614), 2,
      sym_block_comment,
      sym_line_comment,
  [396300] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19348), 1,
      anon_sym_RBRACE,
    STATE(18615), 2,
      sym_block_comment,
      sym_line_comment,
  [396314] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7070), 1,
      anon_sym_RPAREN,
    STATE(18616), 2,
      sym_block_comment,
      sym_line_comment,
  [396328] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21135), 1,
      anon_sym_end,
    STATE(18617), 2,
      sym_block_comment,
      sym_line_comment,
  [396342] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25454), 1,
      anon_sym_COLON2,
    STATE(18618), 2,
      sym_block_comment,
      sym_line_comment,
  [396356] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25456), 1,
      anon_sym_RBRACK,
    STATE(18619), 2,
      sym_block_comment,
      sym_line_comment,
  [396370] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8724), 1,
      anon_sym_RPAREN,
    STATE(18620), 2,
      sym_block_comment,
      sym_line_comment,
  [396384] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25458), 1,
      anon_sym_end,
    STATE(18621), 2,
      sym_block_comment,
      sym_line_comment,
  [396398] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25460), 1,
      anon_sym_RBRACK,
    STATE(18622), 2,
      sym_block_comment,
      sym_line_comment,
  [396412] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7574), 1,
      anon_sym_RPAREN,
    STATE(18623), 2,
      sym_block_comment,
      sym_line_comment,
  [396426] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21115), 1,
      anon_sym_end,
    STATE(18624), 2,
      sym_block_comment,
      sym_line_comment,
  [396440] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25462), 1,
      anon_sym_RBRACK,
    STATE(18625), 2,
      sym_block_comment,
      sym_line_comment,
  [396454] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8536), 1,
      anon_sym_RPAREN,
    STATE(18626), 2,
      sym_block_comment,
      sym_line_comment,
  [396468] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25464), 1,
      anon_sym_COLON2,
    STATE(18627), 2,
      sym_block_comment,
      sym_line_comment,
  [396482] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20293), 1,
      anon_sym_end,
    STATE(18628), 2,
      sym_block_comment,
      sym_line_comment,
  [396496] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13042), 1,
      anon_sym_RPAREN,
    STATE(18629), 2,
      sym_block_comment,
      sym_line_comment,
  [396510] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25466), 1,
      anon_sym_end,
    STATE(18630), 2,
      sym_block_comment,
      sym_line_comment,
  [396524] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9808), 1,
      anon_sym_DASH_GT,
    STATE(18631), 2,
      sym_block_comment,
      sym_line_comment,
  [396538] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25468), 1,
      anon_sym_RBRACK,
    STATE(18632), 2,
      sym_block_comment,
      sym_line_comment,
  [396552] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25470), 1,
      anon_sym_RPAREN,
    STATE(18633), 2,
      sym_block_comment,
      sym_line_comment,
  [396566] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8152), 1,
      anon_sym_RPAREN,
    STATE(18634), 2,
      sym_block_comment,
      sym_line_comment,
  [396580] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25472), 1,
      anon_sym_end,
    STATE(18635), 2,
      sym_block_comment,
      sym_line_comment,
  [396594] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25474), 1,
      anon_sym_end,
    STATE(18636), 2,
      sym_block_comment,
      sym_line_comment,
  [396608] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25476), 1,
      anon_sym_end,
    STATE(18637), 2,
      sym_block_comment,
      sym_line_comment,
  [396622] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13042), 1,
      anon_sym_RPAREN,
    STATE(18638), 2,
      sym_block_comment,
      sym_line_comment,
  [396636] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8702), 1,
      anon_sym_RPAREN,
    STATE(18639), 2,
      sym_block_comment,
      sym_line_comment,
  [396650] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25478), 1,
      anon_sym_RBRACK,
    STATE(18640), 2,
      sym_block_comment,
      sym_line_comment,
  [396664] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25480), 1,
      anon_sym_RBRACK,
    STATE(18641), 2,
      sym_block_comment,
      sym_line_comment,
  [396678] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25482), 1,
      anon_sym_RBRACK,
    STATE(18642), 2,
      sym_block_comment,
      sym_line_comment,
  [396692] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25484), 1,
      anon_sym_end,
    STATE(18643), 2,
      sym_block_comment,
      sym_line_comment,
  [396706] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25486), 1,
      anon_sym_end,
    STATE(18644), 2,
      sym_block_comment,
      sym_line_comment,
  [396720] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7178), 1,
      anon_sym_RPAREN,
    STATE(18645), 2,
      sym_block_comment,
      sym_line_comment,
  [396734] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8734), 1,
      anon_sym_RPAREN,
    STATE(18646), 2,
      sym_block_comment,
      sym_line_comment,
  [396748] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13008), 1,
      anon_sym_RPAREN,
    STATE(18647), 2,
      sym_block_comment,
      sym_line_comment,
  [396762] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25488), 1,
      anon_sym_RBRACK,
    STATE(18648), 2,
      sym_block_comment,
      sym_line_comment,
  [396776] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13008), 1,
      anon_sym_RPAREN,
    STATE(18649), 2,
      sym_block_comment,
      sym_line_comment,
  [396790] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15204), 1,
      anon_sym_DASH_GT,
    STATE(18650), 2,
      sym_block_comment,
      sym_line_comment,
  [396804] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6484), 1,
      anon_sym_RPAREN,
    STATE(18651), 2,
      sym_block_comment,
      sym_line_comment,
  [396818] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25490), 1,
      anon_sym_COLON2,
    STATE(18652), 2,
      sym_block_comment,
      sym_line_comment,
  [396832] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13090), 1,
      anon_sym_RPAREN,
    STATE(18653), 2,
      sym_block_comment,
      sym_line_comment,
  [396846] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25492), 1,
      anon_sym_end,
    STATE(18654), 2,
      sym_block_comment,
      sym_line_comment,
  [396860] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25494), 1,
      anon_sym_COLON2,
    STATE(18655), 2,
      sym_block_comment,
      sym_line_comment,
  [396874] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7444), 1,
      anon_sym_RPAREN,
    STATE(18656), 2,
      sym_block_comment,
      sym_line_comment,
  [396888] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19028), 1,
      anon_sym_RBRACE,
    STATE(18657), 2,
      sym_block_comment,
      sym_line_comment,
  [396902] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25496), 1,
      anon_sym_end,
    STATE(18658), 2,
      sym_block_comment,
      sym_line_comment,
  [396916] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25498), 1,
      anon_sym_end,
    STATE(18659), 2,
      sym_block_comment,
      sym_line_comment,
  [396930] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25500), 1,
      anon_sym_end,
    STATE(18660), 2,
      sym_block_comment,
      sym_line_comment,
  [396944] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8494), 1,
      anon_sym_RPAREN,
    STATE(18661), 2,
      sym_block_comment,
      sym_line_comment,
  [396958] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13090), 1,
      anon_sym_RPAREN,
    STATE(18662), 2,
      sym_block_comment,
      sym_line_comment,
  [396972] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13092), 1,
      anon_sym_RPAREN,
    STATE(18663), 2,
      sym_block_comment,
      sym_line_comment,
  [396986] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6826), 1,
      anon_sym_RPAREN,
    STATE(18664), 2,
      sym_block_comment,
      sym_line_comment,
  [397000] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25502), 1,
      anon_sym_end,
    STATE(18665), 2,
      sym_block_comment,
      sym_line_comment,
  [397014] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25504), 1,
      anon_sym_RPAREN,
    STATE(18666), 2,
      sym_block_comment,
      sym_line_comment,
  [397028] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13026), 1,
      anon_sym_RPAREN,
    STATE(18667), 2,
      sym_block_comment,
      sym_line_comment,
  [397042] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8844), 1,
      anon_sym_RPAREN,
    STATE(18668), 2,
      sym_block_comment,
      sym_line_comment,
  [397056] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7868), 1,
      anon_sym_RPAREN,
    STATE(18669), 2,
      sym_block_comment,
      sym_line_comment,
  [397070] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25506), 1,
      anon_sym_COLON2,
    STATE(18670), 2,
      sym_block_comment,
      sym_line_comment,
  [397084] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25508), 1,
      anon_sym_DASH_GT,
    STATE(18671), 2,
      sym_block_comment,
      sym_line_comment,
  [397098] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13026), 1,
      anon_sym_RPAREN,
    STATE(18672), 2,
      sym_block_comment,
      sym_line_comment,
  [397112] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25510), 1,
      anon_sym_end,
    STATE(18673), 2,
      sym_block_comment,
      sym_line_comment,
  [397126] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25512), 1,
      anon_sym_RPAREN,
    STATE(18674), 2,
      sym_block_comment,
      sym_line_comment,
  [397140] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25514), 1,
      anon_sym_end,
    STATE(18675), 2,
      sym_block_comment,
      sym_line_comment,
  [397154] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25516), 1,
      anon_sym_end,
    STATE(18676), 2,
      sym_block_comment,
      sym_line_comment,
  [397168] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25518), 1,
      anon_sym_end,
    STATE(18677), 2,
      sym_block_comment,
      sym_line_comment,
  [397182] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25520), 1,
      anon_sym_end,
    STATE(18678), 2,
      sym_block_comment,
      sym_line_comment,
  [397196] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25522), 1,
      anon_sym_RBRACK,
    STATE(18679), 2,
      sym_block_comment,
      sym_line_comment,
  [397210] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25524), 1,
      anon_sym_end,
    STATE(18680), 2,
      sym_block_comment,
      sym_line_comment,
  [397224] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25526), 1,
      anon_sym_end,
    STATE(18681), 2,
      sym_block_comment,
      sym_line_comment,
  [397238] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25528), 1,
      anon_sym_end,
    STATE(18682), 2,
      sym_block_comment,
      sym_line_comment,
  [397252] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20553), 1,
      anon_sym_end,
    STATE(18683), 2,
      sym_block_comment,
      sym_line_comment,
  [397266] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25530), 1,
      anon_sym_end,
    STATE(18684), 2,
      sym_block_comment,
      sym_line_comment,
  [397280] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25532), 1,
      anon_sym_end,
    STATE(18685), 2,
      sym_block_comment,
      sym_line_comment,
  [397294] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25534), 1,
      anon_sym_RPAREN,
    STATE(18686), 2,
      sym_block_comment,
      sym_line_comment,
  [397308] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25536), 1,
      anon_sym_RBRACK,
    STATE(18687), 2,
      sym_block_comment,
      sym_line_comment,
  [397322] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10527), 1,
      sym__immediate_paren,
    STATE(18688), 2,
      sym_block_comment,
      sym_line_comment,
  [397336] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21123), 1,
      anon_sym_end,
    STATE(18689), 2,
      sym_block_comment,
      sym_line_comment,
  [397350] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25538), 1,
      anon_sym_end,
    STATE(18690), 2,
      sym_block_comment,
      sym_line_comment,
  [397364] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25540), 1,
      anon_sym_RBRACK,
    STATE(18691), 2,
      sym_block_comment,
      sym_line_comment,
  [397378] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25542), 1,
      anon_sym_end,
    STATE(18692), 2,
      sym_block_comment,
      sym_line_comment,
  [397392] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25544), 1,
      anon_sym_RBRACK,
    STATE(18693), 2,
      sym_block_comment,
      sym_line_comment,
  [397406] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25546), 1,
      anon_sym_end,
    STATE(18694), 2,
      sym_block_comment,
      sym_line_comment,
  [397420] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25548), 1,
      anon_sym_end,
    STATE(18695), 2,
      sym_block_comment,
      sym_line_comment,
  [397434] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25550), 1,
      anon_sym_end,
    STATE(18696), 2,
      sym_block_comment,
      sym_line_comment,
  [397448] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25552), 1,
      anon_sym_end,
    STATE(18697), 2,
      sym_block_comment,
      sym_line_comment,
  [397462] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25554), 1,
      anon_sym_RBRACK,
    STATE(18698), 2,
      sym_block_comment,
      sym_line_comment,
  [397476] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25556), 1,
      anon_sym_RPAREN,
    STATE(18699), 2,
      sym_block_comment,
      sym_line_comment,
  [397490] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20804), 1,
      anon_sym_end,
    STATE(18700), 2,
      sym_block_comment,
      sym_line_comment,
  [397504] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15380), 1,
      anon_sym_DASH_GT,
    STATE(18701), 2,
      sym_block_comment,
      sym_line_comment,
  [397518] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8730), 1,
      anon_sym_RPAREN,
    STATE(18702), 2,
      sym_block_comment,
      sym_line_comment,
  [397532] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25558), 1,
      anon_sym_end,
    STATE(18703), 2,
      sym_block_comment,
      sym_line_comment,
  [397546] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21172), 1,
      anon_sym_end,
    STATE(18704), 2,
      sym_block_comment,
      sym_line_comment,
  [397560] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7012), 1,
      anon_sym_RPAREN,
    STATE(18705), 2,
      sym_block_comment,
      sym_line_comment,
  [397574] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25560), 1,
      anon_sym_end,
    STATE(18706), 2,
      sym_block_comment,
      sym_line_comment,
  [397588] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25562), 1,
      anon_sym_RBRACK,
    STATE(18707), 2,
      sym_block_comment,
      sym_line_comment,
  [397602] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25564), 1,
      anon_sym_end,
    STATE(18708), 2,
      sym_block_comment,
      sym_line_comment,
  [397616] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25566), 1,
      anon_sym_RBRACK,
    STATE(18709), 2,
      sym_block_comment,
      sym_line_comment,
  [397630] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25568), 1,
      anon_sym_RPAREN,
    STATE(18710), 2,
      sym_block_comment,
      sym_line_comment,
  [397644] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7814), 1,
      anon_sym_RPAREN,
    STATE(18711), 2,
      sym_block_comment,
      sym_line_comment,
  [397658] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7592), 1,
      anon_sym_RPAREN,
    STATE(18712), 2,
      sym_block_comment,
      sym_line_comment,
  [397672] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25570), 1,
      anon_sym_end,
    STATE(18713), 2,
      sym_block_comment,
      sym_line_comment,
  [397686] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25572), 1,
      anon_sym_end,
    STATE(18714), 2,
      sym_block_comment,
      sym_line_comment,
  [397700] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25574), 1,
      anon_sym_end,
    STATE(18715), 2,
      sym_block_comment,
      sym_line_comment,
  [397714] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25576), 1,
      anon_sym_RPAREN,
    STATE(18716), 2,
      sym_block_comment,
      sym_line_comment,
  [397728] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6922), 1,
      anon_sym_RPAREN,
    STATE(18717), 2,
      sym_block_comment,
      sym_line_comment,
  [397742] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25578), 1,
      anon_sym_RBRACK,
    STATE(18718), 2,
      sym_block_comment,
      sym_line_comment,
  [397756] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7662), 1,
      anon_sym_RPAREN,
    STATE(18719), 2,
      sym_block_comment,
      sym_line_comment,
  [397770] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25580), 1,
      anon_sym_EQ,
    STATE(18720), 2,
      sym_block_comment,
      sym_line_comment,
  [397784] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25582), 1,
      anon_sym_RBRACK,
    STATE(18721), 2,
      sym_block_comment,
      sym_line_comment,
  [397798] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13110), 1,
      anon_sym_RPAREN,
    STATE(18722), 2,
      sym_block_comment,
      sym_line_comment,
  [397812] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25584), 1,
      anon_sym_end,
    STATE(18723), 2,
      sym_block_comment,
      sym_line_comment,
  [397826] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25586), 1,
      anon_sym_end,
    STATE(18724), 2,
      sym_block_comment,
      sym_line_comment,
  [397840] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25588), 1,
      anon_sym_RPAREN,
    STATE(18725), 2,
      sym_block_comment,
      sym_line_comment,
  [397854] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18760), 1,
      anon_sym_RBRACE,
    STATE(18726), 2,
      sym_block_comment,
      sym_line_comment,
  [397868] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18780), 1,
      anon_sym_RBRACE,
    STATE(18727), 2,
      sym_block_comment,
      sym_line_comment,
  [397882] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7780), 1,
      anon_sym_RPAREN,
    STATE(18728), 2,
      sym_block_comment,
      sym_line_comment,
  [397896] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25590), 1,
      anon_sym_RPAREN,
    STATE(18729), 2,
      sym_block_comment,
      sym_line_comment,
  [397910] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25592), 1,
      anon_sym_end,
    STATE(18730), 2,
      sym_block_comment,
      sym_line_comment,
  [397924] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25594), 1,
      anon_sym_COLON2,
    STATE(18731), 2,
      sym_block_comment,
      sym_line_comment,
  [397938] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25596), 1,
      anon_sym_end,
    STATE(18732), 2,
      sym_block_comment,
      sym_line_comment,
  [397952] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25598), 1,
      anon_sym_end,
    STATE(18733), 2,
      sym_block_comment,
      sym_line_comment,
  [397966] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25600), 1,
      anon_sym_end,
    STATE(18734), 2,
      sym_block_comment,
      sym_line_comment,
  [397980] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10629), 1,
      sym__immediate_paren,
    STATE(18735), 2,
      sym_block_comment,
      sym_line_comment,
  [397994] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13110), 1,
      anon_sym_RPAREN,
    STATE(18736), 2,
      sym_block_comment,
      sym_line_comment,
  [398008] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15688), 1,
      anon_sym_DASH_GT,
    STATE(18737), 2,
      sym_block_comment,
      sym_line_comment,
  [398022] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25602), 1,
      anon_sym_EQ,
    STATE(18738), 2,
      sym_block_comment,
      sym_line_comment,
  [398036] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25604), 1,
      anon_sym_COLON2,
    STATE(18739), 2,
      sym_block_comment,
      sym_line_comment,
  [398050] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25606), 1,
      anon_sym_end,
    STATE(18740), 2,
      sym_block_comment,
      sym_line_comment,
  [398064] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7322), 1,
      anon_sym_RPAREN,
    STATE(18741), 2,
      sym_block_comment,
      sym_line_comment,
  [398078] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25608), 1,
      anon_sym_end,
    STATE(18742), 2,
      sym_block_comment,
      sym_line_comment,
  [398092] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15338), 1,
      anon_sym_DASH_GT,
    STATE(18743), 2,
      sym_block_comment,
      sym_line_comment,
  [398106] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25610), 1,
      anon_sym_end,
    STATE(18744), 2,
      sym_block_comment,
      sym_line_comment,
  [398120] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25612), 1,
      anon_sym_RBRACK,
    STATE(18745), 2,
      sym_block_comment,
      sym_line_comment,
  [398134] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25614), 1,
      anon_sym_RBRACK,
    STATE(18746), 2,
      sym_block_comment,
      sym_line_comment,
  [398148] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25616), 1,
      anon_sym_COLON2,
    STATE(18747), 2,
      sym_block_comment,
      sym_line_comment,
  [398162] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25618), 1,
      anon_sym_end,
    STATE(18748), 2,
      sym_block_comment,
      sym_line_comment,
  [398176] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25620), 1,
      anon_sym_end,
    STATE(18749), 2,
      sym_block_comment,
      sym_line_comment,
  [398190] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6668), 1,
      anon_sym_RPAREN,
    STATE(18750), 2,
      sym_block_comment,
      sym_line_comment,
  [398204] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20061), 1,
      anon_sym_end,
    STATE(18751), 2,
      sym_block_comment,
      sym_line_comment,
  [398218] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25622), 1,
      anon_sym_RBRACK,
    STATE(18752), 2,
      sym_block_comment,
      sym_line_comment,
  [398232] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7840), 1,
      anon_sym_RPAREN,
    STATE(18753), 2,
      sym_block_comment,
      sym_line_comment,
  [398246] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25624), 1,
      anon_sym_RPAREN,
    STATE(18754), 2,
      sym_block_comment,
      sym_line_comment,
  [398260] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25626), 1,
      anon_sym_DASH_GT,
    STATE(18755), 2,
      sym_block_comment,
      sym_line_comment,
  [398274] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25628), 1,
      anon_sym_end,
    STATE(18756), 2,
      sym_block_comment,
      sym_line_comment,
  [398288] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25630), 1,
      anon_sym_end,
    STATE(18757), 2,
      sym_block_comment,
      sym_line_comment,
  [398302] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9826), 1,
      anon_sym_DASH_GT,
    STATE(18758), 2,
      sym_block_comment,
      sym_line_comment,
  [398316] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25632), 1,
      anon_sym_end,
    STATE(18759), 2,
      sym_block_comment,
      sym_line_comment,
  [398330] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25634), 1,
      anon_sym_end,
    STATE(18760), 2,
      sym_block_comment,
      sym_line_comment,
  [398344] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25636), 1,
      anon_sym_end,
    STATE(18761), 2,
      sym_block_comment,
      sym_line_comment,
  [398358] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20593), 1,
      anon_sym_end,
    STATE(18762), 2,
      sym_block_comment,
      sym_line_comment,
  [398372] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25638), 1,
      anon_sym_RBRACK,
    STATE(18763), 2,
      sym_block_comment,
      sym_line_comment,
  [398386] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25640), 1,
      anon_sym_end,
    STATE(18764), 2,
      sym_block_comment,
      sym_line_comment,
  [398400] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25642), 1,
      anon_sym_RBRACK,
    STATE(18765), 2,
      sym_block_comment,
      sym_line_comment,
  [398414] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25644), 1,
      anon_sym_DASH_GT,
    STATE(18766), 2,
      sym_block_comment,
      sym_line_comment,
  [398428] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25646), 1,
      anon_sym_end,
    STATE(18767), 2,
      sym_block_comment,
      sym_line_comment,
  [398442] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25648), 1,
      anon_sym_end,
    STATE(18768), 2,
      sym_block_comment,
      sym_line_comment,
  [398456] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15478), 1,
      anon_sym_DASH_GT,
    STATE(18769), 2,
      sym_block_comment,
      sym_line_comment,
  [398470] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25650), 1,
      anon_sym_RBRACK,
    STATE(18770), 2,
      sym_block_comment,
      sym_line_comment,
  [398484] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24035), 1,
      anon_sym_end,
    STATE(18771), 2,
      sym_block_comment,
      sym_line_comment,
  [398498] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25652), 1,
      anon_sym_end,
    STATE(18772), 2,
      sym_block_comment,
      sym_line_comment,
  [398512] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25654), 1,
      anon_sym_end,
    STATE(18773), 2,
      sym_block_comment,
      sym_line_comment,
  [398526] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25656), 1,
      anon_sym_DASH_GT,
    STATE(18774), 2,
      sym_block_comment,
      sym_line_comment,
  [398540] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25658), 1,
      anon_sym_end,
    STATE(18775), 2,
      sym_block_comment,
      sym_line_comment,
  [398554] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25660), 1,
      anon_sym_RBRACK,
    STATE(18776), 2,
      sym_block_comment,
      sym_line_comment,
  [398568] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18986), 1,
      anon_sym_RBRACE,
    STATE(18777), 2,
      sym_block_comment,
      sym_line_comment,
  [398582] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25662), 1,
      anon_sym_EQ,
    STATE(18778), 2,
      sym_block_comment,
      sym_line_comment,
  [398596] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25664), 1,
      anon_sym_RBRACK,
    STATE(18779), 2,
      sym_block_comment,
      sym_line_comment,
  [398610] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25666), 1,
      anon_sym_RPAREN,
    STATE(18780), 2,
      sym_block_comment,
      sym_line_comment,
  [398624] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25668), 1,
      anon_sym_RBRACK,
    STATE(18781), 2,
      sym_block_comment,
      sym_line_comment,
  [398638] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25670), 1,
      anon_sym_end,
    STATE(18782), 2,
      sym_block_comment,
      sym_line_comment,
  [398652] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15344), 1,
      anon_sym_DASH_GT,
    STATE(18783), 2,
      sym_block_comment,
      sym_line_comment,
  [398666] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25672), 1,
      anon_sym_RPAREN,
    STATE(18784), 2,
      sym_block_comment,
      sym_line_comment,
  [398680] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25674), 1,
      anon_sym_COLON2,
    STATE(18785), 2,
      sym_block_comment,
      sym_line_comment,
  [398694] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10677), 1,
      sym__immediate_paren,
    STATE(18786), 2,
      sym_block_comment,
      sym_line_comment,
  [398708] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7234), 1,
      anon_sym_RPAREN,
    STATE(18787), 2,
      sym_block_comment,
      sym_line_comment,
  [398722] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19316), 1,
      anon_sym_RBRACE,
    STATE(18788), 2,
      sym_block_comment,
      sym_line_comment,
  [398736] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19096), 1,
      anon_sym_RBRACE,
    STATE(18789), 2,
      sym_block_comment,
      sym_line_comment,
  [398750] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15311), 1,
      anon_sym_DASH_GT,
    STATE(18790), 2,
      sym_block_comment,
      sym_line_comment,
  [398764] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25676), 1,
      anon_sym_RPAREN,
    STATE(18791), 2,
      sym_block_comment,
      sym_line_comment,
  [398778] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25678), 1,
      anon_sym_RBRACK,
    STATE(18792), 2,
      sym_block_comment,
      sym_line_comment,
  [398792] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25680), 1,
      anon_sym_RPAREN,
    STATE(18793), 2,
      sym_block_comment,
      sym_line_comment,
  [398806] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7910), 1,
      anon_sym_RPAREN,
    STATE(18794), 2,
      sym_block_comment,
      sym_line_comment,
  [398820] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15464), 1,
      anon_sym_DASH_GT,
    STATE(18795), 2,
      sym_block_comment,
      sym_line_comment,
  [398834] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25682), 1,
      anon_sym_DASH_GT,
    STATE(18796), 2,
      sym_block_comment,
      sym_line_comment,
  [398848] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9858), 1,
      anon_sym_DASH_GT,
    STATE(18797), 2,
      sym_block_comment,
      sym_line_comment,
  [398862] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25684), 1,
      anon_sym_DASH_GT,
    STATE(18798), 2,
      sym_block_comment,
      sym_line_comment,
  [398876] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25686), 1,
      anon_sym_DASH_GT,
    STATE(18799), 2,
      sym_block_comment,
      sym_line_comment,
  [398890] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15594), 1,
      anon_sym_DASH_GT,
    STATE(18800), 2,
      sym_block_comment,
      sym_line_comment,
  [398904] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15172), 1,
      anon_sym_DASH_GT,
    STATE(18801), 2,
      sym_block_comment,
      sym_line_comment,
  [398918] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25688), 1,
      anon_sym_RBRACK,
    STATE(18802), 2,
      sym_block_comment,
      sym_line_comment,
  [398932] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15170), 1,
      anon_sym_DASH_GT,
    STATE(18803), 2,
      sym_block_comment,
      sym_line_comment,
  [398946] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25690), 1,
      anon_sym_end,
    STATE(18804), 2,
      sym_block_comment,
      sym_line_comment,
  [398960] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15174), 1,
      anon_sym_DASH_GT,
    STATE(18805), 2,
      sym_block_comment,
      sym_line_comment,
  [398974] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15680), 1,
      anon_sym_DASH_GT,
    STATE(18806), 2,
      sym_block_comment,
      sym_line_comment,
  [398988] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15277), 1,
      anon_sym_DASH_GT,
    STATE(18807), 2,
      sym_block_comment,
      sym_line_comment,
  [399002] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15279), 1,
      anon_sym_DASH_GT,
    STATE(18808), 2,
      sym_block_comment,
      sym_line_comment,
  [399016] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25692), 1,
      anon_sym_end,
    STATE(18809), 2,
      sym_block_comment,
      sym_line_comment,
  [399030] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25694), 1,
      anon_sym_end,
    STATE(18810), 2,
      sym_block_comment,
      sym_line_comment,
  [399044] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13066), 1,
      anon_sym_RPAREN,
    STATE(18811), 2,
      sym_block_comment,
      sym_line_comment,
  [399058] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25696), 1,
      anon_sym_RBRACK,
    STATE(18812), 2,
      sym_block_comment,
      sym_line_comment,
  [399072] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8442), 1,
      anon_sym_RPAREN,
    STATE(18813), 2,
      sym_block_comment,
      sym_line_comment,
  [399086] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25698), 1,
      anon_sym_end,
    STATE(18814), 2,
      sym_block_comment,
      sym_line_comment,
  [399100] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25700), 1,
      anon_sym_end,
    STATE(18815), 2,
      sym_block_comment,
      sym_line_comment,
  [399114] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25702), 1,
      anon_sym_end,
    STATE(18816), 2,
      sym_block_comment,
      sym_line_comment,
  [399128] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13066), 1,
      anon_sym_RPAREN,
    STATE(18817), 2,
      sym_block_comment,
      sym_line_comment,
  [399142] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25704), 1,
      anon_sym_end,
    STATE(18818), 2,
      sym_block_comment,
      sym_line_comment,
  [399156] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25706), 1,
      anon_sym_end,
    STATE(18819), 2,
      sym_block_comment,
      sym_line_comment,
  [399170] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25708), 1,
      anon_sym_end,
    STATE(18820), 2,
      sym_block_comment,
      sym_line_comment,
  [399184] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25710), 1,
      anon_sym_COLON2,
    STATE(18821), 2,
      sym_block_comment,
      sym_line_comment,
  [399198] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10094), 1,
      anon_sym_DASH_GT,
    STATE(18822), 2,
      sym_block_comment,
      sym_line_comment,
  [399212] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25712), 1,
      anon_sym_end,
    STATE(18823), 2,
      sym_block_comment,
      sym_line_comment,
  [399226] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24045), 1,
      anon_sym_end,
    STATE(18824), 2,
      sym_block_comment,
      sym_line_comment,
  [399240] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8188), 1,
      anon_sym_RPAREN,
    STATE(18825), 2,
      sym_block_comment,
      sym_line_comment,
  [399254] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25714), 1,
      anon_sym_end,
    STATE(18826), 2,
      sym_block_comment,
      sym_line_comment,
  [399268] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25716), 1,
      anon_sym_COLON2,
    STATE(18827), 2,
      sym_block_comment,
      sym_line_comment,
  [399282] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8612), 1,
      anon_sym_RPAREN,
    STATE(18828), 2,
      sym_block_comment,
      sym_line_comment,
  [399296] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8704), 1,
      anon_sym_RPAREN,
    STATE(18829), 2,
      sym_block_comment,
      sym_line_comment,
  [399310] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25718), 1,
      anon_sym_COLON2,
    STATE(18830), 2,
      sym_block_comment,
      sym_line_comment,
  [399324] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25720), 1,
      anon_sym_RBRACK,
    STATE(18831), 2,
      sym_block_comment,
      sym_line_comment,
  [399338] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25722), 1,
      anon_sym_RBRACK,
    STATE(18832), 2,
      sym_block_comment,
      sym_line_comment,
  [399352] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25724), 1,
      anon_sym_end,
    STATE(18833), 2,
      sym_block_comment,
      sym_line_comment,
  [399366] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8660), 1,
      anon_sym_RPAREN,
    STATE(18834), 2,
      sym_block_comment,
      sym_line_comment,
  [399380] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25726), 1,
      anon_sym_EQ,
    STATE(18835), 2,
      sym_block_comment,
      sym_line_comment,
  [399394] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6358), 1,
      anon_sym_RPAREN,
    STATE(18836), 2,
      sym_block_comment,
      sym_line_comment,
  [399408] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25728), 1,
      anon_sym_RBRACK,
    STATE(18837), 2,
      sym_block_comment,
      sym_line_comment,
  [399422] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25730), 1,
      anon_sym_end,
    STATE(18838), 2,
      sym_block_comment,
      sym_line_comment,
  [399436] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13102), 1,
      anon_sym_RPAREN,
    STATE(18839), 2,
      sym_block_comment,
      sym_line_comment,
  [399450] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12998), 1,
      anon_sym_RPAREN,
    STATE(18840), 2,
      sym_block_comment,
      sym_line_comment,
  [399464] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25732), 1,
      anon_sym_end,
    STATE(18841), 2,
      sym_block_comment,
      sym_line_comment,
  [399478] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13102), 1,
      anon_sym_RPAREN,
    STATE(18842), 2,
      sym_block_comment,
      sym_line_comment,
  [399492] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25734), 1,
      anon_sym_end,
    STATE(18843), 2,
      sym_block_comment,
      sym_line_comment,
  [399506] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25736), 1,
      anon_sym_RPAREN,
    STATE(18844), 2,
      sym_block_comment,
      sym_line_comment,
  [399520] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25738), 1,
      anon_sym_end,
    STATE(18845), 2,
      sym_block_comment,
      sym_line_comment,
  [399534] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19420), 1,
      anon_sym_RBRACE,
    STATE(18846), 2,
      sym_block_comment,
      sym_line_comment,
  [399548] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8726), 1,
      anon_sym_RPAREN,
    STATE(18847), 2,
      sym_block_comment,
      sym_line_comment,
  [399562] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25740), 1,
      anon_sym_end,
    STATE(18848), 2,
      sym_block_comment,
      sym_line_comment,
  [399576] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19446), 1,
      anon_sym_RBRACE,
    STATE(18849), 2,
      sym_block_comment,
      sym_line_comment,
  [399590] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13000), 1,
      anon_sym_RPAREN,
    STATE(18850), 2,
      sym_block_comment,
      sym_line_comment,
  [399604] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25742), 1,
      anon_sym_RPAREN,
    STATE(18851), 2,
      sym_block_comment,
      sym_line_comment,
  [399618] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7418), 1,
      anon_sym_RPAREN,
    STATE(18852), 2,
      sym_block_comment,
      sym_line_comment,
  [399632] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12998), 1,
      anon_sym_RPAREN,
    STATE(18853), 2,
      sym_block_comment,
      sym_line_comment,
  [399646] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25744), 1,
      anon_sym_RBRACK,
    STATE(18854), 2,
      sym_block_comment,
      sym_line_comment,
  [399660] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25746), 1,
      anon_sym_end,
    STATE(18855), 2,
      sym_block_comment,
      sym_line_comment,
  [399674] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7462), 1,
      anon_sym_RPAREN,
    STATE(18856), 2,
      sym_block_comment,
      sym_line_comment,
  [399688] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25748), 1,
      anon_sym_RPAREN,
    STATE(18857), 2,
      sym_block_comment,
      sym_line_comment,
  [399702] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25750), 1,
      anon_sym_end,
    STATE(18858), 2,
      sym_block_comment,
      sym_line_comment,
  [399716] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8226), 1,
      anon_sym_RPAREN,
    STATE(18859), 2,
      sym_block_comment,
      sym_line_comment,
  [399730] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15340), 1,
      anon_sym_DASH_GT,
    STATE(18860), 2,
      sym_block_comment,
      sym_line_comment,
  [399744] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25752), 1,
      anon_sym_end,
    STATE(18861), 2,
      sym_block_comment,
      sym_line_comment,
  [399758] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25754), 1,
      anon_sym_COLON2,
    STATE(18862), 2,
      sym_block_comment,
      sym_line_comment,
  [399772] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25756), 1,
      anon_sym_RPAREN,
    STATE(18863), 2,
      sym_block_comment,
      sym_line_comment,
  [399786] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25758), 1,
      anon_sym_end,
    STATE(18864), 2,
      sym_block_comment,
      sym_line_comment,
  [399800] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25760), 1,
      anon_sym_RBRACK,
    STATE(18865), 2,
      sym_block_comment,
      sym_line_comment,
  [399814] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25762), 1,
      anon_sym_EQ,
    STATE(18866), 2,
      sym_block_comment,
      sym_line_comment,
  [399828] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25764), 1,
      anon_sym_RBRACK,
    STATE(18867), 2,
      sym_block_comment,
      sym_line_comment,
  [399842] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8746), 1,
      anon_sym_RPAREN,
    STATE(18868), 2,
      sym_block_comment,
      sym_line_comment,
  [399856] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15271), 1,
      anon_sym_DASH_GT,
    STATE(18869), 2,
      sym_block_comment,
      sym_line_comment,
  [399870] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25766), 1,
      anon_sym_end,
    STATE(18870), 2,
      sym_block_comment,
      sym_line_comment,
  [399884] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25768), 1,
      anon_sym_RPAREN,
    STATE(18871), 2,
      sym_block_comment,
      sym_line_comment,
  [399898] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18790), 1,
      anon_sym_RBRACE,
    STATE(18872), 2,
      sym_block_comment,
      sym_line_comment,
  [399912] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25770), 1,
      anon_sym_COLON2,
    STATE(18873), 2,
      sym_block_comment,
      sym_line_comment,
  [399926] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25772), 1,
      anon_sym_RPAREN,
    STATE(18874), 2,
      sym_block_comment,
      sym_line_comment,
  [399940] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25774), 1,
      anon_sym_end,
    STATE(18875), 2,
      sym_block_comment,
      sym_line_comment,
  [399954] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25776), 1,
      anon_sym_RBRACK,
    STATE(18876), 2,
      sym_block_comment,
      sym_line_comment,
  [399968] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10026), 1,
      anon_sym_DASH_GT,
    STATE(18877), 2,
      sym_block_comment,
      sym_line_comment,
  [399982] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25778), 1,
      anon_sym_type,
    STATE(18878), 2,
      sym_block_comment,
      sym_line_comment,
  [399996] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25780), 1,
      anon_sym_struct,
    STATE(18879), 2,
      sym_block_comment,
      sym_line_comment,
  [400010] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25782), 1,
      anon_sym_RBRACK,
    STATE(18880), 2,
      sym_block_comment,
      sym_line_comment,
  [400024] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25784), 1,
      anon_sym_end,
    STATE(18881), 2,
      sym_block_comment,
      sym_line_comment,
  [400038] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25786), 1,
      anon_sym_end,
    STATE(18882), 2,
      sym_block_comment,
      sym_line_comment,
  [400052] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25788), 1,
      anon_sym_end,
    STATE(18883), 2,
      sym_block_comment,
      sym_line_comment,
  [400066] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25790), 1,
      anon_sym_end,
    STATE(18884), 2,
      sym_block_comment,
      sym_line_comment,
  [400080] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25792), 1,
      anon_sym_end,
    STATE(18885), 2,
      sym_block_comment,
      sym_line_comment,
  [400094] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25794), 1,
      anon_sym_end,
    STATE(18886), 2,
      sym_block_comment,
      sym_line_comment,
  [400108] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13078), 1,
      anon_sym_RPAREN,
    STATE(18887), 2,
      sym_block_comment,
      sym_line_comment,
  [400122] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20209), 1,
      anon_sym_end,
    STATE(18888), 2,
      sym_block_comment,
      sym_line_comment,
  [400136] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7646), 1,
      anon_sym_RPAREN,
    STATE(18889), 2,
      sym_block_comment,
      sym_line_comment,
  [400150] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25796), 1,
      anon_sym_end,
    STATE(18890), 2,
      sym_block_comment,
      sym_line_comment,
  [400164] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25798), 1,
      anon_sym_end,
    STATE(18891), 2,
      sym_block_comment,
      sym_line_comment,
  [400178] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25800), 1,
      anon_sym_RBRACK,
    STATE(18892), 2,
      sym_block_comment,
      sym_line_comment,
  [400192] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25802), 1,
      anon_sym_DASH_GT,
    STATE(18893), 2,
      sym_block_comment,
      sym_line_comment,
  [400206] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13048), 1,
      anon_sym_RPAREN,
    STATE(18894), 2,
      sym_block_comment,
      sym_line_comment,
  [400220] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25804), 1,
      anon_sym_end,
    STATE(18895), 2,
      sym_block_comment,
      sym_line_comment,
  [400234] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10567), 1,
      sym__immediate_paren,
    STATE(18896), 2,
      sym_block_comment,
      sym_line_comment,
  [400248] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13078), 1,
      anon_sym_RPAREN,
    STATE(18897), 2,
      sym_block_comment,
      sym_line_comment,
  [400262] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7002), 1,
      anon_sym_RPAREN,
    STATE(18898), 2,
      sym_block_comment,
      sym_line_comment,
  [400276] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25806), 1,
      anon_sym_end,
    STATE(18899), 2,
      sym_block_comment,
      sym_line_comment,
  [400290] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8788), 1,
      anon_sym_RPAREN,
    STATE(18900), 2,
      sym_block_comment,
      sym_line_comment,
  [400304] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25808), 1,
      anon_sym_EQ,
    STATE(18901), 2,
      sym_block_comment,
      sym_line_comment,
  [400318] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10900), 1,
      sym__immediate_paren,
    STATE(18902), 2,
      sym_block_comment,
      sym_line_comment,
  [400332] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8688), 1,
      anon_sym_RPAREN,
    STATE(18903), 2,
      sym_block_comment,
      sym_line_comment,
  [400346] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25810), 1,
      anon_sym_end,
    STATE(18904), 2,
      sym_block_comment,
      sym_line_comment,
  [400360] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25812), 1,
      anon_sym_COLON2,
    STATE(18905), 2,
      sym_block_comment,
      sym_line_comment,
  [400374] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25814), 1,
      anon_sym_end,
    STATE(18906), 2,
      sym_block_comment,
      sym_line_comment,
  [400388] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6652), 1,
      anon_sym_RPAREN,
    STATE(18907), 2,
      sym_block_comment,
      sym_line_comment,
  [400402] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25816), 1,
      anon_sym_COLON2,
    STATE(18908), 2,
      sym_block_comment,
      sym_line_comment,
  [400416] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25818), 1,
      anon_sym_RBRACK,
    STATE(18909), 2,
      sym_block_comment,
      sym_line_comment,
  [400430] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8718), 1,
      anon_sym_RPAREN,
    STATE(18910), 2,
      sym_block_comment,
      sym_line_comment,
  [400444] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7488), 1,
      anon_sym_RPAREN,
    STATE(18911), 2,
      sym_block_comment,
      sym_line_comment,
  [400458] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8492), 1,
      anon_sym_RPAREN,
    STATE(18912), 2,
      sym_block_comment,
      sym_line_comment,
  [400472] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8216), 1,
      anon_sym_RPAREN,
    STATE(18913), 2,
      sym_block_comment,
      sym_line_comment,
  [400486] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25820), 1,
      anon_sym_RBRACK,
    STATE(18914), 2,
      sym_block_comment,
      sym_line_comment,
  [400500] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20245), 1,
      anon_sym_end,
    STATE(18915), 2,
      sym_block_comment,
      sym_line_comment,
  [400514] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8706), 1,
      anon_sym_RPAREN,
    STATE(18916), 2,
      sym_block_comment,
      sym_line_comment,
  [400528] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25822), 1,
      anon_sym_RBRACK,
    STATE(18917), 2,
      sym_block_comment,
      sym_line_comment,
  [400542] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25824), 1,
      anon_sym_COLON2,
    STATE(18918), 2,
      sym_block_comment,
      sym_line_comment,
  [400556] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25826), 1,
      anon_sym_COLON2,
    STATE(18919), 2,
      sym_block_comment,
      sym_line_comment,
  [400570] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25828), 1,
      anon_sym_EQ,
    STATE(18920), 2,
      sym_block_comment,
      sym_line_comment,
  [400584] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7928), 1,
      anon_sym_RPAREN,
    STATE(18921), 2,
      sym_block_comment,
      sym_line_comment,
  [400598] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6776), 1,
      anon_sym_RPAREN,
    STATE(18922), 2,
      sym_block_comment,
      sym_line_comment,
  [400612] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25830), 1,
      anon_sym_EQ,
    STATE(18923), 2,
      sym_block_comment,
      sym_line_comment,
  [400626] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25832), 1,
      anon_sym_RBRACK,
    STATE(18924), 2,
      sym_block_comment,
      sym_line_comment,
  [400640] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25834), 1,
      anon_sym_end,
    STATE(18925), 2,
      sym_block_comment,
      sym_line_comment,
  [400654] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25836), 1,
      anon_sym_end,
    STATE(18926), 2,
      sym_block_comment,
      sym_line_comment,
  [400668] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13004), 1,
      anon_sym_RPAREN,
    STATE(18927), 2,
      sym_block_comment,
      sym_line_comment,
  [400682] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25838), 1,
      anon_sym_EQ,
    STATE(18928), 2,
      sym_block_comment,
      sym_line_comment,
  [400696] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13004), 1,
      anon_sym_RPAREN,
    STATE(18929), 2,
      sym_block_comment,
      sym_line_comment,
  [400710] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13014), 1,
      anon_sym_RPAREN,
    STATE(18930), 2,
      sym_block_comment,
      sym_line_comment,
  [400724] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25840), 1,
      anon_sym_end,
    STATE(18931), 2,
      sym_block_comment,
      sym_line_comment,
  [400738] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25842), 1,
      anon_sym_end,
    STATE(18932), 2,
      sym_block_comment,
      sym_line_comment,
  [400752] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6366), 1,
      anon_sym_RPAREN,
    STATE(18933), 2,
      sym_block_comment,
      sym_line_comment,
  [400766] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25844), 1,
      anon_sym_end,
    STATE(18934), 2,
      sym_block_comment,
      sym_line_comment,
  [400780] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25846), 1,
      anon_sym_LPAREN,
    STATE(18935), 2,
      sym_block_comment,
      sym_line_comment,
  [400794] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12994), 1,
      anon_sym_RPAREN,
    STATE(18936), 2,
      sym_block_comment,
      sym_line_comment,
  [400808] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25848), 1,
      anon_sym_end,
    STATE(18937), 2,
      sym_block_comment,
      sym_line_comment,
  [400822] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25850), 1,
      anon_sym_RBRACK,
    STATE(18938), 2,
      sym_block_comment,
      sym_line_comment,
  [400836] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25852), 1,
      anon_sym_RPAREN,
    STATE(18939), 2,
      sym_block_comment,
      sym_line_comment,
  [400850] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25854), 1,
      anon_sym_end,
    STATE(18940), 2,
      sym_block_comment,
      sym_line_comment,
  [400864] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25856), 1,
      anon_sym_RPAREN,
    STATE(18941), 2,
      sym_block_comment,
      sym_line_comment,
  [400878] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19338), 1,
      anon_sym_RBRACE,
    STATE(18942), 2,
      sym_block_comment,
      sym_line_comment,
  [400892] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8554), 1,
      anon_sym_RPAREN,
    STATE(18943), 2,
      sym_block_comment,
      sym_line_comment,
  [400906] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8826), 1,
      anon_sym_RPAREN,
    STATE(18944), 2,
      sym_block_comment,
      sym_line_comment,
  [400920] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12994), 1,
      anon_sym_RPAREN,
    STATE(18945), 2,
      sym_block_comment,
      sym_line_comment,
  [400934] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7842), 1,
      anon_sym_RPAREN,
    STATE(18946), 2,
      sym_block_comment,
      sym_line_comment,
  [400948] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25858), 1,
      anon_sym_end,
    STATE(18947), 2,
      sym_block_comment,
      sym_line_comment,
  [400962] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25860), 1,
      anon_sym_end,
    STATE(18948), 2,
      sym_block_comment,
      sym_line_comment,
  [400976] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25862), 1,
      anon_sym_COLON2,
    STATE(18949), 2,
      sym_block_comment,
      sym_line_comment,
  [400990] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25864), 1,
      anon_sym_RBRACK,
    STATE(18950), 2,
      sym_block_comment,
      sym_line_comment,
  [401004] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25866), 1,
      anon_sym_RBRACK,
    STATE(18951), 2,
      sym_block_comment,
      sym_line_comment,
  [401018] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25868), 1,
      anon_sym_EQ,
    STATE(18952), 2,
      sym_block_comment,
      sym_line_comment,
  [401032] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15354), 1,
      anon_sym_DASH_GT,
    STATE(18953), 2,
      sym_block_comment,
      sym_line_comment,
  [401046] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25870), 1,
      anon_sym_RBRACK,
    STATE(18954), 2,
      sym_block_comment,
      sym_line_comment,
  [401060] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25872), 1,
      anon_sym_RBRACK,
    STATE(18955), 2,
      sym_block_comment,
      sym_line_comment,
  [401074] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25874), 1,
      anon_sym_RBRACK,
    STATE(18956), 2,
      sym_block_comment,
      sym_line_comment,
  [401088] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8736), 1,
      anon_sym_RPAREN,
    STATE(18957), 2,
      sym_block_comment,
      sym_line_comment,
  [401102] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25876), 1,
      anon_sym_EQ,
    STATE(18958), 2,
      sym_block_comment,
      sym_line_comment,
  [401116] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25878), 1,
      anon_sym_RBRACK,
    STATE(18959), 2,
      sym_block_comment,
      sym_line_comment,
  [401130] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25880), 1,
      anon_sym_RBRACK,
    STATE(18960), 2,
      sym_block_comment,
      sym_line_comment,
  [401144] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21017), 1,
      anon_sym_end,
    STATE(18961), 2,
      sym_block_comment,
      sym_line_comment,
  [401158] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8036), 1,
      anon_sym_RPAREN,
    STATE(18962), 2,
      sym_block_comment,
      sym_line_comment,
  [401172] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25882), 1,
      anon_sym_end,
    STATE(18963), 2,
      sym_block_comment,
      sym_line_comment,
  [401186] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25884), 1,
      anon_sym_end,
    STATE(18964), 2,
      sym_block_comment,
      sym_line_comment,
  [401200] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13048), 1,
      anon_sym_RPAREN,
    STATE(18965), 2,
      sym_block_comment,
      sym_line_comment,
  [401214] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25886), 1,
      anon_sym_COLON2,
    STATE(18966), 2,
      sym_block_comment,
      sym_line_comment,
  [401228] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9838), 1,
      anon_sym_DASH_GT,
    STATE(18967), 2,
      sym_block_comment,
      sym_line_comment,
  [401242] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25888), 1,
      anon_sym_end,
    STATE(18968), 2,
      sym_block_comment,
      sym_line_comment,
  [401256] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18804), 1,
      anon_sym_RBRACE,
    STATE(18969), 2,
      sym_block_comment,
      sym_line_comment,
  [401270] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6362), 1,
      anon_sym_RPAREN,
    STATE(18970), 2,
      sym_block_comment,
      sym_line_comment,
  [401284] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25890), 1,
      anon_sym_end,
    STATE(18971), 2,
      sym_block_comment,
      sym_line_comment,
  [401298] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(23985), 1,
      anon_sym_end,
    STATE(18972), 2,
      sym_block_comment,
      sym_line_comment,
  [401312] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25892), 1,
      anon_sym_end,
    STATE(18973), 2,
      sym_block_comment,
      sym_line_comment,
  [401326] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25894), 1,
      anon_sym_end,
    STATE(18974), 2,
      sym_block_comment,
      sym_line_comment,
  [401340] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25896), 1,
      anon_sym_end,
    STATE(18975), 2,
      sym_block_comment,
      sym_line_comment,
  [401354] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25898), 1,
      anon_sym_RPAREN,
    STATE(18976), 2,
      sym_block_comment,
      sym_line_comment,
  [401368] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25900), 1,
      anon_sym_end,
    STATE(18977), 2,
      sym_block_comment,
      sym_line_comment,
  [401382] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25902), 1,
      anon_sym_end,
    STATE(18978), 2,
      sym_block_comment,
      sym_line_comment,
  [401396] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13044), 1,
      anon_sym_RPAREN,
    STATE(18979), 2,
      sym_block_comment,
      sym_line_comment,
  [401410] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25904), 1,
      anon_sym_RBRACK,
    STATE(18980), 2,
      sym_block_comment,
      sym_line_comment,
  [401424] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21097), 1,
      anon_sym_end,
    STATE(18981), 2,
      sym_block_comment,
      sym_line_comment,
  [401438] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15295), 1,
      anon_sym_DASH_GT,
    STATE(18982), 2,
      sym_block_comment,
      sym_line_comment,
  [401452] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7304), 1,
      anon_sym_RPAREN,
    STATE(18983), 2,
      sym_block_comment,
      sym_line_comment,
  [401466] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19352), 1,
      anon_sym_RBRACE,
    STATE(18984), 2,
      sym_block_comment,
      sym_line_comment,
  [401480] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25906), 1,
      anon_sym_RBRACK,
    STATE(18985), 2,
      sym_block_comment,
      sym_line_comment,
  [401494] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25908), 1,
      anon_sym_end,
    STATE(18986), 2,
      sym_block_comment,
      sym_line_comment,
  [401508] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25910), 1,
      anon_sym_end,
    STATE(18987), 2,
      sym_block_comment,
      sym_line_comment,
  [401522] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9834), 1,
      anon_sym_DASH_GT,
    STATE(18988), 2,
      sym_block_comment,
      sym_line_comment,
  [401536] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25912), 1,
      anon_sym_end,
    STATE(18989), 2,
      sym_block_comment,
      sym_line_comment,
  [401550] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25914), 1,
      anon_sym_RBRACK,
    STATE(18990), 2,
      sym_block_comment,
      sym_line_comment,
  [401564] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25916), 1,
      anon_sym_end,
    STATE(18991), 2,
      sym_block_comment,
      sym_line_comment,
  [401578] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7470), 1,
      anon_sym_RPAREN,
    STATE(18992), 2,
      sym_block_comment,
      sym_line_comment,
  [401592] = 4,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(187), 1,
      aux_sym_block_comment_token1,
    ACTIONS(25918), 1,
      aux_sym_line_comment_token2,
    STATE(18993), 2,
      sym_block_comment,
      sym_line_comment,
  [401606] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25920), 1,
      anon_sym_type,
    STATE(18994), 2,
      sym_block_comment,
      sym_line_comment,
  [401620] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25922), 1,
      anon_sym_RBRACK,
    STATE(18995), 2,
      sym_block_comment,
      sym_line_comment,
  [401634] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13044), 1,
      anon_sym_RPAREN,
    STATE(18996), 2,
      sym_block_comment,
      sym_line_comment,
  [401648] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16190), 1,
      sym__immediate_paren,
    STATE(18997), 2,
      sym_block_comment,
      sym_line_comment,
  [401662] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25924), 1,
      anon_sym_end,
    STATE(18998), 2,
      sym_block_comment,
      sym_line_comment,
  [401676] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8696), 1,
      anon_sym_RPAREN,
    STATE(18999), 2,
      sym_block_comment,
      sym_line_comment,
  [401690] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25926), 1,
      anon_sym_end,
    STATE(19000), 2,
      sym_block_comment,
      sym_line_comment,
  [401704] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25928), 1,
      anon_sym_RBRACK,
    STATE(19001), 2,
      sym_block_comment,
      sym_line_comment,
  [401718] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25930), 1,
      anon_sym_end,
    STATE(19002), 2,
      sym_block_comment,
      sym_line_comment,
  [401732] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25932), 1,
      anon_sym_end,
    STATE(19003), 2,
      sym_block_comment,
      sym_line_comment,
  [401746] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25934), 1,
      anon_sym_RBRACK,
    STATE(19004), 2,
      sym_block_comment,
      sym_line_comment,
  [401760] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25936), 1,
      anon_sym_LPAREN,
    STATE(19005), 2,
      sym_block_comment,
      sym_line_comment,
  [401774] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13054), 1,
      anon_sym_RPAREN,
    STATE(19006), 2,
      sym_block_comment,
      sym_line_comment,
  [401788] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25938), 1,
      anon_sym_RBRACK,
    STATE(19007), 2,
      sym_block_comment,
      sym_line_comment,
  [401802] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25940), 1,
      anon_sym_RBRACK,
    STATE(19008), 2,
      sym_block_comment,
      sym_line_comment,
  [401816] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25942), 1,
      anon_sym_COLON2,
    STATE(19009), 2,
      sym_block_comment,
      sym_line_comment,
  [401830] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25944), 1,
      anon_sym_end,
    STATE(19010), 2,
      sym_block_comment,
      sym_line_comment,
  [401844] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25946), 1,
      anon_sym_COLON2,
    STATE(19011), 2,
      sym_block_comment,
      sym_line_comment,
  [401858] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25948), 1,
      anon_sym_RPAREN,
    STATE(19012), 2,
      sym_block_comment,
      sym_line_comment,
  [401872] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7212), 1,
      anon_sym_RPAREN,
    STATE(19013), 2,
      sym_block_comment,
      sym_line_comment,
  [401886] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25950), 1,
      anon_sym_end,
    STATE(19014), 2,
      sym_block_comment,
      sym_line_comment,
  [401900] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25952), 1,
      anon_sym_RBRACK,
    STATE(19015), 2,
      sym_block_comment,
      sym_line_comment,
  [401914] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25954), 1,
      anon_sym_end,
    STATE(19016), 2,
      sym_block_comment,
      sym_line_comment,
  [401928] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25956), 1,
      anon_sym_end,
    STATE(19017), 2,
      sym_block_comment,
      sym_line_comment,
  [401942] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21176), 1,
      anon_sym_end,
    STATE(19018), 2,
      sym_block_comment,
      sym_line_comment,
  [401956] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25958), 1,
      anon_sym_COLON2,
    STATE(19019), 2,
      sym_block_comment,
      sym_line_comment,
  [401970] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25960), 1,
      anon_sym_DASH_GT,
    STATE(19020), 2,
      sym_block_comment,
      sym_line_comment,
  [401984] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25962), 1,
      anon_sym_end,
    STATE(19021), 2,
      sym_block_comment,
      sym_line_comment,
  [401998] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25964), 1,
      anon_sym_RPAREN,
    STATE(19022), 2,
      sym_block_comment,
      sym_line_comment,
  [402012] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13052), 1,
      anon_sym_RPAREN,
    STATE(19023), 2,
      sym_block_comment,
      sym_line_comment,
  [402026] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6930), 1,
      anon_sym_RPAREN,
    STATE(19024), 2,
      sym_block_comment,
      sym_line_comment,
  [402040] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19298), 1,
      anon_sym_RBRACE,
    STATE(19025), 2,
      sym_block_comment,
      sym_line_comment,
  [402054] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25966), 1,
      anon_sym_end,
    STATE(19026), 2,
      sym_block_comment,
      sym_line_comment,
  [402068] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7478), 1,
      anon_sym_RPAREN,
    STATE(19027), 2,
      sym_block_comment,
      sym_line_comment,
  [402082] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8708), 1,
      anon_sym_RPAREN,
    STATE(19028), 2,
      sym_block_comment,
      sym_line_comment,
  [402096] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25968), 1,
      anon_sym_RPAREN,
    STATE(19029), 2,
      sym_block_comment,
      sym_line_comment,
  [402110] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25970), 1,
      anon_sym_RBRACK,
    STATE(19030), 2,
      sym_block_comment,
      sym_line_comment,
  [402124] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13052), 1,
      anon_sym_RPAREN,
    STATE(19031), 2,
      sym_block_comment,
      sym_line_comment,
  [402138] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13016), 1,
      anon_sym_RPAREN,
    STATE(19032), 2,
      sym_block_comment,
      sym_line_comment,
  [402152] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19256), 1,
      anon_sym_RBRACE,
    STATE(19033), 2,
      sym_block_comment,
      sym_line_comment,
  [402166] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25972), 1,
      anon_sym_RBRACK,
    STATE(19034), 2,
      sym_block_comment,
      sym_line_comment,
  [402180] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25974), 1,
      anon_sym_end,
    STATE(19035), 2,
      sym_block_comment,
      sym_line_comment,
  [402194] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25976), 1,
      anon_sym_type,
    STATE(19036), 2,
      sym_block_comment,
      sym_line_comment,
  [402208] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13058), 1,
      anon_sym_RPAREN,
    STATE(19037), 2,
      sym_block_comment,
      sym_line_comment,
  [402222] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25978), 1,
      anon_sym_EQ,
    STATE(19038), 2,
      sym_block_comment,
      sym_line_comment,
  [402236] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13058), 1,
      anon_sym_RPAREN,
    STATE(19039), 2,
      sym_block_comment,
      sym_line_comment,
  [402250] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25980), 1,
      anon_sym_end,
    STATE(19040), 2,
      sym_block_comment,
      sym_line_comment,
  [402264] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6340), 1,
      anon_sym_RPAREN,
    STATE(19041), 2,
      sym_block_comment,
      sym_line_comment,
  [402278] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25982), 1,
      anon_sym_end,
    STATE(19042), 2,
      sym_block_comment,
      sym_line_comment,
  [402292] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25984), 1,
      anon_sym_COLON2,
    STATE(19043), 2,
      sym_block_comment,
      sym_line_comment,
  [402306] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13006), 1,
      anon_sym_RPAREN,
    STATE(19044), 2,
      sym_block_comment,
      sym_line_comment,
  [402320] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25986), 1,
      anon_sym_end,
    STATE(19045), 2,
      sym_block_comment,
      sym_line_comment,
  [402334] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25988), 1,
      anon_sym_end,
    STATE(19046), 2,
      sym_block_comment,
      sym_line_comment,
  [402348] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25990), 1,
      anon_sym_RBRACK,
    STATE(19047), 2,
      sym_block_comment,
      sym_line_comment,
  [402362] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25992), 1,
      anon_sym_DASH_GT,
    STATE(19048), 2,
      sym_block_comment,
      sym_line_comment,
  [402376] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25994), 1,
      anon_sym_RPAREN,
    STATE(19049), 2,
      sym_block_comment,
      sym_line_comment,
  [402390] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25996), 1,
      anon_sym_COLON2,
    STATE(19050), 2,
      sym_block_comment,
      sym_line_comment,
  [402404] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(25998), 1,
      anon_sym_RBRACK,
    STATE(19051), 2,
      sym_block_comment,
      sym_line_comment,
  [402418] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20922), 1,
      anon_sym_end,
    STATE(19052), 2,
      sym_block_comment,
      sym_line_comment,
  [402432] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26000), 1,
      anon_sym_RBRACK,
    STATE(19053), 2,
      sym_block_comment,
      sym_line_comment,
  [402446] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26002), 1,
      anon_sym_COLON2,
    STATE(19054), 2,
      sym_block_comment,
      sym_line_comment,
  [402460] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26004), 1,
      anon_sym_end,
    STATE(19055), 2,
      sym_block_comment,
      sym_line_comment,
  [402474] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20860), 1,
      anon_sym_end,
    STATE(19056), 2,
      sym_block_comment,
      sym_line_comment,
  [402488] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13060), 1,
      anon_sym_RPAREN,
    STATE(19057), 2,
      sym_block_comment,
      sym_line_comment,
  [402502] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24185), 1,
      anon_sym_end,
    STATE(19058), 2,
      sym_block_comment,
      sym_line_comment,
  [402516] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19070), 1,
      anon_sym_RBRACE,
    STATE(19059), 2,
      sym_block_comment,
      sym_line_comment,
  [402530] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8002), 1,
      anon_sym_RPAREN,
    STATE(19060), 2,
      sym_block_comment,
      sym_line_comment,
  [402544] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26006), 1,
      anon_sym_end,
    STATE(19061), 2,
      sym_block_comment,
      sym_line_comment,
  [402558] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26008), 1,
      anon_sym_end,
    STATE(19062), 2,
      sym_block_comment,
      sym_line_comment,
  [402572] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26010), 1,
      anon_sym_end,
    STATE(19063), 2,
      sym_block_comment,
      sym_line_comment,
  [402586] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6846), 1,
      anon_sym_RPAREN,
    STATE(19064), 2,
      sym_block_comment,
      sym_line_comment,
  [402600] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26012), 1,
      anon_sym_end,
    STATE(19065), 2,
      sym_block_comment,
      sym_line_comment,
  [402614] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26014), 1,
      anon_sym_RBRACK,
    STATE(19066), 2,
      sym_block_comment,
      sym_line_comment,
  [402628] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9816), 1,
      anon_sym_DASH_GT,
    STATE(19067), 2,
      sym_block_comment,
      sym_line_comment,
  [402642] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26016), 1,
      anon_sym_EQ,
    STATE(19068), 2,
      sym_block_comment,
      sym_line_comment,
  [402656] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26018), 1,
      anon_sym_RPAREN,
    STATE(19069), 2,
      sym_block_comment,
      sym_line_comment,
  [402670] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19272), 1,
      anon_sym_RBRACE,
    STATE(19070), 2,
      sym_block_comment,
      sym_line_comment,
  [402684] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7270), 1,
      anon_sym_RPAREN,
    STATE(19071), 2,
      sym_block_comment,
      sym_line_comment,
  [402698] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10160), 1,
      anon_sym_DASH_GT,
    STATE(19072), 2,
      sym_block_comment,
      sym_line_comment,
  [402712] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6468), 1,
      anon_sym_RPAREN,
    STATE(19073), 2,
      sym_block_comment,
      sym_line_comment,
  [402726] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26020), 1,
      anon_sym_end,
    STATE(19074), 2,
      sym_block_comment,
      sym_line_comment,
  [402740] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8752), 1,
      anon_sym_RPAREN,
    STATE(19075), 2,
      sym_block_comment,
      sym_line_comment,
  [402754] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26022), 1,
      anon_sym_type,
    STATE(19076), 2,
      sym_block_comment,
      sym_line_comment,
  [402768] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26024), 1,
      anon_sym_RBRACK,
    STATE(19077), 2,
      sym_block_comment,
      sym_line_comment,
  [402782] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7398), 1,
      anon_sym_RPAREN,
    STATE(19078), 2,
      sym_block_comment,
      sym_line_comment,
  [402796] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26026), 1,
      anon_sym_COLON2,
    STATE(19079), 2,
      sym_block_comment,
      sym_line_comment,
  [402810] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8000), 1,
      anon_sym_RPAREN,
    STATE(19080), 2,
      sym_block_comment,
      sym_line_comment,
  [402824] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26028), 1,
      anon_sym_RBRACK,
    STATE(19081), 2,
      sym_block_comment,
      sym_line_comment,
  [402838] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26030), 1,
      anon_sym_end,
    STATE(19082), 2,
      sym_block_comment,
      sym_line_comment,
  [402852] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26032), 1,
      anon_sym_EQ,
    STATE(19083), 2,
      sym_block_comment,
      sym_line_comment,
  [402866] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26034), 1,
      anon_sym_RBRACK,
    STATE(19084), 2,
      sym_block_comment,
      sym_line_comment,
  [402880] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13006), 1,
      anon_sym_RPAREN,
    STATE(19085), 2,
      sym_block_comment,
      sym_line_comment,
  [402894] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19160), 1,
      anon_sym_RBRACE,
    STATE(19086), 2,
      sym_block_comment,
      sym_line_comment,
  [402908] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13094), 1,
      anon_sym_RPAREN,
    STATE(19087), 2,
      sym_block_comment,
      sym_line_comment,
  [402922] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8398), 1,
      anon_sym_RPAREN,
    STATE(19088), 2,
      sym_block_comment,
      sym_line_comment,
  [402936] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18838), 1,
      anon_sym_RBRACE,
    STATE(19089), 2,
      sym_block_comment,
      sym_line_comment,
  [402950] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13094), 1,
      anon_sym_RPAREN,
    STATE(19090), 2,
      sym_block_comment,
      sym_line_comment,
  [402964] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15484), 1,
      sym__immediate_paren,
    STATE(19091), 2,
      sym_block_comment,
      sym_line_comment,
  [402978] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26036), 1,
      anon_sym_RBRACK,
    STATE(19092), 2,
      sym_block_comment,
      sym_line_comment,
  [402992] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19000), 1,
      anon_sym_RBRACE,
    STATE(19093), 2,
      sym_block_comment,
      sym_line_comment,
  [403006] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26038), 1,
      anon_sym_RBRACK,
    STATE(19094), 2,
      sym_block_comment,
      sym_line_comment,
  [403020] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26040), 1,
      anon_sym_end,
    STATE(19095), 2,
      sym_block_comment,
      sym_line_comment,
  [403034] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18952), 1,
      anon_sym_RBRACE,
    STATE(19096), 2,
      sym_block_comment,
      sym_line_comment,
  [403048] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13060), 1,
      anon_sym_RPAREN,
    STATE(19097), 2,
      sym_block_comment,
      sym_line_comment,
  [403062] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8694), 1,
      anon_sym_RPAREN,
    STATE(19098), 2,
      sym_block_comment,
      sym_line_comment,
  [403076] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13038), 1,
      anon_sym_RPAREN,
    STATE(19099), 2,
      sym_block_comment,
      sym_line_comment,
  [403090] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8482), 1,
      anon_sym_RPAREN,
    STATE(19100), 2,
      sym_block_comment,
      sym_line_comment,
  [403104] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26042), 1,
      anon_sym_COLON2,
    STATE(19101), 2,
      sym_block_comment,
      sym_line_comment,
  [403118] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13096), 1,
      anon_sym_RPAREN,
    STATE(19102), 2,
      sym_block_comment,
      sym_line_comment,
  [403132] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26044), 1,
      anon_sym_type,
    STATE(19103), 2,
      sym_block_comment,
      sym_line_comment,
  [403146] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21137), 1,
      anon_sym_end,
    STATE(19104), 2,
      sym_block_comment,
      sym_line_comment,
  [403160] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13108), 1,
      anon_sym_RPAREN,
    STATE(19105), 2,
      sym_block_comment,
      sym_line_comment,
  [403174] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13038), 1,
      anon_sym_RPAREN,
    STATE(19106), 2,
      sym_block_comment,
      sym_line_comment,
  [403188] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26046), 1,
      anon_sym_end,
    STATE(19107), 2,
      sym_block_comment,
      sym_line_comment,
  [403202] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26048), 1,
      anon_sym_RBRACK,
    STATE(19108), 2,
      sym_block_comment,
      sym_line_comment,
  [403216] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26050), 1,
      anon_sym_end,
    STATE(19109), 2,
      sym_block_comment,
      sym_line_comment,
  [403230] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26052), 1,
      anon_sym_end,
    STATE(19110), 2,
      sym_block_comment,
      sym_line_comment,
  [403244] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26054), 1,
      anon_sym_RPAREN,
    STATE(19111), 2,
      sym_block_comment,
      sym_line_comment,
  [403258] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26056), 1,
      anon_sym_COLON2,
    STATE(19112), 2,
      sym_block_comment,
      sym_line_comment,
  [403272] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26058), 1,
      anon_sym_RPAREN,
    STATE(19113), 2,
      sym_block_comment,
      sym_line_comment,
  [403286] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26060), 1,
      anon_sym_end,
    STATE(19114), 2,
      sym_block_comment,
      sym_line_comment,
  [403300] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7124), 1,
      anon_sym_RPAREN,
    STATE(19115), 2,
      sym_block_comment,
      sym_line_comment,
  [403314] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26062), 1,
      anon_sym_RBRACK,
    STATE(19116), 2,
      sym_block_comment,
      sym_line_comment,
  [403328] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26064), 1,
      anon_sym_end,
    STATE(19117), 2,
      sym_block_comment,
      sym_line_comment,
  [403342] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26066), 1,
      anon_sym_end,
    STATE(19118), 2,
      sym_block_comment,
      sym_line_comment,
  [403356] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26068), 1,
      anon_sym_end,
    STATE(19119), 2,
      sym_block_comment,
      sym_line_comment,
  [403370] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26070), 1,
      anon_sym_end,
    STATE(19120), 2,
      sym_block_comment,
      sym_line_comment,
  [403384] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26072), 1,
      anon_sym_end,
    STATE(19121), 2,
      sym_block_comment,
      sym_line_comment,
  [403398] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13046), 1,
      anon_sym_RPAREN,
    STATE(19122), 2,
      sym_block_comment,
      sym_line_comment,
  [403412] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26074), 1,
      anon_sym_RBRACK,
    STATE(19123), 2,
      sym_block_comment,
      sym_line_comment,
  [403426] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20774), 1,
      anon_sym_end,
    STATE(19124), 2,
      sym_block_comment,
      sym_line_comment,
  [403440] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13024), 1,
      anon_sym_RPAREN,
    STATE(19125), 2,
      sym_block_comment,
      sym_line_comment,
  [403454] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7880), 1,
      anon_sym_RPAREN,
    STATE(19126), 2,
      sym_block_comment,
      sym_line_comment,
  [403468] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20133), 1,
      anon_sym_end,
    STATE(19127), 2,
      sym_block_comment,
      sym_line_comment,
  [403482] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8722), 1,
      anon_sym_RPAREN,
    STATE(19128), 2,
      sym_block_comment,
      sym_line_comment,
  [403496] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26076), 1,
      anon_sym_type,
    STATE(19129), 2,
      sym_block_comment,
      sym_line_comment,
  [403510] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19170), 1,
      anon_sym_RBRACE,
    STATE(19130), 2,
      sym_block_comment,
      sym_line_comment,
  [403524] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26078), 1,
      anon_sym_end,
    STATE(19131), 2,
      sym_block_comment,
      sym_line_comment,
  [403538] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13046), 1,
      anon_sym_RPAREN,
    STATE(19132), 2,
      sym_block_comment,
      sym_line_comment,
  [403552] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26080), 1,
      anon_sym_end,
    STATE(19133), 2,
      sym_block_comment,
      sym_line_comment,
  [403566] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26082), 1,
      anon_sym_end,
    STATE(19134), 2,
      sym_block_comment,
      sym_line_comment,
  [403580] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26084), 1,
      anon_sym_type,
    STATE(19135), 2,
      sym_block_comment,
      sym_line_comment,
  [403594] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26086), 1,
      anon_sym_RBRACK,
    STATE(19136), 2,
      sym_block_comment,
      sym_line_comment,
  [403608] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21174), 1,
      anon_sym_end,
    STATE(19137), 2,
      sym_block_comment,
      sym_line_comment,
  [403622] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26088), 1,
      anon_sym_COLON2,
    STATE(19138), 2,
      sym_block_comment,
      sym_line_comment,
  [403636] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7626), 1,
      anon_sym_RPAREN,
    STATE(19139), 2,
      sym_block_comment,
      sym_line_comment,
  [403650] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26090), 1,
      anon_sym_type,
    STATE(19140), 2,
      sym_block_comment,
      sym_line_comment,
  [403664] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26092), 1,
      anon_sym_end,
    STATE(19141), 2,
      sym_block_comment,
      sym_line_comment,
  [403678] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26094), 1,
      anon_sym_end,
    STATE(19142), 2,
      sym_block_comment,
      sym_line_comment,
  [403692] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26096), 1,
      anon_sym_type,
    STATE(19143), 2,
      sym_block_comment,
      sym_line_comment,
  [403706] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26098), 1,
      anon_sym_end,
    STATE(19144), 2,
      sym_block_comment,
      sym_line_comment,
  [403720] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7796), 1,
      anon_sym_RPAREN,
    STATE(19145), 2,
      sym_block_comment,
      sym_line_comment,
  [403734] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26100), 1,
      anon_sym_type,
    STATE(19146), 2,
      sym_block_comment,
      sym_line_comment,
  [403748] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26102), 1,
      anon_sym_end,
    STATE(19147), 2,
      sym_block_comment,
      sym_line_comment,
  [403762] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7734), 1,
      anon_sym_RPAREN,
    STATE(19148), 2,
      sym_block_comment,
      sym_line_comment,
  [403776] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26104), 1,
      anon_sym_type,
    STATE(19149), 2,
      sym_block_comment,
      sym_line_comment,
  [403790] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9804), 1,
      anon_sym_DASH_GT,
    STATE(19150), 2,
      sym_block_comment,
      sym_line_comment,
  [403804] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7644), 1,
      anon_sym_RPAREN,
    STATE(19151), 2,
      sym_block_comment,
      sym_line_comment,
  [403818] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26106), 1,
      anon_sym_RBRACK,
    STATE(19152), 2,
      sym_block_comment,
      sym_line_comment,
  [403832] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26108), 1,
      anon_sym_DASH_GT,
    STATE(19153), 2,
      sym_block_comment,
      sym_line_comment,
  [403846] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8260), 1,
      anon_sym_RPAREN,
    STATE(19154), 2,
      sym_block_comment,
      sym_line_comment,
  [403860] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26110), 1,
      anon_sym_end,
    STATE(19155), 2,
      sym_block_comment,
      sym_line_comment,
  [403874] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26112), 1,
      anon_sym_end,
    STATE(19156), 2,
      sym_block_comment,
      sym_line_comment,
  [403888] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8710), 1,
      anon_sym_RPAREN,
    STATE(19157), 2,
      sym_block_comment,
      sym_line_comment,
  [403902] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26114), 1,
      anon_sym_RBRACK,
    STATE(19158), 2,
      sym_block_comment,
      sym_line_comment,
  [403916] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10585), 1,
      sym__immediate_paren,
    STATE(19159), 2,
      sym_block_comment,
      sym_line_comment,
  [403930] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26116), 1,
      anon_sym_end,
    STATE(19160), 2,
      sym_block_comment,
      sym_line_comment,
  [403944] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7544), 1,
      anon_sym_RPAREN,
    STATE(19161), 2,
      sym_block_comment,
      sym_line_comment,
  [403958] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26118), 1,
      anon_sym_end,
    STATE(19162), 2,
      sym_block_comment,
      sym_line_comment,
  [403972] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26120), 1,
      anon_sym_EQ,
    STATE(19163), 2,
      sym_block_comment,
      sym_line_comment,
  [403986] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26122), 1,
      anon_sym_EQ,
    STATE(19164), 2,
      sym_block_comment,
      sym_line_comment,
  [404000] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6346), 1,
      anon_sym_RPAREN,
    STATE(19165), 2,
      sym_block_comment,
      sym_line_comment,
  [404014] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26124), 1,
      anon_sym_RBRACK,
    STATE(19166), 2,
      sym_block_comment,
      sym_line_comment,
  [404028] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26126), 1,
      anon_sym_end,
    STATE(19167), 2,
      sym_block_comment,
      sym_line_comment,
  [404042] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26128), 1,
      anon_sym_RBRACK,
    STATE(19168), 2,
      sym_block_comment,
      sym_line_comment,
  [404056] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26130), 1,
      anon_sym_end,
    STATE(19169), 2,
      sym_block_comment,
      sym_line_comment,
  [404070] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19390), 1,
      anon_sym_RBRACE,
    STATE(19170), 2,
      sym_block_comment,
      sym_line_comment,
  [404084] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7912), 1,
      anon_sym_RPAREN,
    STATE(19171), 2,
      sym_block_comment,
      sym_line_comment,
  [404098] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13062), 1,
      anon_sym_RPAREN,
    STATE(19172), 2,
      sym_block_comment,
      sym_line_comment,
  [404112] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20864), 1,
      anon_sym_end,
    STATE(19173), 2,
      sym_block_comment,
      sym_line_comment,
  [404126] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13062), 1,
      anon_sym_RPAREN,
    STATE(19174), 2,
      sym_block_comment,
      sym_line_comment,
  [404140] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13096), 1,
      anon_sym_RPAREN,
    STATE(19175), 2,
      sym_block_comment,
      sym_line_comment,
  [404154] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26132), 1,
      anon_sym_RBRACK,
    STATE(19176), 2,
      sym_block_comment,
      sym_line_comment,
  [404168] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20269), 1,
      anon_sym_end,
    STATE(19177), 2,
      sym_block_comment,
      sym_line_comment,
  [404182] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26134), 1,
      anon_sym_end,
    STATE(19178), 2,
      sym_block_comment,
      sym_line_comment,
  [404196] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26136), 1,
      sym__block_comment_rest,
    STATE(19179), 2,
      sym_block_comment,
      sym_line_comment,
  [404210] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26138), 1,
      anon_sym_end,
    STATE(19180), 2,
      sym_block_comment,
      sym_line_comment,
  [404224] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26140), 1,
      anon_sym_end,
    STATE(19181), 2,
      sym_block_comment,
      sym_line_comment,
  [404238] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24378), 1,
      anon_sym_end,
    STATE(19182), 2,
      sym_block_comment,
      sym_line_comment,
  [404252] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26142), 1,
      anon_sym_DASH_GT,
    STATE(19183), 2,
      sym_block_comment,
      sym_line_comment,
  [404266] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26144), 1,
      anon_sym_end,
    STATE(19184), 2,
      sym_block_comment,
      sym_line_comment,
  [404280] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26146), 1,
      anon_sym_DASH_GT,
    STATE(19185), 2,
      sym_block_comment,
      sym_line_comment,
  [404294] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13084), 1,
      anon_sym_RPAREN,
    STATE(19186), 2,
      sym_block_comment,
      sym_line_comment,
  [404308] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26148), 1,
      anon_sym_COLON2,
    STATE(19187), 2,
      sym_block_comment,
      sym_line_comment,
  [404322] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13020), 1,
      anon_sym_RPAREN,
    STATE(19188), 2,
      sym_block_comment,
      sym_line_comment,
  [404336] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26150), 1,
      anon_sym_RPAREN,
    STATE(19189), 2,
      sym_block_comment,
      sym_line_comment,
  [404350] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26152), 1,
      anon_sym_RPAREN,
    STATE(19190), 2,
      sym_block_comment,
      sym_line_comment,
  [404364] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26154), 1,
      anon_sym_RPAREN,
    STATE(19191), 2,
      sym_block_comment,
      sym_line_comment,
  [404378] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26156), 1,
      anon_sym_RBRACK,
    STATE(19192), 2,
      sym_block_comment,
      sym_line_comment,
  [404392] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26158), 1,
      anon_sym_COLON2,
    STATE(19193), 2,
      sym_block_comment,
      sym_line_comment,
  [404406] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26160), 1,
      anon_sym_DASH_GT,
    STATE(19194), 2,
      sym_block_comment,
      sym_line_comment,
  [404420] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13020), 1,
      anon_sym_RPAREN,
    STATE(19195), 2,
      sym_block_comment,
      sym_line_comment,
  [404434] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26162), 1,
      anon_sym_RPAREN,
    STATE(19196), 2,
      sym_block_comment,
      sym_line_comment,
  [404448] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26164), 1,
      anon_sym_RBRACK,
    STATE(19197), 2,
      sym_block_comment,
      sym_line_comment,
  [404462] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26166), 1,
      anon_sym_end,
    STATE(19198), 2,
      sym_block_comment,
      sym_line_comment,
  [404476] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7490), 1,
      anon_sym_RPAREN,
    STATE(19199), 2,
      sym_block_comment,
      sym_line_comment,
  [404490] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26168), 1,
      anon_sym_end,
    STATE(19200), 2,
      sym_block_comment,
      sym_line_comment,
  [404504] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26170), 1,
      anon_sym_DASH_GT,
    STATE(19201), 2,
      sym_block_comment,
      sym_line_comment,
  [404518] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21109), 1,
      anon_sym_end,
    STATE(19202), 2,
      sym_block_comment,
      sym_line_comment,
  [404532] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7252), 1,
      anon_sym_RPAREN,
    STATE(19203), 2,
      sym_block_comment,
      sym_line_comment,
  [404546] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26172), 1,
      anon_sym_COLON2,
    STATE(19204), 2,
      sym_block_comment,
      sym_line_comment,
  [404560] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26174), 1,
      anon_sym_end,
    STATE(19205), 2,
      sym_block_comment,
      sym_line_comment,
  [404574] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26176), 1,
      anon_sym_RBRACK,
    STATE(19206), 2,
      sym_block_comment,
      sym_line_comment,
  [404588] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26178), 1,
      anon_sym_RPAREN,
    STATE(19207), 2,
      sym_block_comment,
      sym_line_comment,
  [404602] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26180), 1,
      anon_sym_RPAREN,
    STATE(19208), 2,
      sym_block_comment,
      sym_line_comment,
  [404616] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26182), 1,
      anon_sym_COLON2,
    STATE(19209), 2,
      sym_block_comment,
      sym_line_comment,
  [404630] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26184), 1,
      anon_sym_end,
    STATE(19210), 2,
      sym_block_comment,
      sym_line_comment,
  [404644] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26186), 1,
      anon_sym_end,
    STATE(19211), 2,
      sym_block_comment,
      sym_line_comment,
  [404658] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26188), 1,
      anon_sym_end,
    STATE(19212), 2,
      sym_block_comment,
      sym_line_comment,
  [404672] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26190), 1,
      anon_sym_end,
    STATE(19213), 2,
      sym_block_comment,
      sym_line_comment,
  [404686] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26192), 1,
      anon_sym_end,
    STATE(19214), 2,
      sym_block_comment,
      sym_line_comment,
  [404700] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26194), 1,
      anon_sym_end,
    STATE(19215), 2,
      sym_block_comment,
      sym_line_comment,
  [404714] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26196), 1,
      anon_sym_RBRACK,
    STATE(19216), 2,
      sym_block_comment,
      sym_line_comment,
  [404728] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26198), 1,
      anon_sym_end,
    STATE(19217), 2,
      sym_block_comment,
      sym_line_comment,
  [404742] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26200), 1,
      anon_sym_end,
    STATE(19218), 2,
      sym_block_comment,
      sym_line_comment,
  [404756] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26202), 1,
      anon_sym_end,
    STATE(19219), 2,
      sym_block_comment,
      sym_line_comment,
  [404770] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26204), 1,
      anon_sym_end,
    STATE(19220), 2,
      sym_block_comment,
      sym_line_comment,
  [404784] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26206), 1,
      anon_sym_end,
    STATE(19221), 2,
      sym_block_comment,
      sym_line_comment,
  [404798] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26208), 1,
      anon_sym_end,
    STATE(19222), 2,
      sym_block_comment,
      sym_line_comment,
  [404812] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26210), 1,
      anon_sym_end,
    STATE(19223), 2,
      sym_block_comment,
      sym_line_comment,
  [404826] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26212), 1,
      anon_sym_EQ,
    STATE(19224), 2,
      sym_block_comment,
      sym_line_comment,
  [404840] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26214), 1,
      anon_sym_end,
    STATE(19225), 2,
      sym_block_comment,
      sym_line_comment,
  [404854] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10609), 1,
      sym__immediate_paren,
    STATE(19226), 2,
      sym_block_comment,
      sym_line_comment,
  [404868] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26216), 1,
      anon_sym_RBRACK,
    STATE(19227), 2,
      sym_block_comment,
      sym_line_comment,
  [404882] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20832), 1,
      anon_sym_end,
    STATE(19228), 2,
      sym_block_comment,
      sym_line_comment,
  [404896] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6608), 1,
      anon_sym_RPAREN,
    STATE(19229), 2,
      sym_block_comment,
      sym_line_comment,
  [404910] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26218), 1,
      anon_sym_end,
    STATE(19230), 2,
      sym_block_comment,
      sym_line_comment,
  [404924] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19080), 1,
      anon_sym_RBRACE,
    STATE(19231), 2,
      sym_block_comment,
      sym_line_comment,
  [404938] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20057), 1,
      anon_sym_end,
    STATE(19232), 2,
      sym_block_comment,
      sym_line_comment,
  [404952] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13014), 1,
      anon_sym_RPAREN,
    STATE(19233), 2,
      sym_block_comment,
      sym_line_comment,
  [404966] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21087), 1,
      anon_sym_end,
    STATE(19234), 2,
      sym_block_comment,
      sym_line_comment,
  [404980] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26220), 1,
      anon_sym_end,
    STATE(19235), 2,
      sym_block_comment,
      sym_line_comment,
  [404994] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8574), 1,
      anon_sym_RPAREN,
    STATE(19236), 2,
      sym_block_comment,
      sym_line_comment,
  [405008] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26222), 1,
      anon_sym_end,
    STATE(19237), 2,
      sym_block_comment,
      sym_line_comment,
  [405022] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13034), 1,
      anon_sym_RPAREN,
    STATE(19238), 2,
      sym_block_comment,
      sym_line_comment,
  [405036] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26224), 1,
      anon_sym_DASH_GT,
    STATE(19239), 2,
      sym_block_comment,
      sym_line_comment,
  [405050] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18866), 1,
      anon_sym_RBRACE,
    STATE(19240), 2,
      sym_block_comment,
      sym_line_comment,
  [405064] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8738), 1,
      anon_sym_RPAREN,
    STATE(19241), 2,
      sym_block_comment,
      sym_line_comment,
  [405078] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26226), 1,
      anon_sym_RBRACK,
    STATE(19242), 2,
      sym_block_comment,
      sym_line_comment,
  [405092] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26228), 1,
      anon_sym_end,
    STATE(19243), 2,
      sym_block_comment,
      sym_line_comment,
  [405106] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26230), 1,
      anon_sym_end,
    STATE(19244), 2,
      sym_block_comment,
      sym_line_comment,
  [405120] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8174), 1,
      anon_sym_RPAREN,
    STATE(19245), 2,
      sym_block_comment,
      sym_line_comment,
  [405134] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21079), 1,
      anon_sym_end,
    STATE(19246), 2,
      sym_block_comment,
      sym_line_comment,
  [405148] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8690), 1,
      anon_sym_RPAREN,
    STATE(19247), 2,
      sym_block_comment,
      sym_line_comment,
  [405162] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26232), 1,
      anon_sym_RBRACK,
    STATE(19248), 2,
      sym_block_comment,
      sym_line_comment,
  [405176] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26234), 1,
      anon_sym_end,
    STATE(19249), 2,
      sym_block_comment,
      sym_line_comment,
  [405190] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26236), 1,
      anon_sym_RPAREN,
    STATE(19250), 2,
      sym_block_comment,
      sym_line_comment,
  [405204] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7068), 1,
      anon_sym_RPAREN,
    STATE(19251), 2,
      sym_block_comment,
      sym_line_comment,
  [405218] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26238), 1,
      anon_sym_RBRACK,
    STATE(19252), 2,
      sym_block_comment,
      sym_line_comment,
  [405232] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13024), 1,
      anon_sym_RPAREN,
    STATE(19253), 2,
      sym_block_comment,
      sym_line_comment,
  [405246] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26240), 1,
      anon_sym_end,
    STATE(19254), 2,
      sym_block_comment,
      sym_line_comment,
  [405260] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7122), 1,
      anon_sym_RPAREN,
    STATE(19255), 2,
      sym_block_comment,
      sym_line_comment,
  [405274] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13080), 1,
      anon_sym_RPAREN,
    STATE(19256), 2,
      sym_block_comment,
      sym_line_comment,
  [405288] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26242), 1,
      anon_sym_RBRACK,
    STATE(19257), 2,
      sym_block_comment,
      sym_line_comment,
  [405302] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13080), 1,
      anon_sym_RPAREN,
    STATE(19258), 2,
      sym_block_comment,
      sym_line_comment,
  [405316] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26244), 1,
      anon_sym_end,
    STATE(19259), 2,
      sym_block_comment,
      sym_line_comment,
  [405330] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26246), 1,
      anon_sym_COLON2,
    STATE(19260), 2,
      sym_block_comment,
      sym_line_comment,
  [405344] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26248), 1,
      anon_sym_end,
    STATE(19261), 2,
      sym_block_comment,
      sym_line_comment,
  [405358] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26250), 1,
      anon_sym_RBRACK,
    STATE(19262), 2,
      sym_block_comment,
      sym_line_comment,
  [405372] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13054), 1,
      anon_sym_RPAREN,
    STATE(19263), 2,
      sym_block_comment,
      sym_line_comment,
  [405386] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26252), 1,
      anon_sym_COLON2,
    STATE(19264), 2,
      sym_block_comment,
      sym_line_comment,
  [405400] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26254), 1,
      anon_sym_end,
    STATE(19265), 2,
      sym_block_comment,
      sym_line_comment,
  [405414] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26256), 1,
      anon_sym_end,
    STATE(19266), 2,
      sym_block_comment,
      sym_line_comment,
  [405428] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26258), 1,
      anon_sym_end,
    STATE(19267), 2,
      sym_block_comment,
      sym_line_comment,
  [405442] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8316), 1,
      anon_sym_RPAREN,
    STATE(19268), 2,
      sym_block_comment,
      sym_line_comment,
  [405456] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26260), 1,
      anon_sym_end,
    STATE(19269), 2,
      sym_block_comment,
      sym_line_comment,
  [405470] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8614), 1,
      anon_sym_RPAREN,
    STATE(19270), 2,
      sym_block_comment,
      sym_line_comment,
  [405484] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26262), 1,
      anon_sym_RBRACK,
    STATE(19271), 2,
      sym_block_comment,
      sym_line_comment,
  [405498] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26264), 1,
      anon_sym_end,
    STATE(19272), 2,
      sym_block_comment,
      sym_line_comment,
  [405512] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13056), 1,
      anon_sym_RPAREN,
    STATE(19273), 2,
      sym_block_comment,
      sym_line_comment,
  [405526] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26266), 1,
      anon_sym_end,
    STATE(19274), 2,
      sym_block_comment,
      sym_line_comment,
  [405540] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26268), 1,
      anon_sym_RPAREN,
    STATE(19275), 2,
      sym_block_comment,
      sym_line_comment,
  [405554] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26270), 1,
      anon_sym_RBRACK,
    STATE(19276), 2,
      sym_block_comment,
      sym_line_comment,
  [405568] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8354), 1,
      anon_sym_RPAREN,
    STATE(19277), 2,
      sym_block_comment,
      sym_line_comment,
  [405582] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13056), 1,
      anon_sym_RPAREN,
    STATE(19278), 2,
      sym_block_comment,
      sym_line_comment,
  [405596] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26272), 1,
      anon_sym_COLON2,
    STATE(19279), 2,
      sym_block_comment,
      sym_line_comment,
  [405610] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21178), 1,
      anon_sym_end,
    STATE(19280), 2,
      sym_block_comment,
      sym_line_comment,
  [405624] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26274), 1,
      anon_sym_RPAREN,
    STATE(19281), 2,
      sym_block_comment,
      sym_line_comment,
  [405638] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26276), 1,
      anon_sym_end,
    STATE(19282), 2,
      sym_block_comment,
      sym_line_comment,
  [405652] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26278), 1,
      anon_sym_end,
    STATE(19283), 2,
      sym_block_comment,
      sym_line_comment,
  [405666] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26280), 1,
      anon_sym_end,
    STATE(19284), 2,
      sym_block_comment,
      sym_line_comment,
  [405680] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20852), 1,
      anon_sym_end,
    STATE(19285), 2,
      sym_block_comment,
      sym_line_comment,
  [405694] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26282), 1,
      anon_sym_end,
    STATE(19286), 2,
      sym_block_comment,
      sym_line_comment,
  [405708] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26284), 1,
      anon_sym_end,
    STATE(19287), 2,
      sym_block_comment,
      sym_line_comment,
  [405722] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26286), 1,
      anon_sym_end,
    STATE(19288), 2,
      sym_block_comment,
      sym_line_comment,
  [405736] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24368), 1,
      anon_sym_end,
    STATE(19289), 2,
      sym_block_comment,
      sym_line_comment,
  [405750] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26288), 1,
      anon_sym_end,
    STATE(19290), 2,
      sym_block_comment,
      sym_line_comment,
  [405764] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26290), 1,
      anon_sym_end,
    STATE(19291), 2,
      sym_block_comment,
      sym_line_comment,
  [405778] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10367), 1,
      sym__immediate_paren,
    STATE(19292), 2,
      sym_block_comment,
      sym_line_comment,
  [405792] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26292), 1,
      anon_sym_COLON2,
    STATE(19293), 2,
      sym_block_comment,
      sym_line_comment,
  [405806] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13034), 1,
      anon_sym_RPAREN,
    STATE(19294), 2,
      sym_block_comment,
      sym_line_comment,
  [405820] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26294), 1,
      anon_sym_RPAREN,
    STATE(19295), 2,
      sym_block_comment,
      sym_line_comment,
  [405834] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19048), 1,
      anon_sym_RBRACE,
    STATE(19296), 2,
      sym_block_comment,
      sym_line_comment,
  [405848] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26296), 1,
      anon_sym_end,
    STATE(19297), 2,
      sym_block_comment,
      sym_line_comment,
  [405862] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26298), 1,
      anon_sym_end,
    STATE(19298), 2,
      sym_block_comment,
      sym_line_comment,
  [405876] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26300), 1,
      anon_sym_RPAREN,
    STATE(19299), 2,
      sym_block_comment,
      sym_line_comment,
  [405890] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26302), 1,
      anon_sym_end,
    STATE(19300), 2,
      sym_block_comment,
      sym_line_comment,
  [405904] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26304), 1,
      anon_sym_end,
    STATE(19301), 2,
      sym_block_comment,
      sym_line_comment,
  [405918] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20359), 1,
      anon_sym_end,
    STATE(19302), 2,
      sym_block_comment,
      sym_line_comment,
  [405932] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26306), 1,
      anon_sym_end,
    STATE(19303), 2,
      sym_block_comment,
      sym_line_comment,
  [405946] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18756), 1,
      anon_sym_RBRACE,
    STATE(19304), 2,
      sym_block_comment,
      sym_line_comment,
  [405960] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10186), 1,
      anon_sym_DASH_GT,
    STATE(19305), 2,
      sym_block_comment,
      sym_line_comment,
  [405974] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26308), 1,
      anon_sym_end,
    STATE(19306), 2,
      sym_block_comment,
      sym_line_comment,
  [405988] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7342), 1,
      anon_sym_RPAREN,
    STATE(19307), 2,
      sym_block_comment,
      sym_line_comment,
  [406002] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26310), 1,
      anon_sym_COLON2,
    STATE(19308), 2,
      sym_block_comment,
      sym_line_comment,
  [406016] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26312), 1,
      anon_sym_DASH_GT,
    STATE(19309), 2,
      sym_block_comment,
      sym_line_comment,
  [406030] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26314), 1,
      anon_sym_end,
    STATE(19310), 2,
      sym_block_comment,
      sym_line_comment,
  [406044] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26316), 1,
      anon_sym_RBRACK,
    STATE(19311), 2,
      sym_block_comment,
      sym_line_comment,
  [406058] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26318), 1,
      anon_sym_end,
    STATE(19312), 2,
      sym_block_comment,
      sym_line_comment,
  [406072] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7536), 1,
      anon_sym_RPAREN,
    STATE(19313), 2,
      sym_block_comment,
      sym_line_comment,
  [406086] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26320), 1,
      anon_sym_end,
    STATE(19314), 2,
      sym_block_comment,
      sym_line_comment,
  [406100] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26322), 1,
      anon_sym_EQ,
    STATE(19315), 2,
      sym_block_comment,
      sym_line_comment,
  [406114] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13012), 1,
      anon_sym_RPAREN,
    STATE(19316), 2,
      sym_block_comment,
      sym_line_comment,
  [406128] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26324), 1,
      anon_sym_RPAREN,
    STATE(19317), 2,
      sym_block_comment,
      sym_line_comment,
  [406142] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8278), 1,
      anon_sym_RPAREN,
    STATE(19318), 2,
      sym_block_comment,
      sym_line_comment,
  [406156] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26326), 1,
      anon_sym_COLON2,
    STATE(19319), 2,
      sym_block_comment,
      sym_line_comment,
  [406170] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26328), 1,
      anon_sym_DASH_GT,
    STATE(19320), 2,
      sym_block_comment,
      sym_line_comment,
  [406184] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26330), 1,
      anon_sym_DASH_GT,
    STATE(19321), 2,
      sym_block_comment,
      sym_line_comment,
  [406198] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8712), 1,
      anon_sym_RPAREN,
    STATE(19322), 2,
      sym_block_comment,
      sym_line_comment,
  [406212] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26332), 1,
      anon_sym_RBRACK,
    STATE(19323), 2,
      sym_block_comment,
      sym_line_comment,
  [406226] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26334), 1,
      anon_sym_RPAREN,
    STATE(19324), 2,
      sym_block_comment,
      sym_line_comment,
  [406240] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26336), 1,
      anon_sym_EQ,
    STATE(19325), 2,
      sym_block_comment,
      sym_line_comment,
  [406254] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26338), 1,
      anon_sym_RBRACK,
    STATE(19326), 2,
      sym_block_comment,
      sym_line_comment,
  [406268] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7034), 1,
      anon_sym_RPAREN,
    STATE(19327), 2,
      sym_block_comment,
      sym_line_comment,
  [406282] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6542), 1,
      anon_sym_RPAREN,
    STATE(19328), 2,
      sym_block_comment,
      sym_line_comment,
  [406296] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26340), 1,
      anon_sym_end,
    STATE(19329), 2,
      sym_block_comment,
      sym_line_comment,
  [406310] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6400), 1,
      anon_sym_RPAREN,
    STATE(19330), 2,
      sym_block_comment,
      sym_line_comment,
  [406324] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15206), 1,
      anon_sym_DASH_GT,
    STATE(19331), 2,
      sym_block_comment,
      sym_line_comment,
  [406338] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7680), 1,
      anon_sym_RPAREN,
    STATE(19332), 2,
      sym_block_comment,
      sym_line_comment,
  [406352] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13050), 1,
      anon_sym_RPAREN,
    STATE(19333), 2,
      sym_block_comment,
      sym_line_comment,
  [406366] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26342), 1,
      anon_sym_RBRACK,
    STATE(19334), 2,
      sym_block_comment,
      sym_line_comment,
  [406380] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13070), 1,
      anon_sym_RPAREN,
    STATE(19335), 2,
      sym_block_comment,
      sym_line_comment,
  [406394] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26344), 1,
      anon_sym_RPAREN,
    STATE(19336), 2,
      sym_block_comment,
      sym_line_comment,
  [406408] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13032), 1,
      anon_sym_RPAREN,
    STATE(19337), 2,
      sym_block_comment,
      sym_line_comment,
  [406422] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13050), 1,
      anon_sym_RPAREN,
    STATE(19338), 2,
      sym_block_comment,
      sym_line_comment,
  [406436] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7554), 1,
      anon_sym_RPAREN,
    STATE(19339), 2,
      sym_block_comment,
      sym_line_comment,
  [406450] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9806), 1,
      anon_sym_DASH_GT,
    STATE(19340), 2,
      sym_block_comment,
      sym_line_comment,
  [406464] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16222), 1,
      sym__immediate_paren,
    STATE(19341), 2,
      sym_block_comment,
      sym_line_comment,
  [406478] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26346), 1,
      anon_sym_RBRACK,
    STATE(19342), 2,
      sym_block_comment,
      sym_line_comment,
  [406492] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24079), 1,
      anon_sym_end,
    STATE(19343), 2,
      sym_block_comment,
      sym_line_comment,
  [406506] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26348), 1,
      anon_sym_end,
    STATE(19344), 2,
      sym_block_comment,
      sym_line_comment,
  [406520] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26350), 1,
      anon_sym_end,
    STATE(19345), 2,
      sym_block_comment,
      sym_line_comment,
  [406534] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26352), 1,
      anon_sym_RPAREN,
    STATE(19346), 2,
      sym_block_comment,
      sym_line_comment,
  [406548] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26354), 1,
      anon_sym_EQ,
    STATE(19347), 2,
      sym_block_comment,
      sym_line_comment,
  [406562] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26356), 1,
      anon_sym_RPAREN,
    STATE(19348), 2,
      sym_block_comment,
      sym_line_comment,
  [406576] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19008), 1,
      anon_sym_RBRACE,
    STATE(19349), 2,
      sym_block_comment,
      sym_line_comment,
  [406590] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16238), 1,
      sym__immediate_paren,
    STATE(19350), 2,
      sym_block_comment,
      sym_line_comment,
  [406604] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26358), 1,
      anon_sym_end,
    STATE(19351), 2,
      sym_block_comment,
      sym_line_comment,
  [406618] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8468), 1,
      anon_sym_RPAREN,
    STATE(19352), 2,
      sym_block_comment,
      sym_line_comment,
  [406632] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8534), 1,
      anon_sym_RPAREN,
    STATE(19353), 2,
      sym_block_comment,
      sym_line_comment,
  [406646] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26360), 1,
      anon_sym_RBRACK,
    STATE(19354), 2,
      sym_block_comment,
      sym_line_comment,
  [406660] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26362), 1,
      anon_sym_end,
    STATE(19355), 2,
      sym_block_comment,
      sym_line_comment,
  [406674] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15462), 1,
      anon_sym_DASH_GT,
    STATE(19356), 2,
      sym_block_comment,
      sym_line_comment,
  [406688] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26364), 1,
      anon_sym_RBRACK,
    STATE(19357), 2,
      sym_block_comment,
      sym_line_comment,
  [406702] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7696), 1,
      anon_sym_RPAREN,
    STATE(19358), 2,
      sym_block_comment,
      sym_line_comment,
  [406716] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26366), 1,
      anon_sym_RBRACK,
    STATE(19359), 2,
      sym_block_comment,
      sym_line_comment,
  [406730] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13002), 1,
      anon_sym_RPAREN,
    STATE(19360), 2,
      sym_block_comment,
      sym_line_comment,
  [406744] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26368), 1,
      anon_sym_EQ,
    STATE(19361), 2,
      sym_block_comment,
      sym_line_comment,
  [406758] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26370), 1,
      anon_sym_RBRACK,
    STATE(19362), 2,
      sym_block_comment,
      sym_line_comment,
  [406772] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6438), 1,
      anon_sym_RPAREN,
    STATE(19363), 2,
      sym_block_comment,
      sym_line_comment,
  [406786] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7306), 1,
      anon_sym_RPAREN,
    STATE(19364), 2,
      sym_block_comment,
      sym_line_comment,
  [406800] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26372), 1,
      anon_sym_EQ,
    STATE(19365), 2,
      sym_block_comment,
      sym_line_comment,
  [406814] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26374), 1,
      anon_sym_RBRACK,
    STATE(19366), 2,
      sym_block_comment,
      sym_line_comment,
  [406828] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19440), 1,
      anon_sym_RBRACE,
    STATE(19367), 2,
      sym_block_comment,
      sym_line_comment,
  [406842] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18876), 1,
      anon_sym_RBRACE,
    STATE(19368), 2,
      sym_block_comment,
      sym_line_comment,
  [406856] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8070), 1,
      anon_sym_RPAREN,
    STATE(19369), 2,
      sym_block_comment,
      sym_line_comment,
  [406870] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13012), 1,
      anon_sym_RPAREN,
    STATE(19370), 2,
      sym_block_comment,
      sym_line_comment,
  [406884] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19462), 1,
      anon_sym_RBRACE,
    STATE(19371), 2,
      sym_block_comment,
      sym_line_comment,
  [406898] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18880), 1,
      anon_sym_RBRACE,
    STATE(19372), 2,
      sym_block_comment,
      sym_line_comment,
  [406912] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8728), 1,
      anon_sym_RPAREN,
    STATE(19373), 2,
      sym_block_comment,
      sym_line_comment,
  [406926] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13002), 1,
      anon_sym_RPAREN,
    STATE(19374), 2,
      sym_block_comment,
      sym_line_comment,
  [406940] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13032), 1,
      anon_sym_RPAREN,
    STATE(19375), 2,
      sym_block_comment,
      sym_line_comment,
  [406954] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26376), 1,
      anon_sym_end,
    STATE(19376), 2,
      sym_block_comment,
      sym_line_comment,
  [406968] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26378), 1,
      anon_sym_RBRACK,
    STATE(19377), 2,
      sym_block_comment,
      sym_line_comment,
  [406982] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(22620), 1,
      anon_sym_RPAREN,
    STATE(19378), 2,
      sym_block_comment,
      sym_line_comment,
  [406996] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26380), 1,
      anon_sym_end,
    STATE(19379), 2,
      sym_block_comment,
      sym_line_comment,
  [407010] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26382), 1,
      anon_sym_end,
    STATE(19380), 2,
      sym_block_comment,
      sym_line_comment,
  [407024] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26384), 1,
      anon_sym_RBRACK,
    STATE(19381), 2,
      sym_block_comment,
      sym_line_comment,
  [407038] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26386), 1,
      anon_sym_end,
    STATE(19382), 2,
      sym_block_comment,
      sym_line_comment,
  [407052] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26388), 1,
      anon_sym_COLON2,
    STATE(19383), 2,
      sym_block_comment,
      sym_line_comment,
  [407066] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26390), 1,
      anon_sym_DASH_GT,
    STATE(19384), 2,
      sym_block_comment,
      sym_line_comment,
  [407080] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26392), 1,
      anon_sym_RBRACK,
    STATE(19385), 2,
      sym_block_comment,
      sym_line_comment,
  [407094] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8214), 1,
      anon_sym_RPAREN,
    STATE(19386), 2,
      sym_block_comment,
      sym_line_comment,
  [407108] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13068), 1,
      anon_sym_RPAREN,
    STATE(19387), 2,
      sym_block_comment,
      sym_line_comment,
  [407122] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20181), 1,
      anon_sym_end,
    STATE(19388), 2,
      sym_block_comment,
      sym_line_comment,
  [407136] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13068), 1,
      anon_sym_RPAREN,
    STATE(19389), 2,
      sym_block_comment,
      sym_line_comment,
  [407150] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26394), 1,
      anon_sym_DASH_GT,
    STATE(19390), 2,
      sym_block_comment,
      sym_line_comment,
  [407164] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26396), 1,
      anon_sym_end,
    STATE(19391), 2,
      sym_block_comment,
      sym_line_comment,
  [407178] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26398), 1,
      anon_sym_RBRACK,
    STATE(19392), 2,
      sym_block_comment,
      sym_line_comment,
  [407192] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19456), 1,
      anon_sym_RBRACE,
    STATE(19393), 2,
      sym_block_comment,
      sym_line_comment,
  [407206] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6556), 1,
      anon_sym_RPAREN,
    STATE(19394), 2,
      sym_block_comment,
      sym_line_comment,
  [407220] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8352), 1,
      anon_sym_RPAREN,
    STATE(19395), 2,
      sym_block_comment,
      sym_line_comment,
  [407234] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26400), 1,
      anon_sym_end,
    STATE(19396), 2,
      sym_block_comment,
      sym_line_comment,
  [407248] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26402), 1,
      anon_sym_end,
    STATE(19397), 2,
      sym_block_comment,
      sym_line_comment,
  [407262] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26404), 1,
      anon_sym_end,
    STATE(19398), 2,
      sym_block_comment,
      sym_line_comment,
  [407276] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26406), 1,
      anon_sym_EQ,
    STATE(19399), 2,
      sym_block_comment,
      sym_line_comment,
  [407290] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26408), 1,
      anon_sym_COLON2,
    STATE(19400), 2,
      sym_block_comment,
      sym_line_comment,
  [407304] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10599), 1,
      sym__immediate_paren,
    STATE(19401), 2,
      sym_block_comment,
      sym_line_comment,
  [407318] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26410), 1,
      anon_sym_RBRACK,
    STATE(19402), 2,
      sym_block_comment,
      sym_line_comment,
  [407332] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7610), 1,
      anon_sym_RPAREN,
    STATE(19403), 2,
      sym_block_comment,
      sym_line_comment,
  [407346] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26412), 1,
      anon_sym_EQ,
    STATE(19404), 2,
      sym_block_comment,
      sym_line_comment,
  [407360] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6388), 1,
      anon_sym_RPAREN,
    STATE(19405), 2,
      sym_block_comment,
      sym_line_comment,
  [407374] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26414), 1,
      anon_sym_end,
    STATE(19406), 2,
      sym_block_comment,
      sym_line_comment,
  [407388] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13088), 1,
      anon_sym_RPAREN,
    STATE(19407), 2,
      sym_block_comment,
      sym_line_comment,
  [407402] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26416), 1,
      anon_sym_RBRACK,
    STATE(19408), 2,
      sym_block_comment,
      sym_line_comment,
  [407416] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26418), 1,
      anon_sym_COLON2,
    STATE(19409), 2,
      sym_block_comment,
      sym_line_comment,
  [407430] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26420), 1,
      anon_sym_RBRACK,
    STATE(19410), 2,
      sym_block_comment,
      sym_line_comment,
  [407444] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21150), 1,
      anon_sym_end,
    STATE(19411), 2,
      sym_block_comment,
      sym_line_comment,
  [407458] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13086), 1,
      anon_sym_RPAREN,
    STATE(19412), 2,
      sym_block_comment,
      sym_line_comment,
  [407472] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26422), 1,
      anon_sym_COLON2,
    STATE(19413), 2,
      sym_block_comment,
      sym_line_comment,
  [407486] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26424), 1,
      anon_sym_end,
    STATE(19414), 2,
      sym_block_comment,
      sym_line_comment,
  [407500] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26426), 1,
      anon_sym_RPAREN,
    STATE(19415), 2,
      sym_block_comment,
      sym_line_comment,
  [407514] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13086), 1,
      anon_sym_RPAREN,
    STATE(19416), 2,
      sym_block_comment,
      sym_line_comment,
  [407528] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8150), 1,
      anon_sym_RPAREN,
    STATE(19417), 2,
      sym_block_comment,
      sym_line_comment,
  [407542] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26428), 1,
      anon_sym_EQ,
    STATE(19418), 2,
      sym_block_comment,
      sym_line_comment,
  [407556] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26430), 1,
      anon_sym_RBRACK,
    STATE(19419), 2,
      sym_block_comment,
      sym_line_comment,
  [407570] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26432), 1,
      anon_sym_RBRACK,
    STATE(19420), 2,
      sym_block_comment,
      sym_line_comment,
  [407584] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6624), 1,
      anon_sym_RPAREN,
    STATE(19421), 2,
      sym_block_comment,
      sym_line_comment,
  [407598] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26434), 1,
      anon_sym_end,
    STATE(19422), 2,
      sym_block_comment,
      sym_line_comment,
  [407612] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26436), 1,
      anon_sym_RBRACK,
    STATE(19423), 2,
      sym_block_comment,
      sym_line_comment,
  [407626] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26438), 1,
      anon_sym_RPAREN,
    STATE(19424), 2,
      sym_block_comment,
      sym_line_comment,
  [407640] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(16758), 1,
      sym__immediate_paren,
    STATE(19425), 2,
      sym_block_comment,
      sym_line_comment,
  [407654] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26440), 1,
      anon_sym_RBRACK,
    STATE(19426), 2,
      sym_block_comment,
      sym_line_comment,
  [407668] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26442), 1,
      anon_sym_type,
    STATE(19427), 2,
      sym_block_comment,
      sym_line_comment,
  [407682] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6834), 1,
      anon_sym_RPAREN,
    STATE(19428), 2,
      sym_block_comment,
      sym_line_comment,
  [407696] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26444), 1,
      anon_sym_RBRACK,
    STATE(19429), 2,
      sym_block_comment,
      sym_line_comment,
  [407710] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19424), 1,
      anon_sym_RBRACE,
    STATE(19430), 2,
      sym_block_comment,
      sym_line_comment,
  [407724] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26446), 1,
      anon_sym_end,
    STATE(19431), 2,
      sym_block_comment,
      sym_line_comment,
  [407738] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8742), 1,
      anon_sym_RPAREN,
    STATE(19432), 2,
      sym_block_comment,
      sym_line_comment,
  [407752] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26448), 1,
      anon_sym_end,
    STATE(19433), 2,
      sym_block_comment,
      sym_line_comment,
  [407766] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8318), 1,
      anon_sym_RPAREN,
    STATE(19434), 2,
      sym_block_comment,
      sym_line_comment,
  [407780] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26450), 1,
      anon_sym_COLON2,
    STATE(19435), 2,
      sym_block_comment,
      sym_line_comment,
  [407794] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19230), 1,
      anon_sym_RBRACE,
    STATE(19436), 2,
      sym_block_comment,
      sym_line_comment,
  [407808] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6396), 1,
      anon_sym_RPAREN,
    STATE(19437), 2,
      sym_block_comment,
      sym_line_comment,
  [407822] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8796), 1,
      anon_sym_RPAREN,
    STATE(19438), 2,
      sym_block_comment,
      sym_line_comment,
  [407836] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26452), 1,
      anon_sym_RBRACK,
    STATE(19439), 2,
      sym_block_comment,
      sym_line_comment,
  [407850] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(9812), 1,
      anon_sym_DASH_GT,
    STATE(19440), 2,
      sym_block_comment,
      sym_line_comment,
  [407864] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8714), 1,
      anon_sym_RPAREN,
    STATE(19441), 2,
      sym_block_comment,
      sym_line_comment,
  [407878] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26454), 1,
      anon_sym_end,
    STATE(19442), 2,
      sym_block_comment,
      sym_line_comment,
  [407892] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26456), 1,
      anon_sym_RBRACK,
    STATE(19443), 2,
      sym_block_comment,
      sym_line_comment,
  [407906] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13018), 1,
      anon_sym_RPAREN,
    STATE(19444), 2,
      sym_block_comment,
      sym_line_comment,
  [407920] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26458), 1,
      anon_sym_RBRACK,
    STATE(19445), 2,
      sym_block_comment,
      sym_line_comment,
  [407934] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26460), 1,
      anon_sym_end,
    STATE(19446), 2,
      sym_block_comment,
      sym_line_comment,
  [407948] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26462), 1,
      anon_sym_end,
    STATE(19447), 2,
      sym_block_comment,
      sym_line_comment,
  [407962] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12990), 1,
      anon_sym_RPAREN,
    STATE(19448), 2,
      sym_block_comment,
      sym_line_comment,
  [407976] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26464), 1,
      anon_sym_RBRACK,
    STATE(19449), 2,
      sym_block_comment,
      sym_line_comment,
  [407990] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(12990), 1,
      anon_sym_RPAREN,
    STATE(19450), 2,
      sym_block_comment,
      sym_line_comment,
  [408004] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10501), 1,
      sym__immediate_paren,
    STATE(19451), 2,
      sym_block_comment,
      sym_line_comment,
  [408018] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26466), 1,
      anon_sym_end,
    STATE(19452), 2,
      sym_block_comment,
      sym_line_comment,
  [408032] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8440), 1,
      anon_sym_RPAREN,
    STATE(19453), 2,
      sym_block_comment,
      sym_line_comment,
  [408046] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26468), 1,
      anon_sym_end,
    STATE(19454), 2,
      sym_block_comment,
      sym_line_comment,
  [408060] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20261), 1,
      anon_sym_end,
    STATE(19455), 2,
      sym_block_comment,
      sym_line_comment,
  [408074] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26470), 1,
      anon_sym_RPAREN,
    STATE(19456), 2,
      sym_block_comment,
      sym_line_comment,
  [408088] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26472), 1,
      anon_sym_RBRACK,
    STATE(19457), 2,
      sym_block_comment,
      sym_line_comment,
  [408102] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26474), 1,
      anon_sym_RBRACK,
    STATE(19458), 2,
      sym_block_comment,
      sym_line_comment,
  [408116] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8372), 1,
      anon_sym_RPAREN,
    STATE(19459), 2,
      sym_block_comment,
      sym_line_comment,
  [408130] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26476), 1,
      anon_sym_EQ,
    STATE(19460), 2,
      sym_block_comment,
      sym_line_comment,
  [408144] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26478), 1,
      anon_sym_EQ,
    STATE(19461), 2,
      sym_block_comment,
      sym_line_comment,
  [408158] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26480), 1,
      anon_sym_end,
    STATE(19462), 2,
      sym_block_comment,
      sym_line_comment,
  [408172] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13104), 1,
      anon_sym_RPAREN,
    STATE(19463), 2,
      sym_block_comment,
      sym_line_comment,
  [408186] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26482), 1,
      anon_sym_end,
    STATE(19464), 2,
      sym_block_comment,
      sym_line_comment,
  [408200] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6404), 1,
      anon_sym_RPAREN,
    STATE(19465), 2,
      sym_block_comment,
      sym_line_comment,
  [408214] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15436), 1,
      anon_sym_DASH_GT,
    STATE(19466), 2,
      sym_block_comment,
      sym_line_comment,
  [408228] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26484), 1,
      anon_sym_RPAREN,
    STATE(19467), 2,
      sym_block_comment,
      sym_line_comment,
  [408242] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26486), 1,
      anon_sym_end,
    STATE(19468), 2,
      sym_block_comment,
      sym_line_comment,
  [408256] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26488), 1,
      anon_sym_RPAREN,
    STATE(19469), 2,
      sym_block_comment,
      sym_line_comment,
  [408270] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26490), 1,
      anon_sym_end,
    STATE(19470), 2,
      sym_block_comment,
      sym_line_comment,
  [408284] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8018), 1,
      anon_sym_RPAREN,
    STATE(19471), 2,
      sym_block_comment,
      sym_line_comment,
  [408298] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26492), 1,
      anon_sym_EQ,
    STATE(19472), 2,
      sym_block_comment,
      sym_line_comment,
  [408312] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26494), 1,
      anon_sym_RBRACK,
    STATE(19473), 2,
      sym_block_comment,
      sym_line_comment,
  [408326] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24490), 1,
      anon_sym_end,
    STATE(19474), 2,
      sym_block_comment,
      sym_line_comment,
  [408340] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7244), 1,
      anon_sym_RPAREN,
    STATE(19475), 2,
      sym_block_comment,
      sym_line_comment,
  [408354] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26496), 1,
      anon_sym_RPAREN,
    STATE(19476), 2,
      sym_block_comment,
      sym_line_comment,
  [408368] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18888), 1,
      anon_sym_RBRACE,
    STATE(19477), 2,
      sym_block_comment,
      sym_line_comment,
  [408382] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10515), 1,
      sym__immediate_paren,
    STATE(19478), 2,
      sym_block_comment,
      sym_line_comment,
  [408396] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26498), 1,
      anon_sym_end,
    STATE(19479), 2,
      sym_block_comment,
      sym_line_comment,
  [408410] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13088), 1,
      anon_sym_RPAREN,
    STATE(19480), 2,
      sym_block_comment,
      sym_line_comment,
  [408424] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26500), 1,
      anon_sym_end,
    STATE(19481), 2,
      sym_block_comment,
      sym_line_comment,
  [408438] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8634), 1,
      anon_sym_RPAREN,
    STATE(19482), 2,
      sym_block_comment,
      sym_line_comment,
  [408452] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26502), 1,
      anon_sym_end,
    STATE(19483), 2,
      sym_block_comment,
      sym_line_comment,
  [408466] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26504), 1,
      anon_sym_end,
    STATE(19484), 2,
      sym_block_comment,
      sym_line_comment,
  [408480] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26506), 1,
      anon_sym_end,
    STATE(19485), 2,
      sym_block_comment,
      sym_line_comment,
  [408494] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26508), 1,
      anon_sym_end,
    STATE(19486), 2,
      sym_block_comment,
      sym_line_comment,
  [408508] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26510), 1,
      anon_sym_end,
    STATE(19487), 2,
      sym_block_comment,
      sym_line_comment,
  [408522] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26512), 1,
      anon_sym_end,
    STATE(19488), 2,
      sym_block_comment,
      sym_line_comment,
  [408536] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26514), 1,
      anon_sym_end,
    STATE(19489), 2,
      sym_block_comment,
      sym_line_comment,
  [408550] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8594), 1,
      anon_sym_RPAREN,
    STATE(19490), 2,
      sym_block_comment,
      sym_line_comment,
  [408564] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26516), 1,
      ts_builtin_sym_end,
    STATE(19491), 2,
      sym_block_comment,
      sym_line_comment,
  [408578] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26518), 1,
      anon_sym_RBRACK,
    STATE(19492), 2,
      sym_block_comment,
      sym_line_comment,
  [408592] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26520), 1,
      anon_sym_end,
    STATE(19493), 2,
      sym_block_comment,
      sym_line_comment,
  [408606] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26522), 1,
      anon_sym_end,
    STATE(19494), 2,
      sym_block_comment,
      sym_line_comment,
  [408620] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21131), 1,
      anon_sym_end,
    STATE(19495), 2,
      sym_block_comment,
      sym_line_comment,
  [408634] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13104), 1,
      anon_sym_RPAREN,
    STATE(19496), 2,
      sym_block_comment,
      sym_line_comment,
  [408648] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26524), 1,
      anon_sym_COLON2,
    STATE(19497), 2,
      sym_block_comment,
      sym_line_comment,
  [408662] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26526), 1,
      anon_sym_RPAREN,
    STATE(19498), 2,
      sym_block_comment,
      sym_line_comment,
  [408676] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26528), 1,
      anon_sym_end,
    STATE(19499), 2,
      sym_block_comment,
      sym_line_comment,
  [408690] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18916), 1,
      anon_sym_RBRACE,
    STATE(19500), 2,
      sym_block_comment,
      sym_line_comment,
  [408704] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8740), 1,
      anon_sym_RPAREN,
    STATE(19501), 2,
      sym_block_comment,
      sym_line_comment,
  [408718] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26530), 1,
      anon_sym_RBRACK,
    STATE(19502), 2,
      sym_block_comment,
      sym_line_comment,
  [408732] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26532), 1,
      anon_sym_RPAREN,
    STATE(19503), 2,
      sym_block_comment,
      sym_line_comment,
  [408746] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26534), 1,
      anon_sym_RBRACK,
    STATE(19504), 2,
      sym_block_comment,
      sym_line_comment,
  [408760] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15920), 1,
      sym__immediate_paren,
    STATE(19505), 2,
      sym_block_comment,
      sym_line_comment,
  [408774] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15164), 1,
      anon_sym_DASH_GT,
    STATE(19506), 2,
      sym_block_comment,
      sym_line_comment,
  [408788] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26536), 1,
      anon_sym_COLON2,
    STATE(19507), 2,
      sym_block_comment,
      sym_line_comment,
  [408802] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(24802), 1,
      anon_sym_EQ,
    STATE(19508), 2,
      sym_block_comment,
      sym_line_comment,
  [408816] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26538), 1,
      anon_sym_RPAREN,
    STATE(19509), 2,
      sym_block_comment,
      sym_line_comment,
  [408830] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13074), 1,
      anon_sym_RPAREN,
    STATE(19510), 2,
      sym_block_comment,
      sym_line_comment,
  [408844] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26540), 1,
      anon_sym_end,
    STATE(19511), 2,
      sym_block_comment,
      sym_line_comment,
  [408858] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26542), 1,
      anon_sym_DASH_GT,
    STATE(19512), 2,
      sym_block_comment,
      sym_line_comment,
  [408872] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26544), 1,
      anon_sym_COLON2,
    STATE(19513), 2,
      sym_block_comment,
      sym_line_comment,
  [408886] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26546), 1,
      anon_sym_RBRACK,
    STATE(19514), 2,
      sym_block_comment,
      sym_line_comment,
  [408900] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26548), 1,
      anon_sym_end,
    STATE(19515), 2,
      sym_block_comment,
      sym_line_comment,
  [408914] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13074), 1,
      anon_sym_RPAREN,
    STATE(19516), 2,
      sym_block_comment,
      sym_line_comment,
  [408928] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13018), 1,
      anon_sym_RPAREN,
    STATE(19517), 2,
      sym_block_comment,
      sym_line_comment,
  [408942] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26550), 1,
      anon_sym_end,
    STATE(19518), 2,
      sym_block_comment,
      sym_line_comment,
  [408956] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8720), 1,
      anon_sym_RPAREN,
    STATE(19519), 2,
      sym_block_comment,
      sym_line_comment,
  [408970] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10545), 1,
      sym__immediate_paren,
    STATE(19520), 2,
      sym_block_comment,
      sym_line_comment,
  [408984] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7982), 1,
      anon_sym_RPAREN,
    STATE(19521), 2,
      sym_block_comment,
      sym_line_comment,
  [408998] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18924), 1,
      anon_sym_RBRACE,
    STATE(19522), 2,
      sym_block_comment,
      sym_line_comment,
  [409012] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7018), 1,
      anon_sym_RPAREN,
    STATE(19523), 2,
      sym_block_comment,
      sym_line_comment,
  [409026] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26552), 1,
      anon_sym_RBRACK,
    STATE(19524), 2,
      sym_block_comment,
      sym_line_comment,
  [409040] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15590), 1,
      anon_sym_DASH_GT,
    STATE(19525), 2,
      sym_block_comment,
      sym_line_comment,
  [409054] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26554), 1,
      anon_sym_RBRACK,
    STATE(19526), 2,
      sym_block_comment,
      sym_line_comment,
  [409068] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8716), 1,
      anon_sym_RPAREN,
    STATE(19527), 2,
      sym_block_comment,
      sym_line_comment,
  [409082] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26556), 1,
      anon_sym_RBRACK,
    STATE(19528), 2,
      sym_block_comment,
      sym_line_comment,
  [409096] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26558), 1,
      anon_sym_end,
    STATE(19529), 2,
      sym_block_comment,
      sym_line_comment,
  [409110] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7088), 1,
      anon_sym_RPAREN,
    STATE(19530), 2,
      sym_block_comment,
      sym_line_comment,
  [409124] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26560), 1,
      anon_sym_EQ,
    STATE(19531), 2,
      sym_block_comment,
      sym_line_comment,
  [409138] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6408), 1,
      anon_sym_RPAREN,
    STATE(19532), 2,
      sym_block_comment,
      sym_line_comment,
  [409152] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26562), 1,
      anon_sym_RBRACK,
    STATE(19533), 2,
      sym_block_comment,
      sym_line_comment,
  [409166] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26564), 1,
      anon_sym_end,
    STATE(19534), 2,
      sym_block_comment,
      sym_line_comment,
  [409180] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26566), 1,
      anon_sym_end,
    STATE(19535), 2,
      sym_block_comment,
      sym_line_comment,
  [409194] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26568), 1,
      anon_sym_end,
    STATE(19536), 2,
      sym_block_comment,
      sym_line_comment,
  [409208] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19450), 1,
      anon_sym_RBRACE,
    STATE(19537), 2,
      sym_block_comment,
      sym_line_comment,
  [409222] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26570), 1,
      anon_sym_RPAREN,
    STATE(19538), 2,
      sym_block_comment,
      sym_line_comment,
  [409236] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13036), 1,
      anon_sym_RPAREN,
    STATE(19539), 2,
      sym_block_comment,
      sym_line_comment,
  [409250] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26572), 1,
      anon_sym_RBRACK,
    STATE(19540), 2,
      sym_block_comment,
      sym_line_comment,
  [409264] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13028), 1,
      anon_sym_RPAREN,
    STATE(19541), 2,
      sym_block_comment,
      sym_line_comment,
  [409278] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13036), 1,
      anon_sym_RPAREN,
    STATE(19542), 2,
      sym_block_comment,
      sym_line_comment,
  [409292] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26574), 1,
      anon_sym_RBRACK,
    STATE(19543), 2,
      sym_block_comment,
      sym_line_comment,
  [409306] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10619), 1,
      sym__immediate_paren,
    STATE(19544), 2,
      sym_block_comment,
      sym_line_comment,
  [409320] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26576), 1,
      anon_sym_RBRACK,
    STATE(19545), 2,
      sym_block_comment,
      sym_line_comment,
  [409334] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26578), 1,
      anon_sym_end,
    STATE(19546), 2,
      sym_block_comment,
      sym_line_comment,
  [409348] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26580), 1,
      anon_sym_end,
    STATE(19547), 2,
      sym_block_comment,
      sym_line_comment,
  [409362] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8744), 1,
      anon_sym_RPAREN,
    STATE(19548), 2,
      sym_block_comment,
      sym_line_comment,
  [409376] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26582), 1,
      anon_sym_RBRACK,
    STATE(19549), 2,
      sym_block_comment,
      sym_line_comment,
  [409390] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26584), 1,
      anon_sym_RBRACK,
    STATE(19550), 2,
      sym_block_comment,
      sym_line_comment,
  [409404] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26586), 1,
      anon_sym_end,
    STATE(19551), 2,
      sym_block_comment,
      sym_line_comment,
  [409418] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18904), 1,
      anon_sym_RBRACE,
    STATE(19552), 2,
      sym_block_comment,
      sym_line_comment,
  [409432] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26588), 1,
      anon_sym_RPAREN,
    STATE(19553), 2,
      sym_block_comment,
      sym_line_comment,
  [409446] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13098), 1,
      anon_sym_RPAREN,
    STATE(19554), 2,
      sym_block_comment,
      sym_line_comment,
  [409460] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26590), 1,
      anon_sym_EQ,
    STATE(19555), 2,
      sym_block_comment,
      sym_line_comment,
  [409474] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26592), 1,
      anon_sym_DASH_GT,
    STATE(19556), 2,
      sym_block_comment,
      sym_line_comment,
  [409488] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26594), 1,
      anon_sym_RBRACK,
    STATE(19557), 2,
      sym_block_comment,
      sym_line_comment,
  [409502] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26596), 1,
      anon_sym_EQ,
    STATE(19558), 2,
      sym_block_comment,
      sym_line_comment,
  [409516] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(6520), 1,
      anon_sym_RPAREN,
    STATE(19559), 2,
      sym_block_comment,
      sym_line_comment,
  [409530] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26598), 1,
      anon_sym_RPAREN,
    STATE(19560), 2,
      sym_block_comment,
      sym_line_comment,
  [409544] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15546), 1,
      anon_sym_DASH_GT,
    STATE(19561), 2,
      sym_block_comment,
      sym_line_comment,
  [409558] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26600), 1,
      anon_sym_RBRACK,
    STATE(19562), 2,
      sym_block_comment,
      sym_line_comment,
  [409572] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7286), 1,
      anon_sym_RPAREN,
    STATE(19563), 2,
      sym_block_comment,
      sym_line_comment,
  [409586] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8434), 1,
      anon_sym_RPAREN,
    STATE(19564), 2,
      sym_block_comment,
      sym_line_comment,
  [409600] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26602), 1,
      anon_sym_end,
    STATE(19565), 2,
      sym_block_comment,
      sym_line_comment,
  [409614] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26604), 1,
      anon_sym_COLON2,
    STATE(19566), 2,
      sym_block_comment,
      sym_line_comment,
  [409628] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26606), 1,
      anon_sym_RBRACK,
    STATE(19567), 2,
      sym_block_comment,
      sym_line_comment,
  [409642] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26608), 1,
      anon_sym_EQ,
    STATE(19568), 2,
      sym_block_comment,
      sym_line_comment,
  [409656] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26610), 1,
      anon_sym_RBRACK,
    STATE(19569), 2,
      sym_block_comment,
      sym_line_comment,
  [409670] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26612), 1,
      anon_sym_RPAREN,
    STATE(19570), 2,
      sym_block_comment,
      sym_line_comment,
  [409684] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10555), 1,
      sym__immediate_paren,
    STATE(19571), 2,
      sym_block_comment,
      sym_line_comment,
  [409698] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26614), 1,
      anon_sym_end,
    STATE(19572), 2,
      sym_block_comment,
      sym_line_comment,
  [409712] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26616), 1,
      anon_sym_RPAREN,
    STATE(19573), 2,
      sym_block_comment,
      sym_line_comment,
  [409726] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26618), 1,
      anon_sym_end,
    STATE(19574), 2,
      sym_block_comment,
      sym_line_comment,
  [409740] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18908), 1,
      anon_sym_RBRACE,
    STATE(19575), 2,
      sym_block_comment,
      sym_line_comment,
  [409754] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21061), 1,
      anon_sym_end,
    STATE(19576), 2,
      sym_block_comment,
      sym_line_comment,
  [409768] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(15190), 1,
      anon_sym_DASH_GT,
    STATE(19577), 2,
      sym_block_comment,
      sym_line_comment,
  [409782] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19222), 1,
      anon_sym_RBRACE,
    STATE(19578), 2,
      sym_block_comment,
      sym_line_comment,
  [409796] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18936), 1,
      anon_sym_RBRACE,
    STATE(19579), 2,
      sym_block_comment,
      sym_line_comment,
  [409810] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13108), 1,
      anon_sym_RPAREN,
    STATE(19580), 2,
      sym_block_comment,
      sym_line_comment,
  [409824] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21186), 1,
      anon_sym_end,
    STATE(19581), 2,
      sym_block_comment,
      sym_line_comment,
  [409838] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26620), 1,
      anon_sym_RBRACK,
    STATE(19582), 2,
      sym_block_comment,
      sym_line_comment,
  [409852] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26622), 1,
      anon_sym_end,
    STATE(19583), 2,
      sym_block_comment,
      sym_line_comment,
  [409866] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(20824), 1,
      anon_sym_end,
    STATE(19584), 2,
      sym_block_comment,
      sym_line_comment,
  [409880] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13098), 1,
      anon_sym_RPAREN,
    STATE(19585), 2,
      sym_block_comment,
      sym_line_comment,
  [409894] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(7820), 1,
      anon_sym_RPAREN,
    STATE(19586), 2,
      sym_block_comment,
      sym_line_comment,
  [409908] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26624), 1,
      anon_sym_RPAREN,
    STATE(19587), 2,
      sym_block_comment,
      sym_line_comment,
  [409922] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10330), 1,
      sym__immediate_paren,
    STATE(19588), 2,
      sym_block_comment,
      sym_line_comment,
  [409936] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26626), 1,
      anon_sym_end,
    STATE(19589), 2,
      sym_block_comment,
      sym_line_comment,
  [409950] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26628), 1,
      anon_sym_COLON2,
    STATE(19590), 2,
      sym_block_comment,
      sym_line_comment,
  [409964] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26630), 1,
      anon_sym_RBRACK,
    STATE(19591), 2,
      sym_block_comment,
      sym_line_comment,
  [409978] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18960), 1,
      anon_sym_RBRACE,
    STATE(19592), 2,
      sym_block_comment,
      sym_line_comment,
  [409992] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26632), 1,
      anon_sym_end,
    STATE(19593), 2,
      sym_block_comment,
      sym_line_comment,
  [410006] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26634), 1,
      anon_sym_RBRACK,
    STATE(19594), 2,
      sym_block_comment,
      sym_line_comment,
  [410020] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(19018), 1,
      anon_sym_RBRACE,
    STATE(19595), 2,
      sym_block_comment,
      sym_line_comment,
  [410034] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26636), 1,
      anon_sym_end,
    STATE(19596), 2,
      sym_block_comment,
      sym_line_comment,
  [410048] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26638), 1,
      anon_sym_end,
    STATE(19597), 2,
      sym_block_comment,
      sym_line_comment,
  [410062] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26640), 1,
      anon_sym_end,
    STATE(19598), 2,
      sym_block_comment,
      sym_line_comment,
  [410076] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13028), 1,
      anon_sym_RPAREN,
    STATE(19599), 2,
      sym_block_comment,
      sym_line_comment,
  [410090] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26642), 1,
      anon_sym_RBRACK,
    STATE(19600), 2,
      sym_block_comment,
      sym_line_comment,
  [410104] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26644), 1,
      anon_sym_end,
    STATE(19601), 2,
      sym_block_comment,
      sym_line_comment,
  [410118] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26646), 1,
      anon_sym_end,
    STATE(19602), 2,
      sym_block_comment,
      sym_line_comment,
  [410132] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(21107), 1,
      anon_sym_end,
    STATE(19603), 2,
      sym_block_comment,
      sym_line_comment,
  [410146] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26648), 1,
      anon_sym_COLON2,
    STATE(19604), 2,
      sym_block_comment,
      sym_line_comment,
  [410160] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26650), 1,
      anon_sym_end,
    STATE(19605), 2,
      sym_block_comment,
      sym_line_comment,
  [410174] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26652), 1,
      anon_sym_RBRACK,
    STATE(19606), 2,
      sym_block_comment,
      sym_line_comment,
  [410188] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(10475), 1,
      sym__immediate_paren,
    STATE(19607), 2,
      sym_block_comment,
      sym_line_comment,
  [410202] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13106), 1,
      anon_sym_RPAREN,
    STATE(19608), 2,
      sym_block_comment,
      sym_line_comment,
  [410216] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26654), 1,
      anon_sym_end,
    STATE(19609), 2,
      sym_block_comment,
      sym_line_comment,
  [410230] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(13016), 1,
      anon_sym_RPAREN,
    STATE(19610), 2,
      sym_block_comment,
      sym_line_comment,
  [410244] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26656), 1,
      anon_sym_DASH_GT,
    STATE(19611), 2,
      sym_block_comment,
      sym_line_comment,
  [410258] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(18932), 1,
      anon_sym_RBRACE,
    STATE(19612), 2,
      sym_block_comment,
      sym_line_comment,
  [410272] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26658), 1,
      anon_sym_COLON2,
    STATE(19613), 2,
      sym_block_comment,
      sym_line_comment,
  [410286] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(8658), 1,
      anon_sym_RPAREN,
    STATE(19614), 2,
      sym_block_comment,
      sym_line_comment,
  [410300] = 4,
    ACTIONS(3), 1,
      aux_sym_block_comment_token1,
    ACTIONS(5), 1,
      aux_sym_line_comment_token1,
    ACTIONS(26660), 1,
      anon_sym_RPAREN,
    STATE(19615), 2,
      sym_block_comment,
      sym_line_comment,
  [410314] = 1,
    ACTIONS(26662), 1,
      ts_builtin_sym_end,
  [410318] = 1,
    ACTIONS(26664), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(9476)] = 0,
  [SMALL_STATE(9477)] = 125,
  [SMALL_STATE(9478)] = 250,
  [SMALL_STATE(9479)] = 375,
  [SMALL_STATE(9480)] = 500,
  [SMALL_STATE(9481)] = 625,
  [SMALL_STATE(9482)] = 750,
  [SMALL_STATE(9483)] = 875,
  [SMALL_STATE(9484)] = 1000,
  [SMALL_STATE(9485)] = 1125,
  [SMALL_STATE(9486)] = 1250,
  [SMALL_STATE(9487)] = 1375,
  [SMALL_STATE(9488)] = 1500,
  [SMALL_STATE(9489)] = 1625,
  [SMALL_STATE(9490)] = 1750,
  [SMALL_STATE(9491)] = 1875,
  [SMALL_STATE(9492)] = 2000,
  [SMALL_STATE(9493)] = 2125,
  [SMALL_STATE(9494)] = 2250,
  [SMALL_STATE(9495)] = 2375,
  [SMALL_STATE(9496)] = 2500,
  [SMALL_STATE(9497)] = 2625,
  [SMALL_STATE(9498)] = 2750,
  [SMALL_STATE(9499)] = 2875,
  [SMALL_STATE(9500)] = 3000,
  [SMALL_STATE(9501)] = 3125,
  [SMALL_STATE(9502)] = 3250,
  [SMALL_STATE(9503)] = 3375,
  [SMALL_STATE(9504)] = 3500,
  [SMALL_STATE(9505)] = 3625,
  [SMALL_STATE(9506)] = 3750,
  [SMALL_STATE(9507)] = 3875,
  [SMALL_STATE(9508)] = 4000,
  [SMALL_STATE(9509)] = 4125,
  [SMALL_STATE(9510)] = 4250,
  [SMALL_STATE(9511)] = 4375,
  [SMALL_STATE(9512)] = 4500,
  [SMALL_STATE(9513)] = 4625,
  [SMALL_STATE(9514)] = 4750,
  [SMALL_STATE(9515)] = 4875,
  [SMALL_STATE(9516)] = 5000,
  [SMALL_STATE(9517)] = 5125,
  [SMALL_STATE(9518)] = 5250,
  [SMALL_STATE(9519)] = 5375,
  [SMALL_STATE(9520)] = 5500,
  [SMALL_STATE(9521)] = 5625,
  [SMALL_STATE(9522)] = 5750,
  [SMALL_STATE(9523)] = 5875,
  [SMALL_STATE(9524)] = 6000,
  [SMALL_STATE(9525)] = 6125,
  [SMALL_STATE(9526)] = 6250,
  [SMALL_STATE(9527)] = 6375,
  [SMALL_STATE(9528)] = 6500,
  [SMALL_STATE(9529)] = 6625,
  [SMALL_STATE(9530)] = 6750,
  [SMALL_STATE(9531)] = 6875,
  [SMALL_STATE(9532)] = 7000,
  [SMALL_STATE(9533)] = 7125,
  [SMALL_STATE(9534)] = 7250,
  [SMALL_STATE(9535)] = 7375,
  [SMALL_STATE(9536)] = 7500,
  [SMALL_STATE(9537)] = 7626,
  [SMALL_STATE(9538)] = 7752,
  [SMALL_STATE(9539)] = 7878,
  [SMALL_STATE(9540)] = 8000,
  [SMALL_STATE(9541)] = 8126,
  [SMALL_STATE(9542)] = 8248,
  [SMALL_STATE(9543)] = 8374,
  [SMALL_STATE(9544)] = 8496,
  [SMALL_STATE(9545)] = 8622,
  [SMALL_STATE(9546)] = 8748,
  [SMALL_STATE(9547)] = 8874,
  [SMALL_STATE(9548)] = 9000,
  [SMALL_STATE(9549)] = 9126,
  [SMALL_STATE(9550)] = 9252,
  [SMALL_STATE(9551)] = 9374,
  [SMALL_STATE(9552)] = 9500,
  [SMALL_STATE(9553)] = 9622,
  [SMALL_STATE(9554)] = 9748,
  [SMALL_STATE(9555)] = 9870,
  [SMALL_STATE(9556)] = 9992,
  [SMALL_STATE(9557)] = 10118,
  [SMALL_STATE(9558)] = 10244,
  [SMALL_STATE(9559)] = 10370,
  [SMALL_STATE(9560)] = 10492,
  [SMALL_STATE(9561)] = 10614,
  [SMALL_STATE(9562)] = 10740,
  [SMALL_STATE(9563)] = 10866,
  [SMALL_STATE(9564)] = 10992,
  [SMALL_STATE(9565)] = 11118,
  [SMALL_STATE(9566)] = 11244,
  [SMALL_STATE(9567)] = 11370,
  [SMALL_STATE(9568)] = 11496,
  [SMALL_STATE(9569)] = 11622,
  [SMALL_STATE(9570)] = 11744,
  [SMALL_STATE(9571)] = 11870,
  [SMALL_STATE(9572)] = 11996,
  [SMALL_STATE(9573)] = 12122,
  [SMALL_STATE(9574)] = 12248,
  [SMALL_STATE(9575)] = 12370,
  [SMALL_STATE(9576)] = 12496,
  [SMALL_STATE(9577)] = 12622,
  [SMALL_STATE(9578)] = 12748,
  [SMALL_STATE(9579)] = 12874,
  [SMALL_STATE(9580)] = 13000,
  [SMALL_STATE(9581)] = 13126,
  [SMALL_STATE(9582)] = 13252,
  [SMALL_STATE(9583)] = 13378,
  [SMALL_STATE(9584)] = 13504,
  [SMALL_STATE(9585)] = 13630,
  [SMALL_STATE(9586)] = 13756,
  [SMALL_STATE(9587)] = 13882,
  [SMALL_STATE(9588)] = 14008,
  [SMALL_STATE(9589)] = 14130,
  [SMALL_STATE(9590)] = 14252,
  [SMALL_STATE(9591)] = 14378,
  [SMALL_STATE(9592)] = 14504,
  [SMALL_STATE(9593)] = 14630,
  [SMALL_STATE(9594)] = 14756,
  [SMALL_STATE(9595)] = 14882,
  [SMALL_STATE(9596)] = 15008,
  [SMALL_STATE(9597)] = 15134,
  [SMALL_STATE(9598)] = 15260,
  [SMALL_STATE(9599)] = 15386,
  [SMALL_STATE(9600)] = 15512,
  [SMALL_STATE(9601)] = 15638,
  [SMALL_STATE(9602)] = 15764,
  [SMALL_STATE(9603)] = 15890,
  [SMALL_STATE(9604)] = 16016,
  [SMALL_STATE(9605)] = 16142,
  [SMALL_STATE(9606)] = 16264,
  [SMALL_STATE(9607)] = 16386,
  [SMALL_STATE(9608)] = 16512,
  [SMALL_STATE(9609)] = 16638,
  [SMALL_STATE(9610)] = 16764,
  [SMALL_STATE(9611)] = 16890,
  [SMALL_STATE(9612)] = 17016,
  [SMALL_STATE(9613)] = 17142,
  [SMALL_STATE(9614)] = 17268,
  [SMALL_STATE(9615)] = 17394,
  [SMALL_STATE(9616)] = 17520,
  [SMALL_STATE(9617)] = 17646,
  [SMALL_STATE(9618)] = 17768,
  [SMALL_STATE(9619)] = 17890,
  [SMALL_STATE(9620)] = 18016,
  [SMALL_STATE(9621)] = 18142,
  [SMALL_STATE(9622)] = 18268,
  [SMALL_STATE(9623)] = 18394,
  [SMALL_STATE(9624)] = 18520,
  [SMALL_STATE(9625)] = 18646,
  [SMALL_STATE(9626)] = 18772,
  [SMALL_STATE(9627)] = 18898,
  [SMALL_STATE(9628)] = 19024,
  [SMALL_STATE(9629)] = 19150,
  [SMALL_STATE(9630)] = 19272,
  [SMALL_STATE(9631)] = 19394,
  [SMALL_STATE(9632)] = 19520,
  [SMALL_STATE(9633)] = 19642,
  [SMALL_STATE(9634)] = 19768,
  [SMALL_STATE(9635)] = 19894,
  [SMALL_STATE(9636)] = 20020,
  [SMALL_STATE(9637)] = 20146,
  [SMALL_STATE(9638)] = 20272,
  [SMALL_STATE(9639)] = 20394,
  [SMALL_STATE(9640)] = 20520,
  [SMALL_STATE(9641)] = 20646,
  [SMALL_STATE(9642)] = 20768,
  [SMALL_STATE(9643)] = 20894,
  [SMALL_STATE(9644)] = 21020,
  [SMALL_STATE(9645)] = 21146,
  [SMALL_STATE(9646)] = 21268,
  [SMALL_STATE(9647)] = 21394,
  [SMALL_STATE(9648)] = 21520,
  [SMALL_STATE(9649)] = 21646,
  [SMALL_STATE(9650)] = 21768,
  [SMALL_STATE(9651)] = 21894,
  [SMALL_STATE(9652)] = 22020,
  [SMALL_STATE(9653)] = 22146,
  [SMALL_STATE(9654)] = 22268,
  [SMALL_STATE(9655)] = 22390,
  [SMALL_STATE(9656)] = 22512,
  [SMALL_STATE(9657)] = 22638,
  [SMALL_STATE(9658)] = 22764,
  [SMALL_STATE(9659)] = 22886,
  [SMALL_STATE(9660)] = 23008,
  [SMALL_STATE(9661)] = 23134,
  [SMALL_STATE(9662)] = 23260,
  [SMALL_STATE(9663)] = 23382,
  [SMALL_STATE(9664)] = 23504,
  [SMALL_STATE(9665)] = 23630,
  [SMALL_STATE(9666)] = 23756,
  [SMALL_STATE(9667)] = 23878,
  [SMALL_STATE(9668)] = 24004,
  [SMALL_STATE(9669)] = 24130,
  [SMALL_STATE(9670)] = 24256,
  [SMALL_STATE(9671)] = 24382,
  [SMALL_STATE(9672)] = 24508,
  [SMALL_STATE(9673)] = 24634,
  [SMALL_STATE(9674)] = 24760,
  [SMALL_STATE(9675)] = 24886,
  [SMALL_STATE(9676)] = 25012,
  [SMALL_STATE(9677)] = 25138,
  [SMALL_STATE(9678)] = 25260,
  [SMALL_STATE(9679)] = 25386,
  [SMALL_STATE(9680)] = 25512,
  [SMALL_STATE(9681)] = 25638,
  [SMALL_STATE(9682)] = 25764,
  [SMALL_STATE(9683)] = 25886,
  [SMALL_STATE(9684)] = 26012,
  [SMALL_STATE(9685)] = 26134,
  [SMALL_STATE(9686)] = 26260,
  [SMALL_STATE(9687)] = 26382,
  [SMALL_STATE(9688)] = 26508,
  [SMALL_STATE(9689)] = 26630,
  [SMALL_STATE(9690)] = 26756,
  [SMALL_STATE(9691)] = 26882,
  [SMALL_STATE(9692)] = 27008,
  [SMALL_STATE(9693)] = 27134,
  [SMALL_STATE(9694)] = 27260,
  [SMALL_STATE(9695)] = 27386,
  [SMALL_STATE(9696)] = 27512,
  [SMALL_STATE(9697)] = 27638,
  [SMALL_STATE(9698)] = 27764,
  [SMALL_STATE(9699)] = 27890,
  [SMALL_STATE(9700)] = 28016,
  [SMALL_STATE(9701)] = 28142,
  [SMALL_STATE(9702)] = 28264,
  [SMALL_STATE(9703)] = 28386,
  [SMALL_STATE(9704)] = 28512,
  [SMALL_STATE(9705)] = 28638,
  [SMALL_STATE(9706)] = 28760,
  [SMALL_STATE(9707)] = 28886,
  [SMALL_STATE(9708)] = 29012,
  [SMALL_STATE(9709)] = 29138,
  [SMALL_STATE(9710)] = 29260,
  [SMALL_STATE(9711)] = 29386,
  [SMALL_STATE(9712)] = 29508,
  [SMALL_STATE(9713)] = 29634,
  [SMALL_STATE(9714)] = 29760,
  [SMALL_STATE(9715)] = 29886,
  [SMALL_STATE(9716)] = 30012,
  [SMALL_STATE(9717)] = 30134,
  [SMALL_STATE(9718)] = 30260,
  [SMALL_STATE(9719)] = 30386,
  [SMALL_STATE(9720)] = 30512,
  [SMALL_STATE(9721)] = 30638,
  [SMALL_STATE(9722)] = 30764,
  [SMALL_STATE(9723)] = 30890,
  [SMALL_STATE(9724)] = 30962,
  [SMALL_STATE(9725)] = 31031,
  [SMALL_STATE(9726)] = 31100,
  [SMALL_STATE(9727)] = 31168,
  [SMALL_STATE(9728)] = 31236,
  [SMALL_STATE(9729)] = 31304,
  [SMALL_STATE(9730)] = 31371,
  [SMALL_STATE(9731)] = 31438,
  [SMALL_STATE(9732)] = 31505,
  [SMALL_STATE(9733)] = 31570,
  [SMALL_STATE(9734)] = 31636,
  [SMALL_STATE(9735)] = 31700,
  [SMALL_STATE(9736)] = 31763,
  [SMALL_STATE(9737)] = 31826,
  [SMALL_STATE(9738)] = 31893,
  [SMALL_STATE(9739)] = 31960,
  [SMALL_STATE(9740)] = 32027,
  [SMALL_STATE(9741)] = 32094,
  [SMALL_STATE(9742)] = 32157,
  [SMALL_STATE(9743)] = 32220,
  [SMALL_STATE(9744)] = 32282,
  [SMALL_STATE(9745)] = 32346,
  [SMALL_STATE(9746)] = 32408,
  [SMALL_STATE(9747)] = 32472,
  [SMALL_STATE(9748)] = 32536,
  [SMALL_STATE(9749)] = 32598,
  [SMALL_STATE(9750)] = 32660,
  [SMALL_STATE(9751)] = 32722,
  [SMALL_STATE(9752)] = 32786,
  [SMALL_STATE(9753)] = 32848,
  [SMALL_STATE(9754)] = 32910,
  [SMALL_STATE(9755)] = 32972,
  [SMALL_STATE(9756)] = 33034,
  [SMALL_STATE(9757)] = 33098,
  [SMALL_STATE(9758)] = 33160,
  [SMALL_STATE(9759)] = 33222,
  [SMALL_STATE(9760)] = 33286,
  [SMALL_STATE(9761)] = 33350,
  [SMALL_STATE(9762)] = 33414,
  [SMALL_STATE(9763)] = 33476,
  [SMALL_STATE(9764)] = 33537,
  [SMALL_STATE(9765)] = 33598,
  [SMALL_STATE(9766)] = 33659,
  [SMALL_STATE(9767)] = 33720,
  [SMALL_STATE(9768)] = 33781,
  [SMALL_STATE(9769)] = 33842,
  [SMALL_STATE(9770)] = 33903,
  [SMALL_STATE(9771)] = 33964,
  [SMALL_STATE(9772)] = 34025,
  [SMALL_STATE(9773)] = 34086,
  [SMALL_STATE(9774)] = 34147,
  [SMALL_STATE(9775)] = 34208,
  [SMALL_STATE(9776)] = 34269,
  [SMALL_STATE(9777)] = 34330,
  [SMALL_STATE(9778)] = 34391,
  [SMALL_STATE(9779)] = 34452,
  [SMALL_STATE(9780)] = 34513,
  [SMALL_STATE(9781)] = 34574,
  [SMALL_STATE(9782)] = 34635,
  [SMALL_STATE(9783)] = 34696,
  [SMALL_STATE(9784)] = 34757,
  [SMALL_STATE(9785)] = 34818,
  [SMALL_STATE(9786)] = 34879,
  [SMALL_STATE(9787)] = 34940,
  [SMALL_STATE(9788)] = 35001,
  [SMALL_STATE(9789)] = 35062,
  [SMALL_STATE(9790)] = 35123,
  [SMALL_STATE(9791)] = 35184,
  [SMALL_STATE(9792)] = 35245,
  [SMALL_STATE(9793)] = 35306,
  [SMALL_STATE(9794)] = 35367,
  [SMALL_STATE(9795)] = 35428,
  [SMALL_STATE(9796)] = 35489,
  [SMALL_STATE(9797)] = 35550,
  [SMALL_STATE(9798)] = 35611,
  [SMALL_STATE(9799)] = 35672,
  [SMALL_STATE(9800)] = 35733,
  [SMALL_STATE(9801)] = 35794,
  [SMALL_STATE(9802)] = 35855,
  [SMALL_STATE(9803)] = 35916,
  [SMALL_STATE(9804)] = 35977,
  [SMALL_STATE(9805)] = 36038,
  [SMALL_STATE(9806)] = 36099,
  [SMALL_STATE(9807)] = 36160,
  [SMALL_STATE(9808)] = 36221,
  [SMALL_STATE(9809)] = 36282,
  [SMALL_STATE(9810)] = 36343,
  [SMALL_STATE(9811)] = 36404,
  [SMALL_STATE(9812)] = 36465,
  [SMALL_STATE(9813)] = 36526,
  [SMALL_STATE(9814)] = 36589,
  [SMALL_STATE(9815)] = 36650,
  [SMALL_STATE(9816)] = 36713,
  [SMALL_STATE(9817)] = 36774,
  [SMALL_STATE(9818)] = 36835,
  [SMALL_STATE(9819)] = 36896,
  [SMALL_STATE(9820)] = 36957,
  [SMALL_STATE(9821)] = 37018,
  [SMALL_STATE(9822)] = 37078,
  [SMALL_STATE(9823)] = 37140,
  [SMALL_STATE(9824)] = 37204,
  [SMALL_STATE(9825)] = 37268,
  [SMALL_STATE(9826)] = 37332,
  [SMALL_STATE(9827)] = 37394,
  [SMALL_STATE(9828)] = 37456,
  [SMALL_STATE(9829)] = 37516,
  [SMALL_STATE(9830)] = 37576,
  [SMALL_STATE(9831)] = 37636,
  [SMALL_STATE(9832)] = 37696,
  [SMALL_STATE(9833)] = 37756,
  [SMALL_STATE(9834)] = 37820,
  [SMALL_STATE(9835)] = 37880,
  [SMALL_STATE(9836)] = 37944,
  [SMALL_STATE(9837)] = 38008,
  [SMALL_STATE(9838)] = 38072,
  [SMALL_STATE(9839)] = 38131,
  [SMALL_STATE(9840)] = 38190,
  [SMALL_STATE(9841)] = 38253,
  [SMALL_STATE(9842)] = 38316,
  [SMALL_STATE(9843)] = 38377,
  [SMALL_STATE(9844)] = 38436,
  [SMALL_STATE(9845)] = 38499,
  [SMALL_STATE(9846)] = 38562,
  [SMALL_STATE(9847)] = 38623,
  [SMALL_STATE(9848)] = 38682,
  [SMALL_STATE(9849)] = 38741,
  [SMALL_STATE(9850)] = 38800,
  [SMALL_STATE(9851)] = 38859,
  [SMALL_STATE(9852)] = 38922,
  [SMALL_STATE(9853)] = 38985,
  [SMALL_STATE(9854)] = 39046,
  [SMALL_STATE(9855)] = 39105,
  [SMALL_STATE(9856)] = 39164,
  [SMALL_STATE(9857)] = 39227,
  [SMALL_STATE(9858)] = 39286,
  [SMALL_STATE(9859)] = 39345,
  [SMALL_STATE(9860)] = 39408,
  [SMALL_STATE(9861)] = 39466,
  [SMALL_STATE(9862)] = 39524,
  [SMALL_STATE(9863)] = 39582,
  [SMALL_STATE(9864)] = 39644,
  [SMALL_STATE(9865)] = 39702,
  [SMALL_STATE(9866)] = 39760,
  [SMALL_STATE(9867)] = 39818,
  [SMALL_STATE(9868)] = 39876,
  [SMALL_STATE(9869)] = 39936,
  [SMALL_STATE(9870)] = 39994,
  [SMALL_STATE(9871)] = 40052,
  [SMALL_STATE(9872)] = 40110,
  [SMALL_STATE(9873)] = 40168,
  [SMALL_STATE(9874)] = 40226,
  [SMALL_STATE(9875)] = 40286,
  [SMALL_STATE(9876)] = 40344,
  [SMALL_STATE(9877)] = 40402,
  [SMALL_STATE(9878)] = 40460,
  [SMALL_STATE(9879)] = 40518,
  [SMALL_STATE(9880)] = 40576,
  [SMALL_STATE(9881)] = 40636,
  [SMALL_STATE(9882)] = 40694,
  [SMALL_STATE(9883)] = 40752,
  [SMALL_STATE(9884)] = 40812,
  [SMALL_STATE(9885)] = 40872,
  [SMALL_STATE(9886)] = 40930,
  [SMALL_STATE(9887)] = 40988,
  [SMALL_STATE(9888)] = 41048,
  [SMALL_STATE(9889)] = 41108,
  [SMALL_STATE(9890)] = 41166,
  [SMALL_STATE(9891)] = 41224,
  [SMALL_STATE(9892)] = 41282,
  [SMALL_STATE(9893)] = 41342,
  [SMALL_STATE(9894)] = 41400,
  [SMALL_STATE(9895)] = 41458,
  [SMALL_STATE(9896)] = 41516,
  [SMALL_STATE(9897)] = 41574,
  [SMALL_STATE(9898)] = 41636,
  [SMALL_STATE(9899)] = 41694,
  [SMALL_STATE(9900)] = 41752,
  [SMALL_STATE(9901)] = 41810,
  [SMALL_STATE(9902)] = 41872,
  [SMALL_STATE(9903)] = 41930,
  [SMALL_STATE(9904)] = 41988,
  [SMALL_STATE(9905)] = 42050,
  [SMALL_STATE(9906)] = 42108,
  [SMALL_STATE(9907)] = 42168,
  [SMALL_STATE(9908)] = 42225,
  [SMALL_STATE(9909)] = 42282,
  [SMALL_STATE(9910)] = 42339,
  [SMALL_STATE(9911)] = 42396,
  [SMALL_STATE(9912)] = 42453,
  [SMALL_STATE(9913)] = 42510,
  [SMALL_STATE(9914)] = 42567,
  [SMALL_STATE(9915)] = 42624,
  [SMALL_STATE(9916)] = 42681,
  [SMALL_STATE(9917)] = 42738,
  [SMALL_STATE(9918)] = 42795,
  [SMALL_STATE(9919)] = 42852,
  [SMALL_STATE(9920)] = 42909,
  [SMALL_STATE(9921)] = 42966,
  [SMALL_STATE(9922)] = 43023,
  [SMALL_STATE(9923)] = 43080,
  [SMALL_STATE(9924)] = 43137,
  [SMALL_STATE(9925)] = 43194,
  [SMALL_STATE(9926)] = 43251,
  [SMALL_STATE(9927)] = 43308,
  [SMALL_STATE(9928)] = 43365,
  [SMALL_STATE(9929)] = 43422,
  [SMALL_STATE(9930)] = 43479,
  [SMALL_STATE(9931)] = 43536,
  [SMALL_STATE(9932)] = 43599,
  [SMALL_STATE(9933)] = 43656,
  [SMALL_STATE(9934)] = 43713,
  [SMALL_STATE(9935)] = 43770,
  [SMALL_STATE(9936)] = 43827,
  [SMALL_STATE(9937)] = 43884,
  [SMALL_STATE(9938)] = 43941,
  [SMALL_STATE(9939)] = 43998,
  [SMALL_STATE(9940)] = 44055,
  [SMALL_STATE(9941)] = 44112,
  [SMALL_STATE(9942)] = 44169,
  [SMALL_STATE(9943)] = 44226,
  [SMALL_STATE(9944)] = 44283,
  [SMALL_STATE(9945)] = 44340,
  [SMALL_STATE(9946)] = 44397,
  [SMALL_STATE(9947)] = 44454,
  [SMALL_STATE(9948)] = 44511,
  [SMALL_STATE(9949)] = 44568,
  [SMALL_STATE(9950)] = 44625,
  [SMALL_STATE(9951)] = 44688,
  [SMALL_STATE(9952)] = 44745,
  [SMALL_STATE(9953)] = 44802,
  [SMALL_STATE(9954)] = 44859,
  [SMALL_STATE(9955)] = 44916,
  [SMALL_STATE(9956)] = 44973,
  [SMALL_STATE(9957)] = 45030,
  [SMALL_STATE(9958)] = 45087,
  [SMALL_STATE(9959)] = 45144,
  [SMALL_STATE(9960)] = 45201,
  [SMALL_STATE(9961)] = 45258,
  [SMALL_STATE(9962)] = 45315,
  [SMALL_STATE(9963)] = 45372,
  [SMALL_STATE(9964)] = 45429,
  [SMALL_STATE(9965)] = 45486,
  [SMALL_STATE(9966)] = 45543,
  [SMALL_STATE(9967)] = 45600,
  [SMALL_STATE(9968)] = 45657,
  [SMALL_STATE(9969)] = 45714,
  [SMALL_STATE(9970)] = 45771,
  [SMALL_STATE(9971)] = 45828,
  [SMALL_STATE(9972)] = 45885,
  [SMALL_STATE(9973)] = 45942,
  [SMALL_STATE(9974)] = 45999,
  [SMALL_STATE(9975)] = 46056,
  [SMALL_STATE(9976)] = 46113,
  [SMALL_STATE(9977)] = 46170,
  [SMALL_STATE(9978)] = 46227,
  [SMALL_STATE(9979)] = 46284,
  [SMALL_STATE(9980)] = 46341,
  [SMALL_STATE(9981)] = 46398,
  [SMALL_STATE(9982)] = 46455,
  [SMALL_STATE(9983)] = 46512,
  [SMALL_STATE(9984)] = 46569,
  [SMALL_STATE(9985)] = 46626,
  [SMALL_STATE(9986)] = 46683,
  [SMALL_STATE(9987)] = 46740,
  [SMALL_STATE(9988)] = 46797,
  [SMALL_STATE(9989)] = 46854,
  [SMALL_STATE(9990)] = 46911,
  [SMALL_STATE(9991)] = 46968,
  [SMALL_STATE(9992)] = 47025,
  [SMALL_STATE(9993)] = 47082,
  [SMALL_STATE(9994)] = 47139,
  [SMALL_STATE(9995)] = 47196,
  [SMALL_STATE(9996)] = 47253,
  [SMALL_STATE(9997)] = 47310,
  [SMALL_STATE(9998)] = 47367,
  [SMALL_STATE(9999)] = 47424,
  [SMALL_STATE(10000)] = 47481,
  [SMALL_STATE(10001)] = 47538,
  [SMALL_STATE(10002)] = 47595,
  [SMALL_STATE(10003)] = 47652,
  [SMALL_STATE(10004)] = 47709,
  [SMALL_STATE(10005)] = 47766,
  [SMALL_STATE(10006)] = 47823,
  [SMALL_STATE(10007)] = 47880,
  [SMALL_STATE(10008)] = 47937,
  [SMALL_STATE(10009)] = 48000,
  [SMALL_STATE(10010)] = 48057,
  [SMALL_STATE(10011)] = 48114,
  [SMALL_STATE(10012)] = 48171,
  [SMALL_STATE(10013)] = 48228,
  [SMALL_STATE(10014)] = 48285,
  [SMALL_STATE(10015)] = 48344,
  [SMALL_STATE(10016)] = 48401,
  [SMALL_STATE(10017)] = 48458,
  [SMALL_STATE(10018)] = 48515,
  [SMALL_STATE(10019)] = 48572,
  [SMALL_STATE(10020)] = 48629,
  [SMALL_STATE(10021)] = 48686,
  [SMALL_STATE(10022)] = 48743,
  [SMALL_STATE(10023)] = 48806,
  [SMALL_STATE(10024)] = 48863,
  [SMALL_STATE(10025)] = 48920,
  [SMALL_STATE(10026)] = 48977,
  [SMALL_STATE(10027)] = 49034,
  [SMALL_STATE(10028)] = 49091,
  [SMALL_STATE(10029)] = 49148,
  [SMALL_STATE(10030)] = 49207,
  [SMALL_STATE(10031)] = 49264,
  [SMALL_STATE(10032)] = 49321,
  [SMALL_STATE(10033)] = 49378,
  [SMALL_STATE(10034)] = 49435,
  [SMALL_STATE(10035)] = 49492,
  [SMALL_STATE(10036)] = 49549,
  [SMALL_STATE(10037)] = 49606,
  [SMALL_STATE(10038)] = 49663,
  [SMALL_STATE(10039)] = 49720,
  [SMALL_STATE(10040)] = 49776,
  [SMALL_STATE(10041)] = 49838,
  [SMALL_STATE(10042)] = 49894,
  [SMALL_STATE(10043)] = 49950,
  [SMALL_STATE(10044)] = 50012,
  [SMALL_STATE(10045)] = 50072,
  [SMALL_STATE(10046)] = 50132,
  [SMALL_STATE(10047)] = 50194,
  [SMALL_STATE(10048)] = 50256,
  [SMALL_STATE(10049)] = 50312,
  [SMALL_STATE(10050)] = 50368,
  [SMALL_STATE(10051)] = 50424,
  [SMALL_STATE(10052)] = 50480,
  [SMALL_STATE(10053)] = 50536,
  [SMALL_STATE(10054)] = 50592,
  [SMALL_STATE(10055)] = 50648,
  [SMALL_STATE(10056)] = 50708,
  [SMALL_STATE(10057)] = 50768,
  [SMALL_STATE(10058)] = 50828,
  [SMALL_STATE(10059)] = 50888,
  [SMALL_STATE(10060)] = 50948,
  [SMALL_STATE(10061)] = 51008,
  [SMALL_STATE(10062)] = 51068,
  [SMALL_STATE(10063)] = 51128,
  [SMALL_STATE(10064)] = 51188,
  [SMALL_STATE(10065)] = 51244,
  [SMALL_STATE(10066)] = 51300,
  [SMALL_STATE(10067)] = 51360,
  [SMALL_STATE(10068)] = 51420,
  [SMALL_STATE(10069)] = 51476,
  [SMALL_STATE(10070)] = 51532,
  [SMALL_STATE(10071)] = 51588,
  [SMALL_STATE(10072)] = 51648,
  [SMALL_STATE(10073)] = 51708,
  [SMALL_STATE(10074)] = 51770,
  [SMALL_STATE(10075)] = 51830,
  [SMALL_STATE(10076)] = 51890,
  [SMALL_STATE(10077)] = 51950,
  [SMALL_STATE(10078)] = 52010,
  [SMALL_STATE(10079)] = 52070,
  [SMALL_STATE(10080)] = 52130,
  [SMALL_STATE(10081)] = 52186,
  [SMALL_STATE(10082)] = 52242,
  [SMALL_STATE(10083)] = 52298,
  [SMALL_STATE(10084)] = 52354,
  [SMALL_STATE(10085)] = 52410,
  [SMALL_STATE(10086)] = 52470,
  [SMALL_STATE(10087)] = 52530,
  [SMALL_STATE(10088)] = 52586,
  [SMALL_STATE(10089)] = 52646,
  [SMALL_STATE(10090)] = 52702,
  [SMALL_STATE(10091)] = 52758,
  [SMALL_STATE(10092)] = 52818,
  [SMALL_STATE(10093)] = 52874,
  [SMALL_STATE(10094)] = 52930,
  [SMALL_STATE(10095)] = 52986,
  [SMALL_STATE(10096)] = 53048,
  [SMALL_STATE(10097)] = 53104,
  [SMALL_STATE(10098)] = 53164,
  [SMALL_STATE(10099)] = 53220,
  [SMALL_STATE(10100)] = 53276,
  [SMALL_STATE(10101)] = 53338,
  [SMALL_STATE(10102)] = 53400,
  [SMALL_STATE(10103)] = 53462,
  [SMALL_STATE(10104)] = 53518,
  [SMALL_STATE(10105)] = 53574,
  [SMALL_STATE(10106)] = 53630,
  [SMALL_STATE(10107)] = 53686,
  [SMALL_STATE(10108)] = 53742,
  [SMALL_STATE(10109)] = 53798,
  [SMALL_STATE(10110)] = 53858,
  [SMALL_STATE(10111)] = 53914,
  [SMALL_STATE(10112)] = 53970,
  [SMALL_STATE(10113)] = 54026,
  [SMALL_STATE(10114)] = 54086,
  [SMALL_STATE(10115)] = 54142,
  [SMALL_STATE(10116)] = 54204,
  [SMALL_STATE(10117)] = 54260,
  [SMALL_STATE(10118)] = 54320,
  [SMALL_STATE(10119)] = 54376,
  [SMALL_STATE(10120)] = 54432,
  [SMALL_STATE(10121)] = 54488,
  [SMALL_STATE(10122)] = 54544,
  [SMALL_STATE(10123)] = 54600,
  [SMALL_STATE(10124)] = 54656,
  [SMALL_STATE(10125)] = 54718,
  [SMALL_STATE(10126)] = 54774,
  [SMALL_STATE(10127)] = 54830,
  [SMALL_STATE(10128)] = 54886,
  [SMALL_STATE(10129)] = 54942,
  [SMALL_STATE(10130)] = 54998,
  [SMALL_STATE(10131)] = 55054,
  [SMALL_STATE(10132)] = 55114,
  [SMALL_STATE(10133)] = 55170,
  [SMALL_STATE(10134)] = 55232,
  [SMALL_STATE(10135)] = 55288,
  [SMALL_STATE(10136)] = 55344,
  [SMALL_STATE(10137)] = 55400,
  [SMALL_STATE(10138)] = 55456,
  [SMALL_STATE(10139)] = 55512,
  [SMALL_STATE(10140)] = 55568,
  [SMALL_STATE(10141)] = 55624,
  [SMALL_STATE(10142)] = 55684,
  [SMALL_STATE(10143)] = 55740,
  [SMALL_STATE(10144)] = 55800,
  [SMALL_STATE(10145)] = 55862,
  [SMALL_STATE(10146)] = 55922,
  [SMALL_STATE(10147)] = 55977,
  [SMALL_STATE(10148)] = 56046,
  [SMALL_STATE(10149)] = 56103,
  [SMALL_STATE(10150)] = 56162,
  [SMALL_STATE(10151)] = 56233,
  [SMALL_STATE(10152)] = 56292,
  [SMALL_STATE(10153)] = 56349,
  [SMALL_STATE(10154)] = 56418,
  [SMALL_STATE(10155)] = 56487,
  [SMALL_STATE(10156)] = 56546,
  [SMALL_STATE(10157)] = 56603,
  [SMALL_STATE(10158)] = 56676,
  [SMALL_STATE(10159)] = 56745,
  [SMALL_STATE(10160)] = 56808,
  [SMALL_STATE(10161)] = 56863,
  [SMALL_STATE(10162)] = 56920,
  [SMALL_STATE(10163)] = 56977,
  [SMALL_STATE(10164)] = 57038,
  [SMALL_STATE(10165)] = 57099,
  [SMALL_STATE(10166)] = 57158,
  [SMALL_STATE(10167)] = 57217,
  [SMALL_STATE(10168)] = 57278,
  [SMALL_STATE(10169)] = 57337,
  [SMALL_STATE(10170)] = 57408,
  [SMALL_STATE(10171)] = 57465,
  [SMALL_STATE(10172)] = 57538,
  [SMALL_STATE(10173)] = 57609,
  [SMALL_STATE(10174)] = 57664,
  [SMALL_STATE(10175)] = 57723,
  [SMALL_STATE(10176)] = 57782,
  [SMALL_STATE(10177)] = 57841,
  [SMALL_STATE(10178)] = 57902,
  [SMALL_STATE(10179)] = 57957,
  [SMALL_STATE(10180)] = 58014,
  [SMALL_STATE(10181)] = 58073,
  [SMALL_STATE(10182)] = 58132,
  [SMALL_STATE(10183)] = 58193,
  [SMALL_STATE(10184)] = 58252,
  [SMALL_STATE(10185)] = 58311,
  [SMALL_STATE(10186)] = 58370,
  [SMALL_STATE(10187)] = 58429,
  [SMALL_STATE(10188)] = 58488,
  [SMALL_STATE(10189)] = 58547,
  [SMALL_STATE(10190)] = 58606,
  [SMALL_STATE(10191)] = 58667,
  [SMALL_STATE(10192)] = 58740,
  [SMALL_STATE(10193)] = 58799,
  [SMALL_STATE(10194)] = 58868,
  [SMALL_STATE(10195)] = 58929,
  [SMALL_STATE(10196)] = 58998,
  [SMALL_STATE(10197)] = 59067,
  [SMALL_STATE(10198)] = 59126,
  [SMALL_STATE(10199)] = 59187,
  [SMALL_STATE(10200)] = 59246,
  [SMALL_STATE(10201)] = 59315,
  [SMALL_STATE(10202)] = 59378,
  [SMALL_STATE(10203)] = 59451,
  [SMALL_STATE(10204)] = 59512,
  [SMALL_STATE(10205)] = 59571,
  [SMALL_STATE(10206)] = 59630,
  [SMALL_STATE(10207)] = 59689,
  [SMALL_STATE(10208)] = 59760,
  [SMALL_STATE(10209)] = 59819,
  [SMALL_STATE(10210)] = 59878,
  [SMALL_STATE(10211)] = 59947,
  [SMALL_STATE(10212)] = 60018,
  [SMALL_STATE(10213)] = 60079,
  [SMALL_STATE(10214)] = 60138,
  [SMALL_STATE(10215)] = 60193,
  [SMALL_STATE(10216)] = 60254,
  [SMALL_STATE(10217)] = 60327,
  [SMALL_STATE(10218)] = 60382,
  [SMALL_STATE(10219)] = 60437,
  [SMALL_STATE(10220)] = 60496,
  [SMALL_STATE(10221)] = 60551,
  [SMALL_STATE(10222)] = 60606,
  [SMALL_STATE(10223)] = 60661,
  [SMALL_STATE(10224)] = 60716,
  [SMALL_STATE(10225)] = 60775,
  [SMALL_STATE(10226)] = 60836,
  [SMALL_STATE(10227)] = 60905,
  [SMALL_STATE(10228)] = 60964,
  [SMALL_STATE(10229)] = 61019,
  [SMALL_STATE(10230)] = 61074,
  [SMALL_STATE(10231)] = 61129,
  [SMALL_STATE(10232)] = 61188,
  [SMALL_STATE(10233)] = 61259,
  [SMALL_STATE(10234)] = 61328,
  [SMALL_STATE(10235)] = 61385,
  [SMALL_STATE(10236)] = 61444,
  [SMALL_STATE(10237)] = 61503,
  [SMALL_STATE(10238)] = 61564,
  [SMALL_STATE(10239)] = 61625,
  [SMALL_STATE(10240)] = 61694,
  [SMALL_STATE(10241)] = 61767,
  [SMALL_STATE(10242)] = 61825,
  [SMALL_STATE(10243)] = 61879,
  [SMALL_STATE(10244)] = 61933,
  [SMALL_STATE(10245)] = 61987,
  [SMALL_STATE(10246)] = 62041,
  [SMALL_STATE(10247)] = 62111,
  [SMALL_STATE(10248)] = 62183,
  [SMALL_STATE(10249)] = 62253,
  [SMALL_STATE(10250)] = 62313,
  [SMALL_STATE(10251)] = 62367,
  [SMALL_STATE(10252)] = 62425,
  [SMALL_STATE(10253)] = 62479,
  [SMALL_STATE(10254)] = 62551,
  [SMALL_STATE(10255)] = 62625,
  [SMALL_STATE(10256)] = 62679,
  [SMALL_STATE(10257)] = 62733,
  [SMALL_STATE(10258)] = 62791,
  [SMALL_STATE(10259)] = 62849,
  [SMALL_STATE(10260)] = 62903,
  [SMALL_STATE(10261)] = 62957,
  [SMALL_STATE(10262)] = 63011,
  [SMALL_STATE(10263)] = 63069,
  [SMALL_STATE(10264)] = 63123,
  [SMALL_STATE(10265)] = 63179,
  [SMALL_STATE(10266)] = 63233,
  [SMALL_STATE(10267)] = 63287,
  [SMALL_STATE(10268)] = 63345,
  [SMALL_STATE(10269)] = 63415,
  [SMALL_STATE(10270)] = 63473,
  [SMALL_STATE(10271)] = 63537,
  [SMALL_STATE(10272)] = 63591,
  [SMALL_STATE(10273)] = 63651,
  [SMALL_STATE(10274)] = 63709,
  [SMALL_STATE(10275)] = 63767,
  [SMALL_STATE(10276)] = 63821,
  [SMALL_STATE(10277)] = 63875,
  [SMALL_STATE(10278)] = 63947,
  [SMALL_STATE(10279)] = 64001,
  [SMALL_STATE(10280)] = 64055,
  [SMALL_STATE(10281)] = 64109,
  [SMALL_STATE(10282)] = 64167,
  [SMALL_STATE(10283)] = 64221,
  [SMALL_STATE(10284)] = 64275,
  [SMALL_STATE(10285)] = 64333,
  [SMALL_STATE(10286)] = 64387,
  [SMALL_STATE(10287)] = 64445,
  [SMALL_STATE(10288)] = 64499,
  [SMALL_STATE(10289)] = 64553,
  [SMALL_STATE(10290)] = 64625,
  [SMALL_STATE(10291)] = 64679,
  [SMALL_STATE(10292)] = 64733,
  [SMALL_STATE(10293)] = 64787,
  [SMALL_STATE(10294)] = 64861,
  [SMALL_STATE(10295)] = 64919,
  [SMALL_STATE(10296)] = 64989,
  [SMALL_STATE(10297)] = 65043,
  [SMALL_STATE(10298)] = 65097,
  [SMALL_STATE(10299)] = 65169,
  [SMALL_STATE(10300)] = 65231,
  [SMALL_STATE(10301)] = 65287,
  [SMALL_STATE(10302)] = 65345,
  [SMALL_STATE(10303)] = 65417,
  [SMALL_STATE(10304)] = 65471,
  [SMALL_STATE(10305)] = 65529,
  [SMALL_STATE(10306)] = 65589,
  [SMALL_STATE(10307)] = 65643,
  [SMALL_STATE(10308)] = 65715,
  [SMALL_STATE(10309)] = 65769,
  [SMALL_STATE(10310)] = 65839,
  [SMALL_STATE(10311)] = 65911,
  [SMALL_STATE(10312)] = 65969,
  [SMALL_STATE(10313)] = 66023,
  [SMALL_STATE(10314)] = 66077,
  [SMALL_STATE(10315)] = 66149,
  [SMALL_STATE(10316)] = 66203,
  [SMALL_STATE(10317)] = 66261,
  [SMALL_STATE(10318)] = 66319,
  [SMALL_STATE(10319)] = 66373,
  [SMALL_STATE(10320)] = 66427,
  [SMALL_STATE(10321)] = 66499,
  [SMALL_STATE(10322)] = 66553,
  [SMALL_STATE(10323)] = 66607,
  [SMALL_STATE(10324)] = 66661,
  [SMALL_STATE(10325)] = 66733,
  [SMALL_STATE(10326)] = 66787,
  [SMALL_STATE(10327)] = 66855,
  [SMALL_STATE(10328)] = 66909,
  [SMALL_STATE(10329)] = 66963,
  [SMALL_STATE(10330)] = 67017,
  [SMALL_STATE(10331)] = 67071,
  [SMALL_STATE(10332)] = 67125,
  [SMALL_STATE(10333)] = 67185,
  [SMALL_STATE(10334)] = 67239,
  [SMALL_STATE(10335)] = 67297,
  [SMALL_STATE(10336)] = 67357,
  [SMALL_STATE(10337)] = 67415,
  [SMALL_STATE(10338)] = 67487,
  [SMALL_STATE(10339)] = 67545,
  [SMALL_STATE(10340)] = 67617,
  [SMALL_STATE(10341)] = 67691,
  [SMALL_STATE(10342)] = 67745,
  [SMALL_STATE(10343)] = 67817,
  [SMALL_STATE(10344)] = 67875,
  [SMALL_STATE(10345)] = 67949,
  [SMALL_STATE(10346)] = 68019,
  [SMALL_STATE(10347)] = 68093,
  [SMALL_STATE(10348)] = 68147,
  [SMALL_STATE(10349)] = 68201,
  [SMALL_STATE(10350)] = 68255,
  [SMALL_STATE(10351)] = 68309,
  [SMALL_STATE(10352)] = 68363,
  [SMALL_STATE(10353)] = 68435,
  [SMALL_STATE(10354)] = 68505,
  [SMALL_STATE(10355)] = 68559,
  [SMALL_STATE(10356)] = 68617,
  [SMALL_STATE(10357)] = 68671,
  [SMALL_STATE(10358)] = 68729,
  [SMALL_STATE(10359)] = 68789,
  [SMALL_STATE(10360)] = 68853,
  [SMALL_STATE(10361)] = 68911,
  [SMALL_STATE(10362)] = 68965,
  [SMALL_STATE(10363)] = 69019,
  [SMALL_STATE(10364)] = 69089,
  [SMALL_STATE(10365)] = 69143,
  [SMALL_STATE(10366)] = 69197,
  [SMALL_STATE(10367)] = 69251,
  [SMALL_STATE(10368)] = 69305,
  [SMALL_STATE(10369)] = 69375,
  [SMALL_STATE(10370)] = 69445,
  [SMALL_STATE(10371)] = 69519,
  [SMALL_STATE(10372)] = 69591,
  [SMALL_STATE(10373)] = 69661,
  [SMALL_STATE(10374)] = 69715,
  [SMALL_STATE(10375)] = 69769,
  [SMALL_STATE(10376)] = 69841,
  [SMALL_STATE(10377)] = 69895,
  [SMALL_STATE(10378)] = 69949,
  [SMALL_STATE(10379)] = 70021,
  [SMALL_STATE(10380)] = 70075,
  [SMALL_STATE(10381)] = 70129,
  [SMALL_STATE(10382)] = 70183,
  [SMALL_STATE(10383)] = 70236,
  [SMALL_STATE(10384)] = 70305,
  [SMALL_STATE(10385)] = 70358,
  [SMALL_STATE(10386)] = 70411,
  [SMALL_STATE(10387)] = 70464,
  [SMALL_STATE(10388)] = 70537,
  [SMALL_STATE(10389)] = 70590,
  [SMALL_STATE(10390)] = 70659,
  [SMALL_STATE(10391)] = 70732,
  [SMALL_STATE(10392)] = 70785,
  [SMALL_STATE(10393)] = 70838,
  [SMALL_STATE(10394)] = 70891,
  [SMALL_STATE(10395)] = 70944,
  [SMALL_STATE(10396)] = 70997,
  [SMALL_STATE(10397)] = 71050,
  [SMALL_STATE(10398)] = 71103,
  [SMALL_STATE(10399)] = 71156,
  [SMALL_STATE(10400)] = 71209,
  [SMALL_STATE(10401)] = 71262,
  [SMALL_STATE(10402)] = 71315,
  [SMALL_STATE(10403)] = 71388,
  [SMALL_STATE(10404)] = 71441,
  [SMALL_STATE(10405)] = 71514,
  [SMALL_STATE(10406)] = 71585,
  [SMALL_STATE(10407)] = 71656,
  [SMALL_STATE(10408)] = 71727,
  [SMALL_STATE(10409)] = 71796,
  [SMALL_STATE(10410)] = 71849,
  [SMALL_STATE(10411)] = 71902,
  [SMALL_STATE(10412)] = 71955,
  [SMALL_STATE(10413)] = 72008,
  [SMALL_STATE(10414)] = 72061,
  [SMALL_STATE(10415)] = 72114,
  [SMALL_STATE(10416)] = 72167,
  [SMALL_STATE(10417)] = 72238,
  [SMALL_STATE(10418)] = 72291,
  [SMALL_STATE(10419)] = 72344,
  [SMALL_STATE(10420)] = 72413,
  [SMALL_STATE(10421)] = 72472,
  [SMALL_STATE(10422)] = 72525,
  [SMALL_STATE(10423)] = 72578,
  [SMALL_STATE(10424)] = 72631,
  [SMALL_STATE(10425)] = 72704,
  [SMALL_STATE(10426)] = 72773,
  [SMALL_STATE(10427)] = 72844,
  [SMALL_STATE(10428)] = 72897,
  [SMALL_STATE(10429)] = 72950,
  [SMALL_STATE(10430)] = 73003,
  [SMALL_STATE(10431)] = 73062,
  [SMALL_STATE(10432)] = 73115,
  [SMALL_STATE(10433)] = 73168,
  [SMALL_STATE(10434)] = 73221,
  [SMALL_STATE(10435)] = 73274,
  [SMALL_STATE(10436)] = 73343,
  [SMALL_STATE(10437)] = 73412,
  [SMALL_STATE(10438)] = 73481,
  [SMALL_STATE(10439)] = 73534,
  [SMALL_STATE(10440)] = 73587,
  [SMALL_STATE(10441)] = 73640,
  [SMALL_STATE(10442)] = 73693,
  [SMALL_STATE(10443)] = 73746,
  [SMALL_STATE(10444)] = 73819,
  [SMALL_STATE(10445)] = 73872,
  [SMALL_STATE(10446)] = 73943,
  [SMALL_STATE(10447)] = 74014,
  [SMALL_STATE(10448)] = 74067,
  [SMALL_STATE(10449)] = 74120,
  [SMALL_STATE(10450)] = 74173,
  [SMALL_STATE(10451)] = 74226,
  [SMALL_STATE(10452)] = 74279,
  [SMALL_STATE(10453)] = 74332,
  [SMALL_STATE(10454)] = 74385,
  [SMALL_STATE(10455)] = 74438,
  [SMALL_STATE(10456)] = 74491,
  [SMALL_STATE(10457)] = 74562,
  [SMALL_STATE(10458)] = 74633,
  [SMALL_STATE(10459)] = 74704,
  [SMALL_STATE(10460)] = 74775,
  [SMALL_STATE(10461)] = 74846,
  [SMALL_STATE(10462)] = 74917,
  [SMALL_STATE(10463)] = 74970,
  [SMALL_STATE(10464)] = 75023,
  [SMALL_STATE(10465)] = 75076,
  [SMALL_STATE(10466)] = 75129,
  [SMALL_STATE(10467)] = 75182,
  [SMALL_STATE(10468)] = 75235,
  [SMALL_STATE(10469)] = 75288,
  [SMALL_STATE(10470)] = 75361,
  [SMALL_STATE(10471)] = 75414,
  [SMALL_STATE(10472)] = 75467,
  [SMALL_STATE(10473)] = 75520,
  [SMALL_STATE(10474)] = 75573,
  [SMALL_STATE(10475)] = 75644,
  [SMALL_STATE(10476)] = 75699,
  [SMALL_STATE(10477)] = 75752,
  [SMALL_STATE(10478)] = 75805,
  [SMALL_STATE(10479)] = 75858,
  [SMALL_STATE(10480)] = 75911,
  [SMALL_STATE(10481)] = 75980,
  [SMALL_STATE(10482)] = 76033,
  [SMALL_STATE(10483)] = 76086,
  [SMALL_STATE(10484)] = 76139,
  [SMALL_STATE(10485)] = 76192,
  [SMALL_STATE(10486)] = 76245,
  [SMALL_STATE(10487)] = 76298,
  [SMALL_STATE(10488)] = 76351,
  [SMALL_STATE(10489)] = 76404,
  [SMALL_STATE(10490)] = 76457,
  [SMALL_STATE(10491)] = 76510,
  [SMALL_STATE(10492)] = 76573,
  [SMALL_STATE(10493)] = 76626,
  [SMALL_STATE(10494)] = 76679,
  [SMALL_STATE(10495)] = 76732,
  [SMALL_STATE(10496)] = 76785,
  [SMALL_STATE(10497)] = 76838,
  [SMALL_STATE(10498)] = 76891,
  [SMALL_STATE(10499)] = 76944,
  [SMALL_STATE(10500)] = 77015,
  [SMALL_STATE(10501)] = 77068,
  [SMALL_STATE(10502)] = 77121,
  [SMALL_STATE(10503)] = 77180,
  [SMALL_STATE(10504)] = 77233,
  [SMALL_STATE(10505)] = 77304,
  [SMALL_STATE(10506)] = 77365,
  [SMALL_STATE(10507)] = 77424,
  [SMALL_STATE(10508)] = 77495,
  [SMALL_STATE(10509)] = 77548,
  [SMALL_STATE(10510)] = 77611,
  [SMALL_STATE(10511)] = 77664,
  [SMALL_STATE(10512)] = 77717,
  [SMALL_STATE(10513)] = 77770,
  [SMALL_STATE(10514)] = 77823,
  [SMALL_STATE(10515)] = 77894,
  [SMALL_STATE(10516)] = 77965,
  [SMALL_STATE(10517)] = 78018,
  [SMALL_STATE(10518)] = 78071,
  [SMALL_STATE(10519)] = 78124,
  [SMALL_STATE(10520)] = 78177,
  [SMALL_STATE(10521)] = 78230,
  [SMALL_STATE(10522)] = 78283,
  [SMALL_STATE(10523)] = 78336,
  [SMALL_STATE(10524)] = 78389,
  [SMALL_STATE(10525)] = 78442,
  [SMALL_STATE(10526)] = 78495,
  [SMALL_STATE(10527)] = 78548,
  [SMALL_STATE(10528)] = 78601,
  [SMALL_STATE(10529)] = 78654,
  [SMALL_STATE(10530)] = 78707,
  [SMALL_STATE(10531)] = 78778,
  [SMALL_STATE(10532)] = 78841,
  [SMALL_STATE(10533)] = 78894,
  [SMALL_STATE(10534)] = 78967,
  [SMALL_STATE(10535)] = 79038,
  [SMALL_STATE(10536)] = 79091,
  [SMALL_STATE(10537)] = 79144,
  [SMALL_STATE(10538)] = 79197,
  [SMALL_STATE(10539)] = 79250,
  [SMALL_STATE(10540)] = 79303,
  [SMALL_STATE(10541)] = 79376,
  [SMALL_STATE(10542)] = 79429,
  [SMALL_STATE(10543)] = 79484,
  [SMALL_STATE(10544)] = 79537,
  [SMALL_STATE(10545)] = 79599,
  [SMALL_STATE(10546)] = 79669,
  [SMALL_STATE(10547)] = 79725,
  [SMALL_STATE(10548)] = 79777,
  [SMALL_STATE(10549)] = 79829,
  [SMALL_STATE(10550)] = 79885,
  [SMALL_STATE(10551)] = 79941,
  [SMALL_STATE(10552)] = 79997,
  [SMALL_STATE(10553)] = 80067,
  [SMALL_STATE(10554)] = 80119,
  [SMALL_STATE(10555)] = 80171,
  [SMALL_STATE(10556)] = 80227,
  [SMALL_STATE(10557)] = 80279,
  [SMALL_STATE(10558)] = 80335,
  [SMALL_STATE(10559)] = 80407,
  [SMALL_STATE(10560)] = 80459,
  [SMALL_STATE(10561)] = 80529,
  [SMALL_STATE(10562)] = 80581,
  [SMALL_STATE(10563)] = 80637,
  [SMALL_STATE(10564)] = 80689,
  [SMALL_STATE(10565)] = 80741,
  [SMALL_STATE(10566)] = 80793,
  [SMALL_STATE(10567)] = 80863,
  [SMALL_STATE(10568)] = 80915,
  [SMALL_STATE(10569)] = 80967,
  [SMALL_STATE(10570)] = 81023,
  [SMALL_STATE(10571)] = 81077,
  [SMALL_STATE(10572)] = 81149,
  [SMALL_STATE(10573)] = 81211,
  [SMALL_STATE(10574)] = 81263,
  [SMALL_STATE(10575)] = 81315,
  [SMALL_STATE(10576)] = 81367,
  [SMALL_STATE(10577)] = 81419,
  [SMALL_STATE(10578)] = 81471,
  [SMALL_STATE(10579)] = 81523,
  [SMALL_STATE(10580)] = 81575,
  [SMALL_STATE(10581)] = 81627,
  [SMALL_STATE(10582)] = 81679,
  [SMALL_STATE(10583)] = 81731,
  [SMALL_STATE(10584)] = 81783,
  [SMALL_STATE(10585)] = 81837,
  [SMALL_STATE(10586)] = 81889,
  [SMALL_STATE(10587)] = 81945,
  [SMALL_STATE(10588)] = 81997,
  [SMALL_STATE(10589)] = 82057,
  [SMALL_STATE(10590)] = 82113,
  [SMALL_STATE(10591)] = 82169,
  [SMALL_STATE(10592)] = 82225,
  [SMALL_STATE(10593)] = 82277,
  [SMALL_STATE(10594)] = 82333,
  [SMALL_STATE(10595)] = 82389,
  [SMALL_STATE(10596)] = 82441,
  [SMALL_STATE(10597)] = 82493,
  [SMALL_STATE(10598)] = 82547,
  [SMALL_STATE(10599)] = 82603,
  [SMALL_STATE(10600)] = 82655,
  [SMALL_STATE(10601)] = 82725,
  [SMALL_STATE(10602)] = 82781,
  [SMALL_STATE(10603)] = 82833,
  [SMALL_STATE(10604)] = 82903,
  [SMALL_STATE(10605)] = 82959,
  [SMALL_STATE(10606)] = 83011,
  [SMALL_STATE(10607)] = 83067,
  [SMALL_STATE(10608)] = 83123,
  [SMALL_STATE(10609)] = 83179,
  [SMALL_STATE(10610)] = 83235,
  [SMALL_STATE(10611)] = 83305,
  [SMALL_STATE(10612)] = 83357,
  [SMALL_STATE(10613)] = 83413,
  [SMALL_STATE(10614)] = 83469,
  [SMALL_STATE(10615)] = 83521,
  [SMALL_STATE(10616)] = 83595,
  [SMALL_STATE(10617)] = 83667,
  [SMALL_STATE(10618)] = 83719,
  [SMALL_STATE(10619)] = 83775,
  [SMALL_STATE(10620)] = 83831,
  [SMALL_STATE(10621)] = 83883,
  [SMALL_STATE(10622)] = 83935,
  [SMALL_STATE(10623)] = 84005,
  [SMALL_STATE(10624)] = 84067,
  [SMALL_STATE(10625)] = 84129,
  [SMALL_STATE(10626)] = 84181,
  [SMALL_STATE(10627)] = 84233,
  [SMALL_STATE(10628)] = 84285,
  [SMALL_STATE(10629)] = 84341,
  [SMALL_STATE(10630)] = 84393,
  [SMALL_STATE(10631)] = 84463,
  [SMALL_STATE(10632)] = 84519,
  [SMALL_STATE(10633)] = 84575,
  [SMALL_STATE(10634)] = 84643,
  [SMALL_STATE(10635)] = 84699,
  [SMALL_STATE(10636)] = 84755,
  [SMALL_STATE(10637)] = 84811,
  [SMALL_STATE(10638)] = 84867,
  [SMALL_STATE(10639)] = 84929,
  [SMALL_STATE(10640)] = 84981,
  [SMALL_STATE(10641)] = 85049,
  [SMALL_STATE(10642)] = 85119,
  [SMALL_STATE(10643)] = 85171,
  [SMALL_STATE(10644)] = 85227,
  [SMALL_STATE(10645)] = 85283,
  [SMALL_STATE(10646)] = 85353,
  [SMALL_STATE(10647)] = 85409,
  [SMALL_STATE(10648)] = 85465,
  [SMALL_STATE(10649)] = 85535,
  [SMALL_STATE(10650)] = 85591,
  [SMALL_STATE(10651)] = 85647,
  [SMALL_STATE(10652)] = 85717,
  [SMALL_STATE(10653)] = 85769,
  [SMALL_STATE(10654)] = 85831,
  [SMALL_STATE(10655)] = 85887,
  [SMALL_STATE(10656)] = 85939,
  [SMALL_STATE(10657)] = 85991,
  [SMALL_STATE(10658)] = 86043,
  [SMALL_STATE(10659)] = 86095,
  [SMALL_STATE(10660)] = 86147,
  [SMALL_STATE(10661)] = 86199,
  [SMALL_STATE(10662)] = 86255,
  [SMALL_STATE(10663)] = 86313,
  [SMALL_STATE(10664)] = 86365,
  [SMALL_STATE(10665)] = 86417,
  [SMALL_STATE(10666)] = 86489,
  [SMALL_STATE(10667)] = 86559,
  [SMALL_STATE(10668)] = 86611,
  [SMALL_STATE(10669)] = 86663,
  [SMALL_STATE(10670)] = 86715,
  [SMALL_STATE(10671)] = 86767,
  [SMALL_STATE(10672)] = 86819,
  [SMALL_STATE(10673)] = 86871,
  [SMALL_STATE(10674)] = 86943,
  [SMALL_STATE(10675)] = 86995,
  [SMALL_STATE(10676)] = 87047,
  [SMALL_STATE(10677)] = 87105,
  [SMALL_STATE(10678)] = 87157,
  [SMALL_STATE(10679)] = 87215,
  [SMALL_STATE(10680)] = 87267,
  [SMALL_STATE(10681)] = 87319,
  [SMALL_STATE(10682)] = 87371,
  [SMALL_STATE(10683)] = 87423,
  [SMALL_STATE(10684)] = 87479,
  [SMALL_STATE(10685)] = 87534,
  [SMALL_STATE(10686)] = 87589,
  [SMALL_STATE(10687)] = 87644,
  [SMALL_STATE(10688)] = 87695,
  [SMALL_STATE(10689)] = 87750,
  [SMALL_STATE(10690)] = 87801,
  [SMALL_STATE(10691)] = 87870,
  [SMALL_STATE(10692)] = 87925,
  [SMALL_STATE(10693)] = 87980,
  [SMALL_STATE(10694)] = 88031,
  [SMALL_STATE(10695)] = 88082,
  [SMALL_STATE(10696)] = 88137,
  [SMALL_STATE(10697)] = 88192,
  [SMALL_STATE(10698)] = 88243,
  [SMALL_STATE(10699)] = 88298,
  [SMALL_STATE(10700)] = 88349,
  [SMALL_STATE(10701)] = 88404,
  [SMALL_STATE(10702)] = 88473,
  [SMALL_STATE(10703)] = 88524,
  [SMALL_STATE(10704)] = 88595,
  [SMALL_STATE(10705)] = 88664,
  [SMALL_STATE(10706)] = 88715,
  [SMALL_STATE(10707)] = 88770,
  [SMALL_STATE(10708)] = 88821,
  [SMALL_STATE(10709)] = 88876,
  [SMALL_STATE(10710)] = 88927,
  [SMALL_STATE(10711)] = 88982,
  [SMALL_STATE(10712)] = 89037,
  [SMALL_STATE(10713)] = 89088,
  [SMALL_STATE(10714)] = 89143,
  [SMALL_STATE(10715)] = 89194,
  [SMALL_STATE(10716)] = 89245,
  [SMALL_STATE(10717)] = 89296,
  [SMALL_STATE(10718)] = 89347,
  [SMALL_STATE(10719)] = 89402,
  [SMALL_STATE(10720)] = 89453,
  [SMALL_STATE(10721)] = 89504,
  [SMALL_STATE(10722)] = 89559,
  [SMALL_STATE(10723)] = 89628,
  [SMALL_STATE(10724)] = 89683,
  [SMALL_STATE(10725)] = 89734,
  [SMALL_STATE(10726)] = 89789,
  [SMALL_STATE(10727)] = 89844,
  [SMALL_STATE(10728)] = 89899,
  [SMALL_STATE(10729)] = 89950,
  [SMALL_STATE(10730)] = 90001,
  [SMALL_STATE(10731)] = 90056,
  [SMALL_STATE(10732)] = 90111,
  [SMALL_STATE(10733)] = 90162,
  [SMALL_STATE(10734)] = 90213,
  [SMALL_STATE(10735)] = 90268,
  [SMALL_STATE(10736)] = 90319,
  [SMALL_STATE(10737)] = 90370,
  [SMALL_STATE(10738)] = 90421,
  [SMALL_STATE(10739)] = 90476,
  [SMALL_STATE(10740)] = 90527,
  [SMALL_STATE(10741)] = 90578,
  [SMALL_STATE(10742)] = 90629,
  [SMALL_STATE(10743)] = 90684,
  [SMALL_STATE(10744)] = 90739,
  [SMALL_STATE(10745)] = 90794,
  [SMALL_STATE(10746)] = 90849,
  [SMALL_STATE(10747)] = 90904,
  [SMALL_STATE(10748)] = 90959,
  [SMALL_STATE(10749)] = 91014,
  [SMALL_STATE(10750)] = 91065,
  [SMALL_STATE(10751)] = 91116,
  [SMALL_STATE(10752)] = 91167,
  [SMALL_STATE(10753)] = 91238,
  [SMALL_STATE(10754)] = 91293,
  [SMALL_STATE(10755)] = 91348,
  [SMALL_STATE(10756)] = 91399,
  [SMALL_STATE(10757)] = 91458,
  [SMALL_STATE(10758)] = 91527,
  [SMALL_STATE(10759)] = 91582,
  [SMALL_STATE(10760)] = 91639,
  [SMALL_STATE(10761)] = 91690,
  [SMALL_STATE(10762)] = 91741,
  [SMALL_STATE(10763)] = 91796,
  [SMALL_STATE(10764)] = 91851,
  [SMALL_STATE(10765)] = 91906,
  [SMALL_STATE(10766)] = 91961,
  [SMALL_STATE(10767)] = 92016,
  [SMALL_STATE(10768)] = 92067,
  [SMALL_STATE(10769)] = 92118,
  [SMALL_STATE(10770)] = 92173,
  [SMALL_STATE(10771)] = 92242,
  [SMALL_STATE(10772)] = 92293,
  [SMALL_STATE(10773)] = 92348,
  [SMALL_STATE(10774)] = 92399,
  [SMALL_STATE(10775)] = 92454,
  [SMALL_STATE(10776)] = 92505,
  [SMALL_STATE(10777)] = 92560,
  [SMALL_STATE(10778)] = 92611,
  [SMALL_STATE(10779)] = 92666,
  [SMALL_STATE(10780)] = 92717,
  [SMALL_STATE(10781)] = 92772,
  [SMALL_STATE(10782)] = 92823,
  [SMALL_STATE(10783)] = 92878,
  [SMALL_STATE(10784)] = 92929,
  [SMALL_STATE(10785)] = 92980,
  [SMALL_STATE(10786)] = 93031,
  [SMALL_STATE(10787)] = 93082,
  [SMALL_STATE(10788)] = 93153,
  [SMALL_STATE(10789)] = 93208,
  [SMALL_STATE(10790)] = 93259,
  [SMALL_STATE(10791)] = 93310,
  [SMALL_STATE(10792)] = 93361,
  [SMALL_STATE(10793)] = 93412,
  [SMALL_STATE(10794)] = 93463,
  [SMALL_STATE(10795)] = 93518,
  [SMALL_STATE(10796)] = 93569,
  [SMALL_STATE(10797)] = 93620,
  [SMALL_STATE(10798)] = 93675,
  [SMALL_STATE(10799)] = 93726,
  [SMALL_STATE(10800)] = 93777,
  [SMALL_STATE(10801)] = 93832,
  [SMALL_STATE(10802)] = 93883,
  [SMALL_STATE(10803)] = 93934,
  [SMALL_STATE(10804)] = 94003,
  [SMALL_STATE(10805)] = 94054,
  [SMALL_STATE(10806)] = 94109,
  [SMALL_STATE(10807)] = 94160,
  [SMALL_STATE(10808)] = 94211,
  [SMALL_STATE(10809)] = 94280,
  [SMALL_STATE(10810)] = 94331,
  [SMALL_STATE(10811)] = 94382,
  [SMALL_STATE(10812)] = 94433,
  [SMALL_STATE(10813)] = 94486,
  [SMALL_STATE(10814)] = 94537,
  [SMALL_STATE(10815)] = 94588,
  [SMALL_STATE(10816)] = 94639,
  [SMALL_STATE(10817)] = 94690,
  [SMALL_STATE(10818)] = 94741,
  [SMALL_STATE(10819)] = 94792,
  [SMALL_STATE(10820)] = 94847,
  [SMALL_STATE(10821)] = 94898,
  [SMALL_STATE(10822)] = 94949,
  [SMALL_STATE(10823)] = 95004,
  [SMALL_STATE(10824)] = 95055,
  [SMALL_STATE(10825)] = 95106,
  [SMALL_STATE(10826)] = 95177,
  [SMALL_STATE(10827)] = 95228,
  [SMALL_STATE(10828)] = 95279,
  [SMALL_STATE(10829)] = 95334,
  [SMALL_STATE(10830)] = 95389,
  [SMALL_STATE(10831)] = 95444,
  [SMALL_STATE(10832)] = 95513,
  [SMALL_STATE(10833)] = 95564,
  [SMALL_STATE(10834)] = 95615,
  [SMALL_STATE(10835)] = 95666,
  [SMALL_STATE(10836)] = 95721,
  [SMALL_STATE(10837)] = 95772,
  [SMALL_STATE(10838)] = 95823,
  [SMALL_STATE(10839)] = 95874,
  [SMALL_STATE(10840)] = 95945,
  [SMALL_STATE(10841)] = 96036,
  [SMALL_STATE(10842)] = 96087,
  [SMALL_STATE(10843)] = 96142,
  [SMALL_STATE(10844)] = 96197,
  [SMALL_STATE(10845)] = 96252,
  [SMALL_STATE(10846)] = 96303,
  [SMALL_STATE(10847)] = 96354,
  [SMALL_STATE(10848)] = 96409,
  [SMALL_STATE(10849)] = 96464,
  [SMALL_STATE(10850)] = 96552,
  [SMALL_STATE(10851)] = 96606,
  [SMALL_STATE(10852)] = 96656,
  [SMALL_STATE(10853)] = 96706,
  [SMALL_STATE(10854)] = 96760,
  [SMALL_STATE(10855)] = 96830,
  [SMALL_STATE(10856)] = 96880,
  [SMALL_STATE(10857)] = 96930,
  [SMALL_STATE(10858)] = 96980,
  [SMALL_STATE(10859)] = 97030,
  [SMALL_STATE(10860)] = 97118,
  [SMALL_STATE(10861)] = 97168,
  [SMALL_STATE(10862)] = 97218,
  [SMALL_STATE(10863)] = 97268,
  [SMALL_STATE(10864)] = 97318,
  [SMALL_STATE(10865)] = 97368,
  [SMALL_STATE(10866)] = 97418,
  [SMALL_STATE(10867)] = 97468,
  [SMALL_STATE(10868)] = 97538,
  [SMALL_STATE(10869)] = 97590,
  [SMALL_STATE(10870)] = 97678,
  [SMALL_STATE(10871)] = 97728,
  [SMALL_STATE(10872)] = 97778,
  [SMALL_STATE(10873)] = 97828,
  [SMALL_STATE(10874)] = 97878,
  [SMALL_STATE(10875)] = 97928,
  [SMALL_STATE(10876)] = 97978,
  [SMALL_STATE(10877)] = 98028,
  [SMALL_STATE(10878)] = 98098,
  [SMALL_STATE(10879)] = 98148,
  [SMALL_STATE(10880)] = 98236,
  [SMALL_STATE(10881)] = 98286,
  [SMALL_STATE(10882)] = 98336,
  [SMALL_STATE(10883)] = 98386,
  [SMALL_STATE(10884)] = 98474,
  [SMALL_STATE(10885)] = 98562,
  [SMALL_STATE(10886)] = 98632,
  [SMALL_STATE(10887)] = 98720,
  [SMALL_STATE(10888)] = 98790,
  [SMALL_STATE(10889)] = 98878,
  [SMALL_STATE(10890)] = 98948,
  [SMALL_STATE(10891)] = 99036,
  [SMALL_STATE(10892)] = 99106,
  [SMALL_STATE(10893)] = 99194,
  [SMALL_STATE(10894)] = 99264,
  [SMALL_STATE(10895)] = 99352,
  [SMALL_STATE(10896)] = 99422,
  [SMALL_STATE(10897)] = 99510,
  [SMALL_STATE(10898)] = 99580,
  [SMALL_STATE(10899)] = 99668,
  [SMALL_STATE(10900)] = 99738,
  [SMALL_STATE(10901)] = 99826,
  [SMALL_STATE(10902)] = 99896,
  [SMALL_STATE(10903)] = 99984,
  [SMALL_STATE(10904)] = 100054,
  [SMALL_STATE(10905)] = 100142,
  [SMALL_STATE(10906)] = 100196,
  [SMALL_STATE(10907)] = 100266,
  [SMALL_STATE(10908)] = 100320,
  [SMALL_STATE(10909)] = 100374,
  [SMALL_STATE(10910)] = 100428,
  [SMALL_STATE(10911)] = 100516,
  [SMALL_STATE(10912)] = 100568,
  [SMALL_STATE(10913)] = 100622,
  [SMALL_STATE(10914)] = 100676,
  [SMALL_STATE(10915)] = 100746,
  [SMALL_STATE(10916)] = 100800,
  [SMALL_STATE(10917)] = 100854,
  [SMALL_STATE(10918)] = 100942,
  [SMALL_STATE(10919)] = 101012,
  [SMALL_STATE(10920)] = 101100,
  [SMALL_STATE(10921)] = 101154,
  [SMALL_STATE(10922)] = 101224,
  [SMALL_STATE(10923)] = 101312,
  [SMALL_STATE(10924)] = 101362,
  [SMALL_STATE(10925)] = 101432,
  [SMALL_STATE(10926)] = 101520,
  [SMALL_STATE(10927)] = 101590,
  [SMALL_STATE(10928)] = 101678,
  [SMALL_STATE(10929)] = 101738,
  [SMALL_STATE(10930)] = 101792,
  [SMALL_STATE(10931)] = 101862,
  [SMALL_STATE(10932)] = 101916,
  [SMALL_STATE(10933)] = 102004,
  [SMALL_STATE(10934)] = 102058,
  [SMALL_STATE(10935)] = 102128,
  [SMALL_STATE(10936)] = 102198,
  [SMALL_STATE(10937)] = 102252,
  [SMALL_STATE(10938)] = 102306,
  [SMALL_STATE(10939)] = 102394,
  [SMALL_STATE(10940)] = 102448,
  [SMALL_STATE(10941)] = 102518,
  [SMALL_STATE(10942)] = 102606,
  [SMALL_STATE(10943)] = 102676,
  [SMALL_STATE(10944)] = 102764,
  [SMALL_STATE(10945)] = 102834,
  [SMALL_STATE(10946)] = 102904,
  [SMALL_STATE(10947)] = 102992,
  [SMALL_STATE(10948)] = 103062,
  [SMALL_STATE(10949)] = 103132,
  [SMALL_STATE(10950)] = 103202,
  [SMALL_STATE(10951)] = 103290,
  [SMALL_STATE(10952)] = 103360,
  [SMALL_STATE(10953)] = 103448,
  [SMALL_STATE(10954)] = 103506,
  [SMALL_STATE(10955)] = 103558,
  [SMALL_STATE(10956)] = 103610,
  [SMALL_STATE(10957)] = 103664,
  [SMALL_STATE(10958)] = 103718,
  [SMALL_STATE(10959)] = 103788,
  [SMALL_STATE(10960)] = 103876,
  [SMALL_STATE(10961)] = 103930,
  [SMALL_STATE(10962)] = 103984,
  [SMALL_STATE(10963)] = 104054,
  [SMALL_STATE(10964)] = 104142,
  [SMALL_STATE(10965)] = 104194,
  [SMALL_STATE(10966)] = 104282,
  [SMALL_STATE(10967)] = 104370,
  [SMALL_STATE(10968)] = 104458,
  [SMALL_STATE(10969)] = 104528,
  [SMALL_STATE(10970)] = 104616,
  [SMALL_STATE(10971)] = 104704,
  [SMALL_STATE(10972)] = 104792,
  [SMALL_STATE(10973)] = 104880,
  [SMALL_STATE(10974)] = 104932,
  [SMALL_STATE(10975)] = 105020,
  [SMALL_STATE(10976)] = 105108,
  [SMALL_STATE(10977)] = 105196,
  [SMALL_STATE(10978)] = 105284,
  [SMALL_STATE(10979)] = 105372,
  [SMALL_STATE(10980)] = 105460,
  [SMALL_STATE(10981)] = 105514,
  [SMALL_STATE(10982)] = 105602,
  [SMALL_STATE(10983)] = 105654,
  [SMALL_STATE(10984)] = 105742,
  [SMALL_STATE(10985)] = 105830,
  [SMALL_STATE(10986)] = 105918,
  [SMALL_STATE(10987)] = 106006,
  [SMALL_STATE(10988)] = 106076,
  [SMALL_STATE(10989)] = 106164,
  [SMALL_STATE(10990)] = 106252,
  [SMALL_STATE(10991)] = 106340,
  [SMALL_STATE(10992)] = 106428,
  [SMALL_STATE(10993)] = 106496,
  [SMALL_STATE(10994)] = 106584,
  [SMALL_STATE(10995)] = 106638,
  [SMALL_STATE(10996)] = 106692,
  [SMALL_STATE(10997)] = 106780,
  [SMALL_STATE(10998)] = 106834,
  [SMALL_STATE(10999)] = 106888,
  [SMALL_STATE(11000)] = 106976,
  [SMALL_STATE(11001)] = 107064,
  [SMALL_STATE(11002)] = 107152,
  [SMALL_STATE(11003)] = 107240,
  [SMALL_STATE(11004)] = 107328,
  [SMALL_STATE(11005)] = 107416,
  [SMALL_STATE(11006)] = 107486,
  [SMALL_STATE(11007)] = 107574,
  [SMALL_STATE(11008)] = 107662,
  [SMALL_STATE(11009)] = 107750,
  [SMALL_STATE(11010)] = 107838,
  [SMALL_STATE(11011)] = 107926,
  [SMALL_STATE(11012)] = 108014,
  [SMALL_STATE(11013)] = 108102,
  [SMALL_STATE(11014)] = 108190,
  [SMALL_STATE(11015)] = 108278,
  [SMALL_STATE(11016)] = 108366,
  [SMALL_STATE(11017)] = 108454,
  [SMALL_STATE(11018)] = 108542,
  [SMALL_STATE(11019)] = 108630,
  [SMALL_STATE(11020)] = 108718,
  [SMALL_STATE(11021)] = 108806,
  [SMALL_STATE(11022)] = 108894,
  [SMALL_STATE(11023)] = 108982,
  [SMALL_STATE(11024)] = 109052,
  [SMALL_STATE(11025)] = 109104,
  [SMALL_STATE(11026)] = 109192,
  [SMALL_STATE(11027)] = 109262,
  [SMALL_STATE(11028)] = 109332,
  [SMALL_STATE(11029)] = 109402,
  [SMALL_STATE(11030)] = 109472,
  [SMALL_STATE(11031)] = 109526,
  [SMALL_STATE(11032)] = 109578,
  [SMALL_STATE(11033)] = 109646,
  [SMALL_STATE(11034)] = 109716,
  [SMALL_STATE(11035)] = 109786,
  [SMALL_STATE(11036)] = 109856,
  [SMALL_STATE(11037)] = 109924,
  [SMALL_STATE(11038)] = 109994,
  [SMALL_STATE(11039)] = 110050,
  [SMALL_STATE(11040)] = 110120,
  [SMALL_STATE(11041)] = 110190,
  [SMALL_STATE(11042)] = 110278,
  [SMALL_STATE(11043)] = 110328,
  [SMALL_STATE(11044)] = 110378,
  [SMALL_STATE(11045)] = 110466,
  [SMALL_STATE(11046)] = 110516,
  [SMALL_STATE(11047)] = 110568,
  [SMALL_STATE(11048)] = 110622,
  [SMALL_STATE(11049)] = 110676,
  [SMALL_STATE(11050)] = 110726,
  [SMALL_STATE(11051)] = 110776,
  [SMALL_STATE(11052)] = 110830,
  [SMALL_STATE(11053)] = 110884,
  [SMALL_STATE(11054)] = 110938,
  [SMALL_STATE(11055)] = 110992,
  [SMALL_STATE(11056)] = 111046,
  [SMALL_STATE(11057)] = 111100,
  [SMALL_STATE(11058)] = 111170,
  [SMALL_STATE(11059)] = 111258,
  [SMALL_STATE(11060)] = 111346,
  [SMALL_STATE(11061)] = 111434,
  [SMALL_STATE(11062)] = 111522,
  [SMALL_STATE(11063)] = 111610,
  [SMALL_STATE(11064)] = 111698,
  [SMALL_STATE(11065)] = 111786,
  [SMALL_STATE(11066)] = 111874,
  [SMALL_STATE(11067)] = 111962,
  [SMALL_STATE(11068)] = 112050,
  [SMALL_STATE(11069)] = 112138,
  [SMALL_STATE(11070)] = 112208,
  [SMALL_STATE(11071)] = 112262,
  [SMALL_STATE(11072)] = 112316,
  [SMALL_STATE(11073)] = 112370,
  [SMALL_STATE(11074)] = 112424,
  [SMALL_STATE(11075)] = 112512,
  [SMALL_STATE(11076)] = 112600,
  [SMALL_STATE(11077)] = 112688,
  [SMALL_STATE(11078)] = 112776,
  [SMALL_STATE(11079)] = 112864,
  [SMALL_STATE(11080)] = 112952,
  [SMALL_STATE(11081)] = 113040,
  [SMALL_STATE(11082)] = 113128,
  [SMALL_STATE(11083)] = 113216,
  [SMALL_STATE(11084)] = 113304,
  [SMALL_STATE(11085)] = 113392,
  [SMALL_STATE(11086)] = 113480,
  [SMALL_STATE(11087)] = 113568,
  [SMALL_STATE(11088)] = 113656,
  [SMALL_STATE(11089)] = 113744,
  [SMALL_STATE(11090)] = 113798,
  [SMALL_STATE(11091)] = 113852,
  [SMALL_STATE(11092)] = 113906,
  [SMALL_STATE(11093)] = 113960,
  [SMALL_STATE(11094)] = 114048,
  [SMALL_STATE(11095)] = 114136,
  [SMALL_STATE(11096)] = 114224,
  [SMALL_STATE(11097)] = 114312,
  [SMALL_STATE(11098)] = 114366,
  [SMALL_STATE(11099)] = 114420,
  [SMALL_STATE(11100)] = 114474,
  [SMALL_STATE(11101)] = 114528,
  [SMALL_STATE(11102)] = 114616,
  [SMALL_STATE(11103)] = 114704,
  [SMALL_STATE(11104)] = 114792,
  [SMALL_STATE(11105)] = 114880,
  [SMALL_STATE(11106)] = 114968,
  [SMALL_STATE(11107)] = 115056,
  [SMALL_STATE(11108)] = 115144,
  [SMALL_STATE(11109)] = 115232,
  [SMALL_STATE(11110)] = 115320,
  [SMALL_STATE(11111)] = 115370,
  [SMALL_STATE(11112)] = 115420,
  [SMALL_STATE(11113)] = 115470,
  [SMALL_STATE(11114)] = 115520,
  [SMALL_STATE(11115)] = 115570,
  [SMALL_STATE(11116)] = 115620,
  [SMALL_STATE(11117)] = 115690,
  [SMALL_STATE(11118)] = 115758,
  [SMALL_STATE(11119)] = 115808,
  [SMALL_STATE(11120)] = 115876,
  [SMALL_STATE(11121)] = 115926,
  [SMALL_STATE(11122)] = 115976,
  [SMALL_STATE(11123)] = 116064,
  [SMALL_STATE(11124)] = 116152,
  [SMALL_STATE(11125)] = 116202,
  [SMALL_STATE(11126)] = 116252,
  [SMALL_STATE(11127)] = 116302,
  [SMALL_STATE(11128)] = 116352,
  [SMALL_STATE(11129)] = 116402,
  [SMALL_STATE(11130)] = 116452,
  [SMALL_STATE(11131)] = 116502,
  [SMALL_STATE(11132)] = 116552,
  [SMALL_STATE(11133)] = 116602,
  [SMALL_STATE(11134)] = 116652,
  [SMALL_STATE(11135)] = 116702,
  [SMALL_STATE(11136)] = 116752,
  [SMALL_STATE(11137)] = 116822,
  [SMALL_STATE(11138)] = 116872,
  [SMALL_STATE(11139)] = 116922,
  [SMALL_STATE(11140)] = 116972,
  [SMALL_STATE(11141)] = 117042,
  [SMALL_STATE(11142)] = 117092,
  [SMALL_STATE(11143)] = 117142,
  [SMALL_STATE(11144)] = 117192,
  [SMALL_STATE(11145)] = 117242,
  [SMALL_STATE(11146)] = 117292,
  [SMALL_STATE(11147)] = 117380,
  [SMALL_STATE(11148)] = 117430,
  [SMALL_STATE(11149)] = 117480,
  [SMALL_STATE(11150)] = 117530,
  [SMALL_STATE(11151)] = 117580,
  [SMALL_STATE(11152)] = 117668,
  [SMALL_STATE(11153)] = 117756,
  [SMALL_STATE(11154)] = 117844,
  [SMALL_STATE(11155)] = 117932,
  [SMALL_STATE(11156)] = 118020,
  [SMALL_STATE(11157)] = 118108,
  [SMALL_STATE(11158)] = 118168,
  [SMALL_STATE(11159)] = 118228,
  [SMALL_STATE(11160)] = 118316,
  [SMALL_STATE(11161)] = 118404,
  [SMALL_STATE(11162)] = 118492,
  [SMALL_STATE(11163)] = 118580,
  [SMALL_STATE(11164)] = 118668,
  [SMALL_STATE(11165)] = 118756,
  [SMALL_STATE(11166)] = 118844,
  [SMALL_STATE(11167)] = 118932,
  [SMALL_STATE(11168)] = 119020,
  [SMALL_STATE(11169)] = 119108,
  [SMALL_STATE(11170)] = 119196,
  [SMALL_STATE(11171)] = 119284,
  [SMALL_STATE(11172)] = 119372,
  [SMALL_STATE(11173)] = 119460,
  [SMALL_STATE(11174)] = 119548,
  [SMALL_STATE(11175)] = 119598,
  [SMALL_STATE(11176)] = 119650,
  [SMALL_STATE(11177)] = 119720,
  [SMALL_STATE(11178)] = 119808,
  [SMALL_STATE(11179)] = 119876,
  [SMALL_STATE(11180)] = 119930,
  [SMALL_STATE(11181)] = 119980,
  [SMALL_STATE(11182)] = 120050,
  [SMALL_STATE(11183)] = 120100,
  [SMALL_STATE(11184)] = 120150,
  [SMALL_STATE(11185)] = 120200,
  [SMALL_STATE(11186)] = 120250,
  [SMALL_STATE(11187)] = 120304,
  [SMALL_STATE(11188)] = 120392,
  [SMALL_STATE(11189)] = 120441,
  [SMALL_STATE(11190)] = 120490,
  [SMALL_STATE(11191)] = 120539,
  [SMALL_STATE(11192)] = 120588,
  [SMALL_STATE(11193)] = 120641,
  [SMALL_STATE(11194)] = 120692,
  [SMALL_STATE(11195)] = 120745,
  [SMALL_STATE(11196)] = 120798,
  [SMALL_STATE(11197)] = 120847,
  [SMALL_STATE(11198)] = 120900,
  [SMALL_STATE(11199)] = 120949,
  [SMALL_STATE(11200)] = 120998,
  [SMALL_STATE(11201)] = 121047,
  [SMALL_STATE(11202)] = 121100,
  [SMALL_STATE(11203)] = 121149,
  [SMALL_STATE(11204)] = 121202,
  [SMALL_STATE(11205)] = 121251,
  [SMALL_STATE(11206)] = 121300,
  [SMALL_STATE(11207)] = 121349,
  [SMALL_STATE(11208)] = 121408,
  [SMALL_STATE(11209)] = 121457,
  [SMALL_STATE(11210)] = 121506,
  [SMALL_STATE(11211)] = 121555,
  [SMALL_STATE(11212)] = 121604,
  [SMALL_STATE(11213)] = 121653,
  [SMALL_STATE(11214)] = 121702,
  [SMALL_STATE(11215)] = 121751,
  [SMALL_STATE(11216)] = 121800,
  [SMALL_STATE(11217)] = 121849,
  [SMALL_STATE(11218)] = 121898,
  [SMALL_STATE(11219)] = 121947,
  [SMALL_STATE(11220)] = 121996,
  [SMALL_STATE(11221)] = 122045,
  [SMALL_STATE(11222)] = 122094,
  [SMALL_STATE(11223)] = 122143,
  [SMALL_STATE(11224)] = 122192,
  [SMALL_STATE(11225)] = 122241,
  [SMALL_STATE(11226)] = 122290,
  [SMALL_STATE(11227)] = 122339,
  [SMALL_STATE(11228)] = 122388,
  [SMALL_STATE(11229)] = 122437,
  [SMALL_STATE(11230)] = 122486,
  [SMALL_STATE(11231)] = 122535,
  [SMALL_STATE(11232)] = 122584,
  [SMALL_STATE(11233)] = 122633,
  [SMALL_STATE(11234)] = 122686,
  [SMALL_STATE(11235)] = 122735,
  [SMALL_STATE(11236)] = 122784,
  [SMALL_STATE(11237)] = 122833,
  [SMALL_STATE(11238)] = 122882,
  [SMALL_STATE(11239)] = 122931,
  [SMALL_STATE(11240)] = 122980,
  [SMALL_STATE(11241)] = 123029,
  [SMALL_STATE(11242)] = 123078,
  [SMALL_STATE(11243)] = 123127,
  [SMALL_STATE(11244)] = 123176,
  [SMALL_STATE(11245)] = 123225,
  [SMALL_STATE(11246)] = 123278,
  [SMALL_STATE(11247)] = 123331,
  [SMALL_STATE(11248)] = 123380,
  [SMALL_STATE(11249)] = 123429,
  [SMALL_STATE(11250)] = 123478,
  [SMALL_STATE(11251)] = 123527,
  [SMALL_STATE(11252)] = 123576,
  [SMALL_STATE(11253)] = 123629,
  [SMALL_STATE(11254)] = 123678,
  [SMALL_STATE(11255)] = 123731,
  [SMALL_STATE(11256)] = 123780,
  [SMALL_STATE(11257)] = 123829,
  [SMALL_STATE(11258)] = 123878,
  [SMALL_STATE(11259)] = 123927,
  [SMALL_STATE(11260)] = 123976,
  [SMALL_STATE(11261)] = 124025,
  [SMALL_STATE(11262)] = 124078,
  [SMALL_STATE(11263)] = 124127,
  [SMALL_STATE(11264)] = 124176,
  [SMALL_STATE(11265)] = 124229,
  [SMALL_STATE(11266)] = 124282,
  [SMALL_STATE(11267)] = 124335,
  [SMALL_STATE(11268)] = 124388,
  [SMALL_STATE(11269)] = 124437,
  [SMALL_STATE(11270)] = 124496,
  [SMALL_STATE(11271)] = 124545,
  [SMALL_STATE(11272)] = 124598,
  [SMALL_STATE(11273)] = 124647,
  [SMALL_STATE(11274)] = 124700,
  [SMALL_STATE(11275)] = 124753,
  [SMALL_STATE(11276)] = 124812,
  [SMALL_STATE(11277)] = 124861,
  [SMALL_STATE(11278)] = 124914,
  [SMALL_STATE(11279)] = 124963,
  [SMALL_STATE(11280)] = 125012,
  [SMALL_STATE(11281)] = 125061,
  [SMALL_STATE(11282)] = 125110,
  [SMALL_STATE(11283)] = 125159,
  [SMALL_STATE(11284)] = 125208,
  [SMALL_STATE(11285)] = 125257,
  [SMALL_STATE(11286)] = 125306,
  [SMALL_STATE(11287)] = 125355,
  [SMALL_STATE(11288)] = 125408,
  [SMALL_STATE(11289)] = 125457,
  [SMALL_STATE(11290)] = 125506,
  [SMALL_STATE(11291)] = 125555,
  [SMALL_STATE(11292)] = 125604,
  [SMALL_STATE(11293)] = 125653,
  [SMALL_STATE(11294)] = 125702,
  [SMALL_STATE(11295)] = 125755,
  [SMALL_STATE(11296)] = 125804,
  [SMALL_STATE(11297)] = 125853,
  [SMALL_STATE(11298)] = 125902,
  [SMALL_STATE(11299)] = 125955,
  [SMALL_STATE(11300)] = 126004,
  [SMALL_STATE(11301)] = 126055,
  [SMALL_STATE(11302)] = 126104,
  [SMALL_STATE(11303)] = 126153,
  [SMALL_STATE(11304)] = 126202,
  [SMALL_STATE(11305)] = 126255,
  [SMALL_STATE(11306)] = 126304,
  [SMALL_STATE(11307)] = 126353,
  [SMALL_STATE(11308)] = 126406,
  [SMALL_STATE(11309)] = 126455,
  [SMALL_STATE(11310)] = 126504,
  [SMALL_STATE(11311)] = 126573,
  [SMALL_STATE(11312)] = 126622,
  [SMALL_STATE(11313)] = 126671,
  [SMALL_STATE(11314)] = 126720,
  [SMALL_STATE(11315)] = 126769,
  [SMALL_STATE(11316)] = 126818,
  [SMALL_STATE(11317)] = 126867,
  [SMALL_STATE(11318)] = 126916,
  [SMALL_STATE(11319)] = 126983,
  [SMALL_STATE(11320)] = 127036,
  [SMALL_STATE(11321)] = 127089,
  [SMALL_STATE(11322)] = 127142,
  [SMALL_STATE(11323)] = 127195,
  [SMALL_STATE(11324)] = 127248,
  [SMALL_STATE(11325)] = 127307,
  [SMALL_STATE(11326)] = 127356,
  [SMALL_STATE(11327)] = 127405,
  [SMALL_STATE(11328)] = 127458,
  [SMALL_STATE(11329)] = 127527,
  [SMALL_STATE(11330)] = 127576,
  [SMALL_STATE(11331)] = 127635,
  [SMALL_STATE(11332)] = 127694,
  [SMALL_STATE(11333)] = 127743,
  [SMALL_STATE(11334)] = 127792,
  [SMALL_STATE(11335)] = 127841,
  [SMALL_STATE(11336)] = 127890,
  [SMALL_STATE(11337)] = 127939,
  [SMALL_STATE(11338)] = 127998,
  [SMALL_STATE(11339)] = 128047,
  [SMALL_STATE(11340)] = 128096,
  [SMALL_STATE(11341)] = 128145,
  [SMALL_STATE(11342)] = 128194,
  [SMALL_STATE(11343)] = 128253,
  [SMALL_STATE(11344)] = 128302,
  [SMALL_STATE(11345)] = 128353,
  [SMALL_STATE(11346)] = 128402,
  [SMALL_STATE(11347)] = 128453,
  [SMALL_STATE(11348)] = 128504,
  [SMALL_STATE(11349)] = 128553,
  [SMALL_STATE(11350)] = 128602,
  [SMALL_STATE(11351)] = 128651,
  [SMALL_STATE(11352)] = 128700,
  [SMALL_STATE(11353)] = 128749,
  [SMALL_STATE(11354)] = 128798,
  [SMALL_STATE(11355)] = 128847,
  [SMALL_STATE(11356)] = 128896,
  [SMALL_STATE(11357)] = 128945,
  [SMALL_STATE(11358)] = 128994,
  [SMALL_STATE(11359)] = 129043,
  [SMALL_STATE(11360)] = 129092,
  [SMALL_STATE(11361)] = 129141,
  [SMALL_STATE(11362)] = 129208,
  [SMALL_STATE(11363)] = 129257,
  [SMALL_STATE(11364)] = 129306,
  [SMALL_STATE(11365)] = 129355,
  [SMALL_STATE(11366)] = 129404,
  [SMALL_STATE(11367)] = 129453,
  [SMALL_STATE(11368)] = 129502,
  [SMALL_STATE(11369)] = 129551,
  [SMALL_STATE(11370)] = 129600,
  [SMALL_STATE(11371)] = 129649,
  [SMALL_STATE(11372)] = 129698,
  [SMALL_STATE(11373)] = 129751,
  [SMALL_STATE(11374)] = 129804,
  [SMALL_STATE(11375)] = 129857,
  [SMALL_STATE(11376)] = 129906,
  [SMALL_STATE(11377)] = 129959,
  [SMALL_STATE(11378)] = 130018,
  [SMALL_STATE(11379)] = 130071,
  [SMALL_STATE(11380)] = 130120,
  [SMALL_STATE(11381)] = 130170,
  [SMALL_STATE(11382)] = 130222,
  [SMALL_STATE(11383)] = 130274,
  [SMALL_STATE(11384)] = 130332,
  [SMALL_STATE(11385)] = 130384,
  [SMALL_STATE(11386)] = 130436,
  [SMALL_STATE(11387)] = 130488,
  [SMALL_STATE(11388)] = 130540,
  [SMALL_STATE(11389)] = 130592,
  [SMALL_STATE(11390)] = 130644,
  [SMALL_STATE(11391)] = 130696,
  [SMALL_STATE(11392)] = 130748,
  [SMALL_STATE(11393)] = 130800,
  [SMALL_STATE(11394)] = 130852,
  [SMALL_STATE(11395)] = 130900,
  [SMALL_STATE(11396)] = 130952,
  [SMALL_STATE(11397)] = 131004,
  [SMALL_STATE(11398)] = 131056,
  [SMALL_STATE(11399)] = 131122,
  [SMALL_STATE(11400)] = 131174,
  [SMALL_STATE(11401)] = 131226,
  [SMALL_STATE(11402)] = 131274,
  [SMALL_STATE(11403)] = 131322,
  [SMALL_STATE(11404)] = 131380,
  [SMALL_STATE(11405)] = 131432,
  [SMALL_STATE(11406)] = 131490,
  [SMALL_STATE(11407)] = 131542,
  [SMALL_STATE(11408)] = 131594,
  [SMALL_STATE(11409)] = 131646,
  [SMALL_STATE(11410)] = 131698,
  [SMALL_STATE(11411)] = 131748,
  [SMALL_STATE(11412)] = 131798,
  [SMALL_STATE(11413)] = 131846,
  [SMALL_STATE(11414)] = 131894,
  [SMALL_STATE(11415)] = 131946,
  [SMALL_STATE(11416)] = 131998,
  [SMALL_STATE(11417)] = 132056,
  [SMALL_STATE(11418)] = 132114,
  [SMALL_STATE(11419)] = 132172,
  [SMALL_STATE(11420)] = 132222,
  [SMALL_STATE(11421)] = 132280,
  [SMALL_STATE(11422)] = 132338,
  [SMALL_STATE(11423)] = 132396,
  [SMALL_STATE(11424)] = 132448,
  [SMALL_STATE(11425)] = 132500,
  [SMALL_STATE(11426)] = 132551,
  [SMALL_STATE(11427)] = 132622,
  [SMALL_STATE(11428)] = 132693,
  [SMALL_STATE(11429)] = 132740,
  [SMALL_STATE(11430)] = 132787,
  [SMALL_STATE(11431)] = 132834,
  [SMALL_STATE(11432)] = 132881,
  [SMALL_STATE(11433)] = 132932,
  [SMALL_STATE(11434)] = 132979,
  [SMALL_STATE(11435)] = 133030,
  [SMALL_STATE(11436)] = 133081,
  [SMALL_STATE(11437)] = 133128,
  [SMALL_STATE(11438)] = 133175,
  [SMALL_STATE(11439)] = 133222,
  [SMALL_STATE(11440)] = 133293,
  [SMALL_STATE(11441)] = 133364,
  [SMALL_STATE(11442)] = 133411,
  [SMALL_STATE(11443)] = 133482,
  [SMALL_STATE(11444)] = 133529,
  [SMALL_STATE(11445)] = 133576,
  [SMALL_STATE(11446)] = 133623,
  [SMALL_STATE(11447)] = 133670,
  [SMALL_STATE(11448)] = 133717,
  [SMALL_STATE(11449)] = 133764,
  [SMALL_STATE(11450)] = 133811,
  [SMALL_STATE(11451)] = 133858,
  [SMALL_STATE(11452)] = 133929,
  [SMALL_STATE(11453)] = 133976,
  [SMALL_STATE(11454)] = 134023,
  [SMALL_STATE(11455)] = 134070,
  [SMALL_STATE(11456)] = 134121,
  [SMALL_STATE(11457)] = 134168,
  [SMALL_STATE(11458)] = 134215,
  [SMALL_STATE(11459)] = 134266,
  [SMALL_STATE(11460)] = 134317,
  [SMALL_STATE(11461)] = 134368,
  [SMALL_STATE(11462)] = 134439,
  [SMALL_STATE(11463)] = 134510,
  [SMALL_STATE(11464)] = 134557,
  [SMALL_STATE(11465)] = 134604,
  [SMALL_STATE(11466)] = 134651,
  [SMALL_STATE(11467)] = 134698,
  [SMALL_STATE(11468)] = 134749,
  [SMALL_STATE(11469)] = 134800,
  [SMALL_STATE(11470)] = 134851,
  [SMALL_STATE(11471)] = 134908,
  [SMALL_STATE(11472)] = 134959,
  [SMALL_STATE(11473)] = 135006,
  [SMALL_STATE(11474)] = 135053,
  [SMALL_STATE(11475)] = 135100,
  [SMALL_STATE(11476)] = 135147,
  [SMALL_STATE(11477)] = 135194,
  [SMALL_STATE(11478)] = 135265,
  [SMALL_STATE(11479)] = 135312,
  [SMALL_STATE(11480)] = 135383,
  [SMALL_STATE(11481)] = 135434,
  [SMALL_STATE(11482)] = 135485,
  [SMALL_STATE(11483)] = 135532,
  [SMALL_STATE(11484)] = 135579,
  [SMALL_STATE(11485)] = 135626,
  [SMALL_STATE(11486)] = 135673,
  [SMALL_STATE(11487)] = 135720,
  [SMALL_STATE(11488)] = 135767,
  [SMALL_STATE(11489)] = 135814,
  [SMALL_STATE(11490)] = 135861,
  [SMALL_STATE(11491)] = 135908,
  [SMALL_STATE(11492)] = 135955,
  [SMALL_STATE(11493)] = 136006,
  [SMALL_STATE(11494)] = 136053,
  [SMALL_STATE(11495)] = 136100,
  [SMALL_STATE(11496)] = 136171,
  [SMALL_STATE(11497)] = 136242,
  [SMALL_STATE(11498)] = 136293,
  [SMALL_STATE(11499)] = 136340,
  [SMALL_STATE(11500)] = 136411,
  [SMALL_STATE(11501)] = 136482,
  [SMALL_STATE(11502)] = 136533,
  [SMALL_STATE(11503)] = 136580,
  [SMALL_STATE(11504)] = 136651,
  [SMALL_STATE(11505)] = 136702,
  [SMALL_STATE(11506)] = 136773,
  [SMALL_STATE(11507)] = 136820,
  [SMALL_STATE(11508)] = 136867,
  [SMALL_STATE(11509)] = 136918,
  [SMALL_STATE(11510)] = 136969,
  [SMALL_STATE(11511)] = 137040,
  [SMALL_STATE(11512)] = 137091,
  [SMALL_STATE(11513)] = 137142,
  [SMALL_STATE(11514)] = 137199,
  [SMALL_STATE(11515)] = 137246,
  [SMALL_STATE(11516)] = 137297,
  [SMALL_STATE(11517)] = 137348,
  [SMALL_STATE(11518)] = 137395,
  [SMALL_STATE(11519)] = 137446,
  [SMALL_STATE(11520)] = 137497,
  [SMALL_STATE(11521)] = 137544,
  [SMALL_STATE(11522)] = 137595,
  [SMALL_STATE(11523)] = 137646,
  [SMALL_STATE(11524)] = 137697,
  [SMALL_STATE(11525)] = 137748,
  [SMALL_STATE(11526)] = 137795,
  [SMALL_STATE(11527)] = 137846,
  [SMALL_STATE(11528)] = 137897,
  [SMALL_STATE(11529)] = 137948,
  [SMALL_STATE(11530)] = 137999,
  [SMALL_STATE(11531)] = 138050,
  [SMALL_STATE(11532)] = 138101,
  [SMALL_STATE(11533)] = 138172,
  [SMALL_STATE(11534)] = 138243,
  [SMALL_STATE(11535)] = 138300,
  [SMALL_STATE(11536)] = 138357,
  [SMALL_STATE(11537)] = 138408,
  [SMALL_STATE(11538)] = 138479,
  [SMALL_STATE(11539)] = 138550,
  [SMALL_STATE(11540)] = 138597,
  [SMALL_STATE(11541)] = 138644,
  [SMALL_STATE(11542)] = 138691,
  [SMALL_STATE(11543)] = 138738,
  [SMALL_STATE(11544)] = 138789,
  [SMALL_STATE(11545)] = 138836,
  [SMALL_STATE(11546)] = 138887,
  [SMALL_STATE(11547)] = 138938,
  [SMALL_STATE(11548)] = 138989,
  [SMALL_STATE(11549)] = 139040,
  [SMALL_STATE(11550)] = 139091,
  [SMALL_STATE(11551)] = 139162,
  [SMALL_STATE(11552)] = 139233,
  [SMALL_STATE(11553)] = 139284,
  [SMALL_STATE(11554)] = 139335,
  [SMALL_STATE(11555)] = 139406,
  [SMALL_STATE(11556)] = 139477,
  [SMALL_STATE(11557)] = 139528,
  [SMALL_STATE(11558)] = 139575,
  [SMALL_STATE(11559)] = 139646,
  [SMALL_STATE(11560)] = 139717,
  [SMALL_STATE(11561)] = 139764,
  [SMALL_STATE(11562)] = 139835,
  [SMALL_STATE(11563)] = 139906,
  [SMALL_STATE(11564)] = 139953,
  [SMALL_STATE(11565)] = 140024,
  [SMALL_STATE(11566)] = 140095,
  [SMALL_STATE(11567)] = 140166,
  [SMALL_STATE(11568)] = 140213,
  [SMALL_STATE(11569)] = 140284,
  [SMALL_STATE(11570)] = 140355,
  [SMALL_STATE(11571)] = 140426,
  [SMALL_STATE(11572)] = 140477,
  [SMALL_STATE(11573)] = 140528,
  [SMALL_STATE(11574)] = 140599,
  [SMALL_STATE(11575)] = 140670,
  [SMALL_STATE(11576)] = 140717,
  [SMALL_STATE(11577)] = 140764,
  [SMALL_STATE(11578)] = 140815,
  [SMALL_STATE(11579)] = 140872,
  [SMALL_STATE(11580)] = 140929,
  [SMALL_STATE(11581)] = 140980,
  [SMALL_STATE(11582)] = 141031,
  [SMALL_STATE(11583)] = 141082,
  [SMALL_STATE(11584)] = 141129,
  [SMALL_STATE(11585)] = 141176,
  [SMALL_STATE(11586)] = 141223,
  [SMALL_STATE(11587)] = 141272,
  [SMALL_STATE(11588)] = 141319,
  [SMALL_STATE(11589)] = 141390,
  [SMALL_STATE(11590)] = 141461,
  [SMALL_STATE(11591)] = 141532,
  [SMALL_STATE(11592)] = 141583,
  [SMALL_STATE(11593)] = 141634,
  [SMALL_STATE(11594)] = 141685,
  [SMALL_STATE(11595)] = 141732,
  [SMALL_STATE(11596)] = 141779,
  [SMALL_STATE(11597)] = 141826,
  [SMALL_STATE(11598)] = 141873,
  [SMALL_STATE(11599)] = 141924,
  [SMALL_STATE(11600)] = 141974,
  [SMALL_STATE(11601)] = 142022,
  [SMALL_STATE(11602)] = 142072,
  [SMALL_STATE(11603)] = 142122,
  [SMALL_STATE(11604)] = 142220,
  [SMALL_STATE(11605)] = 142318,
  [SMALL_STATE(11606)] = 142364,
  [SMALL_STATE(11607)] = 142434,
  [SMALL_STATE(11608)] = 142504,
  [SMALL_STATE(11609)] = 142602,
  [SMALL_STATE(11610)] = 142652,
  [SMALL_STATE(11611)] = 142702,
  [SMALL_STATE(11612)] = 142748,
  [SMALL_STATE(11613)] = 142798,
  [SMALL_STATE(11614)] = 142848,
  [SMALL_STATE(11615)] = 142894,
  [SMALL_STATE(11616)] = 142964,
  [SMALL_STATE(11617)] = 143010,
  [SMALL_STATE(11618)] = 143056,
  [SMALL_STATE(11619)] = 143108,
  [SMALL_STATE(11620)] = 143156,
  [SMALL_STATE(11621)] = 143202,
  [SMALL_STATE(11622)] = 143248,
  [SMALL_STATE(11623)] = 143294,
  [SMALL_STATE(11624)] = 143340,
  [SMALL_STATE(11625)] = 143386,
  [SMALL_STATE(11626)] = 143436,
  [SMALL_STATE(11627)] = 143482,
  [SMALL_STATE(11628)] = 143528,
  [SMALL_STATE(11629)] = 143574,
  [SMALL_STATE(11630)] = 143624,
  [SMALL_STATE(11631)] = 143670,
  [SMALL_STATE(11632)] = 143768,
  [SMALL_STATE(11633)] = 143814,
  [SMALL_STATE(11634)] = 143860,
  [SMALL_STATE(11635)] = 143958,
  [SMALL_STATE(11636)] = 144004,
  [SMALL_STATE(11637)] = 144052,
  [SMALL_STATE(11638)] = 144098,
  [SMALL_STATE(11639)] = 144148,
  [SMALL_STATE(11640)] = 144194,
  [SMALL_STATE(11641)] = 144292,
  [SMALL_STATE(11642)] = 144338,
  [SMALL_STATE(11643)] = 144384,
  [SMALL_STATE(11644)] = 144430,
  [SMALL_STATE(11645)] = 144480,
  [SMALL_STATE(11646)] = 144530,
  [SMALL_STATE(11647)] = 144576,
  [SMALL_STATE(11648)] = 144626,
  [SMALL_STATE(11649)] = 144676,
  [SMALL_STATE(11650)] = 144726,
  [SMALL_STATE(11651)] = 144772,
  [SMALL_STATE(11652)] = 144822,
  [SMALL_STATE(11653)] = 144872,
  [SMALL_STATE(11654)] = 144970,
  [SMALL_STATE(11655)] = 145016,
  [SMALL_STATE(11656)] = 145062,
  [SMALL_STATE(11657)] = 145132,
  [SMALL_STATE(11658)] = 145178,
  [SMALL_STATE(11659)] = 145224,
  [SMALL_STATE(11660)] = 145270,
  [SMALL_STATE(11661)] = 145316,
  [SMALL_STATE(11662)] = 145362,
  [SMALL_STATE(11663)] = 145408,
  [SMALL_STATE(11664)] = 145454,
  [SMALL_STATE(11665)] = 145500,
  [SMALL_STATE(11666)] = 145570,
  [SMALL_STATE(11667)] = 145616,
  [SMALL_STATE(11668)] = 145662,
  [SMALL_STATE(11669)] = 145708,
  [SMALL_STATE(11670)] = 145756,
  [SMALL_STATE(11671)] = 145802,
  [SMALL_STATE(11672)] = 145872,
  [SMALL_STATE(11673)] = 145918,
  [SMALL_STATE(11674)] = 145964,
  [SMALL_STATE(11675)] = 146010,
  [SMALL_STATE(11676)] = 146056,
  [SMALL_STATE(11677)] = 146110,
  [SMALL_STATE(11678)] = 146180,
  [SMALL_STATE(11679)] = 146278,
  [SMALL_STATE(11680)] = 146348,
  [SMALL_STATE(11681)] = 146418,
  [SMALL_STATE(11682)] = 146466,
  [SMALL_STATE(11683)] = 146512,
  [SMALL_STATE(11684)] = 146582,
  [SMALL_STATE(11685)] = 146628,
  [SMALL_STATE(11686)] = 146674,
  [SMALL_STATE(11687)] = 146720,
  [SMALL_STATE(11688)] = 146818,
  [SMALL_STATE(11689)] = 146868,
  [SMALL_STATE(11690)] = 146938,
  [SMALL_STATE(11691)] = 146984,
  [SMALL_STATE(11692)] = 147040,
  [SMALL_STATE(11693)] = 147138,
  [SMALL_STATE(11694)] = 147208,
  [SMALL_STATE(11695)] = 147258,
  [SMALL_STATE(11696)] = 147328,
  [SMALL_STATE(11697)] = 147380,
  [SMALL_STATE(11698)] = 147426,
  [SMALL_STATE(11699)] = 147496,
  [SMALL_STATE(11700)] = 147542,
  [SMALL_STATE(11701)] = 147640,
  [SMALL_STATE(11702)] = 147738,
  [SMALL_STATE(11703)] = 147808,
  [SMALL_STATE(11704)] = 147858,
  [SMALL_STATE(11705)] = 147908,
  [SMALL_STATE(11706)] = 147958,
  [SMALL_STATE(11707)] = 148004,
  [SMALL_STATE(11708)] = 148054,
  [SMALL_STATE(11709)] = 148124,
  [SMALL_STATE(11710)] = 148174,
  [SMALL_STATE(11711)] = 148224,
  [SMALL_STATE(11712)] = 148294,
  [SMALL_STATE(11713)] = 148392,
  [SMALL_STATE(11714)] = 148442,
  [SMALL_STATE(11715)] = 148492,
  [SMALL_STATE(11716)] = 148538,
  [SMALL_STATE(11717)] = 148584,
  [SMALL_STATE(11718)] = 148654,
  [SMALL_STATE(11719)] = 148704,
  [SMALL_STATE(11720)] = 148754,
  [SMALL_STATE(11721)] = 148804,
  [SMALL_STATE(11722)] = 148854,
  [SMALL_STATE(11723)] = 148900,
  [SMALL_STATE(11724)] = 148946,
  [SMALL_STATE(11725)] = 148992,
  [SMALL_STATE(11726)] = 149042,
  [SMALL_STATE(11727)] = 149092,
  [SMALL_STATE(11728)] = 149142,
  [SMALL_STATE(11729)] = 149212,
  [SMALL_STATE(11730)] = 149262,
  [SMALL_STATE(11731)] = 149360,
  [SMALL_STATE(11732)] = 149410,
  [SMALL_STATE(11733)] = 149464,
  [SMALL_STATE(11734)] = 149518,
  [SMALL_STATE(11735)] = 149566,
  [SMALL_STATE(11736)] = 149614,
  [SMALL_STATE(11737)] = 149662,
  [SMALL_STATE(11738)] = 149714,
  [SMALL_STATE(11739)] = 149760,
  [SMALL_STATE(11740)] = 149830,
  [SMALL_STATE(11741)] = 149878,
  [SMALL_STATE(11742)] = 149926,
  [SMALL_STATE(11743)] = 149974,
  [SMALL_STATE(11744)] = 150022,
  [SMALL_STATE(11745)] = 150070,
  [SMALL_STATE(11746)] = 150118,
  [SMALL_STATE(11747)] = 150163,
  [SMALL_STATE(11748)] = 150230,
  [SMALL_STATE(11749)] = 150325,
  [SMALL_STATE(11750)] = 150420,
  [SMALL_STATE(11751)] = 150469,
  [SMALL_STATE(11752)] = 150564,
  [SMALL_STATE(11753)] = 150609,
  [SMALL_STATE(11754)] = 150656,
  [SMALL_STATE(11755)] = 150741,
  [SMALL_STATE(11756)] = 150790,
  [SMALL_STATE(11757)] = 150885,
  [SMALL_STATE(11758)] = 150932,
  [SMALL_STATE(11759)] = 151017,
  [SMALL_STATE(11760)] = 151064,
  [SMALL_STATE(11761)] = 151111,
  [SMALL_STATE(11762)] = 151178,
  [SMALL_STATE(11763)] = 151245,
  [SMALL_STATE(11764)] = 151330,
  [SMALL_STATE(11765)] = 151425,
  [SMALL_STATE(11766)] = 151520,
  [SMALL_STATE(11767)] = 151569,
  [SMALL_STATE(11768)] = 151618,
  [SMALL_STATE(11769)] = 151663,
  [SMALL_STATE(11770)] = 151708,
  [SMALL_STATE(11771)] = 151775,
  [SMALL_STATE(11772)] = 151870,
  [SMALL_STATE(11773)] = 151925,
  [SMALL_STATE(11774)] = 152020,
  [SMALL_STATE(11775)] = 152115,
  [SMALL_STATE(11776)] = 152160,
  [SMALL_STATE(11777)] = 152255,
  [SMALL_STATE(11778)] = 152350,
  [SMALL_STATE(11779)] = 152445,
  [SMALL_STATE(11780)] = 152492,
  [SMALL_STATE(11781)] = 152537,
  [SMALL_STATE(11782)] = 152604,
  [SMALL_STATE(11783)] = 152649,
  [SMALL_STATE(11784)] = 152694,
  [SMALL_STATE(11785)] = 152761,
  [SMALL_STATE(11786)] = 152806,
  [SMALL_STATE(11787)] = 152851,
  [SMALL_STATE(11788)] = 152946,
  [SMALL_STATE(11789)] = 152991,
  [SMALL_STATE(11790)] = 153058,
  [SMALL_STATE(11791)] = 153153,
  [SMALL_STATE(11792)] = 153248,
  [SMALL_STATE(11793)] = 153293,
  [SMALL_STATE(11794)] = 153338,
  [SMALL_STATE(11795)] = 153387,
  [SMALL_STATE(11796)] = 153434,
  [SMALL_STATE(11797)] = 153483,
  [SMALL_STATE(11798)] = 153528,
  [SMALL_STATE(11799)] = 153623,
  [SMALL_STATE(11800)] = 153718,
  [SMALL_STATE(11801)] = 153763,
  [SMALL_STATE(11802)] = 153858,
  [SMALL_STATE(11803)] = 153903,
  [SMALL_STATE(11804)] = 153998,
  [SMALL_STATE(11805)] = 154065,
  [SMALL_STATE(11806)] = 154110,
  [SMALL_STATE(11807)] = 154177,
  [SMALL_STATE(11808)] = 154222,
  [SMALL_STATE(11809)] = 154271,
  [SMALL_STATE(11810)] = 154316,
  [SMALL_STATE(11811)] = 154411,
  [SMALL_STATE(11812)] = 154456,
  [SMALL_STATE(11813)] = 154503,
  [SMALL_STATE(11814)] = 154598,
  [SMALL_STATE(11815)] = 154643,
  [SMALL_STATE(11816)] = 154738,
  [SMALL_STATE(11817)] = 154833,
  [SMALL_STATE(11818)] = 154878,
  [SMALL_STATE(11819)] = 154923,
  [SMALL_STATE(11820)] = 155018,
  [SMALL_STATE(11821)] = 155063,
  [SMALL_STATE(11822)] = 155112,
  [SMALL_STATE(11823)] = 155161,
  [SMALL_STATE(11824)] = 155208,
  [SMALL_STATE(11825)] = 155253,
  [SMALL_STATE(11826)] = 155348,
  [SMALL_STATE(11827)] = 155397,
  [SMALL_STATE(11828)] = 155442,
  [SMALL_STATE(11829)] = 155491,
  [SMALL_STATE(11830)] = 155540,
  [SMALL_STATE(11831)] = 155585,
  [SMALL_STATE(11832)] = 155634,
  [SMALL_STATE(11833)] = 155679,
  [SMALL_STATE(11834)] = 155724,
  [SMALL_STATE(11835)] = 155819,
  [SMALL_STATE(11836)] = 155914,
  [SMALL_STATE(11837)] = 155981,
  [SMALL_STATE(11838)] = 156028,
  [SMALL_STATE(11839)] = 156073,
  [SMALL_STATE(11840)] = 156124,
  [SMALL_STATE(11841)] = 156179,
  [SMALL_STATE(11842)] = 156234,
  [SMALL_STATE(11843)] = 156283,
  [SMALL_STATE(11844)] = 156378,
  [SMALL_STATE(11845)] = 156423,
  [SMALL_STATE(11846)] = 156472,
  [SMALL_STATE(11847)] = 156539,
  [SMALL_STATE(11848)] = 156634,
  [SMALL_STATE(11849)] = 156729,
  [SMALL_STATE(11850)] = 156778,
  [SMALL_STATE(11851)] = 156873,
  [SMALL_STATE(11852)] = 156922,
  [SMALL_STATE(11853)] = 157011,
  [SMALL_STATE(11854)] = 157056,
  [SMALL_STATE(11855)] = 157103,
  [SMALL_STATE(11856)] = 157152,
  [SMALL_STATE(11857)] = 157201,
  [SMALL_STATE(11858)] = 157268,
  [SMALL_STATE(11859)] = 157317,
  [SMALL_STATE(11860)] = 157412,
  [SMALL_STATE(11861)] = 157461,
  [SMALL_STATE(11862)] = 157508,
  [SMALL_STATE(11863)] = 157555,
  [SMALL_STATE(11864)] = 157602,
  [SMALL_STATE(11865)] = 157697,
  [SMALL_STATE(11866)] = 157742,
  [SMALL_STATE(11867)] = 157789,
  [SMALL_STATE(11868)] = 157884,
  [SMALL_STATE(11869)] = 157979,
  [SMALL_STATE(11870)] = 158024,
  [SMALL_STATE(11871)] = 158091,
  [SMALL_STATE(11872)] = 158186,
  [SMALL_STATE(11873)] = 158235,
  [SMALL_STATE(11874)] = 158280,
  [SMALL_STATE(11875)] = 158325,
  [SMALL_STATE(11876)] = 158420,
  [SMALL_STATE(11877)] = 158469,
  [SMALL_STATE(11878)] = 158514,
  [SMALL_STATE(11879)] = 158609,
  [SMALL_STATE(11880)] = 158676,
  [SMALL_STATE(11881)] = 158771,
  [SMALL_STATE(11882)] = 158820,
  [SMALL_STATE(11883)] = 158871,
  [SMALL_STATE(11884)] = 158916,
  [SMALL_STATE(11885)] = 158965,
  [SMALL_STATE(11886)] = 159060,
  [SMALL_STATE(11887)] = 159109,
  [SMALL_STATE(11888)] = 159158,
  [SMALL_STATE(11889)] = 159207,
  [SMALL_STATE(11890)] = 159274,
  [SMALL_STATE(11891)] = 159359,
  [SMALL_STATE(11892)] = 159454,
  [SMALL_STATE(11893)] = 159505,
  [SMALL_STATE(11894)] = 159600,
  [SMALL_STATE(11895)] = 159645,
  [SMALL_STATE(11896)] = 159690,
  [SMALL_STATE(11897)] = 159735,
  [SMALL_STATE(11898)] = 159780,
  [SMALL_STATE(11899)] = 159875,
  [SMALL_STATE(11900)] = 159920,
  [SMALL_STATE(11901)] = 160015,
  [SMALL_STATE(11902)] = 160100,
  [SMALL_STATE(11903)] = 160185,
  [SMALL_STATE(11904)] = 160270,
  [SMALL_STATE(11905)] = 160315,
  [SMALL_STATE(11906)] = 160410,
  [SMALL_STATE(11907)] = 160505,
  [SMALL_STATE(11908)] = 160600,
  [SMALL_STATE(11909)] = 160645,
  [SMALL_STATE(11910)] = 160712,
  [SMALL_STATE(11911)] = 160807,
  [SMALL_STATE(11912)] = 160902,
  [SMALL_STATE(11913)] = 160951,
  [SMALL_STATE(11914)] = 161046,
  [SMALL_STATE(11915)] = 161127,
  [SMALL_STATE(11916)] = 161172,
  [SMALL_STATE(11917)] = 161217,
  [SMALL_STATE(11918)] = 161262,
  [SMALL_STATE(11919)] = 161357,
  [SMALL_STATE(11920)] = 161402,
  [SMALL_STATE(11921)] = 161469,
  [SMALL_STATE(11922)] = 161514,
  [SMALL_STATE(11923)] = 161559,
  [SMALL_STATE(11924)] = 161654,
  [SMALL_STATE(11925)] = 161749,
  [SMALL_STATE(11926)] = 161798,
  [SMALL_STATE(11927)] = 161843,
  [SMALL_STATE(11928)] = 161892,
  [SMALL_STATE(11929)] = 161987,
  [SMALL_STATE(11930)] = 162034,
  [SMALL_STATE(11931)] = 162129,
  [SMALL_STATE(11932)] = 162178,
  [SMALL_STATE(11933)] = 162273,
  [SMALL_STATE(11934)] = 162368,
  [SMALL_STATE(11935)] = 162463,
  [SMALL_STATE(11936)] = 162508,
  [SMALL_STATE(11937)] = 162553,
  [SMALL_STATE(11938)] = 162634,
  [SMALL_STATE(11939)] = 162723,
  [SMALL_STATE(11940)] = 162772,
  [SMALL_STATE(11941)] = 162821,
  [SMALL_STATE(11942)] = 162916,
  [SMALL_STATE(11943)] = 162965,
  [SMALL_STATE(11944)] = 163060,
  [SMALL_STATE(11945)] = 163155,
  [SMALL_STATE(11946)] = 163204,
  [SMALL_STATE(11947)] = 163299,
  [SMALL_STATE(11948)] = 163348,
  [SMALL_STATE(11949)] = 163443,
  [SMALL_STATE(11950)] = 163538,
  [SMALL_STATE(11951)] = 163633,
  [SMALL_STATE(11952)] = 163700,
  [SMALL_STATE(11953)] = 163745,
  [SMALL_STATE(11954)] = 163840,
  [SMALL_STATE(11955)] = 163889,
  [SMALL_STATE(11956)] = 163984,
  [SMALL_STATE(11957)] = 164079,
  [SMALL_STATE(11958)] = 164174,
  [SMALL_STATE(11959)] = 164269,
  [SMALL_STATE(11960)] = 164314,
  [SMALL_STATE(11961)] = 164409,
  [SMALL_STATE(11962)] = 164454,
  [SMALL_STATE(11963)] = 164507,
  [SMALL_STATE(11964)] = 164574,
  [SMALL_STATE(11965)] = 164669,
  [SMALL_STATE(11966)] = 164718,
  [SMALL_STATE(11967)] = 164767,
  [SMALL_STATE(11968)] = 164816,
  [SMALL_STATE(11969)] = 164863,
  [SMALL_STATE(11970)] = 164958,
  [SMALL_STATE(11971)] = 165003,
  [SMALL_STATE(11972)] = 165052,
  [SMALL_STATE(11973)] = 165101,
  [SMALL_STATE(11974)] = 165150,
  [SMALL_STATE(11975)] = 165199,
  [SMALL_STATE(11976)] = 165244,
  [SMALL_STATE(11977)] = 165291,
  [SMALL_STATE(11978)] = 165340,
  [SMALL_STATE(11979)] = 165389,
  [SMALL_STATE(11980)] = 165436,
  [SMALL_STATE(11981)] = 165485,
  [SMALL_STATE(11982)] = 165532,
  [SMALL_STATE(11983)] = 165579,
  [SMALL_STATE(11984)] = 165626,
  [SMALL_STATE(11985)] = 165721,
  [SMALL_STATE(11986)] = 165774,
  [SMALL_STATE(11987)] = 165819,
  [SMALL_STATE(11988)] = 165914,
  [SMALL_STATE(11989)] = 165967,
  [SMALL_STATE(11990)] = 166016,
  [SMALL_STATE(11991)] = 166063,
  [SMALL_STATE(11992)] = 166148,
  [SMALL_STATE(11993)] = 166193,
  [SMALL_STATE(11994)] = 166240,
  [SMALL_STATE(11995)] = 166287,
  [SMALL_STATE(11996)] = 166334,
  [SMALL_STATE(11997)] = 166381,
  [SMALL_STATE(11998)] = 166476,
  [SMALL_STATE(11999)] = 166543,
  [SMALL_STATE(12000)] = 166590,
  [SMALL_STATE(12001)] = 166637,
  [SMALL_STATE(12002)] = 166684,
  [SMALL_STATE(12003)] = 166731,
  [SMALL_STATE(12004)] = 166778,
  [SMALL_STATE(12005)] = 166827,
  [SMALL_STATE(12006)] = 166874,
  [SMALL_STATE(12007)] = 166921,
  [SMALL_STATE(12008)] = 166968,
  [SMALL_STATE(12009)] = 167015,
  [SMALL_STATE(12010)] = 167060,
  [SMALL_STATE(12011)] = 167108,
  [SMALL_STATE(12012)] = 167188,
  [SMALL_STATE(12013)] = 167232,
  [SMALL_STATE(12014)] = 167278,
  [SMALL_STATE(12015)] = 167324,
  [SMALL_STATE(12016)] = 167376,
  [SMALL_STATE(12017)] = 167424,
  [SMALL_STATE(12018)] = 167516,
  [SMALL_STATE(12019)] = 167560,
  [SMALL_STATE(12020)] = 167606,
  [SMALL_STATE(12021)] = 167698,
  [SMALL_STATE(12022)] = 167786,
  [SMALL_STATE(12023)] = 167832,
  [SMALL_STATE(12024)] = 167876,
  [SMALL_STATE(12025)] = 167920,
  [SMALL_STATE(12026)] = 167966,
  [SMALL_STATE(12027)] = 168012,
  [SMALL_STATE(12028)] = 168056,
  [SMALL_STATE(12029)] = 168100,
  [SMALL_STATE(12030)] = 168144,
  [SMALL_STATE(12031)] = 168188,
  [SMALL_STATE(12032)] = 168280,
  [SMALL_STATE(12033)] = 168372,
  [SMALL_STATE(12034)] = 168416,
  [SMALL_STATE(12035)] = 168508,
  [SMALL_STATE(12036)] = 168552,
  [SMALL_STATE(12037)] = 168596,
  [SMALL_STATE(12038)] = 168644,
  [SMALL_STATE(12039)] = 168736,
  [SMALL_STATE(12040)] = 168780,
  [SMALL_STATE(12041)] = 168828,
  [SMALL_STATE(12042)] = 168874,
  [SMALL_STATE(12043)] = 168922,
  [SMALL_STATE(12044)] = 168966,
  [SMALL_STATE(12045)] = 169010,
  [SMALL_STATE(12046)] = 169056,
  [SMALL_STATE(12047)] = 169100,
  [SMALL_STATE(12048)] = 169148,
  [SMALL_STATE(12049)] = 169192,
  [SMALL_STATE(12050)] = 169284,
  [SMALL_STATE(12051)] = 169364,
  [SMALL_STATE(12052)] = 169456,
  [SMALL_STATE(12053)] = 169548,
  [SMALL_STATE(12054)] = 169640,
  [SMALL_STATE(12055)] = 169732,
  [SMALL_STATE(12056)] = 169778,
  [SMALL_STATE(12057)] = 169822,
  [SMALL_STATE(12058)] = 169906,
  [SMALL_STATE(12059)] = 169962,
  [SMALL_STATE(12060)] = 170054,
  [SMALL_STATE(12061)] = 170122,
  [SMALL_STATE(12062)] = 170202,
  [SMALL_STATE(12063)] = 170246,
  [SMALL_STATE(12064)] = 170326,
  [SMALL_STATE(12065)] = 170406,
  [SMALL_STATE(12066)] = 170452,
  [SMALL_STATE(12067)] = 170496,
  [SMALL_STATE(12068)] = 170576,
  [SMALL_STATE(12069)] = 170656,
  [SMALL_STATE(12070)] = 170748,
  [SMALL_STATE(12071)] = 170794,
  [SMALL_STATE(12072)] = 170886,
  [SMALL_STATE(12073)] = 170942,
  [SMALL_STATE(12074)] = 171034,
  [SMALL_STATE(12075)] = 171114,
  [SMALL_STATE(12076)] = 171162,
  [SMALL_STATE(12077)] = 171210,
  [SMALL_STATE(12078)] = 171302,
  [SMALL_STATE(12079)] = 171346,
  [SMALL_STATE(12080)] = 171390,
  [SMALL_STATE(12081)] = 171436,
  [SMALL_STATE(12082)] = 171480,
  [SMALL_STATE(12083)] = 171524,
  [SMALL_STATE(12084)] = 171568,
  [SMALL_STATE(12085)] = 171648,
  [SMALL_STATE(12086)] = 171740,
  [SMALL_STATE(12087)] = 171826,
  [SMALL_STATE(12088)] = 171918,
  [SMALL_STATE(12089)] = 172004,
  [SMALL_STATE(12090)] = 172048,
  [SMALL_STATE(12091)] = 172094,
  [SMALL_STATE(12092)] = 172178,
  [SMALL_STATE(12093)] = 172260,
  [SMALL_STATE(12094)] = 172344,
  [SMALL_STATE(12095)] = 172388,
  [SMALL_STATE(12096)] = 172470,
  [SMALL_STATE(12097)] = 172554,
  [SMALL_STATE(12098)] = 172620,
  [SMALL_STATE(12099)] = 172704,
  [SMALL_STATE(12100)] = 172788,
  [SMALL_STATE(12101)] = 172872,
  [SMALL_STATE(12102)] = 172956,
  [SMALL_STATE(12103)] = 173040,
  [SMALL_STATE(12104)] = 173088,
  [SMALL_STATE(12105)] = 173172,
  [SMALL_STATE(12106)] = 173256,
  [SMALL_STATE(12107)] = 173340,
  [SMALL_STATE(12108)] = 173424,
  [SMALL_STATE(12109)] = 173508,
  [SMALL_STATE(12110)] = 173592,
  [SMALL_STATE(12111)] = 173678,
  [SMALL_STATE(12112)] = 173764,
  [SMALL_STATE(12113)] = 173850,
  [SMALL_STATE(12114)] = 173936,
  [SMALL_STATE(12115)] = 174022,
  [SMALL_STATE(12116)] = 174108,
  [SMALL_STATE(12117)] = 174156,
  [SMALL_STATE(12118)] = 174248,
  [SMALL_STATE(12119)] = 174340,
  [SMALL_STATE(12120)] = 174432,
  [SMALL_STATE(12121)] = 174512,
  [SMALL_STATE(12122)] = 174604,
  [SMALL_STATE(12123)] = 174696,
  [SMALL_STATE(12124)] = 174742,
  [SMALL_STATE(12125)] = 174834,
  [SMALL_STATE(12126)] = 174878,
  [SMALL_STATE(12127)] = 174964,
  [SMALL_STATE(12128)] = 175040,
  [SMALL_STATE(12129)] = 175086,
  [SMALL_STATE(12130)] = 175130,
  [SMALL_STATE(12131)] = 175202,
  [SMALL_STATE(12132)] = 175246,
  [SMALL_STATE(12133)] = 175292,
  [SMALL_STATE(12134)] = 175384,
  [SMALL_STATE(12135)] = 175454,
  [SMALL_STATE(12136)] = 175516,
  [SMALL_STATE(12137)] = 175562,
  [SMALL_STATE(12138)] = 175628,
  [SMALL_STATE(12139)] = 175720,
  [SMALL_STATE(12140)] = 175812,
  [SMALL_STATE(12141)] = 175860,
  [SMALL_STATE(12142)] = 175952,
  [SMALL_STATE(12143)] = 176036,
  [SMALL_STATE(12144)] = 176092,
  [SMALL_STATE(12145)] = 176140,
  [SMALL_STATE(12146)] = 176194,
  [SMALL_STATE(12147)] = 176246,
  [SMALL_STATE(12148)] = 176296,
  [SMALL_STATE(12149)] = 176344,
  [SMALL_STATE(12150)] = 176390,
  [SMALL_STATE(12151)] = 176478,
  [SMALL_STATE(12152)] = 176522,
  [SMALL_STATE(12153)] = 176602,
  [SMALL_STATE(12154)] = 176650,
  [SMALL_STATE(12155)] = 176734,
  [SMALL_STATE(12156)] = 176778,
  [SMALL_STATE(12157)] = 176822,
  [SMALL_STATE(12158)] = 176866,
  [SMALL_STATE(12159)] = 176912,
  [SMALL_STATE(12160)] = 176960,
  [SMALL_STATE(12161)] = 177052,
  [SMALL_STATE(12162)] = 177138,
  [SMALL_STATE(12163)] = 177224,
  [SMALL_STATE(12164)] = 177310,
  [SMALL_STATE(12165)] = 177394,
  [SMALL_STATE(12166)] = 177478,
  [SMALL_STATE(12167)] = 177522,
  [SMALL_STATE(12168)] = 177570,
  [SMALL_STATE(12169)] = 177662,
  [SMALL_STATE(12170)] = 177744,
  [SMALL_STATE(12171)] = 177836,
  [SMALL_STATE(12172)] = 177880,
  [SMALL_STATE(12173)] = 177972,
  [SMALL_STATE(12174)] = 178016,
  [SMALL_STATE(12175)] = 178108,
  [SMALL_STATE(12176)] = 178156,
  [SMALL_STATE(12177)] = 178200,
  [SMALL_STATE(12178)] = 178248,
  [SMALL_STATE(12179)] = 178292,
  [SMALL_STATE(12180)] = 178336,
  [SMALL_STATE(12181)] = 178382,
  [SMALL_STATE(12182)] = 178426,
  [SMALL_STATE(12183)] = 178474,
  [SMALL_STATE(12184)] = 178520,
  [SMALL_STATE(12185)] = 178568,
  [SMALL_STATE(12186)] = 178614,
  [SMALL_STATE(12187)] = 178706,
  [SMALL_STATE(12188)] = 178798,
  [SMALL_STATE(12189)] = 178890,
  [SMALL_STATE(12190)] = 178970,
  [SMALL_STATE(12191)] = 179016,
  [SMALL_STATE(12192)] = 179062,
  [SMALL_STATE(12193)] = 179106,
  [SMALL_STATE(12194)] = 179152,
  [SMALL_STATE(12195)] = 179198,
  [SMALL_STATE(12196)] = 179244,
  [SMALL_STATE(12197)] = 179288,
  [SMALL_STATE(12198)] = 179332,
  [SMALL_STATE(12199)] = 179376,
  [SMALL_STATE(12200)] = 179424,
  [SMALL_STATE(12201)] = 179470,
  [SMALL_STATE(12202)] = 179562,
  [SMALL_STATE(12203)] = 179654,
  [SMALL_STATE(12204)] = 179698,
  [SMALL_STATE(12205)] = 179742,
  [SMALL_STATE(12206)] = 179786,
  [SMALL_STATE(12207)] = 179830,
  [SMALL_STATE(12208)] = 179874,
  [SMALL_STATE(12209)] = 179962,
  [SMALL_STATE(12210)] = 180054,
  [SMALL_STATE(12211)] = 180102,
  [SMALL_STATE(12212)] = 180194,
  [SMALL_STATE(12213)] = 180238,
  [SMALL_STATE(12214)] = 180286,
  [SMALL_STATE(12215)] = 180332,
  [SMALL_STATE(12216)] = 180376,
  [SMALL_STATE(12217)] = 180468,
  [SMALL_STATE(12218)] = 180512,
  [SMALL_STATE(12219)] = 180560,
  [SMALL_STATE(12220)] = 180606,
  [SMALL_STATE(12221)] = 180656,
  [SMALL_STATE(12222)] = 180700,
  [SMALL_STATE(12223)] = 180746,
  [SMALL_STATE(12224)] = 180838,
  [SMALL_STATE(12225)] = 180884,
  [SMALL_STATE(12226)] = 180928,
  [SMALL_STATE(12227)] = 180972,
  [SMALL_STATE(12228)] = 181064,
  [SMALL_STATE(12229)] = 181156,
  [SMALL_STATE(12230)] = 181248,
  [SMALL_STATE(12231)] = 181340,
  [SMALL_STATE(12232)] = 181432,
  [SMALL_STATE(12233)] = 181516,
  [SMALL_STATE(12234)] = 181608,
  [SMALL_STATE(12235)] = 181656,
  [SMALL_STATE(12236)] = 181704,
  [SMALL_STATE(12237)] = 181752,
  [SMALL_STATE(12238)] = 181796,
  [SMALL_STATE(12239)] = 181840,
  [SMALL_STATE(12240)] = 181932,
  [SMALL_STATE(12241)] = 182024,
  [SMALL_STATE(12242)] = 182068,
  [SMALL_STATE(12243)] = 182116,
  [SMALL_STATE(12244)] = 182160,
  [SMALL_STATE(12245)] = 182204,
  [SMALL_STATE(12246)] = 182252,
  [SMALL_STATE(12247)] = 182300,
  [SMALL_STATE(12248)] = 182348,
  [SMALL_STATE(12249)] = 182396,
  [SMALL_STATE(12250)] = 182444,
  [SMALL_STATE(12251)] = 182536,
  [SMALL_STATE(12252)] = 182582,
  [SMALL_STATE(12253)] = 182674,
  [SMALL_STATE(12254)] = 182766,
  [SMALL_STATE(12255)] = 182858,
  [SMALL_STATE(12256)] = 182950,
  [SMALL_STATE(12257)] = 183034,
  [SMALL_STATE(12258)] = 183078,
  [SMALL_STATE(12259)] = 183122,
  [SMALL_STATE(12260)] = 183170,
  [SMALL_STATE(12261)] = 183216,
  [SMALL_STATE(12262)] = 183308,
  [SMALL_STATE(12263)] = 183354,
  [SMALL_STATE(12264)] = 183398,
  [SMALL_STATE(12265)] = 183490,
  [SMALL_STATE(12266)] = 183536,
  [SMALL_STATE(12267)] = 183584,
  [SMALL_STATE(12268)] = 183628,
  [SMALL_STATE(12269)] = 183676,
  [SMALL_STATE(12270)] = 183724,
  [SMALL_STATE(12271)] = 183768,
  [SMALL_STATE(12272)] = 183848,
  [SMALL_STATE(12273)] = 183932,
  [SMALL_STATE(12274)] = 183978,
  [SMALL_STATE(12275)] = 184024,
  [SMALL_STATE(12276)] = 184070,
  [SMALL_STATE(12277)] = 184114,
  [SMALL_STATE(12278)] = 184206,
  [SMALL_STATE(12279)] = 184298,
  [SMALL_STATE(12280)] = 184346,
  [SMALL_STATE(12281)] = 184394,
  [SMALL_STATE(12282)] = 184442,
  [SMALL_STATE(12283)] = 184490,
  [SMALL_STATE(12284)] = 184536,
  [SMALL_STATE(12285)] = 184582,
  [SMALL_STATE(12286)] = 184628,
  [SMALL_STATE(12287)] = 184672,
  [SMALL_STATE(12288)] = 184720,
  [SMALL_STATE(12289)] = 184768,
  [SMALL_STATE(12290)] = 184860,
  [SMALL_STATE(12291)] = 184952,
  [SMALL_STATE(12292)] = 185044,
  [SMALL_STATE(12293)] = 185090,
  [SMALL_STATE(12294)] = 185174,
  [SMALL_STATE(12295)] = 185220,
  [SMALL_STATE(12296)] = 185266,
  [SMALL_STATE(12297)] = 185358,
  [SMALL_STATE(12298)] = 185404,
  [SMALL_STATE(12299)] = 185484,
  [SMALL_STATE(12300)] = 185576,
  [SMALL_STATE(12301)] = 185624,
  [SMALL_STATE(12302)] = 185672,
  [SMALL_STATE(12303)] = 185720,
  [SMALL_STATE(12304)] = 185766,
  [SMALL_STATE(12305)] = 185812,
  [SMALL_STATE(12306)] = 185858,
  [SMALL_STATE(12307)] = 185904,
  [SMALL_STATE(12308)] = 185988,
  [SMALL_STATE(12309)] = 186034,
  [SMALL_STATE(12310)] = 186118,
  [SMALL_STATE(12311)] = 186164,
  [SMALL_STATE(12312)] = 186248,
  [SMALL_STATE(12313)] = 186292,
  [SMALL_STATE(12314)] = 186340,
  [SMALL_STATE(12315)] = 186388,
  [SMALL_STATE(12316)] = 186436,
  [SMALL_STATE(12317)] = 186484,
  [SMALL_STATE(12318)] = 186530,
  [SMALL_STATE(12319)] = 186576,
  [SMALL_STATE(12320)] = 186622,
  [SMALL_STATE(12321)] = 186670,
  [SMALL_STATE(12322)] = 186762,
  [SMALL_STATE(12323)] = 186810,
  [SMALL_STATE(12324)] = 186862,
  [SMALL_STATE(12325)] = 186954,
  [SMALL_STATE(12326)] = 187006,
  [SMALL_STATE(12327)] = 187052,
  [SMALL_STATE(12328)] = 187098,
  [SMALL_STATE(12329)] = 187144,
  [SMALL_STATE(12330)] = 187194,
  [SMALL_STATE(12331)] = 187240,
  [SMALL_STATE(12332)] = 187288,
  [SMALL_STATE(12333)] = 187338,
  [SMALL_STATE(12334)] = 187384,
  [SMALL_STATE(12335)] = 187430,
  [SMALL_STATE(12336)] = 187514,
  [SMALL_STATE(12337)] = 187560,
  [SMALL_STATE(12338)] = 187606,
  [SMALL_STATE(12339)] = 187652,
  [SMALL_STATE(12340)] = 187744,
  [SMALL_STATE(12341)] = 187790,
  [SMALL_STATE(12342)] = 187836,
  [SMALL_STATE(12343)] = 187928,
  [SMALL_STATE(12344)] = 188020,
  [SMALL_STATE(12345)] = 188066,
  [SMALL_STATE(12346)] = 188158,
  [SMALL_STATE(12347)] = 188250,
  [SMALL_STATE(12348)] = 188294,
  [SMALL_STATE(12349)] = 188340,
  [SMALL_STATE(12350)] = 188388,
  [SMALL_STATE(12351)] = 188436,
  [SMALL_STATE(12352)] = 188484,
  [SMALL_STATE(12353)] = 188530,
  [SMALL_STATE(12354)] = 188596,
  [SMALL_STATE(12355)] = 188688,
  [SMALL_STATE(12356)] = 188756,
  [SMALL_STATE(12357)] = 188836,
  [SMALL_STATE(12358)] = 188912,
  [SMALL_STATE(12359)] = 188958,
  [SMALL_STATE(12360)] = 189006,
  [SMALL_STATE(12361)] = 189054,
  [SMALL_STATE(12362)] = 189102,
  [SMALL_STATE(12363)] = 189150,
  [SMALL_STATE(12364)] = 189198,
  [SMALL_STATE(12365)] = 189246,
  [SMALL_STATE(12366)] = 189318,
  [SMALL_STATE(12367)] = 189388,
  [SMALL_STATE(12368)] = 189434,
  [SMALL_STATE(12369)] = 189480,
  [SMALL_STATE(12370)] = 189526,
  [SMALL_STATE(12371)] = 189588,
  [SMALL_STATE(12372)] = 189634,
  [SMALL_STATE(12373)] = 189700,
  [SMALL_STATE(12374)] = 189748,
  [SMALL_STATE(12375)] = 189804,
  [SMALL_STATE(12376)] = 189858,
  [SMALL_STATE(12377)] = 189910,
  [SMALL_STATE(12378)] = 189960,
  [SMALL_STATE(12379)] = 190008,
  [SMALL_STATE(12380)] = 190100,
  [SMALL_STATE(12381)] = 190146,
  [SMALL_STATE(12382)] = 190238,
  [SMALL_STATE(12383)] = 190283,
  [SMALL_STATE(12384)] = 190328,
  [SMALL_STATE(12385)] = 190373,
  [SMALL_STATE(12386)] = 190418,
  [SMALL_STATE(12387)] = 190501,
  [SMALL_STATE(12388)] = 190546,
  [SMALL_STATE(12389)] = 190629,
  [SMALL_STATE(12390)] = 190712,
  [SMALL_STATE(12391)] = 190757,
  [SMALL_STATE(12392)] = 190840,
  [SMALL_STATE(12393)] = 190885,
  [SMALL_STATE(12394)] = 190930,
  [SMALL_STATE(12395)] = 190975,
  [SMALL_STATE(12396)] = 191020,
  [SMALL_STATE(12397)] = 191065,
  [SMALL_STATE(12398)] = 191110,
  [SMALL_STATE(12399)] = 191155,
  [SMALL_STATE(12400)] = 191202,
  [SMALL_STATE(12401)] = 191249,
  [SMALL_STATE(12402)] = 191296,
  [SMALL_STATE(12403)] = 191379,
  [SMALL_STATE(12404)] = 191424,
  [SMALL_STATE(12405)] = 191503,
  [SMALL_STATE(12406)] = 191586,
  [SMALL_STATE(12407)] = 191633,
  [SMALL_STATE(12408)] = 191680,
  [SMALL_STATE(12409)] = 191759,
  [SMALL_STATE(12410)] = 191844,
  [SMALL_STATE(12411)] = 191929,
  [SMALL_STATE(12412)] = 191984,
  [SMALL_STATE(12413)] = 192069,
  [SMALL_STATE(12414)] = 192114,
  [SMALL_STATE(12415)] = 192159,
  [SMALL_STATE(12416)] = 192238,
  [SMALL_STATE(12417)] = 192293,
  [SMALL_STATE(12418)] = 192372,
  [SMALL_STATE(12419)] = 192419,
  [SMALL_STATE(12420)] = 192466,
  [SMALL_STATE(12421)] = 192553,
  [SMALL_STATE(12422)] = 192600,
  [SMALL_STATE(12423)] = 192683,
  [SMALL_STATE(12424)] = 192768,
  [SMALL_STATE(12425)] = 192815,
  [SMALL_STATE(12426)] = 192898,
  [SMALL_STATE(12427)] = 192943,
  [SMALL_STATE(12428)] = 192988,
  [SMALL_STATE(12429)] = 193033,
  [SMALL_STATE(12430)] = 193086,
  [SMALL_STATE(12431)] = 193131,
  [SMALL_STATE(12432)] = 193196,
  [SMALL_STATE(12433)] = 193247,
  [SMALL_STATE(12434)] = 193326,
  [SMALL_STATE(12435)] = 193371,
  [SMALL_STATE(12436)] = 193418,
  [SMALL_STATE(12437)] = 193497,
  [SMALL_STATE(12438)] = 193542,
  [SMALL_STATE(12439)] = 193587,
  [SMALL_STATE(12440)] = 193666,
  [SMALL_STATE(12441)] = 193715,
  [SMALL_STATE(12442)] = 193760,
  [SMALL_STATE(12443)] = 193805,
  [SMALL_STATE(12444)] = 193880,
  [SMALL_STATE(12445)] = 193951,
  [SMALL_STATE(12446)] = 193996,
  [SMALL_STATE(12447)] = 194077,
  [SMALL_STATE(12448)] = 194122,
  [SMALL_STATE(12449)] = 194193,
  [SMALL_STATE(12450)] = 194262,
  [SMALL_STATE(12451)] = 194345,
  [SMALL_STATE(12452)] = 194428,
  [SMALL_STATE(12453)] = 194511,
  [SMALL_STATE(12454)] = 194572,
  [SMALL_STATE(12455)] = 194617,
  [SMALL_STATE(12456)] = 194682,
  [SMALL_STATE(12457)] = 194727,
  [SMALL_STATE(12458)] = 194782,
  [SMALL_STATE(12459)] = 194829,
  [SMALL_STATE(12460)] = 194882,
  [SMALL_STATE(12461)] = 194933,
  [SMALL_STATE(12462)] = 195012,
  [SMALL_STATE(12463)] = 195059,
  [SMALL_STATE(12464)] = 195138,
  [SMALL_STATE(12465)] = 195185,
  [SMALL_STATE(12466)] = 195232,
  [SMALL_STATE(12467)] = 195299,
  [SMALL_STATE(12468)] = 195378,
  [SMALL_STATE(12469)] = 195423,
  [SMALL_STATE(12470)] = 195508,
  [SMALL_STATE(12471)] = 195589,
  [SMALL_STATE(12472)] = 195674,
  [SMALL_STATE(12473)] = 195753,
  [SMALL_STATE(12474)] = 195798,
  [SMALL_STATE(12475)] = 195847,
  [SMALL_STATE(12476)] = 195928,
  [SMALL_STATE(12477)] = 196013,
  [SMALL_STATE(12478)] = 196060,
  [SMALL_STATE(12479)] = 196107,
  [SMALL_STATE(12480)] = 196154,
  [SMALL_STATE(12481)] = 196199,
  [SMALL_STATE(12482)] = 196244,
  [SMALL_STATE(12483)] = 196323,
  [SMALL_STATE(12484)] = 196370,
  [SMALL_STATE(12485)] = 196451,
  [SMALL_STATE(12486)] = 196520,
  [SMALL_STATE(12487)] = 196603,
  [SMALL_STATE(12488)] = 196684,
  [SMALL_STATE(12489)] = 196731,
  [SMALL_STATE(12490)] = 196810,
  [SMALL_STATE(12491)] = 196857,
  [SMALL_STATE(12492)] = 196904,
  [SMALL_STATE(12493)] = 196949,
  [SMALL_STATE(12494)] = 196996,
  [SMALL_STATE(12495)] = 197043,
  [SMALL_STATE(12496)] = 197088,
  [SMALL_STATE(12497)] = 197133,
  [SMALL_STATE(12498)] = 197220,
  [SMALL_STATE(12499)] = 197265,
  [SMALL_STATE(12500)] = 197310,
  [SMALL_STATE(12501)] = 197389,
  [SMALL_STATE(12502)] = 197444,
  [SMALL_STATE(12503)] = 197491,
  [SMALL_STATE(12504)] = 197536,
  [SMALL_STATE(12505)] = 197581,
  [SMALL_STATE(12506)] = 197660,
  [SMALL_STATE(12507)] = 197705,
  [SMALL_STATE(12508)] = 197750,
  [SMALL_STATE(12509)] = 197797,
  [SMALL_STATE(12510)] = 197864,
  [SMALL_STATE(12511)] = 197909,
  [SMALL_STATE(12512)] = 197954,
  [SMALL_STATE(12513)] = 198001,
  [SMALL_STATE(12514)] = 198080,
  [SMALL_STATE(12515)] = 198125,
  [SMALL_STATE(12516)] = 198170,
  [SMALL_STATE(12517)] = 198251,
  [SMALL_STATE(12518)] = 198296,
  [SMALL_STATE(12519)] = 198341,
  [SMALL_STATE(12520)] = 198386,
  [SMALL_STATE(12521)] = 198447,
  [SMALL_STATE(12522)] = 198492,
  [SMALL_STATE(12523)] = 198537,
  [SMALL_STATE(12524)] = 198620,
  [SMALL_STATE(12525)] = 198703,
  [SMALL_STATE(12526)] = 198748,
  [SMALL_STATE(12527)] = 198813,
  [SMALL_STATE(12528)] = 198858,
  [SMALL_STATE(12529)] = 198913,
  [SMALL_STATE(12530)] = 198996,
  [SMALL_STATE(12531)] = 199063,
  [SMALL_STATE(12532)] = 199144,
  [SMALL_STATE(12533)] = 199223,
  [SMALL_STATE(12534)] = 199298,
  [SMALL_STATE(12535)] = 199369,
  [SMALL_STATE(12536)] = 199416,
  [SMALL_STATE(12537)] = 199463,
  [SMALL_STATE(12538)] = 199548,
  [SMALL_STATE(12539)] = 199617,
  [SMALL_STATE(12540)] = 199678,
  [SMALL_STATE(12541)] = 199743,
  [SMALL_STATE(12542)] = 199798,
  [SMALL_STATE(12543)] = 199851,
  [SMALL_STATE(12544)] = 199902,
  [SMALL_STATE(12545)] = 199947,
  [SMALL_STATE(12546)] = 200030,
  [SMALL_STATE(12547)] = 200079,
  [SMALL_STATE(12548)] = 200126,
  [SMALL_STATE(12549)] = 200173,
  [SMALL_STATE(12550)] = 200218,
  [SMALL_STATE(12551)] = 200301,
  [SMALL_STATE(12552)] = 200348,
  [SMALL_STATE(12553)] = 200413,
  [SMALL_STATE(12554)] = 200480,
  [SMALL_STATE(12555)] = 200527,
  [SMALL_STATE(12556)] = 200574,
  [SMALL_STATE(12557)] = 200653,
  [SMALL_STATE(12558)] = 200732,
  [SMALL_STATE(12559)] = 200807,
  [SMALL_STATE(12560)] = 200882,
  [SMALL_STATE(12561)] = 200963,
  [SMALL_STATE(12562)] = 201034,
  [SMALL_STATE(12563)] = 201079,
  [SMALL_STATE(12564)] = 201124,
  [SMALL_STATE(12565)] = 201169,
  [SMALL_STATE(12566)] = 201214,
  [SMALL_STATE(12567)] = 201259,
  [SMALL_STATE(12568)] = 201304,
  [SMALL_STATE(12569)] = 201387,
  [SMALL_STATE(12570)] = 201470,
  [SMALL_STATE(12571)] = 201517,
  [SMALL_STATE(12572)] = 201564,
  [SMALL_STATE(12573)] = 201647,
  [SMALL_STATE(12574)] = 201716,
  [SMALL_STATE(12575)] = 201761,
  [SMALL_STATE(12576)] = 201844,
  [SMALL_STATE(12577)] = 201905,
  [SMALL_STATE(12578)] = 201990,
  [SMALL_STATE(12579)] = 202075,
  [SMALL_STATE(12580)] = 202140,
  [SMALL_STATE(12581)] = 202185,
  [SMALL_STATE(12582)] = 202270,
  [SMALL_STATE(12583)] = 202315,
  [SMALL_STATE(12584)] = 202360,
  [SMALL_STATE(12585)] = 202407,
  [SMALL_STATE(12586)] = 202462,
  [SMALL_STATE(12587)] = 202509,
  [SMALL_STATE(12588)] = 202562,
  [SMALL_STATE(12589)] = 202647,
  [SMALL_STATE(12590)] = 202698,
  [SMALL_STATE(12591)] = 202785,
  [SMALL_STATE(12592)] = 202864,
  [SMALL_STATE(12593)] = 202911,
  [SMALL_STATE(12594)] = 202994,
  [SMALL_STATE(12595)] = 203041,
  [SMALL_STATE(12596)] = 203088,
  [SMALL_STATE(12597)] = 203135,
  [SMALL_STATE(12598)] = 203182,
  [SMALL_STATE(12599)] = 203261,
  [SMALL_STATE(12600)] = 203342,
  [SMALL_STATE(12601)] = 203429,
  [SMALL_STATE(12602)] = 203512,
  [SMALL_STATE(12603)] = 203559,
  [SMALL_STATE(12604)] = 203606,
  [SMALL_STATE(12605)] = 203653,
  [SMALL_STATE(12606)] = 203700,
  [SMALL_STATE(12607)] = 203779,
  [SMALL_STATE(12608)] = 203824,
  [SMALL_STATE(12609)] = 203869,
  [SMALL_STATE(12610)] = 203916,
  [SMALL_STATE(12611)] = 203963,
  [SMALL_STATE(12612)] = 204048,
  [SMALL_STATE(12613)] = 204095,
  [SMALL_STATE(12614)] = 204140,
  [SMALL_STATE(12615)] = 204185,
  [SMALL_STATE(12616)] = 204230,
  [SMALL_STATE(12617)] = 204313,
  [SMALL_STATE(12618)] = 204392,
  [SMALL_STATE(12619)] = 204457,
  [SMALL_STATE(12620)] = 204502,
  [SMALL_STATE(12621)] = 204581,
  [SMALL_STATE(12622)] = 204646,
  [SMALL_STATE(12623)] = 204691,
  [SMALL_STATE(12624)] = 204738,
  [SMALL_STATE(12625)] = 204793,
  [SMALL_STATE(12626)] = 204840,
  [SMALL_STATE(12627)] = 204885,
  [SMALL_STATE(12628)] = 204964,
  [SMALL_STATE(12629)] = 205043,
  [SMALL_STATE(12630)] = 205098,
  [SMALL_STATE(12631)] = 205173,
  [SMALL_STATE(12632)] = 205218,
  [SMALL_STATE(12633)] = 205265,
  [SMALL_STATE(12634)] = 205312,
  [SMALL_STATE(12635)] = 205359,
  [SMALL_STATE(12636)] = 205404,
  [SMALL_STATE(12637)] = 205449,
  [SMALL_STATE(12638)] = 205494,
  [SMALL_STATE(12639)] = 205565,
  [SMALL_STATE(12640)] = 205610,
  [SMALL_STATE(12641)] = 205691,
  [SMALL_STATE(12642)] = 205738,
  [SMALL_STATE(12643)] = 205805,
  [SMALL_STATE(12644)] = 205850,
  [SMALL_STATE(12645)] = 205933,
  [SMALL_STATE(12646)] = 205978,
  [SMALL_STATE(12647)] = 206061,
  [SMALL_STATE(12648)] = 206106,
  [SMALL_STATE(12649)] = 206189,
  [SMALL_STATE(12650)] = 206234,
  [SMALL_STATE(12651)] = 206317,
  [SMALL_STATE(12652)] = 206362,
  [SMALL_STATE(12653)] = 206409,
  [SMALL_STATE(12654)] = 206474,
  [SMALL_STATE(12655)] = 206543,
  [SMALL_STATE(12656)] = 206624,
  [SMALL_STATE(12657)] = 206701,
  [SMALL_STATE(12658)] = 206774,
  [SMALL_STATE(12659)] = 206845,
  [SMALL_STATE(12660)] = 206906,
  [SMALL_STATE(12661)] = 206971,
  [SMALL_STATE(12662)] = 207026,
  [SMALL_STATE(12663)] = 207079,
  [SMALL_STATE(12664)] = 207130,
  [SMALL_STATE(12665)] = 207179,
  [SMALL_STATE(12666)] = 207226,
  [SMALL_STATE(12667)] = 207307,
  [SMALL_STATE(12668)] = 207372,
  [SMALL_STATE(12669)] = 207441,
  [SMALL_STATE(12670)] = 207486,
  [SMALL_STATE(12671)] = 207531,
  [SMALL_STATE(12672)] = 207578,
  [SMALL_STATE(12673)] = 207659,
  [SMALL_STATE(12674)] = 207736,
  [SMALL_STATE(12675)] = 207809,
  [SMALL_STATE(12676)] = 207880,
  [SMALL_STATE(12677)] = 207941,
  [SMALL_STATE(12678)] = 208006,
  [SMALL_STATE(12679)] = 208087,
  [SMALL_STATE(12680)] = 208132,
  [SMALL_STATE(12681)] = 208213,
  [SMALL_STATE(12682)] = 208260,
  [SMALL_STATE(12683)] = 208339,
  [SMALL_STATE(12684)] = 208384,
  [SMALL_STATE(12685)] = 208429,
  [SMALL_STATE(12686)] = 208474,
  [SMALL_STATE(12687)] = 208519,
  [SMALL_STATE(12688)] = 208588,
  [SMALL_STATE(12689)] = 208669,
  [SMALL_STATE(12690)] = 208750,
  [SMALL_STATE(12691)] = 208815,
  [SMALL_STATE(12692)] = 208896,
  [SMALL_STATE(12693)] = 208979,
  [SMALL_STATE(12694)] = 209056,
  [SMALL_STATE(12695)] = 209129,
  [SMALL_STATE(12696)] = 209174,
  [SMALL_STATE(12697)] = 209257,
  [SMALL_STATE(12698)] = 209304,
  [SMALL_STATE(12699)] = 209385,
  [SMALL_STATE(12700)] = 209456,
  [SMALL_STATE(12701)] = 209517,
  [SMALL_STATE(12702)] = 209582,
  [SMALL_STATE(12703)] = 209627,
  [SMALL_STATE(12704)] = 209672,
  [SMALL_STATE(12705)] = 209727,
  [SMALL_STATE(12706)] = 209780,
  [SMALL_STATE(12707)] = 209831,
  [SMALL_STATE(12708)] = 209880,
  [SMALL_STATE(12709)] = 209927,
  [SMALL_STATE(12710)] = 209996,
  [SMALL_STATE(12711)] = 210079,
  [SMALL_STATE(12712)] = 210124,
  [SMALL_STATE(12713)] = 210171,
  [SMALL_STATE(12714)] = 210232,
  [SMALL_STATE(12715)] = 210297,
  [SMALL_STATE(12716)] = 210344,
  [SMALL_STATE(12717)] = 210399,
  [SMALL_STATE(12718)] = 210452,
  [SMALL_STATE(12719)] = 210503,
  [SMALL_STATE(12720)] = 210552,
  [SMALL_STATE(12721)] = 210599,
  [SMALL_STATE(12722)] = 210682,
  [SMALL_STATE(12723)] = 210727,
  [SMALL_STATE(12724)] = 210774,
  [SMALL_STATE(12725)] = 210855,
  [SMALL_STATE(12726)] = 210900,
  [SMALL_STATE(12727)] = 210947,
  [SMALL_STATE(12728)] = 211002,
  [SMALL_STATE(12729)] = 211049,
  [SMALL_STATE(12730)] = 211104,
  [SMALL_STATE(12731)] = 211151,
  [SMALL_STATE(12732)] = 211216,
  [SMALL_STATE(12733)] = 211261,
  [SMALL_STATE(12734)] = 211306,
  [SMALL_STATE(12735)] = 211361,
  [SMALL_STATE(12736)] = 211440,
  [SMALL_STATE(12737)] = 211485,
  [SMALL_STATE(12738)] = 211530,
  [SMALL_STATE(12739)] = 211575,
  [SMALL_STATE(12740)] = 211622,
  [SMALL_STATE(12741)] = 211705,
  [SMALL_STATE(12742)] = 211788,
  [SMALL_STATE(12743)] = 211871,
  [SMALL_STATE(12744)] = 211918,
  [SMALL_STATE(12745)] = 211963,
  [SMALL_STATE(12746)] = 212042,
  [SMALL_STATE(12747)] = 212097,
  [SMALL_STATE(12748)] = 212144,
  [SMALL_STATE(12749)] = 212191,
  [SMALL_STATE(12750)] = 212236,
  [SMALL_STATE(12751)] = 212283,
  [SMALL_STATE(12752)] = 212336,
  [SMALL_STATE(12753)] = 212423,
  [SMALL_STATE(12754)] = 212474,
  [SMALL_STATE(12755)] = 212523,
  [SMALL_STATE(12756)] = 212570,
  [SMALL_STATE(12757)] = 212653,
  [SMALL_STATE(12758)] = 212698,
  [SMALL_STATE(12759)] = 212743,
  [SMALL_STATE(12760)] = 212822,
  [SMALL_STATE(12761)] = 212867,
  [SMALL_STATE(12762)] = 212916,
  [SMALL_STATE(12763)] = 212960,
  [SMALL_STATE(12764)] = 213004,
  [SMALL_STATE(12765)] = 213048,
  [SMALL_STATE(12766)] = 213094,
  [SMALL_STATE(12767)] = 213140,
  [SMALL_STATE(12768)] = 213184,
  [SMALL_STATE(12769)] = 213266,
  [SMALL_STATE(12770)] = 213310,
  [SMALL_STATE(12771)] = 213354,
  [SMALL_STATE(12772)] = 213432,
  [SMALL_STATE(12773)] = 213486,
  [SMALL_STATE(12774)] = 213530,
  [SMALL_STATE(12775)] = 213610,
  [SMALL_STATE(12776)] = 213660,
  [SMALL_STATE(12777)] = 213724,
  [SMALL_STATE(12778)] = 213768,
  [SMALL_STATE(12779)] = 213850,
  [SMALL_STATE(12780)] = 213918,
  [SMALL_STATE(12781)] = 213998,
  [SMALL_STATE(12782)] = 214074,
  [SMALL_STATE(12783)] = 214138,
  [SMALL_STATE(12784)] = 214204,
  [SMALL_STATE(12785)] = 214282,
  [SMALL_STATE(12786)] = 214356,
  [SMALL_STATE(12787)] = 214426,
  [SMALL_STATE(12788)] = 214494,
  [SMALL_STATE(12789)] = 214554,
  [SMALL_STATE(12790)] = 214618,
  [SMALL_STATE(12791)] = 214672,
  [SMALL_STATE(12792)] = 214724,
  [SMALL_STATE(12793)] = 214774,
  [SMALL_STATE(12794)] = 214822,
  [SMALL_STATE(12795)] = 214868,
  [SMALL_STATE(12796)] = 214940,
  [SMALL_STATE(12797)] = 215010,
  [SMALL_STATE(12798)] = 215070,
  [SMALL_STATE(12799)] = 215134,
  [SMALL_STATE(12800)] = 215188,
  [SMALL_STATE(12801)] = 215240,
  [SMALL_STATE(12802)] = 215290,
  [SMALL_STATE(12803)] = 215338,
  [SMALL_STATE(12804)] = 215384,
  [SMALL_STATE(12805)] = 215428,
  [SMALL_STATE(12806)] = 215474,
  [SMALL_STATE(12807)] = 215556,
  [SMALL_STATE(12808)] = 215636,
  [SMALL_STATE(12809)] = 215680,
  [SMALL_STATE(12810)] = 215724,
  [SMALL_STATE(12811)] = 215768,
  [SMALL_STATE(12812)] = 215846,
  [SMALL_STATE(12813)] = 215928,
  [SMALL_STATE(12814)] = 216006,
  [SMALL_STATE(12815)] = 216084,
  [SMALL_STATE(12816)] = 216150,
  [SMALL_STATE(12817)] = 216196,
  [SMALL_STATE(12818)] = 216274,
  [SMALL_STATE(12819)] = 216338,
  [SMALL_STATE(12820)] = 216416,
  [SMALL_STATE(12821)] = 216490,
  [SMALL_STATE(12822)] = 216560,
  [SMALL_STATE(12823)] = 216628,
  [SMALL_STATE(12824)] = 216688,
  [SMALL_STATE(12825)] = 216752,
  [SMALL_STATE(12826)] = 216806,
  [SMALL_STATE(12827)] = 216858,
  [SMALL_STATE(12828)] = 216908,
  [SMALL_STATE(12829)] = 216956,
  [SMALL_STATE(12830)] = 217002,
  [SMALL_STATE(12831)] = 217048,
  [SMALL_STATE(12832)] = 217092,
  [SMALL_STATE(12833)] = 217138,
  [SMALL_STATE(12834)] = 217182,
  [SMALL_STATE(12835)] = 217228,
  [SMALL_STATE(12836)] = 217310,
  [SMALL_STATE(12837)] = 217354,
  [SMALL_STATE(12838)] = 217436,
  [SMALL_STATE(12839)] = 217480,
  [SMALL_STATE(12840)] = 217524,
  [SMALL_STATE(12841)] = 217606,
  [SMALL_STATE(12842)] = 217650,
  [SMALL_STATE(12843)] = 217694,
  [SMALL_STATE(12844)] = 217760,
  [SMALL_STATE(12845)] = 217842,
  [SMALL_STATE(12846)] = 217906,
  [SMALL_STATE(12847)] = 217984,
  [SMALL_STATE(12848)] = 218058,
  [SMALL_STATE(12849)] = 218128,
  [SMALL_STATE(12850)] = 218196,
  [SMALL_STATE(12851)] = 218256,
  [SMALL_STATE(12852)] = 218320,
  [SMALL_STATE(12853)] = 218374,
  [SMALL_STATE(12854)] = 218426,
  [SMALL_STATE(12855)] = 218476,
  [SMALL_STATE(12856)] = 218524,
  [SMALL_STATE(12857)] = 218570,
  [SMALL_STATE(12858)] = 218652,
  [SMALL_STATE(12859)] = 218730,
  [SMALL_STATE(12860)] = 218784,
  [SMALL_STATE(12861)] = 218848,
  [SMALL_STATE(12862)] = 218914,
  [SMALL_STATE(12863)] = 218992,
  [SMALL_STATE(12864)] = 219036,
  [SMALL_STATE(12865)] = 219110,
  [SMALL_STATE(12866)] = 219154,
  [SMALL_STATE(12867)] = 219236,
  [SMALL_STATE(12868)] = 219306,
  [SMALL_STATE(12869)] = 219374,
  [SMALL_STATE(12870)] = 219418,
  [SMALL_STATE(12871)] = 219500,
  [SMALL_STATE(12872)] = 219560,
  [SMALL_STATE(12873)] = 219624,
  [SMALL_STATE(12874)] = 219668,
  [SMALL_STATE(12875)] = 219750,
  [SMALL_STATE(12876)] = 219804,
  [SMALL_STATE(12877)] = 219856,
  [SMALL_STATE(12878)] = 219906,
  [SMALL_STATE(12879)] = 219954,
  [SMALL_STATE(12880)] = 219998,
  [SMALL_STATE(12881)] = 220044,
  [SMALL_STATE(12882)] = 220088,
  [SMALL_STATE(12883)] = 220134,
  [SMALL_STATE(12884)] = 220180,
  [SMALL_STATE(12885)] = 220224,
  [SMALL_STATE(12886)] = 220268,
  [SMALL_STATE(12887)] = 220312,
  [SMALL_STATE(12888)] = 220390,
  [SMALL_STATE(12889)] = 220472,
  [SMALL_STATE(12890)] = 220554,
  [SMALL_STATE(12891)] = 220632,
  [SMALL_STATE(12892)] = 220686,
  [SMALL_STATE(12893)] = 220750,
  [SMALL_STATE(12894)] = 220816,
  [SMALL_STATE(12895)] = 220894,
  [SMALL_STATE(12896)] = 220968,
  [SMALL_STATE(12897)] = 221046,
  [SMALL_STATE(12898)] = 221116,
  [SMALL_STATE(12899)] = 221184,
  [SMALL_STATE(12900)] = 221244,
  [SMALL_STATE(12901)] = 221308,
  [SMALL_STATE(12902)] = 221362,
  [SMALL_STATE(12903)] = 221406,
  [SMALL_STATE(12904)] = 221450,
  [SMALL_STATE(12905)] = 221494,
  [SMALL_STATE(12906)] = 221546,
  [SMALL_STATE(12907)] = 221596,
  [SMALL_STATE(12908)] = 221644,
  [SMALL_STATE(12909)] = 221690,
  [SMALL_STATE(12910)] = 221734,
  [SMALL_STATE(12911)] = 221812,
  [SMALL_STATE(12912)] = 221856,
  [SMALL_STATE(12913)] = 221900,
  [SMALL_STATE(12914)] = 221944,
  [SMALL_STATE(12915)] = 221988,
  [SMALL_STATE(12916)] = 222032,
  [SMALL_STATE(12917)] = 222076,
  [SMALL_STATE(12918)] = 222120,
  [SMALL_STATE(12919)] = 222164,
  [SMALL_STATE(12920)] = 222208,
  [SMALL_STATE(12921)] = 222290,
  [SMALL_STATE(12922)] = 222334,
  [SMALL_STATE(12923)] = 222380,
  [SMALL_STATE(12924)] = 222424,
  [SMALL_STATE(12925)] = 222468,
  [SMALL_STATE(12926)] = 222512,
  [SMALL_STATE(12927)] = 222592,
  [SMALL_STATE(12928)] = 222670,
  [SMALL_STATE(12929)] = 222748,
  [SMALL_STATE(12930)] = 222792,
  [SMALL_STATE(12931)] = 222836,
  [SMALL_STATE(12932)] = 222880,
  [SMALL_STATE(12933)] = 222958,
  [SMALL_STATE(12934)] = 223038,
  [SMALL_STATE(12935)] = 223082,
  [SMALL_STATE(12936)] = 223136,
  [SMALL_STATE(12937)] = 223180,
  [SMALL_STATE(12938)] = 223226,
  [SMALL_STATE(12939)] = 223308,
  [SMALL_STATE(12940)] = 223386,
  [SMALL_STATE(12941)] = 223464,
  [SMALL_STATE(12942)] = 223542,
  [SMALL_STATE(12943)] = 223620,
  [SMALL_STATE(12944)] = 223698,
  [SMALL_STATE(12945)] = 223778,
  [SMALL_STATE(12946)] = 223856,
  [SMALL_STATE(12947)] = 223940,
  [SMALL_STATE(12948)] = 224024,
  [SMALL_STATE(12949)] = 224102,
  [SMALL_STATE(12950)] = 224180,
  [SMALL_STATE(12951)] = 224260,
  [SMALL_STATE(12952)] = 224338,
  [SMALL_STATE(12953)] = 224416,
  [SMALL_STATE(12954)] = 224494,
  [SMALL_STATE(12955)] = 224574,
  [SMALL_STATE(12956)] = 224654,
  [SMALL_STATE(12957)] = 224734,
  [SMALL_STATE(12958)] = 224818,
  [SMALL_STATE(12959)] = 224902,
  [SMALL_STATE(12960)] = 224986,
  [SMALL_STATE(12961)] = 225066,
  [SMALL_STATE(12962)] = 225150,
  [SMALL_STATE(12963)] = 225234,
  [SMALL_STATE(12964)] = 225318,
  [SMALL_STATE(12965)] = 225396,
  [SMALL_STATE(12966)] = 225474,
  [SMALL_STATE(12967)] = 225554,
  [SMALL_STATE(12968)] = 225634,
  [SMALL_STATE(12969)] = 225714,
  [SMALL_STATE(12970)] = 225794,
  [SMALL_STATE(12971)] = 225874,
  [SMALL_STATE(12972)] = 225954,
  [SMALL_STATE(12973)] = 226034,
  [SMALL_STATE(12974)] = 226088,
  [SMALL_STATE(12975)] = 226168,
  [SMALL_STATE(12976)] = 226246,
  [SMALL_STATE(12977)] = 226290,
  [SMALL_STATE(12978)] = 226370,
  [SMALL_STATE(12979)] = 226416,
  [SMALL_STATE(12980)] = 226496,
  [SMALL_STATE(12981)] = 226576,
  [SMALL_STATE(12982)] = 226656,
  [SMALL_STATE(12983)] = 226736,
  [SMALL_STATE(12984)] = 226816,
  [SMALL_STATE(12985)] = 226896,
  [SMALL_STATE(12986)] = 226976,
  [SMALL_STATE(12987)] = 227056,
  [SMALL_STATE(12988)] = 227136,
  [SMALL_STATE(12989)] = 227180,
  [SMALL_STATE(12990)] = 227224,
  [SMALL_STATE(12991)] = 227268,
  [SMALL_STATE(12992)] = 227332,
  [SMALL_STATE(12993)] = 227408,
  [SMALL_STATE(12994)] = 227480,
  [SMALL_STATE(12995)] = 227550,
  [SMALL_STATE(12996)] = 227610,
  [SMALL_STATE(12997)] = 227674,
  [SMALL_STATE(12998)] = 227728,
  [SMALL_STATE(12999)] = 227780,
  [SMALL_STATE(13000)] = 227830,
  [SMALL_STATE(13001)] = 227878,
  [SMALL_STATE(13002)] = 227924,
  [SMALL_STATE(13003)] = 227970,
  [SMALL_STATE(13004)] = 228024,
  [SMALL_STATE(13005)] = 228068,
  [SMALL_STATE(13006)] = 228150,
  [SMALL_STATE(13007)] = 228194,
  [SMALL_STATE(13008)] = 228276,
  [SMALL_STATE(13009)] = 228320,
  [SMALL_STATE(13010)] = 228402,
  [SMALL_STATE(13011)] = 228446,
  [SMALL_STATE(13012)] = 228490,
  [SMALL_STATE(13013)] = 228536,
  [SMALL_STATE(13014)] = 228600,
  [SMALL_STATE(13015)] = 228668,
  [SMALL_STATE(13016)] = 228744,
  [SMALL_STATE(13017)] = 228816,
  [SMALL_STATE(13018)] = 228886,
  [SMALL_STATE(13019)] = 228946,
  [SMALL_STATE(13020)] = 229010,
  [SMALL_STATE(13021)] = 229064,
  [SMALL_STATE(13022)] = 229116,
  [SMALL_STATE(13023)] = 229166,
  [SMALL_STATE(13024)] = 229214,
  [SMALL_STATE(13025)] = 229260,
  [SMALL_STATE(13026)] = 229338,
  [SMALL_STATE(13027)] = 229402,
  [SMALL_STATE(13028)] = 229470,
  [SMALL_STATE(13029)] = 229546,
  [SMALL_STATE(13030)] = 229618,
  [SMALL_STATE(13031)] = 229688,
  [SMALL_STATE(13032)] = 229748,
  [SMALL_STATE(13033)] = 229812,
  [SMALL_STATE(13034)] = 229858,
  [SMALL_STATE(13035)] = 229922,
  [SMALL_STATE(13036)] = 229998,
  [SMALL_STATE(13037)] = 230070,
  [SMALL_STATE(13038)] = 230140,
  [SMALL_STATE(13039)] = 230200,
  [SMALL_STATE(13040)] = 230264,
  [SMALL_STATE(13041)] = 230318,
  [SMALL_STATE(13042)] = 230370,
  [SMALL_STATE(13043)] = 230420,
  [SMALL_STATE(13044)] = 230468,
  [SMALL_STATE(13045)] = 230514,
  [SMALL_STATE(13046)] = 230568,
  [SMALL_STATE(13047)] = 230620,
  [SMALL_STATE(13048)] = 230670,
  [SMALL_STATE(13049)] = 230718,
  [SMALL_STATE(13050)] = 230764,
  [SMALL_STATE(13051)] = 230810,
  [SMALL_STATE(13052)] = 230864,
  [SMALL_STATE(13053)] = 230910,
  [SMALL_STATE(13054)] = 230964,
  [SMALL_STATE(13055)] = 231010,
  [SMALL_STATE(13056)] = 231064,
  [SMALL_STATE(13057)] = 231110,
  [SMALL_STATE(13058)] = 231192,
  [SMALL_STATE(13059)] = 231236,
  [SMALL_STATE(13060)] = 231314,
  [SMALL_STATE(13061)] = 231358,
  [SMALL_STATE(13062)] = 231436,
  [SMALL_STATE(13063)] = 231500,
  [SMALL_STATE(13064)] = 231566,
  [SMALL_STATE(13065)] = 231640,
  [SMALL_STATE(13066)] = 231710,
  [SMALL_STATE(13067)] = 231778,
  [SMALL_STATE(13068)] = 231838,
  [SMALL_STATE(13069)] = 231902,
  [SMALL_STATE(13070)] = 231956,
  [SMALL_STATE(13071)] = 232008,
  [SMALL_STATE(13072)] = 232058,
  [SMALL_STATE(13073)] = 232106,
  [SMALL_STATE(13074)] = 232152,
  [SMALL_STATE(13075)] = 232216,
  [SMALL_STATE(13076)] = 232282,
  [SMALL_STATE(13077)] = 232356,
  [SMALL_STATE(13078)] = 232426,
  [SMALL_STATE(13079)] = 232494,
  [SMALL_STATE(13080)] = 232554,
  [SMALL_STATE(13081)] = 232618,
  [SMALL_STATE(13082)] = 232696,
  [SMALL_STATE(13083)] = 232740,
  [SMALL_STATE(13084)] = 232808,
  [SMALL_STATE(13085)] = 232852,
  [SMALL_STATE(13086)] = 232896,
  [SMALL_STATE(13087)] = 232940,
  [SMALL_STATE(13088)] = 232986,
  [SMALL_STATE(13089)] = 233050,
  [SMALL_STATE(13090)] = 233126,
  [SMALL_STATE(13091)] = 233198,
  [SMALL_STATE(13092)] = 233268,
  [SMALL_STATE(13093)] = 233328,
  [SMALL_STATE(13094)] = 233392,
  [SMALL_STATE(13095)] = 233446,
  [SMALL_STATE(13096)] = 233498,
  [SMALL_STATE(13097)] = 233548,
  [SMALL_STATE(13098)] = 233596,
  [SMALL_STATE(13099)] = 233642,
  [SMALL_STATE(13100)] = 233696,
  [SMALL_STATE(13101)] = 233748,
  [SMALL_STATE(13102)] = 233798,
  [SMALL_STATE(13103)] = 233846,
  [SMALL_STATE(13104)] = 233892,
  [SMALL_STATE(13105)] = 233938,
  [SMALL_STATE(13106)] = 234006,
  [SMALL_STATE(13107)] = 234052,
  [SMALL_STATE(13108)] = 234106,
  [SMALL_STATE(13109)] = 234152,
  [SMALL_STATE(13110)] = 234206,
  [SMALL_STATE(13111)] = 234252,
  [SMALL_STATE(13112)] = 234320,
  [SMALL_STATE(13113)] = 234366,
  [SMALL_STATE(13114)] = 234420,
  [SMALL_STATE(13115)] = 234466,
  [SMALL_STATE(13116)] = 234516,
  [SMALL_STATE(13117)] = 234560,
  [SMALL_STATE(13118)] = 234604,
  [SMALL_STATE(13119)] = 234648,
  [SMALL_STATE(13120)] = 234696,
  [SMALL_STATE(13121)] = 234740,
  [SMALL_STATE(13122)] = 234818,
  [SMALL_STATE(13123)] = 234896,
  [SMALL_STATE(13124)] = 234940,
  [SMALL_STATE(13125)] = 234984,
  [SMALL_STATE(13126)] = 235038,
  [SMALL_STATE(13127)] = 235116,
  [SMALL_STATE(13128)] = 235185,
  [SMALL_STATE(13129)] = 235234,
  [SMALL_STATE(13130)] = 235281,
  [SMALL_STATE(13131)] = 235326,
  [SMALL_STATE(13132)] = 235369,
  [SMALL_STATE(13133)] = 235420,
  [SMALL_STATE(13134)] = 235499,
  [SMALL_STATE(13135)] = 235542,
  [SMALL_STATE(13136)] = 235625,
  [SMALL_STATE(13137)] = 235704,
  [SMALL_STATE(13138)] = 235747,
  [SMALL_STATE(13139)] = 235798,
  [SMALL_STATE(13140)] = 235875,
  [SMALL_STATE(13141)] = 235918,
  [SMALL_STATE(13142)] = 235999,
  [SMALL_STATE(13143)] = 236042,
  [SMALL_STATE(13144)] = 236119,
  [SMALL_STATE(13145)] = 236170,
  [SMALL_STATE(13146)] = 236251,
  [SMALL_STATE(13147)] = 236294,
  [SMALL_STATE(13148)] = 236373,
  [SMALL_STATE(13149)] = 236424,
  [SMALL_STATE(13150)] = 236475,
  [SMALL_STATE(13151)] = 236554,
  [SMALL_STATE(13152)] = 236633,
  [SMALL_STATE(13153)] = 236676,
  [SMALL_STATE(13154)] = 236721,
  [SMALL_STATE(13155)] = 236800,
  [SMALL_STATE(13156)] = 236843,
  [SMALL_STATE(13157)] = 236924,
  [SMALL_STATE(13158)] = 237007,
  [SMALL_STATE(13159)] = 237090,
  [SMALL_STATE(13160)] = 237173,
  [SMALL_STATE(13161)] = 237252,
  [SMALL_STATE(13162)] = 237303,
  [SMALL_STATE(13163)] = 237354,
  [SMALL_STATE(13164)] = 237405,
  [SMALL_STATE(13165)] = 237456,
  [SMALL_STATE(13166)] = 237507,
  [SMALL_STATE(13167)] = 237588,
  [SMALL_STATE(13168)] = 237669,
  [SMALL_STATE(13169)] = 237750,
  [SMALL_STATE(13170)] = 237829,
  [SMALL_STATE(13171)] = 237872,
  [SMALL_STATE(13172)] = 237951,
  [SMALL_STATE(13173)] = 237994,
  [SMALL_STATE(13174)] = 238037,
  [SMALL_STATE(13175)] = 238088,
  [SMALL_STATE(13176)] = 238133,
  [SMALL_STATE(13177)] = 238184,
  [SMALL_STATE(13178)] = 238227,
  [SMALL_STATE(13179)] = 238308,
  [SMALL_STATE(13180)] = 238359,
  [SMALL_STATE(13181)] = 238410,
  [SMALL_STATE(13182)] = 238461,
  [SMALL_STATE(13183)] = 238540,
  [SMALL_STATE(13184)] = 238621,
  [SMALL_STATE(13185)] = 238672,
  [SMALL_STATE(13186)] = 238715,
  [SMALL_STATE(13187)] = 238760,
  [SMALL_STATE(13188)] = 238841,
  [SMALL_STATE(13189)] = 238920,
  [SMALL_STATE(13190)] = 238965,
  [SMALL_STATE(13191)] = 239028,
  [SMALL_STATE(13192)] = 239093,
  [SMALL_STATE(13193)] = 239144,
  [SMALL_STATE(13194)] = 239221,
  [SMALL_STATE(13195)] = 239300,
  [SMALL_STATE(13196)] = 239345,
  [SMALL_STATE(13197)] = 239424,
  [SMALL_STATE(13198)] = 239477,
  [SMALL_STATE(13199)] = 239554,
  [SMALL_STATE(13200)] = 239635,
  [SMALL_STATE(13201)] = 239698,
  [SMALL_STATE(13202)] = 239749,
  [SMALL_STATE(13203)] = 239814,
  [SMALL_STATE(13204)] = 239891,
  [SMALL_STATE(13205)] = 239954,
  [SMALL_STATE(13206)] = 240027,
  [SMALL_STATE(13207)] = 240096,
  [SMALL_STATE(13208)] = 240163,
  [SMALL_STATE(13209)] = 240222,
  [SMALL_STATE(13210)] = 240285,
  [SMALL_STATE(13211)] = 240338,
  [SMALL_STATE(13212)] = 240389,
  [SMALL_STATE(13213)] = 240438,
  [SMALL_STATE(13214)] = 240485,
  [SMALL_STATE(13215)] = 240530,
  [SMALL_STATE(13216)] = 240603,
  [SMALL_STATE(13217)] = 240672,
  [SMALL_STATE(13218)] = 240739,
  [SMALL_STATE(13219)] = 240802,
  [SMALL_STATE(13220)] = 240881,
  [SMALL_STATE(13221)] = 240956,
  [SMALL_STATE(13222)] = 241027,
  [SMALL_STATE(13223)] = 241096,
  [SMALL_STATE(13224)] = 241155,
  [SMALL_STATE(13225)] = 241218,
  [SMALL_STATE(13226)] = 241271,
  [SMALL_STATE(13227)] = 241322,
  [SMALL_STATE(13228)] = 241399,
  [SMALL_STATE(13229)] = 241442,
  [SMALL_STATE(13230)] = 241493,
  [SMALL_STATE(13231)] = 241538,
  [SMALL_STATE(13232)] = 241583,
  [SMALL_STATE(13233)] = 241634,
  [SMALL_STATE(13234)] = 241683,
  [SMALL_STATE(13235)] = 241726,
  [SMALL_STATE(13236)] = 241769,
  [SMALL_STATE(13237)] = 241812,
  [SMALL_STATE(13238)] = 241855,
  [SMALL_STATE(13239)] = 241900,
  [SMALL_STATE(13240)] = 241977,
  [SMALL_STATE(13241)] = 242024,
  [SMALL_STATE(13242)] = 242077,
  [SMALL_STATE(13243)] = 242120,
  [SMALL_STATE(13244)] = 242163,
  [SMALL_STATE(13245)] = 242208,
  [SMALL_STATE(13246)] = 242267,
  [SMALL_STATE(13247)] = 242330,
  [SMALL_STATE(13248)] = 242403,
  [SMALL_STATE(13249)] = 242454,
  [SMALL_STATE(13250)] = 242507,
  [SMALL_STATE(13251)] = 242560,
  [SMALL_STATE(13252)] = 242611,
  [SMALL_STATE(13253)] = 242662,
  [SMALL_STATE(13254)] = 242711,
  [SMALL_STATE(13255)] = 242758,
  [SMALL_STATE(13256)] = 242803,
  [SMALL_STATE(13257)] = 242854,
  [SMALL_STATE(13258)] = 242903,
  [SMALL_STATE(13259)] = 242950,
  [SMALL_STATE(13260)] = 243001,
  [SMALL_STATE(13261)] = 243046,
  [SMALL_STATE(13262)] = 243123,
  [SMALL_STATE(13263)] = 243200,
  [SMALL_STATE(13264)] = 243277,
  [SMALL_STATE(13265)] = 243354,
  [SMALL_STATE(13266)] = 243405,
  [SMALL_STATE(13267)] = 243474,
  [SMALL_STATE(13268)] = 243541,
  [SMALL_STATE(13269)] = 243600,
  [SMALL_STATE(13270)] = 243645,
  [SMALL_STATE(13271)] = 243708,
  [SMALL_STATE(13272)] = 243761,
  [SMALL_STATE(13273)] = 243812,
  [SMALL_STATE(13274)] = 243861,
  [SMALL_STATE(13275)] = 243908,
  [SMALL_STATE(13276)] = 243953,
  [SMALL_STATE(13277)] = 243996,
  [SMALL_STATE(13278)] = 244073,
  [SMALL_STATE(13279)] = 244116,
  [SMALL_STATE(13280)] = 244163,
  [SMALL_STATE(13281)] = 244214,
  [SMALL_STATE(13282)] = 244259,
  [SMALL_STATE(13283)] = 244304,
  [SMALL_STATE(13284)] = 244381,
  [SMALL_STATE(13285)] = 244432,
  [SMALL_STATE(13286)] = 244509,
  [SMALL_STATE(13287)] = 244572,
  [SMALL_STATE(13288)] = 244623,
  [SMALL_STATE(13289)] = 244666,
  [SMALL_STATE(13290)] = 244733,
  [SMALL_STATE(13291)] = 244812,
  [SMALL_STATE(13292)] = 244879,
  [SMALL_STATE(13293)] = 244958,
  [SMALL_STATE(13294)] = 245001,
  [SMALL_STATE(13295)] = 245064,
  [SMALL_STATE(13296)] = 245115,
  [SMALL_STATE(13297)] = 245190,
  [SMALL_STATE(13298)] = 245261,
  [SMALL_STATE(13299)] = 245342,
  [SMALL_STATE(13300)] = 245387,
  [SMALL_STATE(13301)] = 245438,
  [SMALL_STATE(13302)] = 245497,
  [SMALL_STATE(13303)] = 245550,
  [SMALL_STATE(13304)] = 245613,
  [SMALL_STATE(13305)] = 245678,
  [SMALL_STATE(13306)] = 245755,
  [SMALL_STATE(13307)] = 245828,
  [SMALL_STATE(13308)] = 245897,
  [SMALL_STATE(13309)] = 245964,
  [SMALL_STATE(13310)] = 246027,
  [SMALL_STATE(13311)] = 246078,
  [SMALL_STATE(13312)] = 246137,
  [SMALL_STATE(13313)] = 246200,
  [SMALL_STATE(13314)] = 246245,
  [SMALL_STATE(13315)] = 246298,
  [SMALL_STATE(13316)] = 246351,
  [SMALL_STATE(13317)] = 246416,
  [SMALL_STATE(13318)] = 246467,
  [SMALL_STATE(13319)] = 246516,
  [SMALL_STATE(13320)] = 246563,
  [SMALL_STATE(13321)] = 246626,
  [SMALL_STATE(13322)] = 246693,
  [SMALL_STATE(13323)] = 246768,
  [SMALL_STATE(13324)] = 246839,
  [SMALL_STATE(13325)] = 246908,
  [SMALL_STATE(13326)] = 246967,
  [SMALL_STATE(13327)] = 247030,
  [SMALL_STATE(13328)] = 247083,
  [SMALL_STATE(13329)] = 247134,
  [SMALL_STATE(13330)] = 247183,
  [SMALL_STATE(13331)] = 247230,
  [SMALL_STATE(13332)] = 247275,
  [SMALL_STATE(13333)] = 247320,
  [SMALL_STATE(13334)] = 247373,
  [SMALL_STATE(13335)] = 247426,
  [SMALL_STATE(13336)] = 247471,
  [SMALL_STATE(13337)] = 247548,
  [SMALL_STATE(13338)] = 247599,
  [SMALL_STATE(13339)] = 247652,
  [SMALL_STATE(13340)] = 247729,
  [SMALL_STATE(13341)] = 247778,
  [SMALL_STATE(13342)] = 247825,
  [SMALL_STATE(13343)] = 247870,
  [SMALL_STATE(13344)] = 247945,
  [SMALL_STATE(13345)] = 247990,
  [SMALL_STATE(13346)] = 248061,
  [SMALL_STATE(13347)] = 248130,
  [SMALL_STATE(13348)] = 248173,
  [SMALL_STATE(13349)] = 248216,
  [SMALL_STATE(13350)] = 248259,
  [SMALL_STATE(13351)] = 248318,
  [SMALL_STATE(13352)] = 248397,
  [SMALL_STATE(13353)] = 248460,
  [SMALL_STATE(13354)] = 248505,
  [SMALL_STATE(13355)] = 248558,
  [SMALL_STATE(13356)] = 248625,
  [SMALL_STATE(13357)] = 248668,
  [SMALL_STATE(13358)] = 248721,
  [SMALL_STATE(13359)] = 248766,
  [SMALL_STATE(13360)] = 248819,
  [SMALL_STATE(13361)] = 248870,
  [SMALL_STATE(13362)] = 248915,
  [SMALL_STATE(13363)] = 248960,
  [SMALL_STATE(13364)] = 249005,
  [SMALL_STATE(13365)] = 249058,
  [SMALL_STATE(13366)] = 249103,
  [SMALL_STATE(13367)] = 249154,
  [SMALL_STATE(13368)] = 249205,
  [SMALL_STATE(13369)] = 249268,
  [SMALL_STATE(13370)] = 249345,
  [SMALL_STATE(13371)] = 249388,
  [SMALL_STATE(13372)] = 249453,
  [SMALL_STATE(13373)] = 249530,
  [SMALL_STATE(13374)] = 249603,
  [SMALL_STATE(13375)] = 249672,
  [SMALL_STATE(13376)] = 249739,
  [SMALL_STATE(13377)] = 249798,
  [SMALL_STATE(13378)] = 249861,
  [SMALL_STATE(13379)] = 249912,
  [SMALL_STATE(13380)] = 249963,
  [SMALL_STATE(13381)] = 250012,
  [SMALL_STATE(13382)] = 250089,
  [SMALL_STATE(13383)] = 250136,
  [SMALL_STATE(13384)] = 250181,
  [SMALL_STATE(13385)] = 250258,
  [SMALL_STATE(13386)] = 250335,
  [SMALL_STATE(13387)] = 250380,
  [SMALL_STATE(13388)] = 250459,
  [SMALL_STATE(13389)] = 250510,
  [SMALL_STATE(13390)] = 250555,
  [SMALL_STATE(13391)] = 250632,
  [SMALL_STATE(13392)] = 250709,
  [SMALL_STATE(13393)] = 250760,
  [SMALL_STATE(13394)] = 250837,
  [SMALL_STATE(13395)] = 250890,
  [SMALL_STATE(13396)] = 250971,
  [SMALL_STATE(13397)] = 251048,
  [SMALL_STATE(13398)] = 251099,
  [SMALL_STATE(13399)] = 251162,
  [SMALL_STATE(13400)] = 251213,
  [SMALL_STATE(13401)] = 251256,
  [SMALL_STATE(13402)] = 251321,
  [SMALL_STATE(13403)] = 251366,
  [SMALL_STATE(13404)] = 251411,
  [SMALL_STATE(13405)] = 251456,
  [SMALL_STATE(13406)] = 251533,
  [SMALL_STATE(13407)] = 251606,
  [SMALL_STATE(13408)] = 251685,
  [SMALL_STATE(13409)] = 251730,
  [SMALL_STATE(13410)] = 251775,
  [SMALL_STATE(13411)] = 251844,
  [SMALL_STATE(13412)] = 251889,
  [SMALL_STATE(13413)] = 251932,
  [SMALL_STATE(13414)] = 251975,
  [SMALL_STATE(13415)] = 252018,
  [SMALL_STATE(13416)] = 252095,
  [SMALL_STATE(13417)] = 252138,
  [SMALL_STATE(13418)] = 252189,
  [SMALL_STATE(13419)] = 252240,
  [SMALL_STATE(13420)] = 252307,
  [SMALL_STATE(13421)] = 252358,
  [SMALL_STATE(13422)] = 252417,
  [SMALL_STATE(13423)] = 252480,
  [SMALL_STATE(13424)] = 252531,
  [SMALL_STATE(13425)] = 252574,
  [SMALL_STATE(13426)] = 252625,
  [SMALL_STATE(13427)] = 252678,
  [SMALL_STATE(13428)] = 252729,
  [SMALL_STATE(13429)] = 252780,
  [SMALL_STATE(13430)] = 252831,
  [SMALL_STATE(13431)] = 252882,
  [SMALL_STATE(13432)] = 252933,
  [SMALL_STATE(13433)] = 253014,
  [SMALL_STATE(13434)] = 253065,
  [SMALL_STATE(13435)] = 253146,
  [SMALL_STATE(13436)] = 253197,
  [SMALL_STATE(13437)] = 253248,
  [SMALL_STATE(13438)] = 253299,
  [SMALL_STATE(13439)] = 253378,
  [SMALL_STATE(13440)] = 253440,
  [SMALL_STATE(13441)] = 253520,
  [SMALL_STATE(13442)] = 253564,
  [SMALL_STATE(13443)] = 253644,
  [SMALL_STATE(13444)] = 253724,
  [SMALL_STATE(13445)] = 253804,
  [SMALL_STATE(13446)] = 253884,
  [SMALL_STATE(13447)] = 253964,
  [SMALL_STATE(13448)] = 254044,
  [SMALL_STATE(13449)] = 254124,
  [SMALL_STATE(13450)] = 254204,
  [SMALL_STATE(13451)] = 254248,
  [SMALL_STATE(13452)] = 254328,
  [SMALL_STATE(13453)] = 254380,
  [SMALL_STATE(13454)] = 254446,
  [SMALL_STATE(13455)] = 254524,
  [SMALL_STATE(13456)] = 254604,
  [SMALL_STATE(13457)] = 254684,
  [SMALL_STATE(13458)] = 254736,
  [SMALL_STATE(13459)] = 254816,
  [SMALL_STATE(13460)] = 254896,
  [SMALL_STATE(13461)] = 254942,
  [SMALL_STATE(13462)] = 255022,
  [SMALL_STATE(13463)] = 255102,
  [SMALL_STATE(13464)] = 255182,
  [SMALL_STATE(13465)] = 255262,
  [SMALL_STATE(13466)] = 255304,
  [SMALL_STATE(13467)] = 255348,
  [SMALL_STATE(13468)] = 255390,
  [SMALL_STATE(13469)] = 255432,
  [SMALL_STATE(13470)] = 255512,
  [SMALL_STATE(13471)] = 255592,
  [SMALL_STATE(13472)] = 255636,
  [SMALL_STATE(13473)] = 255716,
  [SMALL_STATE(13474)] = 255796,
  [SMALL_STATE(13475)] = 255876,
  [SMALL_STATE(13476)] = 255920,
  [SMALL_STATE(13477)] = 256000,
  [SMALL_STATE(13478)] = 256080,
  [SMALL_STATE(13479)] = 256132,
  [SMALL_STATE(13480)] = 256176,
  [SMALL_STATE(13481)] = 256238,
  [SMALL_STATE(13482)] = 256318,
  [SMALL_STATE(13483)] = 256382,
  [SMALL_STATE(13484)] = 256458,
  [SMALL_STATE(13485)] = 256530,
  [SMALL_STATE(13486)] = 256598,
  [SMALL_STATE(13487)] = 256664,
  [SMALL_STATE(13488)] = 256722,
  [SMALL_STATE(13489)] = 256802,
  [SMALL_STATE(13490)] = 256864,
  [SMALL_STATE(13491)] = 256916,
  [SMALL_STATE(13492)] = 256966,
  [SMALL_STATE(13493)] = 257014,
  [SMALL_STATE(13494)] = 257060,
  [SMALL_STATE(13495)] = 257104,
  [SMALL_STATE(13496)] = 257156,
  [SMALL_STATE(13497)] = 257236,
  [SMALL_STATE(13498)] = 257288,
  [SMALL_STATE(13499)] = 257364,
  [SMALL_STATE(13500)] = 257440,
  [SMALL_STATE(13501)] = 257520,
  [SMALL_STATE(13502)] = 257600,
  [SMALL_STATE(13503)] = 257680,
  [SMALL_STATE(13504)] = 257760,
  [SMALL_STATE(13505)] = 257840,
  [SMALL_STATE(13506)] = 257920,
  [SMALL_STATE(13507)] = 258000,
  [SMALL_STATE(13508)] = 258080,
  [SMALL_STATE(13509)] = 258160,
  [SMALL_STATE(13510)] = 258202,
  [SMALL_STATE(13511)] = 258282,
  [SMALL_STATE(13512)] = 258362,
  [SMALL_STATE(13513)] = 258442,
  [SMALL_STATE(13514)] = 258494,
  [SMALL_STATE(13515)] = 258546,
  [SMALL_STATE(13516)] = 258626,
  [SMALL_STATE(13517)] = 258706,
  [SMALL_STATE(13518)] = 258786,
  [SMALL_STATE(13519)] = 258866,
  [SMALL_STATE(13520)] = 258946,
  [SMALL_STATE(13521)] = 258990,
  [SMALL_STATE(13522)] = 259070,
  [SMALL_STATE(13523)] = 259122,
  [SMALL_STATE(13524)] = 259166,
  [SMALL_STATE(13525)] = 259246,
  [SMALL_STATE(13526)] = 259298,
  [SMALL_STATE(13527)] = 259378,
  [SMALL_STATE(13528)] = 259458,
  [SMALL_STATE(13529)] = 259538,
  [SMALL_STATE(13530)] = 259618,
  [SMALL_STATE(13531)] = 259698,
  [SMALL_STATE(13532)] = 259778,
  [SMALL_STATE(13533)] = 259858,
  [SMALL_STATE(13534)] = 259938,
  [SMALL_STATE(13535)] = 260018,
  [SMALL_STATE(13536)] = 260098,
  [SMALL_STATE(13537)] = 260178,
  [SMALL_STATE(13538)] = 260258,
  [SMALL_STATE(13539)] = 260338,
  [SMALL_STATE(13540)] = 260418,
  [SMALL_STATE(13541)] = 260498,
  [SMALL_STATE(13542)] = 260550,
  [SMALL_STATE(13543)] = 260602,
  [SMALL_STATE(13544)] = 260682,
  [SMALL_STATE(13545)] = 260734,
  [SMALL_STATE(13546)] = 260814,
  [SMALL_STATE(13547)] = 260866,
  [SMALL_STATE(13548)] = 260946,
  [SMALL_STATE(13549)] = 261026,
  [SMALL_STATE(13550)] = 261106,
  [SMALL_STATE(13551)] = 261186,
  [SMALL_STATE(13552)] = 261230,
  [SMALL_STATE(13553)] = 261310,
  [SMALL_STATE(13554)] = 261390,
  [SMALL_STATE(13555)] = 261470,
  [SMALL_STATE(13556)] = 261550,
  [SMALL_STATE(13557)] = 261594,
  [SMALL_STATE(13558)] = 261674,
  [SMALL_STATE(13559)] = 261754,
  [SMALL_STATE(13560)] = 261834,
  [SMALL_STATE(13561)] = 261914,
  [SMALL_STATE(13562)] = 261994,
  [SMALL_STATE(13563)] = 262074,
  [SMALL_STATE(13564)] = 262154,
  [SMALL_STATE(13565)] = 262234,
  [SMALL_STATE(13566)] = 262314,
  [SMALL_STATE(13567)] = 262356,
  [SMALL_STATE(13568)] = 262436,
  [SMALL_STATE(13569)] = 262516,
  [SMALL_STATE(13570)] = 262596,
  [SMALL_STATE(13571)] = 262672,
  [SMALL_STATE(13572)] = 262752,
  [SMALL_STATE(13573)] = 262832,
  [SMALL_STATE(13574)] = 262912,
  [SMALL_STATE(13575)] = 262992,
  [SMALL_STATE(13576)] = 263058,
  [SMALL_STATE(13577)] = 263138,
  [SMALL_STATE(13578)] = 263218,
  [SMALL_STATE(13579)] = 263298,
  [SMALL_STATE(13580)] = 263378,
  [SMALL_STATE(13581)] = 263458,
  [SMALL_STATE(13582)] = 263500,
  [SMALL_STATE(13583)] = 263580,
  [SMALL_STATE(13584)] = 263660,
  [SMALL_STATE(13585)] = 263704,
  [SMALL_STATE(13586)] = 263748,
  [SMALL_STATE(13587)] = 263792,
  [SMALL_STATE(13588)] = 263872,
  [SMALL_STATE(13589)] = 263952,
  [SMALL_STATE(13590)] = 263996,
  [SMALL_STATE(13591)] = 264076,
  [SMALL_STATE(13592)] = 264156,
  [SMALL_STATE(13593)] = 264236,
  [SMALL_STATE(13594)] = 264316,
  [SMALL_STATE(13595)] = 264396,
  [SMALL_STATE(13596)] = 264476,
  [SMALL_STATE(13597)] = 264520,
  [SMALL_STATE(13598)] = 264600,
  [SMALL_STATE(13599)] = 264680,
  [SMALL_STATE(13600)] = 264732,
  [SMALL_STATE(13601)] = 264812,
  [SMALL_STATE(13602)] = 264856,
  [SMALL_STATE(13603)] = 264900,
  [SMALL_STATE(13604)] = 264952,
  [SMALL_STATE(13605)] = 265004,
  [SMALL_STATE(13606)] = 265046,
  [SMALL_STATE(13607)] = 265092,
  [SMALL_STATE(13608)] = 265172,
  [SMALL_STATE(13609)] = 265224,
  [SMALL_STATE(13610)] = 265304,
  [SMALL_STATE(13611)] = 265350,
  [SMALL_STATE(13612)] = 265430,
  [SMALL_STATE(13613)] = 265474,
  [SMALL_STATE(13614)] = 265518,
  [SMALL_STATE(13615)] = 265598,
  [SMALL_STATE(13616)] = 265678,
  [SMALL_STATE(13617)] = 265758,
  [SMALL_STATE(13618)] = 265800,
  [SMALL_STATE(13619)] = 265880,
  [SMALL_STATE(13620)] = 265960,
  [SMALL_STATE(13621)] = 266004,
  [SMALL_STATE(13622)] = 266048,
  [SMALL_STATE(13623)] = 266128,
  [SMALL_STATE(13624)] = 266172,
  [SMALL_STATE(13625)] = 266216,
  [SMALL_STATE(13626)] = 266294,
  [SMALL_STATE(13627)] = 266336,
  [SMALL_STATE(13628)] = 266380,
  [SMALL_STATE(13629)] = 266460,
  [SMALL_STATE(13630)] = 266538,
  [SMALL_STATE(13631)] = 266582,
  [SMALL_STATE(13632)] = 266634,
  [SMALL_STATE(13633)] = 266678,
  [SMALL_STATE(13634)] = 266730,
  [SMALL_STATE(13635)] = 266774,
  [SMALL_STATE(13636)] = 266836,
  [SMALL_STATE(13637)] = 266914,
  [SMALL_STATE(13638)] = 266988,
  [SMALL_STATE(13639)] = 267058,
  [SMALL_STATE(13640)] = 267126,
  [SMALL_STATE(13641)] = 267184,
  [SMALL_STATE(13642)] = 267246,
  [SMALL_STATE(13643)] = 267298,
  [SMALL_STATE(13644)] = 267348,
  [SMALL_STATE(13645)] = 267396,
  [SMALL_STATE(13646)] = 267442,
  [SMALL_STATE(13647)] = 267486,
  [SMALL_STATE(13648)] = 267566,
  [SMALL_STATE(13649)] = 267646,
  [SMALL_STATE(13650)] = 267692,
  [SMALL_STATE(13651)] = 267768,
  [SMALL_STATE(13652)] = 267848,
  [SMALL_STATE(13653)] = 267920,
  [SMALL_STATE(13654)] = 267988,
  [SMALL_STATE(13655)] = 268054,
  [SMALL_STATE(13656)] = 268112,
  [SMALL_STATE(13657)] = 268192,
  [SMALL_STATE(13658)] = 268254,
  [SMALL_STATE(13659)] = 268334,
  [SMALL_STATE(13660)] = 268386,
  [SMALL_STATE(13661)] = 268466,
  [SMALL_STATE(13662)] = 268510,
  [SMALL_STATE(13663)] = 268590,
  [SMALL_STATE(13664)] = 268632,
  [SMALL_STATE(13665)] = 268712,
  [SMALL_STATE(13666)] = 268788,
  [SMALL_STATE(13667)] = 268868,
  [SMALL_STATE(13668)] = 268918,
  [SMALL_STATE(13669)] = 268966,
  [SMALL_STATE(13670)] = 269012,
  [SMALL_STATE(13671)] = 269056,
  [SMALL_STATE(13672)] = 269108,
  [SMALL_STATE(13673)] = 269160,
  [SMALL_STATE(13674)] = 269204,
  [SMALL_STATE(13675)] = 269282,
  [SMALL_STATE(13676)] = 269334,
  [SMALL_STATE(13677)] = 269376,
  [SMALL_STATE(13678)] = 269418,
  [SMALL_STATE(13679)] = 269460,
  [SMALL_STATE(13680)] = 269504,
  [SMALL_STATE(13681)] = 269556,
  [SMALL_STATE(13682)] = 269600,
  [SMALL_STATE(13683)] = 269644,
  [SMALL_STATE(13684)] = 269686,
  [SMALL_STATE(13685)] = 269748,
  [SMALL_STATE(13686)] = 269826,
  [SMALL_STATE(13687)] = 269900,
  [SMALL_STATE(13688)] = 269970,
  [SMALL_STATE(13689)] = 270038,
  [SMALL_STATE(13690)] = 270096,
  [SMALL_STATE(13691)] = 270148,
  [SMALL_STATE(13692)] = 270210,
  [SMALL_STATE(13693)] = 270262,
  [SMALL_STATE(13694)] = 270312,
  [SMALL_STATE(13695)] = 270354,
  [SMALL_STATE(13696)] = 270396,
  [SMALL_STATE(13697)] = 270438,
  [SMALL_STATE(13698)] = 270518,
  [SMALL_STATE(13699)] = 270560,
  [SMALL_STATE(13700)] = 270604,
  [SMALL_STATE(13701)] = 270652,
  [SMALL_STATE(13702)] = 270698,
  [SMALL_STATE(13703)] = 270742,
  [SMALL_STATE(13704)] = 270784,
  [SMALL_STATE(13705)] = 270828,
  [SMALL_STATE(13706)] = 270880,
  [SMALL_STATE(13707)] = 270932,
  [SMALL_STATE(13708)] = 271012,
  [SMALL_STATE(13709)] = 271056,
  [SMALL_STATE(13710)] = 271100,
  [SMALL_STATE(13711)] = 271144,
  [SMALL_STATE(13712)] = 271188,
  [SMALL_STATE(13713)] = 271232,
  [SMALL_STATE(13714)] = 271284,
  [SMALL_STATE(13715)] = 271336,
  [SMALL_STATE(13716)] = 271380,
  [SMALL_STATE(13717)] = 271424,
  [SMALL_STATE(13718)] = 271468,
  [SMALL_STATE(13719)] = 271520,
  [SMALL_STATE(13720)] = 271600,
  [SMALL_STATE(13721)] = 271644,
  [SMALL_STATE(13722)] = 271696,
  [SMALL_STATE(13723)] = 271748,
  [SMALL_STATE(13724)] = 271828,
  [SMALL_STATE(13725)] = 271880,
  [SMALL_STATE(13726)] = 271924,
  [SMALL_STATE(13727)] = 271976,
  [SMALL_STATE(13728)] = 272054,
  [SMALL_STATE(13729)] = 272096,
  [SMALL_STATE(13730)] = 272148,
  [SMALL_STATE(13731)] = 272200,
  [SMALL_STATE(13732)] = 272244,
  [SMALL_STATE(13733)] = 272324,
  [SMALL_STATE(13734)] = 272376,
  [SMALL_STATE(13735)] = 272428,
  [SMALL_STATE(13736)] = 272480,
  [SMALL_STATE(13737)] = 272532,
  [SMALL_STATE(13738)] = 272584,
  [SMALL_STATE(13739)] = 272636,
  [SMALL_STATE(13740)] = 272688,
  [SMALL_STATE(13741)] = 272740,
  [SMALL_STATE(13742)] = 272792,
  [SMALL_STATE(13743)] = 272844,
  [SMALL_STATE(13744)] = 272920,
  [SMALL_STATE(13745)] = 272972,
  [SMALL_STATE(13746)] = 273024,
  [SMALL_STATE(13747)] = 273104,
  [SMALL_STATE(13748)] = 273180,
  [SMALL_STATE(13749)] = 273260,
  [SMALL_STATE(13750)] = 273340,
  [SMALL_STATE(13751)] = 273418,
  [SMALL_STATE(13752)] = 273498,
  [SMALL_STATE(13753)] = 273550,
  [SMALL_STATE(13754)] = 273630,
  [SMALL_STATE(13755)] = 273706,
  [SMALL_STATE(13756)] = 273750,
  [SMALL_STATE(13757)] = 273794,
  [SMALL_STATE(13758)] = 273836,
  [SMALL_STATE(13759)] = 273878,
  [SMALL_STATE(13760)] = 273920,
  [SMALL_STATE(13761)] = 274000,
  [SMALL_STATE(13762)] = 274080,
  [SMALL_STATE(13763)] = 274160,
  [SMALL_STATE(13764)] = 274204,
  [SMALL_STATE(13765)] = 274248,
  [SMALL_STATE(13766)] = 274328,
  [SMALL_STATE(13767)] = 274408,
  [SMALL_STATE(13768)] = 274488,
  [SMALL_STATE(13769)] = 274568,
  [SMALL_STATE(13770)] = 274612,
  [SMALL_STATE(13771)] = 274688,
  [SMALL_STATE(13772)] = 274732,
  [SMALL_STATE(13773)] = 274776,
  [SMALL_STATE(13774)] = 274820,
  [SMALL_STATE(13775)] = 274900,
  [SMALL_STATE(13776)] = 274944,
  [SMALL_STATE(13777)] = 275024,
  [SMALL_STATE(13778)] = 275068,
  [SMALL_STATE(13779)] = 275112,
  [SMALL_STATE(13780)] = 275164,
  [SMALL_STATE(13781)] = 275216,
  [SMALL_STATE(13782)] = 275268,
  [SMALL_STATE(13783)] = 275312,
  [SMALL_STATE(13784)] = 275392,
  [SMALL_STATE(13785)] = 275470,
  [SMALL_STATE(13786)] = 275548,
  [SMALL_STATE(13787)] = 275592,
  [SMALL_STATE(13788)] = 275636,
  [SMALL_STATE(13789)] = 275678,
  [SMALL_STATE(13790)] = 275730,
  [SMALL_STATE(13791)] = 275782,
  [SMALL_STATE(13792)] = 275862,
  [SMALL_STATE(13793)] = 275938,
  [SMALL_STATE(13794)] = 275982,
  [SMALL_STATE(13795)] = 276026,
  [SMALL_STATE(13796)] = 276104,
  [SMALL_STATE(13797)] = 276182,
  [SMALL_STATE(13798)] = 276262,
  [SMALL_STATE(13799)] = 276342,
  [SMALL_STATE(13800)] = 276422,
  [SMALL_STATE(13801)] = 276498,
  [SMALL_STATE(13802)] = 276578,
  [SMALL_STATE(13803)] = 276658,
  [SMALL_STATE(13804)] = 276738,
  [SMALL_STATE(13805)] = 276782,
  [SMALL_STATE(13806)] = 276862,
  [SMALL_STATE(13807)] = 276906,
  [SMALL_STATE(13808)] = 276950,
  [SMALL_STATE(13809)] = 277002,
  [SMALL_STATE(13810)] = 277054,
  [SMALL_STATE(13811)] = 277098,
  [SMALL_STATE(13812)] = 277150,
  [SMALL_STATE(13813)] = 277202,
  [SMALL_STATE(13814)] = 277282,
  [SMALL_STATE(13815)] = 277362,
  [SMALL_STATE(13816)] = 277414,
  [SMALL_STATE(13817)] = 277466,
  [SMALL_STATE(13818)] = 277546,
  [SMALL_STATE(13819)] = 277598,
  [SMALL_STATE(13820)] = 277650,
  [SMALL_STATE(13821)] = 277702,
  [SMALL_STATE(13822)] = 277754,
  [SMALL_STATE(13823)] = 277806,
  [SMALL_STATE(13824)] = 277886,
  [SMALL_STATE(13825)] = 277966,
  [SMALL_STATE(13826)] = 278028,
  [SMALL_STATE(13827)] = 278092,
  [SMALL_STATE(13828)] = 278164,
  [SMALL_STATE(13829)] = 278232,
  [SMALL_STATE(13830)] = 278298,
  [SMALL_STATE(13831)] = 278356,
  [SMALL_STATE(13832)] = 278418,
  [SMALL_STATE(13833)] = 278470,
  [SMALL_STATE(13834)] = 278520,
  [SMALL_STATE(13835)] = 278568,
  [SMALL_STATE(13836)] = 278614,
  [SMALL_STATE(13837)] = 278658,
  [SMALL_STATE(13838)] = 278738,
  [SMALL_STATE(13839)] = 278782,
  [SMALL_STATE(13840)] = 278826,
  [SMALL_STATE(13841)] = 278870,
  [SMALL_STATE(13842)] = 278922,
  [SMALL_STATE(13843)] = 278964,
  [SMALL_STATE(13844)] = 279016,
  [SMALL_STATE(13845)] = 279058,
  [SMALL_STATE(13846)] = 279100,
  [SMALL_STATE(13847)] = 279180,
  [SMALL_STATE(13848)] = 279224,
  [SMALL_STATE(13849)] = 279268,
  [SMALL_STATE(13850)] = 279348,
  [SMALL_STATE(13851)] = 279428,
  [SMALL_STATE(13852)] = 279472,
  [SMALL_STATE(13853)] = 279536,
  [SMALL_STATE(13854)] = 279580,
  [SMALL_STATE(13855)] = 279624,
  [SMALL_STATE(13856)] = 279668,
  [SMALL_STATE(13857)] = 279712,
  [SMALL_STATE(13858)] = 279792,
  [SMALL_STATE(13859)] = 279836,
  [SMALL_STATE(13860)] = 279916,
  [SMALL_STATE(13861)] = 279962,
  [SMALL_STATE(13862)] = 280014,
  [SMALL_STATE(13863)] = 280066,
  [SMALL_STATE(13864)] = 280110,
  [SMALL_STATE(13865)] = 280154,
  [SMALL_STATE(13866)] = 280234,
  [SMALL_STATE(13867)] = 280286,
  [SMALL_STATE(13868)] = 280330,
  [SMALL_STATE(13869)] = 280374,
  [SMALL_STATE(13870)] = 280418,
  [SMALL_STATE(13871)] = 280470,
  [SMALL_STATE(13872)] = 280550,
  [SMALL_STATE(13873)] = 280626,
  [SMALL_STATE(13874)] = 280706,
  [SMALL_STATE(13875)] = 280786,
  [SMALL_STATE(13876)] = 280830,
  [SMALL_STATE(13877)] = 280874,
  [SMALL_STATE(13878)] = 280954,
  [SMALL_STATE(13879)] = 281034,
  [SMALL_STATE(13880)] = 281114,
  [SMALL_STATE(13881)] = 281166,
  [SMALL_STATE(13882)] = 281218,
  [SMALL_STATE(13883)] = 281270,
  [SMALL_STATE(13884)] = 281322,
  [SMALL_STATE(13885)] = 281364,
  [SMALL_STATE(13886)] = 281416,
  [SMALL_STATE(13887)] = 281468,
  [SMALL_STATE(13888)] = 281520,
  [SMALL_STATE(13889)] = 281572,
  [SMALL_STATE(13890)] = 281616,
  [SMALL_STATE(13891)] = 281668,
  [SMALL_STATE(13892)] = 281720,
  [SMALL_STATE(13893)] = 281764,
  [SMALL_STATE(13894)] = 281816,
  [SMALL_STATE(13895)] = 281868,
  [SMALL_STATE(13896)] = 281948,
  [SMALL_STATE(13897)] = 282000,
  [SMALL_STATE(13898)] = 282052,
  [SMALL_STATE(13899)] = 282104,
  [SMALL_STATE(13900)] = 282156,
  [SMALL_STATE(13901)] = 282208,
  [SMALL_STATE(13902)] = 282260,
  [SMALL_STATE(13903)] = 282312,
  [SMALL_STATE(13904)] = 282364,
  [SMALL_STATE(13905)] = 282416,
  [SMALL_STATE(13906)] = 282496,
  [SMALL_STATE(13907)] = 282572,
  [SMALL_STATE(13908)] = 282624,
  [SMALL_STATE(13909)] = 282700,
  [SMALL_STATE(13910)] = 282752,
  [SMALL_STATE(13911)] = 282804,
  [SMALL_STATE(13912)] = 282856,
  [SMALL_STATE(13913)] = 282908,
  [SMALL_STATE(13914)] = 282988,
  [SMALL_STATE(13915)] = 283068,
  [SMALL_STATE(13916)] = 283112,
  [SMALL_STATE(13917)] = 283156,
  [SMALL_STATE(13918)] = 283200,
  [SMALL_STATE(13919)] = 283280,
  [SMALL_STATE(13920)] = 283324,
  [SMALL_STATE(13921)] = 283368,
  [SMALL_STATE(13922)] = 283448,
  [SMALL_STATE(13923)] = 283500,
  [SMALL_STATE(13924)] = 283552,
  [SMALL_STATE(13925)] = 283632,
  [SMALL_STATE(13926)] = 283712,
  [SMALL_STATE(13927)] = 283788,
  [SMALL_STATE(13928)] = 283832,
  [SMALL_STATE(13929)] = 283876,
  [SMALL_STATE(13930)] = 283956,
  [SMALL_STATE(13931)] = 284036,
  [SMALL_STATE(13932)] = 284080,
  [SMALL_STATE(13933)] = 284160,
  [SMALL_STATE(13934)] = 284240,
  [SMALL_STATE(13935)] = 284284,
  [SMALL_STATE(13936)] = 284328,
  [SMALL_STATE(13937)] = 284408,
  [SMALL_STATE(13938)] = 284460,
  [SMALL_STATE(13939)] = 284512,
  [SMALL_STATE(13940)] = 284592,
  [SMALL_STATE(13941)] = 284672,
  [SMALL_STATE(13942)] = 284718,
  [SMALL_STATE(13943)] = 284798,
  [SMALL_STATE(13944)] = 284878,
  [SMALL_STATE(13945)] = 284920,
  [SMALL_STATE(13946)] = 285000,
  [SMALL_STATE(13947)] = 285044,
  [SMALL_STATE(13948)] = 285096,
  [SMALL_STATE(13949)] = 285140,
  [SMALL_STATE(13950)] = 285220,
  [SMALL_STATE(13951)] = 285300,
  [SMALL_STATE(13952)] = 285352,
  [SMALL_STATE(13953)] = 285432,
  [SMALL_STATE(13954)] = 285476,
  [SMALL_STATE(13955)] = 285528,
  [SMALL_STATE(13956)] = 285608,
  [SMALL_STATE(13957)] = 285688,
  [SMALL_STATE(13958)] = 285740,
  [SMALL_STATE(13959)] = 285784,
  [SMALL_STATE(13960)] = 285860,
  [SMALL_STATE(13961)] = 285940,
  [SMALL_STATE(13962)] = 285984,
  [SMALL_STATE(13963)] = 286028,
  [SMALL_STATE(13964)] = 286108,
  [SMALL_STATE(13965)] = 286186,
  [SMALL_STATE(13966)] = 286266,
  [SMALL_STATE(13967)] = 286346,
  [SMALL_STATE(13968)] = 286426,
  [SMALL_STATE(13969)] = 286506,
  [SMALL_STATE(13970)] = 286550,
  [SMALL_STATE(13971)] = 286602,
  [SMALL_STATE(13972)] = 286654,
  [SMALL_STATE(13973)] = 286698,
  [SMALL_STATE(13974)] = 286778,
  [SMALL_STATE(13975)] = 286858,
  [SMALL_STATE(13976)] = 286938,
  [SMALL_STATE(13977)] = 287013,
  [SMALL_STATE(13978)] = 287090,
  [SMALL_STATE(13979)] = 287165,
  [SMALL_STATE(13980)] = 287242,
  [SMALL_STATE(13981)] = 287299,
  [SMALL_STATE(13982)] = 287376,
  [SMALL_STATE(13983)] = 287453,
  [SMALL_STATE(13984)] = 287494,
  [SMALL_STATE(13985)] = 287535,
  [SMALL_STATE(13986)] = 287576,
  [SMALL_STATE(13987)] = 287617,
  [SMALL_STATE(13988)] = 287678,
  [SMALL_STATE(13989)] = 287719,
  [SMALL_STATE(13990)] = 287760,
  [SMALL_STATE(13991)] = 287803,
  [SMALL_STATE(13992)] = 287854,
  [SMALL_STATE(13993)] = 287895,
  [SMALL_STATE(13994)] = 287936,
  [SMALL_STATE(13995)] = 287977,
  [SMALL_STATE(13996)] = 288054,
  [SMALL_STATE(13997)] = 288097,
  [SMALL_STATE(13998)] = 288138,
  [SMALL_STATE(13999)] = 288211,
  [SMALL_STATE(14000)] = 288252,
  [SMALL_STATE(14001)] = 288293,
  [SMALL_STATE(14002)] = 288354,
  [SMALL_STATE(14003)] = 288395,
  [SMALL_STATE(14004)] = 288436,
  [SMALL_STATE(14005)] = 288477,
  [SMALL_STATE(14006)] = 288520,
  [SMALL_STATE(14007)] = 288561,
  [SMALL_STATE(14008)] = 288602,
  [SMALL_STATE(14009)] = 288643,
  [SMALL_STATE(14010)] = 288684,
  [SMALL_STATE(14011)] = 288725,
  [SMALL_STATE(14012)] = 288766,
  [SMALL_STATE(14013)] = 288843,
  [SMALL_STATE(14014)] = 288884,
  [SMALL_STATE(14015)] = 288945,
  [SMALL_STATE(14016)] = 289018,
  [SMALL_STATE(14017)] = 289087,
  [SMALL_STATE(14018)] = 289154,
  [SMALL_STATE(14019)] = 289211,
  [SMALL_STATE(14020)] = 289272,
  [SMALL_STATE(14021)] = 289323,
  [SMALL_STATE(14022)] = 289372,
  [SMALL_STATE(14023)] = 289419,
  [SMALL_STATE(14024)] = 289464,
  [SMALL_STATE(14025)] = 289507,
  [SMALL_STATE(14026)] = 289548,
  [SMALL_STATE(14027)] = 289599,
  [SMALL_STATE(14028)] = 289674,
  [SMALL_STATE(14029)] = 289715,
  [SMALL_STATE(14030)] = 289756,
  [SMALL_STATE(14031)] = 289833,
  [SMALL_STATE(14032)] = 289876,
  [SMALL_STATE(14033)] = 289927,
  [SMALL_STATE(14034)] = 289968,
  [SMALL_STATE(14035)] = 290035,
  [SMALL_STATE(14036)] = 290104,
  [SMALL_STATE(14037)] = 290145,
  [SMALL_STATE(14038)] = 290186,
  [SMALL_STATE(14039)] = 290235,
  [SMALL_STATE(14040)] = 290276,
  [SMALL_STATE(14041)] = 290317,
  [SMALL_STATE(14042)] = 290364,
  [SMALL_STATE(14043)] = 290409,
  [SMALL_STATE(14044)] = 290450,
  [SMALL_STATE(14045)] = 290491,
  [SMALL_STATE(14046)] = 290532,
  [SMALL_STATE(14047)] = 290597,
  [SMALL_STATE(14048)] = 290638,
  [SMALL_STATE(14049)] = 290713,
  [SMALL_STATE(14050)] = 290788,
  [SMALL_STATE(14051)] = 290831,
  [SMALL_STATE(14052)] = 290872,
  [SMALL_STATE(14053)] = 290913,
  [SMALL_STATE(14054)] = 290974,
  [SMALL_STATE(14055)] = 291051,
  [SMALL_STATE(14056)] = 291124,
  [SMALL_STATE(14057)] = 291185,
  [SMALL_STATE(14058)] = 291256,
  [SMALL_STATE(14059)] = 291323,
  [SMALL_STATE(14060)] = 291388,
  [SMALL_STATE(14061)] = 291445,
  [SMALL_STATE(14062)] = 291506,
  [SMALL_STATE(14063)] = 291557,
  [SMALL_STATE(14064)] = 291606,
  [SMALL_STATE(14065)] = 291653,
  [SMALL_STATE(14066)] = 291698,
  [SMALL_STATE(14067)] = 291741,
  [SMALL_STATE(14068)] = 291810,
  [SMALL_STATE(14069)] = 291873,
  [SMALL_STATE(14070)] = 291914,
  [SMALL_STATE(14071)] = 291981,
  [SMALL_STATE(14072)] = 292038,
  [SMALL_STATE(14073)] = 292099,
  [SMALL_STATE(14074)] = 292150,
  [SMALL_STATE(14075)] = 292199,
  [SMALL_STATE(14076)] = 292246,
  [SMALL_STATE(14077)] = 292291,
  [SMALL_STATE(14078)] = 292334,
  [SMALL_STATE(14079)] = 292375,
  [SMALL_STATE(14080)] = 292452,
  [SMALL_STATE(14081)] = 292493,
  [SMALL_STATE(14082)] = 292534,
  [SMALL_STATE(14083)] = 292599,
  [SMALL_STATE(14084)] = 292642,
  [SMALL_STATE(14085)] = 292719,
  [SMALL_STATE(14086)] = 292760,
  [SMALL_STATE(14087)] = 292801,
  [SMALL_STATE(14088)] = 292844,
  [SMALL_STATE(14089)] = 292895,
  [SMALL_STATE(14090)] = 292936,
  [SMALL_STATE(14091)] = 292987,
  [SMALL_STATE(14092)] = 293062,
  [SMALL_STATE(14093)] = 293139,
  [SMALL_STATE(14094)] = 293216,
  [SMALL_STATE(14095)] = 293257,
  [SMALL_STATE(14096)] = 293322,
  [SMALL_STATE(14097)] = 293363,
  [SMALL_STATE(14098)] = 293404,
  [SMALL_STATE(14099)] = 293481,
  [SMALL_STATE(14100)] = 293522,
  [SMALL_STATE(14101)] = 293592,
  [SMALL_STATE(14102)] = 293632,
  [SMALL_STATE(14103)] = 293702,
  [SMALL_STATE(14104)] = 293772,
  [SMALL_STATE(14105)] = 293842,
  [SMALL_STATE(14106)] = 293912,
  [SMALL_STATE(14107)] = 293982,
  [SMALL_STATE(14108)] = 294046,
  [SMALL_STATE(14109)] = 294102,
  [SMALL_STATE(14110)] = 294162,
  [SMALL_STATE(14111)] = 294232,
  [SMALL_STATE(14112)] = 294282,
  [SMALL_STATE(14113)] = 294330,
  [SMALL_STATE(14114)] = 294400,
  [SMALL_STATE(14115)] = 294470,
  [SMALL_STATE(14116)] = 294540,
  [SMALL_STATE(14117)] = 294610,
  [SMALL_STATE(14118)] = 294654,
  [SMALL_STATE(14119)] = 294724,
  [SMALL_STATE(14120)] = 294794,
  [SMALL_STATE(14121)] = 294864,
  [SMALL_STATE(14122)] = 294934,
  [SMALL_STATE(14123)] = 294980,
  [SMALL_STATE(14124)] = 295024,
  [SMALL_STATE(14125)] = 295094,
  [SMALL_STATE(14126)] = 295168,
  [SMALL_STATE(14127)] = 295238,
  [SMALL_STATE(14128)] = 295308,
  [SMALL_STATE(14129)] = 295382,
  [SMALL_STATE(14130)] = 295452,
  [SMALL_STATE(14131)] = 295522,
  [SMALL_STATE(14132)] = 295564,
  [SMALL_STATE(14133)] = 295634,
  [SMALL_STATE(14134)] = 295696,
  [SMALL_STATE(14135)] = 295766,
  [SMALL_STATE(14136)] = 295812,
  [SMALL_STATE(14137)] = 295886,
  [SMALL_STATE(14138)] = 295956,
  [SMALL_STATE(14139)] = 296026,
  [SMALL_STATE(14140)] = 296096,
  [SMALL_STATE(14141)] = 296166,
  [SMALL_STATE(14142)] = 296236,
  [SMALL_STATE(14143)] = 296306,
  [SMALL_STATE(14144)] = 296348,
  [SMALL_STATE(14145)] = 296412,
  [SMALL_STATE(14146)] = 296472,
  [SMALL_STATE(14147)] = 296542,
  [SMALL_STATE(14148)] = 296584,
  [SMALL_STATE(14149)] = 296654,
  [SMALL_STATE(14150)] = 296728,
  [SMALL_STATE(14151)] = 296798,
  [SMALL_STATE(14152)] = 296868,
  [SMALL_STATE(14153)] = 296938,
  [SMALL_STATE(14154)] = 297008,
  [SMALL_STATE(14155)] = 297078,
  [SMALL_STATE(14156)] = 297148,
  [SMALL_STATE(14157)] = 297218,
  [SMALL_STATE(14158)] = 297288,
  [SMALL_STATE(14159)] = 297358,
  [SMALL_STATE(14160)] = 297414,
  [SMALL_STATE(14161)] = 297464,
  [SMALL_STATE(14162)] = 297534,
  [SMALL_STATE(14163)] = 297604,
  [SMALL_STATE(14164)] = 297674,
  [SMALL_STATE(14165)] = 297744,
  [SMALL_STATE(14166)] = 297814,
  [SMALL_STATE(14167)] = 297884,
  [SMALL_STATE(14168)] = 297958,
  [SMALL_STATE(14169)] = 298028,
  [SMALL_STATE(14170)] = 298098,
  [SMALL_STATE(14171)] = 298172,
  [SMALL_STATE(14172)] = 298242,
  [SMALL_STATE(14173)] = 298312,
  [SMALL_STATE(14174)] = 298386,
  [SMALL_STATE(14175)] = 298456,
  [SMALL_STATE(14176)] = 298526,
  [SMALL_STATE(14177)] = 298600,
  [SMALL_STATE(14178)] = 298670,
  [SMALL_STATE(14179)] = 298740,
  [SMALL_STATE(14180)] = 298810,
  [SMALL_STATE(14181)] = 298880,
  [SMALL_STATE(14182)] = 298950,
  [SMALL_STATE(14183)] = 299020,
  [SMALL_STATE(14184)] = 299090,
  [SMALL_STATE(14185)] = 299164,
  [SMALL_STATE(14186)] = 299234,
  [SMALL_STATE(14187)] = 299284,
  [SMALL_STATE(14188)] = 299344,
  [SMALL_STATE(14189)] = 299414,
  [SMALL_STATE(14190)] = 299484,
  [SMALL_STATE(14191)] = 299532,
  [SMALL_STATE(14192)] = 299606,
  [SMALL_STATE(14193)] = 299676,
  [SMALL_STATE(14194)] = 299750,
  [SMALL_STATE(14195)] = 299820,
  [SMALL_STATE(14196)] = 299890,
  [SMALL_STATE(14197)] = 299960,
  [SMALL_STATE(14198)] = 300030,
  [SMALL_STATE(14199)] = 300100,
  [SMALL_STATE(14200)] = 300170,
  [SMALL_STATE(14201)] = 300240,
  [SMALL_STATE(14202)] = 300310,
  [SMALL_STATE(14203)] = 300380,
  [SMALL_STATE(14204)] = 300450,
  [SMALL_STATE(14205)] = 300520,
  [SMALL_STATE(14206)] = 300590,
  [SMALL_STATE(14207)] = 300664,
  [SMALL_STATE(14208)] = 300726,
  [SMALL_STATE(14209)] = 300796,
  [SMALL_STATE(14210)] = 300856,
  [SMALL_STATE(14211)] = 300930,
  [SMALL_STATE(14212)] = 301000,
  [SMALL_STATE(14213)] = 301070,
  [SMALL_STATE(14214)] = 301140,
  [SMALL_STATE(14215)] = 301206,
  [SMALL_STATE(14216)] = 301276,
  [SMALL_STATE(14217)] = 301346,
  [SMALL_STATE(14218)] = 301416,
  [SMALL_STATE(14219)] = 301482,
  [SMALL_STATE(14220)] = 301552,
  [SMALL_STATE(14221)] = 301622,
  [SMALL_STATE(14222)] = 301692,
  [SMALL_STATE(14223)] = 301762,
  [SMALL_STATE(14224)] = 301832,
  [SMALL_STATE(14225)] = 301902,
  [SMALL_STATE(14226)] = 301972,
  [SMALL_STATE(14227)] = 302042,
  [SMALL_STATE(14228)] = 302112,
  [SMALL_STATE(14229)] = 302154,
  [SMALL_STATE(14230)] = 302204,
  [SMALL_STATE(14231)] = 302274,
  [SMALL_STATE(14232)] = 302344,
  [SMALL_STATE(14233)] = 302414,
  [SMALL_STATE(14234)] = 302484,
  [SMALL_STATE(14235)] = 302554,
  [SMALL_STATE(14236)] = 302624,
  [SMALL_STATE(14237)] = 302694,
  [SMALL_STATE(14238)] = 302734,
  [SMALL_STATE(14239)] = 302805,
  [SMALL_STATE(14240)] = 302876,
  [SMALL_STATE(14241)] = 302947,
  [SMALL_STATE(14242)] = 303018,
  [SMALL_STATE(14243)] = 303089,
  [SMALL_STATE(14244)] = 303160,
  [SMALL_STATE(14245)] = 303231,
  [SMALL_STATE(14246)] = 303256,
  [SMALL_STATE(14247)] = 303291,
  [SMALL_STATE(14248)] = 303326,
  [SMALL_STATE(14249)] = 303361,
  [SMALL_STATE(14250)] = 303396,
  [SMALL_STATE(14251)] = 303431,
  [SMALL_STATE(14252)] = 303466,
  [SMALL_STATE(14253)] = 303489,
  [SMALL_STATE(14254)] = 303514,
  [SMALL_STATE(14255)] = 303549,
  [SMALL_STATE(14256)] = 303576,
  [SMALL_STATE(14257)] = 303611,
  [SMALL_STATE(14258)] = 303646,
  [SMALL_STATE(14259)] = 303681,
  [SMALL_STATE(14260)] = 303716,
  [SMALL_STATE(14261)] = 303751,
  [SMALL_STATE(14262)] = 303780,
  [SMALL_STATE(14263)] = 303815,
  [SMALL_STATE(14264)] = 303842,
  [SMALL_STATE(14265)] = 303871,
  [SMALL_STATE(14266)] = 303898,
  [SMALL_STATE(14267)] = 303926,
  [SMALL_STATE(14268)] = 303950,
  [SMALL_STATE(14269)] = 303976,
  [SMALL_STATE(14270)] = 304004,
  [SMALL_STATE(14271)] = 304030,
  [SMALL_STATE(14272)] = 304058,
  [SMALL_STATE(14273)] = 304082,
  [SMALL_STATE(14274)] = 304110,
  [SMALL_STATE(14275)] = 304138,
  [SMALL_STATE(14276)] = 304166,
  [SMALL_STATE(14277)] = 304190,
  [SMALL_STATE(14278)] = 304216,
  [SMALL_STATE(14279)] = 304242,
  [SMALL_STATE(14280)] = 304268,
  [SMALL_STATE(14281)] = 304297,
  [SMALL_STATE(14282)] = 304326,
  [SMALL_STATE(14283)] = 304353,
  [SMALL_STATE(14284)] = 304380,
  [SMALL_STATE(14285)] = 304407,
  [SMALL_STATE(14286)] = 304434,
  [SMALL_STATE(14287)] = 304463,
  [SMALL_STATE(14288)] = 304492,
  [SMALL_STATE(14289)] = 304521,
  [SMALL_STATE(14290)] = 304550,
  [SMALL_STATE(14291)] = 304579,
  [SMALL_STATE(14292)] = 304604,
  [SMALL_STATE(14293)] = 304631,
  [SMALL_STATE(14294)] = 304658,
  [SMALL_STATE(14295)] = 304685,
  [SMALL_STATE(14296)] = 304710,
  [SMALL_STATE(14297)] = 304737,
  [SMALL_STATE(14298)] = 304764,
  [SMALL_STATE(14299)] = 304791,
  [SMALL_STATE(14300)] = 304818,
  [SMALL_STATE(14301)] = 304845,
  [SMALL_STATE(14302)] = 304872,
  [SMALL_STATE(14303)] = 304899,
  [SMALL_STATE(14304)] = 304928,
  [SMALL_STATE(14305)] = 304957,
  [SMALL_STATE(14306)] = 304984,
  [SMALL_STATE(14307)] = 305011,
  [SMALL_STATE(14308)] = 305038,
  [SMALL_STATE(14309)] = 305065,
  [SMALL_STATE(14310)] = 305088,
  [SMALL_STATE(14311)] = 305117,
  [SMALL_STATE(14312)] = 305144,
  [SMALL_STATE(14313)] = 305173,
  [SMALL_STATE(14314)] = 305202,
  [SMALL_STATE(14315)] = 305231,
  [SMALL_STATE(14316)] = 305260,
  [SMALL_STATE(14317)] = 305287,
  [SMALL_STATE(14318)] = 305314,
  [SMALL_STATE(14319)] = 305341,
  [SMALL_STATE(14320)] = 305368,
  [SMALL_STATE(14321)] = 305395,
  [SMALL_STATE(14322)] = 305422,
  [SMALL_STATE(14323)] = 305449,
  [SMALL_STATE(14324)] = 305474,
  [SMALL_STATE(14325)] = 305503,
  [SMALL_STATE(14326)] = 305530,
  [SMALL_STATE(14327)] = 305557,
  [SMALL_STATE(14328)] = 305584,
  [SMALL_STATE(14329)] = 305613,
  [SMALL_STATE(14330)] = 305640,
  [SMALL_STATE(14331)] = 305669,
  [SMALL_STATE(14332)] = 305698,
  [SMALL_STATE(14333)] = 305727,
  [SMALL_STATE(14334)] = 305756,
  [SMALL_STATE(14335)] = 305783,
  [SMALL_STATE(14336)] = 305812,
  [SMALL_STATE(14337)] = 305839,
  [SMALL_STATE(14338)] = 305868,
  [SMALL_STATE(14339)] = 305897,
  [SMALL_STATE(14340)] = 305926,
  [SMALL_STATE(14341)] = 305953,
  [SMALL_STATE(14342)] = 305980,
  [SMALL_STATE(14343)] = 306007,
  [SMALL_STATE(14344)] = 306034,
  [SMALL_STATE(14345)] = 306063,
  [SMALL_STATE(14346)] = 306090,
  [SMALL_STATE(14347)] = 306117,
  [SMALL_STATE(14348)] = 306144,
  [SMALL_STATE(14349)] = 306171,
  [SMALL_STATE(14350)] = 306200,
  [SMALL_STATE(14351)] = 306229,
  [SMALL_STATE(14352)] = 306256,
  [SMALL_STATE(14353)] = 306285,
  [SMALL_STATE(14354)] = 306314,
  [SMALL_STATE(14355)] = 306343,
  [SMALL_STATE(14356)] = 306370,
  [SMALL_STATE(14357)] = 306397,
  [SMALL_STATE(14358)] = 306424,
  [SMALL_STATE(14359)] = 306451,
  [SMALL_STATE(14360)] = 306480,
  [SMALL_STATE(14361)] = 306507,
  [SMALL_STATE(14362)] = 306534,
  [SMALL_STATE(14363)] = 306561,
  [SMALL_STATE(14364)] = 306590,
  [SMALL_STATE(14365)] = 306617,
  [SMALL_STATE(14366)] = 306644,
  [SMALL_STATE(14367)] = 306671,
  [SMALL_STATE(14368)] = 306698,
  [SMALL_STATE(14369)] = 306725,
  [SMALL_STATE(14370)] = 306754,
  [SMALL_STATE(14371)] = 306783,
  [SMALL_STATE(14372)] = 306810,
  [SMALL_STATE(14373)] = 306839,
  [SMALL_STATE(14374)] = 306866,
  [SMALL_STATE(14375)] = 306893,
  [SMALL_STATE(14376)] = 306920,
  [SMALL_STATE(14377)] = 306947,
  [SMALL_STATE(14378)] = 306974,
  [SMALL_STATE(14379)] = 306999,
  [SMALL_STATE(14380)] = 307028,
  [SMALL_STATE(14381)] = 307057,
  [SMALL_STATE(14382)] = 307086,
  [SMALL_STATE(14383)] = 307113,
  [SMALL_STATE(14384)] = 307140,
  [SMALL_STATE(14385)] = 307167,
  [SMALL_STATE(14386)] = 307194,
  [SMALL_STATE(14387)] = 307221,
  [SMALL_STATE(14388)] = 307248,
  [SMALL_STATE(14389)] = 307275,
  [SMALL_STATE(14390)] = 307302,
  [SMALL_STATE(14391)] = 307329,
  [SMALL_STATE(14392)] = 307354,
  [SMALL_STATE(14393)] = 307381,
  [SMALL_STATE(14394)] = 307408,
  [SMALL_STATE(14395)] = 307435,
  [SMALL_STATE(14396)] = 307462,
  [SMALL_STATE(14397)] = 307491,
  [SMALL_STATE(14398)] = 307520,
  [SMALL_STATE(14399)] = 307549,
  [SMALL_STATE(14400)] = 307578,
  [SMALL_STATE(14401)] = 307607,
  [SMALL_STATE(14402)] = 307634,
  [SMALL_STATE(14403)] = 307659,
  [SMALL_STATE(14404)] = 307686,
  [SMALL_STATE(14405)] = 307713,
  [SMALL_STATE(14406)] = 307742,
  [SMALL_STATE(14407)] = 307769,
  [SMALL_STATE(14408)] = 307796,
  [SMALL_STATE(14409)] = 307823,
  [SMALL_STATE(14410)] = 307850,
  [SMALL_STATE(14411)] = 307877,
  [SMALL_STATE(14412)] = 307904,
  [SMALL_STATE(14413)] = 307931,
  [SMALL_STATE(14414)] = 307958,
  [SMALL_STATE(14415)] = 307985,
  [SMALL_STATE(14416)] = 308012,
  [SMALL_STATE(14417)] = 308041,
  [SMALL_STATE(14418)] = 308068,
  [SMALL_STATE(14419)] = 308095,
  [SMALL_STATE(14420)] = 308120,
  [SMALL_STATE(14421)] = 308147,
  [SMALL_STATE(14422)] = 308174,
  [SMALL_STATE(14423)] = 308201,
  [SMALL_STATE(14424)] = 308228,
  [SMALL_STATE(14425)] = 308257,
  [SMALL_STATE(14426)] = 308286,
  [SMALL_STATE(14427)] = 308313,
  [SMALL_STATE(14428)] = 308340,
  [SMALL_STATE(14429)] = 308367,
  [SMALL_STATE(14430)] = 308394,
  [SMALL_STATE(14431)] = 308421,
  [SMALL_STATE(14432)] = 308450,
  [SMALL_STATE(14433)] = 308479,
  [SMALL_STATE(14434)] = 308506,
  [SMALL_STATE(14435)] = 308535,
  [SMALL_STATE(14436)] = 308562,
  [SMALL_STATE(14437)] = 308589,
  [SMALL_STATE(14438)] = 308618,
  [SMALL_STATE(14439)] = 308643,
  [SMALL_STATE(14440)] = 308668,
  [SMALL_STATE(14441)] = 308697,
  [SMALL_STATE(14442)] = 308722,
  [SMALL_STATE(14443)] = 308749,
  [SMALL_STATE(14444)] = 308776,
  [SMALL_STATE(14445)] = 308803,
  [SMALL_STATE(14446)] = 308830,
  [SMALL_STATE(14447)] = 308857,
  [SMALL_STATE(14448)] = 308884,
  [SMALL_STATE(14449)] = 308911,
  [SMALL_STATE(14450)] = 308938,
  [SMALL_STATE(14451)] = 308967,
  [SMALL_STATE(14452)] = 308996,
  [SMALL_STATE(14453)] = 309025,
  [SMALL_STATE(14454)] = 309054,
  [SMALL_STATE(14455)] = 309083,
  [SMALL_STATE(14456)] = 309112,
  [SMALL_STATE(14457)] = 309139,
  [SMALL_STATE(14458)] = 309168,
  [SMALL_STATE(14459)] = 309195,
  [SMALL_STATE(14460)] = 309222,
  [SMALL_STATE(14461)] = 309247,
  [SMALL_STATE(14462)] = 309272,
  [SMALL_STATE(14463)] = 309301,
  [SMALL_STATE(14464)] = 309328,
  [SMALL_STATE(14465)] = 309357,
  [SMALL_STATE(14466)] = 309386,
  [SMALL_STATE(14467)] = 309409,
  [SMALL_STATE(14468)] = 309438,
  [SMALL_STATE(14469)] = 309467,
  [SMALL_STATE(14470)] = 309496,
  [SMALL_STATE(14471)] = 309525,
  [SMALL_STATE(14472)] = 309550,
  [SMALL_STATE(14473)] = 309579,
  [SMALL_STATE(14474)] = 309606,
  [SMALL_STATE(14475)] = 309635,
  [SMALL_STATE(14476)] = 309664,
  [SMALL_STATE(14477)] = 309691,
  [SMALL_STATE(14478)] = 309720,
  [SMALL_STATE(14479)] = 309747,
  [SMALL_STATE(14480)] = 309774,
  [SMALL_STATE(14481)] = 309801,
  [SMALL_STATE(14482)] = 309828,
  [SMALL_STATE(14483)] = 309851,
  [SMALL_STATE(14484)] = 309880,
  [SMALL_STATE(14485)] = 309907,
  [SMALL_STATE(14486)] = 309936,
  [SMALL_STATE(14487)] = 309965,
  [SMALL_STATE(14488)] = 309992,
  [SMALL_STATE(14489)] = 310019,
  [SMALL_STATE(14490)] = 310046,
  [SMALL_STATE(14491)] = 310073,
  [SMALL_STATE(14492)] = 310102,
  [SMALL_STATE(14493)] = 310131,
  [SMALL_STATE(14494)] = 310158,
  [SMALL_STATE(14495)] = 310185,
  [SMALL_STATE(14496)] = 310214,
  [SMALL_STATE(14497)] = 310241,
  [SMALL_STATE(14498)] = 310268,
  [SMALL_STATE(14499)] = 310295,
  [SMALL_STATE(14500)] = 310322,
  [SMALL_STATE(14501)] = 310349,
  [SMALL_STATE(14502)] = 310376,
  [SMALL_STATE(14503)] = 310405,
  [SMALL_STATE(14504)] = 310434,
  [SMALL_STATE(14505)] = 310461,
  [SMALL_STATE(14506)] = 310488,
  [SMALL_STATE(14507)] = 310513,
  [SMALL_STATE(14508)] = 310540,
  [SMALL_STATE(14509)] = 310569,
  [SMALL_STATE(14510)] = 310594,
  [SMALL_STATE(14511)] = 310623,
  [SMALL_STATE(14512)] = 310652,
  [SMALL_STATE(14513)] = 310679,
  [SMALL_STATE(14514)] = 310706,
  [SMALL_STATE(14515)] = 310733,
  [SMALL_STATE(14516)] = 310760,
  [SMALL_STATE(14517)] = 310787,
  [SMALL_STATE(14518)] = 310814,
  [SMALL_STATE(14519)] = 310841,
  [SMALL_STATE(14520)] = 310870,
  [SMALL_STATE(14521)] = 310897,
  [SMALL_STATE(14522)] = 310924,
  [SMALL_STATE(14523)] = 310953,
  [SMALL_STATE(14524)] = 310980,
  [SMALL_STATE(14525)] = 311007,
  [SMALL_STATE(14526)] = 311032,
  [SMALL_STATE(14527)] = 311061,
  [SMALL_STATE(14528)] = 311090,
  [SMALL_STATE(14529)] = 311119,
  [SMALL_STATE(14530)] = 311146,
  [SMALL_STATE(14531)] = 311173,
  [SMALL_STATE(14532)] = 311196,
  [SMALL_STATE(14533)] = 311225,
  [SMALL_STATE(14534)] = 311252,
  [SMALL_STATE(14535)] = 311279,
  [SMALL_STATE(14536)] = 311306,
  [SMALL_STATE(14537)] = 311333,
  [SMALL_STATE(14538)] = 311360,
  [SMALL_STATE(14539)] = 311387,
  [SMALL_STATE(14540)] = 311416,
  [SMALL_STATE(14541)] = 311445,
  [SMALL_STATE(14542)] = 311474,
  [SMALL_STATE(14543)] = 311501,
  [SMALL_STATE(14544)] = 311530,
  [SMALL_STATE(14545)] = 311559,
  [SMALL_STATE(14546)] = 311586,
  [SMALL_STATE(14547)] = 311613,
  [SMALL_STATE(14548)] = 311638,
  [SMALL_STATE(14549)] = 311667,
  [SMALL_STATE(14550)] = 311694,
  [SMALL_STATE(14551)] = 311721,
  [SMALL_STATE(14552)] = 311748,
  [SMALL_STATE(14553)] = 311775,
  [SMALL_STATE(14554)] = 311798,
  [SMALL_STATE(14555)] = 311825,
  [SMALL_STATE(14556)] = 311852,
  [SMALL_STATE(14557)] = 311879,
  [SMALL_STATE(14558)] = 311906,
  [SMALL_STATE(14559)] = 311933,
  [SMALL_STATE(14560)] = 311962,
  [SMALL_STATE(14561)] = 311991,
  [SMALL_STATE(14562)] = 312018,
  [SMALL_STATE(14563)] = 312045,
  [SMALL_STATE(14564)] = 312072,
  [SMALL_STATE(14565)] = 312099,
  [SMALL_STATE(14566)] = 312128,
  [SMALL_STATE(14567)] = 312157,
  [SMALL_STATE(14568)] = 312186,
  [SMALL_STATE(14569)] = 312215,
  [SMALL_STATE(14570)] = 312244,
  [SMALL_STATE(14571)] = 312273,
  [SMALL_STATE(14572)] = 312302,
  [SMALL_STATE(14573)] = 312329,
  [SMALL_STATE(14574)] = 312356,
  [SMALL_STATE(14575)] = 312383,
  [SMALL_STATE(14576)] = 312410,
  [SMALL_STATE(14577)] = 312437,
  [SMALL_STATE(14578)] = 312466,
  [SMALL_STATE(14579)] = 312493,
  [SMALL_STATE(14580)] = 312522,
  [SMALL_STATE(14581)] = 312547,
  [SMALL_STATE(14582)] = 312574,
  [SMALL_STATE(14583)] = 312601,
  [SMALL_STATE(14584)] = 312628,
  [SMALL_STATE(14585)] = 312655,
  [SMALL_STATE(14586)] = 312682,
  [SMALL_STATE(14587)] = 312709,
  [SMALL_STATE(14588)] = 312736,
  [SMALL_STATE(14589)] = 312763,
  [SMALL_STATE(14590)] = 312790,
  [SMALL_STATE(14591)] = 312817,
  [SMALL_STATE(14592)] = 312846,
  [SMALL_STATE(14593)] = 312875,
  [SMALL_STATE(14594)] = 312902,
  [SMALL_STATE(14595)] = 312931,
  [SMALL_STATE(14596)] = 312960,
  [SMALL_STATE(14597)] = 312985,
  [SMALL_STATE(14598)] = 313012,
  [SMALL_STATE(14599)] = 313041,
  [SMALL_STATE(14600)] = 313068,
  [SMALL_STATE(14601)] = 313095,
  [SMALL_STATE(14602)] = 313122,
  [SMALL_STATE(14603)] = 313149,
  [SMALL_STATE(14604)] = 313176,
  [SMALL_STATE(14605)] = 313195,
  [SMALL_STATE(14606)] = 313222,
  [SMALL_STATE(14607)] = 313245,
  [SMALL_STATE(14608)] = 313272,
  [SMALL_STATE(14609)] = 313299,
  [SMALL_STATE(14610)] = 313326,
  [SMALL_STATE(14611)] = 313353,
  [SMALL_STATE(14612)] = 313380,
  [SMALL_STATE(14613)] = 313407,
  [SMALL_STATE(14614)] = 313434,
  [SMALL_STATE(14615)] = 313461,
  [SMALL_STATE(14616)] = 313488,
  [SMALL_STATE(14617)] = 313517,
  [SMALL_STATE(14618)] = 313544,
  [SMALL_STATE(14619)] = 313571,
  [SMALL_STATE(14620)] = 313598,
  [SMALL_STATE(14621)] = 313625,
  [SMALL_STATE(14622)] = 313652,
  [SMALL_STATE(14623)] = 313679,
  [SMALL_STATE(14624)] = 313706,
  [SMALL_STATE(14625)] = 313735,
  [SMALL_STATE(14626)] = 313762,
  [SMALL_STATE(14627)] = 313789,
  [SMALL_STATE(14628)] = 313816,
  [SMALL_STATE(14629)] = 313843,
  [SMALL_STATE(14630)] = 313862,
  [SMALL_STATE(14631)] = 313889,
  [SMALL_STATE(14632)] = 313916,
  [SMALL_STATE(14633)] = 313943,
  [SMALL_STATE(14634)] = 313970,
  [SMALL_STATE(14635)] = 313999,
  [SMALL_STATE(14636)] = 314028,
  [SMALL_STATE(14637)] = 314053,
  [SMALL_STATE(14638)] = 314080,
  [SMALL_STATE(14639)] = 314107,
  [SMALL_STATE(14640)] = 314136,
  [SMALL_STATE(14641)] = 314165,
  [SMALL_STATE(14642)] = 314192,
  [SMALL_STATE(14643)] = 314219,
  [SMALL_STATE(14644)] = 314248,
  [SMALL_STATE(14645)] = 314277,
  [SMALL_STATE(14646)] = 314304,
  [SMALL_STATE(14647)] = 314333,
  [SMALL_STATE(14648)] = 314358,
  [SMALL_STATE(14649)] = 314387,
  [SMALL_STATE(14650)] = 314414,
  [SMALL_STATE(14651)] = 314443,
  [SMALL_STATE(14652)] = 314470,
  [SMALL_STATE(14653)] = 314497,
  [SMALL_STATE(14654)] = 314524,
  [SMALL_STATE(14655)] = 314551,
  [SMALL_STATE(14656)] = 314580,
  [SMALL_STATE(14657)] = 314607,
  [SMALL_STATE(14658)] = 314634,
  [SMALL_STATE(14659)] = 314661,
  [SMALL_STATE(14660)] = 314686,
  [SMALL_STATE(14661)] = 314713,
  [SMALL_STATE(14662)] = 314736,
  [SMALL_STATE(14663)] = 314763,
  [SMALL_STATE(14664)] = 314790,
  [SMALL_STATE(14665)] = 314817,
  [SMALL_STATE(14666)] = 314840,
  [SMALL_STATE(14667)] = 314869,
  [SMALL_STATE(14668)] = 314898,
  [SMALL_STATE(14669)] = 314927,
  [SMALL_STATE(14670)] = 314954,
  [SMALL_STATE(14671)] = 314977,
  [SMALL_STATE(14672)] = 315004,
  [SMALL_STATE(14673)] = 315031,
  [SMALL_STATE(14674)] = 315058,
  [SMALL_STATE(14675)] = 315085,
  [SMALL_STATE(14676)] = 315112,
  [SMALL_STATE(14677)] = 315139,
  [SMALL_STATE(14678)] = 315166,
  [SMALL_STATE(14679)] = 315191,
  [SMALL_STATE(14680)] = 315220,
  [SMALL_STATE(14681)] = 315249,
  [SMALL_STATE(14682)] = 315278,
  [SMALL_STATE(14683)] = 315303,
  [SMALL_STATE(14684)] = 315332,
  [SMALL_STATE(14685)] = 315361,
  [SMALL_STATE(14686)] = 315390,
  [SMALL_STATE(14687)] = 315419,
  [SMALL_STATE(14688)] = 315446,
  [SMALL_STATE(14689)] = 315473,
  [SMALL_STATE(14690)] = 315500,
  [SMALL_STATE(14691)] = 315527,
  [SMALL_STATE(14692)] = 315554,
  [SMALL_STATE(14693)] = 315581,
  [SMALL_STATE(14694)] = 315608,
  [SMALL_STATE(14695)] = 315637,
  [SMALL_STATE(14696)] = 315664,
  [SMALL_STATE(14697)] = 315691,
  [SMALL_STATE(14698)] = 315720,
  [SMALL_STATE(14699)] = 315747,
  [SMALL_STATE(14700)] = 315772,
  [SMALL_STATE(14701)] = 315801,
  [SMALL_STATE(14702)] = 315828,
  [SMALL_STATE(14703)] = 315857,
  [SMALL_STATE(14704)] = 315886,
  [SMALL_STATE(14705)] = 315915,
  [SMALL_STATE(14706)] = 315942,
  [SMALL_STATE(14707)] = 315971,
  [SMALL_STATE(14708)] = 316000,
  [SMALL_STATE(14709)] = 316027,
  [SMALL_STATE(14710)] = 316052,
  [SMALL_STATE(14711)] = 316081,
  [SMALL_STATE(14712)] = 316110,
  [SMALL_STATE(14713)] = 316139,
  [SMALL_STATE(14714)] = 316168,
  [SMALL_STATE(14715)] = 316195,
  [SMALL_STATE(14716)] = 316220,
  [SMALL_STATE(14717)] = 316247,
  [SMALL_STATE(14718)] = 316276,
  [SMALL_STATE(14719)] = 316303,
  [SMALL_STATE(14720)] = 316330,
  [SMALL_STATE(14721)] = 316357,
  [SMALL_STATE(14722)] = 316386,
  [SMALL_STATE(14723)] = 316411,
  [SMALL_STATE(14724)] = 316434,
  [SMALL_STATE(14725)] = 316463,
  [SMALL_STATE(14726)] = 316490,
  [SMALL_STATE(14727)] = 316517,
  [SMALL_STATE(14728)] = 316544,
  [SMALL_STATE(14729)] = 316571,
  [SMALL_STATE(14730)] = 316600,
  [SMALL_STATE(14731)] = 316629,
  [SMALL_STATE(14732)] = 316658,
  [SMALL_STATE(14733)] = 316687,
  [SMALL_STATE(14734)] = 316712,
  [SMALL_STATE(14735)] = 316739,
  [SMALL_STATE(14736)] = 316766,
  [SMALL_STATE(14737)] = 316795,
  [SMALL_STATE(14738)] = 316820,
  [SMALL_STATE(14739)] = 316847,
  [SMALL_STATE(14740)] = 316874,
  [SMALL_STATE(14741)] = 316899,
  [SMALL_STATE(14742)] = 316926,
  [SMALL_STATE(14743)] = 316955,
  [SMALL_STATE(14744)] = 316982,
  [SMALL_STATE(14745)] = 317009,
  [SMALL_STATE(14746)] = 317032,
  [SMALL_STATE(14747)] = 317059,
  [SMALL_STATE(14748)] = 317086,
  [SMALL_STATE(14749)] = 317113,
  [SMALL_STATE(14750)] = 317140,
  [SMALL_STATE(14751)] = 317167,
  [SMALL_STATE(14752)] = 317194,
  [SMALL_STATE(14753)] = 317221,
  [SMALL_STATE(14754)] = 317250,
  [SMALL_STATE(14755)] = 317279,
  [SMALL_STATE(14756)] = 317306,
  [SMALL_STATE(14757)] = 317333,
  [SMALL_STATE(14758)] = 317360,
  [SMALL_STATE(14759)] = 317387,
  [SMALL_STATE(14760)] = 317414,
  [SMALL_STATE(14761)] = 317441,
  [SMALL_STATE(14762)] = 317470,
  [SMALL_STATE(14763)] = 317497,
  [SMALL_STATE(14764)] = 317524,
  [SMALL_STATE(14765)] = 317551,
  [SMALL_STATE(14766)] = 317578,
  [SMALL_STATE(14767)] = 317605,
  [SMALL_STATE(14768)] = 317632,
  [SMALL_STATE(14769)] = 317659,
  [SMALL_STATE(14770)] = 317686,
  [SMALL_STATE(14771)] = 317713,
  [SMALL_STATE(14772)] = 317740,
  [SMALL_STATE(14773)] = 317767,
  [SMALL_STATE(14774)] = 317794,
  [SMALL_STATE(14775)] = 317821,
  [SMALL_STATE(14776)] = 317848,
  [SMALL_STATE(14777)] = 317875,
  [SMALL_STATE(14778)] = 317904,
  [SMALL_STATE(14779)] = 317931,
  [SMALL_STATE(14780)] = 317958,
  [SMALL_STATE(14781)] = 317985,
  [SMALL_STATE(14782)] = 318012,
  [SMALL_STATE(14783)] = 318039,
  [SMALL_STATE(14784)] = 318068,
  [SMALL_STATE(14785)] = 318095,
  [SMALL_STATE(14786)] = 318122,
  [SMALL_STATE(14787)] = 318149,
  [SMALL_STATE(14788)] = 318178,
  [SMALL_STATE(14789)] = 318205,
  [SMALL_STATE(14790)] = 318234,
  [SMALL_STATE(14791)] = 318263,
  [SMALL_STATE(14792)] = 318290,
  [SMALL_STATE(14793)] = 318317,
  [SMALL_STATE(14794)] = 318344,
  [SMALL_STATE(14795)] = 318371,
  [SMALL_STATE(14796)] = 318398,
  [SMALL_STATE(14797)] = 318425,
  [SMALL_STATE(14798)] = 318452,
  [SMALL_STATE(14799)] = 318479,
  [SMALL_STATE(14800)] = 318506,
  [SMALL_STATE(14801)] = 318533,
  [SMALL_STATE(14802)] = 318560,
  [SMALL_STATE(14803)] = 318589,
  [SMALL_STATE(14804)] = 318618,
  [SMALL_STATE(14805)] = 318647,
  [SMALL_STATE(14806)] = 318672,
  [SMALL_STATE(14807)] = 318699,
  [SMALL_STATE(14808)] = 318728,
  [SMALL_STATE(14809)] = 318755,
  [SMALL_STATE(14810)] = 318784,
  [SMALL_STATE(14811)] = 318809,
  [SMALL_STATE(14812)] = 318836,
  [SMALL_STATE(14813)] = 318863,
  [SMALL_STATE(14814)] = 318890,
  [SMALL_STATE(14815)] = 318917,
  [SMALL_STATE(14816)] = 318946,
  [SMALL_STATE(14817)] = 318973,
  [SMALL_STATE(14818)] = 319000,
  [SMALL_STATE(14819)] = 319027,
  [SMALL_STATE(14820)] = 319054,
  [SMALL_STATE(14821)] = 319081,
  [SMALL_STATE(14822)] = 319108,
  [SMALL_STATE(14823)] = 319135,
  [SMALL_STATE(14824)] = 319162,
  [SMALL_STATE(14825)] = 319189,
  [SMALL_STATE(14826)] = 319216,
  [SMALL_STATE(14827)] = 319243,
  [SMALL_STATE(14828)] = 319270,
  [SMALL_STATE(14829)] = 319297,
  [SMALL_STATE(14830)] = 319324,
  [SMALL_STATE(14831)] = 319351,
  [SMALL_STATE(14832)] = 319378,
  [SMALL_STATE(14833)] = 319405,
  [SMALL_STATE(14834)] = 319432,
  [SMALL_STATE(14835)] = 319461,
  [SMALL_STATE(14836)] = 319488,
  [SMALL_STATE(14837)] = 319515,
  [SMALL_STATE(14838)] = 319538,
  [SMALL_STATE(14839)] = 319565,
  [SMALL_STATE(14840)] = 319592,
  [SMALL_STATE(14841)] = 319619,
  [SMALL_STATE(14842)] = 319648,
  [SMALL_STATE(14843)] = 319677,
  [SMALL_STATE(14844)] = 319704,
  [SMALL_STATE(14845)] = 319731,
  [SMALL_STATE(14846)] = 319758,
  [SMALL_STATE(14847)] = 319785,
  [SMALL_STATE(14848)] = 319812,
  [SMALL_STATE(14849)] = 319839,
  [SMALL_STATE(14850)] = 319866,
  [SMALL_STATE(14851)] = 319895,
  [SMALL_STATE(14852)] = 319920,
  [SMALL_STATE(14853)] = 319945,
  [SMALL_STATE(14854)] = 319974,
  [SMALL_STATE(14855)] = 320003,
  [SMALL_STATE(14856)] = 320030,
  [SMALL_STATE(14857)] = 320057,
  [SMALL_STATE(14858)] = 320084,
  [SMALL_STATE(14859)] = 320109,
  [SMALL_STATE(14860)] = 320134,
  [SMALL_STATE(14861)] = 320161,
  [SMALL_STATE(14862)] = 320184,
  [SMALL_STATE(14863)] = 320211,
  [SMALL_STATE(14864)] = 320234,
  [SMALL_STATE(14865)] = 320261,
  [SMALL_STATE(14866)] = 320288,
  [SMALL_STATE(14867)] = 320315,
  [SMALL_STATE(14868)] = 320344,
  [SMALL_STATE(14869)] = 320371,
  [SMALL_STATE(14870)] = 320398,
  [SMALL_STATE(14871)] = 320425,
  [SMALL_STATE(14872)] = 320452,
  [SMALL_STATE(14873)] = 320479,
  [SMALL_STATE(14874)] = 320508,
  [SMALL_STATE(14875)] = 320535,
  [SMALL_STATE(14876)] = 320562,
  [SMALL_STATE(14877)] = 320587,
  [SMALL_STATE(14878)] = 320616,
  [SMALL_STATE(14879)] = 320643,
  [SMALL_STATE(14880)] = 320670,
  [SMALL_STATE(14881)] = 320699,
  [SMALL_STATE(14882)] = 320728,
  [SMALL_STATE(14883)] = 320755,
  [SMALL_STATE(14884)] = 320776,
  [SMALL_STATE(14885)] = 320805,
  [SMALL_STATE(14886)] = 320834,
  [SMALL_STATE(14887)] = 320859,
  [SMALL_STATE(14888)] = 320888,
  [SMALL_STATE(14889)] = 320917,
  [SMALL_STATE(14890)] = 320944,
  [SMALL_STATE(14891)] = 320971,
  [SMALL_STATE(14892)] = 320998,
  [SMALL_STATE(14893)] = 321027,
  [SMALL_STATE(14894)] = 321056,
  [SMALL_STATE(14895)] = 321085,
  [SMALL_STATE(14896)] = 321110,
  [SMALL_STATE(14897)] = 321139,
  [SMALL_STATE(14898)] = 321168,
  [SMALL_STATE(14899)] = 321193,
  [SMALL_STATE(14900)] = 321220,
  [SMALL_STATE(14901)] = 321247,
  [SMALL_STATE(14902)] = 321272,
  [SMALL_STATE(14903)] = 321299,
  [SMALL_STATE(14904)] = 321326,
  [SMALL_STATE(14905)] = 321353,
  [SMALL_STATE(14906)] = 321382,
  [SMALL_STATE(14907)] = 321409,
  [SMALL_STATE(14908)] = 321436,
  [SMALL_STATE(14909)] = 321463,
  [SMALL_STATE(14910)] = 321490,
  [SMALL_STATE(14911)] = 321517,
  [SMALL_STATE(14912)] = 321544,
  [SMALL_STATE(14913)] = 321569,
  [SMALL_STATE(14914)] = 321598,
  [SMALL_STATE(14915)] = 321625,
  [SMALL_STATE(14916)] = 321652,
  [SMALL_STATE(14917)] = 321681,
  [SMALL_STATE(14918)] = 321710,
  [SMALL_STATE(14919)] = 321735,
  [SMALL_STATE(14920)] = 321762,
  [SMALL_STATE(14921)] = 321789,
  [SMALL_STATE(14922)] = 321816,
  [SMALL_STATE(14923)] = 321841,
  [SMALL_STATE(14924)] = 321868,
  [SMALL_STATE(14925)] = 321897,
  [SMALL_STATE(14926)] = 321924,
  [SMALL_STATE(14927)] = 321953,
  [SMALL_STATE(14928)] = 321982,
  [SMALL_STATE(14929)] = 322009,
  [SMALL_STATE(14930)] = 322036,
  [SMALL_STATE(14931)] = 322065,
  [SMALL_STATE(14932)] = 322094,
  [SMALL_STATE(14933)] = 322123,
  [SMALL_STATE(14934)] = 322152,
  [SMALL_STATE(14935)] = 322179,
  [SMALL_STATE(14936)] = 322204,
  [SMALL_STATE(14937)] = 322233,
  [SMALL_STATE(14938)] = 322262,
  [SMALL_STATE(14939)] = 322291,
  [SMALL_STATE(14940)] = 322318,
  [SMALL_STATE(14941)] = 322345,
  [SMALL_STATE(14942)] = 322372,
  [SMALL_STATE(14943)] = 322399,
  [SMALL_STATE(14944)] = 322426,
  [SMALL_STATE(14945)] = 322453,
  [SMALL_STATE(14946)] = 322480,
  [SMALL_STATE(14947)] = 322509,
  [SMALL_STATE(14948)] = 322538,
  [SMALL_STATE(14949)] = 322565,
  [SMALL_STATE(14950)] = 322592,
  [SMALL_STATE(14951)] = 322619,
  [SMALL_STATE(14952)] = 322646,
  [SMALL_STATE(14953)] = 322675,
  [SMALL_STATE(14954)] = 322704,
  [SMALL_STATE(14955)] = 322731,
  [SMALL_STATE(14956)] = 322760,
  [SMALL_STATE(14957)] = 322789,
  [SMALL_STATE(14958)] = 322816,
  [SMALL_STATE(14959)] = 322845,
  [SMALL_STATE(14960)] = 322872,
  [SMALL_STATE(14961)] = 322899,
  [SMALL_STATE(14962)] = 322928,
  [SMALL_STATE(14963)] = 322955,
  [SMALL_STATE(14964)] = 322982,
  [SMALL_STATE(14965)] = 323009,
  [SMALL_STATE(14966)] = 323036,
  [SMALL_STATE(14967)] = 323065,
  [SMALL_STATE(14968)] = 323094,
  [SMALL_STATE(14969)] = 323123,
  [SMALL_STATE(14970)] = 323152,
  [SMALL_STATE(14971)] = 323181,
  [SMALL_STATE(14972)] = 323208,
  [SMALL_STATE(14973)] = 323235,
  [SMALL_STATE(14974)] = 323262,
  [SMALL_STATE(14975)] = 323291,
  [SMALL_STATE(14976)] = 323320,
  [SMALL_STATE(14977)] = 323347,
  [SMALL_STATE(14978)] = 323376,
  [SMALL_STATE(14979)] = 323405,
  [SMALL_STATE(14980)] = 323432,
  [SMALL_STATE(14981)] = 323457,
  [SMALL_STATE(14982)] = 323482,
  [SMALL_STATE(14983)] = 323509,
  [SMALL_STATE(14984)] = 323536,
  [SMALL_STATE(14985)] = 323565,
  [SMALL_STATE(14986)] = 323592,
  [SMALL_STATE(14987)] = 323619,
  [SMALL_STATE(14988)] = 323646,
  [SMALL_STATE(14989)] = 323673,
  [SMALL_STATE(14990)] = 323700,
  [SMALL_STATE(14991)] = 323727,
  [SMALL_STATE(14992)] = 323754,
  [SMALL_STATE(14993)] = 323783,
  [SMALL_STATE(14994)] = 323810,
  [SMALL_STATE(14995)] = 323839,
  [SMALL_STATE(14996)] = 323868,
  [SMALL_STATE(14997)] = 323895,
  [SMALL_STATE(14998)] = 323922,
  [SMALL_STATE(14999)] = 323949,
  [SMALL_STATE(15000)] = 323976,
  [SMALL_STATE(15001)] = 324005,
  [SMALL_STATE(15002)] = 324032,
  [SMALL_STATE(15003)] = 324055,
  [SMALL_STATE(15004)] = 324082,
  [SMALL_STATE(15005)] = 324109,
  [SMALL_STATE(15006)] = 324136,
  [SMALL_STATE(15007)] = 324163,
  [SMALL_STATE(15008)] = 324190,
  [SMALL_STATE(15009)] = 324217,
  [SMALL_STATE(15010)] = 324244,
  [SMALL_STATE(15011)] = 324271,
  [SMALL_STATE(15012)] = 324298,
  [SMALL_STATE(15013)] = 324325,
  [SMALL_STATE(15014)] = 324352,
  [SMALL_STATE(15015)] = 324379,
  [SMALL_STATE(15016)] = 324406,
  [SMALL_STATE(15017)] = 324433,
  [SMALL_STATE(15018)] = 324460,
  [SMALL_STATE(15019)] = 324489,
  [SMALL_STATE(15020)] = 324518,
  [SMALL_STATE(15021)] = 324545,
  [SMALL_STATE(15022)] = 324572,
  [SMALL_STATE(15023)] = 324599,
  [SMALL_STATE(15024)] = 324626,
  [SMALL_STATE(15025)] = 324655,
  [SMALL_STATE(15026)] = 324684,
  [SMALL_STATE(15027)] = 324713,
  [SMALL_STATE(15028)] = 324738,
  [SMALL_STATE(15029)] = 324761,
  [SMALL_STATE(15030)] = 324788,
  [SMALL_STATE(15031)] = 324815,
  [SMALL_STATE(15032)] = 324842,
  [SMALL_STATE(15033)] = 324869,
  [SMALL_STATE(15034)] = 324898,
  [SMALL_STATE(15035)] = 324925,
  [SMALL_STATE(15036)] = 324954,
  [SMALL_STATE(15037)] = 324977,
  [SMALL_STATE(15038)] = 325004,
  [SMALL_STATE(15039)] = 325033,
  [SMALL_STATE(15040)] = 325052,
  [SMALL_STATE(15041)] = 325081,
  [SMALL_STATE(15042)] = 325108,
  [SMALL_STATE(15043)] = 325137,
  [SMALL_STATE(15044)] = 325164,
  [SMALL_STATE(15045)] = 325191,
  [SMALL_STATE(15046)] = 325218,
  [SMALL_STATE(15047)] = 325245,
  [SMALL_STATE(15048)] = 325272,
  [SMALL_STATE(15049)] = 325301,
  [SMALL_STATE(15050)] = 325328,
  [SMALL_STATE(15051)] = 325357,
  [SMALL_STATE(15052)] = 325384,
  [SMALL_STATE(15053)] = 325405,
  [SMALL_STATE(15054)] = 325432,
  [SMALL_STATE(15055)] = 325457,
  [SMALL_STATE(15056)] = 325484,
  [SMALL_STATE(15057)] = 325507,
  [SMALL_STATE(15058)] = 325534,
  [SMALL_STATE(15059)] = 325561,
  [SMALL_STATE(15060)] = 325588,
  [SMALL_STATE(15061)] = 325615,
  [SMALL_STATE(15062)] = 325642,
  [SMALL_STATE(15063)] = 325667,
  [SMALL_STATE(15064)] = 325696,
  [SMALL_STATE(15065)] = 325725,
  [SMALL_STATE(15066)] = 325754,
  [SMALL_STATE(15067)] = 325783,
  [SMALL_STATE(15068)] = 325812,
  [SMALL_STATE(15069)] = 325839,
  [SMALL_STATE(15070)] = 325866,
  [SMALL_STATE(15071)] = 325891,
  [SMALL_STATE(15072)] = 325918,
  [SMALL_STATE(15073)] = 325945,
  [SMALL_STATE(15074)] = 325972,
  [SMALL_STATE(15075)] = 326001,
  [SMALL_STATE(15076)] = 326028,
  [SMALL_STATE(15077)] = 326055,
  [SMALL_STATE(15078)] = 326080,
  [SMALL_STATE(15079)] = 326105,
  [SMALL_STATE(15080)] = 326132,
  [SMALL_STATE(15081)] = 326159,
  [SMALL_STATE(15082)] = 326186,
  [SMALL_STATE(15083)] = 326213,
  [SMALL_STATE(15084)] = 326238,
  [SMALL_STATE(15085)] = 326263,
  [SMALL_STATE(15086)] = 326288,
  [SMALL_STATE(15087)] = 326313,
  [SMALL_STATE(15088)] = 326338,
  [SMALL_STATE(15089)] = 326363,
  [SMALL_STATE(15090)] = 326390,
  [SMALL_STATE(15091)] = 326419,
  [SMALL_STATE(15092)] = 326448,
  [SMALL_STATE(15093)] = 326477,
  [SMALL_STATE(15094)] = 326504,
  [SMALL_STATE(15095)] = 326533,
  [SMALL_STATE(15096)] = 326560,
  [SMALL_STATE(15097)] = 326585,
  [SMALL_STATE(15098)] = 326612,
  [SMALL_STATE(15099)] = 326639,
  [SMALL_STATE(15100)] = 326666,
  [SMALL_STATE(15101)] = 326693,
  [SMALL_STATE(15102)] = 326720,
  [SMALL_STATE(15103)] = 326749,
  [SMALL_STATE(15104)] = 326776,
  [SMALL_STATE(15105)] = 326805,
  [SMALL_STATE(15106)] = 326832,
  [SMALL_STATE(15107)] = 326859,
  [SMALL_STATE(15108)] = 326886,
  [SMALL_STATE(15109)] = 326913,
  [SMALL_STATE(15110)] = 326935,
  [SMALL_STATE(15111)] = 326957,
  [SMALL_STATE(15112)] = 326979,
  [SMALL_STATE(15113)] = 327001,
  [SMALL_STATE(15114)] = 327023,
  [SMALL_STATE(15115)] = 327049,
  [SMALL_STATE(15116)] = 327071,
  [SMALL_STATE(15117)] = 327093,
  [SMALL_STATE(15118)] = 327115,
  [SMALL_STATE(15119)] = 327137,
  [SMALL_STATE(15120)] = 327159,
  [SMALL_STATE(15121)] = 327185,
  [SMALL_STATE(15122)] = 327207,
  [SMALL_STATE(15123)] = 327229,
  [SMALL_STATE(15124)] = 327251,
  [SMALL_STATE(15125)] = 327277,
  [SMALL_STATE(15126)] = 327299,
  [SMALL_STATE(15127)] = 327321,
  [SMALL_STATE(15128)] = 327343,
  [SMALL_STATE(15129)] = 327365,
  [SMALL_STATE(15130)] = 327391,
  [SMALL_STATE(15131)] = 327413,
  [SMALL_STATE(15132)] = 327435,
  [SMALL_STATE(15133)] = 327457,
  [SMALL_STATE(15134)] = 327479,
  [SMALL_STATE(15135)] = 327501,
  [SMALL_STATE(15136)] = 327527,
  [SMALL_STATE(15137)] = 327553,
  [SMALL_STATE(15138)] = 327579,
  [SMALL_STATE(15139)] = 327601,
  [SMALL_STATE(15140)] = 327623,
  [SMALL_STATE(15141)] = 327645,
  [SMALL_STATE(15142)] = 327667,
  [SMALL_STATE(15143)] = 327689,
  [SMALL_STATE(15144)] = 327711,
  [SMALL_STATE(15145)] = 327733,
  [SMALL_STATE(15146)] = 327755,
  [SMALL_STATE(15147)] = 327777,
  [SMALL_STATE(15148)] = 327803,
  [SMALL_STATE(15149)] = 327825,
  [SMALL_STATE(15150)] = 327847,
  [SMALL_STATE(15151)] = 327869,
  [SMALL_STATE(15152)] = 327895,
  [SMALL_STATE(15153)] = 327917,
  [SMALL_STATE(15154)] = 327943,
  [SMALL_STATE(15155)] = 327965,
  [SMALL_STATE(15156)] = 327987,
  [SMALL_STATE(15157)] = 328009,
  [SMALL_STATE(15158)] = 328031,
  [SMALL_STATE(15159)] = 328053,
  [SMALL_STATE(15160)] = 328079,
  [SMALL_STATE(15161)] = 328101,
  [SMALL_STATE(15162)] = 328123,
  [SMALL_STATE(15163)] = 328145,
  [SMALL_STATE(15164)] = 328167,
  [SMALL_STATE(15165)] = 328189,
  [SMALL_STATE(15166)] = 328211,
  [SMALL_STATE(15167)] = 328233,
  [SMALL_STATE(15168)] = 328255,
  [SMALL_STATE(15169)] = 328277,
  [SMALL_STATE(15170)] = 328301,
  [SMALL_STATE(15171)] = 328323,
  [SMALL_STATE(15172)] = 328343,
  [SMALL_STATE(15173)] = 328365,
  [SMALL_STATE(15174)] = 328387,
  [SMALL_STATE(15175)] = 328409,
  [SMALL_STATE(15176)] = 328431,
  [SMALL_STATE(15177)] = 328455,
  [SMALL_STATE(15178)] = 328477,
  [SMALL_STATE(15179)] = 328503,
  [SMALL_STATE(15180)] = 328525,
  [SMALL_STATE(15181)] = 328547,
  [SMALL_STATE(15182)] = 328569,
  [SMALL_STATE(15183)] = 328591,
  [SMALL_STATE(15184)] = 328615,
  [SMALL_STATE(15185)] = 328637,
  [SMALL_STATE(15186)] = 328659,
  [SMALL_STATE(15187)] = 328681,
  [SMALL_STATE(15188)] = 328703,
  [SMALL_STATE(15189)] = 328725,
  [SMALL_STATE(15190)] = 328747,
  [SMALL_STATE(15191)] = 328769,
  [SMALL_STATE(15192)] = 328791,
  [SMALL_STATE(15193)] = 328813,
  [SMALL_STATE(15194)] = 328835,
  [SMALL_STATE(15195)] = 328857,
  [SMALL_STATE(15196)] = 328879,
  [SMALL_STATE(15197)] = 328901,
  [SMALL_STATE(15198)] = 328923,
  [SMALL_STATE(15199)] = 328945,
  [SMALL_STATE(15200)] = 328967,
  [SMALL_STATE(15201)] = 328989,
  [SMALL_STATE(15202)] = 329011,
  [SMALL_STATE(15203)] = 329037,
  [SMALL_STATE(15204)] = 329059,
  [SMALL_STATE(15205)] = 329081,
  [SMALL_STATE(15206)] = 329103,
  [SMALL_STATE(15207)] = 329125,
  [SMALL_STATE(15208)] = 329147,
  [SMALL_STATE(15209)] = 329169,
  [SMALL_STATE(15210)] = 329195,
  [SMALL_STATE(15211)] = 329217,
  [SMALL_STATE(15212)] = 329239,
  [SMALL_STATE(15213)] = 329261,
  [SMALL_STATE(15214)] = 329283,
  [SMALL_STATE(15215)] = 329305,
  [SMALL_STATE(15216)] = 329327,
  [SMALL_STATE(15217)] = 329349,
  [SMALL_STATE(15218)] = 329375,
  [SMALL_STATE(15219)] = 329397,
  [SMALL_STATE(15220)] = 329419,
  [SMALL_STATE(15221)] = 329441,
  [SMALL_STATE(15222)] = 329467,
  [SMALL_STATE(15223)] = 329489,
  [SMALL_STATE(15224)] = 329515,
  [SMALL_STATE(15225)] = 329537,
  [SMALL_STATE(15226)] = 329559,
  [SMALL_STATE(15227)] = 329585,
  [SMALL_STATE(15228)] = 329607,
  [SMALL_STATE(15229)] = 329629,
  [SMALL_STATE(15230)] = 329651,
  [SMALL_STATE(15231)] = 329673,
  [SMALL_STATE(15232)] = 329695,
  [SMALL_STATE(15233)] = 329717,
  [SMALL_STATE(15234)] = 329743,
  [SMALL_STATE(15235)] = 329765,
  [SMALL_STATE(15236)] = 329791,
  [SMALL_STATE(15237)] = 329813,
  [SMALL_STATE(15238)] = 329835,
  [SMALL_STATE(15239)] = 329857,
  [SMALL_STATE(15240)] = 329883,
  [SMALL_STATE(15241)] = 329905,
  [SMALL_STATE(15242)] = 329927,
  [SMALL_STATE(15243)] = 329949,
  [SMALL_STATE(15244)] = 329971,
  [SMALL_STATE(15245)] = 329993,
  [SMALL_STATE(15246)] = 330015,
  [SMALL_STATE(15247)] = 330037,
  [SMALL_STATE(15248)] = 330059,
  [SMALL_STATE(15249)] = 330081,
  [SMALL_STATE(15250)] = 330103,
  [SMALL_STATE(15251)] = 330125,
  [SMALL_STATE(15252)] = 330147,
  [SMALL_STATE(15253)] = 330169,
  [SMALL_STATE(15254)] = 330193,
  [SMALL_STATE(15255)] = 330219,
  [SMALL_STATE(15256)] = 330241,
  [SMALL_STATE(15257)] = 330263,
  [SMALL_STATE(15258)] = 330289,
  [SMALL_STATE(15259)] = 330311,
  [SMALL_STATE(15260)] = 330333,
  [SMALL_STATE(15261)] = 330355,
  [SMALL_STATE(15262)] = 330381,
  [SMALL_STATE(15263)] = 330403,
  [SMALL_STATE(15264)] = 330425,
  [SMALL_STATE(15265)] = 330447,
  [SMALL_STATE(15266)] = 330469,
  [SMALL_STATE(15267)] = 330491,
  [SMALL_STATE(15268)] = 330513,
  [SMALL_STATE(15269)] = 330535,
  [SMALL_STATE(15270)] = 330559,
  [SMALL_STATE(15271)] = 330581,
  [SMALL_STATE(15272)] = 330603,
  [SMALL_STATE(15273)] = 330625,
  [SMALL_STATE(15274)] = 330647,
  [SMALL_STATE(15275)] = 330673,
  [SMALL_STATE(15276)] = 330695,
  [SMALL_STATE(15277)] = 330717,
  [SMALL_STATE(15278)] = 330739,
  [SMALL_STATE(15279)] = 330761,
  [SMALL_STATE(15280)] = 330783,
  [SMALL_STATE(15281)] = 330805,
  [SMALL_STATE(15282)] = 330827,
  [SMALL_STATE(15283)] = 330853,
  [SMALL_STATE(15284)] = 330875,
  [SMALL_STATE(15285)] = 330897,
  [SMALL_STATE(15286)] = 330919,
  [SMALL_STATE(15287)] = 330941,
  [SMALL_STATE(15288)] = 330963,
  [SMALL_STATE(15289)] = 330987,
  [SMALL_STATE(15290)] = 331013,
  [SMALL_STATE(15291)] = 331035,
  [SMALL_STATE(15292)] = 331057,
  [SMALL_STATE(15293)] = 331079,
  [SMALL_STATE(15294)] = 331101,
  [SMALL_STATE(15295)] = 331123,
  [SMALL_STATE(15296)] = 331149,
  [SMALL_STATE(15297)] = 331171,
  [SMALL_STATE(15298)] = 331193,
  [SMALL_STATE(15299)] = 331215,
  [SMALL_STATE(15300)] = 331241,
  [SMALL_STATE(15301)] = 331263,
  [SMALL_STATE(15302)] = 331285,
  [SMALL_STATE(15303)] = 331307,
  [SMALL_STATE(15304)] = 331329,
  [SMALL_STATE(15305)] = 331351,
  [SMALL_STATE(15306)] = 331375,
  [SMALL_STATE(15307)] = 331397,
  [SMALL_STATE(15308)] = 331419,
  [SMALL_STATE(15309)] = 331441,
  [SMALL_STATE(15310)] = 331463,
  [SMALL_STATE(15311)] = 331485,
  [SMALL_STATE(15312)] = 331511,
  [SMALL_STATE(15313)] = 331537,
  [SMALL_STATE(15314)] = 331559,
  [SMALL_STATE(15315)] = 331581,
  [SMALL_STATE(15316)] = 331607,
  [SMALL_STATE(15317)] = 331633,
  [SMALL_STATE(15318)] = 331655,
  [SMALL_STATE(15319)] = 331681,
  [SMALL_STATE(15320)] = 331703,
  [SMALL_STATE(15321)] = 331725,
  [SMALL_STATE(15322)] = 331747,
  [SMALL_STATE(15323)] = 331773,
  [SMALL_STATE(15324)] = 331795,
  [SMALL_STATE(15325)] = 331821,
  [SMALL_STATE(15326)] = 331847,
  [SMALL_STATE(15327)] = 331869,
  [SMALL_STATE(15328)] = 331891,
  [SMALL_STATE(15329)] = 331913,
  [SMALL_STATE(15330)] = 331939,
  [SMALL_STATE(15331)] = 331961,
  [SMALL_STATE(15332)] = 331983,
  [SMALL_STATE(15333)] = 332005,
  [SMALL_STATE(15334)] = 332027,
  [SMALL_STATE(15335)] = 332049,
  [SMALL_STATE(15336)] = 332071,
  [SMALL_STATE(15337)] = 332093,
  [SMALL_STATE(15338)] = 332115,
  [SMALL_STATE(15339)] = 332137,
  [SMALL_STATE(15340)] = 332159,
  [SMALL_STATE(15341)] = 332181,
  [SMALL_STATE(15342)] = 332203,
  [SMALL_STATE(15343)] = 332225,
  [SMALL_STATE(15344)] = 332247,
  [SMALL_STATE(15345)] = 332269,
  [SMALL_STATE(15346)] = 332291,
  [SMALL_STATE(15347)] = 332313,
  [SMALL_STATE(15348)] = 332335,
  [SMALL_STATE(15349)] = 332358,
  [SMALL_STATE(15350)] = 332381,
  [SMALL_STATE(15351)] = 332402,
  [SMALL_STATE(15352)] = 332423,
  [SMALL_STATE(15353)] = 332444,
  [SMALL_STATE(15354)] = 332465,
  [SMALL_STATE(15355)] = 332488,
  [SMALL_STATE(15356)] = 332511,
  [SMALL_STATE(15357)] = 332532,
  [SMALL_STATE(15358)] = 332553,
  [SMALL_STATE(15359)] = 332574,
  [SMALL_STATE(15360)] = 332595,
  [SMALL_STATE(15361)] = 332618,
  [SMALL_STATE(15362)] = 332641,
  [SMALL_STATE(15363)] = 332664,
  [SMALL_STATE(15364)] = 332687,
  [SMALL_STATE(15365)] = 332710,
  [SMALL_STATE(15366)] = 332727,
  [SMALL_STATE(15367)] = 332750,
  [SMALL_STATE(15368)] = 332773,
  [SMALL_STATE(15369)] = 332796,
  [SMALL_STATE(15370)] = 332819,
  [SMALL_STATE(15371)] = 332842,
  [SMALL_STATE(15372)] = 332865,
  [SMALL_STATE(15373)] = 332882,
  [SMALL_STATE(15374)] = 332903,
  [SMALL_STATE(15375)] = 332924,
  [SMALL_STATE(15376)] = 332945,
  [SMALL_STATE(15377)] = 332966,
  [SMALL_STATE(15378)] = 332987,
  [SMALL_STATE(15379)] = 333008,
  [SMALL_STATE(15380)] = 333029,
  [SMALL_STATE(15381)] = 333050,
  [SMALL_STATE(15382)] = 333071,
  [SMALL_STATE(15383)] = 333092,
  [SMALL_STATE(15384)] = 333113,
  [SMALL_STATE(15385)] = 333134,
  [SMALL_STATE(15386)] = 333155,
  [SMALL_STATE(15387)] = 333176,
  [SMALL_STATE(15388)] = 333197,
  [SMALL_STATE(15389)] = 333220,
  [SMALL_STATE(15390)] = 333243,
  [SMALL_STATE(15391)] = 333266,
  [SMALL_STATE(15392)] = 333289,
  [SMALL_STATE(15393)] = 333310,
  [SMALL_STATE(15394)] = 333333,
  [SMALL_STATE(15395)] = 333354,
  [SMALL_STATE(15396)] = 333375,
  [SMALL_STATE(15397)] = 333396,
  [SMALL_STATE(15398)] = 333417,
  [SMALL_STATE(15399)] = 333438,
  [SMALL_STATE(15400)] = 333459,
  [SMALL_STATE(15401)] = 333480,
  [SMALL_STATE(15402)] = 333501,
  [SMALL_STATE(15403)] = 333522,
  [SMALL_STATE(15404)] = 333543,
  [SMALL_STATE(15405)] = 333566,
  [SMALL_STATE(15406)] = 333589,
  [SMALL_STATE(15407)] = 333610,
  [SMALL_STATE(15408)] = 333631,
  [SMALL_STATE(15409)] = 333654,
  [SMALL_STATE(15410)] = 333675,
  [SMALL_STATE(15411)] = 333696,
  [SMALL_STATE(15412)] = 333717,
  [SMALL_STATE(15413)] = 333738,
  [SMALL_STATE(15414)] = 333761,
  [SMALL_STATE(15415)] = 333778,
  [SMALL_STATE(15416)] = 333801,
  [SMALL_STATE(15417)] = 333822,
  [SMALL_STATE(15418)] = 333845,
  [SMALL_STATE(15419)] = 333868,
  [SMALL_STATE(15420)] = 333889,
  [SMALL_STATE(15421)] = 333910,
  [SMALL_STATE(15422)] = 333931,
  [SMALL_STATE(15423)] = 333952,
  [SMALL_STATE(15424)] = 333969,
  [SMALL_STATE(15425)] = 333988,
  [SMALL_STATE(15426)] = 334009,
  [SMALL_STATE(15427)] = 334030,
  [SMALL_STATE(15428)] = 334051,
  [SMALL_STATE(15429)] = 334072,
  [SMALL_STATE(15430)] = 334095,
  [SMALL_STATE(15431)] = 334118,
  [SMALL_STATE(15432)] = 334141,
  [SMALL_STATE(15433)] = 334164,
  [SMALL_STATE(15434)] = 334187,
  [SMALL_STATE(15435)] = 334210,
  [SMALL_STATE(15436)] = 334231,
  [SMALL_STATE(15437)] = 334252,
  [SMALL_STATE(15438)] = 334273,
  [SMALL_STATE(15439)] = 334294,
  [SMALL_STATE(15440)] = 334315,
  [SMALL_STATE(15441)] = 334336,
  [SMALL_STATE(15442)] = 334357,
  [SMALL_STATE(15443)] = 334378,
  [SMALL_STATE(15444)] = 334399,
  [SMALL_STATE(15445)] = 334420,
  [SMALL_STATE(15446)] = 334441,
  [SMALL_STATE(15447)] = 334458,
  [SMALL_STATE(15448)] = 334481,
  [SMALL_STATE(15449)] = 334504,
  [SMALL_STATE(15450)] = 334527,
  [SMALL_STATE(15451)] = 334550,
  [SMALL_STATE(15452)] = 334571,
  [SMALL_STATE(15453)] = 334592,
  [SMALL_STATE(15454)] = 334613,
  [SMALL_STATE(15455)] = 334634,
  [SMALL_STATE(15456)] = 334655,
  [SMALL_STATE(15457)] = 334678,
  [SMALL_STATE(15458)] = 334699,
  [SMALL_STATE(15459)] = 334720,
  [SMALL_STATE(15460)] = 334741,
  [SMALL_STATE(15461)] = 334762,
  [SMALL_STATE(15462)] = 334785,
  [SMALL_STATE(15463)] = 334808,
  [SMALL_STATE(15464)] = 334831,
  [SMALL_STATE(15465)] = 334852,
  [SMALL_STATE(15466)] = 334873,
  [SMALL_STATE(15467)] = 334896,
  [SMALL_STATE(15468)] = 334919,
  [SMALL_STATE(15469)] = 334936,
  [SMALL_STATE(15470)] = 334959,
  [SMALL_STATE(15471)] = 334982,
  [SMALL_STATE(15472)] = 335005,
  [SMALL_STATE(15473)] = 335028,
  [SMALL_STATE(15474)] = 335051,
  [SMALL_STATE(15475)] = 335074,
  [SMALL_STATE(15476)] = 335097,
  [SMALL_STATE(15477)] = 335118,
  [SMALL_STATE(15478)] = 335139,
  [SMALL_STATE(15479)] = 335160,
  [SMALL_STATE(15480)] = 335181,
  [SMALL_STATE(15481)] = 335204,
  [SMALL_STATE(15482)] = 335225,
  [SMALL_STATE(15483)] = 335246,
  [SMALL_STATE(15484)] = 335267,
  [SMALL_STATE(15485)] = 335288,
  [SMALL_STATE(15486)] = 335309,
  [SMALL_STATE(15487)] = 335330,
  [SMALL_STATE(15488)] = 335351,
  [SMALL_STATE(15489)] = 335372,
  [SMALL_STATE(15490)] = 335395,
  [SMALL_STATE(15491)] = 335418,
  [SMALL_STATE(15492)] = 335441,
  [SMALL_STATE(15493)] = 335464,
  [SMALL_STATE(15494)] = 335487,
  [SMALL_STATE(15495)] = 335508,
  [SMALL_STATE(15496)] = 335531,
  [SMALL_STATE(15497)] = 335554,
  [SMALL_STATE(15498)] = 335577,
  [SMALL_STATE(15499)] = 335600,
  [SMALL_STATE(15500)] = 335621,
  [SMALL_STATE(15501)] = 335642,
  [SMALL_STATE(15502)] = 335663,
  [SMALL_STATE(15503)] = 335684,
  [SMALL_STATE(15504)] = 335707,
  [SMALL_STATE(15505)] = 335728,
  [SMALL_STATE(15506)] = 335749,
  [SMALL_STATE(15507)] = 335770,
  [SMALL_STATE(15508)] = 335791,
  [SMALL_STATE(15509)] = 335812,
  [SMALL_STATE(15510)] = 335833,
  [SMALL_STATE(15511)] = 335854,
  [SMALL_STATE(15512)] = 335875,
  [SMALL_STATE(15513)] = 335896,
  [SMALL_STATE(15514)] = 335917,
  [SMALL_STATE(15515)] = 335938,
  [SMALL_STATE(15516)] = 335961,
  [SMALL_STATE(15517)] = 335982,
  [SMALL_STATE(15518)] = 336005,
  [SMALL_STATE(15519)] = 336022,
  [SMALL_STATE(15520)] = 336045,
  [SMALL_STATE(15521)] = 336068,
  [SMALL_STATE(15522)] = 336089,
  [SMALL_STATE(15523)] = 336110,
  [SMALL_STATE(15524)] = 336131,
  [SMALL_STATE(15525)] = 336152,
  [SMALL_STATE(15526)] = 336175,
  [SMALL_STATE(15527)] = 336196,
  [SMALL_STATE(15528)] = 336217,
  [SMALL_STATE(15529)] = 336238,
  [SMALL_STATE(15530)] = 336259,
  [SMALL_STATE(15531)] = 336280,
  [SMALL_STATE(15532)] = 336303,
  [SMALL_STATE(15533)] = 336326,
  [SMALL_STATE(15534)] = 336349,
  [SMALL_STATE(15535)] = 336366,
  [SMALL_STATE(15536)] = 336389,
  [SMALL_STATE(15537)] = 336412,
  [SMALL_STATE(15538)] = 336435,
  [SMALL_STATE(15539)] = 336458,
  [SMALL_STATE(15540)] = 336479,
  [SMALL_STATE(15541)] = 336500,
  [SMALL_STATE(15542)] = 336521,
  [SMALL_STATE(15543)] = 336542,
  [SMALL_STATE(15544)] = 336563,
  [SMALL_STATE(15545)] = 336580,
  [SMALL_STATE(15546)] = 336603,
  [SMALL_STATE(15547)] = 336624,
  [SMALL_STATE(15548)] = 336645,
  [SMALL_STATE(15549)] = 336666,
  [SMALL_STATE(15550)] = 336687,
  [SMALL_STATE(15551)] = 336704,
  [SMALL_STATE(15552)] = 336725,
  [SMALL_STATE(15553)] = 336746,
  [SMALL_STATE(15554)] = 336767,
  [SMALL_STATE(15555)] = 336790,
  [SMALL_STATE(15556)] = 336813,
  [SMALL_STATE(15557)] = 336836,
  [SMALL_STATE(15558)] = 336859,
  [SMALL_STATE(15559)] = 336882,
  [SMALL_STATE(15560)] = 336905,
  [SMALL_STATE(15561)] = 336928,
  [SMALL_STATE(15562)] = 336951,
  [SMALL_STATE(15563)] = 336972,
  [SMALL_STATE(15564)] = 336993,
  [SMALL_STATE(15565)] = 337014,
  [SMALL_STATE(15566)] = 337035,
  [SMALL_STATE(15567)] = 337056,
  [SMALL_STATE(15568)] = 337077,
  [SMALL_STATE(15569)] = 337098,
  [SMALL_STATE(15570)] = 337119,
  [SMALL_STATE(15571)] = 337140,
  [SMALL_STATE(15572)] = 337161,
  [SMALL_STATE(15573)] = 337182,
  [SMALL_STATE(15574)] = 337203,
  [SMALL_STATE(15575)] = 337226,
  [SMALL_STATE(15576)] = 337249,
  [SMALL_STATE(15577)] = 337272,
  [SMALL_STATE(15578)] = 337295,
  [SMALL_STATE(15579)] = 337318,
  [SMALL_STATE(15580)] = 337341,
  [SMALL_STATE(15581)] = 337364,
  [SMALL_STATE(15582)] = 337385,
  [SMALL_STATE(15583)] = 337406,
  [SMALL_STATE(15584)] = 337427,
  [SMALL_STATE(15585)] = 337448,
  [SMALL_STATE(15586)] = 337469,
  [SMALL_STATE(15587)] = 337492,
  [SMALL_STATE(15588)] = 337513,
  [SMALL_STATE(15589)] = 337534,
  [SMALL_STATE(15590)] = 337555,
  [SMALL_STATE(15591)] = 337576,
  [SMALL_STATE(15592)] = 337597,
  [SMALL_STATE(15593)] = 337618,
  [SMALL_STATE(15594)] = 337639,
  [SMALL_STATE(15595)] = 337662,
  [SMALL_STATE(15596)] = 337679,
  [SMALL_STATE(15597)] = 337702,
  [SMALL_STATE(15598)] = 337725,
  [SMALL_STATE(15599)] = 337748,
  [SMALL_STATE(15600)] = 337771,
  [SMALL_STATE(15601)] = 337794,
  [SMALL_STATE(15602)] = 337817,
  [SMALL_STATE(15603)] = 337838,
  [SMALL_STATE(15604)] = 337861,
  [SMALL_STATE(15605)] = 337882,
  [SMALL_STATE(15606)] = 337903,
  [SMALL_STATE(15607)] = 337924,
  [SMALL_STATE(15608)] = 337945,
  [SMALL_STATE(15609)] = 337966,
  [SMALL_STATE(15610)] = 337987,
  [SMALL_STATE(15611)] = 338008,
  [SMALL_STATE(15612)] = 338029,
  [SMALL_STATE(15613)] = 338050,
  [SMALL_STATE(15614)] = 338071,
  [SMALL_STATE(15615)] = 338092,
  [SMALL_STATE(15616)] = 338113,
  [SMALL_STATE(15617)] = 338134,
  [SMALL_STATE(15618)] = 338155,
  [SMALL_STATE(15619)] = 338176,
  [SMALL_STATE(15620)] = 338199,
  [SMALL_STATE(15621)] = 338222,
  [SMALL_STATE(15622)] = 338245,
  [SMALL_STATE(15623)] = 338262,
  [SMALL_STATE(15624)] = 338285,
  [SMALL_STATE(15625)] = 338306,
  [SMALL_STATE(15626)] = 338327,
  [SMALL_STATE(15627)] = 338350,
  [SMALL_STATE(15628)] = 338371,
  [SMALL_STATE(15629)] = 338392,
  [SMALL_STATE(15630)] = 338413,
  [SMALL_STATE(15631)] = 338434,
  [SMALL_STATE(15632)] = 338455,
  [SMALL_STATE(15633)] = 338476,
  [SMALL_STATE(15634)] = 338497,
  [SMALL_STATE(15635)] = 338518,
  [SMALL_STATE(15636)] = 338539,
  [SMALL_STATE(15637)] = 338560,
  [SMALL_STATE(15638)] = 338581,
  [SMALL_STATE(15639)] = 338604,
  [SMALL_STATE(15640)] = 338627,
  [SMALL_STATE(15641)] = 338650,
  [SMALL_STATE(15642)] = 338673,
  [SMALL_STATE(15643)] = 338696,
  [SMALL_STATE(15644)] = 338717,
  [SMALL_STATE(15645)] = 338738,
  [SMALL_STATE(15646)] = 338759,
  [SMALL_STATE(15647)] = 338780,
  [SMALL_STATE(15648)] = 338801,
  [SMALL_STATE(15649)] = 338822,
  [SMALL_STATE(15650)] = 338843,
  [SMALL_STATE(15651)] = 338864,
  [SMALL_STATE(15652)] = 338887,
  [SMALL_STATE(15653)] = 338910,
  [SMALL_STATE(15654)] = 338933,
  [SMALL_STATE(15655)] = 338956,
  [SMALL_STATE(15656)] = 338977,
  [SMALL_STATE(15657)] = 339000,
  [SMALL_STATE(15658)] = 339023,
  [SMALL_STATE(15659)] = 339044,
  [SMALL_STATE(15660)] = 339065,
  [SMALL_STATE(15661)] = 339086,
  [SMALL_STATE(15662)] = 339107,
  [SMALL_STATE(15663)] = 339128,
  [SMALL_STATE(15664)] = 339149,
  [SMALL_STATE(15665)] = 339170,
  [SMALL_STATE(15666)] = 339191,
  [SMALL_STATE(15667)] = 339212,
  [SMALL_STATE(15668)] = 339233,
  [SMALL_STATE(15669)] = 339254,
  [SMALL_STATE(15670)] = 339275,
  [SMALL_STATE(15671)] = 339296,
  [SMALL_STATE(15672)] = 339317,
  [SMALL_STATE(15673)] = 339338,
  [SMALL_STATE(15674)] = 339359,
  [SMALL_STATE(15675)] = 339380,
  [SMALL_STATE(15676)] = 339401,
  [SMALL_STATE(15677)] = 339422,
  [SMALL_STATE(15678)] = 339443,
  [SMALL_STATE(15679)] = 339464,
  [SMALL_STATE(15680)] = 339485,
  [SMALL_STATE(15681)] = 339506,
  [SMALL_STATE(15682)] = 339527,
  [SMALL_STATE(15683)] = 339548,
  [SMALL_STATE(15684)] = 339569,
  [SMALL_STATE(15685)] = 339590,
  [SMALL_STATE(15686)] = 339613,
  [SMALL_STATE(15687)] = 339634,
  [SMALL_STATE(15688)] = 339655,
  [SMALL_STATE(15689)] = 339676,
  [SMALL_STATE(15690)] = 339697,
  [SMALL_STATE(15691)] = 339718,
  [SMALL_STATE(15692)] = 339739,
  [SMALL_STATE(15693)] = 339760,
  [SMALL_STATE(15694)] = 339781,
  [SMALL_STATE(15695)] = 339802,
  [SMALL_STATE(15696)] = 339825,
  [SMALL_STATE(15697)] = 339848,
  [SMALL_STATE(15698)] = 339869,
  [SMALL_STATE(15699)] = 339890,
  [SMALL_STATE(15700)] = 339911,
  [SMALL_STATE(15701)] = 339932,
  [SMALL_STATE(15702)] = 339955,
  [SMALL_STATE(15703)] = 339976,
  [SMALL_STATE(15704)] = 339997,
  [SMALL_STATE(15705)] = 340018,
  [SMALL_STATE(15706)] = 340039,
  [SMALL_STATE(15707)] = 340062,
  [SMALL_STATE(15708)] = 340083,
  [SMALL_STATE(15709)] = 340104,
  [SMALL_STATE(15710)] = 340125,
  [SMALL_STATE(15711)] = 340146,
  [SMALL_STATE(15712)] = 340167,
  [SMALL_STATE(15713)] = 340188,
  [SMALL_STATE(15714)] = 340209,
  [SMALL_STATE(15715)] = 340230,
  [SMALL_STATE(15716)] = 340253,
  [SMALL_STATE(15717)] = 340276,
  [SMALL_STATE(15718)] = 340297,
  [SMALL_STATE(15719)] = 340318,
  [SMALL_STATE(15720)] = 340339,
  [SMALL_STATE(15721)] = 340360,
  [SMALL_STATE(15722)] = 340381,
  [SMALL_STATE(15723)] = 340402,
  [SMALL_STATE(15724)] = 340423,
  [SMALL_STATE(15725)] = 340444,
  [SMALL_STATE(15726)] = 340465,
  [SMALL_STATE(15727)] = 340486,
  [SMALL_STATE(15728)] = 340507,
  [SMALL_STATE(15729)] = 340528,
  [SMALL_STATE(15730)] = 340549,
  [SMALL_STATE(15731)] = 340570,
  [SMALL_STATE(15732)] = 340591,
  [SMALL_STATE(15733)] = 340612,
  [SMALL_STATE(15734)] = 340633,
  [SMALL_STATE(15735)] = 340654,
  [SMALL_STATE(15736)] = 340675,
  [SMALL_STATE(15737)] = 340696,
  [SMALL_STATE(15738)] = 340717,
  [SMALL_STATE(15739)] = 340738,
  [SMALL_STATE(15740)] = 340759,
  [SMALL_STATE(15741)] = 340780,
  [SMALL_STATE(15742)] = 340801,
  [SMALL_STATE(15743)] = 340822,
  [SMALL_STATE(15744)] = 340843,
  [SMALL_STATE(15745)] = 340864,
  [SMALL_STATE(15746)] = 340885,
  [SMALL_STATE(15747)] = 340906,
  [SMALL_STATE(15748)] = 340927,
  [SMALL_STATE(15749)] = 340948,
  [SMALL_STATE(15750)] = 340969,
  [SMALL_STATE(15751)] = 340990,
  [SMALL_STATE(15752)] = 341011,
  [SMALL_STATE(15753)] = 341032,
  [SMALL_STATE(15754)] = 341053,
  [SMALL_STATE(15755)] = 341074,
  [SMALL_STATE(15756)] = 341095,
  [SMALL_STATE(15757)] = 341116,
  [SMALL_STATE(15758)] = 341137,
  [SMALL_STATE(15759)] = 341158,
  [SMALL_STATE(15760)] = 341179,
  [SMALL_STATE(15761)] = 341200,
  [SMALL_STATE(15762)] = 341221,
  [SMALL_STATE(15763)] = 341242,
  [SMALL_STATE(15764)] = 341263,
  [SMALL_STATE(15765)] = 341284,
  [SMALL_STATE(15766)] = 341307,
  [SMALL_STATE(15767)] = 341328,
  [SMALL_STATE(15768)] = 341349,
  [SMALL_STATE(15769)] = 341370,
  [SMALL_STATE(15770)] = 341391,
  [SMALL_STATE(15771)] = 341412,
  [SMALL_STATE(15772)] = 341433,
  [SMALL_STATE(15773)] = 341454,
  [SMALL_STATE(15774)] = 341475,
  [SMALL_STATE(15775)] = 341496,
  [SMALL_STATE(15776)] = 341517,
  [SMALL_STATE(15777)] = 341538,
  [SMALL_STATE(15778)] = 341559,
  [SMALL_STATE(15779)] = 341580,
  [SMALL_STATE(15780)] = 341601,
  [SMALL_STATE(15781)] = 341622,
  [SMALL_STATE(15782)] = 341643,
  [SMALL_STATE(15783)] = 341664,
  [SMALL_STATE(15784)] = 341685,
  [SMALL_STATE(15785)] = 341706,
  [SMALL_STATE(15786)] = 341727,
  [SMALL_STATE(15787)] = 341748,
  [SMALL_STATE(15788)] = 341769,
  [SMALL_STATE(15789)] = 341790,
  [SMALL_STATE(15790)] = 341811,
  [SMALL_STATE(15791)] = 341832,
  [SMALL_STATE(15792)] = 341853,
  [SMALL_STATE(15793)] = 341874,
  [SMALL_STATE(15794)] = 341895,
  [SMALL_STATE(15795)] = 341916,
  [SMALL_STATE(15796)] = 341937,
  [SMALL_STATE(15797)] = 341958,
  [SMALL_STATE(15798)] = 341979,
  [SMALL_STATE(15799)] = 342000,
  [SMALL_STATE(15800)] = 342021,
  [SMALL_STATE(15801)] = 342042,
  [SMALL_STATE(15802)] = 342063,
  [SMALL_STATE(15803)] = 342084,
  [SMALL_STATE(15804)] = 342105,
  [SMALL_STATE(15805)] = 342126,
  [SMALL_STATE(15806)] = 342147,
  [SMALL_STATE(15807)] = 342168,
  [SMALL_STATE(15808)] = 342189,
  [SMALL_STATE(15809)] = 342210,
  [SMALL_STATE(15810)] = 342231,
  [SMALL_STATE(15811)] = 342252,
  [SMALL_STATE(15812)] = 342273,
  [SMALL_STATE(15813)] = 342294,
  [SMALL_STATE(15814)] = 342315,
  [SMALL_STATE(15815)] = 342336,
  [SMALL_STATE(15816)] = 342357,
  [SMALL_STATE(15817)] = 342378,
  [SMALL_STATE(15818)] = 342399,
  [SMALL_STATE(15819)] = 342420,
  [SMALL_STATE(15820)] = 342441,
  [SMALL_STATE(15821)] = 342462,
  [SMALL_STATE(15822)] = 342483,
  [SMALL_STATE(15823)] = 342504,
  [SMALL_STATE(15824)] = 342525,
  [SMALL_STATE(15825)] = 342546,
  [SMALL_STATE(15826)] = 342567,
  [SMALL_STATE(15827)] = 342588,
  [SMALL_STATE(15828)] = 342609,
  [SMALL_STATE(15829)] = 342630,
  [SMALL_STATE(15830)] = 342651,
  [SMALL_STATE(15831)] = 342672,
  [SMALL_STATE(15832)] = 342693,
  [SMALL_STATE(15833)] = 342714,
  [SMALL_STATE(15834)] = 342735,
  [SMALL_STATE(15835)] = 342756,
  [SMALL_STATE(15836)] = 342777,
  [SMALL_STATE(15837)] = 342798,
  [SMALL_STATE(15838)] = 342819,
  [SMALL_STATE(15839)] = 342840,
  [SMALL_STATE(15840)] = 342861,
  [SMALL_STATE(15841)] = 342882,
  [SMALL_STATE(15842)] = 342903,
  [SMALL_STATE(15843)] = 342924,
  [SMALL_STATE(15844)] = 342945,
  [SMALL_STATE(15845)] = 342966,
  [SMALL_STATE(15846)] = 342987,
  [SMALL_STATE(15847)] = 343010,
  [SMALL_STATE(15848)] = 343031,
  [SMALL_STATE(15849)] = 343052,
  [SMALL_STATE(15850)] = 343073,
  [SMALL_STATE(15851)] = 343094,
  [SMALL_STATE(15852)] = 343115,
  [SMALL_STATE(15853)] = 343136,
  [SMALL_STATE(15854)] = 343157,
  [SMALL_STATE(15855)] = 343178,
  [SMALL_STATE(15856)] = 343199,
  [SMALL_STATE(15857)] = 343220,
  [SMALL_STATE(15858)] = 343241,
  [SMALL_STATE(15859)] = 343262,
  [SMALL_STATE(15860)] = 343283,
  [SMALL_STATE(15861)] = 343304,
  [SMALL_STATE(15862)] = 343325,
  [SMALL_STATE(15863)] = 343346,
  [SMALL_STATE(15864)] = 343367,
  [SMALL_STATE(15865)] = 343388,
  [SMALL_STATE(15866)] = 343409,
  [SMALL_STATE(15867)] = 343430,
  [SMALL_STATE(15868)] = 343451,
  [SMALL_STATE(15869)] = 343472,
  [SMALL_STATE(15870)] = 343493,
  [SMALL_STATE(15871)] = 343514,
  [SMALL_STATE(15872)] = 343535,
  [SMALL_STATE(15873)] = 343556,
  [SMALL_STATE(15874)] = 343577,
  [SMALL_STATE(15875)] = 343598,
  [SMALL_STATE(15876)] = 343619,
  [SMALL_STATE(15877)] = 343640,
  [SMALL_STATE(15878)] = 343661,
  [SMALL_STATE(15879)] = 343682,
  [SMALL_STATE(15880)] = 343703,
  [SMALL_STATE(15881)] = 343724,
  [SMALL_STATE(15882)] = 343745,
  [SMALL_STATE(15883)] = 343766,
  [SMALL_STATE(15884)] = 343787,
  [SMALL_STATE(15885)] = 343808,
  [SMALL_STATE(15886)] = 343829,
  [SMALL_STATE(15887)] = 343850,
  [SMALL_STATE(15888)] = 343871,
  [SMALL_STATE(15889)] = 343892,
  [SMALL_STATE(15890)] = 343913,
  [SMALL_STATE(15891)] = 343934,
  [SMALL_STATE(15892)] = 343955,
  [SMALL_STATE(15893)] = 343976,
  [SMALL_STATE(15894)] = 343997,
  [SMALL_STATE(15895)] = 344018,
  [SMALL_STATE(15896)] = 344039,
  [SMALL_STATE(15897)] = 344060,
  [SMALL_STATE(15898)] = 344081,
  [SMALL_STATE(15899)] = 344102,
  [SMALL_STATE(15900)] = 344123,
  [SMALL_STATE(15901)] = 344144,
  [SMALL_STATE(15902)] = 344165,
  [SMALL_STATE(15903)] = 344186,
  [SMALL_STATE(15904)] = 344207,
  [SMALL_STATE(15905)] = 344228,
  [SMALL_STATE(15906)] = 344249,
  [SMALL_STATE(15907)] = 344270,
  [SMALL_STATE(15908)] = 344291,
  [SMALL_STATE(15909)] = 344312,
  [SMALL_STATE(15910)] = 344333,
  [SMALL_STATE(15911)] = 344354,
  [SMALL_STATE(15912)] = 344375,
  [SMALL_STATE(15913)] = 344396,
  [SMALL_STATE(15914)] = 344417,
  [SMALL_STATE(15915)] = 344438,
  [SMALL_STATE(15916)] = 344461,
  [SMALL_STATE(15917)] = 344482,
  [SMALL_STATE(15918)] = 344503,
  [SMALL_STATE(15919)] = 344524,
  [SMALL_STATE(15920)] = 344545,
  [SMALL_STATE(15921)] = 344566,
  [SMALL_STATE(15922)] = 344587,
  [SMALL_STATE(15923)] = 344608,
  [SMALL_STATE(15924)] = 344629,
  [SMALL_STATE(15925)] = 344650,
  [SMALL_STATE(15926)] = 344671,
  [SMALL_STATE(15927)] = 344692,
  [SMALL_STATE(15928)] = 344713,
  [SMALL_STATE(15929)] = 344734,
  [SMALL_STATE(15930)] = 344755,
  [SMALL_STATE(15931)] = 344776,
  [SMALL_STATE(15932)] = 344797,
  [SMALL_STATE(15933)] = 344818,
  [SMALL_STATE(15934)] = 344839,
  [SMALL_STATE(15935)] = 344860,
  [SMALL_STATE(15936)] = 344881,
  [SMALL_STATE(15937)] = 344902,
  [SMALL_STATE(15938)] = 344923,
  [SMALL_STATE(15939)] = 344944,
  [SMALL_STATE(15940)] = 344965,
  [SMALL_STATE(15941)] = 344986,
  [SMALL_STATE(15942)] = 345007,
  [SMALL_STATE(15943)] = 345028,
  [SMALL_STATE(15944)] = 345049,
  [SMALL_STATE(15945)] = 345070,
  [SMALL_STATE(15946)] = 345091,
  [SMALL_STATE(15947)] = 345112,
  [SMALL_STATE(15948)] = 345133,
  [SMALL_STATE(15949)] = 345154,
  [SMALL_STATE(15950)] = 345175,
  [SMALL_STATE(15951)] = 345196,
  [SMALL_STATE(15952)] = 345217,
  [SMALL_STATE(15953)] = 345238,
  [SMALL_STATE(15954)] = 345259,
  [SMALL_STATE(15955)] = 345280,
  [SMALL_STATE(15956)] = 345301,
  [SMALL_STATE(15957)] = 345322,
  [SMALL_STATE(15958)] = 345343,
  [SMALL_STATE(15959)] = 345364,
  [SMALL_STATE(15960)] = 345385,
  [SMALL_STATE(15961)] = 345406,
  [SMALL_STATE(15962)] = 345427,
  [SMALL_STATE(15963)] = 345448,
  [SMALL_STATE(15964)] = 345469,
  [SMALL_STATE(15965)] = 345490,
  [SMALL_STATE(15966)] = 345511,
  [SMALL_STATE(15967)] = 345532,
  [SMALL_STATE(15968)] = 345553,
  [SMALL_STATE(15969)] = 345574,
  [SMALL_STATE(15970)] = 345595,
  [SMALL_STATE(15971)] = 345616,
  [SMALL_STATE(15972)] = 345637,
  [SMALL_STATE(15973)] = 345658,
  [SMALL_STATE(15974)] = 345679,
  [SMALL_STATE(15975)] = 345700,
  [SMALL_STATE(15976)] = 345721,
  [SMALL_STATE(15977)] = 345742,
  [SMALL_STATE(15978)] = 345763,
  [SMALL_STATE(15979)] = 345784,
  [SMALL_STATE(15980)] = 345805,
  [SMALL_STATE(15981)] = 345828,
  [SMALL_STATE(15982)] = 345849,
  [SMALL_STATE(15983)] = 345870,
  [SMALL_STATE(15984)] = 345891,
  [SMALL_STATE(15985)] = 345912,
  [SMALL_STATE(15986)] = 345933,
  [SMALL_STATE(15987)] = 345954,
  [SMALL_STATE(15988)] = 345975,
  [SMALL_STATE(15989)] = 345996,
  [SMALL_STATE(15990)] = 346017,
  [SMALL_STATE(15991)] = 346038,
  [SMALL_STATE(15992)] = 346059,
  [SMALL_STATE(15993)] = 346080,
  [SMALL_STATE(15994)] = 346101,
  [SMALL_STATE(15995)] = 346122,
  [SMALL_STATE(15996)] = 346143,
  [SMALL_STATE(15997)] = 346164,
  [SMALL_STATE(15998)] = 346185,
  [SMALL_STATE(15999)] = 346206,
  [SMALL_STATE(16000)] = 346227,
  [SMALL_STATE(16001)] = 346248,
  [SMALL_STATE(16002)] = 346269,
  [SMALL_STATE(16003)] = 346290,
  [SMALL_STATE(16004)] = 346311,
  [SMALL_STATE(16005)] = 346332,
  [SMALL_STATE(16006)] = 346353,
  [SMALL_STATE(16007)] = 346374,
  [SMALL_STATE(16008)] = 346395,
  [SMALL_STATE(16009)] = 346416,
  [SMALL_STATE(16010)] = 346437,
  [SMALL_STATE(16011)] = 346458,
  [SMALL_STATE(16012)] = 346479,
  [SMALL_STATE(16013)] = 346500,
  [SMALL_STATE(16014)] = 346521,
  [SMALL_STATE(16015)] = 346542,
  [SMALL_STATE(16016)] = 346563,
  [SMALL_STATE(16017)] = 346584,
  [SMALL_STATE(16018)] = 346605,
  [SMALL_STATE(16019)] = 346626,
  [SMALL_STATE(16020)] = 346647,
  [SMALL_STATE(16021)] = 346668,
  [SMALL_STATE(16022)] = 346689,
  [SMALL_STATE(16023)] = 346710,
  [SMALL_STATE(16024)] = 346731,
  [SMALL_STATE(16025)] = 346752,
  [SMALL_STATE(16026)] = 346773,
  [SMALL_STATE(16027)] = 346794,
  [SMALL_STATE(16028)] = 346815,
  [SMALL_STATE(16029)] = 346836,
  [SMALL_STATE(16030)] = 346857,
  [SMALL_STATE(16031)] = 346878,
  [SMALL_STATE(16032)] = 346899,
  [SMALL_STATE(16033)] = 346920,
  [SMALL_STATE(16034)] = 346941,
  [SMALL_STATE(16035)] = 346958,
  [SMALL_STATE(16036)] = 346979,
  [SMALL_STATE(16037)] = 347000,
  [SMALL_STATE(16038)] = 347021,
  [SMALL_STATE(16039)] = 347044,
  [SMALL_STATE(16040)] = 347065,
  [SMALL_STATE(16041)] = 347086,
  [SMALL_STATE(16042)] = 347107,
  [SMALL_STATE(16043)] = 347128,
  [SMALL_STATE(16044)] = 347149,
  [SMALL_STATE(16045)] = 347172,
  [SMALL_STATE(16046)] = 347189,
  [SMALL_STATE(16047)] = 347210,
  [SMALL_STATE(16048)] = 347233,
  [SMALL_STATE(16049)] = 347256,
  [SMALL_STATE(16050)] = 347279,
  [SMALL_STATE(16051)] = 347302,
  [SMALL_STATE(16052)] = 347325,
  [SMALL_STATE(16053)] = 347346,
  [SMALL_STATE(16054)] = 347369,
  [SMALL_STATE(16055)] = 347392,
  [SMALL_STATE(16056)] = 347415,
  [SMALL_STATE(16057)] = 347438,
  [SMALL_STATE(16058)] = 347461,
  [SMALL_STATE(16059)] = 347484,
  [SMALL_STATE(16060)] = 347507,
  [SMALL_STATE(16061)] = 347530,
  [SMALL_STATE(16062)] = 347553,
  [SMALL_STATE(16063)] = 347576,
  [SMALL_STATE(16064)] = 347597,
  [SMALL_STATE(16065)] = 347618,
  [SMALL_STATE(16066)] = 347641,
  [SMALL_STATE(16067)] = 347664,
  [SMALL_STATE(16068)] = 347687,
  [SMALL_STATE(16069)] = 347708,
  [SMALL_STATE(16070)] = 347729,
  [SMALL_STATE(16071)] = 347750,
  [SMALL_STATE(16072)] = 347771,
  [SMALL_STATE(16073)] = 347794,
  [SMALL_STATE(16074)] = 347817,
  [SMALL_STATE(16075)] = 347840,
  [SMALL_STATE(16076)] = 347863,
  [SMALL_STATE(16077)] = 347886,
  [SMALL_STATE(16078)] = 347909,
  [SMALL_STATE(16079)] = 347932,
  [SMALL_STATE(16080)] = 347955,
  [SMALL_STATE(16081)] = 347978,
  [SMALL_STATE(16082)] = 347999,
  [SMALL_STATE(16083)] = 348020,
  [SMALL_STATE(16084)] = 348041,
  [SMALL_STATE(16085)] = 348062,
  [SMALL_STATE(16086)] = 348085,
  [SMALL_STATE(16087)] = 348108,
  [SMALL_STATE(16088)] = 348131,
  [SMALL_STATE(16089)] = 348148,
  [SMALL_STATE(16090)] = 348171,
  [SMALL_STATE(16091)] = 348194,
  [SMALL_STATE(16092)] = 348217,
  [SMALL_STATE(16093)] = 348238,
  [SMALL_STATE(16094)] = 348261,
  [SMALL_STATE(16095)] = 348278,
  [SMALL_STATE(16096)] = 348299,
  [SMALL_STATE(16097)] = 348322,
  [SMALL_STATE(16098)] = 348345,
  [SMALL_STATE(16099)] = 348366,
  [SMALL_STATE(16100)] = 348387,
  [SMALL_STATE(16101)] = 348408,
  [SMALL_STATE(16102)] = 348429,
  [SMALL_STATE(16103)] = 348452,
  [SMALL_STATE(16104)] = 348475,
  [SMALL_STATE(16105)] = 348496,
  [SMALL_STATE(16106)] = 348519,
  [SMALL_STATE(16107)] = 348540,
  [SMALL_STATE(16108)] = 348561,
  [SMALL_STATE(16109)] = 348584,
  [SMALL_STATE(16110)] = 348605,
  [SMALL_STATE(16111)] = 348626,
  [SMALL_STATE(16112)] = 348647,
  [SMALL_STATE(16113)] = 348668,
  [SMALL_STATE(16114)] = 348689,
  [SMALL_STATE(16115)] = 348710,
  [SMALL_STATE(16116)] = 348731,
  [SMALL_STATE(16117)] = 348752,
  [SMALL_STATE(16118)] = 348775,
  [SMALL_STATE(16119)] = 348798,
  [SMALL_STATE(16120)] = 348821,
  [SMALL_STATE(16121)] = 348844,
  [SMALL_STATE(16122)] = 348867,
  [SMALL_STATE(16123)] = 348890,
  [SMALL_STATE(16124)] = 348913,
  [SMALL_STATE(16125)] = 348934,
  [SMALL_STATE(16126)] = 348955,
  [SMALL_STATE(16127)] = 348976,
  [SMALL_STATE(16128)] = 348997,
  [SMALL_STATE(16129)] = 349020,
  [SMALL_STATE(16130)] = 349043,
  [SMALL_STATE(16131)] = 349064,
  [SMALL_STATE(16132)] = 349085,
  [SMALL_STATE(16133)] = 349106,
  [SMALL_STATE(16134)] = 349127,
  [SMALL_STATE(16135)] = 349150,
  [SMALL_STATE(16136)] = 349173,
  [SMALL_STATE(16137)] = 349196,
  [SMALL_STATE(16138)] = 349219,
  [SMALL_STATE(16139)] = 349242,
  [SMALL_STATE(16140)] = 349265,
  [SMALL_STATE(16141)] = 349288,
  [SMALL_STATE(16142)] = 349311,
  [SMALL_STATE(16143)] = 349334,
  [SMALL_STATE(16144)] = 349357,
  [SMALL_STATE(16145)] = 349380,
  [SMALL_STATE(16146)] = 349403,
  [SMALL_STATE(16147)] = 349426,
  [SMALL_STATE(16148)] = 349449,
  [SMALL_STATE(16149)] = 349472,
  [SMALL_STATE(16150)] = 349493,
  [SMALL_STATE(16151)] = 349514,
  [SMALL_STATE(16152)] = 349535,
  [SMALL_STATE(16153)] = 349556,
  [SMALL_STATE(16154)] = 349579,
  [SMALL_STATE(16155)] = 349602,
  [SMALL_STATE(16156)] = 349625,
  [SMALL_STATE(16157)] = 349648,
  [SMALL_STATE(16158)] = 349669,
  [SMALL_STATE(16159)] = 349690,
  [SMALL_STATE(16160)] = 349711,
  [SMALL_STATE(16161)] = 349732,
  [SMALL_STATE(16162)] = 349755,
  [SMALL_STATE(16163)] = 349776,
  [SMALL_STATE(16164)] = 349799,
  [SMALL_STATE(16165)] = 349822,
  [SMALL_STATE(16166)] = 349845,
  [SMALL_STATE(16167)] = 349862,
  [SMALL_STATE(16168)] = 349883,
  [SMALL_STATE(16169)] = 349904,
  [SMALL_STATE(16170)] = 349925,
  [SMALL_STATE(16171)] = 349948,
  [SMALL_STATE(16172)] = 349971,
  [SMALL_STATE(16173)] = 349992,
  [SMALL_STATE(16174)] = 350015,
  [SMALL_STATE(16175)] = 350038,
  [SMALL_STATE(16176)] = 350059,
  [SMALL_STATE(16177)] = 350080,
  [SMALL_STATE(16178)] = 350101,
  [SMALL_STATE(16179)] = 350124,
  [SMALL_STATE(16180)] = 350145,
  [SMALL_STATE(16181)] = 350162,
  [SMALL_STATE(16182)] = 350185,
  [SMALL_STATE(16183)] = 350206,
  [SMALL_STATE(16184)] = 350227,
  [SMALL_STATE(16185)] = 350250,
  [SMALL_STATE(16186)] = 350273,
  [SMALL_STATE(16187)] = 350294,
  [SMALL_STATE(16188)] = 350317,
  [SMALL_STATE(16189)] = 350340,
  [SMALL_STATE(16190)] = 350363,
  [SMALL_STATE(16191)] = 350380,
  [SMALL_STATE(16192)] = 350403,
  [SMALL_STATE(16193)] = 350424,
  [SMALL_STATE(16194)] = 350447,
  [SMALL_STATE(16195)] = 350470,
  [SMALL_STATE(16196)] = 350493,
  [SMALL_STATE(16197)] = 350516,
  [SMALL_STATE(16198)] = 350539,
  [SMALL_STATE(16199)] = 350562,
  [SMALL_STATE(16200)] = 350583,
  [SMALL_STATE(16201)] = 350606,
  [SMALL_STATE(16202)] = 350629,
  [SMALL_STATE(16203)] = 350652,
  [SMALL_STATE(16204)] = 350675,
  [SMALL_STATE(16205)] = 350698,
  [SMALL_STATE(16206)] = 350721,
  [SMALL_STATE(16207)] = 350742,
  [SMALL_STATE(16208)] = 350765,
  [SMALL_STATE(16209)] = 350788,
  [SMALL_STATE(16210)] = 350809,
  [SMALL_STATE(16211)] = 350832,
  [SMALL_STATE(16212)] = 350855,
  [SMALL_STATE(16213)] = 350878,
  [SMALL_STATE(16214)] = 350901,
  [SMALL_STATE(16215)] = 350924,
  [SMALL_STATE(16216)] = 350945,
  [SMALL_STATE(16217)] = 350962,
  [SMALL_STATE(16218)] = 350981,
  [SMALL_STATE(16219)] = 351004,
  [SMALL_STATE(16220)] = 351027,
  [SMALL_STATE(16221)] = 351050,
  [SMALL_STATE(16222)] = 351073,
  [SMALL_STATE(16223)] = 351096,
  [SMALL_STATE(16224)] = 351119,
  [SMALL_STATE(16225)] = 351142,
  [SMALL_STATE(16226)] = 351165,
  [SMALL_STATE(16227)] = 351188,
  [SMALL_STATE(16228)] = 351211,
  [SMALL_STATE(16229)] = 351234,
  [SMALL_STATE(16230)] = 351257,
  [SMALL_STATE(16231)] = 351280,
  [SMALL_STATE(16232)] = 351303,
  [SMALL_STATE(16233)] = 351326,
  [SMALL_STATE(16234)] = 351347,
  [SMALL_STATE(16235)] = 351364,
  [SMALL_STATE(16236)] = 351387,
  [SMALL_STATE(16237)] = 351410,
  [SMALL_STATE(16238)] = 351433,
  [SMALL_STATE(16239)] = 351456,
  [SMALL_STATE(16240)] = 351479,
  [SMALL_STATE(16241)] = 351502,
  [SMALL_STATE(16242)] = 351525,
  [SMALL_STATE(16243)] = 351548,
  [SMALL_STATE(16244)] = 351571,
  [SMALL_STATE(16245)] = 351590,
  [SMALL_STATE(16246)] = 351613,
  [SMALL_STATE(16247)] = 351634,
  [SMALL_STATE(16248)] = 351655,
  [SMALL_STATE(16249)] = 351676,
  [SMALL_STATE(16250)] = 351697,
  [SMALL_STATE(16251)] = 351718,
  [SMALL_STATE(16252)] = 351741,
  [SMALL_STATE(16253)] = 351764,
  [SMALL_STATE(16254)] = 351787,
  [SMALL_STATE(16255)] = 351810,
  [SMALL_STATE(16256)] = 351833,
  [SMALL_STATE(16257)] = 351856,
  [SMALL_STATE(16258)] = 351879,
  [SMALL_STATE(16259)] = 351902,
  [SMALL_STATE(16260)] = 351925,
  [SMALL_STATE(16261)] = 351948,
  [SMALL_STATE(16262)] = 351971,
  [SMALL_STATE(16263)] = 351994,
  [SMALL_STATE(16264)] = 352015,
  [SMALL_STATE(16265)] = 352038,
  [SMALL_STATE(16266)] = 352061,
  [SMALL_STATE(16267)] = 352084,
  [SMALL_STATE(16268)] = 352105,
  [SMALL_STATE(16269)] = 352128,
  [SMALL_STATE(16270)] = 352151,
  [SMALL_STATE(16271)] = 352172,
  [SMALL_STATE(16272)] = 352195,
  [SMALL_STATE(16273)] = 352218,
  [SMALL_STATE(16274)] = 352241,
  [SMALL_STATE(16275)] = 352264,
  [SMALL_STATE(16276)] = 352287,
  [SMALL_STATE(16277)] = 352308,
  [SMALL_STATE(16278)] = 352329,
  [SMALL_STATE(16279)] = 352350,
  [SMALL_STATE(16280)] = 352371,
  [SMALL_STATE(16281)] = 352392,
  [SMALL_STATE(16282)] = 352413,
  [SMALL_STATE(16283)] = 352436,
  [SMALL_STATE(16284)] = 352459,
  [SMALL_STATE(16285)] = 352482,
  [SMALL_STATE(16286)] = 352499,
  [SMALL_STATE(16287)] = 352522,
  [SMALL_STATE(16288)] = 352545,
  [SMALL_STATE(16289)] = 352568,
  [SMALL_STATE(16290)] = 352591,
  [SMALL_STATE(16291)] = 352614,
  [SMALL_STATE(16292)] = 352637,
  [SMALL_STATE(16293)] = 352658,
  [SMALL_STATE(16294)] = 352679,
  [SMALL_STATE(16295)] = 352700,
  [SMALL_STATE(16296)] = 352721,
  [SMALL_STATE(16297)] = 352742,
  [SMALL_STATE(16298)] = 352763,
  [SMALL_STATE(16299)] = 352786,
  [SMALL_STATE(16300)] = 352809,
  [SMALL_STATE(16301)] = 352832,
  [SMALL_STATE(16302)] = 352855,
  [SMALL_STATE(16303)] = 352878,
  [SMALL_STATE(16304)] = 352901,
  [SMALL_STATE(16305)] = 352924,
  [SMALL_STATE(16306)] = 352945,
  [SMALL_STATE(16307)] = 352966,
  [SMALL_STATE(16308)] = 352989,
  [SMALL_STATE(16309)] = 353012,
  [SMALL_STATE(16310)] = 353035,
  [SMALL_STATE(16311)] = 353058,
  [SMALL_STATE(16312)] = 353081,
  [SMALL_STATE(16313)] = 353104,
  [SMALL_STATE(16314)] = 353127,
  [SMALL_STATE(16315)] = 353150,
  [SMALL_STATE(16316)] = 353173,
  [SMALL_STATE(16317)] = 353196,
  [SMALL_STATE(16318)] = 353217,
  [SMALL_STATE(16319)] = 353240,
  [SMALL_STATE(16320)] = 353263,
  [SMALL_STATE(16321)] = 353286,
  [SMALL_STATE(16322)] = 353309,
  [SMALL_STATE(16323)] = 353332,
  [SMALL_STATE(16324)] = 353355,
  [SMALL_STATE(16325)] = 353378,
  [SMALL_STATE(16326)] = 353401,
  [SMALL_STATE(16327)] = 353424,
  [SMALL_STATE(16328)] = 353447,
  [SMALL_STATE(16329)] = 353470,
  [SMALL_STATE(16330)] = 353493,
  [SMALL_STATE(16331)] = 353516,
  [SMALL_STATE(16332)] = 353539,
  [SMALL_STATE(16333)] = 353562,
  [SMALL_STATE(16334)] = 353585,
  [SMALL_STATE(16335)] = 353608,
  [SMALL_STATE(16336)] = 353631,
  [SMALL_STATE(16337)] = 353654,
  [SMALL_STATE(16338)] = 353677,
  [SMALL_STATE(16339)] = 353700,
  [SMALL_STATE(16340)] = 353723,
  [SMALL_STATE(16341)] = 353746,
  [SMALL_STATE(16342)] = 353769,
  [SMALL_STATE(16343)] = 353792,
  [SMALL_STATE(16344)] = 353815,
  [SMALL_STATE(16345)] = 353838,
  [SMALL_STATE(16346)] = 353859,
  [SMALL_STATE(16347)] = 353882,
  [SMALL_STATE(16348)] = 353905,
  [SMALL_STATE(16349)] = 353928,
  [SMALL_STATE(16350)] = 353951,
  [SMALL_STATE(16351)] = 353974,
  [SMALL_STATE(16352)] = 353997,
  [SMALL_STATE(16353)] = 354020,
  [SMALL_STATE(16354)] = 354043,
  [SMALL_STATE(16355)] = 354066,
  [SMALL_STATE(16356)] = 354089,
  [SMALL_STATE(16357)] = 354112,
  [SMALL_STATE(16358)] = 354135,
  [SMALL_STATE(16359)] = 354158,
  [SMALL_STATE(16360)] = 354181,
  [SMALL_STATE(16361)] = 354204,
  [SMALL_STATE(16362)] = 354227,
  [SMALL_STATE(16363)] = 354250,
  [SMALL_STATE(16364)] = 354273,
  [SMALL_STATE(16365)] = 354296,
  [SMALL_STATE(16366)] = 354319,
  [SMALL_STATE(16367)] = 354342,
  [SMALL_STATE(16368)] = 354365,
  [SMALL_STATE(16369)] = 354388,
  [SMALL_STATE(16370)] = 354411,
  [SMALL_STATE(16371)] = 354434,
  [SMALL_STATE(16372)] = 354457,
  [SMALL_STATE(16373)] = 354480,
  [SMALL_STATE(16374)] = 354503,
  [SMALL_STATE(16375)] = 354526,
  [SMALL_STATE(16376)] = 354549,
  [SMALL_STATE(16377)] = 354572,
  [SMALL_STATE(16378)] = 354595,
  [SMALL_STATE(16379)] = 354618,
  [SMALL_STATE(16380)] = 354641,
  [SMALL_STATE(16381)] = 354664,
  [SMALL_STATE(16382)] = 354687,
  [SMALL_STATE(16383)] = 354710,
  [SMALL_STATE(16384)] = 354733,
  [SMALL_STATE(16385)] = 354756,
  [SMALL_STATE(16386)] = 354779,
  [SMALL_STATE(16387)] = 354802,
  [SMALL_STATE(16388)] = 354825,
  [SMALL_STATE(16389)] = 354848,
  [SMALL_STATE(16390)] = 354871,
  [SMALL_STATE(16391)] = 354894,
  [SMALL_STATE(16392)] = 354917,
  [SMALL_STATE(16393)] = 354940,
  [SMALL_STATE(16394)] = 354963,
  [SMALL_STATE(16395)] = 354986,
  [SMALL_STATE(16396)] = 355009,
  [SMALL_STATE(16397)] = 355032,
  [SMALL_STATE(16398)] = 355055,
  [SMALL_STATE(16399)] = 355078,
  [SMALL_STATE(16400)] = 355101,
  [SMALL_STATE(16401)] = 355124,
  [SMALL_STATE(16402)] = 355147,
  [SMALL_STATE(16403)] = 355170,
  [SMALL_STATE(16404)] = 355193,
  [SMALL_STATE(16405)] = 355216,
  [SMALL_STATE(16406)] = 355239,
  [SMALL_STATE(16407)] = 355262,
  [SMALL_STATE(16408)] = 355281,
  [SMALL_STATE(16409)] = 355304,
  [SMALL_STATE(16410)] = 355327,
  [SMALL_STATE(16411)] = 355350,
  [SMALL_STATE(16412)] = 355373,
  [SMALL_STATE(16413)] = 355390,
  [SMALL_STATE(16414)] = 355413,
  [SMALL_STATE(16415)] = 355436,
  [SMALL_STATE(16416)] = 355459,
  [SMALL_STATE(16417)] = 355482,
  [SMALL_STATE(16418)] = 355505,
  [SMALL_STATE(16419)] = 355528,
  [SMALL_STATE(16420)] = 355551,
  [SMALL_STATE(16421)] = 355574,
  [SMALL_STATE(16422)] = 355597,
  [SMALL_STATE(16423)] = 355620,
  [SMALL_STATE(16424)] = 355643,
  [SMALL_STATE(16425)] = 355666,
  [SMALL_STATE(16426)] = 355689,
  [SMALL_STATE(16427)] = 355712,
  [SMALL_STATE(16428)] = 355735,
  [SMALL_STATE(16429)] = 355758,
  [SMALL_STATE(16430)] = 355781,
  [SMALL_STATE(16431)] = 355804,
  [SMALL_STATE(16432)] = 355827,
  [SMALL_STATE(16433)] = 355850,
  [SMALL_STATE(16434)] = 355873,
  [SMALL_STATE(16435)] = 355896,
  [SMALL_STATE(16436)] = 355919,
  [SMALL_STATE(16437)] = 355938,
  [SMALL_STATE(16438)] = 355961,
  [SMALL_STATE(16439)] = 355984,
  [SMALL_STATE(16440)] = 356007,
  [SMALL_STATE(16441)] = 356030,
  [SMALL_STATE(16442)] = 356053,
  [SMALL_STATE(16443)] = 356076,
  [SMALL_STATE(16444)] = 356097,
  [SMALL_STATE(16445)] = 356120,
  [SMALL_STATE(16446)] = 356143,
  [SMALL_STATE(16447)] = 356166,
  [SMALL_STATE(16448)] = 356189,
  [SMALL_STATE(16449)] = 356212,
  [SMALL_STATE(16450)] = 356235,
  [SMALL_STATE(16451)] = 356256,
  [SMALL_STATE(16452)] = 356279,
  [SMALL_STATE(16453)] = 356302,
  [SMALL_STATE(16454)] = 356323,
  [SMALL_STATE(16455)] = 356346,
  [SMALL_STATE(16456)] = 356369,
  [SMALL_STATE(16457)] = 356390,
  [SMALL_STATE(16458)] = 356413,
  [SMALL_STATE(16459)] = 356436,
  [SMALL_STATE(16460)] = 356457,
  [SMALL_STATE(16461)] = 356480,
  [SMALL_STATE(16462)] = 356503,
  [SMALL_STATE(16463)] = 356526,
  [SMALL_STATE(16464)] = 356549,
  [SMALL_STATE(16465)] = 356572,
  [SMALL_STATE(16466)] = 356595,
  [SMALL_STATE(16467)] = 356618,
  [SMALL_STATE(16468)] = 356641,
  [SMALL_STATE(16469)] = 356664,
  [SMALL_STATE(16470)] = 356687,
  [SMALL_STATE(16471)] = 356710,
  [SMALL_STATE(16472)] = 356733,
  [SMALL_STATE(16473)] = 356756,
  [SMALL_STATE(16474)] = 356779,
  [SMALL_STATE(16475)] = 356802,
  [SMALL_STATE(16476)] = 356825,
  [SMALL_STATE(16477)] = 356848,
  [SMALL_STATE(16478)] = 356871,
  [SMALL_STATE(16479)] = 356894,
  [SMALL_STATE(16480)] = 356917,
  [SMALL_STATE(16481)] = 356940,
  [SMALL_STATE(16482)] = 356963,
  [SMALL_STATE(16483)] = 356986,
  [SMALL_STATE(16484)] = 357009,
  [SMALL_STATE(16485)] = 357032,
  [SMALL_STATE(16486)] = 357055,
  [SMALL_STATE(16487)] = 357078,
  [SMALL_STATE(16488)] = 357101,
  [SMALL_STATE(16489)] = 357124,
  [SMALL_STATE(16490)] = 357147,
  [SMALL_STATE(16491)] = 357170,
  [SMALL_STATE(16492)] = 357193,
  [SMALL_STATE(16493)] = 357216,
  [SMALL_STATE(16494)] = 357239,
  [SMALL_STATE(16495)] = 357262,
  [SMALL_STATE(16496)] = 357285,
  [SMALL_STATE(16497)] = 357308,
  [SMALL_STATE(16498)] = 357331,
  [SMALL_STATE(16499)] = 357354,
  [SMALL_STATE(16500)] = 357377,
  [SMALL_STATE(16501)] = 357400,
  [SMALL_STATE(16502)] = 357423,
  [SMALL_STATE(16503)] = 357446,
  [SMALL_STATE(16504)] = 357469,
  [SMALL_STATE(16505)] = 357492,
  [SMALL_STATE(16506)] = 357515,
  [SMALL_STATE(16507)] = 357538,
  [SMALL_STATE(16508)] = 357561,
  [SMALL_STATE(16509)] = 357584,
  [SMALL_STATE(16510)] = 357607,
  [SMALL_STATE(16511)] = 357630,
  [SMALL_STATE(16512)] = 357653,
  [SMALL_STATE(16513)] = 357676,
  [SMALL_STATE(16514)] = 357699,
  [SMALL_STATE(16515)] = 357722,
  [SMALL_STATE(16516)] = 357745,
  [SMALL_STATE(16517)] = 357768,
  [SMALL_STATE(16518)] = 357791,
  [SMALL_STATE(16519)] = 357814,
  [SMALL_STATE(16520)] = 357837,
  [SMALL_STATE(16521)] = 357860,
  [SMALL_STATE(16522)] = 357883,
  [SMALL_STATE(16523)] = 357906,
  [SMALL_STATE(16524)] = 357929,
  [SMALL_STATE(16525)] = 357952,
  [SMALL_STATE(16526)] = 357975,
  [SMALL_STATE(16527)] = 357998,
  [SMALL_STATE(16528)] = 358021,
  [SMALL_STATE(16529)] = 358044,
  [SMALL_STATE(16530)] = 358067,
  [SMALL_STATE(16531)] = 358090,
  [SMALL_STATE(16532)] = 358113,
  [SMALL_STATE(16533)] = 358136,
  [SMALL_STATE(16534)] = 358159,
  [SMALL_STATE(16535)] = 358182,
  [SMALL_STATE(16536)] = 358205,
  [SMALL_STATE(16537)] = 358228,
  [SMALL_STATE(16538)] = 358251,
  [SMALL_STATE(16539)] = 358274,
  [SMALL_STATE(16540)] = 358297,
  [SMALL_STATE(16541)] = 358320,
  [SMALL_STATE(16542)] = 358343,
  [SMALL_STATE(16543)] = 358366,
  [SMALL_STATE(16544)] = 358389,
  [SMALL_STATE(16545)] = 358410,
  [SMALL_STATE(16546)] = 358433,
  [SMALL_STATE(16547)] = 358454,
  [SMALL_STATE(16548)] = 358475,
  [SMALL_STATE(16549)] = 358498,
  [SMALL_STATE(16550)] = 358521,
  [SMALL_STATE(16551)] = 358542,
  [SMALL_STATE(16552)] = 358565,
  [SMALL_STATE(16553)] = 358588,
  [SMALL_STATE(16554)] = 358609,
  [SMALL_STATE(16555)] = 358632,
  [SMALL_STATE(16556)] = 358655,
  [SMALL_STATE(16557)] = 358678,
  [SMALL_STATE(16558)] = 358699,
  [SMALL_STATE(16559)] = 358720,
  [SMALL_STATE(16560)] = 358741,
  [SMALL_STATE(16561)] = 358762,
  [SMALL_STATE(16562)] = 358785,
  [SMALL_STATE(16563)] = 358808,
  [SMALL_STATE(16564)] = 358831,
  [SMALL_STATE(16565)] = 358854,
  [SMALL_STATE(16566)] = 358877,
  [SMALL_STATE(16567)] = 358898,
  [SMALL_STATE(16568)] = 358919,
  [SMALL_STATE(16569)] = 358940,
  [SMALL_STATE(16570)] = 358961,
  [SMALL_STATE(16571)] = 358982,
  [SMALL_STATE(16572)] = 359003,
  [SMALL_STATE(16573)] = 359024,
  [SMALL_STATE(16574)] = 359045,
  [SMALL_STATE(16575)] = 359068,
  [SMALL_STATE(16576)] = 359091,
  [SMALL_STATE(16577)] = 359114,
  [SMALL_STATE(16578)] = 359137,
  [SMALL_STATE(16579)] = 359160,
  [SMALL_STATE(16580)] = 359183,
  [SMALL_STATE(16581)] = 359200,
  [SMALL_STATE(16582)] = 359221,
  [SMALL_STATE(16583)] = 359242,
  [SMALL_STATE(16584)] = 359263,
  [SMALL_STATE(16585)] = 359284,
  [SMALL_STATE(16586)] = 359305,
  [SMALL_STATE(16587)] = 359326,
  [SMALL_STATE(16588)] = 359347,
  [SMALL_STATE(16589)] = 359368,
  [SMALL_STATE(16590)] = 359391,
  [SMALL_STATE(16591)] = 359412,
  [SMALL_STATE(16592)] = 359435,
  [SMALL_STATE(16593)] = 359452,
  [SMALL_STATE(16594)] = 359475,
  [SMALL_STATE(16595)] = 359498,
  [SMALL_STATE(16596)] = 359521,
  [SMALL_STATE(16597)] = 359544,
  [SMALL_STATE(16598)] = 359565,
  [SMALL_STATE(16599)] = 359586,
  [SMALL_STATE(16600)] = 359607,
  [SMALL_STATE(16601)] = 359630,
  [SMALL_STATE(16602)] = 359651,
  [SMALL_STATE(16603)] = 359672,
  [SMALL_STATE(16604)] = 359689,
  [SMALL_STATE(16605)] = 359712,
  [SMALL_STATE(16606)] = 359733,
  [SMALL_STATE(16607)] = 359756,
  [SMALL_STATE(16608)] = 359779,
  [SMALL_STATE(16609)] = 359802,
  [SMALL_STATE(16610)] = 359819,
  [SMALL_STATE(16611)] = 359836,
  [SMALL_STATE(16612)] = 359859,
  [SMALL_STATE(16613)] = 359882,
  [SMALL_STATE(16614)] = 359905,
  [SMALL_STATE(16615)] = 359928,
  [SMALL_STATE(16616)] = 359951,
  [SMALL_STATE(16617)] = 359972,
  [SMALL_STATE(16618)] = 359995,
  [SMALL_STATE(16619)] = 360016,
  [SMALL_STATE(16620)] = 360037,
  [SMALL_STATE(16621)] = 360058,
  [SMALL_STATE(16622)] = 360079,
  [SMALL_STATE(16623)] = 360102,
  [SMALL_STATE(16624)] = 360125,
  [SMALL_STATE(16625)] = 360148,
  [SMALL_STATE(16626)] = 360171,
  [SMALL_STATE(16627)] = 360194,
  [SMALL_STATE(16628)] = 360211,
  [SMALL_STATE(16629)] = 360228,
  [SMALL_STATE(16630)] = 360251,
  [SMALL_STATE(16631)] = 360274,
  [SMALL_STATE(16632)] = 360295,
  [SMALL_STATE(16633)] = 360316,
  [SMALL_STATE(16634)] = 360339,
  [SMALL_STATE(16635)] = 360360,
  [SMALL_STATE(16636)] = 360381,
  [SMALL_STATE(16637)] = 360404,
  [SMALL_STATE(16638)] = 360427,
  [SMALL_STATE(16639)] = 360448,
  [SMALL_STATE(16640)] = 360471,
  [SMALL_STATE(16641)] = 360492,
  [SMALL_STATE(16642)] = 360513,
  [SMALL_STATE(16643)] = 360534,
  [SMALL_STATE(16644)] = 360557,
  [SMALL_STATE(16645)] = 360580,
  [SMALL_STATE(16646)] = 360601,
  [SMALL_STATE(16647)] = 360624,
  [SMALL_STATE(16648)] = 360645,
  [SMALL_STATE(16649)] = 360666,
  [SMALL_STATE(16650)] = 360687,
  [SMALL_STATE(16651)] = 360708,
  [SMALL_STATE(16652)] = 360725,
  [SMALL_STATE(16653)] = 360742,
  [SMALL_STATE(16654)] = 360765,
  [SMALL_STATE(16655)] = 360786,
  [SMALL_STATE(16656)] = 360807,
  [SMALL_STATE(16657)] = 360828,
  [SMALL_STATE(16658)] = 360849,
  [SMALL_STATE(16659)] = 360870,
  [SMALL_STATE(16660)] = 360893,
  [SMALL_STATE(16661)] = 360910,
  [SMALL_STATE(16662)] = 360931,
  [SMALL_STATE(16663)] = 360952,
  [SMALL_STATE(16664)] = 360969,
  [SMALL_STATE(16665)] = 360992,
  [SMALL_STATE(16666)] = 361015,
  [SMALL_STATE(16667)] = 361038,
  [SMALL_STATE(16668)] = 361059,
  [SMALL_STATE(16669)] = 361082,
  [SMALL_STATE(16670)] = 361105,
  [SMALL_STATE(16671)] = 361128,
  [SMALL_STATE(16672)] = 361151,
  [SMALL_STATE(16673)] = 361172,
  [SMALL_STATE(16674)] = 361195,
  [SMALL_STATE(16675)] = 361218,
  [SMALL_STATE(16676)] = 361241,
  [SMALL_STATE(16677)] = 361264,
  [SMALL_STATE(16678)] = 361287,
  [SMALL_STATE(16679)] = 361310,
  [SMALL_STATE(16680)] = 361331,
  [SMALL_STATE(16681)] = 361352,
  [SMALL_STATE(16682)] = 361373,
  [SMALL_STATE(16683)] = 361394,
  [SMALL_STATE(16684)] = 361415,
  [SMALL_STATE(16685)] = 361438,
  [SMALL_STATE(16686)] = 361461,
  [SMALL_STATE(16687)] = 361484,
  [SMALL_STATE(16688)] = 361507,
  [SMALL_STATE(16689)] = 361524,
  [SMALL_STATE(16690)] = 361541,
  [SMALL_STATE(16691)] = 361564,
  [SMALL_STATE(16692)] = 361587,
  [SMALL_STATE(16693)] = 361604,
  [SMALL_STATE(16694)] = 361621,
  [SMALL_STATE(16695)] = 361638,
  [SMALL_STATE(16696)] = 361661,
  [SMALL_STATE(16697)] = 361682,
  [SMALL_STATE(16698)] = 361705,
  [SMALL_STATE(16699)] = 361722,
  [SMALL_STATE(16700)] = 361743,
  [SMALL_STATE(16701)] = 361764,
  [SMALL_STATE(16702)] = 361785,
  [SMALL_STATE(16703)] = 361806,
  [SMALL_STATE(16704)] = 361823,
  [SMALL_STATE(16705)] = 361840,
  [SMALL_STATE(16706)] = 361863,
  [SMALL_STATE(16707)] = 361880,
  [SMALL_STATE(16708)] = 361901,
  [SMALL_STATE(16709)] = 361918,
  [SMALL_STATE(16710)] = 361939,
  [SMALL_STATE(16711)] = 361960,
  [SMALL_STATE(16712)] = 361981,
  [SMALL_STATE(16713)] = 361998,
  [SMALL_STATE(16714)] = 362021,
  [SMALL_STATE(16715)] = 362038,
  [SMALL_STATE(16716)] = 362061,
  [SMALL_STATE(16717)] = 362078,
  [SMALL_STATE(16718)] = 362099,
  [SMALL_STATE(16719)] = 362122,
  [SMALL_STATE(16720)] = 362143,
  [SMALL_STATE(16721)] = 362164,
  [SMALL_STATE(16722)] = 362187,
  [SMALL_STATE(16723)] = 362210,
  [SMALL_STATE(16724)] = 362233,
  [SMALL_STATE(16725)] = 362256,
  [SMALL_STATE(16726)] = 362277,
  [SMALL_STATE(16727)] = 362298,
  [SMALL_STATE(16728)] = 362319,
  [SMALL_STATE(16729)] = 362340,
  [SMALL_STATE(16730)] = 362361,
  [SMALL_STATE(16731)] = 362384,
  [SMALL_STATE(16732)] = 362405,
  [SMALL_STATE(16733)] = 362428,
  [SMALL_STATE(16734)] = 362449,
  [SMALL_STATE(16735)] = 362472,
  [SMALL_STATE(16736)] = 362493,
  [SMALL_STATE(16737)] = 362510,
  [SMALL_STATE(16738)] = 362533,
  [SMALL_STATE(16739)] = 362556,
  [SMALL_STATE(16740)] = 362579,
  [SMALL_STATE(16741)] = 362602,
  [SMALL_STATE(16742)] = 362625,
  [SMALL_STATE(16743)] = 362648,
  [SMALL_STATE(16744)] = 362671,
  [SMALL_STATE(16745)] = 362694,
  [SMALL_STATE(16746)] = 362717,
  [SMALL_STATE(16747)] = 362738,
  [SMALL_STATE(16748)] = 362759,
  [SMALL_STATE(16749)] = 362780,
  [SMALL_STATE(16750)] = 362801,
  [SMALL_STATE(16751)] = 362822,
  [SMALL_STATE(16752)] = 362845,
  [SMALL_STATE(16753)] = 362868,
  [SMALL_STATE(16754)] = 362891,
  [SMALL_STATE(16755)] = 362914,
  [SMALL_STATE(16756)] = 362937,
  [SMALL_STATE(16757)] = 362954,
  [SMALL_STATE(16758)] = 362977,
  [SMALL_STATE(16759)] = 362996,
  [SMALL_STATE(16760)] = 363013,
  [SMALL_STATE(16761)] = 363036,
  [SMALL_STATE(16762)] = 363053,
  [SMALL_STATE(16763)] = 363070,
  [SMALL_STATE(16764)] = 363091,
  [SMALL_STATE(16765)] = 363112,
  [SMALL_STATE(16766)] = 363133,
  [SMALL_STATE(16767)] = 363154,
  [SMALL_STATE(16768)] = 363177,
  [SMALL_STATE(16769)] = 363194,
  [SMALL_STATE(16770)] = 363215,
  [SMALL_STATE(16771)] = 363236,
  [SMALL_STATE(16772)] = 363259,
  [SMALL_STATE(16773)] = 363280,
  [SMALL_STATE(16774)] = 363301,
  [SMALL_STATE(16775)] = 363324,
  [SMALL_STATE(16776)] = 363341,
  [SMALL_STATE(16777)] = 363364,
  [SMALL_STATE(16778)] = 363387,
  [SMALL_STATE(16779)] = 363410,
  [SMALL_STATE(16780)] = 363427,
  [SMALL_STATE(16781)] = 363444,
  [SMALL_STATE(16782)] = 363465,
  [SMALL_STATE(16783)] = 363482,
  [SMALL_STATE(16784)] = 363505,
  [SMALL_STATE(16785)] = 363528,
  [SMALL_STATE(16786)] = 363551,
  [SMALL_STATE(16787)] = 363570,
  [SMALL_STATE(16788)] = 363593,
  [SMALL_STATE(16789)] = 363610,
  [SMALL_STATE(16790)] = 363627,
  [SMALL_STATE(16791)] = 363650,
  [SMALL_STATE(16792)] = 363673,
  [SMALL_STATE(16793)] = 363690,
  [SMALL_STATE(16794)] = 363713,
  [SMALL_STATE(16795)] = 363736,
  [SMALL_STATE(16796)] = 363757,
  [SMALL_STATE(16797)] = 363780,
  [SMALL_STATE(16798)] = 363801,
  [SMALL_STATE(16799)] = 363822,
  [SMALL_STATE(16800)] = 363843,
  [SMALL_STATE(16801)] = 363864,
  [SMALL_STATE(16802)] = 363885,
  [SMALL_STATE(16803)] = 363908,
  [SMALL_STATE(16804)] = 363929,
  [SMALL_STATE(16805)] = 363950,
  [SMALL_STATE(16806)] = 363971,
  [SMALL_STATE(16807)] = 363992,
  [SMALL_STATE(16808)] = 364015,
  [SMALL_STATE(16809)] = 364038,
  [SMALL_STATE(16810)] = 364061,
  [SMALL_STATE(16811)] = 364084,
  [SMALL_STATE(16812)] = 364107,
  [SMALL_STATE(16813)] = 364128,
  [SMALL_STATE(16814)] = 364149,
  [SMALL_STATE(16815)] = 364172,
  [SMALL_STATE(16816)] = 364193,
  [SMALL_STATE(16817)] = 364214,
  [SMALL_STATE(16818)] = 364235,
  [SMALL_STATE(16819)] = 364258,
  [SMALL_STATE(16820)] = 364279,
  [SMALL_STATE(16821)] = 364300,
  [SMALL_STATE(16822)] = 364321,
  [SMALL_STATE(16823)] = 364344,
  [SMALL_STATE(16824)] = 364365,
  [SMALL_STATE(16825)] = 364386,
  [SMALL_STATE(16826)] = 364409,
  [SMALL_STATE(16827)] = 364432,
  [SMALL_STATE(16828)] = 364453,
  [SMALL_STATE(16829)] = 364474,
  [SMALL_STATE(16830)] = 364495,
  [SMALL_STATE(16831)] = 364516,
  [SMALL_STATE(16832)] = 364539,
  [SMALL_STATE(16833)] = 364562,
  [SMALL_STATE(16834)] = 364585,
  [SMALL_STATE(16835)] = 364608,
  [SMALL_STATE(16836)] = 364631,
  [SMALL_STATE(16837)] = 364654,
  [SMALL_STATE(16838)] = 364675,
  [SMALL_STATE(16839)] = 364698,
  [SMALL_STATE(16840)] = 364719,
  [SMALL_STATE(16841)] = 364740,
  [SMALL_STATE(16842)] = 364761,
  [SMALL_STATE(16843)] = 364784,
  [SMALL_STATE(16844)] = 364807,
  [SMALL_STATE(16845)] = 364830,
  [SMALL_STATE(16846)] = 364853,
  [SMALL_STATE(16847)] = 364876,
  [SMALL_STATE(16848)] = 364899,
  [SMALL_STATE(16849)] = 364922,
  [SMALL_STATE(16850)] = 364941,
  [SMALL_STATE(16851)] = 364962,
  [SMALL_STATE(16852)] = 364983,
  [SMALL_STATE(16853)] = 365004,
  [SMALL_STATE(16854)] = 365025,
  [SMALL_STATE(16855)] = 365048,
  [SMALL_STATE(16856)] = 365071,
  [SMALL_STATE(16857)] = 365092,
  [SMALL_STATE(16858)] = 365113,
  [SMALL_STATE(16859)] = 365134,
  [SMALL_STATE(16860)] = 365153,
  [SMALL_STATE(16861)] = 365174,
  [SMALL_STATE(16862)] = 365197,
  [SMALL_STATE(16863)] = 365220,
  [SMALL_STATE(16864)] = 365243,
  [SMALL_STATE(16865)] = 365266,
  [SMALL_STATE(16866)] = 365287,
  [SMALL_STATE(16867)] = 365308,
  [SMALL_STATE(16868)] = 365329,
  [SMALL_STATE(16869)] = 365352,
  [SMALL_STATE(16870)] = 365373,
  [SMALL_STATE(16871)] = 365396,
  [SMALL_STATE(16872)] = 365419,
  [SMALL_STATE(16873)] = 365442,
  [SMALL_STATE(16874)] = 365465,
  [SMALL_STATE(16875)] = 365488,
  [SMALL_STATE(16876)] = 365511,
  [SMALL_STATE(16877)] = 365534,
  [SMALL_STATE(16878)] = 365557,
  [SMALL_STATE(16879)] = 365578,
  [SMALL_STATE(16880)] = 365599,
  [SMALL_STATE(16881)] = 365622,
  [SMALL_STATE(16882)] = 365643,
  [SMALL_STATE(16883)] = 365664,
  [SMALL_STATE(16884)] = 365687,
  [SMALL_STATE(16885)] = 365710,
  [SMALL_STATE(16886)] = 365733,
  [SMALL_STATE(16887)] = 365756,
  [SMALL_STATE(16888)] = 365779,
  [SMALL_STATE(16889)] = 365802,
  [SMALL_STATE(16890)] = 365823,
  [SMALL_STATE(16891)] = 365844,
  [SMALL_STATE(16892)] = 365865,
  [SMALL_STATE(16893)] = 365886,
  [SMALL_STATE(16894)] = 365907,
  [SMALL_STATE(16895)] = 365928,
  [SMALL_STATE(16896)] = 365949,
  [SMALL_STATE(16897)] = 365970,
  [SMALL_STATE(16898)] = 365993,
  [SMALL_STATE(16899)] = 366016,
  [SMALL_STATE(16900)] = 366039,
  [SMALL_STATE(16901)] = 366062,
  [SMALL_STATE(16902)] = 366085,
  [SMALL_STATE(16903)] = 366102,
  [SMALL_STATE(16904)] = 366125,
  [SMALL_STATE(16905)] = 366148,
  [SMALL_STATE(16906)] = 366171,
  [SMALL_STATE(16907)] = 366194,
  [SMALL_STATE(16908)] = 366215,
  [SMALL_STATE(16909)] = 366236,
  [SMALL_STATE(16910)] = 366257,
  [SMALL_STATE(16911)] = 366278,
  [SMALL_STATE(16912)] = 366299,
  [SMALL_STATE(16913)] = 366322,
  [SMALL_STATE(16914)] = 366343,
  [SMALL_STATE(16915)] = 366366,
  [SMALL_STATE(16916)] = 366387,
  [SMALL_STATE(16917)] = 366410,
  [SMALL_STATE(16918)] = 366431,
  [SMALL_STATE(16919)] = 366452,
  [SMALL_STATE(16920)] = 366475,
  [SMALL_STATE(16921)] = 366498,
  [SMALL_STATE(16922)] = 366519,
  [SMALL_STATE(16923)] = 366540,
  [SMALL_STATE(16924)] = 366561,
  [SMALL_STATE(16925)] = 366582,
  [SMALL_STATE(16926)] = 366605,
  [SMALL_STATE(16927)] = 366628,
  [SMALL_STATE(16928)] = 366651,
  [SMALL_STATE(16929)] = 366674,
  [SMALL_STATE(16930)] = 366697,
  [SMALL_STATE(16931)] = 366718,
  [SMALL_STATE(16932)] = 366739,
  [SMALL_STATE(16933)] = 366760,
  [SMALL_STATE(16934)] = 366783,
  [SMALL_STATE(16935)] = 366804,
  [SMALL_STATE(16936)] = 366827,
  [SMALL_STATE(16937)] = 366850,
  [SMALL_STATE(16938)] = 366873,
  [SMALL_STATE(16939)] = 366896,
  [SMALL_STATE(16940)] = 366919,
  [SMALL_STATE(16941)] = 366942,
  [SMALL_STATE(16942)] = 366965,
  [SMALL_STATE(16943)] = 366988,
  [SMALL_STATE(16944)] = 367009,
  [SMALL_STATE(16945)] = 367030,
  [SMALL_STATE(16946)] = 367051,
  [SMALL_STATE(16947)] = 367072,
  [SMALL_STATE(16948)] = 367095,
  [SMALL_STATE(16949)] = 367118,
  [SMALL_STATE(16950)] = 367141,
  [SMALL_STATE(16951)] = 367164,
  [SMALL_STATE(16952)] = 367187,
  [SMALL_STATE(16953)] = 367210,
  [SMALL_STATE(16954)] = 367233,
  [SMALL_STATE(16955)] = 367252,
  [SMALL_STATE(16956)] = 367273,
  [SMALL_STATE(16957)] = 367296,
  [SMALL_STATE(16958)] = 367317,
  [SMALL_STATE(16959)] = 367338,
  [SMALL_STATE(16960)] = 367359,
  [SMALL_STATE(16961)] = 367380,
  [SMALL_STATE(16962)] = 367401,
  [SMALL_STATE(16963)] = 367424,
  [SMALL_STATE(16964)] = 367447,
  [SMALL_STATE(16965)] = 367470,
  [SMALL_STATE(16966)] = 367491,
  [SMALL_STATE(16967)] = 367514,
  [SMALL_STATE(16968)] = 367531,
  [SMALL_STATE(16969)] = 367554,
  [SMALL_STATE(16970)] = 367575,
  [SMALL_STATE(16971)] = 367598,
  [SMALL_STATE(16972)] = 367621,
  [SMALL_STATE(16973)] = 367642,
  [SMALL_STATE(16974)] = 367663,
  [SMALL_STATE(16975)] = 367684,
  [SMALL_STATE(16976)] = 367701,
  [SMALL_STATE(16977)] = 367722,
  [SMALL_STATE(16978)] = 367745,
  [SMALL_STATE(16979)] = 367762,
  [SMALL_STATE(16980)] = 367783,
  [SMALL_STATE(16981)] = 367804,
  [SMALL_STATE(16982)] = 367825,
  [SMALL_STATE(16983)] = 367846,
  [SMALL_STATE(16984)] = 367867,
  [SMALL_STATE(16985)] = 367888,
  [SMALL_STATE(16986)] = 367909,
  [SMALL_STATE(16987)] = 367932,
  [SMALL_STATE(16988)] = 367953,
  [SMALL_STATE(16989)] = 367976,
  [SMALL_STATE(16990)] = 367997,
  [SMALL_STATE(16991)] = 368020,
  [SMALL_STATE(16992)] = 368037,
  [SMALL_STATE(16993)] = 368058,
  [SMALL_STATE(16994)] = 368079,
  [SMALL_STATE(16995)] = 368102,
  [SMALL_STATE(16996)] = 368123,
  [SMALL_STATE(16997)] = 368140,
  [SMALL_STATE(16998)] = 368163,
  [SMALL_STATE(16999)] = 368186,
  [SMALL_STATE(17000)] = 368207,
  [SMALL_STATE(17001)] = 368230,
  [SMALL_STATE(17002)] = 368253,
  [SMALL_STATE(17003)] = 368270,
  [SMALL_STATE(17004)] = 368287,
  [SMALL_STATE(17005)] = 368310,
  [SMALL_STATE(17006)] = 368333,
  [SMALL_STATE(17007)] = 368354,
  [SMALL_STATE(17008)] = 368375,
  [SMALL_STATE(17009)] = 368396,
  [SMALL_STATE(17010)] = 368417,
  [SMALL_STATE(17011)] = 368438,
  [SMALL_STATE(17012)] = 368459,
  [SMALL_STATE(17013)] = 368480,
  [SMALL_STATE(17014)] = 368501,
  [SMALL_STATE(17015)] = 368518,
  [SMALL_STATE(17016)] = 368539,
  [SMALL_STATE(17017)] = 368562,
  [SMALL_STATE(17018)] = 368583,
  [SMALL_STATE(17019)] = 368604,
  [SMALL_STATE(17020)] = 368625,
  [SMALL_STATE(17021)] = 368648,
  [SMALL_STATE(17022)] = 368671,
  [SMALL_STATE(17023)] = 368692,
  [SMALL_STATE(17024)] = 368713,
  [SMALL_STATE(17025)] = 368734,
  [SMALL_STATE(17026)] = 368755,
  [SMALL_STATE(17027)] = 368776,
  [SMALL_STATE(17028)] = 368799,
  [SMALL_STATE(17029)] = 368822,
  [SMALL_STATE(17030)] = 368845,
  [SMALL_STATE(17031)] = 368868,
  [SMALL_STATE(17032)] = 368891,
  [SMALL_STATE(17033)] = 368914,
  [SMALL_STATE(17034)] = 368937,
  [SMALL_STATE(17035)] = 368960,
  [SMALL_STATE(17036)] = 368983,
  [SMALL_STATE(17037)] = 369006,
  [SMALL_STATE(17038)] = 369029,
  [SMALL_STATE(17039)] = 369050,
  [SMALL_STATE(17040)] = 369071,
  [SMALL_STATE(17041)] = 369092,
  [SMALL_STATE(17042)] = 369113,
  [SMALL_STATE(17043)] = 369134,
  [SMALL_STATE(17044)] = 369157,
  [SMALL_STATE(17045)] = 369180,
  [SMALL_STATE(17046)] = 369203,
  [SMALL_STATE(17047)] = 369226,
  [SMALL_STATE(17048)] = 369247,
  [SMALL_STATE(17049)] = 369268,
  [SMALL_STATE(17050)] = 369289,
  [SMALL_STATE(17051)] = 369310,
  [SMALL_STATE(17052)] = 369331,
  [SMALL_STATE(17053)] = 369352,
  [SMALL_STATE(17054)] = 369375,
  [SMALL_STATE(17055)] = 369398,
  [SMALL_STATE(17056)] = 369421,
  [SMALL_STATE(17057)] = 369444,
  [SMALL_STATE(17058)] = 369465,
  [SMALL_STATE(17059)] = 369488,
  [SMALL_STATE(17060)] = 369509,
  [SMALL_STATE(17061)] = 369530,
  [SMALL_STATE(17062)] = 369553,
  [SMALL_STATE(17063)] = 369574,
  [SMALL_STATE(17064)] = 369595,
  [SMALL_STATE(17065)] = 369618,
  [SMALL_STATE(17066)] = 369638,
  [SMALL_STATE(17067)] = 369658,
  [SMALL_STATE(17068)] = 369678,
  [SMALL_STATE(17069)] = 369698,
  [SMALL_STATE(17070)] = 369718,
  [SMALL_STATE(17071)] = 369738,
  [SMALL_STATE(17072)] = 369758,
  [SMALL_STATE(17073)] = 369778,
  [SMALL_STATE(17074)] = 369796,
  [SMALL_STATE(17075)] = 369816,
  [SMALL_STATE(17076)] = 369834,
  [SMALL_STATE(17077)] = 369854,
  [SMALL_STATE(17078)] = 369874,
  [SMALL_STATE(17079)] = 369894,
  [SMALL_STATE(17080)] = 369912,
  [SMALL_STATE(17081)] = 369932,
  [SMALL_STATE(17082)] = 369952,
  [SMALL_STATE(17083)] = 369972,
  [SMALL_STATE(17084)] = 369992,
  [SMALL_STATE(17085)] = 370012,
  [SMALL_STATE(17086)] = 370032,
  [SMALL_STATE(17087)] = 370052,
  [SMALL_STATE(17088)] = 370072,
  [SMALL_STATE(17089)] = 370092,
  [SMALL_STATE(17090)] = 370112,
  [SMALL_STATE(17091)] = 370132,
  [SMALL_STATE(17092)] = 370152,
  [SMALL_STATE(17093)] = 370172,
  [SMALL_STATE(17094)] = 370190,
  [SMALL_STATE(17095)] = 370210,
  [SMALL_STATE(17096)] = 370230,
  [SMALL_STATE(17097)] = 370250,
  [SMALL_STATE(17098)] = 370268,
  [SMALL_STATE(17099)] = 370288,
  [SMALL_STATE(17100)] = 370308,
  [SMALL_STATE(17101)] = 370328,
  [SMALL_STATE(17102)] = 370348,
  [SMALL_STATE(17103)] = 370368,
  [SMALL_STATE(17104)] = 370388,
  [SMALL_STATE(17105)] = 370408,
  [SMALL_STATE(17106)] = 370428,
  [SMALL_STATE(17107)] = 370448,
  [SMALL_STATE(17108)] = 370466,
  [SMALL_STATE(17109)] = 370486,
  [SMALL_STATE(17110)] = 370506,
  [SMALL_STATE(17111)] = 370526,
  [SMALL_STATE(17112)] = 370546,
  [SMALL_STATE(17113)] = 370566,
  [SMALL_STATE(17114)] = 370586,
  [SMALL_STATE(17115)] = 370606,
  [SMALL_STATE(17116)] = 370626,
  [SMALL_STATE(17117)] = 370646,
  [SMALL_STATE(17118)] = 370666,
  [SMALL_STATE(17119)] = 370686,
  [SMALL_STATE(17120)] = 370706,
  [SMALL_STATE(17121)] = 370726,
  [SMALL_STATE(17122)] = 370746,
  [SMALL_STATE(17123)] = 370766,
  [SMALL_STATE(17124)] = 370784,
  [SMALL_STATE(17125)] = 370804,
  [SMALL_STATE(17126)] = 370824,
  [SMALL_STATE(17127)] = 370844,
  [SMALL_STATE(17128)] = 370864,
  [SMALL_STATE(17129)] = 370884,
  [SMALL_STATE(17130)] = 370904,
  [SMALL_STATE(17131)] = 370924,
  [SMALL_STATE(17132)] = 370942,
  [SMALL_STATE(17133)] = 370962,
  [SMALL_STATE(17134)] = 370982,
  [SMALL_STATE(17135)] = 371002,
  [SMALL_STATE(17136)] = 371022,
  [SMALL_STATE(17137)] = 371042,
  [SMALL_STATE(17138)] = 371062,
  [SMALL_STATE(17139)] = 371082,
  [SMALL_STATE(17140)] = 371100,
  [SMALL_STATE(17141)] = 371120,
  [SMALL_STATE(17142)] = 371140,
  [SMALL_STATE(17143)] = 371160,
  [SMALL_STATE(17144)] = 371180,
  [SMALL_STATE(17145)] = 371200,
  [SMALL_STATE(17146)] = 371220,
  [SMALL_STATE(17147)] = 371240,
  [SMALL_STATE(17148)] = 371260,
  [SMALL_STATE(17149)] = 371278,
  [SMALL_STATE(17150)] = 371298,
  [SMALL_STATE(17151)] = 371318,
  [SMALL_STATE(17152)] = 371338,
  [SMALL_STATE(17153)] = 371358,
  [SMALL_STATE(17154)] = 371378,
  [SMALL_STATE(17155)] = 371398,
  [SMALL_STATE(17156)] = 371418,
  [SMALL_STATE(17157)] = 371438,
  [SMALL_STATE(17158)] = 371458,
  [SMALL_STATE(17159)] = 371478,
  [SMALL_STATE(17160)] = 371498,
  [SMALL_STATE(17161)] = 371518,
  [SMALL_STATE(17162)] = 371538,
  [SMALL_STATE(17163)] = 371554,
  [SMALL_STATE(17164)] = 371574,
  [SMALL_STATE(17165)] = 371594,
  [SMALL_STATE(17166)] = 371610,
  [SMALL_STATE(17167)] = 371630,
  [SMALL_STATE(17168)] = 371648,
  [SMALL_STATE(17169)] = 371668,
  [SMALL_STATE(17170)] = 371686,
  [SMALL_STATE(17171)] = 371706,
  [SMALL_STATE(17172)] = 371726,
  [SMALL_STATE(17173)] = 371746,
  [SMALL_STATE(17174)] = 371766,
  [SMALL_STATE(17175)] = 371786,
  [SMALL_STATE(17176)] = 371804,
  [SMALL_STATE(17177)] = 371824,
  [SMALL_STATE(17178)] = 371844,
  [SMALL_STATE(17179)] = 371864,
  [SMALL_STATE(17180)] = 371884,
  [SMALL_STATE(17181)] = 371904,
  [SMALL_STATE(17182)] = 371924,
  [SMALL_STATE(17183)] = 371944,
  [SMALL_STATE(17184)] = 371962,
  [SMALL_STATE(17185)] = 371982,
  [SMALL_STATE(17186)] = 372002,
  [SMALL_STATE(17187)] = 372022,
  [SMALL_STATE(17188)] = 372042,
  [SMALL_STATE(17189)] = 372062,
  [SMALL_STATE(17190)] = 372082,
  [SMALL_STATE(17191)] = 372102,
  [SMALL_STATE(17192)] = 372122,
  [SMALL_STATE(17193)] = 372142,
  [SMALL_STATE(17194)] = 372160,
  [SMALL_STATE(17195)] = 372180,
  [SMALL_STATE(17196)] = 372200,
  [SMALL_STATE(17197)] = 372218,
  [SMALL_STATE(17198)] = 372238,
  [SMALL_STATE(17199)] = 372258,
  [SMALL_STATE(17200)] = 372278,
  [SMALL_STATE(17201)] = 372298,
  [SMALL_STATE(17202)] = 372316,
  [SMALL_STATE(17203)] = 372336,
  [SMALL_STATE(17204)] = 372356,
  [SMALL_STATE(17205)] = 372376,
  [SMALL_STATE(17206)] = 372396,
  [SMALL_STATE(17207)] = 372416,
  [SMALL_STATE(17208)] = 372432,
  [SMALL_STATE(17209)] = 372450,
  [SMALL_STATE(17210)] = 372470,
  [SMALL_STATE(17211)] = 372490,
  [SMALL_STATE(17212)] = 372506,
  [SMALL_STATE(17213)] = 372526,
  [SMALL_STATE(17214)] = 372546,
  [SMALL_STATE(17215)] = 372566,
  [SMALL_STATE(17216)] = 372586,
  [SMALL_STATE(17217)] = 372606,
  [SMALL_STATE(17218)] = 372626,
  [SMALL_STATE(17219)] = 372646,
  [SMALL_STATE(17220)] = 372666,
  [SMALL_STATE(17221)] = 372686,
  [SMALL_STATE(17222)] = 372706,
  [SMALL_STATE(17223)] = 372726,
  [SMALL_STATE(17224)] = 372742,
  [SMALL_STATE(17225)] = 372762,
  [SMALL_STATE(17226)] = 372782,
  [SMALL_STATE(17227)] = 372802,
  [SMALL_STATE(17228)] = 372822,
  [SMALL_STATE(17229)] = 372842,
  [SMALL_STATE(17230)] = 372860,
  [SMALL_STATE(17231)] = 372880,
  [SMALL_STATE(17232)] = 372896,
  [SMALL_STATE(17233)] = 372916,
  [SMALL_STATE(17234)] = 372936,
  [SMALL_STATE(17235)] = 372956,
  [SMALL_STATE(17236)] = 372976,
  [SMALL_STATE(17237)] = 372996,
  [SMALL_STATE(17238)] = 373016,
  [SMALL_STATE(17239)] = 373034,
  [SMALL_STATE(17240)] = 373054,
  [SMALL_STATE(17241)] = 373074,
  [SMALL_STATE(17242)] = 373094,
  [SMALL_STATE(17243)] = 373114,
  [SMALL_STATE(17244)] = 373134,
  [SMALL_STATE(17245)] = 373154,
  [SMALL_STATE(17246)] = 373174,
  [SMALL_STATE(17247)] = 373194,
  [SMALL_STATE(17248)] = 373212,
  [SMALL_STATE(17249)] = 373232,
  [SMALL_STATE(17250)] = 373252,
  [SMALL_STATE(17251)] = 373272,
  [SMALL_STATE(17252)] = 373292,
  [SMALL_STATE(17253)] = 373312,
  [SMALL_STATE(17254)] = 373332,
  [SMALL_STATE(17255)] = 373352,
  [SMALL_STATE(17256)] = 373372,
  [SMALL_STATE(17257)] = 373392,
  [SMALL_STATE(17258)] = 373412,
  [SMALL_STATE(17259)] = 373432,
  [SMALL_STATE(17260)] = 373452,
  [SMALL_STATE(17261)] = 373472,
  [SMALL_STATE(17262)] = 373492,
  [SMALL_STATE(17263)] = 373512,
  [SMALL_STATE(17264)] = 373532,
  [SMALL_STATE(17265)] = 373552,
  [SMALL_STATE(17266)] = 373570,
  [SMALL_STATE(17267)] = 373590,
  [SMALL_STATE(17268)] = 373610,
  [SMALL_STATE(17269)] = 373630,
  [SMALL_STATE(17270)] = 373650,
  [SMALL_STATE(17271)] = 373670,
  [SMALL_STATE(17272)] = 373690,
  [SMALL_STATE(17273)] = 373710,
  [SMALL_STATE(17274)] = 373730,
  [SMALL_STATE(17275)] = 373750,
  [SMALL_STATE(17276)] = 373770,
  [SMALL_STATE(17277)] = 373790,
  [SMALL_STATE(17278)] = 373810,
  [SMALL_STATE(17279)] = 373830,
  [SMALL_STATE(17280)] = 373850,
  [SMALL_STATE(17281)] = 373870,
  [SMALL_STATE(17282)] = 373890,
  [SMALL_STATE(17283)] = 373908,
  [SMALL_STATE(17284)] = 373928,
  [SMALL_STATE(17285)] = 373948,
  [SMALL_STATE(17286)] = 373968,
  [SMALL_STATE(17287)] = 373988,
  [SMALL_STATE(17288)] = 374008,
  [SMALL_STATE(17289)] = 374028,
  [SMALL_STATE(17290)] = 374048,
  [SMALL_STATE(17291)] = 374068,
  [SMALL_STATE(17292)] = 374088,
  [SMALL_STATE(17293)] = 374108,
  [SMALL_STATE(17294)] = 374126,
  [SMALL_STATE(17295)] = 374146,
  [SMALL_STATE(17296)] = 374166,
  [SMALL_STATE(17297)] = 374186,
  [SMALL_STATE(17298)] = 374206,
  [SMALL_STATE(17299)] = 374226,
  [SMALL_STATE(17300)] = 374246,
  [SMALL_STATE(17301)] = 374266,
  [SMALL_STATE(17302)] = 374286,
  [SMALL_STATE(17303)] = 374304,
  [SMALL_STATE(17304)] = 374322,
  [SMALL_STATE(17305)] = 374342,
  [SMALL_STATE(17306)] = 374362,
  [SMALL_STATE(17307)] = 374382,
  [SMALL_STATE(17308)] = 374402,
  [SMALL_STATE(17309)] = 374422,
  [SMALL_STATE(17310)] = 374442,
  [SMALL_STATE(17311)] = 374462,
  [SMALL_STATE(17312)] = 374482,
  [SMALL_STATE(17313)] = 374502,
  [SMALL_STATE(17314)] = 374520,
  [SMALL_STATE(17315)] = 374540,
  [SMALL_STATE(17316)] = 374560,
  [SMALL_STATE(17317)] = 374580,
  [SMALL_STATE(17318)] = 374600,
  [SMALL_STATE(17319)] = 374620,
  [SMALL_STATE(17320)] = 374640,
  [SMALL_STATE(17321)] = 374660,
  [SMALL_STATE(17322)] = 374680,
  [SMALL_STATE(17323)] = 374698,
  [SMALL_STATE(17324)] = 374718,
  [SMALL_STATE(17325)] = 374738,
  [SMALL_STATE(17326)] = 374756,
  [SMALL_STATE(17327)] = 374774,
  [SMALL_STATE(17328)] = 374794,
  [SMALL_STATE(17329)] = 374810,
  [SMALL_STATE(17330)] = 374830,
  [SMALL_STATE(17331)] = 374850,
  [SMALL_STATE(17332)] = 374870,
  [SMALL_STATE(17333)] = 374890,
  [SMALL_STATE(17334)] = 374910,
  [SMALL_STATE(17335)] = 374930,
  [SMALL_STATE(17336)] = 374946,
  [SMALL_STATE(17337)] = 374966,
  [SMALL_STATE(17338)] = 374986,
  [SMALL_STATE(17339)] = 375006,
  [SMALL_STATE(17340)] = 375026,
  [SMALL_STATE(17341)] = 375046,
  [SMALL_STATE(17342)] = 375066,
  [SMALL_STATE(17343)] = 375086,
  [SMALL_STATE(17344)] = 375106,
  [SMALL_STATE(17345)] = 375126,
  [SMALL_STATE(17346)] = 375146,
  [SMALL_STATE(17347)] = 375166,
  [SMALL_STATE(17348)] = 375186,
  [SMALL_STATE(17349)] = 375206,
  [SMALL_STATE(17350)] = 375226,
  [SMALL_STATE(17351)] = 375246,
  [SMALL_STATE(17352)] = 375266,
  [SMALL_STATE(17353)] = 375286,
  [SMALL_STATE(17354)] = 375306,
  [SMALL_STATE(17355)] = 375326,
  [SMALL_STATE(17356)] = 375344,
  [SMALL_STATE(17357)] = 375362,
  [SMALL_STATE(17358)] = 375382,
  [SMALL_STATE(17359)] = 375400,
  [SMALL_STATE(17360)] = 375420,
  [SMALL_STATE(17361)] = 375440,
  [SMALL_STATE(17362)] = 375460,
  [SMALL_STATE(17363)] = 375480,
  [SMALL_STATE(17364)] = 375498,
  [SMALL_STATE(17365)] = 375518,
  [SMALL_STATE(17366)] = 375538,
  [SMALL_STATE(17367)] = 375558,
  [SMALL_STATE(17368)] = 375578,
  [SMALL_STATE(17369)] = 375598,
  [SMALL_STATE(17370)] = 375618,
  [SMALL_STATE(17371)] = 375638,
  [SMALL_STATE(17372)] = 375656,
  [SMALL_STATE(17373)] = 375672,
  [SMALL_STATE(17374)] = 375692,
  [SMALL_STATE(17375)] = 375712,
  [SMALL_STATE(17376)] = 375732,
  [SMALL_STATE(17377)] = 375752,
  [SMALL_STATE(17378)] = 375770,
  [SMALL_STATE(17379)] = 375790,
  [SMALL_STATE(17380)] = 375810,
  [SMALL_STATE(17381)] = 375830,
  [SMALL_STATE(17382)] = 375850,
  [SMALL_STATE(17383)] = 375870,
  [SMALL_STATE(17384)] = 375890,
  [SMALL_STATE(17385)] = 375910,
  [SMALL_STATE(17386)] = 375930,
  [SMALL_STATE(17387)] = 375950,
  [SMALL_STATE(17388)] = 375970,
  [SMALL_STATE(17389)] = 375988,
  [SMALL_STATE(17390)] = 376008,
  [SMALL_STATE(17391)] = 376028,
  [SMALL_STATE(17392)] = 376048,
  [SMALL_STATE(17393)] = 376068,
  [SMALL_STATE(17394)] = 376088,
  [SMALL_STATE(17395)] = 376108,
  [SMALL_STATE(17396)] = 376128,
  [SMALL_STATE(17397)] = 376146,
  [SMALL_STATE(17398)] = 376166,
  [SMALL_STATE(17399)] = 376184,
  [SMALL_STATE(17400)] = 376204,
  [SMALL_STATE(17401)] = 376224,
  [SMALL_STATE(17402)] = 376244,
  [SMALL_STATE(17403)] = 376264,
  [SMALL_STATE(17404)] = 376284,
  [SMALL_STATE(17405)] = 376304,
  [SMALL_STATE(17406)] = 376324,
  [SMALL_STATE(17407)] = 376344,
  [SMALL_STATE(17408)] = 376364,
  [SMALL_STATE(17409)] = 376384,
  [SMALL_STATE(17410)] = 376402,
  [SMALL_STATE(17411)] = 376422,
  [SMALL_STATE(17412)] = 376442,
  [SMALL_STATE(17413)] = 376462,
  [SMALL_STATE(17414)] = 376478,
  [SMALL_STATE(17415)] = 376498,
  [SMALL_STATE(17416)] = 376518,
  [SMALL_STATE(17417)] = 376536,
  [SMALL_STATE(17418)] = 376556,
  [SMALL_STATE(17419)] = 376576,
  [SMALL_STATE(17420)] = 376596,
  [SMALL_STATE(17421)] = 376616,
  [SMALL_STATE(17422)] = 376636,
  [SMALL_STATE(17423)] = 376656,
  [SMALL_STATE(17424)] = 376676,
  [SMALL_STATE(17425)] = 376696,
  [SMALL_STATE(17426)] = 376714,
  [SMALL_STATE(17427)] = 376734,
  [SMALL_STATE(17428)] = 376754,
  [SMALL_STATE(17429)] = 376774,
  [SMALL_STATE(17430)] = 376792,
  [SMALL_STATE(17431)] = 376812,
  [SMALL_STATE(17432)] = 376832,
  [SMALL_STATE(17433)] = 376852,
  [SMALL_STATE(17434)] = 376872,
  [SMALL_STATE(17435)] = 376892,
  [SMALL_STATE(17436)] = 376910,
  [SMALL_STATE(17437)] = 376930,
  [SMALL_STATE(17438)] = 376950,
  [SMALL_STATE(17439)] = 376970,
  [SMALL_STATE(17440)] = 376988,
  [SMALL_STATE(17441)] = 377008,
  [SMALL_STATE(17442)] = 377028,
  [SMALL_STATE(17443)] = 377048,
  [SMALL_STATE(17444)] = 377068,
  [SMALL_STATE(17445)] = 377086,
  [SMALL_STATE(17446)] = 377106,
  [SMALL_STATE(17447)] = 377126,
  [SMALL_STATE(17448)] = 377146,
  [SMALL_STATE(17449)] = 377166,
  [SMALL_STATE(17450)] = 377186,
  [SMALL_STATE(17451)] = 377206,
  [SMALL_STATE(17452)] = 377226,
  [SMALL_STATE(17453)] = 377246,
  [SMALL_STATE(17454)] = 377264,
  [SMALL_STATE(17455)] = 377284,
  [SMALL_STATE(17456)] = 377304,
  [SMALL_STATE(17457)] = 377324,
  [SMALL_STATE(17458)] = 377344,
  [SMALL_STATE(17459)] = 377364,
  [SMALL_STATE(17460)] = 377384,
  [SMALL_STATE(17461)] = 377402,
  [SMALL_STATE(17462)] = 377422,
  [SMALL_STATE(17463)] = 377442,
  [SMALL_STATE(17464)] = 377462,
  [SMALL_STATE(17465)] = 377482,
  [SMALL_STATE(17466)] = 377502,
  [SMALL_STATE(17467)] = 377522,
  [SMALL_STATE(17468)] = 377542,
  [SMALL_STATE(17469)] = 377560,
  [SMALL_STATE(17470)] = 377580,
  [SMALL_STATE(17471)] = 377600,
  [SMALL_STATE(17472)] = 377620,
  [SMALL_STATE(17473)] = 377640,
  [SMALL_STATE(17474)] = 377660,
  [SMALL_STATE(17475)] = 377680,
  [SMALL_STATE(17476)] = 377700,
  [SMALL_STATE(17477)] = 377720,
  [SMALL_STATE(17478)] = 377740,
  [SMALL_STATE(17479)] = 377758,
  [SMALL_STATE(17480)] = 377778,
  [SMALL_STATE(17481)] = 377798,
  [SMALL_STATE(17482)] = 377818,
  [SMALL_STATE(17483)] = 377838,
  [SMALL_STATE(17484)] = 377858,
  [SMALL_STATE(17485)] = 377878,
  [SMALL_STATE(17486)] = 377896,
  [SMALL_STATE(17487)] = 377916,
  [SMALL_STATE(17488)] = 377936,
  [SMALL_STATE(17489)] = 377956,
  [SMALL_STATE(17490)] = 377976,
  [SMALL_STATE(17491)] = 377992,
  [SMALL_STATE(17492)] = 378012,
  [SMALL_STATE(17493)] = 378032,
  [SMALL_STATE(17494)] = 378052,
  [SMALL_STATE(17495)] = 378068,
  [SMALL_STATE(17496)] = 378088,
  [SMALL_STATE(17497)] = 378108,
  [SMALL_STATE(17498)] = 378128,
  [SMALL_STATE(17499)] = 378148,
  [SMALL_STATE(17500)] = 378168,
  [SMALL_STATE(17501)] = 378186,
  [SMALL_STATE(17502)] = 378206,
  [SMALL_STATE(17503)] = 378226,
  [SMALL_STATE(17504)] = 378246,
  [SMALL_STATE(17505)] = 378266,
  [SMALL_STATE(17506)] = 378286,
  [SMALL_STATE(17507)] = 378306,
  [SMALL_STATE(17508)] = 378326,
  [SMALL_STATE(17509)] = 378346,
  [SMALL_STATE(17510)] = 378366,
  [SMALL_STATE(17511)] = 378386,
  [SMALL_STATE(17512)] = 378406,
  [SMALL_STATE(17513)] = 378426,
  [SMALL_STATE(17514)] = 378444,
  [SMALL_STATE(17515)] = 378464,
  [SMALL_STATE(17516)] = 378484,
  [SMALL_STATE(17517)] = 378504,
  [SMALL_STATE(17518)] = 378522,
  [SMALL_STATE(17519)] = 378542,
  [SMALL_STATE(17520)] = 378562,
  [SMALL_STATE(17521)] = 378582,
  [SMALL_STATE(17522)] = 378602,
  [SMALL_STATE(17523)] = 378622,
  [SMALL_STATE(17524)] = 378642,
  [SMALL_STATE(17525)] = 378662,
  [SMALL_STATE(17526)] = 378680,
  [SMALL_STATE(17527)] = 378700,
  [SMALL_STATE(17528)] = 378720,
  [SMALL_STATE(17529)] = 378738,
  [SMALL_STATE(17530)] = 378758,
  [SMALL_STATE(17531)] = 378778,
  [SMALL_STATE(17532)] = 378798,
  [SMALL_STATE(17533)] = 378818,
  [SMALL_STATE(17534)] = 378838,
  [SMALL_STATE(17535)] = 378858,
  [SMALL_STATE(17536)] = 378878,
  [SMALL_STATE(17537)] = 378898,
  [SMALL_STATE(17538)] = 378918,
  [SMALL_STATE(17539)] = 378938,
  [SMALL_STATE(17540)] = 378958,
  [SMALL_STATE(17541)] = 378978,
  [SMALL_STATE(17542)] = 378998,
  [SMALL_STATE(17543)] = 379018,
  [SMALL_STATE(17544)] = 379038,
  [SMALL_STATE(17545)] = 379058,
  [SMALL_STATE(17546)] = 379078,
  [SMALL_STATE(17547)] = 379098,
  [SMALL_STATE(17548)] = 379118,
  [SMALL_STATE(17549)] = 379138,
  [SMALL_STATE(17550)] = 379156,
  [SMALL_STATE(17551)] = 379174,
  [SMALL_STATE(17552)] = 379194,
  [SMALL_STATE(17553)] = 379214,
  [SMALL_STATE(17554)] = 379234,
  [SMALL_STATE(17555)] = 379252,
  [SMALL_STATE(17556)] = 379270,
  [SMALL_STATE(17557)] = 379290,
  [SMALL_STATE(17558)] = 379310,
  [SMALL_STATE(17559)] = 379330,
  [SMALL_STATE(17560)] = 379348,
  [SMALL_STATE(17561)] = 379368,
  [SMALL_STATE(17562)] = 379388,
  [SMALL_STATE(17563)] = 379404,
  [SMALL_STATE(17564)] = 379422,
  [SMALL_STATE(17565)] = 379440,
  [SMALL_STATE(17566)] = 379460,
  [SMALL_STATE(17567)] = 379480,
  [SMALL_STATE(17568)] = 379498,
  [SMALL_STATE(17569)] = 379518,
  [SMALL_STATE(17570)] = 379538,
  [SMALL_STATE(17571)] = 379558,
  [SMALL_STATE(17572)] = 379578,
  [SMALL_STATE(17573)] = 379596,
  [SMALL_STATE(17574)] = 379616,
  [SMALL_STATE(17575)] = 379636,
  [SMALL_STATE(17576)] = 379656,
  [SMALL_STATE(17577)] = 379676,
  [SMALL_STATE(17578)] = 379694,
  [SMALL_STATE(17579)] = 379714,
  [SMALL_STATE(17580)] = 379734,
  [SMALL_STATE(17581)] = 379752,
  [SMALL_STATE(17582)] = 379770,
  [SMALL_STATE(17583)] = 379790,
  [SMALL_STATE(17584)] = 379810,
  [SMALL_STATE(17585)] = 379830,
  [SMALL_STATE(17586)] = 379850,
  [SMALL_STATE(17587)] = 379868,
  [SMALL_STATE(17588)] = 379888,
  [SMALL_STATE(17589)] = 379908,
  [SMALL_STATE(17590)] = 379928,
  [SMALL_STATE(17591)] = 379948,
  [SMALL_STATE(17592)] = 379966,
  [SMALL_STATE(17593)] = 379984,
  [SMALL_STATE(17594)] = 380004,
  [SMALL_STATE(17595)] = 380022,
  [SMALL_STATE(17596)] = 380042,
  [SMALL_STATE(17597)] = 380062,
  [SMALL_STATE(17598)] = 380082,
  [SMALL_STATE(17599)] = 380102,
  [SMALL_STATE(17600)] = 380122,
  [SMALL_STATE(17601)] = 380142,
  [SMALL_STATE(17602)] = 380162,
  [SMALL_STATE(17603)] = 380182,
  [SMALL_STATE(17604)] = 380202,
  [SMALL_STATE(17605)] = 380222,
  [SMALL_STATE(17606)] = 380240,
  [SMALL_STATE(17607)] = 380260,
  [SMALL_STATE(17608)] = 380280,
  [SMALL_STATE(17609)] = 380298,
  [SMALL_STATE(17610)] = 380318,
  [SMALL_STATE(17611)] = 380338,
  [SMALL_STATE(17612)] = 380358,
  [SMALL_STATE(17613)] = 380374,
  [SMALL_STATE(17614)] = 380394,
  [SMALL_STATE(17615)] = 380414,
  [SMALL_STATE(17616)] = 380434,
  [SMALL_STATE(17617)] = 380454,
  [SMALL_STATE(17618)] = 380474,
  [SMALL_STATE(17619)] = 380494,
  [SMALL_STATE(17620)] = 380514,
  [SMALL_STATE(17621)] = 380534,
  [SMALL_STATE(17622)] = 380554,
  [SMALL_STATE(17623)] = 380574,
  [SMALL_STATE(17624)] = 380592,
  [SMALL_STATE(17625)] = 380610,
  [SMALL_STATE(17626)] = 380630,
  [SMALL_STATE(17627)] = 380650,
  [SMALL_STATE(17628)] = 380670,
  [SMALL_STATE(17629)] = 380688,
  [SMALL_STATE(17630)] = 380708,
  [SMALL_STATE(17631)] = 380728,
  [SMALL_STATE(17632)] = 380748,
  [SMALL_STATE(17633)] = 380768,
  [SMALL_STATE(17634)] = 380788,
  [SMALL_STATE(17635)] = 380806,
  [SMALL_STATE(17636)] = 380824,
  [SMALL_STATE(17637)] = 380844,
  [SMALL_STATE(17638)] = 380864,
  [SMALL_STATE(17639)] = 380884,
  [SMALL_STATE(17640)] = 380904,
  [SMALL_STATE(17641)] = 380924,
  [SMALL_STATE(17642)] = 380944,
  [SMALL_STATE(17643)] = 380964,
  [SMALL_STATE(17644)] = 380984,
  [SMALL_STATE(17645)] = 381004,
  [SMALL_STATE(17646)] = 381022,
  [SMALL_STATE(17647)] = 381042,
  [SMALL_STATE(17648)] = 381062,
  [SMALL_STATE(17649)] = 381082,
  [SMALL_STATE(17650)] = 381102,
  [SMALL_STATE(17651)] = 381122,
  [SMALL_STATE(17652)] = 381142,
  [SMALL_STATE(17653)] = 381162,
  [SMALL_STATE(17654)] = 381180,
  [SMALL_STATE(17655)] = 381200,
  [SMALL_STATE(17656)] = 381220,
  [SMALL_STATE(17657)] = 381240,
  [SMALL_STATE(17658)] = 381260,
  [SMALL_STATE(17659)] = 381278,
  [SMALL_STATE(17660)] = 381296,
  [SMALL_STATE(17661)] = 381316,
  [SMALL_STATE(17662)] = 381336,
  [SMALL_STATE(17663)] = 381356,
  [SMALL_STATE(17664)] = 381376,
  [SMALL_STATE(17665)] = 381392,
  [SMALL_STATE(17666)] = 381412,
  [SMALL_STATE(17667)] = 381432,
  [SMALL_STATE(17668)] = 381452,
  [SMALL_STATE(17669)] = 381470,
  [SMALL_STATE(17670)] = 381488,
  [SMALL_STATE(17671)] = 381506,
  [SMALL_STATE(17672)] = 381524,
  [SMALL_STATE(17673)] = 381540,
  [SMALL_STATE(17674)] = 381557,
  [SMALL_STATE(17675)] = 381574,
  [SMALL_STATE(17676)] = 381591,
  [SMALL_STATE(17677)] = 381608,
  [SMALL_STATE(17678)] = 381625,
  [SMALL_STATE(17679)] = 381640,
  [SMALL_STATE(17680)] = 381657,
  [SMALL_STATE(17681)] = 381674,
  [SMALL_STATE(17682)] = 381691,
  [SMALL_STATE(17683)] = 381706,
  [SMALL_STATE(17684)] = 381723,
  [SMALL_STATE(17685)] = 381740,
  [SMALL_STATE(17686)] = 381757,
  [SMALL_STATE(17687)] = 381774,
  [SMALL_STATE(17688)] = 381791,
  [SMALL_STATE(17689)] = 381808,
  [SMALL_STATE(17690)] = 381823,
  [SMALL_STATE(17691)] = 381840,
  [SMALL_STATE(17692)] = 381857,
  [SMALL_STATE(17693)] = 381874,
  [SMALL_STATE(17694)] = 381891,
  [SMALL_STATE(17695)] = 381908,
  [SMALL_STATE(17696)] = 381925,
  [SMALL_STATE(17697)] = 381942,
  [SMALL_STATE(17698)] = 381959,
  [SMALL_STATE(17699)] = 381974,
  [SMALL_STATE(17700)] = 381991,
  [SMALL_STATE(17701)] = 382008,
  [SMALL_STATE(17702)] = 382025,
  [SMALL_STATE(17703)] = 382042,
  [SMALL_STATE(17704)] = 382059,
  [SMALL_STATE(17705)] = 382076,
  [SMALL_STATE(17706)] = 382093,
  [SMALL_STATE(17707)] = 382110,
  [SMALL_STATE(17708)] = 382125,
  [SMALL_STATE(17709)] = 382142,
  [SMALL_STATE(17710)] = 382159,
  [SMALL_STATE(17711)] = 382176,
  [SMALL_STATE(17712)] = 382193,
  [SMALL_STATE(17713)] = 382210,
  [SMALL_STATE(17714)] = 382227,
  [SMALL_STATE(17715)] = 382244,
  [SMALL_STATE(17716)] = 382261,
  [SMALL_STATE(17717)] = 382278,
  [SMALL_STATE(17718)] = 382295,
  [SMALL_STATE(17719)] = 382312,
  [SMALL_STATE(17720)] = 382327,
  [SMALL_STATE(17721)] = 382344,
  [SMALL_STATE(17722)] = 382361,
  [SMALL_STATE(17723)] = 382378,
  [SMALL_STATE(17724)] = 382393,
  [SMALL_STATE(17725)] = 382410,
  [SMALL_STATE(17726)] = 382427,
  [SMALL_STATE(17727)] = 382444,
  [SMALL_STATE(17728)] = 382459,
  [SMALL_STATE(17729)] = 382474,
  [SMALL_STATE(17730)] = 382491,
  [SMALL_STATE(17731)] = 382508,
  [SMALL_STATE(17732)] = 382525,
  [SMALL_STATE(17733)] = 382542,
  [SMALL_STATE(17734)] = 382559,
  [SMALL_STATE(17735)] = 382576,
  [SMALL_STATE(17736)] = 382593,
  [SMALL_STATE(17737)] = 382610,
  [SMALL_STATE(17738)] = 382627,
  [SMALL_STATE(17739)] = 382644,
  [SMALL_STATE(17740)] = 382661,
  [SMALL_STATE(17741)] = 382678,
  [SMALL_STATE(17742)] = 382695,
  [SMALL_STATE(17743)] = 382712,
  [SMALL_STATE(17744)] = 382729,
  [SMALL_STATE(17745)] = 382746,
  [SMALL_STATE(17746)] = 382763,
  [SMALL_STATE(17747)] = 382780,
  [SMALL_STATE(17748)] = 382797,
  [SMALL_STATE(17749)] = 382814,
  [SMALL_STATE(17750)] = 382831,
  [SMALL_STATE(17751)] = 382848,
  [SMALL_STATE(17752)] = 382865,
  [SMALL_STATE(17753)] = 382880,
  [SMALL_STATE(17754)] = 382897,
  [SMALL_STATE(17755)] = 382914,
  [SMALL_STATE(17756)] = 382931,
  [SMALL_STATE(17757)] = 382948,
  [SMALL_STATE(17758)] = 382965,
  [SMALL_STATE(17759)] = 382982,
  [SMALL_STATE(17760)] = 382999,
  [SMALL_STATE(17761)] = 383016,
  [SMALL_STATE(17762)] = 383033,
  [SMALL_STATE(17763)] = 383050,
  [SMALL_STATE(17764)] = 383067,
  [SMALL_STATE(17765)] = 383084,
  [SMALL_STATE(17766)] = 383101,
  [SMALL_STATE(17767)] = 383118,
  [SMALL_STATE(17768)] = 383135,
  [SMALL_STATE(17769)] = 383152,
  [SMALL_STATE(17770)] = 383169,
  [SMALL_STATE(17771)] = 383186,
  [SMALL_STATE(17772)] = 383203,
  [SMALL_STATE(17773)] = 383220,
  [SMALL_STATE(17774)] = 383237,
  [SMALL_STATE(17775)] = 383254,
  [SMALL_STATE(17776)] = 383271,
  [SMALL_STATE(17777)] = 383288,
  [SMALL_STATE(17778)] = 383305,
  [SMALL_STATE(17779)] = 383322,
  [SMALL_STATE(17780)] = 383339,
  [SMALL_STATE(17781)] = 383354,
  [SMALL_STATE(17782)] = 383371,
  [SMALL_STATE(17783)] = 383386,
  [SMALL_STATE(17784)] = 383403,
  [SMALL_STATE(17785)] = 383420,
  [SMALL_STATE(17786)] = 383437,
  [SMALL_STATE(17787)] = 383454,
  [SMALL_STATE(17788)] = 383471,
  [SMALL_STATE(17789)] = 383488,
  [SMALL_STATE(17790)] = 383503,
  [SMALL_STATE(17791)] = 383518,
  [SMALL_STATE(17792)] = 383535,
  [SMALL_STATE(17793)] = 383552,
  [SMALL_STATE(17794)] = 383569,
  [SMALL_STATE(17795)] = 383586,
  [SMALL_STATE(17796)] = 383603,
  [SMALL_STATE(17797)] = 383620,
  [SMALL_STATE(17798)] = 383637,
  [SMALL_STATE(17799)] = 383654,
  [SMALL_STATE(17800)] = 383671,
  [SMALL_STATE(17801)] = 383688,
  [SMALL_STATE(17802)] = 383705,
  [SMALL_STATE(17803)] = 383722,
  [SMALL_STATE(17804)] = 383739,
  [SMALL_STATE(17805)] = 383756,
  [SMALL_STATE(17806)] = 383773,
  [SMALL_STATE(17807)] = 383790,
  [SMALL_STATE(17808)] = 383807,
  [SMALL_STATE(17809)] = 383824,
  [SMALL_STATE(17810)] = 383841,
  [SMALL_STATE(17811)] = 383858,
  [SMALL_STATE(17812)] = 383875,
  [SMALL_STATE(17813)] = 383892,
  [SMALL_STATE(17814)] = 383909,
  [SMALL_STATE(17815)] = 383926,
  [SMALL_STATE(17816)] = 383943,
  [SMALL_STATE(17817)] = 383960,
  [SMALL_STATE(17818)] = 383977,
  [SMALL_STATE(17819)] = 383994,
  [SMALL_STATE(17820)] = 384011,
  [SMALL_STATE(17821)] = 384026,
  [SMALL_STATE(17822)] = 384043,
  [SMALL_STATE(17823)] = 384060,
  [SMALL_STATE(17824)] = 384077,
  [SMALL_STATE(17825)] = 384094,
  [SMALL_STATE(17826)] = 384111,
  [SMALL_STATE(17827)] = 384128,
  [SMALL_STATE(17828)] = 384145,
  [SMALL_STATE(17829)] = 384162,
  [SMALL_STATE(17830)] = 384179,
  [SMALL_STATE(17831)] = 384196,
  [SMALL_STATE(17832)] = 384213,
  [SMALL_STATE(17833)] = 384230,
  [SMALL_STATE(17834)] = 384247,
  [SMALL_STATE(17835)] = 384264,
  [SMALL_STATE(17836)] = 384281,
  [SMALL_STATE(17837)] = 384298,
  [SMALL_STATE(17838)] = 384315,
  [SMALL_STATE(17839)] = 384332,
  [SMALL_STATE(17840)] = 384349,
  [SMALL_STATE(17841)] = 384366,
  [SMALL_STATE(17842)] = 384383,
  [SMALL_STATE(17843)] = 384400,
  [SMALL_STATE(17844)] = 384417,
  [SMALL_STATE(17845)] = 384434,
  [SMALL_STATE(17846)] = 384451,
  [SMALL_STATE(17847)] = 384468,
  [SMALL_STATE(17848)] = 384485,
  [SMALL_STATE(17849)] = 384502,
  [SMALL_STATE(17850)] = 384519,
  [SMALL_STATE(17851)] = 384536,
  [SMALL_STATE(17852)] = 384553,
  [SMALL_STATE(17853)] = 384570,
  [SMALL_STATE(17854)] = 384587,
  [SMALL_STATE(17855)] = 384604,
  [SMALL_STATE(17856)] = 384621,
  [SMALL_STATE(17857)] = 384638,
  [SMALL_STATE(17858)] = 384655,
  [SMALL_STATE(17859)] = 384672,
  [SMALL_STATE(17860)] = 384689,
  [SMALL_STATE(17861)] = 384706,
  [SMALL_STATE(17862)] = 384723,
  [SMALL_STATE(17863)] = 384740,
  [SMALL_STATE(17864)] = 384757,
  [SMALL_STATE(17865)] = 384774,
  [SMALL_STATE(17866)] = 384791,
  [SMALL_STATE(17867)] = 384808,
  [SMALL_STATE(17868)] = 384825,
  [SMALL_STATE(17869)] = 384842,
  [SMALL_STATE(17870)] = 384859,
  [SMALL_STATE(17871)] = 384876,
  [SMALL_STATE(17872)] = 384893,
  [SMALL_STATE(17873)] = 384910,
  [SMALL_STATE(17874)] = 384927,
  [SMALL_STATE(17875)] = 384944,
  [SMALL_STATE(17876)] = 384961,
  [SMALL_STATE(17877)] = 384978,
  [SMALL_STATE(17878)] = 384995,
  [SMALL_STATE(17879)] = 385012,
  [SMALL_STATE(17880)] = 385029,
  [SMALL_STATE(17881)] = 385046,
  [SMALL_STATE(17882)] = 385063,
  [SMALL_STATE(17883)] = 385080,
  [SMALL_STATE(17884)] = 385097,
  [SMALL_STATE(17885)] = 385114,
  [SMALL_STATE(17886)] = 385131,
  [SMALL_STATE(17887)] = 385148,
  [SMALL_STATE(17888)] = 385165,
  [SMALL_STATE(17889)] = 385182,
  [SMALL_STATE(17890)] = 385199,
  [SMALL_STATE(17891)] = 385216,
  [SMALL_STATE(17892)] = 385233,
  [SMALL_STATE(17893)] = 385250,
  [SMALL_STATE(17894)] = 385267,
  [SMALL_STATE(17895)] = 385284,
  [SMALL_STATE(17896)] = 385301,
  [SMALL_STATE(17897)] = 385318,
  [SMALL_STATE(17898)] = 385335,
  [SMALL_STATE(17899)] = 385352,
  [SMALL_STATE(17900)] = 385369,
  [SMALL_STATE(17901)] = 385386,
  [SMALL_STATE(17902)] = 385401,
  [SMALL_STATE(17903)] = 385418,
  [SMALL_STATE(17904)] = 385435,
  [SMALL_STATE(17905)] = 385452,
  [SMALL_STATE(17906)] = 385467,
  [SMALL_STATE(17907)] = 385484,
  [SMALL_STATE(17908)] = 385501,
  [SMALL_STATE(17909)] = 385518,
  [SMALL_STATE(17910)] = 385533,
  [SMALL_STATE(17911)] = 385550,
  [SMALL_STATE(17912)] = 385567,
  [SMALL_STATE(17913)] = 385584,
  [SMALL_STATE(17914)] = 385601,
  [SMALL_STATE(17915)] = 385618,
  [SMALL_STATE(17916)] = 385635,
  [SMALL_STATE(17917)] = 385652,
  [SMALL_STATE(17918)] = 385669,
  [SMALL_STATE(17919)] = 385686,
  [SMALL_STATE(17920)] = 385703,
  [SMALL_STATE(17921)] = 385720,
  [SMALL_STATE(17922)] = 385737,
  [SMALL_STATE(17923)] = 385754,
  [SMALL_STATE(17924)] = 385771,
  [SMALL_STATE(17925)] = 385788,
  [SMALL_STATE(17926)] = 385805,
  [SMALL_STATE(17927)] = 385822,
  [SMALL_STATE(17928)] = 385839,
  [SMALL_STATE(17929)] = 385856,
  [SMALL_STATE(17930)] = 385873,
  [SMALL_STATE(17931)] = 385890,
  [SMALL_STATE(17932)] = 385907,
  [SMALL_STATE(17933)] = 385924,
  [SMALL_STATE(17934)] = 385941,
  [SMALL_STATE(17935)] = 385958,
  [SMALL_STATE(17936)] = 385975,
  [SMALL_STATE(17937)] = 385992,
  [SMALL_STATE(17938)] = 386009,
  [SMALL_STATE(17939)] = 386026,
  [SMALL_STATE(17940)] = 386043,
  [SMALL_STATE(17941)] = 386060,
  [SMALL_STATE(17942)] = 386077,
  [SMALL_STATE(17943)] = 386094,
  [SMALL_STATE(17944)] = 386111,
  [SMALL_STATE(17945)] = 386128,
  [SMALL_STATE(17946)] = 386145,
  [SMALL_STATE(17947)] = 386162,
  [SMALL_STATE(17948)] = 386179,
  [SMALL_STATE(17949)] = 386196,
  [SMALL_STATE(17950)] = 386213,
  [SMALL_STATE(17951)] = 386230,
  [SMALL_STATE(17952)] = 386247,
  [SMALL_STATE(17953)] = 386264,
  [SMALL_STATE(17954)] = 386281,
  [SMALL_STATE(17955)] = 386298,
  [SMALL_STATE(17956)] = 386315,
  [SMALL_STATE(17957)] = 386332,
  [SMALL_STATE(17958)] = 386347,
  [SMALL_STATE(17959)] = 386364,
  [SMALL_STATE(17960)] = 386381,
  [SMALL_STATE(17961)] = 386398,
  [SMALL_STATE(17962)] = 386415,
  [SMALL_STATE(17963)] = 386432,
  [SMALL_STATE(17964)] = 386447,
  [SMALL_STATE(17965)] = 386464,
  [SMALL_STATE(17966)] = 386481,
  [SMALL_STATE(17967)] = 386498,
  [SMALL_STATE(17968)] = 386515,
  [SMALL_STATE(17969)] = 386532,
  [SMALL_STATE(17970)] = 386549,
  [SMALL_STATE(17971)] = 386566,
  [SMALL_STATE(17972)] = 386583,
  [SMALL_STATE(17973)] = 386600,
  [SMALL_STATE(17974)] = 386617,
  [SMALL_STATE(17975)] = 386634,
  [SMALL_STATE(17976)] = 386651,
  [SMALL_STATE(17977)] = 386668,
  [SMALL_STATE(17978)] = 386685,
  [SMALL_STATE(17979)] = 386700,
  [SMALL_STATE(17980)] = 386717,
  [SMALL_STATE(17981)] = 386734,
  [SMALL_STATE(17982)] = 386751,
  [SMALL_STATE(17983)] = 386768,
  [SMALL_STATE(17984)] = 386785,
  [SMALL_STATE(17985)] = 386802,
  [SMALL_STATE(17986)] = 386819,
  [SMALL_STATE(17987)] = 386836,
  [SMALL_STATE(17988)] = 386851,
  [SMALL_STATE(17989)] = 386868,
  [SMALL_STATE(17990)] = 386885,
  [SMALL_STATE(17991)] = 386902,
  [SMALL_STATE(17992)] = 386919,
  [SMALL_STATE(17993)] = 386936,
  [SMALL_STATE(17994)] = 386953,
  [SMALL_STATE(17995)] = 386970,
  [SMALL_STATE(17996)] = 386987,
  [SMALL_STATE(17997)] = 387004,
  [SMALL_STATE(17998)] = 387021,
  [SMALL_STATE(17999)] = 387036,
  [SMALL_STATE(18000)] = 387051,
  [SMALL_STATE(18001)] = 387068,
  [SMALL_STATE(18002)] = 387085,
  [SMALL_STATE(18003)] = 387102,
  [SMALL_STATE(18004)] = 387119,
  [SMALL_STATE(18005)] = 387136,
  [SMALL_STATE(18006)] = 387153,
  [SMALL_STATE(18007)] = 387170,
  [SMALL_STATE(18008)] = 387185,
  [SMALL_STATE(18009)] = 387202,
  [SMALL_STATE(18010)] = 387219,
  [SMALL_STATE(18011)] = 387236,
  [SMALL_STATE(18012)] = 387253,
  [SMALL_STATE(18013)] = 387270,
  [SMALL_STATE(18014)] = 387287,
  [SMALL_STATE(18015)] = 387302,
  [SMALL_STATE(18016)] = 387317,
  [SMALL_STATE(18017)] = 387334,
  [SMALL_STATE(18018)] = 387351,
  [SMALL_STATE(18019)] = 387368,
  [SMALL_STATE(18020)] = 387385,
  [SMALL_STATE(18021)] = 387402,
  [SMALL_STATE(18022)] = 387417,
  [SMALL_STATE(18023)] = 387434,
  [SMALL_STATE(18024)] = 387451,
  [SMALL_STATE(18025)] = 387466,
  [SMALL_STATE(18026)] = 387483,
  [SMALL_STATE(18027)] = 387500,
  [SMALL_STATE(18028)] = 387517,
  [SMALL_STATE(18029)] = 387532,
  [SMALL_STATE(18030)] = 387549,
  [SMALL_STATE(18031)] = 387566,
  [SMALL_STATE(18032)] = 387583,
  [SMALL_STATE(18033)] = 387600,
  [SMALL_STATE(18034)] = 387617,
  [SMALL_STATE(18035)] = 387634,
  [SMALL_STATE(18036)] = 387651,
  [SMALL_STATE(18037)] = 387668,
  [SMALL_STATE(18038)] = 387685,
  [SMALL_STATE(18039)] = 387702,
  [SMALL_STATE(18040)] = 387719,
  [SMALL_STATE(18041)] = 387736,
  [SMALL_STATE(18042)] = 387753,
  [SMALL_STATE(18043)] = 387768,
  [SMALL_STATE(18044)] = 387785,
  [SMALL_STATE(18045)] = 387802,
  [SMALL_STATE(18046)] = 387819,
  [SMALL_STATE(18047)] = 387834,
  [SMALL_STATE(18048)] = 387851,
  [SMALL_STATE(18049)] = 387866,
  [SMALL_STATE(18050)] = 387883,
  [SMALL_STATE(18051)] = 387900,
  [SMALL_STATE(18052)] = 387917,
  [SMALL_STATE(18053)] = 387934,
  [SMALL_STATE(18054)] = 387951,
  [SMALL_STATE(18055)] = 387966,
  [SMALL_STATE(18056)] = 387983,
  [SMALL_STATE(18057)] = 388000,
  [SMALL_STATE(18058)] = 388017,
  [SMALL_STATE(18059)] = 388034,
  [SMALL_STATE(18060)] = 388051,
  [SMALL_STATE(18061)] = 388068,
  [SMALL_STATE(18062)] = 388085,
  [SMALL_STATE(18063)] = 388102,
  [SMALL_STATE(18064)] = 388119,
  [SMALL_STATE(18065)] = 388136,
  [SMALL_STATE(18066)] = 388153,
  [SMALL_STATE(18067)] = 388170,
  [SMALL_STATE(18068)] = 388187,
  [SMALL_STATE(18069)] = 388204,
  [SMALL_STATE(18070)] = 388221,
  [SMALL_STATE(18071)] = 388238,
  [SMALL_STATE(18072)] = 388255,
  [SMALL_STATE(18073)] = 388270,
  [SMALL_STATE(18074)] = 388287,
  [SMALL_STATE(18075)] = 388304,
  [SMALL_STATE(18076)] = 388319,
  [SMALL_STATE(18077)] = 388336,
  [SMALL_STATE(18078)] = 388353,
  [SMALL_STATE(18079)] = 388370,
  [SMALL_STATE(18080)] = 388387,
  [SMALL_STATE(18081)] = 388404,
  [SMALL_STATE(18082)] = 388419,
  [SMALL_STATE(18083)] = 388436,
  [SMALL_STATE(18084)] = 388453,
  [SMALL_STATE(18085)] = 388470,
  [SMALL_STATE(18086)] = 388487,
  [SMALL_STATE(18087)] = 388504,
  [SMALL_STATE(18088)] = 388521,
  [SMALL_STATE(18089)] = 388538,
  [SMALL_STATE(18090)] = 388555,
  [SMALL_STATE(18091)] = 388572,
  [SMALL_STATE(18092)] = 388589,
  [SMALL_STATE(18093)] = 388606,
  [SMALL_STATE(18094)] = 388623,
  [SMALL_STATE(18095)] = 388640,
  [SMALL_STATE(18096)] = 388657,
  [SMALL_STATE(18097)] = 388672,
  [SMALL_STATE(18098)] = 388689,
  [SMALL_STATE(18099)] = 388706,
  [SMALL_STATE(18100)] = 388723,
  [SMALL_STATE(18101)] = 388740,
  [SMALL_STATE(18102)] = 388757,
  [SMALL_STATE(18103)] = 388772,
  [SMALL_STATE(18104)] = 388789,
  [SMALL_STATE(18105)] = 388806,
  [SMALL_STATE(18106)] = 388823,
  [SMALL_STATE(18107)] = 388840,
  [SMALL_STATE(18108)] = 388857,
  [SMALL_STATE(18109)] = 388874,
  [SMALL_STATE(18110)] = 388891,
  [SMALL_STATE(18111)] = 388908,
  [SMALL_STATE(18112)] = 388925,
  [SMALL_STATE(18113)] = 388940,
  [SMALL_STATE(18114)] = 388957,
  [SMALL_STATE(18115)] = 388974,
  [SMALL_STATE(18116)] = 388991,
  [SMALL_STATE(18117)] = 389008,
  [SMALL_STATE(18118)] = 389025,
  [SMALL_STATE(18119)] = 389042,
  [SMALL_STATE(18120)] = 389059,
  [SMALL_STATE(18121)] = 389076,
  [SMALL_STATE(18122)] = 389093,
  [SMALL_STATE(18123)] = 389110,
  [SMALL_STATE(18124)] = 389127,
  [SMALL_STATE(18125)] = 389144,
  [SMALL_STATE(18126)] = 389161,
  [SMALL_STATE(18127)] = 389178,
  [SMALL_STATE(18128)] = 389195,
  [SMALL_STATE(18129)] = 389212,
  [SMALL_STATE(18130)] = 389229,
  [SMALL_STATE(18131)] = 389246,
  [SMALL_STATE(18132)] = 389263,
  [SMALL_STATE(18133)] = 389280,
  [SMALL_STATE(18134)] = 389297,
  [SMALL_STATE(18135)] = 389314,
  [SMALL_STATE(18136)] = 389331,
  [SMALL_STATE(18137)] = 389348,
  [SMALL_STATE(18138)] = 389365,
  [SMALL_STATE(18139)] = 389380,
  [SMALL_STATE(18140)] = 389397,
  [SMALL_STATE(18141)] = 389414,
  [SMALL_STATE(18142)] = 389431,
  [SMALL_STATE(18143)] = 389448,
  [SMALL_STATE(18144)] = 389465,
  [SMALL_STATE(18145)] = 389482,
  [SMALL_STATE(18146)] = 389499,
  [SMALL_STATE(18147)] = 389516,
  [SMALL_STATE(18148)] = 389533,
  [SMALL_STATE(18149)] = 389550,
  [SMALL_STATE(18150)] = 389567,
  [SMALL_STATE(18151)] = 389582,
  [SMALL_STATE(18152)] = 389599,
  [SMALL_STATE(18153)] = 389616,
  [SMALL_STATE(18154)] = 389633,
  [SMALL_STATE(18155)] = 389650,
  [SMALL_STATE(18156)] = 389667,
  [SMALL_STATE(18157)] = 389684,
  [SMALL_STATE(18158)] = 389701,
  [SMALL_STATE(18159)] = 389718,
  [SMALL_STATE(18160)] = 389733,
  [SMALL_STATE(18161)] = 389750,
  [SMALL_STATE(18162)] = 389767,
  [SMALL_STATE(18163)] = 389784,
  [SMALL_STATE(18164)] = 389799,
  [SMALL_STATE(18165)] = 389816,
  [SMALL_STATE(18166)] = 389831,
  [SMALL_STATE(18167)] = 389848,
  [SMALL_STATE(18168)] = 389865,
  [SMALL_STATE(18169)] = 389882,
  [SMALL_STATE(18170)] = 389899,
  [SMALL_STATE(18171)] = 389914,
  [SMALL_STATE(18172)] = 389931,
  [SMALL_STATE(18173)] = 389948,
  [SMALL_STATE(18174)] = 389965,
  [SMALL_STATE(18175)] = 389982,
  [SMALL_STATE(18176)] = 389999,
  [SMALL_STATE(18177)] = 390016,
  [SMALL_STATE(18178)] = 390033,
  [SMALL_STATE(18179)] = 390050,
  [SMALL_STATE(18180)] = 390067,
  [SMALL_STATE(18181)] = 390084,
  [SMALL_STATE(18182)] = 390101,
  [SMALL_STATE(18183)] = 390118,
  [SMALL_STATE(18184)] = 390135,
  [SMALL_STATE(18185)] = 390152,
  [SMALL_STATE(18186)] = 390169,
  [SMALL_STATE(18187)] = 390186,
  [SMALL_STATE(18188)] = 390203,
  [SMALL_STATE(18189)] = 390218,
  [SMALL_STATE(18190)] = 390235,
  [SMALL_STATE(18191)] = 390252,
  [SMALL_STATE(18192)] = 390269,
  [SMALL_STATE(18193)] = 390286,
  [SMALL_STATE(18194)] = 390303,
  [SMALL_STATE(18195)] = 390320,
  [SMALL_STATE(18196)] = 390337,
  [SMALL_STATE(18197)] = 390354,
  [SMALL_STATE(18198)] = 390371,
  [SMALL_STATE(18199)] = 390388,
  [SMALL_STATE(18200)] = 390405,
  [SMALL_STATE(18201)] = 390422,
  [SMALL_STATE(18202)] = 390439,
  [SMALL_STATE(18203)] = 390456,
  [SMALL_STATE(18204)] = 390473,
  [SMALL_STATE(18205)] = 390490,
  [SMALL_STATE(18206)] = 390507,
  [SMALL_STATE(18207)] = 390524,
  [SMALL_STATE(18208)] = 390541,
  [SMALL_STATE(18209)] = 390558,
  [SMALL_STATE(18210)] = 390575,
  [SMALL_STATE(18211)] = 390592,
  [SMALL_STATE(18212)] = 390609,
  [SMALL_STATE(18213)] = 390626,
  [SMALL_STATE(18214)] = 390641,
  [SMALL_STATE(18215)] = 390658,
  [SMALL_STATE(18216)] = 390675,
  [SMALL_STATE(18217)] = 390692,
  [SMALL_STATE(18218)] = 390709,
  [SMALL_STATE(18219)] = 390726,
  [SMALL_STATE(18220)] = 390743,
  [SMALL_STATE(18221)] = 390760,
  [SMALL_STATE(18222)] = 390777,
  [SMALL_STATE(18223)] = 390794,
  [SMALL_STATE(18224)] = 390811,
  [SMALL_STATE(18225)] = 390828,
  [SMALL_STATE(18226)] = 390845,
  [SMALL_STATE(18227)] = 390862,
  [SMALL_STATE(18228)] = 390879,
  [SMALL_STATE(18229)] = 390896,
  [SMALL_STATE(18230)] = 390910,
  [SMALL_STATE(18231)] = 390924,
  [SMALL_STATE(18232)] = 390938,
  [SMALL_STATE(18233)] = 390952,
  [SMALL_STATE(18234)] = 390966,
  [SMALL_STATE(18235)] = 390980,
  [SMALL_STATE(18236)] = 390994,
  [SMALL_STATE(18237)] = 391008,
  [SMALL_STATE(18238)] = 391022,
  [SMALL_STATE(18239)] = 391036,
  [SMALL_STATE(18240)] = 391050,
  [SMALL_STATE(18241)] = 391064,
  [SMALL_STATE(18242)] = 391078,
  [SMALL_STATE(18243)] = 391092,
  [SMALL_STATE(18244)] = 391106,
  [SMALL_STATE(18245)] = 391120,
  [SMALL_STATE(18246)] = 391134,
  [SMALL_STATE(18247)] = 391148,
  [SMALL_STATE(18248)] = 391162,
  [SMALL_STATE(18249)] = 391176,
  [SMALL_STATE(18250)] = 391190,
  [SMALL_STATE(18251)] = 391204,
  [SMALL_STATE(18252)] = 391218,
  [SMALL_STATE(18253)] = 391232,
  [SMALL_STATE(18254)] = 391246,
  [SMALL_STATE(18255)] = 391260,
  [SMALL_STATE(18256)] = 391274,
  [SMALL_STATE(18257)] = 391288,
  [SMALL_STATE(18258)] = 391302,
  [SMALL_STATE(18259)] = 391316,
  [SMALL_STATE(18260)] = 391330,
  [SMALL_STATE(18261)] = 391344,
  [SMALL_STATE(18262)] = 391358,
  [SMALL_STATE(18263)] = 391372,
  [SMALL_STATE(18264)] = 391386,
  [SMALL_STATE(18265)] = 391400,
  [SMALL_STATE(18266)] = 391414,
  [SMALL_STATE(18267)] = 391428,
  [SMALL_STATE(18268)] = 391442,
  [SMALL_STATE(18269)] = 391456,
  [SMALL_STATE(18270)] = 391470,
  [SMALL_STATE(18271)] = 391484,
  [SMALL_STATE(18272)] = 391498,
  [SMALL_STATE(18273)] = 391512,
  [SMALL_STATE(18274)] = 391526,
  [SMALL_STATE(18275)] = 391540,
  [SMALL_STATE(18276)] = 391554,
  [SMALL_STATE(18277)] = 391568,
  [SMALL_STATE(18278)] = 391582,
  [SMALL_STATE(18279)] = 391596,
  [SMALL_STATE(18280)] = 391610,
  [SMALL_STATE(18281)] = 391624,
  [SMALL_STATE(18282)] = 391638,
  [SMALL_STATE(18283)] = 391652,
  [SMALL_STATE(18284)] = 391666,
  [SMALL_STATE(18285)] = 391680,
  [SMALL_STATE(18286)] = 391694,
  [SMALL_STATE(18287)] = 391708,
  [SMALL_STATE(18288)] = 391722,
  [SMALL_STATE(18289)] = 391736,
  [SMALL_STATE(18290)] = 391750,
  [SMALL_STATE(18291)] = 391764,
  [SMALL_STATE(18292)] = 391778,
  [SMALL_STATE(18293)] = 391792,
  [SMALL_STATE(18294)] = 391806,
  [SMALL_STATE(18295)] = 391820,
  [SMALL_STATE(18296)] = 391834,
  [SMALL_STATE(18297)] = 391848,
  [SMALL_STATE(18298)] = 391862,
  [SMALL_STATE(18299)] = 391876,
  [SMALL_STATE(18300)] = 391890,
  [SMALL_STATE(18301)] = 391904,
  [SMALL_STATE(18302)] = 391918,
  [SMALL_STATE(18303)] = 391932,
  [SMALL_STATE(18304)] = 391946,
  [SMALL_STATE(18305)] = 391960,
  [SMALL_STATE(18306)] = 391974,
  [SMALL_STATE(18307)] = 391988,
  [SMALL_STATE(18308)] = 392002,
  [SMALL_STATE(18309)] = 392016,
  [SMALL_STATE(18310)] = 392030,
  [SMALL_STATE(18311)] = 392044,
  [SMALL_STATE(18312)] = 392058,
  [SMALL_STATE(18313)] = 392072,
  [SMALL_STATE(18314)] = 392086,
  [SMALL_STATE(18315)] = 392100,
  [SMALL_STATE(18316)] = 392114,
  [SMALL_STATE(18317)] = 392128,
  [SMALL_STATE(18318)] = 392142,
  [SMALL_STATE(18319)] = 392156,
  [SMALL_STATE(18320)] = 392170,
  [SMALL_STATE(18321)] = 392184,
  [SMALL_STATE(18322)] = 392198,
  [SMALL_STATE(18323)] = 392212,
  [SMALL_STATE(18324)] = 392226,
  [SMALL_STATE(18325)] = 392240,
  [SMALL_STATE(18326)] = 392254,
  [SMALL_STATE(18327)] = 392268,
  [SMALL_STATE(18328)] = 392282,
  [SMALL_STATE(18329)] = 392296,
  [SMALL_STATE(18330)] = 392310,
  [SMALL_STATE(18331)] = 392324,
  [SMALL_STATE(18332)] = 392338,
  [SMALL_STATE(18333)] = 392352,
  [SMALL_STATE(18334)] = 392366,
  [SMALL_STATE(18335)] = 392380,
  [SMALL_STATE(18336)] = 392394,
  [SMALL_STATE(18337)] = 392408,
  [SMALL_STATE(18338)] = 392422,
  [SMALL_STATE(18339)] = 392436,
  [SMALL_STATE(18340)] = 392450,
  [SMALL_STATE(18341)] = 392464,
  [SMALL_STATE(18342)] = 392478,
  [SMALL_STATE(18343)] = 392492,
  [SMALL_STATE(18344)] = 392506,
  [SMALL_STATE(18345)] = 392520,
  [SMALL_STATE(18346)] = 392534,
  [SMALL_STATE(18347)] = 392548,
  [SMALL_STATE(18348)] = 392562,
  [SMALL_STATE(18349)] = 392576,
  [SMALL_STATE(18350)] = 392590,
  [SMALL_STATE(18351)] = 392604,
  [SMALL_STATE(18352)] = 392618,
  [SMALL_STATE(18353)] = 392632,
  [SMALL_STATE(18354)] = 392646,
  [SMALL_STATE(18355)] = 392660,
  [SMALL_STATE(18356)] = 392674,
  [SMALL_STATE(18357)] = 392688,
  [SMALL_STATE(18358)] = 392702,
  [SMALL_STATE(18359)] = 392716,
  [SMALL_STATE(18360)] = 392730,
  [SMALL_STATE(18361)] = 392744,
  [SMALL_STATE(18362)] = 392758,
  [SMALL_STATE(18363)] = 392772,
  [SMALL_STATE(18364)] = 392786,
  [SMALL_STATE(18365)] = 392800,
  [SMALL_STATE(18366)] = 392814,
  [SMALL_STATE(18367)] = 392828,
  [SMALL_STATE(18368)] = 392842,
  [SMALL_STATE(18369)] = 392856,
  [SMALL_STATE(18370)] = 392870,
  [SMALL_STATE(18371)] = 392884,
  [SMALL_STATE(18372)] = 392898,
  [SMALL_STATE(18373)] = 392912,
  [SMALL_STATE(18374)] = 392926,
  [SMALL_STATE(18375)] = 392940,
  [SMALL_STATE(18376)] = 392954,
  [SMALL_STATE(18377)] = 392968,
  [SMALL_STATE(18378)] = 392982,
  [SMALL_STATE(18379)] = 392996,
  [SMALL_STATE(18380)] = 393010,
  [SMALL_STATE(18381)] = 393024,
  [SMALL_STATE(18382)] = 393038,
  [SMALL_STATE(18383)] = 393052,
  [SMALL_STATE(18384)] = 393066,
  [SMALL_STATE(18385)] = 393080,
  [SMALL_STATE(18386)] = 393094,
  [SMALL_STATE(18387)] = 393108,
  [SMALL_STATE(18388)] = 393122,
  [SMALL_STATE(18389)] = 393136,
  [SMALL_STATE(18390)] = 393150,
  [SMALL_STATE(18391)] = 393164,
  [SMALL_STATE(18392)] = 393178,
  [SMALL_STATE(18393)] = 393192,
  [SMALL_STATE(18394)] = 393206,
  [SMALL_STATE(18395)] = 393220,
  [SMALL_STATE(18396)] = 393234,
  [SMALL_STATE(18397)] = 393248,
  [SMALL_STATE(18398)] = 393262,
  [SMALL_STATE(18399)] = 393276,
  [SMALL_STATE(18400)] = 393290,
  [SMALL_STATE(18401)] = 393304,
  [SMALL_STATE(18402)] = 393318,
  [SMALL_STATE(18403)] = 393332,
  [SMALL_STATE(18404)] = 393346,
  [SMALL_STATE(18405)] = 393360,
  [SMALL_STATE(18406)] = 393374,
  [SMALL_STATE(18407)] = 393388,
  [SMALL_STATE(18408)] = 393402,
  [SMALL_STATE(18409)] = 393416,
  [SMALL_STATE(18410)] = 393430,
  [SMALL_STATE(18411)] = 393444,
  [SMALL_STATE(18412)] = 393458,
  [SMALL_STATE(18413)] = 393472,
  [SMALL_STATE(18414)] = 393486,
  [SMALL_STATE(18415)] = 393500,
  [SMALL_STATE(18416)] = 393514,
  [SMALL_STATE(18417)] = 393528,
  [SMALL_STATE(18418)] = 393542,
  [SMALL_STATE(18419)] = 393556,
  [SMALL_STATE(18420)] = 393570,
  [SMALL_STATE(18421)] = 393584,
  [SMALL_STATE(18422)] = 393598,
  [SMALL_STATE(18423)] = 393612,
  [SMALL_STATE(18424)] = 393626,
  [SMALL_STATE(18425)] = 393640,
  [SMALL_STATE(18426)] = 393654,
  [SMALL_STATE(18427)] = 393668,
  [SMALL_STATE(18428)] = 393682,
  [SMALL_STATE(18429)] = 393696,
  [SMALL_STATE(18430)] = 393710,
  [SMALL_STATE(18431)] = 393724,
  [SMALL_STATE(18432)] = 393738,
  [SMALL_STATE(18433)] = 393752,
  [SMALL_STATE(18434)] = 393766,
  [SMALL_STATE(18435)] = 393780,
  [SMALL_STATE(18436)] = 393794,
  [SMALL_STATE(18437)] = 393808,
  [SMALL_STATE(18438)] = 393822,
  [SMALL_STATE(18439)] = 393836,
  [SMALL_STATE(18440)] = 393850,
  [SMALL_STATE(18441)] = 393864,
  [SMALL_STATE(18442)] = 393878,
  [SMALL_STATE(18443)] = 393892,
  [SMALL_STATE(18444)] = 393906,
  [SMALL_STATE(18445)] = 393920,
  [SMALL_STATE(18446)] = 393934,
  [SMALL_STATE(18447)] = 393948,
  [SMALL_STATE(18448)] = 393962,
  [SMALL_STATE(18449)] = 393976,
  [SMALL_STATE(18450)] = 393990,
  [SMALL_STATE(18451)] = 394004,
  [SMALL_STATE(18452)] = 394018,
  [SMALL_STATE(18453)] = 394032,
  [SMALL_STATE(18454)] = 394046,
  [SMALL_STATE(18455)] = 394060,
  [SMALL_STATE(18456)] = 394074,
  [SMALL_STATE(18457)] = 394088,
  [SMALL_STATE(18458)] = 394102,
  [SMALL_STATE(18459)] = 394116,
  [SMALL_STATE(18460)] = 394130,
  [SMALL_STATE(18461)] = 394144,
  [SMALL_STATE(18462)] = 394158,
  [SMALL_STATE(18463)] = 394172,
  [SMALL_STATE(18464)] = 394186,
  [SMALL_STATE(18465)] = 394200,
  [SMALL_STATE(18466)] = 394214,
  [SMALL_STATE(18467)] = 394228,
  [SMALL_STATE(18468)] = 394242,
  [SMALL_STATE(18469)] = 394256,
  [SMALL_STATE(18470)] = 394270,
  [SMALL_STATE(18471)] = 394284,
  [SMALL_STATE(18472)] = 394298,
  [SMALL_STATE(18473)] = 394312,
  [SMALL_STATE(18474)] = 394326,
  [SMALL_STATE(18475)] = 394340,
  [SMALL_STATE(18476)] = 394354,
  [SMALL_STATE(18477)] = 394368,
  [SMALL_STATE(18478)] = 394382,
  [SMALL_STATE(18479)] = 394396,
  [SMALL_STATE(18480)] = 394410,
  [SMALL_STATE(18481)] = 394424,
  [SMALL_STATE(18482)] = 394438,
  [SMALL_STATE(18483)] = 394452,
  [SMALL_STATE(18484)] = 394466,
  [SMALL_STATE(18485)] = 394480,
  [SMALL_STATE(18486)] = 394494,
  [SMALL_STATE(18487)] = 394508,
  [SMALL_STATE(18488)] = 394522,
  [SMALL_STATE(18489)] = 394536,
  [SMALL_STATE(18490)] = 394550,
  [SMALL_STATE(18491)] = 394564,
  [SMALL_STATE(18492)] = 394578,
  [SMALL_STATE(18493)] = 394592,
  [SMALL_STATE(18494)] = 394606,
  [SMALL_STATE(18495)] = 394620,
  [SMALL_STATE(18496)] = 394634,
  [SMALL_STATE(18497)] = 394648,
  [SMALL_STATE(18498)] = 394662,
  [SMALL_STATE(18499)] = 394676,
  [SMALL_STATE(18500)] = 394690,
  [SMALL_STATE(18501)] = 394704,
  [SMALL_STATE(18502)] = 394718,
  [SMALL_STATE(18503)] = 394732,
  [SMALL_STATE(18504)] = 394746,
  [SMALL_STATE(18505)] = 394760,
  [SMALL_STATE(18506)] = 394774,
  [SMALL_STATE(18507)] = 394788,
  [SMALL_STATE(18508)] = 394802,
  [SMALL_STATE(18509)] = 394816,
  [SMALL_STATE(18510)] = 394830,
  [SMALL_STATE(18511)] = 394844,
  [SMALL_STATE(18512)] = 394858,
  [SMALL_STATE(18513)] = 394872,
  [SMALL_STATE(18514)] = 394886,
  [SMALL_STATE(18515)] = 394900,
  [SMALL_STATE(18516)] = 394914,
  [SMALL_STATE(18517)] = 394928,
  [SMALL_STATE(18518)] = 394942,
  [SMALL_STATE(18519)] = 394956,
  [SMALL_STATE(18520)] = 394970,
  [SMALL_STATE(18521)] = 394984,
  [SMALL_STATE(18522)] = 394998,
  [SMALL_STATE(18523)] = 395012,
  [SMALL_STATE(18524)] = 395026,
  [SMALL_STATE(18525)] = 395040,
  [SMALL_STATE(18526)] = 395054,
  [SMALL_STATE(18527)] = 395068,
  [SMALL_STATE(18528)] = 395082,
  [SMALL_STATE(18529)] = 395096,
  [SMALL_STATE(18530)] = 395110,
  [SMALL_STATE(18531)] = 395124,
  [SMALL_STATE(18532)] = 395138,
  [SMALL_STATE(18533)] = 395152,
  [SMALL_STATE(18534)] = 395166,
  [SMALL_STATE(18535)] = 395180,
  [SMALL_STATE(18536)] = 395194,
  [SMALL_STATE(18537)] = 395208,
  [SMALL_STATE(18538)] = 395222,
  [SMALL_STATE(18539)] = 395236,
  [SMALL_STATE(18540)] = 395250,
  [SMALL_STATE(18541)] = 395264,
  [SMALL_STATE(18542)] = 395278,
  [SMALL_STATE(18543)] = 395292,
  [SMALL_STATE(18544)] = 395306,
  [SMALL_STATE(18545)] = 395320,
  [SMALL_STATE(18546)] = 395334,
  [SMALL_STATE(18547)] = 395348,
  [SMALL_STATE(18548)] = 395362,
  [SMALL_STATE(18549)] = 395376,
  [SMALL_STATE(18550)] = 395390,
  [SMALL_STATE(18551)] = 395404,
  [SMALL_STATE(18552)] = 395418,
  [SMALL_STATE(18553)] = 395432,
  [SMALL_STATE(18554)] = 395446,
  [SMALL_STATE(18555)] = 395460,
  [SMALL_STATE(18556)] = 395474,
  [SMALL_STATE(18557)] = 395488,
  [SMALL_STATE(18558)] = 395502,
  [SMALL_STATE(18559)] = 395516,
  [SMALL_STATE(18560)] = 395530,
  [SMALL_STATE(18561)] = 395544,
  [SMALL_STATE(18562)] = 395558,
  [SMALL_STATE(18563)] = 395572,
  [SMALL_STATE(18564)] = 395586,
  [SMALL_STATE(18565)] = 395600,
  [SMALL_STATE(18566)] = 395614,
  [SMALL_STATE(18567)] = 395628,
  [SMALL_STATE(18568)] = 395642,
  [SMALL_STATE(18569)] = 395656,
  [SMALL_STATE(18570)] = 395670,
  [SMALL_STATE(18571)] = 395684,
  [SMALL_STATE(18572)] = 395698,
  [SMALL_STATE(18573)] = 395712,
  [SMALL_STATE(18574)] = 395726,
  [SMALL_STATE(18575)] = 395740,
  [SMALL_STATE(18576)] = 395754,
  [SMALL_STATE(18577)] = 395768,
  [SMALL_STATE(18578)] = 395782,
  [SMALL_STATE(18579)] = 395796,
  [SMALL_STATE(18580)] = 395810,
  [SMALL_STATE(18581)] = 395824,
  [SMALL_STATE(18582)] = 395838,
  [SMALL_STATE(18583)] = 395852,
  [SMALL_STATE(18584)] = 395866,
  [SMALL_STATE(18585)] = 395880,
  [SMALL_STATE(18586)] = 395894,
  [SMALL_STATE(18587)] = 395908,
  [SMALL_STATE(18588)] = 395922,
  [SMALL_STATE(18589)] = 395936,
  [SMALL_STATE(18590)] = 395950,
  [SMALL_STATE(18591)] = 395964,
  [SMALL_STATE(18592)] = 395978,
  [SMALL_STATE(18593)] = 395992,
  [SMALL_STATE(18594)] = 396006,
  [SMALL_STATE(18595)] = 396020,
  [SMALL_STATE(18596)] = 396034,
  [SMALL_STATE(18597)] = 396048,
  [SMALL_STATE(18598)] = 396062,
  [SMALL_STATE(18599)] = 396076,
  [SMALL_STATE(18600)] = 396090,
  [SMALL_STATE(18601)] = 396104,
  [SMALL_STATE(18602)] = 396118,
  [SMALL_STATE(18603)] = 396132,
  [SMALL_STATE(18604)] = 396146,
  [SMALL_STATE(18605)] = 396160,
  [SMALL_STATE(18606)] = 396174,
  [SMALL_STATE(18607)] = 396188,
  [SMALL_STATE(18608)] = 396202,
  [SMALL_STATE(18609)] = 396216,
  [SMALL_STATE(18610)] = 396230,
  [SMALL_STATE(18611)] = 396244,
  [SMALL_STATE(18612)] = 396258,
  [SMALL_STATE(18613)] = 396272,
  [SMALL_STATE(18614)] = 396286,
  [SMALL_STATE(18615)] = 396300,
  [SMALL_STATE(18616)] = 396314,
  [SMALL_STATE(18617)] = 396328,
  [SMALL_STATE(18618)] = 396342,
  [SMALL_STATE(18619)] = 396356,
  [SMALL_STATE(18620)] = 396370,
  [SMALL_STATE(18621)] = 396384,
  [SMALL_STATE(18622)] = 396398,
  [SMALL_STATE(18623)] = 396412,
  [SMALL_STATE(18624)] = 396426,
  [SMALL_STATE(18625)] = 396440,
  [SMALL_STATE(18626)] = 396454,
  [SMALL_STATE(18627)] = 396468,
  [SMALL_STATE(18628)] = 396482,
  [SMALL_STATE(18629)] = 396496,
  [SMALL_STATE(18630)] = 396510,
  [SMALL_STATE(18631)] = 396524,
  [SMALL_STATE(18632)] = 396538,
  [SMALL_STATE(18633)] = 396552,
  [SMALL_STATE(18634)] = 396566,
  [SMALL_STATE(18635)] = 396580,
  [SMALL_STATE(18636)] = 396594,
  [SMALL_STATE(18637)] = 396608,
  [SMALL_STATE(18638)] = 396622,
  [SMALL_STATE(18639)] = 396636,
  [SMALL_STATE(18640)] = 396650,
  [SMALL_STATE(18641)] = 396664,
  [SMALL_STATE(18642)] = 396678,
  [SMALL_STATE(18643)] = 396692,
  [SMALL_STATE(18644)] = 396706,
  [SMALL_STATE(18645)] = 396720,
  [SMALL_STATE(18646)] = 396734,
  [SMALL_STATE(18647)] = 396748,
  [SMALL_STATE(18648)] = 396762,
  [SMALL_STATE(18649)] = 396776,
  [SMALL_STATE(18650)] = 396790,
  [SMALL_STATE(18651)] = 396804,
  [SMALL_STATE(18652)] = 396818,
  [SMALL_STATE(18653)] = 396832,
  [SMALL_STATE(18654)] = 396846,
  [SMALL_STATE(18655)] = 396860,
  [SMALL_STATE(18656)] = 396874,
  [SMALL_STATE(18657)] = 396888,
  [SMALL_STATE(18658)] = 396902,
  [SMALL_STATE(18659)] = 396916,
  [SMALL_STATE(18660)] = 396930,
  [SMALL_STATE(18661)] = 396944,
  [SMALL_STATE(18662)] = 396958,
  [SMALL_STATE(18663)] = 396972,
  [SMALL_STATE(18664)] = 396986,
  [SMALL_STATE(18665)] = 397000,
  [SMALL_STATE(18666)] = 397014,
  [SMALL_STATE(18667)] = 397028,
  [SMALL_STATE(18668)] = 397042,
  [SMALL_STATE(18669)] = 397056,
  [SMALL_STATE(18670)] = 397070,
  [SMALL_STATE(18671)] = 397084,
  [SMALL_STATE(18672)] = 397098,
  [SMALL_STATE(18673)] = 397112,
  [SMALL_STATE(18674)] = 397126,
  [SMALL_STATE(18675)] = 397140,
  [SMALL_STATE(18676)] = 397154,
  [SMALL_STATE(18677)] = 397168,
  [SMALL_STATE(18678)] = 397182,
  [SMALL_STATE(18679)] = 397196,
  [SMALL_STATE(18680)] = 397210,
  [SMALL_STATE(18681)] = 397224,
  [SMALL_STATE(18682)] = 397238,
  [SMALL_STATE(18683)] = 397252,
  [SMALL_STATE(18684)] = 397266,
  [SMALL_STATE(18685)] = 397280,
  [SMALL_STATE(18686)] = 397294,
  [SMALL_STATE(18687)] = 397308,
  [SMALL_STATE(18688)] = 397322,
  [SMALL_STATE(18689)] = 397336,
  [SMALL_STATE(18690)] = 397350,
  [SMALL_STATE(18691)] = 397364,
  [SMALL_STATE(18692)] = 397378,
  [SMALL_STATE(18693)] = 397392,
  [SMALL_STATE(18694)] = 397406,
  [SMALL_STATE(18695)] = 397420,
  [SMALL_STATE(18696)] = 397434,
  [SMALL_STATE(18697)] = 397448,
  [SMALL_STATE(18698)] = 397462,
  [SMALL_STATE(18699)] = 397476,
  [SMALL_STATE(18700)] = 397490,
  [SMALL_STATE(18701)] = 397504,
  [SMALL_STATE(18702)] = 397518,
  [SMALL_STATE(18703)] = 397532,
  [SMALL_STATE(18704)] = 397546,
  [SMALL_STATE(18705)] = 397560,
  [SMALL_STATE(18706)] = 397574,
  [SMALL_STATE(18707)] = 397588,
  [SMALL_STATE(18708)] = 397602,
  [SMALL_STATE(18709)] = 397616,
  [SMALL_STATE(18710)] = 397630,
  [SMALL_STATE(18711)] = 397644,
  [SMALL_STATE(18712)] = 397658,
  [SMALL_STATE(18713)] = 397672,
  [SMALL_STATE(18714)] = 397686,
  [SMALL_STATE(18715)] = 397700,
  [SMALL_STATE(18716)] = 397714,
  [SMALL_STATE(18717)] = 397728,
  [SMALL_STATE(18718)] = 397742,
  [SMALL_STATE(18719)] = 397756,
  [SMALL_STATE(18720)] = 397770,
  [SMALL_STATE(18721)] = 397784,
  [SMALL_STATE(18722)] = 397798,
  [SMALL_STATE(18723)] = 397812,
  [SMALL_STATE(18724)] = 397826,
  [SMALL_STATE(18725)] = 397840,
  [SMALL_STATE(18726)] = 397854,
  [SMALL_STATE(18727)] = 397868,
  [SMALL_STATE(18728)] = 397882,
  [SMALL_STATE(18729)] = 397896,
  [SMALL_STATE(18730)] = 397910,
  [SMALL_STATE(18731)] = 397924,
  [SMALL_STATE(18732)] = 397938,
  [SMALL_STATE(18733)] = 397952,
  [SMALL_STATE(18734)] = 397966,
  [SMALL_STATE(18735)] = 397980,
  [SMALL_STATE(18736)] = 397994,
  [SMALL_STATE(18737)] = 398008,
  [SMALL_STATE(18738)] = 398022,
  [SMALL_STATE(18739)] = 398036,
  [SMALL_STATE(18740)] = 398050,
  [SMALL_STATE(18741)] = 398064,
  [SMALL_STATE(18742)] = 398078,
  [SMALL_STATE(18743)] = 398092,
  [SMALL_STATE(18744)] = 398106,
  [SMALL_STATE(18745)] = 398120,
  [SMALL_STATE(18746)] = 398134,
  [SMALL_STATE(18747)] = 398148,
  [SMALL_STATE(18748)] = 398162,
  [SMALL_STATE(18749)] = 398176,
  [SMALL_STATE(18750)] = 398190,
  [SMALL_STATE(18751)] = 398204,
  [SMALL_STATE(18752)] = 398218,
  [SMALL_STATE(18753)] = 398232,
  [SMALL_STATE(18754)] = 398246,
  [SMALL_STATE(18755)] = 398260,
  [SMALL_STATE(18756)] = 398274,
  [SMALL_STATE(18757)] = 398288,
  [SMALL_STATE(18758)] = 398302,
  [SMALL_STATE(18759)] = 398316,
  [SMALL_STATE(18760)] = 398330,
  [SMALL_STATE(18761)] = 398344,
  [SMALL_STATE(18762)] = 398358,
  [SMALL_STATE(18763)] = 398372,
  [SMALL_STATE(18764)] = 398386,
  [SMALL_STATE(18765)] = 398400,
  [SMALL_STATE(18766)] = 398414,
  [SMALL_STATE(18767)] = 398428,
  [SMALL_STATE(18768)] = 398442,
  [SMALL_STATE(18769)] = 398456,
  [SMALL_STATE(18770)] = 398470,
  [SMALL_STATE(18771)] = 398484,
  [SMALL_STATE(18772)] = 398498,
  [SMALL_STATE(18773)] = 398512,
  [SMALL_STATE(18774)] = 398526,
  [SMALL_STATE(18775)] = 398540,
  [SMALL_STATE(18776)] = 398554,
  [SMALL_STATE(18777)] = 398568,
  [SMALL_STATE(18778)] = 398582,
  [SMALL_STATE(18779)] = 398596,
  [SMALL_STATE(18780)] = 398610,
  [SMALL_STATE(18781)] = 398624,
  [SMALL_STATE(18782)] = 398638,
  [SMALL_STATE(18783)] = 398652,
  [SMALL_STATE(18784)] = 398666,
  [SMALL_STATE(18785)] = 398680,
  [SMALL_STATE(18786)] = 398694,
  [SMALL_STATE(18787)] = 398708,
  [SMALL_STATE(18788)] = 398722,
  [SMALL_STATE(18789)] = 398736,
  [SMALL_STATE(18790)] = 398750,
  [SMALL_STATE(18791)] = 398764,
  [SMALL_STATE(18792)] = 398778,
  [SMALL_STATE(18793)] = 398792,
  [SMALL_STATE(18794)] = 398806,
  [SMALL_STATE(18795)] = 398820,
  [SMALL_STATE(18796)] = 398834,
  [SMALL_STATE(18797)] = 398848,
  [SMALL_STATE(18798)] = 398862,
  [SMALL_STATE(18799)] = 398876,
  [SMALL_STATE(18800)] = 398890,
  [SMALL_STATE(18801)] = 398904,
  [SMALL_STATE(18802)] = 398918,
  [SMALL_STATE(18803)] = 398932,
  [SMALL_STATE(18804)] = 398946,
  [SMALL_STATE(18805)] = 398960,
  [SMALL_STATE(18806)] = 398974,
  [SMALL_STATE(18807)] = 398988,
  [SMALL_STATE(18808)] = 399002,
  [SMALL_STATE(18809)] = 399016,
  [SMALL_STATE(18810)] = 399030,
  [SMALL_STATE(18811)] = 399044,
  [SMALL_STATE(18812)] = 399058,
  [SMALL_STATE(18813)] = 399072,
  [SMALL_STATE(18814)] = 399086,
  [SMALL_STATE(18815)] = 399100,
  [SMALL_STATE(18816)] = 399114,
  [SMALL_STATE(18817)] = 399128,
  [SMALL_STATE(18818)] = 399142,
  [SMALL_STATE(18819)] = 399156,
  [SMALL_STATE(18820)] = 399170,
  [SMALL_STATE(18821)] = 399184,
  [SMALL_STATE(18822)] = 399198,
  [SMALL_STATE(18823)] = 399212,
  [SMALL_STATE(18824)] = 399226,
  [SMALL_STATE(18825)] = 399240,
  [SMALL_STATE(18826)] = 399254,
  [SMALL_STATE(18827)] = 399268,
  [SMALL_STATE(18828)] = 399282,
  [SMALL_STATE(18829)] = 399296,
  [SMALL_STATE(18830)] = 399310,
  [SMALL_STATE(18831)] = 399324,
  [SMALL_STATE(18832)] = 399338,
  [SMALL_STATE(18833)] = 399352,
  [SMALL_STATE(18834)] = 399366,
  [SMALL_STATE(18835)] = 399380,
  [SMALL_STATE(18836)] = 399394,
  [SMALL_STATE(18837)] = 399408,
  [SMALL_STATE(18838)] = 399422,
  [SMALL_STATE(18839)] = 399436,
  [SMALL_STATE(18840)] = 399450,
  [SMALL_STATE(18841)] = 399464,
  [SMALL_STATE(18842)] = 399478,
  [SMALL_STATE(18843)] = 399492,
  [SMALL_STATE(18844)] = 399506,
  [SMALL_STATE(18845)] = 399520,
  [SMALL_STATE(18846)] = 399534,
  [SMALL_STATE(18847)] = 399548,
  [SMALL_STATE(18848)] = 399562,
  [SMALL_STATE(18849)] = 399576,
  [SMALL_STATE(18850)] = 399590,
  [SMALL_STATE(18851)] = 399604,
  [SMALL_STATE(18852)] = 399618,
  [SMALL_STATE(18853)] = 399632,
  [SMALL_STATE(18854)] = 399646,
  [SMALL_STATE(18855)] = 399660,
  [SMALL_STATE(18856)] = 399674,
  [SMALL_STATE(18857)] = 399688,
  [SMALL_STATE(18858)] = 399702,
  [SMALL_STATE(18859)] = 399716,
  [SMALL_STATE(18860)] = 399730,
  [SMALL_STATE(18861)] = 399744,
  [SMALL_STATE(18862)] = 399758,
  [SMALL_STATE(18863)] = 399772,
  [SMALL_STATE(18864)] = 399786,
  [SMALL_STATE(18865)] = 399800,
  [SMALL_STATE(18866)] = 399814,
  [SMALL_STATE(18867)] = 399828,
  [SMALL_STATE(18868)] = 399842,
  [SMALL_STATE(18869)] = 399856,
  [SMALL_STATE(18870)] = 399870,
  [SMALL_STATE(18871)] = 399884,
  [SMALL_STATE(18872)] = 399898,
  [SMALL_STATE(18873)] = 399912,
  [SMALL_STATE(18874)] = 399926,
  [SMALL_STATE(18875)] = 399940,
  [SMALL_STATE(18876)] = 399954,
  [SMALL_STATE(18877)] = 399968,
  [SMALL_STATE(18878)] = 399982,
  [SMALL_STATE(18879)] = 399996,
  [SMALL_STATE(18880)] = 400010,
  [SMALL_STATE(18881)] = 400024,
  [SMALL_STATE(18882)] = 400038,
  [SMALL_STATE(18883)] = 400052,
  [SMALL_STATE(18884)] = 400066,
  [SMALL_STATE(18885)] = 400080,
  [SMALL_STATE(18886)] = 400094,
  [SMALL_STATE(18887)] = 400108,
  [SMALL_STATE(18888)] = 400122,
  [SMALL_STATE(18889)] = 400136,
  [SMALL_STATE(18890)] = 400150,
  [SMALL_STATE(18891)] = 400164,
  [SMALL_STATE(18892)] = 400178,
  [SMALL_STATE(18893)] = 400192,
  [SMALL_STATE(18894)] = 400206,
  [SMALL_STATE(18895)] = 400220,
  [SMALL_STATE(18896)] = 400234,
  [SMALL_STATE(18897)] = 400248,
  [SMALL_STATE(18898)] = 400262,
  [SMALL_STATE(18899)] = 400276,
  [SMALL_STATE(18900)] = 400290,
  [SMALL_STATE(18901)] = 400304,
  [SMALL_STATE(18902)] = 400318,
  [SMALL_STATE(18903)] = 400332,
  [SMALL_STATE(18904)] = 400346,
  [SMALL_STATE(18905)] = 400360,
  [SMALL_STATE(18906)] = 400374,
  [SMALL_STATE(18907)] = 400388,
  [SMALL_STATE(18908)] = 400402,
  [SMALL_STATE(18909)] = 400416,
  [SMALL_STATE(18910)] = 400430,
  [SMALL_STATE(18911)] = 400444,
  [SMALL_STATE(18912)] = 400458,
  [SMALL_STATE(18913)] = 400472,
  [SMALL_STATE(18914)] = 400486,
  [SMALL_STATE(18915)] = 400500,
  [SMALL_STATE(18916)] = 400514,
  [SMALL_STATE(18917)] = 400528,
  [SMALL_STATE(18918)] = 400542,
  [SMALL_STATE(18919)] = 400556,
  [SMALL_STATE(18920)] = 400570,
  [SMALL_STATE(18921)] = 400584,
  [SMALL_STATE(18922)] = 400598,
  [SMALL_STATE(18923)] = 400612,
  [SMALL_STATE(18924)] = 400626,
  [SMALL_STATE(18925)] = 400640,
  [SMALL_STATE(18926)] = 400654,
  [SMALL_STATE(18927)] = 400668,
  [SMALL_STATE(18928)] = 400682,
  [SMALL_STATE(18929)] = 400696,
  [SMALL_STATE(18930)] = 400710,
  [SMALL_STATE(18931)] = 400724,
  [SMALL_STATE(18932)] = 400738,
  [SMALL_STATE(18933)] = 400752,
  [SMALL_STATE(18934)] = 400766,
  [SMALL_STATE(18935)] = 400780,
  [SMALL_STATE(18936)] = 400794,
  [SMALL_STATE(18937)] = 400808,
  [SMALL_STATE(18938)] = 400822,
  [SMALL_STATE(18939)] = 400836,
  [SMALL_STATE(18940)] = 400850,
  [SMALL_STATE(18941)] = 400864,
  [SMALL_STATE(18942)] = 400878,
  [SMALL_STATE(18943)] = 400892,
  [SMALL_STATE(18944)] = 400906,
  [SMALL_STATE(18945)] = 400920,
  [SMALL_STATE(18946)] = 400934,
  [SMALL_STATE(18947)] = 400948,
  [SMALL_STATE(18948)] = 400962,
  [SMALL_STATE(18949)] = 400976,
  [SMALL_STATE(18950)] = 400990,
  [SMALL_STATE(18951)] = 401004,
  [SMALL_STATE(18952)] = 401018,
  [SMALL_STATE(18953)] = 401032,
  [SMALL_STATE(18954)] = 401046,
  [SMALL_STATE(18955)] = 401060,
  [SMALL_STATE(18956)] = 401074,
  [SMALL_STATE(18957)] = 401088,
  [SMALL_STATE(18958)] = 401102,
  [SMALL_STATE(18959)] = 401116,
  [SMALL_STATE(18960)] = 401130,
  [SMALL_STATE(18961)] = 401144,
  [SMALL_STATE(18962)] = 401158,
  [SMALL_STATE(18963)] = 401172,
  [SMALL_STATE(18964)] = 401186,
  [SMALL_STATE(18965)] = 401200,
  [SMALL_STATE(18966)] = 401214,
  [SMALL_STATE(18967)] = 401228,
  [SMALL_STATE(18968)] = 401242,
  [SMALL_STATE(18969)] = 401256,
  [SMALL_STATE(18970)] = 401270,
  [SMALL_STATE(18971)] = 401284,
  [SMALL_STATE(18972)] = 401298,
  [SMALL_STATE(18973)] = 401312,
  [SMALL_STATE(18974)] = 401326,
  [SMALL_STATE(18975)] = 401340,
  [SMALL_STATE(18976)] = 401354,
  [SMALL_STATE(18977)] = 401368,
  [SMALL_STATE(18978)] = 401382,
  [SMALL_STATE(18979)] = 401396,
  [SMALL_STATE(18980)] = 401410,
  [SMALL_STATE(18981)] = 401424,
  [SMALL_STATE(18982)] = 401438,
  [SMALL_STATE(18983)] = 401452,
  [SMALL_STATE(18984)] = 401466,
  [SMALL_STATE(18985)] = 401480,
  [SMALL_STATE(18986)] = 401494,
  [SMALL_STATE(18987)] = 401508,
  [SMALL_STATE(18988)] = 401522,
  [SMALL_STATE(18989)] = 401536,
  [SMALL_STATE(18990)] = 401550,
  [SMALL_STATE(18991)] = 401564,
  [SMALL_STATE(18992)] = 401578,
  [SMALL_STATE(18993)] = 401592,
  [SMALL_STATE(18994)] = 401606,
  [SMALL_STATE(18995)] = 401620,
  [SMALL_STATE(18996)] = 401634,
  [SMALL_STATE(18997)] = 401648,
  [SMALL_STATE(18998)] = 401662,
  [SMALL_STATE(18999)] = 401676,
  [SMALL_STATE(19000)] = 401690,
  [SMALL_STATE(19001)] = 401704,
  [SMALL_STATE(19002)] = 401718,
  [SMALL_STATE(19003)] = 401732,
  [SMALL_STATE(19004)] = 401746,
  [SMALL_STATE(19005)] = 401760,
  [SMALL_STATE(19006)] = 401774,
  [SMALL_STATE(19007)] = 401788,
  [SMALL_STATE(19008)] = 401802,
  [SMALL_STATE(19009)] = 401816,
  [SMALL_STATE(19010)] = 401830,
  [SMALL_STATE(19011)] = 401844,
  [SMALL_STATE(19012)] = 401858,
  [SMALL_STATE(19013)] = 401872,
  [SMALL_STATE(19014)] = 401886,
  [SMALL_STATE(19015)] = 401900,
  [SMALL_STATE(19016)] = 401914,
  [SMALL_STATE(19017)] = 401928,
  [SMALL_STATE(19018)] = 401942,
  [SMALL_STATE(19019)] = 401956,
  [SMALL_STATE(19020)] = 401970,
  [SMALL_STATE(19021)] = 401984,
  [SMALL_STATE(19022)] = 401998,
  [SMALL_STATE(19023)] = 402012,
  [SMALL_STATE(19024)] = 402026,
  [SMALL_STATE(19025)] = 402040,
  [SMALL_STATE(19026)] = 402054,
  [SMALL_STATE(19027)] = 402068,
  [SMALL_STATE(19028)] = 402082,
  [SMALL_STATE(19029)] = 402096,
  [SMALL_STATE(19030)] = 402110,
  [SMALL_STATE(19031)] = 402124,
  [SMALL_STATE(19032)] = 402138,
  [SMALL_STATE(19033)] = 402152,
  [SMALL_STATE(19034)] = 402166,
  [SMALL_STATE(19035)] = 402180,
  [SMALL_STATE(19036)] = 402194,
  [SMALL_STATE(19037)] = 402208,
  [SMALL_STATE(19038)] = 402222,
  [SMALL_STATE(19039)] = 402236,
  [SMALL_STATE(19040)] = 402250,
  [SMALL_STATE(19041)] = 402264,
  [SMALL_STATE(19042)] = 402278,
  [SMALL_STATE(19043)] = 402292,
  [SMALL_STATE(19044)] = 402306,
  [SMALL_STATE(19045)] = 402320,
  [SMALL_STATE(19046)] = 402334,
  [SMALL_STATE(19047)] = 402348,
  [SMALL_STATE(19048)] = 402362,
  [SMALL_STATE(19049)] = 402376,
  [SMALL_STATE(19050)] = 402390,
  [SMALL_STATE(19051)] = 402404,
  [SMALL_STATE(19052)] = 402418,
  [SMALL_STATE(19053)] = 402432,
  [SMALL_STATE(19054)] = 402446,
  [SMALL_STATE(19055)] = 402460,
  [SMALL_STATE(19056)] = 402474,
  [SMALL_STATE(19057)] = 402488,
  [SMALL_STATE(19058)] = 402502,
  [SMALL_STATE(19059)] = 402516,
  [SMALL_STATE(19060)] = 402530,
  [SMALL_STATE(19061)] = 402544,
  [SMALL_STATE(19062)] = 402558,
  [SMALL_STATE(19063)] = 402572,
  [SMALL_STATE(19064)] = 402586,
  [SMALL_STATE(19065)] = 402600,
  [SMALL_STATE(19066)] = 402614,
  [SMALL_STATE(19067)] = 402628,
  [SMALL_STATE(19068)] = 402642,
  [SMALL_STATE(19069)] = 402656,
  [SMALL_STATE(19070)] = 402670,
  [SMALL_STATE(19071)] = 402684,
  [SMALL_STATE(19072)] = 402698,
  [SMALL_STATE(19073)] = 402712,
  [SMALL_STATE(19074)] = 402726,
  [SMALL_STATE(19075)] = 402740,
  [SMALL_STATE(19076)] = 402754,
  [SMALL_STATE(19077)] = 402768,
  [SMALL_STATE(19078)] = 402782,
  [SMALL_STATE(19079)] = 402796,
  [SMALL_STATE(19080)] = 402810,
  [SMALL_STATE(19081)] = 402824,
  [SMALL_STATE(19082)] = 402838,
  [SMALL_STATE(19083)] = 402852,
  [SMALL_STATE(19084)] = 402866,
  [SMALL_STATE(19085)] = 402880,
  [SMALL_STATE(19086)] = 402894,
  [SMALL_STATE(19087)] = 402908,
  [SMALL_STATE(19088)] = 402922,
  [SMALL_STATE(19089)] = 402936,
  [SMALL_STATE(19090)] = 402950,
  [SMALL_STATE(19091)] = 402964,
  [SMALL_STATE(19092)] = 402978,
  [SMALL_STATE(19093)] = 402992,
  [SMALL_STATE(19094)] = 403006,
  [SMALL_STATE(19095)] = 403020,
  [SMALL_STATE(19096)] = 403034,
  [SMALL_STATE(19097)] = 403048,
  [SMALL_STATE(19098)] = 403062,
  [SMALL_STATE(19099)] = 403076,
  [SMALL_STATE(19100)] = 403090,
  [SMALL_STATE(19101)] = 403104,
  [SMALL_STATE(19102)] = 403118,
  [SMALL_STATE(19103)] = 403132,
  [SMALL_STATE(19104)] = 403146,
  [SMALL_STATE(19105)] = 403160,
  [SMALL_STATE(19106)] = 403174,
  [SMALL_STATE(19107)] = 403188,
  [SMALL_STATE(19108)] = 403202,
  [SMALL_STATE(19109)] = 403216,
  [SMALL_STATE(19110)] = 403230,
  [SMALL_STATE(19111)] = 403244,
  [SMALL_STATE(19112)] = 403258,
  [SMALL_STATE(19113)] = 403272,
  [SMALL_STATE(19114)] = 403286,
  [SMALL_STATE(19115)] = 403300,
  [SMALL_STATE(19116)] = 403314,
  [SMALL_STATE(19117)] = 403328,
  [SMALL_STATE(19118)] = 403342,
  [SMALL_STATE(19119)] = 403356,
  [SMALL_STATE(19120)] = 403370,
  [SMALL_STATE(19121)] = 403384,
  [SMALL_STATE(19122)] = 403398,
  [SMALL_STATE(19123)] = 403412,
  [SMALL_STATE(19124)] = 403426,
  [SMALL_STATE(19125)] = 403440,
  [SMALL_STATE(19126)] = 403454,
  [SMALL_STATE(19127)] = 403468,
  [SMALL_STATE(19128)] = 403482,
  [SMALL_STATE(19129)] = 403496,
  [SMALL_STATE(19130)] = 403510,
  [SMALL_STATE(19131)] = 403524,
  [SMALL_STATE(19132)] = 403538,
  [SMALL_STATE(19133)] = 403552,
  [SMALL_STATE(19134)] = 403566,
  [SMALL_STATE(19135)] = 403580,
  [SMALL_STATE(19136)] = 403594,
  [SMALL_STATE(19137)] = 403608,
  [SMALL_STATE(19138)] = 403622,
  [SMALL_STATE(19139)] = 403636,
  [SMALL_STATE(19140)] = 403650,
  [SMALL_STATE(19141)] = 403664,
  [SMALL_STATE(19142)] = 403678,
  [SMALL_STATE(19143)] = 403692,
  [SMALL_STATE(19144)] = 403706,
  [SMALL_STATE(19145)] = 403720,
  [SMALL_STATE(19146)] = 403734,
  [SMALL_STATE(19147)] = 403748,
  [SMALL_STATE(19148)] = 403762,
  [SMALL_STATE(19149)] = 403776,
  [SMALL_STATE(19150)] = 403790,
  [SMALL_STATE(19151)] = 403804,
  [SMALL_STATE(19152)] = 403818,
  [SMALL_STATE(19153)] = 403832,
  [SMALL_STATE(19154)] = 403846,
  [SMALL_STATE(19155)] = 403860,
  [SMALL_STATE(19156)] = 403874,
  [SMALL_STATE(19157)] = 403888,
  [SMALL_STATE(19158)] = 403902,
  [SMALL_STATE(19159)] = 403916,
  [SMALL_STATE(19160)] = 403930,
  [SMALL_STATE(19161)] = 403944,
  [SMALL_STATE(19162)] = 403958,
  [SMALL_STATE(19163)] = 403972,
  [SMALL_STATE(19164)] = 403986,
  [SMALL_STATE(19165)] = 404000,
  [SMALL_STATE(19166)] = 404014,
  [SMALL_STATE(19167)] = 404028,
  [SMALL_STATE(19168)] = 404042,
  [SMALL_STATE(19169)] = 404056,
  [SMALL_STATE(19170)] = 404070,
  [SMALL_STATE(19171)] = 404084,
  [SMALL_STATE(19172)] = 404098,
  [SMALL_STATE(19173)] = 404112,
  [SMALL_STATE(19174)] = 404126,
  [SMALL_STATE(19175)] = 404140,
  [SMALL_STATE(19176)] = 404154,
  [SMALL_STATE(19177)] = 404168,
  [SMALL_STATE(19178)] = 404182,
  [SMALL_STATE(19179)] = 404196,
  [SMALL_STATE(19180)] = 404210,
  [SMALL_STATE(19181)] = 404224,
  [SMALL_STATE(19182)] = 404238,
  [SMALL_STATE(19183)] = 404252,
  [SMALL_STATE(19184)] = 404266,
  [SMALL_STATE(19185)] = 404280,
  [SMALL_STATE(19186)] = 404294,
  [SMALL_STATE(19187)] = 404308,
  [SMALL_STATE(19188)] = 404322,
  [SMALL_STATE(19189)] = 404336,
  [SMALL_STATE(19190)] = 404350,
  [SMALL_STATE(19191)] = 404364,
  [SMALL_STATE(19192)] = 404378,
  [SMALL_STATE(19193)] = 404392,
  [SMALL_STATE(19194)] = 404406,
  [SMALL_STATE(19195)] = 404420,
  [SMALL_STATE(19196)] = 404434,
  [SMALL_STATE(19197)] = 404448,
  [SMALL_STATE(19198)] = 404462,
  [SMALL_STATE(19199)] = 404476,
  [SMALL_STATE(19200)] = 404490,
  [SMALL_STATE(19201)] = 404504,
  [SMALL_STATE(19202)] = 404518,
  [SMALL_STATE(19203)] = 404532,
  [SMALL_STATE(19204)] = 404546,
  [SMALL_STATE(19205)] = 404560,
  [SMALL_STATE(19206)] = 404574,
  [SMALL_STATE(19207)] = 404588,
  [SMALL_STATE(19208)] = 404602,
  [SMALL_STATE(19209)] = 404616,
  [SMALL_STATE(19210)] = 404630,
  [SMALL_STATE(19211)] = 404644,
  [SMALL_STATE(19212)] = 404658,
  [SMALL_STATE(19213)] = 404672,
  [SMALL_STATE(19214)] = 404686,
  [SMALL_STATE(19215)] = 404700,
  [SMALL_STATE(19216)] = 404714,
  [SMALL_STATE(19217)] = 404728,
  [SMALL_STATE(19218)] = 404742,
  [SMALL_STATE(19219)] = 404756,
  [SMALL_STATE(19220)] = 404770,
  [SMALL_STATE(19221)] = 404784,
  [SMALL_STATE(19222)] = 404798,
  [SMALL_STATE(19223)] = 404812,
  [SMALL_STATE(19224)] = 404826,
  [SMALL_STATE(19225)] = 404840,
  [SMALL_STATE(19226)] = 404854,
  [SMALL_STATE(19227)] = 404868,
  [SMALL_STATE(19228)] = 404882,
  [SMALL_STATE(19229)] = 404896,
  [SMALL_STATE(19230)] = 404910,
  [SMALL_STATE(19231)] = 404924,
  [SMALL_STATE(19232)] = 404938,
  [SMALL_STATE(19233)] = 404952,
  [SMALL_STATE(19234)] = 404966,
  [SMALL_STATE(19235)] = 404980,
  [SMALL_STATE(19236)] = 404994,
  [SMALL_STATE(19237)] = 405008,
  [SMALL_STATE(19238)] = 405022,
  [SMALL_STATE(19239)] = 405036,
  [SMALL_STATE(19240)] = 405050,
  [SMALL_STATE(19241)] = 405064,
  [SMALL_STATE(19242)] = 405078,
  [SMALL_STATE(19243)] = 405092,
  [SMALL_STATE(19244)] = 405106,
  [SMALL_STATE(19245)] = 405120,
  [SMALL_STATE(19246)] = 405134,
  [SMALL_STATE(19247)] = 405148,
  [SMALL_STATE(19248)] = 405162,
  [SMALL_STATE(19249)] = 405176,
  [SMALL_STATE(19250)] = 405190,
  [SMALL_STATE(19251)] = 405204,
  [SMALL_STATE(19252)] = 405218,
  [SMALL_STATE(19253)] = 405232,
  [SMALL_STATE(19254)] = 405246,
  [SMALL_STATE(19255)] = 405260,
  [SMALL_STATE(19256)] = 405274,
  [SMALL_STATE(19257)] = 405288,
  [SMALL_STATE(19258)] = 405302,
  [SMALL_STATE(19259)] = 405316,
  [SMALL_STATE(19260)] = 405330,
  [SMALL_STATE(19261)] = 405344,
  [SMALL_STATE(19262)] = 405358,
  [SMALL_STATE(19263)] = 405372,
  [SMALL_STATE(19264)] = 405386,
  [SMALL_STATE(19265)] = 405400,
  [SMALL_STATE(19266)] = 405414,
  [SMALL_STATE(19267)] = 405428,
  [SMALL_STATE(19268)] = 405442,
  [SMALL_STATE(19269)] = 405456,
  [SMALL_STATE(19270)] = 405470,
  [SMALL_STATE(19271)] = 405484,
  [SMALL_STATE(19272)] = 405498,
  [SMALL_STATE(19273)] = 405512,
  [SMALL_STATE(19274)] = 405526,
  [SMALL_STATE(19275)] = 405540,
  [SMALL_STATE(19276)] = 405554,
  [SMALL_STATE(19277)] = 405568,
  [SMALL_STATE(19278)] = 405582,
  [SMALL_STATE(19279)] = 405596,
  [SMALL_STATE(19280)] = 405610,
  [SMALL_STATE(19281)] = 405624,
  [SMALL_STATE(19282)] = 405638,
  [SMALL_STATE(19283)] = 405652,
  [SMALL_STATE(19284)] = 405666,
  [SMALL_STATE(19285)] = 405680,
  [SMALL_STATE(19286)] = 405694,
  [SMALL_STATE(19287)] = 405708,
  [SMALL_STATE(19288)] = 405722,
  [SMALL_STATE(19289)] = 405736,
  [SMALL_STATE(19290)] = 405750,
  [SMALL_STATE(19291)] = 405764,
  [SMALL_STATE(19292)] = 405778,
  [SMALL_STATE(19293)] = 405792,
  [SMALL_STATE(19294)] = 405806,
  [SMALL_STATE(19295)] = 405820,
  [SMALL_STATE(19296)] = 405834,
  [SMALL_STATE(19297)] = 405848,
  [SMALL_STATE(19298)] = 405862,
  [SMALL_STATE(19299)] = 405876,
  [SMALL_STATE(19300)] = 405890,
  [SMALL_STATE(19301)] = 405904,
  [SMALL_STATE(19302)] = 405918,
  [SMALL_STATE(19303)] = 405932,
  [SMALL_STATE(19304)] = 405946,
  [SMALL_STATE(19305)] = 405960,
  [SMALL_STATE(19306)] = 405974,
  [SMALL_STATE(19307)] = 405988,
  [SMALL_STATE(19308)] = 406002,
  [SMALL_STATE(19309)] = 406016,
  [SMALL_STATE(19310)] = 406030,
  [SMALL_STATE(19311)] = 406044,
  [SMALL_STATE(19312)] = 406058,
  [SMALL_STATE(19313)] = 406072,
  [SMALL_STATE(19314)] = 406086,
  [SMALL_STATE(19315)] = 406100,
  [SMALL_STATE(19316)] = 406114,
  [SMALL_STATE(19317)] = 406128,
  [SMALL_STATE(19318)] = 406142,
  [SMALL_STATE(19319)] = 406156,
  [SMALL_STATE(19320)] = 406170,
  [SMALL_STATE(19321)] = 406184,
  [SMALL_STATE(19322)] = 406198,
  [SMALL_STATE(19323)] = 406212,
  [SMALL_STATE(19324)] = 406226,
  [SMALL_STATE(19325)] = 406240,
  [SMALL_STATE(19326)] = 406254,
  [SMALL_STATE(19327)] = 406268,
  [SMALL_STATE(19328)] = 406282,
  [SMALL_STATE(19329)] = 406296,
  [SMALL_STATE(19330)] = 406310,
  [SMALL_STATE(19331)] = 406324,
  [SMALL_STATE(19332)] = 406338,
  [SMALL_STATE(19333)] = 406352,
  [SMALL_STATE(19334)] = 406366,
  [SMALL_STATE(19335)] = 406380,
  [SMALL_STATE(19336)] = 406394,
  [SMALL_STATE(19337)] = 406408,
  [SMALL_STATE(19338)] = 406422,
  [SMALL_STATE(19339)] = 406436,
  [SMALL_STATE(19340)] = 406450,
  [SMALL_STATE(19341)] = 406464,
  [SMALL_STATE(19342)] = 406478,
  [SMALL_STATE(19343)] = 406492,
  [SMALL_STATE(19344)] = 406506,
  [SMALL_STATE(19345)] = 406520,
  [SMALL_STATE(19346)] = 406534,
  [SMALL_STATE(19347)] = 406548,
  [SMALL_STATE(19348)] = 406562,
  [SMALL_STATE(19349)] = 406576,
  [SMALL_STATE(19350)] = 406590,
  [SMALL_STATE(19351)] = 406604,
  [SMALL_STATE(19352)] = 406618,
  [SMALL_STATE(19353)] = 406632,
  [SMALL_STATE(19354)] = 406646,
  [SMALL_STATE(19355)] = 406660,
  [SMALL_STATE(19356)] = 406674,
  [SMALL_STATE(19357)] = 406688,
  [SMALL_STATE(19358)] = 406702,
  [SMALL_STATE(19359)] = 406716,
  [SMALL_STATE(19360)] = 406730,
  [SMALL_STATE(19361)] = 406744,
  [SMALL_STATE(19362)] = 406758,
  [SMALL_STATE(19363)] = 406772,
  [SMALL_STATE(19364)] = 406786,
  [SMALL_STATE(19365)] = 406800,
  [SMALL_STATE(19366)] = 406814,
  [SMALL_STATE(19367)] = 406828,
  [SMALL_STATE(19368)] = 406842,
  [SMALL_STATE(19369)] = 406856,
  [SMALL_STATE(19370)] = 406870,
  [SMALL_STATE(19371)] = 406884,
  [SMALL_STATE(19372)] = 406898,
  [SMALL_STATE(19373)] = 406912,
  [SMALL_STATE(19374)] = 406926,
  [SMALL_STATE(19375)] = 406940,
  [SMALL_STATE(19376)] = 406954,
  [SMALL_STATE(19377)] = 406968,
  [SMALL_STATE(19378)] = 406982,
  [SMALL_STATE(19379)] = 406996,
  [SMALL_STATE(19380)] = 407010,
  [SMALL_STATE(19381)] = 407024,
  [SMALL_STATE(19382)] = 407038,
  [SMALL_STATE(19383)] = 407052,
  [SMALL_STATE(19384)] = 407066,
  [SMALL_STATE(19385)] = 407080,
  [SMALL_STATE(19386)] = 407094,
  [SMALL_STATE(19387)] = 407108,
  [SMALL_STATE(19388)] = 407122,
  [SMALL_STATE(19389)] = 407136,
  [SMALL_STATE(19390)] = 407150,
  [SMALL_STATE(19391)] = 407164,
  [SMALL_STATE(19392)] = 407178,
  [SMALL_STATE(19393)] = 407192,
  [SMALL_STATE(19394)] = 407206,
  [SMALL_STATE(19395)] = 407220,
  [SMALL_STATE(19396)] = 407234,
  [SMALL_STATE(19397)] = 407248,
  [SMALL_STATE(19398)] = 407262,
  [SMALL_STATE(19399)] = 407276,
  [SMALL_STATE(19400)] = 407290,
  [SMALL_STATE(19401)] = 407304,
  [SMALL_STATE(19402)] = 407318,
  [SMALL_STATE(19403)] = 407332,
  [SMALL_STATE(19404)] = 407346,
  [SMALL_STATE(19405)] = 407360,
  [SMALL_STATE(19406)] = 407374,
  [SMALL_STATE(19407)] = 407388,
  [SMALL_STATE(19408)] = 407402,
  [SMALL_STATE(19409)] = 407416,
  [SMALL_STATE(19410)] = 407430,
  [SMALL_STATE(19411)] = 407444,
  [SMALL_STATE(19412)] = 407458,
  [SMALL_STATE(19413)] = 407472,
  [SMALL_STATE(19414)] = 407486,
  [SMALL_STATE(19415)] = 407500,
  [SMALL_STATE(19416)] = 407514,
  [SMALL_STATE(19417)] = 407528,
  [SMALL_STATE(19418)] = 407542,
  [SMALL_STATE(19419)] = 407556,
  [SMALL_STATE(19420)] = 407570,
  [SMALL_STATE(19421)] = 407584,
  [SMALL_STATE(19422)] = 407598,
  [SMALL_STATE(19423)] = 407612,
  [SMALL_STATE(19424)] = 407626,
  [SMALL_STATE(19425)] = 407640,
  [SMALL_STATE(19426)] = 407654,
  [SMALL_STATE(19427)] = 407668,
  [SMALL_STATE(19428)] = 407682,
  [SMALL_STATE(19429)] = 407696,
  [SMALL_STATE(19430)] = 407710,
  [SMALL_STATE(19431)] = 407724,
  [SMALL_STATE(19432)] = 407738,
  [SMALL_STATE(19433)] = 407752,
  [SMALL_STATE(19434)] = 407766,
  [SMALL_STATE(19435)] = 407780,
  [SMALL_STATE(19436)] = 407794,
  [SMALL_STATE(19437)] = 407808,
  [SMALL_STATE(19438)] = 407822,
  [SMALL_STATE(19439)] = 407836,
  [SMALL_STATE(19440)] = 407850,
  [SMALL_STATE(19441)] = 407864,
  [SMALL_STATE(19442)] = 407878,
  [SMALL_STATE(19443)] = 407892,
  [SMALL_STATE(19444)] = 407906,
  [SMALL_STATE(19445)] = 407920,
  [SMALL_STATE(19446)] = 407934,
  [SMALL_STATE(19447)] = 407948,
  [SMALL_STATE(19448)] = 407962,
  [SMALL_STATE(19449)] = 407976,
  [SMALL_STATE(19450)] = 407990,
  [SMALL_STATE(19451)] = 408004,
  [SMALL_STATE(19452)] = 408018,
  [SMALL_STATE(19453)] = 408032,
  [SMALL_STATE(19454)] = 408046,
  [SMALL_STATE(19455)] = 408060,
  [SMALL_STATE(19456)] = 408074,
  [SMALL_STATE(19457)] = 408088,
  [SMALL_STATE(19458)] = 408102,
  [SMALL_STATE(19459)] = 408116,
  [SMALL_STATE(19460)] = 408130,
  [SMALL_STATE(19461)] = 408144,
  [SMALL_STATE(19462)] = 408158,
  [SMALL_STATE(19463)] = 408172,
  [SMALL_STATE(19464)] = 408186,
  [SMALL_STATE(19465)] = 408200,
  [SMALL_STATE(19466)] = 408214,
  [SMALL_STATE(19467)] = 408228,
  [SMALL_STATE(19468)] = 408242,
  [SMALL_STATE(19469)] = 408256,
  [SMALL_STATE(19470)] = 408270,
  [SMALL_STATE(19471)] = 408284,
  [SMALL_STATE(19472)] = 408298,
  [SMALL_STATE(19473)] = 408312,
  [SMALL_STATE(19474)] = 408326,
  [SMALL_STATE(19475)] = 408340,
  [SMALL_STATE(19476)] = 408354,
  [SMALL_STATE(19477)] = 408368,
  [SMALL_STATE(19478)] = 408382,
  [SMALL_STATE(19479)] = 408396,
  [SMALL_STATE(19480)] = 408410,
  [SMALL_STATE(19481)] = 408424,
  [SMALL_STATE(19482)] = 408438,
  [SMALL_STATE(19483)] = 408452,
  [SMALL_STATE(19484)] = 408466,
  [SMALL_STATE(19485)] = 408480,
  [SMALL_STATE(19486)] = 408494,
  [SMALL_STATE(19487)] = 408508,
  [SMALL_STATE(19488)] = 408522,
  [SMALL_STATE(19489)] = 408536,
  [SMALL_STATE(19490)] = 408550,
  [SMALL_STATE(19491)] = 408564,
  [SMALL_STATE(19492)] = 408578,
  [SMALL_STATE(19493)] = 408592,
  [SMALL_STATE(19494)] = 408606,
  [SMALL_STATE(19495)] = 408620,
  [SMALL_STATE(19496)] = 408634,
  [SMALL_STATE(19497)] = 408648,
  [SMALL_STATE(19498)] = 408662,
  [SMALL_STATE(19499)] = 408676,
  [SMALL_STATE(19500)] = 408690,
  [SMALL_STATE(19501)] = 408704,
  [SMALL_STATE(19502)] = 408718,
  [SMALL_STATE(19503)] = 408732,
  [SMALL_STATE(19504)] = 408746,
  [SMALL_STATE(19505)] = 408760,
  [SMALL_STATE(19506)] = 408774,
  [SMALL_STATE(19507)] = 408788,
  [SMALL_STATE(19508)] = 408802,
  [SMALL_STATE(19509)] = 408816,
  [SMALL_STATE(19510)] = 408830,
  [SMALL_STATE(19511)] = 408844,
  [SMALL_STATE(19512)] = 408858,
  [SMALL_STATE(19513)] = 408872,
  [SMALL_STATE(19514)] = 408886,
  [SMALL_STATE(19515)] = 408900,
  [SMALL_STATE(19516)] = 408914,
  [SMALL_STATE(19517)] = 408928,
  [SMALL_STATE(19518)] = 408942,
  [SMALL_STATE(19519)] = 408956,
  [SMALL_STATE(19520)] = 408970,
  [SMALL_STATE(19521)] = 408984,
  [SMALL_STATE(19522)] = 408998,
  [SMALL_STATE(19523)] = 409012,
  [SMALL_STATE(19524)] = 409026,
  [SMALL_STATE(19525)] = 409040,
  [SMALL_STATE(19526)] = 409054,
  [SMALL_STATE(19527)] = 409068,
  [SMALL_STATE(19528)] = 409082,
  [SMALL_STATE(19529)] = 409096,
  [SMALL_STATE(19530)] = 409110,
  [SMALL_STATE(19531)] = 409124,
  [SMALL_STATE(19532)] = 409138,
  [SMALL_STATE(19533)] = 409152,
  [SMALL_STATE(19534)] = 409166,
  [SMALL_STATE(19535)] = 409180,
  [SMALL_STATE(19536)] = 409194,
  [SMALL_STATE(19537)] = 409208,
  [SMALL_STATE(19538)] = 409222,
  [SMALL_STATE(19539)] = 409236,
  [SMALL_STATE(19540)] = 409250,
  [SMALL_STATE(19541)] = 409264,
  [SMALL_STATE(19542)] = 409278,
  [SMALL_STATE(19543)] = 409292,
  [SMALL_STATE(19544)] = 409306,
  [SMALL_STATE(19545)] = 409320,
  [SMALL_STATE(19546)] = 409334,
  [SMALL_STATE(19547)] = 409348,
  [SMALL_STATE(19548)] = 409362,
  [SMALL_STATE(19549)] = 409376,
  [SMALL_STATE(19550)] = 409390,
  [SMALL_STATE(19551)] = 409404,
  [SMALL_STATE(19552)] = 409418,
  [SMALL_STATE(19553)] = 409432,
  [SMALL_STATE(19554)] = 409446,
  [SMALL_STATE(19555)] = 409460,
  [SMALL_STATE(19556)] = 409474,
  [SMALL_STATE(19557)] = 409488,
  [SMALL_STATE(19558)] = 409502,
  [SMALL_STATE(19559)] = 409516,
  [SMALL_STATE(19560)] = 409530,
  [SMALL_STATE(19561)] = 409544,
  [SMALL_STATE(19562)] = 409558,
  [SMALL_STATE(19563)] = 409572,
  [SMALL_STATE(19564)] = 409586,
  [SMALL_STATE(19565)] = 409600,
  [SMALL_STATE(19566)] = 409614,
  [SMALL_STATE(19567)] = 409628,
  [SMALL_STATE(19568)] = 409642,
  [SMALL_STATE(19569)] = 409656,
  [SMALL_STATE(19570)] = 409670,
  [SMALL_STATE(19571)] = 409684,
  [SMALL_STATE(19572)] = 409698,
  [SMALL_STATE(19573)] = 409712,
  [SMALL_STATE(19574)] = 409726,
  [SMALL_STATE(19575)] = 409740,
  [SMALL_STATE(19576)] = 409754,
  [SMALL_STATE(19577)] = 409768,
  [SMALL_STATE(19578)] = 409782,
  [SMALL_STATE(19579)] = 409796,
  [SMALL_STATE(19580)] = 409810,
  [SMALL_STATE(19581)] = 409824,
  [SMALL_STATE(19582)] = 409838,
  [SMALL_STATE(19583)] = 409852,
  [SMALL_STATE(19584)] = 409866,
  [SMALL_STATE(19585)] = 409880,
  [SMALL_STATE(19586)] = 409894,
  [SMALL_STATE(19587)] = 409908,
  [SMALL_STATE(19588)] = 409922,
  [SMALL_STATE(19589)] = 409936,
  [SMALL_STATE(19590)] = 409950,
  [SMALL_STATE(19591)] = 409964,
  [SMALL_STATE(19592)] = 409978,
  [SMALL_STATE(19593)] = 409992,
  [SMALL_STATE(19594)] = 410006,
  [SMALL_STATE(19595)] = 410020,
  [SMALL_STATE(19596)] = 410034,
  [SMALL_STATE(19597)] = 410048,
  [SMALL_STATE(19598)] = 410062,
  [SMALL_STATE(19599)] = 410076,
  [SMALL_STATE(19600)] = 410090,
  [SMALL_STATE(19601)] = 410104,
  [SMALL_STATE(19602)] = 410118,
  [SMALL_STATE(19603)] = 410132,
  [SMALL_STATE(19604)] = 410146,
  [SMALL_STATE(19605)] = 410160,
  [SMALL_STATE(19606)] = 410174,
  [SMALL_STATE(19607)] = 410188,
  [SMALL_STATE(19608)] = 410202,
  [SMALL_STATE(19609)] = 410216,
  [SMALL_STATE(19610)] = 410230,
  [SMALL_STATE(19611)] = 410244,
  [SMALL_STATE(19612)] = 410258,
  [SMALL_STATE(19613)] = 410272,
  [SMALL_STATE(19614)] = 410286,
  [SMALL_STATE(19615)] = 410300,
  [SMALL_STATE(19616)] = 410314,
  [SMALL_STATE(19617)] = 410318,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19179),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18993),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9821),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16092),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18268),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19427),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18503),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2807),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2738),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3212),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2424),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3209),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11463),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2395),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13970),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13971),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11510),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11588),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11044),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9371),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9686),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13378),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10031),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9867),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9867),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9842),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9896),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9921),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16996),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17002),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17003),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15365),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11575),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11575),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10017),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16249),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, 0, 0),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18516),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19129),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18517),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2827),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2829),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2843),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3696),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2566),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3697),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12347),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2689),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1598),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1601),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13861),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13862),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11550),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11551),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1200),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10892),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9336),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9649),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2768),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13176),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10250),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9828),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9815),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9834),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10364),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17002),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15365),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(241),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19179),
  [189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16340),
  [193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16341),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1724),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13808),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13809),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11532),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11533),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10849),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9345),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9629),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13259),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9905),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9846),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9862),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9921),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16053),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16054),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4106),
  [247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 1, 0, 0),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16277),
  [253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18536),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19140),
  [257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18537),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2701),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2702),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2703),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3700),
  [271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(444),
  [273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2575),
  [275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3703),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7257),
  [279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2090),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(649),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13599),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13478),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11499),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11505),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10950),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4095),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9684),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4334),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6935),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6936),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6937),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4317),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7033),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 1, 0, 0),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17826),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15313),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17893),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 3, 0, 0),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 3, 0, 0),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18106),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15167),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18135),
  [339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4105),
  [341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16172),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18314),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18994),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18315),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2779),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3672),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2540),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3675),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7874),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1566),
  [375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1581),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(652),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13513),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13514),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11564),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11568),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11041),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4096),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9711),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13265),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4289),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6874),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6875),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6877),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4291),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7198),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17797),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15130),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17798),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17884),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15236),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17890),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17887),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15128),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17961),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18157),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15327),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18066),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18207),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15307),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18208),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17758),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15138),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17992),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4117),
  [453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16305),
  [457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18549),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19146),
  [461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18550),
  [463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3726),
  [475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(447),
  [477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2587),
  [479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3729),
  [481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8077),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2223),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2226),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13780),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13781),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11426),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11427),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10984),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4100),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9560),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13184),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4617),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7796),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7913),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7797),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7623),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1643),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1937),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1951),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16293),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18543),
  [543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19143),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18544),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2712),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3713),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2581),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3716),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8198),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2164),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13902),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13903),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11495),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11496),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10952),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4098),
  [593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9701),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13397),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4692),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7268),
  [601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7269),
  [603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7270),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4580),
  [607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7683),
  [609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18196),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15198),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18199),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1660),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4132),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16215),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18459),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19076),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18460),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2805),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3692),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2553),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3693),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8450),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1802),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13721),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13722),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11461),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11462),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(653),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11177),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4101),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9569),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13378),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4854),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7262),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7265),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7267),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4855),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7908),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18185),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15197),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18192),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17806),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15189),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17809),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4128),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16263),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18526),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19135),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18527),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2879),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2881),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3698),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2571),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3699),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8230),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1726),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13937),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13938),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11589),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11590),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1183),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10894),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4099),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9702),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13379),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4714),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7888),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7889),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7890),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4741),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7783),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18133),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15165),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18215),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17885),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15116),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17902),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17828),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15245),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17849),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17721),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15272),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18008),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17981),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15265),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17718),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4122),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16233),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18488),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19103),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18489),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2815),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2816),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3694),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2559),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3695),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8042),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1829),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13789),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13790),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11500),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11503),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10884),
  [875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4097),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9638),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13144),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4549),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7370),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7370),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7371),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7372),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7488),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17844),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15117),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17866),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18103),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15127),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18161),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1784),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1787),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4221),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16199),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18387),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19036),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18388),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2790),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2791),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2792),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1222),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3687),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2547),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3690),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8832),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1667),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(628),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13603),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13604),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11439),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11440),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10977),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4102),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9550),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4929),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8047),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8048),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8049),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4966),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7983),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18087),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15262),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18095),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1699),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2036),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1934),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2366),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17703),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15170),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17747),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17918),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15323),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17922),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18177),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15243),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18183),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 1),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10841),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1778),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2041),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7575),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3350),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2554),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1512),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3059),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13890),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13891),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11561),
  [1089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11562),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [1093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11156),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9338),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9645),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7243),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2549),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9830),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9813),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9832),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(239),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3222),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3223),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [1131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [1151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2530),
  [1155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10815),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [1169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8914),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8054),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [1179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8560),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11594),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8110),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12238),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [1205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8299),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7552),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8602),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8163),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [1229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9146),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11502),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1097),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4821),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16317),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18555),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19149),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18556),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2734),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2736),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2593),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3740),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9293),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2145),
  [1277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2282),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2299),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13495),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13497),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11477),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11479),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10990),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4103),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9653),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13162),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5759),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9036),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9036),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8956),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9053),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9005),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9005),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18059),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15162),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18069),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17680),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15270),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17688),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 1),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8459),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [1349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1834),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_argument_list, 1, 0, 0),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_argument_list, 1, 0, 0),
  [1355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4106),
  [1358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0),
  [1360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(120),
  [1363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16277),
  [1366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18536),
  [1369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19140),
  [1372] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18537),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2701),
  [1378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2702),
  [1381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2703),
  [1384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [1387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1242),
  [1390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3700),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(444),
  [1396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2575),
  [1399] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3703),
  [1402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7257),
  [1405] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(140),
  [1408] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1854),
  [1411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2090),
  [1414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2091),
  [1417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(649),
  [1420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13599),
  [1423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13478),
  [1426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11499),
  [1429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11505),
  [1432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(600),
  [1435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1149),
  [1438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10950),
  [1441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4095),
  [1444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9684),
  [1447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13176),
  [1450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4334),
  [1453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6935),
  [1456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6936),
  [1459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6937),
  [1462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4317),
  [1465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16996),
  [1468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(17002),
  [1471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(17003),
  [1474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(15365),
  [1477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7033),
  [1480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(251),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7906),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12155),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8254),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7291),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(665),
  [1509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4105),
  [1512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(107),
  [1515] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16172),
  [1518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18314),
  [1521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18994),
  [1524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18315),
  [1527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2777),
  [1530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2778),
  [1533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2779),
  [1536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(510),
  [1539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1302),
  [1542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3672),
  [1545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(438),
  [1548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2540),
  [1551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3675),
  [1554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7874),
  [1557] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(126),
  [1560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1566),
  [1563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1581),
  [1566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1583),
  [1569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(652),
  [1572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13513),
  [1575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13514),
  [1578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11564),
  [1581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11568),
  [1584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(602),
  [1587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1215),
  [1590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11041),
  [1593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4096),
  [1596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9711),
  [1599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13265),
  [1602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4289),
  [1605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6874),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6875),
  [1611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(6877),
  [1614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4291),
  [1617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7198),
  [1620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(243),
  [1623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4132),
  [1626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [1629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16215),
  [1632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18459),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19076),
  [1638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18460),
  [1641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2803),
  [1644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2804),
  [1647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2805),
  [1650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(564),
  [1653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1226),
  [1656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3692),
  [1659] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(440),
  [1662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2553),
  [1665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3693),
  [1668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8450),
  [1671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(254),
  [1674] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1489),
  [1677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1800),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1802),
  [1683] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(640),
  [1686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13721),
  [1689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13722),
  [1692] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11461),
  [1695] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11462),
  [1698] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(653),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1203),
  [1704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11177),
  [1707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4101),
  [1710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9569),
  [1713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13378),
  [1716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4854),
  [1719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7262),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7265),
  [1725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7267),
  [1728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4855),
  [1731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7908),
  [1734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(310),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9734),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19044),
  [1741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [1743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16041),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18878),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18561),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18879),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2748),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2749),
  [1755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [1757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4075),
  [1763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [1765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2519),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3550),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10824),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [1773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2692),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2694),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9776),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13818),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13819),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11537),
  [1789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11538),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [1797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10840),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9389),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9483),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19085),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19085),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10477),
  [1809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9807),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9890),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9890),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9853),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9886),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9808),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9474),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10567),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10567),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19044),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10477),
  [1835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [1837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4128),
  [1842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(109),
  [1845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16263),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18526),
  [1851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19135),
  [1854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18527),
  [1857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2879),
  [1860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2880),
  [1863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2881),
  [1866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(503),
  [1869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1238),
  [1872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3698),
  [1875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(443),
  [1878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2571),
  [1881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3699),
  [1884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8230),
  [1887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(260),
  [1890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1726),
  [1893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2016),
  [1896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2020),
  [1899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(624),
  [1902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13937),
  [1905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13938),
  [1908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11589),
  [1911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11590),
  [1914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(633),
  [1917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1183),
  [1920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10894),
  [1923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4099),
  [1926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9702),
  [1929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13379),
  [1932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4714),
  [1935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7888),
  [1938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7889),
  [1941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7890),
  [1944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4741),
  [1947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7783),
  [1950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(282),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18485),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9530),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18496),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18496),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18485),
  [1967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4139),
  [1970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(150),
  [1973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16293),
  [1976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18543),
  [1979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19143),
  [1982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18544),
  [1985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2712),
  [1988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2713),
  [1991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2714),
  [1994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(549),
  [1997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1246),
  [2000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3713),
  [2003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(446),
  [2006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2581),
  [2009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3716),
  [2012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8198),
  [2015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(263),
  [2018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1880),
  [2021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2157),
  [2024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2164),
  [2027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(631),
  [2030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13902),
  [2033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13903),
  [2036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11495),
  [2039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11496),
  [2042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(607),
  [2045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1165),
  [2048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10952),
  [2051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4098),
  [2054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9701),
  [2057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13397),
  [2060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4692),
  [2063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7268),
  [2066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7269),
  [2069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7270),
  [2072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4580),
  [2075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7683),
  [2078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(287),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18722),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10670),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9535),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18736),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18736),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18722),
  [2095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4117),
  [2098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(157),
  [2101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16305),
  [2104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18549),
  [2107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19146),
  [2110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18550),
  [2113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2723),
  [2116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2724),
  [2119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2725),
  [2122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(567),
  [2125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1250),
  [2128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3726),
  [2131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(447),
  [2134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2587),
  [2137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3729),
  [2140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8077),
  [2143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(265),
  [2146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2066),
  [2149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2223),
  [2152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2226),
  [2155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(657),
  [2158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13780),
  [2161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13781),
  [2164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11426),
  [2167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11427),
  [2170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(648),
  [2173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1213),
  [2176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10984),
  [2179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4100),
  [2182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9560),
  [2185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13184),
  [2188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4617),
  [2191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7796),
  [2194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7913),
  [2197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7797),
  [2200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4757),
  [2203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7623),
  [2206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1878),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9543),
  [2219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11926),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [2223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2413),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2414),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1619),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1968),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1971),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18376),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9491),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18380),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18380),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18376),
  [2251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(262),
  [2254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1346),
  [2257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1627),
  [2260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1660),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19407),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9995),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9524),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19480),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19480),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19407),
  [2277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(250),
  [2280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1643),
  [2283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1937),
  [2286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1951),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19099),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1379),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9499),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19106),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19106),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19099),
  [2303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8021),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19256),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10096),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9520),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19258),
  [2319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19258),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19256),
  [2323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8085),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [2327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [2329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18521),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9526),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18663),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18663),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18521),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19316),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5860),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9486),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19370),
  [2353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19370),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19316),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19023),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10261),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9506),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19031),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19031),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19023),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18310),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9518),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18365),
  [2381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18365),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18310),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19102),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9528),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19175),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19175),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19102),
  [2399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18647),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6290),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9484),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18649),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18649),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18647),
  [2413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18289),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10035),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18292),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18292),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18289),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18509),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9500),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18513),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18513),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18509),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18811),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9513),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18817),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18817),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18811),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19087),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9527),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19090),
  [2465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19090),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19087),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19387),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11214),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9514),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19389),
  [2479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19389),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19387),
  [2483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19580),
  [2485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [2489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9534),
  [2491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19105),
  [2493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19105),
  [2495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19580),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18614),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [2501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9515),
  [2505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19335),
  [2507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19335),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18614),
  [2511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18840),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9479),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18853),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18853),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18840),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19463),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11874),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9532),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19496),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19496),
  [2537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19463),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19610),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11329),
  [2543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9488),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19032),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19032),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19610),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18416),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [2557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9512),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18449),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18449),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18416),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19554),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10489),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9529),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19585),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19585),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19554),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18936),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1996),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9477),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18945),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18945),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18936),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19360),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9481),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19374),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19374),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19360),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18930),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11125),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9487),
  [2617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19233),
  [2619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19233),
  [2621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18930),
  [2623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19444),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9489),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19517),
  [2633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19517),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19444),
  [2637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19125),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9492),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19253),
  [2647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19253),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19125),
  [2651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19541),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9494),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19599),
  [2661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19599),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19541),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19337),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9496),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19375),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19375),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19337),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18629),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7909),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9501),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18638),
  [2689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18638),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18629),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19122),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6958),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9503),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19132),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19132),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19122),
  [2707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19057),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16580),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9510),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19097),
  [2717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19097),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19057),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18255),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5487),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9516),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18257),
  [2731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18257),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18255),
  [2735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18444),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7038),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9521),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18447),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18447),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18444),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18653),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9525),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18662),
  [2759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18662),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18653),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18839),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9531),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18842),
  [2773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18842),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18839),
  [2777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18927),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9482),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18929),
  [2787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18929),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18927),
  [2791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19037),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9509),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19039),
  [2801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19039),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19037),
  [2805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19172),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19174),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19174),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19172),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19333),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7062),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9505),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19338),
  [2829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19338),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19333),
  [2833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19448),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8352),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9476),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19450),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19450),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19448),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19539),
  [2849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17998),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9498),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19542),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19542),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19539),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19186),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9522),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18406),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18406),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19186),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18490),
  [2877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9480),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18850),
  [2885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18850),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18490),
  [2889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19238),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9497),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19294),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19294),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19238),
  [2903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19006),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9507),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19263),
  [2913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19263),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19006),
  [2917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18887),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9519),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18897),
  [2927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18897),
  [2929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18887),
  [2931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19412),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [2935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9523),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19416),
  [2941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19416),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19412),
  [2945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18894),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9504),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18965),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18965),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18894),
  [2959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18271),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6691),
  [2963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9485),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18309),
  [2969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18309),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18271),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18667),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7168),
  [2977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9493),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18672),
  [2983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18672),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18667),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18979),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7599),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9502),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18996),
  [2997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18996),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18979),
  [3001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19273),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2376),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9508),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19278),
  [3011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19278),
  [3013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19273),
  [3015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19510),
  [3017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8781),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9517),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19516),
  [3025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19516),
  [3027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19510),
  [3029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19608),
  [3031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7542),
  [3033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [3035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9533),
  [3037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18287),
  [3039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18287),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19608),
  [3043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18241),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [3049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9478),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18264),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18264),
  [3055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18241),
  [3057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19188),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10538),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9490),
  [3065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19195),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19195),
  [3069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19188),
  [3071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1, 0, 0),
  [3073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1, 0, 0),
  [3077] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(281),
  [3080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1404),
  [3083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1784),
  [3086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1787),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2537),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1615),
  [3097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1617),
  [3099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13880),
  [3101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13881),
  [3103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11554),
  [3105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11555),
  [3107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11152),
  [3109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9342),
  [3111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9654),
  [3113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9858),
  [3115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9827),
  [3117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9839),
  [3119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [3121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(273),
  [3124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2181),
  [3127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1344),
  [3130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1347),
  [3133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 2, 0, 4),
  [3135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [3139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(286),
  [3142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1699),
  [3145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2023),
  [3148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2036),
  [3151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(291),
  [3154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1934),
  [3157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2358),
  [3160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2366),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9238),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [3169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4221),
  [3172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(268),
  [3175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16199),
  [3178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18387),
  [3181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19036),
  [3184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18388),
  [3187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2790),
  [3190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2791),
  [3193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2792),
  [3196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(511),
  [3199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1222),
  [3202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3687),
  [3205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(439),
  [3208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2547),
  [3211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3690),
  [3214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8832),
  [3217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(274),
  [3220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1514),
  [3223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1667),
  [3226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1669),
  [3229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(628),
  [3232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13603),
  [3235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13604),
  [3238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11439),
  [3241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11440),
  [3244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(639),
  [3247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1158),
  [3250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10977),
  [3253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4102),
  [3256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9550),
  [3259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13259),
  [3262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4929),
  [3265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8047),
  [3268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8048),
  [3271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8049),
  [3274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4966),
  [3277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7983),
  [3280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(366),
  [3283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [3285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13900),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13901),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11569),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11570),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11162),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9343),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9658),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9838),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9822),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9847),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1907),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2192),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2194),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13909),
  [3327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13910),
  [3329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11573),
  [3331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11574),
  [3333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11165),
  [3335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9341),
  [3337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9662),
  [3339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9849),
  [3341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9826),
  [3343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9855),
  [3345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [3347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4122),
  [3350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(72),
  [3353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16233),
  [3356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18488),
  [3359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19103),
  [3362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18489),
  [3365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2815),
  [3368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2816),
  [3371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2817),
  [3374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(545),
  [3377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1230),
  [3380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3694),
  [3383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [3386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2559),
  [3389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3695),
  [3392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8042),
  [3395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(296),
  [3398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1541),
  [3401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1828),
  [3404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1829),
  [3407] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(608),
  [3410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13789),
  [3413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13790),
  [3416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11500),
  [3419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11503),
  [3422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(598),
  [3425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1255),
  [3428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10884),
  [3431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4097),
  [3434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9638),
  [3437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13144),
  [3440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4549),
  [3443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7370),
  [3446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7370),
  [3449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7371),
  [3452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7372),
  [3455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4665),
  [3458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(17002),
  [3461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(15365),
  [3464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7488),
  [3467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(7488),
  [3470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [3473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(325),
  [3476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8829),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [3480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [3482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [3484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [3486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [3488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1697),
  [3490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(99),
  [3493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(337),
  [3496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1778),
  [3499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2041),
  [3502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2042),
  [3505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [3508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(374),
  [3511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(316),
  [3514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1770),
  [3517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2452),
  [3520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2530),
  [3523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [3525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [3527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2087),
  [3529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2148),
  [3531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [3533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [3535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2165),
  [3537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2180),
  [3539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [3541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2531),
  [3543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [3545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [3549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [3551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2679),
  [3553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [3555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2616),
  [3557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11044),
  [3559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9686),
  [3561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9896),
  [3563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(317),
  [3566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2352),
  [3569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1366),
  [3572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1367),
  [3575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [3577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [3579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [3581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2536),
  [3583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1537),
  [3585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1539),
  [3587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13822),
  [3589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13843),
  [3591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11442),
  [3593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11451),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11025),
  [3597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9340),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9709),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [3603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9742),
  [3605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9733),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9735),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(367),
  [3613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [3615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [3617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9192),
  [3621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3321),
  [3623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2925),
  [3625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9552),
  [3627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8784),
  [3629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2561),
  [3631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3078),
  [3633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [3635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [3637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2946),
  [3639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [3641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [3643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [3645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [3647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [3649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [3651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [3653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [3655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [3659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [3661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [3665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(786),
  [3667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(373),
  [3670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1464),
  [3673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1830),
  [3676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1834),
  [3679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [3681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [3683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [3685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1768),
  [3687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11058),
  [3689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9588),
  [3691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [3693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7572),
  [3695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [3699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [3701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2374),
  [3703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [3705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [3707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8113),
  [3709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [3711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [3713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12258),
  [3715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [3719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4821),
  [3722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(242),
  [3725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(16317),
  [3728] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18555),
  [3731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(19149),
  [3734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(18556),
  [3737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2734),
  [3740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2735),
  [3743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2736),
  [3746] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(553),
  [3749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1254),
  [3752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3739),
  [3755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(445),
  [3758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2593),
  [3761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3740),
  [3764] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9293),
  [3767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(376),
  [3770] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2145),
  [3773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2282),
  [3776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2299),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(577),
  [3782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13495),
  [3785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13497),
  [3788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11477),
  [3791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11479),
  [3794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(576),
  [3797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1286),
  [3800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(10990),
  [3803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(4103),
  [3806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9653),
  [3809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(13162),
  [3812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5759),
  [3815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9036),
  [3818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9036),
  [3821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(8956),
  [3824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9053),
  [3827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(5408),
  [3830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9005),
  [3833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(9005),
  [3836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [3839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(400),
  [3842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7936),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [3846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [3848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [3850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [3852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [3854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2162),
  [3856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1504),
  [3858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [3860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13896),
  [3862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13897),
  [3864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11565),
  [3866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11566),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11082),
  [3870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9337),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [3876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [3878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [3880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [3882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2179),
  [3884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2328),
  [3886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2331),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [3892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [3894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [3896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [3898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [3900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [3902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2253),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8566),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10806),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1000),
  [3922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8168),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [3928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [3930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11490),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(664),
  [3936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7606),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [3940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [3942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8917),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [3948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8302),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [3952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [3954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [3956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2013),
  [3958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1941),
  [3960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1944),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2128),
  [3966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [3968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [3970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13885),
  [3972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13886),
  [3974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11558),
  [3976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11559),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11075),
  [3980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9410),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9605),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10107),
  [3986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10107),
  [3988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10029),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10108),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [3994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [3996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [3998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2112),
  [4000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2160),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2163),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [4008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [4010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [4012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [4014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2389),
  [4016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [4018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1988),
  [4020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [4022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [4026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [4028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [4030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(398),
  [4033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2040),
  [4036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2413),
  [4039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2414),
  [4042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [4046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [4048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(392),
  [4050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [4052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [4058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [4060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [4062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2237),
  [4066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2241),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [4074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1804),
  [4076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [4078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [4080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [4082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2550),
  [4084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1729),
  [4086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1733),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [4098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [4100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [4102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2563),
  [4104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2533),
  [4106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2534),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [4110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [4120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [4124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [4126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [4128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [4130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [4132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [4134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [4136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [4140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [4142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [4144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2681),
  [4146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2683),
  [4148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [4150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2557),
  [4152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2524),
  [4154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2525),
  [4156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [4162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [4166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [4170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [4174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [4178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [4186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [4190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [4194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [4198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [4200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8147),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11156),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9543),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13265),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9830),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9832),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11926),
  [4214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [4216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8855),
  [4218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12205),
  [4220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7928),
  [4222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7426),
  [4224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [4226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [4228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [4230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [4232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [4236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [4240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [4244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [4248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [4252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [4256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [4258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [4260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [4268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9207),
  [4270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8323),
  [4272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11454),
  [4274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10717),
  [4276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7972),
  [4278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8209),
  [4280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7950),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [4290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2380),
  [4292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10826),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [4296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [4298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8860),
  [4300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [4302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [4304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7976),
  [4306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [4310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7560),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [4314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [4316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9191),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [4322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8301),
  [4324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [4326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1108),
  [4328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11465),
  [4330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [4332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [4334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7596),
  [4336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [4340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9210),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [4344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [4346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10785),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [4352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7432),
  [4354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [4356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [4358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11486),
  [4360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [4362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [4364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8112),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [4368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [4370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7953),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8167),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [4380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [4382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7935),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [4386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [4388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12212),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8326),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [4398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [4400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8219),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [4404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [4406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8565),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [4412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 1, 0, 0),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [4418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12244),
  [4420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [4422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [4424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8152),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [4428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(973),
  [4430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8916),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [4434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(663),
  [4436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7295),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [4440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [4442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 1, 0, 0),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [4446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11152),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9654),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13379),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9858),
  [4456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9839),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 1, 0, 0),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [4464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(610),
  [4466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7934),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [4470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [4472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9187),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [4476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [4478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8549),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [4482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [4484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7944),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [4496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10892),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [4500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13176),
  [4502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9828),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9834),
  [4506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10364),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9201),
  [4512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11474),
  [4518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [4522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8256),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [4526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11514),
  [4530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [4532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [4534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8293),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [4538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1100),
  [4540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11525),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [4544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [4546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8294),
  [4548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [4550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [4552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8295),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [4556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1103),
  [4558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8296),
  [4560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [4562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [4564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7915),
  [4566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [4568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [4570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8626),
  [4572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [4574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [4576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10816),
  [4578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [4580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(738),
  [4582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8828),
  [4584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [4586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [4588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8862),
  [4590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [4592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [4594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8863),
  [4596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [4598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [4600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8864),
  [4602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [4604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(659),
  [4606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, 0, 0),
  [4608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8840),
  [4610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [4612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [4614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8317),
  [4616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [4618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [4620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8127),
  [4622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [4624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(967),
  [4626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8543),
  [4628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [4630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [4632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 3, 0, 4),
  [4634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10709),
  [4636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [4638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [4640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10781),
  [4642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [4644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [4646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10699),
  [4648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [4650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(985),
  [4652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10702),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [4656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(986),
  [4658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8101),
  [4660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [4662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [4664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7533),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [4668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [4670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [4672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [4674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7535),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [4678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [4680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7555),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [4684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [4686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10760),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [4690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [4692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7556),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [4698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7297),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [4704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7506),
  [4706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [4708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [4710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9186),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [4716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7522),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [4720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [4722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8202),
  [4724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [4726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [4728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7524),
  [4730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [4732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [4734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8547),
  [4736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [4740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [4742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [4744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7920),
  [4746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [4748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [4750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11449),
  [4752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [4754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [4756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11506),
  [4758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [4760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [4762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8055),
  [4764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [4766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [4768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7402),
  [4770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [4772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [4774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12176),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [4778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1065),
  [4780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8102),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [4784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [4786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8084),
  [4788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [4790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [4792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8103),
  [4794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [4796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [4798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8542),
  [4800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [4802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [4804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8595),
  [4806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [4808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [4810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9147),
  [4812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [4816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8596),
  [4818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [4820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [4822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8597),
  [4824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [4826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [4828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8598),
  [4830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [4832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [4834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9184),
  [4836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(776),
  [4840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9185),
  [4842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [4846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12018),
  [4848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [4850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [4852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [4854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [4856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7963),
  [4858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [4862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12203),
  [4864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [4866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [4868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12204),
  [4870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [4874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8460),
  [4876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [4880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12217),
  [4882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [4884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [4886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12221),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [4892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8089),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [4898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11431),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [4902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [4904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8156),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [4908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [4910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8157),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [4914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [4916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8158),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [4920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8159),
  [4924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [4928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7521),
  [4930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [4932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [4934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18642),
  [4936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [4938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [4940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10245),
  [4942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [4944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11177),
  [4946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9569),
  [4948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7262),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7908),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18707),
  [4960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6078),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19473),
  [4964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18871),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19569),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6881),
  [4976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19429),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19594),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [4984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 3, 0, 0),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18781),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18558),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19567),
  [4996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7729),
  [4998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_row, 1, 0, 0),
  [5000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_row, 1, 0, 0),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18421),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [5006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18434),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19053),
  [5012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [5014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19051),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19445),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11199),
  [5022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19557),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6189),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9760),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18411),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16660),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10179),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18427),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6944),
  [5042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 0),
  [5044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11165),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9662),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13184),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9849),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9855),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18745),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18258),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19066),
  [5066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7068),
  [5068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18995),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19342),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18776),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19582),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17789),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18619),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8979),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18478),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8770),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19192),
  [5094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6628),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18571),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19077),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [5108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11162),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9658),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13397),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9838),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9847),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19410),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11315),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19540),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9923),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19562),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11792),
  [5134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2, 0, 0),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18698),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8384),
  [5140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18368),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5961),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18909),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7275),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19362),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18481),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7353),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10973),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18579),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10418),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18606),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19069),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18333),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18389),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [5186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4132),
  [5189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(98),
  [5192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(16215),
  [5195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(18459),
  [5198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(19076),
  [5201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(18460),
  [5204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2803),
  [5207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2804),
  [5210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2805),
  [5213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(564),
  [5216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(1226),
  [5219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(3692),
  [5222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(440),
  [5225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2553),
  [5228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(3693),
  [5231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(8450),
  [5234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(273),
  [5237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(2181),
  [5240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(1344),
  [5243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(1347),
  [5246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(640),
  [5249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(13721),
  [5252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(13722),
  [5255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(11461),
  [5258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(11462),
  [5261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(653),
  [5264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0),
  [5266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(1203),
  [5269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(11177),
  [5272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4101),
  [5275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(9569),
  [5278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(13378),
  [5281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4854),
  [5284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7262),
  [5287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7265),
  [5290] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7267),
  [5293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(4855),
  [5296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(16996),
  [5299] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(17002),
  [5302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(17003),
  [5305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(15365),
  [5308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(7908),
  [5311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0), SHIFT_REPEAT(393),
  [5314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 2, 0, 0),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18837),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7573),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9892),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [5328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19334),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19524),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18924),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10519),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19366),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18435),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10657),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19600),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11290),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18328),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11621),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19257),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4264),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18518),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11112),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18938),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9435),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19166),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9916),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18721),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18867),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19533),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6040),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18959),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4759),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19402),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9818),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19084),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19359),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19227),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19426),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10080),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6768),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [5432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8843),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10849),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9629),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13259),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9905),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9862),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [5446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8851),
  [5448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8850),
  [5450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11466),
  [5452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7498),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18429),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4243),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7536),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7537),
  [5468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8655),
  [5470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8689),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19378),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10234),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11204),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7918),
  [5482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8694),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7921),
  [5486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7924),
  [5488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7927),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7926),
  [5492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8717),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7635),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [5498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18664),
  [5500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [5502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [5504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7764),
  [5506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7876),
  [5508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7207),
  [5510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7250),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [5514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5572),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [5518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4511),
  [5520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10015),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8594),
  [5524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19229),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9893),
  [5528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [5530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11429),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11542),
  [5534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8599),
  [5536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8600),
  [5538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11595),
  [5540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11464),
  [5542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11472),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [5546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7961),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7965),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7966),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7969),
  [5554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7968),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7977),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [5560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19465),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10173),
  [5564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8034),
  [5568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8040),
  [5570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8041),
  [5572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8050),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10374),
  [5578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10777),
  [5580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7525),
  [5582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8155),
  [5584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11437),
  [5586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11498),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8160),
  [5590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8162),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7557),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7561),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10712),
  [5598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8200),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10715),
  [5604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8203),
  [5606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8204),
  [5608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8208),
  [5610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8207),
  [5612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8541),
  [5614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8220),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10373),
  [5618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19437),
  [5620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [5622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [5624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8237),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8240),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8241),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8246),
  [5632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10347),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4837),
  [5636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18574),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [5644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7379),
  [5646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8553),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8559),
  [5650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9183),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9926),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7404),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [5658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9188),
  [5660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9189),
  [5662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7942),
  [5664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7408),
  [5666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [5668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9198),
  [5670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9202),
  [5672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9203),
  [5674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9206),
  [5676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9205),
  [5678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7945),
  [5680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7946),
  [5682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9215),
  [5684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [5686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19041),
  [5688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6264),
  [5690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [5692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9229),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9232),
  [5696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9233),
  [5698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9239),
  [5700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6401),
  [5704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7949),
  [5706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7948),
  [5708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7421),
  [5710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7420),
  [5712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [5714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11280),
  [5716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19405),
  [5718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [5720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [5722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11303),
  [5724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6285),
  [5726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7954),
  [5728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [5730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [5732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [5734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18367),
  [5736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10242),
  [5738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [5740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [5742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10395),
  [5744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18933),
  [5746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [5748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [5750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7989),
  [5752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11227),
  [5754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18577),
  [5756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9899),
  [5758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [5760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11241),
  [5762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9983),
  [5764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8617),
  [5766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7993),
  [5768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [5770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18922),
  [5772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [5774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [5778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6000),
  [5780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7999),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10384),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19165),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10393),
  [5792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6019),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [5796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10453),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19532),
  [5800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10535),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5308),
  [5808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4530),
  [5810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9965),
  [5812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18651),
  [5814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11174),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9992),
  [5820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11375),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19394),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6066),
  [5834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4453),
  [5836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7436),
  [5838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6099),
  [5840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18554),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6107),
  [5848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4567),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9811),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19328),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9754),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6795),
  [5860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18423),
  [5862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [5864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [5866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [5868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6116),
  [5870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7839),
  [5872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6639),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19428),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11685),
  [5878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [5880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [5882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11895),
  [5884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7849),
  [5886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [5888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18970),
  [5890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [5892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [5894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [5896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5683),
  [5898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8100),
  [5900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7898),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11221),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18569),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11235),
  [5912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5702),
  [5914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7253),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [5918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19073),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10750),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [5924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [5926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10864),
  [5928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9820),
  [5930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8107),
  [5932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19559),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [5942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5717),
  [5944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8109),
  [5946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6172),
  [5948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18609),
  [5950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6178),
  [5956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6152),
  [5958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9802),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11921),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18907),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [5966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11817),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4636),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11024),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8400),
  [5976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18474),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8407),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5755),
  [5986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8124),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10733),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7303),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18605),
  [5994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5770),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8128),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18324),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4864),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7399),
  [6014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8143),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8146),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18836),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5284),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5793),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8145),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19330),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6221),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7603),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19363),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [6052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [6058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8153),
  [6060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7130),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18326),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7142),
  [6070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5855),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10556),
  [6074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19421),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10464),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [6080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5886),
  [6082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18514),
  [6084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6385),
  [6086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [6088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [6090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6559),
  [6092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8182),
  [6094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8185),
  [6096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11646),
  [6098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11663),
  [6100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8186),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8192),
  [6104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11132),
  [6106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11142),
  [6108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10568),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [6114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10680),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6315),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10789),
  [6122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10799),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4772),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4778),
  [6128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10827),
  [6130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10823),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7782),
  [6134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7793),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6852),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10801),
  [6142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [6144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [6146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [6148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [6150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12192),
  [6152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6909),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18750),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [6164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11438),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6622),
  [6168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [6170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12225),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [6174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5187),
  [6176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12226),
  [6178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10790),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7422),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [6184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10793),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10795),
  [6188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [6190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [6192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12171),
  [6194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [6196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10809),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [6204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12178),
  [6206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12179),
  [6208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16714),
  [6210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16768),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12198),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12197),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6991),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7577),
  [6224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12215),
  [6228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [6230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [6232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9439),
  [6234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [6236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [6238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18452),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [6244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12027),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18081),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17682),
  [6250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12030),
  [6252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [6254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9112),
  [6256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12033),
  [6258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8803),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [6262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12046),
  [6264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6479),
  [6266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6517),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9442),
  [6270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10082),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4893),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9994),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11446),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8826),
  [6280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11443),
  [6282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8292),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11544),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8865),
  [6288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8867),
  [6290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8297),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8298),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9884),
  [6296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11489),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [6300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8315),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9761),
  [6304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8318),
  [6306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8319),
  [6308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8322),
  [6310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8321),
  [6312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8838),
  [6314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8327),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10069),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19064),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [6324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8354),
  [6326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8357),
  [6328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8358),
  [6330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8363),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10041),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4662),
  [6336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8842),
  [6338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19327),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [6342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19203),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19522),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18921),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19339),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19161),
  [6366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19612),
  [6370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18984),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10508),
  [6376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18341),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18339),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11200),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19530),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18451),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [6394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18420),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19521),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18668),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10214),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19563),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18712),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19096),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18846),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7574),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9887),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5173),
  [6428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19059),
  [6430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [6432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19592),
  [6434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [6436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19471),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [6440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19130),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6414),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19170),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9918),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11031),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19367),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18580),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16663),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18608),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19372),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4948),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19139),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10707),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5314),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18361),
  [6474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [6476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18450),
  [6478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6945),
  [6480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10152),
  [6482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18741),
  [6484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10870),
  [6486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18584),
  [6488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19393),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18777),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9868),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19537),
  [6508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [6510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18573),
  [6512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6416),
  [6514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19093),
  [6516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7069),
  [6518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18719),
  [6520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [6522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18410),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10292),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19579),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9763),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4305),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18342),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11622),
  [6536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19349),
  [6538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [6540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18347),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9748),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19086),
  [6546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [6548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19552),
  [6550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [6552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2, 0, 0),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18274),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19595),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17790),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18548),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11113),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19436),
  [6568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11316),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19358),
  [6572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [6574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [6576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(650),
  [6578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [6580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11025),
  [6582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9709),
  [6584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13144),
  [6586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9735),
  [6588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9808),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [6592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18657),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9004),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11046),
  [6600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18727),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5910),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19475),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9860),
  [6610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18525),
  [6612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8773),
  [6614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19578),
  [6616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11793),
  [6618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19304),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19126),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10444),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18788),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10365),
  [6630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19296),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18872),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6301),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19371),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [6642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [6644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [6646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(742),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19148),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9475),
  [6656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9475),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18859),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10034),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18645),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9876),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19255),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18852),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18969),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18789),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19033),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8385),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18553),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18615),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6995),
  [6696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18726),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19231),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [6706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [6708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19430),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10081),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19089),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [6720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18378),
  [6722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [6724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18849),
  [6726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9955),
  [6728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [6730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(900),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19145),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10156),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [6740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [6746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19240),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [6754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19025),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7276),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [6762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18856),
  [6766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 3, 0, 0),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [6772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19013),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19368),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [6784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [6786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19070),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18753),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18591),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6462),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18942),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9436),
  [6804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19477),
  [6806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [6808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18237),
  [6810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11291),
  [6812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [6814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18589),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7354),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18588),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10423),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18471),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [6828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19575),
  [6830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18613),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11635),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9746),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18393),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19100),
  [6846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [6848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [6850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18443),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10671),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19500),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6577),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [6860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [6862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10874),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [6866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [6868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [6870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11041),
  [6872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9711),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [6876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6877),
  [6878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [6880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [6882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10977),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9550),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8047),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8049),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7983),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9936),
  [6908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [6912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10306),
  [6916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10350),
  [6918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11293),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [6922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [6924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10318),
  [6926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [6928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [6930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [6932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10348),
  [6934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10315),
  [6936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [6938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [6940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [6942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [6944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10587),
  [6946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [6948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [6950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10674),
  [6952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [6954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3552),
  [6956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11074),
  [6958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10009),
  [6960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18483),
  [6962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9421),
  [6964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3769),
  [6966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [6968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [6970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [6972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4887),
  [6974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10667),
  [6976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18988),
  [6978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10012),
  [6980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9430),
  [6982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [6984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10220),
  [6986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [6988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4343),
  [6990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10271),
  [6992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [6994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [6996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [6998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [7000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [7002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [7004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [7006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [7008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10221),
  [7010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5006),
  [7012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [7014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10223),
  [7016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10222),
  [7018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [7020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [7022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9420),
  [7024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [7026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [7028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10228),
  [7030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10229),
  [7032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10265),
  [7034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10146),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10433),
  [7040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [7044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [7050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11278),
  [7058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11281),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6294),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10554),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11379),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4284),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11302),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11305),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [7096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [7098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9431),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [7104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9415),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [7110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [7116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10397),
  [7118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9780),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5944),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6302),
  [7130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6451),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10327),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5947),
  [7144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9422),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9961),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11208),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11212),
  [7154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11232),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10517),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [7160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9441),
  [7162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11238),
  [7164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5625),
  [7166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [7168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11240),
  [7170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11242),
  [7172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5626),
  [7174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11257),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9891),
  [7180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [7182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [7184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10330),
  [7186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5977),
  [7188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9934),
  [7194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10361),
  [7196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [7198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10367),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10362),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [7204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5991),
  [7206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10376),
  [7208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10377),
  [7210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [7212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [7214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10279),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6055),
  [7218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9877),
  [7220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10415),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10520),
  [7224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10385),
  [7226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [7228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9456),
  [7230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9864),
  [7232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10052),
  [7234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10532),
  [7236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [7238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9869),
  [7240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10391),
  [7242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10401),
  [7244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9861),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9881),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9885),
  [7250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10481),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9894),
  [7256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10412),
  [7262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10454),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6033),
  [7268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5640),
  [7270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10494),
  [7272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [7274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5641),
  [7276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10512),
  [7278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10537),
  [7280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5644),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10471),
  [7286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [7288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5645),
  [7290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6791),
  [7292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [7294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9960),
  [7296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9962),
  [7298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9966),
  [7300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [7302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [7304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [7306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [7308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5654),
  [7310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5653),
  [7312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9991),
  [7314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9993),
  [7316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [7318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [7320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10000),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10871),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [7326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6634),
  [7328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18967),
  [7330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6056),
  [7336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [7338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [7340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6063),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [7346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4944),
  [7348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [7350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [7352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10018),
  [7354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [7356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [7358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [7360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [7366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [7368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [7370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [7372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10894),
  [7374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [7376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7888),
  [7378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7890),
  [7380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7783),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10873),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6095),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [7396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [7398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6104),
  [7400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10876),
  [7402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10875),
  [7404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [7406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9752),
  [7408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [7410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4647),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10878),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10880),
  [7416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [7418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [7420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10882),
  [7422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11308),
  [7424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [7426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [7428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [7430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [7432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [7434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [7436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10092),
  [7438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [7440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [7442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [7444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [7446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [7448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [7450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [7452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6805),
  [7454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9915),
  [7456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [7458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5671),
  [7464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11218),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9753),
  [7470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9788),
  [7472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [7474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6629),
  [7476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [7478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [7480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [7482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10260),
  [7484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9749),
  [7486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [7488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10296),
  [7490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6656),
  [7492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [7494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9758),
  [7500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6671),
  [7502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [7504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [7506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6464),
  [7508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11657),
  [7510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [7512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [7514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [7516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [7518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9762),
  [7520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [7522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [7524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [7526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [7528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [7532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11190),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [7536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5681),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9750),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5685),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6169),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11670),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11217),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11219),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11222),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11682),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11228),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11686),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11684),
  [7582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11230),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11243),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11614),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11616),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11248),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11675),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11916),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4342),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10821),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8397),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11936),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [7646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [7648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [7650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [7652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [7654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [7660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [7662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [7664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [7666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7300),
  [7668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10697),
  [7670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6168),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8364),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10716),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6175),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10714),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10694),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10810),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10814),
  [7694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6182),
  [7696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [7698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10740),
  [7700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [7702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [7704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11899),
  [7706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11917),
  [7708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11922),
  [7710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [7712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [7714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11237),
  [7716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11827),
  [7718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [7720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [7722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11780),
  [7724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11833),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4175),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5097),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5098),
  [7732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11935),
  [7734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [7736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [7738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [7740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [7742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10626),
  [7744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [7746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [7748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [7750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10950),
  [7752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9684),
  [7754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [7756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8396),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8398),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10579),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8401),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9810),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8404),
  [7782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [7784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [7786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8406),
  [7788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8408),
  [7790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [7792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [7794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [7796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [7798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [7800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [7802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [7804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [7806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7296),
  [7808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [7810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7304),
  [7812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [7814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10681),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7314),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7317),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7334),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10574),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7378),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [7864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [7872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [7878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10513),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7410),
  [7888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7127),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [7902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [7904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [7906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7457),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10516),
  [7912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [7916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [7918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [7920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [7922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [7924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7028),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5883),
  [7934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5817),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [7942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [7948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [7954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10952),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9701),
  [7966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [7968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [7970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [7972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [7974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [7976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4916),
  [7978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [7980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [7982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5841),
  [7984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [7986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11641),
  [7988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [7990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7598),
  [7992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7601),
  [7994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7604),
  [7996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [8000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10493),
  [8002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7614),
  [8004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [8006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [8008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [8010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7659),
  [8012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [8016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7670),
  [8018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [8020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [8022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11129),
  [8024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [8026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [8028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [8030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7131),
  [8032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11654),
  [8034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [8036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [8038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [8040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [8042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [8044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7143),
  [8046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [8048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [8050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [8052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [8054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5857),
  [8056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [8058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [8060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5882),
  [8062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [8064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5887),
  [8066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11134),
  [8068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6547),
  [8070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9986),
  [8072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [8074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [8076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6548),
  [8078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [8080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [8082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5897),
  [8084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [8086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [8088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [8090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [8092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [8094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10652),
  [8096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [8098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9466),
  [8100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [8102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [8104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11639),
  [8106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11642),
  [8108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4308),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11650),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [8114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11660),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [8120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11662),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11664),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [8130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11668),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11128),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11130),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [8144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11133),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [8150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11138),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6432),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11141),
  [8160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11143),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [8166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11147),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6441),
  [8170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9451),
  [8176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5920),
  [8182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [8184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [8186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4752),
  [8188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [8190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [8192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9438),
  [8194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [8196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [8198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [8200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9449),
  [8202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [8204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [8206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [8208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [8210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [8212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6317),
  [8214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [8216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6320),
  [8218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6322),
  [8220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10548),
  [8222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [8224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [8226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10038),
  [8228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [8230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [8232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [8234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [8236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11272),
  [8238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [8240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7930),
  [8242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [8244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [8246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [8248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [8250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7771),
  [8252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [8254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7785),
  [8256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [8258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6799),
  [8260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7790),
  [8262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7792),
  [8264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7800),
  [8266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7854),
  [8268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [8270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6844),
  [8272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [8274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [8276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [8278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6863),
  [8284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10984),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [8298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7796),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7797),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4757),
  [8304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7623),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [8308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [8310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [8312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [8314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [8318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [8324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [8326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [8328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5419),
  [8330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [8332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [8334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [8336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [8338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [8340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [8342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7352),
  [8344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6904),
  [8346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6906),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [8362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [8364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [8366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [8368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [8370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7779),
  [8372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [8374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [8376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [8378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [8380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10440),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [8384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9444),
  [8386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [8390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10094),
  [8392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [8394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11225),
  [8398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [8402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [8404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10123),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7259),
  [8412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7391),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7474),
  [8422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [8424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7678),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6226),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [8430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [8432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [8434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10132),
  [8436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6756),
  [8438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [8440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [8442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [8444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [8446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10429),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6769),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10498),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16706),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10134),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [8462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10068),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [8474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5477),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10488),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10496),
  [8480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9443),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6225),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6227),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16609),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10492),
  [8500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6433),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16704),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16708),
  [8512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16716),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [8516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16759),
  [8518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16762),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16775),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16782),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7550),
  [8526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6974),
  [8528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [8530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6979),
  [8532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [8534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6174),
  [8536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [8538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [8540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6996),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [8544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7115),
  [8546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [8548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [8550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7564),
  [8554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [8556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [8558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7579),
  [8560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7588),
  [8562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [8564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [8566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [8568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [8570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [8572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11992),
  [8574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7134),
  [8576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [8578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3210),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [8582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18046),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [8588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [8590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [8596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9018),
  [8604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18042),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18054),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18096),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18112),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8403),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18170),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17678),
  [8618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17689),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17719),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8792),
  [8624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9914),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9015),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9019),
  [8630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9034),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9038),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9099),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9113),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9132),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10105),
  [8646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8791),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [8652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8804),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8811),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7313),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8827),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8833),
  [8664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11285),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8852),
  [8670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19067),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6477),
  [8676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6495),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6518),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7394),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7018),
  [8692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5821),
  [8694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7613),
  [8696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7138),
  [8698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5892),
  [8700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11659),
  [8702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11137),
  [8704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5926),
  [8706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [8708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [8710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7789),
  [8712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6856),
  [8714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [8716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [8718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6913),
  [8720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6696),
  [8722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [8724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [8726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [8728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [8730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [8732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16756),
  [8734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [8736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [8738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [8740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18163),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9096),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9943),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11340),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9958),
  [8756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9947),
  [8758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10020),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10025),
  [8766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10127),
  [8768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [8770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9920),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11210),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18382),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9879),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9773),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9800),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9812),
  [8784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9458),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9902),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9787),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9866),
  [8792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9873),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9777),
  [8796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10036),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9791),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18758),
  [8802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9900),
  [8804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9870),
  [8806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [8808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9797),
  [8810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [8812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [8814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9755),
  [8816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [8818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [8820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9872),
  [8822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [8824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18592),
  [8826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [8828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [8830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [8832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [8834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10049),
  [8836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [8838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [8840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [8842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4834),
  [8844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10217),
  [8846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [8848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9909),
  [8850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [8852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [8854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9470),
  [8856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [8858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [8860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9471),
  [8862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [8864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [8866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [8868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [8870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [8872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [8874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [8876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [8880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [8894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [8898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(4994),
  [8901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(974),
  [8904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(644),
  [8907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1194),
  [8910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10978),
  [8913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9562),
  [8916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(13248),
  [8919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5706),
  [8922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5907),
  [8925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(16996),
  [8928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(17002),
  [8931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(17003),
  [8934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(15365),
  [8937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10567),
  [8940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5031),
  [8943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1099),
  [8946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(626),
  [8949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1219),
  [8952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10890),
  [8955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9553),
  [8958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5491),
  [8961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5575),
  [8964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5287),
  [8967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1033),
  [8970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(591),
  [8973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1150),
  [8976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(11003),
  [8979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9700),
  [8982] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6205),
  [8985] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6187),
  [8988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5072),
  [8991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(801),
  [8994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(616),
  [8997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1227),
  [9000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10917),
  [9003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9687),
  [9006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6268),
  [9009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5958),
  [9012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5201),
  [9015] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(835),
  [9018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(647),
  [9021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1172),
  [9024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10932),
  [9027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9556),
  [9030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(13248),
  [9033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5957),
  [9036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6037),
  [9039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(17002),
  [9042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(15365),
  [9045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10567),
  [9048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5230),
  [9051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(888),
  [9054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(609),
  [9057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1182),
  [9060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10965),
  [9063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9572),
  [9066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6074),
  [9069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6156),
  [9072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5261),
  [9075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(982),
  [9078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(646),
  [9081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1202),
  [9084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10983),
  [9087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9631),
  [9090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6139),
  [9093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6298),
  [9096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(5796),
  [9099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(706),
  [9102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(588),
  [9105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1152),
  [9108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10900),
  [9111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9708),
  [9114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6380),
  [9117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6409),
  [9120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9895),
  [9123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(771),
  [9126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(656),
  [9129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1223),
  [9132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10879),
  [9135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9689),
  [9138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10129),
  [9141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(10125),
  [9144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6347),
  [9147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1048),
  [9150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(595),
  [9153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(1162),
  [9156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(11011),
  [9159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(9536),
  [9162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(7032),
  [9165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(6939),
  [9168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(4994),
  [9171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [9173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(974),
  [9176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(644),
  [9179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1194),
  [9182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10978),
  [9185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9562),
  [9188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(13248),
  [9191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5706),
  [9194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5907),
  [9197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(16996),
  [9200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(17002),
  [9203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(17003),
  [9206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(15365),
  [9209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10567),
  [9212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [9214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5031),
  [9217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1099),
  [9220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(626),
  [9223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1219),
  [9226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10890),
  [9229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9553),
  [9232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5491),
  [9235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5575),
  [9238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5287),
  [9241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1033),
  [9244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(591),
  [9247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1150),
  [9250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(11003),
  [9253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9700),
  [9256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6205),
  [9259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6187),
  [9262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5261),
  [9265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(982),
  [9268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(646),
  [9271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1202),
  [9274] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10983),
  [9277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9631),
  [9280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6139),
  [9283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6298),
  [9286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5230),
  [9289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(888),
  [9292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(609),
  [9295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1182),
  [9298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10965),
  [9301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9572),
  [9304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6074),
  [9307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6156),
  [9310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5201),
  [9313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(835),
  [9316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(647),
  [9319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1172),
  [9322] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10932),
  [9325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9556),
  [9328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(13248),
  [9331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5957),
  [9334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6037),
  [9337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(17002),
  [9340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(15365),
  [9343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10567),
  [9346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5072),
  [9349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(801),
  [9352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(616),
  [9355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1227),
  [9358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10917),
  [9361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9687),
  [9364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6268),
  [9367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5958),
  [9370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(5796),
  [9373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(706),
  [9376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(588),
  [9379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1152),
  [9382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(10900),
  [9385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9708),
  [9388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6380),
  [9391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6409),
  [9394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6347),
  [9397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1048),
  [9400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(595),
  [9403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(1162),
  [9406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(11011),
  [9409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9536),
  [9412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(7032),
  [9415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(6939),
  [9418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4116),
  [9420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4422),
  [9422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4466),
  [9424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4500),
  [9426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4369),
  [9428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4458),
  [9430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4235),
  [9432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17634),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15304),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18204),
  [9440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4111),
  [9442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4265),
  [9444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4295),
  [9446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4483),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [9450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4468),
  [9452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4144),
  [9454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4484),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17453),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15333),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17792),
  [9462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4238),
  [9464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4517),
  [9466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4682),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [9470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4673),
  [9472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [9478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4578),
  [9480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4357),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4682),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17591),
  [9490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15228),
  [9492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18172),
  [9494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4241),
  [9496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [9498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4802),
  [9500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [9502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4743),
  [9504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [9506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4469),
  [9508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17580),
  [9512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15238),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17757),
  [9516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4239),
  [9518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4575),
  [9520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [9522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [9524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4720),
  [9526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4724),
  [9528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [9530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4726),
  [9532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17075),
  [9534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15297),
  [9536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17764),
  [9538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4242),
  [9540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4796),
  [9542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4516),
  [9544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4685),
  [9546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4669),
  [9548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4810),
  [9550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4477),
  [9552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [9554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17139),
  [9556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15346),
  [9558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17781),
  [9560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4228),
  [9562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4684),
  [9564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4581),
  [9566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4550),
  [9568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4670),
  [9570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4727),
  [9572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [9574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4730),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17577),
  [9578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15174),
  [9580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18155),
  [9582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4365),
  [9584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5022),
  [9586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4960),
  [9588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [9590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [9592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [9594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4829),
  [9596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5021),
  [9598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17592),
  [9600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15290),
  [9602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18184),
  [9604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5009),
  [9606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5443),
  [9608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5546),
  [9610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [9612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5871),
  [9614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5859),
  [9616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [9618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [9620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5539),
  [9622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5245),
  [9624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [9626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [9628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5859),
  [9630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17564),
  [9632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15181),
  [9634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17827),
  [9636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2732),
  [9638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16401),
  [9640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16402),
  [9642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [9644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [9646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2802),
  [9648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2847),
  [9650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16222),
  [9652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16223),
  [9654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [9656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2773),
  [9658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16271),
  [9660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16272),
  [9662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_expression, 2, 0, 0),
  [9664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_expression, 2, 0, 0),
  [9666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [9668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2826),
  [9670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16478),
  [9672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16479),
  [9674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2786),
  [9676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16405),
  [9678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16406),
  [9680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 3, 0, 0),
  [9682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [9684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 3, 0, 0),
  [9686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [9688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2709),
  [9690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16348),
  [9692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16349),
  [9694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2710),
  [9696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_broadcast_call_expression, 4, 0, 0),
  [9698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [9700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_broadcast_call_expression, 4, 0, 0),
  [9702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 5, 0, 0),
  [9704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 5, 0, 0),
  [9706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, 0, 7),
  [9708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, 0, 7),
  [9710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 3, 0, 0),
  [9712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 3, 0, 0),
  [9714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation_expression, 2, 0, 0),
  [9716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_expression, 2, 0, 0),
  [9718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2728),
  [9720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2699),
  [9722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2823),
  [9724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [9726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2, 0, 0),
  [9728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 2, 0, 0),
  [9730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer_literal, 1, 0, 0),
  [9732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4248),
  [9734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer_literal, 1, 0, 0),
  [9736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [9738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 0),
  [9740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 3, 0, 0),
  [9742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [9744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, 0, 5),
  [9746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [9748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [9750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [9752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 0),
  [9754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4, 0, 0),
  [9756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2, 0, 0),
  [9758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 5),
  [9760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, 0, 0),
  [9762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 4, 0, 0),
  [9764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4359),
  [9766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14204),
  [9768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9474),
  [9770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17673),
  [9772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15306),
  [9774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18206),
  [9776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16330),
  [9778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16331),
  [9780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 4, 0, 11),
  [9782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 4, 0, 11),
  [9784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 4, 0, 11),
  [9786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 4, 0, 11),
  [9788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [9790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 0),
  [9792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5, 0, 0),
  [9794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [9796] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 5, 0, 11),
  [9798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 5, 0, 11),
  [9800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 5, 0, 11),
  [9802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 5, 0, 11),
  [9804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2700),
  [9806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, 0, 0),
  [9808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 0),
  [9810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 10),
  [9812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 10),
  [9814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, 0, 5),
  [9816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, 0, 5),
  [9818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 10),
  [9820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 10),
  [9822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 0),
  [9824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, 0, 5),
  [9826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, 0, 5),
  [9828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, 0, 10),
  [9830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, 0, 10),
  [9832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 6, 0, 0),
  [9834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 6, 0, 0),
  [9836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 7, 0, 0),
  [9838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 7, 0, 0),
  [9840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [9842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14205),
  [9844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4403),
  [9846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14164),
  [9848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17795),
  [9850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15126),
  [9852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17796),
  [9854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [9856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14196),
  [9858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2721),
  [9860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [9862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [9864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [9866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [9868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16184),
  [9870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16185),
  [9872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [9874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2830),
  [9876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [9878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4460),
  [9880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9895),
  [9882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [9884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [9886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [9888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10879),
  [9890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9689),
  [9892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13248),
  [9894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10129),
  [9896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10125),
  [9898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 5, 0, 0),
  [9900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 5, 0, 0),
  [9902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4746),
  [9904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14158),
  [9906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18223),
  [9908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15264),
  [9910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18226),
  [9912] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float_literal, 2, 0, 0),
  [9914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float_literal, 2, 0, 0),
  [9916] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 3, 0, 0),
  [9918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 3, 0, 0),
  [9920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 3, 0, 0),
  [9922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 3, 0, 0),
  [9924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4735),
  [9926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_expression, 3, 0, 0),
  [9928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_expression, 3, 0, 0),
  [9930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [9932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4645),
  [9934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14115),
  [9936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18166),
  [9938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15188),
  [9940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18171),
  [9942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [9944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4842),
  [9946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14230),
  [9948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17865),
  [9950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15158),
  [9952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17947),
  [9954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 3, 0, 0),
  [9956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 3, 0, 0),
  [9958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__syntactic_operator, 1, 0, 0),
  [9960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__syntactic_operator, 1, 0, 0),
  [9962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parametrized_type_expression, 3, 0, 0),
  [9964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parametrized_type_expression, 3, 0, 0),
  [9966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1980),
  [9968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4620),
  [9970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14189),
  [9972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17785),
  [9974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15154),
  [9976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17825),
  [9978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [9980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1, 0, 0),
  [9982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__string, 1, 0, 0),
  [9984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__string, 1, 0, 0),
  [9986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__array, 1, 0, 0),
  [9988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__array, 1, 0, 0),
  [9990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [9992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [9994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_literal, 3, 0, 0),
  [9996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_literal, 3, 0, 0),
  [9998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14221),
  [10000] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 2, 0, 0),
  [10002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 2, 0, 0),
  [10004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 2, 0, 0),
  [10006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 2, 0, 0),
  [10008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14132),
  [10010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [10012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [10014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_command_literal, 2, 0, 0),
  [10016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_command_literal, 2, 0, 0),
  [10018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 3, 0, 0),
  [10020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 3, 0, 0),
  [10022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2760),
  [10024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14232),
  [10026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2888),
  [10028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 4, 0, 0),
  [10030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 4, 0, 0),
  [10032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comprehension_expression, 4, 0, 0),
  [10034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comprehension_expression, 4, 0, 0),
  [10036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 4, 0, 0),
  [10038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 4, 0, 0),
  [10040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_curly_expression, 4, 0, 0),
  [10042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_curly_expression, 4, 0, 0),
  [10044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 5, 0, 0),
  [10046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 5, 0, 0),
  [10048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comprehension_expression, 5, 0, 0),
  [10050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comprehension_expression, 5, 0, 0),
  [10052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector_expression, 5, 0, 0),
  [10054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector_expression, 5, 0, 0),
  [10056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_matrix_expression, 5, 0, 0),
  [10058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_matrix_expression, 5, 0, 0),
  [10060] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 5, 0, 16),
  [10062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 5, 0, 16),
  [10064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 5, 0, 16),
  [10066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 5, 0, 16),
  [10068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [10070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 6, 0, 0),
  [10072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 6, 0, 0),
  [10074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 6, 0, 0),
  [10076] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_string_literal, 6, 0, 19),
  [10078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_string_literal, 6, 0, 19),
  [10080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefixed_command_literal, 6, 0, 19),
  [10082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefixed_command_literal, 6, 0, 19),
  [10084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4586),
  [10086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_adjoint_expression, 2, 0, 0),
  [10088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_adjoint_expression, 2, 0, 0),
  [10090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [10092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2705),
  [10094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [10096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [10098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1620),
  [10100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4731),
  [10102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 4, 0, 0),
  [10104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 4, 0, 0),
  [10106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 4, 0, 0),
  [10108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 4, 0, 0),
  [10110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1758),
  [10112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2195),
  [10114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14102),
  [10116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_expression, 5, 0, 15),
  [10118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_expression, 5, 0, 15),
  [10120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2793),
  [10122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_broadcast_call_expression, 5, 0, 0),
  [10124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_broadcast_call_expression, 5, 0, 0),
  [10126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [10128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 3, 0, 0),
  [10130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 3, 0, 0),
  [10132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2863),
  [10134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_float_literal, 1, 0, 0),
  [10136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_float_literal, 1, 0, 0),
  [10138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_macrocall_expression, 6, 0, 0),
  [10140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_macrocall_expression, 6, 0, 0),
  [10142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_clause, 4, 0, 0),
  [10144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_clause, 4, 0, 0),
  [10146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4797),
  [10148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [10150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4812),
  [10152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__assignment_operator, 1, 0, 0),
  [10154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__assignment_operator, 1, 0, 0),
  [10156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16394),
  [10158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16395),
  [10160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2876),
  [10162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16490),
  [10164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16491),
  [10166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4630),
  [10168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14198),
  [10170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18175),
  [10172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15230),
  [10174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18176),
  [10176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4993),
  [10178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14116),
  [10180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17715),
  [10182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15301),
  [10184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17976),
  [10186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2753),
  [10188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16496),
  [10190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16497),
  [10192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [10194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [10196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14148),
  [10198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2825),
  [10200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2878),
  [10202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14182),
  [10204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2775),
  [10206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2831),
  [10208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1593),
  [10210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [10212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5004),
  [10214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_signature, 1, 0, 0),
  [10216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 1, 0, 0),
  [10218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16207),
  [10220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16208),
  [10222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1805),
  [10224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14104),
  [10226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16333),
  [10228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16334),
  [10230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2765),
  [10232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16484),
  [10234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16485),
  [10236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [10238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16502),
  [10240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16503),
  [10242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16448),
  [10244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16449),
  [10246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1245),
  [10248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14137),
  [10250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10741),
  [10252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [10254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [10256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [10258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10946),
  [10260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9542),
  [10262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13248),
  [10264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11255),
  [10266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11191),
  [10268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [10270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2832),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16441),
  [10274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16442),
  [10276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16528),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16529),
  [10282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16466),
  [10286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16467),
  [10288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1275),
  [10290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [10292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [10294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [10296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2846),
  [10298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5234),
  [10300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10322),
  [10302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [10304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [10306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [10308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11084),
  [10310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9610),
  [10312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10629),
  [10314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10679),
  [10316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [10318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11086),
  [10320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9611),
  [10322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [10324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [10326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14235),
  [10328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_expression, 3, 0, 0),
  [10330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17783),
  [10332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15237),
  [10334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17793),
  [10336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [10338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [10340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14154),
  [10342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18050),
  [10344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15156),
  [10346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18058),
  [10348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16417),
  [10350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16418),
  [10352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16382),
  [10354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16383),
  [10356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [10358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_tuple_expression, 2, 0, 0), REDUCE(sym_argument_list, 2, 0, 0),
  [10361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [10363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5317),
  [10365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14155),
  [10367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18034),
  [10369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15216),
  [10371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18036),
  [10373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [10375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11102),
  [10377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9626),
  [10379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16384),
  [10381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16385),
  [10383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [10385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1273),
  [10387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5735),
  [10389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16363),
  [10391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16364),
  [10393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_tuple_expression, 3, 0, 0), REDUCE(sym_argument_list, 3, 0, 0),
  [10396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16474),
  [10398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16475),
  [10400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14219),
  [10402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16510),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16511),
  [10406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0), REDUCE(sym_argument_list, 3, 0, 0),
  [10409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [10411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11077),
  [10413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9598),
  [10415] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_head, 1, 0, 0),
  [10417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14180),
  [10419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [10421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_head, 1, 0, 0),
  [10423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_tuple_expression, 5, 0, 0), REDUCE(sym_argument_list, 5, 0, 0),
  [10426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5486),
  [10428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5494),
  [10430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5498),
  [10432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5537),
  [10434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [10436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5541),
  [10438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5545),
  [10440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_typed_expression, 2, 0, 0),
  [10442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5551),
  [10444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11094),
  [10446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9621),
  [10448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_tuple_expression, 4, 0, 0), REDUCE(sym_argument_list, 4, 0, 0),
  [10451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parenthesized_expression, 4, 0, 0), REDUCE(sym_argument_list, 4, 0, 0),
  [10454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0), REDUCE(sym_argument_list, 3, 0, 5),
  [10457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5951),
  [10459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6028),
  [10461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5956),
  [10463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6036),
  [10465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6138),
  [10467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16354),
  [10469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16355),
  [10471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5941),
  [10473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14233),
  [10475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17771),
  [10477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15210),
  [10479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17773),
  [10481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10859),
  [10483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9712),
  [10485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5379),
  [10487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14203),
  [10489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18168),
  [10491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15280),
  [10493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18179),
  [10495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [10497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5777),
  [10499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14129),
  [10501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18100),
  [10503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15115),
  [10505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18130),
  [10507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11060),
  [10509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9579),
  [10511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5799),
  [10513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14212),
  [10515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17761),
  [10517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15148),
  [10519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17762),
  [10521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5618),
  [10523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14220),
  [10525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_typed_expression, 2, 0, 0),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17856),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15266),
  [10531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17911),
  [10533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11062),
  [10535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9580),
  [10537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_juxtaposition_expression, 2, 0, 0),
  [10539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_juxtaposition_expression, 2, 0, 0),
  [10541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5807),
  [10543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14171),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17939),
  [10547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15319),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17943),
  [10551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5872),
  [10553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14185),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18080),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15343),
  [10559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18086),
  [10561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [10563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6044),
  [10565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14124),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17870),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15342),
  [10571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17882),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16391),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16392),
  [10577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 0),
  [10579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 0),
  [10581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6123),
  [10583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14153),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17886),
  [10587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15205),
  [10589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17888),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16542),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16543),
  [10595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6196),
  [10597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14231),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17776),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15284),
  [10603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17803),
  [10605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6130),
  [10607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14199),
  [10609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17934),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15140),
  [10613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17935),
  [10615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6249),
  [10617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14138),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18065),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15287),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18070),
  [10625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5963),
  [10627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14165),
  [10629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17875),
  [10631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15142),
  [10633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17876),
  [10635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_identifier, 2, 0, 0),
  [10637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14922),
  [10639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_identifier, 2, 0, 0),
  [10641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6373),
  [10643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16494),
  [10645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16495),
  [10647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14547),
  [10649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [10651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16522),
  [10653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16523),
  [10655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16482),
  [10657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16483),
  [10659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6565),
  [10661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6686),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16439),
  [10665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16440),
  [10667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14509),
  [10669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14378),
  [10671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [10673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6446),
  [10675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14183),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17746),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15278),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18144),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16526),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16527),
  [10687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11079),
  [10689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9599),
  [10691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16492),
  [10693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16493),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16446),
  [10697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16447),
  [10699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14636),
  [10701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16388),
  [10703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16389),
  [10705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16500),
  [10707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16501),
  [10709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14722),
  [10711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14461),
  [10713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6675),
  [10715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14699),
  [10717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6700),
  [10719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6738),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16524),
  [10723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16525),
  [10725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7166),
  [10727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_path, 2, 0, 0),
  [10729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14391),
  [10731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_path, 2, 0, 0),
  [10733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6931),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16498),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16499),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16444),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16445),
  [10743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [10745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6726),
  [10747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 1, 0, 0),
  [10749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11806),
  [10751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13525),
  [10753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11607),
  [10755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, 0, 0),
  [10757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__importable, 1, 0, 0),
  [10759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__importable, 1, 0, 0),
  [10761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exportable, 1, 0, 0),
  [10763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exportable, 1, 0, 0),
  [10765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11951),
  [10767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13542),
  [10769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11728),
  [10771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6648),
  [10773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14163),
  [10775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17829),
  [10777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15268),
  [10779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17831),
  [10781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16480),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16481),
  [10785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14438),
  [10787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7103),
  [10789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6908),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16425),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16426),
  [10795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16437),
  [10797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16438),
  [10799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11761),
  [10801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13816),
  [10803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11665),
  [10805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14506),
  [10807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, 0, 0),
  [10809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13541),
  [10811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, 0, 0),
  [10813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_public_statement, 2, 0, 0),
  [10815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_statement, 2, 0, 0),
  [10817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7502),
  [10819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11781),
  [10821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13457),
  [10823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11677),
  [10825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14981),
  [10827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7393),
  [10829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_open_tuple, 2, 0, 0),
  [10831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2999),
  [10833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_open_tuple, 2, 0, 0),
  [10835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0),
  [10837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2999),
  [10840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0),
  [10842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7403),
  [10844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14291),
  [10846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14709),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7903),
  [10850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0),
  [10852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13522),
  [10855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0),
  [10857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7280),
  [10859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7805),
  [10861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0),
  [10863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0),
  [10865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11806),
  [10868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11762),
  [10870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13870),
  [10872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11739),
  [10874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14295),
  [10876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, 0, 0),
  [10878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, 0, 0),
  [10880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_public_statement, 3, 0, 0),
  [10882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_statement, 3, 0, 0),
  [10884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__import_list, 2, 0, 0),
  [10886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, 0, 0),
  [10888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11804),
  [10890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13951),
  [10892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11683),
  [10894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14525),
  [10896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6833),
  [10898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14197),
  [10900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17996),
  [10902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15229),
  [10904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18000),
  [10906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3642),
  [10908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exportable, 3, 0, 0),
  [10910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exportable, 3, 0, 0),
  [10912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3642),
  [10915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13522),
  [10917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11784),
  [10919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13745),
  [10921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11680),
  [10923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14439),
  [10925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13541),
  [10928] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [10930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3257),
  [10932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3275),
  [10934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9677),
  [10936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2627),
  [10938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3276),
  [10940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3755),
  [10942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3756),
  [10944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3279),
  [10946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3280),
  [10948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3759),
  [10950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3760),
  [10952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3761),
  [10954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3762),
  [10956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3763),
  [10958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3764),
  [10960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3765),
  [10962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3766),
  [10964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [10966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_statement, 2, 0, 0),
  [10968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2, 0, 0),
  [10970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_statement, 2, 0, 0),
  [10972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_statement, 2, 0, 0),
  [10974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_macro_argument_list_repeat1, 1, 0, 0),
  [10976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_argument_list_repeat1, 1, 0, 0),
  [10978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [10980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3058),
  [10982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, 0, 0),
  [10984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3000),
  [10986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3022),
  [10988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9559),
  [10990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7416),
  [10992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2652),
  [10994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3002),
  [10996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3024),
  [10998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3025),
  [11000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3026),
  [11002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [11004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3028),
  [11006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3029),
  [11008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3030),
  [11010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3031),
  [11012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3032),
  [11014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3033),
  [11016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3034),
  [11018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3035),
  [11020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, 0, 6),
  [11022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 6),
  [11024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11951),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16422),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16423),
  [11031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10879),
  [11033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 5, 0, 0),
  [11035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 5, 0, 0),
  [11037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14323),
  [11039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 4),
  [11041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 4),
  [11043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 12),
  [11045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 12),
  [11047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0),
  [11049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [11051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(1356),
  [11054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3656),
  [11056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5506),
  [11058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3674),
  [11060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9574),
  [11062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8519),
  [11064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2577),
  [11066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3676),
  [11068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3438),
  [11070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3439),
  [11072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3679),
  [11074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3680),
  [11076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3458),
  [11078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3459),
  [11080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3460),
  [11082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [11084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3462),
  [11086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3463),
  [11088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3464),
  [11090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3465),
  [11092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17301),
  [11095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17301),
  [11098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [11100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [11102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17163),
  [11105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17163),
  [11108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 6),
  [11110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 6),
  [11112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_assignment_expression, 3, 0, 6),
  [11114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_assignment_expression, 3, 0, 6),
  [11116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 13),
  [11118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 13),
  [11120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, 0, 0),
  [11122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, 0, 0),
  [11124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2402),
  [11126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17957),
  [11128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17305),
  [11131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17305),
  [11134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3216),
  [11137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1705),
  [11139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [11141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17126),
  [11144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17126),
  [11147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2417),
  [11149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8949),
  [11151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17308),
  [11154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17308),
  [11157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1913),
  [11159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7365),
  [11161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17166),
  [11164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17166),
  [11167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14715),
  [11169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splat_expression, 2, 0, 0),
  [11171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splat_expression, 2, 0, 0),
  [11173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_selected_import, 3, 0, 0),
  [11175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_selected_import, 3, 0, 0),
  [11177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2432),
  [11179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8777),
  [11181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17311),
  [11184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17311),
  [11187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1570),
  [11189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9944),
  [11191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17083),
  [11194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17083),
  [11197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 0),
  [11199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 0),
  [11201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2445),
  [11203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6659),
  [11205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17316),
  [11208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17316),
  [11211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 4),
  [11213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 4),
  [11215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11963),
  [11217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13633),
  [11219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2599),
  [11221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2049),
  [11223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_statement, 2, 0, 0),
  [11225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_statement, 2, 0, 0),
  [11227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [11229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11209),
  [11231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17133),
  [11234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17133),
  [11237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1940),
  [11239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7000),
  [11241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17171),
  [11244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17171),
  [11247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function_expression, 3, 0, 0),
  [11249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function_expression, 3, 0, 0),
  [11251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [11253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 2, 0, 0),
  [11255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, 0, 0),
  [11257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 0),
  [11259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 2, 0, 0),
  [11261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 2, 0, 0),
  [11263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [11265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 2),
  [11267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 2),
  [11269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 6, 0, 0),
  [11271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 6, 0, 0),
  [11273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [11275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3, 0, 0),
  [11277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3, 0, 0),
  [11279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 6, 0, 8),
  [11281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 6, 0, 8),
  [11283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, 0, 0),
  [11285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, 0, 0),
  [11287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closed_assignment, 3, 0, 6),
  [11289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closed_assignment, 3, 0, 6),
  [11291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 2, 0, 0),
  [11293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, 0, 0),
  [11295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2560),
  [11297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9794),
  [11299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17273),
  [11302] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17273),
  [11305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 2, 0, 0),
  [11307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 2, 0, 0),
  [11309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 6, 0, 0),
  [11311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 6, 0, 0),
  [11313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13452),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13815),
  [11317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 17),
  [11319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 17),
  [11321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1967),
  [11323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5810),
  [11325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17176),
  [11328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17176),
  [11331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 4, 0, 0),
  [11333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 4, 0, 0),
  [11335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 4, 0, 3),
  [11337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 4, 0, 3),
  [11339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_definition, 4, 0, 0),
  [11341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_definition, 4, 0, 0),
  [11343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 4, 0, 0),
  [11345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, 0, 0),
  [11347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 4, 0, 0),
  [11349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 4, 0, 0),
  [11351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, 0, 0),
  [11353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, 0, 0),
  [11355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 4, 0, 0),
  [11357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 4, 0, 0),
  [11359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 18),
  [11361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 18),
  [11363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1757),
  [11365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4327),
  [11367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17140),
  [11370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17140),
  [11373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 4, 0, 0),
  [11375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 4, 0, 0),
  [11377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 4, 0, 8),
  [11379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 4, 0, 8),
  [11381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, 0, 0),
  [11383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, 0, 0),
  [11385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 4),
  [11387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 4),
  [11389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1597),
  [11391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6047),
  [11393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17088),
  [11396] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17088),
  [11399] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 9),
  [11401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 9),
  [11403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, 0, 0),
  [11405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, 0, 0),
  [11407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, 0, 0),
  [11409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, 0, 0),
  [11411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 4),
  [11413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 4),
  [11415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [11417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7584),
  [11419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17179),
  [11422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17179),
  [11425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [11427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14851),
  [11429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8076),
  [11431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [11433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7109),
  [11435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17190),
  [11438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17190),
  [11441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3020),
  [11443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3020),
  [11446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2045),
  [11448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5876),
  [11450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17199),
  [11453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17199),
  [11456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 21),
  [11458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 21),
  [11460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13779),
  [11462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [11464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4898),
  [11466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17387),
  [11469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17387),
  [11472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 2, 0, 0),
  [11474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 2, 0, 0),
  [11476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13815),
  [11479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [11481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4455),
  [11483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17318),
  [11486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17318),
  [11489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1783),
  [11491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4590),
  [11493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17143),
  [11496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17143),
  [11499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [11501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_statement, 3, 0, 0),
  [11503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [11505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11627),
  [11507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17209),
  [11510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17209),
  [11513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 3, 0, 3),
  [11515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 3, 0, 3),
  [11517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macrocall_expression, 4, 0, 0),
  [11519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macrocall_expression, 4, 0, 0),
  [11521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11761),
  [11524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13744),
  [11526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 3, 0, 0),
  [11528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 3, 0, 0),
  [11530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 3, 0, 0),
  [11532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 3, 0, 0),
  [11534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 3, 0, 0),
  [11536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 3, 0, 0),
  [11538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [11540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11120),
  [11542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17213),
  [11545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17213),
  [11548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote_statement, 3, 0, 0),
  [11550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote_statement, 3, 0, 0),
  [11552] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 3, 0, 0),
  [11554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 3, 0, 0),
  [11556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13452),
  [11559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, 0, 4),
  [11561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, 0, 4),
  [11563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, 0, 0),
  [11565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, 0, 0),
  [11567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 3, 0, 0),
  [11569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 3, 0, 0),
  [11571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, 0, 4),
  [11573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, 0, 4),
  [11575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [11577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5915),
  [11579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17217),
  [11582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17217),
  [11585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1644),
  [11587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4827),
  [11589] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17351),
  [11592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17351),
  [11595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11781),
  [11598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2133),
  [11600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [11602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17222),
  [11605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17222),
  [11608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2150),
  [11610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [11612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17225),
  [11615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17225),
  [11618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2617),
  [11620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [11622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2956),
  [11624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2977),
  [11626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9688),
  [11628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8285),
  [11630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2639),
  [11632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [11634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2979),
  [11636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2980),
  [11638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2981),
  [11640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2982),
  [11642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2983),
  [11644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2984),
  [11646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2985),
  [11648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2986),
  [11650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [11652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2988),
  [11654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2989),
  [11656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2990),
  [11658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1547),
  [11660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10468),
  [11662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17076),
  [11665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17076),
  [11668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3021),
  [11670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3041),
  [11672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9682),
  [11674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8480),
  [11676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2653),
  [11678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3023),
  [11680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3043),
  [11682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3044),
  [11684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3045),
  [11686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3046),
  [11688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3047),
  [11690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3048),
  [11692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3049),
  [11694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3050),
  [11696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3051),
  [11698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [11700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3053),
  [11702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3054),
  [11704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1624),
  [11706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6085),
  [11708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17100),
  [11711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17100),
  [11714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3060),
  [11716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3112),
  [11718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3113),
  [11720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9541),
  [11722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8129),
  [11724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2665),
  [11726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3114),
  [11728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3115),
  [11730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3116),
  [11732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3117),
  [11734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3118),
  [11736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3119),
  [11738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3120),
  [11740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3121),
  [11742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [11744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [11746] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3124),
  [11748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3125),
  [11750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3126),
  [11752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2167),
  [11754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7479),
  [11756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17230),
  [11759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17230),
  [11762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1809),
  [11764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6163),
  [11766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17149),
  [11769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17149),
  [11772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14647),
  [11774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [11776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9959),
  [11778] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17475),
  [11781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17475),
  [11784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2183),
  [11786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6837),
  [11788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17234),
  [11791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17234),
  [11794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1856),
  [11796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10605),
  [11798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17392),
  [11801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17392),
  [11804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11679),
  [11806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [11808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [11810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17237),
  [11813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17237),
  [11816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2211),
  [11818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5414),
  [11820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17241),
  [11823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17241),
  [11826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [11828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11818),
  [11830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17153),
  [11833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17153),
  [11836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2225),
  [11838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6894),
  [11840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17244),
  [11843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17244),
  [11846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13947),
  [11848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2240),
  [11850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6568),
  [11852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17252),
  [11855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17252),
  [11858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13779),
  [11861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11762),
  [11864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_expression, 3, 0, 0),
  [11866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_expression, 3, 0, 0),
  [11868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2256),
  [11870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5170),
  [11872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17257),
  [11875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17257),
  [11878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2270),
  [11880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7728),
  [11882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17263),
  [11885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17263),
  [11888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [11890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9461),
  [11892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17428),
  [11895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17428),
  [11898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_alias, 3, 0, 0),
  [11900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_alias, 3, 0, 0),
  [11902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [11904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6740),
  [11906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17270),
  [11909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17270),
  [11912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14471),
  [11914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1649),
  [11916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6783),
  [11918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17113),
  [11921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17113),
  [11924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_module_definition, 5, 0, 3),
  [11926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_definition, 5, 0, 3),
  [11928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2301),
  [11930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5452),
  [11932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17274),
  [11935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17274),
  [11938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3060),
  [11941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive_definition, 5, 0, 0),
  [11943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive_definition, 5, 0, 0),
  [11945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1860),
  [11947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8388),
  [11949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17158),
  [11952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17158),
  [11955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [11957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6209),
  [11959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17278),
  [11962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17278),
  [11965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_definition, 5, 0, 0),
  [11967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, 0, 0),
  [11969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, 0, 0),
  [11971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, 0, 0),
  [11973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2257),
  [11975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10116),
  [11977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17459),
  [11980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17459),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16540),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16541),
  [11987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [11989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10524),
  [11991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17068),
  [11994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17068),
  [11997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2330),
  [11999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16692),
  [12001] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17285),
  [12004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17285),
  [12007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2429),
  [12009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4693),
  [12011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17507),
  [12014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17507),
  [12017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2345),
  [12019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6954),
  [12021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17290),
  [12024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17290),
  [12027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15096),
  [12029] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13947),
  [12032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11804),
  [12035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2929),
  [12038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2600),
  [12040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5583),
  [12042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17535),
  [12045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17535),
  [12048] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, 0, 0),
  [12050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, 0, 0),
  [12052] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_statement, 5, 0, 8),
  [12054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_statement, 5, 0, 8),
  [12056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13744),
  [12059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2360),
  [12061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7538),
  [12063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17294),
  [12066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17294),
  [12069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11784),
  [12072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [12074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10321),
  [12076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17556),
  [12079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17556),
  [12082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [12084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4833),
  [12086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17600),
  [12089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17600),
  [12092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1677),
  [12094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6489),
  [12096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17118),
  [12099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17118),
  [12102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [12104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11343),
  [12106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17617),
  [12109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17617),
  [12112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2373),
  [12114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7090),
  [12116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17297),
  [12119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17297),
  [12122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1443),
  [12124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6419),
  [12126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17627),
  [12129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17627),
  [12132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14737),
  [12134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1468),
  [12136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11357),
  [12138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17639),
  [12141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17639),
  [12144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [12146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5967),
  [12148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17655),
  [12151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0), SHIFT(17655),
  [12154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2637),
  [12156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2609),
  [12158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2655),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16538),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16539),
  [12164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13631),
  [12166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2693),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9641),
  [12170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [12172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3434),
  [12175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1985),
  [12177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3442),
  [12179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3467),
  [12181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3473),
  [12183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3474),
  [12185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [12187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3476),
  [12189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3477),
  [12191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3478),
  [12193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [12195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3480),
  [12197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [12199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3469),
  [12201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3470),
  [12203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3471),
  [12205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3472),
  [12207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13631),
  [12210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11963),
  [12213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [12215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2196),
  [12217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3320),
  [12219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14858),
  [12221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8738),
  [12223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3290),
  [12225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3556),
  [12227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9716),
  [12229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2623),
  [12231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3571),
  [12233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3557),
  [12235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3558),
  [12237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3559),
  [12239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3560),
  [12241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3561),
  [12243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3562),
  [12245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3563),
  [12247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3564),
  [12249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3565),
  [12251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3566),
  [12253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3567),
  [12255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3568),
  [12257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3702),
  [12259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3753),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [12263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [12265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3705),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [12269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3707),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [12279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3717),
  [12281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3718),
  [12283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3719),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [12289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [12293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3950),
  [12295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3952),
  [12297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3953),
  [12299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3770),
  [12301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4040),
  [12303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3954),
  [12305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3955),
  [12307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4041),
  [12309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4042),
  [12311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4043),
  [12313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4044),
  [12315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4045),
  [12317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4046),
  [12319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4047),
  [12321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4048),
  [12323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4029),
  [12325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4030),
  [12327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2651),
  [12329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [12331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3802),
  [12333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3997),
  [12335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4032),
  [12337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4033),
  [12339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3998),
  [12341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3999),
  [12343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4000),
  [12345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4001),
  [12347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4002),
  [12349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4003),
  [12351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [12353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4005),
  [12355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3320),
  [12358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [12360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2976),
  [12362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3001),
  [12364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [12366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2978),
  [12368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [12370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3004),
  [12372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [12374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [12376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [12378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [12380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3009),
  [12382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3010),
  [12384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3011),
  [12386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3012),
  [12388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [12390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [12392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [12394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3366),
  [12396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2975),
  [12399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2589),
  [12401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3401),
  [12403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3419),
  [12405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3425),
  [12407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3426),
  [12409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [12411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3428),
  [12413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3429),
  [12415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3430),
  [12417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3431),
  [12419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3432),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11920),
  [12423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13546),
  [12425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1621),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [12429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [12431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3363),
  [12433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3364),
  [12435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3365),
  [12437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [12439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3403),
  [12441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3421),
  [12443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3422),
  [12445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [12447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [12449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3577),
  [12451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3578),
  [12453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3579),
  [12455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3580),
  [12457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3581),
  [12459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [12461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3531),
  [12463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3494),
  [12465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3495),
  [12467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3496),
  [12469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [12471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [12473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3528),
  [12475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3529),
  [12477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3530),
  [12479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14596),
  [12481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [12483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3518),
  [12485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3519),
  [12487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [12489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [12491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3522),
  [12493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3523),
  [12495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3524),
  [12497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [12499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3526),
  [12501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3355),
  [12503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3356),
  [12505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3359),
  [12507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3360),
  [12509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3361),
  [12511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3466),
  [12513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3485),
  [12515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3468),
  [12517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3487),
  [12519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3488),
  [12521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3489),
  [12523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3490),
  [12525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3491),
  [12527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [12529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3493),
  [12531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11717),
  [12533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8985),
  [12535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11086),
  [12537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3314),
  [12539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3574),
  [12541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3575),
  [12543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3576),
  [12545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3315),
  [12547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3316),
  [12549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3572),
  [12551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3573),
  [12553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3317),
  [12555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3318),
  [12557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4034),
  [12559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3855),
  [12561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2656),
  [12563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3868),
  [12565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3856),
  [12567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3857),
  [12569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3858),
  [12571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3859),
  [12573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3860),
  [12575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [12577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3862),
  [12579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [12581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3864),
  [12583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3865),
  [12585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3866),
  [12587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3867),
  [12589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13544),
  [12591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [12593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11920),
  [12596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3331),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [12602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3337),
  [12604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3338),
  [12606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3339),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3341),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [12614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3353),
  [12616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3332),
  [12618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [12620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3334),
  [12622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [12624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [12626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [12628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [12630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [12632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3130),
  [12635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13544),
  [12638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3956),
  [12640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [12642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3951),
  [12644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3777),
  [12646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [12648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3940),
  [12650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3941),
  [12652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3942),
  [12654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [12656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3944),
  [12658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3945),
  [12660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3946),
  [12662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3947),
  [12664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3948),
  [12666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3949),
  [12668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_binding, 3, 0, 6),
  [12670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_binding, 3, 0, 6),
  [12672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3980),
  [12674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3981),
  [12676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2647),
  [12678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3982),
  [12680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [12682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3969),
  [12684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3984),
  [12686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3985),
  [12688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [12690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3973),
  [12692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3974),
  [12694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3975),
  [12696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3976),
  [12698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3977),
  [12700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3978),
  [12702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3979),
  [12704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3183),
  [12706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3184),
  [12708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9539),
  [12710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9176),
  [12712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2671),
  [12714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3185),
  [12716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [12718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3170),
  [12720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [12722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [12724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [12726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [12728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3175),
  [12730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3176),
  [12732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3177),
  [12734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [12736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [12738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3180),
  [12740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3184),
  [12742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14805),
  [12744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_binding, 4, 0, 14),
  [12746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_binding, 4, 0, 14),
  [12748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [12750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3418),
  [12752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [12754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [12756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3451),
  [12758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3452),
  [12760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3453),
  [12762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [12764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [12766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [12768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3443),
  [12770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3420),
  [12772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [12774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3446),
  [12776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3447),
  [12778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [12780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3443),
  [12782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [12784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2949),
  [12786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2950),
  [12788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2951),
  [12790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2952),
  [12792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2953),
  [12794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2954),
  [12796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2972),
  [12798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2927),
  [12800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2928),
  [12802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [12804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_row_repeat1, 1, 0, 0),
  [12806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1962),
  [12808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4035),
  [12810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4036),
  [12812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4037),
  [12814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3772),
  [12816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3869),
  [12818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4038),
  [12820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4039),
  [12822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3870),
  [12824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [12826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [12828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3873),
  [12830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [12832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [12834] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [12836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3877),
  [12838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11062),
  [12840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3667),
  [12842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3668),
  [12844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [12846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [12848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3554),
  [12850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [12852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [12854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [12856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [12858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3595),
  [12860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3612),
  [12862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3629),
  [12864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [12866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [12868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [12870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [12872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10118),
  [12874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10280),
  [12876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10290),
  [12878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10356),
  [12880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10283),
  [12882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10331),
  [12884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10148),
  [12886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10341),
  [12888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17073),
  [12890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15119),
  [12892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17892),
  [12894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9736),
  [12896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9782),
  [12898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9766),
  [12900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [12902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9775),
  [12904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9803),
  [12906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9782),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9769),
  [12910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9769),
  [12912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9747),
  [12914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9770),
  [12916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9766),
  [12918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9803),
  [12920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17208),
  [12922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15241),
  [12924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17712),
  [12926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9848),
  [12928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10027),
  [12930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9975),
  [12932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9953),
  [12934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9979),
  [12936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10019),
  [12938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9906),
  [12940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9939),
  [12942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17525),
  [12944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15317),
  [12946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17817),
  [12948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11079),
  [12950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0), SHIFT(9689),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16312),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16313),
  [12957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0),
  [12959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2380),
  [12962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0),
  [12964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9448),
  [12966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [12968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5022),
  [12970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [12972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5021),
  [12974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [12976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [12978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__do_parameter_list, 3, 0, 0),
  [12980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_parameter_list, 3, 0, 0),
  [12982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__do_parameter_list, 2, 0, 0),
  [12984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_parameter_list, 2, 0, 0),
  [12986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__do_parameter_list, 1, 0, 0),
  [12988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__do_parameter_list, 1, 0, 0),
  [12990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8018),
  [12992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9580),
  [12994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [12996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9115),
  [12998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7171),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6503),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9790),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6506),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5569),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11045),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11325),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10522),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6198),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6997),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9978),
  [13032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7897),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18024),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5992),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7580),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7052),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7799),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6864),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10256),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [13060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16034),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11355),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5864),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8861),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10065),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7855),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9940),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6395),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10422),
  [13100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11605),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11865),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7851),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10627),
  [13112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6347),
  [13114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6978),
  [13116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7035),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [13120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7174),
  [13122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6950),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [13128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6733),
  [13130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6491),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [13136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [13138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [13140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17169),
  [13142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15203),
  [13144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17739),
  [13146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5261),
  [13148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6042),
  [13150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6247),
  [13152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6202),
  [13154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6202),
  [13156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6195),
  [13158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [13160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6032),
  [13162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6032),
  [13164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5542),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17193),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15155),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18049),
  [13180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5201),
  [13182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6296),
  [13184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6269),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [13188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6007),
  [13190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5964),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6025),
  [13196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6025),
  [13198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6037),
  [13204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [13206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [13208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17107),
  [13210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15200),
  [13212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17883),
  [13214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6203),
  [13216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [13218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [13220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [13222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11187),
  [13224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9685),
  [13226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6524),
  [13228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [13230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5230),
  [13232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6190),
  [13234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6038),
  [13236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6121),
  [13238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6121),
  [13240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6081),
  [13242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6190),
  [13244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5952),
  [13246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5952),
  [13248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5444),
  [13250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5954),
  [13252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [13254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [13256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [13258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17097),
  [13260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15283),
  [13262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17767),
  [13264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [13266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11015),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9697),
  [13276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5833),
  [13278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [13280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11362),
  [13282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11366),
  [13284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11363),
  [13286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11363),
  [13288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11339),
  [13290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11362),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11360),
  [13294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11360),
  [13296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10868),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11365),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11191),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11366),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11339),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17460),
  [13308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15340),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18088),
  [13312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11084),
  [13320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9610),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10679),
  [13324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6345),
  [13326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6820),
  [13328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6818),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7040),
  [13332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7040),
  [13334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6949),
  [13336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [13338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6573),
  [13340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17416),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15225),
  [13350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17906),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [13360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [13364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [13366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5369),
  [13368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5500),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [13372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5725),
  [13374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5720),
  [13376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [13380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [13382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5215),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5867),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17201),
  [13394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15303),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17938),
  [13398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10160),
  [13400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10539),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10543),
  [13404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10543),
  [13406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10382),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10541),
  [13410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10541),
  [13412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10264),
  [13414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10470),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10497),
  [13418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10539),
  [13420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10382),
  [13422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17478),
  [13424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15157),
  [13426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18107),
  [13428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6597),
  [13430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7235),
  [13432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7914),
  [13434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7499),
  [13436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7499),
  [13438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7434),
  [13440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [13442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [13444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7485),
  [13446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6728),
  [13448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7487),
  [13450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [13452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7914),
  [13454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [13456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17079),
  [13458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15141),
  [13460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17873),
  [13462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10639),
  [13464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11049),
  [13466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11184),
  [13468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11050),
  [13470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11050),
  [13472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11042),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11049),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11182),
  [13478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11182),
  [13480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10812),
  [13482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11183),
  [13484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11110),
  [13486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11184),
  [13488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11042),
  [13490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17659),
  [13492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15260),
  [13494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18222),
  [13496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5796),
  [13498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [13500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [13502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [13504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10900),
  [13506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [13508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [13510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6409),
  [13512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6369),
  [13514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7178),
  [13516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7120),
  [13518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [13520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7193),
  [13522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7181),
  [13524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [13526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6624),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [13532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [13534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17183),
  [13536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15320),
  [13538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17926),
  [13540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5210),
  [13542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [13544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [13546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [13548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10938),
  [13550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9634),
  [13552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6005),
  [13554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [13556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5031),
  [13558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5783),
  [13560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5646),
  [13562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5579),
  [13564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5579),
  [13566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5557),
  [13568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [13570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [13572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5731),
  [13574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5107),
  [13576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [13578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [13580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [13582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [13584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17175),
  [13586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15347),
  [13588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17786),
  [13590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11473),
  [13592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [13594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [13596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [13598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10966),
  [13600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9721),
  [13602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11873),
  [13604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11786),
  [13606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9843),
  [13608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [13610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [13612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [13614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10922),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9718),
  [13618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9942),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10023),
  [13622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10596),
  [13624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10563),
  [13626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10592),
  [13628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10592),
  [13630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10658),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10596),
  [13634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10578),
  [13636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10578),
  [13638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10475),
  [13640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10585),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10563),
  [13644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10658),
  [13646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17148),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15276),
  [13650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17904),
  [13652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [13654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5207),
  [13656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5241),
  [13658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [13660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5090),
  [13662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5081),
  [13664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [13668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5232),
  [13670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4992),
  [13672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [13674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [13676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [13680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17325),
  [13682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15292),
  [13684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18002),
  [13686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [13688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [13690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [13692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10999),
  [13694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9636),
  [13696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5305),
  [13698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [13700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [13702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [13704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [13706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11003),
  [13708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9700),
  [13710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6205),
  [13712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [13714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4994),
  [13716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5647),
  [13718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5797),
  [13720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [13722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5761),
  [13724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5734),
  [13726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5496),
  [13730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5496),
  [13732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [13734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [13736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [13738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [13740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17302),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15336),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18078),
  [13748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6440),
  [13750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6878),
  [13752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6876),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7060),
  [13756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7060),
  [13758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7036),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6878),
  [13762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [13764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7093),
  [13766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6607),
  [13768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [13770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6989),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6876),
  [13774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7036),
  [13776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17326),
  [13778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15227),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17995),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [13784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [13788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [13792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [13794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [13796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [13798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5538),
  [13800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [13802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5798),
  [13804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5775),
  [13806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [13808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [13810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5534),
  [13812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5240),
  [13814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [13816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [13818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [13820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [13822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17409),
  [13824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15207),
  [13826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17770),
  [13828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6602),
  [13830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7288),
  [13832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7798),
  [13834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7612),
  [13836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7612),
  [13838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7526),
  [13840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [13842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6832),
  [13844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7617),
  [13846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7798),
  [13848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7526),
  [13850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17605),
  [13852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15132),
  [13854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17986),
  [13856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [13858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [13860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [13862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [13864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10917),
  [13866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9687),
  [13868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6268),
  [13870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [13872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9953),
  [13874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [13876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10019),
  [13878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9939),
  [13880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9975),
  [13882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9979),
  [13884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4990),
  [13886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [13888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [13890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [13892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10969),
  [13894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9715),
  [13896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5664),
  [13898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [13900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6605),
  [13902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7446),
  [13904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7438),
  [13906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7260),
  [13908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7260),
  [13910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7660),
  [13912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7446),
  [13914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6772),
  [13916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [13918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7438),
  [13920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [13922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17653),
  [13924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15220),
  [13926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18218),
  [13928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4755),
  [13930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4575),
  [13932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [13934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [13936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [13938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [13940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [13942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5484),
  [13944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5547),
  [13946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [13948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [13950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5940),
  [13952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [13954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [13956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5543),
  [13958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5252),
  [13960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [13962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [13964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [13966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5940),
  [13968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17371),
  [13970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15249),
  [13972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18029),
  [13974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10099),
  [13976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10050),
  [13978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10084),
  [13980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10084),
  [13982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10039),
  [13984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10099),
  [13986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10104),
  [13988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10104),
  [13990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10014),
  [13992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10106),
  [13994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10050),
  [13996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10039),
  [13998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17358),
  [14000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15177),
  [14002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18016),
  [14004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10230),
  [14006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10403),
  [14008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10528),
  [14010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10511),
  [14012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10511),
  [14014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10479),
  [14016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10403),
  [14018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10450),
  [14020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10450),
  [14022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10300),
  [14024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10452),
  [14026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10411),
  [14028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10528),
  [14030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10479),
  [14032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17444),
  [14034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15201),
  [14036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18097),
  [14038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9969),
  [14040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9948),
  [14042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9999),
  [14044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9999),
  [14046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9964),
  [14048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9969),
  [14050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10028),
  [14052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10028),
  [14054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9880),
  [14056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10030),
  [14058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9948),
  [14060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9964),
  [14062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17572),
  [14064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15133),
  [14066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17834),
  [14068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6338),
  [14070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7163),
  [14072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7177),
  [14074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7087),
  [14076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7087),
  [14078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6829),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7163),
  [14082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [14084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7202),
  [14086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6470),
  [14088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [14090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [14092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7177),
  [14094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6829),
  [14096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17500),
  [14098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15331),
  [14100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18120),
  [14102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11064),
  [14104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9585),
  [14106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4808),
  [14108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5208),
  [14110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5129),
  [14112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [14114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5199),
  [14116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5361),
  [14118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [14120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [14122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5137),
  [14124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4963),
  [14126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [14128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [14130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [14132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [14134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17377),
  [14136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15215),
  [14138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18033),
  [14140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11413),
  [14142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11611),
  [14144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11716),
  [14146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11623),
  [14148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11623),
  [14150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11706),
  [14152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11611),
  [14154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11715),
  [14156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11715),
  [14158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11586),
  [14160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11722),
  [14162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11617),
  [14164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11716),
  [14166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11706),
  [14168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17265),
  [14170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15185),
  [14172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17965),
  [14174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6352),
  [14176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [14178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7185),
  [14180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7165),
  [14182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7165),
  [14184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [14186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6947),
  [14188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6723),
  [14190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6723),
  [14192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6575),
  [14194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [14196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [14198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [14200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7070),
  [14202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17238),
  [14204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15246),
  [14206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18067),
  [14208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9599),
  [14210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11081),
  [14212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9604),
  [14214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9611),
  [14216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11088),
  [14218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [14220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11060),
  [14222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9579),
  [14224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [14226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [14228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [14230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11063),
  [14232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9584),
  [14234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10394),
  [14236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10919),
  [14238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9703),
  [14240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10693),
  [14242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11297),
  [14244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11335),
  [14246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11334),
  [14248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11334),
  [14250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11284),
  [14252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11297),
  [14254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11299),
  [14256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11299),
  [14258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10964),
  [14260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11301),
  [14262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11311),
  [14264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11335),
  [14266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11284),
  [14268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17282),
  [14270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15118),
  [14272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18083),
  [14274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6201),
  [14276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6029),
  [14278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6023),
  [14280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6023),
  [14282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6008),
  [14284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [14286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [14288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5971),
  [14290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5407),
  [14292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [14294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [14296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6008),
  [14298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17196),
  [14300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15139),
  [14302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17933),
  [14304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14604),
  [14306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15518),
  [14308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16285),
  [14310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16088),
  [14312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16088),
  [14314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15550),
  [14316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15518),
  [14318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16180),
  [14320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16180),
  [14322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15286),
  [14324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16190),
  [14326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16651),
  [14328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16285),
  [14330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15550),
  [14332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17581),
  [14334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15279),
  [14336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18164),
  [14338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7462),
  [14340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8876),
  [14342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8766),
  [14344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [14346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8809),
  [14348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8631),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [14352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8945),
  [14354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8945),
  [14356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8484),
  [14358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8685),
  [14360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8768),
  [14362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8766),
  [14364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8631),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17322),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15334),
  [14370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18148),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [14374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10932),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9556),
  [14382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5957),
  [14384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6346),
  [14386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6887),
  [14388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6699),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6822),
  [14392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [14394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6731),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6887),
  [14398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [14400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7161),
  [14402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6515),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7162),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [14412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17513),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15224),
  [14416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17924),
  [14418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6251),
  [14420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6591),
  [14422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6620),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [14426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6642),
  [14428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6673),
  [14430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [14434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6664),
  [14436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6450),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6666),
  [14440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6576),
  [14442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [14444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6673),
  [14446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17429),
  [14448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15166),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18064),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [14454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [14456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [14458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10971),
  [14460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9692),
  [14462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5687),
  [14464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11782),
  [14466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11908),
  [14468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11959),
  [14470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11959),
  [14472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11752),
  [14474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11782),
  [14476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11783),
  [14478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11783),
  [14480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11619),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11785),
  [14484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11908),
  [14486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11752),
  [14488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17247),
  [14490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15199),
  [14492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17959),
  [14494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6625),
  [14496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7904),
  [14498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7840),
  [14500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [14502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7867),
  [14504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7847),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [14508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6836),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7840),
  [14514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7847),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17435),
  [14518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15212),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18227),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [14526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [14528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10941),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9691),
  [14532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5257),
  [14534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6335),
  [14536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6940),
  [14538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6953),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [14542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7180),
  [14544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7164),
  [14546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6940),
  [14548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6932),
  [14550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6932),
  [14552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6521),
  [14554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [14556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [14558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [14560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7164),
  [14562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17093),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15179),
  [14566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17874),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [14572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10946),
  [14576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [14582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [14584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [14586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [14588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [14590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5532),
  [14592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5549),
  [14594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5485),
  [14596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5485),
  [14598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5449),
  [14600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5532),
  [14602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [14604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5548),
  [14606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5272),
  [14608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [14610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [14612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [14614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17303),
  [14616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15222),
  [14618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18074),
  [14620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6589),
  [14622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7875),
  [14624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7234),
  [14626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7756),
  [14628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7756),
  [14630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7803),
  [14632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7875),
  [14634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6812),
  [14636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7567),
  [14638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [14640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7803),
  [14642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17555),
  [14644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15213),
  [14646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17916),
  [14648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [14650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [14652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [14654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11011),
  [14656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9536),
  [14658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7032),
  [14660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11077),
  [14662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9598),
  [14664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11080),
  [14666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9603),
  [14668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11094),
  [14670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9621),
  [14672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11087),
  [14674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9615),
  [14676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11102),
  [14678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9626),
  [14680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11096),
  [14682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9623),
  [14684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11103),
  [14686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9628),
  [14688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15372),
  [14690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18102),
  [14692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18075),
  [14694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17905),
  [14696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17905),
  [14698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17752),
  [14700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18102),
  [14702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18159),
  [14704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18159),
  [14706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17361),
  [14708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18015),
  [14710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17780),
  [14712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18075),
  [14714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17752),
  [14716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17608),
  [14718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15338),
  [14720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18189),
  [14722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [14724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [14726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [14728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11000),
  [14730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9648),
  [14732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5773),
  [14734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8582),
  [14736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9119),
  [14738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9127),
  [14740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [14742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8981),
  [14744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9103),
  [14746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9119),
  [14748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8795),
  [14750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8960),
  [14752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9127),
  [14754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9103),
  [14756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17567),
  [14758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15345),
  [14760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17709),
  [14762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [14764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [14766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [14768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10978),
  [14770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9562),
  [14772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5706),
  [14774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6483),
  [14776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6621),
  [14778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [14780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6513),
  [14782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6498),
  [14784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [14786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6463),
  [14788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6463),
  [14790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6344),
  [14792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [14794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6621),
  [14796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [14798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17293),
  [14800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15277),
  [14802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17778),
  [14804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10859),
  [14806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9712),
  [14808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6145),
  [14810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6200),
  [14812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [14814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6288),
  [14816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6271),
  [14818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [14820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [14822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [14824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [14826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [14828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [14830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [14832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17624),
  [14834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15259),
  [14836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17861),
  [14838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [14840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [14842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [14844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10985),
  [14846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9567),
  [14848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5730),
  [14850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6199),
  [14852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6655),
  [14854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6668),
  [14856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [14858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [14860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6574),
  [14862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [14864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [14866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6522),
  [14868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6339),
  [14870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6530),
  [14872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6657),
  [14874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [14876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [14878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17167),
  [14880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15144),
  [14882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17686),
  [14884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6494),
  [14886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7691),
  [14888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7765),
  [14890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7910),
  [14892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7910),
  [14894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7680),
  [14896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [14898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6824),
  [14900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7804),
  [14902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7765),
  [14904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7680),
  [14906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17528),
  [14908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15244),
  [14910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17674),
  [14912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [14914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4265),
  [14916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [14918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [14920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [14922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [14924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6248),
  [14926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5983),
  [14928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [14930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [14932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5955),
  [14934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6248),
  [14936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [14938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6136),
  [14940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5556),
  [14942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6137),
  [14944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5983),
  [14946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [14948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17425),
  [14950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15275),
  [14952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18060),
  [14954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [14956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [14958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [14960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10983),
  [14962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9631),
  [14964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6139),
  [14966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [14968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [14970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [14972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10965),
  [14974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9572),
  [14976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [14978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [14980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [14982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [14984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10974),
  [14986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9549),
  [14988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10851),
  [14990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6454),
  [14992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6456),
  [14994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [14996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [14998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6382),
  [15000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [15002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [15004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6370),
  [15006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6246),
  [15008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [15010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [15012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [15014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17645),
  [15016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15242),
  [15018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18225),
  [15020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9689),
  [15022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [15024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [15026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [15028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10890),
  [15030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9553),
  [15032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5491),
  [15034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10356),
  [15036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10280),
  [15038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10331),
  [15040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10341),
  [15042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10290),
  [15044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10283),
  [15046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5939),
  [15048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5493),
  [15050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [15052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5708),
  [15054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5689),
  [15056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [15058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [15060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5481),
  [15062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5212),
  [15064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [15066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5493),
  [15068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [15070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17363),
  [15072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15131),
  [15074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17760),
  [15076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6717),
  [15078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8177),
  [15080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8172),
  [15082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [15084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8464),
  [15086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8154),
  [15088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8177),
  [15090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7451),
  [15092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8382),
  [15094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8172),
  [15096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8154),
  [15098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17559),
  [15100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15256),
  [15102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18149),
  [15104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [15106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [15108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [15110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [15112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [15114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [15116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9741),
  [15118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [15120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9778),
  [15122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9829),
  [15124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9831),
  [15126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9854),
  [15128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9796),
  [15130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9857),
  [15132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9850),
  [15134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [15136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [15138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9878),
  [15140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9889),
  [15142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9903),
  [15144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [15146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10033),
  [15148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9917),
  [15150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [15152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16337),
  [15154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16338),
  [15156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2727),
  [15158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10126),
  [15160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2799),
  [15162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10114),
  [15164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2743),
  [15166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16486),
  [15168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16487),
  [15170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [15172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2868),
  [15174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2856),
  [15176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9925),
  [15178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10016),
  [15180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [15182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10329),
  [15184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2787),
  [15186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16239),
  [15188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16240),
  [15190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2720),
  [15192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16379),
  [15194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16380),
  [15196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2706),
  [15198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16415),
  [15200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16416),
  [15202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2785),
  [15204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [15206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2825),
  [15208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [15210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2722),
  [15212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16343),
  [15214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16344),
  [15216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [15218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2711),
  [15220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [15222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [15224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10303),
  [15226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16328),
  [15228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16329),
  [15230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9725),
  [15232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14208),
  [15234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3367),
  [15236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18125),
  [15238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15252),
  [15240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17694),
  [15242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [15244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(796),
  [15246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [15248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [15250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [15252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9724),
  [15254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14151),
  [15256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2906),
  [15258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18040),
  [15260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15250),
  [15262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17910),
  [15264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [15266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [15268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(3774),
  [15271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [15273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16258),
  [15275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16259),
  [15277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2865),
  [15279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2866),
  [15281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [15283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14226),
  [15285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3383),
  [15287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2761),
  [15289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2806),
  [15291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16953),
  [15293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16962),
  [15295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2873),
  [15297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10090),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2763),
  [15301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [15303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14106),
  [15305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3767),
  [15307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [15309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [15311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [15313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [15315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [15319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [15321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [15323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [15325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [15327] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__primary_expression, 1, 0, 0), SHIFT(3211),
  [15330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [15332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2814),
  [15334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [15336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [15338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2845),
  [15340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [15342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1806),
  [15344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [15346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [15348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [15350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [15352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [15354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2800),
  [15356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [15358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [15360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1837),
  [15362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9728),
  [15364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14110),
  [15366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3499),
  [15368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9723),
  [15370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14201),
  [15372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [15374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17775),
  [15376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15339),
  [15378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17812),
  [15380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [15382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [15384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14234),
  [15386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [15388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [15390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14162),
  [15392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3853),
  [15394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [15396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10410),
  [15398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 0),
  [15400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 0),
  [15402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2733),
  [15404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14211),
  [15406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [15408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [15410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14118),
  [15412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [15414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2518),
  [15416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14178),
  [15418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [15420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9726),
  [15422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14119),
  [15424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3289),
  [15426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [15428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14174),
  [15430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [15432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [15434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10476),
  [15436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [15438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [15440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9727),
  [15442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14179),
  [15444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3400),
  [15446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2716),
  [15448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14192),
  [15450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2945),
  [15452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [15454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2772),
  [15456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [15458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9473),
  [15460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9473),
  [15462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [15464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2862),
  [15466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2869),
  [15468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2867),
  [15470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14166),
  [15472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [15474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2854),
  [15476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1559),
  [15478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [15480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10011),
  [15482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14168),
  [15484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17837),
  [15486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15152),
  [15488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17838),
  [15490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2442),
  [15492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [15494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1548),
  [15496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2567),
  [15498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14142),
  [15500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [15502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [15504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14139),
  [15506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [15508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2844),
  [15510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [15512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14225),
  [15514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [15516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2820),
  [15518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [15520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3181),
  [15522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1852),
  [15524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9730),
  [15526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14121),
  [15528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3207),
  [15530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14202),
  [15532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [15534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14146),
  [15536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [15538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [15540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2795),
  [15542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [15544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [15546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2776),
  [15548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16323),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16324),
  [15552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2744),
  [15554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [15556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [15558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3906),
  [15560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [15562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14217),
  [15564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [15566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [15568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1728),
  [15570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2769),
  [15572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14161),
  [15574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3128),
  [15576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10659),
  [15578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10122),
  [15580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14126),
  [15582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18022),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15191),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18023),
  [15588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2877),
  [15592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3774),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [15596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2015),
  [15598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__do_parameter_list_repeat1, 2, 0, 0),
  [15600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__do_parameter_list_repeat1, 2, 0, 0),
  [15602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2794),
  [15604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2884),
  [15606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3313),
  [15608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [15610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16375),
  [15612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16376),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16464),
  [15616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16465),
  [15618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2746),
  [15620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14134),
  [15622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [15624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14227),
  [15626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [15628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [15630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3272),
  [15632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [15634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10490),
  [15636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3775),
  [15638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16457),
  [15640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16458),
  [15642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16534),
  [15644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16535),
  [15646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10881),
  [15648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2752),
  [15650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14188),
  [15652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [15654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [15656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [15658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3254),
  [15660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [15662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3208),
  [15664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3208),
  [15666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [15668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [15670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10409),
  [15672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [15674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [15676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3483),
  [15678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [15680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [15682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2398),
  [15684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14152),
  [15686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [15688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [15690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2771),
  [15692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16472),
  [15694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16473),
  [15696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16397),
  [15698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16398),
  [15700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16512),
  [15702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16513),
  [15704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9732),
  [15706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14194),
  [15708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [15710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11188),
  [15712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16413),
  [15714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16414),
  [15716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10611),
  [15718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [15720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14216),
  [15722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [15724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [15726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16399),
  [15728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16400),
  [15730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14130),
  [15732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16508),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16509),
  [15738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2852),
  [15740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14157),
  [15742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [15744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11333),
  [15746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16373),
  [15748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16374),
  [15750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [15752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11185),
  [15754] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [15756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [15758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [15760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [15762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16351),
  [15764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16352),
  [15766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9848),
  [15768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [15770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10322),
  [15772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [15774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11367),
  [15776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10160),
  [15778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [15780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [15782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [15784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10542),
  [15786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9895),
  [15788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9411),
  [15790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [15792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [15794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [15796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9465),
  [15798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9465),
  [15800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9416),
  [15802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9447),
  [15804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9462),
  [15806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [15808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [15810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6369),
  [15812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [15814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [15816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [15818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [15820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [15822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [15824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [15826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1283),
  [15828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6665),
  [15830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [15832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [15834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10118),
  [15836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [15838] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1325),
  [15840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [15842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [15844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6717),
  [15846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [15848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [15850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [15852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [15854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [15856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [15858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [15860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7486),
  [15862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [15864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17777),
  [15866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6605),
  [15868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [15870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [15872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [15874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6440),
  [15876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [15878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [15880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [15882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7159),
  [15884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11268),
  [15886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [15888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10230),
  [15890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16365),
  [15892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16366),
  [15894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9843),
  [15896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [15898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [15900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [15902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [15904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [15906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [15908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [15910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [15912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [15914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6716),
  [15916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10923),
  [15918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14181),
  [15920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18110),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15160),
  [15924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18117),
  [15926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [15928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [15930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [15932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11413),
  [15934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [15936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [15938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [15940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11600),
  [15942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [15944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10741),
  [15946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [15948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [15950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [15952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2235),
  [15954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [15956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [15958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11789),
  [15960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13713),
  [15962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11606),
  [15964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14980),
  [15966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2317),
  [15968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6494),
  [15970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [15972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [15974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [15976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2340),
  [15978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [15980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [15982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [15984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [15986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6718),
  [15988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11306),
  [15990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [15992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11473),
  [15994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10693),
  [15996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [15998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [16000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [16002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [16004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [16006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10639),
  [16008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6345),
  [16010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [16012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [16014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [16016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6199),
  [16018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [16020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [16022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [16024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6650),
  [16026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [16028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [16030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [16032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [16034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [16036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [16038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [16040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [16042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [16044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [16046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [16048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6711),
  [16050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [16052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4242),
  [16054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [16056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [16058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14604),
  [16060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [16062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [16064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [16066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [16068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [16070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3253),
  [16072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [16074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [16076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6625),
  [16078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [16080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [16082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [16084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6352),
  [16086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [16088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [16090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [16092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6753),
  [16094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [16096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15372),
  [16098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [16100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [16102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [16104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [16106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [16108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [16110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [16112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [16114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [16116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [16118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [16120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8745),
  [16122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [16124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [16126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2430),
  [16128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2614),
  [16130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [16132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2688),
  [16134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [16136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [16138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [16140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [16142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16371),
  [16144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16372),
  [16146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16432),
  [16148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16433),
  [16150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11300),
  [16152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16346),
  [16154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16347),
  [16156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10729),
  [16158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [16160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [16162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [16164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11371),
  [16166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11371),
  [16168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10911),
  [16170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11234),
  [16172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11282),
  [16174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16403),
  [16176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16404),
  [16178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16476),
  [16180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16477),
  [16182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2848),
  [16184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [16186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10462),
  [16188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14175),
  [16190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18104),
  [16192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15273),
  [16194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18128),
  [16196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14177),
  [16198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [16200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [16202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2870),
  [16204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [16206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6203),
  [16208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16300),
  [16210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16301),
  [16212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14859),
  [16214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16356),
  [16216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16357),
  [16218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11262),
  [16220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14215),
  [16222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18089),
  [16224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15341),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18091),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16286),
  [16230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16287),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13706),
  [16234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10677),
  [16236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14140),
  [16238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17907),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15293),
  [16242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17908),
  [16244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14114),
  [16246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14103),
  [16248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14169),
  [16250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14200),
  [16252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14222),
  [16254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13706),
  [16257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11789),
  [16260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14120),
  [16262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11354),
  [16264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11738),
  [16266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16454),
  [16268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16455),
  [16270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16462),
  [16272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16463),
  [16274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16532),
  [16276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16533),
  [16278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14223),
  [16280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14224),
  [16282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16520),
  [16284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16521),
  [16286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9555),
  [16288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14127),
  [16290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14150),
  [16292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14156),
  [16294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6842),
  [16296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17550),
  [16298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13740),
  [16300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11002),
  [16302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13174),
  [16304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [16306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17439),
  [16308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13714),
  [16310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10898),
  [16312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13367),
  [16314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10409),
  [16316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17485),
  [16318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13608),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11061),
  [16322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13392),
  [16324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16419),
  [16326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16420),
  [16328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [16330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17549),
  [16332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13724),
  [16334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10910),
  [16336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13201),
  [16338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14195),
  [16340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [16342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17628),
  [16344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13742),
  [16346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11010),
  [16348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13192),
  [16350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16460),
  [16352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16461),
  [16354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [16356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17398),
  [16358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13738),
  [16360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10981),
  [16362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13163),
  [16364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16488),
  [16366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16489),
  [16368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6688),
  [16370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17468),
  [16372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13736),
  [16374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10976),
  [16376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13388),
  [16378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [16380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17131),
  [16382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13729),
  [16384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10927),
  [16386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13310),
  [16388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16410),
  [16390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16411),
  [16392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11354),
  [16394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17313),
  [16396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13752),
  [16398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11059),
  [16400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13229),
  [16402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11961),
  [16404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16451),
  [16406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16452),
  [16408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16470),
  [16410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16471),
  [16412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16530),
  [16414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16531),
  [16416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16506),
  [16418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16507),
  [16420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17668),
  [16422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11083),
  [16424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13418),
  [16426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14172),
  [16428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17563),
  [16430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11085),
  [16432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13423),
  [16434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [16436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11738),
  [16438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17355),
  [16440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13730),
  [16442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11065),
  [16444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13232),
  [16446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17669),
  [16448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11101),
  [16450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13431),
  [16452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17623),
  [16454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11151),
  [16456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13427),
  [16458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17670),
  [16460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11105),
  [16462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13435),
  [16464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [16466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17396),
  [16468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13690),
  [16470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10888),
  [16472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13300),
  [16474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17635),
  [16476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11161),
  [16478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13429),
  [16480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17671),
  [16482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11107),
  [16484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13437),
  [16486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17658),
  [16488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11109),
  [16490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13287),
  [16492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14105),
  [16494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11723),
  [16496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [16498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17586),
  [16500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13734),
  [16502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10963),
  [16504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13161),
  [16506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16369),
  [16508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16370),
  [16510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16429),
  [16512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16430),
  [16514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [16516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [16518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [16520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3435),
  [16522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [16524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [16526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9589),
  [16528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10784),
  [16530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [16532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [16534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [16536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [16538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [16540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [16542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3436),
  [16544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [16546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [16548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3330),
  [16550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3344),
  [16552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3345),
  [16554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [16556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [16558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [16560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [16562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [16564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [16566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [16568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [16570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [16572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11909),
  [16574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13923),
  [16576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11838),
  [16578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [16580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9756),
  [16582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2556),
  [16584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [16586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [16588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [16590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14460),
  [16592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16408),
  [16594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16409),
  [16596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [16598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9883),
  [16600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [16602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16468),
  [16604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16469),
  [16606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16504),
  [16608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16505),
  [16610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [16612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [16614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [16616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11711),
  [16618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [16620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10162),
  [16622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [16624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [16626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [16628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [16630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14113),
  [16632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [16634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [16636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [16638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16360),
  [16640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16361),
  [16642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11857),
  [16644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13894),
  [16646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [16648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [16650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [16652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [16654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [16656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [16658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [16660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [16662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [16664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11695),
  [16666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11870),
  [16668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13899),
  [16670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11698),
  [16672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14895),
  [16674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15077),
  [16676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [16678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11224),
  [16680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [16682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [16684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2818),
  [16686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1546),
  [16688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [16690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [16692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3701),
  [16694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3752),
  [16696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [16698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9659),
  [16700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11597),
  [16702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2629),
  [16704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3754),
  [16706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [16708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [16710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2896),
  [16712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [16714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2898),
  [16716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [16718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [16720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2901),
  [16722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2902),
  [16724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [16726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [16728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [16730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13922),
  [16732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [16734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13922),
  [16737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11909),
  [16740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [16742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [16744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9817),
  [16746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [16748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [16750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [16752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [16754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11832),
  [16756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14141),
  [16758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17960),
  [16760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15204),
  [16762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17966),
  [16764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [16766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11655),
  [16768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [16770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [16772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [16774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [16776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2088),
  [16778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [16780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [16782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [16784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [16786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [16788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [16790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [16792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [16794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6318),
  [16796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [16798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [16800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6375),
  [16802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [16804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15087),
  [16806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [16808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7931),
  [16810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [16812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [16814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10112),
  [16816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [16818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [16820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7213),
  [16822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [16824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [16826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7170),
  [16828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [16830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16358),
  [16832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16359),
  [16834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [16836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11189),
  [16838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2546),
  [16840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14580),
  [16842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [16844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [16846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [16848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [16850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10313),
  [16852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [16854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [16856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2431),
  [16858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8820),
  [16860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [16862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3751),
  [16865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [16867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7173),
  [16869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [16871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16427),
  [16873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16428),
  [16875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [16877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [16879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [16881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [16883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9935),
  [16885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [16887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11836),
  [16889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13883),
  [16891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14236),
  [16893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [16895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [16897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [16899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1992),
  [16901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [16903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [16905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [16907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [16909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [16911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [16913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [16915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [16917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3751),
  [16919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1, 0, 0),
  [16921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2601),
  [16923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [16925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [16927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13893),
  [16929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [16931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11135),
  [16933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [16935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13893),
  [16938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11857),
  [16941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [16943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9922),
  [16945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [16947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [16949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9057),
  [16951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [16953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [16955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [16957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [16959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [16961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [16963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11768),
  [16965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [16967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16367),
  [16969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16368),
  [16971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [16973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [16975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [16977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [16979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11288),
  [16981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [16983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11879),
  [16985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13907),
  [16987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [16989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10583),
  [16991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [16993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2891),
  [16995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2931),
  [16997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9705),
  [16999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12237),
  [17001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2631),
  [17003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2893),
  [17005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2933),
  [17007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2934),
  [17009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2935),
  [17011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2936),
  [17013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2937),
  [17015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2938),
  [17017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2939),
  [17019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2940),
  [17021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2941),
  [17023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [17025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [17027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2944),
  [17029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [17031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [17033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [17035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11889),
  [17037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13912),
  [17039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [17041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7780),
  [17043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [17045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [17047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [17049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [17051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [17053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [17055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [17057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [17059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [17061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [17063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [17065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [17067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [17069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [17071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1960),
  [17073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [17075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [17077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [17079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [17081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [17083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [17085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [17087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [17089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [17091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [17093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10398),
  [17095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [17097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [17099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [17101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [17103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [17105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [17107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [17109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [17111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [17113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [17115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [17117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [17119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [17121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [17123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18138),
  [17125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [17127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [17129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2603),
  [17131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [17133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [17135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [17137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [17139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [17141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [17143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [17145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [17147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [17149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [17151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [17153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [17155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [17157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6034),
  [17159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [17161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [17163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [17165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [17167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2329),
  [17169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16610),
  [17171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [17173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [17175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [17177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9432),
  [17179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [17181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [17183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [17185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [17187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [17189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [17191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [17193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [17195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [17197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [17199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [17201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11689),
  [17203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [17205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [17207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [17209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [17211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [17213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [17215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13898),
  [17217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3701),
  [17220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13898),
  [17223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11870),
  [17226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [17228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11702),
  [17230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [17232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [17234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [17236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11708),
  [17238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14901),
  [17240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15054),
  [17242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [17244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6061),
  [17246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [17248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15085),
  [17250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15083),
  [17252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11998),
  [17254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13957),
  [17256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11615),
  [17258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1930),
  [17260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1976),
  [17262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2890),
  [17264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2930),
  [17266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2957),
  [17268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9663),
  [17270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [17272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2932),
  [17274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2959),
  [17276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2960),
  [17278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [17280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2962),
  [17282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2963),
  [17284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2964),
  [17286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2965),
  [17288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2966),
  [17290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2967),
  [17292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2968),
  [17294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2969),
  [17296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2970),
  [17298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [17300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [17302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15062),
  [17304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [17306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [17308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [17312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [17314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3217),
  [17316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3322),
  [17318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9655),
  [17320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2607),
  [17322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3323),
  [17324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [17326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3326),
  [17328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3327),
  [17330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [17332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3225),
  [17334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3226),
  [17336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3227),
  [17338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3228),
  [17340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3229),
  [17342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3230),
  [17344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3231),
  [17346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [17348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [17350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [17352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [17354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [17356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [17358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [17360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [17362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [17364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [17366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3040),
  [17368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [17370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9666),
  [17372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2654),
  [17374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3042),
  [17376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3065),
  [17378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3066),
  [17380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [17382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [17384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3069),
  [17386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3070),
  [17388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [17390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3072),
  [17392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3073),
  [17394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [17396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3075),
  [17398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2035),
  [17400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [17402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3613),
  [17404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [17406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9618),
  [17408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [17410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [17412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [17414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [17416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [17418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [17420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3614),
  [17422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [17424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [17426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3661),
  [17428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3662),
  [17430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3663),
  [17432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [17434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [17436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [17438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [17440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3182),
  [17442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3630),
  [17444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [17446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2674),
  [17448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [17450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [17452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [17454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [17456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [17458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3631),
  [17460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [17462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [17464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3622),
  [17466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3623),
  [17468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3624),
  [17470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [17472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [17474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [17476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [17478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [17480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [17482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3039),
  [17484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3064),
  [17486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [17488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1686),
  [17490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [17492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [17494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [17496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [17498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [17500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3639),
  [17502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [17504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [17506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [17508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [17510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [17512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [17514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [17516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3643),
  [17518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [17520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [17522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3650),
  [17524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [17526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3652),
  [17528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [17530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [17532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [17534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3165),
  [17537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [17539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [17541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [17543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [17545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2641),
  [17547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [17549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [17551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [17553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [17555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [17557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1740),
  [17559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [17561] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3182),
  [17564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16518),
  [17566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16519),
  [17568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [17570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [17572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [17574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3039),
  [17577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [17579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1792),
  [17581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2555),
  [17583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [17585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [17587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [17589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [17591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15088),
  [17593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [17595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11747),
  [17597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13812),
  [17599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [17601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [17603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [17605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [17607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [17609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [17611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [17613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [17615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [17617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [17619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [17621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [17623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [17625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [17627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2923),
  [17630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [17632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [17634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0),
  [17636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0),
  [17638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [17640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [17642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13882),
  [17644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13882),
  [17647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11836),
  [17650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [17652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [17654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [17656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2890),
  [17659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [17661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [17663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13904),
  [17665] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13904),
  [17668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11879),
  [17671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13911),
  [17673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13911),
  [17676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11889),
  [17679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [17681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11656),
  [17683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [17685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11770),
  [17687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13821),
  [17689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11671),
  [17691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14740),
  [17693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3570),
  [17696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [17698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2526),
  [17700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [17702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [17704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [17706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14912),
  [17708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [17710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15084),
  [17712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [17714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15086),
  [17716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [17718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11747),
  [17721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3058),
  [17724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2955),
  [17727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14678),
  [17729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13954),
  [17731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2664),
  [17733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2660),
  [17735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2993),
  [17737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [17740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT(2569),
  [17743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [17745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [17747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [17749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3352),
  [17751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [17753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3354),
  [17755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3371),
  [17757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3372),
  [17759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3373),
  [17761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3374),
  [17763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3375),
  [17765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3376),
  [17767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3377),
  [17769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3378),
  [17771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3379),
  [17773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3380),
  [17775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3381),
  [17777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3382),
  [17779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3214),
  [17781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3215),
  [17783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [17785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9632),
  [17787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2680),
  [17789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3250),
  [17791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3306),
  [17793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3351),
  [17795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3417),
  [17797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [17799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3768),
  [17801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2974),
  [17803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2992),
  [17805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3129),
  [17807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3147),
  [17809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3189),
  [17811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [17813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4027),
  [17815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [17817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [17819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [17821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [17823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [17825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [17827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [17829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3810),
  [17831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2889),
  [17833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3816),
  [17835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3817),
  [17837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3818),
  [17839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3819),
  [17841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [17843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [17845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [17847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2994),
  [17849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2995),
  [17851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9630),
  [17853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2583),
  [17855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2996),
  [17857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2998),
  [17859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3016),
  [17861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3017),
  [17863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [17865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3019),
  [17867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3037),
  [17869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [17871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3056),
  [17873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3057),
  [17875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3109),
  [17877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3110),
  [17879] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), SHIFT(2569),
  [17882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0),
  [17885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13954),
  [17888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3368),
  [17890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3386),
  [17892] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3392),
  [17894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3393),
  [17896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3394),
  [17898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3395),
  [17900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3396),
  [17902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3397),
  [17904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3398),
  [17906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [17908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2669),
  [17910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2997),
  [17912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3255),
  [17914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13811),
  [17916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1, 0, 0),
  [17918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [17920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [17922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1184),
  [17924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13820),
  [17926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13820),
  [17929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11770),
  [17932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11998),
  [17935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16516),
  [17937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16517),
  [17939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3370),
  [17941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3388),
  [17943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3389),
  [17945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3390),
  [17947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3391),
  [17949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(2993),
  [17952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15070),
  [17954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14876),
  [17956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3214),
  [17959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2521),
  [17961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [17963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [17965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13811),
  [17968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [17970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3415),
  [17972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3086),
  [17975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3284),
  [17977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3285),
  [17979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3286),
  [17981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3287),
  [17983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3288),
  [17985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3274),
  [17987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3281),
  [17989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3282),
  [17991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3283),
  [17993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3291),
  [17995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3292),
  [17997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3277),
  [17999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3278),
  [18001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3295),
  [18003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3296),
  [18005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3385),
  [18007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3402),
  [18009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [18011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3409),
  [18013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3410),
  [18015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3411),
  [18017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3412),
  [18019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3413),
  [18021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3414),
  [18023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [18025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [18027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3387),
  [18029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3404),
  [18031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3405),
  [18033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3406),
  [18035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3407),
  [18037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [18039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3148),
  [18042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3484),
  [18044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3501),
  [18046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3506),
  [18048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [18050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3508),
  [18052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3509),
  [18054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [18056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [18058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3512),
  [18060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3486),
  [18062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3502),
  [18064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [18066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3504),
  [18068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [18070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4008),
  [18072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [18074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [18076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [18078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [18080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4012),
  [18082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [18084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4009),
  [18086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [18088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [18090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4066),
  [18092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4067),
  [18094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [18096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [18098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [18100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [18102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2, 0, 0),
  [18104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3596),
  [18106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [18108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [18110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3597),
  [18112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [18114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [18116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [18118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [18120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3599),
  [18122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [18124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [18126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3606),
  [18128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3607),
  [18130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3608),
  [18132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [18134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [18136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [18138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [18140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [18142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [18144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [18146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [18148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [18150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [18152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [18154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3132),
  [18156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [18158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [18160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [18162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [18164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [18166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [18168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [18170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [18172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4022),
  [18174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [18176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [18178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3804),
  [18180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [18182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [18184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [18186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4023),
  [18188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [18190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [18192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [18194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4017),
  [18196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4018),
  [18198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [18200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [18202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4021),
  [18204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4072),
  [18206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [18208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [18210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [18212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [18214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [18216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [18218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4051),
  [18220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [18222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [18224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4057),
  [18226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4058),
  [18228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4059),
  [18230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [18232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [18234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [18236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3891),
  [18238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [18240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [18242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [18244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [18246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [18248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [18250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [18252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3892),
  [18254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [18256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [18258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [18260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [18262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3932),
  [18264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3933),
  [18266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [18268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [18270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3907),
  [18272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [18274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [18276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [18278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [18280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [18282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [18284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [18286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3908),
  [18288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [18290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [18292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3900),
  [18294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [18296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [18298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [18300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [18302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [18304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4074),
  [18306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [18308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [18310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [18312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [18314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [18316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3917),
  [18318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [18320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3914),
  [18322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [18324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [18326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3921),
  [18328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3922),
  [18330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3923),
  [18332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [18334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [18336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [18338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11846),
  [18340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13888),
  [18342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11693),
  [18344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14886),
  [18346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3202),
  [18348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3203),
  [18350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [18352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3111),
  [18355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18007),
  [18357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [18359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [18361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [18363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9606),
  [18365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2670),
  [18367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [18369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [18371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [18373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [18375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [18377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3592),
  [18379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [18381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [18383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3586),
  [18385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3587),
  [18387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3588),
  [18389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [18391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [18393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [18395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3190),
  [18397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3191),
  [18399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3192),
  [18401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [18403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3194),
  [18405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3195),
  [18407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3196),
  [18409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3197),
  [18411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3198),
  [18413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3199),
  [18415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [18417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [18419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [18421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [18423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7439),
  [18425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7852),
  [18427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3966),
  [18429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [18431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2667),
  [18433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [18435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [18437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [18439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [18441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [18443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3967),
  [18445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [18447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [18449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [18451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3961),
  [18453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3962),
  [18455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [18457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [18459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [18461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [18463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_open_tuple_repeat1, 2, 0, 0), SHIFT_REPEAT(3256),
  [18466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3710),
  [18468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3807),
  [18470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [18472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [18474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [18476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [18478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [18480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [18482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3807),
  [18484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [18486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3844),
  [18488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3846),
  [18490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3848),
  [18492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3849),
  [18494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [18496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [18498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [18500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [18502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [18504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [18506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5495),
  [18508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9001),
  [18510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [18512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [18514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [18516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3307),
  [18518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [18520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [18522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3299),
  [18524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3300),
  [18526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3301),
  [18528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [18530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [18532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [18534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3308),
  [18536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [18538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [18540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [18542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [18544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [18546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [18548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [18550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [18552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [18554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3235),
  [18556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3236),
  [18558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3237),
  [18560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3238),
  [18562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3239),
  [18564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3240),
  [18566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3241),
  [18568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3242),
  [18570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3243),
  [18572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3244),
  [18574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3245),
  [18576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [18578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [18580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3149),
  [18582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [18584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [18586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3745),
  [18588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3746),
  [18590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3747),
  [18592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [18594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [18596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [18598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [18600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3150),
  [18602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [18604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [18606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3741),
  [18608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [18610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [18612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [18614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [18616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [18618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [18620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3786),
  [18622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3787),
  [18624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3788),
  [18626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [18628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [18630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [18632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [18634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [18636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [18638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [18640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [18642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3779),
  [18644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3793),
  [18646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [18648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [18650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3730),
  [18652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3731),
  [18654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3732),
  [18656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [18658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [18660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [18662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [18664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [18666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [18668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [18670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [18672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [18674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3721),
  [18676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3166),
  [18678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3167),
  [18680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [18682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [18684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [18686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [18688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [18690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [18692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3167),
  [18694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [18696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [18698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3158),
  [18700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3159),
  [18702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3160),
  [18704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [18706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [18708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [18710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16736),
  [18712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7795),
  [18714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6460),
  [18716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [18718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [18720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8415),
  [18722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [18724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [18726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3780),
  [18728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [18730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13887),
  [18732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(13887),
  [18735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, 0, 0), SHIFT_REPEAT(11846),
  [18738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14898),
  [18740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [18742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2621),
  [18744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [18746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [18748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11630),
  [18750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [18752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [18754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [18756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [18758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2604),
  [18760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [18762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [18764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11124),
  [18766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [18768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1959),
  [18770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13737),
  [18772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10979),
  [18774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13148),
  [18776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [18778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [18780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [18782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [18784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [18786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [18788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [18790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [18792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [18794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [18796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2168),
  [18798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [18800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2479),
  [18802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [18804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [18806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1481),
  [18808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [18810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2481),
  [18812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13735),
  [18814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10975),
  [18816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13280),
  [18818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3534),
  [18820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [18822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [18824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3543),
  [18826] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3544),
  [18828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3545),
  [18830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [18832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [18834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [18836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [18838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [18840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [18842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [18844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [18846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [18848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [18850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [18852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [18854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2146),
  [18856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13741),
  [18858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11009),
  [18860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13179),
  [18862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [18864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [18866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6839),
  [18868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [18870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1794),
  [18872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [18874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [18876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [18878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [18880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [18882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2206),
  [18884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2489),
  [18886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [18888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [18890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2403),
  [18892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [18894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [18896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13675),
  [18898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10886),
  [18900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13164),
  [18902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [18904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [18906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [18908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6900),
  [18910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [18912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [18914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [18916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [18918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2446),
  [18920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [18922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [18924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [18926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2545),
  [18928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [18930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [18932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7801),
  [18934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [18936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9819),
  [18938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [18940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [18942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [18944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [18946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [18948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [18950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [18952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [18954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2562),
  [18956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2483),
  [18958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [18960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6216),
  [18962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2238),
  [18964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [18966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [18968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16694),
  [18970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2570),
  [18972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [18974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [18976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [18978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6956),
  [18980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [18982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [18984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [18986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7541),
  [18988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2277),
  [18990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1530),
  [18992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [18994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [18996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11213),
  [18998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2375),
  [19000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7096),
  [19002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [19004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [19006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [19008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [19010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [19012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [19014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [19016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [19018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17987),
  [19020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2221),
  [19022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1525),
  [19024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [19026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [19028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8952),
  [19030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2357),
  [19032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [19034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [19036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8779),
  [19038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [19040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [19042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [19044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [19046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [19048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [19050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2369),
  [19052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [19054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2551),
  [19056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [19058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1337),
  [19060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1542),
  [19062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2687),
  [19064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1543),
  [19066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1544),
  [19068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [19070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [19072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13705),
  [19074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10896),
  [19076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13284),
  [19078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [19080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [19082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10902),
  [19084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13132),
  [19086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [19088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [19090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [19092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [19094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [19096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [19098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [19100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3061),
  [19102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [19104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [19106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3096),
  [19108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3097),
  [19110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3098),
  [19112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [19114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [19116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [19118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [19120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [19122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11359),
  [19124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [19126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [19128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [19130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [19132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [19134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [19136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3088),
  [19138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [19140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [19142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [19144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2691),
  [19146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1872),
  [19148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [19150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [19152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10869),
  [19154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13360),
  [19156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1999),
  [19158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [19160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [19162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13718),
  [19164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10904),
  [19166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13181),
  [19168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [19170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6424),
  [19172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [19174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0),
  [19176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [19178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [19180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [19182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [19184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [19186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [19188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3838),
  [19190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [19192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [19194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [19196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [19198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [19200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [19202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3839),
  [19204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [19206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [19208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3829),
  [19210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3830),
  [19212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3831),
  [19214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [19216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [19218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [19220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [19222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11830),
  [19224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [19226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [19228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [19230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11369),
  [19232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1908),
  [19234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1957),
  [19236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [19238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2457),
  [19240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1588),
  [19242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13733),
  [19244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10959),
  [19246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13149),
  [19248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13739),
  [19250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11001),
  [19252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13165),
  [19254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [19256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8390),
  [19258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13726),
  [19260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10925),
  [19262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13251),
  [19264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [19266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1496),
  [19268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5969),
  [19270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2433),
  [19272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [19274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [19276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_field, 3, 0, 0),
  [19278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [19280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [19282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10581),
  [19284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2459),
  [19286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [19288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11076),
  [19290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13399),
  [19292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [19294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10526),
  [19296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [19298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7285),
  [19300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2685),
  [19302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11078),
  [19304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13417),
  [19306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [19308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [19310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1776),
  [19312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [19314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [19316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10255),
  [19318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [19320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [19322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [19324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10943),
  [19326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13420),
  [19328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [19330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [19332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2014),
  [19334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0),
  [19336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [19338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9450),
  [19340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2463),
  [19342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [19344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [19346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [19348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [19350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [19352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10482),
  [19354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11093),
  [19356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13430),
  [19358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11095),
  [19360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13425),
  [19362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11104),
  [19364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13433),
  [19366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [19368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11155),
  [19370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13428),
  [19372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11106),
  [19374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13436),
  [19376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [19378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11108),
  [19380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13138),
  [19382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [19384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [19386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [19388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [19390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [19392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1571),
  [19394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [19396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_vector_expression_repeat1, 2, 0, 0),
  [19398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [19400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [19402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [19404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1819),
  [19406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [19408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [19410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [19412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [19414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1824),
  [19416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [19418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [19420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [19422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [19424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10120),
  [19426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2222),
  [19428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11146),
  [19430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13180),
  [19432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1753),
  [19434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [19436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [19438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [19440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [19442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [19444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [19446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [19448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [19450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [19452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [19454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [19456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [19458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [19460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [19462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [19464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4006),
  [19466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [19468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [19470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [19472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [19474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [19476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [19478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3994),
  [19480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [19482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [19484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3988),
  [19486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3989),
  [19488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3990),
  [19490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [19492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [19494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [19496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3251),
  [19498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [19500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2597),
  [19502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [19504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [19506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [19508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3261),
  [19510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [19512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3258),
  [19514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [19516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [19518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3265),
  [19520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3266),
  [19522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3267),
  [19524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [19526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [19528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [19530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [19532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [19534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [19536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4050),
  [19538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [19540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [19542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [19544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [19546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3888),
  [19548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [19550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [19552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [19554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3883),
  [19556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3884),
  [19558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3885),
  [19560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [19562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3887),
  [19564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [19566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2918),
  [19568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [19570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [19572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [19574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2907),
  [19576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [19578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2910),
  [19580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [19582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [19584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2917),
  [19586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [19588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [19590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [19592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [19594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [19596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3087),
  [19598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [19600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [19602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [19604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [19606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [19608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3704),
  [19610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [19612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [19614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3683),
  [19616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3684),
  [19618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3685),
  [19620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [19622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [19624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [19626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9545),
  [19628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18061),
  [19630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9601),
  [19632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17801),
  [19634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9563),
  [19636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18140),
  [19638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9573),
  [19640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17948),
  [19642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9607),
  [19644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18178),
  [19646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [19648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [19650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [19652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3077),
  [19654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [19656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [19658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3085),
  [19660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3103),
  [19662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3104),
  [19664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [19666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [19668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [19670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9624),
  [19672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9602),
  [19674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17852),
  [19676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9596),
  [19678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17855),
  [19680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9650),
  [19682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17756),
  [19684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [19686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17821),
  [19688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9595),
  [19690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9590),
  [19692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9680),
  [19694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9695),
  [19696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17927),
  [19698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15622),
  [19700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [19702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [19704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [19706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [19708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [19710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9646),
  [19712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18108),
  [19714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9597),
  [19716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [19718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17994),
  [19720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9586),
  [19722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9565),
  [19724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17974),
  [19726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9571),
  [19728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16627),
  [19730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9537),
  [19732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18124),
  [19734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9570),
  [19736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9609),
  [19738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9643),
  [19740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18063),
  [19742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2649),
  [19744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9620),
  [19746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9714),
  [19748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17819),
  [19750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9538),
  [19752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17903),
  [19754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9704),
  [19756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18180),
  [19758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9591),
  [19760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18047),
  [19762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9625),
  [19764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9696),
  [19766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17845),
  [19768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9698),
  [19770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17847),
  [19772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9707),
  [19774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17921),
  [19776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9608),
  [19778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15414),
  [19780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9594),
  [19782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9612),
  [19784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3677),
  [19786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9642),
  [19788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17997),
  [19790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [19792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9613),
  [19794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9614),
  [19796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9619),
  [19798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9566),
  [19800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17815),
  [19802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9710),
  [19804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18210),
  [19806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16975),
  [19808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9713),
  [19810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17725),
  [19812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [19814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9561),
  [19816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18045),
  [19818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9699),
  [19820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17979),
  [19822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9622),
  [19824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9651),
  [19826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17749),
  [19828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9719),
  [19830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18205),
  [19832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9546),
  [19834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17846),
  [19836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9681),
  [19838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18141),
  [19840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9694),
  [19842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17769),
  [19844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9577),
  [19846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18114),
  [19848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9627),
  [19850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9582),
  [19852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9583),
  [19854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9540),
  [19856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17813),
  [19858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9578),
  [19860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17800),
  [19862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9558),
  [19864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17868),
  [19866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9600),
  [19868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [19870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [19872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [19874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [19876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [19878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [19880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [19882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [19884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [19886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [19888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9554),
  [19890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [19892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [19894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9632),
  [19896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11597),
  [19898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [19900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [19902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [19904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [19906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [19908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [19910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [19912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [19914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9751),
  [19916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9874),
  [19918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [19920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [19922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [19924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [19926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clause, 2, 0, 0),
  [19928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [19930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10161),
  [19932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clause, 1, 0, 0),
  [19934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0),
  [19936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3776),
  [19939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(2569),
  [19942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3500),
  [19945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(1356),
  [19948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [19950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [19952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(3384),
  [19955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [19957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [19959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [19961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17538),
  [19963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16967),
  [19965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11231),
  [19967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17288),
  [19969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16991),
  [19971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17491),
  [19973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17014),
  [19975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11236),
  [19977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17469),
  [19979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16592),
  [19981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [19983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [19985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [19987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8732),
  [19989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7210),
  [19991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [19993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10993),
  [19995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9551),
  [19997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6563),
  [19999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [20001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11017),
  [20003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9544),
  [20005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [20007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [20009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [20011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6595),
  [20013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [20015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [20017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [20019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6310),
  [20021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [20023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [20025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [20027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6093),
  [20029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11633),
  [20031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [20033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [20035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [20037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10986),
  [20039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9548),
  [20041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [20043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [20045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [20047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [20049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [20051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [20053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11637),
  [20055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [20057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9208),
  [20059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [20061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11484),
  [20063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [20065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [20067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [20069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7872),
  [20071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [20073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [20075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [20077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [20079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11448),
  [20081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [20083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [20085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [20087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9764),
  [20089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2466),
  [20091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9767),
  [20093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [20095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [20097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [20099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2494),
  [20101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [20103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [20105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [20107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7426),
  [20109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [20111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [20113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6417),
  [20115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [20117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [20119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [20121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11013),
  [20123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9690),
  [20125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [20127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [20129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [20131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [20133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [20135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [20137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(17538),
  [20140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(16967),
  [20143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [20145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [20147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [20149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6206),
  [20151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6208),
  [20153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [20155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [20157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2578),
  [20159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6218),
  [20161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6224),
  [20163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [20165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [20167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [20169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6425),
  [20171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [20173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6167),
  [20175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [20177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [20179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [20181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [20183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10988),
  [20185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9564),
  [20187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(17288),
  [20190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(16991),
  [20193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat2, 2, 0, 0),
  [20195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [20197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16688),
  [20199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [20201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16689),
  [20203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [20205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [20207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [20209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7951),
  [20211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [20213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16698),
  [20215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2622),
  [20217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16703),
  [20219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10996),
  [20221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9679),
  [20223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [20225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [20227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2400),
  [20230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2400),
  [20233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [20235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [20237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [20239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11018),
  [20241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9568),
  [20243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [20245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7995),
  [20247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [20249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [20251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9988),
  [20253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [20255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 2, 0, 0),
  [20257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [20259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11205),
  [20261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8066),
  [20263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2476),
  [20265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [20267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [20269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [20271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11805),
  [20273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [20275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [20277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11809),
  [20279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [20281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [20283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [20285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11894),
  [20287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10991),
  [20289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9647),
  [20291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [20293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7429),
  [20295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [20297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11897),
  [20299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11345),
  [20301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11349),
  [20303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [20305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [20307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [20309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [20311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11019),
  [20313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9593),
  [20315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7544),
  [20317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11454),
  [20319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [20321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11196),
  [20323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11202),
  [20325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [20327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [20329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [20331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [20333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11115),
  [20335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11206),
  [20337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11118),
  [20339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16514),
  [20341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16515),
  [20343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7088),
  [20345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7089),
  [20347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [20349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7112),
  [20351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [20353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2378),
  [20355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [20357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [20359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [20361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [20363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5504),
  [20365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [20367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8386),
  [20369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10796),
  [20371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10802),
  [20373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11068),
  [20375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9592),
  [20377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11126),
  [20379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [20381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [20383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8393),
  [20385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [20387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8394),
  [20389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1867),
  [20391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [20393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [20395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [20397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11020),
  [20399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9637),
  [20401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7240),
  [20403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7472),
  [20405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11215),
  [20407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [20409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17901),
  [20411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [20413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10577),
  [20415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17909),
  [20417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [20419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11216),
  [20421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11127),
  [20423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10617),
  [20425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [20427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18014),
  [20429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [20431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clause_repeat1, 1, 0, 0),
  [20433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10259),
  [20435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [20437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [20439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18028),
  [20441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [20443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [20445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10319),
  [20447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1738),
  [20449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [20451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11016),
  [20453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9693),
  [20455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7768),
  [20457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11456),
  [20459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7769),
  [20461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10561),
  [20463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [20465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10564),
  [20467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(17491),
  [20470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(17014),
  [20473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat1, 2, 0, 0),
  [20475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9121),
  [20477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9143),
  [20479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [20481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [20483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10749),
  [20485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [20487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10486),
  [20489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9007),
  [20491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10487),
  [20493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11066),
  [20495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9660),
  [20497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [20499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [20501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [20503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(17469),
  [20506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(16592),
  [20509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat2, 2, 0, 0),
  [20511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8147),
  [20513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [20515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [20517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [20519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [20521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7292),
  [20523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [20525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [20527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10521),
  [20529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10386),
  [20531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10972),
  [20533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9640),
  [20535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [20537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9234),
  [20539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [20541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [20543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9235),
  [20545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [20547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11004),
  [20549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9587),
  [20551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8187),
  [20553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8188),
  [20555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [20557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [20559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [20561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11021),
  [20563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9644),
  [20565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8776),
  [20567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [20569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8783),
  [20571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8786),
  [20573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [20575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2514),
  [20577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5880),
  [20579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [20581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11012),
  [20583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9652),
  [20585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [20587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11123),
  [20589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [20591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [20593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8214),
  [20595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [20597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5881),
  [20599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [20601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6466),
  [20603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [20605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [20607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5913),
  [20609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6834),
  [20611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [20613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [20615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [20617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [20619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [20621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [20623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6841),
  [20625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [20627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6843),
  [20629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [20631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [20633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7375),
  [20635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9467),
  [20637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9433),
  [20639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [20641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [20643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [20645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [20647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10439),
  [20649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [20651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10455),
  [20653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [20655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [20657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [20659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11022),
  [20661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9683),
  [20663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7972),
  [20665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10263),
  [20667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10266),
  [20669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7974),
  [20671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [20673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11624),
  [20675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [20677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [20679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [20681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [20683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6487),
  [20685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [20687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [20689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5918),
  [20691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9246),
  [20693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [20695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9440),
  [20697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9928),
  [20699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [20701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [20703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [20705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10485),
  [20707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10500),
  [20709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [20711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [20713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2025),
  [20715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [20717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7007),
  [20719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11006),
  [20721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9717),
  [20723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11067),
  [20725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9657),
  [20727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [20729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [20731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_clause, 3, 0, 0),
  [20733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [20735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10037),
  [20737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [20739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [20741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [20743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11154),
  [20745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9661),
  [20747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [20749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [20751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2482),
  [20753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2541),
  [20756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [20758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11160),
  [20760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9665),
  [20762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8043),
  [20764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12205),
  [20766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [20768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [20770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [20772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [20774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12206),
  [20776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11164),
  [20778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9668),
  [20780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2458),
  [20782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [20784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11167),
  [20786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9670),
  [20788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [20790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11169),
  [20792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9672),
  [20794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5413),
  [20796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9938),
  [20798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9941),
  [20800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11122),
  [20802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9633),
  [20804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8267),
  [20806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [20808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [20810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [20812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [20814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [20816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9954),
  [20818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [20820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9957),
  [20822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8209),
  [20824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8210),
  [20826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [20828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [20830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12035),
  [20832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12039),
  [20834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [20836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11007),
  [20838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9678),
  [20840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [20842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [20844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [20846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [20848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [20850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8044),
  [20852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12082),
  [20854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [20856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11626),
  [20858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10717),
  [20860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10719),
  [20862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8855),
  [20864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8858),
  [20866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [20868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [20870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [20872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [20874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11276),
  [20876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [20878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [20880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [20882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [20884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11283),
  [20886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10013),
  [20888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [20890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [20892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [20894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [20896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10970),
  [20898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9547),
  [20900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11014),
  [20902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9639),
  [20904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6303),
  [20906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6084),
  [20908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [20910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [20912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [20914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [20916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [20918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [20920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [20922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8360),
  [20924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [20926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [20928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [20930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [20932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10139),
  [20934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10070),
  [20936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7582),
  [20938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [20940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [20942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [20944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7594),
  [20946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [20948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [20950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [20952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [20954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10989),
  [20956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9635),
  [20958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1963),
  [20961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1963),
  [20964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10136),
  [20966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10138),
  [20968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [20970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8695),
  [20972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8702),
  [20974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [20976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [20978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11482),
  [20980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [20982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(1352),
  [20985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [20987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11153),
  [20989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [20991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7121),
  [20993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [20995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10967),
  [20997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9706),
  [20999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [21001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [21003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7928),
  [21005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [21007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9792),
  [21009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [21011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11159),
  [21013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9664),
  [21015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6046),
  [21017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [21019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11163),
  [21021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9667),
  [21023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [21025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [21027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [21029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [21031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11166),
  [21033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9669),
  [21035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11168),
  [21037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9671),
  [21039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11170),
  [21041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9673),
  [21043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11171),
  [21045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9674),
  [21047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11172),
  [21049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9675),
  [21051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11173),
  [21053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9676),
  [21055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [21057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [21059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [21061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8324),
  [21063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [21065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [21067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11008),
  [21069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9575),
  [21071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [21073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [21075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [21077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9793),
  [21079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7431),
  [21081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [21083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [21085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8218),
  [21087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12044),
  [21089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [21091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1574),
  [21094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1574),
  [21097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7998),
  [21099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11483),
  [21101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [21103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12241),
  [21105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [21107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10735),
  [21109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [21111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [21113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [21115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [21117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1743),
  [21120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1743),
  [21123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8191),
  [21125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9209),
  [21127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8362),
  [21129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8300),
  [21131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11457),
  [21133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8164),
  [21135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [21137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9317),
  [21139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8111),
  [21141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [21143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(3350),
  [21146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 0),
  [21148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [21150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [21152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [21154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7932),
  [21156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16216),
  [21158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [21160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [21162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8915),
  [21164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9190),
  [21166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10818),
  [21168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [21170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [21172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7251),
  [21174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12207),
  [21176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11493),
  [21178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [21180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10807),
  [21182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [21184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7992),
  [21186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [21188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2638),
  [21191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(2638),
  [21194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [21196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17372),
  [21198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10197),
  [21200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17672),
  [21202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17612),
  [21204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10213),
  [21206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17413),
  [21208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [21210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [21212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10235),
  [21214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10231),
  [21216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [21218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5076),
  [21220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [21222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10466),
  [21224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [21226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delimiter_cmd_3, 1, 0, 0),
  [21228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6697),
  [21230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [21232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [21234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [21236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [21238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [21240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11921),
  [21242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [21244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [21246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [21248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [21250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6622),
  [21252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [21254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [21256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [21258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [21260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10360),
  [21262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11709),
  [21264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5474),
  [21266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [21268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [21270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11710),
  [21272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [21274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [21276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [21278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5171),
  [21280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [21282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [21284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [21286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5180),
  [21288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [21290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [21292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10691),
  [21294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11511),
  [21296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11512),
  [21298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11515),
  [21300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11516),
  [21302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [21304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [21306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9809),
  [21308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [21310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [21312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10828),
  [21314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11725),
  [21316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7734),
  [21318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [21320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [21322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11727),
  [21324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [21326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 5, 0, 0),
  [21328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7422),
  [21330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [21332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [21334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [21336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [21338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7216),
  [21340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 5, 0, 20),
  [21342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15027),
  [21344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7218),
  [21346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [21348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6741),
  [21350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [21352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [21354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5135),
  [21356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [21358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [21360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6755),
  [21362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [21364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [21366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1385),
  [21368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10218),
  [21370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4694),
  [21372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [21374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [21376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [21378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [21380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10269),
  [21382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7005),
  [21384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [21386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_interpolation, 2, 0, 0),
  [21388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8389),
  [21390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [21392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [21394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [21396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [21398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [21400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5462),
  [21402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [21404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [21406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5584),
  [21408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [21410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [21412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11821),
  [21414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11822),
  [21416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [21418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [21420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11828),
  [21422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11831),
  [21424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [21426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9865),
  [21428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [21430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [21432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [21434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6214),
  [21436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [21438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [21440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8400),
  [21442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [21444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [21446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [21448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [21450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [21452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [21454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [21456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [21458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6229),
  [21460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [21462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1040),
  [21464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [21466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [21468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11713),
  [21470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11714),
  [21472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11599),
  [21474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11726),
  [21476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10956),
  [21478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10957),
  [21480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [21482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [21484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9811),
  [21486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [21488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [21490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16693),
  [21492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [21494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1044),
  [21496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4702),
  [21498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [21500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [21502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16714),
  [21504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [21506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1045),
  [21508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [21510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10994),
  [21512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10995),
  [21514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [21516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [21518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [21520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10997),
  [21522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10998),
  [21524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [21526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10960),
  [21528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10961),
  [21530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6955),
  [21532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [21534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [21536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [21538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7204),
  [21540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [21542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [21544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17347),
  [21546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17386),
  [21548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5158),
  [21550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [21552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [21554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17232),
  [21556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17272),
  [21558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__do_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(3273),
  [21561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [21563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7539),
  [21565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [21567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [21569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4632),
  [21571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [21573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [21575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6086),
  [21577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [21579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [21581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [21583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7559),
  [21585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [21587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [21589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11766),
  [21591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [21593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [21595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7284),
  [21597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [21599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(922),
  [21601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [21603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [21605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11829),
  [21607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7092),
  [21609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [21611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [21613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5593),
  [21615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [21617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [21619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [21621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [21623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [21625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9743),
  [21627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [21629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4374),
  [21631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7118),
  [21633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [21635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [21637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [21639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [21641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [21643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [21645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [21647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [21649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [21651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [21653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [21655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [21657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7303),
  [21659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [21661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(924),
  [21663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [21665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [21667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [21669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5516),
  [21671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [21673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [21675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [21677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [21679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10723),
  [21681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10727),
  [21683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [21685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [21687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [21689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [21691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17963),
  [21693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [21695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [21697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [21699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [21701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [21703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18081),
  [21705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [21707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [21709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [21711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [21713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10569),
  [21715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [21717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [21719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [21721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [21723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10797),
  [21725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10743),
  [21727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6714),
  [21729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [21731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10546),
  [21733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [21735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8951),
  [21737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [21739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [21741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10252),
  [21743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [21745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [21747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11796),
  [21749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9027),
  [21751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [21753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [21755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11884),
  [21757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [21759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [21761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6586),
  [21763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [21765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [21767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8778),
  [21769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [21771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [21773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7366),
  [21775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [21777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [21779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8803),
  [21781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [21783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [21785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [21787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [21789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5238),
  [21791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [21793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [21795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [21797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6677),
  [21799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [21801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [21803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1921),
  [21805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [21807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6479),
  [21809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [21811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [21813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7384),
  [21815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [21817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [21819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11545),
  [21821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11546),
  [21823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11549),
  [21825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11552),
  [21827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10637),
  [21829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11386),
  [21831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11387),
  [21833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11392),
  [21835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11393),
  [21837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10646),
  [21839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10586),
  [21841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10589),
  [21843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10591),
  [21845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10608),
  [21847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [21849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11577),
  [21851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11580),
  [21853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11581),
  [21855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11582),
  [21857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [21859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [21861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [21863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11388),
  [21865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11389),
  [21867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [21869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11390),
  [21871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11391),
  [21873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [21875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10594),
  [21877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10598),
  [21879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10604),
  [21881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10628),
  [21883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [21885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [21887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [21889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [21891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11718),
  [21893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11719),
  [21895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11720),
  [21897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11721),
  [21899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11591),
  [21901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11592),
  [21903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11425),
  [21905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11593),
  [21907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10692),
  [21909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10764),
  [21911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10800),
  [21913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10835),
  [21915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5552),
  [21917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [21919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [21921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [21923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11186),
  [21925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10850),
  [21927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10853),
  [21929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11179),
  [21931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [21933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(703),
  [21935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [21937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [21939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [21941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [21943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [21945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [21947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6764),
  [21949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [21951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [21953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [21955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6481),
  [21957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [21959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [21961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [21963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [21965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [21967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10091),
  [21969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10113),
  [21971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10143),
  [21973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10045),
  [21975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11556),
  [21977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11572),
  [21979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11432),
  [21981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11460),
  [21983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [21985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [21987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [21989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [21991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [21993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [21995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [21997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [21999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [22001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [22003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6342),
  [22005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6343),
  [22007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5000),
  [22009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [22011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [22013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [22015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [22017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6266),
  [22019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [22021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6826),
  [22023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [22025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6828),
  [22027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6553),
  [22029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [22031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [22033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [22035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [22037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [22039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [22041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [22043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11707),
  [22045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11729),
  [22047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11705),
  [22049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11688),
  [22051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11434),
  [22053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11435),
  [22055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11455),
  [22057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11458),
  [22059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10726),
  [22061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10746),
  [22063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10762),
  [22065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10763),
  [22067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [22069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [22071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [22073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [22075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10686),
  [22077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10696),
  [22079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10700),
  [22081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10725),
  [22083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14661),
  [22085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14670),
  [22087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [22089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [22091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14723),
  [22093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14745),
  [22095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12479),
  [22097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12488),
  [22099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12493),
  [22101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12502),
  [22103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12282),
  [22105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12287),
  [22107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12288),
  [22109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12316),
  [22111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11404),
  [22113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11415),
  [22115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11382),
  [22117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11408),
  [22119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [22121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6610),
  [22123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6611),
  [22125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [22127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6847),
  [22129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6848),
  [22131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [22133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [22135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [22137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [22139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6616),
  [22141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [22143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [22145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [22147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [22149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [22151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11598),
  [22153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11519),
  [22155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [22157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [22159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11521),
  [22161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11524),
  [22163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11424),
  [22165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11385),
  [22167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11381),
  [22169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11384),
  [22171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10635),
  [22173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10647),
  [22175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10649),
  [22177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10650),
  [22179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16063),
  [22181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16209),
  [22183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16605),
  [22185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16616),
  [22187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [22189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8873),
  [22191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [22193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [22195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [22197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [22199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8567),
  [22201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8569),
  [22203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6348),
  [22205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6349),
  [22207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6350),
  [22209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [22211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10683),
  [22213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10644),
  [22215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [22217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10601),
  [22219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9446),
  [22221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10883),
  [22223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10562),
  [22225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [22227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11211),
  [22229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [22231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [22233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [22235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [22237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16536),
  [22239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16537),
  [22241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17207),
  [22243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17211),
  [22245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17223),
  [22247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17231),
  [22249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [22251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [22253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [22255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [22257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [22259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [22261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6795),
  [22263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [22265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [22267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7001),
  [22269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [22271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [22273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [22275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11658),
  [22277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(2711),
  [22280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [22282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11294),
  [22284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11307),
  [22286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [22288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10872),
  [22290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [22292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [22294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4249),
  [22296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [22298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [22300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [22302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7013),
  [22304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [22306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [22308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11221),
  [22310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [22312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [22314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10057),
  [22316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10058),
  [22318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [22320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [22322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [22324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [22326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [22328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9744),
  [22330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [22332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [22334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6125),
  [22336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [22338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [22340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4487),
  [22342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [22344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [22346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10063),
  [22348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10145),
  [22350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [22352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19440),
  [22354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [22356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11246),
  [22358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11644),
  [22360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11348),
  [22362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [22364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [22366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9835),
  [22368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9833),
  [22370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11648),
  [22372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1744),
  [22374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [22376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [22378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [22380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5811),
  [22382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [22384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [22386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11252),
  [22388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6126),
  [22390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [22392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [22394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [22396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9824),
  [22398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9825),
  [22400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [22402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [22404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [22406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [22408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1975),
  [22410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [22412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [22414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [22416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [22418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5819),
  [22420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [22422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [22424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [22426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [22428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [22430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [22432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [22434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11280),
  [22436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [22438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [22440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5862),
  [22442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [22444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9911),
  [22446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [22448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [22450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [22452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1982),
  [22454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10186),
  [22456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10187),
  [22458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [22460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9419),
  [22462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11703),
  [22464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [22466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [22468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11704),
  [22470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [22472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [22474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [22476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [22478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [22480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [22482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10224),
  [22484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5865),
  [22486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [22488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [22490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10227),
  [22492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5866),
  [22494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [22496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [22498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [22500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [22502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [22504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [22506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [22508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [22510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [22512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9418),
  [22514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [22516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [22518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [22520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2630),
  [22522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [22524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [22526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10281),
  [22528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [22530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [22532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [22534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [22536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7585),
  [22538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [22540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [22542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(17372),
  [22545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 2, 0, 0),
  [22547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [22549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [22551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [22553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [22555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [22557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5663),
  [22559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [22561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [22563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [22565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [22567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [22569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [22571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [22573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1630),
  [22575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9888),
  [22577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [22579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7603),
  [22581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [22583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [22585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [22587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [22589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [22591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [22593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [22595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [22597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(17672),
  [22600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat2, 2, 0, 0),
  [22602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [22604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [22606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [22608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [22610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [22612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [22614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [22616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [22618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [22620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18631),
  [22622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10373),
  [22624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [22626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [22628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [22630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [22632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [22634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1073),
  [22636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4880),
  [22638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [22640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [22642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6422),
  [22644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [22646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [22648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [22650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [22652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6127),
  [22654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [22656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1105),
  [22658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [22660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [22662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [22664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [22666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [22668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5901),
  [22670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6128),
  [22672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [22674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [22676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [22678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [22680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [22682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [22684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [22686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9426),
  [22688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9424),
  [22690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [22692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [22694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [22696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(721),
  [22698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [22700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [22702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [22704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [22706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [22708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [22710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [22712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [22714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6292),
  [22716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [22718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [22720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [22722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [22724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7110),
  [22726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [22728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [22730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [22732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [22734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [22736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [22738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [22740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [22742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [22744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(781),
  [22746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [22748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [22750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [22752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [22754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [22756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [22758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [22760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [22762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [22764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [22766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [22768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [22770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [22772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7130),
  [22774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [22776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [22778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [22780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [22782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [22784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [22786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_command_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(17612),
  [22789] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_command_literal_repeat1, 2, 0, 0),
  [22791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4690),
  [22793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [22795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [22797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4341),
  [22799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [22801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [22803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_prefixed_command_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(17413),
  [22806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_command_literal_repeat2, 2, 0, 0),
  [22808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [22810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [22812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [22814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6436),
  [22816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [22818] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [22820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [22822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [22824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [22826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1348),
  [22829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1348),
  [22832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [22834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [22836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [22838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [22840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [22842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [22844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [22846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [22848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [22850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [22852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [22854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [22856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6643),
  [22858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6645),
  [22860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [22862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [22864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10015),
  [22866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [22868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [22870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [22872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10381),
  [22874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [22876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [22878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [22880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [22882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [22884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 5),
  [22886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), REDUCE(aux_sym_argument_list_repeat1, 2, 0, 5),
  [22889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat2, 1, 0, 0),
  [22891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [22893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [22895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [22897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10334),
  [22899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10336),
  [22901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5877),
  [22903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [22905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [22907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [22909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11364),
  [22911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [22913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [22915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [22917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [22919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [22921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [22923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [22925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5886),
  [22927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [22929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [22931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [22933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [22935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [22937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [22939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [22941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [22943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [22945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11227),
  [22947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [22949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [22951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [22953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [22955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [22957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [22959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [22961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [22963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [22965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [22967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [22969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [22971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6453),
  [22973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [22975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [22977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [22979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [22981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9871),
  [22983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [22985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [22987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [22989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [22991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11261),
  [22993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [22995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11264),
  [22997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11628),
  [22999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [23001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(970),
  [23003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [23005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [23007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6099),
  [23009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [23011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [23013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [23015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [23017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [23019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [23021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [23023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5968),
  [23025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [23027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [23029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11646),
  [23031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [23033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [23035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [23037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [23039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [23041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [23043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [23045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10328),
  [23047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [23049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5981),
  [23051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [23053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [23055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9425),
  [23057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10675),
  [23059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [23061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [23063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [23065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [23067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [23069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10055),
  [23071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10056),
  [23073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [23075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [23077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [23079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10273),
  [23081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [23083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [23085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [23087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [23089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [23091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [23093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10074),
  [23095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10085),
  [23097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10338),
  [23099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [23101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11121),
  [23103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [23105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [23107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10286),
  [23109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [23111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6421),
  [23113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6520),
  [23115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [23117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [23119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4591),
  [23121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [23123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [23125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [23127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10525),
  [23129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [23131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [23133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11132),
  [23135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [23137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(976),
  [23139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [23141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [23143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [23145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10805),
  [23147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10794),
  [23149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [23151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [23153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [23155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [23157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10556),
  [23159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [23161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [23163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2858),
  [23166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [23168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [23170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10188),
  [23172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10189),
  [23174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [23176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10778),
  [23178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [23180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10698),
  [23182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [23184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [23186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1310),
  [23189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__block_repeat1, 2, 0, 0), SHIFT_REPEAT(1310),
  [23192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [23194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [23196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(2818),
  [23199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10384),
  [23201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [23203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [23205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5916),
  [23207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [23209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [23211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [23213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [23215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [23217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10413),
  [23219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [23221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10175),
  [23223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10847),
  [23225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10180),
  [23227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5924),
  [23229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [23231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [23233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10078),
  [23235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10088),
  [23237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [23239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [23241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [23243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10788),
  [23245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10819),
  [23247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10842),
  [23249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [23251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [23253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10066),
  [23255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10077),
  [23257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [23259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [23261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [23263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [23265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [23267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [23269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10772),
  [23271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10848),
  [23273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [23275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [23277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [23279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2640),
  [23281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10908),
  [23283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [23285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [23287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [23289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10909),
  [23291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [23293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [23295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [23297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [23299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [23301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [23303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [23305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [23307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [23309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [23311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [23313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2731),
  [23316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9463),
  [23318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [23320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [23322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [23324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [23326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [23328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10915),
  [23330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10916),
  [23332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10473),
  [23334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [23336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [23338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [23340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [23342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(988),
  [23344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [23346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10069),
  [23348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [23350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [23352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [23354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [23356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [23358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [23360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10170),
  [23362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [23364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [23366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10905),
  [23368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [23370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5638),
  [23372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10907),
  [23374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [23376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6639),
  [23378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [23380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [23382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [23384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10453),
  [23386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [23388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [23390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10912),
  [23392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10913),
  [23394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10151),
  [23396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10155),
  [23398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [23400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9882),
  [23402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [23404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [23406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [23408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [23410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6164),
  [23412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [23414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [23416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7509),
  [23418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [23420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [23422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [23424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [23426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10176),
  [23428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10181),
  [23430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [23432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11372),
  [23434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7782),
  [23436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [23438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [23440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11373),
  [23442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [23444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [23446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [23448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [23450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [23452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [23454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10846),
  [23456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [23458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [23460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [23462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9945),
  [23464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [23466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [23468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [23470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [23472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4464),
  [23474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [23476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4307),
  [23478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [23480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [23482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10178),
  [23484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9439),
  [23486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [23488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [23490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [23492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5650),
  [23494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6172),
  [23496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [23498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [23500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10262),
  [23502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10267),
  [23504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [23506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6838),
  [23508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [23510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [23512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [23514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [23516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_vector_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2715),
  [23519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11931),
  [23521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [23523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9924),
  [23525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10355),
  [23527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10317),
  [23529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9965),
  [23531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [23533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [23535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [23537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11974),
  [23539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1, 0, 0),
  [23541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [23543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [23545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [23547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [23549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1821),
  [23551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11609),
  [23553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11610),
  [23555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0),
  [23557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1124),
  [23560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(1124),
  [23563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10929),
  [23565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10931),
  [23567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11612),
  [23569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [23571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11613),
  [23573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [23575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat2, 1, 0, 0),
  [23577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11266),
  [23579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9472),
  [23581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9472),
  [23583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11267),
  [23585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delimiter_str_1, 1, 0, 0),
  [23587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4921),
  [23589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [23591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [23593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5383),
  [23595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [23597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1002),
  [23599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [23601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [23603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [23605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delimiter_str_3, 1, 0, 0),
  [23607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__delimiter_cmd_1, 1, 0, 0),
  [23609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5391),
  [23611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [23613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1003),
  [23615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [23617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [23619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11881),
  [23621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10936),
  [23623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11888),
  [23625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10937),
  [23627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11467),
  [23629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_command_literal_repeat1, 1, 0, 0),
  [23631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [23633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [23635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11468),
  [23637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10119),
  [23639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [23641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [23643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11469),
  [23645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11471),
  [23647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [23649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [23651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [23653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [23655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [23657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5415),
  [23659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [23661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [23663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [23665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [23667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11697),
  [23669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5423),
  [23671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [23673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [23675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10782),
  [23677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10844),
  [23679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [23681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [23683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6048),
  [23685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [23687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [23689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4839),
  [23691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [23693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [23695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10730),
  [23697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [23699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11245),
  [23701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [23703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [23705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11820),
  [23707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [23709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [23711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6899),
  [23713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [23715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [23717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [23719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6058),
  [23721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [23723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [23725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11254),
  [23727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [23729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [23731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [23733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [23735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [23737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18019),
  [23739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15314),
  [23741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18020),
  [23743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [23745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18071),
  [23747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15302),
  [23749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18073),
  [23751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [23753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [23755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18151),
  [23757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15190),
  [23759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18154),
  [23761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [23763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [23765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18094),
  [23767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15111),
  [23769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18105),
  [23771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [23773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [23775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17881),
  [23777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15263),
  [23779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17896),
  [23781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17794),
  [23783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15110),
  [23785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17802),
  [23787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [23789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [23791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [23793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17731),
  [23795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15168),
  [23797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17733),
  [23799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [23801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [23803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17774),
  [23805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15211),
  [23807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17779),
  [23809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [23811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [23813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [23815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17824),
  [23817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15337),
  [23819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17835),
  [23821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17877),
  [23823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15145),
  [23825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17880),
  [23827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [23829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [23831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [23833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17949),
  [23835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15194),
  [23837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17952),
  [23839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18001),
  [23841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15232),
  [23843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18003),
  [23845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2636),
  [23847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [23849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18077),
  [23851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15255),
  [23853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18085),
  [23855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18181),
  [23857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15281),
  [23859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18187),
  [23861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 0),
  [23863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 0),
  [23865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17808),
  [23867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15310),
  [23869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17810),
  [23871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17832),
  [23873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15187),
  [23875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17833),
  [23877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [23879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17853),
  [23881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15234),
  [23883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17858),
  [23885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [23887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [23889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8734),
  [23891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7886),
  [23893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [23895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [23897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [23899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [23901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [23903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [23905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1979),
  [23907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [23909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [23911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16434),
  [23913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16435),
  [23915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [23917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [23919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [23921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, 0, 0),
  [23923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [23925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, 0, 0),
  [23927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [23929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [23931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [23933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [23935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [23937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [23939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [23941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [23943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [23945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [23947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10751),
  [23949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [23951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [23953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [23955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [23957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [23959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [23961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [23963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [23965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [23967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [23969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [23971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1923),
  [23973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [23975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [23977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [23979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [23981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [23983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 3, 0, 4),
  [23985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8379),
  [23987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [23989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [23991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2584),
  [23993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [23995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [23997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [23999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [24001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [24003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [24005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1368),
  [24007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [24009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17982),
  [24011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15125),
  [24013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18098),
  [24015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [24017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [24019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [24021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [24023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [24025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [24027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [24029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17857),
  [24031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15326),
  [24033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17863),
  [24035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8216),
  [24037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [24039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [24041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [24043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [24045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8271),
  [24047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [24049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16166),
  [24051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18935),
  [24053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [24055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [24057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [24059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [24061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [24063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [24065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [24067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [24069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [24071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [24073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17685),
  [24075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15291),
  [24077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18041),
  [24079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [24081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [24083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [24085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17730),
  [24087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15172),
  [24089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17736),
  [24091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [24093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [24095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [24097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [24099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [24101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, 0, 0),
  [24103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [24105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [24107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2644),
  [24109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [24111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [24113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [24115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [24117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [24119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17894),
  [24121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15192),
  [24123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17895),
  [24125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [24127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [24129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [24131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [24133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [24135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [24137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9248),
  [24139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17950),
  [24141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15271),
  [24143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17953),
  [24145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [24147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [24149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 8),
  [24151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_let_statement_repeat1, 2, 0, 8),
  [24153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [24155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18021),
  [24157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [24159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [24161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18025),
  [24163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15193),
  [24165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18026),
  [24167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [24169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [24171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [24173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [24175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat1, 1, 0, 0),
  [24177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2309),
  [24179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [24181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [24183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [24185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11452),
  [24187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [24189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [24191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [24193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [24195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18136),
  [24197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15112),
  [24199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18137),
  [24201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(2789),
  [24204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18126),
  [24206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15143),
  [24208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18127),
  [24210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [24212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17814),
  [24214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15231),
  [24216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17816),
  [24218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [24220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [24222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [24224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2698),
  [24226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [24228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [24230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [24232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [24234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [24236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [24238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_command_literal_repeat2, 1, 0, 0),
  [24240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [24242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [24244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [24246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17839),
  [24248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15163),
  [24250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17841),
  [24252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [24254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [24256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [24258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17864),
  [24260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15121),
  [24262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17867),
  [24264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [24266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [24268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [24270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [24272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [24274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17889),
  [24276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15208),
  [24278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17891),
  [24280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [24282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [24284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [24286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [24288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [24290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [24292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [24294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [24296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17919),
  [24298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15328),
  [24300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17920),
  [24302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [24304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [24306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [24308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [24310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16603),
  [24312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18394),
  [24314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [24316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [24318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [24320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [24322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [24324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [24326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [24328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [24330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [24332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17936),
  [24334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15146),
  [24336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17942),
  [24338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2632),
  [24340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16902),
  [24342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18321),
  [24344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [24346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [24348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [24350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [24352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [24354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [24356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [24358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [24360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17988),
  [24362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15300),
  [24364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17990),
  [24366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [24368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12089),
  [24370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [24372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [24374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [24376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_matrix_expression_repeat1, 2, 0, 0),
  [24378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8026),
  [24380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [24382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [24384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18037),
  [24386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15219),
  [24388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18038),
  [24390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [24392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [24394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [24396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [24398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [24400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [24402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [24404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18056),
  [24406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15285),
  [24408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18057),
  [24410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15534),
  [24412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19005),
  [24414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [24416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [24418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [24420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [24422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [24424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18092),
  [24426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15344),
  [24428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18099),
  [24430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [24432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [24434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [24436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18160),
  [24438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15218),
  [24440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18162),
  [24442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 3, 0, 0),
  [24444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [24446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [24448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [24450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [24452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [24454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [24456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [24458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [24460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [24462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17804),
  [24464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15186),
  [24466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17822),
  [24468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [24470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [24472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [24474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [24476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 4, 0, 4),
  [24478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 4),
  [24480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [24482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [24484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18013),
  [24486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15109),
  [24488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18035),
  [24490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [24492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [24494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17968),
  [24496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15206),
  [24498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17975),
  [24500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [24502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17970),
  [24504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15251),
  [24506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17972),
  [24508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [24510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [24512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [24514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_command_literal_repeat1, 1, 0, 0),
  [24516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [24518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [24520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17912),
  [24522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15308),
  [24524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17913),
  [24526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [24528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [24530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18197),
  [24532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15122),
  [24534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18209),
  [24536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18132),
  [24538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15330),
  [24540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18203),
  [24542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [24544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [24546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [24548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17699),
  [24550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15175),
  [24552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17714),
  [24554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17763),
  [24556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15150),
  [24558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17765),
  [24560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [24562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [24564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [24566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17915),
  [24568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15267),
  [24570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17925),
  [24572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [24574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18118),
  [24576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15164),
  [24578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18129),
  [24580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [24582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [24584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [24586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [24588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17854),
  [24590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15298),
  [24592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17862),
  [24594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [24596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [24598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17954),
  [24600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15321),
  [24602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17958),
  [24604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_prefixed_string_literal_repeat2, 1, 0, 0),
  [24606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [24608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19270),
  [24610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [24612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18661),
  [24614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [24616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18398),
  [24618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18530),
  [24620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [24622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19027),
  [24624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [24626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19275),
  [24628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19482),
  [24630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [24632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [24634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [24636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18355),
  [24638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19313),
  [24640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [24642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [24644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [24646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19570),
  [24648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18834),
  [24650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [24652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [24654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18335),
  [24656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [24658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [24660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9741),
  [24662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18494),
  [24664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18230),
  [24666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19171),
  [24668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19012),
  [24670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [24672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19196),
  [24674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [24676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19189),
  [24678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19281),
  [24680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19560),
  [24682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [24684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18327),
  [24686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [24688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 0),
  [24690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18669),
  [24692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [24694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18317),
  [24696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18272),
  [24698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [24700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18242),
  [24702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18277),
  [24704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19459),
  [24706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18356),
  [24708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18293),
  [24710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18857),
  [24712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18323),
  [24714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18332),
  [24716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [24718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18480),
  [24720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [24722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18725),
  [24724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18710),
  [24726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [24728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18716),
  [24730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18417),
  [24732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [24734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [24736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18572),
  [24738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18486),
  [24740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18465),
  [24742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18616),
  [24744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [24746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18535),
  [24748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18626),
  [24750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18301),
  [24752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18250),
  [24754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18634),
  [24756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19438),
  [24758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18729),
  [24760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18813),
  [24762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [24764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18711),
  [24766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [24768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18754),
  [24770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18699),
  [24772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18686),
  [24774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18352),
  [24776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19498),
  [24778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18787),
  [24780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19088),
  [24782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [24784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18791),
  [24786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18251),
  [24788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18889),
  [24790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18291),
  [24792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19317),
  [24794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18825),
  [24796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19078),
  [24798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18590),
  [24800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [24802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [24804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18851),
  [24806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18941),
  [24808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18943),
  [24810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [24812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, 0, 0),
  [24814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18445),
  [24816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18913),
  [24818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18976),
  [24820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19199),
  [24822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18939),
  [24824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19060),
  [24826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19415),
  [24828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19022),
  [24830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [24832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19503),
  [24834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19024),
  [24836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18538),
  [24838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [24840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18313),
  [24842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19071),
  [24844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19049),
  [24846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, 0, 0),
  [24848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19208),
  [24850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19113),
  [24852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19564),
  [24854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19346),
  [24856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [24858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19154),
  [24860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19236),
  [24862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19191),
  [24864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19332),
  [24866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [24868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19352),
  [24870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19245),
  [24872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19586),
  [24874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [24876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19364),
  [24878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19299),
  [24880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19295),
  [24882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18656),
  [24884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19469),
  [24886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18345),
  [24888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19318),
  [24890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18946),
  [24892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19348),
  [24894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18468),
  [24896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19467),
  [24898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19476),
  [24900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19424),
  [24902] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, 0, 0),
  [24904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19434),
  [24906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18705),
  [24908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19490),
  [24910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19403),
  [24912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19456),
  [24914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14935),
  [24916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18437),
  [24918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19538),
  [24920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19523),
  [24922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18944),
  [24924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19553),
  [24926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18728),
  [24928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18900),
  [24930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19307),
  [24932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18962),
  [24934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19115),
  [24936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19277),
  [24938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18563),
  [24940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18844),
  [24942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [24944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10791),
  [24946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11226),
  [24948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10792),
  [24950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10793),
  [24952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11595),
  [24954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [24956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11596),
  [24958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16761),
  [24960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [24962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [24964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10712),
  [24966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10121),
  [24968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [24970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8654),
  [24972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10795),
  [24974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7948),
  [24976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [24978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11540),
  [24980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [24982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [24984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8680),
  [24986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [24988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [24990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11919),
  [24992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [24994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [24996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11517),
  [24998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8694),
  [25000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8199),
  [25002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [25004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8704),
  [25006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10804),
  [25008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11239),
  [25010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7921),
  [25012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6497),
  [25014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7411),
  [25016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [25018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10380),
  [25020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [25022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8717),
  [25024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9243),
  [25026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11970),
  [25028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6562),
  [25030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8719),
  [25032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [25034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9244),
  [25036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7954),
  [25038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11476),
  [25040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [25042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [25044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [25046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [25048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [25050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9215),
  [25052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [25054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2788),
  [25056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9245),
  [25058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [25060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10809),
  [25062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11627),
  [25064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8378),
  [25066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10811),
  [25068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11258),
  [25070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [25072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [25074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [25076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9240),
  [25078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9985),
  [25080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [25082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7853),
  [25084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [25086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8399),
  [25088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [25090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [25092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9247),
  [25094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7868),
  [25096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [25098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [25100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9133),
  [25102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16788),
  [25104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11478),
  [25106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [25108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10866),
  [25110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [25112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [25114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [25116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [25118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11541),
  [25120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11229),
  [25122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7248),
  [25124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7295),
  [25126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7961),
  [25128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11643),
  [25130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [25132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [25134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9249),
  [25136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8200),
  [25138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [25140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2797),
  [25142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5583),
  [25144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [25146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5144),
  [25148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8100),
  [25150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [25152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [25154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [25156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17723),
  [25158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9198),
  [25160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [25162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6435),
  [25164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7816),
  [25166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7838),
  [25168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8371),
  [25170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [25172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8107),
  [25174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8730),
  [25176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16692),
  [25178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [25180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8201),
  [25182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [25184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [25186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7884),
  [25188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7316),
  [25190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6740),
  [25192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [25194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [25196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [25198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [25200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9227),
  [25202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11661),
  [25204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [25206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10605),
  [25208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9228),
  [25210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [25212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8731),
  [25214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [25216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [25218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8733),
  [25220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6926),
  [25222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8735),
  [25224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10785),
  [25226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [25228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [25230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7891),
  [25232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [25234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [25236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2810),
  [25238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [25240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [25242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11279),
  [25244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [25246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11672),
  [25248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7846),
  [25250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8220),
  [25252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [25254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [25256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [25258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [25260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8050),
  [25262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [25264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8240),
  [25266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8155),
  [25268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8777),
  [25270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9237),
  [25272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [25274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [25276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [25278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10789),
  [25280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11431),
  [25282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [25284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [25286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [25288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8412),
  [25290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [25292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8350),
  [25294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7987),
  [25296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [25298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [25300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8051),
  [25302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [25304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8123),
  [25306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [25308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8124),
  [25310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [25312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [25314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7988),
  [25316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16094),
  [25318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [25320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8739),
  [25322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2871),
  [25324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [25326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11120),
  [25328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [25330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [25332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8741),
  [25334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10801),
  [25336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [25338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2886),
  [25340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2887),
  [25342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8127),
  [25344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [25346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [25348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [25350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7848),
  [25352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [25354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [25356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [25358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4711),
  [25360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7849),
  [25362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6977),
  [25364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7989),
  [25366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10737),
  [25368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [25370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [25372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8128),
  [25374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [25376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10728),
  [25378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [25380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [25382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10813),
  [25384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [25386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [25388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [25390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [25392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6489),
  [25394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [25396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2828),
  [25398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [25400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10837),
  [25402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [25404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8144),
  [25406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8145),
  [25408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [25410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [25412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [25414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [25416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10524),
  [25418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [25420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [25422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10705),
  [25424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [25426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [25428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11131),
  [25430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [25432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7924),
  [25434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [25436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [25438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11441),
  [25440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [25442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8152),
  [25444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [25446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8153),
  [25448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [25450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [25452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7960),
  [25454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [25456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8949),
  [25458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7250),
  [25460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6754),
  [25462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11295),
  [25464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [25466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [25468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7456),
  [25470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [25472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [25474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9200),
  [25476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8257),
  [25478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11139),
  [25480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10669),
  [25482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10321),
  [25484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11464),
  [25486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7962),
  [25488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [25490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2685),
  [25492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [25494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1989),
  [25496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7231),
  [25498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9907),
  [25500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [25502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [25504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [25506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [25508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [25510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8181),
  [25512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [25514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8182),
  [25516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [25518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8184),
  [25520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [25522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [25524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [25526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10799),
  [25528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8865),
  [25530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7379),
  [25532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [25534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11148),
  [25536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11853),
  [25538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8192),
  [25540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10523),
  [25542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [25544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8797),
  [25546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11507),
  [25548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8351),
  [25550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [25552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [25554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [25556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [25558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10820),
  [25560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9253),
  [25562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [25564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [25566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [25568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6071),
  [25570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9254),
  [25572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [25574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [25576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [25578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10621),
  [25580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [25582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5915),
  [25584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [25586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8357),
  [25588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11249),
  [25590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5830),
  [25592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [25594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [25596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9203),
  [25598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10823),
  [25600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [25602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [25604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [25606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7945),
  [25608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [25610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9204),
  [25612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7538),
  [25614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [25616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [25618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6223),
  [25620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [25622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5923),
  [25624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11317),
  [25626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2847),
  [25628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11487),
  [25630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8211),
  [25632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [25634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8212),
  [25636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8213),
  [25638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [25640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8215),
  [25642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [25644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2849),
  [25646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [25648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8238),
  [25650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [25652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [25654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [25656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2851),
  [25658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8217),
  [25660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [25662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [25664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6802),
  [25666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11814),
  [25668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [25670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [25672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7984),
  [25674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [25676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10668),
  [25678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [25680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16978),
  [25682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2863),
  [25684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2860),
  [25686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [25688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10388),
  [25690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10687),
  [25692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10761),
  [25694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11437),
  [25696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10051),
  [25698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [25700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8221),
  [25702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [25704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10614),
  [25706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8356),
  [25708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5574),
  [25710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [25712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9205),
  [25714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7525),
  [25716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [25718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [25720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [25722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11220),
  [25724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7963),
  [25726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1964),
  [25728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7584),
  [25730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8272),
  [25732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [25734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10838),
  [25736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10484),
  [25738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11465),
  [25740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7965),
  [25742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [25744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [25746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [25748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10276),
  [25750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [25752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [25754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [25756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8725),
  [25758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11429),
  [25760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7012),
  [25762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [25764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [25766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7402),
  [25768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19340),
  [25770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [25772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10664),
  [25774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8280),
  [25776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8830),
  [25778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [25780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [25782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7558),
  [25784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7990),
  [25786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8034),
  [25788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [25790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [25792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [25794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7404),
  [25796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12192),
  [25798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7993),
  [25800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6314),
  [25802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [25804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [25806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12225),
  [25808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [25810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [25812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [25814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [25816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [25818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [25820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [25822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [25824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [25826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [25828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [25830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [25832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10468),
  [25834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [25836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8363),
  [25838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [25840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7408),
  [25842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7966),
  [25844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11443),
  [25846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2759),
  [25848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8239),
  [25850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9461),
  [25852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [25854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [25856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6797),
  [25858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7926),
  [25860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8241),
  [25862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [25864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9020),
  [25866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8405),
  [25868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [25870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [25872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7602),
  [25874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [25876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [25878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [25880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7569),
  [25882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [25884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7767),
  [25886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [25888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7996),
  [25890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8327),
  [25892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8203),
  [25894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7420),
  [25896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9229),
  [25898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [25900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [25902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8366),
  [25904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [25906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [25908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [25910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [25912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12166),
  [25914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [25916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12171),
  [25918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19616),
  [25920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2833),
  [25922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [25924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8012),
  [25926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12173),
  [25928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [25930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10733),
  [25932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [25934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16712),
  [25936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2756),
  [25938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6636),
  [25940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10312),
  [25942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [25944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7946),
  [25946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1990),
  [25948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8853),
  [25950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [25952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9785),
  [25954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [25956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [25958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [25960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [25962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12176),
  [25964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [25966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7976),
  [25968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8015),
  [25970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4776),
  [25972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10449),
  [25974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10739),
  [25976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [25978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1910),
  [25980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9196),
  [25982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12178),
  [25984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [25986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [25988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [25990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6228),
  [25992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2699),
  [25994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [25996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [25998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [26000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6419),
  [26002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [26004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9230),
  [26006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [26008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12179),
  [26010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12196),
  [26012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [26014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [26016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1980),
  [26018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [26020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [26022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2835),
  [26024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6163),
  [26026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [26028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10510),
  [26030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12197),
  [26032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [26034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7479),
  [26036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [26038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10010),
  [26040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8839),
  [26042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [26044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [26046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8840),
  [26048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7616),
  [26050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7498),
  [26052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8842),
  [26054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11394),
  [26056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [26058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10472),
  [26060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7862),
  [26062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [26064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10777),
  [26066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8244),
  [26068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9201),
  [26070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9231),
  [26072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [26074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7781),
  [26076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [26078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11438),
  [26080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11445),
  [26082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8843),
  [26084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2838),
  [26086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [26088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [26090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [26092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [26094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [26096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2840),
  [26098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12212),
  [26100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [26102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9232),
  [26104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [26106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6403),
  [26108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2745),
  [26110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8020),
  [26112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8022),
  [26114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7791),
  [26116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12215),
  [26118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11498),
  [26120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2693),
  [26122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [26124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9944),
  [26126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8023),
  [26128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [26130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11472),
  [26132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5185),
  [26134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11489),
  [26136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19617),
  [26138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8025),
  [26140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8204),
  [26142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [26144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8027),
  [26146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2737),
  [26148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [26150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [26152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [26154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [26156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [26158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [26160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [26162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7153),
  [26164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9468),
  [26166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10760),
  [26168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [26170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2710),
  [26172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1753),
  [26174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8541),
  [26176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [26178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15423),
  [26180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7671),
  [26182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [26184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8037),
  [26186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8206),
  [26188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8038),
  [26190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [26192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9210),
  [26194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8860),
  [26196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [26198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12023),
  [26200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12024),
  [26202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [26204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12027),
  [26206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12028),
  [26208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12029),
  [26210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12030),
  [26212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [26214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12033),
  [26216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6837),
  [26218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12043),
  [26220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12046),
  [26222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12048),
  [26224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [26226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [26228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [26230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11444),
  [26232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9908),
  [26234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7058),
  [26236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [26238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9437),
  [26240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8868),
  [26242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [26244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8553),
  [26246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2081),
  [26248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9239),
  [26250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7020),
  [26252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [26254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8354),
  [26256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [26258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8207),
  [26260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11542),
  [26262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9963),
  [26264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7967),
  [26266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [26268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6243),
  [26270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6851),
  [26272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [26274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [26276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12078),
  [26278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12079),
  [26280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12081),
  [26282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11430),
  [26284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12083),
  [26286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8235),
  [26288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12094),
  [26290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [26292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [26294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9455),
  [26296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8236),
  [26298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [26300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [26302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12125),
  [26304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12129),
  [26306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11466),
  [26308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8326),
  [26310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [26312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [26314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7412),
  [26316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6915),
  [26318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10400),
  [26320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10128),
  [26322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [26324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6809),
  [26326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [26328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2812),
  [26330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2786),
  [26332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [26334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9010),
  [26336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [26338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6661),
  [26340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9202),
  [26342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [26344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [26346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [26348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [26350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [26352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [26354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [26356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [26358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8361),
  [26360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [26362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9183),
  [26364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [26366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [26368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [26370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5382),
  [26372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [26374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5876),
  [26376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8063),
  [26378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9990),
  [26380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [26382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10243),
  [26384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [26386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [26388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [26390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [26392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10054),
  [26394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [26396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [26398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [26400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7876),
  [26402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7968),
  [26404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8292),
  [26406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [26408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [26410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [26412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [26414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [26416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [26418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [26420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11357),
  [26422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [26424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7436),
  [26426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9789),
  [26428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [26430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [26432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [26434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10783),
  [26436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5315),
  [26438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10001),
  [26440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10116),
  [26442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [26444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [26446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11450),
  [26448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9188),
  [26450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [26452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18188),
  [26454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10786),
  [26456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [26458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11209),
  [26460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [26462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8065),
  [26464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18072),
  [26466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8040),
  [26468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11428),
  [26470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [26472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [26474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9801),
  [26476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [26478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [26480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8314),
  [26482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8315),
  [26484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6183),
  [26486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [26488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [26490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [26492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [26494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [26496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [26498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8070),
  [26500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8317),
  [26502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8318),
  [26504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [26506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8319),
  [26508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8320),
  [26510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [26512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7953),
  [26514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11292),
  [26516] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [26518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [26520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [26522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [26524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [26526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9919),
  [26528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8041),
  [26530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [26532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [26534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [26536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [26538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16628),
  [26540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [26542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [26544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [26546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [26548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [26550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8358),
  [26552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [26554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [26556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [26558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8369),
  [26560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [26562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [26564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8355),
  [26566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8599),
  [26568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [26570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5529),
  [26572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9959),
  [26574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6478),
  [26576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [26578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11453),
  [26580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [26582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9109),
  [26584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [26586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9768),
  [26588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [26590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [26592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2811),
  [26594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6209),
  [26596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [26598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [26600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11818),
  [26602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [26604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [26606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [26608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [26610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6894),
  [26612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7684),
  [26614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10790),
  [26616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [26618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7942),
  [26620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17957),
  [26622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7943),
  [26624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9170),
  [26626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11447),
  [26628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [26630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [26632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8074),
  [26634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [26636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [26638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [26640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11915),
  [26642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11343),
  [26644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9233),
  [26646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [26648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [26650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7207),
  [26652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [26654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7944),
  [26656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2780),
  [26658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [26660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7554),
  [26662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_comment, 2, 0, 0),
  [26664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 0),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__block_comment_rest = 0,
  ts_external_token__immediate_paren = 1,
  ts_external_token__immediate_bracket = 2,
  ts_external_token__immediate_brace = 3,
  ts_external_token__immediate_string_start = 4,
  ts_external_token__immediate_command_start = 5,
  ts_external_token__content_cmd_1 = 6,
  ts_external_token__content_cmd_1_raw = 7,
  ts_external_token__content_cmd_3 = 8,
  ts_external_token__content_cmd_3_raw = 9,
  ts_external_token__content_str_1 = 10,
  ts_external_token__content_str_1_raw = 11,
  ts_external_token__content_str_3 = 12,
  ts_external_token__content_str_3_raw = 13,
  ts_external_token__end_cmd = 14,
  ts_external_token__end_str = 15,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__block_comment_rest] = sym__block_comment_rest,
  [ts_external_token__immediate_paren] = sym__immediate_paren,
  [ts_external_token__immediate_bracket] = sym__immediate_bracket,
  [ts_external_token__immediate_brace] = sym__immediate_brace,
  [ts_external_token__immediate_string_start] = sym__immediate_string_start,
  [ts_external_token__immediate_command_start] = sym__immediate_command_start,
  [ts_external_token__content_cmd_1] = sym__content_cmd_1,
  [ts_external_token__content_cmd_1_raw] = sym__content_cmd_1_raw,
  [ts_external_token__content_cmd_3] = sym__content_cmd_3,
  [ts_external_token__content_cmd_3_raw] = sym__content_cmd_3_raw,
  [ts_external_token__content_str_1] = sym__content_str_1,
  [ts_external_token__content_str_1_raw] = sym__content_str_1_raw,
  [ts_external_token__content_str_3] = sym__content_str_3,
  [ts_external_token__content_str_3_raw] = sym__content_str_3_raw,
  [ts_external_token__end_cmd] = sym__end_cmd,
  [ts_external_token__end_str] = sym__end_str,
};

static const bool ts_external_scanner_states[15][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__block_comment_rest] = true,
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
    [ts_external_token__content_cmd_1] = true,
    [ts_external_token__content_cmd_1_raw] = true,
    [ts_external_token__content_cmd_3] = true,
    [ts_external_token__content_cmd_3_raw] = true,
    [ts_external_token__content_str_1] = true,
    [ts_external_token__content_str_1_raw] = true,
    [ts_external_token__content_str_3] = true,
    [ts_external_token__content_str_3_raw] = true,
    [ts_external_token__end_cmd] = true,
    [ts_external_token__end_str] = true,
  },
  [2] = {
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [3] = {
    [ts_external_token__immediate_paren] = true,
    [ts_external_token__immediate_bracket] = true,
    [ts_external_token__immediate_brace] = true,
  },
  [4] = {
    [ts_external_token__immediate_paren] = true,
  },
  [5] = {
    [ts_external_token__immediate_string_start] = true,
    [ts_external_token__immediate_command_start] = true,
  },
  [6] = {
    [ts_external_token__content_str_1] = true,
    [ts_external_token__end_str] = true,
  },
  [7] = {
    [ts_external_token__content_str_3] = true,
    [ts_external_token__end_str] = true,
  },
  [8] = {
    [ts_external_token__content_cmd_1] = true,
    [ts_external_token__end_cmd] = true,
  },
  [9] = {
    [ts_external_token__content_cmd_3] = true,
    [ts_external_token__end_cmd] = true,
  },
  [10] = {
    [ts_external_token__content_str_1_raw] = true,
    [ts_external_token__end_str] = true,
  },
  [11] = {
    [ts_external_token__content_str_3_raw] = true,
    [ts_external_token__end_str] = true,
  },
  [12] = {
    [ts_external_token__content_cmd_1_raw] = true,
    [ts_external_token__end_cmd] = true,
  },
  [13] = {
    [ts_external_token__content_cmd_3_raw] = true,
    [ts_external_token__end_cmd] = true,
  },
  [14] = {
    [ts_external_token__block_comment_rest] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_julia_external_scanner_create(void);
void tree_sitter_julia_external_scanner_destroy(void *);
bool tree_sitter_julia_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_julia_external_scanner_serialize(void *, char *);
void tree_sitter_julia_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_julia(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__word_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_julia_external_scanner_create,
      tree_sitter_julia_external_scanner_destroy,
      tree_sitter_julia_external_scanner_scan,
      tree_sitter_julia_external_scanner_serialize,
      tree_sitter_julia_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
